const $$Language$Dafny: bool
uses {
axiom $$Language$Dafny;
}

type Ty;

type Bv0 = int;

const unique TBool: Ty
uses {
axiom Tag(TBool) == TagBool;
}

const unique TChar: Ty
uses {
axiom Tag(TChar) == TagChar;
}

const unique TInt: Ty
uses {
axiom Tag(TInt) == TagInt;
}

const unique TReal: Ty
uses {
axiom Tag(TReal) == TagReal;
}

const unique TORDINAL: Ty
uses {
axiom Tag(TORDINAL) == TagORDINAL;
}

function TBitvector(int) : Ty;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

function TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

function TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

function TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

function TMap(Ty, Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

function TIMap(Ty, Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function Inv0_TBitvector(Ty) : int;

function Inv0_TSet(Ty) : Ty;

function Inv0_TISet(Ty) : Ty;

function Inv0_TSeq(Ty) : Ty;

function Inv0_TMultiSet(Ty) : Ty;

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

type TyTagFamily;

function TagFamily(Ty) : TyTagFamily;

function {:identity} Lit<T>(x: T) : T
uses {
axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);
}

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int
uses {
axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);
}

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real
uses {
axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);
}

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

function {:inline} char#IsChar(n: int) : bool
{
  (0 <= n && n < 55296) || (57344 <= n && n < 1114112)
}

type char;

function char#FromInt(int) : char;

axiom (forall n: int :: { char#FromInt(n) } char#IsChar(n) ==> char#ToInt(char#FromInt(n)) == n);

function char#ToInt(char) : int;

axiom (forall ch: char :: { char#ToInt(ch) } char#FromInt(char#ToInt(ch)) == ch && char#IsChar(char#ToInt(ch)));

function char#Plus(char, char) : char;

axiom (forall a: char, b: char :: { char#Plus(a, b) } char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: { char#Minus(a, b) } char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall<T> x: Box :: { $Unbox(x): T } $Box($Unbox(x): T) == x);

function $IsBox(Box, Ty) : bool;

function $IsAllocBox(Box, Ty, Heap) : bool;

axiom (forall bx: Box :: { $IsBox(bx, TInt) } $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: { $IsBox(bx, TReal) } $IsBox(bx, TReal) ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: { $IsBox(bx, TBool) } $IsBox(bx, TBool) ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: { $IsBox(bx, TChar) } $IsBox(bx, TChar) ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(0)) } $IsBox(bx, TBitvector(0)) ==> $Box($Unbox(bx): Bv0) == bx && $Is($Unbox(bx): Bv0, TBitvector(0)));

axiom (forall bx: Box, t: Ty :: { $IsBox(bx, TSet(t)) } $IsBox(bx, TSet(t)) ==> $Box($Unbox(bx): Set) == bx && $Is($Unbox(bx): Set, TSet(t)));

axiom (forall bx: Box, t: Ty :: { $IsBox(bx, TISet(t)) } $IsBox(bx, TISet(t)) ==> $Box($Unbox(bx): ISet) == bx && $Is($Unbox(bx): ISet, TISet(t)));

axiom (forall bx: Box, t: Ty :: { $IsBox(bx, TMultiSet(t)) } $IsBox(bx, TMultiSet(t)) ==> $Box($Unbox(bx): MultiSet) == bx && $Is($Unbox(bx): MultiSet, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: { $IsBox(bx, TSeq(t)) } $IsBox(bx, TSeq(t)) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: { $IsBox(bx, TMap(s, t)) } $IsBox(bx, TMap(s, t)) ==> $Box($Unbox(bx): Map) == bx && $Is($Unbox(bx): Map, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: { $IsBox(bx, TIMap(s, t)) } $IsBox(bx, TIMap(s, t)) ==> $Box($Unbox(bx): IMap) == bx && $Is($Unbox(bx): IMap, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: { $IsBox($Box(v), t) } $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: { $IsAllocBox($Box(v), t, h) } $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall v: Bv0 :: { $Is(v, TBitvector(0)) } $Is(v, TBitvector(0)));

axiom (forall v: Set, t0: Ty :: { $Is(v, TSet(t0)) } $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet, t0: Ty :: { $Is(v, TISet(t0)) } $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet, t0: Ty :: { $Is(v, TMultiSet(t0)) } $Is(v, TMultiSet(t0)) <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet, t0: Ty :: { $Is(v, TMultiSet(t0)) } $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq, t0: Ty :: { $Is(v, TSeq(t0)) } $Is(v, TSeq(t0)) <==> (forall i: int :: { Seq#Index(v, i) } 0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Map, t0: Ty, t1: Ty :: { $Is(v, TMap(t0, t1)) } $Is(v, TMap(t0, t1)) <==> (forall bx: Box :: { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map, t0: Ty, t1: Ty :: { $Is(v, TMap(t0, t1)) } $Is(v, TMap(t0, t1)) ==> $Is(Map#Domain(v), TSet(t0)) && $Is(Map#Values(v), TSet(t1)) && $Is(Map#Items(v), TSet(Tclass._System.Tuple2(t0, t1))));

axiom (forall v: IMap, t0: Ty, t1: Ty :: { $Is(v, TIMap(t0, t1)) } $Is(v, TIMap(t0, t1)) <==> (forall bx: Box :: { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap, t0: Ty, t1: Ty :: { $Is(v, TIMap(t0, t1)) } $Is(v, TIMap(t0, t1)) ==> $Is(IMap#Domain(v), TISet(t0)) && $Is(IMap#Values(v), TISet(t1)) && $Is(IMap#Items(v), TISet(Tclass._System.Tuple2(t0, t1))));

function $IsAlloc<T>(T, Ty, Heap) : bool;

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: { $IsAlloc(v, TORDINAL, h) } $IsAlloc(v, TORDINAL, h));

axiom (forall v: Bv0, h: Heap :: { $IsAlloc(v, TBitvector(0), h) } $IsAlloc(v, TBitvector(0), h));

axiom (forall v: Set, t0: Ty, h: Heap :: { $IsAlloc(v, TSet(t0), h) } $IsAlloc(v, TSet(t0), h) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet, t0: Ty, h: Heap :: { $IsAlloc(v, TISet(t0), h) } $IsAlloc(v, TISet(t0), h) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet, t0: Ty, h: Heap :: { $IsAlloc(v, TMultiSet(t0), h) } $IsAlloc(v, TMultiSet(t0), h) <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq, t0: Ty, h: Heap :: { $IsAlloc(v, TSeq(t0), h) } $IsAlloc(v, TSeq(t0), h) <==> (forall i: int :: { Seq#Index(v, i) } 0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map, t0: Ty, t1: Ty, h: Heap :: { $IsAlloc(v, TMap(t0, t1), h) } $IsAlloc(v, TMap(t0, t1), h) <==> (forall bx: Box :: { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } Map#Domain(v)[bx] ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap, t0: Ty, t1: Ty, h: Heap :: { $IsAlloc(v, TIMap(t0, t1), h) } $IsAlloc(v, TIMap(t0, t1), h) <==> (forall bx: Box :: { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } IMap#Domain(v)[bx] ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

function $AlwaysAllocated(Ty) : bool;

axiom (forall ty: Ty :: { $AlwaysAllocated(ty) } $AlwaysAllocated(ty) ==> (forall h: Heap, v: Box :: { $IsAllocBox(v, ty, h) } $IsBox(v, ty) ==> $IsAllocBox(v, ty, h)));

function $OlderTag(Heap) : bool;

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty
uses {
axiom Tag(Tclass._System.object?()) == Tagclass._System.object? && TagFamily(Tclass._System.object?()) == tytagFamily$object;
}

function Tclass._System.Tuple2(Ty, Ty) : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: { TypeTuple(a, b) } TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set;

axiom (forall s: [ref]bool, bx: Box :: { SetRef_to_SetBox(s)[bx] } SetRef_to_SetBox(s)[bx] <==> s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: { SetRef_to_SetBox(s) } $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: { ORD#FromNat(n) } 0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: { ORD#Offset(o) } { ORD#IsNat(o) } ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Less(o, p) } (ORD#Less(o, p) ==> o != p) && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p)) && (ORD#IsNat(o) && ORD#IsNat(p) ==> (ORD#Less(o, p) <==> ORD#Offset(o) < ORD#Offset(p))) && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Less(o, p), ORD#Less(p, o) } ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#LessThanLimit(o, p) } ORD#LessThanLimit(o, p) <==> ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Plus(o, p) } (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p)) && (ORD#IsNat(p) ==> (ORD#IsNat(ORD#Plus(o, p)) <==> ORD#IsNat(o)) && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Plus(o, p) } (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p))) && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Plus(o, p) } (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p) && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Minus(o, p) } ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o) ==> (ORD#IsNat(ORD#Minus(o, p)) <==> ORD#IsNat(o)) && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: { ORD#Minus(o, p) } ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o) ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o) || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 0 <= m && 0 <= n ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 0 <= m && 0 <= n && m + n <= ORD#Offset(o) ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 0 <= m && 0 <= n && n <= ORD#Offset(o) + m ==> (0 <= m - n ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) == ORD#Plus(o, ORD#FromNat(m - n))) && (m - n <= 0 ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 0 <= m && 0 <= n && n <= ORD#Offset(o) + m ==> (0 <= m - n ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) == ORD#Minus(o, ORD#FromNat(m - n))) && (m - n <= 0 ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: { AtLayer(f, ly) } AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: { AtLayer(f, $LS(ly)) } AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field;

function FDim(Field) : int
uses {
axiom FDim(alloc) == 0;
}

function IndexField(int) : Field;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse(Field) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field, int) : Field;

axiom (forall f: Field, i: int :: { MultiIndexField(f, i) } FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0(Field) : Field;

function MultiIndexField_Inverse1(Field) : int;

axiom (forall f: Field, i: int :: { MultiIndexField(f, i) } MultiIndexField_Inverse0(MultiIndexField(f, i)) == f && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType(Field) : ClassName;

type NameFamily;

function DeclName(Field) : NameFamily
uses {
axiom DeclName(alloc) == allocName;
}

function FieldOfDecl(ClassName, NameFamily) : Field;

axiom (forall cl: ClassName, nm: NameFamily :: { FieldOfDecl(cl, nm): Field } DeclType(FieldOfDecl(cl, nm): Field) == cl && DeclName(FieldOfDecl(cl, nm): Field) == nm);

function $IsGhostField(Field) : bool
uses {
axiom $IsGhostField(alloc);
}

axiom (forall h: Heap, k: Heap :: { $HeapSuccGhost(h, k) } $HeapSuccGhost(h, k) ==> $HeapSucc(h, k) && (forall o: ref, f: Field :: { read(k, o, f) } !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: { $HeapSucc(h, k), $IsAlloc(v, t, h) } $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field;

const unique allocName: NameFamily;

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: { _System.array.Length(o) } 0 <= _System.array.Length(o));

function Int(x: real) : int
uses {
axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));
}

function Real(x: int) : real
uses {
axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));
}

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref][Field]Box;

function {:inline} read(H: Heap, r: ref, f: Field) : Box
{
  H[r][f]
}

function {:inline} update(H: Heap, r: ref, f: Field, v: Box) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap
uses {
axiom $IsGoodHeap($OneHeap);
}

function $HeapSucc(Heap, Heap) : bool;

axiom (forall h: Heap, r: ref, f: Field, x: Box :: { update(h, r, f, x) } $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: { $HeapSucc(a, b), $HeapSucc(b, c) } a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: { $HeapSucc(h, k) } $HeapSucc(h, k) ==> (forall o: ref :: { read(k, o, alloc) } $Unbox(read(h, o, alloc)) ==> $Unbox(read(k, o, alloc))));

function $HeapSuccGhost(Heap, Heap) : bool;

procedure $YieldHavoc(this: ref, rds: Set, nw: Set);
  modifies $Heap;
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)) ==> $o == this || rds[$Box($o)] || nw[$Box($o)] ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set, modi: Set);
  modifies $Heap;
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)) ==> rds[$Box($o)] && !modi[$Box($o)] && $o != this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set, nw: Set);
  modifies $Heap;
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || modi[$Box($o)] || nw[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field) returns (s: Set);
  free ensures (forall bx: Box :: { s[bx] } s[bx] <==> ($Unbox(read(newHeap, this, NW)): Set)[bx] || ($Unbox(bx) != null && !$Unbox(read(prevHeap, $Unbox(bx): ref, alloc)) && $Unbox(read(newHeap, $Unbox(bx): ref, alloc))));



type Set = [Box]bool;

function Set#Card(Set) : int;

axiom (forall s: Set :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty() : Set;

axiom (forall o: Box :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall s: Set :: { Set#Card(s) } (Set#Card(s) == 0 <==> s == Set#Empty()) && (Set#Card(s) != 0 ==> (exists x: Box :: s[x])));

function Set#Singleton(Box) : Set;

axiom (forall r: Box :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall r: Box, o: Box :: { Set#Singleton(r)[o] } Set#Singleton(r)[o] <==> r == o);

axiom (forall r: Box :: { Set#Card(Set#Singleton(r)) } Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne(Set, Box) : Set;

axiom (forall a: Set, x: Box, o: Box :: { Set#UnionOne(a, x)[o] } Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall a: Set, x: Box :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall a: Set, x: Box, y: Box :: { Set#UnionOne(a, x), a[y] } a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall a: Set, x: Box :: { Set#Card(Set#UnionOne(a, x)) } a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall a: Set, x: Box :: { Set#Card(Set#UnionOne(a, x)) } !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union(Set, Set) : Set;

axiom (forall a: Set, b: Set, o: Box :: { Set#Union(a, b)[o] } Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall a: Set, b: Set, y: Box :: { Set#Union(a, b), a[y] } a[y] ==> Set#Union(a, b)[y]);

axiom (forall a: Set, b: Set, y: Box :: { Set#Union(a, b), b[y] } b[y] ==> Set#Union(a, b)[y]);

axiom (forall a: Set, b: Set :: { Set#Union(a, b) } Set#Disjoint(a, b) ==> Set#Difference(Set#Union(a, b), a) == b && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection(Set, Set) : Set;

axiom (forall a: Set, b: Set, o: Box :: { Set#Intersection(a, b)[o] } Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall a: Set, b: Set :: { Set#Union(Set#Union(a, b), b) } Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall a: Set, b: Set :: { Set#Union(a, Set#Union(a, b)) } Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall a: Set, b: Set :: { Set#Intersection(Set#Intersection(a, b), b) } Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall a: Set, b: Set :: { Set#Intersection(a, Set#Intersection(a, b)) } Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall a: Set, b: Set :: { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b)) == Set#Card(a) + Set#Card(b));

function Set#Difference(Set, Set) : Set;

axiom (forall a: Set, b: Set, o: Box :: { Set#Difference(a, b)[o] } Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall a: Set, b: Set, y: Box :: { Set#Difference(a, b), b[y] } b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall a: Set, b: Set :: { Set#Card(Set#Difference(a, b)) } Set#Card(Set#Difference(a, b)) + Set#Card(Set#Difference(b, a)) + Set#Card(Set#Intersection(a, b)) == Set#Card(Set#Union(a, b)) && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset(Set, Set) : bool;

axiom (forall a: Set, b: Set :: { Set#Subset(a, b) } Set#Subset(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal(Set, Set) : bool;

axiom (forall a: Set, b: Set :: { Set#Equal(a, b) } Set#Equal(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall a: Set, b: Set :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint(Set, Set) : bool;

axiom (forall a: Set, b: Set :: { Set#Disjoint(a, b) } Set#Disjoint(a, b) <==> (forall o: Box :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet = [Box]bool;

function ISet#Empty() : Set;

axiom (forall o: Box :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne(ISet, Box) : ISet;

axiom (forall a: ISet, x: Box, o: Box :: { ISet#UnionOne(a, x)[o] } ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall a: ISet, x: Box :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall a: ISet, x: Box, y: Box :: { ISet#UnionOne(a, x), a[y] } a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union(ISet, ISet) : ISet;

axiom (forall a: ISet, b: ISet, o: Box :: { ISet#Union(a, b)[o] } ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall a: ISet, b: ISet, y: Box :: { ISet#Union(a, b), a[y] } a[y] ==> ISet#Union(a, b)[y]);

axiom (forall a: Set, b: Set, y: Box :: { ISet#Union(a, b), b[y] } b[y] ==> ISet#Union(a, b)[y]);

axiom (forall a: ISet, b: ISet :: { ISet#Union(a, b) } ISet#Disjoint(a, b) ==> ISet#Difference(ISet#Union(a, b), a) == b && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection(ISet, ISet) : ISet;

axiom (forall a: ISet, b: ISet, o: Box :: { ISet#Intersection(a, b)[o] } ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall a: ISet, b: ISet :: { ISet#Union(ISet#Union(a, b), b) } ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall a: Set, b: Set :: { ISet#Union(a, ISet#Union(a, b)) } ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall a: ISet, b: ISet :: { ISet#Intersection(ISet#Intersection(a, b), b) } ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall a: ISet, b: ISet :: { ISet#Intersection(a, ISet#Intersection(a, b)) } ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference(ISet, ISet) : ISet;

axiom (forall a: ISet, b: ISet, o: Box :: { ISet#Difference(a, b)[o] } ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall a: ISet, b: ISet, y: Box :: { ISet#Difference(a, b), b[y] } b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset(ISet, ISet) : bool;

axiom (forall a: ISet, b: ISet :: { ISet#Subset(a, b) } ISet#Subset(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal(ISet, ISet) : bool;

axiom (forall a: ISet, b: ISet :: { ISet#Equal(a, b) } ISet#Equal(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall a: ISet, b: ISet :: { ISet#Equal(a, b) } ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint(ISet, ISet) : bool;

axiom (forall a: ISet, b: ISet :: { ISet#Disjoint(a, b) } ISet#Disjoint(a, b) <==> (forall o: Box :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: { Math#min(a, b) } Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet = [Box]int;

function $IsGoodMultiSet(ms: MultiSet) : bool;

axiom (forall ms: MultiSet :: { $IsGoodMultiSet(ms) } $IsGoodMultiSet(ms) <==> (forall bx: Box :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card(MultiSet) : int;

axiom (forall s: MultiSet :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall s: MultiSet, x: Box, n: int :: { MultiSet#Card(s[x := n]) } 0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty() : MultiSet;

axiom (forall o: Box :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall s: MultiSet :: { MultiSet#Card(s) } (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty()) && (MultiSet#Card(s) != 0 ==> (exists x: Box :: 0 < s[x])));

function MultiSet#Singleton(Box) : MultiSet;

axiom (forall r: Box, o: Box :: { MultiSet#Singleton(r)[o] } (MultiSet#Singleton(r)[o] == 1 <==> r == o) && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall r: Box :: { MultiSet#Singleton(r) } MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne(MultiSet, Box) : MultiSet;

axiom (forall a: MultiSet, x: Box, o: Box :: { MultiSet#UnionOne(a, x)[o] } 0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall a: MultiSet, x: Box :: { MultiSet#UnionOne(a, x) } MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall a: MultiSet, x: Box, y: Box :: { MultiSet#UnionOne(a, x), a[y] } 0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall a: MultiSet, x: Box, y: Box :: { MultiSet#UnionOne(a, x), a[y] } x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall a: MultiSet, x: Box :: { MultiSet#Card(MultiSet#UnionOne(a, x)) } MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union(MultiSet, MultiSet) : MultiSet;

axiom (forall a: MultiSet, b: MultiSet, o: Box :: { MultiSet#Union(a, b)[o] } MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Card(MultiSet#Union(a, b)) } MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection(MultiSet, MultiSet) : MultiSet;

axiom (forall a: MultiSet, b: MultiSet, o: Box :: { MultiSet#Intersection(a, b)[o] } MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } MultiSet#Intersection(MultiSet#Intersection(a, b), b) == MultiSet#Intersection(a, b));

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } MultiSet#Intersection(a, MultiSet#Intersection(a, b)) == MultiSet#Intersection(a, b));

function MultiSet#Difference(MultiSet, MultiSet) : MultiSet;

axiom (forall a: MultiSet, b: MultiSet, o: Box :: { MultiSet#Difference(a, b)[o] } MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall a: MultiSet, b: MultiSet, y: Box :: { MultiSet#Difference(a, b), b[y], a[y] } a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Card(MultiSet#Difference(a, b)) } MultiSet#Card(MultiSet#Difference(a, b)) + MultiSet#Card(MultiSet#Difference(b, a)) + 2 * MultiSet#Card(MultiSet#Intersection(a, b)) == MultiSet#Card(MultiSet#Union(a, b)) && MultiSet#Card(MultiSet#Difference(a, b)) == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset(MultiSet, MultiSet) : bool;

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Subset(a, b) } MultiSet#Subset(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal(MultiSet, MultiSet) : bool;

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Equal(a, b) } MultiSet#Equal(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Equal(a, b) } MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint(MultiSet, MultiSet) : bool;

axiom (forall a: MultiSet, b: MultiSet :: { MultiSet#Disjoint(a, b) } MultiSet#Disjoint(a, b) <==> (forall o: Box :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet(Set) : MultiSet;

axiom (forall s: Set, a: Box :: { MultiSet#FromSet(s)[a] } (MultiSet#FromSet(s)[a] == 0 <==> !s[a]) && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall s: Set :: { MultiSet#Card(MultiSet#FromSet(s)) } MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq(Seq) : MultiSet
uses {
axiom MultiSet#FromSeq(Seq#Empty(): Seq) == MultiSet#Empty(): MultiSet;
}

axiom (forall s: Seq :: { MultiSet#FromSeq(s) } $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall s: Seq :: { MultiSet#Card(MultiSet#FromSeq(s)) } MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall s: Seq, v: Box :: { MultiSet#FromSeq(Seq#Build(s, v)) } MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall a: Seq, b: Seq :: { MultiSet#FromSeq(Seq#Append(a, b)) } MultiSet#FromSeq(Seq#Append(a, b)) == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall s: Seq, i: int, v: Box, x: Box :: { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 0 <= i && i < Seq#Length(s) ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x] == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), MultiSet#Singleton(v))[x]);

axiom (forall s: Seq, x: Box :: { MultiSet#FromSeq(s)[x] } (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i)) <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq;

function Seq#Length(Seq) : int;

axiom (forall s: Seq :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty() : Seq
uses {
axiom Seq#Length(Seq#Empty(): Seq) == 0;
}

axiom (forall s: Seq :: { Seq#Length(s) } Seq#Length(s) == 0 ==> s == Seq#Empty());

function Seq#Singleton(Box) : Seq;

axiom (forall t: Box :: { Seq#Length(Seq#Singleton(t)) } Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build(s: Seq, val: Box) : Seq;

function Seq#Build_inv0(s: Seq) : Seq;

function Seq#Build_inv1(s: Seq) : Box;

axiom (forall s: Seq, val: Box :: { Seq#Build(s, val) } Seq#Build_inv0(Seq#Build(s, val)) == s && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall s: Seq, v: Box :: { Seq#Build(s, v) } Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall s: Seq, i: int, v: Box :: { Seq#Index(Seq#Build(s, v), i) } (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v) && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq, bx: Box, t: Ty :: { $Is(Seq#Build(s, bx), TSeq(t)) } $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: { Seq#Length(Seq#Create(ty, heap, len, init): Seq) } $IsGoodHeap(heap) && 0 <= len ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: { Seq#Index(Seq#Create(ty, heap, len, init), i) } $IsGoodHeap(heap) && 0 <= i && i < len ==> Seq#Index(Seq#Create(ty, heap, len, init), i) == Apply1(TInt, ty, heap, init, $Box(i)));

function Seq#Append(Seq, Seq) : Seq;

axiom (forall s0: Seq, s1: Seq :: { Seq#Length(Seq#Append(s0, s1)) } Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

function Seq#Index(Seq, int) : Box;

axiom (forall t: Box :: { Seq#Index(Seq#Singleton(t), 0) } Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall s0: Seq, s1: Seq, n: int :: { Seq#Index(Seq#Append(s0, s1), n) } (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n)) && (Seq#Length(s0) <= n ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update(Seq, int, Box) : Seq;

axiom (forall s: Seq, i: int, v: Box :: { Seq#Length(Seq#Update(s, i, v)) } 0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall s: Seq, i: int, v: Box, n: int :: { Seq#Index(Seq#Update(s, i, v), n) } 0 <= n && n < Seq#Length(s) ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v) && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains(Seq, Box) : bool;

axiom (forall s: Seq, x: Box :: { Seq#Contains(s, x) } Seq#Contains(s, x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall x: Box :: { Seq#Contains(Seq#Empty(), x) } !Seq#Contains(Seq#Empty(), x));

axiom (forall s0: Seq, s1: Seq, x: Box :: { Seq#Contains(Seq#Append(s0, s1), x) } Seq#Contains(Seq#Append(s0, s1), x) <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall s: Seq, v: Box, x: Box :: { Seq#Contains(Seq#Build(s, v), x) } Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall s: Seq, n: int, x: Box :: { Seq#Contains(Seq#Take(s, n), x) } Seq#Contains(Seq#Take(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall s: Seq, n: int, x: Box :: { Seq#Contains(Seq#Drop(s, n), x) } Seq#Contains(Seq#Drop(s, n), x) <==> (exists i: int :: { Seq#Index(s, i) } 0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal(Seq, Seq) : bool;

axiom (forall s0: Seq, s1: Seq :: { Seq#Equal(s0, s1) } Seq#Equal(s0, s1) <==> Seq#Length(s0) == Seq#Length(s1) && (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall a: Seq, b: Seq :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil(Seq, Seq, int) : bool;

axiom (forall s0: Seq, s1: Seq, n: int :: { Seq#SameUntil(s0, s1, n) } Seq#SameUntil(s0, s1, n) <==> (forall j: int :: { Seq#Index(s0, j) } { Seq#Index(s1, j) } 0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take(s: Seq, howMany: int) : Seq;

axiom (forall s: Seq, n: int :: { Seq#Length(Seq#Take(s, n)) } 0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall s: Seq, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 0 <= j && j < n && j < Seq#Length(s) ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop(s: Seq, howMany: int) : Seq;

axiom (forall s: Seq, n: int :: { Seq#Length(Seq#Drop(s, n)) } 0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall s: Seq, n: int, j: int :: {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 0 <= n && 0 <= j && j < Seq#Length(s) - n ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall s: Seq, n: int, k: int :: {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 0 <= n && n <= k && k < Seq#Length(s) ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall s: Seq, t: Seq, n: int :: { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } n == Seq#Length(s) ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq;

axiom (forall h: Heap, a: ref :: { Seq#Length(Seq#FromArray(h, a)) } Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: { Seq#FromArray(h, a) } (forall i: int :: { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq, i) } 0 <= i && i < Seq#Length(Seq#FromArray(h, a)) ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a] ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: { Seq#FromArray(update(h, a, IndexField(i), v), a) } 0 <= i && i < _System.array.Length(a) ==> Seq#FromArray(update(h, a, IndexField(i), v), a) == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall s: Seq, i: int, v: Box, n: int :: { Seq#Take(Seq#Update(s, i, v), n) } 0 <= i && i < n && n <= Seq#Length(s) ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall s: Seq, i: int, v: Box, n: int :: { Seq#Take(Seq#Update(s, i, v), n) } n <= i && i < Seq#Length(s) ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall s: Seq, i: int, v: Box, n: int :: { Seq#Drop(Seq#Update(s, i, v), n) } 0 <= n && n <= i && i < Seq#Length(s) ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall s: Seq, i: int, v: Box, n: int :: { Seq#Drop(Seq#Update(s, i, v), n) } 0 <= i && i < n && n <= Seq#Length(s) ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a) ==> Seq#Take(Seq#FromArray(h, a), n1) == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field)));

axiom (forall s: Seq, v: Box, n: int :: { Seq#Drop(Seq#Build(s, v), n) } 0 <= n && n <= Seq#Length(s) ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank(Seq) : int;

axiom (forall s: Seq, i: int :: { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 0 <= i && i < Seq#Length(s) ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall s: Seq, i: int :: { Seq#Rank(Seq#Drop(s, i)) } 0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall s: Seq, i: int :: { Seq#Rank(Seq#Take(s, i)) } 0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall s: Seq, i: int, j: int :: { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 0 <= i && i < j && j <= Seq#Length(s) ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall s: Seq, n: int :: { Seq#Drop(s, n) } n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall s: Seq, n: int :: { Seq#Take(s, n) } n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall s: Seq, m: int, n: int :: { Seq#Drop(Seq#Drop(s, m), n) } 0 <= m && 0 <= n && m + n <= Seq#Length(s) ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map;

function Map#Domain(Map) : Set;

function Map#Elements(Map) : [Box]Box;

function Map#Card(Map) : int;

axiom (forall m: Map :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall m: Map :: { Map#Card(m) } Map#Card(m) == 0 <==> m == Map#Empty());

axiom (forall m: Map :: { Map#Domain(m) } m == Map#Empty() || (exists k: Box :: Map#Domain(m)[k]));

axiom (forall m: Map :: { Map#Values(m) } m == Map#Empty() || (exists v: Box :: Map#Values(m)[v]));

axiom (forall m: Map :: { Map#Items(m) } m == Map#Empty() || (exists k: Box, v: Box :: Map#Items(m)[$Box(#_System._tuple#2._#Make2(k, v))]));

axiom (forall m: Map :: { Set#Card(Map#Domain(m)) } { Map#Card(m) } Set#Card(Map#Domain(m)) == Map#Card(m));

axiom (forall m: Map :: { Set#Card(Map#Values(m)) } { Map#Card(m) } Set#Card(Map#Values(m)) <= Map#Card(m));

axiom (forall m: Map :: { Set#Card(Map#Items(m)) } { Map#Card(m) } Set#Card(Map#Items(m)) == Map#Card(m));

function Map#Values(Map) : Set;

axiom (forall m: Map, v: Box :: { Map#Values(m)[v] } Map#Values(m)[v] <==> (exists u: Box :: { Map#Domain(m)[u] } { Map#Elements(m)[u] } Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items(Map) : Set;

function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall m: Map, item: Box :: { Map#Items(m)[item] } Map#Items(m)[item] <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))] && Map#Elements(m)[_System.Tuple2._0($Unbox(item))] == _System.Tuple2._1($Unbox(item)));

function Map#Empty() : Map;

axiom (forall u: Box :: { Map#Domain(Map#Empty(): Map)[u] } !Map#Domain(Map#Empty(): Map)[u]);

function Map#Glue([Box]bool, [Box]Box, Ty) : Map;

axiom (forall a: [Box]bool, b: [Box]Box, t: Ty :: { Map#Domain(Map#Glue(a, b, t)) } Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall a: [Box]bool, b: [Box]Box, t: Ty :: { Map#Elements(Map#Glue(a, b, t)) } Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall a: [Box]bool, b: [Box]Box, t0: Ty, t1: Ty :: { Map#Glue(a, b, TMap(t0, t1)) } (forall bx: Box :: a[bx] ==> $IsBox(bx, t0) && $IsBox(b[bx], t1)) ==> $Is(Map#Glue(a, b, TMap(t0, t1)), TMap(t0, t1)));

function Map#Build(Map, Box, Box) : Map;

axiom (forall m: Map, u: Box, u': Box, v: Box :: { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } (u' == u ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v) && (u' != u ==> (Map#Domain(Map#Build(m, u, v))[u'] <==> Map#Domain(m)[u']) && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall m: Map, u: Box, v: Box :: { Map#Card(Map#Build(m, u, v)) } Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall m: Map, u: Box, v: Box :: { Map#Card(Map#Build(m, u, v)) } !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Merge(Map, Map) : Map;

axiom (forall m: Map, n: Map :: { Map#Domain(Map#Merge(m, n)) } Map#Domain(Map#Merge(m, n)) == Set#Union(Map#Domain(m), Map#Domain(n)));

axiom (forall m: Map, n: Map, u: Box :: { Map#Elements(Map#Merge(m, n))[u] } Map#Domain(Map#Merge(m, n))[u] ==> (!Map#Domain(n)[u] ==> Map#Elements(Map#Merge(m, n))[u] == Map#Elements(m)[u]) && (Map#Domain(n)[u] ==> Map#Elements(Map#Merge(m, n))[u] == Map#Elements(n)[u]));

function Map#Subtract(Map, Set) : Map;

axiom (forall m: Map, s: Set :: { Map#Domain(Map#Subtract(m, s)) } Map#Domain(Map#Subtract(m, s)) == Set#Difference(Map#Domain(m), s));

axiom (forall m: Map, s: Set, u: Box :: { Map#Elements(Map#Subtract(m, s))[u] } Map#Domain(Map#Subtract(m, s))[u] ==> Map#Elements(Map#Subtract(m, s))[u] == Map#Elements(m)[u]);

function Map#Equal(Map, Map) : bool;

axiom (forall m: Map, m': Map :: { Map#Equal(m, m') } Map#Equal(m, m') <==> (forall u: Box :: Map#Domain(m)[u] <==> Map#Domain(m')[u]) && (forall u: Box :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall m: Map, m': Map :: { Map#Equal(m, m') } Map#Equal(m, m') ==> m == m');

function Map#Disjoint(Map, Map) : bool;

axiom (forall m: Map, m': Map :: { Map#Disjoint(m, m') } Map#Disjoint(m, m') <==> (forall o: Box :: { Map#Domain(m)[o] } { Map#Domain(m')[o] } !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap;

function IMap#Domain(IMap) : Set;

function IMap#Elements(IMap) : [Box]Box;

axiom (forall m: IMap :: { IMap#Domain(m) } m == IMap#Empty() || (exists k: Box :: IMap#Domain(m)[k]));

axiom (forall m: IMap :: { IMap#Values(m) } m == IMap#Empty() || (exists v: Box :: IMap#Values(m)[v]));

axiom (forall m: IMap :: { IMap#Items(m) } m == IMap#Empty() || (exists k: Box, v: Box :: IMap#Items(m)[$Box(#_System._tuple#2._#Make2(k, v))]));

axiom (forall m: IMap :: { IMap#Domain(m) } m == IMap#Empty() <==> IMap#Domain(m) == ISet#Empty());

axiom (forall m: IMap :: { IMap#Values(m) } m == IMap#Empty() <==> IMap#Values(m) == ISet#Empty());

axiom (forall m: IMap :: { IMap#Items(m) } m == IMap#Empty() <==> IMap#Items(m) == ISet#Empty());

function IMap#Values(IMap) : Set;

axiom (forall m: IMap, v: Box :: { IMap#Values(m)[v] } IMap#Values(m)[v] <==> (exists u: Box :: { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items(IMap) : Set;

axiom (forall m: IMap, item: Box :: { IMap#Items(m)[item] } IMap#Items(m)[item] <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))] && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))] == _System.Tuple2._1($Unbox(item)));

function IMap#Empty() : IMap;

axiom (forall u: Box :: { IMap#Domain(IMap#Empty(): IMap)[u] } !IMap#Domain(IMap#Empty(): IMap)[u]);

function IMap#Glue([Box]bool, [Box]Box, Ty) : IMap;

axiom (forall a: [Box]bool, b: [Box]Box, t: Ty :: { IMap#Domain(IMap#Glue(a, b, t)) } IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall a: [Box]bool, b: [Box]Box, t: Ty :: { IMap#Elements(IMap#Glue(a, b, t)) } IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall a: [Box]bool, b: [Box]Box, t0: Ty, t1: Ty :: { IMap#Glue(a, b, TIMap(t0, t1)) } (forall bx: Box :: a[bx] ==> $IsBox(bx, t0) && $IsBox(b[bx], t1)) ==> $Is(Map#Glue(a, b, TIMap(t0, t1)), TIMap(t0, t1)));

function IMap#Build(IMap, Box, Box) : IMap;

axiom (forall m: IMap, u: Box, u': Box, v: Box :: { IMap#Domain(IMap#Build(m, u, v))[u'] } { IMap#Elements(IMap#Build(m, u, v))[u'] } (u' == u ==> IMap#Domain(IMap#Build(m, u, v))[u'] && IMap#Elements(IMap#Build(m, u, v))[u'] == v) && (u' != u ==> (IMap#Domain(IMap#Build(m, u, v))[u'] <==> IMap#Domain(m)[u']) && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal(IMap, IMap) : bool;

axiom (forall m: IMap, m': IMap :: { IMap#Equal(m, m') } IMap#Equal(m, m') <==> (forall u: Box :: IMap#Domain(m)[u] <==> IMap#Domain(m')[u]) && (forall u: Box :: IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall m: IMap, m': IMap :: { IMap#Equal(m, m') } IMap#Equal(m, m') ==> m == m');

function IMap#Merge(IMap, IMap) : IMap;

axiom (forall m: IMap, n: IMap :: { IMap#Domain(IMap#Merge(m, n)) } IMap#Domain(IMap#Merge(m, n)) == Set#Union(IMap#Domain(m), IMap#Domain(n)));

axiom (forall m: IMap, n: IMap, u: Box :: { IMap#Elements(IMap#Merge(m, n))[u] } IMap#Domain(IMap#Merge(m, n))[u] ==> (!IMap#Domain(n)[u] ==> IMap#Elements(IMap#Merge(m, n))[u] == IMap#Elements(m)[u]) && (IMap#Domain(n)[u] ==> IMap#Elements(IMap#Merge(m, n))[u] == IMap#Elements(n)[u]));

function IMap#Subtract(IMap, Set) : IMap;

axiom (forall m: IMap, s: Set :: { IMap#Domain(IMap#Subtract(m, s)) } IMap#Domain(IMap#Subtract(m, s)) == Set#Difference(IMap#Domain(m), s));

axiom (forall m: IMap, s: Set, u: Box :: { IMap#Elements(IMap#Subtract(m, s))[u] } IMap#Domain(IMap#Subtract(m, s))[u] ==> IMap#Elements(IMap#Subtract(m, s))[u] == IMap#Elements(m)[u]);

function INTERNAL_add_boogie(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { INTERNAL_add_boogie(x, y): int } INTERNAL_add_boogie(x, y): int == x + y);
}

function INTERNAL_sub_boogie(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { INTERNAL_sub_boogie(x, y): int } INTERNAL_sub_boogie(x, y): int == x - y);
}

function INTERNAL_mul_boogie(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { INTERNAL_mul_boogie(x, y): int } INTERNAL_mul_boogie(x, y): int == x * y);
}

function INTERNAL_div_boogie(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { INTERNAL_div_boogie(x, y): int } INTERNAL_div_boogie(x, y): int == x div y);
}

function INTERNAL_mod_boogie(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { INTERNAL_mod_boogie(x, y): int } INTERNAL_mod_boogie(x, y): int == x mod y);
}

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool
uses {
axiom (forall x: int, y: int :: {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } INTERNAL_lt_boogie(x, y): bool <==> x < y);
}

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool
uses {
axiom (forall x: int, y: int :: {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } INTERNAL_le_boogie(x, y): bool <==> x <= y);
}

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool
uses {
axiom (forall x: int, y: int :: {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } INTERNAL_gt_boogie(x, y): bool <==> x > y);
}

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool
uses {
axiom (forall x: int, y: int :: {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } INTERNAL_ge_boogie(x, y): bool <==> x >= y);
}

function Mul(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);
}

function Div(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);
}

function Mod(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);
}

function Add(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);
}

function Sub(x: int, y: int) : int
uses {
axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);
}

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(8)) } $IsBox(bx, TBitvector(8)) ==> $Box($Unbox(bx): bv8) == bx && $Is($Unbox(bx): bv8, TBitvector(8)));

axiom (forall v: bv8 :: { $Is(v, TBitvector(8)) } $Is(v, TBitvector(8)));

axiom (forall v: bv8, heap: Heap :: { $IsAlloc(v, TBitvector(8), heap) } $IsAlloc(v, TBitvector(8), heap));

function {:bvbuiltin "bvand"} and_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvor"} or_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvxor"} xor_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvnot"} not_bv8(bv8) : bv8;

function {:bvbuiltin "bvadd"} add_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvsub"} sub_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvmul"} mul_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvudiv"} div_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvurem"} mod_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvult"} lt_bv8(bv8, bv8) : bool;

function {:bvbuiltin "bvule"} le_bv8(bv8, bv8) : bool;

function {:bvbuiltin "bvuge"} ge_bv8(bv8, bv8) : bool;

function {:bvbuiltin "bvugt"} gt_bv8(bv8, bv8) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "bvlshr"} RightShift_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv8(bv8, bv8) : bv8;

function {:bvbuiltin "(_ int2bv 8)"} nat_to_bv8(int) : bv8;

function {:bvbuiltin "bv2int"} smt_nat_from_bv8(bv8) : int;

function nat_from_bv8(bv8) : int;

axiom (forall b: bv8 :: { nat_from_bv8(b) } 0 <= nat_from_bv8(b) && nat_from_bv8(b) < 256 && nat_from_bv8(b) == smt_nat_from_bv8(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(24)) } $IsBox(bx, TBitvector(24)) ==> $Box($Unbox(bx): bv24) == bx && $Is($Unbox(bx): bv24, TBitvector(24)));

axiom (forall v: bv24 :: { $Is(v, TBitvector(24)) } $Is(v, TBitvector(24)));

axiom (forall v: bv24, heap: Heap :: { $IsAlloc(v, TBitvector(24), heap) } $IsAlloc(v, TBitvector(24), heap));

function {:bvbuiltin "bvand"} and_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvor"} or_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvxor"} xor_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvnot"} not_bv24(bv24) : bv24;

function {:bvbuiltin "bvadd"} add_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvsub"} sub_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvmul"} mul_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvudiv"} div_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvurem"} mod_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvult"} lt_bv24(bv24, bv24) : bool;

function {:bvbuiltin "bvule"} le_bv24(bv24, bv24) : bool;

function {:bvbuiltin "bvuge"} ge_bv24(bv24, bv24) : bool;

function {:bvbuiltin "bvugt"} gt_bv24(bv24, bv24) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "bvlshr"} RightShift_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv24(bv24, bv24) : bv24;

function {:bvbuiltin "(_ int2bv 24)"} nat_to_bv24(int) : bv24;

function {:bvbuiltin "bv2int"} smt_nat_from_bv24(bv24) : int;

function nat_from_bv24(bv24) : int;

axiom (forall b: bv24 :: { nat_from_bv24(b) } 0 <= nat_from_bv24(b) && nat_from_bv24(b) < 16777216 && nat_from_bv24(b) == smt_nat_from_bv24(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(5)) } $IsBox(bx, TBitvector(5)) ==> $Box($Unbox(bx): bv5) == bx && $Is($Unbox(bx): bv5, TBitvector(5)));

axiom (forall v: bv5 :: { $Is(v, TBitvector(5)) } $Is(v, TBitvector(5)));

axiom (forall v: bv5, heap: Heap :: { $IsAlloc(v, TBitvector(5), heap) } $IsAlloc(v, TBitvector(5), heap));

function {:bvbuiltin "bvand"} and_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvor"} or_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvxor"} xor_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvnot"} not_bv5(bv5) : bv5;

function {:bvbuiltin "bvadd"} add_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvsub"} sub_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvmul"} mul_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvudiv"} div_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvurem"} mod_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvult"} lt_bv5(bv5, bv5) : bool;

function {:bvbuiltin "bvule"} le_bv5(bv5, bv5) : bool;

function {:bvbuiltin "bvuge"} ge_bv5(bv5, bv5) : bool;

function {:bvbuiltin "bvugt"} gt_bv5(bv5, bv5) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "bvlshr"} RightShift_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv5(bv5, bv5) : bv5;

function {:bvbuiltin "(_ int2bv 5)"} nat_to_bv5(int) : bv5;

function {:bvbuiltin "bv2int"} smt_nat_from_bv5(bv5) : int;

function nat_from_bv5(bv5) : int;

axiom (forall b: bv5 :: { nat_from_bv5(b) } 0 <= nat_from_bv5(b) && nat_from_bv5(b) < 32 && nat_from_bv5(b) == smt_nat_from_bv5(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(7)) } $IsBox(bx, TBitvector(7)) ==> $Box($Unbox(bx): bv7) == bx && $Is($Unbox(bx): bv7, TBitvector(7)));

axiom (forall v: bv7 :: { $Is(v, TBitvector(7)) } $Is(v, TBitvector(7)));

axiom (forall v: bv7, heap: Heap :: { $IsAlloc(v, TBitvector(7), heap) } $IsAlloc(v, TBitvector(7), heap));

function {:bvbuiltin "bvand"} and_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvor"} or_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvxor"} xor_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvnot"} not_bv7(bv7) : bv7;

function {:bvbuiltin "bvadd"} add_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvsub"} sub_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvmul"} mul_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvudiv"} div_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvurem"} mod_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvult"} lt_bv7(bv7, bv7) : bool;

function {:bvbuiltin "bvule"} le_bv7(bv7, bv7) : bool;

function {:bvbuiltin "bvuge"} ge_bv7(bv7, bv7) : bool;

function {:bvbuiltin "bvugt"} gt_bv7(bv7, bv7) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "bvlshr"} RightShift_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv7(bv7, bv7) : bv7;

function {:bvbuiltin "(_ int2bv 7)"} nat_to_bv7(int) : bv7;

function {:bvbuiltin "bv2int"} smt_nat_from_bv7(bv7) : int;

function nat_from_bv7(bv7) : int;

axiom (forall b: bv7 :: { nat_from_bv7(b) } 0 <= nat_from_bv7(b) && nat_from_bv7(b) < 128 && nat_from_bv7(b) == smt_nat_from_bv7(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(6)) } $IsBox(bx, TBitvector(6)) ==> $Box($Unbox(bx): bv6) == bx && $Is($Unbox(bx): bv6, TBitvector(6)));

axiom (forall v: bv6 :: { $Is(v, TBitvector(6)) } $Is(v, TBitvector(6)));

axiom (forall v: bv6, heap: Heap :: { $IsAlloc(v, TBitvector(6), heap) } $IsAlloc(v, TBitvector(6), heap));

function {:bvbuiltin "bvand"} and_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvor"} or_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvxor"} xor_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvnot"} not_bv6(bv6) : bv6;

function {:bvbuiltin "bvadd"} add_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvsub"} sub_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvmul"} mul_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvudiv"} div_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvurem"} mod_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvult"} lt_bv6(bv6, bv6) : bool;

function {:bvbuiltin "bvule"} le_bv6(bv6, bv6) : bool;

function {:bvbuiltin "bvuge"} ge_bv6(bv6, bv6) : bool;

function {:bvbuiltin "bvugt"} gt_bv6(bv6, bv6) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "bvlshr"} RightShift_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv6(bv6, bv6) : bv6;

function {:bvbuiltin "(_ int2bv 6)"} nat_to_bv6(int) : bv6;

function {:bvbuiltin "bv2int"} smt_nat_from_bv6(bv6) : int;

function nat_from_bv6(bv6) : int;

axiom (forall b: bv6 :: { nat_from_bv6(b) } 0 <= nat_from_bv6(b) && nat_from_bv6(b) < 64 && nat_from_bv6(b) == smt_nat_from_bv6(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(4)) } $IsBox(bx, TBitvector(4)) ==> $Box($Unbox(bx): bv4) == bx && $Is($Unbox(bx): bv4, TBitvector(4)));

axiom (forall v: bv4 :: { $Is(v, TBitvector(4)) } $Is(v, TBitvector(4)));

axiom (forall v: bv4, heap: Heap :: { $IsAlloc(v, TBitvector(4), heap) } $IsAlloc(v, TBitvector(4), heap));

function {:bvbuiltin "bvand"} and_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvor"} or_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvxor"} xor_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvnot"} not_bv4(bv4) : bv4;

function {:bvbuiltin "bvadd"} add_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvsub"} sub_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvmul"} mul_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvudiv"} div_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvurem"} mod_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvult"} lt_bv4(bv4, bv4) : bool;

function {:bvbuiltin "bvule"} le_bv4(bv4, bv4) : bool;

function {:bvbuiltin "bvuge"} ge_bv4(bv4, bv4) : bool;

function {:bvbuiltin "bvugt"} gt_bv4(bv4, bv4) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "bvlshr"} RightShift_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv4(bv4, bv4) : bv4;

function {:bvbuiltin "(_ int2bv 4)"} nat_to_bv4(int) : bv4;

function {:bvbuiltin "bv2int"} smt_nat_from_bv4(bv4) : int;

function nat_from_bv4(bv4) : int;

axiom (forall b: bv4 :: { nat_from_bv4(b) } 0 <= nat_from_bv4(b) && nat_from_bv4(b) < 16 && nat_from_bv4(b) == smt_nat_from_bv4(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(2)) } $IsBox(bx, TBitvector(2)) ==> $Box($Unbox(bx): bv2) == bx && $Is($Unbox(bx): bv2, TBitvector(2)));

axiom (forall v: bv2 :: { $Is(v, TBitvector(2)) } $Is(v, TBitvector(2)));

axiom (forall v: bv2, heap: Heap :: { $IsAlloc(v, TBitvector(2), heap) } $IsAlloc(v, TBitvector(2), heap));

function {:bvbuiltin "bvand"} and_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvor"} or_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvxor"} xor_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvnot"} not_bv2(bv2) : bv2;

function {:bvbuiltin "bvadd"} add_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvsub"} sub_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvmul"} mul_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvudiv"} div_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvurem"} mod_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvult"} lt_bv2(bv2, bv2) : bool;

function {:bvbuiltin "bvule"} le_bv2(bv2, bv2) : bool;

function {:bvbuiltin "bvuge"} ge_bv2(bv2, bv2) : bool;

function {:bvbuiltin "bvugt"} gt_bv2(bv2, bv2) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "bvlshr"} RightShift_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv2(bv2, bv2) : bv2;

function {:bvbuiltin "(_ int2bv 2)"} nat_to_bv2(int) : bv2;

function {:bvbuiltin "bv2int"} smt_nat_from_bv2(bv2) : int;

function nat_from_bv2(bv2) : int;

axiom (forall b: bv2 :: { nat_from_bv2(b) } 0 <= nat_from_bv2(b) && nat_from_bv2(b) < 4 && nat_from_bv2(b) == smt_nat_from_bv2(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(3)) } $IsBox(bx, TBitvector(3)) ==> $Box($Unbox(bx): bv3) == bx && $Is($Unbox(bx): bv3, TBitvector(3)));

axiom (forall v: bv3 :: { $Is(v, TBitvector(3)) } $Is(v, TBitvector(3)));

axiom (forall v: bv3, heap: Heap :: { $IsAlloc(v, TBitvector(3), heap) } $IsAlloc(v, TBitvector(3), heap));

function {:bvbuiltin "bvand"} and_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvor"} or_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvxor"} xor_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvnot"} not_bv3(bv3) : bv3;

function {:bvbuiltin "bvadd"} add_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvsub"} sub_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvmul"} mul_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvudiv"} div_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvurem"} mod_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvult"} lt_bv3(bv3, bv3) : bool;

function {:bvbuiltin "bvule"} le_bv3(bv3, bv3) : bool;

function {:bvbuiltin "bvuge"} ge_bv3(bv3, bv3) : bool;

function {:bvbuiltin "bvugt"} gt_bv3(bv3, bv3) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "bvlshr"} RightShift_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv3(bv3, bv3) : bv3;

function {:bvbuiltin "(_ int2bv 3)"} nat_to_bv3(int) : bv3;

function {:bvbuiltin "bv2int"} smt_nat_from_bv3(bv3) : int;

function nat_from_bv3(bv3) : int;

axiom (forall b: bv3 :: { nat_from_bv3(b) } 0 <= nat_from_bv3(b) && nat_from_bv3(b) < 8 && nat_from_bv3(b) == smt_nat_from_bv3(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(16)) } $IsBox(bx, TBitvector(16)) ==> $Box($Unbox(bx): bv16) == bx && $Is($Unbox(bx): bv16, TBitvector(16)));

axiom (forall v: bv16 :: { $Is(v, TBitvector(16)) } $Is(v, TBitvector(16)));

axiom (forall v: bv16, heap: Heap :: { $IsAlloc(v, TBitvector(16), heap) } $IsAlloc(v, TBitvector(16), heap));

function {:bvbuiltin "bvand"} and_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvor"} or_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvxor"} xor_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvnot"} not_bv16(bv16) : bv16;

function {:bvbuiltin "bvadd"} add_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvsub"} sub_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvmul"} mul_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvudiv"} div_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvurem"} mod_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvult"} lt_bv16(bv16, bv16) : bool;

function {:bvbuiltin "bvule"} le_bv16(bv16, bv16) : bool;

function {:bvbuiltin "bvuge"} ge_bv16(bv16, bv16) : bool;

function {:bvbuiltin "bvugt"} gt_bv16(bv16, bv16) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "bvlshr"} RightShift_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv16(bv16, bv16) : bv16;

function {:bvbuiltin "(_ int2bv 16)"} nat_to_bv16(int) : bv16;

function {:bvbuiltin "bv2int"} smt_nat_from_bv16(bv16) : int;

function nat_from_bv16(bv16) : int;

axiom (forall b: bv16 :: { nat_from_bv16(b) } 0 <= nat_from_bv16(b) && nat_from_bv16(b) < 65536 && nat_from_bv16(b) == smt_nat_from_bv16(b));

axiom (forall bx: Box :: { $IsBox(bx, TBitvector(10)) } $IsBox(bx, TBitvector(10)) ==> $Box($Unbox(bx): bv10) == bx && $Is($Unbox(bx): bv10, TBitvector(10)));

axiom (forall v: bv10 :: { $Is(v, TBitvector(10)) } $Is(v, TBitvector(10)));

axiom (forall v: bv10, heap: Heap :: { $IsAlloc(v, TBitvector(10), heap) } $IsAlloc(v, TBitvector(10), heap));

function {:bvbuiltin "bvand"} and_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvor"} or_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvxor"} xor_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvnot"} not_bv10(bv10) : bv10;

function {:bvbuiltin "bvadd"} add_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvsub"} sub_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvmul"} mul_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvudiv"} div_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvurem"} mod_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvult"} lt_bv10(bv10, bv10) : bool;

function {:bvbuiltin "bvule"} le_bv10(bv10, bv10) : bool;

function {:bvbuiltin "bvuge"} ge_bv10(bv10, bv10) : bool;

function {:bvbuiltin "bvugt"} gt_bv10(bv10, bv10) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "bvlshr"} RightShift_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv10(bv10, bv10) : bv10;

function {:bvbuiltin "(_ int2bv 10)"} nat_to_bv10(int) : bv10;

function {:bvbuiltin "bv2int"} smt_nat_from_bv10(bv10) : int;

function nat_from_bv10(bv10) : int;

axiom (forall b: bv10 :: { nat_from_bv10(b) } 0 <= nat_from_bv10(b) && nat_from_bv10(b) < 1024 && nat_from_bv10(b) == smt_nat_from_bv10(b));

function Tclass._System.nat() : Ty
uses {
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat && TagFamily(Tclass._System.nat()) == tytagFamily$nat;
}

const unique Tagclass._System.nat: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass._System.nat()) } $IsBox(bx, Tclass._System.nat()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

axiom (forall x#0: int :: { $Is(x#0, Tclass._System.nat()) } $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass._System.nat(), $h) } $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

const unique Tagclass._System.object?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass._System.object?()) } $IsBox(bx, Tclass._System.object?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

axiom (forall $o: ref :: { $Is($o, Tclass._System.object?()) } $Is($o, Tclass._System.object?()));

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass._System.object?(), $h) } $IsAlloc($o, Tclass._System.object?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$_System.object(ty: Ty) : bool;

function Tclass._System.object() : Ty
uses {
axiom Tag(Tclass._System.object()) == Tagclass._System.object && TagFamily(Tclass._System.object()) == tytagFamily$object;
}

const unique Tagclass._System.object: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass._System.object()) } $IsBox(bx, Tclass._System.object()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

axiom (forall c#0: ref :: { $Is(c#0, Tclass._System.object()) } $Is(c#0, Tclass._System.object()) <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass._System.object(), $h) } $IsAlloc(c#0, Tclass._System.object(), $h) <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

const unique Tagclass._System.array?: TyTag;

axiom (forall _System.array$arg: Ty :: { Tclass._System.array?(_System.array$arg) } Tag(Tclass._System.array?(_System.array$arg)) == Tagclass._System.array? && TagFamily(Tclass._System.array?(_System.array$arg)) == tytagFamily$array);

function Tclass._System.array?_0(Ty) : Ty;

axiom (forall _System.array$arg: Ty :: { Tclass._System.array?(_System.array$arg) } Tclass._System.array?_0(Tclass._System.array?(_System.array$arg)) == _System.array$arg);

axiom (forall _System.array$arg: Ty, bx: Box :: { $IsBox(bx, Tclass._System.array?(_System.array$arg)) } $IsBox(bx, Tclass._System.array?(_System.array$arg)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.array?(_System.array$arg)));

axiom (forall _System.array$arg: Ty, $h: Heap, $o: ref, $i0: int :: { read($h, $o, IndexField($i0)), Tclass._System.array?(_System.array$arg) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass._System.array?(_System.array$arg) && 0 <= $i0 && $i0 < _System.array.Length($o) ==> $IsBox(read($h, $o, IndexField($i0)), _System.array$arg));

axiom (forall _System.array$arg: Ty, $h: Heap, $o: ref, $i0: int :: { read($h, $o, IndexField($i0)), Tclass._System.array?(_System.array$arg) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass._System.array?(_System.array$arg) && 0 <= $i0 && $i0 < _System.array.Length($o) && $Unbox(read($h, $o, alloc)): bool ==> $IsAllocBox(read($h, $o, IndexField($i0)), _System.array$arg, $h));

axiom (forall _System.array$arg: Ty, $o: ref :: { $Is($o, Tclass._System.array?(_System.array$arg)) } $Is($o, Tclass._System.array?(_System.array$arg)) <==> $o == null || dtype($o) == Tclass._System.array?(_System.array$arg));

axiom (forall _System.array$arg: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass._System.array?(_System.array$arg), $h) } $IsAlloc($o, Tclass._System.array?(_System.array$arg), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

axiom (forall _System.array$arg: Ty, $o: ref :: { _System.array.Length($o), Tclass._System.array?(_System.array$arg) } $o != null && dtype($o) == Tclass._System.array?(_System.array$arg) ==> $Is(_System.array.Length($o), TInt));

axiom (forall _System.array$arg: Ty, $h: Heap, $o: ref :: { _System.array.Length($o), $Unbox(read($h, $o, alloc)): bool, Tclass._System.array?(_System.array$arg) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass._System.array?(_System.array$arg) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

const unique Tagclass._System.array: TyTag;

axiom (forall _System.array$arg: Ty :: { Tclass._System.array(_System.array$arg) } Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array && TagFamily(Tclass._System.array(_System.array$arg)) == tytagFamily$array);

function Tclass._System.array_0(Ty) : Ty;

axiom (forall _System.array$arg: Ty :: { Tclass._System.array(_System.array$arg) } Tclass._System.array_0(Tclass._System.array(_System.array$arg)) == _System.array$arg);

axiom (forall _System.array$arg: Ty, bx: Box :: { $IsBox(bx, Tclass._System.array(_System.array$arg)) } $IsBox(bx, Tclass._System.array(_System.array$arg)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

axiom (forall _System.array$arg: Ty, c#0: ref :: { $Is(c#0, Tclass._System.array(_System.array$arg)) } $Is(c#0, Tclass._System.array(_System.array$arg)) <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

const unique Tagclass._System.___hFunc1: TyTag;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hFunc1(#$T0, #$R) } Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1 && TagFamily(Tclass._System.___hFunc1(#$T0, #$R)) == tytagFamily$_#Func1);

function Tclass._System.___hFunc1_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hFunc1(#$T0, #$R) } Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hFunc1(#$T0, #$R) } Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set;

axiom (forall t0: Ty, t1: Ty, heap: Heap, h: [Heap,Box]Box, r: [Heap,Box]bool, rd: [Heap,Box]Set, bx0: Box :: { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, t1: Ty, heap: Heap, h: [Heap,Box]Box, r: [Heap,Box]bool, rd: [Heap,Box]Set, bx0: Box :: { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, t1: Ty, heap: Heap, h: [Heap,Box]Box, r: [Heap,Box]bool, rd: [Heap,Box]Set, bx0: Box, bx: Box :: { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] <==> rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall o: ref, fld: Field :: o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall o: ref, fld: Field :: o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall o: ref, fld: Field :: o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires1(t0, t1, h0, f, bx0) <==> Requires1(t0, t1, h1, f, bx0)));

axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall o: ref, fld: Field :: o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires1(t0, t1, h0, f, bx0) <==> Requires1(t0, t1, h1, f, bx0)));

axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall o: ref, fld: Field :: o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall o: ref, fld: Field :: o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } { Reads1(t0, t1, heap, f, bx0) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set) <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set)));

axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } { Requires1(t0, t1, heap, f, bx0) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1)) && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set) ==> (Requires1(t0, t1, $OneHeap, f, bx0) <==> Requires1(t0, t1, heap, f, bx0)));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: { $Is(f, Tclass._System.___hFunc1(t0, t1)) } $Is(f, Tclass._System.___hFunc1(t0, t1)) <==> (forall h: Heap, bx0: Box :: { Apply1(t0, t1, h, f, bx0) } $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0) ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } $Is(f, Tclass._System.___hFunc1(t0, t1)) && (forall bx: Box :: { $IsBox(bx, u0) } { $IsBox(bx, t0) } $IsBox(bx, u0) ==> $IsBox(bx, t0)) && (forall bx: Box :: { $IsBox(bx, t1) } { $IsBox(bx, u1) } $IsBox(bx, t1) ==> $IsBox(bx, u1)) ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) <==> (forall bx0: Box :: { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0) ==> (forall r: ref :: { Reads1(t0, t1, h, f, bx0)[$Box(r)] } r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) ==> (forall bx0: Box :: { Apply1(t0, t1, h, f, bx0) } $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0) ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

const unique Tagclass._System.___hPartialFunc1: TyTag;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc1(#$T0, #$R) } Tag(Tclass._System.___hPartialFunc1(#$T0, #$R)) == Tagclass._System.___hPartialFunc1 && TagFamily(Tclass._System.___hPartialFunc1(#$T0, #$R)) == tytagFamily$_#PartialFunc1);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc1(#$T0, #$R) } Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc1(#$T0, #$R) } Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R)) == #$R);

axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R)) && (forall x0#0: Box :: $IsBox(x0#0, #$T0) ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set)));

axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

const unique Tagclass._System.___hTotalFunc1: TyTag;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc1(#$T0, #$R) } Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1 && TagFamily(Tclass._System.___hTotalFunc1(#$T0, #$R)) == tytagFamily$_#TotalFunc1);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc1(#$T0, #$R) } Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc1(#$T0, #$R) } Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) && (forall x0#0: Box :: $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

const unique Tagclass._System.___hFunc0: TyTag;

axiom (forall #$R: Ty :: { Tclass._System.___hFunc0(#$R) } Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0 && TagFamily(Tclass._System.___hFunc0(#$R)) == tytagFamily$_#Func0);

function Tclass._System.___hFunc0_0(Ty) : Ty;

axiom (forall #$R: Ty :: { Tclass._System.___hFunc0(#$R) } Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

axiom (forall #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } $IsBox(bx, Tclass._System.___hFunc0(#$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set :: { Apply0(t0, heap, Handle0(h, r, rd)) } Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set :: { Requires0(t0, heap, Handle0(h, r, rd)) } r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set, bx: Box :: { Reads0(t0, heap, Handle0(h, r, rd))[bx] } Reads0(t0, heap, Handle0(h, r, rd))[bx] <==> rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: { $HeapSucc(h0, h1), Reads0(t0, h1, f) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $Is(f, Tclass._System.___hFunc0(t0)) && (forall o: ref, fld: Field :: o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: { $HeapSucc(h0, h1), Reads0(t0, h1, f) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $Is(f, Tclass._System.___hFunc0(t0)) && (forall o: ref, fld: Field :: o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: { $HeapSucc(h0, h1), Requires0(t0, h1, f) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $Is(f, Tclass._System.___hFunc0(t0)) && (forall o: ref, fld: Field :: o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires0(t0, h0, f) <==> Requires0(t0, h1, f)));

axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: { $HeapSucc(h0, h1), Requires0(t0, h1, f) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $Is(f, Tclass._System.___hFunc0(t0)) && (forall o: ref, fld: Field :: o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires0(t0, h0, f) <==> Requires0(t0, h1, f)));

axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: { $HeapSucc(h0, h1), Apply0(t0, h1, f) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $Is(f, Tclass._System.___hFunc0(t0)) && (forall o: ref, fld: Field :: o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: { $HeapSucc(h0, h1), Apply0(t0, h1, f) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $Is(f, Tclass._System.___hFunc0(t0)) && (forall o: ref, fld: Field :: o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

axiom (forall t0: Ty, heap: Heap, f: HandleType :: { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0)) ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set) <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set)));

axiom (forall t0: Ty, heap: Heap, f: HandleType :: { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0)) && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set) ==> (Requires0(t0, $OneHeap, f) <==> Requires0(t0, heap, f)));

axiom (forall f: HandleType, t0: Ty :: { $Is(f, Tclass._System.___hFunc0(t0)) } $Is(f, Tclass._System.___hFunc0(t0)) <==> (forall h: Heap :: { Apply0(t0, h, f) } $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } $Is(f, Tclass._System.___hFunc0(t0)) && (forall bx: Box :: { $IsBox(bx, t0) } { $IsBox(bx, u0) } $IsBox(bx, t0) ==> $IsBox(bx, u0)) ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h) <==> Requires0(t0, h, f) ==> (forall r: ref :: { Reads0(t0, h, f)[$Box(r)] } r != null && Reads0(t0, h, f)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h) ==> Requires0(t0, h, f) ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

const unique Tagclass._System.___hPartialFunc0: TyTag;

axiom (forall #$R: Ty :: { Tclass._System.___hPartialFunc0(#$R) } Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0 && TagFamily(Tclass._System.___hPartialFunc0(#$R)) == tytagFamily$_#PartialFunc0);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

axiom (forall #$R: Ty :: { Tclass._System.___hPartialFunc0(#$R) } Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

axiom (forall #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

axiom (forall #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) <==> $Is(f#0, Tclass._System.___hFunc0(#$R)) && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set));

axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

const unique Tagclass._System.___hTotalFunc0: TyTag;

axiom (forall #$R: Ty :: { Tclass._System.___hTotalFunc0(#$R) } Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0 && TagFamily(Tclass._System.___hTotalFunc0(#$R)) == tytagFamily$_#TotalFunc0);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

axiom (forall #$R: Ty :: { Tclass._System.___hTotalFunc0(#$R) } Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

axiom (forall #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

axiom (forall #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique ##_System._tuple#2._#Make2: DtCtorId
uses {
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0)) == ##_System._tuple#2._#Make2);
}

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { _System.Tuple2.___hMake2_q(d) } _System.Tuple2.___hMake2_q(d) <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

axiom (forall d: DatatypeType :: { _System.Tuple2.___hMake2_q(d) } _System.Tuple2.___hMake2_q(d) ==> (exists a#1#0#0: Box, a#1#1#0: Box :: d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

const unique Tagclass._System.Tuple2: TyTag;

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty :: { Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1) } Tag(Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) == Tagclass._System.Tuple2 && TagFamily(Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) == tytagFamily$_tuple#2);

function Tclass._System.Tuple2_0(Ty) : Ty;

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty :: { Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1) } Tclass._System.Tuple2_0(Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) == _System._tuple#2$T0);

function Tclass._System.Tuple2_1(Ty) : Ty;

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty :: { Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1) } Tclass._System.Tuple2_1(Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) == _System._tuple#2$T1);

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty, bx: Box :: { $IsBox(bx, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) } $IsBox(bx, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)));

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) } $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) <==> $IsBox(a#2#0#0, _System._tuple#2$T0) && $IsBox(a#2#1#0, _System._tuple#2$T1));

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty, a#2#0#0: Box, a#2#1#0: Box, $h: Heap :: { $IsAlloc(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1), $h) <==> $IsAllocBox(a#2#0#0, _System._tuple#2$T0, $h) && $IsAllocBox(a#2#1#0, _System._tuple#2$T1, $h)));

axiom (forall d: DatatypeType, _System._tuple#2$T0: Ty, $h: Heap :: { $IsAllocBox(_System.Tuple2._0(d), _System._tuple#2$T0, $h) } $IsGoodHeap($h) && _System.Tuple2.___hMake2_q(d) && (exists _System._tuple#2$T1: Ty :: { $IsAlloc(d, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1), $h) } $IsAlloc(d, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1), $h)) ==> $IsAllocBox(_System.Tuple2._0(d), _System._tuple#2$T0, $h));

axiom (forall d: DatatypeType, _System._tuple#2$T1: Ty, $h: Heap :: { $IsAllocBox(_System.Tuple2._1(d), _System._tuple#2$T1, $h) } $IsGoodHeap($h) && _System.Tuple2.___hMake2_q(d) && (exists _System._tuple#2$T0: Ty :: { $IsAlloc(d, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1), $h) } $IsAlloc(d, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1), $h)) ==> $IsAllocBox(_System.Tuple2._1(d), _System._tuple#2$T1, $h));

axiom (forall a#3#0#0: Box, a#3#1#0: Box :: { #_System._tuple#2._#Make2(Lit(a#3#0#0), Lit(a#3#1#0)) } #_System._tuple#2._#Make2(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0)));

axiom (forall a#4#0#0: Box, a#4#1#0: Box :: { #_System._tuple#2._#Make2(a#4#0#0, a#4#1#0) } _System.Tuple2._0(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)) == a#4#0#0);

axiom (forall a#5#0#0: Box, a#5#1#0: Box :: { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } BoxRank(a#5#0#0) < DtRank(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)));

axiom (forall a#6#0#0: Box, a#6#1#0: Box :: { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } _System.Tuple2._1(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)) == a#6#1#0);

axiom (forall a#7#0#0: Box, a#7#1#0: Box :: { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } BoxRank(a#7#1#0) < DtRank(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)));

function $IsA#_System.Tuple2(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#_System.Tuple2(d) } $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

axiom (forall _System._tuple#2$T0: Ty, _System._tuple#2$T1: Ty, d: DatatypeType :: { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) } $Is(d, Tclass._System.Tuple2(_System._tuple#2$T0, _System._tuple#2$T1)) ==> _System.Tuple2.___hMake2_q(d));

function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { _System.Tuple2#Equal(a, b) } _System.Tuple2#Equal(a, b) <==> _System.Tuple2._0(a) == _System.Tuple2._0(b) && _System.Tuple2._1(a) == _System.Tuple2._1(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { _System.Tuple2#Equal(a, b) } _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

function #_System._tuple#0._#Make0() : DatatypeType
uses {
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());
}

const unique ##_System._tuple#0._#Make0: DtCtorId
uses {
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;
}

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { _System.Tuple0.___hMake0_q(d) } _System.Tuple0.___hMake0_q(d) <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

axiom (forall d: DatatypeType :: { _System.Tuple0.___hMake0_q(d) } _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty
uses {
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0 && TagFamily(Tclass._System.Tuple0()) == tytagFamily$_tuple#0;
}

const unique Tagclass._System.Tuple0: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass._System.Tuple0()) } $IsBox(bx, Tclass._System.Tuple0()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass._System.Tuple0(), $h) } $IsGoodHeap($h) && $Is(d, Tclass._System.Tuple0()) ==> $IsAlloc(d, Tclass._System.Tuple0(), $h));

function $IsA#_System.Tuple0(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#_System.Tuple0(d) } $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

axiom (forall d: DatatypeType :: { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { _System.Tuple0#Equal(a, b) } _System.Tuple0#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { _System.Tuple0#Equal(a, b) } _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hFunc2: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2 && TagFamily(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == tytagFamily$_#Func2);

function Tclass._System.___hFunc2_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set;

axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, h: [Heap,Box,Box]Box, r: [Heap,Box,Box]bool, rd: [Heap,Box,Box]Set, bx0: Box, bx1: Box :: { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, h: [Heap,Box,Box]Box, r: [Heap,Box,Box]bool, rd: [Heap,Box,Box]Set, bx0: Box, bx1: Box :: { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, h: [Heap,Box,Box]Box, r: [Heap,Box,Box]bool, rd: [Heap,Box,Box]Set, bx0: Box, bx1: Box, bx: Box :: { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] <==> rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall o: ref, fld: Field :: o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall o: ref, fld: Field :: o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall o: ref, fld: Field :: o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires2(t0, t1, t2, h0, f, bx0, bx1) <==> Requires2(t0, t1, t2, h1, f, bx0, bx1)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall o: ref, fld: Field :: o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires2(t0, t1, t2, h0, f, bx0, bx1) <==> Requires2(t0, t1, t2, h1, f, bx0, bx1)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall o: ref, fld: Field :: o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall o: ref, fld: Field :: o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } { Reads2(t0, t1, t2, heap, f, bx0, bx1) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set) <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } { Requires2(t0, t1, t2, heap, f, bx0, bx1) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set) ==> (Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1) <==> Requires2(t0, t1, t2, heap, f, bx0, bx1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) <==> (forall h: Heap, bx0: Box, bx1: Box :: { Apply2(t0, t1, t2, h, f, bx0, bx1) } $IsGoodHeap(h) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && Requires2(t0, t1, t2, h, f, bx0, bx1) ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) && (forall bx: Box :: { $IsBox(bx, u0) } { $IsBox(bx, t0) } $IsBox(bx, u0) ==> $IsBox(bx, t0)) && (forall bx: Box :: { $IsBox(bx, u1) } { $IsBox(bx, t1) } $IsBox(bx, u1) ==> $IsBox(bx, t1)) && (forall bx: Box :: { $IsBox(bx, t2) } { $IsBox(bx, u2) } $IsBox(bx, t2) ==> $IsBox(bx, u2)) ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) <==> (forall bx0: Box, bx1: Box :: { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && $IsBox(bx1, t1) && $IsAllocBox(bx1, t1, h) && Requires2(t0, t1, t2, h, f, bx0, bx1) ==> (forall r: ref :: { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) ==> (forall bx0: Box, bx1: Box :: { Apply2(t0, t1, t2, h, f, bx0, bx1) } $IsAllocBox(bx0, t0, h) && $IsAllocBox(bx1, t1, h) && Requires2(t0, t1, t2, h, f, bx0, bx1) ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hPartialFunc2: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hPartialFunc2 && TagFamily(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) == tytagFamily$_#PartialFunc2);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) && (forall x0#0: Box, x1#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set)));

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hTotalFunc2: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hTotalFunc2 && TagFamily(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) == tytagFamily$_#TotalFunc2);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) && (forall x0#0: Box, x1#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hFunc3: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) == Tagclass._System.___hFunc3 && TagFamily(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) == tytagFamily$_#Func3);

function Tclass._System.___hFunc3_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) == #$T0);

function Tclass._System.___hFunc3_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) == #$T1);

function Tclass._System.___hFunc3_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) == #$T2);

function Tclass._System.___hFunc3_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set) : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set;

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, h: [Heap,Box,Box,Box]Box, r: [Heap,Box,Box,Box]bool, rd: [Heap,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box :: { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, h: [Heap,Box,Box,Box]Box, r: [Heap,Box,Box,Box]bool, rd: [Heap,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box :: { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } r[heap, bx0, bx1, bx2] ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, h: [Heap,Box,Box,Box]Box, r: [Heap,Box,Box,Box]bool, rd: [Heap,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx: Box :: { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] <==> rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box) : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box) : bool
{
  true
}

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall o: ref, fld: Field :: o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2) == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall o: ref, fld: Field :: o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2) == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall o: ref, fld: Field :: o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2) <==> Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall o: ref, fld: Field :: o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2) <==> Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall o: ref, fld: Field :: o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2) == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall o: ref, fld: Field :: o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2) == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set) <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box :: { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set) ==> (Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2) <==> Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } $IsGoodHeap(h) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) && (forall bx: Box :: { $IsBox(bx, u0) } { $IsBox(bx, t0) } $IsBox(bx, u0) ==> $IsBox(bx, t0)) && (forall bx: Box :: { $IsBox(bx, u1) } { $IsBox(bx, t1) } $IsBox(bx, u1) ==> $IsBox(bx, t1)) && (forall bx: Box :: { $IsBox(bx, u2) } { $IsBox(bx, t2) } $IsBox(bx, u2) ==> $IsBox(bx, t2)) && (forall bx: Box :: { $IsBox(bx, t3) } { $IsBox(bx, u3) } $IsBox(bx, t3) ==> $IsBox(bx, u3)) ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) <==> (forall bx0: Box, bx1: Box, bx2: Box :: { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && $IsBox(bx1, t1) && $IsAllocBox(bx1, t1, h) && $IsBox(bx2, t2) && $IsAllocBox(bx2, t2, h) && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) ==> (forall r: ref :: { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) ==> (forall bx0: Box, bx1: Box, bx2: Box :: { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } $IsAllocBox(bx0, t0, h) && $IsAllocBox(bx1, t1, h) && $IsAllocBox(bx2, t2, h) && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hPartialFunc3: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) == Tagclass._System.___hPartialFunc3 && TagFamily(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) == tytagFamily$_#PartialFunc3);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) == #$T0);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) == #$T1);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) == #$T2);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), Set#Empty(): Set)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hTotalFunc3: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) == Tagclass._System.___hTotalFunc3 && TagFamily(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) == tytagFamily$_#TotalFunc3);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) == #$T0);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) == #$T1);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) == #$T2);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function #_System._tuple#3._#Make3(Box, Box, Box) : DatatypeType;

const unique ##_System._tuple#3._#Make3: DtCtorId
uses {
axiom (forall a#12#0#0: Box, a#12#1#0: Box, a#12#2#0: Box :: { #_System._tuple#3._#Make3(a#12#0#0, a#12#1#0, a#12#2#0) } DatatypeCtorId(#_System._tuple#3._#Make3(a#12#0#0, a#12#1#0, a#12#2#0)) == ##_System._tuple#3._#Make3);
}

function _System.Tuple3.___hMake3_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { _System.Tuple3.___hMake3_q(d) } _System.Tuple3.___hMake3_q(d) <==> DatatypeCtorId(d) == ##_System._tuple#3._#Make3);

axiom (forall d: DatatypeType :: { _System.Tuple3.___hMake3_q(d) } _System.Tuple3.___hMake3_q(d) ==> (exists a#13#0#0: Box, a#13#1#0: Box, a#13#2#0: Box :: d == #_System._tuple#3._#Make3(a#13#0#0, a#13#1#0, a#13#2#0)));

function Tclass._System.Tuple3(Ty, Ty, Ty) : Ty;

const unique Tagclass._System.Tuple3: TyTag;

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty :: { Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2) } Tag(Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) == Tagclass._System.Tuple3 && TagFamily(Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) == tytagFamily$_tuple#3);

function Tclass._System.Tuple3_0(Ty) : Ty;

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty :: { Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2) } Tclass._System.Tuple3_0(Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) == _System._tuple#3$T0);

function Tclass._System.Tuple3_1(Ty) : Ty;

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty :: { Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2) } Tclass._System.Tuple3_1(Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) == _System._tuple#3$T1);

function Tclass._System.Tuple3_2(Ty) : Ty;

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty :: { Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2) } Tclass._System.Tuple3_2(Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) == _System._tuple#3$T2);

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty, bx: Box :: { $IsBox(bx, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) } $IsBox(bx, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)));

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty, a#14#0#0: Box, a#14#1#0: Box, a#14#2#0: Box :: { $Is(#_System._tuple#3._#Make3(a#14#0#0, a#14#1#0, a#14#2#0), Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) } $Is(#_System._tuple#3._#Make3(a#14#0#0, a#14#1#0, a#14#2#0), Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) <==> $IsBox(a#14#0#0, _System._tuple#3$T0) && $IsBox(a#14#1#0, _System._tuple#3$T1) && $IsBox(a#14#2#0, _System._tuple#3$T2));

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty, a#14#0#0: Box, a#14#1#0: Box, a#14#2#0: Box, $h: Heap :: { $IsAlloc(#_System._tuple#3._#Make3(a#14#0#0, a#14#1#0, a#14#2#0), Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#_System._tuple#3._#Make3(a#14#0#0, a#14#1#0, a#14#2#0), Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h) <==> $IsAllocBox(a#14#0#0, _System._tuple#3$T0, $h) && $IsAllocBox(a#14#1#0, _System._tuple#3$T1, $h) && $IsAllocBox(a#14#2#0, _System._tuple#3$T2, $h)));

axiom (forall d: DatatypeType, _System._tuple#3$T0: Ty, $h: Heap :: { $IsAllocBox(_System.Tuple3._0(d), _System._tuple#3$T0, $h) } $IsGoodHeap($h) && _System.Tuple3.___hMake3_q(d) && (exists _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty :: { $IsAlloc(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h) } $IsAlloc(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h)) ==> $IsAllocBox(_System.Tuple3._0(d), _System._tuple#3$T0, $h));

axiom (forall d: DatatypeType, _System._tuple#3$T1: Ty, $h: Heap :: { $IsAllocBox(_System.Tuple3._1(d), _System._tuple#3$T1, $h) } $IsGoodHeap($h) && _System.Tuple3.___hMake3_q(d) && (exists _System._tuple#3$T0: Ty, _System._tuple#3$T2: Ty :: { $IsAlloc(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h) } $IsAlloc(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h)) ==> $IsAllocBox(_System.Tuple3._1(d), _System._tuple#3$T1, $h));

axiom (forall d: DatatypeType, _System._tuple#3$T2: Ty, $h: Heap :: { $IsAllocBox(_System.Tuple3._2(d), _System._tuple#3$T2, $h) } $IsGoodHeap($h) && _System.Tuple3.___hMake3_q(d) && (exists _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty :: { $IsAlloc(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h) } $IsAlloc(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2), $h)) ==> $IsAllocBox(_System.Tuple3._2(d), _System._tuple#3$T2, $h));

axiom (forall a#15#0#0: Box, a#15#1#0: Box, a#15#2#0: Box :: { #_System._tuple#3._#Make3(Lit(a#15#0#0), Lit(a#15#1#0), Lit(a#15#2#0)) } #_System._tuple#3._#Make3(Lit(a#15#0#0), Lit(a#15#1#0), Lit(a#15#2#0)) == Lit(#_System._tuple#3._#Make3(a#15#0#0, a#15#1#0, a#15#2#0)));

function _System.Tuple3._0(DatatypeType) : Box;

axiom (forall a#16#0#0: Box, a#16#1#0: Box, a#16#2#0: Box :: { #_System._tuple#3._#Make3(a#16#0#0, a#16#1#0, a#16#2#0) } _System.Tuple3._0(#_System._tuple#3._#Make3(a#16#0#0, a#16#1#0, a#16#2#0)) == a#16#0#0);

axiom (forall a#17#0#0: Box, a#17#1#0: Box, a#17#2#0: Box :: { #_System._tuple#3._#Make3(a#17#0#0, a#17#1#0, a#17#2#0) } BoxRank(a#17#0#0) < DtRank(#_System._tuple#3._#Make3(a#17#0#0, a#17#1#0, a#17#2#0)));

function _System.Tuple3._1(DatatypeType) : Box;

axiom (forall a#18#0#0: Box, a#18#1#0: Box, a#18#2#0: Box :: { #_System._tuple#3._#Make3(a#18#0#0, a#18#1#0, a#18#2#0) } _System.Tuple3._1(#_System._tuple#3._#Make3(a#18#0#0, a#18#1#0, a#18#2#0)) == a#18#1#0);

axiom (forall a#19#0#0: Box, a#19#1#0: Box, a#19#2#0: Box :: { #_System._tuple#3._#Make3(a#19#0#0, a#19#1#0, a#19#2#0) } BoxRank(a#19#1#0) < DtRank(#_System._tuple#3._#Make3(a#19#0#0, a#19#1#0, a#19#2#0)));

function _System.Tuple3._2(DatatypeType) : Box;

axiom (forall a#20#0#0: Box, a#20#1#0: Box, a#20#2#0: Box :: { #_System._tuple#3._#Make3(a#20#0#0, a#20#1#0, a#20#2#0) } _System.Tuple3._2(#_System._tuple#3._#Make3(a#20#0#0, a#20#1#0, a#20#2#0)) == a#20#2#0);

axiom (forall a#21#0#0: Box, a#21#1#0: Box, a#21#2#0: Box :: { #_System._tuple#3._#Make3(a#21#0#0, a#21#1#0, a#21#2#0) } BoxRank(a#21#2#0) < DtRank(#_System._tuple#3._#Make3(a#21#0#0, a#21#1#0, a#21#2#0)));

function $IsA#_System.Tuple3(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#_System.Tuple3(d) } $IsA#_System.Tuple3(d) ==> _System.Tuple3.___hMake3_q(d));

axiom (forall _System._tuple#3$T0: Ty, _System._tuple#3$T1: Ty, _System._tuple#3$T2: Ty, d: DatatypeType :: { _System.Tuple3.___hMake3_q(d), $Is(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) } $Is(d, Tclass._System.Tuple3(_System._tuple#3$T0, _System._tuple#3$T1, _System._tuple#3$T2)) ==> _System.Tuple3.___hMake3_q(d));

function _System.Tuple3#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { _System.Tuple3#Equal(a, b) } _System.Tuple3#Equal(a, b) <==> _System.Tuple3._0(a) == _System.Tuple3._0(b) && _System.Tuple3._1(a) == _System.Tuple3._1(b) && _System.Tuple3._2(a) == _System.Tuple3._2(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { _System.Tuple3#Equal(a, b) } _System.Tuple3#Equal(a, b) <==> a == b);

const unique class._System.Tuple3: ClassName;

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hFunc4: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == Tagclass._System.___hFunc4 && TagFamily(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == tytagFamily$_#Func4);

function Tclass._System.___hFunc4_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T0);

function Tclass._System.___hFunc4_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T1);

function Tclass._System.___hFunc4_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T2);

function Tclass._System.___hFunc4_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T3);

function Tclass._System.___hFunc4_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, [Heap,Box,Box,Box,Box]bool, [Heap,Box,Box,Box,Box]Set) : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set;

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } r[heap, bx0, bx1, bx2, bx3] ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx: Box :: { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] <==> rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box) : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box) : bool
{
  true
}

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall o: ref, fld: Field :: o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3) == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall o: ref, fld: Field :: o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3) == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall o: ref, fld: Field :: o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3) <==> Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall o: ref, fld: Field :: o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3) <==> Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall o: ref, fld: Field :: o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3) == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall o: ref, fld: Field :: o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3) == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set) <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set) ==> (Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3) <==> Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } $IsGoodHeap(h) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty, u4: Ty :: { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) && (forall bx: Box :: { $IsBox(bx, u0) } { $IsBox(bx, t0) } $IsBox(bx, u0) ==> $IsBox(bx, t0)) && (forall bx: Box :: { $IsBox(bx, u1) } { $IsBox(bx, t1) } $IsBox(bx, u1) ==> $IsBox(bx, t1)) && (forall bx: Box :: { $IsBox(bx, u2) } { $IsBox(bx, t2) } $IsBox(bx, u2) ==> $IsBox(bx, t2)) && (forall bx: Box :: { $IsBox(bx, u3) } { $IsBox(bx, t3) } $IsBox(bx, u3) ==> $IsBox(bx, t3)) && (forall bx: Box :: { $IsBox(bx, t4) } { $IsBox(bx, u4) } $IsBox(bx, t4) ==> $IsBox(bx, u4)) ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && $IsBox(bx1, t1) && $IsAllocBox(bx1, t1, h) && $IsBox(bx2, t2) && $IsAllocBox(bx2, t2, h) && $IsBox(bx3, t3) && $IsAllocBox(bx3, t3, h) && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) ==> (forall r: ref :: { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } $IsAllocBox(bx0, t0, h) && $IsAllocBox(bx1, t1, h) && $IsAllocBox(bx2, t2, h) && $IsAllocBox(bx3, t3, h) && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hPartialFunc4: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == Tagclass._System.___hPartialFunc4 && TagFamily(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == tytagFamily$_#PartialFunc4);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T0);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T1);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T2);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T3);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) && $IsBox(x3#0, #$T3) ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), Set#Empty(): Set)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hTotalFunc4: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == Tagclass._System.___hTotalFunc4 && TagFamily(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == tytagFamily$_#TotalFunc4);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T0);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T1);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T2);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$T3);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) && $IsBox(x3#0, #$T3) ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hFunc5: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tag(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == Tagclass._System.___hFunc5 && TagFamily(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == tytagFamily$_#Func5);

function Tclass._System.___hFunc5_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hFunc5_0(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T0);

function Tclass._System.___hFunc5_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hFunc5_1(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T1);

function Tclass._System.___hFunc5_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hFunc5_2(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T2);

function Tclass._System.___hFunc5_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hFunc5_3(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T3);

function Tclass._System.___hFunc5_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hFunc5_4(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T4);

function Tclass._System.___hFunc5_5(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hFunc5_5(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

function Handle5([Heap,Box,Box,Box,Box,Box]Box, [Heap,Box,Box,Box,Box,Box]bool, [Heap,Box,Box,Box,Box,Box]Set) : HandleType;

function Apply5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Box;

function Requires5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : bool;

function Reads5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Set;

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) == h[heap, bx0, bx1, bx2, bx3, bx4]);

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } r[heap, bx0, bx1, bx2, bx3, bx4] ==> Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx: Box :: { Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx] } Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx] <==> rd[heap, bx0, bx1, bx2, bx3, bx4][bx]);

function {:inline} Requires5#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box) : bool
{
  true
}

function {:inline} Reads5#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box) : bool
{
  true
}

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall o: ref, fld: Field :: o != null && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4) == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall o: ref, fld: Field :: o != null && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4) == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall o: ref, fld: Field :: o != null && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4) <==> Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall o: ref, fld: Field :: o != null && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4) <==> Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall o: ref, fld: Field :: o != null && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4) == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall o: ref, fld: Field :: o != null && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4) == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } { Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) ==> (Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), Set#Empty(): Set) <==> Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4), Set#Empty(): Set)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } { Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), Set#Empty(): Set) ==> (Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4) <==> Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty :: { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) } $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } $IsGoodHeap(h) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) ==> $IsBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty, u4: Ty, u5: Ty :: { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)), $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)) } $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) && (forall bx: Box :: { $IsBox(bx, u0) } { $IsBox(bx, t0) } $IsBox(bx, u0) ==> $IsBox(bx, t0)) && (forall bx: Box :: { $IsBox(bx, u1) } { $IsBox(bx, t1) } $IsBox(bx, u1) ==> $IsBox(bx, t1)) && (forall bx: Box :: { $IsBox(bx, u2) } { $IsBox(bx, t2) } $IsBox(bx, u2) ==> $IsBox(bx, t2)) && (forall bx: Box :: { $IsBox(bx, u3) } { $IsBox(bx, t3) } $IsBox(bx, u3) ==> $IsBox(bx, t3)) && (forall bx: Box :: { $IsBox(bx, u4) } { $IsBox(bx, t4) } $IsBox(bx, u4) ==> $IsBox(bx, t4)) && (forall bx: Box :: { $IsBox(bx, t5) } { $IsBox(bx, u5) } $IsBox(bx, t5) ==> $IsBox(bx, u5)) ==> $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && $IsBox(bx1, t1) && $IsAllocBox(bx1, t1, h) && $IsBox(bx2, t2) && $IsAllocBox(bx2, t2, h) && $IsBox(bx3, t3) && $IsAllocBox(bx3, t3, h) && $IsBox(bx4, t4) && $IsAllocBox(bx4, t4, h) && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) ==> (forall r: ref :: { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)] } r != null && Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } $IsAllocBox(bx0, t0, h) && $IsAllocBox(bx1, t1, h) && $IsAllocBox(bx2, t2, h) && $IsAllocBox(bx3, t3, h) && $IsAllocBox(bx4, t4, h) && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) ==> $IsAllocBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5, h)));

function Tclass._System.___hPartialFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hPartialFunc5: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tag(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == Tagclass._System.___hPartialFunc5 && TagFamily(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == tytagFamily$_#PartialFunc5);

function Tclass._System.___hPartialFunc5_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hPartialFunc5_0(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T0);

function Tclass._System.___hPartialFunc5_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hPartialFunc5_1(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T1);

function Tclass._System.___hPartialFunc5_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hPartialFunc5_2(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T2);

function Tclass._System.___hPartialFunc5_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hPartialFunc5_3(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T3);

function Tclass._System.___hPartialFunc5_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hPartialFunc5_4(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T4);

function Tclass._System.___hPartialFunc5_5(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hPartialFunc5_5(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) <==> $Is(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) && $IsBox(x3#0, #$T3) && $IsBox(x4#0, #$T4) ==> Set#Equal(Reads5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0), Set#Empty(): Set)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hTotalFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hTotalFunc5: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tag(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == Tagclass._System.___hTotalFunc5 && TagFamily(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == tytagFamily$_#TotalFunc5);

function Tclass._System.___hTotalFunc5_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hTotalFunc5_0(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T0);

function Tclass._System.___hTotalFunc5_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hTotalFunc5_1(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T1);

function Tclass._System.___hTotalFunc5_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hTotalFunc5_2(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T2);

function Tclass._System.___hTotalFunc5_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hTotalFunc5_3(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T3);

function Tclass._System.___hTotalFunc5_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hTotalFunc5_4(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$T4);

function Tclass._System.___hTotalFunc5_5(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } Tclass._System.___hTotalFunc5_5(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) && $IsBox(x3#0, #$T3) && $IsBox(x4#0, #$T4) ==> Requires5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hFunc6: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tag(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == Tagclass._System.___hFunc6 && TagFamily(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == tytagFamily$_#Func6);

function Tclass._System.___hFunc6_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_0(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T0);

function Tclass._System.___hFunc6_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_1(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T1);

function Tclass._System.___hFunc6_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_2(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T2);

function Tclass._System.___hFunc6_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_3(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T3);

function Tclass._System.___hFunc6_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_4(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T4);

function Tclass._System.___hFunc6_5(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_5(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T5);

function Tclass._System.___hFunc6_6(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hFunc6_6(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

function Handle6([Heap,Box,Box,Box,Box,Box,Box]Box, [Heap,Box,Box,Box,Box,Box,Box]bool, [Heap,Box,Box,Box,Box,Box,Box]Set) : HandleType;

function Apply6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box) : Box;

function Requires6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box) : bool;

function Reads6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box) : Set;

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Apply6(t0, t1, t2, t3, t4, t5, t6, heap, Handle6(h, r, rd), bx0, bx1, bx2, bx3, bx4, bx5) } Apply6(t0, t1, t2, t3, t4, t5, t6, heap, Handle6(h, r, rd), bx0, bx1, bx2, bx3, bx4, bx5) == h[heap, bx0, bx1, bx2, bx3, bx4, bx5]);

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Requires6(t0, t1, t2, t3, t4, t5, t6, heap, Handle6(h, r, rd), bx0, bx1, bx2, bx3, bx4, bx5) } r[heap, bx0, bx1, bx2, bx3, bx4, bx5] ==> Requires6(t0, t1, t2, t3, t4, t5, t6, heap, Handle6(h, r, rd), bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, h: [Heap,Box,Box,Box,Box,Box,Box]Box, r: [Heap,Box,Box,Box,Box,Box,Box]bool, rd: [Heap,Box,Box,Box,Box,Box,Box]Set, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx: Box :: { Reads6(t0, t1, t2, t3, t4, t5, t6, heap, Handle6(h, r, rd), bx0, bx1, bx2, bx3, bx4, bx5)[bx] } Reads6(t0, t1, t2, t3, t4, t5, t6, heap, Handle6(h, r, rd), bx0, bx1, bx2, bx3, bx4, bx5)[bx] <==> rd[heap, bx0, bx1, bx2, bx3, bx4, bx5][bx]);

function {:inline} Requires6#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box) : bool
{
  true
}

function {:inline} Reads6#canCall(t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box) : bool
{
  true
}

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall o: ref, fld: Field :: o != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5) == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall o: ref, fld: Field :: o != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5) == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall o: ref, fld: Field :: o != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5) <==> Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall o: ref, fld: Field :: o != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> (Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5) <==> Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall o: ref, fld: Field :: o != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5) == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } $HeapSucc(h0, h1) && $IsGoodHeap(h0) && $IsGoodHeap(h1) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall o: ref, fld: Field :: o != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld)) ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5) == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } { Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) ==> (Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), Set#Empty(): Set) <==> Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5), Set#Empty(): Set)));

axiom (forall t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } { Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } $IsGoodHeap(heap) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), Set#Empty(): Set) ==> (Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5) <==> Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty :: { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) } $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } $IsGoodHeap(h) && $IsBox(bx0, t0) && $IsBox(bx1, t1) && $IsBox(bx2, t2) && $IsBox(bx3, t3) && $IsBox(bx4, t4) && $IsBox(bx5, t5) && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) ==> $IsBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty, u4: Ty, u5: Ty, u6: Ty :: { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)), $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)) } $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) && (forall bx: Box :: { $IsBox(bx, u0) } { $IsBox(bx, t0) } $IsBox(bx, u0) ==> $IsBox(bx, t0)) && (forall bx: Box :: { $IsBox(bx, u1) } { $IsBox(bx, t1) } $IsBox(bx, u1) ==> $IsBox(bx, t1)) && (forall bx: Box :: { $IsBox(bx, u2) } { $IsBox(bx, t2) } $IsBox(bx, u2) ==> $IsBox(bx, t2)) && (forall bx: Box :: { $IsBox(bx, u3) } { $IsBox(bx, t3) } $IsBox(bx, u3) ==> $IsBox(bx, t3)) && (forall bx: Box :: { $IsBox(bx, u4) } { $IsBox(bx, t4) } $IsBox(bx, u4) ==> $IsBox(bx, t4)) && (forall bx: Box :: { $IsBox(bx, u5) } { $IsBox(bx, t5) } $IsBox(bx, u5) ==> $IsBox(bx, t5)) && (forall bx: Box :: { $IsBox(bx, t6) } { $IsBox(bx, u6) } $IsBox(bx, t6) ==> $IsBox(bx, u6)) ==> $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } $IsGoodHeap(h) ==> ($IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && $IsBox(bx1, t1) && $IsAllocBox(bx1, t1, h) && $IsBox(bx2, t2) && $IsAllocBox(bx2, t2, h) && $IsBox(bx3, t3) && $IsAllocBox(bx3, t3, h) && $IsBox(bx4, t4) && $IsAllocBox(bx4, t4, h) && $IsBox(bx5, t5) && $IsAllocBox(bx5, t5, h) && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) ==> (forall r: ref :: { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)] } r != null && Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)] ==> $Unbox(read(h, r, alloc)): bool))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } $IsAllocBox(bx0, t0, h) && $IsAllocBox(bx1, t1, h) && $IsAllocBox(bx2, t2, h) && $IsAllocBox(bx3, t3, h) && $IsAllocBox(bx4, t4, h) && $IsAllocBox(bx5, t5, h) && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) ==> $IsAllocBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6, h)));

function Tclass._System.___hPartialFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hPartialFunc6: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tag(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == Tagclass._System.___hPartialFunc6 && TagFamily(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == tytagFamily$_#PartialFunc6);

function Tclass._System.___hPartialFunc6_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_0(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T0);

function Tclass._System.___hPartialFunc6_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_1(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T1);

function Tclass._System.___hPartialFunc6_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_2(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T2);

function Tclass._System.___hPartialFunc6_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_3(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T3);

function Tclass._System.___hPartialFunc6_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_4(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T4);

function Tclass._System.___hPartialFunc6_5(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_5(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T5);

function Tclass._System.___hPartialFunc6_6(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hPartialFunc6_6(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) <==> $Is(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) && $IsBox(x3#0, #$T3) && $IsBox(x4#0, #$T4) && $IsBox(x5#0, #$T5) ==> Set#Equal(Reads6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0, x5#0), Set#Empty(): Set)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h));

function Tclass._System.___hTotalFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass._System.___hTotalFunc6: TyTag;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tag(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == Tagclass._System.___hTotalFunc6 && TagFamily(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == tytagFamily$_#TotalFunc6);

function Tclass._System.___hTotalFunc6_0(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_0(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T0);

function Tclass._System.___hTotalFunc6_1(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_1(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T1);

function Tclass._System.___hTotalFunc6_2(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_2(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T2);

function Tclass._System.___hTotalFunc6_3(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_3(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T3);

function Tclass._System.___hTotalFunc6_4(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_4(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T4);

function Tclass._System.___hTotalFunc6_5(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_5(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$T5);

function Tclass._System.___hTotalFunc6_6(Ty) : Ty;

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } Tclass._System.___hTotalFunc6_6(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) == #$R);

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: { $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) ==> $Box($Unbox(bx): HandleType) == bx && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, f#0: HandleType :: { $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) <==> $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2) && $IsBox(x3#0, #$T3) && $IsBox(x4#0, #$T4) && $IsBox(x5#0, #$T5) ==> Requires6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0, x5#0)));

axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: { $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) } $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h));

const unique class.Wrappers.__default: ClassName;

function Wrappers.__default.Need(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0) || (1 < $FunctionContextHeight && $IsBox(error#0, Wrappers._default.Need$E)) ==> $Is(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0), Tclass.Wrappers.Outcome(Wrappers._default.Need$E)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { $IsAlloc(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0), Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap) } (Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0) || (1 < $FunctionContextHeight && $IsBox(error#0, Wrappers._default.Need$E) && $IsAllocBox(error#0, Wrappers._default.Need$E, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0), Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0) || (1 < $FunctionContextHeight && $IsBox(error#0, Wrappers._default.Need$E)) ==> Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0) == (if condition#0 then #Wrappers.Outcome.Pass() else #Wrappers.Outcome.Fail(error#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: {:weight 3} { Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), error#0) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, Lit(condition#0), error#0) || (1 < $FunctionContextHeight && $IsBox(error#0, Wrappers._default.Need$E)) ==> Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), error#0) == (if condition#0 then #Wrappers.Outcome.Pass() else #Wrappers.Outcome.Fail(error#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: {:weight 3} { Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), Lit(error#0)) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, Lit(condition#0), Lit(error#0)) || (1 < $FunctionContextHeight && $IsBox(error#0, Wrappers._default.Need$E)) ==> Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), Lit(error#0)) == (if condition#0 then #Wrappers.Outcome.Pass() else #Wrappers.Outcome.Fail(Lit(error#0))));
}

function Wrappers.__default.Need#canCall(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box) : bool;

function Tclass.Wrappers.Outcome(Ty) : Ty;

const unique Tagclass.Wrappers.Outcome: TyTag;

axiom (forall Wrappers.Outcome$E: Ty :: { Tclass.Wrappers.Outcome(Wrappers.Outcome$E) } Tag(Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) == Tagclass.Wrappers.Outcome && TagFamily(Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) == tytagFamily$Outcome);

function Tclass.Wrappers.Outcome_0(Ty) : Ty;

axiom (forall Wrappers.Outcome$E: Ty :: { Tclass.Wrappers.Outcome(Wrappers.Outcome$E) } Tclass.Wrappers.Outcome_0(Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) == Wrappers.Outcome$E);

axiom (forall Wrappers.Outcome$E: Ty, bx: Box :: { $IsBox(bx, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) } $IsBox(bx, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)));

function Wrappers.__default.Need#requires(Ty, bool, Box) : bool;

axiom (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { Wrappers.__default.Need#requires(Wrappers._default.Need$E, condition#0, error#0) } $IsBox(error#0, Wrappers._default.Need$E) ==> (Wrappers.__default.Need#requires(Wrappers._default.Need$E, condition#0, error#0) <==> true));

procedure {:verboseName "Wrappers.Need (well-formedness)"} {:testInline} CheckWellformed$$Wrappers.__default.Need(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box where $IsBox(error#0, Wrappers._default.Need$E)) returns (result#0: DatatypeType where $Is(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Wrappers.Need (correctness)"} {:testInline} Impl$$Wrappers.__default.Need(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box where $IsBox(error#0, Wrappers._default.Need$E) && $IsAllocBox(error#0, Wrappers._default.Need$E, $Heap)) returns (defass#result#0: bool, result#0: DatatypeType where defass#result#0 ==> $Is(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E)) && $IsAlloc(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Outcome(result#0) && $IsA#Wrappers.Outcome(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0)) && Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0);
  free ensures {:id "id3"} Wrappers.Outcome#Equal(result#0, Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Wrappers.Need (well-formedness)"} {:testInline} CheckWellFormed$$Wrappers.__default.Need(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box where $IsBox(error#0, Wrappers._default.Need$E) && $IsAllocBox(error#0, Wrappers._default.Need$E, $Heap)) returns (result#0: DatatypeType where $Is(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E)) && $IsAlloc(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Wrappers.Need (call precondtion)"} {:testInline} CallPre$$Wrappers.__default.Need(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box where $IsBox(error#0, Wrappers._default.Need$E) && $IsAllocBox(error#0, Wrappers._default.Need$E, $Heap));



procedure {:verboseName "Wrappers.Need (call postcondition)"} {:testInline} CallPost$$Wrappers.__default.Need(Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box where $IsBox(error#0, Wrappers._default.Need$E) && $IsAllocBox(error#0, Wrappers._default.Need$E, $Heap)) returns (result#0: DatatypeType where $Is(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E)) && $IsAlloc(result#0, Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Outcome(result#0) && $IsA#Wrappers.Outcome(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0)) && Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0);
  free ensures {:id "id12"} Wrappers.Outcome#Equal(result#0, Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function #Wrappers.Option.None() : DatatypeType
uses {
axiom DatatypeCtorId(#Wrappers.Option.None()) == ##Wrappers.Option.None;
axiom #Wrappers.Option.None() == Lit(#Wrappers.Option.None());
}

const unique ##Wrappers.Option.None: DtCtorId
uses {
axiom DatatypeCtorId(#Wrappers.Option.None()) == ##Wrappers.Option.None;
}

function Wrappers.Option.None_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Wrappers.Option.None_q(d) } Wrappers.Option.None_q(d) <==> DatatypeCtorId(d) == ##Wrappers.Option.None);

axiom (forall d: DatatypeType :: { Wrappers.Option.None_q(d) } Wrappers.Option.None_q(d) ==> d == #Wrappers.Option.None());

function Tclass.Wrappers.Option(Ty) : Ty;

const unique Tagclass.Wrappers.Option: TyTag;

axiom (forall Wrappers.Option$T: Ty :: { Tclass.Wrappers.Option(Wrappers.Option$T) } Tag(Tclass.Wrappers.Option(Wrappers.Option$T)) == Tagclass.Wrappers.Option && TagFamily(Tclass.Wrappers.Option(Wrappers.Option$T)) == tytagFamily$Option);

function Tclass.Wrappers.Option_0(Ty) : Ty;

axiom (forall Wrappers.Option$T: Ty :: { Tclass.Wrappers.Option(Wrappers.Option$T) } Tclass.Wrappers.Option_0(Tclass.Wrappers.Option(Wrappers.Option$T)) == Wrappers.Option$T);

axiom (forall Wrappers.Option$T: Ty, bx: Box :: { $IsBox(bx, Tclass.Wrappers.Option(Wrappers.Option$T)) } $IsBox(bx, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.Wrappers.Option(Wrappers.Option$T)));

axiom (forall Wrappers.Option$T: Ty :: { $Is(#Wrappers.Option.None(), Tclass.Wrappers.Option(Wrappers.Option$T)) } $Is(#Wrappers.Option.None(), Tclass.Wrappers.Option(Wrappers.Option$T)));

axiom (forall Wrappers.Option$T: Ty, $h: Heap :: { $IsAlloc(#Wrappers.Option.None(), Tclass.Wrappers.Option(Wrappers.Option$T), $h) } $IsGoodHeap($h) ==> $IsAlloc(#Wrappers.Option.None(), Tclass.Wrappers.Option(Wrappers.Option$T), $h));

function #Wrappers.Option.Some(Box) : DatatypeType;

const unique ##Wrappers.Option.Some: DtCtorId
uses {
axiom (forall a#4#0#0: Box :: { #Wrappers.Option.Some(a#4#0#0) } DatatypeCtorId(#Wrappers.Option.Some(a#4#0#0)) == ##Wrappers.Option.Some);
}

function Wrappers.Option.Some_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Wrappers.Option.Some_q(d) } Wrappers.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Wrappers.Option.Some);

axiom (forall d: DatatypeType :: { Wrappers.Option.Some_q(d) } Wrappers.Option.Some_q(d) ==> (exists a#5#0#0: Box :: d == #Wrappers.Option.Some(a#5#0#0)));

axiom (forall Wrappers.Option$T: Ty, a#6#0#0: Box :: { $Is(#Wrappers.Option.Some(a#6#0#0), Tclass.Wrappers.Option(Wrappers.Option$T)) } $Is(#Wrappers.Option.Some(a#6#0#0), Tclass.Wrappers.Option(Wrappers.Option$T)) <==> $IsBox(a#6#0#0, Wrappers.Option$T));

axiom (forall Wrappers.Option$T: Ty, a#6#0#0: Box, $h: Heap :: { $IsAlloc(#Wrappers.Option.Some(a#6#0#0), Tclass.Wrappers.Option(Wrappers.Option$T), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#Wrappers.Option.Some(a#6#0#0), Tclass.Wrappers.Option(Wrappers.Option$T), $h) <==> $IsAllocBox(a#6#0#0, Wrappers.Option$T, $h)));

axiom (forall d: DatatypeType, Wrappers.Option$T: Ty, $h: Heap :: { $IsAllocBox(Wrappers.Option.value(d), Wrappers.Option$T, $h) } $IsGoodHeap($h) && Wrappers.Option.Some_q(d) && $IsAlloc(d, Tclass.Wrappers.Option(Wrappers.Option$T), $h) ==> $IsAllocBox(Wrappers.Option.value(d), Wrappers.Option$T, $h));

axiom (forall a#7#0#0: Box :: { #Wrappers.Option.Some(Lit(a#7#0#0)) } #Wrappers.Option.Some(Lit(a#7#0#0)) == Lit(#Wrappers.Option.Some(a#7#0#0)));

function Wrappers.Option.value(DatatypeType) : Box;

axiom (forall a#8#0#0: Box :: { #Wrappers.Option.Some(a#8#0#0) } Wrappers.Option.value(#Wrappers.Option.Some(a#8#0#0)) == a#8#0#0);

axiom (forall a#9#0#0: Box :: { #Wrappers.Option.Some(a#9#0#0) } BoxRank(a#9#0#0) < DtRank(#Wrappers.Option.Some(a#9#0#0)));

function $IsA#Wrappers.Option(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#Wrappers.Option(d) } $IsA#Wrappers.Option(d) ==> Wrappers.Option.None_q(d) || Wrappers.Option.Some_q(d));

axiom (forall Wrappers.Option$T: Ty, d: DatatypeType :: { Wrappers.Option.Some_q(d), $Is(d, Tclass.Wrappers.Option(Wrappers.Option$T)) } { Wrappers.Option.None_q(d), $Is(d, Tclass.Wrappers.Option(Wrappers.Option$T)) } $Is(d, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.None_q(d) || Wrappers.Option.Some_q(d));

function Wrappers.Option#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Option#Equal(a, b), Wrappers.Option.None_q(a) } { Wrappers.Option#Equal(a, b), Wrappers.Option.None_q(b) } Wrappers.Option.None_q(a) && Wrappers.Option.None_q(b) ==> Wrappers.Option#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Option#Equal(a, b), Wrappers.Option.Some_q(a) } { Wrappers.Option#Equal(a, b), Wrappers.Option.Some_q(b) } Wrappers.Option.Some_q(a) && Wrappers.Option.Some_q(b) ==> (Wrappers.Option#Equal(a, b) <==> Wrappers.Option.value(a) == Wrappers.Option.value(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Option#Equal(a, b) } Wrappers.Option#Equal(a, b) <==> a == b);

const unique class.Wrappers.Option: ClassName;

function Wrappers.Option.ToResult(Wrappers.Option$T: Ty, this: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T))) ==> $Is(Wrappers.Option.ToResult(Wrappers.Option$T, this), Tclass.Wrappers.Result(Wrappers.Option$T, TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Option$T: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Option.ToResult(Wrappers.Option$T, this), Tclass.Wrappers.Result(Wrappers.Option$T, TSeq(TChar)), $Heap) } (Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Option.ToResult(Wrappers.Option$T, this), Tclass.Wrappers.Result(Wrappers.Option$T, TSeq(TChar)), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T))) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#0 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#0))));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T))) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#2 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#2)))));
}

function Wrappers.Option.ToResult#canCall(Wrappers.Option$T: Ty, this: DatatypeType) : bool;

function Tclass.Wrappers.Result(Ty, Ty) : Ty;

const unique Tagclass.Wrappers.Result: TyTag;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty :: { Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R) } Tag(Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) == Tagclass.Wrappers.Result && TagFamily(Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) == tytagFamily$Result);

function Tclass.Wrappers.Result_0(Ty) : Ty;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty :: { Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R) } Tclass.Wrappers.Result_0(Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) == Wrappers.Result$T);

function Tclass.Wrappers.Result_1(Ty) : Ty;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty :: { Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R) } Tclass.Wrappers.Result_1(Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) == Wrappers.Result$R);

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, bx: Box :: { $IsBox(bx, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) } $IsBox(bx, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)));

function Wrappers.Option.ToResult#requires(Ty, DatatypeType) : bool;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult#requires(Wrappers.Option$T, this) } $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> (Wrappers.Option.ToResult#requires(Wrappers.Option$T, this) <==> true));

procedure {:verboseName "Wrappers.Option.ToResult (well-formedness)"} CheckWellformed$$Wrappers.Option.ToResult(Wrappers.Option$T: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Option.ToResult_k(Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> $Is(Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0), Tclass.Wrappers.Result(Wrappers.Option$T, Wrappers.Option.ToResult'$R)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { $IsAlloc(Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0), Tclass.Wrappers.Result(Wrappers.Option$T, Wrappers.Option.ToResult'$R), $Heap) } (Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && $IsBox(error#0, Wrappers.Option.ToResult'$R) && $IsAllocBox(error#0, Wrappers.Option.ToResult'$R, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0), Tclass.Wrappers.Result(Wrappers.Option$T, Wrappers.Option.ToResult'$R), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#0 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#0))));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#2 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#2)))));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#4 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#4)))));
}

function Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box) : bool;

function Wrappers.Option.ToResult_k#requires(Ty, Ty, DatatypeType, Box) : bool;

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k#requires(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R) ==> (Wrappers.Option.ToResult_k#requires(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) <==> true));

procedure {:verboseName "Wrappers.Option.ToResult' (well-formedness)"} CheckWellformed$$Wrappers.Option.ToResult_k(Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap), error#0: Box where $IsBox(error#0, Wrappers.Option.ToResult'$R));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Option.UnwrapOr(Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> $IsBox(Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0), Wrappers.Option$T));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { $IsAllocBox(Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0), Wrappers.Option$T, $Heap) } (Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || (0 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && $IsBox(default#0, Wrappers.Option$T) && $IsAllocBox(default#0, Wrappers.Option$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0), Wrappers.Option$T, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#0 := Wrappers.Option.value(this); v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#2 := Lit(Wrappers.Option.value(Lit(this))); v#2)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#4 := Lit(Wrappers.Option.value(Lit(this))); v#4)));
}

function Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box) : bool;

function Wrappers.Option.UnwrapOr#requires(Ty, DatatypeType, Box) : bool;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr#requires(Wrappers.Option$T, this, default#0) } $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T) ==> (Wrappers.Option.UnwrapOr#requires(Wrappers.Option$T, this, default#0) <==> true));

procedure {:verboseName "Wrappers.Option.UnwrapOr (well-formedness)"} CheckWellformed$$Wrappers.Option.UnwrapOr(Wrappers.Option$T: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap), default#0: Box where $IsBox(default#0, Wrappers.Option$T));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Option.IsFailure(Wrappers.Option$T: Ty, this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.IsFailure(Wrappers.Option$T, this) } Wrappers.Option.IsFailure#canCall(Wrappers.Option$T, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T))) ==> (Wrappers.Option.IsFailure(Wrappers.Option$T, this) <==> Wrappers.Option.None_q(this)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.IsFailure(Wrappers.Option$T, Lit(this)) } Wrappers.Option.IsFailure#canCall(Wrappers.Option$T, Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T))) ==> (Wrappers.Option.IsFailure(Wrappers.Option$T, Lit(this)) <==> Lit(Wrappers.Option.None_q(Lit(this)))));
}

function Wrappers.Option.IsFailure#canCall(Wrappers.Option$T: Ty, this: DatatypeType) : bool;

function Wrappers.Option.IsFailure#requires(Ty, DatatypeType) : bool;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.IsFailure#requires(Wrappers.Option$T, this) } $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> (Wrappers.Option.IsFailure#requires(Wrappers.Option$T, this) <==> true));

procedure {:verboseName "Wrappers.Option.IsFailure (well-formedness)"} CheckWellformed$$Wrappers.Option.IsFailure(Wrappers.Option$T: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Option.PropagateFailure(Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) } Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.None_q(this)) ==> $Is(Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this), Tclass.Wrappers.Option(Wrappers.Option.PropagateFailure$U)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this), Tclass.Wrappers.Option(Wrappers.Option.PropagateFailure$U), $Heap) } (Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && Wrappers.Option.None_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this), Tclass.Wrappers.Option(Wrappers.Option.PropagateFailure$U), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) } Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.None_q(this)) ==> Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) == Lit(#Wrappers.Option.None()));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, Lit(this)) } Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Lit(Wrappers.Option.None_q(Lit(this)))) ==> Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, Lit(this)) == Lit(#Wrappers.Option.None()));
}

function Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType) : bool;

function Wrappers.Option.PropagateFailure#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Option.PropagateFailure#requires(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) } $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> (Wrappers.Option.PropagateFailure#requires(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) <==> Wrappers.Option.None_q(this)));

procedure {:verboseName "Wrappers.Option.PropagateFailure (well-formedness)"} CheckWellformed$$Wrappers.Option.PropagateFailure(Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Option.Extract(Wrappers.Option$T: Ty, this: DatatypeType) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.Extract(Wrappers.Option$T, this) } Wrappers.Option.Extract#canCall(Wrappers.Option$T, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.Some_q(this)) ==> $IsBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Option$T: Ty, this: DatatypeType :: { $IsAllocBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T, $Heap) } (Wrappers.Option.Extract#canCall(Wrappers.Option$T, this) || (0 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && Wrappers.Option.Some_q(this))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.Extract(Wrappers.Option$T, this) } Wrappers.Option.Extract#canCall(Wrappers.Option$T, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.Some_q(this)) ==> Wrappers.Option.Extract(Wrappers.Option$T, this) == Wrappers.Option.value(this));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.Extract(Wrappers.Option$T, Lit(this)) } Wrappers.Option.Extract#canCall(Wrappers.Option$T, Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Lit(Wrappers.Option.Some_q(Lit(this)))) ==> Wrappers.Option.Extract(Wrappers.Option$T, Lit(this)) == Lit(Wrappers.Option.value(Lit(this))));
}

function Wrappers.Option.Extract#canCall(Wrappers.Option$T: Ty, this: DatatypeType) : bool;

function Wrappers.Option.Extract#requires(Ty, DatatypeType) : bool;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.Extract#requires(Wrappers.Option$T, this) } $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> (Wrappers.Option.Extract#requires(Wrappers.Option$T, this) <==> Wrappers.Option.Some_q(this)));

procedure {:verboseName "Wrappers.Option.Extract (well-formedness)"} CheckWellformed$$Wrappers.Option.Extract(Wrappers.Option$T: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Wrappers.Option.Extract (well-formedness)"} CheckWellformed$$Wrappers.Option.Extract(Wrappers.Option$T: Ty, this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Wrappers.Option.Extract", " | ", Wrappers.Option$T, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/Wrappers.dfy(39,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Wrappers.Option.Some_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T);
    assume false;
    return;

  anon4_Else:
    assume Wrappers.Option.Some_q(this);
    assume Wrappers.Option.Extract(Wrappers.Option$T, this) == Wrappers.Option.value(this);
    assume true;
    assume $IsBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T);
    return;
}



function #Wrappers.Result.Success(Box) : DatatypeType;

const unique ##Wrappers.Result.Success: DtCtorId
uses {
axiom (forall a#0#0#0: Box :: { #Wrappers.Result.Success(a#0#0#0) } DatatypeCtorId(#Wrappers.Result.Success(a#0#0#0)) == ##Wrappers.Result.Success);
}

function Wrappers.Result.Success_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Wrappers.Result.Success_q(d) } Wrappers.Result.Success_q(d) <==> DatatypeCtorId(d) == ##Wrappers.Result.Success);

axiom (forall d: DatatypeType :: { Wrappers.Result.Success_q(d) } Wrappers.Result.Success_q(d) ==> (exists a#1#0#0: Box :: d == #Wrappers.Result.Success(a#1#0#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, a#2#0#0: Box :: { $Is(#Wrappers.Result.Success(a#2#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) } $Is(#Wrappers.Result.Success(a#2#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) <==> $IsBox(a#2#0#0, Wrappers.Result$T));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, a#2#0#0: Box, $h: Heap :: { $IsAlloc(#Wrappers.Result.Success(a#2#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#Wrappers.Result.Success(a#2#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h) <==> $IsAllocBox(a#2#0#0, Wrappers.Result$T, $h)));

axiom (forall d: DatatypeType, Wrappers.Result$T: Ty, $h: Heap :: { $IsAllocBox(Wrappers.Result.value(d), Wrappers.Result$T, $h) } $IsGoodHeap($h) && Wrappers.Result.Success_q(d) && (exists Wrappers.Result$R: Ty :: { $IsAlloc(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h) } $IsAlloc(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h)) ==> $IsAllocBox(Wrappers.Result.value(d), Wrappers.Result$T, $h));

axiom (forall a#3#0#0: Box :: { #Wrappers.Result.Success(Lit(a#3#0#0)) } #Wrappers.Result.Success(Lit(a#3#0#0)) == Lit(#Wrappers.Result.Success(a#3#0#0)));

function Wrappers.Result.value(DatatypeType) : Box;

axiom (forall a#4#0#0: Box :: { #Wrappers.Result.Success(a#4#0#0) } Wrappers.Result.value(#Wrappers.Result.Success(a#4#0#0)) == a#4#0#0);

axiom (forall a#5#0#0: Box :: { #Wrappers.Result.Success(a#5#0#0) } BoxRank(a#5#0#0) < DtRank(#Wrappers.Result.Success(a#5#0#0)));

function #Wrappers.Result.Failure(Box) : DatatypeType;

const unique ##Wrappers.Result.Failure: DtCtorId
uses {
axiom (forall a#6#0#0: Box :: { #Wrappers.Result.Failure(a#6#0#0) } DatatypeCtorId(#Wrappers.Result.Failure(a#6#0#0)) == ##Wrappers.Result.Failure);
}

function Wrappers.Result.Failure_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Wrappers.Result.Failure_q(d) } Wrappers.Result.Failure_q(d) <==> DatatypeCtorId(d) == ##Wrappers.Result.Failure);

axiom (forall d: DatatypeType :: { Wrappers.Result.Failure_q(d) } Wrappers.Result.Failure_q(d) ==> (exists a#7#0#0: Box :: d == #Wrappers.Result.Failure(a#7#0#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, a#8#0#0: Box :: { $Is(#Wrappers.Result.Failure(a#8#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) } $Is(#Wrappers.Result.Failure(a#8#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) <==> $IsBox(a#8#0#0, Wrappers.Result$R));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, a#8#0#0: Box, $h: Heap :: { $IsAlloc(#Wrappers.Result.Failure(a#8#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#Wrappers.Result.Failure(a#8#0#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h) <==> $IsAllocBox(a#8#0#0, Wrappers.Result$R, $h)));

axiom (forall d: DatatypeType, Wrappers.Result$R: Ty, $h: Heap :: { $IsAllocBox(Wrappers.Result.error(d), Wrappers.Result$R, $h) } $IsGoodHeap($h) && Wrappers.Result.Failure_q(d) && (exists Wrappers.Result$T: Ty :: { $IsAlloc(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h) } $IsAlloc(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $h)) ==> $IsAllocBox(Wrappers.Result.error(d), Wrappers.Result$R, $h));

axiom (forall a#9#0#0: Box :: { #Wrappers.Result.Failure(Lit(a#9#0#0)) } #Wrappers.Result.Failure(Lit(a#9#0#0)) == Lit(#Wrappers.Result.Failure(a#9#0#0)));

function Wrappers.Result.error(DatatypeType) : Box;

axiom (forall a#10#0#0: Box :: { #Wrappers.Result.Failure(a#10#0#0) } Wrappers.Result.error(#Wrappers.Result.Failure(a#10#0#0)) == a#10#0#0);

axiom (forall a#11#0#0: Box :: { #Wrappers.Result.Failure(a#11#0#0) } BoxRank(a#11#0#0) < DtRank(#Wrappers.Result.Failure(a#11#0#0)));

function $IsA#Wrappers.Result(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#Wrappers.Result(d) } $IsA#Wrappers.Result(d) ==> Wrappers.Result.Success_q(d) || Wrappers.Result.Failure_q(d));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, d: DatatypeType :: { Wrappers.Result.Failure_q(d), $Is(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) } { Wrappers.Result.Success_q(d), $Is(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) } $Is(d, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.Success_q(d) || Wrappers.Result.Failure_q(d));

function Wrappers.Result#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Result#Equal(a, b), Wrappers.Result.Success_q(a) } { Wrappers.Result#Equal(a, b), Wrappers.Result.Success_q(b) } Wrappers.Result.Success_q(a) && Wrappers.Result.Success_q(b) ==> (Wrappers.Result#Equal(a, b) <==> Wrappers.Result.value(a) == Wrappers.Result.value(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Result#Equal(a, b), Wrappers.Result.Failure_q(a) } { Wrappers.Result#Equal(a, b), Wrappers.Result.Failure_q(b) } Wrappers.Result.Failure_q(a) && Wrappers.Result.Failure_q(b) ==> (Wrappers.Result#Equal(a, b) <==> Wrappers.Result.error(a) == Wrappers.Result.error(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Result#Equal(a, b) } Wrappers.Result#Equal(a, b) <==> a == b);

const unique class.Wrappers.Result: ClassName;

function Wrappers.Result.ToOption(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R))) ==> $Is(Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this), Tclass.Wrappers.Option(Wrappers.Result$T)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this), Tclass.Wrappers.Option(Wrappers.Result$T), $Heap) } (Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this), Tclass.Wrappers.Option(Wrappers.Result$T), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R))) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#0 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#0)) else (var e#0 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R))) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#2 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#2))) else (var e#2 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));
}

function Wrappers.Result.ToOption#canCall(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType) : bool;

function Wrappers.Result.ToOption#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption#requires(Wrappers.Result$T, Wrappers.Result$R, this) } $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> (Wrappers.Result.ToOption#requires(Wrappers.Result$T, Wrappers.Result$R, this) <==> true));

procedure {:verboseName "Wrappers.Result.ToOption (well-formedness)"} CheckWellformed$$Wrappers.Result.ToOption(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Result.UnwrapOr(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> $IsBox(Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0), Wrappers.Result$T));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { $IsAllocBox(Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0), Wrappers.Result$T, $Heap) } (Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || (0 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $IsBox(default#0, Wrappers.Result$T) && $IsAllocBox(default#0, Wrappers.Result$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0), Wrappers.Result$T, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#0 := Wrappers.Result.value(this); s#0) else (var e#0 := Wrappers.Result.error(this); default#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#2 := Lit(Wrappers.Result.value(Lit(this))); s#2) else (var e#2 := Lit(Wrappers.Result.error(Lit(this))); default#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#4 := Lit(Wrappers.Result.value(Lit(this))); s#4) else (var e#4 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));
}

function Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box) : bool;

function Wrappers.Result.UnwrapOr#requires(Ty, Ty, DatatypeType, Box) : bool;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr#requires(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T) ==> (Wrappers.Result.UnwrapOr#requires(Wrappers.Result$T, Wrappers.Result$R, this, default#0) <==> true));

procedure {:verboseName "Wrappers.Result.UnwrapOr (well-formedness)"} CheckWellformed$$Wrappers.Result.UnwrapOr(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap), default#0: Box where $IsBox(default#0, Wrappers.Result$T));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Result.IsFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.IsFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R))) ==> (Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, this) <==> Wrappers.Result.Failure_q(this)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.IsFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R))) ==> (Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) <==> Lit(Wrappers.Result.Failure_q(Lit(this)))));
}

function Wrappers.Result.IsFailure#canCall(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType) : bool;

function Wrappers.Result.IsFailure#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.IsFailure#requires(Wrappers.Result$T, Wrappers.Result$R, this) } $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> (Wrappers.Result.IsFailure#requires(Wrappers.Result$T, Wrappers.Result$R, this) <==> true));

procedure {:verboseName "Wrappers.Result.IsFailure (well-formedness)"} CheckWellformed$$Wrappers.Result.IsFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Result.PropagateFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) } Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Failure_q(this)) ==> $Is(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R), $Heap) } (Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && Wrappers.Result.Failure_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) } Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Failure_q(this)) ==> Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) == #Wrappers.Result.Failure(Wrappers.Result.error(this)));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, Lit(this)) } Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Lit(Wrappers.Result.Failure_q(Lit(this)))) ==> Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, Lit(this)) == Lit(#Wrappers.Result.Failure(Lit(Wrappers.Result.error(Lit(this))))));
}

function Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType) : bool;

function Wrappers.Result.PropagateFailure#requires(Ty, Ty, Ty, DatatypeType) : bool;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Result.PropagateFailure#requires(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) } $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> (Wrappers.Result.PropagateFailure#requires(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) <==> Wrappers.Result.Failure_q(this)));

procedure {:verboseName "Wrappers.Result.PropagateFailure (well-formedness)"} CheckWellformed$$Wrappers.Result.PropagateFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Wrappers.Result.PropagateFailure (well-formedness)"} CheckWellformed$$Wrappers.Result.PropagateFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Wrappers.Result.PropagateFailure", " | ", Wrappers.Result$T, " | ", Wrappers.Result$R, " | ", Wrappers.Result.PropagateFailure$U, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/Wrappers.dfy(65,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Wrappers.Result.Failure_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R));
    assume false;
    return;

  anon4_Else:
    assume Wrappers.Result.Failure_q(this);
    assume Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) == #Wrappers.Result.Failure(Wrappers.Result.error(this));
    assume true;
    assume $Is(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R));
    return;
}



function Wrappers.Result.MapFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType, reWrap#0: HandleType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> $Is(Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result.MapFailure$NewR)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType, reWrap#0: HandleType :: { $IsAlloc(Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result.MapFailure$NewR), $Heap) } (Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR)) && $IsAlloc(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result.MapFailure$NewR), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#0 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#0)) else (var e#0 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#0)))));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#2 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#2))) else (var e#2 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#2)))));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#4 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#4))) else (var e#4 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#4)))));
}

function Wrappers.Result.MapFailure#canCall(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType, reWrap#0: HandleType) : bool;

function Wrappers.Result.MapFailure#requires(Ty, Ty, Ty, DatatypeType, HandleType) : bool;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure#requires(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR)) ==> (Wrappers.Result.MapFailure#requires(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) <==> true));

procedure {:verboseName "Wrappers.Result.MapFailure (well-formedness)"} CheckWellformed$$Wrappers.Result.MapFailure(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap), reWrap#0: HandleType where $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Result.Extract(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Success_q(this)) ==> $IsBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { $IsAllocBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T, $Heap) } (Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (0 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && Wrappers.Result.Success_q(this))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Success_q(this)) ==> Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) == Wrappers.Result.value(this));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Lit(Wrappers.Result.Success_q(Lit(this)))) ==> Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == Lit(Wrappers.Result.value(Lit(this))));
}

function Wrappers.Result.Extract#canCall(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType) : bool;

function Wrappers.Result.Extract#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.Extract#requires(Wrappers.Result$T, Wrappers.Result$R, this) } $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> (Wrappers.Result.Extract#requires(Wrappers.Result$T, Wrappers.Result$R, this) <==> Wrappers.Result.Success_q(this)));

procedure {:verboseName "Wrappers.Result.Extract (well-formedness)"} CheckWellformed$$Wrappers.Result.Extract(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Wrappers.Result.Extract (well-formedness)"} CheckWellformed$$Wrappers.Result.Extract(Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Wrappers.Result.Extract", " | ", Wrappers.Result$T, " | ", Wrappers.Result$R, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/Wrappers.dfy(78,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Wrappers.Result.Success_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T);
    assume false;
    return;

  anon4_Else:
    assume Wrappers.Result.Success_q(this);
    assume Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) == Wrappers.Result.value(this);
    assume true;
    assume $IsBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T);
    return;
}



function #Wrappers.Outcome.Pass() : DatatypeType
uses {
axiom DatatypeCtorId(#Wrappers.Outcome.Pass()) == ##Wrappers.Outcome.Pass;
axiom #Wrappers.Outcome.Pass() == Lit(#Wrappers.Outcome.Pass());
}

const unique ##Wrappers.Outcome.Pass: DtCtorId
uses {
axiom DatatypeCtorId(#Wrappers.Outcome.Pass()) == ##Wrappers.Outcome.Pass;
}

function Wrappers.Outcome.Pass_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Wrappers.Outcome.Pass_q(d) } Wrappers.Outcome.Pass_q(d) <==> DatatypeCtorId(d) == ##Wrappers.Outcome.Pass);

axiom (forall d: DatatypeType :: { Wrappers.Outcome.Pass_q(d) } Wrappers.Outcome.Pass_q(d) ==> d == #Wrappers.Outcome.Pass());

axiom (forall Wrappers.Outcome$E: Ty :: { $Is(#Wrappers.Outcome.Pass(), Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) } $Is(#Wrappers.Outcome.Pass(), Tclass.Wrappers.Outcome(Wrappers.Outcome$E)));

axiom (forall Wrappers.Outcome$E: Ty, $h: Heap :: { $IsAlloc(#Wrappers.Outcome.Pass(), Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $h) } $IsGoodHeap($h) ==> $IsAlloc(#Wrappers.Outcome.Pass(), Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $h));

function #Wrappers.Outcome.Fail(Box) : DatatypeType;

const unique ##Wrappers.Outcome.Fail: DtCtorId
uses {
axiom (forall a#4#0#0: Box :: { #Wrappers.Outcome.Fail(a#4#0#0) } DatatypeCtorId(#Wrappers.Outcome.Fail(a#4#0#0)) == ##Wrappers.Outcome.Fail);
}

function Wrappers.Outcome.Fail_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Wrappers.Outcome.Fail_q(d) } Wrappers.Outcome.Fail_q(d) <==> DatatypeCtorId(d) == ##Wrappers.Outcome.Fail);

axiom (forall d: DatatypeType :: { Wrappers.Outcome.Fail_q(d) } Wrappers.Outcome.Fail_q(d) ==> (exists a#5#0#0: Box :: d == #Wrappers.Outcome.Fail(a#5#0#0)));

axiom (forall Wrappers.Outcome$E: Ty, a#6#0#0: Box :: { $Is(#Wrappers.Outcome.Fail(a#6#0#0), Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) } $Is(#Wrappers.Outcome.Fail(a#6#0#0), Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) <==> $IsBox(a#6#0#0, Wrappers.Outcome$E));

axiom (forall Wrappers.Outcome$E: Ty, a#6#0#0: Box, $h: Heap :: { $IsAlloc(#Wrappers.Outcome.Fail(a#6#0#0), Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#Wrappers.Outcome.Fail(a#6#0#0), Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $h) <==> $IsAllocBox(a#6#0#0, Wrappers.Outcome$E, $h)));

axiom (forall d: DatatypeType, Wrappers.Outcome$E: Ty, $h: Heap :: { $IsAllocBox(Wrappers.Outcome.error(d), Wrappers.Outcome$E, $h) } $IsGoodHeap($h) && Wrappers.Outcome.Fail_q(d) && $IsAlloc(d, Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $h) ==> $IsAllocBox(Wrappers.Outcome.error(d), Wrappers.Outcome$E, $h));

axiom (forall a#7#0#0: Box :: { #Wrappers.Outcome.Fail(Lit(a#7#0#0)) } #Wrappers.Outcome.Fail(Lit(a#7#0#0)) == Lit(#Wrappers.Outcome.Fail(a#7#0#0)));

function Wrappers.Outcome.error(DatatypeType) : Box;

axiom (forall a#8#0#0: Box :: { #Wrappers.Outcome.Fail(a#8#0#0) } Wrappers.Outcome.error(#Wrappers.Outcome.Fail(a#8#0#0)) == a#8#0#0);

axiom (forall a#9#0#0: Box :: { #Wrappers.Outcome.Fail(a#9#0#0) } BoxRank(a#9#0#0) < DtRank(#Wrappers.Outcome.Fail(a#9#0#0)));

function $IsA#Wrappers.Outcome(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#Wrappers.Outcome(d) } $IsA#Wrappers.Outcome(d) ==> Wrappers.Outcome.Pass_q(d) || Wrappers.Outcome.Fail_q(d));

axiom (forall Wrappers.Outcome$E: Ty, d: DatatypeType :: { Wrappers.Outcome.Fail_q(d), $Is(d, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) } { Wrappers.Outcome.Pass_q(d), $Is(d, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) } $Is(d, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) ==> Wrappers.Outcome.Pass_q(d) || Wrappers.Outcome.Fail_q(d));

function Wrappers.Outcome#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Outcome#Equal(a, b), Wrappers.Outcome.Pass_q(a) } { Wrappers.Outcome#Equal(a, b), Wrappers.Outcome.Pass_q(b) } Wrappers.Outcome.Pass_q(a) && Wrappers.Outcome.Pass_q(b) ==> Wrappers.Outcome#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Outcome#Equal(a, b), Wrappers.Outcome.Fail_q(a) } { Wrappers.Outcome#Equal(a, b), Wrappers.Outcome.Fail_q(b) } Wrappers.Outcome.Fail_q(a) && Wrappers.Outcome.Fail_q(b) ==> (Wrappers.Outcome#Equal(a, b) <==> Wrappers.Outcome.error(a) == Wrappers.Outcome.error(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { Wrappers.Outcome#Equal(a, b) } Wrappers.Outcome#Equal(a, b) <==> a == b);

const unique class.Wrappers.Outcome: ClassName;

function Wrappers.Outcome.IsFailure(Wrappers.Outcome$E: Ty, this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Outcome$E: Ty, this: DatatypeType :: { Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, this) } Wrappers.Outcome.IsFailure#canCall(Wrappers.Outcome$E, this) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E))) ==> (Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, this) <==> Wrappers.Outcome.Fail_q(this)));
axiom 0 <= $FunctionContextHeight ==> (forall Wrappers.Outcome$E: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, Lit(this)) } Wrappers.Outcome.IsFailure#canCall(Wrappers.Outcome$E, Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E))) ==> (Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, Lit(this)) <==> Lit(Wrappers.Outcome.Fail_q(Lit(this)))));
}

function Wrappers.Outcome.IsFailure#canCall(Wrappers.Outcome$E: Ty, this: DatatypeType) : bool;

function Wrappers.Outcome.IsFailure#requires(Ty, DatatypeType) : bool;

axiom (forall Wrappers.Outcome$E: Ty, this: DatatypeType :: { Wrappers.Outcome.IsFailure#requires(Wrappers.Outcome$E, this) } $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) ==> (Wrappers.Outcome.IsFailure#requires(Wrappers.Outcome$E, this) <==> true));

procedure {:verboseName "Wrappers.Outcome.IsFailure (well-formedness)"} CheckWellformed$$Wrappers.Outcome.IsFailure(Wrappers.Outcome$E: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && $IsAlloc(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) } Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && Wrappers.Outcome.Fail_q(this)) ==> $Is(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E), $Heap) } (Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $IsAlloc(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $Heap) && Wrappers.Outcome.Fail_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) } Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && Wrappers.Outcome.Fail_q(this)) ==> Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) == #Wrappers.Result.Failure(Wrappers.Outcome.error(this)));
axiom 1 <= $FunctionContextHeight ==> (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, Lit(this)) } Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && Lit(Wrappers.Outcome.Fail_q(Lit(this)))) ==> Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, Lit(this)) == Lit(#Wrappers.Result.Failure(Lit(Wrappers.Outcome.error(Lit(this))))));
}

function Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType) : bool;

function Wrappers.Outcome.PropagateFailure#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Outcome.PropagateFailure#requires(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) } $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) ==> (Wrappers.Outcome.PropagateFailure#requires(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) <==> Wrappers.Outcome.Fail_q(this)));

procedure {:verboseName "Wrappers.Outcome.PropagateFailure (well-formedness)"} CheckWellformed$$Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType where $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && $IsAlloc(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Wrappers.Outcome.PropagateFailure (well-formedness)"} CheckWellformed$$Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Wrappers.Outcome.PropagateFailure", " | ", Wrappers.Outcome$E, " | ", Wrappers.Outcome.PropagateFailure$U, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/Wrappers.dfy(91,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Wrappers.Outcome.Fail_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E));
    assume false;
    return;

  anon4_Else:
    assume Wrappers.Outcome.Fail_q(this);
    assume Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) == #Wrappers.Result.Failure(Wrappers.Outcome.error(this));
    assume true;
    assume $Is(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E));
    return;
}



const unique tytagFamily$nat: TyTagFamily;

const unique tytagFamily$object: TyTagFamily;

const unique tytagFamily$array: TyTagFamily;

const unique tytagFamily$_#Func1: TyTagFamily;

const unique tytagFamily$_#PartialFunc1: TyTagFamily;

const unique tytagFamily$_#TotalFunc1: TyTagFamily;

const unique tytagFamily$_#Func0: TyTagFamily;

const unique tytagFamily$_#PartialFunc0: TyTagFamily;

const unique tytagFamily$_#TotalFunc0: TyTagFamily;

const unique tytagFamily$_tuple#2: TyTagFamily;

const unique tytagFamily$_tuple#0: TyTagFamily;

const unique tytagFamily$_#Func2: TyTagFamily;

const unique tytagFamily$_#PartialFunc2: TyTagFamily;

const unique tytagFamily$_#TotalFunc2: TyTagFamily;

const unique tytagFamily$_#Func3: TyTagFamily;

const unique tytagFamily$_#PartialFunc3: TyTagFamily;

const unique tytagFamily$_#TotalFunc3: TyTagFamily;

const unique tytagFamily$_tuple#3: TyTagFamily;

const unique tytagFamily$_#Func4: TyTagFamily;

const unique tytagFamily$_#PartialFunc4: TyTagFamily;

const unique tytagFamily$_#TotalFunc4: TyTagFamily;

const unique tytagFamily$_#Func5: TyTagFamily;

const unique tytagFamily$_#PartialFunc5: TyTagFamily;

const unique tytagFamily$_#TotalFunc5: TyTagFamily;

const unique tytagFamily$_#Func6: TyTagFamily;

const unique tytagFamily$_#PartialFunc6: TyTagFamily;

const unique tytagFamily$_#TotalFunc6: TyTagFamily;

const unique tytagFamily$Outcome: TyTagFamily;

const unique tytagFamily$Option: TyTagFamily;

const unique tytagFamily$Result: TyTagFamily;

const unique class.BoundedInts.__default: ClassName;

function BoundedInts.__default.TWO__TO__THE__0() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__0(): int == LitInt(1);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__0(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_0 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__0();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__0(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__0(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__1() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__1(): int == LitInt(2);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__1(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_1 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__1();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__1(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__1(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__2() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__2(): int == LitInt(4);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__2(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_2 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__2();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__2(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__2(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__4() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__4(): int == LitInt(16);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__4(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_4 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__4();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__4(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__4(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__5() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__5(): int == LitInt(32);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__5(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_5 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__5();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__5(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__5(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__8() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__8(): int == LitInt(256);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__8(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_8 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__8();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__8(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__8(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__16() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__16(): int == LitInt(65536);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__16(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_16 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__16();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__16(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__16(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__24() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__24(): int == LitInt(16777216);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__24(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_24 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__24();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__24(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__24(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__32() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__32(): int == LitInt(4294967296);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__32(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_32 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__32();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__32(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__32(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__40() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__40(): int == LitInt(1099511627776);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__40(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_40 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__40();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__40(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__40(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__48() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__48(): int == LitInt(281474976710656);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__48(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_48 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__48();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__48(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__48(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__56() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__56(): int == LitInt(72057594037927936);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__56(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_56 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__56();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__56(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__56(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__64() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__64(): int == LitInt(18446744073709551616);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__64(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_64 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__64();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__64(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__64(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__128() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__128(): int == LitInt(340282366920938463463374607431768211456);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__128(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_128 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__128();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__128(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__128(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__256() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__256(): int == LitInt(115792089237316195423570985008687907853269984665640564039457584007913129639936);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__256(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_256 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__256();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__256(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__256(), TInt, $h));

function BoundedInts.__default.TWO__TO__THE__512() : int
uses {
axiom BoundedInts.__default.TWO__TO__THE__512(): int == LitInt(13407807929942597099574024998205846127479365820592393377723561443721764030073546976801874298166903427690031858186486050853753882811946569946433649006084096);
axiom 0 < $FunctionContextHeight ==> $Is(BoundedInts.__default.TWO__TO__THE__512(), TInt);
}

procedure {:verboseName "BoundedInts.TWO_TO_THE_512 (well-formedness)"} CheckWellFormed$$BoundedInts.__default.TWO__TO__THE__512();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__512(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__512(), TInt, $h));

function BoundedInts.__default.UINT8__MAX() : int
uses {
axiom BoundedInts.__default.UINT8__MAX(): int == LitInt(255);
axiom 2 < $FunctionContextHeight ==> $Is(BoundedInts.__default.UINT8__MAX(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "BoundedInts.UINT8_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT8__MAX();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.UINT8_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT8__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.UINT8_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(37,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(255);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



function Tclass.BoundedInts.uint8() : Ty
uses {
axiom Tag(Tclass.BoundedInts.uint8()) == Tagclass.BoundedInts.uint8 && TagFamily(Tclass.BoundedInts.uint8()) == tytagFamily$uint8;
}

const unique Tagclass.BoundedInts.uint8: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.uint8()) } $IsBox(bx, Tclass.BoundedInts.uint8()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.uint8()));

axiom 2 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT8__MAX(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT8__MAX(), Tclass.BoundedInts.uint8(), $h));

function BoundedInts.__default.UINT16__MAX() : int
uses {
axiom BoundedInts.__default.UINT16__MAX(): int == LitInt(65535);
axiom 2 < $FunctionContextHeight ==> $Is(BoundedInts.__default.UINT16__MAX(), Tclass.BoundedInts.uint16());
}

procedure {:verboseName "BoundedInts.UINT16_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT16__MAX();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.UINT16_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT16__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.UINT16_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(38,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(65535);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    assume true;
    return;
}



function Tclass.BoundedInts.uint16() : Ty
uses {
axiom Tag(Tclass.BoundedInts.uint16()) == Tagclass.BoundedInts.uint16 && TagFamily(Tclass.BoundedInts.uint16()) == tytagFamily$uint16;
}

const unique Tagclass.BoundedInts.uint16: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.uint16()) } $IsBox(bx, Tclass.BoundedInts.uint16()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.uint16()));

axiom 2 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT16__MAX(), Tclass.BoundedInts.uint16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT16__MAX(), Tclass.BoundedInts.uint16(), $h));

function BoundedInts.__default.UINT32__MAX() : int
uses {
axiom BoundedInts.__default.UINT32__MAX(): int == LitInt(4294967295);
axiom 2 < $FunctionContextHeight ==> $Is(BoundedInts.__default.UINT32__MAX(), Tclass.BoundedInts.uint32());
}

procedure {:verboseName "BoundedInts.UINT32_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT32__MAX();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.UINT32_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT32__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.UINT32_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(39,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(4294967295);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    return;
}



function Tclass.BoundedInts.uint32() : Ty
uses {
axiom Tag(Tclass.BoundedInts.uint32()) == Tagclass.BoundedInts.uint32 && TagFamily(Tclass.BoundedInts.uint32()) == tytagFamily$uint32;
}

const unique Tagclass.BoundedInts.uint32: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.uint32()) } $IsBox(bx, Tclass.BoundedInts.uint32()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.uint32()));

axiom 2 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT32__MAX(), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT32__MAX(), Tclass.BoundedInts.uint32(), $h));

function BoundedInts.__default.UINT64__MAX() : int
uses {
axiom BoundedInts.__default.UINT64__MAX(): int == LitInt(18446744073709551615);
axiom 2 < $FunctionContextHeight ==> $Is(BoundedInts.__default.UINT64__MAX(), Tclass.BoundedInts.uint64());
}

procedure {:verboseName "BoundedInts.UINT64_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT64__MAX();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.UINT64_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.UINT64__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.UINT64_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(40,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(18446744073709551615);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    return;
}



function Tclass.BoundedInts.uint64() : Ty
uses {
axiom Tag(Tclass.BoundedInts.uint64()) == Tagclass.BoundedInts.uint64 && TagFamily(Tclass.BoundedInts.uint64()) == tytagFamily$uint64;
}

const unique Tagclass.BoundedInts.uint64: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.uint64()) } $IsBox(bx, Tclass.BoundedInts.uint64()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.uint64()));

axiom 2 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT64__MAX(), Tclass.BoundedInts.uint64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT64__MAX(), Tclass.BoundedInts.uint64(), $h));

function BoundedInts.__default.INT8__MIN() : int
uses {
axiom BoundedInts.__default.INT8__MIN(): int == LitInt(-128);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT8__MIN(), Tclass.BoundedInts.int8());
}

procedure {:verboseName "BoundedInts.INT8_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT8__MIN();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT8_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT8__MIN()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT8_MIN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(42,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(-128);
    assume LitInt(-128) <= newtype$check#0 && newtype$check#0 < 128;
    assume true;
    return;
}



function Tclass.BoundedInts.int8() : Ty
uses {
axiom Tag(Tclass.BoundedInts.int8()) == Tagclass.BoundedInts.int8 && TagFamily(Tclass.BoundedInts.int8()) == tytagFamily$int8;
}

const unique Tagclass.BoundedInts.int8: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.int8()) } $IsBox(bx, Tclass.BoundedInts.int8()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.int8()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT8__MIN(), Tclass.BoundedInts.int8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT8__MIN(), Tclass.BoundedInts.int8(), $h));

function BoundedInts.__default.INT8__MAX() : int
uses {
axiom BoundedInts.__default.INT8__MAX(): int == LitInt(127);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT8__MAX(), Tclass.BoundedInts.int8());
}

procedure {:verboseName "BoundedInts.INT8_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT8__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT8_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT8__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT8_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(43,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(127);
    assume LitInt(-128) <= newtype$check#0 && newtype$check#0 < 128;
    assume true;
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT8__MAX(), Tclass.BoundedInts.int8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT8__MAX(), Tclass.BoundedInts.int8(), $h));

function BoundedInts.__default.INT16__MIN() : int
uses {
axiom BoundedInts.__default.INT16__MIN(): int == LitInt(-32768);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT16__MIN(), Tclass.BoundedInts.int16());
}

procedure {:verboseName "BoundedInts.INT16_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT16__MIN();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT16_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT16__MIN()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT16_MIN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(44,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(-32768);
    assume LitInt(-32768) <= newtype$check#0 && newtype$check#0 < 32768;
    assume true;
    return;
}



function Tclass.BoundedInts.int16() : Ty
uses {
axiom Tag(Tclass.BoundedInts.int16()) == Tagclass.BoundedInts.int16 && TagFamily(Tclass.BoundedInts.int16()) == tytagFamily$int16;
}

const unique Tagclass.BoundedInts.int16: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.int16()) } $IsBox(bx, Tclass.BoundedInts.int16()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.int16()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT16__MIN(), Tclass.BoundedInts.int16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT16__MIN(), Tclass.BoundedInts.int16(), $h));

function BoundedInts.__default.INT16__MAX() : int
uses {
axiom BoundedInts.__default.INT16__MAX(): int == LitInt(32767);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT16__MAX(), Tclass.BoundedInts.int16());
}

procedure {:verboseName "BoundedInts.INT16_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT16__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT16_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT16__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT16_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(45,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(32767);
    assume LitInt(-32768) <= newtype$check#0 && newtype$check#0 < 32768;
    assume true;
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT16__MAX(), Tclass.BoundedInts.int16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT16__MAX(), Tclass.BoundedInts.int16(), $h));

function BoundedInts.__default.INT32__MIN() : int
uses {
axiom BoundedInts.__default.INT32__MIN(): int == LitInt(-2147483648);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT32__MIN(), Tclass.BoundedInts.int32());
}

procedure {:verboseName "BoundedInts.INT32_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT32__MIN();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT32_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT32__MIN()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT32_MIN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(46,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(-2147483648);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    assume true;
    return;
}



function Tclass.BoundedInts.int32() : Ty
uses {
axiom Tag(Tclass.BoundedInts.int32()) == Tagclass.BoundedInts.int32 && TagFamily(Tclass.BoundedInts.int32()) == tytagFamily$int32;
}

const unique Tagclass.BoundedInts.int32: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.int32()) } $IsBox(bx, Tclass.BoundedInts.int32()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.int32()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT32__MIN(), Tclass.BoundedInts.int32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT32__MIN(), Tclass.BoundedInts.int32(), $h));

function BoundedInts.__default.INT32__MAX() : int
uses {
axiom BoundedInts.__default.INT32__MAX(): int == LitInt(2147483647);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT32__MAX(), Tclass.BoundedInts.int32());
}

procedure {:verboseName "BoundedInts.INT32_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT32__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT32_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT32__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT32_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(47,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(2147483647);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    assume true;
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT32__MAX(), Tclass.BoundedInts.int32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT32__MAX(), Tclass.BoundedInts.int32(), $h));

function BoundedInts.__default.INT64__MIN() : int
uses {
axiom BoundedInts.__default.INT64__MIN(): int == LitInt(-9223372036854775808);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT64__MIN(), Tclass.BoundedInts.int64());
}

procedure {:verboseName "BoundedInts.INT64_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT64__MIN();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT64_MIN (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT64__MIN()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT64_MIN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(48,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(-9223372036854775808);
    assume LitInt(-9223372036854775808) <= newtype$check#0 && newtype$check#0 < 9223372036854775808;
    assume true;
    return;
}



function Tclass.BoundedInts.int64() : Ty
uses {
axiom Tag(Tclass.BoundedInts.int64()) == Tagclass.BoundedInts.int64 && TagFamily(Tclass.BoundedInts.int64()) == tytagFamily$int64;
}

const unique Tagclass.BoundedInts.int64: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.int64()) } $IsBox(bx, Tclass.BoundedInts.int64()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.int64()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT64__MIN(), Tclass.BoundedInts.int64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT64__MIN(), Tclass.BoundedInts.int64(), $h));

function BoundedInts.__default.INT64__MAX() : int
uses {
axiom BoundedInts.__default.INT64__MAX(): int == LitInt(9223372036854775807);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.INT64__MAX(), Tclass.BoundedInts.int64());
}

procedure {:verboseName "BoundedInts.INT64_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT64__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.INT64_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.INT64__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.INT64_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(49,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(9223372036854775807);
    assume LitInt(-9223372036854775808) <= newtype$check#0 && newtype$check#0 < 9223372036854775808;
    assume true;
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT64__MAX(), Tclass.BoundedInts.int64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT64__MAX(), Tclass.BoundedInts.int64(), $h));

function BoundedInts.__default.NAT8__MAX() : int
uses {
axiom BoundedInts.__default.NAT8__MAX(): int == LitInt(127);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.NAT8__MAX(), Tclass.BoundedInts.nat8());
}

procedure {:verboseName "BoundedInts.NAT8_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT8__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.NAT8_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT8__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.NAT8_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(51,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(127);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 128;
    assume true;
    return;
}



function Tclass.BoundedInts.nat8() : Ty
uses {
axiom Tag(Tclass.BoundedInts.nat8()) == Tagclass.BoundedInts.nat8 && TagFamily(Tclass.BoundedInts.nat8()) == tytagFamily$nat8;
}

const unique Tagclass.BoundedInts.nat8: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.nat8()) } $IsBox(bx, Tclass.BoundedInts.nat8()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.nat8()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT8__MAX(), Tclass.BoundedInts.nat8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT8__MAX(), Tclass.BoundedInts.nat8(), $h));

function BoundedInts.__default.NAT16__MAX() : int
uses {
axiom BoundedInts.__default.NAT16__MAX(): int == LitInt(32767);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.NAT16__MAX(), Tclass.BoundedInts.nat16());
}

procedure {:verboseName "BoundedInts.NAT16_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT16__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.NAT16_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT16__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.NAT16_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(52,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(32767);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 32768;
    assume true;
    return;
}



function Tclass.BoundedInts.nat16() : Ty
uses {
axiom Tag(Tclass.BoundedInts.nat16()) == Tagclass.BoundedInts.nat16 && TagFamily(Tclass.BoundedInts.nat16()) == tytagFamily$nat16;
}

const unique Tagclass.BoundedInts.nat16: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.nat16()) } $IsBox(bx, Tclass.BoundedInts.nat16()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.nat16()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT16__MAX(), Tclass.BoundedInts.nat16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT16__MAX(), Tclass.BoundedInts.nat16(), $h));

function BoundedInts.__default.NAT32__MAX() : int
uses {
axiom BoundedInts.__default.NAT32__MAX(): int == LitInt(2147483647);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.NAT32__MAX(), Tclass.BoundedInts.nat32());
}

procedure {:verboseName "BoundedInts.NAT32_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT32__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.NAT32_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT32__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.NAT32_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(53,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(2147483647);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 2147483648;
    assume true;
    return;
}



function Tclass.BoundedInts.nat32() : Ty
uses {
axiom Tag(Tclass.BoundedInts.nat32()) == Tagclass.BoundedInts.nat32 && TagFamily(Tclass.BoundedInts.nat32()) == tytagFamily$nat32;
}

const unique Tagclass.BoundedInts.nat32: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.nat32()) } $IsBox(bx, Tclass.BoundedInts.nat32()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.nat32()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT32__MAX(), Tclass.BoundedInts.nat32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT32__MAX(), Tclass.BoundedInts.nat32(), $h));

function BoundedInts.__default.NAT64__MAX() : int
uses {
axiom BoundedInts.__default.NAT64__MAX(): int == LitInt(9223372036854775807);
axiom 1 < $FunctionContextHeight ==> $Is(BoundedInts.__default.NAT64__MAX(), Tclass.BoundedInts.nat64());
}

procedure {:verboseName "BoundedInts.NAT64_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT64__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.NAT64_MAX (well-formedness)"} CheckWellFormed$$BoundedInts.__default.NAT64__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.NAT64_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(54,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(9223372036854775807);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 9223372036854775808;
    assume true;
    return;
}



function Tclass.BoundedInts.nat64() : Ty
uses {
axiom Tag(Tclass.BoundedInts.nat64()) == Tagclass.BoundedInts.nat64 && TagFamily(Tclass.BoundedInts.nat64()) == tytagFamily$nat64;
}

const unique Tagclass.BoundedInts.nat64: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.nat64()) } $IsBox(bx, Tclass.BoundedInts.nat64()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.nat64()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT64__MAX(), Tclass.BoundedInts.nat64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT64__MAX(), Tclass.BoundedInts.nat64(), $h));

procedure {:verboseName "BoundedInts.uint8 (well-formedness)"} CheckWellFormed$$BoundedInts.uint8(x#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.uint8 (well-formedness)"} CheckWellFormed$$BoundedInts.uint8(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.uint8", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(22,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8();
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} 0 < BoundedInts.__default.TWO__TO__THE__8();
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.uint8()) } $Is(x#0, Tclass.BoundedInts.uint8()) <==> LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.uint8(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.uint8(), $h));

const unique class.BoundedInts.uint8: ClassName;

procedure {:verboseName "BoundedInts.uint16 (well-formedness)"} CheckWellFormed$$BoundedInts.uint16(x#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.uint16 (well-formedness)"} CheckWellFormed$$BoundedInts.uint16(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.uint16", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(23,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16();
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} 0 < BoundedInts.__default.TWO__TO__THE__16();
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.uint16()) } $Is(x#0, Tclass.BoundedInts.uint16()) <==> LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16());

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.uint16(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.uint16(), $h));

const unique class.BoundedInts.uint16: ClassName;

procedure {:verboseName "BoundedInts.uint32 (well-formedness)"} CheckWellFormed$$BoundedInts.uint32(x#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.uint32 (well-formedness)"} CheckWellFormed$$BoundedInts.uint32(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.uint32", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(24,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32();
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} 0 < BoundedInts.__default.TWO__TO__THE__32();
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.uint32()) } $Is(x#0, Tclass.BoundedInts.uint32()) <==> LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.uint32(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.uint32(), $h));

const unique class.BoundedInts.uint32: ClassName;

procedure {:verboseName "BoundedInts.uint64 (well-formedness)"} CheckWellFormed$$BoundedInts.uint64(x#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.uint64 (well-formedness)"} CheckWellFormed$$BoundedInts.uint64(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.uint64", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(25,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64();
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} 0 < BoundedInts.__default.TWO__TO__THE__64();
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.uint64()) } $Is(x#0, Tclass.BoundedInts.uint64()) <==> LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64());

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.uint64(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.uint64(), $h));

const unique class.BoundedInts.uint64: ClassName;

procedure {:verboseName "BoundedInts.int8 (well-formedness)"} CheckWellFormed$$BoundedInts.int8(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.int8 (well-formedness)"} CheckWellFormed$$BoundedInts.int8(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.int8", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(27,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(-128) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(-128);
    goto anon4;

  anon4:
    assume LitInt(-128) <= x#0 && x#0 < 128;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(-128) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 128);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.int8()) } $Is(x#0, Tclass.BoundedInts.int8()) <==> LitInt(-128) <= x#0 && x#0 < 128);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.int8(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.int8(), $h));

const unique class.BoundedInts.int8: ClassName;

procedure {:verboseName "BoundedInts.int16 (well-formedness)"} CheckWellFormed$$BoundedInts.int16(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.int16 (well-formedness)"} CheckWellFormed$$BoundedInts.int16(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.int16", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(28,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(-32768) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(-32768);
    goto anon4;

  anon4:
    assume LitInt(-32768) <= x#0 && x#0 < 32768;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(-32768) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 32768);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.int16()) } $Is(x#0, Tclass.BoundedInts.int16()) <==> LitInt(-32768) <= x#0 && x#0 < 32768);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.int16(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.int16(), $h));

const unique class.BoundedInts.int16: ClassName;

procedure {:verboseName "BoundedInts.int32 (well-formedness)"} CheckWellFormed$$BoundedInts.int32(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.int32 (well-formedness)"} CheckWellFormed$$BoundedInts.int32(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.int32", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(29,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(-2147483648) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(-2147483648);
    goto anon4;

  anon4:
    assume LitInt(-2147483648) <= x#0 && x#0 < 2147483648;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(-2147483648) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 2147483648);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.int32()) } $Is(x#0, Tclass.BoundedInts.int32()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.int32(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.int32(), $h));

const unique class.BoundedInts.int32: ClassName;

procedure {:verboseName "BoundedInts.int64 (well-formedness)"} CheckWellFormed$$BoundedInts.int64(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.int64 (well-formedness)"} CheckWellFormed$$BoundedInts.int64(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.int64", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(30,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(-9223372036854775808) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(-9223372036854775808);
    goto anon4;

  anon4:
    assume LitInt(-9223372036854775808) <= x#0 && x#0 < 9223372036854775808;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(-9223372036854775808) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 9223372036854775808);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.int64()) } $Is(x#0, Tclass.BoundedInts.int64()) <==> LitInt(-9223372036854775808) <= x#0 && x#0 < 9223372036854775808);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.int64(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.int64(), $h));

const unique class.BoundedInts.int64: ClassName;

procedure {:verboseName "BoundedInts.nat8 (well-formedness)"} CheckWellFormed$$BoundedInts.nat8(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.nat8 (well-formedness)"} CheckWellFormed$$BoundedInts.nat8(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.nat8", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(32,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < 128;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 128);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.nat8()) } $Is(x#0, Tclass.BoundedInts.nat8()) <==> LitInt(0) <= x#0 && x#0 < 128);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.nat8(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.nat8(), $h));

const unique class.BoundedInts.nat8: ClassName;

procedure {:verboseName "BoundedInts.nat16 (well-formedness)"} CheckWellFormed$$BoundedInts.nat16(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.nat16 (well-formedness)"} CheckWellFormed$$BoundedInts.nat16(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.nat16", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(33,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < 32768;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 32768);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.nat16()) } $Is(x#0, Tclass.BoundedInts.nat16()) <==> LitInt(0) <= x#0 && x#0 < 32768);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.nat16(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.nat16(), $h));

const unique class.BoundedInts.nat16: ClassName;

procedure {:verboseName "BoundedInts.nat32 (well-formedness)"} CheckWellFormed$$BoundedInts.nat32(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.nat32 (well-formedness)"} CheckWellFormed$$BoundedInts.nat32(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.nat32", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(34,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < 2147483648;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 2147483648);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.nat32()) } $Is(x#0, Tclass.BoundedInts.nat32()) <==> LitInt(0) <= x#0 && x#0 < 2147483648);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.nat32(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.nat32(), $h));

const unique class.BoundedInts.nat32: ClassName;

procedure {:verboseName "BoundedInts.nat64 (well-formedness)"} CheckWellFormed$$BoundedInts.nat64(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.nat64 (well-formedness)"} CheckWellFormed$$BoundedInts.nat64(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.nat64", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(35,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < 9223372036854775808;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 9223372036854775808);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.BoundedInts.nat64()) } $Is(x#0, Tclass.BoundedInts.nat64()) <==> LitInt(0) <= x#0 && x#0 < 9223372036854775808);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.BoundedInts.nat64(), $h) } $IsAlloc(x#0, Tclass.BoundedInts.nat64(), $h));

const unique class.BoundedInts.nat64: ClassName;

procedure {:verboseName "BoundedInts.opt_byte (well-formedness)"} CheckWellFormed$$BoundedInts.opt__byte(c#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "BoundedInts.opt_byte (well-formedness)"} CheckWellFormed$$BoundedInts.opt__byte(c#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "BoundedInts.opt_byte", " | ", c#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/BoundedInts.dfy(58,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(-1) <= c#0;
    goto anon4;

  anon7_Else:
    assume {:partition} c#0 < LitInt(-1);
    goto anon4;

  anon4:
    assume LitInt(-1) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(-1) <= LitInt(0);
    assume {:subsumption 0} 0 < BoundedInts.__default.TWO__TO__THE__8();
    return;
}



function Tclass.BoundedInts.opt__byte() : Ty
uses {
axiom Tag(Tclass.BoundedInts.opt__byte()) == Tagclass.BoundedInts.opt__byte && TagFamily(Tclass.BoundedInts.opt__byte()) == tytagFamily$opt_byte;
}

const unique Tagclass.BoundedInts.opt__byte: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.BoundedInts.opt__byte()) } $IsBox(bx, Tclass.BoundedInts.opt__byte()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.BoundedInts.opt__byte()));

axiom (forall c#0: int :: { $Is(c#0, Tclass.BoundedInts.opt__byte()) } $Is(c#0, Tclass.BoundedInts.opt__byte()) <==> LitInt(-1) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall c#0: int, $h: Heap :: { $IsAlloc(c#0, Tclass.BoundedInts.opt__byte(), $h) } $IsAlloc(c#0, Tclass.BoundedInts.opt__byte(), $h));

const unique class.BoundedInts.opt__byte: ClassName;

const unique tytagFamily$uint8: TyTagFamily;

const unique tytagFamily$uint16: TyTagFamily;

const unique tytagFamily$uint32: TyTagFamily;

const unique tytagFamily$uint64: TyTagFamily;

const unique tytagFamily$int8: TyTagFamily;

const unique tytagFamily$int16: TyTagFamily;

const unique tytagFamily$int32: TyTagFamily;

const unique tytagFamily$int64: TyTagFamily;

const unique tytagFamily$nat8: TyTagFamily;

const unique tytagFamily$nat16: TyTagFamily;

const unique tytagFamily$nat32: TyTagFamily;

const unique tytagFamily$nat64: TyTagFamily;

const unique tytagFamily$opt_byte: TyTagFamily;

const unique class.StandardLibrary_mUInt.__default: ClassName;

function StandardLibrary_mUInt.__default.UINT16__LIMIT() : int
uses {
axiom StandardLibrary_mUInt.__default.UINT16__LIMIT(): int == BoundedInts.__default.UINT16__MAX() + 1;
axiom 0 < $FunctionContextHeight ==> $Is(StandardLibrary_mUInt.__default.UINT16__LIMIT(), TInt);
}

procedure {:verboseName "StandardLibrary.UInt.UINT16_LIMIT (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UINT16__LIMIT();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT16__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT16__LIMIT(), TInt, $h));

function StandardLibrary_mUInt.__default.UINT32__LIMIT() : int
uses {
axiom StandardLibrary_mUInt.__default.UINT32__LIMIT(): int == BoundedInts.__default.UINT32__MAX() + 1;
axiom 0 < $FunctionContextHeight ==> $Is(StandardLibrary_mUInt.__default.UINT32__LIMIT(), TInt);
}

procedure {:verboseName "StandardLibrary.UInt.UINT32_LIMIT (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UINT32__LIMIT();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT32__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT32__LIMIT(), TInt, $h));

function StandardLibrary_mUInt.__default.UINT64__LIMIT() : int
uses {
axiom StandardLibrary_mUInt.__default.UINT64__LIMIT(): int == BoundedInts.__default.UINT64__MAX() + 1;
axiom 0 < $FunctionContextHeight ==> $Is(StandardLibrary_mUInt.__default.UINT64__LIMIT(), TInt);
}

procedure {:verboseName "StandardLibrary.UInt.UINT64_LIMIT (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UINT64__LIMIT();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT64__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT64__LIMIT(), TInt, $h));

function StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() : int
uses {
axiom StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(): int == BoundedInts.__default.INT32__MAX();
axiom 0 < $FunctionContextHeight ==> $Is(StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(), TInt);
}

procedure {:verboseName "StandardLibrary.UInt.INT32_MAX_LIMIT (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(), TInt, $h));

function StandardLibrary_mUInt.__default.INT64__MAX__LIMIT() : int
uses {
axiom StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(): int == BoundedInts.__default.INT64__MAX();
axiom 0 < $FunctionContextHeight ==> $Is(StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(), TInt);
}

procedure {:verboseName "StandardLibrary.UInt.INT64_MAX_LIMIT (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.INT64__MAX__LIMIT();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(), TInt, $h));

function StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() : int
uses {
axiom StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(): int == BoundedInts.__default.UINT64__MAX();
axiom 0 < $FunctionContextHeight ==> $Is(StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(), TInt);
}

procedure {:verboseName "StandardLibrary.UInt.UINT64_MAX_LIMIT (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(), TInt, $h));

function StandardLibrary_mUInt.__default.UInt8Less(a#0: int, b#0: int) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: { StandardLibrary_mUInt.__default.UInt8Less(a#0, b#0) } StandardLibrary_mUInt.__default.UInt8Less#canCall(a#0, b#0) || (1 < $FunctionContextHeight && LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (StandardLibrary_mUInt.__default.UInt8Less(a#0, b#0) <==> a#0 < b#0));
axiom 1 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt8Less(LitInt(a#0), LitInt(b#0)) } StandardLibrary_mUInt.__default.UInt8Less#canCall(LitInt(a#0), LitInt(b#0)) || (1 < $FunctionContextHeight && LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (StandardLibrary_mUInt.__default.UInt8Less(LitInt(a#0), LitInt(b#0)) <==> Lit(a#0 < b#0)));
}

function StandardLibrary_mUInt.__default.UInt8Less#canCall(a#0: int, b#0: int) : bool;

function StandardLibrary_mUInt.__default.UInt8Less#requires(int, int) : bool;

axiom (forall a#0: int, b#0: int :: { StandardLibrary_mUInt.__default.UInt8Less#requires(a#0, b#0) } LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (StandardLibrary_mUInt.__default.UInt8Less#requires(a#0, b#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.UInt8Less (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt8Less(a#0: int where LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__8(), b#0: int where LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, s#0) } StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt._default.HasUint16Len$T, s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint16Len$T))) ==> (StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, s#0) <==> Seq#Length(s#0) < StandardLibrary_mUInt.__default.UINT16__LIMIT()));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, Lit(s#0)) } StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt._default.HasUint16Len$T, Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint16Len$T))) ==> (StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, Lit(s#0)) <==> Seq#Length(Lit(s#0)) < StandardLibrary_mUInt.__default.UINT16__LIMIT()));
}

function StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq) : bool;

function StandardLibrary_mUInt.__default.HasUint16Len#requires(Ty, Seq) : bool;

axiom (forall StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint16Len#requires(StandardLibrary.UInt._default.HasUint16Len$T, s#0) } $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint16Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint16Len#requires(StandardLibrary.UInt._default.HasUint16Len$T, s#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.HasUint16Len (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint16Len$T)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, s#0) } StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt._default.HasUint32Len$T, s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint32Len$T))) ==> (StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, s#0) <==> Seq#Length(s#0) < StandardLibrary_mUInt.__default.UINT32__LIMIT()));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, Lit(s#0)) } StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt._default.HasUint32Len$T, Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint32Len$T))) ==> (StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, Lit(s#0)) <==> Seq#Length(Lit(s#0)) < StandardLibrary_mUInt.__default.UINT32__LIMIT()));
}

function StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq) : bool;

function StandardLibrary_mUInt.__default.HasUint32Len#requires(Ty, Seq) : bool;

axiom (forall StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint32Len#requires(StandardLibrary.UInt._default.HasUint32Len$T, s#0) } $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint32Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint32Len#requires(StandardLibrary.UInt._default.HasUint32Len$T, s#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.HasUint32Len (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint32Len$T)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, s#0) } StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt._default.HasUint64Len$T, s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint64Len$T))) ==> (StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, s#0) <==> Seq#Length(s#0) < StandardLibrary_mUInt.__default.UINT64__LIMIT()));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, Lit(s#0)) } StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt._default.HasUint64Len$T, Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint64Len$T))) ==> (StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, Lit(s#0)) <==> Seq#Length(Lit(s#0)) < StandardLibrary_mUInt.__default.UINT64__LIMIT()));
}

function StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq) : bool;

function StandardLibrary_mUInt.__default.HasUint64Len#requires(Ty, Seq) : bool;

axiom (forall StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint64Len#requires(StandardLibrary.UInt._default.HasUint64Len$T, s#0) } $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint64Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint64Len#requires(StandardLibrary.UInt._default.HasUint64Len$T, s#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.HasUint64Len (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint64Len$T)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary_mUInt.__default.UInt16ToSeq(x#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> Seq#Length(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0)) == LitInt(2) && Mul(LitInt(256), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), LitInt(0))): int) + $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), LitInt(1))): int == x#0 && $Is(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#0 := Div(x#0, LitInt(256)); (var b1#0 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0)), $Box(b1#0)))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#1 := LitInt(Div(x#0, LitInt(256))); (var b1#1 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#1)), $Box(b1#1))))));
}

function StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0: int) : bool;

function StandardLibrary_mUInt.__default.UInt16ToSeq#requires(int) : bool;

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq#requires(x#0) } LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16() ==> (StandardLibrary_mUInt.__default.UInt16ToSeq#requires(x#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.UInt16ToSeq (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt16ToSeq(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id127"} Seq#Length(ret#0) == LitInt(2);
  free ensures {:id "id128"} Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + $Unbox(Seq#Index(ret#0, LitInt(1))): int == x#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt16ToSeq (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt16ToSeq(x#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var b0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var b1#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16ToSeq", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(44,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(ret#0) == LitInt(2);
    newtype$check#0 := LitInt(256);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    newtype$check#1 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#2 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#3 := Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(0))): int);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__16();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(ret#0);
    newtype$check#4 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#5 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#6 := Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__16();
    assume Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + $Unbox(Seq#Index(ret#0, LitInt(1))): int == x#0;
    assume false;
    return;

  anon4_Else:
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := LitInt(256);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__16();
    assume LitInt(256) != 0;
    newtype$check#8 := Div(x#0, LitInt(256));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#9 := Div(x#0, LitInt(256));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#10 := Div(x#0, LitInt(256));
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0#0#0 == Div(x#0, LitInt(256));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0 == let#0#0#0;
    havoc b1#Z#0;
    assume LitInt(0) <= b1#Z#0 && b1#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#11 := LitInt(256);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__16();
    assume LitInt(256) != 0;
    newtype$check#12 := Mod(x#0, LitInt(256));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#13 := Mod(x#0, LitInt(256));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#14 := Mod(x#0, LitInt(256));
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#1#0#0 == Mod(x#0, LitInt(256));
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint8());
    assume b1#Z#0 == let#1#0#0;
    assume StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#Z#0)), $Box(b1#Z#0));
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == ret#0;
    return;
}



function StandardLibrary_mUInt.__default.SeqToUInt16(s#0: Seq) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(StandardLibrary_mUInt.__default.SeqToUInt16(s#0)), s#0) && StandardLibrary_mUInt.__default.SeqToUInt16(s#0) >= LitInt(0) && LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt16(s#0) && StandardLibrary_mUInt.__default.SeqToUInt16(s#0) < BoundedInts.__default.TWO__TO__THE__16());
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#0 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#0 + $Unbox(Seq#Index(s#0, LitInt(1))): int));
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#1 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#1 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));
}

function StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0: Seq) : bool;

function StandardLibrary_mUInt.__default.SeqToUInt16#requires(Seq) : bool;

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (StandardLibrary_mUInt.__default.SeqToUInt16#requires(s#0) <==> Seq#Length(s#0) == LitInt(2)));

procedure {:verboseName "StandardLibrary.UInt.SeqToUInt16 (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToUInt16(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) returns (x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id156"} Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), s#0);
  free ensures {:id "id157"} x#0 >= LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqToUInt16 (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToUInt16(s#0: Seq) returns (x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var newtype$check#0: int;
  var x0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToUInt16", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(53,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(2);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt16(s#0) && StandardLibrary_mUInt.__default.SeqToUInt16(s#0) < BoundedInts.__default.TWO__TO__THE__16();
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint16(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0);
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), s#0);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    assume x#0 >= LitInt(0);
    assume false;
    return;

  anon4_Else:
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < BoundedInts.__default.TWO__TO__THE__16();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#2 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#3 := LitInt(256);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#4 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#0#0#0 == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint16());
    assume x0#Z#0 == let#0#0#0;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#6 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#7 := x0#Z#0 + $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__16();
    assume StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == x0#Z#0 + $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.SeqToUInt16(s#0), Tclass.BoundedInts.uint16());
    assume StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == x#0;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16());
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(62,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(63,40): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint16(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0);
    ##s#0 := StandardLibrary_mUInt.__default.UInt16ToSeq(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(2);
    assume Seq#Length(##s#0) == LitInt(2);
    assume StandardLibrary_mUInt.__default.SeqToUInt16#canCall(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0));
    assume StandardLibrary_mUInt.__default.SeqToUInt16(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0)) == x#0;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16());



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16());
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) && StandardLibrary_mUInt.__default.SeqToUInt16#canCall(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0));
  free ensures {:id "id177"} StandardLibrary_mUInt.__default.SeqToUInt16(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) && StandardLibrary_mUInt.__default.SeqToUInt16#canCall(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0));
  free ensures {:id "id178"} StandardLibrary_mUInt.__default.SeqToUInt16(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(64,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(66,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(2);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(68,40): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(2);
    assume Seq#Length(##s#0) == LitInt(2);
    assume StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0);
    ##x#0 := StandardLibrary_mUInt.__default.SeqToUInt16(s#0);
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint16(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt16(s#0));
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(StandardLibrary_mUInt.__default.SeqToUInt16(s#0)), s#0);
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id182"} Seq#Length(s#0) == LitInt(2);



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) && StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt16(s#0));
  free ensures {:id "id183"} Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(StandardLibrary_mUInt.__default.SeqToUInt16(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id184"} Seq#Length(s#0) == LitInt(2);
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) && StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt16(s#0));
  free ensures {:id "id185"} Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(StandardLibrary_mUInt.__default.SeqToUInt16(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(69,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function StandardLibrary_mUInt.__default.UInt32ToSeq(x#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> Seq#Length(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0)) == LitInt(4) && Mul(LitInt(16777216), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(1))): int) + Mul(LitInt(256), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(2))): int) + $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(3))): int == x#0 && $Is(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#0 := Div(x#0, LitInt(16777216)); (var x0#0 := x#0 - Mul(b0#0, LitInt(16777216)); (var b1#0 := Div(x0#0, LitInt(65536)); (var x1#0 := x0#0 - Mul(b1#0, LitInt(65536)); (var b2#0 := Div(x1#0, LitInt(256)); (var b3#0 := Mod(x1#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0)), $Box(b1#0)), $Box(b2#0)), $Box(b3#0)))))))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#1 := LitInt(Div(x#0, LitInt(16777216))); (var x0#1 := LitInt(x#0 - Mul(b0#1, LitInt(16777216))); (var b1#1 := LitInt(Div(x0#1, LitInt(65536))); (var x1#1 := LitInt(x0#1 - Mul(b1#1, LitInt(65536))); (var b2#1 := LitInt(Div(x1#1, LitInt(256))); (var b3#1 := LitInt(Mod(x1#1, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#1)), $Box(b1#1)), $Box(b2#1)), $Box(b3#1))))))))));
}

function StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0: int) : bool;

function StandardLibrary_mUInt.__default.UInt32ToSeq#requires(int) : bool;

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq#requires(x#0) } LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (StandardLibrary_mUInt.__default.UInt32ToSeq#requires(x#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.UInt32ToSeq (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt32ToSeq(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id186"} Seq#Length(ret#0) == LitInt(4);
  free ensures {:id "id187"} Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + $Unbox(Seq#Index(ret#0, LitInt(3))): int == x#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt32ToSeq (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt32ToSeq(x#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var b0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var x0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var b1#Z#0: int;
  var let#2#0#0: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;
  var newtype$check#29: int;
  var x1#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#30: int;
  var newtype$check#31: int;
  var newtype$check#32: int;
  var newtype$check#33: int;
  var newtype$check#34: int;
  var b2#Z#0: int;
  var let#4#0#0: int;
  var newtype$check#35: int;
  var newtype$check#36: int;
  var newtype$check#37: int;
  var newtype$check#38: int;
  var b3#Z#0: int;
  var let#5#0#0: int;
  var newtype$check#39: int;
  var newtype$check#40: int;
  var newtype$check#41: int;
  var newtype$check#42: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32ToSeq", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(71,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(ret#0) == LitInt(4);
    newtype$check#0 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    newtype$check#1 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(0))): int);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#4 := LitInt(65536);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(ret#0);
    newtype$check#5 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#6 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#7 := Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(1))): int);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#8 := Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(1))): int);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#9 := LitInt(256);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(ret#0);
    newtype$check#10 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#11 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#12 := Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(2))): int);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#13 := Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(2))): int);
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(ret#0);
    newtype$check#14 := $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#15 := $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#16 := Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__32();
    assume Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + $Unbox(Seq#Index(ret#0, LitInt(3))): int == x#0;
    assume false;
    return;

  anon4_Else:
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#17 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__32();
    assume LitInt(16777216) != 0;
    newtype$check#18 := Div(x#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#19 := Div(x#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#20 := Div(x#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0#0#0 == Div(x#0, LitInt(16777216));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0 == let#0#0#0;
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#21 := b0#Z#0;
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#22 := b0#Z#0;
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#23 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#24 := Mul(b0#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#25 := x#0 - Mul(b0#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == x#0 - Mul(b0#Z#0, LitInt(16777216));
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume x0#Z#0 == let#1#0#0;
    havoc b1#Z#0;
    assume LitInt(0) <= b1#Z#0 && b1#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#26 := LitInt(65536);
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < BoundedInts.__default.TWO__TO__THE__32();
    assume LitInt(65536) != 0;
    newtype$check#27 := Div(x0#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#28 := Div(x0#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#29 := Div(x0#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#29 && newtype$check#29 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#2#0#0 == Div(x0#Z#0, LitInt(65536));
    assume true;
    assume $Is(let#2#0#0, Tclass.BoundedInts.uint8());
    assume b1#Z#0 == let#2#0#0;
    havoc x1#Z#0;
    assume LitInt(0) <= x1#Z#0 && x1#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#30 := b1#Z#0;
    assume LitInt(0) <= newtype$check#30 && newtype$check#30 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#31 := b1#Z#0;
    assume LitInt(0) <= newtype$check#31 && newtype$check#31 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#32 := LitInt(65536);
    assume LitInt(0) <= newtype$check#32 && newtype$check#32 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#33 := Mul(b1#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#33 && newtype$check#33 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#34 := x0#Z#0 - Mul(b1#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#34 && newtype$check#34 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#3#0#0 == x0#Z#0 - Mul(b1#Z#0, LitInt(65536));
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint32());
    assume x1#Z#0 == let#3#0#0;
    havoc b2#Z#0;
    assume LitInt(0) <= b2#Z#0 && b2#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#35 := LitInt(256);
    assume LitInt(0) <= newtype$check#35 && newtype$check#35 < BoundedInts.__default.TWO__TO__THE__32();
    assume LitInt(256) != 0;
    newtype$check#36 := Div(x1#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#36 && newtype$check#36 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#37 := Div(x1#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#37 && newtype$check#37 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#38 := Div(x1#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#38 && newtype$check#38 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#4#0#0 == Div(x1#Z#0, LitInt(256));
    assume true;
    assume $Is(let#4#0#0, Tclass.BoundedInts.uint8());
    assume b2#Z#0 == let#4#0#0;
    havoc b3#Z#0;
    assume LitInt(0) <= b3#Z#0 && b3#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#39 := LitInt(256);
    assume LitInt(0) <= newtype$check#39 && newtype$check#39 < BoundedInts.__default.TWO__TO__THE__32();
    assume LitInt(256) != 0;
    newtype$check#40 := Mod(x1#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#40 && newtype$check#40 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#41 := Mod(x1#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#41 && newtype$check#41 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#42 := Mod(x1#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#42 && newtype$check#42 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#5#0#0 == Mod(x1#Z#0, LitInt(256));
    assume true;
    assume $Is(let#5#0#0, Tclass.BoundedInts.uint8());
    assume b3#Z#0 == let#5#0#0;
    assume StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#Z#0)), $Box(b1#Z#0)), $Box(b2#Z#0)), $Box(b3#Z#0));
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == ret#0;
    return;
}



function StandardLibrary_mUInt.__default.SeqToUInt32(s#0: Seq) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(StandardLibrary_mUInt.__default.SeqToUInt32(s#0)), s#0) && LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt32(s#0) && StandardLibrary_mUInt.__default.SeqToUInt32(s#0) < BoundedInts.__default.TWO__TO__THE__32());
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#0 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#0 := x0#0 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#0 := x1#0 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#0 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#1 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#1 := x0#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#1 := x1#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#1 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));
}

function StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0: Seq) : bool;

function StandardLibrary_mUInt.__default.SeqToUInt32#requires(Seq) : bool;

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (StandardLibrary_mUInt.__default.SeqToUInt32#requires(s#0) <==> Seq#Length(s#0) == LitInt(4)));

procedure {:verboseName "StandardLibrary.UInt.SeqToUInt32 (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToUInt32(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) returns (x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id255"} Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqToUInt32 (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToUInt32(s#0: Seq) returns (x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var x0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var x1#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var x2#Z#0: int;
  var let#2#0#0: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToUInt32", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(86,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(4);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt32(s#0) && StandardLibrary_mUInt.__default.SeqToUInt32(s#0) < BoundedInts.__default.TWO__TO__THE__32();
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0);
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), s#0);
    assume false;
    return;

  anon4_Else:
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#0#0#0 == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint32());
    assume x0#Z#0 == let#0#0#0;
    havoc x1#Z#0;
    assume LitInt(0) <= x1#Z#0 && x1#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#6 := LitInt(65536);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#8 := x0#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == x0#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536));
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume x1#Z#0 == let#1#0#0;
    havoc x2#Z#0;
    assume LitInt(0) <= x2#Z#0 && x2#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#11 := LitInt(256);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#12 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#13 := x1#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#2#0#0 == x1#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256));
    assume true;
    assume $Is(let#2#0#0, Tclass.BoundedInts.uint32());
    assume x2#Z#0 == let#2#0#0;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#14 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#16 := x2#Z#0 + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__32();
    assume StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == x2#Z#0 + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.SeqToUInt32(s#0), Tclass.BoundedInts.uint32());
    assume StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == x#0;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(96,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(97,40): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0);
    ##s#0 := StandardLibrary_mUInt.__default.UInt32ToSeq(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume StandardLibrary_mUInt.__default.SeqToUInt32#canCall(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0));
    assume StandardLibrary_mUInt.__default.SeqToUInt32(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0)) == x#0;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32());



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) && StandardLibrary_mUInt.__default.SeqToUInt32#canCall(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0));
  free ensures {:id "id289"} StandardLibrary_mUInt.__default.SeqToUInt32(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) && StandardLibrary_mUInt.__default.SeqToUInt32#canCall(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0));
  free ensures {:id "id290"} StandardLibrary_mUInt.__default.SeqToUInt32(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(98,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(100,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(4);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(102,40): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0);
    ##x#0 := StandardLibrary_mUInt.__default.SeqToUInt32(s#0);
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt32(s#0));
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(StandardLibrary_mUInt.__default.SeqToUInt32(s#0)), s#0);
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id294"} Seq#Length(s#0) == LitInt(4);



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) && StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt32(s#0));
  free ensures {:id "id295"} Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(StandardLibrary_mUInt.__default.SeqToUInt32(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id296"} Seq#Length(s#0) == LitInt(4);
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) && StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt32(s#0));
  free ensures {:id "id297"} Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(StandardLibrary_mUInt.__default.SeqToUInt32(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(103,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function StandardLibrary_mUInt.__default.UInt64ToSeq(x#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> Seq#Length(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0)) == LitInt(8) && Mul(LitInt(72057594037927936), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(6))): int) + $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(7))): int == x#0 && $Is(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#0 := Div(x#0, LitInt(72057594037927936)); (var x0#0 := x#0 - Mul(b0#0, LitInt(72057594037927936)); (var b1#0 := Div(x0#0, LitInt(281474976710656)); (var x1#0 := x0#0 - Mul(b1#0, LitInt(281474976710656)); (var b2#0 := Div(x1#0, LitInt(1099511627776)); (var x2#0 := x1#0 - Mul(b2#0, LitInt(1099511627776)); (var b3#0 := Div(x2#0, LitInt(4294967296)); (var x3#0 := x2#0 - Mul(b3#0, LitInt(4294967296)); (var b4#0 := Div(x3#0, LitInt(16777216)); (var x4#0 := x3#0 - Mul(b4#0, LitInt(16777216)); (var b5#0 := Div(x4#0, LitInt(65536)); (var x5#0 := x4#0 - Mul(b5#0, LitInt(65536)); (var b6#0 := Div(x5#0, LitInt(256)); (var b7#0 := Mod(x5#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0)), $Box(b1#0)), $Box(b2#0)), $Box(b3#0)), $Box(b4#0)), $Box(b5#0)), $Box(b6#0)), $Box(b7#0)))))))))))))))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#1 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#1 := LitInt(x#0 - Mul(b0#1, LitInt(72057594037927936))); (var b1#1 := LitInt(Div(x0#1, LitInt(281474976710656))); (var x1#1 := LitInt(x0#1 - Mul(b1#1, LitInt(281474976710656))); (var b2#1 := LitInt(Div(x1#1, LitInt(1099511627776))); (var x2#1 := LitInt(x1#1 - Mul(b2#1, LitInt(1099511627776))); (var b3#1 := LitInt(Div(x2#1, LitInt(4294967296))); (var x3#1 := LitInt(x2#1 - Mul(b3#1, LitInt(4294967296))); (var b4#1 := LitInt(Div(x3#1, LitInt(16777216))); (var x4#1 := LitInt(x3#1 - Mul(b4#1, LitInt(16777216))); (var b5#1 := LitInt(Div(x4#1, LitInt(65536))); (var x5#1 := LitInt(x4#1 - Mul(b5#1, LitInt(65536))); (var b6#1 := LitInt(Div(x5#1, LitInt(256))); (var b7#1 := LitInt(Mod(x5#1, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#1)), $Box(b1#1)), $Box(b2#1)), $Box(b3#1)), $Box(b4#1)), $Box(b5#1)), $Box(b6#1)), $Box(b7#1))))))))))))))))));
}

function StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0: int) : bool;

function StandardLibrary_mUInt.__default.UInt64ToSeq#requires(int) : bool;

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq#requires(x#0) } LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64() ==> (StandardLibrary_mUInt.__default.UInt64ToSeq#requires(x#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.UInt64ToSeq (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt64ToSeq(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id298"} Seq#Length(ret#0) == LitInt(8);
  free ensures {:id "id299"} Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(6))): int) + $Unbox(Seq#Index(ret#0, LitInt(7))): int == x#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64ToSeq (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.UInt64ToSeq(x#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;
  var newtype$check#29: int;
  var newtype$check#30: int;
  var newtype$check#31: int;
  var newtype$check#32: int;
  var newtype$check#33: int;
  var newtype$check#34: int;
  var newtype$check#35: int;
  var newtype$check#36: int;
  var b0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#37: int;
  var newtype$check#38: int;
  var newtype$check#39: int;
  var newtype$check#40: int;
  var x0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#41: int;
  var newtype$check#42: int;
  var newtype$check#43: int;
  var newtype$check#44: int;
  var newtype$check#45: int;
  var b1#Z#0: int;
  var let#2#0#0: int;
  var newtype$check#46: int;
  var newtype$check#47: int;
  var newtype$check#48: int;
  var newtype$check#49: int;
  var x1#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#50: int;
  var newtype$check#51: int;
  var newtype$check#52: int;
  var newtype$check#53: int;
  var newtype$check#54: int;
  var b2#Z#0: int;
  var let#4#0#0: int;
  var newtype$check#55: int;
  var newtype$check#56: int;
  var newtype$check#57: int;
  var newtype$check#58: int;
  var x2#Z#0: int;
  var let#5#0#0: int;
  var newtype$check#59: int;
  var newtype$check#60: int;
  var newtype$check#61: int;
  var newtype$check#62: int;
  var newtype$check#63: int;
  var b3#Z#0: int;
  var let#6#0#0: int;
  var newtype$check#64: int;
  var newtype$check#65: int;
  var newtype$check#66: int;
  var newtype$check#67: int;
  var x3#Z#0: int;
  var let#7#0#0: int;
  var newtype$check#68: int;
  var newtype$check#69: int;
  var newtype$check#70: int;
  var newtype$check#71: int;
  var newtype$check#72: int;
  var b4#Z#0: int;
  var let#8#0#0: int;
  var newtype$check#73: int;
  var newtype$check#74: int;
  var newtype$check#75: int;
  var newtype$check#76: int;
  var x4#Z#0: int;
  var let#9#0#0: int;
  var newtype$check#77: int;
  var newtype$check#78: int;
  var newtype$check#79: int;
  var newtype$check#80: int;
  var newtype$check#81: int;
  var b5#Z#0: int;
  var let#10#0#0: int;
  var newtype$check#82: int;
  var newtype$check#83: int;
  var newtype$check#84: int;
  var newtype$check#85: int;
  var x5#Z#0: int;
  var let#11#0#0: int;
  var newtype$check#86: int;
  var newtype$check#87: int;
  var newtype$check#88: int;
  var newtype$check#89: int;
  var newtype$check#90: int;
  var b6#Z#0: int;
  var let#12#0#0: int;
  var newtype$check#91: int;
  var newtype$check#92: int;
  var newtype$check#93: int;
  var newtype$check#94: int;
  var b7#Z#0: int;
  var let#13#0#0: int;
  var newtype$check#95: int;
  var newtype$check#96: int;
  var newtype$check#97: int;
  var newtype$check#98: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64ToSeq", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(105,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(ret#0) == LitInt(8);
    newtype$check#0 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    newtype$check#1 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#2 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#3 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#4 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(ret#0);
    newtype$check#5 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#6 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#7 := Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#8 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#9 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(ret#0);
    newtype$check#10 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#11 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#12 := Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#13 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int);
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#14 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(ret#0);
    newtype$check#15 := $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#16 := $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#17 := Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#18 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int);
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#19 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(4) && LitInt(4) < Seq#Length(ret#0);
    newtype$check#20 := $Unbox(Seq#Index(ret#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#21 := $Unbox(Seq#Index(ret#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#22 := Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int);
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#23 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int);
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#24 := LitInt(65536);
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(5) && LitInt(5) < Seq#Length(ret#0);
    newtype$check#25 := $Unbox(Seq#Index(ret#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#26 := $Unbox(Seq#Index(ret#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#27 := Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(5))): int);
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#28 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(5))): int);
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#29 := LitInt(256);
    assume LitInt(0) <= newtype$check#29 && newtype$check#29 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(6) && LitInt(6) < Seq#Length(ret#0);
    newtype$check#30 := $Unbox(Seq#Index(ret#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#30 && newtype$check#30 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#31 := $Unbox(Seq#Index(ret#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#31 && newtype$check#31 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#32 := Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(6))): int);
    assume LitInt(0) <= newtype$check#32 && newtype$check#32 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#33 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(6))): int);
    assume LitInt(0) <= newtype$check#33 && newtype$check#33 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(7) && LitInt(7) < Seq#Length(ret#0);
    newtype$check#34 := $Unbox(Seq#Index(ret#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#34 && newtype$check#34 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#35 := $Unbox(Seq#Index(ret#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#35 && newtype$check#35 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#36 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(6))): int) + $Unbox(Seq#Index(ret#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#36 && newtype$check#36 < BoundedInts.__default.TWO__TO__THE__64();
    assume Mul(LitInt(72057594037927936), $Unbox(Seq#Index(ret#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(ret#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(ret#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(ret#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(ret#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(ret#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(ret#0, LitInt(6))): int) + $Unbox(Seq#Index(ret#0, LitInt(7))): int == x#0;
    assume false;
    return;

  anon4_Else:
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#37 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#37 && newtype$check#37 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(72057594037927936) != 0;
    newtype$check#38 := Div(x#0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#38 && newtype$check#38 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#39 := Div(x#0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#39 && newtype$check#39 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#40 := Div(x#0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#40 && newtype$check#40 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0#0#0 == Div(x#0, LitInt(72057594037927936));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0 == let#0#0#0;
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#41 := b0#Z#0;
    assume LitInt(0) <= newtype$check#41 && newtype$check#41 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#42 := b0#Z#0;
    assume LitInt(0) <= newtype$check#42 && newtype$check#42 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#43 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#43 && newtype$check#43 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#44 := Mul(b0#Z#0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#44 && newtype$check#44 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#45 := x#0 - Mul(b0#Z#0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#45 && newtype$check#45 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#1#0#0 == x#0 - Mul(b0#Z#0, LitInt(72057594037927936));
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint64());
    assume x0#Z#0 == let#1#0#0;
    havoc b1#Z#0;
    assume LitInt(0) <= b1#Z#0 && b1#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#46 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#46 && newtype$check#46 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(281474976710656) != 0;
    newtype$check#47 := Div(x0#Z#0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#47 && newtype$check#47 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#48 := Div(x0#Z#0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#48 && newtype$check#48 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#49 := Div(x0#Z#0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#49 && newtype$check#49 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#2#0#0 == Div(x0#Z#0, LitInt(281474976710656));
    assume true;
    assume $Is(let#2#0#0, Tclass.BoundedInts.uint8());
    assume b1#Z#0 == let#2#0#0;
    havoc x1#Z#0;
    assume LitInt(0) <= x1#Z#0 && x1#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#50 := b1#Z#0;
    assume LitInt(0) <= newtype$check#50 && newtype$check#50 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#51 := b1#Z#0;
    assume LitInt(0) <= newtype$check#51 && newtype$check#51 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#52 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#52 && newtype$check#52 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#53 := Mul(b1#Z#0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#53 && newtype$check#53 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#54 := x0#Z#0 - Mul(b1#Z#0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#54 && newtype$check#54 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#3#0#0 == x0#Z#0 - Mul(b1#Z#0, LitInt(281474976710656));
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint64());
    assume x1#Z#0 == let#3#0#0;
    havoc b2#Z#0;
    assume LitInt(0) <= b2#Z#0 && b2#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#55 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#55 && newtype$check#55 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(1099511627776) != 0;
    newtype$check#56 := Div(x1#Z#0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#56 && newtype$check#56 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#57 := Div(x1#Z#0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#57 && newtype$check#57 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#58 := Div(x1#Z#0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#58 && newtype$check#58 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#4#0#0 == Div(x1#Z#0, LitInt(1099511627776));
    assume true;
    assume $Is(let#4#0#0, Tclass.BoundedInts.uint8());
    assume b2#Z#0 == let#4#0#0;
    havoc x2#Z#0;
    assume LitInt(0) <= x2#Z#0 && x2#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#59 := b2#Z#0;
    assume LitInt(0) <= newtype$check#59 && newtype$check#59 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#60 := b2#Z#0;
    assume LitInt(0) <= newtype$check#60 && newtype$check#60 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#61 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#61 && newtype$check#61 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#62 := Mul(b2#Z#0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#62 && newtype$check#62 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#63 := x1#Z#0 - Mul(b2#Z#0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#63 && newtype$check#63 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#5#0#0 == x1#Z#0 - Mul(b2#Z#0, LitInt(1099511627776));
    assume true;
    assume $Is(let#5#0#0, Tclass.BoundedInts.uint64());
    assume x2#Z#0 == let#5#0#0;
    havoc b3#Z#0;
    assume LitInt(0) <= b3#Z#0 && b3#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#64 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#64 && newtype$check#64 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(4294967296) != 0;
    newtype$check#65 := Div(x2#Z#0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#65 && newtype$check#65 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#66 := Div(x2#Z#0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#66 && newtype$check#66 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#67 := Div(x2#Z#0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#67 && newtype$check#67 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#6#0#0 == Div(x2#Z#0, LitInt(4294967296));
    assume true;
    assume $Is(let#6#0#0, Tclass.BoundedInts.uint8());
    assume b3#Z#0 == let#6#0#0;
    havoc x3#Z#0;
    assume LitInt(0) <= x3#Z#0 && x3#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#68 := b3#Z#0;
    assume LitInt(0) <= newtype$check#68 && newtype$check#68 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#69 := b3#Z#0;
    assume LitInt(0) <= newtype$check#69 && newtype$check#69 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#70 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#70 && newtype$check#70 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#71 := Mul(b3#Z#0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#71 && newtype$check#71 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#72 := x2#Z#0 - Mul(b3#Z#0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#72 && newtype$check#72 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#7#0#0 == x2#Z#0 - Mul(b3#Z#0, LitInt(4294967296));
    assume true;
    assume $Is(let#7#0#0, Tclass.BoundedInts.uint64());
    assume x3#Z#0 == let#7#0#0;
    havoc b4#Z#0;
    assume LitInt(0) <= b4#Z#0 && b4#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#73 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#73 && newtype$check#73 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(16777216) != 0;
    newtype$check#74 := Div(x3#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#74 && newtype$check#74 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#75 := Div(x3#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#75 && newtype$check#75 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#76 := Div(x3#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#76 && newtype$check#76 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#8#0#0 == Div(x3#Z#0, LitInt(16777216));
    assume true;
    assume $Is(let#8#0#0, Tclass.BoundedInts.uint8());
    assume b4#Z#0 == let#8#0#0;
    havoc x4#Z#0;
    assume LitInt(0) <= x4#Z#0 && x4#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#77 := b4#Z#0;
    assume LitInt(0) <= newtype$check#77 && newtype$check#77 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#78 := b4#Z#0;
    assume LitInt(0) <= newtype$check#78 && newtype$check#78 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#79 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#79 && newtype$check#79 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#80 := Mul(b4#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#80 && newtype$check#80 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#81 := x3#Z#0 - Mul(b4#Z#0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#81 && newtype$check#81 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#9#0#0 == x3#Z#0 - Mul(b4#Z#0, LitInt(16777216));
    assume true;
    assume $Is(let#9#0#0, Tclass.BoundedInts.uint64());
    assume x4#Z#0 == let#9#0#0;
    havoc b5#Z#0;
    assume LitInt(0) <= b5#Z#0 && b5#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#82 := LitInt(65536);
    assume LitInt(0) <= newtype$check#82 && newtype$check#82 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(65536) != 0;
    newtype$check#83 := Div(x4#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#83 && newtype$check#83 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#84 := Div(x4#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#84 && newtype$check#84 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#85 := Div(x4#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#85 && newtype$check#85 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#10#0#0 == Div(x4#Z#0, LitInt(65536));
    assume true;
    assume $Is(let#10#0#0, Tclass.BoundedInts.uint8());
    assume b5#Z#0 == let#10#0#0;
    havoc x5#Z#0;
    assume LitInt(0) <= x5#Z#0 && x5#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#86 := b5#Z#0;
    assume LitInt(0) <= newtype$check#86 && newtype$check#86 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#87 := b5#Z#0;
    assume LitInt(0) <= newtype$check#87 && newtype$check#87 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#88 := LitInt(65536);
    assume LitInt(0) <= newtype$check#88 && newtype$check#88 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#89 := Mul(b5#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#89 && newtype$check#89 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#90 := x4#Z#0 - Mul(b5#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#90 && newtype$check#90 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#11#0#0 == x4#Z#0 - Mul(b5#Z#0, LitInt(65536));
    assume true;
    assume $Is(let#11#0#0, Tclass.BoundedInts.uint64());
    assume x5#Z#0 == let#11#0#0;
    havoc b6#Z#0;
    assume LitInt(0) <= b6#Z#0 && b6#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#91 := LitInt(256);
    assume LitInt(0) <= newtype$check#91 && newtype$check#91 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(256) != 0;
    newtype$check#92 := Div(x5#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#92 && newtype$check#92 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#93 := Div(x5#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#93 && newtype$check#93 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#94 := Div(x5#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#94 && newtype$check#94 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#12#0#0 == Div(x5#Z#0, LitInt(256));
    assume true;
    assume $Is(let#12#0#0, Tclass.BoundedInts.uint8());
    assume b6#Z#0 == let#12#0#0;
    havoc b7#Z#0;
    assume LitInt(0) <= b7#Z#0 && b7#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#95 := LitInt(256);
    assume LitInt(0) <= newtype$check#95 && newtype$check#95 < BoundedInts.__default.TWO__TO__THE__64();
    assume LitInt(256) != 0;
    newtype$check#96 := Mod(x5#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#96 && newtype$check#96 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#97 := Mod(x5#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#97 && newtype$check#97 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#98 := Mod(x5#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#98 && newtype$check#98 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#13#0#0 == Mod(x5#Z#0, LitInt(256));
    assume true;
    assume $Is(let#13#0#0, Tclass.BoundedInts.uint8());
    assume b7#Z#0 == let#13#0#0;
    assume StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#Z#0)), $Box(b1#Z#0)), $Box(b2#Z#0)), $Box(b3#Z#0)), $Box(b4#Z#0)), $Box(b5#Z#0)), $Box(b6#Z#0)), $Box(b7#Z#0));
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == ret#0;
    return;
}



function StandardLibrary_mUInt.__default.SeqToUInt64(s#0: Seq) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(StandardLibrary_mUInt.__default.SeqToUInt64(s#0)), s#0) && LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt64(s#0) && StandardLibrary_mUInt.__default.SeqToUInt64(s#0) < BoundedInts.__default.TWO__TO__THE__64());
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#0 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#0 := x0#0 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#0 := x1#0 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#0 := x2#0 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#0 := x3#0 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#0 := x4#0 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#0 := x5#0 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#0 := x6#0 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#0)))))))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#1 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#1 := x0#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#1 := x1#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#1 := x2#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#1 := x3#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#1 := x4#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#1 := x5#1 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#1 := x6#1 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#1)))))))));
}

function StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0: Seq) : bool;

function StandardLibrary_mUInt.__default.SeqToUInt64#requires(Seq) : bool;

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (StandardLibrary_mUInt.__default.SeqToUInt64#requires(s#0) <==> Seq#Length(s#0) == LitInt(8)));

procedure {:verboseName "StandardLibrary.UInt.SeqToUInt64 (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToUInt64(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) returns (x#2: int where LitInt(0) <= x#2 && x#2 < BoundedInts.__default.TWO__TO__THE__64());
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id447"} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#2), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqToUInt64 (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToUInt64(s#0: Seq) returns (x#2: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var x0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var x1#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var x2#Z#0: int;
  var let#2#0#0: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var x3#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var x4#Z#0: int;
  var let#4#0#0: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var x5#Z#0: int;
  var let#5#0#0: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;
  var x6#Z#0: int;
  var let#6#0#0: int;
  var newtype$check#29: int;
  var newtype$check#30: int;
  var newtype$check#31: int;
  var newtype$check#32: int;
  var newtype$check#33: int;
  var x#Z#0: int;
  var let#7#0#0: int;
  var newtype$check#34: int;
  var newtype$check#35: int;
  var newtype$check#36: int;
  var x##0: int;
  var s##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToUInt64", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(134,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(8);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt64(s#0) && StandardLibrary_mUInt.__default.SeqToUInt64(s#0) < BoundedInts.__default.TWO__TO__THE__64();
    ##x#0 := x#2;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#2);
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#2), s#0);
    assume false;
    return;

  anon4_Else:
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#2 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0#0#0 == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint64());
    assume x0#Z#0 == let#0#0#0;
    havoc x1#Z#0;
    assume LitInt(0) <= x1#Z#0 && x1#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#6 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#8 := x0#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#1#0#0 == x0#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint64());
    assume x1#Z#0 == let#1#0#0;
    havoc x2#Z#0;
    assume LitInt(0) <= x2#Z#0 && x2#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#11 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#12 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#13 := x1#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#2#0#0 == x1#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume true;
    assume $Is(let#2#0#0, Tclass.BoundedInts.uint64());
    assume x2#Z#0 == let#2#0#0;
    havoc x3#Z#0;
    assume LitInt(0) <= x3#Z#0 && x3#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#14 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#16 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#17 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#18 := x2#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#3#0#0 == x2#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint64());
    assume x3#Z#0 == let#3#0#0;
    havoc x4#Z#0;
    assume LitInt(0) <= x4#Z#0 && x4#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#19 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#20 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#21 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#22 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#23 := x3#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#4#0#0 == x3#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume true;
    assume $Is(let#4#0#0, Tclass.BoundedInts.uint64());
    assume x4#Z#0 == let#4#0#0;
    havoc x5#Z#0;
    assume LitInt(0) <= x5#Z#0 && x5#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#24 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#25 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#26 := LitInt(65536);
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#27 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#28 := x4#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#5#0#0 == x4#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume true;
    assume $Is(let#5#0#0, Tclass.BoundedInts.uint64());
    assume x5#Z#0 == let#5#0#0;
    havoc x6#Z#0;
    assume LitInt(0) <= x6#Z#0 && x6#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#29 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#29 && newtype$check#29 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#30 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#30 && newtype$check#30 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#31 := LitInt(256);
    assume LitInt(0) <= newtype$check#31 && newtype$check#31 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#32 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#32 && newtype$check#32 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#33 := x5#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#33 && newtype$check#33 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#6#0#0 == x5#Z#0 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume true;
    assume $Is(let#6#0#0, Tclass.BoundedInts.uint64());
    assume x6#Z#0 == let#6#0#0;
    havoc x#Z#0;
    assume LitInt(0) <= x#Z#0 && x#Z#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#34 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#34 && newtype$check#34 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#35 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#35 && newtype$check#35 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#36 := x6#Z#0 + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#36 && newtype$check#36 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#7#0#0 == x6#Z#0 + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume true;
    assume $Is(let#7#0#0, Tclass.BoundedInts.uint64());
    assume x#Z#0 == let#7#0#0;
    assume true;
    x##0 := x#Z#0;
    assume true;
    s##0 := s#0;
    call CallPre$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x##0, s##0);
    call CallPost$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x##0, s##0);
    assume {:captureState "StandardLibrary/src/UInt.dfy(146,27)"} true;
    assume StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == x#Z#0;
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.SeqToUInt64(s#0), Tclass.BoundedInts.uint64());
    assume StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == x#2;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64(), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int, s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;
  var newtype$check#29: int;
  var newtype$check#30: int;
  var newtype$check#31: int;
  var newtype$check#32: int;
  var newtype$check#33: int;
  var newtype$check#34: int;
  var newtype$check#35: int;
  var newtype$check#36: int;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqSerialize", " | ", x#0, " | ", s#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(150,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(8);
    newtype$check#0 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#2 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#3 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#4 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#6 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#7 := Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#8 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#9 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#11 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#12 := Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#13 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int);
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#14 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#16 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#17 := Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#18 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int);
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#19 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#20 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#21 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#22 := Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int);
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#23 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int);
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#24 := LitInt(65536);
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#25 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#26 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#27 := Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int);
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#28 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int);
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#29 := LitInt(256);
    assume LitInt(0) <= newtype$check#29 && newtype$check#29 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#30 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#30 && newtype$check#30 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#31 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#31 && newtype$check#31 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#32 := Mul(LitInt(256), $Unbox(Seq#Index(s#0, LitInt(6))): int);
    assume LitInt(0) <= newtype$check#32 && newtype$check#32 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#33 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(s#0, LitInt(6))): int);
    assume LitInt(0) <= newtype$check#33 && newtype$check#33 < BoundedInts.__default.TWO__TO__THE__64();
    assume 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#34 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#34 && newtype$check#34 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#35 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#35 && newtype$check#35 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#36 := Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(s#0, LitInt(6))): int) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#36 && newtype$check#36 < BoundedInts.__default.TWO__TO__THE__64();
    assume Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(s#0, LitInt(6))): int) + $Unbox(Seq#Index(s#0, LitInt(7))): int == x#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(160,27): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), s#0);
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64(), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id563"} Seq#Length(s#0) == LitInt(8);
  requires {:id "id564"} Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(s#0, LitInt(6))): int) + $Unbox(Seq#Index(s#0, LitInt(7))): int == x#0;



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64(), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
  free ensures {:id "id565"} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64(), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id566"} Seq#Length(s#0) == LitInt(8);
  requires {:id "id567"} Mul(LitInt(72057594037927936), $Unbox(Seq#Index(s#0, LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(s#0, LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(s#0, LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(s#0, LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(s#0, LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(s#0, LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(s#0, LitInt(6))): int) + $Unbox(Seq#Index(s#0, LitInt(7))): int == x#0;
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
  free ensures {:id "id568"} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b0#Z#0_1_0: int;
  var let#0_1_0#0#0: int;
  var newtype$check#0_1_0: int;
  var newtype$check#0_1_1: int;
  var newtype$check#0_1_2: int;
  var newtype$check#0_1_3: int;
  var newtype$check#0_1_4: int;
  var newtype$check#0_1_5: int;
  var newtype$check#0_1_6: int;
  var newtype$check#0_1_7: int;
  var newtype$check#0_1_8: int;
  var newtype$check#0_1_9: int;
  var newtype$check#0_1_10: int;
  var newtype$check#0_1_11: int;
  var newtype$check#0_1_12: int;
  var newtype$check#0_1_13: int;
  var newtype$check#0_1_14: int;
  var newtype$check#0_1_15: int;
  var newtype$check#0_1_16: int;
  var newtype$check#0_1_17: int;
  var newtype$check#0_1_18: int;
  var newtype$check#0_1_19: int;
  var newtype$check#0_1_20: int;
  var newtype$check#0_1_21: int;
  var newtype$check#0_1_22: int;
  var newtype$check#0_1_23: int;
  var newtype$check#0_1_24: int;
  var newtype$check#0_1_25: int;
  var newtype$check#0_1_26: int;
  var newtype$check#0_1_27: int;
  var newtype$check#0_1_28: int;
  var newtype$check#0_1_29: int;
  var newtype$check#0_1_30: int;
  var newtype$check#0_1_31: int;
  var newtype$check#0_1_32: int;
  var newtype$check#0_1_33: int;
  var newtype$check#0_1_34: int;
  var newtype$check#0_1_35: int;
  var newtype$check#0_1_36: int;
  var newtype$check#0_1_37: int;
  var newtype$check#0_1_38: int;
  var newtype$check#0_1_39: int;
  var newtype$check#0_1_40: int;
  var x0#Z#0_1_0: int;
  var let#0_1_1#0#0: int;
  var newtype$check#0_1_41: int;
  var newtype$check#0_1_42: int;
  var newtype$check#0_1_43: int;
  var newtype$check#0_1_44: int;
  var newtype$check#0_1_45: int;
  var newtype$check#0_1_46: int;
  var newtype$check#0_1_47: int;
  var newtype$check#0_1_48: int;
  var newtype$check#0_1_49: int;
  var newtype$check#0_1_50: int;
  var newtype$check#0_1_51: int;
  var newtype$check#0_1_52: int;
  var newtype$check#0_1_53: int;
  var newtype$check#0_1_54: int;
  var newtype$check#0_1_55: int;
  var newtype$check#0_1_56: int;
  var newtype$check#0_1_57: int;
  var newtype$check#0_1_58: int;
  var newtype$check#0_1_59: int;
  var newtype$check#0_1_60: int;
  var newtype$check#0_1_61: int;
  var newtype$check#0_1_62: int;
  var newtype$check#0_1_63: int;
  var newtype$check#0_1_64: int;
  var newtype$check#0_1_65: int;
  var newtype$check#0_1_66: int;
  var newtype$check#0_1_67: int;
  var newtype$check#0_1_68: int;
  var newtype$check#0_1_69: int;
  var newtype$check#0_1_70: int;
  var newtype$check#0_1_71: int;
  var newtype$check#0_1_72: int;
  var newtype$check#0_1_73: int;
  var newtype$check#0_1_74: int;
  var newtype$check#0_1_75: int;
  var newtype$check#0_1_76: int;
  var newtype$check#0_1_77: int;
  var newtype$check#0_1_78: int;
  var newtype$check#0_1_79: int;
  var newtype$check#0_1_80: int;
  var newtype$check#0_1_81: int;
  var newtype$check#0_1_82: int;
  var newtype$check#0_1_83: int;
  var newtype$check#0_1_84: int;
  var newtype$check#0_1_85: int;
  var newtype$check#0_1_86: int;
  var newtype$check#0_1_87: int;
  var newtype$check#0_1_88: int;
  var newtype$check#0_1_89: int;
  var newtype$check#0_1_90: int;
  var newtype$check#0_1_91: int;
  var newtype$check#0_1_92: int;
  var newtype$check#0_1_93: int;
  var newtype$check#0_1_94: int;
  var newtype$check#0_1_95: int;
  var newtype$check#0_1_96: int;
  var newtype$check#0_1_97: int;
  var newtype$check#0_1_98: int;
  var newtype$check#0_1_99: int;
  var newtype$check#0_1_100: int;
  var newtype$check#0_1_101: int;
  var newtype$check#0_1_102: int;
  var newtype$check#0_1_103: int;
  var newtype$check#0_1_104: int;
  var newtype$check#0_1_105: int;
  var newtype$check#0_1_106: int;
  var newtype$check#0_1_107: int;
  var newtype$check#0_1_108: int;
  var newtype$check#0_1_109: int;
  var newtype$check#0_1_110: int;
  var newtype$check#0_1_111: int;
  var newtype$check#0_1_112: int;
  var newtype$check#0_1_113: int;
  var newtype$check#0_1_114: int;
  var b1#Z#0_1_0: int;
  var let#0_1_2#0#0: int;
  var newtype$check#0_1_115: int;
  var newtype$check#0_1_116: int;
  var newtype$check#0_1_117: int;
  var newtype$check#0_1_118: int;
  var x1#Z#0_1_0: int;
  var let#0_1_3#0#0: int;
  var newtype$check#0_1_119: int;
  var newtype$check#0_1_120: int;
  var newtype$check#0_1_121: int;
  var newtype$check#0_1_122: int;
  var newtype$check#0_1_123: int;
  var newtype$check#0_1_124: int;
  var newtype$check#0_1_125: int;
  var newtype$check#0_1_126: int;
  var newtype$check#0_1_127: int;
  var newtype$check#0_1_128: int;
  var newtype$check#0_1_129: int;
  var newtype$check#0_1_130: int;
  var newtype$check#0_1_131: int;
  var newtype$check#0_1_132: int;
  var newtype$check#0_1_133: int;
  var newtype$check#0_1_134: int;
  var newtype$check#0_1_135: int;
  var newtype$check#0_1_136: int;
  var newtype$check#0_1_137: int;
  var newtype$check#0_1_138: int;
  var newtype$check#0_1_139: int;
  var newtype$check#0_1_140: int;
  var newtype$check#0_1_141: int;
  var newtype$check#0_1_142: int;
  var newtype$check#0_1_143: int;
  var newtype$check#0_1_144: int;
  var newtype$check#0_1_145: int;
  var newtype$check#0_1_146: int;
  var newtype$check#0_1_147: int;
  var newtype$check#0_1_148: int;
  var newtype$check#0_1_149: int;
  var newtype$check#0_1_150: int;
  var b2#Z#0_1_0: int;
  var let#0_1_4#0#0: int;
  var newtype$check#0_1_151: int;
  var newtype$check#0_1_152: int;
  var newtype$check#0_1_153: int;
  var newtype$check#0_1_154: int;
  var x2#Z#0_1_0: int;
  var let#0_1_5#0#0: int;
  var newtype$check#0_1_155: int;
  var newtype$check#0_1_156: int;
  var newtype$check#0_1_157: int;
  var newtype$check#0_1_158: int;
  var newtype$check#0_1_159: int;
  var newtype$check#0_1_160: int;
  var newtype$check#0_1_161: int;
  var newtype$check#0_1_162: int;
  var newtype$check#0_1_163: int;
  var newtype$check#0_1_164: int;
  var newtype$check#0_1_165: int;
  var newtype$check#0_1_166: int;
  var newtype$check#0_1_167: int;
  var newtype$check#0_1_168: int;
  var newtype$check#0_1_169: int;
  var newtype$check#0_1_170: int;
  var newtype$check#0_1_171: int;
  var newtype$check#0_1_172: int;
  var newtype$check#0_1_173: int;
  var newtype$check#0_1_174: int;
  var newtype$check#0_1_175: int;
  var newtype$check#0_1_176: int;
  var newtype$check#0_1_177: int;
  var newtype$check#0_1_178: int;
  var newtype$check#0_1_179: int;
  var newtype$check#0_1_180: int;
  var newtype$check#0_1_181: int;
  var b3#Z#0_1_0: int;
  var let#0_1_6#0#0: int;
  var newtype$check#0_1_182: int;
  var newtype$check#0_1_183: int;
  var newtype$check#0_1_184: int;
  var newtype$check#0_1_185: int;
  var x3#Z#0_1_0: int;
  var let#0_1_7#0#0: int;
  var newtype$check#0_1_186: int;
  var newtype$check#0_1_187: int;
  var newtype$check#0_1_188: int;
  var newtype$check#0_1_189: int;
  var newtype$check#0_1_190: int;
  var newtype$check#0_1_191: int;
  var newtype$check#0_1_192: int;
  var newtype$check#0_1_193: int;
  var newtype$check#0_1_194: int;
  var newtype$check#0_1_195: int;
  var newtype$check#0_1_196: int;
  var newtype$check#0_1_197: int;
  var newtype$check#0_1_198: int;
  var newtype$check#0_1_199: int;
  var newtype$check#0_1_200: int;
  var newtype$check#0_1_201: int;
  var newtype$check#0_1_202: int;
  var newtype$check#0_1_203: int;
  var newtype$check#0_1_204: int;
  var newtype$check#0_1_205: int;
  var newtype$check#0_1_206: int;
  var newtype$check#0_1_207: int;
  var b4#Z#0_1_0: int;
  var let#0_1_8#0#0: int;
  var newtype$check#0_1_208: int;
  var newtype$check#0_1_209: int;
  var newtype$check#0_1_210: int;
  var newtype$check#0_1_211: int;
  var x4#Z#0_1_0: int;
  var let#0_1_9#0#0: int;
  var newtype$check#0_1_212: int;
  var newtype$check#0_1_213: int;
  var newtype$check#0_1_214: int;
  var newtype$check#0_1_215: int;
  var newtype$check#0_1_216: int;
  var newtype$check#0_1_217: int;
  var newtype$check#0_1_218: int;
  var newtype$check#0_1_219: int;
  var newtype$check#0_1_220: int;
  var newtype$check#0_1_221: int;
  var newtype$check#0_1_222: int;
  var newtype$check#0_1_223: int;
  var newtype$check#0_1_224: int;
  var newtype$check#0_1_225: int;
  var newtype$check#0_1_226: int;
  var newtype$check#0_1_227: int;
  var newtype$check#0_1_228: int;
  var b5#Z#0_1_0: int;
  var let#0_1_10#0#0: int;
  var newtype$check#0_1_229: int;
  var newtype$check#0_1_230: int;
  var newtype$check#0_1_231: int;
  var newtype$check#0_1_232: int;
  var x5#Z#0_1_0: int;
  var let#0_1_11#0#0: int;
  var newtype$check#0_1_233: int;
  var newtype$check#0_1_234: int;
  var newtype$check#0_1_235: int;
  var newtype$check#0_1_236: int;
  var newtype$check#0_1_237: int;
  var newtype$check#0_1_238: int;
  var newtype$check#0_1_239: int;
  var newtype$check#0_1_240: int;
  var newtype$check#0_1_241: int;
  var newtype$check#0_1_242: int;
  var newtype$check#0_1_243: int;
  var newtype$check#0_1_244: int;
  var b6#Z#0_1_0: int;
  var let#0_1_12#0#0: int;
  var newtype$check#0_1_245: int;
  var newtype$check#0_1_246: int;
  var newtype$check#0_1_247: int;
  var newtype$check#0_1_248: int;
  var b7#Z#0_1_0: int;
  var let#0_1_13#0#0: int;
  var newtype$check#0_1_249: int;
  var newtype$check#0_1_250: int;
  var newtype$check#0_1_251: int;
  var newtype$check#0_1_252: int;
  var newtype$check#0_2_0: int;
  var newtype$check#0_2_1: int;
  var newtype$check#0_2_2: int;
  var newtype$check#0_2_3: int;
  var newtype$check#0_2_4: int;
  var newtype$check#0_2_5: int;
  var newtype$check#0_2_6: int;
  var newtype$check#0_2_7: int;
  var newtype$check#0_2_8: int;
  var newtype$check#0_2_9: int;
  var newtype$check#0_2_10: int;
  var newtype$check#0_2_11: int;
  var newtype$check#0_2_12: int;
  var newtype$check#0_2_13: int;
  var newtype$check#0_2_14: int;
  var newtype$check#0_2_15: int;
  var newtype$check#0_2_16: int;
  var newtype$check#0_2_17: int;
  var newtype$check#0_2_18: int;
  var newtype$check#0_2_19: int;
  var newtype$check#0_2_20: int;
  var newtype$check#0_2_21: int;
  var newtype$check#0_2_22: int;
  var newtype$check#0_2_23: int;
  var newtype$check#0_2_24: int;
  var newtype$check#0_2_25: int;
  var newtype$check#0_2_26: int;
  var newtype$check#0_2_27: int;
  var newtype$check#0_2_28: int;
  var newtype$check#0_2_29: int;
  var newtype$check#0_2_30: int;
  var newtype$check#0_2_31: int;
  var newtype$check#0_2_32: int;
  var newtype$check#0_2_33: int;
  var newtype$check#0_2_34: int;
  var newtype$check#0_2_35: int;
  var newtype$check#0_2_36: int;
  var ##x#0_2_0: int;
  var b0#Z#0_2_0: int;
  var let#0_2_0#0#0: int;
  var newtype$check#0_2_37: int;
  var newtype$check#0_2_38: int;
  var newtype$check#0_2_39: int;
  var newtype$check#0_2_40: int;
  var newtype$check#0_2_41: int;
  var newtype$check#0_2_42: int;
  var newtype$check#0_2_43: int;
  var newtype$check#0_2_44: int;
  var newtype$check#0_2_45: int;
  var newtype$check#0_2_46: int;
  var newtype$check#0_2_47: int;
  var newtype$check#0_2_48: int;
  var newtype$check#0_2_49: int;
  var newtype$check#0_2_50: int;
  var newtype$check#0_2_51: int;
  var newtype$check#0_2_52: int;
  var newtype$check#0_2_53: int;
  var newtype$check#0_2_54: int;
  var newtype$check#0_2_55: int;
  var newtype$check#0_2_56: int;
  var newtype$check#0_2_57: int;
  var newtype$check#0_2_58: int;
  var newtype$check#0_2_59: int;
  var newtype$check#0_2_60: int;
  var newtype$check#0_2_61: int;
  var newtype$check#0_2_62: int;
  var newtype$check#0_2_63: int;
  var newtype$check#0_2_64: int;
  var newtype$check#0_2_65: int;
  var newtype$check#0_2_66: int;
  var newtype$check#0_2_67: int;
  var newtype$check#0_2_68: int;
  var newtype$check#0_2_69: int;
  var newtype$check#0_2_70: int;
  var newtype$check#0_2_71: int;
  var newtype$check#0_2_72: int;
  var newtype$check#0_2_73: int;
  var newtype$check#0_2_74: int;
  var newtype$check#0_2_75: int;
  var newtype$check#0_2_76: int;
  var newtype$check#0_2_77: int;
  var x0#Z#0_2_0: int;
  var let#0_2_1#0#0: int;
  var newtype$check#0_2_78: int;
  var newtype$check#0_2_79: int;
  var newtype$check#0_2_80: int;
  var newtype$check#0_2_81: int;
  var newtype$check#0_2_82: int;
  var newtype$check#0_2_83: int;
  var newtype$check#0_2_84: int;
  var newtype$check#0_2_85: int;
  var newtype$check#0_2_86: int;
  var newtype$check#0_2_87: int;
  var newtype$check#0_2_88: int;
  var newtype$check#0_2_89: int;
  var newtype$check#0_2_90: int;
  var newtype$check#0_2_91: int;
  var newtype$check#0_2_92: int;
  var newtype$check#0_2_93: int;
  var newtype$check#0_2_94: int;
  var newtype$check#0_2_95: int;
  var newtype$check#0_2_96: int;
  var newtype$check#0_2_97: int;
  var newtype$check#0_2_98: int;
  var newtype$check#0_2_99: int;
  var newtype$check#0_2_100: int;
  var newtype$check#0_2_101: int;
  var newtype$check#0_2_102: int;
  var newtype$check#0_2_103: int;
  var newtype$check#0_2_104: int;
  var newtype$check#0_2_105: int;
  var newtype$check#0_2_106: int;
  var newtype$check#0_2_107: int;
  var newtype$check#0_2_108: int;
  var newtype$check#0_2_109: int;
  var newtype$check#0_2_110: int;
  var newtype$check#0_2_111: int;
  var newtype$check#0_2_112: int;
  var newtype$check#0_2_113: int;
  var newtype$check#0_2_114: int;
  var newtype$check#0_2_115: int;
  var newtype$check#0_2_116: int;
  var newtype$check#0_2_117: int;
  var newtype$check#0_2_118: int;
  var newtype$check#0_2_119: int;
  var newtype$check#0_2_120: int;
  var newtype$check#0_2_121: int;
  var newtype$check#0_2_122: int;
  var newtype$check#0_2_123: int;
  var newtype$check#0_2_124: int;
  var newtype$check#0_2_125: int;
  var newtype$check#0_2_126: int;
  var newtype$check#0_2_127: int;
  var newtype$check#0_2_128: int;
  var newtype$check#0_2_129: int;
  var newtype$check#0_2_130: int;
  var newtype$check#0_2_131: int;
  var newtype$check#0_2_132: int;
  var newtype$check#0_2_133: int;
  var newtype$check#0_2_134: int;
  var newtype$check#0_2_135: int;
  var newtype$check#0_2_136: int;
  var newtype$check#0_2_137: int;
  var newtype$check#0_2_138: int;
  var newtype$check#0_2_139: int;
  var newtype$check#0_2_140: int;
  var newtype$check#0_2_141: int;
  var newtype$check#0_2_142: int;
  var newtype$check#0_2_143: int;
  var newtype$check#0_2_144: int;
  var newtype$check#0_2_145: int;
  var newtype$check#0_2_146: int;
  var newtype$check#0_2_147: int;
  var newtype$check#0_2_148: int;
  var newtype$check#0_2_149: int;
  var newtype$check#0_2_150: int;
  var newtype$check#0_2_151: int;
  var b1#Z#0_2_0: int;
  var let#0_2_2#0#0: int;
  var newtype$check#0_2_152: int;
  var newtype$check#0_2_153: int;
  var newtype$check#0_2_154: int;
  var newtype$check#0_2_155: int;
  var x1#Z#0_2_0: int;
  var let#0_2_3#0#0: int;
  var newtype$check#0_2_156: int;
  var newtype$check#0_2_157: int;
  var newtype$check#0_2_158: int;
  var newtype$check#0_2_159: int;
  var newtype$check#0_2_160: int;
  var newtype$check#0_2_161: int;
  var newtype$check#0_2_162: int;
  var newtype$check#0_2_163: int;
  var newtype$check#0_2_164: int;
  var newtype$check#0_2_165: int;
  var newtype$check#0_2_166: int;
  var newtype$check#0_2_167: int;
  var newtype$check#0_2_168: int;
  var newtype$check#0_2_169: int;
  var newtype$check#0_2_170: int;
  var newtype$check#0_2_171: int;
  var newtype$check#0_2_172: int;
  var newtype$check#0_2_173: int;
  var newtype$check#0_2_174: int;
  var newtype$check#0_2_175: int;
  var newtype$check#0_2_176: int;
  var newtype$check#0_2_177: int;
  var newtype$check#0_2_178: int;
  var newtype$check#0_2_179: int;
  var newtype$check#0_2_180: int;
  var newtype$check#0_2_181: int;
  var newtype$check#0_2_182: int;
  var newtype$check#0_2_183: int;
  var newtype$check#0_2_184: int;
  var newtype$check#0_2_185: int;
  var newtype$check#0_2_186: int;
  var newtype$check#0_2_187: int;
  var b2#Z#0_2_0: int;
  var let#0_2_4#0#0: int;
  var newtype$check#0_2_188: int;
  var newtype$check#0_2_189: int;
  var newtype$check#0_2_190: int;
  var newtype$check#0_2_191: int;
  var x2#Z#0_2_0: int;
  var let#0_2_5#0#0: int;
  var newtype$check#0_2_192: int;
  var newtype$check#0_2_193: int;
  var newtype$check#0_2_194: int;
  var newtype$check#0_2_195: int;
  var newtype$check#0_2_196: int;
  var newtype$check#0_2_197: int;
  var newtype$check#0_2_198: int;
  var newtype$check#0_2_199: int;
  var newtype$check#0_2_200: int;
  var newtype$check#0_2_201: int;
  var newtype$check#0_2_202: int;
  var newtype$check#0_2_203: int;
  var newtype$check#0_2_204: int;
  var newtype$check#0_2_205: int;
  var newtype$check#0_2_206: int;
  var newtype$check#0_2_207: int;
  var newtype$check#0_2_208: int;
  var newtype$check#0_2_209: int;
  var newtype$check#0_2_210: int;
  var newtype$check#0_2_211: int;
  var newtype$check#0_2_212: int;
  var newtype$check#0_2_213: int;
  var newtype$check#0_2_214: int;
  var newtype$check#0_2_215: int;
  var newtype$check#0_2_216: int;
  var newtype$check#0_2_217: int;
  var newtype$check#0_2_218: int;
  var b3#Z#0_2_0: int;
  var let#0_2_6#0#0: int;
  var newtype$check#0_2_219: int;
  var newtype$check#0_2_220: int;
  var newtype$check#0_2_221: int;
  var newtype$check#0_2_222: int;
  var x3#Z#0_2_0: int;
  var let#0_2_7#0#0: int;
  var newtype$check#0_2_223: int;
  var newtype$check#0_2_224: int;
  var newtype$check#0_2_225: int;
  var newtype$check#0_2_226: int;
  var newtype$check#0_2_227: int;
  var newtype$check#0_2_228: int;
  var newtype$check#0_2_229: int;
  var newtype$check#0_2_230: int;
  var newtype$check#0_2_231: int;
  var newtype$check#0_2_232: int;
  var newtype$check#0_2_233: int;
  var newtype$check#0_2_234: int;
  var newtype$check#0_2_235: int;
  var newtype$check#0_2_236: int;
  var newtype$check#0_2_237: int;
  var newtype$check#0_2_238: int;
  var newtype$check#0_2_239: int;
  var newtype$check#0_2_240: int;
  var newtype$check#0_2_241: int;
  var newtype$check#0_2_242: int;
  var newtype$check#0_2_243: int;
  var newtype$check#0_2_244: int;
  var b4#Z#0_2_0: int;
  var let#0_2_8#0#0: int;
  var newtype$check#0_2_245: int;
  var newtype$check#0_2_246: int;
  var newtype$check#0_2_247: int;
  var newtype$check#0_2_248: int;
  var x4#Z#0_2_0: int;
  var let#0_2_9#0#0: int;
  var newtype$check#0_2_249: int;
  var newtype$check#0_2_250: int;
  var newtype$check#0_2_251: int;
  var newtype$check#0_2_252: int;
  var newtype$check#0_2_253: int;
  var newtype$check#0_2_254: int;
  var newtype$check#0_2_255: int;
  var newtype$check#0_2_256: int;
  var newtype$check#0_2_257: int;
  var newtype$check#0_2_258: int;
  var newtype$check#0_2_259: int;
  var newtype$check#0_2_260: int;
  var newtype$check#0_2_261: int;
  var newtype$check#0_2_262: int;
  var newtype$check#0_2_263: int;
  var newtype$check#0_2_264: int;
  var newtype$check#0_2_265: int;
  var b5#Z#0_2_0: int;
  var let#0_2_10#0#0: int;
  var newtype$check#0_2_266: int;
  var newtype$check#0_2_267: int;
  var newtype$check#0_2_268: int;
  var newtype$check#0_2_269: int;
  var x5#Z#0_2_0: int;
  var let#0_2_11#0#0: int;
  var newtype$check#0_2_270: int;
  var newtype$check#0_2_271: int;
  var newtype$check#0_2_272: int;
  var newtype$check#0_2_273: int;
  var newtype$check#0_2_274: int;
  var newtype$check#0_2_275: int;
  var newtype$check#0_2_276: int;
  var newtype$check#0_2_277: int;
  var newtype$check#0_2_278: int;
  var newtype$check#0_2_279: int;
  var newtype$check#0_2_280: int;
  var newtype$check#0_2_281: int;
  var b6#Z#0_2_0: int;
  var let#0_2_12#0#0: int;
  var newtype$check#0_2_282: int;
  var newtype$check#0_2_283: int;
  var newtype$check#0_2_284: int;
  var newtype$check#0_2_285: int;
  var b7#Z#0_2_0: int;
  var let#0_2_13#0#0: int;
  var newtype$check#0_2_286: int;
  var newtype$check#0_2_287: int;
  var newtype$check#0_2_288: int;
  var newtype$check#0_2_289: int;
  var ##x#0_3_0: int;
  var newtype$check#0_3_0: int;
  var newtype$check#0_3_1: int;
  var newtype$check#0_3_2: int;
  var newtype$check#0_3_3: int;
  var newtype$check#0_3_4: int;
  var newtype$check#0_3_5: int;
  var newtype$check#0_3_6: int;
  var newtype$check#0_3_7: int;
  var newtype$check#0_3_8: int;
  var newtype$check#0_3_9: int;
  var newtype$check#0_3_10: int;
  var newtype$check#0_3_11: int;
  var newtype$check#0_3_12: int;
  var newtype$check#0_3_13: int;
  var newtype$check#0_3_14: int;
  var newtype$check#0_3_15: int;
  var newtype$check#0_3_16: int;
  var newtype$check#0_3_17: int;
  var newtype$check#0_3_18: int;
  var newtype$check#0_3_19: int;
  var newtype$check#0_3_20: int;
  var newtype$check#0_3_21: int;
  var newtype$check#0_3_22: int;
  var newtype$check#0_3_23: int;
  var newtype$check#0_3_24: int;
  var newtype$check#0_3_25: int;
  var newtype$check#0_3_26: int;
  var newtype$check#0_3_27: int;
  var newtype$check#0_3_28: int;
  var newtype$check#0_3_29: int;
  var newtype$check#0_3_30: int;
  var newtype$check#0_3_31: int;
  var newtype$check#0_3_32: int;
  var newtype$check#0_3_33: int;
  var newtype$check#0_3_34: int;
  var newtype$check#0_3_35: int;
  var newtype$check#0_3_36: int;
  var ##x#0_3_1: int;
  var ##x#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqSerialize", " | ", x#0, " | ", s#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(161,2): initial state"} true;
    $_reverifyPost := false;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##x#0_0 := x#0;
    assume $IsAlloc(##x#0_0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
    assume false;
    goto anon6;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    ##x#0_3_0 := x#0;
    assume $IsAlloc(##x#0_3_0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_3_0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_3_0 && newtype$check#0_3_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_3_1 && newtype$check#0_3_1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_2 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_3_2 && newtype$check#0_3_2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_3_3 && newtype$check#0_3_3 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_3_4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_3_4 && newtype$check#0_3_4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_3_5 && newtype$check#0_3_5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_6 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_3_6 && newtype$check#0_3_6 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_3_7 && newtype$check#0_3_7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_3_8 && newtype$check#0_3_8 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_3_9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_3_9 && newtype$check#0_3_9 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_3_10 && newtype$check#0_3_10 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_11 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_3_11 && newtype$check#0_3_11 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_12 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_3_12 && newtype$check#0_3_12 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_13 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_3_13 && newtype$check#0_3_13 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_3_14 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_3_14 && newtype$check#0_3_14 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_3_15 && newtype$check#0_3_15 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_16 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_3_16 && newtype$check#0_3_16 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_17 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_3_17 && newtype$check#0_3_17 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_18 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_3_18 && newtype$check#0_3_18 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_3_19 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_3_19 && newtype$check#0_3_19 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_20 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_3_20 && newtype$check#0_3_20 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_21 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_3_21 && newtype$check#0_3_21 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_22 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_3_22 && newtype$check#0_3_22 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_23 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_3_23 && newtype$check#0_3_23 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_3_24 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_3_24 && newtype$check#0_3_24 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_25 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_3_25 && newtype$check#0_3_25 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_26 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_3_26 && newtype$check#0_3_26 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_27 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_3_27 && newtype$check#0_3_27 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_28 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_3_28 && newtype$check#0_3_28 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_3_29 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_3_29 && newtype$check#0_3_29 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_30 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_3_30 && newtype$check#0_3_30 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_31 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_3_31 && newtype$check#0_3_31 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_32 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_3_32 && newtype$check#0_3_32 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_33 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_3_33 && newtype$check#0_3_33 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_3_34 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_3_34 && newtype$check#0_3_34 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_35 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_3_35 && newtype$check#0_3_35 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_3_36 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_3_36 && newtype$check#0_3_36 < BoundedInts.__default.TWO__TO__THE__64();
    ##x#0_3_1 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume $IsAlloc(##x#0_3_1, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int);
    assume {:subsumption 0} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), StandardLibrary_mUInt.__default.UInt64ToSeq(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int));
    assume false;
    goto anon6;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_2_0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_2_0 && newtype$check#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_2_1 && newtype$check#0_2_1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_2 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_2_2 && newtype$check#0_2_2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_3 && newtype$check#0_2_3 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_2_4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_4 && newtype$check#0_2_4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_5 && newtype$check#0_2_5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_6 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_2_6 && newtype$check#0_2_6 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_7 && newtype$check#0_2_7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_8 && newtype$check#0_2_8 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_2_9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_9 && newtype$check#0_2_9 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_10 && newtype$check#0_2_10 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_11 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_11 && newtype$check#0_2_11 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_12 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_12 && newtype$check#0_2_12 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_13 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_13 && newtype$check#0_2_13 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_2_14 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_14 && newtype$check#0_2_14 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_15 && newtype$check#0_2_15 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_16 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_16 && newtype$check#0_2_16 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_17 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_17 && newtype$check#0_2_17 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_18 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_18 && newtype$check#0_2_18 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_19 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_19 && newtype$check#0_2_19 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_20 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_20 && newtype$check#0_2_20 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_21 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_21 && newtype$check#0_2_21 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_22 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_22 && newtype$check#0_2_22 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_23 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_23 && newtype$check#0_2_23 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_24 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_24 && newtype$check#0_2_24 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_25 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_25 && newtype$check#0_2_25 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_26 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_26 && newtype$check#0_2_26 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_27 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_27 && newtype$check#0_2_27 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_28 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_28 && newtype$check#0_2_28 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_29 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_29 && newtype$check#0_2_29 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_30 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_30 && newtype$check#0_2_30 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_31 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_31 && newtype$check#0_2_31 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_32 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_32 && newtype$check#0_2_32 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_33 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_33 && newtype$check#0_2_33 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_34 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_34 && newtype$check#0_2_34 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_35 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_35 && newtype$check#0_2_35 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_36 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_36 && newtype$check#0_2_36 < BoundedInts.__default.TWO__TO__THE__64();
    ##x#0_2_0 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume $IsAlloc(##x#0_2_0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int);
    havoc b0#Z#0_2_0;
    assume LitInt(0) <= b0#Z#0_2_0 && b0#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_2_37 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_2_37 && newtype$check#0_2_37 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_38 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_2_38 && newtype$check#0_2_38 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_39 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_2_39 && newtype$check#0_2_39 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_40 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_40 && newtype$check#0_2_40 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_2_41 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_41 && newtype$check#0_2_41 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_42 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_42 && newtype$check#0_2_42 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_43 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_2_43 && newtype$check#0_2_43 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_44 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_44 && newtype$check#0_2_44 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_45 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_45 && newtype$check#0_2_45 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_2_46 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_46 && newtype$check#0_2_46 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_47 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_47 && newtype$check#0_2_47 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_48 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_48 && newtype$check#0_2_48 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_49 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_49 && newtype$check#0_2_49 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_50 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_50 && newtype$check#0_2_50 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_2_51 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_51 && newtype$check#0_2_51 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_52 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_52 && newtype$check#0_2_52 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_53 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_53 && newtype$check#0_2_53 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_54 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_54 && newtype$check#0_2_54 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_55 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_55 && newtype$check#0_2_55 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_56 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_56 && newtype$check#0_2_56 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_57 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_57 && newtype$check#0_2_57 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_58 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_58 && newtype$check#0_2_58 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_59 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_59 && newtype$check#0_2_59 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_60 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_60 && newtype$check#0_2_60 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_61 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_61 && newtype$check#0_2_61 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_62 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_62 && newtype$check#0_2_62 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_63 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_63 && newtype$check#0_2_63 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_64 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_64 && newtype$check#0_2_64 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_65 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_65 && newtype$check#0_2_65 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_66 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_66 && newtype$check#0_2_66 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_67 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_67 && newtype$check#0_2_67 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_68 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_68 && newtype$check#0_2_68 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_69 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_69 && newtype$check#0_2_69 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_70 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_70 && newtype$check#0_2_70 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_71 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_71 && newtype$check#0_2_71 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_72 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_72 && newtype$check#0_2_72 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_73 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_73 && newtype$check#0_2_73 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_74 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_2_74 && newtype$check#0_2_74 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(72057594037927936) != 0;
    newtype$check#0_2_75 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_75 && newtype$check#0_2_75 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_76 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_76 && newtype$check#0_2_76 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_77 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_77 && newtype$check#0_2_77 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_0#0#0 == Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume true;
    assume $Is(let#0_2_0#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0_2_0 == let#0_2_0#0#0;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume true;
    assume b0#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(182,23)"} true;
    havoc x0#Z#0_2_0;
    assume LitInt(0) <= x0#Z#0_2_0 && x0#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_2_78 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_2_78 && newtype$check#0_2_78 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_79 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_2_79 && newtype$check#0_2_79 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_80 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_2_80 && newtype$check#0_2_80 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_81 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_81 && newtype$check#0_2_81 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_2_82 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_82 && newtype$check#0_2_82 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_83 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_83 && newtype$check#0_2_83 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_84 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_2_84 && newtype$check#0_2_84 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_85 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_85 && newtype$check#0_2_85 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_86 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_86 && newtype$check#0_2_86 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_2_87 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_87 && newtype$check#0_2_87 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_88 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_88 && newtype$check#0_2_88 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_89 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_89 && newtype$check#0_2_89 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_90 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_90 && newtype$check#0_2_90 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_91 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_91 && newtype$check#0_2_91 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_2_92 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_92 && newtype$check#0_2_92 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_93 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_93 && newtype$check#0_2_93 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_94 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_94 && newtype$check#0_2_94 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_95 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_95 && newtype$check#0_2_95 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_96 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_96 && newtype$check#0_2_96 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_97 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_97 && newtype$check#0_2_97 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_98 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_98 && newtype$check#0_2_98 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_99 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_99 && newtype$check#0_2_99 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_100 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_100 && newtype$check#0_2_100 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_101 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_101 && newtype$check#0_2_101 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_102 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_102 && newtype$check#0_2_102 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_103 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_103 && newtype$check#0_2_103 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_104 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_104 && newtype$check#0_2_104 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_105 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_105 && newtype$check#0_2_105 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_106 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_106 && newtype$check#0_2_106 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_107 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_107 && newtype$check#0_2_107 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_108 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_108 && newtype$check#0_2_108 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_109 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_109 && newtype$check#0_2_109 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_110 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_110 && newtype$check#0_2_110 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_111 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_111 && newtype$check#0_2_111 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_112 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_112 && newtype$check#0_2_112 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_113 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_113 && newtype$check#0_2_113 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_114 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_114 && newtype$check#0_2_114 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_115 := b0#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_115 && newtype$check#0_2_115 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_116 := b0#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_116 && newtype$check#0_2_116 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_117 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_2_117 && newtype$check#0_2_117 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_118 := Mul(b0#Z#0_2_0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_118 && newtype$check#0_2_118 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_119 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int - Mul(b0#Z#0_2_0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_2_119 && newtype$check#0_2_119 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_2_1#0#0 == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int - Mul(b0#Z#0_2_0, LitInt(72057594037927936));
    assume true;
    assume $Is(let#0_2_1#0#0, Tclass.BoundedInts.uint64());
    assume x0#Z#0_2_0 == let#0_2_1#0#0;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_2_120 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_120 && newtype$check#0_2_120 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_121 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_2_121 && newtype$check#0_2_121 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_122 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_2_122 && newtype$check#0_2_122 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_123 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_123 && newtype$check#0_2_123 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_2_124 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_124 && newtype$check#0_2_124 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_125 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_125 && newtype$check#0_2_125 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_126 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_126 && newtype$check#0_2_126 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_127 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_127 && newtype$check#0_2_127 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_128 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_128 && newtype$check#0_2_128 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_2_129 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_129 && newtype$check#0_2_129 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_130 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_130 && newtype$check#0_2_130 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_131 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_131 && newtype$check#0_2_131 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_132 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_132 && newtype$check#0_2_132 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_133 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_133 && newtype$check#0_2_133 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_134 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_134 && newtype$check#0_2_134 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_135 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_135 && newtype$check#0_2_135 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_136 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_136 && newtype$check#0_2_136 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_137 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_137 && newtype$check#0_2_137 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_138 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_138 && newtype$check#0_2_138 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_139 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_139 && newtype$check#0_2_139 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_140 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_140 && newtype$check#0_2_140 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_141 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_141 && newtype$check#0_2_141 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_142 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_142 && newtype$check#0_2_142 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_143 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_143 && newtype$check#0_2_143 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_144 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_144 && newtype$check#0_2_144 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_145 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_145 && newtype$check#0_2_145 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_146 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_146 && newtype$check#0_2_146 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_147 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_147 && newtype$check#0_2_147 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_148 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_148 && newtype$check#0_2_148 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_149 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_149 && newtype$check#0_2_149 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_150 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_150 && newtype$check#0_2_150 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_151 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_151 && newtype$check#0_2_151 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x0#Z#0_2_0 == Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(197,37)"} true;
    havoc b1#Z#0_2_0;
    assume LitInt(0) <= b1#Z#0_2_0 && b1#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_152 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_2_152 && newtype$check#0_2_152 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(281474976710656) != 0;
    newtype$check#0_2_153 := Div(x0#Z#0_2_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_153 && newtype$check#0_2_153 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_154 := Div(x0#Z#0_2_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_154 && newtype$check#0_2_154 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_155 := Div(x0#Z#0_2_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_155 && newtype$check#0_2_155 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_2#0#0 == Div(x0#Z#0_2_0, LitInt(281474976710656));
    assume true;
    assume $Is(let#0_2_2#0#0, Tclass.BoundedInts.uint8());
    assume b1#Z#0_2_0 == let#0_2_2#0#0;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume true;
    assume b1#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(200,23)"} true;
    havoc x1#Z#0_2_0;
    assume LitInt(0) <= x1#Z#0_2_0 && x1#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_156 := b1#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_156 && newtype$check#0_2_156 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_157 := b1#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_157 && newtype$check#0_2_157 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_158 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_2_158 && newtype$check#0_2_158 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_159 := Mul(b1#Z#0_2_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_159 && newtype$check#0_2_159 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_160 := x0#Z#0_2_0 - Mul(b1#Z#0_2_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_2_160 && newtype$check#0_2_160 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_2_3#0#0 == x0#Z#0_2_0 - Mul(b1#Z#0_2_0, LitInt(281474976710656));
    assume true;
    assume $Is(let#0_2_3#0#0, Tclass.BoundedInts.uint64());
    assume x1#Z#0_2_0 == let#0_2_3#0#0;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_2_161 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_161 && newtype$check#0_2_161 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_162 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_2_162 && newtype$check#0_2_162 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_163 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_163 && newtype$check#0_2_163 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_164 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_164 && newtype$check#0_2_164 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_2_165 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_165 && newtype$check#0_2_165 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_166 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_166 && newtype$check#0_2_166 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_167 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_167 && newtype$check#0_2_167 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_168 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_168 && newtype$check#0_2_168 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_169 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_169 && newtype$check#0_2_169 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_170 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_170 && newtype$check#0_2_170 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_171 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_171 && newtype$check#0_2_171 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_172 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_172 && newtype$check#0_2_172 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_173 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_173 && newtype$check#0_2_173 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_174 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_174 && newtype$check#0_2_174 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_175 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_175 && newtype$check#0_2_175 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_176 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_176 && newtype$check#0_2_176 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_177 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_177 && newtype$check#0_2_177 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_178 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_178 && newtype$check#0_2_178 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_179 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_179 && newtype$check#0_2_179 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_180 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_180 && newtype$check#0_2_180 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_181 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_181 && newtype$check#0_2_181 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_182 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_182 && newtype$check#0_2_182 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_183 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_183 && newtype$check#0_2_183 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_184 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_184 && newtype$check#0_2_184 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_185 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_185 && newtype$check#0_2_185 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_186 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_186 && newtype$check#0_2_186 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_187 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_187 && newtype$check#0_2_187 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x1#Z#0_2_0 == Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(207,37)"} true;
    havoc b2#Z#0_2_0;
    assume LitInt(0) <= b2#Z#0_2_0 && b2#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_188 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_188 && newtype$check#0_2_188 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(1099511627776) != 0;
    newtype$check#0_2_189 := Div(x1#Z#0_2_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_189 && newtype$check#0_2_189 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_190 := Div(x1#Z#0_2_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_190 && newtype$check#0_2_190 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_191 := Div(x1#Z#0_2_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_191 && newtype$check#0_2_191 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_4#0#0 == Div(x1#Z#0_2_0, LitInt(1099511627776));
    assume true;
    assume $Is(let#0_2_4#0#0, Tclass.BoundedInts.uint8());
    assume b2#Z#0_2_0 == let#0_2_4#0#0;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    assume true;
    assume b2#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(210,23)"} true;
    havoc x2#Z#0_2_0;
    assume LitInt(0) <= x2#Z#0_2_0 && x2#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_192 := b2#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_192 && newtype$check#0_2_192 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_193 := b2#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_193 && newtype$check#0_2_193 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_194 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_2_194 && newtype$check#0_2_194 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_195 := Mul(b2#Z#0_2_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_195 && newtype$check#0_2_195 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_196 := x1#Z#0_2_0 - Mul(b2#Z#0_2_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_2_196 && newtype$check#0_2_196 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_2_5#0#0 == x1#Z#0_2_0 - Mul(b2#Z#0_2_0, LitInt(1099511627776));
    assume true;
    assume $Is(let#0_2_5#0#0, Tclass.BoundedInts.uint64());
    assume x2#Z#0_2_0 == let#0_2_5#0#0;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_2_197 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_197 && newtype$check#0_2_197 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_198 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_2_198 && newtype$check#0_2_198 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_199 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_199 && newtype$check#0_2_199 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_200 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_200 && newtype$check#0_2_200 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_201 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_201 && newtype$check#0_2_201 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_202 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_202 && newtype$check#0_2_202 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_203 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_203 && newtype$check#0_2_203 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_204 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_204 && newtype$check#0_2_204 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_205 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_205 && newtype$check#0_2_205 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_206 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_206 && newtype$check#0_2_206 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_207 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_207 && newtype$check#0_2_207 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_208 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_208 && newtype$check#0_2_208 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_209 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_209 && newtype$check#0_2_209 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_210 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_210 && newtype$check#0_2_210 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_211 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_211 && newtype$check#0_2_211 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_212 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_212 && newtype$check#0_2_212 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_213 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_213 && newtype$check#0_2_213 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_214 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_214 && newtype$check#0_2_214 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_215 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_215 && newtype$check#0_2_215 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_216 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_216 && newtype$check#0_2_216 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_217 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_217 && newtype$check#0_2_217 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_218 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_218 && newtype$check#0_2_218 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x2#Z#0_2_0 == Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(216,37)"} true;
    havoc b3#Z#0_2_0;
    assume LitInt(0) <= b3#Z#0_2_0 && b3#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_219 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_219 && newtype$check#0_2_219 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(4294967296) != 0;
    newtype$check#0_2_220 := Div(x2#Z#0_2_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_220 && newtype$check#0_2_220 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_221 := Div(x2#Z#0_2_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_221 && newtype$check#0_2_221 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_222 := Div(x2#Z#0_2_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_222 && newtype$check#0_2_222 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_6#0#0 == Div(x2#Z#0_2_0, LitInt(4294967296));
    assume true;
    assume $Is(let#0_2_6#0#0, Tclass.BoundedInts.uint8());
    assume b3#Z#0_2_0 == let#0_2_6#0#0;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    assume true;
    assume b3#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(219,23)"} true;
    havoc x3#Z#0_2_0;
    assume LitInt(0) <= x3#Z#0_2_0 && x3#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_223 := b3#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_223 && newtype$check#0_2_223 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_224 := b3#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_224 && newtype$check#0_2_224 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_225 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_2_225 && newtype$check#0_2_225 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_226 := Mul(b3#Z#0_2_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_226 && newtype$check#0_2_226 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_227 := x2#Z#0_2_0 - Mul(b3#Z#0_2_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_2_227 && newtype$check#0_2_227 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_2_7#0#0 == x2#Z#0_2_0 - Mul(b3#Z#0_2_0, LitInt(4294967296));
    assume true;
    assume $Is(let#0_2_7#0#0, Tclass.BoundedInts.uint64());
    assume x3#Z#0_2_0 == let#0_2_7#0#0;
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_2_228 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_228 && newtype$check#0_2_228 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_229 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_2_229 && newtype$check#0_2_229 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_230 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_230 && newtype$check#0_2_230 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_231 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_231 && newtype$check#0_2_231 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_232 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_232 && newtype$check#0_2_232 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_233 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_233 && newtype$check#0_2_233 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_234 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_234 && newtype$check#0_2_234 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_235 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_235 && newtype$check#0_2_235 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_236 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_236 && newtype$check#0_2_236 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_237 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_237 && newtype$check#0_2_237 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_238 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_238 && newtype$check#0_2_238 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_239 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_239 && newtype$check#0_2_239 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_240 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_240 && newtype$check#0_2_240 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_241 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_241 && newtype$check#0_2_241 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_242 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_242 && newtype$check#0_2_242 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_243 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_243 && newtype$check#0_2_243 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_244 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_244 && newtype$check#0_2_244 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x3#Z#0_2_0 == Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(224,37)"} true;
    havoc b4#Z#0_2_0;
    assume LitInt(0) <= b4#Z#0_2_0 && b4#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_245 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_245 && newtype$check#0_2_245 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(16777216) != 0;
    newtype$check#0_2_246 := Div(x3#Z#0_2_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_246 && newtype$check#0_2_246 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_247 := Div(x3#Z#0_2_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_247 && newtype$check#0_2_247 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_248 := Div(x3#Z#0_2_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_248 && newtype$check#0_2_248 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_8#0#0 == Div(x3#Z#0_2_0, LitInt(16777216));
    assume true;
    assume $Is(let#0_2_8#0#0, Tclass.BoundedInts.uint8());
    assume b4#Z#0_2_0 == let#0_2_8#0#0;
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    assume true;
    assume b4#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(227,23)"} true;
    havoc x4#Z#0_2_0;
    assume LitInt(0) <= x4#Z#0_2_0 && x4#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_249 := b4#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_249 && newtype$check#0_2_249 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_250 := b4#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_250 && newtype$check#0_2_250 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_251 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_2_251 && newtype$check#0_2_251 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_252 := Mul(b4#Z#0_2_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_252 && newtype$check#0_2_252 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_253 := x3#Z#0_2_0 - Mul(b4#Z#0_2_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_2_253 && newtype$check#0_2_253 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_2_9#0#0 == x3#Z#0_2_0 - Mul(b4#Z#0_2_0, LitInt(16777216));
    assume true;
    assume $Is(let#0_2_9#0#0, Tclass.BoundedInts.uint64());
    assume x4#Z#0_2_0 == let#0_2_9#0#0;
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_2_254 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_254 && newtype$check#0_2_254 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_255 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_2_255 && newtype$check#0_2_255 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_256 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_256 && newtype$check#0_2_256 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_257 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_257 && newtype$check#0_2_257 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_258 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_258 && newtype$check#0_2_258 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_259 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_259 && newtype$check#0_2_259 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_260 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_260 && newtype$check#0_2_260 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_261 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_261 && newtype$check#0_2_261 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_262 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_262 && newtype$check#0_2_262 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_263 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_263 && newtype$check#0_2_263 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_264 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_264 && newtype$check#0_2_264 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_265 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_265 && newtype$check#0_2_265 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x4#Z#0_2_0 == Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(231,37)"} true;
    havoc b5#Z#0_2_0;
    assume LitInt(0) <= b5#Z#0_2_0 && b5#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_266 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_266 && newtype$check#0_2_266 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(65536) != 0;
    newtype$check#0_2_267 := Div(x4#Z#0_2_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_267 && newtype$check#0_2_267 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_268 := Div(x4#Z#0_2_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_268 && newtype$check#0_2_268 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_269 := Div(x4#Z#0_2_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_269 && newtype$check#0_2_269 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_10#0#0 == Div(x4#Z#0_2_0, LitInt(65536));
    assume true;
    assume $Is(let#0_2_10#0#0, Tclass.BoundedInts.uint8());
    assume b5#Z#0_2_0 == let#0_2_10#0#0;
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    assume true;
    assume b5#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(234,23)"} true;
    havoc x5#Z#0_2_0;
    assume LitInt(0) <= x5#Z#0_2_0 && x5#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_270 := b5#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_270 && newtype$check#0_2_270 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_271 := b5#Z#0_2_0;
    assume LitInt(0) <= newtype$check#0_2_271 && newtype$check#0_2_271 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_272 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_2_272 && newtype$check#0_2_272 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_273 := Mul(b5#Z#0_2_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_273 && newtype$check#0_2_273 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_274 := x4#Z#0_2_0 - Mul(b5#Z#0_2_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_2_274 && newtype$check#0_2_274 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_2_11#0#0 == x4#Z#0_2_0 - Mul(b5#Z#0_2_0, LitInt(65536));
    assume true;
    assume $Is(let#0_2_11#0#0, Tclass.BoundedInts.uint64());
    assume x5#Z#0_2_0 == let#0_2_11#0#0;
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_2_275 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_275 && newtype$check#0_2_275 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_276 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_2_276 && newtype$check#0_2_276 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_277 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_277 && newtype$check#0_2_277 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_278 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_278 && newtype$check#0_2_278 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_2_279 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_279 && newtype$check#0_2_279 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_280 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_280 && newtype$check#0_2_280 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_281 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_2_281 && newtype$check#0_2_281 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x5#Z#0_2_0 == Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(236,60)"} true;
    havoc b6#Z#0_2_0;
    assume LitInt(0) <= b6#Z#0_2_0 && b6#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_282 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_282 && newtype$check#0_2_282 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(256) != 0;
    newtype$check#0_2_283 := Div(x5#Z#0_2_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_283 && newtype$check#0_2_283 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_284 := Div(x5#Z#0_2_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_284 && newtype$check#0_2_284 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_285 := Div(x5#Z#0_2_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_285 && newtype$check#0_2_285 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_12#0#0 == Div(x5#Z#0_2_0, LitInt(256));
    assume true;
    assume $Is(let#0_2_12#0#0, Tclass.BoundedInts.uint8());
    assume b6#Z#0_2_0 == let#0_2_12#0#0;
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    assume true;
    assume b6#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(239,23)"} true;
    havoc b7#Z#0_2_0;
    assume LitInt(0) <= b7#Z#0_2_0 && b7#Z#0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_286 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_2_286 && newtype$check#0_2_286 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(256) != 0;
    newtype$check#0_2_287 := Mod(x5#Z#0_2_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_287 && newtype$check#0_2_287 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_2_288 := Mod(x5#Z#0_2_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_288 && newtype$check#0_2_288 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2_289 := Mod(x5#Z#0_2_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_2_289 && newtype$check#0_2_289 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_2_13#0#0 == Mod(x5#Z#0_2_0, LitInt(256));
    assume true;
    assume $Is(let#0_2_13#0#0, Tclass.BoundedInts.uint8());
    assume b7#Z#0_2_0 == let#0_2_13#0#0;
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    assume true;
    assume b7#Z#0_2_0 == $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(241,23)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int), (var b0#0_1_0 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)); (var x0#0_1_0 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int - Mul(b0#0_1_0, LitInt(72057594037927936)); (var b1#0_1_0 := Div(x0#0_1_0, LitInt(281474976710656)); (var x1#0_1_0 := x0#0_1_0 - Mul(b1#0_1_0, LitInt(281474976710656)); (var b2#0_1_0 := Div(x1#0_1_0, LitInt(1099511627776)); (var x2#0_1_0 := x1#0_1_0 - Mul(b2#0_1_0, LitInt(1099511627776)); (var b3#0_1_0 := Div(x2#0_1_0, LitInt(4294967296)); (var x3#0_1_0 := x2#0_1_0 - Mul(b3#0_1_0, LitInt(4294967296)); (var b4#0_1_0 := Div(x3#0_1_0, LitInt(16777216)); (var x4#0_1_0 := x3#0_1_0 - Mul(b4#0_1_0, LitInt(16777216)); (var b5#0_1_0 := Div(x4#0_1_0, LitInt(65536)); (var x5#0_1_0 := x4#0_1_0 - Mul(b5#0_1_0, LitInt(65536)); (var b6#0_1_0 := Div(x5#0_1_0, LitInt(256)); (var b7#0_1_0 := Mod(x5#0_1_0, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0_1_0)), $Box(b1#0_1_0)), $Box(b2#0_1_0)), $Box(b3#0_1_0)), $Box(b4#0_1_0)), $Box(b5#0_1_0)), $Box(b6#0_1_0)), $Box(b7#0_1_0)))))))))))))))));
    assume false;
    goto anon6;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc b0#Z#0_1_0;
    assume LitInt(0) <= b0#Z#0_1_0 && b0#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_1_0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_1_0 && newtype$check#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_1_1 && newtype$check#0_1_1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_2 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_1_2 && newtype$check#0_1_2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_3 && newtype$check#0_1_3 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_1_4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_1_4 && newtype$check#0_1_4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_1_5 && newtype$check#0_1_5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_6 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_1_6 && newtype$check#0_1_6 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_7 && newtype$check#0_1_7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_8 && newtype$check#0_1_8 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_1_9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_9 && newtype$check#0_1_9 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_10 && newtype$check#0_1_10 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_11 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_1_11 && newtype$check#0_1_11 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_12 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_12 && newtype$check#0_1_12 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_13 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_13 && newtype$check#0_1_13 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_1_14 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_14 && newtype$check#0_1_14 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_15 && newtype$check#0_1_15 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_16 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_16 && newtype$check#0_1_16 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_17 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_17 && newtype$check#0_1_17 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_18 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_18 && newtype$check#0_1_18 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_1_19 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_19 && newtype$check#0_1_19 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_20 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_20 && newtype$check#0_1_20 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_21 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_21 && newtype$check#0_1_21 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_22 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_22 && newtype$check#0_1_22 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_23 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_23 && newtype$check#0_1_23 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_24 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_24 && newtype$check#0_1_24 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_25 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_25 && newtype$check#0_1_25 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_26 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_26 && newtype$check#0_1_26 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_27 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_27 && newtype$check#0_1_27 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_28 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_28 && newtype$check#0_1_28 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_29 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_29 && newtype$check#0_1_29 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_30 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_30 && newtype$check#0_1_30 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_31 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_31 && newtype$check#0_1_31 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_32 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_32 && newtype$check#0_1_32 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_33 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_33 && newtype$check#0_1_33 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_34 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_34 && newtype$check#0_1_34 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_35 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_35 && newtype$check#0_1_35 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_36 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_36 && newtype$check#0_1_36 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_37 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_1_37 && newtype$check#0_1_37 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(72057594037927936) != 0;
    newtype$check#0_1_38 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_38 && newtype$check#0_1_38 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_39 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_39 && newtype$check#0_1_39 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_40 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_40 && newtype$check#0_1_40 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_0#0#0 == Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936));
    assume true;
    assume $Is(let#0_1_0#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0_1_0 == let#0_1_0#0#0;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume true;
    assume b0#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(182,23)"} true;
    havoc x0#Z#0_1_0;
    assume LitInt(0) <= x0#Z#0_1_0 && x0#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_1_41 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_1_41 && newtype$check#0_1_41 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_42 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_1_42 && newtype$check#0_1_42 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_43 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_1_43 && newtype$check#0_1_43 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_44 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_44 && newtype$check#0_1_44 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_1_45 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_1_45 && newtype$check#0_1_45 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_46 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_1_46 && newtype$check#0_1_46 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_47 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_1_47 && newtype$check#0_1_47 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_48 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_48 && newtype$check#0_1_48 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_49 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_49 && newtype$check#0_1_49 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_1_50 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_50 && newtype$check#0_1_50 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_51 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_51 && newtype$check#0_1_51 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_52 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_1_52 && newtype$check#0_1_52 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_53 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_53 && newtype$check#0_1_53 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_54 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_54 && newtype$check#0_1_54 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_1_55 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_55 && newtype$check#0_1_55 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_56 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_56 && newtype$check#0_1_56 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_57 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_57 && newtype$check#0_1_57 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_58 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_58 && newtype$check#0_1_58 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_59 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_59 && newtype$check#0_1_59 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_1_60 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_60 && newtype$check#0_1_60 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_61 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_61 && newtype$check#0_1_61 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_62 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_62 && newtype$check#0_1_62 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_63 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_63 && newtype$check#0_1_63 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_64 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_64 && newtype$check#0_1_64 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_65 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_65 && newtype$check#0_1_65 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_66 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_66 && newtype$check#0_1_66 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_67 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_67 && newtype$check#0_1_67 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_68 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_68 && newtype$check#0_1_68 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_69 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_69 && newtype$check#0_1_69 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_70 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_70 && newtype$check#0_1_70 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_71 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_71 && newtype$check#0_1_71 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_72 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_72 && newtype$check#0_1_72 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_73 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_73 && newtype$check#0_1_73 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_74 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_74 && newtype$check#0_1_74 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_75 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_75 && newtype$check#0_1_75 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_76 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_76 && newtype$check#0_1_76 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_77 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_77 && newtype$check#0_1_77 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_78 := b0#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_78 && newtype$check#0_1_78 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_79 := b0#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_79 && newtype$check#0_1_79 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_80 := LitInt(72057594037927936);
    assume LitInt(0) <= newtype$check#0_1_80 && newtype$check#0_1_80 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_81 := Mul(b0#Z#0_1_0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_81 && newtype$check#0_1_81 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_82 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int - Mul(b0#Z#0_1_0, LitInt(72057594037927936));
    assume LitInt(0) <= newtype$check#0_1_82 && newtype$check#0_1_82 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_1_1#0#0 == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int - Mul(b0#Z#0_1_0, LitInt(72057594037927936));
    assume true;
    assume $Is(let#0_1_1#0#0, Tclass.BoundedInts.uint64());
    assume x0#Z#0_1_0 == let#0_1_1#0#0;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_1_83 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_1_83 && newtype$check#0_1_83 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_84 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_1_84 && newtype$check#0_1_84 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_85 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_1_85 && newtype$check#0_1_85 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_86 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_86 && newtype$check#0_1_86 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_1_87 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_87 && newtype$check#0_1_87 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_88 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_88 && newtype$check#0_1_88 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_89 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_1_89 && newtype$check#0_1_89 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_90 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_90 && newtype$check#0_1_90 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_91 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_91 && newtype$check#0_1_91 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_1_92 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_92 && newtype$check#0_1_92 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_93 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_93 && newtype$check#0_1_93 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_94 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_94 && newtype$check#0_1_94 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_95 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_95 && newtype$check#0_1_95 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_96 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_96 && newtype$check#0_1_96 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_1_97 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_97 && newtype$check#0_1_97 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_98 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_98 && newtype$check#0_1_98 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_99 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_99 && newtype$check#0_1_99 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_100 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_100 && newtype$check#0_1_100 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_101 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_101 && newtype$check#0_1_101 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_102 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_102 && newtype$check#0_1_102 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_103 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_103 && newtype$check#0_1_103 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_104 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_104 && newtype$check#0_1_104 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_105 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_105 && newtype$check#0_1_105 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_106 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_106 && newtype$check#0_1_106 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_107 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_107 && newtype$check#0_1_107 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_108 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_108 && newtype$check#0_1_108 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_109 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_109 && newtype$check#0_1_109 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_110 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_110 && newtype$check#0_1_110 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_111 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_111 && newtype$check#0_1_111 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_112 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_112 && newtype$check#0_1_112 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_113 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_113 && newtype$check#0_1_113 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_114 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_114 && newtype$check#0_1_114 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x0#Z#0_1_0 == Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(197,37)"} true;
    havoc b1#Z#0_1_0;
    assume LitInt(0) <= b1#Z#0_1_0 && b1#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_115 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_1_115 && newtype$check#0_1_115 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(281474976710656) != 0;
    newtype$check#0_1_116 := Div(x0#Z#0_1_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_116 && newtype$check#0_1_116 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_117 := Div(x0#Z#0_1_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_117 && newtype$check#0_1_117 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_118 := Div(x0#Z#0_1_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_118 && newtype$check#0_1_118 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_2#0#0 == Div(x0#Z#0_1_0, LitInt(281474976710656));
    assume true;
    assume $Is(let#0_1_2#0#0, Tclass.BoundedInts.uint8());
    assume b1#Z#0_1_0 == let#0_1_2#0#0;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume true;
    assume b1#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(200,23)"} true;
    havoc x1#Z#0_1_0;
    assume LitInt(0) <= x1#Z#0_1_0 && x1#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_119 := b1#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_119 && newtype$check#0_1_119 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_120 := b1#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_120 && newtype$check#0_1_120 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_121 := LitInt(281474976710656);
    assume LitInt(0) <= newtype$check#0_1_121 && newtype$check#0_1_121 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_122 := Mul(b1#Z#0_1_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_122 && newtype$check#0_1_122 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_123 := x0#Z#0_1_0 - Mul(b1#Z#0_1_0, LitInt(281474976710656));
    assume LitInt(0) <= newtype$check#0_1_123 && newtype$check#0_1_123 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_1_3#0#0 == x0#Z#0_1_0 - Mul(b1#Z#0_1_0, LitInt(281474976710656));
    assume true;
    assume $Is(let#0_1_3#0#0, Tclass.BoundedInts.uint64());
    assume x1#Z#0_1_0 == let#0_1_3#0#0;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_1_124 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_124 && newtype$check#0_1_124 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_125 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_1_125 && newtype$check#0_1_125 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_126 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_1_126 && newtype$check#0_1_126 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_127 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_127 && newtype$check#0_1_127 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_1_128 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_128 && newtype$check#0_1_128 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_129 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_129 && newtype$check#0_1_129 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_130 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_130 && newtype$check#0_1_130 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_131 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_131 && newtype$check#0_1_131 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_132 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_132 && newtype$check#0_1_132 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_1_133 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_133 && newtype$check#0_1_133 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_134 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_134 && newtype$check#0_1_134 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_135 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_135 && newtype$check#0_1_135 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_136 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_136 && newtype$check#0_1_136 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_137 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_137 && newtype$check#0_1_137 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_138 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_138 && newtype$check#0_1_138 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_139 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_139 && newtype$check#0_1_139 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_140 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_140 && newtype$check#0_1_140 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_141 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_141 && newtype$check#0_1_141 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_142 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_142 && newtype$check#0_1_142 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_143 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_143 && newtype$check#0_1_143 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_144 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_144 && newtype$check#0_1_144 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_145 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_145 && newtype$check#0_1_145 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_146 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_146 && newtype$check#0_1_146 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_147 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_147 && newtype$check#0_1_147 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_148 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_148 && newtype$check#0_1_148 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_149 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_149 && newtype$check#0_1_149 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_150 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_150 && newtype$check#0_1_150 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x1#Z#0_1_0 == Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(207,37)"} true;
    havoc b2#Z#0_1_0;
    assume LitInt(0) <= b2#Z#0_1_0 && b2#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_151 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_1_151 && newtype$check#0_1_151 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(1099511627776) != 0;
    newtype$check#0_1_152 := Div(x1#Z#0_1_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_152 && newtype$check#0_1_152 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_153 := Div(x1#Z#0_1_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_153 && newtype$check#0_1_153 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_154 := Div(x1#Z#0_1_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_154 && newtype$check#0_1_154 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_4#0#0 == Div(x1#Z#0_1_0, LitInt(1099511627776));
    assume true;
    assume $Is(let#0_1_4#0#0, Tclass.BoundedInts.uint8());
    assume b2#Z#0_1_0 == let#0_1_4#0#0;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    assume true;
    assume b2#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(210,23)"} true;
    havoc x2#Z#0_1_0;
    assume LitInt(0) <= x2#Z#0_1_0 && x2#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_155 := b2#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_155 && newtype$check#0_1_155 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_156 := b2#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_156 && newtype$check#0_1_156 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_157 := LitInt(1099511627776);
    assume LitInt(0) <= newtype$check#0_1_157 && newtype$check#0_1_157 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_158 := Mul(b2#Z#0_1_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_158 && newtype$check#0_1_158 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_159 := x1#Z#0_1_0 - Mul(b2#Z#0_1_0, LitInt(1099511627776));
    assume LitInt(0) <= newtype$check#0_1_159 && newtype$check#0_1_159 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_1_5#0#0 == x1#Z#0_1_0 - Mul(b2#Z#0_1_0, LitInt(1099511627776));
    assume true;
    assume $Is(let#0_1_5#0#0, Tclass.BoundedInts.uint64());
    assume x2#Z#0_1_0 == let#0_1_5#0#0;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_1_160 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_160 && newtype$check#0_1_160 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_161 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_1_161 && newtype$check#0_1_161 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_162 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_162 && newtype$check#0_1_162 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_163 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_163 && newtype$check#0_1_163 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_1_164 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_164 && newtype$check#0_1_164 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_165 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_165 && newtype$check#0_1_165 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_166 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_166 && newtype$check#0_1_166 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_167 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_167 && newtype$check#0_1_167 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_168 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_168 && newtype$check#0_1_168 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_169 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_169 && newtype$check#0_1_169 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_170 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_170 && newtype$check#0_1_170 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_171 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_171 && newtype$check#0_1_171 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_172 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_172 && newtype$check#0_1_172 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_173 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_173 && newtype$check#0_1_173 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_174 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_174 && newtype$check#0_1_174 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_175 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_175 && newtype$check#0_1_175 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_176 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_176 && newtype$check#0_1_176 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_177 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_177 && newtype$check#0_1_177 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_178 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_178 && newtype$check#0_1_178 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_179 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_179 && newtype$check#0_1_179 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_180 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_180 && newtype$check#0_1_180 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_181 := Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_181 && newtype$check#0_1_181 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x2#Z#0_1_0 == Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(216,37)"} true;
    havoc b3#Z#0_1_0;
    assume LitInt(0) <= b3#Z#0_1_0 && b3#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_182 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_182 && newtype$check#0_1_182 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(4294967296) != 0;
    newtype$check#0_1_183 := Div(x2#Z#0_1_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_183 && newtype$check#0_1_183 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_184 := Div(x2#Z#0_1_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_184 && newtype$check#0_1_184 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_185 := Div(x2#Z#0_1_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_185 && newtype$check#0_1_185 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_6#0#0 == Div(x2#Z#0_1_0, LitInt(4294967296));
    assume true;
    assume $Is(let#0_1_6#0#0, Tclass.BoundedInts.uint8());
    assume b3#Z#0_1_0 == let#0_1_6#0#0;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    assume true;
    assume b3#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(219,23)"} true;
    havoc x3#Z#0_1_0;
    assume LitInt(0) <= x3#Z#0_1_0 && x3#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_186 := b3#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_186 && newtype$check#0_1_186 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_187 := b3#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_187 && newtype$check#0_1_187 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_188 := LitInt(4294967296);
    assume LitInt(0) <= newtype$check#0_1_188 && newtype$check#0_1_188 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_189 := Mul(b3#Z#0_1_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_189 && newtype$check#0_1_189 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_190 := x2#Z#0_1_0 - Mul(b3#Z#0_1_0, LitInt(4294967296));
    assume LitInt(0) <= newtype$check#0_1_190 && newtype$check#0_1_190 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_1_7#0#0 == x2#Z#0_1_0 - Mul(b3#Z#0_1_0, LitInt(4294967296));
    assume true;
    assume $Is(let#0_1_7#0#0, Tclass.BoundedInts.uint64());
    assume x3#Z#0_1_0 == let#0_1_7#0#0;
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    newtype$check#0_1_191 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_191 && newtype$check#0_1_191 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_192 := $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume LitInt(0) <= newtype$check#0_1_192 && newtype$check#0_1_192 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_193 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_193 && newtype$check#0_1_193 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_194 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_194 && newtype$check#0_1_194 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_195 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_195 && newtype$check#0_1_195 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_196 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_196 && newtype$check#0_1_196 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_197 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_197 && newtype$check#0_1_197 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_198 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_198 && newtype$check#0_1_198 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_199 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_199 && newtype$check#0_1_199 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_200 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_200 && newtype$check#0_1_200 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_201 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_201 && newtype$check#0_1_201 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_202 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_202 && newtype$check#0_1_202 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_203 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_203 && newtype$check#0_1_203 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_204 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_204 && newtype$check#0_1_204 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_205 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_205 && newtype$check#0_1_205 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_206 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_206 && newtype$check#0_1_206 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_207 := Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_207 && newtype$check#0_1_207 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x3#Z#0_1_0 == Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(224,37)"} true;
    havoc b4#Z#0_1_0;
    assume LitInt(0) <= b4#Z#0_1_0 && b4#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_208 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_208 && newtype$check#0_1_208 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(16777216) != 0;
    newtype$check#0_1_209 := Div(x3#Z#0_1_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_209 && newtype$check#0_1_209 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_210 := Div(x3#Z#0_1_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_210 && newtype$check#0_1_210 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_211 := Div(x3#Z#0_1_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_211 && newtype$check#0_1_211 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_8#0#0 == Div(x3#Z#0_1_0, LitInt(16777216));
    assume true;
    assume $Is(let#0_1_8#0#0, Tclass.BoundedInts.uint8());
    assume b4#Z#0_1_0 == let#0_1_8#0#0;
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    assume true;
    assume b4#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(4))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(227,23)"} true;
    havoc x4#Z#0_1_0;
    assume LitInt(0) <= x4#Z#0_1_0 && x4#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_212 := b4#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_212 && newtype$check#0_1_212 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_213 := b4#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_213 && newtype$check#0_1_213 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_214 := LitInt(16777216);
    assume LitInt(0) <= newtype$check#0_1_214 && newtype$check#0_1_214 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_215 := Mul(b4#Z#0_1_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_215 && newtype$check#0_1_215 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_216 := x3#Z#0_1_0 - Mul(b4#Z#0_1_0, LitInt(16777216));
    assume LitInt(0) <= newtype$check#0_1_216 && newtype$check#0_1_216 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_1_9#0#0 == x3#Z#0_1_0 - Mul(b4#Z#0_1_0, LitInt(16777216));
    assume true;
    assume $Is(let#0_1_9#0#0, Tclass.BoundedInts.uint64());
    assume x4#Z#0_1_0 == let#0_1_9#0#0;
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    newtype$check#0_1_217 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_217 && newtype$check#0_1_217 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_218 := $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume LitInt(0) <= newtype$check#0_1_218 && newtype$check#0_1_218 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_219 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_219 && newtype$check#0_1_219 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_220 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_220 && newtype$check#0_1_220 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_221 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_221 && newtype$check#0_1_221 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_222 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_222 && newtype$check#0_1_222 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_223 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_223 && newtype$check#0_1_223 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_224 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_224 && newtype$check#0_1_224 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_225 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_225 && newtype$check#0_1_225 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_226 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_226 && newtype$check#0_1_226 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_227 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_227 && newtype$check#0_1_227 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_228 := Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_228 && newtype$check#0_1_228 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x4#Z#0_1_0 == Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(231,37)"} true;
    havoc b5#Z#0_1_0;
    assume LitInt(0) <= b5#Z#0_1_0 && b5#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_229 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_229 && newtype$check#0_1_229 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(65536) != 0;
    newtype$check#0_1_230 := Div(x4#Z#0_1_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_230 && newtype$check#0_1_230 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_231 := Div(x4#Z#0_1_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_231 && newtype$check#0_1_231 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_232 := Div(x4#Z#0_1_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_232 && newtype$check#0_1_232 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_10#0#0 == Div(x4#Z#0_1_0, LitInt(65536));
    assume true;
    assume $Is(let#0_1_10#0#0, Tclass.BoundedInts.uint8());
    assume b5#Z#0_1_0 == let#0_1_10#0#0;
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    assume true;
    assume b5#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(5))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(234,23)"} true;
    havoc x5#Z#0_1_0;
    assume LitInt(0) <= x5#Z#0_1_0 && x5#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_233 := b5#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_233 && newtype$check#0_1_233 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_234 := b5#Z#0_1_0;
    assume LitInt(0) <= newtype$check#0_1_234 && newtype$check#0_1_234 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_235 := LitInt(65536);
    assume LitInt(0) <= newtype$check#0_1_235 && newtype$check#0_1_235 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_236 := Mul(b5#Z#0_1_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_236 && newtype$check#0_1_236 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_237 := x4#Z#0_1_0 - Mul(b5#Z#0_1_0, LitInt(65536));
    assume LitInt(0) <= newtype$check#0_1_237 && newtype$check#0_1_237 < BoundedInts.__default.TWO__TO__THE__64();
    assume let#0_1_11#0#0 == x4#Z#0_1_0 - Mul(b5#Z#0_1_0, LitInt(65536));
    assume true;
    assume $Is(let#0_1_11#0#0, Tclass.BoundedInts.uint64());
    assume x5#Z#0_1_0 == let#0_1_11#0#0;
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    newtype$check#0_1_238 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_238 && newtype$check#0_1_238 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_239 := $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume LitInt(0) <= newtype$check#0_1_239 && newtype$check#0_1_239 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_240 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_240 && newtype$check#0_1_240 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_241 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_241 && newtype$check#0_1_241 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    newtype$check#0_1_242 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_242 && newtype$check#0_1_242 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_243 := $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_243 && newtype$check#0_1_243 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_244 := Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume LitInt(0) <= newtype$check#0_1_244 && newtype$check#0_1_244 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume x5#Z#0_1_0 == Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(236,60)"} true;
    havoc b6#Z#0_1_0;
    assume LitInt(0) <= b6#Z#0_1_0 && b6#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_245 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_245 && newtype$check#0_1_245 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(256) != 0;
    newtype$check#0_1_246 := Div(x5#Z#0_1_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_246 && newtype$check#0_1_246 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_247 := Div(x5#Z#0_1_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_247 && newtype$check#0_1_247 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_248 := Div(x5#Z#0_1_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_248 && newtype$check#0_1_248 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_12#0#0 == Div(x5#Z#0_1_0, LitInt(256));
    assume true;
    assume $Is(let#0_1_12#0#0, Tclass.BoundedInts.uint8());
    assume b6#Z#0_1_0 == let#0_1_12#0#0;
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    assume true;
    assume b6#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(6))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(239,23)"} true;
    havoc b7#Z#0_1_0;
    assume LitInt(0) <= b7#Z#0_1_0 && b7#Z#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_249 := LitInt(256);
    assume LitInt(0) <= newtype$check#0_1_249 && newtype$check#0_1_249 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} LitInt(256) != 0;
    newtype$check#0_1_250 := Mod(x5#Z#0_1_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_250 && newtype$check#0_1_250 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1_251 := Mod(x5#Z#0_1_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_251 && newtype$check#0_1_251 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_252 := Mod(x5#Z#0_1_0, LitInt(256));
    assume LitInt(0) <= newtype$check#0_1_252 && newtype$check#0_1_252 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0_1_13#0#0 == Mod(x5#Z#0_1_0, LitInt(256));
    assume true;
    assume $Is(let#0_1_13#0#0, Tclass.BoundedInts.uint8());
    assume b7#Z#0_1_0 == let#0_1_13#0#0;
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    assume true;
    assume b7#Z#0_1_0 == $Unbox(Seq#Index(s#0, LitInt(7))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(241,23)"} true;
    assume true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    assume true;
    assume {:subsumption 0} Seq#Equal((var b0#0_1_0 := Div(Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)); (var x0#0_1_0 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)) + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)) + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)) + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(7))): int - Mul(b0#0_1_0, LitInt(72057594037927936)); (var b1#0_1_0 := Div(x0#0_1_0, LitInt(281474976710656)); (var x1#0_1_0 := x0#0_1_0 - Mul(b1#0_1_0, LitInt(281474976710656)); (var b2#0_1_0 := Div(x1#0_1_0, LitInt(1099511627776)); (var x2#0_1_0 := x1#0_1_0 - Mul(b2#0_1_0, LitInt(1099511627776)); (var b3#0_1_0 := Div(x2#0_1_0, LitInt(4294967296)); (var x3#0_1_0 := x2#0_1_0 - Mul(b3#0_1_0, LitInt(4294967296)); (var b4#0_1_0 := Div(x3#0_1_0, LitInt(16777216)); (var x4#0_1_0 := x3#0_1_0 - Mul(b4#0_1_0, LitInt(16777216)); (var b5#0_1_0 := Div(x4#0_1_0, LitInt(65536)); (var x5#0_1_0 := x4#0_1_0 - Mul(b5#0_1_0, LitInt(65536)); (var b6#0_1_0 := Div(x5#0_1_0, LitInt(256)); (var b7#0_1_0 := Mod(x5#0_1_0, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0_1_0)), $Box(b1#0_1_0)), $Box(b2#0_1_0)), $Box(b3#0_1_0)), $Box(b4#0_1_0)), $Box(b5#0_1_0)), $Box(b6#0_1_0)), $Box(b7#0_1_0)))))))))))))))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), Seq#Index(s#0, LitInt(1))), Seq#Index(s#0, LitInt(2))), Seq#Index(s#0, LitInt(3))), Seq#Index(s#0, LitInt(4))), Seq#Index(s#0, LitInt(5))), Seq#Index(s#0, LitInt(6))), Seq#Index(s#0, LitInt(7))));
    assume false;
    goto anon6;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(4) && LitInt(4) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(5) && LitInt(5) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(6) && LitInt(6) < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(7) && LitInt(7) < Seq#Length(s#0);
    assume true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), Seq#Index(s#0, LitInt(1))), Seq#Index(s#0, LitInt(2))), Seq#Index(s#0, LitInt(3))), Seq#Index(s#0, LitInt(4))), Seq#Index(s#0, LitInt(5))), Seq#Index(s#0, LitInt(6))), Seq#Index(s#0, LitInt(7))), s#0);
    assume false;
    goto anon6;

  anon11_Else:
    goto anon6;

  anon6:
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), s#0);
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64());
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(250,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(251,40): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0);
    ##s#0 := StandardLibrary_mUInt.__default.UInt64ToSeq(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(8);
    assume Seq#Length(##s#0) == LitInt(8);
    assume StandardLibrary_mUInt.__default.SeqToUInt64#canCall(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0));
    assume StandardLibrary_mUInt.__default.SeqToUInt64(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0)) == x#0;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64());



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64());
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) && StandardLibrary_mUInt.__default.SeqToUInt64#canCall(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0));
  free ensures {:id "id1390"} StandardLibrary_mUInt.__default.SeqToUInt64(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) && StandardLibrary_mUInt.__default.SeqToUInt64#canCall(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0));
  free ensures {:id "id1391"} StandardLibrary_mUInt.__default.SeqToUInt64(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(252,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(254,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(8);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(256,40): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(8);
    assume Seq#Length(##s#0) == LitInt(8);
    assume StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0);
    ##x#0 := StandardLibrary_mUInt.__default.SeqToUInt64(s#0);
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint64(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt64(s#0));
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(StandardLibrary_mUInt.__default.SeqToUInt64(s#0)), s#0);
    return;
}



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id1395"} Seq#Length(s#0) == LitInt(8);



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) && StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt64(s#0));
  free ensures {:id "id1396"} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(StandardLibrary_mUInt.__default.SeqToUInt64(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id1397"} Seq#Length(s#0) == LitInt(8);
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) && StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(StandardLibrary_mUInt.__default.SeqToUInt64(s#0));
  free ensures {:id "id1398"} Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(StandardLibrary_mUInt.__default.SeqToUInt64(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (correctness)"} Impl$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(257,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function StandardLibrary_mUInt.__default.SeqToNat($ly: LayerType, s#0: Seq) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($ly, s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) ==> LitInt(0) <= StandardLibrary_mUInt.__default.SeqToNat($ly, s#0));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#0 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#0)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#0 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#0)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#0)): int)));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#1 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#1)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#1 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#1)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#1)): int)));
}

function StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == StandardLibrary_mUInt.__default.SeqToNat($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat(AsFuelBottom($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat($ly, s#0) == StandardLibrary_mUInt.__default.SeqToNat($LZ, s#0));

function StandardLibrary_mUInt.__default.SeqToNat#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat#requires($ly, s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (StandardLibrary_mUInt.__default.SeqToNat#requires($ly, s#0) <==> true));

procedure {:verboseName "StandardLibrary.UInt.SeqToNat (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToNat(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqToNat (well-formedness)"} CheckWellformed$$StandardLibrary_mUInt.__default.SeqToNat(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var finalIndex#Z#0: int;
  var let#0#0#0: int;
  var ##s#0: Seq;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToNat", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(259,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume LitInt(0) <= StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0);
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0) == LitInt(0);
    assume true;
    assume $Is(StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0), Tclass._System.nat());
    return;

  anon7_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    havoc finalIndex#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(s#0) - 1;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume finalIndex#Z#0 == let#0#0#0;
    assume 0 <= finalIndex#Z#0 && finalIndex#Z#0 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, finalIndex#Z#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Seq#Rank(##s#0) < Seq#Rank(s#0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#Z#0));
    assume 0 <= finalIndex#Z#0 && finalIndex#Z#0 < Seq#Length(s#0);
    newtype$check#0 := $Unbox(Seq#Index(s#0, finalIndex#Z#0)): int;
    assume LitInt(0) <= newtype$check#0;
    newtype$check#1 := $Unbox(Seq#Index(s#0, finalIndex#Z#0)): int;
    assume LitInt(0) <= newtype$check#1;
    assume $Is(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), Seq#Take(s#0, finalIndex#Z#0)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#Z#0)): int, Tclass._System.nat());
    assume StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0) == Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), Seq#Take(s#0, finalIndex#Z#0)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#Z#0)): int;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#Z#0));
    assume $Is(StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0), Tclass._System.nat());
    return;
}



procedure {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var newtype$check#0: int;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToNatZeroPrefix", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(268,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(269,24): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    ##s#1 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0);
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
    assume StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0) == StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
    return;
}



procedure {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) && StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
  free ensures {:id "id1412"} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s#0) == StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (correctness)"} Impl$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) && StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
  free ensures {:id "id1413"} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s#0) == StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (correctness)"} Impl$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var s'#1_0: Seq where $Is(s'#1_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s'#1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var newtype$check#1_0: int;
  var sLength#1_0: int;
  var sFinalIndex#1_0: int;
  var ##s#1_0_0_0: Seq;
  var newtype$check#1_0_0_0: int;
  var ##s#1_0_0_1: Seq;
  var ##s#1_0_1_0: Seq;
  var newtype$check#1_0_1_0: int;
  var newtype$check#1_0_1_1: int;
  var ##s#1_0_1_1: Seq;
  var newtype$check#1_0_2_0: int;
  var ##s#1_0_2_0: Seq;
  var newtype$check#1_0_2_1: int;
  var newtype$check#1_0_2_2: int;
  var newtype$check#1_0_2_3: int;
  var ##s#1_0_2_1: Seq;
  var newtype$check#1_0_2_4: int;
  var newtype$check#1_0_2_5: int;
  var ##s#1_0_3_0: Seq;
  var newtype$check#1_0_3_0: int;
  var newtype$check#1_0_3_1: int;
  var newtype$check#1_0_3_2: int;
  var ##s#1_0_3_1: Seq;
  var newtype$check#1_0_3_3: int;
  var newtype$check#1_0_3_4: int;
  var ##s#1_0_4_0: Seq;
  var ##s#1_0_4_1: Seq;
  var newtype$check#1_0_4_0: int;
  var newtype$check#1_0_4_1: int;
  var ##s#1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToNatZeroPrefix", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(270,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq :: $Is($ih#s0#0, TSeq(Tclass.BoundedInts.uint8())) && Lit(true) && Seq#Rank($ih#s0#0) < Seq#Rank(s#0) ==> StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), $ih#s0#0) == StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), $ih#s0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    return;

  anon12_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    assume true;
    newtype$check#1_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    s'#1_0 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0);
    assume {:captureState "StandardLibrary/src/UInt.dfy(273,23)"} true;
    assume true;
    assume true;
    sLength#1_0 := Seq#Length(s#0);
    assume {:captureState "StandardLibrary/src/UInt.dfy(274,24)"} true;
    assume true;
    assume true;
    sFinalIndex#1_0 := sLength#1_0 - 1;
    assume {:captureState "StandardLibrary/src/UInt.dfy(275,36)"} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##s#1_0_0 := s#0;
    assume $IsAlloc(##s#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume false;
    goto anon11;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##s#1_0_4_0 := s#0;
    assume $IsAlloc(##s#1_0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 <= Seq#Length(s#0);
    ##s#1_0_4_1 := Seq#Take(s#0, sFinalIndex#1_0);
    assume $IsAlloc(##s#1_0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, sFinalIndex#1_0));
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 < Seq#Length(s#0);
    newtype$check#1_0_4_0 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_4_0;
    newtype$check#1_0_4_1 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_4_1;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, sFinalIndex#1_0));
    assume {:subsumption 0} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s#0) == Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, sFinalIndex#1_0)), LitInt(256)) + $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume false;
    goto anon11;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 <= Seq#Length(s#0);
    ##s#1_0_3_0 := Seq#Take(s#0, sFinalIndex#1_0);
    assume $IsAlloc(##s#1_0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, sFinalIndex#1_0));
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 < Seq#Length(s#0);
    newtype$check#1_0_3_0 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_3_0;
    newtype$check#1_0_3_1 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_3_1;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, sFinalIndex#1_0));
    newtype$check#1_0_3_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0_3_2 && newtype$check#1_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 <= Seq#Length(s#0);
    ##s#1_0_3_1 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0));
    assume $IsAlloc(##s#1_0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 < Seq#Length(s#0);
    newtype$check#1_0_3_3 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_3_3;
    newtype$check#1_0_3_4 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_3_4;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    assume {:subsumption 0} Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, sFinalIndex#1_0)), LitInt(256)) + $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int == Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0))), LitInt(256)) + $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume false;
    goto anon11;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    newtype$check#1_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0_2_0 && newtype$check#1_0_2_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 <= Seq#Length(s#0);
    ##s#1_0_2_0 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0));
    assume $IsAlloc(##s#1_0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 < Seq#Length(s#0);
    newtype$check#1_0_2_1 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_2_1;
    newtype$check#1_0_2_2 := $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_2_2;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    assume {:subsumption 0} 0 <= sLength#1_0 && sLength#1_0 <= Seq#Length(s'#1_0);
    newtype$check#1_0_2_3 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0_2_3 && newtype$check#1_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 <= Seq#Length(s#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Equal(Seq#Take(s'#1_0, sLength#1_0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    assume {:subsumption 0} 0 <= sLength#1_0 && sLength#1_0 < Seq#Length(s'#1_0);
    assume {:subsumption 0} 0 <= sFinalIndex#1_0 && sFinalIndex#1_0 < Seq#Length(s#0);
    goto anon8;

  anon17_Else:
    assume {:partition} !Seq#Equal(Seq#Take(s'#1_0, sLength#1_0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    goto anon8;

  anon8:
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Take(s'#1_0, sLength#1_0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0)));
    assume {:subsumption 0} $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int == $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume Seq#Equal(Seq#Take(s'#1_0, sLength#1_0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0))) && $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int == $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(282,92)"} true;
    assume {:subsumption 0} 0 <= sLength#1_0 && sLength#1_0 <= Seq#Length(s'#1_0);
    ##s#1_0_2_1 := Seq#Take(s'#1_0, sLength#1_0);
    assume $IsAlloc(##s#1_0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s'#1_0, sLength#1_0));
    assume {:subsumption 0} 0 <= sLength#1_0 && sLength#1_0 < Seq#Length(s'#1_0);
    newtype$check#1_0_2_4 := $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_2_4;
    newtype$check#1_0_2_5 := $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_2_5;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s'#1_0, sLength#1_0));
    assume {:subsumption 0} Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Take(s#0, sFinalIndex#1_0))), LitInt(256)) + $Unbox(Seq#Index(s#0, sFinalIndex#1_0)): int == Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s'#1_0, sLength#1_0)), LitInt(256)) + $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int;
    assume false;
    goto anon11;

  anon16_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:subsumption 0} 0 <= sLength#1_0 && sLength#1_0 <= Seq#Length(s'#1_0);
    ##s#1_0_1_0 := Seq#Take(s'#1_0, sLength#1_0);
    assume $IsAlloc(##s#1_0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s'#1_0, sLength#1_0));
    assume {:subsumption 0} 0 <= sLength#1_0 && sLength#1_0 < Seq#Length(s'#1_0);
    newtype$check#1_0_1_0 := $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_1_0;
    newtype$check#1_0_1_1 := $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int;
    assume LitInt(0) <= newtype$check#1_0_1_1;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s'#1_0, sLength#1_0));
    ##s#1_0_1_1 := s'#1_0;
    assume $IsAlloc(##s#1_0_1_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s'#1_0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s'#1_0);
    assume {:subsumption 0} Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s'#1_0, sLength#1_0)), LitInt(256)) + $Unbox(Seq#Index(s'#1_0, sLength#1_0)): int == StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s'#1_0);
    assume false;
    goto anon11;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    ##s#1_0_0_0 := s'#1_0;
    assume $IsAlloc(##s#1_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s'#1_0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s'#1_0);
    newtype$check#1_0_0_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0_0_0 && newtype$check#1_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    ##s#1_0_0_1 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0);
    assume $IsAlloc(##s#1_0_0_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
    assume {:subsumption 0} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s'#1_0) == StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
    assume false;
    goto anon11;

  anon19_Else:
    goto anon11;

  anon11:
    assume StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0) == StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), s#0));
    return;
}



procedure {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var suffixStartIndex#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##x#0: int;
  var i#0: int;
  var newtype$check#2: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqWithUInt32Suffix", " | ", s#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(293,8): initial state"} true;
    assume n#0 < StandardLibrary_mUInt.__default.UINT32__LIMIT();
    assume LitInt(4) <= Seq#Length(s#0);
    havoc suffixStartIndex#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(s#0) - 4;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume suffixStartIndex#Z#0 == let#0#0#0;
    assume 0 <= suffixStartIndex#Z#0 && suffixStartIndex#Z#0 <= Seq#Length(s#0);
    newtype$check#0 := n#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := n#0;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    ##x#0 := n#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(n#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Equal(Seq#Drop(s#0, suffixStartIndex#Z#0), StandardLibrary_mUInt.__default.UInt32ToSeq(n#0));
    havoc i#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon5;

  anon11_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon5;

  anon5:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < suffixStartIndex#Z#0;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon7;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < suffixStartIndex#Z#0);
    goto anon7;

  anon10_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    goto anon8;

  anon9_Else:
    assume {:partition} !Seq#Equal(Seq#Drop(s#0, suffixStartIndex#Z#0), StandardLibrary_mUInt.__default.UInt32ToSeq(n#0));
    goto anon8;

  anon8:
    assume (var suffixStartIndex#0 := Seq#Length(s#0) - 4; Seq#Equal(Seq#Drop(s#0, suffixStartIndex#0), StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)) && (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): int } LitInt(0) <= i#1 && i#1 < suffixStartIndex#0 ==> $Unbox(Seq#Index(s#0, i#1)): int == LitInt(0)));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UInt.dfy(299,24): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0) == n#0;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (call precondtion)"} CallPre$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id1470"} n#0 < StandardLibrary_mUInt.__default.UINT32__LIMIT();
  requires {:id "id1471"} LitInt(4) <= Seq#Length(s#0);
  requires {:id "id1472"} (var suffixStartIndex#0 := Seq#Length(s#0) - 4; Seq#Equal(Seq#Drop(s#0, suffixStartIndex#0), StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)));
  requires {:id "id1473"} (var suffixStartIndex#0 := Seq#Length(s#0) - 4; (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): int } LitInt(0) <= i#1 && i#1 < suffixStartIndex#0 ==> $Unbox(Seq#Index(s#0, i#1)): int == LitInt(0)));



procedure {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
  free ensures {:id "id1474"} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s#0) == n#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (correctness)"} Impl$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id1475"} n#0 < StandardLibrary_mUInt.__default.UINT32__LIMIT();
  requires {:id "id1476"} LitInt(4) <= Seq#Length(s#0);
  requires {:id "id1477"} (var suffixStartIndex#0 := Seq#Length(s#0) - 4; Seq#Equal(Seq#Drop(s#0, suffixStartIndex#0), StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)));
  requires {:id "id1478"} (var suffixStartIndex#0 := Seq#Length(s#0) - 4; (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): int } LitInt(0) <= i#1 && i#1 < suffixStartIndex#0 ==> $Unbox(Seq#Index(s#0, i#1)): int == LitInt(0)));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
  free ensures {:id "id1479"} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s#0) == n#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (correctness)"} Impl$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##s#0_0_0_0: Seq;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var newtype$check#0_0_0_2: int;
  var newtype$check#0_0_0_3: int;
  var newtype$check#0_0_0_4: int;
  var newtype$check#0_0_0_5: int;
  var newtype$check#0_0_0_6: int;
  var newtype$check#0_0_0_7: int;
  var ##s#0_0_1_0: Seq;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var newtype$check#0_0_1_2: int;
  var newtype$check#0_0_1_3: int;
  var newtype$check#0_0_1_4: int;
  var newtype$check#0_0_1_5: int;
  var ##s#0_0_1_1: Seq;
  var newtype$check#0_0_1_6: int;
  var newtype$check#0_0_1_7: int;
  var newtype$check#0_0_1_8: int;
  var newtype$check#0_0_1_9: int;
  var newtype$check#0_0_1_10: int;
  var newtype$check#0_0_1_11: int;
  var newtype$check#0_0_1_12: int;
  var newtype$check#0_0_1_13: int;
  var ##s#0_0_2_0: Seq;
  var newtype$check#0_0_2_0: int;
  var newtype$check#0_0_2_1: int;
  var newtype$check#0_0_2_2: int;
  var newtype$check#0_0_2_3: int;
  var ##s#0_0_2_1: Seq;
  var newtype$check#0_0_2_4: int;
  var newtype$check#0_0_2_5: int;
  var newtype$check#0_0_2_6: int;
  var newtype$check#0_0_2_7: int;
  var newtype$check#0_0_2_8: int;
  var newtype$check#0_0_2_9: int;
  var ##s#0_0_3_0: Seq;
  var newtype$check#0_0_3_0: int;
  var newtype$check#0_0_3_1: int;
  var ##s#0_0_3_1: Seq;
  var newtype$check#0_0_3_2: int;
  var newtype$check#0_0_3_3: int;
  var newtype$check#0_0_3_4: int;
  var newtype$check#0_0_3_5: int;
  var ##s#0_0_4_0: Seq;
  var ##s#0_0_4_1: Seq;
  var newtype$check#0_0_4_0: int;
  var newtype$check#0_0_4_1: int;
  var ##s#0_0_0: Seq;
  var newtype$check#1_0: int;
  var s##1_0: Seq;
  var s##1_1: Seq;
  var n##1_0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqWithUInt32Suffix", " | ", s#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UInt.dfy(300,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq :: $Is($ih#s0#0, TSeq(Tclass.BoundedInts.uint8())) && n#0 < StandardLibrary_mUInt.__default.UINT32__LIMIT() && LitInt(4) <= Seq#Length($ih#s0#0) && (var suffixStartIndex#1 := Seq#Length($ih#s0#0) - 4; Seq#Equal(Seq#Drop($ih#s0#0, suffixStartIndex#1), StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)) && (forall i#2: int :: { $Unbox(Seq#Index($ih#s0#0, i#2)): int } LitInt(0) <= i#2 && i#2 < suffixStartIndex#1 ==> $Unbox(Seq#Index($ih#s0#0, i#2)): int == LitInt(0))) && (Seq#Rank($ih#s0#0) < Seq#Rank(s#0) || (Seq#Rank($ih#s0#0) == Seq#Rank(s#0) && 0 <= n#0 && n#0 < n#0)) ==> StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), $ih#s0#0) == n#0);
    $_reverifyPost := false;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume false;
    goto anon14;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    ##s#0_0_4_0 := s#0;
    assume $IsAlloc(##s#0_0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0);
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    ##s#0_0_4_1 := Seq#Take(s#0, LitInt(3));
    assume $IsAlloc(##s#0_0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(3)));
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_4_0 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_4_0;
    newtype$check#0_0_4_1 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_4_1;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(3)));
    assume {:subsumption 0} StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), s#0) == Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(3))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume false;
    goto anon14;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    ##s#0_0_3_0 := Seq#Take(s#0, LitInt(3));
    assume $IsAlloc(##s#0_0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(3)));
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_3_0 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_3_0;
    newtype$check#0_0_3_1 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_3_1;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(3)));
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(Seq#Take(s#0, LitInt(3)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(3)), LitInt(2)), Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(Seq#Take(s#0, LitInt(3)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon6;

  anon20_Else:
    assume {:partition} !Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(3)), LitInt(2)), Seq#Take(s#0, LitInt(2)));
    goto anon6;

  anon6:
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(3)), LitInt(2)), Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} $Unbox(Seq#Index(Seq#Take(s#0, LitInt(3)), LitInt(2))): int == $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(3)), LitInt(2)), Seq#Take(s#0, LitInt(2))) && $Unbox(Seq#Index(Seq#Take(s#0, LitInt(3)), LitInt(2))): int == $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(307,61)"} true;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##s#0_0_3_1 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##s#0_0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_0_3_2 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_3_2;
    newtype$check#0_0_3_3 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_3_3;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_3_4 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_3_4;
    newtype$check#0_0_3_5 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_3_5;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(3))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int == Mul(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(2))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume false;
    goto anon14;

  anon19_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##s#0_0_2_0 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##s#0_0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_0_2_0 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_2_0;
    newtype$check#0_0_2_1 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_2_1;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_2_2 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_2_2;
    newtype$check#0_0_2_3 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_2_3;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(2)), LitInt(1)), Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon9;

  anon22_Else:
    assume {:partition} !Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(2)), LitInt(1)), Seq#Take(s#0, LitInt(1)));
    goto anon9;

  anon9:
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(2)), LitInt(1)), Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} $Unbox(Seq#Index(Seq#Take(s#0, LitInt(2)), LitInt(1))): int == $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(2)), LitInt(1)), Seq#Take(s#0, LitInt(1))) && $Unbox(Seq#Index(Seq#Take(s#0, LitInt(2)), LitInt(1))): int == $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(311,61)"} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0_0_2_1 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#0_0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_0_2_4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_2_4;
    newtype$check#0_0_2_5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_2_5;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_0_2_6 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_2_6;
    newtype$check#0_0_2_7 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_2_7;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_2_8 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_2_8;
    newtype$check#0_0_2_9 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_2_9;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} Mul(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(2))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int == Mul(Mul(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(1))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume false;
    goto anon14;

  anon21_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0_0_1_0 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#0_0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_0_1_0 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_1_0;
    newtype$check#0_0_1_1 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_1_1;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_0_1_2 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_1_2;
    newtype$check#0_0_1_3 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_1_3;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_1_4 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_1_4;
    newtype$check#0_0_1_5 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_1_5;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(s#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(1)), LitInt(0)), Seq#Take(s#0, LitInt(0)));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Take(s#0, LitInt(1)));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon12;

  anon24_Else:
    assume {:partition} !Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(1)), LitInt(0)), Seq#Take(s#0, LitInt(0)));
    goto anon12;

  anon12:
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(1)), LitInt(0)), Seq#Take(s#0, LitInt(0)));
    assume {:subsumption 0} $Unbox(Seq#Index(Seq#Take(s#0, LitInt(1)), LitInt(0))): int == $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume Seq#Equal(Seq#Take(Seq#Take(s#0, LitInt(1)), LitInt(0)), Seq#Take(s#0, LitInt(0))) && $Unbox(Seq#Index(Seq#Take(s#0, LitInt(1)), LitInt(0))): int == $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume {:captureState "StandardLibrary/src/UInt.dfy(316,61)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(s#0);
    ##s#0_0_1_1 := Seq#Take(s#0, LitInt(0));
    assume $IsAlloc(##s#0_0_1_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(0)));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_0_1_6 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_0_1_6;
    newtype$check#0_0_1_7 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_0_1_7;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_0_1_8 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_1_8;
    newtype$check#0_0_1_9 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_1_9;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_0_1_10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_1_10;
    newtype$check#0_0_1_11 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_1_11;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_1_12 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_1_12;
    newtype$check#0_0_1_13 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_1_13;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(0)));
    assume {:subsumption 0} Mul(Mul(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(1))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int == Mul(Mul(Mul(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(0))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume false;
    goto anon14;

  anon23_Else:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(s#0);
    ##s#0_0_0_0 := Seq#Take(s#0, LitInt(0));
    assume $IsAlloc(##s#0_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(0)));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0_0_0_0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_0_0_0;
    newtype$check#0_0_0_1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0_0_0_1;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#0_0_0_2 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_0_2;
    newtype$check#0_0_0_3 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#0_0_0_3;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#0_0_0_4 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_0_4;
    newtype$check#0_0_0_5 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#0_0_0_5;
    assume {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#0_0_0_6 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_0_6;
    newtype$check#0_0_0_7 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#0_0_0_7;
    assume StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, LitInt(0)));
    assume true;
    assume {:subsumption 0} Mul(Mul(Mul(Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($LS($LZ)), Seq#Take(s#0, LitInt(0))), LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(3))): int == n#0;
    assume false;
    goto anon14;

  anon25_Else:
    goto anon14;

  anon14:
    assume StandardLibrary_mUInt.__default.SeqToNat($LS($LZ), s#0) == n#0;
    return;

  anon16_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(4);
    newtype$check#1_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume true;
    assume Seq#Equal(s#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))), Seq#Drop(s#0, LitInt(1))));
    assume {:captureState "StandardLibrary/src/UInt.dfy(326,30)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume true;
    s##1_0 := Seq#Drop(s#0, LitInt(1));
    call CallPre$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s##1_0);
    call CallPost$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s##1_0);
    assume {:captureState "StandardLibrary/src/UInt.dfy(327,32)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume true;
    s##1_1 := Seq#Drop(s#0, LitInt(1));
    assume true;
    n##1_0 := n#0;
    assume 0 <= n#0 || Seq#Rank(s##1_1) < Seq#Rank(s#0) || n##1_0 == n#0;
    assume Seq#Rank(s##1_1) < Seq#Rank(s#0) || (Seq#Rank(s##1_1) == Seq#Rank(s#0) && n##1_0 < n#0);
    call CallPre$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s##1_1, n##1_0);
    call CallPost$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s##1_1, n##1_0);
    assume {:captureState "StandardLibrary/src/UInt.dfy(328,36)"} true;
    return;
}



procedure {:verboseName "StandardLibrary.UInt.seq16 (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary.UInt.seq16$T)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.seq16 (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T: Ty, s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.seq16", " | ", StandardLibrary.UInt.seq16$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(27,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary.UInt.seq16$T), $Heap);
    assume StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt.seq16$T, s#0);
    assume StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt.seq16$T, s#0);
    return;

  anon4_Else:
    assume StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt.seq16$T, Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt.seq16$T, Lit(Seq#Empty(): Seq)) ==> Lit(StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt.seq16$T, Lit(Seq#Empty(): Seq))) || Seq#Length(Lit(Seq#Empty(): Seq)) < StandardLibrary_mUInt.__default.UINT16__LIMIT();
    return;
}



function Tclass.StandardLibrary_mUInt.seq16(Ty) : Ty;

const unique Tagclass.StandardLibrary_mUInt.seq16: TyTag;

axiom (forall StandardLibrary.UInt.seq16$T: Ty :: { Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T) } Tag(Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) == Tagclass.StandardLibrary_mUInt.seq16 && TagFamily(Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) == tytagFamily$seq16);

function Tclass.StandardLibrary_mUInt.seq16_0(Ty) : Ty;

axiom (forall StandardLibrary.UInt.seq16$T: Ty :: { Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T) } Tclass.StandardLibrary_mUInt.seq16_0(Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) == StandardLibrary.UInt.seq16$T);

axiom (forall StandardLibrary.UInt.seq16$T: Ty, bx: Box :: { $IsBox(bx, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) } $IsBox(bx, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)));

axiom (forall StandardLibrary.UInt.seq16$T: Ty, s#0: Seq :: { $Is(s#0, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) } $Is(s#0, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T)) <==> $Is(s#0, TSeq(StandardLibrary.UInt.seq16$T)) && StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt.seq16$T, s#0));

axiom (forall StandardLibrary.UInt.seq16$T: Ty, s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T), $h) } $IsAlloc(s#0, Tclass.StandardLibrary_mUInt.seq16(StandardLibrary.UInt.seq16$T), $h) <==> $IsAlloc(s#0, TSeq(StandardLibrary.UInt.seq16$T), $h));

procedure {:verboseName "StandardLibrary.UInt.seq32 (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary.UInt.seq32$T)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.seq32 (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T: Ty, s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.seq32", " | ", StandardLibrary.UInt.seq32$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(34,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary.UInt.seq32$T), $Heap);
    assume StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt.seq32$T, s#0);
    assume StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt.seq32$T, s#0);
    return;

  anon4_Else:
    assume StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt.seq32$T, Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt.seq32$T, Lit(Seq#Empty(): Seq)) ==> Lit(StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt.seq32$T, Lit(Seq#Empty(): Seq))) || Seq#Length(Lit(Seq#Empty(): Seq)) < StandardLibrary_mUInt.__default.UINT32__LIMIT();
    return;
}



function Tclass.StandardLibrary_mUInt.seq32(Ty) : Ty;

const unique Tagclass.StandardLibrary_mUInt.seq32: TyTag;

axiom (forall StandardLibrary.UInt.seq32$T: Ty :: { Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T) } Tag(Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) == Tagclass.StandardLibrary_mUInt.seq32 && TagFamily(Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) == tytagFamily$seq32);

function Tclass.StandardLibrary_mUInt.seq32_0(Ty) : Ty;

axiom (forall StandardLibrary.UInt.seq32$T: Ty :: { Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T) } Tclass.StandardLibrary_mUInt.seq32_0(Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) == StandardLibrary.UInt.seq32$T);

axiom (forall StandardLibrary.UInt.seq32$T: Ty, bx: Box :: { $IsBox(bx, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) } $IsBox(bx, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)));

axiom (forall StandardLibrary.UInt.seq32$T: Ty, s#0: Seq :: { $Is(s#0, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) } $Is(s#0, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T)) <==> $Is(s#0, TSeq(StandardLibrary.UInt.seq32$T)) && StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt.seq32$T, s#0));

axiom (forall StandardLibrary.UInt.seq32$T: Ty, s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T), $h) } $IsAlloc(s#0, Tclass.StandardLibrary_mUInt.seq32(StandardLibrary.UInt.seq32$T), $h) <==> $IsAlloc(s#0, TSeq(StandardLibrary.UInt.seq32$T), $h));

procedure {:verboseName "StandardLibrary.UInt.seq64 (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary.UInt.seq64$T)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt.seq64 (well-formedness)"} CheckWellFormed$$StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T: Ty, s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.seq64", " | ", StandardLibrary.UInt.seq64$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UInt.dfy(41,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary.UInt.seq64$T), $Heap);
    assume StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt.seq64$T, s#0);
    assume StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt.seq64$T, s#0);
    return;

  anon4_Else:
    assume StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt.seq64$T, Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt.seq64$T, Lit(Seq#Empty(): Seq)) ==> Lit(StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt.seq64$T, Lit(Seq#Empty(): Seq))) || Seq#Length(Lit(Seq#Empty(): Seq)) < StandardLibrary_mUInt.__default.UINT64__LIMIT();
    return;
}



function Tclass.StandardLibrary_mUInt.seq64(Ty) : Ty;

const unique Tagclass.StandardLibrary_mUInt.seq64: TyTag;

axiom (forall StandardLibrary.UInt.seq64$T: Ty :: { Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T) } Tag(Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) == Tagclass.StandardLibrary_mUInt.seq64 && TagFamily(Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) == tytagFamily$seq64);

function Tclass.StandardLibrary_mUInt.seq64_0(Ty) : Ty;

axiom (forall StandardLibrary.UInt.seq64$T: Ty :: { Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T) } Tclass.StandardLibrary_mUInt.seq64_0(Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) == StandardLibrary.UInt.seq64$T);

axiom (forall StandardLibrary.UInt.seq64$T: Ty, bx: Box :: { $IsBox(bx, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) } $IsBox(bx, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)));

axiom (forall StandardLibrary.UInt.seq64$T: Ty, s#0: Seq :: { $Is(s#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) } $Is(s#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T)) <==> $Is(s#0, TSeq(StandardLibrary.UInt.seq64$T)) && StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt.seq64$T, s#0));

axiom (forall StandardLibrary.UInt.seq64$T: Ty, s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T), $h) } $IsAlloc(s#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.UInt.seq64$T), $h) <==> $IsAlloc(s#0, TSeq(StandardLibrary.UInt.seq64$T), $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__0(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__0(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__0(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__1(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__1(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__1(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__2(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__2(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__2(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__4(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__4(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__4(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__5(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__5(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__5(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__8(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__8(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__8(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__16(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__16(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__16(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__24(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__24(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__24(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__32(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__32(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__32(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__40(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__40(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__40(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__48(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__48(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__48(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__56(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__56(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__56(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__64(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__64(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__64(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__128(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__128(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__128(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__256(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__256(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__256(), TInt, $h));

axiom $Is(BoundedInts.__default.TWO__TO__THE__512(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.TWO__TO__THE__512(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.TWO__TO__THE__512(), TInt, $h));

axiom $Is(BoundedInts.__default.UINT8__MAX(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT8__MAX(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT8__MAX(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(BoundedInts.__default.UINT16__MAX(), Tclass.BoundedInts.uint16());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT16__MAX(), Tclass.BoundedInts.uint16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT16__MAX(), Tclass.BoundedInts.uint16(), $h));

axiom $Is(BoundedInts.__default.UINT32__MAX(), Tclass.BoundedInts.uint32());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT32__MAX(), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT32__MAX(), Tclass.BoundedInts.uint32(), $h));

axiom $Is(BoundedInts.__default.UINT64__MAX(), Tclass.BoundedInts.uint64());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.UINT64__MAX(), Tclass.BoundedInts.uint64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.UINT64__MAX(), Tclass.BoundedInts.uint64(), $h));

axiom $Is(BoundedInts.__default.INT8__MIN(), Tclass.BoundedInts.int8());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT8__MIN(), Tclass.BoundedInts.int8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT8__MIN(), Tclass.BoundedInts.int8(), $h));

axiom $Is(BoundedInts.__default.INT8__MAX(), Tclass.BoundedInts.int8());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT8__MAX(), Tclass.BoundedInts.int8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT8__MAX(), Tclass.BoundedInts.int8(), $h));

axiom $Is(BoundedInts.__default.INT16__MIN(), Tclass.BoundedInts.int16());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT16__MIN(), Tclass.BoundedInts.int16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT16__MIN(), Tclass.BoundedInts.int16(), $h));

axiom $Is(BoundedInts.__default.INT16__MAX(), Tclass.BoundedInts.int16());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT16__MAX(), Tclass.BoundedInts.int16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT16__MAX(), Tclass.BoundedInts.int16(), $h));

axiom $Is(BoundedInts.__default.INT32__MIN(), Tclass.BoundedInts.int32());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT32__MIN(), Tclass.BoundedInts.int32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT32__MIN(), Tclass.BoundedInts.int32(), $h));

axiom $Is(BoundedInts.__default.INT32__MAX(), Tclass.BoundedInts.int32());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT32__MAX(), Tclass.BoundedInts.int32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT32__MAX(), Tclass.BoundedInts.int32(), $h));

axiom $Is(BoundedInts.__default.INT64__MIN(), Tclass.BoundedInts.int64());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT64__MIN(), Tclass.BoundedInts.int64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT64__MIN(), Tclass.BoundedInts.int64(), $h));

axiom $Is(BoundedInts.__default.INT64__MAX(), Tclass.BoundedInts.int64());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.INT64__MAX(), Tclass.BoundedInts.int64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.INT64__MAX(), Tclass.BoundedInts.int64(), $h));

axiom $Is(BoundedInts.__default.NAT8__MAX(), Tclass.BoundedInts.nat8());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT8__MAX(), Tclass.BoundedInts.nat8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT8__MAX(), Tclass.BoundedInts.nat8(), $h));

axiom $Is(BoundedInts.__default.NAT16__MAX(), Tclass.BoundedInts.nat16());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT16__MAX(), Tclass.BoundedInts.nat16(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT16__MAX(), Tclass.BoundedInts.nat16(), $h));

axiom $Is(BoundedInts.__default.NAT32__MAX(), Tclass.BoundedInts.nat32());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT32__MAX(), Tclass.BoundedInts.nat32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT32__MAX(), Tclass.BoundedInts.nat32(), $h));

axiom $Is(BoundedInts.__default.NAT64__MAX(), Tclass.BoundedInts.nat64());

axiom (forall $h: Heap :: { $IsAlloc(BoundedInts.__default.NAT64__MAX(), Tclass.BoundedInts.nat64(), $h) } $IsGoodHeap($h) ==> $IsAlloc(BoundedInts.__default.NAT64__MAX(), Tclass.BoundedInts.nat64(), $h));

const unique tytagFamily$seq16: TyTagFamily;

const unique tytagFamily$seq32: TyTagFamily;

const unique tytagFamily$seq64: TyTagFamily;

const unique class.StandardLibrary_mSequence.__default: ClassName;

function StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || (2 < $FunctionContextHeight && $Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) ==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0)));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || (2 < $FunctionContextHeight && $Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> (!(Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(seq2#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT()) ==> StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0)) && (StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> (if Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(seq2#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() then Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0)) else StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: {:weight 3} { StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) } StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) || (2 < $FunctionContextHeight && $Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 && LitInt(start1#0 + size#0) <= Seq#Length(Lit(seq1#0)) && LitInt(start2#0 + size#0) <= Seq#Length(Lit(seq2#0))) ==> (!(Seq#Length(Lit(seq1#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(Lit(seq2#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT()) ==> StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0))) && (StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) <==> (if Seq#Length(Lit(seq1#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(Lit(seq2#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() then Seq#Equal(Seq#Drop(Seq#Take(Lit(seq1#0), LitInt(start1#0 + size#0)), LitInt(start1#0)), Seq#Drop(Seq#Take(Lit(seq2#0), LitInt(start2#0 + size#0)), LitInt(start2#0))) else StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)))));
}

function StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) : bool;

function StandardLibrary_mSequence.__default.SequenceEqualNat#requires(Ty, Seq, Seq, int, int, int) : bool;

axiom (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqualNat#requires(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } $Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 ==> (StandardLibrary_mSequence.__default.SequenceEqualNat#requires(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)));

procedure {:verboseName "StandardLibrary.Sequence.SequenceEqualNat (well-formedness)"} CheckWellformed$$StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq where $Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)), seq2#0: Seq where $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)), start1#0: int where LitInt(0) <= start1#0, start2#0: int where LitInt(0) <= start2#0, size#0: int where LitInt(0) <= size#0) returns (ret#0: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id1598"} ret#0 ==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Sequence.SequenceEqualNat (well-formedness)"} CheckWellformed$$StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) returns (ret#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##seq1#0: Seq;
  var ##seq2#0: Seq;
  var ##start1#0: int;
  var ##start2#0: int;
  var ##size#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Sequence.SequenceEqualNat", " | ", StandardLibrary.Sequence._default.SequenceEqualNat$T, " | ", seq1#0, " | ", seq2#0, " | ", start1#0, " | ", start2#0, " | ", size#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(10,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume start1#0 + size#0 <= Seq#Length(seq1#0);
    assume start2#0 + size#0 <= Seq#Length(seq2#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume ret#0;
    assume 0 <= start1#0 && start1#0 <= Seq#Length(seq1#0);
    assume start1#0 <= start1#0 + size#0 && start1#0 + size#0 <= Seq#Length(seq1#0);
    assume 0 <= start2#0 && start2#0 <= Seq#Length(seq2#0);
    assume start2#0 <= start2#0 + size#0 && start2#0 + size#0 <= Seq#Length(seq2#0);
    assume Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));
    goto anon5;

  anon13_Else:
    assume ret#0 ==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() >= Seq#Length(seq1#0);
    goto anon8;

  anon14_Else:
    assume {:partition} Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT();
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(seq2#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT();
    assume 0 <= start1#0 && start1#0 <= Seq#Length(seq1#0);
    assume start1#0 <= start1#0 + size#0 && start1#0 + size#0 <= Seq#Length(seq1#0);
    assume 0 <= start2#0 && start2#0 <= Seq#Length(seq2#0);
    assume start2#0 <= start2#0 + size#0 && start2#0 + size#0 <= Seq#Length(seq2#0);
    assume StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));
    assume true;
    assume $Is(StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0), TBool);
    goto anon11;

  anon15_Else:
    assume {:partition} !(Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(seq2#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT());
    newtype$check#0 := start1#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#1 := start1#0;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#2 := start2#0;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#3 := start2#0;
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#4 := size#0;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#5 := size#0;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__64();
    assume $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqualNat$T));
    ##seq1#0 := seq1#0;
    assume $IsAlloc(##seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqualNat$T), $Heap);
    assume $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqualNat$T));
    ##seq2#0 := seq2#0;
    assume $IsAlloc(##seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqualNat$T), $Heap);
    ##start1#0 := start1#0;
    assume $IsAlloc(##start1#0, Tclass.BoundedInts.uint64(), $Heap);
    ##start2#0 := start2#0;
    assume $IsAlloc(##start2#0, Tclass.BoundedInts.uint64(), $Heap);
    ##size#0 := size#0;
    assume $IsAlloc(##size#0, Tclass.BoundedInts.uint64(), $Heap);
    assume {:subsumption 0} ##start1#0 + ##size#0 <= Seq#Length(##seq1#0);
    assume ##start1#0 + ##size#0 <= Seq#Length(##seq1#0);
    assume {:subsumption 0} ##start2#0 + ##size#0 <= Seq#Length(##seq2#0);
    assume ##start2#0 + ##size#0 <= Seq#Length(##seq2#0);
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    assume StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    assume $Is(StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0), TBool);
    goto anon11;

  anon11:
    assume StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> ret#0;
    return;
}



function StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || (0 < $FunctionContextHeight && $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> (StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || (0 < $FunctionContextHeight && $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> (StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: {:weight 3} { StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) } StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) || (0 < $FunctionContextHeight && $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(start1#0 + size#0) <= Seq#Length(Lit(seq1#0)) && LitInt(start2#0 + size#0) <= Seq#Length(Lit(seq2#0))) ==> (StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) <==> Seq#Equal(Seq#Drop(Seq#Take(Lit(seq1#0), LitInt(start1#0 + size#0)), LitInt(start1#0)), Seq#Drop(Seq#Take(Lit(seq2#0), LitInt(start2#0 + size#0)), LitInt(start2#0)))));
}

function StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) : bool;

function StandardLibrary_mSequence.__default.SequenceEqual#requires(Ty, Seq, Seq, int, int, int) : bool;

axiom (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqual#requires(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() ==> (StandardLibrary_mSequence.__default.SequenceEqual#requires(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)));

procedure {:verboseName "StandardLibrary.Sequence.SequenceEqual (well-formedness)"} CheckWellformed$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq where $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)), seq2#0: Seq where $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)), start1#0: int where LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64(), start2#0: int where LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64(), size#0: int where LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64()) returns (ret#0: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id1625"} ret#0 <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Sequence.SequenceEqual (well-formedness)"} CheckWellformed$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) returns (ret#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Sequence.SequenceEqual", " | ", StandardLibrary.Sequence._default.SequenceEqual$T, " | ", seq1#0, " | ", seq2#0, " | ", start1#0, " | ", start2#0, " | ", size#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(22,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := start1#0;
    assume LitInt(0) <= newtype$check#0;
    newtype$check#1 := start1#0;
    assume LitInt(0) <= newtype$check#1;
    newtype$check#2 := size#0;
    assume LitInt(0) <= newtype$check#2;
    newtype$check#3 := size#0;
    assume LitInt(0) <= newtype$check#3;
    assume start1#0 + size#0 <= Seq#Length(seq1#0);
    newtype$check#4 := start2#0;
    assume LitInt(0) <= newtype$check#4;
    newtype$check#5 := start2#0;
    assume LitInt(0) <= newtype$check#5;
    newtype$check#6 := size#0;
    assume LitInt(0) <= newtype$check#6;
    newtype$check#7 := size#0;
    assume LitInt(0) <= newtype$check#7;
    assume start2#0 + size#0 <= Seq#Length(seq2#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume 0 <= start1#0 && start1#0 <= Seq#Length(seq1#0);
    newtype$check#8 := start1#0 + size#0;
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__64();
    assume start1#0 <= start1#0 + size#0 && start1#0 + size#0 <= Seq#Length(seq1#0);
    assume 0 <= start2#0 && start2#0 <= Seq#Length(seq2#0);
    newtype$check#9 := start2#0 + size#0;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__64();
    assume start2#0 <= start2#0 + size#0 && start2#0 + size#0 <= Seq#Length(seq2#0);
    assume ret#0 <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));
    assume false;
    return;

  anon4_Else:
    assume 0 <= start1#0 && start1#0 <= Seq#Length(seq1#0);
    newtype$check#10 := start1#0 + size#0;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__64();
    assume start1#0 <= start1#0 + size#0 && start1#0 + size#0 <= Seq#Length(seq1#0);
    assume 0 <= start2#0 && start2#0 <= Seq#Length(seq2#0);
    newtype$check#11 := start2#0 + size#0;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__64();
    assume start2#0 <= start2#0 + size#0 && start2#0 + size#0 <= Seq#Length(seq2#0);
    assume StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0));
    assume true;
    assume $Is(StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0), TBool);
    assume StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> ret#0;
    return;
}



procedure {:verboseName "StandardLibrary.Sequence.SequenceEqual (correctness)"} Impl$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq where $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), seq2#0: Seq where $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), start1#0: int where LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64(), start2#0: int where LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64(), size#0: int where LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64()) returns (defass#ret#0: bool, ret#0: bool, $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id1651"} start1#0 + size#0 <= Seq#Length(seq1#0);
  requires {:id "id1652"} start2#0 + size#0 <= Seq#Length(seq2#0);
  modifies $Heap;
  free ensures StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
  free ensures {:id "id1653"} ret#0 <==> StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Sequence.SequenceEqual (correctness)"} Impl$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) returns (defass#ret#0: bool, ret#0: bool, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var j#0: int where LitInt(0) <= j#0 && j#0 < BoundedInts.__default.TWO__TO__THE__64();
  var newtype$check#0: int;
  var newtype$check#1: int;
  var i#0: int;
  var i#0#lo: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var i#0#hi: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var i#0#x: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#ret#0: bool;
  var $w$loop#0: bool;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var k#0: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Sequence.SequenceEqual", " | ", StandardLibrary.Sequence._default.SequenceEqual$T, " | ", seq1#0, " | ", seq2#0, " | ", start1#0, " | ", start2#0, " | ", size#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sequence.dfy(28,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    newtype$check#0 := start2#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#1 := start2#0;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    j#0 := start2#0;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(29,29)"} true;
    newtype$check#2 := start1#0;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#3 := start1#0;
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__64();
    i#0#lo := start1#0;
    newtype$check#4 := start1#0 + size#0;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#5 := start1#0 + size#0;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#6 := start1#0 + size#0;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__64();
    i#0#hi := start1#0 + size#0;
    assume i#0#lo <= i#0#hi;
    havoc i#0#x;
    assume i#0#lo <= i#0#x && i#0#x <= i#0#hi;
    assume $Is(i#0#x, Tclass.BoundedInts.uint64());
    i#0 := i#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#ret#0 := defass#ret#0;
    havoc $w$loop#0;
    goto anon17_LoopHead;

  anon17_LoopHead:
    assume i#0#lo <= i#0 && i#0 <= i#0#hi;
    assume true;
    assume $w$loop#0 ==> j#0 == i#0 - start1#0 + start2#0;
    assume true;
    assume $w$loop#0 ==> (forall k#1: int :: { Seq#Index(seq1#0, k#1) } LitInt(0) <= k#1 && k#1 < BoundedInts.__default.TWO__TO__THE__64() && start1#0 <= k#1 && k#1 < i#0 ==> Seq#Index(seq1#0, k#1) == Seq#Index(seq2#0, k#1 - start1#0 + start2#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#ret#0 ==> defass#ret#0;
    assume true;
    goto anon17_LoopDone, anon17_LoopBody;

  anon17_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(30,4): after some loop iterations"} true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} !$w$loop#0;
    newtype$check#7 := i#0 - start1#0;
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#8 := i#0 - start1#0 + start2#0;
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    assume j#0 == i#0 - start1#0 + start2#0;
    havoc k#0;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= k#0 && k#0 < BoundedInts.__default.TWO__TO__THE__64();
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} start1#0 <= k#0;
    goto anon5;

  anon20_Else:
    assume {:partition} k#0 < start1#0;
    goto anon5;

  anon5:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} start1#0 <= k#0 && k#0 < i#0;
    assume {:subsumption 0} 0 <= k#0 && k#0 < Seq#Length(seq1#0);
    newtype$check#9 := k#0 - start1#0;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#10 := k#0 - start1#0 + start2#0;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__64();
    assume {:subsumption 0} 0 <= k#0 - start1#0 + start2#0 && k#0 - start1#0 + start2#0 < Seq#Length(seq2#0);
    goto anon7;

  anon21_Else:
    assume {:partition} !(start1#0 <= k#0 && k#0 < i#0);
    goto anon7;

  anon19_Else:
    assume {:partition} !(LitInt(0) <= k#0 && k#0 < BoundedInts.__default.TWO__TO__THE__64());
    goto anon7;

  anon7:
    assume true;
    assume (forall k#1: int :: { Seq#Index(seq1#0, k#1) } LitInt(0) <= k#1 && k#1 < BoundedInts.__default.TWO__TO__THE__64() && start1#0 <= k#1 && k#1 < i#0 ==> Seq#Index(seq1#0, k#1) == Seq#Index(seq2#0, k#1 - start1#0 + start2#0));
    assume false;
    goto anon8;

  anon18_Else:
    assume {:partition} $w$loop#0;
    goto anon8;

  anon8:
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} i#0 == i#0#hi;
    goto anon15;

  anon22_Else:
    assume {:partition} i#0 != i#0#hi;
    push;
    assume 0 <= i#0 && i#0 < Seq#Length(seq1#0);
    assume 0 <= j#0 && j#0 < Seq#Length(seq2#0);
    assume true;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Index(seq1#0, i#0) != Seq#Index(seq2#0, j#0);
    push;
    assume true;
    assume true;
    ret#0 := Lit(false);
    defass#ret#0 := true;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(35,20)"} true;
    assume defass#ret#0;
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    pop;
    pop;
    return;

  anon23_Else:
    assume {:partition} Seq#Index(seq1#0, i#0) == Seq#Index(seq2#0, j#0);
    assume true;
    newtype$check#0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#0_1 := j#0 + 1;
    assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    j#0 := j#0 + 1;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(37,16)"} true;
    pop;
    i#0 := i#0 + 1;
    assume true;
    goto anon17_LoopHead;

  anon17_LoopDone:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume true;
    assume true;
    ret#0 := Lit(true);
    defass#ret#0 := true;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(39,15)"} true;
    assume defass#ret#0;
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    return;
}



procedure {:verboseName "StandardLibrary.Sequence.SequenceEqual (well-formedness)"} CheckWellFormed$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq where $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), seq2#0: Seq where $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), start1#0: int where LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64(), start2#0: int where LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64(), size#0: int where LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64()) returns (ret#0: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Sequence.SequenceEqual (well-formedness)"} CheckWellFormed$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) returns (ret#0: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var ##seq1#0: Seq;
  var ##seq2#0: Seq;
  var ##start1#0: int;
  var ##start2#0: int;
  var ##size#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Sequence.SequenceEqual", " | ", StandardLibrary.Sequence._default.SequenceEqual$T, " | ", seq1#0, " | ", seq2#0, " | ", start1#0, " | ", start2#0, " | ", size#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sequence.dfy(22,12): initial state"} true;
    newtype$check#11 := start1#0;
    assume LitInt(0) <= newtype$check#11;
    newtype$check#12 := start1#0;
    assume LitInt(0) <= newtype$check#12;
    newtype$check#13 := size#0;
    assume LitInt(0) <= newtype$check#13;
    newtype$check#14 := size#0;
    assume LitInt(0) <= newtype$check#14;
    assume start1#0 + size#0 <= Seq#Length(seq1#0);
    newtype$check#15 := start2#0;
    assume LitInt(0) <= newtype$check#15;
    newtype$check#16 := start2#0;
    assume LitInt(0) <= newtype$check#16;
    newtype$check#17 := size#0;
    assume LitInt(0) <= newtype$check#17;
    newtype$check#18 := size#0;
    assume LitInt(0) <= newtype$check#18;
    assume start2#0 + size#0 <= Seq#Length(seq2#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc ret#0;
    assume {:captureState "StandardLibrary/src/Sequence.dfy(28,4): post-state"} true;
    ##seq1#0 := seq1#0;
    assume $IsAlloc(##seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap);
    ##seq2#0 := seq2#0;
    assume $IsAlloc(##seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap);
    ##start1#0 := start1#0;
    assume $IsAlloc(##start1#0, Tclass.BoundedInts.uint64(), $Heap);
    ##start2#0 := start2#0;
    assume $IsAlloc(##start2#0, Tclass.BoundedInts.uint64(), $Heap);
    ##size#0 := size#0;
    assume $IsAlloc(##size#0, Tclass.BoundedInts.uint64(), $Heap);
    assume {:subsumption 0} ##start1#0 + ##size#0 <= Seq#Length(##seq1#0);
    assume ##start1#0 + ##size#0 <= Seq#Length(##seq1#0);
    assume {:subsumption 0} ##start2#0 + ##size#0 <= Seq#Length(##seq2#0);
    assume ##start2#0 + ##size#0 <= Seq#Length(##seq2#0);
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    assume ret#0 <==> StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    return;
}



procedure {:verboseName "StandardLibrary.Sequence.SequenceEqual (call precondtion)"} CallPre$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq where $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), seq2#0: Seq where $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), start1#0: int where LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64(), start2#0: int where LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64(), size#0: int where LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64());
  requires {:id "id1697"} start1#0 + size#0 <= Seq#Length(seq1#0);
  requires {:id "id1698"} start2#0 + size#0 <= Seq#Length(seq2#0);



procedure {:verboseName "StandardLibrary.Sequence.SequenceEqual (call postcondition)"} CallPost$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq where $Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), seq2#0: Seq where $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $IsAlloc(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T), $Heap), start1#0: int where LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64(), start2#0: int where LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64(), size#0: int where LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64()) returns (ret#0: bool);
  modifies $Heap;
  free ensures StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
  free ensures {:id "id1699"} ret#0 <==> StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom $Is(StandardLibrary_mUInt.__default.UINT16__LIMIT(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT16__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT16__LIMIT(), TInt, $h));

axiom $Is(StandardLibrary_mUInt.__default.UINT32__LIMIT(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT32__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT32__LIMIT(), TInt, $h));

axiom $Is(StandardLibrary_mUInt.__default.UINT64__LIMIT(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT64__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT64__LIMIT(), TInt, $h));

axiom $Is(StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.INT32__MAX__LIMIT(), TInt, $h));

axiom $Is(StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.INT64__MAX__LIMIT(), TInt, $h));

axiom $Is(StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(), TInt);

axiom (forall $h: Heap :: { $IsAlloc(StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(), TInt, $h) } $IsGoodHeap($h) ==> $IsAlloc(StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT(), TInt, $h));

axiom (forall a#0: int, b#0: int :: { StandardLibrary_mUInt.__default.UInt8Less(a#0, b#0) } StandardLibrary_mUInt.__default.UInt8Less#canCall(a#0, b#0) || (LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (StandardLibrary_mUInt.__default.UInt8Less(a#0, b#0) <==> a#0 < b#0));

axiom (forall a#0: int, b#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt8Less(LitInt(a#0), LitInt(b#0)) } StandardLibrary_mUInt.__default.UInt8Less#canCall(LitInt(a#0), LitInt(b#0)) || (LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (StandardLibrary_mUInt.__default.UInt8Less(LitInt(a#0), LitInt(b#0)) <==> Lit(a#0 < b#0)));

axiom (forall StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, s#0) } StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt._default.HasUint16Len$T, s#0) || $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint16Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, s#0) <==> Seq#Length(s#0) < StandardLibrary_mUInt.__default.UINT16__LIMIT()));

axiom (forall StandardLibrary.UInt._default.HasUint16Len$T: Ty, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, Lit(s#0)) } StandardLibrary_mUInt.__default.HasUint16Len#canCall(StandardLibrary.UInt._default.HasUint16Len$T, Lit(s#0)) || $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint16Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint16Len(StandardLibrary.UInt._default.HasUint16Len$T, Lit(s#0)) <==> Seq#Length(Lit(s#0)) < StandardLibrary_mUInt.__default.UINT16__LIMIT()));

axiom (forall StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, s#0) } StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt._default.HasUint32Len$T, s#0) || $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint32Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, s#0) <==> Seq#Length(s#0) < StandardLibrary_mUInt.__default.UINT32__LIMIT()));

axiom (forall StandardLibrary.UInt._default.HasUint32Len$T: Ty, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, Lit(s#0)) } StandardLibrary_mUInt.__default.HasUint32Len#canCall(StandardLibrary.UInt._default.HasUint32Len$T, Lit(s#0)) || $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint32Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint32Len(StandardLibrary.UInt._default.HasUint32Len$T, Lit(s#0)) <==> Seq#Length(Lit(s#0)) < StandardLibrary_mUInt.__default.UINT32__LIMIT()));

axiom (forall StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq :: { StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, s#0) } StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt._default.HasUint64Len$T, s#0) || $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint64Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, s#0) <==> Seq#Length(s#0) < StandardLibrary_mUInt.__default.UINT64__LIMIT()));

axiom (forall StandardLibrary.UInt._default.HasUint64Len$T: Ty, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, Lit(s#0)) } StandardLibrary_mUInt.__default.HasUint64Len#canCall(StandardLibrary.UInt._default.HasUint64Len$T, Lit(s#0)) || $Is(s#0, TSeq(StandardLibrary.UInt._default.HasUint64Len$T)) ==> (StandardLibrary_mUInt.__default.HasUint64Len(StandardLibrary.UInt._default.HasUint64Len$T, Lit(s#0)) <==> Seq#Length(Lit(s#0)) < StandardLibrary_mUInt.__default.UINT64__LIMIT()));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> Seq#Length(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0)) == LitInt(2) && Mul(LitInt(256), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), LitInt(0))): int) + $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), LitInt(1))): int == x#0 && $Is(StandardLibrary_mUInt.__default.UInt16ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#2 := Div(x#0, LitInt(256)); (var b1#2 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#2)), $Box(b1#2)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#3 := LitInt(Div(x#0, LitInt(256))); (var b1#3 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#3)), $Box(b1#3))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt16ToSeq(StandardLibrary_mUInt.__default.SeqToUInt16(s#0)), s#0) && StandardLibrary_mUInt.__default.SeqToUInt16(s#0) >= LitInt(0) && LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt16(s#0) && StandardLibrary_mUInt.__default.SeqToUInt16(s#0) < BoundedInts.__default.TWO__TO__THE__16());

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#2 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#2 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#3 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#3 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> Seq#Length(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0)) == LitInt(4) && Mul(LitInt(16777216), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(0))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(1))): int) + Mul(LitInt(256), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(2))): int) + $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), LitInt(3))): int == x#0 && $Is(StandardLibrary_mUInt.__default.UInt32ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#2 := Div(x#0, LitInt(16777216)); (var x0#2 := x#0 - Mul(b0#2, LitInt(16777216)); (var b1#2 := Div(x0#2, LitInt(65536)); (var x1#2 := x0#2 - Mul(b1#2, LitInt(65536)); (var b2#2 := Div(x1#2, LitInt(256)); (var b3#2 := Mod(x1#2, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#2)), $Box(b1#2)), $Box(b2#2)), $Box(b3#2)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#3 := LitInt(Div(x#0, LitInt(16777216))); (var x0#3 := LitInt(x#0 - Mul(b0#3, LitInt(16777216))); (var b1#3 := LitInt(Div(x0#3, LitInt(65536))); (var x1#3 := LitInt(x0#3 - Mul(b1#3, LitInt(65536))); (var b2#3 := LitInt(Div(x1#3, LitInt(256))); (var b3#3 := LitInt(Mod(x1#3, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#3)), $Box(b1#3)), $Box(b2#3)), $Box(b3#3))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq(StandardLibrary_mUInt.__default.SeqToUInt32(s#0)), s#0) && LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt32(s#0) && StandardLibrary_mUInt.__default.SeqToUInt32(s#0) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#2 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#2 := x0#2 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#2 := x1#2 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#2 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#3 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#3 := x0#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#3 := x1#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#3 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> Seq#Length(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0)) == LitInt(8) && Mul(LitInt(72057594037927936), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(0))): int) + Mul(LitInt(281474976710656), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(1))): int) + Mul(LitInt(1099511627776), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(2))): int) + Mul(LitInt(4294967296), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(3))): int) + Mul(LitInt(16777216), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(4))): int) + Mul(LitInt(65536), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(5))): int) + Mul(LitInt(256), $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(6))): int) + $Unbox(Seq#Index(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), LitInt(7))): int == x#0 && $Is(StandardLibrary_mUInt.__default.UInt64ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#2 := Div(x#0, LitInt(72057594037927936)); (var x0#2 := x#0 - Mul(b0#2, LitInt(72057594037927936)); (var b1#2 := Div(x0#2, LitInt(281474976710656)); (var x1#2 := x0#2 - Mul(b1#2, LitInt(281474976710656)); (var b2#2 := Div(x1#2, LitInt(1099511627776)); (var x2#2 := x1#2 - Mul(b2#2, LitInt(1099511627776)); (var b3#2 := Div(x2#2, LitInt(4294967296)); (var x3#2 := x2#2 - Mul(b3#2, LitInt(4294967296)); (var b4#2 := Div(x3#2, LitInt(16777216)); (var x4#2 := x3#2 - Mul(b4#2, LitInt(16777216)); (var b5#2 := Div(x4#2, LitInt(65536)); (var x5#2 := x4#2 - Mul(b5#2, LitInt(65536)); (var b6#2 := Div(x5#2, LitInt(256)); (var b7#2 := Mod(x5#2, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#2)), $Box(b1#2)), $Box(b2#2)), $Box(b3#2)), $Box(b4#2)), $Box(b5#2)), $Box(b6#2)), $Box(b7#2)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#3 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#3 := LitInt(x#0 - Mul(b0#3, LitInt(72057594037927936))); (var b1#3 := LitInt(Div(x0#3, LitInt(281474976710656))); (var x1#3 := LitInt(x0#3 - Mul(b1#3, LitInt(281474976710656))); (var b2#3 := LitInt(Div(x1#3, LitInt(1099511627776))); (var x2#3 := LitInt(x1#3 - Mul(b2#3, LitInt(1099511627776))); (var b3#3 := LitInt(Div(x2#3, LitInt(4294967296))); (var x3#3 := LitInt(x2#3 - Mul(b3#3, LitInt(4294967296))); (var b4#3 := LitInt(Div(x3#3, LitInt(16777216))); (var x4#3 := LitInt(x3#3 - Mul(b4#3, LitInt(16777216))); (var b5#3 := LitInt(Div(x4#3, LitInt(65536))); (var x5#3 := LitInt(x4#3 - Mul(b5#3, LitInt(65536))); (var b6#3 := LitInt(Div(x5#3, LitInt(256))); (var b7#3 := LitInt(Mod(x5#3, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#3)), $Box(b1#3)), $Box(b2#3)), $Box(b3#3)), $Box(b4#3)), $Box(b5#3)), $Box(b6#3)), $Box(b7#3))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt64ToSeq(StandardLibrary_mUInt.__default.SeqToUInt64(s#0)), s#0) && LitInt(0) <= StandardLibrary_mUInt.__default.SeqToUInt64(s#0) && StandardLibrary_mUInt.__default.SeqToUInt64(s#0) < BoundedInts.__default.TWO__TO__THE__64());

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#2 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#2 := x0#2 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#2 := x1#2 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#2 := x2#2 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#2 := x3#2 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#2 := x4#2 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#2 := x5#2 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#3 := x6#2 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#3)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#3 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#3 := x0#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#3 := x1#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#3 := x2#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#3 := x3#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#3 := x4#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#3 := x5#3 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#4 := x6#3 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#4)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($ly, s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> LitInt(0) <= StandardLibrary_mUInt.__default.SeqToNat($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#2 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#2)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#2 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#2)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#2)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#3 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#3)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#3 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#3)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#3)): int)));

const unique class.String.__default: ClassName;

function String.__default.Base10() : Seq
uses {
axiom String.__default.Base10(): Seq == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(char#FromInt(48)))), $Box(Lit(char#FromInt(49)))), $Box(Lit(char#FromInt(50)))), $Box(Lit(char#FromInt(51)))), $Box(Lit(char#FromInt(52)))), $Box(Lit(char#FromInt(53)))), $Box(Lit(char#FromInt(54)))), $Box(Lit(char#FromInt(55)))), $Box(Lit(char#FromInt(56)))), $Box(Lit(char#FromInt(57)))));
axiom 0 < $FunctionContextHeight ==> $Is(String.__default.Base10(), TSeq(TChar));
}

procedure {:verboseName "StandardLibrary.String.Base10 (well-formedness)"} CheckWellFormed$$String.__default.Base10();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(String.__default.Base10(), TSeq(TChar), $h) } $IsGoodHeap($h) ==> $IsAlloc(String.__default.Base10(), TSeq(TChar), $h));

function String.__default.Int2Digits($ly: LayerType, n#0: int, base#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { String.__default.Int2Digits($ly, n#0, base#0) } String.__default.Int2Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && base#0 > 1 && n#0 >= LitInt(0)) ==> (forall d#0: int :: { Seq#Contains(String.__default.Int2Digits($ly, n#0, base#0), $Box(d#0)) } Seq#Contains(String.__default.Int2Digits($ly, n#0, base#0), $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < base#0) && $Is(String.__default.Int2Digits($ly, n#0, base#0), TSeq(TInt)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { String.__default.Int2Digits($LS($ly), n#0, base#0) } String.__default.Int2Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && base#0 > 1 && n#0 >= LitInt(0)) ==> (n#0 != LitInt(0) ==> String.__default.Int2Digits#canCall(Div(n#0, base#0), base#0)) && String.__default.Int2Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else Seq#Append(String.__default.Int2Digits($ly, Div(n#0, base#0), base#0), Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { String.__default.Int2Digits($LS($ly), LitInt(n#0), base#0) } String.__default.Int2Digits#canCall(LitInt(n#0), base#0) || (0 < $FunctionContextHeight && base#0 > 1 && LitInt(n#0) >= LitInt(0)) ==> (LitInt(n#0) != LitInt(0) ==> String.__default.Int2Digits#canCall(Div(n#0, base#0), base#0)) && String.__default.Int2Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(String.__default.Int2Digits($LS($ly), Div(n#0, base#0), base#0), Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { String.__default.Int2Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } String.__default.Int2Digits#canCall(LitInt(n#0), LitInt(base#0)) || (0 < $FunctionContextHeight && Lit(base#0 > 1) && LitInt(n#0) >= LitInt(0)) ==> (LitInt(n#0) != LitInt(0) ==> String.__default.Int2Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && String.__default.Int2Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(String.__default.Int2Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0)), Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0))))))));
}

function String.__default.Int2Digits#canCall(n#0: int, base#0: int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { String.__default.Int2Digits($LS($ly), n#0, base#0) } String.__default.Int2Digits($LS($ly), n#0, base#0) == String.__default.Int2Digits($ly, n#0, base#0));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { String.__default.Int2Digits(AsFuelBottom($ly), n#0, base#0) } String.__default.Int2Digits($ly, n#0, base#0) == String.__default.Int2Digits($LZ, n#0, base#0));

function String.__default.Int2Digits#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { String.__default.Int2Digits#requires($ly, n#0, base#0) } String.__default.Int2Digits#requires($ly, n#0, base#0) <==> base#0 > 1 && n#0 >= LitInt(0));

procedure {:verboseName "StandardLibrary.String.Int2Digits (well-formedness)"} CheckWellformed$$String.__default.Int2Digits(n#0: int, base#0: int) returns (digits#0: Seq where $Is(digits#0, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id1733"} (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.String.Int2Digits (well-formedness)"} CheckWellformed$$String.__default.Int2Digits(n#0: int, base#0: int) returns (digits#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var d#2: int;
  var ##n#0: int;
  var ##base#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.String.Int2Digits", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/String.dfy(14,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    assume n#0 >= LitInt(0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(String.__default.Int2Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    havoc d#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Seq#Contains(digits#0, $Box(d#2));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= d#2;
    goto anon5;

  anon14_Else:
    assume {:partition} d#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= d#2 && d#2 < base#0;
    goto anon7;

  anon13_Else:
    assume Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < base#0;
    goto anon7;

  anon7:
    assume (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);
    assume false;
    return;

  anon12_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} n#0 == LitInt(0);
    assume String.__default.Int2Digits($LS($LZ), n#0, base#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(String.__default.Int2Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon11;

  anon15_Else:
    assume {:partition} n#0 != LitInt(0);
    assume true;
    assume n#0 > 0;
    assume {:captureState "StandardLibrary/src/String.dfy(23,18)"} true;
    assume true;
    assume base#0 > 1;
    assume {:captureState "StandardLibrary/src/String.dfy(24,21)"} true;
    assume true;
    assume n#0 < Mul(base#0, n#0);
    assume {:captureState "StandardLibrary/src/String.dfy(25,25)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    assume Div(n#0, base#0) < n#0;
    assume {:captureState "StandardLibrary/src/String.dfy(26,25)"} true;
    assume base#0 != 0;
    ##n#0 := Div(n#0, base#0);
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume {:subsumption 0} ##n#0 >= LitInt(0);
    assume ##n#0 >= LitInt(0);
    assume 0 <= n#0 || ##n#0 == n#0;
    assume ##n#0 < n#0;
    assume String.__default.Int2Digits#canCall(Div(n#0, base#0), base#0);
    assume base#0 != 0;
    assume String.__default.Int2Digits($LS($LZ), n#0, base#0) == Seq#Append(String.__default.Int2Digits($LS($LZ), Div(n#0, base#0), base#0), Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))));
    assume String.__default.Int2Digits#canCall(Div(n#0, base#0), base#0);
    assume $Is(String.__default.Int2Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon11;

  anon11:
    assume String.__default.Int2Digits($LS($LZ), n#0, base#0) == digits#0;
    return;
}



function String.__default.Digits2String($ly: LayerType, digits#0: Seq, chars#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { String.__default.Digits2String($ly, digits#0, chars#0) } String.__default.Digits2String#canCall(digits#0, chars#0) || (0 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> $Is(String.__default.Digits2String($ly, digits#0, chars#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { String.__default.Digits2String($LS($ly), digits#0, chars#0) } String.__default.Digits2String#canCall(digits#0, chars#0) || (0 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> String.__default.Digits2String#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && String.__default.Digits2String($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), String.__default.Digits2String($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { String.__default.Digits2String($LS($ly), Lit(digits#0), Lit(chars#0)) } String.__default.Digits2String#canCall(Lit(digits#0), Lit(chars#0)) || (0 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#2: int :: { Seq#Contains(digits#0, $Box(d#2)) } Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> String.__default.Digits2String#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && String.__default.Digits2String($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), String.__default.Digits2String($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));
}

function String.__default.Digits2String#canCall(digits#0: Seq, chars#0: Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { String.__default.Digits2String($LS($ly), digits#0, chars#0) } String.__default.Digits2String($LS($ly), digits#0, chars#0) == String.__default.Digits2String($ly, digits#0, chars#0));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { String.__default.Digits2String(AsFuelBottom($ly), digits#0, chars#0) } String.__default.Digits2String($ly, digits#0, chars#0) == String.__default.Digits2String($LZ, digits#0, chars#0));

function String.__default.Digits2String#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { String.__default.Digits2String#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (String.__default.Digits2String#requires($ly, digits#0, chars#0) <==> (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))));

procedure {:verboseName "StandardLibrary.String.Digits2String (well-formedness)"} CheckWellformed$$String.__default.Digits2String(digits#0: Seq where $Is(digits#0, TSeq(TInt)), chars#0: Seq where $Is(chars#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.String.Digits2String (well-formedness)"} CheckWellformed$$String.__default.Digits2String(digits#0: Seq, chars#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var d#3: int;
  var d#4: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.String.Digits2String", " | ", digits#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/String.dfy(30,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc d#3;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Seq#Contains(digits#0, $Box(d#3));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= d#3;
    goto anon4;

  anon15_Else:
    assume {:partition} d#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= d#3 && d#3 < Seq#Length(chars#0);
    goto anon6;

  anon14_Else:
    assume Seq#Contains(digits#0, $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < Seq#Length(chars#0);
    goto anon6;

  anon6:
    assume (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(String.__default.Digits2String($LS($LZ), digits#0, chars#0), TSeq(TChar));
    assume false;
    return;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Equal(digits#0, Seq#Empty(): Seq);
    assume String.__default.Digits2String($LS($LZ), digits#0, chars#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(String.__default.Digits2String($LS($LZ), digits#0, chars#0), TSeq(TChar));
    return;

  anon17_Else:
    assume {:partition} !Seq#Equal(digits#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(digits#0);
    assume true;
    assume Seq#Contains(digits#0, Seq#Index(digits#0, LitInt(0)));
    assume {:captureState "StandardLibrary/src/String.dfy(35,32)"} true;
    havoc d#4;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(digits#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Contains(Seq#Drop(digits#0, LitInt(1)), $Box(d#4));
    goto anon13;

  anon19_Else:
    assume {:partition} !Seq#Contains(Seq#Drop(digits#0, LitInt(1)), $Box(d#4));
    goto anon13;

  anon18_Else:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume true;
    assume (forall d#5: int :: { Seq#Contains(digits#0, $Box(d#5)) } { Seq#Contains(Seq#Drop(digits#0, 1), $Box(d#5)) } Seq#Contains(Seq#Drop(digits#0, LitInt(1)), $Box(d#5)) ==> Seq#Contains(digits#0, $Box(d#5)));
    assume {:captureState "StandardLibrary/src/String.dfy(36,55)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(digits#0);
    assume 0 <= $Unbox(Seq#Index(digits#0, LitInt(0))): int && $Unbox(Seq#Index(digits#0, LitInt(0))): int < Seq#Length(chars#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(digits#0);
    ##digits#0 := Seq#Drop(digits#0, LitInt(1));
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall d#6: int :: { Seq#Contains(##digits#0, $Box(d#6)) } Seq#Contains(##digits#0, $Box(d#6)) ==> LitInt(0) <= d#6 && d#6 < Seq#Length(##chars#0));
    assume (forall d#6: int :: { Seq#Contains(##digits#0, $Box(d#6)) } Seq#Contains(##digits#0, $Box(d#6)) ==> LitInt(0) <= d#6 && d#6 < Seq#Length(##chars#0));
    assume Seq#Rank(##digits#0) < Seq#Rank(digits#0) || (Seq#Rank(##digits#0) == Seq#Rank(digits#0) && Seq#Rank(##chars#0) < Seq#Rank(chars#0));
    assume String.__default.Digits2String#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0);
    assume String.__default.Digits2String($LS($LZ), digits#0, chars#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), String.__default.Digits2String($LS($LZ), Seq#Drop(digits#0, LitInt(1)), chars#0));
    assume String.__default.Digits2String#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0);
    assume $Is(String.__default.Digits2String($LS($LZ), digits#0, chars#0), TSeq(TChar));
    return;
}



function String.__default.Int2String(n#0: int, chars#0: Seq) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { String.__default.Int2String(n#0, chars#0) } String.__default.Int2String#canCall(n#0, chars#0) || (1 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> $Is(String.__default.Int2String(n#0, chars#0), TSeq(TChar)));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { String.__default.Int2String(n#0, chars#0) } String.__default.Int2String#canCall(n#0, chars#0) || (1 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#0 := Seq#Length(chars#0); n#0 != LitInt(0) ==> (n#0 > 0 ==> String.__default.Int2Digits#canCall(n#0, base#0) && String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), n#0, base#0), chars#0)) && (0 >= n#0 ==> String.__default.Int2Digits#canCall(0 - n#0, base#0) && String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), 0 - n#0, base#0), chars#0))) && String.__default.Int2String(n#0, chars#0) == (var base#0 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))) else (if n#0 > 0 then String.__default.Digits2String($LS($LZ), String.__default.Int2Digits($LS($LZ), n#0, base#0), chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), String.__default.Digits2String($LS($LZ), String.__default.Int2Digits($LS($LZ), 0 - n#0, base#0), chars#0))))));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: {:weight 3} { String.__default.Int2String(LitInt(n#0), Lit(chars#0)) } String.__default.Int2String#canCall(LitInt(n#0), Lit(chars#0)) || (1 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#1 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> (Lit(n#0 > 0) ==> String.__default.Int2Digits#canCall(LitInt(n#0), base#1) && String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0))) && (!Lit(n#0 > 0) ==> String.__default.Int2Digits#canCall(LitInt(0 - n#0), base#1) && String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), LitInt(0 - n#0), base#1), Lit(chars#0)))) && String.__default.Int2String(LitInt(n#0), Lit(chars#0)) == (var base#1 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))) else (if n#0 > 0 then String.__default.Digits2String($LS($LZ), String.__default.Int2Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), String.__default.Digits2String($LS($LZ), String.__default.Int2Digits($LS($LZ), LitInt(0 - n#0), base#1), Lit(chars#0)))))));
}

function String.__default.Int2String#canCall(n#0: int, chars#0: Seq) : bool;

function String.__default.Int2String#requires(int, Seq) : bool;

axiom (forall n#0: int, chars#0: Seq :: { String.__default.Int2String#requires(n#0, chars#0) } $Is(chars#0, TSeq(TChar)) ==> (String.__default.Int2String#requires(n#0, chars#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "StandardLibrary.String.Int2String (well-formedness)"} CheckWellformed$$String.__default.Int2String(n#0: int, chars#0: Seq where $Is(chars#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.String.Int2String (well-formedness)"} CheckWellformed$$String.__default.Int2String(n#0: int, chars#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var base#Z#0: int;
  var let#0#0#0: int;
  var ##n#0: int;
  var ##base#0: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;
  var ##n#1: int;
  var ##base#1: int;
  var ##digits#1: Seq;
  var ##chars#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.String.Int2String", " | ", n#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/String.dfy(40,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(String.__default.Int2String(n#0, chars#0), TSeq(TChar));
    assume false;
    return;

  anon8_Else:
    havoc base#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(chars#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume base#Z#0 == let#0#0#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} n#0 == LitInt(0);
    assume String.__default.Int2String(n#0, chars#0) == Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))));
    assume true;
    assume $Is(String.__default.Int2String(n#0, chars#0), TSeq(TChar));
    return;

  anon9_Else:
    assume {:partition} n#0 != LitInt(0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} n#0 > 0;
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##base#0 := base#Z#0;
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume {:subsumption 0} ##n#0 >= LitInt(0);
    assume ##n#0 >= LitInt(0);
    assume String.__default.Int2Digits#canCall(n#0, base#Z#0);
    ##digits#0 := String.__default.Int2Digits($LS($LZ), n#0, base#Z#0);
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume String.__default.Int2String(n#0, chars#0) == String.__default.Digits2String($LS($LZ), String.__default.Int2Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume String.__default.Int2Digits#canCall(n#0, base#Z#0) && String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume $Is(String.__default.Int2String(n#0, chars#0), TSeq(TChar));
    return;

  anon10_Else:
    assume {:partition} 0 >= n#0;
    ##n#1 := 0 - n#0;
    assume $IsAlloc(##n#1, TInt, $Heap);
    ##base#1 := base#Z#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume {:subsumption 0} ##base#1 > 1;
    assume ##base#1 > 1;
    assume {:subsumption 0} ##n#1 >= LitInt(0);
    assume ##n#1 >= LitInt(0);
    assume String.__default.Int2Digits#canCall(0 - n#0, base#Z#0);
    ##digits#1 := String.__default.Int2Digits($LS($LZ), 0 - n#0, base#Z#0);
    assume $IsAlloc(##digits#1, TSeq(TInt), $Heap);
    ##chars#1 := chars#0;
    assume $IsAlloc(##chars#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall d#1: int :: { Seq#Contains(##digits#1, $Box(d#1)) } Seq#Contains(##digits#1, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(##chars#1));
    assume (forall d#1: int :: { Seq#Contains(##digits#1, $Box(d#1)) } Seq#Contains(##digits#1, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(##chars#1));
    assume String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), 0 - n#0, base#Z#0), chars#0);
    assume String.__default.Int2String(n#0, chars#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), String.__default.Digits2String($LS($LZ), String.__default.Int2Digits($LS($LZ), 0 - n#0, base#Z#0), chars#0));
    assume String.__default.Int2Digits#canCall(0 - n#0, base#Z#0) && String.__default.Digits2String#canCall(String.__default.Int2Digits($LS($LZ), 0 - n#0, base#Z#0), chars#0);
    assume $Is(String.__default.Int2String(n#0, chars#0), TSeq(TChar));
    return;
}



function String.__default.Base10Int2String(n#0: int) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int :: { String.__default.Base10Int2String(n#0) } String.__default.Base10Int2String#canCall(n#0) || 2 < $FunctionContextHeight ==> $Is(String.__default.Base10Int2String(n#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int :: { String.__default.Base10Int2String(n#0) } String.__default.Base10Int2String#canCall(n#0) || 2 < $FunctionContextHeight ==> String.__default.Int2String#canCall(n#0, String.__default.Base10()) && String.__default.Base10Int2String(n#0) == String.__default.Int2String(n#0, String.__default.Base10()));
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { String.__default.Base10Int2String(LitInt(n#0)) } String.__default.Base10Int2String#canCall(LitInt(n#0)) || 2 < $FunctionContextHeight ==> String.__default.Int2String#canCall(LitInt(n#0), String.__default.Base10()) && String.__default.Base10Int2String(LitInt(n#0)) == String.__default.Int2String(LitInt(n#0), String.__default.Base10()));
}

function String.__default.Base10Int2String#canCall(n#0: int) : bool;

function String.__default.Base10Int2String#requires(int) : bool;

axiom (forall n#0: int :: { String.__default.Base10Int2String#requires(n#0) } String.__default.Base10Int2String#requires(n#0) <==> true);

procedure {:verboseName "StandardLibrary.String.Base10Int2String (well-formedness)"} CheckWellformed$$String.__default.Base10Int2String(n#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.String.Base10Int2String (well-formedness)"} CheckWellformed$$String.__default.Base10Int2String(n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##n#0: int;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.String.Base10Int2String", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/String.dfy(52,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(String.__default.Base10Int2String(n#0), TSeq(TChar));
    assume false;
    return;

  anon4_Else:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##chars#0 := String.__default.Base10();
    assume $IsAlloc(##chars#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##chars#0) > 1;
    assume Seq#Length(##chars#0) > 1;
    assume String.__default.Int2String#canCall(n#0, String.__default.Base10());
    assume String.__default.Base10Int2String(n#0) == String.__default.Int2String(n#0, String.__default.Base10());
    assume String.__default.Int2String#canCall(n#0, String.__default.Base10());
    assume $Is(String.__default.Base10Int2String(n#0), TSeq(TChar));
    return;
}



procedure {:verboseName "StandardLibrary.String.HasSubString (well-formedness)"} CheckWellFormed$$String.__default.HasSubString(haystack#0: Seq where $Is(haystack#0, TSeq(TChar)) && $IsAlloc(haystack#0, TSeq(TChar), $Heap), needle#0: Seq where $Is(needle#0, TSeq(TChar)) && $IsAlloc(needle#0, TSeq(TChar), $Heap)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(o#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.String.HasSubString (well-formedness)"} CheckWellFormed$$String.__default.HasSubString(haystack#0: Seq, needle#0: Seq) returns (o#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var i#2: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.String.HasSubString", " | ", haystack#0, " | ", needle#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/String.dfy(58,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc o#0;
    assume {:captureState "StandardLibrary/src/String.dfy(61,20): post-state"} true;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume Wrappers.Option.Some_q(o#0);
    assume Wrappers.Option.Some_q(o#0);
    assume $Unbox(Wrappers.Option.value(o#0)): int <= Seq#Length(haystack#0) - Seq#Length(needle#0);
    assume Wrappers.Option.Some_q(o#0);
    assume 0 <= $Unbox(Wrappers.Option.value(o#0)): int && $Unbox(Wrappers.Option.value(o#0)): int <= Seq#Length(haystack#0);
    assume Wrappers.Option.Some_q(o#0);
    assume $Unbox(Wrappers.Option.value(o#0)): int <= $Unbox(Wrappers.Option.value(o#0)): int + Seq#Length(needle#0) && $Unbox(Wrappers.Option.value(o#0)): int + Seq#Length(needle#0) <= Seq#Length(haystack#0);
    assume Seq#Equal(Seq#Drop(Seq#Take(haystack#0, $Unbox(Wrappers.Option.value(o#0)): int + Seq#Length(needle#0)), $Unbox(Wrappers.Option.value(o#0)): int), needle#0);
    havoc i#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= i#0;
    assume Wrappers.Option.Some_q(o#0);
    goto anon5;

  anon25_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon5;

  anon5:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < $Unbox(Wrappers.Option.value(o#0)): int;
    assume 0 <= i#0 && i#0 <= Seq#Length(haystack#0);
    assume 0 <= Seq#Length(needle#0) && Seq#Length(needle#0) <= Seq#Length(Seq#Drop(haystack#0, i#0));
    goto anon7;

  anon26_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < $Unbox(Wrappers.Option.value(o#0)): int);
    goto anon7;

  anon24_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { Seq#Drop(haystack#0, i#1) } LitInt(0) <= i#1 && i#1 < $Unbox(Wrappers.Option.value(o#0)): int ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#1), Seq#Length(needle#0)), needle#0));
    goto anon9;

  anon23_Else:
    assume Wrappers.Option.Some_q(o#0) ==> $Unbox(Wrappers.Option.value(o#0)): int <= Seq#Length(haystack#0) - Seq#Length(needle#0) && Seq#Equal(Seq#Drop(Seq#Take(haystack#0, $Unbox(Wrappers.Option.value(o#0)): int + Seq#Length(needle#0)), $Unbox(Wrappers.Option.value(o#0)): int), needle#0) && (forall i#1: int :: { Seq#Drop(haystack#0, i#1) } LitInt(0) <= i#1 && i#1 < $Unbox(Wrappers.Option.value(o#0)): int ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#1), Seq#Length(needle#0)), needle#0));
    goto anon9;

  anon9:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume Seq#Length(haystack#0) < Seq#Length(needle#0);
    goto anon13;

  anon28_Else:
    assume Seq#Length(needle#0) <= Seq#Length(haystack#0);
    assume Seq#Length(haystack#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1;
    goto anon13;

  anon13:
    assume Wrappers.Option.None_q(o#0);
    goto anon15;

  anon27_Else:
    assume Seq#Length(haystack#0) < Seq#Length(needle#0) || Seq#Length(haystack#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 ==> Wrappers.Option.None_q(o#0);
    goto anon15;

  anon15:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume Wrappers.Option.None_q(o#0);
    assume Seq#Length(needle#0) <= Seq#Length(haystack#0);
    assume Seq#Length(haystack#0) <= StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1;
    havoc i#2;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} true;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon19;

  anon31_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon19;

  anon19:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 <= Seq#Length(haystack#0) - Seq#Length(needle#0);
    assume 0 <= i#2 && i#2 <= Seq#Length(haystack#0);
    assume 0 <= Seq#Length(needle#0) && Seq#Length(needle#0) <= Seq#Length(Seq#Drop(haystack#0, i#2));
    goto anon21;

  anon32_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 <= Seq#Length(haystack#0) - Seq#Length(needle#0));
    goto anon21;

  anon30_Else:
    assume {:partition} false;
    goto anon21;

  anon21:
    assume (forall i#3: int :: { Seq#Drop(haystack#0, i#3) } LitInt(0) <= i#3 && i#3 <= Seq#Length(haystack#0) - Seq#Length(needle#0) ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#3), Seq#Length(needle#0)), needle#0));
    return;

  anon29_Else:
    assume Wrappers.Option.None_q(o#0) && Seq#Length(needle#0) <= Seq#Length(haystack#0) && Seq#Length(haystack#0) <= StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 ==> (forall i#3: int :: { Seq#Drop(haystack#0, i#3) } LitInt(0) <= i#3 && i#3 <= Seq#Length(haystack#0) - Seq#Length(needle#0) ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#3), Seq#Length(needle#0)), needle#0));
    return;
}



procedure {:verboseName "StandardLibrary.String.HasSubString (call precondtion)"} CallPre$$String.__default.HasSubString(haystack#0: Seq where $Is(haystack#0, TSeq(TChar)) && $IsAlloc(haystack#0, TSeq(TChar), $Heap), needle#0: Seq where $Is(needle#0, TSeq(TChar)) && $IsAlloc(needle#0, TSeq(TChar), $Heap));



procedure {:verboseName "StandardLibrary.String.HasSubString (call postcondition)"} CallPost$$String.__default.HasSubString(haystack#0: Seq where $Is(haystack#0, TSeq(TChar)) && $IsAlloc(haystack#0, TSeq(TChar), $Heap), needle#0: Seq where $Is(needle#0, TSeq(TChar)) && $IsAlloc(needle#0, TSeq(TChar), $Heap)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(o#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id1808"} Wrappers.Option.Some_q(o#0) ==> $Unbox(Wrappers.Option.value(o#0)): int <= Seq#Length(haystack#0) - Seq#Length(needle#0);
  free ensures {:id "id1809"} Wrappers.Option.Some_q(o#0) ==> Seq#Equal(Seq#Drop(Seq#Take(haystack#0, $Unbox(Wrappers.Option.value(o#0)): int + Seq#Length(needle#0)), $Unbox(Wrappers.Option.value(o#0)): int), needle#0);
  free ensures {:id "id1810"} Wrappers.Option.Some_q(o#0) ==> (forall i#1: int :: { Seq#Drop(haystack#0, i#1) } LitInt(0) <= i#1 && i#1 < $Unbox(Wrappers.Option.value(o#0)): int ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#1), Seq#Length(needle#0)), needle#0));
  free ensures true;
  free ensures {:id "id1811"} Seq#Length(haystack#0) < Seq#Length(needle#0) || Seq#Length(haystack#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 ==> Wrappers.Option.None_q(o#0);
  free ensures true;
  free ensures {:id "id1812"} Wrappers.Option.None_q(o#0) && Seq#Length(needle#0) <= Seq#Length(haystack#0) && Seq#Length(haystack#0) <= StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 ==> (forall i#3: int :: { Seq#Drop(haystack#0, i#3) } LitInt(0) <= i#3 && i#3 <= Seq#Length(haystack#0) - Seq#Length(needle#0) ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#3), Seq#Length(needle#0)), needle#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "StandardLibrary.String.HasSubString (correctness)"} Impl$$String.__default.HasSubString(haystack#0: Seq where $Is(haystack#0, TSeq(TChar)) && $IsAlloc(haystack#0, TSeq(TChar), $Heap), needle#0: Seq where $Is(needle#0, TSeq(TChar)) && $IsAlloc(needle#0, TSeq(TChar), $Heap)) returns (defass#o#0: bool, o#0: DatatypeType where defass#o#0 ==> $Is(o#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(o#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id1813"} Wrappers.Option.Some_q(o#0) ==> $Unbox(Wrappers.Option.value(o#0)): int <= Seq#Length(haystack#0) - Seq#Length(needle#0);
  free ensures {:id "id1814"} Wrappers.Option.Some_q(o#0) ==> Seq#Equal(Seq#Drop(Seq#Take(haystack#0, $Unbox(Wrappers.Option.value(o#0)): int + Seq#Length(needle#0)), $Unbox(Wrappers.Option.value(o#0)): int), needle#0);
  free ensures {:id "id1815"} Wrappers.Option.Some_q(o#0) ==> (forall i#1: int :: { Seq#Drop(haystack#0, i#1) } LitInt(0) <= i#1 && i#1 < $Unbox(Wrappers.Option.value(o#0)): int ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#1), Seq#Length(needle#0)), needle#0));
  free ensures true;
  free ensures {:id "id1816"} Seq#Length(haystack#0) < Seq#Length(needle#0) || Seq#Length(haystack#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 ==> Wrappers.Option.None_q(o#0);
  free ensures true;
  free ensures {:id "id1817"} Wrappers.Option.None_q(o#0) && Seq#Length(needle#0) <= Seq#Length(haystack#0) && Seq#Length(haystack#0) <= StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 ==> (forall i#3: int :: { Seq#Drop(haystack#0, i#3) } LitInt(0) <= i#3 && i#3 <= Seq#Length(haystack#0) - Seq#Length(needle#0) ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#3), Seq#Length(needle#0)), needle#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.String.HasSubString (correctness)"} Impl$$String.__default.HasSubString(haystack#0: Seq, needle#0: Seq) returns (defass#o#0: bool, o#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var size#0: int where LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64();
  var newtype$check#0: int;
  var newtype$check#1: int;
  var limit#0: int where LitInt(0) <= limit#0 && limit#0 < BoundedInts.__default.TWO__TO__THE__64();
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var index#0: int;
  var index#0#lo: int;
  var newtype$check#7: int;
  var index#0#hi: int;
  var index#0#x: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#o#0: bool;
  var $w$loop#0: bool;
  var i#4: int;
  var newtype$check#8: int;
  var newtype$check#1_0: int;
  var ##seq1#1_0: Seq;
  var ##seq2#1_0: Seq;
  var ##start1#1_0: int;
  var ##start2#1_0: int;
  var ##size#1_0: int;
  var newtype$check#1_0_0: int;
  var newtype$check#1_0_1: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.String.HasSubString", " | ", haystack#0, " | ", needle#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/String.dfy(69,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Length(haystack#0) < Seq#Length(needle#0);
    push;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Option.None());
    defass#o#0 := true;
    assume {:captureState "StandardLibrary/src/String.dfy(71,26)"} true;
    assume defass#o#0;
    pop;
    return;

  anon23_Else:
    assume {:partition} Seq#Length(needle#0) <= Seq#Length(haystack#0);
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1 < Seq#Length(haystack#0);
    assume true;
    assume false;
    goto anon6;

  anon24_Else:
    assume {:partition} Seq#Length(haystack#0) <= StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() - 1;
    goto anon6;

  anon6:
    assume true;
    newtype$check#0 := Seq#Length(needle#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#1 := Seq#Length(needle#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    size#0 := Seq#Length(needle#0);
    assume {:captureState "StandardLibrary/src/String.dfy(77,43)"} true;
    assume true;
    newtype$check#2 := Seq#Length(haystack#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#3 := Seq#Length(haystack#0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#4 := Seq#Length(haystack#0) - size#0;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#5 := LitInt(1);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#6 := Seq#Length(haystack#0) - size#0 + 1;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__64();
    assume true;
    limit#0 := Seq#Length(haystack#0) - size#0 + 1;
    assume {:captureState "StandardLibrary/src/String.dfy(78,56)"} true;
    newtype$check#7 := LitInt(0);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__64();
    index#0#lo := LitInt(0);
    index#0#hi := limit#0;
    assume index#0#lo <= index#0#hi;
    havoc index#0#x;
    assume index#0#lo <= index#0#x && index#0#x <= index#0#hi;
    assume $Is(index#0#x, Tclass.BoundedInts.uint64());
    index#0 := index#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#o#0 := defass#o#0;
    havoc $w$loop#0;
    goto anon25_LoopHead;

  anon25_LoopHead:
    assume index#0#lo <= index#0 && index#0 <= index#0#hi;
    assume true;
    assume $w$loop#0 ==> (forall i#5: int :: { Seq#Drop(haystack#0, i#5) } LitInt(0) <= i#5 && i#5 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= i#5 && i#5 < index#0 ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#5), size#0), needle#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#o#0 ==> defass#o#0;
    assume true;
    goto anon25_LoopDone, anon25_LoopBody;

  anon25_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/String.dfy(80,4): after some loop iterations"} true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} !$w$loop#0;
    havoc i#4;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < BoundedInts.__default.TWO__TO__THE__64();
    newtype$check#8 := LitInt(0);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__64();
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon11;

  anon28_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon11;

  anon11:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < index#0;
    assume {:subsumption 0} 0 <= i#4 && i#4 <= Seq#Length(haystack#0);
    assume {:subsumption 0} 0 <= size#0 && size#0 <= Seq#Length(Seq#Drop(haystack#0, i#4));
    goto anon13;

  anon29_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < index#0);
    goto anon13;

  anon27_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < BoundedInts.__default.TWO__TO__THE__64());
    goto anon13;

  anon13:
    assume true;
    assume (forall i#5: int :: { Seq#Drop(haystack#0, i#5) } LitInt(0) <= i#5 && i#5 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= i#5 && i#5 < index#0 ==> !Seq#Equal(Seq#Take(Seq#Drop(haystack#0, i#5), size#0), needle#0));
    assume false;
    goto anon14;

  anon26_Else:
    assume {:partition} $w$loop#0;
    goto anon14;

  anon14:
    assume true;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} index#0 == index#0#hi;
    goto anon21;

  anon30_Else:
    assume {:partition} index#0 != index#0#hi;
    push;
    newtype$check#1_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < BoundedInts.__default.TWO__TO__THE__64();
    assume $Is(haystack#0, Tclass.StandardLibrary_mUInt.seq64(TChar));
    ##seq1#1_0 := haystack#0;
    assume $IsAlloc(##seq1#1_0, Tclass.StandardLibrary_mUInt.seq64(TChar), $Heap);
    assume $Is(needle#0, Tclass.StandardLibrary_mUInt.seq64(TChar));
    ##seq2#1_0 := needle#0;
    assume $IsAlloc(##seq2#1_0, Tclass.StandardLibrary_mUInt.seq64(TChar), $Heap);
    ##start1#1_0 := index#0;
    assume $IsAlloc(##start1#1_0, Tclass.BoundedInts.uint64(), $Heap);
    ##start2#1_0 := LitInt(0);
    assume $IsAlloc(##start2#1_0, Tclass.BoundedInts.uint64(), $Heap);
    ##size#1_0 := size#0;
    assume $IsAlloc(##size#1_0, Tclass.BoundedInts.uint64(), $Heap);
    assume {:subsumption 0} ##start1#1_0 + ##size#1_0 <= Seq#Length(##seq1#1_0);
    assume ##start1#1_0 + ##size#1_0 <= Seq#Length(##seq1#1_0);
    assume {:subsumption 0} ##start2#1_0 + ##size#1_0 <= Seq#Length(##seq2#1_0);
    assume ##start2#1_0 + ##size#1_0 <= Seq#Length(##seq2#1_0);
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(TChar, haystack#0, needle#0, index#0, LitInt(0), size#0);
    assume StandardLibrary_mSequence.__default.SequenceEqual#canCall(TChar, haystack#0, needle#0, index#0, LitInt(0), size#0);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} StandardLibrary_mSequence.__default.SequenceEqual(TChar, haystack#0, needle#0, index#0, LitInt(0), size#0);
    push;
    assume true;
    newtype$check#1_0_0 := index#0;
    assume LitInt(0) <= newtype$check#1_0_0;
    newtype$check#1_0_1 := index#0;
    assume LitInt(0) <= newtype$check#1_0_1;
    assume true;
    o#0 := #Wrappers.Option.Some($Box(index#0));
    defass#o#0 := true;
    assume {:captureState "StandardLibrary/src/String.dfy(84,42)"} true;
    assume defass#o#0;
    pop;
    pop;
    return;

  anon31_Else:
    assume {:partition} !StandardLibrary_mSequence.__default.SequenceEqual(TChar, haystack#0, needle#0, index#0, LitInt(0), size#0);
    pop;
    index#0 := index#0 + 1;
    assume true;
    goto anon25_LoopHead;

  anon25_LoopDone:
    assume {:partition} false;
    goto anon21;

  anon21:
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Option.None());
    defass#o#0 := true;
    assume {:captureState "StandardLibrary/src/String.dfy(87,24)"} true;
    assume defass#o#0;
    return;
}



axiom (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0) || $IsBox(error#0, Wrappers._default.Need$E) ==> $Is(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0), Tclass.Wrappers.Outcome(Wrappers._default.Need$E)));

axiom (forall $Heap: Heap, Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { $IsAlloc(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0), Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap) } (Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0) || ($IsBox(error#0, Wrappers._default.Need$E) && $IsAllocBox(error#0, Wrappers._default.Need$E, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0), Tclass.Wrappers.Outcome(Wrappers._default.Need$E), $Heap));

axiom (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: { Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, condition#0, error#0) || $IsBox(error#0, Wrappers._default.Need$E) ==> Wrappers.__default.Need(Wrappers._default.Need$E, condition#0, error#0) == (if condition#0 then #Wrappers.Outcome.Pass() else #Wrappers.Outcome.Fail(error#0)));

axiom (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: {:weight 3} { Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), error#0) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, Lit(condition#0), error#0) || $IsBox(error#0, Wrappers._default.Need$E) ==> Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), error#0) == (if condition#0 then #Wrappers.Outcome.Pass() else #Wrappers.Outcome.Fail(error#0)));

axiom (forall Wrappers._default.Need$E: Ty, condition#0: bool, error#0: Box :: {:weight 3} { Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), Lit(error#0)) } Wrappers.__default.Need#canCall(Wrappers._default.Need$E, Lit(condition#0), Lit(error#0)) || $IsBox(error#0, Wrappers._default.Need$E) ==> Wrappers.__default.Need(Wrappers._default.Need$E, Lit(condition#0), Lit(error#0)) == (if condition#0 then #Wrappers.Outcome.Pass() else #Wrappers.Outcome.Fail(Lit(error#0))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> $Is(Wrappers.Option.ToResult(Wrappers.Option$T, this), Tclass.Wrappers.Result(Wrappers.Option$T, TSeq(TChar))));

axiom (forall $Heap: Heap, Wrappers.Option$T: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Option.ToResult(Wrappers.Option$T, this), Tclass.Wrappers.Result(Wrappers.Option$T, TSeq(TChar)), $Heap) } (Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap)) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Option.ToResult(Wrappers.Option$T, this), Tclass.Wrappers.Result(Wrappers.Option$T, TSeq(TChar)), $Heap));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#4 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#4))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#6 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#6)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> $Is(Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0), Tclass.Wrappers.Result(Wrappers.Option$T, Wrappers.Option.ToResult'$R)));

axiom (forall $Heap: Heap, Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { $IsAlloc(Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0), Tclass.Wrappers.Result(Wrappers.Option$T, Wrappers.Option.ToResult'$R), $Heap) } (Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && $IsBox(error#0, Wrappers.Option.ToResult'$R) && $IsAllocBox(error#0, Wrappers.Option.ToResult'$R, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0), Tclass.Wrappers.Result(Wrappers.Option$T, Wrappers.Option.ToResult'$R), $Heap));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#6 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#6))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#8 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#8)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#10 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#10)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> $IsBox(Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0), Wrappers.Option$T));

axiom (forall $Heap: Heap, Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { $IsAllocBox(Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0), Wrappers.Option$T, $Heap) } (Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && $IsBox(default#0, Wrappers.Option$T) && $IsAllocBox(default#0, Wrappers.Option$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0), Wrappers.Option$T, $Heap));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#6 := Wrappers.Option.value(this); v#6)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#8 := Lit(Wrappers.Option.value(Lit(this))); v#8)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#10 := Lit(Wrappers.Option.value(Lit(this))); v#10)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.IsFailure(Wrappers.Option$T, this) } Wrappers.Option.IsFailure#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> (Wrappers.Option.IsFailure(Wrappers.Option$T, this) <==> Wrappers.Option.None_q(this)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.IsFailure(Wrappers.Option$T, Lit(this)) } Wrappers.Option.IsFailure#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> (Wrappers.Option.IsFailure(Wrappers.Option$T, Lit(this)) <==> Lit(Wrappers.Option.None_q(Lit(this)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) } Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.None_q(this)) ==> $Is(Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this), Tclass.Wrappers.Option(Wrappers.Option.PropagateFailure$U)));

axiom (forall $Heap: Heap, Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this), Tclass.Wrappers.Option(Wrappers.Option.PropagateFailure$U), $Heap) } (Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) || ($IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && Wrappers.Option.None_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this), Tclass.Wrappers.Option(Wrappers.Option.PropagateFailure$U), $Heap));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) } Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.None_q(this)) ==> Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, this) == Lit(#Wrappers.Option.None()));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.PropagateFailure$U: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, Lit(this)) } Wrappers.Option.PropagateFailure#canCall(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, Lit(this)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Lit(Wrappers.Option.None_q(Lit(this)))) ==> Wrappers.Option.PropagateFailure(Wrappers.Option$T, Wrappers.Option.PropagateFailure$U, Lit(this)) == Lit(#Wrappers.Option.None()));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.Extract(Wrappers.Option$T, this) } Wrappers.Option.Extract#canCall(Wrappers.Option$T, this) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.Some_q(this)) ==> $IsBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T));

axiom (forall $Heap: Heap, Wrappers.Option$T: Ty, this: DatatypeType :: { $IsAllocBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T, $Heap) } (Wrappers.Option.Extract#canCall(Wrappers.Option$T, this) || ($IsAlloc(this, Tclass.Wrappers.Option(Wrappers.Option$T), $Heap) && Wrappers.Option.Some_q(this))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Option.Extract(Wrappers.Option$T, this), Wrappers.Option$T, $Heap));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.Extract(Wrappers.Option$T, this) } Wrappers.Option.Extract#canCall(Wrappers.Option$T, this) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Wrappers.Option.Some_q(this)) ==> Wrappers.Option.Extract(Wrappers.Option$T, this) == Wrappers.Option.value(this));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.Extract(Wrappers.Option$T, Lit(this)) } Wrappers.Option.Extract#canCall(Wrappers.Option$T, Lit(this)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && Lit(Wrappers.Option.Some_q(Lit(this)))) ==> Wrappers.Option.Extract(Wrappers.Option$T, Lit(this)) == Lit(Wrappers.Option.value(Lit(this))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> $Is(Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this), Tclass.Wrappers.Option(Wrappers.Result$T)));

axiom (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this), Tclass.Wrappers.Option(Wrappers.Result$T), $Heap) } (Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap)) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this), Tclass.Wrappers.Option(Wrappers.Result$T), $Heap));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#4 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#4)) else (var e#4 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#6 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#6))) else (var e#6 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> $IsBox(Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0), Wrappers.Result$T));

axiom (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { $IsAllocBox(Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0), Wrappers.Result$T, $Heap) } (Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $IsBox(default#0, Wrappers.Result$T) && $IsAllocBox(default#0, Wrappers.Result$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0), Wrappers.Result$T, $Heap));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#6 := Wrappers.Result.value(this); s#6) else (var e#6 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#8 := Lit(Wrappers.Result.value(Lit(this))); s#8) else (var e#8 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#10 := Lit(Wrappers.Result.value(Lit(this))); s#10) else (var e#10 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.IsFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> (Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, this) <==> Wrappers.Result.Failure_q(this)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.IsFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> (Wrappers.Result.IsFailure(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) <==> Lit(Wrappers.Result.Failure_q(Lit(this)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) } Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Failure_q(this)) ==> $Is(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R)));

axiom (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R), $Heap) } (Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) || ($IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && Wrappers.Result.Failure_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Result.PropagateFailure$U, Wrappers.Result$R), $Heap));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) } Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Failure_q(this)) ==> Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, this) == #Wrappers.Result.Failure(Wrappers.Result.error(this)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.PropagateFailure$U: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, Lit(this)) } Wrappers.Result.PropagateFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, Lit(this)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Lit(Wrappers.Result.Failure_q(Lit(this)))) ==> Wrappers.Result.PropagateFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.PropagateFailure$U, Lit(this)) == Lit(#Wrappers.Result.Failure(Lit(Wrappers.Result.error(Lit(this))))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> $Is(Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result.MapFailure$NewR)));

axiom (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, this: DatatypeType, reWrap#0: HandleType :: { $IsAlloc(Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result.MapFailure$NewR), $Heap) } (Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR)) && $IsAlloc(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result.MapFailure$NewR), $Heap));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#6 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#6)) else (var e#6 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#6)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#8 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#8))) else (var e#8 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#8)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#10 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#10))) else (var e#10 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#10)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Success_q(this)) ==> $IsBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T));

axiom (forall $Heap: Heap, Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { $IsAllocBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T, $Heap) } (Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || ($IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && Wrappers.Result.Success_q(this))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this), Wrappers.Result$T, $Heap));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Wrappers.Result.Success_q(this)) ==> Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, this) == Wrappers.Result.value(this));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.Extract#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && Lit(Wrappers.Result.Success_q(Lit(this)))) ==> Wrappers.Result.Extract(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == Lit(Wrappers.Result.value(Lit(this))));

axiom (forall Wrappers.Outcome$E: Ty, this: DatatypeType :: { Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, this) } Wrappers.Outcome.IsFailure#canCall(Wrappers.Outcome$E, this) || $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) ==> (Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, this) <==> Wrappers.Outcome.Fail_q(this)));

axiom (forall Wrappers.Outcome$E: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, Lit(this)) } Wrappers.Outcome.IsFailure#canCall(Wrappers.Outcome$E, Lit(this)) || $Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) ==> (Wrappers.Outcome.IsFailure(Wrappers.Outcome$E, Lit(this)) <==> Lit(Wrappers.Outcome.Fail_q(Lit(this)))));

axiom (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) } Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) || ($Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && Wrappers.Outcome.Fail_q(this)) ==> $Is(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E)));

axiom (forall $Heap: Heap, Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { $IsAlloc(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E), $Heap) } (Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) || ($IsAlloc(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E), $Heap) && Wrappers.Outcome.Fail_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this), Tclass.Wrappers.Result(Wrappers.Outcome.PropagateFailure$U, Wrappers.Outcome$E), $Heap));

axiom (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: { Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) } Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) || ($Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && Wrappers.Outcome.Fail_q(this)) ==> Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, this) == #Wrappers.Result.Failure(Wrappers.Outcome.error(this)));

axiom (forall Wrappers.Outcome$E: Ty, Wrappers.Outcome.PropagateFailure$U: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, Lit(this)) } Wrappers.Outcome.PropagateFailure#canCall(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, Lit(this)) || ($Is(this, Tclass.Wrappers.Outcome(Wrappers.Outcome$E)) && Lit(Wrappers.Outcome.Fail_q(Lit(this)))) ==> Wrappers.Outcome.PropagateFailure(Wrappers.Outcome$E, Wrappers.Outcome.PropagateFailure$U, Lit(this)) == Lit(#Wrappers.Result.Failure(Lit(Wrappers.Outcome.error(Lit(this))))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#4 := Div(x#0, LitInt(256)); (var b1#4 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#4)), $Box(b1#4)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#5 := LitInt(Div(x#0, LitInt(256))); (var b1#5 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#5)), $Box(b1#5))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#4 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#4 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#5 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#5 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#4 := Div(x#0, LitInt(16777216)); (var x0#4 := x#0 - Mul(b0#4, LitInt(16777216)); (var b1#4 := Div(x0#4, LitInt(65536)); (var x1#4 := x0#4 - Mul(b1#4, LitInt(65536)); (var b2#4 := Div(x1#4, LitInt(256)); (var b3#4 := Mod(x1#4, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#4)), $Box(b1#4)), $Box(b2#4)), $Box(b3#4)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#5 := LitInt(Div(x#0, LitInt(16777216))); (var x0#5 := LitInt(x#0 - Mul(b0#5, LitInt(16777216))); (var b1#5 := LitInt(Div(x0#5, LitInt(65536))); (var x1#5 := LitInt(x0#5 - Mul(b1#5, LitInt(65536))); (var b2#5 := LitInt(Div(x1#5, LitInt(256))); (var b3#5 := LitInt(Mod(x1#5, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#5)), $Box(b1#5)), $Box(b2#5)), $Box(b3#5))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#4 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#4 := x0#4 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#4 := x1#4 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#4 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#5 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#5 := x0#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#5 := x1#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#5 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#4 := Div(x#0, LitInt(72057594037927936)); (var x0#4 := x#0 - Mul(b0#4, LitInt(72057594037927936)); (var b1#4 := Div(x0#4, LitInt(281474976710656)); (var x1#4 := x0#4 - Mul(b1#4, LitInt(281474976710656)); (var b2#4 := Div(x1#4, LitInt(1099511627776)); (var x2#4 := x1#4 - Mul(b2#4, LitInt(1099511627776)); (var b3#4 := Div(x2#4, LitInt(4294967296)); (var x3#4 := x2#4 - Mul(b3#4, LitInt(4294967296)); (var b4#4 := Div(x3#4, LitInt(16777216)); (var x4#4 := x3#4 - Mul(b4#4, LitInt(16777216)); (var b5#4 := Div(x4#4, LitInt(65536)); (var x5#4 := x4#4 - Mul(b5#4, LitInt(65536)); (var b6#4 := Div(x5#4, LitInt(256)); (var b7#4 := Mod(x5#4, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#4)), $Box(b1#4)), $Box(b2#4)), $Box(b3#4)), $Box(b4#4)), $Box(b5#4)), $Box(b6#4)), $Box(b7#4)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#5 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#5 := LitInt(x#0 - Mul(b0#5, LitInt(72057594037927936))); (var b1#5 := LitInt(Div(x0#5, LitInt(281474976710656))); (var x1#5 := LitInt(x0#5 - Mul(b1#5, LitInt(281474976710656))); (var b2#5 := LitInt(Div(x1#5, LitInt(1099511627776))); (var x2#5 := LitInt(x1#5 - Mul(b2#5, LitInt(1099511627776))); (var b3#5 := LitInt(Div(x2#5, LitInt(4294967296))); (var x3#5 := LitInt(x2#5 - Mul(b3#5, LitInt(4294967296))); (var b4#5 := LitInt(Div(x3#5, LitInt(16777216))); (var x4#5 := LitInt(x3#5 - Mul(b4#5, LitInt(16777216))); (var b5#5 := LitInt(Div(x4#5, LitInt(65536))); (var x5#5 := LitInt(x4#5 - Mul(b5#5, LitInt(65536))); (var b6#5 := LitInt(Div(x5#5, LitInt(256))); (var b7#5 := LitInt(Mod(x5#5, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#5)), $Box(b1#5)), $Box(b2#5)), $Box(b3#5)), $Box(b4#5)), $Box(b5#5)), $Box(b6#5)), $Box(b7#5))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#4 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#4 := x0#4 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#4 := x1#4 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#4 := x2#4 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#4 := x3#4 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#4 := x4#4 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#4 := x5#4 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#5 := x6#4 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#5)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#5 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#5 := x0#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#5 := x1#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#5 := x2#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#5 := x3#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#5 := x4#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#5 := x5#5 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#6 := x6#5 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#6)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#4 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#4)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#4 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#4)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#4)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#5 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#5)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#5 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#5)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#5)): int)));

axiom (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || ($Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) ==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0)));

axiom (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || ($Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> (!(Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(seq2#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT()) ==> StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0)) && (StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> (if Seq#Length(seq1#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(seq2#0) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() then Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0)) else StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqualNat$T, seq1#0, seq2#0, start1#0, start2#0, size#0))));

axiom (forall StandardLibrary.Sequence._default.SequenceEqualNat$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: {:weight 3} { StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) } StandardLibrary_mSequence.__default.SequenceEqualNat#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) || ($Is(seq1#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && $Is(seq2#0, TSeq(StandardLibrary.Sequence._default.SequenceEqualNat$T)) && LitInt(0) <= start1#0 && LitInt(0) <= start2#0 && LitInt(0) <= size#0 && LitInt(start1#0 + size#0) <= Seq#Length(Lit(seq1#0)) && LitInt(start2#0 + size#0) <= Seq#Length(Lit(seq2#0))) ==> (!(Seq#Length(Lit(seq1#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(Lit(seq2#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT()) ==> StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0))) && (StandardLibrary_mSequence.__default.SequenceEqualNat(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) <==> (if Seq#Length(Lit(seq1#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() || Seq#Length(Lit(seq2#0)) > StandardLibrary_mUInt.__default.UINT64__MAX__LIMIT() then Seq#Equal(Seq#Drop(Seq#Take(Lit(seq1#0), LitInt(start1#0 + size#0)), LitInt(start1#0)), Seq#Drop(Seq#Take(Lit(seq2#0), LitInt(start2#0 + size#0)), LitInt(start2#0))) else StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqualNat$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)))));

axiom (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || ($Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> (StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0))));

axiom (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: { StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) } StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) || ($Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() && start1#0 + size#0 <= Seq#Length(seq1#0) && start2#0 + size#0 <= Seq#Length(seq2#0)) ==> (StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0) <==> Seq#Equal(Seq#Drop(Seq#Take(seq1#0, start1#0 + size#0), start1#0), Seq#Drop(Seq#Take(seq2#0, start2#0 + size#0), start2#0))));

axiom (forall StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int :: {:weight 3} { StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) } StandardLibrary_mSequence.__default.SequenceEqual#canCall(StandardLibrary.Sequence._default.SequenceEqual$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) || ($Is(seq1#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && $Is(seq2#0, Tclass.StandardLibrary_mUInt.seq64(StandardLibrary.Sequence._default.SequenceEqual$T)) && LitInt(0) <= start1#0 && start1#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= start2#0 && start2#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(0) <= size#0 && size#0 < BoundedInts.__default.TWO__TO__THE__64() && LitInt(start1#0 + size#0) <= Seq#Length(Lit(seq1#0)) && LitInt(start2#0 + size#0) <= Seq#Length(Lit(seq2#0))) ==> (StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, Lit(seq1#0), Lit(seq2#0), LitInt(start1#0), LitInt(start2#0), LitInt(size#0)) <==> Seq#Equal(Seq#Drop(Seq#Take(Lit(seq1#0), LitInt(start1#0 + size#0)), LitInt(start1#0)), Seq#Drop(Seq#Take(Lit(seq2#0), LitInt(start2#0 + size#0)), LitInt(start2#0)))));

const unique class.StandardLibrary.__default: ClassName;

procedure {:verboseName "StandardLibrary.SeqTakeAppend (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A), $Heap), i#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SeqTakeAppend (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq, i#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqTakeAppend", " | ", StandardLibrary._default.SeqTakeAppend$A, " | ", s#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(11,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon3;

  anon4_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(13,28): post-state"} true;
    assume 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(s#0);
    assume Seq#Equal(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, i#0))), Seq#Take(s#0, i#0 + 1));
    return;
}



procedure {:verboseName "StandardLibrary.SeqTakeAppend (call precondtion)"} CallPre$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A), $Heap), i#0: int);
  requires {:id "id1854"} LitInt(0) <= i#0;
  requires {:id "id1855"} i#0 < Seq#Length(s#0);



procedure {:verboseName "StandardLibrary.SeqTakeAppend (call postcondition)"} CallPost$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A), $Heap), i#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id1856"} Seq#Equal(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, i#0))), Seq#Take(s#0, i#0 + 1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.SeqTakeAppend (correctness)"} Impl$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqTakeAppend$A), $Heap), i#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id1857"} LitInt(0) <= i#0;
  requires {:id "id1858"} i#0 < Seq#Length(s#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id1859"} Seq#Equal(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, i#0))), Seq#Take(s#0, i#0 + 1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SeqTakeAppend (correctness)"} Impl$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq, i#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqTakeAppend", " | ", StandardLibrary._default.SeqTakeAppend$A, " | ", s#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(14,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function StandardLibrary.__default.Join(StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0) } StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, ss#0, joiner#0) || (0 < $FunctionContextHeight && $Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && 0 < Seq#Length(ss#0)) ==> $Is(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { $IsAlloc(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T), $Heap) } (StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, ss#0, joiner#0) || (0 < $FunctionContextHeight && $Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $IsAlloc(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T)), $Heap) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && $IsAlloc(joiner#0, TSeq(StandardLibrary._default.Join$T), $Heap) && 0 < Seq#Length(ss#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), ss#0, joiner#0) } StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, ss#0, joiner#0) || (0 < $FunctionContextHeight && $Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && 0 < Seq#Length(ss#0)) ==> (Seq#Length(ss#0) != LitInt(1) ==> StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Seq#Drop(ss#0, LitInt(1)), joiner#0)) && StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), ss#0, joiner#0) == (if Seq#Length(ss#0) == LitInt(1) then $Unbox(Seq#Index(ss#0, LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(ss#0, LitInt(0))): Seq, joiner#0), StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, Seq#Drop(ss#0, LitInt(1)), joiner#0))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: {:weight 3} { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), Lit(ss#0), Lit(joiner#0)) } StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Lit(ss#0), Lit(joiner#0)) || (0 < $FunctionContextHeight && $Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && 0 < Seq#Length(Lit(ss#0))) ==> (Seq#Length(Lit(ss#0)) != LitInt(1) ==> StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Lit(Seq#Drop(Lit(ss#0), LitInt(1))), Lit(joiner#0))) && StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), Lit(ss#0), Lit(joiner#0)) == (if Seq#Length(Lit(ss#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(ss#0), LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(Lit(ss#0), LitInt(0))): Seq, joiner#0), StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), Lit(Seq#Drop(Lit(ss#0), LitInt(1))), Lit(joiner#0)))));
}

function StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T: Ty, ss#0: Seq, joiner#0: Seq) : bool;

axiom (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), ss#0, joiner#0) } StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), ss#0, joiner#0) == StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0));

axiom (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, AsFuelBottom($ly), ss#0, joiner#0) } StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0) == StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LZ, ss#0, joiner#0));

function StandardLibrary.__default.Join#requires(Ty, LayerType, Seq, Seq) : bool;

axiom (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join#requires(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0) } $Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) ==> (StandardLibrary.__default.Join#requires(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0) <==> 0 < Seq#Length(ss#0)));

procedure {:verboseName "StandardLibrary.Join (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Join(StandardLibrary._default.Join$T: Ty, ss#0: Seq where $Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))), joiner#0: Seq where $Is(joiner#0, TSeq(StandardLibrary._default.Join$T))) returns (s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.Join$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Join (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Join(StandardLibrary._default.Join$T: Ty, ss#0: Seq, joiner#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ss#0: Seq;
  var ##joiner#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Join", " | ", StandardLibrary._default.Join$T, " | ", ss#0, " | ", joiner#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(16,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume 0 < Seq#Length(ss#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T));
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(ss#0) == LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ss#0);
    assume StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), ss#0, joiner#0) == $Unbox(Seq#Index(ss#0, LitInt(0))): Seq;
    assume true;
    assume $Is(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T));
    goto anon6;

  anon8_Else:
    assume {:partition} Seq#Length(ss#0) != LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ss#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(ss#0);
    ##ss#0 := Seq#Drop(ss#0, LitInt(1));
    assume $IsAlloc(##ss#0, TSeq(TSeq(StandardLibrary._default.Join$T)), $Heap);
    ##joiner#0 := joiner#0;
    assume $IsAlloc(##joiner#0, TSeq(StandardLibrary._default.Join$T), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##ss#0);
    assume 0 < Seq#Length(##ss#0);
    assume Seq#Rank(##ss#0) < Seq#Rank(ss#0) || (Seq#Rank(##ss#0) == Seq#Rank(ss#0) && Seq#Rank(##joiner#0) < Seq#Rank(joiner#0));
    assume StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Seq#Drop(ss#0, LitInt(1)), joiner#0);
    assume StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), ss#0, joiner#0) == Seq#Append(Seq#Append($Unbox(Seq#Index(ss#0, LitInt(0))): Seq, joiner#0), StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), Seq#Drop(ss#0, LitInt(1)), joiner#0));
    assume StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Seq#Drop(ss#0, LitInt(1)), joiner#0);
    assume $Is(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T));
    goto anon6;

  anon6:
    assume StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($LZ), ss#0, joiner#0) == s#0;
    return;
}



function StandardLibrary.__default.Split(StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#0: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#0)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { $IsAlloc(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)), $Heap) } (StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Split$T), $Heap) && $IsBox(delim#0, StandardLibrary._default.Split$T) && $IsAllocBox(delim#0, StandardLibrary._default.Split$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#1 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#1) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#1)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#1 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#1) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#1)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#1)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#2 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#2) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#2)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#2 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#2) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#2)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#2)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#3 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#3) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#3)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#3 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#3) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#3)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#3)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));
}

function StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T: Ty, s#0: Seq, delim#0: Box) : bool;

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, AsFuelBottom($ly), s#0, delim#0) } StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) == StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LZ, s#0, delim#0));

function StandardLibrary.__default.Split#requires(Ty, LayerType, Seq, Box) : bool;

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split#requires(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } $Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T) ==> (StandardLibrary.__default.Split#requires(StandardLibrary._default.Split$T, $ly, s#0, delim#0) <==> true));

procedure {:verboseName "StandardLibrary.Split (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Split(StandardLibrary._default.Split$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.Split$T)), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.Split$T)) returns (res#0: Seq where $Is(res#0, TSeq(TSeq(StandardLibrary._default.Split$T))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id1869"} !Seq#Contains(s#0, delim#0) ==> Seq#Equal(res#0, Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
  free ensures {:id "id1870"} Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(res#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))));
  free ensures {:id "id1871"} 0 < Seq#Length(res#0);
  free ensures {:id "id1872"} (forall i#4: int :: { $Unbox(Seq#Index(res#0, i#4)): Seq } LitInt(0) <= i#4 && i#4 < Seq#Length(res#0) ==> !Seq#Contains($Unbox(Seq#Index(res#0, i#4)): Seq, delim#0));
  free ensures {:id "id1873"} Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LS($LZ)), res#0, Seq#Build(Seq#Empty(): Seq, delim#0)), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Split (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Split(StandardLibrary._default.Split$T: Ty, s#0: Seq, delim#0: Box) returns (res#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#5: int;
  var ##ss#0: Seq;
  var ##joiner#0: Seq;
  var i#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##c#0: Box;
  var ##i#0: int;
  var ##s#1: Seq;
  var ##delim#0: Box;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Split", " | ", StandardLibrary._default.Split$T, " | ", s#0, " | ", delim#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(22,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)));
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume !Seq#Contains(s#0, delim#0);
    assume Seq#Equal(res#0, Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
    goto anon5;

  anon19_Else:
    assume !Seq#Contains(s#0, delim#0) ==> Seq#Equal(res#0, Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
    goto anon5;

  anon5:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume Seq#Equal(s#0, Seq#Empty(): Seq);
    assume Seq#Equal(res#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))));
    goto anon8;

  anon20_Else:
    assume Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(res#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))));
    goto anon8;

  anon8:
    assume 0 < Seq#Length(res#0);
    havoc i#5;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= i#5;
    goto anon11;

  anon22_Else:
    assume {:partition} i#5 < LitInt(0);
    goto anon11;

  anon11:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(res#0);
    assume 0 <= i#5 && i#5 < Seq#Length(res#0);
    assume !Seq#Contains($Unbox(Seq#Index(res#0, i#5)): Seq, delim#0);
    goto anon13;

  anon21_Else:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(res#0) ==> !Seq#Contains($Unbox(Seq#Index(res#0, i#5)): Seq, delim#0);
    goto anon13;

  anon13:
    assume (forall i#4: int :: { $Unbox(Seq#Index(res#0, i#4)): Seq } LitInt(0) <= i#4 && i#4 < Seq#Length(res#0) ==> !Seq#Contains($Unbox(Seq#Index(res#0, i#4)): Seq, delim#0));
    ##ss#0 := res#0;
    assume $IsAlloc(##ss#0, TSeq(TSeq(StandardLibrary._default.Split$T)), $Heap);
    ##joiner#0 := Seq#Build(Seq#Empty(): Seq, delim#0);
    assume $IsAlloc(##joiner#0, TSeq(StandardLibrary._default.Split$T), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##ss#0);
    assume 0 < Seq#Length(##ss#0);
    assume StandardLibrary.__default.Join#canCall(StandardLibrary._default.Split$T, res#0, Seq#Build(Seq#Empty(): Seq, delim#0));
    assume Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), res#0, Seq#Build(Seq#Empty(): Seq, delim#0)), s#0);
    assume false;
    return;

  anon18_Else:
    havoc i#Z#0;
    assume $Is(i#Z#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(i#Z#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.Split$T), $Heap);
    ##c#0 := delim#0;
    assume $IsAllocBox(##c#0, StandardLibrary._default.Split$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0 := LitInt(0);
    assume $IsAlloc(##i#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0 <= Seq#Length(##s#0);
    assume ##i#0 <= Seq#Length(##s#0);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0));
    assume let#0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume i#Z#0 == let#0#0#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Option.Some_q(i#Z#0);
    assume Wrappers.Option.Some_q(i#Z#0);
    assume 0 <= $Unbox(Wrappers.Option.value(i#Z#0)): int && $Unbox(Wrappers.Option.value(i#Z#0)): int <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(i#Z#0);
    assume 0 <= $Unbox(Wrappers.Option.value(i#Z#0)): int + 1 && $Unbox(Wrappers.Option.value(i#Z#0)): int + 1 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int + 1);
    assume $IsAlloc(##s#1, TSeq(StandardLibrary._default.Split$T), $Heap);
    ##delim#0 := delim#0;
    assume $IsAllocBox(##delim#0, StandardLibrary._default.Split$T, $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#1) == Seq#Length(s#0);
    assume Seq#Length(##s#1) < Seq#Length(s#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int + 1), delim#0);
    assume StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), s#0, delim#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int + 1), delim#0));
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int + 1), delim#0);
    assume $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)));
    goto anon17;

  anon23_Else:
    assume {:partition} !Wrappers.Option.Some_q(i#Z#0);
    assume StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), s#0, delim#0) == Seq#Build(Seq#Empty(): Seq, $Box(s#0));
    assume true;
    assume $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)));
    goto anon17;

  anon17:
    assume StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($LZ), s#0, delim#0) == res#0;
    return;
}



function StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0))): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0))): Seq), s#0) && !Seq#Contains($Unbox(_System.Tuple2._0(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0))): Seq, delim#0) && $Is(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { $IsAlloc(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T)), $Heap) } (StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SplitOnce$T), $Heap) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && $IsAllocBox(delim#0, StandardLibrary._default.SplitOnce$T, $Heap) && Seq#Contains(s#0, delim#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T)), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#0)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0)): int + 1)))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#1 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#1)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#1)): int + 1)))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#2 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#2)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#2)): int + 1))))))));
}

function StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box) : bool;

function StandardLibrary.__default.SplitOnce#requires(Ty, Seq, Box) : bool;

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce#requires(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) ==> (StandardLibrary.__default.SplitOnce#requires(StandardLibrary._default.SplitOnce$T, s#0, delim#0) <==> Seq#Contains(s#0, delim#0)));

procedure {:verboseName "StandardLibrary.SplitOnce (well-formedness)"} CheckWellformed$$StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.SplitOnce$T)) returns (res#0: DatatypeType where $Is(res#0, Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id1901"} Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(res#0)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(res#0)): Seq), s#0);
  free ensures {:id "id1902"} !Seq#Contains($Unbox(_System.Tuple2._0(res#0)): Seq, delim#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SplitOnce (well-formedness)"} CheckWellformed$$StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##c#0: Box;
  var ##i#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SplitOnce", " | ", StandardLibrary._default.SplitOnce$T, " | ", s#0, " | ", delim#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(35,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Contains(s#0, delim#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T)));
    assume _System.Tuple2.___hMake2_q(res#0);
    assume _System.Tuple2.___hMake2_q(res#0);
    assume Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(res#0)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(res#0)): Seq), s#0);
    assume _System.Tuple2.___hMake2_q(res#0);
    assume !Seq#Contains($Unbox(_System.Tuple2._0(res#0)): Seq, delim#0);
    assume false;
    return;

  anon4_Else:
    havoc i#Z#0;
    assume $Is(i#Z#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(i#Z#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.SplitOnce$T), $Heap);
    ##c#0 := delim#0;
    assume $IsAllocBox(##c#0, StandardLibrary._default.SplitOnce$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0 := LitInt(0);
    assume $IsAlloc(##i#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0 <= Seq#Length(##s#0);
    assume ##i#0 <= Seq#Length(##s#0);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0));
    assume let#0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume i#Z#0 == let#0#0#0;
    assume true;
    assume Wrappers.Option.Some_q(i#Z#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(41,18)"} true;
    assume Wrappers.Option.Some_q(i#Z#0);
    assume 0 <= $Unbox(Wrappers.Option.value(i#Z#0)): int && $Unbox(Wrappers.Option.value(i#Z#0)): int <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(i#Z#0);
    assume 0 <= $Unbox(Wrappers.Option.value(i#Z#0)): int + 1 && $Unbox(Wrappers.Option.value(i#Z#0)): int + 1 <= Seq#Length(s#0);
    assume StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0)): int + 1)));
    assume true;
    assume $Is(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T)));
    assume StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == res#0;
    return;
}



function StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0)) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0))): DatatypeType)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0))): DatatypeType)): Seq), s#0)) && (Wrappers.Option.None_q(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0)) ==> !Seq#Contains(s#0, delim#0)) && (Wrappers.Option.Some_q(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0)) ==> !Seq#Contains($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0))): DatatypeType)): Seq, delim#0)) && $Is(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { $IsAlloc(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))), $Heap) } (StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SplitOnce?$T), $Heap) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T) && $IsAllocBox(delim#0, StandardLibrary._default.SplitOnce?$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#0) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#0)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#0))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#0) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#0) else (var i#0 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#0)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#0)), $Box(Seq#Drop(s#0, i#0 + 1)))))))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#1 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#1) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#1)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#1))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#1 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#1) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#1) else (var i#1 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#1)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#1)), $Box(Seq#Drop(Lit(s#0), i#1 + 1)))))))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#2 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#2) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#2) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#2)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#2) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#2))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#2 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#2) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#2) else (var i#2 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#2)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#2))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#2 + 1)))))))))))));
}

function StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box) : bool;

function StandardLibrary.__default.SplitOnce_q#requires(Ty, Seq, Box) : bool;

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q#requires(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T) ==> (StandardLibrary.__default.SplitOnce_q#requires(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) <==> true));

procedure {:verboseName "StandardLibrary.SplitOnce? (well-formedness)"} CheckWellformed$$StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id1917"} Wrappers.Option.Some_q(res#0) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq), s#0);
  free ensures {:id "id1918"} Wrappers.Option.None_q(res#0) ==> !Seq#Contains(s#0, delim#0);
  free ensures {:id "id1919"} Wrappers.Option.Some_q(res#0) ==> !Seq#Contains($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq, delim#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SplitOnce? (well-formedness)"} CheckWellformed$$StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##c#0: Box;
  var ##i#0: int;
  var i#Z#0: int;
  var let#1#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SplitOnce?", " | ", StandardLibrary._default.SplitOnce?$T, " | ", s#0, " | ", delim#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(46,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Option.Some_q(res#0);
    assume Wrappers.Option.Some_q(res#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(res#0)): DatatypeType);
    assume Wrappers.Option.Some_q(res#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(res#0)): DatatypeType);
    assume Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq), s#0);
    goto anon5;

  anon17_Else:
    assume Wrappers.Option.Some_q(res#0) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq), s#0);
    goto anon5;

  anon5:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Wrappers.Option.None_q(res#0);
    assume !Seq#Contains(s#0, delim#0);
    goto anon8;

  anon18_Else:
    assume Wrappers.Option.None_q(res#0) ==> !Seq#Contains(s#0, delim#0);
    goto anon8;

  anon8:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Wrappers.Option.Some_q(res#0);
    assume Wrappers.Option.Some_q(res#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(res#0)): DatatypeType);
    assume !Seq#Contains($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq, delim#0);
    goto anon11;

  anon19_Else:
    assume Wrappers.Option.Some_q(res#0) ==> !Seq#Contains($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(res#0)): DatatypeType)): Seq, delim#0);
    goto anon11;

  anon11:
    assume false;
    return;

  anon16_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.SplitOnce?$T), $Heap);
    ##c#0 := delim#0;
    assume $IsAllocBox(##c#0, StandardLibrary._default.SplitOnce?$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0 := LitInt(0);
    assume $IsAlloc(##i#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0 <= Seq#Length(##s#0);
    assume ##i#0 <= Seq#Length(##s#0);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0));
    assume let#0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#Z#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#Z#0);
    assume StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#Z#0);
    assume $Is(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))));
    goto anon15;

  anon20_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#Z#0);
    havoc i#Z#0;
    assume LitInt(0) <= i#Z#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#Z#0)): int;
    assume Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass._System.nat());
    assume i#Z#0 == let#1#0#0;
    assume 0 <= i#Z#0 && i#Z#0 <= Seq#Length(s#0);
    assume 0 <= i#Z#0 + 1 && i#Z#0 + 1 <= Seq#Length(s#0);
    assume StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#Z#0)), $Box(Seq#Drop(s#0, i#Z#0 + 1)))));
    assume true;
    assume $Is(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))));
    goto anon15;

  anon15:
    assume StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == res#0;
    return;
}



procedure {:verboseName "StandardLibrary.WillSplitOnDelim (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T, $Heap), prefix#0: Seq where $Is(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.WillSplitOnDelim (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq, delim#0: Box, prefix#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##s#0: Seq;
  var ##delim#0: Box;
  var ##s#1: Seq;
  var ##delim#1: Box;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.WillSplitOnDelim", " | ", StandardLibrary._default.WillSplitOnDelim$T, " | ", s#0, " | ", delim#0, " | ", prefix#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(55,37): initial state"} true;
    assume Seq#Length(prefix#0) < Seq#Length(s#0);
    havoc i#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon8_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(prefix#0);
    assume 0 <= i#0 && i#0 < Seq#Length(prefix#0);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume Seq#Index(prefix#0, i#0) == Seq#Index(s#0, i#0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(prefix#0) ==> Seq#Index(prefix#0, i#0) == Seq#Index(s#0, i#0);
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(s#0, i#1) } { Seq#Index(prefix#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(prefix#0) ==> Seq#Index(prefix#0, i#1) == Seq#Index(s#0, i#1));
    assume !Seq#Contains(prefix#0, delim#0);
    assume 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) < Seq#Length(s#0);
    assume Seq#Index(s#0, Seq#Length(prefix#0)) == delim#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(59,28): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0 := delim#0;
    assume $IsAllocBox(##delim#0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0);
    assume 0 <= Seq#Length(prefix#0) + 1 && Seq#Length(prefix#0) + 1 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(prefix#0) + 1);
    assume $IsAlloc(##s#1, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#1 := delim#0;
    assume $IsAllocBox(##delim#1, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LZ), s#0, delim#0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LZ), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)));
    return;
}



procedure {:verboseName "StandardLibrary.WillSplitOnDelim (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T, $Heap), prefix#0: Seq where $Is(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap));
  requires {:id "id1957"} Seq#Length(prefix#0) < Seq#Length(s#0);
  requires {:id "id1958"} (forall i#1: int :: { Seq#Index(s#0, i#1) } { Seq#Index(prefix#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(prefix#0) ==> Seq#Index(prefix#0, i#1) == Seq#Index(s#0, i#1));
  requires {:id "id1959"} !Seq#Contains(prefix#0, delim#0);
  requires {:id "id1960"} Seq#Index(s#0, Seq#Length(prefix#0)) == delim#0;



procedure {:verboseName "StandardLibrary.WillSplitOnDelim (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T, $Heap), prefix#0: Seq where $Is(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0) && StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
  free ensures {:id "id1961"} Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), s#0, delim#0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.WillSplitOnDelim (correctness)"} {:vcs_split_on_every_assert} Impl$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillSplitOnDelim$T, $Heap), prefix#0: Seq where $Is(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && $IsAlloc(prefix#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id1962"} Seq#Length(prefix#0) < Seq#Length(s#0);
  requires {:id "id1963"} (forall i#1: int :: { Seq#Index(s#0, i#1) } { Seq#Index(prefix#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(prefix#0) ==> Seq#Index(prefix#0, i#1) == Seq#Index(s#0, i#1));
  requires {:id "id1964"} !Seq#Contains(prefix#0, delim#0);
  requires {:id "id1965"} Seq#Index(s#0, Seq#Length(prefix#0)) == delim#0;
  modifies $Heap;
  free ensures StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0) && StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
  free ensures {:id "id1966"} Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), s#0, delim#0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.WillSplitOnDelim (correctness)"} {:vcs_split_on_every_assert} Impl$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq, delim#0: Box, prefix#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##s#0_0_0: Seq;
  var ##delim#0_0_0: Box;
  var ##s#0_0_1: Seq;
  var ##delim#0_0_1: Box;
  var i#Z#0_1_0: DatatypeType;
  var let#0_1_0#0#0: DatatypeType;
  var ##s#0_1_0: Seq;
  var ##c#0_1_0: Box;
  var ##i#0_1_0: int;
  var ##s#0_1_1: Seq;
  var ##delim#0_1_0: Box;
  var s##0_1_0: Seq;
  var c##0_1_0: Box;
  var start##0_1_0: int;
  var elemIndex##0_1_0: int;
  var ##s#0_1_2: Seq;
  var ##c#0_1_1: Box;
  var ##i#0_1_1: int;
  var ##s#0_1_3: Seq;
  var ##delim#0_1_1: Box;
  var ##s#0_2_0: Seq;
  var ##delim#0_2_0: Box;
  var i#Z#0_2_0: DatatypeType;
  var let#0_2_0#0#0: DatatypeType;
  var ##s#0_2_1: Seq;
  var ##c#0_2_0: Box;
  var ##i#0_2_0: int;
  var ##s#0_2_2: Seq;
  var ##delim#0_2_1: Box;
  var ##s#0_0: Seq;
  var ##delim#0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.WillSplitOnDelim", " | ", StandardLibrary._default.WillSplitOnDelim$T, " | ", s#0, " | ", delim#0, " | ", prefix#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(60,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq :: $Is($ih#s0#0, TSeq(StandardLibrary._default.WillSplitOnDelim$T)) && Seq#Length(prefix#0) < Seq#Length($ih#s0#0) && (forall i#2: int :: { Seq#Index($ih#s0#0, i#2) } { Seq#Index(prefix#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(prefix#0) ==> Seq#Index(prefix#0, i#2) == Seq#Index($ih#s0#0, i#2)) && !Seq#Contains(prefix#0, delim#0) && Seq#Index($ih#s0#0, Seq#Length(prefix#0)) == delim#0 && (Seq#Rank($ih#s0#0) < Seq#Rank(s#0) || (Seq#Rank($ih#s0#0) == Seq#Rank(s#0) && Seq#Rank(prefix#0) < Seq#Rank(prefix#0))) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LZ), $ih#s0#0, delim#0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LZ), Seq#Drop($ih#s0#0, Seq#Length(prefix#0) + 1), delim#0))));
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_0 := delim#0;
    assume $IsAllocBox(##delim#0_0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0);
    assume false;
    goto anon11;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##s#0_2_0 := s#0;
    assume $IsAlloc(##s#0_2_0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_2_0 := delim#0;
    assume $IsAllocBox(##delim#0_2_0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0);
    havoc i#Z#0_2_0;
    assume $Is(i#Z#0_2_0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(i#Z#0_2_0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0_2_1 := s#0;
    assume $IsAlloc(##s#0_2_1, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##c#0_2_0 := delim#0;
    assume $IsAllocBox(##c#0_2_0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0_2_0 := LitInt(0);
    assume $IsAlloc(##i#0_2_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0_2_0 <= Seq#Length(##s#0_2_1);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume let#0_2_0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0_2_0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume i#Z#0_2_0 == let#0_2_0#0#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Wrappers.Option.Some_q(i#Z#0_2_0);
    assume Wrappers.Option.Some_q(i#Z#0_2_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_2_0)): int && $Unbox(Wrappers.Option.value(i#Z#0_2_0)): int <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(i#Z#0_2_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_2_0)): int + 1 && $Unbox(Wrappers.Option.value(i#Z#0_2_0)): int + 1 <= Seq#Length(s#0);
    ##s#0_2_2 := Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_2_0)): int + 1);
    assume $IsAlloc(##s#0_2_2, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_2_1 := delim#0;
    assume $IsAllocBox(##delim#0_2_1, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_2_0)): int + 1), delim#0);
    goto anon5;

  anon14_Else:
    assume {:partition} !Wrappers.Option.Some_q(i#Z#0_2_0);
    goto anon5;

  anon5:
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)) && (var i#0_1_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#0_1_0) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_1_0)): int + 1), delim#0));
    assume {:subsumption 0} Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), s#0, delim#0), (var i#0_1_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#0_1_0) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#0_1_0)): int))), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_1_0)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));
    assume false;
    goto anon11;

  anon13_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    havoc i#Z#0_1_0;
    assume $Is(i#Z#0_1_0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(i#Z#0_1_0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0_1_0 := s#0;
    assume $IsAlloc(##s#0_1_0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##c#0_1_0 := delim#0;
    assume $IsAllocBox(##c#0_1_0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0_1_0 := LitInt(0);
    assume $IsAlloc(##i#0_1_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0_1_0 <= Seq#Length(##s#0_1_0);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume let#0_1_0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0_1_0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume i#Z#0_1_0 == let#0_1_0#0#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Option.Some_q(i#Z#0_1_0);
    assume Wrappers.Option.Some_q(i#Z#0_1_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int && $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(i#Z#0_1_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1 && $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1 <= Seq#Length(s#0);
    ##s#0_1_1 := Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1);
    assume $IsAlloc(##s#0_1_1, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_1_0 := delim#0;
    assume $IsAllocBox(##delim#0_1_0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1), delim#0);
    goto anon9;

  anon16_Else:
    assume {:partition} !Wrappers.Option.Some_q(i#Z#0_1_0);
    goto anon9;

  anon9:
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)) && (var i#0_1_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#0_1_0) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_1_0)): int + 1), delim#0));
    assume true;
    s##0_1_0 := s#0;
    assume true;
    c##0_1_0 := delim#0;
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    start##0_1_0 := LitInt(0);
    assume true;
    assume $Is(Seq#Length(prefix#0), Tclass._System.nat());
    elemIndex##0_1_0 := Seq#Length(prefix#0);
    call CallPre$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.WillSplitOnDelim$T, s##0_1_0, c##0_1_0, start##0_1_0, elemIndex##0_1_0);
    call CallPost$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.WillSplitOnDelim$T, s##0_1_0, c##0_1_0, start##0_1_0, elemIndex##0_1_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(66,61)"} true;
    ##s#0_1_2 := s#0;
    assume $IsAlloc(##s#0_1_2, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##c#0_1_1 := delim#0;
    assume $IsAllocBox(##c#0_1_1, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0_1_1 := LitInt(0);
    assume $IsAlloc(##i#0_1_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0_1_1 <= Seq#Length(##s#0_1_2);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0));
    assume Wrappers.Option.Some_q(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(66,106)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) + 1 && Seq#Length(prefix#0) + 1 <= Seq#Length(s#0);
    ##s#0_1_3 := Seq#Drop(s#0, Seq#Length(prefix#0) + 1);
    assume $IsAlloc(##s#0_1_3, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_1_1 := delim#0;
    assume $IsAllocBox(##delim#0_1_1, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume {:subsumption 0} Seq#Equal((var i#0_1_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#0_1_0) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#0_1_0)): int))), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_1_0)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, Seq#Length(prefix#0)))), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)));
    assume false;
    goto anon11;

  anon15_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) + 1 && Seq#Length(prefix#0) + 1 <= Seq#Length(s#0);
    ##s#0_0_0 := Seq#Drop(s#0, Seq#Length(prefix#0) + 1);
    assume $IsAlloc(##s#0_0_0, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_0_0 := delim#0;
    assume $IsAllocBox(##delim#0_0_0, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(s#0);
    assume true;
    assume Seq#Equal(Seq#Take(s#0, Seq#Length(prefix#0)), prefix#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(68,40)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) + 1 && Seq#Length(prefix#0) + 1 <= Seq#Length(s#0);
    ##s#0_0_1 := Seq#Drop(s#0, Seq#Length(prefix#0) + 1);
    assume $IsAlloc(##s#0_0_1, TSeq(StandardLibrary._default.WillSplitOnDelim$T), $Heap);
    ##delim#0_0_1 := delim#0;
    assume $IsAllocBox(##delim#0_0_1, StandardLibrary._default.WillSplitOnDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillSplitOnDelim$T, Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, Seq#Length(prefix#0)))), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)));
    assume false;
    goto anon11;

  anon17_Else:
    goto anon11;

  anon11:
    assume Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LZ), s#0, delim#0), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), StandardLibrary.__default.Split(StandardLibrary._default.WillSplitOnDelim$T, $LS($LZ), Seq#Drop(s#0, Seq#Length(prefix#0) + 1), delim#0)));
    return;
}



procedure {:verboseName "StandardLibrary.WillNotSplitWithOutDelim (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.WillNotSplitWithOutDelim (call precondtion)"} CallPre$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap));
  requires {:id "id2003"} !Seq#Contains(s#0, delim#0);



procedure {:verboseName "StandardLibrary.WillNotSplitWithOutDelim (call postcondition)"} CallPost$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
  free ensures {:id "id2004"} Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LS($LZ)), s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.WillNotSplitWithOutDelim (correctness)"} Impl$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap), delim#0: Box where $IsBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T) && $IsAllocBox(delim#0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id2005"} !Seq#Contains(s#0, delim#0);
  modifies $Heap;
  free ensures StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
  free ensures {:id "id2006"} Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LS($LZ)), s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.WillNotSplitWithOutDelim (correctness)"} Impl$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T: Ty, s#0: Seq, delim#0: Box) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var i#Z#0_0_0: DatatypeType;
  var let#0_0_0#0#0: DatatypeType;
  var ##s#0_0_0: Seq;
  var ##c#0_0_0: Box;
  var ##i#0_0_0: int;
  var ##s#0_0_1: Seq;
  var ##delim#0_0_0: Box;
  var s##0_0_0: Seq;
  var c##0_0_0: Box;
  var start##0_0_0: int;
  var elemIndex##0_0_0: int;
  var ##s#0_1_0: Seq;
  var ##delim#0_1_0: Box;
  var i#Z#0_1_0: DatatypeType;
  var let#0_1_0#0#0: DatatypeType;
  var ##s#0_1_1: Seq;
  var ##c#0_1_0: Box;
  var ##i#0_1_0: int;
  var ##s#0_1_2: Seq;
  var ##delim#0_1_1: Box;
  var ##s#0_0: Seq;
  var ##delim#0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.WillNotSplitWithOutDelim", " | ", StandardLibrary._default.WillNotSplitWithOutDelim$T, " | ", s#0, " | ", delim#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(76,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq :: $Is($ih#s0#0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T)) && !Seq#Contains($ih#s0#0, delim#0) && Seq#Rank($ih#s0#0) < Seq#Rank(s#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LZ), $ih#s0#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box($ih#s0#0))));
    $_reverifyPost := false;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap);
    ##delim#0_0 := delim#0;
    assume $IsAllocBox(##delim#0_0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
    assume false;
    goto anon10;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##s#0_1_0 := s#0;
    assume $IsAlloc(##s#0_1_0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap);
    ##delim#0_1_0 := delim#0;
    assume $IsAllocBox(##delim#0_1_0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
    havoc i#Z#0_1_0;
    assume $Is(i#Z#0_1_0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(i#Z#0_1_0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0_1_1 := s#0;
    assume $IsAlloc(##s#0_1_1, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap);
    ##c#0_1_0 := delim#0;
    assume $IsAllocBox(##c#0_1_0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0_1_0 := LitInt(0);
    assume $IsAlloc(##i#0_1_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0_1_0 <= Seq#Length(##s#0_1_1);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0));
    assume let#0_1_0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0_1_0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume i#Z#0_1_0 == let#0_1_0#0#0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Wrappers.Option.Some_q(i#Z#0_1_0);
    assume Wrappers.Option.Some_q(i#Z#0_1_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int && $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(i#Z#0_1_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1 && $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1 <= Seq#Length(s#0);
    ##s#0_1_2 := Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1);
    assume $IsAlloc(##s#0_1_2, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap);
    ##delim#0_1_1 := delim#0;
    assume $IsAllocBox(##delim#0_1_1, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_1_0)): int + 1), delim#0);
    goto anon5;

  anon13_Else:
    assume {:partition} !Wrappers.Option.Some_q(i#Z#0_1_0);
    goto anon5;

  anon5:
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0)) && (var i#0_0_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#0_0_0) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_0_0)): int + 1), delim#0));
    assume {:subsumption 0} Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LS($LZ)), s#0, delim#0), (var i#0_0_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#0_0_0) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#0_0_0)): int))), StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_0_0)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));
    assume false;
    goto anon10;

  anon12_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    havoc i#Z#0_0_0;
    assume $Is(i#Z#0_0_0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(i#Z#0_0_0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap);
    ##c#0_0_0 := delim#0;
    assume $IsAllocBox(##c#0_0_0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##i#0_0_0 := LitInt(0);
    assume $IsAlloc(##i#0_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0_0_0 <= Seq#Length(##s#0_0_0);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0));
    assume let#0_0_0#0#0 == StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0));
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0));
    assume $Is(let#0_0_0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume i#Z#0_0_0 == let#0_0_0#0#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Wrappers.Option.Some_q(i#Z#0_0_0);
    assume Wrappers.Option.Some_q(i#Z#0_0_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_0_0)): int && $Unbox(Wrappers.Option.value(i#Z#0_0_0)): int <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(i#Z#0_0_0);
    assume {:subsumption 0} 0 <= $Unbox(Wrappers.Option.value(i#Z#0_0_0)): int + 1 && $Unbox(Wrappers.Option.value(i#Z#0_0_0)): int + 1 <= Seq#Length(s#0);
    ##s#0_0_1 := Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_0_0)): int + 1);
    assume $IsAlloc(##s#0_0_1, TSeq(StandardLibrary._default.WillNotSplitWithOutDelim$T), $Heap);
    ##delim#0_0_0 := delim#0;
    assume $IsAllocBox(##delim#0_0_0, StandardLibrary._default.WillNotSplitWithOutDelim$T, $Heap);
    assume StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#Z#0_0_0)): int + 1), delim#0);
    goto anon9;

  anon15_Else:
    assume {:partition} !Wrappers.Option.Some_q(i#Z#0_0_0);
    goto anon9;

  anon9:
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0)) && (var i#0_0_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#0_0_0) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.WillNotSplitWithOutDelim$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_0_0)): int + 1), delim#0));
    assume true;
    s##0_0_0 := s#0;
    assume true;
    c##0_0_0 := delim#0;
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    start##0_0_0 := LitInt(0);
    assume true;
    assume $Is(Seq#Length(s#0), Tclass._System.nat());
    elemIndex##0_0_0 := Seq#Length(s#0);
    call CallPre$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.WillNotSplitWithOutDelim$T, s##0_0_0, c##0_0_0, start##0_0_0, elemIndex##0_0_0);
    call CallPost$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.WillNotSplitWithOutDelim$T, s##0_0_0, c##0_0_0, start##0_0_0, elemIndex##0_0_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(82,56)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal((var i#0_0_0 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#0_0_0) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#0_0_0)): int))), StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LS($LZ)), Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#0_0_0)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))), Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
    assume false;
    goto anon10;

  anon14_Else:
    goto anon10;

  anon10:
    assume Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.WillNotSplitWithOutDelim$T, $LS($LZ), s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)));
    return;
}



procedure {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T), $Heap), c#0: Box where $IsBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T) && $IsAllocBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T, $Heap), start#0: int where LitInt(0) <= start#0, elemIndex#0: int where LitInt(0) <= elemIndex#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq, c#0: Box, start#0: int, elemIndex#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##s#0: Seq;
  var ##c#0: Box;
  var ##i#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.FindIndexMatchingLocatesElem", " | ", StandardLibrary._default.FindIndexMatchingLocatesElem$T, " | ", s#0, " | ", c#0, " | ", start#0, " | ", elemIndex#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(87,8): initial state"} true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} start#0 <= elemIndex#0;
    goto anon3;

  anon15_Else:
    assume {:partition} elemIndex#0 < start#0;
    goto anon3;

  anon3:
    assume start#0 <= elemIndex#0 && elemIndex#0 <= Seq#Length(s#0);
    havoc i#0;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} start#0 <= i#0;
    goto anon6;

  anon17_Else:
    assume {:partition} i#0 < start#0;
    goto anon6;

  anon6:
    assume start#0 <= i#0 && i#0 < elemIndex#0;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume Seq#Index(s#0, i#0) != c#0;
    goto anon8;

  anon16_Else:
    assume start#0 <= i#0 && i#0 < elemIndex#0 ==> Seq#Index(s#0, i#0) != c#0;
    goto anon8;

  anon8:
    assume (forall i#1: int :: { Seq#Index(s#0, i#1) } start#0 <= i#1 && i#1 < elemIndex#0 ==> Seq#Index(s#0, i#1) != c#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume elemIndex#0 == Seq#Length(s#0);
    goto anon11;

  anon18_Else:
    assume elemIndex#0 != Seq#Length(s#0);
    assume 0 <= elemIndex#0 && elemIndex#0 < Seq#Length(s#0);
    assume Seq#Index(s#0, elemIndex#0) == c#0;
    goto anon11;

  anon11:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(91,43): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T), $Heap);
    ##c#0 := c#0;
    assume $IsAllocBox(##c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T, $Heap);
    ##i#0 := start#0;
    assume $IsAlloc(##i#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0 <= Seq#Length(##s#0);
    assume ##i#0 <= Seq#Length(##s#0);
    assume StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} elemIndex#0 == Seq#Length(s#0);
    goto anon14;

  anon19_Else:
    assume {:partition} elemIndex#0 != Seq#Length(s#0);
    goto anon14;

  anon14:
    assume Wrappers.Option#Equal(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0), (if elemIndex#0 == Seq#Length(s#0) then #Wrappers.Option.None() else #Wrappers.Option.Some($Box(elemIndex#0))));
    return;
}



procedure {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (call precondtion)"} CallPre$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T), $Heap), c#0: Box where $IsBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T) && $IsAllocBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T, $Heap), start#0: int where LitInt(0) <= start#0, elemIndex#0: int where LitInt(0) <= elemIndex#0);
  requires {:id "id2042"} start#0 <= elemIndex#0;
  requires {:id "id2043"} elemIndex#0 <= Seq#Length(s#0);
  requires {:id "id2044"} (forall i#1: int :: { Seq#Index(s#0, i#1) } start#0 <= i#1 && i#1 < elemIndex#0 ==> Seq#Index(s#0, i#1) != c#0);
  requires {:id "id2045"} elemIndex#0 == Seq#Length(s#0) || Seq#Index(s#0, elemIndex#0) == c#0;



procedure {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (call postcondition)"} CallPost$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T), $Heap), c#0: Box where $IsBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T) && $IsAllocBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T, $Heap), start#0: int where LitInt(0) <= start#0, elemIndex#0: int where LitInt(0) <= elemIndex#0);
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0)) && $IsA#Wrappers.Option((if elemIndex#0 == Seq#Length(s#0) then #Wrappers.Option.None() else #Wrappers.Option.Some($Box(elemIndex#0)))) && StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0);
  free ensures {:id "id2046"} Wrappers.Option#Equal(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0), (if elemIndex#0 == Seq#Length(s#0) then #Wrappers.Option.None() else #Wrappers.Option.Some($Box(elemIndex#0))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (correctness)"} Impl$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndexMatchingLocatesElem$T), $Heap), c#0: Box where $IsBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T) && $IsAllocBox(c#0, StandardLibrary._default.FindIndexMatchingLocatesElem$T, $Heap), start#0: int where LitInt(0) <= start#0, elemIndex#0: int where LitInt(0) <= elemIndex#0) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id2047"} start#0 <= elemIndex#0;
  requires {:id "id2048"} elemIndex#0 <= Seq#Length(s#0);
  requires {:id "id2049"} (forall i#1: int :: { Seq#Index(s#0, i#1) } start#0 <= i#1 && i#1 < elemIndex#0 ==> Seq#Index(s#0, i#1) != c#0);
  requires {:id "id2050"} elemIndex#0 == Seq#Length(s#0) || Seq#Index(s#0, elemIndex#0) == c#0;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0)) && $IsA#Wrappers.Option((if elemIndex#0 == Seq#Length(s#0) then #Wrappers.Option.None() else #Wrappers.Option.Some($Box(elemIndex#0)))) && StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0);
  free ensures {:id "id2051"} Wrappers.Option#Equal(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0), (if elemIndex#0 == Seq#Length(s#0) then #Wrappers.Option.None() else #Wrappers.Option.Some($Box(elemIndex#0))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (correctness)"} Impl$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq, c#0: Box, start#0: int, elemIndex#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.FindIndexMatchingLocatesElem", " | ", StandardLibrary._default.FindIndexMatchingLocatesElem$T, " | ", s#0, " | ", c#0, " | ", start#0, " | ", elemIndex#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(93,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int < Seq#Length(s#0) && Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int) == c#0 && !Seq#Contains(Seq#Drop(Seq#Take(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int), i#0), c#0)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0)) ==> !Seq#Contains(Seq#Drop(s#0, i#0), c#0)) && $Is(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: $Box($l#2#x#0 == c#0)), (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: $IsBox($l#2#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#x#0: Box :: $Box($l#0#x#0 == c#0)), (lambda $l#0#heap#0: Heap, $l#0#x#0: Box :: $IsBox($l#0#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#0#heap#0: Heap, $l#0#x#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), i#0));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: $Box($l#5#x#0 == c#0)), (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: $IsBox($l#5#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#x#0: Box :: $Box($l#3#x#0 == c#0)), (lambda $l#3#heap#0: Heap, $l#3#x#0: Box :: $IsBox($l#3#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#3#heap#0: Heap, $l#3#x#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: $Box($l#8#x#0 == Lit(c#0))), (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: $IsBox($l#8#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#x#0: Box :: $Box($l#6#x#0 == Lit(c#0))), (lambda $l#6#heap#0: Heap, $l#6#x#0: Box :: $IsBox($l#6#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#6#heap#0: Heap, $l#6#x#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));
}

function StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int) : bool;

function StandardLibrary.__default.FindIndexMatching#requires(Ty, Seq, Box, int) : bool;

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching#requires(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 ==> (StandardLibrary.__default.FindIndexMatching#requires(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) <==> i#0 <= Seq#Length(s#0)));

procedure {:verboseName "StandardLibrary.FindIndexMatching (well-formedness)"} CheckWellformed$$StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)), c#0: Box where $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T), i#0: int where LitInt(0) <= i#0) returns (index#0: DatatypeType where $Is(index#0, Tclass.Wrappers.Option(Tclass._System.nat())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2052"} Wrappers.Option.Some_q(index#0) ==> i#0 <= $Unbox(Wrappers.Option.value(index#0)): int;
  free ensures {:id "id2053"} Wrappers.Option.Some_q(index#0) ==> $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0);
  free ensures {:id "id2054"} Wrappers.Option.Some_q(index#0) ==> Seq#Index(s#0, $Unbox(Wrappers.Option.value(index#0)): int) == c#0;
  free ensures {:id "id2055"} Wrappers.Option.Some_q(index#0) ==> !Seq#Contains(Seq#Drop(Seq#Take(s#0, $Unbox(Wrappers.Option.value(index#0)): int), i#0), c#0);
  free ensures {:id "id2056"} Wrappers.Option.None_q(index#0) ==> !Seq#Contains(Seq#Drop(s#0, i#0), c#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.FindIndexMatching (well-formedness)"} CheckWellformed$$StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int) returns (index#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var x#0: Box;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##s#0: Seq;
  var ##f#0: HandleType;
  var ##i#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.FindIndexMatching", " | ", StandardLibrary._default.FindIndexMatching$T, " | ", s#0, " | ", c#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(95,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume i#0 <= Seq#Length(s#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Option.Some_q(index#0);
    assume Wrappers.Option.Some_q(index#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} i#0 <= $Unbox(Wrappers.Option.value(index#0)): int;
    assume Wrappers.Option.Some_q(index#0);
    goto anon5;

  anon18_Else:
    assume {:partition} $Unbox(Wrappers.Option.value(index#0)): int < i#0;
    goto anon5;

  anon5:
    assume i#0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0);
    assume Wrappers.Option.Some_q(index#0);
    assume 0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0);
    assume Seq#Index(s#0, $Unbox(Wrappers.Option.value(index#0)): int) == c#0;
    assume 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume Wrappers.Option.Some_q(index#0);
    assume i#0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int <= Seq#Length(s#0);
    assume !Seq#Contains(Seq#Drop(Seq#Take(s#0, $Unbox(Wrappers.Option.value(index#0)): int), i#0), c#0);
    goto anon7;

  anon17_Else:
    assume Wrappers.Option.Some_q(index#0) ==> i#0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0) && Seq#Index(s#0, $Unbox(Wrappers.Option.value(index#0)): int) == c#0 && !Seq#Contains(Seq#Drop(Seq#Take(s#0, $Unbox(Wrappers.Option.value(index#0)): int), i#0), c#0);
    goto anon7;

  anon7:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Wrappers.Option.None_q(index#0);
    assume 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume !Seq#Contains(Seq#Drop(s#0, i#0), c#0);
    goto anon10;

  anon19_Else:
    assume Wrappers.Option.None_q(index#0) ==> !Seq#Contains(Seq#Drop(s#0, i#0), c#0);
    goto anon10;

  anon10:
    assume false;
    return;

  anon16_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc x#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $IsBox(x#0, StandardLibrary._default.FindIndexMatching$T) && $IsAllocBox(x#0, StandardLibrary._default.FindIndexMatching$T, $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 <==> x#0 == c#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon14;

  anon21_Else:
    assume {:partition} !($IsBox(x#0, StandardLibrary._default.FindIndexMatching$T) && $IsAllocBox(x#0, StandardLibrary._default.FindIndexMatching$T, $lambdaHeap#0));
    goto anon14;

  anon14:
    assume false;
    goto anon15;

  anon20_Else:
    goto anon15;

  anon15:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.FindIndexMatching$T), $Heap);
    ##f#0 := Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: $Box($l#10#x#0 == c#0)), (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: $IsBox($l#10#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#10#heap#0: Heap, $l#10#x#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndexMatching$T, TBool), $Heap);
    ##i#0 := i#0;
    assume $IsAlloc(##i#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0 <= Seq#Length(##s#0);
    assume ##i#0 <= Seq#Length(##s#0);
    assume StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: $Box($l#11#x#0 == c#0)), (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: $IsBox($l#11#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#11#heap#0: Heap, $l#11#x#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))), i#0);
    assume StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#x#0: Box :: $Box($l#13#x#0 == c#0)), (lambda $l#13#heap#0: Heap, $l#13#x#0: Box :: $IsBox($l#13#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#13#heap#0: Heap, $l#13#x#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), i#0);
    assume StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#x#0: Box :: $Box($l#15#x#0 == c#0)), (lambda $l#15#heap#0: Heap, $l#15#x#0: Box :: $IsBox($l#15#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#15#heap#0: Heap, $l#15#x#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))), i#0);
    assume $Is(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == index#0;
    return;
}



function StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, s#0: Seq, f#0: HandleType, i#0: int) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#0: int :: { Seq#Index(s#0, j#0) } i#0 <= j#0 && j#0 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#0))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#1: int :: { Seq#Index(s#0, j#1) } i#0 <= j#1 && j#1 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#1))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (i#0 != Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0 + 1)) && StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), s#0, f#0, i#0) == (if i#0 == Seq#Length(s#0) then #Wrappers.Option.None() else (if $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool then #Wrappers.Option.Some($Box(i#0)) else StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0 + 1))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), f#0, LitInt(i#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), f#0, LitInt(i#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> (LitInt(i#0) != Seq#Length(Lit(s#0)) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(i#0)))): bool ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), f#0, LitInt(i#0 + 1))) && StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), f#0, LitInt(i#0)) == (if LitInt(i#0) == Seq#Length(Lit(s#0)) then #Wrappers.Option.None() else (if $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(i#0)))): bool then #Wrappers.Option.Some($Box(LitInt(i#0))) else StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), f#0, LitInt(i#0 + 1)))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), Lit(f#0), LitInt(i#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), Lit(f#0), LitInt(i#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> (LitInt(i#0) != Seq#Length(Lit(s#0)) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(i#0)))): bool ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), Lit(f#0), LitInt(i#0 + 1))) && StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), Lit(f#0), LitInt(i#0)) == (if LitInt(i#0) == Seq#Length(Lit(s#0)) then #Wrappers.Option.None() else (if $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(i#0)))): bool then #Wrappers.Option.Some($Box(LitInt(i#0))) else StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), Lit(f#0), LitInt(i#0 + 1)))));
}

function StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T: Ty, s#0: Seq, f#0: HandleType, i#0: int) : bool;

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), s#0, f#0, i#0) } StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), s#0, f#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, AsFuelBottom($ly), s#0, f#0, i#0) } StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LZ, s#0, f#0, i#0));

function StandardLibrary.__default.FindIndex#requires(Ty, LayerType, Seq, HandleType, int) : bool;

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex#requires(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 ==> (StandardLibrary.__default.FindIndex#requires(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0) <==> i#0 <= Seq#Length(s#0)));

procedure {:verboseName "StandardLibrary.FindIndex (well-formedness)"} CheckWellformed$$StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)), i#0: int where LitInt(0) <= i#0) returns (index#0: DatatypeType where $Is(index#0, Tclass.Wrappers.Option(Tclass._System.nat())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2078"} Wrappers.Option.Some_q(index#0) ==> i#0 <= $Unbox(Wrappers.Option.value(index#0)): int;
  free ensures {:id "id2079"} Wrappers.Option.Some_q(index#0) ==> $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0);
  free ensures {:id "id2080"} Wrappers.Option.Some_q(index#0) ==> $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(index#0)): int))): bool;
  free ensures {:id "id2081"} Wrappers.Option.Some_q(index#0) ==> (forall j#2: int :: { Seq#Index(s#0, j#2) } i#0 <= j#2 && j#2 < $Unbox(Wrappers.Option.value(index#0)): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#2))): bool);
  free ensures {:id "id2082"} Wrappers.Option.None_q(index#0) ==> (forall j#3: int :: { Seq#Index(s#0, j#3) } i#0 <= j#3 && j#3 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#3))): bool);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.FindIndex (well-formedness)"} CheckWellformed$$StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T: Ty, s#0: Seq, f#0: HandleType, i#0: int) returns (index#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#4: int;
  var j#5: int;
  var ##s#0: Seq;
  var ##f#0: HandleType;
  var ##i#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.FindIndex", " | ", StandardLibrary._default.FindIndex$T, " | ", s#0, " | ", f#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(104,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume i#0 <= Seq#Length(s#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume Wrappers.Option.Some_q(index#0);
    assume Wrappers.Option.Some_q(index#0);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} i#0 <= $Unbox(Wrappers.Option.value(index#0)): int;
    assume Wrappers.Option.Some_q(index#0);
    goto anon5;

  anon29_Else:
    assume {:partition} $Unbox(Wrappers.Option.value(index#0)): int < i#0;
    goto anon5;

  anon5:
    assume i#0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0);
    assume Wrappers.Option.Some_q(index#0);
    assume 0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0);
    assume $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(index#0)): int))): bool;
    havoc j#4;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} true;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} i#0 <= j#4;
    assume Wrappers.Option.Some_q(index#0);
    goto anon8;

  anon31_Else:
    assume {:partition} j#4 < i#0;
    goto anon8;

  anon8:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} i#0 <= j#4 && j#4 < $Unbox(Wrappers.Option.value(index#0)): int;
    assume 0 <= j#4 && j#4 < Seq#Length(s#0);
    goto anon10;

  anon32_Else:
    assume {:partition} !(i#0 <= j#4 && j#4 < $Unbox(Wrappers.Option.value(index#0)): int);
    goto anon10;

  anon30_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall j#2: int :: { Seq#Index(s#0, j#2) } i#0 <= j#2 && j#2 < $Unbox(Wrappers.Option.value(index#0)): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#2))): bool);
    goto anon12;

  anon28_Else:
    assume Wrappers.Option.Some_q(index#0) ==> i#0 <= $Unbox(Wrappers.Option.value(index#0)): int && $Unbox(Wrappers.Option.value(index#0)): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(index#0)): int))): bool && (forall j#2: int :: { Seq#Index(s#0, j#2) } i#0 <= j#2 && j#2 < $Unbox(Wrappers.Option.value(index#0)): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#2))): bool);
    goto anon12;

  anon12:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume Wrappers.Option.None_q(index#0);
    havoc j#5;
    assume true;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} i#0 <= j#5;
    goto anon16;

  anon35_Else:
    assume {:partition} j#5 < i#0;
    goto anon16;

  anon16:
    assume i#0 <= j#5 && j#5 < Seq#Length(s#0);
    assume 0 <= j#5 && j#5 < Seq#Length(s#0);
    assume !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#5))): bool;
    goto anon18;

  anon34_Else:
    assume i#0 <= j#5 && j#5 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#5))): bool;
    goto anon18;

  anon18:
    assume (forall j#3: int :: { Seq#Index(s#0, j#3) } i#0 <= j#3 && j#3 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#3))): bool);
    goto anon20;

  anon33_Else:
    assume Wrappers.Option.None_q(index#0) ==> (forall j#3: int :: { Seq#Index(s#0, j#3) } i#0 <= j#3 && j#3 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#3))): bool);
    goto anon20;

  anon20:
    assume false;
    return;

  anon27_Else:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} i#0 == Seq#Length(s#0);
    assume StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon26;

  anon36_Else:
    assume {:partition} i#0 != Seq#Length(s#0);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool;
    assume StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0) == #Wrappers.Option.Some($Box(i#0));
    assume true;
    assume $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon26;

  anon37_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap);
    assume $Is(i#0 + 1, Tclass._System.nat());
    ##i#0 := i#0 + 1;
    assume $IsAlloc(##i#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##i#0 <= Seq#Length(##s#0);
    assume ##i#0 <= Seq#Length(##s#0);
    assume 0 <= Seq#Length(s#0) - i#0 || Seq#Length(##s#0) - ##i#0 == Seq#Length(s#0) - i#0;
    assume Seq#Length(##s#0) - ##i#0 < Seq#Length(s#0) - i#0;
    assume StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0 + 1);
    assume StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0 + 1);
    assume StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0 + 1);
    assume $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon26;

  anon26:
    assume StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($LZ), s#0, f#0, i#0) == index#0;
    return;
}



function StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T: Ty, $ly: LayerType, s#0: Seq, f#0: HandleType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#0: int :: { Seq#Index(s#0, i#0) } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#0))) && (forall i#1: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#1) } (LitInt(0) <= i#1 && i#1 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#1))) && (LitInt(0) <= i#1 && i#1 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#1))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { $IsAlloc(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T), $Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> $IsAlloc(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) ==> (Seq#Length(s#0) != LitInt(0) ==> ($Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0))) && StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), s#0, f#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (if $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, Seq#Drop(s#0, LitInt(1)), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, Seq#Drop(s#0, LitInt(1)), f#0))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: {:weight 3} { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(s#0), f#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> ($Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0))) && StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), f#0) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (if $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(s#0), LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: {:weight 3} { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), Lit(f#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(s#0), Lit(f#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> ($Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0))) && (!$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0)))) && StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), Lit(f#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (if $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(s#0), LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0))) else StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0)))));
}

function StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T: Ty, s#0: Seq, f#0: HandleType) : bool;

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), s#0, f#0) } StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), s#0, f#0) == StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, AsFuelBottom($ly), s#0, f#0) } StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0) == StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LZ, s#0, f#0));

function StandardLibrary.__default.Filter#requires(Ty, LayerType, Seq, HandleType) : bool;

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter#requires(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) ==> (StandardLibrary.__default.Filter#requires(StandardLibrary._default.Filter$T, $ly, s#0, f#0) <==> true));

procedure {:verboseName "StandardLibrary.Filter (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.Filter$T)), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) returns (res#0: Seq where $Is(res#0, TSeq(StandardLibrary._default.Filter$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2111"} (forall i#2: int :: { Seq#Index(s#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#2))): bool ==> Seq#Contains(res#0, Seq#Index(s#0, i#2)));
  free ensures {:id "id2112"} (forall i#3: int :: { Seq#Index(res#0, i#3) } (LitInt(0) <= i#3 && i#3 < Seq#Length(res#0) ==> Seq#Contains(s#0, Seq#Index(res#0, i#3))) && (LitInt(0) <= i#3 && i#3 < Seq#Length(res#0) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(res#0, i#3))): bool));
  free ensures {:id "id2113"} Seq#Length(res#0) <= Seq#Length(s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Filter (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T: Ty, s#0: Seq, f#0: HandleType) returns (res#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#4: int;
  var i#5: int;
  var ##s#0: Seq;
  var ##f#0: HandleType;
  var ##s#1: Seq;
  var ##f#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Filter", " | ", StandardLibrary._default.Filter$T, " | ", s#0, " | ", f#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(115,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0), TSeq(StandardLibrary._default.Filter$T));
    havoc i#4;
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon5;

  anon21_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#4 && i#4 < Seq#Length(s#0);
    assume 0 <= i#4 && i#4 < Seq#Length(s#0);
    assume $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#4))): bool;
    assume 0 <= i#4 && i#4 < Seq#Length(s#0);
    assume Seq#Contains(res#0, Seq#Index(s#0, i#4));
    goto anon7;

  anon20_Else:
    assume LitInt(0) <= i#4 && i#4 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#4))): bool ==> Seq#Contains(res#0, Seq#Index(s#0, i#4));
    goto anon7;

  anon7:
    assume (forall i#2: int :: { Seq#Index(s#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#2))): bool ==> Seq#Contains(res#0, Seq#Index(s#0, i#2)));
    havoc i#5;
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= i#5;
    goto anon10;

  anon23_Else:
    assume {:partition} i#5 < LitInt(0);
    goto anon10;

  anon10:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(res#0);
    assume 0 <= i#5 && i#5 < Seq#Length(res#0);
    assume Seq#Contains(s#0, Seq#Index(res#0, i#5));
    assume 0 <= i#5 && i#5 < Seq#Length(res#0);
    assume $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(res#0, i#5))): bool;
    goto anon12;

  anon22_Else:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(res#0) ==> Seq#Contains(s#0, Seq#Index(res#0, i#5)) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(res#0, i#5))): bool;
    goto anon12;

  anon12:
    assume (forall i#3: int :: { Seq#Index(res#0, i#3) } (LitInt(0) <= i#3 && i#3 < Seq#Length(res#0) ==> Seq#Contains(s#0, Seq#Index(res#0, i#3))) && (LitInt(0) <= i#3 && i#3 < Seq#Length(res#0) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(res#0, i#3))): bool));
    assume Seq#Length(res#0) <= Seq#Length(s#0);
    assume false;
    return;

  anon19_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0), TSeq(StandardLibrary._default.Filter$T));
    goto anon18;

  anon24_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(StandardLibrary._default.Filter$T), $Heap);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap);
    assume Seq#Rank(##s#0) < Seq#Rank(s#0);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0);
    assume StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), Seq#Drop(s#0, LitInt(1)), f#0));
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0);
    assume $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0), TSeq(StandardLibrary._default.Filter$T));
    goto anon18;

  anon25_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#1, TSeq(StandardLibrary._default.Filter$T), $Heap);
    ##f#1 := f#0;
    assume $IsAlloc(##f#1, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap);
    assume Seq#Rank(##s#1) < Seq#Rank(s#0);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0);
    assume StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0) == StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), Seq#Drop(s#0, LitInt(1)), f#0);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0);
    assume $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0), TSeq(StandardLibrary._default.Filter$T));
    goto anon18;

  anon18:
    assume StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($LZ), s#0, f#0) == res#0;
    return;
}



procedure {:verboseName "StandardLibrary.FilterIsDistributive (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), s'#0: Seq where $Is(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.FilterIsDistributive (call precondtion)"} CallPre$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), s'#0: Seq where $Is(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap));



procedure {:verboseName "StandardLibrary.FilterIsDistributive (call postcondition)"} CallPost$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), s'#0: Seq where $Is(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s#0, s'#0), f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s#0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
  free ensures {:id "id2140"} Seq#Equal(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Append(s#0, s'#0), f#0), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s#0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.FilterIsDistributive (correctness)"} Impl$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), s'#0: Seq where $Is(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s'#0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s#0, s'#0), f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s#0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
  free ensures {:id "id2141"} Seq#Equal(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Append(s#0, s'#0), f#0), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s#0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.FilterIsDistributive (correctness)"} Impl$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T: Ty, s#0: Seq, s'#0: Seq, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var S#1_0: Seq where $Is(S#1_0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(S#1_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
  var s1#1_0: Seq where $Is(s1#1_0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $IsAlloc(s1#1_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
  var ##s#1_0_0_0: Seq;
  var ##f#1_0_0_0: HandleType;
  var ##s#1_0_0_1: Seq;
  var ##f#1_0_0_1: HandleType;
  var ##s#1_0_0_2: Seq;
  var ##f#1_0_0_2: HandleType;
  var ##s#1_0_0_3: Seq;
  var ##f#1_0_0_3: HandleType;
  var ##s#1_0_0_4: Seq;
  var ##f#1_0_0_4: HandleType;
  var ##s#1_0_1_0: Seq;
  var ##f#1_0_1_0: HandleType;
  var ##s#1_0_1_1: Seq;
  var ##f#1_0_1_1: HandleType;
  var ##s#1_0_1_2: Seq;
  var ##f#1_0_1_2: HandleType;
  var ##s#1_0_1_3: Seq;
  var ##f#1_0_1_3: HandleType;
  var ##s#1_0_1_4: Seq;
  var ##f#1_0_1_4: HandleType;
  var ##s#1_0_1_5: Seq;
  var ##f#1_0_1_5: HandleType;
  var ##s#1_0_1_6: Seq;
  var ##f#1_0_1_6: HandleType;
  var ##s#1_0_2_0: Seq;
  var ##f#1_0_2_0: HandleType;
  var ##s#1_0_2_1: Seq;
  var ##f#1_0_2_1: HandleType;
  var ##s#1_0_2_2: Seq;
  var ##f#1_0_2_2: HandleType;
  var ##s#1_0_2_3: Seq;
  var ##f#1_0_2_3: HandleType;
  var ##s#1_0_2_4: Seq;
  var ##f#1_0_2_4: HandleType;
  var ##s#1_0_2_5: Seq;
  var ##f#1_0_2_5: HandleType;
  var ##s#1_0_2_6: Seq;
  var ##f#1_0_2_6: HandleType;
  var ##s#1_0_2_7: Seq;
  var ##f#1_0_2_7: HandleType;
  var ##s#1_0_3_0: Seq;
  var ##f#1_0_3_0: HandleType;
  var ##s#1_0_3_1: Seq;
  var ##f#1_0_3_1: HandleType;
  var s##1_0_3_0: Seq;
  var s'##1_0_3_0: Seq;
  var f##1_0_3_0: HandleType;
  var ##s#1_0_3_2: Seq;
  var ##f#1_0_3_2: HandleType;
  var ##s#1_0_3_3: Seq;
  var ##f#1_0_3_3: HandleType;
  var ##s#1_0_3_4: Seq;
  var ##f#1_0_3_4: HandleType;
  var ##s#1_0_3_5: Seq;
  var ##f#1_0_3_5: HandleType;
  var ##s#1_0_4_0: Seq;
  var ##f#1_0_4_0: HandleType;
  var ##s#1_0_4_1: Seq;
  var ##f#1_0_4_1: HandleType;
  var ##s#1_0_4_2: Seq;
  var ##f#1_0_4_2: HandleType;
  var ##s#1_0_4_3: Seq;
  var ##f#1_0_4_3: HandleType;
  var ##s#1_0_5_0: Seq;
  var ##f#1_0_5_0: HandleType;
  var ##s#1_0_5_1: Seq;
  var ##f#1_0_5_1: HandleType;
  var ##s#1_0_5_2: Seq;
  var ##f#1_0_5_2: HandleType;
  var ##s#1_0_0: Seq;
  var ##f#1_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.FilterIsDistributive", " | ", StandardLibrary._default.FilterIsDistributive$T, " | ", s#0, " | ", s'#0, " | ", f#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(127,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq, $ih#s'0#0: Seq, $ih#f0#0: HandleType :: $Is($ih#s0#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $Is($ih#s'0#0, TSeq(StandardLibrary._default.FilterIsDistributive$T)) && $Is($ih#f0#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool)) && Lit(true) && (Seq#Rank($ih#s0#0) < Seq#Rank(s#0) || (Seq#Rank($ih#s0#0) == Seq#Rank(s#0) && Seq#Rank($ih#s'0#0) < Seq#Rank(s'#0))) ==> Seq#Equal(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LZ), Seq#Append($ih#s0#0, $ih#s'0#0), $ih#f0#0), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LZ), $ih#s0#0, $ih#f0#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LZ), $ih#s'0#0, $ih#f0#0))));
    $_reverifyPost := false;
    assume true;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    assume true;
    assume Seq#Equal(Seq#Append(s#0, s'#0), s'#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(129,25)"} true;
    return;

  anon43_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    assume true;
    assume true;
    S#1_0 := Seq#Append(s#0, s'#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(131,21)"} true;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume true;
    s1#1_0 := Seq#Drop(s#0, LitInt(1));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(132,22)"} true;
    goto anon44_Then, anon44_Else;

  anon44_Then:
    ##s#1_0_0 := S#1_0;
    assume $IsAlloc(##s#1_0_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, S#1_0, f#0);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, S#1_0, f#0);
    assume false;
    goto anon42;

  anon44_Else:
    goto anon45_Then, anon45_Else;

  anon45_Then:
    ##s#1_0_5_0 := S#1_0;
    assume $IsAlloc(##s#1_0_5_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_5_0 := f#0;
    assume $IsAlloc(##f#1_0_5_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, S#1_0, f#0);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, S#1_0, f#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(S#1_0);
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(S#1_0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(S#1_0);
    ##s#1_0_5_1 := Seq#Drop(S#1_0, LitInt(1));
    assume $IsAlloc(##s#1_0_5_1, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_5_1 := f#0;
    assume $IsAlloc(##f#1_0_5_1, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0);
    goto anon7;

  anon46_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(S#1_0);
    ##s#1_0_5_2 := Seq#Drop(S#1_0, LitInt(1));
    assume $IsAlloc(##s#1_0_5_2, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_5_2 := f#0;
    assume $IsAlloc(##f#1_0_5_2, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0);
    goto anon7;

  anon7:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0));
    assume {:subsumption 0} Seq#Equal(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), S#1_0, f#0), (if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(S#1_0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Drop(S#1_0, LitInt(1)), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Drop(S#1_0, LitInt(1)), f#0)));
    assume false;
    goto anon42;

  anon45_Else:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(S#1_0);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(S#1_0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(S#1_0);
    ##s#1_0_4_0 := Seq#Drop(S#1_0, LitInt(1));
    assume $IsAlloc(##s#1_0_4_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_4_0 := f#0;
    assume $IsAlloc(##f#1_0_4_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0);
    goto anon11;

  anon48_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(S#1_0);
    ##s#1_0_4_1 := Seq#Drop(S#1_0, LitInt(1));
    assume $IsAlloc(##s#1_0_4_1, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_4_1 := f#0;
    assume $IsAlloc(##f#1_0_4_1, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0);
    goto anon11;

  anon11:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Drop(S#1_0, LitInt(1)), f#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(S#1_0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} Seq#Index(S#1_0, LitInt(0)) == Seq#Index(s#0, LitInt(0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(S#1_0);
    goto anon13;

  anon49_Else:
    assume {:partition} Seq#Index(S#1_0, LitInt(0)) != Seq#Index(s#0, LitInt(0));
    goto anon13;

  anon13:
    assume true;
    assume {:subsumption 0} Seq#Index(S#1_0, LitInt(0)) == Seq#Index(s#0, LitInt(0));
    assume {:subsumption 0} Seq#Equal(Seq#Drop(S#1_0, LitInt(1)), Seq#Append(s1#1_0, s'#0));
    assume Seq#Index(S#1_0, LitInt(0)) == Seq#Index(s#0, LitInt(0)) && Seq#Equal(Seq#Drop(S#1_0, LitInt(1)), Seq#Append(s1#1_0, s'#0));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(137,52)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_4_2 := Seq#Append(s1#1_0, s'#0);
    assume $IsAlloc(##s#1_0_4_2, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_4_2 := f#0;
    assume $IsAlloc(##f#1_0_4_2, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0);
    goto anon16;

  anon50_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_4_3 := Seq#Append(s1#1_0, s'#0);
    assume $IsAlloc(##s#1_0_4_3, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_4_3 := f#0;
    assume $IsAlloc(##f#1_0_4_3, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0);
    goto anon16;

  anon16:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0));
    assume {:subsumption 0} Seq#Equal((if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(S#1_0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(S#1_0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Drop(S#1_0, LitInt(1)), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Drop(S#1_0, LitInt(1)), f#0)), (if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Append(s1#1_0, s'#0), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Append(s1#1_0, s'#0), f#0)));
    assume false;
    goto anon42;

  anon47_Else:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_3_0 := Seq#Append(s1#1_0, s'#0);
    assume $IsAlloc(##s#1_0_3_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_3_0 := f#0;
    assume $IsAlloc(##f#1_0_3_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0);
    goto anon20;

  anon52_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_3_1 := Seq#Append(s1#1_0, s'#0);
    assume $IsAlloc(##s#1_0_3_1, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_3_1 := f#0;
    assume $IsAlloc(##f#1_0_3_1, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0);
    goto anon20;

  anon20:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, Seq#Append(s1#1_0, s'#0), f#0));
    assume true;
    s##1_0_3_0 := s1#1_0;
    assume true;
    s'##1_0_3_0 := s'#0;
    assume true;
    f##1_0_3_0 := f#0;
    assume Seq#Rank(s##1_0_3_0) < Seq#Rank(s#0) || (Seq#Rank(s##1_0_3_0) == Seq#Rank(s#0) && Seq#Rank(s'##1_0_3_0) < Seq#Rank(s'#0));
    call CallPre$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T, s##1_0_3_0, s'##1_0_3_0, f##1_0_3_0);
    call CallPost$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T, s##1_0_3_0, s'##1_0_3_0, f##1_0_3_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(139,43)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_3_2 := s1#1_0;
    assume $IsAlloc(##s#1_0_3_2, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_3_2 := f#0;
    assume $IsAlloc(##f#1_0_3_2, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_3_3 := s'#0;
    assume $IsAlloc(##s#1_0_3_3, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_3_3 := f#0;
    assume $IsAlloc(##f#1_0_3_3, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon23;

  anon53_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_3_4 := s1#1_0;
    assume $IsAlloc(##s#1_0_3_4, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_3_4 := f#0;
    assume $IsAlloc(##f#1_0_3_4, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_3_5 := s'#0;
    assume $IsAlloc(##s#1_0_3_5, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_3_5 := f#0;
    assume $IsAlloc(##f#1_0_3_5, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon23;

  anon23:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0));
    assume {:subsumption 0} Seq#Equal((if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Append(s1#1_0, s'#0), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), Seq#Append(s1#1_0, s'#0), f#0)), (if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0))) else Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0))));
    assume false;
    goto anon42;

  anon51_Else:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_2_0 := s1#1_0;
    assume $IsAlloc(##s#1_0_2_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_0 := f#0;
    assume $IsAlloc(##f#1_0_2_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_2_1 := s'#0;
    assume $IsAlloc(##s#1_0_2_1, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_1 := f#0;
    assume $IsAlloc(##f#1_0_2_1, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon27;

  anon55_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_2_2 := s1#1_0;
    assume $IsAlloc(##s#1_0_2_2, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_2 := f#0;
    assume $IsAlloc(##f#1_0_2_2, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_2_3 := s'#0;
    assume $IsAlloc(##s#1_0_2_3, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_3 := f#0;
    assume $IsAlloc(##f#1_0_2_3, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon27;

  anon27:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_2_4 := s1#1_0;
    assume $IsAlloc(##s#1_0_2_4, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_4 := f#0;
    assume $IsAlloc(##f#1_0_2_4, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_2_5 := s'#0;
    assume $IsAlloc(##s#1_0_2_5, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_5 := f#0;
    assume $IsAlloc(##f#1_0_2_5, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon30;

  anon56_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_2_6 := s1#1_0;
    assume $IsAlloc(##s#1_0_2_6, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_6 := f#0;
    assume $IsAlloc(##f#1_0_2_6, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_2_7 := s'#0;
    assume $IsAlloc(##s#1_0_2_7, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_2_7 := f#0;
    assume $IsAlloc(##f#1_0_2_7, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon30;

  anon30:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0));
    assume {:subsumption 0} Seq#Equal((if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0))) else Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0))), (if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0)), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)) else Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0))));
    assume false;
    goto anon42;

  anon54_Else:
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_1_0 := s1#1_0;
    assume $IsAlloc(##s#1_0_1_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_0 := f#0;
    assume $IsAlloc(##f#1_0_1_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_1_1 := s'#0;
    assume $IsAlloc(##s#1_0_1_1, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_1 := f#0;
    assume $IsAlloc(##f#1_0_1_1, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon34;

  anon58_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_1_2 := s1#1_0;
    assume $IsAlloc(##s#1_0_1_2, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_2 := f#0;
    assume $IsAlloc(##f#1_0_1_2, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    ##s#1_0_1_3 := s'#0;
    assume $IsAlloc(##s#1_0_1_3, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_3 := f#0;
    assume $IsAlloc(##f#1_0_1_3, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    goto anon34;

  anon34:
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_1_4 := s1#1_0;
    assume $IsAlloc(##s#1_0_1_4, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_4 := f#0;
    assume $IsAlloc(##f#1_0_1_4, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    goto anon37;

  anon59_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_1_5 := s1#1_0;
    assume $IsAlloc(##s#1_0_1_5, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_5 := f#0;
    assume $IsAlloc(##f#1_0_1_5, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    goto anon37;

  anon37:
    ##s#1_0_1_6 := s'#0;
    assume $IsAlloc(##s#1_0_1_6, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_1_6 := f#0;
    assume $IsAlloc(##f#1_0_1_6, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0)) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    assume {:subsumption 0} Seq#Equal((if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0)), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)) else Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0))), Seq#Append((if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0)), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)));
    assume false;
    goto anon42;

  anon57_Else:
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#1_0_0_0 := s1#1_0;
    assume $IsAlloc(##s#1_0_0_0, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0_0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    goto anon41;

  anon61_Else:
    assume {:partition} !$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool;
    ##s#1_0_0_1 := s1#1_0;
    assume $IsAlloc(##s#1_0_0_1, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_0_1 := f#0;
    assume $IsAlloc(##f#1_0_0_1, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0);
    goto anon41;

  anon41:
    ##s#1_0_0_2 := s'#0;
    assume $IsAlloc(##s#1_0_0_2, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_0_2 := f#0;
    assume $IsAlloc(##f#1_0_0_2, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    assume ($Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0)) && (!$Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s1#1_0, f#0)) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    ##s#1_0_0_3 := s#0;
    assume $IsAlloc(##s#1_0_0_3, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_0_3 := f#0;
    assume $IsAlloc(##f#1_0_0_3, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s#0, f#0);
    ##s#1_0_0_4 := s'#0;
    assume $IsAlloc(##s#1_0_0_4, TSeq(StandardLibrary._default.FilterIsDistributive$T), $Heap);
    ##f#1_0_0_4 := f#0;
    assume $IsAlloc(##f#1_0_0_4, Tclass._System.___hTotalFunc1(StandardLibrary._default.FilterIsDistributive$T, TBool), $Heap);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    assume StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s#0, f#0) && StandardLibrary.__default.Filter#canCall(StandardLibrary._default.FilterIsDistributive$T, s'#0, f#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append((if $Unbox(Apply1(StandardLibrary._default.FilterIsDistributive$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s1#1_0, f#0)), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s#0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LS($LZ)), s'#0, f#0)));
    assume false;
    goto anon42;

  anon60_Else:
    goto anon42;

  anon42:
    assume Seq#Equal(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LZ), S#1_0, f#0), Seq#Append(StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LZ), s#0, f#0), StandardLibrary.__default.Filter(StandardLibrary._default.FilterIsDistributive$T, $LS($LZ), s'#0, f#0)));
    return;
}



function StandardLibrary.__default.Min(a#0: int, b#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: { StandardLibrary.__default.Min(a#0, b#0) } StandardLibrary.__default.Min#canCall(a#0, b#0) || 0 < $FunctionContextHeight ==> StandardLibrary.__default.Min(a#0, b#0) == (if a#0 < b#0 then a#0 else b#0));
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: {:weight 3} { StandardLibrary.__default.Min(LitInt(a#0), LitInt(b#0)) } StandardLibrary.__default.Min#canCall(LitInt(a#0), LitInt(b#0)) || 0 < $FunctionContextHeight ==> StandardLibrary.__default.Min(LitInt(a#0), LitInt(b#0)) == (if a#0 < b#0 then a#0 else b#0));
}

function StandardLibrary.__default.Min#canCall(a#0: int, b#0: int) : bool;

function StandardLibrary.__default.Min#requires(int, int) : bool;

axiom (forall a#0: int, b#0: int :: { StandardLibrary.__default.Min#requires(a#0, b#0) } StandardLibrary.__default.Min#requires(a#0, b#0) <==> true);

procedure {:verboseName "StandardLibrary.Min (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Min(a#0: int, b#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || (0 < $FunctionContextHeight && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#0: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#0) } LitInt(0) <= i#0 && i#0 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#0) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { $IsAlloc(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T), $Heap) } (StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || (0 < $FunctionContextHeight && $IsBox(value#0, StandardLibrary._default.Fill$T) && $IsAllocBox(value#0, StandardLibrary._default.Fill$T, $Heap) && LitInt(0) <= n#0)) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: value#0), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $IsBox($l#0#_v0#0, TInt)), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#_v0#0: Box :: value#0), (lambda $l#2#heap#0: Heap, $l#2#_v0#0: Box :: $IsBox($l#2#_v0#0, TInt)), (lambda $l#2#heap#0: Heap, $l#2#_v0#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#_v0#0: Box :: Lit(value#0)), (lambda $l#4#heap#0: Heap, $l#4#_v0#0: Box :: $IsBox($l#4#_v0#0, TInt)), (lambda $l#4#heap#0: Heap, $l#4#_v0#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)))));
}

function StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int) : bool;

function StandardLibrary.__default.Fill#requires(Ty, Box, int) : bool;

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill#requires(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0 ==> (StandardLibrary.__default.Fill#requires(StandardLibrary._default.Fill$T, value#0, n#0) <==> true));

procedure {:verboseName "StandardLibrary.Fill (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T: Ty, value#0: Box where $IsBox(value#0, StandardLibrary._default.Fill$T), n#0: int where LitInt(0) <= n#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2188"} Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0;
  free ensures {:id "id2189"} (forall i#1: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#1) } LitInt(0) <= i#1 && i#1 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#1) == value#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.Fill (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##value#0: Box;
  var ##n#0: int;
  var i#2: int;
  var ##value#1: Box;
  var ##n#1: int;
  var $lambdaHeap#0: Heap;
  var _v0#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Box;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.Fill", " | ", StandardLibrary._default.Fill$T, " | ", value#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "int"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(155,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T));
    ##value#0 := value#0;
    assume $IsAllocBox(##value#0, StandardLibrary._default.Fill$T, $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume 0 <= n#0 || ##n#0 == n#0;
    assume (value#0 == value#0 && n#0 == n#0) || ##n#0 < n#0;
    assume (value#0 == value#0 && n#0 == n#0) || StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0);
    assume Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0;
    havoc i#2;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon5;

  anon15_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#2 && i#2 < n#0;
    ##value#1 := value#0;
    assume $IsAllocBox(##value#1, StandardLibrary._default.Fill$T, $Heap);
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, Tclass._System.nat(), $Heap);
    assume 0 <= n#0 || ##n#1 == n#0;
    assume (value#0 == value#0 && n#0 == n#0) || ##n#1 < n#0;
    assume (value#0 == value#0 && n#0 == n#0) || StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0);
    assume 0 <= i#2 && i#2 < Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0));
    assume Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#2) == value#0;
    goto anon7;

  anon14_Else:
    assume LitInt(0) <= i#2 && i#2 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#2) == value#0;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#1) } LitInt(0) <= i#1 && i#1 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#1) == value#0);
    assume false;
    return;

  anon13_Else:
    assume 0 <= n#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc _v0#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == value#0;
    assume true;
    assume $IsBox(lambdaResult#0, StandardLibrary._default.Fill$T);
    goto anon11;

  anon17_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    assume false;
    goto anon12;

  anon16_Else:
    goto anon12;

  anon12:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < n#0 ==> Requires1(TInt, StandardLibrary._default.Fill$T, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: value#0), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: $IsBox($l#6#_v0#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < n#0 ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, StandardLibrary._default.Fill$T, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: value#0), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: $IsBox($l#6#_v0#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#_v0#0: Box :: value#0), (lambda $l#8#heap#0: Heap, $l#8#_v0#0: Box :: $IsBox($l#8#_v0#0, TInt)), (lambda $l#8#heap#0: Heap, $l#8#_v0#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T));
    assume b$reqreads#0;
    return;
}



procedure {:verboseName "StandardLibrary.SeqToArray (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqToArray$T), $Heap)) returns (a#0: ref where $Is(a#0, Tclass._System.array(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(a#0, Tclass._System.array(StandardLibrary._default.SeqToArray$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SeqToArray (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq) returns (a#0: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqToArray", " | ", StandardLibrary._default.SeqToArray$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(162,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc a#0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(164,12): post-state"} true;
    assume a#0 != null && !$Unbox(read(old($Heap), a#0, alloc)): bool;
    assume a#0 != null;
    assume _System.array.Length(a#0) == Seq#Length(s#0);
    havoc i#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon8_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    assume a#0 != null;
    assume 0 <= i#0 && i#0 < _System.array.Length(a#0);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume read($Heap, a#0, IndexField(i#0)) == Seq#Index(s#0, i#0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> read($Heap, a#0, IndexField(i#0)) == Seq#Index(s#0, i#0);
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(s#0, i#1) } { read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> read($Heap, a#0, IndexField(i#1)) == Seq#Index(s#0, i#1));
    return;
}



procedure {:verboseName "StandardLibrary.SeqToArray (call precondtion)"} CallPre$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqToArray$T), $Heap));



procedure {:verboseName "StandardLibrary.SeqToArray (call postcondition)"} CallPost$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqToArray$T), $Heap)) returns (a#0: ref where $Is(a#0, Tclass._System.array(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(a#0, Tclass._System.array(StandardLibrary._default.SeqToArray$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2215"} a#0 != null && !$Unbox(read(old($Heap), a#0, alloc)): bool;
  free ensures true;
  free ensures {:id "id2216"} _System.array.Length(a#0) == Seq#Length(s#0);
  free ensures true;
  free ensures {:id "id2217"} (forall i#1: int :: { Seq#Index(s#0, i#1) } { read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> read($Heap, a#0, IndexField(i#1)) == Seq#Index(s#0, i#1));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "StandardLibrary.SeqToArray (correctness)"} Impl$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqToArray$T), $Heap)) returns (defass#a#0: bool, a#0: ref where defass#a#0 ==> $Is(a#0, Tclass._System.array(StandardLibrary._default.SeqToArray$T)) && $IsAlloc(a#0, Tclass._System.array(StandardLibrary._default.SeqToArray$T), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2218"} a#0 != null && !$Unbox(read(old($Heap), a#0, alloc)): bool;
  free ensures true;
  free ensures {:id "id2219"} _System.array.Length(a#0) == Seq#Length(s#0);
  free ensures true;
  free ensures {:id "id2220"} (forall i#1: int :: { Seq#Index(s#0, i#1) } { read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> read($Heap, a#0, IndexField(i#1)) == Seq#Index(s#0, i#1));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SeqToArray (correctness)"} Impl$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq) returns (defass#a#0: bool, a#0: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var i#2: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Box;
  var $nw: ref;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqToArray", " | ", StandardLibrary._default.SeqToArray$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(167,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume 0 <= Seq#Length(s#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#2;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon4;

  anon10_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    assume lambdaResult#0 == Seq#Index(s#0, i#2);
    assume true;
    assume $IsBox(lambdaResult#0, StandardLibrary._default.SeqToArray$T);
    goto anon6;

  anon11_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(s#0));
    goto anon6;

  anon9_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon8_Else:
    goto anon7;

  anon7:
    havoc $nw;
    assume $nw != null && $Is($nw, Tclass._System.array?(StandardLibrary._default.SeqToArray$T));
    assume !$Unbox(read($Heap, $nw, alloc)): bool;
    assume _System.array.Length($nw) == Seq#Length(s#0);
    assume {:subsumption 0} (forall arrayinit#0#i0#0: int :: 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < Seq#Length(s#0) ==> Requires1(TInt, StandardLibrary._default.SeqToArray$T, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: Seq#Index(s#0, $Unbox($l#0#i#0): int)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(s#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    assume (forall arrayinit#0#i0#0: int :: { read($Heap, $nw, IndexField(arrayinit#0#i0#0)) } 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < Seq#Length(s#0) ==> read($Heap, $nw, IndexField(arrayinit#0#i0#0)) == Apply1(TInt, StandardLibrary._default.SeqToArray$T, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: Seq#Index(s#0, $Unbox($l#0#i#0): int)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(s#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    $Heap := update($Heap, $nw, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    a#0 := $nw;
    defass#a#0 := true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(168,52)"} true;
    assume defass#a#0;
    return;
}



procedure {:verboseName "StandardLibrary.SeqPartsMakeWhole (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T), $Heap), i#0: int where LitInt(0) <= i#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SeqPartsMakeWhole (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq, i#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqPartsMakeWhole", " | ", StandardLibrary._default.SeqPartsMakeWhole$T, " | ", s#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(171,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon3;

  anon4_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(173,28): post-state"} true;
    assume 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume Seq#Equal(Seq#Append(Seq#Take(s#0, i#0), Seq#Drop(s#0, i#0)), s#0);
    return;
}



procedure {:verboseName "StandardLibrary.SeqPartsMakeWhole (call precondtion)"} CallPre$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T), $Heap), i#0: int where LitInt(0) <= i#0);
  requires {:id "id2231"} LitInt(0) <= i#0;
  requires {:id "id2232"} i#0 <= Seq#Length(s#0);



procedure {:verboseName "StandardLibrary.SeqPartsMakeWhole (call postcondition)"} CallPost$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T), $Heap), i#0: int where LitInt(0) <= i#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2233"} Seq#Equal(Seq#Append(Seq#Take(s#0, i#0), Seq#Drop(s#0, i#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.SeqPartsMakeWhole (correctness)"} Impl$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq where $Is(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SeqPartsMakeWhole$T), $Heap), i#0: int where LitInt(0) <= i#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id2234"} LitInt(0) <= i#0;
  requires {:id "id2235"} i#0 <= Seq#Length(s#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2236"} Seq#Equal(Seq#Append(Seq#Take(s#0, i#0), Seq#Drop(s#0, i#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SeqPartsMakeWhole (correctness)"} Impl$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq, i#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqPartsMakeWhole", " | ", StandardLibrary._default.SeqPartsMakeWhole$T, " | ", s#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(174,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#0) } LitInt(0) <= k#0 ==> k#0 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#0)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#0) } LitInt(0) <= k#0 && k#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#0))));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#1: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#1) } LitInt(0) <= k#1 ==> k#1 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#1)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#1: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#1) } LitInt(0) <= k#1 && k#1 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#1))));
axiom 1 <= $FunctionContextHeight ==> (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#2: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#2) } LitInt(0) <= k#2 ==> k#2 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#2)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#2: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#2) } LitInt(0) <= k#2 && k#2 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#2))));
}

function StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType) : bool;

function StandardLibrary.__default.LexicographicLessOrEqual#requires(Ty, Seq, Seq, HandleType) : bool;

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual#requires(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool)) ==> (StandardLibrary.__default.LexicographicLessOrEqual#requires(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> true));

procedure {:verboseName "StandardLibrary.LexicographicLessOrEqual (well-formedness)"} CheckWellformed$$StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.LexicographicLessOrEqual (well-formedness)"} CheckWellformed$$StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#3: int;
  var ##a#0: Seq;
  var ##b#0: Seq;
  var ##less#0: HandleType;
  var ##lengthOfCommonPrefix#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.LexicographicLessOrEqual", " | ", StandardLibrary._default.LexicographicLessOrEqual$T, " | ", a#0, " | ", b#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(191,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    havoc k#3;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= k#3;
    goto anon6;

  anon11_Else:
    assume {:partition} k#3 < LitInt(0);
    goto anon6;

  anon6:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= k#3 && k#3 <= Seq#Length(a#0);
    ##a#0 := a#0;
    assume $IsAlloc(##a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T), $Heap);
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T), $Heap);
    ##less#0 := less#0;
    assume $IsAlloc(##less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool), $Heap);
    assume $Is(k#3, Tclass._System.nat());
    ##lengthOfCommonPrefix#0 := k#3;
    assume $IsAlloc(##lengthOfCommonPrefix#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#0 <= Seq#Length(##a#0);
    assume LitInt(0) <= ##lengthOfCommonPrefix#0 && ##lengthOfCommonPrefix#0 <= Seq#Length(##a#0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#3);
    goto anon8;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= k#3 && k#3 <= Seq#Length(a#0));
    goto anon8;

  anon10_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#4: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#4) } LitInt(0) <= k#4 && k#4 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#4));
    assume (forall k#4: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#4) } LitInt(0) <= k#4 && k#4 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#4));
    assume $Is(StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0), TBool);
    return;
}



function StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#0: int :: { Seq#Index(b#0, i#0) } { Seq#Index(a#0, i#0) } LitInt(0) <= i#0 && i#0 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#0) == Seq#Index(b#0, i#0)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#1: int :: { Seq#Index(b#0, i#1) } { Seq#Index(a#0, i#1) } LitInt(0) <= i#1 && i#1 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#1) == Seq#Index(Lit(b#0), i#1)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#2: int :: { Seq#Index(b#0, i#2) } { Seq#Index(a#0, i#2) } LitInt(0) <= i#2 && i#2 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#2) == Seq#Index(Lit(b#0), i#2)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));
}

function StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int) : bool;

function StandardLibrary.__default.LexicographicLessOrEqualAux#requires(Ty, Seq, Seq, HandleType, int) : bool;

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux#requires(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 ==> (StandardLibrary.__default.LexicographicLessOrEqualAux#requires(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)));

procedure {:verboseName "StandardLibrary.LexicographicLessOrEqualAux (well-formedness)"} CheckWellformed$$StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)), lengthOfCommonPrefix#0: int where LitInt(0) <= lengthOfCommonPrefix#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.LexicographicLessOrEqualAux (well-formedness)"} CheckWellformed$$StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.LexicographicLessOrEqualAux", " | ", StandardLibrary._default.LexicographicLessOrEqualAux$T, " | ", a#0, " | ", b#0, " | ", less#0, " | ", lengthOfCommonPrefix#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(195,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= lengthOfCommonPrefix#0;
    goto anon3;

  anon17_Else:
    assume {:partition} lengthOfCommonPrefix#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume false;
    return;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} lengthOfCommonPrefix#0 <= Seq#Length(b#0);
    havoc i#3;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon9;

  anon21_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon9;

  anon9:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= i#3 && i#3 < lengthOfCommonPrefix#0;
    assume 0 <= i#3 && i#3 < Seq#Length(a#0);
    assume 0 <= i#3 && i#3 < Seq#Length(b#0);
    goto anon11;

  anon22_Else:
    assume {:partition} !(LitInt(0) <= i#3 && i#3 < lengthOfCommonPrefix#0);
    goto anon11;

  anon20_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    goto anon12;

  anon19_Else:
    assume {:partition} Seq#Length(b#0) < lengthOfCommonPrefix#0;
    goto anon12;

  anon12:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#4: int :: { Seq#Index(b#0, i#4) } { Seq#Index(a#0, i#4) } LitInt(0) <= i#4 && i#4 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#4) == Seq#Index(b#0, i#4));
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} lengthOfCommonPrefix#0 != Seq#Length(a#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} lengthOfCommonPrefix#0 < Seq#Length(b#0);
    assume 0 <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 < Seq#Length(a#0);
    assume 0 <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 < Seq#Length(b#0);
    goto anon16;

  anon25_Else:
    assume {:partition} Seq#Length(b#0) <= lengthOfCommonPrefix#0;
    goto anon16;

  anon24_Else:
    assume {:partition} lengthOfCommonPrefix#0 == Seq#Length(a#0);
    goto anon16;

  anon23_Else:
    assume {:partition} !(lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#4: int :: { Seq#Index(b#0, i#4) } { Seq#Index(a#0, i#4) } LitInt(0) <= i#4 && i#4 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#4) == Seq#Index(b#0, i#4)));
    goto anon16;

  anon16:
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#4: int :: { Seq#Index(b#0, i#4) } { Seq#Index(a#0, i#4) } LitInt(0) <= i#4 && i#4 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#4) == Seq#Index(b#0, i#4)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool));
    assume true;
    assume $Is(StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), TBool);
    return;
}



function StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T: Ty, less#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.Trichotomous$T) && $IsBox(y#0, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#0, x#0)): bool) && (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.Trichotomous$T) && $IsBox(y#1, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#1, x#1)): bool ==> false) && (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.Trichotomous$T) && $IsBox(y#2, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#2, y#2)): bool ==> x#2 != y#2)));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#3: Box, y#3: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#3, x#3)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#3, y#3)): bool } $IsBox(x#3, StandardLibrary._default.Trichotomous$T) && $IsBox(y#3, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#3, y#3)): bool || x#3 == y#3 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#3, x#3)): bool) && (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#4, x#4)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#4, y#4)): bool } $IsBox(x#4, StandardLibrary._default.Trichotomous$T) && $IsBox(y#4, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#4, y#4)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#4, x#4)): bool ==> false) && (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.Trichotomous$T) && $IsBox(y#5, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#5, y#5)): bool ==> x#5 != y#5)));
}

function StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T: Ty, less#0: HandleType) : bool;

function StandardLibrary.__default.Trichotomous#requires(Ty, HandleType) : bool;

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous#requires(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool)) ==> (StandardLibrary.__default.Trichotomous#requires(StandardLibrary._default.Trichotomous$T, less#0) <==> true));

procedure {:verboseName "StandardLibrary.Trichotomous (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T: Ty where $AlwaysAllocated(StandardLibrary._default.Trichotomous$T), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#0: Box, y#0: Box, z#0: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#0, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#0, z#0)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#0, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.Transitive$T) && $IsBox(y#0, StandardLibrary._default.Transitive$T) && $IsBox(z#0, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#0, y#0)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#0, z#0)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#0, z#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box, z#1: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#1, z#1)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#1, z#1)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#1, z#1)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.Transitive$T) && $IsBox(y#1, StandardLibrary._default.Transitive$T) && $IsBox(z#1, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#1, z#1)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#1, z#1)): bool)));
}

function StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T: Ty, R#0: HandleType) : bool;

function StandardLibrary.__default.Transitive#requires(Ty, HandleType) : bool;

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive#requires(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool)) ==> (StandardLibrary.__default.Transitive#requires(StandardLibrary._default.Transitive$T, R#0) <==> true));

procedure {:verboseName "StandardLibrary.Transitive (well-formedness)"} CheckWellformed$$StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T: Ty where $AlwaysAllocated(StandardLibrary._default.Transitive$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibrary_mUInt.__default.UInt8Less#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $fh$0x#0, $fh$0x#1) } Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $fh$0x#0, $fh$0x#1) == $Box(StandardLibrary_mUInt.__default.UInt8Less($Unbox($fh$0x#0): int, $Unbox($fh$0x#1): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Requires2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $fh$0x#0, $fh$0x#1) } Requires2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $fh$0x#0, $fh$0x#1) <==> StandardLibrary_mUInt.__default.UInt8Less#requires($Unbox($fh$0x#0): int, $Unbox($fh$0x#1): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Reads2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $fh$0x#0, $fh$0x#1)[$bx] } Reads2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $fh$0x#0, $fh$0x#1)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: int, $fh$0x#1: int :: { StandardLibrary_mUInt.__default.UInt8Less($fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } StandardLibrary_mUInt.__default.UInt8Less($fh$0x#0, $fh$0x#1) <==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box($fh$0x#0), $Box($fh$0x#1))): bool);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##less#0: HandleType;
  var ##R#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt8LessIsTrichotomousTransitive"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(230,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(231,24): post-state"} true;
    assume true;
    ##less#0 := StandardLibrary_mUInt.__default.UInt8Less#Handle();
    assume $IsAlloc(##less#0, Tclass._System.___hTotalFunc2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
    assume StandardLibrary.__default.Trichotomous(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
    assume true;
    ##R#0 := StandardLibrary_mUInt.__default.UInt8Less#Handle();
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume StandardLibrary.__default.Transitive#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
    assume StandardLibrary.__default.Transitive(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
    return;
}



procedure {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (call precondtion)"} CallPre$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive();



procedure {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (call postcondition)"} CallPost$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive();
  modifies $Heap;
  free ensures StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
  free ensures {:id "id2253"} StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) && StandardLibrary.__default.Trichotomous(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) && (forall x#0: int, y#0: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#0), $Box(x#0))): bool } { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#0), $Box(y#0))): bool } LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#0 && y#0 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#0), $Box(y#0))): bool || x#0 == y#0 || $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#0), $Box(x#0))): bool) && (forall x#1: int, y#1: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#1), $Box(x#1))): bool } { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#1), $Box(y#1))): bool } LitInt(0) <= x#1 && x#1 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#1 && y#1 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#1), $Box(y#1))): bool && $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#1), $Box(x#1))): bool ==> false) && (forall x#2: int, y#2: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#2), $Box(y#2))): bool } LitInt(0) <= x#2 && x#2 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#2 && y#2 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#2), $Box(y#2))): bool ==> x#2 != y#2);
  free ensures StandardLibrary.__default.Transitive#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
  free ensures {:id "id2254"} StandardLibrary.__default.Transitive#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) && StandardLibrary.__default.Transitive(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) && (forall x#3: int, y#3: int, z#0: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#3), $Box(z#0))): bool, $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#3), $Box(z#0))): bool } { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#3), $Box(z#0))): bool, $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#3), $Box(y#3))): bool } LitInt(0) <= x#3 && x#3 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#3 && y#3 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= z#0 && z#0 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#3), $Box(y#3))): bool && $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#3), $Box(z#0))): bool ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#3), $Box(z#0))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (correctness)"} Impl$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
  free ensures {:id "id2255"} StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) ==> StandardLibrary.__default.Trichotomous(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) || (forall x#4: int, y#4: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#4), $Box(x#4))): bool } { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#4), $Box(y#4))): bool } LitInt(0) <= x#4 && x#4 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#4 && y#4 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#4), $Box(y#4))): bool || x#4 == y#4 || $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#4), $Box(x#4))): bool);
  free ensures {:id "id2256"} StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) ==> StandardLibrary.__default.Trichotomous(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) || (forall x#5: int, y#5: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#5), $Box(x#5))): bool } { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#5), $Box(y#5))): bool } LitInt(0) <= x#5 && x#5 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#5 && y#5 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#5), $Box(y#5))): bool && $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#5), $Box(x#5))): bool ==> false);
  free ensures {:id "id2257"} StandardLibrary.__default.Trichotomous#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) ==> StandardLibrary.__default.Trichotomous(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) || (forall x#6: int, y#6: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#6), $Box(y#6))): bool } LitInt(0) <= x#6 && x#6 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#6 && y#6 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#6), $Box(y#6))): bool ==> x#6 != y#6);
  free ensures StandardLibrary.__default.Transitive#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle());
  free ensures {:id "id2258"} StandardLibrary.__default.Transitive#canCall(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) ==> StandardLibrary.__default.Transitive(Tclass.BoundedInts.uint8(), StandardLibrary_mUInt.__default.UInt8Less#Handle()) || (forall x#7: int, y#7: int, z#1: int :: { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#7), $Box(z#1))): bool, $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#7), $Box(z#1))): bool } { $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#7), $Box(z#1))): bool, $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#7), $Box(y#7))): bool } LitInt(0) <= x#7 && x#7 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= y#7 && y#7 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= z#1 && z#1 < BoundedInts.__default.TWO__TO__THE__8() ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#7), $Box(y#7))): bool && $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(y#7), $Box(z#1))): bool ==> $Unbox(Apply2(Tclass.BoundedInts.uint8(), Tclass.BoundedInts.uint8(), TBool, $Heap, StandardLibrary_mUInt.__default.UInt8Less#Handle(), $Box(x#7), $Box(z#1))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (correctness)"} Impl$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt8LessIsTrichotomousTransitive"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(233,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "StandardLibrary.LexIsReflexive (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.LexIsReflexive (call precondtion)"} CallPre$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool), $Heap));



procedure {:verboseName "StandardLibrary.LexIsReflexive (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0);
  free ensures {:id "id2260"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0) && StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0) && (exists k#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, k#0) } LitInt(0) <= k#0 && k#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, k#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.LexIsReflexive (correctness)"} Impl$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsReflexive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0);
  free ensures {:id "id2261"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0) || (exists k#1: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, k#1) } LitInt(0) <= k#1 && k#1 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, k#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.LexIsReflexive (correctness)"} Impl$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T: Ty, a#0: Seq, less#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##a#1: Seq;
  var ##b#1: Seq;
  var ##less#1: HandleType;
  var ##lengthOfCommonPrefix#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsReflexive", " | ", StandardLibrary._default.LexIsReflexive$T, " | ", a#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(243,2): initial state"} true;
    $_reverifyPost := false;
    ##a#1 := a#0;
    assume $IsAlloc(##a#1, TSeq(StandardLibrary._default.LexIsReflexive$T), $Heap);
    ##b#1 := a#0;
    assume $IsAlloc(##b#1, TSeq(StandardLibrary._default.LexIsReflexive$T), $Heap);
    ##less#1 := less#0;
    assume $IsAlloc(##less#1, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool), $Heap);
    assume $Is(Seq#Length(a#0), Tclass._System.nat());
    ##lengthOfCommonPrefix#0 := Seq#Length(a#0);
    assume $IsAlloc(##lengthOfCommonPrefix#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#0 <= Seq#Length(##a#1);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0));
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0)) || Seq#Length(a#0) <= Seq#Length(a#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0)) || (forall i#0: int :: { Seq#Index(a#0, i#0) } { Seq#Index(a#0, i#0) } LitInt(0) <= i#0 && i#0 < Seq#Length(a#0) ==> Seq#Index(a#0, i#0) == Seq#Index(a#0, i#0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0)) || Seq#Length(a#0) == Seq#Length(a#0) || (Seq#Length(a#0) < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsReflexive$T, StandardLibrary._default.LexIsReflexive$T, TBool, $Heap, less#0, Seq#Index(a#0, Seq#Length(a#0)), Seq#Index(a#0, Seq#Length(a#0)))): bool);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsReflexive$T, a#0, a#0, less#0, Seq#Length(a#0));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(244,55)"} true;
    return;
}



procedure {:verboseName "StandardLibrary.LexIsAntisymmetric (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsAntisymmetric$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.LexIsAntisymmetric (call precondtion)"} CallPre$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsAntisymmetric$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool), $Heap));
  requires {:id "id2273"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.LexIsAntisymmetric$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsAntisymmetric$T, less#0) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#0, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#0, x#0)): bool);
  requires {:id "id2274"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.LexIsAntisymmetric$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsAntisymmetric$T, less#0) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#1, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#1, x#1)): bool ==> false);
  requires {:id "id2275"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.LexIsAntisymmetric$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsAntisymmetric$T, less#0) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#2, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#2, y#2)): bool ==> x#2 != y#2);
  requires {:id "id2276"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0) || (exists k#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k#0) } LitInt(0) <= k#0 && k#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k#0));
  requires {:id "id2277"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0) || (exists k#1: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k#1) } LitInt(0) <= k#1 && k#1 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k#1));



procedure {:verboseName "StandardLibrary.LexIsAntisymmetric (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsAntisymmetric$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2278"} Seq#Equal(a#0, b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.LexIsAntisymmetric (correctness)"} Impl$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsAntisymmetric$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id2279"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0) && StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0) && (exists k#2: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k#2) } LitInt(0) <= k#2 && k#2 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k#2));
  free requires {:id "id2280"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0) && StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0) && (exists k#3: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k#3) } LitInt(0) <= k#3 && k#3 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k#3));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2281"} Seq#Equal(a#0, b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.LexIsAntisymmetric (correctness)"} Impl$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#3: Box;
  var y#3: Box;
  var $Heap_at_0: Heap;
  var x#6: Box;
  var y#6: Box;
  var $Heap_at_1: Heap;
  var defass#k0#0: bool;
  var k0#0: int;
  var k0#1: int;
  var ##a#2: Seq;
  var ##b#2: Seq;
  var ##less#3: HandleType;
  var ##lengthOfCommonPrefix#0: int;
  var defass#k1#0: bool;
  var k1#0: int;
  var k1#1: int;
  var ##a#3: Seq;
  var ##b#3: Seq;
  var ##less#4: HandleType;
  var ##lengthOfCommonPrefix#1: int;
  var max#0: int;
  var i#0: int;
  var $Heap_at_2: Heap;
  var ##$Heap_at_2#max#0: int;
  var $Heap_at_3: Heap;
  var ##$Heap_at_3#k0#0: int;
  var $Heap_at_4: Heap;
  var ##$Heap_at_4#k1#0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsAntisymmetric", " | ", StandardLibrary._default.LexIsAntisymmetric$T, " | ", a#0, " | ", b#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(252,2): initial state"} true;
    $_reverifyPost := false;
    havoc x#3;
    havoc y#3;
    goto anon167_Then, anon167_Else;

  anon167_Then:
    assume {:partition} $IsBox(x#3, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(x#3, StandardLibrary._default.LexIsAntisymmetric$T, $Heap) && $IsBox(y#3, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(y#3, StandardLibrary._default.LexIsAntisymmetric$T, $Heap);
    goto anon168_Then, anon168_Else;

  anon168_Then:
    assume {:partition} $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#3, y#3)): bool;
    goto anon3;

  anon168_Else:
    assume {:partition} !$Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#3, y#3)): bool;
    goto anon3;

  anon167_Else:
    assume {:partition} !($IsBox(x#3, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(x#3, StandardLibrary._default.LexIsAntisymmetric$T, $Heap) && $IsBox(y#3, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(y#3, StandardLibrary._default.LexIsAntisymmetric$T, $Heap));
    goto anon3;

  anon3:
    assume true;
    goto anon169_Then, anon169_Else;

  anon169_Then:
    push;
    assume StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsAntisymmetric$T, less#0);
    pop;
    assume (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#4, y#4)): bool } $IsBox(x#4, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#4, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#4, y#4)): bool ==> x#4 != y#4);
    assume false;
    goto anon5;

  anon169_Else:
    goto anon5;

  anon5:
    $Heap_at_0 := $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(255,4)"} true;
    havoc x#6;
    havoc y#6;
    goto anon170_Then, anon170_Else;

  anon170_Then:
    assume {:partition} $IsBox(x#6, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(x#6, StandardLibrary._default.LexIsAntisymmetric$T, $Heap) && $IsBox(y#6, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(y#6, StandardLibrary._default.LexIsAntisymmetric$T, $Heap);
    goto anon171_Then, anon171_Else;

  anon171_Then:
    assume {:partition} $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#6, y#6)): bool;
    goto anon8;

  anon171_Else:
    assume {:partition} !$Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#6, y#6)): bool;
    goto anon8;

  anon8:
    goto anon172_Then, anon172_Else;

  anon172_Then:
    assume {:partition} $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#6, y#6)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#6, x#6)): bool;
    goto anon10;

  anon172_Else:
    assume {:partition} !($Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#6, y#6)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#6, x#6)): bool);
    goto anon10;

  anon170_Else:
    assume {:partition} !($IsBox(x#6, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(x#6, StandardLibrary._default.LexIsAntisymmetric$T, $Heap) && $IsBox(y#6, StandardLibrary._default.LexIsAntisymmetric$T) && $IsAllocBox(y#6, StandardLibrary._default.LexIsAntisymmetric$T, $Heap));
    goto anon10;

  anon10:
    assume true;
    goto anon173_Then, anon173_Else;

  anon173_Then:
    push;
    assume StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsAntisymmetric$T, less#0);
    pop;
    assume (forall x#7: Box, y#7: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#7, x#7)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#7, y#7)): bool } $IsBox(x#7, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#7, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, x#7, y#7)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, y#7, x#7)): bool ==> false);
    assume false;
    goto anon12;

  anon173_Else:
    goto anon12;

  anon12:
    $Heap_at_1 := $Heap;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(258,4)"} true;
    havoc k0#1;
    goto anon174_Then, anon174_Else;

  anon174_Then:
    assume {:partition} true;
    goto anon175_Then, anon175_Else;

  anon175_Then:
    assume {:partition} LitInt(0) <= k0#1;
    goto anon15;

  anon175_Else:
    assume {:partition} k0#1 < LitInt(0);
    goto anon15;

  anon15:
    goto anon176_Then, anon176_Else;

  anon176_Then:
    assume {:partition} LitInt(0) <= k0#1 && k0#1 <= Seq#Length(a#0);
    ##a#2 := a#0;
    assume $IsAlloc(##a#2, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap);
    ##less#3 := less#0;
    assume $IsAlloc(##less#3, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool), $Heap);
    assume $Is(k0#1, Tclass._System.nat());
    ##lengthOfCommonPrefix#0 := k0#1;
    assume $IsAlloc(##lengthOfCommonPrefix#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#0 <= Seq#Length(##a#2);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k0#1);
    goto anon17;

  anon176_Else:
    assume {:partition} !(LitInt(0) <= k0#1 && k0#1 <= Seq#Length(a#0));
    goto anon17;

  anon17:
    assume LitInt(0) <= k0#1 ==> k0#1 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k0#1);
    goto anon18;

  anon174_Else:
    assume {:partition} false;
    goto anon18;

  anon18:
    assume ($Is(Seq#Length(a#0) + 1 - 1, TInt) && LitInt(0) <= Seq#Length(a#0) + 1 - 1 && Seq#Length(a#0) + 1 - 1 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, Seq#Length(a#0) + 1 - 1)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, LitInt(0))) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, LitInt(0))) || (exists $as#k00#0: int :: LitInt(0) <= $as#k00#0 && $as#k00#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, $as#k00#0));
    defass#k0#0 := true;
    havoc k0#0;
    assume LitInt(0) <= k0#0 && k0#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0, k0#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(259,75)"} true;
    havoc k1#1;
    goto anon177_Then, anon177_Else;

  anon177_Then:
    assume {:partition} true;
    goto anon178_Then, anon178_Else;

  anon178_Then:
    assume {:partition} LitInt(0) <= k1#1;
    goto anon21;

  anon178_Else:
    assume {:partition} k1#1 < LitInt(0);
    goto anon21;

  anon21:
    goto anon179_Then, anon179_Else;

  anon179_Then:
    assume {:partition} LitInt(0) <= k1#1 && k1#1 <= Seq#Length(b#0);
    ##a#3 := b#0;
    assume $IsAlloc(##a#3, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap);
    ##b#3 := a#0;
    assume $IsAlloc(##b#3, TSeq(StandardLibrary._default.LexIsAntisymmetric$T), $Heap);
    ##less#4 := less#0;
    assume $IsAlloc(##less#4, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool), $Heap);
    assume $Is(k1#1, Tclass._System.nat());
    ##lengthOfCommonPrefix#1 := k1#1;
    assume $IsAlloc(##lengthOfCommonPrefix#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#1;
    assume {:subsumption 0} ##lengthOfCommonPrefix#1 <= Seq#Length(##a#3);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k1#1);
    goto anon23;

  anon179_Else:
    assume {:partition} !(LitInt(0) <= k1#1 && k1#1 <= Seq#Length(b#0));
    goto anon23;

  anon23:
    assume LitInt(0) <= k1#1 ==> k1#1 <= Seq#Length(b#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k1#1);
    goto anon24;

  anon177_Else:
    assume {:partition} false;
    goto anon24;

  anon24:
    assume ($Is(Seq#Length(b#0) + 1 - 1, TInt) && LitInt(0) <= Seq#Length(b#0) + 1 - 1 && Seq#Length(b#0) + 1 - 1 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, Seq#Length(b#0) + 1 - 1)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, LitInt(0))) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, LitInt(0))) || (exists $as#k10#0: int :: LitInt(0) <= $as#k10#0 && $as#k10#0 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, $as#k10#0));
    defass#k1#0 := true;
    havoc k1#0;
    assume LitInt(0) <= k1#0 && k1#0 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsAntisymmetric$T, b#0, a#0, less#0, k1#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(260,75)"} true;
    assume true;
    assume defass#k0#0;
    assume defass#k1#0;
    goto anon180_Then, anon180_Else;

  anon180_Then:
    assume {:partition} k0#0 < k1#0;
    assume defass#k1#0;
    goto anon27;

  anon180_Else:
    assume {:partition} k1#0 <= k0#0;
    assume defass#k0#0;
    goto anon27;

  anon27:
    assume true;
    max#0 := (if k0#0 < k1#0 then k1#0 else k0#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(261,41)"} true;
    goto anon181_Then, anon181_Else;

  anon181_Then:
    assume {:partition} max#0 <= Seq#Length(a#0);
    goto anon29;

  anon181_Else:
    assume {:partition} Seq#Length(a#0) < max#0;
    goto anon29;

  anon29:
    assume true;
    assume {:subsumption 0} max#0 <= Seq#Length(a#0);
    assume {:subsumption 0} max#0 <= Seq#Length(b#0);
    assume max#0 <= Seq#Length(a#0) && max#0 <= Seq#Length(b#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(262,35)"} true;
    havoc i#0;
    goto anon182_Then, anon182_Else;

  anon182_Then:
    assume {:partition} true;
    goto anon183_Then, anon183_Else;

  anon183_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon32;

  anon183_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon32;

  anon32:
    goto anon184_Then, anon184_Else;

  anon184_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < max#0;
    assume {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(a#0);
    assume {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(b#0);
    goto anon34;

  anon184_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < max#0);
    goto anon34;

  anon182_Else:
    assume {:partition} false;
    goto anon34;

  anon34:
    assume true;
    goto anon185_Then, anon185_Else;

  anon185_Then:
    assume (forall i#1: int :: { Seq#Index(b#0, i#1) } { Seq#Index(a#0, i#1) } LitInt(0) <= i#1 && i#1 < max#0 ==> Seq#Index(a#0, i#1) == Seq#Index(b#0, i#1));
    assume false;
    goto anon36;

  anon185_Else:
    goto anon36;

  anon36:
    $Heap_at_2 := $Heap;
    ##$Heap_at_2#max#0 := max#0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(263,66)"} true;
    assume defass#k0#0;
    goto anon186_Then, anon186_Else;

  anon186_Then:
    assume {:partition} k0#0 != Seq#Length(a#0);
    assume defass#k0#0;
    goto anon187_Then, anon187_Else;

  anon187_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon39;

  anon187_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon39;

  anon186_Else:
    assume {:partition} k0#0 == Seq#Length(a#0);
    goto anon39;

  anon39:
    assume true;
    goto anon188_Then, anon188_Else;

  anon188_Then:
    assume k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    assume false;
    goto anon41;

  anon188_Else:
    goto anon41;

  anon41:
    $Heap_at_3 := $Heap;
    ##$Heap_at_3#k0#0 := k0#0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(264,60)"} true;
    assume defass#k1#0;
    goto anon189_Then, anon189_Else;

  anon189_Then:
    assume {:partition} k1#0 != Seq#Length(b#0);
    assume defass#k1#0;
    goto anon190_Then, anon190_Else;

  anon190_Then:
    assume {:partition} k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon44;

  anon190_Else:
    assume {:partition} Seq#Length(a#0) <= k1#0;
    goto anon44;

  anon189_Else:
    assume {:partition} k1#0 == Seq#Length(b#0);
    goto anon44;

  anon44:
    assume true;
    goto anon191_Then, anon191_Else;

  anon191_Then:
    assume k1#0 == Seq#Length(b#0) || (k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    assume false;
    goto anon46;

  anon191_Else:
    goto anon46;

  anon46:
    $Heap_at_4 := $Heap;
    ##$Heap_at_4#k1#0 := k1#0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(265,60)"} true;
    goto anon192_Then, anon192_Else;

  anon192_Then:
    assume true;
    assume false;
    goto anon166;

  anon192_Else:
    goto anon193_Then, anon193_Else;

  anon193_Then:
    assume true;
    assume true;
    assume ##$Heap_at_3#k0#0 == Seq#Length(a#0) || (##$Heap_at_3#k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_3, less#0, Seq#Index(a#0, ##$Heap_at_3#k0#0), Seq#Index(b#0, ##$Heap_at_3#k0#0))): bool);
    assume ##$Heap_at_4#k1#0 == Seq#Length(b#0) || (##$Heap_at_4#k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_4, less#0, Seq#Index(b#0, ##$Heap_at_4#k1#0), Seq#Index(a#0, ##$Heap_at_4#k1#0))): bool);
    assume defass#k0#0;
    goto anon194_Then, anon194_Else;

  anon194_Then:
    assume {:partition} k0#0 != Seq#Length(a#0);
    assume defass#k0#0;
    goto anon195_Then, anon195_Else;

  anon195_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon51;

  anon195_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon51;

  anon194_Else:
    assume {:partition} k0#0 == Seq#Length(a#0);
    goto anon51;

  anon51:
    goto anon196_Then, anon196_Else;

  anon196_Then:
    assume {:partition} k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    assume defass#k1#0;
    goto anon197_Then, anon197_Else;

  anon197_Then:
    assume {:partition} k1#0 != Seq#Length(b#0);
    assume defass#k1#0;
    goto anon198_Then, anon198_Else;

  anon198_Then:
    assume {:partition} k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon55;

  anon198_Else:
    assume {:partition} Seq#Length(a#0) <= k1#0;
    goto anon55;

  anon197_Else:
    assume {:partition} k1#0 == Seq#Length(b#0);
    goto anon55;

  anon196_Else:
    assume {:partition} !(k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool));
    goto anon55;

  anon55:
    assume true;
    assume {:subsumption 0} Lit(true) ==> k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    assume {:subsumption 0} Lit(true) ==> k1#0 == Seq#Length(b#0) || (k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    assume false;
    goto anon166;

  anon193_Else:
    goto anon199_Then, anon199_Else;

  anon199_Then:
    assume defass#k0#0;
    goto anon200_Then, anon200_Else;

  anon200_Then:
    assume {:partition} k0#0 != Seq#Length(a#0);
    assume defass#k0#0;
    goto anon201_Then, anon201_Else;

  anon201_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon59;

  anon201_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon59;

  anon200_Else:
    assume {:partition} k0#0 == Seq#Length(a#0);
    goto anon59;

  anon59:
    goto anon202_Then, anon202_Else;

  anon202_Then:
    assume {:partition} k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    assume defass#k1#0;
    goto anon203_Then, anon203_Else;

  anon203_Then:
    assume {:partition} k1#0 != Seq#Length(b#0);
    assume defass#k1#0;
    goto anon204_Then, anon204_Else;

  anon204_Then:
    assume {:partition} k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon63;

  anon204_Else:
    assume {:partition} Seq#Length(a#0) <= k1#0;
    goto anon63;

  anon203_Else:
    assume {:partition} k1#0 == Seq#Length(b#0);
    goto anon63;

  anon202_Else:
    assume {:partition} !(k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool));
    goto anon63;

  anon63:
    assume true;
    assume defass#k0#0;
    goto anon205_Then, anon205_Else;

  anon205_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon65;

  anon205_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon65;

  anon65:
    goto anon206_Then, anon206_Else;

  anon206_Then:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0));
    assume defass#k0#0;
    goto anon207_Then, anon207_Else;

  anon207_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon68;

  anon207_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon68;

  anon68:
    goto anon208_Then, anon208_Else;

  anon208_Then:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon70;

  anon208_Else:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0));
    goto anon70;

  anon206_Else:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    goto anon70;

  anon70:
    goto anon209_Then, anon209_Else;

  anon209_Then:
    assume {:partition} !((k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool));
    assume defass#k0#0;
    goto anon210_Then, anon210_Else;

  anon210_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon73;

  anon210_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon73;

  anon73:
    goto anon211_Then, anon211_Else;

  anon211_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon75;

  anon211_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon75;

  anon209_Else:
    assume {:partition} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    goto anon75;

  anon75:
    goto anon212_Then, anon212_Else;

  anon212_Then:
    assume {:partition} !((k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 == Seq#Length(b#0)));
    assume defass#k0#0;
    goto anon213_Then, anon213_Else;

  anon213_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon78;

  anon213_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon78;

  anon78:
    goto anon214_Then, anon214_Else;

  anon214_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon80;

  anon214_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon80;

  anon80:
    goto anon215_Then, anon215_Else;

  anon215_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon82;

  anon215_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0));
    goto anon82;

  anon212_Else:
    assume {:partition} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 == Seq#Length(b#0));
    goto anon82;

  anon82:
    assume true;
    assume {:subsumption 0} (k0#0 == Seq#Length(a#0) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool)) && (k1#0 == Seq#Length(b#0) || (k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool)) <==> (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    assume false;
    goto anon166;

  anon199_Else:
    goto anon216_Then, anon216_Else;

  anon216_Then:
    assume defass#k0#0;
    goto anon217_Then, anon217_Else;

  anon217_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon85;

  anon217_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon85;

  anon85:
    goto anon218_Then, anon218_Else;

  anon218_Then:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0));
    assume defass#k0#0;
    goto anon219_Then, anon219_Else;

  anon219_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon88;

  anon219_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon88;

  anon88:
    goto anon220_Then, anon220_Else;

  anon220_Then:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon90;

  anon220_Else:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0));
    goto anon90;

  anon218_Else:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    goto anon90;

  anon90:
    goto anon221_Then, anon221_Else;

  anon221_Then:
    assume {:partition} !((k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool));
    assume defass#k0#0;
    goto anon222_Then, anon222_Else;

  anon222_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon93;

  anon222_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon93;

  anon93:
    goto anon223_Then, anon223_Else;

  anon223_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon95;

  anon223_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon95;

  anon221_Else:
    assume {:partition} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    goto anon95;

  anon95:
    goto anon224_Then, anon224_Else;

  anon224_Then:
    assume {:partition} !((k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 == Seq#Length(b#0)));
    assume defass#k0#0;
    goto anon225_Then, anon225_Else;

  anon225_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon98;

  anon225_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon98;

  anon98:
    goto anon226_Then, anon226_Else;

  anon226_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon100;

  anon226_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon100;

  anon100:
    goto anon227_Then, anon227_Else;

  anon227_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon102;

  anon227_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0));
    goto anon102;

  anon224_Else:
    assume {:partition} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 == Seq#Length(b#0));
    goto anon102;

  anon102:
    assume true;
    assume (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_0, less#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#5, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_0, less#0, x#5, y#5)): bool ==> x#5 != y#5);
    assume (forall i#2: int :: { Seq#Index(b#0, i#2) } { Seq#Index(a#0, i#2) } LitInt(0) <= i#2 && i#2 < ##$Heap_at_2#max#0 ==> Seq#Index(a#0, i#2) == Seq#Index(b#0, i#2));
    assume defass#k0#0;
    goto anon228_Then, anon228_Else;

  anon228_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon104;

  anon228_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon104;

  anon104:
    goto anon229_Then, anon229_Else;

  anon229_Then:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0));
    assume defass#k0#0;
    goto anon230_Then, anon230_Else;

  anon230_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon107;

  anon230_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon107;

  anon107:
    goto anon231_Then, anon231_Else;

  anon231_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon109;

  anon231_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon109;

  anon109:
    goto anon232_Then, anon232_Else;

  anon232_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon111;

  anon232_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0));
    goto anon111;

  anon229_Else:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    goto anon111;

  anon111:
    assume true;
    assume {:subsumption 0} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 == Seq#Length(a#0) && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) <==> (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    assume false;
    goto anon166;

  anon216_Else:
    goto anon233_Then, anon233_Else;

  anon233_Then:
    assume defass#k0#0;
    goto anon234_Then, anon234_Else;

  anon234_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon114;

  anon234_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon114;

  anon114:
    goto anon235_Then, anon235_Else;

  anon235_Then:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0));
    assume defass#k0#0;
    goto anon236_Then, anon236_Else;

  anon236_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon117;

  anon236_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon117;

  anon117:
    goto anon237_Then, anon237_Else;

  anon237_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon119;

  anon237_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon119;

  anon119:
    goto anon238_Then, anon238_Else;

  anon238_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon121;

  anon238_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0));
    goto anon121;

  anon235_Else:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    goto anon121;

  anon121:
    assume true;
    assume (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    assume (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_0, less#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#5, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_0, less#0, x#5, y#5)): bool ==> x#5 != y#5);
    assume (forall i#2: int :: { Seq#Index(b#0, i#2) } { Seq#Index(a#0, i#2) } LitInt(0) <= i#2 && i#2 < ##$Heap_at_2#max#0 ==> Seq#Index(a#0, i#2) == Seq#Index(b#0, i#2));
    assume defass#k0#0;
    goto anon239_Then, anon239_Else;

  anon239_Then:
    assume {:partition} max#0 <= k0#0;
    assume defass#k1#0;
    goto anon123;

  anon239_Else:
    assume {:partition} k0#0 < max#0;
    goto anon123;

  anon123:
    assume true;
    assume {:subsumption 0} max#0 <= k0#0;
    assume {:subsumption 0} max#0 <= k1#0;
    assume max#0 <= k0#0 && max#0 <= k1#0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(278,78)"} true;
    assume defass#k0#0;
    goto anon240_Then, anon240_Else;

  anon240_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon125;

  anon240_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon125;

  anon125:
    goto anon241_Then, anon241_Else;

  anon241_Then:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0));
    assume defass#k0#0;
    goto anon242_Then, anon242_Else;

  anon242_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon128;

  anon242_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon128;

  anon128:
    goto anon243_Then, anon243_Else;

  anon243_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon130;

  anon243_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon130;

  anon130:
    goto anon244_Then, anon244_Else;

  anon244_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon132;

  anon244_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0));
    goto anon132;

  anon132:
    goto anon245_Then, anon245_Else;

  anon245_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool;
    assume defass#k0#0;
    assume defass#k1#0;
    goto anon246_Then, anon246_Else;

  anon246_Then:
    assume {:partition} k0#0 == k1#0;
    assume defass#k1#0;
    goto anon135;

  anon246_Else:
    assume {:partition} k0#0 != k1#0;
    goto anon135;

  anon245_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    goto anon135;

  anon241_Else:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    goto anon135;

  anon135:
    assume true;
    assume {:subsumption 0} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool) ==> (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool && k0#0 == k1#0 && k1#0 == max#0);
    assume false;
    goto anon166;

  anon233_Else:
    goto anon247_Then, anon247_Else;

  anon247_Then:
    assume defass#k0#0;
    goto anon248_Then, anon248_Else;

  anon248_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon138;

  anon248_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon138;

  anon138:
    goto anon249_Then, anon249_Else;

  anon249_Then:
    assume {:partition} !(k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0));
    assume defass#k0#0;
    goto anon250_Then, anon250_Else;

  anon250_Then:
    assume {:partition} k0#0 < Seq#Length(b#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(a#0);
    assume defass#k0#0;
    assume {:subsumption 0} 0 <= k0#0 && k0#0 < Seq#Length(b#0);
    goto anon141;

  anon250_Else:
    assume {:partition} Seq#Length(b#0) <= k0#0;
    goto anon141;

  anon141:
    goto anon251_Then, anon251_Else;

  anon251_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool;
    assume defass#k1#0;
    goto anon143;

  anon251_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool);
    goto anon143;

  anon143:
    goto anon252_Then, anon252_Else;

  anon252_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(b#0);
    assume defass#k1#0;
    assume {:subsumption 0} 0 <= k1#0 && k1#0 < Seq#Length(a#0);
    goto anon145;

  anon252_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0));
    goto anon145;

  anon145:
    goto anon253_Then, anon253_Else;

  anon253_Then:
    assume {:partition} k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool;
    assume defass#k0#0;
    assume defass#k1#0;
    goto anon254_Then, anon254_Else;

  anon254_Then:
    assume {:partition} k0#0 == k1#0;
    assume defass#k1#0;
    goto anon148;

  anon254_Else:
    assume {:partition} k0#0 != k1#0;
    goto anon148;

  anon253_Else:
    assume {:partition} !(k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool);
    goto anon148;

  anon249_Else:
    assume {:partition} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    goto anon148;

  anon148:
    assume true;
    assume (forall x#8: Box, y#8: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_1, less#0, y#8, x#8)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_1, less#0, x#8, y#8)): bool } $IsBox(x#8, StandardLibrary._default.LexIsAntisymmetric$T) && $IsBox(y#8, StandardLibrary._default.LexIsAntisymmetric$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_1, less#0, x#8, y#8)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap_at_1, less#0, y#8, x#8)): bool ==> false);
    assume defass#k0#0;
    goto anon255_Then, anon255_Else;

  anon255_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon150;

  anon255_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon150;

  anon150:
    assume true;
    assume {:subsumption 0} (k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0)) || (k0#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(a#0, k0#0), Seq#Index(b#0, k0#0))): bool && k1#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsAntisymmetric$T, StandardLibrary._default.LexIsAntisymmetric$T, TBool, $Heap, less#0, Seq#Index(b#0, k1#0), Seq#Index(a#0, k1#0))): bool && k0#0 == k1#0 && k1#0 == max#0) <==> k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    assume false;
    goto anon166;

  anon247_Else:
    goto anon256_Then, anon256_Else;

  anon256_Then:
    assume defass#k0#0;
    goto anon257_Then, anon257_Else;

  anon257_Then:
    assume {:partition} k0#0 == Seq#Length(a#0);
    assume defass#k1#0;
    goto anon153;

  anon257_Else:
    assume {:partition} k0#0 != Seq#Length(a#0);
    goto anon153;

  anon153:
    assume true;
    assume k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0);
    assume defass#k0#0;
    goto anon258_Then, anon258_Else;

  anon258_Then:
    assume {:partition} Seq#Length(a#0) == k0#0;
    assume defass#k0#0;
    goto anon155;

  anon258_Else:
    assume {:partition} Seq#Length(a#0) != k0#0;
    goto anon155;

  anon155:
    goto anon259_Then, anon259_Else;

  anon259_Then:
    assume {:partition} Seq#Length(a#0) == k0#0 && k0#0 <= max#0;
    assume defass#k1#0;
    goto anon260_Then, anon260_Else;

  anon260_Then:
    assume {:partition} Seq#Length(b#0) == k1#0;
    assume defass#k1#0;
    goto anon158;

  anon260_Else:
    assume {:partition} Seq#Length(b#0) != k1#0;
    goto anon158;

  anon259_Else:
    assume {:partition} !(Seq#Length(a#0) == k0#0 && k0#0 <= max#0);
    goto anon158;

  anon158:
    goto anon261_Then, anon261_Else;

  anon261_Then:
    assume {:partition} Seq#Length(a#0) == k0#0 && k0#0 <= max#0 && Seq#Length(b#0) == k1#0 && k1#0 <= max#0;
    assume defass#k0#0;
    assume defass#k1#0;
    goto anon160;

  anon261_Else:
    assume {:partition} !(Seq#Length(a#0) == k0#0 && k0#0 <= max#0 && Seq#Length(b#0) == k1#0 && k1#0 <= max#0);
    goto anon160;

  anon160:
    assume true;
    assume {:subsumption 0} Seq#Length(a#0) == k0#0 && k0#0 <= max#0 && Seq#Length(b#0) == k1#0 && k1#0 <= max#0 ==> k0#0 == k1#0;
    assume Seq#Length(a#0) == k0#0 && k0#0 <= max#0 && Seq#Length(b#0) == k1#0 && k1#0 <= max#0 ==> k0#0 == k1#0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(283,67)"} true;
    goto anon262_Then, anon262_Else;

  anon262_Then:
    assume {:partition} max#0 == Seq#Length(a#0);
    goto anon162;

  anon262_Else:
    assume {:partition} max#0 != Seq#Length(a#0);
    goto anon162;

  anon162:
    assume true;
    assume {:subsumption 0} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0) ==> max#0 == Seq#Length(a#0);
    assume {:subsumption 0} k0#0 == Seq#Length(a#0) && k1#0 == Seq#Length(b#0) ==> Seq#Length(a#0) == Seq#Length(b#0);
    assume false;
    goto anon166;

  anon256_Else:
    goto anon263_Then, anon263_Else;

  anon263_Then:
    goto anon264_Then, anon264_Else;

  anon264_Then:
    assume {:partition} max#0 == Seq#Length(a#0);
    goto anon165;

  anon264_Else:
    assume {:partition} max#0 != Seq#Length(a#0);
    goto anon165;

  anon165:
    assume true;
    assume max#0 == Seq#Length(a#0) && Seq#Length(a#0) == Seq#Length(b#0);
    assume (forall i#2: int :: { Seq#Index(b#0, i#2) } { Seq#Index(a#0, i#2) } LitInt(0) <= i#2 && i#2 < ##$Heap_at_2#max#0 ==> Seq#Index(a#0, i#2) == Seq#Index(b#0, i#2));
    assume true;
    assume {:subsumption 0} max#0 == Seq#Length(a#0) && Seq#Length(a#0) == Seq#Length(b#0) ==> Seq#Equal(a#0, b#0);
    assume false;
    goto anon166;

  anon263_Else:
    goto anon166;

  anon166:
    assume true ==> Seq#Equal(a#0, b#0);
    return;
}



procedure {:verboseName "StandardLibrary.LexIsTransitive (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTransitive$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), c#0: Seq where $Is(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.LexIsTransitive (call precondtion)"} CallPre$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTransitive$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), c#0: Seq where $Is(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap));
  requires {:id "id2480"} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.LexIsTransitive$T, less#0) ==> StandardLibrary.__default.Transitive(StandardLibrary._default.LexIsTransitive$T, less#0) || (forall x#0: Box, y#0: Box, z#0: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#0, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, y#0, z#0)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, y#0, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.LexIsTransitive$T) && $IsBox(y#0, StandardLibrary._default.LexIsTransitive$T) && $IsBox(z#0, StandardLibrary._default.LexIsTransitive$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#0, y#0)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, y#0, z#0)): bool ==> $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#0, z#0)): bool);
  requires {:id "id2481"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0) || (exists k#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k#0) } LitInt(0) <= k#0 && k#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k#0));
  requires {:id "id2482"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0) || (exists k#1: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k#1) } LitInt(0) <= k#1 && k#1 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k#1));



procedure {:verboseName "StandardLibrary.LexIsTransitive (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTransitive$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), c#0: Seq where $Is(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0);
  free ensures {:id "id2483"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0) && StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0) && (exists k#2: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#2) } LitInt(0) <= k#2 && k#2 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#2));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.LexIsTransitive (correctness)"} Impl$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTransitive$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), c#0: Seq where $Is(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T)) && $IsAlloc(c#0, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id2484"} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.LexIsTransitive$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.LexIsTransitive$T, less#0) && (forall x#1: Box, y#1: Box, z#1: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#1, z#1)): bool, $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, y#1, z#1)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, y#1, z#1)): bool, $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.LexIsTransitive$T) && $IsBox(y#1, StandardLibrary._default.LexIsTransitive$T) && $IsBox(z#1, StandardLibrary._default.LexIsTransitive$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, y#1, z#1)): bool ==> $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, x#1, z#1)): bool);
  free requires {:id "id2485"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0) && StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0) && (exists k#3: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k#3) } LitInt(0) <= k#3 && k#3 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k#3));
  free requires {:id "id2486"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0) && StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0) && (exists k#4: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k#4) } LitInt(0) <= k#4 && k#4 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k#4));
  modifies $Heap;
  free ensures StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0);
  free ensures {:id "id2487"} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0) || (exists k#5: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#5) } LitInt(0) <= k#5 && k#5 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#5));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.LexIsTransitive (correctness)"} Impl$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T: Ty, a#0: Seq, b#0: Seq, c#0: Seq, less#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var defass#k0#0: bool;
  var k0#0: int;
  var k0#1: int;
  var ##a#3: Seq;
  var ##b#3: Seq;
  var ##less#3: HandleType;
  var ##lengthOfCommonPrefix#0: int;
  var defass#k1#0: bool;
  var k1#0: int;
  var k1#1: int;
  var ##a#4: Seq;
  var ##b#4: Seq;
  var ##less#4: HandleType;
  var ##lengthOfCommonPrefix#1: int;
  var k#6: int;
  var ##a#5: Seq;
  var ##b#5: Seq;
  var ##less#5: HandleType;
  var ##lengthOfCommonPrefix#2: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsTransitive", " | ", StandardLibrary._default.LexIsTransitive$T, " | ", a#0, " | ", b#0, " | ", c#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(295,2): initial state"} true;
    $_reverifyPost := false;
    havoc k0#1;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= k0#1;
    goto anon3;

  anon17_Else:
    assume {:partition} k0#1 < LitInt(0);
    goto anon3;

  anon3:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= k0#1 && k0#1 <= Seq#Length(a#0);
    ##a#3 := a#0;
    assume $IsAlloc(##a#3, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap);
    ##b#3 := b#0;
    assume $IsAlloc(##b#3, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap);
    ##less#3 := less#0;
    assume $IsAlloc(##less#3, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap);
    assume $Is(k0#1, Tclass._System.nat());
    ##lengthOfCommonPrefix#0 := k0#1;
    assume $IsAlloc(##lengthOfCommonPrefix#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#0 <= Seq#Length(##a#3);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k0#1);
    goto anon5;

  anon18_Else:
    assume {:partition} !(LitInt(0) <= k0#1 && k0#1 <= Seq#Length(a#0));
    goto anon5;

  anon5:
    assume LitInt(0) <= k0#1 ==> k0#1 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k0#1);
    goto anon6;

  anon16_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume ($Is(Seq#Length(a#0) + 1 - 1, TInt) && LitInt(0) <= Seq#Length(a#0) + 1 - 1 && Seq#Length(a#0) + 1 - 1 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, Seq#Length(a#0) + 1 - 1)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, LitInt(0))) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, LitInt(0))) || (exists $as#k00#0: int :: LitInt(0) <= $as#k00#0 && $as#k00#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, $as#k00#0));
    defass#k0#0 := true;
    havoc k0#0;
    assume LitInt(0) <= k0#0 && k0#0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, less#0, k0#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(296,75)"} true;
    havoc k1#1;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= k1#1;
    goto anon9;

  anon20_Else:
    assume {:partition} k1#1 < LitInt(0);
    goto anon9;

  anon9:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} LitInt(0) <= k1#1 && k1#1 <= Seq#Length(b#0);
    ##a#4 := b#0;
    assume $IsAlloc(##a#4, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap);
    ##b#4 := c#0;
    assume $IsAlloc(##b#4, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap);
    ##less#4 := less#0;
    assume $IsAlloc(##less#4, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap);
    assume $Is(k1#1, Tclass._System.nat());
    ##lengthOfCommonPrefix#1 := k1#1;
    assume $IsAlloc(##lengthOfCommonPrefix#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#1;
    assume {:subsumption 0} ##lengthOfCommonPrefix#1 <= Seq#Length(##a#4);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k1#1);
    goto anon11;

  anon21_Else:
    assume {:partition} !(LitInt(0) <= k1#1 && k1#1 <= Seq#Length(b#0));
    goto anon11;

  anon11:
    assume LitInt(0) <= k1#1 ==> k1#1 <= Seq#Length(b#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k1#1);
    goto anon12;

  anon19_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume ($Is(Seq#Length(b#0) + 1 - 1, TInt) && LitInt(0) <= Seq#Length(b#0) + 1 - 1 && Seq#Length(b#0) + 1 - 1 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, Seq#Length(b#0) + 1 - 1)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, LitInt(0))) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && LitInt(0) <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, LitInt(0))) || (exists $as#k10#0: int :: LitInt(0) <= $as#k10#0 && $as#k10#0 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, $as#k10#0));
    defass#k1#0 := true;
    havoc k1#0;
    assume LitInt(0) <= k1#0 && k1#0 <= Seq#Length(b#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, b#0, c#0, less#0, k1#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(297,75)"} true;
    assume true;
    assume defass#k0#0;
    assume defass#k1#0;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} k0#0 < k1#0;
    assume defass#k0#0;
    goto anon15;

  anon22_Else:
    assume {:partition} k1#0 <= k0#0;
    assume defass#k1#0;
    goto anon15;

  anon15:
    assume true;
    k#6 := (if k0#0 < k1#0 then k0#0 else k1#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(298,39)"} true;
    ##a#5 := a#0;
    assume $IsAlloc(##a#5, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap);
    ##b#5 := c#0;
    assume $IsAlloc(##b#5, TSeq(StandardLibrary._default.LexIsTransitive$T), $Heap);
    ##less#5 := less#0;
    assume $IsAlloc(##less#5, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool), $Heap);
    assume $Is(k#6, Tclass._System.nat());
    ##lengthOfCommonPrefix#2 := k#6;
    assume $IsAlloc(##lengthOfCommonPrefix#2, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#2;
    assume {:subsumption 0} ##lengthOfCommonPrefix#2 <= Seq#Length(##a#5);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6) || k#6 <= Seq#Length(c#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6) || (forall i#0: int :: { Seq#Index(c#0, i#0) } { Seq#Index(a#0, i#0) } LitInt(0) <= i#0 && i#0 < k#6 ==> Seq#Index(a#0, i#0) == Seq#Index(c#0, i#0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6) || k#6 == Seq#Length(a#0) || (k#6 < Seq#Length(c#0) && $Unbox(Apply2(StandardLibrary._default.LexIsTransitive$T, StandardLibrary._default.LexIsTransitive$T, TBool, $Heap, less#0, Seq#Index(a#0, k#6), Seq#Index(c#0, k#6))): bool);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTransitive$T, a#0, c#0, less#0, k#6);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(299,53)"} true;
    return;
}



procedure {:verboseName "StandardLibrary.LexIsTotal (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTotal$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.LexIsTotal (call precondtion)"} CallPre$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTotal$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap));
  requires {:id "id2514"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.LexIsTotal$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsTotal$T, less#0) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.LexIsTotal$T) && $IsBox(y#0, StandardLibrary._default.LexIsTotal$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, y#0, x#0)): bool);
  requires {:id "id2515"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.LexIsTotal$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsTotal$T, less#0) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.LexIsTotal$T) && $IsBox(y#1, StandardLibrary._default.LexIsTotal$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, y#1, x#1)): bool ==> false);
  requires {:id "id2516"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.LexIsTotal$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsTotal$T, less#0) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.LexIsTotal$T) && $IsBox(y#2, StandardLibrary._default.LexIsTotal$T) ==> $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, x#2, y#2)): bool ==> x#2 != y#2);



procedure {:verboseName "StandardLibrary.LexIsTotal (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTotal$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0) && (!StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0));
  free ensures {:id "id2517"} StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0) || StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.LexIsTotal (correctness)"} Impl$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T: Ty where $AlwaysAllocated(StandardLibrary._default.LexIsTotal$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.LexIsTotal$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0) && (!StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0));
  free ensures {:id "id2518"} StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0) || StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.LexIsTotal (correctness)"} Impl$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $decr_init$loop#01: int;
  var $w$loop#0: bool;
  var i#0: int;
  var $decr$loop#00: int;
  var $decr$loop#01: int;
  var a##1_0: Seq;
  var less##1_0: HandleType;
  var ##a#2_0_0: Seq;
  var ##b#2_0_0: Seq;
  var ##less#2_0_0: HandleType;
  var ##lengthOfCommonPrefix#2_0_0: int;
  var ##a#2_1_0_0: Seq;
  var ##b#2_1_0_0: Seq;
  var ##less#2_1_0_0: HandleType;
  var ##lengthOfCommonPrefix#2_1_0_0: int;
  var ##a#2_1_1_0_0: Seq;
  var ##b#2_1_1_0_0: Seq;
  var ##less#2_1_1_0_0: HandleType;
  var ##lengthOfCommonPrefix#2_1_1_0_0: int;
  var ##a#2_1_1_1_0: Seq;
  var ##b#2_1_1_1_0: Seq;
  var ##less#2_1_1_1_0: HandleType;
  var ##lengthOfCommonPrefix#2_1_1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsTotal", " | ", StandardLibrary._default.LexIsTotal$T, " | ", a#0, " | ", b#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(305,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    m#0 := LitInt(0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(306,14)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(a#0) - m#0;
    $decr_init$loop#01 := (if m#0 < Seq#Length(a#0) then Seq#Length(b#0) - m#0 else 0 - 1);
    havoc $w$loop#0;
    goto anon38_LoopHead;

  anon38_LoopHead:
    assume true;
    assume $w$loop#0 ==> m#0 <= Seq#Length(a#0);
    assume $w$loop#0 ==> m#0 <= Seq#Length(b#0);
    assume true;
    assume $w$loop#0 ==> (forall i#1: int :: { Seq#Index(b#0, i#1) } { Seq#Index(a#0, i#1) } LitInt(0) <= i#1 && i#1 < m#0 ==> Seq#Index(a#0, i#1) == Seq#Index(b#0, i#1));
    assume $PreLoopHeap$loop#0 == $Heap;
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume Seq#Length(a#0) - m#0 <= $decr_init$loop#00 && (Seq#Length(a#0) - m#0 == $decr_init$loop#00 ==> (if m#0 < Seq#Length(a#0) then Seq#Length(b#0) - m#0 else 0 - 1) <= $decr_init$loop#01);
    goto anon38_LoopDone, anon38_LoopBody;

  anon38_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(307,4): after some loop iterations"} true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} !$w$loop#0;
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} m#0 <= Seq#Length(a#0);
    goto anon4;

  anon40_Else:
    assume {:partition} Seq#Length(a#0) < m#0;
    goto anon4;

  anon4:
    assume true;
    assume m#0 <= Seq#Length(a#0) && m#0 <= Seq#Length(b#0);
    havoc i#0;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} true;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon7;

  anon42_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon7;

  anon7:
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < m#0;
    assume {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(a#0);
    assume {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(b#0);
    goto anon9;

  anon43_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < m#0);
    goto anon9;

  anon41_Else:
    assume {:partition} false;
    goto anon9;

  anon9:
    assume true;
    assume (forall i#1: int :: { Seq#Index(b#0, i#1) } { Seq#Index(a#0, i#1) } LitInt(0) <= i#1 && i#1 < m#0 ==> Seq#Index(a#0, i#1) == Seq#Index(b#0, i#1));
    assume true;
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} m#0 < Seq#Length(a#0);
    goto anon12;

  anon44_Else:
    assume {:partition} Seq#Length(a#0) <= m#0;
    goto anon12;

  anon12:
    assume true;
    assume false;
    goto anon13;

  anon39_Else:
    assume {:partition} $w$loop#0;
    goto anon13;

  anon13:
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} m#0 < Seq#Length(a#0);
    goto anon15;

  anon45_Else:
    assume {:partition} Seq#Length(a#0) <= m#0;
    goto anon15;

  anon15:
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} m#0 < Seq#Length(a#0) && m#0 < Seq#Length(b#0);
    assume 0 <= m#0 && m#0 < Seq#Length(a#0);
    assume 0 <= m#0 && m#0 < Seq#Length(b#0);
    goto anon17;

  anon46_Else:
    assume {:partition} !(m#0 < Seq#Length(a#0) && m#0 < Seq#Length(b#0));
    goto anon17;

  anon17:
    assume true;
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} !(m#0 < Seq#Length(a#0) && m#0 < Seq#Length(b#0) && Seq#Index(a#0, m#0) == Seq#Index(b#0, m#0));
    goto anon20;

  anon47_Else:
    assume {:partition} m#0 < Seq#Length(a#0) && m#0 < Seq#Length(b#0) && Seq#Index(a#0, m#0) == Seq#Index(b#0, m#0);
    $decr$loop#00 := Seq#Length(a#0) - m#0;
    $decr$loop#01 := (if m#0 < Seq#Length(a#0) then Seq#Length(b#0) - m#0 else 0 - 1);
    push;
    assume true;
    assume true;
    m#0 := m#0 + 1;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(311,16)"} true;
    pop;
    assume 0 <= $decr$loop#00 || Seq#Length(a#0) - m#0 == $decr$loop#00;
    assume 0 <= $decr$loop#01 || Seq#Length(a#0) - m#0 < $decr$loop#00 || (if m#0 < Seq#Length(a#0) then Seq#Length(b#0) - m#0 else 0 - 1) == $decr$loop#01;
    assume Seq#Length(a#0) - m#0 < $decr$loop#00 || (Seq#Length(a#0) - m#0 == $decr$loop#00 && (if m#0 < Seq#Length(a#0) then Seq#Length(b#0) - m#0 else 0 - 1) < $decr$loop#01);
    assume true;
    goto anon38_LoopHead;

  anon38_LoopDone:
    assume {:partition} false;
    goto anon20;

  anon20:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} m#0 == Seq#Length(a#0);
    goto anon22;

  anon48_Else:
    assume {:partition} m#0 != Seq#Length(a#0);
    goto anon22;

  anon22:
    assume true;
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} m#0 == Seq#Length(a#0) && Seq#Length(a#0) == Seq#Length(b#0);
    assume true;
    assume Seq#Equal(a#0, b#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(315,19)"} true;
    assume true;
    a##1_0 := a#0;
    assume true;
    less##1_0 := less#0;
    call CallPre$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsTotal$T, a##1_0, less##1_0);
    call CallPost$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsTotal$T, a##1_0, less##1_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(316,29)"} true;
    return;

  anon49_Else:
    assume {:partition} !(m#0 == Seq#Length(a#0) && Seq#Length(a#0) == Seq#Length(b#0));
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} m#0 == Seq#Length(a#0);
    goto anon26;

  anon50_Else:
    assume {:partition} m#0 != Seq#Length(a#0);
    goto anon26;

  anon26:
    assume true;
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} m#0 == Seq#Length(a#0) && Seq#Length(a#0) < Seq#Length(b#0);
    ##a#2_0_0 := a#0;
    assume $IsAlloc(##a#2_0_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##b#2_0_0 := b#0;
    assume $IsAlloc(##b#2_0_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##less#2_0_0 := less#0;
    assume $IsAlloc(##less#2_0_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap);
    assume $Is(m#0, Tclass._System.nat());
    ##lengthOfCommonPrefix#2_0_0 := m#0;
    assume $IsAlloc(##lengthOfCommonPrefix#2_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#2_0_0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#2_0_0 <= Seq#Length(##a#2_0_0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) || m#0 <= Seq#Length(b#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) || (forall i#2_0_0: int :: { Seq#Index(b#0, i#2_0_0) } { Seq#Index(a#0, i#2_0_0) } LitInt(0) <= i#2_0_0 && i#2_0_0 < m#0 ==> Seq#Index(a#0, i#2_0_0) == Seq#Index(b#0, i#2_0_0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) || m#0 == Seq#Length(a#0) || (m#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(a#0, m#0), Seq#Index(b#0, m#0))): bool);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(318,55)"} true;
    return;

  anon51_Else:
    assume {:partition} !(m#0 == Seq#Length(a#0) && Seq#Length(a#0) < Seq#Length(b#0));
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} m#0 == Seq#Length(b#0);
    goto anon30;

  anon52_Else:
    assume {:partition} m#0 != Seq#Length(b#0);
    goto anon30;

  anon30:
    assume true;
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} m#0 == Seq#Length(b#0) && Seq#Length(b#0) < Seq#Length(a#0);
    ##a#2_1_0_0 := b#0;
    assume $IsAlloc(##a#2_1_0_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##b#2_1_0_0 := a#0;
    assume $IsAlloc(##b#2_1_0_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##less#2_1_0_0 := less#0;
    assume $IsAlloc(##less#2_1_0_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap);
    assume $Is(m#0, Tclass._System.nat());
    ##lengthOfCommonPrefix#2_1_0_0 := m#0;
    assume $IsAlloc(##lengthOfCommonPrefix#2_1_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#2_1_0_0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#2_1_0_0 <= Seq#Length(##a#2_1_0_0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) || m#0 <= Seq#Length(a#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) || (forall i#2_1_0_0: int :: { Seq#Index(a#0, i#2_1_0_0) } { Seq#Index(b#0, i#2_1_0_0) } LitInt(0) <= i#2_1_0_0 && i#2_1_0_0 < m#0 ==> Seq#Index(b#0, i#2_1_0_0) == Seq#Index(a#0, i#2_1_0_0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) || m#0 == Seq#Length(b#0) || (m#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(b#0, m#0), Seq#Index(a#0, m#0))): bool);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(320,55)"} true;
    return;

  anon53_Else:
    assume {:partition} !(m#0 == Seq#Length(b#0) && Seq#Length(b#0) < Seq#Length(a#0));
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} m#0 < Seq#Length(a#0);
    goto anon34;

  anon54_Else:
    assume {:partition} Seq#Length(a#0) <= m#0;
    goto anon34;

  anon34:
    assume true;
    assume {:subsumption 0} m#0 < Seq#Length(a#0);
    assume {:subsumption 0} m#0 < Seq#Length(b#0);
    assume m#0 < Seq#Length(a#0) && m#0 < Seq#Length(b#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(322,31)"} true;
    assume StandardLibrary.__default.Trichotomous(StandardLibrary._default.LexIsTotal$T, less#0);
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume 0 <= m#0 && m#0 < Seq#Length(a#0);
    assume 0 <= m#0 && m#0 < Seq#Length(b#0);
    assume true;
    assume $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(a#0, m#0), Seq#Index(b#0, m#0))): bool;
    ##a#2_1_1_1_0 := a#0;
    assume $IsAlloc(##a#2_1_1_1_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##b#2_1_1_1_0 := b#0;
    assume $IsAlloc(##b#2_1_1_1_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##less#2_1_1_1_0 := less#0;
    assume $IsAlloc(##less#2_1_1_1_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap);
    assume $Is(m#0, Tclass._System.nat());
    ##lengthOfCommonPrefix#2_1_1_1_0 := m#0;
    assume $IsAlloc(##lengthOfCommonPrefix#2_1_1_1_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#2_1_1_1_0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#2_1_1_1_0 <= Seq#Length(##a#2_1_1_1_0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) || m#0 <= Seq#Length(b#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) || (forall i#2_1_1_1_0: int :: { Seq#Index(b#0, i#2_1_1_1_0) } { Seq#Index(a#0, i#2_1_1_1_0) } LitInt(0) <= i#2_1_1_1_0 && i#2_1_1_1_0 < m#0 ==> Seq#Index(a#0, i#2_1_1_1_0) == Seq#Index(b#0, i#2_1_1_1_0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0) || m#0 == Seq#Length(a#0) || (m#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(a#0, m#0), Seq#Index(b#0, m#0))): bool);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0, m#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(326,57)"} true;
    return;

  anon55_Else:
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume 0 <= m#0 && m#0 < Seq#Length(b#0);
    assume 0 <= m#0 && m#0 < Seq#Length(a#0);
    assume true;
    assume $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(b#0, m#0), Seq#Index(a#0, m#0))): bool;
    ##a#2_1_1_0_0 := b#0;
    assume $IsAlloc(##a#2_1_1_0_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##b#2_1_1_0_0 := a#0;
    assume $IsAlloc(##b#2_1_1_0_0, TSeq(StandardLibrary._default.LexIsTotal$T), $Heap);
    ##less#2_1_1_0_0 := less#0;
    assume $IsAlloc(##less#2_1_1_0_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool), $Heap);
    assume $Is(m#0, Tclass._System.nat());
    ##lengthOfCommonPrefix#2_1_1_0_0 := m#0;
    assume $IsAlloc(##lengthOfCommonPrefix#2_1_1_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} LitInt(0) <= ##lengthOfCommonPrefix#2_1_1_0_0;
    assume {:subsumption 0} ##lengthOfCommonPrefix#2_1_1_0_0 <= Seq#Length(##a#2_1_1_0_0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) || m#0 <= Seq#Length(a#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) || (forall i#2_1_1_0_0: int :: { Seq#Index(a#0, i#2_1_1_0_0) } { Seq#Index(b#0, i#2_1_1_0_0) } LitInt(0) <= i#2_1_1_0_0 && i#2_1_1_0_0 < m#0 ==> Seq#Index(b#0, i#2_1_1_0_0) == Seq#Index(a#0, i#2_1_1_0_0));
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0) || m#0 == Seq#Length(b#0) || (m#0 < Seq#Length(a#0) && $Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(b#0, m#0), Seq#Index(a#0, m#0))): bool);
    assume StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexIsTotal$T, b#0, a#0, less#0, m#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(328,57)"} true;
    return;

  anon56_Else:
    assume true;
    assume true;
    assume !$Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(a#0, m#0), Seq#Index(b#0, m#0))): bool && !$Unbox(Apply2(StandardLibrary._default.LexIsTotal$T, StandardLibrary._default.LexIsTotal$T, TBool, $Heap, less#0, Seq#Index(b#0, m#0), Seq#Index(a#0, m#0))): bool;
    assume false;
    return;
}



function StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType) : Seq
uses {
axiom 6 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || (6 < $FunctionContextHeight && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#0: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#0)]) && (forall k#0: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#0)) } { s#0[$Box(k#0)] } $Is(k#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#0)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#0))) && (forall i#1: int, _t#0#0: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#1)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#0)): Seq } _t#0#0 == i#1 - 1 ==> 0 < i#1 && i#1 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#0)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#1)): Seq, less#0)) && (forall i#2: int, j#0: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#0)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#2)): Seq } LitInt(0) <= i#2 && i#2 < j#0 && j#0 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#2)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#0)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));
axiom 6 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || (6 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#0 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#0)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#0))), less#0)))));
axiom 6 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || (6 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#1 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#1)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#1))), less#0)))));
axiom 6 <= $FunctionContextHeight ==> (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || (6 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#2 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#2)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#2))), Lit(less#0))))));
}

function StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T: Ty, s#0: Set, less#0: HandleType) : bool;

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, AsFuelBottom($ly), s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) == StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LZ, s#0, less#0));

function StandardLibrary.__default.SetToOrderedSequence#requires(Ty, LayerType, Set, HandleType) : bool;

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence#requires(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) ==> (StandardLibrary.__default.SetToOrderedSequence#requires(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) <==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)));

function $let#0_a(StandardLibrary._default.SetToOrderedSequence$T: Ty, s: Set, less: HandleType) : Seq;

function $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T: Ty, s: Set, less: HandleType) : bool;

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, s: Set, less: HandleType :: { $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s, less) } $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s, less) ==> $Is($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s, less), TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && s[$Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s, less))] && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s, less), s, less));

procedure {:verboseName "StandardLibrary.SetToOrderedSequence (well-formedness)"} CheckWellformed$$StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T: Ty where $AlwaysAllocated(StandardLibrary._default.SetToOrderedSequence$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool))) returns (q#0: Seq where $Is(q#0, TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2574"} Set#Card(s#0) == Seq#Length(q#0);
  free ensures {:id "id2575"} (forall i#3: int :: { $Unbox(Seq#Index(q#0, i#3)): Seq } LitInt(0) <= i#3 && i#3 < Seq#Length(q#0) ==> s#0[Seq#Index(q#0, i#3)]);
  free ensures {:id "id2576"} (forall k#1: Seq :: { Seq#Contains(q#0, $Box(k#1)) } { s#0[$Box(k#1)] } $Is(k#1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#1)] ==> Seq#Contains(q#0, $Box(k#1)));
  free ensures {:id "id2577"} (forall i#4: int, _t#0#1: int :: { $Unbox(Seq#Index(q#0, i#4)): Seq, $Unbox(Seq#Index(q#0, _t#0#1)): Seq } _t#0#1 == i#4 - 1 ==> 0 < i#4 && i#4 < Seq#Length(q#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(q#0, _t#0#1)): Seq, $Unbox(Seq#Index(q#0, i#4)): Seq, less#0));
  free ensures {:id "id2578"} (forall i#5: int, j#1: int :: { $Unbox(Seq#Index(q#0, j#1)): Seq, $Unbox(Seq#Index(q#0, i#5)): Seq } LitInt(0) <= i#5 && i#5 < j#1 && j#1 < Seq#Length(q#0) ==> !Seq#Equal($Unbox(Seq#Index(q#0, i#5)): Seq, $Unbox(Seq#Index(q#0, j#1)): Seq));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.SetToOrderedSequence (well-formedness)"} CheckWellformed$$StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T: Ty, s#0: Set, less#0: HandleType) returns (q#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##less#0: HandleType;
  var ##R#0: HandleType;
  var i#6: int;
  var k#2: Seq;
  var i#7: int;
  var ##a#0: Seq;
  var ##b#0: Seq;
  var ##less#1: HandleType;
  var i#8: int;
  var j#2: int;
  var s##0: Set;
  var less##0: HandleType;
  var a#3: Seq;
  var b#0: Seq;
  var ##a#1: Seq;
  var ##s#0: Set;
  var ##less#2: HandleType;
  var ##a#2: Seq;
  var ##s#1: Set;
  var ##less#3: HandleType;
  var a#0_0_0: Seq;
  var b#0_0_0: Seq;
  var ##a#0_0_0: Seq;
  var ##s#0_0_0: Set;
  var ##less#0_0_0: HandleType;
  var ##a#0_0_1: Seq;
  var ##s#0_0_1: Set;
  var ##less#0_0_1: HandleType;
  var a##0_0_0: Seq;
  var b##0_0_0: Seq;
  var s##0_0_0: Set;
  var less##0_0_0: HandleType;
  var $initHeapForallStmt#0_0_0: Heap;
  var a#5: Seq;
  var ##a#3: Seq;
  var ##s#2: Set;
  var ##less#4: HandleType;
  var ##s#3: Set;
  var ##less#5: HandleType;
  var a#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.SetToOrderedSequence", " | ", StandardLibrary._default.SetToOrderedSequence$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(338,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##less#0 := less#0;
    assume $IsAlloc(##less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.SetToOrderedSequence$T, less#0);
    assume StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0);
    ##R#0 := less#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.SetToOrderedSequence$T, less#0);
    assume StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T)));
    assume Set#Card(s#0) == Seq#Length(q#0);
    havoc i#6;
    assume true;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(0) <= i#6;
    goto anon5;

  anon44_Else:
    assume {:partition} i#6 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#6 && i#6 < Seq#Length(q#0);
    assume 0 <= i#6 && i#6 < Seq#Length(q#0);
    assume s#0[Seq#Index(q#0, i#6)];
    goto anon7;

  anon43_Else:
    assume LitInt(0) <= i#6 && i#6 < Seq#Length(q#0) ==> s#0[Seq#Index(q#0, i#6)];
    goto anon7;

  anon7:
    assume (forall i#3: int :: { $Unbox(Seq#Index(q#0, i#3)): Seq } LitInt(0) <= i#3 && i#3 < Seq#Length(q#0) ==> s#0[Seq#Index(q#0, i#3)]);
    havoc k#2;
    assume $Is(k#2, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(k#2, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume s#0[$Box(k#2)];
    assume Seq#Contains(q#0, $Box(k#2));
    goto anon10;

  anon45_Else:
    assume s#0[$Box(k#2)] ==> Seq#Contains(q#0, $Box(k#2));
    goto anon10;

  anon10:
    assume (forall k#1: Seq :: { Seq#Contains(q#0, $Box(k#1)) } { s#0[$Box(k#1)] } $Is(k#1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#1)] ==> Seq#Contains(q#0, $Box(k#1)));
    havoc i#7;
    assume true;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} 0 < i#7;
    goto anon13;

  anon47_Else:
    assume {:partition} i#7 <= 0;
    goto anon13;

  anon13:
    assume 0 < i#7 && i#7 < Seq#Length(q#0);
    assume 0 <= i#7 - 1 && i#7 - 1 < Seq#Length(q#0);
    assume 0 <= i#7 && i#7 < Seq#Length(q#0);
    ##a#0 := $Unbox(Seq#Index(q#0, i#7 - 1)): Seq;
    assume $IsAlloc(##a#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##b#0 := $Unbox(Seq#Index(q#0, i#7)): Seq;
    assume $IsAlloc(##b#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##less#1 := less#0;
    assume $IsAlloc(##less#1, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(q#0, i#7 - 1)): Seq, $Unbox(Seq#Index(q#0, i#7)): Seq, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(q#0, i#7 - 1)): Seq, $Unbox(Seq#Index(q#0, i#7)): Seq, less#0);
    goto anon15;

  anon46_Else:
    assume 0 < i#7 && i#7 < Seq#Length(q#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(q#0, i#7 - 1)): Seq, $Unbox(Seq#Index(q#0, i#7)): Seq, less#0);
    goto anon15;

  anon15:
    assume (forall i#4: int, _t#0#1: int :: { $Unbox(Seq#Index(q#0, i#4)): Seq, $Unbox(Seq#Index(q#0, _t#0#1)): Seq } _t#0#1 == i#4 - 1 ==> 0 < i#4 && i#4 < Seq#Length(q#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(q#0, _t#0#1)): Seq, $Unbox(Seq#Index(q#0, i#4)): Seq, less#0));
    havoc i#8;
    havoc j#2;
    assume true;
    goto anon48_Then, anon48_Else;

  anon48_Then:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} LitInt(0) <= i#8;
    goto anon18;

  anon49_Else:
    assume {:partition} i#8 < LitInt(0);
    goto anon18;

  anon18:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} LitInt(0) <= i#8 && i#8 < j#2;
    goto anon20;

  anon50_Else:
    assume {:partition} !(LitInt(0) <= i#8 && i#8 < j#2);
    goto anon20;

  anon20:
    assume LitInt(0) <= i#8 && i#8 < j#2 && j#2 < Seq#Length(q#0);
    assume 0 <= i#8 && i#8 < Seq#Length(q#0);
    assume 0 <= j#2 && j#2 < Seq#Length(q#0);
    assume !Seq#Equal($Unbox(Seq#Index(q#0, i#8)): Seq, $Unbox(Seq#Index(q#0, j#2)): Seq);
    goto anon22;

  anon48_Else:
    assume LitInt(0) <= i#8 && i#8 < j#2 && j#2 < Seq#Length(q#0) ==> !Seq#Equal($Unbox(Seq#Index(q#0, i#8)): Seq, $Unbox(Seq#Index(q#0, j#2)): Seq);
    goto anon22;

  anon22:
    assume (forall i#5: int, j#1: int :: { $Unbox(Seq#Index(q#0, j#1)): Seq, $Unbox(Seq#Index(q#0, i#5)): Seq } LitInt(0) <= i#5 && i#5 < j#1 && j#1 < Seq#Length(q#0) ==> !Seq#Equal($Unbox(Seq#Index(q#0, i#5)): Seq, $Unbox(Seq#Index(q#0, j#1)): Seq));
    assume false;
    return;

  anon42_Else:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} Set#Equal(s#0, Set#Empty(): Set);
    assume StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), s#0, less#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T)));
    goto anon41;

  anon51_Else:
    assume {:partition} !Set#Equal(s#0, Set#Empty(): Set);
    assume true;
    s##0 := s#0;
    assume true;
    less##0 := less#0;
    call CallPre$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.SetToOrderedSequence$T, s##0, less##0);
    call CallPost$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.SetToOrderedSequence$T, s##0, less##0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(352,29)"} true;
    havoc a#3;
    havoc b#0;
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} $Is(a#3, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(a#3, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap) && $Is(b#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##a#1 := a#3;
    assume $IsAlloc(##a#1, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T)), $Heap);
    ##less#2 := less#0;
    assume $IsAlloc(##less#2, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, a#3, s#0, less#0);
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#3, s#0, less#0);
    ##a#2 := b#0;
    assume $IsAlloc(##a#2, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T)), $Heap);
    ##less#3 := less#0;
    assume $IsAlloc(##less#3, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, b#0, s#0, less#0);
    goto anon28;

  anon53_Else:
    assume {:partition} !StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#3, s#0, less#0);
    goto anon28;

  anon28:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#3, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#0, s#0, less#0);
    goto anon30;

  anon54_Else:
    assume {:partition} !(StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#3, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#0, s#0, less#0));
    goto anon30;

  anon52_Else:
    assume {:partition} !($Is(a#3, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(a#3, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap) && $Is(b#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap));
    goto anon30;

  anon30:
    assume (forall a#4: Seq, b#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#1, s#0, less#0), StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) } $Is(a#4, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $Is(b#1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) ==> StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, b#1, s#0, less#0)));
    goto anon55_Then, anon55_Else;

  anon55_Then:
    goto anon56_Then, anon56_Else;

  anon56_Then:
    havoc a#0_0_0, b#0_0_0;
    assume $Is(a#0_0_0, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $Is(b#0_0_0, TSeq(StandardLibrary._default.SetToOrderedSequence$T));
    ##a#0_0_0 := a#0_0_0;
    assume $IsAlloc(##a#0_0_0, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T)), $Heap);
    ##less#0_0_0 := less#0;
    assume $IsAlloc(##less#0_0_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_0, s#0, less#0);
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_0, s#0, less#0);
    ##a#0_0_1 := b#0_0_0;
    assume $IsAlloc(##a#0_0_1, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##s#0_0_1 := s#0;
    assume $IsAlloc(##s#0_0_1, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T)), $Heap);
    ##less#0_0_1 := less#0;
    assume $IsAlloc(##less#0_0_1, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, b#0_0_0, s#0, less#0);
    goto anon34;

  anon57_Else:
    assume {:partition} !StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_0, s#0, less#0);
    goto anon34;

  anon34:
    assume StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_0, s#0, less#0) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, b#0_0_0, s#0, less#0));
    assume StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_0, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#0_0_0, s#0, less#0);
    assume true;
    a##0_0_0 := a#0_0_0;
    assume true;
    b##0_0_0 := b#0_0_0;
    assume true;
    s##0_0_0 := s#0;
    assume true;
    less##0_0_0 := less#0;
    call CallPre$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.SetToOrderedSequence$T, a##0_0_0, b##0_0_0, s##0_0_0, less##0_0_0);
    call CallPost$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.SetToOrderedSequence$T, a##0_0_0, b##0_0_0, s##0_0_0, less##0_0_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(363,40)"} true;
    assume false;
    goto anon36;

  anon56_Else:
    $initHeapForallStmt#0_0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0_0_0 == $Heap;
    assume (forall a#0_0_1: Seq, b#0_0_1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#0_0_1, s#0, less#0), StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_1, s#0, less#0) } $Is(a#0_0_1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $Is(b#0_0_1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#0_0_1, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#0_0_1, s#0, less#0) ==> Seq#Equal(a#0_0_1, b#0_0_1));
    goto anon36;

  anon36:
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(364,8)"} true;
    assume (forall a#4: Seq, b#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#1, s#0, less#0), StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) } $Is(a#4, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $Is(b#1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#1, s#0, less#0) ==> Seq#Equal(a#4, b#1));
    assume false;
    goto anon37;

  anon55_Else:
    goto anon37;

  anon37:
    assume (forall a#4: Seq, b#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#1, s#0, less#0), StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) } $Is(a#4, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $Is(b#1, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#4, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, b#1, s#0, less#0) ==> Seq#Equal(a#4, b#1));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(365,6)"} true;
    havoc a#5;
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} $Is(a#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(a#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} s#0[$Box(a#5)];
    ##a#3 := a#5;
    assume $IsAlloc(##a#3, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T)), $Heap);
    ##less#4 := less#0;
    assume $IsAlloc(##less#4, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, a#5, s#0, less#0);
    goto anon40;

  anon59_Else:
    assume {:partition} !s#0[$Box(a#5)];
    goto anon40;

  anon58_Else:
    assume {:partition} !($Is(a#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(a#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap));
    goto anon40;

  anon40:
    assume ($Is(Lit(Seq#Empty(): Seq), TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && s#0[$Box(Lit(Seq#Empty(): Seq))] && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, Lit(Seq#Empty(): Seq), s#0, less#0)) || (exists a#6: Seq :: $Is(a#6, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && s#0[$Box(a#6)] && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#6, s#0, less#0));
    assume $Is(a#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(a#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    assume s#0[$Box(a#5)] && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#5, s#0, less#0);
    ##s#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#5)));
    assume $IsAlloc(##s#3, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T)), $Heap);
    ##less#5 := less#0;
    assume $IsAlloc(##less#5, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool), $Heap);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.SetToOrderedSequence$T) && $IsBox(y#0, StandardLibrary._default.SetToOrderedSequence$T) ==> $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#0, x#0)): bool);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.SetToOrderedSequence$T) && $IsBox(y#1, StandardLibrary._default.SetToOrderedSequence$T) ==> $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#1, x#1)): bool ==> false);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.SetToOrderedSequence$T) && $IsBox(y#2, StandardLibrary._default.SetToOrderedSequence$T) ==> $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#2, y#2)): bool ==> x#2 != y#2);
    assume {:subsumption 0} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) ==> StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) || (forall x#3: Box, y#3: Box, z#0: Box :: { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#3, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#3, z#0)): bool } { $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#3, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#3, y#3)): bool } $IsBox(x#3, StandardLibrary._default.SetToOrderedSequence$T) && $IsBox(y#3, StandardLibrary._default.SetToOrderedSequence$T) && $IsBox(z#0, StandardLibrary._default.SetToOrderedSequence$T) ==> $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#3, y#3)): bool && $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, y#3, z#0)): bool ==> $Unbox(Apply2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool, $Heap, ##less#5, x#3, z#0)): bool);
    assume StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, ##less#5) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, ##less#5);
    assume Set#Subset(##s#3, s#0) && !Set#Subset(s#0, ##s#3);
    assume StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#5))), less#0);
    havoc a#7;
    assume $Is(a#7, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) && $IsAlloc(a#7, TSeq(StandardLibrary._default.SetToOrderedSequence$T), $Heap);
    assume s#0[$Box(a#7)] ==> StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.SetToOrderedSequence$T, a#7, s#0, less#0);
    assume s#0[$Box(a#7)] && StandardLibrary.__default.IsMinimum(StandardLibrary._default.SetToOrderedSequence$T, a#7, s#0, less#0);
    assume StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#7))), less#0);
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#5)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#5))), less#0)), Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#7)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#7))), less#0)));
    assume $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0);
    assume StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), s#0, less#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#5)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#5))), less#0));
    assume StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#5))), less#0);
    assume $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T)));
    goto anon41;

  anon41:
    assume StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($LZ), s#0, less#0) == q#0;
    return;
}



function StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || (2 < $FunctionContextHeight && $Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#0: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#0, less#0) } { s#0[$Box(z#0)] } $Is(z#0, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#0)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#0, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#0: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#0, less#0) } { s#0[$Box(z#0)] } $Is(z#0, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#0)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#0, less#0))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || (2 < $FunctionContextHeight && $Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#1: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#1, less#0) } { s#0[$Box(z#1)] } $Is(z#1, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#1)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#1, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#1: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#1, less#0) } { s#0[$Box(z#1)] } $Is(z#1, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#1)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#1, less#0))));
axiom 2 <= $FunctionContextHeight ==> (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || (2 < $FunctionContextHeight && $Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#2: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#2, less#0) } { s#0[$Box(z#2)] } $Is(z#2, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#2)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#2, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#2: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#2, less#0) } { s#0[$Box(z#2)] } $Is(z#2, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#2)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#2, Lit(less#0)))));
}

function StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType) : bool;

function StandardLibrary.__default.IsMinimum#requires(Ty, Seq, Set, HandleType) : bool;

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum#requires(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } $Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool)) ==> (StandardLibrary.__default.IsMinimum#requires(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> true));

procedure {:verboseName "StandardLibrary.IsMinimum (well-formedness)"} CheckWellformed$$StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.ThereIsAMinimum (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.ThereIsAMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.ThereIsAMinimum (call precondtion)"} CallPre$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.ThereIsAMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool), $Heap));
  requires {:id "id2625"} !Set#Equal(s#0, Set#Empty(): Set);
  requires {:id "id2626"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.ThereIsAMinimum$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.ThereIsAMinimum$T, less#0) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#0, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#0, x#0)): bool);
  requires {:id "id2627"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.ThereIsAMinimum$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.ThereIsAMinimum$T, less#0) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#1, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#1, x#1)): bool ==> false);
  requires {:id "id2628"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.ThereIsAMinimum$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.ThereIsAMinimum$T, less#0) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#2, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#2, y#2)): bool ==> x#2 != y#2);
  requires {:id "id2629"} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.ThereIsAMinimum$T, less#0) ==> StandardLibrary.__default.Transitive(StandardLibrary._default.ThereIsAMinimum$T, less#0) || (forall x#3: Box, y#3: Box, z#0: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#3, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#3, z#0)): bool } { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#3, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#3, y#3)): bool } $IsBox(x#3, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#3, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(z#0, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#3, y#3)): bool && $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#3, z#0)): bool ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#3, z#0)): bool);



procedure {:verboseName "StandardLibrary.ThereIsAMinimum (call postcondition)"} CallPost$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.ThereIsAMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool), $Heap));
  modifies $Heap;
  free ensures (forall a#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0) } $Is(a#1, TSeq(StandardLibrary._default.ThereIsAMinimum$T)) ==> StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0));
  free ensures {:id "id2630"} (exists a#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0) } $Is(a#1, TSeq(StandardLibrary._default.ThereIsAMinimum$T)) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.ThereIsAMinimum (correctness)"} Impl$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.ThereIsAMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.ThereIsAMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id2631"} !Set#Equal(s#0, Set#Empty(): Set);
  free requires {:id "id2632"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.ThereIsAMinimum$T, less#0) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.ThereIsAMinimum$T, less#0) && (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#4, x#4)): bool } { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#4, y#4)): bool } $IsBox(x#4, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#4, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#4, y#4)): bool || x#4 == y#4 || $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#4, x#4)): bool) && (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#5, x#5)): bool } { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#5, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#5, y#5)): bool && $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#5, x#5)): bool ==> false) && (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#6, y#6)): bool } $IsBox(x#6, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#6, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#6, y#6)): bool ==> x#6 != y#6);
  free requires {:id "id2633"} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.ThereIsAMinimum$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.ThereIsAMinimum$T, less#0) && (forall x#7: Box, y#7: Box, z#1: Box :: { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#7, z#1)): bool, $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#7, z#1)): bool } { $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#7, z#1)): bool, $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#7, y#7)): bool } $IsBox(x#7, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(y#7, StandardLibrary._default.ThereIsAMinimum$T) && $IsBox(z#1, StandardLibrary._default.ThereIsAMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#7, y#7)): bool && $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, y#7, z#1)): bool ==> $Unbox(Apply2(StandardLibrary._default.ThereIsAMinimum$T, StandardLibrary._default.ThereIsAMinimum$T, TBool, $Heap, less#0, x#7, z#1)): bool);
  modifies $Heap;
  free ensures (forall a#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0) } $Is(a#1, TSeq(StandardLibrary._default.ThereIsAMinimum$T)) ==> StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0));
  free ensures {:id "id2634"} (exists a#1: Seq :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0) } $Is(a#1, TSeq(StandardLibrary._default.ThereIsAMinimum$T)) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.ThereIsAMinimum$T, a#1, s#0, less#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.ThereIsAMinimum (correctness)"} Impl$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T: Ty, s#0: Set, less#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#2: Seq where $Is(a#2, TSeq(StandardLibrary._default.ThereIsAMinimum$T)) && $IsAlloc(a#2, TSeq(StandardLibrary._default.ThereIsAMinimum$T), $Heap);
  var $rhs##0: Seq;
  var s##0: Set;
  var less##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.ThereIsAMinimum", " | ", StandardLibrary._default.ThereIsAMinimum$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(382,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    s##0 := s#0;
    assume true;
    less##0 := less#0;
    call CallPre$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.ThereIsAMinimum$T, s##0, less##0);
    call $rhs##0 := CallPost$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.ThereIsAMinimum$T, s##0, less##0);
    a#2 := $rhs##0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(383,33)"} true;
    return;
}



procedure {:verboseName "StandardLibrary.MinimumIsUnique (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T: Ty where $AlwaysAllocated(StandardLibrary._default.MinimumIsUnique$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.MinimumIsUnique (call precondtion)"} CallPre$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T: Ty where $AlwaysAllocated(StandardLibrary._default.MinimumIsUnique$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool), $Heap));
  requires {:id "id2642"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.MinimumIsUnique$T, a#0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.MinimumIsUnique$T, a#0, s#0, less#0) || s#0[$Box(a#0)];
  requires {:id "id2643"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.MinimumIsUnique$T, a#0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.MinimumIsUnique$T, a#0, s#0, less#0) || (forall z#0: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, a#0, z#0, less#0) } { s#0[$Box(z#0)] } $Is(z#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) ==> s#0[$Box(z#0)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, a#0, z#0, less#0));
  requires {:id "id2644"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.MinimumIsUnique$T, b#0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.MinimumIsUnique$T, b#0, s#0, less#0) || s#0[$Box(b#0)];
  requires {:id "id2645"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.MinimumIsUnique$T, b#0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.MinimumIsUnique$T, b#0, s#0, less#0) || (forall z#1: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, b#0, z#1, less#0) } { s#0[$Box(z#1)] } $Is(z#1, TSeq(StandardLibrary._default.MinimumIsUnique$T)) ==> s#0[$Box(z#1)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, b#0, z#1, less#0));
  requires {:id "id2646"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.MinimumIsUnique$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.MinimumIsUnique$T, less#0) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.MinimumIsUnique$T) && $IsBox(y#0, StandardLibrary._default.MinimumIsUnique$T) ==> $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#0, x#0)): bool);
  requires {:id "id2647"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.MinimumIsUnique$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.MinimumIsUnique$T, less#0) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.MinimumIsUnique$T) && $IsBox(y#1, StandardLibrary._default.MinimumIsUnique$T) ==> $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#1, x#1)): bool ==> false);
  requires {:id "id2648"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.MinimumIsUnique$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.MinimumIsUnique$T, less#0) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.MinimumIsUnique$T) && $IsBox(y#2, StandardLibrary._default.MinimumIsUnique$T) ==> $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#2, y#2)): bool ==> x#2 != y#2);



procedure {:verboseName "StandardLibrary.MinimumIsUnique (call postcondition)"} CallPost$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T: Ty where $AlwaysAllocated(StandardLibrary._default.MinimumIsUnique$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2649"} Seq#Equal(a#0, b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.MinimumIsUnique (correctness)"} Impl$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T: Ty where $AlwaysAllocated(StandardLibrary._default.MinimumIsUnique$T), a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), b#0: Seq where $Is(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T)) && $IsAlloc(b#0, TSeq(StandardLibrary._default.MinimumIsUnique$T), $Heap), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.MinimumIsUnique$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id2650"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.MinimumIsUnique$T, a#0, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.MinimumIsUnique$T, a#0, s#0, less#0) && s#0[$Box(a#0)] && (forall z#2: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, a#0, z#2, less#0) } { s#0[$Box(z#2)] } $Is(z#2, TSeq(StandardLibrary._default.MinimumIsUnique$T)) ==> s#0[$Box(z#2)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, a#0, z#2, less#0));
  free requires {:id "id2651"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.MinimumIsUnique$T, b#0, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.MinimumIsUnique$T, b#0, s#0, less#0) && s#0[$Box(b#0)] && (forall z#3: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, b#0, z#3, less#0) } { s#0[$Box(z#3)] } $Is(z#3, TSeq(StandardLibrary._default.MinimumIsUnique$T)) ==> s#0[$Box(z#3)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.MinimumIsUnique$T, b#0, z#3, less#0));
  free requires {:id "id2652"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.MinimumIsUnique$T, less#0) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.MinimumIsUnique$T, less#0) && (forall x#3: Box, y#3: Box :: { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#3, x#3)): bool } { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#3, y#3)): bool } $IsBox(x#3, StandardLibrary._default.MinimumIsUnique$T) && $IsBox(y#3, StandardLibrary._default.MinimumIsUnique$T) ==> $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#3, y#3)): bool || x#3 == y#3 || $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#3, x#3)): bool) && (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#4, x#4)): bool } { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#4, y#4)): bool } $IsBox(x#4, StandardLibrary._default.MinimumIsUnique$T) && $IsBox(y#4, StandardLibrary._default.MinimumIsUnique$T) ==> $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#4, y#4)): bool && $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, y#4, x#4)): bool ==> false) && (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.MinimumIsUnique$T) && $IsBox(y#5, StandardLibrary._default.MinimumIsUnique$T) ==> $Unbox(Apply2(StandardLibrary._default.MinimumIsUnique$T, StandardLibrary._default.MinimumIsUnique$T, TBool, $Heap, less#0, x#5, y#5)): bool ==> x#5 != y#5);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id2653"} Seq#Equal(a#0, b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.MinimumIsUnique (correctness)"} Impl$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T: Ty, a#0: Seq, b#0: Seq, s#0: Set, less#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a##0: Seq;
  var b##0: Seq;
  var less##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.MinimumIsUnique", " | ", StandardLibrary._default.MinimumIsUnique$T, " | ", a#0, " | ", b#0, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Set", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(390,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    a##0 := a#0;
    assume true;
    b##0 := b#0;
    assume true;
    less##0 := less#0;
    call CallPre$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.MinimumIsUnique$T, a##0, b##0, less##0);
    call CallPost$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.MinimumIsUnique$T, a##0, b##0, less##0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(391,34)"} true;
    return;
}



procedure {:verboseName "StandardLibrary.FindMinimum (well-formedness)"} CheckWellFormed$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.FindMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap)) returns (a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "StandardLibrary.FindMinimum (call precondtion)"} CallPre$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.FindMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap));
  requires {:id "id2660"} !Set#Equal(s#0, Set#Empty(): Set);
  requires {:id "id2661"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.FindMinimum$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.FindMinimum$T, less#0) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#0, x#0)): bool } { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#0, y#0)): bool } $IsBox(x#0, StandardLibrary._default.FindMinimum$T) && $IsBox(y#0, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#0, x#0)): bool);
  requires {:id "id2662"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.FindMinimum$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.FindMinimum$T, less#0) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#1, x#1)): bool } { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#1, y#1)): bool } $IsBox(x#1, StandardLibrary._default.FindMinimum$T) && $IsBox(y#1, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#1, y#1)): bool && $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#1, x#1)): bool ==> false);
  requires {:id "id2663"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.FindMinimum$T, less#0) ==> StandardLibrary.__default.Trichotomous(StandardLibrary._default.FindMinimum$T, less#0) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#2, y#2)): bool } $IsBox(x#2, StandardLibrary._default.FindMinimum$T) && $IsBox(y#2, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#2, y#2)): bool ==> x#2 != y#2);
  requires {:id "id2664"} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.FindMinimum$T, less#0) ==> StandardLibrary.__default.Transitive(StandardLibrary._default.FindMinimum$T, less#0) || (forall x#3: Box, y#3: Box, z#0: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#3, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#3, z#0)): bool } { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#3, z#0)): bool, $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#3, y#3)): bool } $IsBox(x#3, StandardLibrary._default.FindMinimum$T) && $IsBox(y#3, StandardLibrary._default.FindMinimum$T) && $IsBox(z#0, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#3, y#3)): bool && $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#3, z#0)): bool ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#3, z#0)): bool);



procedure {:verboseName "StandardLibrary.FindMinimum (call postcondition)"} CallPost$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.FindMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap)) returns (a#0: Seq where $Is(a#0, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0);
  free ensures {:id "id2665"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0) && StandardLibrary.__default.IsMinimum(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0) && s#0[$Box(a#0)] && (forall z#1: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1, less#0) } { s#0[$Box(z#1)] } $Is(z#1, TSeq(StandardLibrary._default.FindMinimum$T)) ==> s#0[$Box(z#1)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1, less#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "StandardLibrary.FindMinimum (correctness)"} Impl$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T: Ty where $AlwaysAllocated(StandardLibrary._default.FindMinimum$T), s#0: Set where $Is(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T))) && $IsAlloc(s#0, TSet(TSeq(StandardLibrary._default.FindMinimum$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap)) returns (defass#a#0: bool, a#0: Seq where defass#a#0 ==> $Is(a#0, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(a#0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id2666"} !Set#Equal(s#0, Set#Empty(): Set);
  free requires {:id "id2667"} StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.FindMinimum$T, less#0) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.FindMinimum$T, less#0) && (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#4, x#4)): bool } { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#4, y#4)): bool } $IsBox(x#4, StandardLibrary._default.FindMinimum$T) && $IsBox(y#4, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#4, y#4)): bool || x#4 == y#4 || $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#4, x#4)): bool) && (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#5, x#5)): bool } { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.FindMinimum$T) && $IsBox(y#5, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#5, y#5)): bool && $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#5, x#5)): bool ==> false) && (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#6, y#6)): bool } $IsBox(x#6, StandardLibrary._default.FindMinimum$T) && $IsBox(y#6, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#6, y#6)): bool ==> x#6 != y#6);
  free requires {:id "id2668"} StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.FindMinimum$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.FindMinimum$T, less#0) && (forall x#7: Box, y#7: Box, z#2: Box :: { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#7, z#2)): bool, $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#7, z#2)): bool } { $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#7, z#2)): bool, $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#7, y#7)): bool } $IsBox(x#7, StandardLibrary._default.FindMinimum$T) && $IsBox(y#7, StandardLibrary._default.FindMinimum$T) && $IsBox(z#2, StandardLibrary._default.FindMinimum$T) ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#7, y#7)): bool && $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, y#7, z#2)): bool ==> $Unbox(Apply2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool, $Heap, less#0, x#7, z#2)): bool);
  modifies $Heap;
  free ensures StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0);
  free ensures {:id "id2669"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0) || s#0[$Box(a#0)];
  free ensures {:id "id2670"} StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0) ==> StandardLibrary.__default.IsMinimum(StandardLibrary._default.FindMinimum$T, a#0, s#0, less#0) || (forall z#3: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#3, less#0) } { s#0[$Box(z#3)] } $Is(z#3, TSeq(StandardLibrary._default.FindMinimum$T)) ==> s#0[$Box(z#3)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#3, less#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "StandardLibrary.FindMinimum (correctness)"} Impl$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T: Ty, s#0: Set, less#0: HandleType) returns (defass#a#0: bool, a#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#1: Seq;
  var a##0_0: Seq;
  var less##0_0: HandleType;
  var s'#1_0: Set where $Is(s'#1_0, TSet(TSeq(StandardLibrary._default.FindMinimum$T))) && $IsAlloc(s'#1_0, TSet(TSeq(StandardLibrary._default.FindMinimum$T)), $Heap);
  var x#1_0: Seq;
  var a'#1_0: Seq where $Is(a'#1_0, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(a'#1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
  var $rhs##1_0: Seq;
  var s##1_0: Set;
  var less##1_0: HandleType;
  var ##a#1_0: Seq;
  var ##b#1_0: Seq;
  var ##less#1_0: HandleType;
  var ##a#1_1_0: Seq;
  var ##b#1_1_0: Seq;
  var ##less#1_1_0: HandleType;
  var a##1_1_0_0: Seq;
  var b##1_1_0_0: Seq;
  var less##1_1_0_0: HandleType;
  var z#1_1_1_0: Seq;
  var ##a#1_1_1_0: Seq;
  var ##b#1_1_1_0: Seq;
  var ##less#1_1_1_0: HandleType;
  var a##1_1_1_0_0: Seq;
  var less##1_1_1_0_0: HandleType;
  var ##a#1_1_1_1_0_0_0: Seq;
  var ##b#1_1_1_1_0_0_0: Seq;
  var ##less#1_1_1_1_0_0_0: HandleType;
  var a##1_1_1_1_0_0_0: Seq;
  var b##1_1_1_1_0_0_0: Seq;
  var c##1_1_1_1_0_0_0: Seq;
  var less##1_1_1_1_0_0_0: HandleType;
  var ##a#1_1_1_1_0_0_1: Seq;
  var ##b#1_1_1_1_0_0_1: Seq;
  var ##less#1_1_1_1_0_0_1: HandleType;
  var ##a#1_1_1_1_0_1_0: Seq;
  var ##b#1_1_1_1_0_1_0: Seq;
  var ##less#1_1_1_1_0_1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "StandardLibrary.FindMinimum", " | ", StandardLibrary._default.FindMinimum$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(398,2): initial state"} true;
    $_reverifyPost := false;
    havoc a#1;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} $Is(a#1, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(a#1, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    assume true;
    goto anon2;

  anon26_Else:
    assume {:partition} !($Is(a#1, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(a#1, TSeq(StandardLibrary._default.FindMinimum$T), $Heap));
    goto anon2;

  anon2:
    assume ($Is(Lit(Seq#Empty(): Seq), TSeq(StandardLibrary._default.FindMinimum$T)) && s#0[$Box(Lit(Seq#Empty(): Seq))]) || (exists $as#a0#0: Seq :: $Is($as#a0#0, TSeq(StandardLibrary._default.FindMinimum$T)) && s#0[$Box($as#a0#0)]);
    defass#a#0 := true;
    havoc a#0;
    assume s#0[$Box(a#0)];
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(399,15)"} true;
    assume defass#a#0;
    assume true;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Set#Equal(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#0)));
    assume defass#a#0;
    assume true;
    a##0_0 := a#0;
    assume true;
    less##0_0 := less#0;
    call CallPre$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.FindMinimum$T, a##0_0, less##0_0);
    call CallPost$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.FindMinimum$T, a##0_0, less##0_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(401,29)"} true;
    goto anon25;

  anon27_Else:
    assume {:partition} !Set#Equal(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#0)));
    assume true;
    assume defass#a#0;
    assume true;
    s'#1_0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#0)));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(403,23)"} true;
    havoc x#1_0;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} $Is(x#1_0, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(x#1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    assume defass#a#0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} !Seq#Equal(x#1_0, a#0);
    goto anon7;

  anon29_Else:
    assume {:partition} Seq#Equal(x#1_0, a#0);
    goto anon7;

  anon28_Else:
    assume {:partition} !($Is(x#1_0, TSeq(StandardLibrary._default.FindMinimum$T)) && $IsAlloc(x#1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap));
    goto anon7;

  anon7:
    assume true;
    assume (forall x#1_1: Seq :: { s'#1_0[$Box(x#1_1)] } { s#0[$Box(x#1_1)] } $Is(x#1_1, TSeq(StandardLibrary._default.FindMinimum$T)) ==> (s#0[$Box(x#1_1)] <==> Seq#Equal(x#1_1, a#0) || s'#1_0[$Box(x#1_1)]));
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(404,54)"} true;
    assume true;
    assume true;
    s##1_0 := s'#1_0;
    assume true;
    less##1_0 := less#0;
    assume Set#Subset(s##1_0, s#0) && !Set#Subset(s#0, s##1_0);
    call CallPre$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T, s##1_0, less##1_0);
    call $rhs##1_0 := CallPost$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T, s##1_0, less##1_0);
    a'#1_0 := $rhs##1_0;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(405,37)"} true;
    assume defass#a#0;
    ##a#1_0 := a'#1_0;
    assume $IsAlloc(##a#1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##b#1_0 := a#0;
    assume $IsAlloc(##b#1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##less#1_0 := less#0;
    assume $IsAlloc(##less#1_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, a#0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, a#0, less#0);
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a'#1_0, a#0, less#0);
    assume true;
    assume true;
    a#0 := a'#1_0;
    defass#a#0 := true;
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(407,15)"} true;
    goto anon25;

  anon30_Else:
    assume {:partition} !StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a'#1_0, a#0, less#0);
    assume defass#a#0;
    ##a#1_1_0 := a#0;
    assume $IsAlloc(##a#1_1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##b#1_1_0 := a'#1_0;
    assume $IsAlloc(##b#1_1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##less#1_1_0 := less#0;
    assume $IsAlloc(##less#1_1_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    push;
    assume defass#a#0;
    assume true;
    a##1_1_0_0 := a#0;
    assume true;
    b##1_1_0_0 := a'#1_0;
    assume true;
    less##1_1_0_0 := less#0;
    call CallPre$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.FindMinimum$T, a##1_1_0_0, b##1_1_0_0, less##1_1_0_0);
    call CallPost$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.FindMinimum$T, a##1_1_0_0, b##1_1_0_0, less##1_1_0_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(410,33)"} true;
    pop;
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0) || (exists k#1_1_0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0, k#1_1_0) } LitInt(0) <= k#1_1_0 && k#1_1_0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0, k#1_1_0));
    assume false;
    goto anon11;

  anon31_Else:
    goto anon11;

  anon11:
    assume StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, a'#1_0, less#0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(411,8)"} true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    havoc z#1_1_1_0;
    assume $Is(z#1_1_1_0, TSeq(StandardLibrary._default.FindMinimum$T));
    assume true;
    assume s#0[$Box(z#1_1_1_0)];
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume defass#a#0;
    ##a#1_1_1_0 := a#0;
    assume $IsAlloc(##a#1_1_1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##b#1_1_1_0 := z#1_1_1_0;
    assume $IsAlloc(##b#1_1_1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##less#1_1_1_0 := less#0;
    assume $IsAlloc(##less#1_1_1_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0);
    assume false;
    goto anon14;

  anon33_Else:
    goto anon14;

  anon14:
    assume defass#a#0;
    assume true;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} Seq#Equal(z#1_1_1_0, a#0);
    assume defass#a#0;
    assume true;
    a##1_1_1_0_0 := a#0;
    assume true;
    less##1_1_1_0_0 := less#0;
    call CallPre$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.FindMinimum$T, a##1_1_1_0_0, less##1_1_1_0_0);
    call CallPost$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.FindMinimum$T, a##1_1_1_0_0, less##1_1_1_0_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(416,35)"} true;
    goto anon22;

  anon34_Else:
    assume {:partition} !Seq#Equal(z#1_1_1_0, a#0);
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume true;
    assume false;
    goto anon21;

  anon35_Else:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume true;
    assume true;
    assume {:subsumption 0} Lit(true) <==> s'#1_0[$Box(z#1_1_1_0)];
    assume false;
    goto anon21;

  anon36_Else:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume true;
    assume s'#1_0[$Box(z#1_1_1_0)];
    ##a#1_1_1_1_0_1_0 := a'#1_0;
    assume $IsAlloc(##a#1_1_1_1_0_1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##b#1_1_1_1_0_1_0 := z#1_1_1_0;
    assume $IsAlloc(##b#1_1_1_1_0_1_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##less#1_1_1_1_0_1_0 := less#0;
    assume $IsAlloc(##less#1_1_1_1_0_1_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0);
    assume {:subsumption 0} s'#1_0[$Box(z#1_1_1_0)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0) || (exists k#1_1_1_1_0_1_0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0, k#1_1_1_1_0_1_0) } LitInt(0) <= k#1_1_1_1_0_1_0 && k#1_1_1_1_0_1_0 <= Seq#Length(a'#1_0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0, k#1_1_1_1_0_1_0));
    assume false;
    goto anon21;

  anon37_Else:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    ##a#1_1_1_1_0_0_0 := a'#1_0;
    assume $IsAlloc(##a#1_1_1_1_0_0_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##b#1_1_1_1_0_0_0 := z#1_1_1_0;
    assume $IsAlloc(##b#1_1_1_1_0_0_0, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##less#1_1_1_1_0_0_0 := less#0;
    assume $IsAlloc(##less#1_1_1_1_0_0_0, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0);
    assume defass#a#0;
    assume true;
    a##1_1_1_1_0_0_0 := a#0;
    assume true;
    b##1_1_1_1_0_0_0 := a'#1_0;
    assume true;
    c##1_1_1_1_0_0_0 := z#1_1_1_0;
    assume true;
    less##1_1_1_1_0_0_0 := less#0;
    call CallPre$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.FindMinimum$T, a##1_1_1_1_0_0_0, b##1_1_1_1_0_0_0, c##1_1_1_1_0_0_0, less##1_1_1_1_0_0_0);
    call CallPost$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.FindMinimum$T, a##1_1_1_1_0_0_0, b##1_1_1_1_0_0_0, c##1_1_1_1_0_0_0, less##1_1_1_1_0_0_0);
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(424,50)"} true;
    assume defass#a#0;
    ##a#1_1_1_1_0_0_1 := a#0;
    assume $IsAlloc(##a#1_1_1_1_0_0_1, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##b#1_1_1_1_0_0_1 := z#1_1_1_0;
    assume $IsAlloc(##b#1_1_1_1_0_0_1, TSeq(StandardLibrary._default.FindMinimum$T), $Heap);
    ##less#1_1_1_1_0_0_1 := less#0;
    assume $IsAlloc(##less#1_1_1_1_0_0_1, Tclass._System.___hTotalFunc2(StandardLibrary._default.FindMinimum$T, StandardLibrary._default.FindMinimum$T, TBool), $Heap);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0);
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0);
    assume {:subsumption 0} StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a'#1_0, z#1_1_1_0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0) || (exists k#1_1_1_1_0_0_0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0, k#1_1_1_1_0_0_0) } LitInt(0) <= k#1_1_1_1_0_0_0 && k#1_1_1_1_0_0_0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0, k#1_1_1_1_0_0_0));
    assume false;
    goto anon21;

  anon38_Else:
    goto anon21;

  anon21:
    assume true ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0);
    goto anon22;

  anon22:
    assume StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0) || (exists k#1_1_1_0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0, k#1_1_1_0) } LitInt(0) <= k#1_1_1_0 && k#1_1_1_0 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_0, less#0, k#1_1_1_0));
    assume false;
    goto anon24;

  anon32_Else:
    assume (forall z#1_1_1_1: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_1, less#0) } { s#0[$Box(z#1_1_1_1)] } $Is(z#1_1_1_1, TSeq(StandardLibrary._default.FindMinimum$T)) && s#0[$Box(z#1_1_1_1)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.FindMinimum$T, a#0, z#1_1_1_1, less#0));
    goto anon24;

  anon24:
    assume {:captureState "StandardLibrary/src/StandardLibrary.dfy(428,8)"} true;
    goto anon25;

  anon25:
    assume defass#a#0;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#8 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#8))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#10 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#10)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#12 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#12))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#14 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#14)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#16 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#16)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#12 := Wrappers.Option.value(this); v#12)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#14 := Lit(Wrappers.Option.value(Lit(this))); v#14)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#16 := Lit(Wrappers.Option.value(Lit(this))); v#16)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#8 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#8)) else (var e#8 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#10 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#10))) else (var e#10 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#12 := Wrappers.Result.value(this); s#12) else (var e#12 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#14 := Lit(Wrappers.Result.value(Lit(this))); s#14) else (var e#14 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#16 := Lit(Wrappers.Result.value(Lit(this))); s#16) else (var e#16 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#12 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#12)) else (var e#12 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#12)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#14 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#14))) else (var e#14 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#14)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#16 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#16))) else (var e#16 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#16)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#6 := Div(x#0, LitInt(256)); (var b1#6 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#6)), $Box(b1#6)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#7 := LitInt(Div(x#0, LitInt(256))); (var b1#7 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#7)), $Box(b1#7))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#6 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#6 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#7 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#7 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#6 := Div(x#0, LitInt(16777216)); (var x0#6 := x#0 - Mul(b0#6, LitInt(16777216)); (var b1#6 := Div(x0#6, LitInt(65536)); (var x1#6 := x0#6 - Mul(b1#6, LitInt(65536)); (var b2#6 := Div(x1#6, LitInt(256)); (var b3#6 := Mod(x1#6, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#6)), $Box(b1#6)), $Box(b2#6)), $Box(b3#6)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#7 := LitInt(Div(x#0, LitInt(16777216))); (var x0#7 := LitInt(x#0 - Mul(b0#7, LitInt(16777216))); (var b1#7 := LitInt(Div(x0#7, LitInt(65536))); (var x1#7 := LitInt(x0#7 - Mul(b1#7, LitInt(65536))); (var b2#7 := LitInt(Div(x1#7, LitInt(256))); (var b3#7 := LitInt(Mod(x1#7, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#7)), $Box(b1#7)), $Box(b2#7)), $Box(b3#7))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#6 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#6 := x0#6 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#6 := x1#6 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#6 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#7 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#7 := x0#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#7 := x1#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#7 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#6 := Div(x#0, LitInt(72057594037927936)); (var x0#6 := x#0 - Mul(b0#6, LitInt(72057594037927936)); (var b1#6 := Div(x0#6, LitInt(281474976710656)); (var x1#6 := x0#6 - Mul(b1#6, LitInt(281474976710656)); (var b2#6 := Div(x1#6, LitInt(1099511627776)); (var x2#6 := x1#6 - Mul(b2#6, LitInt(1099511627776)); (var b3#6 := Div(x2#6, LitInt(4294967296)); (var x3#6 := x2#6 - Mul(b3#6, LitInt(4294967296)); (var b4#6 := Div(x3#6, LitInt(16777216)); (var x4#6 := x3#6 - Mul(b4#6, LitInt(16777216)); (var b5#6 := Div(x4#6, LitInt(65536)); (var x5#6 := x4#6 - Mul(b5#6, LitInt(65536)); (var b6#6 := Div(x5#6, LitInt(256)); (var b7#6 := Mod(x5#6, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#6)), $Box(b1#6)), $Box(b2#6)), $Box(b3#6)), $Box(b4#6)), $Box(b5#6)), $Box(b6#6)), $Box(b7#6)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#7 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#7 := LitInt(x#0 - Mul(b0#7, LitInt(72057594037927936))); (var b1#7 := LitInt(Div(x0#7, LitInt(281474976710656))); (var x1#7 := LitInt(x0#7 - Mul(b1#7, LitInt(281474976710656))); (var b2#7 := LitInt(Div(x1#7, LitInt(1099511627776))); (var x2#7 := LitInt(x1#7 - Mul(b2#7, LitInt(1099511627776))); (var b3#7 := LitInt(Div(x2#7, LitInt(4294967296))); (var x3#7 := LitInt(x2#7 - Mul(b3#7, LitInt(4294967296))); (var b4#7 := LitInt(Div(x3#7, LitInt(16777216))); (var x4#7 := LitInt(x3#7 - Mul(b4#7, LitInt(16777216))); (var b5#7 := LitInt(Div(x4#7, LitInt(65536))); (var x5#7 := LitInt(x4#7 - Mul(b5#7, LitInt(65536))); (var b6#7 := LitInt(Div(x5#7, LitInt(256))); (var b7#7 := LitInt(Mod(x5#7, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#7)), $Box(b1#7)), $Box(b2#7)), $Box(b3#7)), $Box(b4#7)), $Box(b5#7)), $Box(b6#7)), $Box(b7#7))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#6 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#6 := x0#6 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#6 := x1#6 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#6 := x2#6 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#6 := x3#6 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#6 := x4#6 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#6 := x5#6 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#7 := x6#6 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#7)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#7 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#7 := x0#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#7 := x1#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#7 := x2#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#7 := x3#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#7 := x4#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#7 := x5#7 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#8 := x6#7 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#8)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#6 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#6)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#6 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#6)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#6)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#7 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#7)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#7 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#7)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#7)): int)));

axiom (forall n#0: int, chars#0: Seq :: { String.__default.Int2String(n#0, chars#0) } String.__default.Int2String#canCall(n#0, chars#0) || ($Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> $Is(String.__default.Int2String(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int :: { String.__default.Base10Int2String(n#0) } $Is(String.__default.Base10Int2String(n#0), TSeq(TChar)));

const reveal_UTF8._default.EncodeAscii: bool;

const unique class.UTF8.__default: ClassName;

function UTF8.__default.Encode(s#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.Encode(s#0) } UTF8.__default.Encode#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (UTF8.__default.IsASCIIString(s#0) ==> Wrappers.Result.Success_q(UTF8.__default.Encode(s#0)) && Seq#Length($Unbox(Wrappers.Result.value(UTF8.__default.Encode(s#0))): Seq) == Seq#Length(s#0)) && (Wrappers.Result.Success_q(UTF8.__default.Encode(s#0)) ==> Wrappers.Result.Success_q(UTF8.__default.Decode($Unbox(Wrappers.Result.value(UTF8.__default.Encode(s#0))): Seq)) && Seq#Equal($Unbox(Wrappers.Result.value(UTF8.__default.Decode($Unbox(Wrappers.Result.value(UTF8.__default.Encode(s#0))): Seq))): Seq, s#0)) && $Is(UTF8.__default.Encode(s#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));
}

function UTF8.__default.Encode#canCall(s#0: Seq) : bool;

function Tclass.UTF8.ValidUTF8Bytes() : Ty
uses {
axiom Tag(Tclass.UTF8.ValidUTF8Bytes()) == Tagclass.UTF8.ValidUTF8Bytes && TagFamily(Tclass.UTF8.ValidUTF8Bytes()) == tytagFamily$ValidUTF8Bytes;
}

const unique Tagclass.UTF8.ValidUTF8Bytes: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.UTF8.ValidUTF8Bytes()) } $IsBox(bx, Tclass.UTF8.ValidUTF8Bytes()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.UTF8.ValidUTF8Bytes()));

function UTF8.__default.Encode#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.Encode#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.Encode#requires(s#0) <==> true));

procedure {:verboseName "UTF8.Encode (well-formedness)"} {:extern} CheckWellformed$$UTF8.__default.Encode(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2717"} UTF8.__default.IsASCIIString(s#0) ==> Wrappers.Result.Success_q(res#0);
  free ensures {:id "id2718"} UTF8.__default.IsASCIIString(s#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Seq#Length(s#0);
  free ensures {:id "id2719"} Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.Success_q(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq));
  free ensures {:id "id2720"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq))): Seq, s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.Encode (well-formedness)"} {:extern} CheckWellformed$$UTF8.__default.Encode(s#0: Seq) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##b#0: Seq;
  var ##b#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.Encode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(25,37): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(UTF8.__default.Encode(s#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar)));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(s#0);
    assume UTF8.__default.IsASCIIString(s#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Seq#Length(s#0);
    goto anon5;

  anon11_Else:
    assume UTF8.__default.IsASCIIString(s#0) ==> Wrappers.Result.Success_q(res#0) && Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Seq#Length(s#0);
    goto anon5;

  anon5:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    ##b#0 := $Unbox(Wrappers.Result.value(res#0)): Seq;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UTF8.__default.Decode#canCall($Unbox(Wrappers.Result.value(res#0)): Seq);
    assume Wrappers.Result.Success_q(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq));
    assume Wrappers.Result.Success_q(res#0);
    ##b#1 := $Unbox(Wrappers.Result.value(res#0)): Seq;
    assume $IsAlloc(##b#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UTF8.__default.Decode#canCall($Unbox(Wrappers.Result.value(res#0)): Seq);
    assume Wrappers.Result.Success_q(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq));
    assume Seq#Equal($Unbox(Wrappers.Result.value(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq))): Seq, s#0);
    goto anon8;

  anon12_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.Success_q(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq)) && Seq#Equal($Unbox(Wrappers.Result.value(UTF8.__default.Decode($Unbox(Wrappers.Result.value(res#0)): Seq))): Seq, s#0);
    goto anon8;

  anon8:
    assume false;
    return;

  anon10_Else:
    assume false;
    return;
}



function UTF8.__default.Decode(b#0: Seq) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall b#0: Seq :: { UTF8.__default.Decode(b#0) } UTF8.__default.Decode#canCall(b#0) || (3 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Wrappers.Result.Success_q(UTF8.__default.Decode(b#0)) ==> UTF8.__default.ValidUTF8Seq(b#0)) && $Is(UTF8.__default.Decode(b#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
}

function UTF8.__default.Decode#canCall(b#0: Seq) : bool;

function UTF8.__default.Decode#requires(Seq) : bool;

axiom (forall b#0: Seq :: { UTF8.__default.Decode#requires(b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UTF8.__default.Decode#requires(b#0) <==> true));

procedure {:verboseName "UTF8.Decode (well-formedness)"} {:extern} CheckWellformed$$UTF8.__default.Decode(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2733"} Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq#canCall(b#0) ==> UTF8.__default.ValidUTF8Seq(b#0) || (UTF8.__default.ValidUTF8Range#canCall(b#0, LitInt(0), Seq#Length(b#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), b#0, LitInt(0), Seq#Length(b#0)) || (LitInt(0) == Seq#Length(b#0) ==> Lit(true)));
  free ensures {:id "id2734"} Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq#canCall(b#0) ==> UTF8.__default.ValidUTF8Seq(b#0) || (UTF8.__default.ValidUTF8Range#canCall(b#0, LitInt(0), Seq#Length(b#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), b#0, LitInt(0), Seq#Length(b#0)) || (LitInt(0) != Seq#Length(b#0) ==> (var r#0 := Seq#Drop(Seq#Take(b#0, Seq#Length(b#0)), LitInt(0)); UTF8.__default.Uses1Byte(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), b#0, LitInt(0 + 1), Seq#Length(b#0)))));
  free ensures {:id "id2735"} Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq#canCall(b#0) ==> UTF8.__default.ValidUTF8Seq(b#0) || (UTF8.__default.ValidUTF8Range#canCall(b#0, LitInt(0), Seq#Length(b#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), b#0, LitInt(0), Seq#Length(b#0)) || (LitInt(0) != Seq#Length(b#0) ==> (var r#0 := Seq#Drop(Seq#Take(b#0, Seq#Length(b#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), b#0, LitInt(0 + 2), Seq#Length(b#0)))));
  free ensures {:id "id2736"} Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq#canCall(b#0) ==> UTF8.__default.ValidUTF8Seq(b#0) || (UTF8.__default.ValidUTF8Range#canCall(b#0, LitInt(0), Seq#Length(b#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), b#0, LitInt(0), Seq#Length(b#0)) || (LitInt(0) != Seq#Length(b#0) ==> (var r#0 := Seq#Drop(Seq#Take(b#0, Seq#Length(b#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), b#0, LitInt(0 + 3), Seq#Length(b#0)))));
  free ensures {:id "id2737"} Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq#canCall(b#0) ==> UTF8.__default.ValidUTF8Seq(b#0) || (UTF8.__default.ValidUTF8Range#canCall(b#0, LitInt(0), Seq#Length(b#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), b#0, LitInt(0), Seq#Length(b#0)) || (LitInt(0) != Seq#Length(b#0) ==> (var r#0 := Seq#Drop(Seq#Take(b#0, Seq#Length(b#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), b#0, LitInt(0 + 4), Seq#Length(b#0)))));
  free ensures {:id "id2738"} Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq#canCall(b#0) ==> UTF8.__default.ValidUTF8Seq(b#0) || (UTF8.__default.ValidUTF8Range#canCall(b#0, LitInt(0), Seq#Length(b#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), b#0, LitInt(0), Seq#Length(b#0)) || (LitInt(0) != Seq#Length(b#0) ==> (var r#0 := Seq#Drop(Seq#Take(b#0, Seq#Length(b#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> !(LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0)) ==> Lit(false))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.Decode (well-formedness)"} {:extern} CheckWellformed$$UTF8.__default.Decode(b#0: Seq) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.Decode", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(33,37): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(UTF8.__default.Decode(b#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar)));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(res#0);
    ##s#0 := b#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UTF8.__default.ValidUTF8Seq#canCall(b#0);
    assume UTF8.__default.ValidUTF8Seq(b#0);
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(res#0) ==> UTF8.__default.ValidUTF8Seq(b#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



function UTF8.__default.CreateEncodeSuccess(bytes#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { UTF8.__default.CreateEncodeSuccess(bytes#0) } UTF8.__default.CreateEncodeSuccess#canCall(bytes#0) || (4 < $FunctionContextHeight && $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes())) ==> $Is(UTF8.__default.CreateEncodeSuccess(bytes#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));
axiom 4 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { UTF8.__default.CreateEncodeSuccess(bytes#0) } UTF8.__default.CreateEncodeSuccess#canCall(bytes#0) || (4 < $FunctionContextHeight && $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes())) ==> UTF8.__default.CreateEncodeSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));
axiom 4 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: {:weight 3} { UTF8.__default.CreateEncodeSuccess(Lit(bytes#0)) } UTF8.__default.CreateEncodeSuccess#canCall(Lit(bytes#0)) || (4 < $FunctionContextHeight && $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes())) ==> UTF8.__default.CreateEncodeSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));
}

function UTF8.__default.CreateEncodeSuccess#canCall(bytes#0: Seq) : bool;

function UTF8.__default.CreateEncodeSuccess#requires(Seq) : bool;

axiom (forall bytes#0: Seq :: { UTF8.__default.CreateEncodeSuccess#requires(bytes#0) } $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes()) ==> (UTF8.__default.CreateEncodeSuccess#requires(bytes#0) <==> true));

procedure {:verboseName "UTF8.CreateEncodeSuccess (well-formedness)"} CheckWellformed$$UTF8.__default.CreateEncodeSuccess(bytes#0: Seq where $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function UTF8.__default.CreateEncodeFailure(error#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UTF8.__default.CreateEncodeFailure(error#0) } UTF8.__default.CreateEncodeFailure#canCall(error#0) || (4 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> $Is(UTF8.__default.CreateEncodeFailure(error#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));
axiom 4 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UTF8.__default.CreateEncodeFailure(error#0) } UTF8.__default.CreateEncodeFailure#canCall(error#0) || (4 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UTF8.__default.CreateEncodeFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 4 <= $FunctionContextHeight ==> (forall error#0: Seq :: {:weight 3} { UTF8.__default.CreateEncodeFailure(Lit(error#0)) } UTF8.__default.CreateEncodeFailure#canCall(Lit(error#0)) || (4 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UTF8.__default.CreateEncodeFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function UTF8.__default.CreateEncodeFailure#canCall(error#0: Seq) : bool;

function UTF8.__default.CreateEncodeFailure#requires(Seq) : bool;

axiom (forall error#0: Seq :: { UTF8.__default.CreateEncodeFailure#requires(error#0) } $Is(error#0, TSeq(TChar)) ==> (UTF8.__default.CreateEncodeFailure#requires(error#0) <==> true));

procedure {:verboseName "UTF8.CreateEncodeFailure (well-formedness)"} CheckWellformed$$UTF8.__default.CreateEncodeFailure(error#0: Seq where $Is(error#0, TSeq(TChar)));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function UTF8.__default.CreateDecodeSuccess(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.CreateDecodeSuccess(s#0) } UTF8.__default.CreateDecodeSuccess#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(UTF8.__default.CreateDecodeSuccess(s#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.CreateDecodeSuccess(s#0) } UTF8.__default.CreateDecodeSuccess#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> UTF8.__default.CreateDecodeSuccess(s#0) == #Wrappers.Result.Success($Box(s#0)));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.CreateDecodeSuccess(Lit(s#0)) } UTF8.__default.CreateDecodeSuccess#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> UTF8.__default.CreateDecodeSuccess(Lit(s#0)) == Lit(#Wrappers.Result.Success($Box(Lit(s#0)))));
}

function UTF8.__default.CreateDecodeSuccess#canCall(s#0: Seq) : bool;

function UTF8.__default.CreateDecodeSuccess#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.CreateDecodeSuccess#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.CreateDecodeSuccess#requires(s#0) <==> true));

procedure {:verboseName "UTF8.CreateDecodeSuccess (well-formedness)"} CheckWellformed$$UTF8.__default.CreateDecodeSuccess(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function UTF8.__default.CreateDecodeFailure(error#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UTF8.__default.CreateDecodeFailure(error#0) } UTF8.__default.CreateDecodeFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> $Is(UTF8.__default.CreateDecodeFailure(error#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UTF8.__default.CreateDecodeFailure(error#0) } UTF8.__default.CreateDecodeFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UTF8.__default.CreateDecodeFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: {:weight 3} { UTF8.__default.CreateDecodeFailure(Lit(error#0)) } UTF8.__default.CreateDecodeFailure#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UTF8.__default.CreateDecodeFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function UTF8.__default.CreateDecodeFailure#canCall(error#0: Seq) : bool;

function UTF8.__default.CreateDecodeFailure#requires(Seq) : bool;

axiom (forall error#0: Seq :: { UTF8.__default.CreateDecodeFailure#requires(error#0) } $Is(error#0, TSeq(TChar)) ==> (UTF8.__default.CreateDecodeFailure#requires(error#0) <==> true));

procedure {:verboseName "UTF8.CreateDecodeFailure (well-formedness)"} CheckWellformed$$UTF8.__default.CreateDecodeFailure(error#0: Seq where $Is(error#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function UTF8.__default.IsASCIIString(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#1)): char) < 128)));
}

function UTF8.__default.IsASCIIString#canCall(s#0: Seq) : bool;

function UTF8.__default.IsASCIIString#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString#requires(s#0) <==> true));

procedure {:verboseName "UTF8.IsASCIIString (well-formedness)"} CheckWellformed$$UTF8.__default.IsASCIIString(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.IsASCIIString (well-formedness)"} CheckWellformed$$UTF8.__default.IsASCIIString(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.IsASCIIString", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(57,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    havoc i#2;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon6;

  anon11_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon6;

  anon6:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    goto anon8;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(s#0));
    goto anon8;

  anon10_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume UTF8.__default.IsASCIIString(s#0) <==> (forall i#3: int :: { $Unbox(Seq#Index(s#0, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128);
    assume true;
    assume $Is(UTF8.__default.IsASCIIString(s#0), TBool);
    return;
}



function UTF8.__default.EncodeAscii($ly: LayerType, $reveal: bool, s#0: Seq) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#0: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#0)): int } { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#0)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#0, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#1 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#1, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));
}

function UTF8.__default.EncodeAscii#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), $reveal, s#0) } UTF8.__default.EncodeAscii($LS($ly), $reveal, s#0) == UTF8.__default.EncodeAscii($ly, $reveal, s#0));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii(AsFuelBottom($ly), $reveal, s#0) } UTF8.__default.EncodeAscii($ly, $reveal, s#0) == UTF8.__default.EncodeAscii($LZ, $reveal, s#0));

function UTF8.__default.EncodeAscii#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii#requires($ly, s#0) } $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.EncodeAscii#requires($ly, s#0) <==> UTF8.__default.IsASCIIString(s#0)));

procedure {:verboseName "UTF8.EncodeAscii (well-formedness)"} CheckWellformed$$UTF8.__default.EncodeAscii(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (ret#0: Seq where $Is(ret#0, Tclass.UTF8.ValidUTF8Bytes()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id2748"} Seq#Length(s#0) == Seq#Length(ret#0);
  free ensures {:id "id2749"} (forall i#1: int :: { $Unbox(Seq#Index(ret#0, i#1)): int } { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) == $Unbox(Seq#Index(ret#0, i#1)): int);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.EncodeAscii (well-formedness)"} CheckWellformed$$UTF8.__default.EncodeAscii(s#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var i#2: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var x#Z#0: Seq;
  var let#0#0#0: Seq;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var ##s#1: Seq;
  var s##0: Seq;
  var t##0: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.EncodeAscii", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(62,45): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(s#0);
    assume UTF8.__default.IsASCIIString(s#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, s#0), Tclass.UTF8.ValidUTF8Bytes());
    assume Seq#Length(s#0) == Seq#Length(ret#0);
    havoc i#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon5;

  anon14_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    newtype$check#0 := char#ToInt($Unbox(Seq#Index(s#0, i#2)): char);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt($Unbox(Seq#Index(s#0, i#2)): char);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= i#2 && i#2 < Seq#Length(ret#0);
    assume char#ToInt($Unbox(Seq#Index(s#0, i#2)): char) == $Unbox(Seq#Index(ret#0, i#2)): int;
    goto anon7;

  anon13_Else:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#2)): char) == $Unbox(Seq#Index(ret#0, i#2)): int;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { $Unbox(Seq#Index(ret#0, i#1)): int } { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) == $Unbox(Seq#Index(ret#0, i#1)): int);
    assume false;
    return;

  anon12_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.UTF8.ValidUTF8Bytes());
    assume UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, s#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, s#0), Tclass.UTF8.ValidUTF8Bytes());
    goto anon11;

  anon15_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    havoc x#Z#0;
    assume $Is(x#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#2 := char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0#0#0 == Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char)));
    assume true;
    assume $Is(let#0#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume x#Z#0 == let#0#0#0;
    ##s#1 := x#Z#0;
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UTF8.__default.ValidUTF8Seq#canCall(x#Z#0);
    assume UTF8.__default.ValidUTF8Seq#canCall(x#Z#0);
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(x#Z#0) ==> UTF8.__default.ValidUTF8Seq(x#Z#0) || (UTF8.__default.ValidUTF8Range#canCall(x#Z#0, LitInt(0), Seq#Length(x#Z#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), x#Z#0, LitInt(0), Seq#Length(x#Z#0)) || (LitInt(0) == Seq#Length(x#Z#0) ==> Lit(true)));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(x#Z#0) ==> UTF8.__default.ValidUTF8Seq(x#Z#0) || (UTF8.__default.ValidUTF8Range#canCall(x#Z#0, LitInt(0), Seq#Length(x#Z#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), x#Z#0, LitInt(0), Seq#Length(x#Z#0)) || (LitInt(0) != Seq#Length(x#Z#0) ==> (var r#0 := Seq#Drop(Seq#Take(x#Z#0, Seq#Length(x#Z#0)), LitInt(0)); UTF8.__default.Uses1Byte(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), x#Z#0, LitInt(0 + 1), Seq#Length(x#Z#0)))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(x#Z#0) ==> UTF8.__default.ValidUTF8Seq(x#Z#0) || (UTF8.__default.ValidUTF8Range#canCall(x#Z#0, LitInt(0), Seq#Length(x#Z#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), x#Z#0, LitInt(0), Seq#Length(x#Z#0)) || (LitInt(0) != Seq#Length(x#Z#0) ==> (var r#0 := Seq#Drop(Seq#Take(x#Z#0, Seq#Length(x#Z#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), x#Z#0, LitInt(0 + 2), Seq#Length(x#Z#0)))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(x#Z#0) ==> UTF8.__default.ValidUTF8Seq(x#Z#0) || (UTF8.__default.ValidUTF8Range#canCall(x#Z#0, LitInt(0), Seq#Length(x#Z#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), x#Z#0, LitInt(0), Seq#Length(x#Z#0)) || (LitInt(0) != Seq#Length(x#Z#0) ==> (var r#0 := Seq#Drop(Seq#Take(x#Z#0, Seq#Length(x#Z#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), x#Z#0, LitInt(0 + 3), Seq#Length(x#Z#0)))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(x#Z#0) ==> UTF8.__default.ValidUTF8Seq(x#Z#0) || (UTF8.__default.ValidUTF8Range#canCall(x#Z#0, LitInt(0), Seq#Length(x#Z#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), x#Z#0, LitInt(0), Seq#Length(x#Z#0)) || (LitInt(0) != Seq#Length(x#Z#0) ==> (var r#0 := Seq#Drop(Seq#Take(x#Z#0, Seq#Length(x#Z#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), x#Z#0, LitInt(0 + 4), Seq#Length(x#Z#0)))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(x#Z#0) ==> UTF8.__default.ValidUTF8Seq(x#Z#0) || (UTF8.__default.ValidUTF8Range#canCall(x#Z#0, LitInt(0), Seq#Length(x#Z#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), x#Z#0, LitInt(0), Seq#Length(x#Z#0)) || (LitInt(0) != Seq#Length(x#Z#0) ==> (var r#0 := Seq#Drop(Seq#Take(x#Z#0, Seq#Length(x#Z#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> !(LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0)) ==> Lit(false))));
    assume UTF8.__default.ValidUTF8Seq(x#Z#0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(71,28)"} true;
    assume true;
    s##0 := x#Z#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#2 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#2) ==> UTF8.__default.IsASCIIString(##s#2) || (forall i#3: int :: { $Unbox(Seq#Index(##s#2, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#2) ==> char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#2);
    assume Seq#Rank(##s#2) < Seq#Rank(s#0);
    assume UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)));
    assume UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)));
    t##0 := UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)));
    call CallPre$$UTF8.__default.ValidUTF8Concat(s##0, t##0);
    call CallPost$$UTF8.__default.ValidUTF8Concat(s##0, t##0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(72,44)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#3 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#3) ==> UTF8.__default.IsASCIIString(##s#3) || (forall i#4: int :: { $Unbox(Seq#Index(##s#3, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##s#3) ==> char#ToInt($Unbox(Seq#Index(##s#3, i#4)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#3);
    assume Seq#Rank(##s#3) < Seq#Rank(s#0);
    assume UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)));
    assume $Is(Seq#Append(x#Z#0, UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))), Tclass.UTF8.ValidUTF8Bytes());
    assume UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, s#0) == Seq#Append(x#Z#0, UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1))));
    assume UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)));
    assume $Is(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, s#0), Tclass.UTF8.ValidUTF8Bytes());
    goto anon11;

  anon11:
    assume UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, s#0) == ret#0;
    return;
}



procedure {:verboseName "UTF8.EncodeAsciiUnique2 (well-formedness)"} CheckWellFormed$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.EncodeAsciiUnique2 (well-formedness)"} CheckWellFormed$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq, y#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.EncodeAsciiUnique2", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(77,8): initial state"} true;
    ##s#0 := x#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(x#0);
    assume UTF8.__default.IsASCIIString(x#0);
    ##s#1 := y#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(y#0);
    assume UTF8.__default.IsASCIIString(y#0);
    assume !Seq#Equal(x#0, y#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(80,27): post-state"} true;
    ##s#2 := x#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#2) ==> UTF8.__default.IsASCIIString(##s#2) || (forall i#0: int :: { $Unbox(Seq#Index(##s#2, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#2) ==> char#ToInt($Unbox(Seq#Index(##s#2, i#0)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#2);
    assume UTF8.__default.EncodeAscii#canCall(x#0);
    ##s#3 := y#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#3) ==> UTF8.__default.IsASCIIString(##s#3) || (forall i#1: int :: { $Unbox(Seq#Index(##s#3, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#3) ==> char#ToInt($Unbox(Seq#Index(##s#3, i#1)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#3);
    assume UTF8.__default.EncodeAscii#canCall(y#0);
    assume !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    return;
}



procedure {:verboseName "UTF8.EncodeAsciiUnique2 (call precondtion)"} CallPre$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap));
  requires {:id "id2791"} UTF8.__default.IsASCIIString#canCall(x#0) ==> UTF8.__default.IsASCIIString(x#0) || (forall i#2: int :: { $Unbox(Seq#Index(x#0, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(x#0) ==> char#ToInt($Unbox(Seq#Index(x#0, i#2)): char) < 128);
  requires {:id "id2792"} UTF8.__default.IsASCIIString#canCall(y#0) ==> UTF8.__default.IsASCIIString(y#0) || (forall i#3: int :: { $Unbox(Seq#Index(y#0, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(y#0) ==> char#ToInt($Unbox(Seq#Index(y#0, i#3)): char) < 128);
  requires {:id "id2793"} !Seq#Equal(x#0, y#0);



procedure {:verboseName "UTF8.EncodeAsciiUnique2 (call postcondition)"} CallPost$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures UTF8.__default.EncodeAscii#canCall(x#0) && UTF8.__default.EncodeAscii#canCall(y#0);
  free ensures {:id "id2794"} !Seq#Equal(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UTF8.EncodeAsciiUnique2 (correctness)"} Impl$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  free requires {:id "id2795"} UTF8.__default.IsASCIIString#canCall(x#0) && UTF8.__default.IsASCIIString(x#0) && (forall i#4: int :: { $Unbox(Seq#Index(x#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(x#0) ==> char#ToInt($Unbox(Seq#Index(x#0, i#4)): char) < 128);
  free requires {:id "id2796"} UTF8.__default.IsASCIIString#canCall(y#0) && UTF8.__default.IsASCIIString(y#0) && (forall i#5: int :: { $Unbox(Seq#Index(y#0, i#5)): char } LitInt(0) <= i#5 && i#5 < Seq#Length(y#0) ==> char#ToInt($Unbox(Seq#Index(y#0, i#5)): char) < 128);
  requires {:id "id2797"} !Seq#Equal(x#0, y#0);
  modifies $Heap;
  free ensures UTF8.__default.EncodeAscii#canCall(x#0) && UTF8.__default.EncodeAscii#canCall(y#0);
  free ensures {:id "id2798"} !Seq#Equal(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.EncodeAsciiUnique2 (correctness)"} Impl$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq, y#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##s#4: Seq;
  var ##s#5: Seq;
  var ##s#0_0: Seq;
  var ##s#0_1: Seq;
  var ##s#0_1_0: Seq;
  var ##s#0_1_1: Seq;
  var ##s#0_1_0_0: Seq;
  var ##s#0_1_0_1: Seq;
  var x##0_1_0_0_0: Seq;
  var y##0_1_0_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.EncodeAsciiUnique2", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(81,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq, $ih#y0#0: Seq :: $Is($ih#x0#0, TSeq(TChar)) && $Is($ih#y0#0, TSeq(TChar)) && UTF8.__default.IsASCIIString($ih#x0#0) && UTF8.__default.IsASCIIString($ih#y0#0) && !Seq#Equal($ih#x0#0, $ih#y0#0) && (Seq#Rank($ih#x0#0) < Seq#Rank(x#0) || (Seq#Rank($ih#x0#0) == Seq#Rank(x#0) && Seq#Rank($ih#y0#0) < Seq#Rank(y#0))) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, $ih#x0#0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, $ih#y0#0)));
    $_reverifyPost := false;
    call CallPre$$UTF8.__default.reveal__EncodeAscii();
    call CallPost$$UTF8.__default.reveal__EncodeAscii();
    assume {:captureState "StandardLibrary/src/UTF8.dfy(82,23)"} true;
    ##s#4 := x#0;
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#4) ==> UTF8.__default.IsASCIIString(##s#4) || (forall i#6: int :: { $Unbox(Seq#Index(##s#4, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(##s#4) ==> char#ToInt($Unbox(Seq#Index(##s#4, i#6)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#4);
    assume UTF8.__default.EncodeAscii#canCall(x#0);
    ##s#5 := y#0;
    assume $IsAlloc(##s#5, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#5) ==> UTF8.__default.IsASCIIString(##s#5) || (forall i#7: int :: { $Unbox(Seq#Index(##s#5, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(##s#5) ==> char#ToInt($Unbox(Seq#Index(##s#5, i#7)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#5);
    assume UTF8.__default.EncodeAscii#canCall(y#0);
    assume UTF8.__default.EncodeAscii#canCall(x#0) && UTF8.__default.EncodeAscii#canCall(y#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    ##s#0_0 := x#0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_0) ==> UTF8.__default.IsASCIIString(##s#0_0) || (forall i#0_0: int :: { $Unbox(Seq#Index(##s#0_0, i#0_0)): char } LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(##s#0_0) ==> char#ToInt($Unbox(Seq#Index(##s#0_0, i#0_0)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#0_0);
    assume UTF8.__default.EncodeAscii#canCall(x#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0)) == LitInt(0);
    ##s#0_1 := y#0;
    assume $IsAlloc(##s#0_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_1) ==> UTF8.__default.IsASCIIString(##s#0_1) || (forall i#0_1: int :: { $Unbox(Seq#Index(##s#0_1, i#0_1)): char } LitInt(0) <= i#0_1 && i#0_1 < Seq#Length(##s#0_1) ==> char#ToInt($Unbox(Seq#Index(##s#0_1, i#0_1)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#0_1);
    assume UTF8.__default.EncodeAscii#canCall(y#0);
    goto anon3;

  anon12_Else:
    assume {:partition} Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0)) != LitInt(0);
    goto anon3;

  anon3:
    assume UTF8.__default.EncodeAscii#canCall(x#0) && (Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0)) == LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(y#0));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0)) == LitInt(0) && Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0)) == LitInt(0);
    return;

  anon13_Else:
    assume {:partition} !(Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0)) == LitInt(0) && Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0)) == LitInt(0));
    ##s#0_1_0 := x#0;
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_1_0) ==> UTF8.__default.IsASCIIString(##s#0_1_0) || (forall i#0_1_0: int :: { $Unbox(Seq#Index(##s#0_1_0, i#0_1_0)): char } LitInt(0) <= i#0_1_0 && i#0_1_0 < Seq#Length(##s#0_1_0) ==> char#ToInt($Unbox(Seq#Index(##s#0_1_0, i#0_1_0)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#0_1_0);
    assume UTF8.__default.EncodeAscii#canCall(x#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0));
    ##s#0_1_1 := y#0;
    assume $IsAlloc(##s#0_1_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_1_1) ==> UTF8.__default.IsASCIIString(##s#0_1_1) || (forall i#0_1_1: int :: { $Unbox(Seq#Index(##s#0_1_1, i#0_1_1)): char } LitInt(0) <= i#0_1_1 && i#0_1_1 < Seq#Length(##s#0_1_1) ==> char#ToInt($Unbox(Seq#Index(##s#0_1_1, i#0_1_1)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#0_1_1);
    assume UTF8.__default.EncodeAscii#canCall(y#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    assume UTF8.__default.EncodeAscii#canCall(x#0) && UTF8.__default.EncodeAscii#canCall(y#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Unbox(Seq#Index(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), LitInt(0))): int == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0), LitInt(0))): int;
    ##s#0_1_0_0 := x#0;
    assume $IsAlloc(##s#0_1_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_1_0_0) ==> UTF8.__default.IsASCIIString(##s#0_1_0_0) || (forall i#0_1_0_0: int :: { $Unbox(Seq#Index(##s#0_1_0_0, i#0_1_0_0)): char } LitInt(0) <= i#0_1_0_0 && i#0_1_0_0 < Seq#Length(##s#0_1_0_0) ==> char#ToInt($Unbox(Seq#Index(##s#0_1_0_0, i#0_1_0_0)): char) < 128);
    assume UTF8.__default.EncodeAscii#canCall(x#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0));
    ##s#0_1_0_1 := y#0;
    assume $IsAlloc(##s#0_1_0_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_1_0_1) ==> UTF8.__default.IsASCIIString(##s#0_1_0_1) || (forall i#0_1_0_1: int :: { $Unbox(Seq#Index(##s#0_1_0_1, i#0_1_0_1)): char } LitInt(0) <= i#0_1_0_1 && i#0_1_0_1 < Seq#Length(##s#0_1_0_1) ==> char#ToInt($Unbox(Seq#Index(##s#0_1_0_1, i#0_1_0_1)): char) < 128);
    assume UTF8.__default.EncodeAscii#canCall(y#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    assume UTF8.__default.EncodeAscii#canCall(x#0) && UTF8.__default.EncodeAscii#canCall(y#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(x#0);
    assume true;
    x##0_1_0_0_0 := Seq#Drop(x#0, LitInt(1));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(y#0);
    assume true;
    y##0_1_0_0_0 := Seq#Drop(y#0, LitInt(1));
    assume Seq#Rank(x##0_1_0_0_0) < Seq#Rank(x#0) || (Seq#Rank(x##0_1_0_0_0) == Seq#Rank(x#0) && Seq#Rank(y##0_1_0_0_0) < Seq#Rank(y#0));
    call CallPre$$UTF8.__default.EncodeAsciiUnique2(x##0_1_0_0_0, y##0_1_0_0_0);
    call CallPost$$UTF8.__default.EncodeAsciiUnique2(x##0_1_0_0_0, y##0_1_0_0_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(87,44)"} true;
    assume {:subsumption 0} !Seq#Equal(Seq#Drop(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#0), LitInt(1)), Seq#Drop(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#0), LitInt(1)));
    assume false;
    goto anon8;

  anon15_Else:
    goto anon8;

  anon8:
    assume !Seq#Equal(Seq#Drop(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#0), LitInt(1)), Seq#Drop(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0), LitInt(1)));
    assume {:captureState "StandardLibrary/src/UTF8.dfy(88,8)"} true;
    return;

  anon14_Else:
    assume {:partition} $Unbox(Seq#Index(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), LitInt(0))): int != $Unbox(Seq#Index(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0), LitInt(0))): int;
    return;

  anon11_Else:
    assume {:partition} !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    return;
}



procedure {:verboseName "UTF8.EncodeAsciiUnique (well-formedness)"} CheckWellFormed$$UTF8.__default.EncodeAsciiUnique();
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.EncodeAsciiUnique (well-formedness)"} CheckWellFormed$$UTF8.__default.EncodeAsciiUnique()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: Seq;
  var y#0: Seq;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.EncodeAsciiUnique"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(95,18): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(96,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    assume $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap) && $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap);
    goto anon5_Then, anon5_Else;

  anon5_Then:
    ##s#0 := x#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(x#0);
    assume UTF8.__default.IsASCIIString(x#0);
    ##s#1 := y#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(y#0);
    assume UTF8.__default.IsASCIIString(y#0);
    assume !Seq#Equal(x#0, y#0);
    ##s#2 := x#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#2) ==> UTF8.__default.IsASCIIString(##s#2) || (forall i#0: int :: { $Unbox(Seq#Index(##s#2, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#2) ==> char#ToInt($Unbox(Seq#Index(##s#2, i#0)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#2);
    assume UTF8.__default.EncodeAscii#canCall(x#0);
    ##s#3 := y#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#3) ==> UTF8.__default.IsASCIIString(##s#3) || (forall i#1: int :: { $Unbox(Seq#Index(##s#3, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#3) ==> char#ToInt($Unbox(Seq#Index(##s#3, i#1)): char) < 128);
    assume UTF8.__default.IsASCIIString(##s#3);
    assume UTF8.__default.EncodeAscii#canCall(y#0);
    assume !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    goto anon4;

  anon5_Else:
    assume UTF8.__default.IsASCIIString(x#0) && UTF8.__default.IsASCIIString(y#0) && !Seq#Equal(x#0, y#0) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0));
    goto anon4;

  anon4:
    assume (forall x#1: Seq, y#1: Seq :: { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.IsASCIIString(x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.IsASCIIString(y#1) } { UTF8.__default.IsASCIIString(y#1), UTF8.__default.IsASCIIString(x#1) } $Is(x#1, TSeq(TChar)) && $Is(y#1, TSeq(TChar)) ==> UTF8.__default.IsASCIIString(x#1) && UTF8.__default.IsASCIIString(y#1) && !Seq#Equal(x#1, y#1) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1)));
    return;
}



procedure {:verboseName "UTF8.EncodeAsciiUnique (call precondtion)"} CallPre$$UTF8.__default.EncodeAsciiUnique();



procedure {:verboseName "UTF8.EncodeAsciiUnique (call postcondition)"} CallPost$$UTF8.__default.EncodeAsciiUnique();
  modifies $Heap;
  free ensures (forall x#1: Seq, y#1: Seq :: { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.IsASCIIString(x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.IsASCIIString(y#1) } { UTF8.__default.IsASCIIString(y#1), UTF8.__default.IsASCIIString(x#1) } $Is(x#1, TSeq(TChar)) && $Is(y#1, TSeq(TChar)) ==> UTF8.__default.IsASCIIString#canCall(x#1) && (UTF8.__default.IsASCIIString(x#1) ==> UTF8.__default.IsASCIIString#canCall(y#1) && (UTF8.__default.IsASCIIString(y#1) ==> !Seq#Equal(x#1, y#1) ==> UTF8.__default.EncodeAscii#canCall(x#1) && UTF8.__default.EncodeAscii#canCall(y#1))));
  free ensures {:id "id2828"} (forall x#1: Seq, y#1: Seq :: { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.IsASCIIString(x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.IsASCIIString(y#1) } { UTF8.__default.IsASCIIString(y#1), UTF8.__default.IsASCIIString(x#1) } $Is(x#1, TSeq(TChar)) && $Is(y#1, TSeq(TChar)) ==> UTF8.__default.IsASCIIString(x#1) && UTF8.__default.IsASCIIString(y#1) && !Seq#Equal(x#1, y#1) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UTF8.EncodeAsciiUnique (correctness)"} Impl$$UTF8.__default.EncodeAsciiUnique() returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: Seq, y#1: Seq :: { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.IsASCIIString(x#1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.IsASCIIString(y#1) } { UTF8.__default.IsASCIIString(y#1), UTF8.__default.IsASCIIString(x#1) } $Is(x#1, TSeq(TChar)) && $Is(y#1, TSeq(TChar)) ==> UTF8.__default.IsASCIIString#canCall(x#1) && (UTF8.__default.IsASCIIString(x#1) ==> UTF8.__default.IsASCIIString#canCall(y#1) && (UTF8.__default.IsASCIIString(y#1) ==> !Seq#Equal(x#1, y#1) ==> UTF8.__default.EncodeAscii#canCall(x#1) && UTF8.__default.EncodeAscii#canCall(y#1))));
  free ensures {:id "id2829"} (forall x#1: Seq, y#1: Seq :: { UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#1) } { UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#1), UTF8.__default.IsASCIIString(x#1) } { UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.IsASCIIString(y#1) } { UTF8.__default.IsASCIIString(y#1), UTF8.__default.IsASCIIString(x#1) } $Is(x#1, TSeq(TChar)) && $Is(y#1, TSeq(TChar)) ==> UTF8.__default.IsASCIIString(x#1) && UTF8.__default.IsASCIIString(y#1) && !Seq#Equal(x#1, y#1) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#1), UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.EncodeAsciiUnique (correctness)"} Impl$$UTF8.__default.EncodeAsciiUnique() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: Seq;
  var y#0_0: Seq;
  var ##s#0_0: Seq;
  var ##s#0_1: Seq;
  var ##s#0_2: Seq;
  var ##s#0_3: Seq;
  var ##s#0_4: Seq;
  var ##s#0_5: Seq;
  var x##0_0_0: Seq;
  var y##0_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.EncodeAsciiUnique"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(97,2): initial state"} true;
    $_reverifyPost := false;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc x#0_0, y#0_0;
    assume $Is(x#0_0, TSeq(TChar)) && $Is(y#0_0, TSeq(TChar));
    assume true;
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##s#0_0 := x#0_0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(x#0_0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} UTF8.__default.IsASCIIString(x#0_0);
    ##s#0_1 := y#0_0;
    assume $IsAlloc(##s#0_1, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(y#0_0);
    goto anon4;

  anon21_Else:
    assume {:partition} !UTF8.__default.IsASCIIString(x#0_0);
    goto anon4;

  anon4:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0);
    goto anon6;

  anon22_Else:
    assume {:partition} !(UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0));
    goto anon6;

  anon6:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0) && !Seq#Equal(x#0_0, y#0_0);
    ##s#0_2 := x#0_0;
    assume $IsAlloc(##s#0_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_2) ==> UTF8.__default.IsASCIIString(##s#0_2) || (forall i#0_0: int :: { $Unbox(Seq#Index(##s#0_2, i#0_0)): char } LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(##s#0_2) ==> char#ToInt($Unbox(Seq#Index(##s#0_2, i#0_0)): char) < 128);
    assume UTF8.__default.EncodeAscii#canCall(x#0_0);
    ##s#0_3 := y#0_0;
    assume $IsAlloc(##s#0_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} UTF8.__default.IsASCIIString#canCall(##s#0_3) ==> UTF8.__default.IsASCIIString(##s#0_3) || (forall i#0_1: int :: { $Unbox(Seq#Index(##s#0_3, i#0_1)): char } LitInt(0) <= i#0_1 && i#0_1 < Seq#Length(##s#0_3) ==> char#ToInt($Unbox(Seq#Index(##s#0_3, i#0_1)): char) < 128);
    assume UTF8.__default.EncodeAscii#canCall(y#0_0);
    goto anon8;

  anon23_Else:
    assume {:partition} !(UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0) && !Seq#Equal(x#0_0, y#0_0));
    goto anon8;

  anon8:
    assume UTF8.__default.IsASCIIString#canCall(x#0_0) && (UTF8.__default.IsASCIIString(x#0_0) ==> UTF8.__default.IsASCIIString#canCall(y#0_0) && (UTF8.__default.IsASCIIString(y#0_0) ==> !Seq#Equal(x#0_0, y#0_0) ==> UTF8.__default.EncodeAscii#canCall(x#0_0) && UTF8.__default.EncodeAscii#canCall(y#0_0)));
    assume UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0) && !Seq#Equal(x#0_0, y#0_0) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0_0), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0_0));
    assume false;
    goto anon9;

  anon20_Else:
    goto anon9;

  anon9:
    ##s#0_4 := x#0_0;
    assume $IsAlloc(##s#0_4, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(x#0_0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} UTF8.__default.IsASCIIString(x#0_0);
    ##s#0_5 := y#0_0;
    assume $IsAlloc(##s#0_5, TSeq(TChar), $Heap);
    assume UTF8.__default.IsASCIIString#canCall(y#0_0);
    goto anon11;

  anon24_Else:
    assume {:partition} !UTF8.__default.IsASCIIString(x#0_0);
    goto anon11;

  anon11:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0);
    goto anon13;

  anon25_Else:
    assume {:partition} !(UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0));
    goto anon13;

  anon13:
    assume UTF8.__default.IsASCIIString#canCall(x#0_0) && (UTF8.__default.IsASCIIString(x#0_0) ==> UTF8.__default.IsASCIIString#canCall(y#0_0));
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0) && !Seq#Equal(x#0_0, y#0_0);
    assume true;
    x##0_0_0 := x#0_0;
    assume true;
    y##0_0_0 := y#0_0;
    call CallPre$$UTF8.__default.EncodeAsciiUnique2(x##0_0_0, y##0_0_0);
    call CallPost$$UTF8.__default.EncodeAsciiUnique2(x##0_0_0, y##0_0_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(100,32)"} true;
    goto anon16;

  anon26_Else:
    assume {:partition} !(UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0) && !Seq#Equal(x#0_0, y#0_0));
    goto anon16;

  anon16:
    assume UTF8.__default.IsASCIIString(x#0_0) && UTF8.__default.IsASCIIString(y#0_0) && !Seq#Equal(x#0_0, y#0_0) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, x#0_0), UTF8.__default.EncodeAscii($LS($LS($LZ)), reveal_UTF8._default.EncodeAscii, y#0_0));
    assume false;
    goto anon18;

  anon19_Else:
    assume (forall x#0_1: Seq, y#0_1: Seq :: { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0_1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0_1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0_1), UTF8.__default.IsASCIIString(x#0_1) } { UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0_1), UTF8.__default.IsASCIIString(y#0_1) } { UTF8.__default.IsASCIIString(y#0_1), UTF8.__default.IsASCIIString(x#0_1) } $Is(x#0_1, TSeq(TChar)) && $Is(y#0_1, TSeq(TChar)) && Lit(true) ==> UTF8.__default.IsASCIIString(x#0_1) && UTF8.__default.IsASCIIString(y#0_1) && !Seq#Equal(x#0_1, y#0_1) ==> !Seq#Equal(UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, x#0_1), UTF8.__default.EncodeAscii($LS($LZ), reveal_UTF8._default.EncodeAscii, y#0_1)));
    goto anon18;

  anon18:
    assume {:captureState "StandardLibrary/src/UTF8.dfy(102,4)"} true;
    return;
}



function UTF8.__default.Uses1Byte(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.Uses1Byte(s#0) } UTF8.__default.Uses1Byte#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(1)) ==> (UTF8.__default.Uses1Byte(s#0) <==> LitInt(0) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(127)));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses1Byte(Lit(s#0)) } UTF8.__default.Uses1Byte#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(1)) ==> (UTF8.__default.Uses1Byte(Lit(s#0)) <==> LitInt(0) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(127)));
}

function UTF8.__default.Uses1Byte#canCall(s#0: Seq) : bool;

function UTF8.__default.Uses1Byte#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.Uses1Byte#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UTF8.__default.Uses1Byte#requires(s#0) <==> Seq#Length(s#0) >= LitInt(1)));

procedure {:verboseName "UTF8.Uses1Byte (well-formedness)"} CheckWellformed$$UTF8.__default.Uses1Byte(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.Uses1Byte (well-formedness)"} CheckWellformed$$UTF8.__default.Uses1Byte(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.Uses1Byte", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(105,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) >= LitInt(1);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#1 := LitInt(127);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon7_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int < LitInt(0);
    goto anon5;

  anon5:
    assume UTF8.__default.Uses1Byte(s#0) <==> LitInt(0) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(127);
    assume true;
    assume $Is(UTF8.__default.Uses1Byte(s#0), TBool);
    return;
}



function UTF8.__default.Uses2Bytes(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.Uses2Bytes(s#0) } UTF8.__default.Uses2Bytes#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(2)) ==> (UTF8.__default.Uses2Bytes(s#0) <==> LitInt(194) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(223) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191)));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses2Bytes(Lit(s#0)) } UTF8.__default.Uses2Bytes#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(2)) ==> (UTF8.__default.Uses2Bytes(Lit(s#0)) <==> LitInt(194) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(223) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191)));
}

function UTF8.__default.Uses2Bytes#canCall(s#0: Seq) : bool;

function UTF8.__default.Uses2Bytes#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.Uses2Bytes#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UTF8.__default.Uses2Bytes#requires(s#0) <==> Seq#Length(s#0) >= LitInt(2)));

procedure {:verboseName "UTF8.Uses2Bytes (well-formedness)"} CheckWellformed$$UTF8.__default.Uses2Bytes(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.Uses2Bytes (well-formedness)"} CheckWellformed$$UTF8.__default.Uses2Bytes(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.Uses2Bytes", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(112,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) >= LitInt(2);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    newtype$check#0 := LitInt(194);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(194) <= $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#1 := LitInt(223);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon10_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int < LitInt(194);
    goto anon5;

  anon5:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(194) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(223);
    newtype$check#2 := LitInt(128);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#3 := LitInt(191);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon8;

  anon12_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(128);
    goto anon8;

  anon11_Else:
    assume {:partition} !(LitInt(194) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(223));
    goto anon8;

  anon8:
    assume UTF8.__default.Uses2Bytes(s#0) <==> LitInt(194) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(223) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191);
    assume true;
    assume $Is(UTF8.__default.Uses2Bytes(s#0), TBool);
    return;
}



function UTF8.__default.Uses3Bytes(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.Uses3Bytes(s#0) } UTF8.__default.Uses3Bytes#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(3)) ==> (UTF8.__default.Uses3Bytes(s#0) <==> ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191))));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses3Bytes(Lit(s#0)) } UTF8.__default.Uses3Bytes#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(3)) ==> (UTF8.__default.Uses3Bytes(Lit(s#0)) <==> ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191)) || (LitInt(238) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191))));
}

function UTF8.__default.Uses3Bytes#canCall(s#0: Seq) : bool;

function UTF8.__default.Uses3Bytes#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.Uses3Bytes#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UTF8.__default.Uses3Bytes#requires(s#0) <==> Seq#Length(s#0) >= LitInt(3)));

procedure {:verboseName "UTF8.Uses3Bytes (well-formedness)"} CheckWellformed$$UTF8.__default.Uses3Bytes(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.Uses3Bytes (well-formedness)"} CheckWellformed$$UTF8.__default.Uses3Bytes(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.Uses3Bytes", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(119,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) >= LitInt(3);
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume false;
    return;

  anon35_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0 := LitInt(224);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224);
    newtype$check#1 := LitInt(160);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#2 := LitInt(191);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon6;

  anon37_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(160);
    goto anon6;

  anon36_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int != LitInt(224);
    goto anon6;

  anon6:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191);
    newtype$check#3 := LitInt(128);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#4 := LitInt(191);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon9;

  anon39_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon9;

  anon38_Else:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191));
    goto anon9;

  anon9:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    newtype$check#5 := LitInt(225);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#6 := LitInt(236);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon12;

  anon41_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int < LitInt(225);
    goto anon12;

  anon12:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236);
    newtype$check#7 := LitInt(128);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#8 := LitInt(191);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon15;

  anon43_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(128);
    goto anon15;

  anon42_Else:
    assume {:partition} !(LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236));
    goto anon15;

  anon15:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191);
    newtype$check#9 := LitInt(128);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#10 := LitInt(191);
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon18;

  anon45_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon18;

  anon44_Else:
    assume {:partition} !(LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191));
    goto anon18;

  anon40_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191);
    goto anon18;

  anon18:
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} !(($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#11 := LitInt(237);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237);
    newtype$check#12 := LitInt(128);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#13 := LitInt(159);
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon22;

  anon48_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(128);
    goto anon22;

  anon47_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int != LitInt(237);
    goto anon22;

  anon22:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159);
    newtype$check#14 := LitInt(128);
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#15 := LitInt(191);
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon25;

  anon50_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon25;

  anon49_Else:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159));
    goto anon25;

  anon46_Else:
    assume {:partition} ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    goto anon25;

  anon25:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} !(($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)));
    newtype$check#16 := LitInt(238);
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#17 := LitInt(239);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon28;

  anon52_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int < LitInt(238);
    goto anon28;

  anon28:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239);
    newtype$check#18 := LitInt(128);
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#19 := LitInt(191);
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon31;

  anon54_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(128);
    goto anon31;

  anon53_Else:
    assume {:partition} !(LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239));
    goto anon31;

  anon31:
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191);
    newtype$check#20 := LitInt(128);
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#21 := LitInt(191);
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon34;

  anon56_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon34;

  anon55_Else:
    assume {:partition} !(LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191));
    goto anon34;

  anon51_Else:
    assume {:partition} ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    goto anon34;

  anon34:
    assume UTF8.__default.Uses3Bytes(s#0) <==> ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    assume true;
    assume $Is(UTF8.__default.Uses3Bytes(s#0), TBool);
    return;
}



function UTF8.__default.Uses4Bytes(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.Uses4Bytes(s#0) } UTF8.__default.Uses4Bytes#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(4)) ==> (UTF8.__default.Uses4Bytes(s#0) <==> ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191))));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses4Bytes(Lit(s#0)) } UTF8.__default.Uses4Bytes#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(4)) ==> (UTF8.__default.Uses4Bytes(Lit(s#0)) <==> ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int <= LitInt(191)) || ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int <= LitInt(191))));
}

function UTF8.__default.Uses4Bytes#canCall(s#0: Seq) : bool;

function UTF8.__default.Uses4Bytes#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.Uses4Bytes#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UTF8.__default.Uses4Bytes#requires(s#0) <==> Seq#Length(s#0) >= LitInt(4)));

procedure {:verboseName "UTF8.Uses4Bytes (well-formedness)"} CheckWellformed$$UTF8.__default.Uses4Bytes(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.Uses4Bytes (well-formedness)"} CheckWellformed$$UTF8.__default.Uses4Bytes(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.Uses4Bytes", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(129,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) >= LitInt(4);
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume false;
    return;

  anon35_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0 := LitInt(240);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240);
    newtype$check#1 := LitInt(144);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#2 := LitInt(191);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon6;

  anon37_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(144);
    goto anon6;

  anon36_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int != LitInt(240);
    goto anon6;

  anon6:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191);
    newtype$check#3 := LitInt(128);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#4 := LitInt(191);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon9;

  anon39_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon9;

  anon38_Else:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191));
    goto anon9;

  anon9:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191);
    newtype$check#5 := LitInt(128);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#6 := LitInt(191);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon12;

  anon41_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(3))): int < LitInt(128);
    goto anon12;

  anon40_Else:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    goto anon12;

  anon12:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191));
    newtype$check#7 := LitInt(241);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#8 := LitInt(243);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon15;

  anon43_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int < LitInt(241);
    goto anon15;

  anon15:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243);
    newtype$check#9 := LitInt(128);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#10 := LitInt(191);
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon18;

  anon45_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(128);
    goto anon18;

  anon44_Else:
    assume {:partition} !(LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243));
    goto anon18;

  anon18:
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191);
    newtype$check#11 := LitInt(128);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#12 := LitInt(191);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon21;

  anon47_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon21;

  anon46_Else:
    assume {:partition} !(LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191));
    goto anon21;

  anon21:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191);
    newtype$check#13 := LitInt(128);
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#14 := LitInt(191);
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon24;

  anon49_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(3))): int < LitInt(128);
    goto anon24;

  anon48_Else:
    assume {:partition} !(LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    goto anon24;

  anon42_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191);
    goto anon24;

  anon24:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} !(($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#15 := LitInt(244);
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244);
    newtype$check#16 := LitInt(128);
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#17 := LitInt(143);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon28;

  anon52_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(1))): int < LitInt(128);
    goto anon28;

  anon51_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int != LitInt(244);
    goto anon28;

  anon28:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143);
    newtype$check#18 := LitInt(128);
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#19 := LitInt(191);
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon31;

  anon54_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(2))): int < LitInt(128);
    goto anon31;

  anon53_Else:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143));
    goto anon31;

  anon31:
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191);
    newtype$check#20 := LitInt(128);
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#21 := LitInt(191);
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon34;

  anon56_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(3))): int < LitInt(128);
    goto anon34;

  anon55_Else:
    assume {:partition} !($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191));
    goto anon34;

  anon50_Else:
    assume {:partition} ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191));
    goto anon34;

  anon34:
    assume UTF8.__default.Uses4Bytes(s#0) <==> ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191));
    assume true;
    assume $Is(UTF8.__default.Uses4Bytes(s#0), TBool);
    return;
}



function UTF8.__default.ValidUTF8Range($ly: LayerType, a#0: Seq, lo#0: int, hi#0: int) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#0 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#0) && (UTF8.__default.Uses1Byte(r#0) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#0) ==> (LitInt(2) <= Seq#Length(r#0) ==> UTF8.__default.Uses2Bytes#canCall(r#0)) && (LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> (LitInt(3) <= Seq#Length(r#0) ==> UTF8.__default.Uses3Bytes#canCall(r#0)) && (LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> (LitInt(4) <= Seq#Length(r#0) ==> UTF8.__default.Uses4Bytes#canCall(r#0)) && (LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#0 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#0) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#1 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#1) && (UTF8.__default.Uses1Byte(r#1) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#1) ==> (LitInt(2) <= Seq#Length(r#1) ==> UTF8.__default.Uses2Bytes#canCall(r#1)) && (LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1)) ==> (LitInt(3) <= Seq#Length(r#1) ==> UTF8.__default.Uses3Bytes#canCall(r#1)) && (LitInt(3) <= Seq#Length(r#1) && UTF8.__default.Uses3Bytes(r#1) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#1) && UTF8.__default.Uses3Bytes(r#1)) ==> (LitInt(4) <= Seq#Length(r#1) ==> UTF8.__default.Uses4Bytes#canCall(r#1)) && (LitInt(4) <= Seq#Length(r#1) && UTF8.__default.Uses4Bytes(r#1) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#1 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#1) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#1) && UTF8.__default.Uses3Bytes(r#1) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#1) && UTF8.__default.Uses4Bytes(r#1) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#2 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#2) && (UTF8.__default.Uses1Byte(r#2) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#2) ==> (LitInt(2) <= Seq#Length(r#2) ==> UTF8.__default.Uses2Bytes#canCall(r#2)) && (LitInt(2) <= Seq#Length(r#2) && UTF8.__default.Uses2Bytes(r#2) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#2) && UTF8.__default.Uses2Bytes(r#2)) ==> (LitInt(3) <= Seq#Length(r#2) ==> UTF8.__default.Uses3Bytes#canCall(r#2)) && (LitInt(3) <= Seq#Length(r#2) && UTF8.__default.Uses3Bytes(r#2) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#2) && UTF8.__default.Uses3Bytes(r#2)) ==> (LitInt(4) <= Seq#Length(r#2) ==> UTF8.__default.Uses4Bytes#canCall(r#2)) && (LitInt(4) <= Seq#Length(r#2) && UTF8.__default.Uses4Bytes(r#2) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#2 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#2) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#2) && UTF8.__default.Uses2Bytes(r#2) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#2) && UTF8.__default.Uses3Bytes(r#2) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#2) && UTF8.__default.Uses4Bytes(r#2) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));
}

function UTF8.__default.ValidUTF8Range#canCall(a#0: Seq, lo#0: int, hi#0: int) : bool;

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($ly, a#0, lo#0, hi#0));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range(AsFuelBottom($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range($ly, a#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LZ, a#0, lo#0, hi#0));

function UTF8.__default.ValidUTF8Range#requires(LayerType, Seq, int, int) : bool;

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range#requires($ly, a#0, lo#0, hi#0) } $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 ==> (UTF8.__default.ValidUTF8Range#requires($ly, a#0, lo#0, hi#0) <==> lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)));

procedure {:verboseName "UTF8.ValidUTF8Range (well-formedness)"} CheckWellformed$$UTF8.__default.ValidUTF8Range(a#0: Seq where $Is(a#0, TSeq(Tclass.BoundedInts.uint8())), lo#0: int where LitInt(0) <= lo#0, hi#0: int where LitInt(0) <= hi#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.ValidUTF8Range (well-formedness)"} CheckWellformed$$UTF8.__default.ValidUTF8Range(a#0: Seq, lo#0: int, hi#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var r#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##s#0: Seq;
  var ##a#0: Seq;
  var ##lo#0: int;
  var ##hi#0: int;
  var ##s#1: Seq;
  var ##a#1: Seq;
  var ##lo#1: int;
  var ##hi#1: int;
  var ##s#2: Seq;
  var ##a#2: Seq;
  var ##lo#2: int;
  var ##hi#2: int;
  var ##s#3: Seq;
  var ##a#3: Seq;
  var ##lo#3: int;
  var ##hi#3: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Range", " | ", a#0, " | ", lo#0, " | ", hi#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(138,36): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} lo#0 <= hi#0;
    goto anon3;

  anon22_Else:
    assume {:partition} hi#0 < lo#0;
    goto anon3;

  anon3:
    assume lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume false;
    return;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} lo#0 == hi#0;
    assume UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0) <==> Lit(true);
    assume true;
    assume $Is(UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0), TBool);
    return;

  anon24_Else:
    assume {:partition} lo#0 != hi#0;
    havoc r#Z#0;
    assume $Is(r#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(r#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume 0 <= lo#0 && lo#0 <= Seq#Length(a#0);
    assume lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0);
    assume let#0#0#0 == Seq#Drop(Seq#Take(a#0, hi#0), lo#0);
    assume true;
    assume $Is(let#0#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume r#Z#0 == let#0#0#0;
    ##s#0 := r#Z#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) >= LitInt(1);
    assume Seq#Length(##s#0) >= LitInt(1);
    assume UTF8.__default.Uses1Byte#canCall(r#Z#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} UTF8.__default.Uses1Byte(r#Z#0);
    ##a#0 := a#0;
    assume $IsAlloc(##a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0 + 1, Tclass._System.nat());
    ##lo#0 := lo#0 + 1;
    assume $IsAlloc(##lo#0, Tclass._System.nat(), $Heap);
    ##hi#0 := hi#0;
    assume $IsAlloc(##hi#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#0 <= ##hi#0;
    assume {:subsumption 0} ##hi#0 <= Seq#Length(##a#0);
    assume ##lo#0 <= ##hi#0 && ##hi#0 <= Seq#Length(##a#0);
    assume 0 <= hi#0 - lo#0 || ##hi#0 - ##lo#0 == hi#0 - lo#0;
    assume ##hi#0 - ##lo#0 < hi#0 - lo#0;
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0);
    assume UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0 + 1, hi#0);
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0);
    assume $Is(UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0), TBool);
    return;

  anon25_Else:
    assume {:partition} !UTF8.__default.Uses1Byte(r#Z#0);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(2) <= Seq#Length(r#Z#0);
    ##s#1 := r#Z#0;
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) >= LitInt(2);
    assume Seq#Length(##s#1) >= LitInt(2);
    assume UTF8.__default.Uses2Bytes#canCall(r#Z#0);
    goto anon11;

  anon26_Else:
    assume {:partition} Seq#Length(r#Z#0) < LitInt(2);
    goto anon11;

  anon11:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} LitInt(2) <= Seq#Length(r#Z#0) && UTF8.__default.Uses2Bytes(r#Z#0);
    ##a#1 := a#0;
    assume $IsAlloc(##a#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0 + 2, Tclass._System.nat());
    ##lo#1 := lo#0 + 2;
    assume $IsAlloc(##lo#1, Tclass._System.nat(), $Heap);
    ##hi#1 := hi#0;
    assume $IsAlloc(##hi#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#1 <= ##hi#1;
    assume {:subsumption 0} ##hi#1 <= Seq#Length(##a#1);
    assume ##lo#1 <= ##hi#1 && ##hi#1 <= Seq#Length(##a#1);
    assume 0 <= hi#0 - lo#0 || ##hi#1 - ##lo#1 == hi#0 - lo#0;
    assume ##hi#1 - ##lo#1 < hi#0 - lo#0;
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0);
    assume UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0 + 2, hi#0);
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0);
    assume $Is(UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0), TBool);
    return;

  anon27_Else:
    assume {:partition} !(LitInt(2) <= Seq#Length(r#Z#0) && UTF8.__default.Uses2Bytes(r#Z#0));
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} LitInt(3) <= Seq#Length(r#Z#0);
    ##s#2 := r#Z#0;
    assume $IsAlloc(##s#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) >= LitInt(3);
    assume Seq#Length(##s#2) >= LitInt(3);
    assume UTF8.__default.Uses3Bytes#canCall(r#Z#0);
    goto anon15;

  anon28_Else:
    assume {:partition} Seq#Length(r#Z#0) < LitInt(3);
    goto anon15;

  anon15:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} LitInt(3) <= Seq#Length(r#Z#0) && UTF8.__default.Uses3Bytes(r#Z#0);
    ##a#2 := a#0;
    assume $IsAlloc(##a#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0 + 3, Tclass._System.nat());
    ##lo#2 := lo#0 + 3;
    assume $IsAlloc(##lo#2, Tclass._System.nat(), $Heap);
    ##hi#2 := hi#0;
    assume $IsAlloc(##hi#2, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#2 <= ##hi#2;
    assume {:subsumption 0} ##hi#2 <= Seq#Length(##a#2);
    assume ##lo#2 <= ##hi#2 && ##hi#2 <= Seq#Length(##a#2);
    assume 0 <= hi#0 - lo#0 || ##hi#2 - ##lo#2 == hi#0 - lo#0;
    assume ##hi#2 - ##lo#2 < hi#0 - lo#0;
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0);
    assume UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0 + 3, hi#0);
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0);
    assume $Is(UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0), TBool);
    return;

  anon29_Else:
    assume {:partition} !(LitInt(3) <= Seq#Length(r#Z#0) && UTF8.__default.Uses3Bytes(r#Z#0));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} LitInt(4) <= Seq#Length(r#Z#0);
    ##s#3 := r#Z#0;
    assume $IsAlloc(##s#3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#3) >= LitInt(4);
    assume Seq#Length(##s#3) >= LitInt(4);
    assume UTF8.__default.Uses4Bytes#canCall(r#Z#0);
    goto anon19;

  anon30_Else:
    assume {:partition} Seq#Length(r#Z#0) < LitInt(4);
    goto anon19;

  anon19:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} LitInt(4) <= Seq#Length(r#Z#0) && UTF8.__default.Uses4Bytes(r#Z#0);
    ##a#3 := a#0;
    assume $IsAlloc(##a#3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0 + 4, Tclass._System.nat());
    ##lo#3 := lo#0 + 4;
    assume $IsAlloc(##lo#3, Tclass._System.nat(), $Heap);
    ##hi#3 := hi#0;
    assume $IsAlloc(##hi#3, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#3 <= ##hi#3;
    assume {:subsumption 0} ##hi#3 <= Seq#Length(##a#3);
    assume ##lo#3 <= ##hi#3 && ##hi#3 <= Seq#Length(##a#3);
    assume 0 <= hi#0 - lo#0 || ##hi#3 - ##lo#3 == hi#0 - lo#0;
    assume ##hi#3 - ##lo#3 < hi#0 - lo#0;
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0);
    assume UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0 + 4, hi#0);
    assume UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0);
    assume $Is(UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0), TBool);
    return;

  anon31_Else:
    assume {:partition} !(LitInt(4) <= Seq#Length(r#Z#0) && UTF8.__default.Uses4Bytes(r#Z#0));
    assume UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0) <==> Lit(false);
    assume true;
    assume $Is(UTF8.__default.ValidUTF8Range($LS($LZ), a#0, lo#0, hi#0), TBool);
    return;
}



procedure {:verboseName "UTF8.ValidUTF8Embed (well-formedness)"} CheckWellFormed$$UTF8.__default.ValidUTF8Embed(a#0: Seq where $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), c#0: Seq where $Is(c#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(c#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), lo#0: int where LitInt(0) <= lo#0, hi#0: int where LitInt(0) <= hi#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.ValidUTF8Embed (well-formedness)"} CheckWellFormed$$UTF8.__default.ValidUTF8Embed(a#0: Seq, b#0: Seq, c#0: Seq, lo#0: int, hi#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##a#0: Seq;
  var ##lo#0: int;
  var ##hi#0: int;
  var ##a#1: Seq;
  var ##lo#1: int;
  var ##hi#1: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Embed", " | ", a#0, " | ", b#0, " | ", c#0, " | ", lo#0, " | ", hi#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(158,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} lo#0 <= hi#0;
    goto anon3;

  anon4_Else:
    assume {:partition} hi#0 < lo#0;
    goto anon3;

  anon3:
    assume lo#0 <= hi#0 && hi#0 <= Seq#Length(b#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(160,38): post-state"} true;
    ##a#0 := b#0;
    assume $IsAlloc(##a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##lo#0 := lo#0;
    assume $IsAlloc(##lo#0, Tclass._System.nat(), $Heap);
    ##hi#0 := hi#0;
    assume $IsAlloc(##hi#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#0 <= ##hi#0;
    assume {:subsumption 0} ##hi#0 <= Seq#Length(##a#0);
    assume ##lo#0 <= ##hi#0 && ##hi#0 <= Seq#Length(##a#0);
    assume UTF8.__default.ValidUTF8Range#canCall(b#0, lo#0, hi#0);
    ##a#1 := Seq#Append(Seq#Append(a#0, b#0), c#0);
    assume $IsAlloc(##a#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(Seq#Length(a#0) + lo#0, Tclass._System.nat());
    ##lo#1 := Seq#Length(a#0) + lo#0;
    assume $IsAlloc(##lo#1, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(a#0) + hi#0, Tclass._System.nat());
    ##hi#1 := Seq#Length(a#0) + hi#0;
    assume $IsAlloc(##hi#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#1 <= ##hi#1;
    assume {:subsumption 0} ##hi#1 <= Seq#Length(##a#1);
    assume ##lo#1 <= ##hi#1 && ##hi#1 <= Seq#Length(##a#1);
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + lo#0, Seq#Length(a#0) + hi#0);
    assume UTF8.__default.ValidUTF8Range($LS($LZ), b#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + lo#0, Seq#Length(a#0) + hi#0);
    return;
}



procedure {:verboseName "UTF8.ValidUTF8Embed (call precondtion)"} CallPre$$UTF8.__default.ValidUTF8Embed(a#0: Seq where $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), c#0: Seq where $Is(c#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(c#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), lo#0: int where LitInt(0) <= lo#0, hi#0: int where LitInt(0) <= hi#0);
  requires {:id "id2988"} lo#0 <= hi#0;
  requires {:id "id2989"} hi#0 <= Seq#Length(b#0);



procedure {:verboseName "UTF8.ValidUTF8Embed (call postcondition)"} CallPost$$UTF8.__default.ValidUTF8Embed(a#0: Seq where $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), c#0: Seq where $Is(c#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(c#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), lo#0: int where LitInt(0) <= lo#0, hi#0: int where LitInt(0) <= hi#0);
  modifies $Heap;
  free ensures UTF8.__default.ValidUTF8Range#canCall(b#0, lo#0, hi#0) && UTF8.__default.ValidUTF8Range#canCall(Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + lo#0, Seq#Length(a#0) + hi#0);
  free ensures {:id "id2990"} UTF8.__default.ValidUTF8Range($LS($LS($LZ)), b#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + lo#0, Seq#Length(a#0) + hi#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UTF8.ValidUTF8Embed (correctness)"} Impl$$UTF8.__default.ValidUTF8Embed(a#0: Seq where $Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), c#0: Seq where $Is(c#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(c#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), lo#0: int where LitInt(0) <= lo#0, hi#0: int where LitInt(0) <= hi#0) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id2991"} lo#0 <= hi#0;
  requires {:id "id2992"} hi#0 <= Seq#Length(b#0);
  modifies $Heap;
  free ensures UTF8.__default.ValidUTF8Range#canCall(b#0, lo#0, hi#0) && UTF8.__default.ValidUTF8Range#canCall(Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + lo#0, Seq#Length(a#0) + hi#0);
  free ensures {:id "id2993"} UTF8.__default.ValidUTF8Range($LS($LS($LZ)), b#0, lo#0, hi#0) <==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + lo#0, Seq#Length(a#0) + hi#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.ValidUTF8Embed (correctness)"} Impl$$UTF8.__default.ValidUTF8Embed(a#0: Seq, b#0: Seq, c#0: Seq, lo#0: int, hi#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var r#1_0: Seq where $Is(r#1_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(r#1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var r'#1_0: Seq where $Is(r'#1_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(r'#1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var ##s#1_0: Seq;
  var a##1_0_0: Seq;
  var b##1_0_0: Seq;
  var c##1_0_0: Seq;
  var lo##1_0_0: int;
  var hi##1_0_0: int;
  var ##s#1_1_0: Seq;
  var a##1_1_0_0: Seq;
  var b##1_1_0_0: Seq;
  var c##1_1_0_0: Seq;
  var lo##1_1_0_0: int;
  var hi##1_1_0_0: int;
  var ##s#1_1_1_0: Seq;
  var a##1_1_1_0_0: Seq;
  var b##1_1_1_0_0: Seq;
  var c##1_1_1_0_0: Seq;
  var lo##1_1_1_0_0: int;
  var hi##1_1_1_0_0: int;
  var ##s#1_1_1_1_0: Seq;
  var a##1_1_1_1_0_0: Seq;
  var b##1_1_1_1_0_0: Seq;
  var c##1_1_1_1_0_0: Seq;
  var lo##1_1_1_1_0_0: int;
  var hi##1_1_1_1_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Embed", " | ", a#0, " | ", b#0, " | ", c#0, " | ", lo#0, " | ", hi#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(162,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#a0#0: Seq, $ih#b0#0: Seq, $ih#c0#0: Seq, $ih#lo0#0: int, $ih#hi0#0: int :: $Is($ih#a0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is($ih#b0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is($ih#c0#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= $ih#lo0#0 && LitInt(0) <= $ih#hi0#0 && $ih#lo0#0 <= $ih#hi0#0 && $ih#hi0#0 <= Seq#Length($ih#b0#0) && 0 <= $ih#hi0#0 - $ih#lo0#0 && $ih#hi0#0 - $ih#lo0#0 < hi#0 - lo#0 ==> (UTF8.__default.ValidUTF8Range($LS($LZ), $ih#b0#0, $ih#lo0#0, $ih#hi0#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(Seq#Append($ih#a0#0, $ih#b0#0), $ih#c0#0), Seq#Length($ih#a0#0) + $ih#lo0#0, Seq#Length($ih#a0#0) + $ih#hi0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} lo#0 == hi#0;
    return;

  anon17_Else:
    assume {:partition} lo#0 != hi#0;
    assume true;
    assume 0 <= lo#0 && lo#0 <= Seq#Length(b#0);
    assume lo#0 <= hi#0 && hi#0 <= Seq#Length(b#0);
    assume true;
    r#1_0 := Seq#Drop(Seq#Take(b#0, hi#0), lo#0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(165,24)"} true;
    assume true;
    assume 0 <= Seq#Length(a#0) + lo#0 && Seq#Length(a#0) + lo#0 <= Seq#Length(Seq#Append(Seq#Append(a#0, b#0), c#0));
    assume Seq#Length(a#0) + lo#0 <= Seq#Length(a#0) + hi#0 && Seq#Length(a#0) + hi#0 <= Seq#Length(Seq#Append(Seq#Append(a#0, b#0), c#0));
    assume true;
    r'#1_0 := Seq#Drop(Seq#Take(Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Length(a#0) + hi#0), Seq#Length(a#0) + lo#0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(166,47)"} true;
    assume true;
    assume Seq#Equal(r#1_0, r'#1_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(167,20)"} true;
    ##s#1_0 := r#1_0;
    assume $IsAlloc(##s#1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1_0) >= LitInt(1);
    assume Seq#Length(##s#1_0) >= LitInt(1);
    assume UTF8.__default.Uses1Byte#canCall(r#1_0);
    assume UTF8.__default.Uses1Byte#canCall(r#1_0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} UTF8.__default.Uses1Byte(r#1_0);
    assume true;
    a##1_0_0 := a#0;
    assume true;
    b##1_0_0 := b#0;
    assume true;
    c##1_0_0 := c#0;
    assume true;
    assume $Is(lo#0 + 1, Tclass._System.nat());
    lo##1_0_0 := lo#0 + 1;
    assume true;
    hi##1_0_0 := hi#0;
    assume 0 <= hi#0 - lo#0 || hi##1_0_0 - lo##1_0_0 == hi#0 - lo#0;
    assume hi##1_0_0 - lo##1_0_0 < hi#0 - lo#0;
    call CallPre$$UTF8.__default.ValidUTF8Embed(a##1_0_0, b##1_0_0, c##1_0_0, lo##1_0_0, hi##1_0_0);
    call CallPost$$UTF8.__default.ValidUTF8Embed(a##1_0_0, b##1_0_0, c##1_0_0, lo##1_0_0, hi##1_0_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(169,43)"} true;
    return;

  anon18_Else:
    assume {:partition} !UTF8.__default.Uses1Byte(r#1_0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(2) <= Seq#Length(r#1_0);
    ##s#1_1_0 := r#1_0;
    assume $IsAlloc(##s#1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1_1_0) >= LitInt(2);
    assume Seq#Length(##s#1_1_0) >= LitInt(2);
    assume UTF8.__default.Uses2Bytes#canCall(r#1_0);
    goto anon6;

  anon19_Else:
    assume {:partition} Seq#Length(r#1_0) < LitInt(2);
    goto anon6;

  anon6:
    assume LitInt(2) <= Seq#Length(r#1_0) ==> UTF8.__default.Uses2Bytes#canCall(r#1_0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(2) <= Seq#Length(r#1_0) && UTF8.__default.Uses2Bytes(r#1_0);
    assume true;
    a##1_1_0_0 := a#0;
    assume true;
    b##1_1_0_0 := b#0;
    assume true;
    c##1_1_0_0 := c#0;
    assume true;
    assume $Is(lo#0 + 2, Tclass._System.nat());
    lo##1_1_0_0 := lo#0 + 2;
    assume true;
    hi##1_1_0_0 := hi#0;
    assume 0 <= hi#0 - lo#0 || hi##1_1_0_0 - lo##1_1_0_0 == hi#0 - lo#0;
    assume hi##1_1_0_0 - lo##1_1_0_0 < hi#0 - lo#0;
    call CallPre$$UTF8.__default.ValidUTF8Embed(a##1_1_0_0, b##1_1_0_0, c##1_1_0_0, lo##1_1_0_0, hi##1_1_0_0);
    call CallPost$$UTF8.__default.ValidUTF8Embed(a##1_1_0_0, b##1_1_0_0, c##1_1_0_0, lo##1_1_0_0, hi##1_1_0_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(171,43)"} true;
    return;

  anon20_Else:
    assume {:partition} !(LitInt(2) <= Seq#Length(r#1_0) && UTF8.__default.Uses2Bytes(r#1_0));
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} LitInt(3) <= Seq#Length(r#1_0);
    ##s#1_1_1_0 := r#1_0;
    assume $IsAlloc(##s#1_1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1_1_1_0) >= LitInt(3);
    assume Seq#Length(##s#1_1_1_0) >= LitInt(3);
    assume UTF8.__default.Uses3Bytes#canCall(r#1_0);
    goto anon10;

  anon21_Else:
    assume {:partition} Seq#Length(r#1_0) < LitInt(3);
    goto anon10;

  anon10:
    assume LitInt(3) <= Seq#Length(r#1_0) ==> UTF8.__default.Uses3Bytes#canCall(r#1_0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(3) <= Seq#Length(r#1_0) && UTF8.__default.Uses3Bytes(r#1_0);
    assume true;
    a##1_1_1_0_0 := a#0;
    assume true;
    b##1_1_1_0_0 := b#0;
    assume true;
    c##1_1_1_0_0 := c#0;
    assume true;
    assume $Is(lo#0 + 3, Tclass._System.nat());
    lo##1_1_1_0_0 := lo#0 + 3;
    assume true;
    hi##1_1_1_0_0 := hi#0;
    assume 0 <= hi#0 - lo#0 || hi##1_1_1_0_0 - lo##1_1_1_0_0 == hi#0 - lo#0;
    assume hi##1_1_1_0_0 - lo##1_1_1_0_0 < hi#0 - lo#0;
    call CallPre$$UTF8.__default.ValidUTF8Embed(a##1_1_1_0_0, b##1_1_1_0_0, c##1_1_1_0_0, lo##1_1_1_0_0, hi##1_1_1_0_0);
    call CallPost$$UTF8.__default.ValidUTF8Embed(a##1_1_1_0_0, b##1_1_1_0_0, c##1_1_1_0_0, lo##1_1_1_0_0, hi##1_1_1_0_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(173,43)"} true;
    return;

  anon22_Else:
    assume {:partition} !(LitInt(3) <= Seq#Length(r#1_0) && UTF8.__default.Uses3Bytes(r#1_0));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(4) <= Seq#Length(r#1_0);
    ##s#1_1_1_1_0 := r#1_0;
    assume $IsAlloc(##s#1_1_1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1_1_1_1_0) >= LitInt(4);
    assume Seq#Length(##s#1_1_1_1_0) >= LitInt(4);
    assume UTF8.__default.Uses4Bytes#canCall(r#1_0);
    goto anon14;

  anon23_Else:
    assume {:partition} Seq#Length(r#1_0) < LitInt(4);
    goto anon14;

  anon14:
    assume LitInt(4) <= Seq#Length(r#1_0) ==> UTF8.__default.Uses4Bytes#canCall(r#1_0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(4) <= Seq#Length(r#1_0) && UTF8.__default.Uses4Bytes(r#1_0);
    assume true;
    a##1_1_1_1_0_0 := a#0;
    assume true;
    b##1_1_1_1_0_0 := b#0;
    assume true;
    c##1_1_1_1_0_0 := c#0;
    assume true;
    assume $Is(lo#0 + 4, Tclass._System.nat());
    lo##1_1_1_1_0_0 := lo#0 + 4;
    assume true;
    hi##1_1_1_1_0_0 := hi#0;
    assume 0 <= hi#0 - lo#0 || hi##1_1_1_1_0_0 - lo##1_1_1_1_0_0 == hi#0 - lo#0;
    assume hi##1_1_1_1_0_0 - lo##1_1_1_1_0_0 < hi#0 - lo#0;
    call CallPre$$UTF8.__default.ValidUTF8Embed(a##1_1_1_1_0_0, b##1_1_1_1_0_0, c##1_1_1_1_0_0, lo##1_1_1_1_0_0, hi##1_1_1_1_0_0);
    call CallPost$$UTF8.__default.ValidUTF8Embed(a##1_1_1_1_0_0, b##1_1_1_1_0_0, c##1_1_1_1_0_0, lo##1_1_1_1_0_0, hi##1_1_1_1_0_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(175,43)"} true;
    return;

  anon24_Else:
    assume {:partition} !(LitInt(4) <= Seq#Length(r#1_0) && UTF8.__default.Uses4Bytes(r#1_0));
    return;
}



function UTF8.__default.ValidUTF8Seq(s#0: Seq) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UTF8.__default.ValidUTF8Seq(s#0) } UTF8.__default.ValidUTF8Seq#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) ==> UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) && (UTF8.__default.ValidUTF8Seq(s#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0))));
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UTF8.__default.ValidUTF8Seq(Lit(s#0)) } UTF8.__default.ValidUTF8Seq#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(s#0), LitInt(0), Seq#Length(Lit(s#0))) && (UTF8.__default.ValidUTF8Seq(Lit(s#0)) <==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(s#0), LitInt(0), Seq#Length(Lit(s#0)))));
}

function UTF8.__default.ValidUTF8Seq#canCall(s#0: Seq) : bool;

function UTF8.__default.ValidUTF8Seq#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UTF8.__default.ValidUTF8Seq#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UTF8.__default.ValidUTF8Seq#requires(s#0) <==> true));

procedure {:verboseName "UTF8.ValidUTF8Seq (well-formedness)"} CheckWellformed$$UTF8.__default.ValidUTF8Seq(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.ValidUTF8Seq (well-formedness)"} CheckWellformed$$UTF8.__default.ValidUTF8Seq(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##a#0: Seq;
  var ##lo#0: int;
  var ##hi#0: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Seq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(180,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    ##a#0 := s#0;
    assume $IsAlloc(##a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##lo#0 := LitInt(0);
    assume $IsAlloc(##lo#0, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(s#0), Tclass._System.nat());
    ##hi#0 := Seq#Length(s#0);
    assume $IsAlloc(##hi#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#0 <= ##hi#0;
    assume {:subsumption 0} ##hi#0 <= Seq#Length(##a#0);
    assume ##lo#0 <= ##hi#0 && ##hi#0 <= Seq#Length(##a#0);
    assume UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0));
    assume UTF8.__default.ValidUTF8Seq(s#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0));
    assume UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0));
    assume $Is(UTF8.__default.ValidUTF8Seq(s#0), TBool);
    return;
}



procedure {:verboseName "UTF8.ValidUTF8Concat (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$UTF8.__default.ValidUTF8Concat(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), t#0: Seq where $Is(t#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(t#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UTF8.ValidUTF8Concat (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$UTF8.__default.ValidUTF8Concat(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), t#0: Seq where $Is(t#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(t#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id3033"} UTF8.__default.ValidUTF8Seq#canCall(s#0) ==> UTF8.__default.ValidUTF8Seq(s#0) || (UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0)) || (LitInt(0) == Seq#Length(s#0) ==> Lit(true)));
  requires {:id "id3034"} UTF8.__default.ValidUTF8Seq#canCall(s#0) ==> UTF8.__default.ValidUTF8Seq(s#0) || (UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0)) || (LitInt(0) != Seq#Length(s#0) ==> (var r#0 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), LitInt(0)); UTF8.__default.Uses1Byte(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, LitInt(0 + 1), Seq#Length(s#0)))));
  requires {:id "id3035"} UTF8.__default.ValidUTF8Seq#canCall(s#0) ==> UTF8.__default.ValidUTF8Seq(s#0) || (UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0)) || (LitInt(0) != Seq#Length(s#0) ==> (var r#0 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, LitInt(0 + 2), Seq#Length(s#0)))));
  requires {:id "id3036"} UTF8.__default.ValidUTF8Seq#canCall(s#0) ==> UTF8.__default.ValidUTF8Seq(s#0) || (UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0)) || (LitInt(0) != Seq#Length(s#0) ==> (var r#0 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, LitInt(0 + 3), Seq#Length(s#0)))));
  requires {:id "id3037"} UTF8.__default.ValidUTF8Seq#canCall(s#0) ==> UTF8.__default.ValidUTF8Seq(s#0) || (UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0)) || (LitInt(0) != Seq#Length(s#0) ==> (var r#0 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, LitInt(0 + 4), Seq#Length(s#0)))));
  requires {:id "id3038"} UTF8.__default.ValidUTF8Seq#canCall(s#0) ==> UTF8.__default.ValidUTF8Seq(s#0) || (UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0)) || (LitInt(0) != Seq#Length(s#0) ==> (var r#0 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> !(LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0)) ==> Lit(false))));
  requires {:id "id3039"} UTF8.__default.ValidUTF8Seq#canCall(t#0) ==> UTF8.__default.ValidUTF8Seq(t#0) || (UTF8.__default.ValidUTF8Range#canCall(t#0, LitInt(0), Seq#Length(t#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0)) || (LitInt(0) == Seq#Length(t#0) ==> Lit(true)));
  requires {:id "id3040"} UTF8.__default.ValidUTF8Seq#canCall(t#0) ==> UTF8.__default.ValidUTF8Seq(t#0) || (UTF8.__default.ValidUTF8Range#canCall(t#0, LitInt(0), Seq#Length(t#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0)) || (LitInt(0) != Seq#Length(t#0) ==> (var r#1 := Seq#Drop(Seq#Take(t#0, Seq#Length(t#0)), LitInt(0)); UTF8.__default.Uses1Byte(r#1) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), t#0, LitInt(0 + 1), Seq#Length(t#0)))));
  requires {:id "id3041"} UTF8.__default.ValidUTF8Seq#canCall(t#0) ==> UTF8.__default.ValidUTF8Seq(t#0) || (UTF8.__default.ValidUTF8Range#canCall(t#0, LitInt(0), Seq#Length(t#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0)) || (LitInt(0) != Seq#Length(t#0) ==> (var r#1 := Seq#Drop(Seq#Take(t#0, Seq#Length(t#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#1) ==> LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), t#0, LitInt(0 + 2), Seq#Length(t#0)))));
  requires {:id "id3042"} UTF8.__default.ValidUTF8Seq#canCall(t#0) ==> UTF8.__default.ValidUTF8Seq(t#0) || (UTF8.__default.ValidUTF8Range#canCall(t#0, LitInt(0), Seq#Length(t#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0)) || (LitInt(0) != Seq#Length(t#0) ==> (var r#1 := Seq#Drop(Seq#Take(t#0, Seq#Length(t#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#1) ==> !(LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1)) ==> LitInt(3) <= Seq#Length(r#1) && UTF8.__default.Uses3Bytes(r#1) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), t#0, LitInt(0 + 3), Seq#Length(t#0)))));
  requires {:id "id3043"} UTF8.__default.ValidUTF8Seq#canCall(t#0) ==> UTF8.__default.ValidUTF8Seq(t#0) || (UTF8.__default.ValidUTF8Range#canCall(t#0, LitInt(0), Seq#Length(t#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0)) || (LitInt(0) != Seq#Length(t#0) ==> (var r#1 := Seq#Drop(Seq#Take(t#0, Seq#Length(t#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#1) ==> !(LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1)) ==> !(LitInt(3) <= Seq#Length(r#1) && UTF8.__default.Uses3Bytes(r#1)) ==> LitInt(4) <= Seq#Length(r#1) && UTF8.__default.Uses4Bytes(r#1) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), t#0, LitInt(0 + 4), Seq#Length(t#0)))));
  requires {:id "id3044"} UTF8.__default.ValidUTF8Seq#canCall(t#0) ==> UTF8.__default.ValidUTF8Seq(t#0) || (UTF8.__default.ValidUTF8Range#canCall(t#0, LitInt(0), Seq#Length(t#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0)) || (LitInt(0) != Seq#Length(t#0) ==> (var r#1 := Seq#Drop(Seq#Take(t#0, Seq#Length(t#0)), LitInt(0)); !UTF8.__default.Uses1Byte(r#1) ==> !(LitInt(2) <= Seq#Length(r#1) && UTF8.__default.Uses2Bytes(r#1)) ==> !(LitInt(3) <= Seq#Length(r#1) && UTF8.__default.Uses3Bytes(r#1)) ==> !(LitInt(4) <= Seq#Length(r#1) && UTF8.__default.Uses4Bytes(r#1)) ==> Lit(false))));



procedure {:verboseName "UTF8.ValidUTF8Concat (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$UTF8.__default.ValidUTF8Concat(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), t#0: Seq where $Is(t#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(t#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id3045"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) && UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) && UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UTF8.ValidUTF8Concat (correctness)"} {:vcs_split_on_every_assert} Impl$$UTF8.__default.ValidUTF8Concat(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), t#0: Seq where $Is(t#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(t#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id3046"} UTF8.__default.ValidUTF8Seq#canCall(s#0) && UTF8.__default.ValidUTF8Seq(s#0) && UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0));
  free requires {:id "id3047"} UTF8.__default.ValidUTF8Seq#canCall(t#0) && UTF8.__default.ValidUTF8Seq(t#0) && UTF8.__default.ValidUTF8Range($LS($LZ), t#0, LitInt(0), Seq#Length(t#0));
  modifies $Heap;
  free ensures UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id3048"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) == Seq#Length(Seq#Append(s#0, t#0)) ==> Lit(true)));
  free ensures {:id "id3049"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#5 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); UTF8.__default.Uses1Byte(r#5) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 1), Seq#Length(Seq#Append(s#0, t#0))))));
  free ensures {:id "id3050"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#5 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#5) ==> LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 2), Seq#Length(Seq#Append(s#0, t#0))))));
  free ensures {:id "id3051"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#5 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#5) ==> !(LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5)) ==> LitInt(3) <= Seq#Length(r#5) && UTF8.__default.Uses3Bytes(r#5) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 3), Seq#Length(Seq#Append(s#0, t#0))))));
  free ensures {:id "id3052"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#5 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#5) ==> !(LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5)) ==> !(LitInt(3) <= Seq#Length(r#5) && UTF8.__default.Uses3Bytes(r#5)) ==> LitInt(4) <= Seq#Length(r#5) && UTF8.__default.Uses4Bytes(r#5) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 4), Seq#Length(Seq#Append(s#0, t#0))))));
  free ensures {:id "id3053"} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#5 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#5) ==> !(LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5)) ==> !(LitInt(3) <= Seq#Length(r#5) && UTF8.__default.Uses3Bytes(r#5)) ==> !(LitInt(4) <= Seq#Length(r#5) && UTF8.__default.Uses4Bytes(r#5)) ==> Lit(false))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.ValidUTF8Concat (correctness)"} {:vcs_split_on_every_assert} Impl$$UTF8.__default.ValidUTF8Concat(s#0: Seq, t#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var lo#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##a#0: Seq;
  var ##lo#0: int;
  var ##hi#0: int;
  var ##a#1: Seq;
  var ##lo#1: int;
  var ##hi#1: int;
  var ##a#2: Seq;
  var ##lo#2: int;
  var ##hi#2: int;
  var ##a#3: Seq;
  var ##lo#3: int;
  var ##hi#3: int;
  var ##a#4: Seq;
  var ##lo#4: int;
  var ##hi#4: int;
  var $decr$loop#00: int;
  var r#0_0: Seq where $Is(r#0_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(r#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var ##s#0_0: Seq;
  var ##s#0_1_0: Seq;
  var ##s#0_1_1_0: Seq;
  var ##s#0_1_1_1_0: Seq;
  var ##s#3: Seq;
  var a##1_0: Seq;
  var b##1_0: Seq;
  var c##1_0: Seq;
  var lo##1_0: int;
  var hi##1_0: int;

  anon0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Concat", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(187,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    lo#0 := LitInt(0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(188,15)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(s#0) - lo#0;
    havoc $w$loop#0;
    goto anon33_LoopHead;

  anon33_LoopHead:
    assume true;
    assume $w$loop#0 ==> lo#0 <= Seq#Length(s#0);
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) || (lo#0 == Seq#Length(s#0) ==> Lit(true));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) || (lo#0 != Seq#Length(s#0) ==> (var r#6 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), lo#0); UTF8.__default.Uses1Byte(r#6) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, lo#0 + 1, Seq#Length(s#0))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) || (lo#0 != Seq#Length(s#0) ==> (var r#6 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), lo#0); !UTF8.__default.Uses1Byte(r#6) ==> LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, lo#0 + 2, Seq#Length(s#0))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) || (lo#0 != Seq#Length(s#0) ==> (var r#6 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), lo#0); !UTF8.__default.Uses1Byte(r#6) ==> !(LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6)) ==> LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, lo#0 + 3, Seq#Length(s#0))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) || (lo#0 != Seq#Length(s#0) ==> (var r#6 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), lo#0); !UTF8.__default.Uses1Byte(r#6) ==> !(LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6)) ==> !(LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6)) ==> LitInt(4) <= Seq#Length(r#6) && UTF8.__default.Uses4Bytes(r#6) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), s#0, lo#0 + 4, Seq#Length(s#0))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) || (lo#0 != Seq#Length(s#0) ==> (var r#6 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), lo#0); !UTF8.__default.Uses1Byte(r#6) ==> !(LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6)) ==> !(LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6)) ==> !(LitInt(4) <= Seq#Length(r#6) && UTF8.__default.Uses4Bytes(r#6)) ==> Lit(false)));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) && UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) && (if lo#0 == Seq#Length(s#0) then true else (var r#6 := Seq#Drop(Seq#Take(s#0, Seq#Length(s#0)), lo#0); (if UTF8.__default.Uses1Byte(r#6) then UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0 + 1, Seq#Length(s#0)) else (if LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6) then UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0 + 2, Seq#Length(s#0)) else (if LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6) then UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0 + 3, Seq#Length(s#0)) else (if LitInt(4) <= Seq#Length(r#6) && UTF8.__default.Uses4Bytes(r#6) then UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0 + 4, Seq#Length(s#0)) else false))))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) && (UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) || (lo#0 == Seq#Length(Seq#Append(s#0, t#0)) ==> Lit(true));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) || (lo#0 != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#7 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), lo#0); UTF8.__default.Uses1Byte(r#7) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), lo#0 + 1, Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) || (lo#0 != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#7 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), lo#0); !UTF8.__default.Uses1Byte(r#7) ==> LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), lo#0 + 2, Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) || (lo#0 != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#7 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), lo#0); !UTF8.__default.Uses1Byte(r#7) ==> !(LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7)) ==> LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), lo#0 + 3, Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) || (lo#0 != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#7 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), lo#0); !UTF8.__default.Uses1Byte(r#7) ==> !(LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7)) ==> !(LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7)) ==> LitInt(4) <= Seq#Length(r#7) && UTF8.__default.Uses4Bytes(r#7) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), lo#0 + 4, Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) || (lo#0 != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#7 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), lo#0); !UTF8.__default.Uses1Byte(r#7) ==> !(LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7)) ==> !(LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7)) ==> !(LitInt(4) <= Seq#Length(r#7) && UTF8.__default.Uses4Bytes(r#7)) ==> Lit(false)));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) && UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) && (if lo#0 == Seq#Length(Seq#Append(s#0, t#0)) then true else (var r#7 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), lo#0); (if UTF8.__default.Uses1Byte(r#7) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0 + 1, Seq#Length(Seq#Append(s#0, t#0))) else (if LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0 + 2, Seq#Length(Seq#Append(s#0, t#0))) else (if LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0 + 3, Seq#Length(Seq#Append(s#0, t#0))) else (if LitInt(4) <= Seq#Length(r#7) && UTF8.__default.Uses4Bytes(r#7) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0 + 4, Seq#Length(Seq#Append(s#0, t#0))) else false))))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) && (UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) == Seq#Length(Seq#Append(s#0, t#0)) ==> Lit(true));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#8 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); UTF8.__default.Uses1Byte(r#8) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 1), Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#8 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#8) ==> LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 2), Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#8 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#8) ==> !(LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8)) ==> LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 3), Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#8 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#8) ==> !(LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8)) ==> !(LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8)) ==> LitInt(4) <= Seq#Length(r#8) && UTF8.__default.Uses4Bytes(r#8) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 4), Seq#Length(Seq#Append(s#0, t#0)))));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#8 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#8) ==> !(LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8)) ==> !(LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8)) ==> !(LitInt(4) <= Seq#Length(r#8) && UTF8.__default.Uses4Bytes(r#8)) ==> Lit(false)));
    assume $w$loop#0 ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) && UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) && (if LitInt(0) == Seq#Length(Seq#Append(s#0, t#0)) then true else (var r#8 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); (if UTF8.__default.Uses1Byte(r#8) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0 + 1), Seq#Length(Seq#Append(s#0, t#0))) else (if LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0 + 2), Seq#Length(Seq#Append(s#0, t#0))) else (if LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0 + 3), Seq#Length(Seq#Append(s#0, t#0))) else (if LitInt(4) <= Seq#Length(r#8) && UTF8.__default.Uses4Bytes(r#8) then UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0 + 4), Seq#Length(Seq#Append(s#0, t#0))) else false))))));
    assume $PreLoopHeap$loop#0 == $Heap;
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume Seq#Length(s#0) - lo#0 <= $decr_init$loop#00;
    goto anon33_LoopDone, anon33_LoopBody;

  anon33_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(189,4): after some loop iterations"} true;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} !$w$loop#0;
    assume true;
    assume lo#0 <= Seq#Length(s#0);
    ##a#0 := s#0;
    assume $IsAlloc(##a#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0, Tclass._System.nat());
    ##lo#0 := lo#0;
    assume $IsAlloc(##lo#0, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(s#0), Tclass._System.nat());
    ##hi#0 := Seq#Length(s#0);
    assume $IsAlloc(##hi#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#0 <= ##hi#0;
    assume {:subsumption 0} ##hi#0 <= Seq#Length(##a#0);
    assume UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0));
    assume UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0));
    assume UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0));
    ##a#1 := Seq#Append(s#0, t#0);
    assume $IsAlloc(##a#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##lo#1 := LitInt(0);
    assume $IsAlloc(##lo#1, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(Seq#Append(s#0, t#0)), Tclass._System.nat());
    ##hi#1 := Seq#Length(Seq#Append(s#0, t#0));
    assume $IsAlloc(##hi#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#1 <= ##hi#1;
    assume {:subsumption 0} ##hi#1 <= Seq#Length(##a#1);
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0)));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0)));
    ##a#2 := Seq#Append(s#0, t#0);
    assume $IsAlloc(##a#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0, Tclass._System.nat());
    ##lo#2 := lo#0;
    assume $IsAlloc(##lo#2, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(Seq#Append(s#0, t#0)), Tclass._System.nat());
    ##hi#2 := Seq#Length(Seq#Append(s#0, t#0));
    assume $IsAlloc(##hi#2, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#2 <= ##hi#2;
    assume {:subsumption 0} ##hi#2 <= Seq#Length(##a#2);
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)));
    goto anon4;

  anon35_Else:
    assume {:partition} !UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0)));
    goto anon4;

  anon4:
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) && (UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))));
    assume UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)));
    ##a#3 := Seq#Append(s#0, t#0);
    assume $IsAlloc(##a#3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(lo#0, Tclass._System.nat());
    ##lo#3 := lo#0;
    assume $IsAlloc(##lo#3, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(Seq#Append(s#0, t#0)), Tclass._System.nat());
    ##hi#3 := Seq#Length(Seq#Append(s#0, t#0));
    assume $IsAlloc(##hi#3, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#3 <= ##hi#3;
    assume {:subsumption 0} ##hi#3 <= Seq#Length(##a#3);
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)));
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)));
    ##a#4 := Seq#Append(s#0, t#0);
    assume $IsAlloc(##a#4, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##lo#4 := LitInt(0);
    assume $IsAlloc(##lo#4, Tclass._System.nat(), $Heap);
    assume $Is(Seq#Length(Seq#Append(s#0, t#0)), Tclass._System.nat());
    ##hi#4 := Seq#Length(Seq#Append(s#0, t#0));
    assume $IsAlloc(##hi#4, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##lo#4 <= ##hi#4;
    assume {:subsumption 0} ##hi#4 <= Seq#Length(##a#4);
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0)));
    goto anon6;

  anon36_Else:
    assume {:partition} !UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)));
    goto anon6;

  anon6:
    assume UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) && (UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))));
    assume UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0)));
    assume true;
    assume false;
    goto anon7;

  anon34_Else:
    assume {:partition} $w$loop#0;
    goto anon7;

  anon7:
    assume true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} Seq#Length(s#0) <= lo#0;
    goto anon28;

  anon37_Else:
    assume {:partition} lo#0 < Seq#Length(s#0);
    $decr$loop#00 := Seq#Length(s#0) - lo#0;
    push;
    assume true;
    assume 0 <= lo#0 && lo#0 <= Seq#Length(Seq#Append(s#0, t#0));
    assume true;
    r#0_0 := Seq#Drop(Seq#Append(s#0, t#0), lo#0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(195,28)"} true;
    ##s#0_0 := r#0_0;
    assume $IsAlloc(##s#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0_0) >= LitInt(1);
    assume Seq#Length(##s#0_0) >= LitInt(1);
    assume UTF8.__default.Uses1Byte#canCall(r#0_0);
    assume UTF8.__default.Uses1Byte#canCall(r#0_0);
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} UTF8.__default.Uses1Byte(r#0_0);
    push;
    assume true;
    assume true;
    lo#0 := lo#0 + 1;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(197,20)"} true;
    pop;
    goto anon27;

  anon38_Else:
    assume {:partition} !UTF8.__default.Uses1Byte(r#0_0);
    push;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} LitInt(2) <= Seq#Length(r#0_0);
    ##s#0_1_0 := r#0_0;
    assume $IsAlloc(##s#0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0_1_0) >= LitInt(2);
    assume Seq#Length(##s#0_1_0) >= LitInt(2);
    assume UTF8.__default.Uses2Bytes#canCall(r#0_0);
    goto anon13;

  anon39_Else:
    assume {:partition} Seq#Length(r#0_0) < LitInt(2);
    goto anon13;

  anon13:
    assume LitInt(2) <= Seq#Length(r#0_0) ==> UTF8.__default.Uses2Bytes#canCall(r#0_0);
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} LitInt(2) <= Seq#Length(r#0_0) && UTF8.__default.Uses2Bytes(r#0_0);
    push;
    assume true;
    assume true;
    lo#0 := lo#0 + 2;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(199,20)"} true;
    pop;
    goto anon26;

  anon40_Else:
    assume {:partition} !(LitInt(2) <= Seq#Length(r#0_0) && UTF8.__default.Uses2Bytes(r#0_0));
    push;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} LitInt(3) <= Seq#Length(r#0_0);
    ##s#0_1_1_0 := r#0_0;
    assume $IsAlloc(##s#0_1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0_1_1_0) >= LitInt(3);
    assume Seq#Length(##s#0_1_1_0) >= LitInt(3);
    assume UTF8.__default.Uses3Bytes#canCall(r#0_0);
    goto anon17;

  anon41_Else:
    assume {:partition} Seq#Length(r#0_0) < LitInt(3);
    goto anon17;

  anon17:
    assume LitInt(3) <= Seq#Length(r#0_0) ==> UTF8.__default.Uses3Bytes#canCall(r#0_0);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} LitInt(3) <= Seq#Length(r#0_0) && UTF8.__default.Uses3Bytes(r#0_0);
    push;
    assume true;
    assume true;
    lo#0 := lo#0 + 3;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(201,20)"} true;
    pop;
    goto anon25;

  anon42_Else:
    assume {:partition} !(LitInt(3) <= Seq#Length(r#0_0) && UTF8.__default.Uses3Bytes(r#0_0));
    push;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(4) <= Seq#Length(r#0_0);
    ##s#0_1_1_1_0 := r#0_0;
    assume $IsAlloc(##s#0_1_1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0_1_1_1_0) >= LitInt(4);
    assume Seq#Length(##s#0_1_1_1_0) >= LitInt(4);
    assume UTF8.__default.Uses4Bytes#canCall(r#0_0);
    goto anon21;

  anon43_Else:
    assume {:partition} Seq#Length(r#0_0) < LitInt(4);
    goto anon21;

  anon21:
    assume LitInt(4) <= Seq#Length(r#0_0) ==> UTF8.__default.Uses4Bytes#canCall(r#0_0);
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(4) <= Seq#Length(r#0_0) && UTF8.__default.Uses4Bytes(r#0_0);
    push;
    assume true;
    assume true;
    lo#0 := lo#0 + 4;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(203,20)"} true;
    pop;
    goto anon24;

  anon44_Else:
    assume {:partition} !(LitInt(4) <= Seq#Length(r#0_0) && UTF8.__default.Uses4Bytes(r#0_0));
    goto anon24;

  anon24:
    pop;
    goto anon25;

  anon25:
    pop;
    goto anon26;

  anon26:
    pop;
    goto anon27;

  anon27:
    pop;
    assume 0 <= $decr$loop#00 || Seq#Length(s#0) - lo#0 == $decr$loop#00;
    assume Seq#Length(s#0) - lo#0 < $decr$loop#00;
    assume lo#0 <= Seq#Length(s#0) ==> UTF8.__default.ValidUTF8Range#canCall(s#0, lo#0, Seq#Length(s#0)) && (UTF8.__default.ValidUTF8Range($LS($LZ), s#0, lo#0, Seq#Length(s#0)) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) && (UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)))) && ((UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0)))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) && (UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), lo#0, Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))))));
    goto anon33_LoopHead;

  anon33_LoopDone:
    assume {:partition} false;
    goto anon28;

  anon28:
    ##s#3 := Seq#Append(s#0, t#0);
    assume $IsAlloc(##s#3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0));
    assume UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0));
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume true;
    a##1_0 := s#0;
    assume true;
    b##1_0 := t#0;
    assume true;
    c##1_0 := Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    lo##1_0 := LitInt(0);
    assume true;
    assume $Is(Seq#Length(t#0), Tclass._System.nat());
    hi##1_0 := Seq#Length(t#0);
    call CallPre$$UTF8.__default.ValidUTF8Embed(a##1_0, b##1_0, c##1_0, lo##1_0, hi##1_0);
    call CallPost$$UTF8.__default.ValidUTF8Embed(a##1_0, b##1_0, c##1_0, lo##1_0, hi##1_0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(207,38)"} true;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} Seq#Equal(Seq#Append(s#0, t#0), Seq#Append(Seq#Append(s#0, t#0), Seq#Empty(): Seq));
    goto anon31;

  anon46_Else:
    assume {:partition} !Seq#Equal(Seq#Append(s#0, t#0), Seq#Append(Seq#Append(s#0, t#0), Seq#Empty(): Seq));
    goto anon31;

  anon31:
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Append(s#0, t#0), Seq#Append(Seq#Append(s#0, t#0), Seq#Empty(): Seq));
    assume {:subsumption 0} lo#0 == Seq#Length(s#0);
    assume Seq#Equal(Seq#Append(s#0, t#0), Seq#Append(Seq#Append(s#0, t#0), Seq#Empty(): Seq)) && lo#0 == Seq#Length(s#0);
    assume {:captureState "StandardLibrary/src/UTF8.dfy(208,45)"} true;
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) == Seq#Length(Seq#Append(s#0, t#0)) ==> Lit(true)));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#9 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); UTF8.__default.Uses1Byte(r#9) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 1), Seq#Length(Seq#Append(s#0, t#0))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#9 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#9) ==> LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 2), Seq#Length(Seq#Append(s#0, t#0))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#9 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#9) ==> !(LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9)) ==> LitInt(3) <= Seq#Length(r#9) && UTF8.__default.Uses3Bytes(r#9) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 3), Seq#Length(Seq#Append(s#0, t#0))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#9 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#9) ==> !(LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9)) ==> !(LitInt(3) <= Seq#Length(r#9) && UTF8.__default.Uses3Bytes(r#9)) ==> LitInt(4) <= Seq#Length(r#9) && UTF8.__default.Uses4Bytes(r#9) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Seq#Append(s#0, t#0), LitInt(0 + 4), Seq#Length(Seq#Append(s#0, t#0))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Seq#Append(s#0, t#0)) ==> UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0)) || (UTF8.__default.ValidUTF8Range#canCall(Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Seq#Append(s#0, t#0), LitInt(0), Seq#Length(Seq#Append(s#0, t#0))) || (LitInt(0) != Seq#Length(Seq#Append(s#0, t#0)) ==> (var r#9 := Seq#Drop(Seq#Take(Seq#Append(s#0, t#0), Seq#Length(Seq#Append(s#0, t#0))), LitInt(0)); !UTF8.__default.Uses1Byte(r#9) ==> !(LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9)) ==> !(LitInt(3) <= Seq#Length(r#9) && UTF8.__default.Uses3Bytes(r#9)) ==> !(LitInt(4) <= Seq#Length(r#9) && UTF8.__default.Uses4Bytes(r#9)) ==> Lit(false))));
    assume false;
    goto anon32;

  anon45_Else:
    goto anon32;

  anon32:
    assume UTF8.__default.ValidUTF8Seq(Seq#Append(s#0, t#0));
    assume {:captureState "StandardLibrary/src/UTF8.dfy(209,4)"} true;
    return;
}



procedure {:verboseName "UTF8.reveal_EncodeAscii (well-formedness)"} {:verify false} CheckWellFormed$$UTF8.__default.reveal__EncodeAscii();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UTF8.reveal_EncodeAscii (call precondtion)"} {:verify false} CallPre$$UTF8.__default.reveal__EncodeAscii();



procedure {:verboseName "UTF8.reveal_EncodeAscii (call postcondition)"} {:verify false} CallPost$$UTF8.__default.reveal__EncodeAscii();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_UTF8._default.EncodeAscii;



procedure {:verboseName "UTF8.ValidUTF8Bytes (well-formedness)"} CheckWellFormed$$UTF8.ValidUTF8Bytes(i#0: Seq where $Is(i#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UTF8.ValidUTF8Bytes (well-formedness)"} CheckWellFormed$$UTF8.ValidUTF8Bytes(i#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Bytes", " | ", i#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UTF8.dfy(21,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := i#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UTF8.__default.ValidUTF8Seq#canCall(i#0);
    assume UTF8.__default.ValidUTF8Seq(i#0);
    return;

  anon4_Else:
    assume UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UTF8.__default.ValidUTF8Seq(Lit(Seq#Empty(): Seq))) || (UTF8.__default.ValidUTF8Range#canCall(Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) || (LitInt(0) == Seq#Length(Lit(Seq#Empty(): Seq)) ==> Lit(true)));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UTF8.__default.ValidUTF8Seq(Lit(Seq#Empty(): Seq))) || (UTF8.__default.ValidUTF8Range#canCall(Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) || (LitInt(0) != Seq#Length(Lit(Seq#Empty(): Seq)) ==> (var r#0 := Seq#Drop(Seq#Take(Lit(Seq#Empty(): Seq), Seq#Length(Lit(Seq#Empty(): Seq))), LitInt(0)); UTF8.__default.Uses1Byte(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Lit(Seq#Empty(): Seq), LitInt(0 + 1), Seq#Length(Lit(Seq#Empty(): Seq))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UTF8.__default.ValidUTF8Seq(Lit(Seq#Empty(): Seq))) || (UTF8.__default.ValidUTF8Range#canCall(Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) || (LitInt(0) != Seq#Length(Lit(Seq#Empty(): Seq)) ==> (var r#0 := Seq#Drop(Seq#Take(Lit(Seq#Empty(): Seq), Seq#Length(Lit(Seq#Empty(): Seq))), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Lit(Seq#Empty(): Seq), LitInt(0 + 2), Seq#Length(Lit(Seq#Empty(): Seq))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UTF8.__default.ValidUTF8Seq(Lit(Seq#Empty(): Seq))) || (UTF8.__default.ValidUTF8Range#canCall(Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) || (LitInt(0) != Seq#Length(Lit(Seq#Empty(): Seq)) ==> (var r#0 := Seq#Drop(Seq#Take(Lit(Seq#Empty(): Seq), Seq#Length(Lit(Seq#Empty(): Seq))), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Lit(Seq#Empty(): Seq), LitInt(0 + 3), Seq#Length(Lit(Seq#Empty(): Seq))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UTF8.__default.ValidUTF8Seq(Lit(Seq#Empty(): Seq))) || (UTF8.__default.ValidUTF8Range#canCall(Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) || (LitInt(0) != Seq#Length(Lit(Seq#Empty(): Seq)) ==> (var r#0 := Seq#Drop(Seq#Take(Lit(Seq#Empty(): Seq), Seq#Length(Lit(Seq#Empty(): Seq))), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0) ==> UTF8.__default.ValidUTF8Range($LS($LS($LZ)), Lit(Seq#Empty(): Seq), LitInt(0 + 4), Seq#Length(Lit(Seq#Empty(): Seq))))));
    assume {:subsumption 0} UTF8.__default.ValidUTF8Seq#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UTF8.__default.ValidUTF8Seq(Lit(Seq#Empty(): Seq))) || (UTF8.__default.ValidUTF8Range#canCall(Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) ==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(Seq#Empty(): Seq), LitInt(0), Seq#Length(Lit(Seq#Empty(): Seq))) || (LitInt(0) != Seq#Length(Lit(Seq#Empty(): Seq)) ==> (var r#0 := Seq#Drop(Seq#Take(Lit(Seq#Empty(): Seq), Seq#Length(Lit(Seq#Empty(): Seq))), LitInt(0)); !UTF8.__default.Uses1Byte(r#0) ==> !(LitInt(2) <= Seq#Length(r#0) && UTF8.__default.Uses2Bytes(r#0)) ==> !(LitInt(3) <= Seq#Length(r#0) && UTF8.__default.Uses3Bytes(r#0)) ==> !(LitInt(4) <= Seq#Length(r#0) && UTF8.__default.Uses4Bytes(r#0)) ==> Lit(false))));
    return;
}



axiom (forall i#0: Seq :: { $Is(i#0, Tclass.UTF8.ValidUTF8Bytes()) } $Is(i#0, Tclass.UTF8.ValidUTF8Bytes()) <==> $Is(i#0, TSeq(Tclass.BoundedInts.uint8())) && UTF8.__default.ValidUTF8Seq(i#0));

axiom (forall i#0: Seq, $h: Heap :: { $IsAlloc(i#0, Tclass.UTF8.ValidUTF8Bytes(), $h) } $IsAlloc(i#0, Tclass.UTF8.ValidUTF8Bytes(), $h) <==> $IsAlloc(i#0, TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#12 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#12))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#14 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#14)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#18 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#18))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#20 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#20)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#22 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#22)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#18 := Wrappers.Option.value(this); v#18)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#20 := Lit(Wrappers.Option.value(Lit(this))); v#20)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#22 := Lit(Wrappers.Option.value(Lit(this))); v#22)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#12 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#12)) else (var e#12 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#14 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#14))) else (var e#14 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#18 := Wrappers.Result.value(this); s#18) else (var e#18 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#20 := Lit(Wrappers.Result.value(Lit(this))); s#20) else (var e#20 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#22 := Lit(Wrappers.Result.value(Lit(this))); s#22) else (var e#22 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#18 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#18)) else (var e#18 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#18)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#20 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#20))) else (var e#20 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#20)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#22 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#22))) else (var e#22 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#22)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#8 := Div(x#0, LitInt(256)); (var b1#8 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#8)), $Box(b1#8)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#9 := LitInt(Div(x#0, LitInt(256))); (var b1#9 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#9)), $Box(b1#9))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#8 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#9 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#9 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#8 := Div(x#0, LitInt(16777216)); (var x0#8 := x#0 - Mul(b0#8, LitInt(16777216)); (var b1#8 := Div(x0#8, LitInt(65536)); (var x1#8 := x0#8 - Mul(b1#8, LitInt(65536)); (var b2#8 := Div(x1#8, LitInt(256)); (var b3#8 := Mod(x1#8, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#8)), $Box(b1#8)), $Box(b2#8)), $Box(b3#8)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#9 := LitInt(Div(x#0, LitInt(16777216))); (var x0#9 := LitInt(x#0 - Mul(b0#9, LitInt(16777216))); (var b1#9 := LitInt(Div(x0#9, LitInt(65536))); (var x1#9 := LitInt(x0#9 - Mul(b1#9, LitInt(65536))); (var b2#9 := LitInt(Div(x1#9, LitInt(256))); (var b3#9 := LitInt(Mod(x1#9, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#9)), $Box(b1#9)), $Box(b2#9)), $Box(b3#9))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#8 := x0#8 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#8 := x1#8 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#8 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#9 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#9 := x0#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#9 := x1#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#9 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#8 := Div(x#0, LitInt(72057594037927936)); (var x0#8 := x#0 - Mul(b0#8, LitInt(72057594037927936)); (var b1#8 := Div(x0#8, LitInt(281474976710656)); (var x1#8 := x0#8 - Mul(b1#8, LitInt(281474976710656)); (var b2#8 := Div(x1#8, LitInt(1099511627776)); (var x2#8 := x1#8 - Mul(b2#8, LitInt(1099511627776)); (var b3#8 := Div(x2#8, LitInt(4294967296)); (var x3#8 := x2#8 - Mul(b3#8, LitInt(4294967296)); (var b4#8 := Div(x3#8, LitInt(16777216)); (var x4#8 := x3#8 - Mul(b4#8, LitInt(16777216)); (var b5#8 := Div(x4#8, LitInt(65536)); (var x5#8 := x4#8 - Mul(b5#8, LitInt(65536)); (var b6#8 := Div(x5#8, LitInt(256)); (var b7#8 := Mod(x5#8, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#8)), $Box(b1#8)), $Box(b2#8)), $Box(b3#8)), $Box(b4#8)), $Box(b5#8)), $Box(b6#8)), $Box(b7#8)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#9 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#9 := LitInt(x#0 - Mul(b0#9, LitInt(72057594037927936))); (var b1#9 := LitInt(Div(x0#9, LitInt(281474976710656))); (var x1#9 := LitInt(x0#9 - Mul(b1#9, LitInt(281474976710656))); (var b2#9 := LitInt(Div(x1#9, LitInt(1099511627776))); (var x2#9 := LitInt(x1#9 - Mul(b2#9, LitInt(1099511627776))); (var b3#9 := LitInt(Div(x2#9, LitInt(4294967296))); (var x3#9 := LitInt(x2#9 - Mul(b3#9, LitInt(4294967296))); (var b4#9 := LitInt(Div(x3#9, LitInt(16777216))); (var x4#9 := LitInt(x3#9 - Mul(b4#9, LitInt(16777216))); (var b5#9 := LitInt(Div(x4#9, LitInt(65536))); (var x5#9 := LitInt(x4#9 - Mul(b5#9, LitInt(65536))); (var b6#9 := LitInt(Div(x5#9, LitInt(256))); (var b7#9 := LitInt(Mod(x5#9, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#9)), $Box(b1#9)), $Box(b2#9)), $Box(b3#9)), $Box(b4#9)), $Box(b5#9)), $Box(b6#9)), $Box(b7#9))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#8 := x0#8 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#8 := x1#8 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#8 := x2#8 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#8 := x3#8 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#8 := x4#8 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#8 := x5#8 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#9 := x6#8 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#9)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#9 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#9 := x0#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#9 := x1#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#9 := x2#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#9 := x3#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#9 := x4#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#9 := x5#9 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#10 := x6#9 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#10)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#8 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#8)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#8 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#8)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#8)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#9 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#9)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#9 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#9)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#9)): int)));

const unique tytagFamily$ValidUTF8Bytes: TyTagFamily;

const unique class.AwsCryptographyPrimitivesTypes.__default: ClassName;

function AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#canCall(x#0) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0) <==> LitInt(0) <= x#0));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#canCall(LitInt(x#0)) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(LitInt(x#0)) <==> LitInt(0) <= LitInt(x#0)));
}

function AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#requires(x#0) } LitInt(-2147483648) <= x#0 && x#0 < 2147483648 ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#requires(x#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_PositiveInteger (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_PositiveInteger (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IsValid_PositiveInteger", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(606,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    assume AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0) <==> LitInt(0) <= x#0;
    assume true;
    assume $Is(AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0), TBool);
    return;
}



function AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#canCall(x#0) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0) <==> LitInt(81) <= x#0));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#canCall(LitInt(x#0)) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(LitInt(x#0)) <==> LitInt(81) <= LitInt(x#0)));
}

function AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#requires(x#0) } LitInt(-2147483648) <= x#0 && x#0 < 2147483648 ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#requires(x#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_RSAModulusLengthBits (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_RSAModulusLengthBits (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IsValid_RSAModulusLengthBits", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(620,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    newtype$check#0 := LitInt(81);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    assume AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0) <==> LitInt(81) <= x#0;
    assume true;
    assume $Is(AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0), TBool);
    return;
}



function AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#canCall(x#0) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0) <==> LitInt(81) <= x#0 && x#0 <= LitInt(4096)));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#canCall(LitInt(x#0)) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(LitInt(x#0)) <==> LitInt(81) <= LitInt(x#0) && LitInt(x#0) <= LitInt(4096)));
}

function AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#requires(x#0) } LitInt(-2147483648) <= x#0 && x#0 < 2147483648 ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#requires(x#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_RSAModulusLengthBitsToGenerate (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_RSAModulusLengthBitsToGenerate (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IsValid_RSAModulusLengthBitsToGenerate", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(624,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := LitInt(81);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(81) <= x#0;
    newtype$check#1 := LitInt(4096);
    assume LitInt(-2147483648) <= newtype$check#1 && newtype$check#1 < 2147483648;
    goto anon5;

  anon7_Else:
    assume {:partition} x#0 < LitInt(81);
    goto anon5;

  anon5:
    assume AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0) <==> LitInt(81) <= x#0 && x#0 <= LitInt(4096);
    assume true;
    assume $Is(AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0), TBool);
    return;
}



function AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#canCall(x#0) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0) <==> LitInt(1) <= x#0 && x#0 <= LitInt(32)));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#canCall(LitInt(x#0)) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(LitInt(x#0)) <==> LitInt(1) <= LitInt(x#0) && LitInt(x#0) <= LitInt(32)));
}

function AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#requires(x#0) } LitInt(-2147483648) <= x#0 && x#0 < 2147483648 ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#requires(x#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_SymmetricKeyLength (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_SymmetricKeyLength (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IsValid_SymmetricKeyLength", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(642,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := LitInt(1);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(1) <= x#0;
    newtype$check#1 := LitInt(32);
    assume LitInt(-2147483648) <= newtype$check#1 && newtype$check#1 < 2147483648;
    goto anon5;

  anon7_Else:
    assume {:partition} x#0 < LitInt(1);
    goto anon5;

  anon5:
    assume AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0) <==> LitInt(1) <= x#0 && x#0 <= LitInt(32);
    assume true;
    assume $Is(AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0), TBool);
    return;
}



function AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#canCall(x#0) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0) <==> LitInt(0) <= x#0 && x#0 <= LitInt(255)));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#canCall(LitInt(x#0)) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(LitInt(x#0)) <==> LitInt(0) <= LitInt(x#0) && LitInt(x#0) <= LitInt(255)));
}

function AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#requires(x#0) } LitInt(-2147483648) <= x#0 && x#0 < 2147483648 ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#requires(x#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_Uint8Bits (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_Uint8Bits (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IsValid_Uint8Bits", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(646,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    newtype$check#1 := LitInt(255);
    assume LitInt(-2147483648) <= newtype$check#1 && newtype$check#1 < 2147483648;
    goto anon5;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon5;

  anon5:
    assume AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0) <==> LitInt(0) <= x#0 && x#0 <= LitInt(255);
    assume true;
    assume $Is(AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0), TBool);
    return;
}



function AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#canCall(x#0) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0) <==> LitInt(0) <= x#0 && x#0 <= LitInt(32)));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#canCall(LitInt(x#0)) || (0 < $FunctionContextHeight && LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(LitInt(x#0)) <==> LitInt(0) <= LitInt(x#0) && LitInt(x#0) <= LitInt(32)));
}

function AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#requires(x#0) } LitInt(-2147483648) <= x#0 && x#0 < 2147483648 ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#requires(x#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_Uint8Bytes (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IsValid_Uint8Bytes (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IsValid_Uint8Bytes", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(650,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(-2147483648) <= newtype$check#0 && newtype$check#0 < 2147483648;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    newtype$check#1 := LitInt(32);
    assume LitInt(-2147483648) <= newtype$check#1 && newtype$check#1 < 2147483648;
    goto anon5;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon5;

  anon5:
    assume AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0) <==> LitInt(0) <= x#0 && x#0 <= LitInt(32);
    assume true;
    assume $Is(AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0), TBool);
    return;
}



function AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0) } AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#canCall(x#0) || 0 < $FunctionContextHeight ==> (AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0) <==> 0 < x#0));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#canCall(LitInt(x#0)) || 0 < $FunctionContextHeight ==> (AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(LitInt(x#0)) <==> Lit(0 < x#0)));
}

function AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#canCall(x#0: int) : bool;

function AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#requires(int) : bool;

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#requires(x#0) } AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#requires(x#0) <==> true);

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IsDummySubsetType (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(Box, Box) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent: DtCtorId
uses {
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: { #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#0#0#0, a#0#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#0#0#0, a#0#1#0)) == ##AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent);
}

function AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d) } AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d) } AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d) ==> (exists a#1#0#0: Box, a#1#1#0: Box :: d == #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#1#0#0, a#1#1#0)));

function Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Ty, Ty) : Ty;

const unique Tagclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent: TyTag;

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty :: { Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O) } Tag(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) == Tagclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) == tytagFamily$DafnyCallEvent);

function Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent_0(Ty) : Ty;

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty :: { Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O) } Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent_0(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) == AwsCryptographyPrimitivesTypes.DafnyCallEvent$I);

function Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent_1(Ty) : Ty;

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty :: { Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O) } Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent_1(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) == AwsCryptographyPrimitivesTypes.DafnyCallEvent$O);

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty, bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)));

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty, a#2#0#0: Box, a#2#1#0: Box :: { $Is(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) } $Is(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) <==> $IsBox(a#2#0#0, AwsCryptographyPrimitivesTypes.DafnyCallEvent$I) && $IsBox(a#2#1#0, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O));

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty, a#2#0#0: Box, a#2#1#0: Box, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O), $h) <==> $IsAllocBox(a#2#0#0, AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, $h) && $IsAllocBox(a#2#1#0, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O, $h)));

axiom (forall d: DatatypeType, AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, $h: Heap :: { $IsAllocBox(AwsCryptographyPrimitivesTypes.DafnyCallEvent.input(d), AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d) && (exists AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O), $h) } $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O), $h)) ==> $IsAllocBox(AwsCryptographyPrimitivesTypes.DafnyCallEvent.input(d), AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, $h));

axiom (forall d: DatatypeType, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty, $h: Heap :: { $IsAllocBox(AwsCryptographyPrimitivesTypes.DafnyCallEvent.output(d), AwsCryptographyPrimitivesTypes.DafnyCallEvent$O, $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d) && (exists AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O), $h) } $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O), $h)) ==> $IsAllocBox(AwsCryptographyPrimitivesTypes.DafnyCallEvent.output(d), AwsCryptographyPrimitivesTypes.DafnyCallEvent$O, $h));

axiom (forall a#3#0#0: Box, a#3#1#0: Box :: { #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(Lit(a#3#0#0), Lit(a#3#1#0)) } #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#3#0#0, a#3#1#0)));

function AwsCryptographyPrimitivesTypes.DafnyCallEvent.input(DatatypeType) : Box;

axiom (forall a#4#0#0: Box, a#4#1#0: Box :: { #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#4#0#0, a#4#1#0) } AwsCryptographyPrimitivesTypes.DafnyCallEvent.input(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#4#0#0, a#4#1#0)) == a#4#0#0);

axiom (forall a#5#0#0: Box, a#5#1#0: Box :: { #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#5#0#0, a#5#1#0) } BoxRank(a#5#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#5#0#0, a#5#1#0)));

function AwsCryptographyPrimitivesTypes.DafnyCallEvent.output(DatatypeType) : Box;

axiom (forall a#6#0#0: Box, a#6#1#0: Box :: { #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#6#0#0, a#6#1#0) } AwsCryptographyPrimitivesTypes.DafnyCallEvent.output(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#6#0#0, a#6#1#0)) == a#6#1#0);

axiom (forall a#7#0#0: Box, a#7#1#0: Box :: { #AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#7#0#0, a#7#1#0) } BoxRank(a#7#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent(a#7#0#0, a#7#1#0)));

function $IsA#AwsCryptographyPrimitivesTypes.DafnyCallEvent(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DafnyCallEvent(d) } $IsA#AwsCryptographyPrimitivesTypes.DafnyCallEvent(d) ==> AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d));

axiom (forall AwsCryptographyPrimitivesTypes.DafnyCallEvent$I: Ty, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O: Ty, d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(AwsCryptographyPrimitivesTypes.DafnyCallEvent$I, AwsCryptographyPrimitivesTypes.DafnyCallEvent$O)) ==> AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent_q(d));

function AwsCryptographyPrimitivesTypes.DafnyCallEvent#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DafnyCallEvent#Equal(a, b) } AwsCryptographyPrimitivesTypes.DafnyCallEvent#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DafnyCallEvent.input(a) == AwsCryptographyPrimitivesTypes.DafnyCallEvent.input(b) && AwsCryptographyPrimitivesTypes.DafnyCallEvent.output(a) == AwsCryptographyPrimitivesTypes.DafnyCallEvent.output(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DafnyCallEvent#Equal(a, b) } AwsCryptographyPrimitivesTypes.DafnyCallEvent#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DafnyCallEvent: ClassName;

function #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(int, int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR: DtCtorId
uses {
axiom (forall a#8#0#0: int, a#8#1#0: int :: { #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#8#0#0, a#8#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#8#0#0, a#8#1#0)) == ##AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR);
}

function AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d) } AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d) } AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d) ==> (exists a#9#0#0: int, a#9#1#0: int :: d == #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#9#0#0, a#9#1#0)));

function Tclass.AwsCryptographyPrimitivesTypes.AES__CTR() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) == Tagclass.AwsCryptographyPrimitivesTypes.AES__CTR && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) == tytagFamily$AES_CTR;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.AES__CTR: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()));

function Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) == Tagclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) == tytagFamily$SymmetricKeyLength;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()));

function Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()) == Tagclass.AwsCryptographyPrimitivesTypes.Uint8Bits && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()) == tytagFamily$Uint8Bits;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.Uint8Bits: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()));

axiom (forall a#10#0#0: int, a#10#1#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#10#0#0, a#10#1#0), Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) } $Is(#AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#10#0#0, a#10#1#0), Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) <==> $Is(a#10#0#0, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) && $Is(a#10#1#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AES__CTR.keyLength(d), Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AES__CTR.keyLength(d), Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AES__CTR.nonceLength(d), Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AES__CTR.nonceLength(d), Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits(), $h));

axiom (forall a#11#0#0: int, a#11#1#0: int :: { #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(LitInt(a#11#0#0), LitInt(a#11#1#0)) } #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(LitInt(a#11#0#0), LitInt(a#11#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#11#0#0, a#11#1#0)));

function AwsCryptographyPrimitivesTypes.AES__CTR.keyLength(DatatypeType) : int;

axiom (forall a#12#0#0: int, a#12#1#0: int :: { #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#12#0#0, a#12#1#0) } AwsCryptographyPrimitivesTypes.AES__CTR.keyLength(#AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#12#0#0, a#12#1#0)) == a#12#0#0);

function AwsCryptographyPrimitivesTypes.AES__CTR.nonceLength(DatatypeType) : int;

axiom (forall a#13#0#0: int, a#13#1#0: int :: { #AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#13#0#0, a#13#1#0) } AwsCryptographyPrimitivesTypes.AES__CTR.nonceLength(#AwsCryptographyPrimitivesTypes.AES_CTR.AES_CTR(a#13#0#0, a#13#1#0)) == a#13#1#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.AES__CTR(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.AES__CTR(d) } $IsA#AwsCryptographyPrimitivesTypes.AES__CTR(d) ==> AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AES__CTR()) ==> AwsCryptographyPrimitivesTypes.AES__CTR.AES__CTR_q(d));

function AwsCryptographyPrimitivesTypes.AES__CTR#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__CTR#Equal(a, b) } AwsCryptographyPrimitivesTypes.AES__CTR#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.AES__CTR.keyLength(a) == AwsCryptographyPrimitivesTypes.AES__CTR.keyLength(b) && AwsCryptographyPrimitivesTypes.AES__CTR.nonceLength(a) == AwsCryptographyPrimitivesTypes.AES__CTR.nonceLength(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__CTR#Equal(a, b) } AwsCryptographyPrimitivesTypes.AES__CTR#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.AES__CTR: ClassName;

function #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(int, int, int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM: DtCtorId
uses {
axiom (forall a#14#0#0: int, a#14#1#0: int, a#14#2#0: int :: { #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#14#0#0, a#14#1#0, a#14#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#14#0#0, a#14#1#0, a#14#2#0)) == ##AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM);
}

function AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) } AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) } AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) ==> (exists a#15#0#0: int, a#15#1#0: int, a#15#2#0: int :: d == #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#15#0#0, a#15#1#0, a#15#2#0)));

function Tclass.AwsCryptographyPrimitivesTypes.AES__GCM() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) == Tagclass.AwsCryptographyPrimitivesTypes.AES__GCM && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) == tytagFamily$AES_GCM;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.AES__GCM: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()));

function Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) == Tagclass.AwsCryptographyPrimitivesTypes.Uint8Bytes && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) == tytagFamily$Uint8Bytes;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.Uint8Bytes: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()));

axiom (forall a#16#0#0: int, a#16#1#0: int, a#16#2#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#16#0#0, a#16#1#0, a#16#2#0), Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) } $Is(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#16#0#0, a#16#1#0, a#16#2#0), Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) <==> $Is(a#16#0#0, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) && $Is(a#16#1#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) && $Is(a#16#2#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AES__GCM.keyLength(d), Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AES__GCM.keyLength(d), Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AES__GCM.tagLength(d), Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AES__GCM.tagLength(d), Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AES__GCM.ivLength(d), Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AES__GCM.ivLength(d), Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits(), $h));

axiom (forall a#17#0#0: int, a#17#1#0: int, a#17#2#0: int :: { #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(LitInt(a#17#0#0), LitInt(a#17#1#0), LitInt(a#17#2#0)) } #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(LitInt(a#17#0#0), LitInt(a#17#1#0), LitInt(a#17#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#17#0#0, a#17#1#0, a#17#2#0)));

function AwsCryptographyPrimitivesTypes.AES__GCM.keyLength(DatatypeType) : int;

axiom (forall a#18#0#0: int, a#18#1#0: int, a#18#2#0: int :: { #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#18#0#0, a#18#1#0, a#18#2#0) } AwsCryptographyPrimitivesTypes.AES__GCM.keyLength(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#18#0#0, a#18#1#0, a#18#2#0)) == a#18#0#0);

function AwsCryptographyPrimitivesTypes.AES__GCM.tagLength(DatatypeType) : int;

axiom (forall a#19#0#0: int, a#19#1#0: int, a#19#2#0: int :: { #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#19#0#0, a#19#1#0, a#19#2#0) } AwsCryptographyPrimitivesTypes.AES__GCM.tagLength(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#19#0#0, a#19#1#0, a#19#2#0)) == a#19#1#0);

function AwsCryptographyPrimitivesTypes.AES__GCM.ivLength(DatatypeType) : int;

axiom (forall a#20#0#0: int, a#20#1#0: int, a#20#2#0: int :: { #AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#20#0#0, a#20#1#0, a#20#2#0) } AwsCryptographyPrimitivesTypes.AES__GCM.ivLength(#AwsCryptographyPrimitivesTypes.AES_GCM.AES_GCM(a#20#0#0, a#20#1#0, a#20#2#0)) == a#20#2#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.AES__GCM(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.AES__GCM(d) } $IsA#AwsCryptographyPrimitivesTypes.AES__GCM(d) ==> AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) ==> AwsCryptographyPrimitivesTypes.AES__GCM.AES__GCM_q(d));

function AwsCryptographyPrimitivesTypes.AES__GCM#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__GCM#Equal(a, b) } AwsCryptographyPrimitivesTypes.AES__GCM#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.AES__GCM.keyLength(a) == AwsCryptographyPrimitivesTypes.AES__GCM.keyLength(b) && AwsCryptographyPrimitivesTypes.AES__GCM.tagLength(a) == AwsCryptographyPrimitivesTypes.AES__GCM.tagLength(b) && AwsCryptographyPrimitivesTypes.AES__GCM.ivLength(a) == AwsCryptographyPrimitivesTypes.AES__GCM.ivLength(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AES__GCM#Equal(a, b) } AwsCryptographyPrimitivesTypes.AES__GCM#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.AES__GCM: ClassName;

function #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(DatatypeType, Seq, Seq, Seq, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput: DtCtorId
uses {
axiom (forall a#21#0#0: DatatypeType, a#21#1#0: Seq, a#21#2#0: Seq, a#21#3#0: Seq, a#21#4#0: Seq, a#21#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0, a#21#5#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0, a#21#5#0)) == ##AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput);
}

function AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) } AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) } AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) ==> (exists a#22#0#0: DatatypeType, a#22#1#0: Seq, a#22#2#0: Seq, a#22#3#0: Seq, a#22#4#0: Seq, a#22#5#0: Seq :: d == #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0, a#22#5#0)));

function Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) == Tagclass.AwsCryptographyPrimitivesTypes.AESDecryptInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) == tytagFamily$AESDecryptInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.AESDecryptInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()));

axiom (forall a#23#0#0: DatatypeType, a#23#1#0: Seq, a#23#2#0: Seq, a#23#3#0: Seq, a#23#4#0: Seq, a#23#5#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0, a#23#5#0), Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) } $Is(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0, a#23#5#0), Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) <==> $Is(a#23#0#0, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) && $Is(a#23#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#23#2#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#23#3#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#23#4#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#23#5#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.encAlg(d), Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.encAlg(d), Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.key(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.key(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.cipherTxt(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.cipherTxt(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.authTag(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.authTag(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.iv(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.iv(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.aad(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESDecryptInput.aad(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#24#0#0: DatatypeType, a#24#1#0: Seq, a#24#2#0: Seq, a#24#3#0: Seq, a#24#4#0: Seq, a#24#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(Lit(a#24#0#0), Lit(a#24#1#0), Lit(a#24#2#0), Lit(a#24#3#0), Lit(a#24#4#0), Lit(a#24#5#0)) } #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(Lit(a#24#0#0), Lit(a#24#1#0), Lit(a#24#2#0), Lit(a#24#3#0), Lit(a#24#4#0), Lit(a#24#5#0)) == Lit(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0, a#24#5#0)));

function AwsCryptographyPrimitivesTypes.AESDecryptInput.encAlg(DatatypeType) : DatatypeType;

axiom (forall a#25#0#0: DatatypeType, a#25#1#0: Seq, a#25#2#0: Seq, a#25#3#0: Seq, a#25#4#0: Seq, a#25#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0, a#25#5#0) } AwsCryptographyPrimitivesTypes.AESDecryptInput.encAlg(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0, a#25#5#0)) == a#25#0#0);

axiom (forall a#26#0#0: DatatypeType, a#26#1#0: Seq, a#26#2#0: Seq, a#26#3#0: Seq, a#26#4#0: Seq, a#26#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0, a#26#5#0) } DtRank(a#26#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0, a#26#5#0)));

function AwsCryptographyPrimitivesTypes.AESDecryptInput.key(DatatypeType) : Seq;

axiom (forall a#27#0#0: DatatypeType, a#27#1#0: Seq, a#27#2#0: Seq, a#27#3#0: Seq, a#27#4#0: Seq, a#27#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#27#0#0, a#27#1#0, a#27#2#0, a#27#3#0, a#27#4#0, a#27#5#0) } AwsCryptographyPrimitivesTypes.AESDecryptInput.key(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#27#0#0, a#27#1#0, a#27#2#0, a#27#3#0, a#27#4#0, a#27#5#0)) == a#27#1#0);

axiom (forall a#28#0#0: DatatypeType, a#28#1#0: Seq, a#28#2#0: Seq, a#28#3#0: Seq, a#28#4#0: Seq, a#28#5#0: Seq, i: int :: { Seq#Index(a#28#1#0, i), #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#28#0#0, a#28#1#0, a#28#2#0, a#28#3#0, a#28#4#0, a#28#5#0) } 0 <= i && i < Seq#Length(a#28#1#0) ==> DtRank($Unbox(Seq#Index(a#28#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#28#0#0, a#28#1#0, a#28#2#0, a#28#3#0, a#28#4#0, a#28#5#0)));

axiom (forall a#29#0#0: DatatypeType, a#29#1#0: Seq, a#29#2#0: Seq, a#29#3#0: Seq, a#29#4#0: Seq, a#29#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#29#0#0, a#29#1#0, a#29#2#0, a#29#3#0, a#29#4#0, a#29#5#0) } Seq#Rank(a#29#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#29#0#0, a#29#1#0, a#29#2#0, a#29#3#0, a#29#4#0, a#29#5#0)));

function AwsCryptographyPrimitivesTypes.AESDecryptInput.cipherTxt(DatatypeType) : Seq;

axiom (forall a#30#0#0: DatatypeType, a#30#1#0: Seq, a#30#2#0: Seq, a#30#3#0: Seq, a#30#4#0: Seq, a#30#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#30#0#0, a#30#1#0, a#30#2#0, a#30#3#0, a#30#4#0, a#30#5#0) } AwsCryptographyPrimitivesTypes.AESDecryptInput.cipherTxt(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#30#0#0, a#30#1#0, a#30#2#0, a#30#3#0, a#30#4#0, a#30#5#0)) == a#30#2#0);

axiom (forall a#31#0#0: DatatypeType, a#31#1#0: Seq, a#31#2#0: Seq, a#31#3#0: Seq, a#31#4#0: Seq, a#31#5#0: Seq, i: int :: { Seq#Index(a#31#2#0, i), #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#31#0#0, a#31#1#0, a#31#2#0, a#31#3#0, a#31#4#0, a#31#5#0) } 0 <= i && i < Seq#Length(a#31#2#0) ==> DtRank($Unbox(Seq#Index(a#31#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#31#0#0, a#31#1#0, a#31#2#0, a#31#3#0, a#31#4#0, a#31#5#0)));

axiom (forall a#32#0#0: DatatypeType, a#32#1#0: Seq, a#32#2#0: Seq, a#32#3#0: Seq, a#32#4#0: Seq, a#32#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#32#0#0, a#32#1#0, a#32#2#0, a#32#3#0, a#32#4#0, a#32#5#0) } Seq#Rank(a#32#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#32#0#0, a#32#1#0, a#32#2#0, a#32#3#0, a#32#4#0, a#32#5#0)));

function AwsCryptographyPrimitivesTypes.AESDecryptInput.authTag(DatatypeType) : Seq;

axiom (forall a#33#0#0: DatatypeType, a#33#1#0: Seq, a#33#2#0: Seq, a#33#3#0: Seq, a#33#4#0: Seq, a#33#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#33#0#0, a#33#1#0, a#33#2#0, a#33#3#0, a#33#4#0, a#33#5#0) } AwsCryptographyPrimitivesTypes.AESDecryptInput.authTag(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#33#0#0, a#33#1#0, a#33#2#0, a#33#3#0, a#33#4#0, a#33#5#0)) == a#33#3#0);

axiom (forall a#34#0#0: DatatypeType, a#34#1#0: Seq, a#34#2#0: Seq, a#34#3#0: Seq, a#34#4#0: Seq, a#34#5#0: Seq, i: int :: { Seq#Index(a#34#3#0, i), #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#34#0#0, a#34#1#0, a#34#2#0, a#34#3#0, a#34#4#0, a#34#5#0) } 0 <= i && i < Seq#Length(a#34#3#0) ==> DtRank($Unbox(Seq#Index(a#34#3#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#34#0#0, a#34#1#0, a#34#2#0, a#34#3#0, a#34#4#0, a#34#5#0)));

axiom (forall a#35#0#0: DatatypeType, a#35#1#0: Seq, a#35#2#0: Seq, a#35#3#0: Seq, a#35#4#0: Seq, a#35#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#35#0#0, a#35#1#0, a#35#2#0, a#35#3#0, a#35#4#0, a#35#5#0) } Seq#Rank(a#35#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#35#0#0, a#35#1#0, a#35#2#0, a#35#3#0, a#35#4#0, a#35#5#0)));

function AwsCryptographyPrimitivesTypes.AESDecryptInput.iv(DatatypeType) : Seq;

axiom (forall a#36#0#0: DatatypeType, a#36#1#0: Seq, a#36#2#0: Seq, a#36#3#0: Seq, a#36#4#0: Seq, a#36#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#36#0#0, a#36#1#0, a#36#2#0, a#36#3#0, a#36#4#0, a#36#5#0) } AwsCryptographyPrimitivesTypes.AESDecryptInput.iv(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#36#0#0, a#36#1#0, a#36#2#0, a#36#3#0, a#36#4#0, a#36#5#0)) == a#36#4#0);

axiom (forall a#37#0#0: DatatypeType, a#37#1#0: Seq, a#37#2#0: Seq, a#37#3#0: Seq, a#37#4#0: Seq, a#37#5#0: Seq, i: int :: { Seq#Index(a#37#4#0, i), #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#37#0#0, a#37#1#0, a#37#2#0, a#37#3#0, a#37#4#0, a#37#5#0) } 0 <= i && i < Seq#Length(a#37#4#0) ==> DtRank($Unbox(Seq#Index(a#37#4#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#37#0#0, a#37#1#0, a#37#2#0, a#37#3#0, a#37#4#0, a#37#5#0)));

axiom (forall a#38#0#0: DatatypeType, a#38#1#0: Seq, a#38#2#0: Seq, a#38#3#0: Seq, a#38#4#0: Seq, a#38#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#38#0#0, a#38#1#0, a#38#2#0, a#38#3#0, a#38#4#0, a#38#5#0) } Seq#Rank(a#38#4#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#38#0#0, a#38#1#0, a#38#2#0, a#38#3#0, a#38#4#0, a#38#5#0)));

function AwsCryptographyPrimitivesTypes.AESDecryptInput.aad(DatatypeType) : Seq;

axiom (forall a#39#0#0: DatatypeType, a#39#1#0: Seq, a#39#2#0: Seq, a#39#3#0: Seq, a#39#4#0: Seq, a#39#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#39#0#0, a#39#1#0, a#39#2#0, a#39#3#0, a#39#4#0, a#39#5#0) } AwsCryptographyPrimitivesTypes.AESDecryptInput.aad(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#39#0#0, a#39#1#0, a#39#2#0, a#39#3#0, a#39#4#0, a#39#5#0)) == a#39#5#0);

axiom (forall a#40#0#0: DatatypeType, a#40#1#0: Seq, a#40#2#0: Seq, a#40#3#0: Seq, a#40#4#0: Seq, a#40#5#0: Seq, i: int :: { Seq#Index(a#40#5#0, i), #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#40#0#0, a#40#1#0, a#40#2#0, a#40#3#0, a#40#4#0, a#40#5#0) } 0 <= i && i < Seq#Length(a#40#5#0) ==> DtRank($Unbox(Seq#Index(a#40#5#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#40#0#0, a#40#1#0, a#40#2#0, a#40#3#0, a#40#4#0, a#40#5#0)));

axiom (forall a#41#0#0: DatatypeType, a#41#1#0: Seq, a#41#2#0: Seq, a#41#3#0: Seq, a#41#4#0: Seq, a#41#5#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#41#0#0, a#41#1#0, a#41#2#0, a#41#3#0, a#41#4#0, a#41#5#0) } Seq#Rank(a#41#5#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput(a#41#0#0, a#41#1#0, a#41#2#0, a#41#3#0, a#41#4#0, a#41#5#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(d) } $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(d) ==> AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) ==> AwsCryptographyPrimitivesTypes.AESDecryptInput.AESDecryptInput_q(d));

function AwsCryptographyPrimitivesTypes.AESDecryptInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESDecryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AESDecryptInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.AES__GCM#Equal(AwsCryptographyPrimitivesTypes.AESDecryptInput.encAlg(a), AwsCryptographyPrimitivesTypes.AESDecryptInput.encAlg(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESDecryptInput.key(a), AwsCryptographyPrimitivesTypes.AESDecryptInput.key(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESDecryptInput.cipherTxt(a), AwsCryptographyPrimitivesTypes.AESDecryptInput.cipherTxt(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESDecryptInput.authTag(a), AwsCryptographyPrimitivesTypes.AESDecryptInput.authTag(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESDecryptInput.iv(a), AwsCryptographyPrimitivesTypes.AESDecryptInput.iv(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESDecryptInput.aad(a), AwsCryptographyPrimitivesTypes.AESDecryptInput.aad(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESDecryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AESDecryptInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.AESDecryptInput: ClassName;

function #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(DatatypeType, Seq, Seq, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput: DtCtorId
uses {
axiom (forall a#42#0#0: DatatypeType, a#42#1#0: Seq, a#42#2#0: Seq, a#42#3#0: Seq, a#42#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#42#0#0, a#42#1#0, a#42#2#0, a#42#3#0, a#42#4#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#42#0#0, a#42#1#0, a#42#2#0, a#42#3#0, a#42#4#0)) == ##AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput);
}

function AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) } AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) } AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) ==> (exists a#43#0#0: DatatypeType, a#43#1#0: Seq, a#43#2#0: Seq, a#43#3#0: Seq, a#43#4#0: Seq :: d == #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#43#0#0, a#43#1#0, a#43#2#0, a#43#3#0, a#43#4#0)));

function Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) == Tagclass.AwsCryptographyPrimitivesTypes.AESEncryptInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) == tytagFamily$AESEncryptInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.AESEncryptInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()));

axiom (forall a#44#0#0: DatatypeType, a#44#1#0: Seq, a#44#2#0: Seq, a#44#3#0: Seq, a#44#4#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#44#0#0, a#44#1#0, a#44#2#0, a#44#3#0, a#44#4#0), Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) } $Is(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#44#0#0, a#44#1#0, a#44#2#0, a#44#3#0, a#44#4#0), Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) <==> $Is(a#44#0#0, Tclass.AwsCryptographyPrimitivesTypes.AES__GCM()) && $Is(a#44#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#44#2#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#44#3#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#44#4#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.encAlg(d), Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.encAlg(d), Tclass.AwsCryptographyPrimitivesTypes.AES__GCM(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.iv(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.iv(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.key(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.key(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.msg(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.msg(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.aad(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptInput.aad(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#45#0#0: DatatypeType, a#45#1#0: Seq, a#45#2#0: Seq, a#45#3#0: Seq, a#45#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(Lit(a#45#0#0), Lit(a#45#1#0), Lit(a#45#2#0), Lit(a#45#3#0), Lit(a#45#4#0)) } #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(Lit(a#45#0#0), Lit(a#45#1#0), Lit(a#45#2#0), Lit(a#45#3#0), Lit(a#45#4#0)) == Lit(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#45#0#0, a#45#1#0, a#45#2#0, a#45#3#0, a#45#4#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptInput.encAlg(DatatypeType) : DatatypeType;

axiom (forall a#46#0#0: DatatypeType, a#46#1#0: Seq, a#46#2#0: Seq, a#46#3#0: Seq, a#46#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#46#0#0, a#46#1#0, a#46#2#0, a#46#3#0, a#46#4#0) } AwsCryptographyPrimitivesTypes.AESEncryptInput.encAlg(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#46#0#0, a#46#1#0, a#46#2#0, a#46#3#0, a#46#4#0)) == a#46#0#0);

axiom (forall a#47#0#0: DatatypeType, a#47#1#0: Seq, a#47#2#0: Seq, a#47#3#0: Seq, a#47#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#47#0#0, a#47#1#0, a#47#2#0, a#47#3#0, a#47#4#0) } DtRank(a#47#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#47#0#0, a#47#1#0, a#47#2#0, a#47#3#0, a#47#4#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptInput.iv(DatatypeType) : Seq;

axiom (forall a#48#0#0: DatatypeType, a#48#1#0: Seq, a#48#2#0: Seq, a#48#3#0: Seq, a#48#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0, a#48#4#0) } AwsCryptographyPrimitivesTypes.AESEncryptInput.iv(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0, a#48#4#0)) == a#48#1#0);

axiom (forall a#49#0#0: DatatypeType, a#49#1#0: Seq, a#49#2#0: Seq, a#49#3#0: Seq, a#49#4#0: Seq, i: int :: { Seq#Index(a#49#1#0, i), #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#49#0#0, a#49#1#0, a#49#2#0, a#49#3#0, a#49#4#0) } 0 <= i && i < Seq#Length(a#49#1#0) ==> DtRank($Unbox(Seq#Index(a#49#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#49#0#0, a#49#1#0, a#49#2#0, a#49#3#0, a#49#4#0)));

axiom (forall a#50#0#0: DatatypeType, a#50#1#0: Seq, a#50#2#0: Seq, a#50#3#0: Seq, a#50#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#50#0#0, a#50#1#0, a#50#2#0, a#50#3#0, a#50#4#0) } Seq#Rank(a#50#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#50#0#0, a#50#1#0, a#50#2#0, a#50#3#0, a#50#4#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptInput.key(DatatypeType) : Seq;

axiom (forall a#51#0#0: DatatypeType, a#51#1#0: Seq, a#51#2#0: Seq, a#51#3#0: Seq, a#51#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#51#0#0, a#51#1#0, a#51#2#0, a#51#3#0, a#51#4#0) } AwsCryptographyPrimitivesTypes.AESEncryptInput.key(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#51#0#0, a#51#1#0, a#51#2#0, a#51#3#0, a#51#4#0)) == a#51#2#0);

axiom (forall a#52#0#0: DatatypeType, a#52#1#0: Seq, a#52#2#0: Seq, a#52#3#0: Seq, a#52#4#0: Seq, i: int :: { Seq#Index(a#52#2#0, i), #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#52#0#0, a#52#1#0, a#52#2#0, a#52#3#0, a#52#4#0) } 0 <= i && i < Seq#Length(a#52#2#0) ==> DtRank($Unbox(Seq#Index(a#52#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#52#0#0, a#52#1#0, a#52#2#0, a#52#3#0, a#52#4#0)));

axiom (forall a#53#0#0: DatatypeType, a#53#1#0: Seq, a#53#2#0: Seq, a#53#3#0: Seq, a#53#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#53#0#0, a#53#1#0, a#53#2#0, a#53#3#0, a#53#4#0) } Seq#Rank(a#53#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#53#0#0, a#53#1#0, a#53#2#0, a#53#3#0, a#53#4#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptInput.msg(DatatypeType) : Seq;

axiom (forall a#54#0#0: DatatypeType, a#54#1#0: Seq, a#54#2#0: Seq, a#54#3#0: Seq, a#54#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#54#0#0, a#54#1#0, a#54#2#0, a#54#3#0, a#54#4#0) } AwsCryptographyPrimitivesTypes.AESEncryptInput.msg(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#54#0#0, a#54#1#0, a#54#2#0, a#54#3#0, a#54#4#0)) == a#54#3#0);

axiom (forall a#55#0#0: DatatypeType, a#55#1#0: Seq, a#55#2#0: Seq, a#55#3#0: Seq, a#55#4#0: Seq, i: int :: { Seq#Index(a#55#3#0, i), #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#55#0#0, a#55#1#0, a#55#2#0, a#55#3#0, a#55#4#0) } 0 <= i && i < Seq#Length(a#55#3#0) ==> DtRank($Unbox(Seq#Index(a#55#3#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#55#0#0, a#55#1#0, a#55#2#0, a#55#3#0, a#55#4#0)));

axiom (forall a#56#0#0: DatatypeType, a#56#1#0: Seq, a#56#2#0: Seq, a#56#3#0: Seq, a#56#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#56#0#0, a#56#1#0, a#56#2#0, a#56#3#0, a#56#4#0) } Seq#Rank(a#56#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#56#0#0, a#56#1#0, a#56#2#0, a#56#3#0, a#56#4#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptInput.aad(DatatypeType) : Seq;

axiom (forall a#57#0#0: DatatypeType, a#57#1#0: Seq, a#57#2#0: Seq, a#57#3#0: Seq, a#57#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#57#0#0, a#57#1#0, a#57#2#0, a#57#3#0, a#57#4#0) } AwsCryptographyPrimitivesTypes.AESEncryptInput.aad(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#57#0#0, a#57#1#0, a#57#2#0, a#57#3#0, a#57#4#0)) == a#57#4#0);

axiom (forall a#58#0#0: DatatypeType, a#58#1#0: Seq, a#58#2#0: Seq, a#58#3#0: Seq, a#58#4#0: Seq, i: int :: { Seq#Index(a#58#4#0, i), #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#58#0#0, a#58#1#0, a#58#2#0, a#58#3#0, a#58#4#0) } 0 <= i && i < Seq#Length(a#58#4#0) ==> DtRank($Unbox(Seq#Index(a#58#4#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#58#0#0, a#58#1#0, a#58#2#0, a#58#3#0, a#58#4#0)));

axiom (forall a#59#0#0: DatatypeType, a#59#1#0: Seq, a#59#2#0: Seq, a#59#3#0: Seq, a#59#4#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#59#0#0, a#59#1#0, a#59#2#0, a#59#3#0, a#59#4#0) } Seq#Rank(a#59#4#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput(a#59#0#0, a#59#1#0, a#59#2#0, a#59#3#0, a#59#4#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(d) } $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(d) ==> AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) ==> AwsCryptographyPrimitivesTypes.AESEncryptInput.AESEncryptInput_q(d));

function AwsCryptographyPrimitivesTypes.AESEncryptInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AESEncryptInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.AES__GCM#Equal(AwsCryptographyPrimitivesTypes.AESEncryptInput.encAlg(a), AwsCryptographyPrimitivesTypes.AESEncryptInput.encAlg(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESEncryptInput.iv(a), AwsCryptographyPrimitivesTypes.AESEncryptInput.iv(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESEncryptInput.key(a), AwsCryptographyPrimitivesTypes.AESEncryptInput.key(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESEncryptInput.msg(a), AwsCryptographyPrimitivesTypes.AESEncryptInput.msg(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESEncryptInput.aad(a), AwsCryptographyPrimitivesTypes.AESEncryptInput.aad(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AESEncryptInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.AESEncryptInput: ClassName;

function #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput: DtCtorId
uses {
axiom (forall a#60#0#0: Seq, a#60#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#60#0#0, a#60#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#60#0#0, a#60#1#0)) == ##AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput);
}

function AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d) } AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d) } AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d) ==> (exists a#61#0#0: Seq, a#61#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#61#0#0, a#61#1#0)));

function Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) == tytagFamily$AESEncryptOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()));

axiom (forall a#62#0#0: Seq, a#62#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#62#0#0, a#62#1#0), Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) } $Is(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#62#0#0, a#62#1#0), Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) <==> $Is(a#62#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#62#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptOutput.cipherText(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptOutput.cipherText(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptOutput.authTag(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AESEncryptOutput.authTag(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#63#0#0: Seq, a#63#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(Lit(a#63#0#0), Lit(a#63#1#0)) } #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(Lit(a#63#0#0), Lit(a#63#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#63#0#0, a#63#1#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptOutput.cipherText(DatatypeType) : Seq;

axiom (forall a#64#0#0: Seq, a#64#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#64#0#0, a#64#1#0) } AwsCryptographyPrimitivesTypes.AESEncryptOutput.cipherText(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#64#0#0, a#64#1#0)) == a#64#0#0);

axiom (forall a#65#0#0: Seq, a#65#1#0: Seq, i: int :: { Seq#Index(a#65#0#0, i), #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#65#0#0, a#65#1#0) } 0 <= i && i < Seq#Length(a#65#0#0) ==> DtRank($Unbox(Seq#Index(a#65#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#65#0#0, a#65#1#0)));

axiom (forall a#66#0#0: Seq, a#66#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#66#0#0, a#66#1#0) } Seq#Rank(a#66#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#66#0#0, a#66#1#0)));

function AwsCryptographyPrimitivesTypes.AESEncryptOutput.authTag(DatatypeType) : Seq;

axiom (forall a#67#0#0: Seq, a#67#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#67#0#0, a#67#1#0) } AwsCryptographyPrimitivesTypes.AESEncryptOutput.authTag(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#67#0#0, a#67#1#0)) == a#67#1#0);

axiom (forall a#68#0#0: Seq, a#68#1#0: Seq, i: int :: { Seq#Index(a#68#1#0, i), #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#68#0#0, a#68#1#0) } 0 <= i && i < Seq#Length(a#68#1#0) ==> DtRank($Unbox(Seq#Index(a#68#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#68#0#0, a#68#1#0)));

axiom (forall a#69#0#0: Seq, a#69#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#69#0#0, a#69#1#0) } Seq#Rank(a#69#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput(a#69#0#0, a#69#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.AESEncryptOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.AESEncryptOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.AESEncryptOutput(d) ==> AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput()) ==> AwsCryptographyPrimitivesTypes.AESEncryptOutput.AESEncryptOutput_q(d));

function AwsCryptographyPrimitivesTypes.AESEncryptOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AESEncryptOutput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.AESEncryptOutput.cipherText(a), AwsCryptographyPrimitivesTypes.AESEncryptOutput.cipherText(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.AESEncryptOutput.authTag(a), AwsCryptographyPrimitivesTypes.AESEncryptOutput.authTag(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AESEncryptOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AESEncryptOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.AESEncryptOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(Seq, int, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput: DtCtorId
uses {
axiom (forall a#70#0#0: Seq, a#70#1#0: int, a#70#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#70#0#0, a#70#1#0, a#70#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#70#0#0, a#70#1#0, a#70#2#0)) == ##AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput);
}

function AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput);

procedure {:verboseName "#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput (well-formedness)"} CheckWellformed$$#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())), expectedLength#0: int where LitInt(-2147483648) <= expectedLength#0 && expectedLength#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(expectedLength#0), nonce#0: DatatypeType where $Is(nonce#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) ==> (exists a#0#0#0: Seq, a#0#1#0: int, a#0#2#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#0#0#0, a#0#1#0, a#0#2#0)));

function Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) == Tagclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) == tytagFamily$AesKdfCtrInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()));

function Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) == Tagclass.AwsCryptographyPrimitivesTypes.PositiveInteger && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) == tytagFamily$PositiveInteger;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.PositiveInteger: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()));

axiom (forall a#1#0#0: Seq, a#1#1#0: int, a#1#2#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#1#0#0, a#1#1#0, a#1#2#0), Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) } $Is(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#1#0#0, a#1#1#0, a#1#2#0), Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) <==> $Is(a#1#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#1#1#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) && $Is(a#1#2#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall a#2#0#0: Seq, a#2#1#0: int, a#2#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(Lit(a#2#0#0), LitInt(a#2#1#0), Lit(a#2#2#0)) } #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(Lit(a#2#0#0), LitInt(a#2#1#0), Lit(a#2#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#2#0#0, a#2#1#0, a#2#2#0)));

function AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(DatatypeType) : Seq;

axiom (forall a#3#0#0: Seq, a#3#1#0: int, a#3#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#3#0#0, a#3#1#0, a#3#2#0) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#3#0#0, a#3#1#0, a#3#2#0)) == a#3#0#0);

axiom (forall a#4#0#0: Seq, a#4#1#0: int, a#4#2#0: DatatypeType, i: int :: { Seq#Index(a#4#0#0, i), #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#4#0#0, a#4#1#0, a#4#2#0) } 0 <= i && i < Seq#Length(a#4#0#0) ==> DtRank($Unbox(Seq#Index(a#4#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#4#0#0, a#4#1#0, a#4#2#0)));

axiom (forall a#5#0#0: Seq, a#5#1#0: int, a#5#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#5#0#0, a#5#1#0, a#5#2#0) } Seq#Rank(a#5#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#5#0#0, a#5#1#0, a#5#2#0)));

function AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(DatatypeType) : int;

axiom (forall a#6#0#0: Seq, a#6#1#0: int, a#6#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#6#0#0, a#6#1#0, a#6#2#0) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#6#0#0, a#6#1#0, a#6#2#0)) == a#6#1#0);

function AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(DatatypeType) : DatatypeType;

axiom (forall a#7#0#0: Seq, a#7#1#0: int, a#7#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#7#0#0, a#7#1#0, a#7#2#0) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#7#0#0, a#7#1#0, a#7#2#0)) == a#7#2#0);

axiom (forall a#8#0#0: Seq, a#8#1#0: int, a#8#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#8#0#0, a#8#1#0, a#8#2#0) } DtRank(a#8#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#8#0#0, a#8#1#0, a#8#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(d) } $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(d) ==> AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) ==> AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d));

function AwsCryptographyPrimitivesTypes.AesKdfCtrInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AesKdfCtrInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(a), AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(b)) && AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(a) == AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(b) && Wrappers.Option#Equal(AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(a), AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.AesKdfCtrInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.AesKdfCtrInput: ClassName;

const unique class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?: ClassName;

function Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) == Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory? && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) == tytagFamily$IAwsCryptographicPrimitivesClientCallHistory;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()));

axiom (forall $o: ref :: { $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) } $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) <==> $o == null || dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?());

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?(), $h) } $IsAlloc($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) == Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) == tytagFamily$IAwsCryptographicPrimitivesClientCallHistory;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory._ctor (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.__ctor() returns (this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory._ctor (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.__ctor();



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory._ctor (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.__ctor() returns (this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), $Heap));
  modifies $Heap;
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSuccGhost(old($Heap), $Heap);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory._ctor (correctness)"} Impl$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.__ctor() returns (this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSuccGhost(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory._ctor (correctness)"} Impl$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.__ctor() returns (this: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var this.GenerateRandomBytes: Seq;
  var this.Digest: Seq;
  var this.HMac: Seq;
  var this.HkdfExtract: Seq;
  var this.HkdfExpand: Seq;
  var this.Hkdf: Seq;
  var this.KdfCounterMode: Seq;
  var this.AesKdfCounterMode: Seq;
  var this.AESEncrypt: Seq;
  var this.AESDecrypt: Seq;
  var this.GenerateRSAKeyPair: Seq;
  var this.GetRSAKeyModulusLength: Seq;
  var this.RSADecrypt: Seq;
  var this.RSAEncrypt: Seq;
  var this.GenerateECDSASignatureKey: Seq;
  var this.ECDSASign: Seq;
  var this.ECDSAVerify: Seq;
  var this.GenerateECCKeyPair: Seq;
  var this.GetPublicKeyFromPrivateKey: Seq;
  var this.ValidatePublicKey: Seq;
  var this.DeriveSharedSecret: Seq;
  var this.CompressPublicKey: Seq;
  var this.DecompressPublicKey: Seq;
  var this.ParsePublicKey: Seq;
  var defass#this.GenerateRandomBytes: bool;
  var defass#this.Digest: bool;
  var defass#this.HMac: bool;
  var defass#this.HkdfExtract: bool;
  var defass#this.HkdfExpand: bool;
  var defass#this.Hkdf: bool;
  var defass#this.KdfCounterMode: bool;
  var defass#this.AesKdfCounterMode: bool;
  var defass#this.AESEncrypt: bool;
  var defass#this.AESDecrypt: bool;
  var defass#this.GenerateRSAKeyPair: bool;
  var defass#this.GetRSAKeyModulusLength: bool;
  var defass#this.RSADecrypt: bool;
  var defass#this.RSAEncrypt: bool;
  var defass#this.GenerateECDSASignatureKey: bool;
  var defass#this.ECDSASign: bool;
  var defass#this.ECDSAVerify: bool;
  var defass#this.GenerateECCKeyPair: bool;
  var defass#this.GetPublicKeyFromPrivateKey: bool;
  var defass#this.ValidatePublicKey: bool;
  var defass#this.DeriveSharedSecret: bool;
  var defass#this.CompressPublicKey: bool;
  var defass#this.DecompressPublicKey: bool;
  var defass#this.ParsePublicKey: bool;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory._ctor"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(49,24): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    this.GenerateRandomBytes := Lit(Seq#Empty(): Seq);
    defass#this.GenerateRandomBytes := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(50,31)"} true;
    assume true;
    assume true;
    this.Digest := Lit(Seq#Empty(): Seq);
    defass#this.Digest := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(51,18)"} true;
    assume true;
    assume true;
    this.HMac := Lit(Seq#Empty(): Seq);
    defass#this.HMac := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(52,16)"} true;
    assume true;
    assume true;
    this.HkdfExtract := Lit(Seq#Empty(): Seq);
    defass#this.HkdfExtract := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(53,23)"} true;
    assume true;
    assume true;
    this.HkdfExpand := Lit(Seq#Empty(): Seq);
    defass#this.HkdfExpand := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(54,22)"} true;
    assume true;
    assume true;
    this.Hkdf := Lit(Seq#Empty(): Seq);
    defass#this.Hkdf := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(55,16)"} true;
    assume true;
    assume true;
    this.KdfCounterMode := Lit(Seq#Empty(): Seq);
    defass#this.KdfCounterMode := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(56,26)"} true;
    assume true;
    assume true;
    this.AesKdfCounterMode := Lit(Seq#Empty(): Seq);
    defass#this.AesKdfCounterMode := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(57,29)"} true;
    assume true;
    assume true;
    this.AESEncrypt := Lit(Seq#Empty(): Seq);
    defass#this.AESEncrypt := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(58,22)"} true;
    assume true;
    assume true;
    this.AESDecrypt := Lit(Seq#Empty(): Seq);
    defass#this.AESDecrypt := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(59,22)"} true;
    assume true;
    assume true;
    this.GenerateRSAKeyPair := Lit(Seq#Empty(): Seq);
    defass#this.GenerateRSAKeyPair := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(60,30)"} true;
    assume true;
    assume true;
    this.GetRSAKeyModulusLength := Lit(Seq#Empty(): Seq);
    defass#this.GetRSAKeyModulusLength := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(61,34)"} true;
    assume true;
    assume true;
    this.RSADecrypt := Lit(Seq#Empty(): Seq);
    defass#this.RSADecrypt := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(62,22)"} true;
    assume true;
    assume true;
    this.RSAEncrypt := Lit(Seq#Empty(): Seq);
    defass#this.RSAEncrypt := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(63,22)"} true;
    assume true;
    assume true;
    this.GenerateECDSASignatureKey := Lit(Seq#Empty(): Seq);
    defass#this.GenerateECDSASignatureKey := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(64,37)"} true;
    assume true;
    assume true;
    this.ECDSASign := Lit(Seq#Empty(): Seq);
    defass#this.ECDSASign := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(65,21)"} true;
    assume true;
    assume true;
    this.ECDSAVerify := Lit(Seq#Empty(): Seq);
    defass#this.ECDSAVerify := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(66,23)"} true;
    assume true;
    assume true;
    this.GenerateECCKeyPair := Lit(Seq#Empty(): Seq);
    defass#this.GenerateECCKeyPair := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(67,30)"} true;
    assume true;
    assume true;
    this.GetPublicKeyFromPrivateKey := Lit(Seq#Empty(): Seq);
    defass#this.GetPublicKeyFromPrivateKey := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(68,38)"} true;
    assume true;
    assume true;
    this.ValidatePublicKey := Lit(Seq#Empty(): Seq);
    defass#this.ValidatePublicKey := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(69,29)"} true;
    assume true;
    assume true;
    this.DeriveSharedSecret := Lit(Seq#Empty(): Seq);
    defass#this.DeriveSharedSecret := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(70,30)"} true;
    assume true;
    assume true;
    this.CompressPublicKey := Lit(Seq#Empty(): Seq);
    defass#this.CompressPublicKey := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(71,29)"} true;
    assume true;
    assume true;
    this.DecompressPublicKey := Lit(Seq#Empty(): Seq);
    defass#this.DecompressPublicKey := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(72,31)"} true;
    assume true;
    assume true;
    this.ParsePublicKey := Lit(Seq#Empty(): Seq);
    defass#this.ParsePublicKey := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(73,26)"} true;
    assume defass#this.GenerateRandomBytes;
    assume defass#this.Digest;
    assume defass#this.HMac;
    assume defass#this.HkdfExtract;
    assume defass#this.HkdfExpand;
    assume defass#this.Hkdf;
    assume defass#this.KdfCounterMode;
    assume defass#this.AesKdfCounterMode;
    assume defass#this.AESEncrypt;
    assume defass#this.AESDecrypt;
    assume defass#this.GenerateRSAKeyPair;
    assume defass#this.GetRSAKeyModulusLength;
    assume defass#this.RSADecrypt;
    assume defass#this.RSAEncrypt;
    assume defass#this.GenerateECDSASignatureKey;
    assume defass#this.ECDSASign;
    assume defass#this.ECDSAVerify;
    assume defass#this.GenerateECCKeyPair;
    assume defass#this.GetPublicKeyFromPrivateKey;
    assume defass#this.ValidatePublicKey;
    assume defass#this.DeriveSharedSecret;
    assume defass#this.CompressPublicKey;
    assume defass#this.DecompressPublicKey;
    assume defass#this.ParsePublicKey;
    assume !$Unbox(read($Heap, this, alloc)): bool;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq == this.GenerateRandomBytes;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq == this.Digest;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac)): Seq == this.HMac;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq == this.HkdfExtract;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq == this.HkdfExpand;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq == this.Hkdf;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq == this.KdfCounterMode;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq == this.AesKdfCounterMode;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq == this.AESEncrypt;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq == this.AESDecrypt;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq == this.GenerateRSAKeyPair;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength)): Seq == this.GetRSAKeyModulusLength;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq == this.RSADecrypt;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq == this.RSAEncrypt;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq == this.GenerateECDSASignatureKey;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq == this.ECDSASign;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq == this.ECDSAVerify;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq == this.GenerateECCKeyPair;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq == this.GetPublicKeyFromPrivateKey;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq == this.ValidatePublicKey;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq == this.DeriveSharedSecret;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq == this.CompressPublicKey;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq == this.DecompressPublicKey;
    assume $Unbox(read($Heap, this, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq == this.ParsePublicKey;
    $Heap := update($Heap, this, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    return;
}



const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$GenerateRandomBytes) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes);
}

function Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) == tytagFamily$GenerateRandomBytesInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()));

function Tclass.AwsCryptographyPrimitivesTypes.Error() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.Error()) == Tagclass.AwsCryptographyPrimitivesTypes.Error && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.Error()) == tytagFamily$Error;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.Error: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.Error()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.Error()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$Digest) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest);
}

function Tclass.AwsCryptographyPrimitivesTypes.DigestInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) == Tagclass.AwsCryptographyPrimitivesTypes.DigestInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) == tytagFamily$DigestInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DigestInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$HMac) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac);
}

function Tclass.AwsCryptographyPrimitivesTypes.HMacInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) == Tagclass.AwsCryptographyPrimitivesTypes.HMacInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) == tytagFamily$HMacInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.HMacInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HMac)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$HkdfExtract) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract);
}

function Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) == Tagclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) == tytagFamily$HkdfExtractInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$HkdfExpand) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand);
}

function Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) == Tagclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) == tytagFamily$HkdfExpandInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$Hkdf) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf);
}

function Tclass.AwsCryptographyPrimitivesTypes.HkdfInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) == Tagclass.AwsCryptographyPrimitivesTypes.HkdfInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) == tytagFamily$HkdfInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.HkdfInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$KdfCounterMode) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode);
}

function Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) == Tagclass.AwsCryptographyPrimitivesTypes.KdfCtrInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) == tytagFamily$KdfCtrInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.KdfCtrInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$AesKdfCounterMode) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode);
}

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$AESEncrypt) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt);
}

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$AESDecrypt) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt);
}

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$GenerateRSAKeyPair) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair);
}

function Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) == tytagFamily$GenerateRSAKeyPairInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()));

function Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) == tytagFamily$GenerateRSAKeyPairOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$GetRSAKeyModulusLength) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength);
}

function Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) == Tagclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) == tytagFamily$GetRSAKeyModulusLengthInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()));

function Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) == tytagFamily$GetRSAKeyModulusLengthOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetRSAKeyModulusLength)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$RSADecrypt) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt);
}

function Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) == Tagclass.AwsCryptographyPrimitivesTypes.RSADecryptInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) == tytagFamily$RSADecryptInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSADecryptInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$RSAEncrypt) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt);
}

function Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) == Tagclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) == tytagFamily$RSAEncryptInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$GenerateECDSASignatureKey) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey);
}

function Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) == tytagFamily$GenerateECDSASignatureKeyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()));

function Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) == tytagFamily$GenerateECDSASignatureKeyOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$ECDSASign) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign);
}

function Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) == Tagclass.AwsCryptographyPrimitivesTypes.ECDSASignInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) == tytagFamily$ECDSASignInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ECDSASignInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$ECDSAVerify) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify);
}

function Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) == tytagFamily$ECDSAVerifyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$GenerateECCKeyPair) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair);
}

function Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) == tytagFamily$GenerateECCKeyPairInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()));

function Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) == tytagFamily$GenerateECCKeyPairOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$GetPublicKeyFromPrivateKey) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey);
}

function Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) == tytagFamily$GetPublicKeyFromPrivateKeyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()));

function Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) == tytagFamily$GetPublicKeyFromPrivateKeyOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$ValidatePublicKey) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey);
}

function Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) == tytagFamily$ValidatePublicKeyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()));

function Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) == tytagFamily$ValidatePublicKeyOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$DeriveSharedSecret) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret);
}

function Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) == Tagclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) == tytagFamily$DeriveSharedSecretInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()));

function Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) == tytagFamily$DeriveSharedSecretOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$CompressPublicKey) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey);
}

function Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) == tytagFamily$CompressPublicKeyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()));

function Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) == tytagFamily$CompressPublicKeyOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$DecompressPublicKey) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey);
}

function Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) == tytagFamily$DecompressPublicKeyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()));

function Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) == tytagFamily$DecompressPublicKeyOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

const AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey: Field
uses {
axiom FDim(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey) == 0 && FieldOfDecl(class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?, field$ParsePublicKey) == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey && $IsGhostField(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey);
}

function Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) == Tagclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) == tytagFamily$ParsePublicKeyInput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()));

function Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) == Tagclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) == tytagFamily$ParsePublicKeyOutput;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() ==> $Is($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())))));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, TSeq(Tclass.AwsCryptographyPrimitivesTypes.DafnyCallEvent(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))), $h));

axiom (forall c#0: ref :: { $Is(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) } $Is(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()) <==> $Is(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), $h) } $IsAlloc(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), $h) <==> $IsAlloc(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory?(), $h));

const unique class.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?: ClassName;

function Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) == Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient? && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) == tytagFamily$IAwsCryptographicPrimitivesClient;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()));

axiom (forall $o: ref :: { $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) } $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) <==> $o == null || implements$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(dtype($o)));

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $h) } $IsAlloc($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(ty: Ty) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this: ref) : Set
uses {
axiom 0 < $FunctionContextHeight ==> (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o) } $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o), TSet(Tclass._System.object())));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o), TSet(Tclass._System.object()), $h));
}

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this: ref) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this) || (2 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient())) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))]);
}

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this: ref) : bool;

function Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) == Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) == tytagFamily$IAwsCryptographicPrimitivesClient;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()));

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this: ref) : ref
uses {
axiom 1 < $FunctionContextHeight ==> (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o) } $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()));
axiom 1 < $FunctionContextHeight ==> (forall $h: Heap, $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), $h));
}

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#requires(ref) : bool;

axiom (forall this: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#requires(this) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#requires(this) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id3199"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(124,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume this == this;
    assume this == this || AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))];
    goto anon5;

  anon8_Else:
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))];
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(129,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(138,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0));
  requires {:id "id3215"} Lit(true);
  requires {:id "id3216"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3217"} Lit(true);
  free ensures {:id "id3218"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3219"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3220"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(144,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(153,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0));
  requires {:id "id3232"} Lit(true);
  requires {:id "id3233"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3234"} Lit(true);
  free ensures {:id "id3235"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3236"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3237"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this: ref, input#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this, input#0) || (2 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this, input#0) || (2 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
}

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this: ref, input#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#requires(ref, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#requires(this, input#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#requires(this, input#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(165,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(174,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0));
  requires {:id "id3249"} Lit(true);
  requires {:id "id3250"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3251"} Lit(true);
  free ensures {:id "id3252"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3253"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3254"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(180,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(189,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0));
  requires {:id "id3266"} Lit(true);
  requires {:id "id3267"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3268"} Lit(true);
  free ensures {:id "id3269"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3270"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3271"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(195,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(204,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0));
  requires {:id "id3283"} Lit(true);
  requires {:id "id3284"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3285"} Lit(true);
  free ensures {:id "id3286"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3287"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3288"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(210,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(219,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0));
  requires {:id "id3300"} Lit(true);
  requires {:id "id3301"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3302"} Lit(true);
  free ensures {:id "id3303"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3304"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3305"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(225,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(234,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0));
  requires {:id "id3317"} Lit(true);
  requires {:id "id3318"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3319"} Lit(true);
  free ensures {:id "id3320"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3321"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3322"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(240,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(249,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0));
  requires {:id "id3334"} Lit(true);
  requires {:id "id3335"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3336"} Lit(true);
  free ensures {:id "id3337"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3338"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3339"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(255,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(264,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0));
  requires {:id "id3351"} Lit(true);
  requires {:id "id3352"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3353"} Lit(true);
  free ensures {:id "id3354"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3355"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3356"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(270,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(279,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0));
  requires {:id "id3368"} Lit(true);
  requires {:id "id3369"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3370"} Lit(true);
  free ensures {:id "id3371"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3372"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3373"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this: ref, input#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (3 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (3 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
}

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this: ref, input#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#requires(ref, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#requires(this, input#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#requires(this, input#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(291,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(300,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0));
  requires {:id "id3385"} Lit(true);
  requires {:id "id3386"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3387"} Lit(true);
  free ensures {:id "id3388"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3389"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3390"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(306,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(315,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0));
  requires {:id "id3402"} Lit(true);
  requires {:id "id3403"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3404"} Lit(true);
  free ensures {:id "id3405"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3406"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3407"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(321,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(330,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0));
  requires {:id "id3419"} Lit(true);
  requires {:id "id3420"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3421"} Lit(true);
  free ensures {:id "id3422"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3423"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3424"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(336,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(345,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0));
  requires {:id "id3436"} Lit(true);
  requires {:id "id3437"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3438"} Lit(true);
  free ensures {:id "id3439"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3440"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3441"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(351,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(360,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0));
  requires {:id "id3453"} Lit(true);
  requires {:id "id3454"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3455"} Lit(true);
  free ensures {:id "id3456"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3457"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3458"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(366,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(375,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0));
  requires {:id "id3470"} Lit(true);
  requires {:id "id3471"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3472"} Lit(true);
  free ensures {:id "id3473"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3474"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3475"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(381,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(390,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0));
  requires {:id "id3487"} Lit(true);
  requires {:id "id3488"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3489"} Lit(true);
  free ensures {:id "id3490"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3491"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3492"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(396,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(405,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0));
  requires {:id "id3504"} Lit(true);
  requires {:id "id3505"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3506"} Lit(true);
  free ensures {:id "id3507"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3508"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3509"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(411,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(420,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0));
  requires {:id "id3521"} Lit(true);
  requires {:id "id3522"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3523"} Lit(true);
  free ensures {:id "id3524"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3525"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3526"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(426,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(435,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0));
  requires {:id "id3538"} Lit(true);
  requires {:id "id3539"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3540"} Lit(true);
  free ensures {:id "id3541"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3542"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3543"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(441,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(450,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0));
  requires {:id "id3555"} Lit(true);
  requires {:id "id3556"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3557"} Lit(true);
  free ensures {:id "id3558"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3559"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3560"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(456,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(465,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey (call precondtion)"} CallPre$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0));
  requires {:id "id3572"} Lit(true);
  requires {:id "id3573"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);



procedure {:verboseName "AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey (call postcondition)"} CallPost$$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id3574"} Lit(true);
  free ensures {:id "id3575"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this);
  free ensures AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id3576"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0);
  free ensures true;
  free ensures {:id "id3577"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall c#0: ref :: { $Is(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) } $Is(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) <==> $Is(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $h) } $IsAlloc(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $h) <==> $IsAlloc(c#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?(), $h));

function #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(DatatypeType, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#0#0#0, a#0#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#0#0#0, a#0#1#0)) == ##AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput);
}

function AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#1#0#0, a#1#1#0)));

function Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) == Tagclass.AwsCryptographyPrimitivesTypes.ECCPublicKey && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) == tytagFamily$ECCPublicKey;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ECCPublicKey: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()));

function Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) == Tagclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) == tytagFamily$ECDHCurveSpec;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) <==> $Is(a#2#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) && $Is(a#2#1#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(Lit(a#3#0#0), Lit(a#3#1#0)) } #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#3#0#0, a#3#1#0)));

function AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.publicKey(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#4#0#0, a#4#1#0) } AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.publicKey(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#4#0#0, a#4#1#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#5#0#0, a#5#1#0) } DtRank(a#5#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#5#0#0, a#5#1#0)));

function AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#6#0#0, a#6#1#0) } AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.eccCurve(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#6#0#0, a#6#1#0)) == a#6#1#0);

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#7#0#0, a#7#1#0) } DtRank(a#7#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput(a#7#0#0, a#7#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(d) ==> AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) ==> AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.CompressPublicKeyInput_q(d));

function AwsCryptographyPrimitivesTypes.CompressPublicKeyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.CompressPublicKeyInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.publicKey(a), AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.publicKey(b)) && AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.eccCurve(a), AwsCryptographyPrimitivesTypes.CompressPublicKeyInput.eccCurve(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.CompressPublicKeyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput: DtCtorId
uses {
axiom (forall a#8#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#8#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#8#0#0)) == ##AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput);
}

function AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d) ==> (exists a#9#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#9#0#0)));

axiom (forall a#10#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#10#0#0), Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#10#0#0), Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) <==> $Is(a#10#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.compressedPublicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.compressedPublicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#11#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(Lit(a#11#0#0)) } #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(Lit(a#11#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#11#0#0)));

function AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.compressedPublicKey(DatatypeType) : Seq;

axiom (forall a#12#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#12#0#0) } AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.compressedPublicKey(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#12#0#0)) == a#12#0#0);

axiom (forall a#13#0#0: Seq, i: int :: { Seq#Index(a#13#0#0, i), #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#13#0#0) } 0 <= i && i < Seq#Length(a#13#0#0) ==> DtRank($Unbox(Seq#Index(a#13#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#13#0#0)));

axiom (forall a#14#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#14#0#0) } Seq#Rank(a#14#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput(a#14#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(d) ==> AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput()) ==> AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.CompressPublicKeyOutput_q(d));

function AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.compressedPublicKey(a), AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput.compressedPublicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig()) == ##AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig;
axiom $Is(#AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig(), Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig());
axiom #AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig() == Lit(#AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig());
}

const unique ##AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig()) == ##AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig;
}

function AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d) } AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d) } AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d) ==> d == #AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig());

function Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) == Tagclass.AwsCryptographyPrimitivesTypes.CryptoConfig && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) == tytagFamily$CryptoConfig;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.CryptoConfig: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.CryptoConfig(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.CryptoConfig(d) } $IsA#AwsCryptographyPrimitivesTypes.CryptoConfig(d) ==> AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) ==> AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(d));

function AwsCryptographyPrimitivesTypes.CryptoConfig#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.CryptoConfig#Equal(a, b) } AwsCryptographyPrimitivesTypes.CryptoConfig#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.CryptoConfig#Equal(a, b) } AwsCryptographyPrimitivesTypes.CryptoConfig#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.CryptoConfig: ClassName;

function #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(Seq, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput: DtCtorId
uses {
axiom (forall a#19#0#0: Seq, a#19#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#19#0#0, a#19#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#19#0#0, a#19#1#0)) == ##AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput);
}

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d) ==> (exists a#20#0#0: Seq, a#20#1#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#20#0#0, a#20#1#0)));

axiom (forall a#21#0#0: Seq, a#21#1#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#21#0#0, a#21#1#0), Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#21#0#0, a#21#1#0), Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) <==> $Is(a#21#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#21#1#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.compressedPublicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.compressedPublicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall a#22#0#0: Seq, a#22#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(Lit(a#22#0#0), Lit(a#22#1#0)) } #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(Lit(a#22#0#0), Lit(a#22#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#22#0#0, a#22#1#0)));

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.compressedPublicKey(DatatypeType) : Seq;

axiom (forall a#23#0#0: Seq, a#23#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#23#0#0, a#23#1#0) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.compressedPublicKey(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#23#0#0, a#23#1#0)) == a#23#0#0);

axiom (forall a#24#0#0: Seq, a#24#1#0: DatatypeType, i: int :: { Seq#Index(a#24#0#0, i), #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#24#0#0, a#24#1#0) } 0 <= i && i < Seq#Length(a#24#0#0) ==> DtRank($Unbox(Seq#Index(a#24#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#24#0#0, a#24#1#0)));

axiom (forall a#25#0#0: Seq, a#25#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#25#0#0, a#25#1#0) } Seq#Rank(a#25#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#25#0#0, a#25#1#0)));

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#26#0#0: Seq, a#26#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#26#0#0, a#26#1#0) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.eccCurve(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#26#0#0, a#26#1#0)) == a#26#1#0);

axiom (forall a#27#0#0: Seq, a#27#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#27#0#0, a#27#1#0) } DtRank(a#27#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput(a#27#0#0, a#27#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(d) ==> AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) ==> AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.DecompressPublicKeyInput_q(d));

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.compressedPublicKey(a), AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.compressedPublicKey(b)) && AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.eccCurve(a), AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput.eccCurve(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput: DtCtorId
uses {
axiom (forall a#28#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#28#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#28#0#0)) == ##AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput);
}

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d) ==> (exists a#29#0#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#29#0#0)));

axiom (forall a#30#0#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#30#0#0), Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#30#0#0), Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) <==> $Is(a#30#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h));

axiom (forall a#31#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(Lit(a#31#0#0)) } #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(Lit(a#31#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#31#0#0)));

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.publicKey(DatatypeType) : DatatypeType;

axiom (forall a#32#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#32#0#0) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.publicKey(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#32#0#0)) == a#32#0#0);

axiom (forall a#33#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#33#0#0) } DtRank(a#33#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput(a#33#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(d) ==> AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput()) ==> AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.DecompressPublicKeyOutput_q(d));

function AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.publicKey(a), AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(DatatypeType, DatatypeType, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput: DtCtorId
uses {
axiom (forall a#34#0#0: DatatypeType, a#34#1#0: DatatypeType, a#34#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#34#0#0, a#34#1#0, a#34#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#34#0#0, a#34#1#0, a#34#2#0)) == ##AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput);
}

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) ==> (exists a#35#0#0: DatatypeType, a#35#1#0: DatatypeType, a#35#2#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#35#0#0, a#35#1#0, a#35#2#0)));

function Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) == Tagclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) == tytagFamily$ECCPrivateKey;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()));

axiom (forall a#36#0#0: DatatypeType, a#36#1#0: DatatypeType, a#36#2#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#36#0#0, a#36#1#0, a#36#2#0), Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) } $Is(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#36#0#0, a#36#1#0, a#36#2#0), Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) <==> $Is(a#36#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) && $Is(a#36#1#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) && $Is(a#36#2#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h));

axiom (forall a#37#0#0: DatatypeType, a#37#1#0: DatatypeType, a#37#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(Lit(a#37#0#0), Lit(a#37#1#0), Lit(a#37#2#0)) } #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(Lit(a#37#0#0), Lit(a#37#1#0), Lit(a#37#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#37#0#0, a#37#1#0, a#37#2#0)));

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#38#0#0: DatatypeType, a#38#1#0: DatatypeType, a#38#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#38#0#0, a#38#1#0, a#38#2#0) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.eccCurve(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#38#0#0, a#38#1#0, a#38#2#0)) == a#38#0#0);

axiom (forall a#39#0#0: DatatypeType, a#39#1#0: DatatypeType, a#39#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#39#0#0, a#39#1#0, a#39#2#0) } DtRank(a#39#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#39#0#0, a#39#1#0, a#39#2#0)));

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.privateKey(DatatypeType) : DatatypeType;

axiom (forall a#40#0#0: DatatypeType, a#40#1#0: DatatypeType, a#40#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#40#0#0, a#40#1#0, a#40#2#0) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.privateKey(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#40#0#0, a#40#1#0, a#40#2#0)) == a#40#1#0);

axiom (forall a#41#0#0: DatatypeType, a#41#1#0: DatatypeType, a#41#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#41#0#0, a#41#1#0, a#41#2#0) } DtRank(a#41#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#41#0#0, a#41#1#0, a#41#2#0)));

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.publicKey(DatatypeType) : DatatypeType;

axiom (forall a#42#0#0: DatatypeType, a#42#1#0: DatatypeType, a#42#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#42#0#0, a#42#1#0, a#42#2#0) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.publicKey(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#42#0#0, a#42#1#0, a#42#2#0)) == a#42#2#0);

axiom (forall a#43#0#0: DatatypeType, a#43#1#0: DatatypeType, a#43#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#43#0#0, a#43#1#0, a#43#2#0) } DtRank(a#43#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput(a#43#0#0, a#43#1#0, a#43#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(d) } $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(d) ==> AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) ==> AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.DeriveSharedSecretInput_q(d));

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.eccCurve(a), AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.eccCurve(b)) && AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.privateKey(a), AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.privateKey(b)) && AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.publicKey(a), AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput: ClassName;

function #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput: DtCtorId
uses {
axiom (forall a#44#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#44#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#44#0#0)) == ##AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput);
}

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d) ==> (exists a#45#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#45#0#0)));

axiom (forall a#46#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#46#0#0), Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) } $Is(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#46#0#0), Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) <==> $Is(a#46#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.sharedSecret(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.sharedSecret(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#47#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(Lit(a#47#0#0)) } #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(Lit(a#47#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#47#0#0)));

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.sharedSecret(DatatypeType) : Seq;

axiom (forall a#48#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#48#0#0) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.sharedSecret(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#48#0#0)) == a#48#0#0);

axiom (forall a#49#0#0: Seq, i: int :: { Seq#Index(a#49#0#0, i), #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#49#0#0) } 0 <= i && i < Seq#Length(a#49#0#0) ==> DtRank($Unbox(Seq#Index(a#49#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#49#0#0)));

axiom (forall a#50#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#50#0#0) } Seq#Rank(a#50#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput(a#50#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(d) ==> AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput()) ==> AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.DeriveSharedSecretOutput_q(d));

function AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.sharedSecret(a), AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput.sharedSecret(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512()) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512;
axiom $Is(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512(), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm());
axiom #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512() == Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512());
}

const unique ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512()) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512;
}

function AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d) ==> d == #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512());

function Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) == Tagclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) == tytagFamily$DigestAlgorithm;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()));

function #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384()) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384;
axiom $Is(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384(), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm());
axiom #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384() == Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
}

const unique ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384()) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384;
}

function AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d) ==> d == #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());

function #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256()) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256;
axiom $Is(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256(), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm());
axiom #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256() == Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256());
}

const unique ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256()) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256;
}

function AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d) ==> d == #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(d) } $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(d) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d) || AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d) || AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) } { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) } { AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(d) || AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(d) || AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(d));

function AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(a) } { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(b) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(a) && AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(b) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(a) } { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(b) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(a) && AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(b) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(a) } { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(b) } AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(a) && AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__256_q(b) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b) } AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DigestAlgorithm: ClassName;

function #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(DatatypeType, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.DigestInput.DigestInput: DtCtorId
uses {
axiom (forall a#63#0#0: DatatypeType, a#63#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#63#0#0, a#63#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#63#0#0, a#63#1#0)) == ##AwsCryptographyPrimitivesTypes.DigestInput.DigestInput);
}

function AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d) } AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.DigestInput.DigestInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d) } AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d) ==> (exists a#64#0#0: DatatypeType, a#64#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#64#0#0, a#64#1#0)));

axiom (forall a#65#0#0: DatatypeType, a#65#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#65#0#0, a#65#1#0), Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) } $Is(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#65#0#0, a#65#1#0), Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) <==> $Is(a#65#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#65#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.DigestInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.DigestInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#66#0#0: DatatypeType, a#66#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(Lit(a#66#0#0), Lit(a#66#1#0)) } #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(Lit(a#66#0#0), Lit(a#66#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#66#0#0, a#66#1#0)));

function AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#67#0#0: DatatypeType, a#67#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#67#0#0, a#67#1#0) } AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#67#0#0, a#67#1#0)) == a#67#0#0);

axiom (forall a#68#0#0: DatatypeType, a#68#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#68#0#0, a#68#1#0) } DtRank(a#68#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#68#0#0, a#68#1#0)));

function AwsCryptographyPrimitivesTypes.DigestInput.message(DatatypeType) : Seq;

axiom (forall a#69#0#0: DatatypeType, a#69#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#69#0#0, a#69#1#0) } AwsCryptographyPrimitivesTypes.DigestInput.message(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#69#0#0, a#69#1#0)) == a#69#1#0);

axiom (forall a#70#0#0: DatatypeType, a#70#1#0: Seq, i: int :: { Seq#Index(a#70#1#0, i), #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#70#0#0, a#70#1#0) } 0 <= i && i < Seq#Length(a#70#1#0) ==> DtRank($Unbox(Seq#Index(a#70#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#70#0#0, a#70#1#0)));

axiom (forall a#71#0#0: DatatypeType, a#71#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#71#0#0, a#71#1#0) } Seq#Rank(a#71#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(a#71#0#0, a#71#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.DigestInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.DigestInput(d) } $IsA#AwsCryptographyPrimitivesTypes.DigestInput(d) ==> AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) ==> AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(d));

function AwsCryptographyPrimitivesTypes.DigestInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DigestInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(a), AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.DigestInput.message(a), AwsCryptographyPrimitivesTypes.DigestInput.message(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.DigestInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.DigestInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.DigestInput: ClassName;

function #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey: DtCtorId
uses {
axiom (forall a#72#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#72#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#72#0#0)) == ##AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey);
}

function AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d) } AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d) } AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d) ==> (exists a#73#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#73#0#0)));

axiom (forall a#74#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#74#0#0), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) } $Is(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#74#0#0), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) <==> $Is(a#74#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECCPrivateKey.pem(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECCPrivateKey.pem(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#75#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(Lit(a#75#0#0)) } #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(Lit(a#75#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#75#0#0)));

function AwsCryptographyPrimitivesTypes.ECCPrivateKey.pem(DatatypeType) : Seq;

axiom (forall a#76#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#76#0#0) } AwsCryptographyPrimitivesTypes.ECCPrivateKey.pem(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#76#0#0)) == a#76#0#0);

axiom (forall a#77#0#0: Seq, i: int :: { Seq#Index(a#77#0#0, i), #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#77#0#0) } 0 <= i && i < Seq#Length(a#77#0#0) ==> DtRank($Unbox(Seq#Index(a#77#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#77#0#0)));

axiom (forall a#78#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#78#0#0) } Seq#Rank(a#78#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey(a#78#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ECCPrivateKey(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ECCPrivateKey(d) } $IsA#AwsCryptographyPrimitivesTypes.ECCPrivateKey(d) ==> AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) ==> AwsCryptographyPrimitivesTypes.ECCPrivateKey.ECCPrivateKey_q(d));

function AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.ECCPrivateKey.pem(a), AwsCryptographyPrimitivesTypes.ECCPrivateKey.pem(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ECCPrivateKey: ClassName;

function #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey: DtCtorId
uses {
axiom (forall a#79#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#79#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#79#0#0)) == ##AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey);
}

function AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d) } AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d) } AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d) ==> (exists a#80#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#80#0#0)));

axiom (forall a#81#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#81#0#0), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) } $Is(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#81#0#0), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) <==> $Is(a#81#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECCPublicKey.der(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECCPublicKey.der(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#82#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(Lit(a#82#0#0)) } #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(Lit(a#82#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#82#0#0)));

function AwsCryptographyPrimitivesTypes.ECCPublicKey.der(DatatypeType) : Seq;

axiom (forall a#83#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#83#0#0) } AwsCryptographyPrimitivesTypes.ECCPublicKey.der(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#83#0#0)) == a#83#0#0);

axiom (forall a#84#0#0: Seq, i: int :: { Seq#Index(a#84#0#0, i), #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#84#0#0) } 0 <= i && i < Seq#Length(a#84#0#0) ==> DtRank($Unbox(Seq#Index(a#84#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#84#0#0)));

axiom (forall a#85#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#85#0#0) } Seq#Rank(a#85#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey(a#85#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ECCPublicKey(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ECCPublicKey(d) } $IsA#AwsCryptographyPrimitivesTypes.ECCPublicKey(d) ==> AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()) ==> AwsCryptographyPrimitivesTypes.ECCPublicKey.ECCPublicKey_q(d));

function AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.ECCPublicKey.der(a), AwsCryptographyPrimitivesTypes.ECCPublicKey.der(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ECCPublicKey: ClassName;

function #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256;
axiom $Is(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256(), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec());
axiom #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256() == Lit(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256());
}

const unique ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256;
}

function AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d) ==> d == #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P256());

function #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384;
axiom $Is(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384(), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec());
axiom #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384() == Lit(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384());
}

const unique ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384;
}

function AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d) ==> d == #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P384());

function #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521;
axiom $Is(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521(), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec());
axiom #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521() == Lit(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521());
}

const unique ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521;
}

function AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d) ==> d == #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC_NIST_P521());

function #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2;
axiom $Is(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2(), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec());
axiom #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2() == Lit(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2());
}

const unique ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2()) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2;
}

function AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d) ==> d == #AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ECDHCurveSpec(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ECDHCurveSpec(d) } $IsA#AwsCryptographyPrimitivesTypes.ECDHCurveSpec(d) ==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d) || AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d) || AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d) || AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) ==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(d) || AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(d) || AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(d) || AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(d));

function AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(a) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(b) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(a) && AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P256_q(b) ==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(a) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(b) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(a) && AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P384_q(b) ==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(a) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(b) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(a) && AwsCryptographyPrimitivesTypes.ECDHCurveSpec.ECC__NIST__P521_q(b) ==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(a) } { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(b) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(a) && AwsCryptographyPrimitivesTypes.ECDHCurveSpec.SM2_q(b) ==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ECDHCurveSpec: ClassName;

function #AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384()) == ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384;
axiom $Is(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384(), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm());
axiom #AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384() == Lit(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384());
}

const unique ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384()) == ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384;
}

function AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d) ==> d == #AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P384());

function Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) == Tagclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) == tytagFamily$ECDSASignatureAlgorithm;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()));

function #AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256()) == ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256;
axiom $Is(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256(), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm());
axiom #AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256() == Lit(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256());
}

const unique ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256()) == ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256;
}

function AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d) ==> d == #AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA_P256());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(d) } $IsA#AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(d) ==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d) || AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) } { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) ==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(d) || AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(d));

function AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(a) } { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(b) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(a) && AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P384_q(b) ==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(a) } { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b), AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(b) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(a) && AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm.ECDSA__P256_q(b) ==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm: ClassName;

function #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(DatatypeType, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput: DtCtorId
uses {
axiom (forall a#110#0#0: DatatypeType, a#110#1#0: Seq, a#110#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#110#0#0, a#110#1#0, a#110#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#110#0#0, a#110#1#0, a#110#2#0)) == ##AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput);
}

function AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) } AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) } AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) ==> (exists a#111#0#0: DatatypeType, a#111#1#0: Seq, a#111#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#111#0#0, a#111#1#0, a#111#2#0)));

axiom (forall a#112#0#0: DatatypeType, a#112#1#0: Seq, a#112#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#112#0#0, a#112#1#0, a#112#2#0), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) } $Is(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#112#0#0, a#112#1#0, a#112#2#0), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) <==> $Is(a#112#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) && $Is(a#112#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#112#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSASignInput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSASignInput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSASignInput.signingKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSASignInput.signingKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSASignInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSASignInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#113#0#0: DatatypeType, a#113#1#0: Seq, a#113#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(Lit(a#113#0#0), Lit(a#113#1#0), Lit(a#113#2#0)) } #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(Lit(a#113#0#0), Lit(a#113#1#0), Lit(a#113#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#113#0#0, a#113#1#0, a#113#2#0)));

function AwsCryptographyPrimitivesTypes.ECDSASignInput.signatureAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#114#0#0: DatatypeType, a#114#1#0: Seq, a#114#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#114#0#0, a#114#1#0, a#114#2#0) } AwsCryptographyPrimitivesTypes.ECDSASignInput.signatureAlgorithm(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#114#0#0, a#114#1#0, a#114#2#0)) == a#114#0#0);

axiom (forall a#115#0#0: DatatypeType, a#115#1#0: Seq, a#115#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#115#0#0, a#115#1#0, a#115#2#0) } DtRank(a#115#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#115#0#0, a#115#1#0, a#115#2#0)));

function AwsCryptographyPrimitivesTypes.ECDSASignInput.signingKey(DatatypeType) : Seq;

axiom (forall a#116#0#0: DatatypeType, a#116#1#0: Seq, a#116#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#116#0#0, a#116#1#0, a#116#2#0) } AwsCryptographyPrimitivesTypes.ECDSASignInput.signingKey(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#116#0#0, a#116#1#0, a#116#2#0)) == a#116#1#0);

axiom (forall a#117#0#0: DatatypeType, a#117#1#0: Seq, a#117#2#0: Seq, i: int :: { Seq#Index(a#117#1#0, i), #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#117#0#0, a#117#1#0, a#117#2#0) } 0 <= i && i < Seq#Length(a#117#1#0) ==> DtRank($Unbox(Seq#Index(a#117#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#117#0#0, a#117#1#0, a#117#2#0)));

axiom (forall a#118#0#0: DatatypeType, a#118#1#0: Seq, a#118#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#118#0#0, a#118#1#0, a#118#2#0) } Seq#Rank(a#118#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#118#0#0, a#118#1#0, a#118#2#0)));

function AwsCryptographyPrimitivesTypes.ECDSASignInput.message(DatatypeType) : Seq;

axiom (forall a#119#0#0: DatatypeType, a#119#1#0: Seq, a#119#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#119#0#0, a#119#1#0, a#119#2#0) } AwsCryptographyPrimitivesTypes.ECDSASignInput.message(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#119#0#0, a#119#1#0, a#119#2#0)) == a#119#2#0);

axiom (forall a#120#0#0: DatatypeType, a#120#1#0: Seq, a#120#2#0: Seq, i: int :: { Seq#Index(a#120#2#0, i), #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#120#0#0, a#120#1#0, a#120#2#0) } 0 <= i && i < Seq#Length(a#120#2#0) ==> DtRank($Unbox(Seq#Index(a#120#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#120#0#0, a#120#1#0, a#120#2#0)));

axiom (forall a#121#0#0: DatatypeType, a#121#1#0: Seq, a#121#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#121#0#0, a#121#1#0, a#121#2#0) } Seq#Rank(a#121#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput(a#121#0#0, a#121#1#0, a#121#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(d) } $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(d) ==> AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) ==> AwsCryptographyPrimitivesTypes.ECDSASignInput.ECDSASignInput_q(d));

function AwsCryptographyPrimitivesTypes.ECDSASignInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECDSASignInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(AwsCryptographyPrimitivesTypes.ECDSASignInput.signatureAlgorithm(a), AwsCryptographyPrimitivesTypes.ECDSASignInput.signatureAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.ECDSASignInput.signingKey(a), AwsCryptographyPrimitivesTypes.ECDSASignInput.signingKey(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.ECDSASignInput.message(a), AwsCryptographyPrimitivesTypes.ECDSASignInput.message(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSASignInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECDSASignInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ECDSASignInput: ClassName;

function #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(DatatypeType, Seq, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput: DtCtorId
uses {
axiom (forall a#122#0#0: DatatypeType, a#122#1#0: Seq, a#122#2#0: Seq, a#122#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#122#0#0, a#122#1#0, a#122#2#0, a#122#3#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#122#0#0, a#122#1#0, a#122#2#0, a#122#3#0)) == ##AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput);
}

function AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) ==> (exists a#123#0#0: DatatypeType, a#123#1#0: Seq, a#123#2#0: Seq, a#123#3#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#123#0#0, a#123#1#0, a#123#2#0, a#123#3#0)));

axiom (forall a#124#0#0: DatatypeType, a#124#1#0: Seq, a#124#2#0: Seq, a#124#3#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#124#0#0, a#124#1#0, a#124#2#0, a#124#3#0), Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) } $Is(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#124#0#0, a#124#1#0, a#124#2#0, a#124#3#0), Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) <==> $Is(a#124#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) && $Is(a#124#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#124#2#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#124#3#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.verificationKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.verificationKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signature(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signature(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#125#0#0: DatatypeType, a#125#1#0: Seq, a#125#2#0: Seq, a#125#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(Lit(a#125#0#0), Lit(a#125#1#0), Lit(a#125#2#0), Lit(a#125#3#0)) } #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(Lit(a#125#0#0), Lit(a#125#1#0), Lit(a#125#2#0), Lit(a#125#3#0)) == Lit(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#125#0#0, a#125#1#0, a#125#2#0, a#125#3#0)));

function AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signatureAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#126#0#0: DatatypeType, a#126#1#0: Seq, a#126#2#0: Seq, a#126#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#126#0#0, a#126#1#0, a#126#2#0, a#126#3#0) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signatureAlgorithm(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#126#0#0, a#126#1#0, a#126#2#0, a#126#3#0)) == a#126#0#0);

axiom (forall a#127#0#0: DatatypeType, a#127#1#0: Seq, a#127#2#0: Seq, a#127#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#127#0#0, a#127#1#0, a#127#2#0, a#127#3#0) } DtRank(a#127#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#127#0#0, a#127#1#0, a#127#2#0, a#127#3#0)));

function AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.verificationKey(DatatypeType) : Seq;

axiom (forall a#128#0#0: DatatypeType, a#128#1#0: Seq, a#128#2#0: Seq, a#128#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#128#0#0, a#128#1#0, a#128#2#0, a#128#3#0) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.verificationKey(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#128#0#0, a#128#1#0, a#128#2#0, a#128#3#0)) == a#128#1#0);

axiom (forall a#129#0#0: DatatypeType, a#129#1#0: Seq, a#129#2#0: Seq, a#129#3#0: Seq, i: int :: { Seq#Index(a#129#1#0, i), #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#129#0#0, a#129#1#0, a#129#2#0, a#129#3#0) } 0 <= i && i < Seq#Length(a#129#1#0) ==> DtRank($Unbox(Seq#Index(a#129#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#129#0#0, a#129#1#0, a#129#2#0, a#129#3#0)));

axiom (forall a#130#0#0: DatatypeType, a#130#1#0: Seq, a#130#2#0: Seq, a#130#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#130#0#0, a#130#1#0, a#130#2#0, a#130#3#0) } Seq#Rank(a#130#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#130#0#0, a#130#1#0, a#130#2#0, a#130#3#0)));

function AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.message(DatatypeType) : Seq;

axiom (forall a#131#0#0: DatatypeType, a#131#1#0: Seq, a#131#2#0: Seq, a#131#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#131#0#0, a#131#1#0, a#131#2#0, a#131#3#0) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.message(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#131#0#0, a#131#1#0, a#131#2#0, a#131#3#0)) == a#131#2#0);

axiom (forall a#132#0#0: DatatypeType, a#132#1#0: Seq, a#132#2#0: Seq, a#132#3#0: Seq, i: int :: { Seq#Index(a#132#2#0, i), #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#132#0#0, a#132#1#0, a#132#2#0, a#132#3#0) } 0 <= i && i < Seq#Length(a#132#2#0) ==> DtRank($Unbox(Seq#Index(a#132#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#132#0#0, a#132#1#0, a#132#2#0, a#132#3#0)));

axiom (forall a#133#0#0: DatatypeType, a#133#1#0: Seq, a#133#2#0: Seq, a#133#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#133#0#0, a#133#1#0, a#133#2#0, a#133#3#0) } Seq#Rank(a#133#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#133#0#0, a#133#1#0, a#133#2#0, a#133#3#0)));

function AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signature(DatatypeType) : Seq;

axiom (forall a#134#0#0: DatatypeType, a#134#1#0: Seq, a#134#2#0: Seq, a#134#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#134#0#0, a#134#1#0, a#134#2#0, a#134#3#0) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signature(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#134#0#0, a#134#1#0, a#134#2#0, a#134#3#0)) == a#134#3#0);

axiom (forall a#135#0#0: DatatypeType, a#135#1#0: Seq, a#135#2#0: Seq, a#135#3#0: Seq, i: int :: { Seq#Index(a#135#3#0, i), #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#135#0#0, a#135#1#0, a#135#2#0, a#135#3#0) } 0 <= i && i < Seq#Length(a#135#3#0) ==> DtRank($Unbox(Seq#Index(a#135#3#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#135#0#0, a#135#1#0, a#135#2#0, a#135#3#0)));

axiom (forall a#136#0#0: DatatypeType, a#136#1#0: Seq, a#136#2#0: Seq, a#136#3#0: Seq :: { #AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#136#0#0, a#136#1#0, a#136#2#0, a#136#3#0) } Seq#Rank(a#136#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput(a#136#0#0, a#136#1#0, a#136#2#0, a#136#3#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(d) ==> AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) ==> AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.ECDSAVerifyInput_q(d));

function AwsCryptographyPrimitivesTypes.ECDSAVerifyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSAVerifyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signatureAlgorithm(a), AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signatureAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.verificationKey(a), AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.verificationKey(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.message(a), AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.message(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signature(a), AwsCryptographyPrimitivesTypes.ECDSAVerifyInput.signature(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ECDSAVerifyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ECDSAVerifyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput: DtCtorId
uses {
axiom (forall a#137#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#137#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#137#0#0)) == ##AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput);
}

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d) ==> (exists a#138#0#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#138#0#0)));

axiom (forall a#139#0#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#139#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#139#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) <==> $Is(a#139#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall a#140#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(Lit(a#140#0#0)) } #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(Lit(a#140#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#140#0#0)));

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#141#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#141#0#0) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.eccCurve(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#141#0#0)) == a#141#0#0);

axiom (forall a#142#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#142#0#0) } DtRank(a#142#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput(a#142#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(d) ==> AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) ==> AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.GenerateECCKeyPairInput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.eccCurve(a), AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput.eccCurve(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(DatatypeType, DatatypeType, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput: DtCtorId
uses {
axiom (forall a#143#0#0: DatatypeType, a#143#1#0: DatatypeType, a#143#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#143#0#0, a#143#1#0, a#143#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#143#0#0, a#143#1#0, a#143#2#0)) == ##AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput);
}

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) ==> (exists a#144#0#0: DatatypeType, a#144#1#0: DatatypeType, a#144#2#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#144#0#0, a#144#1#0, a#144#2#0)));

axiom (forall a#145#0#0: DatatypeType, a#145#1#0: DatatypeType, a#145#2#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#145#0#0, a#145#1#0, a#145#2#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#145#0#0, a#145#1#0, a#145#2#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) <==> $Is(a#145#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) && $Is(a#145#1#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) && $Is(a#145#2#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h));

axiom (forall a#146#0#0: DatatypeType, a#146#1#0: DatatypeType, a#146#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(Lit(a#146#0#0), Lit(a#146#1#0), Lit(a#146#2#0)) } #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(Lit(a#146#0#0), Lit(a#146#1#0), Lit(a#146#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#146#0#0, a#146#1#0, a#146#2#0)));

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#147#0#0: DatatypeType, a#147#1#0: DatatypeType, a#147#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#147#0#0, a#147#1#0, a#147#2#0) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.eccCurve(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#147#0#0, a#147#1#0, a#147#2#0)) == a#147#0#0);

axiom (forall a#148#0#0: DatatypeType, a#148#1#0: DatatypeType, a#148#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#148#0#0, a#148#1#0, a#148#2#0) } DtRank(a#148#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#148#0#0, a#148#1#0, a#148#2#0)));

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.privateKey(DatatypeType) : DatatypeType;

axiom (forall a#149#0#0: DatatypeType, a#149#1#0: DatatypeType, a#149#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#149#0#0, a#149#1#0, a#149#2#0) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.privateKey(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#149#0#0, a#149#1#0, a#149#2#0)) == a#149#1#0);

axiom (forall a#150#0#0: DatatypeType, a#150#1#0: DatatypeType, a#150#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#150#0#0, a#150#1#0, a#150#2#0) } DtRank(a#150#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#150#0#0, a#150#1#0, a#150#2#0)));

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.publicKey(DatatypeType) : DatatypeType;

axiom (forall a#151#0#0: DatatypeType, a#151#1#0: DatatypeType, a#151#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#151#0#0, a#151#1#0, a#151#2#0) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.publicKey(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#151#0#0, a#151#1#0, a#151#2#0)) == a#151#2#0);

axiom (forall a#152#0#0: DatatypeType, a#152#1#0: DatatypeType, a#152#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#152#0#0, a#152#1#0, a#152#2#0) } DtRank(a#152#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput(a#152#0#0, a#152#1#0, a#152#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(d) ==> AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput()) ==> AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.GenerateECCKeyPairOutput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.eccCurve(a), AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.eccCurve(b)) && AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.privateKey(a), AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.privateKey(b)) && AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.publicKey(a), AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput: DtCtorId
uses {
axiom (forall a#153#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#153#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#153#0#0)) == ##AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput);
}

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d) ==> (exists a#154#0#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#154#0#0)));

axiom (forall a#155#0#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#155#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#155#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) <==> $Is(a#155#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h));

axiom (forall a#156#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(Lit(a#156#0#0)) } #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(Lit(a#156#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#156#0#0)));

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.signatureAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#157#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#157#0#0) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.signatureAlgorithm(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#157#0#0)) == a#157#0#0);

axiom (forall a#158#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#158#0#0) } DtRank(a#158#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput(a#158#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(d) ==> AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) ==> AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.GenerateECDSASignatureKeyInput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.signatureAlgorithm(a), AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput.signatureAlgorithm(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(DatatypeType, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput: DtCtorId
uses {
axiom (forall a#159#0#0: DatatypeType, a#159#1#0: Seq, a#159#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#159#0#0, a#159#1#0, a#159#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#159#0#0, a#159#1#0, a#159#2#0)) == ##AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput);
}

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) ==> (exists a#160#0#0: DatatypeType, a#160#1#0: Seq, a#160#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#160#0#0, a#160#1#0, a#160#2#0)));

axiom (forall a#161#0#0: DatatypeType, a#161#1#0: Seq, a#161#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#161#0#0, a#161#1#0, a#161#2#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#161#0#0, a#161#1#0, a#161#2#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) <==> $Is(a#161#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm()) && $Is(a#161#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#161#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signatureAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.verificationKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.verificationKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signingKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signingKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#162#0#0: DatatypeType, a#162#1#0: Seq, a#162#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(Lit(a#162#0#0), Lit(a#162#1#0), Lit(a#162#2#0)) } #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(Lit(a#162#0#0), Lit(a#162#1#0), Lit(a#162#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#162#0#0, a#162#1#0, a#162#2#0)));

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signatureAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#163#0#0: DatatypeType, a#163#1#0: Seq, a#163#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#163#0#0, a#163#1#0, a#163#2#0) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signatureAlgorithm(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#163#0#0, a#163#1#0, a#163#2#0)) == a#163#0#0);

axiom (forall a#164#0#0: DatatypeType, a#164#1#0: Seq, a#164#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#164#0#0, a#164#1#0, a#164#2#0) } DtRank(a#164#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#164#0#0, a#164#1#0, a#164#2#0)));

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.verificationKey(DatatypeType) : Seq;

axiom (forall a#165#0#0: DatatypeType, a#165#1#0: Seq, a#165#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#165#0#0, a#165#1#0, a#165#2#0) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.verificationKey(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#165#0#0, a#165#1#0, a#165#2#0)) == a#165#1#0);

axiom (forall a#166#0#0: DatatypeType, a#166#1#0: Seq, a#166#2#0: Seq, i: int :: { Seq#Index(a#166#1#0, i), #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#166#0#0, a#166#1#0, a#166#2#0) } 0 <= i && i < Seq#Length(a#166#1#0) ==> DtRank($Unbox(Seq#Index(a#166#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#166#0#0, a#166#1#0, a#166#2#0)));

axiom (forall a#167#0#0: DatatypeType, a#167#1#0: Seq, a#167#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#167#0#0, a#167#1#0, a#167#2#0) } Seq#Rank(a#167#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#167#0#0, a#167#1#0, a#167#2#0)));

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signingKey(DatatypeType) : Seq;

axiom (forall a#168#0#0: DatatypeType, a#168#1#0: Seq, a#168#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#168#0#0, a#168#1#0, a#168#2#0) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signingKey(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#168#0#0, a#168#1#0, a#168#2#0)) == a#168#2#0);

axiom (forall a#169#0#0: DatatypeType, a#169#1#0: Seq, a#169#2#0: Seq, i: int :: { Seq#Index(a#169#2#0, i), #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#169#0#0, a#169#1#0, a#169#2#0) } 0 <= i && i < Seq#Length(a#169#2#0) ==> DtRank($Unbox(Seq#Index(a#169#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#169#0#0, a#169#1#0, a#169#2#0)));

axiom (forall a#170#0#0: DatatypeType, a#170#1#0: Seq, a#170#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#170#0#0, a#170#1#0, a#170#2#0) } Seq#Rank(a#170#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput(a#170#0#0, a#170#1#0, a#170#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(d) ==> AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput()) ==> AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.GenerateECDSASignatureKeyOutput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDSASignatureAlgorithm#Equal(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signatureAlgorithm(a), AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signatureAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.verificationKey(a), AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.verificationKey(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signingKey(a), AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput.signingKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput: DtCtorId
uses {
axiom (forall a#171#0#0: int :: { #AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#171#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#171#0#0)) == ##AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput);
}

function AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d) ==> (exists a#172#0#0: int :: d == #AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#172#0#0)));

axiom (forall a#173#0#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#173#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#173#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) <==> $Is(a#173#0#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.length(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.length(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h));

axiom (forall a#174#0#0: int :: { #AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(LitInt(a#174#0#0)) } #AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(LitInt(a#174#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#174#0#0)));

function AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.length(DatatypeType) : int;

axiom (forall a#175#0#0: int :: { #AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#175#0#0) } AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.length(#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput(a#175#0#0)) == a#175#0#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(d) ==> AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) ==> AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.GenerateRandomBytesInput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.length(a) == AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput.length(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput: DtCtorId
uses {
axiom (forall a#176#0#0: int :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#176#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#176#0#0)) == ##AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput);
}

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d) ==> (exists a#177#0#0: int :: d == #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#177#0#0)));

function Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()) == Tagclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()) == tytagFamily$RSAModulusLengthBitsToGenerate;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()));

axiom (forall a#178#0#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#178#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#178#0#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) <==> $Is(a#178#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.lengthBits(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.lengthBits(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate(), $h));

axiom (forall a#179#0#0: int :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(LitInt(a#179#0#0)) } #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(LitInt(a#179#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#179#0#0)));

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.lengthBits(DatatypeType) : int;

axiom (forall a#180#0#0: int :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#180#0#0) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.lengthBits(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput(a#180#0#0)) == a#180#0#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(d) ==> AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) ==> AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.GenerateRSAKeyPairInput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.lengthBits(a) == AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput.lengthBits(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(DatatypeType, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput: DtCtorId
uses {
axiom (forall a#181#0#0: DatatypeType, a#181#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#181#0#0, a#181#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#181#0#0, a#181#1#0)) == ##AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput);
}

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d) ==> (exists a#182#0#0: DatatypeType, a#182#1#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#182#0#0, a#182#1#0)));

function Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) == Tagclass.AwsCryptographyPrimitivesTypes.RSAPublicKey && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) == tytagFamily$RSAPublicKey;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSAPublicKey: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()));

function Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) == Tagclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) == tytagFamily$RSAPrivateKey;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()));

axiom (forall a#183#0#0: DatatypeType, a#183#1#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#183#0#0, a#183#1#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) } $Is(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#183#0#0, a#183#1#0), Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) <==> $Is(a#183#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) && $Is(a#183#1#0, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey(), $h));

axiom (forall a#184#0#0: DatatypeType, a#184#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(Lit(a#184#0#0), Lit(a#184#1#0)) } #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(Lit(a#184#0#0), Lit(a#184#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#184#0#0, a#184#1#0)));

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.publicKey(DatatypeType) : DatatypeType;

axiom (forall a#185#0#0: DatatypeType, a#185#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#185#0#0, a#185#1#0) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.publicKey(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#185#0#0, a#185#1#0)) == a#185#0#0);

axiom (forall a#186#0#0: DatatypeType, a#186#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#186#0#0, a#186#1#0) } DtRank(a#186#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#186#0#0, a#186#1#0)));

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.privateKey(DatatypeType) : DatatypeType;

axiom (forall a#187#0#0: DatatypeType, a#187#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#187#0#0, a#187#1#0) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.privateKey(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#187#0#0, a#187#1#0)) == a#187#1#0);

axiom (forall a#188#0#0: DatatypeType, a#188#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#188#0#0, a#188#1#0) } DtRank(a#188#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput(a#188#0#0, a#188#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(d) ==> AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput()) ==> AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.GenerateRSAKeyPairOutput_q(d));

function AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.RSAPublicKey#Equal(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.publicKey(a), AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.publicKey(b)) && AwsCryptographyPrimitivesTypes.RSAPrivateKey#Equal(AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.privateKey(a), AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput.privateKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(DatatypeType, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput: DtCtorId
uses {
axiom (forall a#189#0#0: DatatypeType, a#189#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#189#0#0, a#189#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#189#0#0, a#189#1#0)) == ##AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput);
}

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d) ==> (exists a#190#0#0: DatatypeType, a#190#1#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#190#0#0, a#190#1#0)));

axiom (forall a#191#0#0: DatatypeType, a#191#1#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#191#0#0, a#191#1#0), Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#191#0#0, a#191#1#0), Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) <==> $Is(a#191#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) && $Is(a#191#1#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h));

axiom (forall a#192#0#0: DatatypeType, a#192#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(Lit(a#192#0#0), Lit(a#192#1#0)) } #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(Lit(a#192#0#0), Lit(a#192#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#192#0#0, a#192#1#0)));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#193#0#0: DatatypeType, a#193#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#193#0#0, a#193#1#0) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.eccCurve(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#193#0#0, a#193#1#0)) == a#193#0#0);

axiom (forall a#194#0#0: DatatypeType, a#194#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#194#0#0, a#194#1#0) } DtRank(a#194#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#194#0#0, a#194#1#0)));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.privateKey(DatatypeType) : DatatypeType;

axiom (forall a#195#0#0: DatatypeType, a#195#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#195#0#0, a#195#1#0) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.privateKey(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#195#0#0, a#195#1#0)) == a#195#1#0);

axiom (forall a#196#0#0: DatatypeType, a#196#1#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#196#0#0, a#196#1#0) } DtRank(a#196#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput(a#196#0#0, a#196#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(d) ==> AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) ==> AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.GetPublicKeyFromPrivateKeyInput_q(d));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.eccCurve(a), AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.eccCurve(b)) && AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.privateKey(a), AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput.privateKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(DatatypeType, DatatypeType, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput: DtCtorId
uses {
axiom (forall a#197#0#0: DatatypeType, a#197#1#0: DatatypeType, a#197#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#197#0#0, a#197#1#0, a#197#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#197#0#0, a#197#1#0, a#197#2#0)) == ##AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput);
}

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) ==> (exists a#198#0#0: DatatypeType, a#198#1#0: DatatypeType, a#198#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#198#0#0, a#198#1#0, a#198#2#0)));

axiom (forall a#199#0#0: DatatypeType, a#199#1#0: DatatypeType, a#199#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#199#0#0, a#199#1#0, a#199#2#0), Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#199#0#0, a#199#1#0, a#199#2#0), Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) <==> $Is(a#199#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) && $Is(a#199#1#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey()) && $Is(a#199#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.privateKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPrivateKey(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#200#0#0: DatatypeType, a#200#1#0: DatatypeType, a#200#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(Lit(a#200#0#0), Lit(a#200#1#0), Lit(a#200#2#0)) } #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(Lit(a#200#0#0), Lit(a#200#1#0), Lit(a#200#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#200#0#0, a#200#1#0, a#200#2#0)));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#201#0#0: DatatypeType, a#201#1#0: DatatypeType, a#201#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#201#0#0, a#201#1#0, a#201#2#0) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.eccCurve(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#201#0#0, a#201#1#0, a#201#2#0)) == a#201#0#0);

axiom (forall a#202#0#0: DatatypeType, a#202#1#0: DatatypeType, a#202#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#202#0#0, a#202#1#0, a#202#2#0) } DtRank(a#202#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#202#0#0, a#202#1#0, a#202#2#0)));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.privateKey(DatatypeType) : DatatypeType;

axiom (forall a#203#0#0: DatatypeType, a#203#1#0: DatatypeType, a#203#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#203#0#0, a#203#1#0, a#203#2#0) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.privateKey(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#203#0#0, a#203#1#0, a#203#2#0)) == a#203#1#0);

axiom (forall a#204#0#0: DatatypeType, a#204#1#0: DatatypeType, a#204#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#204#0#0, a#204#1#0, a#204#2#0) } DtRank(a#204#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#204#0#0, a#204#1#0, a#204#2#0)));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.publicKey(DatatypeType) : Seq;

axiom (forall a#205#0#0: DatatypeType, a#205#1#0: DatatypeType, a#205#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#205#0#0, a#205#1#0, a#205#2#0) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.publicKey(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#205#0#0, a#205#1#0, a#205#2#0)) == a#205#2#0);

axiom (forall a#206#0#0: DatatypeType, a#206#1#0: DatatypeType, a#206#2#0: Seq, i: int :: { Seq#Index(a#206#2#0, i), #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#206#0#0, a#206#1#0, a#206#2#0) } 0 <= i && i < Seq#Length(a#206#2#0) ==> DtRank($Unbox(Seq#Index(a#206#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#206#0#0, a#206#1#0, a#206#2#0)));

axiom (forall a#207#0#0: DatatypeType, a#207#1#0: DatatypeType, a#207#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#207#0#0, a#207#1#0, a#207#2#0) } Seq#Rank(a#207#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput(a#207#0#0, a#207#1#0, a#207#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(d) ==> AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput()) ==> AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.GetPublicKeyFromPrivateKeyOutput_q(d));

function AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.eccCurve(a), AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.eccCurve(b)) && AwsCryptographyPrimitivesTypes.ECCPrivateKey#Equal(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.privateKey(a), AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.privateKey(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.publicKey(a), AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput: DtCtorId
uses {
axiom (forall a#208#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#208#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#208#0#0)) == ##AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput);
}

function AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d) ==> (exists a#209#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#209#0#0)));

axiom (forall a#210#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#210#0#0), Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) } $Is(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#210#0#0), Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) <==> $Is(a#210#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#211#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(Lit(a#211#0#0)) } #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(Lit(a#211#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#211#0#0)));

function AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.publicKey(DatatypeType) : Seq;

axiom (forall a#212#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#212#0#0) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.publicKey(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#212#0#0)) == a#212#0#0);

axiom (forall a#213#0#0: Seq, i: int :: { Seq#Index(a#213#0#0, i), #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#213#0#0) } 0 <= i && i < Seq#Length(a#213#0#0) ==> DtRank($Unbox(Seq#Index(a#213#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#213#0#0)));

axiom (forall a#214#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#214#0#0) } Seq#Rank(a#214#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput(a#214#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(d) } $IsA#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(d) ==> AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.GetRSAKeyModulusLengthInput_q(d));

function AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.publicKey(a), AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput: ClassName;

function #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput: DtCtorId
uses {
axiom (forall a#215#0#0: int :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#215#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#215#0#0)) == ##AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput);
}

function AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d) ==> (exists a#216#0#0: int :: d == #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#216#0#0)));

function Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) == Tagclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) == tytagFamily$RSAModulusLengthBits;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()));

axiom (forall a#217#0#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#217#0#0), Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) } $Is(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#217#0#0), Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) <==> $Is(a#217#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.length(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.length(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h));

axiom (forall a#218#0#0: int :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(LitInt(a#218#0#0)) } #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(LitInt(a#218#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#218#0#0)));

function AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.length(DatatypeType) : int;

axiom (forall a#219#0#0: int :: { #AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#219#0#0) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.length(#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput(a#219#0#0)) == a#219#0#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(d) ==> AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput()) ==> AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.GetRSAKeyModulusLengthOutput_q(d));

function AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.length(a) == AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput.length(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(DatatypeType, Seq, Seq, int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput: DtCtorId
uses {
axiom (forall a#220#0#0: DatatypeType, a#220#1#0: Seq, a#220#2#0: Seq, a#220#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#220#0#0, a#220#1#0, a#220#2#0, a#220#3#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#220#0#0, a#220#1#0, a#220#2#0, a#220#3#0)) == ##AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput);
}

function AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) ==> (exists a#221#0#0: DatatypeType, a#221#1#0: Seq, a#221#2#0: Seq, a#221#3#0: int :: d == #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#221#0#0, a#221#1#0, a#221#2#0, a#221#3#0)));

axiom (forall a#222#0#0: DatatypeType, a#222#1#0: Seq, a#222#2#0: Seq, a#222#3#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#222#0#0, a#222#1#0, a#222#2#0, a#222#3#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) } $Is(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#222#0#0, a#222#1#0, a#222#2#0, a#222#3#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) <==> $Is(a#222#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#222#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#222#2#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#222#3#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.prk(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.prk(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.info(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.info(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExpandInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h));

axiom (forall a#223#0#0: DatatypeType, a#223#1#0: Seq, a#223#2#0: Seq, a#223#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(Lit(a#223#0#0), Lit(a#223#1#0), Lit(a#223#2#0), LitInt(a#223#3#0)) } #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(Lit(a#223#0#0), Lit(a#223#1#0), Lit(a#223#2#0), LitInt(a#223#3#0)) == Lit(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#223#0#0, a#223#1#0, a#223#2#0, a#223#3#0)));

function AwsCryptographyPrimitivesTypes.HkdfExpandInput.digestAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#224#0#0: DatatypeType, a#224#1#0: Seq, a#224#2#0: Seq, a#224#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#224#0#0, a#224#1#0, a#224#2#0, a#224#3#0) } AwsCryptographyPrimitivesTypes.HkdfExpandInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#224#0#0, a#224#1#0, a#224#2#0, a#224#3#0)) == a#224#0#0);

axiom (forall a#225#0#0: DatatypeType, a#225#1#0: Seq, a#225#2#0: Seq, a#225#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#225#0#0, a#225#1#0, a#225#2#0, a#225#3#0) } DtRank(a#225#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#225#0#0, a#225#1#0, a#225#2#0, a#225#3#0)));

function AwsCryptographyPrimitivesTypes.HkdfExpandInput.prk(DatatypeType) : Seq;

axiom (forall a#226#0#0: DatatypeType, a#226#1#0: Seq, a#226#2#0: Seq, a#226#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#226#0#0, a#226#1#0, a#226#2#0, a#226#3#0) } AwsCryptographyPrimitivesTypes.HkdfExpandInput.prk(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#226#0#0, a#226#1#0, a#226#2#0, a#226#3#0)) == a#226#1#0);

axiom (forall a#227#0#0: DatatypeType, a#227#1#0: Seq, a#227#2#0: Seq, a#227#3#0: int, i: int :: { Seq#Index(a#227#1#0, i), #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#227#0#0, a#227#1#0, a#227#2#0, a#227#3#0) } 0 <= i && i < Seq#Length(a#227#1#0) ==> DtRank($Unbox(Seq#Index(a#227#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#227#0#0, a#227#1#0, a#227#2#0, a#227#3#0)));

axiom (forall a#228#0#0: DatatypeType, a#228#1#0: Seq, a#228#2#0: Seq, a#228#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#228#0#0, a#228#1#0, a#228#2#0, a#228#3#0) } Seq#Rank(a#228#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#228#0#0, a#228#1#0, a#228#2#0, a#228#3#0)));

function AwsCryptographyPrimitivesTypes.HkdfExpandInput.info(DatatypeType) : Seq;

axiom (forall a#229#0#0: DatatypeType, a#229#1#0: Seq, a#229#2#0: Seq, a#229#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#229#0#0, a#229#1#0, a#229#2#0, a#229#3#0) } AwsCryptographyPrimitivesTypes.HkdfExpandInput.info(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#229#0#0, a#229#1#0, a#229#2#0, a#229#3#0)) == a#229#2#0);

axiom (forall a#230#0#0: DatatypeType, a#230#1#0: Seq, a#230#2#0: Seq, a#230#3#0: int, i: int :: { Seq#Index(a#230#2#0, i), #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#230#0#0, a#230#1#0, a#230#2#0, a#230#3#0) } 0 <= i && i < Seq#Length(a#230#2#0) ==> DtRank($Unbox(Seq#Index(a#230#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#230#0#0, a#230#1#0, a#230#2#0, a#230#3#0)));

axiom (forall a#231#0#0: DatatypeType, a#231#1#0: Seq, a#231#2#0: Seq, a#231#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#231#0#0, a#231#1#0, a#231#2#0, a#231#3#0) } Seq#Rank(a#231#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#231#0#0, a#231#1#0, a#231#2#0, a#231#3#0)));

function AwsCryptographyPrimitivesTypes.HkdfExpandInput.expectedLength(DatatypeType) : int;

axiom (forall a#232#0#0: DatatypeType, a#232#1#0: Seq, a#232#2#0: Seq, a#232#3#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#232#0#0, a#232#1#0, a#232#2#0, a#232#3#0) } AwsCryptographyPrimitivesTypes.HkdfExpandInput.expectedLength(#AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput(a#232#0#0, a#232#1#0, a#232#2#0, a#232#3#0)) == a#232#3#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(d) } $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(d) ==> AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) ==> AwsCryptographyPrimitivesTypes.HkdfExpandInput.HkdfExpandInput_q(d));

function AwsCryptographyPrimitivesTypes.HkdfExpandInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExpandInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HkdfExpandInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.HkdfExpandInput.digestAlgorithm(a), AwsCryptographyPrimitivesTypes.HkdfExpandInput.digestAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HkdfExpandInput.prk(a), AwsCryptographyPrimitivesTypes.HkdfExpandInput.prk(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HkdfExpandInput.info(a), AwsCryptographyPrimitivesTypes.HkdfExpandInput.info(b)) && AwsCryptographyPrimitivesTypes.HkdfExpandInput.expectedLength(a) == AwsCryptographyPrimitivesTypes.HkdfExpandInput.expectedLength(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExpandInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HkdfExpandInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.HkdfExpandInput: ClassName;

function #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(DatatypeType, DatatypeType, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput: DtCtorId
uses {
axiom (forall a#233#0#0: DatatypeType, a#233#1#0: DatatypeType, a#233#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#233#0#0, a#233#1#0, a#233#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#233#0#0, a#233#1#0, a#233#2#0)) == ##AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput);
}

function AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput);

procedure {:verboseName "#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput (well-formedness)"} CheckWellformed$$#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()), salt#0: DatatypeType where $Is(salt#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))), ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) ==> (exists a#0#0#0: DatatypeType, a#0#1#0: DatatypeType, a#0#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#0#0#0, a#0#1#0, a#0#2#0)));

axiom (forall a#1#0#0: DatatypeType, a#1#1#0: DatatypeType, a#1#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#1#0#0, a#1#1#0, a#1#2#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) } $Is(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#1#0#0, a#1#1#0, a#1#2#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) <==> $Is(a#1#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#1#1#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))) && $Is(a#1#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType, a#2#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0)) } #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#2#0#0, a#2#1#0, a#2#2#0)));

function AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType, a#3#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#3#0#0, a#3#1#0, a#3#2#0) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#3#0#0, a#3#1#0, a#3#2#0)) == a#3#0#0);

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType, a#4#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#4#0#0, a#4#1#0, a#4#2#0) } DtRank(a#4#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#4#0#0, a#4#1#0, a#4#2#0)));

function AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(DatatypeType) : DatatypeType;

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType, a#5#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#5#0#0, a#5#1#0, a#5#2#0) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#5#0#0, a#5#1#0, a#5#2#0)) == a#5#1#0);

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType, a#6#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#6#0#0, a#6#1#0, a#6#2#0) } DtRank(a#6#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#6#0#0, a#6#1#0, a#6#2#0)));

function AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(DatatypeType) : Seq;

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType, a#7#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#7#0#0, a#7#1#0, a#7#2#0) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#7#0#0, a#7#1#0, a#7#2#0)) == a#7#2#0);

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType, a#8#2#0: Seq, i: int :: { Seq#Index(a#8#2#0, i), #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#8#0#0, a#8#1#0, a#8#2#0) } 0 <= i && i < Seq#Length(a#8#2#0) ==> DtRank($Unbox(Seq#Index(a#8#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#8#0#0, a#8#1#0, a#8#2#0)));

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: DatatypeType, a#9#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#9#0#0, a#9#1#0, a#9#2#0) } Seq#Rank(a#9#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#9#0#0, a#9#1#0, a#9#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(d) } $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(d) ==> AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) ==> AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d));

function AwsCryptographyPrimitivesTypes.HkdfExtractInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExtractInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HkdfExtractInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(a), AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(b)) && Wrappers.Option#Equal(AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(a), AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(a), AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExtractInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HkdfExtractInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.HkdfExtractInput: ClassName;

function #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(DatatypeType, DatatypeType, Seq, Seq, int) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput: DtCtorId
uses {
axiom (forall a#10#0#0: DatatypeType, a#10#1#0: DatatypeType, a#10#2#0: Seq, a#10#3#0: Seq, a#10#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0)) == ##AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput);
}

function AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput);

procedure {:verboseName "#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput (well-formedness)"} CheckWellformed$$#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()), salt#0: DatatypeType where $Is(salt#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))), ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())), info#0: Seq where $Is(info#0, TSeq(Tclass.BoundedInts.uint8())), expectedLength#0: int where LitInt(-2147483648) <= expectedLength#0 && expectedLength#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(expectedLength#0));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) ==> (exists a#0#0#0: DatatypeType, a#0#1#0: DatatypeType, a#0#2#0: Seq, a#0#3#0: Seq, a#0#4#0: int :: d == #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0)));

axiom (forall a#1#0#0: DatatypeType, a#1#1#0: DatatypeType, a#1#2#0: Seq, a#1#3#0: Seq, a#1#4#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) } $Is(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) <==> $Is(a#1#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#1#1#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))) && $Is(a#1#2#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#1#3#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#1#4#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.salt(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.salt(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.info(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.info(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType, a#2#2#0: Seq, a#2#3#0: Seq, a#2#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0), Lit(a#2#3#0), LitInt(a#2#4#0)) } #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0), Lit(a#2#3#0), LitInt(a#2#4#0)) == Lit(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0)));

function AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType, a#3#2#0: Seq, a#3#3#0: Seq, a#3#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0)) == a#3#0#0);

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType, a#4#2#0: Seq, a#4#3#0: Seq, a#4#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0) } DtRank(a#4#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0)));

function AwsCryptographyPrimitivesTypes.HkdfInput.salt(DatatypeType) : DatatypeType;

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType, a#5#2#0: Seq, a#5#3#0: Seq, a#5#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.salt(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0)) == a#5#1#0);

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType, a#6#2#0: Seq, a#6#3#0: Seq, a#6#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0) } DtRank(a#6#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0)));

function AwsCryptographyPrimitivesTypes.HkdfInput.ikm(DatatypeType) : Seq;

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType, a#7#2#0: Seq, a#7#3#0: Seq, a#7#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.ikm(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0)) == a#7#2#0);

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType, a#8#2#0: Seq, a#8#3#0: Seq, a#8#4#0: int, i: int :: { Seq#Index(a#8#2#0, i), #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0) } 0 <= i && i < Seq#Length(a#8#2#0) ==> DtRank($Unbox(Seq#Index(a#8#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0)));

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: DatatypeType, a#9#2#0: Seq, a#9#3#0: Seq, a#9#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0) } Seq#Rank(a#9#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0)));

function AwsCryptographyPrimitivesTypes.HkdfInput.info(DatatypeType) : Seq;

axiom (forall a#10#0#0: DatatypeType, a#10#1#0: DatatypeType, a#10#2#0: Seq, a#10#3#0: Seq, a#10#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.info(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0)) == a#10#3#0);

axiom (forall a#11#0#0: DatatypeType, a#11#1#0: DatatypeType, a#11#2#0: Seq, a#11#3#0: Seq, a#11#4#0: int, i: int :: { Seq#Index(a#11#3#0, i), #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0) } 0 <= i && i < Seq#Length(a#11#3#0) ==> DtRank($Unbox(Seq#Index(a#11#3#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0)));

axiom (forall a#12#0#0: DatatypeType, a#12#1#0: DatatypeType, a#12#2#0: Seq, a#12#3#0: Seq, a#12#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0) } Seq#Rank(a#12#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0)));

function AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(DatatypeType) : int;

axiom (forall a#13#0#0: DatatypeType, a#13#1#0: DatatypeType, a#13#2#0: Seq, a#13#3#0: Seq, a#13#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0)) == a#13#4#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(d) } $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(d) ==> AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) ==> AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d));

function AwsCryptographyPrimitivesTypes.HkdfInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HkdfInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(a), AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(b)) && Wrappers.Option#Equal(AwsCryptographyPrimitivesTypes.HkdfInput.salt(a), AwsCryptographyPrimitivesTypes.HkdfInput.salt(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HkdfInput.ikm(a), AwsCryptographyPrimitivesTypes.HkdfInput.ikm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HkdfInput.info(a), AwsCryptographyPrimitivesTypes.HkdfInput.info(b)) && AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(a) == AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HkdfInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.HkdfInput: ClassName;

function #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(DatatypeType, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.HMacInput.HMacInput: DtCtorId
uses {
axiom (forall a#14#0#0: DatatypeType, a#14#1#0: Seq, a#14#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#14#0#0, a#14#1#0, a#14#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#14#0#0, a#14#1#0, a#14#2#0)) == ##AwsCryptographyPrimitivesTypes.HMacInput.HMacInput);
}

function AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) } AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.HMacInput.HMacInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) } AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) ==> (exists a#15#0#0: DatatypeType, a#15#1#0: Seq, a#15#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#15#0#0, a#15#1#0, a#15#2#0)));

axiom (forall a#16#0#0: DatatypeType, a#16#1#0: Seq, a#16#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#16#0#0, a#16#1#0, a#16#2#0), Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) } $Is(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#16#0#0, a#16#1#0, a#16#2#0), Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) <==> $Is(a#16#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#16#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#16#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HMacInput.key(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HMacInput.key(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.HMacInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.HMacInput.message(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#17#0#0: DatatypeType, a#17#1#0: Seq, a#17#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(Lit(a#17#0#0), Lit(a#17#1#0), Lit(a#17#2#0)) } #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(Lit(a#17#0#0), Lit(a#17#1#0), Lit(a#17#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#17#0#0, a#17#1#0, a#17#2#0)));

function AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#18#0#0: DatatypeType, a#18#1#0: Seq, a#18#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#18#0#0, a#18#1#0, a#18#2#0) } AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#18#0#0, a#18#1#0, a#18#2#0)) == a#18#0#0);

axiom (forall a#19#0#0: DatatypeType, a#19#1#0: Seq, a#19#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#19#0#0, a#19#1#0, a#19#2#0) } DtRank(a#19#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#19#0#0, a#19#1#0, a#19#2#0)));

function AwsCryptographyPrimitivesTypes.HMacInput.key(DatatypeType) : Seq;

axiom (forall a#20#0#0: DatatypeType, a#20#1#0: Seq, a#20#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#20#0#0, a#20#1#0, a#20#2#0) } AwsCryptographyPrimitivesTypes.HMacInput.key(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#20#0#0, a#20#1#0, a#20#2#0)) == a#20#1#0);

axiom (forall a#21#0#0: DatatypeType, a#21#1#0: Seq, a#21#2#0: Seq, i: int :: { Seq#Index(a#21#1#0, i), #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#21#0#0, a#21#1#0, a#21#2#0) } 0 <= i && i < Seq#Length(a#21#1#0) ==> DtRank($Unbox(Seq#Index(a#21#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#21#0#0, a#21#1#0, a#21#2#0)));

axiom (forall a#22#0#0: DatatypeType, a#22#1#0: Seq, a#22#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#22#0#0, a#22#1#0, a#22#2#0) } Seq#Rank(a#22#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#22#0#0, a#22#1#0, a#22#2#0)));

function AwsCryptographyPrimitivesTypes.HMacInput.message(DatatypeType) : Seq;

axiom (forall a#23#0#0: DatatypeType, a#23#1#0: Seq, a#23#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#23#0#0, a#23#1#0, a#23#2#0) } AwsCryptographyPrimitivesTypes.HMacInput.message(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#23#0#0, a#23#1#0, a#23#2#0)) == a#23#2#0);

axiom (forall a#24#0#0: DatatypeType, a#24#1#0: Seq, a#24#2#0: Seq, i: int :: { Seq#Index(a#24#2#0, i), #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#24#0#0, a#24#1#0, a#24#2#0) } 0 <= i && i < Seq#Length(a#24#2#0) ==> DtRank($Unbox(Seq#Index(a#24#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#24#0#0, a#24#1#0, a#24#2#0)));

axiom (forall a#25#0#0: DatatypeType, a#25#1#0: Seq, a#25#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#25#0#0, a#25#1#0, a#25#2#0) } Seq#Rank(a#25#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#25#0#0, a#25#1#0, a#25#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.HMacInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.HMacInput(d) } $IsA#AwsCryptographyPrimitivesTypes.HMacInput(d) ==> AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d));

function AwsCryptographyPrimitivesTypes.HMacInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HMacInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HMacInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(a), AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HMacInput.key(a), AwsCryptographyPrimitivesTypes.HMacInput.key(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.HMacInput.message(a), AwsCryptographyPrimitivesTypes.HMacInput.message(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.HMacInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.HMacInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.HMacInput: ClassName;

function #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(DatatypeType, Seq, int, DatatypeType, DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput: DtCtorId
uses {
axiom (forall a#26#0#0: DatatypeType, a#26#1#0: Seq, a#26#2#0: int, a#26#3#0: DatatypeType, a#26#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0)) == ##AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput);
}

function AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) } AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput);

procedure {:verboseName "#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput (well-formedness)"} CheckWellformed$$#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()), ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())), expectedLength#0: int where LitInt(-2147483648) <= expectedLength#0 && expectedLength#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(expectedLength#0), purpose#0: DatatypeType where $Is(purpose#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))), nonce#0: DatatypeType where $Is(nonce#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) } AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) ==> (exists a#0#0#0: DatatypeType, a#0#1#0: Seq, a#0#2#0: int, a#0#3#0: DatatypeType, a#0#4#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0)));

axiom (forall a#1#0#0: DatatypeType, a#1#1#0: Seq, a#1#2#0: int, a#1#3#0: DatatypeType, a#1#4#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0), Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) } $Is(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0), Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) <==> $Is(a#1#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#1#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#1#2#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) && $Is(a#1#3#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))) && $Is(a#1#4#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(d), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(d), Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(d), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq, a#2#2#0: int, a#2#3#0: DatatypeType, a#2#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(Lit(a#2#0#0), Lit(a#2#1#0), LitInt(a#2#2#0), Lit(a#2#3#0), Lit(a#2#4#0)) } #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(Lit(a#2#0#0), Lit(a#2#1#0), LitInt(a#2#2#0), Lit(a#2#3#0), Lit(a#2#4#0)) == Lit(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0)));

function AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(DatatypeType) : DatatypeType;

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq, a#3#2#0: int, a#3#3#0: DatatypeType, a#3#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0)) == a#3#0#0);

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq, a#4#2#0: int, a#4#3#0: DatatypeType, a#4#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0) } DtRank(a#4#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0)));

function AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(DatatypeType) : Seq;

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq, a#5#2#0: int, a#5#3#0: DatatypeType, a#5#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0)) == a#5#1#0);

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq, a#6#2#0: int, a#6#3#0: DatatypeType, a#6#4#0: DatatypeType, i: int :: { Seq#Index(a#6#1#0, i), #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0) } 0 <= i && i < Seq#Length(a#6#1#0) ==> DtRank($Unbox(Seq#Index(a#6#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0)));

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq, a#7#2#0: int, a#7#3#0: DatatypeType, a#7#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0) } Seq#Rank(a#7#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0)));

function AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(DatatypeType) : int;

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq, a#8#2#0: int, a#8#3#0: DatatypeType, a#8#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0)) == a#8#2#0);

function AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(DatatypeType) : DatatypeType;

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq, a#9#2#0: int, a#9#3#0: DatatypeType, a#9#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0)) == a#9#3#0);

axiom (forall a#10#0#0: DatatypeType, a#10#1#0: Seq, a#10#2#0: int, a#10#3#0: DatatypeType, a#10#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0) } DtRank(a#10#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0)));

function AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(DatatypeType) : DatatypeType;

axiom (forall a#11#0#0: DatatypeType, a#11#1#0: Seq, a#11#2#0: int, a#11#3#0: DatatypeType, a#11#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0)) == a#11#4#0);

axiom (forall a#12#0#0: DatatypeType, a#12#1#0: Seq, a#12#2#0: int, a#12#3#0: DatatypeType, a#12#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0) } DtRank(a#12#4#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(d) } $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(d) ==> AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) ==> AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d));

function AwsCryptographyPrimitivesTypes.KdfCtrInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.KdfCtrInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.KdfCtrInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(a), AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(a), AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(b)) && AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(a) == AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(b) && Wrappers.Option#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(a), AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(b)) && Wrappers.Option#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(a), AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.KdfCtrInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.KdfCtrInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.KdfCtrInput: ClassName;

function #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput: DtCtorId
uses {
axiom (forall a#13#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#13#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#13#0#0)) == ##AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput);
}

function AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) ==> (exists a#14#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#14#0#0)));

axiom (forall a#15#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#15#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#15#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) <==> $Is(a#15#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#16#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(Lit(a#16#0#0)) } #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(Lit(a#16#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#16#0#0)));

function AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(DatatypeType) : Seq;

axiom (forall a#17#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#17#0#0) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#17#0#0)) == a#17#0#0);

axiom (forall a#18#0#0: Seq, i: int :: { Seq#Index(a#18#0#0, i), #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#18#0#0) } 0 <= i && i < Seq#Length(a#18#0#0) ==> DtRank($Unbox(Seq#Index(a#18#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#18#0#0)));

axiom (forall a#19#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#19#0#0) } Seq#Rank(a#19#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#19#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(d) ==> AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) ==> AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d));

function AwsCryptographyPrimitivesTypes.ParsePublicKeyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(a), AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(DatatypeType) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput: DtCtorId
uses {
axiom (forall a#20#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#20#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#20#0#0)) == ##AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput);
}

function AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) ==> (exists a#21#0#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#21#0#0)));

axiom (forall a#22#0#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#22#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#22#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) <==> $Is(a#22#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(d), Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey(), $h));

axiom (forall a#23#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(Lit(a#23#0#0)) } #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(Lit(a#23#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#23#0#0)));

function AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(DatatypeType) : DatatypeType;

axiom (forall a#24#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#24#0#0) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#24#0#0)) == a#24#0#0);

axiom (forall a#25#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#25#0#0) } DtRank(a#25#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#25#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(d) ==> AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) ==> AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d));

function AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECCPublicKey#Equal(AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(a), AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput: ClassName;

procedure {:verboseName "AwsCryptographyPrimitivesTypes.PositiveInteger (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.PositiveInteger(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger(), $h));

function #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(DatatypeType, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq, a#0#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#0#0#0, a#0#1#0, a#0#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#0#0#0, a#0#1#0, a#0#2#0)) == ##AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput);
}

function AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) } AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) } AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq, a#1#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) == Tagclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) == tytagFamily$RSAPaddingMode;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq, a#2#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) } $Is(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) <==> $Is(a#2#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) && $Is(a#2#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#2#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq, a#3#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) } #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#3#0#0, a#3#1#0, a#3#2#0)));

function AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq, a#4#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#4#0#0, a#4#1#0, a#4#2#0) } AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#4#0#0, a#4#1#0, a#4#2#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq, a#5#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#5#0#0, a#5#1#0, a#5#2#0) } DtRank(a#5#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#5#0#0, a#5#1#0, a#5#2#0)));

function AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(DatatypeType) : Seq;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq, a#6#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#6#0#0, a#6#1#0, a#6#2#0) } AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#6#0#0, a#6#1#0, a#6#2#0)) == a#6#1#0);

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq, a#7#2#0: Seq, i: int :: { Seq#Index(a#7#1#0, i), #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#7#0#0, a#7#1#0, a#7#2#0) } 0 <= i && i < Seq#Length(a#7#1#0) ==> DtRank($Unbox(Seq#Index(a#7#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#7#0#0, a#7#1#0, a#7#2#0)));

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq, a#8#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#8#0#0, a#8#1#0, a#8#2#0) } Seq#Rank(a#8#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#8#0#0, a#8#1#0, a#8#2#0)));

function AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(DatatypeType) : Seq;

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq, a#9#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#9#0#0, a#9#1#0, a#9#2#0) } AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#9#0#0, a#9#1#0, a#9#2#0)) == a#9#2#0);

axiom (forall a#10#0#0: DatatypeType, a#10#1#0: Seq, a#10#2#0: Seq, i: int :: { Seq#Index(a#10#2#0, i), #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#10#0#0, a#10#1#0, a#10#2#0) } 0 <= i && i < Seq#Length(a#10#2#0) ==> DtRank($Unbox(Seq#Index(a#10#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#10#0#0, a#10#1#0, a#10#2#0)));

axiom (forall a#11#0#0: DatatypeType, a#11#1#0: Seq, a#11#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#11#0#0, a#11#1#0, a#11#2#0) } Seq#Rank(a#11#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#11#0#0, a#11#1#0, a#11#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(d) } $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(d) ==> AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) ==> AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d));

function AwsCryptographyPrimitivesTypes.RSADecryptInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSADecryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSADecryptInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(a), AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(a), AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(a), AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSADecryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSADecryptInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.RSADecryptInput: ClassName;

function #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(DatatypeType, Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput: DtCtorId
uses {
axiom (forall a#12#0#0: DatatypeType, a#12#1#0: Seq, a#12#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#12#0#0, a#12#1#0, a#12#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#12#0#0, a#12#1#0, a#12#2#0)) == ##AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput);
}

function AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) ==> (exists a#13#0#0: DatatypeType, a#13#1#0: Seq, a#13#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#13#0#0, a#13#1#0, a#13#2#0)));

axiom (forall a#14#0#0: DatatypeType, a#14#1#0: Seq, a#14#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#14#0#0, a#14#1#0, a#14#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) } $Is(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#14#0#0, a#14#1#0, a#14#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) <==> $Is(a#14#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) && $Is(a#14#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#14#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(d), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#15#0#0: DatatypeType, a#15#1#0: Seq, a#15#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(Lit(a#15#0#0), Lit(a#15#1#0), Lit(a#15#2#0)) } #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(Lit(a#15#0#0), Lit(a#15#1#0), Lit(a#15#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#15#0#0, a#15#1#0, a#15#2#0)));

function AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(DatatypeType) : DatatypeType;

axiom (forall a#16#0#0: DatatypeType, a#16#1#0: Seq, a#16#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#16#0#0, a#16#1#0, a#16#2#0) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#16#0#0, a#16#1#0, a#16#2#0)) == a#16#0#0);

axiom (forall a#17#0#0: DatatypeType, a#17#1#0: Seq, a#17#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#17#0#0, a#17#1#0, a#17#2#0) } DtRank(a#17#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#17#0#0, a#17#1#0, a#17#2#0)));

function AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(DatatypeType) : Seq;

axiom (forall a#18#0#0: DatatypeType, a#18#1#0: Seq, a#18#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#18#0#0, a#18#1#0, a#18#2#0) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#18#0#0, a#18#1#0, a#18#2#0)) == a#18#1#0);

axiom (forall a#19#0#0: DatatypeType, a#19#1#0: Seq, a#19#2#0: Seq, i: int :: { Seq#Index(a#19#1#0, i), #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#19#0#0, a#19#1#0, a#19#2#0) } 0 <= i && i < Seq#Length(a#19#1#0) ==> DtRank($Unbox(Seq#Index(a#19#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#19#0#0, a#19#1#0, a#19#2#0)));

axiom (forall a#20#0#0: DatatypeType, a#20#1#0: Seq, a#20#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#20#0#0, a#20#1#0, a#20#2#0) } Seq#Rank(a#20#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#20#0#0, a#20#1#0, a#20#2#0)));

function AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(DatatypeType) : Seq;

axiom (forall a#21#0#0: DatatypeType, a#21#1#0: Seq, a#21#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#21#0#0, a#21#1#0, a#21#2#0) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#21#0#0, a#21#1#0, a#21#2#0)) == a#21#2#0);

axiom (forall a#22#0#0: DatatypeType, a#22#1#0: Seq, a#22#2#0: Seq, i: int :: { Seq#Index(a#22#2#0, i), #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#22#0#0, a#22#1#0, a#22#2#0) } 0 <= i && i < Seq#Length(a#22#2#0) ==> DtRank($Unbox(Seq#Index(a#22#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#22#0#0, a#22#1#0, a#22#2#0)));

axiom (forall a#23#0#0: DatatypeType, a#23#1#0: Seq, a#23#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#23#0#0, a#23#1#0, a#23#2#0) } Seq#Rank(a#23#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#23#0#0, a#23#1#0, a#23#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(d) } $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(d) ==> AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) ==> AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d));

function AwsCryptographyPrimitivesTypes.RSAEncryptInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAEncryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAEncryptInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(a), AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(a), AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(a), AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAEncryptInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAEncryptInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.RSAEncryptInput: ClassName;

procedure {:verboseName "AwsCryptographyPrimitivesTypes.RSAModulusLengthBits (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBitsToGenerate(), $h));

function #AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1;
axiom $Is(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1(), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode());
axiom #AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1() == Lit(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1());
}

const unique ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1;
}

function AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d) ==> d == #AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1());

function #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1;
axiom $Is(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1(), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode());
axiom #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1() == Lit(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1());
}

const unique ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1;
}

function AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d) ==> d == #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA1());

function #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256;
axiom $Is(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256(), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode());
axiom #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256() == Lit(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256());
}

const unique ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256;
}

function AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d) ==> d == #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA256());

function #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384;
axiom $Is(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384(), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode());
axiom #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384() == Lit(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384());
}

const unique ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384;
}

function AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d) ==> d == #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA384());

function #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512() : DatatypeType
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512;
axiom $Is(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512(), Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode());
axiom #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512() == Lit(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512());
}

const unique ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512: DtCtorId
uses {
axiom DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512()) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512;
}

function AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d) ==> d == #AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP_SHA512());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.RSAPaddingMode(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.RSAPaddingMode(d) } $IsA#AwsCryptographyPrimitivesTypes.RSAPaddingMode(d) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(d) || AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(d));

function AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(a) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(b) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(a) && AwsCryptographyPrimitivesTypes.RSAPaddingMode.PKCS1_q(b) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(a) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(b) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(a) && AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA1_q(b) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(a) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(b) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(a) && AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA256_q(b) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(a) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(b) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(a) && AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA384_q(b) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(a) } { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b), AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(b) } AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(a) && AwsCryptographyPrimitivesTypes.RSAPaddingMode.OAEP__SHA512_q(b) ==> AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAPaddingMode#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.RSAPaddingMode: ClassName;

function #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(int, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey: DtCtorId
uses {
axiom (forall a#20#0#0: int, a#20#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#20#0#0, a#20#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#20#0#0, a#20#1#0)) == ##AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey);
}

function AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) ==> (exists a#21#0#0: int, a#21#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#21#0#0, a#21#1#0)));

axiom (forall a#22#0#0: int, a#22#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#22#0#0, a#22#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) } $Is(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#22#0#0, a#22#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) <==> $Is(a#22#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) && $Is(a#22#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#23#0#0: int, a#23#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(LitInt(a#23#0#0), Lit(a#23#1#0)) } #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(LitInt(a#23#0#0), Lit(a#23#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#23#0#0, a#23#1#0)));

function AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(DatatypeType) : int;

axiom (forall a#24#0#0: int, a#24#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#24#0#0, a#24#1#0) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#24#0#0, a#24#1#0)) == a#24#0#0);

function AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(DatatypeType) : Seq;

axiom (forall a#25#0#0: int, a#25#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#25#0#0, a#25#1#0) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#25#0#0, a#25#1#0)) == a#25#1#0);

axiom (forall a#26#0#0: int, a#26#1#0: Seq, i: int :: { Seq#Index(a#26#1#0, i), #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#26#0#0, a#26#1#0) } 0 <= i && i < Seq#Length(a#26#1#0) ==> DtRank($Unbox(Seq#Index(a#26#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#26#0#0, a#26#1#0)));

axiom (forall a#27#0#0: int, a#27#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#27#0#0, a#27#1#0) } Seq#Rank(a#27#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#27#0#0, a#27#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.RSAPrivateKey(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.RSAPrivateKey(d) } $IsA#AwsCryptographyPrimitivesTypes.RSAPrivateKey(d) ==> AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) ==> AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d));

function AwsCryptographyPrimitivesTypes.RSAPrivateKey#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPrivateKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAPrivateKey#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(a) == AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(b) && Seq#Equal(AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(a), AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPrivateKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAPrivateKey#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.RSAPrivateKey: ClassName;

function #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(int, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey: DtCtorId
uses {
axiom (forall a#28#0#0: int, a#28#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#28#0#0, a#28#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#28#0#0, a#28#1#0)) == ##AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey);
}

function AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) } AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) } AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) ==> (exists a#29#0#0: int, a#29#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#29#0#0, a#29#1#0)));

axiom (forall a#30#0#0: int, a#30#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#30#0#0, a#30#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) } $Is(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#30#0#0, a#30#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) <==> $Is(a#30#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) && $Is(a#30#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(d), Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#31#0#0: int, a#31#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(LitInt(a#31#0#0), Lit(a#31#1#0)) } #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(LitInt(a#31#0#0), Lit(a#31#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#31#0#0, a#31#1#0)));

function AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(DatatypeType) : int;

axiom (forall a#32#0#0: int, a#32#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#32#0#0, a#32#1#0) } AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#32#0#0, a#32#1#0)) == a#32#0#0);

function AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(DatatypeType) : Seq;

axiom (forall a#33#0#0: int, a#33#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#33#0#0, a#33#1#0) } AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#33#0#0, a#33#1#0)) == a#33#1#0);

axiom (forall a#34#0#0: int, a#34#1#0: Seq, i: int :: { Seq#Index(a#34#1#0, i), #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#34#0#0, a#34#1#0) } 0 <= i && i < Seq#Length(a#34#1#0) ==> DtRank($Unbox(Seq#Index(a#34#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#34#0#0, a#34#1#0)));

axiom (forall a#35#0#0: int, a#35#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#35#0#0, a#35#1#0) } Seq#Rank(a#35#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#35#0#0, a#35#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.RSAPublicKey(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.RSAPublicKey(d) } $IsA#AwsCryptographyPrimitivesTypes.RSAPublicKey(d) ==> AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) ==> AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d));

function AwsCryptographyPrimitivesTypes.RSAPublicKey#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPublicKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAPublicKey#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(a) == AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(b) && Seq#Equal(AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(a), AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPublicKey#Equal(a, b) } AwsCryptographyPrimitivesTypes.RSAPublicKey#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.RSAPublicKey: ClassName;

procedure {:verboseName "AwsCryptographyPrimitivesTypes.SymmetricKeyLength (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.SymmetricKeyLength(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.SymmetricKeyLength(), $h));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.Uint8Bits (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.Uint8Bits(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bits(), $h));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.Uint8Bytes (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.Uint8Bytes(x#0: int where LitInt(-2147483648) <= x#0 && x#0 < 2147483648);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes()) <==> LitInt(-2147483648) <= x#0 && x#0 < 2147483648 && AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.Uint8Bytes(), $h));

function #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(DatatypeType, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#0#0#0, a#0#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#0#0#0, a#0#1#0)) == ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput);
}

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#1#0#0, a#1#1#0)));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#2#0#0, a#2#1#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) <==> $Is(a#2#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) && $Is(a#2#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(d), Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(Lit(a#3#0#0), Lit(a#3#1#0)) } #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#3#0#0, a#3#1#0)));

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#4#0#0, a#4#1#0) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#4#0#0, a#4#1#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#5#0#0, a#5#1#0) } DtRank(a#5#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#5#0#0, a#5#1#0)));

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(DatatypeType) : Seq;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#6#0#0, a#6#1#0) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#6#0#0, a#6#1#0)) == a#6#1#0);

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq, i: int :: { Seq#Index(a#7#1#0, i), #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#7#0#0, a#7#1#0) } 0 <= i && i < Seq#Length(a#7#1#0) ==> DtRank($Unbox(Seq#Index(a#7#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#7#0#0, a#7#1#0)));

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#8#0#0, a#8#1#0) } Seq#Rank(a#8#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#8#0#0, a#8#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(d) } $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(d) ==> AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) ==> AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d));

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ECDHCurveSpec#Equal(AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(a), AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(a), AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput: ClassName;

function #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(bool) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput: DtCtorId
uses {
axiom (forall a#9#0#0: bool :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#9#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#9#0#0)) == ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput);
}

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) ==> (exists a#10#0#0: bool :: d == #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#10#0#0)));

axiom (forall a#11#0#0: bool :: { $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#11#0#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#11#0#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) <==> $Is(a#11#0#0, TBool));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(d), TBool, $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(d), TBool, $h));

axiom (forall a#12#0#0: bool :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(Lit(a#12#0#0)) } #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(Lit(a#12#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#12#0#0)));

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(DatatypeType) : bool;

axiom (forall a#13#0#0: bool :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#13#0#0) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#13#0#0)) <==> a#13#0#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) ==> $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), $h));

function $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(d) } $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(d) ==> AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) ==> AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d));

function AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(a) <==> AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput#Equal(a, b) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput: ClassName;

function #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError: DtCtorId
uses {
axiom (forall a#14#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#14#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#14#0#0)) == ##AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError);
}

function AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) } AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) } AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) ==> (exists a#15#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#15#0#0)));

axiom (forall a#16#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#16#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#16#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#16#0#0, TSeq(TChar)));

axiom (forall a#16#0#0: Seq, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#16#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#16#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#16#0#0, TSeq(TChar), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.Error.message(d), TSeq(TChar), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.Error.message(d), TSeq(TChar), $h));

axiom (forall a#17#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(a#17#0#0)) } #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(a#17#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#17#0#0)));

function AwsCryptographyPrimitivesTypes.Error.message(DatatypeType) : Seq;

axiom (forall a#18#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#18#0#0) } AwsCryptographyPrimitivesTypes.Error.message(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#18#0#0)) == a#18#0#0);

axiom (forall a#19#0#0: Seq, i: int :: { Seq#Index(a#19#0#0, i), #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#19#0#0) } 0 <= i && i < Seq#Length(a#19#0#0) ==> DtRank($Unbox(Seq#Index(a#19#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#19#0#0)));

axiom (forall a#20#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#20#0#0) } Seq#Rank(a#20#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#20#0#0)));

function #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(Seq, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors: DtCtorId
uses {
axiom (forall a#21#0#0: Seq, a#21#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#21#0#0, a#21#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#21#0#0, a#21#1#0)) == ##AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors);
}

function AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) } AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) } AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) ==> (exists a#22#0#0: Seq, a#22#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#22#0#0, a#22#1#0)));

axiom (forall a#23#0#0: Seq, a#23#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#23#0#0, a#23#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#23#0#0, a#23#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#23#0#0, TSeq(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $Is(a#23#1#0, TSeq(TChar)));

axiom (forall a#23#0#0: Seq, a#23#1#0: Seq, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#23#0#0, a#23#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#23#0#0, a#23#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#23#0#0, TSeq(Tclass.AwsCryptographyPrimitivesTypes.Error()), $h) && $IsAlloc(a#23#1#0, TSeq(TChar), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.Error.list(d), TSeq(Tclass.AwsCryptographyPrimitivesTypes.Error()), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.Error.list(d), TSeq(Tclass.AwsCryptographyPrimitivesTypes.Error()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.Error.message(d), TSeq(TChar), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.Error.message(d), TSeq(TChar), $h));

axiom (forall a#24#0#0: Seq, a#24#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(Lit(a#24#0#0), Lit(a#24#1#0)) } #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(Lit(a#24#0#0), Lit(a#24#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#24#0#0, a#24#1#0)));

function AwsCryptographyPrimitivesTypes.Error.list(DatatypeType) : Seq;

axiom (forall a#25#0#0: Seq, a#25#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#25#0#0, a#25#1#0) } AwsCryptographyPrimitivesTypes.Error.list(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#25#0#0, a#25#1#0)) == a#25#0#0);

axiom (forall a#26#0#0: Seq, a#26#1#0: Seq, i: int :: { Seq#Index(a#26#0#0, i), #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#26#0#0, a#26#1#0) } 0 <= i && i < Seq#Length(a#26#0#0) ==> DtRank($Unbox(Seq#Index(a#26#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#26#0#0, a#26#1#0)));

axiom (forall a#27#0#0: Seq, a#27#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#27#0#0, a#27#1#0) } Seq#Rank(a#27#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#27#0#0, a#27#1#0)));

axiom (forall a#28#0#0: Seq, a#28#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#28#0#0, a#28#1#0) } AwsCryptographyPrimitivesTypes.Error.message(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#28#0#0, a#28#1#0)) == a#28#1#0);

axiom (forall a#29#0#0: Seq, a#29#1#0: Seq, i: int :: { Seq#Index(a#29#1#0, i), #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#29#0#0, a#29#1#0) } 0 <= i && i < Seq#Length(a#29#1#0) ==> DtRank($Unbox(Seq#Index(a#29#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#29#0#0, a#29#1#0)));

axiom (forall a#30#0#0: Seq, a#30#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#30#0#0, a#30#1#0) } Seq#Rank(a#30#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#30#0#0, a#30#1#0)));

function #AwsCryptographyPrimitivesTypes.Error.Opaque(ref) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.Error.Opaque: DtCtorId
uses {
axiom (forall a#31#0#0: ref :: { #AwsCryptographyPrimitivesTypes.Error.Opaque(a#31#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#31#0#0)) == ##AwsCryptographyPrimitivesTypes.Error.Opaque);
}

function AwsCryptographyPrimitivesTypes.Error.Opaque_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) } AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.Error.Opaque);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) } AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) ==> (exists a#32#0#0: ref :: d == #AwsCryptographyPrimitivesTypes.Error.Opaque(a#32#0#0)));

axiom (forall a#33#0#0: ref :: { $Is(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#33#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#33#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#33#0#0, Tclass._System.object()));

axiom (forall a#33#0#0: ref, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#33#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#33#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#33#0#0, Tclass._System.object(), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.Error.obj(d), Tclass._System.object(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.Error.obj(d), Tclass._System.object(), $h));

axiom (forall a#34#0#0: ref :: { #AwsCryptographyPrimitivesTypes.Error.Opaque(Lit(a#34#0#0)) } #AwsCryptographyPrimitivesTypes.Error.Opaque(Lit(a#34#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#34#0#0)));

function AwsCryptographyPrimitivesTypes.Error.obj(DatatypeType) : ref;

axiom (forall a#35#0#0: ref :: { #AwsCryptographyPrimitivesTypes.Error.Opaque(a#35#0#0) } AwsCryptographyPrimitivesTypes.Error.obj(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#35#0#0)) == a#35#0#0);

function #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(ref, Seq) : DatatypeType;

const unique ##AwsCryptographyPrimitivesTypes.Error.OpaqueWithText: DtCtorId
uses {
axiom (forall a#36#0#0: ref, a#36#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#36#0#0, a#36#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#36#0#0, a#36#1#0)) == ##AwsCryptographyPrimitivesTypes.Error.OpaqueWithText);
}

function AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) } AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) <==> DatatypeCtorId(d) == ##AwsCryptographyPrimitivesTypes.Error.OpaqueWithText);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) } AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) ==> (exists a#37#0#0: ref, a#37#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#37#0#0, a#37#1#0)));

axiom (forall a#38#0#0: ref, a#38#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#38#0#0, a#38#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#38#0#0, a#38#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#38#0#0, Tclass._System.object()) && $Is(a#38#1#0, TSeq(TChar)));

axiom (forall a#38#0#0: ref, a#38#1#0: Seq, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#38#0#0, a#38#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#38#0#0, a#38#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#38#0#0, Tclass._System.object(), $h) && $IsAlloc(a#38#1#0, TSeq(TChar), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.Error.obj(d), Tclass._System.object(), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.Error.obj(d), Tclass._System.object(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(AwsCryptographyPrimitivesTypes.Error.objMessage(d), TSeq(TChar), $h) } $IsGoodHeap($h) && AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) && $IsAlloc(d, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.Error.objMessage(d), TSeq(TChar), $h));

axiom (forall a#39#0#0: ref, a#39#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(Lit(a#39#0#0), Lit(a#39#1#0)) } #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(Lit(a#39#0#0), Lit(a#39#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#39#0#0, a#39#1#0)));

axiom (forall a#40#0#0: ref, a#40#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#40#0#0, a#40#1#0) } AwsCryptographyPrimitivesTypes.Error.obj(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#40#0#0, a#40#1#0)) == a#40#0#0);

function AwsCryptographyPrimitivesTypes.Error.objMessage(DatatypeType) : Seq;

axiom (forall a#41#0#0: ref, a#41#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#41#0#0, a#41#1#0) } AwsCryptographyPrimitivesTypes.Error.objMessage(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#41#0#0, a#41#1#0)) == a#41#1#0);

axiom (forall a#42#0#0: ref, a#42#1#0: Seq, i: int :: { Seq#Index(a#42#1#0, i), #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#42#0#0, a#42#1#0) } 0 <= i && i < Seq#Length(a#42#1#0) ==> DtRank($Unbox(Seq#Index(a#42#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#42#0#0, a#42#1#0)));

axiom (forall a#43#0#0: ref, a#43#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#43#0#0, a#43#1#0) } Seq#Rank(a#43#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#43#0#0, a#43#1#0)));

function $IsA#AwsCryptographyPrimitivesTypes.Error(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#AwsCryptographyPrimitivesTypes.Error(d) } $IsA#AwsCryptographyPrimitivesTypes.Error(d) ==> AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) || AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) || AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) || AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.Error()) } { AwsCryptographyPrimitivesTypes.Error.Opaque_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.Error()) } { AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.Error()) } { AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d), $Is(d, Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(d, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) || AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) || AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) || AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d));

function AwsCryptographyPrimitivesTypes.Error#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(a) } { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(b) } AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(a) && AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(b) ==> (AwsCryptographyPrimitivesTypes.Error#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.Error.message(a), AwsCryptographyPrimitivesTypes.Error.message(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(a) } { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(b) } AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(a) && AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(b) ==> (AwsCryptographyPrimitivesTypes.Error#Equal(a, b) <==> Seq#Equal(AwsCryptographyPrimitivesTypes.Error.list(a), AwsCryptographyPrimitivesTypes.Error.list(b)) && Seq#Equal(AwsCryptographyPrimitivesTypes.Error.message(a), AwsCryptographyPrimitivesTypes.Error.message(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.Opaque_q(a) } { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.Opaque_q(b) } AwsCryptographyPrimitivesTypes.Error.Opaque_q(a) && AwsCryptographyPrimitivesTypes.Error.Opaque_q(b) ==> (AwsCryptographyPrimitivesTypes.Error#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.Error.obj(a) == AwsCryptographyPrimitivesTypes.Error.obj(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(a) } { AwsCryptographyPrimitivesTypes.Error#Equal(a, b), AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(b) } AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(a) && AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(b) ==> (AwsCryptographyPrimitivesTypes.Error#Equal(a, b) <==> AwsCryptographyPrimitivesTypes.Error.obj(a) == AwsCryptographyPrimitivesTypes.Error.obj(b) && Seq#Equal(AwsCryptographyPrimitivesTypes.Error.objMessage(a), AwsCryptographyPrimitivesTypes.Error.objMessage(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error#Equal(a, b) } AwsCryptographyPrimitivesTypes.Error#Equal(a, b) <==> a == b);

const unique class.AwsCryptographyPrimitivesTypes.Error: ClassName;

procedure {:verboseName "AwsCryptographyPrimitivesTypes.OpaqueError (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.OpaqueError(e#0: DatatypeType where $Is(e#0, Tclass.AwsCryptographyPrimitivesTypes.Error()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.AwsCryptographyPrimitivesTypes.OpaqueError() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()) == Tagclass.AwsCryptographyPrimitivesTypes.OpaqueError && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()) == tytagFamily$OpaqueError;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.OpaqueError: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()));

axiom (forall e#0: DatatypeType :: { $Is(e#0, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()) } $Is(e#0, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError()) <==> $Is(e#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && (AwsCryptographyPrimitivesTypes.Error.Opaque_q(e#0) || AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(e#0)));

axiom (forall e#0: DatatypeType, $h: Heap :: { $IsAlloc(e#0, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError(), $h) } $IsAlloc(e#0, Tclass.AwsCryptographyPrimitivesTypes.OpaqueError(), $h) <==> $IsAlloc(e#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $h));

procedure {:verboseName "AwsCryptographyPrimitivesTypes.DummySubsetType (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.DummySubsetType(x#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AwsCryptographyPrimitivesTypes.DummySubsetType (well-formedness)"} CheckWellFormed$$AwsCryptographyPrimitivesTypes.DummySubsetType(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "AwsCryptographyPrimitivesTypes.DummySubsetType", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(698,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    assume AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#canCall(x#0);
    assume AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0);
    return;

  anon4_Else:
    assume AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#canCall(LitInt(1));
    assume {:subsumption 0} AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType#canCall(LitInt(1)) ==> Lit(AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(LitInt(1))) || Lit(0 < 1);
    return;
}



function Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType() : Ty
uses {
axiom Tag(Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()) == Tagclass.AwsCryptographyPrimitivesTypes.DummySubsetType && TagFamily(Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()) == tytagFamily$DummySubsetType;
}

const unique Tagclass.AwsCryptographyPrimitivesTypes.DummySubsetType: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()) } $IsBox(bx, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()));

axiom (forall x#0: int :: { $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()) } $Is(x#0, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType()) <==> AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType(), $h) } $IsAlloc(x#0, Tclass.AwsCryptographyPrimitivesTypes.DummySubsetType(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#16 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#16))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#18 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#18)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#24 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#24))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#26 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#26)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#28 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#28)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#24 := Wrappers.Option.value(this); v#24)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#26 := Lit(Wrappers.Option.value(Lit(this))); v#26)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#28 := Lit(Wrappers.Option.value(Lit(this))); v#28)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#16 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#16)) else (var e#16 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#18 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#18))) else (var e#18 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#24 := Wrappers.Result.value(this); s#24) else (var e#24 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#26 := Lit(Wrappers.Result.value(Lit(this))); s#26) else (var e#26 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#28 := Lit(Wrappers.Result.value(Lit(this))); s#28) else (var e#28 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#24 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#24)) else (var e#24 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#24)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#26 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#26))) else (var e#26 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#26)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#28 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#28))) else (var e#28 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#28)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#10 := Div(x#0, LitInt(256)); (var b1#10 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#10)), $Box(b1#10)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#11 := LitInt(Div(x#0, LitInt(256))); (var b1#11 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#11)), $Box(b1#11))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#10 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#10 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#11 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#11 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#10 := Div(x#0, LitInt(16777216)); (var x0#10 := x#0 - Mul(b0#10, LitInt(16777216)); (var b1#10 := Div(x0#10, LitInt(65536)); (var x1#10 := x0#10 - Mul(b1#10, LitInt(65536)); (var b2#10 := Div(x1#10, LitInt(256)); (var b3#10 := Mod(x1#10, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#10)), $Box(b1#10)), $Box(b2#10)), $Box(b3#10)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#11 := LitInt(Div(x#0, LitInt(16777216))); (var x0#11 := LitInt(x#0 - Mul(b0#11, LitInt(16777216))); (var b1#11 := LitInt(Div(x0#11, LitInt(65536))); (var x1#11 := LitInt(x0#11 - Mul(b1#11, LitInt(65536))); (var b2#11 := LitInt(Div(x1#11, LitInt(256))); (var b3#11 := LitInt(Mod(x1#11, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#11)), $Box(b1#11)), $Box(b2#11)), $Box(b3#11))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#10 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#10 := x0#10 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#10 := x1#10 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#10 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#11 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#11 := x0#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#11 := x1#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#11 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#10 := Div(x#0, LitInt(72057594037927936)); (var x0#10 := x#0 - Mul(b0#10, LitInt(72057594037927936)); (var b1#10 := Div(x0#10, LitInt(281474976710656)); (var x1#10 := x0#10 - Mul(b1#10, LitInt(281474976710656)); (var b2#10 := Div(x1#10, LitInt(1099511627776)); (var x2#10 := x1#10 - Mul(b2#10, LitInt(1099511627776)); (var b3#10 := Div(x2#10, LitInt(4294967296)); (var x3#10 := x2#10 - Mul(b3#10, LitInt(4294967296)); (var b4#10 := Div(x3#10, LitInt(16777216)); (var x4#10 := x3#10 - Mul(b4#10, LitInt(16777216)); (var b5#10 := Div(x4#10, LitInt(65536)); (var x5#10 := x4#10 - Mul(b5#10, LitInt(65536)); (var b6#10 := Div(x5#10, LitInt(256)); (var b7#10 := Mod(x5#10, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#10)), $Box(b1#10)), $Box(b2#10)), $Box(b3#10)), $Box(b4#10)), $Box(b5#10)), $Box(b6#10)), $Box(b7#10)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#11 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#11 := LitInt(x#0 - Mul(b0#11, LitInt(72057594037927936))); (var b1#11 := LitInt(Div(x0#11, LitInt(281474976710656))); (var x1#11 := LitInt(x0#11 - Mul(b1#11, LitInt(281474976710656))); (var b2#11 := LitInt(Div(x1#11, LitInt(1099511627776))); (var x2#11 := LitInt(x1#11 - Mul(b2#11, LitInt(1099511627776))); (var b3#11 := LitInt(Div(x2#11, LitInt(4294967296))); (var x3#11 := LitInt(x2#11 - Mul(b3#11, LitInt(4294967296))); (var b4#11 := LitInt(Div(x3#11, LitInt(16777216))); (var x4#11 := LitInt(x3#11 - Mul(b4#11, LitInt(16777216))); (var b5#11 := LitInt(Div(x4#11, LitInt(65536))); (var x5#11 := LitInt(x4#11 - Mul(b5#11, LitInt(65536))); (var b6#11 := LitInt(Div(x5#11, LitInt(256))); (var b7#11 := LitInt(Mod(x5#11, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#11)), $Box(b1#11)), $Box(b2#11)), $Box(b3#11)), $Box(b4#11)), $Box(b5#11)), $Box(b6#11)), $Box(b7#11))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#10 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#10 := x0#10 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#10 := x1#10 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#10 := x2#10 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#10 := x3#10 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#10 := x4#10 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#10 := x5#10 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#11 := x6#10 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#11)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#11 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#11 := x0#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#11 := x1#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#11 := x2#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#11 := x3#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#11 := x4#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#11 := x5#11 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#12 := x6#11 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#12)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#10 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#10)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#10 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#10)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#10)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#11 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#11)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#11 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#11)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#11)): int)));

axiom (forall s#0: Seq :: { UTF8.__default.Encode(s#0) } UTF8.__default.Encode#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) ==> Wrappers.Result.Success_q(UTF8.__default.Encode(s#0)) && Seq#Length($Unbox(Wrappers.Result.value(UTF8.__default.Encode(s#0))): Seq) == Seq#Length(s#0)) && (Wrappers.Result.Success_q(UTF8.__default.Encode(s#0)) ==> Wrappers.Result.Success_q(UTF8.__default.Decode($Unbox(Wrappers.Result.value(UTF8.__default.Encode(s#0))): Seq)) && Seq#Equal($Unbox(Wrappers.Result.value(UTF8.__default.Decode($Unbox(Wrappers.Result.value(UTF8.__default.Encode(s#0))): Seq))): Seq, s#0)) && $Is(UTF8.__default.Encode(s#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));

axiom (forall b#0: Seq :: { UTF8.__default.Decode(b#0) } UTF8.__default.Decode#canCall(b#0) || $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Wrappers.Result.Success_q(UTF8.__default.Decode(b#0)) ==> UTF8.__default.ValidUTF8Seq(b#0)) && $Is(UTF8.__default.Decode(b#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));

axiom (forall bytes#0: Seq :: { UTF8.__default.CreateEncodeSuccess(bytes#0) } UTF8.__default.CreateEncodeSuccess#canCall(bytes#0) || $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes()) ==> $Is(UTF8.__default.CreateEncodeSuccess(bytes#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));

axiom (forall bytes#0: Seq :: { UTF8.__default.CreateEncodeSuccess(bytes#0) } UTF8.__default.CreateEncodeSuccess#canCall(bytes#0) || $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes()) ==> UTF8.__default.CreateEncodeSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));

axiom (forall bytes#0: Seq :: {:weight 3} { UTF8.__default.CreateEncodeSuccess(Lit(bytes#0)) } UTF8.__default.CreateEncodeSuccess#canCall(Lit(bytes#0)) || $Is(bytes#0, Tclass.UTF8.ValidUTF8Bytes()) ==> UTF8.__default.CreateEncodeSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));

axiom (forall error#0: Seq :: { UTF8.__default.CreateEncodeFailure(error#0) } UTF8.__default.CreateEncodeFailure#canCall(error#0) || $Is(error#0, TSeq(TChar)) ==> $Is(UTF8.__default.CreateEncodeFailure(error#0), Tclass.Wrappers.Result(Tclass.UTF8.ValidUTF8Bytes(), TSeq(TChar))));

axiom (forall error#0: Seq :: { UTF8.__default.CreateEncodeFailure(error#0) } UTF8.__default.CreateEncodeFailure#canCall(error#0) || $Is(error#0, TSeq(TChar)) ==> UTF8.__default.CreateEncodeFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));

axiom (forall error#0: Seq :: {:weight 3} { UTF8.__default.CreateEncodeFailure(Lit(error#0)) } UTF8.__default.CreateEncodeFailure#canCall(Lit(error#0)) || $Is(error#0, TSeq(TChar)) ==> UTF8.__default.CreateEncodeFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));

axiom (forall s#0: Seq :: { UTF8.__default.CreateDecodeSuccess(s#0) } UTF8.__default.CreateDecodeSuccess#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> $Is(UTF8.__default.CreateDecodeSuccess(s#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));

axiom (forall s#0: Seq :: { UTF8.__default.CreateDecodeSuccess(s#0) } UTF8.__default.CreateDecodeSuccess#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> UTF8.__default.CreateDecodeSuccess(s#0) == #Wrappers.Result.Success($Box(s#0)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.CreateDecodeSuccess(Lit(s#0)) } UTF8.__default.CreateDecodeSuccess#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> UTF8.__default.CreateDecodeSuccess(Lit(s#0)) == Lit(#Wrappers.Result.Success($Box(Lit(s#0)))));

axiom (forall error#0: Seq :: { UTF8.__default.CreateDecodeFailure(error#0) } UTF8.__default.CreateDecodeFailure#canCall(error#0) || $Is(error#0, TSeq(TChar)) ==> $Is(UTF8.__default.CreateDecodeFailure(error#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));

axiom (forall error#0: Seq :: { UTF8.__default.CreateDecodeFailure(error#0) } UTF8.__default.CreateDecodeFailure#canCall(error#0) || $Is(error#0, TSeq(TChar)) ==> UTF8.__default.CreateDecodeFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));

axiom (forall error#0: Seq :: {:weight 3} { UTF8.__default.CreateDecodeFailure(Lit(error#0)) } UTF8.__default.CreateDecodeFailure#canCall(Lit(error#0)) || $Is(error#0, TSeq(TChar)) ==> UTF8.__default.CreateDecodeFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#4: int :: { $Unbox(Seq#Index(s#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#4)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#5: int :: { $Unbox(Seq#Index(s#0, i#5)): char } LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#5)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#5: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#5)): int } { $Unbox(Seq#Index(s#0, i#5)): char } LitInt(0) <= i#5 && i#5 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#5)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#5)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#2 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#2, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#3 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#3, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall s#0: Seq :: { UTF8.__default.Uses1Byte(s#0) } UTF8.__default.Uses1Byte#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(1)) ==> (UTF8.__default.Uses1Byte(s#0) <==> LitInt(0) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(127)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses1Byte(Lit(s#0)) } UTF8.__default.Uses1Byte#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(1)) ==> (UTF8.__default.Uses1Byte(Lit(s#0)) <==> LitInt(0) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(127)));

axiom (forall s#0: Seq :: { UTF8.__default.Uses2Bytes(s#0) } UTF8.__default.Uses2Bytes#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(2)) ==> (UTF8.__default.Uses2Bytes(s#0) <==> LitInt(194) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(223) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses2Bytes(Lit(s#0)) } UTF8.__default.Uses2Bytes#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(2)) ==> (UTF8.__default.Uses2Bytes(Lit(s#0)) <==> LitInt(194) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(223) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191)));

axiom (forall s#0: Seq :: { UTF8.__default.Uses3Bytes(s#0) } UTF8.__default.Uses3Bytes#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(3)) ==> (UTF8.__default.Uses3Bytes(s#0) <==> ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191)) || (LitInt(238) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191))));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses3Bytes(Lit(s#0)) } UTF8.__default.Uses3Bytes#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(3)) ==> (UTF8.__default.Uses3Bytes(Lit(s#0)) <==> ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(224) && LitInt(160) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191)) || (LitInt(225) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(236) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191)) || ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(237) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(159) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191)) || (LitInt(238) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(239) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191))));

axiom (forall s#0: Seq :: { UTF8.__default.Uses4Bytes(s#0) } UTF8.__default.Uses4Bytes#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) >= LitInt(4)) ==> (UTF8.__default.Uses4Bytes(s#0) <==> ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(s#0, LitInt(0))): int && $Unbox(Seq#Index(s#0, LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191)) || ($Unbox(Seq#Index(s#0, LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(1))): int && $Unbox(Seq#Index(s#0, LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(2))): int && $Unbox(Seq#Index(s#0, LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(s#0, LitInt(3))): int && $Unbox(Seq#Index(s#0, LitInt(3))): int <= LitInt(191))));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.Uses4Bytes(Lit(s#0)) } UTF8.__default.Uses4Bytes#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) >= LitInt(4)) ==> (UTF8.__default.Uses4Bytes(Lit(s#0)) <==> ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(240) && LitInt(144) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int <= LitInt(191)) || (LitInt(241) <= $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int <= LitInt(243) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int <= LitInt(191)) || ($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int == LitInt(244) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int <= LitInt(143) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int <= LitInt(191) && LitInt(128) <= $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int <= LitInt(191))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#3 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#3) && (UTF8.__default.Uses1Byte(r#3) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#3) ==> (LitInt(2) <= Seq#Length(r#3) ==> UTF8.__default.Uses2Bytes#canCall(r#3)) && (LitInt(2) <= Seq#Length(r#3) && UTF8.__default.Uses2Bytes(r#3) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#3) && UTF8.__default.Uses2Bytes(r#3)) ==> (LitInt(3) <= Seq#Length(r#3) ==> UTF8.__default.Uses3Bytes#canCall(r#3)) && (LitInt(3) <= Seq#Length(r#3) && UTF8.__default.Uses3Bytes(r#3) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#3) && UTF8.__default.Uses3Bytes(r#3)) ==> (LitInt(4) <= Seq#Length(r#3) ==> UTF8.__default.Uses4Bytes#canCall(r#3)) && (LitInt(4) <= Seq#Length(r#3) && UTF8.__default.Uses4Bytes(r#3) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#3 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#3) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#3) && UTF8.__default.Uses2Bytes(r#3) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#3) && UTF8.__default.Uses3Bytes(r#3) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#3) && UTF8.__default.Uses4Bytes(r#3) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#4 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#4) && (UTF8.__default.Uses1Byte(r#4) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#4) ==> (LitInt(2) <= Seq#Length(r#4) ==> UTF8.__default.Uses2Bytes#canCall(r#4)) && (LitInt(2) <= Seq#Length(r#4) && UTF8.__default.Uses2Bytes(r#4) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#4) && UTF8.__default.Uses2Bytes(r#4)) ==> (LitInt(3) <= Seq#Length(r#4) ==> UTF8.__default.Uses3Bytes#canCall(r#4)) && (LitInt(3) <= Seq#Length(r#4) && UTF8.__default.Uses3Bytes(r#4) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#4) && UTF8.__default.Uses3Bytes(r#4)) ==> (LitInt(4) <= Seq#Length(r#4) ==> UTF8.__default.Uses4Bytes#canCall(r#4)) && (LitInt(4) <= Seq#Length(r#4) && UTF8.__default.Uses4Bytes(r#4) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#4 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#4) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#4) && UTF8.__default.Uses2Bytes(r#4) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#4) && UTF8.__default.Uses3Bytes(r#4) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#4) && UTF8.__default.Uses4Bytes(r#4) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#5 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#5) && (UTF8.__default.Uses1Byte(r#5) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#5) ==> (LitInt(2) <= Seq#Length(r#5) ==> UTF8.__default.Uses2Bytes#canCall(r#5)) && (LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5)) ==> (LitInt(3) <= Seq#Length(r#5) ==> UTF8.__default.Uses3Bytes#canCall(r#5)) && (LitInt(3) <= Seq#Length(r#5) && UTF8.__default.Uses3Bytes(r#5) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#5) && UTF8.__default.Uses3Bytes(r#5)) ==> (LitInt(4) <= Seq#Length(r#5) ==> UTF8.__default.Uses4Bytes#canCall(r#5)) && (LitInt(4) <= Seq#Length(r#5) && UTF8.__default.Uses4Bytes(r#5) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#5 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#5) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#5) && UTF8.__default.Uses2Bytes(r#5) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#5) && UTF8.__default.Uses3Bytes(r#5) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#5) && UTF8.__default.Uses4Bytes(r#5) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall s#0: Seq :: { UTF8.__default.ValidUTF8Seq(s#0) } UTF8.__default.ValidUTF8Seq#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> UTF8.__default.ValidUTF8Range#canCall(s#0, LitInt(0), Seq#Length(s#0)) && (UTF8.__default.ValidUTF8Seq(s#0) <==> UTF8.__default.ValidUTF8Range($LS($LZ), s#0, LitInt(0), Seq#Length(s#0))));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.ValidUTF8Seq(Lit(s#0)) } UTF8.__default.ValidUTF8Seq#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(s#0), LitInt(0), Seq#Length(Lit(s#0))) && (UTF8.__default.ValidUTF8Seq(Lit(s#0)) <==> UTF8.__default.ValidUTF8Range($LS($LZ), Lit(s#0), LitInt(0), Seq#Length(Lit(s#0)))));

const unique tytagFamily$DafnyCallEvent: TyTagFamily;

const unique tytagFamily$AES_CTR: TyTagFamily;

const unique tytagFamily$SymmetricKeyLength: TyTagFamily;

const unique tytagFamily$Uint8Bits: TyTagFamily;

const unique tytagFamily$AES_GCM: TyTagFamily;

const unique tytagFamily$Uint8Bytes: TyTagFamily;

const unique tytagFamily$AESDecryptInput: TyTagFamily;

const unique tytagFamily$AESEncryptInput: TyTagFamily;

const unique tytagFamily$AESEncryptOutput: TyTagFamily;

const unique tytagFamily$AesKdfCtrInput: TyTagFamily;

const unique tytagFamily$PositiveInteger: TyTagFamily;

const unique tytagFamily$IAwsCryptographicPrimitivesClientCallHistory: TyTagFamily;

const unique tytagFamily$GenerateRandomBytesInput: TyTagFamily;

const unique tytagFamily$Error: TyTagFamily;

const unique tytagFamily$DigestInput: TyTagFamily;

const unique tytagFamily$HMacInput: TyTagFamily;

const unique tytagFamily$HkdfExtractInput: TyTagFamily;

const unique tytagFamily$HkdfExpandInput: TyTagFamily;

const unique tytagFamily$HkdfInput: TyTagFamily;

const unique tytagFamily$KdfCtrInput: TyTagFamily;

const unique tytagFamily$GenerateRSAKeyPairInput: TyTagFamily;

const unique tytagFamily$GenerateRSAKeyPairOutput: TyTagFamily;

const unique tytagFamily$GetRSAKeyModulusLengthInput: TyTagFamily;

const unique tytagFamily$GetRSAKeyModulusLengthOutput: TyTagFamily;

const unique tytagFamily$RSADecryptInput: TyTagFamily;

const unique tytagFamily$RSAEncryptInput: TyTagFamily;

const unique tytagFamily$GenerateECDSASignatureKeyInput: TyTagFamily;

const unique tytagFamily$GenerateECDSASignatureKeyOutput: TyTagFamily;

const unique tytagFamily$ECDSASignInput: TyTagFamily;

const unique tytagFamily$ECDSAVerifyInput: TyTagFamily;

const unique tytagFamily$GenerateECCKeyPairInput: TyTagFamily;

const unique tytagFamily$GenerateECCKeyPairOutput: TyTagFamily;

const unique tytagFamily$GetPublicKeyFromPrivateKeyInput: TyTagFamily;

const unique tytagFamily$GetPublicKeyFromPrivateKeyOutput: TyTagFamily;

const unique tytagFamily$ValidatePublicKeyInput: TyTagFamily;

const unique tytagFamily$ValidatePublicKeyOutput: TyTagFamily;

const unique tytagFamily$DeriveSharedSecretInput: TyTagFamily;

const unique tytagFamily$DeriveSharedSecretOutput: TyTagFamily;

const unique tytagFamily$CompressPublicKeyInput: TyTagFamily;

const unique tytagFamily$CompressPublicKeyOutput: TyTagFamily;

const unique tytagFamily$DecompressPublicKeyInput: TyTagFamily;

const unique tytagFamily$DecompressPublicKeyOutput: TyTagFamily;

const unique tytagFamily$ParsePublicKeyInput: TyTagFamily;

const unique tytagFamily$ParsePublicKeyOutput: TyTagFamily;

const unique tytagFamily$IAwsCryptographicPrimitivesClient: TyTagFamily;

const unique tytagFamily$ECCPublicKey: TyTagFamily;

const unique tytagFamily$ECDHCurveSpec: TyTagFamily;

const unique tytagFamily$CryptoConfig: TyTagFamily;

const unique tytagFamily$ECCPrivateKey: TyTagFamily;

const unique tytagFamily$DigestAlgorithm: TyTagFamily;

const unique tytagFamily$ECDSASignatureAlgorithm: TyTagFamily;

const unique tytagFamily$RSAModulusLengthBitsToGenerate: TyTagFamily;

const unique tytagFamily$RSAPublicKey: TyTagFamily;

const unique tytagFamily$RSAPrivateKey: TyTagFamily;

const unique tytagFamily$RSAModulusLengthBits: TyTagFamily;

const unique tytagFamily$RSAPaddingMode: TyTagFamily;

const unique tytagFamily$OpaqueError: TyTagFamily;

const unique tytagFamily$DummySubsetType: TyTagFamily;

const unique field$GenerateRandomBytes: NameFamily;

const unique field$Digest: NameFamily;

const unique field$HMac: NameFamily;

const unique field$HkdfExtract: NameFamily;

const unique field$HkdfExpand: NameFamily;

const unique field$Hkdf: NameFamily;

const unique field$KdfCounterMode: NameFamily;

const unique field$AesKdfCounterMode: NameFamily;

const unique field$AESEncrypt: NameFamily;

const unique field$AESDecrypt: NameFamily;

const unique field$GenerateRSAKeyPair: NameFamily;

const unique field$GetRSAKeyModulusLength: NameFamily;

const unique field$RSADecrypt: NameFamily;

const unique field$RSAEncrypt: NameFamily;

const unique field$GenerateECDSASignatureKey: NameFamily;

const unique field$ECDSASign: NameFamily;

const unique field$ECDSAVerify: NameFamily;

const unique field$GenerateECCKeyPair: NameFamily;

const unique field$GetPublicKeyFromPrivateKey: NameFamily;

const unique field$ValidatePublicKey: NameFamily;

const unique field$DeriveSharedSecret: NameFamily;

const unique field$CompressPublicKey: NameFamily;

const unique field$DecompressPublicKey: NameFamily;

const unique field$ParsePublicKey: NameFamily;

const unique class.ExternDigest.__default: ClassName;

procedure {:verboseName "ExternDigest.Digest (well-formedness)"} {:extern} CheckWellFormed$$ExternDigest.__default.Digest(alg#0: DatatypeType where $Is(alg#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(alg#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(alg#0), msg#0: Seq where $Is(msg#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(msg#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ExternDigest.Digest (call precondtion)"} {:extern} CallPre$$ExternDigest.__default.Digest(alg#0: DatatypeType where $Is(alg#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(alg#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(alg#0), msg#0: Seq where $Is(msg#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(msg#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "ExternDigest.Digest (call postcondition)"} {:extern} CallPost$$ExternDigest.__default.Digest(alg#0: DatatypeType where $Is(alg#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(alg#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(alg#0), msg#0: Seq where $Is(msg#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(msg#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function ExternDigest.__default.CreateDigestSuccess(bytes#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { ExternDigest.__default.CreateDigestSuccess(bytes#0) } ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> $Is(ExternDigest.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, bytes#0: Seq :: { $IsAlloc(ExternDigest.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(ExternDigest.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { ExternDigest.__default.CreateDigestSuccess(bytes#0) } ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> ExternDigest.__default.CreateDigestSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: {:weight 3} { ExternDigest.__default.CreateDigestSuccess(Lit(bytes#0)) } ExternDigest.__default.CreateDigestSuccess#canCall(Lit(bytes#0)) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> ExternDigest.__default.CreateDigestSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));
}

function ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0: Seq) : bool;

function ExternDigest.__default.CreateDigestSuccess#requires(Seq) : bool;

axiom (forall bytes#0: Seq :: { ExternDigest.__default.CreateDigestSuccess#requires(bytes#0) } $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> (ExternDigest.__default.CreateDigestSuccess#requires(bytes#0) <==> true));

procedure {:verboseName "ExternDigest.CreateDigestSuccess (well-formedness)"} CheckWellformed$$ExternDigest.__default.CreateDigestSuccess(bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function ExternDigest.__default.CreateDigestFailure(error#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { ExternDigest.__default.CreateDigestFailure(error#0) } ExternDigest.__default.CreateDigestFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> $Is(ExternDigest.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(ExternDigest.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (ExternDigest.__default.CreateDigestFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(ExternDigest.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { ExternDigest.__default.CreateDigestFailure(error#0) } ExternDigest.__default.CreateDigestFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> ExternDigest.__default.CreateDigestFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: {:weight 3} { ExternDigest.__default.CreateDigestFailure(Lit(error#0)) } ExternDigest.__default.CreateDigestFailure#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> ExternDigest.__default.CreateDigestFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function ExternDigest.__default.CreateDigestFailure#canCall(error#0: DatatypeType) : bool;

function ExternDigest.__default.CreateDigestFailure#requires(DatatypeType) : bool;

axiom (forall error#0: DatatypeType :: { ExternDigest.__default.CreateDigestFailure#requires(error#0) } $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> (ExternDigest.__default.CreateDigestFailure#requires(error#0) <==> true));

procedure {:verboseName "ExternDigest.CreateDigestFailure (well-formedness)"} CheckWellformed$$ExternDigest.__default.CreateDigestFailure(error#0: DatatypeType where $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#20 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#20))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#22 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#22)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#30 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#30))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#32 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#32)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#34 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#34)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#30 := Wrappers.Option.value(this); v#30)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#32 := Lit(Wrappers.Option.value(Lit(this))); v#32)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#34 := Lit(Wrappers.Option.value(Lit(this))); v#34)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#20 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#20)) else (var e#20 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#22 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#22))) else (var e#22 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#30 := Wrappers.Result.value(this); s#30) else (var e#30 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#32 := Lit(Wrappers.Result.value(Lit(this))); s#32) else (var e#32 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#34 := Lit(Wrappers.Result.value(Lit(this))); s#34) else (var e#34 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#30 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#30)) else (var e#30 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#30)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#32 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#32))) else (var e#32 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#32)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#34 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#34))) else (var e#34 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#34)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#12 := Div(x#0, LitInt(256)); (var b1#12 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#12)), $Box(b1#12)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#13 := LitInt(Div(x#0, LitInt(256))); (var b1#13 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#13)), $Box(b1#13))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#12 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#12 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#13 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#13 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#12 := Div(x#0, LitInt(16777216)); (var x0#12 := x#0 - Mul(b0#12, LitInt(16777216)); (var b1#12 := Div(x0#12, LitInt(65536)); (var x1#12 := x0#12 - Mul(b1#12, LitInt(65536)); (var b2#12 := Div(x1#12, LitInt(256)); (var b3#12 := Mod(x1#12, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#12)), $Box(b1#12)), $Box(b2#12)), $Box(b3#12)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#13 := LitInt(Div(x#0, LitInt(16777216))); (var x0#13 := LitInt(x#0 - Mul(b0#13, LitInt(16777216))); (var b1#13 := LitInt(Div(x0#13, LitInt(65536))); (var x1#13 := LitInt(x0#13 - Mul(b1#13, LitInt(65536))); (var b2#13 := LitInt(Div(x1#13, LitInt(256))); (var b3#13 := LitInt(Mod(x1#13, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#13)), $Box(b1#13)), $Box(b2#13)), $Box(b3#13))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#12 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#12 := x0#12 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#12 := x1#12 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#12 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#13 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#13 := x0#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#13 := x1#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#13 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#12 := Div(x#0, LitInt(72057594037927936)); (var x0#12 := x#0 - Mul(b0#12, LitInt(72057594037927936)); (var b1#12 := Div(x0#12, LitInt(281474976710656)); (var x1#12 := x0#12 - Mul(b1#12, LitInt(281474976710656)); (var b2#12 := Div(x1#12, LitInt(1099511627776)); (var x2#12 := x1#12 - Mul(b2#12, LitInt(1099511627776)); (var b3#12 := Div(x2#12, LitInt(4294967296)); (var x3#12 := x2#12 - Mul(b3#12, LitInt(4294967296)); (var b4#12 := Div(x3#12, LitInt(16777216)); (var x4#12 := x3#12 - Mul(b4#12, LitInt(16777216)); (var b5#12 := Div(x4#12, LitInt(65536)); (var x5#12 := x4#12 - Mul(b5#12, LitInt(65536)); (var b6#12 := Div(x5#12, LitInt(256)); (var b7#12 := Mod(x5#12, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#12)), $Box(b1#12)), $Box(b2#12)), $Box(b3#12)), $Box(b4#12)), $Box(b5#12)), $Box(b6#12)), $Box(b7#12)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#13 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#13 := LitInt(x#0 - Mul(b0#13, LitInt(72057594037927936))); (var b1#13 := LitInt(Div(x0#13, LitInt(281474976710656))); (var x1#13 := LitInt(x0#13 - Mul(b1#13, LitInt(281474976710656))); (var b2#13 := LitInt(Div(x1#13, LitInt(1099511627776))); (var x2#13 := LitInt(x1#13 - Mul(b2#13, LitInt(1099511627776))); (var b3#13 := LitInt(Div(x2#13, LitInt(4294967296))); (var x3#13 := LitInt(x2#13 - Mul(b3#13, LitInt(4294967296))); (var b4#13 := LitInt(Div(x3#13, LitInt(16777216))); (var x4#13 := LitInt(x3#13 - Mul(b4#13, LitInt(16777216))); (var b5#13 := LitInt(Div(x4#13, LitInt(65536))); (var x5#13 := LitInt(x4#13 - Mul(b5#13, LitInt(65536))); (var b6#13 := LitInt(Div(x5#13, LitInt(256))); (var b7#13 := LitInt(Mod(x5#13, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#13)), $Box(b1#13)), $Box(b2#13)), $Box(b3#13)), $Box(b4#13)), $Box(b5#13)), $Box(b6#13)), $Box(b7#13))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#12 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#12 := x0#12 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#12 := x1#12 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#12 := x2#12 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#12 := x3#12 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#12 := x4#12 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#12 := x5#12 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#13 := x6#12 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#13)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#13 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#13 := x0#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#13 := x1#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#13 := x2#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#13 := x3#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#13 := x4#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#13 := x5#13 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#14 := x6#13 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#14)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#12 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#12)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#12 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#12)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#12)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#13 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#13)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#13 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#13)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#13)): int)));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#6: int :: { $Unbox(Seq#Index(s#0, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#7: int :: { $Unbox(Seq#Index(s#0, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#7)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#6: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#6)): int } { $Unbox(Seq#Index(s#0, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#6)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#4 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#4, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#5 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#5, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#6 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#6) && (UTF8.__default.Uses1Byte(r#6) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#6) ==> (LitInt(2) <= Seq#Length(r#6) ==> UTF8.__default.Uses2Bytes#canCall(r#6)) && (LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6)) ==> (LitInt(3) <= Seq#Length(r#6) ==> UTF8.__default.Uses3Bytes#canCall(r#6)) && (LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6)) ==> (LitInt(4) <= Seq#Length(r#6) ==> UTF8.__default.Uses4Bytes#canCall(r#6)) && (LitInt(4) <= Seq#Length(r#6) && UTF8.__default.Uses4Bytes(r#6) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#6 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#6) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#6) && UTF8.__default.Uses2Bytes(r#6) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#6) && UTF8.__default.Uses3Bytes(r#6) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#6) && UTF8.__default.Uses4Bytes(r#6) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#7 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#7) && (UTF8.__default.Uses1Byte(r#7) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#7) ==> (LitInt(2) <= Seq#Length(r#7) ==> UTF8.__default.Uses2Bytes#canCall(r#7)) && (LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7)) ==> (LitInt(3) <= Seq#Length(r#7) ==> UTF8.__default.Uses3Bytes#canCall(r#7)) && (LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7)) ==> (LitInt(4) <= Seq#Length(r#7) ==> UTF8.__default.Uses4Bytes#canCall(r#7)) && (LitInt(4) <= Seq#Length(r#7) && UTF8.__default.Uses4Bytes(r#7) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#7 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#7) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#7) && UTF8.__default.Uses2Bytes(r#7) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#7) && UTF8.__default.Uses3Bytes(r#7) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#7) && UTF8.__default.Uses4Bytes(r#7) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#8 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#8) && (UTF8.__default.Uses1Byte(r#8) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#8) ==> (LitInt(2) <= Seq#Length(r#8) ==> UTF8.__default.Uses2Bytes#canCall(r#8)) && (LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8)) ==> (LitInt(3) <= Seq#Length(r#8) ==> UTF8.__default.Uses3Bytes#canCall(r#8)) && (LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8)) ==> (LitInt(4) <= Seq#Length(r#8) ==> UTF8.__default.Uses4Bytes#canCall(r#8)) && (LitInt(4) <= Seq#Length(r#8) && UTF8.__default.Uses4Bytes(r#8) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#8 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#8) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#8) && UTF8.__default.Uses2Bytes(r#8) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#8) && UTF8.__default.Uses3Bytes(r#8) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#8) && UTF8.__default.Uses4Bytes(r#8) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#canCall(x#0) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(x#0) <==> LitInt(0) <= x#0));

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger#canCall(LitInt(x#0)) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__PositiveInteger(LitInt(x#0)) <==> LitInt(0) <= LitInt(x#0)));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#canCall(x#0) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(x#0) <==> LitInt(81) <= x#0));

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits#canCall(LitInt(x#0)) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBits(LitInt(x#0)) <==> LitInt(81) <= LitInt(x#0)));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#canCall(x#0) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(x#0) <==> LitInt(81) <= x#0 && x#0 <= LitInt(4096)));

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate#canCall(LitInt(x#0)) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__RSAModulusLengthBitsToGenerate(LitInt(x#0)) <==> LitInt(81) <= LitInt(x#0) && LitInt(x#0) <= LitInt(4096)));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#canCall(x#0) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(x#0) <==> LitInt(1) <= x#0 && x#0 <= LitInt(32)));

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength#canCall(LitInt(x#0)) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__SymmetricKeyLength(LitInt(x#0)) <==> LitInt(1) <= LitInt(x#0) && LitInt(x#0) <= LitInt(32)));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#canCall(x#0) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(x#0) <==> LitInt(0) <= x#0 && x#0 <= LitInt(255)));

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits#canCall(LitInt(x#0)) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bits(LitInt(x#0)) <==> LitInt(0) <= LitInt(x#0) && LitInt(x#0) <= LitInt(255)));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#canCall(x#0) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(x#0) <==> LitInt(0) <= x#0 && x#0 <= LitInt(32)));

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes#canCall(LitInt(x#0)) || (LitInt(-2147483648) <= x#0 && x#0 < 2147483648) ==> (AwsCryptographyPrimitivesTypes.__default.IsValid__Uint8Bytes(LitInt(x#0)) <==> LitInt(0) <= LitInt(x#0) && LitInt(x#0) <= LitInt(32)));

axiom (forall x#0: int :: { AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0) } AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(x#0) <==> 0 < x#0);

axiom (forall x#0: int :: {:weight 3} { AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(LitInt(x#0)) } AwsCryptographyPrimitivesTypes.__default.IsDummySubsetType(LitInt(x#0)) <==> Lit(0 < x#0));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput_q(d) ==> (exists a#71#0#0: Seq, a#71#1#0: int, a#71#2#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#71#0#0, a#71#1#0, a#71#2#0)));

axiom (forall a#72#0#0: Seq, a#72#1#0: int, a#72#2#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#72#0#0, a#72#1#0, a#72#2#0), Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) } $Is(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#72#0#0, a#72#1#0, a#72#2#0), Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) <==> $Is(a#72#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#72#1#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) && $Is(a#72#2#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall a#73#0#0: Seq, a#73#1#0: int, a#73#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(Lit(a#73#0#0), LitInt(a#73#1#0), Lit(a#73#2#0)) } #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(Lit(a#73#0#0), LitInt(a#73#1#0), Lit(a#73#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#73#0#0, a#73#1#0, a#73#2#0)));

axiom (forall a#74#0#0: Seq, a#74#1#0: int, a#74#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#74#0#0, a#74#1#0, a#74#2#0) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.ikm(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#74#0#0, a#74#1#0, a#74#2#0)) == a#74#0#0);

axiom (forall a#75#0#0: Seq, a#75#1#0: int, a#75#2#0: DatatypeType, i: int :: { Seq#Index(a#75#0#0, i), #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#75#0#0, a#75#1#0, a#75#2#0) } 0 <= i && i < Seq#Length(a#75#0#0) ==> DtRank($Unbox(Seq#Index(a#75#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#75#0#0, a#75#1#0, a#75#2#0)));

axiom (forall a#76#0#0: Seq, a#76#1#0: int, a#76#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#76#0#0, a#76#1#0, a#76#2#0) } Seq#Rank(a#76#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#76#0#0, a#76#1#0, a#76#2#0)));

axiom (forall a#77#0#0: Seq, a#77#1#0: int, a#77#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#77#0#0, a#77#1#0, a#77#2#0) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.expectedLength(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#77#0#0, a#77#1#0, a#77#2#0)) == a#77#1#0);

axiom (forall a#78#0#0: Seq, a#78#1#0: int, a#78#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#78#0#0, a#78#1#0, a#78#2#0) } AwsCryptographyPrimitivesTypes.AesKdfCtrInput.nonce(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#78#0#0, a#78#1#0, a#78#2#0)) == a#78#2#0);

axiom (forall a#79#0#0: Seq, a#79#1#0: int, a#79#2#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#79#0#0, a#79#1#0, a#79#2#0) } DtRank(a#79#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.AesKdfCtrInput.AesKdfCtrInput(a#79#0#0, a#79#1#0, a#79#2#0)));

axiom (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o) } $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o), TSet(Tclass._System.object())));

axiom (forall $h: Heap, $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($o), TSet(Tclass._System.object()), $h));

axiom (forall this: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient())) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))]);

axiom (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o) } $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory()));

axiom (forall $h: Heap, $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient?()) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($o), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), $h));

axiom (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this, input#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this, input#0) || (0 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (0 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput_q(d) ==> (exists a#234#0#0: DatatypeType, a#234#1#0: DatatypeType, a#234#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#234#0#0, a#234#1#0, a#234#2#0)));

axiom (forall a#235#0#0: DatatypeType, a#235#1#0: DatatypeType, a#235#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#235#0#0, a#235#1#0, a#235#2#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) } $Is(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#235#0#0, a#235#1#0, a#235#2#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) <==> $Is(a#235#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#235#1#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))) && $Is(a#235#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#236#0#0: DatatypeType, a#236#1#0: DatatypeType, a#236#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(Lit(a#236#0#0), Lit(a#236#1#0), Lit(a#236#2#0)) } #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(Lit(a#236#0#0), Lit(a#236#1#0), Lit(a#236#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#236#0#0, a#236#1#0, a#236#2#0)));

axiom (forall a#237#0#0: DatatypeType, a#237#1#0: DatatypeType, a#237#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#237#0#0, a#237#1#0, a#237#2#0) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#237#0#0, a#237#1#0, a#237#2#0)) == a#237#0#0);

axiom (forall a#238#0#0: DatatypeType, a#238#1#0: DatatypeType, a#238#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#238#0#0, a#238#1#0, a#238#2#0) } DtRank(a#238#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#238#0#0, a#238#1#0, a#238#2#0)));

axiom (forall a#239#0#0: DatatypeType, a#239#1#0: DatatypeType, a#239#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#239#0#0, a#239#1#0, a#239#2#0) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.salt(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#239#0#0, a#239#1#0, a#239#2#0)) == a#239#1#0);

axiom (forall a#240#0#0: DatatypeType, a#240#1#0: DatatypeType, a#240#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#240#0#0, a#240#1#0, a#240#2#0) } DtRank(a#240#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#240#0#0, a#240#1#0, a#240#2#0)));

axiom (forall a#241#0#0: DatatypeType, a#241#1#0: DatatypeType, a#241#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#241#0#0, a#241#1#0, a#241#2#0) } AwsCryptographyPrimitivesTypes.HkdfExtractInput.ikm(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#241#0#0, a#241#1#0, a#241#2#0)) == a#241#2#0);

axiom (forall a#242#0#0: DatatypeType, a#242#1#0: DatatypeType, a#242#2#0: Seq, i: int :: { Seq#Index(a#242#2#0, i), #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#242#0#0, a#242#1#0, a#242#2#0) } 0 <= i && i < Seq#Length(a#242#2#0) ==> DtRank($Unbox(Seq#Index(a#242#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#242#0#0, a#242#1#0, a#242#2#0)));

axiom (forall a#243#0#0: DatatypeType, a#243#1#0: DatatypeType, a#243#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#243#0#0, a#243#1#0, a#243#2#0) } Seq#Rank(a#243#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfExtractInput.HkdfExtractInput(a#243#0#0, a#243#1#0, a#243#2#0)));

axiom (forall a#244#0#0: DatatypeType, a#244#1#0: DatatypeType, a#244#2#0: Seq, a#244#3#0: Seq, a#244#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#244#0#0, a#244#1#0, a#244#2#0, a#244#3#0, a#244#4#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#244#0#0, a#244#1#0, a#244#2#0, a#244#3#0, a#244#4#0)) == ##AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) } AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput_q(d) ==> (exists a#245#0#0: DatatypeType, a#245#1#0: DatatypeType, a#245#2#0: Seq, a#245#3#0: Seq, a#245#4#0: int :: d == #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#245#0#0, a#245#1#0, a#245#2#0, a#245#3#0, a#245#4#0)));

axiom (forall a#246#0#0: DatatypeType, a#246#1#0: DatatypeType, a#246#2#0: Seq, a#246#3#0: Seq, a#246#4#0: int :: { $Is(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#246#0#0, a#246#1#0, a#246#2#0, a#246#3#0, a#246#4#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) } $Is(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#246#0#0, a#246#1#0, a#246#2#0, a#246#3#0, a#246#4#0), Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) <==> $Is(a#246#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#246#1#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))) && $Is(a#246#2#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#246#3#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#246#4#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()));

axiom (forall a#247#0#0: DatatypeType, a#247#1#0: DatatypeType, a#247#2#0: Seq, a#247#3#0: Seq, a#247#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(Lit(a#247#0#0), Lit(a#247#1#0), Lit(a#247#2#0), Lit(a#247#3#0), LitInt(a#247#4#0)) } #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(Lit(a#247#0#0), Lit(a#247#1#0), Lit(a#247#2#0), Lit(a#247#3#0), LitInt(a#247#4#0)) == Lit(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#247#0#0, a#247#1#0, a#247#2#0, a#247#3#0, a#247#4#0)));

axiom (forall a#248#0#0: DatatypeType, a#248#1#0: DatatypeType, a#248#2#0: Seq, a#248#3#0: Seq, a#248#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#248#0#0, a#248#1#0, a#248#2#0, a#248#3#0, a#248#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#248#0#0, a#248#1#0, a#248#2#0, a#248#3#0, a#248#4#0)) == a#248#0#0);

axiom (forall a#249#0#0: DatatypeType, a#249#1#0: DatatypeType, a#249#2#0: Seq, a#249#3#0: Seq, a#249#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#249#0#0, a#249#1#0, a#249#2#0, a#249#3#0, a#249#4#0) } DtRank(a#249#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#249#0#0, a#249#1#0, a#249#2#0, a#249#3#0, a#249#4#0)));

axiom (forall a#250#0#0: DatatypeType, a#250#1#0: DatatypeType, a#250#2#0: Seq, a#250#3#0: Seq, a#250#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#250#0#0, a#250#1#0, a#250#2#0, a#250#3#0, a#250#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.salt(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#250#0#0, a#250#1#0, a#250#2#0, a#250#3#0, a#250#4#0)) == a#250#1#0);

axiom (forall a#251#0#0: DatatypeType, a#251#1#0: DatatypeType, a#251#2#0: Seq, a#251#3#0: Seq, a#251#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#251#0#0, a#251#1#0, a#251#2#0, a#251#3#0, a#251#4#0) } DtRank(a#251#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#251#0#0, a#251#1#0, a#251#2#0, a#251#3#0, a#251#4#0)));

axiom (forall a#252#0#0: DatatypeType, a#252#1#0: DatatypeType, a#252#2#0: Seq, a#252#3#0: Seq, a#252#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#252#0#0, a#252#1#0, a#252#2#0, a#252#3#0, a#252#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.ikm(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#252#0#0, a#252#1#0, a#252#2#0, a#252#3#0, a#252#4#0)) == a#252#2#0);

axiom (forall a#253#0#0: DatatypeType, a#253#1#0: DatatypeType, a#253#2#0: Seq, a#253#3#0: Seq, a#253#4#0: int, i: int :: { Seq#Index(a#253#2#0, i), #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#253#0#0, a#253#1#0, a#253#2#0, a#253#3#0, a#253#4#0) } 0 <= i && i < Seq#Length(a#253#2#0) ==> DtRank($Unbox(Seq#Index(a#253#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#253#0#0, a#253#1#0, a#253#2#0, a#253#3#0, a#253#4#0)));

axiom (forall a#254#0#0: DatatypeType, a#254#1#0: DatatypeType, a#254#2#0: Seq, a#254#3#0: Seq, a#254#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#254#0#0, a#254#1#0, a#254#2#0, a#254#3#0, a#254#4#0) } Seq#Rank(a#254#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#254#0#0, a#254#1#0, a#254#2#0, a#254#3#0, a#254#4#0)));

axiom (forall a#255#0#0: DatatypeType, a#255#1#0: DatatypeType, a#255#2#0: Seq, a#255#3#0: Seq, a#255#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#255#0#0, a#255#1#0, a#255#2#0, a#255#3#0, a#255#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.info(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#255#0#0, a#255#1#0, a#255#2#0, a#255#3#0, a#255#4#0)) == a#255#3#0);

axiom (forall a#256#0#0: DatatypeType, a#256#1#0: DatatypeType, a#256#2#0: Seq, a#256#3#0: Seq, a#256#4#0: int, i: int :: { Seq#Index(a#256#3#0, i), #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#256#0#0, a#256#1#0, a#256#2#0, a#256#3#0, a#256#4#0) } 0 <= i && i < Seq#Length(a#256#3#0) ==> DtRank($Unbox(Seq#Index(a#256#3#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#256#0#0, a#256#1#0, a#256#2#0, a#256#3#0, a#256#4#0)));

axiom (forall a#257#0#0: DatatypeType, a#257#1#0: DatatypeType, a#257#2#0: Seq, a#257#3#0: Seq, a#257#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#257#0#0, a#257#1#0, a#257#2#0, a#257#3#0, a#257#4#0) } Seq#Rank(a#257#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#257#0#0, a#257#1#0, a#257#2#0, a#257#3#0, a#257#4#0)));

axiom (forall a#258#0#0: DatatypeType, a#258#1#0: DatatypeType, a#258#2#0: Seq, a#258#3#0: Seq, a#258#4#0: int :: { #AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#258#0#0, a#258#1#0, a#258#2#0, a#258#3#0, a#258#4#0) } AwsCryptographyPrimitivesTypes.HkdfInput.expectedLength(#AwsCryptographyPrimitivesTypes.HkdfInput.HkdfInput(a#258#0#0, a#258#1#0, a#258#2#0, a#258#3#0, a#258#4#0)) == a#258#4#0);

axiom (forall a#259#0#0: DatatypeType, a#259#1#0: Seq, a#259#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#259#0#0, a#259#1#0, a#259#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#259#0#0, a#259#1#0, a#259#2#0)) == ##AwsCryptographyPrimitivesTypes.HMacInput.HMacInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) } AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(d) ==> (exists a#260#0#0: DatatypeType, a#260#1#0: Seq, a#260#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#260#0#0, a#260#1#0, a#260#2#0)));

axiom (forall a#261#0#0: DatatypeType, a#261#1#0: Seq, a#261#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#261#0#0, a#261#1#0, a#261#2#0), Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) } $Is(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#261#0#0, a#261#1#0, a#261#2#0), Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) <==> $Is(a#261#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#261#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#261#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#262#0#0: DatatypeType, a#262#1#0: Seq, a#262#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(Lit(a#262#0#0), Lit(a#262#1#0), Lit(a#262#2#0)) } #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(Lit(a#262#0#0), Lit(a#262#1#0), Lit(a#262#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#262#0#0, a#262#1#0, a#262#2#0)));

axiom (forall a#263#0#0: DatatypeType, a#263#1#0: Seq, a#263#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#263#0#0, a#263#1#0, a#263#2#0) } AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#263#0#0, a#263#1#0, a#263#2#0)) == a#263#0#0);

axiom (forall a#264#0#0: DatatypeType, a#264#1#0: Seq, a#264#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#264#0#0, a#264#1#0, a#264#2#0) } DtRank(a#264#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#264#0#0, a#264#1#0, a#264#2#0)));

axiom (forall a#265#0#0: DatatypeType, a#265#1#0: Seq, a#265#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#265#0#0, a#265#1#0, a#265#2#0) } AwsCryptographyPrimitivesTypes.HMacInput.key(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#265#0#0, a#265#1#0, a#265#2#0)) == a#265#1#0);

axiom (forall a#266#0#0: DatatypeType, a#266#1#0: Seq, a#266#2#0: Seq, i: int :: { Seq#Index(a#266#1#0, i), #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#266#0#0, a#266#1#0, a#266#2#0) } 0 <= i && i < Seq#Length(a#266#1#0) ==> DtRank($Unbox(Seq#Index(a#266#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#266#0#0, a#266#1#0, a#266#2#0)));

axiom (forall a#267#0#0: DatatypeType, a#267#1#0: Seq, a#267#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#267#0#0, a#267#1#0, a#267#2#0) } Seq#Rank(a#267#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#267#0#0, a#267#1#0, a#267#2#0)));

axiom (forall a#268#0#0: DatatypeType, a#268#1#0: Seq, a#268#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#268#0#0, a#268#1#0, a#268#2#0) } AwsCryptographyPrimitivesTypes.HMacInput.message(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#268#0#0, a#268#1#0, a#268#2#0)) == a#268#2#0);

axiom (forall a#269#0#0: DatatypeType, a#269#1#0: Seq, a#269#2#0: Seq, i: int :: { Seq#Index(a#269#2#0, i), #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#269#0#0, a#269#1#0, a#269#2#0) } 0 <= i && i < Seq#Length(a#269#2#0) ==> DtRank($Unbox(Seq#Index(a#269#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#269#0#0, a#269#1#0, a#269#2#0)));

axiom (forall a#270#0#0: DatatypeType, a#270#1#0: Seq, a#270#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#270#0#0, a#270#1#0, a#270#2#0) } Seq#Rank(a#270#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.HMacInput.HMacInput(a#270#0#0, a#270#1#0, a#270#2#0)));

axiom (forall a#271#0#0: DatatypeType, a#271#1#0: Seq, a#271#2#0: int, a#271#3#0: DatatypeType, a#271#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#271#0#0, a#271#1#0, a#271#2#0, a#271#3#0, a#271#4#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#271#0#0, a#271#1#0, a#271#2#0, a#271#3#0, a#271#4#0)) == ##AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) } AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(d) ==> (exists a#272#0#0: DatatypeType, a#272#1#0: Seq, a#272#2#0: int, a#272#3#0: DatatypeType, a#272#4#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#272#0#0, a#272#1#0, a#272#2#0, a#272#3#0, a#272#4#0)));

axiom (forall a#273#0#0: DatatypeType, a#273#1#0: Seq, a#273#2#0: int, a#273#3#0: DatatypeType, a#273#4#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#273#0#0, a#273#1#0, a#273#2#0, a#273#3#0, a#273#4#0), Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) } $Is(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#273#0#0, a#273#1#0, a#273#2#0, a#273#3#0, a#273#4#0), Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) <==> $Is(a#273#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $Is(a#273#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#273#2#0, Tclass.AwsCryptographyPrimitivesTypes.PositiveInteger()) && $Is(a#273#3#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))) && $Is(a#273#4#0, Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall a#274#0#0: DatatypeType, a#274#1#0: Seq, a#274#2#0: int, a#274#3#0: DatatypeType, a#274#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(Lit(a#274#0#0), Lit(a#274#1#0), LitInt(a#274#2#0), Lit(a#274#3#0), Lit(a#274#4#0)) } #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(Lit(a#274#0#0), Lit(a#274#1#0), LitInt(a#274#2#0), Lit(a#274#3#0), Lit(a#274#4#0)) == Lit(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#274#0#0, a#274#1#0, a#274#2#0, a#274#3#0, a#274#4#0)));

axiom (forall a#275#0#0: DatatypeType, a#275#1#0: Seq, a#275#2#0: int, a#275#3#0: DatatypeType, a#275#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#275#0#0, a#275#1#0, a#275#2#0, a#275#3#0, a#275#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#275#0#0, a#275#1#0, a#275#2#0, a#275#3#0, a#275#4#0)) == a#275#0#0);

axiom (forall a#276#0#0: DatatypeType, a#276#1#0: Seq, a#276#2#0: int, a#276#3#0: DatatypeType, a#276#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#276#0#0, a#276#1#0, a#276#2#0, a#276#3#0, a#276#4#0) } DtRank(a#276#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#276#0#0, a#276#1#0, a#276#2#0, a#276#3#0, a#276#4#0)));

axiom (forall a#277#0#0: DatatypeType, a#277#1#0: Seq, a#277#2#0: int, a#277#3#0: DatatypeType, a#277#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#277#0#0, a#277#1#0, a#277#2#0, a#277#3#0, a#277#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#277#0#0, a#277#1#0, a#277#2#0, a#277#3#0, a#277#4#0)) == a#277#1#0);

axiom (forall a#278#0#0: DatatypeType, a#278#1#0: Seq, a#278#2#0: int, a#278#3#0: DatatypeType, a#278#4#0: DatatypeType, i: int :: { Seq#Index(a#278#1#0, i), #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#278#0#0, a#278#1#0, a#278#2#0, a#278#3#0, a#278#4#0) } 0 <= i && i < Seq#Length(a#278#1#0) ==> DtRank($Unbox(Seq#Index(a#278#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#278#0#0, a#278#1#0, a#278#2#0, a#278#3#0, a#278#4#0)));

axiom (forall a#279#0#0: DatatypeType, a#279#1#0: Seq, a#279#2#0: int, a#279#3#0: DatatypeType, a#279#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#279#0#0, a#279#1#0, a#279#2#0, a#279#3#0, a#279#4#0) } Seq#Rank(a#279#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#279#0#0, a#279#1#0, a#279#2#0, a#279#3#0, a#279#4#0)));

axiom (forall a#280#0#0: DatatypeType, a#280#1#0: Seq, a#280#2#0: int, a#280#3#0: DatatypeType, a#280#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#280#0#0, a#280#1#0, a#280#2#0, a#280#3#0, a#280#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#280#0#0, a#280#1#0, a#280#2#0, a#280#3#0, a#280#4#0)) == a#280#2#0);

axiom (forall a#281#0#0: DatatypeType, a#281#1#0: Seq, a#281#2#0: int, a#281#3#0: DatatypeType, a#281#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#281#0#0, a#281#1#0, a#281#2#0, a#281#3#0, a#281#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#281#0#0, a#281#1#0, a#281#2#0, a#281#3#0, a#281#4#0)) == a#281#3#0);

axiom (forall a#282#0#0: DatatypeType, a#282#1#0: Seq, a#282#2#0: int, a#282#3#0: DatatypeType, a#282#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#282#0#0, a#282#1#0, a#282#2#0, a#282#3#0, a#282#4#0) } DtRank(a#282#3#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#282#0#0, a#282#1#0, a#282#2#0, a#282#3#0, a#282#4#0)));

axiom (forall a#283#0#0: DatatypeType, a#283#1#0: Seq, a#283#2#0: int, a#283#3#0: DatatypeType, a#283#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#283#0#0, a#283#1#0, a#283#2#0, a#283#3#0, a#283#4#0) } AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#283#0#0, a#283#1#0, a#283#2#0, a#283#3#0, a#283#4#0)) == a#283#4#0);

axiom (forall a#284#0#0: DatatypeType, a#284#1#0: Seq, a#284#2#0: int, a#284#3#0: DatatypeType, a#284#4#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#284#0#0, a#284#1#0, a#284#2#0, a#284#3#0, a#284#4#0) } DtRank(a#284#4#0) < DtRank(#AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput(a#284#0#0, a#284#1#0, a#284#2#0, a#284#3#0, a#284#4#0)));

axiom (forall a#285#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#285#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#285#0#0)) == ##AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput_q(d) ==> (exists a#286#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#286#0#0)));

axiom (forall a#287#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#287#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#287#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) <==> $Is(a#287#0#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#288#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(Lit(a#288#0#0)) } #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(Lit(a#288#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#288#0#0)));

axiom (forall a#289#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#289#0#0) } AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.publicKey(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#289#0#0)) == a#289#0#0);

axiom (forall a#290#0#0: Seq, i: int :: { Seq#Index(a#290#0#0, i), #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#290#0#0) } 0 <= i && i < Seq#Length(a#290#0#0) ==> DtRank($Unbox(Seq#Index(a#290#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#290#0#0)));

axiom (forall a#291#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#291#0#0) } Seq#Rank(a#291#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput.ParsePublicKeyInput(a#291#0#0)));

axiom (forall a#292#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#292#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#292#0#0)) == ##AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput_q(d) ==> (exists a#293#0#0: DatatypeType :: d == #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#293#0#0)));

axiom (forall a#294#0#0: DatatypeType :: { $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#294#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#294#0#0), Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput()) <==> $Is(a#294#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECCPublicKey()));

axiom (forall a#295#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(Lit(a#295#0#0)) } #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(Lit(a#295#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#295#0#0)));

axiom (forall a#296#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#296#0#0) } AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.publicKey(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#296#0#0)) == a#296#0#0);

axiom (forall a#297#0#0: DatatypeType :: { #AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#297#0#0) } DtRank(a#297#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput.ParsePublicKeyOutput(a#297#0#0)));

axiom (forall a#298#0#0: DatatypeType, a#298#1#0: Seq, a#298#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#298#0#0, a#298#1#0, a#298#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#298#0#0, a#298#1#0, a#298#2#0)) == ##AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) } AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput_q(d) ==> (exists a#299#0#0: DatatypeType, a#299#1#0: Seq, a#299#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#299#0#0, a#299#1#0, a#299#2#0)));

axiom (forall a#300#0#0: DatatypeType, a#300#1#0: Seq, a#300#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#300#0#0, a#300#1#0, a#300#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) } $Is(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#300#0#0, a#300#1#0, a#300#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) <==> $Is(a#300#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) && $Is(a#300#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#300#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#301#0#0: DatatypeType, a#301#1#0: Seq, a#301#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(Lit(a#301#0#0), Lit(a#301#1#0), Lit(a#301#2#0)) } #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(Lit(a#301#0#0), Lit(a#301#1#0), Lit(a#301#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#301#0#0, a#301#1#0, a#301#2#0)));

axiom (forall a#302#0#0: DatatypeType, a#302#1#0: Seq, a#302#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#302#0#0, a#302#1#0, a#302#2#0) } AwsCryptographyPrimitivesTypes.RSADecryptInput.padding(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#302#0#0, a#302#1#0, a#302#2#0)) == a#302#0#0);

axiom (forall a#303#0#0: DatatypeType, a#303#1#0: Seq, a#303#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#303#0#0, a#303#1#0, a#303#2#0) } DtRank(a#303#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#303#0#0, a#303#1#0, a#303#2#0)));

axiom (forall a#304#0#0: DatatypeType, a#304#1#0: Seq, a#304#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#304#0#0, a#304#1#0, a#304#2#0) } AwsCryptographyPrimitivesTypes.RSADecryptInput.privateKey(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#304#0#0, a#304#1#0, a#304#2#0)) == a#304#1#0);

axiom (forall a#305#0#0: DatatypeType, a#305#1#0: Seq, a#305#2#0: Seq, i: int :: { Seq#Index(a#305#1#0, i), #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#305#0#0, a#305#1#0, a#305#2#0) } 0 <= i && i < Seq#Length(a#305#1#0) ==> DtRank($Unbox(Seq#Index(a#305#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#305#0#0, a#305#1#0, a#305#2#0)));

axiom (forall a#306#0#0: DatatypeType, a#306#1#0: Seq, a#306#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#306#0#0, a#306#1#0, a#306#2#0) } Seq#Rank(a#306#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#306#0#0, a#306#1#0, a#306#2#0)));

axiom (forall a#307#0#0: DatatypeType, a#307#1#0: Seq, a#307#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#307#0#0, a#307#1#0, a#307#2#0) } AwsCryptographyPrimitivesTypes.RSADecryptInput.cipherText(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#307#0#0, a#307#1#0, a#307#2#0)) == a#307#2#0);

axiom (forall a#308#0#0: DatatypeType, a#308#1#0: Seq, a#308#2#0: Seq, i: int :: { Seq#Index(a#308#2#0, i), #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#308#0#0, a#308#1#0, a#308#2#0) } 0 <= i && i < Seq#Length(a#308#2#0) ==> DtRank($Unbox(Seq#Index(a#308#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#308#0#0, a#308#1#0, a#308#2#0)));

axiom (forall a#309#0#0: DatatypeType, a#309#1#0: Seq, a#309#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#309#0#0, a#309#1#0, a#309#2#0) } Seq#Rank(a#309#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSADecryptInput.RSADecryptInput(a#309#0#0, a#309#1#0, a#309#2#0)));

axiom (forall a#310#0#0: DatatypeType, a#310#1#0: Seq, a#310#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#310#0#0, a#310#1#0, a#310#2#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#310#0#0, a#310#1#0, a#310#2#0)) == ##AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput_q(d) ==> (exists a#311#0#0: DatatypeType, a#311#1#0: Seq, a#311#2#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#311#0#0, a#311#1#0, a#311#2#0)));

axiom (forall a#312#0#0: DatatypeType, a#312#1#0: Seq, a#312#2#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#312#0#0, a#312#1#0, a#312#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) } $Is(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#312#0#0, a#312#1#0, a#312#2#0), Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) <==> $Is(a#312#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAPaddingMode()) && $Is(a#312#1#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#312#2#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#313#0#0: DatatypeType, a#313#1#0: Seq, a#313#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(Lit(a#313#0#0), Lit(a#313#1#0), Lit(a#313#2#0)) } #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(Lit(a#313#0#0), Lit(a#313#1#0), Lit(a#313#2#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#313#0#0, a#313#1#0, a#313#2#0)));

axiom (forall a#314#0#0: DatatypeType, a#314#1#0: Seq, a#314#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#314#0#0, a#314#1#0, a#314#2#0) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.padding(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#314#0#0, a#314#1#0, a#314#2#0)) == a#314#0#0);

axiom (forall a#315#0#0: DatatypeType, a#315#1#0: Seq, a#315#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#315#0#0, a#315#1#0, a#315#2#0) } DtRank(a#315#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#315#0#0, a#315#1#0, a#315#2#0)));

axiom (forall a#316#0#0: DatatypeType, a#316#1#0: Seq, a#316#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#316#0#0, a#316#1#0, a#316#2#0) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.publicKey(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#316#0#0, a#316#1#0, a#316#2#0)) == a#316#1#0);

axiom (forall a#317#0#0: DatatypeType, a#317#1#0: Seq, a#317#2#0: Seq, i: int :: { Seq#Index(a#317#1#0, i), #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#317#0#0, a#317#1#0, a#317#2#0) } 0 <= i && i < Seq#Length(a#317#1#0) ==> DtRank($Unbox(Seq#Index(a#317#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#317#0#0, a#317#1#0, a#317#2#0)));

axiom (forall a#318#0#0: DatatypeType, a#318#1#0: Seq, a#318#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#318#0#0, a#318#1#0, a#318#2#0) } Seq#Rank(a#318#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#318#0#0, a#318#1#0, a#318#2#0)));

axiom (forall a#319#0#0: DatatypeType, a#319#1#0: Seq, a#319#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#319#0#0, a#319#1#0, a#319#2#0) } AwsCryptographyPrimitivesTypes.RSAEncryptInput.plaintext(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#319#0#0, a#319#1#0, a#319#2#0)) == a#319#2#0);

axiom (forall a#320#0#0: DatatypeType, a#320#1#0: Seq, a#320#2#0: Seq, i: int :: { Seq#Index(a#320#2#0, i), #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#320#0#0, a#320#1#0, a#320#2#0) } 0 <= i && i < Seq#Length(a#320#2#0) ==> DtRank($Unbox(Seq#Index(a#320#2#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#320#0#0, a#320#1#0, a#320#2#0)));

axiom (forall a#321#0#0: DatatypeType, a#321#1#0: Seq, a#321#2#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#321#0#0, a#321#1#0, a#321#2#0) } Seq#Rank(a#321#2#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAEncryptInput.RSAEncryptInput(a#321#0#0, a#321#1#0, a#321#2#0)));

axiom (forall a#342#0#0: int, a#342#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#342#0#0, a#342#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#342#0#0, a#342#1#0)) == ##AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey_q(d) ==> (exists a#343#0#0: int, a#343#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#343#0#0, a#343#1#0)));

axiom (forall a#344#0#0: int, a#344#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#344#0#0, a#344#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) } $Is(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#344#0#0, a#344#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPrivateKey()) <==> $Is(a#344#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) && $Is(a#344#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#345#0#0: int, a#345#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(LitInt(a#345#0#0), Lit(a#345#1#0)) } #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(LitInt(a#345#0#0), Lit(a#345#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#345#0#0, a#345#1#0)));

axiom (forall a#346#0#0: int, a#346#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#346#0#0, a#346#1#0) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.lengthBits(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#346#0#0, a#346#1#0)) == a#346#0#0);

axiom (forall a#347#0#0: int, a#347#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#347#0#0, a#347#1#0) } AwsCryptographyPrimitivesTypes.RSAPrivateKey.pem(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#347#0#0, a#347#1#0)) == a#347#1#0);

axiom (forall a#348#0#0: int, a#348#1#0: Seq, i: int :: { Seq#Index(a#348#1#0, i), #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#348#0#0, a#348#1#0) } 0 <= i && i < Seq#Length(a#348#1#0) ==> DtRank($Unbox(Seq#Index(a#348#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#348#0#0, a#348#1#0)));

axiom (forall a#349#0#0: int, a#349#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#349#0#0, a#349#1#0) } Seq#Rank(a#349#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPrivateKey.RSAPrivateKey(a#349#0#0, a#349#1#0)));

axiom (forall a#350#0#0: int, a#350#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#350#0#0, a#350#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#350#0#0, a#350#1#0)) == ##AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) } AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey_q(d) ==> (exists a#351#0#0: int, a#351#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#351#0#0, a#351#1#0)));

axiom (forall a#352#0#0: int, a#352#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#352#0#0, a#352#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) } $Is(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#352#0#0, a#352#1#0), Tclass.AwsCryptographyPrimitivesTypes.RSAPublicKey()) <==> $Is(a#352#0#0, Tclass.AwsCryptographyPrimitivesTypes.RSAModulusLengthBits()) && $Is(a#352#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#353#0#0: int, a#353#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(LitInt(a#353#0#0), Lit(a#353#1#0)) } #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(LitInt(a#353#0#0), Lit(a#353#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#353#0#0, a#353#1#0)));

axiom (forall a#354#0#0: int, a#354#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#354#0#0, a#354#1#0) } AwsCryptographyPrimitivesTypes.RSAPublicKey.lengthBits(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#354#0#0, a#354#1#0)) == a#354#0#0);

axiom (forall a#355#0#0: int, a#355#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#355#0#0, a#355#1#0) } AwsCryptographyPrimitivesTypes.RSAPublicKey.pem(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#355#0#0, a#355#1#0)) == a#355#1#0);

axiom (forall a#356#0#0: int, a#356#1#0: Seq, i: int :: { Seq#Index(a#356#1#0, i), #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#356#0#0, a#356#1#0) } 0 <= i && i < Seq#Length(a#356#1#0) ==> DtRank($Unbox(Seq#Index(a#356#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#356#0#0, a#356#1#0)));

axiom (forall a#357#0#0: int, a#357#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#357#0#0, a#357#1#0) } Seq#Rank(a#357#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.RSAPublicKey.RSAPublicKey(a#357#0#0, a#357#1#0)));

axiom (forall a#358#0#0: DatatypeType, a#358#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#358#0#0, a#358#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#358#0#0, a#358#1#0)) == ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput_q(d) ==> (exists a#359#0#0: DatatypeType, a#359#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#359#0#0, a#359#1#0)));

axiom (forall a#360#0#0: DatatypeType, a#360#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#360#0#0, a#360#1#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) } $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#360#0#0, a#360#1#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) <==> $Is(a#360#0#0, Tclass.AwsCryptographyPrimitivesTypes.ECDHCurveSpec()) && $Is(a#360#1#0, TSeq(Tclass.BoundedInts.uint8())));

axiom (forall a#361#0#0: DatatypeType, a#361#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(Lit(a#361#0#0), Lit(a#361#1#0)) } #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(Lit(a#361#0#0), Lit(a#361#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#361#0#0, a#361#1#0)));

axiom (forall a#362#0#0: DatatypeType, a#362#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#362#0#0, a#362#1#0) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.eccCurve(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#362#0#0, a#362#1#0)) == a#362#0#0);

axiom (forall a#363#0#0: DatatypeType, a#363#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#363#0#0, a#363#1#0) } DtRank(a#363#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#363#0#0, a#363#1#0)));

axiom (forall a#364#0#0: DatatypeType, a#364#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#364#0#0, a#364#1#0) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.publicKey(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#364#0#0, a#364#1#0)) == a#364#1#0);

axiom (forall a#365#0#0: DatatypeType, a#365#1#0: Seq, i: int :: { Seq#Index(a#365#1#0, i), #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#365#0#0, a#365#1#0) } 0 <= i && i < Seq#Length(a#365#1#0) ==> DtRank($Unbox(Seq#Index(a#365#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#365#0#0, a#365#1#0)));

axiom (forall a#366#0#0: DatatypeType, a#366#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#366#0#0, a#366#1#0) } Seq#Rank(a#366#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput.ValidatePublicKeyInput(a#366#0#0, a#366#1#0)));

axiom (forall a#367#0#0: bool :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#367#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#367#0#0)) == ##AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput_q(d) ==> (exists a#368#0#0: bool :: d == #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#368#0#0)));

axiom (forall a#369#0#0: bool :: { $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#369#0#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) } $Is(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#369#0#0), Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput()) <==> $Is(a#369#0#0, TBool));

axiom (forall a#370#0#0: bool :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(Lit(a#370#0#0)) } #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(Lit(a#370#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#370#0#0)));

axiom (forall a#371#0#0: bool :: { #AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#371#0#0) } AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.success(#AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput.ValidatePublicKeyOutput(a#371#0#0)) <==> a#371#0#0);

axiom (forall a#372#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#372#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#372#0#0)) == ##AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) } AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError_q(d) ==> (exists a#373#0#0: Seq :: d == #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#373#0#0)));

axiom (forall a#374#0#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#374#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#374#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#374#0#0, TSeq(TChar)));

axiom (forall a#374#0#0: Seq, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#374#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#374#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#374#0#0, TSeq(TChar), $h)));

axiom (forall a#375#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(a#375#0#0)) } #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(a#375#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#375#0#0)));

axiom (forall a#376#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#376#0#0) } AwsCryptographyPrimitivesTypes.Error.message(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#376#0#0)) == a#376#0#0);

axiom (forall a#377#0#0: Seq, i: int :: { Seq#Index(a#377#0#0, i), #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#377#0#0) } 0 <= i && i < Seq#Length(a#377#0#0) ==> DtRank($Unbox(Seq#Index(a#377#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#377#0#0)));

axiom (forall a#378#0#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#378#0#0) } Seq#Rank(a#378#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(a#378#0#0)));

axiom (forall a#379#0#0: Seq, a#379#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#379#0#0, a#379#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#379#0#0, a#379#1#0)) == ##AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) } AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors_q(d) ==> (exists a#380#0#0: Seq, a#380#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#380#0#0, a#380#1#0)));

axiom (forall a#381#0#0: Seq, a#381#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#381#0#0, a#381#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#381#0#0, a#381#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#381#0#0, TSeq(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $Is(a#381#1#0, TSeq(TChar)));

axiom (forall a#381#0#0: Seq, a#381#1#0: Seq, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#381#0#0, a#381#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#381#0#0, a#381#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#381#0#0, TSeq(Tclass.AwsCryptographyPrimitivesTypes.Error()), $h) && $IsAlloc(a#381#1#0, TSeq(TChar), $h)));

axiom (forall a#382#0#0: Seq, a#382#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(Lit(a#382#0#0), Lit(a#382#1#0)) } #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(Lit(a#382#0#0), Lit(a#382#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#382#0#0, a#382#1#0)));

axiom (forall a#383#0#0: Seq, a#383#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#383#0#0, a#383#1#0) } AwsCryptographyPrimitivesTypes.Error.list(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#383#0#0, a#383#1#0)) == a#383#0#0);

axiom (forall a#384#0#0: Seq, a#384#1#0: Seq, i: int :: { Seq#Index(a#384#0#0, i), #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#384#0#0, a#384#1#0) } 0 <= i && i < Seq#Length(a#384#0#0) ==> DtRank($Unbox(Seq#Index(a#384#0#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#384#0#0, a#384#1#0)));

axiom (forall a#385#0#0: Seq, a#385#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#385#0#0, a#385#1#0) } Seq#Rank(a#385#0#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#385#0#0, a#385#1#0)));

axiom (forall a#386#0#0: Seq, a#386#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#386#0#0, a#386#1#0) } AwsCryptographyPrimitivesTypes.Error.message(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#386#0#0, a#386#1#0)) == a#386#1#0);

axiom (forall a#387#0#0: Seq, a#387#1#0: Seq, i: int :: { Seq#Index(a#387#1#0, i), #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#387#0#0, a#387#1#0) } 0 <= i && i < Seq#Length(a#387#1#0) ==> DtRank($Unbox(Seq#Index(a#387#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#387#0#0, a#387#1#0)));

axiom (forall a#388#0#0: Seq, a#388#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#388#0#0, a#388#1#0) } Seq#Rank(a#388#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.CollectionOfErrors(a#388#0#0, a#388#1#0)));

axiom (forall a#389#0#0: ref :: { #AwsCryptographyPrimitivesTypes.Error.Opaque(a#389#0#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#389#0#0)) == ##AwsCryptographyPrimitivesTypes.Error.Opaque);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) } AwsCryptographyPrimitivesTypes.Error.Opaque_q(d) ==> (exists a#390#0#0: ref :: d == #AwsCryptographyPrimitivesTypes.Error.Opaque(a#390#0#0)));

axiom (forall a#391#0#0: ref :: { $Is(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#391#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#391#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#391#0#0, Tclass._System.object()));

axiom (forall a#391#0#0: ref, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#391#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#391#0#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#391#0#0, Tclass._System.object(), $h)));

axiom (forall a#392#0#0: ref :: { #AwsCryptographyPrimitivesTypes.Error.Opaque(Lit(a#392#0#0)) } #AwsCryptographyPrimitivesTypes.Error.Opaque(Lit(a#392#0#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#392#0#0)));

axiom (forall a#393#0#0: ref :: { #AwsCryptographyPrimitivesTypes.Error.Opaque(a#393#0#0) } AwsCryptographyPrimitivesTypes.Error.obj(#AwsCryptographyPrimitivesTypes.Error.Opaque(a#393#0#0)) == a#393#0#0);

axiom (forall a#394#0#0: ref, a#394#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#394#0#0, a#394#1#0) } DatatypeCtorId(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#394#0#0, a#394#1#0)) == ##AwsCryptographyPrimitivesTypes.Error.OpaqueWithText);

axiom (forall d: DatatypeType :: { AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) } AwsCryptographyPrimitivesTypes.Error.OpaqueWithText_q(d) ==> (exists a#395#0#0: ref, a#395#1#0: Seq :: d == #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#395#0#0, a#395#1#0)));

axiom (forall a#396#0#0: ref, a#396#1#0: Seq :: { $Is(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#396#0#0, a#396#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) } $Is(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#396#0#0, a#396#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error()) <==> $Is(a#396#0#0, Tclass._System.object()) && $Is(a#396#1#0, TSeq(TChar)));

axiom (forall a#396#0#0: ref, a#396#1#0: Seq, $h: Heap :: { $IsAlloc(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#396#0#0, a#396#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#396#0#0, a#396#1#0), Tclass.AwsCryptographyPrimitivesTypes.Error(), $h) <==> $IsAlloc(a#396#0#0, Tclass._System.object(), $h) && $IsAlloc(a#396#1#0, TSeq(TChar), $h)));

axiom (forall a#397#0#0: ref, a#397#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(Lit(a#397#0#0), Lit(a#397#1#0)) } #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(Lit(a#397#0#0), Lit(a#397#1#0)) == Lit(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#397#0#0, a#397#1#0)));

axiom (forall a#398#0#0: ref, a#398#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#398#0#0, a#398#1#0) } AwsCryptographyPrimitivesTypes.Error.obj(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#398#0#0, a#398#1#0)) == a#398#0#0);

axiom (forall a#399#0#0: ref, a#399#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#399#0#0, a#399#1#0) } AwsCryptographyPrimitivesTypes.Error.objMessage(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#399#0#0, a#399#1#0)) == a#399#1#0);

axiom (forall a#400#0#0: ref, a#400#1#0: Seq, i: int :: { Seq#Index(a#400#1#0, i), #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#400#0#0, a#400#1#0) } 0 <= i && i < Seq#Length(a#400#1#0) ==> DtRank($Unbox(Seq#Index(a#400#1#0, i)): DatatypeType) < DtRank(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#400#0#0, a#400#1#0)));

axiom (forall a#401#0#0: ref, a#401#1#0: Seq :: { #AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#401#0#0, a#401#1#0) } Seq#Rank(a#401#1#0) < DtRank(#AwsCryptographyPrimitivesTypes.Error.OpaqueWithText(a#401#0#0, a#401#1#0)));

const unique class.Digest.__default: ClassName;

function Digest.__default.Length(digestAlgorithm#0: DatatypeType) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall digestAlgorithm#0: DatatypeType :: { Digest.__default.Length(digestAlgorithm#0) } Digest.__default.Length#canCall(digestAlgorithm#0) || (0 < $FunctionContextHeight && $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm())) ==> LitInt(0) <= Digest.__default.Length(digestAlgorithm#0));
axiom 0 <= $FunctionContextHeight ==> (forall digestAlgorithm#0: DatatypeType :: { Digest.__default.Length(digestAlgorithm#0) } Digest.__default.Length#canCall(digestAlgorithm#0) || (0 < $FunctionContextHeight && $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm())) ==> Digest.__default.Length(digestAlgorithm#0) == (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(digestAlgorithm#0) then 64 else (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(digestAlgorithm#0) then 48 else 32)));
axiom 0 <= $FunctionContextHeight ==> (forall digestAlgorithm#0: DatatypeType :: {:weight 3} { Digest.__default.Length(Lit(digestAlgorithm#0)) } Digest.__default.Length#canCall(Lit(digestAlgorithm#0)) || (0 < $FunctionContextHeight && $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm())) ==> Digest.__default.Length(Lit(digestAlgorithm#0)) == (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(Lit(digestAlgorithm#0)) then 64 else (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(Lit(digestAlgorithm#0)) then 48 else 32)));
}

function Digest.__default.Length#canCall(digestAlgorithm#0: DatatypeType) : bool;

function Digest.__default.Length#requires(DatatypeType) : bool;

axiom (forall digestAlgorithm#0: DatatypeType :: { Digest.__default.Length#requires(digestAlgorithm#0) } $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> (Digest.__default.Length#requires(digestAlgorithm#0) <==> true));

procedure {:verboseName "Digest.Length (well-formedness)"} CheckWellformed$$Digest.__default.Length(digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Digest.Length (well-formedness)"} CheckWellformed$$Digest.__default.Length(digestAlgorithm#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Digest.Length", " | ", digestAlgorithm#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(13,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume LitInt(0) <= Digest.__default.Length(digestAlgorithm#0);
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} digestAlgorithm#0 == #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512();
    assume $Is(LitInt(64), Tclass._System.nat());
    assume Digest.__default.Length(digestAlgorithm#0) == LitInt(64);
    assume true;
    assume $Is(Digest.__default.Length(digestAlgorithm#0), Tclass._System.nat());
    return;

  anon9_Else:
    assume {:partition} digestAlgorithm#0 != #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_512();
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} digestAlgorithm#0 == #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384();
    assume $Is(LitInt(48), Tclass._System.nat());
    assume Digest.__default.Length(digestAlgorithm#0) == LitInt(48);
    assume true;
    assume $Is(Digest.__default.Length(digestAlgorithm#0), Tclass._System.nat());
    return;

  anon10_Else:
    assume {:partition} digestAlgorithm#0 != #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} digestAlgorithm#0 == #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256();
    assume $Is(LitInt(32), Tclass._System.nat());
    assume Digest.__default.Length(digestAlgorithm#0) == LitInt(32);
    assume true;
    assume $Is(Digest.__default.Length(digestAlgorithm#0), Tclass._System.nat());
    return;

  anon11_Else:
    assume {:partition} digestAlgorithm#0 != #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256();
    assume false;
    return;
}



procedure {:verboseName "Digest.Digest (well-formedness)"} CheckWellFormed$$Digest.__default.Digest(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Digest.Digest (well-formedness)"} CheckWellFormed$$Digest.__default.Digest(input#0: DatatypeType) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##digestAlgorithm#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "Digest.Digest", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(21,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(23,25): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(input#0);
    ##digestAlgorithm#0 := AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0);
    assume $IsAlloc(##digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap);
    assume Digest.__default.Length#canCall(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
    assume Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
    return;

  anon4_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
    return;
}



procedure {:verboseName "Digest.Digest (call precondtion)"} CallPre$$Digest.__default.Digest(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0));



procedure {:verboseName "Digest.Digest (call postcondition)"} CallPost$$Digest.__default.Digest(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(input#0) && Digest.__default.Length#canCall(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
  free ensures {:id "id3601"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Digest.Digest (correctness)"} Impl$$Digest.__default.Digest(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(input#0) && Digest.__default.Length#canCall(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
  free ensures {:id "id3602"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.DigestInput.digestAlgorithm(input#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Digest.Digest (correctness)"} Impl$$Digest.__default.Digest(input#0: DatatypeType) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var digestAlgorithm#0: DatatypeType;
  var message#0: Seq;
  var let#0#0#0: DatatypeType;
  var value#0: Seq where $Is(value#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(value#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var $rhs##0: DatatypeType;
  var alg##0: DatatypeType;
  var msg##0: Seq;
  var defass#valueOrError1#0: bool;
  var valueOrError1#0: DatatypeType where defass#valueOrError1#0 ==> $Is(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var ##digestAlgorithm#1: DatatypeType;
  var ##condition#0: bool;
  var ##error#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "Digest.Digest", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(24,2): initial state"} true;
    $_reverifyPost := false;
    havoc digestAlgorithm#0;
    assume $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap);
    havoc message#0;
    assume $Is(message#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(message#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume let#0#0#0 == input#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput());
    assume AwsCryptographyPrimitivesTypes.DigestInput.DigestInput_q(let#0#0#0);
    assume #AwsCryptographyPrimitivesTypes.DigestInput.DigestInput(digestAlgorithm#0, message#0) == let#0#0#0;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    alg##0 := digestAlgorithm#0;
    assume true;
    msg##0 := message#0;
    call CallPre$$ExternDigest.__default.Digest(alg##0, msg##0);
    call $rhs##0 := CallPost$$ExternDigest.__default.Digest(alg##0, msg##0);
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(26,62)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    defass#res#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(26,62)"} true;
    assume defass#res#0;
    pop;
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    value#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0)): Seq;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(26,62)"} true;
    havoc valueOrError1#0 /* where defass#valueOrError1#0 ==> $Is(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    ##digestAlgorithm#1 := digestAlgorithm#0;
    assume $IsAlloc(##digestAlgorithm#1, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap);
    assume Digest.__default.Length#canCall(digestAlgorithm#0);
    ##condition#0 := Seq#Length(value#0) == Digest.__default.Length(digestAlgorithm#0);
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(68))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(46))))));
    assume $IsAlloc(##error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), Seq#Length(value#0) == Digest.__default.Length(digestAlgorithm#0), $Box(Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(68))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(46))))))));
    assume Digest.__default.Length#canCall(digestAlgorithm#0) && Wrappers.__default.Need#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), Seq#Length(value#0) == Digest.__default.Length(digestAlgorithm#0), $Box(Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(68))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(46))))))));
    valueOrError1#0 := Wrappers.__default.Need(Tclass.AwsCryptographyPrimitivesTypes.Error(), Seq#Length(value#0) == Digest.__default.Length(digestAlgorithm#0), $Box(Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(68))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(46))))))));
    defass#valueOrError1#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(30,5)"} true;
    assume defass#valueOrError1#0;
    assume $IsAllocBox($Box(valueOrError1#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    push;
    assume true;
    assume defass#valueOrError1#0;
    assume $IsAllocBox($Box(valueOrError1#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError1#0);
    assume Wrappers.Outcome.Fail_q(valueOrError1#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0);
    res#0 := Wrappers.Outcome.PropagateFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0);
    defass#res#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(30,5)"} true;
    assume defass#res#0;
    pop;
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(value#0));
    defass#res#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/Digest.dfy(31,25)"} true;
    assume defass#res#0;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#24 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#24))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#26 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#26)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#36 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#36))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#38 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#38)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#40 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#40)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#36 := Wrappers.Option.value(this); v#36)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#38 := Lit(Wrappers.Option.value(Lit(this))); v#38)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#40 := Lit(Wrappers.Option.value(Lit(this))); v#40)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#24 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#24)) else (var e#24 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#26 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#26))) else (var e#26 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#36 := Wrappers.Result.value(this); s#36) else (var e#36 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#38 := Lit(Wrappers.Result.value(Lit(this))); s#38) else (var e#38 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#40 := Lit(Wrappers.Result.value(Lit(this))); s#40) else (var e#40 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#36 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#36)) else (var e#36 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#36)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#38 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#38))) else (var e#38 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#38)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#40 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#40))) else (var e#40 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#40)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#14 := Div(x#0, LitInt(256)); (var b1#14 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#14)), $Box(b1#14)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#15 := LitInt(Div(x#0, LitInt(256))); (var b1#15 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#15)), $Box(b1#15))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#14 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#14 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#15 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#15 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#14 := Div(x#0, LitInt(16777216)); (var x0#14 := x#0 - Mul(b0#14, LitInt(16777216)); (var b1#14 := Div(x0#14, LitInt(65536)); (var x1#14 := x0#14 - Mul(b1#14, LitInt(65536)); (var b2#14 := Div(x1#14, LitInt(256)); (var b3#14 := Mod(x1#14, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#14)), $Box(b1#14)), $Box(b2#14)), $Box(b3#14)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#15 := LitInt(Div(x#0, LitInt(16777216))); (var x0#15 := LitInt(x#0 - Mul(b0#15, LitInt(16777216))); (var b1#15 := LitInt(Div(x0#15, LitInt(65536))); (var x1#15 := LitInt(x0#15 - Mul(b1#15, LitInt(65536))); (var b2#15 := LitInt(Div(x1#15, LitInt(256))); (var b3#15 := LitInt(Mod(x1#15, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#15)), $Box(b1#15)), $Box(b2#15)), $Box(b3#15))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#14 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#14 := x0#14 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#14 := x1#14 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#14 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#15 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#15 := x0#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#15 := x1#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#15 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#14 := Div(x#0, LitInt(72057594037927936)); (var x0#14 := x#0 - Mul(b0#14, LitInt(72057594037927936)); (var b1#14 := Div(x0#14, LitInt(281474976710656)); (var x1#14 := x0#14 - Mul(b1#14, LitInt(281474976710656)); (var b2#14 := Div(x1#14, LitInt(1099511627776)); (var x2#14 := x1#14 - Mul(b2#14, LitInt(1099511627776)); (var b3#14 := Div(x2#14, LitInt(4294967296)); (var x3#14 := x2#14 - Mul(b3#14, LitInt(4294967296)); (var b4#14 := Div(x3#14, LitInt(16777216)); (var x4#14 := x3#14 - Mul(b4#14, LitInt(16777216)); (var b5#14 := Div(x4#14, LitInt(65536)); (var x5#14 := x4#14 - Mul(b5#14, LitInt(65536)); (var b6#14 := Div(x5#14, LitInt(256)); (var b7#14 := Mod(x5#14, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#14)), $Box(b1#14)), $Box(b2#14)), $Box(b3#14)), $Box(b4#14)), $Box(b5#14)), $Box(b6#14)), $Box(b7#14)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#15 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#15 := LitInt(x#0 - Mul(b0#15, LitInt(72057594037927936))); (var b1#15 := LitInt(Div(x0#15, LitInt(281474976710656))); (var x1#15 := LitInt(x0#15 - Mul(b1#15, LitInt(281474976710656))); (var b2#15 := LitInt(Div(x1#15, LitInt(1099511627776))); (var x2#15 := LitInt(x1#15 - Mul(b2#15, LitInt(1099511627776))); (var b3#15 := LitInt(Div(x2#15, LitInt(4294967296))); (var x3#15 := LitInt(x2#15 - Mul(b3#15, LitInt(4294967296))); (var b4#15 := LitInt(Div(x3#15, LitInt(16777216))); (var x4#15 := LitInt(x3#15 - Mul(b4#15, LitInt(16777216))); (var b5#15 := LitInt(Div(x4#15, LitInt(65536))); (var x5#15 := LitInt(x4#15 - Mul(b5#15, LitInt(65536))); (var b6#15 := LitInt(Div(x5#15, LitInt(256))); (var b7#15 := LitInt(Mod(x5#15, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#15)), $Box(b1#15)), $Box(b2#15)), $Box(b3#15)), $Box(b4#15)), $Box(b5#15)), $Box(b6#15)), $Box(b7#15))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#14 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#14 := x0#14 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#14 := x1#14 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#14 := x2#14 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#14 := x3#14 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#14 := x4#14 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#14 := x5#14 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#15 := x6#14 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#15)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#15 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#15 := x0#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#15 := x1#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#15 := x2#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#15 := x3#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#15 := x4#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#15 := x5#15 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#16 := x6#15 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#16)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#14 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#14)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#14 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#14)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#14)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#15 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#15)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#15 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#15)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#15)): int)));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#8: int :: { $Unbox(Seq#Index(s#0, i#8)): char } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#9: int :: { $Unbox(Seq#Index(s#0, i#9)): char } LitInt(0) <= i#9 && i#9 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#9)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#7: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#7)): int } { $Unbox(Seq#Index(s#0, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#7)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#7)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#6 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#6, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#7 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#7, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#9 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#9) && (UTF8.__default.Uses1Byte(r#9) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#9) ==> (LitInt(2) <= Seq#Length(r#9) ==> UTF8.__default.Uses2Bytes#canCall(r#9)) && (LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9)) ==> (LitInt(3) <= Seq#Length(r#9) ==> UTF8.__default.Uses3Bytes#canCall(r#9)) && (LitInt(3) <= Seq#Length(r#9) && UTF8.__default.Uses3Bytes(r#9) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#9) && UTF8.__default.Uses3Bytes(r#9)) ==> (LitInt(4) <= Seq#Length(r#9) ==> UTF8.__default.Uses4Bytes#canCall(r#9)) && (LitInt(4) <= Seq#Length(r#9) && UTF8.__default.Uses4Bytes(r#9) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#9 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#9) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#9) && UTF8.__default.Uses2Bytes(r#9) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#9) && UTF8.__default.Uses3Bytes(r#9) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#9) && UTF8.__default.Uses4Bytes(r#9) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#10 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#10) && (UTF8.__default.Uses1Byte(r#10) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#10) ==> (LitInt(2) <= Seq#Length(r#10) ==> UTF8.__default.Uses2Bytes#canCall(r#10)) && (LitInt(2) <= Seq#Length(r#10) && UTF8.__default.Uses2Bytes(r#10) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#10) && UTF8.__default.Uses2Bytes(r#10)) ==> (LitInt(3) <= Seq#Length(r#10) ==> UTF8.__default.Uses3Bytes#canCall(r#10)) && (LitInt(3) <= Seq#Length(r#10) && UTF8.__default.Uses3Bytes(r#10) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#10) && UTF8.__default.Uses3Bytes(r#10)) ==> (LitInt(4) <= Seq#Length(r#10) ==> UTF8.__default.Uses4Bytes#canCall(r#10)) && (LitInt(4) <= Seq#Length(r#10) && UTF8.__default.Uses4Bytes(r#10) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#10 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#10) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#10) && UTF8.__default.Uses2Bytes(r#10) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#10) && UTF8.__default.Uses3Bytes(r#10) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#10) && UTF8.__default.Uses4Bytes(r#10) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#11 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#11) && (UTF8.__default.Uses1Byte(r#11) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#11) ==> (LitInt(2) <= Seq#Length(r#11) ==> UTF8.__default.Uses2Bytes#canCall(r#11)) && (LitInt(2) <= Seq#Length(r#11) && UTF8.__default.Uses2Bytes(r#11) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#11) && UTF8.__default.Uses2Bytes(r#11)) ==> (LitInt(3) <= Seq#Length(r#11) ==> UTF8.__default.Uses3Bytes#canCall(r#11)) && (LitInt(3) <= Seq#Length(r#11) && UTF8.__default.Uses3Bytes(r#11) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#11) && UTF8.__default.Uses3Bytes(r#11)) ==> (LitInt(4) <= Seq#Length(r#11) ==> UTF8.__default.Uses4Bytes#canCall(r#11)) && (LitInt(4) <= Seq#Length(r#11) && UTF8.__default.Uses4Bytes(r#11) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#11 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#11) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#11) && UTF8.__default.Uses2Bytes(r#11) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#11) && UTF8.__default.Uses3Bytes(r#11) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#11) && UTF8.__default.Uses4Bytes(r#11) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall bytes#0: Seq :: { ExternDigest.__default.CreateDigestSuccess(bytes#0) } ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0) || $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> $Is(ExternDigest.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, bytes#0: Seq :: { $IsAlloc(ExternDigest.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0) || ($Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(ExternDigest.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall bytes#0: Seq :: { ExternDigest.__default.CreateDigestSuccess(bytes#0) } ExternDigest.__default.CreateDigestSuccess#canCall(bytes#0) || $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> ExternDigest.__default.CreateDigestSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));

axiom (forall bytes#0: Seq :: {:weight 3} { ExternDigest.__default.CreateDigestSuccess(Lit(bytes#0)) } ExternDigest.__default.CreateDigestSuccess#canCall(Lit(bytes#0)) || $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> ExternDigest.__default.CreateDigestSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));

axiom (forall error#0: DatatypeType :: { ExternDigest.__default.CreateDigestFailure(error#0) } ExternDigest.__default.CreateDigestFailure#canCall(error#0) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> $Is(ExternDigest.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(ExternDigest.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (ExternDigest.__default.CreateDigestFailure#canCall(error#0) || ($Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(ExternDigest.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall error#0: DatatypeType :: { ExternDigest.__default.CreateDigestFailure(error#0) } ExternDigest.__default.CreateDigestFailure#canCall(error#0) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> ExternDigest.__default.CreateDigestFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));

axiom (forall error#0: DatatypeType :: {:weight 3} { ExternDigest.__default.CreateDigestFailure(Lit(error#0)) } ExternDigest.__default.CreateDigestFailure#canCall(Lit(error#0)) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> ExternDigest.__default.CreateDigestFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));

const unique class.HMAC.__default: ClassName;

function HMAC.__default.Digest(input#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall input#0: DatatypeType :: { HMAC.__default.Digest(input#0) } HMAC.__default.Digest#canCall(input#0) || (0 < $FunctionContextHeight && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> (Wrappers.Result.Success_q(HMAC.__default.Digest(input#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(HMAC.__default.Digest(input#0))): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0))) && $Is(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, input#0: DatatypeType :: { $IsAlloc(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.Digest#canCall(input#0) || (0 < $FunctionContextHeight && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
}

function HMAC.__default.Digest#canCall(input#0: DatatypeType) : bool;

function HMAC.__default.Digest#requires(DatatypeType) : bool;

axiom (forall input#0: DatatypeType :: { HMAC.__default.Digest#requires(input#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> (HMAC.__default.Digest#requires(input#0) <==> true));

procedure {:verboseName "HMAC.Digest (well-formedness)"} {:extern} CheckWellformed$$HMAC.__default.Digest(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id3625"} Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HMAC.Digest (well-formedness)"} {:extern} CheckWellformed$$HMAC.__default.Digest(input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##digestAlgorithm#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "HMAC.Digest", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(71,30): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(output#0);
    assume Wrappers.Result.Success_q(output#0);
    assume AwsCryptographyPrimitivesTypes.HMacInput.HMacInput_q(input#0);
    ##digestAlgorithm#0 := AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0);
    assume $IsAlloc(##digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap);
    assume Digest.__default.Length#canCall(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0));
    assume Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0));
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0));
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



function HMAC.__default.CreateHMacSuccess(hmac#0: ref) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall hmac#0: ref :: { HMAC.__default.CreateHMacSuccess(hmac#0) } HMAC.__default.CreateHMacSuccess#canCall(hmac#0) || (1 < $FunctionContextHeight && $Is(hmac#0, Tclass.HMAC.HMac())) ==> $Is(HMAC.__default.CreateHMacSuccess(hmac#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, hmac#0: ref :: { $IsAlloc(HMAC.__default.CreateHMacSuccess(hmac#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateHMacSuccess#canCall(hmac#0) || (1 < $FunctionContextHeight && $Is(hmac#0, Tclass.HMAC.HMac()) && $IsAlloc(hmac#0, Tclass.HMAC.HMac(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateHMacSuccess(hmac#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall hmac#0: ref :: { HMAC.__default.CreateHMacSuccess(hmac#0) } HMAC.__default.CreateHMacSuccess#canCall(hmac#0) || (1 < $FunctionContextHeight && $Is(hmac#0, Tclass.HMAC.HMac())) ==> HMAC.__default.CreateHMacSuccess(hmac#0) == #Wrappers.Result.Success($Box(hmac#0)));
axiom 1 <= $FunctionContextHeight ==> (forall hmac#0: ref :: {:weight 3} { HMAC.__default.CreateHMacSuccess(Lit(hmac#0)) } HMAC.__default.CreateHMacSuccess#canCall(Lit(hmac#0)) || (1 < $FunctionContextHeight && $Is(hmac#0, Tclass.HMAC.HMac())) ==> HMAC.__default.CreateHMacSuccess(Lit(hmac#0)) == Lit(#Wrappers.Result.Success($Box(Lit(hmac#0)))));
}

function HMAC.__default.CreateHMacSuccess#canCall(hmac#0: ref) : bool;

function Tclass.HMAC.HMac() : Ty
uses {
axiom Tag(Tclass.HMAC.HMac()) == Tagclass.HMAC.HMac && TagFamily(Tclass.HMAC.HMac()) == tytagFamily$HMac;
}

const unique Tagclass.HMAC.HMac: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.HMAC.HMac()) } $IsBox(bx, Tclass.HMAC.HMac()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.HMAC.HMac()));

function HMAC.__default.CreateHMacSuccess#requires(ref) : bool;

axiom (forall hmac#0: ref :: { HMAC.__default.CreateHMacSuccess#requires(hmac#0) } $Is(hmac#0, Tclass.HMAC.HMac()) ==> (HMAC.__default.CreateHMacSuccess#requires(hmac#0) <==> true));

procedure {:verboseName "HMAC.CreateHMacSuccess (well-formedness)"} CheckWellformed$$HMAC.__default.CreateHMacSuccess(hmac#0: ref where $Is(hmac#0, Tclass.HMAC.HMac()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function HMAC.__default.CreateHMacFailure(error#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { HMAC.__default.CreateHMacFailure(error#0) } HMAC.__default.CreateHMacFailure#canCall(error#0) || (1 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> $Is(HMAC.__default.CreateHMacFailure(error#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(HMAC.__default.CreateHMacFailure(error#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateHMacFailure#canCall(error#0) || (1 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateHMacFailure(error#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { HMAC.__default.CreateHMacFailure(error#0) } HMAC.__default.CreateHMacFailure#canCall(error#0) || (1 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> HMAC.__default.CreateHMacFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 1 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: {:weight 3} { HMAC.__default.CreateHMacFailure(Lit(error#0)) } HMAC.__default.CreateHMacFailure#canCall(Lit(error#0)) || (1 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> HMAC.__default.CreateHMacFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function HMAC.__default.CreateHMacFailure#canCall(error#0: DatatypeType) : bool;

function HMAC.__default.CreateHMacFailure#requires(DatatypeType) : bool;

axiom (forall error#0: DatatypeType :: { HMAC.__default.CreateHMacFailure#requires(error#0) } $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> (HMAC.__default.CreateHMacFailure#requires(error#0) <==> true));

procedure {:verboseName "HMAC.CreateHMacFailure (well-formedness)"} CheckWellformed$$HMAC.__default.CreateHMacFailure(error#0: DatatypeType where $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function HMAC.__default.CreateDigestSuccess(bytes#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { HMAC.__default.CreateDigestSuccess(bytes#0) } HMAC.__default.CreateDigestSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> $Is(HMAC.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, bytes#0: Seq :: { $IsAlloc(HMAC.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateDigestSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { HMAC.__default.CreateDigestSuccess(bytes#0) } HMAC.__default.CreateDigestSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> HMAC.__default.CreateDigestSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: {:weight 3} { HMAC.__default.CreateDigestSuccess(Lit(bytes#0)) } HMAC.__default.CreateDigestSuccess#canCall(Lit(bytes#0)) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> HMAC.__default.CreateDigestSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));
}

function HMAC.__default.CreateDigestSuccess#canCall(bytes#0: Seq) : bool;

function HMAC.__default.CreateDigestSuccess#requires(Seq) : bool;

axiom (forall bytes#0: Seq :: { HMAC.__default.CreateDigestSuccess#requires(bytes#0) } $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> (HMAC.__default.CreateDigestSuccess#requires(bytes#0) <==> true));

procedure {:verboseName "HMAC.CreateDigestSuccess (well-formedness)"} CheckWellformed$$HMAC.__default.CreateDigestSuccess(bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function HMAC.__default.CreateDigestFailure(error#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { HMAC.__default.CreateDigestFailure(error#0) } HMAC.__default.CreateDigestFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> $Is(HMAC.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(HMAC.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateDigestFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { HMAC.__default.CreateDigestFailure(error#0) } HMAC.__default.CreateDigestFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> HMAC.__default.CreateDigestFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: {:weight 3} { HMAC.__default.CreateDigestFailure(Lit(error#0)) } HMAC.__default.CreateDigestFailure#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> HMAC.__default.CreateDigestFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function HMAC.__default.CreateDigestFailure#canCall(error#0: DatatypeType) : bool;

function HMAC.__default.CreateDigestFailure#requires(DatatypeType) : bool;

axiom (forall error#0: DatatypeType :: { HMAC.__default.CreateDigestFailure#requires(error#0) } $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> (HMAC.__default.CreateDigestFailure#requires(error#0) <==> true));

procedure {:verboseName "HMAC.CreateDigestFailure (well-formedness)"} CheckWellformed$$HMAC.__default.CreateDigestFailure(error#0: DatatypeType where $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



const unique class.HMAC.HMac?: ClassName;

function Tclass.HMAC.HMac?() : Ty
uses {
axiom Tag(Tclass.HMAC.HMac?()) == Tagclass.HMAC.HMac? && TagFamily(Tclass.HMAC.HMac?()) == tytagFamily$HMac;
}

const unique Tagclass.HMAC.HMac?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.HMAC.HMac?()) } $IsBox(bx, Tclass.HMAC.HMac?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.HMAC.HMac?()));

axiom (forall $o: ref :: { $Is($o, Tclass.HMAC.HMac?()) } $Is($o, Tclass.HMAC.HMac?()) <==> $o == null || dtype($o) == Tclass.HMAC.HMac?());

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.HMAC.HMac?(), $h) } $IsAlloc($o, Tclass.HMAC.HMac?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function HMAC.HMac.GetKey($heap: Heap, this: ref) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetKey($Heap, this) } HMAC.HMac.GetKey#canCall($Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) ==> $Is(HMAC.HMac.GetKey($Heap, this), TSeq(Tclass.BoundedInts.uint8())));
}

function HMAC.HMac.GetKey#canCall($heap: Heap, this: ref) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), HMAC.HMac.GetKey($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> HMAC.HMac.GetKey($h0, this) == HMAC.HMac.GetKey($h1, this));

function HMAC.HMac.GetKey#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetKey#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap) ==> (HMAC.HMac.GetKey#requires($Heap, this) <==> true));

procedure {:verboseName "HMAC.HMac.GetKey (well-formedness)"} {:extern} CheckWellformed$$HMAC.HMac.GetKey(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function HMAC.HMac.GetDigest($heap: Heap, this: ref) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetDigest($Heap, this) } HMAC.HMac.GetDigest#canCall($Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) ==> $Is(HMAC.HMac.GetDigest($Heap, this), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()));
}

function HMAC.HMac.GetDigest#canCall($heap: Heap, this: ref) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), HMAC.HMac.GetDigest($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> HMAC.HMac.GetDigest($h0, this) == HMAC.HMac.GetDigest($h1, this));

function HMAC.HMac.GetDigest#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetDigest#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap) ==> (HMAC.HMac.GetDigest#requires($Heap, this) <==> true));

procedure {:verboseName "HMAC.HMac.GetDigest (well-formedness)"} {:extern} CheckWellformed$$HMAC.HMac.GetDigest(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function HMAC.HMac.GetInputSoFar($heap: Heap, this: ref) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetInputSoFar($Heap, this) } HMAC.HMac.GetInputSoFar#canCall($Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) ==> $Is(HMAC.HMac.GetInputSoFar($Heap, this), TSeq(Tclass.BoundedInts.uint8())));
}

function HMAC.HMac.GetInputSoFar#canCall($heap: Heap, this: ref) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), HMAC.HMac.GetInputSoFar($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> HMAC.HMac.GetInputSoFar($h0, this) == HMAC.HMac.GetInputSoFar($h1, this));

function HMAC.HMac.GetInputSoFar#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetInputSoFar#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap) ==> (HMAC.HMac.GetInputSoFar#requires($Heap, this) <==> true));

procedure {:verboseName "HMAC.HMac.GetInputSoFar (well-formedness)"} {:extern} CheckWellformed$$HMAC.HMac.GetInputSoFar(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "HMAC.HMac.Build (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.Build(digest#0: DatatypeType where $Is(digest#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digest#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digest#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HMAC.HMac.Build (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.Build(digest#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HMAC.HMac.Build", " | ", digest#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(27,28): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(30,14): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Wrappers.Result.Success_q(output#0);
    assume Wrappers.Result.Success_q(output#0);
    assume $Unbox(Wrappers.Result.value(output#0)): ref != null;
    assume $IsAllocBox(Wrappers.Result.value(output#0), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetDigest#canCall($Heap, $Unbox(Wrappers.Result.value(output#0)): ref);
    assume AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), digest#0);
    assume Wrappers.Result.Success_q(output#0);
    assume $Unbox(Wrappers.Result.value(output#0)): ref != null;
    assume $IsAllocBox(Wrappers.Result.value(output#0), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetInputSoFar#canCall($Heap, $Unbox(Wrappers.Result.value(output#0)): ref);
    assume Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), Seq#Empty(): Seq);
    assume Wrappers.Result.Success_q(output#0);
    assume $Unbox(Wrappers.Result.value(output#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(output#0)): ref, alloc)): bool;
    return;

  anon4_Else:
    assume Wrappers.Result.Success_q(output#0) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), digest#0) && Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), Seq#Empty(): Seq) && $Unbox(Wrappers.Result.value(output#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(output#0)): ref, alloc)): bool;
    return;
}



procedure {:verboseName "HMAC.HMac.Build (call precondtion)"} {:extern} CallPre$$HMAC.HMac.Build(digest#0: DatatypeType where $Is(digest#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digest#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digest#0));



procedure {:verboseName "HMAC.HMac.Build (call postcondition)"} {:extern} CallPost$$HMAC.HMac.Build(digest#0: DatatypeType where $Is(digest#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digest#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digest#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(output#0) ==> $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest($Heap, $Unbox(Wrappers.Result.value(output#0)): ref)) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digest#0) && HMAC.HMac.GetDigest#canCall($Heap, $Unbox(Wrappers.Result.value(output#0)): ref) && (AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), digest#0) ==> HMAC.HMac.GetInputSoFar#canCall($Heap, $Unbox(Wrappers.Result.value(output#0)): ref));
  free ensures {:id "id3644"} Wrappers.Result.Success_q(output#0) ==> AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), digest#0);
  free ensures {:id "id3645"} Wrappers.Result.Success_q(output#0) ==> Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, $Unbox(Wrappers.Result.value(output#0)): ref), Seq#Empty(): Seq);
  free ensures {:id "id3646"} Wrappers.Result.Success_q(output#0) ==> $Unbox(Wrappers.Result.value(output#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(output#0)): ref, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "HMAC.HMac.Init (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.Init(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), key#0: Seq where $Is(key#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(key#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HMAC.HMac.Init (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.Init(this: ref, key#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HMAC.HMac.Init", " | ", this, " | ", key#0} true;
    assume {:print "Types", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(35,28): initial state"} true;
    assume 0 < Seq#Length(key#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(38,28): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetKey#canCall($Heap, this);
    assume Seq#Equal(HMAC.HMac.GetKey($Heap, this), key#0);
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetDigest#canCall($Heap, this);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetDigest#canCall(old($Heap), this);
    assume AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, this), HMAC.HMac.GetDigest(old($Heap), this));
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetInputSoFar#canCall($Heap, this);
    assume Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, this), Seq#Empty(): Seq);
    return;
}



procedure {:verboseName "HMAC.HMac.Init (call precondtion)"} {:extern} CallPre$$HMAC.HMac.Init(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), key#0: Seq where $Is(key#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(key#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id3652"} 0 < Seq#Length(key#0);



procedure {:verboseName "HMAC.HMac.Init (call postcondition)"} {:extern} CallPost$$HMAC.HMac.Init(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), key#0: Seq where $Is(key#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(key#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures HMAC.HMac.GetKey#canCall($Heap, this);
  free ensures {:id "id3653"} Seq#Equal(HMAC.HMac.GetKey($Heap, this), key#0);
  free ensures $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest($Heap, this)) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest(old($Heap), this)) && HMAC.HMac.GetDigest#canCall($Heap, this) && HMAC.HMac.GetDigest#canCall(old($Heap), this);
  free ensures {:id "id3654"} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, this), HMAC.HMac.GetDigest(old($Heap), this));
  free ensures HMAC.HMac.GetInputSoFar#canCall($Heap, this);
  free ensures {:id "id3655"} Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, this), Seq#Empty(): Seq);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "HMAC.HMac.Update (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.Update(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), input#0: Seq where $Is(input#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(input#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HMAC.HMac.Update (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.Update(this: ref, input#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HMAC.HMac.Update", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(42,35): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetKey#canCall($Heap, this);
    assume Seq#Length(HMAC.HMac.GetKey($Heap, this)) > 0;
    assume Seq#Length(input#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(46,35): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetInputSoFar#canCall($Heap, this);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetInputSoFar#canCall(old($Heap), this);
    assume Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, this), Seq#Append(HMAC.HMac.GetInputSoFar(old($Heap), this), input#0));
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetDigest#canCall($Heap, this);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetDigest#canCall(old($Heap), this);
    assume AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, this), HMAC.HMac.GetDigest(old($Heap), this));
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetKey#canCall($Heap, this);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetKey#canCall(old($Heap), this);
    assume Seq#Equal(HMAC.HMac.GetKey($Heap, this), HMAC.HMac.GetKey(old($Heap), this));
    return;
}



procedure {:verboseName "HMAC.HMac.Update (call precondtion)"} {:extern} CallPre$$HMAC.HMac.Update(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), input#0: Seq where $Is(input#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(input#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id3664"} Seq#Length(HMAC.HMac.GetKey($Heap, this)) > 0;
  requires {:id "id3665"} Seq#Length(input#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();



procedure {:verboseName "HMAC.HMac.Update (call postcondition)"} {:extern} CallPost$$HMAC.HMac.Update(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), input#0: Seq where $Is(input#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(input#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures HMAC.HMac.GetInputSoFar#canCall($Heap, this) && HMAC.HMac.GetInputSoFar#canCall(old($Heap), this);
  free ensures {:id "id3666"} Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, this), Seq#Append(HMAC.HMac.GetInputSoFar(old($Heap), this), input#0));
  free ensures $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest($Heap, this)) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest(old($Heap), this)) && HMAC.HMac.GetDigest#canCall($Heap, this) && HMAC.HMac.GetDigest#canCall(old($Heap), this);
  free ensures {:id "id3667"} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, this), HMAC.HMac.GetDigest(old($Heap), this));
  free ensures HMAC.HMac.GetKey#canCall($Heap, this) && HMAC.HMac.GetKey#canCall(old($Heap), this);
  free ensures {:id "id3668"} Seq#Equal(HMAC.HMac.GetKey($Heap, this), HMAC.HMac.GetKey(old($Heap), this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "HMAC.HMac.GetResult (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.GetResult(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) returns (s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HMAC.HMac.GetResult (well-formedness)"} {:extern} CheckWellFormed$$HMAC.HMac.GetResult(this: ref) returns (s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##digestAlgorithm#0: DatatypeType;
  var ##message#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HMAC.HMac.GetResult", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(50,33): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetKey#canCall($Heap, this);
    assume Seq#Length(HMAC.HMac.GetKey($Heap, this)) > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    havoc s#0;
    assume {:captureState "AwsCryptographyPrimitives/src/HKDF/HMAC.dfy(53,18): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetDigest#canCall($Heap, this);
    ##digestAlgorithm#0 := HMAC.HMac.GetDigest($Heap, this);
    assume $IsAlloc(##digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap);
    assume Digest.__default.Length#canCall(HMAC.HMac.GetDigest($Heap, this));
    assume Seq#Length(s#0) == Digest.__default.Length(HMAC.HMac.GetDigest($Heap, this));
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetInputSoFar#canCall($Heap, this);
    assume Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, this), Seq#Empty(): Seq);
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetDigest#canCall($Heap, this);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetDigest#canCall(old($Heap), this);
    assume AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, this), HMAC.HMac.GetDigest(old($Heap), this));
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetKey#canCall($Heap, this);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetKey#canCall(old($Heap), this);
    assume Seq#Equal(HMAC.HMac.GetKey($Heap, this), HMAC.HMac.GetKey(old($Heap), this));
    assume $IsAllocBox($Box(this), Tclass.HMAC.HMac?(), $Heap);
    assume $IsAlloc(this, Tclass.HMAC.HMac(), old($Heap));
    assume HMAC.HMac.GetInputSoFar#canCall(old($Heap), this);
    ##message#0 := HMAC.HMac.GetInputSoFar(old($Heap), this);
    assume $IsAlloc(##message#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HMAC.HMac.HashSignature#canCall(this, HMAC.HMac.GetInputSoFar(old($Heap), this), s#0);
    assume HMAC.HMac.HashSignature(this, HMAC.HMac.GetInputSoFar(old($Heap), this), s#0);
    return;
}



procedure {:verboseName "HMAC.HMac.GetResult (call precondtion)"} {:extern} CallPre$$HMAC.HMac.GetResult(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap));
  requires {:id "id3678"} Seq#Length(HMAC.HMac.GetKey($Heap, this)) > 0;



procedure {:verboseName "HMAC.HMac.GetResult (call postcondition)"} {:extern} CallPost$$HMAC.HMac.GetResult(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) returns (s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures HMAC.HMac.GetDigest#canCall($Heap, this) && Digest.__default.Length#canCall(HMAC.HMac.GetDigest($Heap, this));
  free ensures {:id "id3679"} Seq#Length(s#0) == Digest.__default.Length(HMAC.HMac.GetDigest($Heap, this));
  free ensures HMAC.HMac.GetInputSoFar#canCall($Heap, this);
  free ensures {:id "id3680"} Seq#Equal(HMAC.HMac.GetInputSoFar($Heap, this), Seq#Empty(): Seq);
  free ensures $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest($Heap, this)) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(HMAC.HMac.GetDigest(old($Heap), this)) && HMAC.HMac.GetDigest#canCall($Heap, this) && HMAC.HMac.GetDigest#canCall(old($Heap), this);
  free ensures {:id "id3681"} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(HMAC.HMac.GetDigest($Heap, this), HMAC.HMac.GetDigest(old($Heap), this));
  free ensures HMAC.HMac.GetKey#canCall($Heap, this) && HMAC.HMac.GetKey#canCall(old($Heap), this);
  free ensures {:id "id3682"} Seq#Equal(HMAC.HMac.GetKey($Heap, this), HMAC.HMac.GetKey(old($Heap), this));
  free ensures HMAC.HMac.GetInputSoFar#canCall(old($Heap), this) && HMAC.HMac.HashSignature#canCall(this, HMAC.HMac.GetInputSoFar(old($Heap), this), s#0);
  free ensures {:id "id3683"} HMAC.HMac.HashSignature(this, HMAC.HMac.GetInputSoFar(old($Heap), this), s#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



function HMAC.HMac.HashSignature(this: ref, message#0: Seq, s#0: Seq) : bool;

function HMAC.HMac.HashSignature#canCall(this: ref, message#0: Seq, s#0: Seq) : bool;

function HMAC.HMac.HashSignature#requires(ref, Seq, Seq) : bool;

axiom (forall this: ref, message#0: Seq, s#0: Seq :: { HMAC.HMac.HashSignature#requires(this, message#0, s#0) } this != null && $Is(this, Tclass.HMAC.HMac()) && $Is(message#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (HMAC.HMac.HashSignature#requires(this, message#0, s#0) <==> true));

procedure {:verboseName "HMAC.HMac.HashSignature (well-formedness)"} CheckWellformed$$HMAC.HMac.HashSignature(this: ref where this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap), message#0: Seq where $Is(message#0, TSeq(Tclass.BoundedInts.uint8())), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall c#0: ref :: { $Is(c#0, Tclass.HMAC.HMac()) } $Is(c#0, Tclass.HMAC.HMac()) <==> $Is(c#0, Tclass.HMAC.HMac?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.HMAC.HMac(), $h) } $IsAlloc(c#0, Tclass.HMAC.HMac(), $h) <==> $IsAlloc(c#0, Tclass.HMAC.HMac?(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#28 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#28))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#30 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#30)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#42 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#42))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#44 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#44)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#46 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#46)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#42 := Wrappers.Option.value(this); v#42)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#44 := Lit(Wrappers.Option.value(Lit(this))); v#44)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#46 := Lit(Wrappers.Option.value(Lit(this))); v#46)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#28 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#28)) else (var e#28 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#30 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#30))) else (var e#30 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#42 := Wrappers.Result.value(this); s#42) else (var e#42 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#44 := Lit(Wrappers.Result.value(Lit(this))); s#44) else (var e#44 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#46 := Lit(Wrappers.Result.value(Lit(this))); s#46) else (var e#46 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#42 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#42)) else (var e#42 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#42)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#44 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#44))) else (var e#44 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#44)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#46 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#46))) else (var e#46 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#46)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#16 := Div(x#0, LitInt(256)); (var b1#16 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#16)), $Box(b1#16)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#17 := LitInt(Div(x#0, LitInt(256))); (var b1#17 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#17)), $Box(b1#17))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#16 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#16 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#17 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#17 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#16 := Div(x#0, LitInt(16777216)); (var x0#16 := x#0 - Mul(b0#16, LitInt(16777216)); (var b1#16 := Div(x0#16, LitInt(65536)); (var x1#16 := x0#16 - Mul(b1#16, LitInt(65536)); (var b2#16 := Div(x1#16, LitInt(256)); (var b3#16 := Mod(x1#16, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#16)), $Box(b1#16)), $Box(b2#16)), $Box(b3#16)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#17 := LitInt(Div(x#0, LitInt(16777216))); (var x0#17 := LitInt(x#0 - Mul(b0#17, LitInt(16777216))); (var b1#17 := LitInt(Div(x0#17, LitInt(65536))); (var x1#17 := LitInt(x0#17 - Mul(b1#17, LitInt(65536))); (var b2#17 := LitInt(Div(x1#17, LitInt(256))); (var b3#17 := LitInt(Mod(x1#17, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#17)), $Box(b1#17)), $Box(b2#17)), $Box(b3#17))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#16 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#16 := x0#16 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#16 := x1#16 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#16 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#17 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#17 := x0#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#17 := x1#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#17 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#16 := Div(x#0, LitInt(72057594037927936)); (var x0#16 := x#0 - Mul(b0#16, LitInt(72057594037927936)); (var b1#16 := Div(x0#16, LitInt(281474976710656)); (var x1#16 := x0#16 - Mul(b1#16, LitInt(281474976710656)); (var b2#16 := Div(x1#16, LitInt(1099511627776)); (var x2#16 := x1#16 - Mul(b2#16, LitInt(1099511627776)); (var b3#16 := Div(x2#16, LitInt(4294967296)); (var x3#16 := x2#16 - Mul(b3#16, LitInt(4294967296)); (var b4#16 := Div(x3#16, LitInt(16777216)); (var x4#16 := x3#16 - Mul(b4#16, LitInt(16777216)); (var b5#16 := Div(x4#16, LitInt(65536)); (var x5#16 := x4#16 - Mul(b5#16, LitInt(65536)); (var b6#16 := Div(x5#16, LitInt(256)); (var b7#16 := Mod(x5#16, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#16)), $Box(b1#16)), $Box(b2#16)), $Box(b3#16)), $Box(b4#16)), $Box(b5#16)), $Box(b6#16)), $Box(b7#16)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#17 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#17 := LitInt(x#0 - Mul(b0#17, LitInt(72057594037927936))); (var b1#17 := LitInt(Div(x0#17, LitInt(281474976710656))); (var x1#17 := LitInt(x0#17 - Mul(b1#17, LitInt(281474976710656))); (var b2#17 := LitInt(Div(x1#17, LitInt(1099511627776))); (var x2#17 := LitInt(x1#17 - Mul(b2#17, LitInt(1099511627776))); (var b3#17 := LitInt(Div(x2#17, LitInt(4294967296))); (var x3#17 := LitInt(x2#17 - Mul(b3#17, LitInt(4294967296))); (var b4#17 := LitInt(Div(x3#17, LitInt(16777216))); (var x4#17 := LitInt(x3#17 - Mul(b4#17, LitInt(16777216))); (var b5#17 := LitInt(Div(x4#17, LitInt(65536))); (var x5#17 := LitInt(x4#17 - Mul(b5#17, LitInt(65536))); (var b6#17 := LitInt(Div(x5#17, LitInt(256))); (var b7#17 := LitInt(Mod(x5#17, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#17)), $Box(b1#17)), $Box(b2#17)), $Box(b3#17)), $Box(b4#17)), $Box(b5#17)), $Box(b6#17)), $Box(b7#17))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#16 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#16 := x0#16 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#16 := x1#16 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#16 := x2#16 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#16 := x3#16 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#16 := x4#16 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#16 := x5#16 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#17 := x6#16 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#17)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#17 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#17 := x0#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#17 := x1#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#17 := x2#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#17 := x3#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#17 := x4#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#17 := x5#17 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#18 := x6#17 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#18)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#16 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#16)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#16 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#16)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#16)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#17 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#17)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#17 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#17)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#17)): int)));

axiom (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0) } StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, ss#0, joiner#0) || ($Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && 0 < Seq#Length(ss#0)) ==> $Is(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T)));

axiom (forall $Heap: Heap, StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { $IsAlloc(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T), $Heap) } (StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, ss#0, joiner#0) || ($Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $IsAlloc(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T)), $Heap) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && $IsAlloc(joiner#0, TSeq(StandardLibrary._default.Join$T), $Heap) && 0 < Seq#Length(ss#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, ss#0, joiner#0), TSeq(StandardLibrary._default.Join$T), $Heap));

axiom (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), ss#0, joiner#0) } StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, ss#0, joiner#0) || ($Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && 0 < Seq#Length(ss#0)) ==> (Seq#Length(ss#0) != LitInt(1) ==> StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Seq#Drop(ss#0, LitInt(1)), joiner#0)) && StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), ss#0, joiner#0) == (if Seq#Length(ss#0) == LitInt(1) then $Unbox(Seq#Index(ss#0, LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(ss#0, LitInt(0))): Seq, joiner#0), StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $ly, Seq#Drop(ss#0, LitInt(1)), joiner#0))));

axiom (forall StandardLibrary._default.Join$T: Ty, $ly: LayerType, ss#0: Seq, joiner#0: Seq :: {:weight 3} { StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), Lit(ss#0), Lit(joiner#0)) } StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Lit(ss#0), Lit(joiner#0)) || ($Is(ss#0, TSeq(TSeq(StandardLibrary._default.Join$T))) && $Is(joiner#0, TSeq(StandardLibrary._default.Join$T)) && 0 < Seq#Length(Lit(ss#0))) ==> (Seq#Length(Lit(ss#0)) != LitInt(1) ==> StandardLibrary.__default.Join#canCall(StandardLibrary._default.Join$T, Lit(Seq#Drop(Lit(ss#0), LitInt(1))), Lit(joiner#0))) && StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), Lit(ss#0), Lit(joiner#0)) == (if Seq#Length(Lit(ss#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(ss#0), LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(Lit(ss#0), LitInt(0))): Seq, joiner#0), StandardLibrary.__default.Join(StandardLibrary._default.Join$T, $LS($ly), Lit(Seq#Drop(Lit(ss#0), LitInt(1))), Lit(joiner#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#6: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#6)): Seq } LitInt(0) <= i#6 && i#6 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#6)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall $Heap: Heap, StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { $IsAlloc(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)), $Heap) } (StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Split$T), $Heap) && $IsBox(delim#0, StandardLibrary._default.Split$T) && $IsAllocBox(delim#0, StandardLibrary._default.Split$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T)), $Heap));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#7 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#7) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#7)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#7 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#7) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#7)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#7)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#8 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#8) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#8)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#8 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#8) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#8)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#8)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#9 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#9) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#9)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#9 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#9) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#9)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#9)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0))): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0))): Seq), s#0) && !Seq#Contains($Unbox(_System.Tuple2._0(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0))): Seq, delim#0) && $Is(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T))));

axiom (forall $Heap: Heap, StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { $IsAlloc(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T)), $Heap) } (StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SplitOnce$T), $Heap) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && $IsAllocBox(delim#0, StandardLibrary._default.SplitOnce$T, $Heap) && Seq#Contains(s#0, delim#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce$T), TSeq(StandardLibrary._default.SplitOnce$T)), $Heap));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#3 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#3)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#3)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#4 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#4)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#4)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#5 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#5)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#5)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0)) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0))): DatatypeType)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0))): DatatypeType)): Seq), s#0)) && (Wrappers.Option.None_q(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0)) ==> !Seq#Contains(s#0, delim#0)) && (Wrappers.Option.Some_q(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0)) ==> !Seq#Contains($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0))): DatatypeType)): Seq, delim#0)) && $Is(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)))));

axiom (forall $Heap: Heap, StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { $IsAlloc(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))), $Heap) } (StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.SplitOnce?$T), $Heap) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T) && $IsAllocBox(delim#0, StandardLibrary._default.SplitOnce?$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T))), $Heap));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#3 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#3) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#3) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#3)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#3) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#3))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#3 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#3) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#3) else (var i#3 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#3)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#3)), $Box(Seq#Drop(s#0, i#3 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#4 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#4) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#4) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#4)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#4) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#4))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#4 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#4) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#4) else (var i#4 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#4)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#4)), $Box(Seq#Drop(Lit(s#0), i#4 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#5 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#5) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#5) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#5)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#5) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#5))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#5 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#5) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#5) else (var i#5 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#5)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#5))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#5 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int < Seq#Length(s#0) && Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int) == c#0 && !Seq#Contains(Seq#Drop(Seq#Take(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0))): int), i#0), c#0)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0)) ==> !Seq#Contains(Seq#Drop(s#0, i#0), c#0)) && $Is(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#x#0: Box :: $Box($l#18#x#0 == c#0)), (lambda $l#18#heap#0: Heap, $l#18#x#0: Box :: $IsBox($l#18#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#18#heap#0: Heap, $l#18#x#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#x#0: Box :: $Box($l#16#x#0 == c#0)), (lambda $l#16#heap#0: Heap, $l#16#x#0: Box :: $IsBox($l#16#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#16#heap#0: Heap, $l#16#x#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#x#0: Box :: $Box($l#21#x#0 == c#0)), (lambda $l#21#heap#0: Heap, $l#21#x#0: Box :: $IsBox($l#21#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#21#heap#0: Heap, $l#21#x#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#x#0: Box :: $Box($l#19#x#0 == c#0)), (lambda $l#19#heap#0: Heap, $l#19#x#0: Box :: $IsBox($l#19#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#19#heap#0: Heap, $l#19#x#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#x#0: Box :: $Box($l#24#x#0 == Lit(c#0))), (lambda $l#24#heap#0: Heap, $l#24#x#0: Box :: $IsBox($l#24#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#24#heap#0: Heap, $l#24#x#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#x#0: Box :: $Box($l#22#x#0 == Lit(c#0))), (lambda $l#22#heap#0: Heap, $l#22#x#0: Box :: $IsBox($l#22#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#22#heap#0: Heap, $l#22#x#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#6: int :: { Seq#Index(s#0, j#6) } i#0 <= j#6 && j#6 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#6))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#7: int :: { Seq#Index(s#0, j#7) } i#0 <= j#7 && j#7 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#7))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (i#0 != Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0 + 1)) && StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), s#0, f#0, i#0) == (if i#0 == Seq#Length(s#0) then #Wrappers.Option.None() else (if $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, i#0))): bool then #Wrappers.Option.Some($Box(i#0)) else StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0 + 1))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), f#0, LitInt(i#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), f#0, LitInt(i#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> (LitInt(i#0) != Seq#Length(Lit(s#0)) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(i#0)))): bool ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), f#0, LitInt(i#0 + 1))) && StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), f#0, LitInt(i#0)) == (if LitInt(i#0) == Seq#Length(Lit(s#0)) then #Wrappers.Option.None() else (if $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(i#0)))): bool then #Wrappers.Option.Some($Box(LitInt(i#0))) else StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), f#0, LitInt(i#0 + 1)))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), Lit(f#0), LitInt(i#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), Lit(f#0), LitInt(i#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> (LitInt(i#0) != Seq#Length(Lit(s#0)) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(i#0)))): bool ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, Lit(s#0), Lit(f#0), LitInt(i#0 + 1))) && StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), Lit(f#0), LitInt(i#0)) == (if LitInt(i#0) == Seq#Length(Lit(s#0)) then #Wrappers.Option.None() else (if $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(i#0)))): bool then #Wrappers.Option.Some($Box(LitInt(i#0))) else StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $LS($ly), Lit(s#0), Lit(f#0), LitInt(i#0 + 1)))));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#6: int :: { Seq#Index(s#0, i#6) } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#6))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#6))) && (forall i#7: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#7) } (LitInt(0) <= i#7 && i#7 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#7))) && (LitInt(0) <= i#7 && i#7 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#7))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { $IsAlloc(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T), $Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> $IsAlloc(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T), $Heap));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) ==> (Seq#Length(s#0) != LitInt(0) ==> ($Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Seq#Drop(s#0, LitInt(1)), f#0))) && StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), s#0, f#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (if $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, Seq#Drop(s#0, LitInt(1)), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, Seq#Drop(s#0, LitInt(1)), f#0))));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: {:weight 3} { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(s#0), f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> ($Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0)) && (!$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0))) && StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), f#0) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (if $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Lit(s#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(s#0), LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0)) else StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), f#0))));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: {:weight 3} { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), Lit(f#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(s#0), Lit(f#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> ($Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0))) && (!$Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(0)))): bool ==> StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0)))) && StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(s#0), Lit(f#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (if $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, Lit(f#0), Seq#Index(Lit(s#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(s#0), LitInt(0))), StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0))) else StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), Lit(f#0)))));

axiom (forall a#0: int, b#0: int :: { StandardLibrary.__default.Min(a#0, b#0) } StandardLibrary.__default.Min(a#0, b#0) == (if a#0 < b#0 then a#0 else b#0));

axiom (forall a#0: int, b#0: int :: {:weight 3} { StandardLibrary.__default.Min(LitInt(a#0), LitInt(b#0)) } StandardLibrary.__default.Min(LitInt(a#0), LitInt(b#0)) == (if a#0 < b#0 then a#0 else b#0));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#3: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#3) } LitInt(0) <= i#3 && i#3 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#3) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall $Heap: Heap, StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { $IsAlloc(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T), $Heap) } (StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && $IsAllocBox(value#0, StandardLibrary._default.Fill$T, $Heap) && LitInt(0) <= n#0)) && $IsGoodHeap($Heap) ==> $IsAlloc(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T), $Heap));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#_v0#0: Box :: value#0), (lambda $l#10#heap#0: Heap, $l#10#_v0#0: Box :: $IsBox($l#10#_v0#0, TInt)), (lambda $l#10#heap#0: Heap, $l#10#_v0#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: value#0), (lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: $IsBox($l#12#_v0#0, TInt)), (lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#_v0#0: Box :: Lit(value#0)), (lambda $l#14#heap#0: Heap, $l#14#_v0#0: Box :: $IsBox($l#14#_v0#0, TInt)), (lambda $l#14#heap#0: Heap, $l#14#_v0#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#5: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#5) } LitInt(0) <= k#5 ==> k#5 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#5)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#5: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#5) } LitInt(0) <= k#5 && k#5 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#5))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#6: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#6) } LitInt(0) <= k#6 ==> k#6 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#6)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#6: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#6) } LitInt(0) <= k#6 && k#6 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#6))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#7: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#7) } LitInt(0) <= k#7 ==> k#7 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#7)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#7: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#7) } LitInt(0) <= k#7 && k#7 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#7))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#5: int :: { Seq#Index(b#0, i#5) } { Seq#Index(a#0, i#5) } LitInt(0) <= i#5 && i#5 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#5) == Seq#Index(b#0, i#5)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#6: int :: { Seq#Index(b#0, i#6) } { Seq#Index(a#0, i#6) } LitInt(0) <= i#6 && i#6 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#6) == Seq#Index(Lit(b#0), i#6)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#7: int :: { Seq#Index(b#0, i#7) } { Seq#Index(a#0, i#7) } LitInt(0) <= i#7 && i#7 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#7) == Seq#Index(Lit(b#0), i#7)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#12: Box, y#12: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#12, x#12)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#12, y#12)): bool } $IsBox(x#12, StandardLibrary._default.Trichotomous$T) && $IsBox(y#12, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#12, y#12)): bool || x#12 == y#12 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#12, x#12)): bool) && (forall x#13: Box, y#13: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#13, x#13)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#13, y#13)): bool } $IsBox(x#13, StandardLibrary._default.Trichotomous$T) && $IsBox(y#13, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#13, y#13)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#13, x#13)): bool ==> false) && (forall x#14: Box, y#14: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#14, y#14)): bool } $IsBox(x#14, StandardLibrary._default.Trichotomous$T) && $IsBox(y#14, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#14, y#14)): bool ==> x#14 != y#14)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#15: Box, y#15: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#15, x#15)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#15, y#15)): bool } $IsBox(x#15, StandardLibrary._default.Trichotomous$T) && $IsBox(y#15, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#15, y#15)): bool || x#15 == y#15 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#15, x#15)): bool) && (forall x#16: Box, y#16: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#16, x#16)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#16, y#16)): bool } $IsBox(x#16, StandardLibrary._default.Trichotomous$T) && $IsBox(y#16, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#16, y#16)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#16, x#16)): bool ==> false) && (forall x#17: Box, y#17: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#17, y#17)): bool } $IsBox(x#17, StandardLibrary._default.Trichotomous$T) && $IsBox(y#17, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#17, y#17)): bool ==> x#17 != y#17)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#4: Box, y#4: Box, z#4: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#4, z#4)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#4, z#4)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#4, z#4)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#4, y#4)): bool } $IsBox(x#4, StandardLibrary._default.Transitive$T) && $IsBox(y#4, StandardLibrary._default.Transitive$T) && $IsBox(z#4, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#4, y#4)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#4, z#4)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#4, z#4)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#5: Box, y#5: Box, z#5: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#5, z#5)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#5, z#5)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#5, z#5)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#5, y#5)): bool } $IsBox(x#5, StandardLibrary._default.Transitive$T) && $IsBox(y#5, StandardLibrary._default.Transitive$T) && $IsBox(z#5, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#5, y#5)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#5, z#5)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#5, z#5)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#9: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#9)): Seq } LitInt(0) <= i#9 && i#9 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#9)]) && (forall k#3: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#3)) } { s#0[$Box(k#3)] } $Is(k#3, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#3)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#3))) && (forall i#10: int, _t#0#2: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#10)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#2)): Seq } _t#0#2 == i#10 - 1 ==> 0 < i#10 && i#10 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#2)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#10)): Seq, less#0)) && (forall i#11: int, j#3: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#3)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#11)): Seq } LitInt(0) <= i#11 && i#11 < j#3 && j#3 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#11)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#3)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#8 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#8)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#8))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#9 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#9)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#9))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#10 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#10)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#10))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#5: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#5, less#0) } { s#0[$Box(z#5)] } $Is(z#5, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#5)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#5, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#5: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#5, less#0) } { s#0[$Box(z#5)] } $Is(z#5, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#5)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#5, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#6: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#6, less#0) } { s#0[$Box(z#6)] } $Is(z#6, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#6)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#6, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#6: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#6, less#0) } { s#0[$Box(z#6)] } $Is(z#6, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#6)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#6, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#7: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#7, less#0) } { s#0[$Box(z#7)] } $Is(z#7, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#7)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#7, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#7: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#7, less#0) } { s#0[$Box(z#7)] } $Is(z#7, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#7)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#7, Lit(less#0)))));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#10: int :: { $Unbox(Seq#Index(s#0, i#10)): char } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#11: int :: { $Unbox(Seq#Index(s#0, i#11)): char } LitInt(0) <= i#11 && i#11 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#11)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#8: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#8)): int } { $Unbox(Seq#Index(s#0, i#8)): char } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#8)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#8 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#8, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#9 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#9, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#12 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#12) && (UTF8.__default.Uses1Byte(r#12) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#12) ==> (LitInt(2) <= Seq#Length(r#12) ==> UTF8.__default.Uses2Bytes#canCall(r#12)) && (LitInt(2) <= Seq#Length(r#12) && UTF8.__default.Uses2Bytes(r#12) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#12) && UTF8.__default.Uses2Bytes(r#12)) ==> (LitInt(3) <= Seq#Length(r#12) ==> UTF8.__default.Uses3Bytes#canCall(r#12)) && (LitInt(3) <= Seq#Length(r#12) && UTF8.__default.Uses3Bytes(r#12) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#12) && UTF8.__default.Uses3Bytes(r#12)) ==> (LitInt(4) <= Seq#Length(r#12) ==> UTF8.__default.Uses4Bytes#canCall(r#12)) && (LitInt(4) <= Seq#Length(r#12) && UTF8.__default.Uses4Bytes(r#12) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#12 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#12) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#12) && UTF8.__default.Uses2Bytes(r#12) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#12) && UTF8.__default.Uses3Bytes(r#12) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#12) && UTF8.__default.Uses4Bytes(r#12) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#13 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#13) && (UTF8.__default.Uses1Byte(r#13) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#13) ==> (LitInt(2) <= Seq#Length(r#13) ==> UTF8.__default.Uses2Bytes#canCall(r#13)) && (LitInt(2) <= Seq#Length(r#13) && UTF8.__default.Uses2Bytes(r#13) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#13) && UTF8.__default.Uses2Bytes(r#13)) ==> (LitInt(3) <= Seq#Length(r#13) ==> UTF8.__default.Uses3Bytes#canCall(r#13)) && (LitInt(3) <= Seq#Length(r#13) && UTF8.__default.Uses3Bytes(r#13) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#13) && UTF8.__default.Uses3Bytes(r#13)) ==> (LitInt(4) <= Seq#Length(r#13) ==> UTF8.__default.Uses4Bytes#canCall(r#13)) && (LitInt(4) <= Seq#Length(r#13) && UTF8.__default.Uses4Bytes(r#13) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#13 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#13) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#13) && UTF8.__default.Uses2Bytes(r#13) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#13) && UTF8.__default.Uses3Bytes(r#13) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#13) && UTF8.__default.Uses4Bytes(r#13) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#14 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#14) && (UTF8.__default.Uses1Byte(r#14) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#14) ==> (LitInt(2) <= Seq#Length(r#14) ==> UTF8.__default.Uses2Bytes#canCall(r#14)) && (LitInt(2) <= Seq#Length(r#14) && UTF8.__default.Uses2Bytes(r#14) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#14) && UTF8.__default.Uses2Bytes(r#14)) ==> (LitInt(3) <= Seq#Length(r#14) ==> UTF8.__default.Uses3Bytes#canCall(r#14)) && (LitInt(3) <= Seq#Length(r#14) && UTF8.__default.Uses3Bytes(r#14) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#14) && UTF8.__default.Uses3Bytes(r#14)) ==> (LitInt(4) <= Seq#Length(r#14) ==> UTF8.__default.Uses4Bytes#canCall(r#14)) && (LitInt(4) <= Seq#Length(r#14) && UTF8.__default.Uses4Bytes(r#14) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#14 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#14) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#14) && UTF8.__default.Uses2Bytes(r#14) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#14) && UTF8.__default.Uses3Bytes(r#14) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#14) && UTF8.__default.Uses4Bytes(r#14) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall digestAlgorithm#0: DatatypeType :: { Digest.__default.Length(digestAlgorithm#0) } Digest.__default.Length#canCall(digestAlgorithm#0) || $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> LitInt(0) <= Digest.__default.Length(digestAlgorithm#0));

axiom (forall digestAlgorithm#0: DatatypeType :: { Digest.__default.Length(digestAlgorithm#0) } Digest.__default.Length#canCall(digestAlgorithm#0) || $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> Digest.__default.Length(digestAlgorithm#0) == (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(digestAlgorithm#0) then 64 else (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(digestAlgorithm#0) then 48 else 32)));

axiom (forall digestAlgorithm#0: DatatypeType :: {:weight 3} { Digest.__default.Length(Lit(digestAlgorithm#0)) } Digest.__default.Length#canCall(Lit(digestAlgorithm#0)) || $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) ==> Digest.__default.Length(Lit(digestAlgorithm#0)) == (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__512_q(Lit(digestAlgorithm#0)) then 64 else (if AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA__384_q(Lit(digestAlgorithm#0)) then 48 else 32)));

const unique tytagFamily$HMac: TyTagFamily;

const unique class.KdfCtr.__default: ClassName;

function KdfCtr.__default.SEPARATION__INDICATOR() : Seq
uses {
axiom KdfCtr.__default.SEPARATION__INDICATOR(): Seq == Lit(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(0))));
axiom 0 < $FunctionContextHeight ==> $Is(KdfCtr.__default.SEPARATION__INDICATOR(), TSeq(Tclass.BoundedInts.uint8()));
}

procedure {:verboseName "KdfCtr.SEPARATION_INDICATOR (well-formedness)"} CheckWellFormed$$KdfCtr.__default.SEPARATION__INDICATOR();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "KdfCtr.SEPARATION_INDICATOR (well-formedness)"} CheckWellFormed$$KdfCtr.__default.SEPARATION__INDICATOR()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "KdfCtr.SEPARATION_INDICATOR"} true;
    assume {:print "Types"} true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(21,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(KdfCtr.__default.SEPARATION__INDICATOR(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(KdfCtr.__default.SEPARATION__INDICATOR(), TSeq(Tclass.BoundedInts.uint8()), $h));

function KdfCtr.__default.COUNTER__START__VALUE() : int
uses {
axiom KdfCtr.__default.COUNTER__START__VALUE(): int == LitInt(1);
axiom 0 < $FunctionContextHeight ==> $Is(KdfCtr.__default.COUNTER__START__VALUE(), Tclass.BoundedInts.uint32());
}

procedure {:verboseName "KdfCtr.COUNTER_START_VALUE (well-formedness)"} CheckWellFormed$$KdfCtr.__default.COUNTER__START__VALUE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "KdfCtr.COUNTER_START_VALUE (well-formedness)"} CheckWellFormed$$KdfCtr.__default.COUNTER__START__VALUE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "KdfCtr.COUNTER_START_VALUE"} true;
    assume {:print "Types"} true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(22,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(KdfCtr.__default.COUNTER__START__VALUE(), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) ==> $IsAlloc(KdfCtr.__default.COUNTER__START__VALUE(), Tclass.BoundedInts.uint32(), $h));

procedure {:verboseName "KdfCtr.KdfCounterMode (well-formedness)"} {:testEntry} CheckWellFormed$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "KdfCtr.KdfCounterMode (well-formedness)"} {:testEntry} CheckWellFormed$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Block", " | ", "CheckWellFormed$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(29,28):post-state"} true;
    assume {:print "Block", " | ", "CheckWellFormed$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(27,22):initialstate"} true;
    assume {:print "Impl", " | ", "KdfCtr.KdfCounterMode", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(27,22): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(29,28): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Wrappers.Result.Success_q(output#0);
    assume Wrappers.Result.Success_q(output#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    newtype$check#0 := AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
    assume LitInt(0) <= newtype$check#0;
    newtype$check#1 := AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
    assume LitInt(0) <= newtype$check#1;
    assume Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
    return;

  anon4_Else:
    assume Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
    return;
}



procedure {:verboseName "KdfCtr.KdfCounterMode (call precondtion)"} {:testEntry} CallPre$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0));



procedure {:verboseName "KdfCtr.KdfCounterMode (call postcondition)"} {:testEntry} CallPost$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(output#0) ==> AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
  free ensures {:id "id3697"} Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "KdfCtr.KdfCounterMode (correctness)"} {:testEntry} Impl$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(output#0) ==> AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
  free ensures {:id "id3698"} Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "KdfCtr.KdfCounterMode (correctness)"} {:testEntry} Impl$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var defass##tmp0#1_1_0: bool;
  var #tmp0#1_1_0: DatatypeType where defass##tmp0#1_1_0 ==> $Is(#tmp0#1_1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(#tmp0#1_1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var defass##tmp1#1_1_0: bool;
  var #tmp1#1_1_0: DatatypeType where defass##tmp1#1_1_0 ==> $Is(#tmp1#1_1_0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp1#1_1_0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
  var defass##tmp2#0: bool;
  var #tmp2#0: bool;
  var defass##tmp4#0: bool;
  var #tmp4#0: bool;
  var defass##tmp5#0: bool;
  var #tmp5#0: bool;
  var defass##tmp6#0: bool;
  var #tmp6#0: bool;
  var defass##tmp7#0: bool;
  var #tmp7#0: bool;
  var defass##tmp8#0: bool;
  var #tmp8#0: bool;
  var defass##tmp9#4_0: bool;
  var #tmp9#4_0: bool;
  var defass##tmp10#4_0: bool;
  var #tmp10#4_0: bool;
  var defass##tmp11#8_0: bool;
  var #tmp11#8_0: bool;
  var defass##tmp12#10_0: bool;
  var #tmp12#10_0: bool;
  var newtype$check#10_0: int;
  var newtype$check#10_0_0: int;
  var defass##tmp3#0: bool;
  var #tmp3#0: DatatypeType where defass##tmp3#0 ==> $Is(#tmp3#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp3#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var $rhs##0: DatatypeType;
  var condition##0: bool;
  var error##0: DatatypeType;
  var ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(ikm#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var label_#0: Seq where $Is(label_#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(label_#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var ##default#0: Seq;
  var info#0: Seq where $Is(info#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(info#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var ##default#1: Seq;
  var okm#0: Seq where $Is(okm#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(okm#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var internalLength#0: int where LitInt(0) <= internalLength#0 && internalLength#0 < BoundedInts.__default.TWO__TO__THE__32();
  var newtype$check#2: int;
  var newtype$check#3: int;
  var defass##tmp13#0: bool;
  var #tmp13#0: bool;
  var defass##tmp14#0: bool;
  var #tmp14#0: DatatypeType where defass##tmp14#0 ==> $Is(#tmp14#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp14#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
  var defass#valueOrError1#0: bool;
  var valueOrError1#0: DatatypeType where defass#valueOrError1#0 ==> $Is(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var $rhs##1: DatatypeType;
  var condition##1: bool;
  var error##1: DatatypeType;
  var lengthBits#0: Seq where $Is(lengthBits#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(lengthBits#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var ##x#0: int;
  var explicitInfo#0: Seq where $Is(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass##tmp15#0: bool;
  var #tmp15#0: DatatypeType where defass##tmp15#0 ==> $Is(#tmp15#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp15#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
  var defass#valueOrError2#0: bool;
  var valueOrError2#0: DatatypeType where defass#valueOrError2#0 ==> $Is(valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var $rhs##2: DatatypeType;
  var condition##2: bool;
  var error##2: DatatypeType;
  var defass#valueOrError3#0: bool;
  var valueOrError3#0: DatatypeType where defass#valueOrError3#0 ==> $Is(valueOrError3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var $rhs##3: DatatypeType;
  var ikm##0: Seq;
  var explicitInfo##0: Seq;
  var length##0: int;
  var offset##0: int;
  var newtype$check#8: int;
  var digestAlgorithm##0: DatatypeType;
  var defass##tmp16#0: bool;
  var #tmp16#0: DatatypeType where defass##tmp16#0 ==> $Is(#tmp16#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(#tmp16#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$CallPost$$Wrappers.__default.Need$0$defass#result#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$0$$_reverifyPost: bool;
  var inline$CallPost$$Wrappers.__default.Need$0$Wrappers._default.Need$E: Ty;
  var inline$CallPost$$Wrappers.__default.Need$0$condition#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$0$error#0: Box;
  var inline$CallPost$$Wrappers.__default.Need$0$result#0: DatatypeType;
  var inline$CallPost$$Wrappers.__default.Need$0$$Heap: Heap;
  var inline$Impl$$Wrappers.__default.Need$0$$_ModifiesFrame: [ref,Field]bool;
  var inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0: bool;
  var inline$Impl$$Wrappers.__default.Need$0$#tmp0#0: DatatypeType where inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$0$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$0$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E), $Heap);
  var inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E: Ty;
  var inline$Impl$$Wrappers.__default.Need$0$condition#0: bool;
  var inline$Impl$$Wrappers.__default.Need$0$error#0: Box;
  var inline$Impl$$Wrappers.__default.Need$0$defass#result#0: bool;
  var inline$Impl$$Wrappers.__default.Need$0$result#0: DatatypeType;
  var inline$Impl$$Wrappers.__default.Need$0$$_reverifyPost: bool;
  var inline$Impl$$Wrappers.__default.Need$0$$Heap: Heap;
  var inline$CallPost$$Wrappers.__default.Need$1$defass#result#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$1$$_reverifyPost: bool;
  var inline$CallPost$$Wrappers.__default.Need$1$Wrappers._default.Need$E: Ty;
  var inline$CallPost$$Wrappers.__default.Need$1$condition#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$1$error#0: Box;
  var inline$CallPost$$Wrappers.__default.Need$1$result#0: DatatypeType;
  var inline$CallPost$$Wrappers.__default.Need$1$$Heap: Heap;
  var inline$Impl$$Wrappers.__default.Need$1$$_ModifiesFrame: [ref,Field]bool;
  var inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0: bool;
  var inline$Impl$$Wrappers.__default.Need$1$#tmp0#0: DatatypeType where inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$1$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$1$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E), $Heap);
  var inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E: Ty;
  var inline$Impl$$Wrappers.__default.Need$1$condition#0: bool;
  var inline$Impl$$Wrappers.__default.Need$1$error#0: Box;
  var inline$Impl$$Wrappers.__default.Need$1$defass#result#0: bool;
  var inline$Impl$$Wrappers.__default.Need$1$result#0: DatatypeType;
  var inline$Impl$$Wrappers.__default.Need$1$$_reverifyPost: bool;
  var inline$Impl$$Wrappers.__default.Need$1$$Heap: Heap;
  var inline$CallPost$$Wrappers.__default.Need$2$defass#result#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$2$$_reverifyPost: bool;
  var inline$CallPost$$Wrappers.__default.Need$2$Wrappers._default.Need$E: Ty;
  var inline$CallPost$$Wrappers.__default.Need$2$condition#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$2$error#0: Box;
  var inline$CallPost$$Wrappers.__default.Need$2$result#0: DatatypeType;
  var inline$CallPost$$Wrappers.__default.Need$2$$Heap: Heap;
  var inline$Impl$$Wrappers.__default.Need$2$$_ModifiesFrame: [ref,Field]bool;
  var inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0: bool;
  var inline$Impl$$Wrappers.__default.Need$2$#tmp0#0: DatatypeType where inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$2$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$2$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E), $Heap);
  var inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E: Ty;
  var inline$Impl$$Wrappers.__default.Need$2$condition#0: bool;
  var inline$Impl$$Wrappers.__default.Need$2$error#0: Box;
  var inline$Impl$$Wrappers.__default.Need$2$defass#result#0: bool;
  var inline$Impl$$Wrappers.__default.Need$2$result#0: DatatypeType;
  var inline$Impl$$Wrappers.__default.Need$2$$_reverifyPost: bool;
  var inline$Impl$$Wrappers.__default.Need$2$$Heap: Heap;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$defass#output#0: bool;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$$_reverifyPost: bool;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$ikm#0: Seq;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$explicitInfo#0: Seq;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$length#0: int;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$offset#0: int;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0: DatatypeType;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$output#0: DatatypeType;
  var inline$CallPost$$KdfCtr.__default.RawDerive$0$$Heap: Heap;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame: [ref,Field]bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0: ref where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, Tclass.HMAC.HMac()) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, Tclass.HMAC.HMac(), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0: DatatypeType where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##0: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$digest##0: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$key##0: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0: int where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0 ==> LitInt(0) <= inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$##digestAlgorithm#2: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0: int where LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 && inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 < 2147483648;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#1: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#2: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0: int where LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 && inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 < 2147483648;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#3: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#4: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#5: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#6: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0: Seq where $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$i#0: Seq where $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$##x#0: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#7: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#8: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#9: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#x: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0: Heap;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#output#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass##tmp0#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#valueOrError0#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#hmac#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_0: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_1: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0: Seq where $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_0: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0: DatatypeType where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_1: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$x##1_0: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0: DatatypeType where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0: DatatypeType where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$condition##0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$error##0: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0: DatatypeType where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$explicitInfo#0: Seq;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$length#0: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$offset#0: int;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$output#0: DatatypeType;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$_reverifyPost: bool;
  var inline$Impl$$KdfCtr.__default.RawDerive$0$$Heap: Heap;
  var inline$CallPost$$KdfCtr.__default.Increment$0$defass#ret#0: bool;
  var inline$CallPost$$KdfCtr.__default.Increment$0$$_reverifyPost: bool;
  var inline$CallPost$$KdfCtr.__default.Increment$0$x#0: Seq;
  var inline$CallPost$$KdfCtr.__default.Increment$0$ret#0: DatatypeType;
  var inline$CallPost$$KdfCtr.__default.Increment$0$$Heap: Heap;
  var inline$Impl$$KdfCtr.__default.Increment$0$$_ModifiesFrame: [ref,Field]bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0: DatatypeType where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_1: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0: DatatypeType where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_1: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_2: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0: DatatypeType where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_1: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_2: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_3: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0: DatatypeType where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_0: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_1: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_2: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_3: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_4: int;
  var inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0: DatatypeType where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap);
  var inline$Impl$$KdfCtr.__default.Increment$0$x#0: Seq;
  var inline$Impl$$KdfCtr.__default.Increment$0$defass#ret#0: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$ret#0: DatatypeType;
  var inline$Impl$$KdfCtr.__default.Increment$0$$_reverifyPost: bool;
  var inline$Impl$$KdfCtr.__default.Increment$0$$Heap: Heap;
  var inline$CallPost$$Wrappers.__default.Need$3$defass#result#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$3$$_reverifyPost: bool;
  var inline$CallPost$$Wrappers.__default.Need$3$Wrappers._default.Need$E: Ty;
  var inline$CallPost$$Wrappers.__default.Need$3$condition#0: bool;
  var inline$CallPost$$Wrappers.__default.Need$3$error#0: Box;
  var inline$CallPost$$Wrappers.__default.Need$3$result#0: DatatypeType;
  var inline$CallPost$$Wrappers.__default.Need$3$$Heap: Heap;
  var inline$Impl$$Wrappers.__default.Need$3$$_ModifiesFrame: [ref,Field]bool;
  var inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0: bool;
  var inline$Impl$$Wrappers.__default.Need$3$#tmp0#0: DatatypeType where inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$3$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$3$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E), $Heap);
  var inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E: Ty;
  var inline$Impl$$Wrappers.__default.Need$3$condition#0: bool;
  var inline$Impl$$Wrappers.__default.Need$3$error#0: Box;
  var inline$Impl$$Wrappers.__default.Need$3$defass#result#0: bool;
  var inline$Impl$$Wrappers.__default.Need$3$result#0: DatatypeType;
  var inline$Impl$$Wrappers.__default.Need$3$$_reverifyPost: bool;
  var inline$Impl$$Wrappers.__default.Need$3$$Heap: Heap;

  anon0:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(75,2)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(30,2):initialstate"} true;
    assume {:print "Impl", " | ", "KdfCtr.KdfCounterMode", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(30,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume Lit(true);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(75,2)"} true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0)) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0), #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256());
    push;
    pop;
    goto anon7;

  anon60_Else:
    assume {:partition} !AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0), #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256());
    push;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0)) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0), #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
    push;
    pop;
    pop;
    goto anon7;

  anon61_Else:
    assume {:partition} !AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0), #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(37,111)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(37,110)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(37,109)"} true;
    push;
    havoc #tmp0#1_1_0 /* where defass##tmp0#1_1_0 ==> $Is(#tmp0#1_1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(#tmp0#1_1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    havoc #tmp1#1_1_0 /* where defass##tmp1#1_1_0 ==> $Is(#tmp1#1_1_0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp1#1_1_0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */;
    assume true;
    assume true;
    #tmp1#1_1_0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(75))), $Box(char#FromInt(100))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(77))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))));
    defass##tmp1#1_1_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(37,109)"} true;
    assume true;
    assume defass##tmp1#1_1_0;
    assume true;
    #tmp0#1_1_0 := #Wrappers.Result.Failure($Box(#tmp1#1_1_0));
    defass##tmp0#1_1_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(37,110)"} true;
    assume true;
    assume defass##tmp0#1_1_0;
    assume true;
    output#0 := #tmp0#1_1_0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(37,111)"} true;
    assume defass#output#0;
    pop;
    pop;
    return;

  anon7:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,10)"} true;
    havoc #tmp2#0;
    havoc #tmp4#0;
    havoc #tmp5#0;
    havoc #tmp6#0;
    havoc #tmp7#0;
    havoc #tmp8#0;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0)) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp8#0 := AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0), #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256());
    defass##tmp8#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,10)"} true;
    assume defass##tmp8#0;
    assume true;
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume {:partition} !#tmp8#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,68)#thenBranch"} true;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0)) && AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp8#0 := AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0), #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
    defass##tmp8#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,68)#thenBranch"} true;
    pop;
    goto anon10;

  anon62_Else:
    assume {:partition} #tmp8#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,57)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp8#0;
    assume true;
    #tmp8#0 := #tmp8#0;
    defass##tmp8#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,57)#elseBranch"} true;
    pop;
    goto anon10;

  anon10:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume true;
    assume defass##tmp8#0;
    assume true;
    #tmp7#0 := #tmp8#0;
    defass##tmp7#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume defass##tmp7#0;
    assume true;
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} #tmp7#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,10)"} true;
    push;
    havoc #tmp9#4_0;
    havoc #tmp10#4_0;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp10#4_0 := Seq#Length(AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(input#0)) == LitInt(32);
    defass##tmp10#4_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,10)"} true;
    assume defass##tmp10#4_0;
    assume true;
    goto anon64_Then, anon64_Else;

  anon64_Then:
    assume {:partition} !#tmp10#4_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,31)#thenBranch"} true;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp10#4_0 := Seq#Length(AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(input#0)) == LitInt(48);
    defass##tmp10#4_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,31)#thenBranch"} true;
    pop;
    goto anon14;

  anon64_Else:
    assume {:partition} #tmp10#4_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,25)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp10#4_0;
    assume true;
    #tmp10#4_0 := #tmp10#4_0;
    defass##tmp10#4_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,25)#elseBranch"} true;
    pop;
    goto anon14;

  anon14:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,10)"} true;
    assume true;
    assume defass##tmp10#4_0;
    assume true;
    #tmp9#4_0 := #tmp10#4_0;
    defass##tmp9#4_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,10)"} true;
    assume defass##tmp9#4_0;
    assume true;
    goto anon65_Then, anon65_Else;

  anon65_Then:
    assume {:partition} !#tmp9#4_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,52)#thenBranch"} true;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp9#4_0 := Seq#Length(AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(input#0)) == LitInt(66);
    defass##tmp9#4_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,52)#thenBranch"} true;
    pop;
    goto anon17;

  anon65_Else:
    assume {:partition} #tmp9#4_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,46)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp9#4_0;
    assume true;
    #tmp9#4_0 := #tmp9#4_0;
    defass##tmp9#4_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,46)#elseBranch"} true;
    pop;
    goto anon17;

  anon17:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,9)#thenBranch"} true;
    assume true;
    assume defass##tmp9#4_0;
    assume true;
    #tmp7#0 := #tmp9#4_0;
    defass##tmp7#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,9)#thenBranch"} true;
    pop;
    goto anon19;

  anon63_Else:
    assume {:partition} !#tmp7#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,122)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp7#0;
    assume true;
    #tmp7#0 := #tmp7#0;
    defass##tmp7#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,122)#elseBranch"} true;
    pop;
    goto anon19;

  anon19:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume true;
    assume defass##tmp7#0;
    assume true;
    #tmp6#0 := #tmp7#0;
    defass##tmp6#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume defass##tmp6#0;
    assume true;
    goto anon66_Then, anon66_Else;

  anon66_Then:
    assume {:partition} #tmp6#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(44,9)#thenBranch"} true;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp6#0 := Wrappers.Option.Some_q(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0));
    defass##tmp6#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(44,9)#thenBranch"} true;
    pop;
    goto anon22;

  anon66_Else:
    assume {:partition} !#tmp6#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,69)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp6#0;
    assume true;
    #tmp6#0 := #tmp6#0;
    defass##tmp6#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(43,69)#elseBranch"} true;
    pop;
    goto anon22;

  anon22:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume true;
    assume defass##tmp6#0;
    assume true;
    #tmp5#0 := #tmp6#0;
    defass##tmp5#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume defass##tmp5#0;
    assume true;
    goto anon67_Then, anon67_Else;

  anon67_Then:
    assume {:partition} #tmp5#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,10)"} true;
    push;
    havoc #tmp11#8_0;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume Wrappers.Option.Some_q(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0));
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp11#8_0 := Seq#Length($Unbox(Wrappers.Option.value(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0))): Seq) == LitInt(16);
    defass##tmp11#8_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,10)"} true;
    assume defass##tmp11#8_0;
    assume true;
    goto anon68_Then, anon68_Else;

  anon68_Then:
    assume {:partition} !#tmp11#8_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,39)#thenBranch"} true;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume Wrappers.Option.Some_q(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0));
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp11#8_0 := Seq#Length($Unbox(Wrappers.Option.value(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0))): Seq) == LitInt(32);
    defass##tmp11#8_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,39)#thenBranch"} true;
    pop;
    goto anon26;

  anon68_Else:
    assume {:partition} #tmp11#8_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,33)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp11#8_0;
    assume true;
    #tmp11#8_0 := #tmp11#8_0;
    defass##tmp11#8_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,33)#elseBranch"} true;
    pop;
    goto anon26;

  anon26:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,9)#thenBranch"} true;
    assume true;
    assume defass##tmp11#8_0;
    assume true;
    #tmp5#0 := #tmp11#8_0;
    defass##tmp5#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,9)#thenBranch"} true;
    pop;
    goto anon28;

  anon67_Else:
    assume {:partition} !#tmp5#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(44,21)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp5#0;
    assume true;
    #tmp5#0 := #tmp5#0;
    defass##tmp5#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(44,21)#elseBranch"} true;
    pop;
    goto anon28;

  anon28:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume true;
    assume defass##tmp5#0;
    assume true;
    #tmp4#0 := #tmp5#0;
    defass##tmp4#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,9)"} true;
    assume defass##tmp4#0;
    assume true;
    goto anon69_Then, anon69_Else;

  anon69_Then:
    assume {:partition} #tmp4#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,10)"} true;
    push;
    havoc #tmp12#10_0;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    newtype$check#10_0 := LitInt(32);
    assume LitInt(-2147483648) <= newtype$check#10_0 && newtype$check#10_0 < 2147483648;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp12#10_0 := AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0) == LitInt(32);
    defass##tmp12#10_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,10)"} true;
    assume defass##tmp12#10_0;
    assume true;
    goto anon70_Then, anon70_Else;

  anon70_Then:
    assume {:partition} !#tmp12#10_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,40)#thenBranch"} true;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    newtype$check#10_0_0 := LitInt(64);
    assume LitInt(-2147483648) <= newtype$check#10_0_0 && newtype$check#10_0_0 < 2147483648;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    #tmp12#10_0 := AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0) == LitInt(64);
    defass##tmp12#10_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,40)#thenBranch"} true;
    pop;
    goto anon32;

  anon70_Else:
    assume {:partition} #tmp12#10_0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,34)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp12#10_0;
    assume true;
    #tmp12#10_0 := #tmp12#10_0;
    defass##tmp12#10_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,34)#elseBranch"} true;
    pop;
    goto anon32;

  anon32:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,9)#thenBranch"} true;
    assume true;
    assume defass##tmp12#10_0;
    assume true;
    #tmp4#0 := #tmp12#10_0;
    defass##tmp4#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,9)#thenBranch"} true;
    pop;
    goto anon34;

  anon69_Else:
    assume {:partition} !#tmp4#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,64)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp4#0;
    assume true;
    #tmp4#0 := #tmp4#0;
    defass##tmp4#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(45,64)#elseBranch"} true;
    pop;
    goto anon34;

  anon34:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,6)"} true;
    assume true;
    assume defass##tmp4#0;
    assume true;
    #tmp2#0 := #tmp4#0;
    defass##tmp2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(42,6)"} true;
    assume defass##tmp2#0;
    assume true;
    goto anon71_Then, anon71_Else;

  anon71_Then:
    assume {:partition} #tmp2#0;
    push;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    goto anon72_Then, anon72_Else;

  anon72_Then:
    assume {:partition} 0 < Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8));
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    goto anon37;

  anon72_Else:
    assume {:partition} Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)) <= 0;
    goto anon37;

  anon37:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(47,9)#thenBranch"} true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0) && (0 < Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)) ==> AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0));
    #tmp2#0 := 0 < Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)) && Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
    defass##tmp2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(47,9)#thenBranch"} true;
    pop;
    goto anon39;

  anon71_Else:
    assume {:partition} !#tmp2#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,66)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp2#0;
    assume true;
    #tmp2#0 := #tmp2#0;
    defass##tmp2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(46,66)#elseBranch"} true;
    pop;
    goto anon39;

  anon39:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(49,5)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(48,94)"} true;
    havoc #tmp3#0 /* where defass##tmp3#0 ==> $Is(#tmp3#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp3#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */;
    assume true;
    assume true;
    #tmp3#0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(75))), $Box(char#FromInt(100))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(77))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))));
    defass##tmp3#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(48,94)"} true;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume defass##tmp2#0;
    assume true;
    condition##0 := #tmp2#0;
    assume defass##tmp3#0;
    assume true;
    error##0 := #tmp3#0;
    call CallPre$$Wrappers.__default.Need(Tclass.AwsCryptographyPrimitivesTypes.Error(), condition##0, $Box(error##0));
    goto inline$CallPost$$Wrappers.__default.Need$0$Entry;

  inline$CallPost$$Wrappers.__default.Need$0$Entry:
    inline$CallPost$$Wrappers.__default.Need$0$Wrappers._default.Need$E := Tclass.AwsCryptographyPrimitivesTypes.Error();
    inline$CallPost$$Wrappers.__default.Need$0$condition#0 := condition##0;
    inline$CallPost$$Wrappers.__default.Need$0$error#0 := $Box(error##0);
    havoc inline$CallPost$$Wrappers.__default.Need$0$defass#result#0, inline$CallPost$$Wrappers.__default.Need$0$$_reverifyPost, inline$CallPost$$Wrappers.__default.Need$0$result#0;
    inline$CallPost$$Wrappers.__default.Need$0$$Heap := $Heap;
    goto inline$CallPost$$Wrappers.__default.Need$0$anon_0;

  inline$CallPost$$Wrappers.__default.Need$0$anon_0:
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$CallPost$$Wrappers.__default.Need$0$Wrappers._default.Need$E, " | ", inline$CallPost$$Wrappers.__default.Need$0$condition#0, " | ", inline$CallPost$$Wrappers.__default.Need$0$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    goto inline$Impl$$Wrappers.__default.Need$0$Entry;

  inline$Impl$$Wrappers.__default.Need$0$Entry:
    inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E := inline$CallPost$$Wrappers.__default.Need$0$Wrappers._default.Need$E;
    inline$Impl$$Wrappers.__default.Need$0$condition#0 := inline$CallPost$$Wrappers.__default.Need$0$condition#0;
    inline$Impl$$Wrappers.__default.Need$0$error#0 := inline$CallPost$$Wrappers.__default.Need$0$error#0;
    assume true;
    havoc inline$Impl$$Wrappers.__default.Need$0$$_ModifiesFrame, inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0, inline$Impl$$Wrappers.__default.Need$0$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$0$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$0$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E), $Heap) */, inline$Impl$$Wrappers.__default.Need$0$defass#result#0, inline$Impl$$Wrappers.__default.Need$0$result#0, inline$Impl$$Wrappers.__default.Need$0$$_reverifyPost;
    inline$Impl$$Wrappers.__default.Need$0$$Heap := $Heap;
    goto inline$Impl$$Wrappers.__default.Need$0$anon0;

  inline$Impl$$Wrappers.__default.Need$0$anon0:
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(104,14):initialstate"} true;
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E, " | ", inline$Impl$$Wrappers.__default.Need$0$condition#0, " | ", inline$Impl$$Wrappers.__default.Need$0$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    inline$Impl$$Wrappers.__default.Need$0$$_ModifiesFrame := (lambda inline$Impl$$Wrappers.__default.Need$0$$o: ref, inline$Impl$$Wrappers.__default.Need$0$$f: Field :: inline$Impl$$Wrappers.__default.Need$0$$o != null && $Unbox(read($Heap, inline$Impl$$Wrappers.__default.Need$0$$o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Wrappers.dfy(104,14): initial state"} true;
    inline$Impl$$Wrappers.__default.Need$0$$_reverifyPost := false;
    assume true;
    goto inline$Impl$$Wrappers.__default.Need$0$anon4_Then, inline$Impl$$Wrappers.__default.Need$0$anon4_Else;

  inline$Impl$$Wrappers.__default.Need$0$anon4_Then:
    assume {:partition} inline$Impl$$Wrappers.__default.Need$0$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(106,17)"} true;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$0$result#0 := Lit(#Wrappers.Outcome.Pass());
    inline$Impl$$Wrappers.__default.Need$0$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(106,17)"} true;
    assume inline$Impl$$Wrappers.__default.Need$0$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$0$condition#0, inline$Impl$$Wrappers.__default.Need$0$error#0);
    goto inline$Impl$$Wrappers.__default.Need$0$Return;

  inline$Impl$$Wrappers.__default.Need$0$anon4_Else:
    assume {:partition} !inline$Impl$$Wrappers.__default.Need$0$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,24)"} true;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,23)"} true;
    havoc inline$Impl$$Wrappers.__default.Need$0$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$0$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$0$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$0$#tmp0#0 := #Wrappers.Outcome.Fail(inline$Impl$$Wrappers.__default.Need$0$error#0);
    inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,23)"} true;
    assume true;
    assume inline$Impl$$Wrappers.__default.Need$0$defass##tmp0#0;
    assume true;
    inline$Impl$$Wrappers.__default.Need$0$result#0 := inline$Impl$$Wrappers.__default.Need$0$#tmp0#0;
    inline$Impl$$Wrappers.__default.Need$0$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,24)"} true;
    assume inline$Impl$$Wrappers.__default.Need$0$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$0$condition#0, inline$Impl$$Wrappers.__default.Need$0$error#0);
    goto inline$Impl$$Wrappers.__default.Need$0$Return;

  inline$Impl$$Wrappers.__default.Need$0$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$Impl$$Wrappers.__default.Need$0$result#0, Wrappers.__default.Need(inline$Impl$$Wrappers.__default.Need$0$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$0$condition#0, inline$Impl$$Wrappers.__default.Need$0$error#0));
    assume true;
    assume true;
    inline$CallPost$$Wrappers.__default.Need$0$defass#result#0 := inline$Impl$$Wrappers.__default.Need$0$defass#result#0;
    inline$CallPost$$Wrappers.__default.Need$0$result#0 := inline$Impl$$Wrappers.__default.Need$0$result#0;
    inline$CallPost$$Wrappers.__default.Need$0$$_reverifyPost := inline$Impl$$Wrappers.__default.Need$0$$_reverifyPost;
    goto inline$CallPost$$Wrappers.__default.Need$0$anon_0$1;

  inline$CallPost$$Wrappers.__default.Need$0$anon_0$1:
    goto inline$CallPost$$Wrappers.__default.Need$0$Return;

  inline$CallPost$$Wrappers.__default.Need$0$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$CallPost$$Wrappers.__default.Need$0$result#0, Wrappers.__default.Need(inline$CallPost$$Wrappers.__default.Need$0$Wrappers._default.Need$E, inline$CallPost$$Wrappers.__default.Need$0$condition#0, inline$CallPost$$Wrappers.__default.Need$0$error#0));
    assume true;
    assume true;
    $rhs##0 := inline$CallPost$$Wrappers.__default.Need$0$result#0;
    goto anon39$1;

  anon39$1:
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(49,5)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    goto anon73_Then, anon73_Else;

  anon73_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(49,5)"} true;
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    output#0 := Wrappers.Outcome.PropagateFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(49,5)"} true;
    assume defass#output#0;
    pop;
    return;

  anon73_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError0#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(59,6)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(57,77)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(54,17)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(53,40)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(52,44)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(51,24)"} true;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    ikm#0 := AwsCryptographyPrimitivesTypes.KdfCtrInput.ikm(input#0);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(51,24)"} true;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume $IsAllocBox($Box(AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(input#0)), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##default#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##default#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Wrappers.Option.UnwrapOr#canCall(TSeq(Tclass.BoundedInts.uint8()), AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(input#0), $Box(Lit(Seq#Empty(): Seq)));
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0) && Wrappers.Option.UnwrapOr#canCall(TSeq(Tclass.BoundedInts.uint8()), AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(input#0), $Box(Lit(Seq#Empty(): Seq)));
    label_#0 := $Unbox(Wrappers.Option.UnwrapOr(TSeq(Tclass.BoundedInts.uint8()), AwsCryptographyPrimitivesTypes.KdfCtrInput.purpose(input#0), $Box(Lit(Seq#Empty(): Seq)))): Seq;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(52,44)"} true;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume $IsAllocBox($Box(AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0)), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##default#1 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##default#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Wrappers.Option.UnwrapOr#canCall(TSeq(Tclass.BoundedInts.uint8()), AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0), $Box(Lit(Seq#Empty(): Seq)));
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0) && Wrappers.Option.UnwrapOr#canCall(TSeq(Tclass.BoundedInts.uint8()), AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0), $Box(Lit(Seq#Empty(): Seq)));
    info#0 := $Unbox(Wrappers.Option.UnwrapOr(TSeq(Tclass.BoundedInts.uint8()), AwsCryptographyPrimitivesTypes.KdfCtrInput.nonce(input#0), $Box(Lit(Seq#Empty(): Seq)))): Seq;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(53,40)"} true;
    assume true;
    assume true;
    okm#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(54,17)"} true;
    assume true;
    newtype$check#2 := 4 + Seq#Length(KdfCtr.__default.SEPARATION__INDICATOR()) + 4;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := 4 + Seq#Length(KdfCtr.__default.SEPARATION__INDICATOR()) + 4;
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    internalLength#0 := 4 + Seq#Length(KdfCtr.__default.SEPARATION__INDICATOR()) + 4;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(57,77)"} true;
    havoc #tmp13#0;
    assume true;
    assume true;
    #tmp13#0 := Lit(true);
    defass##tmp13#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(59,6)"} true;
    assume defass##tmp13#0;
    assume true;
    goto anon74_Then, anon74_Else;

  anon74_Then:
    assume {:partition} #tmp13#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(59,9)#thenBranch"} true;
    push;
    assume true;
    assume true;
    #tmp13#0 := internalLength#0 + Seq#Length(label_#0) + Seq#Length(info#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
    defass##tmp13#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(59,9)#thenBranch"} true;
    pop;
    goto anon46;

  anon74_Else:
    assume {:partition} !#tmp13#0;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(59,6)#elseBranch"} true;
    push;
    assume true;
    assume defass##tmp13#0;
    assume true;
    #tmp13#0 := #tmp13#0;
    defass##tmp13#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(59,6)#elseBranch"} true;
    pop;
    goto anon46;

  anon46:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(61,5)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(60,92)"} true;
    havoc #tmp14#0 /* where defass##tmp14#0 ==> $Is(#tmp14#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp14#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */;
    assume true;
    assume true;
    #tmp14#0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(76))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(120))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(73))), $Box(char#FromInt(78))), $Box(char#FromInt(84))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(95))), $Box(char#FromInt(77))), $Box(char#FromInt(65))), $Box(char#FromInt(88))), $Box(char#FromInt(95))), $Box(char#FromInt(76))), $Box(char#FromInt(73))), $Box(char#FromInt(77))), $Box(char#FromInt(73))), $Box(char#FromInt(84))))));
    defass##tmp14#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(60,92)"} true;
    havoc valueOrError1#0 /* where defass#valueOrError1#0 ==> $Is(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume defass##tmp13#0;
    assume true;
    condition##1 := #tmp13#0;
    assume defass##tmp14#0;
    assume true;
    error##1 := #tmp14#0;
    call CallPre$$Wrappers.__default.Need(Tclass.AwsCryptographyPrimitivesTypes.Error(), condition##1, $Box(error##1));
    goto inline$CallPost$$Wrappers.__default.Need$1$Entry;

  inline$CallPost$$Wrappers.__default.Need$1$Entry:
    inline$CallPost$$Wrappers.__default.Need$1$Wrappers._default.Need$E := Tclass.AwsCryptographyPrimitivesTypes.Error();
    inline$CallPost$$Wrappers.__default.Need$1$condition#0 := condition##1;
    inline$CallPost$$Wrappers.__default.Need$1$error#0 := $Box(error##1);
    havoc inline$CallPost$$Wrappers.__default.Need$1$defass#result#0, inline$CallPost$$Wrappers.__default.Need$1$$_reverifyPost, inline$CallPost$$Wrappers.__default.Need$1$result#0;
    inline$CallPost$$Wrappers.__default.Need$1$$Heap := $Heap;
    goto inline$CallPost$$Wrappers.__default.Need$1$anon_0;

  inline$CallPost$$Wrappers.__default.Need$1$anon_0:
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$CallPost$$Wrappers.__default.Need$1$Wrappers._default.Need$E, " | ", inline$CallPost$$Wrappers.__default.Need$1$condition#0, " | ", inline$CallPost$$Wrappers.__default.Need$1$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    goto inline$Impl$$Wrappers.__default.Need$1$Entry;

  inline$Impl$$Wrappers.__default.Need$1$Entry:
    inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E := inline$CallPost$$Wrappers.__default.Need$1$Wrappers._default.Need$E;
    inline$Impl$$Wrappers.__default.Need$1$condition#0 := inline$CallPost$$Wrappers.__default.Need$1$condition#0;
    inline$Impl$$Wrappers.__default.Need$1$error#0 := inline$CallPost$$Wrappers.__default.Need$1$error#0;
    assume true;
    havoc inline$Impl$$Wrappers.__default.Need$1$$_ModifiesFrame, inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0, inline$Impl$$Wrappers.__default.Need$1$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$1$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$1$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E), $Heap) */, inline$Impl$$Wrappers.__default.Need$1$defass#result#0, inline$Impl$$Wrappers.__default.Need$1$result#0, inline$Impl$$Wrappers.__default.Need$1$$_reverifyPost;
    inline$Impl$$Wrappers.__default.Need$1$$Heap := $Heap;
    goto inline$Impl$$Wrappers.__default.Need$1$anon0;

  inline$Impl$$Wrappers.__default.Need$1$anon0:
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(104,14):initialstate"} true;
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E, " | ", inline$Impl$$Wrappers.__default.Need$1$condition#0, " | ", inline$Impl$$Wrappers.__default.Need$1$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    inline$Impl$$Wrappers.__default.Need$1$$_ModifiesFrame := (lambda inline$Impl$$Wrappers.__default.Need$1$$o: ref, inline$Impl$$Wrappers.__default.Need$1$$f: Field :: inline$Impl$$Wrappers.__default.Need$1$$o != null && $Unbox(read($Heap, inline$Impl$$Wrappers.__default.Need$1$$o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Wrappers.dfy(104,14): initial state"} true;
    inline$Impl$$Wrappers.__default.Need$1$$_reverifyPost := false;
    assume true;
    goto inline$Impl$$Wrappers.__default.Need$1$anon4_Then, inline$Impl$$Wrappers.__default.Need$1$anon4_Else;

  inline$Impl$$Wrappers.__default.Need$1$anon4_Then:
    assume {:partition} inline$Impl$$Wrappers.__default.Need$1$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(106,17)"} true;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$1$result#0 := Lit(#Wrappers.Outcome.Pass());
    inline$Impl$$Wrappers.__default.Need$1$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(106,17)"} true;
    assume inline$Impl$$Wrappers.__default.Need$1$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$1$condition#0, inline$Impl$$Wrappers.__default.Need$1$error#0);
    goto inline$Impl$$Wrappers.__default.Need$1$Return;

  inline$Impl$$Wrappers.__default.Need$1$anon4_Else:
    assume {:partition} !inline$Impl$$Wrappers.__default.Need$1$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,24)"} true;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,23)"} true;
    havoc inline$Impl$$Wrappers.__default.Need$1$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$1$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$1$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$1$#tmp0#0 := #Wrappers.Outcome.Fail(inline$Impl$$Wrappers.__default.Need$1$error#0);
    inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,23)"} true;
    assume true;
    assume inline$Impl$$Wrappers.__default.Need$1$defass##tmp0#0;
    assume true;
    inline$Impl$$Wrappers.__default.Need$1$result#0 := inline$Impl$$Wrappers.__default.Need$1$#tmp0#0;
    inline$Impl$$Wrappers.__default.Need$1$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,24)"} true;
    assume inline$Impl$$Wrappers.__default.Need$1$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$1$condition#0, inline$Impl$$Wrappers.__default.Need$1$error#0);
    goto inline$Impl$$Wrappers.__default.Need$1$Return;

  inline$Impl$$Wrappers.__default.Need$1$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$Impl$$Wrappers.__default.Need$1$result#0, Wrappers.__default.Need(inline$Impl$$Wrappers.__default.Need$1$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$1$condition#0, inline$Impl$$Wrappers.__default.Need$1$error#0));
    assume true;
    assume true;
    inline$CallPost$$Wrappers.__default.Need$1$defass#result#0 := inline$Impl$$Wrappers.__default.Need$1$defass#result#0;
    inline$CallPost$$Wrappers.__default.Need$1$result#0 := inline$Impl$$Wrappers.__default.Need$1$result#0;
    inline$CallPost$$Wrappers.__default.Need$1$$_reverifyPost := inline$Impl$$Wrappers.__default.Need$1$$_reverifyPost;
    goto inline$CallPost$$Wrappers.__default.Need$1$anon_0$1;

  inline$CallPost$$Wrappers.__default.Need$1$anon_0$1:
    goto inline$CallPost$$Wrappers.__default.Need$1$Return;

  inline$CallPost$$Wrappers.__default.Need$1$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$CallPost$$Wrappers.__default.Need$1$result#0, Wrappers.__default.Need(inline$CallPost$$Wrappers.__default.Need$1$Wrappers._default.Need$E, inline$CallPost$$Wrappers.__default.Need$1$condition#0, inline$CallPost$$Wrappers.__default.Need$1$error#0));
    assume true;
    assume true;
    $rhs##1 := inline$CallPost$$Wrappers.__default.Need$1$result#0;
    goto anon46$1;

  anon46$1:
    valueOrError1#0 := $rhs##1;
    defass#valueOrError1#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(61,5)"} true;
    assume defass#valueOrError1#0;
    assume $IsAllocBox($Box(valueOrError1#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    goto anon75_Then, anon75_Else;

  anon75_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(61,5)"} true;
    push;
    assume true;
    assume defass#valueOrError1#0;
    assume $IsAllocBox($Box(valueOrError1#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError1#0);
    assume Wrappers.Outcome.Fail_q(valueOrError1#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0);
    output#0 := Wrappers.Outcome.PropagateFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0);
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(61,5)"} true;
    assume defass#output#0;
    pop;
    return;

  anon75_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError1#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(70,5)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(69,98)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(65,73)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(64,89)"} true;
    assume true;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    newtype$check#4 := LitInt(8);
    assume LitInt(-2147483648) <= newtype$check#4 && newtype$check#4 < 2147483648;
    newtype$check#5 := Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8));
    assume LitInt(-2147483648) <= newtype$check#5 && newtype$check#5 < 2147483648;
    newtype$check#6 := Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#7 := Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__32();
    ##x#0 := Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8));
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)));
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0) && StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)));
    lengthBits#0 := StandardLibrary_mUInt.__default.UInt32ToSeq(Mul(AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0), LitInt(8)));
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(64,89)"} true;
    assume true;
    assume true;
    explicitInfo#0 := Seq#Append(Seq#Append(Seq#Append(label_#0, KdfCtr.__default.SEPARATION__INDICATOR()), info#0), lengthBits#0);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(65,73)"} true;
    havoc #tmp15#0 /* where defass##tmp15#0 ==> $Is(#tmp15#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(#tmp15#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */;
    assume true;
    assume true;
    #tmp15#0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(82))), $Box(char#FromInt(70))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(120))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(73))), $Box(char#FromInt(78))), $Box(char#FromInt(84))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(95))), $Box(char#FromInt(77))), $Box(char#FromInt(65))), $Box(char#FromInt(88))), $Box(char#FromInt(95))), $Box(char#FromInt(76))), $Box(char#FromInt(73))), $Box(char#FromInt(77))), $Box(char#FromInt(73))), $Box(char#FromInt(84))), $Box(char#FromInt(46))))));
    defass##tmp15#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(69,98)"} true;
    havoc valueOrError2#0 /* where defass#valueOrError2#0 ==> $Is(valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    condition##2 := 4 + Seq#Length(explicitInfo#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
    assume defass##tmp15#0;
    assume true;
    error##2 := #tmp15#0;
    call CallPre$$Wrappers.__default.Need(Tclass.AwsCryptographyPrimitivesTypes.Error(), condition##2, $Box(error##2));
    goto inline$CallPost$$Wrappers.__default.Need$2$Entry;

  inline$CallPost$$Wrappers.__default.Need$2$Entry:
    inline$CallPost$$Wrappers.__default.Need$2$Wrappers._default.Need$E := Tclass.AwsCryptographyPrimitivesTypes.Error();
    inline$CallPost$$Wrappers.__default.Need$2$condition#0 := condition##2;
    inline$CallPost$$Wrappers.__default.Need$2$error#0 := $Box(error##2);
    havoc inline$CallPost$$Wrappers.__default.Need$2$defass#result#0, inline$CallPost$$Wrappers.__default.Need$2$$_reverifyPost, inline$CallPost$$Wrappers.__default.Need$2$result#0;
    inline$CallPost$$Wrappers.__default.Need$2$$Heap := $Heap;
    goto inline$CallPost$$Wrappers.__default.Need$2$anon_0;

  inline$CallPost$$Wrappers.__default.Need$2$anon_0:
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$CallPost$$Wrappers.__default.Need$2$Wrappers._default.Need$E, " | ", inline$CallPost$$Wrappers.__default.Need$2$condition#0, " | ", inline$CallPost$$Wrappers.__default.Need$2$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    goto inline$Impl$$Wrappers.__default.Need$2$Entry;

  inline$Impl$$Wrappers.__default.Need$2$Entry:
    inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E := inline$CallPost$$Wrappers.__default.Need$2$Wrappers._default.Need$E;
    inline$Impl$$Wrappers.__default.Need$2$condition#0 := inline$CallPost$$Wrappers.__default.Need$2$condition#0;
    inline$Impl$$Wrappers.__default.Need$2$error#0 := inline$CallPost$$Wrappers.__default.Need$2$error#0;
    assume true;
    havoc inline$Impl$$Wrappers.__default.Need$2$$_ModifiesFrame, inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0, inline$Impl$$Wrappers.__default.Need$2$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$2$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$2$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E), $Heap) */, inline$Impl$$Wrappers.__default.Need$2$defass#result#0, inline$Impl$$Wrappers.__default.Need$2$result#0, inline$Impl$$Wrappers.__default.Need$2$$_reverifyPost;
    inline$Impl$$Wrappers.__default.Need$2$$Heap := $Heap;
    goto inline$Impl$$Wrappers.__default.Need$2$anon0;

  inline$Impl$$Wrappers.__default.Need$2$anon0:
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(104,14):initialstate"} true;
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E, " | ", inline$Impl$$Wrappers.__default.Need$2$condition#0, " | ", inline$Impl$$Wrappers.__default.Need$2$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    inline$Impl$$Wrappers.__default.Need$2$$_ModifiesFrame := (lambda inline$Impl$$Wrappers.__default.Need$2$$o: ref, inline$Impl$$Wrappers.__default.Need$2$$f: Field :: inline$Impl$$Wrappers.__default.Need$2$$o != null && $Unbox(read($Heap, inline$Impl$$Wrappers.__default.Need$2$$o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Wrappers.dfy(104,14): initial state"} true;
    inline$Impl$$Wrappers.__default.Need$2$$_reverifyPost := false;
    assume true;
    goto inline$Impl$$Wrappers.__default.Need$2$anon4_Then, inline$Impl$$Wrappers.__default.Need$2$anon4_Else;

  inline$Impl$$Wrappers.__default.Need$2$anon4_Then:
    assume {:partition} inline$Impl$$Wrappers.__default.Need$2$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(106,17)"} true;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$2$result#0 := Lit(#Wrappers.Outcome.Pass());
    inline$Impl$$Wrappers.__default.Need$2$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(106,17)"} true;
    assume inline$Impl$$Wrappers.__default.Need$2$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$2$condition#0, inline$Impl$$Wrappers.__default.Need$2$error#0);
    goto inline$Impl$$Wrappers.__default.Need$2$Return;

  inline$Impl$$Wrappers.__default.Need$2$anon4_Else:
    assume {:partition} !inline$Impl$$Wrappers.__default.Need$2$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,24)"} true;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,23)"} true;
    havoc inline$Impl$$Wrappers.__default.Need$2$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$2$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$2$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$2$#tmp0#0 := #Wrappers.Outcome.Fail(inline$Impl$$Wrappers.__default.Need$2$error#0);
    inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,23)"} true;
    assume true;
    assume inline$Impl$$Wrappers.__default.Need$2$defass##tmp0#0;
    assume true;
    inline$Impl$$Wrappers.__default.Need$2$result#0 := inline$Impl$$Wrappers.__default.Need$2$#tmp0#0;
    inline$Impl$$Wrappers.__default.Need$2$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,24)"} true;
    assume inline$Impl$$Wrappers.__default.Need$2$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$2$condition#0, inline$Impl$$Wrappers.__default.Need$2$error#0);
    goto inline$Impl$$Wrappers.__default.Need$2$Return;

  inline$Impl$$Wrappers.__default.Need$2$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$Impl$$Wrappers.__default.Need$2$result#0, Wrappers.__default.Need(inline$Impl$$Wrappers.__default.Need$2$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$2$condition#0, inline$Impl$$Wrappers.__default.Need$2$error#0));
    assume true;
    assume true;
    inline$CallPost$$Wrappers.__default.Need$2$defass#result#0 := inline$Impl$$Wrappers.__default.Need$2$defass#result#0;
    inline$CallPost$$Wrappers.__default.Need$2$result#0 := inline$Impl$$Wrappers.__default.Need$2$result#0;
    inline$CallPost$$Wrappers.__default.Need$2$$_reverifyPost := inline$Impl$$Wrappers.__default.Need$2$$_reverifyPost;
    goto inline$CallPost$$Wrappers.__default.Need$2$anon_0$1;

  inline$CallPost$$Wrappers.__default.Need$2$anon_0$1:
    goto inline$CallPost$$Wrappers.__default.Need$2$Return;

  inline$CallPost$$Wrappers.__default.Need$2$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$CallPost$$Wrappers.__default.Need$2$result#0, Wrappers.__default.Need(inline$CallPost$$Wrappers.__default.Need$2$Wrappers._default.Need$E, inline$CallPost$$Wrappers.__default.Need$2$condition#0, inline$CallPost$$Wrappers.__default.Need$2$error#0));
    assume true;
    assume true;
    $rhs##2 := inline$CallPost$$Wrappers.__default.Need$2$result#0;
    goto anon75_Else$1;

  anon75_Else$1:
    valueOrError2#0 := $rhs##2;
    defass#valueOrError2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(70,5)"} true;
    assume defass#valueOrError2#0;
    assume $IsAllocBox($Box(valueOrError2#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError2#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError2#0);
    goto anon76_Then, anon76_Else;

  anon76_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError2#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(70,5)"} true;
    push;
    assume true;
    assume defass#valueOrError2#0;
    assume $IsAllocBox($Box(valueOrError2#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError2#0);
    assume Wrappers.Outcome.Fail_q(valueOrError2#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError2#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError2#0);
    output#0 := Wrappers.Outcome.PropagateFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError2#0);
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(70,5)"} true;
    assume defass#output#0;
    pop;
    return;

  anon76_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError2#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(72,87)"} true;
    havoc valueOrError3#0 /* where defass#valueOrError3#0 ==> $Is(valueOrError3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(valueOrError3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    ikm##0 := ikm#0;
    assume true;
    explicitInfo##0 := explicitInfo#0;
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    length##0 := AwsCryptographyPrimitivesTypes.KdfCtrInput.expectedLength(input#0);
    newtype$check#8 := LitInt(0);
    assume LitInt(-2147483648) <= newtype$check#8 && newtype$check#8 < 2147483648;
    assume true;
    offset##0 := LitInt(0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    assume AwsCryptographyPrimitivesTypes.KdfCtrInput.KdfCtrInput_q(input#0);
    digestAlgorithm##0 := AwsCryptographyPrimitivesTypes.KdfCtrInput.digestAlgorithm(input#0);
    call CallPre$$KdfCtr.__default.RawDerive(ikm##0, explicitInfo##0, length##0, offset##0, digestAlgorithm##0);
    goto inline$CallPost$$KdfCtr.__default.RawDerive$0$Entry;

  inline$CallPost$$KdfCtr.__default.RawDerive$0$Entry:
    inline$CallPost$$KdfCtr.__default.RawDerive$0$ikm#0 := ikm##0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$explicitInfo#0 := explicitInfo##0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$length#0 := length##0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$offset#0 := offset##0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0 := digestAlgorithm##0;
    havoc inline$CallPost$$KdfCtr.__default.RawDerive$0$defass#output#0, inline$CallPost$$KdfCtr.__default.RawDerive$0$$_reverifyPost, inline$CallPost$$KdfCtr.__default.RawDerive$0$output#0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$$Heap := $Heap;
    goto inline$CallPost$$KdfCtr.__default.RawDerive$0$anon_0;

  inline$CallPost$$KdfCtr.__default.RawDerive$0$anon_0:
    assume {:print "Impl", " | ", "KdfCtr.RawDerive", " | ", inline$CallPost$$KdfCtr.__default.RawDerive$0$ikm#0, " | ", inline$CallPost$$KdfCtr.__default.RawDerive$0$explicitInfo#0, " | ", inline$CallPost$$KdfCtr.__default.RawDerive$0$length#0, " | ", inline$CallPost$$KdfCtr.__default.RawDerive$0$offset#0, " | ", inline$CallPost$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "DatatypeType"} true;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$Entry;

  inline$Impl$$KdfCtr.__default.RawDerive$0$Entry:
    inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0 := inline$CallPost$$KdfCtr.__default.RawDerive$0$ikm#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$explicitInfo#0 := inline$CallPost$$KdfCtr.__default.RawDerive$0$explicitInfo#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 := inline$CallPost$$KdfCtr.__default.RawDerive$0$length#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$offset#0 := inline$CallPost$$KdfCtr.__default.RawDerive$0$offset#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0 := inline$CallPost$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0;
    assume true;
    assume Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0) >= LitInt(32);
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 > 0;
    assume 4 + Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$explicitInfo#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
    assume AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0, #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256()) || AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0, #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 + Digest.__default.Length(Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256())) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() - 1;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 + Digest.__default.Length(Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384())) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() - 1;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame, inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, Tclass.HMAC.HMac()) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, Tclass.HMAC.HMac(), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0, inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##0, inline$Impl$$KdfCtr.__default.RawDerive$0$digest##0, inline$Impl$$KdfCtr.__default.RawDerive$0$key##0, inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0, inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0 ==> LitInt(0) <= inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0 */, inline$Impl$$KdfCtr.__default.RawDerive$0$##digestAlgorithm#2, inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 /* where LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 && inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 < 2147483648 */, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#1, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#2, inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 /* where LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 && inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 < 2147483648 */, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#3, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#4, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#5, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#6, inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0 /* where $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0, TSeq(Tclass.BoundedInts.uint8()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$i#0 /* where $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0, TSeq(Tclass.BoundedInts.uint8()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$##x#0, inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0, inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#7, inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#8, inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#9, inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#x, inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0, inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#output#0, inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass##tmp0#0, inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#valueOrError0#0, inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0, inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_0, inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_1, inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0 /* where $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_0, inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0, inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_1, inline$Impl$$KdfCtr.__default.RawDerive$0$x##1_0, inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0, inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0, inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1, inline$Impl$$KdfCtr.__default.RawDerive$0$condition##0, inline$Impl$$KdfCtr.__default.RawDerive$0$error##0, inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0, inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0, inline$Impl$$KdfCtr.__default.RawDerive$0$output#0, inline$Impl$$KdfCtr.__default.RawDerive$0$$_reverifyPost;
    inline$Impl$$KdfCtr.__default.RawDerive$0$$Heap := $Heap;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon0;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon0:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(88,48)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(87,2):initialstate"} true;
    assume {:print "Impl", " | ", "KdfCtr.RawDerive", " | ", inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0, " | ", inline$Impl$$KdfCtr.__default.RawDerive$0$explicitInfo#0, " | ", inline$Impl$$KdfCtr.__default.RawDerive$0$length#0, " | ", inline$Impl$$KdfCtr.__default.RawDerive$0$offset#0, " | ", inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "DatatypeType"} true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame := (lambda inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref, inline$Impl$$KdfCtr.__default.RawDerive$0$$f: Field :: inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(87,2): initial state"} true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$$_reverifyPost := false;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0, Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$digest##0 := inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0;
    call CallPre$$HMAC.HMac.Build(inline$Impl$$KdfCtr.__default.RawDerive$0$digest##0);
    call inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##0 := CallPost$$HMAC.HMac.Build(inline$Impl$$KdfCtr.__default.RawDerive$0$digest##0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(88,48)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon20_Then, inline$Impl$$KdfCtr.__default.RawDerive$0$anon20_Else;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon20_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(88,48)"} true;
    push;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.Failure_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$output#0 := Wrappers.Result.PropagateFailure(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(88,48)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    pop;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$Return;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon20_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(97,63)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(94,20)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(93,68)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(91,65)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(91,55)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(89,25)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(88,48)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.Success_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 := $Unbox(Wrappers.Result.Extract(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError0#0)): ref;
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(88,48)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 != null;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$key##0 := inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0;
    assume (forall inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref, inline$Impl$$KdfCtr.__default.RawDerive$0$$f: Field :: inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool && inline$Impl$$KdfCtr.__default.RawDerive$0$$o == inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame[inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f]);
    call CallPre$$HMAC.HMac.Init(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$key##0);
    call CallPost$$HMAC.HMac.Init(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$key##0);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(89,25)"} true;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0 ==> LitInt(0) <= inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0 */;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$##digestAlgorithm#2 := inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0;
    assume $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$##digestAlgorithm#2, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap);
    assume Digest.__default.Length#canCall(inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0);
    assume Digest.__default.Length#canCall(inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0 := Digest.__default.Length(inline$Impl$$KdfCtr.__default.RawDerive$0$digestAlgorithm#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(91,55)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#1 := inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0;
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#1 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#1 < 2147483648;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#2 := inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0;
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#2 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#2 < 2147483648;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp0#0;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(91,65)"} true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#3 := inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 + inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0;
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#3 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#3 < 2147483648;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#4 := LitInt(1);
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#4 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#4 < 2147483648;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#5 := inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 + inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 - 1;
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#5 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#5 < 2147483648;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 != 0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#6 := Div(inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 + inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 - 1, inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0);
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#6 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#6 < 2147483648;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 := Div(inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 + inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0 - 1, inline$Impl$$KdfCtr.__default.RawDerive$0$macLengthBytes#0);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(93,68)"} true;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(94,20)"} true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$##x#0 := KdfCtr.__default.COUNTER__START__VALUE();
    assume $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(KdfCtr.__default.COUNTER__START__VALUE());
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(KdfCtr.__default.COUNTER__START__VALUE());
    inline$Impl$$KdfCtr.__default.RawDerive$0$i#0 := StandardLibrary_mUInt.__default.UInt32ToSeq(KdfCtr.__default.COUNTER__START__VALUE());
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(97,63)"} true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#7 := LitInt(1);
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#7 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#7 < 2147483648;
    inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo := LitInt(1);
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#8 := LitInt(1);
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#8 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#8 < 2147483648;
    inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#9 := inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 + 1;
    assume LitInt(-2147483648) <= inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#9 && inline$Impl$$KdfCtr.__default.RawDerive$0$newtype$check#9 < 2147483648;
    inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi := inline$Impl$$KdfCtr.__default.RawDerive$0$iterations#0 + 1;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo <= inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#x;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo <= inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#x && inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#x <= inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi;
    assume $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#x, Tclass.BoundedInts.int32());
    inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo;
    inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0 := $Heap;
    inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#output#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass##tmp0#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#valueOrError0#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#hmac#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopHead;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopHead:
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#lo <= inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 && inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 <= inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0 ==> Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0) == LitInt(4);
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0 ==> HMAC.HMac.GetKey#canCall($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0);
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0 ==> Seq#Equal(HMAC.HMac.GetKey($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0), inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0);
    assume (forall inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref :: { $Heap[inline$Impl$$KdfCtr.__default.RawDerive$0$$o] } inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read(inline$Impl$$KdfCtr.__default.RawDerive$0$$Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool ==> $Heap[inline$Impl$$KdfCtr.__default.RawDerive$0$$o] == inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0[inline$Impl$$KdfCtr.__default.RawDerive$0$$o]);
    assume $HeapSucc(inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0, $Heap);
    assume (forall inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref, inline$Impl$$KdfCtr.__default.RawDerive$0$$f: Field :: { read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f) } inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read(inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool ==> read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f) == read(inline$Impl$$KdfCtr.__default.RawDerive$0$$PreLoopHeap$loop#0, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f) || inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame[inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f]);
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#output#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass##tmp0#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp0#0;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#valueOrError0#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError0#0;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$preLoop$loop#0$defass#hmac#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    assume true;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopDone, inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopBody;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopBody:
    assume {:partition} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(99,4):aftersomeloopiterations"} true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(99,4): after some loop iterations"} true;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon22_Then, inline$Impl$$KdfCtr.__default.RawDerive$0$anon22_Else;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon22_Then:
    assume {:partition} !inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0;
    assume true;
    assume Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0) == LitInt(4);
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    assume {:subsumption 0} inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 != null;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0), Tclass.HMAC.HMac?(), $Heap);
    assume HMAC.HMac.GetKey#canCall($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0);
    assume HMAC.HMac.GetKey#canCall($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0);
    assume Seq#Equal(HMAC.HMac.GetKey($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0), inline$Impl$$KdfCtr.__default.RawDerive$0$ikm#0);
    assume false;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon7;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon22_Else:
    assume {:partition} inline$Impl$$KdfCtr.__default.RawDerive$0$$w$loop#0;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon7;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon7:
    assume true;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon23_Then, inline$Impl$$KdfCtr.__default.RawDerive$0$anon23_Else;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon23_Then:
    assume {:partition} inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 == inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon14;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon23_Else:
    assume {:partition} inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 != inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0#hi;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(112,23)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(110,28)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(109,33)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(108,31)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(107,20)"} true;
    push;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 != null;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_0 := inline$Impl$$KdfCtr.__default.RawDerive$0$i#0;
    assume (forall inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref, inline$Impl$$KdfCtr.__default.RawDerive$0$$f: Field :: inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool && inline$Impl$$KdfCtr.__default.RawDerive$0$$o == inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame[inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f]);
    call CallPre$$HMAC.HMac.Update(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_0);
    call CallPost$$HMAC.HMac.Update(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_0);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(107,20)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 != null;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_1 := inline$Impl$$KdfCtr.__default.RawDerive$0$explicitInfo#0;
    assume (forall inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref, inline$Impl$$KdfCtr.__default.RawDerive$0$$f: Field :: inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool && inline$Impl$$KdfCtr.__default.RawDerive$0$$o == inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame[inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f]);
    call CallPre$$HMAC.HMac.Update(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_1);
    call CallPost$$HMAC.HMac.Update(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0, inline$Impl$$KdfCtr.__default.RawDerive$0$input##1_1);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(108,31)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#hmac#0;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 != null;
    assume (forall inline$Impl$$KdfCtr.__default.RawDerive$0$$o: ref, inline$Impl$$KdfCtr.__default.RawDerive$0$$f: Field :: inline$Impl$$KdfCtr.__default.RawDerive$0$$o != null && $Unbox(read($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$$o, alloc)): bool && inline$Impl$$KdfCtr.__default.RawDerive$0$$o == inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0 ==> inline$Impl$$KdfCtr.__default.RawDerive$0$$_ModifiesFrame[inline$Impl$$KdfCtr.__default.RawDerive$0$$o, inline$Impl$$KdfCtr.__default.RawDerive$0$$f]);
    call CallPre$$HMAC.HMac.GetResult(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0);
    call inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_0 := CallPost$$HMAC.HMac.GetResult(inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0 := inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_0;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(109,33)"} true;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0 := Seq#Append(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0, inline$Impl$$KdfCtr.__default.RawDerive$0$tmp#1_0);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(110,28)"} true;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$x##1_0 := inline$Impl$$KdfCtr.__default.RawDerive$0$i#0;
    call CallPre$$KdfCtr.__default.Increment(inline$Impl$$KdfCtr.__default.RawDerive$0$x##1_0);
    goto inline$CallPost$$KdfCtr.__default.Increment$0$Entry;

  inline$CallPost$$KdfCtr.__default.Increment$0$Entry:
    inline$CallPost$$KdfCtr.__default.Increment$0$x#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$x##1_0;
    havoc inline$CallPost$$KdfCtr.__default.Increment$0$defass#ret#0, inline$CallPost$$KdfCtr.__default.Increment$0$$_reverifyPost, inline$CallPost$$KdfCtr.__default.Increment$0$ret#0;
    inline$CallPost$$KdfCtr.__default.Increment$0$$Heap := $Heap;
    goto inline$CallPost$$KdfCtr.__default.Increment$0$anon_0;

  inline$CallPost$$KdfCtr.__default.Increment$0$anon_0:
    assume {:print "Impl", " | ", "KdfCtr.Increment", " | ", inline$CallPost$$KdfCtr.__default.Increment$0$x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    goto inline$Impl$$KdfCtr.__default.Increment$0$Entry;

  inline$Impl$$KdfCtr.__default.Increment$0$Entry:
    inline$Impl$$KdfCtr.__default.Increment$0$x#0 := inline$CallPost$$KdfCtr.__default.Increment$0$x#0;
    assume true;
    assume Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0) == LitInt(4);
    havoc inline$Impl$$KdfCtr.__default.Increment$0$$_ModifiesFrame, inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0, inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_1, inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0, inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_1, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_2, inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0, inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_1, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_2, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_3, inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0, inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_0, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_1, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_2, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_3, inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_4, inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0, inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */, inline$Impl$$KdfCtr.__default.Increment$0$defass#ret#0, inline$Impl$$KdfCtr.__default.Increment$0$ret#0, inline$Impl$$KdfCtr.__default.Increment$0$$_reverifyPost;
    inline$Impl$$KdfCtr.__default.Increment$0$$Heap := $Heap;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon0;

  inline$Impl$$KdfCtr.__default.Increment$0$anon0:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(129,4):initialstate"} true;
    assume {:print "Impl", " | ", "KdfCtr.Increment", " | ", inline$Impl$$KdfCtr.__default.Increment$0$x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    inline$Impl$$KdfCtr.__default.Increment$0$$_ModifiesFrame := (lambda inline$Impl$$KdfCtr.__default.Increment$0$$o: ref, inline$Impl$$KdfCtr.__default.Increment$0$$f: Field :: inline$Impl$$KdfCtr.__default.Increment$0$$o != null && $Unbox(read($Heap, inline$Impl$$KdfCtr.__default.Increment$0$$o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(129,4): initial state"} true;
    inline$Impl$$KdfCtr.__default.Increment$0$$_reverifyPost := false;
    havoc inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0 := LitInt(255);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon14_Then, inline$Impl$$KdfCtr.__default.Increment$0$anon14_Else;

  inline$Impl$$KdfCtr.__default.Increment$0$anon14_Then:
    assume {:partition} $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(3))): int < 255;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(130,6)#thenBranch"} true;
    push;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_0 := LitInt(1);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_1 := $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(3))): int + 1;
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_1 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0 := #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))), Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(1))), Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(2))), $Box($Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(3))): int + 1))));
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(130,6)#thenBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon12;

  inline$Impl$$KdfCtr.__default.Increment$0$anon14_Else:
    assume {:partition} 255 <= $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(3))): int;
    push;
    havoc inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0 := LitInt(255);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon15_Then, inline$Impl$$KdfCtr.__default.Increment$0$anon15_Else;

  inline$Impl$$KdfCtr.__default.Increment$0$anon15_Then:
    assume {:partition} $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(2))): int < 255;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(132,6)#thenBranch"} true;
    push;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_0 := LitInt(1);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_1 := $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(2))): int + 1;
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_1 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_2 := LitInt(0);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_2 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_0_2 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0 := #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))), Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(1))), $Box($Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(2))): int + 1)), $Box(LitInt(0)))));
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(132,6)#thenBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon11;

  inline$Impl$$KdfCtr.__default.Increment$0$anon15_Else:
    assume {:partition} 255 <= $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(2))): int;
    push;
    havoc inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0 := LitInt(255);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon16_Then, inline$Impl$$KdfCtr.__default.Increment$0$anon16_Else;

  inline$Impl$$KdfCtr.__default.Increment$0$anon16_Then:
    assume {:partition} $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(1))): int < 255;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(134,6)#thenBranch"} true;
    push;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_0 := LitInt(1);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_1 := $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(1))): int + 1;
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_1 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_2 := LitInt(0);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_2 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_2 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_3 := LitInt(0);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_3 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_0_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0 := #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))), $Box($Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(1))): int + 1)), $Box(LitInt(0))), $Box(LitInt(0)))));
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(134,6)#thenBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon10;

  inline$Impl$$KdfCtr.__default.Increment$0$anon16_Else:
    assume {:partition} 255 <= $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(1))): int;
    push;
    havoc inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0 := LitInt(255);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon17_Then, inline$Impl$$KdfCtr.__default.Increment$0$anon17_Else;

  inline$Impl$$KdfCtr.__default.Increment$0$anon17_Then:
    assume {:partition} $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))): int < 255;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(136,6)#thenBranch"} true;
    push;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_0 := LitInt(1);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_0 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_1 := $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))): int + 1;
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_1 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_2 := LitInt(0);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_2 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_2 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_3 := LitInt(0);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_3 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_3 < BoundedInts.__default.TWO__TO__THE__8();
    inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_4 := LitInt(0);
    assume LitInt(0) <= inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_4 && inline$Impl$$KdfCtr.__default.Increment$0$newtype$check#1_1_1_0_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0 := #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box($Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))): int + 1)), $Box(LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))));
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(136,6)#thenBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon9;

  inline$Impl$$KdfCtr.__default.Increment$0$anon17_Else:
    assume {:partition} 255 <= $Unbox(Seq#Index(inline$Impl$$KdfCtr.__default.Increment$0$x#0, LitInt(0))): int;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(138,6)#elseBranch"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(138,120)"} true;
    push;
    havoc inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0 /* where inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0 ==> $Is(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(59))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(120))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(46))))));
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(138,120)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp4#0;
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0 := #Wrappers.Result.Failure($Box(inline$Impl$$KdfCtr.__default.Increment$0$#tmp4#0));
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(138,6)#elseBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon9;

  inline$Impl$$KdfCtr.__default.Increment$0$anon9:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(135,9)#elseBranch"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp3#0;
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0 := inline$Impl$$KdfCtr.__default.Increment$0$#tmp3#0;
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(135,9)#elseBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon10;

  inline$Impl$$KdfCtr.__default.Increment$0$anon10:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(133,9)#elseBranch"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp2#0;
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0 := inline$Impl$$KdfCtr.__default.Increment$0$#tmp2#0;
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(133,9)#elseBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon11;

  inline$Impl$$KdfCtr.__default.Increment$0$anon11:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(131,9)#elseBranch"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp1#0;
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0 := inline$Impl$$KdfCtr.__default.Increment$0$#tmp1#0;
    inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(131,9)#elseBranch"} true;
    pop;
    goto inline$Impl$$KdfCtr.__default.Increment$0$anon12;

  inline$Impl$$KdfCtr.__default.Increment$0$anon12:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.Increment", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(138,121)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.Increment$0$defass##tmp0#0;
    assume true;
    inline$Impl$$KdfCtr.__default.Increment$0$ret#0 := inline$Impl$$KdfCtr.__default.Increment$0$#tmp0#0;
    inline$Impl$$KdfCtr.__default.Increment$0$defass#ret#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(138,121)"} true;
    assume inline$Impl$$KdfCtr.__default.Increment$0$defass#ret#0;
    assume KdfCtr.__default.Increment#canCall(inline$Impl$$KdfCtr.__default.Increment$0$x#0);
    goto inline$Impl$$KdfCtr.__default.Increment$0$Return;

  inline$Impl$$KdfCtr.__default.Increment$0$Return:
    assume true;
    assume Wrappers.Result#Equal(inline$Impl$$KdfCtr.__default.Increment$0$ret#0, KdfCtr.__default.Increment(inline$Impl$$KdfCtr.__default.Increment$0$x#0));
    assume true;
    assume true;
    inline$CallPost$$KdfCtr.__default.Increment$0$defass#ret#0 := inline$Impl$$KdfCtr.__default.Increment$0$defass#ret#0;
    inline$CallPost$$KdfCtr.__default.Increment$0$ret#0 := inline$Impl$$KdfCtr.__default.Increment$0$ret#0;
    inline$CallPost$$KdfCtr.__default.Increment$0$$_reverifyPost := inline$Impl$$KdfCtr.__default.Increment$0$$_reverifyPost;
    goto inline$CallPost$$KdfCtr.__default.Increment$0$anon_0$1;

  inline$CallPost$$KdfCtr.__default.Increment$0$anon_0$1:
    goto inline$CallPost$$KdfCtr.__default.Increment$0$Return;

  inline$CallPost$$KdfCtr.__default.Increment$0$Return:
    assume true;
    assume Wrappers.Result#Equal(inline$CallPost$$KdfCtr.__default.Increment$0$ret#0, KdfCtr.__default.Increment(inline$CallPost$$KdfCtr.__default.Increment$0$x#0));
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_1 := inline$CallPost$$KdfCtr.__default.Increment$0$ret#0;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon23_Else$1;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon23_Else$1:
    inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0 := inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1_1;
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(112,23)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon24_Then, inline$Impl$$KdfCtr.__default.RawDerive$0$anon24_Else;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon24_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(112,23)"} true;
    push;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.Failure_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$output#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(112,23)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    pop;
    pop;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$Return;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon24_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(112,23)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError1#1_0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.Success_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$i#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError1#1_0)): Seq;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(112,23)"} true;
    pop;
    inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$iteration#0 + 1;
    assume Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$i#0) == LitInt(4) ==> HMAC.HMac.GetKey#canCall($Heap, inline$Impl$$KdfCtr.__default.RawDerive$0$hmac#0);
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopHead;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon21_LoopDone:
    assume {:partition} false;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon14;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon14:
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(118,5)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(117,97)"} true;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0 := Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(70))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))))));
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(117,97)"} true;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0, Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$condition##0 := Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0) >= inline$Impl$$KdfCtr.__default.RawDerive$0$length#0;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp1#0;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$error##0 := inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp1#0;
    call CallPre$$Wrappers.__default.Need(Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$condition##0, $Box(inline$Impl$$KdfCtr.__default.RawDerive$0$error##0));
    goto inline$CallPost$$Wrappers.__default.Need$3$Entry;

  inline$CallPost$$Wrappers.__default.Need$3$Entry:
    inline$CallPost$$Wrappers.__default.Need$3$Wrappers._default.Need$E := Tclass.AwsCryptographyPrimitivesTypes.Error();
    inline$CallPost$$Wrappers.__default.Need$3$condition#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$condition##0;
    inline$CallPost$$Wrappers.__default.Need$3$error#0 := $Box(inline$Impl$$KdfCtr.__default.RawDerive$0$error##0);
    havoc inline$CallPost$$Wrappers.__default.Need$3$defass#result#0, inline$CallPost$$Wrappers.__default.Need$3$$_reverifyPost, inline$CallPost$$Wrappers.__default.Need$3$result#0;
    inline$CallPost$$Wrappers.__default.Need$3$$Heap := $Heap;
    goto inline$CallPost$$Wrappers.__default.Need$3$anon_0;

  inline$CallPost$$Wrappers.__default.Need$3$anon_0:
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$CallPost$$Wrappers.__default.Need$3$Wrappers._default.Need$E, " | ", inline$CallPost$$Wrappers.__default.Need$3$condition#0, " | ", inline$CallPost$$Wrappers.__default.Need$3$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    goto inline$Impl$$Wrappers.__default.Need$3$Entry;

  inline$Impl$$Wrappers.__default.Need$3$Entry:
    inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E := inline$CallPost$$Wrappers.__default.Need$3$Wrappers._default.Need$E;
    inline$Impl$$Wrappers.__default.Need$3$condition#0 := inline$CallPost$$Wrappers.__default.Need$3$condition#0;
    inline$Impl$$Wrappers.__default.Need$3$error#0 := inline$CallPost$$Wrappers.__default.Need$3$error#0;
    assume true;
    havoc inline$Impl$$Wrappers.__default.Need$3$$_ModifiesFrame, inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0, inline$Impl$$Wrappers.__default.Need$3$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$3$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$3$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E), $Heap) */, inline$Impl$$Wrappers.__default.Need$3$defass#result#0, inline$Impl$$Wrappers.__default.Need$3$result#0, inline$Impl$$Wrappers.__default.Need$3$$_reverifyPost;
    inline$Impl$$Wrappers.__default.Need$3$$Heap := $Heap;
    goto inline$Impl$$Wrappers.__default.Need$3$anon0;

  inline$Impl$$Wrappers.__default.Need$3$anon0:
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(104,14):initialstate"} true;
    assume {:print "Impl", " | ", "Wrappers.Need", " | ", inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E, " | ", inline$Impl$$Wrappers.__default.Need$3$condition#0, " | ", inline$Impl$$Wrappers.__default.Need$3$error#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "Box"} true;
    inline$Impl$$Wrappers.__default.Need$3$$_ModifiesFrame := (lambda inline$Impl$$Wrappers.__default.Need$3$$o: ref, inline$Impl$$Wrappers.__default.Need$3$$f: Field :: inline$Impl$$Wrappers.__default.Need$3$$o != null && $Unbox(read($Heap, inline$Impl$$Wrappers.__default.Need$3$$o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Wrappers.dfy(104,14): initial state"} true;
    inline$Impl$$Wrappers.__default.Need$3$$_reverifyPost := false;
    assume true;
    goto inline$Impl$$Wrappers.__default.Need$3$anon4_Then, inline$Impl$$Wrappers.__default.Need$3$anon4_Else;

  inline$Impl$$Wrappers.__default.Need$3$anon4_Then:
    assume {:partition} inline$Impl$$Wrappers.__default.Need$3$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(106,17)"} true;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$3$result#0 := Lit(#Wrappers.Outcome.Pass());
    inline$Impl$$Wrappers.__default.Need$3$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(106,17)"} true;
    assume inline$Impl$$Wrappers.__default.Need$3$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$3$condition#0, inline$Impl$$Wrappers.__default.Need$3$error#0);
    goto inline$Impl$$Wrappers.__default.Need$3$Return;

  inline$Impl$$Wrappers.__default.Need$3$anon4_Else:
    assume {:partition} !inline$Impl$$Wrappers.__default.Need$3$condition#0;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,24)"} true;
    assume {:print "Block", " | ", "Impl$$Wrappers.__default.Need", " | ", "libraries/src/Wrappers.dfy(108,23)"} true;
    havoc inline$Impl$$Wrappers.__default.Need$3$#tmp0#0 /* where inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0 ==> $Is(inline$Impl$$Wrappers.__default.Need$3$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E)) && $IsAlloc(inline$Impl$$Wrappers.__default.Need$3$#tmp0#0, Tclass.Wrappers.Outcome(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E), $Heap) */;
    assume true;
    assume true;
    inline$Impl$$Wrappers.__default.Need$3$#tmp0#0 := #Wrappers.Outcome.Fail(inline$Impl$$Wrappers.__default.Need$3$error#0);
    inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,23)"} true;
    assume true;
    assume inline$Impl$$Wrappers.__default.Need$3$defass##tmp0#0;
    assume true;
    inline$Impl$$Wrappers.__default.Need$3$result#0 := inline$Impl$$Wrappers.__default.Need$3$#tmp0#0;
    inline$Impl$$Wrappers.__default.Need$3$defass#result#0 := true;
    assume {:captureState "libraries/src/Wrappers.dfy(108,24)"} true;
    assume inline$Impl$$Wrappers.__default.Need$3$defass#result#0;
    assume Wrappers.__default.Need#canCall(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$3$condition#0, inline$Impl$$Wrappers.__default.Need$3$error#0);
    goto inline$Impl$$Wrappers.__default.Need$3$Return;

  inline$Impl$$Wrappers.__default.Need$3$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$Impl$$Wrappers.__default.Need$3$result#0, Wrappers.__default.Need(inline$Impl$$Wrappers.__default.Need$3$Wrappers._default.Need$E, inline$Impl$$Wrappers.__default.Need$3$condition#0, inline$Impl$$Wrappers.__default.Need$3$error#0));
    assume true;
    assume true;
    inline$CallPost$$Wrappers.__default.Need$3$defass#result#0 := inline$Impl$$Wrappers.__default.Need$3$defass#result#0;
    inline$CallPost$$Wrappers.__default.Need$3$result#0 := inline$Impl$$Wrappers.__default.Need$3$result#0;
    inline$CallPost$$Wrappers.__default.Need$3$$_reverifyPost := inline$Impl$$Wrappers.__default.Need$3$$_reverifyPost;
    goto inline$CallPost$$Wrappers.__default.Need$3$anon_0$1;

  inline$CallPost$$Wrappers.__default.Need$3$anon_0$1:
    goto inline$CallPost$$Wrappers.__default.Need$3$Return;

  inline$CallPost$$Wrappers.__default.Need$3$Return:
    assume true;
    assume Wrappers.Outcome#Equal(inline$CallPost$$Wrappers.__default.Need$3$result#0, Wrappers.__default.Need(inline$CallPost$$Wrappers.__default.Need$3$Wrappers._default.Need$E, inline$CallPost$$Wrappers.__default.Need$3$condition#0, inline$CallPost$$Wrappers.__default.Need$3$error#0));
    assume true;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1 := inline$CallPost$$Wrappers.__default.Need$3$result#0;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon14$1;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon14$1:
    inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$$rhs##1;
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(118,5)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$anon25_Then, inline$Impl$$KdfCtr.__default.RawDerive$0$anon25_Else;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon25_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(118,5)"} true;
    push;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#valueOrError2#0;
    assume $IsAllocBox($Box(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0), Tclass.Wrappers.Outcome(Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    assume Wrappers.Outcome.Fail_q(inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$output#0 := Wrappers.Outcome.PropagateFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(118,5)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    pop;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$Return;

  inline$Impl$$KdfCtr.__default.RawDerive$0$anon25_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.AwsCryptographyPrimitivesTypes.Error(), inline$Impl$$KdfCtr.__default.RawDerive$0$valueOrError2#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(120,36)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.RawDerive", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(120,35)"} true;
    havoc inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0 /* where inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0 ==> $Is(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume 0 <= inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 && inline$Impl$$KdfCtr.__default.RawDerive$0$length#0 <= Seq#Length(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0);
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0 := #Wrappers.Result.Success($Box(Seq#Take(inline$Impl$$KdfCtr.__default.RawDerive$0$buffer#0, inline$Impl$$KdfCtr.__default.RawDerive$0$length#0)));
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(120,35)"} true;
    assume true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass##tmp2#0;
    assume true;
    inline$Impl$$KdfCtr.__default.RawDerive$0$output#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$#tmp2#0;
    inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(120,36)"} true;
    assume inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    goto inline$Impl$$KdfCtr.__default.RawDerive$0$Return;

  inline$Impl$$KdfCtr.__default.RawDerive$0$Return:
    assume true;
    assume Wrappers.Result.Success_q(inline$Impl$$KdfCtr.__default.RawDerive$0$output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(inline$Impl$$KdfCtr.__default.RawDerive$0$output#0)): Seq) == inline$Impl$$KdfCtr.__default.RawDerive$0$length#0;
    assume true;
    assume true;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$defass#output#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$defass#output#0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$output#0 := inline$Impl$$KdfCtr.__default.RawDerive$0$output#0;
    inline$CallPost$$KdfCtr.__default.RawDerive$0$$_reverifyPost := inline$Impl$$KdfCtr.__default.RawDerive$0$$_reverifyPost;
    goto inline$CallPost$$KdfCtr.__default.RawDerive$0$anon_0$1;

  inline$CallPost$$KdfCtr.__default.RawDerive$0$anon_0$1:
    goto inline$CallPost$$KdfCtr.__default.RawDerive$0$Return;

  inline$CallPost$$KdfCtr.__default.RawDerive$0$Return:
    assume true;
    assume Wrappers.Result.Success_q(inline$CallPost$$KdfCtr.__default.RawDerive$0$output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(inline$CallPost$$KdfCtr.__default.RawDerive$0$output#0)): Seq) == inline$CallPost$$KdfCtr.__default.RawDerive$0$length#0;
    assume true;
    assume true;
    $rhs##3 := inline$CallPost$$KdfCtr.__default.RawDerive$0$output#0;
    goto anon76_Else$1;

  anon76_Else$1:
    valueOrError3#0 := $rhs##3;
    defass#valueOrError3#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(72,87)"} true;
    assume defass#valueOrError3#0;
    assume $IsAllocBox($Box(valueOrError3#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0);
    goto anon77_Then, anon77_Else;

  anon77_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(72,87)"} true;
    push;
    assume true;
    assume defass#valueOrError3#0;
    assume $IsAllocBox($Box(valueOrError3#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#0);
    assume Wrappers.Result.Failure_q(valueOrError3#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError3#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError3#0);
    output#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), TSeq(Tclass.BoundedInts.uint8()), valueOrError3#0);
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(72,87)"} true;
    assume defass#output#0;
    pop;
    return;

  anon77_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0);
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(74,23)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(74,22)"} true;
    assume {:print "Block", " | ", "Impl$$KdfCtr.__default.KdfCounterMode", " | ", "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(72,87)"} true;
    assume true;
    assume defass#valueOrError3#0;
    assume $IsAllocBox($Box(valueOrError3#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#0);
    assume Wrappers.Result.Success_q(valueOrError3#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0);
    okm#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error(), valueOrError3#0)): Seq;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(72,87)"} true;
    havoc #tmp16#0 /* where defass##tmp16#0 ==> $Is(#tmp16#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(#tmp16#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) */;
    assume true;
    assume true;
    #tmp16#0 := #Wrappers.Result.Success($Box(okm#0));
    defass##tmp16#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(74,22)"} true;
    assume true;
    assume defass##tmp16#0;
    assume true;
    output#0 := #tmp16#0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/src/KDF/KdfCtr.dfy(74,23)"} true;
    assume defass#output#0;
    return;
}



procedure {:verboseName "KdfCtr.RawDerive (well-formedness)"} {:testInline} CheckWellFormed$$KdfCtr.__default.RawDerive(ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(ikm#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), explicitInfo#0: Seq where $Is(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), length#0: int where LitInt(-2147483648) <= length#0 && length#0 < 2147483648, offset#0: int where LitInt(-2147483648) <= offset#0 && offset#0 < 2147483648, digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digestAlgorithm#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "KdfCtr.RawDerive (call precondtion)"} {:testInline} CallPre$$KdfCtr.__default.RawDerive(ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(ikm#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), explicitInfo#0: Seq where $Is(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), length#0: int where LitInt(-2147483648) <= length#0 && length#0 < 2147483648, offset#0: int where LitInt(-2147483648) <= offset#0 && offset#0 < 2147483648, digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digestAlgorithm#0));
  requires {:id "id3847"} Seq#Length(ikm#0) >= LitInt(32);
  requires {:id "id3848"} length#0 > 0;
  requires {:id "id3849"} 4 + Seq#Length(explicitInfo#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
  requires {:id "id3850"} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(digestAlgorithm#0, #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256()) || AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(digestAlgorithm#0, #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
  requires {:id "id3851"} length#0 + Digest.__default.Length(Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256())) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() - 1;
  requires {:id "id3852"} length#0 + Digest.__default.Length(Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384())) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() - 1;



procedure {:verboseName "KdfCtr.RawDerive (call postcondition)"} {:testInline} CallPost$$KdfCtr.__default.RawDerive(ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(ikm#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), explicitInfo#0: Seq where $Is(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), length#0: int where LitInt(-2147483648) <= length#0 && length#0 < 2147483648, offset#0: int where LitInt(-2147483648) <= offset#0 && offset#0 < 2147483648, digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digestAlgorithm#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id3853"} Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == length#0;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "KdfCtr.RawDerive (correctness)"} {:testInline} Impl$$KdfCtr.__default.RawDerive(ikm#0: Seq where $Is(ikm#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(ikm#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), explicitInfo#0: Seq where $Is(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(explicitInfo#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), length#0: int where LitInt(-2147483648) <= length#0 && length#0 < 2147483648, offset#0: int where LitInt(-2147483648) <= offset#0 && offset#0 < 2147483648, digestAlgorithm#0: DatatypeType where $Is(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()) && $IsAlloc(digestAlgorithm#0, Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestAlgorithm(digestAlgorithm#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id3854"} Seq#Length(ikm#0) >= LitInt(32);
  requires {:id "id3855"} length#0 > 0;
  requires {:id "id3856"} 4 + Seq#Length(explicitInfo#0) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT();
  requires {:id "id3857"} AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(digestAlgorithm#0, #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256()) || AwsCryptographyPrimitivesTypes.DigestAlgorithm#Equal(digestAlgorithm#0, #AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384());
  requires {:id "id3858"} length#0 + Digest.__default.Length(Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_256())) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() - 1;
  requires {:id "id3859"} length#0 + Digest.__default.Length(Lit(#AwsCryptographyPrimitivesTypes.DigestAlgorithm.SHA_384())) < StandardLibrary_mUInt.__default.INT32__MAX__LIMIT() - 1;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id3860"} Wrappers.Result.Success_q(output#0) ==> Seq#Length($Unbox(Wrappers.Result.value(output#0)): Seq) == length#0;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function KdfCtr.__default.Increment(x#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { KdfCtr.__default.Increment(x#0) } KdfCtr.__default.Increment#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(x#0) == LitInt(4)) ==> (Wrappers.Result.Success_q(KdfCtr.__default.Increment(x#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(KdfCtr.__default.Increment(x#0))): Seq) == LitInt(4)) && $Is(KdfCtr.__default.Increment(x#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, x#0: Seq :: { $IsAlloc(KdfCtr.__default.Increment(x#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (KdfCtr.__default.Increment#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap) && Seq#Length(x#0) == LitInt(4))) && $IsGoodHeap($Heap) ==> $IsAlloc(KdfCtr.__default.Increment(x#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { KdfCtr.__default.Increment(x#0) } KdfCtr.__default.Increment#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(x#0) == LitInt(4)) ==> KdfCtr.__default.Increment(x#0) == (if $Unbox(Seq#Index(x#0, LitInt(3))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(x#0, LitInt(0))), Seq#Index(x#0, LitInt(1))), Seq#Index(x#0, LitInt(2))), $Box($Unbox(Seq#Index(x#0, LitInt(3))): int + 1)))) else (if $Unbox(Seq#Index(x#0, LitInt(2))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(x#0, LitInt(0))), Seq#Index(x#0, LitInt(1))), $Box($Unbox(Seq#Index(x#0, LitInt(2))): int + 1)), $Box(LitInt(0))))) else (if $Unbox(Seq#Index(x#0, LitInt(1))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(x#0, LitInt(0))), $Box($Unbox(Seq#Index(x#0, LitInt(1))): int + 1)), $Box(LitInt(0))), $Box(LitInt(0))))) else (if $Unbox(Seq#Index(x#0, LitInt(0))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box($Unbox(Seq#Index(x#0, LitInt(0))): int + 1)), $Box(LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0))))) else #Wrappers.Result.Failure($Box(Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(59))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(120))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(46)))))))))))));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { KdfCtr.__default.Increment(Lit(x#0)) } KdfCtr.__default.Increment#canCall(Lit(x#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(x#0)) == LitInt(4)) ==> KdfCtr.__default.Increment(Lit(x#0)) == (if $Unbox(Seq#Index(Lit(x#0), LitInt(3))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(x#0), LitInt(0))), Seq#Index(Lit(x#0), LitInt(1))), Seq#Index(Lit(x#0), LitInt(2))), $Box($Unbox(Seq#Index(Lit(x#0), LitInt(3))): int + 1)))) else (if $Unbox(Seq#Index(Lit(x#0), LitInt(2))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(x#0), LitInt(0))), Seq#Index(Lit(x#0), LitInt(1))), $Box($Unbox(Seq#Index(Lit(x#0), LitInt(2))): int + 1)), $Box(LitInt(0))))) else (if $Unbox(Seq#Index(Lit(x#0), LitInt(1))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(x#0), LitInt(0))), $Box($Unbox(Seq#Index(Lit(x#0), LitInt(1))): int + 1)), $Box(LitInt(0))), $Box(LitInt(0))))) else (if $Unbox(Seq#Index(Lit(x#0), LitInt(0))): int < 255 then #Wrappers.Result.Success($Box(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box($Unbox(Seq#Index(Lit(x#0), LitInt(0))): int + 1)), $Box(LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0))))) else #Wrappers.Result.Failure($Box(Lit(#AwsCryptographyPrimitivesTypes.Error.AwsCryptographicPrimitivesError(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(59))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(120))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(46)))))))))))));
}

function KdfCtr.__default.Increment#canCall(x#0: Seq) : bool;

function KdfCtr.__default.Increment#requires(Seq) : bool;

axiom (forall x#0: Seq :: { KdfCtr.__default.Increment#requires(x#0) } $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) ==> (KdfCtr.__default.Increment#requires(x#0) <==> Seq#Length(x#0) == LitInt(4)));

procedure {:verboseName "KdfCtr.Increment (well-formedness)"} {:testInline} CheckWellformed$$KdfCtr.__default.Increment(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8()))) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id3945"} Wrappers.Result.Success_q(ret#0) ==> Seq#Length($Unbox(Wrappers.Result.value(ret#0)): Seq) == LitInt(4);



procedure {:verboseName "KdfCtr.Increment (correctness)"} {:testInline} Impl$$KdfCtr.__default.Increment(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (defass#ret#0: bool, ret#0: DatatypeType where defass#ret#0 ==> $Is(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id3989"} Seq#Length(x#0) == LitInt(4);
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(ret#0) && $IsA#Wrappers.Result(KdfCtr.__default.Increment(x#0)) && KdfCtr.__default.Increment#canCall(x#0);
  free ensures {:id "id3990"} Wrappers.Result#Equal(ret#0, KdfCtr.__default.Increment(x#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "KdfCtr.Increment (well-formedness)"} {:testInline} CheckWellFormed$$KdfCtr.__default.Increment(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "KdfCtr.Increment (call precondtion)"} {:testInline} CallPre$$KdfCtr.__default.Increment(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id4043"} Seq#Length(x#0) == LitInt(4);



procedure {:verboseName "KdfCtr.Increment (call postcondition)"} {:testInline} CallPost$$KdfCtr.__default.Increment(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(ret#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(ret#0) && $IsA#Wrappers.Result(KdfCtr.__default.Increment(x#0)) && KdfCtr.__default.Increment#canCall(x#0);
  free ensures {:id "id4044"} Wrappers.Result#Equal(ret#0, KdfCtr.__default.Increment(x#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#32 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#32))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#34 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#34)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#48 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#48))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#50 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#50)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#52 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#52)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#48 := Wrappers.Option.value(this); v#48)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#50 := Lit(Wrappers.Option.value(Lit(this))); v#50)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#52 := Lit(Wrappers.Option.value(Lit(this))); v#52)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#32 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#32)) else (var e#32 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#34 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#34))) else (var e#34 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#48 := Wrappers.Result.value(this); s#48) else (var e#48 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#50 := Lit(Wrappers.Result.value(Lit(this))); s#50) else (var e#50 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#52 := Lit(Wrappers.Result.value(Lit(this))); s#52) else (var e#52 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#48 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#48)) else (var e#48 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#48)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#50 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#50))) else (var e#50 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#50)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#52 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#52))) else (var e#52 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#52)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#18 := Div(x#0, LitInt(256)); (var b1#18 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#18)), $Box(b1#18)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#19 := LitInt(Div(x#0, LitInt(256))); (var b1#19 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#19)), $Box(b1#19))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#18 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#18 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#19 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#19 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#18 := Div(x#0, LitInt(16777216)); (var x0#18 := x#0 - Mul(b0#18, LitInt(16777216)); (var b1#18 := Div(x0#18, LitInt(65536)); (var x1#18 := x0#18 - Mul(b1#18, LitInt(65536)); (var b2#18 := Div(x1#18, LitInt(256)); (var b3#18 := Mod(x1#18, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#18)), $Box(b1#18)), $Box(b2#18)), $Box(b3#18)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#19 := LitInt(Div(x#0, LitInt(16777216))); (var x0#19 := LitInt(x#0 - Mul(b0#19, LitInt(16777216))); (var b1#19 := LitInt(Div(x0#19, LitInt(65536))); (var x1#19 := LitInt(x0#19 - Mul(b1#19, LitInt(65536))); (var b2#19 := LitInt(Div(x1#19, LitInt(256))); (var b3#19 := LitInt(Mod(x1#19, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#19)), $Box(b1#19)), $Box(b2#19)), $Box(b3#19))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#18 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#18 := x0#18 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#18 := x1#18 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#18 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#19 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#19 := x0#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#19 := x1#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#19 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#18 := Div(x#0, LitInt(72057594037927936)); (var x0#18 := x#0 - Mul(b0#18, LitInt(72057594037927936)); (var b1#18 := Div(x0#18, LitInt(281474976710656)); (var x1#18 := x0#18 - Mul(b1#18, LitInt(281474976710656)); (var b2#18 := Div(x1#18, LitInt(1099511627776)); (var x2#18 := x1#18 - Mul(b2#18, LitInt(1099511627776)); (var b3#18 := Div(x2#18, LitInt(4294967296)); (var x3#18 := x2#18 - Mul(b3#18, LitInt(4294967296)); (var b4#18 := Div(x3#18, LitInt(16777216)); (var x4#18 := x3#18 - Mul(b4#18, LitInt(16777216)); (var b5#18 := Div(x4#18, LitInt(65536)); (var x5#18 := x4#18 - Mul(b5#18, LitInt(65536)); (var b6#18 := Div(x5#18, LitInt(256)); (var b7#18 := Mod(x5#18, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#18)), $Box(b1#18)), $Box(b2#18)), $Box(b3#18)), $Box(b4#18)), $Box(b5#18)), $Box(b6#18)), $Box(b7#18)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#19 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#19 := LitInt(x#0 - Mul(b0#19, LitInt(72057594037927936))); (var b1#19 := LitInt(Div(x0#19, LitInt(281474976710656))); (var x1#19 := LitInt(x0#19 - Mul(b1#19, LitInt(281474976710656))); (var b2#19 := LitInt(Div(x1#19, LitInt(1099511627776))); (var x2#19 := LitInt(x1#19 - Mul(b2#19, LitInt(1099511627776))); (var b3#19 := LitInt(Div(x2#19, LitInt(4294967296))); (var x3#19 := LitInt(x2#19 - Mul(b3#19, LitInt(4294967296))); (var b4#19 := LitInt(Div(x3#19, LitInt(16777216))); (var x4#19 := LitInt(x3#19 - Mul(b4#19, LitInt(16777216))); (var b5#19 := LitInt(Div(x4#19, LitInt(65536))); (var x5#19 := LitInt(x4#19 - Mul(b5#19, LitInt(65536))); (var b6#19 := LitInt(Div(x5#19, LitInt(256))); (var b7#19 := LitInt(Mod(x5#19, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#19)), $Box(b1#19)), $Box(b2#19)), $Box(b3#19)), $Box(b4#19)), $Box(b5#19)), $Box(b6#19)), $Box(b7#19))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#18 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#18 := x0#18 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#18 := x1#18 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#18 := x2#18 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#18 := x3#18 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#18 := x4#18 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#18 := x5#18 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#19 := x6#18 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#19)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#19 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#19 := x0#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#19 := x1#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#19 := x2#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#19 := x3#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#19 := x4#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#19 := x5#19 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#20 := x6#19 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#20)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#18 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#18)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#18 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#18)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#18)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#19 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#19)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#19 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#19)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#19)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#10: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#10)): Seq } LitInt(0) <= i#10 && i#10 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#10)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#11 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#11) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#11)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#11 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#11) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#11)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#11)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#12 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#12) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#12)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#12 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#12) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#12)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#12)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#13 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#13) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#13)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#13 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#13) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#13)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#13)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#6 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#6)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#6)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#7 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#7)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#7)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#8 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#8)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#8)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#6 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#6) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#6) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#6)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#6) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#6))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#6 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#6) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#6) else (var i#6 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#6)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#6)), $Box(Seq#Drop(s#0, i#6 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#7 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#7) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#7) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#7)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#7) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#7))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#7 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#7) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#7) else (var i#7 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#7)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#7)), $Box(Seq#Drop(Lit(s#0), i#7 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#8 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#8) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#8) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#8)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#8) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#8))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#8 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#8) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#8) else (var i#8 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#8)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#8))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#8 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#x#0: Box :: $Box($l#27#x#0 == c#0)), (lambda $l#27#heap#0: Heap, $l#27#x#0: Box :: $IsBox($l#27#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#27#heap#0: Heap, $l#27#x#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#x#0: Box :: $Box($l#25#x#0 == c#0)), (lambda $l#25#heap#0: Heap, $l#25#x#0: Box :: $IsBox($l#25#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#25#heap#0: Heap, $l#25#x#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#x#0: Box :: $Box($l#30#x#0 == c#0)), (lambda $l#30#heap#0: Heap, $l#30#x#0: Box :: $IsBox($l#30#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#30#heap#0: Heap, $l#30#x#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#x#0: Box :: $Box($l#28#x#0 == c#0)), (lambda $l#28#heap#0: Heap, $l#28#x#0: Box :: $IsBox($l#28#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#28#heap#0: Heap, $l#28#x#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#x#0: Box :: $Box($l#33#x#0 == Lit(c#0))), (lambda $l#33#heap#0: Heap, $l#33#x#0: Box :: $IsBox($l#33#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#33#heap#0: Heap, $l#33#x#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#x#0: Box :: $Box($l#31#x#0 == Lit(c#0))), (lambda $l#31#heap#0: Heap, $l#31#x#0: Box :: $IsBox($l#31#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#31#heap#0: Heap, $l#31#x#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#8: int :: { Seq#Index(s#0, j#8) } i#0 <= j#8 && j#8 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#8))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#9: int :: { Seq#Index(s#0, j#9) } i#0 <= j#9 && j#9 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#9))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#8: int :: { Seq#Index(s#0, i#8) } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#8))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#8))) && (forall i#9: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#9) } (LitInt(0) <= i#9 && i#9 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#9))) && (LitInt(0) <= i#9 && i#9 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#9))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#4: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#4) } LitInt(0) <= i#4 && i#4 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#4) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: value#0), (lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: $IsBox($l#16#_v0#0, TInt)), (lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#_v0#0: Box :: value#0), (lambda $l#18#heap#0: Heap, $l#18#_v0#0: Box :: $IsBox($l#18#_v0#0, TInt)), (lambda $l#18#heap#0: Heap, $l#18#_v0#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: Lit(value#0)), (lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: $IsBox($l#20#_v0#0, TInt)), (lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#8: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#8) } LitInt(0) <= k#8 ==> k#8 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#8)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#8: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#8) } LitInt(0) <= k#8 && k#8 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#8))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#9: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#9) } LitInt(0) <= k#9 ==> k#9 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#9)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#9: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#9) } LitInt(0) <= k#9 && k#9 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#9))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#10: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#10) } LitInt(0) <= k#10 ==> k#10 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#10)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#10: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#10) } LitInt(0) <= k#10 && k#10 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#10))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#8: int :: { Seq#Index(b#0, i#8) } { Seq#Index(a#0, i#8) } LitInt(0) <= i#8 && i#8 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#8) == Seq#Index(b#0, i#8)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#9: int :: { Seq#Index(b#0, i#9) } { Seq#Index(a#0, i#9) } LitInt(0) <= i#9 && i#9 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#9) == Seq#Index(Lit(b#0), i#9)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#10: int :: { Seq#Index(b#0, i#10) } { Seq#Index(a#0, i#10) } LitInt(0) <= i#10 && i#10 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#10) == Seq#Index(Lit(b#0), i#10)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#18: Box, y#18: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#18, x#18)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#18, y#18)): bool } $IsBox(x#18, StandardLibrary._default.Trichotomous$T) && $IsBox(y#18, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#18, y#18)): bool || x#18 == y#18 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#18, x#18)): bool) && (forall x#19: Box, y#19: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#19, x#19)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#19, y#19)): bool } $IsBox(x#19, StandardLibrary._default.Trichotomous$T) && $IsBox(y#19, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#19, y#19)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#19, x#19)): bool ==> false) && (forall x#20: Box, y#20: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#20, y#20)): bool } $IsBox(x#20, StandardLibrary._default.Trichotomous$T) && $IsBox(y#20, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#20, y#20)): bool ==> x#20 != y#20)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#21: Box, y#21: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#21, x#21)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#21, y#21)): bool } $IsBox(x#21, StandardLibrary._default.Trichotomous$T) && $IsBox(y#21, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#21, y#21)): bool || x#21 == y#21 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#21, x#21)): bool) && (forall x#22: Box, y#22: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#22, x#22)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#22, y#22)): bool } $IsBox(x#22, StandardLibrary._default.Trichotomous$T) && $IsBox(y#22, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#22, y#22)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#22, x#22)): bool ==> false) && (forall x#23: Box, y#23: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#23, y#23)): bool } $IsBox(x#23, StandardLibrary._default.Trichotomous$T) && $IsBox(y#23, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#23, y#23)): bool ==> x#23 != y#23)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#6: Box, y#6: Box, z#6: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#6, z#6)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#6, z#6)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#6, z#6)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#6, y#6)): bool } $IsBox(x#6, StandardLibrary._default.Transitive$T) && $IsBox(y#6, StandardLibrary._default.Transitive$T) && $IsBox(z#6, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#6, y#6)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#6, z#6)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#6, z#6)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#7: Box, y#7: Box, z#7: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#7, z#7)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#7, z#7)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#7, z#7)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#7, y#7)): bool } $IsBox(x#7, StandardLibrary._default.Transitive$T) && $IsBox(y#7, StandardLibrary._default.Transitive$T) && $IsBox(z#7, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#7, y#7)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#7, z#7)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#7, z#7)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#12: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#12)): Seq } LitInt(0) <= i#12 && i#12 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#12)]) && (forall k#4: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#4)) } { s#0[$Box(k#4)] } $Is(k#4, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#4)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#4))) && (forall i#13: int, _t#0#3: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#13)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#3)): Seq } _t#0#3 == i#13 - 1 ==> 0 < i#13 && i#13 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#3)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#13)): Seq, less#0)) && (forall i#14: int, j#4: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#4)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#14)): Seq } LitInt(0) <= i#14 && i#14 < j#4 && j#4 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#14)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#4)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#11 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#11)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#11))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#12 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#12)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#12))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#13 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#13)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#13))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#8: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#8, less#0) } { s#0[$Box(z#8)] } $Is(z#8, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#8)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#8, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#8: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#8, less#0) } { s#0[$Box(z#8)] } $Is(z#8, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#8)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#8, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#9: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#9, less#0) } { s#0[$Box(z#9)] } $Is(z#9, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#9)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#9, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#9: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#9, less#0) } { s#0[$Box(z#9)] } $Is(z#9, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#9)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#9, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#10: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#10, less#0) } { s#0[$Box(z#10)] } $Is(z#10, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#10)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#10, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#10: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#10, less#0) } { s#0[$Box(z#10)] } $Is(z#10, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#10)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#10, Lit(less#0)))));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#12: int :: { $Unbox(Seq#Index(s#0, i#12)): char } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#13: int :: { $Unbox(Seq#Index(s#0, i#13)): char } LitInt(0) <= i#13 && i#13 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#13)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#9: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#9)): int } { $Unbox(Seq#Index(s#0, i#9)): char } LitInt(0) <= i#9 && i#9 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#9)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#9)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#10 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#10, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#11 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#11, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#15 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#15) && (UTF8.__default.Uses1Byte(r#15) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#15) ==> (LitInt(2) <= Seq#Length(r#15) ==> UTF8.__default.Uses2Bytes#canCall(r#15)) && (LitInt(2) <= Seq#Length(r#15) && UTF8.__default.Uses2Bytes(r#15) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#15) && UTF8.__default.Uses2Bytes(r#15)) ==> (LitInt(3) <= Seq#Length(r#15) ==> UTF8.__default.Uses3Bytes#canCall(r#15)) && (LitInt(3) <= Seq#Length(r#15) && UTF8.__default.Uses3Bytes(r#15) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#15) && UTF8.__default.Uses3Bytes(r#15)) ==> (LitInt(4) <= Seq#Length(r#15) ==> UTF8.__default.Uses4Bytes#canCall(r#15)) && (LitInt(4) <= Seq#Length(r#15) && UTF8.__default.Uses4Bytes(r#15) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#15 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#15) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#15) && UTF8.__default.Uses2Bytes(r#15) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#15) && UTF8.__default.Uses3Bytes(r#15) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#15) && UTF8.__default.Uses4Bytes(r#15) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#16 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#16) && (UTF8.__default.Uses1Byte(r#16) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#16) ==> (LitInt(2) <= Seq#Length(r#16) ==> UTF8.__default.Uses2Bytes#canCall(r#16)) && (LitInt(2) <= Seq#Length(r#16) && UTF8.__default.Uses2Bytes(r#16) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#16) && UTF8.__default.Uses2Bytes(r#16)) ==> (LitInt(3) <= Seq#Length(r#16) ==> UTF8.__default.Uses3Bytes#canCall(r#16)) && (LitInt(3) <= Seq#Length(r#16) && UTF8.__default.Uses3Bytes(r#16) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#16) && UTF8.__default.Uses3Bytes(r#16)) ==> (LitInt(4) <= Seq#Length(r#16) ==> UTF8.__default.Uses4Bytes#canCall(r#16)) && (LitInt(4) <= Seq#Length(r#16) && UTF8.__default.Uses4Bytes(r#16) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#16 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#16) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#16) && UTF8.__default.Uses2Bytes(r#16) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#16) && UTF8.__default.Uses3Bytes(r#16) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#16) && UTF8.__default.Uses4Bytes(r#16) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#17 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#17) && (UTF8.__default.Uses1Byte(r#17) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#17) ==> (LitInt(2) <= Seq#Length(r#17) ==> UTF8.__default.Uses2Bytes#canCall(r#17)) && (LitInt(2) <= Seq#Length(r#17) && UTF8.__default.Uses2Bytes(r#17) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#17) && UTF8.__default.Uses2Bytes(r#17)) ==> (LitInt(3) <= Seq#Length(r#17) ==> UTF8.__default.Uses3Bytes#canCall(r#17)) && (LitInt(3) <= Seq#Length(r#17) && UTF8.__default.Uses3Bytes(r#17) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#17) && UTF8.__default.Uses3Bytes(r#17)) ==> (LitInt(4) <= Seq#Length(r#17) ==> UTF8.__default.Uses4Bytes#canCall(r#17)) && (LitInt(4) <= Seq#Length(r#17) && UTF8.__default.Uses4Bytes(r#17) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#17 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#17) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#17) && UTF8.__default.Uses2Bytes(r#17) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#17) && UTF8.__default.Uses3Bytes(r#17) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#17) && UTF8.__default.Uses4Bytes(r#17) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall input#0: DatatypeType :: { HMAC.__default.Digest(input#0) } HMAC.__default.Digest#canCall(input#0) || $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> (Wrappers.Result.Success_q(HMAC.__default.Digest(input#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(HMAC.__default.Digest(input#0))): Seq) == Digest.__default.Length(AwsCryptographyPrimitivesTypes.HMacInput.digestAlgorithm(input#0))) && $Is(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, input#0: DatatypeType :: { $IsAlloc(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.Digest#canCall(input#0) || ($Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.Digest(input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall hmac#0: ref :: { HMAC.__default.CreateHMacSuccess(hmac#0) } HMAC.__default.CreateHMacSuccess#canCall(hmac#0) || $Is(hmac#0, Tclass.HMAC.HMac()) ==> $Is(HMAC.__default.CreateHMacSuccess(hmac#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, hmac#0: ref :: { $IsAlloc(HMAC.__default.CreateHMacSuccess(hmac#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateHMacSuccess#canCall(hmac#0) || ($Is(hmac#0, Tclass.HMAC.HMac()) && $IsAlloc(hmac#0, Tclass.HMAC.HMac(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateHMacSuccess(hmac#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall hmac#0: ref :: { HMAC.__default.CreateHMacSuccess(hmac#0) } HMAC.__default.CreateHMacSuccess#canCall(hmac#0) || $Is(hmac#0, Tclass.HMAC.HMac()) ==> HMAC.__default.CreateHMacSuccess(hmac#0) == #Wrappers.Result.Success($Box(hmac#0)));

axiom (forall hmac#0: ref :: {:weight 3} { HMAC.__default.CreateHMacSuccess(Lit(hmac#0)) } HMAC.__default.CreateHMacSuccess#canCall(Lit(hmac#0)) || $Is(hmac#0, Tclass.HMAC.HMac()) ==> HMAC.__default.CreateHMacSuccess(Lit(hmac#0)) == Lit(#Wrappers.Result.Success($Box(Lit(hmac#0)))));

axiom (forall error#0: DatatypeType :: { HMAC.__default.CreateHMacFailure(error#0) } HMAC.__default.CreateHMacFailure#canCall(error#0) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> $Is(HMAC.__default.CreateHMacFailure(error#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(HMAC.__default.CreateHMacFailure(error#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateHMacFailure#canCall(error#0) || ($Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateHMacFailure(error#0), Tclass.Wrappers.Result(Tclass.HMAC.HMac(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall error#0: DatatypeType :: { HMAC.__default.CreateHMacFailure(error#0) } HMAC.__default.CreateHMacFailure#canCall(error#0) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> HMAC.__default.CreateHMacFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));

axiom (forall error#0: DatatypeType :: {:weight 3} { HMAC.__default.CreateHMacFailure(Lit(error#0)) } HMAC.__default.CreateHMacFailure#canCall(Lit(error#0)) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> HMAC.__default.CreateHMacFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));

axiom (forall bytes#0: Seq :: { HMAC.__default.CreateDigestSuccess(bytes#0) } HMAC.__default.CreateDigestSuccess#canCall(bytes#0) || $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> $Is(HMAC.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, bytes#0: Seq :: { $IsAlloc(HMAC.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateDigestSuccess#canCall(bytes#0) || ($Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateDigestSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall bytes#0: Seq :: { HMAC.__default.CreateDigestSuccess(bytes#0) } HMAC.__default.CreateDigestSuccess#canCall(bytes#0) || $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> HMAC.__default.CreateDigestSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));

axiom (forall bytes#0: Seq :: {:weight 3} { HMAC.__default.CreateDigestSuccess(Lit(bytes#0)) } HMAC.__default.CreateDigestSuccess#canCall(Lit(bytes#0)) || $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> HMAC.__default.CreateDigestSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));

axiom (forall error#0: DatatypeType :: { HMAC.__default.CreateDigestFailure(error#0) } HMAC.__default.CreateDigestFailure#canCall(error#0) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> $Is(HMAC.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(HMAC.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (HMAC.__default.CreateDigestFailure#canCall(error#0) || ($Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(HMAC.__default.CreateDigestFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall error#0: DatatypeType :: { HMAC.__default.CreateDigestFailure(error#0) } HMAC.__default.CreateDigestFailure#canCall(error#0) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> HMAC.__default.CreateDigestFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));

axiom (forall error#0: DatatypeType :: {:weight 3} { HMAC.__default.CreateDigestFailure(Lit(error#0)) } HMAC.__default.CreateDigestFailure#canCall(Lit(error#0)) || $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> HMAC.__default.CreateDigestFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));

axiom (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetKey($Heap, this) } HMAC.HMac.GetKey#canCall($Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) ==> $Is(HMAC.HMac.GetKey($Heap, this), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetDigest($Heap, this) } HMAC.HMac.GetDigest#canCall($Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) ==> $Is(HMAC.HMac.GetDigest($Heap, this), Tclass.AwsCryptographyPrimitivesTypes.DigestAlgorithm()));

axiom (forall $Heap: Heap, this: ref :: { HMAC.HMac.GetInputSoFar($Heap, this) } HMAC.HMac.GetInputSoFar#canCall($Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.HMAC.HMac()) && $IsAlloc(this, Tclass.HMAC.HMac(), $Heap)) ==> $Is(HMAC.HMac.GetInputSoFar($Heap, this), TSeq(Tclass.BoundedInts.uint8())));

const unique class.AbstractAwsCryptographyPrimitivesOperations.__default: ClassName;

function AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0: Box) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0: Box) : bool;

function Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig() : Ty;

function AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#requires(Box) : bool;

axiom (forall config#0: Box :: { AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#requires(config#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#requires(config#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ValidInternalConfig? (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0: Box) : Set
uses {
axiom 0 <= $FunctionContextHeight ==> (forall config#0: Box :: { AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0) } AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig#canCall(config#0) || (0 < $FunctionContextHeight && $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig())) ==> $Is(AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0), TSet(Tclass._System.object())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, config#0: Box :: { $IsAlloc(AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0), TSet(Tclass._System.object()), $Heap) } (AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig#canCall(config#0) || (0 < $FunctionContextHeight && $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0), TSet(Tclass._System.object()), $Heap));
}

function AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig#canCall(config#0: Box) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig#requires(Box) : bool;

axiom (forall config#0: Box :: { AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig#requires(config#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig#requires(config#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ModifiesInternalConfig (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRandomBytesEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRandomBytes (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytes(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRandomBytes (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytes(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0));
  requires {:id "id4125"} Lit(true);
  requires {:id "id4126"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRandomBytes (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytes(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4127"} Lit(true);
  free ensures {:id "id4128"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4129"} AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRandomBytesEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DigestEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.Digest (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.Digest(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.Digest (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.Digest(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0));
  requires {:id "id4135"} Lit(true);
  requires {:id "id4136"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.Digest (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.Digest(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4137"} Lit(true);
  free ensures {:id "id4138"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4139"} AbstractAwsCryptographyPrimitivesOperations.__default.DigestEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.HMac(config#0: Box, input#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.HMac(config#0, input#0) } AbstractAwsCryptographyPrimitivesOperations.__default.HMac#canCall(config#0, input#0) || (0 < $FunctionContextHeight && $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> $Is(AbstractAwsCryptographyPrimitivesOperations.__default.HMac(config#0, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, config#0: Box, input#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesOperations.__default.HMac(config#0, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesOperations.__default.HMac#canCall(config#0, input#0) || (0 < $FunctionContextHeight && $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesOperations.__default.HMac(config#0, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
}

function AbstractAwsCryptographyPrimitivesOperations.__default.HMac#canCall(config#0: Box, input#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HMac#requires(Box, DatatypeType) : bool;

axiom (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.HMac#requires(config#0, input#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.HMac#requires(config#0, input#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HMac (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.HMac(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExtractEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExtract (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtract(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExtract (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtract(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0));
  requires {:id "id4145"} Lit(true);
  requires {:id "id4146"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExtract (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtract(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4147"} Lit(true);
  free ensures {:id "id4148"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4149"} AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExtractEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExpandEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExpand (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpand(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExpand (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpand(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0));
  requires {:id "id4155"} Lit(true);
  requires {:id "id4156"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfExpand (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpand(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4157"} Lit(true);
  free ensures {:id "id4158"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4159"} AbstractAwsCryptographyPrimitivesOperations.__default.HkdfExpandEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.HkdfEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.Hkdf (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.Hkdf(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.Hkdf (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.Hkdf(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0));
  requires {:id "id4165"} Lit(true);
  requires {:id "id4166"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.Hkdf (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.Hkdf(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4167"} Lit(true);
  free ensures {:id "id4168"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4169"} AbstractAwsCryptographyPrimitivesOperations.__default.HkdfEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.KdfCounterModeEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.KdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.KdfCounterMode (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0));
  requires {:id "id4175"} Lit(true);
  requires {:id "id4176"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.KdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4177"} Lit(true);
  free ensures {:id "id4178"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4179"} AbstractAwsCryptographyPrimitivesOperations.__default.KdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AesKdfCounterModeEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AesKdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AesKdfCounterMode (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0));
  requires {:id "id4185"} Lit(true);
  requires {:id "id4186"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AesKdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4187"} Lit(true);
  free ensures {:id "id4188"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4189"} AbstractAwsCryptographyPrimitivesOperations.__default.AesKdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESEncryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.AESEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESEncrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.AESEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0));
  requires {:id "id4195"} Lit(true);
  requires {:id "id4196"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.AESEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4197"} Lit(true);
  free ensures {:id "id4198"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4199"} AbstractAwsCryptographyPrimitivesOperations.__default.AESEncryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESDecryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESDecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.AESDecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESDecrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.AESDecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0));
  requires {:id "id4205"} Lit(true);
  requires {:id "id4206"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.AESDecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.AESDecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4207"} Lit(true);
  free ensures {:id "id4208"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4209"} AbstractAwsCryptographyPrimitivesOperations.__default.AESDecryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRSAKeyPairEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRSAKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRSAKeyPair (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0));
  requires {:id "id4215"} Lit(true);
  requires {:id "id4216"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateRSAKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4217"} Lit(true);
  free ensures {:id "id4218"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4219"} AbstractAwsCryptographyPrimitivesOperations.__default.GenerateRSAKeyPairEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength(config#0: Box, input#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength(config#0, input#0) } AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength#canCall(config#0, input#0) || (0 < $FunctionContextHeight && $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> $Is(AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength(config#0, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, config#0: Box, input#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength(config#0, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength#canCall(config#0, input#0) || (0 < $FunctionContextHeight && $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength(config#0, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
}

function AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength#canCall(config#0: Box, input#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength#requires(Box, DatatypeType) : bool;

axiom (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength#requires(config#0, input#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength#requires(config#0, input#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GetRSAKeyModulusLength (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.GetRSAKeyModulusLength(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSADecryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSADecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.RSADecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSADecrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.RSADecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0));
  requires {:id "id4225"} Lit(true);
  requires {:id "id4226"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSADecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.RSADecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4227"} Lit(true);
  free ensures {:id "id4228"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4229"} AbstractAwsCryptographyPrimitivesOperations.__default.RSADecryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSAEncryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSAEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSAEncrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0));
  requires {:id "id4235"} Lit(true);
  requires {:id "id4236"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.RSAEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4237"} Lit(true);
  free ensures {:id "id4238"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4239"} AbstractAwsCryptographyPrimitivesOperations.__default.RSAEncryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECDSASignatureKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECDSASignatureKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECDSASignatureKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0));
  requires {:id "id4245"} Lit(true);
  requires {:id "id4246"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECDSASignatureKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4247"} Lit(true);
  free ensures {:id "id4248"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4249"} AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSASignEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSASign (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASign(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSASign (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASign(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0));
  requires {:id "id4255"} Lit(true);
  requires {:id "id4256"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSASign (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASign(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4257"} Lit(true);
  free ensures {:id "id4258"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4259"} AbstractAwsCryptographyPrimitivesOperations.__default.ECDSASignEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSAVerifyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSAVerify (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerify(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSAVerify (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerify(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0));
  requires {:id "id4265"} Lit(true);
  requires {:id "id4266"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ECDSAVerify (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerify(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4267"} Lit(true);
  free ensures {:id "id4268"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4269"} AbstractAwsCryptographyPrimitivesOperations.__default.ECDSAVerifyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECCKeyPairEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECCKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECCKeyPair (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0));
  requires {:id "id4275"} Lit(true);
  requires {:id "id4276"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GenerateECCKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4277"} Lit(true);
  free ensures {:id "id4278"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4279"} AbstractAwsCryptographyPrimitivesOperations.__default.GenerateECCKeyPairEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GetPublicKeyFromPrivateKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GetPublicKeyFromPrivateKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GetPublicKeyFromPrivateKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0));
  requires {:id "id4285"} Lit(true);
  requires {:id "id4286"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.GetPublicKeyFromPrivateKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4287"} Lit(true);
  free ensures {:id "id4288"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4289"} AbstractAwsCryptographyPrimitivesOperations.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ValidatePublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ValidatePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ValidatePublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0));
  requires {:id "id4295"} Lit(true);
  requires {:id "id4296"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ValidatePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4297"} Lit(true);
  free ensures {:id "id4298"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4299"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidatePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DeriveSharedSecretEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DeriveSharedSecret (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecret(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DeriveSharedSecret (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecret(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0));
  requires {:id "id4305"} Lit(true);
  requires {:id "id4306"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DeriveSharedSecret (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecret(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4307"} Lit(true);
  free ensures {:id "id4308"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4309"} AbstractAwsCryptographyPrimitivesOperations.__default.DeriveSharedSecretEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.CompressPublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.CompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.CompressPublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0));
  requires {:id "id4315"} Lit(true);
  requires {:id "id4316"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.CompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4317"} Lit(true);
  free ensures {:id "id4318"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4319"} AbstractAwsCryptographyPrimitivesOperations.__default.CompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DecompressPublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DecompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DecompressPublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0));
  requires {:id "id4325"} Lit(true);
  requires {:id "id4326"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.DecompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4327"} Lit(true);
  free ensures {:id "id4328"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4329"} AbstractAwsCryptographyPrimitivesOperations.__default.DecompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ParsePublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly(input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ParsePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ParsePublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0));
  requires {:id "id4335"} Lit(true);
  requires {:id "id4336"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesOperations.ParsePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesOperations.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id4337"} Lit(true);
  free ensures {:id "id4338"} AbstractAwsCryptographyPrimitivesOperations.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id4339"} AbstractAwsCryptographyPrimitivesOperations.__default.ParsePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesOperations.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



const unique class.AbstractAwsCryptographyPrimitivesOperations.InternalConfig: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#36 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#36))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#38 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#38)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#54 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#54))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#56 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#56)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#58 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#58)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#54 := Wrappers.Option.value(this); v#54)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#56 := Lit(Wrappers.Option.value(Lit(this))); v#56)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#58 := Lit(Wrappers.Option.value(Lit(this))); v#58)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#36 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#36)) else (var e#36 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#38 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#38))) else (var e#38 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#54 := Wrappers.Result.value(this); s#54) else (var e#54 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#56 := Lit(Wrappers.Result.value(Lit(this))); s#56) else (var e#56 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#58 := Lit(Wrappers.Result.value(Lit(this))); s#58) else (var e#58 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#54 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#54)) else (var e#54 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#54)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#56 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#56))) else (var e#56 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#56)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#58 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#58))) else (var e#58 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#58)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#20 := Div(x#0, LitInt(256)); (var b1#20 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#20)), $Box(b1#20)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#21 := LitInt(Div(x#0, LitInt(256))); (var b1#21 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#21)), $Box(b1#21))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#20 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#20 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#21 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#21 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#20 := Div(x#0, LitInt(16777216)); (var x0#20 := x#0 - Mul(b0#20, LitInt(16777216)); (var b1#20 := Div(x0#20, LitInt(65536)); (var x1#20 := x0#20 - Mul(b1#20, LitInt(65536)); (var b2#20 := Div(x1#20, LitInt(256)); (var b3#20 := Mod(x1#20, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#20)), $Box(b1#20)), $Box(b2#20)), $Box(b3#20)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#21 := LitInt(Div(x#0, LitInt(16777216))); (var x0#21 := LitInt(x#0 - Mul(b0#21, LitInt(16777216))); (var b1#21 := LitInt(Div(x0#21, LitInt(65536))); (var x1#21 := LitInt(x0#21 - Mul(b1#21, LitInt(65536))); (var b2#21 := LitInt(Div(x1#21, LitInt(256))); (var b3#21 := LitInt(Mod(x1#21, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#21)), $Box(b1#21)), $Box(b2#21)), $Box(b3#21))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#20 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#20 := x0#20 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#20 := x1#20 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#20 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#21 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#21 := x0#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#21 := x1#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#21 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#20 := Div(x#0, LitInt(72057594037927936)); (var x0#20 := x#0 - Mul(b0#20, LitInt(72057594037927936)); (var b1#20 := Div(x0#20, LitInt(281474976710656)); (var x1#20 := x0#20 - Mul(b1#20, LitInt(281474976710656)); (var b2#20 := Div(x1#20, LitInt(1099511627776)); (var x2#20 := x1#20 - Mul(b2#20, LitInt(1099511627776)); (var b3#20 := Div(x2#20, LitInt(4294967296)); (var x3#20 := x2#20 - Mul(b3#20, LitInt(4294967296)); (var b4#20 := Div(x3#20, LitInt(16777216)); (var x4#20 := x3#20 - Mul(b4#20, LitInt(16777216)); (var b5#20 := Div(x4#20, LitInt(65536)); (var x5#20 := x4#20 - Mul(b5#20, LitInt(65536)); (var b6#20 := Div(x5#20, LitInt(256)); (var b7#20 := Mod(x5#20, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#20)), $Box(b1#20)), $Box(b2#20)), $Box(b3#20)), $Box(b4#20)), $Box(b5#20)), $Box(b6#20)), $Box(b7#20)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#21 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#21 := LitInt(x#0 - Mul(b0#21, LitInt(72057594037927936))); (var b1#21 := LitInt(Div(x0#21, LitInt(281474976710656))); (var x1#21 := LitInt(x0#21 - Mul(b1#21, LitInt(281474976710656))); (var b2#21 := LitInt(Div(x1#21, LitInt(1099511627776))); (var x2#21 := LitInt(x1#21 - Mul(b2#21, LitInt(1099511627776))); (var b3#21 := LitInt(Div(x2#21, LitInt(4294967296))); (var x3#21 := LitInt(x2#21 - Mul(b3#21, LitInt(4294967296))); (var b4#21 := LitInt(Div(x3#21, LitInt(16777216))); (var x4#21 := LitInt(x3#21 - Mul(b4#21, LitInt(16777216))); (var b5#21 := LitInt(Div(x4#21, LitInt(65536))); (var x5#21 := LitInt(x4#21 - Mul(b5#21, LitInt(65536))); (var b6#21 := LitInt(Div(x5#21, LitInt(256))); (var b7#21 := LitInt(Mod(x5#21, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#21)), $Box(b1#21)), $Box(b2#21)), $Box(b3#21)), $Box(b4#21)), $Box(b5#21)), $Box(b6#21)), $Box(b7#21))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#20 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#20 := x0#20 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#20 := x1#20 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#20 := x2#20 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#20 := x3#20 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#20 := x4#20 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#20 := x5#20 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#21 := x6#20 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#21)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#21 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#21 := x0#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#21 := x1#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#21 := x2#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#21 := x3#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#21 := x4#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#21 := x5#21 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#22 := x6#21 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#22)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#20 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#20)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#20 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#20)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#20)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#21 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#21)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#21 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#21)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#21)): int)));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#14: int :: { $Unbox(Seq#Index(s#0, i#14)): char } LitInt(0) <= i#14 && i#14 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#14)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#15: int :: { $Unbox(Seq#Index(s#0, i#15)): char } LitInt(0) <= i#15 && i#15 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#15)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#10: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#10)): int } { $Unbox(Seq#Index(s#0, i#10)): char } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#10)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#12 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#12, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#13 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#13, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#18 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#18) && (UTF8.__default.Uses1Byte(r#18) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#18) ==> (LitInt(2) <= Seq#Length(r#18) ==> UTF8.__default.Uses2Bytes#canCall(r#18)) && (LitInt(2) <= Seq#Length(r#18) && UTF8.__default.Uses2Bytes(r#18) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#18) && UTF8.__default.Uses2Bytes(r#18)) ==> (LitInt(3) <= Seq#Length(r#18) ==> UTF8.__default.Uses3Bytes#canCall(r#18)) && (LitInt(3) <= Seq#Length(r#18) && UTF8.__default.Uses3Bytes(r#18) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#18) && UTF8.__default.Uses3Bytes(r#18)) ==> (LitInt(4) <= Seq#Length(r#18) ==> UTF8.__default.Uses4Bytes#canCall(r#18)) && (LitInt(4) <= Seq#Length(r#18) && UTF8.__default.Uses4Bytes(r#18) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#18 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#18) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#18) && UTF8.__default.Uses2Bytes(r#18) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#18) && UTF8.__default.Uses3Bytes(r#18) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#18) && UTF8.__default.Uses4Bytes(r#18) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#19 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#19) && (UTF8.__default.Uses1Byte(r#19) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#19) ==> (LitInt(2) <= Seq#Length(r#19) ==> UTF8.__default.Uses2Bytes#canCall(r#19)) && (LitInt(2) <= Seq#Length(r#19) && UTF8.__default.Uses2Bytes(r#19) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#19) && UTF8.__default.Uses2Bytes(r#19)) ==> (LitInt(3) <= Seq#Length(r#19) ==> UTF8.__default.Uses3Bytes#canCall(r#19)) && (LitInt(3) <= Seq#Length(r#19) && UTF8.__default.Uses3Bytes(r#19) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#19) && UTF8.__default.Uses3Bytes(r#19)) ==> (LitInt(4) <= Seq#Length(r#19) ==> UTF8.__default.Uses4Bytes#canCall(r#19)) && (LitInt(4) <= Seq#Length(r#19) && UTF8.__default.Uses4Bytes(r#19) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#19 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#19) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#19) && UTF8.__default.Uses2Bytes(r#19) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#19) && UTF8.__default.Uses3Bytes(r#19) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#19) && UTF8.__default.Uses4Bytes(r#19) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#20 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#20) && (UTF8.__default.Uses1Byte(r#20) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#20) ==> (LitInt(2) <= Seq#Length(r#20) ==> UTF8.__default.Uses2Bytes#canCall(r#20)) && (LitInt(2) <= Seq#Length(r#20) && UTF8.__default.Uses2Bytes(r#20) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#20) && UTF8.__default.Uses2Bytes(r#20)) ==> (LitInt(3) <= Seq#Length(r#20) ==> UTF8.__default.Uses3Bytes#canCall(r#20)) && (LitInt(3) <= Seq#Length(r#20) && UTF8.__default.Uses3Bytes(r#20) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#20) && UTF8.__default.Uses3Bytes(r#20)) ==> (LitInt(4) <= Seq#Length(r#20) ==> UTF8.__default.Uses4Bytes#canCall(r#20)) && (LitInt(4) <= Seq#Length(r#20) && UTF8.__default.Uses4Bytes(r#20) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#20 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#20) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#20) && UTF8.__default.Uses2Bytes(r#20) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#20) && UTF8.__default.Uses3Bytes(r#20) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#20) && UTF8.__default.Uses4Bytes(r#20) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

const class.AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default: ClassName;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0: Box) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0: Box) : bool;

function Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig() : Ty;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#requires(Box) : bool;

axiom (forall config#0: Box :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#requires(config#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#requires(config#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0: Box) : Set;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#canCall(config#0: Box) : bool;

axiom (forall config#0: Box :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0) } AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#canCall(config#0) || $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) ==> $Is(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0), TSet(Tclass._System.object())));

axiom (forall $Heap: Heap, config#0: Box :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0), TSet(Tclass._System.object()), $Heap) } (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#canCall(config#0) || ($IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0), TSet(Tclass._System.object()), $Heap));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#requires(Box) : bool;

axiom (forall config#0: Box :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#requires(config#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#requires(config#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(config#0: Box, input#0: DatatypeType) : DatatypeType;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#canCall(config#0: Box, input#0: DatatypeType) : bool;

axiom (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(config#0, input#0) } AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#canCall(config#0, input#0) || ($IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> $Is(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(config#0, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, config#0: Box, input#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(config#0, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#canCall(config#0, input#0) || ($IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(config#0, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#requires(Box, DatatypeType) : bool;

axiom (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#requires(config#0, input#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#requires(config#0, input#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(config#0: Box, input#0: DatatypeType) : DatatypeType;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#canCall(config#0: Box, input#0: DatatypeType) : bool;

axiom (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(config#0, input#0) } AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#canCall(config#0, input#0) || ($IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> $Is(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(config#0, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, config#0: Box, input#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(config#0, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#canCall(config#0, input#0) || ($IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(config#0, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#requires(Box, DatatypeType) : bool;

axiom (forall config#0: Box, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#requires(config#0, input#0) } $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#requires(config#0, input#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#canCall(input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#requires(DatatypeType, DatatypeType) : bool;

axiom (forall input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#requires(input#0, output#0) } $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#requires(input#0, output#0) <==> true));

const class.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#40 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#40))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#42 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#42)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#60 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#60))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#62 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#62)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#64 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#64)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#60 := Wrappers.Option.value(this); v#60)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#62 := Lit(Wrappers.Option.value(Lit(this))); v#62)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#64 := Lit(Wrappers.Option.value(Lit(this))); v#64)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#40 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#40)) else (var e#40 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#42 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#42))) else (var e#42 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#60 := Wrappers.Result.value(this); s#60) else (var e#60 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#62 := Lit(Wrappers.Result.value(Lit(this))); s#62) else (var e#62 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#64 := Lit(Wrappers.Result.value(Lit(this))); s#64) else (var e#64 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#60 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#60)) else (var e#60 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#60)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#62 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#62))) else (var e#62 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#62)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#64 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#64))) else (var e#64 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#64)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#22 := Div(x#0, LitInt(256)); (var b1#22 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#22)), $Box(b1#22)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#23 := LitInt(Div(x#0, LitInt(256))); (var b1#23 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#23)), $Box(b1#23))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#22 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#22 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#23 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#23 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#22 := Div(x#0, LitInt(16777216)); (var x0#22 := x#0 - Mul(b0#22, LitInt(16777216)); (var b1#22 := Div(x0#22, LitInt(65536)); (var x1#22 := x0#22 - Mul(b1#22, LitInt(65536)); (var b2#22 := Div(x1#22, LitInt(256)); (var b3#22 := Mod(x1#22, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#22)), $Box(b1#22)), $Box(b2#22)), $Box(b3#22)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#23 := LitInt(Div(x#0, LitInt(16777216))); (var x0#23 := LitInt(x#0 - Mul(b0#23, LitInt(16777216))); (var b1#23 := LitInt(Div(x0#23, LitInt(65536))); (var x1#23 := LitInt(x0#23 - Mul(b1#23, LitInt(65536))); (var b2#23 := LitInt(Div(x1#23, LitInt(256))); (var b3#23 := LitInt(Mod(x1#23, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#23)), $Box(b1#23)), $Box(b2#23)), $Box(b3#23))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#22 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#22 := x0#22 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#22 := x1#22 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#22 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#23 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#23 := x0#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#23 := x1#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#23 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#22 := Div(x#0, LitInt(72057594037927936)); (var x0#22 := x#0 - Mul(b0#22, LitInt(72057594037927936)); (var b1#22 := Div(x0#22, LitInt(281474976710656)); (var x1#22 := x0#22 - Mul(b1#22, LitInt(281474976710656)); (var b2#22 := Div(x1#22, LitInt(1099511627776)); (var x2#22 := x1#22 - Mul(b2#22, LitInt(1099511627776)); (var b3#22 := Div(x2#22, LitInt(4294967296)); (var x3#22 := x2#22 - Mul(b3#22, LitInt(4294967296)); (var b4#22 := Div(x3#22, LitInt(16777216)); (var x4#22 := x3#22 - Mul(b4#22, LitInt(16777216)); (var b5#22 := Div(x4#22, LitInt(65536)); (var x5#22 := x4#22 - Mul(b5#22, LitInt(65536)); (var b6#22 := Div(x5#22, LitInt(256)); (var b7#22 := Mod(x5#22, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#22)), $Box(b1#22)), $Box(b2#22)), $Box(b3#22)), $Box(b4#22)), $Box(b5#22)), $Box(b6#22)), $Box(b7#22)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#23 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#23 := LitInt(x#0 - Mul(b0#23, LitInt(72057594037927936))); (var b1#23 := LitInt(Div(x0#23, LitInt(281474976710656))); (var x1#23 := LitInt(x0#23 - Mul(b1#23, LitInt(281474976710656))); (var b2#23 := LitInt(Div(x1#23, LitInt(1099511627776))); (var x2#23 := LitInt(x1#23 - Mul(b2#23, LitInt(1099511627776))); (var b3#23 := LitInt(Div(x2#23, LitInt(4294967296))); (var x3#23 := LitInt(x2#23 - Mul(b3#23, LitInt(4294967296))); (var b4#23 := LitInt(Div(x3#23, LitInt(16777216))); (var x4#23 := LitInt(x3#23 - Mul(b4#23, LitInt(16777216))); (var b5#23 := LitInt(Div(x4#23, LitInt(65536))); (var x5#23 := LitInt(x4#23 - Mul(b5#23, LitInt(65536))); (var b6#23 := LitInt(Div(x5#23, LitInt(256))); (var b7#23 := LitInt(Mod(x5#23, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#23)), $Box(b1#23)), $Box(b2#23)), $Box(b3#23)), $Box(b4#23)), $Box(b5#23)), $Box(b6#23)), $Box(b7#23))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#22 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#22 := x0#22 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#22 := x1#22 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#22 := x2#22 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#22 := x3#22 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#22 := x4#22 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#22 := x5#22 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#23 := x6#22 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#23)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#23 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#23 := x0#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#23 := x1#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#23 := x2#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#23 := x3#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#23 := x4#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#23 := x5#23 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#24 := x6#23 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#24)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#22 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#22)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#22 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#22)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#22)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#23 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#23)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#23 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#23)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#23)): int)));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#16: int :: { $Unbox(Seq#Index(s#0, i#16)): char } LitInt(0) <= i#16 && i#16 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#16)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#17: int :: { $Unbox(Seq#Index(s#0, i#17)): char } LitInt(0) <= i#17 && i#17 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#17)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#11: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#11)): int } { $Unbox(Seq#Index(s#0, i#11)): char } LitInt(0) <= i#11 && i#11 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#11)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#11)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#14 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#14, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#15 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#15, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#21 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#21) && (UTF8.__default.Uses1Byte(r#21) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#21) ==> (LitInt(2) <= Seq#Length(r#21) ==> UTF8.__default.Uses2Bytes#canCall(r#21)) && (LitInt(2) <= Seq#Length(r#21) && UTF8.__default.Uses2Bytes(r#21) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#21) && UTF8.__default.Uses2Bytes(r#21)) ==> (LitInt(3) <= Seq#Length(r#21) ==> UTF8.__default.Uses3Bytes#canCall(r#21)) && (LitInt(3) <= Seq#Length(r#21) && UTF8.__default.Uses3Bytes(r#21) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#21) && UTF8.__default.Uses3Bytes(r#21)) ==> (LitInt(4) <= Seq#Length(r#21) ==> UTF8.__default.Uses4Bytes#canCall(r#21)) && (LitInt(4) <= Seq#Length(r#21) && UTF8.__default.Uses4Bytes(r#21) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#21 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#21) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#21) && UTF8.__default.Uses2Bytes(r#21) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#21) && UTF8.__default.Uses3Bytes(r#21) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#21) && UTF8.__default.Uses4Bytes(r#21) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#22 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#22) && (UTF8.__default.Uses1Byte(r#22) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#22) ==> (LitInt(2) <= Seq#Length(r#22) ==> UTF8.__default.Uses2Bytes#canCall(r#22)) && (LitInt(2) <= Seq#Length(r#22) && UTF8.__default.Uses2Bytes(r#22) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#22) && UTF8.__default.Uses2Bytes(r#22)) ==> (LitInt(3) <= Seq#Length(r#22) ==> UTF8.__default.Uses3Bytes#canCall(r#22)) && (LitInt(3) <= Seq#Length(r#22) && UTF8.__default.Uses3Bytes(r#22) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#22) && UTF8.__default.Uses3Bytes(r#22)) ==> (LitInt(4) <= Seq#Length(r#22) ==> UTF8.__default.Uses4Bytes#canCall(r#22)) && (LitInt(4) <= Seq#Length(r#22) && UTF8.__default.Uses4Bytes(r#22) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#22 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#22) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#22) && UTF8.__default.Uses2Bytes(r#22) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#22) && UTF8.__default.Uses3Bytes(r#22) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#22) && UTF8.__default.Uses4Bytes(r#22) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#23 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#23) && (UTF8.__default.Uses1Byte(r#23) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#23) ==> (LitInt(2) <= Seq#Length(r#23) ==> UTF8.__default.Uses2Bytes#canCall(r#23)) && (LitInt(2) <= Seq#Length(r#23) && UTF8.__default.Uses2Bytes(r#23) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#23) && UTF8.__default.Uses2Bytes(r#23)) ==> (LitInt(3) <= Seq#Length(r#23) ==> UTF8.__default.Uses3Bytes#canCall(r#23)) && (LitInt(3) <= Seq#Length(r#23) && UTF8.__default.Uses3Bytes(r#23) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#23) && UTF8.__default.Uses3Bytes(r#23)) ==> (LitInt(4) <= Seq#Length(r#23) ==> UTF8.__default.Uses4Bytes#canCall(r#23)) && (LitInt(4) <= Seq#Length(r#23) && UTF8.__default.Uses4Bytes(r#23) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#23 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#23) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#23) && UTF8.__default.Uses2Bytes(r#23) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#23) && UTF8.__default.Uses3Bytes(r#23) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#23) && UTF8.__default.Uses4Bytes(r#23) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

const unique class.AbstractAwsCryptographyPrimitivesService.__default: ClassName;

function AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig() : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig#canCall() || 0 < $FunctionContextHeight ==> $Is(AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig(), Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig());
}

function AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig#canCall() : bool;

function AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig#requires() : bool
uses {
axiom AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig#requires() <==> true;
}

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.DefaultCryptoConfig (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient() : Ty
uses {
axiom Tag(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) == Tagclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient && TagFamily(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) == tytagFamily$AtomicPrimitivesClient;
}

const unique Tagclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } $IsBox(bx, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitives (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.__default.AtomicPrimitives(config#0: DatatypeType where $Is(config#0, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) && $IsAlloc(config#0, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CryptoConfig(config#0)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?() : Ty
uses {
axiom Tag(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) == Tagclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient? && TagFamily(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) == tytagFamily$AtomicPrimitivesClient;
axiom implements$AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?());
}

const unique Tagclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) } $IsBox(bx, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitives (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.__default.AtomicPrimitives(config#0: DatatypeType) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitives", " | ", config#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(712,9): initial state"} true;
    assume AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig#canCall();
    assume AwsCryptographyPrimitivesTypes.CryptoConfig.CryptoConfig_q(AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig());
    assume AbstractAwsCryptographyPrimitivesService.__default.DefaultCryptoConfig#canCall();
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(714,25): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume $Unbox(Wrappers.Result.value(res#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(res#0)): ref, alloc)): bool;
    assume Wrappers.Result.Success_q(res#0);
    assume $Unbox(Wrappers.Result.value(res#0)): ref != null;
    assume (forall $o: ref :: { $o != null } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> $o != null) && (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
    assume Wrappers.Result.Success_q(res#0);
    assume $Unbox(Wrappers.Result.value(res#0)): ref != null;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref) != null && !$Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref), alloc)): bool;
    assume Wrappers.Result.Success_q(res#0);
    assume $Unbox(Wrappers.Result.value(res#0)): ref != null;
    assume $IsAllocBox(Wrappers.Result.value(res#0), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall($Unbox(Wrappers.Result.value(res#0)): ref);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState($Unbox(Wrappers.Result.value(res#0)): ref);
    return;

  anon4_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(res#0)): ref, alloc)): bool && (forall $o: ref :: { $o != null } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> $o != null) && (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool) && AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref) != null && !$Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref), alloc)): bool && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState($Unbox(Wrappers.Result.value(res#0)): ref);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitives (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.__default.AtomicPrimitives(config#0: DatatypeType where $Is(config#0, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) && $IsAlloc(config#0, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CryptoConfig(config#0));



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitives (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.__default.AtomicPrimitives(config#0: DatatypeType where $Is(config#0, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig()) && $IsAlloc(config#0, Tclass.AwsCryptographyPrimitivesTypes.CryptoConfig(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CryptoConfig(config#0)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(res#0)): ref, alloc)): bool ==> (forall $o: ref :: { $o != null } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> $o != null) && (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref) != null && !$Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref), alloc)): bool ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall($Unbox(Wrappers.Result.value(res#0)): ref);
  free ensures {:id "id4353"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(res#0)): ref, alloc)): bool;
  free ensures {:id "id4354"} Wrappers.Result.Success_q(res#0) ==> (forall $o: ref :: { $o != null } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> $o != null) && (forall $o: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies($Unbox(Wrappers.Result.value(res#0)): ref)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures {:id "id4355"} Wrappers.Result.Success_q(res#0) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref) != null && !$Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History($Unbox(Wrappers.Result.value(res#0)): ref), alloc)): bool;
  free ensures {:id "id4356"} Wrappers.Result.Success_q(res#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState($Unbox(Wrappers.Result.value(res#0)): ref);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0: ref) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall client#0: ref :: { AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0) } AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#canCall(client#0) || (0 < $FunctionContextHeight && $Is(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient())) ==> $Is(AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, client#0: ref :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#canCall(client#0) || (0 < $FunctionContextHeight && $Is(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $IsAlloc(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall client#0: ref :: { AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0) } AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#canCall(client#0) || (0 < $FunctionContextHeight && $Is(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient())) ==> AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0) == #Wrappers.Result.Success($Box(client#0)));
axiom 0 <= $FunctionContextHeight ==> (forall client#0: ref :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(Lit(client#0)) } AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#canCall(Lit(client#0)) || (0 < $FunctionContextHeight && $Is(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient())) ==> AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(Lit(client#0)) == Lit(#Wrappers.Result.Success($Box(Lit(client#0)))));
}

function AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#canCall(client#0: ref) : bool;

function AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#requires(ref) : bool;

axiom (forall client#0: ref :: { AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#requires(client#0) } $Is(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) ==> (AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient#requires(client#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.CreateSuccessOfClient (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.__default.CreateSuccessOfClient(client#0: ref where $Is(client#0, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0) } AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> $Is(AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, error#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) && $IsAlloc(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0) } AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(Lit(error#0)) } AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#canCall(error#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#requires(DatatypeType) : bool;

axiom (forall error#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#requires(error#0) } $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()) ==> (AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError#requires(error#0) <==> true));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.CreateFailureOfError (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.__default.CreateFailureOfError(error#0: DatatypeType where $Is(error#0, Tclass.AwsCryptographyPrimitivesTypes.Error()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



const unique class.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?: ClassName;

axiom (forall $o: ref :: { $Is($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) } $Is($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) <==> $o == null || dtype($o) == Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?());

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $h) } $IsAlloc($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient._ctor (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.__ctor(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this: ref) : Box
uses {
axiom 0 < $FunctionContextHeight ==> (forall $o: ref :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config($o) } $o != null && dtype($o) == Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?() ==> $IsBox(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config($o), Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: ref :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAllocBox(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config($o), Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $h));
}

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient._ctor (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.__ctor(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap));
  requires {:id "id4363"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient._ctor (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.__ctor(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap));
  modifies $Heap;
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4364"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures {:id "id4365"} AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null && !$Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), alloc)): bool;
  free ensures {:id "id4366"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this) == config#0;
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this: ref) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: ref :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)) && !AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this))[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))] && Set#Equal(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#Union(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this: ref) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#requires(ref) : bool;

axiom (forall this: ref :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#requires(this) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#requires(this) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall this: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id4367"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this));
  free ensures {:id "id4368"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> !AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this))[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))];
  free ensures {:id "id4369"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> Set#Equal(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#Union(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##config#0: Box;
  var ##config#1: Box;
  var ##config#2: Box;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(736,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume this == this;
    assume this == this || AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    ##config#0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume $IsAllocBox(##config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this));
    assume AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this));
    ##config#1 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume $IsAllocBox(##config#1, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this));
    assume !AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this))[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))];
    ##config#2 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume $IsAllocBox(##config#2, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this));
    assume Set#Equal(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#Union(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    goto anon5;

  anon8_Else:
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)) && !AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this))[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))] && Set#Equal(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#Union(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this: ref)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    assume true;
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)) && !AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this))[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))] && Set#Equal(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#Union(AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this)), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))];
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(744,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(753,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0));
  requires {:id "id4407"} Lit(true);
  requires {:id "id4408"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4409"} Lit(true);
  free ensures {:id "id4410"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4411"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4412"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4413"} Lit(true);
  requires {:id "id4414"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4415"} Lit(true);
  free ensures {:id "id4416"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4417"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytesEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4418"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(756,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytes(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytes(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(757,61)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRandomBytes, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(758,98)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(764,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(773,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0));
  requires {:id "id4457"} Lit(true);
  requires {:id "id4458"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4459"} Lit(true);
  free ensures {:id "id4460"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4461"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4462"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4463"} Lit(true);
  requires {:id "id4464"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4465"} Lit(true);
  free ensures {:id "id4466"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4467"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DigestEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4468"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(776,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Digest(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Digest(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(777,48)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Digest, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(778,72)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this: ref, input#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> $Is(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), input#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0) == AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), input#0));
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, Lit(input#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(this, Lit(input#0)) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), Lit(input#0)) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, Lit(input#0)) == AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), Lit(input#0)));
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(Lit(this), Lit(input#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(Lit(this), Lit(input#0)) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(Lit(this)), Lit(input#0)) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(Lit(this), Lit(input#0)) == AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HMac(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(Lit(this)), Lit(input#0)));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(this: ref, input#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#requires(ref, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#requires(this, input#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#requires(this, input#0) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0) == AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0);
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HMac(this, input#0) == output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(793,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(802,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0));
  requires {:id "id4511"} Lit(true);
  requires {:id "id4512"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4513"} Lit(true);
  free ensures {:id "id4514"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4515"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4516"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4517"} Lit(true);
  requires {:id "id4518"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4519"} Lit(true);
  free ensures {:id "id4520"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4521"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtractEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4522"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(805,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtract(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtract(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(806,53)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExtract, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(807,82)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(813,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(822,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0));
  requires {:id "id4561"} Lit(true);
  requires {:id "id4562"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4563"} Lit(true);
  free ensures {:id "id4564"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4565"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4566"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4567"} Lit(true);
  requires {:id "id4568"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4569"} Lit(true);
  free ensures {:id "id4570"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4571"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpandEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4572"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(825,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpand(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpand(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(826,52)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.HkdfExpand, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(827,80)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(833,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(842,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0));
  requires {:id "id4611"} Lit(true);
  requires {:id "id4612"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4613"} Lit(true);
  free ensures {:id "id4614"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4615"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4616"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4617"} Lit(true);
  requires {:id "id4618"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4619"} Lit(true);
  free ensures {:id "id4620"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4621"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4622"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(845,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Hkdf(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Hkdf(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(846,46)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.Hkdf, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(847,68)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(853,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(862,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0));
  requires {:id "id4661"} Lit(true);
  requires {:id "id4662"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4663"} Lit(true);
  free ensures {:id "id4664"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4665"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4666"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4667"} Lit(true);
  requires {:id "id4668"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4669"} Lit(true);
  free ensures {:id "id4670"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4671"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterModeEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4672"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(865,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterMode(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterMode(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(866,56)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.KdfCounterMode, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(867,88)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(873,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(882,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0));
  requires {:id "id4711"} Lit(true);
  requires {:id "id4712"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4713"} Lit(true);
  free ensures {:id "id4714"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4715"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4716"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4717"} Lit(true);
  requires {:id "id4718"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4719"} Lit(true);
  free ensures {:id "id4720"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4721"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterModeEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4722"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(885,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterMode(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterMode(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(886,59)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AesKdfCounterMode, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(887,94)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(893,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(902,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0));
  requires {:id "id4761"} Lit(true);
  requires {:id "id4762"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4763"} Lit(true);
  free ensures {:id "id4764"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4765"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4766"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4767"} Lit(true);
  requires {:id "id4768"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4769"} Lit(true);
  free ensures {:id "id4770"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4771"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4772"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(905,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncrypt(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncrypt(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(906,52)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESEncrypt, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(907,80)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(913,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(922,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0));
  requires {:id "id4811"} Lit(true);
  requires {:id "id4812"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4813"} Lit(true);
  free ensures {:id "id4814"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4815"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4816"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4817"} Lit(true);
  requires {:id "id4818"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4819"} Lit(true);
  free ensures {:id "id4820"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4821"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4822"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(925,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecrypt(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecrypt(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(926,52)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.AESDecrypt, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(927,80)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(933,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(942,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0));
  requires {:id "id4861"} Lit(true);
  requires {:id "id4862"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4863"} Lit(true);
  free ensures {:id "id4864"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4865"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4866"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4867"} Lit(true);
  requires {:id "id4868"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4869"} Lit(true);
  free ensures {:id "id4870"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4871"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPairEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4872"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(945,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPair(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPair(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(946,60)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateRSAKeyPair, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(947,96)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this: ref, input#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> $Is(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), input#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) == AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), input#0));
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, Lit(input#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, Lit(input#0)) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), Lit(input#0)) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, Lit(input#0)) == AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this), Lit(input#0)));
axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(Lit(this), Lit(input#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(Lit(this), Lit(input#0)) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength#canCall(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(Lit(this)), Lit(input#0)) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(Lit(this), Lit(input#0)) == AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetRSAKeyModulusLength(AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(Lit(this)), Lit(input#0)));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(this: ref, input#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#requires(ref, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#requires(this, input#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#requires(this, input#0) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) == AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0);
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) == output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(962,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(971,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0));
  requires {:id "id4915"} Lit(true);
  requires {:id "id4916"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4917"} Lit(true);
  free ensures {:id "id4918"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4919"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4920"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4921"} Lit(true);
  requires {:id "id4922"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4923"} Lit(true);
  free ensures {:id "id4924"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4925"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4926"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(974,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecrypt(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecrypt(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(975,52)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSADecrypt, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(976,80)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(982,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(991,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0));
  requires {:id "id4965"} Lit(true);
  requires {:id "id4966"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4967"} Lit(true);
  free ensures {:id "id4968"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4969"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4970"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id4971"} Lit(true);
  requires {:id "id4972"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id4973"} Lit(true);
  free ensures {:id "id4974"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id4975"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncryptEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id4976"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(994,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncrypt(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncrypt(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(995,52)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.RSAEncrypt, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(996,80)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1002,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1011,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0));
  requires {:id "id5015"} Lit(true);
  requires {:id "id5016"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5017"} Lit(true);
  free ensures {:id "id5018"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5019"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5020"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5021"} Lit(true);
  requires {:id "id5022"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5023"} Lit(true);
  free ensures {:id "id5024"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5025"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5026"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1014,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKey(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKey(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1015,67)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECDSASignatureKey, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1016,110)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1022,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1031,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0));
  requires {:id "id5065"} Lit(true);
  requires {:id "id5066"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5067"} Lit(true);
  free ensures {:id "id5068"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5069"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5070"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5071"} Lit(true);
  requires {:id "id5072"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5073"} Lit(true);
  free ensures {:id "id5074"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5075"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASignEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5076"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1034,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASign(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASign(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1035,51)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSASign, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1036,78)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1042,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1051,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0));
  requires {:id "id5115"} Lit(true);
  requires {:id "id5116"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5117"} Lit(true);
  free ensures {:id "id5118"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5119"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5120"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5121"} Lit(true);
  requires {:id "id5122"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5123"} Lit(true);
  free ensures {:id "id5124"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5125"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerifyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5126"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1054,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerify(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerify(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1055,53)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ECDSAVerify, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1056,82)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1062,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1071,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0));
  requires {:id "id5165"} Lit(true);
  requires {:id "id5166"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5167"} Lit(true);
  free ensures {:id "id5168"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5169"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5170"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5171"} Lit(true);
  requires {:id "id5172"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5173"} Lit(true);
  free ensures {:id "id5174"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5175"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPairEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5176"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1074,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPair(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPair(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1075,60)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GenerateECCKeyPair, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1076,96)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1082,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1091,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0));
  requires {:id "id5215"} Lit(true);
  requires {:id "id5216"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5217"} Lit(true);
  free ensures {:id "id5218"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5219"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5220"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5221"} Lit(true);
  requires {:id "id5222"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5223"} Lit(true);
  free ensures {:id "id5224"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5225"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5226"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1094,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKey(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKey(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1095,68)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.GetPublicKeyFromPrivateKey, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1096,112)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1102,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1111,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0));
  requires {:id "id5265"} Lit(true);
  requires {:id "id5266"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5267"} Lit(true);
  free ensures {:id "id5268"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5269"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5270"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5271"} Lit(true);
  requires {:id "id5272"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5273"} Lit(true);
  free ensures {:id "id5274"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5275"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5276"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1114,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKey(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKey(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1115,59)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ValidatePublicKey, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1116,94)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1122,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1131,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0));
  requires {:id "id5315"} Lit(true);
  requires {:id "id5316"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5317"} Lit(true);
  free ensures {:id "id5318"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5319"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5320"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5321"} Lit(true);
  requires {:id "id5322"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5323"} Lit(true);
  free ensures {:id "id5324"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5325"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecretEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5326"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1134,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecret(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecret(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1135,60)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DeriveSharedSecret, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1136,96)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1142,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1151,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0));
  requires {:id "id5365"} Lit(true);
  requires {:id "id5366"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5367"} Lit(true);
  free ensures {:id "id5368"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5369"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5370"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5371"} Lit(true);
  requires {:id "id5372"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5373"} Lit(true);
  free ensures {:id "id5374"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5375"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5376"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1154,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKey(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKey(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1155,59)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.CompressPublicKey, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1156,94)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1162,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1171,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0));
  requires {:id "id5415"} Lit(true);
  requires {:id "id5416"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5417"} Lit(true);
  free ensures {:id "id5418"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5419"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5420"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5421"} Lit(true);
  requires {:id "id5422"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5423"} Lit(true);
  free ensures {:id "id5424"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5425"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5426"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1174,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKey(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKey(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1175,61)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.DecompressPublicKey, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1176,98)"} true;
    assume defass#output#0;
    return;
}



function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#canCall(input#0, output#0) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(input#0, output#0)));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: {:weight 3} { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(Lit(this), Lit(input#0), Lit(output#0)) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()))) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#canCall(Lit(input#0), Lit(output#0)) && (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(Lit(this), Lit(input#0), Lit(output#0)) <==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(Lit(input#0), Lit(output#0))));
}

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this: ref, input#0: DatatypeType, output#0: DatatypeType) : bool;

function AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#requires(ref, DatatypeType, DatatypeType) : bool;

axiom (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#requires(this, input#0, output#0) } this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) ==> (AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#requires(this, input#0, output#0) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall this: ref, input#0: DatatypeType, output#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0), $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0), AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) } AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient())) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) <==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0)));

procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly (well-formedness)"} CheckWellformed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()), output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this: ref, input#0: DatatypeType, output#0: DatatypeType)
{
  var AtomicPrimitivesClient_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly", " | ", this, " | ", input#0, " | ", output#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume DtRank(input#0) <= DtRank(input#0) && (DtRank(input#0) == DtRank(input#0) ==> DtRank(output#0) <= DtRank(output#0));
    AtomicPrimitivesClient_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume (forall $o: ref, $f: Field :: true);
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##input#0: DatatypeType;
  var ##output#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1182,11): initial state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    havoc output#0;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1191,8): post-state"} true;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume $IsAllocBox($Box(this), Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $Heap);
    ##input#0 := input#0;
    assume $IsAlloc(##input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap);
    ##output#0 := output#0;
    assume $IsAlloc(##output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0);
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), old($Heap));
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory(), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (override check)"} OverrideCheck$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume Set#Subset(Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))), Set#Difference(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this), Set#UnionOne(Set#Empty(): Set, $Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)))));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ((AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)) ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
    assume $HeapSucc(old($Heap), $Heap);
    assume true && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    assume Lit(true);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
    assume AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(input#0, output#0);
    assume Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
    return;
}



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0));
  requires {:id "id5465"} Lit(true);
  requires {:id "id5466"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5467"} Lit(true);
  free ensures {:id "id5468"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5469"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5470"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref where this != null && $Is(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) && $IsAlloc(this, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5471"} Lit(true);
  requires {:id "id5472"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState#canCall(this);
  free ensures {:id "id5473"} Lit(true);
  free ensures {:id "id5474"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidState(this);
  free ensures AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0);
  free ensures {:id "id5475"} AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly#canCall(this, input#0, output#0) ==> AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKeyEnsuresPublicly(this, input#0, output#0) || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures true;
  free ensures {:id "id5476"} Seq#Equal($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Append($Unbox(read(old($Heap), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || $o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (correctness)"} Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref, input#0: DatatypeType) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var config##0: Box;
  var input##0: DatatypeType;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box($o)] && $o != AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this)) || ($o == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) && $f == AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey));
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1194,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    config##0 := AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.config(this);
    assume true;
    input##0 := input#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config##0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKey(config##0, input##0);
    call $rhs##0 := CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKey(config##0, input##0);
    output#0 := $rhs##0;
    defass#output#0 := true;
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1195,56)"} true;
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume true;
    assume $_ModifiesFrame[AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey];
    assume AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this) != null;
    assume defass#output#0;
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(#AwsCryptographyPrimitivesTypes.DafnyCallEvent.DafnyCallEvent($Box(input#0), $Box(output#0)))));
    $Heap := update($Heap, AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this), AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClientCallHistory.ParsePublicKey, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "AwsCryptographyPrimitives/Model/AwsCryptographyPrimitivesTypes.dfy(1196,88)"} true;
    assume defass#output#0;
    return;
}



axiom (forall c#0: ref :: { $Is(c#0, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) } $Is(c#0, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient()) <==> $Is(c#0, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $h) } $IsAlloc(c#0, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient(), $h) <==> $IsAlloc(c#0, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#44 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#44))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#46 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#46)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#66 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#66))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#68 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#68)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#70 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#70)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#66 := Wrappers.Option.value(this); v#66)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#68 := Lit(Wrappers.Option.value(Lit(this))); v#68)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#70 := Lit(Wrappers.Option.value(Lit(this))); v#70)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#44 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#44)) else (var e#44 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#46 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#46))) else (var e#46 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#66 := Wrappers.Result.value(this); s#66) else (var e#66 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#68 := Lit(Wrappers.Result.value(Lit(this))); s#68) else (var e#68 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#70 := Lit(Wrappers.Result.value(Lit(this))); s#70) else (var e#70 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#66 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#66)) else (var e#66 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#66)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#68 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#68))) else (var e#68 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#68)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#70 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#70))) else (var e#70 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#70)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#24 := Div(x#0, LitInt(256)); (var b1#24 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#24)), $Box(b1#24)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#25 := LitInt(Div(x#0, LitInt(256))); (var b1#25 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#25)), $Box(b1#25))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#24 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#24 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#25 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#25 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#24 := Div(x#0, LitInt(16777216)); (var x0#24 := x#0 - Mul(b0#24, LitInt(16777216)); (var b1#24 := Div(x0#24, LitInt(65536)); (var x1#24 := x0#24 - Mul(b1#24, LitInt(65536)); (var b2#24 := Div(x1#24, LitInt(256)); (var b3#24 := Mod(x1#24, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#24)), $Box(b1#24)), $Box(b2#24)), $Box(b3#24)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#25 := LitInt(Div(x#0, LitInt(16777216))); (var x0#25 := LitInt(x#0 - Mul(b0#25, LitInt(16777216))); (var b1#25 := LitInt(Div(x0#25, LitInt(65536))); (var x1#25 := LitInt(x0#25 - Mul(b1#25, LitInt(65536))); (var b2#25 := LitInt(Div(x1#25, LitInt(256))); (var b3#25 := LitInt(Mod(x1#25, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#25)), $Box(b1#25)), $Box(b2#25)), $Box(b3#25))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#24 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#24 := x0#24 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#24 := x1#24 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#24 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#25 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#25 := x0#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#25 := x1#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#25 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#24 := Div(x#0, LitInt(72057594037927936)); (var x0#24 := x#0 - Mul(b0#24, LitInt(72057594037927936)); (var b1#24 := Div(x0#24, LitInt(281474976710656)); (var x1#24 := x0#24 - Mul(b1#24, LitInt(281474976710656)); (var b2#24 := Div(x1#24, LitInt(1099511627776)); (var x2#24 := x1#24 - Mul(b2#24, LitInt(1099511627776)); (var b3#24 := Div(x2#24, LitInt(4294967296)); (var x3#24 := x2#24 - Mul(b3#24, LitInt(4294967296)); (var b4#24 := Div(x3#24, LitInt(16777216)); (var x4#24 := x3#24 - Mul(b4#24, LitInt(16777216)); (var b5#24 := Div(x4#24, LitInt(65536)); (var x5#24 := x4#24 - Mul(b5#24, LitInt(65536)); (var b6#24 := Div(x5#24, LitInt(256)); (var b7#24 := Mod(x5#24, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#24)), $Box(b1#24)), $Box(b2#24)), $Box(b3#24)), $Box(b4#24)), $Box(b5#24)), $Box(b6#24)), $Box(b7#24)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#25 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#25 := LitInt(x#0 - Mul(b0#25, LitInt(72057594037927936))); (var b1#25 := LitInt(Div(x0#25, LitInt(281474976710656))); (var x1#25 := LitInt(x0#25 - Mul(b1#25, LitInt(281474976710656))); (var b2#25 := LitInt(Div(x1#25, LitInt(1099511627776))); (var x2#25 := LitInt(x1#25 - Mul(b2#25, LitInt(1099511627776))); (var b3#25 := LitInt(Div(x2#25, LitInt(4294967296))); (var x3#25 := LitInt(x2#25 - Mul(b3#25, LitInt(4294967296))); (var b4#25 := LitInt(Div(x3#25, LitInt(16777216))); (var x4#25 := LitInt(x3#25 - Mul(b4#25, LitInt(16777216))); (var b5#25 := LitInt(Div(x4#25, LitInt(65536))); (var x5#25 := LitInt(x4#25 - Mul(b5#25, LitInt(65536))); (var b6#25 := LitInt(Div(x5#25, LitInt(256))); (var b7#25 := LitInt(Mod(x5#25, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#25)), $Box(b1#25)), $Box(b2#25)), $Box(b3#25)), $Box(b4#25)), $Box(b5#25)), $Box(b6#25)), $Box(b7#25))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#24 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#24 := x0#24 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#24 := x1#24 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#24 := x2#24 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#24 := x3#24 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#24 := x4#24 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#24 := x5#24 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#25 := x6#24 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#25)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#25 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#25 := x0#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#25 := x1#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#25 := x2#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#25 := x3#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#25 := x4#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#25 := x5#25 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#26 := x6#25 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#26)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#24 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#24)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#24 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#24)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#24)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#25 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#25)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#25 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#25)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#25)): int)));

axiom (forall s#0: Seq :: { UTF8.__default.IsASCIIString(s#0) } UTF8.__default.IsASCIIString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(s#0) <==> (forall i#18: int :: { $Unbox(Seq#Index(s#0, i#18)): char } LitInt(0) <= i#18 && i#18 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#18)): char) < 128)));

axiom (forall s#0: Seq :: {:weight 3} { UTF8.__default.IsASCIIString(Lit(s#0)) } UTF8.__default.IsASCIIString#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (UTF8.__default.IsASCIIString(Lit(s#0)) <==> (forall i#19: int :: { $Unbox(Seq#Index(s#0, i#19)): char } LitInt(0) <= i#19 && i#19 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#19)): char) < 128)));

axiom (forall $ly: LayerType, $reveal: bool, s#0: Seq :: { UTF8.__default.EncodeAscii($ly, $reveal, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> Seq#Length(s#0) == Seq#Length(UTF8.__default.EncodeAscii($ly, $reveal, s#0)) && (forall i#12: int :: { $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#12)): int } { $Unbox(Seq#Index(s#0, i#12)): char } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) == $Unbox(Seq#Index(UTF8.__default.EncodeAscii($ly, $reveal, s#0), i#12)): int) && $Is(UTF8.__default.EncodeAscii($ly, $reveal, s#0), Tclass.UTF8.ValidUTF8Bytes()));

axiom (forall $ly: LayerType, s#0: Seq :: { UTF8.__default.EncodeAscii($LS($ly), true, s#0) } UTF8.__default.EncodeAscii#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && UTF8.__default.IsASCIIString(s#0)) ==> (Seq#Length(s#0) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Seq#Drop(s#0, LitInt(1)))) && UTF8.__default.EncodeAscii($LS($ly), true, s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else (var x#16 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char))); Seq#Append(x#16, UTF8.__default.EncodeAscii($ly, reveal_UTF8._default.EncodeAscii, Seq#Drop(s#0, LitInt(1)))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) } UTF8.__default.EncodeAscii#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(UTF8.__default.IsASCIIString(Lit(s#0)))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> UTF8.__default.EncodeAscii#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && UTF8.__default.EncodeAscii($LS($ly), true, Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#17 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))); Seq#Append(x#17, UTF8.__default.EncodeAscii($LS($ly), reveal_UTF8._default.EncodeAscii, Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: { UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) } UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0, hi#0) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && lo#0 <= hi#0 && hi#0 <= Seq#Length(a#0)) ==> (lo#0 != hi#0 ==> (var r#24 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); UTF8.__default.Uses1Byte#canCall(r#24) && (UTF8.__default.Uses1Byte(r#24) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 1, hi#0)) && (!UTF8.__default.Uses1Byte(r#24) ==> (LitInt(2) <= Seq#Length(r#24) ==> UTF8.__default.Uses2Bytes#canCall(r#24)) && (LitInt(2) <= Seq#Length(r#24) && UTF8.__default.Uses2Bytes(r#24) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 2, hi#0)) && (!(LitInt(2) <= Seq#Length(r#24) && UTF8.__default.Uses2Bytes(r#24)) ==> (LitInt(3) <= Seq#Length(r#24) ==> UTF8.__default.Uses3Bytes#canCall(r#24)) && (LitInt(3) <= Seq#Length(r#24) && UTF8.__default.Uses3Bytes(r#24) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 3, hi#0)) && (!(LitInt(3) <= Seq#Length(r#24) && UTF8.__default.Uses3Bytes(r#24)) ==> (LitInt(4) <= Seq#Length(r#24) ==> UTF8.__default.Uses4Bytes#canCall(r#24)) && (LitInt(4) <= Seq#Length(r#24) && UTF8.__default.Uses4Bytes(r#24) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, lo#0 + 4, hi#0))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, lo#0, hi#0) <==> (if lo#0 == hi#0 then true else (var r#24 := Seq#Drop(Seq#Take(a#0, hi#0), lo#0); (if UTF8.__default.Uses1Byte(r#24) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 1, hi#0) else (if LitInt(2) <= Seq#Length(r#24) && UTF8.__default.Uses2Bytes(r#24) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 2, hi#0) else (if LitInt(3) <= Seq#Length(r#24) && UTF8.__default.Uses3Bytes(r#24) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 3, hi#0) else (if LitInt(4) <= Seq#Length(r#24) && UTF8.__default.Uses4Bytes(r#24) then UTF8.__default.ValidUTF8Range($ly, a#0, lo#0 + 4, hi#0) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(a#0)) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#25 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); UTF8.__default.Uses1Byte#canCall(r#25) && (UTF8.__default.Uses1Byte(r#25) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#25) ==> (LitInt(2) <= Seq#Length(r#25) ==> UTF8.__default.Uses2Bytes#canCall(r#25)) && (LitInt(2) <= Seq#Length(r#25) && UTF8.__default.Uses2Bytes(r#25) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#25) && UTF8.__default.Uses2Bytes(r#25)) ==> (LitInt(3) <= Seq#Length(r#25) ==> UTF8.__default.Uses3Bytes#canCall(r#25)) && (LitInt(3) <= Seq#Length(r#25) && UTF8.__default.Uses3Bytes(r#25) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#25) && UTF8.__default.Uses3Bytes(r#25)) ==> (LitInt(4) <= Seq#Length(r#25) ==> UTF8.__default.Uses4Bytes#canCall(r#25)) && (LitInt(4) <= Seq#Length(r#25) && UTF8.__default.Uses4Bytes(r#25) ==> UTF8.__default.ValidUTF8Range#canCall(a#0, LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#25 := Seq#Drop(Seq#Take(a#0, LitInt(hi#0)), LitInt(lo#0)); (if UTF8.__default.Uses1Byte(r#25) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#25) && UTF8.__default.Uses2Bytes(r#25) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#25) && UTF8.__default.Uses3Bytes(r#25) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#25) && UTF8.__default.Uses4Bytes(r#25) then UTF8.__default.ValidUTF8Range($LS($ly), a#0, LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall $ly: LayerType, a#0: Seq, lo#0: int, hi#0: int :: {:weight 3} { UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) } UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0), LitInt(hi#0)) || ($Is(a#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= lo#0 && LitInt(0) <= hi#0 && LitInt(lo#0) <= LitInt(hi#0) && LitInt(hi#0) <= Seq#Length(Lit(a#0))) ==> (LitInt(lo#0) != LitInt(hi#0) ==> (var r#26 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); UTF8.__default.Uses1Byte#canCall(r#26) && (UTF8.__default.Uses1Byte(r#26) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0))) && (!UTF8.__default.Uses1Byte(r#26) ==> (LitInt(2) <= Seq#Length(r#26) ==> UTF8.__default.Uses2Bytes#canCall(r#26)) && (LitInt(2) <= Seq#Length(r#26) && UTF8.__default.Uses2Bytes(r#26) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0))) && (!(LitInt(2) <= Seq#Length(r#26) && UTF8.__default.Uses2Bytes(r#26)) ==> (LitInt(3) <= Seq#Length(r#26) ==> UTF8.__default.Uses3Bytes#canCall(r#26)) && (LitInt(3) <= Seq#Length(r#26) && UTF8.__default.Uses3Bytes(r#26) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0))) && (!(LitInt(3) <= Seq#Length(r#26) && UTF8.__default.Uses3Bytes(r#26)) ==> (LitInt(4) <= Seq#Length(r#26) ==> UTF8.__default.Uses4Bytes#canCall(r#26)) && (LitInt(4) <= Seq#Length(r#26) && UTF8.__default.Uses4Bytes(r#26) ==> UTF8.__default.ValidUTF8Range#canCall(Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)))))))) && (UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0), LitInt(hi#0)) <==> (if LitInt(lo#0) == LitInt(hi#0) then true else (var r#26 := Lit(Seq#Drop(Seq#Take(Lit(a#0), LitInt(hi#0)), LitInt(lo#0))); (if UTF8.__default.Uses1Byte(r#26) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 1), LitInt(hi#0)) else (if LitInt(2) <= Seq#Length(r#26) && UTF8.__default.Uses2Bytes(r#26) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 2), LitInt(hi#0)) else (if LitInt(3) <= Seq#Length(r#26) && UTF8.__default.Uses3Bytes(r#26) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 3), LitInt(hi#0)) else (if LitInt(4) <= Seq#Length(r#26) && UTF8.__default.Uses4Bytes(r#26) then UTF8.__default.ValidUTF8Range($LS($ly), Lit(a#0), LitInt(lo#0 + 4), LitInt(hi#0)) else false))))))));

axiom (forall this: ref :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState#canCall(this) || (2 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient())) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.ValidState(this) ==> AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.Modifies(this)[$Box(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.History(this))]);

axiom (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this, input#0) || (2 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput())) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac#canCall(this, input#0) || (2 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HMacInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.HMac(this, input#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

axiom (forall this: ref, input#0: DatatypeType :: { AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0) } AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (2 < $FunctionContextHeight && this != null && $Is(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput())) ==> $Is(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())));

axiom (forall $Heap: Heap, this: ref, input#0: DatatypeType :: { $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap) } (AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength#canCall(this, input#0) || (2 < $FunctionContextHeight && this != null && $IsAlloc(this, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $Heap) && $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthInput(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient.GetRSAKeyModulusLength(this, input#0), Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetRSAKeyModulusLengthOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));

procedure {:verboseName "GenerateRandomBytes (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytes(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GenerateRandomBytes (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytes(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0));
  requires {:id "id5488"} Lit(true);
  requires {:id "id5489"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "GenerateRandomBytes (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytes(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRandomBytesInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5490"} Lit(true);
  free ensures {:id "id5491"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5492"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRandomBytesEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Digest (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Digest(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Digest (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Digest(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0));
  requires {:id "id5493"} Lit(true);
  requires {:id "id5494"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "Digest (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Digest(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DigestInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DigestInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5495"} Lit(true);
  free ensures {:id "id5496"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5497"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DigestEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "HkdfExtract (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtract(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "HkdfExtract (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtract(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0));
  requires {:id "id5498"} Lit(true);
  requires {:id "id5499"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "HkdfExtract (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtract(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExtractInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExtractInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5500"} Lit(true);
  free ensures {:id "id5501"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5502"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExtractEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "HkdfExpand (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpand(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "HkdfExpand (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpand(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0));
  requires {:id "id5503"} Lit(true);
  requires {:id "id5504"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "HkdfExpand (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpand(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfExpandInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfExpandInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5505"} Lit(true);
  free ensures {:id "id5506"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5507"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfExpandEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Hkdf (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Hkdf(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Hkdf (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Hkdf(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0));
  requires {:id "id5508"} Lit(true);
  requires {:id "id5509"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "Hkdf (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.Hkdf(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.HkdfInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.HkdfInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5510"} Lit(true);
  free ensures {:id "id5511"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5512"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.HkdfEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "KdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "KdfCounterMode (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0));
  requires {:id "id5513"} Lit(true);
  requires {:id "id5514"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "KdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.KdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.KdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5515"} Lit(true);
  free ensures {:id "id5516"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5517"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.KdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AesKdfCounterMode (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AesKdfCounterMode (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0));
  requires {:id "id5518"} Lit(true);
  requires {:id "id5519"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AesKdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterMode(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AesKdfCtrInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AesKdfCtrInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5520"} Lit(true);
  free ensures {:id "id5521"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5522"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AesKdfCounterModeEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AESEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AESEncrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0));
  requires {:id "id5523"} Lit(true);
  requires {:id "id5524"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AESEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.AESEncryptOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5525"} Lit(true);
  free ensures {:id "id5526"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5527"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESEncryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "AESDecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "AESDecrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0));
  requires {:id "id5528"} Lit(true);
  requires {:id "id5529"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "AESDecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.AESDecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.AESDecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5530"} Lit(true);
  free ensures {:id "id5531"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5532"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.AESDecryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "GenerateRSAKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GenerateRSAKeyPair (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0));
  requires {:id "id5533"} Lit(true);
  requires {:id "id5534"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "GenerateRSAKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateRSAKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5535"} Lit(true);
  free ensures {:id "id5536"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5537"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateRSAKeyPairEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "RSADecrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "RSADecrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0));
  requires {:id "id5538"} Lit(true);
  requires {:id "id5539"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "RSADecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSADecryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSADecryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5540"} Lit(true);
  free ensures {:id "id5541"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5542"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSADecryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "RSAEncrypt (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "RSAEncrypt (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0));
  requires {:id "id5543"} Lit(true);
  requires {:id "id5544"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "RSAEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncrypt(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.RSAEncryptInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.RSAEncryptInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5545"} Lit(true);
  free ensures {:id "id5546"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5547"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.RSAEncryptEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "GenerateECDSASignatureKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GenerateECDSASignatureKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0));
  requires {:id "id5548"} Lit(true);
  requires {:id "id5549"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "GenerateECDSASignatureKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECDSASignatureKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5550"} Lit(true);
  free ensures {:id "id5551"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5552"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECDSASignatureKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "ECDSASign (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASign(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ECDSASign (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASign(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0));
  requires {:id "id5553"} Lit(true);
  requires {:id "id5554"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "ECDSASign (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASign(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSASignInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSASignInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5555"} Lit(true);
  free ensures {:id "id5556"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5557"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSASignEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "ECDSAVerify (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerify(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ECDSAVerify (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerify(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0));
  requires {:id "id5558"} Lit(true);
  requires {:id "id5559"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "ECDSAVerify (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerify(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ECDSAVerifyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5560"} Lit(true);
  free ensures {:id "id5561"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5562"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ECDSAVerifyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "GenerateECCKeyPair (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GenerateECCKeyPair (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0));
  requires {:id "id5563"} Lit(true);
  requires {:id "id5564"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "GenerateECCKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPair(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GenerateECCKeyPairInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GenerateECCKeyPairOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5565"} Lit(true);
  free ensures {:id "id5566"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5567"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GenerateECCKeyPairEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "GetPublicKeyFromPrivateKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GetPublicKeyFromPrivateKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0));
  requires {:id "id5568"} Lit(true);
  requires {:id "id5569"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "GetPublicKeyFromPrivateKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.GetPublicKeyFromPrivateKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5570"} Lit(true);
  free ensures {:id "id5571"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5572"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.GetPublicKeyFromPrivateKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "ValidatePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ValidatePublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0));
  requires {:id "id5573"} Lit(true);
  requires {:id "id5574"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "ValidatePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ValidatePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ValidatePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5575"} Lit(true);
  free ensures {:id "id5576"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5577"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidatePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "DeriveSharedSecret (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecret(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DeriveSharedSecret (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecret(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0));
  requires {:id "id5578"} Lit(true);
  requires {:id "id5579"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "DeriveSharedSecret (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecret(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DeriveSharedSecretInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DeriveSharedSecretOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5580"} Lit(true);
  free ensures {:id "id5581"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5582"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DeriveSharedSecretEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "CompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "CompressPublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0));
  requires {:id "id5583"} Lit(true);
  requires {:id "id5584"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "CompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.CompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.CompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5585"} Lit(true);
  free ensures {:id "id5586"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5587"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.CompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "DecompressPublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DecompressPublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0));
  requires {:id "id5588"} Lit(true);
  requires {:id "id5589"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "DecompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.DecompressPublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.DecompressPublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5590"} Lit(true);
  free ensures {:id "id5591"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5592"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.DecompressPublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "ParsePublicKey (well-formedness)"} CheckWellFormed$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ParsePublicKey (call precondtion)"} CallPre$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0));
  requires {:id "id5593"} Lit(true);
  requires {:id "id5594"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);



procedure {:verboseName "ParsePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKey(config#0: Box where $IsBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig()) && $IsAllocBox(config#0, Tclass.AbstractAwsCryptographyPrimitivesService.Operations.Abs.InternalConfig(), $Heap), input#0: DatatypeType where $Is(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput()) && $IsAlloc(input#0, Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(), $Heap) && $IsA#AwsCryptographyPrimitivesTypes.ParsePublicKeyInput(input#0)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error())) && $IsAlloc(output#0, Tclass.Wrappers.Result(Tclass.AwsCryptographyPrimitivesTypes.ParsePublicKeyOutput(), Tclass.AwsCryptographyPrimitivesTypes.Error()), $Heap));
  modifies $Heap;
  free ensures Lit(true) ==> AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q#canCall(config#0);
  free ensures {:id "id5595"} Lit(true);
  free ensures {:id "id5596"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ValidInternalConfig_q(config#0);
  free ensures AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly#canCall(input#0, output#0);
  free ensures {:id "id5597"} AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ParsePublicKeyEnsuresPublicly(input#0, output#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || AbstractAwsCryptographyPrimitivesService.Operations.Abs.__default.ModifiesInternalConfig(config#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall $o: ref :: { $Is($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) } $o != null && $Is($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?()) ==> $Is($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient()));

axiom (forall $o: ref, $heap: Heap :: { $IsAlloc($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $heap) } $o != null && $IsAlloc($o, Tclass.AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient?(), $heap) ==> $IsAlloc($o, Tclass.AwsCryptographyPrimitivesTypes.IAwsCryptographicPrimitivesClient(), $heap));

const unique tytagFamily$AtomicPrimitivesClient: TyTagFamily;

const unique class.Relations.__default: ClassName;

function Relations.__default.Reflexive(Relations._default.Reflexive$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#0: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#0, x#0)): bool } $IsBox(x#0, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#1: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#1, x#1)): bool } $IsBox(x#1, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#1, x#1)): bool)));
}

function Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T: Ty, R#0: HandleType) : bool;

function Relations.__default.Reflexive#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive#requires(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool)) ==> (Relations.__default.Reflexive#requires(Relations._default.Reflexive$T, R#0) <==> true));

procedure {:verboseName "Relations.Reflexive (well-formedness)"} CheckWellformed$$Relations.__default.Reflexive(Relations._default.Reflexive$T: Ty where $AlwaysAllocated(Relations._default.Reflexive$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.Irreflexive(Relations._default.Irreflexive$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#0: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#0, x#0)): bool } $IsBox(x#0, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#1: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#1, x#1)): bool } $IsBox(x#1, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#1, x#1)): bool)));
}

function Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T: Ty, R#0: HandleType) : bool;

function Relations.__default.Irreflexive#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive#requires(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool)) ==> (Relations.__default.Irreflexive#requires(Relations._default.Irreflexive$T, R#0) <==> true));

procedure {:verboseName "Relations.Irreflexive (well-formedness)"} CheckWellformed$$Relations.__default.Irreflexive(Relations._default.Irreflexive$T: Ty where $AlwaysAllocated(Relations._default.Irreflexive$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#0, x#0)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Relations._default.AntiSymmetric$T) && $IsBox(y#0, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#0, y#0)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#0, x#0)): bool ==> x#0 == y#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#1, x#1)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Relations._default.AntiSymmetric$T) && $IsBox(y#1, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#1, x#1)): bool ==> x#1 == y#1)));
}

function Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T: Ty, R#0: HandleType) : bool;

function Relations.__default.AntiSymmetric#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric#requires(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool)) ==> (Relations.__default.AntiSymmetric#requires(Relations._default.AntiSymmetric$T, R#0) <==> true));

procedure {:verboseName "Relations.AntiSymmetric (well-formedness)"} CheckWellformed$$Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T: Ty where $AlwaysAllocated(Relations._default.AntiSymmetric$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.Symmetric(Relations._default.Symmetric$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#0, x#0)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Relations._default.Symmetric$T) && $IsBox(y#0, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#0, y#0)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#0, x#0)): bool))));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#1, x#1)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Relations._default.Symmetric$T) && $IsBox(y#1, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#1, x#1)): bool))));
}

function Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T: Ty, R#0: HandleType) : bool;

function Relations.__default.Symmetric#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric#requires(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool)) ==> (Relations.__default.Symmetric#requires(Relations._default.Symmetric$T, R#0) <==> true));

procedure {:verboseName "Relations.Symmetric (well-formedness)"} CheckWellformed$$Relations.__default.Symmetric(Relations._default.Symmetric$T: Ty where $AlwaysAllocated(Relations._default.Symmetric$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.Connected(Relations._default.Connected$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#0, x#0)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Relations._default.Connected$T) && $IsBox(y#0, Relations._default.Connected$T) ==> x#0 != y#0 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#0, y#0)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#1, x#1)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Relations._default.Connected$T) && $IsBox(y#1, Relations._default.Connected$T) ==> x#1 != y#1 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#1, x#1)): bool)));
}

function Relations.__default.Connected#canCall(Relations._default.Connected$T: Ty, R#0: HandleType) : bool;

function Relations.__default.Connected#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected#requires(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool)) ==> (Relations.__default.Connected#requires(Relations._default.Connected$T, R#0) <==> true));

procedure {:verboseName "Relations.Connected (well-formedness)"} CheckWellformed$$Relations.__default.Connected(Relations._default.Connected$T: Ty where $AlwaysAllocated(Relations._default.Connected$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#0, x#0)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Relations._default.StronglyConnected$T) && $IsBox(y#0, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#0, y#0)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#1, x#1)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Relations._default.StronglyConnected$T) && $IsBox(y#1, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#1, x#1)): bool)));
}

function Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T: Ty, R#0: HandleType) : bool;

function Relations.__default.StronglyConnected#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected#requires(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool)) ==> (Relations.__default.StronglyConnected#requires(Relations._default.StronglyConnected$T, R#0) <==> true));

procedure {:verboseName "Relations.StronglyConnected (well-formedness)"} CheckWellformed$$Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T: Ty where $AlwaysAllocated(Relations._default.StronglyConnected$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.Transitive(Relations._default.Transitive$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#0: Box, y#0: Box, z#0: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#0, z#0)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#0, z#0)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#0, z#0)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Relations._default.Transitive$T) && $IsBox(y#0, Relations._default.Transitive$T) && $IsBox(z#0, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#0, y#0)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#0, z#0)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#0, z#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box, z#1: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#1, z#1)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#1, z#1)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#1, z#1)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Relations._default.Transitive$T) && $IsBox(y#1, Relations._default.Transitive$T) && $IsBox(z#1, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#1, z#1)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#1, z#1)): bool)));
}

function Relations.__default.Transitive#canCall(Relations._default.Transitive$T: Ty, R#0: HandleType) : bool;

function Relations.__default.Transitive#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive#requires(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool)) ==> (Relations.__default.Transitive#requires(Relations._default.Transitive$T, R#0) <==> true));

procedure {:verboseName "Relations.Transitive (well-formedness)"} CheckWellformed$$Relations.__default.Transitive(Relations._default.Transitive$T: Ty where $AlwaysAllocated(Relations._default.Transitive$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T: Ty, R#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.TotalOrdering$T: Ty, R#0: HandleType :: { Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, R#0) } Relations.__default.TotalOrdering#canCall(Relations._default.TotalOrdering$T, R#0) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.TotalOrdering$T, Relations._default.TotalOrdering$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.TotalOrdering$T, R#0) && (Relations.__default.Reflexive(Relations._default.TotalOrdering$T, R#0) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.TotalOrdering$T, R#0) && (Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.TotalOrdering$T, R#0) && (Relations.__default.Transitive(Relations._default.TotalOrdering$T, R#0) ==> Relations.__default.StronglyConnected#canCall(Relations._default.TotalOrdering$T, R#0)))) && (Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, R#0) <==> Relations.__default.Reflexive(Relations._default.TotalOrdering$T, R#0) && Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.TotalOrdering$T, R#0) && Relations.__default.StronglyConnected(Relations._default.TotalOrdering$T, R#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.TotalOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, Lit(R#0)) } Relations.__default.TotalOrdering#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.TotalOrdering$T, Relations._default.TotalOrdering$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.TotalOrdering$T, Lit(R#0))) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Transitive(Relations._default.TotalOrdering$T, Lit(R#0))) ==> Relations.__default.StronglyConnected#canCall(Relations._default.TotalOrdering$T, Lit(R#0))))) && (Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.TotalOrdering$T, Lit(R#0)) && Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.TotalOrdering$T, Lit(R#0)) && Relations.__default.StronglyConnected(Relations._default.TotalOrdering$T, Lit(R#0)))));
}

function Relations.__default.TotalOrdering#canCall(Relations._default.TotalOrdering$T: Ty, R#0: HandleType) : bool;

function Relations.__default.TotalOrdering#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.TotalOrdering$T: Ty, R#0: HandleType :: { Relations.__default.TotalOrdering#requires(Relations._default.TotalOrdering$T, R#0) } $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.TotalOrdering$T, Relations._default.TotalOrdering$T, TBool)) ==> (Relations.__default.TotalOrdering#requires(Relations._default.TotalOrdering$T, R#0) <==> true));

procedure {:verboseName "Relations.TotalOrdering (well-formedness)"} CheckWellformed$$Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T: Ty where $AlwaysAllocated(Relations._default.TotalOrdering$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.TotalOrdering$T, Relations._default.TotalOrdering$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType :: { Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, R#0) } Relations.__default.StrictTotalOrdering#canCall(Relations._default.StrictTotalOrdering$T, R#0) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StrictTotalOrdering$T, Relations._default.StrictTotalOrdering$T, TBool))) ==> Relations.__default.Irreflexive#canCall(Relations._default.StrictTotalOrdering$T, R#0) && (Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, R#0) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.StrictTotalOrdering$T, R#0) && (Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.StrictTotalOrdering$T, R#0) && (Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, R#0) ==> Relations.__default.Connected#canCall(Relations._default.StrictTotalOrdering$T, R#0)))) && (Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, R#0) <==> Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, R#0) && Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, R#0) && Relations.__default.Connected(Relations._default.StrictTotalOrdering$T, R#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, Lit(R#0)) } Relations.__default.StrictTotalOrdering#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StrictTotalOrdering$T, Relations._default.StrictTotalOrdering$T, TBool))) ==> Relations.__default.Irreflexive#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, Lit(R#0))) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, Lit(R#0))) ==> Relations.__default.Connected#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0))))) && (Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && Relations.__default.Connected(Relations._default.StrictTotalOrdering$T, Lit(R#0)))));
}

function Relations.__default.StrictTotalOrdering#canCall(Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType) : bool;

function Relations.__default.StrictTotalOrdering#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType :: { Relations.__default.StrictTotalOrdering#requires(Relations._default.StrictTotalOrdering$T, R#0) } $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StrictTotalOrdering$T, Relations._default.StrictTotalOrdering$T, TBool)) ==> (Relations.__default.StrictTotalOrdering#requires(Relations._default.StrictTotalOrdering$T, R#0) <==> true));

procedure {:verboseName "Relations.StrictTotalOrdering (well-formedness)"} CheckWellformed$$Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T: Ty where $AlwaysAllocated(Relations._default.StrictTotalOrdering$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StrictTotalOrdering$T, Relations._default.StrictTotalOrdering$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.PreOrdering(Relations._default.PreOrdering$T: Ty, R#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.PreOrdering$T: Ty, R#0: HandleType :: { Relations.__default.PreOrdering(Relations._default.PreOrdering$T, R#0) } Relations.__default.PreOrdering#canCall(Relations._default.PreOrdering$T, R#0) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PreOrdering$T, Relations._default.PreOrdering$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.PreOrdering$T, R#0) && (Relations.__default.Reflexive(Relations._default.PreOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.PreOrdering$T, R#0)) && (Relations.__default.PreOrdering(Relations._default.PreOrdering$T, R#0) <==> Relations.__default.Reflexive(Relations._default.PreOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.PreOrdering$T, R#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.PreOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.PreOrdering(Relations._default.PreOrdering$T, Lit(R#0)) } Relations.__default.PreOrdering#canCall(Relations._default.PreOrdering$T, Lit(R#0)) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PreOrdering$T, Relations._default.PreOrdering$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.PreOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.PreOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.PreOrdering$T, Lit(R#0))) && (Relations.__default.PreOrdering(Relations._default.PreOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.PreOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.PreOrdering$T, Lit(R#0)))));
}

function Relations.__default.PreOrdering#canCall(Relations._default.PreOrdering$T: Ty, R#0: HandleType) : bool;

function Relations.__default.PreOrdering#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.PreOrdering$T: Ty, R#0: HandleType :: { Relations.__default.PreOrdering#requires(Relations._default.PreOrdering$T, R#0) } $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PreOrdering$T, Relations._default.PreOrdering$T, TBool)) ==> (Relations.__default.PreOrdering#requires(Relations._default.PreOrdering$T, R#0) <==> true));

procedure {:verboseName "Relations.PreOrdering (well-formedness)"} CheckWellformed$$Relations.__default.PreOrdering(Relations._default.PreOrdering$T: Ty where $AlwaysAllocated(Relations._default.PreOrdering$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PreOrdering$T, Relations._default.PreOrdering$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T: Ty, R#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.PartialOrdering$T: Ty, R#0: HandleType :: { Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, R#0) } Relations.__default.PartialOrdering#canCall(Relations._default.PartialOrdering$T, R#0) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PartialOrdering$T, Relations._default.PartialOrdering$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.PartialOrdering$T, R#0) && (Relations.__default.Reflexive(Relations._default.PartialOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.PartialOrdering$T, R#0) && (Relations.__default.Transitive(Relations._default.PartialOrdering$T, R#0) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.PartialOrdering$T, R#0))) && (Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, R#0) <==> Relations.__default.Reflexive(Relations._default.PartialOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.PartialOrdering$T, R#0) && Relations.__default.AntiSymmetric(Relations._default.PartialOrdering$T, R#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.PartialOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, Lit(R#0)) } Relations.__default.PartialOrdering#canCall(Relations._default.PartialOrdering$T, Lit(R#0)) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PartialOrdering$T, Relations._default.PartialOrdering$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.PartialOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.PartialOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.PartialOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Transitive(Relations._default.PartialOrdering$T, Lit(R#0))) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.PartialOrdering$T, Lit(R#0)))) && (Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.PartialOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.PartialOrdering$T, Lit(R#0)) && Relations.__default.AntiSymmetric(Relations._default.PartialOrdering$T, Lit(R#0)))));
}

function Relations.__default.PartialOrdering#canCall(Relations._default.PartialOrdering$T: Ty, R#0: HandleType) : bool;

function Relations.__default.PartialOrdering#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.PartialOrdering$T: Ty, R#0: HandleType :: { Relations.__default.PartialOrdering#requires(Relations._default.PartialOrdering$T, R#0) } $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PartialOrdering$T, Relations._default.PartialOrdering$T, TBool)) ==> (Relations.__default.PartialOrdering#requires(Relations._default.PartialOrdering$T, R#0) <==> true));

procedure {:verboseName "Relations.PartialOrdering (well-formedness)"} CheckWellformed$$Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T: Ty where $AlwaysAllocated(Relations._default.PartialOrdering$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PartialOrdering$T, Relations._default.PartialOrdering$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType :: { Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, R#0) } Relations.__default.EquivalenceRelation#canCall(Relations._default.EquivalenceRelation$T, R#0) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.EquivalenceRelation$T, Relations._default.EquivalenceRelation$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.EquivalenceRelation$T, R#0) && (Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, R#0) ==> Relations.__default.Symmetric#canCall(Relations._default.EquivalenceRelation$T, R#0) && (Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.EquivalenceRelation$T, R#0))) && (Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, R#0) <==> Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, R#0) && Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, R#0) && Relations.__default.Transitive(Relations._default.EquivalenceRelation$T, R#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, Lit(R#0)) } Relations.__default.EquivalenceRelation#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.EquivalenceRelation$T, Relations._default.EquivalenceRelation$T, TBool))) ==> Relations.__default.Reflexive#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, Lit(R#0))) ==> Relations.__default.Symmetric#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)) && (Lit(Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)))) && (Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, Lit(R#0)) && Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.EquivalenceRelation$T, Lit(R#0)))));
}

function Relations.__default.EquivalenceRelation#canCall(Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType) : bool;

function Relations.__default.EquivalenceRelation#requires(Ty, HandleType) : bool;

axiom (forall Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType :: { Relations.__default.EquivalenceRelation#requires(Relations._default.EquivalenceRelation$T, R#0) } $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.EquivalenceRelation$T, Relations._default.EquivalenceRelation$T, TBool)) ==> (Relations.__default.EquivalenceRelation#requires(Relations._default.EquivalenceRelation$T, R#0) <==> true));

procedure {:verboseName "Relations.EquivalenceRelation (well-formedness)"} CheckWellformed$$Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T: Ty where $AlwaysAllocated(Relations._default.EquivalenceRelation$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.EquivalenceRelation$T, Relations._default.EquivalenceRelation$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.SortedBy(Relations._default.SortedBy$T: Ty, a#0: Seq, lessThan#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#0: int, j#0: int :: { Seq#Index(a#0, j#0), Seq#Index(a#0, i#0) } LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#0), Seq#Index(a#0, j#0))): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#1: int, j#1: int :: { Seq#Index(a#0, j#1), Seq#Index(a#0, i#1) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#1), Seq#Index(Lit(a#0), j#1))): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#2: int, j#2: int :: { Seq#Index(a#0, j#2), Seq#Index(a#0, i#2) } LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#2), Seq#Index(Lit(a#0), j#2))): bool)));
}

function Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T: Ty, a#0: Seq, lessThan#0: HandleType) : bool;

function Relations.__default.SortedBy#requires(Ty, Seq, HandleType) : bool;

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy#requires(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool)) ==> (Relations.__default.SortedBy#requires(Relations._default.SortedBy$T, a#0, lessThan#0) <==> true));

procedure {:verboseName "Relations.SortedBy (well-formedness)"} CheckWellformed$$Relations.__default.SortedBy(Relations._default.SortedBy$T: Ty, a#0: Seq where $Is(a#0, TSeq(Relations._default.SortedBy$T)), lessThan#0: HandleType where $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Relations.SortedBy (well-formedness)"} CheckWellformed$$Relations.__default.SortedBy(Relations._default.SortedBy$T: Ty, a#0: Seq, lessThan#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;
  var j#3: int;

  anon0:
    assume {:print "Impl", " | ", "Relations.SortedBy", " | ", Relations._default.SortedBy$T, " | ", a#0, " | ", lessThan#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/Relations.dfy(69,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume false;
    return;

  anon11_Else:
    havoc i#3;
    havoc j#3;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon6;

  anon13_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon6;

  anon6:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= i#3 && i#3 < j#3;
    goto anon8;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= i#3 && i#3 < j#3);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(a#0);
    assume 0 <= i#3 && i#3 < Seq#Length(a#0);
    assume 0 <= j#3 && j#3 < Seq#Length(a#0);
    goto anon10;

  anon15_Else:
    assume {:partition} !(LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(a#0));
    goto anon10;

  anon12_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#4: int, j#4: int :: { Seq#Index(a#0, j#4), Seq#Index(a#0, i#4) } LitInt(0) <= i#4 && i#4 < j#4 && j#4 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#4), Seq#Index(a#0, j#4))): bool);
    assume true;
    assume $Is(Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), TBool);
    return;
}



function Relations.__default.IsLeast(Relations._default.IsLeast$T: Ty, R#0: HandleType, min#0: Box, s#0: Set) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#0: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#0)): bool } { s#0[x#0] } $IsBox(x#0, Relations._default.IsLeast$T) && s#0[x#0] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#1: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#1)): bool } { s#0[x#1] } $IsBox(x#1, Relations._default.IsLeast$T) && Lit(s#0)[x#1] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#1)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#2: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#2)): bool } { s#0[x#2] } $IsBox(x#2, Relations._default.IsLeast$T) && Lit(s#0)[x#2] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#2)): bool)));
}

function Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T: Ty, R#0: HandleType, min#0: Box, s#0: Set) : bool;

function Relations.__default.IsLeast#requires(Ty, HandleType, Box, Set) : bool;

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast#requires(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T)) ==> (Relations.__default.IsLeast#requires(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> true));

procedure {:verboseName "Relations.IsLeast (well-formedness)"} CheckWellformed$$Relations.__default.IsLeast(Relations._default.IsLeast$T: Ty, R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)), min#0: Box where $IsBox(min#0, Relations._default.IsLeast$T), s#0: Set where $Is(s#0, TSet(Relations._default.IsLeast$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.IsMinimal(Relations._default.IsMinimal$T: Ty, R#0: HandleType, min#0: Box, s#0: Set) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#0: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#0)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#0, min#0)): bool } { s#0[x#0] } $IsBox(x#0, Relations._default.IsMinimal$T) && s#0[x#0] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#0, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#1: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#1)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#1, min#0)): bool } { s#0[x#1] } $IsBox(x#1, Relations._default.IsMinimal$T) && Lit(s#0)[x#1] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#1, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#1)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#2: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#2)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#2, min#0)): bool } { s#0[x#2] } $IsBox(x#2, Relations._default.IsMinimal$T) && Lit(s#0)[x#2] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#2, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#2)): bool)));
}

function Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T: Ty, R#0: HandleType, min#0: Box, s#0: Set) : bool;

function Relations.__default.IsMinimal#requires(Ty, HandleType, Box, Set) : bool;

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal#requires(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T)) ==> (Relations.__default.IsMinimal#requires(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> true));

procedure {:verboseName "Relations.IsMinimal (well-formedness)"} CheckWellformed$$Relations.__default.IsMinimal(Relations._default.IsMinimal$T: Ty, R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)), min#0: Box where $IsBox(min#0, Relations._default.IsMinimal$T), s#0: Set where $Is(s#0, TSet(Relations._default.IsMinimal$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.IsGreatest(Relations._default.IsGreatest$T: Ty, R#0: HandleType, max#0: Box, s#0: Set) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#0: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#0, max#0)): bool } { s#0[x#0] } $IsBox(x#0, Relations._default.IsGreatest$T) && s#0[x#0] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#0, max#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#1: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#1, max#0)): bool } { s#0[x#1] } $IsBox(x#1, Relations._default.IsGreatest$T) && Lit(s#0)[x#1] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#1, max#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#2: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#2, max#0)): bool } { s#0[x#2] } $IsBox(x#2, Relations._default.IsGreatest$T) && Lit(s#0)[x#2] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#2, Lit(max#0))): bool)));
}

function Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T: Ty, R#0: HandleType, max#0: Box, s#0: Set) : bool;

function Relations.__default.IsGreatest#requires(Ty, HandleType, Box, Set) : bool;

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest#requires(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T)) ==> (Relations.__default.IsGreatest#requires(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> true));

procedure {:verboseName "Relations.IsGreatest (well-formedness)"} CheckWellformed$$Relations.__default.IsGreatest(Relations._default.IsGreatest$T: Ty, R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)), max#0: Box where $IsBox(max#0, Relations._default.IsGreatest$T), s#0: Set where $Is(s#0, TSet(Relations._default.IsGreatest$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Relations.__default.IsMaximal(Relations._default.IsMaximal$T: Ty, R#0: HandleType, max#0: Box, s#0: Set) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#0: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#0, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#0)): bool } { s#0[x#0] } $IsBox(x#0, Relations._default.IsMaximal$T) && s#0[x#0] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#0)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#0, max#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#1: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#1, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#1)): bool } { s#0[x#1] } $IsBox(x#1, Relations._default.IsMaximal$T) && Lit(s#0)[x#1] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#1)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#1, max#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#2: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#2, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#2)): bool } { s#0[x#2] } $IsBox(x#2, Relations._default.IsMaximal$T) && Lit(s#0)[x#2] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#2)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#2, Lit(max#0))): bool)));
}

function Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T: Ty, R#0: HandleType, max#0: Box, s#0: Set) : bool;

function Relations.__default.IsMaximal#requires(Ty, HandleType, Box, Set) : bool;

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal#requires(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T)) ==> (Relations.__default.IsMaximal#requires(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> true));

procedure {:verboseName "Relations.IsMaximal (well-formedness)"} CheckWellformed$$Relations.__default.IsMaximal(Relations._default.IsMaximal$T: Ty, R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)), max#0: Box where $IsBox(max#0, Relations._default.IsMaximal$T), s#0: Set where $Is(s#0, TSet(Relations._default.IsMaximal$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (well-formedness)"} CheckWellFormed$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty where $AlwaysAllocated(Relations._default.LemmaNewFirstElementStillSortedBy$T), x#0: Box where $IsBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsAllocBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T, $Heap), s#0: Seq where $Is(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T)) && $IsAlloc(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T), $Heap), lessThan#0: HandleType where $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool)) && $IsAlloc(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (well-formedness)"} CheckWellFormed$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty, x#0: Box, s#0: Seq, lessThan#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##a#0: Seq;
  var ##lessThan#0: HandleType;
  var ##R#0: HandleType;
  var ##a#1: Seq;
  var ##lessThan#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "Relations.LemmaNewFirstElementStillSortedBy", " | ", Relations._default.LemmaNewFirstElementStillSortedBy$T, " | ", x#0, " | ", s#0, " | ", lessThan#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Relations.dfy(95,8): initial state"} true;
    ##a#0 := s#0;
    assume $IsAlloc(##a#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T), $Heap);
    ##lessThan#0 := lessThan#0;
    assume $IsAlloc(##lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap);
    assume Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, s#0, lessThan#0);
    assume Relations.__default.SortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, s#0, lessThan#0);
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume Seq#Length(s#0) == LitInt(0);
    goto anon4;

  anon5_Else:
    assume Seq#Length(s#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#0, Seq#Index(s#0, LitInt(0)))): bool;
    goto anon4;

  anon4:
    ##R#0 := lessThan#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap);
    assume Relations.__default.TotalOrdering#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0);
    assume Relations.__default.TotalOrdering(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Relations.dfy(99,20): post-state"} true;
    ##a#1 := Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0);
    assume $IsAlloc(##a#1, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T), $Heap);
    ##lessThan#1 := lessThan#0;
    assume $IsAlloc(##lessThan#1, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap);
    assume Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0);
    assume Relations.__default.SortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0);
    return;
}



procedure {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (call precondtion)"} CallPre$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty where $AlwaysAllocated(Relations._default.LemmaNewFirstElementStillSortedBy$T), x#0: Box where $IsBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsAllocBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T, $Heap), s#0: Seq where $Is(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T)) && $IsAlloc(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T), $Heap), lessThan#0: HandleType where $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool)) && $IsAlloc(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap));
  requires {:id "id5624"} Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, s#0, lessThan#0) ==> Relations.__default.SortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, s#0, lessThan#0) || (forall i#0: int, j#0: int :: { Seq#Index(s#0, j#0), Seq#Index(s#0, i#0) } LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(s#0) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(s#0, i#0), Seq#Index(s#0, j#0))): bool);
  requires {:id "id5625"} Seq#Length(s#0) == LitInt(0) || $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#0, Seq#Index(s#0, LitInt(0)))): bool;
  requires {:id "id5626"} Relations.__default.TotalOrdering#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.TotalOrdering(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (Relations.__default.Reflexive#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.Reflexive(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (forall x#1: Box :: { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#1, x#1)): bool } $IsBox(x#1, Relations._default.LemmaNewFirstElementStillSortedBy$T) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#1, x#1)): bool));
  requires {:id "id5627"} Relations.__default.TotalOrdering#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.TotalOrdering(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (Relations.__default.AntiSymmetric#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.AntiSymmetric(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (forall x#2: Box, y#0: Box :: { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#0, x#2)): bool } { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#2, y#0)): bool } $IsBox(x#2, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsBox(y#0, Relations._default.LemmaNewFirstElementStillSortedBy$T) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#2, y#0)): bool && $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#0, x#2)): bool ==> x#2 == y#0));
  requires {:id "id5628"} Relations.__default.TotalOrdering#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.TotalOrdering(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (Relations.__default.Transitive#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.Transitive(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (forall x#3: Box, y#1: Box, z#0: Box :: { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#3, z#0)): bool, $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#1, z#0)): bool } { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#1, z#0)): bool, $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#3, y#1)): bool } $IsBox(x#3, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsBox(y#1, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsBox(z#0, Relations._default.LemmaNewFirstElementStillSortedBy$T) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#3, y#1)): bool && $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#1, z#0)): bool ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#3, z#0)): bool));
  requires {:id "id5629"} Relations.__default.TotalOrdering#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.TotalOrdering(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (Relations.__default.StronglyConnected#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) ==> Relations.__default.StronglyConnected(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) || (forall x#4: Box, y#2: Box :: { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#2, x#4)): bool } { $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#4, y#2)): bool } $IsBox(x#4, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsBox(y#2, Relations._default.LemmaNewFirstElementStillSortedBy$T) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#4, y#2)): bool || $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, y#2, x#4)): bool));



procedure {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (call postcondition)"} CallPost$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty where $AlwaysAllocated(Relations._default.LemmaNewFirstElementStillSortedBy$T), x#0: Box where $IsBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsAllocBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T, $Heap), s#0: Seq where $Is(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T)) && $IsAlloc(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T), $Heap), lessThan#0: HandleType where $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool)) && $IsAlloc(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap));
  modifies $Heap;
  free ensures Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0);
  free ensures {:id "id5630"} Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0) && Relations.__default.SortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0) && (forall i#1: int, j#1: int :: { Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), j#1), Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), i#1) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0)) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), i#1), Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), j#1))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (correctness)"} Impl$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty where $AlwaysAllocated(Relations._default.LemmaNewFirstElementStillSortedBy$T), x#0: Box where $IsBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T) && $IsAllocBox(x#0, Relations._default.LemmaNewFirstElementStillSortedBy$T, $Heap), s#0: Seq where $Is(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T)) && $IsAlloc(s#0, TSeq(Relations._default.LemmaNewFirstElementStillSortedBy$T), $Heap), lessThan#0: HandleType where $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool)) && $IsAlloc(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id5631"} Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, s#0, lessThan#0) && Relations.__default.SortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, s#0, lessThan#0) && (forall i#2: int, j#2: int :: { Seq#Index(s#0, j#2), Seq#Index(s#0, i#2) } LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(s#0) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(s#0, i#2), Seq#Index(s#0, j#2))): bool);
  requires {:id "id5632"} Seq#Length(s#0) == LitInt(0) || $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, x#0, Seq#Index(s#0, LitInt(0)))): bool;
  free requires {:id "id5633"} Relations.__default.TotalOrdering#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) && Relations.__default.TotalOrdering(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) && Relations.__default.Reflexive(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) && Relations.__default.AntiSymmetric(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) && Relations.__default.Transitive(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0) && Relations.__default.StronglyConnected(Relations._default.LemmaNewFirstElementStillSortedBy$T, lessThan#0);
  modifies $Heap;
  free ensures Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0);
  free ensures {:id "id5634"} Relations.__default.SortedBy#canCall(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0) ==> Relations.__default.SortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), lessThan#0) || (forall i#3: int, j#3: int :: { Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), j#3), Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), i#3) } LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0)) ==> $Unbox(Apply2(Relations._default.LemmaNewFirstElementStillSortedBy$T, Relations._default.LemmaNewFirstElementStillSortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), i#3), Seq#Index(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), s#0), j#3))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (correctness)"} Impl$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty, x#0: Box, s#0: Seq, lessThan#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Relations.LemmaNewFirstElementStillSortedBy", " | ", Relations._default.LemmaNewFirstElementStillSortedBy$T, " | ", x#0, " | ", s#0, " | ", lessThan#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Relations.dfy(100,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



const unique class.Seq_mMergeSort.__default: ClassName;

function Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> MultiSet#Equal(MultiSet#FromSeq(a#0), MultiSet#FromSeq(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0))) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0), lessThanOrEq#0) && $Is(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortBy$T)));
axiom 1 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#0 := Div(Seq#Length(a#0), LitInt(2)); (var left#0, right#0 := Seq#Take(a#0, splitIndex#0), Seq#Drop(a#0, splitIndex#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#0, lessThanOrEq#0) && (var leftSorted#0 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#0, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#0, lessThanOrEq#0) && (var rightSorted#0 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#0, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#0, rightSorted#0, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#0 := Div(Seq#Length(a#0), LitInt(2)); (var left#0, right#0 := Seq#Take(a#0, splitIndex#0), Seq#Drop(a#0, splitIndex#0); (var leftSorted#0 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#0, lessThanOrEq#0); (var rightSorted#0 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#0, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#0, rightSorted#0, lessThanOrEq#0)))))));
axiom 1 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#1 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#1, right#1 := Seq#Take(Lit(a#0), splitIndex#1), Seq#Drop(Lit(a#0), splitIndex#1); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#1, lessThanOrEq#0) && (var leftSorted#1 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#1, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#1, lessThanOrEq#0) && (var rightSorted#1 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#1, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#1, rightSorted#1, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#1 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#1, right#1 := Seq#Take(Lit(a#0), splitIndex#1), Seq#Drop(Lit(a#0), splitIndex#1); (var leftSorted#1 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#1, lessThanOrEq#0); (var rightSorted#1 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#1, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#1, rightSorted#1, lessThanOrEq#0)))))));
axiom 1 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || (1 < $FunctionContextHeight && $Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#2 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#2, right#2 := Seq#Take(Lit(a#0), splitIndex#2), Seq#Drop(Lit(a#0), splitIndex#2); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#2, Lit(lessThanOrEq#0)) && (var leftSorted#2 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#2, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#2, Lit(lessThanOrEq#0)) && (var rightSorted#2 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#2, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#2, rightSorted#2, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#2 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#2, right#2 := Seq#Take(Lit(a#0), splitIndex#2), Seq#Drop(Lit(a#0), splitIndex#2); (var leftSorted#2 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#2, Lit(lessThanOrEq#0)); (var rightSorted#2 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#2, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#2, rightSorted#2, Lit(lessThanOrEq#0))))))));
}

function Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T: Ty, a#0: Seq, lessThanOrEq#0: HandleType) : bool;

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, AsFuelBottom($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0) == Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LZ, a#0, lessThanOrEq#0));

function Seq_mMergeSort.__default.MergeSortBy#requires(Ty, LayerType, Seq, HandleType) : bool;

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy#requires(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0) } $Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) ==> (Seq_mMergeSort.__default.MergeSortBy#requires(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0) <==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)));

procedure {:verboseName "Seq.MergeSort.MergeSortBy (well-formedness)"} CheckWellformed$$Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T: Ty where $AlwaysAllocated(Seq.MergeSort._default.MergeSortBy$T), a#0: Seq where $Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)), lessThanOrEq#0: HandleType where $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool))) returns (result#0: Seq where $Is(result#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id5635"} MultiSet#Equal(MultiSet#FromSeq(a#0), MultiSet#FromSeq(result#0));
  free ensures {:id "id5636"} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortBy$T, result#0, lessThanOrEq#0) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, result#0, lessThanOrEq#0) || (forall i#0: int, j#0: int :: { Seq#Index(result#0, j#0), Seq#Index(result#0, i#0) } LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(result#0) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(result#0, i#0), Seq#Index(result#0, j#0))): bool);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.MergeSort.MergeSortBy (well-formedness)"} CheckWellformed$$Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T: Ty, a#0: Seq, lessThanOrEq#0: HandleType) returns (result#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##R#0: HandleType;
  var ##a#0: Seq;
  var ##lessThan#0: HandleType;
  var splitIndex#Z#0: int;
  var let#0#0#0: int;
  var left#Z#0: Seq;
  var right#Z#0: Seq;
  var let#1#0#0: Seq;
  var let#1#1#0: Seq;
  var leftSorted#Z#0: Seq;
  var let#2#0#0: Seq;
  var ##a#1: Seq;
  var ##lessThanOrEq#0: HandleType;
  var rightSorted#Z#0: Seq;
  var let#3#0#0: Seq;
  var ##a#2: Seq;
  var ##lessThanOrEq#1: HandleType;
  var ##left#0: Seq;
  var ##right#0: Seq;
  var ##lessThanOrEq#2: HandleType;

  anon0:
    assume {:print "Impl", " | ", "Seq.MergeSort.MergeSortBy", " | ", Seq.MergeSort._default.MergeSortBy$T, " | ", a#0, " | ", lessThanOrEq#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(15,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##R#0 := lessThanOrEq#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool), $Heap);
    assume Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0);
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), a#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortBy$T));
    assume MultiSet#Equal(MultiSet#FromSeq(a#0), MultiSet#FromSeq(result#0));
    ##a#0 := result#0;
    assume $IsAlloc(##a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##lessThan#0 := lessThanOrEq#0;
    assume $IsAlloc(##lessThan#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool), $Heap);
    assume Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortBy$T, result#0, lessThanOrEq#0);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, result#0, lessThanOrEq#0);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(a#0) <= LitInt(1);
    assume Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), a#0, lessThanOrEq#0) == a#0;
    assume true;
    assume $Is(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), a#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortBy$T));
    goto anon6;

  anon8_Else:
    assume {:partition} LitInt(1) < Seq#Length(a#0);
    havoc splitIndex#Z#0;
    assume true;
    assume LitInt(2) != 0;
    assume let#0#0#0 == Div(Seq#Length(a#0), LitInt(2));
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume splitIndex#Z#0 == let#0#0#0;
    havoc left#Z#0;
    havoc right#Z#0;
    assume $Is(left#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $IsAlloc(left#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap) && $Is(right#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $IsAlloc(right#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    assume 0 <= splitIndex#Z#0 && splitIndex#Z#0 <= Seq#Length(a#0);
    assume let#1#0#0 == Seq#Take(a#0, splitIndex#Z#0);
    assume true;
    assume $Is(let#1#0#0, TSeq(Seq.MergeSort._default.MergeSortBy$T));
    assume left#Z#0 == let#1#0#0;
    assume 0 <= splitIndex#Z#0 && splitIndex#Z#0 <= Seq#Length(a#0);
    assume let#1#1#0 == Seq#Drop(a#0, splitIndex#Z#0);
    assume true;
    assume $Is(let#1#1#0, TSeq(Seq.MergeSort._default.MergeSortBy$T));
    assume right#Z#0 == let#1#1#0;
    assume true;
    assume Seq#Equal(a#0, Seq#Append(left#Z#0, right#Z#0));
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(26,30)"} true;
    havoc leftSorted#Z#0;
    assume $Is(leftSorted#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $IsAlloc(leftSorted#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##a#1 := left#Z#0;
    assume $IsAlloc(##a#1, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##lessThanOrEq#0 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (forall x#0: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#0, x#0)): bool } $IsBox(x#0, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#0, x#0)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (forall x#1: Box, y#0: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#0, x#1)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#1, y#0)): bool } $IsBox(x#1, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#0, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#1, y#0)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#0, x#1)): bool ==> x#1 == y#0));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (forall x#2: Box, y#1: Box, z#0: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#2, z#0)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#1, z#0)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#1, z#0)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#2, y#1)): bool } $IsBox(x#2, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#1, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(z#0, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#2, y#1)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#1, z#0)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#2, z#0)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0) || (forall x#3: Box, y#2: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#2, x#3)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#3, y#2)): bool } $IsBox(x#3, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#2, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, x#3, y#2)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#0, y#2, x#3)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#0);
    assume Seq#Rank(##a#1) < Seq#Rank(a#0);
    assume Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#Z#0, lessThanOrEq#0);
    assume let#2#0#0 == Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), left#Z#0, lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#Z#0, lessThanOrEq#0);
    assume $Is(let#2#0#0, TSeq(Seq.MergeSort._default.MergeSortBy$T));
    assume leftSorted#Z#0 == let#2#0#0;
    havoc rightSorted#Z#0;
    assume $Is(rightSorted#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $IsAlloc(rightSorted#Z#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##a#2 := right#Z#0;
    assume $IsAlloc(##a#2, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##lessThanOrEq#1 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#1, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (forall x#4: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#4, x#4)): bool } $IsBox(x#4, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#4, x#4)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (forall x#5: Box, y#3: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#3, x#5)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#5, y#3)): bool } $IsBox(x#5, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#3, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#5, y#3)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#3, x#5)): bool ==> x#5 == y#3));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (forall x#6: Box, y#4: Box, z#1: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#6, z#1)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#4, z#1)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#4, z#1)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#6, y#4)): bool } $IsBox(x#6, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#4, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(z#1, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#6, y#4)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#4, z#1)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#6, z#1)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1) || (forall x#7: Box, y#5: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#5, x#7)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#7, y#5)): bool } $IsBox(x#7, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#5, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, x#7, y#5)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#1, y#5, x#7)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#1);
    assume Seq#Rank(##a#2) < Seq#Rank(a#0);
    assume Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#Z#0, lessThanOrEq#0);
    assume let#3#0#0 == Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), right#Z#0, lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#Z#0, lessThanOrEq#0);
    assume $Is(let#3#0#0, TSeq(Seq.MergeSort._default.MergeSortBy$T));
    assume rightSorted#Z#0 == let#3#0#0;
    ##left#0 := leftSorted#Z#0;
    assume $IsAlloc(##left#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##right#0 := rightSorted#Z#0;
    assume $IsAlloc(##right#0, TSeq(Seq.MergeSort._default.MergeSortBy$T), $Heap);
    ##lessThanOrEq#2 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#2, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortBy$T, ##left#0, ##lessThanOrEq#2) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, ##left#0, ##lessThanOrEq#2) || (forall i#1: int, j#1: int :: { Seq#Index(##left#0, j#1), Seq#Index(##left#0, i#1) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(##left#0) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, Seq#Index(##left#0, i#1), Seq#Index(##left#0, j#1))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, ##left#0, ##lessThanOrEq#2);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortBy$T, ##right#0, ##lessThanOrEq#2) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, ##right#0, ##lessThanOrEq#2) || (forall i#2: int, j#2: int :: { Seq#Index(##right#0, j#2), Seq#Index(##right#0, i#2) } LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(##right#0) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, Seq#Index(##right#0, i#2), Seq#Index(##right#0, j#2))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, ##right#0, ##lessThanOrEq#2);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (forall x#8: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#8, x#8)): bool } $IsBox(x#8, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#8, x#8)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (forall x#9: Box, y#6: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#6, x#9)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#9, y#6)): bool } $IsBox(x#9, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#6, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#9, y#6)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#6, x#9)): bool ==> x#9 == y#6));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (forall x#10: Box, y#7: Box, z#2: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#10, z#2)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#7, z#2)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#7, z#2)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#10, y#7)): bool } $IsBox(x#10, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#7, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(z#2, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#10, y#7)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#7, z#2)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#10, z#2)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2) || (forall x#11: Box, y#8: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#8, x#11)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#11, y#8)): bool } $IsBox(x#11, Seq.MergeSort._default.MergeSortBy$T) && $IsBox(y#8, Seq.MergeSort._default.MergeSortBy$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, x#11, y#8)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool, $Heap, ##lessThanOrEq#2, y#8, x#11)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, ##lessThanOrEq#2);
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#Z#0, rightSorted#Z#0, lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), a#0, lessThanOrEq#0) == Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#Z#0, rightSorted#Z#0, lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#Z#0, rightSorted#Z#0, lessThanOrEq#0);
    assume $Is(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), a#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortBy$T));
    goto anon6;

  anon6:
    assume Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), a#0, lessThanOrEq#0) == result#0;
    return;
}



function Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, right#0, lessThanOrEq#0) || (0 < $FunctionContextHeight && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)) ==> MultiSet#Equal(MultiSet#FromSeq(Seq#Append(left#0, right#0)), MultiSet#FromSeq(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0))) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0), lessThanOrEq#0) && $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), left#0, right#0, lessThanOrEq#0), $IsGoodHeap($Heap) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, right#0, lessThanOrEq#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)) ==> (Seq#Length(left#0) != LitInt(0) ==> Seq#Length(right#0) != LitInt(0) ==> ($Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0)) && (!$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0))) && Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), left#0, right#0, lessThanOrEq#0) == (if Seq#Length(left#0) == LitInt(0) then right#0 else (if Seq#Length(right#0) == LitInt(0) then left#0 else (if $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(left#0, LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(right#0, LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0))))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), lessThanOrEq#0), $IsGoodHeap($Heap) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(right#0), lessThanOrEq#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(right#0), lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)) ==> (Seq#Length(Lit(left#0)) != LitInt(0) ==> Seq#Length(Lit(right#0)) != LitInt(0) ==> ($Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), lessThanOrEq#0)) && (!$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), lessThanOrEq#0))) && Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), lessThanOrEq#0) == (if Seq#Length(Lit(left#0)) == LitInt(0) then right#0 else (if Seq#Length(Lit(right#0)) == LitInt(0) then left#0 else (if $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(left#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), lessThanOrEq#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(right#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), lessThanOrEq#0))))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), Lit(lessThanOrEq#0)), $IsGoodHeap($Heap) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(right#0), Lit(lessThanOrEq#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Lit(Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(lessThanOrEq#0))) && Lit(Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(right#0), Lit(lessThanOrEq#0))) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, Lit(lessThanOrEq#0)))) ==> (Seq#Length(Lit(left#0)) != LitInt(0) ==> Seq#Length(Lit(right#0)) != LitInt(0) ==> ($Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, Lit(lessThanOrEq#0), Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), Lit(lessThanOrEq#0))) && (!$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, Lit(lessThanOrEq#0), Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), Lit(lessThanOrEq#0)))) && Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(left#0)) == LitInt(0) then right#0 else (if Seq#Length(Lit(right#0)) == LitInt(0) then left#0 else (if $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, Lit(lessThanOrEq#0), Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(left#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), Lit(lessThanOrEq#0))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(right#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), Lit(lessThanOrEq#0)))))));
}

function Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T: Ty, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType) : bool;

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), left#0, right#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), left#0, right#0, lessThanOrEq#0) == Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0));

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, AsFuelBottom($ly), left#0, right#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0) == Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LZ, left#0, right#0, lessThanOrEq#0));

function Seq_mMergeSort.__default.MergeSortedWith#requires(Ty, LayerType, Seq, Seq, HandleType) : bool;

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith#requires(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) ==> (Seq_mMergeSort.__default.MergeSortedWith#requires(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0) <==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)));

procedure {:verboseName "Seq.MergeSort.MergeSortedWith (well-formedness)"} CheckWellformed$$Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T: Ty where $AlwaysAllocated(Seq.MergeSort._default.MergeSortedWith$T), left#0: Seq where $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)), right#0: Seq where $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)), lessThanOrEq#0: HandleType where $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool))) returns (result#0: Seq where $Is(result#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id5673"} MultiSet#Equal(MultiSet#FromSeq(Seq#Append(left#0, right#0)), MultiSet#FromSeq(result#0));
  free ensures {:id "id5674"} Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, result#0, lessThanOrEq#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.MergeSort.MergeSortedWith (well-formedness)"} CheckWellformed$$Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T: Ty, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType) returns (result#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##a#0: Seq;
  var ##lessThan#0: HandleType;
  var ##a#1: Seq;
  var ##lessThan#1: HandleType;
  var ##R#0: HandleType;
  var ##a#2: Seq;
  var ##lessThan#2: HandleType;
  var x##0: Box;
  var s##0: Seq;
  var ##left#0: Seq;
  var ##right#0: Seq;
  var ##lessThanOrEq#0: HandleType;
  var lessThan##0: HandleType;
  var ##left#1: Seq;
  var ##right#1: Seq;
  var ##lessThanOrEq#1: HandleType;
  var x##1: Box;
  var s##1: Seq;
  var ##left#2: Seq;
  var ##right#2: Seq;
  var ##lessThanOrEq#2: HandleType;
  var lessThan##1: HandleType;
  var ##left#3: Seq;
  var ##right#3: Seq;
  var ##lessThanOrEq#3: HandleType;

  anon0:
    assume {:print "Impl", " | ", "Seq.MergeSort.MergeSortedWith", " | ", Seq.MergeSort._default.MergeSortedWith$T, " | ", left#0, " | ", right#0, " | ", lessThanOrEq#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(34,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##a#0 := left#0;
    assume $IsAlloc(##a#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThan#0 := lessThanOrEq#0;
    assume $IsAlloc(##lessThan#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0);
    ##a#1 := right#0;
    assume $IsAlloc(##a#1, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThan#1 := lessThanOrEq#0;
    assume $IsAlloc(##lessThan#1, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0);
    ##R#0 := lessThanOrEq#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0);
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T));
    assume MultiSet#Equal(MultiSet#FromSeq(Seq#Append(left#0, right#0)), MultiSet#FromSeq(result#0));
    ##a#2 := result#0;
    assume $IsAlloc(##a#2, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThan#2 := lessThanOrEq#0;
    assume $IsAlloc(##lessThan#2, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, result#0, lessThanOrEq#0);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, result#0, lessThanOrEq#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Length(left#0) == LitInt(0);
    assume Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0) == right#0;
    assume true;
    assume $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T));
    goto anon10;

  anon12_Else:
    assume {:partition} Seq#Length(left#0) != LitInt(0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Length(right#0) == LitInt(0);
    assume Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0) == left#0;
    assume true;
    assume $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T));
    goto anon10;

  anon13_Else:
    assume {:partition} Seq#Length(right#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(left#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(right#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(left#0);
    assume true;
    x##0 := Seq#Index(left#0, LitInt(0));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(left#0);
    ##left#0 := Seq#Drop(left#0, LitInt(1));
    assume $IsAlloc(##left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##right#0 := right#0;
    assume $IsAlloc(##right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThanOrEq#0 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##left#0, ##lessThanOrEq#0) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#0, ##lessThanOrEq#0) || (forall i#0: int, j#0: int :: { Seq#Index(##left#0, j#0), Seq#Index(##left#0, i#0) } LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(##left#0) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, Seq#Index(##left#0, i#0), Seq#Index(##left#0, j#0))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#0, ##lessThanOrEq#0);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##right#0, ##lessThanOrEq#0) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#0, ##lessThanOrEq#0) || (forall i#1: int, j#1: int :: { Seq#Index(##right#0, j#1), Seq#Index(##right#0, i#1) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(##right#0) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, Seq#Index(##right#0, i#1), Seq#Index(##right#0, j#1))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#0, ##lessThanOrEq#0);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (forall x#0: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#0, x#0)): bool } $IsBox(x#0, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#0, x#0)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (forall x#1: Box, y#0: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#0, x#1)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#1, y#0)): bool } $IsBox(x#1, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#0, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#1, y#0)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#0, x#1)): bool ==> x#1 == y#0));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (forall x#2: Box, y#1: Box, z#0: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#2, z#0)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#1, z#0)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#1, z#0)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#2, y#1)): bool } $IsBox(x#2, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#1, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(z#0, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#2, y#1)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#1, z#0)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#2, z#0)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0) || (forall x#3: Box, y#2: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#2, x#3)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#3, y#2)): bool } $IsBox(x#3, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#2, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, x#3, y#2)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#0, y#2, x#3)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#0);
    assume Seq#Rank(##left#0) < Seq#Rank(left#0) || (Seq#Rank(##left#0) == Seq#Rank(left#0) && Seq#Rank(##right#0) < Seq#Rank(right#0));
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0);
    s##0 := Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0);
    assume true;
    lessThan##0 := lessThanOrEq#0;
    call CallPre$$Relations.__default.LemmaNewFirstElementStillSortedBy(Seq.MergeSort._default.MergeSortedWith$T, x##0, s##0, lessThan##0);
    call CallPost$$Relations.__default.LemmaNewFirstElementStillSortedBy(Seq.MergeSort._default.MergeSortedWith$T, x##0, s##0, lessThan##0);
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(46,110)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(left#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(left#0);
    assume true;
    assume Seq#Equal(left#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(left#0, LitInt(0))), Seq#Drop(left#0, LitInt(1))));
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(47,42)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(left#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(left#0);
    ##left#1 := Seq#Drop(left#0, LitInt(1));
    assume $IsAlloc(##left#1, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##right#1 := right#0;
    assume $IsAlloc(##right#1, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThanOrEq#1 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#1, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##left#1, ##lessThanOrEq#1) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#1, ##lessThanOrEq#1) || (forall i#2: int, j#2: int :: { Seq#Index(##left#1, j#2), Seq#Index(##left#1, i#2) } LitInt(0) <= i#2 && i#2 < j#2 && j#2 < Seq#Length(##left#1) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, Seq#Index(##left#1, i#2), Seq#Index(##left#1, j#2))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#1, ##lessThanOrEq#1);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##right#1, ##lessThanOrEq#1) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#1, ##lessThanOrEq#1) || (forall i#3: int, j#3: int :: { Seq#Index(##right#1, j#3), Seq#Index(##right#1, i#3) } LitInt(0) <= i#3 && i#3 < j#3 && j#3 < Seq#Length(##right#1) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, Seq#Index(##right#1, i#3), Seq#Index(##right#1, j#3))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#1, ##lessThanOrEq#1);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (forall x#4: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#4, x#4)): bool } $IsBox(x#4, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#4, x#4)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (forall x#5: Box, y#3: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#3, x#5)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#5, y#3)): bool } $IsBox(x#5, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#3, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#5, y#3)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#3, x#5)): bool ==> x#5 == y#3));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (forall x#6: Box, y#4: Box, z#1: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#6, z#1)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#4, z#1)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#4, z#1)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#6, y#4)): bool } $IsBox(x#6, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#4, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(z#1, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#6, y#4)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#4, z#1)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#6, z#1)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1) || (forall x#7: Box, y#5: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#5, x#7)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#7, y#5)): bool } $IsBox(x#7, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#5, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, x#7, y#5)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#1, y#5, x#7)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#1);
    assume Seq#Rank(##left#1) < Seq#Rank(left#0) || (Seq#Rank(##left#1) == Seq#Rank(left#0) && Seq#Rank(##right#1) < Seq#Rank(right#0));
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(left#0, LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0));
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0);
    assume $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T));
    goto anon10;

  anon14_Else:
    assume {:partition} !$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(right#0);
    assume true;
    x##1 := Seq#Index(right#0, LitInt(0));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(right#0);
    ##left#2 := left#0;
    assume $IsAlloc(##left#2, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##right#2 := Seq#Drop(right#0, LitInt(1));
    assume $IsAlloc(##right#2, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThanOrEq#2 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#2, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##left#2, ##lessThanOrEq#2) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#2, ##lessThanOrEq#2) || (forall i#4: int, j#4: int :: { Seq#Index(##left#2, j#4), Seq#Index(##left#2, i#4) } LitInt(0) <= i#4 && i#4 < j#4 && j#4 < Seq#Length(##left#2) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, Seq#Index(##left#2, i#4), Seq#Index(##left#2, j#4))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#2, ##lessThanOrEq#2);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##right#2, ##lessThanOrEq#2) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#2, ##lessThanOrEq#2) || (forall i#5: int, j#5: int :: { Seq#Index(##right#2, j#5), Seq#Index(##right#2, i#5) } LitInt(0) <= i#5 && i#5 < j#5 && j#5 < Seq#Length(##right#2) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, Seq#Index(##right#2, i#5), Seq#Index(##right#2, j#5))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#2, ##lessThanOrEq#2);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (forall x#8: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#8, x#8)): bool } $IsBox(x#8, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#8, x#8)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (forall x#9: Box, y#6: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#6, x#9)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#9, y#6)): bool } $IsBox(x#9, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#6, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#9, y#6)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#6, x#9)): bool ==> x#9 == y#6));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (forall x#10: Box, y#7: Box, z#2: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#10, z#2)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#7, z#2)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#7, z#2)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#10, y#7)): bool } $IsBox(x#10, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#7, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(z#2, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#10, y#7)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#7, z#2)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#10, z#2)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2) || (forall x#11: Box, y#8: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#8, x#11)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#11, y#8)): bool } $IsBox(x#11, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#8, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, x#11, y#8)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#2, y#8, x#11)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#2);
    assume Seq#Rank(##left#2) < Seq#Rank(left#0) || (Seq#Rank(##left#2) == Seq#Rank(left#0) && Seq#Rank(##right#2) < Seq#Rank(right#0));
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0);
    s##1 := Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0);
    assume true;
    lessThan##1 := lessThanOrEq#0;
    call CallPre$$Relations.__default.LemmaNewFirstElementStillSortedBy(Seq.MergeSort._default.MergeSortedWith$T, x##1, s##1, lessThan##1);
    call CallPost$$Relations.__default.LemmaNewFirstElementStillSortedBy(Seq.MergeSort._default.MergeSortedWith$T, x##1, s##1, lessThan##1);
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(52,111)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(right#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(right#0);
    assume true;
    assume Seq#Equal(right#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(right#0, LitInt(0))), Seq#Drop(right#0, LitInt(1))));
    assume {:captureState "libraries/src/Collections/Sequences/MergeSort.dfy(53,45)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(right#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(right#0);
    ##left#3 := left#0;
    assume $IsAlloc(##left#3, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##right#3 := Seq#Drop(right#0, LitInt(1));
    assume $IsAlloc(##right#3, TSeq(Seq.MergeSort._default.MergeSortedWith$T), $Heap);
    ##lessThanOrEq#3 := lessThanOrEq#0;
    assume $IsAlloc(##lessThanOrEq#3, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool), $Heap);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##left#3, ##lessThanOrEq#3) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#3, ##lessThanOrEq#3) || (forall i#6: int, j#6: int :: { Seq#Index(##left#3, j#6), Seq#Index(##left#3, i#6) } LitInt(0) <= i#6 && i#6 < j#6 && j#6 < Seq#Length(##left#3) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, Seq#Index(##left#3, i#6), Seq#Index(##left#3, j#6))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##left#3, ##lessThanOrEq#3);
    assume {:subsumption 0} Relations.__default.SortedBy#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##right#3, ##lessThanOrEq#3) ==> Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#3, ##lessThanOrEq#3) || (forall i#7: int, j#7: int :: { Seq#Index(##right#3, j#7), Seq#Index(##right#3, i#7) } LitInt(0) <= i#7 && i#7 < j#7 && j#7 < Seq#Length(##right#3) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, Seq#Index(##right#3, i#7), Seq#Index(##right#3, j#7))): bool);
    assume Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, ##right#3, ##lessThanOrEq#3);
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (Relations.__default.Reflexive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.Reflexive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (forall x#12: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#12, x#12)): bool } $IsBox(x#12, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#12, x#12)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (Relations.__default.AntiSymmetric#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.AntiSymmetric(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (forall x#13: Box, y#9: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#9, x#13)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#13, y#9)): bool } $IsBox(x#13, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#9, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#13, y#9)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#9, x#13)): bool ==> x#13 == y#9));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (Relations.__default.Transitive#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.Transitive(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (forall x#14: Box, y#10: Box, z#3: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#14, z#3)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#10, z#3)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#10, z#3)): bool, $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#14, y#10)): bool } $IsBox(x#14, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#10, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(z#3, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#14, y#10)): bool && $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#10, z#3)): bool ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#14, z#3)): bool));
    assume {:subsumption 0} Relations.__default.TotalOrdering#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (Relations.__default.StronglyConnected#canCall(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) ==> Relations.__default.StronglyConnected(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3) || (forall x#15: Box, y#11: Box :: { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#11, x#15)): bool } { $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#15, y#11)): bool } $IsBox(x#15, Seq.MergeSort._default.MergeSortedWith$T) && $IsBox(y#11, Seq.MergeSort._default.MergeSortedWith$T) ==> $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, x#15, y#11)): bool || $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, ##lessThanOrEq#3, y#11, x#15)): bool));
    assume Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, ##lessThanOrEq#3);
    assume Seq#Rank(##left#3) < Seq#Rank(left#0) || (Seq#Rank(##left#3) == Seq#Rank(left#0) && Seq#Rank(##right#3) < Seq#Rank(right#0));
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0);
    assume Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(right#0, LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0));
    assume Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0);
    assume $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T));
    goto anon10;

  anon10:
    assume Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($LZ), left#0, right#0, lessThanOrEq#0) == result#0;
    return;
}



axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#4: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#4, x#4)): bool } $IsBox(x#4, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#4, x#4)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#5: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#5, x#5)): bool } $IsBox(x#5, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#5, x#5)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#4: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#4, x#4)): bool } $IsBox(x#4, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#4, x#4)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#5: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#5, x#5)): bool } $IsBox(x#5, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#5, x#5)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#4, x#4)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#4, y#4)): bool } $IsBox(x#4, Relations._default.AntiSymmetric$T) && $IsBox(y#4, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#4, y#4)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#4, x#4)): bool ==> x#4 == y#4)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#5, x#5)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#5, y#5)): bool } $IsBox(x#5, Relations._default.AntiSymmetric$T) && $IsBox(y#5, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#5, y#5)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#5, x#5)): bool ==> x#5 == y#5)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#4, x#4)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#4, y#4)): bool } $IsBox(x#4, Relations._default.Symmetric$T) && $IsBox(y#4, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#4, y#4)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#4, x#4)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#5, x#5)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#5, y#5)): bool } $IsBox(x#5, Relations._default.Symmetric$T) && $IsBox(y#5, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#5, y#5)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#5, x#5)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#4, x#4)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#4, y#4)): bool } $IsBox(x#4, Relations._default.Connected$T) && $IsBox(y#4, Relations._default.Connected$T) ==> x#4 != y#4 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#4, y#4)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#4, x#4)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#5, x#5)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#5, y#5)): bool } $IsBox(x#5, Relations._default.Connected$T) && $IsBox(y#5, Relations._default.Connected$T) ==> x#5 != y#5 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#5, y#5)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#5, x#5)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#4, x#4)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#4, y#4)): bool } $IsBox(x#4, Relations._default.StronglyConnected$T) && $IsBox(y#4, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#4, y#4)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#4, x#4)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#5, x#5)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#5, y#5)): bool } $IsBox(x#5, Relations._default.StronglyConnected$T) && $IsBox(y#5, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#5, y#5)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#5, x#5)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#4: Box, y#4: Box, z#4: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#4, z#4)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#4, z#4)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#4, z#4)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#4, y#4)): bool } $IsBox(x#4, Relations._default.Transitive$T) && $IsBox(y#4, Relations._default.Transitive$T) && $IsBox(z#4, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#4, y#4)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#4, z#4)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#4, z#4)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#5: Box, y#5: Box, z#5: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#5, z#5)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#5, z#5)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#5, z#5)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#5, y#5)): bool } $IsBox(x#5, Relations._default.Transitive$T) && $IsBox(y#5, Relations._default.Transitive$T) && $IsBox(z#5, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#5, y#5)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#5, z#5)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#5, z#5)): bool)));

axiom (forall Relations._default.TotalOrdering$T: Ty, R#0: HandleType :: { Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, R#0) } Relations.__default.TotalOrdering#canCall(Relations._default.TotalOrdering$T, R#0) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.TotalOrdering$T, Relations._default.TotalOrdering$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.TotalOrdering$T, R#0) && (Relations.__default.Reflexive(Relations._default.TotalOrdering$T, R#0) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.TotalOrdering$T, R#0) && (Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.TotalOrdering$T, R#0) && (Relations.__default.Transitive(Relations._default.TotalOrdering$T, R#0) ==> Relations.__default.StronglyConnected#canCall(Relations._default.TotalOrdering$T, R#0)))) && (Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, R#0) <==> Relations.__default.Reflexive(Relations._default.TotalOrdering$T, R#0) && Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.TotalOrdering$T, R#0) && Relations.__default.StronglyConnected(Relations._default.TotalOrdering$T, R#0)));

axiom (forall Relations._default.TotalOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, Lit(R#0)) } Relations.__default.TotalOrdering#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.TotalOrdering$T, Relations._default.TotalOrdering$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.TotalOrdering$T, Lit(R#0))) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.TotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Transitive(Relations._default.TotalOrdering$T, Lit(R#0))) ==> Relations.__default.StronglyConnected#canCall(Relations._default.TotalOrdering$T, Lit(R#0))))) && (Relations.__default.TotalOrdering(Relations._default.TotalOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.TotalOrdering$T, Lit(R#0)) && Relations.__default.AntiSymmetric(Relations._default.TotalOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.TotalOrdering$T, Lit(R#0)) && Relations.__default.StronglyConnected(Relations._default.TotalOrdering$T, Lit(R#0)))));

axiom (forall Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType :: { Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, R#0) } Relations.__default.StrictTotalOrdering#canCall(Relations._default.StrictTotalOrdering$T, R#0) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StrictTotalOrdering$T, Relations._default.StrictTotalOrdering$T, TBool)) ==> Relations.__default.Irreflexive#canCall(Relations._default.StrictTotalOrdering$T, R#0) && (Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, R#0) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.StrictTotalOrdering$T, R#0) && (Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.StrictTotalOrdering$T, R#0) && (Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, R#0) ==> Relations.__default.Connected#canCall(Relations._default.StrictTotalOrdering$T, R#0)))) && (Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, R#0) <==> Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, R#0) && Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, R#0) && Relations.__default.Connected(Relations._default.StrictTotalOrdering$T, R#0)));

axiom (forall Relations._default.StrictTotalOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, Lit(R#0)) } Relations.__default.StrictTotalOrdering#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StrictTotalOrdering$T, Relations._default.StrictTotalOrdering$T, TBool)) ==> Relations.__default.Irreflexive#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, Lit(R#0))) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, Lit(R#0))) ==> Relations.__default.Connected#canCall(Relations._default.StrictTotalOrdering$T, Lit(R#0))))) && (Relations.__default.StrictTotalOrdering(Relations._default.StrictTotalOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Irreflexive(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && Relations.__default.AntiSymmetric(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.StrictTotalOrdering$T, Lit(R#0)) && Relations.__default.Connected(Relations._default.StrictTotalOrdering$T, Lit(R#0)))));

axiom (forall Relations._default.PreOrdering$T: Ty, R#0: HandleType :: { Relations.__default.PreOrdering(Relations._default.PreOrdering$T, R#0) } Relations.__default.PreOrdering#canCall(Relations._default.PreOrdering$T, R#0) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PreOrdering$T, Relations._default.PreOrdering$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.PreOrdering$T, R#0) && (Relations.__default.Reflexive(Relations._default.PreOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.PreOrdering$T, R#0)) && (Relations.__default.PreOrdering(Relations._default.PreOrdering$T, R#0) <==> Relations.__default.Reflexive(Relations._default.PreOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.PreOrdering$T, R#0)));

axiom (forall Relations._default.PreOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.PreOrdering(Relations._default.PreOrdering$T, Lit(R#0)) } Relations.__default.PreOrdering#canCall(Relations._default.PreOrdering$T, Lit(R#0)) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PreOrdering$T, Relations._default.PreOrdering$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.PreOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.PreOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.PreOrdering$T, Lit(R#0))) && (Relations.__default.PreOrdering(Relations._default.PreOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.PreOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.PreOrdering$T, Lit(R#0)))));

axiom (forall Relations._default.PartialOrdering$T: Ty, R#0: HandleType :: { Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, R#0) } Relations.__default.PartialOrdering#canCall(Relations._default.PartialOrdering$T, R#0) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PartialOrdering$T, Relations._default.PartialOrdering$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.PartialOrdering$T, R#0) && (Relations.__default.Reflexive(Relations._default.PartialOrdering$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.PartialOrdering$T, R#0) && (Relations.__default.Transitive(Relations._default.PartialOrdering$T, R#0) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.PartialOrdering$T, R#0))) && (Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, R#0) <==> Relations.__default.Reflexive(Relations._default.PartialOrdering$T, R#0) && Relations.__default.Transitive(Relations._default.PartialOrdering$T, R#0) && Relations.__default.AntiSymmetric(Relations._default.PartialOrdering$T, R#0)));

axiom (forall Relations._default.PartialOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, Lit(R#0)) } Relations.__default.PartialOrdering#canCall(Relations._default.PartialOrdering$T, Lit(R#0)) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.PartialOrdering$T, Relations._default.PartialOrdering$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.PartialOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.PartialOrdering$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.PartialOrdering$T, Lit(R#0)) && (Lit(Relations.__default.Transitive(Relations._default.PartialOrdering$T, Lit(R#0))) ==> Relations.__default.AntiSymmetric#canCall(Relations._default.PartialOrdering$T, Lit(R#0)))) && (Relations.__default.PartialOrdering(Relations._default.PartialOrdering$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.PartialOrdering$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.PartialOrdering$T, Lit(R#0)) && Relations.__default.AntiSymmetric(Relations._default.PartialOrdering$T, Lit(R#0)))));

axiom (forall Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType :: { Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, R#0) } Relations.__default.EquivalenceRelation#canCall(Relations._default.EquivalenceRelation$T, R#0) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.EquivalenceRelation$T, Relations._default.EquivalenceRelation$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.EquivalenceRelation$T, R#0) && (Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, R#0) ==> Relations.__default.Symmetric#canCall(Relations._default.EquivalenceRelation$T, R#0) && (Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, R#0) ==> Relations.__default.Transitive#canCall(Relations._default.EquivalenceRelation$T, R#0))) && (Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, R#0) <==> Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, R#0) && Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, R#0) && Relations.__default.Transitive(Relations._default.EquivalenceRelation$T, R#0)));

axiom (forall Relations._default.EquivalenceRelation$T: Ty, R#0: HandleType :: {:weight 3} { Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, Lit(R#0)) } Relations.__default.EquivalenceRelation#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)) || $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.EquivalenceRelation$T, Relations._default.EquivalenceRelation$T, TBool)) ==> Relations.__default.Reflexive#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)) && (Lit(Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, Lit(R#0))) ==> Relations.__default.Symmetric#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)) && (Lit(Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, Lit(R#0))) ==> Relations.__default.Transitive#canCall(Relations._default.EquivalenceRelation$T, Lit(R#0)))) && (Relations.__default.EquivalenceRelation(Relations._default.EquivalenceRelation$T, Lit(R#0)) <==> Lit(Relations.__default.Reflexive(Relations._default.EquivalenceRelation$T, Lit(R#0)) && Relations.__default.Symmetric(Relations._default.EquivalenceRelation$T, Lit(R#0)) && Relations.__default.Transitive(Relations._default.EquivalenceRelation$T, Lit(R#0)))));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#5: int, j#5: int :: { Seq#Index(a#0, j#5), Seq#Index(a#0, i#5) } LitInt(0) <= i#5 && i#5 < j#5 && j#5 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#5), Seq#Index(a#0, j#5))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#6: int, j#6: int :: { Seq#Index(a#0, j#6), Seq#Index(a#0, i#6) } LitInt(0) <= i#6 && i#6 < j#6 && j#6 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#6), Seq#Index(Lit(a#0), j#6))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#7: int, j#7: int :: { Seq#Index(a#0, j#7), Seq#Index(a#0, i#7) } LitInt(0) <= i#7 && i#7 < j#7 && j#7 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#7), Seq#Index(Lit(a#0), j#7))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#5: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#5)): bool } { s#0[x#5] } $IsBox(x#5, Relations._default.IsLeast$T) && s#0[x#5] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#5)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#6: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#6)): bool } { s#0[x#6] } $IsBox(x#6, Relations._default.IsLeast$T) && Lit(s#0)[x#6] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#6)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#7: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#7)): bool } { s#0[x#7] } $IsBox(x#7, Relations._default.IsLeast$T) && Lit(s#0)[x#7] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#7)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#5: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#5)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#5, min#0)): bool } { s#0[x#5] } $IsBox(x#5, Relations._default.IsMinimal$T) && s#0[x#5] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#5, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#5)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#6: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#6)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#6, min#0)): bool } { s#0[x#6] } $IsBox(x#6, Relations._default.IsMinimal$T) && Lit(s#0)[x#6] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#6, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#6)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#7: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#7)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#7, min#0)): bool } { s#0[x#7] } $IsBox(x#7, Relations._default.IsMinimal$T) && Lit(s#0)[x#7] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#7, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#7)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#5: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#5, max#0)): bool } { s#0[x#5] } $IsBox(x#5, Relations._default.IsGreatest$T) && s#0[x#5] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#5, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#6: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#6, max#0)): bool } { s#0[x#6] } $IsBox(x#6, Relations._default.IsGreatest$T) && Lit(s#0)[x#6] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#6, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#7: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#7, max#0)): bool } { s#0[x#7] } $IsBox(x#7, Relations._default.IsGreatest$T) && Lit(s#0)[x#7] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#7, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#5: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#5, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#5)): bool } { s#0[x#5] } $IsBox(x#5, Relations._default.IsMaximal$T) && s#0[x#5] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#5)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#5, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#6: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#6, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#6)): bool } { s#0[x#6] } $IsBox(x#6, Relations._default.IsMaximal$T) && Lit(s#0)[x#6] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#6)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#6, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#7: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#7, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#7)): bool } { s#0[x#7] } $IsBox(x#7, Relations._default.IsMaximal$T) && Lit(s#0)[x#7] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#7)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#7, Lit(max#0))): bool)));

const unique class.Math.__default: ClassName;

function Math.__default.Min(a#0: int, b#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: { Math.__default.Min(a#0, b#0) } Math.__default.Min#canCall(a#0, b#0) || 0 < $FunctionContextHeight ==> Math.__default.Min(a#0, b#0) == (if a#0 < b#0 then a#0 else b#0));
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: {:weight 3} { Math.__default.Min(LitInt(a#0), LitInt(b#0)) } Math.__default.Min#canCall(LitInt(a#0), LitInt(b#0)) || 0 < $FunctionContextHeight ==> Math.__default.Min(LitInt(a#0), LitInt(b#0)) == (if a#0 < b#0 then a#0 else b#0));
}

function Math.__default.Min#canCall(a#0: int, b#0: int) : bool;

function Math.__default.Min#requires(int, int) : bool;

axiom (forall a#0: int, b#0: int :: { Math.__default.Min#requires(a#0, b#0) } Math.__default.Min#requires(a#0, b#0) <==> true);

procedure {:verboseName "Math.Min (well-formedness)"} CheckWellformed$$Math.__default.Min(a#0: int, b#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Math.__default.Max(a#0: int, b#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: { Math.__default.Max(a#0, b#0) } Math.__default.Max#canCall(a#0, b#0) || 0 < $FunctionContextHeight ==> Math.__default.Max(a#0, b#0) == (if a#0 < b#0 then b#0 else a#0));
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: {:weight 3} { Math.__default.Max(LitInt(a#0), LitInt(b#0)) } Math.__default.Max#canCall(LitInt(a#0), LitInt(b#0)) || 0 < $FunctionContextHeight ==> Math.__default.Max(LitInt(a#0), LitInt(b#0)) == (if a#0 < b#0 then b#0 else a#0));
}

function Math.__default.Max#canCall(a#0: int, b#0: int) : bool;

function Math.__default.Max#requires(int, int) : bool;

axiom (forall a#0: int, b#0: int :: { Math.__default.Max#requires(a#0, b#0) } Math.__default.Max#requires(a#0, b#0) <==> true);

procedure {:verboseName "Math.Max (well-formedness)"} CheckWellformed$$Math.__default.Max(a#0: int, b#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Math.__default.Abs(a#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int :: { Math.__default.Abs(a#0) } Math.__default.Abs#canCall(a#0) || 0 < $FunctionContextHeight ==> Math.__default.Abs(a#0) >= LitInt(0));
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int :: { Math.__default.Abs(a#0) } Math.__default.Abs#canCall(a#0) || 0 < $FunctionContextHeight ==> Math.__default.Abs(a#0) == (if a#0 >= LitInt(0) then a#0 else 0 - a#0));
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int :: {:weight 3} { Math.__default.Abs(LitInt(a#0)) } Math.__default.Abs#canCall(LitInt(a#0)) || 0 < $FunctionContextHeight ==> Math.__default.Abs(LitInt(a#0)) == (if LitInt(a#0) >= LitInt(0) then a#0 else 0 - a#0));
}

function Math.__default.Abs#canCall(a#0: int) : bool;

function Math.__default.Abs#requires(int) : bool;

axiom (forall a#0: int :: { Math.__default.Abs#requires(a#0) } Math.__default.Abs#requires(a#0) <==> true);

procedure {:verboseName "Math.Abs (well-formedness)"} CheckWellformed$$Math.__default.Abs(a#0: int) returns (a'#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id5744"} a'#0 >= LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Math.Abs (well-formedness)"} CheckWellformed$$Math.__default.Abs(a#0: int) returns (a'#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Math.Abs", " | ", a#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/Math.dfy(25,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume a'#0 >= LitInt(0);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} a#0 >= LitInt(0);
    assume Math.__default.Abs(a#0) == a#0;
    assume true;
    assume $Is(Math.__default.Abs(a#0), TInt);
    goto anon6;

  anon8_Else:
    assume {:partition} LitInt(0) > a#0;
    assume Math.__default.Abs(a#0) == 0 - a#0;
    assume true;
    assume $Is(Math.__default.Abs(a#0), TInt);
    goto anon6;

  anon6:
    assume Math.__default.Abs(a#0) == a'#0;
    return;
}



const reveal_Seq._default.ToSet: bool;

const reveal_Seq._default.HasNoDuplicates: bool;

const reveal_Seq._default.IndexOf: bool;

const reveal_Seq._default.IndexOfOption: bool;

const reveal_Seq._default.LastIndexOf: bool;

const reveal_Seq._default.LastIndexOfOption: bool;

const reveal_Seq._default.Remove: bool;

const reveal_Seq._default.RemoveValue: bool;

const reveal_Seq._default.Insert: bool;

const reveal_Seq._default.Reverse: bool;

const reveal_Seq._default.Repeat: bool;

const reveal_Seq._default.Unzip: bool;

const reveal_Seq._default.Zip: bool;

const reveal_Seq._default.Max: bool;

const reveal_Seq._default.Min: bool;

const reveal_Seq._default.Map: bool;

const reveal_Seq._default.MapWithResult: bool;

const reveal_Seq._default.Filter: bool;

const reveal_Seq._default.FoldLeft: bool;

const reveal_Seq._default.FoldRight: bool;

const unique class.Seq.__default: ClassName;

function Seq.__default.First(Seq._default.First$T: Ty, xs#0: Seq) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.First$T: Ty, xs#0: Seq :: { Seq.__default.First(Seq._default.First$T, xs#0) } Seq.__default.First#canCall(Seq._default.First$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.First$T)) && Seq#Length(xs#0) > 0) ==> $IsBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.First$T: Ty, xs#0: Seq :: { $IsAllocBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T, $Heap) } (Seq.__default.First#canCall(Seq._default.First$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.First$T)) && $IsAlloc(xs#0, TSeq(Seq._default.First$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.First$T: Ty, xs#0: Seq :: { Seq.__default.First(Seq._default.First$T, xs#0) } Seq.__default.First#canCall(Seq._default.First$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.First$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.First(Seq._default.First$T, xs#0) == Seq#Index(xs#0, LitInt(0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.First$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.First(Seq._default.First$T, Lit(xs#0)) } Seq.__default.First#canCall(Seq._default.First$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.First$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.First(Seq._default.First$T, Lit(xs#0)) == Seq#Index(Lit(xs#0), LitInt(0)));
}

function Seq.__default.First#canCall(Seq._default.First$T: Ty, xs#0: Seq) : bool;

function Seq.__default.First#requires(Ty, Seq) : bool;

axiom (forall Seq._default.First$T: Ty, xs#0: Seq :: { Seq.__default.First#requires(Seq._default.First$T, xs#0) } $Is(xs#0, TSeq(Seq._default.First$T)) ==> (Seq.__default.First#requires(Seq._default.First$T, xs#0) <==> Seq#Length(xs#0) > 0));

procedure {:verboseName "Seq.First (well-formedness)"} CheckWellformed$$Seq.__default.First(Seq._default.First$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.First$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.First (well-formedness)"} CheckWellformed$$Seq.__default.First(Seq._default.First$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.First", " | ", Seq._default.First$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(35,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(xs#0) > 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T);
    assume false;
    return;

  anon4_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume Seq.__default.First(Seq._default.First$T, xs#0) == Seq#Index(xs#0, LitInt(0));
    assume true;
    assume $IsBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T);
    return;
}



function Seq.__default.DropFirst(Seq._default.DropFirst$T: Ty, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: { Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) } Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropFirst$T)) && Seq#Length(xs#0) > 0) ==> $Is(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.DropFirst$T: Ty, xs#0: Seq :: { $IsAlloc(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T), $Heap) } (Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropFirst$T)) && $IsAlloc(xs#0, TSeq(Seq._default.DropFirst$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: { Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) } Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropFirst$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) == Seq#Drop(xs#0, LitInt(1)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.DropFirst(Seq._default.DropFirst$T, Lit(xs#0)) } Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropFirst$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.DropFirst(Seq._default.DropFirst$T, Lit(xs#0)) == Lit(Seq#Drop(Lit(xs#0), LitInt(1))));
}

function Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T: Ty, xs#0: Seq) : bool;

function Seq.__default.DropFirst#requires(Ty, Seq) : bool;

axiom (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: { Seq.__default.DropFirst#requires(Seq._default.DropFirst$T, xs#0) } $Is(xs#0, TSeq(Seq._default.DropFirst$T)) ==> (Seq.__default.DropFirst#requires(Seq._default.DropFirst$T, xs#0) <==> Seq#Length(xs#0) > 0));

procedure {:verboseName "Seq.DropFirst (well-formedness)"} CheckWellformed$$Seq.__default.DropFirst(Seq._default.DropFirst$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.DropFirst$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.DropFirst (well-formedness)"} CheckWellformed$$Seq.__default.DropFirst(Seq._default.DropFirst$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.DropFirst", " | ", Seq._default.DropFirst$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(43,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(xs#0) > 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T));
    assume false;
    return;

  anon4_Else:
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) == Seq#Drop(xs#0, LitInt(1));
    assume true;
    assume $Is(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T));
    return;
}



function Seq.__default.Last(Seq._default.Last$T: Ty, xs#0: Seq) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Last$T: Ty, xs#0: Seq :: { Seq.__default.Last(Seq._default.Last$T, xs#0) } Seq.__default.Last#canCall(Seq._default.Last$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Last$T)) && Seq#Length(xs#0) > 0) ==> $IsBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Last$T: Ty, xs#0: Seq :: { $IsAllocBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T, $Heap) } (Seq.__default.Last#canCall(Seq._default.Last$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Last$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Last$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Last$T: Ty, xs#0: Seq :: { Seq.__default.Last(Seq._default.Last$T, xs#0) } Seq.__default.Last#canCall(Seq._default.Last$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Last$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.Last(Seq._default.Last$T, xs#0) == Seq#Index(xs#0, Seq#Length(xs#0) - 1));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Last$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.Last(Seq._default.Last$T, Lit(xs#0)) } Seq.__default.Last#canCall(Seq._default.Last$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Last$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.Last(Seq._default.Last$T, Lit(xs#0)) == Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1));
}

function Seq.__default.Last#canCall(Seq._default.Last$T: Ty, xs#0: Seq) : bool;

function Seq.__default.Last#requires(Ty, Seq) : bool;

axiom (forall Seq._default.Last$T: Ty, xs#0: Seq :: { Seq.__default.Last#requires(Seq._default.Last$T, xs#0) } $Is(xs#0, TSeq(Seq._default.Last$T)) ==> (Seq.__default.Last#requires(Seq._default.Last$T, xs#0) <==> Seq#Length(xs#0) > 0));

procedure {:verboseName "Seq.Last (well-formedness)"} CheckWellformed$$Seq.__default.Last(Seq._default.Last$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Last$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Last (well-formedness)"} CheckWellformed$$Seq.__default.Last(Seq._default.Last$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.Last", " | ", Seq._default.Last$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(50,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(xs#0) > 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T);
    assume false;
    return;

  anon4_Else:
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 < Seq#Length(xs#0);
    assume Seq.__default.Last(Seq._default.Last$T, xs#0) == Seq#Index(xs#0, Seq#Length(xs#0) - 1);
    assume true;
    assume $IsBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T);
    return;
}



function Seq.__default.DropLast(Seq._default.DropLast$T: Ty, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: { Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) } Seq.__default.DropLast#canCall(Seq._default.DropLast$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropLast$T)) && Seq#Length(xs#0) > 0) ==> $Is(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.DropLast$T: Ty, xs#0: Seq :: { $IsAlloc(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T), $Heap) } (Seq.__default.DropLast#canCall(Seq._default.DropLast$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.DropLast$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: { Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) } Seq.__default.DropLast#canCall(Seq._default.DropLast$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropLast$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) == Seq#Take(xs#0, Seq#Length(xs#0) - 1));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.DropLast(Seq._default.DropLast$T, Lit(xs#0)) } Seq.__default.DropLast#canCall(Seq._default.DropLast$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.DropLast$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.DropLast(Seq._default.DropLast$T, Lit(xs#0)) == Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1));
}

function Seq.__default.DropLast#canCall(Seq._default.DropLast$T: Ty, xs#0: Seq) : bool;

function Seq.__default.DropLast#requires(Ty, Seq) : bool;

axiom (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: { Seq.__default.DropLast#requires(Seq._default.DropLast$T, xs#0) } $Is(xs#0, TSeq(Seq._default.DropLast$T)) ==> (Seq.__default.DropLast#requires(Seq._default.DropLast$T, xs#0) <==> Seq#Length(xs#0) > 0));

procedure {:verboseName "Seq.DropLast (well-formedness)"} CheckWellformed$$Seq.__default.DropLast(Seq._default.DropLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.DropLast$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.DropLast (well-formedness)"} CheckWellformed$$Seq.__default.DropLast(Seq._default.DropLast$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.DropLast", " | ", Seq._default.DropLast$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(58,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(xs#0) > 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T));
    assume false;
    return;

  anon4_Else:
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    assume Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) == Seq#Take(xs#0, Seq#Length(xs#0) - 1);
    assume true;
    assume $Is(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T));
    return;
}



procedure {:verboseName "Seq.LemmaLast (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaLast$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaLast (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaLast", " | ", Seq._default.LemmaLast$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(67,8): initial state"} true;
    assume Seq#Length(xs#0) > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(69,38): post-state"} true;
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.LemmaLast$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#0) > 0;
    assume Seq#Length(##xs#0) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaLast$T, xs#0);
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.LemmaLast$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1) > 0;
    assume Seq#Length(##xs#1) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaLast$T, xs#0);
    assume Seq#Equal(Seq#Append(Seq.__default.DropLast(Seq._default.LemmaLast$T, xs#0), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(Seq._default.LemmaLast$T, xs#0))), xs#0);
    return;
}



procedure {:verboseName "Seq.LemmaLast (call precondtion)"} CallPre$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaLast$T), $Heap));
  requires {:id "id5765"} Seq#Length(xs#0) > 0;



procedure {:verboseName "Seq.LemmaLast (call postcondition)"} CallPost$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaLast$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.DropLast#canCall(Seq._default.LemmaLast$T, xs#0) && Seq.__default.Last#canCall(Seq._default.LemmaLast$T, xs#0);
  free ensures {:id "id5766"} Seq#Equal(Seq#Append(Seq.__default.DropLast(Seq._default.LemmaLast$T, xs#0), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(Seq._default.LemmaLast$T, xs#0))), xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaLast (correctness)"} Impl$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaLast$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id5767"} Seq#Length(xs#0) > 0;
  modifies $Heap;
  free ensures Seq.__default.DropLast#canCall(Seq._default.LemmaLast$T, xs#0) && Seq.__default.Last#canCall(Seq._default.LemmaLast$T, xs#0);
  free ensures {:id "id5768"} Seq#Equal(Seq#Append(Seq.__default.DropLast(Seq._default.LemmaLast$T, xs#0), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(Seq._default.LemmaLast$T, xs#0))), xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaLast (correctness)"} Impl$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaLast", " | ", Seq._default.LemmaLast$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(70,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Seq.LemmaAppendLast (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaAppendLast (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaAppendLast", " | ", Seq._default.LemmaAppendLast$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(75,8): initial state"} true;
    assume 0 < Seq#Length(ys#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(77,26): post-state"} true;
    ##xs#0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#0) > 0;
    assume Seq#Length(##xs#0) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaAppendLast$T, Seq#Append(xs#0, ys#0));
    ##xs#1 := ys#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.LemmaAppendLast$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1) > 0;
    assume Seq#Length(##xs#1) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaAppendLast$T, ys#0);
    assume Seq.__default.Last(Seq._default.LemmaAppendLast$T, Seq#Append(xs#0, ys#0)) == Seq.__default.Last(Seq._default.LemmaAppendLast$T, ys#0);
    return;
}



procedure {:verboseName "Seq.LemmaAppendLast (call precondtion)"} CallPre$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap));
  requires {:id "id5773"} 0 < Seq#Length(ys#0);



procedure {:verboseName "Seq.LemmaAppendLast (call postcondition)"} CallPost$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Last#canCall(Seq._default.LemmaAppendLast$T, Seq#Append(xs#0, ys#0)) && Seq.__default.Last#canCall(Seq._default.LemmaAppendLast$T, ys#0);
  free ensures {:id "id5774"} Seq.__default.Last(Seq._default.LemmaAppendLast$T, Seq#Append(xs#0, ys#0)) == Seq.__default.Last(Seq._default.LemmaAppendLast$T, ys#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaAppendLast (correctness)"} Impl$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaAppendLast$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaAppendLast$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id5775"} 0 < Seq#Length(ys#0);
  modifies $Heap;
  free ensures Seq.__default.Last#canCall(Seq._default.LemmaAppendLast$T, Seq#Append(xs#0, ys#0)) && Seq.__default.Last#canCall(Seq._default.LemmaAppendLast$T, ys#0);
  free ensures {:id "id5776"} Seq.__default.Last(Seq._default.LemmaAppendLast$T, Seq#Append(xs#0, ys#0)) == Seq.__default.Last(Seq._default.LemmaAppendLast$T, ys#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaAppendLast (correctness)"} Impl$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaAppendLast", " | ", Seq._default.LemmaAppendLast$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(78,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Seq.LemmaConcatIsAssociative (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), zs#0: Seq where $Is(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaConcatIsAssociative (call precondtion)"} CallPre$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), zs#0: Seq where $Is(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap));



procedure {:verboseName "Seq.LemmaConcatIsAssociative (call postcondition)"} CallPost$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), zs#0: Seq where $Is(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5778"} Seq#Equal(Seq#Append(xs#0, Seq#Append(ys#0, zs#0)), Seq#Append(Seq#Append(xs#0, ys#0), zs#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaConcatIsAssociative (correctness)"} Impl$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap), zs#0: Seq where $Is(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T)) && $IsAlloc(zs#0, TSeq(Seq._default.LemmaConcatIsAssociative$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5779"} Seq#Equal(Seq#Append(xs#0, Seq#Append(ys#0, zs#0)), Seq#Append(Seq#Append(xs#0, ys#0), zs#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaConcatIsAssociative (correctness)"} Impl$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T: Ty, xs#0: Seq, ys#0: Seq, zs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaConcatIsAssociative", " | ", Seq._default.LemmaConcatIsAssociative$T, " | ", xs#0, " | ", ys#0, " | ", zs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(84,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Seq.IndexingImpliesMembership (well-formedness)"} CheckWellFormed$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T)) && $IsAlloc(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.IndexingImpliesMembership (well-formedness)"} CheckWellFormed$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType, xs#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var t#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.IndexingImpliesMembership", " | ", Seq._default.IndexingImpliesMembership$T, " | ", p#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(97,8): initial state"} true;
    havoc i#0;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon11_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#0))): bool;
    goto anon6;

  anon10_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#0))): bool;
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#1))): bool);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(99,12): post-state"} true;
    havoc t#0;
    assume $IsBox(t#0, Seq._default.IndexingImpliesMembership$T) && $IsAllocBox(t#0, Seq._default.IndexingImpliesMembership$T, $Heap);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Seq#Contains(xs#0, t#0);
    assume $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#0)): bool;
    goto anon9;

  anon12_Else:
    assume Seq#Contains(xs#0, t#0) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#0)): bool;
    goto anon9;

  anon9:
    assume (forall t#1: Box :: { $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#1)): bool } { Seq#Contains(xs#0, t#1) } $IsBox(t#1, Seq._default.IndexingImpliesMembership$T) && Seq#Contains(xs#0, t#1) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#1)): bool);
    return;
}



procedure {:verboseName "Seq.IndexingImpliesMembership (call precondtion)"} CallPre$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T)) && $IsAlloc(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T), $Heap));
  requires {:id "id5789"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#1))): bool);



procedure {:verboseName "Seq.IndexingImpliesMembership (call postcondition)"} CallPost$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T)) && $IsAlloc(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5790"} (forall t#1: Box :: { $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#1)): bool } { Seq#Contains(xs#0, t#1) } $IsBox(t#1, Seq._default.IndexingImpliesMembership$T) && Seq#Contains(xs#0, t#1) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#1)): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.IndexingImpliesMembership (correctness)"} Impl$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.IndexingImpliesMembership$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T)) && $IsAlloc(xs#0, TSeq(Seq._default.IndexingImpliesMembership$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id5791"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#1))): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5792"} (forall t#1: Box :: { $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#1)): bool } { Seq#Contains(xs#0, t#1) } $IsBox(t#1, Seq._default.IndexingImpliesMembership$T) && Seq#Contains(xs#0, t#1) ==> $Unbox(Apply1(Seq._default.IndexingImpliesMembership$T, TBool, $Heap, p#0, t#1)): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.IndexingImpliesMembership (correctness)"} Impl$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.IndexingImpliesMembership", " | ", Seq._default.IndexingImpliesMembership$T, " | ", p#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(100,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Seq.MembershipImpliesIndexing (well-formedness)"} CheckWellFormed$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.MembershipImpliesIndexing (well-formedness)"} CheckWellFormed$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType, xs#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var t#0: Box;
  var i#0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.MembershipImpliesIndexing", " | ", Seq._default.MembershipImpliesIndexing$T, " | ", p#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(107,8): initial state"} true;
    havoc t#0;
    assume $IsBox(t#0, Seq._default.MembershipImpliesIndexing$T) && $IsAllocBox(t#0, Seq._default.MembershipImpliesIndexing$T, $Heap);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(xs#0, t#0);
    assume $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#0)): bool;
    goto anon4;

  anon10_Else:
    assume Seq#Contains(xs#0, t#0) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#0)): bool;
    goto anon4;

  anon4:
    assume (forall t#1: Box :: { $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#1)): bool } { Seq#Contains(xs#0, t#1) } $IsBox(t#1, Seq._default.MembershipImpliesIndexing$T) && Seq#Contains(xs#0, t#1) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#1)): bool);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(109,12): post-state"} true;
    havoc i#0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon7;

  anon12_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon7;

  anon7:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#0))): bool;
    goto anon9;

  anon11_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#0))): bool;
    goto anon9;

  anon9:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#1))): bool);
    return;
}



procedure {:verboseName "Seq.MembershipImpliesIndexing (call precondtion)"} CallPre$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T), $Heap));
  requires {:id "id5802"} (forall t#1: Box :: { $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#1)): bool } { Seq#Contains(xs#0, t#1) } $IsBox(t#1, Seq._default.MembershipImpliesIndexing$T) && Seq#Contains(xs#0, t#1) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#1)): bool);



procedure {:verboseName "Seq.MembershipImpliesIndexing (call postcondition)"} CallPost$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5803"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#1))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.MembershipImpliesIndexing (correctness)"} Impl$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Seq._default.MembershipImpliesIndexing$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MembershipImpliesIndexing$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id5804"} (forall t#1: Box :: { $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#1)): bool } { Seq#Contains(xs#0, t#1) } $IsBox(t#1, Seq._default.MembershipImpliesIndexing$T) && Seq#Contains(xs#0, t#1) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, t#1)): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5805"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> $Unbox(Apply1(Seq._default.MembershipImpliesIndexing$T, TBool, $Heap, p#0, Seq#Index(xs#0, i#1))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.MembershipImpliesIndexing (correctness)"} Impl$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.MembershipImpliesIndexing", " | ", Seq._default.MembershipImpliesIndexing$T, " | ", p#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(110,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Seq.__default.IsPrefix(Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) } Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, xs#0, ys#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T))) ==> Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) ==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Take(ys#0, Seq#Length(xs#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) } Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, xs#0, ys#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T))) ==> (Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#SameUntil(xs#0, ys#0, Seq#Length(xs#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: {:weight 3} { Seq.__default.IsPrefix(Seq._default.IsPrefix$T, Lit(xs#0), Lit(ys#0)) } Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, Lit(xs#0), Lit(ys#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T))) ==> (Seq.__default.IsPrefix(Seq._default.IsPrefix$T, Lit(xs#0), Lit(ys#0)) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#SameUntil(xs#0, ys#0, Seq#Length(xs#0))));
}

function Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq) : bool;

function Seq.__default.IsPrefix#requires(Ty, Seq, Seq) : bool;

axiom (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsPrefix#requires(Seq._default.IsPrefix$T, xs#0, ys#0) } $Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T)) ==> (Seq.__default.IsPrefix#requires(Seq._default.IsPrefix$T, xs#0, ys#0) <==> true));

procedure {:verboseName "Seq.IsPrefix (well-formedness)"} CheckWellformed$$Seq.__default.IsPrefix(Seq._default.IsPrefix$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IsPrefix$T)), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.IsPrefix$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id5806"} Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) ==> Seq#Length(xs#0) <= Seq#Length(ys#0);
  free ensures {:id "id5807"} Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) ==> Seq#Equal(xs#0, Seq#Take(ys#0, Seq#Length(xs#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.IsPrefix (well-formedness)"} CheckWellformed$$Seq.__default.IsPrefix(Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##ys#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.IsPrefix", " | ", Seq._default.IsPrefix$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(114,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.IsPrefix$T), $Heap);
    ##ys#0 := ys#0;
    assume $IsAlloc(##ys#0, TSeq(Seq._default.IsPrefix$T), $Heap);
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq#Rank(##xs#0) < Seq#Rank(xs#0) || (Seq#Rank(##xs#0) == Seq#Rank(xs#0) && Seq#Rank(##ys#0) < Seq#Rank(ys#0));
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, xs#0, ys#0);
    assume Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(xs#0) <= Seq#Length(ys#0);
    assume 0 <= Seq#Length(xs#0) && Seq#Length(xs#0) <= Seq#Length(ys#0);
    goto anon5;

  anon11_Else:
    assume {:partition} Seq#Length(ys#0) < Seq#Length(xs#0);
    goto anon5;

  anon5:
    assume Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Take(ys#0, Seq#Length(xs#0)));
    goto anon7;

  anon10_Else:
    assume Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) ==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Take(ys#0, Seq#Length(xs#0)));
    goto anon7;

  anon7:
    assume false;
    return;

  anon9_Else:
    assume Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#SameUntil(xs#0, ys#0, Seq#Length(xs#0));
    assume true;
    assume $Is(Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0), TBool);
    return;
}



function Seq.__default.IsSuffix(Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsSuffix(Seq._default.IsSuffix$T, xs#0, ys#0) } Seq.__default.IsSuffix#canCall(Seq._default.IsSuffix$T, xs#0, ys#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IsSuffix$T)) && $Is(ys#0, TSeq(Seq._default.IsSuffix$T))) ==> (Seq.__default.IsSuffix(Seq._default.IsSuffix$T, xs#0, ys#0) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Drop(ys#0, Seq#Length(ys#0) - Seq#Length(xs#0)))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq :: {:weight 3} { Seq.__default.IsSuffix(Seq._default.IsSuffix$T, Lit(xs#0), Lit(ys#0)) } Seq.__default.IsSuffix#canCall(Seq._default.IsSuffix$T, Lit(xs#0), Lit(ys#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IsSuffix$T)) && $Is(ys#0, TSeq(Seq._default.IsSuffix$T))) ==> (Seq.__default.IsSuffix(Seq._default.IsSuffix$T, Lit(xs#0), Lit(ys#0)) <==> Seq#Length(Lit(xs#0)) <= Seq#Length(Lit(ys#0)) && Seq#Equal(xs#0, Seq#Drop(Lit(ys#0), Seq#Length(Lit(ys#0)) - Seq#Length(Lit(xs#0))))));
}

function Seq.__default.IsSuffix#canCall(Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq) : bool;

function Seq.__default.IsSuffix#requires(Ty, Seq, Seq) : bool;

axiom (forall Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsSuffix#requires(Seq._default.IsSuffix$T, xs#0, ys#0) } $Is(xs#0, TSeq(Seq._default.IsSuffix$T)) && $Is(ys#0, TSeq(Seq._default.IsSuffix$T)) ==> (Seq.__default.IsSuffix#requires(Seq._default.IsSuffix$T, xs#0, ys#0) <==> true));

procedure {:verboseName "Seq.IsSuffix (well-formedness)"} CheckWellformed$$Seq.__default.IsSuffix(Seq._default.IsSuffix$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IsSuffix$T)), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.IsSuffix$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.IsSuffix (well-formedness)"} CheckWellformed$$Seq.__default.IsSuffix(Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.IsSuffix", " | ", Seq._default.IsSuffix$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(121,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(xs#0) <= Seq#Length(ys#0);
    assume 0 <= Seq#Length(ys#0) - Seq#Length(xs#0) && Seq#Length(ys#0) - Seq#Length(xs#0) <= Seq#Length(ys#0);
    goto anon5;

  anon7_Else:
    assume {:partition} Seq#Length(ys#0) < Seq#Length(xs#0);
    goto anon5;

  anon5:
    assume Seq.__default.IsSuffix(Seq._default.IsSuffix$T, xs#0, ys#0) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Drop(ys#0, Seq#Length(ys#0) - Seq#Length(xs#0)));
    assume true;
    assume $Is(Seq.__default.IsSuffix(Seq._default.IsSuffix$T, xs#0, ys#0), TBool);
    return;
}



procedure {:verboseName "Seq.LemmaSplitAt (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSplitAt$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSplitAt$T), $Heap), pos#0: int where LitInt(0) <= pos#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSplitAt (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq, pos#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSplitAt", " | ", Seq._default.LemmaSplitAt$T, " | ", xs#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(130,8): initial state"} true;
    assume pos#0 < Seq#Length(xs#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(132,34): post-state"} true;
    assume 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume Seq#Equal(Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0)), xs#0);
    return;
}



procedure {:verboseName "Seq.LemmaSplitAt (call precondtion)"} CallPre$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSplitAt$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSplitAt$T), $Heap), pos#0: int where LitInt(0) <= pos#0);
  requires {:id "id5820"} pos#0 < Seq#Length(xs#0);



procedure {:verboseName "Seq.LemmaSplitAt (call postcondition)"} CallPost$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSplitAt$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSplitAt$T), $Heap), pos#0: int where LitInt(0) <= pos#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5821"} Seq#Equal(Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0)), xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaSplitAt (correctness)"} Impl$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSplitAt$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSplitAt$T), $Heap), pos#0: int where LitInt(0) <= pos#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id5822"} pos#0 < Seq#Length(xs#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5823"} Seq#Equal(Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0)), xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSplitAt (correctness)"} Impl$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq, pos#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSplitAt", " | ", Seq._default.LemmaSplitAt$T, " | ", xs#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(133,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Seq.LemmaElementFromSlice (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), xs'#0: Seq where $Is(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), a#0: int, b#0: int, pos#0: int where LitInt(0) <= pos#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaElementFromSlice (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq, xs'#0: Seq, a#0: int, b#0: int, pos#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaElementFromSlice", " | ", Seq._default.LemmaElementFromSlice$T, " | ", xs#0, " | ", xs'#0, " | ", a#0, " | ", b#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(137,8): initial state"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= a#0;
    goto anon3;

  anon8_Else:
    assume {:partition} a#0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= a#0 && a#0 <= b#0;
    goto anon5;

  anon9_Else:
    assume {:partition} !(LitInt(0) <= a#0 && a#0 <= b#0);
    goto anon5;

  anon5:
    assume LitInt(0) <= a#0 && a#0 <= b#0 && b#0 <= Seq#Length(xs#0);
    assume 0 <= a#0 && a#0 <= Seq#Length(xs#0);
    assume a#0 <= b#0 && b#0 <= Seq#Length(xs#0);
    assume Seq#Equal(xs'#0, Seq#Drop(Seq#Take(xs#0, b#0), a#0));
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} a#0 <= pos#0;
    goto anon7;

  anon10_Else:
    assume {:partition} pos#0 < a#0;
    goto anon7;

  anon7:
    assume a#0 <= pos#0 && pos#0 < b#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(141,21): post-state"} true;
    assume pos#0 - a#0 < Seq#Length(xs'#0);
    assume 0 <= pos#0 - a#0 && pos#0 - a#0 < Seq#Length(xs'#0);
    assume 0 <= pos#0 && pos#0 < Seq#Length(xs#0);
    assume Seq#Index(xs'#0, pos#0 - a#0) == Seq#Index(xs#0, pos#0);
    return;
}



procedure {:verboseName "Seq.LemmaElementFromSlice (call precondtion)"} CallPre$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), xs'#0: Seq where $Is(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), a#0: int, b#0: int, pos#0: int where LitInt(0) <= pos#0);
  requires {:id "id5833"} LitInt(0) <= a#0;
  requires {:id "id5834"} a#0 <= b#0;
  requires {:id "id5835"} b#0 <= Seq#Length(xs#0);
  requires {:id "id5836"} Seq#Equal(xs'#0, Seq#Drop(Seq#Take(xs#0, b#0), a#0));
  requires {:id "id5837"} a#0 <= pos#0;
  requires {:id "id5838"} pos#0 < b#0;



procedure {:verboseName "Seq.LemmaElementFromSlice (call postcondition)"} CallPost$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), xs'#0: Seq where $Is(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), a#0: int, b#0: int, pos#0: int where LitInt(0) <= pos#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5839"} pos#0 - a#0 < Seq#Length(xs'#0);
  free ensures true;
  free ensures {:id "id5840"} Seq#Index(xs'#0, pos#0 - a#0) == Seq#Index(xs#0, pos#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaElementFromSlice (correctness)"} Impl$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), xs'#0: Seq where $Is(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T)) && $IsAlloc(xs'#0, TSeq(Seq._default.LemmaElementFromSlice$T), $Heap), a#0: int, b#0: int, pos#0: int where LitInt(0) <= pos#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id5841"} LitInt(0) <= a#0;
  requires {:id "id5842"} a#0 <= b#0;
  requires {:id "id5843"} b#0 <= Seq#Length(xs#0);
  requires {:id "id5844"} Seq#Equal(xs'#0, Seq#Drop(Seq#Take(xs#0, b#0), a#0));
  requires {:id "id5845"} a#0 <= pos#0;
  requires {:id "id5846"} pos#0 < b#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5847"} pos#0 - a#0 < Seq#Length(xs'#0);
  free ensures true;
  free ensures {:id "id5848"} Seq#Index(xs'#0, pos#0 - a#0) == Seq#Index(xs#0, pos#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaElementFromSlice (correctness)"} Impl$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq, xs'#0: Seq, a#0: int, b#0: int, pos#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaElementFromSlice", " | ", Seq._default.LemmaElementFromSlice$T, " | ", xs#0, " | ", xs'#0, " | ", a#0, " | ", b#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(143,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Seq.LemmaSliceOfSlice (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap), s1#0: int, e1#0: int, s2#0: int, e2#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSliceOfSlice (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq, s1#0: int, e1#0: int, s2#0: int, e2#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSliceOfSlice", " | ", Seq._default.LemmaSliceOfSlice$T, " | ", xs#0, " | ", s1#0, " | ", e1#0, " | ", s2#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(148,8): initial state"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= s1#0;
    goto anon3;

  anon10_Else:
    assume {:partition} s1#0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= s1#0 && s1#0 <= e1#0;
    goto anon5;

  anon11_Else:
    assume {:partition} !(LitInt(0) <= s1#0 && s1#0 <= e1#0);
    goto anon5;

  anon5:
    assume LitInt(0) <= s1#0 && s1#0 <= e1#0 && e1#0 <= Seq#Length(xs#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= s2#0;
    goto anon7;

  anon12_Else:
    assume {:partition} s2#0 < LitInt(0);
    goto anon7;

  anon7:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= s2#0 && s2#0 <= e2#0;
    goto anon9;

  anon13_Else:
    assume {:partition} !(LitInt(0) <= s2#0 && s2#0 <= e2#0);
    goto anon9;

  anon9:
    assume LitInt(0) <= s2#0 && s2#0 <= e2#0 && e2#0 <= e1#0 - s1#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(151,32): post-state"} true;
    assume 0 <= s1#0 && s1#0 <= Seq#Length(xs#0);
    assume s1#0 <= e1#0 && e1#0 <= Seq#Length(xs#0);
    assume 0 <= s2#0 && s2#0 <= Seq#Length(Seq#Drop(Seq#Take(xs#0, e1#0), s1#0));
    assume s2#0 <= e2#0 && e2#0 <= Seq#Length(Seq#Drop(Seq#Take(xs#0, e1#0), s1#0));
    assume 0 <= s1#0 + s2#0 && s1#0 + s2#0 <= Seq#Length(xs#0);
    assume s1#0 + s2#0 <= s1#0 + e2#0 && s1#0 + e2#0 <= Seq#Length(xs#0);
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(xs#0, e1#0), s1#0), e2#0), s2#0), Seq#Drop(Seq#Take(xs#0, s1#0 + e2#0), s1#0 + s2#0));
    return;
}



procedure {:verboseName "Seq.LemmaSliceOfSlice (call precondtion)"} CallPre$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap), s1#0: int, e1#0: int, s2#0: int, e2#0: int);
  requires {:id "id5858"} LitInt(0) <= s1#0;
  requires {:id "id5859"} s1#0 <= e1#0;
  requires {:id "id5860"} e1#0 <= Seq#Length(xs#0);
  requires {:id "id5861"} LitInt(0) <= s2#0;
  requires {:id "id5862"} s2#0 <= e2#0;
  requires {:id "id5863"} e2#0 <= e1#0 - s1#0;



procedure {:verboseName "Seq.LemmaSliceOfSlice (call postcondition)"} CallPost$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap), s1#0: int, e1#0: int, s2#0: int, e2#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5864"} Seq#Equal(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(xs#0, e1#0), s1#0), e2#0), s2#0), Seq#Drop(Seq#Take(xs#0, s1#0 + e2#0), s1#0 + s2#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaSliceOfSlice (correctness)"} Impl$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap), s1#0: int, e1#0: int, s2#0: int, e2#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id5865"} LitInt(0) <= s1#0;
  requires {:id "id5866"} s1#0 <= e1#0;
  requires {:id "id5867"} e1#0 <= Seq#Length(xs#0);
  requires {:id "id5868"} LitInt(0) <= s2#0;
  requires {:id "id5869"} s2#0 <= e2#0;
  requires {:id "id5870"} e2#0 <= e1#0 - s1#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5871"} Seq#Equal(Seq#Drop(Seq#Take(Seq#Drop(Seq#Take(xs#0, e1#0), s1#0), e2#0), s2#0), Seq#Drop(Seq#Take(xs#0, s1#0 + e2#0), s1#0 + s2#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSliceOfSlice (correctness)"} Impl$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq, s1#0: int, e1#0: int, s2#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var r1#0: Seq where $Is(r1#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(r1#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap);
  var r2#0: Seq where $Is(r2#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(r2#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap);
  var r3#0: Seq where $Is(r3#0, TSeq(Seq._default.LemmaSliceOfSlice$T)) && $IsAlloc(r3#0, TSeq(Seq._default.LemmaSliceOfSlice$T), $Heap);
  var i#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSliceOfSlice", " | ", Seq._default.LemmaSliceOfSlice$T, " | ", xs#0, " | ", s1#0, " | ", e1#0, " | ", s2#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(152,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume 0 <= s1#0 && s1#0 <= Seq#Length(xs#0);
    assume s1#0 <= e1#0 && e1#0 <= Seq#Length(xs#0);
    assume true;
    r1#0 := Seq#Drop(Seq#Take(xs#0, e1#0), s1#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(153,24)"} true;
    assume true;
    assume 0 <= s2#0 && s2#0 <= Seq#Length(r1#0);
    assume s2#0 <= e2#0 && e2#0 <= Seq#Length(r1#0);
    assume true;
    r2#0 := Seq#Drop(Seq#Take(r1#0, e2#0), s2#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(154,24)"} true;
    assume true;
    assume 0 <= s1#0 + s2#0 && s1#0 + s2#0 <= Seq#Length(xs#0);
    assume s1#0 + s2#0 <= s1#0 + e2#0 && s1#0 + e2#0 <= Seq#Length(xs#0);
    assume true;
    r3#0 := Seq#Drop(Seq#Take(xs#0, s1#0 + e2#0), s1#0 + s2#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(155,30)"} true;
    assume true;
    assume Seq#Length(r2#0) == Seq#Length(r3#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(156,23)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc i#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= i#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} i#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(r2#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < Seq#Length(r2#0);
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < Seq#Length(r3#0);
    assume true;
    assume Seq#Index(r2#0, i#0_0) == Seq#Index(r3#0, i#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume Seq#Index(r2#0, i#0_0) == Seq#Index(r3#0, i#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall i#0_1: int :: { Seq#Index(r2#0, i#0_1), Seq#Index(r3#0, i#0_1) } LitInt(0) <= i#0_1 && i#0_1 < Seq#Length(r2#0) ==> Seq#Index(r2#0, i#0_1) == Seq#Index(r3#0, i#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(159,4)"} true;
    return;
}



procedure {:verboseName "Seq.ToArray (well-formedness)"} CheckWellFormed$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.ToArray$T)) && $IsAlloc(xs#0, TSeq(Seq._default.ToArray$T), $Heap)) returns (a#0: ref where $Is(a#0, Tclass._System.array(Seq._default.ToArray$T)) && $IsAlloc(a#0, Tclass._System.array(Seq._default.ToArray$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.ToArray (well-formedness)"} CheckWellFormed$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq) returns (a#0: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.ToArray", " | ", Seq._default.ToArray$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(163,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc a#0;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(164,12): post-state"} true;
    assume a#0 != null && !$Unbox(read(old($Heap), a#0, alloc)): bool;
    assume a#0 != null;
    assume _System.array.Length(a#0) == Seq#Length(xs#0);
    havoc i#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon8_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume a#0 != null;
    assume 0 <= i#0 && i#0 < _System.array.Length(a#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume read($Heap, a#0, IndexField(i#0)) == Seq#Index(xs#0, i#0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> read($Heap, a#0, IndexField(i#0)) == Seq#Index(xs#0, i#0);
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } { read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> read($Heap, a#0, IndexField(i#1)) == Seq#Index(xs#0, i#1));
    return;
}



procedure {:verboseName "Seq.ToArray (call precondtion)"} CallPre$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.ToArray$T)) && $IsAlloc(xs#0, TSeq(Seq._default.ToArray$T), $Heap));



procedure {:verboseName "Seq.ToArray (call postcondition)"} CallPost$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.ToArray$T)) && $IsAlloc(xs#0, TSeq(Seq._default.ToArray$T), $Heap)) returns (a#0: ref where $Is(a#0, Tclass._System.array(Seq._default.ToArray$T)) && $IsAlloc(a#0, Tclass._System.array(Seq._default.ToArray$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5897"} a#0 != null && !$Unbox(read(old($Heap), a#0, alloc)): bool;
  free ensures true;
  free ensures {:id "id5898"} _System.array.Length(a#0) == Seq#Length(xs#0);
  free ensures true;
  free ensures {:id "id5899"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } { read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> read($Heap, a#0, IndexField(i#1)) == Seq#Index(xs#0, i#1));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Seq.ToArray (correctness)"} Impl$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.ToArray$T)) && $IsAlloc(xs#0, TSeq(Seq._default.ToArray$T), $Heap)) returns (defass#a#0: bool, a#0: ref where defass#a#0 ==> $Is(a#0, Tclass._System.array(Seq._default.ToArray$T)) && $IsAlloc(a#0, Tclass._System.array(Seq._default.ToArray$T), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id5900"} a#0 != null && !$Unbox(read(old($Heap), a#0, alloc)): bool;
  free ensures true;
  free ensures {:id "id5901"} _System.array.Length(a#0) == Seq#Length(xs#0);
  free ensures true;
  free ensures {:id "id5902"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } { read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> read($Heap, a#0, IndexField(i#1)) == Seq#Index(xs#0, i#1));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.ToArray (correctness)"} Impl$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq) returns (defass#a#0: bool, a#0: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var i#2: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Box;
  var $nw: ref;

  anon0:
    assume {:print "Impl", " | ", "Seq.ToArray", " | ", Seq._default.ToArray$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(167,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume 0 <= Seq#Length(xs#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#2;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon4;

  anon10_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0);
    assume 0 <= i#2 && i#2 < Seq#Length(xs#0);
    assume lambdaResult#0 == Seq#Index(xs#0, i#2);
    assume true;
    assume $IsBox(lambdaResult#0, Seq._default.ToArray$T);
    goto anon6;

  anon11_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0));
    goto anon6;

  anon9_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon8_Else:
    goto anon7;

  anon7:
    havoc $nw;
    assume $nw != null && $Is($nw, Tclass._System.array?(Seq._default.ToArray$T));
    assume !$Unbox(read($Heap, $nw, alloc)): bool;
    assume _System.array.Length($nw) == Seq#Length(xs#0);
    assume {:subsumption 0} (forall arrayinit#0#i0#0: int :: 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < Seq#Length(xs#0) ==> Requires1(TInt, Seq._default.ToArray$T, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: Seq#Index(xs#0, $Unbox($l#0#i#0): int)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(xs#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    assume (forall arrayinit#0#i0#0: int :: { read($Heap, $nw, IndexField(arrayinit#0#i0#0)) } 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < Seq#Length(xs#0) ==> read($Heap, $nw, IndexField(arrayinit#0#i0#0)) == Apply1(TInt, Seq._default.ToArray$T, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: Seq#Index(xs#0, $Unbox($l#0#i#0): int)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(xs#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    $Heap := update($Heap, $nw, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    a#0 := $nw;
    defass#a#0 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(168,55)"} true;
    assume defass#a#0;
    return;
}



function Seq.__default.ToSet(Seq._default.ToSet$T: Ty, $reveal: bool, xs#0: Seq) : Set
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.ToSet$T: Ty, $reveal: bool, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.ToSet$T))) ==> $Is(Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0), TSet(Seq._default.ToSet$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.ToSet$T: Ty, $reveal: bool, xs#0: Seq :: { $IsAlloc(Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0), TSet(Seq._default.ToSet$T), $Heap) } (Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.ToSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.ToSet$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0), TSet(Seq._default.ToSet$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.ToSet$T))) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#0: Box :: $IsBox($y#0, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.ToSet$T))) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#1: Box :: $IsBox($y#1, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#1)));
}

function Seq.__default.ToSet#canCall(Seq._default.ToSet$T: Ty, xs#0: Seq) : bool;

function Seq.__default.ToSet#requires(Ty, Seq) : bool;

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet#requires(Seq._default.ToSet$T, xs#0) } $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> (Seq.__default.ToSet#requires(Seq._default.ToSet$T, xs#0) <==> true));

procedure {:verboseName "Seq.ToSet (well-formedness)"} CheckWellformed$$Seq.__default.ToSet(Seq._default.ToSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.ToSet$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfSet (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfSet (call precondtion)"} CallPre$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap));



procedure {:verboseName "Seq.LemmaCardinalityOfSet (call postcondition)"} CallPost$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
  free ensures {:id "id5911"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0)) <= Seq#Length(xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfSet (correctness)"} Impl$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
  free ensures {:id "id5912"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0)) <= Seq#Length(xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaCardinalityOfSet (correctness)"} Impl$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#1_0: Seq;
  var ##xs#1_1: Seq;
  var ##xs#1_2: Seq;
  var ##xs#1_3: Seq;
  var xs##1_0: Seq;
  var ##xs#1_4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaCardinalityOfSet", " | ", Seq._default.LemmaCardinalityOfSet$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(181,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__ToSet();
    call CallPost$$Seq.__default.reveal__ToSet();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(182,17)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    ##xs#1_0 := xs#0;
    assume $IsAlloc(##xs#1_0, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    ##xs#1_1 := xs#0;
    assume $IsAlloc(##xs#1_1, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_1) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    ##xs#1_2 := Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    assume $IsAlloc(##xs#1_2, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSet$T, Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSet$T, xs#0));
    ##xs#1_3 := xs#0;
    assume $IsAlloc(##xs#1_3, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_3) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0) && Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0) && Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSet$T, Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSet$T, xs#0)) && Seq.__default.Last#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    assume Set#Equal(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0), Set#Union(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSet$T, reveal_Seq._default.ToSet, Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSet$T, xs#0)), Set#UnionOne(Set#Empty(): Set, Seq.__default.Last(Seq._default.LemmaCardinalityOfSet$T, xs#0))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(185,58)"} true;
    ##xs#1_4 := xs#0;
    assume $IsAlloc(##xs#1_4, TSeq(Seq._default.LemmaCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_4) > 0;
    assume Seq#Length(##xs#1_4) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    xs##1_0 := Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0);
    call CallPre$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T, xs##1_0);
    call CallPost$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T, xs##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(186,41)"} true;
    return;
}



procedure {:verboseName "Seq.LemmaCardinalityOfEmptySetIs0 (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfEmptySetIs0 (call precondtion)"} CallPre$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T), $Heap));



procedure {:verboseName "Seq.LemmaCardinalityOfEmptySetIs0 (call postcondition)"} CallPost$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfEmptySetIs0$T, xs#0);
  free ensures {:id "id5923"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfEmptySetIs0$T, reveal_Seq._default.ToSet, xs#0)) == LitInt(0) <==> Seq#Length(xs#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfEmptySetIs0 (correctness)"} Impl$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfEmptySetIs0$T, xs#0);
  free ensures {:id "id5924"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfEmptySetIs0$T, reveal_Seq._default.ToSet, xs#0)) == LitInt(0) <==> Seq#Length(xs#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaCardinalityOfEmptySetIs0 (correctness)"} Impl$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaCardinalityOfEmptySetIs0", " | ", Seq._default.LemmaCardinalityOfEmptySetIs0$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(194,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__ToSet();
    call CallPost$$Seq.__default.reveal__ToSet();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(195,17)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(xs#0) != 0;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##xs#0_0 := xs#0;
    assume $IsAlloc(##xs#0_0, TSeq(Seq._default.LemmaCardinalityOfEmptySetIs0$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfEmptySetIs0$T, xs#0);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfEmptySetIs0$T, xs#0);
    assume Seq.__default.ToSet(Seq._default.LemmaCardinalityOfEmptySetIs0$T, reveal_Seq._default.ToSet, xs#0)[Seq#Index(xs#0, LitInt(0))];
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(197,31)"} true;
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) == 0;
    return;
}



function Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T: Ty, $reveal: bool, xs#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T))) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#0: int, j#0: int :: { Seq#Index(xs#0, j#0), Seq#Index(xs#0, i#0) } LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && LitInt(0) <= j#0 && j#0 < Seq#Length(xs#0) && i#0 != j#0 ==> Seq#Index(xs#0, i#0) != Seq#Index(xs#0, j#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T))) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#1: int, j#1: int :: { Seq#Index(xs#0, j#1), Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#1 && j#1 < Seq#Length(Lit(xs#0)) && i#1 != j#1 ==> Seq#Index(Lit(xs#0), i#1) != Seq#Index(Lit(xs#0), j#1))));
}

function Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq) : bool;

function Seq.__default.HasNoDuplicates#requires(Ty, Seq) : bool;

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates#requires(Seq._default.HasNoDuplicates$T, xs#0) } $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates#requires(Seq._default.HasNoDuplicates$T, xs#0) <==> true));

procedure {:verboseName "Seq.HasNoDuplicates (well-formedness)"} CheckWellformed$$Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.HasNoDuplicates (well-formedness)"} CheckWellformed$$Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var j#2: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.HasNoDuplicates", " | ", Seq._default.HasNoDuplicates$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(202,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume false;
    return;

  anon14_Else:
    havoc i#2;
    havoc j#2;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon6;

  anon16_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon6;

  anon6:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= j#2;
    goto anon9;

  anon18_Else:
    assume {:partition} j#2 < LitInt(0);
    goto anon9;

  anon17_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0));
    goto anon9;

  anon9:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) && LitInt(0) <= j#2 && j#2 < Seq#Length(xs#0);
    goto anon11;

  anon19_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) && LitInt(0) <= j#2 && j#2 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) && LitInt(0) <= j#2 && j#2 < Seq#Length(xs#0) && i#2 != j#2;
    assume 0 <= i#2 && i#2 < Seq#Length(xs#0);
    assume 0 <= j#2 && j#2 < Seq#Length(xs#0);
    goto anon13;

  anon20_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) && LitInt(0) <= j#2 && j#2 < Seq#Length(xs#0) && i#2 != j#2);
    goto anon13;

  anon15_Else:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, xs#0) <==> (forall i#3: int, j#3: int :: { Seq#Index(xs#0, j#3), Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) && LitInt(0) <= j#3 && j#3 < Seq#Length(xs#0) && i#3 != j#3 ==> Seq#Index(xs#0, i#3) != Seq#Index(xs#0, j#3));
    assume true;
    assume $Is(Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, xs#0), TBool);
    return;
}



procedure {:verboseName "Seq.LemmaNoDuplicatesInConcat (well-formedness)"} {:timeLimit 30} CheckWellFormed$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaNoDuplicatesInConcat (call precondtion)"} {:timeLimit 30} CallPre$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap));
  requires {:id "id5936"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesInConcat$T, reveal_Seq._default.HasNoDuplicates, xs#0);
  requires {:id "id5937"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesInConcat$T, reveal_Seq._default.HasNoDuplicates, ys#0);
  requires {:id "id5938"} MultiSet#Disjoint(MultiSet#FromSeq(xs#0), MultiSet#FromSeq(ys#0));



procedure {:verboseName "Seq.LemmaNoDuplicatesInConcat (call postcondition)"} {:timeLimit 30} CallPost$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.HasNoDuplicates#canCall(Seq._default.LemmaNoDuplicatesInConcat$T, Seq#Append(xs#0, ys#0));
  free ensures {:id "id5939"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesInConcat$T, reveal_Seq._default.HasNoDuplicates, Seq#Append(xs#0, ys#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaNoDuplicatesInConcat (correctness)"} {:timeLimit 30} Impl$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id5940"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesInConcat$T, reveal_Seq._default.HasNoDuplicates, xs#0);
  requires {:id "id5941"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesInConcat$T, reveal_Seq._default.HasNoDuplicates, ys#0);
  requires {:id "id5942"} MultiSet#Disjoint(MultiSet#FromSeq(xs#0), MultiSet#FromSeq(ys#0));
  modifies $Heap;
  free ensures Seq.__default.HasNoDuplicates#canCall(Seq._default.LemmaNoDuplicatesInConcat$T, Seq#Append(xs#0, ys#0));
  free ensures {:id "id5943"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesInConcat$T, reveal_Seq._default.HasNoDuplicates, Seq#Append(xs#0, ys#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaNoDuplicatesInConcat (correctness)"} {:timeLimit 30} Impl$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T: Ty, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var zs#0: Seq where $Is(zs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T)) && $IsAlloc(zs#0, TSeq(Seq._default.LemmaNoDuplicatesInConcat$T), $Heap);
  var i#0_0: int;
  var j#0_0: int;
  var i#0_2: int;
  var j#0_2: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaNoDuplicatesInConcat", " | ", Seq._default.LemmaNoDuplicatesInConcat$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(215,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__HasNoDuplicates();
    call CallPost$$Seq.__default.reveal__HasNoDuplicates();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(216,27)"} true;
    assume true;
    assume true;
    zs#0 := Seq#Append(xs#0, ys#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(217,21)"} true;
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Length(zs#0) > 1;
    havoc i#0_0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= i#0_0;
    goto anon4;

  anon24_Else:
    assume {:partition} i#0_0 < LitInt(0);
    goto anon4;

  anon4:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < Seq#Length(zs#0);
    goto anon6;

  anon25_Else:
    assume {:partition} !(LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(xs#0));
    goto anon6;

  anon23_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume true;
    assume (forall i#0_1: int :: { Seq#Index(zs#0, i#0_1) } LitInt(0) <= i#0_1 && i#0_1 < Seq#Length(xs#0) ==> MultiSet#FromSeq(xs#0)[Seq#Index(zs#0, i#0_1)] > 0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(219,64)"} true;
    havoc j#0_0;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} true;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Seq#Length(xs#0) <= j#0_0;
    goto anon9;

  anon27_Else:
    assume {:partition} j#0_0 < Seq#Length(xs#0);
    goto anon9;

  anon9:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} Seq#Length(xs#0) <= j#0_0 && j#0_0 < Seq#Length(zs#0);
    assume {:subsumption 0} 0 <= j#0_0 && j#0_0 < Seq#Length(zs#0);
    goto anon11;

  anon28_Else:
    assume {:partition} !(Seq#Length(xs#0) <= j#0_0 && j#0_0 < Seq#Length(zs#0));
    goto anon11;

  anon26_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    assume true;
    assume (forall j#0_1: int :: { Seq#Index(zs#0, j#0_1) } Seq#Length(xs#0) <= j#0_1 && j#0_1 < Seq#Length(zs#0) ==> MultiSet#FromSeq(ys#0)[Seq#Index(zs#0, j#0_1)] > 0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(220,67)"} true;
    havoc i#0_2;
    havoc j#0_2;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} true;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} i#0_2 != j#0_2;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} LitInt(0) <= i#0_2;
    goto anon15;

  anon31_Else:
    assume {:partition} i#0_2 < LitInt(0);
    goto anon15;

  anon30_Else:
    assume {:partition} i#0_2 == j#0_2;
    goto anon15;

  anon15:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} i#0_2 != j#0_2 && LitInt(0) <= i#0_2 && i#0_2 < Seq#Length(xs#0);
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} Seq#Length(xs#0) <= j#0_2;
    goto anon18;

  anon33_Else:
    assume {:partition} j#0_2 < Seq#Length(xs#0);
    goto anon18;

  anon32_Else:
    assume {:partition} !(i#0_2 != j#0_2 && LitInt(0) <= i#0_2 && i#0_2 < Seq#Length(xs#0));
    goto anon18;

  anon18:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} i#0_2 != j#0_2 && LitInt(0) <= i#0_2 && i#0_2 < Seq#Length(xs#0) && Seq#Length(xs#0) <= j#0_2 && j#0_2 < Seq#Length(zs#0);
    assume {:subsumption 0} 0 <= i#0_2 && i#0_2 < Seq#Length(zs#0);
    assume {:subsumption 0} 0 <= j#0_2 && j#0_2 < Seq#Length(zs#0);
    goto anon20;

  anon34_Else:
    assume {:partition} !(i#0_2 != j#0_2 && LitInt(0) <= i#0_2 && i#0_2 < Seq#Length(xs#0) && Seq#Length(xs#0) <= j#0_2 && j#0_2 < Seq#Length(zs#0));
    goto anon20;

  anon29_Else:
    assume {:partition} false;
    goto anon20;

  anon20:
    assume true;
    assume (forall i#0_3: int, j#0_3: int :: { Seq#Index(zs#0, j#0_3), Seq#Index(zs#0, i#0_3) } i#0_3 != j#0_3 && LitInt(0) <= i#0_3 && i#0_3 < Seq#Length(xs#0) && Seq#Length(xs#0) <= j#0_3 && j#0_3 < Seq#Length(zs#0) ==> Seq#Index(zs#0, i#0_3) != Seq#Index(zs#0, j#0_3));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(221,90)"} true;
    return;

  anon22_Else:
    assume {:partition} 1 >= Seq#Length(zs#0);
    return;
}



procedure {:verboseName "Seq.LemmaCardinalityOfSetNoDuplicates (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfSetNoDuplicates (call precondtion)"} CallPre$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap));
  requires {:id "id5956"} Seq.__default.HasNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, xs#0);



procedure {:verboseName "Seq.LemmaCardinalityOfSetNoDuplicates (call postcondition)"} CallPost$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
  free ensures {:id "id5957"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, reveal_Seq._default.ToSet, xs#0)) == Seq#Length(xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaCardinalityOfSetNoDuplicates (correctness)"} Impl$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id5958"} Seq.__default.HasNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, xs#0);
  modifies $Heap;
  free ensures Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
  free ensures {:id "id5959"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, reveal_Seq._default.ToSet, xs#0)) == Seq#Length(xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaCardinalityOfSetNoDuplicates (correctness)"} Impl$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var xs##1_0: Seq;
  var ##xs#1_0: Seq;
  var ##xs#1_1: Seq;
  var ##xs#1_2: Seq;
  var ##xs#1_3: Seq;
  var ##xs#1_4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaCardinalityOfSetNoDuplicates", " | ", Seq._default.LemmaCardinalityOfSetNoDuplicates$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(230,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__HasNoDuplicates();
    call CallPost$$Seq.__default.reveal__HasNoDuplicates();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(231,27)"} true;
    call CallPre$$Seq.__default.reveal__ToSet();
    call CallPost$$Seq.__default.reveal__ToSet();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(232,17)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    ##xs#1_0 := xs#0;
    assume $IsAlloc(##xs#1_0, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0) > 0;
    assume Seq#Length(##xs#1_0) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    xs##1_0 := Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0);
    call CallPre$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs##1_0);
    call CallPost$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(235,53)"} true;
    ##xs#1_1 := xs#0;
    assume $IsAlloc(##xs#1_1, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    ##xs#1_2 := xs#0;
    assume $IsAlloc(##xs#1_2, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_2) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    ##xs#1_3 := Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    assume $IsAlloc(##xs#1_3, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0));
    ##xs#1_4 := xs#0;
    assume $IsAlloc(##xs#1_4, TSeq(Seq._default.LemmaCardinalityOfSetNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_4) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0) && Seq.__default.DropLast#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0) && Seq.__default.ToSet#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0)) && Seq.__default.Last#canCall(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    assume Set#Equal(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, reveal_Seq._default.ToSet, xs#0), Set#Union(Seq.__default.ToSet(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, reveal_Seq._default.ToSet, Seq.__default.DropLast(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0)), Set#UnionOne(Set#Empty(): Set, Seq.__default.Last(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(236,58)"} true;
    return;
}



procedure {:verboseName "Seq.LemmaNoDuplicatesCardinalityOfSet (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaNoDuplicatesCardinalityOfSet (call precondtion)"} CallPre$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap));
  requires {:id "id5973"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0)) == Seq#Length(xs#0);



procedure {:verboseName "Seq.LemmaNoDuplicatesCardinalityOfSet (call postcondition)"} CallPost$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.HasNoDuplicates#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
  free ensures {:id "id5974"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.HasNoDuplicates, xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaNoDuplicatesCardinalityOfSet (correctness)"} Impl$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id5975"} Set#Card(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0)) == Seq#Length(xs#0);
  modifies $Heap;
  free ensures Seq.__default.HasNoDuplicates#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
  free ensures {:id "id5976"} Seq.__default.HasNoDuplicates(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.HasNoDuplicates, xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaNoDuplicatesCardinalityOfSet (correctness)"} Impl$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#1_0: Seq;
  var ##xs#1_1: Seq;
  var ##xs#1_2: Seq;
  var ##xs#1_3: Seq;
  var ##xs#1_4: Seq;
  var ##xs#1_5: Seq;
  var ##xs#1_6: Seq;
  var ##xs#1_7: Seq;
  var ##xs#1_0_0: Seq;
  var ##xs#1_0_1: Seq;
  var ##xs#1_0_2: Seq;
  var xs##1_0_0: Seq;
  var ##xs#1_0_3: Seq;
  var ##xs#1_0_4: Seq;
  var ##xs#1_0_5: Seq;
  var ##xs#1_1_0: Seq;
  var ##xs#1_1_1: Seq;
  var ##xs#1_1_2: Seq;
  var xs##1_1_0: Seq;
  var ##xs#1_1_3: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaNoDuplicatesCardinalityOfSet", " | ", Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(244,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__HasNoDuplicates();
    call CallPost$$Seq.__default.reveal__HasNoDuplicates();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(245,27)"} true;
    call CallPre$$Seq.__default.reveal__ToSet();
    call CallPost$$Seq.__default.reveal__ToSet();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(246,17)"} true;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    return;

  anon5_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    ##xs#1_0 := xs#0;
    assume $IsAlloc(##xs#1_0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0) > 0;
    assume Seq.__default.First#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_1 := xs#0;
    assume $IsAlloc(##xs#1_1, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_1) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq.__default.First#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq#Equal(xs#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq.__default.First(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0)), Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(249,46)"} true;
    ##xs#1_2 := xs#0;
    assume $IsAlloc(##xs#1_2, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_3 := xs#0;
    assume $IsAlloc(##xs#1_3, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_3) > 0;
    assume Seq.__default.First#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_4 := xs#0;
    assume $IsAlloc(##xs#1_4, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_4) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_5 := Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume $IsAlloc(##xs#1_5, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.First#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume Set#Equal(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0), Set#Union(Set#UnionOne(Set#Empty(): Set, Seq.__default.First(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0)), Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(250,60)"} true;
    ##xs#1_6 := xs#0;
    assume $IsAlloc(##xs#1_6, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_6) > 0;
    assume Seq#Length(##xs#1_6) > 0;
    assume Seq.__default.First#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_7 := xs#0;
    assume $IsAlloc(##xs#1_7, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_7) > 0;
    assume Seq#Length(##xs#1_7) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq.__default.First#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Seq#Contains(Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0), Seq.__default.First(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    ##xs#1_0_0 := xs#0;
    assume $IsAlloc(##xs#1_0_0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_0_1 := xs#0;
    assume $IsAlloc(##xs#1_0_1, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_0_2 := Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume $IsAlloc(##xs#1_0_2, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume Set#Equal(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0), Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(253,48)"} true;
    ##xs#1_0_3 := xs#0;
    assume $IsAlloc(##xs#1_0_3, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_3) > 0;
    assume Seq#Length(##xs#1_0_3) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    xs##1_0_0 := Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    call CallPre$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs##1_0_0);
    call CallPost$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs##1_0_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(254,44)"} true;
    ##xs#1_0_4 := xs#0;
    assume $IsAlloc(##xs#1_0_4, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_0_5 := xs#0;
    assume $IsAlloc(##xs#1_0_5, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_5) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Set#Card(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0)) <= Seq#Length(Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(255,45)"} true;
    return;

  anon6_Else:
    assume {:partition} !Seq#Contains(Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0), Seq.__default.First(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    ##xs#1_1_0 := xs#0;
    assume $IsAlloc(##xs#1_1_0, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_1_1 := xs#0;
    assume $IsAlloc(##xs#1_1_1, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_1_1) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    ##xs#1_1_2 := Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume $IsAlloc(##xs#1_1_2, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0) && Seq.__default.ToSet#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0));
    assume Set#Card(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, xs#0)) == 1 + Set#Card(Seq.__default.ToSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, reveal_Seq._default.ToSet, Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(257,56)"} true;
    ##xs#1_1_3 := xs#0;
    assume $IsAlloc(##xs#1_1_3, TSeq(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_1_3) > 0;
    assume Seq#Length(##xs#1_1_3) > 0;
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq.__default.DropFirst#canCall(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    xs##1_1_0 := Seq.__default.DropFirst(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    assume Seq#Rank(xs##1_1_0) < Seq#Rank(xs#0);
    call CallPre$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs##1_1_0);
    call CallPost$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs##1_1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(258,56)"} true;
    return;
}



procedure {:verboseName "Seq.LemmaMultisetHasNoDuplicates (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaMultisetHasNoDuplicates (call precondtion)"} CallPre$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap));
  requires {:id "id6007"} Seq.__default.HasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, xs#0);



procedure {:verboseName "Seq.LemmaMultisetHasNoDuplicates (call postcondition)"} CallPost$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id6008"} (forall x#1: Box :: { MultiSet#FromSeq(xs#0)[x#1] } $IsBox(x#1, Seq._default.LemmaMultisetHasNoDuplicates$T) && MultiSet#FromSeq(xs#0)[x#1] > 0 ==> MultiSet#FromSeq(xs#0)[x#1] == LitInt(1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaMultisetHasNoDuplicates (correctness)"} Impl$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6009"} Seq.__default.HasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, xs#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id6010"} (forall x#1: Box :: { MultiSet#FromSeq(xs#0)[x#1] } $IsBox(x#1, Seq._default.LemmaMultisetHasNoDuplicates$T) && MultiSet#FromSeq(xs#0)[x#1] > 0 ==> MultiSet#FromSeq(xs#0)[x#1] == LitInt(1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMultisetHasNoDuplicates (correctness)"} Impl$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#1_0: Seq;
  var ##xs#1_1: Seq;
  var ##xs#1_2: Seq;
  var ##xs#1_3: Seq;
  var ##xs#1_4: Seq;
  var ##xs#1_5: Seq;
  var xs##1_0: Seq;
  var ##xs#1_6: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMultisetHasNoDuplicates", " | ", Seq._default.LemmaMultisetHasNoDuplicates$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(268,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    return;

  anon7_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    ##xs#1_0 := xs#0;
    assume $IsAlloc(##xs#1_0, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    ##xs#1_1 := xs#0;
    assume $IsAlloc(##xs#1_1, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_1) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0) && Seq.__default.Last#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    assume Seq#Equal(xs#0, Seq#Append(Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(271,44)"} true;
    ##xs#1_2 := xs#0;
    assume $IsAlloc(##xs#1_2, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_2) > 0;
    assume Seq.__default.Last#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    ##xs#1_3 := xs#0;
    assume $IsAlloc(##xs#1_3, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_3) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    assume Seq.__default.Last#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0) && Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    push;
    call CallPre$$Seq.__default.reveal__HasNoDuplicates();
    call CallPost$$Seq.__default.reveal__HasNoDuplicates();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(273,31)"} true;
    pop;
    assume !Seq#Contains(Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0), Seq.__default.Last(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0));
    assume false;
    goto anon4;

  anon8_Else:
    goto anon4;

  anon4:
    assume !Seq#Contains(Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0), Seq.__default.Last(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(274,6)"} true;
    ##xs#1_4 := xs#0;
    assume $IsAlloc(##xs#1_4, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_4) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    ##xs#1_5 := Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    assume $IsAlloc(##xs#1_5, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume Seq.__default.HasNoDuplicates#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0));
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0) && Seq.__default.HasNoDuplicates#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0));
    goto anon9_Then, anon9_Else;

  anon9_Then:
    push;
    call CallPre$$Seq.__default.reveal__HasNoDuplicates();
    call CallPost$$Seq.__default.reveal__HasNoDuplicates();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(276,31)"} true;
    pop;
    assume Seq.__default.HasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0));
    assume false;
    goto anon6;

  anon9_Else:
    goto anon6;

  anon6:
    assume Seq.__default.HasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, reveal_Seq._default.HasNoDuplicates, Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(277,6)"} true;
    ##xs#1_6 := xs#0;
    assume $IsAlloc(##xs#1_6, TSeq(Seq._default.LemmaMultisetHasNoDuplicates$T), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_6) > 0;
    assume Seq#Length(##xs#1_6) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    assume Seq.__default.DropLast#canCall(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    xs##1_0 := Seq.__default.DropLast(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0);
    call CallPre$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, xs##1_0);
    call CallPost$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, xs##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(278,48)"} true;
    return;
}



function Seq.__default.IndexOf(Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#0: int :: { Seq#Index(xs#0, j#0) } LitInt(0) <= j#0 && j#0 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#0) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, xs#0, v#0) == (if Seq#Index(xs#0, LitInt(0)) == v#0 then 0 else 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, reveal_Seq._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(xs#0), v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then 0 else 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), reveal_Seq._default.IndexOf, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(xs#0), Lit(v#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then 0 else 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), reveal_Seq._default.IndexOf, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))));
}

function Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T: Ty, xs#0: Seq, v#0: Box) : bool;

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), $reveal, xs#0, v#0) } Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), $reveal, xs#0, v#0) == Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, AsFuelBottom($ly), $reveal, xs#0, v#0) } Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) == Seq.__default.IndexOf(Seq._default.IndexOf$T, $LZ, $reveal, xs#0, v#0));

function Seq.__default.IndexOf#requires(Ty, LayerType, Seq, Box) : bool;

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf#requires(Seq._default.IndexOf$T, $ly, xs#0, v#0) } $Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) ==> (Seq.__default.IndexOf#requires(Seq._default.IndexOf$T, $ly, xs#0, v#0) <==> Seq#Contains(xs#0, v#0)));

procedure {:verboseName "Seq.IndexOf (well-formedness)"} CheckWellformed$$Seq.__default.IndexOf(Seq._default.IndexOf$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IndexOf$T)), v#0: Box where $IsBox(v#0, Seq._default.IndexOf$T)) returns (i#0: int where LitInt(0) <= i#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6029"} i#0 < Seq#Length(xs#0);
  free ensures {:id "id6030"} Seq#Index(xs#0, i#0) == v#0;
  free ensures {:id "id6031"} (forall j#1: int :: { Seq#Index(xs#0, j#1) } LitInt(0) <= j#1 && j#1 < i#0 ==> Seq#Index(xs#0, j#1) != v#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.IndexOf (well-formedness)"} CheckWellformed$$Seq.__default.IndexOf(Seq._default.IndexOf$T: Ty, xs#0: Seq, v#0: Box) returns (i#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#2: int;
  var ##xs#0: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.IndexOf", " | ", Seq._default.IndexOf$T, " | ", xs#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(284,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Contains(xs#0, v#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0);
    assume i#0 < Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, i#0) == v#0;
    havoc j#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= j#2;
    goto anon5;

  anon14_Else:
    assume {:partition} j#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= j#2 && j#2 < i#0;
    assume 0 <= j#2 && j#2 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, j#2) != v#0;
    goto anon7;

  anon13_Else:
    assume LitInt(0) <= j#2 && j#2 < i#0 ==> Seq#Index(xs#0, j#2) != v#0;
    goto anon7;

  anon7:
    assume (forall j#1: int :: { Seq#Index(xs#0, j#1) } LitInt(0) <= j#1 && j#1 < i#0 ==> Seq#Index(xs#0, j#1) != v#0);
    assume false;
    return;

  anon12_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Index(xs#0, LitInt(0)) == v#0;
    assume $Is(LitInt(0), Tclass._System.nat());
    assume Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0) == LitInt(0);
    assume true;
    assume $Is(Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0), Tclass._System.nat());
    goto anon11;

  anon15_Else:
    assume {:partition} Seq#Index(xs#0, LitInt(0)) != v#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.IndexOf$T), $Heap);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, Seq._default.IndexOf$T, $Heap);
    assume {:subsumption 0} Seq#Contains(##xs#0, ##v#0);
    assume Seq#Contains(##xs#0, ##v#0);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume $Is(1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0), Tclass._System.nat());
    assume Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0) == 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume $Is(Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0), Tclass._System.nat());
    goto anon11;

  anon11:
    assume Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0) == i#0;
    return;
}



function Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#0: int :: { Seq#Index(xs#0, j#0) } LitInt(0) <= j#0 && j#0 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#0) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#0 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#0) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#0)): int + 1)) else #Wrappers.Option.None())))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#1 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#1) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#1)): int + 1)) else #Wrappers.Option.None())))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#2 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#2) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#2)): int + 1)) else #Wrappers.Option.None())))));
}

function Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T: Ty, xs#0: Seq, v#0: Box) : bool;

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), $reveal, xs#0, v#0) } Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), $reveal, xs#0, v#0) == Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, AsFuelBottom($ly), $reveal, xs#0, v#0) } Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) == Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LZ, $reveal, xs#0, v#0));

function Seq.__default.IndexOfOption#requires(Ty, LayerType, Seq, Box) : bool;

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption#requires(Seq._default.IndexOfOption$T, $ly, xs#0, v#0) } $Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T) ==> (Seq.__default.IndexOfOption#requires(Seq._default.IndexOfOption$T, $ly, xs#0, v#0) <==> true));

procedure {:verboseName "Seq.IndexOfOption (well-formedness)"} CheckWellformed$$Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.IndexOfOption$T)), v#0: Box where $IsBox(v#0, Seq._default.IndexOfOption$T)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Option(Tclass._System.nat())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6050"} Wrappers.Option.Some_q(o#0) ==> $Unbox(Wrappers.Option.value(o#0)): int < Seq#Length(xs#0);
  free ensures {:id "id6051"} Wrappers.Option.Some_q(o#0) ==> Seq#Index(xs#0, $Unbox(Wrappers.Option.value(o#0)): int) == v#0;
  free ensures {:id "id6052"} Wrappers.Option.Some_q(o#0) ==> (forall j#1: int :: { Seq#Index(xs#0, j#1) } LitInt(0) <= j#1 && j#1 < $Unbox(Wrappers.Option.value(o#0)): int ==> Seq#Index(xs#0, j#1) != v#0);
  free ensures {:id "id6053"} !Wrappers.Option.Some_q(o#0) ==> !Seq#Contains(xs#0, v#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.IndexOfOption (well-formedness)"} CheckWellformed$$Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T: Ty, xs#0: Seq, v#0: Box) returns (o#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#2: int;
  var o'#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##xs#0: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.IndexOfOption", " | ", Seq._default.IndexOfOption$T, " | ", xs#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(294,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume Wrappers.Option.Some_q(o#0);
    assume Wrappers.Option.Some_q(o#0);
    assume $Unbox(Wrappers.Option.value(o#0)): int < Seq#Length(xs#0);
    assume Wrappers.Option.Some_q(o#0);
    assume 0 <= $Unbox(Wrappers.Option.value(o#0)): int && $Unbox(Wrappers.Option.value(o#0)): int < Seq#Length(xs#0);
    assume Seq#Index(xs#0, $Unbox(Wrappers.Option.value(o#0)): int) == v#0;
    havoc j#2;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= j#2;
    assume Wrappers.Option.Some_q(o#0);
    goto anon6;

  anon22_Else:
    assume {:partition} j#2 < LitInt(0);
    goto anon6;

  anon6:
    assume LitInt(0) <= j#2 && j#2 < $Unbox(Wrappers.Option.value(o#0)): int;
    assume 0 <= j#2 && j#2 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, j#2) != v#0;
    goto anon8;

  anon21_Else:
    assume LitInt(0) <= j#2 && j#2 < $Unbox(Wrappers.Option.value(o#0)): int ==> Seq#Index(xs#0, j#2) != v#0;
    goto anon8;

  anon8:
    assume (forall j#1: int :: { Seq#Index(xs#0, j#1) } LitInt(0) <= j#1 && j#1 < $Unbox(Wrappers.Option.value(o#0)): int ==> Seq#Index(xs#0, j#1) != v#0);
    goto anon10;

  anon20_Else:
    assume !Wrappers.Option.Some_q(o#0);
    assume !Seq#Contains(xs#0, v#0);
    goto anon10;

  anon10:
    assume false;
    return;

  anon19_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume $Is(Lit(#Wrappers.Option.None()), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon18;

  anon23_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} Seq#Index(xs#0, LitInt(0)) == v#0;
    assume $Is(Lit(#Wrappers.Option.Some($Box(LitInt(0)))), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0) == Lit(#Wrappers.Option.Some($Box(LitInt(0))));
    assume true;
    assume $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon18;

  anon24_Else:
    assume {:partition} Seq#Index(xs#0, LitInt(0)) != v#0;
    havoc o'#Z#0;
    assume $Is(o'#Z#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(o'#Z#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.IndexOfOption$T), $Heap);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, Seq._default.IndexOfOption$T, $Heap);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume let#0#0#0 == Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume o'#Z#0 == let#0#0#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Option.Some_q(o'#Z#0);
    assume Wrappers.Option.Some_q(o'#Z#0);
    assume $Is(#Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#Z#0)): int + 1)), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0) == #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#Z#0)): int + 1));
    assume true;
    assume $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon18;

  anon25_Else:
    assume {:partition} !Wrappers.Option.Some_q(o'#Z#0);
    assume $Is(Lit(#Wrappers.Option.None()), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon18;

  anon18:
    assume Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($LZ), reveal_Seq._default.IndexOfOption, xs#0, v#0) == o#0;
    return;
}



function Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#0: int :: { Seq#Index(xs#0, j#0) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#0 && j#0 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#0) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(xs#0, Seq#Length(xs#0) - 1) != v#0 ==> Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0)) && Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, xs#0, v#0) == (if Seq#Index(xs#0, Seq#Length(xs#0) - 1) == v#0 then Seq#Length(xs#0) - 1 else Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, reveal_Seq._default.LastIndexOf, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Lit(xs#0), v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != v#0 ==> Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0)) && Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == v#0 then Seq#Length(Lit(xs#0)) - 1 else Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), reveal_Seq._default.LastIndexOf, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Lit(xs#0), Lit(v#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != Lit(v#0) ==> Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0))) && Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == Lit(v#0) then Seq#Length(Lit(xs#0)) - 1 else Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), reveal_Seq._default.LastIndexOf, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0))));
}

function Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T: Ty, xs#0: Seq, v#0: Box) : bool;

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), $reveal, xs#0, v#0) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), $reveal, xs#0, v#0) == Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, AsFuelBottom($ly), $reveal, xs#0, v#0) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) == Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LZ, $reveal, xs#0, v#0));

function Seq.__default.LastIndexOf#requires(Ty, LayerType, Seq, Box) : bool;

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf#requires(Seq._default.LastIndexOf$T, $ly, xs#0, v#0) } $Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) ==> (Seq.__default.LastIndexOf#requires(Seq._default.LastIndexOf$T, $ly, xs#0, v#0) <==> Seq#Contains(xs#0, v#0)));

procedure {:verboseName "Seq.LastIndexOf (well-formedness)"} CheckWellformed$$Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LastIndexOf$T)), v#0: Box where $IsBox(v#0, Seq._default.LastIndexOf$T)) returns (i#0: int where LitInt(0) <= i#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6083"} i#0 < Seq#Length(xs#0);
  free ensures {:id "id6084"} Seq#Index(xs#0, i#0) == v#0;
  free ensures {:id "id6085"} (forall j#1: int :: { Seq#Index(xs#0, j#1) } i#0 < j#1 && j#1 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#1) != v#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LastIndexOf (well-formedness)"} CheckWellformed$$Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T: Ty, xs#0: Seq, v#0: Box) returns (i#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#2: int;
  var ##xs#0: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.LastIndexOf", " | ", Seq._default.LastIndexOf$T, " | ", xs#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(309,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Contains(xs#0, v#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, xs#0, v#0);
    assume i#0 < Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, i#0) == v#0;
    havoc j#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} i#0 < j#2;
    goto anon5;

  anon14_Else:
    assume {:partition} j#2 <= i#0;
    goto anon5;

  anon5:
    assume i#0 < j#2 && j#2 < Seq#Length(xs#0);
    assume 0 <= j#2 && j#2 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, j#2) != v#0;
    goto anon7;

  anon13_Else:
    assume i#0 < j#2 && j#2 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#2) != v#0;
    goto anon7;

  anon7:
    assume (forall j#1: int :: { Seq#Index(xs#0, j#1) } i#0 < j#1 && j#1 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#1) != v#0);
    assume false;
    return;

  anon12_Else:
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 < Seq#Length(xs#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Index(xs#0, Seq#Length(xs#0) - 1) == v#0;
    assume $Is(Seq#Length(xs#0) - 1, Tclass._System.nat());
    assume Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, xs#0, v#0) == Seq#Length(xs#0) - 1;
    assume true;
    assume $Is(Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, xs#0, v#0), Tclass._System.nat());
    goto anon11;

  anon15_Else:
    assume {:partition} Seq#Index(xs#0, Seq#Length(xs#0) - 1) != v#0;
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    ##xs#0 := Seq#Take(xs#0, Seq#Length(xs#0) - 1);
    assume $IsAlloc(##xs#0, TSeq(Seq._default.LastIndexOf$T), $Heap);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, Seq._default.LastIndexOf$T, $Heap);
    assume {:subsumption 0} Seq#Contains(##xs#0, ##v#0);
    assume Seq#Contains(##xs#0, ##v#0);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0);
    assume Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, xs#0, v#0) == Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0);
    assume Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0);
    assume $Is(Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, xs#0, v#0), Tclass._System.nat());
    goto anon11;

  anon11:
    assume Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($LZ), reveal_Seq._default.LastIndexOf, xs#0, v#0) == i#0;
    return;
}



function Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#0: int :: { Seq#Index(xs#0, j#0) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#0 && j#0 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#0) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, Seq#Length(xs#0) - 1) != v#0 ==> Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0)) && Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, Seq#Length(xs#0) - 1) == v#0 then #Wrappers.Option.Some($Box(Seq#Length(xs#0) - 1)) else Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, reveal_Seq._default.LastIndexOfOption, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Lit(xs#0), v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != v#0 ==> Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0)) && Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == v#0 then #Wrappers.Option.Some($Box(Seq#Length(Lit(xs#0)) - 1)) else Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), reveal_Seq._default.LastIndexOfOption, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Lit(xs#0), Lit(v#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != Lit(v#0) ==> Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0))) && Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == Lit(v#0) then #Wrappers.Option.Some($Box(Seq#Length(Lit(xs#0)) - 1)) else Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), reveal_Seq._default.LastIndexOfOption, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0)))));
}

function Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T: Ty, xs#0: Seq, v#0: Box) : bool;

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), $reveal, xs#0, v#0) == Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, AsFuelBottom($ly), $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) == Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LZ, $reveal, xs#0, v#0));

function Seq.__default.LastIndexOfOption#requires(Ty, LayerType, Seq, Box) : bool;

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption#requires(Seq._default.LastIndexOfOption$T, $ly, xs#0, v#0) } $Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T) ==> (Seq.__default.LastIndexOfOption#requires(Seq._default.LastIndexOfOption$T, $ly, xs#0, v#0) <==> true));

procedure {:verboseName "Seq.LastIndexOfOption (well-formedness)"} CheckWellformed$$Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)), v#0: Box where $IsBox(v#0, Seq._default.LastIndexOfOption$T)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Option(Tclass._System.nat())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6103"} Wrappers.Option.Some_q(o#0) ==> $Unbox(Wrappers.Option.value(o#0)): int < Seq#Length(xs#0);
  free ensures {:id "id6104"} Wrappers.Option.Some_q(o#0) ==> Seq#Index(xs#0, $Unbox(Wrappers.Option.value(o#0)): int) == v#0;
  free ensures {:id "id6105"} Wrappers.Option.Some_q(o#0) ==> (forall j#1: int :: { Seq#Index(xs#0, j#1) } $Unbox(Wrappers.Option.value(o#0)): int < j#1 && j#1 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#1) != v#0);
  free ensures {:id "id6106"} !Wrappers.Option.Some_q(o#0) ==> !Seq#Contains(xs#0, v#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LastIndexOfOption (well-formedness)"} CheckWellformed$$Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T: Ty, xs#0: Seq, v#0: Box) returns (o#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#2: int;
  var ##xs#0: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.LastIndexOfOption", " | ", Seq._default.LastIndexOfOption$T, " | ", xs#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(319,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Wrappers.Option.Some_q(o#0);
    assume Wrappers.Option.Some_q(o#0);
    assume $Unbox(Wrappers.Option.value(o#0)): int < Seq#Length(xs#0);
    assume Wrappers.Option.Some_q(o#0);
    assume 0 <= $Unbox(Wrappers.Option.value(o#0)): int && $Unbox(Wrappers.Option.value(o#0)): int < Seq#Length(xs#0);
    assume Seq#Index(xs#0, $Unbox(Wrappers.Option.value(o#0)): int) == v#0;
    havoc j#2;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Wrappers.Option.Some_q(o#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} $Unbox(Wrappers.Option.value(o#0)): int < j#2;
    goto anon6;

  anon20_Else:
    assume {:partition} j#2 <= $Unbox(Wrappers.Option.value(o#0)): int;
    goto anon6;

  anon6:
    assume $Unbox(Wrappers.Option.value(o#0)): int < j#2 && j#2 < Seq#Length(xs#0);
    assume 0 <= j#2 && j#2 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, j#2) != v#0;
    goto anon8;

  anon19_Else:
    assume $Unbox(Wrappers.Option.value(o#0)): int < j#2 && j#2 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#2) != v#0;
    goto anon8;

  anon8:
    assume (forall j#1: int :: { Seq#Index(xs#0, j#1) } $Unbox(Wrappers.Option.value(o#0)): int < j#1 && j#1 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#1) != v#0);
    goto anon10;

  anon18_Else:
    assume !Wrappers.Option.Some_q(o#0);
    assume !Seq#Contains(xs#0, v#0);
    goto anon10;

  anon10:
    assume false;
    return;

  anon17_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume $Is(Lit(#Wrappers.Option.None()), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon16;

  anon21_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 < Seq#Length(xs#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Index(xs#0, Seq#Length(xs#0) - 1) == v#0;
    assume $Is(#Wrappers.Option.Some($Box(Seq#Length(xs#0) - 1)), Tclass.Wrappers.Option(Tclass._System.nat()));
    assume Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0) == #Wrappers.Option.Some($Box(Seq#Length(xs#0) - 1));
    assume true;
    assume $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon16;

  anon22_Else:
    assume {:partition} Seq#Index(xs#0, Seq#Length(xs#0) - 1) != v#0;
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    ##xs#0 := Seq#Take(xs#0, Seq#Length(xs#0) - 1);
    assume $IsAlloc(##xs#0, TSeq(Seq._default.LastIndexOfOption$T), $Heap);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, Seq._default.LastIndexOfOption$T, $Heap);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0);
    assume Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0) == Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0);
    assume Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0);
    assume $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon16;

  anon16:
    assume Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($LZ), reveal_Seq._default.LastIndexOfOption, xs#0, v#0) == o#0;
    return;
}



function Seq.__default.Remove(Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#0: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#0), Seq#Index(xs#0, i#0) } LitInt(0) <= i#0 && i#0 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#0) == Seq#Index(xs#0, i#0)) && (forall i#1: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#1) } pos#0 <= i#1 && i#1 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#1) == Seq#Index(xs#0, i#1 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { $IsAlloc(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T), $Heap) } (Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Remove$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Remove$T), $Heap) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, true, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq.__default.Remove(Seq._default.Remove$T, true, xs#0, pos#0) == Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0 + 1)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int :: {:weight 3} { Seq.__default.Remove(Seq._default.Remove$T, true, Lit(xs#0), LitInt(pos#0)) } Seq.__default.Remove#canCall(Seq._default.Remove$T, Lit(xs#0), LitInt(pos#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(Lit(xs#0))) ==> Seq.__default.Remove(Seq._default.Remove$T, true, Lit(xs#0), LitInt(pos#0)) == Seq#Append(Seq#Take(Lit(xs#0), LitInt(pos#0)), Seq#Drop(Lit(xs#0), LitInt(pos#0 + 1))));
}

function Seq.__default.Remove#canCall(Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int) : bool;

function Seq.__default.Remove#requires(Ty, Seq, int) : bool;

axiom (forall Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int :: { Seq.__default.Remove#requires(Seq._default.Remove$T, xs#0, pos#0) } $Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 ==> (Seq.__default.Remove#requires(Seq._default.Remove$T, xs#0, pos#0) <==> pos#0 < Seq#Length(xs#0)));

procedure {:verboseName "Seq.Remove (well-formedness)"} CheckWellformed$$Seq.__default.Remove(Seq._default.Remove$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Remove$T)), pos#0: int where LitInt(0) <= pos#0) returns (ys#0: Seq where $Is(ys#0, TSeq(Seq._default.Remove$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6130"} Seq#Length(ys#0) == Seq#Length(xs#0) - 1;
  free ensures {:id "id6131"} (forall i#2: int :: { Seq#Index(ys#0, i#2), Seq#Index(xs#0, i#2) } LitInt(0) <= i#2 && i#2 < pos#0 ==> Seq#Index(ys#0, i#2) == Seq#Index(xs#0, i#2));
  free ensures {:id "id6132"} (forall i#3: int :: { Seq#Index(ys#0, i#3) } pos#0 <= i#3 && i#3 < Seq#Length(xs#0) - 1 ==> Seq#Index(ys#0, i#3) == Seq#Index(xs#0, i#3 + 1));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Remove (well-formedness)"} CheckWellformed$$Seq.__default.Remove(Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int) returns (ys#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#4: int;
  var i#5: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.Remove", " | ", Seq._default.Remove$T, " | ", xs#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(329,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume pos#0 < Seq#Length(xs#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(Seq.__default.Remove(Seq._default.Remove$T, reveal_Seq._default.Remove, xs#0, pos#0), TSeq(Seq._default.Remove$T));
    assume Seq#Length(ys#0) == Seq#Length(xs#0) - 1;
    havoc i#4;
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon5;

  anon16_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#4 && i#4 < pos#0;
    assume 0 <= i#4 && i#4 < Seq#Length(ys#0);
    assume 0 <= i#4 && i#4 < Seq#Length(xs#0);
    assume Seq#Index(ys#0, i#4) == Seq#Index(xs#0, i#4);
    goto anon7;

  anon15_Else:
    assume LitInt(0) <= i#4 && i#4 < pos#0 ==> Seq#Index(ys#0, i#4) == Seq#Index(xs#0, i#4);
    goto anon7;

  anon7:
    assume (forall i#2: int :: { Seq#Index(ys#0, i#2), Seq#Index(xs#0, i#2) } LitInt(0) <= i#2 && i#2 < pos#0 ==> Seq#Index(ys#0, i#2) == Seq#Index(xs#0, i#2));
    havoc i#5;
    assume true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} pos#0 <= i#5;
    goto anon10;

  anon18_Else:
    assume {:partition} i#5 < pos#0;
    goto anon10;

  anon10:
    assume pos#0 <= i#5 && i#5 < Seq#Length(xs#0) - 1;
    assume 0 <= i#5 && i#5 < Seq#Length(ys#0);
    assume 0 <= i#5 + 1 && i#5 + 1 < Seq#Length(xs#0);
    assume Seq#Index(ys#0, i#5) == Seq#Index(xs#0, i#5 + 1);
    goto anon12;

  anon17_Else:
    assume pos#0 <= i#5 && i#5 < Seq#Length(xs#0) - 1 ==> Seq#Index(ys#0, i#5) == Seq#Index(xs#0, i#5 + 1);
    goto anon12;

  anon12:
    assume (forall i#3: int :: { Seq#Index(ys#0, i#3) } pos#0 <= i#3 && i#3 < Seq#Length(xs#0) - 1 ==> Seq#Index(ys#0, i#3) == Seq#Index(xs#0, i#3 + 1));
    assume false;
    return;

  anon14_Else:
    assume 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume 0 <= pos#0 + 1 && pos#0 + 1 <= Seq#Length(xs#0);
    assume Seq.__default.Remove(Seq._default.Remove$T, reveal_Seq._default.Remove, xs#0, pos#0) == Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0 + 1));
    assume true;
    assume $Is(Seq.__default.Remove(Seq._default.Remove$T, reveal_Seq._default.Remove, xs#0, pos#0), TSeq(Seq._default.Remove$T));
    assume Seq.__default.Remove(Seq._default.Remove$T, reveal_Seq._default.Remove, xs#0, pos#0) == ys#0;
    return;
}



function Seq.__default.RemoveValue(Seq._default.RemoveValue$T: Ty, $reveal: bool, xs#0: Seq, v#0: Box) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.RemoveValue$T: Ty, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (!Seq#Contains(xs#0, v#0) ==> Seq#Equal(xs#0, Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0))) && (Seq#Contains(xs#0, v#0) ==> MultiSet#Card(MultiSet#FromSeq(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0))) == MultiSet#Card(MultiSet#FromSeq(xs#0)) - 1) && (Seq#Contains(xs#0, v#0) ==> MultiSet#FromSeq(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0))[v#0] == MultiSet#FromSeq(xs#0)[v#0] - 1) && (Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, xs#0) ==> Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0)) && Set#Equal(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0)), Set#Difference(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, xs#0), Set#UnionOne(Set#Empty(): Set, v#0)))) && $Is(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0), TSeq(Seq._default.RemoveValue$T)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.RemoveValue$T: Ty, $reveal: bool, xs#0: Seq, v#0: Box :: { $IsAlloc(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0), TSeq(Seq._default.RemoveValue$T), $Heap) } (Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsAlloc(xs#0, TSeq(Seq._default.RemoveValue$T), $Heap) && $IsBox(v#0, Seq._default.RemoveValue$T) && $IsAllocBox(v#0, Seq._default.RemoveValue$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0), TSeq(Seq._default.RemoveValue$T), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#0 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#0), Seq#Drop(xs#0, i#0 + 1)))));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#1 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#1), Seq#Drop(Lit(xs#0), i#1 + 1)))));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#2 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#2), Seq#Drop(Lit(xs#0), i#2 + 1)))));
}

function Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box) : bool;

function Seq.__default.RemoveValue#requires(Ty, Seq, Box) : bool;

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue#requires(Seq._default.RemoveValue$T, xs#0, v#0) } $Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T) ==> (Seq.__default.RemoveValue#requires(Seq._default.RemoveValue$T, xs#0, v#0) <==> true));

procedure {:verboseName "Seq.RemoveValue (well-formedness)"} CheckWellformed$$Seq.__default.RemoveValue(Seq._default.RemoveValue$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.RemoveValue$T)), v#0: Box where $IsBox(v#0, Seq._default.RemoveValue$T)) returns (ys#0: Seq where $Is(ys#0, TSeq(Seq._default.RemoveValue$T)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6151"} !Seq#Contains(xs#0, v#0) ==> Seq#Equal(xs#0, ys#0);
  free ensures {:id "id6152"} Seq#Contains(xs#0, v#0) ==> MultiSet#Card(MultiSet#FromSeq(ys#0)) == MultiSet#Card(MultiSet#FromSeq(xs#0)) - 1;
  free ensures {:id "id6153"} Seq#Contains(xs#0, v#0) ==> MultiSet#FromSeq(ys#0)[v#0] == MultiSet#FromSeq(xs#0)[v#0] - 1;
  free ensures {:id "id6154"} Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, xs#0) ==> Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, ys#0);
  free ensures {:id "id6155"} Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, xs#0) ==> Set#Equal(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, ys#0), Set#Difference(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, xs#0), Set#UnionOne(Set#Empty(): Set, v#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.RemoveValue (well-formedness)"} CheckWellformed$$Seq.__default.RemoveValue(Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box) returns (ys#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var i#Z#0: int;
  var let#0#0#0: int;
  var ##xs#4: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.RemoveValue", " | ", Seq._default.RemoveValue$T, " | ", xs#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(340,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, reveal_Seq._default.RemoveValue, xs#0, v#0), TSeq(Seq._default.RemoveValue$T));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume !Seq#Contains(xs#0, v#0);
    assume Seq#Equal(xs#0, ys#0);
    goto anon5;

  anon20_Else:
    assume !Seq#Contains(xs#0, v#0) ==> Seq#Equal(xs#0, ys#0);
    goto anon5;

  anon5:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Seq#Contains(xs#0, v#0);
    assume MultiSet#Card(MultiSet#FromSeq(ys#0)) == MultiSet#Card(MultiSet#FromSeq(xs#0)) - 1;
    goto anon8;

  anon21_Else:
    assume Seq#Contains(xs#0, v#0) ==> MultiSet#Card(MultiSet#FromSeq(ys#0)) == MultiSet#Card(MultiSet#FromSeq(xs#0)) - 1;
    goto anon8;

  anon8:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume Seq#Contains(xs#0, v#0);
    newtype$check#0 := MultiSet#FromSeq(xs#0)[v#0] - 1;
    assume LitInt(0) <= newtype$check#0;
    assume MultiSet#FromSeq(ys#0)[v#0] == MultiSet#FromSeq(xs#0)[v#0] - 1;
    goto anon11;

  anon22_Else:
    assume Seq#Contains(xs#0, v#0) ==> MultiSet#FromSeq(ys#0)[v#0] == MultiSet#FromSeq(xs#0)[v#0] - 1;
    goto anon11;

  anon11:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.RemoveValue$T), $Heap);
    assume Seq.__default.HasNoDuplicates#canCall(Seq._default.RemoveValue$T, xs#0);
    assume Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, xs#0);
    ##xs#1 := ys#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.RemoveValue$T), $Heap);
    assume Seq.__default.HasNoDuplicates#canCall(Seq._default.RemoveValue$T, ys#0);
    assume Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, ys#0);
    ##xs#2 := ys#0;
    assume $IsAlloc(##xs#2, TSeq(Seq._default.RemoveValue$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.RemoveValue$T, ys#0);
    ##xs#3 := xs#0;
    assume $IsAlloc(##xs#3, TSeq(Seq._default.RemoveValue$T), $Heap);
    assume Seq.__default.ToSet#canCall(Seq._default.RemoveValue$T, xs#0);
    assume Set#Equal(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, ys#0), Set#Difference(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, xs#0), Set#UnionOne(Set#Empty(): Set, v#0)));
    goto anon14;

  anon23_Else:
    assume Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, xs#0) ==> Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, ys#0) && Set#Equal(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, ys#0), Set#Difference(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, xs#0), Set#UnionOne(Set#Empty(): Set, v#0)));
    goto anon14;

  anon14:
    assume false;
    return;

  anon19_Else:
    call CallPre$$Seq.__default.reveal__HasNoDuplicates();
    call CallPost$$Seq.__default.reveal__HasNoDuplicates();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(346,27)"} true;
    call CallPre$$Seq.__default.reveal__ToSet();
    call CallPost$$Seq.__default.reveal__ToSet();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(347,17)"} true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} !Seq#Contains(xs#0, v#0);
    assume Seq.__default.RemoveValue(Seq._default.RemoveValue$T, reveal_Seq._default.RemoveValue, xs#0, v#0) == xs#0;
    assume true;
    assume $Is(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, reveal_Seq._default.RemoveValue, xs#0, v#0), TSeq(Seq._default.RemoveValue$T));
    goto anon18;

  anon24_Else:
    assume {:partition} Seq#Contains(xs#0, v#0);
    havoc i#Z#0;
    assume LitInt(0) <= i#Z#0;
    ##xs#4 := xs#0;
    assume $IsAlloc(##xs#4, TSeq(Seq._default.RemoveValue$T), $Heap);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, Seq._default.RemoveValue$T, $Heap);
    assume {:subsumption 0} Seq#Contains(##xs#4, ##v#0);
    assume Seq#Contains(##xs#4, ##v#0);
    assume Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0);
    assume let#0#0#0 == Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0);
    assume Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0);
    assume $Is(let#0#0#0, Tclass._System.nat());
    assume i#Z#0 == let#0#0#0;
    assume {:subsumption 0} 0 <= i#Z#0 && i#Z#0 <= Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= i#Z#0 + 1 && i#Z#0 + 1 <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(xs#0, Seq#Append(Seq#Append(Seq#Take(xs#0, i#Z#0), Seq#Build(Seq#Empty(): Seq, v#0)), Seq#Drop(xs#0, i#Z#0 + 1)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(351,44)"} true;
    assume 0 <= i#Z#0 && i#Z#0 <= Seq#Length(xs#0);
    assume 0 <= i#Z#0 + 1 && i#Z#0 + 1 <= Seq#Length(xs#0);
    assume Seq.__default.RemoveValue(Seq._default.RemoveValue$T, reveal_Seq._default.RemoveValue, xs#0, v#0) == Seq#Append(Seq#Take(xs#0, i#Z#0), Seq#Drop(xs#0, i#Z#0 + 1));
    assume true;
    assume $Is(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, reveal_Seq._default.RemoveValue, xs#0, v#0), TSeq(Seq._default.RemoveValue$T));
    goto anon18;

  anon18:
    assume Seq.__default.RemoveValue(Seq._default.RemoveValue$T, reveal_Seq._default.RemoveValue, xs#0, v#0) == ys#0;
    return;
}



function Seq.__default.Insert(Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#0: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#0), Seq#Index(xs#0, i#0) } LitInt(0) <= i#0 && i#0 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#0) == Seq#Index(xs#0, i#0)) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } pos#0 <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#1 + 1) == Seq#Index(xs#0, i#1)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { $IsAlloc(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T), $Heap) } (Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Insert$T), $Heap) && $IsBox(a#0, Seq._default.Insert$T) && $IsAllocBox(a#0, Seq._default.Insert$T, $Heap) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, true, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq.__default.Insert(Seq._default.Insert$T, true, xs#0, a#0, pos#0) == Seq#Append(Seq#Append(Seq#Take(xs#0, pos#0), Seq#Build(Seq#Empty(): Seq, a#0)), Seq#Drop(xs#0, pos#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: {:weight 3} { Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), a#0, LitInt(pos#0)) } Seq.__default.Insert#canCall(Seq._default.Insert$T, Lit(xs#0), a#0, LitInt(pos#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && LitInt(pos#0) <= Seq#Length(Lit(xs#0))) ==> Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), a#0, LitInt(pos#0)) == Seq#Append(Seq#Append(Seq#Take(Lit(xs#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq, a#0)), Seq#Drop(Lit(xs#0), LitInt(pos#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: {:weight 3} { Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), Lit(a#0), LitInt(pos#0)) } Seq.__default.Insert#canCall(Seq._default.Insert$T, Lit(xs#0), Lit(a#0), LitInt(pos#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && LitInt(pos#0) <= Seq#Length(Lit(xs#0))) ==> Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), Lit(a#0), LitInt(pos#0)) == Seq#Append(Seq#Append(Seq#Take(Lit(xs#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq, Lit(a#0))), Seq#Drop(Lit(xs#0), LitInt(pos#0))));
}

function Seq.__default.Insert#canCall(Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int) : bool;

function Seq.__default.Insert#requires(Ty, Seq, Box, int) : bool;

axiom (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert#requires(Seq._default.Insert$T, xs#0, a#0, pos#0) } $Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 ==> (Seq.__default.Insert#requires(Seq._default.Insert$T, xs#0, a#0, pos#0) <==> pos#0 <= Seq#Length(xs#0)));

procedure {:verboseName "Seq.Insert (well-formedness)"} CheckWellformed$$Seq.__default.Insert(Seq._default.Insert$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Insert$T)), a#0: Box where $IsBox(a#0, Seq._default.Insert$T), pos#0: int where LitInt(0) <= pos#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6185"} Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1;
  free ensures {:id "id6186"} (forall i#2: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#2), Seq#Index(xs#0, i#2) } LitInt(0) <= i#2 && i#2 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#2) == Seq#Index(xs#0, i#2));
  free ensures {:id "id6187"} (forall i#3: int :: { Seq#Index(xs#0, i#3) } pos#0 <= i#3 && i#3 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#3 + 1) == Seq#Index(xs#0, i#3));
  free ensures {:id "id6188"} Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0;
  free ensures {:id "id6189"} MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Insert (well-formedness)"} CheckWellformed$$Seq.__default.Insert(Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##a#0: Box;
  var ##pos#0: int;
  var i#4: int;
  var ##xs#1: Seq;
  var ##a#1: Box;
  var ##pos#1: int;
  var i#5: int;
  var ##xs#2: Seq;
  var ##a#2: Box;
  var ##pos#2: int;
  var ##xs#3: Seq;
  var ##a#3: Box;
  var ##pos#3: int;
  var ##xs#4: Seq;
  var ##a#4: Box;
  var ##pos#4: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.Insert", " | ", Seq._default.Insert$T, " | ", xs#0, " | ", a#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "int"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(356,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume pos#0 <= Seq#Length(xs#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T));
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.Insert$T), $Heap);
    ##a#0 := a#0;
    assume $IsAllocBox(##a#0, Seq._default.Insert$T, $Heap);
    ##pos#0 := pos#0;
    assume $IsAlloc(##pos#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#0 <= Seq#Length(##xs#0);
    assume ##pos#0 <= Seq#Length(##xs#0);
    assume 0 <= pos#0 || Seq#Rank(##xs#0) < Seq#Rank(xs#0) || ##pos#0 == pos#0;
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq#Rank(##xs#0) < Seq#Rank(xs#0) || (Seq#Rank(##xs#0) == Seq#Rank(xs#0) && ##pos#0 < pos#0);
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0);
    assume Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1;
    havoc i#4;
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon5;

  anon16_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#4 && i#4 < pos#0;
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.Insert$T), $Heap);
    ##a#1 := a#0;
    assume $IsAllocBox(##a#1, Seq._default.Insert$T, $Heap);
    ##pos#1 := pos#0;
    assume $IsAlloc(##pos#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#1 <= Seq#Length(##xs#1);
    assume ##pos#1 <= Seq#Length(##xs#1);
    assume 0 <= pos#0 || Seq#Rank(##xs#1) < Seq#Rank(xs#0) || ##pos#1 == pos#0;
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq#Rank(##xs#1) < Seq#Rank(xs#0) || (Seq#Rank(##xs#1) == Seq#Rank(xs#0) && ##pos#1 < pos#0);
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0);
    assume 0 <= i#4 && i#4 < Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0));
    assume 0 <= i#4 && i#4 < Seq#Length(xs#0);
    assume Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#4) == Seq#Index(xs#0, i#4);
    goto anon7;

  anon15_Else:
    assume LitInt(0) <= i#4 && i#4 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#4) == Seq#Index(xs#0, i#4);
    goto anon7;

  anon7:
    assume (forall i#2: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#2), Seq#Index(xs#0, i#2) } LitInt(0) <= i#2 && i#2 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#2) == Seq#Index(xs#0, i#2));
    havoc i#5;
    assume true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} pos#0 <= i#5;
    goto anon10;

  anon18_Else:
    assume {:partition} i#5 < pos#0;
    goto anon10;

  anon10:
    assume pos#0 <= i#5 && i#5 < Seq#Length(xs#0);
    ##xs#2 := xs#0;
    assume $IsAlloc(##xs#2, TSeq(Seq._default.Insert$T), $Heap);
    ##a#2 := a#0;
    assume $IsAllocBox(##a#2, Seq._default.Insert$T, $Heap);
    ##pos#2 := pos#0;
    assume $IsAlloc(##pos#2, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#2 <= Seq#Length(##xs#2);
    assume ##pos#2 <= Seq#Length(##xs#2);
    assume 0 <= pos#0 || Seq#Rank(##xs#2) < Seq#Rank(xs#0) || ##pos#2 == pos#0;
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq#Rank(##xs#2) < Seq#Rank(xs#0) || (Seq#Rank(##xs#2) == Seq#Rank(xs#0) && ##pos#2 < pos#0);
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0);
    assume 0 <= i#5 + 1 && i#5 + 1 < Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0));
    assume 0 <= i#5 && i#5 < Seq#Length(xs#0);
    assume Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#5 + 1) == Seq#Index(xs#0, i#5);
    goto anon12;

  anon17_Else:
    assume pos#0 <= i#5 && i#5 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#5 + 1) == Seq#Index(xs#0, i#5);
    goto anon12;

  anon12:
    assume (forall i#3: int :: { Seq#Index(xs#0, i#3) } pos#0 <= i#3 && i#3 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#3 + 1) == Seq#Index(xs#0, i#3));
    ##xs#3 := xs#0;
    assume $IsAlloc(##xs#3, TSeq(Seq._default.Insert$T), $Heap);
    ##a#3 := a#0;
    assume $IsAllocBox(##a#3, Seq._default.Insert$T, $Heap);
    ##pos#3 := pos#0;
    assume $IsAlloc(##pos#3, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#3 <= Seq#Length(##xs#3);
    assume ##pos#3 <= Seq#Length(##xs#3);
    assume 0 <= pos#0 || Seq#Rank(##xs#3) < Seq#Rank(xs#0) || ##pos#3 == pos#0;
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq#Rank(##xs#3) < Seq#Rank(xs#0) || (Seq#Rank(##xs#3) == Seq#Rank(xs#0) && ##pos#3 < pos#0);
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0);
    assume 0 <= pos#0 && pos#0 < Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0));
    assume Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0;
    ##xs#4 := xs#0;
    assume $IsAlloc(##xs#4, TSeq(Seq._default.Insert$T), $Heap);
    ##a#4 := a#0;
    assume $IsAllocBox(##a#4, Seq._default.Insert$T, $Heap);
    ##pos#4 := pos#0;
    assume $IsAlloc(##pos#4, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#4 <= Seq#Length(##xs#4);
    assume ##pos#4 <= Seq#Length(##xs#4);
    assume 0 <= pos#0 || Seq#Rank(##xs#4) < Seq#Rank(xs#0) || ##pos#4 == pos#0;
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq#Rank(##xs#4) < Seq#Rank(xs#0) || (Seq#Rank(##xs#4) == Seq#Rank(xs#0) && ##pos#4 < pos#0);
    assume (Seq#Equal(xs#0, xs#0) && a#0 == a#0 && pos#0 == pos#0) || Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0);
    assume MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0)));
    assume false;
    return;

  anon14_Else:
    assume {:subsumption 0} 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(xs#0, Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(364,38)"} true;
    assume 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume 0 <= pos#0 && pos#0 <= Seq#Length(xs#0);
    assume Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0) == Seq#Append(Seq#Append(Seq#Take(xs#0, pos#0), Seq#Build(Seq#Empty(): Seq, a#0)), Seq#Drop(xs#0, pos#0));
    assume true;
    assume $Is(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T));
    return;
}



function Seq.__default.Reverse(Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Reverse$T))) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#0: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#0) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#0 - 1) } LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#0) == Seq#Index(xs#0, Seq#Length(xs#0) - i#0 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { $IsAlloc(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T), $Heap) } (Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Reverse$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Reverse$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Reverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Reverse$T))) ==> (!Seq#Equal(xs#0, Seq#Empty(): Seq) ==> Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0)))) && Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, xs#0) == (if Seq#Equal(xs#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, Seq#Length(xs#0) - 1)), Seq.__default.Reverse(Seq._default.Reverse$T, $ly, reveal_Seq._default.Reverse, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0))))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Reverse$T: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, Lit(xs#0)) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Reverse$T))) ==> (!Seq#Equal(xs#0, Seq#Empty(): Seq) ==> Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Seq#Drop(Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), LitInt(0)))) && Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, Lit(xs#0)) == (if Seq#Equal(xs#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1)), Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), reveal_Seq._default.Reverse, Seq#Drop(Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), LitInt(0))))));
}

function Seq.__default.Reverse#canCall(Seq._default.Reverse$T: Ty, xs#0: Seq) : bool;

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), $reveal, xs#0) } Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), $reveal, xs#0) == Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, AsFuelBottom($ly), $reveal, xs#0) } Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) == Seq.__default.Reverse(Seq._default.Reverse$T, $LZ, $reveal, xs#0));

function Seq.__default.Reverse#requires(Ty, LayerType, Seq) : bool;

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Reverse#requires(Seq._default.Reverse$T, $ly, xs#0) } $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> (Seq.__default.Reverse#requires(Seq._default.Reverse$T, $ly, xs#0) <==> true));

procedure {:verboseName "Seq.Reverse (well-formedness)"} CheckWellformed$$Seq.__default.Reverse(Seq._default.Reverse$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Reverse$T))) returns (ys#0: Seq where $Is(ys#0, TSeq(Seq._default.Reverse$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6228"} Seq#Length(ys#0) == Seq#Length(xs#0);
  free ensures {:id "id6229"} (forall i#1: int :: { Seq#Index(ys#0, i#1) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#1 - 1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Index(ys#0, i#1) == Seq#Index(xs#0, Seq#Length(xs#0) - i#1 - 1));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Reverse (well-formedness)"} CheckWellformed$$Seq.__default.Reverse(Seq._default.Reverse$T: Ty, xs#0: Seq) returns (ys#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var ##xs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.Reverse", " | ", Seq._default.Reverse$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(369,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, xs#0), TSeq(Seq._default.Reverse$T));
    assume Seq#Length(ys#0) == Seq#Length(xs#0);
    havoc i#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon5;

  anon14_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0);
    assume 0 <= i#2 && i#2 < Seq#Length(ys#0);
    assume 0 <= Seq#Length(xs#0) - i#2 - 1 && Seq#Length(xs#0) - i#2 - 1 < Seq#Length(xs#0);
    assume Seq#Index(ys#0, i#2) == Seq#Index(xs#0, Seq#Length(xs#0) - i#2 - 1);
    goto anon7;

  anon13_Else:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> Seq#Index(ys#0, i#2) == Seq#Index(xs#0, Seq#Length(xs#0) - i#2 - 1);
    goto anon7;

  anon7:
    assume (forall i#1: int :: { Seq#Index(ys#0, i#1) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#1 - 1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Index(ys#0, i#1) == Seq#Index(xs#0, Seq#Length(xs#0) - i#1 - 1));
    assume false;
    return;

  anon12_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Equal(xs#0, Seq#Empty(): Seq);
    assume Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, xs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, xs#0), TSeq(Seq._default.Reverse$T));
    goto anon11;

  anon15_Else:
    assume {:partition} !Seq#Equal(xs#0, Seq#Empty(): Seq);
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 < Seq#Length(xs#0);
    assume 0 <= LitInt(0) && LitInt(0) <= Seq#Length(xs#0);
    assume LitInt(0) <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.Reverse$T), $Heap);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0)));
    assume Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, xs#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, Seq#Length(xs#0) - 1)), Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0))));
    assume Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0)));
    assume $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, xs#0), TSeq(Seq._default.Reverse$T));
    goto anon11;

  anon11:
    assume Seq.__default.Reverse(Seq._default.Reverse$T, $LS($LZ), reveal_Seq._default.Reverse, xs#0) == ys#0;
    return;
}



function Seq.__default.Repeat(Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || (0 < $FunctionContextHeight && $IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#0: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#0) } LitInt(0) <= i#0 && i#0 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#0) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { $IsAlloc(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T), $Heap) } (Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || (0 < $FunctionContextHeight && $IsBox(v#0, Seq._default.Repeat$T) && $IsAllocBox(v#0, Seq._default.Repeat$T, $Heap) && LitInt(0) <= length#0)) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || (0 < $FunctionContextHeight && $IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> (length#0 != LitInt(0) ==> Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0 - 1)) && Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, length#0) == (if length#0 == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, v#0), Seq.__default.Repeat(Seq._default.Repeat$T, $ly, reveal_Seq._default.Repeat, v#0, length#0 - 1))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: {:weight 3} { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, LitInt(length#0)) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, LitInt(length#0)) || (0 < $FunctionContextHeight && $IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> (LitInt(length#0) != LitInt(0) ==> Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, LitInt(length#0 - 1))) && Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, LitInt(length#0)) == (if LitInt(length#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, v#0), Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), reveal_Seq._default.Repeat, v#0, LitInt(length#0 - 1)))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: {:weight 3} { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, Lit(v#0), LitInt(length#0)) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, Lit(v#0), LitInt(length#0)) || (0 < $FunctionContextHeight && $IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> (LitInt(length#0) != LitInt(0) ==> Seq.__default.Repeat#canCall(Seq._default.Repeat$T, Lit(v#0), LitInt(length#0 - 1))) && Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, Lit(v#0), LitInt(length#0)) == (if LitInt(length#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Lit(v#0)), Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), reveal_Seq._default.Repeat, Lit(v#0), LitInt(length#0 - 1)))));
}

function Seq.__default.Repeat#canCall(Seq._default.Repeat$T: Ty, v#0: Box, length#0: int) : bool;

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), $reveal, v#0, length#0) } Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), $reveal, v#0, length#0) == Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, AsFuelBottom($ly), $reveal, v#0, length#0) } Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) == Seq.__default.Repeat(Seq._default.Repeat$T, $LZ, $reveal, v#0, length#0));

function Seq.__default.Repeat#requires(Ty, LayerType, Box, int) : bool;

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: { Seq.__default.Repeat#requires(Seq._default.Repeat$T, $ly, v#0, length#0) } $IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0 ==> (Seq.__default.Repeat#requires(Seq._default.Repeat$T, $ly, v#0, length#0) <==> true));

procedure {:verboseName "Seq.Repeat (well-formedness)"} CheckWellformed$$Seq.__default.Repeat(Seq._default.Repeat$T: Ty, v#0: Box where $IsBox(v#0, Seq._default.Repeat$T), length#0: int where LitInt(0) <= length#0) returns (xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Repeat$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6244"} Seq#Length(xs#0) == length#0;
  free ensures {:id "id6245"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Index(xs#0, i#1) == v#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Repeat (well-formedness)"} CheckWellformed$$Seq.__default.Repeat(Seq._default.Repeat$T: Ty, v#0: Box, length#0: int) returns (xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var ##v#0: Box;
  var ##length#0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.Repeat", " | ", Seq._default.Repeat$T, " | ", v#0, " | ", length#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "int"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(377,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0), TSeq(Seq._default.Repeat$T));
    assume Seq#Length(xs#0) == length#0;
    havoc i#2;
    assume LitInt(0) <= i#2;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume i#2 < Seq#Length(xs#0);
    assume 0 <= i#2 && i#2 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, i#2) == v#0;
    goto anon5;

  anon11_Else:
    assume i#2 < Seq#Length(xs#0) ==> Seq#Index(xs#0, i#2) == v#0;
    goto anon5;

  anon5:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Index(xs#0, i#1) == v#0);
    assume false;
    return;

  anon10_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} length#0 == LitInt(0);
    assume Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0), TSeq(Seq._default.Repeat$T));
    goto anon9;

  anon12_Else:
    assume {:partition} length#0 != LitInt(0);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, Seq._default.Repeat$T, $Heap);
    assume $Is(length#0 - 1, Tclass._System.nat());
    ##length#0 := length#0 - 1;
    assume $IsAlloc(##length#0, Tclass._System.nat(), $Heap);
    assume 0 <= length#0 || ##length#0 == length#0;
    assume ##length#0 < length#0;
    assume Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0 - 1);
    assume Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, v#0), Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0 - 1));
    assume Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0 - 1);
    assume $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0), TSeq(Seq._default.Repeat$T));
    goto anon9;

  anon9:
    assume Seq.__default.Repeat(Seq._default.Repeat$T, $LS($LZ), reveal_Seq._default.Repeat, v#0, length#0) == xs#0;
    return;
}



function Seq.__default.Unzip(Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#0: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#0) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#0) } LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#0), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#0)), $Unbox(Seq#Index(xs#0, i#0)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { $IsAlloc(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)), $Heap) } (Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) && $IsAlloc(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#0, b#0 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#0, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#1, b#1 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#1, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#1, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));
}

function Seq.__default.Unzip#canCall(Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, xs#0: Seq) : bool;

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), $reveal, xs#0) } Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), $reveal, xs#0) == Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, AsFuelBottom($ly), $reveal, xs#0) } Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) == Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LZ, $reveal, xs#0));

function Seq.__default.Unzip#requires(Ty, Ty, LayerType, Seq) : bool;

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip#requires(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, xs#0) } $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq.__default.Unzip#requires(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, xs#0) <==> true));

procedure {:verboseName "Seq.Unzip (well-formedness)"} CheckWellformed$$Seq.__default.Unzip(Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, xs#0: Seq where $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6258"} Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq);
  free ensures {:id "id6259"} Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0);
  free ensures {:id "id6260"} (forall i#1: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq, i#1) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq, i#1), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq, i#1)), $Unbox(Seq#Index(xs#0, i#1)): DatatypeType));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Unzip (well-formedness)"} CheckWellformed$$Seq.__default.Unzip(Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var i#2: int;
  var ##xs#3: Seq;
  var ##xs#4: Seq;
  var a#Z#0: Seq;
  var b#Z#0: Seq;
  var let#0#0#0: DatatypeType;
  var ##xs#5: Seq;
  var ##xs#6: Seq;
  var ##xs#7: Seq;
  var ##xs#8: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.Unzip", " | ", Seq._default.Unzip$A, " | ", Seq._default.Unzip$B, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(388,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)));
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#1) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
    ##xs#2 := xs#0;
    assume $IsAlloc(##xs#2, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#2) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    goto anon4;

  anon14_Else:
    assume {:partition} Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq) != Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
    goto anon4;

  anon4:
    assume Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0);
    havoc i#2;
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon7;

  anon16_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon7;

  anon7:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0);
    ##xs#3 := xs#0;
    assume $IsAlloc(##xs#3, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#3) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume 0 <= i#2 && i#2 < Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
    ##xs#4 := xs#0;
    assume $IsAlloc(##xs#4, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#4) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume 0 <= i#2 && i#2 < Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
    assume 0 <= i#2 && i#2 < Seq#Length(xs#0);
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#2), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#2)), $Unbox(Seq#Index(xs#0, i#2)): DatatypeType);
    goto anon9;

  anon15_Else:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#2), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#2)), $Unbox(Seq#Index(xs#0, i#2)): DatatypeType);
    goto anon9;

  anon9:
    assume (forall i#1: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#1) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#1), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, i#1)), $Unbox(Seq#Index(xs#0, i#1)): DatatypeType));
    assume false;
    return;

  anon13_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0) == Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))));
    assume true;
    assume $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)));
    return;

  anon17_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    havoc a#Z#0;
    havoc b#Z#0;
    assume $Is(a#Z#0, TSeq(Seq._default.Unzip$A)) && $IsAlloc(a#Z#0, TSeq(Seq._default.Unzip$A), $Heap) && $Is(b#Z#0, TSeq(Seq._default.Unzip$B)) && $IsAlloc(b#Z#0, TSeq(Seq._default.Unzip$B), $Heap);
    ##xs#5 := xs#0;
    assume $IsAlloc(##xs#5, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#5) > 0;
    assume Seq#Length(##xs#5) > 0;
    assume Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0);
    ##xs#6 := Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0);
    assume $IsAlloc(##xs#6, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume Seq#Rank(##xs#6) < Seq#Rank(xs#0);
    assume Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)));
    assume let#0#0#0 == Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0));
    assume Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0));
    assume $Is(let#0#0#0, Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)));
    assume _System.Tuple2.___hMake2_q(let#0#0#0);
    assume #_System._tuple#2._#Make2($Box(a#Z#0), $Box(b#Z#0)) == let#0#0#0;
    ##xs#7 := xs#0;
    assume $IsAlloc(##xs#7, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#7) > 0;
    assume Seq#Length(##xs#7) > 0;
    assume Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType);
    assume _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType);
    ##xs#8 := xs#0;
    assume $IsAlloc(##xs#8, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#8) > 0;
    assume Seq#Length(##xs#8) > 0;
    assume Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType);
    assume _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType);
    assume Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0) == #_System._tuple#2._#Make2($Box(Seq#Append(a#Z#0, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#Z#0, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))));
    assume Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType);
    assume $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)));
    return;
}



function Seq.__default.Zip(Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || (2 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#0: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#0)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#0), Seq#Index(ys#0, i#0)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { $IsAlloc(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)), $Heap) } (Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || (2 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Zip$A)) && $IsAlloc(xs#0, TSeq(Seq._default.Zip$A), $Heap) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && $IsAlloc(ys#0, TSeq(Seq._default.Zip$B), $Heap) && Seq#Length(xs#0) == Seq#Length(ys#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || (2 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Seq._default.Zip$A, xs#0) && Seq.__default.DropLast#canCall(Seq._default.Zip$B, ys#0) && Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0)) && Seq.__default.Last#canCall(Seq._default.Zip$A, xs#0) && Seq.__default.Last#canCall(Seq._default.Zip$B, ys#0)) && Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, xs#0, ys#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0)), Seq#Build(Seq#Empty(): Seq, $Box(#_System._tuple#2._#Make2(Seq.__default.Last(Seq._default.Zip$A, xs#0), Seq.__default.Last(Seq._default.Zip$B, ys#0)))))));
axiom 2 <= $FunctionContextHeight ==> (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, xs#0: Seq, ys#0: Seq :: {:weight 3} { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, Lit(xs#0), Lit(ys#0)) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Lit(xs#0), Lit(ys#0)) || (2 < $FunctionContextHeight && $Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(Lit(xs#0)) == Seq#Length(Lit(ys#0))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Seq._default.Zip$A, Lit(xs#0)) && Seq.__default.DropLast#canCall(Seq._default.Zip$B, Lit(ys#0)) && Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Lit(Seq.__default.DropLast(Seq._default.Zip$A, Lit(xs#0))), Lit(Seq.__default.DropLast(Seq._default.Zip$B, Lit(ys#0)))) && Seq.__default.Last#canCall(Seq._default.Zip$A, Lit(xs#0)) && Seq.__default.Last#canCall(Seq._default.Zip$B, Lit(ys#0))) && Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, Lit(xs#0), Lit(ys#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), reveal_Seq._default.Zip, Lit(Seq.__default.DropLast(Seq._default.Zip$A, Lit(xs#0))), Lit(Seq.__default.DropLast(Seq._default.Zip$B, Lit(ys#0)))), Seq#Build(Seq#Empty(): Seq, $Box(Lit(#_System._tuple#2._#Make2(Lit(Seq.__default.Last(Seq._default.Zip$A, Lit(xs#0))), Lit(Seq.__default.Last(Seq._default.Zip$B, Lit(ys#0))))))))));
}

function Seq.__default.Zip#canCall(Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, xs#0: Seq, ys#0: Seq) : bool;

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), $reveal, xs#0, ys#0) } Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), $reveal, xs#0, ys#0) == Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, AsFuelBottom($ly), $reveal, xs#0, ys#0) } Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) == Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LZ, $reveal, xs#0, ys#0));

function Seq.__default.Zip#requires(Ty, Ty, LayerType, Seq, Seq) : bool;

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip#requires(Seq._default.Zip$A, Seq._default.Zip$B, $ly, xs#0, ys#0) } $Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) ==> (Seq.__default.Zip#requires(Seq._default.Zip$A, Seq._default.Zip$B, $ly, xs#0, ys#0) <==> Seq#Length(xs#0) == Seq#Length(ys#0)));

procedure {:verboseName "Seq.Zip (well-formedness)"} CheckWellformed$$Seq.__default.Zip(Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Zip$A)), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.Zip$B)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6282"} Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0);
  free ensures {:id "id6283"} (forall i#1: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, xs#0, ys#0), i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, xs#0, ys#0), i#1)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#1), Seq#Index(ys#0, i#1))));
  free ensures {:id "id6284"} Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0);
  free ensures {:id "id6285"} Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Zip (well-formedness)"} CheckWellformed$$Seq.__default.Zip(Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##ys#0: Seq;
  var i#2: int;
  var ##xs#1: Seq;
  var ##ys#1: Seq;
  var ##xs#2: Seq;
  var ##ys#2: Seq;
  var ##xs#3: Seq;
  var ##ys#3: Seq;
  var ##xs#4: Seq;
  var ##xs#5: Seq;
  var ##ys#4: Seq;
  var ##xs#6: Seq;
  var ##xs#7: Seq;
  var ##xs#8: Seq;
  var ##xs#9: Seq;
  var ##ys#5: Seq;
  var ##xs#10: Seq;
  var ##xs#11: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.Zip", " | ", Seq._default.Zip$A, " | ", Seq._default.Zip$B, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(400,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(xs#0) == Seq#Length(ys#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)));
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.Zip$A), $Heap);
    ##ys#0 := ys#0;
    assume $IsAlloc(##ys#0, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#0) == Seq#Length(##ys#0);
    assume Seq#Length(##xs#0) == Seq#Length(##ys#0);
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq#Rank(##xs#0) < Seq#Rank(xs#0) || (Seq#Rank(##xs#0) == Seq#Rank(xs#0) && Seq#Rank(##ys#0) < Seq#Rank(ys#0));
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0);
    assume Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0);
    havoc i#2;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= i#2;
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.Zip$A), $Heap);
    ##ys#1 := ys#0;
    assume $IsAlloc(##ys#1, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1) == Seq#Length(##ys#1);
    assume Seq#Length(##xs#1) == Seq#Length(##ys#1);
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq#Rank(##xs#1) < Seq#Rank(xs#0) || (Seq#Rank(##xs#1) == Seq#Rank(xs#0) && Seq#Rank(##ys#1) < Seq#Rank(ys#0));
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0);
    goto anon5;

  anon13_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0));
    ##xs#2 := xs#0;
    assume $IsAlloc(##xs#2, TSeq(Seq._default.Zip$A), $Heap);
    ##ys#2 := ys#0;
    assume $IsAlloc(##ys#2, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#2) == Seq#Length(##ys#2);
    assume Seq#Length(##xs#2) == Seq#Length(##ys#2);
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq#Rank(##xs#2) < Seq#Rank(xs#0) || (Seq#Rank(##xs#2) == Seq#Rank(xs#0) && Seq#Rank(##ys#2) < Seq#Rank(ys#0));
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0);
    assume 0 <= i#2 && i#2 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0));
    assume 0 <= i#2 && i#2 < Seq#Length(xs#0);
    assume 0 <= i#2 && i#2 < Seq#Length(ys#0);
    assume _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), i#2)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#2), Seq#Index(ys#0, i#2)));
    goto anon7;

  anon12_Else:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), i#2)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#2), Seq#Index(ys#0, i#2)));
    goto anon7;

  anon7:
    assume (forall i#1: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), i#1)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#1), Seq#Index(ys#0, i#1))));
    ##xs#3 := xs#0;
    assume $IsAlloc(##xs#3, TSeq(Seq._default.Zip$A), $Heap);
    ##ys#3 := ys#0;
    assume $IsAlloc(##ys#3, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#3) == Seq#Length(##ys#3);
    assume Seq#Length(##xs#3) == Seq#Length(##ys#3);
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq#Rank(##xs#3) < Seq#Rank(xs#0) || (Seq#Rank(##xs#3) == Seq#Rank(xs#0) && Seq#Rank(##ys#3) < Seq#Rank(ys#0));
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0);
    ##xs#4 := Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0);
    assume $IsAlloc(##xs#4, TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)), $Heap);
    assume Seq.__default.Unzip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)));
    assume Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0);
    ##xs#5 := xs#0;
    assume $IsAlloc(##xs#5, TSeq(Seq._default.Zip$A), $Heap);
    ##ys#4 := ys#0;
    assume $IsAlloc(##ys#4, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#5) == Seq#Length(##ys#4);
    assume Seq#Length(##xs#5) == Seq#Length(##ys#4);
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq#Rank(##xs#5) < Seq#Rank(xs#0) || (Seq#Rank(##xs#5) == Seq#Rank(xs#0) && Seq#Rank(##ys#4) < Seq#Rank(ys#0));
    assume (Seq#Equal(xs#0, xs#0) && Seq#Equal(ys#0, ys#0)) || Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0);
    ##xs#6 := Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0);
    assume $IsAlloc(##xs#6, TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)), $Heap);
    assume Seq.__default.Unzip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)));
    assume Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0);
    assume false;
    return;

  anon11_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)));
    return;

  anon14_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    ##xs#7 := xs#0;
    assume $IsAlloc(##xs#7, TSeq(Seq._default.Zip$A), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#7) > 0;
    assume Seq#Length(##xs#7) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.Zip$A, xs#0);
    ##xs#8 := ys#0;
    assume $IsAlloc(##xs#8, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#8) > 0;
    assume Seq#Length(##xs#8) > 0;
    assume Seq.__default.DropLast#canCall(Seq._default.Zip$B, ys#0);
    ##xs#9 := Seq.__default.DropLast(Seq._default.Zip$A, xs#0);
    assume $IsAlloc(##xs#9, TSeq(Seq._default.Zip$A), $Heap);
    ##ys#5 := Seq.__default.DropLast(Seq._default.Zip$B, ys#0);
    assume $IsAlloc(##ys#5, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#9) == Seq#Length(##ys#5);
    assume Seq#Length(##xs#9) == Seq#Length(##ys#5);
    assume Seq#Rank(##xs#9) < Seq#Rank(xs#0) || (Seq#Rank(##xs#9) == Seq#Rank(xs#0) && Seq#Rank(##ys#5) < Seq#Rank(ys#0));
    assume Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0));
    ##xs#10 := xs#0;
    assume $IsAlloc(##xs#10, TSeq(Seq._default.Zip$A), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#10) > 0;
    assume Seq#Length(##xs#10) > 0;
    assume Seq.__default.Last#canCall(Seq._default.Zip$A, xs#0);
    ##xs#11 := ys#0;
    assume $IsAlloc(##xs#11, TSeq(Seq._default.Zip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#11) > 0;
    assume Seq#Length(##xs#11) > 0;
    assume Seq.__default.Last#canCall(Seq._default.Zip$B, ys#0);
    assume Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0) == Seq#Append(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0)), Seq#Build(Seq#Empty(): Seq, $Box(#_System._tuple#2._#Make2(Seq.__default.Last(Seq._default.Zip$A, xs#0), Seq.__default.Last(Seq._default.Zip$B, ys#0)))));
    assume Seq.__default.DropLast#canCall(Seq._default.Zip$A, xs#0) && Seq.__default.DropLast#canCall(Seq._default.Zip$B, ys#0) && Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0)) && Seq.__default.Last#canCall(Seq._default.Zip$A, xs#0) && Seq.__default.Last#canCall(Seq._default.Zip$B, ys#0);
    assume $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Zip, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)));
    return;
}



procedure {:verboseName "Seq.LemmaZipOfUnzip (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq where $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B))) && $IsAlloc(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B)), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaZipOfUnzip (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##ys#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaZipOfUnzip", " | ", Seq._default.LemmaZipOfUnzip$A, " | ", Seq._default.LemmaZipOfUnzip$B, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(412,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(413,42): post-state"} true;
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B)), $Heap);
    assume Seq.__default.Unzip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B)), $Heap);
    assume Seq.__default.Unzip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0);
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    assume _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0));
    ##xs#2 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq;
    assume $IsAlloc(##xs#2, TSeq(Seq._default.LemmaZipOfUnzip$A), $Heap);
    ##ys#0 := $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq;
    assume $IsAlloc(##ys#0, TSeq(Seq._default.LemmaZipOfUnzip$B), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#2) == Seq#Length(##ys#0);
    assume Seq#Length(##xs#2) == Seq#Length(##ys#0);
    assume Seq.__default.Zip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
    assume Seq#Equal(Seq.__default.Zip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Zip, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq), xs#0);
    return;
}



procedure {:verboseName "Seq.LemmaZipOfUnzip (call precondtion)"} CallPre$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq where $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B))) && $IsAlloc(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B)), $Heap));



procedure {:verboseName "Seq.LemmaZipOfUnzip (call postcondition)"} CallPost$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq where $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B))) && $IsAlloc(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B)), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Unzip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0) && _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0)) && Seq.__default.Unzip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0) && _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0)) && Seq.__default.Zip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
  free ensures {:id "id6317"} Seq#Equal(Seq.__default.Zip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq), xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaZipOfUnzip (correctness)"} Impl$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq where $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B))) && $IsAlloc(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B)), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.Unzip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0) && _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0)) && Seq.__default.Unzip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0) && _System.Tuple2.___hMake2_q(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0)) && Seq.__default.Zip#canCall(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, xs#0))): Seq);
  free ensures {:id "id6318"} Seq#Equal(Seq.__default.Zip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LS($LZ)), reveal_Seq._default.Zip, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LS($LZ)), reveal_Seq._default.Unzip, xs#0))): Seq), xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaZipOfUnzip (correctness)"} Impl$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaZipOfUnzip", " | ", Seq._default.LemmaZipOfUnzip$A, " | ", Seq._default.LemmaZipOfUnzip$B, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(414,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq :: $Is($ih#xs0#0, TSeq(Tclass._System.Tuple2(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B))) && Lit(true) && Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) ==> Seq#Equal(Seq.__default.Zip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Zip, $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, $ih#xs0#0))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, $LS($LZ), reveal_Seq._default.Unzip, $ih#xs0#0))): Seq), $ih#xs0#0));
    $_reverifyPost := false;
    return;
}



function Seq.__default.Max($ly: LayerType, $reveal: bool, xs#0: Seq) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#0: int :: { Seq#Contains(xs#0, $Box(k#0)) } Seq#Contains(xs#0, $Box(k#0)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#0) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, xs#0: Seq :: { Seq.__default.Max($LS($ly), true, xs#0) } Seq.__default.Max#canCall(xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (Seq#Length(xs#0) != LitInt(1) ==> Seq.__default.Max#canCall(Seq#Drop(xs#0, LitInt(1))) && Math.__default.Max#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($ly, reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))))) && Seq.__default.Max($LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(1) then $Unbox(Seq#Index(xs#0, LitInt(0))): int else Math.__default.Max($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($ly, reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Max($LS($ly), true, Lit(xs#0)) } Seq.__default.Max#canCall(Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(Lit(xs#0))) ==> (Seq#Length(Lit(xs#0)) != LitInt(1) ==> Seq.__default.Max#canCall(Lit(Seq#Drop(Lit(xs#0), LitInt(1)))) && Math.__default.Max#canCall($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Max($LS($ly), reveal_Seq._default.Max, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))) && Seq.__default.Max($LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int else Math.__default.Max($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Max($LS($ly), reveal_Seq._default.Max, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))));
}

function Seq.__default.Max#canCall(xs#0: Seq) : bool;

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($LS($ly), $reveal, xs#0) } Seq.__default.Max($LS($ly), $reveal, xs#0) == Seq.__default.Max($ly, $reveal, xs#0));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max(AsFuelBottom($ly), $reveal, xs#0) } Seq.__default.Max($ly, $reveal, xs#0) == Seq.__default.Max($LZ, $reveal, xs#0));

function Seq.__default.Max#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, xs#0: Seq :: { Seq.__default.Max#requires($ly, xs#0) } $Is(xs#0, TSeq(TInt)) ==> (Seq.__default.Max#requires($ly, xs#0) <==> 0 < Seq#Length(xs#0)));

procedure {:verboseName "Seq.Max (well-formedness)"} CheckWellformed$$Seq.__default.Max(xs#0: Seq where $Is(xs#0, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6319"} (forall k#1: int :: { Seq#Contains(xs#0, $Box(k#1)) } Seq#Contains(xs#0, $Box(k#1)) ==> Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, xs#0) >= k#1);
  free ensures {:id "id6320"} Seq#Contains(xs#0, $Box(Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, xs#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Max (well-formedness)"} CheckWellformed$$Seq.__default.Max(xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#2: int;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##a#0: int;
  var ##b#0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.Max", " | ", xs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(424,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume 0 < Seq#Length(xs#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc k#2;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(xs#0, $Box(k#2));
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0);
    assume 0 < Seq#Length(##xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Max#canCall(xs#0);
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0) >= k#2;
    goto anon5;

  anon10_Else:
    assume Seq#Contains(xs#0, $Box(k#2)) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0) >= k#2;
    goto anon5;

  anon5:
    assume (forall k#1: int :: { Seq#Contains(xs#0, $Box(k#1)) } Seq#Contains(xs#0, $Box(k#1)) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0) >= k#1);
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#1);
    assume 0 < Seq#Length(##xs#1);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#1) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Max#canCall(xs#0);
    assume Seq#Contains(xs#0, $Box(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0)));
    assume false;
    return;

  anon9_Else:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(xs#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(429,34)"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0) == $Unbox(Seq#Index(xs#0, LitInt(0))): int;
    assume true;
    assume $Is(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0), TInt);
    return;

  anon11_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#2 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#2, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#2);
    assume 0 < Seq#Length(##xs#2);
    assume Seq#Rank(##xs#2) < Seq#Rank(xs#0);
    assume Seq.__default.Max#canCall(Seq#Drop(xs#0, LitInt(1)));
    ##a#0 := $Unbox(Seq#Index(xs#0, LitInt(0))): int;
    assume $IsAlloc(##a#0, TInt, $Heap);
    ##b#0 := Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1)));
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume Math.__default.Max#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))));
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0) == Math.__default.Max($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))));
    assume Seq.__default.Max#canCall(Seq#Drop(xs#0, LitInt(1))) && Math.__default.Max#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))));
    assume $Is(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0), TInt);
    return;
}



procedure {:verboseName "Seq.LemmaMaxOfConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMaxOfConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq, ys#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var i#0: int;
  var ##xs#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMaxOfConcat", " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(435,8): initial state"} true;
    assume 0 < Seq#Length(xs#0);
    assume 0 < Seq#Length(ys#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(437,23): post-state"} true;
    ##xs#0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0);
    assume 0 < Seq#Length(##xs#0);
    assume Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0));
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#1);
    assume 0 < Seq#Length(##xs#1);
    assume Seq.__default.Max#canCall(xs#0);
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0);
    ##xs#2 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#2, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#2);
    assume 0 < Seq#Length(##xs#2);
    assume Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0));
    ##xs#3 := ys#0;
    assume $IsAlloc(##xs#3, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#3);
    assume 0 < Seq#Length(##xs#3);
    assume Seq.__default.Max#canCall(ys#0);
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, ys#0);
    havoc i#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#0));
    ##xs#4 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#4, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#4);
    assume 0 < Seq#Length(##xs#4);
    assume Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0));
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= i#0;
    goto anon4;

  anon5_Else:
    assume Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#0)) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= i#0;
    goto anon4;

  anon4:
    assume (forall i#1: int :: { Seq#Contains(Seq#Build(Seq#Empty(): Seq, $Box(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)))), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= i#1);
    return;
}



procedure {:verboseName "Seq.LemmaMaxOfConcat (call precondtion)"} CallPre$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap));
  requires {:id "id6354"} 0 < Seq#Length(xs#0);
  requires {:id "id6355"} 0 < Seq#Length(ys#0);



procedure {:verboseName "Seq.LemmaMaxOfConcat (call postcondition)"} CallPost$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Max#canCall(xs#0);
  free ensures {:id "id6356"} Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, xs#0);
  free ensures Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Max#canCall(ys#0);
  free ensures {:id "id6357"} Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, ys#0);
  free ensures (forall i#1: int :: { Seq#Contains(Seq#Build(Seq#Empty(): Seq, $Box(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)))), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0)));
  free ensures {:id "id6358"} (forall i#1: int :: { Seq#Contains(Seq#Build(Seq#Empty(): Seq, $Box(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)))), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= i#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaMaxOfConcat (correctness)"} Impl$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6359"} 0 < Seq#Length(xs#0);
  requires {:id "id6360"} 0 < Seq#Length(ys#0);
  modifies $Heap;
  free ensures Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Max#canCall(xs#0);
  free ensures {:id "id6361"} Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, xs#0);
  free ensures Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Max#canCall(ys#0);
  free ensures {:id "id6362"} Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, ys#0);
  free ensures (forall i#1: int :: { Seq#Contains(Seq#Build(Seq#Empty(): Seq, $Box(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)))), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Max#canCall(Seq#Append(xs#0, ys#0)));
  free ensures {:id "id6363"} (forall i#1: int :: { Seq#Contains(Seq#Build(Seq#Empty(): Seq, $Box(Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)))), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Append(xs#0, ys#0)) >= i#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMaxOfConcat (correctness)"} Impl$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var xs##1_0: Seq;
  var ys##1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMaxOfConcat", " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(440,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#xs0#0, TSeq(TInt)) && $Is($ih#ys0#0, TSeq(TInt)) && 0 < Seq#Length($ih#xs0#0) && 0 < Seq#Length($ih#ys0#0) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append($ih#xs0#0, $ih#ys0#0)) >= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, $ih#xs0#0) && Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append($ih#xs0#0, $ih#ys0#0)) >= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, $ih#ys0#0) && (forall i#2: int :: { Seq#Contains(Seq#Build(Seq#Empty(): Seq, $Box(Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append($ih#xs0#0, $ih#ys0#0)))), $Box(i#2)) } Seq#Contains(Seq#Append($ih#xs0#0, $ih#ys0#0), $Box(i#2)) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Append($ih#xs0#0, $ih#ys0#0)) >= i#2));
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__Max();
    call CallPost$$Seq.__default.reveal__Max();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(441,15)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(1);
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(1);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(444,43)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    xs##1_0 := Seq#Drop(xs#0, LitInt(1));
    assume true;
    ys##1_0 := ys#0;
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0) || (Seq#Rank(xs##1_0) == Seq#Rank(xs#0) && Seq#Rank(ys##1_0) < Seq#Rank(ys#0));
    call CallPre$$Seq.__default.LemmaMaxOfConcat(xs##1_0, ys##1_0);
    call CallPost$$Seq.__default.LemmaMaxOfConcat(xs##1_0, ys##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(445,35)"} true;
    return;
}



function Seq.__default.Min($ly: LayerType, $reveal: bool, xs#0: Seq) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#0: int :: { Seq#Contains(xs#0, $Box(k#0)) } Seq#Contains(xs#0, $Box(k#0)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#0) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, xs#0: Seq :: { Seq.__default.Min($LS($ly), true, xs#0) } Seq.__default.Min#canCall(xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (Seq#Length(xs#0) != LitInt(1) ==> Seq.__default.Min#canCall(Seq#Drop(xs#0, LitInt(1))) && Math.__default.Min#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($ly, reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))))) && Seq.__default.Min($LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(1) then $Unbox(Seq#Index(xs#0, LitInt(0))): int else Math.__default.Min($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($ly, reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Min($LS($ly), true, Lit(xs#0)) } Seq.__default.Min#canCall(Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(Lit(xs#0))) ==> (Seq#Length(Lit(xs#0)) != LitInt(1) ==> Seq.__default.Min#canCall(Lit(Seq#Drop(Lit(xs#0), LitInt(1)))) && Math.__default.Min#canCall($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Min($LS($ly), reveal_Seq._default.Min, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))) && Seq.__default.Min($LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int else Math.__default.Min($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Min($LS($ly), reveal_Seq._default.Min, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))));
}

function Seq.__default.Min#canCall(xs#0: Seq) : bool;

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($LS($ly), $reveal, xs#0) } Seq.__default.Min($LS($ly), $reveal, xs#0) == Seq.__default.Min($ly, $reveal, xs#0));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min(AsFuelBottom($ly), $reveal, xs#0) } Seq.__default.Min($ly, $reveal, xs#0) == Seq.__default.Min($LZ, $reveal, xs#0));

function Seq.__default.Min#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, xs#0: Seq :: { Seq.__default.Min#requires($ly, xs#0) } $Is(xs#0, TSeq(TInt)) ==> (Seq.__default.Min#requires($ly, xs#0) <==> 0 < Seq#Length(xs#0)));

procedure {:verboseName "Seq.Min (well-formedness)"} CheckWellformed$$Seq.__default.Min(xs#0: Seq where $Is(xs#0, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6373"} (forall k#1: int :: { Seq#Contains(xs#0, $Box(k#1)) } Seq#Contains(xs#0, $Box(k#1)) ==> Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, xs#0) <= k#1);
  free ensures {:id "id6374"} Seq#Contains(xs#0, $Box(Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, xs#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Min (well-formedness)"} CheckWellformed$$Seq.__default.Min(xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#2: int;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##a#0: int;
  var ##b#0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.Min", " | ", xs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(450,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume 0 < Seq#Length(xs#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc k#2;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(xs#0, $Box(k#2));
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0);
    assume 0 < Seq#Length(##xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Min#canCall(xs#0);
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0) <= k#2;
    goto anon5;

  anon10_Else:
    assume Seq#Contains(xs#0, $Box(k#2)) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0) <= k#2;
    goto anon5;

  anon5:
    assume (forall k#1: int :: { Seq#Contains(xs#0, $Box(k#1)) } Seq#Contains(xs#0, $Box(k#1)) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0) <= k#1);
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#1);
    assume 0 < Seq#Length(##xs#1);
    assume Seq#Equal(xs#0, xs#0) || Seq#Rank(##xs#1) < Seq#Rank(xs#0);
    assume Seq#Equal(xs#0, xs#0) || Seq.__default.Min#canCall(xs#0);
    assume Seq#Contains(xs#0, $Box(Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0)));
    assume false;
    return;

  anon9_Else:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(xs#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(455,34)"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0) == $Unbox(Seq#Index(xs#0, LitInt(0))): int;
    assume true;
    assume $Is(Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0), TInt);
    return;

  anon11_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#2 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#2, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#2);
    assume 0 < Seq#Length(##xs#2);
    assume Seq#Rank(##xs#2) < Seq#Rank(xs#0);
    assume Seq.__default.Min#canCall(Seq#Drop(xs#0, LitInt(1)));
    ##a#0 := $Unbox(Seq#Index(xs#0, LitInt(0))): int;
    assume $IsAlloc(##a#0, TInt, $Heap);
    ##b#0 := Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1)));
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume Math.__default.Min#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))));
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0) == Math.__default.Min($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))));
    assume Seq.__default.Min#canCall(Seq#Drop(xs#0, LitInt(1))) && Math.__default.Min#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))));
    assume $Is(Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0), TInt);
    return;
}



procedure {:verboseName "Seq.LemmaMinOfConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMinOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMinOfConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMinOfConcat(xs#0: Seq, ys#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var i#0: int;
  var ##xs#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMinOfConcat", " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(461,8): initial state"} true;
    assume 0 < Seq#Length(xs#0);
    assume 0 < Seq#Length(ys#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(463,23): post-state"} true;
    ##xs#0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0);
    assume 0 < Seq#Length(##xs#0);
    assume Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0));
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#1);
    assume 0 < Seq#Length(##xs#1);
    assume Seq.__default.Min#canCall(xs#0);
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0);
    ##xs#2 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#2, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#2);
    assume 0 < Seq#Length(##xs#2);
    assume Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0));
    ##xs#3 := ys#0;
    assume $IsAlloc(##xs#3, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#3);
    assume 0 < Seq#Length(##xs#3);
    assume Seq.__default.Min#canCall(ys#0);
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, ys#0);
    havoc i#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#0));
    ##xs#4 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#4, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#4);
    assume 0 < Seq#Length(##xs#4);
    assume Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0));
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= i#0;
    goto anon4;

  anon5_Else:
    assume Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#0)) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= i#0;
    goto anon4;

  anon4:
    assume (forall i#1: int :: { Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= i#1);
    return;
}



procedure {:verboseName "Seq.LemmaMinOfConcat (call precondtion)"} CallPre$$Seq.__default.LemmaMinOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap));
  requires {:id "id6408"} 0 < Seq#Length(xs#0);
  requires {:id "id6409"} 0 < Seq#Length(ys#0);



procedure {:verboseName "Seq.LemmaMinOfConcat (call postcondition)"} CallPost$$Seq.__default.LemmaMinOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Min#canCall(xs#0);
  free ensures {:id "id6410"} Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, xs#0);
  free ensures Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Min#canCall(ys#0);
  free ensures {:id "id6411"} Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, ys#0);
  free ensures (forall i#1: int :: { Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0)));
  free ensures {:id "id6412"} (forall i#1: int :: { Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= i#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaMinOfConcat (correctness)"} Impl$$Seq.__default.LemmaMinOfConcat(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TInt)) && $IsAlloc(ys#0, TSeq(TInt), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6413"} 0 < Seq#Length(xs#0);
  requires {:id "id6414"} 0 < Seq#Length(ys#0);
  modifies $Heap;
  free ensures Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Min#canCall(xs#0);
  free ensures {:id "id6415"} Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, xs#0);
  free ensures Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0)) && Seq.__default.Min#canCall(ys#0);
  free ensures {:id "id6416"} Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, ys#0);
  free ensures (forall i#1: int :: { Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Min#canCall(Seq#Append(xs#0, ys#0)));
  free ensures {:id "id6417"} (forall i#1: int :: { Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) } Seq#Contains(Seq#Append(xs#0, ys#0), $Box(i#1)) ==> Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Append(xs#0, ys#0)) <= i#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMinOfConcat (correctness)"} Impl$$Seq.__default.LemmaMinOfConcat(xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var xs##1_0: Seq;
  var ys##1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMinOfConcat", " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(466,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#xs0#0, TSeq(TInt)) && $Is($ih#ys0#0, TSeq(TInt)) && 0 < Seq#Length($ih#xs0#0) && 0 < Seq#Length($ih#ys0#0) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append($ih#xs0#0, $ih#ys0#0)) <= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, $ih#xs0#0) && Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append($ih#xs0#0, $ih#ys0#0)) <= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, $ih#ys0#0) && (forall i#2: int :: { Seq#Contains(Seq#Append($ih#xs0#0, $ih#ys0#0), $Box(i#2)) } Seq#Contains(Seq#Append($ih#xs0#0, $ih#ys0#0), $Box(i#2)) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Append($ih#xs0#0, $ih#ys0#0)) <= i#2));
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__Min();
    call CallPost$$Seq.__default.reveal__Min();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(467,15)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(1);
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(1);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(470,43)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    xs##1_0 := Seq#Drop(xs#0, LitInt(1));
    assume true;
    ys##1_0 := ys#0;
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0) || (Seq#Rank(xs##1_0) == Seq#Rank(xs#0) && Seq#Rank(ys##1_0) < Seq#Rank(ys#0));
    call CallPre$$Seq.__default.LemmaMinOfConcat(xs##1_0, ys##1_0);
    call CallPost$$Seq.__default.LemmaMinOfConcat(xs##1_0, ys##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(471,35)"} true;
    return;
}



procedure {:verboseName "Seq.LemmaSubseqMax (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSubseqMax(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSubseqMax (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSubseqMax(xs#0: Seq, from#0: int, to#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSubseqMax", " | ", xs#0, " | ", from#0, " | ", to#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(477,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} from#0 < to#0;
    goto anon3;

  anon4_Else:
    assume {:partition} to#0 <= from#0;
    goto anon3;

  anon3:
    assume from#0 < to#0 && to#0 <= Seq#Length(xs#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(479,30): post-state"} true;
    assume 0 <= from#0 && from#0 <= Seq#Length(xs#0);
    assume from#0 <= to#0 && to#0 <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(Seq#Take(xs#0, to#0), from#0);
    assume $IsAlloc(##xs#0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0);
    assume 0 < Seq#Length(##xs#0);
    assume Seq.__default.Max#canCall(Seq#Drop(Seq#Take(xs#0, to#0), from#0));
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#1);
    assume 0 < Seq#Length(##xs#1);
    assume Seq.__default.Max#canCall(xs#0);
    assume Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Drop(Seq#Take(xs#0, to#0), from#0)) <= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0);
    return;
}



procedure {:verboseName "Seq.LemmaSubseqMax (call precondtion)"} CallPre$$Seq.__default.LemmaSubseqMax(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0);
  requires {:id "id6433"} from#0 < to#0;
  requires {:id "id6434"} to#0 <= Seq#Length(xs#0);



procedure {:verboseName "Seq.LemmaSubseqMax (call postcondition)"} CallPost$$Seq.__default.LemmaSubseqMax(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0);
  modifies $Heap;
  free ensures Seq.__default.Max#canCall(Seq#Drop(Seq#Take(xs#0, to#0), from#0)) && Seq.__default.Max#canCall(xs#0);
  free ensures {:id "id6435"} Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Drop(Seq#Take(xs#0, to#0), from#0)) <= Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaSubseqMax (correctness)"} Impl$$Seq.__default.LemmaSubseqMax(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6436"} from#0 < to#0;
  requires {:id "id6437"} to#0 <= Seq#Length(xs#0);
  modifies $Heap;
  free ensures Seq.__default.Max#canCall(Seq#Drop(Seq#Take(xs#0, to#0), from#0)) && Seq.__default.Max#canCall(xs#0);
  free ensures {:id "id6438"} Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, Seq#Drop(Seq#Take(xs#0, to#0), from#0)) <= Seq.__default.Max($LS($LS($LZ)), reveal_Seq._default.Max, xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSubseqMax (correctness)"} Impl$$Seq.__default.LemmaSubseqMax(xs#0: Seq, from#0: int, to#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var subseq#0: Seq where $Is(subseq#0, TSeq(TInt)) && $IsAlloc(subseq#0, TSeq(TInt), $Heap);
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var defass#k#0_0: bool;
  var k#0_0: int;
  var k#0_1: int;
  var ##xs#0_0: Seq;
  var $lambdaHeap#0_0: Heap;
  var i#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSubseqMax", " | ", xs#0, " | ", from#0, " | ", to#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(480,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq :: $Is($ih#xs0#0, TSeq(TInt)) && from#0 < to#0 && to#0 <= Seq#Length($ih#xs0#0) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && ((0 <= from#0 && from#0 < from#0) || (from#0 == from#0 && 0 <= to#0 && to#0 < to#0)))) ==> Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, Seq#Drop(Seq#Take($ih#xs0#0, to#0), from#0)) <= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, $ih#xs0#0));
    $_reverifyPost := false;
    assume true;
    assume 0 <= from#0 && from#0 <= Seq#Length(xs#0);
    assume from#0 <= to#0 && to#0 <= Seq#Length(xs#0);
    assume true;
    subseq#0 := Seq#Drop(Seq#Take(xs#0, to#0), from#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(481,30)"} true;
    ##xs#2 := subseq#0;
    assume $IsAlloc(##xs#2, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#2);
    assume 0 < Seq#Length(##xs#2);
    assume Seq.__default.Max#canCall(subseq#0);
    ##xs#3 := xs#0;
    assume $IsAlloc(##xs#3, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#3);
    assume 0 < Seq#Length(##xs#3);
    assume Seq.__default.Max#canCall(xs#0);
    assume Seq.__default.Max#canCall(subseq#0) && Seq.__default.Max#canCall(xs#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0) > Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0);
    havoc k#0_1;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= k#0_1;
    goto anon4;

  anon18_Else:
    assume {:partition} k#0_1 < LitInt(0);
    goto anon4;

  anon4:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= k#0_1 && k#0_1 < Seq#Length(subseq#0);
    assume {:subsumption 0} 0 <= k#0_1 && k#0_1 < Seq#Length(subseq#0);
    ##xs#0_0 := subseq#0;
    assume $IsAlloc(##xs#0_0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0_0);
    assume Seq.__default.Max#canCall(subseq#0);
    goto anon6;

  anon19_Else:
    assume {:partition} !(LitInt(0) <= k#0_1 && k#0_1 < Seq#Length(subseq#0));
    goto anon6;

  anon6:
    assume LitInt(0) <= k#0_1 ==> k#0_1 < Seq#Length(subseq#0) ==> Seq.__default.Max#canCall(subseq#0);
    goto anon7;

  anon17_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume ($Is(Seq#Length(subseq#0) - 1, TInt) && LitInt(0) <= Seq#Length(subseq#0) - 1 && Seq#Length(subseq#0) - 1 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, Seq#Length(subseq#0) - 1)): int == Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && 0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, LitInt(0))): int == Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && 0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, LitInt(0))): int == Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0)) || (exists $as#k0_0#0_0: int :: LitInt(0) <= $as#k0_0#0_0 && $as#k0_0#0_0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, $as#k0_0#0_0)): int == Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0));
    defass#k#0_0 := true;
    havoc k#0_0;
    assume LitInt(0) <= k#0_0 && k#0_0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, k#0_0)): int == Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(483,60)"} true;
    assume 0 <= Seq#Length(subseq#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc i#0_0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= i#0_0;
    goto anon11;

  anon22_Else:
    assume {:partition} i#0_0 < LitInt(0);
    goto anon11;

  anon11:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(subseq#0);
    assume lambdaResult#0_0 == i#0_0 + from#0;
    assume true;
    assume $Is(lambdaResult#0_0, TInt);
    goto anon13;

  anon23_Else:
    assume {:partition} !(LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(subseq#0));
    goto anon13;

  anon21_Else:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume false;
    goto anon14;

  anon20_Else:
    goto anon14;

  anon14:
    assume {:subsumption 0} (forall seqinit#0_0#i0#0: int :: 0 <= seqinit#0_0#i0#0 && seqinit#0_0#i0#0 < Seq#Length(subseq#0) ==> Requires1(TInt, TInt, $Heap, Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $Box($Unbox($l#0_1#i#0): int + from#0)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $IsBox($l#0_1#i#0, TInt) && LitInt(0) <= $Unbox($l#0_1#i#0): int && $Unbox($l#0_1#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0_0#i0#0)));
    assume defass#k#0_0;
    assume {:subsumption 0} 0 <= k#0_0 && k#0_0 < Seq#Length(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_2#ly#0: LayerType :: Handle1((lambda $l#0_2#heap#0: Heap, $l#0_2#i#0: Box :: $Box($Unbox($l#0_2#i#0): int + from#0)), (lambda $l#0_2#heap#0: Heap, $l#0_2#i#0: Box :: $IsBox($l#0_2#i#0, TInt) && LitInt(0) <= $Unbox($l#0_2#i#0): int && $Unbox($l#0_2#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_2#heap#0: Heap, $l#0_2#i#0: Box :: SetRef_to_SetBox((lambda $l#0_2#o#0: ref :: false))))), $LS($LZ)))));
    assume {:subsumption 0} 0 <= $Unbox(Seq#Index(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_0#ly#0: LayerType :: Handle1((lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $Box($Unbox($l#0_0#i#0): int + from#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $IsBox($l#0_0#i#0, TInt) && LitInt(0) <= $Unbox($l#0_0#i#0): int && $Unbox($l#0_0#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: SetRef_to_SetBox((lambda $l#0_0#o#0: ref :: false))))), $LS($LZ)))), k#0_0)): int && $Unbox(Seq#Index(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_0#ly#0: LayerType :: Handle1((lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $Box($Unbox($l#0_0#i#0): int + from#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $IsBox($l#0_0#i#0, TInt) && LitInt(0) <= $Unbox($l#0_0#i#0): int && $Unbox($l#0_0#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: SetRef_to_SetBox((lambda $l#0_0#o#0: ref :: false))))), $LS($LZ)))), k#0_0)): int < Seq#Length(xs#0);
    assume true;
    assume Seq#Contains(xs#0, Seq#Index(xs#0, $Unbox(Seq#Index(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_5#ly#0: LayerType :: Handle1((lambda $l#0_5#heap#0: Heap, $l#0_5#i#0: Box :: $Box($Unbox($l#0_5#i#0): int + from#0)), (lambda $l#0_5#heap#0: Heap, $l#0_5#i#0: Box :: $IsBox($l#0_5#i#0, TInt) && LitInt(0) <= $Unbox($l#0_5#i#0): int && $Unbox($l#0_5#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_5#heap#0: Heap, $l#0_5#i#0: Box :: SetRef_to_SetBox((lambda $l#0_5#o#0: ref :: false))))), $LS($LZ)))), k#0_0)): int));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(484,81)"} true;
    assume true;
    assume Lit(false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(485,18)"} true;
    return;

  anon16_Else:
    assume {:partition} Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, xs#0) >= Seq.__default.Max($LS($LZ), reveal_Seq._default.Max, subseq#0);
    return;
}



procedure {:verboseName "Seq.LemmaSubseqMin (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSubseqMin(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSubseqMin (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaSubseqMin(xs#0: Seq, from#0: int, to#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSubseqMin", " | ", xs#0, " | ", from#0, " | ", to#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(491,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} from#0 < to#0;
    goto anon3;

  anon4_Else:
    assume {:partition} to#0 <= from#0;
    goto anon3;

  anon3:
    assume from#0 < to#0 && to#0 <= Seq#Length(xs#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(493,30): post-state"} true;
    assume 0 <= from#0 && from#0 <= Seq#Length(xs#0);
    assume from#0 <= to#0 && to#0 <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(Seq#Take(xs#0, to#0), from#0);
    assume $IsAlloc(##xs#0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0);
    assume 0 < Seq#Length(##xs#0);
    assume Seq.__default.Min#canCall(Seq#Drop(Seq#Take(xs#0, to#0), from#0));
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#1);
    assume 0 < Seq#Length(##xs#1);
    assume Seq.__default.Min#canCall(xs#0);
    assume Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Drop(Seq#Take(xs#0, to#0), from#0)) >= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0);
    return;
}



procedure {:verboseName "Seq.LemmaSubseqMin (call precondtion)"} CallPre$$Seq.__default.LemmaSubseqMin(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0);
  requires {:id "id6462"} from#0 < to#0;
  requires {:id "id6463"} to#0 <= Seq#Length(xs#0);



procedure {:verboseName "Seq.LemmaSubseqMin (call postcondition)"} CallPost$$Seq.__default.LemmaSubseqMin(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0);
  modifies $Heap;
  free ensures Seq.__default.Min#canCall(Seq#Drop(Seq#Take(xs#0, to#0), from#0)) && Seq.__default.Min#canCall(xs#0);
  free ensures {:id "id6464"} Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Drop(Seq#Take(xs#0, to#0), from#0)) >= Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, xs#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaSubseqMin (correctness)"} Impl$$Seq.__default.LemmaSubseqMin(xs#0: Seq where $Is(xs#0, TSeq(TInt)) && $IsAlloc(xs#0, TSeq(TInt), $Heap), from#0: int where LitInt(0) <= from#0, to#0: int where LitInt(0) <= to#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6465"} from#0 < to#0;
  requires {:id "id6466"} to#0 <= Seq#Length(xs#0);
  modifies $Heap;
  free ensures Seq.__default.Min#canCall(Seq#Drop(Seq#Take(xs#0, to#0), from#0)) && Seq.__default.Min#canCall(xs#0);
  free ensures {:id "id6467"} Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, Seq#Drop(Seq#Take(xs#0, to#0), from#0)) >= Seq.__default.Min($LS($LS($LZ)), reveal_Seq._default.Min, xs#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaSubseqMin (correctness)"} Impl$$Seq.__default.LemmaSubseqMin(xs#0: Seq, from#0: int, to#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var subseq#0: Seq where $Is(subseq#0, TSeq(TInt)) && $IsAlloc(subseq#0, TSeq(TInt), $Heap);
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var defass#k#0_0: bool;
  var k#0_0: int;
  var k#0_1: int;
  var ##xs#0_0: Seq;
  var $lambdaHeap#0_0: Heap;
  var i#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaSubseqMin", " | ", xs#0, " | ", from#0, " | ", to#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(494,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq :: $Is($ih#xs0#0, TSeq(TInt)) && from#0 < to#0 && to#0 <= Seq#Length($ih#xs0#0) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && ((0 <= from#0 && from#0 < from#0) || (from#0 == from#0 && 0 <= to#0 && to#0 < to#0)))) ==> Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, Seq#Drop(Seq#Take($ih#xs0#0, to#0), from#0)) >= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, $ih#xs0#0));
    $_reverifyPost := false;
    assume true;
    assume 0 <= from#0 && from#0 <= Seq#Length(xs#0);
    assume from#0 <= to#0 && to#0 <= Seq#Length(xs#0);
    assume true;
    subseq#0 := Seq#Drop(Seq#Take(xs#0, to#0), from#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(495,30)"} true;
    ##xs#2 := subseq#0;
    assume $IsAlloc(##xs#2, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#2);
    assume 0 < Seq#Length(##xs#2);
    assume Seq.__default.Min#canCall(subseq#0);
    ##xs#3 := xs#0;
    assume $IsAlloc(##xs#3, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#3);
    assume 0 < Seq#Length(##xs#3);
    assume Seq.__default.Min#canCall(xs#0);
    assume Seq.__default.Min#canCall(subseq#0) && Seq.__default.Min#canCall(xs#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0) < Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0);
    havoc k#0_1;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= k#0_1;
    goto anon4;

  anon18_Else:
    assume {:partition} k#0_1 < LitInt(0);
    goto anon4;

  anon4:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= k#0_1 && k#0_1 < Seq#Length(subseq#0);
    assume {:subsumption 0} 0 <= k#0_1 && k#0_1 < Seq#Length(subseq#0);
    ##xs#0_0 := subseq#0;
    assume $IsAlloc(##xs#0_0, TSeq(TInt), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##xs#0_0);
    assume Seq.__default.Min#canCall(subseq#0);
    goto anon6;

  anon19_Else:
    assume {:partition} !(LitInt(0) <= k#0_1 && k#0_1 < Seq#Length(subseq#0));
    goto anon6;

  anon6:
    assume LitInt(0) <= k#0_1 ==> k#0_1 < Seq#Length(subseq#0) ==> Seq.__default.Min#canCall(subseq#0);
    goto anon7;

  anon17_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume ($Is(Seq#Length(subseq#0) - 1, TInt) && LitInt(0) <= Seq#Length(subseq#0) - 1 && Seq#Length(subseq#0) - 1 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, Seq#Length(subseq#0) - 1)): int == Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && 0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, LitInt(0))): int == Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0)) || ($Is(LitInt(0), TInt) && LitInt(0) <= LitInt(0) && 0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, LitInt(0))): int == Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0)) || (exists $as#k0_0#0_0: int :: LitInt(0) <= $as#k0_0#0_0 && $as#k0_0#0_0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, $as#k0_0#0_0)): int == Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0));
    defass#k#0_0 := true;
    havoc k#0_0;
    assume LitInt(0) <= k#0_0 && k#0_0 < Seq#Length(subseq#0) && $Unbox(Seq#Index(subseq#0, k#0_0)): int == Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(497,60)"} true;
    assume 0 <= Seq#Length(subseq#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc i#0_0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= i#0_0;
    goto anon11;

  anon22_Else:
    assume {:partition} i#0_0 < LitInt(0);
    goto anon11;

  anon11:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(subseq#0);
    assume lambdaResult#0_0 == i#0_0 + from#0;
    assume true;
    assume $Is(lambdaResult#0_0, TInt);
    goto anon13;

  anon23_Else:
    assume {:partition} !(LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(subseq#0));
    goto anon13;

  anon21_Else:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume false;
    goto anon14;

  anon20_Else:
    goto anon14;

  anon14:
    assume {:subsumption 0} (forall seqinit#0_0#i0#0: int :: 0 <= seqinit#0_0#i0#0 && seqinit#0_0#i0#0 < Seq#Length(subseq#0) ==> Requires1(TInt, TInt, $Heap, Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $Box($Unbox($l#0_1#i#0): int + from#0)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $IsBox($l#0_1#i#0, TInt) && LitInt(0) <= $Unbox($l#0_1#i#0): int && $Unbox($l#0_1#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0_0#i0#0)));
    assume defass#k#0_0;
    assume {:subsumption 0} 0 <= k#0_0 && k#0_0 < Seq#Length(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_2#ly#0: LayerType :: Handle1((lambda $l#0_2#heap#0: Heap, $l#0_2#i#0: Box :: $Box($Unbox($l#0_2#i#0): int + from#0)), (lambda $l#0_2#heap#0: Heap, $l#0_2#i#0: Box :: $IsBox($l#0_2#i#0, TInt) && LitInt(0) <= $Unbox($l#0_2#i#0): int && $Unbox($l#0_2#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_2#heap#0: Heap, $l#0_2#i#0: Box :: SetRef_to_SetBox((lambda $l#0_2#o#0: ref :: false))))), $LS($LZ)))));
    assume {:subsumption 0} 0 <= $Unbox(Seq#Index(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_0#ly#0: LayerType :: Handle1((lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $Box($Unbox($l#0_0#i#0): int + from#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $IsBox($l#0_0#i#0, TInt) && LitInt(0) <= $Unbox($l#0_0#i#0): int && $Unbox($l#0_0#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: SetRef_to_SetBox((lambda $l#0_0#o#0: ref :: false))))), $LS($LZ)))), k#0_0)): int && $Unbox(Seq#Index(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_0#ly#0: LayerType :: Handle1((lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $Box($Unbox($l#0_0#i#0): int + from#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: $IsBox($l#0_0#i#0, TInt) && LitInt(0) <= $Unbox($l#0_0#i#0): int && $Unbox($l#0_0#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_0#heap#0: Heap, $l#0_0#i#0: Box :: SetRef_to_SetBox((lambda $l#0_0#o#0: ref :: false))))), $LS($LZ)))), k#0_0)): int < Seq#Length(xs#0);
    assume true;
    assume Seq#Contains(xs#0, Seq#Index(xs#0, $Unbox(Seq#Index(Seq#Create(TInt, $Heap, Seq#Length(subseq#0), Lit(AtLayer((lambda $l#0_5#ly#0: LayerType :: Handle1((lambda $l#0_5#heap#0: Heap, $l#0_5#i#0: Box :: $Box($Unbox($l#0_5#i#0): int + from#0)), (lambda $l#0_5#heap#0: Heap, $l#0_5#i#0: Box :: $IsBox($l#0_5#i#0, TInt) && LitInt(0) <= $Unbox($l#0_5#i#0): int && $Unbox($l#0_5#i#0): int < Seq#Length(subseq#0)), (lambda $l#0_5#heap#0: Heap, $l#0_5#i#0: Box :: SetRef_to_SetBox((lambda $l#0_5#o#0: ref :: false))))), $LS($LZ)))), k#0_0)): int));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(498,81)"} true;
    return;

  anon16_Else:
    assume {:partition} Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, xs#0) <= Seq.__default.Min($LS($LZ), reveal_Seq._default.Min, subseq#0);
    return;
}



function Seq.__default.Flatten(Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0) } Seq.__default.Flatten#canCall(Seq._default.Flatten$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T)))) ==> $Is(Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0), TSeq(Seq._default.Flatten$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { $IsAlloc(Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0), TSeq(Seq._default.Flatten$T), $Heap) } (Seq.__default.Flatten#canCall(Seq._default.Flatten$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.Flatten$T)), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0), TSeq(Seq._default.Flatten$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), xs#0) } Seq.__default.Flatten#canCall(Seq._default.Flatten$T, xs#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.Flatten$T, $ly, Seq#Drop(xs#0, LitInt(1))))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), Lit(xs#0)) } Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Lit(xs#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T)))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))))) && Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))));
}

function Seq.__default.Flatten#canCall(Seq._default.Flatten$T: Ty, xs#0: Seq) : bool;

axiom (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), xs#0) } Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), xs#0) == Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0));

axiom (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten(Seq._default.Flatten$T, AsFuelBottom($ly), xs#0) } Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0) == Seq.__default.Flatten(Seq._default.Flatten$T, $LZ, xs#0));

function Seq.__default.Flatten#requires(Ty, LayerType, Seq) : bool;

axiom (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten#requires(Seq._default.Flatten$T, $ly, xs#0) } $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))) ==> (Seq.__default.Flatten#requires(Seq._default.Flatten$T, $ly, xs#0) <==> true));

procedure {:verboseName "Seq.Flatten (well-formedness)"} CheckWellformed$$Seq.__default.Flatten(Seq._default.Flatten$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Flatten (well-formedness)"} CheckWellformed$$Seq.__default.Flatten(Seq._default.Flatten$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.Flatten", " | ", Seq._default.Flatten$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(510,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(Seq.__default.Flatten(Seq._default.Flatten$T, $LS($LZ), xs#0), TSeq(Seq._default.Flatten$T));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.Flatten(Seq._default.Flatten$T, $LS($LZ), xs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Seq.__default.Flatten(Seq._default.Flatten$T, $LS($LZ), xs#0), TSeq(Seq._default.Flatten$T));
    return;

  anon7_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(TSeq(Seq._default.Flatten$T)), $Heap);
    assume 0 <= Seq#Length(xs#0) || Seq#Length(##xs#0) == Seq#Length(xs#0);
    assume Seq#Length(##xs#0) < Seq#Length(xs#0);
    assume Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Seq#Drop(xs#0, LitInt(1)));
    assume Seq.__default.Flatten(Seq._default.Flatten$T, $LS($LZ), xs#0) == Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.Flatten$T, $LS($LZ), Seq#Drop(xs#0, LitInt(1))));
    assume Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Seq#Drop(xs#0, LitInt(1)));
    assume $Is(Seq.__default.Flatten(Seq._default.Flatten$T, $LS($LZ), xs#0), TSeq(Seq._default.Flatten$T));
    return;
}



procedure {:verboseName "Seq.LemmaFlattenConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaFlattenConcat (call precondtion)"} CallPre$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap));



procedure {:verboseName "Seq.LemmaFlattenConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(xs#0, ys#0)) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
  free ensures {:id "id6491"} Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), ys#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFlattenConcat (correctness)"} Impl$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(xs#0, ys#0)) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
  free ensures {:id "id6492"} Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), ys#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenConcat (correctness)"} Impl$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T: Ty, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##xs#1_0_0_0: Seq;
  var ##xs#1_0_0_1: Seq;
  var ##xs#1_0_0_2: Seq;
  var ##xs#1_0_0_3: Seq;
  var ##xs#1_0_1_0: Seq;
  var ##xs#1_0_1_1: Seq;
  var ##xs#1_0_1_2: Seq;
  var ##xs#1_0_2_0: Seq;
  var ##xs#1_0_2_1: Seq;
  var ##xs#1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenConcat", " | ", Seq._default.LemmaFlattenConcat$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(522,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#xs0#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && $Is($ih#ys0#0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T))) && Lit(true) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LZ), Seq#Append($ih#xs0#0, $ih#ys0#0)), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LZ), $ih#xs0#0), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LZ), $ih#ys0#0))));
    $_reverifyPost := false;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume true;
    assume Seq#Equal(Seq#Append(xs#0, ys#0), ys#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(524,26)"} true;
    return;

  anon8_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##xs#1_0_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(xs#0, ys#0));
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(xs#0, ys#0));
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##xs#1_0_2_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_2_0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(xs#0, ys#0));
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    assume Seq#Equal($Unbox(Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0))): Seq, $Unbox(Seq#Index(xs#0, LitInt(0))): Seq);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(528,38)"} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(528,78)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#1_0_2_1 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_2_1, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, ys#0)), Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0))));
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#1_0_1_0 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_1_0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#1_0_1_1 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_1_1, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Drop(xs#0, LitInt(1)));
    ##xs#1_0_1_2 := ys#0;
    assume $IsAlloc(##xs#1_0_1_2, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0))), Seq#Append(Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Drop(xs#0, LitInt(1)))), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), ys#0)));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#1_0_0_0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_0_0, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Drop(xs#0, LitInt(1)));
    ##xs#1_0_0_1 := ys#0;
    assume $IsAlloc(##xs#1_0_0_1, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
    ##xs#1_0_0_2 := xs#0;
    assume $IsAlloc(##xs#1_0_0_2, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, xs#0);
    ##xs#1_0_0_3 := ys#0;
    assume $IsAlloc(##xs#1_0_0_3, TSeq(TSeq(Seq._default.LemmaFlattenConcat$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenConcat$T, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), Seq#Drop(xs#0, LitInt(1)))), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), ys#0)), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LS($LZ)), ys#0)));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LZ), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LZ), xs#0), Seq.__default.Flatten(Seq._default.LemmaFlattenConcat$T, $LS($LZ), ys#0)));
    return;
}



function Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0) } Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, xs#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T)))) ==> $Is(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0), TSeq(Seq._default.FlattenReverse$T)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { $IsAlloc(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0), TSeq(Seq._default.FlattenReverse$T), $Heap) } (Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, xs#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T)), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0), TSeq(Seq._default.FlattenReverse$T), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), xs#0) } Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, xs#0) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0)) && Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.FlattenReverse$T), xs#0)): Seq)));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), Lit(xs#0)) } Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Lit(xs#0)) || (1 < $FunctionContextHeight && $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T)))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0)) && Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Lit(Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0)))) && Seq.__default.Last#canCall(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0))) && Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), Lit(Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0)))), $Unbox(Seq.__default.Last(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0))): Seq)));
}

function Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T: Ty, xs#0: Seq) : bool;

axiom (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), xs#0) } Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), xs#0) == Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0));

axiom (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, AsFuelBottom($ly), xs#0) } Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0) == Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LZ, xs#0));

function Seq.__default.FlattenReverse#requires(Ty, LayerType, Seq) : bool;

axiom (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse#requires(Seq._default.FlattenReverse$T, $ly, xs#0) } $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))) ==> (Seq.__default.FlattenReverse#requires(Seq._default.FlattenReverse$T, $ly, xs#0) <==> true));

procedure {:verboseName "Seq.FlattenReverse (well-formedness)"} CheckWellformed$$Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.FlattenReverse (well-formedness)"} CheckWellformed$$Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T: Ty, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.FlattenReverse", " | ", Seq._default.FlattenReverse$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(538,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($LZ), xs#0), TSeq(Seq._default.FlattenReverse$T));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($LZ), xs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($LZ), xs#0), TSeq(Seq._default.FlattenReverse$T));
    return;

  anon7_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#0) > 0;
    assume Seq#Length(##xs#0) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0);
    ##xs#1 := Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0);
    assume $IsAlloc(##xs#1, TSeq(TSeq(Seq._default.FlattenReverse$T)), $Heap);
    assume 0 <= Seq#Length(xs#0) || Seq#Length(##xs#1) == Seq#Length(xs#0);
    assume Seq#Length(##xs#1) < Seq#Length(xs#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0));
    ##xs#2 := xs#0;
    assume $IsAlloc(##xs#2, TSeq(TSeq(Seq._default.FlattenReverse$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#2) > 0;
    assume Seq#Length(##xs#2) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0);
    assume Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($LZ), xs#0) == Seq#Append(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($LZ), Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.FlattenReverse$T), xs#0)): Seq);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0);
    assume $Is(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($LZ), xs#0), TSeq(Seq._default.FlattenReverse$T));
    return;
}



procedure {:verboseName "Seq.LemmaFlattenReverseConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaFlattenReverseConcat (call precondtion)"} CallPre$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap));



procedure {:verboseName "Seq.LemmaFlattenReverseConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap));
  modifies $Heap;
  free ensures Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, ys#0)) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, ys#0);
  free ensures {:id "id6519"} Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), ys#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFlattenReverseConcat (correctness)"} Impl$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap), ys#0: Seq where $Is(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $IsAlloc(ys#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, ys#0)) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, ys#0);
  free ensures {:id "id6520"} Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), ys#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenReverseConcat (correctness)"} Impl$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T: Ty, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##xs#0_0: Seq;
  var ##xs#1_0_0_0: Seq;
  var ##xs#1_0_0_1: Seq;
  var ##xs#1_0_0_2: Seq;
  var ##xs#1_0_0_3: Seq;
  var ##xs#1_0_0_4: Seq;
  var ##xs#1_0_0_5: Seq;
  var ##xs#1_0_1_0: Seq;
  var ##xs#1_0_1_1: Seq;
  var ##xs#1_0_1_2: Seq;
  var ##xs#1_0_1_3: Seq;
  var ##xs#1_0_1_4: Seq;
  var ##xs#1_0_1_5: Seq;
  var ##xs#1_0_1_6: Seq;
  var ##xs#1_0_2_0: Seq;
  var ##xs#1_0_2_1: Seq;
  var ##xs#1_0_2_2: Seq;
  var ##xs#1_0_2_3: Seq;
  var ##xs#1_0_2_4: Seq;
  var ##xs#1_0_2_5: Seq;
  var ##xs#1_0_2_6: Seq;
  var ##xs#1_0_2_7: Seq;
  var ##xs#1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenReverseConcat", " | ", Seq._default.LemmaFlattenReverseConcat$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(551,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#xs0#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && $Is($ih#ys0#0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T))) && Lit(true) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), Seq#Append($ih#xs0#0, $ih#ys0#0)), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), $ih#xs0#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), $ih#ys0#0))));
    $_reverifyPost := false;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(ys#0) == LitInt(0);
    ##xs#0_0 := ys#0;
    assume $IsAlloc(##xs#0_0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, ys#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), ys#0), Seq#Empty(): Seq);
    assume Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), ys#0), Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(553,37)"} true;
    assume true;
    assume Seq#Equal(Seq#Append(xs#0, ys#0), xs#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(554,26)"} true;
    return;

  anon8_Else:
    assume {:partition} Seq#Length(ys#0) != LitInt(0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##xs#1_0_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, ys#0));
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, ys#0));
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##xs#1_0_2_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_2_0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, ys#0));
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, ys#0));
    ##xs#1_0_2_1 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_2_1, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_1) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), Seq#Append(xs#0, ys#0));
    ##xs#1_0_2_2 := ys#0;
    assume $IsAlloc(##xs#1_0_2_2, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_2) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), Seq#Append(xs#0, ys#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq#Equal($Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenReverseConcat$T), Seq#Append(xs#0, ys#0))): Seq, $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)): Seq);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(558,42)"} true;
    ##xs#1_0_2_3 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_2_3, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_3) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), Seq#Append(xs#0, ys#0));
    ##xs#1_0_2_4 := ys#0;
    assume $IsAlloc(##xs#1_0_2_4, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_4) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), Seq#Append(xs#0, ys#0)) && Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq#Equal(Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), Seq#Append(xs#0, ys#0)), Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(558,90)"} true;
    ##xs#1_0_2_5 := ys#0;
    assume $IsAlloc(##xs#1_0_2_5, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_5) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    ##xs#1_0_2_6 := Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0));
    assume $IsAlloc(##xs#1_0_2_6, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)));
    ##xs#1_0_2_7 := ys#0;
    assume $IsAlloc(##xs#1_0_2_7, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_7) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0))) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume {:subsumption 0} Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0))), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)): Seq));
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##xs#1_0_1_0 := ys#0;
    assume $IsAlloc(##xs#1_0_1_0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_0) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    ##xs#1_0_1_1 := Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0));
    assume $IsAlloc(##xs#1_0_1_1, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)));
    ##xs#1_0_1_2 := ys#0;
    assume $IsAlloc(##xs#1_0_1_2, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_2) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0))) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    ##xs#1_0_1_3 := xs#0;
    assume $IsAlloc(##xs#1_0_1_3, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0);
    ##xs#1_0_1_4 := ys#0;
    assume $IsAlloc(##xs#1_0_1_4, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_4) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    ##xs#1_0_1_5 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume $IsAlloc(##xs#1_0_1_5, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0));
    ##xs#1_0_1_6 := ys#0;
    assume $IsAlloc(##xs#1_0_1_6, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_6) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0) && Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq#Append(xs#0, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0))), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)): Seq), Seq#Append(Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0))), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)): Seq));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##xs#1_0_0_0 := xs#0;
    assume $IsAlloc(##xs#1_0_0_0, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0);
    ##xs#1_0_0_1 := ys#0;
    assume $IsAlloc(##xs#1_0_0_1, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_1) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    ##xs#1_0_0_2 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume $IsAlloc(##xs#1_0_0_2, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0));
    ##xs#1_0_0_3 := ys#0;
    assume $IsAlloc(##xs#1_0_0_3, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_3) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0) && Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0);
    ##xs#1_0_0_4 := xs#0;
    assume $IsAlloc(##xs#1_0_0_4, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0);
    ##xs#1_0_0_5 := ys#0;
    assume $IsAlloc(##xs#1_0_0_5, TSeq(TSeq(Seq._default.LemmaFlattenReverseConcat$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, ys#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenReverseConcat$T, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0))), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenReverseConcat$T), ys#0)): Seq), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LS($LZ)), ys#0)));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenReverseConcat$T, $LS($LZ), ys#0)));
    return;
}



procedure {:verboseName "Seq.LemmaFlattenAndFlattenReverseAreEquivalent (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaFlattenAndFlattenReverseAreEquivalent (call precondtion)"} CallPre$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap));



procedure {:verboseName "Seq.LemmaFlattenAndFlattenReverseAreEquivalent (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
  free ensures {:id "id6543"} Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), xs#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFlattenAndFlattenReverseAreEquivalent (correctness)"} Impl$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
  free ensures {:id "id6544"} Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), xs#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), xs#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenAndFlattenReverseAreEquivalent (correctness)"} Impl$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T: Ty, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##xs#1_0_0_0: Seq;
  var ##xs#1_0_0_1: Seq;
  var ##xs#1_0_0_2: Seq;
  var ##xs#1_0_0_3: Seq;
  var xs##1_0_0_0: Seq;
  var ##xs#1_0_0_4: Seq;
  var ys##1_0_0_0: Seq;
  var ##xs#1_0_0_5: Seq;
  var ##xs#1_0_0_6: Seq;
  var ##xs#1_0_0_7: Seq;
  var ##xs#1_0_0_8: Seq;
  var ##xs#1_0_1_0: Seq;
  var ##xs#1_0_1_1: Seq;
  var ##xs#1_0_1_2: Seq;
  var ##xs#1_0_1_3: Seq;
  var ##xs#1_0_1_4: Seq;
  var ##xs#1_0_1_5: Seq;
  var ##xs#1_0_1_6: Seq;
  var ##xs#1_0_2_0: Seq;
  var ##xs#1_0_2_1: Seq;
  var ##xs#1_0_2_2: Seq;
  var xs##1_0_2_0: Seq;
  var ##xs#1_0_2_3: Seq;
  var ##xs#1_0_2_4: Seq;
  var ##xs#1_0_2_5: Seq;
  var ##xs#1_0_2_6: Seq;
  var ##xs#1_0_3_0: Seq;
  var ##xs#1_0_3_1: Seq;
  var ##xs#1_0_3_2: Seq;
  var ##xs#1_0_3_3: Seq;
  var ##xs#1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenAndFlattenReverseAreEquivalent", " | ", Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(570,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq :: $Is($ih#xs0#0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T))) && Lit(true) && Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) ==> Seq#Equal(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LZ), $ih#xs0#0), Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LZ), $ih#xs0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    return;

  anon9_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##xs#1_0_0 := xs#0;
    assume $IsAlloc(##xs#1_0_0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##xs#1_0_3_0 := xs#0;
    assume $IsAlloc(##xs#1_0_3_0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    ##xs#1_0_3_1 := xs#0;
    assume $IsAlloc(##xs#1_0_3_1, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_3_1) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_3_2 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume $IsAlloc(##xs#1_0_3_2, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    ##xs#1_0_3_3 := xs#0;
    assume $IsAlloc(##xs#1_0_3_3, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_3_3) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume {:subsumption 0} Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), xs#0), Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)): Seq));
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##xs#1_0_2_0 := xs#0;
    assume $IsAlloc(##xs#1_0_2_0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_0) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_2_1 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume $IsAlloc(##xs#1_0_2_1, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    ##xs#1_0_2_2 := xs#0;
    assume $IsAlloc(##xs#1_0_2_2, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_2) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_2_3 := xs#0;
    assume $IsAlloc(##xs#1_0_2_3, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_3) > 0;
    assume Seq#Length(##xs#1_0_2_3) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    xs##1_0_2_0 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq#Rank(xs##1_0_2_0) < Seq#Rank(xs#0);
    call CallPre$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs##1_0_2_0);
    call CallPost$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs##1_0_2_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(576,66)"} true;
    ##xs#1_0_2_4 := xs#0;
    assume $IsAlloc(##xs#1_0_2_4, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_4) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_2_5 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume $IsAlloc(##xs#1_0_2_5, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    ##xs#1_0_2_6 := xs#0;
    assume $IsAlloc(##xs#1_0_2_6, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_2_6) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)): Seq), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)): Seq));
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##xs#1_0_1_0 := xs#0;
    assume $IsAlloc(##xs#1_0_1_0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_0) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_1_1 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume $IsAlloc(##xs#1_0_1_1, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    ##xs#1_0_1_2 := xs#0;
    assume $IsAlloc(##xs#1_0_1_2, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_2) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_1_3 := xs#0;
    assume $IsAlloc(##xs#1_0_1_3, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_3) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_1_4 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume $IsAlloc(##xs#1_0_1_4, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    ##xs#1_0_1_5 := xs#0;
    assume $IsAlloc(##xs#1_0_1_5, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_1_5) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_1_6 := Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    assume $IsAlloc(##xs#1_0_1_6, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)));
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)): Seq), Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)), Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)))));
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##xs#1_0_0_0 := xs#0;
    assume $IsAlloc(##xs#1_0_0_0, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_0) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_0_1 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume $IsAlloc(##xs#1_0_0_1, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    ##xs#1_0_0_2 := xs#0;
    assume $IsAlloc(##xs#1_0_0_2, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_2) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_0_3 := Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    assume $IsAlloc(##xs#1_0_0_3, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)));
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)));
    ##xs#1_0_0_4 := xs#0;
    assume $IsAlloc(##xs#1_0_0_4, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_4) > 0;
    assume Seq#Length(##xs#1_0_0_4) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    xs##1_0_0_0 := Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_0_5 := xs#0;
    assume $IsAlloc(##xs#1_0_0_5, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_5) > 0;
    assume Seq#Length(##xs#1_0_0_5) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ys##1_0_0_0 := Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0));
    call CallPre$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs##1_0_0_0, ys##1_0_0_0);
    call CallPost$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs##1_0_0_0, ys##1_0_0_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(579,54)"} true;
    ##xs#1_0_0_6 := xs#0;
    assume $IsAlloc(##xs#1_0_0_6, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_6) > 0;
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    ##xs#1_0_0_7 := xs#0;
    assume $IsAlloc(##xs#1_0_0_7, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1_0_0_7) > 0;
    assume Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq.__default.DropLast#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0) && Seq.__default.Last#canCall(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0);
    assume Seq#Equal(xs#0, Seq#Append(Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0))));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(580,48)"} true;
    ##xs#1_0_0_8 := xs#0;
    assume $IsAlloc(##xs#1_0_0_8, TSeq(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    assume Seq.__default.Flatten#canCall(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq.__default.DropLast(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)), Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), Seq#Build(Seq#Empty(): Seq, Seq.__default.Last(TSeq(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T), xs#0)))), Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LS($LZ)), xs#0));
    assume false;
    goto anon8;

  anon14_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LZ), xs#0), Seq.__default.Flatten(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, $LS($LZ), xs#0));
    return;
}



procedure {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T)), $Heap), i#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq, i#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenLengthGeSingleElementLength", " | ", Seq._default.LemmaFlattenLengthGeSingleElementLength$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(588,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon3;

  anon4_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(590,33): post-state"} true;
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, $LS($LZ), xs#0)) >= Seq#Length($Unbox(Seq#Index(xs#0, i#0)): Seq);
    return;
}



procedure {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (call precondtion)"} CallPre$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T)), $Heap), i#0: int);
  requires {:id "id6576"} LitInt(0) <= i#0;
  requires {:id "id6577"} i#0 < Seq#Length(xs#0);



procedure {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T)), $Heap), i#0: int);
  modifies $Heap;
  free ensures Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, xs#0);
  free ensures {:id "id6578"} Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, $LS($LS($LZ)), xs#0)) >= Seq#Length($Unbox(Seq#Index(xs#0, i#0)): Seq);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (correctness)"} Impl$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T)), $Heap), i#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id6579"} LitInt(0) <= i#0;
  requires {:id "id6580"} i#0 < Seq#Length(xs#0);
  modifies $Heap;
  free ensures Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, xs#0);
  free ensures {:id "id6581"} Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, $LS($LS($LZ)), xs#0)) >= Seq#Length($Unbox(Seq#Index(xs#0, i#0)): Seq);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (correctness)"} Impl$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq, i#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var xs##0_0: Seq;
  var i##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenLengthGeSingleElementLength", " | ", Seq._default.LemmaFlattenLengthGeSingleElementLength$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(591,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq :: $Is($ih#xs0#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthGeSingleElementLength$T))) && LitInt(0) <= i#0 && i#0 < Seq#Length($ih#xs0#0) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && 0 <= i#0 && i#0 < i#0)) ==> Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, $LS($LZ), $ih#xs0#0)) >= Seq#Length($Unbox(Seq#Index($ih#xs0#0, i#0)): Seq));
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} i#0 < Seq#Length(xs#0) - 1;
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    assume true;
    xs##0_0 := Seq#Take(xs#0, Seq#Length(xs#0) - 1);
    assume true;
    i##0_0 := i#0;
    assume 0 <= i#0 || Seq#Rank(xs##0_0) < Seq#Rank(xs#0) || i##0_0 == i#0;
    assume Seq#Rank(xs##0_0) < Seq#Rank(xs#0) || (Seq#Rank(xs##0_0) == Seq#Rank(xs#0) && i##0_0 < i#0);
    call CallPre$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, xs##0_0, i##0_0);
    call CallPost$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, xs##0_0, i##0_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(593,62)"} true;
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) - 1 <= i#0;
    return;
}



procedure {:verboseName "Seq.LemmaFlattenLengthLeMul (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T)), $Heap), j#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenLengthLeMul (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq, j#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##xs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenLengthLeMul", " | ", Seq._default.LemmaFlattenLengthLeMul$T, " | ", xs#0, " | ", j#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(600,8): initial state"} true;
    havoc i#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon8_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume Seq#Length($Unbox(Seq#Index(xs#0, i#0)): Seq) <= j#0;
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> Seq#Length($Unbox(Seq#Index(xs#0, i#0)): Seq) <= j#0;
    goto anon6;

  anon6:
    assume (forall i#1: int :: { $Unbox(Seq#Index(xs#0, i#1)): Seq } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Length($Unbox(Seq#Index(xs#0, i#1)): Seq) <= j#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(602,33): post-state"} true;
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthLeMul$T, xs#0);
    assume Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthLeMul$T, $LS($LZ), xs#0)) <= Mul(Seq#Length(xs#0), j#0);
    return;
}



procedure {:verboseName "Seq.LemmaFlattenLengthLeMul (call precondtion)"} CallPre$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T)), $Heap), j#0: int);
  requires {:id "id6593"} (forall i#1: int :: { $Unbox(Seq#Index(xs#0, i#1)): Seq } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Length($Unbox(Seq#Index(xs#0, i#1)): Seq) <= j#0);



procedure {:verboseName "Seq.LemmaFlattenLengthLeMul (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T)), $Heap), j#0: int);
  modifies $Heap;
  free ensures Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthLeMul$T, xs#0);
  free ensures {:id "id6594"} Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthLeMul$T, $LS($LS($LZ)), xs#0)) <= Mul(Seq#Length(xs#0), j#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFlattenLengthLeMul (correctness)"} Impl$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T)), $Heap), j#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id6595"} (forall i#1: int :: { $Unbox(Seq#Index(xs#0, i#1)): Seq } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Seq#Length($Unbox(Seq#Index(xs#0, i#1)): Seq) <= j#0);
  modifies $Heap;
  free ensures Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthLeMul$T, xs#0);
  free ensures {:id "id6596"} Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthLeMul$T, $LS($LS($LZ)), xs#0)) <= Mul(Seq#Length(xs#0), j#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFlattenLengthLeMul (correctness)"} Impl$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq, j#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var xs##1_0: Seq;
  var j##1_0: int;
  var ##xs#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenLengthLeMul", " | ", Seq._default.LemmaFlattenLengthLeMul$T, " | ", xs#0, " | ", j#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(603,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#xs0#0: Seq :: $Is($ih#xs0#0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T))) && (forall i#2: int :: { $Unbox(Seq#Index($ih#xs0#0, i#2)): Seq } LitInt(0) <= i#2 && i#2 < Seq#Length($ih#xs0#0) ==> Seq#Length($Unbox(Seq#Index($ih#xs0#0, i#2)): Seq) <= j#0) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && 0 <= j#0 && j#0 < j#0)) ==> Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthLeMul$T, $LS($LZ), $ih#xs0#0)) <= Mul(Seq#Length($ih#xs0#0), j#0));
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    return;

  anon3_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    assume true;
    xs##1_0 := Seq#Take(xs#0, Seq#Length(xs#0) - 1);
    assume true;
    j##1_0 := j#0;
    assume 0 <= j#0 || Seq#Rank(xs##1_0) < Seq#Rank(xs#0) || j##1_0 == j#0;
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0) || (Seq#Rank(xs##1_0) == Seq#Rank(xs#0) && j##1_0 < j#0);
    call CallPre$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T, xs##1_0, j##1_0);
    call CallPost$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T, xs##1_0, j##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(606,46)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(xs#0) - 1 && Seq#Length(xs#0) - 1 <= Seq#Length(xs#0);
    ##xs#1_0 := Seq#Take(xs#0, Seq#Length(xs#0) - 1);
    assume $IsAlloc(##xs#1_0, TSeq(TSeq(Seq._default.LemmaFlattenLengthLeMul$T)), $Heap);
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthLeMul$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1));
    assume Seq.__default.FlattenReverse#canCall(Seq._default.LemmaFlattenLengthLeMul$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1));
    assume {:subsumption 0} Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthLeMul$T, $LS($LS($LZ)), Seq#Take(xs#0, Seq#Length(xs#0) - 1))) <= Mul(Seq#Length(xs#0) - 1, j#0);
    assume Seq#Length(Seq.__default.FlattenReverse(Seq._default.LemmaFlattenLengthLeMul$T, $LS($LZ), Seq#Take(xs#0, Seq#Length(xs#0) - 1))) <= Mul(Seq#Length(xs#0) - 1, j#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(607,59)"} true;
    return;
}



function Seq.__default.Map(Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $heap: Heap, f#0: HandleType, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#2: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#2) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#2))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R), $Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#3)))) ==> (forall $l#1#i#0: int :: LitInt(0) <= $l#1#i#0 ==> $l#1#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#1#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#0#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#0#i#0): int))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#0#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#0#i#0): int))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: (exists i#4: int, o#1: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#0#heap#0, f#0, Seq#Index(xs#0, i#4))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#0#heap#0, f#0, Seq#Index(xs#0, i#4))[$Box(o#1)] && $Box($l#0#o#0) == $Box(o#1))))))), $LS($LZ)))));
}

function Seq.__default.Map#canCall(Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $heap: Heap, f#0: HandleType, xs#0: Seq) : bool;

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $h0: Heap, $h1: Heap, f#0: HandleType, xs#0: Seq :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $h1, f#0, xs#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && (Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $h0, f#0, xs#0) || ($Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && (exists i#0: int, o#0: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $h0, f#0, xs#0) == Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $h1, f#0, xs#0));

function Seq.__default.Map#requires(Ty, Ty, Heap, HandleType, Seq) : bool;

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#3)))));

procedure {:verboseName "Seq.Map (well-formedness)"} CheckWellformed$$Seq.__default.Map(Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Map$T))) returns (result#0: Seq where $Is(result#0, TSeq(Seq._default.Map$R)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6605"} Seq#Length(result#0) == Seq#Length(xs#0);
  free ensures {:id "id6606"} (forall i#5: int :: { Seq#Index(result#0, i#5) } LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> Seq#Index(result#0, i#5) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#5)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Map (well-formedness)"} CheckWellformed$$Seq.__default.Map(Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#6: int;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var i#7: int;
  var o#2: ref;
  var ##x0#1: Box;
  var b$reqreads#1: bool;
  var i#8: int;
  var o#3: ref;
  var ##x0#2: Box;
  var i#9: int;
  var $lambdaHeap#0: Heap;
  var i#10: int;
  var $_Frame#l0: [ref,Field]bool;
  var i#12: int;
  var o#5: ref;
  var ##x0#3: Box;
  var b$reqreads#2: bool;
  var ##x0#4: Box;
  var lambdaResult#0: Box;
  var b$reqreads#3: bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.Map", " | ", Seq._default.Map$T, " | ", Seq._default.Map$R, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#3 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(620,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (exists i#0: int, o#0: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)));
    havoc i#6;
    assume true;
    goto anon44_Then, anon44_Else;

  anon44_Then:
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} LitInt(0) <= i#6;
    goto anon4;

  anon45_Else:
    assume {:partition} i#6 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap);
    assume 0 <= i#6 && i#6 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#6);
    assume $IsAllocBox(##x0#0, Seq._default.Map$T, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#6));
    assume Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#6));
    goto anon6;

  anon44_Else:
    assume LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#6));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)));
    assume b$reqreads#0;
    havoc i#7;
    havoc o#2;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} $Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap);
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} LitInt(0) <= i#7;
    goto anon9;

  anon47_Else:
    assume {:partition} i#7 < LitInt(0);
    goto anon9;

  anon9:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap);
    assume 0 <= i#7 && i#7 < Seq#Length(xs#0);
    ##x0#1 := Seq#Index(xs#0, i#7);
    assume $IsAllocBox(##x0#1, Seq._default.Map$T, $Heap);
    assume Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#7));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Reads1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#7));
    goto anon11;

  anon48_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)];
    goto anon13;

  anon49_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)]);
    goto anon13;

  anon46_Else:
    assume {:partition} !($Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap));
    goto anon13;

  anon13:
    assume b$reqreads#1;
    havoc i#8;
    havoc o#3;
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} $Is(o#3, Tclass._System.object?()) && $IsAlloc(o#3, Tclass._System.object?(), $Heap);
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} LitInt(0) <= i#8;
    goto anon16;

  anon51_Else:
    assume {:partition} i#8 < LitInt(0);
    goto anon16;

  anon16:
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap);
    assume 0 <= i#8 && i#8 < Seq#Length(xs#0);
    ##x0#2 := Seq#Index(xs#0, i#8);
    assume $IsAllocBox(##x0#2, Seq._default.Map$T, $Heap);
    assume Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#8));
    assume Reads1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#8));
    goto anon18;

  anon52_Else:
    assume {:partition} !(LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0));
    goto anon18;

  anon18:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#8))[$Box(o#3)];
    goto anon20;

  anon53_Else:
    assume {:partition} !(LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#8))[$Box(o#3)]);
    goto anon20;

  anon50_Else:
    assume {:partition} !($Is(o#3, Tclass._System.object?()) && $IsAlloc(o#3, Tclass._System.object?(), $Heap));
    goto anon20;

  anon20:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R));
    assume Seq#Length(result#0) == Seq#Length(xs#0);
    havoc i#9;
    assume true;
    goto anon55_Then, anon55_Else;

  anon55_Then:
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} LitInt(0) <= i#9;
    goto anon24;

  anon56_Else:
    assume {:partition} i#9 < LitInt(0);
    goto anon24;

  anon24:
    assume LitInt(0) <= i#9 && i#9 < Seq#Length(xs#0);
    assume 0 <= i#9 && i#9 < Seq#Length(result#0);
    assume 0 <= i#9 && i#9 < Seq#Length(xs#0);
    assume Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#9));
    assume Seq#Index(result#0, i#9) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#9));
    goto anon26;

  anon55_Else:
    assume LitInt(0) <= i#9 && i#9 < Seq#Length(xs#0) ==> Seq#Index(result#0, i#9) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#9));
    goto anon26;

  anon26:
    assume (forall i#5: int :: { Seq#Index(result#0, i#5) } LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> Seq#Index(result#0, i#5) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#5)));
    assume false;
    return;

  anon54_Else:
    assume 0 <= Seq#Length(xs#0);
    b$reqreads#2 := true;
    goto anon57_Then, anon57_Else;

  anon57_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#10;
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> (exists i#11: int, o#4: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#11))[$Box(o#4)] && $Box($o) == $Box(o#4)));
    havoc i#12;
    havoc o#5;
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} $Is(o#5, Tclass._System.object?()) && $IsAlloc(o#5, Tclass._System.object?(), $lambdaHeap#0);
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} LitInt(0) <= i#12;
    goto anon32;

  anon60_Else:
    assume {:partition} i#12 < LitInt(0);
    goto anon32;

  anon32:
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $lambdaHeap#0);
    assume 0 <= i#12 && i#12 < Seq#Length(xs#0);
    ##x0#3 := Seq#Index(xs#0, i#12);
    assume $IsAllocBox(##x0#3, Seq._default.Map$T, $lambdaHeap#0);
    assume Requires1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#12));
    b$reqreads#2 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool && Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#12))[$Box($o)] ==> $_Frame#l0[$o, $f]);
    assume Reads1#canCall(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#12));
    goto anon34;

  anon61_Else:
    assume {:partition} !(LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0));
    goto anon34;

  anon34:
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume {:partition} LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)];
    goto anon36;

  anon62_Else:
    assume {:partition} !(LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)]);
    goto anon36;

  anon59_Else:
    assume {:partition} !($Is(o#5, Tclass._System.object?()) && $IsAlloc(o#5, Tclass._System.object?(), $lambdaHeap#0));
    goto anon36;

  anon36:
    assume b$reqreads#2;
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} LitInt(0) <= i#10;
    goto anon38;

  anon63_Else:
    assume {:partition} i#10 < LitInt(0);
    goto anon38;

  anon38:
    goto anon64_Then, anon64_Else;

  anon64_Then:
    assume {:partition} LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $lambdaHeap#0);
    assume 0 <= i#10 && i#10 < Seq#Length(xs#0);
    ##x0#4 := Seq#Index(xs#0, i#10);
    assume $IsAllocBox(##x0#4, Seq._default.Map$T, $lambdaHeap#0);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool && Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, ##x0#4)[$Box($o)] ==> $_Frame#l0[$o, $f]);
    assume Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#10));
    goto anon40;

  anon64_Else:
    assume {:partition} !(LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0));
    goto anon40;

  anon40:
    goto anon65_Then, anon65_Else;

  anon65_Then:
    assume {:partition} LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#10));
    assume 0 <= i#10 && i#10 < Seq#Length(xs#0);
    assume Requires1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#10));
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool && Reads1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#10))[$Box($o)] ==> $_Frame#l0[$o, $f]);
    assume lambdaResult#0 == Apply1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#10));
    assume true;
    assume $IsBox(lambdaResult#0, Seq._default.Map$R);
    goto anon42;

  anon65_Else:
    assume {:partition} !(LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $lambdaHeap#0, f#0, Seq#Index(xs#0, i#10)));
    goto anon42;

  anon58_Else:
    assume {:partition} false;
    goto anon42;

  anon42:
    assume false;
    goto anon43;

  anon57_Else:
    goto anon43;

  anon43:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(xs#0) ==> Requires1(TInt, Seq._default.Map$R, $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#2#i#0): int))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#2#i#0): int))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: (exists i#13: int, o#6: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, i#13))[$Box(o#6)] } $Is(o#6, Tclass._System.object?()) && LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, i#13))[$Box(o#6)] && $Box($l#2#o#0) == $Box(o#6))))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#3 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(xs#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, Seq._default.Map$R, $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#2#i#0): int))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#2#i#0): int))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: (exists i#13: int, o#6: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, i#13))[$Box(o#6)] } $Is(o#6, Tclass._System.object?()) && LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#2#heap#0, f#0, Seq#Index(xs#0, i#13))[$Box(o#6)] && $Box($l#2#o#0) == $Box(o#6))))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, reveal_Seq._default.Map, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#4#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#4#i#0): int))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#4#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#4#i#0): int))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: (exists i#15: int, o#8: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#4#heap#0, f#0, Seq#Index(xs#0, i#15))[$Box(o#8)] } $Is(o#8, Tclass._System.object?()) && LitInt(0) <= i#15 && i#15 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#4#heap#0, f#0, Seq#Index(xs#0, i#15))[$Box(o#8)] && $Box($l#4#o#0) == $Box(o#8))))))), $LS($LZ))));
    assume (forall $l#5#i#0: int :: LitInt(0) <= $l#5#i#0 ==> $l#5#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#5#i#0)));
    assume $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R));
    assume Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, reveal_Seq._default.Map, $Heap, f#0, xs#0) == result#0;
    assume b$reqreads#3;
    return;
}



function Seq.__default.MapWithResult(Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $heap: Heap, f#0: HandleType, xs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#2: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#2) } { Seq#Index(xs#0, i#2) } (LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#2))): DatatypeType)) && (LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#2) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#2))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#3)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#0 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#0) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#0) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#0 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#0)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#0 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#0) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#0) else (var head#0 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#0); (var valueOrError1#0 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#0) else (var tail#0 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#0), tail#0)))))))))));
}

function Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $heap: Heap, f#0: HandleType, xs#0: Seq) : bool;

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), $reveal, $Heap, f#0, xs#0) == Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, AsFuelBottom($ly), $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) == Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LZ, $reveal, $Heap, f#0, xs#0));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $h0: Heap, $h1: Heap, f#0: HandleType, xs#0: Seq :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $h1, f#0, xs#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && (Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $h0, f#0, xs#0) || ($Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && (exists i#0: int, o#0: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $h0, f#0, xs#0) == Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $h1, f#0, xs#0));

function Seq.__default.MapWithResult#requires(Ty, Ty, Ty, LayerType, Heap, HandleType, Seq) : bool;

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#3)))));

procedure {:verboseName "Seq.MapWithResult (well-formedness)"} CheckWellformed$$Seq.__default.MapWithResult(Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.MapWithResult$T))) returns (result#0: DatatypeType where $Is(result#0, Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6640"} Wrappers.Result.Success_q(result#0) ==> Seq#Length($Unbox(Wrappers.Result.value(result#0)): Seq) == Seq#Length(xs#0);
  free ensures {:id "id6641"} Wrappers.Result.Success_q(result#0) ==> (forall i#4: int :: { Seq#Index($Unbox(Wrappers.Result.value(result#0)): Seq, i#4) } { Seq#Index(xs#0, i#4) } (LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#4))): DatatypeType)) && (LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(result#0)): Seq, i#4) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#4))): DatatypeType)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.MapWithResult (well-formedness)"} CheckWellformed$$Seq.__default.MapWithResult(Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#5: int;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var i#6: int;
  var o#1: ref;
  var ##x0#1: Box;
  var b$reqreads#1: bool;
  var i#7: int;
  var o#2: ref;
  var ##x0#2: Box;
  var i#8: int;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var head#Z#0: Box;
  var let#1#0#0: Box;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var tail#Z#0: Seq;
  var let#3#0#0: Seq;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.MapWithResult", " | ", Seq._default.MapWithResult$T, " | ", Seq._default.MapWithResult$R, " | ", Seq._default.MapWithResult$E, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(637,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (exists i#0: int, o#0: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)));
    havoc i#5;
    assume true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} LitInt(0) <= i#5;
    goto anon4;

  anon40_Else:
    assume {:partition} i#5 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap);
    assume 0 <= i#5 && i#5 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#5);
    assume $IsAllocBox(##x0#0, Seq._default.MapWithResult$T, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#5));
    assume Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon6;

  anon39_Else:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)));
    assume b$reqreads#0;
    havoc i#6;
    havoc o#1;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} $Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} LitInt(0) <= i#6;
    goto anon9;

  anon42_Else:
    assume {:partition} i#6 < LitInt(0);
    goto anon9;

  anon9:
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap);
    assume 0 <= i#6 && i#6 < Seq#Length(xs#0);
    ##x0#1 := Seq#Index(xs#0, i#6);
    assume $IsAllocBox(##x0#1, Seq._default.MapWithResult$T, $Heap);
    assume Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#6));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#6))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Reads1#canCall(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#6));
    goto anon11;

  anon43_Else:
    assume {:partition} !(LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#6))[$Box(o#1)];
    goto anon13;

  anon44_Else:
    assume {:partition} !(LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#6))[$Box(o#1)]);
    goto anon13;

  anon41_Else:
    assume {:partition} !($Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap));
    goto anon13;

  anon13:
    assume b$reqreads#1;
    havoc i#7;
    havoc o#2;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} $Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap);
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} LitInt(0) <= i#7;
    goto anon16;

  anon46_Else:
    assume {:partition} i#7 < LitInt(0);
    goto anon16;

  anon16:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap);
    assume 0 <= i#7 && i#7 < Seq#Length(xs#0);
    ##x0#2 := Seq#Index(xs#0, i#7);
    assume $IsAllocBox(##x0#2, Seq._default.MapWithResult$T, $Heap);
    assume Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#7));
    assume Reads1#canCall(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#7));
    goto anon18;

  anon47_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0));
    goto anon18;

  anon18:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)];
    goto anon20;

  anon48_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)]);
    goto anon20;

  anon45_Else:
    assume {:partition} !($Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap));
    goto anon20;

  anon20:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E));
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume Wrappers.Result.Success_q(result#0);
    assume Wrappers.Result.Success_q(result#0);
    assume Seq#Length($Unbox(Wrappers.Result.value(result#0)): Seq) == Seq#Length(xs#0);
    havoc i#8;
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} true;
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} LitInt(0) <= i#8;
    goto anon25;

  anon52_Else:
    assume {:partition} i#8 < LitInt(0);
    goto anon25;

  anon25:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0);
    assume 0 <= i#8 && i#8 < Seq#Length(xs#0);
    assume Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#8));
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#8))): DatatypeType);
    assume Wrappers.Result.Success_q(result#0);
    assume 0 <= i#8 && i#8 < Seq#Length($Unbox(Wrappers.Result.value(result#0)): Seq);
    assume 0 <= i#8 && i#8 < Seq#Length(xs#0);
    assume Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#8));
    assume Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#8))): DatatypeType);
    goto anon28;

  anon54_Else:
    assume {:partition} !Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#8))): DatatypeType);
    goto anon28;

  anon53_Else:
    assume {:partition} !(LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0));
    goto anon28;

  anon51_Else:
    assume {:partition} false;
    goto anon28;

  anon28:
    assume (forall i#4: int :: { Seq#Index($Unbox(Wrappers.Result.value(result#0)): Seq, i#4) } { Seq#Index(xs#0, i#4) } (LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#4))): DatatypeType)) && (LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(result#0)): Seq, i#4) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#4))): DatatypeType)));
    goto anon30;

  anon50_Else:
    assume Wrappers.Result.Success_q(result#0) ==> Seq#Length($Unbox(Wrappers.Result.value(result#0)): Seq) == Seq#Length(xs#0) && (forall i#4: int :: { Seq#Index($Unbox(Wrappers.Result.value(result#0)): Seq, i#4) } { Seq#Index(xs#0, i#4) } (LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#4))): DatatypeType)) && (LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(result#0)): Seq, i#4) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#4))): DatatypeType)));
    goto anon30;

  anon30:
    assume false;
    return;

  anon49_Else:
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0) == Lit(#Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))));
    assume true;
    assume $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E));
    goto anon38;

  anon55_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)));
    b$reqreads#2 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume let#0#0#0 == $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType;
    assume true;
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#Z#0);
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#Z#0);
    assume Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0) == Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#Z#0);
    assume $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E));
    goto anon38;

  anon56_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#Z#0);
    havoc head#Z#0;
    assume $IsBox(head#Z#0, Seq._default.MapWithResult$R) && $IsAllocBox(head#Z#0, Seq._default.MapWithResult$R, $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#Z#0);
    assume let#1#0#0 == Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#Z#0);
    assume $IsBox(let#1#0#0, Seq._default.MapWithResult$R);
    assume head#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.MapWithResult$T), $Heap);
    assume {:subsumption 0} (forall i#9: int :: { Seq#Index(##xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#9)));
    assume (forall i#9: int :: { Seq#Index(##xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#9)));
    b$reqreads#3 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#10: int, o#3: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#10))[$Box(o#3)] } $Is(o#3, Tclass._System.object?()) && LitInt(0) <= i#10 && i#10 < Seq#Length(##xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#10))[$Box(o#3)] && $Box($o) == $Box(o#3)) ==> $_ReadsFrame[$o, $f]);
    assume (Set#Subset((lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))), (lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5)))) && !Set#Subset((lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5))), (lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))))) || (Set#Equal((lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))), (lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5)))) && Seq#Rank(##xs#0) < Seq#Rank(xs#0));
    assume Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume let#2#0#0 == Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#Z#0);
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#Z#0);
    assume Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0) == Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#Z#0);
    assume $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E));
    goto anon38;

  anon57_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#Z#0);
    havoc tail#Z#0;
    assume $Is(tail#Z#0, TSeq(Seq._default.MapWithResult$R)) && $IsAlloc(tail#Z#0, TSeq(Seq._default.MapWithResult$R), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Seq._default.MapWithResult$R));
    assume tail#Z#0 == let#3#0#0;
    assume Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#Z#0), tail#Z#0)));
    assume true;
    assume $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E));
    goto anon38;

  anon38:
    assume Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, f#0, xs#0) == result#0;
    assume b$reqreads#2;
    assume b$reqreads#3;
    return;
}



procedure {:verboseName "Seq.LemmaMapDistributesOverConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMapDistributesOverConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType, xs#0: Seq, ys#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##x0#0: Box;
  var j#0: int;
  var ##x0#1: Box;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var ##f#2: HandleType;
  var ##xs#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMapDistributesOverConcat", " | ", Seq._default.LemmaMapDistributesOverConcat$T, " | ", Seq._default.LemmaMapDistributesOverConcat$R, " | ", f#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(656,8): initial state"} true;
    havoc i#0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon13_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#0);
    assume $IsAllocBox(##x0#0, Seq._default.LemmaMapDistributesOverConcat$T, $Heap);
    assume Requires1#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(xs#0, i#0));
    assume Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(xs#0, i#0));
    goto anon6;

  anon12_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(xs#0, i#0));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(xs#0, i#1)));
    havoc j#0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= j#0;
    goto anon9;

  anon15_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon9;

  anon9:
    assume LitInt(0) <= j#0 && j#0 < Seq#Length(ys#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    assume 0 <= j#0 && j#0 < Seq#Length(ys#0);
    ##x0#1 := Seq#Index(ys#0, j#0);
    assume $IsAllocBox(##x0#1, Seq._default.LemmaMapDistributesOverConcat$T, $Heap);
    assume Requires1#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(ys#0, j#0));
    assume Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(ys#0, j#0));
    goto anon11;

  anon14_Else:
    assume LitInt(0) <= j#0 && j#0 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(ys#0, j#0));
    goto anon11;

  anon11:
    assume (forall j#1: int :: { Seq#Index(ys#0, j#1) } LitInt(0) <= j#1 && j#1 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(ys#0, j#1)));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(659,28): post-state"} true;
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { Seq#Index(##xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#0, Seq#Index(##xs#0, i#2)));
    assume (forall i#2: int :: { Seq#Index(##xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#0, Seq#Index(##xs#0, i#2)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0));
    ##f#1 := f#0;
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { Seq#Index(##xs#1, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1, Seq#Index(##xs#1, i#3)));
    assume (forall i#3: int :: { Seq#Index(##xs#1, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1, Seq#Index(##xs#1, i#3)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, xs#0);
    ##f#2 := f#0;
    assume $IsAlloc(##f#2, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#2 := ys#0;
    assume $IsAlloc(##xs#2, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { Seq#Index(##xs#2, i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#2) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#2, Seq#Index(##xs#2, i#4)));
    assume (forall i#4: int :: { Seq#Index(##xs#2, i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#2) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#2, Seq#Index(##xs#2, i#4)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume Seq#Equal(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)));
    return;
}



procedure {:verboseName "Seq.LemmaMapDistributesOverConcat (call precondtion)"} CallPre$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap));
  requires {:id "id6703"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(xs#0, i#1)));
  requires {:id "id6704"} (forall j#1: int :: { Seq#Index(ys#0, j#1) } LitInt(0) <= j#1 && j#1 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(ys#0, j#1)));



procedure {:verboseName "Seq.LemmaMapDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0)) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, xs#0) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
  free ensures {:id "id6705"} Seq#Equal(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaMapDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6706"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(xs#0, i#1)));
  requires {:id "id6707"} (forall j#1: int :: { Seq#Index(ys#0, j#1) } LitInt(0) <= j#1 && j#1 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Index(ys#0, j#1)));
  modifies $Heap;
  free ensures Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0)) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, xs#0) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
  free ensures {:id "id6708"} Seq#Equal(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaMapDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##f#1_0_0_0: HandleType;
  var ##xs#1_0_0_0: Seq;
  var ##f#1_0_0_1: HandleType;
  var ##xs#1_0_0_1: Seq;
  var ##f#1_0_0_2: HandleType;
  var ##xs#1_0_0_2: Seq;
  var ##f#1_0_0_3: HandleType;
  var ##xs#1_0_0_3: Seq;
  var ##f#1_0_0_4: HandleType;
  var ##xs#1_0_0_4: Seq;
  var ##f#1_0_1_0: HandleType;
  var ##xs#1_0_1_0: Seq;
  var ##f#1_0_1_1: HandleType;
  var ##xs#1_0_1_1: Seq;
  var ##f#1_0_1_2: HandleType;
  var ##xs#1_0_1_2: Seq;
  var ##f#1_0_1_3: HandleType;
  var ##xs#1_0_1_3: Seq;
  var ##f#1_0_1_4: HandleType;
  var ##xs#1_0_1_4: Seq;
  var ##f#1_0_2_0: HandleType;
  var ##xs#1_0_2_0: Seq;
  var ##f#1_0_2_1: HandleType;
  var ##xs#1_0_2_1: Seq;
  var ##f#1_0_2_2: HandleType;
  var ##xs#1_0_2_2: Seq;
  var ##f#1_0_0: HandleType;
  var ##xs#1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaMapDistributesOverConcat", " | ", Seq._default.LemmaMapDistributesOverConcat$T, " | ", Seq._default.LemmaMapDistributesOverConcat$R, " | ", f#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(660,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__Map();
    call CallPost$$Seq.__default.reveal__Map();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(661,15)"} true;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume true;
    assume Seq#Equal(Seq#Append(xs#0, ys#0), ys#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(663,26)"} true;
    return;

  anon8_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##f#1_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0: int :: { Seq#Index(##xs#1_0_0, i#1_0_0) } LitInt(0) <= i#1_0_0 && i#1_0_0 < Seq#Length(##xs#1_0_0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_0, Seq#Index(##xs#1_0_0, i#1_0_0)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##f#1_0_2_0 := f#0;
    assume $IsAlloc(##f#1_0_2_0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_2_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_2_0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_2_0: int :: { Seq#Index(##xs#1_0_2_0, i#1_0_2_0) } LitInt(0) <= i#1_0_2_0 && i#1_0_2_0 < Seq#Length(##xs#1_0_2_0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_2_0, Seq#Index(##xs#1_0_2_0, i#1_0_2_0)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    assume Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0)) == Seq#Index(xs#0, LitInt(0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(667,38)"} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(667,77)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_2_1 := f#0;
    assume $IsAlloc(##f#1_0_2_1, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_2_1 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_2_1, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_2_1: int :: { Seq#Index(##xs#1_0_2_1, i#1_0_2_1) } LitInt(0) <= i#1_0_2_1 && i#1_0_2_1 < Seq#Length(##xs#1_0_2_1) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_2_1, Seq#Index(##xs#1_0_2_1, i#1_0_2_1)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_2_2 := f#0;
    assume $IsAlloc(##f#1_0_2_2, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_2_2 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_2_2, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_2_2: int :: { Seq#Index(##xs#1_0_2_2, i#1_0_2_2) } LitInt(0) <= i#1_0_2_2 && i#1_0_2_2 < Seq#Length(##xs#1_0_2_2) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_2_2, Seq#Index(##xs#1_0_2_2, i#1_0_2_2)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} Seq#Equal(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0))));
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_1_0 := f#0;
    assume $IsAlloc(##f#1_0_1_0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_1_0 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_1_0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_0: int :: { Seq#Index(##xs#1_0_1_0, i#1_0_1_0) } LitInt(0) <= i#1_0_1_0 && i#1_0_1_0 < Seq#Length(##xs#1_0_1_0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_1_0, Seq#Index(##xs#1_0_1_0, i#1_0_1_0)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_1 := f#0;
    assume $IsAlloc(##f#1_0_1_1, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_1_1 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_1_1, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_1: int :: { Seq#Index(##xs#1_0_1_1, i#1_0_1_1) } LitInt(0) <= i#1_0_1_1 && i#1_0_1_1 < Seq#Length(##xs#1_0_1_1) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_1_1, Seq#Index(##xs#1_0_1_1, i#1_0_1_1)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_1_2 := f#0;
    assume $IsAlloc(##f#1_0_1_2, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_1_2 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_1_2, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_2: int :: { Seq#Index(##xs#1_0_1_2, i#1_0_1_2) } LitInt(0) <= i#1_0_1_2 && i#1_0_1_2 < Seq#Length(##xs#1_0_1_2) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_1_2, Seq#Index(##xs#1_0_1_2, i#1_0_1_2)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_3 := f#0;
    assume $IsAlloc(##f#1_0_1_3, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_1_3 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_1_3, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_3: int :: { Seq#Index(##xs#1_0_1_3, i#1_0_1_3) } LitInt(0) <= i#1_0_1_3 && i#1_0_1_3 < Seq#Length(##xs#1_0_1_3) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_1_3, Seq#Index(##xs#1_0_1_3, i#1_0_1_3)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_1_4 := f#0;
    assume $IsAlloc(##f#1_0_1_4, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_1_4 := ys#0;
    assume $IsAlloc(##xs#1_0_1_4, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_4: int :: { Seq#Index(##xs#1_0_1_4, i#1_0_1_4) } LitInt(0) <= i#1_0_1_4 && i#1_0_1_4 < Seq#Length(##xs#1_0_1_4) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_1_4, Seq#Index(##xs#1_0_1_4, i#1_0_1_4)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0))), Seq#Append(Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0_0, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_0_0 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_0_0, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_0: int :: { Seq#Index(##xs#1_0_0_0, i#1_0_0_0) } LitInt(0) <= i#1_0_0_0 && i#1_0_0_0 < Seq#Length(##xs#1_0_0_0) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_0_0, Seq#Index(##xs#1_0_0_0, i#1_0_0_0)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_0_1 := f#0;
    assume $IsAlloc(##f#1_0_0_1, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_0_1 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_0_1, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_1: int :: { Seq#Index(##xs#1_0_0_1, i#1_0_0_1) } LitInt(0) <= i#1_0_0_1 && i#1_0_0_1 < Seq#Length(##xs#1_0_0_1) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_0_1, Seq#Index(##xs#1_0_0_1, i#1_0_0_1)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_0_2 := f#0;
    assume $IsAlloc(##f#1_0_0_2, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_0_2 := ys#0;
    assume $IsAlloc(##xs#1_0_0_2, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_2: int :: { Seq#Index(##xs#1_0_0_2, i#1_0_0_2) } LitInt(0) <= i#1_0_0_2 && i#1_0_0_2 < Seq#Length(##xs#1_0_0_2) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_0_2, Seq#Index(##xs#1_0_0_2, i#1_0_0_2)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0), Seq#Append(xs#0, ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(670,56)"} true;
    ##f#1_0_0_3 := f#0;
    assume $IsAlloc(##f#1_0_0_3, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_0_3 := xs#0;
    assume $IsAlloc(##xs#1_0_0_3, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_3: int :: { Seq#Index(##xs#1_0_0_3, i#1_0_0_3) } LitInt(0) <= i#1_0_0_3 && i#1_0_0_3 < Seq#Length(##xs#1_0_0_3) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_0_3, Seq#Index(##xs#1_0_0_3, i#1_0_0_3)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, xs#0);
    ##f#1_0_0_4 := f#0;
    assume $IsAlloc(##f#1_0_0_4, Tclass._System.___hFunc1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R), $Heap);
    ##xs#1_0_0_4 := ys#0;
    assume $IsAlloc(##xs#1_0_0_4, TSeq(Seq._default.LemmaMapDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_4: int :: { Seq#Index(##xs#1_0_0_4, i#1_0_0_4) } LitInt(0) <= i#1_0_0_4 && i#1_0_0_4 < Seq#Length(##xs#1_0_0_4) ==> Requires1(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, ##f#1_0_0_4, Seq#Index(##xs#1_0_0_4, i#1_0_0_4)));
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, xs#0) && Seq.__default.Map#canCall(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, $Heap, f#0, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)), Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, xs#0), Seq.__default.Map(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, reveal_Seq._default.Map, $Heap, f#0, ys#0)));
    return;
}



function Seq.__default.Filter(Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $heap: Heap, f#0: HandleType, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#2: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#2) } LitInt(0) <= i#2 ==> i#2 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#2)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#2))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T), $Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#3)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));
}

function Seq.__default.Filter#canCall(Seq._default.Filter$T: Ty, $heap: Heap, f#0: HandleType, xs#0: Seq) : bool;

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), $reveal, $Heap, f#0, xs#0) == Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, AsFuelBottom($ly), $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) == Seq.__default.Filter(Seq._default.Filter$T, $LZ, $reveal, $Heap, f#0, xs#0));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $h0: Heap, $h1: Heap, f#0: HandleType, xs#0: Seq :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $h1, f#0, xs#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && (Seq.__default.Filter#canCall(Seq._default.Filter$T, $h0, f#0, xs#0) || ($Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && (exists i#0: int, o#0: ref :: { Reads1(Seq._default.Filter$T, TBool, $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $h0, f#0, xs#0) == Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $h1, f#0, xs#0));

function Seq.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq) : bool;

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#3)))));

procedure {:verboseName "Seq.Filter (well-formedness)"} CheckWellformed$$Seq.__default.Filter(Seq._default.Filter$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.Filter$T))) returns (result#0: Seq where $Is(result#0, TSeq(Seq._default.Filter$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id6747"} Seq#Length(result#0) <= Seq#Length(xs#0);
  free ensures {:id "id6748"} (forall i#4: int :: { Seq#Index(result#0, i#4) } LitInt(0) <= i#4 ==> i#4 < Seq#Length(result#0) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4))): bool);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.Filter (well-formedness)"} CheckWellformed$$Seq.__default.Filter(Seq._default.Filter$T: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#5: int;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var i#6: int;
  var o#1: ref;
  var ##x0#1: Box;
  var b$reqreads#1: bool;
  var i#7: int;
  var o#2: ref;
  var ##x0#2: Box;
  var i#8: int;
  var ##x0#3: Box;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.Filter", " | ", Seq._default.Filter$T, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(678,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (exists i#0: int, o#0: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)));
    havoc i#5;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= i#5;
    goto anon4;

  anon33_Else:
    assume {:partition} i#5 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap);
    assume 0 <= i#5 && i#5 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#5);
    assume $IsAllocBox(##x0#0, Seq._default.Filter$T, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#5));
    assume Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon6;

  anon32_Else:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)));
    assume b$reqreads#0;
    havoc i#6;
    havoc o#1;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} $Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap);
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} LitInt(0) <= i#6;
    goto anon9;

  anon35_Else:
    assume {:partition} i#6 < LitInt(0);
    goto anon9;

  anon9:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap);
    assume 0 <= i#6 && i#6 < Seq#Length(xs#0);
    ##x0#1 := Seq#Index(xs#0, i#6);
    assume $IsAllocBox(##x0#1, Seq._default.Filter$T, $Heap);
    assume Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Reads1#canCall(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6));
    goto anon11;

  anon36_Else:
    assume {:partition} !(LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6))[$Box(o#1)];
    goto anon13;

  anon37_Else:
    assume {:partition} !(LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6))[$Box(o#1)]);
    goto anon13;

  anon34_Else:
    assume {:partition} !($Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap));
    goto anon13;

  anon13:
    assume b$reqreads#1;
    havoc i#7;
    havoc o#2;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} LitInt(0) <= i#7;
    goto anon16;

  anon39_Else:
    assume {:partition} i#7 < LitInt(0);
    goto anon16;

  anon16:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap);
    assume 0 <= i#7 && i#7 < Seq#Length(xs#0);
    ##x0#2 := Seq#Index(xs#0, i#7);
    assume $IsAllocBox(##x0#2, Seq._default.Filter$T, $Heap);
    assume Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7));
    assume Reads1#canCall(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7));
    goto anon18;

  anon40_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0));
    goto anon18;

  anon18:
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)];
    goto anon20;

  anon41_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)]);
    goto anon20;

  anon38_Else:
    assume {:partition} !($Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap));
    goto anon20;

  anon20:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume $Is(Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T));
    assume Seq#Length(result#0) <= Seq#Length(xs#0);
    havoc i#8;
    assume LitInt(0) <= i#8;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume i#8 < Seq#Length(result#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap);
    assume 0 <= i#8 && i#8 < Seq#Length(result#0);
    ##x0#3 := Seq#Index(result#0, i#8);
    assume $IsAllocBox(##x0#3, Seq._default.Filter$T, $Heap);
    assume Requires1#canCall(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8));
    assume Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8));
    assume 0 <= i#8 && i#8 < Seq#Length(result#0);
    assume Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8));
    assume $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8))): bool;
    goto anon24;

  anon43_Else:
    assume i#8 < Seq#Length(result#0) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8))): bool;
    goto anon24;

  anon24:
    assume (forall i#4: int :: { Seq#Index(result#0, i#4) } LitInt(0) <= i#4 ==> i#4 < Seq#Length(result#0) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4))): bool);
    assume false;
    return;

  anon42_Else:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T));
    goto anon31;

  anon44_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)));
    b$reqreads#2 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    goto anon30;

  anon45_Else:
    assume {:partition} !$Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool;
    goto anon30;

  anon30:
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.Filter$T), $Heap);
    assume {:subsumption 0} (forall i#9: int :: { Seq#Index(##xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#9)));
    assume (forall i#9: int :: { Seq#Index(##xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#9)));
    b$reqreads#3 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#10: int, o#3: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#10))[$Box(o#3)] } $Is(o#3, Tclass._System.object?()) && LitInt(0) <= i#10 && i#10 < Seq#Length(##xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#10))[$Box(o#3)] && $Box($o) == $Box(o#3)) ==> $_ReadsFrame[$o, $f]);
    assume (Set#Subset((lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))), (lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5)))) && !Set#Subset((lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5))), (lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))))) || (Set#Equal((lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))), (lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5)))) && Seq#Rank(##xs#0) < Seq#Rank(xs#0));
    assume Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0) == Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))));
    assume Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume $Is(Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T));
    goto anon31;

  anon31:
    assume Seq.__default.Filter(Seq._default.Filter$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0) == result#0;
    assume b$reqreads#2;
    assume b$reqreads#3;
    return;
}



procedure {:verboseName "Seq.LemmaFilterDistributesOverConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFilterDistributesOverConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType, xs#0: Seq, ys#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##x0#0: Box;
  var j#0: int;
  var ##x0#1: Box;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var ##f#2: HandleType;
  var ##xs#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFilterDistributesOverConcat", " | ", Seq._default.LemmaFilterDistributesOverConcat$T, " | ", f#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(691,8): initial state"} true;
    havoc i#0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon13_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#0);
    assume $IsAllocBox(##x0#0, Seq._default.LemmaFilterDistributesOverConcat$T, $Heap);
    assume Requires1#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0));
    assume Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0));
    goto anon6;

  anon12_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)));
    havoc j#0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= j#0;
    goto anon9;

  anon15_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon9;

  anon9:
    assume LitInt(0) <= j#0 && j#0 < Seq#Length(ys#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    assume 0 <= j#0 && j#0 < Seq#Length(ys#0);
    ##x0#1 := Seq#Index(ys#0, j#0);
    assume $IsAllocBox(##x0#1, Seq._default.LemmaFilterDistributesOverConcat$T, $Heap);
    assume Requires1#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(ys#0, j#0));
    assume Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(ys#0, j#0));
    goto anon11;

  anon14_Else:
    assume LitInt(0) <= j#0 && j#0 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(ys#0, j#0));
    goto anon11;

  anon11:
    assume (forall j#1: int :: { Seq#Index(ys#0, j#1) } LitInt(0) <= j#1 && j#1 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(ys#0, j#1)));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(694,31): post-state"} true;
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { Seq#Index(##xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#2)));
    assume (forall i#2: int :: { Seq#Index(##xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#2)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0));
    ##f#1 := f#0;
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1 := xs#0;
    assume $IsAlloc(##xs#1, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { Seq#Index(##xs#1, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1, Seq#Index(##xs#1, i#3)));
    assume (forall i#3: int :: { Seq#Index(##xs#1, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1, Seq#Index(##xs#1, i#3)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, xs#0);
    ##f#2 := f#0;
    assume $IsAlloc(##f#2, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#2 := ys#0;
    assume $IsAlloc(##xs#2, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { Seq#Index(##xs#2, i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#2) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#2, Seq#Index(##xs#2, i#4)));
    assume (forall i#4: int :: { Seq#Index(##xs#2, i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#2) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#2, Seq#Index(##xs#2, i#4)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
    return;
}



procedure {:verboseName "Seq.LemmaFilterDistributesOverConcat (call precondtion)"} CallPre$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap));
  requires {:id "id6794"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)));
  requires {:id "id6795"} (forall j#1: int :: { Seq#Index(ys#0, j#1) } LitInt(0) <= j#1 && j#1 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(ys#0, j#1)));



procedure {:verboseName "Seq.LemmaFilterDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0)) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, xs#0) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
  free ensures {:id "id6796"} Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, xs#0), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFilterDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6797"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)));
  requires {:id "id6798"} (forall j#1: int :: { Seq#Index(ys#0, j#1) } LitInt(0) <= j#1 && j#1 < Seq#Length(ys#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, f#0, Seq#Index(ys#0, j#1)));
  modifies $Heap;
  free ensures Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0)) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, xs#0) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
  free ensures {:id "id6799"} Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, xs#0), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFilterDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##f#1_0_0_0: HandleType;
  var ##xs#1_0_0_0: Seq;
  var ##f#1_0_0_1: HandleType;
  var ##xs#1_0_0_1: Seq;
  var ##f#1_0_0_2: HandleType;
  var ##xs#1_0_0_2: Seq;
  var ##f#1_0_0_3: HandleType;
  var ##xs#1_0_0_3: Seq;
  var ##f#1_0_0_4: HandleType;
  var ##xs#1_0_0_4: Seq;
  var ##f#1_0_1_0: HandleType;
  var ##xs#1_0_1_0: Seq;
  var ##f#1_0_1_1: HandleType;
  var ##xs#1_0_1_1: Seq;
  var ##f#1_0_1_2: HandleType;
  var ##xs#1_0_1_2: Seq;
  var ##f#1_0_1_3: HandleType;
  var ##xs#1_0_1_3: Seq;
  var ##f#1_0_1_4: HandleType;
  var ##xs#1_0_1_4: Seq;
  var ##f#1_0_1_5: HandleType;
  var ##xs#1_0_1_5: Seq;
  var ##f#1_0_1_6: HandleType;
  var ##xs#1_0_1_6: Seq;
  var ##f#1_0_1_7: HandleType;
  var ##xs#1_0_1_7: Seq;
  var ##f#1_0_2_0: HandleType;
  var ##xs#1_0_2_0: Seq;
  var ##f#1_0_2_1: HandleType;
  var ##xs#1_0_2_1: Seq;
  var ##f#1_0_2_2: HandleType;
  var ##xs#1_0_2_2: Seq;
  var ##f#1_0_0: HandleType;
  var ##xs#1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFilterDistributesOverConcat", " | ", Seq._default.LemmaFilterDistributesOverConcat$T, " | ", f#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(695,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#f0#0: HandleType, $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#f0#0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool)) && $Is($ih#xs0#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && $Is($ih#ys0#0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T)) && (forall i#5: int :: { Seq#Index($ih#xs0#0, i#5) } LitInt(0) <= i#5 && i#5 < Seq#Length($ih#xs0#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $initHeapForallStmt#0, $ih#f0#0, Seq#Index($ih#xs0#0, i#5))) && (forall j#2: int :: { Seq#Index($ih#ys0#0, j#2) } LitInt(0) <= j#2 && j#2 < Seq#Length($ih#ys0#0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $initHeapForallStmt#0, $ih#f0#0, Seq#Index($ih#ys0#0, j#2))) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, $ih#f0#0, Seq#Append($ih#xs0#0, $ih#ys0#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, $ih#f0#0, $ih#xs0#0), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, $ih#f0#0, $ih#ys0#0))));
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__Filter();
    call CallPost$$Seq.__default.reveal__Filter();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(696,18)"} true;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume true;
    assume Seq#Equal(Seq#Append(xs#0, ys#0), ys#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(698,26)"} true;
    return;

  anon8_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##f#1_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0: int :: { Seq#Index(##xs#1_0_0, i#1_0_0) } LitInt(0) <= i#1_0_0 && i#1_0_0 < Seq#Length(##xs#1_0_0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_0, Seq#Index(##xs#1_0_0, i#1_0_0)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##f#1_0_2_0 := f#0;
    assume $IsAlloc(##f#1_0_2_0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_2_0 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_2_0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_2_0: int :: { Seq#Index(##xs#1_0_2_0, i#1_0_2_0) } LitInt(0) <= i#1_0_2_0 && i#1_0_2_0 < Seq#Length(##xs#1_0_2_0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_2_0, Seq#Index(##xs#1_0_2_0, i#1_0_2_0)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    assume {:split_here} Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0)) == Seq#Index(xs#0, LitInt(0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(702,52)"} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(702,91)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_2_1 := f#0;
    assume $IsAlloc(##f#1_0_2_1, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_2_1 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_2_1, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_2_1: int :: { Seq#Index(##xs#1_0_2_1, i#1_0_2_1) } LitInt(0) <= i#1_0_2_1 && i#1_0_2_1 < Seq#Length(##xs#1_0_2_1) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_2_1, Seq#Index(##xs#1_0_2_1, i#1_0_2_1)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_2_2 := f#0;
    assume $IsAlloc(##f#1_0_2_2, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_2_2 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_2_2, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_2_2: int :: { Seq#Index(##xs#1_0_2_2, i#1_0_2_2) } LitInt(0) <= i#1_0_2_2 && i#1_0_2_2 < Seq#Length(##xs#1_0_2_2) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_2_2, Seq#Index(##xs#1_0_2_2, i#1_0_2_2)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0))));
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_1_0 := f#0;
    assume $IsAlloc(##f#1_0_1_0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_0 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_1_0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_0: int :: { Seq#Index(##xs#1_0_1_0, i#1_0_1_0) } LitInt(0) <= i#1_0_1_0 && i#1_0_1_0 < Seq#Length(##xs#1_0_1_0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_0, Seq#Index(##xs#1_0_1_0, i#1_0_1_0)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_1 := f#0;
    assume $IsAlloc(##f#1_0_1_1, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_1 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_1_1, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_1: int :: { Seq#Index(##xs#1_0_1_1, i#1_0_1_1) } LitInt(0) <= i#1_0_1_1 && i#1_0_1_1 < Seq#Length(##xs#1_0_1_1) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_1, Seq#Index(##xs#1_0_1_1, i#1_0_1_1)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_2 := f#0;
    assume $IsAlloc(##f#1_0_1_2, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_2 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_1_2, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_2: int :: { Seq#Index(##xs#1_0_1_2, i#1_0_1_2) } LitInt(0) <= i#1_0_1_2 && i#1_0_1_2 < Seq#Length(##xs#1_0_1_2) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_2, Seq#Index(##xs#1_0_1_2, i#1_0_1_2)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_3 := f#0;
    assume $IsAlloc(##f#1_0_1_3, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_3 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_1_3, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_3: int :: { Seq#Index(##xs#1_0_1_3, i#1_0_1_3) } LitInt(0) <= i#1_0_1_3 && i#1_0_1_3 < Seq#Length(##xs#1_0_1_3) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_3, Seq#Index(##xs#1_0_1_3, i#1_0_1_3)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_1_4 := f#0;
    assume $IsAlloc(##f#1_0_1_4, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_4 := ys#0;
    assume $IsAlloc(##xs#1_0_1_4, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_4: int :: { Seq#Index(##xs#1_0_1_4, i#1_0_1_4) } LitInt(0) <= i#1_0_1_4 && i#1_0_1_4 < Seq#Length(##xs#1_0_1_4) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_4, Seq#Index(##xs#1_0_1_4, i#1_0_1_4)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0)) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
    assume Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(704,78)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_1_5 := f#0;
    assume $IsAlloc(##f#1_0_1_5, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_5 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_1_5, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_5: int :: { Seq#Index(##xs#1_0_1_5, i#1_0_1_5) } LitInt(0) <= i#1_0_1_5 && i#1_0_1_5 < Seq#Length(##xs#1_0_1_5) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_5, Seq#Index(##xs#1_0_1_5, i#1_0_1_5)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_6 := f#0;
    assume $IsAlloc(##f#1_0_1_6, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_6 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_1_6, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_6: int :: { Seq#Index(##xs#1_0_1_6, i#1_0_1_6) } LitInt(0) <= i#1_0_1_6 && i#1_0_1_6 < Seq#Length(##xs#1_0_1_6) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_6, Seq#Index(##xs#1_0_1_6, i#1_0_1_6)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_1_7 := f#0;
    assume $IsAlloc(##f#1_0_1_7, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_1_7 := ys#0;
    assume $IsAlloc(##xs#1_0_1_7, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_1_7: int :: { Seq#Index(##xs#1_0_1_7, i#1_0_1_7) } LitInt(0) <= i#1_0_1_7 && i#1_0_1_7 < Seq#Length(##xs#1_0_1_7) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_1_7, Seq#Index(##xs#1_0_1_7, i#1_0_1_7)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0))), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, ys#0))));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    ##f#1_0_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0_0, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_0_0 := Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)));
    assume $IsAlloc(##xs#1_0_0_0, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_0: int :: { Seq#Index(##xs#1_0_0_0, i#1_0_0_0) } LitInt(0) <= i#1_0_0_0 && i#1_0_0_0 < Seq#Length(##xs#1_0_0_0) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_0_0, Seq#Index(##xs#1_0_0_0, i#1_0_0_0)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_0_1 := f#0;
    assume $IsAlloc(##f#1_0_0_1, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_0_1 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_0_1, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_1: int :: { Seq#Index(##xs#1_0_0_1, i#1_0_0_1) } LitInt(0) <= i#1_0_0_1 && i#1_0_0_1 < Seq#Length(##xs#1_0_0_1) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_0_1, Seq#Index(##xs#1_0_0_1, i#1_0_0_1)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_0_2 := f#0;
    assume $IsAlloc(##f#1_0_0_2, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_0_2 := ys#0;
    assume $IsAlloc(##xs#1_0_0_2, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_2: int :: { Seq#Index(##xs#1_0_0_2, i#1_0_0_2) } LitInt(0) <= i#1_0_0_2 && i#1_0_0_2 < Seq#Length(##xs#1_0_0_2) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_0_2, Seq#Index(##xs#1_0_0_2, i#1_0_0_2)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume {:split_here} Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0)), Seq#Append(xs#0, ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(706,73)"} true;
    ##f#1_0_0_3 := f#0;
    assume $IsAlloc(##f#1_0_0_3, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_0_3 := xs#0;
    assume $IsAlloc(##xs#1_0_0_3, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_3: int :: { Seq#Index(##xs#1_0_0_3, i#1_0_0_3) } LitInt(0) <= i#1_0_0_3 && i#1_0_0_3 < Seq#Length(##xs#1_0_0_3) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_0_3, Seq#Index(##xs#1_0_0_3, i#1_0_0_3)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, xs#0);
    ##f#1_0_0_4 := f#0;
    assume $IsAlloc(##f#1_0_0_4, Tclass._System.___hFunc1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool), $Heap);
    ##xs#1_0_0_4 := ys#0;
    assume $IsAlloc(##xs#1_0_0_4, TSeq(Seq._default.LemmaFilterDistributesOverConcat$T), $Heap);
    assume {:subsumption 0} (forall i#1_0_0_4: int :: { Seq#Index(##xs#1_0_0_4, i#1_0_0_4) } LitInt(0) <= i#1_0_0_4 && i#1_0_0_4 < Seq#Length(##xs#1_0_0_4) ==> Requires1(Seq._default.LemmaFilterDistributesOverConcat$T, TBool, $Heap, ##f#1_0_0_4, Seq#Index(##xs#1_0_0_4, i#1_0_0_4)));
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, xs#0) && Seq.__default.Filter#canCall(Seq._default.LemmaFilterDistributesOverConcat$T, $Heap, f#0, ys#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0)))), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, ys#0))), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, xs#0), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, Seq#Append(xs#0, ys#0)), Seq#Append(Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, xs#0), Seq.__default.Filter(Seq._default.LemmaFilterDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.Filter, $Heap, f#0, ys#0)));
    return;
}



function Seq.__default.FoldLeft(Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, xs#0) || (0 < $FunctionContextHeight && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> $IsBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0), Seq._default.FoldLeft$A));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq :: { $IsAllocBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0), Seq._default.FoldLeft$A, $Heap) } (Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, xs#0) || (0 < $FunctionContextHeight && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A), $Heap) && $IsBox(init#0, Seq._default.FoldLeft$A) && $IsAllocBox(init#0, Seq._default.FoldLeft$A, $Heap) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FoldLeft$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0), Seq._default.FoldLeft$A, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then init#0 else Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: {:weight 3} { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, Lit(xs#0)), $IsGoodHeap($Heap) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, Lit(xs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))) && Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: {:weight 3} { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, Lit(f#0), Lit(init#0), Lit(xs#0)), $IsGoodHeap($Heap) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Lit(f#0), Lit(init#0), Lit(xs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Lit(f#0), Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, Lit(f#0), Lit(init#0), Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))) && Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, Lit(f#0), Lit(init#0), Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), reveal_Seq._default.FoldLeft, Lit(f#0), Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, Lit(f#0), Lit(init#0), Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))));
}

function Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, f#0: HandleType, init#0: Box, xs#0: Seq) : bool;

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), $reveal, f#0, init#0, xs#0) } Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), $reveal, f#0, init#0, xs#0) == Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0));

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, AsFuelBottom($ly), $reveal, f#0, init#0, xs#0) } Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0) == Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LZ, $reveal, f#0, init#0, xs#0));

function Seq.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq) : bool;

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft#requires(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, f#0, init#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T)) ==> (Seq.__default.FoldLeft#requires(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, f#0, init#0, xs#0) <==> true));

procedure {:verboseName "Seq.FoldLeft (well-formedness)"} CheckWellformed$$Seq.__default.FoldLeft(Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)), init#0: Box where $IsBox(init#0, Seq._default.FoldLeft$A), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FoldLeft$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.FoldLeft (well-formedness)"} CheckWellformed$$Seq.__default.FoldLeft(Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, f#0: HandleType, init#0: Box, xs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##f#0: HandleType;
  var ##init#0: Box;
  var ##xs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.FoldLeft", " | ", Seq._default.FoldLeft$A, " | ", Seq._default.FoldLeft$T, " | ", f#0, " | ", init#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Box", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(714,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $IsBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), Seq._default.FoldLeft$A);
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0) == init#0;
    assume true;
    assume $IsBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), Seq._default.FoldLeft$A);
    return;

  anon7_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A), $Heap);
    ##init#0 := Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0)));
    assume $IsAllocBox(##init#0, Seq._default.FoldLeft$A, $Heap);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.FoldLeft$T), $Heap);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    assume Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0) == Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    assume Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    assume $IsBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), Seq._default.FoldLeft$A);
    return;
}



procedure {:verboseName "Seq.LemmaFoldLeftDistributesOverConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A: Ty, Seq._default.LemmaFoldLeftDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaFoldLeftDistributesOverConcat (call precondtion)"} CallPre$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A: Ty, Seq._default.LemmaFoldLeftDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap));
  requires {:id "id6852"} LitInt(0) <= Seq#Length(Seq#Append(xs#0, ys#0));



procedure {:verboseName "Seq.LemmaFoldLeftDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A: Ty, Seq._default.LemmaFoldLeftDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, Seq#Append(xs#0, ys#0)) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
  free ensures {:id "id6853"} Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, init#0, Seq#Append(xs#0, ys#0)) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFoldLeftDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A: Ty, Seq._default.LemmaFoldLeftDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6854"} LitInt(0) <= Seq#Length(Seq#Append(xs#0, ys#0));
  modifies $Heap;
  free ensures Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, Seq#Append(xs#0, ys#0)) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
  free ensures {:id "id6855"} Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, init#0, Seq#Append(xs#0, ys#0)) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFoldLeftDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A: Ty, Seq._default.LemmaFoldLeftDistributesOverConcat$T: Ty, f#0: HandleType, init#0: Box, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##f#1_0_0_0: HandleType;
  var ##init#1_0_0_0: Box;
  var ##xs#1_0_0_0: Seq;
  var ##f#1_0_0_1: HandleType;
  var ##init#1_0_0_1: Box;
  var ##xs#1_0_0_1: Seq;
  var ##f#1_0_1_0: HandleType;
  var ##init#1_0_1_0: Box;
  var ##xs#1_0_1_0: Seq;
  var ##f#1_0_1_1: HandleType;
  var ##init#1_0_1_1: Box;
  var ##xs#1_0_1_1: Seq;
  var f##1_0_1_0: HandleType;
  var init##1_0_1_0: Box;
  var xs##1_0_1_0: Seq;
  var ys##1_0_1_0: Seq;
  var ##f#1_0_1_2: HandleType;
  var ##init#1_0_1_2: Box;
  var ##xs#1_0_1_2: Seq;
  var ##f#1_0_2_0: HandleType;
  var ##init#1_0_2_0: Box;
  var ##xs#1_0_2_0: Seq;
  var ##f#1_0_2_1: HandleType;
  var ##init#1_0_2_1: Box;
  var ##xs#1_0_2_1: Seq;
  var ##f#1_0_2_2: HandleType;
  var ##init#1_0_2_2: Box;
  var ##xs#1_0_2_2: Seq;
  var ##f#1_0_2_3: HandleType;
  var ##init#1_0_2_3: Box;
  var ##xs#1_0_2_3: Seq;
  var ##f#1_0_0: HandleType;
  var ##init#1_0_0: Box;
  var ##xs#1_0_0: Seq;
  var ##f#1_0_1: HandleType;
  var ##init#1_0_1: Box;
  var ##xs#1_0_1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFoldLeftDistributesOverConcat", " | ", Seq._default.LemmaFoldLeftDistributesOverConcat$A, " | ", Seq._default.LemmaFoldLeftDistributesOverConcat$T, " | ", f#0, " | ", init#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Box", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(726,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#f0#0: HandleType, $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#f0#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A)) && $Is($ih#xs0#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && $Is($ih#ys0#0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T)) && LitInt(0) <= Seq#Length(Seq#Append($ih#xs0#0, $ih#ys0#0)) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, $ih#f0#0, init#0, Seq#Append($ih#xs0#0, $ih#ys0#0)) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, $ih#f0#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, $ih#f0#0, init#0, $ih#xs0#0), $ih#ys0#0));
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__FoldLeft();
    call CallPost$$Seq.__default.reveal__FoldLeft();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(727,20)"} true;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume true;
    assume Seq#Equal(Seq#Append(xs#0, ys#0), ys#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(729,26)"} true;
    return;

  anon8_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume true;
    assume Seq#Length(xs#0) >= LitInt(1);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(731,22)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    assume Seq#Index(Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0), LitInt(0)) == Seq#Index(xs#0, LitInt(0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(732,49)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##f#1_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_0 := init#0;
    assume $IsAllocBox(##init#1_0_0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_0 := xs#0;
    assume $IsAlloc(##xs#1_0_0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0);
    ##f#1_0_1 := f#0;
    assume $IsAlloc(##f#1_0_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_1 := Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0);
    assume $IsAllocBox(##init#1_0_1, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_1 := ys#0;
    assume $IsAlloc(##xs#1_0_1, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##f#1_0_2_0 := f#0;
    assume $IsAlloc(##f#1_0_2_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_2_0 := init#0;
    assume $IsAllocBox(##init#1_0_2_0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_2_0 := xs#0;
    assume $IsAlloc(##xs#1_0_2_0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0);
    ##f#1_0_2_1 := f#0;
    assume $IsAlloc(##f#1_0_2_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_2_1 := Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0);
    assume $IsAllocBox(##init#1_0_2_1, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_2_1 := ys#0;
    assume $IsAlloc(##xs#1_0_2_1, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_2_2 := f#0;
    assume $IsAlloc(##f#1_0_2_2, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_2_2 := Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0)));
    assume $IsAllocBox(##init#1_0_2_2, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_2_2 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_2_2, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_2_3 := f#0;
    assume $IsAlloc(##f#1_0_2_3, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_2_3 := Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    assume $IsAllocBox(##init#1_0_2_3, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_2_3 := ys#0;
    assume $IsAlloc(##xs#1_0_2_3, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0);
    assume {:subsumption 0} Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0);
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_0 := f#0;
    assume $IsAlloc(##f#1_0_1_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_1_0 := Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0)));
    assume $IsAllocBox(##init#1_0_1_0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_1_0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_1_0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    ##f#1_0_1_1 := f#0;
    assume $IsAlloc(##f#1_0_1_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_1_1 := Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)));
    assume $IsAllocBox(##init#1_0_1_1, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_1_1 := ys#0;
    assume $IsAlloc(##xs#1_0_1_1, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))) && Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0);
    assume true;
    f##1_0_1_0 := f#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    init##1_0_1_0 := Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    xs##1_0_1_0 := Seq#Drop(xs#0, LitInt(1));
    assume true;
    ys##1_0_1_0 := ys#0;
    assume Seq#Rank(xs##1_0_1_0) < Seq#Rank(xs#0) || (Seq#Rank(xs##1_0_1_0) == Seq#Rank(xs#0) && Seq#Rank(ys##1_0_1_0) < Seq#Rank(ys#0));
    call CallPre$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f##1_0_1_0, init##1_0_1_0, xs##1_0_1_0, ys##1_0_1_0);
    call CallPost$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f##1_0_1_0, init##1_0_1_0, xs##1_0_1_0, ys##1_0_1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(736,76)"} true;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_2 := f#0;
    assume $IsAlloc(##f#1_0_1_2, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_1_2 := Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0)));
    assume $IsAllocBox(##init#1_0_1_2, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_1_2 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_1_2, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), ys#0) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_0_0 := Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0)));
    assume $IsAllocBox(##init#1_0_0_0, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_0_0 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_0_0, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    assume Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0)) == Seq#Index(xs#0, LitInt(0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(738,38)"} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(739,47)"} true;
    ##f#1_0_0_1 := f#0;
    assume $IsAlloc(##f#1_0_0_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A), $Heap);
    ##init#1_0_0_1 := init#0;
    assume $IsAllocBox(##init#1_0_0_1, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap);
    ##xs#1_0_0_1 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_0_1, TSeq(Seq._default.LemmaFoldLeftDistributesOverConcat$T), $Heap);
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, Seq#Append(xs#0, ys#0));
    assume Seq.__default.FoldLeft#canCall(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, Seq._default.LemmaFoldLeftDistributesOverConcat$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0)) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, init#0, Seq#Append(xs#0, ys#0));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, xs#0), ys#0) == Seq.__default.FoldLeft(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldLeft, f#0, init#0, Seq#Append(xs#0, ys#0));
    return;
}



function Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, inv#0: HandleType, stp#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#0: Box, xs#0: Seq, b#0: Box, b'#0: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#0, x#0, b'#0)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#0) } $IsBox(x#0, Seq._default.InvFoldLeft$A) && $Is(xs#0, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#0, Seq._default.InvFoldLeft$B) && $IsBox(b'#0, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#0)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#0, x#0, b'#0)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#0, $Box(xs#0))): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#1: Box, xs#1: Seq, b#1: Box, b'#1: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#1, x#1, b'#1)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#1) } $IsBox(x#1, Seq._default.InvFoldLeft$A) && $Is(xs#1, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#1, Seq._default.InvFoldLeft$B) && $IsBox(b'#1, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#1, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#1)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#1, x#1, b'#1)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#1, $Box(xs#1))): bool)));
}

function Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, inv#0: HandleType, stp#0: HandleType) : bool;

function Seq.__default.InvFoldLeft#requires(Ty, Ty, HandleType, HandleType) : bool;

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft#requires(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool)) ==> (Seq.__default.InvFoldLeft#requires(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> true));

procedure {:verboseName "Seq.InvFoldLeft (well-formedness)"} CheckWellformed$$Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A: Ty where $AlwaysAllocated(Seq._default.InvFoldLeft$A), Seq._default.InvFoldLeft$B: Ty where $AlwaysAllocated(Seq._default.InvFoldLeft$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaInvFoldLeft (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$A), Seq._default.LemmaInvFoldLeft$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldLeft$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldLeft$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaInvFoldLeft (call precondtion)"} CallPre$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$A), Seq._default.LemmaInvFoldLeft$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldLeft$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldLeft$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A), $Heap));
  requires {:id "id6894"} Seq.__default.InvFoldLeft#canCall(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv#0, stp#0) ==> Seq.__default.InvFoldLeft(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv#0, stp#0) || (forall x#0: Box, xs#1: Seq, b#3: Box, b'#0: Box :: { $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $Heap, stp#0, b#3, x#0, b'#0)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#1) } $IsBox(x#0, Seq._default.LemmaInvFoldLeft$A) && $Is(xs#1, TSeq(Seq._default.LemmaInvFoldLeft$A)) && $IsBox(b#3, Seq._default.LemmaInvFoldLeft$B) && $IsBox(b'#0, Seq._default.LemmaInvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, b#3, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#1)))): bool && $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $Heap, stp#0, b#3, x#0, b'#0)): bool ==> $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, b'#0, $Box(xs#1))): bool);
  requires {:id "id6895"} (forall b#2: Box, a#1: Box :: { Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $Heap, f#0, b#2, a#1) } $IsBox(b#2, Seq._default.LemmaInvFoldLeft$B) && $IsBox(a#1, Seq._default.LemmaInvFoldLeft$A) ==> $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $Heap, stp#0, b#2, a#1, Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $Heap, f#0, b#2, a#1))): bool);
  requires {:id "id6896"} $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, b#0, $Box(xs#0))): bool;



procedure {:verboseName "Seq.LemmaInvFoldLeft (call postcondition)"} CallPost$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$A), Seq._default.LemmaInvFoldLeft$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldLeft$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldLeft$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A), $Heap));
  modifies $Heap;
  free ensures Seq.__default.FoldLeft#canCall(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, f#0, b#0, xs#0);
  free ensures {:id "id6897"} $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, Seq.__default.FoldLeft(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, b#0, xs#0), $Box(Lit(Seq#Empty(): Seq)))): bool;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaInvFoldLeft (correctness)"} Impl$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$A), Seq._default.LemmaInvFoldLeft$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldLeft$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldLeft$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldLeft$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldLeft$A), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id6898"} Seq.__default.InvFoldLeft#canCall(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv#0, stp#0) && Seq.__default.InvFoldLeft(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv#0, stp#0) && (forall x#1: Box, xs#2: Seq, b#4: Box, b'#1: Box :: { $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $Heap, stp#0, b#4, x#1, b'#1)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#2) } $IsBox(x#1, Seq._default.LemmaInvFoldLeft$A) && $Is(xs#2, TSeq(Seq._default.LemmaInvFoldLeft$A)) && $IsBox(b#4, Seq._default.LemmaInvFoldLeft$B) && $IsBox(b'#1, Seq._default.LemmaInvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, b#4, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#2)))): bool && $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $Heap, stp#0, b#4, x#1, b'#1)): bool ==> $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, b'#1, $Box(xs#2))): bool);
  requires {:id "id6899"} (forall b#2: Box, a#1: Box :: { Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $Heap, f#0, b#2, a#1) } $IsBox(b#2, Seq._default.LemmaInvFoldLeft$B) && $IsBox(a#1, Seq._default.LemmaInvFoldLeft$A) ==> $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $Heap, stp#0, b#2, a#1, Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $Heap, f#0, b#2, a#1))): bool);
  requires {:id "id6900"} $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, b#0, $Box(xs#0))): bool;
  modifies $Heap;
  free ensures Seq.__default.FoldLeft#canCall(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, f#0, b#0, xs#0);
  free ensures {:id "id6901"} $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, Seq.__default.FoldLeft(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, $LS($LS($LZ)), reveal_Seq._default.FoldLeft, f#0, b#0, xs#0), $Box(Lit(Seq#Empty(): Seq)))): bool;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaInvFoldLeft (correctness)"} Impl$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A: Ty, Seq._default.LemmaInvFoldLeft$B: Ty, inv#0: HandleType, stp#0: HandleType, f#0: HandleType, b#0: Box, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var inv##1_0: HandleType;
  var stp##1_0: HandleType;
  var f##1_0: HandleType;
  var b##1_0: Box;
  var xs##1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaInvFoldLeft", " | ", Seq._default.LemmaInvFoldLeft$A, " | ", Seq._default.LemmaInvFoldLeft$B, " | ", inv#0, " | ", stp#0, " | ", f#0, " | ", b#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "HandleType", " | ", "HandleType", " | ", "Box", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(764,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#f0#0: HandleType, $ih#xs0#0: Seq :: $Is($ih#f0#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B)) && $Is($ih#xs0#0, TSeq(Seq._default.LemmaInvFoldLeft$A)) && Seq.__default.InvFoldLeft(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv#0, stp#0) && (forall b#5: Box, a#2: Box :: { Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $initHeapForallStmt#0, $ih#f0#0, b#5, a#2) } $IsBox(b#5, Seq._default.LemmaInvFoldLeft$B) && $IsBox(a#2, Seq._default.LemmaInvFoldLeft$A) ==> $Unbox(Apply3(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, TBool, $initHeapForallStmt#0, stp#0, b#5, a#2, Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $initHeapForallStmt#0, $ih#f0#0, b#5, a#2))): bool) && $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $initHeapForallStmt#0, inv#0, b#0, $Box($ih#xs0#0))): bool && Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) ==> $Unbox(Apply2(Seq._default.LemmaInvFoldLeft$B, TSeq(Seq._default.LemmaInvFoldLeft$A), TBool, $Heap, inv#0, Seq.__default.FoldLeft(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, $LS($LZ), reveal_Seq._default.FoldLeft, $ih#f0#0, b#0, $ih#xs0#0), $Box(Lit(Seq#Empty(): Seq)))): bool);
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__FoldLeft();
    call CallPost$$Seq.__default.reveal__FoldLeft();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(765,20)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Equal(xs#0, Seq#Empty(): Seq);
    return;

  anon3_Else:
    assume {:partition} !Seq#Equal(xs#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), xs#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(768,36)"} true;
    assume true;
    inv##1_0 := inv#0;
    assume true;
    stp##1_0 := stp#0;
    assume true;
    f##1_0 := f#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    b##1_0 := Apply2(Seq._default.LemmaInvFoldLeft$B, Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, $Heap, f#0, b#0, Seq#Index(xs#0, LitInt(0)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    xs##1_0 := Seq#Drop(xs#0, LitInt(1));
    assume Seq#Rank(xs##1_0) < Seq#Rank(xs#0);
    call CallPre$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv##1_0, stp##1_0, f##1_0, b##1_0, xs##1_0);
    call CallPost$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv##1_0, stp##1_0, f##1_0, b##1_0, xs##1_0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(769,57)"} true;
    return;
}



function Seq.__default.FoldRight(Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, xs#0, init#0) || (0 < $FunctionContextHeight && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> $IsBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0), Seq._default.FoldRight$A));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box :: { $IsAllocBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0), Seq._default.FoldRight$A, $Heap) } (Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, xs#0, init#0) || (0 < $FunctionContextHeight && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A), $Heap) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FoldRight$T), $Heap) && $IsBox(init#0, Seq._default.FoldRight$A) && $IsAllocBox(init#0, Seq._default.FoldRight$A, $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0), Seq._default.FoldRight$A, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, xs#0, init#0), $IsGoodHeap($Heap) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, xs#0, init#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Seq#Drop(xs#0, LitInt(1)), init#0)) && Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, xs#0, init#0) == (if Seq#Length(xs#0) == LitInt(0) then init#0 else Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, reveal_Seq._default.FoldRight, f#0, Seq#Drop(xs#0, LitInt(1)), init#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: {:weight 3} { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, Lit(xs#0), init#0), $IsGoodHeap($Heap) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Lit(xs#0), init#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), init#0)) && Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, Lit(xs#0), init#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, f#0, Seq#Index(Lit(xs#0), LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), reveal_Seq._default.FoldRight, f#0, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), init#0))));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: {:weight 3} { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, Lit(f#0), Lit(xs#0), Lit(init#0)), $IsGoodHeap($Heap) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, Lit(f#0), Lit(xs#0), Lit(init#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, Lit(f#0), Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(init#0))) && Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, Lit(f#0), Lit(xs#0), Lit(init#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, Lit(f#0), Seq#Index(Lit(xs#0), LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), reveal_Seq._default.FoldRight, Lit(f#0), Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(init#0)))));
}

function Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, f#0: HandleType, xs#0: Seq, init#0: Box) : bool;

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), $reveal, f#0, xs#0, init#0) } Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), $reveal, f#0, xs#0, init#0) == Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0));

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, AsFuelBottom($ly), $reveal, f#0, xs#0, init#0) } Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0) == Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LZ, $reveal, f#0, xs#0, init#0));

function Seq.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Seq, Box) : bool;

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight#requires(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, f#0, xs#0, init#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A) ==> (Seq.__default.FoldRight#requires(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, f#0, xs#0, init#0) <==> true));

procedure {:verboseName "Seq.FoldRight (well-formedness)"} CheckWellformed$$Seq.__default.FoldRight(Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FoldRight$T)), init#0: Box where $IsBox(init#0, Seq._default.FoldRight$A));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.FoldRight (well-formedness)"} CheckWellformed$$Seq.__default.FoldRight(Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, f#0: HandleType, xs#0: Seq, init#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##init#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.FoldRight", " | ", Seq._default.FoldRight$A, " | ", Seq._default.FoldRight$T, " | ", f#0, " | ", xs#0, " | ", init#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(775,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $IsBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, xs#0, init#0), Seq._default.FoldRight$A);
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, xs#0, init#0) == init#0;
    assume true;
    assume $IsBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, xs#0, init#0), Seq._default.FoldRight$A);
    return;

  anon7_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A), $Heap);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(Seq._default.FoldRight$T), $Heap);
    ##init#0 := init#0;
    assume $IsAllocBox(##init#0, Seq._default.FoldRight$A, $Heap);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Seq#Drop(xs#0, LitInt(1)), init#0);
    assume Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, xs#0, init#0) == Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, Seq#Drop(xs#0, LitInt(1)), init#0));
    assume Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Seq#Drop(xs#0, LitInt(1)), init#0);
    assume $IsBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, xs#0, init#0), Seq._default.FoldRight$A);
    return;
}



procedure {:verboseName "Seq.LemmaFoldRightDistributesOverConcat (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A: Ty, Seq._default.LemmaFoldRightDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaFoldRightDistributesOverConcat (call precondtion)"} CallPre$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A: Ty, Seq._default.LemmaFoldRightDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap));
  requires {:id "id6919"} LitInt(0) <= Seq#Length(Seq#Append(xs#0, ys#0));



procedure {:verboseName "Seq.LemmaFoldRightDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A: Ty, Seq._default.LemmaFoldRightDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap));
  modifies $Heap;
  free ensures Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(xs#0, ys#0), init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
  free ensures {:id "id6920"} Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Append(xs#0, ys#0), init#0) == Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaFoldRightDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A: Ty, Seq._default.LemmaFoldRightDistributesOverConcat$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap), init#0: Box where $IsBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A) && $IsAllocBox(init#0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap), ys#0: Seq where $Is(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $IsAlloc(ys#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id6921"} LitInt(0) <= Seq#Length(Seq#Append(xs#0, ys#0));
  modifies $Heap;
  free ensures Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(xs#0, ys#0), init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
  free ensures {:id "id6922"} Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Append(xs#0, ys#0), init#0) == Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaFoldRightDistributesOverConcat (correctness)"} Impl$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A: Ty, Seq._default.LemmaFoldRightDistributesOverConcat$T: Ty, f#0: HandleType, init#0: Box, xs#0: Seq, ys#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##f#1_0_0_0: HandleType;
  var ##xs#1_0_0_0: Seq;
  var ##init#1_0_0_0: Box;
  var ##f#1_0_0_1: HandleType;
  var ##xs#1_0_0_1: Seq;
  var ##init#1_0_0_1: Box;
  var ##f#1_0_1_0: HandleType;
  var ##xs#1_0_1_0: Seq;
  var ##init#1_0_1_0: Box;
  var ##f#1_0_1_1: HandleType;
  var ##xs#1_0_1_1: Seq;
  var ##init#1_0_1_1: Box;
  var ##f#1_0_1_2: HandleType;
  var ##xs#1_0_1_2: Seq;
  var ##init#1_0_1_2: Box;
  var ##f#1_0_2_0: HandleType;
  var ##xs#1_0_2_0: Seq;
  var ##init#1_0_2_0: Box;
  var ##f#1_0_2_1: HandleType;
  var ##xs#1_0_2_1: Seq;
  var ##init#1_0_2_1: Box;
  var ##f#1_0_2_2: HandleType;
  var ##xs#1_0_2_2: Seq;
  var ##init#1_0_2_2: Box;
  var ##f#1_0_2_3: HandleType;
  var ##xs#1_0_2_3: Seq;
  var ##init#1_0_2_3: Box;
  var ##f#1_0_0: HandleType;
  var ##xs#1_0_0: Seq;
  var ##init#1_0_0: Box;
  var ##f#1_0_1: HandleType;
  var ##xs#1_0_1: Seq;
  var ##init#1_0_1: Box;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaFoldRightDistributesOverConcat", " | ", Seq._default.LemmaFoldRightDistributesOverConcat$A, " | ", Seq._default.LemmaFoldRightDistributesOverConcat$T, " | ", f#0, " | ", init#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Box", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(787,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#f0#0: HandleType, $ih#xs0#0: Seq, $ih#ys0#0: Seq :: $Is($ih#f0#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A)) && $Is($ih#xs0#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && $Is($ih#ys0#0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T)) && LitInt(0) <= Seq#Length(Seq#Append($ih#xs0#0, $ih#ys0#0)) && (Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) || (Seq#Rank($ih#xs0#0) == Seq#Rank(xs#0) && Seq#Rank($ih#ys0#0) < Seq#Rank(ys#0))) ==> Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, $ih#f0#0, Seq#Append($ih#xs0#0, $ih#ys0#0), init#0) == Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, $ih#f0#0, $ih#xs0#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, $ih#f0#0, $ih#ys0#0, init#0)));
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__FoldRight();
    call CallPost$$Seq.__default.reveal__FoldRight();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(788,21)"} true;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume true;
    assume Seq#Equal(Seq#Append(xs#0, ys#0), ys#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(790,26)"} true;
    return;

  anon8_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##f#1_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_0 := ys#0;
    assume $IsAlloc(##xs#1_0_0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_0 := init#0;
    assume $IsAllocBox(##init#1_0_0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0);
    ##f#1_0_1 := f#0;
    assume $IsAlloc(##f#1_0_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_1 := xs#0;
    assume $IsAlloc(##xs#1_0_1, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_1 := Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0);
    assume $IsAllocBox(##init#1_0_1, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##f#1_0_2_0 := f#0;
    assume $IsAlloc(##f#1_0_2_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_2_0 := ys#0;
    assume $IsAlloc(##xs#1_0_2_0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_2_0 := init#0;
    assume $IsAllocBox(##init#1_0_2_0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0);
    ##f#1_0_2_1 := f#0;
    assume $IsAlloc(##f#1_0_2_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_2_1 := xs#0;
    assume $IsAlloc(##xs#1_0_2_1, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_2_1 := Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0);
    assume $IsAllocBox(##init#1_0_2_1, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_2_2 := f#0;
    assume $IsAlloc(##f#1_0_2_2, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_2_2 := ys#0;
    assume $IsAlloc(##xs#1_0_2_2, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_2_2 := init#0;
    assume $IsAllocBox(##init#1_0_2_2, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0);
    ##f#1_0_2_3 := f#0;
    assume $IsAlloc(##f#1_0_2_3, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_2_3 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_2_3, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_2_3 := Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0);
    assume $IsAllocBox(##init#1_0_2_3, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Drop(xs#0, LitInt(1)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Drop(xs#0, LitInt(1)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume {:subsumption 0} Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, ys#0, init#0)) == Apply2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Drop(xs#0, LitInt(1)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, ys#0, init#0)));
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_0 := f#0;
    assume $IsAlloc(##f#1_0_1_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_1_0 := ys#0;
    assume $IsAlloc(##xs#1_0_1_0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_1_0 := init#0;
    assume $IsAllocBox(##init#1_0_1_0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0);
    ##f#1_0_1_1 := f#0;
    assume $IsAlloc(##f#1_0_1_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_1_1 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#1_0_1_1, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_1_1 := Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0);
    assume $IsAllocBox(##init#1_0_1_1, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Drop(xs#0, LitInt(1)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, ys#0, init#0) && Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Drop(xs#0, LitInt(1)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_1_2 := f#0;
    assume $IsAlloc(##f#1_0_1_2, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_1_2 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_1_2, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_1_2 := init#0;
    assume $IsAllocBox(##init#1_0_1_2, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), init#0);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), init#0);
    assume {:subsumption 0} Apply2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Drop(xs#0, LitInt(1)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, ys#0, init#0))) == Apply2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), init#0));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#1_0_0_0 := f#0;
    assume $IsAlloc(##f#1_0_0_0, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_0_0 := Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0);
    assume $IsAlloc(##xs#1_0_0_0, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_0_0 := init#0;
    assume $IsAllocBox(##init#1_0_0_0, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), init#0);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), init#0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume true;
    assume Seq#Index(Seq#Append(xs#0, ys#0), LitInt(0)) == Seq#Index(xs#0, LitInt(0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(796,38)"} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(Seq#Append(xs#0, ys#0));
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#Append(xs#0, ys#0), LitInt(1)), Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0));
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(797,46)"} true;
    ##f#1_0_0_1 := f#0;
    assume $IsAlloc(##f#1_0_0_1, Tclass._System.___hTotalFunc2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A), $Heap);
    ##xs#1_0_0_1 := Seq#Append(xs#0, ys#0);
    assume $IsAlloc(##xs#1_0_0_1, TSeq(Seq._default.LemmaFoldRightDistributesOverConcat$T), $Heap);
    ##init#1_0_0_1 := init#0;
    assume $IsAllocBox(##init#1_0_0_1, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(xs#0, ys#0), init#0);
    assume Seq.__default.FoldRight#canCall(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, Seq#Append(xs#0, ys#0), init#0);
    assume {:subsumption 0} Apply2(Seq._default.LemmaFoldRightDistributesOverConcat$T, Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Append(Seq#Drop(xs#0, LitInt(1)), ys#0), init#0)) == Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, Seq#Append(xs#0, ys#0), init#0);
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, xs#0, Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, ys#0, init#0)) == Seq.__default.FoldRight(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, $LS($LZ), reveal_Seq._default.FoldRight, f#0, Seq#Append(xs#0, ys#0), init#0);
    return;
}



function Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, inv#0: HandleType, stp#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#0: Box, xs#0: Seq, b#0: Box, b'#0: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#0), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#0, b#0, b'#0)): bool } $IsBox(x#0, Seq._default.InvFoldRight$A) && $Is(xs#0, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#0, Seq._default.InvFoldRight$B) && $IsBox(b'#0, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#0), b#0)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#0, b#0, b'#0)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#0)), b'#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#1: Box, xs#1: Seq, b#1: Box, b'#1: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#1), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#1, b#1, b'#1)): bool } $IsBox(x#1, Seq._default.InvFoldRight$A) && $Is(xs#1, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#1, Seq._default.InvFoldRight$B) && $IsBox(b'#1, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#1), b#1)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#1, b#1, b'#1)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#1)), b'#1)): bool)));
}

function Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, inv#0: HandleType, stp#0: HandleType) : bool;

function Seq.__default.InvFoldRight#requires(Ty, Ty, HandleType, HandleType) : bool;

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight#requires(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool)) ==> (Seq.__default.InvFoldRight#requires(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> true));

procedure {:verboseName "Seq.InvFoldRight (well-formedness)"} CheckWellformed$$Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A: Ty where $AlwaysAllocated(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B: Ty where $AlwaysAllocated(Seq._default.InvFoldRight$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaInvFoldRight (well-formedness)"} CheckWellFormed$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldRight$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldRight$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.LemmaInvFoldRight (call precondtion)"} CallPre$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldRight$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldRight$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A), $Heap));
  requires {:id "id6950"} Seq.__default.InvFoldRight#canCall(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, inv#0, stp#0) ==> Seq.__default.InvFoldRight(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, inv#0, stp#0) || (forall x#0: Box, xs#1: Seq, b#3: Box, b'#0: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#1), $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $Heap, stp#0, x#0, b#3, b'#0)): bool } $IsBox(x#0, Seq._default.LemmaInvFoldRight$A) && $Is(xs#1, TSeq(Seq._default.LemmaInvFoldRight$A)) && $IsBox(b#3, Seq._default.LemmaInvFoldRight$B) && $IsBox(b'#0, Seq._default.LemmaInvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#1), b#3)): bool && $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $Heap, stp#0, x#0, b#3, b'#0)): bool ==> $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#0), xs#1)), b'#0)): bool);
  requires {:id "id6951"} (forall a#1: Box, b#2: Box :: { Apply2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, $Heap, f#0, a#1, b#2) } $IsBox(a#1, Seq._default.LemmaInvFoldRight$A) && $IsBox(b#2, Seq._default.LemmaInvFoldRight$B) ==> $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $Heap, stp#0, a#1, b#2, Apply2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, $Heap, f#0, a#1, b#2))): bool);
  requires {:id "id6952"} $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(Lit(Seq#Empty(): Seq)), b#0)): bool;



procedure {:verboseName "Seq.LemmaInvFoldRight (call postcondition)"} CallPost$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldRight$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldRight$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A), $Heap));
  modifies $Heap;
  free ensures Seq.__default.FoldRight#canCall(Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$A, f#0, xs#0, b#0);
  free ensures {:id "id6953"} $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#0), Seq.__default.FoldRight(Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$A, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, xs#0, b#0))): bool;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Seq.LemmaInvFoldRight (correctness)"} Impl$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B: Ty where $AlwaysAllocated(Seq._default.LemmaInvFoldRight$B), inv#0: HandleType where $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool), $Heap), stp#0: HandleType where $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool)) && $IsAlloc(stp#0, Tclass._System.___hTotalFunc3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool), $Heap), f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B), $Heap), b#0: Box where $IsBox(b#0, Seq._default.LemmaInvFoldRight$B) && $IsAllocBox(b#0, Seq._default.LemmaInvFoldRight$B, $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A)) && $IsAlloc(xs#0, TSeq(Seq._default.LemmaInvFoldRight$A), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id6954"} Seq.__default.InvFoldRight#canCall(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, inv#0, stp#0) && Seq.__default.InvFoldRight(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, inv#0, stp#0) && (forall x#1: Box, xs#2: Seq, b#4: Box, b'#1: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#2), $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $Heap, stp#0, x#1, b#4, b'#1)): bool } $IsBox(x#1, Seq._default.LemmaInvFoldRight$A) && $Is(xs#2, TSeq(Seq._default.LemmaInvFoldRight$A)) && $IsBox(b#4, Seq._default.LemmaInvFoldRight$B) && $IsBox(b'#1, Seq._default.LemmaInvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#2), b#4)): bool && $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $Heap, stp#0, x#1, b#4, b'#1)): bool ==> $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#1), xs#2)), b'#1)): bool);
  requires {:id "id6955"} (forall a#1: Box, b#2: Box :: { Apply2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, $Heap, f#0, a#1, b#2) } $IsBox(a#1, Seq._default.LemmaInvFoldRight$A) && $IsBox(b#2, Seq._default.LemmaInvFoldRight$B) ==> $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $Heap, stp#0, a#1, b#2, Apply2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, $Heap, f#0, a#1, b#2))): bool);
  requires {:id "id6956"} $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(Lit(Seq#Empty(): Seq)), b#0)): bool;
  modifies $Heap;
  free ensures Seq.__default.FoldRight#canCall(Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$A, f#0, xs#0, b#0);
  free ensures {:id "id6957"} $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#0), Seq.__default.FoldRight(Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$A, $LS($LS($LZ)), reveal_Seq._default.FoldRight, f#0, xs#0, b#0))): bool;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.LemmaInvFoldRight (correctness)"} Impl$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A: Ty, Seq._default.LemmaInvFoldRight$B: Ty, inv#0: HandleType, stp#0: HandleType, f#0: HandleType, b#0: Box, xs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Seq.LemmaInvFoldRight", " | ", Seq._default.LemmaInvFoldRight$A, " | ", Seq._default.LemmaInvFoldRight$B, " | ", inv#0, " | ", stp#0, " | ", f#0, " | ", b#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "HandleType", " | ", "HandleType", " | ", "Box", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(822,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#f0#0: HandleType, $ih#xs0#0: Seq :: $Is($ih#f0#0, Tclass._System.___hTotalFunc2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B)) && $Is($ih#xs0#0, TSeq(Seq._default.LemmaInvFoldRight$A)) && Seq.__default.InvFoldRight(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, inv#0, stp#0) && (forall a#2: Box, b#5: Box :: { Apply2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, $initHeapForallStmt#0, $ih#f0#0, a#2, b#5) } $IsBox(a#2, Seq._default.LemmaInvFoldRight$A) && $IsBox(b#5, Seq._default.LemmaInvFoldRight$B) ==> $Unbox(Apply3(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, TBool, $initHeapForallStmt#0, stp#0, a#2, b#5, Apply2(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$B, $initHeapForallStmt#0, $ih#f0#0, a#2, b#5))): bool) && $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $initHeapForallStmt#0, inv#0, $Box(Lit(Seq#Empty(): Seq)), b#0)): bool && Seq#Rank($ih#xs0#0) < Seq#Rank(xs#0) ==> $Unbox(Apply2(TSeq(Seq._default.LemmaInvFoldRight$A), Seq._default.LemmaInvFoldRight$B, TBool, $Heap, inv#0, $Box($ih#xs0#0), Seq.__default.FoldRight(Seq._default.LemmaInvFoldRight$B, Seq._default.LemmaInvFoldRight$A, $LS($LZ), reveal_Seq._default.FoldRight, $ih#f0#0, $ih#xs0#0, b#0))): bool);
    $_reverifyPost := false;
    call CallPre$$Seq.__default.reveal__FoldRight();
    call CallPost$$Seq.__default.reveal__FoldRight();
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(823,21)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Equal(xs#0, Seq#Empty(): Seq);
    return;

  anon3_Else:
    assume {:partition} !Seq#Equal(xs#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1))), xs#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(826,36)"} true;
    return;
}



function Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $heap: Heap, f#0: HandleType, xs#0: Seq) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $Is(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R)));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R), $Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#2: int :: { Seq#Index(xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#2)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));
}

function Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $heap: Heap, f#0: HandleType, xs#0: Seq) : bool;

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $h0: Heap, $h1: Heap, f#0: HandleType, xs#0: Seq :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $h1, f#0, xs#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && (Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $h0, f#0, xs#0) || ($Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && (exists i#0: int, o#0: ref :: { Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $h0, f#0, xs#0) == Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $h1, f#0, xs#0));

function Seq.__default.FlatMap#requires(Ty, Ty, Heap, HandleType, Seq) : bool;

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#2: int :: { Seq#Index(xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#2)))));

procedure {:verboseName "Seq.FlatMap (well-formedness)"} CheckWellformed$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FlatMap$T))) returns (result#0: Seq where $Is(result#0, TSeq(Seq._default.FlatMap$R)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.FlatMap (well-formedness)"} CheckWellformed$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var i#4: int;
  var o#1: ref;
  var ##x0#1: Box;
  var b$reqreads#1: bool;
  var i#5: int;
  var o#2: ref;
  var ##x0#2: Box;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var b$reqreads#2: bool;

  anon0:
    assume {:print "Impl", " | ", "Seq.FlatMap", " | ", Seq._default.FlatMap$T, " | ", Seq._default.FlatMap$R, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(831,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (exists i#0: int, o#0: ref :: { Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)));
    havoc i#3;
    assume true;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon4;

  anon24_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    assume 0 <= i#3 && i#3 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#3);
    assume $IsAllocBox(##x0#0, Seq._default.FlatMap$T, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#3));
    assume Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#3));
    goto anon6;

  anon23_Else:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#3));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)));
    assume b$reqreads#0;
    havoc i#4;
    havoc o#1;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} $Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon9;

  anon26_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon9;

  anon9:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    assume 0 <= i#4 && i#4 < Seq#Length(xs#0);
    ##x0#1 := Seq#Index(xs#0, i#4);
    assume $IsAllocBox(##x0#1, Seq._default.FlatMap$T, $Heap);
    assume Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#4));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#4))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Reads1#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#4));
    goto anon11;

  anon27_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#4))[$Box(o#1)];
    goto anon13;

  anon28_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#4))[$Box(o#1)]);
    goto anon13;

  anon25_Else:
    assume {:partition} !($Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap));
    goto anon13;

  anon13:
    assume b$reqreads#1;
    havoc i#5;
    havoc o#2;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} $Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap);
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} LitInt(0) <= i#5;
    goto anon16;

  anon30_Else:
    assume {:partition} i#5 < LitInt(0);
    goto anon16;

  anon16:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    assume 0 <= i#5 && i#5 < Seq#Length(xs#0);
    ##x0#2 := Seq#Index(xs#0, i#5);
    assume $IsAllocBox(##x0#2, Seq._default.FlatMap$T, $Heap);
    assume Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#5));
    assume Reads1#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon18;

  anon31_Else:
    assume {:partition} !(LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0));
    goto anon18;

  anon18:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#5))[$Box(o#2)];
    goto anon20;

  anon32_Else:
    assume {:partition} !(LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#5))[$Box(o#2)]);
    goto anon20;

  anon29_Else:
    assume {:partition} !($Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap));
    goto anon20;

  anon20:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume $Is(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R));
    assume false;
    return;

  anon33_Else:
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.FlatMap$T), $Heap);
    assume {:subsumption 0} (forall i#6: int :: { Seq#Index(##xs#0, i#6) } LitInt(0) <= i#6 && i#6 < Seq#Length(##xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#0, Seq#Index(##xs#0, i#6)));
    assume (forall i#6: int :: { Seq#Index(##xs#0, i#6) } LitInt(0) <= i#6 && i#6 < Seq#Length(##xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#0, Seq#Index(##xs#0, i#6)));
    b$reqreads#2 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#7: int, o#3: ref :: { Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#0, Seq#Index(##xs#0, i#7))[$Box(o#3)] } $Is(o#3, Tclass._System.object?()) && LitInt(0) <= i#7 && i#7 < Seq#Length(##xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#0, Seq#Index(##xs#0, i#7))[$Box(o#3)] && $Box($o) == $Box(o#3)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0);
    ##xs#1 := Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0);
    assume $IsAlloc(##xs#1, TSeq(TSeq(Seq._default.FlatMap$R)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0));
    assume Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0));
    assume Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0));
    assume $Is(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R));
    assume Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == result#0;
    assume b$reqreads#2;
    return;
}



procedure {:verboseName "Seq.FlatMap (correctness)"} Impl$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap)) returns (defass#result#0: bool, result#0: Seq where defass#result#0 ==> $Is(result#0, TSeq(Seq._default.FlatMap$R)) && $IsAlloc(result#0, TSeq(Seq._default.FlatMap$R), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id6978"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)));
  modifies $Heap;
  free ensures Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0);
  free ensures {:id "id6979"} Seq#Equal(result#0, Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.FlatMap (correctness)"} Impl$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType, xs#0: Seq) returns (defass#result#0: bool, result#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var unflattened#0: Seq where $Is(unflattened#0, TSeq(TSeq(Seq._default.FlatMap$R))) && $IsAlloc(unflattened#0, TSeq(TSeq(Seq._default.FlatMap$R)), $Heap);
  var i#8: int;
  var i#8#lo: int;
  var i#8#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#result#0: bool;
  var $w$loop#0: bool;
  var ##f#1: HandleType;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var next#0: Seq where $Is(next#0, TSeq(Seq._default.FlatMap$R)) && $IsAlloc(next#0, TSeq(Seq._default.FlatMap$R), $Heap);

  anon0:
    assume {:print "Impl", " | ", "Seq.FlatMap", " | ", Seq._default.FlatMap$T, " | ", Seq._default.FlatMap$R, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(837,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    result#0 := Lit(Seq#Empty(): Seq);
    defass#result#0 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(838,16)"} true;
    assume true;
    assume true;
    unflattened#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(839,44)"} true;
    i#8#lo := LitInt(0);
    i#8#hi := Seq#Length(xs#0);
    assume i#8#lo <= i#8#hi;
    i#8 := i#8#hi;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#result#0 := defass#result#0;
    havoc $w$loop#0;
    goto anon7_LoopHead;

  anon7_LoopHead:
    assume i#8#lo <= i#8 && i#8 <= i#8#hi;
    assume $w$loop#0 ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Drop(xs#0, i#8));
    assume $w$loop#0 ==> Seq#Equal(unflattened#0, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, Seq#Drop(xs#0, i#8)));
    assume $w$loop#0 ==> Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, unflattened#0);
    assume $w$loop#0 ==> Seq#Equal(result#0, Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LS($LZ)), unflattened#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#result#0 ==> defass#result#0;
    assume true;
    goto anon7_LoopDone, anon7_LoopBody;

  anon7_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(840,4): after some loop iterations"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#8 && i#8 <= Seq#Length(xs#0);
    ##f#1 := f#0;
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    ##xs#2 := Seq#Drop(xs#0, i#8);
    assume $IsAlloc(##xs#2, TSeq(Seq._default.FlatMap$T), $Heap);
    assume {:subsumption 0} (forall i#9: int :: { Seq#Index(##xs#2, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#2) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#1, Seq#Index(##xs#2, i#9)));
    assume Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Drop(xs#0, i#8));
    assume Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Drop(xs#0, i#8));
    assume Seq#Equal(unflattened#0, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, Seq#Drop(xs#0, i#8)));
    assume defass#result#0;
    ##xs#3 := unflattened#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(Seq._default.FlatMap$R)), $Heap);
    assume Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, unflattened#0);
    assume Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, unflattened#0);
    assume Seq#Equal(result#0, Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), unflattened#0));
    assume false;
    goto anon3;

  anon8_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} i#8 == i#8#lo;
    goto anon6;

  anon9_Else:
    assume {:partition} i#8 != i#8#lo;
    i#8 := i#8 - 1;
    assume true;
    assume 0 <= i#8 && i#8 < Seq#Length(xs#0);
    assume Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#8));
    assume true;
    next#0 := $Unbox(Apply1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#8))): Seq;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(844,26)"} true;
    assume true;
    assume true;
    unflattened#0 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(next#0)), unflattened#0);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(845,41)"} true;
    assume true;
    assume defass#result#0;
    assume true;
    result#0 := Seq#Append(next#0, result#0);
    defass#result#0 := true;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(846,29)"} true;
    assume Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Drop(xs#0, i#8)) && (Seq#Equal(unflattened#0, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, Seq#Drop(xs#0, i#8))) ==> Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, unflattened#0));
    goto anon7_LoopHead;

  anon7_LoopDone:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume defass#result#0;
    assume Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0);
    return;
}



procedure {:verboseName "Seq.reveal_ToSet (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__ToSet();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_ToSet (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__ToSet();



procedure {:verboseName "Seq.reveal_ToSet (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__ToSet();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.ToSet;



procedure {:verboseName "Seq.reveal_HasNoDuplicates (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__HasNoDuplicates();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_HasNoDuplicates (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__HasNoDuplicates();



procedure {:verboseName "Seq.reveal_HasNoDuplicates (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__HasNoDuplicates();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.HasNoDuplicates;



procedure {:verboseName "Seq.reveal_IndexOf (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__IndexOf();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_IndexOf (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__IndexOf();



procedure {:verboseName "Seq.reveal_IndexOf (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__IndexOf();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.IndexOf;



procedure {:verboseName "Seq.reveal_IndexOfOption (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__IndexOfOption();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_IndexOfOption (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__IndexOfOption();



procedure {:verboseName "Seq.reveal_IndexOfOption (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__IndexOfOption();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.IndexOfOption;



procedure {:verboseName "Seq.reveal_LastIndexOf (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__LastIndexOf();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_LastIndexOf (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__LastIndexOf();



procedure {:verboseName "Seq.reveal_LastIndexOf (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__LastIndexOf();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.LastIndexOf;



procedure {:verboseName "Seq.reveal_LastIndexOfOption (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__LastIndexOfOption();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_LastIndexOfOption (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__LastIndexOfOption();



procedure {:verboseName "Seq.reveal_LastIndexOfOption (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__LastIndexOfOption();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.LastIndexOfOption;



procedure {:verboseName "Seq.reveal_Remove (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Remove();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Remove (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Remove();



procedure {:verboseName "Seq.reveal_Remove (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Remove();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Remove;



procedure {:verboseName "Seq.reveal_RemoveValue (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__RemoveValue();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_RemoveValue (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__RemoveValue();



procedure {:verboseName "Seq.reveal_RemoveValue (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__RemoveValue();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.RemoveValue;



procedure {:verboseName "Seq.reveal_Insert (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Insert();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Insert (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Insert();



procedure {:verboseName "Seq.reveal_Insert (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Insert();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Insert;



procedure {:verboseName "Seq.reveal_Reverse (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Reverse();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Reverse (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Reverse();



procedure {:verboseName "Seq.reveal_Reverse (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Reverse();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Reverse;



procedure {:verboseName "Seq.reveal_Repeat (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Repeat();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Repeat (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Repeat();



procedure {:verboseName "Seq.reveal_Repeat (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Repeat();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Repeat;



procedure {:verboseName "Seq.reveal_Unzip (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Unzip();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Unzip (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Unzip();



procedure {:verboseName "Seq.reveal_Unzip (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Unzip();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Unzip;



procedure {:verboseName "Seq.reveal_Zip (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Zip();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Zip (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Zip();



procedure {:verboseName "Seq.reveal_Zip (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Zip();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Zip;



procedure {:verboseName "Seq.reveal_Max (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Max();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Max (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Max();



procedure {:verboseName "Seq.reveal_Max (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Max();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Max;



procedure {:verboseName "Seq.reveal_Min (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Min();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Min (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Min();



procedure {:verboseName "Seq.reveal_Min (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Min();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Min;



procedure {:verboseName "Seq.reveal_Map (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Map();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Map (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Map();



procedure {:verboseName "Seq.reveal_Map (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Map();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Map;



procedure {:verboseName "Seq.reveal_MapWithResult (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__MapWithResult();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_MapWithResult (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__MapWithResult();



procedure {:verboseName "Seq.reveal_MapWithResult (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__MapWithResult();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.MapWithResult;



procedure {:verboseName "Seq.reveal_Filter (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__Filter();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_Filter (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__Filter();



procedure {:verboseName "Seq.reveal_Filter (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__Filter();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.Filter;



procedure {:verboseName "Seq.reveal_FoldLeft (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__FoldLeft();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_FoldLeft (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__FoldLeft();



procedure {:verboseName "Seq.reveal_FoldLeft (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__FoldLeft();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.FoldLeft;



procedure {:verboseName "Seq.reveal_FoldRight (well-formedness)"} {:verify false} CheckWellFormed$$Seq.__default.reveal__FoldRight();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Seq.reveal_FoldRight (call precondtion)"} {:verify false} CallPre$$Seq.__default.reveal__FoldRight();



procedure {:verboseName "Seq.reveal_FoldRight (call postcondition)"} {:verify false} CallPost$$Seq.__default.reveal__FoldRight();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Seq._default.FoldRight;



procedure {:verboseName "Seq.FlatMap (well-formedness)"} CheckWellFormed$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap)) returns (result#0: Seq where $Is(result#0, TSeq(Seq._default.FlatMap$R)) && $IsAlloc(result#0, TSeq(Seq._default.FlatMap$R), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Seq.FlatMap (well-formedness)"} CheckWellFormed$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##x0#0: Box;
  var i#1: int;
  var o#0: ref;
  var ##x0#1: Box;
  var ##f#0: HandleType;
  var ##xs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Seq.FlatMap", " | ", Seq._default.FlatMap$T, " | ", Seq._default.FlatMap$R, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(831,11): initial state"} true;
    havoc i#0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon15_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#0);
    assume $IsAllocBox(##x0#0, Seq._default.FlatMap$T, $Heap);
    assume Requires1#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#0));
    assume Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#0));
    goto anon6;

  anon14_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#0));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)));
    havoc i#1;
    havoc o#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} $Is(o#0, Tclass._System.object?()) && $IsAlloc(o#0, Tclass._System.object?(), $Heap);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= i#1;
    goto anon9;

  anon17_Else:
    assume {:partition} i#1 < LitInt(0);
    goto anon9;

  anon9:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    assume 0 <= i#1 && i#1 < Seq#Length(xs#0);
    ##x0#1 := Seq#Index(xs#0, i#1);
    assume $IsAllocBox(##x0#1, Seq._default.FlatMap$T, $Heap);
    assume Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1));
    assume Reads1#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1));
    goto anon11;

  anon18_Else:
    assume {:partition} !(LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1))[$Box(o#0)];
    goto anon13;

  anon19_Else:
    assume {:partition} !(LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) && Reads1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1))[$Box(o#0)]);
    goto anon13;

  anon16_Else:
    assume {:partition} !($Is(o#0, Tclass._System.object?()) && $IsAlloc(o#0, Tclass._System.object?(), $Heap));
    goto anon13;

  anon13:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc result#0;
    assume {:captureState "libraries/src/Collections/Sequences/Seq.dfy(837,2): post-state"} true;
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap);
    ##xs#0 := xs#0;
    assume $IsAlloc(##xs#0, TSeq(Seq._default.FlatMap$T), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { Seq#Index(##xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#0, Seq#Index(##xs#0, i#2)));
    assume (forall i#2: int :: { Seq#Index(##xs#0, i#2) } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, ##f#0, Seq#Index(##xs#0, i#2)));
    assume Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0);
    assume Seq#Equal(result#0, Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0));
    return;
}



procedure {:verboseName "Seq.FlatMap (call precondtion)"} CallPre$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap));
  requires {:id "id7006"} (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)));



procedure {:verboseName "Seq.FlatMap (call postcondition)"} CallPost$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap), xs#0: Seq where $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap)) returns (result#0: Seq where $Is(result#0, TSeq(Seq._default.FlatMap$R)) && $IsAlloc(result#0, TSeq(Seq._default.FlatMap$R), $Heap));
  modifies $Heap;
  free ensures Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0);
  free ensures {:id "id7007"} Seq#Equal(result#0, Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#48 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#48))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#50 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#50)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#72 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#72))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#74 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#74)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#76 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#76)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#72 := Wrappers.Option.value(this); v#72)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#74 := Lit(Wrappers.Option.value(Lit(this))); v#74)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#76 := Lit(Wrappers.Option.value(Lit(this))); v#76)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#48 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#48)) else (var e#48 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#50 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#50))) else (var e#50 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#72 := Wrappers.Result.value(this); s#72) else (var e#72 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#74 := Lit(Wrappers.Result.value(Lit(this))); s#74) else (var e#74 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#76 := Lit(Wrappers.Result.value(Lit(this))); s#76) else (var e#76 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#72 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#72)) else (var e#72 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#72)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#74 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#74))) else (var e#74 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#74)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#76 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#76))) else (var e#76 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#76)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#6: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#6, x#6)): bool } $IsBox(x#6, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#6, x#6)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#7: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#7, x#7)): bool } $IsBox(x#7, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#7, x#7)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#6: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#6, x#6)): bool } $IsBox(x#6, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#6, x#6)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#7: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#7, x#7)): bool } $IsBox(x#7, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#7, x#7)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#6, x#6)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#6, y#6)): bool } $IsBox(x#6, Relations._default.AntiSymmetric$T) && $IsBox(y#6, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#6, y#6)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#6, x#6)): bool ==> x#6 == y#6)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#7: Box, y#7: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#7, x#7)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#7, y#7)): bool } $IsBox(x#7, Relations._default.AntiSymmetric$T) && $IsBox(y#7, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#7, y#7)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#7, x#7)): bool ==> x#7 == y#7)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#6, x#6)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#6, y#6)): bool } $IsBox(x#6, Relations._default.Symmetric$T) && $IsBox(y#6, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#6, y#6)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#6, x#6)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#7: Box, y#7: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#7, x#7)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#7, y#7)): bool } $IsBox(x#7, Relations._default.Symmetric$T) && $IsBox(y#7, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#7, y#7)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#7, x#7)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#6, x#6)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#6, y#6)): bool } $IsBox(x#6, Relations._default.Connected$T) && $IsBox(y#6, Relations._default.Connected$T) ==> x#6 != y#6 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#6, y#6)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#6, x#6)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#7: Box, y#7: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#7, x#7)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#7, y#7)): bool } $IsBox(x#7, Relations._default.Connected$T) && $IsBox(y#7, Relations._default.Connected$T) ==> x#7 != y#7 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#7, y#7)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#7, x#7)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#6, x#6)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#6, y#6)): bool } $IsBox(x#6, Relations._default.StronglyConnected$T) && $IsBox(y#6, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#6, y#6)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#6, x#6)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#7: Box, y#7: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#7, x#7)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#7, y#7)): bool } $IsBox(x#7, Relations._default.StronglyConnected$T) && $IsBox(y#7, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#7, y#7)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#7, x#7)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#6: Box, y#6: Box, z#6: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#6, z#6)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#6, z#6)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#6, z#6)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#6, y#6)): bool } $IsBox(x#6, Relations._default.Transitive$T) && $IsBox(y#6, Relations._default.Transitive$T) && $IsBox(z#6, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#6, y#6)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#6, z#6)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#6, z#6)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#7: Box, y#7: Box, z#7: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#7, z#7)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#7, z#7)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#7, z#7)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#7, y#7)): bool } $IsBox(x#7, Relations._default.Transitive$T) && $IsBox(y#7, Relations._default.Transitive$T) && $IsBox(z#7, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#7, y#7)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#7, z#7)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#7, z#7)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#8: int, j#8: int :: { Seq#Index(a#0, j#8), Seq#Index(a#0, i#8) } LitInt(0) <= i#8 && i#8 < j#8 && j#8 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#8), Seq#Index(a#0, j#8))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#9: int, j#9: int :: { Seq#Index(a#0, j#9), Seq#Index(a#0, i#9) } LitInt(0) <= i#9 && i#9 < j#9 && j#9 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#9), Seq#Index(Lit(a#0), j#9))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#10: int, j#10: int :: { Seq#Index(a#0, j#10), Seq#Index(a#0, i#10) } LitInt(0) <= i#10 && i#10 < j#10 && j#10 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#10), Seq#Index(Lit(a#0), j#10))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#8: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#8)): bool } { s#0[x#8] } $IsBox(x#8, Relations._default.IsLeast$T) && s#0[x#8] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#8)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#9: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#9)): bool } { s#0[x#9] } $IsBox(x#9, Relations._default.IsLeast$T) && Lit(s#0)[x#9] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#9)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#10: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#10)): bool } { s#0[x#10] } $IsBox(x#10, Relations._default.IsLeast$T) && Lit(s#0)[x#10] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#10)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#8: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#8)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#8, min#0)): bool } { s#0[x#8] } $IsBox(x#8, Relations._default.IsMinimal$T) && s#0[x#8] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#8, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#8)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#9: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#9)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#9, min#0)): bool } { s#0[x#9] } $IsBox(x#9, Relations._default.IsMinimal$T) && Lit(s#0)[x#9] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#9, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#9)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#10: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#10)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#10, min#0)): bool } { s#0[x#10] } $IsBox(x#10, Relations._default.IsMinimal$T) && Lit(s#0)[x#10] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#10, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#10)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#8: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#8, max#0)): bool } { s#0[x#8] } $IsBox(x#8, Relations._default.IsGreatest$T) && s#0[x#8] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#8, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#9: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#9, max#0)): bool } { s#0[x#9] } $IsBox(x#9, Relations._default.IsGreatest$T) && Lit(s#0)[x#9] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#9, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#10: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#10, max#0)): bool } { s#0[x#10] } $IsBox(x#10, Relations._default.IsGreatest$T) && Lit(s#0)[x#10] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#10, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#8: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#8, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#8)): bool } { s#0[x#8] } $IsBox(x#8, Relations._default.IsMaximal$T) && s#0[x#8] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#8)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#8, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#9: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#9, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#9)): bool } { s#0[x#9] } $IsBox(x#9, Relations._default.IsMaximal$T) && Lit(s#0)[x#9] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#9)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#9, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#10: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#10, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#10)): bool } { s#0[x#10] } $IsBox(x#10, Relations._default.IsMaximal$T) && Lit(s#0)[x#10] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#10)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#10, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> MultiSet#Equal(MultiSet#FromSeq(a#0), MultiSet#FromSeq(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0))) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortBy$T, Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0), lessThanOrEq#0) && $Is(Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, a#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortBy$T)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#3 := Div(Seq#Length(a#0), LitInt(2)); (var left#3, right#3 := Seq#Take(a#0, splitIndex#3), Seq#Drop(a#0, splitIndex#3); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#3, lessThanOrEq#0) && (var leftSorted#3 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#3, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#3, lessThanOrEq#0) && (var rightSorted#3 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#3, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#3, rightSorted#3, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#3 := Div(Seq#Length(a#0), LitInt(2)); (var left#3, right#3 := Seq#Take(a#0, splitIndex#3), Seq#Drop(a#0, splitIndex#3); (var leftSorted#3 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#3, lessThanOrEq#0); (var rightSorted#3 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#3, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#3, rightSorted#3, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#4 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#4, right#4 := Seq#Take(Lit(a#0), splitIndex#4), Seq#Drop(Lit(a#0), splitIndex#4); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#4, lessThanOrEq#0) && (var leftSorted#4 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#4, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#4, lessThanOrEq#0) && (var rightSorted#4 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#4, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#4, rightSorted#4, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#4 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#4, right#4 := Seq#Take(Lit(a#0), splitIndex#4), Seq#Drop(Lit(a#0), splitIndex#4); (var leftSorted#4 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#4, lessThanOrEq#0); (var rightSorted#4 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#4, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#4, rightSorted#4, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#5 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#5, right#5 := Seq#Take(Lit(a#0), splitIndex#5), Seq#Drop(Lit(a#0), splitIndex#5); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#5, Lit(lessThanOrEq#0)) && (var leftSorted#5 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#5, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#5, Lit(lessThanOrEq#0)) && (var rightSorted#5 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#5, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#5, rightSorted#5, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#5 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#5, right#5 := Seq#Take(Lit(a#0), splitIndex#5), Seq#Drop(Lit(a#0), splitIndex#5); (var leftSorted#5 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#5, Lit(lessThanOrEq#0)); (var rightSorted#5 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#5, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#5, rightSorted#5, Lit(lessThanOrEq#0))))))));

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, right#0, lessThanOrEq#0) || ($Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)) ==> MultiSet#Equal(MultiSet#FromSeq(Seq#Append(left#0, right#0)), MultiSet#FromSeq(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0))) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0), lessThanOrEq#0) && $Is(Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, right#0, lessThanOrEq#0), TSeq(Seq.MergeSort._default.MergeSortedWith$T)));

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), left#0, right#0, lessThanOrEq#0), $IsGoodHeap($Heap) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, right#0, lessThanOrEq#0) || ($IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, left#0, lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, right#0, lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)) ==> (Seq#Length(left#0) != LitInt(0) ==> Seq#Length(right#0) != LitInt(0) ==> ($Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0)) && (!$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0))) && Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), left#0, right#0, lessThanOrEq#0) == (if Seq#Length(left#0) == LitInt(0) then right#0 else (if Seq#Length(right#0) == LitInt(0) then left#0 else (if $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(left#0, LitInt(0)), Seq#Index(right#0, LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(left#0, LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, Seq#Drop(left#0, LitInt(1)), right#0, lessThanOrEq#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(right#0, LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $ly, left#0, Seq#Drop(right#0, LitInt(1)), lessThanOrEq#0))))));

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), lessThanOrEq#0), $IsGoodHeap($Heap) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(right#0), lessThanOrEq#0) || ($IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), lessThanOrEq#0) && Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(right#0), lessThanOrEq#0) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, lessThanOrEq#0)) ==> (Seq#Length(Lit(left#0)) != LitInt(0) ==> Seq#Length(Lit(right#0)) != LitInt(0) ==> ($Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), lessThanOrEq#0)) && (!$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), lessThanOrEq#0))) && Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), lessThanOrEq#0) == (if Seq#Length(Lit(left#0)) == LitInt(0) then right#0 else (if Seq#Length(Lit(right#0)) == LitInt(0) then left#0 else (if $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, lessThanOrEq#0, Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(left#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), lessThanOrEq#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(right#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), lessThanOrEq#0))))));

axiom (forall Seq.MergeSort._default.MergeSortedWith$T: Ty, $ly: LayerType, $Heap: Heap, left#0: Seq, right#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), Lit(lessThanOrEq#0)), $IsGoodHeap($Heap) } Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(right#0), Lit(lessThanOrEq#0)) || ($IsGoodHeap($Heap) && $Is(left#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(right#0, TSeq(Seq.MergeSort._default.MergeSortedWith$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool)) && Lit(Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(lessThanOrEq#0))) && Lit(Relations.__default.SortedBy(Seq.MergeSort._default.MergeSortedWith$T, Lit(right#0), Lit(lessThanOrEq#0))) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortedWith$T, Lit(lessThanOrEq#0)))) ==> (Seq#Length(Lit(left#0)) != LitInt(0) ==> Seq#Length(Lit(right#0)) != LitInt(0) ==> ($Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, Lit(lessThanOrEq#0), Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), Lit(lessThanOrEq#0))) && (!$Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, Lit(lessThanOrEq#0), Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool ==> Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortedWith$T, Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), Lit(lessThanOrEq#0)))) && Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(right#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(left#0)) == LitInt(0) then right#0 else (if Seq#Length(Lit(right#0)) == LitInt(0) then left#0 else (if $Unbox(Apply2(Seq.MergeSort._default.MergeSortedWith$T, Seq.MergeSort._default.MergeSortedWith$T, TBool, $Heap, Lit(lessThanOrEq#0), Seq#Index(Lit(left#0), LitInt(0)), Seq#Index(Lit(right#0), LitInt(0)))): bool then Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(left#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(Seq#Drop(Lit(left#0), LitInt(1))), Lit(right#0), Lit(lessThanOrEq#0))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(right#0), LitInt(0))), Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortedWith$T, $LS($ly), Lit(left#0), Lit(Seq#Drop(Lit(right#0), LitInt(1))), Lit(lessThanOrEq#0)))))));

axiom (forall a#0: int, b#0: int :: { Math.__default.Min(a#0, b#0) } Math.__default.Min(a#0, b#0) == (if a#0 < b#0 then a#0 else b#0));

axiom (forall a#0: int, b#0: int :: {:weight 3} { Math.__default.Min(LitInt(a#0), LitInt(b#0)) } Math.__default.Min(LitInt(a#0), LitInt(b#0)) == (if a#0 < b#0 then a#0 else b#0));

axiom (forall a#0: int, b#0: int :: { Math.__default.Max(a#0, b#0) } Math.__default.Max(a#0, b#0) == (if a#0 < b#0 then b#0 else a#0));

axiom (forall a#0: int, b#0: int :: {:weight 3} { Math.__default.Max(LitInt(a#0), LitInt(b#0)) } Math.__default.Max(LitInt(a#0), LitInt(b#0)) == (if a#0 < b#0 then b#0 else a#0));

axiom (forall a#0: int :: { Math.__default.Abs(a#0) } Math.__default.Abs(a#0) >= LitInt(0));

axiom (forall a#0: int :: { Math.__default.Abs(a#0) } Math.__default.Abs(a#0) == (if a#0 >= LitInt(0) then a#0 else 0 - a#0));

axiom (forall a#0: int :: {:weight 3} { Math.__default.Abs(LitInt(a#0)) } Math.__default.Abs(LitInt(a#0)) == (if LitInt(a#0) >= LitInt(0) then a#0 else 0 - a#0));

const unique class.AbstractUnicodeStrings.__default: ClassName;

function AbstractUnicodeStrings.__default.ToUTF8Checked(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { AbstractUnicodeStrings.__default.ToUTF8Checked(s#0) } AbstractUnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(AbstractUnicodeStrings.__default.ToUTF8Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));
}

function AbstractUnicodeStrings.__default.ToUTF8Checked#canCall(s#0: Seq) : bool;

function AbstractUnicodeStrings.__default.ToUTF8Checked#requires(Seq) : bool;

axiom (forall s#0: Seq :: { AbstractUnicodeStrings.__default.ToUTF8Checked#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (AbstractUnicodeStrings.__default.ToUTF8Checked#requires(s#0) <==> true));

procedure {:verboseName "AbstractUnicodeStrings.ToUTF8Checked (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.ToUTF8Checked(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0) } AbstractUnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)) ==> $Is(AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0), $IsGoodHeap($Heap) } AbstractUnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(char#ToInt($Unbox($l#2#c#0): char))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#2#c#0): char) && char#ToInt($Unbox($l#2#c#0): char) < 128), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))), s#0) && AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(char#ToInt($Unbox($l#0#c#0): char))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#0#c#0): char) && char#ToInt($Unbox($l#0#c#0): char) < 128), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { AbstractUnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)), $IsGoodHeap($Heap) } AbstractUnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#2: int :: { $Unbox(Seq#Index(s#0, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(char#ToInt($Unbox($l#5#c#0): char))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#5#c#0): char) && char#ToInt($Unbox($l#5#c#0): char) < 128), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && AbstractUnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(char#ToInt($Unbox($l#3#c#0): char))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#3#c#0): char) && char#ToInt($Unbox($l#3#c#0): char) < 128), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));
}

function AbstractUnicodeStrings.__default.ASCIIToUTF8#canCall(s#0: Seq) : bool;

function AbstractUnicodeStrings.__default.ASCIIToUTF8#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { AbstractUnicodeStrings.__default.ASCIIToUTF8#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (AbstractUnicodeStrings.__default.ASCIIToUTF8#requires(s#0) <==> (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)));

procedure {:verboseName "AbstractUnicodeStrings.ASCIIToUTF8 (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractUnicodeStrings.ASCIIToUTF8 (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractUnicodeStrings.ASCIIToUTF8", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStrings.dfy(45,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc i#3;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon4;

  anon19_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon6;

  anon20_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < LitInt(0);
    goto anon6;

  anon6:
    assume LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon18_Else:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon8:
    assume (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $Is(AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0);
    goto anon14;

  anon24_Else:
    assume {:partition} char#ToInt(c#0) < LitInt(0);
    goto anon14;

  anon14:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128;
    newtype$check#0 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#0 == char#ToInt(c#0);
    assume true;
    assume $Is(lambdaResult#0, Tclass.BoundedInts.uint8());
    goto anon16;

  anon25_Else:
    assume {:partition} !(LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128);
    goto anon16;

  anon23_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon16;

  anon16:
    assume false;
    goto anon17;

  anon22_Else:
    goto anon17;

  anon17:
    ##f#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(char#ToInt($Unbox($l#7#c#0): char))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#7#c#0): char) && char#ToInt($Unbox($l#7#c#0): char) < 128), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, Tclass.BoundedInts.uint8()), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    assume (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#5: int, o#0: ref :: { Reads1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#5 && i#5 < Seq#Length(##xs#0) && Reads1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(char#ToInt($Unbox($l#8#c#0): char))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#8#c#0): char) && char#ToInt($Unbox($l#8#c#0): char) < 128), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(char#ToInt($Unbox($l#10#c#0): char))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#10#c#0): char) && char#ToInt($Unbox($l#10#c#0): char) < 128), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(char#ToInt($Unbox($l#12#c#0): char))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#12#c#0): char) && char#ToInt($Unbox($l#12#c#0): char) < 128), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $Is(AbstractUnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume b$reqreads#0;
    return;
}



function AbstractUnicodeStrings.__default.FromUTF8Checked(bs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { AbstractUnicodeStrings.__default.FromUTF8Checked(bs#0) } AbstractUnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> $Is(AbstractUnicodeStrings.__default.FromUTF8Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar))));
}

function AbstractUnicodeStrings.__default.FromUTF8Checked#canCall(bs#0: Seq) : bool;

function AbstractUnicodeStrings.__default.FromUTF8Checked#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { AbstractUnicodeStrings.__default.FromUTF8Checked#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (AbstractUnicodeStrings.__default.FromUTF8Checked#requires(bs#0) <==> true));

procedure {:verboseName "AbstractUnicodeStrings.FromUTF8Checked (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.FromUTF8Checked(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractUnicodeStrings.__default.ToUTF16Checked(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { AbstractUnicodeStrings.__default.ToUTF16Checked(s#0) } AbstractUnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(AbstractUnicodeStrings.__default.ToUTF16Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16()))));
}

function AbstractUnicodeStrings.__default.ToUTF16Checked#canCall(s#0: Seq) : bool;

function AbstractUnicodeStrings.__default.ToUTF16Checked#requires(Seq) : bool;

axiom (forall s#0: Seq :: { AbstractUnicodeStrings.__default.ToUTF16Checked#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (AbstractUnicodeStrings.__default.ToUTF16Checked#requires(s#0) <==> true));

procedure {:verboseName "AbstractUnicodeStrings.ToUTF16Checked (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.ToUTF16Checked(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0) } AbstractUnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)) ==> $Is(AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0), $IsGoodHeap($Heap) } AbstractUnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(char#ToInt($Unbox($l#2#c#0): char))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#2#c#0): char) && char#ToInt($Unbox($l#2#c#0): char) < 128), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))), s#0) && AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(char#ToInt($Unbox($l#0#c#0): char))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#0#c#0): char) && char#ToInt($Unbox($l#0#c#0): char) < 128), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { AbstractUnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)), $IsGoodHeap($Heap) } AbstractUnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#2: int :: { $Unbox(Seq#Index(s#0, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(char#ToInt($Unbox($l#5#c#0): char))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#5#c#0): char) && char#ToInt($Unbox($l#5#c#0): char) < 128), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && AbstractUnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(char#ToInt($Unbox($l#3#c#0): char))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#3#c#0): char) && char#ToInt($Unbox($l#3#c#0): char) < 128), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));
}

function AbstractUnicodeStrings.__default.ASCIIToUTF16#canCall(s#0: Seq) : bool;

function AbstractUnicodeStrings.__default.ASCIIToUTF16#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { AbstractUnicodeStrings.__default.ASCIIToUTF16#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (AbstractUnicodeStrings.__default.ASCIIToUTF16#requires(s#0) <==> (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)));

procedure {:verboseName "AbstractUnicodeStrings.ASCIIToUTF16 (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "AbstractUnicodeStrings.ASCIIToUTF16 (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "AbstractUnicodeStrings.ASCIIToUTF16", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStrings.dfy(55,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc i#3;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon4;

  anon19_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon6;

  anon20_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < LitInt(0);
    goto anon6;

  anon6:
    assume LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon18_Else:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon8:
    assume (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $Is(AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16()));
    assume false;
    return;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0);
    goto anon14;

  anon24_Else:
    assume {:partition} char#ToInt(c#0) < LitInt(0);
    goto anon14;

  anon14:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128;
    newtype$check#0 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#1 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    assume lambdaResult#0 == char#ToInt(c#0);
    assume true;
    assume $Is(lambdaResult#0, Tclass.BoundedInts.uint16());
    goto anon16;

  anon25_Else:
    assume {:partition} !(LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128);
    goto anon16;

  anon23_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon16;

  anon16:
    assume false;
    goto anon17;

  anon22_Else:
    goto anon17;

  anon17:
    ##f#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(char#ToInt($Unbox($l#7#c#0): char))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#7#c#0): char) && char#ToInt($Unbox($l#7#c#0): char) < 128), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, Tclass.BoundedInts.uint16()), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    assume (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#5: int, o#0: ref :: { Reads1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#5 && i#5 < Seq#Length(##xs#0) && Reads1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(char#ToInt($Unbox($l#8#c#0): char))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#8#c#0): char) && char#ToInt($Unbox($l#8#c#0): char) < 128), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(char#ToInt($Unbox($l#10#c#0): char))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#10#c#0): char) && char#ToInt($Unbox($l#10#c#0): char) < 128), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(char#ToInt($Unbox($l#12#c#0): char))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#12#c#0): char) && char#ToInt($Unbox($l#12#c#0): char) < 128), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $Is(AbstractUnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16()));
    assume b$reqreads#0;
    return;
}



function AbstractUnicodeStrings.__default.FromUTF16Checked(bs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { AbstractUnicodeStrings.__default.FromUTF16Checked(bs#0) } AbstractUnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> $Is(AbstractUnicodeStrings.__default.FromUTF16Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar))));
}

function AbstractUnicodeStrings.__default.FromUTF16Checked#canCall(bs#0: Seq) : bool;

function AbstractUnicodeStrings.__default.FromUTF16Checked#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { AbstractUnicodeStrings.__default.FromUTF16Checked#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint16())) ==> (AbstractUnicodeStrings.__default.FromUTF16Checked#requires(bs#0) <==> true));

procedure {:verboseName "AbstractUnicodeStrings.FromUTF16Checked (well-formedness)"} CheckWellformed$$AbstractUnicodeStrings.__default.FromUTF16Checked(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#52 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#52))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#54 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#54)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#78 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#78))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#80 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#80)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#82 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#82)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#78 := Wrappers.Option.value(this); v#78)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#80 := Lit(Wrappers.Option.value(Lit(this))); v#80)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#82 := Lit(Wrappers.Option.value(Lit(this))); v#82)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#52 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#52)) else (var e#52 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#54 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#54))) else (var e#54 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#78 := Wrappers.Result.value(this); s#78) else (var e#78 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#80 := Lit(Wrappers.Result.value(Lit(this))); s#80) else (var e#80 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#82 := Lit(Wrappers.Result.value(Lit(this))); s#82) else (var e#82 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#78 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#78)) else (var e#78 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#78)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#80 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#80))) else (var e#80 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#80)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#82 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#82))) else (var e#82 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#82)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#8: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#8, x#8)): bool } $IsBox(x#8, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#8, x#8)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#9: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#9, x#9)): bool } $IsBox(x#9, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#9, x#9)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#8: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#8, x#8)): bool } $IsBox(x#8, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#8, x#8)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#9: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#9, x#9)): bool } $IsBox(x#9, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#9, x#9)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#8: Box, y#8: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#8, x#8)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#8, y#8)): bool } $IsBox(x#8, Relations._default.AntiSymmetric$T) && $IsBox(y#8, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#8, y#8)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#8, x#8)): bool ==> x#8 == y#8)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#9: Box, y#9: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#9, x#9)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#9, y#9)): bool } $IsBox(x#9, Relations._default.AntiSymmetric$T) && $IsBox(y#9, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#9, y#9)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#9, x#9)): bool ==> x#9 == y#9)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#8: Box, y#8: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#8, x#8)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#8, y#8)): bool } $IsBox(x#8, Relations._default.Symmetric$T) && $IsBox(y#8, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#8, y#8)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#8, x#8)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#9: Box, y#9: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#9, x#9)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#9, y#9)): bool } $IsBox(x#9, Relations._default.Symmetric$T) && $IsBox(y#9, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#9, y#9)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#9, x#9)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#8: Box, y#8: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#8, x#8)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#8, y#8)): bool } $IsBox(x#8, Relations._default.Connected$T) && $IsBox(y#8, Relations._default.Connected$T) ==> x#8 != y#8 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#8, y#8)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#8, x#8)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#9: Box, y#9: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#9, x#9)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#9, y#9)): bool } $IsBox(x#9, Relations._default.Connected$T) && $IsBox(y#9, Relations._default.Connected$T) ==> x#9 != y#9 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#9, y#9)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#9, x#9)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#8: Box, y#8: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#8, x#8)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#8, y#8)): bool } $IsBox(x#8, Relations._default.StronglyConnected$T) && $IsBox(y#8, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#8, y#8)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#8, x#8)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#9: Box, y#9: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#9, x#9)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#9, y#9)): bool } $IsBox(x#9, Relations._default.StronglyConnected$T) && $IsBox(y#9, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#9, y#9)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#9, x#9)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#8: Box, y#8: Box, z#8: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#8, z#8)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#8, z#8)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#8, z#8)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#8, y#8)): bool } $IsBox(x#8, Relations._default.Transitive$T) && $IsBox(y#8, Relations._default.Transitive$T) && $IsBox(z#8, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#8, y#8)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#8, z#8)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#8, z#8)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#9: Box, y#9: Box, z#9: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#9, z#9)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#9, z#9)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#9, z#9)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#9, y#9)): bool } $IsBox(x#9, Relations._default.Transitive$T) && $IsBox(y#9, Relations._default.Transitive$T) && $IsBox(z#9, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#9, y#9)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#9, z#9)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#9, z#9)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#11: int, j#11: int :: { Seq#Index(a#0, j#11), Seq#Index(a#0, i#11) } LitInt(0) <= i#11 && i#11 < j#11 && j#11 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#11), Seq#Index(a#0, j#11))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#12: int, j#12: int :: { Seq#Index(a#0, j#12), Seq#Index(a#0, i#12) } LitInt(0) <= i#12 && i#12 < j#12 && j#12 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#12), Seq#Index(Lit(a#0), j#12))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#13: int, j#13: int :: { Seq#Index(a#0, j#13), Seq#Index(a#0, i#13) } LitInt(0) <= i#13 && i#13 < j#13 && j#13 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#13), Seq#Index(Lit(a#0), j#13))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#11: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#11)): bool } { s#0[x#11] } $IsBox(x#11, Relations._default.IsLeast$T) && s#0[x#11] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#11)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#12: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#12)): bool } { s#0[x#12] } $IsBox(x#12, Relations._default.IsLeast$T) && Lit(s#0)[x#12] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#12)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#13: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#13)): bool } { s#0[x#13] } $IsBox(x#13, Relations._default.IsLeast$T) && Lit(s#0)[x#13] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#13)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#11: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#11)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#11, min#0)): bool } { s#0[x#11] } $IsBox(x#11, Relations._default.IsMinimal$T) && s#0[x#11] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#11, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#11)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#12: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#12)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#12, min#0)): bool } { s#0[x#12] } $IsBox(x#12, Relations._default.IsMinimal$T) && Lit(s#0)[x#12] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#12, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#12)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#13: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#13)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#13, min#0)): bool } { s#0[x#13] } $IsBox(x#13, Relations._default.IsMinimal$T) && Lit(s#0)[x#13] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#13, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#13)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#11: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#11, max#0)): bool } { s#0[x#11] } $IsBox(x#11, Relations._default.IsGreatest$T) && s#0[x#11] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#11, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#12: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#12, max#0)): bool } { s#0[x#12] } $IsBox(x#12, Relations._default.IsGreatest$T) && Lit(s#0)[x#12] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#12, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#13: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#13, max#0)): bool } { s#0[x#13] } $IsBox(x#13, Relations._default.IsGreatest$T) && Lit(s#0)[x#13] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#13, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#11: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#11, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#11)): bool } { s#0[x#11] } $IsBox(x#11, Relations._default.IsMaximal$T) && s#0[x#11] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#11)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#11, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#12: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#12, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#12)): bool } { s#0[x#12] } $IsBox(x#12, Relations._default.IsMaximal$T) && Lit(s#0)[x#12] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#12)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#12, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#13: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#13, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#13)): bool } { s#0[x#13] } $IsBox(x#13, Relations._default.IsMaximal$T) && Lit(s#0)[x#13] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#13)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#13, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#6 := Div(Seq#Length(a#0), LitInt(2)); (var left#6, right#6 := Seq#Take(a#0, splitIndex#6), Seq#Drop(a#0, splitIndex#6); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#6, lessThanOrEq#0) && (var leftSorted#6 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#6, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#6, lessThanOrEq#0) && (var rightSorted#6 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#6, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#6, rightSorted#6, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#6 := Div(Seq#Length(a#0), LitInt(2)); (var left#6, right#6 := Seq#Take(a#0, splitIndex#6), Seq#Drop(a#0, splitIndex#6); (var leftSorted#6 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#6, lessThanOrEq#0); (var rightSorted#6 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#6, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#6, rightSorted#6, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#7 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#7, right#7 := Seq#Take(Lit(a#0), splitIndex#7), Seq#Drop(Lit(a#0), splitIndex#7); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#7, lessThanOrEq#0) && (var leftSorted#7 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#7, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#7, lessThanOrEq#0) && (var rightSorted#7 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#7, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#7, rightSorted#7, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#7 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#7, right#7 := Seq#Take(Lit(a#0), splitIndex#7), Seq#Drop(Lit(a#0), splitIndex#7); (var leftSorted#7 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#7, lessThanOrEq#0); (var rightSorted#7 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#7, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#7, rightSorted#7, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#8 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#8, right#8 := Seq#Take(Lit(a#0), splitIndex#8), Seq#Drop(Lit(a#0), splitIndex#8); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#8, Lit(lessThanOrEq#0)) && (var leftSorted#8 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#8, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#8, Lit(lessThanOrEq#0)) && (var rightSorted#8 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#8, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#8, rightSorted#8, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#8 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#8, right#8 := Seq#Take(Lit(a#0), splitIndex#8), Seq#Drop(Lit(a#0), splitIndex#8); (var leftSorted#8 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#8, Lit(lessThanOrEq#0)); (var rightSorted#8 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#8, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#8, rightSorted#8, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.First$T: Ty, xs#0: Seq :: { Seq.__default.First(Seq._default.First$T, xs#0) } Seq.__default.First#canCall(Seq._default.First$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.First$T)) && Seq#Length(xs#0) > 0) ==> $IsBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T));

axiom (forall $Heap: Heap, Seq._default.First$T: Ty, xs#0: Seq :: { $IsAllocBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T, $Heap) } (Seq.__default.First#canCall(Seq._default.First$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.First$T)) && $IsAlloc(xs#0, TSeq(Seq._default.First$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.First(Seq._default.First$T, xs#0), Seq._default.First$T, $Heap));

axiom (forall Seq._default.First$T: Ty, xs#0: Seq :: { Seq.__default.First(Seq._default.First$T, xs#0) } Seq.__default.First#canCall(Seq._default.First$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.First$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.First(Seq._default.First$T, xs#0) == Seq#Index(xs#0, LitInt(0)));

axiom (forall Seq._default.First$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.First(Seq._default.First$T, Lit(xs#0)) } Seq.__default.First#canCall(Seq._default.First$T, Lit(xs#0)) || ($Is(xs#0, TSeq(Seq._default.First$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.First(Seq._default.First$T, Lit(xs#0)) == Seq#Index(Lit(xs#0), LitInt(0)));

axiom (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: { Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) } Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.DropFirst$T)) && Seq#Length(xs#0) > 0) ==> $Is(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T)));

axiom (forall $Heap: Heap, Seq._default.DropFirst$T: Ty, xs#0: Seq :: { $IsAlloc(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T), $Heap) } (Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.DropFirst$T)) && $IsAlloc(xs#0, TSeq(Seq._default.DropFirst$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0), TSeq(Seq._default.DropFirst$T), $Heap));

axiom (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: { Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) } Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.DropFirst$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.DropFirst(Seq._default.DropFirst$T, xs#0) == Seq#Drop(xs#0, LitInt(1)));

axiom (forall Seq._default.DropFirst$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.DropFirst(Seq._default.DropFirst$T, Lit(xs#0)) } Seq.__default.DropFirst#canCall(Seq._default.DropFirst$T, Lit(xs#0)) || ($Is(xs#0, TSeq(Seq._default.DropFirst$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.DropFirst(Seq._default.DropFirst$T, Lit(xs#0)) == Lit(Seq#Drop(Lit(xs#0), LitInt(1))));

axiom (forall Seq._default.Last$T: Ty, xs#0: Seq :: { Seq.__default.Last(Seq._default.Last$T, xs#0) } Seq.__default.Last#canCall(Seq._default.Last$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.Last$T)) && Seq#Length(xs#0) > 0) ==> $IsBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T));

axiom (forall $Heap: Heap, Seq._default.Last$T: Ty, xs#0: Seq :: { $IsAllocBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T, $Heap) } (Seq.__default.Last#canCall(Seq._default.Last$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.Last$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Last$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.Last(Seq._default.Last$T, xs#0), Seq._default.Last$T, $Heap));

axiom (forall Seq._default.Last$T: Ty, xs#0: Seq :: { Seq.__default.Last(Seq._default.Last$T, xs#0) } Seq.__default.Last#canCall(Seq._default.Last$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.Last$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.Last(Seq._default.Last$T, xs#0) == Seq#Index(xs#0, Seq#Length(xs#0) - 1));

axiom (forall Seq._default.Last$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.Last(Seq._default.Last$T, Lit(xs#0)) } Seq.__default.Last#canCall(Seq._default.Last$T, Lit(xs#0)) || ($Is(xs#0, TSeq(Seq._default.Last$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.Last(Seq._default.Last$T, Lit(xs#0)) == Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1));

axiom (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: { Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) } Seq.__default.DropLast#canCall(Seq._default.DropLast$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.DropLast$T)) && Seq#Length(xs#0) > 0) ==> $Is(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T)));

axiom (forall $Heap: Heap, Seq._default.DropLast$T: Ty, xs#0: Seq :: { $IsAlloc(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T), $Heap) } (Seq.__default.DropLast#canCall(Seq._default.DropLast$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.DropLast$T)) && $IsAlloc(xs#0, TSeq(Seq._default.DropLast$T), $Heap) && Seq#Length(xs#0) > 0)) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.DropLast(Seq._default.DropLast$T, xs#0), TSeq(Seq._default.DropLast$T), $Heap));

axiom (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: { Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) } Seq.__default.DropLast#canCall(Seq._default.DropLast$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.DropLast$T)) && Seq#Length(xs#0) > 0) ==> Seq.__default.DropLast(Seq._default.DropLast$T, xs#0) == Seq#Take(xs#0, Seq#Length(xs#0) - 1));

axiom (forall Seq._default.DropLast$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.DropLast(Seq._default.DropLast$T, Lit(xs#0)) } Seq.__default.DropLast#canCall(Seq._default.DropLast$T, Lit(xs#0)) || ($Is(xs#0, TSeq(Seq._default.DropLast$T)) && Seq#Length(Lit(xs#0)) > 0) ==> Seq.__default.DropLast(Seq._default.DropLast$T, Lit(xs#0)) == Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1));

axiom (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) } Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T))) ==> Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) ==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Take(ys#0, Seq#Length(xs#0))));

axiom (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) } Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T))) ==> (Seq.__default.IsPrefix(Seq._default.IsPrefix$T, xs#0, ys#0) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#SameUntil(xs#0, ys#0, Seq#Length(xs#0))));

axiom (forall Seq._default.IsPrefix$T: Ty, xs#0: Seq, ys#0: Seq :: {:weight 3} { Seq.__default.IsPrefix(Seq._default.IsPrefix$T, Lit(xs#0), Lit(ys#0)) } Seq.__default.IsPrefix#canCall(Seq._default.IsPrefix$T, Lit(xs#0), Lit(ys#0)) || ($Is(xs#0, TSeq(Seq._default.IsPrefix$T)) && $Is(ys#0, TSeq(Seq._default.IsPrefix$T))) ==> (Seq.__default.IsPrefix(Seq._default.IsPrefix$T, Lit(xs#0), Lit(ys#0)) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#SameUntil(xs#0, ys#0, Seq#Length(xs#0))));

axiom (forall Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq :: { Seq.__default.IsSuffix(Seq._default.IsSuffix$T, xs#0, ys#0) } Seq.__default.IsSuffix#canCall(Seq._default.IsSuffix$T, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.IsSuffix$T)) && $Is(ys#0, TSeq(Seq._default.IsSuffix$T))) ==> (Seq.__default.IsSuffix(Seq._default.IsSuffix$T, xs#0, ys#0) <==> Seq#Length(xs#0) <= Seq#Length(ys#0) && Seq#Equal(xs#0, Seq#Drop(ys#0, Seq#Length(ys#0) - Seq#Length(xs#0)))));

axiom (forall Seq._default.IsSuffix$T: Ty, xs#0: Seq, ys#0: Seq :: {:weight 3} { Seq.__default.IsSuffix(Seq._default.IsSuffix$T, Lit(xs#0), Lit(ys#0)) } Seq.__default.IsSuffix#canCall(Seq._default.IsSuffix$T, Lit(xs#0), Lit(ys#0)) || ($Is(xs#0, TSeq(Seq._default.IsSuffix$T)) && $Is(ys#0, TSeq(Seq._default.IsSuffix$T))) ==> (Seq.__default.IsSuffix(Seq._default.IsSuffix$T, Lit(xs#0), Lit(ys#0)) <==> Seq#Length(Lit(xs#0)) <= Seq#Length(Lit(ys#0)) && Seq#Equal(xs#0, Seq#Drop(Lit(ys#0), Seq#Length(Lit(ys#0)) - Seq#Length(Lit(xs#0))))));

axiom (forall Seq._default.ToSet$T: Ty, $reveal: bool, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> $Is(Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0), TSet(Seq._default.ToSet$T)));

axiom (forall $Heap: Heap, Seq._default.ToSet$T: Ty, $reveal: bool, xs#0: Seq :: { $IsAlloc(Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0), TSet(Seq._default.ToSet$T), $Heap) } (Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.ToSet$T)) && $IsAlloc(xs#0, TSeq(Seq._default.ToSet$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.ToSet(Seq._default.ToSet$T, $reveal, xs#0), TSet(Seq._default.ToSet$T), $Heap));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#4: Box :: $IsBox($y#4, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#4)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#5: Box :: $IsBox($y#5, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#5)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#4: int, j#4: int :: { Seq#Index(xs#0, j#4), Seq#Index(xs#0, i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) && LitInt(0) <= j#4 && j#4 < Seq#Length(xs#0) && i#4 != j#4 ==> Seq#Index(xs#0, i#4) != Seq#Index(xs#0, j#4))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#5: int, j#5: int :: { Seq#Index(xs#0, j#5), Seq#Index(xs#0, i#5) } LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#5 && j#5 < Seq#Length(Lit(xs#0)) && i#5 != j#5 ==> Seq#Index(Lit(xs#0), i#5) != Seq#Index(Lit(xs#0), j#5))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#3: int :: { Seq#Index(xs#0, j#3) } LitInt(0) <= j#3 && j#3 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#3) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, xs#0, v#0) == (if Seq#Index(xs#0, LitInt(0)) == v#0 then 0 else 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, reveal_Seq._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0)));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then 0 else 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), reveal_Seq._default.IndexOf, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then 0 else 1 + Seq.__default.IndexOf(Seq._default.IndexOf$T, $LS($ly), reveal_Seq._default.IndexOf, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#3: int :: { Seq#Index(xs#0, j#3) } LitInt(0) <= j#3 && j#3 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#3) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#3 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#3) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#3)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#4 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#4) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#4)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#5 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#5) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#5)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#3: int :: { Seq#Index(xs#0, j#3) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#3 && j#3 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#3) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(xs#0, Seq#Length(xs#0) - 1) != v#0 ==> Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0)) && Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, xs#0, v#0) == (if Seq#Index(xs#0, Seq#Length(xs#0) - 1) == v#0 then Seq#Length(xs#0) - 1 else Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, reveal_Seq._default.LastIndexOf, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0)));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != v#0 ==> Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0)) && Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == v#0 then Seq#Length(Lit(xs#0)) - 1 else Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), reveal_Seq._default.LastIndexOf, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0)));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != Lit(v#0) ==> Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0))) && Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == Lit(v#0) then Seq#Length(Lit(xs#0)) - 1 else Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $LS($ly), reveal_Seq._default.LastIndexOf, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0))));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#3: int :: { Seq#Index(xs#0, j#3) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#3 && j#3 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#3) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, Seq#Length(xs#0) - 1) != v#0 ==> Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0)) && Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, Seq#Length(xs#0) - 1) == v#0 then #Wrappers.Option.Some($Box(Seq#Length(xs#0) - 1)) else Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, reveal_Seq._default.LastIndexOfOption, Seq#Take(xs#0, Seq#Length(xs#0) - 1), v#0))));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != v#0 ==> Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0)) && Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == v#0 then #Wrappers.Option.Some($Box(Seq#Length(Lit(xs#0)) - 1)) else Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), reveal_Seq._default.LastIndexOfOption, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), v#0))));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) != Lit(v#0) ==> Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0))) && Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1) == Lit(v#0) then #Wrappers.Option.Some($Box(Seq#Length(Lit(xs#0)) - 1)) else Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $LS($ly), reveal_Seq._default.LastIndexOfOption, Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), Lit(v#0)))));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#6: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#6), Seq#Index(xs#0, i#6) } LitInt(0) <= i#6 && i#6 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#6) == Seq#Index(xs#0, i#6)) && (forall i#7: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#7) } pos#0 <= i#7 && i#7 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#7) == Seq#Index(xs#0, i#7 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall $Heap: Heap, Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { $IsAlloc(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T), $Heap) } (Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Remove$T), $Heap) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T), $Heap));

axiom (forall Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, true, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq.__default.Remove(Seq._default.Remove$T, true, xs#0, pos#0) == Seq#Append(Seq#Take(xs#0, pos#0), Seq#Drop(xs#0, pos#0 + 1)));

axiom (forall Seq._default.Remove$T: Ty, xs#0: Seq, pos#0: int :: {:weight 3} { Seq.__default.Remove(Seq._default.Remove$T, true, Lit(xs#0), LitInt(pos#0)) } Seq.__default.Remove#canCall(Seq._default.Remove$T, Lit(xs#0), LitInt(pos#0)) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(Lit(xs#0))) ==> Seq.__default.Remove(Seq._default.Remove$T, true, Lit(xs#0), LitInt(pos#0)) == Seq#Append(Seq#Take(Lit(xs#0), LitInt(pos#0)), Seq#Drop(Lit(xs#0), LitInt(pos#0 + 1))));

axiom (forall Seq._default.RemoveValue$T: Ty, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (!Seq#Contains(xs#0, v#0) ==> Seq#Equal(xs#0, Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0))) && (Seq#Contains(xs#0, v#0) ==> MultiSet#Card(MultiSet#FromSeq(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0))) == MultiSet#Card(MultiSet#FromSeq(xs#0)) - 1) && (Seq#Contains(xs#0, v#0) ==> MultiSet#FromSeq(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0))[v#0] == MultiSet#FromSeq(xs#0)[v#0] - 1) && (Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, xs#0) ==> Seq.__default.HasNoDuplicates(Seq._default.RemoveValue$T, reveal_Seq._default.HasNoDuplicates, Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0)) && Set#Equal(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0)), Set#Difference(Seq.__default.ToSet(Seq._default.RemoveValue$T, reveal_Seq._default.ToSet, xs#0), Set#UnionOne(Set#Empty(): Set, v#0)))) && $Is(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0), TSeq(Seq._default.RemoveValue$T)));

axiom (forall $Heap: Heap, Seq._default.RemoveValue$T: Ty, $reveal: bool, xs#0: Seq, v#0: Box :: { $IsAlloc(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0), TSeq(Seq._default.RemoveValue$T), $Heap) } (Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsAlloc(xs#0, TSeq(Seq._default.RemoveValue$T), $Heap) && $IsBox(v#0, Seq._default.RemoveValue$T) && $IsAllocBox(v#0, Seq._default.RemoveValue$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.RemoveValue(Seq._default.RemoveValue$T, $reveal, xs#0, v#0), TSeq(Seq._default.RemoveValue$T), $Heap));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#3 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#3), Seq#Drop(xs#0, i#3 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#4 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#4), Seq#Drop(Lit(xs#0), i#4 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#5 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#5), Seq#Drop(Lit(xs#0), i#5 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#6: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#6), Seq#Index(xs#0, i#6) } LitInt(0) <= i#6 && i#6 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#6) == Seq#Index(xs#0, i#6)) && (forall i#7: int :: { Seq#Index(xs#0, i#7) } pos#0 <= i#7 && i#7 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#7 + 1) == Seq#Index(xs#0, i#7)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall $Heap: Heap, Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { $IsAlloc(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T), $Heap) } (Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Insert$T), $Heap) && $IsBox(a#0, Seq._default.Insert$T) && $IsAllocBox(a#0, Seq._default.Insert$T, $Heap) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T), $Heap));

axiom (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, true, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq.__default.Insert(Seq._default.Insert$T, true, xs#0, a#0, pos#0) == Seq#Append(Seq#Append(Seq#Take(xs#0, pos#0), Seq#Build(Seq#Empty(): Seq, a#0)), Seq#Drop(xs#0, pos#0)));

axiom (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: {:weight 3} { Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), a#0, LitInt(pos#0)) } Seq.__default.Insert#canCall(Seq._default.Insert$T, Lit(xs#0), a#0, LitInt(pos#0)) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && LitInt(pos#0) <= Seq#Length(Lit(xs#0))) ==> Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), a#0, LitInt(pos#0)) == Seq#Append(Seq#Append(Seq#Take(Lit(xs#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq, a#0)), Seq#Drop(Lit(xs#0), LitInt(pos#0))));

axiom (forall Seq._default.Insert$T: Ty, xs#0: Seq, a#0: Box, pos#0: int :: {:weight 3} { Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), Lit(a#0), LitInt(pos#0)) } Seq.__default.Insert#canCall(Seq._default.Insert$T, Lit(xs#0), Lit(a#0), LitInt(pos#0)) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && LitInt(pos#0) <= Seq#Length(Lit(xs#0))) ==> Seq.__default.Insert(Seq._default.Insert$T, true, Lit(xs#0), Lit(a#0), LitInt(pos#0)) == Seq#Append(Seq#Append(Seq#Take(Lit(xs#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq, Lit(a#0))), Seq#Drop(Lit(xs#0), LitInt(pos#0))));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#3: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#3) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#3 - 1) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#3) == Seq#Index(xs#0, Seq#Length(xs#0) - i#3 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall $Heap: Heap, Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { $IsAlloc(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T), $Heap) } (Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || ($Is(xs#0, TSeq(Seq._default.Reverse$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Reverse$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T), $Heap));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> (!Seq#Equal(xs#0, Seq#Empty(): Seq) ==> Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0)))) && Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, xs#0) == (if Seq#Equal(xs#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, Seq#Length(xs#0) - 1)), Seq.__default.Reverse(Seq._default.Reverse$T, $ly, reveal_Seq._default.Reverse, Seq#Drop(Seq#Take(xs#0, Seq#Length(xs#0) - 1), LitInt(0))))));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, Lit(xs#0)) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> (!Seq#Equal(xs#0, Seq#Empty(): Seq) ==> Seq.__default.Reverse#canCall(Seq._default.Reverse$T, Seq#Drop(Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), LitInt(0)))) && Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), true, Lit(xs#0)) == (if Seq#Equal(xs#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1)), Seq.__default.Reverse(Seq._default.Reverse$T, $LS($ly), reveal_Seq._default.Reverse, Seq#Drop(Seq#Take(Lit(xs#0), Seq#Length(Lit(xs#0)) - 1), LitInt(0))))));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#3: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#3) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall $Heap: Heap, Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { $IsAlloc(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T), $Heap) } (Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && $IsAllocBox(v#0, Seq._default.Repeat$T, $Heap) && LitInt(0) <= length#0)) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T), $Heap));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> (length#0 != LitInt(0) ==> Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0 - 1)) && Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, length#0) == (if length#0 == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, v#0), Seq.__default.Repeat(Seq._default.Repeat$T, $ly, reveal_Seq._default.Repeat, v#0, length#0 - 1))));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: {:weight 3} { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, LitInt(length#0)) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, LitInt(length#0)) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> (LitInt(length#0) != LitInt(0) ==> Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, LitInt(length#0 - 1))) && Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, v#0, LitInt(length#0)) == (if LitInt(length#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, v#0), Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), reveal_Seq._default.Repeat, v#0, LitInt(length#0 - 1)))));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, v#0: Box, length#0: int :: {:weight 3} { Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, Lit(v#0), LitInt(length#0)) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, Lit(v#0), LitInt(length#0)) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> (LitInt(length#0) != LitInt(0) ==> Seq.__default.Repeat#canCall(Seq._default.Repeat$T, Lit(v#0), LitInt(length#0 - 1))) && Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), true, Lit(v#0), LitInt(length#0)) == (if LitInt(length#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Lit(v#0)), Seq.__default.Repeat(Seq._default.Repeat$T, $LS($ly), reveal_Seq._default.Repeat, Lit(v#0), LitInt(length#0 - 1)))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#3: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#3) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#3), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#3)), $Unbox(Seq#Index(xs#0, i#3)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall $Heap: Heap, Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { $IsAlloc(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)), $Heap) } (Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || ($Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) && $IsAlloc(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B)), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B)), $Heap));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#2, b#2 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#2, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#2, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#3, b#3 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#3, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#3, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#3: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#3)): DatatypeType } LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#3)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#3), Seq#Index(ys#0, i#3)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $Heap: Heap, Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { $IsAlloc(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)), $Heap) } (Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $IsAlloc(xs#0, TSeq(Seq._default.Zip$A), $Heap) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && $IsAlloc(ys#0, TSeq(Seq._default.Zip$B), $Heap) && Seq#Length(xs#0) == Seq#Length(ys#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B)), $Heap));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Seq._default.Zip$A, xs#0) && Seq.__default.DropLast#canCall(Seq._default.Zip$B, ys#0) && Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0)) && Seq.__default.Last#canCall(Seq._default.Zip$A, xs#0) && Seq.__default.Last#canCall(Seq._default.Zip$B, ys#0)) && Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, xs#0, ys#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, Seq.__default.DropLast(Seq._default.Zip$A, xs#0), Seq.__default.DropLast(Seq._default.Zip$B, ys#0)), Seq#Build(Seq#Empty(): Seq, $Box(#_System._tuple#2._#Make2(Seq.__default.Last(Seq._default.Zip$A, xs#0), Seq.__default.Last(Seq._default.Zip$B, ys#0)))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, xs#0: Seq, ys#0: Seq :: {:weight 3} { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, Lit(xs#0), Lit(ys#0)) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Lit(xs#0), Lit(ys#0)) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(Lit(xs#0)) == Seq#Length(Lit(ys#0))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Seq._default.Zip$A, Lit(xs#0)) && Seq.__default.DropLast#canCall(Seq._default.Zip$B, Lit(ys#0)) && Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, Lit(Seq.__default.DropLast(Seq._default.Zip$A, Lit(xs#0))), Lit(Seq.__default.DropLast(Seq._default.Zip$B, Lit(ys#0)))) && Seq.__default.Last#canCall(Seq._default.Zip$A, Lit(xs#0)) && Seq.__default.Last#canCall(Seq._default.Zip$B, Lit(ys#0))) && Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), true, Lit(xs#0), Lit(ys#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($ly), reveal_Seq._default.Zip, Lit(Seq.__default.DropLast(Seq._default.Zip$A, Lit(xs#0))), Lit(Seq.__default.DropLast(Seq._default.Zip$B, Lit(ys#0)))), Seq#Build(Seq#Empty(): Seq, $Box(Lit(#_System._tuple#2._#Make2(Lit(Seq.__default.Last(Seq._default.Zip$A, Lit(xs#0))), Lit(Seq.__default.Last(Seq._default.Zip$B, Lit(ys#0))))))))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#3: int :: { Seq#Contains(xs#0, $Box(k#3)) } Seq#Contains(xs#0, $Box(k#3)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#3) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, xs#0: Seq :: { Seq.__default.Max($LS($ly), true, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (Seq#Length(xs#0) != LitInt(1) ==> Seq.__default.Max#canCall(Seq#Drop(xs#0, LitInt(1))) && Math.__default.Max#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($ly, reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))))) && Seq.__default.Max($LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(1) then $Unbox(Seq#Index(xs#0, LitInt(0))): int else Math.__default.Max($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Max($ly, reveal_Seq._default.Max, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Max($LS($ly), true, Lit(xs#0)) } Seq.__default.Max#canCall(Lit(xs#0)) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(Lit(xs#0))) ==> (Seq#Length(Lit(xs#0)) != LitInt(1) ==> Seq.__default.Max#canCall(Lit(Seq#Drop(Lit(xs#0), LitInt(1)))) && Math.__default.Max#canCall($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Max($LS($ly), reveal_Seq._default.Max, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))) && Seq.__default.Max($LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int else Math.__default.Max($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Max($LS($ly), reveal_Seq._default.Max, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#3: int :: { Seq#Contains(xs#0, $Box(k#3)) } Seq#Contains(xs#0, $Box(k#3)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#3) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall $ly: LayerType, xs#0: Seq :: { Seq.__default.Min($LS($ly), true, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (Seq#Length(xs#0) != LitInt(1) ==> Seq.__default.Min#canCall(Seq#Drop(xs#0, LitInt(1))) && Math.__default.Min#canCall($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($ly, reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))))) && Seq.__default.Min($LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(1) then $Unbox(Seq#Index(xs#0, LitInt(0))): int else Math.__default.Min($Unbox(Seq#Index(xs#0, LitInt(0))): int, Seq.__default.Min($ly, reveal_Seq._default.Min, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Min($LS($ly), true, Lit(xs#0)) } Seq.__default.Min#canCall(Lit(xs#0)) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(Lit(xs#0))) ==> (Seq#Length(Lit(xs#0)) != LitInt(1) ==> Seq.__default.Min#canCall(Lit(Seq#Drop(Lit(xs#0), LitInt(1)))) && Math.__default.Min#canCall($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Min($LS($ly), reveal_Seq._default.Min, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))) && Seq.__default.Min($LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int else Math.__default.Min($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): int, Seq.__default.Min($LS($ly), reveal_Seq._default.Min, Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))));

axiom (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0) } Seq.__default.Flatten#canCall(Seq._default.Flatten$T, xs#0) || $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))) ==> $Is(Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0), TSeq(Seq._default.Flatten$T)));

axiom (forall $Heap: Heap, Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { $IsAlloc(Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0), TSeq(Seq._default.Flatten$T), $Heap) } (Seq.__default.Flatten#canCall(Seq._default.Flatten$T, xs#0) || ($Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.Flatten$T)), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.Flatten(Seq._default.Flatten$T, $ly, xs#0), TSeq(Seq._default.Flatten$T), $Heap));

axiom (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), xs#0) } Seq.__default.Flatten#canCall(Seq._default.Flatten$T, xs#0) || $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(xs#0, LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.Flatten$T, $ly, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.Flatten$T: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), Lit(xs#0)) } Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Lit(xs#0)) || $Is(xs#0, TSeq(TSeq(Seq._default.Flatten$T))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.Flatten#canCall(Seq._default.Flatten$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))))) && Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(Lit(xs#0), LitInt(0))): Seq, Seq.__default.Flatten(Seq._default.Flatten$T, $LS($ly), Lit(Seq#Drop(Lit(xs#0), LitInt(1)))))));

axiom (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0) } Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, xs#0) || $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))) ==> $Is(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0), TSeq(Seq._default.FlattenReverse$T)));

axiom (forall $Heap: Heap, Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { $IsAlloc(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0), TSeq(Seq._default.FlattenReverse$T), $Heap) } (Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, xs#0) || ($Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))) && $IsAlloc(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T)), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, xs#0), TSeq(Seq._default.FlattenReverse$T), $Heap));

axiom (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), xs#0) } Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, xs#0) || $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0) && Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0)) && Seq.__default.Last#canCall(TSeq(Seq._default.FlattenReverse$T), xs#0)) && Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $ly, Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), xs#0)), $Unbox(Seq.__default.Last(TSeq(Seq._default.FlattenReverse$T), xs#0)): Seq)));

axiom (forall Seq._default.FlattenReverse$T: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), Lit(xs#0)) } Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Lit(xs#0)) || $Is(xs#0, TSeq(TSeq(Seq._default.FlattenReverse$T))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0)) && Seq.__default.FlattenReverse#canCall(Seq._default.FlattenReverse$T, Lit(Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0)))) && Seq.__default.Last#canCall(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0))) && Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Seq.__default.FlattenReverse(Seq._default.FlattenReverse$T, $LS($ly), Lit(Seq.__default.DropLast(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0)))), $Unbox(Seq.__default.Last(TSeq(Seq._default.FlattenReverse$T), Lit(xs#0))): Seq)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#16: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#16) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#16))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R), $Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R), $Heap));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#17: int :: { Seq#Index(xs#0, i#17) } LitInt(0) <= i#17 && i#17 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#17)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#17: int :: { Seq#Index(xs#0, i#17) } LitInt(0) <= i#17 && i#17 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#17)))) ==> (forall $l#7#i#0: int :: LitInt(0) <= $l#7#i#0 ==> $l#7#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#7#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#6#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#6#i#0): int))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt) && LitInt(0) <= $Unbox($l#6#i#0): int && $Unbox($l#6#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#6#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#6#i#0): int))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: (exists i#18: int, o#9: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#6#heap#0, f#0, Seq#Index(xs#0, i#18))[$Box(o#9)] } $Is(o#9, Tclass._System.object?()) && LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#6#heap#0, f#0, Seq#Index(xs#0, i#18))[$Box(o#9)] && $Box($l#6#o#0) == $Box(o#9))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#13: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#13) } { Seq#Index(xs#0, i#13) } (LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#13))): DatatypeType)) && (LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#13) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#13))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E), $Heap));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#14: int :: { Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#14)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#14: int :: { Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#14)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#1 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#1) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#1) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#1 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#1)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#1 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#1) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#1) else (var head#1 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#1); (var valueOrError1#1 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#1) else (var tail#1 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#1), tail#1)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#13: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#13) } LitInt(0) <= i#13 ==> i#13 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#13)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#13))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T), $Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T), $Heap));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#14: int :: { Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#14)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#14: int :: { Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#14)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, xs#0) || ($Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> $IsBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0), Seq._default.FoldLeft$A));

axiom (forall $Heap: Heap, Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, init#0: Box, xs#0: Seq :: { $IsAllocBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0), Seq._default.FoldLeft$A, $Heap) } (Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, xs#0) || ($Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A), $Heap) && $IsBox(init#0, Seq._default.FoldLeft$A) && $IsAllocBox(init#0, Seq._default.FoldLeft$A, $Heap) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FoldLeft$T), $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, $reveal, f#0, init#0, xs#0), Seq._default.FoldLeft$A, $Heap));

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then init#0 else Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $ly, reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(xs#0, LitInt(0))), Seq#Drop(xs#0, LitInt(1)))));

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: {:weight 3} { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, Lit(xs#0)), $IsGoodHeap($Heap) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, init#0, Lit(xs#0)) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))) && Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, f#0, init#0, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), reveal_Seq._default.FoldLeft, f#0, Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, f#0, init#0, Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))));

axiom (forall Seq._default.FoldLeft$A: Ty, Seq._default.FoldLeft$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, init#0: Box, xs#0: Seq :: {:weight 3} { Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, Lit(f#0), Lit(init#0), Lit(xs#0)), $IsGoodHeap($Heap) } Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Lit(f#0), Lit(init#0), Lit(xs#0)) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A)) && $IsBox(init#0, Seq._default.FoldLeft$A) && $Is(xs#0, TSeq(Seq._default.FoldLeft$T))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldLeft#canCall(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Lit(f#0), Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, Lit(f#0), Lit(init#0), Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))) && Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), true, Lit(f#0), Lit(init#0), Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Seq.__default.FoldLeft(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, $LS($ly), reveal_Seq._default.FoldLeft, Lit(f#0), Apply2(Seq._default.FoldLeft$A, Seq._default.FoldLeft$T, Seq._default.FoldLeft$A, $Heap, Lit(f#0), Lit(init#0), Seq#Index(Lit(xs#0), LitInt(0))), Lit(Seq#Drop(Lit(xs#0), LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#4: Box, xs#4: Seq, b#4: Box, b'#4: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#4, x#4, b'#4)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#4), xs#4) } $IsBox(x#4, Seq._default.InvFoldLeft$A) && $Is(xs#4, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#4, Seq._default.InvFoldLeft$B) && $IsBox(b'#4, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#4, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#4), xs#4)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#4, x#4, b'#4)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#4, $Box(xs#4))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#5: Box, xs#5: Seq, b#5: Box, b'#5: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#5, x#5, b'#5)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#5), xs#5) } $IsBox(x#5, Seq._default.InvFoldLeft$A) && $Is(xs#5, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#5, Seq._default.InvFoldLeft$B) && $IsBox(b'#5, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#5, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#5), xs#5)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#5, x#5, b'#5)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#5, $Box(xs#5))): bool)));

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, xs#0, init#0) || ($Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> $IsBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0), Seq._default.FoldRight$A));

axiom (forall $Heap: Heap, Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $reveal: bool, f#0: HandleType, xs#0: Seq, init#0: Box :: { $IsAllocBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0), Seq._default.FoldRight$A, $Heap) } (Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, xs#0, init#0) || ($Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A), $Heap) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FoldRight$T), $Heap) && $IsBox(init#0, Seq._default.FoldRight$A) && $IsAllocBox(init#0, Seq._default.FoldRight$A, $Heap))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, $reveal, f#0, xs#0, init#0), Seq._default.FoldRight$A, $Heap));

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, xs#0, init#0), $IsGoodHeap($Heap) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, xs#0, init#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Seq#Drop(xs#0, LitInt(1)), init#0)) && Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, xs#0, init#0) == (if Seq#Length(xs#0) == LitInt(0) then init#0 else Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, f#0, Seq#Index(xs#0, LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $ly, reveal_Seq._default.FoldRight, f#0, Seq#Drop(xs#0, LitInt(1)), init#0))));

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: {:weight 3} { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, Lit(xs#0), init#0), $IsGoodHeap($Heap) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Lit(xs#0), init#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, f#0, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), init#0)) && Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, f#0, Lit(xs#0), init#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, f#0, Seq#Index(Lit(xs#0), LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), reveal_Seq._default.FoldRight, f#0, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), init#0))));

axiom (forall Seq._default.FoldRight$A: Ty, Seq._default.FoldRight$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq, init#0: Box :: {:weight 3} { Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, Lit(f#0), Lit(xs#0), Lit(init#0)), $IsGoodHeap($Heap) } Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, Lit(f#0), Lit(xs#0), Lit(init#0)) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hTotalFunc2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A)) && $Is(xs#0, TSeq(Seq._default.FoldRight$T)) && $IsBox(init#0, Seq._default.FoldRight$A)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.FoldRight#canCall(Seq._default.FoldRight$A, Seq._default.FoldRight$T, Lit(f#0), Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(init#0))) && Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), true, Lit(f#0), Lit(xs#0), Lit(init#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then init#0 else Apply2(Seq._default.FoldRight$T, Seq._default.FoldRight$A, Seq._default.FoldRight$A, $Heap, Lit(f#0), Seq#Index(Lit(xs#0), LitInt(0)), Seq.__default.FoldRight(Seq._default.FoldRight$A, Seq._default.FoldRight$T, $LS($ly), reveal_Seq._default.FoldRight, Lit(f#0), Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(init#0)))));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#4: Box, xs#4: Seq, b#4: Box, b'#4: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#4), xs#4), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#4, b#4, b'#4)): bool } $IsBox(x#4, Seq._default.InvFoldRight$A) && $Is(xs#4, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#4, Seq._default.InvFoldRight$B) && $IsBox(b'#4, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#4), b#4)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#4, b#4, b'#4)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#4), xs#4)), b'#4)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#5: Box, xs#5: Seq, b#5: Box, b'#5: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#5), xs#5), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#5, b#5, b'#5)): bool } $IsBox(x#5, Seq._default.InvFoldRight$A) && $Is(xs#5, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#5, Seq._default.InvFoldRight$B) && $IsBox(b'#5, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#5), b#5)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#5, b#5, b'#5)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#5), xs#5)), b'#5)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $Is(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R), $Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R)), $Heap) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && $IsAlloc(xs#0, TSeq(Seq._default.FlatMap$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), TSeq(Seq._default.FlatMap$R), $Heap));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#10: int :: { Seq#Index(xs#0, i#10) } LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#10)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#10: int :: { Seq#Index(xs#0, i#10) } LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#10)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

const reveal_Unicode._default.IsInAssignedPlane: bool;

const unique class.Unicode.__default: ClassName;

function Unicode.__default.HIGH__SURROGATE__MIN() : bv24
uses {
axiom Unicode.__default.HIGH__SURROGATE__MIN(): bv24 == Lit(55296bv24);
axiom 1 < $FunctionContextHeight ==> $Is(Unicode.__default.HIGH__SURROGATE__MIN(), Tclass.Unicode.CodePoint());
}

procedure {:verboseName "Unicode.HIGH_SURROGATE_MIN (well-formedness)"} CheckWellFormed$$Unicode.__default.HIGH__SURROGATE__MIN();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.Unicode.CodePoint() : Ty
uses {
axiom Tag(Tclass.Unicode.CodePoint()) == Tagclass.Unicode.CodePoint && TagFamily(Tclass.Unicode.CodePoint()) == tytagFamily$CodePoint;
}

const unique Tagclass.Unicode.CodePoint: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Unicode.CodePoint()) } $IsBox(bx, Tclass.Unicode.CodePoint()) ==> $Box($Unbox(bx): bv24) == bx && $Is($Unbox(bx): bv24, Tclass.Unicode.CodePoint()));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.HIGH_SURROGATE_MIN (well-formedness)"} CheckWellFormed$$Unicode.__default.HIGH__SURROGATE__MIN()
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Unicode.HIGH_SURROGATE_MIN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(27,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(Lit(55296bv24), Tclass.Unicode.CodePoint());
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(Unicode.__default.HIGH__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.HIGH__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h));

function Unicode.__default.HIGH__SURROGATE__MAX() : bv24
uses {
axiom Unicode.__default.HIGH__SURROGATE__MAX(): bv24 == Lit(56319bv24);
axiom 1 < $FunctionContextHeight ==> $Is(Unicode.__default.HIGH__SURROGATE__MAX(), Tclass.Unicode.CodePoint());
}

procedure {:verboseName "Unicode.HIGH_SURROGATE_MAX (well-formedness)"} CheckWellFormed$$Unicode.__default.HIGH__SURROGATE__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.HIGH_SURROGATE_MAX (well-formedness)"} CheckWellFormed$$Unicode.__default.HIGH__SURROGATE__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Unicode.HIGH_SURROGATE_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(28,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(Lit(56319bv24), Tclass.Unicode.CodePoint());
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(Unicode.__default.HIGH__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.HIGH__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h));

function Unicode.__default.LOW__SURROGATE__MIN() : bv24
uses {
axiom Unicode.__default.LOW__SURROGATE__MIN(): bv24 == Lit(56320bv24);
axiom 1 < $FunctionContextHeight ==> $Is(Unicode.__default.LOW__SURROGATE__MIN(), Tclass.Unicode.CodePoint());
}

procedure {:verboseName "Unicode.LOW_SURROGATE_MIN (well-formedness)"} CheckWellFormed$$Unicode.__default.LOW__SURROGATE__MIN();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.LOW_SURROGATE_MIN (well-formedness)"} CheckWellFormed$$Unicode.__default.LOW__SURROGATE__MIN()
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Unicode.LOW_SURROGATE_MIN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(35,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(Lit(56320bv24), Tclass.Unicode.CodePoint());
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(Unicode.__default.LOW__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.LOW__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h));

function Unicode.__default.LOW__SURROGATE__MAX() : bv24
uses {
axiom Unicode.__default.LOW__SURROGATE__MAX(): bv24 == Lit(57343bv24);
axiom 1 < $FunctionContextHeight ==> $Is(Unicode.__default.LOW__SURROGATE__MAX(), Tclass.Unicode.CodePoint());
}

procedure {:verboseName "Unicode.LOW_SURROGATE_MAX (well-formedness)"} CheckWellFormed$$Unicode.__default.LOW__SURROGATE__MAX();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.LOW_SURROGATE_MAX (well-formedness)"} CheckWellFormed$$Unicode.__default.LOW__SURROGATE__MAX()
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Unicode.LOW_SURROGATE_MAX"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(36,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(Lit(57343bv24), Tclass.Unicode.CodePoint());
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(Unicode.__default.LOW__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.LOW__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h));

function Unicode.__default.ASSIGNED__PLANES() : Set
uses {
axiom Unicode.__default.ASSIGNED__PLANES(): Set == Lit(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(0bv8))), $Box(Lit(1bv8))), $Box(Lit(2bv8))), $Box(Lit(3bv8))), $Box(Lit(14bv8))), $Box(Lit(15bv8))), $Box(Lit(16bv8))));
axiom 0 < $FunctionContextHeight ==> $Is(Unicode.__default.ASSIGNED__PLANES(), TSet(TBitvector(8)));
}

procedure {:verboseName "Unicode.ASSIGNED_PLANES (well-formedness)"} CheckWellFormed$$Unicode.__default.ASSIGNED__PLANES();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(Unicode.__default.ASSIGNED__PLANES(), TSet(TBitvector(8)), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.ASSIGNED__PLANES(), TSet(TBitvector(8)), $h));

function Unicode.__default.IsInAssignedPlane($reveal: bool, i#0: bv24) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (1 < $FunctionContextHeight && le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#0 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#0)])));
axiom 1 <= $FunctionContextHeight ==> (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (1 < $FunctionContextHeight && le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#1 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#1)])));
}

function Unicode.__default.IsInAssignedPlane#canCall(i#0: bv24) : bool;

function Unicode.__default.IsInAssignedPlane#requires(bv24) : bool;

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane#requires(i#0) } le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24) ==> (Unicode.__default.IsInAssignedPlane#requires(i#0) <==> true));

procedure {:verboseName "Unicode.IsInAssignedPlane (well-formedness)"} CheckWellformed$$Unicode.__default.IsInAssignedPlane(i#0: bv24 where le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.IsInAssignedPlane (well-formedness)"} CheckWellformed$$Unicode.__default.IsInAssignedPlane(i#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var plane#Z#0: bv8;
  var let#0#0#0: bv8;
  var newtype$check#0: int;
  var newtype$check#1: bv24;

  anon0:
    assume {:print "Impl", " | ", "Unicode.IsInAssignedPlane", " | ", i#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(55,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    havoc plane#Z#0;
    assume true;
    newtype$check#0 := LitInt(16);
    assume 0 <= newtype$check#0 && newtype$check#0 < 32;
    assume le_bv5(16bv5, 24bv5);
    newtype$check#1 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24);
    assume lt_bv24(newtype$check#1, 256bv24);
    assume let#0#0#0 == RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume plane#Z#0 == let#0#0#0;
    assume Unicode.__default.IsInAssignedPlane(reveal_Unicode._default.IsInAssignedPlane, i#0) <==> Unicode.__default.ASSIGNED__PLANES()[$Box(plane#Z#0)];
    assume true;
    assume $Is(Unicode.__default.IsInAssignedPlane(reveal_Unicode._default.IsInAssignedPlane, i#0), TBool);
    return;
}



procedure {:verboseName "Unicode.reveal_IsInAssignedPlane (well-formedness)"} {:verify false} CheckWellFormed$$Unicode.__default.reveal__IsInAssignedPlane();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Unicode.reveal_IsInAssignedPlane (call precondtion)"} {:verify false} CallPre$$Unicode.__default.reveal__IsInAssignedPlane();



procedure {:verboseName "Unicode.reveal_IsInAssignedPlane (call postcondition)"} {:verify false} CallPost$$Unicode.__default.reveal__IsInAssignedPlane();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Unicode._default.IsInAssignedPlane;



procedure {:verboseName "Unicode.CodePoint (well-formedness)"} CheckWellFormed$$Unicode.CodePoint(i#0: bv24);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.CodePoint (well-formedness)"} CheckWellFormed$$Unicode.CodePoint(i#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Unicode.CodePoint", " | ", i#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(20,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(0bv24, i#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(0bv24, i#0);
    goto anon4;

  anon4:
    assume le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24);
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} le_bv24(0bv24, 0bv24);
    assume {:subsumption 0} le_bv24(0bv24, 1114111bv24);
    return;
}



axiom (forall i#0: bv24 :: { $Is(i#0, Tclass.Unicode.CodePoint()) } $Is(i#0, Tclass.Unicode.CodePoint()) <==> le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24));

axiom (forall i#0: bv24, $h: Heap :: { $IsAlloc(i#0, Tclass.Unicode.CodePoint(), $h) } $IsAlloc(i#0, Tclass.Unicode.CodePoint(), $h));

procedure {:verboseName "Unicode.HighSurrogateCodePoint (well-formedness)"} CheckWellFormed$$Unicode.HighSurrogateCodePoint(p#0: bv24 where le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.HighSurrogateCodePoint (well-formedness)"} CheckWellFormed$$Unicode.HighSurrogateCodePoint(p#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: bv24;

  anon0:
    assume {:print "Impl", " | ", "Unicode.HighSurrogateCodePoint", " | ", p#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(25,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(Unicode.__default.HIGH__SURROGATE__MIN(), p#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(Unicode.__default.HIGH__SURROGATE__MIN(), p#0);
    goto anon4;

  anon4:
    assume le_bv24(Unicode.__default.HIGH__SURROGATE__MIN(), p#0) && le_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MAX());
    return;

  anon6_Else:
    newtype$check#0 := Unicode.__default.HIGH__SURROGATE__MIN();
    assume le_bv24(0bv24, newtype$check#0) && le_bv24(newtype$check#0, 1114111bv24);
    assume true;
    assume {:subsumption 0} le_bv24(Unicode.__default.HIGH__SURROGATE__MIN(), Unicode.__default.HIGH__SURROGATE__MIN());
    assume {:subsumption 0} le_bv24(Unicode.__default.HIGH__SURROGATE__MIN(), Unicode.__default.HIGH__SURROGATE__MAX());
    return;
}



function Tclass.Unicode.HighSurrogateCodePoint() : Ty
uses {
axiom Tag(Tclass.Unicode.HighSurrogateCodePoint()) == Tagclass.Unicode.HighSurrogateCodePoint && TagFamily(Tclass.Unicode.HighSurrogateCodePoint()) == tytagFamily$HighSurrogateCodePoint;
}

const unique Tagclass.Unicode.HighSurrogateCodePoint: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Unicode.HighSurrogateCodePoint()) } $IsBox(bx, Tclass.Unicode.HighSurrogateCodePoint()) ==> $Box($Unbox(bx): bv24) == bx && $Is($Unbox(bx): bv24, Tclass.Unicode.HighSurrogateCodePoint()));

axiom (forall p#0: bv24 :: { $Is(p#0, Tclass.Unicode.HighSurrogateCodePoint()) } $Is(p#0, Tclass.Unicode.HighSurrogateCodePoint()) <==> le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24) && le_bv24(Unicode.__default.HIGH__SURROGATE__MIN(), p#0) && le_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MAX()));

axiom (forall p#0: bv24, $h: Heap :: { $IsAlloc(p#0, Tclass.Unicode.HighSurrogateCodePoint(), $h) } $IsAlloc(p#0, Tclass.Unicode.HighSurrogateCodePoint(), $h));

procedure {:verboseName "Unicode.LowSurrogateCodePoint (well-formedness)"} CheckWellFormed$$Unicode.LowSurrogateCodePoint(p#0: bv24 where le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.LowSurrogateCodePoint (well-formedness)"} CheckWellFormed$$Unicode.LowSurrogateCodePoint(p#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: bv24;

  anon0:
    assume {:print "Impl", " | ", "Unicode.LowSurrogateCodePoint", " | ", p#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(33,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(Unicode.__default.LOW__SURROGATE__MIN(), p#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(Unicode.__default.LOW__SURROGATE__MIN(), p#0);
    goto anon4;

  anon4:
    assume le_bv24(Unicode.__default.LOW__SURROGATE__MIN(), p#0) && le_bv24(p#0, Unicode.__default.LOW__SURROGATE__MAX());
    return;

  anon6_Else:
    newtype$check#0 := Unicode.__default.LOW__SURROGATE__MIN();
    assume le_bv24(0bv24, newtype$check#0) && le_bv24(newtype$check#0, 1114111bv24);
    assume true;
    assume {:subsumption 0} le_bv24(Unicode.__default.LOW__SURROGATE__MIN(), Unicode.__default.LOW__SURROGATE__MIN());
    assume {:subsumption 0} le_bv24(Unicode.__default.LOW__SURROGATE__MIN(), Unicode.__default.LOW__SURROGATE__MAX());
    return;
}



function Tclass.Unicode.LowSurrogateCodePoint() : Ty
uses {
axiom Tag(Tclass.Unicode.LowSurrogateCodePoint()) == Tagclass.Unicode.LowSurrogateCodePoint && TagFamily(Tclass.Unicode.LowSurrogateCodePoint()) == tytagFamily$LowSurrogateCodePoint;
}

const unique Tagclass.Unicode.LowSurrogateCodePoint: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Unicode.LowSurrogateCodePoint()) } $IsBox(bx, Tclass.Unicode.LowSurrogateCodePoint()) ==> $Box($Unbox(bx): bv24) == bx && $Is($Unbox(bx): bv24, Tclass.Unicode.LowSurrogateCodePoint()));

axiom (forall p#0: bv24 :: { $Is(p#0, Tclass.Unicode.LowSurrogateCodePoint()) } $Is(p#0, Tclass.Unicode.LowSurrogateCodePoint()) <==> le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24) && le_bv24(Unicode.__default.LOW__SURROGATE__MIN(), p#0) && le_bv24(p#0, Unicode.__default.LOW__SURROGATE__MAX()));

axiom (forall p#0: bv24, $h: Heap :: { $IsAlloc(p#0, Tclass.Unicode.LowSurrogateCodePoint(), $h) } $IsAlloc(p#0, Tclass.Unicode.LowSurrogateCodePoint(), $h));

procedure {:verboseName "Unicode.ScalarValue (well-formedness)"} CheckWellFormed$$Unicode.ScalarValue(p#0: bv24 where le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Unicode.ScalarValue (well-formedness)"} CheckWellFormed$$Unicode.ScalarValue(p#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: bv24;

  anon0:
    assume {:print "Impl", " | ", "Unicode.ScalarValue", " | ", p#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Unicode.dfy(41,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} !lt_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MIN());
    goto anon4;

  anon9_Else:
    assume {:partition} lt_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MIN());
    goto anon4;

  anon4:
    assume lt_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MAX());
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} !lt_bv24(p#0, Unicode.__default.LOW__SURROGATE__MIN());
    goto anon6;

  anon10_Else:
    assume {:partition} lt_bv24(p#0, Unicode.__default.LOW__SURROGATE__MIN());
    goto anon6;

  anon6:
    assume lt_bv24(p#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(p#0, Unicode.__default.LOW__SURROGATE__MAX());
    return;

  anon8_Else:
    newtype$check#0 := Lit(0bv24);
    assume le_bv24(0bv24, newtype$check#0) && le_bv24(newtype$check#0, 1114111bv24);
    assume true;
    assume {:subsumption 0} lt_bv24(0bv24, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(0bv24, Unicode.__default.HIGH__SURROGATE__MAX());
    assume {:subsumption 0} lt_bv24(0bv24, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(0bv24, Unicode.__default.LOW__SURROGATE__MAX());
    return;
}



function Tclass.Unicode.ScalarValue() : Ty
uses {
axiom Tag(Tclass.Unicode.ScalarValue()) == Tagclass.Unicode.ScalarValue && TagFamily(Tclass.Unicode.ScalarValue()) == tytagFamily$ScalarValue;
}

const unique Tagclass.Unicode.ScalarValue: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Unicode.ScalarValue()) } $IsBox(bx, Tclass.Unicode.ScalarValue()) ==> $Box($Unbox(bx): bv24) == bx && $Is($Unbox(bx): bv24, Tclass.Unicode.ScalarValue()));

axiom (forall p#0: bv24 :: { $Is(p#0, Tclass.Unicode.ScalarValue()) } $Is(p#0, Tclass.Unicode.ScalarValue()) <==> le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24) && (lt_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(p#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(p#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(p#0, Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall p#0: bv24, $h: Heap :: { $IsAlloc(p#0, Tclass.Unicode.ScalarValue(), $h) } $IsAlloc(p#0, Tclass.Unicode.ScalarValue(), $h));

procedure {:verboseName "Unicode.AssignedCodePoint (well-formedness)"} CheckWellFormed$$Unicode.AssignedCodePoint(p#0: bv24 where le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.Unicode.AssignedCodePoint() : Ty
uses {
axiom Tag(Tclass.Unicode.AssignedCodePoint()) == Tagclass.Unicode.AssignedCodePoint && TagFamily(Tclass.Unicode.AssignedCodePoint()) == tytagFamily$AssignedCodePoint;
}

const unique Tagclass.Unicode.AssignedCodePoint: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Unicode.AssignedCodePoint()) } $IsBox(bx, Tclass.Unicode.AssignedCodePoint()) ==> $Box($Unbox(bx): bv24) == bx && $Is($Unbox(bx): bv24, Tclass.Unicode.AssignedCodePoint()));

axiom (forall p#0: bv24 :: { $Is(p#0, Tclass.Unicode.AssignedCodePoint()) } $Is(p#0, Tclass.Unicode.AssignedCodePoint()) <==> le_bv24(0bv24, p#0) && le_bv24(p#0, 1114111bv24) && Unicode.__default.IsInAssignedPlane(reveal_Unicode._default.IsInAssignedPlane, p#0));

axiom (forall p#0: bv24, $h: Heap :: { $IsAlloc(p#0, Tclass.Unicode.AssignedCodePoint(), $h) } $IsAlloc(p#0, Tclass.Unicode.AssignedCodePoint(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#56 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#56))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#58 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#58)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#84 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#84))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#86 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#86)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#88 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#88)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#84 := Wrappers.Option.value(this); v#84)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#86 := Lit(Wrappers.Option.value(Lit(this))); v#86)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#88 := Lit(Wrappers.Option.value(Lit(this))); v#88)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#56 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#56)) else (var e#56 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#58 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#58))) else (var e#58 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#84 := Wrappers.Result.value(this); s#84) else (var e#84 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#86 := Lit(Wrappers.Result.value(Lit(this))); s#86) else (var e#86 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#88 := Lit(Wrappers.Result.value(Lit(this))); s#88) else (var e#88 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#84 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#84)) else (var e#84 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#84)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#86 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#86))) else (var e#86 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#86)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#88 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#88))) else (var e#88 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#88)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#10: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#10, x#10)): bool } $IsBox(x#10, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#10, x#10)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#11: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#11, x#11)): bool } $IsBox(x#11, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#11, x#11)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#10: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#10, x#10)): bool } $IsBox(x#10, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#10, x#10)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#11: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#11, x#11)): bool } $IsBox(x#11, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#11, x#11)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#10: Box, y#10: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#10, x#10)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#10, y#10)): bool } $IsBox(x#10, Relations._default.AntiSymmetric$T) && $IsBox(y#10, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#10, y#10)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#10, x#10)): bool ==> x#10 == y#10)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#11: Box, y#11: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#11, x#11)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#11, y#11)): bool } $IsBox(x#11, Relations._default.AntiSymmetric$T) && $IsBox(y#11, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#11, y#11)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#11, x#11)): bool ==> x#11 == y#11)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#10: Box, y#10: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#10, x#10)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#10, y#10)): bool } $IsBox(x#10, Relations._default.Symmetric$T) && $IsBox(y#10, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#10, y#10)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#10, x#10)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#11: Box, y#11: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#11, x#11)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#11, y#11)): bool } $IsBox(x#11, Relations._default.Symmetric$T) && $IsBox(y#11, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#11, y#11)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#11, x#11)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#10: Box, y#10: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#10, x#10)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#10, y#10)): bool } $IsBox(x#10, Relations._default.Connected$T) && $IsBox(y#10, Relations._default.Connected$T) ==> x#10 != y#10 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#10, y#10)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#10, x#10)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#11: Box, y#11: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#11, x#11)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#11, y#11)): bool } $IsBox(x#11, Relations._default.Connected$T) && $IsBox(y#11, Relations._default.Connected$T) ==> x#11 != y#11 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#11, y#11)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#11, x#11)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#10: Box, y#10: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#10, x#10)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#10, y#10)): bool } $IsBox(x#10, Relations._default.StronglyConnected$T) && $IsBox(y#10, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#10, y#10)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#10, x#10)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#11: Box, y#11: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#11, x#11)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#11, y#11)): bool } $IsBox(x#11, Relations._default.StronglyConnected$T) && $IsBox(y#11, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#11, y#11)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#11, x#11)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#10: Box, y#10: Box, z#10: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#10, z#10)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#10, z#10)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#10, z#10)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#10, y#10)): bool } $IsBox(x#10, Relations._default.Transitive$T) && $IsBox(y#10, Relations._default.Transitive$T) && $IsBox(z#10, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#10, y#10)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#10, z#10)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#10, z#10)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#11: Box, y#11: Box, z#11: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#11, z#11)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#11, z#11)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#11, z#11)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#11, y#11)): bool } $IsBox(x#11, Relations._default.Transitive$T) && $IsBox(y#11, Relations._default.Transitive$T) && $IsBox(z#11, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#11, y#11)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#11, z#11)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#11, z#11)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#14: int, j#14: int :: { Seq#Index(a#0, j#14), Seq#Index(a#0, i#14) } LitInt(0) <= i#14 && i#14 < j#14 && j#14 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#14), Seq#Index(a#0, j#14))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#15: int, j#15: int :: { Seq#Index(a#0, j#15), Seq#Index(a#0, i#15) } LitInt(0) <= i#15 && i#15 < j#15 && j#15 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#15), Seq#Index(Lit(a#0), j#15))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#16: int, j#16: int :: { Seq#Index(a#0, j#16), Seq#Index(a#0, i#16) } LitInt(0) <= i#16 && i#16 < j#16 && j#16 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#16), Seq#Index(Lit(a#0), j#16))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#14: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#14)): bool } { s#0[x#14] } $IsBox(x#14, Relations._default.IsLeast$T) && s#0[x#14] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#14)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#15: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#15)): bool } { s#0[x#15] } $IsBox(x#15, Relations._default.IsLeast$T) && Lit(s#0)[x#15] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#15)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#16: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#16)): bool } { s#0[x#16] } $IsBox(x#16, Relations._default.IsLeast$T) && Lit(s#0)[x#16] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#16)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#14: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#14)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#14, min#0)): bool } { s#0[x#14] } $IsBox(x#14, Relations._default.IsMinimal$T) && s#0[x#14] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#14, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#14)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#15: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#15)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#15, min#0)): bool } { s#0[x#15] } $IsBox(x#15, Relations._default.IsMinimal$T) && Lit(s#0)[x#15] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#15, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#15)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#16: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#16)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#16, min#0)): bool } { s#0[x#16] } $IsBox(x#16, Relations._default.IsMinimal$T) && Lit(s#0)[x#16] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#16, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#16)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#14: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#14, max#0)): bool } { s#0[x#14] } $IsBox(x#14, Relations._default.IsGreatest$T) && s#0[x#14] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#14, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#15: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#15, max#0)): bool } { s#0[x#15] } $IsBox(x#15, Relations._default.IsGreatest$T) && Lit(s#0)[x#15] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#15, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#16: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#16, max#0)): bool } { s#0[x#16] } $IsBox(x#16, Relations._default.IsGreatest$T) && Lit(s#0)[x#16] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#16, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#14: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#14, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#14)): bool } { s#0[x#14] } $IsBox(x#14, Relations._default.IsMaximal$T) && s#0[x#14] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#14)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#14, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#15: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#15, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#15)): bool } { s#0[x#15] } $IsBox(x#15, Relations._default.IsMaximal$T) && Lit(s#0)[x#15] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#15)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#15, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#16: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#16, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#16)): bool } { s#0[x#16] } $IsBox(x#16, Relations._default.IsMaximal$T) && Lit(s#0)[x#16] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#16)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#16, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#9 := Div(Seq#Length(a#0), LitInt(2)); (var left#9, right#9 := Seq#Take(a#0, splitIndex#9), Seq#Drop(a#0, splitIndex#9); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#9, lessThanOrEq#0) && (var leftSorted#9 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#9, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#9, lessThanOrEq#0) && (var rightSorted#9 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#9, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#9, rightSorted#9, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#9 := Div(Seq#Length(a#0), LitInt(2)); (var left#9, right#9 := Seq#Take(a#0, splitIndex#9), Seq#Drop(a#0, splitIndex#9); (var leftSorted#9 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#9, lessThanOrEq#0); (var rightSorted#9 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#9, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#9, rightSorted#9, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#10 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#10, right#10 := Seq#Take(Lit(a#0), splitIndex#10), Seq#Drop(Lit(a#0), splitIndex#10); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#10, lessThanOrEq#0) && (var leftSorted#10 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#10, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#10, lessThanOrEq#0) && (var rightSorted#10 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#10, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#10, rightSorted#10, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#10 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#10, right#10 := Seq#Take(Lit(a#0), splitIndex#10), Seq#Drop(Lit(a#0), splitIndex#10); (var leftSorted#10 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#10, lessThanOrEq#0); (var rightSorted#10 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#10, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#10, rightSorted#10, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#11 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#11, right#11 := Seq#Take(Lit(a#0), splitIndex#11), Seq#Drop(Lit(a#0), splitIndex#11); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#11, Lit(lessThanOrEq#0)) && (var leftSorted#11 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#11, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#11, Lit(lessThanOrEq#0)) && (var rightSorted#11 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#11, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#11, rightSorted#11, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#11 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#11, right#11 := Seq#Take(Lit(a#0), splitIndex#11), Seq#Drop(Lit(a#0), splitIndex#11); (var leftSorted#11 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#11, Lit(lessThanOrEq#0)); (var rightSorted#11 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#11, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#11, rightSorted#11, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#6: Box :: $IsBox($y#6, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#6)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#7: Box :: $IsBox($y#7, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#7)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#6: int, j#6: int :: { Seq#Index(xs#0, j#6), Seq#Index(xs#0, i#6) } LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && LitInt(0) <= j#6 && j#6 < Seq#Length(xs#0) && i#6 != j#6 ==> Seq#Index(xs#0, i#6) != Seq#Index(xs#0, j#6))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#7: int, j#7: int :: { Seq#Index(xs#0, j#7), Seq#Index(xs#0, i#7) } LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#7 && j#7 < Seq#Length(Lit(xs#0)) && i#7 != j#7 ==> Seq#Index(Lit(xs#0), i#7) != Seq#Index(Lit(xs#0), j#7))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#4: int :: { Seq#Index(xs#0, j#4) } LitInt(0) <= j#4 && j#4 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#4) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#4: int :: { Seq#Index(xs#0, j#4) } LitInt(0) <= j#4 && j#4 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#4) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#6 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#6) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#6)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#7 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#7) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#7)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#8 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#8) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#8)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#4: int :: { Seq#Index(xs#0, j#4) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#4 && j#4 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#4) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#4: int :: { Seq#Index(xs#0, j#4) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#4 && j#4 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#4) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#8: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#8), Seq#Index(xs#0, i#8) } LitInt(0) <= i#8 && i#8 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#8) == Seq#Index(xs#0, i#8)) && (forall i#9: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#9) } pos#0 <= i#9 && i#9 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#9) == Seq#Index(xs#0, i#9 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#6 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#6), Seq#Drop(xs#0, i#6 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#7 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#7), Seq#Drop(Lit(xs#0), i#7 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#8 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#8), Seq#Drop(Lit(xs#0), i#8 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#8: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#8), Seq#Index(xs#0, i#8) } LitInt(0) <= i#8 && i#8 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#8) == Seq#Index(xs#0, i#8)) && (forall i#9: int :: { Seq#Index(xs#0, i#9) } pos#0 <= i#9 && i#9 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#9 + 1) == Seq#Index(xs#0, i#9)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#4: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#4) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#4 - 1) } LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#4) == Seq#Index(xs#0, Seq#Length(xs#0) - i#4 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#4: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#4) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#4: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#4) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#4) } LitInt(0) <= i#4 && i#4 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#4), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#4)), $Unbox(Seq#Index(xs#0, i#4)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#4, b#4 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#4, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#4, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#5, b#5 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#5, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#5, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#4: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#4)): DatatypeType } LitInt(0) <= i#4 && i#4 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#4)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#4), Seq#Index(ys#0, i#4)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#4: int :: { Seq#Contains(xs#0, $Box(k#4)) } Seq#Contains(xs#0, $Box(k#4)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#4) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#4: int :: { Seq#Contains(xs#0, $Box(k#4)) } Seq#Contains(xs#0, $Box(k#4)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#4) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#19: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#19) } LitInt(0) <= i#19 && i#19 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#19) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#19))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#20)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#20)))) ==> (forall $l#9#i#0: int :: LitInt(0) <= $l#9#i#0 ==> $l#9#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#9#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#8#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#8#i#0): int))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#8#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#8#i#0): int))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: (exists i#21: int, o#10: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#8#heap#0, f#0, Seq#Index(xs#0, i#21))[$Box(o#10)] } $Is(o#10, Tclass._System.object?()) && LitInt(0) <= i#21 && i#21 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#8#heap#0, f#0, Seq#Index(xs#0, i#21))[$Box(o#10)] && $Box($l#8#o#0) == $Box(o#10))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#15: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#15) } { Seq#Index(xs#0, i#15) } (LitInt(0) <= i#15 && i#15 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#15))): DatatypeType)) && (LitInt(0) <= i#15 && i#15 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#15) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#15))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#16: int :: { Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#16)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#16: int :: { Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#16)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#2 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#2) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#2) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#2 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#2)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#2 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#2) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#2) else (var head#2 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#2); (var valueOrError1#2 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#2) else (var tail#2 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#2)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#2), tail#2)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#15: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#15) } LitInt(0) <= i#15 ==> i#15 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#15)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#15))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#16: int :: { Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#16)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#16: int :: { Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#16)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#6: Box, xs#6: Seq, b#6: Box, b'#6: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#6, x#6, b'#6)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#6), xs#6) } $IsBox(x#6, Seq._default.InvFoldLeft$A) && $Is(xs#6, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#6, Seq._default.InvFoldLeft$B) && $IsBox(b'#6, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#6, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#6), xs#6)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#6, x#6, b'#6)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#6, $Box(xs#6))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#7: Box, xs#7: Seq, b#7: Box, b'#7: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#7, x#7, b'#7)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#7), xs#7) } $IsBox(x#7, Seq._default.InvFoldLeft$A) && $Is(xs#7, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#7, Seq._default.InvFoldLeft$B) && $IsBox(b'#7, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#7, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#7), xs#7)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#7, x#7, b'#7)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#7, $Box(xs#7))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#6: Box, xs#6: Seq, b#6: Box, b'#6: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#6), xs#6), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#6, b#6, b'#6)): bool } $IsBox(x#6, Seq._default.InvFoldRight$A) && $Is(xs#6, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#6, Seq._default.InvFoldRight$B) && $IsBox(b'#6, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#6), b#6)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#6, b#6, b'#6)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#6), xs#6)), b'#6)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#7: Box, xs#7: Seq, b#7: Box, b'#7: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#7), xs#7), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#7, b#7, b'#7)): bool } $IsBox(x#7, Seq._default.InvFoldRight$A) && $Is(xs#7, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#7, Seq._default.InvFoldRight$B) && $IsBox(b'#7, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#7), b#7)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#7, b#7, b'#7)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#7), xs#7)), b'#7)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#11: int :: { Seq#Index(xs#0, i#11) } LitInt(0) <= i#11 && i#11 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#11)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#11: int :: { Seq#Index(xs#0, i#11) } LitInt(0) <= i#11 && i#11 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#11)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

const unique tytagFamily$CodePoint: TyTagFamily;

const unique tytagFamily$HighSurrogateCodePoint: TyTagFamily;

const unique tytagFamily$LowSurrogateCodePoint: TyTagFamily;

const unique tytagFamily$ScalarValue: TyTagFamily;

const unique tytagFamily$AssignedCodePoint: TyTagFamily;

const unique class.Functions.__default: ClassName;

function Functions.__default.Injective(Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $heap: Heap, f#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#1: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#1) } $IsBox(x#1, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#1))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#0: Box, x2#0: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#0), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#0) } $IsBox(x1#0, Functions._default.Injective$X) && $IsBox(x2#0, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#0) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#0) ==> x1#0 == x2#0)));
}

function Functions.__default.Injective#canCall(Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $heap: Heap, f#0: HandleType) : bool;

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $h0: Heap, $h1: Heap, f#0: HandleType :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $h1, f#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && (Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $h0, f#0) || $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && (exists _x0#0: Box, _obj#0: ref :: { Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $h0, f#0, _x0#0)[$Box(_obj#0)] } $IsBox(_x0#0, Functions._default.Injective$X) && $Is(_obj#0, Tclass._System.object?()) && Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $h0, f#0, _x0#0)[$Box(_obj#0)] && $Box($o) == $Box(_obj#0)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $h0, f#0) <==> Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $h1, f#0)));

function Functions.__default.Injective#requires(Ty, Ty, Heap, HandleType) : bool;

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#1: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#1) } $IsBox(x#1, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#1))));

procedure {:verboseName "Functions.Injective (well-formedness)"} CheckWellformed$$Functions.__default.Injective(Functions._default.Injective$X: Ty where $AlwaysAllocated(Functions._default.Injective$X), Functions._default.Injective$Y: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Reads1#Handle(#$T0: Ty, #$R: Ty, self: HandleType) : HandleType;

axiom (forall #$T0: Ty, #$R: Ty, $self: HandleType, $heap: Heap, $fh$0x#0: Box :: { Apply1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0) } Apply1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0) == $Box(Reads1(#$T0, #$R, $heap, $self, $fh$0x#0)));

axiom (forall #$T0: Ty, #$R: Ty, $self: HandleType, $heap: Heap, $fh$0x#0: Box :: { Requires1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0) } Requires1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0) <==> Requires1(#$T0, #$R, $heap, $self, $fh$0x#0));

axiom (forall $bx: Box, #$T0: Ty, #$R: Ty, $self: HandleType, $heap: Heap, $fh$0x#0: Box :: { Reads1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0)[$bx] } Requires1(#$T0, #$R, $heap, $self, $fh$0x#0) ==> (Reads1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0)[$bx] <==> Reads1(#$T0, #$R, $heap, $self, $fh$0x#0)[$bx]));

axiom (forall #$T0: Ty, #$R: Ty, $self: HandleType, $heap: Heap, $fh$0x#0: Box :: { Reads1(#$T0, #$R, $heap, $self, $fh$0x#0) } Reads1(#$T0, #$R, $heap, $self, $fh$0x#0) == $Unbox(Apply1(#$T0, TSet(Tclass._System.object?()), $heap, Reads1#Handle(#$T0, #$R, $self), $fh$0x#0)): Set);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Functions.Injective (well-formedness)"} CheckWellformed$$Functions.__default.Injective(Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, f#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#2: Box;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var _x0#1: Box;
  var _obj#1: ref;
  var b$reqreads#1: bool;
  var _x0#2: Box;
  var _obj#2: ref;
  var x1#1: Box;
  var x2#1: Box;

  anon0:
    assume {:print "Impl", " | ", "Functions.Injective", " | ", Functions._default.Injective$X, " | ", Functions._default.Injective$Y, " | ", f#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/Functions.dfy(17,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (exists _x0#0: Box, _obj#0: ref :: { Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, _x0#0)[$Box(_obj#0)] } $IsBox(_x0#0, Functions._default.Injective$X) && $Is(_obj#0, Tclass._System.object?()) && Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, _x0#0)[$Box(_obj#0)] && $Box($o) == $Box(_obj#0)));
    havoc x#2;
    assume $IsBox(x#2, Functions._default.Injective$X) && $IsAllocBox(x#2, Functions._default.Injective$X, $Heap);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(Functions._default.Injective$X, Functions._default.Injective$Y), $Heap);
    ##x0#0 := x#2;
    assume $IsAllocBox(##x0#0, Functions._default.Injective$X, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#2);
    assume Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#2);
    assume (forall x#0: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#0) } $IsBox(x#0, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#0));
    assume b$reqreads#0;
    havoc _x0#1;
    havoc _obj#1;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $IsBox(_x0#1, Functions._default.Injective$X) && $IsAllocBox(_x0#1, Functions._default.Injective$X, $Heap) && $Is(_obj#1, Tclass._System.object?()) && $IsAlloc(_obj#1, Tclass._System.object?(), $Heap);
    assume true;
    assume Requires1(Functions._default.Injective$X, TSet(Tclass._System.object?()), $Heap, Reads1#Handle(Functions._default.Injective$X, Functions._default.Injective$Y, f#0), _x0#1);
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Functions._default.Injective$X, TSet(Tclass._System.object?()), $Heap, Reads1#Handle(Functions._default.Injective$X, Functions._default.Injective$Y, f#0), _x0#1)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, _x0#1)[$Box(_obj#1)];
    goto anon4;

  anon14_Else:
    assume {:partition} !Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, _x0#1)[$Box(_obj#1)];
    goto anon4;

  anon13_Else:
    assume {:partition} !($IsBox(_x0#1, Functions._default.Injective$X) && $IsAllocBox(_x0#1, Functions._default.Injective$X, $Heap) && $Is(_obj#1, Tclass._System.object?()) && $IsAlloc(_obj#1, Tclass._System.object?(), $Heap));
    goto anon4;

  anon4:
    assume b$reqreads#1;
    havoc _x0#2;
    havoc _obj#2;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} $IsBox(_x0#2, Functions._default.Injective$X) && $IsAllocBox(_x0#2, Functions._default.Injective$X, $Heap) && $Is(_obj#2, Tclass._System.object?()) && $IsAlloc(_obj#2, Tclass._System.object?(), $Heap);
    assume true;
    assume Requires1(Functions._default.Injective$X, TSet(Tclass._System.object?()), $Heap, Reads1#Handle(Functions._default.Injective$X, Functions._default.Injective$Y, f#0), _x0#2);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, _x0#2)[$Box(_obj#2)];
    goto anon7;

  anon16_Else:
    assume {:partition} !Reads1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, _x0#2)[$Box(_obj#2)];
    goto anon7;

  anon15_Else:
    assume {:partition} !($IsBox(_x0#2, Functions._default.Injective$X) && $IsAllocBox(_x0#2, Functions._default.Injective$X, $Heap) && $Is(_obj#2, Tclass._System.object?()) && $IsAlloc(_obj#2, Tclass._System.object?(), $Heap));
    goto anon7;

  anon7:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume false;
    return;

  anon17_Else:
    havoc x1#1;
    havoc x2#1;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} $IsBox(x1#1, Functions._default.Injective$X) && $IsAllocBox(x1#1, Functions._default.Injective$X, $Heap) && $IsBox(x2#1, Functions._default.Injective$X) && $IsAllocBox(x2#1, Functions._default.Injective$X, $Heap);
    assume Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#1);
    assume Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#1);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#1) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#1);
    goto anon12;

  anon19_Else:
    assume {:partition} Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#1) != Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#1);
    goto anon12;

  anon18_Else:
    assume {:partition} !($IsBox(x1#1, Functions._default.Injective$X) && $IsAllocBox(x1#1, Functions._default.Injective$X, $Heap) && $IsBox(x2#1, Functions._default.Injective$X) && $IsAllocBox(x2#1, Functions._default.Injective$X, $Heap));
    goto anon12;

  anon12:
    assume Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#2: Box, x2#2: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#2), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#2) } $IsBox(x1#2, Functions._default.Injective$X) && $IsBox(x2#2, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#2) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#2) ==> x1#2 == x2#2);
    assume true;
    assume $Is(Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), TBool);
    return;
}



const unique class.UnicodeEncodingForm.__default: ClassName;

function UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly: LayerType, s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#0: int :: { Seq#Take(s#0, i#0) } 0 < i#0 && i#0 < Seq#Length(s#0) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#0))));
}

function UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(AsFuelBottom($ly), s#0) } UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) <==> UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LZ, s#0));

function Tclass.UnicodeEncodingForm.CodeUnit() : Ty;

function UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires($ly, s#0) } $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) ==> (UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires($ly, s#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.IsMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) returns (b#0: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7089"} b#0 ==> Seq#Length(s#0) > 0;
  free ensures {:id "id7090"} b#0 ==> (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#1)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.IsMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.IsMinimalWellFormedCodeUnitSubsequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(57,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume b#0;
    assume Seq#Length(s#0) > 0;
    havoc i#2;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} 0 < i#2;
    goto anon6;

  anon15_Else:
    assume {:partition} i#2 <= 0;
    goto anon6;

  anon6:
    assume 0 < i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, i#2);
    assume $IsAlloc(##s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#0) == Seq#Length(s#0);
    assume Seq#Take(s#0, i#2) == s#0 || Seq#Length(##s#0) < Seq#Length(s#0);
    assume Seq#Take(s#0, i#2) == s#0 || UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#2));
    assume !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2));
    goto anon8;

  anon14_Else:
    assume 0 < i#2 && i#2 < Seq#Length(s#0) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2));
    goto anon8;

  anon8:
    assume (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1)));
    goto anon10;

  anon13_Else:
    assume b#0 ==> Seq#Length(s#0) > 0 && (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1)));
    goto anon10;

  anon10:
    assume false;
    return;

  anon12_Else:
    assume false;
    return;
}



function UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#0: int :: { Seq#Take(s#0, i#0) } 0 < i#0 && i#0 <= Seq#Length(s#0) && UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#0))) <==> true && Wrappers.Option.Some_q(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(s#0) && Seq#Equal(prefix#0, Seq#Take(s#0, Seq#Length(prefix#0))) && (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(prefix#0) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1))))) && $Is(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { $IsAlloc(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap) } (UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
}

function UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0: Seq) : bool;

function Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq() : Ty
uses {
axiom Tag(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) == Tagclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq && TagFamily(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) == tytagFamily$MinimalWellFormedCodeUnitSeq;
}

const unique Tagclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) } $IsBox(bx, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));

function UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(s#0) } $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) ==> (UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(s#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) returns (maybePrefix#0: DatatypeType where $Is(maybePrefix#0, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7101"} Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
  free ensures {:id "id7102"} (exists i#2: int :: { Seq#Take(s#0, i#2) } 0 < i#2 && i#2 <= Seq#Length(s#0) && UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#2))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
  free ensures {:id "id7103"} Wrappers.Option.Some_q(maybePrefix#0) ==> Lit(true);
  free ensures {:id "id7104"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#1));
  free ensures {:id "id7105"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Length(prefix#1) <= Seq#Length(s#0));
  free ensures {:id "id7106"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))));
  free ensures {:id "id7107"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; (forall i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 < Seq#Length(prefix#1) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#3))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq) returns (maybePrefix#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#4: int;
  var ##s#0: Seq;
  var prefix#Z#0: Seq;
  var let#0#0#0: Seq;
  var i#5: int;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(67,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume $Is(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume Seq#Length(s#0) == LitInt(0);
    assume Wrappers.Option.None_q(maybePrefix#0);
    goto anon5;

  anon29_Else:
    assume Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
    goto anon5;

  anon5:
    havoc i#4;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} true;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} 0 < i#4;
    goto anon8;

  anon31_Else:
    assume {:partition} i#4 <= 0;
    goto anon8;

  anon8:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} 0 < i#4 && i#4 <= Seq#Length(s#0);
    assume 0 <= i#4 && i#4 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, i#4);
    assume $IsAlloc(##s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#4));
    goto anon10;

  anon32_Else:
    assume {:partition} !(0 < i#4 && i#4 <= Seq#Length(s#0));
    goto anon10;

  anon30_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} Lit(true);
    goto anon12;

  anon33_Else:
    assume {:partition} !Lit(true);
    goto anon12;

  anon12:
    assume (exists i#2: int :: { Seq#Take(s#0, i#2) } 0 < i#2 && i#2 <= Seq#Length(s#0) && UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume true;
    havoc prefix#Z#0;
    assume $Is(prefix#Z#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(maybePrefix#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume let#0#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume $Is(let#0#0#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#0 == let#0#0#0;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0);
    goto anon15;

  anon35_Else:
    assume {:partition} Seq#Length(prefix#Z#0) <= 0;
    goto anon15;

  anon15:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    assume 0 <= Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    goto anon17;

  anon36_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0));
    goto anon17;

  anon17:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#0, Seq#Take(s#0, Seq#Length(prefix#Z#0)));
    havoc i#5;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} 0 < i#5;
    goto anon21;

  anon39_Else:
    assume {:partition} i#5 <= 0;
    goto anon21;

  anon21:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} 0 < i#5 && i#5 < Seq#Length(prefix#Z#0);
    assume 0 <= i#5 && i#5 <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, i#5);
    assume $IsAlloc(##s#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#5));
    goto anon23;

  anon40_Else:
    assume {:partition} !(0 < i#5 && i#5 < Seq#Length(prefix#Z#0));
    goto anon23;

  anon38_Else:
    assume {:partition} false;
    goto anon23;

  anon23:
    goto anon24;

  anon37_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#0, Seq#Take(s#0, Seq#Length(prefix#Z#0))));
    goto anon24;

  anon24:
    assume (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#1) && Seq#Length(prefix#1) <= Seq#Length(s#0) && Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))) && (forall i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 < Seq#Length(prefix#1) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#3))));
    goto anon26;

  anon34_Else:
    assume Wrappers.Option.Some_q(maybePrefix#0) ==> true && (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#1) && Seq#Length(prefix#1) <= Seq#Length(s#0) && Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))) && (forall i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 < Seq#Length(prefix#1) ==> !UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#3))));
    goto anon26;

  anon26:
    assume false;
    return;

  anon28_Else:
    assume false;
    return;
}



function UnicodeEncodingForm.__default.EncodeScalarValue(v#0: bv24) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { UnicodeEncodingForm.__default.EncodeScalarValue(v#0) } UnicodeEncodingForm.__default.EncodeScalarValue#canCall(v#0) || (3 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> $Is(UnicodeEncodingForm.__default.EncodeScalarValue(v#0), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, v#0: bv24 :: { $IsAlloc(UnicodeEncodingForm.__default.EncodeScalarValue(v#0), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap) } (UnicodeEncodingForm.__default.EncodeScalarValue#canCall(v#0) || (3 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())))) && $IsGoodHeap($Heap) ==> $IsAlloc(UnicodeEncodingForm.__default.EncodeScalarValue(v#0), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
}

function UnicodeEncodingForm.__default.EncodeScalarValue#canCall(v#0: bv24) : bool;

function UnicodeEncodingForm.__default.EncodeScalarValue#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { UnicodeEncodingForm.__default.EncodeScalarValue#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (UnicodeEncodingForm.__default.EncodeScalarValue#requires(v#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.EncodeScalarValue (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.EncodeScalarValue(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq) : bv24
uses {
axiom 4 <= $FunctionContextHeight ==> (forall m#0: Seq :: { UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || (4 < $FunctionContextHeight && $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) ==> Seq#Equal(UnicodeEncodingForm.__default.EncodeScalarValue(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)), m#0) && le_bv24(0bv24, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
}

function UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0: Seq) : bool;

function UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(Seq) : bool;

axiom (forall m#0: Seq :: { UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(m#0) } $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(m#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7122"} Seq#Equal(UnicodeEncodingForm.__default.EncodeScalarValue(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(88,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume le_bv24(0bv24, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume UnicodeEncodingForm.__default.EncodeScalarValue#canCall(v#0);
    assume Seq#Equal(UnicodeEncodingForm.__default.EncodeScalarValue(v#0), m#0);
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap));



procedure {:verboseName "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0))) && UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id7125"} Wrappers.Option#Equal(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0)), #Wrappers.Option.Some($Box(m#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0))) && UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id7126"} Wrappers.Option#Equal(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0)), #Wrappers.Option.Some($Box(m#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ms#0: Seq where $Is(ms#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(ms#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
  var ##s#1: Seq;
  var defass#prefix#0: bool;
  var prefix#0: Seq where defass#prefix#0 ==> $Is(prefix#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var ##s#2: Seq;
  var ##s#0_1_0: Seq;
  var ##s#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(101,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    ms#0 := Seq#Append(m#0, s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(102,19)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(m#0) && Seq#Length(m#0) <= Seq#Length(ms#0);
    ##s#1 := Seq#Take(ms#0, Seq#Length(m#0));
    assume $IsAlloc(##s#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(ms#0, Seq#Length(m#0)));
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(ms#0, Seq#Length(m#0)));
    assume {:subsumption 0} UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(ms#0, Seq#Length(m#0)));
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(ms#0, Seq#Length(m#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(103,60)"} true;
    assume true;
    ##s#2 := ms#0;
    assume $IsAlloc(##s#2, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(ms#0);
    assume $IsAllocBox($Box(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0)), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(ms#0) && Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0))): Seq;
    defass#prefix#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(104,79)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##s#0_0 := m#0;
    assume $IsAlloc(##s#0_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume false;
    goto anon8;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##s#0_1_0 := m#0;
    assume $IsAlloc(##s#0_1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0);
    assume defass#prefix#0;
    assume true;
    assume {:subsumption 0} UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0) ==> Seq#Length(prefix#0) <= Seq#Length(m#0);
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume defass#prefix#0;
    assume true;
    assume Seq#Length(prefix#0) <= Seq#Length(m#0);
    assume defass#prefix#0;
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(ms#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(ms#0);
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(m#0);
    goto anon5;

  anon12_Else:
    assume {:partition} !Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    goto anon5;

  anon5:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0)));
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(m#0);
    goto anon7;

  anon13_Else:
    assume {:partition} !(Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0))));
    goto anon7;

  anon7:
    assume true;
    assume {:subsumption 0} Seq#Length(prefix#0) <= Seq#Length(m#0) ==> Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    assume {:subsumption 0} Seq#Length(prefix#0) <= Seq#Length(m#0) ==> Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0)));
    assume {:subsumption 0} Seq#Length(prefix#0) <= Seq#Length(m#0) ==> Seq#Equal(Seq#Take(m#0, Seq#Length(prefix#0)), m#0);
    assume false;
    goto anon8;

  anon11_Else:
    goto anon8;

  anon8:
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0) ==> Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(m#0, Seq#Length(prefix#0)), m#0);
    return;
}



function UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly: LayerType, s#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) } UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> (Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0)) ==> Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0))): Seq), s#0)) && $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, $ly: LayerType, s#0: Seq :: { $IsAlloc(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap) } (UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#0 := UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) && (Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#0)) && (!Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) && (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0)): Seq; UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#0))) && (var valueOrError1#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#0))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) && (Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0))))))) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#0 := UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) then Wrappers.Option.PropagateFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#0) else (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0)): Seq; (var valueOrError1#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#0))); (if Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) then Wrappers.Option.PropagateFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) else (var restParts#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), restParts#0)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#1 := UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)); Wrappers.Option.IsFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) && (Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#1)) && (!Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) && (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1)): Seq; UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#1))) && (var valueOrError1#1 := UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#1))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) && (Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1))))))) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#1 := UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)); (if Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) then Wrappers.Option.PropagateFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#1) else (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1)): Seq; (var valueOrError1#1 := UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#1))); (if Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) then Wrappers.Option.PropagateFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) else (var restParts#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#1)), restParts#1)))))))))));
}

function UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(AsFuelBottom($ly), s#0) } UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) == UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LZ, s#0));

function UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#requires($ly, s#0) } $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) ==> (UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#requires($ly, s#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7151"} Wrappers.Option.Some_q(maybeParts#0) ==> Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (maybeParts#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var prefix#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##s#1: Seq;
  var restParts#Z#0: Seq;
  var let#3#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(116,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume $IsAllocBox($Box(maybeParts#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybeParts#0);
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0);
    ##xs#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq);
    assume Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);
    goto anon5;

  anon15_Else:
    assume Wrappers.Option.Some_q(maybeParts#0) ==> Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Lit(#Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))));
    assume true;
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon16_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0);
    assume let#0#0#0 == UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Wrappers.Option.PropagateFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon17_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    havoc prefix#Z#0;
    assume $Is(prefix#Z#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume 0 <= Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(prefix#Z#0));
    assume $IsAlloc(##s#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#1) == Seq#Length(s#0);
    assume Seq#Length(##s#1) < Seq#Length(s#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume let#2#0#0 == UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume $Is(let#2#0#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume Wrappers.Option.IsFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError1#Z#0);
    assume Wrappers.Option.None_q(valueOrError1#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Wrappers.Option.PropagateFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon18_Else:
    assume {:partition} !Wrappers.Option.IsFailure(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    havoc restParts#Z#0;
    assume $Is(restParts#Z#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(restParts#Z#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError1#Z#0);
    assume Wrappers.Option.Some_q(valueOrError1#Z#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume restParts#Z#0 == let#3#0#0;
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#Z#0)), restParts#Z#0)));
    assume true;
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon13:
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == maybeParts#0;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (correctness)"} Impl$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns (defass#maybeParts#0: bool, maybeParts#0: DatatypeType where defass#maybeParts#0 ==> $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap), $_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeParts#0) && $IsA#Wrappers.Option(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id7176"} Wrappers.Option#Equal(maybeParts#0, UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (correctness)"} Impl$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (defass#maybeParts#0: bool, maybeParts#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var result#0: Seq where $Is(result#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(result#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var rest#0: Seq where $Is(rest#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(rest#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#maybeParts#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;
  var ##s#6: Seq;
  var $decr$loop#00: int;
  var defass#prefix#2: bool;
  var prefix#2: Seq where defass#prefix#2 ==> $Is(prefix#2, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#2, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var defass#valueOrError0#2: bool;
  var valueOrError0#2: DatatypeType where defass#valueOrError0#2 ==> $Is(valueOrError0#2, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#2, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(131,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    push;
    assume true;
    assume true;
    maybeParts#0 := Lit(#Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))));
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(133,21)"} true;
    assume defass#maybeParts#0;
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    pop;
    return;

  anon19_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    assume true;
    assume true;
    result#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(135,55)"} true;
    assume true;
    assume true;
    rest#0 := s#0;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(136,17)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#maybeParts#0 := defass#maybeParts#0;
    $decr_init$loop#00 := Seq#Length(rest#0) - 0;
    havoc $w$loop#0;
    goto anon20_LoopHead;

  anon20_LoopHead:
    assume $w$loop#0 ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume $w$loop#0 ==> (Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0)) <==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), rest#0)));
    assume $w$loop#0 ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0));
    assume $w$loop#0 ==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true);
    assume $w$loop#0 ==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Seq#Equal($Unbox(Wrappers.Option.value(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0))): Seq, Seq#Append(result#0, $Unbox(Wrappers.Option.value(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), rest#0))): Seq));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#maybeParts#0 ==> defass#maybeParts#0;
    assume Seq#Length(rest#0) - 0 <= $decr_init$loop#00;
    goto anon20_LoopDone, anon20_LoopBody;

  anon20_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(137,4): after some loop iterations"} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} !$w$loop#0;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    ##s#3 := rest#0;
    assume $IsAlloc(##s#3, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) <==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0));
    ##s#4 := s#0;
    assume $IsAlloc(##s#4, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Lit(true);
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    ##s#6 := rest#0;
    assume $IsAlloc(##s#6, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0));
    goto anon9;

  anon23_Else:
    assume {:partition} !Lit(true);
    goto anon9;

  anon22_Else:
    assume {:partition} !Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    goto anon9;

  anon9:
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0));
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> true && Seq#Equal($Unbox(Wrappers.Option.value(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq, Seq#Append(result#0, $Unbox(Wrappers.Option.value(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0))): Seq));
    assume true;
    assume false;
    goto anon10;

  anon21_Else:
    assume {:partition} $w$loop#0;
    goto anon10;

  anon10:
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} 0 >= Seq#Length(rest#0);
    goto anon17;

  anon24_Else:
    assume {:partition} Seq#Length(rest#0) > 0;
    $decr$loop#00 := Seq#Length(rest#0) - 0;
    push;
    havoc valueOrError0#2 /* where defass#valueOrError0#2 ==> $Is(valueOrError0#2, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#2, Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap) */;
    assume true;
    ##s#7 := rest#0;
    assume $IsAlloc(##s#7, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(rest#0);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(rest#0);
    valueOrError0#2 := UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(rest#0);
    defass#valueOrError0#2 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(145,73)"} true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume Wrappers.Option.IsFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    push;
    assume true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#2);
    assume Wrappers.Option.None_q(valueOrError0#2);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    maybeParts#0 := Wrappers.Option.PropagateFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(145,73)"} true;
    assume defass#maybeParts#0;
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    pop;
    pop;
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#2);
    assume Wrappers.Option.Some_q(valueOrError0#2);
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume Wrappers.Option.Extract#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2)): Seq;
    defass#prefix#2 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(145,73)"} true;
    assume true;
    assume defass#prefix#2;
    assume true;
    result#0 := Seq#Append(result#0, Seq#Build(Seq#Empty(): Seq, $Box(prefix#2)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(146,33)"} true;
    assume true;
    assume defass#prefix#2;
    assume 0 <= Seq#Length(prefix#2) && Seq#Length(prefix#2) <= Seq#Length(rest#0);
    assume true;
    rest#0 := Seq#Drop(rest#0, Seq#Length(prefix#2));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(147,30)"} true;
    pop;
    assume 0 <= $decr$loop#00 || Seq#Length(rest#0) - 0 == $decr$loop#00;
    assume Seq#Length(rest#0) - 0 < $decr$loop#00;
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0) && ((Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) <==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0))) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0)));
    goto anon20_LoopHead;

  anon20_LoopDone:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume true;
    assume Seq#Equal(Seq#Append(result#0, Seq#Empty(): Seq), result#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(149,32)"} true;
    assume true;
    assume true;
    maybeParts#0 := #Wrappers.Option.Some($Box(result#0));
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(150,23)"} true;
    assume defass#maybeParts#0;
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    return;
}



function UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq) : Seq
uses {
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0) } UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) ==> Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0)), s#0) && $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
axiom 8 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { $IsAlloc(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap) } (UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0) } UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq);
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UnicodeEncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) } UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) || (8 < $FunctionContextHeight && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))) && UnicodeEncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) == Lit($Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0))))): Seq));
}

function UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0: Seq) : bool;

function Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq() : Ty
uses {
axiom Tag(Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) == Tagclass.UnicodeEncodingForm.WellFormedCodeUnitSeq && TagFamily(Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) == tytagFamily$WellFormedCodeUnitSeq;
}

const unique Tagclass.UnicodeEncodingForm.WellFormedCodeUnitSeq: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) } $IsBox(bx, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()));

function UnicodeEncodingForm.__default.PartitionCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UnicodeEncodingForm.__default.PartitionCodeUnitSequence#requires(s#0) } $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) ==> (UnicodeEncodingForm.__default.PartitionCodeUnitSequence#requires(s#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) returns (parts#0: Seq where $Is(parts#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7208"} Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), parts#0), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq) returns (parts#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.PartitionCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(157,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#0);
    assume Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), parts#0), s#0);
    assume false;
    return;

  anon4_Else:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume $IsAllocBox($Box(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)), Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq;
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume $Is(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0) == parts#0;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0)) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
  free ensures {:id "id7214"} Wrappers.Option#Equal(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0)) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
  free ensures {:id "id7215"} Wrappers.Option#Equal(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var m##0: Seq;
  var s##0: Seq;
  var ##s#0_0_0: Seq;
  var ##s#0_0_1: Seq;
  var ##s#0_1_0: Seq;
  var ##s#1_1_0: Seq;
  var ##s#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(169,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#m0#0: Seq :: $Is($ih#m0#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && Lit(true) && Seq#Rank($ih#m0#0) < Seq#Rank(m#0) ==> Wrappers.Option#Equal(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), $ih#m0#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box($ih#m0#0))))));
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    assume true;
    s##0 := Lit(Seq#Empty(): Seq);
    call CallPre$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##0, s##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##0, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(170,77)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume true;
    assume false;
    goto anon4;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    push;
    pop;
    ##s#0_1_0 := Seq#Append(m#0, Seq#Empty(): Seq);
    assume $IsAlloc(##s#0_1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume {:subsumption 0} Wrappers.Option#Equal(#Wrappers.Option.Some($Box(m#0)), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, Seq#Empty(): Seq)));
    assume false;
    goto anon4;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##s#0_0_0 := Seq#Append(m#0, Seq#Empty(): Seq);
    assume $IsAlloc(##s#0_0_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    push;
    push;
    assume true;
    assume Seq#Equal(Seq#Append(m#0, Seq#Empty(): Seq), m#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(174,26)"} true;
    pop;
    pop;
    ##s#0_0_1 := m#0;
    assume $IsAlloc(##s#0_0_1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume {:subsumption 0} Wrappers.Option#Equal(UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, Seq#Empty(): Seq)), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(m#0));
    assume false;
    goto anon4;

  anon11_Else:
    goto anon4;

  anon4:
    assume Wrappers.Option#Equal(#Wrappers.Option.Some($Box(m#0)), UnicodeEncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(m#0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##s#1_0 := m#0;
    assume $IsAlloc(##s#1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##s#1_1_0 := m#0;
    assume $IsAlloc(##s#1_1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume true;
    assume {:subsumption 0} Wrappers.Option#Equal(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(m#0)), Seq#Empty(): Seq))));
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume true;
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(m#0)), Seq#Empty(): Seq), Seq#Build(Seq#Empty(): Seq, $Box(m#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(180,30)"} true;
    assume true;
    assume {:subsumption 0} Wrappers.Option#Equal(#Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(m#0)), Seq#Empty(): Seq))), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
    assume false;
    goto anon8;

  anon14_Else:
    goto anon8;

  anon8:
    assume Wrappers.Option#Equal(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
    return;
}



function UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) } UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) <==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))));
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) } UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && (UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) <==> Lit(Wrappers.Option.Some_q(Lit(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))))));
}

function UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0: Seq) : bool;

function UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) ==> (UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#requires(s#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.IsWellFormedCodeUnitSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) returns (b#0: bool);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0);
  free ensures {:id "id7229"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(m#0) && Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0);
  free ensures {:id "id7230"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(m#0) || Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(198,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(199,57)"} true;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id7234"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0)) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(m#0, s#0)) && Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(m#0, s#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id7235"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0)) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(m#0, s#0)) || Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(m#0, s#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m##0: Seq;
  var m##1: Seq;
  var s##0: Seq;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(208,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(209,57)"} true;
    assume true;
    m##1 := m#0;
    assume true;
    s##0 := s#0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##1, s##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##1, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(210,76)"} true;
    ##s#1 := Seq#Append(m#0, s#0);
    assume $IsAlloc(##s#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Append(m#0, s#0));
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Append(m#0, s#0));
    assume {:subsumption 0} Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(m#0, s#0)));
    assume Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(m#0, s#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(211,56)"} true;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));



procedure {:verboseName "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#0) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0));
  free ensures {:id "id7243"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)) && Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap)) returns ($_reverifyPost: bool);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#0) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0));
  free ensures {:id "id7244"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)) || Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), ms#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##xs#0_0: Seq;
  var ##s#0_0: Seq;
  var head#1_0: Seq where $Is(head#1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(head#1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
  var tail#1_0: Seq where $Is(tail#1_0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(tail#1_0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ms##1_0: Seq;
  var flatTail#1_0: Seq where $Is(flatTail#1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(flatTail#1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
  var ##xs#1_0: Seq;
  var m##1_0: Seq;
  var s##1_0: Seq;
  var ##s#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences", " | ", ms#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(219,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#ms0#0: Seq :: $Is($ih#ms0#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && Lit(true) && Seq#Rank($ih#ms0#0) < Seq#Rank(ms#0) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), $ih#ms0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(ms#0) == LitInt(0);
    ##xs#0_0 := ms#0;
    assume $IsAlloc(##xs#0_0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#0);
    ##s#0_0 := Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0);
    assume $IsAlloc(##s#0_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0));
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#0) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0));
    assume {:subsumption 0} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)) || Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), ms#0)));
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(221,58)"} true;
    return;

  anon3_Else:
    assume {:partition} Seq#Length(ms#0) != LitInt(0);
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ms#0);
    assume true;
    head#1_0 := $Unbox(Seq#Index(ms#0, LitInt(0))): Seq;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(224,23)"} true;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(ms#0);
    assume true;
    tail#1_0 := Seq#Drop(ms#0, LitInt(1));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(225,25)"} true;
    assume true;
    ms##1_0 := tail#1_0;
    assume Seq#Rank(ms##1_0) < Seq#Rank(ms#0);
    call CallPre$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##1_0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(226,61)"} true;
    assume true;
    ##xs#1_0 := tail#1_0;
    assume $IsAlloc(##xs#1_0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), tail#1_0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), tail#1_0);
    flatTail#1_0 := Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), tail#1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(227,39)"} true;
    assume true;
    assume $Is(head#1_0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq());
    m##1_0 := head#1_0;
    assume true;
    assume $Is(flatTail#1_0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    s##1_0 := flatTail#1_0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##1_0, s##1_0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##1_0, s##1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(228,70)"} true;
    ##s#1_0 := Seq#Append(head#1_0, flatTail#1_0);
    assume $IsAlloc(##s#1_0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0));
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0));
    assume {:subsumption 0} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0)) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(head#1_0, flatTail#1_0)) || Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(head#1_0, flatTail#1_0)));
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(head#1_0, flatTail#1_0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(229,58)"} true;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id7262"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0)) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(s#0, t#0)) && Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id7263"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0)) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(s#0, t#0)) || Wrappers.Option.Some_q(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (correctness)"} Impl$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq, t#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var partsS#0: Seq where $Is(partsS#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsS#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#1: Seq;
  var partsT#0: Seq where $Is(partsT#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsT#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#2: Seq;
  var partsST#0: Seq where $Is(partsST#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsST#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var xs##0: Seq;
  var ys##0: Seq;
  var ##xs#0: Seq;
  var part#0: Seq;
  var ##s#3: Seq;
  var ms##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(238,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    partsS#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(239,46)"} true;
    assume true;
    ##s#2 := t#0;
    assume $IsAlloc(##s#2, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(t#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(t#0);
    partsT#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequence(t#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(240,46)"} true;
    assume true;
    assume true;
    partsST#0 := Seq#Append(partsS#0, partsT#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(241,34)"} true;
    assume true;
    xs##0 := partsS#0;
    assume true;
    ys##0 := partsT#0;
    call CallPre$$Seq.__default.LemmaFlattenConcat(Tclass.UnicodeEncodingForm.CodeUnit(), xs##0, ys##0);
    call CallPost$$Seq.__default.LemmaFlattenConcat(Tclass.UnicodeEncodingForm.CodeUnit(), xs##0, ys##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(242,42)"} true;
    ##xs#0 := partsST#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), partsST#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), partsST#0);
    assume {:subsumption 0} Seq#Equal(Seq#Append(s#0, t#0), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), partsST#0));
    assume Seq#Equal(Seq#Append(s#0, t#0), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), partsST#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(244,40)"} true;
    havoc part#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} $Is(part#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(part#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Seq#Contains(partsST#0, $Box(part#0));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(part#0) > 0;
    ##s#3 := part#0;
    assume $IsAlloc(##s#3, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(part#0);
    goto anon4;

  anon7_Else:
    assume {:partition} 0 >= Seq#Length(part#0);
    goto anon4;

  anon6_Else:
    assume {:partition} !Seq#Contains(partsST#0, $Box(part#0));
    goto anon4;

  anon5_Else:
    assume {:partition} !($Is(part#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(part#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap));
    goto anon4;

  anon4:
    assume (forall part#1: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) ==> Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 ==> UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(part#1));
    assume {:subsumption 0} (forall part#1: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 && UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), part#1));
    assume (forall part#1: Seq :: { UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 && UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(247,55)"} true;
    assume true;
    ms##0 := partsST#0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(248,62)"} true;
    return;
}



function UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq) : Seq
uses {
axiom 10 <= $FunctionContextHeight ==> (forall vs#0: Seq :: { UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0) } UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (10 < $FunctionContextHeight && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> $Is(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()));
axiom 10 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: { $IsAlloc(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap) } (UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (10 < $FunctionContextHeight && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
axiom 10 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: { UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (10 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#0 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#0)) && UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#0 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#0)));
axiom 10 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { UnicodeEncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || (10 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#1)) && UnicodeEncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#1)));
}

function UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0: Seq) : bool;

function UnicodeEncodingForm.__default.EncodeScalarSequence#requires(Seq) : bool;

axiom (forall $Heap: Heap, vs#0: Seq :: { UnicodeEncodingForm.__default.EncodeScalarSequence#requires(vs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) ==> (UnicodeEncodingForm.__default.EncodeScalarSequence#requires(vs#0) <==> true));

function UnicodeEncodingForm.__default.EncodeScalarValue#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) == $Box(UnicodeEncodingForm.__default.EncodeScalarValue($Unbox($fh$0x#0): bv24)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) <==> UnicodeEncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$0x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: bv24 :: { UnicodeEncodingForm.__default.EncodeScalarValue($fh$0x#0), $IsGoodHeap($heap) } UnicodeEncodingForm.__default.EncodeScalarValue($fh$0x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) returns (s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ms#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ms##0: Seq;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(254,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    assume false;
    return;

  anon4_Else:
    havoc ms#Z#0;
    assume $Is(ms#Z#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#Z#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume 3 != $FunctionContextHeight;
    ##f#0 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0 := vs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): bv24 } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): bv24 } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume let#0#0#0 == Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $Is(let#0#0#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume ms#Z#0 == let#0#0#0;
    assume true;
    ms##0 := ms#Z#0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(257,56)"} true;
    ##xs#1 := ms#Z#0;
    assume $IsAlloc(##xs#1, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#Z#0);
    assume $Is(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#Z#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    assume UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0) == Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), ms#Z#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), ms#Z#0);
    assume $Is(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    assume UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0) == s#0;
    assume b$reqreads#0;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (correctness)"} Impl$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (defass#s#0: bool, s#0: Seq where defass#s#0 ==> $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap), $_reverifyPost: bool);
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
  free ensures {:id "id7285"} Seq#Equal(s#0, UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (correctness)"} Impl$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (defass#s#0: bool, s#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var unflattened#0: Seq where $Is(unflattened#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(unflattened#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#s#0: bool;
  var $w$loop#0: bool;
  var ##f#1: HandleType;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var defass#next#0: bool;
  var next#0: Seq where defass#next#0 ==> $Is(next#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(next#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var ##v#0: bv24;
  var m##0: Seq;
  var s##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(260,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    s#0 := Lit(Seq#Empty(): Seq);
    defass#s#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(265,11)"} true;
    assume true;
    assume true;
    unflattened#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(266,66)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(vs#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#hi;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#s#0 := defass#s#0;
    havoc $w$loop#0;
    goto anon7_LoopHead;

  anon7_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume $w$loop#0 ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume $w$loop#0 ==> Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)));
    assume $w$loop#0 ==> Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), unflattened#0);
    assume $w$loop#0 ==> Seq#Equal(s#0, Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), unflattened#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#s#0 ==> defass#s#0;
    assume true;
    goto anon7_LoopDone, anon7_LoopBody;

  anon7_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(267,4): after some loop iterations"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} !$w$loop#0;
    assume 3 != $FunctionContextHeight;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(vs#0);
    ##f#1 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#2 := Seq#Drop(vs#0, i#2);
    assume $IsAlloc(##xs#2, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##xs#2, i#3)): bv24 } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#2) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#1, Seq#Index(##xs#2, i#3)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)));
    assume defass#s#0;
    ##xs#3 := unflattened#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), unflattened#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), unflattened#0);
    assume Seq#Equal(s#0, Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LZ), unflattened#0));
    assume false;
    goto anon3;

  anon8_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} i#2 == i#2#lo;
    goto anon6;

  anon9_Else:
    assume {:partition} i#2 != i#2#lo;
    i#2 := i#2 - 1;
    assume true;
    assume 0 <= i#2 && i#2 < Seq#Length(vs#0);
    ##v#0 := $Unbox(Seq#Index(vs#0, i#2)): bv24;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume UnicodeEncodingForm.__default.EncodeScalarValue#canCall($Unbox(Seq#Index(vs#0, i#2)): bv24);
    assume UnicodeEncodingForm.__default.EncodeScalarValue#canCall($Unbox(Seq#Index(vs#0, i#2)): bv24);
    next#0 := UnicodeEncodingForm.__default.EncodeScalarValue($Unbox(Seq#Index(vs#0, i#2)): bv24);
    defass#next#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(271,72)"} true;
    assume true;
    assume defass#next#0;
    assume true;
    unflattened#0 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(next#0)), unflattened#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(272,41)"} true;
    assume defass#next#0;
    assume true;
    m##0 := next#0;
    assume defass#s#0;
    assume true;
    s##0 := s#0;
    call CallPre$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##0, s##0);
    call CallPost$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##0, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(273,63)"} true;
    assume true;
    assume defass#next#0;
    assume defass#s#0;
    assume true;
    assume $Is(Seq#Append(next#0, s#0), Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    s#0 := Seq#Append(next#0, s#0);
    defass#s#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(274,19)"} true;
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)) && (Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2))) ==> Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), unflattened#0));
    goto anon7_LoopHead;

  anon7_LoopDone:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume defass#s#0;
    assume UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    return;
}



function UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq) : Seq
uses {
axiom 11 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0) } UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || (11 < $FunctionContextHeight && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) ==> Seq#Equal(UnicodeEncodingForm.__default.EncodeScalarSequence(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0)), s#0) && $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue())));
axiom 11 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || (11 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0)) && UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#0 := Seq.__default.Map(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0); vs#0)));
axiom 11 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeEncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || (11 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) ==> UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#1 := Lit(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#1)) && UnicodeEncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#1 := Lit(UnicodeEncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#1 := Seq.__default.Map(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#1); vs#1)));
}

function UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0: Seq) : bool;

function UnicodeEncodingForm.__default.DecodeCodeUnitSequence#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeEncodingForm.__default.DecodeCodeUnitSequence#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) ==> (UnicodeEncodingForm.__default.DecodeCodeUnitSequence#requires(s#0) <==> true));

function UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) } Apply1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) == $Box(UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$0x#0): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) } Requires1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) <==> UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$0x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq :: { UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$0x#0), $IsGoodHeap($heap) } UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$0x#0) == $Unbox(Apply1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$0x#0))): bv24);

procedure {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq())) returns (vs#2: Seq where $Is(vs#2, TSeq(Tclass.Unicode.ScalarValue())));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7311"} Seq#Equal(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#2), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequence (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq) returns (vs#2: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##vs#0: Seq;
  var parts#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##s#0: Seq;
  var vs#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#0_0_0: HandleType;
  var ##xs#0_0_0: Seq;
  var ##xs#0_0_1: Seq;
  var ##vs#0_0_0: Seq;
  var ##xs#0_1_0: Seq;
  var ##f#0_1_0: HandleType;
  var ##xs#0_1_1: Seq;
  var ##f#0_1_1: HandleType;
  var ##xs#0_1_2: Seq;
  var ##xs#0_1_3: Seq;
  var ##xs#0_2_0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.DecodeCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(281,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue()));
    ##vs#0 := vs#2;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#2);
    assume Seq#Equal(UnicodeEncodingForm.__default.EncodeScalarSequence(vs#2), s#0);
    assume false;
    return;

  anon9_Else:
    havoc parts#Z#0;
    assume $Is(parts#Z#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(parts#Z#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume let#0#0#0 == UnicodeEncodingForm.__default.PartitionCodeUnitSequence(s#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume $Is(let#0#0#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume parts#Z#0 == let#0#0#0;
    havoc vs#Z#0;
    assume $Is(vs#Z#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#Z#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume 4 != $FunctionContextHeight;
    ##f#0 := UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue()), $Heap);
    ##xs#0 := parts#Z#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume let#1#0#0 == Seq.__default.Map(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume Seq.__default.Map#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.Unicode.ScalarValue()));
    assume vs#Z#0 == let#1#0#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume true;
    ##xs#0_2_0 := parts#Z#0;
    assume $IsAlloc(##xs#0_2_0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#Z#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#Z#0);
    assume {:subsumption 0} Seq#Equal(s#0, Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), parts#Z#0));
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##xs#0_1_0 := parts#Z#0;
    assume $IsAlloc(##xs#0_1_0, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#Z#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#Z#0);
    assume 3 != $FunctionContextHeight;
    ##f#0_1_0 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_1_0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_1_1 := vs#Z#0;
    assume $IsAlloc(##xs#0_1_1, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_1_0: int :: { $Unbox(Seq#Index(##xs#0_1_1, i#0_1_0)): bv24 } LitInt(0) <= i#0_1_0 && i#0_1_0 < Seq#Length(##xs#0_1_1) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_0)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_1_1: int, o#0_1_0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_1))[$Box(o#0_1_0)] } $Is(o#0_1_0, Tclass._System.object?()) && LitInt(0) <= i#0_1_1 && i#0_1_1 < Seq#Length(##xs#0_1_1) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_1))[$Box(o#0_1_0)] && $Box($o) == $Box(o#0_1_0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume Seq#Equal(parts#Z#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(289,54)"} true;
    assume 3 != $FunctionContextHeight;
    ##f#0_1_1 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_1_1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_1_2 := vs#Z#0;
    assume $IsAlloc(##xs#0_1_2, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_1_2: int :: { $Unbox(Seq#Index(##xs#0_1_2, i#0_1_2)): bv24 } LitInt(0) <= i#0_1_2 && i#0_1_2 < Seq#Length(##xs#0_1_2) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_2)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_1_3: int, o#0_1_1: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_3))[$Box(o#0_1_1)] } $Is(o#0_1_1, Tclass._System.object?()) && LitInt(0) <= i#0_1_3 && i#0_1_3 < Seq#Length(##xs#0_1_2) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_3))[$Box(o#0_1_1)] && $Box($o) == $Box(o#0_1_1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    ##xs#0_1_3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume $IsAlloc(##xs#0_1_3, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0) && Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume {:subsumption 0} Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), parts#Z#0), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0)));
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume 3 != $FunctionContextHeight;
    ##f#0_0_0 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_0_0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_0_0 := vs#Z#0;
    assume $IsAlloc(##xs#0_0_0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_0_0: int :: { $Unbox(Seq#Index(##xs#0_0_0, i#0_0_0)): bv24 } LitInt(0) <= i#0_0_0 && i#0_0_0 < Seq#Length(##xs#0_0_0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_0)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_0_1: int, o#0_0_0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_1))[$Box(o#0_0_0)] } $Is(o#0_0_0, Tclass._System.object?()) && LitInt(0) <= i#0_0_1 && i#0_0_1 < Seq#Length(##xs#0_0_0) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_1))[$Box(o#0_0_0)] && $Box($o) == $Box(o#0_0_0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    ##xs#0_0_1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume $IsAlloc(##xs#0_0_1, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0) && Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    ##vs#0_0_0 := vs#Z#0;
    assume $IsAlloc(##vs#0_0_0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#Z#0);
    assume UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#Z#0);
    assume {:subsumption 0} Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0)), UnicodeEncodingForm.__default.EncodeScalarSequence(vs#Z#0));
    assume false;
    goto anon8;

  anon13_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(s#0, UnicodeEncodingForm.__default.EncodeScalarSequence(vs#Z#0));
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0) == vs#Z#0;
    assume true;
    assume $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue()));
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0) == vs#2;
    assume b$reqreads#0;
    return;
}



function UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) : DatatypeType
uses {
axiom 12 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || (12 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> (UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))): Seq, UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0))) && (!UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))) && $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));
axiom 12 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || (12 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) && (UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0)) && UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == (if UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) then #Wrappers.Option.Some($Box(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0))) else #Wrappers.Option.None()));
axiom 12 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) } UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(Lit(s#0)) || (12 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) ==> UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) && (Lit(UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0))) ==> UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0))) && UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) == (if UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) then #Wrappers.Option.Some($Box(Lit(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0))))) else #Wrappers.Option.None()));
}

function UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0: Seq) : bool;

function UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(s#0) } $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) ==> (UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(s#0) <==> true));

procedure {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()))) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));
  free requires 12 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7336"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(maybeVs#0);
  free ensures {:id "id7337"} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0));
  free ensures {:id "id7338"} !UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Lit(true);
  free ensures {:id "id7339"} !UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.None_q(maybeVs#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (maybeVs#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(300,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume Wrappers.Option.Some_q(maybeVs#0);
    assume $IsAllocBox($Box(maybeVs#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybeVs#0);
    assume Wrappers.Option.Some_q(maybeVs#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0);
    assume $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0));
    goto anon5;

  anon14_Else:
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(maybeVs#0) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0));
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume !UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume true;
    assume Wrappers.Option.None_q(maybeVs#0);
    goto anon8;

  anon15_Else:
    assume !UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(maybeVs#0);
    goto anon8;

  anon8:
    assume false;
    return;

  anon13_Else:
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq());
    ##s#4 := s#0;
    assume $IsAlloc(##s#4, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == #Wrappers.Option.Some($Box(UnicodeEncodingForm.__default.DecodeCodeUnitSequence(s#0)));
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon12;

  anon16_Else:
    assume {:partition} !UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon12;

  anon12:
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == maybeVs#0;
    return;
}



procedure {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (correctness)"} Impl$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns (defass#maybeVs#0: bool, maybeVs#0: DatatypeType where defass#maybeVs#0 ==> $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap), $_reverifyPost: bool);
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeVs#0) && $IsA#Wrappers.Option(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id7354"} Wrappers.Option#Equal(maybeVs#0, UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (correctness)"} Impl$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (defass#maybeVs#0: bool, maybeVs#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
  var ##s#5: Seq;
  var parts#0: Seq where $Is(parts#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(parts#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##vs#0: Seq;
  var ##xs#3: Seq;
  var ##f#2: HandleType;
  var ##xs#4: Seq;
  var ##f#3: HandleType;
  var ##xs#5: Seq;
  var ##xs#6: Seq;
  var ##xs#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(311,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    maybeParts#0 := UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(312,57)"} true;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Option.None_q(maybeParts#0);
    push;
    assume true;
    assume true;
    maybeVs#0 := Lit(#Wrappers.Option.None());
    defass#maybeVs#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(314,17)"} true;
    assume defass#maybeVs#0;
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
    pop;
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Option.None_q(maybeParts#0);
    assume true;
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume true;
    parts#0 := $Unbox(Wrappers.Option.value(maybeParts#0)): Seq;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(316,33)"} true;
    assume true;
    assume 4 != $FunctionContextHeight;
    ##f#0 := UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue()), $Heap);
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume Seq.__default.Map#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    assume Seq.__default.Map#canCall(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    vs#0 := Seq.__default.Map(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(317,72)"} true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume true;
    push;
    pop;
    ##xs#7 := parts#0;
    assume $IsAlloc(##xs#7, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#0);
    assume {:subsumption 0} Seq#Equal(s#0, Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), parts#0));
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##xs#3 := parts#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#0);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), parts#0);
    push;
    push;
    assume 3 != $FunctionContextHeight;
    ##f#2 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#2, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#4 := vs#0;
    assume $IsAlloc(##xs#4, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#4, i#2)): bv24 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#4) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#2, Seq#Index(##xs#4, i#2)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq#Equal(parts#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(321,54)"} true;
    pop;
    pop;
    assume 3 != $FunctionContextHeight;
    ##f#3 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#3, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#5 := vs#0;
    assume $IsAlloc(##xs#5, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##xs#5, i#3)): bv24 } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#5) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#3, Seq#Index(##xs#5, i#3)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    ##xs#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $IsAlloc(##xs#6, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume {:subsumption 0} Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), parts#0), Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0)));
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume 3 != $FunctionContextHeight;
    ##f#1 := UnicodeEncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#1 := vs#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#1: int :: { $Unbox(Seq#Index(##xs#1, i#1)): bv24 } LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#1) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#1, Seq#Index(##xs#1, i#1)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    ##xs#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $IsAlloc(##xs#2, TSeq(TSeq(Tclass.UnicodeEncodingForm.CodeUnit())), $Heap);
    assume Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && Seq.__default.Flatten#canCall(Tclass.UnicodeEncodingForm.CodeUnit(), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    push;
    pop;
    ##vs#0 := vs#0;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    assume UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    assume {:subsumption 0} Seq#Equal(Seq.__default.Flatten(Tclass.UnicodeEncodingForm.CodeUnit(), $LS($LS($LZ)), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, UnicodeEncodingForm.__default.EncodeScalarValue#Handle(), vs#0)), UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0));
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume Seq#Equal(s#0, UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0));
    assume true;
    assume true;
    maybeVs#0 := #Wrappers.Option.Some($Box(vs#0));
    defass#maybeVs#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(325,19)"} true;
    assume defass#maybeVs#0;
    assume UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
    return;
}



procedure {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap));



procedure {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeParts#0) && $IsA#Wrappers.Option(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id7378"} Wrappers.Option#Equal(maybeParts#0, UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap));



procedure {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (s#0: Seq where $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures UnicodeEncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
  free ensures {:id "id7412"} Seq#Equal(s#0, UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (call precondtion)"} CallPre$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap));



procedure {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap)) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeVs#0) && $IsA#Wrappers.Option(UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id7440"} Wrappers.Option#Equal(maybeVs#0, UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "UnicodeEncodingForm.WellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.WellFormedCodeUnitSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeEncodingForm.WellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.WellFormedCodeUnitSeq(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.WellFormedCodeUnitSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy(36,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $Heap);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    return;

  anon4_Else:
    assume UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(Seq#Empty(): Seq))) || Lit(Wrappers.Option.Some_q(Lit(UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Lit(Seq#Empty(): Seq)))));
    return;
}



axiom (forall s#0: Seq :: { $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) } $Is(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq()) <==> $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && UnicodeEncodingForm.__default.IsWellFormedCodeUnitSequence(s#0));

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $h) } $IsAlloc(s#0, Tclass.UnicodeEncodingForm.WellFormedCodeUnitSeq(), $h) <==> $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $h));

procedure {:verboseName "UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall s#0: Seq :: { $Is(s#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) } $Is(s#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq()) <==> $Is(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit())) && UnicodeEncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0));

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $h) } $IsAlloc(s#0, Tclass.UnicodeEncodingForm.MinimalWellFormedCodeUnitSeq(), $h) <==> $IsAlloc(s#0, TSeq(Tclass.UnicodeEncodingForm.CodeUnit()), $h));

const unique class.UnicodeEncodingForm.CodeUnit: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#60 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#60))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#62 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#62)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#90 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#90))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#92 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#92)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#94 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#94)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#90 := Wrappers.Option.value(this); v#90)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#92 := Lit(Wrappers.Option.value(Lit(this))); v#92)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#94 := Lit(Wrappers.Option.value(Lit(this))); v#94)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#60 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#60)) else (var e#60 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#62 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#62))) else (var e#62 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#90 := Wrappers.Result.value(this); s#90) else (var e#90 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#92 := Lit(Wrappers.Result.value(Lit(this))); s#92) else (var e#92 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#94 := Lit(Wrappers.Result.value(Lit(this))); s#94) else (var e#94 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#90 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#90)) else (var e#90 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#90)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#92 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#92))) else (var e#92 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#92)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#94 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#94))) else (var e#94 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#94)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#12: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#12, x#12)): bool } $IsBox(x#12, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#12, x#12)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#13: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#13, x#13)): bool } $IsBox(x#13, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#13, x#13)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#12: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#12, x#12)): bool } $IsBox(x#12, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#12, x#12)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#13: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#13, x#13)): bool } $IsBox(x#13, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#13, x#13)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#12: Box, y#12: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#12, x#12)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#12, y#12)): bool } $IsBox(x#12, Relations._default.AntiSymmetric$T) && $IsBox(y#12, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#12, y#12)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#12, x#12)): bool ==> x#12 == y#12)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#13: Box, y#13: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#13, x#13)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#13, y#13)): bool } $IsBox(x#13, Relations._default.AntiSymmetric$T) && $IsBox(y#13, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#13, y#13)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#13, x#13)): bool ==> x#13 == y#13)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#12: Box, y#12: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#12, x#12)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#12, y#12)): bool } $IsBox(x#12, Relations._default.Symmetric$T) && $IsBox(y#12, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#12, y#12)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#12, x#12)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#13: Box, y#13: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#13, x#13)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#13, y#13)): bool } $IsBox(x#13, Relations._default.Symmetric$T) && $IsBox(y#13, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#13, y#13)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#13, x#13)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#12: Box, y#12: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#12, x#12)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#12, y#12)): bool } $IsBox(x#12, Relations._default.Connected$T) && $IsBox(y#12, Relations._default.Connected$T) ==> x#12 != y#12 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#12, y#12)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#12, x#12)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#13: Box, y#13: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#13, x#13)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#13, y#13)): bool } $IsBox(x#13, Relations._default.Connected$T) && $IsBox(y#13, Relations._default.Connected$T) ==> x#13 != y#13 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#13, y#13)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#13, x#13)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#12: Box, y#12: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#12, x#12)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#12, y#12)): bool } $IsBox(x#12, Relations._default.StronglyConnected$T) && $IsBox(y#12, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#12, y#12)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#12, x#12)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#13: Box, y#13: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#13, x#13)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#13, y#13)): bool } $IsBox(x#13, Relations._default.StronglyConnected$T) && $IsBox(y#13, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#13, y#13)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#13, x#13)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#12: Box, y#12: Box, z#12: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#12, z#12)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#12, z#12)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#12, z#12)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#12, y#12)): bool } $IsBox(x#12, Relations._default.Transitive$T) && $IsBox(y#12, Relations._default.Transitive$T) && $IsBox(z#12, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#12, y#12)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#12, z#12)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#12, z#12)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#13: Box, y#13: Box, z#13: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#13, z#13)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#13, z#13)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#13, z#13)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#13, y#13)): bool } $IsBox(x#13, Relations._default.Transitive$T) && $IsBox(y#13, Relations._default.Transitive$T) && $IsBox(z#13, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#13, y#13)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#13, z#13)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#13, z#13)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#17: int, j#17: int :: { Seq#Index(a#0, j#17), Seq#Index(a#0, i#17) } LitInt(0) <= i#17 && i#17 < j#17 && j#17 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#17), Seq#Index(a#0, j#17))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#18: int, j#18: int :: { Seq#Index(a#0, j#18), Seq#Index(a#0, i#18) } LitInt(0) <= i#18 && i#18 < j#18 && j#18 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#18), Seq#Index(Lit(a#0), j#18))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#19: int, j#19: int :: { Seq#Index(a#0, j#19), Seq#Index(a#0, i#19) } LitInt(0) <= i#19 && i#19 < j#19 && j#19 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#19), Seq#Index(Lit(a#0), j#19))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#17: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#17)): bool } { s#0[x#17] } $IsBox(x#17, Relations._default.IsLeast$T) && s#0[x#17] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#17)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#18: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#18)): bool } { s#0[x#18] } $IsBox(x#18, Relations._default.IsLeast$T) && Lit(s#0)[x#18] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#18)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#19: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#19)): bool } { s#0[x#19] } $IsBox(x#19, Relations._default.IsLeast$T) && Lit(s#0)[x#19] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#19)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#17: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#17)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#17, min#0)): bool } { s#0[x#17] } $IsBox(x#17, Relations._default.IsMinimal$T) && s#0[x#17] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#17, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#17)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#18: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#18)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#18, min#0)): bool } { s#0[x#18] } $IsBox(x#18, Relations._default.IsMinimal$T) && Lit(s#0)[x#18] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#18, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#18)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#19: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#19)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#19, min#0)): bool } { s#0[x#19] } $IsBox(x#19, Relations._default.IsMinimal$T) && Lit(s#0)[x#19] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#19, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#19)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#17: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#17, max#0)): bool } { s#0[x#17] } $IsBox(x#17, Relations._default.IsGreatest$T) && s#0[x#17] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#17, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#18: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#18, max#0)): bool } { s#0[x#18] } $IsBox(x#18, Relations._default.IsGreatest$T) && Lit(s#0)[x#18] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#18, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#19: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#19, max#0)): bool } { s#0[x#19] } $IsBox(x#19, Relations._default.IsGreatest$T) && Lit(s#0)[x#19] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#19, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#17: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#17, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#17)): bool } { s#0[x#17] } $IsBox(x#17, Relations._default.IsMaximal$T) && s#0[x#17] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#17)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#17, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#18: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#18, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#18)): bool } { s#0[x#18] } $IsBox(x#18, Relations._default.IsMaximal$T) && Lit(s#0)[x#18] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#18)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#18, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#19: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#19, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#19)): bool } { s#0[x#19] } $IsBox(x#19, Relations._default.IsMaximal$T) && Lit(s#0)[x#19] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#19)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#19, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#12 := Div(Seq#Length(a#0), LitInt(2)); (var left#12, right#12 := Seq#Take(a#0, splitIndex#12), Seq#Drop(a#0, splitIndex#12); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#12, lessThanOrEq#0) && (var leftSorted#12 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#12, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#12, lessThanOrEq#0) && (var rightSorted#12 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#12, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#12, rightSorted#12, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#12 := Div(Seq#Length(a#0), LitInt(2)); (var left#12, right#12 := Seq#Take(a#0, splitIndex#12), Seq#Drop(a#0, splitIndex#12); (var leftSorted#12 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#12, lessThanOrEq#0); (var rightSorted#12 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#12, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#12, rightSorted#12, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#13 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#13, right#13 := Seq#Take(Lit(a#0), splitIndex#13), Seq#Drop(Lit(a#0), splitIndex#13); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#13, lessThanOrEq#0) && (var leftSorted#13 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#13, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#13, lessThanOrEq#0) && (var rightSorted#13 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#13, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#13, rightSorted#13, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#13 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#13, right#13 := Seq#Take(Lit(a#0), splitIndex#13), Seq#Drop(Lit(a#0), splitIndex#13); (var leftSorted#13 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#13, lessThanOrEq#0); (var rightSorted#13 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#13, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#13, rightSorted#13, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#14 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#14, right#14 := Seq#Take(Lit(a#0), splitIndex#14), Seq#Drop(Lit(a#0), splitIndex#14); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#14, Lit(lessThanOrEq#0)) && (var leftSorted#14 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#14, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#14, Lit(lessThanOrEq#0)) && (var rightSorted#14 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#14, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#14, rightSorted#14, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#14 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#14, right#14 := Seq#Take(Lit(a#0), splitIndex#14), Seq#Drop(Lit(a#0), splitIndex#14); (var leftSorted#14 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#14, Lit(lessThanOrEq#0)); (var rightSorted#14 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#14, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#14, rightSorted#14, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#8: Box :: $IsBox($y#8, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#8)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#9: Box :: $IsBox($y#9, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#9)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#8: int, j#8: int :: { Seq#Index(xs#0, j#8), Seq#Index(xs#0, i#8) } LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0) && LitInt(0) <= j#8 && j#8 < Seq#Length(xs#0) && i#8 != j#8 ==> Seq#Index(xs#0, i#8) != Seq#Index(xs#0, j#8))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#9: int, j#9: int :: { Seq#Index(xs#0, j#9), Seq#Index(xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#9 && j#9 < Seq#Length(Lit(xs#0)) && i#9 != j#9 ==> Seq#Index(Lit(xs#0), i#9) != Seq#Index(Lit(xs#0), j#9))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#5: int :: { Seq#Index(xs#0, j#5) } LitInt(0) <= j#5 && j#5 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#5) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#5: int :: { Seq#Index(xs#0, j#5) } LitInt(0) <= j#5 && j#5 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#5) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#9 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#9) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#9)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#10 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#10) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#10)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#11 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#11) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#11)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#5: int :: { Seq#Index(xs#0, j#5) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#5 && j#5 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#5) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#5: int :: { Seq#Index(xs#0, j#5) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#5 && j#5 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#5) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#10: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#10), Seq#Index(xs#0, i#10) } LitInt(0) <= i#10 && i#10 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#10) == Seq#Index(xs#0, i#10)) && (forall i#11: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#11) } pos#0 <= i#11 && i#11 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#11) == Seq#Index(xs#0, i#11 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#9 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#9), Seq#Drop(xs#0, i#9 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#10 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#10), Seq#Drop(Lit(xs#0), i#10 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#11 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#11), Seq#Drop(Lit(xs#0), i#11 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#10: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#10), Seq#Index(xs#0, i#10) } LitInt(0) <= i#10 && i#10 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#10) == Seq#Index(xs#0, i#10)) && (forall i#11: int :: { Seq#Index(xs#0, i#11) } pos#0 <= i#11 && i#11 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#11 + 1) == Seq#Index(xs#0, i#11)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#5: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#5) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#5 - 1) } LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#5) == Seq#Index(xs#0, Seq#Length(xs#0) - i#5 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#5: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#5) } LitInt(0) <= i#5 && i#5 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#5) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#5: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#5) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#5) } LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#5), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#5)), $Unbox(Seq#Index(xs#0, i#5)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#6, b#6 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#6, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#6, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#7, b#7 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#7, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#7, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#5: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#5)): DatatypeType } LitInt(0) <= i#5 && i#5 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#5)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#5), Seq#Index(ys#0, i#5)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#5: int :: { Seq#Contains(xs#0, $Box(k#5)) } Seq#Contains(xs#0, $Box(k#5)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#5) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#5: int :: { Seq#Contains(xs#0, $Box(k#5)) } Seq#Contains(xs#0, $Box(k#5)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#5) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#22: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#22) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#22))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#23: int :: { Seq#Index(xs#0, i#23) } LitInt(0) <= i#23 && i#23 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#23)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#23: int :: { Seq#Index(xs#0, i#23) } LitInt(0) <= i#23 && i#23 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#23)))) ==> (forall $l#11#i#0: int :: LitInt(0) <= $l#11#i#0 ==> $l#11#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#11#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#10#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#10#i#0): int))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $IsBox($l#10#i#0, TInt) && LitInt(0) <= $Unbox($l#10#i#0): int && $Unbox($l#10#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#10#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#10#i#0): int))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: (exists i#24: int, o#11: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#10#heap#0, f#0, Seq#Index(xs#0, i#24))[$Box(o#11)] } $Is(o#11, Tclass._System.object?()) && LitInt(0) <= i#24 && i#24 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#10#heap#0, f#0, Seq#Index(xs#0, i#24))[$Box(o#11)] && $Box($l#10#o#0) == $Box(o#11))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#17: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#17) } { Seq#Index(xs#0, i#17) } (LitInt(0) <= i#17 && i#17 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#17))): DatatypeType)) && (LitInt(0) <= i#17 && i#17 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#17) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#17))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#18: int :: { Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#18)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#18: int :: { Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#18)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#3 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#3) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#3) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#3 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#3)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#3 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#3) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#3) else (var head#3 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#3); (var valueOrError1#3 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#3) else (var tail#3 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#3), tail#3)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#17: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#17) } LitInt(0) <= i#17 ==> i#17 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#17)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#17))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#18: int :: { Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#18)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#18: int :: { Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#18)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#8: Box, xs#8: Seq, b#8: Box, b'#8: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#8, x#8, b'#8)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#8), xs#8) } $IsBox(x#8, Seq._default.InvFoldLeft$A) && $Is(xs#8, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#8, Seq._default.InvFoldLeft$B) && $IsBox(b'#8, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#8, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#8), xs#8)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#8, x#8, b'#8)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#8, $Box(xs#8))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#9: Box, xs#9: Seq, b#9: Box, b'#9: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#9, x#9, b'#9)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#9), xs#9) } $IsBox(x#9, Seq._default.InvFoldLeft$A) && $Is(xs#9, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#9, Seq._default.InvFoldLeft$B) && $IsBox(b'#9, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#9, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#9), xs#9)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#9, x#9, b'#9)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#9, $Box(xs#9))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#8: Box, xs#8: Seq, b#8: Box, b'#8: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#8), xs#8), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#8, b#8, b'#8)): bool } $IsBox(x#8, Seq._default.InvFoldRight$A) && $Is(xs#8, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#8, Seq._default.InvFoldRight$B) && $IsBox(b'#8, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#8), b#8)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#8, b#8, b'#8)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#8), xs#8)), b'#8)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#9: Box, xs#9: Seq, b#9: Box, b'#9: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#9), xs#9), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#9, b#9, b'#9)): bool } $IsBox(x#9, Seq._default.InvFoldRight$A) && $Is(xs#9, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#9, Seq._default.InvFoldRight$B) && $IsBox(b'#9, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#9), b#9)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#9, b#9, b'#9)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#9), xs#9)), b'#9)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#12: int :: { Seq#Index(xs#0, i#12) } LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#12)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#12: int :: { Seq#Index(xs#0, i#12) } LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#12)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom $Is(Unicode.__default.HIGH__SURROGATE__MIN(), Tclass.Unicode.CodePoint());

axiom (forall $h: Heap :: { $IsAlloc(Unicode.__default.HIGH__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.HIGH__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h));

axiom $Is(Unicode.__default.HIGH__SURROGATE__MAX(), Tclass.Unicode.CodePoint());

axiom (forall $h: Heap :: { $IsAlloc(Unicode.__default.HIGH__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.HIGH__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h));

axiom $Is(Unicode.__default.LOW__SURROGATE__MIN(), Tclass.Unicode.CodePoint());

axiom (forall $h: Heap :: { $IsAlloc(Unicode.__default.LOW__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.LOW__SURROGATE__MIN(), Tclass.Unicode.CodePoint(), $h));

axiom $Is(Unicode.__default.LOW__SURROGATE__MAX(), Tclass.Unicode.CodePoint());

axiom (forall $h: Heap :: { $IsAlloc(Unicode.__default.LOW__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.LOW__SURROGATE__MAX(), Tclass.Unicode.CodePoint(), $h));

axiom $Is(Unicode.__default.ASSIGNED__PLANES(), TSet(TBitvector(8)));

axiom (forall $h: Heap :: { $IsAlloc(Unicode.__default.ASSIGNED__PLANES(), TSet(TBitvector(8)), $h) } $IsGoodHeap($h) ==> $IsAlloc(Unicode.__default.ASSIGNED__PLANES(), TSet(TBitvector(8)), $h));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#2 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#2)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#3 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#3)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#3: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#3) } $IsBox(x#3, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#3))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#3: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#3) } $IsBox(x#3, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#3))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#3: Box, x2#3: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#3), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#3) } $IsBox(x1#3, Functions._default.Injective$X) && $IsBox(x2#3, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#3) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#3) ==> x1#3 == x2#3)));

const unique tytagFamily$MinimalWellFormedCodeUnitSeq: TyTagFamily;

const unique tytagFamily$WellFormedCodeUnitSeq: TyTagFamily;

const unique class.Utf8EncodingForm.__default: ClassName;

function Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly: LayerType, s#0: Seq) : bool
uses {
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#0: int :: { Seq#Take(s#0, i#0) } 0 < i#0 && i#0 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#0))));
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> (Seq#Length(s#0) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(2) ==> (Seq#Length(s#0) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(3) ==> Seq#Length(s#0) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0)))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then (var b#0 := Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0); b#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#1 := Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#1) else (if Seq#Length(s#0) == LitInt(3) then (var b#2 := Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0); b#2) else (if Seq#Length(s#0) == LitInt(4) then (var b#3 := Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0); b#3) else false))))));
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> (Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(2) ==> (Seq#Length(Lit(s#0)) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(3) ==> Seq#Length(Lit(s#0)) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0))))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then (var b#4 := Lit(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0))); b#4) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#5 := Lit(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#5) else (if Seq#Length(Lit(s#0)) == LitInt(3) then (var b#6 := Lit(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0))); b#6) else (if Seq#Length(Lit(s#0)) == LitInt(4) then (var b#7 := Lit(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0))); b#7) else false))))));
}

function Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(AsFuelBottom($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) <==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LZ, s#0));

function Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires($ly, s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires($ly, s#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.IsMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (b#8: bool);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7468"} b#8 ==> Seq#Length(s#0) > 0;
  free ensures {:id "id7469"} b#8 ==> (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#1)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.IsMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(s#0: Seq) returns (b#8: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var ##s#0: Seq;
  var b#Z#0: bool;
  var let#0#0#0: bool;
  var ##s#1: Seq;
  var i#3: int;
  var ##s#2: Seq;
  var b#Z#1: bool;
  var let#1#0#0: bool;
  var ##s#3: Seq;
  var i#5: int;
  var ##s#4: Seq;
  var b#Z#2: bool;
  var let#2#0#0: bool;
  var ##s#5: Seq;
  var i#7: int;
  var ##s#6: Seq;
  var b#Z#3: bool;
  var let#3#0#0: bool;
  var ##s#7: Seq;
  var i#9: int;
  var ##s#8: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.IsMinimalWellFormedCodeUnitSubsequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(25,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon49_Then, anon49_Else;

  anon49_Then:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume b#8;
    assume Seq#Length(s#0) > 0;
    havoc i#2;
    assume true;
    goto anon51_Then, anon51_Else;

  anon51_Then:
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} 0 < i#2;
    goto anon6;

  anon52_Else:
    assume {:partition} i#2 <= 0;
    goto anon6;

  anon6:
    assume 0 < i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, i#2);
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#0) == Seq#Length(s#0);
    assume Seq#Take(s#0, i#2) == s#0 || Seq#Length(##s#0) < Seq#Length(s#0);
    assume Seq#Take(s#0, i#2) == s#0 || Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#2));
    assume !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2));
    goto anon8;

  anon51_Else:
    assume 0 < i#2 && i#2 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2));
    goto anon8;

  anon8:
    assume (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1)));
    goto anon10;

  anon50_Else:
    assume b#8 ==> Seq#Length(s#0) > 0 && (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1)));
    goto anon10;

  anon10:
    assume false;
    return;

  anon49_Else:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(1);
    havoc b#Z#0;
    assume true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(1);
    assume Seq#Length(##s#1) == LitInt(1);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0);
    assume let#0#0#0 <==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0);
    assume $Is(let#0#0#0, TBool);
    assume b#Z#0 <==> let#0#0#0;
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} b#Z#0;
    havoc i#3;
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} true;
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} 0 < i#3;
    goto anon16;

  anon56_Else:
    assume {:partition} i#3 <= 0;
    goto anon16;

  anon16:
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} 0 < i#3 && i#3 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= i#3 && i#3 <= Seq#Length(s#0);
    ##s#2 := Seq#Take(s#0, i#3);
    assume $IsAlloc(##s#2, TSeq(TBitvector(8)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#2) == Seq#Length(s#0);
    assume Seq#Length(##s#2) < Seq#Length(s#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#3));
    goto anon18;

  anon57_Else:
    assume {:partition} !(0 < i#3 && i#3 < Seq#Length(s#0));
    goto anon18;

  anon55_Else:
    assume {:partition} false;
    goto anon18;

  anon18:
    goto anon19;

  anon54_Else:
    assume {:partition} !b#Z#0;
    goto anon19;

  anon19:
    assume b#Z#0 ==> (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(s#0) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#4)));
    assume {:subsumption 0} b#Z#0 ==> (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#4)));
    assume b#Z#0 ==> (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#4)));
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(29,109)"} true;
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#Z#0;
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon48;

  anon53_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(1);
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(2);
    havoc b#Z#1;
    assume true;
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#3) == LitInt(2);
    assume Seq#Length(##s#3) == LitInt(2);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0);
    assume let#1#0#0 <==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0);
    assume $Is(let#1#0#0, TBool);
    assume b#Z#1 <==> let#1#0#0;
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} b#Z#1;
    havoc i#5;
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} true;
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} 0 < i#5;
    goto anon25;

  anon61_Else:
    assume {:partition} i#5 <= 0;
    goto anon25;

  anon25:
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume {:partition} 0 < i#5 && i#5 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= i#5 && i#5 <= Seq#Length(s#0);
    ##s#4 := Seq#Take(s#0, i#5);
    assume $IsAlloc(##s#4, TSeq(TBitvector(8)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#4) == Seq#Length(s#0);
    assume Seq#Length(##s#4) < Seq#Length(s#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#5));
    goto anon27;

  anon62_Else:
    assume {:partition} !(0 < i#5 && i#5 < Seq#Length(s#0));
    goto anon27;

  anon60_Else:
    assume {:partition} false;
    goto anon27;

  anon27:
    goto anon28;

  anon59_Else:
    assume {:partition} !b#Z#1;
    goto anon28;

  anon28:
    assume b#Z#1 ==> (forall i#6: int :: { Seq#Take(s#0, i#6) } 0 < i#6 && i#6 < Seq#Length(s#0) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#6)));
    assume {:subsumption 0} b#Z#1 ==> (forall i#6: int :: { Seq#Take(s#0, i#6) } 0 < i#6 && i#6 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#6)));
    assume b#Z#1 ==> (forall i#6: int :: { Seq#Take(s#0, i#6) } 0 < i#6 && i#6 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#6)));
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(34,114)"} true;
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#Z#1;
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon48;

  anon58_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(2);
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(3);
    havoc b#Z#2;
    assume true;
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#5) == LitInt(3);
    assume Seq#Length(##s#5) == LitInt(3);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0);
    assume let#2#0#0 <==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0);
    assume $Is(let#2#0#0, TBool);
    assume b#Z#2 <==> let#2#0#0;
    goto anon64_Then, anon64_Else;

  anon64_Then:
    assume {:partition} b#Z#2;
    havoc i#7;
    goto anon65_Then, anon65_Else;

  anon65_Then:
    assume {:partition} true;
    goto anon66_Then, anon66_Else;

  anon66_Then:
    assume {:partition} 0 < i#7;
    goto anon34;

  anon66_Else:
    assume {:partition} i#7 <= 0;
    goto anon34;

  anon34:
    goto anon67_Then, anon67_Else;

  anon67_Then:
    assume {:partition} 0 < i#7 && i#7 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= i#7 && i#7 <= Seq#Length(s#0);
    ##s#6 := Seq#Take(s#0, i#7);
    assume $IsAlloc(##s#6, TSeq(TBitvector(8)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#6) == Seq#Length(s#0);
    assume Seq#Length(##s#6) < Seq#Length(s#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#7));
    goto anon36;

  anon67_Else:
    assume {:partition} !(0 < i#7 && i#7 < Seq#Length(s#0));
    goto anon36;

  anon65_Else:
    assume {:partition} false;
    goto anon36;

  anon36:
    goto anon37;

  anon64_Else:
    assume {:partition} !b#Z#2;
    goto anon37;

  anon37:
    assume b#Z#2 ==> (forall i#8: int :: { Seq#Take(s#0, i#8) } 0 < i#8 && i#8 < Seq#Length(s#0) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#8)));
    assume {:subsumption 0} b#Z#2 ==> (forall i#8: int :: { Seq#Take(s#0, i#8) } 0 < i#8 && i#8 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#8)));
    assume b#Z#2 ==> (forall i#8: int :: { Seq#Take(s#0, i#8) } 0 < i#8 && i#8 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#8)));
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(39,114)"} true;
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#Z#2;
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon48;

  anon63_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(3);
    goto anon68_Then, anon68_Else;

  anon68_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4);
    havoc b#Z#3;
    assume true;
    ##s#7 := s#0;
    assume $IsAlloc(##s#7, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#7) == LitInt(4);
    assume Seq#Length(##s#7) == LitInt(4);
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0);
    assume let#3#0#0 <==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0);
    assume $Is(let#3#0#0, TBool);
    assume b#Z#3 <==> let#3#0#0;
    goto anon69_Then, anon69_Else;

  anon69_Then:
    assume {:partition} b#Z#3;
    havoc i#9;
    goto anon70_Then, anon70_Else;

  anon70_Then:
    assume {:partition} true;
    goto anon71_Then, anon71_Else;

  anon71_Then:
    assume {:partition} 0 < i#9;
    goto anon43;

  anon71_Else:
    assume {:partition} i#9 <= 0;
    goto anon43;

  anon43:
    goto anon72_Then, anon72_Else;

  anon72_Then:
    assume {:partition} 0 < i#9 && i#9 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= i#9 && i#9 <= Seq#Length(s#0);
    ##s#8 := Seq#Take(s#0, i#9);
    assume $IsAlloc(##s#8, TSeq(TBitvector(8)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#8) == Seq#Length(s#0);
    assume Seq#Length(##s#8) < Seq#Length(s#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#9));
    goto anon45;

  anon72_Else:
    assume {:partition} !(0 < i#9 && i#9 < Seq#Length(s#0));
    goto anon45;

  anon70_Else:
    assume {:partition} false;
    goto anon45;

  anon45:
    goto anon46;

  anon69_Else:
    assume {:partition} !b#Z#3;
    goto anon46;

  anon46:
    assume b#Z#3 ==> (forall i#10: int :: { Seq#Take(s#0, i#10) } 0 < i#10 && i#10 < Seq#Length(s#0) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#10)));
    assume {:subsumption 0} b#Z#3 ==> (forall i#10: int :: { Seq#Take(s#0, i#10) } 0 < i#10 && i#10 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#10)));
    assume b#Z#3 ==> (forall i#10: int :: { Seq#Take(s#0, i#10) } 0 < i#10 && i#10 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#10)));
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(44,114)"} true;
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#Z#3;
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon48;

  anon68_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(4);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> Lit(false);
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon48;

  anon48:
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#8;
    return;
}



function Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstByte#0 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#0) && le_bv8(firstByte#0, 127bv8))));
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#1) && le_bv8(firstByte#1, 127bv8))));
}

function Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#requires(s#0) <==> Seq#Length(s#0) == LitInt(1)));

procedure {:verboseName "Utf8EncodingForm.IsWellFormedSingleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (b#0: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.IsWellFormedSingleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.IsWellFormedSingleCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(50,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(1);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume false;
    return;

  anon7_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume let#0#0#0 == $Unbox(Seq#Index(s#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Lit(true);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} le_bv8(0bv8, firstByte#Z#0);
    goto anon6;

  anon9_Else:
    assume {:partition} !le_bv8(0bv8, firstByte#Z#0);
    goto anon6;

  anon8_Else:
    assume {:partition} !Lit(true);
    goto anon6;

  anon6:
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> true && le_bv8(0bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 127bv8);
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0), TBool);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> b#0;
    return;
}



function Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) ==> true && !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstByte#0 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#0 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#0) && le_bv8(firstByte#0, 223bv8) && le_bv8(128bv8, secondByte#0) && le_bv8(secondByte#0, 191bv8)))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; le_bv8(194bv8, firstByte#1) && le_bv8(firstByte#1, 223bv8) && le_bv8(128bv8, secondByte#1) && le_bv8(secondByte#1, 191bv8)))));
}

function Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#requires(s#0) <==> Seq#Length(s#0) == LitInt(2)));

procedure {:verboseName "Utf8EncodingForm.IsWellFormedDoubleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (b#0: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7524"} b#0 ==> Lit(true);
  free ensures {:id "id7525"} b#0 ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.IsWellFormedDoubleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#1#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.IsWellFormedDoubleCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(57,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(2);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume b#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(1);
    assume Seq#Length(##s#0) == LitInt(1);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)));
    assume !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    goto anon5;

  anon13_Else:
    assume b#0 ==> true && !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume let#0#0#0 == $Unbox(Seq#Index(s#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume let#1#0#0 == $Unbox(Seq#Index(s#0, LitInt(1))): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#1#0#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} le_bv8(194bv8, firstByte#Z#0);
    goto anon8;

  anon14_Else:
    assume {:partition} !le_bv8(194bv8, firstByte#Z#0);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} le_bv8(194bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 223bv8);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} le_bv8(128bv8, secondByte#Z#0);
    goto anon11;

  anon16_Else:
    assume {:partition} !le_bv8(128bv8, secondByte#Z#0);
    goto anon11;

  anon15_Else:
    assume {:partition} !(le_bv8(194bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 223bv8));
    goto anon11;

  anon11:
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> le_bv8(194bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 223bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8);
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0), TBool);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> b#0;
    return;
}



function Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) && !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> (var firstByte#0 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#0 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#0 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; ((firstByte#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#0) && le_bv8(secondByte#0, 191bv8)) || (le_bv8(225bv8, firstByte#0) && le_bv8(firstByte#0, 236bv8) && le_bv8(128bv8, secondByte#0) && le_bv8(secondByte#0, 191bv8)) || (firstByte#0 == Lit(237bv8) && le_bv8(128bv8, secondByte#0) && le_bv8(secondByte#0, 159bv8)) || (le_bv8(238bv8, firstByte#0) && le_bv8(firstByte#0, 239bv8) && le_bv8(128bv8, secondByte#0) && le_bv8(secondByte#0, 191bv8))) && le_bv8(128bv8, thirdByte#0) && le_bv8(thirdByte#0, 191bv8))))));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; ((firstByte#1 == Lit(224bv8) && le_bv8(160bv8, secondByte#1) && le_bv8(secondByte#1, 191bv8)) || (le_bv8(225bv8, firstByte#1) && le_bv8(firstByte#1, 236bv8) && le_bv8(128bv8, secondByte#1) && le_bv8(secondByte#1, 191bv8)) || (firstByte#1 == Lit(237bv8) && le_bv8(128bv8, secondByte#1) && le_bv8(secondByte#1, 159bv8)) || (le_bv8(238bv8, firstByte#1) && le_bv8(firstByte#1, 239bv8) && le_bv8(128bv8, secondByte#1) && le_bv8(secondByte#1, 191bv8))) && le_bv8(128bv8, thirdByte#1) && le_bv8(thirdByte#1, 191bv8))))));
}

function Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#requires(s#0) <==> Seq#Length(s#0) == LitInt(3)));

procedure {:verboseName "Utf8EncodingForm.IsWellFormedTripleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (b#0: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7541"} b#0 ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
  free ensures {:id "id7542"} b#0 ==> !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.IsWellFormedTripleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#1#0#0: bv8;
  var thirdByte#Z#0: bv8;
  var let#2#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.IsWellFormedTripleCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(68,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(3);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume b#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(1);
    assume Seq#Length(##s#0) == LitInt(1);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)));
    assume !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(2);
    assume Seq#Length(##s#1) == LitInt(2);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)));
    assume !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));
    goto anon5;

  anon30_Else:
    assume b#0 ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) && !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon29_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume let#0#0#0 == $Unbox(Seq#Index(s#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume let#1#0#0 == $Unbox(Seq#Index(s#0, LitInt(1))): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#1#0#0;
    havoc thirdByte#Z#0;
    assume true;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    assume let#2#0#0 == $Unbox(Seq#Index(s#0, LitInt(2))): bv8;
    assume true;
    assume $Is(let#2#0#0, TBitvector(8));
    assume thirdByte#Z#0 == let#2#0#0;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} firstByte#Z#0 == Lit(224bv8);
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} le_bv8(160bv8, secondByte#Z#0);
    goto anon9;

  anon32_Else:
    assume {:partition} !le_bv8(160bv8, secondByte#Z#0);
    goto anon9;

  anon31_Else:
    assume {:partition} firstByte#Z#0 != Lit(224bv8);
    goto anon9;

  anon9:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} !(firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8));
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} le_bv8(225bv8, firstByte#Z#0);
    goto anon12;

  anon34_Else:
    assume {:partition} !le_bv8(225bv8, firstByte#Z#0);
    goto anon12;

  anon12:
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} le_bv8(128bv8, secondByte#Z#0);
    goto anon15;

  anon36_Else:
    assume {:partition} !le_bv8(128bv8, secondByte#Z#0);
    goto anon15;

  anon35_Else:
    assume {:partition} !(le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8));
    goto anon15;

  anon33_Else:
    assume {:partition} firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8);
    goto anon15;

  anon15:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} !((firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)));
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} firstByte#Z#0 == Lit(237bv8);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} le_bv8(128bv8, secondByte#Z#0);
    goto anon19;

  anon39_Else:
    assume {:partition} !le_bv8(128bv8, secondByte#Z#0);
    goto anon19;

  anon38_Else:
    assume {:partition} firstByte#Z#0 != Lit(237bv8);
    goto anon19;

  anon37_Else:
    assume {:partition} (firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8));
    goto anon19;

  anon19:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} !((firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(237bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 159bv8)));
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} le_bv8(238bv8, firstByte#Z#0);
    goto anon22;

  anon41_Else:
    assume {:partition} !le_bv8(238bv8, firstByte#Z#0);
    goto anon22;

  anon22:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} le_bv8(238bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 239bv8);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} le_bv8(128bv8, secondByte#Z#0);
    goto anon25;

  anon43_Else:
    assume {:partition} !le_bv8(128bv8, secondByte#Z#0);
    goto anon25;

  anon42_Else:
    assume {:partition} !(le_bv8(238bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 239bv8));
    goto anon25;

  anon40_Else:
    assume {:partition} (firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(237bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 159bv8));
    goto anon25;

  anon25:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} (firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(237bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 159bv8)) || (le_bv8(238bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 239bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8));
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} le_bv8(128bv8, thirdByte#Z#0);
    goto anon28;

  anon45_Else:
    assume {:partition} !le_bv8(128bv8, thirdByte#Z#0);
    goto anon28;

  anon44_Else:
    assume {:partition} !((firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(237bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 159bv8)) || (le_bv8(238bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 239bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)));
    goto anon28;

  anon28:
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> ((firstByte#Z#0 == Lit(224bv8) && le_bv8(160bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(225bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 236bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(237bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 159bv8)) || (le_bv8(238bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 239bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8))) && le_bv8(128bv8, thirdByte#Z#0) && le_bv8(thirdByte#Z#0, 191bv8);
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0), TBool);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> b#0;
    return;
}



function Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 5 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) && !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) && !Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3))));
axiom 5 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> (var firstByte#0 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#0 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#0 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#0 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; ((firstByte#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#0) && le_bv8(secondByte#0, 191bv8)) || (le_bv8(241bv8, firstByte#0) && le_bv8(firstByte#0, 243bv8) && le_bv8(128bv8, secondByte#0) && le_bv8(secondByte#0, 191bv8)) || (firstByte#0 == Lit(244bv8) && le_bv8(128bv8, secondByte#0) && le_bv8(secondByte#0, 143bv8))) && le_bv8(128bv8, thirdByte#0) && le_bv8(thirdByte#0, 191bv8) && le_bv8(128bv8, fourthByte#0) && le_bv8(fourthByte#0, 191bv8)))))));
axiom 5 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0)) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; (var fourthByte#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(3))): bv8; ((firstByte#1 == Lit(240bv8) && le_bv8(144bv8, secondByte#1) && le_bv8(secondByte#1, 191bv8)) || (le_bv8(241bv8, firstByte#1) && le_bv8(firstByte#1, 243bv8) && le_bv8(128bv8, secondByte#1) && le_bv8(secondByte#1, 191bv8)) || (firstByte#1 == Lit(244bv8) && le_bv8(128bv8, secondByte#1) && le_bv8(secondByte#1, 143bv8))) && le_bv8(128bv8, thirdByte#1) && le_bv8(thirdByte#1, 191bv8) && le_bv8(128bv8, fourthByte#1) && le_bv8(fourthByte#1, 191bv8)))))));
}

function Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#requires(s#0) <==> Seq#Length(s#0) == LitInt(4)));

procedure {:verboseName "Utf8EncodingForm.IsWellFormedQuadrupleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (b#0: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7563"} b#0 ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
  free ensures {:id "id7564"} b#0 ==> !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));
  free ensures {:id "id7565"} b#0 ==> !Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.IsWellFormedQuadrupleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#1#0#0: bv8;
  var thirdByte#Z#0: bv8;
  var let#2#0#0: bv8;
  var fourthByte#Z#0: bv8;
  var let#3#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.IsWellFormedQuadrupleCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(86,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(4);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume b#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(1);
    assume Seq#Length(##s#0) == LitInt(1);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)));
    assume !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(2);
    assume Seq#Length(##s#1) == LitInt(2);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)));
    assume !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));
    assume 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    ##s#2 := Seq#Take(s#0, LitInt(3));
    assume $IsAlloc(##s#2, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) == LitInt(3);
    assume Seq#Length(##s#2) == LitInt(3);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(3)));
    assume !Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3)));
    goto anon5;

  anon27_Else:
    assume b#0 ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) && !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) && !Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon26_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume let#0#0#0 == $Unbox(Seq#Index(s#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume let#1#0#0 == $Unbox(Seq#Index(s#0, LitInt(1))): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#1#0#0;
    havoc thirdByte#Z#0;
    assume true;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    assume let#2#0#0 == $Unbox(Seq#Index(s#0, LitInt(2))): bv8;
    assume true;
    assume $Is(let#2#0#0, TBitvector(8));
    assume thirdByte#Z#0 == let#2#0#0;
    havoc fourthByte#Z#0;
    assume true;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    assume let#3#0#0 == $Unbox(Seq#Index(s#0, LitInt(3))): bv8;
    assume true;
    assume $Is(let#3#0#0, TBitvector(8));
    assume fourthByte#Z#0 == let#3#0#0;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} firstByte#Z#0 == Lit(240bv8);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} le_bv8(144bv8, secondByte#Z#0);
    goto anon9;

  anon29_Else:
    assume {:partition} !le_bv8(144bv8, secondByte#Z#0);
    goto anon9;

  anon28_Else:
    assume {:partition} firstByte#Z#0 != Lit(240bv8);
    goto anon9;

  anon9:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} !(firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8));
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} le_bv8(241bv8, firstByte#Z#0);
    goto anon12;

  anon31_Else:
    assume {:partition} !le_bv8(241bv8, firstByte#Z#0);
    goto anon12;

  anon12:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8);
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} le_bv8(128bv8, secondByte#Z#0);
    goto anon15;

  anon33_Else:
    assume {:partition} !le_bv8(128bv8, secondByte#Z#0);
    goto anon15;

  anon32_Else:
    assume {:partition} !(le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8));
    goto anon15;

  anon30_Else:
    assume {:partition} firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8);
    goto anon15;

  anon15:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} !((firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} firstByte#Z#0 == Lit(244bv8);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} le_bv8(128bv8, secondByte#Z#0);
    goto anon19;

  anon36_Else:
    assume {:partition} !le_bv8(128bv8, secondByte#Z#0);
    goto anon19;

  anon35_Else:
    assume {:partition} firstByte#Z#0 != Lit(244bv8);
    goto anon19;

  anon34_Else:
    assume {:partition} (firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8));
    goto anon19;

  anon19:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} (firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(244bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 143bv8));
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} le_bv8(128bv8, thirdByte#Z#0);
    goto anon22;

  anon38_Else:
    assume {:partition} !le_bv8(128bv8, thirdByte#Z#0);
    goto anon22;

  anon37_Else:
    assume {:partition} !((firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(244bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 143bv8)));
    goto anon22;

  anon22:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} ((firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(244bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 143bv8))) && le_bv8(128bv8, thirdByte#Z#0) && le_bv8(thirdByte#Z#0, 191bv8);
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} le_bv8(128bv8, fourthByte#Z#0);
    goto anon25;

  anon40_Else:
    assume {:partition} !le_bv8(128bv8, fourthByte#Z#0);
    goto anon25;

  anon39_Else:
    assume {:partition} !(((firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(244bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 143bv8))) && le_bv8(128bv8, thirdByte#Z#0) && le_bv8(thirdByte#Z#0, 191bv8));
    goto anon25;

  anon25:
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> ((firstByte#Z#0 == Lit(240bv8) && le_bv8(144bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (le_bv8(241bv8, firstByte#Z#0) && le_bv8(firstByte#Z#0, 243bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 191bv8)) || (firstByte#Z#0 == Lit(244bv8) && le_bv8(128bv8, secondByte#Z#0) && le_bv8(secondByte#Z#0, 143bv8))) && le_bv8(128bv8, thirdByte#Z#0) && le_bv8(thirdByte#Z#0, 191bv8) && le_bv8(128bv8, fourthByte#Z#0) && le_bv8(fourthByte#Z#0, 191bv8);
    assume true;
    assume $Is(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0), TBool);
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> b#0;
    return;
}



function Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq) : DatatypeType
uses {
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#0: int :: { Seq#Take(s#0, i#0) } 0 < i#0 && i#0 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#0))) <==> true && Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(s#0) && Seq#Equal(prefix#0, Seq#Take(s#0, Seq#Length(prefix#0))) && (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(prefix#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1))))) && $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Seq#Length(s#0) >= LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)))) && (!(Seq#Length(s#0) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)))) ==> (Seq#Length(s#0) >= LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)))) && (!(Seq#Length(s#0) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)))) ==> (Seq#Length(s#0) >= LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(3)))) && (!(Seq#Length(s#0) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3)))) ==> Seq#Length(s#0) >= LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(4)))))) && Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == (if Seq#Length(s#0) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1)))) else (if Seq#Length(s#0) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2)))) else (if Seq#Length(s#0) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(3)))) else (if Seq#Length(s#0) >= LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Seq#Take(s#0, LitInt(4))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(4)))) else #Wrappers.Option.None())))));
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || (8 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Seq#Length(Lit(s#0)) >= LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(1))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1))))) ==> (Seq#Length(Lit(s#0)) >= LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(2))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(2))))) ==> (Seq#Length(Lit(s#0)) >= LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(3))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(3))))) ==> Seq#Length(Lit(s#0)) >= LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(4))))))) && Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) == (if Seq#Length(Lit(s#0)) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(1))))) else (if Seq#Length(Lit(s#0)) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(2)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(2))))) else (if Seq#Length(Lit(s#0)) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(3)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(3))))) else (if Seq#Length(Lit(s#0)) >= LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(4)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(4))))) else #Wrappers.Option.None())))));
}

function Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0: Seq) : bool;

function Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq() : Ty
uses {
axiom Tag(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) == Tagclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq && TagFamily(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) == tytagFamily$MinimalWellFormedCodeUnitSeq;
}

const unique Tagclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) } $IsBox(bx, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));

function Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(s#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (maybePrefix#0: DatatypeType where $Is(maybePrefix#0, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7592"} Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
  free ensures {:id "id7593"} (exists i#2: int :: { Seq#Take(s#0, i#2) } 0 < i#2 && i#2 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#2))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
  free ensures {:id "id7594"} Wrappers.Option.Some_q(maybePrefix#0) ==> Lit(true);
  free ensures {:id "id7595"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#1));
  free ensures {:id "id7596"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Length(prefix#1) <= Seq#Length(s#0));
  free ensures {:id "id7597"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))));
  free ensures {:id "id7598"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; (forall i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 < Seq#Length(prefix#1) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#3))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq) returns (maybePrefix#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#4: int;
  var ##s#0: Seq;
  var prefix#Z#0: Seq;
  var let#0#0#0: Seq;
  var i#5: int;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(106,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume Seq#Length(s#0) == LitInt(0);
    assume Wrappers.Option.None_q(maybePrefix#0);
    goto anon5;

  anon46_Else:
    assume Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
    goto anon5;

  anon5:
    havoc i#4;
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} true;
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} 0 < i#4;
    goto anon8;

  anon48_Else:
    assume {:partition} i#4 <= 0;
    goto anon8;

  anon8:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} 0 < i#4 && i#4 <= Seq#Length(s#0);
    assume 0 <= i#4 && i#4 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, i#4);
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#4));
    goto anon10;

  anon49_Else:
    assume {:partition} !(0 < i#4 && i#4 <= Seq#Length(s#0));
    goto anon10;

  anon47_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} Lit(true);
    goto anon12;

  anon50_Else:
    assume {:partition} !Lit(true);
    goto anon12;

  anon12:
    assume (exists i#2: int :: { Seq#Take(s#0, i#2) } 0 < i#2 && i#2 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume true;
    havoc prefix#Z#0;
    assume $Is(prefix#Z#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(maybePrefix#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume let#0#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume $Is(let#0#0#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#0 == let#0#0#0;
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0);
    goto anon15;

  anon52_Else:
    assume {:partition} Seq#Length(prefix#Z#0) <= 0;
    goto anon15;

  anon15:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    assume 0 <= Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    goto anon17;

  anon53_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0));
    goto anon17;

  anon17:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#0, Seq#Take(s#0, Seq#Length(prefix#Z#0)));
    havoc i#5;
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} true;
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} 0 < i#5;
    goto anon21;

  anon56_Else:
    assume {:partition} i#5 <= 0;
    goto anon21;

  anon21:
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} 0 < i#5 && i#5 < Seq#Length(prefix#Z#0);
    assume 0 <= i#5 && i#5 <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, i#5);
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#5));
    goto anon23;

  anon57_Else:
    assume {:partition} !(0 < i#5 && i#5 < Seq#Length(prefix#Z#0));
    goto anon23;

  anon55_Else:
    assume {:partition} false;
    goto anon23;

  anon23:
    goto anon24;

  anon54_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#0, Seq#Take(s#0, Seq#Length(prefix#Z#0))));
    goto anon24;

  anon24:
    assume (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#1) && Seq#Length(prefix#1) <= Seq#Length(s#0) && Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))) && (forall i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 < Seq#Length(prefix#1) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#3))));
    goto anon26;

  anon51_Else:
    assume Wrappers.Option.Some_q(maybePrefix#0) ==> true && (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#1) && Seq#Length(prefix#1) <= Seq#Length(s#0) && Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))) && (forall i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 < Seq#Length(prefix#1) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#3))));
    goto anon26;

  anon26:
    assume false;
    return;

  anon45_Else:
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(1);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#2 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#2, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) == LitInt(1);
    assume Seq#Length(##s#2) == LitInt(1);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)));
    goto anon29;

  anon58_Else:
    assume {:partition} LitInt(1) > Seq#Length(s#0);
    goto anon29;

  anon29:
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume $Is(#Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1)))), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1))));
    assume true;
    assume $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon44;

  anon59_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))));
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(2);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##s#3 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##s#3, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#3) == LitInt(2);
    assume Seq#Length(##s#3) == LitInt(2);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)));
    goto anon33;

  anon60_Else:
    assume {:partition} LitInt(2) > Seq#Length(s#0);
    goto anon33;

  anon33:
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    assume $Is(#Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2)))), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2))));
    assume true;
    assume $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon44;

  anon61_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))));
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(3);
    assume 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    ##s#4 := Seq#Take(s#0, LitInt(3));
    assume $IsAlloc(##s#4, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#4) == LitInt(3);
    assume Seq#Length(##s#4) == LitInt(3);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(3)));
    goto anon37;

  anon62_Else:
    assume {:partition} LitInt(3) > Seq#Length(s#0);
    goto anon37;

  anon37:
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3)));
    assume 0 <= LitInt(3) && LitInt(3) <= Seq#Length(s#0);
    assume $Is(#Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(3)))), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(3))));
    assume true;
    assume $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon44;

  anon63_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3))));
    goto anon64_Then, anon64_Else;

  anon64_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(4);
    assume 0 <= LitInt(4) && LitInt(4) <= Seq#Length(s#0);
    ##s#5 := Seq#Take(s#0, LitInt(4));
    assume $IsAlloc(##s#5, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#5) == LitInt(4);
    assume Seq#Length(##s#5) == LitInt(4);
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(4)));
    goto anon41;

  anon64_Else:
    assume {:partition} LitInt(4) > Seq#Length(s#0);
    goto anon41;

  anon41:
    goto anon65_Then, anon65_Else;

  anon65_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Seq#Take(s#0, LitInt(4)));
    assume 0 <= LitInt(4) && LitInt(4) <= Seq#Length(s#0);
    assume $Is(#Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(4)))), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(4))));
    assume true;
    assume $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon44;

  anon65_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Seq#Take(s#0, LitInt(4))));
    assume $Is(Lit(#Wrappers.Option.None()), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon44;

  anon44:
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == maybePrefix#0;
    return;
}



function Utf8EncodingForm.__default.EncodeScalarValue(v#0: bv24) : Seq
uses {
axiom 9 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue(v#0) } Utf8EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (9 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
axiom 9 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue(v#0) } Utf8EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (9 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> (le_bv24(v#0, 127bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0)) && (!le_bv24(v#0, 127bv24) ==> (le_bv24(v#0, 2047bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0)) && (!le_bv24(v#0, 2047bv24) ==> (le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0)) && (!le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0)))) && Utf8EncodingForm.__default.EncodeScalarValue(v#0) == (if le_bv24(v#0, 127bv24) then Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) else (if le_bv24(v#0, 2047bv24) then Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) else (if le_bv24(v#0, 65535bv24) then Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) else Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0)))));
axiom 9 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValue(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValue#canCall(Lit(v#0)) || (9 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> (le_bv24(v#0, 127bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0))) && (!le_bv24(v#0, 127bv24) ==> (le_bv24(v#0, 2047bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0))) && (!le_bv24(v#0, 2047bv24) ==> (le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0))) && (!le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0))))) && Utf8EncodingForm.__default.EncodeScalarValue(Lit(v#0)) == (if le_bv24(v#0, 127bv24) then Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) else (if le_bv24(v#0, 2047bv24) then Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) else (if le_bv24(v#0, 65535bv24) then Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) else Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0))))));
}

function Utf8EncodingForm.__default.EncodeScalarValue#canCall(v#0: bv24) : bool;

function Utf8EncodingForm.__default.EncodeScalarValue#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf8EncodingForm.__default.EncodeScalarValue#requires(v#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.EncodeScalarValue (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValue(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarValue (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValue(v#0: bv24) returns (m#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var ##v#1: bv24;
  var ##v#2: bv24;
  var ##v#3: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarValue", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(121,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} le_bv24(v#0, 127bv24);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(0bv24, ##v#0);
    assume {:subsumption 0} le_bv24(##v#0, 127bv24);
    assume le_bv24(0bv24, ##v#0) && le_bv24(##v#0, 127bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0);
    assume Utf8EncodingForm.__default.EncodeScalarValue(v#0) == Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0);
    assume Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    goto anon10;

  anon12_Else:
    assume {:partition} !le_bv24(v#0, 127bv24);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} le_bv24(v#0, 2047bv24);
    ##v#1 := v#0;
    assume $IsAlloc(##v#1, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(128bv24, ##v#1);
    assume {:subsumption 0} le_bv24(##v#1, 2047bv24);
    assume le_bv24(128bv24, ##v#1) && le_bv24(##v#1, 2047bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarValue(v#0) == Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0);
    assume Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    goto anon10;

  anon13_Else:
    assume {:partition} !le_bv24(v#0, 2047bv24);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} le_bv24(v#0, 65535bv24);
    ##v#2 := v#0;
    assume $IsAlloc(##v#2, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(2048bv24, ##v#2);
    assume {:subsumption 0} le_bv24(##v#2, 65535bv24);
    assume le_bv24(2048bv24, ##v#2) && le_bv24(##v#2, 65535bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarValue(v#0) == Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0);
    assume Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    goto anon10;

  anon14_Else:
    assume {:partition} !le_bv24(v#0, 65535bv24);
    ##v#3 := v#0;
    assume $IsAlloc(##v#3, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(65536bv24, ##v#3);
    assume {:subsumption 0} le_bv24(##v#3, 1114111bv24);
    assume le_bv24(65536bv24, ##v#3) && le_bv24(##v#3, 1114111bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarValue(v#0) == Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0);
    assume Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    goto anon10;

  anon10:
    assume Utf8EncodingForm.__default.EncodeScalarValue(v#0) == m#0;
    return;
}



function Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0: bv24) : Seq
uses {
axiom 8 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (8 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0)) == LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
axiom 8 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (8 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == (var x#0 := and_bv24(v#0, 127bv24)[7:0]; (var firstByte#0 := (0bv1 ++ x#0): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#0)))));
axiom 8 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0)) || (8 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) == (var x#1 := Lit(and_bv24(v#0, 127bv24))[7:0]; (var firstByte#1 := (0bv1 ++ x#1): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#1)))));
}

function Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0: bv24) : bool;

function Utf8EncodingForm.__default.EncodeScalarValueSingleByte#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf8EncodingForm.__default.EncodeScalarValueSingleByte#requires(v#0) <==> le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)));

procedure {:verboseName "Utf8EncodingForm.EncodeScalarValueSingleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7652"} Seq#Length(m#0) == LitInt(1);
  free ensures {:id "id7653"} Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(m#0) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(m#0) || (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; Lit(true));
  free ensures {:id "id7654"} Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(m#0) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(m#0) || (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; le_bv8(0bv8, firstByte#2));
  free ensures {:id "id7655"} Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(m#0) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(m#0) || (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; le_bv8(firstByte#2, 127bv8));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarValueSingleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0: bv24) returns (m#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var x#Z#0: bv7;
  var let#0#0#0: bv7;
  var newtype$check#0: bv24;
  var firstByte#Z#0: bv8;
  var let#1#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarValueSingleByte", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(129,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} le_bv24(0bv24, v#0);
    goto anon3;

  anon6_Else:
    assume {:partition} !le_bv24(0bv24, v#0);
    goto anon3;

  anon3:
    assume le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Seq#Length(m#0) == LitInt(1);
    ##s#0 := m#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(1);
    assume Seq#Length(##s#0) == LitInt(1);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(m#0);
    assume Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(m#0);
    assume false;
    return;

  anon7_Else:
    havoc x#Z#0;
    assume true;
    newtype$check#0 := and_bv24(v#0, 127bv24);
    assume lt_bv24(newtype$check#0, 128bv24);
    assume let#0#0#0 == and_bv24(v#0, 127bv24)[7:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(7));
    assume x#Z#0 == let#0#0#0;
    havoc firstByte#Z#0;
    assume true;
    assume let#1#0#0 == (0bv1 ++ x#Z#0): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#1#0#0;
    assume $Is(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#Z#0)), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == Seq#Build(Seq#Empty(): Seq, $Box(firstByte#Z#0));
    assume true;
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == m#0;
    return;
}



function Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0: bv24) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (4 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0)) == LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), TSeq(TBitvector(8))));
axiom 4 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (4 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == (var x#0 := and_bv24(v#0, 63bv24)[6:0]; (var y#0 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#0 := or_bv8(192bv8, (0bv3 ++ y#0): bv8); (var secondByte#0 := or_bv8(128bv8, (0bv2 ++ x#0): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#0)), $Box(secondByte#0)))))));
axiom 4 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0)) || (4 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) == (var x#1 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#1 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#1 := or_bv8(192bv8, (0bv3 ++ y#1): bv8); (var secondByte#1 := or_bv8(128bv8, (0bv2 ++ x#1): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#1)), $Box(secondByte#1)))))));
}

function Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0: bv24) : bool;

function Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#requires(v#0) <==> le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)));

procedure {:verboseName "Utf8EncodingForm.EncodeScalarValueDoubleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (s#0: Seq where $Is(s#0, TSeq(TBitvector(8))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7668"} Seq#Length(s#0) == LitInt(2);
  free ensures {:id "id7669"} Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#2)));
  free ensures {:id "id7670"} Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(firstByte#2, 223bv8)));
  free ensures {:id "id7671"} Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(128bv8, secondByte#2)));
  free ensures {:id "id7672"} Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(secondByte#2, 191bv8)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarValueDoubleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0: bv24) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var x#Z#0: bv6;
  var let#0#0#0: bv6;
  var newtype$check#0: bv24;
  var y#Z#0: bv5;
  var let#1#0#0: bv5;
  var newtype$check#1: int;
  var newtype$check#2: bv24;
  var firstByte#Z#0: bv8;
  var let#2#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#3#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarValueDoubleByte", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(141,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} le_bv24(128bv24, v#0);
    goto anon3;

  anon6_Else:
    assume {:partition} !le_bv24(128bv24, v#0);
    goto anon3;

  anon3:
    assume le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), TSeq(TBitvector(8)));
    assume Seq#Length(s#0) == LitInt(2);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(2);
    assume Seq#Length(##s#0) == LitInt(2);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0);
    assume false;
    return;

  anon7_Else:
    havoc x#Z#0;
    assume true;
    newtype$check#0 := and_bv24(v#0, 63bv24);
    assume lt_bv24(newtype$check#0, 64bv24);
    assume let#0#0#0 == and_bv24(v#0, 63bv24)[6:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(6));
    assume x#Z#0 == let#0#0#0;
    havoc y#Z#0;
    assume true;
    newtype$check#1 := LitInt(6);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(6bv5, 24bv5);
    newtype$check#2 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24);
    assume lt_bv24(newtype$check#2, 32bv24);
    assume let#1#0#0 == RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0];
    assume true;
    assume $Is(let#1#0#0, TBitvector(5));
    assume y#Z#0 == let#1#0#0;
    havoc firstByte#Z#0;
    assume true;
    assume let#2#0#0 == or_bv8(192bv8, (0bv3 ++ y#Z#0): bv8);
    assume true;
    assume $Is(let#2#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#2#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume let#3#0#0 == or_bv8(128bv8, (0bv2 ++ x#Z#0): bv8);
    assume true;
    assume $Is(let#3#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#3#0#0;
    assume Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#Z#0)), $Box(secondByte#Z#0));
    assume true;
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), TSeq(TBitvector(8)));
    assume Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == s#0;
    return;
}



function Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0: bv24) : Seq
uses {
axiom 5 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (5 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0)) == LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), TSeq(TBitvector(8))));
axiom 5 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (5 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == (var x#0 := and_bv24(v#0, 63bv24)[6:0]; (var y#0 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#0 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#0 := or_bv8(224bv8, (0bv4 ++ z#0): bv8); (var secondByte#0 := or_bv8(128bv8, (0bv2 ++ y#0): bv8); (var thirdByte#0 := or_bv8(128bv8, (0bv2 ++ x#0): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#0)), $Box(secondByte#0)), $Box(thirdByte#0)))))))));
axiom 5 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0)) || (5 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) == (var x#1 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#1 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#1 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#1 := or_bv8(224bv8, (0bv4 ++ z#1): bv8); (var secondByte#1 := or_bv8(128bv8, (0bv2 ++ y#1): bv8); (var thirdByte#1 := or_bv8(128bv8, (0bv2 ++ x#1): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#1)), $Box(secondByte#1)), $Box(thirdByte#1)))))))));
}

function Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0: bv24) : bool;

function Utf8EncodingForm.__default.EncodeScalarValueTripleByte#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf8EncodingForm.__default.EncodeScalarValueTripleByte#requires(v#0) <==> le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)));

procedure {:verboseName "Utf8EncodingForm.EncodeScalarValueTripleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (s#0: Seq where $Is(s#0, TSeq(TBitvector(8))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7691"} Seq#Length(s#0) == LitInt(3);
  free ensures {:id "id7692"} Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (firstByte#2 == Lit(224bv8) && le_bv8(160bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (le_bv8(225bv8, firstByte#2) && le_bv8(firstByte#2, 236bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (firstByte#2 == Lit(237bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 159bv8)) || (le_bv8(238bv8, firstByte#2) && le_bv8(firstByte#2, 239bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)))));
  free ensures {:id "id7693"} Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; le_bv8(128bv8, thirdByte#2))));
  free ensures {:id "id7694"} Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; le_bv8(thirdByte#2, 191bv8))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarValueTripleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0: bv24) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var x#Z#0: bv6;
  var let#0#0#0: bv6;
  var newtype$check#0: bv24;
  var y#Z#0: bv6;
  var let#1#0#0: bv6;
  var newtype$check#1: int;
  var newtype$check#2: bv24;
  var z#Z#0: bv4;
  var let#2#0#0: bv4;
  var newtype$check#3: int;
  var newtype$check#4: bv24;
  var firstByte#Z#0: bv8;
  var let#3#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#4#0#0: bv8;
  var thirdByte#Z#0: bv8;
  var let#5#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarValueTripleByte", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(155,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} le_bv24(2048bv24, v#0);
    goto anon3;

  anon6_Else:
    assume {:partition} !le_bv24(2048bv24, v#0);
    goto anon3;

  anon3:
    assume le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), TSeq(TBitvector(8)));
    assume Seq#Length(s#0) == LitInt(3);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(3);
    assume Seq#Length(##s#0) == LitInt(3);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0);
    assume false;
    return;

  anon7_Else:
    havoc x#Z#0;
    assume true;
    newtype$check#0 := and_bv24(v#0, 63bv24);
    assume lt_bv24(newtype$check#0, 64bv24);
    assume let#0#0#0 == and_bv24(v#0, 63bv24)[6:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(6));
    assume x#Z#0 == let#0#0#0;
    havoc y#Z#0;
    assume true;
    newtype$check#1 := LitInt(6);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(6bv5, 24bv5);
    newtype$check#2 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24);
    assume lt_bv24(newtype$check#2, 64bv24);
    assume let#1#0#0 == RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0];
    assume true;
    assume $Is(let#1#0#0, TBitvector(6));
    assume y#Z#0 == let#1#0#0;
    havoc z#Z#0;
    assume true;
    newtype$check#3 := LitInt(12);
    assume 0 <= newtype$check#3 && newtype$check#3 < 32;
    assume le_bv5(12bv5, 24bv5);
    newtype$check#4 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24);
    assume lt_bv24(newtype$check#4, 16bv24);
    assume let#2#0#0 == RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0];
    assume true;
    assume $Is(let#2#0#0, TBitvector(4));
    assume z#Z#0 == let#2#0#0;
    havoc firstByte#Z#0;
    assume true;
    assume let#3#0#0 == or_bv8(224bv8, (0bv4 ++ z#Z#0): bv8);
    assume true;
    assume $Is(let#3#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#3#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume let#4#0#0 == or_bv8(128bv8, (0bv2 ++ y#Z#0): bv8);
    assume true;
    assume $Is(let#4#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#4#0#0;
    havoc thirdByte#Z#0;
    assume true;
    assume let#5#0#0 == or_bv8(128bv8, (0bv2 ++ x#Z#0): bv8);
    assume true;
    assume $Is(let#5#0#0, TBitvector(8));
    assume thirdByte#Z#0 == let#5#0#0;
    assume Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#Z#0)), $Box(secondByte#Z#0)), $Box(thirdByte#Z#0));
    assume true;
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), TSeq(TBitvector(8)));
    assume Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == s#0;
    return;
}



function Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0: bv24) : Seq
uses {
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0)) == LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), TSeq(TBitvector(8))));
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == (var x#0 := and_bv24(v#0, 63bv24)[6:0]; (var y#0 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#0 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#0 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#0 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#0 := or_bv8(240bv8, (0bv5 ++ u1#0): bv8); (var secondByte#0 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#0): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#0): bv8); (var thirdByte#0 := or_bv8(128bv8, (0bv2 ++ y#0): bv8); (var fourthByte#0 := or_bv8(128bv8, (0bv2 ++ x#0): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#0)), $Box(secondByte#0)), $Box(thirdByte#0)), $Box(fourthByte#0))))))))))));
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0)) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) == (var x#1 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#1 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#1 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#1 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#1 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#1 := or_bv8(240bv8, (0bv5 ++ u1#1): bv8); (var secondByte#1 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#1): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#1): bv8); (var thirdByte#1 := or_bv8(128bv8, (0bv2 ++ y#1): bv8); (var fourthByte#1 := or_bv8(128bv8, (0bv2 ++ x#1): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#1)), $Box(secondByte#1)), $Box(thirdByte#1)), $Box(fourthByte#1))))))))))));
}

function Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0: bv24) : bool;

function Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#requires(v#0) <==> le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)));

procedure {:verboseName "Utf8EncodingForm.EncodeScalarValueQuadrupleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (s#0: Seq where $Is(s#0, TSeq(TBitvector(8))));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7720"} Seq#Length(s#0) == LitInt(4);
  free ensures {:id "id7721"} Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; (firstByte#2 == Lit(240bv8) && le_bv8(144bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (le_bv8(241bv8, firstByte#2) && le_bv8(firstByte#2, 243bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (firstByte#2 == Lit(244bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 143bv8))))));
  free ensures {:id "id7722"} Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; le_bv8(128bv8, thirdByte#2)))));
  free ensures {:id "id7723"} Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; le_bv8(thirdByte#2, 191bv8)))));
  free ensures {:id "id7724"} Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; le_bv8(128bv8, fourthByte#2)))));
  free ensures {:id "id7725"} Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) || (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; le_bv8(fourthByte#2, 191bv8)))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarValueQuadrupleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0: bv24) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var x#Z#0: bv6;
  var let#0#0#0: bv6;
  var newtype$check#0: bv24;
  var y#Z#0: bv6;
  var let#1#0#0: bv6;
  var newtype$check#1: int;
  var newtype$check#2: bv24;
  var z#Z#0: bv4;
  var let#2#0#0: bv4;
  var newtype$check#3: int;
  var newtype$check#4: bv24;
  var u2#Z#0: bv2;
  var let#3#0#0: bv2;
  var newtype$check#5: int;
  var newtype$check#6: bv24;
  var u1#Z#0: bv3;
  var let#4#0#0: bv3;
  var newtype$check#7: int;
  var newtype$check#8: bv24;
  var firstByte#Z#0: bv8;
  var let#5#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#6#0#0: bv8;
  var newtype$check#9: int;
  var thirdByte#Z#0: bv8;
  var let#7#0#0: bv8;
  var fourthByte#Z#0: bv8;
  var let#8#0#0: bv8;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarValueQuadrupleByte", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(171,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} le_bv24(65536bv24, v#0);
    goto anon3;

  anon6_Else:
    assume {:partition} !le_bv24(65536bv24, v#0);
    goto anon3;

  anon3:
    assume le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), TSeq(TBitvector(8)));
    assume Seq#Length(s#0) == LitInt(4);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0);
    assume false;
    return;

  anon7_Else:
    assume true;
    assume le_bv24(v#0, 2097151bv24);
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(178,24)"} true;
    havoc x#Z#0;
    assume true;
    newtype$check#0 := and_bv24(v#0, 63bv24);
    assume lt_bv24(newtype$check#0, 64bv24);
    assume let#0#0#0 == and_bv24(v#0, 63bv24)[6:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(6));
    assume x#Z#0 == let#0#0#0;
    havoc y#Z#0;
    assume true;
    newtype$check#1 := LitInt(6);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(6bv5, 24bv5);
    newtype$check#2 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24);
    assume lt_bv24(newtype$check#2, 64bv24);
    assume let#1#0#0 == RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0];
    assume true;
    assume $Is(let#1#0#0, TBitvector(6));
    assume y#Z#0 == let#1#0#0;
    havoc z#Z#0;
    assume true;
    newtype$check#3 := LitInt(12);
    assume 0 <= newtype$check#3 && newtype$check#3 < 32;
    assume le_bv5(12bv5, 24bv5);
    newtype$check#4 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24);
    assume lt_bv24(newtype$check#4, 16bv24);
    assume let#2#0#0 == RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0];
    assume true;
    assume $Is(let#2#0#0, TBitvector(4));
    assume z#Z#0 == let#2#0#0;
    havoc u2#Z#0;
    assume true;
    newtype$check#5 := LitInt(16);
    assume 0 <= newtype$check#5 && newtype$check#5 < 32;
    assume le_bv5(16bv5, 24bv5);
    newtype$check#6 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24);
    assume lt_bv24(newtype$check#6, 4bv24);
    assume let#3#0#0 == RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0];
    assume true;
    assume $Is(let#3#0#0, TBitvector(2));
    assume u2#Z#0 == let#3#0#0;
    havoc u1#Z#0;
    assume true;
    newtype$check#7 := LitInt(18);
    assume 0 <= newtype$check#7 && newtype$check#7 < 32;
    assume le_bv5(18bv5, 24bv5);
    newtype$check#8 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24);
    assume lt_bv24(newtype$check#8, 8bv24);
    assume let#4#0#0 == RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0];
    assume true;
    assume $Is(let#4#0#0, TBitvector(3));
    assume u1#Z#0 == let#4#0#0;
    havoc firstByte#Z#0;
    assume true;
    assume let#5#0#0 == or_bv8(240bv8, (0bv5 ++ u1#Z#0): bv8);
    assume true;
    assume $Is(let#5#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#5#0#0;
    havoc secondByte#Z#0;
    assume true;
    newtype$check#9 := LitInt(4);
    assume 0 <= newtype$check#9 && newtype$check#9 < 16;
    assume le_bv4(4bv4, 8bv4);
    assume let#6#0#0 == or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#Z#0): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#Z#0): bv8);
    assume true;
    assume $Is(let#6#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#6#0#0;
    havoc thirdByte#Z#0;
    assume true;
    assume let#7#0#0 == or_bv8(128bv8, (0bv2 ++ y#Z#0): bv8);
    assume true;
    assume $Is(let#7#0#0, TBitvector(8));
    assume thirdByte#Z#0 == let#7#0#0;
    havoc fourthByte#Z#0;
    assume true;
    assume let#8#0#0 == or_bv8(128bv8, (0bv2 ++ x#Z#0): bv8);
    assume true;
    assume $Is(let#8#0#0, TBitvector(8));
    assume fourthByte#Z#0 == let#8#0#0;
    assume Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#Z#0)), $Box(secondByte#Z#0)), $Box(thirdByte#Z#0)), $Box(fourthByte#Z#0));
    assume true;
    assume $Is(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), TSeq(TBitvector(8)));
    assume Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == s#0;
    return;
}



function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq) : bv24
uses {
axiom 10 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || (10 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) ==> Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValue(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 10 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || (10 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) ==> (Seq#Length(m#0) == LitInt(1) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0)) && (Seq#Length(m#0) != LitInt(1) ==> (Seq#Length(m#0) == LitInt(2) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0)) && (Seq#Length(m#0) != LitInt(2) ==> (Seq#Length(m#0) == LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0)) && (Seq#Length(m#0) != LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0)))) && Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == (if Seq#Length(m#0) == LitInt(1) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) else (if Seq#Length(m#0) == LitInt(2) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) else (if Seq#Length(m#0) == LitInt(3) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) else Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)))));
axiom 10 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(Lit(m#0)) || (10 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) ==> (Seq#Length(Lit(m#0)) == LitInt(1) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(1) ==> (Seq#Length(Lit(m#0)) == LitInt(2) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(2) ==> (Seq#Length(Lit(m#0)) == LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0))))) && Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) == (if Seq#Length(Lit(m#0)) == LitInt(1) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) else (if Seq#Length(Lit(m#0)) == LitInt(2) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) else (if Seq#Length(Lit(m#0)) == LitInt(3) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) else Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0))))));
}

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(m#0) } $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(m#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7766"} Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValue(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var ##m#0: Seq;
  var ##m#1: Seq;
  var ##m#2: Seq;
  var ##m#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(194,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume Utf8EncodingForm.__default.EncodeScalarValue#canCall(v#0);
    assume Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValue(v#0), m#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Length(m#0) == LitInt(1);
    ##m#0 := m#0;
    assume $IsAlloc(##m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume {:subsumption 0} Seq#Length(##m#0) == LitInt(1);
    assume Seq#Length(##m#0) == LitInt(1);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0);
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Tclass.Unicode.ScalarValue());
    goto anon10;

  anon12_Else:
    assume {:partition} Seq#Length(m#0) != LitInt(1);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Length(m#0) == LitInt(2);
    ##m#1 := m#0;
    assume $IsAlloc(##m#1, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume {:subsumption 0} Seq#Length(##m#1) == LitInt(2);
    assume Seq#Length(##m#1) == LitInt(2);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0);
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Tclass.Unicode.ScalarValue());
    goto anon10;

  anon13_Else:
    assume {:partition} Seq#Length(m#0) != LitInt(2);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Length(m#0) == LitInt(3);
    ##m#2 := m#0;
    assume $IsAlloc(##m#2, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume {:subsumption 0} Seq#Length(##m#2) == LitInt(3);
    assume Seq#Length(##m#2) == LitInt(3);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0);
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Tclass.Unicode.ScalarValue());
    goto anon10;

  anon14_Else:
    assume {:partition} Seq#Length(m#0) != LitInt(3);
    assume true;
    assume Seq#Length(m#0) == LitInt(4);
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(199,24)"} true;
    ##m#3 := m#0;
    assume $IsAlloc(##m#3, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume {:subsumption 0} Seq#Length(##m#3) == LitInt(4);
    assume Seq#Length(##m#3) == LitInt(4);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0);
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0);
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Tclass.Unicode.ScalarValue());
    goto anon10;

  anon10:
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == v#0;
    return;
}



function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0: Seq) : bv24
uses {
axiom 9 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || (9 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), 127bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 9 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || (9 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (var firstByte#0 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var x#0 := firstByte#0[7:0]; (0bv17 ++ x#0): bv24)));
axiom 9 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0)) || (9 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) == (var firstByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var x#1 := firstByte#1[7:0]; (0bv17 ++ x#1): bv24)));
}

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#requires(m#0) } $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#requires(m#0) <==> Seq#Length(m#0) == LitInt(1)));

procedure {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7778"} le_bv24(0bv24, v#0);
  free ensures {:id "id7779"} le_bv24(v#0, 127bv24);
  free ensures {:id "id7780"} Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var x#Z#0: bv7;
  var let#1#0#0: bv7;
  var newtype$check#0: bv8;
  var newtype$check#1: bv7;
  var newtype$check#2: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(202,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(m#0) == LitInt(1);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(0bv24, v#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(0bv24, v#0);
    goto anon4;

  anon4:
    assume le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(0bv24, ##v#0);
    assume {:subsumption 0} le_bv24(##v#0, 127bv24);
    assume le_bv24(0bv24, ##v#0) && le_bv24(##v#0, 127bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0);
    assume Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0), m#0);
    assume false;
    return;

  anon6_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(m#0);
    assume let#0#0#0 == $Unbox(Seq#Index(m#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc x#Z#0;
    assume true;
    newtype$check#0 := firstByte#Z#0;
    assume lt_bv8(newtype$check#0, 128bv8);
    assume let#1#0#0 == firstByte#Z#0[7:0];
    assume true;
    assume $Is(let#1#0#0, TBitvector(7));
    assume x#Z#0 == let#1#0#0;
    newtype$check#1 := x#Z#0;
    assume le_bv24(0bv24, (0bv17 ++ newtype$check#1): bv24) && le_bv24((0bv17 ++ newtype$check#1): bv24, 1114111bv24);
    assume (lt_bv24((0bv17 ++ newtype$check#1): bv24, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24((0bv17 ++ newtype$check#1): bv24, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24((0bv17 ++ newtype$check#1): bv24, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24((0bv17 ++ newtype$check#1): bv24, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#2 := (0bv17 ++ x#Z#0): bv24;
    assume le_bv24(0bv24, newtype$check#2) && le_bv24(newtype$check#2, 1114111bv24);
    assume (lt_bv24(newtype$check#2, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#2, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#2, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#2, Unicode.__default.LOW__SURROGATE__MAX()));
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (0bv17 ++ x#Z#0): bv24;
    assume true;
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == v#0;
    return;
}



function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0: Seq) : bv24
uses {
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> le_bv24(128bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), 2047bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == (var firstByte#0 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#0 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var y#0 := (0bv16 ++ and_bv8(firstByte#0, 31bv8)): bv24; (var x#0 := (0bv16 ++ and_bv8(secondByte#0, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#0, (0bv19 ++ 6bv5): bv24), x#0))))));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0)) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) == (var firstByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var y#1 := (0bv16 ++ and_bv8(firstByte#1, 31bv8)): bv24; (var x#1 := (0bv16 ++ and_bv8(secondByte#1, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#1, (0bv19 ++ 6bv5): bv24), x#1))))));
}

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#requires(m#0) } $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#requires(m#0) <==> Seq#Length(m#0) == LitInt(2)));

procedure {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7798"} le_bv24(128bv24, v#0);
  free ensures {:id "id7799"} le_bv24(v#0, 2047bv24);
  free ensures {:id "id7800"} Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#1#0#0: bv8;
  var y#Z#0: bv24;
  var let#2#0#0: bv24;
  var x#Z#0: bv24;
  var let#3#0#0: bv24;
  var newtype$check#0: int;
  var newtype$check#1: bv24;
  var newtype$check#2: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(212,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(m#0) == LitInt(2);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(128bv24, v#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(128bv24, v#0);
    goto anon4;

  anon4:
    assume le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(128bv24, ##v#0);
    assume {:subsumption 0} le_bv24(##v#0, 2047bv24);
    assume le_bv24(128bv24, ##v#0) && le_bv24(##v#0, 2047bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0);
    assume Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), m#0);
    assume false;
    return;

  anon6_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(m#0);
    assume let#0#0#0 == $Unbox(Seq#Index(m#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(m#0);
    assume let#1#0#0 == $Unbox(Seq#Index(m#0, LitInt(1))): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#1#0#0;
    havoc y#Z#0;
    assume true;
    assume let#2#0#0 == (0bv16 ++ and_bv8(firstByte#Z#0, 31bv8)): bv24;
    assume true;
    assume $Is(let#2#0#0, TBitvector(24));
    assume y#Z#0 == let#2#0#0;
    havoc x#Z#0;
    assume true;
    assume let#3#0#0 == (0bv16 ++ and_bv8(secondByte#Z#0, 63bv8)): bv24;
    assume true;
    assume $Is(let#3#0#0, TBitvector(24));
    assume x#Z#0 == let#3#0#0;
    newtype$check#0 := LitInt(6);
    assume 0 <= newtype$check#0 && newtype$check#0 < 32;
    assume le_bv5(6bv5, 24bv5);
    newtype$check#1 := x#Z#0;
    assume le_bv24(0bv24, newtype$check#1) && le_bv24(newtype$check#1, 1114111bv24);
    assume (lt_bv24(newtype$check#1, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#1, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#1, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#1, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#2 := x#Z#0;
    assume le_bv24(0bv24, newtype$check#2) && le_bv24(newtype$check#2, 1114111bv24);
    assume (lt_bv24(newtype$check#2, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#2, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#2, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#2, Unicode.__default.LOW__SURROGATE__MAX()));
    assume $Is(or_bv24(LeftShift_bv24(y#Z#0, (0bv19 ++ 6bv5): bv24), x#Z#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == or_bv24(LeftShift_bv24(y#Z#0, (0bv19 ++ 6bv5): bv24), x#Z#0);
    assume true;
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == v#0;
    return;
}



function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0: Seq) : bv24
uses {
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> le_bv24(2048bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), 65535bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == (var firstByte#0 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#0 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#0 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var z#0 := (0bv16 ++ and_bv8(firstByte#0, 15bv8)): bv24; (var y#0 := (0bv16 ++ and_bv8(secondByte#0, 63bv8)): bv24; (var x#0 := (0bv16 ++ and_bv8(thirdByte#0, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#0, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#0, (0bv19 ++ 6bv5): bv24)), x#0))))))));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0)) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) == (var firstByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var z#1 := (0bv16 ++ and_bv8(firstByte#1, 15bv8)): bv24; (var y#1 := (0bv16 ++ and_bv8(secondByte#1, 63bv8)): bv24; (var x#1 := (0bv16 ++ and_bv8(thirdByte#1, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#1, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#1, (0bv19 ++ 6bv5): bv24)), x#1))))))));
}

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#requires(m#0) } $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#requires(m#0) <==> Seq#Length(m#0) == LitInt(3)));

procedure {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7825"} le_bv24(2048bv24, v#0);
  free ensures {:id "id7826"} le_bv24(v#0, 65535bv24);
  free ensures {:id "id7827"} Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#1#0#0: bv8;
  var thirdByte#Z#0: bv8;
  var let#2#0#0: bv8;
  var z#Z#0: bv24;
  var let#3#0#0: bv24;
  var y#Z#0: bv24;
  var let#4#0#0: bv24;
  var x#Z#0: bv24;
  var let#5#0#0: bv24;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: bv24;
  var newtype$check#3: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(224,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(m#0) == LitInt(3);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(2048bv24, v#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(2048bv24, v#0);
    goto anon4;

  anon4:
    assume le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(2048bv24, ##v#0);
    assume {:subsumption 0} le_bv24(##v#0, 65535bv24);
    assume le_bv24(2048bv24, ##v#0) && le_bv24(##v#0, 65535bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0);
    assume Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), m#0);
    assume false;
    return;

  anon6_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(m#0);
    assume let#0#0#0 == $Unbox(Seq#Index(m#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(m#0);
    assume let#1#0#0 == $Unbox(Seq#Index(m#0, LitInt(1))): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#1#0#0;
    havoc thirdByte#Z#0;
    assume true;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(m#0);
    assume let#2#0#0 == $Unbox(Seq#Index(m#0, LitInt(2))): bv8;
    assume true;
    assume $Is(let#2#0#0, TBitvector(8));
    assume thirdByte#Z#0 == let#2#0#0;
    havoc z#Z#0;
    assume true;
    assume let#3#0#0 == (0bv16 ++ and_bv8(firstByte#Z#0, 15bv8)): bv24;
    assume true;
    assume $Is(let#3#0#0, TBitvector(24));
    assume z#Z#0 == let#3#0#0;
    havoc y#Z#0;
    assume true;
    assume let#4#0#0 == (0bv16 ++ and_bv8(secondByte#Z#0, 63bv8)): bv24;
    assume true;
    assume $Is(let#4#0#0, TBitvector(24));
    assume y#Z#0 == let#4#0#0;
    havoc x#Z#0;
    assume true;
    assume let#5#0#0 == (0bv16 ++ and_bv8(thirdByte#Z#0, 63bv8)): bv24;
    assume true;
    assume $Is(let#5#0#0, TBitvector(24));
    assume x#Z#0 == let#5#0#0;
    assume true;
    assume {:split_here} Lit(true);
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(235,29)"} true;
    newtype$check#0 := LitInt(12);
    assume 0 <= newtype$check#0 && newtype$check#0 < 32;
    assume le_bv5(12bv5, 24bv5);
    newtype$check#1 := LitInt(6);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(6bv5, 24bv5);
    newtype$check#2 := x#Z#0;
    assume le_bv24(0bv24, newtype$check#2) && le_bv24(newtype$check#2, 1114111bv24);
    assume (lt_bv24(newtype$check#2, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#2, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#2, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#2, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#3 := x#Z#0;
    assume le_bv24(0bv24, newtype$check#3) && le_bv24(newtype$check#3, 1114111bv24);
    assume (lt_bv24(newtype$check#3, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#3, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#3, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#3, Unicode.__default.LOW__SURROGATE__MAX()));
    assume $Is(or_bv24(or_bv24(LeftShift_bv24(z#Z#0, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#Z#0, (0bv19 ++ 6bv5): bv24)), x#Z#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == or_bv24(or_bv24(LeftShift_bv24(z#Z#0, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#Z#0, (0bv19 ++ 6bv5): bv24)), x#Z#0);
    assume true;
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == v#0;
    return;
}



function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0: Seq) : bv24
uses {
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> le_bv24(65536bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), 1114111bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == (var firstByte#0 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#0 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#0 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var fourthByte#0 := $Unbox(Seq#Index(m#0, LitInt(3))): bv8; (var u1#0 := (0bv16 ++ and_bv8(firstByte#0, 7bv8)): bv24; (var u2#0 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#0, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#0 := (0bv16 ++ and_bv8(secondByte#0, 15bv8)): bv24; (var y#0 := (0bv16 ++ and_bv8(thirdByte#0, 63bv8)): bv24; (var x#0 := (0bv16 ++ and_bv8(fourthByte#0, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#0, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#0, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#0, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#0, (0bv19 ++ 6bv5): bv24)), x#0)))))))))));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0)) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) == (var firstByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var fourthByte#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(3))): bv8; (var u1#1 := (0bv16 ++ and_bv8(firstByte#1, 7bv8)): bv24; (var u2#1 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#1, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#1 := (0bv16 ++ and_bv8(secondByte#1, 15bv8)): bv24; (var y#1 := (0bv16 ++ and_bv8(thirdByte#1, 63bv8)): bv24; (var x#1 := (0bv16 ++ and_bv8(fourthByte#1, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#1, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#1, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#1, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#1, (0bv19 ++ 6bv5): bv24)), x#1)))))))))));
}

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#requires(m#0) } $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#requires(m#0) <==> Seq#Length(m#0) == LitInt(4)));

procedure {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id7860"} le_bv24(65536bv24, v#0);
  free ensures {:id "id7861"} le_bv24(v#0, 1114111bv24);
  free ensures {:id "id7862"} Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var firstByte#Z#0: bv8;
  var let#0#0#0: bv8;
  var secondByte#Z#0: bv8;
  var let#1#0#0: bv8;
  var thirdByte#Z#0: bv8;
  var let#2#0#0: bv8;
  var fourthByte#Z#0: bv8;
  var let#3#0#0: bv8;
  var u1#Z#0: bv24;
  var let#4#0#0: bv24;
  var u2#Z#0: bv24;
  var let#5#0#0: bv24;
  var newtype$check#0: int;
  var z#Z#0: bv24;
  var let#6#0#0: bv24;
  var y#Z#0: bv24;
  var let#7#0#0: bv24;
  var x#Z#0: bv24;
  var let#8#0#0: bv24;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: bv24;
  var newtype$check#6: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(239,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(m#0) == LitInt(4);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(65536bv24, v#0);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(65536bv24, v#0);
    goto anon4;

  anon4:
    assume le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(65536bv24, ##v#0);
    assume {:subsumption 0} le_bv24(##v#0, 1114111bv24);
    assume le_bv24(65536bv24, ##v#0) && le_bv24(##v#0, 1114111bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0);
    assume Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), m#0);
    assume false;
    return;

  anon6_Else:
    havoc firstByte#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(m#0);
    assume let#0#0#0 == $Unbox(Seq#Index(m#0, LitInt(0))): bv8;
    assume true;
    assume $Is(let#0#0#0, TBitvector(8));
    assume firstByte#Z#0 == let#0#0#0;
    havoc secondByte#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(m#0);
    assume let#1#0#0 == $Unbox(Seq#Index(m#0, LitInt(1))): bv8;
    assume true;
    assume $Is(let#1#0#0, TBitvector(8));
    assume secondByte#Z#0 == let#1#0#0;
    havoc thirdByte#Z#0;
    assume true;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(m#0);
    assume let#2#0#0 == $Unbox(Seq#Index(m#0, LitInt(2))): bv8;
    assume true;
    assume $Is(let#2#0#0, TBitvector(8));
    assume thirdByte#Z#0 == let#2#0#0;
    havoc fourthByte#Z#0;
    assume true;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(m#0);
    assume let#3#0#0 == $Unbox(Seq#Index(m#0, LitInt(3))): bv8;
    assume true;
    assume $Is(let#3#0#0, TBitvector(8));
    assume fourthByte#Z#0 == let#3#0#0;
    havoc u1#Z#0;
    assume true;
    assume let#4#0#0 == (0bv16 ++ and_bv8(firstByte#Z#0, 7bv8)): bv24;
    assume true;
    assume $Is(let#4#0#0, TBitvector(24));
    assume u1#Z#0 == let#4#0#0;
    havoc u2#Z#0;
    assume true;
    newtype$check#0 := LitInt(4);
    assume 0 <= newtype$check#0 && newtype$check#0 < 16;
    assume le_bv4(4bv4, 8bv4);
    assume let#5#0#0 == (0bv16 ++ RightShift_bv8(and_bv8(secondByte#Z#0, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24;
    assume true;
    assume $Is(let#5#0#0, TBitvector(24));
    assume u2#Z#0 == let#5#0#0;
    havoc z#Z#0;
    assume true;
    assume let#6#0#0 == (0bv16 ++ and_bv8(secondByte#Z#0, 15bv8)): bv24;
    assume true;
    assume $Is(let#6#0#0, TBitvector(24));
    assume z#Z#0 == let#6#0#0;
    havoc y#Z#0;
    assume true;
    assume let#7#0#0 == (0bv16 ++ and_bv8(thirdByte#Z#0, 63bv8)): bv24;
    assume true;
    assume $Is(let#7#0#0, TBitvector(24));
    assume y#Z#0 == let#7#0#0;
    havoc x#Z#0;
    assume true;
    assume let#8#0#0 == (0bv16 ++ and_bv8(fourthByte#Z#0, 63bv8)): bv24;
    assume true;
    assume $Is(let#8#0#0, TBitvector(24));
    assume x#Z#0 == let#8#0#0;
    assume true;
    assume {:split_here} Lit(true);
    assume {:captureState "libraries/src/Unicode/Utf8EncodingForm.dfy(253,29)"} true;
    newtype$check#1 := LitInt(18);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(18bv5, 24bv5);
    newtype$check#2 := LitInt(16);
    assume 0 <= newtype$check#2 && newtype$check#2 < 32;
    assume le_bv5(16bv5, 24bv5);
    newtype$check#3 := LitInt(12);
    assume 0 <= newtype$check#3 && newtype$check#3 < 32;
    assume le_bv5(12bv5, 24bv5);
    newtype$check#4 := LitInt(6);
    assume 0 <= newtype$check#4 && newtype$check#4 < 32;
    assume le_bv5(6bv5, 24bv5);
    newtype$check#5 := x#Z#0;
    assume le_bv24(0bv24, newtype$check#5) && le_bv24(newtype$check#5, 1114111bv24);
    assume (lt_bv24(newtype$check#5, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#5, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#5, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#5, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#6 := x#Z#0;
    assume le_bv24(0bv24, newtype$check#6) && le_bv24(newtype$check#6, 1114111bv24);
    assume (lt_bv24(newtype$check#6, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#6, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#6, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#6, Unicode.__default.LOW__SURROGATE__MAX()));
    assume $Is(or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#Z#0, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#Z#0, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#Z#0, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#Z#0, (0bv19 ++ 6bv5): bv24)), x#Z#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#Z#0, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#Z#0, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#Z#0, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#Z#0, (0bv19 ++ 6bv5): bv24)), x#Z#0);
    assume true;
    assume $Is(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Tclass.Unicode.ScalarValue());
    assume Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == v#0;
    return;
}



procedure {:verboseName "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call precondtion)"} CallPre$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap));



procedure {:verboseName "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0))) && Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id7909"} Wrappers.Option#Equal(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0)), #Wrappers.Option.Some($Box(m#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns ($_reverifyPost: bool);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0))) && Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id7910"} $_reverifyPost ==> Wrappers.Option#Equal(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0)), #Wrappers.Option.Some($Box(m#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ms#0: Seq where $Is(ms#0, TSeq(TBitvector(8))) && $IsAlloc(ms#0, TSeq(TBitvector(8)), $Heap);
  var ##s#1: Seq;
  var defass#prefix#0: bool;
  var prefix#0: Seq where defass#prefix#0 ==> $Is(prefix#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var ##s#2: Seq;
  var ##s#0_1_0: Seq;
  var ##s#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](101,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    ms#0 := Seq#Append(m#0, s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](102,19)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(m#0) && Seq#Length(m#0) <= Seq#Length(ms#0);
    ##s#1 := Seq#Take(ms#0, Seq#Length(m#0));
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(ms#0, Seq#Length(m#0)));
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(ms#0, Seq#Length(m#0)));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(ms#0, Seq#Length(m#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](103,60)"} true;
    assume true;
    ##s#2 := ms#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(ms#0);
    assume $IsAllocBox($Box(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0)), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(ms#0) && Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0))): Seq;
    defass#prefix#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](104,79)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##s#0_0 := m#0;
    assume $IsAlloc(##s#0_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume false;
    goto anon8;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##s#0_1_0 := m#0;
    assume $IsAlloc(##s#0_1_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0);
    assume defass#prefix#0;
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume defass#prefix#0;
    assume true;
    assume Seq#Length(prefix#0) <= Seq#Length(m#0);
    assume defass#prefix#0;
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(ms#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(ms#0);
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(m#0);
    goto anon5;

  anon12_Else:
    assume {:partition} !Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    goto anon5;

  anon5:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0)));
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(m#0);
    goto anon7;

  anon13_Else:
    assume {:partition} !(Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0))));
    goto anon7;

  anon7:
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon11_Else:
    goto anon8;

  anon8:
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0) ==> Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(m#0, Seq#Length(prefix#0)), m#0);
    return;
}



function Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly: LayerType, s#0: Seq) : DatatypeType
uses {
axiom 9 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (9 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0)) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0))): Seq), s#0)) && $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))));
axiom 9 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (9 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#0 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#0)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) && (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#0))) && (var valueOrError1#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#0))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#0 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#0) else (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0)): Seq; (var valueOrError1#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#0))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) else (var restParts#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), restParts#0)))))))))));
axiom 9 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || (9 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#1 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#1)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) && (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#1))) && (var valueOrError1#1 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#1))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#1 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#1) else (var prefix#1 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1)): Seq); (var valueOrError1#1 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#1))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) else (var restParts#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#1)), restParts#1)))))))))));
}

function Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(AsFuelBottom($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) == Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LZ, s#0));

function Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#requires($ly, s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#requires($ly, s#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (maybeParts#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var prefix#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##s#1: Seq;
  var restParts#Z#0: Seq;
  var let#3#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](116,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume $IsAllocBox($Box(maybeParts#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybeParts#0);
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0);
    ##xs#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq;
    assume $IsAlloc(##xs#0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq);
    assume Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);
    goto anon5;

  anon15_Else:
    assume Wrappers.Option.Some_q(maybeParts#0) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Lit(#Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))));
    assume true;
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon16_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0);
    assume let#0#0#0 == Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon17_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    havoc prefix#Z#0;
    assume $Is(prefix#Z#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume 0 <= Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(prefix#Z#0));
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#1) == Seq#Length(s#0);
    assume Seq#Length(##s#1) < Seq#Length(s#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume let#2#0#0 == Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume $Is(let#2#0#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError1#Z#0);
    assume Wrappers.Option.None_q(valueOrError1#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon18_Else:
    assume {:partition} !Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    havoc restParts#Z#0;
    assume $Is(restParts#Z#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(restParts#Z#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError1#Z#0);
    assume Wrappers.Option.Some_q(valueOrError1#Z#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume restParts#Z#0 == let#3#0#0;
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#Z#0)), restParts#Z#0)));
    assume true;
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon13:
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == maybeParts#0;
    return;
}



procedure {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (correctness)"} Impl$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns (defass#maybeParts#0: bool, maybeParts#0: DatatypeType where defass#maybeParts#0 ==> $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap), $_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeParts#0) && $IsA#Wrappers.Option(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id7954"} $_reverifyPost ==> Wrappers.Option#Equal(maybeParts#0, Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (correctness)"} Impl$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (defass#maybeParts#0: bool, maybeParts#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var result#0: Seq where $Is(result#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(result#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var rest#0: Seq where $Is(rest#0, TSeq(TBitvector(8))) && $IsAlloc(rest#0, TSeq(TBitvector(8)), $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#maybeParts#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;
  var ##s#6: Seq;
  var $decr$loop#00: int;
  var defass#prefix#2: bool;
  var prefix#2: Seq where defass#prefix#2 ==> $Is(prefix#2, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#2, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var defass#valueOrError0#2: bool;
  var valueOrError0#2: DatatypeType where defass#valueOrError0#2 ==> $Is(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](131,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    push;
    assume true;
    assume true;
    maybeParts#0 := Lit(#Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))));
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](133,21)"} true;
    assume defass#maybeParts#0;
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    pop;
    return;

  anon19_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    assume true;
    assume true;
    result#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](135,55)"} true;
    assume true;
    assume true;
    rest#0 := s#0;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](136,17)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#maybeParts#0 := defass#maybeParts#0;
    $decr_init$loop#00 := Seq#Length(rest#0) - 0;
    havoc $w$loop#0;
    goto anon20_LoopHead;

  anon20_LoopHead:
    assume $w$loop#0 ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume $w$loop#0 ==> (Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0)) <==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), rest#0)));
    assume $w$loop#0 ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0));
    assume $w$loop#0 ==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true);
    assume $w$loop#0 ==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Seq#Equal($Unbox(Wrappers.Option.value(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0))): Seq, Seq#Append(result#0, $Unbox(Wrappers.Option.value(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), rest#0))): Seq));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#maybeParts#0 ==> defass#maybeParts#0;
    assume Seq#Length(rest#0) - 0 <= $decr_init$loop#00;
    goto anon20_LoopDone, anon20_LoopBody;

  anon20_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](137,4): after some loop iterations"} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} !$w$loop#0;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    ##s#3 := rest#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) <==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0));
    ##s#4 := s#0;
    assume $IsAlloc(##s#4, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Lit(true);
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    ##s#6 := rest#0;
    assume $IsAlloc(##s#6, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0));
    goto anon9;

  anon23_Else:
    assume {:partition} !Lit(true);
    goto anon9;

  anon22_Else:
    assume {:partition} !Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    goto anon9;

  anon9:
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0));
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> true && Seq#Equal($Unbox(Wrappers.Option.value(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq, Seq#Append(result#0, $Unbox(Wrappers.Option.value(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0))): Seq));
    assume true;
    assume false;
    goto anon10;

  anon21_Else:
    assume {:partition} $w$loop#0;
    goto anon10;

  anon10:
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} 0 >= Seq#Length(rest#0);
    goto anon17;

  anon24_Else:
    assume {:partition} Seq#Length(rest#0) > 0;
    $decr$loop#00 := Seq#Length(rest#0) - 0;
    push;
    havoc valueOrError0#2 /* where defass#valueOrError0#2 ==> $Is(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap) */;
    assume true;
    ##s#7 := rest#0;
    assume $IsAlloc(##s#7, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(rest#0);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(rest#0);
    valueOrError0#2 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(rest#0);
    defass#valueOrError0#2 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](145,73)"} true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    push;
    assume true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#2);
    assume Wrappers.Option.None_q(valueOrError0#2);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    maybeParts#0 := Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](145,73)"} true;
    assume defass#maybeParts#0;
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    pop;
    pop;
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#2);
    assume Wrappers.Option.Some_q(valueOrError0#2);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2)): Seq;
    defass#prefix#2 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](145,73)"} true;
    assume true;
    assume defass#prefix#2;
    assume true;
    result#0 := Seq#Append(result#0, Seq#Build(Seq#Empty(): Seq, $Box(prefix#2)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](146,33)"} true;
    assume true;
    assume defass#prefix#2;
    assume 0 <= Seq#Length(prefix#2) && Seq#Length(prefix#2) <= Seq#Length(rest#0);
    assume true;
    rest#0 := Seq#Drop(rest#0, Seq#Length(prefix#2));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](147,30)"} true;
    pop;
    assume 0 <= $decr$loop#00 || Seq#Length(rest#0) - 0 == $decr$loop#00;
    assume Seq#Length(rest#0) - 0 < $decr$loop#00;
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0) && ((Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) <==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0))) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0)));
    goto anon20_LoopHead;

  anon20_LoopDone:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume true;
    assume Seq#Equal(Seq#Append(result#0, Seq#Empty(): Seq), result#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](149,32)"} true;
    assume true;
    assume true;
    maybeParts#0 := #Wrappers.Option.Some($Box(result#0));
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](150,23)"} true;
    assume defass#maybeParts#0;
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    return;
}



function Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq) : Seq
uses {
axiom 13 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (13 < $FunctionContextHeight && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0)), s#0) && $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
axiom 13 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (13 < $FunctionContextHeight && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq);
axiom 13 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) || (13 < $FunctionContextHeight && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))) && Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) == Lit($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0))))): Seq));
}

function Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0: Seq) : bool;

function Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq() : Ty
uses {
axiom Tag(Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) == Tagclass.Utf8EncodingForm.WellFormedCodeUnitSeq && TagFamily(Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) == tytagFamily$WellFormedCodeUnitSeq;
}

const unique Tagclass.Utf8EncodingForm.WellFormedCodeUnitSeq: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) } $IsBox(bx, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()));

function Utf8EncodingForm.__default.PartitionCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequence#requires(s#0) } $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.PartitionCodeUnitSequence#requires(s#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) returns (parts#0: Seq where $Is(parts#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq) returns (parts#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.PartitionCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](157,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#0);
    assume Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), parts#0), s#0);
    assume false;
    return;

  anon4_Else:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume $IsAllocBox($Box(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq;
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) == parts#0;
    return;
}



procedure {:verboseName "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call precondtion)"} CallPre$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0)) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
  free ensures {:id "id7991"} Wrappers.Option#Equal(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0)) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
  free ensures {:id "id7992"} $_reverifyPost ==> Wrappers.Option#Equal(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var m##0: Seq;
  var s##0: Seq;
  var ##s#0_0_0: Seq;
  var ##s#0_0_1: Seq;
  var ##s#0_1_0: Seq;
  var ##s#1_1_0: Seq;
  var ##s#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](169,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#m0#0: Seq :: $Is($ih#m0#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Lit(true) && Seq#Rank($ih#m0#0) < Seq#Rank(m#0) ==> Wrappers.Option#Equal(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), $ih#m0#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box($ih#m0#0))))));
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    assume true;
    s##0 := Lit(Seq#Empty(): Seq);
    call CallPre$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##0, s##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##0, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](170,77)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume true;
    assume false;
    goto anon4;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    push;
    pop;
    ##s#0_1_0 := Seq#Append(m#0, Seq#Empty(): Seq);
    assume $IsAlloc(##s#0_1_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume true;
    assume false;
    goto anon4;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##s#0_0_0 := Seq#Append(m#0, Seq#Empty(): Seq);
    assume $IsAlloc(##s#0_0_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    push;
    push;
    assume true;
    assume Seq#Equal(Seq#Append(m#0, Seq#Empty(): Seq), m#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](174,26)"} true;
    pop;
    pop;
    ##s#0_0_1 := m#0;
    assume $IsAlloc(##s#0_0_1, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume true;
    assume false;
    goto anon4;

  anon11_Else:
    goto anon4;

  anon4:
    assume Wrappers.Option#Equal(#Wrappers.Option.Some($Box(m#0)), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(m#0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##s#1_0 := m#0;
    assume $IsAlloc(##s#1_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##s#1_1_0 := m#0;
    assume $IsAlloc(##s#1_1_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume true;
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(m#0)), Seq#Empty(): Seq), Seq#Build(Seq#Empty(): Seq, $Box(m#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](180,30)"} true;
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon14_Else:
    goto anon8;

  anon8:
    assume Wrappers.Option#Equal(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
    return;
}



function Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 11 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) || (11 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) <==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))));
axiom 11 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) || (11 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) <==> Lit(Wrappers.Option.Some_q(Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))))));
}

function Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#requires(s#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.IsWellFormedCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (b#0: bool);
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  free requires 12 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call precondtion)"} CallPre$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0);
  free ensures {:id "id8002"} Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(m#0) && Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 12 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0);
  free ensures {:id "id8003"} $_reverifyPost ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(m#0) || Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](198,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    call CallPre$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](199,57)"} true;
    return;
}



procedure {:verboseName "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call precondtion)"} CallPre$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id8007"} Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0)) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(m#0, s#0)) && Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(m#0, s#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id8008"} $_reverifyPost ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0)) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(m#0, s#0)) || Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(m#0, s#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m##0: Seq;
  var m##1: Seq;
  var s##0: Seq;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](208,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    call CallPre$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](209,57)"} true;
    assume true;
    m##1 := m#0;
    assume true;
    s##0 := s#0;
    call CallPre$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##1, s##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##1, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](210,76)"} true;
    ##s#1 := Seq#Append(m#0, s#0);
    assume $IsAlloc(##s#1, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Append(m#0, s#0));
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Append(m#0, s#0));
    assume true;
    assume Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(m#0, s#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](211,56)"} true;
    return;
}



procedure {:verboseName "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call precondtion)"} CallPre$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));



procedure {:verboseName "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(TBitvector(8), ms#0) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0));
  free ensures {:id "id8015"} Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0)) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0)) && Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap)) returns ($_reverifyPost: bool);
  free requires 14 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(TBitvector(8), ms#0) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0));
  free ensures {:id "id8016"} $_reverifyPost ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0)) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0)) || Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq.__default.Flatten(TBitvector(8), $LS($LS($LZ)), ms#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##xs#0_0: Seq;
  var ##s#0_0: Seq;
  var head#1_0: Seq where $Is(head#1_0, TSeq(TBitvector(8))) && $IsAlloc(head#1_0, TSeq(TBitvector(8)), $Heap);
  var tail#1_0: Seq where $Is(tail#1_0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(tail#1_0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ms##1_0: Seq;
  var flatTail#1_0: Seq where $Is(flatTail#1_0, TSeq(TBitvector(8))) && $IsAlloc(flatTail#1_0, TSeq(TBitvector(8)), $Heap);
  var ##xs#1_0: Seq;
  var m##1_0: Seq;
  var s##1_0: Seq;
  var ##s#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences", " | ", ms#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](219,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#ms0#0: Seq :: $Is($ih#ms0#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && Lit(true) && Seq#Rank($ih#ms0#0) < Seq#Rank(ms#0) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(8), $LS($LZ), $ih#ms0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(ms#0) == LitInt(0);
    ##xs#0_0 := ms#0;
    assume $IsAlloc(##xs#0_0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), ms#0);
    ##s#0_0 := Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0);
    assume $IsAlloc(##s#0_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0));
    assume Seq.__default.Flatten#canCall(TBitvector(8), ms#0) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0));
    assume true;
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](221,58)"} true;
    return;

  anon3_Else:
    assume {:partition} Seq#Length(ms#0) != LitInt(0);
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ms#0);
    assume true;
    head#1_0 := $Unbox(Seq#Index(ms#0, LitInt(0))): Seq;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](224,23)"} true;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(ms#0);
    assume true;
    tail#1_0 := Seq#Drop(ms#0, LitInt(1));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](225,25)"} true;
    assume true;
    ms##1_0 := tail#1_0;
    assume Seq#Rank(ms##1_0) < Seq#Rank(ms#0);
    call CallPre$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##1_0);
    call CallPost$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](226,61)"} true;
    assume true;
    ##xs#1_0 := tail#1_0;
    assume $IsAlloc(##xs#1_0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), tail#1_0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), tail#1_0);
    flatTail#1_0 := Seq.__default.Flatten(TBitvector(8), $LS($LZ), tail#1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](227,39)"} true;
    assume true;
    assume $Is(head#1_0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq());
    m##1_0 := head#1_0;
    assume true;
    assume $Is(flatTail#1_0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    s##1_0 := flatTail#1_0;
    call CallPre$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##1_0, s##1_0);
    call CallPost$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##1_0, s##1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](228,70)"} true;
    ##s#1_0 := Seq#Append(head#1_0, flatTail#1_0);
    assume $IsAlloc(##s#1_0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0));
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0));
    assume true;
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(head#1_0, flatTail#1_0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](229,58)"} true;
    return;
}



procedure {:verboseName "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 15 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call precondtion)"} CallPre$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id8032"} Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0)) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(s#0, t#0)) && Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 15 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id8033"} $_reverifyPost ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0)) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(s#0, t#0)) || Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq, t#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var partsS#0: Seq where $Is(partsS#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsS#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#1: Seq;
  var partsT#0: Seq where $Is(partsT#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsT#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#2: Seq;
  var partsST#0: Seq where $Is(partsST#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsST#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var xs##0: Seq;
  var ys##0: Seq;
  var ##xs#0: Seq;
  var part#0: Seq;
  var ##s#3: Seq;
  var ms##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](238,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    partsS#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](239,46)"} true;
    assume true;
    ##s#2 := t#0;
    assume $IsAlloc(##s#2, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(t#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(t#0);
    partsT#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(t#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](240,46)"} true;
    assume true;
    assume true;
    partsST#0 := Seq#Append(partsS#0, partsT#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](241,34)"} true;
    assume true;
    xs##0 := partsS#0;
    assume true;
    ys##0 := partsT#0;
    free call CallPre$$Seq.__default.LemmaFlattenConcat(TBitvector(8), xs##0, ys##0);
    call CallPost$$Seq.__default.LemmaFlattenConcat(TBitvector(8), xs##0, ys##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](242,42)"} true;
    ##xs#0 := partsST#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), partsST#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), partsST#0);
    assume true;
    assume Seq#Equal(Seq#Append(s#0, t#0), Seq.__default.Flatten(TBitvector(8), $LS($LZ), partsST#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](244,40)"} true;
    havoc part#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} $Is(part#0, TSeq(TBitvector(8))) && $IsAlloc(part#0, TSeq(TBitvector(8)), $Heap);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Seq#Contains(partsST#0, $Box(part#0));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(part#0) > 0;
    ##s#3 := part#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(part#0);
    goto anon4;

  anon7_Else:
    assume {:partition} 0 >= Seq#Length(part#0);
    goto anon4;

  anon6_Else:
    assume {:partition} !Seq#Contains(partsST#0, $Box(part#0));
    goto anon4;

  anon5_Else:
    assume {:partition} !($Is(part#0, TSeq(TBitvector(8))) && $IsAlloc(part#0, TSeq(TBitvector(8)), $Heap));
    goto anon4;

  anon4:
    assume (forall part#1: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(TBitvector(8))) ==> Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(part#1));
    assume true;
    assume (forall part#1: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(TBitvector(8))) && Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](247,55)"} true;
    assume true;
    ms##0 := partsST#0;
    call CallPre$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](248,62)"} true;
    return;
}



function Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) : Seq
uses {
axiom 15 <= $FunctionContextHeight ==> (forall vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (15 < $FunctionContextHeight && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> $Is(Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()));
axiom 15 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (15 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#0 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(8), ms#0)) && Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#0 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#0)));
axiom 15 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || (15 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(8), ms#1)) && Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#1)));
}

function Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0: Seq) : bool;

function Utf8EncodingForm.__default.EncodeScalarSequence#requires(Seq) : bool;

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence#requires(vs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) ==> (Utf8EncodingForm.__default.EncodeScalarSequence#requires(vs#0) <==> true));

function Utf8EncodingForm.__default.EncodeScalarValue#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) == $Box(Utf8EncodingForm.__default.EncodeScalarValue($Unbox($fh$0x#0): bv24)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) <==> Utf8EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$0x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue($fh$0x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.EncodeScalarValue($fh$0x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "Utf8EncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) returns (s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()));
  free requires 15 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ms#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ms##0: Seq;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](254,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    assume false;
    return;

  anon4_Else:
    havoc ms#Z#0;
    assume $Is(ms#Z#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#Z#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume 9 != $FunctionContextHeight;
    ##f#0 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0 := vs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): bv24 } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): bv24 } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume let#0#0#0 == Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $Is(let#0#0#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume ms#Z#0 == let#0#0#0;
    assume true;
    ms##0 := ms#Z#0;
    call CallPre$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](257,56)"} true;
    ##xs#1 := ms#Z#0;
    assume $IsAlloc(##xs#1, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), ms#Z#0);
    assume $Is(Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#Z#0), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#Z#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), ms#Z#0);
    assume $Is(Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    assume Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == s#0;
    assume b$reqreads#0;
    return;
}



procedure {:verboseName "Utf8EncodingForm.EncodeScalarSequence (correctness)"} Impl$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (defass#s#0: bool, s#0: Seq where defass#s#0 ==> $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap), $_reverifyPost: bool);
  free requires 16 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
  free ensures {:id "id8053"} $_reverifyPost ==> Seq#Equal(s#0, Utf8EncodingForm.__default.EncodeScalarSequence(vs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.EncodeScalarSequence (correctness)"} Impl$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (defass#s#0: bool, s#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var unflattened#0: Seq where $Is(unflattened#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(unflattened#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#s#0: bool;
  var $w$loop#0: bool;
  var ##f#1: HandleType;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var defass#next#0: bool;
  var next#0: Seq where defass#next#0 ==> $Is(next#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(next#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var ##v#0: bv24;
  var m##0: Seq;
  var s##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](260,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    s#0 := Lit(Seq#Empty(): Seq);
    defass#s#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](265,11)"} true;
    assume true;
    assume true;
    unflattened#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](266,66)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(vs#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#hi;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#s#0 := defass#s#0;
    havoc $w$loop#0;
    goto anon7_LoopHead;

  anon7_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume $w$loop#0 ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume $w$loop#0 ==> Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)));
    assume $w$loop#0 ==> Seq.__default.Flatten#canCall(TBitvector(8), unflattened#0);
    assume $w$loop#0 ==> Seq#Equal(s#0, Seq.__default.Flatten(TBitvector(8), $LS($LS($LZ)), unflattened#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#s#0 ==> defass#s#0;
    assume true;
    goto anon7_LoopDone, anon7_LoopBody;

  anon7_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](267,4): after some loop iterations"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} !$w$loop#0;
    assume 9 != $FunctionContextHeight;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(vs#0);
    ##f#1 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#2 := Seq#Drop(vs#0, i#2);
    assume $IsAlloc(##xs#2, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##xs#2, i#3)): bv24 } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#2) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#1, Seq#Index(##xs#2, i#3)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)));
    assume defass#s#0;
    ##xs#3 := unflattened#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), unflattened#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), unflattened#0);
    assume Seq#Equal(s#0, Seq.__default.Flatten(TBitvector(8), $LS($LZ), unflattened#0));
    assume false;
    goto anon3;

  anon8_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} i#2 == i#2#lo;
    goto anon6;

  anon9_Else:
    assume {:partition} i#2 != i#2#lo;
    i#2 := i#2 - 1;
    assume true;
    assume 0 <= i#2 && i#2 < Seq#Length(vs#0);
    ##v#0 := $Unbox(Seq#Index(vs#0, i#2)): bv24;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume Utf8EncodingForm.__default.EncodeScalarValue#canCall($Unbox(Seq#Index(vs#0, i#2)): bv24);
    assume Utf8EncodingForm.__default.EncodeScalarValue#canCall($Unbox(Seq#Index(vs#0, i#2)): bv24);
    next#0 := Utf8EncodingForm.__default.EncodeScalarValue($Unbox(Seq#Index(vs#0, i#2)): bv24);
    defass#next#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](271,72)"} true;
    assume true;
    assume defass#next#0;
    assume true;
    unflattened#0 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(next#0)), unflattened#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](272,41)"} true;
    assume defass#next#0;
    assume true;
    m##0 := next#0;
    assume defass#s#0;
    assume true;
    s##0 := s#0;
    call CallPre$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##0, s##0);
    call CallPost$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##0, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](273,63)"} true;
    assume true;
    assume defass#next#0;
    assume defass#s#0;
    assume true;
    assume $Is(Seq#Append(next#0, s#0), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    s#0 := Seq#Append(next#0, s#0);
    defass#s#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](274,19)"} true;
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)) && (Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2))) ==> Seq.__default.Flatten#canCall(TBitvector(8), unflattened#0));
    goto anon7_LoopHead;

  anon7_LoopDone:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume defass#s#0;
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    return;
}



function Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq) : Seq
uses {
axiom 16 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || (16 < $FunctionContextHeight && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Seq#Equal(Utf8EncodingForm.__default.EncodeScalarSequence(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0)), s#0) && $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue())));
axiom 16 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || (16 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#0 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0); vs#0)));
axiom 16 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || (16 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#1 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#1)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#1 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#1 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#1); vs#1)));
}

function Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeCodeUnitSequence#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> (Utf8EncodingForm.__default.DecodeCodeUnitSequence#requires(s#0) <==> true));

function Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) } Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) == $Box(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$0x#0): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) } Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) <==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$0x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$0x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$0x#0) == $Unbox(Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$0x#0))): bv24);

procedure {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) returns (vs#2: Seq where $Is(vs#2, TSeq(Tclass.Unicode.ScalarValue())));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq) returns (vs#2: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##vs#0: Seq;
  var parts#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##s#0: Seq;
  var vs#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#0_0_0: HandleType;
  var ##xs#0_0_0: Seq;
  var ##xs#0_0_1: Seq;
  var ##vs#0_0_0: Seq;
  var ##xs#0_1_0: Seq;
  var ##f#0_1_0: HandleType;
  var ##xs#0_1_1: Seq;
  var ##f#0_1_1: HandleType;
  var ##xs#0_1_2: Seq;
  var ##xs#0_1_3: Seq;
  var ##xs#0_2_0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](281,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue()));
    ##vs#0 := vs#2;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#2);
    assume Seq#Equal(Utf8EncodingForm.__default.EncodeScalarSequence(vs#2), s#0);
    assume false;
    return;

  anon9_Else:
    havoc parts#Z#0;
    assume $Is(parts#Z#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(parts#Z#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume let#0#0#0 == Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume $Is(let#0#0#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume parts#Z#0 == let#0#0#0;
    havoc vs#Z#0;
    assume $Is(vs#Z#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#Z#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume 10 != $FunctionContextHeight;
    ##f#0 := Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue()), $Heap);
    ##xs#0 := parts#Z#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume let#1#0#0 == Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.Unicode.ScalarValue()));
    assume vs#Z#0 == let#1#0#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume true;
    ##xs#0_2_0 := parts#Z#0;
    assume $IsAlloc(##xs#0_2_0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#Z#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#Z#0);
    assume true;
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##xs#0_1_0 := parts#Z#0;
    assume $IsAlloc(##xs#0_1_0, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#Z#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#Z#0);
    assume 9 != $FunctionContextHeight;
    ##f#0_1_0 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_1_0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_1_1 := vs#Z#0;
    assume $IsAlloc(##xs#0_1_1, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_1_0: int :: { $Unbox(Seq#Index(##xs#0_1_1, i#0_1_0)): bv24 } LitInt(0) <= i#0_1_0 && i#0_1_0 < Seq#Length(##xs#0_1_1) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_0)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_1_1: int, o#0_1_0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_1))[$Box(o#0_1_0)] } $Is(o#0_1_0, Tclass._System.object?()) && LitInt(0) <= i#0_1_1 && i#0_1_1 < Seq#Length(##xs#0_1_1) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_1))[$Box(o#0_1_0)] && $Box($o) == $Box(o#0_1_0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume Seq#Equal(parts#Z#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](289,54)"} true;
    assume 9 != $FunctionContextHeight;
    ##f#0_1_1 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_1_1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_1_2 := vs#Z#0;
    assume $IsAlloc(##xs#0_1_2, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_1_2: int :: { $Unbox(Seq#Index(##xs#0_1_2, i#0_1_2)): bv24 } LitInt(0) <= i#0_1_2 && i#0_1_2 < Seq#Length(##xs#0_1_2) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_2)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_1_3: int, o#0_1_1: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_3))[$Box(o#0_1_1)] } $Is(o#0_1_1, Tclass._System.object?()) && LitInt(0) <= i#0_1_3 && i#0_1_3 < Seq#Length(##xs#0_1_2) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_3))[$Box(o#0_1_1)] && $Box($o) == $Box(o#0_1_1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    ##xs#0_1_3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume $IsAlloc(##xs#0_1_3, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0) && Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume true;
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume 9 != $FunctionContextHeight;
    ##f#0_0_0 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_0_0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_0_0 := vs#Z#0;
    assume $IsAlloc(##xs#0_0_0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_0_0: int :: { $Unbox(Seq#Index(##xs#0_0_0, i#0_0_0)): bv24 } LitInt(0) <= i#0_0_0 && i#0_0_0 < Seq#Length(##xs#0_0_0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_0)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_0_1: int, o#0_0_0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_1))[$Box(o#0_0_0)] } $Is(o#0_0_0, Tclass._System.object?()) && LitInt(0) <= i#0_0_1 && i#0_0_1 < Seq#Length(##xs#0_0_0) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_1))[$Box(o#0_0_0)] && $Box($o) == $Box(o#0_0_0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    ##xs#0_0_1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume $IsAlloc(##xs#0_0_1, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0) && Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    ##vs#0_0_0 := vs#Z#0;
    assume $IsAlloc(##vs#0_0_0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#Z#0);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#Z#0);
    assume true;
    assume false;
    goto anon8;

  anon13_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(s#0, Utf8EncodingForm.__default.EncodeScalarSequence(vs#Z#0));
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == vs#Z#0;
    assume true;
    assume $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue()));
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == vs#2;
    assume b$reqreads#0;
    return;
}



function Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) : DatatypeType
uses {
axiom 17 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || (17 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))): Seq, Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0))) && (!Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))) && $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));
axiom 17 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || (17 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) && (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0)) && Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == (if Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) then #Wrappers.Option.Some($Box(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0))) else #Wrappers.Option.None()));
axiom 17 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) } Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(Lit(s#0)) || (17 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(8)))) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) && (Lit(Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0))) ==> Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0))) && Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) == (if Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) then #Wrappers.Option.Some($Box(Lit(Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0))))) else #Wrappers.Option.None()));
}

function Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0: Seq) : bool;

function Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(s#0) } $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(s#0) <==> true));

procedure {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8)))) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));
  free requires 17 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (maybeVs#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](300,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume Wrappers.Option.Some_q(maybeVs#0);
    assume $IsAllocBox($Box(maybeVs#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybeVs#0);
    assume Wrappers.Option.Some_q(maybeVs#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0);
    assume $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0));
    goto anon5;

  anon14_Else:
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(maybeVs#0) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0));
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume !Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume true;
    assume Wrappers.Option.None_q(maybeVs#0);
    goto anon8;

  anon15_Else:
    assume !Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(maybeVs#0);
    goto anon8;

  anon8:
    assume false;
    return;

  anon13_Else:
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    ##s#4 := s#0;
    assume $IsAlloc(##s#4, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == #Wrappers.Option.Some($Box(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0)));
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon12;

  anon16_Else:
    assume {:partition} !Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon12;

  anon12:
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == maybeVs#0;
    return;
}



procedure {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (correctness)"} Impl$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns (defass#maybeVs#0: bool, maybeVs#0: DatatypeType where defass#maybeVs#0 ==> $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap), $_reverifyPost: bool);
  free requires 18 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeVs#0) && $IsA#Wrappers.Option(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8114"} $_reverifyPost ==> Wrappers.Option#Equal(maybeVs#0, Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (correctness)"} Impl$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (defass#maybeVs#0: bool, maybeVs#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
  var ##s#5: Seq;
  var parts#0: Seq where $Is(parts#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(parts#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##vs#0: Seq;
  var ##xs#3: Seq;
  var ##f#2: HandleType;
  var ##xs#4: Seq;
  var ##f#3: HandleType;
  var ##xs#5: Seq;
  var ##xs#6: Seq;
  var ##xs#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](311,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    maybeParts#0 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](312,57)"} true;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Option.None_q(maybeParts#0);
    push;
    assume true;
    assume true;
    maybeVs#0 := Lit(#Wrappers.Option.None());
    defass#maybeVs#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](314,17)"} true;
    assume defass#maybeVs#0;
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
    pop;
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Option.None_q(maybeParts#0);
    assume true;
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume true;
    parts#0 := $Unbox(Wrappers.Option.value(maybeParts#0)): Seq;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](316,33)"} true;
    assume true;
    assume 10 != $FunctionContextHeight;
    ##f#0 := Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue()), $Heap);
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    assume Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    vs#0 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](317,72)"} true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume true;
    push;
    pop;
    ##xs#7 := parts#0;
    assume $IsAlloc(##xs#7, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#0);
    assume true;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##xs#3 := parts#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#0);
    assume Seq.__default.Flatten#canCall(TBitvector(8), parts#0);
    push;
    push;
    assume 9 != $FunctionContextHeight;
    ##f#2 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#2, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#4 := vs#0;
    assume $IsAlloc(##xs#4, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#4, i#2)): bv24 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#4) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#2, Seq#Index(##xs#4, i#2)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq#Equal(parts#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](321,54)"} true;
    pop;
    pop;
    assume 9 != $FunctionContextHeight;
    ##f#3 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#3, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#5 := vs#0;
    assume $IsAlloc(##xs#5, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##xs#5, i#3)): bv24 } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#5) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#3, Seq#Index(##xs#5, i#3)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    ##xs#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $IsAlloc(##xs#6, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume true;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume 9 != $FunctionContextHeight;
    ##f#1 := Utf8EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#1 := vs#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#1: int :: { $Unbox(Seq#Index(##xs#1, i#1)): bv24 } LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#1) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#1, Seq#Index(##xs#1, i#1)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    ##xs#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $IsAlloc(##xs#2, TSeq(TSeq(TBitvector(8))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && Seq.__default.Flatten#canCall(TBitvector(8), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    push;
    pop;
    ##vs#0 := vs#0;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    assume true;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume Seq#Equal(s#0, Utf8EncodingForm.__default.EncodeScalarSequence(vs#0));
    assume true;
    assume true;
    maybeVs#0 := #Wrappers.Option.Some($Box(vs#0));
    defass#maybeVs#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf8EncodingForm](325,19)"} true;
    assume defass#maybeVs#0;
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
    return;
}



procedure {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (call precondtion)"} CallPre$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap));



procedure {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeParts#0) && $IsA#Wrappers.Option(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8135"} Wrappers.Option#Equal(maybeParts#0, Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Utf8EncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.EncodeScalarSequence (call precondtion)"} CallPre$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap));



procedure {:verboseName "Utf8EncodingForm.EncodeScalarSequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (s#0: Seq where $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
  free ensures {:id "id8169"} Seq#Equal(s#0, Utf8EncodingForm.__default.EncodeScalarSequence(vs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap));
  free requires 18 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (call precondtion)"} CallPre$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap));



procedure {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))) && $IsAlloc(s#0, TSeq(TBitvector(8)), $Heap)) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeVs#0) && $IsA#Wrappers.Option(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8197"} Wrappers.Option#Equal(maybeVs#0, Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Utf8EncodingForm.WellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.WellFormedCodeUnitSeq(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))));
  free requires 12 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall s#0: Seq :: { $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) } $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) <==> $Is(s#0, TSeq(TBitvector(8))) && Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0));

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $h) } $IsAlloc(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $h) <==> $IsAlloc(s#0, TSeq(TBitvector(8)), $h));

procedure {:verboseName "Utf8EncodingForm.MinimalWellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(s#0: Seq where $Is(s#0, TSeq(TBitvector(8))));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall s#0: Seq :: { $Is(s#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) } $Is(s#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) <==> $Is(s#0, TSeq(TBitvector(8))) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0));

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $h) } $IsAlloc(s#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $h) <==> $IsAlloc(s#0, TSeq(TBitvector(8)), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#64 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#64))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#66 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#66)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#96 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#96))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#98 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#98)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#100 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#100)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#96 := Wrappers.Option.value(this); v#96)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#98 := Lit(Wrappers.Option.value(Lit(this))); v#98)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#100 := Lit(Wrappers.Option.value(Lit(this))); v#100)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#64 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#64)) else (var e#64 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#66 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#66))) else (var e#66 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#96 := Wrappers.Result.value(this); s#96) else (var e#96 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#98 := Lit(Wrappers.Result.value(Lit(this))); s#98) else (var e#98 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#100 := Lit(Wrappers.Result.value(Lit(this))); s#100) else (var e#100 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#96 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#96)) else (var e#96 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#96)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#98 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#98))) else (var e#98 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#98)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#100 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#100))) else (var e#100 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#100)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#14: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#14, x#14)): bool } $IsBox(x#14, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#14, x#14)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#15: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#15, x#15)): bool } $IsBox(x#15, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#15, x#15)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#14: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#14, x#14)): bool } $IsBox(x#14, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#14, x#14)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#15: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#15, x#15)): bool } $IsBox(x#15, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#15, x#15)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#14: Box, y#14: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#14, x#14)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#14, y#14)): bool } $IsBox(x#14, Relations._default.AntiSymmetric$T) && $IsBox(y#14, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#14, y#14)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#14, x#14)): bool ==> x#14 == y#14)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#15: Box, y#15: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#15, x#15)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#15, y#15)): bool } $IsBox(x#15, Relations._default.AntiSymmetric$T) && $IsBox(y#15, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#15, y#15)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#15, x#15)): bool ==> x#15 == y#15)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#14: Box, y#14: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#14, x#14)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#14, y#14)): bool } $IsBox(x#14, Relations._default.Symmetric$T) && $IsBox(y#14, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#14, y#14)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#14, x#14)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#15: Box, y#15: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#15, x#15)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#15, y#15)): bool } $IsBox(x#15, Relations._default.Symmetric$T) && $IsBox(y#15, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#15, y#15)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#15, x#15)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#14: Box, y#14: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#14, x#14)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#14, y#14)): bool } $IsBox(x#14, Relations._default.Connected$T) && $IsBox(y#14, Relations._default.Connected$T) ==> x#14 != y#14 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#14, y#14)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#14, x#14)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#15: Box, y#15: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#15, x#15)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#15, y#15)): bool } $IsBox(x#15, Relations._default.Connected$T) && $IsBox(y#15, Relations._default.Connected$T) ==> x#15 != y#15 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#15, y#15)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#15, x#15)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#14: Box, y#14: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#14, x#14)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#14, y#14)): bool } $IsBox(x#14, Relations._default.StronglyConnected$T) && $IsBox(y#14, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#14, y#14)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#14, x#14)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#15: Box, y#15: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#15, x#15)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#15, y#15)): bool } $IsBox(x#15, Relations._default.StronglyConnected$T) && $IsBox(y#15, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#15, y#15)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#15, x#15)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#14: Box, y#14: Box, z#14: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#14, z#14)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#14, z#14)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#14, z#14)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#14, y#14)): bool } $IsBox(x#14, Relations._default.Transitive$T) && $IsBox(y#14, Relations._default.Transitive$T) && $IsBox(z#14, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#14, y#14)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#14, z#14)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#14, z#14)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#15: Box, y#15: Box, z#15: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#15, z#15)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#15, z#15)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#15, z#15)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#15, y#15)): bool } $IsBox(x#15, Relations._default.Transitive$T) && $IsBox(y#15, Relations._default.Transitive$T) && $IsBox(z#15, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#15, y#15)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#15, z#15)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#15, z#15)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#20: int, j#20: int :: { Seq#Index(a#0, j#20), Seq#Index(a#0, i#20) } LitInt(0) <= i#20 && i#20 < j#20 && j#20 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#20), Seq#Index(a#0, j#20))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#21: int, j#21: int :: { Seq#Index(a#0, j#21), Seq#Index(a#0, i#21) } LitInt(0) <= i#21 && i#21 < j#21 && j#21 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#21), Seq#Index(Lit(a#0), j#21))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#22: int, j#22: int :: { Seq#Index(a#0, j#22), Seq#Index(a#0, i#22) } LitInt(0) <= i#22 && i#22 < j#22 && j#22 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#22), Seq#Index(Lit(a#0), j#22))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#20: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#20)): bool } { s#0[x#20] } $IsBox(x#20, Relations._default.IsLeast$T) && s#0[x#20] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#20)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#21: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#21)): bool } { s#0[x#21] } $IsBox(x#21, Relations._default.IsLeast$T) && Lit(s#0)[x#21] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#21)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#22: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#22)): bool } { s#0[x#22] } $IsBox(x#22, Relations._default.IsLeast$T) && Lit(s#0)[x#22] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#22)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#20: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#20)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#20, min#0)): bool } { s#0[x#20] } $IsBox(x#20, Relations._default.IsMinimal$T) && s#0[x#20] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#20, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#20)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#21: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#21)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#21, min#0)): bool } { s#0[x#21] } $IsBox(x#21, Relations._default.IsMinimal$T) && Lit(s#0)[x#21] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#21, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#21)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#22: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#22)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#22, min#0)): bool } { s#0[x#22] } $IsBox(x#22, Relations._default.IsMinimal$T) && Lit(s#0)[x#22] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#22, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#22)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#20: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#20, max#0)): bool } { s#0[x#20] } $IsBox(x#20, Relations._default.IsGreatest$T) && s#0[x#20] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#20, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#21: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#21, max#0)): bool } { s#0[x#21] } $IsBox(x#21, Relations._default.IsGreatest$T) && Lit(s#0)[x#21] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#21, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#22: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#22, max#0)): bool } { s#0[x#22] } $IsBox(x#22, Relations._default.IsGreatest$T) && Lit(s#0)[x#22] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#22, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#20: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#20, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#20)): bool } { s#0[x#20] } $IsBox(x#20, Relations._default.IsMaximal$T) && s#0[x#20] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#20)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#20, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#21: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#21, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#21)): bool } { s#0[x#21] } $IsBox(x#21, Relations._default.IsMaximal$T) && Lit(s#0)[x#21] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#21)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#21, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#22: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#22, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#22)): bool } { s#0[x#22] } $IsBox(x#22, Relations._default.IsMaximal$T) && Lit(s#0)[x#22] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#22)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#22, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#15 := Div(Seq#Length(a#0), LitInt(2)); (var left#15, right#15 := Seq#Take(a#0, splitIndex#15), Seq#Drop(a#0, splitIndex#15); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#15, lessThanOrEq#0) && (var leftSorted#15 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#15, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#15, lessThanOrEq#0) && (var rightSorted#15 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#15, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#15, rightSorted#15, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#15 := Div(Seq#Length(a#0), LitInt(2)); (var left#15, right#15 := Seq#Take(a#0, splitIndex#15), Seq#Drop(a#0, splitIndex#15); (var leftSorted#15 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#15, lessThanOrEq#0); (var rightSorted#15 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#15, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#15, rightSorted#15, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#16 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#16, right#16 := Seq#Take(Lit(a#0), splitIndex#16), Seq#Drop(Lit(a#0), splitIndex#16); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#16, lessThanOrEq#0) && (var leftSorted#16 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#16, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#16, lessThanOrEq#0) && (var rightSorted#16 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#16, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#16, rightSorted#16, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#16 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#16, right#16 := Seq#Take(Lit(a#0), splitIndex#16), Seq#Drop(Lit(a#0), splitIndex#16); (var leftSorted#16 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#16, lessThanOrEq#0); (var rightSorted#16 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#16, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#16, rightSorted#16, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#17 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#17, right#17 := Seq#Take(Lit(a#0), splitIndex#17), Seq#Drop(Lit(a#0), splitIndex#17); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#17, Lit(lessThanOrEq#0)) && (var leftSorted#17 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#17, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#17, Lit(lessThanOrEq#0)) && (var rightSorted#17 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#17, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#17, rightSorted#17, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#17 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#17, right#17 := Seq#Take(Lit(a#0), splitIndex#17), Seq#Drop(Lit(a#0), splitIndex#17); (var leftSorted#17 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#17, Lit(lessThanOrEq#0)); (var rightSorted#17 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#17, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#17, rightSorted#17, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#10: Box :: $IsBox($y#10, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#10)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#11: Box :: $IsBox($y#11, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#11)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#10: int, j#10: int :: { Seq#Index(xs#0, j#10), Seq#Index(xs#0, i#10) } LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) && LitInt(0) <= j#10 && j#10 < Seq#Length(xs#0) && i#10 != j#10 ==> Seq#Index(xs#0, i#10) != Seq#Index(xs#0, j#10))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#11: int, j#11: int :: { Seq#Index(xs#0, j#11), Seq#Index(xs#0, i#11) } LitInt(0) <= i#11 && i#11 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#11 && j#11 < Seq#Length(Lit(xs#0)) && i#11 != j#11 ==> Seq#Index(Lit(xs#0), i#11) != Seq#Index(Lit(xs#0), j#11))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#6: int :: { Seq#Index(xs#0, j#6) } LitInt(0) <= j#6 && j#6 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#6) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#6: int :: { Seq#Index(xs#0, j#6) } LitInt(0) <= j#6 && j#6 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#6) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#12 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#12) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#12)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#13 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#13) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#13)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#14 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#14) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#14)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#6: int :: { Seq#Index(xs#0, j#6) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#6 && j#6 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#6) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#6: int :: { Seq#Index(xs#0, j#6) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#6 && j#6 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#6) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#12: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#12), Seq#Index(xs#0, i#12) } LitInt(0) <= i#12 && i#12 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#12) == Seq#Index(xs#0, i#12)) && (forall i#13: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#13) } pos#0 <= i#13 && i#13 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#13) == Seq#Index(xs#0, i#13 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#12 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#12), Seq#Drop(xs#0, i#12 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#13 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#13), Seq#Drop(Lit(xs#0), i#13 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#14 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#14), Seq#Drop(Lit(xs#0), i#14 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#12: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#12), Seq#Index(xs#0, i#12) } LitInt(0) <= i#12 && i#12 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#12) == Seq#Index(xs#0, i#12)) && (forall i#13: int :: { Seq#Index(xs#0, i#13) } pos#0 <= i#13 && i#13 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#13 + 1) == Seq#Index(xs#0, i#13)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#6: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#6) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#6 - 1) } LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#6) == Seq#Index(xs#0, Seq#Length(xs#0) - i#6 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#6: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#6) } LitInt(0) <= i#6 && i#6 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#6) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#6: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#6) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#6) } LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#6), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#6)), $Unbox(Seq#Index(xs#0, i#6)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#8, b#8 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#8, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#8, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#9, b#9 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#9, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#9, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#6: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#6)): DatatypeType } LitInt(0) <= i#6 && i#6 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#6)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#6), Seq#Index(ys#0, i#6)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#6: int :: { Seq#Contains(xs#0, $Box(k#6)) } Seq#Contains(xs#0, $Box(k#6)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#6) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#6: int :: { Seq#Contains(xs#0, $Box(k#6)) } Seq#Contains(xs#0, $Box(k#6)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#6) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#25: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#25) } LitInt(0) <= i#25 && i#25 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#25) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#25))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#26: int :: { Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#26)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#26: int :: { Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#26)))) ==> (forall $l#13#i#0: int :: LitInt(0) <= $l#13#i#0 ==> $l#13#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#13#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#12#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#12#i#0): int))), (lambda $l#12#heap#0: Heap, $l#12#i#0: Box :: $IsBox($l#12#i#0, TInt) && LitInt(0) <= $Unbox($l#12#i#0): int && $Unbox($l#12#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#12#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#12#i#0): int))), (lambda $l#12#heap#0: Heap, $l#12#i#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: (exists i#27: int, o#12: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#12#heap#0, f#0, Seq#Index(xs#0, i#27))[$Box(o#12)] } $Is(o#12, Tclass._System.object?()) && LitInt(0) <= i#27 && i#27 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#12#heap#0, f#0, Seq#Index(xs#0, i#27))[$Box(o#12)] && $Box($l#12#o#0) == $Box(o#12))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#19: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#19) } { Seq#Index(xs#0, i#19) } (LitInt(0) <= i#19 && i#19 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#19))): DatatypeType)) && (LitInt(0) <= i#19 && i#19 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#19) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#19))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#20)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#20)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#4 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#4) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#4) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#4 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#4) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#4)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#4) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#4)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#4 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#4) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#4) else (var head#4 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#4); (var valueOrError1#4 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#4) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#4) else (var tail#4 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#4), tail#4)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#19: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#19) } LitInt(0) <= i#19 ==> i#19 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#19)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#19))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#20)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#20)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#10: Box, xs#10: Seq, b#10: Box, b'#10: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#10, x#10, b'#10)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#10), xs#10) } $IsBox(x#10, Seq._default.InvFoldLeft$A) && $Is(xs#10, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#10, Seq._default.InvFoldLeft$B) && $IsBox(b'#10, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#10, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#10), xs#10)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#10, x#10, b'#10)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#10, $Box(xs#10))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#11: Box, xs#11: Seq, b#11: Box, b'#11: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#11, x#11, b'#11)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#11), xs#11) } $IsBox(x#11, Seq._default.InvFoldLeft$A) && $Is(xs#11, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#11, Seq._default.InvFoldLeft$B) && $IsBox(b'#11, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#11, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#11), xs#11)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#11, x#11, b'#11)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#11, $Box(xs#11))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#10: Box, xs#10: Seq, b#10: Box, b'#10: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#10), xs#10), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#10, b#10, b'#10)): bool } $IsBox(x#10, Seq._default.InvFoldRight$A) && $Is(xs#10, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#10, Seq._default.InvFoldRight$B) && $IsBox(b'#10, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#10), b#10)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#10, b#10, b'#10)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#10), xs#10)), b'#10)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#11: Box, xs#11: Seq, b#11: Box, b'#11: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#11), xs#11), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#11, b#11, b'#11)): bool } $IsBox(x#11, Seq._default.InvFoldRight$A) && $Is(xs#11, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#11, Seq._default.InvFoldRight$B) && $IsBox(b'#11, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#11), b#11)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#11, b#11, b'#11)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#11), xs#11)), b'#11)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#13: int :: { Seq#Index(xs#0, i#13) } LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#13)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#13: int :: { Seq#Index(xs#0, i#13) } LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#13)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#4 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#4)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#5 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#5)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#4: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#4) } $IsBox(x#4, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#4))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#4: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#4) } $IsBox(x#4, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#4))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#4: Box, x2#4: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#4), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#4) } $IsBox(x1#4, Functions._default.Injective$X) && $IsBox(x2#4, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#4) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#4) ==> x1#4 == x2#4)));

const unique class.Utf16EncodingForm.__default: ClassName;

function Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly: LayerType, s#0: Seq) : bool
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#0: int :: { Seq#Take(s#0, i#0) } 0 < i#0 && i#0 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#0))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> Seq#Length(s#0) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#0 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#0) else false))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#1 := Lit(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#1) else false))));
}

function Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(AsFuelBottom($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) <==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LZ, s#0));

function Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires($ly, s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#requires($ly, s#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.IsMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (b#2: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8221"} b#2 ==> Seq#Length(s#0) > 0;
  free ensures {:id "id8222"} b#2 ==> (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#1)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.IsMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence(s#0: Seq) returns (b#2: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var b#Z#0: bool;
  var let#0#0#0: bool;
  var ##s#2: Seq;
  var i#3: int;
  var ##s#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.IsMinimalWellFormedCodeUnitSubsequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(22,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume b#2;
    assume Seq#Length(s#0) > 0;
    havoc i#2;
    assume true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} 0 < i#2;
    goto anon6;

  anon27_Else:
    assume {:partition} i#2 <= 0;
    goto anon6;

  anon6:
    assume 0 < i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, i#2);
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#0) == Seq#Length(s#0);
    assume Seq#Take(s#0, i#2) == s#0 || Seq#Length(##s#0) < Seq#Length(s#0);
    assume Seq#Take(s#0, i#2) == s#0 || Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#2));
    assume !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2));
    goto anon8;

  anon26_Else:
    assume 0 < i#2 && i#2 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2));
    goto anon8;

  anon8:
    assume (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1)));
    goto anon10;

  anon25_Else:
    assume b#2 ==> Seq#Length(s#0) > 0 && (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1)));
    goto anon10;

  anon10:
    assume false;
    return;

  anon24_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(1);
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(1);
    assume Seq#Length(##s#1) == LitInt(1);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0);
    assume $Is(Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon23;

  anon28_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(1);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(2);
    havoc b#Z#0;
    assume true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) == LitInt(2);
    assume Seq#Length(##s#2) == LitInt(2);
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0);
    assume let#0#0#0 <==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0);
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0);
    assume $Is(let#0#0#0, TBool);
    assume b#Z#0 <==> let#0#0#0;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} b#Z#0;
    havoc i#3;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} 0 < i#3;
    goto anon18;

  anon32_Else:
    assume {:partition} i#3 <= 0;
    goto anon18;

  anon18:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} 0 < i#3 && i#3 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= i#3 && i#3 <= Seq#Length(s#0);
    ##s#3 := Seq#Take(s#0, i#3);
    assume $IsAlloc(##s#3, TSeq(TBitvector(16)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#3) == Seq#Length(s#0);
    assume Seq#Length(##s#3) < Seq#Length(s#0);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#3));
    goto anon20;

  anon33_Else:
    assume {:partition} !(0 < i#3 && i#3 < Seq#Length(s#0));
    goto anon20;

  anon31_Else:
    assume {:partition} false;
    goto anon20;

  anon20:
    goto anon21;

  anon30_Else:
    assume {:partition} !b#Z#0;
    goto anon21;

  anon21:
    assume b#Z#0 ==> (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(s#0) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#4)));
    assume {:subsumption 0} b#Z#0 ==> (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#4)));
    assume b#Z#0 ==> (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#4)));
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(27,114)"} true;
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#Z#0;
    assume true;
    assume $Is(Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon23;

  anon29_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(2);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> Lit(false);
    assume true;
    assume $Is(Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0), TBool);
    goto anon23;

  anon23:
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0) <==> b#2;
    return;
}



function Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstWord#0 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#0) && le_bv16(firstWord#0, 55295bv16)) || (le_bv16(57344bv16, firstWord#0) && le_bv16(firstWord#0, 65535bv16)))));
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (le_bv16(0bv16, firstWord#1) && le_bv16(firstWord#1, 55295bv16)) || (le_bv16(57344bv16, firstWord#1) && le_bv16(firstWord#1, 65535bv16)))));
}

function Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#requires(s#0) <==> Seq#Length(s#0) == LitInt(1)));

procedure {:verboseName "Utf16EncodingForm.IsWellFormedSingleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (b#0: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.IsWellFormedSingleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var firstWord#Z#0: bv16;
  var let#0#0#0: bv16;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.IsWellFormedSingleCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(33,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(1);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    havoc firstWord#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume let#0#0#0 == $Unbox(Seq#Index(s#0, LitInt(0))): bv16;
    assume true;
    assume $Is(let#0#0#0, TBitvector(16));
    assume firstWord#Z#0 == let#0#0#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} le_bv16(0bv16, firstWord#Z#0);
    goto anon5;

  anon10_Else:
    assume {:partition} !le_bv16(0bv16, firstWord#Z#0);
    goto anon5;

  anon5:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} !(le_bv16(0bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 55295bv16));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} le_bv16(57344bv16, firstWord#Z#0);
    goto anon8;

  anon12_Else:
    assume {:partition} !le_bv16(57344bv16, firstWord#Z#0);
    goto anon8;

  anon11_Else:
    assume {:partition} le_bv16(0bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 55295bv16);
    goto anon8;

  anon8:
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (le_bv16(0bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 55295bv16)) || (le_bv16(57344bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 65535bv16));
    assume true;
    assume $Is(Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0), TBool);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> b#0;
    return;
}



function Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) ==> !Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstWord#0 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (var secondWord#0 := $Unbox(Seq#Index(s#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#0) && le_bv16(firstWord#0, 56319bv16) && le_bv16(56320bv16, secondWord#0) && le_bv16(secondWord#0, 57343bv16)))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (var secondWord#1 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv16; le_bv16(55296bv16, firstWord#1) && le_bv16(firstWord#1, 56319bv16) && le_bv16(56320bv16, secondWord#1) && le_bv16(secondWord#1, 57343bv16)))));
}

function Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#requires(s#0) <==> Seq#Length(s#0) == LitInt(2)));

procedure {:verboseName "Utf16EncodingForm.IsWellFormedDoubleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (b#0: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8252"} b#0 ==> !Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.IsWellFormedDoubleCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0: Seq) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var firstWord#Z#0: bv16;
  var let#0#0#0: bv16;
  var secondWord#Z#0: bv16;
  var let#1#0#0: bv16;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.IsWellFormedDoubleCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(41,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(2);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume b#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(1);
    assume Seq#Length(##s#0) == LitInt(1);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)));
    assume !Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    goto anon5;

  anon13_Else:
    assume b#0 ==> !Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    havoc firstWord#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    assume let#0#0#0 == $Unbox(Seq#Index(s#0, LitInt(0))): bv16;
    assume true;
    assume $Is(let#0#0#0, TBitvector(16));
    assume firstWord#Z#0 == let#0#0#0;
    havoc secondWord#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    assume let#1#0#0 == $Unbox(Seq#Index(s#0, LitInt(1))): bv16;
    assume true;
    assume $Is(let#1#0#0, TBitvector(16));
    assume secondWord#Z#0 == let#1#0#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} le_bv16(55296bv16, firstWord#Z#0);
    goto anon8;

  anon14_Else:
    assume {:partition} !le_bv16(55296bv16, firstWord#Z#0);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} le_bv16(55296bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 56319bv16);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} le_bv16(56320bv16, secondWord#Z#0);
    goto anon11;

  anon16_Else:
    assume {:partition} !le_bv16(56320bv16, secondWord#Z#0);
    goto anon11;

  anon15_Else:
    assume {:partition} !(le_bv16(55296bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 56319bv16));
    goto anon11;

  anon11:
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> le_bv16(55296bv16, firstWord#Z#0) && le_bv16(firstWord#Z#0, 56319bv16) && le_bv16(56320bv16, secondWord#Z#0) && le_bv16(secondWord#Z#0, 57343bv16);
    assume true;
    assume $Is(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0), TBool);
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> b#0;
    return;
}



function Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq) : DatatypeType
uses {
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#0: int :: { Seq#Take(s#0, i#0) } 0 < i#0 && i#0 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#0))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(s#0) && Seq#Equal(prefix#0, Seq#Take(s#0, Seq#Length(prefix#0))) && (forall i#1: int :: { Seq#Take(s#0, i#1) } 0 < i#1 && i#1 < Seq#Length(prefix#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#1))))) && (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#2: int :: { Seq#Take(s#0, i#2) } 0 < i#2 && i#2 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#2))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#1) && Seq#Length(prefix#1) <= Seq#Length(s#0) && Seq#Equal(prefix#1, Seq#Take(s#0, Seq#Length(prefix#1))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#1))) && $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Seq#Length(s#0) >= LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)))) && (!(Seq#Length(s#0) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)))) ==> Seq#Length(s#0) >= LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)))) && Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == (if Seq#Length(s#0) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1)))) else (if Seq#Length(s#0) >= LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2)))) else #Wrappers.Option.None())));
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Seq#Length(Lit(s#0)) >= LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(1))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1))))) ==> Seq#Length(Lit(s#0)) >= LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(2))))) && Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) == (if Seq#Length(Lit(s#0)) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(1))))) else (if Seq#Length(Lit(s#0)) >= LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(2)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(2))))) else #Wrappers.Option.None())));
}

function Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0: Seq) : bool;

function Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq() : Ty
uses {
axiom Tag(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) == Tagclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq && TagFamily(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) == tytagFamily$MinimalWellFormedCodeUnitSeq;
}

const unique Tagclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) } $IsBox(bx, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));

function Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#requires(s#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (maybePrefix#0: DatatypeType where $Is(maybePrefix#0, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8267"} Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
  free ensures {:id "id8268"} (exists i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#3))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
  free ensures {:id "id8269"} Wrappers.Option.Some_q(maybePrefix#0) ==> Lit(true);
  free ensures {:id "id8270"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#2));
  free ensures {:id "id8271"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Length(prefix#2) <= Seq#Length(s#0));
  free ensures {:id "id8272"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Equal(prefix#2, Seq#Take(s#0, Seq#Length(prefix#2))));
  free ensures {:id "id8273"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(prefix#2) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#4))));
  free ensures {:id "id8274"} Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
  free ensures {:id "id8275"} (exists i#5: int :: { Seq#Take(s#0, i#5) } 0 < i#5 && i#5 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(s#0, i#5))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
  free ensures {:id "id8276"} Wrappers.Option.Some_q(maybePrefix#0) ==> Lit(true);
  free ensures {:id "id8277"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#3));
  free ensures {:id "id8278"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Length(prefix#3) <= Seq#Length(s#0));
  free ensures {:id "id8279"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Seq#Equal(prefix#3, Seq#Take(s#0, Seq#Length(prefix#3))));
  free ensures {:id "id8280"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(prefix#3) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#3) || (Seq#Length(prefix#3) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(prefix#3) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(prefix#3) || (var firstWord#0 := $Unbox(Seq#Index(prefix#3, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#0) && le_bv16(firstWord#0, 55295bv16)) || (le_bv16(57344bv16, firstWord#0) && le_bv16(firstWord#0, 65535bv16)))));
  free ensures {:id "id8281"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(prefix#3) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#3) || (Seq#Length(prefix#3) != LitInt(1) ==> Seq#Length(prefix#3) == LitInt(2) ==> (var b#0 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(prefix#3); (b#0 ==> (forall i#6: int :: { Seq#Take(prefix#3, i#6) } 0 < i#6 && i#6 < Seq#Length(prefix#3) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(prefix#3, i#6)))) ==> b#0)));
  free ensures {:id "id8282"} Wrappers.Option.Some_q(maybePrefix#0) ==> (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(prefix#3) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#3) || (Seq#Length(prefix#3) != LitInt(1) ==> Seq#Length(prefix#3) != LitInt(2) ==> Lit(false)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0: Seq) returns (maybePrefix#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#7: int;
  var ##s#0: Seq;
  var prefix#Z#0: Seq;
  var let#0#0#0: Seq;
  var i#8: int;
  var ##s#1: Seq;
  var i#9: int;
  var ##s#2: Seq;
  var prefix#Z#1: Seq;
  var let#1#0#0: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.SplitPrefixMinimalWellFormedCodeUnitSubsequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(51,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume Seq#Length(s#0) == LitInt(0);
    assume Wrappers.Option.None_q(maybePrefix#0);
    goto anon5;

  anon57_Else:
    assume Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
    goto anon5;

  anon5:
    havoc i#7;
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} true;
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} 0 < i#7;
    goto anon8;

  anon59_Else:
    assume {:partition} i#7 <= 0;
    goto anon8;

  anon8:
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} 0 < i#7 && i#7 <= Seq#Length(s#0);
    assume 0 <= i#7 && i#7 <= Seq#Length(s#0);
    ##s#0 := Seq#Take(s#0, i#7);
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#7));
    goto anon10;

  anon60_Else:
    assume {:partition} !(0 < i#7 && i#7 <= Seq#Length(s#0));
    goto anon10;

  anon58_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} Lit(true);
    goto anon12;

  anon61_Else:
    assume {:partition} !Lit(true);
    goto anon12;

  anon12:
    assume (exists i#3: int :: { Seq#Take(s#0, i#3) } 0 < i#3 && i#3 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#3))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume true;
    havoc prefix#Z#0;
    assume $Is(prefix#Z#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(maybePrefix#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume let#0#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume $Is(let#0#0#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#0 == let#0#0#0;
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0);
    goto anon15;

  anon63_Else:
    assume {:partition} Seq#Length(prefix#Z#0) <= 0;
    goto anon15;

  anon15:
    goto anon64_Then, anon64_Else;

  anon64_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    assume 0 <= Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    goto anon17;

  anon64_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0));
    goto anon17;

  anon17:
    goto anon65_Then, anon65_Else;

  anon65_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#0, Seq#Take(s#0, Seq#Length(prefix#Z#0)));
    havoc i#8;
    goto anon66_Then, anon66_Else;

  anon66_Then:
    assume {:partition} true;
    goto anon67_Then, anon67_Else;

  anon67_Then:
    assume {:partition} 0 < i#8;
    goto anon21;

  anon67_Else:
    assume {:partition} i#8 <= 0;
    goto anon21;

  anon21:
    goto anon68_Then, anon68_Else;

  anon68_Then:
    assume {:partition} 0 < i#8 && i#8 < Seq#Length(prefix#Z#0);
    assume 0 <= i#8 && i#8 <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, i#8);
    assume $IsAlloc(##s#1, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#8));
    goto anon23;

  anon68_Else:
    assume {:partition} !(0 < i#8 && i#8 < Seq#Length(prefix#Z#0));
    goto anon23;

  anon66_Else:
    assume {:partition} false;
    goto anon23;

  anon23:
    goto anon24;

  anon65_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#0, Seq#Take(s#0, Seq#Length(prefix#Z#0))));
    goto anon24;

  anon24:
    assume (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#2) && Seq#Length(prefix#2) <= Seq#Length(s#0) && Seq#Equal(prefix#2, Seq#Take(s#0, Seq#Length(prefix#2))) && (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(prefix#2) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#4))));
    goto anon26;

  anon62_Else:
    assume Wrappers.Option.Some_q(maybePrefix#0) ==> true && (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#2) && Seq#Length(prefix#2) <= Seq#Length(s#0) && Seq#Equal(prefix#2, Seq#Take(s#0, Seq#Length(prefix#2))) && (forall i#4: int :: { Seq#Take(s#0, i#4) } 0 < i#4 && i#4 < Seq#Length(prefix#2) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#4))));
    goto anon26;

  anon26:
    goto anon69_Then, anon69_Else;

  anon69_Then:
    assume Seq#Length(s#0) == LitInt(0);
    assume Wrappers.Option.None_q(maybePrefix#0);
    goto anon29;

  anon69_Else:
    assume Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(maybePrefix#0);
    goto anon29;

  anon29:
    havoc i#9;
    goto anon70_Then, anon70_Else;

  anon70_Then:
    assume {:partition} true;
    goto anon71_Then, anon71_Else;

  anon71_Then:
    assume {:partition} 0 < i#9;
    goto anon32;

  anon71_Else:
    assume {:partition} i#9 <= 0;
    goto anon32;

  anon32:
    goto anon72_Then, anon72_Else;

  anon72_Then:
    assume {:partition} 0 < i#9 && i#9 <= Seq#Length(s#0);
    assume 0 <= i#9 && i#9 <= Seq#Length(s#0);
    ##s#2 := Seq#Take(s#0, i#9);
    assume $IsAlloc(##s#2, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(s#0, i#9));
    goto anon34;

  anon72_Else:
    assume {:partition} !(0 < i#9 && i#9 <= Seq#Length(s#0));
    goto anon34;

  anon70_Else:
    assume {:partition} false;
    goto anon34;

  anon34:
    goto anon73_Then, anon73_Else;

  anon73_Then:
    assume {:partition} Lit(true);
    goto anon36;

  anon73_Else:
    assume {:partition} !Lit(true);
    goto anon36;

  anon36:
    assume (exists i#5: int :: { Seq#Take(s#0, i#5) } 0 < i#5 && i#5 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#5))) <==> true && Wrappers.Option.Some_q(maybePrefix#0);
    goto anon74_Then, anon74_Else;

  anon74_Then:
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume true;
    havoc prefix#Z#1;
    assume $Is(prefix#Z#1, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#1, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(maybePrefix#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Some_q(maybePrefix#0);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume let#1#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0);
    assume $Is(let#1#0#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#1 == let#1#0#0;
    goto anon75_Then, anon75_Else;

  anon75_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#1);
    goto anon39;

  anon75_Else:
    assume {:partition} Seq#Length(prefix#Z#1) <= 0;
    goto anon39;

  anon39:
    goto anon76_Then, anon76_Else;

  anon76_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#1) && Seq#Length(prefix#Z#1) <= Seq#Length(s#0);
    assume 0 <= Seq#Length(prefix#Z#1) && Seq#Length(prefix#Z#1) <= Seq#Length(s#0);
    goto anon41;

  anon76_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#1) && Seq#Length(prefix#Z#1) <= Seq#Length(s#0));
    goto anon41;

  anon41:
    goto anon77_Then, anon77_Else;

  anon77_Then:
    assume {:partition} 0 < Seq#Length(prefix#Z#1) && Seq#Length(prefix#Z#1) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#1, Seq#Take(s#0, Seq#Length(prefix#Z#1)));
    ##s#3 := prefix#Z#1;
    assume $IsAlloc(##s#3, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(prefix#Z#1);
    goto anon43;

  anon77_Else:
    assume {:partition} !(0 < Seq#Length(prefix#Z#1) && Seq#Length(prefix#Z#1) <= Seq#Length(s#0) && Seq#Equal(prefix#Z#1, Seq#Take(s#0, Seq#Length(prefix#Z#1))));
    goto anon43;

  anon43:
    assume (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#3) && Seq#Length(prefix#3) <= Seq#Length(s#0) && Seq#Equal(prefix#3, Seq#Take(s#0, Seq#Length(prefix#3))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#3));
    goto anon45;

  anon74_Else:
    assume Wrappers.Option.Some_q(maybePrefix#0) ==> true && (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), maybePrefix#0)): Seq; 0 < Seq#Length(prefix#3) && Seq#Length(prefix#3) <= Seq#Length(s#0) && Seq#Equal(prefix#3, Seq#Take(s#0, Seq#Length(prefix#3))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#3));
    goto anon45;

  anon45:
    assume false;
    return;

  anon56_Else:
    goto anon78_Then, anon78_Else;

  anon78_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(1);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#4 := Seq#Take(s#0, LitInt(1));
    assume $IsAlloc(##s#4, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#4) == LitInt(1);
    assume Seq#Length(##s#4) == LitInt(1);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)));
    goto anon48;

  anon78_Else:
    assume {:partition} LitInt(1) > Seq#Length(s#0);
    goto anon48;

  anon48:
    goto anon79_Then, anon79_Else;

  anon79_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume $Is(#Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1)))), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1))));
    assume true;
    assume $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon55;

  anon79_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))));
    goto anon80_Then, anon80_Else;

  anon80_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(2);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##s#5 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##s#5, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#5) == LitInt(2);
    assume Seq#Length(##s#5) == LitInt(2);
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)));
    goto anon52;

  anon80_Else:
    assume {:partition} LitInt(2) > Seq#Length(s#0);
    goto anon52;

  anon52:
    goto anon81_Then, anon81_Else;

  anon81_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)));
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    assume $Is(#Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2)))), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2))));
    assume true;
    assume $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon55;

  anon81_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))));
    assume $Is(Lit(#Wrappers.Option.None()), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    goto anon55;

  anon55:
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == maybePrefix#0;
    return;
}



function Utf16EncodingForm.__default.EncodeScalarValue(v#0: bv24) : Seq
uses {
axiom 7 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue(v#0) } Utf16EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (7 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> $Is(Utf16EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
axiom 7 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue(v#0) } Utf16EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (7 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0)) && (!((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24))) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0)) && Utf16EncodingForm.__default.EncodeScalarValue(v#0) == (if (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) then Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) else Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0)));
axiom 7 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValue(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValue#canCall(Lit(v#0)) || (7 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0))) && (!((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24))) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0))) && Utf16EncodingForm.__default.EncodeScalarValue(Lit(v#0)) == (if (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) then Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) else Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0))));
}

function Utf16EncodingForm.__default.EncodeScalarValue#canCall(v#0: bv24) : bool;

function Utf16EncodingForm.__default.EncodeScalarValue#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf16EncodingForm.__default.EncodeScalarValue#requires(v#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.EncodeScalarValue (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarValue(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.EncodeScalarValue (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarValue(v#0: bv24) returns (m#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var ##v#1: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.EncodeScalarValue", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(71,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} le_bv24(0bv24, v#0);
    goto anon5;

  anon13_Else:
    assume {:partition} !le_bv24(0bv24, v#0);
    goto anon5;

  anon5:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} !(le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} le_bv24(57344bv24, v#0);
    goto anon8;

  anon15_Else:
    assume {:partition} !le_bv24(57344bv24, v#0);
    goto anon8;

  anon14_Else:
    assume {:partition} le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24);
    goto anon8;

  anon8:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24));
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} (le_bv24(0bv24, ##v#0) && le_bv24(##v#0, 55295bv24)) || (le_bv24(57344bv24, ##v#0) && le_bv24(##v#0, 65535bv24));
    assume (le_bv24(0bv24, ##v#0) && le_bv24(##v#0, 55295bv24)) || (le_bv24(57344bv24, ##v#0) && le_bv24(##v#0, 65535bv24));
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0);
    assume Utf16EncodingForm.__default.EncodeScalarValue(v#0) == Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0);
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0);
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    goto anon11;

  anon16_Else:
    assume {:partition} !((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)));
    ##v#1 := v#0;
    assume $IsAlloc(##v#1, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(65536bv24, ##v#1);
    assume {:subsumption 0} le_bv24(##v#1, 1114111bv24);
    assume le_bv24(65536bv24, ##v#1) && le_bv24(##v#1, 1114111bv24);
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0);
    assume Utf16EncodingForm.__default.EncodeScalarValue(v#0) == Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0);
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0);
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    goto anon11;

  anon11:
    assume Utf16EncodingForm.__default.EncodeScalarValue(v#0) == m#0;
    return;
}



function Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0: bv24) : Seq
uses {
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Seq#Length(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0)) == LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0)) && $Is(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == (var firstWord#0 := v#0[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#0))));
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0)) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) == (var firstWord#1 := Lit(v#0)[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#1))));
}

function Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0: bv24) : bool;

function Utf16EncodingForm.__default.EncodeScalarValueSingleWord#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf16EncodingForm.__default.EncodeScalarValueSingleWord#requires(v#0) <==> (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24))));

procedure {:verboseName "Utf16EncodingForm.EncodeScalarValueSingleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8329"} Seq#Length(m#0) == LitInt(1);
  free ensures {:id "id8330"} Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(m#0) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(m#0) || (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#2) && le_bv16(firstWord#2, 55295bv16)) || (le_bv16(57344bv16, firstWord#2) && le_bv16(firstWord#2, 65535bv16)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.EncodeScalarValueSingleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0: bv24) returns (m#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var firstWord#Z#0: bv16;
  var let#0#0#0: bv16;
  var newtype$check#0: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.EncodeScalarValueSingleWord", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(77,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} le_bv24(0bv24, v#0);
    goto anon4;

  anon12_Else:
    assume {:partition} !le_bv24(0bv24, v#0);
    goto anon4;

  anon4:
    assume le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24);
    goto anon8;

  anon11_Else:
    assume !(le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} le_bv24(57344bv24, v#0);
    goto anon7;

  anon13_Else:
    assume {:partition} !le_bv24(57344bv24, v#0);
    goto anon7;

  anon7:
    assume le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24);
    goto anon8;

  anon8:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Seq#Length(m#0) == LitInt(1);
    ##s#0 := m#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(1);
    assume Seq#Length(##s#0) == LitInt(1);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(m#0);
    assume Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(m#0);
    assume false;
    return;

  anon14_Else:
    havoc firstWord#Z#0;
    assume true;
    newtype$check#0 := v#0;
    assume lt_bv24(newtype$check#0, 65536bv24);
    assume let#0#0#0 == v#0[16:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(16));
    assume firstWord#Z#0 == let#0#0#0;
    assume $Is(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#Z#0)), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == Seq#Build(Seq#Empty(): Seq, $Box(firstWord#Z#0));
    assume true;
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == m#0;
    return;
}



function Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0: bv24) : Seq
uses {
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Seq#Length(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0)) == LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0)) && $Is(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == (var x2#0 := and_bv24(v#0, 1023bv24)[10:0]; (var x1#0 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#0 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#0 := sub_bv5(u#0, 1bv5)[4:0]; (var firstWord#0 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#0): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#0): bv16); (var secondWord#0 := or_bv16(56320bv16, (0bv6 ++ x2#0): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#0)), $Box(secondWord#0)))))))));
axiom 6 <= $FunctionContextHeight ==> (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0)) || (6 < $FunctionContextHeight && le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) == (var x2#1 := Lit(and_bv24(v#0, 1023bv24))[10:0]; (var x1#1 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#1 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#1 := sub_bv5(u#1, 1bv5)[4:0]; (var firstWord#1 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#1): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#1): bv16); (var secondWord#1 := or_bv16(56320bv16, (0bv6 ++ x2#1): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#1)), $Box(secondWord#1)))))))));
}

function Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0: bv24) : bool;

function Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#requires(bv24) : bool;

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#requires(v#0) } le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) ==> (Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#requires(v#0) <==> le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)));

procedure {:verboseName "Utf16EncodingForm.EncodeScalarValueDoubleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) returns (m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8343"} Seq#Length(m#0) == LitInt(2);
  free ensures {:id "id8344"} Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(m#0) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(m#0) || (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#2)));
  free ensures {:id "id8345"} Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(m#0) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(m#0) || (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; le_bv16(firstWord#2, 56319bv16)));
  free ensures {:id "id8346"} Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(m#0) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(m#0) || (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; le_bv16(56320bv16, secondWord#2)));
  free ensures {:id "id8347"} Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(m#0) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(m#0) || (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; le_bv16(secondWord#2, 57343bv16)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.EncodeScalarValueDoubleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0: bv24) returns (m#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var x2#Z#0: bv10;
  var let#0#0#0: bv10;
  var newtype$check#0: bv24;
  var x1#Z#0: bv6;
  var let#1#0#0: bv6;
  var newtype$check#1: int;
  var newtype$check#2: bv24;
  var u#Z#0: bv5;
  var let#2#0#0: bv5;
  var newtype$check#3: int;
  var newtype$check#4: bv24;
  var w#Z#0: bv4;
  var let#3#0#0: bv4;
  var newtype$check#5: bv5;
  var firstWord#Z#0: bv16;
  var let#4#0#0: bv16;
  var newtype$check#6: int;
  var secondWord#Z#0: bv16;
  var let#5#0#0: bv16;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.EncodeScalarValueDoubleWord", " | ", v#0} true;
    assume {:print "Types", " | ", "bv24"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(88,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} le_bv24(65536bv24, v#0);
    goto anon3;

  anon6_Else:
    assume {:partition} !le_bv24(65536bv24, v#0);
    goto anon3;

  anon3:
    assume le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Seq#Length(m#0) == LitInt(2);
    ##s#0 := m#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(2);
    assume Seq#Length(##s#0) == LitInt(2);
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(m#0);
    assume Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(m#0);
    assume false;
    return;

  anon7_Else:
    havoc x2#Z#0;
    assume true;
    newtype$check#0 := and_bv24(v#0, 1023bv24);
    assume lt_bv24(newtype$check#0, 1024bv24);
    assume let#0#0#0 == and_bv24(v#0, 1023bv24)[10:0];
    assume true;
    assume $Is(let#0#0#0, TBitvector(10));
    assume x2#Z#0 == let#0#0#0;
    havoc x1#Z#0;
    assume true;
    newtype$check#1 := LitInt(10);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(10bv5, 24bv5);
    newtype$check#2 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24);
    assume lt_bv24(newtype$check#2, 64bv24);
    assume let#1#0#0 == RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0];
    assume true;
    assume $Is(let#1#0#0, TBitvector(6));
    assume x1#Z#0 == let#1#0#0;
    havoc u#Z#0;
    assume true;
    newtype$check#3 := LitInt(16);
    assume 0 <= newtype$check#3 && newtype$check#3 < 32;
    assume le_bv5(16bv5, 24bv5);
    newtype$check#4 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24);
    assume lt_bv24(newtype$check#4, 32bv24);
    assume let#2#0#0 == RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0];
    assume true;
    assume $Is(let#2#0#0, TBitvector(5));
    assume u#Z#0 == let#2#0#0;
    havoc w#Z#0;
    assume true;
    newtype$check#5 := sub_bv5(u#Z#0, 1bv5);
    assume lt_bv5(newtype$check#5, 16bv5);
    assume let#3#0#0 == sub_bv5(u#Z#0, 1bv5)[4:0];
    assume true;
    assume $Is(let#3#0#0, TBitvector(4));
    assume w#Z#0 == let#3#0#0;
    havoc firstWord#Z#0;
    assume true;
    newtype$check#6 := LitInt(6);
    assume 0 <= newtype$check#6 && newtype$check#6 < 32;
    assume le_bv5(6bv5, 16bv5);
    assume let#4#0#0 == or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#Z#0): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#Z#0): bv16);
    assume true;
    assume $Is(let#4#0#0, TBitvector(16));
    assume firstWord#Z#0 == let#4#0#0;
    havoc secondWord#Z#0;
    assume true;
    assume let#5#0#0 == or_bv16(56320bv16, (0bv6 ++ x2#Z#0): bv16);
    assume true;
    assume $Is(let#5#0#0, TBitvector(16));
    assume secondWord#Z#0 == let#5#0#0;
    assume $Is(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#Z#0)), $Box(secondWord#Z#0)), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#Z#0)), $Box(secondWord#Z#0));
    assume true;
    assume $Is(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == m#0;
    return;
}



function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq) : bv24
uses {
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) ==> Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValue(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)), m#0) && le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) ==> (Seq#Length(m#0) == LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0)) && (Seq#Length(m#0) != LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0)) && Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == (if Seq#Length(m#0) == LitInt(1) then Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) else Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)));
axiom 8 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(Lit(m#0)) || (8 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) ==> (Seq#Length(Lit(m#0)) == LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0))) && Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) == (if Seq#Length(Lit(m#0)) == LitInt(1) then Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) else Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0))));
}

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0: Seq) : bool;

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(m#0) } $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires(m#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8377"} Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValue(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var ##m#0: Seq;
  var ##m#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(106,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume Utf16EncodingForm.__default.EncodeScalarValue#canCall(v#0);
    assume Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValue(v#0), m#0);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(m#0) == LitInt(1);
    ##m#0 := m#0;
    assume $IsAlloc(##m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume {:subsumption 0} Seq#Length(##m#0) == LitInt(1);
    assume Seq#Length(##m#0) == LitInt(1);
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0);
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0);
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0);
    assume $Is(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Tclass.Unicode.ScalarValue());
    goto anon6;

  anon8_Else:
    assume {:partition} Seq#Length(m#0) != LitInt(1);
    assume true;
    assume Seq#Length(m#0) == LitInt(2);
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(109,24)"} true;
    ##m#1 := m#0;
    assume $IsAlloc(##m#1, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume {:subsumption 0} Seq#Length(##m#1) == LitInt(2);
    assume Seq#Length(##m#1) == LitInt(2);
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0);
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0);
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0);
    assume $Is(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Tclass.Unicode.ScalarValue());
    goto anon6;

  anon6:
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == v#0;
    return;
}



function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0: Seq) : bv24
uses {
axiom 7 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || (7 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> ((le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 55295bv24)) || (le_bv24(57344bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 65535bv24))) && Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)), m#0) && le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 7 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || (7 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (var firstWord#0 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var x#0 := firstWord#0; (0bv8 ++ x#0): bv24)));
axiom 7 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0)) || (7 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) == (var firstWord#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var x#1 := firstWord#1; (0bv8 ++ x#1): bv24)));
}

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0: Seq) : bool;

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#requires(m#0) } $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#requires(m#0) <==> Seq#Length(m#0) == LitInt(1)));

procedure {:verboseName "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#0: bv24 where le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8385"} (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24));
  free ensures {:id "id8386"} Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0: Seq) returns (v#0: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var firstWord#Z#0: bv16;
  var let#0#0#0: bv16;
  var x#Z#0: bv16;
  var let#1#0#0: bv16;
  var newtype$check#0: bv16;
  var newtype$check#1: bv24;
  var ##v#1: bv24;
  var newtype$check#2: bv16;
  var newtype$check#3: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(112,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(m#0) == LitInt(1);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} le_bv24(0bv24, v#0);
    goto anon5;

  anon13_Else:
    assume {:partition} !le_bv24(0bv24, v#0);
    goto anon5;

  anon5:
    assume le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24);
    goto anon9;

  anon12_Else:
    assume !(le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} le_bv24(57344bv24, v#0);
    goto anon8;

  anon14_Else:
    assume {:partition} !le_bv24(57344bv24, v#0);
    goto anon8;

  anon8:
    assume le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24);
    goto anon9;

  anon9:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} (le_bv24(0bv24, ##v#0) && le_bv24(##v#0, 55295bv24)) || (le_bv24(57344bv24, ##v#0) && le_bv24(##v#0, 65535bv24));
    assume (le_bv24(0bv24, ##v#0) && le_bv24(##v#0, 55295bv24)) || (le_bv24(57344bv24, ##v#0) && le_bv24(##v#0, 65535bv24));
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0);
    assume Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0), m#0);
    assume false;
    return;

  anon11_Else:
    havoc firstWord#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(m#0);
    assume let#0#0#0 == $Unbox(Seq#Index(m#0, LitInt(0))): bv16;
    assume true;
    assume $Is(let#0#0#0, TBitvector(16));
    assume firstWord#Z#0 == let#0#0#0;
    havoc x#Z#0;
    assume true;
    assume let#1#0#0 == firstWord#Z#0;
    assume true;
    assume $Is(let#1#0#0, TBitvector(16));
    assume x#Z#0 == let#1#0#0;
    newtype$check#0 := x#Z#0;
    assume le_bv24(0bv24, (0bv8 ++ newtype$check#0): bv24) && le_bv24((0bv8 ++ newtype$check#0): bv24, 1114111bv24);
    assume (lt_bv24((0bv8 ++ newtype$check#0): bv24, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24((0bv8 ++ newtype$check#0): bv24, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24((0bv8 ++ newtype$check#0): bv24, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24((0bv8 ++ newtype$check#0): bv24, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#1 := (0bv8 ++ x#Z#0): bv24;
    assume le_bv24(0bv24, newtype$check#1) && le_bv24(newtype$check#1, 1114111bv24);
    assume (lt_bv24(newtype$check#1, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#1, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#1, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#1, Unicode.__default.LOW__SURROGATE__MAX()));
    ##v#1 := (0bv8 ++ x#Z#0): bv24;
    assume $IsAlloc(##v#1, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} (le_bv24(0bv24, ##v#1) && le_bv24(##v#1, 55295bv24)) || (le_bv24(57344bv24, ##v#1) && le_bv24(##v#1, 65535bv24));
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall((0bv8 ++ x#Z#0): bv24);
    assume Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall((0bv8 ++ x#Z#0): bv24);
    assume Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueSingleWord((0bv8 ++ x#Z#0): bv24), m#0);
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(121,69)"} true;
    newtype$check#2 := x#Z#0;
    assume le_bv24(0bv24, (0bv8 ++ newtype$check#2): bv24) && le_bv24((0bv8 ++ newtype$check#2): bv24, 1114111bv24);
    assume (lt_bv24((0bv8 ++ newtype$check#2): bv24, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24((0bv8 ++ newtype$check#2): bv24, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24((0bv8 ++ newtype$check#2): bv24, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24((0bv8 ++ newtype$check#2): bv24, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#3 := (0bv8 ++ x#Z#0): bv24;
    assume le_bv24(0bv24, newtype$check#3) && le_bv24(newtype$check#3, 1114111bv24);
    assume (lt_bv24(newtype$check#3, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#3, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#3, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#3, Unicode.__default.LOW__SURROGATE__MAX()));
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (0bv8 ++ x#Z#0): bv24;
    assume true;
    assume $Is(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Tclass.Unicode.ScalarValue());
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == v#0;
    return;
}



function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0: Seq) : bv24
uses {
axiom 7 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || (7 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> le_bv24(65536bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), 1114111bv24) && Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)), m#0) && le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.LOW__SURROGATE__MAX())));
axiom 7 <= $FunctionContextHeight ==> (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || (7 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == (var firstWord#0 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#0 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; (var x2#0 := (0bv8 ++ and_bv16(secondWord#0, 1023bv16)): bv24; (var x1#0 := (0bv8 ++ and_bv16(firstWord#0, 63bv16)): bv24; (var w#0 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#0, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#0 := add_bv24(w#0, 1bv24); (var v#0 := or_bv24(or_bv24(LeftShift_bv24(u#0, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#0, (0bv19 ++ 10bv5): bv24)), x2#0); v#0))))))));
axiom 7 <= $FunctionContextHeight ==> (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0)) || (7 < $FunctionContextHeight && $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) == (var firstWord#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var secondWord#1 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv16; (var x2#1 := (0bv8 ++ and_bv16(secondWord#1, 1023bv16)): bv24; (var x1#1 := (0bv8 ++ and_bv16(firstWord#1, 63bv16)): bv24; (var w#1 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#1, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#1 := add_bv24(w#1, 1bv24); (var v#1 := or_bv24(or_bv24(LeftShift_bv24(u#1, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#1, (0bv19 ++ 10bv5): bv24)), x2#1); v#1))))))));
}

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0: Seq) : bool;

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#requires(Seq) : bool;

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#requires(m#0) } $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#requires(m#0) <==> Seq#Length(m#0) == LitInt(2)));

procedure {:verboseName "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) returns (v#2: bv24 where le_bv24(0bv24, v#2) && le_bv24(v#2, 1114111bv24) && (lt_bv24(v#2, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#2, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#2, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#2, Unicode.__default.LOW__SURROGATE__MAX())));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8410"} le_bv24(65536bv24, v#2);
  free ensures {:id "id8411"} le_bv24(v#2, 1114111bv24);
  free ensures {:id "id8412"} Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#2), m#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0: Seq) returns (v#2: bv24)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: bv24;
  var firstWord#Z#0: bv16;
  var let#0#0#0: bv16;
  var secondWord#Z#0: bv16;
  var let#1#0#0: bv16;
  var x2#Z#0: bv24;
  var let#2#0#0: bv24;
  var x1#Z#0: bv24;
  var let#3#0#0: bv24;
  var w#Z#0: bv24;
  var let#4#0#0: bv24;
  var newtype$check#0: int;
  var u#Z#0: bv24;
  var let#5#0#0: bv24;
  var v#Z#0: bv24;
  var let#6#0#0: bv24;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: bv24;
  var newtype$check#4: bv24;
  var ##v#1: bv24;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(125,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(m#0) == LitInt(2);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.LOW__SURROGATE__MAX()));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} le_bv24(65536bv24, v#2);
    goto anon4;

  anon7_Else:
    assume {:partition} !le_bv24(65536bv24, v#2);
    goto anon4;

  anon4:
    assume le_bv24(65536bv24, v#2) && le_bv24(v#2, 1114111bv24);
    ##v#0 := v#2;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(65536bv24, ##v#0);
    assume {:subsumption 0} le_bv24(##v#0, 1114111bv24);
    assume le_bv24(65536bv24, ##v#0) && le_bv24(##v#0, 1114111bv24);
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#2);
    assume Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#2), m#0);
    assume false;
    return;

  anon6_Else:
    havoc firstWord#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(m#0);
    assume let#0#0#0 == $Unbox(Seq#Index(m#0, LitInt(0))): bv16;
    assume true;
    assume $Is(let#0#0#0, TBitvector(16));
    assume firstWord#Z#0 == let#0#0#0;
    havoc secondWord#Z#0;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(m#0);
    assume let#1#0#0 == $Unbox(Seq#Index(m#0, LitInt(1))): bv16;
    assume true;
    assume $Is(let#1#0#0, TBitvector(16));
    assume secondWord#Z#0 == let#1#0#0;
    havoc x2#Z#0;
    assume true;
    assume let#2#0#0 == (0bv8 ++ and_bv16(secondWord#Z#0, 1023bv16)): bv24;
    assume true;
    assume $Is(let#2#0#0, TBitvector(24));
    assume x2#Z#0 == let#2#0#0;
    havoc x1#Z#0;
    assume true;
    assume let#3#0#0 == (0bv8 ++ and_bv16(firstWord#Z#0, 63bv16)): bv24;
    assume true;
    assume $Is(let#3#0#0, TBitvector(24));
    assume x1#Z#0 == let#3#0#0;
    havoc w#Z#0;
    assume true;
    newtype$check#0 := LitInt(6);
    assume 0 <= newtype$check#0 && newtype$check#0 < 32;
    assume le_bv5(6bv5, 16bv5);
    assume let#4#0#0 == (0bv8 ++ RightShift_bv16(and_bv16(firstWord#Z#0, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24;
    assume true;
    assume $Is(let#4#0#0, TBitvector(24));
    assume w#Z#0 == let#4#0#0;
    havoc u#Z#0;
    assume true;
    assume let#5#0#0 == add_bv24(w#Z#0, 1bv24);
    assume true;
    assume $Is(let#5#0#0, TBitvector(24));
    assume u#Z#0 == let#5#0#0;
    havoc v#Z#0;
    assume true;
    newtype$check#1 := LitInt(16);
    assume 0 <= newtype$check#1 && newtype$check#1 < 32;
    assume le_bv5(16bv5, 24bv5);
    newtype$check#2 := LitInt(10);
    assume 0 <= newtype$check#2 && newtype$check#2 < 32;
    assume le_bv5(10bv5, 24bv5);
    newtype$check#3 := x2#Z#0;
    assume le_bv24(0bv24, newtype$check#3) && le_bv24(newtype$check#3, 1114111bv24);
    assume (lt_bv24(newtype$check#3, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#3, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#3, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#3, Unicode.__default.LOW__SURROGATE__MAX()));
    newtype$check#4 := x2#Z#0;
    assume le_bv24(0bv24, newtype$check#4) && le_bv24(newtype$check#4, 1114111bv24);
    assume (lt_bv24(newtype$check#4, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(newtype$check#4, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(newtype$check#4, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(newtype$check#4, Unicode.__default.LOW__SURROGATE__MAX()));
    assume let#6#0#0 == or_bv24(or_bv24(LeftShift_bv24(u#Z#0, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#Z#0, (0bv19 ++ 10bv5): bv24)), x2#Z#0);
    assume true;
    assume $Is(let#6#0#0, TBitvector(24));
    assume v#Z#0 == let#6#0#0;
    assume true;
    assume {:split_here} Lit(true);
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(137,29)"} true;
    assume $Is(v#Z#0, Tclass.Unicode.ScalarValue());
    ##v#1 := v#Z#0;
    assume $IsAlloc(##v#1, Tclass.Unicode.ScalarValue(), $Heap);
    assume {:subsumption 0} le_bv24(65536bv24, ##v#1);
    assume {:subsumption 0} le_bv24(##v#1, 1114111bv24);
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#Z#0);
    assume Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#Z#0);
    assume Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#Z#0), m#0);
    assume {:captureState "libraries/src/Unicode/Utf16EncodingForm.dfy(138,46)"} true;
    assume $Is(v#Z#0, Tclass.Unicode.ScalarValue());
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == v#Z#0;
    assume true;
    assume $Is(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Tclass.Unicode.ScalarValue());
    assume Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == v#2;
    return;
}



procedure {:verboseName "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call precondtion)"} CallPre$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap));



procedure {:verboseName "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0))) && Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id8453"} Wrappers.Option#Equal(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0)), #Wrappers.Option.Some($Box(m#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0))) && Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id8454"} $_reverifyPost ==> Wrappers.Option#Equal(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Seq#Append(m#0, s#0)), #Wrappers.Option.Some($Box(m#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ms#0: Seq where $Is(ms#0, TSeq(TBitvector(16))) && $IsAlloc(ms#0, TSeq(TBitvector(16)), $Heap);
  var ##s#1: Seq;
  var defass#prefix#0: bool;
  var prefix#0: Seq where defass#prefix#0 ==> $Is(prefix#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var ##s#2: Seq;
  var ##s#0_1_0: Seq;
  var ##s#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](101,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    ms#0 := Seq#Append(m#0, s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](102,19)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(m#0) && Seq#Length(m#0) <= Seq#Length(ms#0);
    ##s#1 := Seq#Take(ms#0, Seq#Length(m#0));
    assume $IsAlloc(##s#1, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(ms#0, Seq#Length(m#0)));
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Take(ms#0, Seq#Length(m#0)));
    assume true;
    assume true;
    assume true;
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LS($LZ)), Seq#Take(ms#0, Seq#Length(m#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](103,60)"} true;
    assume true;
    ##s#2 := ms#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(ms#0);
    assume $IsAllocBox($Box(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0)), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(ms#0) && Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0));
    prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(ms#0))): Seq;
    defass#prefix#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](104,79)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##s#0_0 := m#0;
    assume $IsAlloc(##s#0_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume false;
    goto anon8;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##s#0_1_0 := m#0;
    assume $IsAlloc(##s#0_1_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0);
    assume defass#prefix#0;
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume defass#prefix#0;
    assume true;
    assume Seq#Length(prefix#0) <= Seq#Length(m#0);
    assume defass#prefix#0;
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(ms#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(ms#0);
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(m#0);
    goto anon5;

  anon12_Else:
    assume {:partition} !Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0)));
    goto anon5;

  anon5:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0)));
    assume defass#prefix#0;
    assume {:subsumption 0} 0 <= Seq#Length(prefix#0) && Seq#Length(prefix#0) <= Seq#Length(m#0);
    goto anon7;

  anon13_Else:
    assume {:partition} !(Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0))));
    goto anon7;

  anon7:
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon11_Else:
    goto anon8;

  anon8:
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), m#0) ==> Seq#Equal(prefix#0, Seq#Take(ms#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(ms#0, Seq#Length(prefix#0)), Seq#Take(m#0, Seq#Length(prefix#0))) && Seq#Equal(Seq#Take(m#0, Seq#Length(prefix#0)), m#0);
    return;
}



function Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly: LayerType, s#0: Seq) : DatatypeType
uses {
axiom 7 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (7 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0)) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0))): Seq), s#0)) && $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))));
axiom 7 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || (7 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#0 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#0)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) && (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#0))) && (var valueOrError1#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#0))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#0 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#0) else (var prefix#0 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#0)): Seq; (var valueOrError1#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#0))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0) else (var restParts#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#0)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#0)), restParts#0)))))))))));
axiom 7 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || (7 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#1 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#1)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) && (var prefix#1 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#1))) && (var valueOrError1#1 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#1))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#1 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#1) else (var prefix#1 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#1)): Seq); (var valueOrError1#1 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#1))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1) else (var restParts#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#1)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#1)), restParts#1)))))))))));
}

function Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(AsFuelBottom($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) == Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LZ, s#0));

function Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#requires($ly, s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#requires($ly, s#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (maybeParts#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var prefix#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##s#1: Seq;
  var restParts#Z#0: Seq;
  var let#3#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](116,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume $IsAllocBox($Box(maybeParts#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybeParts#0);
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0);
    ##xs#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq;
    assume $IsAlloc(##xs#0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq);
    assume Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);
    goto anon5;

  anon15_Else:
    assume Wrappers.Option.Some_q(maybeParts#0) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), maybeParts#0)): Seq), s#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Lit(#Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))));
    assume true;
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon16_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0);
    assume let#0#0#0 == Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#Z#0);
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon17_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    havoc prefix#Z#0;
    assume $Is(prefix#Z#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#Z#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    assume prefix#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume 0 <= Seq#Length(prefix#Z#0) && Seq#Length(prefix#Z#0) <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(prefix#Z#0));
    assume $IsAlloc(##s#1, TSeq(TBitvector(16)), $Heap);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#1) == Seq#Length(s#0);
    assume Seq#Length(##s#1) < Seq#Length(s#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume let#2#0#0 == Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#Z#0)));
    assume $Is(let#2#0#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError1#Z#0);
    assume Wrappers.Option.None_q(valueOrError1#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon18_Else:
    assume {:partition} !Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    havoc restParts#Z#0;
    assume $Is(restParts#Z#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(restParts#Z#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError1#Z#0);
    assume Wrappers.Option.Some_q(valueOrError1#Z#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume restParts#Z#0 == let#3#0#0;
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#Z#0)), restParts#Z#0)));
    assume true;
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
    goto anon13;

  anon13:
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0) == maybeParts#0;
    return;
}



procedure {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (correctness)"} Impl$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns (defass#maybeParts#0: bool, maybeParts#0: DatatypeType where defass#maybeParts#0 ==> $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap), $_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeParts#0) && $IsA#Wrappers.Option(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8498"} $_reverifyPost ==> Wrappers.Option#Equal(maybeParts#0, Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (correctness)"} Impl$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (defass#maybeParts#0: bool, maybeParts#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var result#0: Seq where $Is(result#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(result#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var rest#0: Seq where $Is(rest#0, TSeq(TBitvector(16))) && $IsAlloc(rest#0, TSeq(TBitvector(16)), $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#maybeParts#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;
  var ##s#6: Seq;
  var $decr$loop#00: int;
  var defass#prefix#2: bool;
  var prefix#2: Seq where defass#prefix#2 ==> $Is(prefix#2, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(prefix#2, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var defass#valueOrError0#2: bool;
  var valueOrError0#2: DatatypeType where defass#valueOrError0#2 ==> $Is(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](131,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    push;
    assume true;
    assume true;
    maybeParts#0 := Lit(#Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))));
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](133,21)"} true;
    assume defass#maybeParts#0;
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    pop;
    return;

  anon19_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    assume true;
    assume true;
    result#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](135,55)"} true;
    assume true;
    assume true;
    rest#0 := s#0;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](136,17)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#maybeParts#0 := defass#maybeParts#0;
    $decr_init$loop#00 := Seq#Length(rest#0) - 0;
    havoc $w$loop#0;
    goto anon20_LoopHead;

  anon20_LoopHead:
    assume $w$loop#0 ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume $w$loop#0 ==> (Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0)) <==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), rest#0)));
    assume $w$loop#0 ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0));
    assume $w$loop#0 ==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true);
    assume $w$loop#0 ==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Seq#Equal($Unbox(Wrappers.Option.value(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0))): Seq, Seq#Append(result#0, $Unbox(Wrappers.Option.value(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), rest#0))): Seq));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#maybeParts#0 ==> defass#maybeParts#0;
    assume Seq#Length(rest#0) - 0 <= $decr_init$loop#00;
    goto anon20_LoopDone, anon20_LoopBody;

  anon20_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](137,4): after some loop iterations"} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} !$w$loop#0;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    ##s#3 := rest#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) <==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0));
    ##s#4 := s#0;
    assume $IsAlloc(##s#4, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Lit(true);
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    ##s#6 := rest#0;
    assume $IsAlloc(##s#6, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0);
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0));
    goto anon9;

  anon23_Else:
    assume {:partition} !Lit(true);
    goto anon9;

  anon22_Else:
    assume {:partition} !Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    goto anon9;

  anon9:
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0));
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> true && Seq#Equal($Unbox(Wrappers.Option.value(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq, Seq#Append(result#0, $Unbox(Wrappers.Option.value(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0))): Seq));
    assume true;
    assume false;
    goto anon10;

  anon21_Else:
    assume {:partition} $w$loop#0;
    goto anon10;

  anon10:
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} 0 >= Seq#Length(rest#0);
    goto anon17;

  anon24_Else:
    assume {:partition} Seq#Length(rest#0) > 0;
    $decr$loop#00 := Seq#Length(rest#0) - 0;
    push;
    havoc valueOrError0#2 /* where defass#valueOrError0#2 ==> $Is(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(valueOrError0#2, Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap) */;
    assume true;
    ##s#7 := rest#0;
    assume $IsAlloc(##s#7, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(rest#0);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(rest#0);
    valueOrError0#2 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(rest#0);
    defass#valueOrError0#2 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](145,73)"} true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    push;
    assume true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#2);
    assume Wrappers.Option.None_q(valueOrError0#2);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    maybeParts#0 := Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#2);
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](145,73)"} true;
    assume defass#maybeParts#0;
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    pop;
    pop;
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume true;
    assume defass#valueOrError0#2;
    assume $IsAllocBox($Box(valueOrError0#2), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#2);
    assume Wrappers.Option.Some_q(valueOrError0#2);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    assume Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2);
    prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#2)): Seq;
    defass#prefix#2 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](145,73)"} true;
    assume true;
    assume defass#prefix#2;
    assume true;
    result#0 := Seq#Append(result#0, Seq#Build(Seq#Empty(): Seq, $Box(prefix#2)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](146,33)"} true;
    assume true;
    assume defass#prefix#2;
    assume 0 <= Seq#Length(prefix#2) && Seq#Length(prefix#2) <= Seq#Length(rest#0);
    assume true;
    rest#0 := Seq#Drop(rest#0, Seq#Length(prefix#2));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](147,30)"} true;
    pop;
    assume 0 <= $decr$loop#00 || Seq#Length(rest#0) - 0 == $decr$loop#00;
    assume Seq#Length(rest#0) - 0 < $decr$loop#00;
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0) && ((Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) <==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), rest#0))) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) ==> Lit(true) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(rest#0)));
    goto anon20_LoopHead;

  anon20_LoopDone:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume true;
    assume Seq#Equal(Seq#Append(result#0, Seq#Empty(): Seq), result#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](149,32)"} true;
    assume true;
    assume true;
    maybeParts#0 := #Wrappers.Option.Some($Box(result#0));
    defass#maybeParts#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](150,23)"} true;
    assume defass#maybeParts#0;
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    return;
}



function Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq) : Seq
uses {
axiom 11 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (11 < $FunctionContextHeight && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0)), s#0) && $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
axiom 11 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || (11 < $FunctionContextHeight && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq);
axiom 11 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) || (11 < $FunctionContextHeight && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))) && Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) == Lit($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0))))): Seq));
}

function Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0: Seq) : bool;

function Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq() : Ty
uses {
axiom Tag(Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) == Tagclass.Utf16EncodingForm.WellFormedCodeUnitSeq && TagFamily(Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) == tytagFamily$WellFormedCodeUnitSeq;
}

const unique Tagclass.Utf16EncodingForm.WellFormedCodeUnitSeq: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) } $IsBox(bx, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()));

function Utf16EncodingForm.__default.PartitionCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequence#requires(s#0) } $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> (Utf16EncodingForm.__default.PartitionCodeUnitSequence#requires(s#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) returns (parts#0: Seq where $Is(parts#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0: Seq) returns (parts#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.PartitionCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](157,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#0);
    assume Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), parts#0), s#0);
    assume false;
    return;

  anon4_Else:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume $IsAllocBox($Box(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq;
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0));
    assume $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) == parts#0;
    return;
}



procedure {:verboseName "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call precondtion)"} CallPre$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0)) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
  free ensures {:id "id8535"} Wrappers.Option#Equal(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0)) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
  free ensures {:id "id8536"} $_reverifyPost ==> Wrappers.Option#Equal(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var m##0: Seq;
  var s##0: Seq;
  var ##s#0_0_0: Seq;
  var ##s#0_0_1: Seq;
  var ##s#0_1_0: Seq;
  var ##s#1_1_0: Seq;
  var ##s#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](169,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#m0#0: Seq :: $Is($ih#m0#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Lit(true) && Seq#Rank($ih#m0#0) < Seq#Rank(m#0) ==> Wrappers.Option#Equal(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), $ih#m0#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box($ih#m0#0))))));
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    assume true;
    s##0 := Lit(Seq#Empty(): Seq);
    call CallPre$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##0, s##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##0, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](170,77)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume true;
    assume false;
    goto anon4;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    push;
    pop;
    ##s#0_1_0 := Seq#Append(m#0, Seq#Empty(): Seq);
    assume $IsAlloc(##s#0_1_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume true;
    assume false;
    goto anon4;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##s#0_0_0 := Seq#Append(m#0, Seq#Empty(): Seq);
    assume $IsAlloc(##s#0_0_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Seq#Append(m#0, Seq#Empty(): Seq));
    push;
    push;
    assume true;
    assume Seq#Equal(Seq#Append(m#0, Seq#Empty(): Seq), m#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](174,26)"} true;
    pop;
    pop;
    ##s#0_0_1 := m#0;
    assume $IsAlloc(##s#0_0_1, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(m#0);
    assume true;
    assume false;
    goto anon4;

  anon11_Else:
    goto anon4;

  anon4:
    assume Wrappers.Option#Equal(#Wrappers.Option.Some($Box(m#0)), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(m#0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##s#1_0 := m#0;
    assume $IsAlloc(##s#1_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##s#1_1_0 := m#0;
    assume $IsAlloc(##s#1_1_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(m#0);
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume true;
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(m#0)), Seq#Empty(): Seq), Seq#Build(Seq#Empty(): Seq, $Box(m#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](180,30)"} true;
    assume true;
    assume true;
    assume false;
    goto anon8;

  anon14_Else:
    goto anon8;

  anon8:
    assume Wrappers.Option#Equal(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0), #Wrappers.Option.Some($Box(Seq#Build(Seq#Empty(): Seq, $Box(m#0)))));
    return;
}



function Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0: Seq) : bool
uses {
axiom 9 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) || (9 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) <==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))));
axiom 9 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) || (9 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) <==> Lit(Wrappers.Option.Some_q(Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))))));
}

function Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#requires(s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#requires(s#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.IsWellFormedCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (b#0: bool);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call precondtion)"} CallPre$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0);
  free ensures {:id "id8546"} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(m#0) && Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), m#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0);
  free ensures {:id "id8547"} $_reverifyPost ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(m#0) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(m#0) || Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), m#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](198,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    call CallPre$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](199,57)"} true;
    return;
}



procedure {:verboseName "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call precondtion)"} CallPre$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id8551"} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(m#0, s#0)) && Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(m#0, s#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq where $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap), s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 11 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0));
  free ensures {:id "id8552"} $_reverifyPost ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(m#0, s#0)) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(m#0, s#0)) || Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(m#0, s#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq, s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m##0: Seq;
  var m##1: Seq;
  var s##0: Seq;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](208,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    m##0 := m#0;
    call CallPre$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](209,57)"} true;
    assume true;
    m##1 := m#0;
    assume true;
    s##0 := s#0;
    call CallPre$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##1, s##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m##1, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](210,76)"} true;
    ##s#1 := Seq#Append(m#0, s#0);
    assume $IsAlloc(##s#1, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Append(m#0, s#0));
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Append(m#0, s#0));
    assume true;
    assume Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(m#0, s#0)));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](211,56)"} true;
    return;
}



procedure {:verboseName "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
  free requires 12 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call precondtion)"} CallPre$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));



procedure {:verboseName "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap));
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(TBitvector(16), ms#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0));
  free ensures {:id "id8559"} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0)) && Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq where $Is(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap)) returns ($_reverifyPost: bool);
  free requires 12 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Seq.__default.Flatten#canCall(TBitvector(16), ms#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0));
  free ensures {:id "id8560"} $_reverifyPost ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0)) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0)) || Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq.__default.Flatten(TBitvector(16), $LS($LS($LZ)), ms#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##xs#0_0: Seq;
  var ##s#0_0: Seq;
  var head#1_0: Seq where $Is(head#1_0, TSeq(TBitvector(16))) && $IsAlloc(head#1_0, TSeq(TBitvector(16)), $Heap);
  var tail#1_0: Seq where $Is(tail#1_0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(tail#1_0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ms##1_0: Seq;
  var flatTail#1_0: Seq where $Is(flatTail#1_0, TSeq(TBitvector(16))) && $IsAlloc(flatTail#1_0, TSeq(TBitvector(16)), $Heap);
  var ##xs#1_0: Seq;
  var m##1_0: Seq;
  var s##1_0: Seq;
  var ##s#1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences", " | ", ms#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](219,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#ms0#0: Seq :: $Is($ih#ms0#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && Lit(true) && Seq#Rank($ih#ms0#0) < Seq#Rank(ms#0) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(16), $LS($LZ), $ih#ms0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(ms#0) == LitInt(0);
    ##xs#0_0 := ms#0;
    assume $IsAlloc(##xs#0_0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), ms#0);
    ##s#0_0 := Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0);
    assume $IsAlloc(##s#0_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0));
    assume Seq.__default.Flatten#canCall(TBitvector(16), ms#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0));
    assume true;
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](221,58)"} true;
    return;

  anon3_Else:
    assume {:partition} Seq#Length(ms#0) != LitInt(0);
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ms#0);
    assume true;
    head#1_0 := $Unbox(Seq#Index(ms#0, LitInt(0))): Seq;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](224,23)"} true;
    assume true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(ms#0);
    assume true;
    tail#1_0 := Seq#Drop(ms#0, LitInt(1));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](225,25)"} true;
    assume true;
    ms##1_0 := tail#1_0;
    assume Seq#Rank(ms##1_0) < Seq#Rank(ms#0);
    call CallPre$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##1_0);
    call CallPost$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](226,61)"} true;
    assume true;
    ##xs#1_0 := tail#1_0;
    assume $IsAlloc(##xs#1_0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), tail#1_0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), tail#1_0);
    flatTail#1_0 := Seq.__default.Flatten(TBitvector(16), $LS($LZ), tail#1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](227,39)"} true;
    assume true;
    assume $Is(head#1_0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq());
    m##1_0 := head#1_0;
    assume true;
    assume $Is(flatTail#1_0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    s##1_0 := flatTail#1_0;
    call CallPre$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##1_0, s##1_0);
    call CallPost$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##1_0, s##1_0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](228,70)"} true;
    ##s#1_0 := Seq#Append(head#1_0, flatTail#1_0);
    assume $IsAlloc(##s#1_0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0));
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(head#1_0, flatTail#1_0));
    assume true;
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(head#1_0, flatTail#1_0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](229,58)"} true;
    return;
}



procedure {:verboseName "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call precondtion)"} CallPre$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));



procedure {:verboseName "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id8576"} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(s#0, t#0)) && Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap), t#0: Seq where $Is(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(t#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap)) returns ($_reverifyPost: bool);
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0));
  free ensures {:id "id8577"} $_reverifyPost ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq#Append(s#0, t#0)) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq#Append(s#0, t#0)) || Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), Seq#Append(s#0, t#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (correctness)"} Impl$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq, t#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var partsS#0: Seq where $Is(partsS#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsS#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#1: Seq;
  var partsT#0: Seq where $Is(partsT#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsT#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var ##s#2: Seq;
  var partsST#0: Seq where $Is(partsST#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(partsST#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var xs##0: Seq;
  var ys##0: Seq;
  var ##xs#0: Seq;
  var part#0: Seq;
  var ##s#3: Seq;
  var ms##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](238,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    partsS#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](239,46)"} true;
    assume true;
    ##s#2 := t#0;
    assume $IsAlloc(##s#2, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(t#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(t#0);
    partsT#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(t#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](240,46)"} true;
    assume true;
    assume true;
    partsST#0 := Seq#Append(partsS#0, partsT#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](241,34)"} true;
    assume true;
    xs##0 := partsS#0;
    assume true;
    ys##0 := partsT#0;
    free call CallPre$$Seq.__default.LemmaFlattenConcat(TBitvector(16), xs##0, ys##0);
    call CallPost$$Seq.__default.LemmaFlattenConcat(TBitvector(16), xs##0, ys##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](242,42)"} true;
    ##xs#0 := partsST#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), partsST#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), partsST#0);
    assume true;
    assume Seq#Equal(Seq#Append(s#0, t#0), Seq.__default.Flatten(TBitvector(16), $LS($LZ), partsST#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](244,40)"} true;
    havoc part#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} $Is(part#0, TSeq(TBitvector(16))) && $IsAlloc(part#0, TSeq(TBitvector(16)), $Heap);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Seq#Contains(partsST#0, $Box(part#0));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(part#0) > 0;
    ##s#3 := part#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(part#0);
    goto anon4;

  anon7_Else:
    assume {:partition} 0 >= Seq#Length(part#0);
    goto anon4;

  anon6_Else:
    assume {:partition} !Seq#Contains(partsST#0, $Box(part#0));
    goto anon4;

  anon5_Else:
    assume {:partition} !($Is(part#0, TSeq(TBitvector(16))) && $IsAlloc(part#0, TSeq(TBitvector(16)), $Heap));
    goto anon4;

  anon4:
    assume (forall part#1: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(TBitvector(16))) ==> Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(part#1));
    assume true;
    assume (forall part#1: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1) } { Seq#Length(part#1) } { Seq#Contains(partsST#0, $Box(part#1)) } $Is(part#1, TSeq(TBitvector(16))) && Seq#Contains(partsST#0, $Box(part#1)) ==> Seq#Length(part#1) > 0 && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), part#1));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](247,55)"} true;
    assume true;
    ms##0 := partsST#0;
    call CallPre$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](248,62)"} true;
    return;
}



function Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) : Seq
uses {
axiom 13 <= $FunctionContextHeight ==> (forall vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (13 < $FunctionContextHeight && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> $Is(Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()));
axiom 13 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || (13 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#0 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(16), ms#0)) && Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#0 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#0)));
axiom 13 <= $FunctionContextHeight ==> (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || (13 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(16), ms#1)) && Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#1)));
}

function Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0: Seq) : bool;

function Utf16EncodingForm.__default.EncodeScalarSequence#requires(Seq) : bool;

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence#requires(vs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) ==> (Utf16EncodingForm.__default.EncodeScalarSequence#requires(vs#0) <==> true));

function Utf16EncodingForm.__default.EncodeScalarValue#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) == $Box(Utf16EncodingForm.__default.EncodeScalarValue($Unbox($fh$0x#0): bv24)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0) <==> Utf16EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$0x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue($fh$0x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.EncodeScalarValue($fh$0x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "Utf16EncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) returns (s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ms#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ms##0: Seq;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](254,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    assume false;
    return;

  anon4_Else:
    havoc ms#Z#0;
    assume $Is(ms#Z#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(ms#Z#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume 7 != $FunctionContextHeight;
    ##f#0 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0 := vs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): bv24 } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): bv24 } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume let#0#0#0 == Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $Is(let#0#0#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume ms#Z#0 == let#0#0#0;
    assume true;
    ms##0 := ms#Z#0;
    call CallPre$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](257,56)"} true;
    ##xs#1 := ms#Z#0;
    assume $IsAlloc(##xs#1, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), ms#Z#0);
    assume $Is(Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#Z#0), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    assume Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#Z#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), ms#Z#0);
    assume $Is(Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    assume Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == s#0;
    assume b$reqreads#0;
    return;
}



procedure {:verboseName "Utf16EncodingForm.EncodeScalarSequence (correctness)"} Impl$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (defass#s#0: bool, s#0: Seq where defass#s#0 ==> $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap), $_reverifyPost: bool);
  free requires 14 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
  free ensures {:id "id8597"} $_reverifyPost ==> Seq#Equal(s#0, Utf16EncodingForm.__default.EncodeScalarSequence(vs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.EncodeScalarSequence (correctness)"} Impl$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (defass#s#0: bool, s#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var unflattened#0: Seq where $Is(unflattened#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(unflattened#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#s#0: bool;
  var $w$loop#0: bool;
  var ##f#1: HandleType;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var defass#next#0: bool;
  var next#0: Seq where defass#next#0 ==> $Is(next#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && $IsAlloc(next#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap);
  var ##v#0: bv24;
  var m##0: Seq;
  var s##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](260,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    s#0 := Lit(Seq#Empty(): Seq);
    defass#s#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](265,11)"} true;
    assume true;
    assume true;
    unflattened#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](266,66)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(vs#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#hi;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#s#0 := defass#s#0;
    havoc $w$loop#0;
    goto anon7_LoopHead;

  anon7_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume $w$loop#0 ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume $w$loop#0 ==> Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)));
    assume $w$loop#0 ==> Seq.__default.Flatten#canCall(TBitvector(16), unflattened#0);
    assume $w$loop#0 ==> Seq#Equal(s#0, Seq.__default.Flatten(TBitvector(16), $LS($LS($LZ)), unflattened#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#s#0 ==> defass#s#0;
    assume true;
    goto anon7_LoopDone, anon7_LoopBody;

  anon7_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](267,4): after some loop iterations"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} !$w$loop#0;
    assume 7 != $FunctionContextHeight;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(vs#0);
    ##f#1 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#2 := Seq#Drop(vs#0, i#2);
    assume $IsAlloc(##xs#2, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##xs#2, i#3)): bv24 } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#2) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#1, Seq#Index(##xs#2, i#3)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2));
    assume Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)));
    assume defass#s#0;
    ##xs#3 := unflattened#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), unflattened#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), unflattened#0);
    assume Seq#Equal(s#0, Seq.__default.Flatten(TBitvector(16), $LS($LZ), unflattened#0));
    assume false;
    goto anon3;

  anon8_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} i#2 == i#2#lo;
    goto anon6;

  anon9_Else:
    assume {:partition} i#2 != i#2#lo;
    i#2 := i#2 - 1;
    assume true;
    assume 0 <= i#2 && i#2 < Seq#Length(vs#0);
    ##v#0 := $Unbox(Seq#Index(vs#0, i#2)): bv24;
    assume $IsAlloc(##v#0, Tclass.Unicode.ScalarValue(), $Heap);
    assume Utf16EncodingForm.__default.EncodeScalarValue#canCall($Unbox(Seq#Index(vs#0, i#2)): bv24);
    assume Utf16EncodingForm.__default.EncodeScalarValue#canCall($Unbox(Seq#Index(vs#0, i#2)): bv24);
    next#0 := Utf16EncodingForm.__default.EncodeScalarValue($Unbox(Seq#Index(vs#0, i#2)): bv24);
    defass#next#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](271,72)"} true;
    assume true;
    assume defass#next#0;
    assume true;
    unflattened#0 := Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(next#0)), unflattened#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](272,41)"} true;
    assume defass#next#0;
    assume true;
    m##0 := next#0;
    assume defass#s#0;
    assume true;
    s##0 := s#0;
    call CallPre$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##0, s##0);
    call CallPost$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m##0, s##0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](273,63)"} true;
    assume true;
    assume defass#next#0;
    assume defass#s#0;
    assume true;
    assume $Is(Seq#Append(next#0, s#0), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    s#0 := Seq#Append(next#0, s#0);
    defass#s#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](274,19)"} true;
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2)) && (Seq#Equal(unflattened#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Seq#Drop(vs#0, i#2))) ==> Seq.__default.Flatten#canCall(TBitvector(16), unflattened#0));
    goto anon7_LoopHead;

  anon7_LoopDone:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume defass#s#0;
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    return;
}



function Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq) : Seq
uses {
axiom 14 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || (14 < $FunctionContextHeight && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Seq#Equal(Utf16EncodingForm.__default.EncodeScalarSequence(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0)), s#0) && $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue())));
axiom 14 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || (14 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#0 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0); vs#0)));
axiom 14 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || (14 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#1 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#1)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#1 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#1 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#1); vs#1)));
}

function Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0: Seq) : bool;

function Utf16EncodingForm.__default.DecodeCodeUnitSequence#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> (Utf16EncodingForm.__default.DecodeCodeUnitSequence#requires(s#0) <==> true));

function Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) } Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) == $Box(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$0x#0): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) } Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0) <==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$0x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$0x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$0x#0) == $Unbox(Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$0x#0))): bv24);

procedure {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) returns (vs#2: Seq where $Is(vs#2, TSeq(Tclass.Unicode.ScalarValue())));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequence (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0: Seq) returns (vs#2: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##vs#0: Seq;
  var parts#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##s#0: Seq;
  var vs#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#0_0_0: HandleType;
  var ##xs#0_0_0: Seq;
  var ##xs#0_0_1: Seq;
  var ##vs#0_0_0: Seq;
  var ##xs#0_1_0: Seq;
  var ##f#0_1_0: HandleType;
  var ##xs#0_1_1: Seq;
  var ##f#0_1_1: HandleType;
  var ##xs#0_1_2: Seq;
  var ##xs#0_1_3: Seq;
  var ##xs#0_2_0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeCodeUnitSequence", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](281,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue()));
    ##vs#0 := vs#2;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#2);
    assume Seq#Equal(Utf16EncodingForm.__default.EncodeScalarSequence(vs#2), s#0);
    assume false;
    return;

  anon9_Else:
    havoc parts#Z#0;
    assume $Is(parts#Z#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(parts#Z#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume let#0#0#0 == Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0);
    assume $Is(let#0#0#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));
    assume parts#Z#0 == let#0#0#0;
    havoc vs#Z#0;
    assume $Is(vs#Z#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#Z#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume 8 != $FunctionContextHeight;
    ##f#0 := Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue()), $Heap);
    ##xs#0 := parts#Z#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume let#1#0#0 == Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.Unicode.ScalarValue()));
    assume vs#Z#0 == let#1#0#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume true;
    ##xs#0_2_0 := parts#Z#0;
    assume $IsAlloc(##xs#0_2_0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#Z#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#Z#0);
    assume true;
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##xs#0_1_0 := parts#Z#0;
    assume $IsAlloc(##xs#0_1_0, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#Z#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#Z#0);
    assume 7 != $FunctionContextHeight;
    ##f#0_1_0 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_1_0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_1_1 := vs#Z#0;
    assume $IsAlloc(##xs#0_1_1, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_1_0: int :: { $Unbox(Seq#Index(##xs#0_1_1, i#0_1_0)): bv24 } LitInt(0) <= i#0_1_0 && i#0_1_0 < Seq#Length(##xs#0_1_1) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_0)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_1_1: int, o#0_1_0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_1))[$Box(o#0_1_0)] } $Is(o#0_1_0, Tclass._System.object?()) && LitInt(0) <= i#0_1_1 && i#0_1_1 < Seq#Length(##xs#0_1_1) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_0, Seq#Index(##xs#0_1_1, i#0_1_1))[$Box(o#0_1_0)] && $Box($o) == $Box(o#0_1_0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume Seq#Equal(parts#Z#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](289,54)"} true;
    assume 7 != $FunctionContextHeight;
    ##f#0_1_1 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_1_1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_1_2 := vs#Z#0;
    assume $IsAlloc(##xs#0_1_2, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_1_2: int :: { $Unbox(Seq#Index(##xs#0_1_2, i#0_1_2)): bv24 } LitInt(0) <= i#0_1_2 && i#0_1_2 < Seq#Length(##xs#0_1_2) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_2)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_1_3: int, o#0_1_1: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_3))[$Box(o#0_1_1)] } $Is(o#0_1_1, Tclass._System.object?()) && LitInt(0) <= i#0_1_3 && i#0_1_3 < Seq#Length(##xs#0_1_2) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_1_1, Seq#Index(##xs#0_1_2, i#0_1_3))[$Box(o#0_1_1)] && $Box($o) == $Box(o#0_1_1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    ##xs#0_1_3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume $IsAlloc(##xs#0_1_3, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0) && Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume true;
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume 7 != $FunctionContextHeight;
    ##f#0_0_0 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#0_0_0, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#0_0_0 := vs#Z#0;
    assume $IsAlloc(##xs#0_0_0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#0_0_0: int :: { $Unbox(Seq#Index(##xs#0_0_0, i#0_0_0)): bv24 } LitInt(0) <= i#0_0_0 && i#0_0_0 < Seq#Length(##xs#0_0_0) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_0)));
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#0_0_1: int, o#0_0_0: ref :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_1))[$Box(o#0_0_0)] } $Is(o#0_0_0, Tclass._System.object?()) && LitInt(0) <= i#0_0_1 && i#0_0_1 < Seq#Length(##xs#0_0_0) && Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#0_0_0, Seq#Index(##xs#0_0_0, i#0_0_1))[$Box(o#0_0_0)] && $Box($o) == $Box(o#0_0_0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    ##xs#0_0_1 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0);
    assume $IsAlloc(##xs#0_0_1, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0) && Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#Z#0));
    ##vs#0_0_0 := vs#Z#0;
    assume $IsAlloc(##vs#0_0_0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#Z#0);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#Z#0);
    assume true;
    assume false;
    goto anon8;

  anon13_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(s#0, Utf16EncodingForm.__default.EncodeScalarSequence(vs#Z#0));
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == vs#Z#0;
    assume true;
    assume $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue()));
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == vs#2;
    assume b$reqreads#0;
    return;
}



function Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) : DatatypeType
uses {
axiom 15 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || (15 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))): Seq, Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0))) && (!Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))) && $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));
axiom 15 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || (15 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0)) && Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) then #Wrappers.Option.Some($Box(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0))) else #Wrappers.Option.None()));
axiom 15 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) } Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(Lit(s#0)) || (15 < $FunctionContextHeight && $Is(s#0, TSeq(TBitvector(16)))) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) && (Lit(Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0))) ==> Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0))) && Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) then #Wrappers.Option.Some($Box(Lit(Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0))))) else #Wrappers.Option.None()));
}

function Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0: Seq) : bool;

function Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(s#0) } $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#requires(s#0) <==> true));

procedure {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16)))) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));
  free requires 15 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellformed$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (maybeVs#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](300,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume Wrappers.Option.Some_q(maybeVs#0);
    assume $IsAllocBox($Box(maybeVs#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(maybeVs#0);
    assume Wrappers.Option.Some_q(maybeVs#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0);
    assume $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0));
    goto anon5;

  anon14_Else:
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(maybeVs#0) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), maybeVs#0)): Seq, Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0));
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    assume !Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume true;
    assume Wrappers.Option.None_q(maybeVs#0);
    goto anon8;

  anon15_Else:
    assume !Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(maybeVs#0);
    goto anon8;

  anon8:
    assume false;
    return;

  anon13_Else:
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    ##s#4 := s#0;
    assume $IsAlloc(##s#4, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == #Wrappers.Option.Some($Box(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0)));
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0);
    assume $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon12;

  anon16_Else:
    assume {:partition} !Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0);
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    goto anon12;

  anon12:
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == maybeVs#0;
    return;
}



procedure {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (correctness)"} Impl$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns (defass#maybeVs#0: bool, maybeVs#0: DatatypeType where defass#maybeVs#0 ==> $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap), $_reverifyPost: bool);
  free requires 16 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeVs#0) && $IsA#Wrappers.Option(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8658"} $_reverifyPost ==> Wrappers.Option#Equal(maybeVs#0, Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (correctness)"} Impl$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (defass#maybeVs#0: bool, maybeVs#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap);
  var ##s#5: Seq;
  var parts#0: Seq where $Is(parts#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())) && $IsAlloc(parts#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
  var vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##vs#0: Seq;
  var ##xs#3: Seq;
  var ##f#2: HandleType;
  var ##xs#4: Seq;
  var ##f#3: HandleType;
  var ##xs#5: Seq;
  var ##xs#6: Seq;
  var ##xs#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](311,12): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#5 := s#0;
    assume $IsAlloc(##s#5, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    assume Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
    maybeParts#0 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](312,57)"} true;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Option.None_q(maybeParts#0);
    push;
    assume true;
    assume true;
    maybeVs#0 := Lit(#Wrappers.Option.None());
    defass#maybeVs#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](314,17)"} true;
    assume defass#maybeVs#0;
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
    pop;
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Option.None_q(maybeParts#0);
    assume true;
    assume Wrappers.Option.Some_q(maybeParts#0);
    assume true;
    parts#0 := $Unbox(Wrappers.Option.value(maybeParts#0)): Seq;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](316,33)"} true;
    assume true;
    assume 8 != $FunctionContextHeight;
    ##f#0 := Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle();
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue()), $Heap);
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): Seq } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    assume Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    vs#0 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#0);
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](317,72)"} true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume true;
    push;
    pop;
    ##xs#7 := parts#0;
    assume $IsAlloc(##xs#7, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#0);
    assume true;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##xs#3 := parts#0;
    assume $IsAlloc(##xs#3, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#0);
    assume Seq.__default.Flatten#canCall(TBitvector(16), parts#0);
    push;
    push;
    assume 7 != $FunctionContextHeight;
    ##f#2 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#2, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#4 := vs#0;
    assume $IsAlloc(##xs#4, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#4, i#2)): bv24 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#4) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#2, Seq#Index(##xs#4, i#2)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume Seq#Equal(parts#0, Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](321,54)"} true;
    pop;
    pop;
    assume 7 != $FunctionContextHeight;
    ##f#3 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#3, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#5 := vs#0;
    assume $IsAlloc(##xs#5, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##xs#5, i#3)): bv24 } LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#5) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#3, Seq#Index(##xs#5, i#3)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    ##xs#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $IsAlloc(##xs#6, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume true;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume 7 != $FunctionContextHeight;
    ##f#1 := Utf16EncodingForm.__default.EncodeScalarValue#Handle();
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), $Heap);
    ##xs#1 := vs#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume {:subsumption 0} (forall i#1: int :: { $Unbox(Seq#Index(##xs#1, i#1)): bv24 } LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#1) ==> Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, ##f#1, Seq#Index(##xs#1, i#1)));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    ##xs#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0);
    assume $IsAlloc(##xs#2, TSeq(TSeq(TBitvector(16))), $Heap);
    assume Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    assume Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && Seq.__default.Flatten#canCall(TBitvector(16), Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0));
    push;
    pop;
    ##vs#0 := vs#0;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
    assume true;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume Seq#Equal(s#0, Utf16EncodingForm.__default.EncodeScalarSequence(vs#0));
    assume true;
    assume true;
    maybeVs#0 := #Wrappers.Option.Some($Box(vs#0));
    defass#maybeVs#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeEncodingForm.dfy[Utf16EncodingForm](325,19)"} true;
    assume defass#maybeVs#0;
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
    return;
}



procedure {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (call precondtion)"} CallPre$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap));



procedure {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns (maybeParts#0: DatatypeType where $Is(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))) && $IsAlloc(maybeParts#0, Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeParts#0) && $IsA#Wrappers.Option(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8679"} Wrappers.Option#Equal(maybeParts#0, Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LS($LZ)), s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Utf16EncodingForm.EncodeScalarSequence (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  free requires 14 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.EncodeScalarSequence (call precondtion)"} CallPre$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap));



procedure {:verboseName "Utf16EncodingForm.EncodeScalarSequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq where $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap)) returns (s#0: Seq where $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap));
  modifies $Heap;
  free ensures Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0);
  free ensures {:id "id8713"} Seq#Equal(s#0, Utf16EncodingForm.__default.EncodeScalarSequence(vs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (call precondtion)"} CallPre$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap));



procedure {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))) && $IsAlloc(s#0, TSeq(TBitvector(16)), $Heap)) returns (maybeVs#0: DatatypeType where $Is(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(maybeVs#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Option(maybeVs#0) && $IsA#Wrappers.Option(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0);
  free ensures {:id "id8741"} Wrappers.Option#Equal(maybeVs#0, Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Utf16EncodingForm.WellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.WellFormedCodeUnitSeq(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall s#0: Seq :: { $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) } $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) <==> $Is(s#0, TSeq(TBitvector(16))) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0));

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $h) } $IsAlloc(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $h) <==> $IsAlloc(s#0, TSeq(TBitvector(16)), $h));

procedure {:verboseName "Utf16EncodingForm.MinimalWellFormedCodeUnitSeq (well-formedness)"} CheckWellFormed$$Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(s#0: Seq where $Is(s#0, TSeq(TBitvector(16))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall s#0: Seq :: { $Is(s#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) } $Is(s#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) <==> $Is(s#0, TSeq(TBitvector(16))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), s#0));

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $h) } $IsAlloc(s#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $h) <==> $IsAlloc(s#0, TSeq(TBitvector(16)), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#68 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#68))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#70 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#70)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#102 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#102))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#104 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#104)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#106 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#106)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#102 := Wrappers.Option.value(this); v#102)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#104 := Lit(Wrappers.Option.value(Lit(this))); v#104)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#106 := Lit(Wrappers.Option.value(Lit(this))); v#106)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#68 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#68)) else (var e#68 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#70 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#70))) else (var e#70 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#102 := Wrappers.Result.value(this); s#102) else (var e#102 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#104 := Lit(Wrappers.Result.value(Lit(this))); s#104) else (var e#104 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#106 := Lit(Wrappers.Result.value(Lit(this))); s#106) else (var e#106 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#102 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#102)) else (var e#102 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#102)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#104 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#104))) else (var e#104 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#104)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#106 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#106))) else (var e#106 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#106)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#16: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#16, x#16)): bool } $IsBox(x#16, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#16, x#16)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#17: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#17, x#17)): bool } $IsBox(x#17, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#17, x#17)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#16: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#16, x#16)): bool } $IsBox(x#16, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#16, x#16)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#17: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#17, x#17)): bool } $IsBox(x#17, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#17, x#17)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#16: Box, y#16: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#16, x#16)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#16, y#16)): bool } $IsBox(x#16, Relations._default.AntiSymmetric$T) && $IsBox(y#16, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#16, y#16)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#16, x#16)): bool ==> x#16 == y#16)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#17: Box, y#17: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#17, x#17)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#17, y#17)): bool } $IsBox(x#17, Relations._default.AntiSymmetric$T) && $IsBox(y#17, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#17, y#17)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#17, x#17)): bool ==> x#17 == y#17)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#16: Box, y#16: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#16, x#16)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#16, y#16)): bool } $IsBox(x#16, Relations._default.Symmetric$T) && $IsBox(y#16, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#16, y#16)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#16, x#16)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#17: Box, y#17: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#17, x#17)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#17, y#17)): bool } $IsBox(x#17, Relations._default.Symmetric$T) && $IsBox(y#17, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#17, y#17)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#17, x#17)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#16: Box, y#16: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#16, x#16)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#16, y#16)): bool } $IsBox(x#16, Relations._default.Connected$T) && $IsBox(y#16, Relations._default.Connected$T) ==> x#16 != y#16 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#16, y#16)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#16, x#16)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#17: Box, y#17: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#17, x#17)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#17, y#17)): bool } $IsBox(x#17, Relations._default.Connected$T) && $IsBox(y#17, Relations._default.Connected$T) ==> x#17 != y#17 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#17, y#17)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#17, x#17)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#16: Box, y#16: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#16, x#16)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#16, y#16)): bool } $IsBox(x#16, Relations._default.StronglyConnected$T) && $IsBox(y#16, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#16, y#16)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#16, x#16)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#17: Box, y#17: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#17, x#17)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#17, y#17)): bool } $IsBox(x#17, Relations._default.StronglyConnected$T) && $IsBox(y#17, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#17, y#17)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#17, x#17)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#16: Box, y#16: Box, z#16: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#16, z#16)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#16, z#16)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#16, z#16)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#16, y#16)): bool } $IsBox(x#16, Relations._default.Transitive$T) && $IsBox(y#16, Relations._default.Transitive$T) && $IsBox(z#16, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#16, y#16)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#16, z#16)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#16, z#16)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#17: Box, y#17: Box, z#17: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#17, z#17)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#17, z#17)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#17, z#17)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#17, y#17)): bool } $IsBox(x#17, Relations._default.Transitive$T) && $IsBox(y#17, Relations._default.Transitive$T) && $IsBox(z#17, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#17, y#17)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#17, z#17)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#17, z#17)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#23: int, j#23: int :: { Seq#Index(a#0, j#23), Seq#Index(a#0, i#23) } LitInt(0) <= i#23 && i#23 < j#23 && j#23 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#23), Seq#Index(a#0, j#23))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#24: int, j#24: int :: { Seq#Index(a#0, j#24), Seq#Index(a#0, i#24) } LitInt(0) <= i#24 && i#24 < j#24 && j#24 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#24), Seq#Index(Lit(a#0), j#24))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#25: int, j#25: int :: { Seq#Index(a#0, j#25), Seq#Index(a#0, i#25) } LitInt(0) <= i#25 && i#25 < j#25 && j#25 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#25), Seq#Index(Lit(a#0), j#25))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#23: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#23)): bool } { s#0[x#23] } $IsBox(x#23, Relations._default.IsLeast$T) && s#0[x#23] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#23)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#24: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#24)): bool } { s#0[x#24] } $IsBox(x#24, Relations._default.IsLeast$T) && Lit(s#0)[x#24] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#24)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#25: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#25)): bool } { s#0[x#25] } $IsBox(x#25, Relations._default.IsLeast$T) && Lit(s#0)[x#25] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#25)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#23: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#23)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#23, min#0)): bool } { s#0[x#23] } $IsBox(x#23, Relations._default.IsMinimal$T) && s#0[x#23] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#23, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#23)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#24: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#24)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#24, min#0)): bool } { s#0[x#24] } $IsBox(x#24, Relations._default.IsMinimal$T) && Lit(s#0)[x#24] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#24, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#24)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#25: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#25)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#25, min#0)): bool } { s#0[x#25] } $IsBox(x#25, Relations._default.IsMinimal$T) && Lit(s#0)[x#25] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#25, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#25)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#23: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#23, max#0)): bool } { s#0[x#23] } $IsBox(x#23, Relations._default.IsGreatest$T) && s#0[x#23] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#23, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#24: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#24, max#0)): bool } { s#0[x#24] } $IsBox(x#24, Relations._default.IsGreatest$T) && Lit(s#0)[x#24] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#24, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#25: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#25, max#0)): bool } { s#0[x#25] } $IsBox(x#25, Relations._default.IsGreatest$T) && Lit(s#0)[x#25] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#25, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#23: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#23, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#23)): bool } { s#0[x#23] } $IsBox(x#23, Relations._default.IsMaximal$T) && s#0[x#23] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#23)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#23, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#24: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#24, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#24)): bool } { s#0[x#24] } $IsBox(x#24, Relations._default.IsMaximal$T) && Lit(s#0)[x#24] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#24)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#24, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#25: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#25, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#25)): bool } { s#0[x#25] } $IsBox(x#25, Relations._default.IsMaximal$T) && Lit(s#0)[x#25] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#25)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#25, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#18 := Div(Seq#Length(a#0), LitInt(2)); (var left#18, right#18 := Seq#Take(a#0, splitIndex#18), Seq#Drop(a#0, splitIndex#18); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#18, lessThanOrEq#0) && (var leftSorted#18 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#18, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#18, lessThanOrEq#0) && (var rightSorted#18 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#18, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#18, rightSorted#18, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#18 := Div(Seq#Length(a#0), LitInt(2)); (var left#18, right#18 := Seq#Take(a#0, splitIndex#18), Seq#Drop(a#0, splitIndex#18); (var leftSorted#18 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#18, lessThanOrEq#0); (var rightSorted#18 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#18, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#18, rightSorted#18, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#19 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#19, right#19 := Seq#Take(Lit(a#0), splitIndex#19), Seq#Drop(Lit(a#0), splitIndex#19); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#19, lessThanOrEq#0) && (var leftSorted#19 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#19, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#19, lessThanOrEq#0) && (var rightSorted#19 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#19, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#19, rightSorted#19, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#19 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#19, right#19 := Seq#Take(Lit(a#0), splitIndex#19), Seq#Drop(Lit(a#0), splitIndex#19); (var leftSorted#19 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#19, lessThanOrEq#0); (var rightSorted#19 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#19, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#19, rightSorted#19, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#20 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#20, right#20 := Seq#Take(Lit(a#0), splitIndex#20), Seq#Drop(Lit(a#0), splitIndex#20); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#20, Lit(lessThanOrEq#0)) && (var leftSorted#20 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#20, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#20, Lit(lessThanOrEq#0)) && (var rightSorted#20 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#20, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#20, rightSorted#20, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#20 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#20, right#20 := Seq#Take(Lit(a#0), splitIndex#20), Seq#Drop(Lit(a#0), splitIndex#20); (var leftSorted#20 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#20, Lit(lessThanOrEq#0)); (var rightSorted#20 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#20, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#20, rightSorted#20, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#12: Box :: $IsBox($y#12, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#12)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#13: Box :: $IsBox($y#13, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#13)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#12: int, j#12: int :: { Seq#Index(xs#0, j#12), Seq#Index(xs#0, i#12) } LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && LitInt(0) <= j#12 && j#12 < Seq#Length(xs#0) && i#12 != j#12 ==> Seq#Index(xs#0, i#12) != Seq#Index(xs#0, j#12))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#13: int, j#13: int :: { Seq#Index(xs#0, j#13), Seq#Index(xs#0, i#13) } LitInt(0) <= i#13 && i#13 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#13 && j#13 < Seq#Length(Lit(xs#0)) && i#13 != j#13 ==> Seq#Index(Lit(xs#0), i#13) != Seq#Index(Lit(xs#0), j#13))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#7: int :: { Seq#Index(xs#0, j#7) } LitInt(0) <= j#7 && j#7 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#7) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#7: int :: { Seq#Index(xs#0, j#7) } LitInt(0) <= j#7 && j#7 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#7) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#15 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#15) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#15)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#16 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#16) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#16)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#17 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#17) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#17)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#7: int :: { Seq#Index(xs#0, j#7) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#7 && j#7 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#7) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#7: int :: { Seq#Index(xs#0, j#7) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#7 && j#7 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#7) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#14: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#14), Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#14) == Seq#Index(xs#0, i#14)) && (forall i#15: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#15) } pos#0 <= i#15 && i#15 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#15) == Seq#Index(xs#0, i#15 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#15 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#15), Seq#Drop(xs#0, i#15 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#16 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#16), Seq#Drop(Lit(xs#0), i#16 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#17 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#17), Seq#Drop(Lit(xs#0), i#17 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#14: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#14), Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#14) == Seq#Index(xs#0, i#14)) && (forall i#15: int :: { Seq#Index(xs#0, i#15) } pos#0 <= i#15 && i#15 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#15 + 1) == Seq#Index(xs#0, i#15)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#7: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#7) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#7 - 1) } LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#7) == Seq#Index(xs#0, Seq#Length(xs#0) - i#7 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#7: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#7) } LitInt(0) <= i#7 && i#7 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#7) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#7: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#7) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#7) } LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#7), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#7)), $Unbox(Seq#Index(xs#0, i#7)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#10, b#10 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#10, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#10, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#11, b#11 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#11, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#11, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#7: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#7)): DatatypeType } LitInt(0) <= i#7 && i#7 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#7)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#7), Seq#Index(ys#0, i#7)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#7: int :: { Seq#Contains(xs#0, $Box(k#7)) } Seq#Contains(xs#0, $Box(k#7)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#7) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#7: int :: { Seq#Contains(xs#0, $Box(k#7)) } Seq#Contains(xs#0, $Box(k#7)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#7) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#28: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#28) } LitInt(0) <= i#28 && i#28 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#28) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#28))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#29: int :: { Seq#Index(xs#0, i#29) } LitInt(0) <= i#29 && i#29 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#29)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#29: int :: { Seq#Index(xs#0, i#29) } LitInt(0) <= i#29 && i#29 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#29)))) ==> (forall $l#15#i#0: int :: LitInt(0) <= $l#15#i#0 ==> $l#15#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#15#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#14#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#14#i#0): int))), (lambda $l#14#heap#0: Heap, $l#14#i#0: Box :: $IsBox($l#14#i#0, TInt) && LitInt(0) <= $Unbox($l#14#i#0): int && $Unbox($l#14#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#14#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#14#i#0): int))), (lambda $l#14#heap#0: Heap, $l#14#i#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: (exists i#30: int, o#13: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#14#heap#0, f#0, Seq#Index(xs#0, i#30))[$Box(o#13)] } $Is(o#13, Tclass._System.object?()) && LitInt(0) <= i#30 && i#30 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#14#heap#0, f#0, Seq#Index(xs#0, i#30))[$Box(o#13)] && $Box($l#14#o#0) == $Box(o#13))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#21: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#21) } { Seq#Index(xs#0, i#21) } (LitInt(0) <= i#21 && i#21 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#21))): DatatypeType)) && (LitInt(0) <= i#21 && i#21 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#21) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#21))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#22: int :: { Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#22)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#22: int :: { Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#22)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#5 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#5) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#5) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#5 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#5) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#5)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#5) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#5)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#5 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#5) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#5) else (var head#5 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#5); (var valueOrError1#5 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#5) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#5) else (var tail#5 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#5)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#5), tail#5)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#21: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#21) } LitInt(0) <= i#21 ==> i#21 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#21)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#21))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#22: int :: { Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#22)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#22: int :: { Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#22)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#12: Box, xs#12: Seq, b#12: Box, b'#12: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#12, x#12, b'#12)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#12), xs#12) } $IsBox(x#12, Seq._default.InvFoldLeft$A) && $Is(xs#12, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#12, Seq._default.InvFoldLeft$B) && $IsBox(b'#12, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#12, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#12), xs#12)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#12, x#12, b'#12)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#12, $Box(xs#12))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#13: Box, xs#13: Seq, b#13: Box, b'#13: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#13, x#13, b'#13)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#13), xs#13) } $IsBox(x#13, Seq._default.InvFoldLeft$A) && $Is(xs#13, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#13, Seq._default.InvFoldLeft$B) && $IsBox(b'#13, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#13, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#13), xs#13)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#13, x#13, b'#13)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#13, $Box(xs#13))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#12: Box, xs#12: Seq, b#12: Box, b'#12: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#12), xs#12), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#12, b#12, b'#12)): bool } $IsBox(x#12, Seq._default.InvFoldRight$A) && $Is(xs#12, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#12, Seq._default.InvFoldRight$B) && $IsBox(b'#12, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#12), b#12)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#12, b#12, b'#12)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#12), xs#12)), b'#12)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#13: Box, xs#13: Seq, b#13: Box, b'#13: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#13), xs#13), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#13, b#13, b'#13)): bool } $IsBox(x#13, Seq._default.InvFoldRight$A) && $Is(xs#13, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#13, Seq._default.InvFoldRight$B) && $IsBox(b'#13, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#13), b#13)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#13, b#13, b'#13)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#13), xs#13)), b'#13)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#14: int :: { Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#14)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#14: int :: { Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#14)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#6 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#6)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#7 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#7)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#5: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#5) } $IsBox(x#5, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#5))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#5: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#5) } $IsBox(x#5, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#5))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#5: Box, x2#5: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#5), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#5) } $IsBox(x1#5, Functions._default.Injective$X) && $IsBox(x2#5, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#5) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#5) ==> x1#5 == x2#5)));

const unique class.UnicodeStrings.__default: ClassName;

function UnicodeStrings.__default.IsWellFormedString(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> Seq#Length(s#0) == LitInt(0) ==> UnicodeStrings.__default.IsWellFormedString(s#0));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#2#c#0): char)))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar)), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#3#c#0): char)))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar)), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), s#0)) && (UnicodeStrings.__default.IsWellFormedString(s#0) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#0#c#0): char)))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar)), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.IsWellFormedString(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#6#c#0): char)))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, TChar)), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#7#c#0): char)))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar)), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (UnicodeStrings.__default.IsWellFormedString(Lit(s#0)) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#4#c#0): char)))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, TChar)), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))));
}

function UnicodeStrings.__default.IsWellFormedString#canCall(s#0: Seq) : bool;

function UnicodeStrings.__default.IsWellFormedString#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.IsWellFormedString#requires(s#0) <==> true));

procedure {:verboseName "UnicodeStrings.IsWellFormedString (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.IsWellFormedString(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id8765"} Seq#Length(s#0) == LitInt(0) ==> UnicodeStrings.__default.IsWellFormedString(s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.IsWellFormedString (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.IsWellFormedString(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bv16;
  var newtype$check#0: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##s#1: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.IsWellFormedString", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStringsWithoutUnicodeChar.dfy(19,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Seq#Length(s#0) == LitInt(0);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume s#0 == s#0 || Seq#Rank(##s#0) < Seq#Rank(s#0);
    assume s#0 == s#0 || UnicodeStrings.__default.IsWellFormedString#canCall(s#0);
    assume UnicodeStrings.__default.IsWellFormedString(s#0);
    goto anon5;

  anon12_Else:
    assume Seq#Length(s#0) == LitInt(0) ==> UnicodeStrings.__default.IsWellFormedString(s#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon11_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(c#0);
    assume 0 <= newtype$check#0 && newtype$check#0 < 65536;
    assume lambdaResult#0 == nat_to_bv16(char#ToInt(c#0));
    assume true;
    assume $Is(lambdaResult#0, TBitvector(16));
    goto anon9;

  anon14_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon9;

  anon9:
    assume false;
    goto anon10;

  anon13_Else:
    goto anon10;

  anon10:
    ##f#0 := Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#9#c#0): char)))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, TBitvector(16)), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#10#c#0): char)))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar)), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), s#0);
    ##s#1 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#12#c#0): char)))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar)), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $IsAlloc(##s#1, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#13#c#0): char)))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), s#0));
    assume UnicodeStrings.__default.IsWellFormedString(s#0) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#15#c#0): char)))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))), s#0));
    assume Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#17#c#0): char)))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#18#c#0): char)))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), s#0));
    assume $Is(UnicodeStrings.__default.IsWellFormedString(s#0), TBool);
    assume b$reqreads#0;
    return;
}



function UnicodeStrings.__default.ToUTF8Checked(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(UnicodeStrings.__default.ToUTF8Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#3#c#0): char)))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar)), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), s#0) && (var asCodeUnits#0 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#6#c#0): char)))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, TChar)), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), s#0); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#0) && (var valueOrError0#0 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#0); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) && (var utf32#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#0) && (var asUtf8CodeUnits#0 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#0); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(nat_from_bv8($Unbox($l#5#c#0): bv8))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TBitvector(8))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#0)))))) && UnicodeStrings.__default.ToUTF8Checked(s#0) == (var asCodeUnits#0 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#0#c#0): char)))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar)), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0); (var valueOrError0#0 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#0); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var utf32#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0)): Seq; (var asUtf8CodeUnits#0 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#0); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(nat_from_bv8($Unbox($l#1#c#0): bv8))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TBitvector(8))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#0)))))))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#10#c#0): char)))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar)), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && (var asCodeUnits#1 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#13#c#0): char)))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#1) && (var valueOrError0#1 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#1); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) && (var utf32#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#1) && (var asUtf8CodeUnits#1 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#1); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(nat_from_bv8($Unbox($l#12#c#0): bv8))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TBitvector(8))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#1)))))) && UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)) == (var asCodeUnits#1 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#7#c#0): char)))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar)), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); (var valueOrError0#1 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#1); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var utf32#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1)): Seq; (var asUtf8CodeUnits#1 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#1); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(nat_from_bv8($Unbox($l#8#c#0): bv8))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TBitvector(8))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#1)))))))));
}

function UnicodeStrings.__default.ToUTF8Checked#canCall(s#0: Seq) : bool;

function UnicodeStrings.__default.ToUTF8Checked#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ToUTF8Checked#requires(s#0) <==> true));

procedure {:verboseName "UnicodeStrings.ToUTF8Checked (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ToUTF8Checked(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.ToUTF8Checked (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ToUTF8Checked(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var asCodeUnits#Z#0: Seq;
  var let#0#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bv16;
  var newtype$check#0: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##s#0: Seq;
  var utf32#Z#0: Seq;
  var let#2#0#0: Seq;
  var asUtf8CodeUnits#Z#0: Seq;
  var let#3#0#0: Seq;
  var ##vs#0: Seq;
  var $lambdaHeap#1: Heap;
  var c#1: bv8;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: int;
  var newtype$check#1: bv8;
  var newtype$check#2: int;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.ToUTF8Checked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStringsWithoutUnicodeChar.dfy(25,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(UnicodeStrings.__default.ToUTF8Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())));
    assume false;
    return;

  anon15_Else:
    havoc asCodeUnits#Z#0;
    assume $Is(asCodeUnits#Z#0, TSeq(TBitvector(16))) && $IsAlloc(asCodeUnits#Z#0, TSeq(TBitvector(16)), $Heap);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(c#0);
    assume 0 <= newtype$check#0 && newtype$check#0 < 65536;
    assume lambdaResult#0 == nat_to_bv16(char#ToInt(c#0));
    assume true;
    assume $Is(lambdaResult#0, TBitvector(16));
    goto anon6;

  anon17_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon16_Else:
    goto anon7;

  anon7:
    ##f#0 := Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#15#c#0): char)))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, TBitvector(16)), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#16#c#0): char)))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, TChar)), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume let#0#0#0 == Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#18#c#0): char)))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#20#c#0): char)))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, TChar)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $Is(let#0#0#0, TSeq(TBitvector(16)));
    assume asCodeUnits#Z#0 == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    ##s#0 := asCodeUnits#Z#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#Z#0);
    assume let#1#0#0 == Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#Z#0);
    assume Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#Z#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume UnicodeStrings.__default.ToUTF8Checked(s#0) == Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(UnicodeStrings.__default.ToUTF8Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())));
    goto anon14;

  anon18_Else:
    assume {:partition} !Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    havoc utf32#Z#0;
    assume $Is(utf32#Z#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(utf32#Z#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    assume let#2#0#0 == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    assume $Is(let#2#0#0, TSeq(Tclass.Unicode.ScalarValue()));
    assume utf32#Z#0 == let#2#0#0;
    havoc asUtf8CodeUnits#Z#0;
    assume $Is(asUtf8CodeUnits#Z#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(asUtf8CodeUnits#Z#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    ##vs#0 := utf32#Z#0;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#Z#0);
    assume let#3#0#0 == Utf8EncodingForm.__default.EncodeScalarSequence(utf32#Z#0);
    assume Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#Z#0);
    assume $Is(let#3#0#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq());
    assume asUtf8CodeUnits#Z#0 == let#3#0#0;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} true;
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#1 := c#1;
    assume LitInt(0) <= nat_from_bv8(newtype$check#1) && nat_from_bv8(newtype$check#1) < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := nat_from_bv8(c#1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#1 == nat_from_bv8(c#1);
    assume true;
    assume $Is(lambdaResult#1, Tclass.BoundedInts.uint8());
    goto anon12;

  anon20_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon19_Else:
    goto anon13;

  anon13:
    ##f#1 := Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(nat_from_bv8($Unbox($l#22#c#0): bv8))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TBitvector(8))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(TBitvector(8), Tclass.BoundedInts.uint8()), $Heap);
    ##xs#1 := asUtf8CodeUnits#Z#0;
    assume $IsAlloc(##xs#1, TSeq(TBitvector(8)), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): bv8 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    assume (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): bv8 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#3: int, o#1: ref :: { Reads1(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) && Reads1(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] && $Box($o) == $Box(o#1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(nat_from_bv8($Unbox($l#23#c#0): bv8))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TBitvector(8))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#Z#0);
    assume UnicodeStrings.__default.ToUTF8Checked(s#0) == #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(nat_from_bv8($Unbox($l#26#c#0): bv8))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TBitvector(8))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#Z#0)));
    assume Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(nat_from_bv8($Unbox($l#28#c#0): bv8))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, TBitvector(8))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#Z#0);
    assume $Is(UnicodeStrings.__default.ToUTF8Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())));
    goto anon14;

  anon14:
    assume b$reqreads#0;
    assume b$reqreads#1;
    return;
}



function UnicodeStrings.__default.FromUTF8Checked(bs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> $Is(UnicodeStrings.__default.FromUTF8Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(nat_to_bv8($Unbox($l#3#c#0): int))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), bs#0) && (var asCodeUnits#0 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(nat_to_bv8($Unbox($l#6#c#0): int))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), bs#0); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#0) && (var valueOrError0#0 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#0); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#0)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) && (var utf32#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#0) && (var asUtf16CodeUnits#0 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#0); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#5#cu#0): bv16)))), (lambda $l#5#heap#0: Heap, $l#5#cu#0: Box :: $IsBox($l#5#cu#0, TBitvector(16))), (lambda $l#5#heap#0: Heap, $l#5#cu#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#0)))))) && UnicodeStrings.__default.FromUTF8Checked(bs#0) == (var asCodeUnits#0 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(nat_to_bv8($Unbox($l#0#c#0): int))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint8())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), bs#0); (var valueOrError0#0 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#0); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#0) else (var utf32#0 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#0)): Seq; (var asUtf16CodeUnits#0 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#0); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#1#cu#0): bv16)))), (lambda $l#1#heap#0: Heap, $l#1#cu#0: Box :: $IsBox($l#1#cu#0, TBitvector(16))), (lambda $l#1#heap#0: Heap, $l#1#cu#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#0)))))))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(bs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(nat_to_bv8($Unbox($l#10#c#0): int))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && (var asCodeUnits#1 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(nat_to_bv8($Unbox($l#13#c#0): int))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#1) && (var valueOrError0#1 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#1); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#1)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) && (var utf32#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#1) && (var asUtf16CodeUnits#1 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#1); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#12#cu#0): bv16)))), (lambda $l#12#heap#0: Heap, $l#12#cu#0: Box :: $IsBox($l#12#cu#0, TBitvector(16))), (lambda $l#12#heap#0: Heap, $l#12#cu#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#1)))))) && UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)) == (var asCodeUnits#1 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(nat_to_bv8($Unbox($l#7#c#0): int))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint8())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); (var valueOrError0#1 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#1); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#1) else (var utf32#1 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#1)): Seq; (var asUtf16CodeUnits#1 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#1); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#8#cu#0): bv16)))), (lambda $l#8#heap#0: Heap, $l#8#cu#0: Box :: $IsBox($l#8#cu#0, TBitvector(16))), (lambda $l#8#heap#0: Heap, $l#8#cu#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#1)))))))));
}

function UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0: Seq) : bool;

function UnicodeStrings.__default.FromUTF8Checked#requires(Seq) : bool;

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked#requires(bs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UnicodeStrings.__default.FromUTF8Checked#requires(bs#0) <==> true));

procedure {:verboseName "UnicodeStrings.FromUTF8Checked (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$UnicodeStrings.__default.FromUTF8Checked(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.FromUTF8Checked (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$UnicodeStrings.__default.FromUTF8Checked(bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var asCodeUnits#Z#0: Seq;
  var let#0#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var c#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bv8;
  var newtype$check#0: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##s#0: Seq;
  var utf32#Z#0: Seq;
  var let#2#0#0: Seq;
  var asUtf16CodeUnits#Z#0: Seq;
  var let#3#0#0: Seq;
  var ##vs#0: Seq;
  var $lambdaHeap#1: Heap;
  var cu#0: bv16;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: char;
  var newtype$check#1: bv16;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.FromUTF8Checked", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStringsWithoutUnicodeChar.dfy(32,40): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(UnicodeStrings.__default.FromUTF8Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar)));
    assume false;
    return;

  anon15_Else:
    havoc asCodeUnits#Z#0;
    assume $Is(asCodeUnits#Z#0, TSeq(TBitvector(8))) && $IsAlloc(asCodeUnits#Z#0, TSeq(TBitvector(8)), $Heap);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := c#0;
    assume 0 <= newtype$check#0 && newtype$check#0 < 256;
    assume lambdaResult#0 == nat_to_bv8(c#0);
    assume true;
    assume $Is(lambdaResult#0, TBitvector(8));
    goto anon6;

  anon17_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon16_Else:
    goto anon7;

  anon7:
    ##f#0 := Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(nat_to_bv8($Unbox($l#15#c#0): int))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint8())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.BoundedInts.uint8(), TBitvector(8)), $Heap);
    ##xs#0 := bs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): int } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): int } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(nat_to_bv8($Unbox($l#16#c#0): int))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.BoundedInts.uint8())), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))), bs#0);
    assume let#0#0#0 == Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(nat_to_bv8($Unbox($l#18#c#0): int))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint8())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), bs#0);
    assume Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(nat_to_bv8($Unbox($l#20#c#0): int))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint8())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), bs#0);
    assume $Is(let#0#0#0, TSeq(TBitvector(8)));
    assume asCodeUnits#Z#0 == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    ##s#0 := asCodeUnits#Z#0;
    assume $IsAlloc(##s#0, TSeq(TBitvector(8)), $Heap);
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#Z#0);
    assume let#1#0#0 == Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#Z#0);
    assume Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#Z#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#Z#0);
    assume UnicodeStrings.__default.FromUTF8Checked(bs#0) == Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#Z#0);
    assume $Is(UnicodeStrings.__default.FromUTF8Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar)));
    goto anon14;

  anon18_Else:
    assume {:partition} !Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    havoc utf32#Z#0;
    assume $Is(utf32#Z#0, TSeq(Tclass.Unicode.ScalarValue())) && $IsAlloc(utf32#Z#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue())), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    assume let#2#0#0 == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0)): Seq;
    assume Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#Z#0);
    assume $Is(let#2#0#0, TSeq(Tclass.Unicode.ScalarValue()));
    assume utf32#Z#0 == let#2#0#0;
    havoc asUtf16CodeUnits#Z#0;
    assume $Is(asUtf16CodeUnits#Z#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) && $IsAlloc(asUtf16CodeUnits#Z#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq(), $Heap);
    ##vs#0 := utf32#Z#0;
    assume $IsAlloc(##vs#0, TSeq(Tclass.Unicode.ScalarValue()), $Heap);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#Z#0);
    assume let#3#0#0 == Utf16EncodingForm.__default.EncodeScalarSequence(utf32#Z#0);
    assume Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#Z#0);
    assume $Is(let#3#0#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq());
    assume asUtf16CodeUnits#Z#0 == let#3#0#0;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc cu#0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} true;
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#1 := cu#0;
    assume lambdaResult#1 == char#FromInt(nat_from_bv16(cu#0));
    assume true;
    assume $Is(lambdaResult#1, TChar);
    goto anon12;

  anon20_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon19_Else:
    goto anon13;

  anon13:
    ##f#1 := Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#22#cu#0): bv16)))), (lambda $l#22#heap#0: Heap, $l#22#cu#0: Box :: $IsBox($l#22#cu#0, TBitvector(16))), (lambda $l#22#heap#0: Heap, $l#22#cu#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(TBitvector(16), TChar), $Heap);
    ##xs#1 := asUtf16CodeUnits#Z#0;
    assume $IsAlloc(##xs#1, TSeq(TBitvector(16)), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): bv16 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(TBitvector(16), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    assume (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): bv16 } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(TBitvector(16), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#3: int, o#1: ref :: { Reads1(TBitvector(16), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) && Reads1(TBitvector(16), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] && $Box($o) == $Box(o#1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#23#cu#0): bv16)))), (lambda $l#23#heap#0: Heap, $l#23#cu#0: Box :: $IsBox($l#23#cu#0, TBitvector(16))), (lambda $l#23#heap#0: Heap, $l#23#cu#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#Z#0);
    assume UnicodeStrings.__default.FromUTF8Checked(bs#0) == #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#26#cu#0): bv16)))), (lambda $l#26#heap#0: Heap, $l#26#cu#0: Box :: $IsBox($l#26#cu#0, TBitvector(16))), (lambda $l#26#heap#0: Heap, $l#26#cu#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#Z#0)));
    assume Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#28#cu#0): bv16)))), (lambda $l#28#heap#0: Heap, $l#28#cu#0: Box :: $IsBox($l#28#cu#0, TBitvector(16))), (lambda $l#28#heap#0: Heap, $l#28#cu#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#Z#0);
    assume $Is(UnicodeStrings.__default.FromUTF8Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar)));
    goto anon14;

  anon14:
    assume b$reqreads#0;
    assume b$reqreads#1;
    return;
}



function UnicodeStrings.__default.ToUTF16Checked(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(UnicodeStrings.__default.ToUTF16Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16()))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#3#c#0): char)))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar)), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#4#c#0): char)))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, TChar)), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#5#c#0): char)))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar)), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), s#0)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(char#ToInt($Unbox($l#7#c#0): char))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar)), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), s#0)) && UnicodeStrings.__default.ToUTF16Checked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#0#c#0): char)))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar)), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(char#ToInt($Unbox($l#1#c#0): char))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TChar)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))), s#0))) else #Wrappers.Option.None()));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#11#c#0): char)))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, TChar)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#12#c#0): char)))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar)), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#13#c#0): char)))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(char#ToInt($Unbox($l#15#c#0): char))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#8#c#0): char)))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar)), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(char#ToInt($Unbox($l#9#c#0): char))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))) else #Wrappers.Option.None()));
}

function UnicodeStrings.__default.ToUTF16Checked#canCall(s#0: Seq) : bool;

function UnicodeStrings.__default.ToUTF16Checked#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ToUTF16Checked#requires(s#0) <==> true));

procedure {:verboseName "UnicodeStrings.ToUTF16Checked (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ToUTF16Checked(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.ToUTF16Checked (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ToUTF16Checked(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bv16;
  var newtype$check#0: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##s#0: Seq;
  var $lambdaHeap#1: Heap;
  var c#1: char;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.ToUTF16Checked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStringsWithoutUnicodeChar.dfy(39,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(UnicodeStrings.__default.ToUTF16Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16())));
    assume false;
    return;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(c#0);
    assume 0 <= newtype$check#0 && newtype$check#0 < 65536;
    assume lambdaResult#0 == nat_to_bv16(char#ToInt(c#0));
    assume true;
    assume $Is(lambdaResult#0, TBitvector(16));
    goto anon6;

  anon17_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon16_Else:
    goto anon7;

  anon7:
    ##f#0 := Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#17#c#0): char)))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, TBitvector(16)), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(TChar, TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#18#c#0): char)))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), s#0);
    ##s#0 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#20#c#0): char)))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, TChar)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#21#c#0): char)))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), s#0));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#30#c#0): char)))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar)), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), s#0));
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} $Is(c#1, TChar);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#1 := char#ToInt(c#1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#2 := char#ToInt(c#1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    assume lambdaResult#1 == char#ToInt(c#1);
    assume true;
    assume $Is(lambdaResult#1, Tclass.BoundedInts.uint16());
    goto anon11;

  anon20_Else:
    assume {:partition} !$Is(c#1, TChar);
    goto anon11;

  anon11:
    assume false;
    goto anon12;

  anon19_Else:
    goto anon12;

  anon12:
    ##f#1 := Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(char#ToInt($Unbox($l#23#c#0): char))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(TChar, Tclass.BoundedInts.uint16()), $Heap);
    ##xs#1 := s#0;
    assume $IsAlloc(##xs#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    assume (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#3: int, o#1: ref :: { Reads1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) && Reads1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] && $Box($o) == $Box(o#1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(char#ToInt($Unbox($l#24#c#0): char))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, TChar)), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume UnicodeStrings.__default.ToUTF16Checked(s#0) == #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(char#ToInt($Unbox($l#27#c#0): char))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar)), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))), s#0)));
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(char#ToInt($Unbox($l#29#c#0): char))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $Is(UnicodeStrings.__default.ToUTF16Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16())));
    goto anon14;

  anon18_Else:
    assume {:partition} !Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#30#c#0): char)))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar)), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), s#0));
    assume UnicodeStrings.__default.ToUTF16Checked(s#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(UnicodeStrings.__default.ToUTF16Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16())));
    goto anon14;

  anon14:
    assume b$reqreads#0;
    assume b$reqreads#1;
    return;
}



function UnicodeStrings.__default.FromUTF16Checked(bs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> $Is(UnicodeStrings.__default.FromUTF16Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(nat_to_bv16($Unbox($l#3#c#0): int))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint16())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), bs#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(nat_to_bv16($Unbox($l#4#c#0): int))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.BoundedInts.uint16())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), bs#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(nat_to_bv16($Unbox($l#5#c#0): int))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.BoundedInts.uint16())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), bs#0)) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(char#FromInt($Unbox($l#7#c#0): int))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint16())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), bs#0)) && UnicodeStrings.__default.FromUTF16Checked(bs#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(nat_to_bv16($Unbox($l#0#c#0): int))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint16())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), bs#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(char#FromInt($Unbox($l#1#c#0): int))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint16())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))), bs#0))) else #Wrappers.Option.None()));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(bs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(nat_to_bv16($Unbox($l#11#c#0): int))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint16())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(nat_to_bv16($Unbox($l#12#c#0): int))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.BoundedInts.uint16())), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(nat_to_bv16($Unbox($l#13#c#0): int))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint16())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(char#FromInt($Unbox($l#15#c#0): int))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint16())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(nat_to_bv16($Unbox($l#8#c#0): int))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint16())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(char#FromInt($Unbox($l#9#c#0): int))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint16())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)))) else #Wrappers.Option.None()));
}

function UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0: Seq) : bool;

function UnicodeStrings.__default.FromUTF16Checked#requires(Seq) : bool;

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked#requires(bs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16())) ==> (UnicodeStrings.__default.FromUTF16Checked#requires(bs#0) <==> true));

procedure {:verboseName "UnicodeStrings.FromUTF16Checked (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.FromUTF16Checked(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.FromUTF16Checked (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.FromUTF16Checked(bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bv16;
  var newtype$check#0: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var ##s#0: Seq;
  var $lambdaHeap#1: Heap;
  var c#1: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: char;
  var newtype$check#1: int;
  var ##f#1: HandleType;
  var ##xs#1: Seq;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.FromUTF16Checked", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStringsWithoutUnicodeChar.dfy(46,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(UnicodeStrings.__default.FromUTF16Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar)));
    assume false;
    return;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16();
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := c#0;
    assume 0 <= newtype$check#0 && newtype$check#0 < 65536;
    assume lambdaResult#0 == nat_to_bv16(c#0);
    assume true;
    assume $Is(lambdaResult#0, TBitvector(16));
    goto anon6;

  anon17_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16());
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon16_Else:
    goto anon7;

  anon7:
    ##f#0 := Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(nat_to_bv16($Unbox($l#17#c#0): int))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.BoundedInts.uint16())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.BoundedInts.uint16(), TBitvector(16)), $Heap);
    ##xs#0 := bs#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): int } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): int } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(nat_to_bv16($Unbox($l#18#c#0): int))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint16())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), bs#0);
    ##s#0 := Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(nat_to_bv16($Unbox($l#20#c#0): int))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint16())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), bs#0);
    assume $IsAlloc(##s#0, TSeq(TBitvector(16)), $Heap);
    assume Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(nat_to_bv16($Unbox($l#21#c#0): int))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.BoundedInts.uint16())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), bs#0));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(nat_to_bv16($Unbox($l#30#c#0): int))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.BoundedInts.uint16())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), bs#0));
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16();
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#1 := c#1;
    assume char#IsChar(newtype$check#1);
    assume lambdaResult#1 == char#FromInt(c#1);
    assume true;
    assume $Is(lambdaResult#1, TChar);
    goto anon11;

  anon20_Else:
    assume {:partition} !(LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16());
    goto anon11;

  anon11:
    assume false;
    goto anon12;

  anon19_Else:
    goto anon12;

  anon12:
    ##f#1 := Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(char#FromInt($Unbox($l#23#c#0): int))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.BoundedInts.uint16())), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#1, Tclass._System.___hFunc1(Tclass.BoundedInts.uint16(), TChar), $Heap);
    ##xs#1 := bs#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): int } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(Tclass.BoundedInts.uint16(), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    assume (forall i#2: int :: { $Unbox(Seq#Index(##xs#1, i#2)): int } LitInt(0) <= i#2 && i#2 < Seq#Length(##xs#1) ==> Requires1(Tclass.BoundedInts.uint16(), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#2)));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#3: int, o#1: ref :: { Reads1(Tclass.BoundedInts.uint16(), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#3 && i#3 < Seq#Length(##xs#1) && Reads1(Tclass.BoundedInts.uint16(), TChar, $Heap, ##f#1, Seq#Index(##xs#1, i#3))[$Box(o#1)] && $Box($o) == $Box(o#1)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(char#FromInt($Unbox($l#24#c#0): int))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.BoundedInts.uint16())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), bs#0);
    assume UnicodeStrings.__default.FromUTF16Checked(bs#0) == #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(char#FromInt($Unbox($l#27#c#0): int))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.BoundedInts.uint16())), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))), bs#0)));
    assume Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(char#FromInt($Unbox($l#29#c#0): int))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint16())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))), bs#0);
    assume $Is(UnicodeStrings.__default.FromUTF16Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar)));
    goto anon14;

  anon18_Else:
    assume {:partition} !Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(nat_to_bv16($Unbox($l#30#c#0): int))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.BoundedInts.uint16())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), bs#0));
    assume UnicodeStrings.__default.FromUTF16Checked(bs#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(UnicodeStrings.__default.FromUTF16Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar)));
    goto anon14;

  anon14:
    assume b$reqreads#0;
    assume b$reqreads#1;
    return;
}



function UnicodeStrings.__default.ASCIIToUTF8(s#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)) ==> $Is(UnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(char#ToInt($Unbox($l#2#c#0): char))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#2#c#0): char) && char#ToInt($Unbox($l#2#c#0): char) < 128), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(char#ToInt($Unbox($l#0#c#0): char))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#0#c#0): char) && char#ToInt($Unbox($l#0#c#0): char) < 128), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#2: int :: { $Unbox(Seq#Index(s#0, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(char#ToInt($Unbox($l#5#c#0): char))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#5#c#0): char) && char#ToInt($Unbox($l#5#c#0): char) < 128), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(char#ToInt($Unbox($l#3#c#0): char))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#3#c#0): char) && char#ToInt($Unbox($l#3#c#0): char) < 128), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));
}

function UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0: Seq) : bool;

function UnicodeStrings.__default.ASCIIToUTF8#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF8#requires(s#0) <==> (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)));

procedure {:verboseName "UnicodeStrings.ASCIIToUTF8 (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ASCIIToUTF8(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.ASCIIToUTF8 (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ASCIIToUTF8(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.ASCIIToUTF8", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStrings.dfy[UnicodeStrings](45,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc i#3;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon4;

  anon19_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon6;

  anon20_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < LitInt(0);
    goto anon6;

  anon6:
    assume LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon18_Else:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon8:
    assume (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $Is(UnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0);
    goto anon14;

  anon24_Else:
    assume {:partition} char#ToInt(c#0) < LitInt(0);
    goto anon14;

  anon14:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128;
    newtype$check#0 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#0 == char#ToInt(c#0);
    assume true;
    assume $Is(lambdaResult#0, Tclass.BoundedInts.uint8());
    goto anon16;

  anon25_Else:
    assume {:partition} !(LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128);
    goto anon16;

  anon23_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon16;

  anon16:
    assume false;
    goto anon17;

  anon22_Else:
    goto anon17;

  anon17:
    ##f#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(char#ToInt($Unbox($l#7#c#0): char))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#7#c#0): char) && char#ToInt($Unbox($l#7#c#0): char) < 128), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, Tclass.BoundedInts.uint8()), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    assume (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#5: int, o#0: ref :: { Reads1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#5 && i#5 < Seq#Length(##xs#0) && Reads1(TChar, Tclass.BoundedInts.uint8(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(char#ToInt($Unbox($l#8#c#0): char))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#8#c#0): char) && char#ToInt($Unbox($l#8#c#0): char) < 128), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume UnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(char#ToInt($Unbox($l#10#c#0): char))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#10#c#0): char) && char#ToInt($Unbox($l#10#c#0): char) < 128), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(char#ToInt($Unbox($l#12#c#0): char))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#12#c#0): char) && char#ToInt($Unbox($l#12#c#0): char) < 128), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $Is(UnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume b$reqreads#0;
    return;
}



function UnicodeStrings.__default.ASCIIToUTF16(s#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)) ==> $Is(UnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(char#ToInt($Unbox($l#2#c#0): char))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#2#c#0): char) && char#ToInt($Unbox($l#2#c#0): char) < 128), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(char#ToInt($Unbox($l#0#c#0): char))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#0#c#0): char) && char#ToInt($Unbox($l#0#c#0): char) < 128), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), s#0));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#2: int :: { $Unbox(Seq#Index(s#0, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#2)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(char#ToInt($Unbox($l#5#c#0): char))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#5#c#0): char) && char#ToInt($Unbox($l#5#c#0): char) < 128), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(char#ToInt($Unbox($l#3#c#0): char))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#3#c#0): char) && char#ToInt($Unbox($l#3#c#0): char) < 128), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));
}

function UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0: Seq) : bool;

function UnicodeStrings.__default.ASCIIToUTF16#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF16#requires(s#0) <==> (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128)));

procedure {:verboseName "UnicodeStrings.ASCIIToUTF16 (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ASCIIToUTF16(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UnicodeStrings.ASCIIToUTF16 (well-formedness)"} CheckWellformed$$UnicodeStrings.__default.ASCIIToUTF16(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#3: int;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "UnicodeStrings.ASCIIToUTF16", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/Unicode/UnicodeStrings.dfy[UnicodeStrings](55,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc i#3;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#3;
    goto anon4;

  anon19_Else:
    assume {:partition} i#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char);
    assume 0 <= i#3 && i#3 < Seq#Length(s#0);
    goto anon6;

  anon20_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < LitInt(0);
    goto anon6;

  anon6:
    assume LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon18_Else:
    assume LitInt(0) <= i#3 && i#3 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < 128;
    goto anon8;

  anon8:
    assume (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $Is(UnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16()));
    assume false;
    return;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0);
    goto anon14;

  anon24_Else:
    assume {:partition} char#ToInt(c#0) < LitInt(0);
    goto anon14;

  anon14:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128;
    newtype$check#0 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#1 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    assume lambdaResult#0 == char#ToInt(c#0);
    assume true;
    assume $Is(lambdaResult#0, Tclass.BoundedInts.uint16());
    goto anon16;

  anon25_Else:
    assume {:partition} !(LitInt(0) <= char#ToInt(c#0) && char#ToInt(c#0) < 128);
    goto anon16;

  anon23_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon16;

  anon16:
    assume false;
    goto anon17;

  anon22_Else:
    goto anon17;

  anon17:
    ##f#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(char#ToInt($Unbox($l#7#c#0): char))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#7#c#0): char) && char#ToInt($Unbox($l#7#c#0): char) < 128), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(TChar, Tclass.BoundedInts.uint16()), $Heap);
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    assume (forall i#4: int :: { $Unbox(Seq#Index(##xs#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##xs#0) ==> Requires1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#4)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#5: int, o#0: ref :: { Reads1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#5 && i#5 < Seq#Length(##xs#0) && Reads1(TChar, Tclass.BoundedInts.uint16(), $Heap, ##f#0, Seq#Index(##xs#0, i#5))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(char#ToInt($Unbox($l#8#c#0): char))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#8#c#0): char) && char#ToInt($Unbox($l#8#c#0): char) < 128), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume UnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(char#ToInt($Unbox($l#10#c#0): char))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#10#c#0): char) && char#ToInt($Unbox($l#10#c#0): char) < 128), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(char#ToInt($Unbox($l#12#c#0): char))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#12#c#0): char) && char#ToInt($Unbox($l#12#c#0): char) < 128), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), s#0);
    assume $Is(UnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16()));
    assume b$reqreads#0;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#72 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#72))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#74 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#74)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#108 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#108))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#110 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#110)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#112 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#112)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#108 := Wrappers.Option.value(this); v#108)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#110 := Lit(Wrappers.Option.value(Lit(this))); v#110)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#112 := Lit(Wrappers.Option.value(Lit(this))); v#112)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#72 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#72)) else (var e#72 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#74 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#74))) else (var e#74 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#108 := Wrappers.Result.value(this); s#108) else (var e#108 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#110 := Lit(Wrappers.Result.value(Lit(this))); s#110) else (var e#110 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#112 := Lit(Wrappers.Result.value(Lit(this))); s#112) else (var e#112 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#108 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#108)) else (var e#108 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#108)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#110 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#110))) else (var e#110 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#110)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#112 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#112))) else (var e#112 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#112)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#18: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#18, x#18)): bool } $IsBox(x#18, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#18, x#18)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#19: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#19, x#19)): bool } $IsBox(x#19, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#19, x#19)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#18: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#18, x#18)): bool } $IsBox(x#18, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#18, x#18)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#19: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#19, x#19)): bool } $IsBox(x#19, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#19, x#19)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#18: Box, y#18: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#18, x#18)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#18, y#18)): bool } $IsBox(x#18, Relations._default.AntiSymmetric$T) && $IsBox(y#18, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#18, y#18)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#18, x#18)): bool ==> x#18 == y#18)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#19: Box, y#19: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#19, x#19)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#19, y#19)): bool } $IsBox(x#19, Relations._default.AntiSymmetric$T) && $IsBox(y#19, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#19, y#19)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#19, x#19)): bool ==> x#19 == y#19)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#18: Box, y#18: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#18, x#18)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#18, y#18)): bool } $IsBox(x#18, Relations._default.Symmetric$T) && $IsBox(y#18, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#18, y#18)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#18, x#18)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#19: Box, y#19: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#19, x#19)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#19, y#19)): bool } $IsBox(x#19, Relations._default.Symmetric$T) && $IsBox(y#19, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#19, y#19)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#19, x#19)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#18: Box, y#18: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#18, x#18)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#18, y#18)): bool } $IsBox(x#18, Relations._default.Connected$T) && $IsBox(y#18, Relations._default.Connected$T) ==> x#18 != y#18 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#18, y#18)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#18, x#18)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#19: Box, y#19: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#19, x#19)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#19, y#19)): bool } $IsBox(x#19, Relations._default.Connected$T) && $IsBox(y#19, Relations._default.Connected$T) ==> x#19 != y#19 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#19, y#19)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#19, x#19)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#18: Box, y#18: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#18, x#18)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#18, y#18)): bool } $IsBox(x#18, Relations._default.StronglyConnected$T) && $IsBox(y#18, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#18, y#18)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#18, x#18)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#19: Box, y#19: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#19, x#19)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#19, y#19)): bool } $IsBox(x#19, Relations._default.StronglyConnected$T) && $IsBox(y#19, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#19, y#19)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#19, x#19)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#18: Box, y#18: Box, z#18: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#18, z#18)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#18, z#18)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#18, z#18)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#18, y#18)): bool } $IsBox(x#18, Relations._default.Transitive$T) && $IsBox(y#18, Relations._default.Transitive$T) && $IsBox(z#18, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#18, y#18)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#18, z#18)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#18, z#18)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#19: Box, y#19: Box, z#19: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#19, z#19)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#19, z#19)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#19, z#19)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#19, y#19)): bool } $IsBox(x#19, Relations._default.Transitive$T) && $IsBox(y#19, Relations._default.Transitive$T) && $IsBox(z#19, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#19, y#19)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#19, z#19)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#19, z#19)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#26: int, j#26: int :: { Seq#Index(a#0, j#26), Seq#Index(a#0, i#26) } LitInt(0) <= i#26 && i#26 < j#26 && j#26 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#26), Seq#Index(a#0, j#26))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#27: int, j#27: int :: { Seq#Index(a#0, j#27), Seq#Index(a#0, i#27) } LitInt(0) <= i#27 && i#27 < j#27 && j#27 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#27), Seq#Index(Lit(a#0), j#27))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#28: int, j#28: int :: { Seq#Index(a#0, j#28), Seq#Index(a#0, i#28) } LitInt(0) <= i#28 && i#28 < j#28 && j#28 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#28), Seq#Index(Lit(a#0), j#28))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#26: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#26)): bool } { s#0[x#26] } $IsBox(x#26, Relations._default.IsLeast$T) && s#0[x#26] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#26)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#27: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#27)): bool } { s#0[x#27] } $IsBox(x#27, Relations._default.IsLeast$T) && Lit(s#0)[x#27] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#27)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#28: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#28)): bool } { s#0[x#28] } $IsBox(x#28, Relations._default.IsLeast$T) && Lit(s#0)[x#28] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#28)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#26: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#26)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#26, min#0)): bool } { s#0[x#26] } $IsBox(x#26, Relations._default.IsMinimal$T) && s#0[x#26] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#26, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#26)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#27: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#27)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#27, min#0)): bool } { s#0[x#27] } $IsBox(x#27, Relations._default.IsMinimal$T) && Lit(s#0)[x#27] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#27, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#27)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#28: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#28)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#28, min#0)): bool } { s#0[x#28] } $IsBox(x#28, Relations._default.IsMinimal$T) && Lit(s#0)[x#28] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#28, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#28)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#26: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#26, max#0)): bool } { s#0[x#26] } $IsBox(x#26, Relations._default.IsGreatest$T) && s#0[x#26] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#26, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#27: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#27, max#0)): bool } { s#0[x#27] } $IsBox(x#27, Relations._default.IsGreatest$T) && Lit(s#0)[x#27] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#27, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#28: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#28, max#0)): bool } { s#0[x#28] } $IsBox(x#28, Relations._default.IsGreatest$T) && Lit(s#0)[x#28] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#28, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#26: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#26, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#26)): bool } { s#0[x#26] } $IsBox(x#26, Relations._default.IsMaximal$T) && s#0[x#26] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#26)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#26, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#27: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#27, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#27)): bool } { s#0[x#27] } $IsBox(x#27, Relations._default.IsMaximal$T) && Lit(s#0)[x#27] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#27)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#27, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#28: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#28, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#28)): bool } { s#0[x#28] } $IsBox(x#28, Relations._default.IsMaximal$T) && Lit(s#0)[x#28] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#28)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#28, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#21 := Div(Seq#Length(a#0), LitInt(2)); (var left#21, right#21 := Seq#Take(a#0, splitIndex#21), Seq#Drop(a#0, splitIndex#21); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#21, lessThanOrEq#0) && (var leftSorted#21 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#21, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#21, lessThanOrEq#0) && (var rightSorted#21 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#21, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#21, rightSorted#21, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#21 := Div(Seq#Length(a#0), LitInt(2)); (var left#21, right#21 := Seq#Take(a#0, splitIndex#21), Seq#Drop(a#0, splitIndex#21); (var leftSorted#21 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#21, lessThanOrEq#0); (var rightSorted#21 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#21, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#21, rightSorted#21, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#22 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#22, right#22 := Seq#Take(Lit(a#0), splitIndex#22), Seq#Drop(Lit(a#0), splitIndex#22); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#22, lessThanOrEq#0) && (var leftSorted#22 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#22, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#22, lessThanOrEq#0) && (var rightSorted#22 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#22, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#22, rightSorted#22, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#22 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#22, right#22 := Seq#Take(Lit(a#0), splitIndex#22), Seq#Drop(Lit(a#0), splitIndex#22); (var leftSorted#22 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#22, lessThanOrEq#0); (var rightSorted#22 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#22, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#22, rightSorted#22, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#23 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#23, right#23 := Seq#Take(Lit(a#0), splitIndex#23), Seq#Drop(Lit(a#0), splitIndex#23); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#23, Lit(lessThanOrEq#0)) && (var leftSorted#23 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#23, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#23, Lit(lessThanOrEq#0)) && (var rightSorted#23 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#23, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#23, rightSorted#23, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#23 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#23, right#23 := Seq#Take(Lit(a#0), splitIndex#23), Seq#Drop(Lit(a#0), splitIndex#23); (var leftSorted#23 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#23, Lit(lessThanOrEq#0)); (var rightSorted#23 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#23, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#23, rightSorted#23, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#14: Box :: $IsBox($y#14, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#14)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#15: Box :: $IsBox($y#15, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#15)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#14: int, j#14: int :: { Seq#Index(xs#0, j#14), Seq#Index(xs#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) && LitInt(0) <= j#14 && j#14 < Seq#Length(xs#0) && i#14 != j#14 ==> Seq#Index(xs#0, i#14) != Seq#Index(xs#0, j#14))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#15: int, j#15: int :: { Seq#Index(xs#0, j#15), Seq#Index(xs#0, i#15) } LitInt(0) <= i#15 && i#15 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#15 && j#15 < Seq#Length(Lit(xs#0)) && i#15 != j#15 ==> Seq#Index(Lit(xs#0), i#15) != Seq#Index(Lit(xs#0), j#15))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#8: int :: { Seq#Index(xs#0, j#8) } LitInt(0) <= j#8 && j#8 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#8) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#8: int :: { Seq#Index(xs#0, j#8) } LitInt(0) <= j#8 && j#8 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#8) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#18 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#18) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#18)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#19 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#19) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#19)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#20 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#20) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#20)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#8: int :: { Seq#Index(xs#0, j#8) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#8 && j#8 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#8) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#8: int :: { Seq#Index(xs#0, j#8) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#8 && j#8 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#8) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#16: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#16), Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#16) == Seq#Index(xs#0, i#16)) && (forall i#17: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#17) } pos#0 <= i#17 && i#17 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#17) == Seq#Index(xs#0, i#17 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#18 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#18), Seq#Drop(xs#0, i#18 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#19 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#19), Seq#Drop(Lit(xs#0), i#19 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#20 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#20), Seq#Drop(Lit(xs#0), i#20 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#16: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#16), Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#16) == Seq#Index(xs#0, i#16)) && (forall i#17: int :: { Seq#Index(xs#0, i#17) } pos#0 <= i#17 && i#17 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#17 + 1) == Seq#Index(xs#0, i#17)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#8: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#8) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#8 - 1) } LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#8) == Seq#Index(xs#0, Seq#Length(xs#0) - i#8 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#8: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#8) } LitInt(0) <= i#8 && i#8 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#8) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#8: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#8) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#8) } LitInt(0) <= i#8 && i#8 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#8), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#8)), $Unbox(Seq#Index(xs#0, i#8)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#12, b#12 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#12, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#12, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#13, b#13 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#13, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#13, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#8: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#8)): DatatypeType } LitInt(0) <= i#8 && i#8 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#8)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#8), Seq#Index(ys#0, i#8)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#8: int :: { Seq#Contains(xs#0, $Box(k#8)) } Seq#Contains(xs#0, $Box(k#8)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#8) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#8: int :: { Seq#Contains(xs#0, $Box(k#8)) } Seq#Contains(xs#0, $Box(k#8)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#8) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#31: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#31) } LitInt(0) <= i#31 && i#31 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#31) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#31))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#32: int :: { Seq#Index(xs#0, i#32) } LitInt(0) <= i#32 && i#32 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#32)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#32: int :: { Seq#Index(xs#0, i#32) } LitInt(0) <= i#32 && i#32 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#32)))) ==> (forall $l#17#i#0: int :: LitInt(0) <= $l#17#i#0 ==> $l#17#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#17#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#16#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#16#i#0): int))), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $IsBox($l#16#i#0, TInt) && LitInt(0) <= $Unbox($l#16#i#0): int && $Unbox($l#16#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#16#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#16#i#0): int))), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: (exists i#33: int, o#14: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#16#heap#0, f#0, Seq#Index(xs#0, i#33))[$Box(o#14)] } $Is(o#14, Tclass._System.object?()) && LitInt(0) <= i#33 && i#33 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#16#heap#0, f#0, Seq#Index(xs#0, i#33))[$Box(o#14)] && $Box($l#16#o#0) == $Box(o#14))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#23: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#23) } { Seq#Index(xs#0, i#23) } (LitInt(0) <= i#23 && i#23 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#23))): DatatypeType)) && (LitInt(0) <= i#23 && i#23 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#23) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#23))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#24: int :: { Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#24)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#24: int :: { Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#24)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#6 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#6) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#6) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#6 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#6) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#6)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#6) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#6)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#6 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#6) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#6) else (var head#6 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#6); (var valueOrError1#6 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#6) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#6) else (var tail#6 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#6), tail#6)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#23: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#23) } LitInt(0) <= i#23 ==> i#23 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#23)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#23))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#24: int :: { Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#24)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#24: int :: { Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#24)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#14: Box, xs#14: Seq, b#14: Box, b'#14: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#14, x#14, b'#14)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#14), xs#14) } $IsBox(x#14, Seq._default.InvFoldLeft$A) && $Is(xs#14, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#14, Seq._default.InvFoldLeft$B) && $IsBox(b'#14, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#14, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#14), xs#14)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#14, x#14, b'#14)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#14, $Box(xs#14))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#15: Box, xs#15: Seq, b#15: Box, b'#15: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#15, x#15, b'#15)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#15), xs#15) } $IsBox(x#15, Seq._default.InvFoldLeft$A) && $Is(xs#15, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#15, Seq._default.InvFoldLeft$B) && $IsBox(b'#15, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#15, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#15), xs#15)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#15, x#15, b'#15)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#15, $Box(xs#15))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#14: Box, xs#14: Seq, b#14: Box, b'#14: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#14), xs#14), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#14, b#14, b'#14)): bool } $IsBox(x#14, Seq._default.InvFoldRight$A) && $Is(xs#14, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#14, Seq._default.InvFoldRight$B) && $IsBox(b'#14, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#14), b#14)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#14, b#14, b'#14)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#14), xs#14)), b'#14)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#15: Box, xs#15: Seq, b#15: Box, b'#15: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#15), xs#15), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#15, b#15, b'#15)): bool } $IsBox(x#15, Seq._default.InvFoldRight$A) && $Is(xs#15, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#15, Seq._default.InvFoldRight$B) && $IsBox(b'#15, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#15), b#15)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#15, b#15, b'#15)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#15), xs#15)), b'#15)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#15: int :: { Seq#Index(xs#0, i#15) } LitInt(0) <= i#15 && i#15 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#15)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#15: int :: { Seq#Index(xs#0, i#15) } LitInt(0) <= i#15 && i#15 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#15)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#8 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#8)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#9 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#9)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#6: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#6) } $IsBox(x#6, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#6))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#6: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#6) } $IsBox(x#6, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#6))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#6: Box, x2#6: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#6), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#6) } $IsBox(x1#6, Functions._default.Injective$X) && $IsBox(x2#6, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#6) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#6) ==> x1#6 == x2#6)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#11: int :: { Seq#Take(s#0, i#11) } 0 < i#11 && i#11 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#11))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> (Seq#Length(s#0) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(2) ==> (Seq#Length(s#0) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(3) ==> Seq#Length(s#0) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0)))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then (var b#9 := Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0); b#9) else (if Seq#Length(s#0) == LitInt(2) then (var b#10 := Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#10) else (if Seq#Length(s#0) == LitInt(3) then (var b#11 := Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0); b#11) else (if Seq#Length(s#0) == LitInt(4) then (var b#12 := Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0); b#12) else false))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> (Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(2) ==> (Seq#Length(Lit(s#0)) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(3) ==> Seq#Length(Lit(s#0)) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0))))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then (var b#13 := Lit(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0))); b#13) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#14 := Lit(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#14) else (if Seq#Length(Lit(s#0)) == LitInt(3) then (var b#15 := Lit(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0))); b#15) else (if Seq#Length(Lit(s#0)) == LitInt(4) then (var b#16 := Lit(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0))); b#16) else false))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#2) && le_bv8(firstByte#2, 127bv8))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#3) && le_bv8(firstByte#3, 127bv8))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) ==> true && !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#2) && le_bv8(firstByte#2, 223bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; le_bv8(194bv8, firstByte#3) && le_bv8(firstByte#3, 223bv8) && le_bv8(128bv8, secondByte#3) && le_bv8(secondByte#3, 191bv8)))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) && !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; ((firstByte#2 == Lit(224bv8) && le_bv8(160bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (le_bv8(225bv8, firstByte#2) && le_bv8(firstByte#2, 236bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (firstByte#2 == Lit(237bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 159bv8)) || (le_bv8(238bv8, firstByte#2) && le_bv8(firstByte#2, 239bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8))) && le_bv8(128bv8, thirdByte#2) && le_bv8(thirdByte#2, 191bv8))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; ((firstByte#3 == Lit(224bv8) && le_bv8(160bv8, secondByte#3) && le_bv8(secondByte#3, 191bv8)) || (le_bv8(225bv8, firstByte#3) && le_bv8(firstByte#3, 236bv8) && le_bv8(128bv8, secondByte#3) && le_bv8(secondByte#3, 191bv8)) || (firstByte#3 == Lit(237bv8) && le_bv8(128bv8, secondByte#3) && le_bv8(secondByte#3, 159bv8)) || (le_bv8(238bv8, firstByte#3) && le_bv8(firstByte#3, 239bv8) && le_bv8(128bv8, secondByte#3) && le_bv8(secondByte#3, 191bv8))) && le_bv8(128bv8, thirdByte#3) && le_bv8(thirdByte#3, 191bv8))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) ==> !Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) && !Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) && !Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> (var firstByte#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; ((firstByte#2 == Lit(240bv8) && le_bv8(144bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (le_bv8(241bv8, firstByte#2) && le_bv8(firstByte#2, 243bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 191bv8)) || (firstByte#2 == Lit(244bv8) && le_bv8(128bv8, secondByte#2) && le_bv8(secondByte#2, 143bv8))) && le_bv8(128bv8, thirdByte#2) && le_bv8(thirdByte#2, 191bv8) && le_bv8(128bv8, fourthByte#2) && le_bv8(fourthByte#2, 191bv8)))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; (var fourthByte#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(3))): bv8; ((firstByte#3 == Lit(240bv8) && le_bv8(144bv8, secondByte#3) && le_bv8(secondByte#3, 191bv8)) || (le_bv8(241bv8, firstByte#3) && le_bv8(firstByte#3, 243bv8) && le_bv8(128bv8, secondByte#3) && le_bv8(secondByte#3, 191bv8)) || (firstByte#3 == Lit(244bv8) && le_bv8(128bv8, secondByte#3) && le_bv8(secondByte#3, 143bv8))) && le_bv8(128bv8, thirdByte#3) && le_bv8(thirdByte#3, 191bv8) && le_bv8(128bv8, fourthByte#3) && le_bv8(fourthByte#3, 191bv8)))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#6: int :: { Seq#Take(s#0, i#6) } 0 < i#6 && i#6 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#6))) <==> true && Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#2 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#2) && Seq#Length(prefix#2) <= Seq#Length(s#0) && Seq#Equal(prefix#2, Seq#Take(s#0, Seq#Length(prefix#2))) && (forall i#7: int :: { Seq#Take(s#0, i#7) } 0 < i#7 && i#7 < Seq#Length(prefix#2) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#7))))) && $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) >= LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)))) && (!(Seq#Length(s#0) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)))) ==> (Seq#Length(s#0) >= LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)))) && (!(Seq#Length(s#0) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2)))) ==> (Seq#Length(s#0) >= LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(3)))) && (!(Seq#Length(s#0) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3)))) ==> Seq#Length(s#0) >= LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(4)))))) && Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == (if Seq#Length(s#0) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1)))) else (if Seq#Length(s#0) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2)))) else (if Seq#Length(s#0) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Seq#Take(s#0, LitInt(3))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(3)))) else (if Seq#Length(s#0) >= LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Seq#Take(s#0, LitInt(4))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(4)))) else #Wrappers.Option.None())))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(Lit(s#0)) >= LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(1))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1))))) ==> (Seq#Length(Lit(s#0)) >= LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(2))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(2))))) ==> (Seq#Length(Lit(s#0)) >= LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(3))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(3))))) ==> Seq#Length(Lit(s#0)) >= LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(4))))))) && Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) == (if Seq#Length(Lit(s#0)) >= LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(1))))) else (if Seq#Length(Lit(s#0)) >= LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(2)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(2))))) else (if Seq#Length(Lit(s#0)) >= LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(3)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(3))))) else (if Seq#Length(Lit(s#0)) >= LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(4)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(4))))) else #Wrappers.Option.None())))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue(v#0) } Utf8EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> $Is(Utf8EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue(v#0) } Utf8EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> (le_bv24(v#0, 127bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0)) && (!le_bv24(v#0, 127bv24) ==> (le_bv24(v#0, 2047bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0)) && (!le_bv24(v#0, 2047bv24) ==> (le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0)) && (!le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0)))) && Utf8EncodingForm.__default.EncodeScalarValue(v#0) == (if le_bv24(v#0, 127bv24) then Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) else (if le_bv24(v#0, 2047bv24) then Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) else (if le_bv24(v#0, 65535bv24) then Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) else Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0)))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValue(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValue#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> (le_bv24(v#0, 127bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0))) && (!le_bv24(v#0, 127bv24) ==> (le_bv24(v#0, 2047bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0))) && (!le_bv24(v#0, 2047bv24) ==> (le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0))) && (!le_bv24(v#0, 65535bv24) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0))))) && Utf8EncodingForm.__default.EncodeScalarValue(Lit(v#0)) == (if le_bv24(v#0, 127bv24) then Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) else (if le_bv24(v#0, 2047bv24) then Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) else (if le_bv24(v#0, 65535bv24) then Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) else Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0)) == LitInt(1) && Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == (var x#2 := and_bv24(v#0, 127bv24)[7:0]; (var firstByte#3 := (0bv1 ++ x#2): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#3)))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) == (var x#3 := Lit(and_bv24(v#0, 127bv24))[7:0]; (var firstByte#4 := (0bv1 ++ x#3): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#4)))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0)) == LitInt(2) && Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0), TSeq(TBitvector(8))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == (var x#2 := and_bv24(v#0, 63bv24)[6:0]; (var y#2 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#3 := or_bv8(192bv8, (0bv3 ++ y#2): bv8); (var secondByte#3 := or_bv8(128bv8, (0bv2 ++ x#2): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#3)), $Box(secondByte#3)))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) == (var x#3 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#3 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#4 := or_bv8(192bv8, (0bv3 ++ y#3): bv8); (var secondByte#4 := or_bv8(128bv8, (0bv2 ++ x#3): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#4)), $Box(secondByte#4)))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0)) == LitInt(3) && Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0), TSeq(TBitvector(8))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == (var x#2 := and_bv24(v#0, 63bv24)[6:0]; (var y#2 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#2 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#3 := or_bv8(224bv8, (0bv4 ++ z#2): bv8); (var secondByte#3 := or_bv8(128bv8, (0bv2 ++ y#2): bv8); (var thirdByte#3 := or_bv8(128bv8, (0bv2 ++ x#2): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#3)), $Box(secondByte#3)), $Box(thirdByte#3)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) == (var x#3 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#3 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#3 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#4 := or_bv8(224bv8, (0bv4 ++ z#3): bv8); (var secondByte#4 := or_bv8(128bv8, (0bv2 ++ y#3): bv8); (var thirdByte#4 := or_bv8(128bv8, (0bv2 ++ x#3): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#4)), $Box(secondByte#4)), $Box(thirdByte#4)))))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Seq#Length(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0)) == LitInt(4) && Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0)) && $Is(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0), TSeq(TBitvector(8))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == (var x#2 := and_bv24(v#0, 63bv24)[6:0]; (var y#2 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#2 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#2 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#2 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#3 := or_bv8(240bv8, (0bv5 ++ u1#2): bv8); (var secondByte#3 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#2): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#2): bv8); (var thirdByte#3 := or_bv8(128bv8, (0bv2 ++ y#2): bv8); (var fourthByte#3 := or_bv8(128bv8, (0bv2 ++ x#2): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#3)), $Box(secondByte#3)), $Box(thirdByte#3)), $Box(fourthByte#3))))))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) == (var x#3 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#3 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#3 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#3 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#3 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#4 := or_bv8(240bv8, (0bv5 ++ u1#3): bv8); (var secondByte#4 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#3): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#3): bv8); (var thirdByte#4 := or_bv8(128bv8, (0bv2 ++ y#3): bv8); (var fourthByte#4 := or_bv8(128bv8, (0bv2 ++ x#3): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#4)), $Box(secondByte#4)), $Box(thirdByte#4)), $Box(fourthByte#4))))))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValue(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Seq#Length(m#0) == LitInt(1) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0)) && (Seq#Length(m#0) != LitInt(1) ==> (Seq#Length(m#0) == LitInt(2) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0)) && (Seq#Length(m#0) != LitInt(2) ==> (Seq#Length(m#0) == LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0)) && (Seq#Length(m#0) != LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0)))) && Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == (if Seq#Length(m#0) == LitInt(1) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) else (if Seq#Length(m#0) == LitInt(2) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) else (if Seq#Length(m#0) == LitInt(3) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) else Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(Lit(m#0)) || $Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Seq#Length(Lit(m#0)) == LitInt(1) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(1) ==> (Seq#Length(Lit(m#0)) == LitInt(2) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(2) ==> (Seq#Length(Lit(m#0)) == LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(3) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0))))) && Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) == (if Seq#Length(Lit(m#0)) == LitInt(1) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) else (if Seq#Length(Lit(m#0)) == LitInt(2) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) else (if Seq#Length(Lit(m#0)) == LitInt(3) then Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) else Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), 127bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var x#2 := firstByte#2[7:0]; (0bv17 ++ x#2): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) == (var firstByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var x#3 := firstByte#3[7:0]; (0bv17 ++ x#3): bv24)));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> le_bv24(128bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), 2047bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var y#2 := (0bv16 ++ and_bv8(firstByte#2, 31bv8)): bv24; (var x#2 := (0bv16 ++ and_bv8(secondByte#2, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#2, (0bv19 ++ 6bv5): bv24), x#2))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) == (var firstByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var y#3 := (0bv16 ++ and_bv8(firstByte#3, 31bv8)): bv24; (var x#3 := (0bv16 ++ and_bv8(secondByte#3, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#3, (0bv19 ++ 6bv5): bv24), x#3))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> le_bv24(2048bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), 65535bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var z#2 := (0bv16 ++ and_bv8(firstByte#2, 15bv8)): bv24; (var y#2 := (0bv16 ++ and_bv8(secondByte#2, 63bv8)): bv24; (var x#2 := (0bv16 ++ and_bv8(thirdByte#2, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#2, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#2, (0bv19 ++ 6bv5): bv24)), x#2))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) == (var firstByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var z#3 := (0bv16 ++ and_bv8(firstByte#3, 15bv8)): bv24; (var y#3 := (0bv16 ++ and_bv8(secondByte#3, 63bv8)): bv24; (var x#3 := (0bv16 ++ and_bv8(thirdByte#3, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#3, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#3, (0bv19 ++ 6bv5): bv24)), x#3))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> le_bv24(65536bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), 1114111bv24) && Seq#Equal(Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)), m#0) && le_bv24(0bv24, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0)) && le_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), 1114111bv24) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == (var firstByte#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#2 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var fourthByte#2 := $Unbox(Seq#Index(m#0, LitInt(3))): bv8; (var u1#2 := (0bv16 ++ and_bv8(firstByte#2, 7bv8)): bv24; (var u2#2 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#2, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#2 := (0bv16 ++ and_bv8(secondByte#2, 15bv8)): bv24; (var y#2 := (0bv16 ++ and_bv8(thirdByte#2, 63bv8)): bv24; (var x#2 := (0bv16 ++ and_bv8(fourthByte#2, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#2, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#2, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#2, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#2, (0bv19 ++ 6bv5): bv24)), x#2)))))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) == (var firstByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var fourthByte#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(3))): bv8; (var u1#3 := (0bv16 ++ and_bv8(firstByte#3, 7bv8)): bv24; (var u2#3 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#3, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#3 := (0bv16 ++ and_bv8(secondByte#3, 15bv8)): bv24; (var y#3 := (0bv16 ++ and_bv8(thirdByte#3, 63bv8)): bv24; (var x#3 := (0bv16 ++ and_bv8(fourthByte#3, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#3, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#3, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#3, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#3, (0bv19 ++ 6bv5): bv24)), x#3)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0)) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0))): Seq), s#0)) && $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#3 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#3)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) && (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#3))) && (var valueOrError1#2 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#3))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#3 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#3) else (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3)): Seq; (var valueOrError1#2 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#3))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) else (var restParts#2 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#3)), restParts#2)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#4 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#4)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) && (var prefix#4 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#4))) && (var valueOrError1#3 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#4))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#4 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#4) else (var prefix#4 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4)): Seq); (var valueOrError1#3 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#4))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) else (var restParts#3 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#4)), restParts#3)))))))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(8), $LS($LZ), Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0)), s#0) && $Is(Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq);

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) || $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))) && Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) == Lit($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0))))): Seq));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) <==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) <==> Lit(Wrappers.Option.Some_q(Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))))));

axiom (forall vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) ==> $Is(Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) == $Box(Utf8EncodingForm.__default.EncodeScalarValue($Unbox($fh$1x#0): bv24)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) <==> Utf8EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$1x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue($fh$1x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.EncodeScalarValue($fh$1x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(8), ms#2)) && Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#2)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(8), ms#3)) && Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#3)));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq()) ==> Seq#Equal(Utf8EncodingForm.__default.EncodeScalarSequence(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0)), s#0) && $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) } Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) == $Box(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$1x#0): Seq)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) } Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) <==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$1x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$1x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$1x#0) == $Unbox(Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$1x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#2 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#2)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#2 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#3 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#2); vs#3)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#3 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#3)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#3 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#4 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#3); vs#4)));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))): Seq, Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0))) && (!Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))) && $Is(Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) && (Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0)) && Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == (if Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) then #Wrappers.Option.Some($Box(Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0))) else #Wrappers.Option.None()));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) } Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) && (Lit(Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0))) ==> Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0))) && Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) == (if Utf8EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) then #Wrappers.Option.Some($Box(Lit(Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0))))) else #Wrappers.Option.None()));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#5: int :: { Seq#Take(s#0, i#5) } 0 < i#5 && i#5 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#5))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> Seq#Length(s#0) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#3 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#3) else false))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#4 := Lit(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#4) else false))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstWord#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#2) && le_bv16(firstWord#2, 55295bv16)) || (le_bv16(57344bv16, firstWord#2) && le_bv16(firstWord#2, 65535bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (le_bv16(0bv16, firstWord#3) && le_bv16(firstWord#3, 55295bv16)) || (le_bv16(57344bv16, firstWord#3) && le_bv16(firstWord#3, 65535bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) ==> !Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstWord#2 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (var secondWord#2 := $Unbox(Seq#Index(s#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#2) && le_bv16(firstWord#2, 56319bv16) && le_bv16(56320bv16, secondWord#2) && le_bv16(secondWord#2, 57343bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (var secondWord#3 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv16; le_bv16(55296bv16, firstWord#3) && le_bv16(firstWord#3, 56319bv16) && le_bv16(56320bv16, secondWord#3) && le_bv16(secondWord#3, 57343bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#10: int :: { Seq#Take(s#0, i#10) } 0 < i#10 && i#10 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#10))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#4 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#4) && Seq#Length(prefix#4) <= Seq#Length(s#0) && Seq#Equal(prefix#4, Seq#Take(s#0, Seq#Length(prefix#4))) && (forall i#11: int :: { Seq#Take(s#0, i#11) } 0 < i#11 && i#11 < Seq#Length(prefix#4) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#11))))) && (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#12: int :: { Seq#Take(s#0, i#12) } 0 < i#12 && i#12 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#12))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#5 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#5) && Seq#Length(prefix#5) <= Seq#Length(s#0) && Seq#Equal(prefix#5, Seq#Take(s#0, Seq#Length(prefix#5))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#5))) && $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) >= LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(1)))) && (!(Seq#Length(s#0) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1)))) ==> Seq#Length(s#0) >= LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Seq#Take(s#0, LitInt(2)))) && Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) == (if Seq#Length(s#0) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Seq#Take(s#0, LitInt(1))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(1)))) else (if Seq#Length(s#0) >= LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Seq#Take(s#0, LitInt(2))) then #Wrappers.Option.Some($Box(Seq#Take(s#0, LitInt(2)))) else #Wrappers.Option.None())));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(Lit(s#0)) >= LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(1))))) && (!(Seq#Length(Lit(s#0)) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1))))) ==> Seq#Length(Lit(s#0)) >= LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(Seq#Take(Lit(s#0), LitInt(2))))) && Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0)) == (if Seq#Length(Lit(s#0)) >= LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(1)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(1))))) else (if Seq#Length(Lit(s#0)) >= LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(Seq#Take(Lit(s#0), LitInt(2)))) then #Wrappers.Option.Some($Box(Lit(Seq#Take(Lit(s#0), LitInt(2))))) else #Wrappers.Option.None())));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue(v#0) } Utf16EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> $Is(Utf16EncodingForm.__default.EncodeScalarValue(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue(v#0) } Utf16EncodingForm.__default.EncodeScalarValue#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0)) && (!((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24))) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0)) && Utf16EncodingForm.__default.EncodeScalarValue(v#0) == (if (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) then Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) else Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0)));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValue(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValue#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX()))) ==> ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0))) && (!((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24))) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0))) && Utf16EncodingForm.__default.EncodeScalarValue(Lit(v#0)) == (if (le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)) then Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) else Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0))));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Seq#Length(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0)) == LitInt(1) && Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0)) && $Is(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == (var firstWord#3 := v#0[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#3))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) == (var firstWord#4 := Lit(v#0)[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#4))));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Seq#Length(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0)) == LitInt(2) && Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0)) && $Is(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == (var x2#2 := and_bv24(v#0, 1023bv24)[10:0]; (var x1#2 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#2 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#2 := sub_bv5(u#2, 1bv5)[4:0]; (var firstWord#3 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#2): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#2): bv16); (var secondWord#3 := or_bv16(56320bv16, (0bv6 ++ x2#2): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#3)), $Box(secondWord#3)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) == (var x2#3 := Lit(and_bv24(v#0, 1023bv24))[10:0]; (var x1#3 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#3 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#3 := sub_bv5(u#3, 1bv5)[4:0]; (var firstWord#4 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#3): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#3): bv16); (var secondWord#4 := or_bv16(56320bv16, (0bv6 ++ x2#3): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#4)), $Box(secondWord#4)))))))));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValue(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)), m#0) && le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(m#0) || $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Seq#Length(m#0) == LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0)) && (Seq#Length(m#0) != LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0)) && Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(m#0) == (if Seq#Length(m#0) == LitInt(1) then Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) else Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#canCall(Lit(m#0)) || $Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) ==> (Seq#Length(Lit(m#0)) == LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0))) && (Seq#Length(Lit(m#0)) != LitInt(1) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0))) && Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence(Lit(m#0)) == (if Seq#Length(Lit(m#0)) == LitInt(1) then Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) else Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0))));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> ((le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 55295bv24)) || (le_bv24(57344bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 65535bv24))) && Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)), m#0) && le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var x#2 := firstWord#2; (0bv8 ++ x#2): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) == (var firstWord#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var x#3 := firstWord#3; (0bv8 ++ x#3): bv24)));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> le_bv24(65536bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), 1114111bv24) && Seq#Equal(Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)), m#0) && le_bv24(0bv24, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0)) && le_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), 1114111bv24) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0), Unicode.__default.LOW__SURROGATE__MAX())));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == (var firstWord#2 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#2 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; (var x2#2 := (0bv8 ++ and_bv16(secondWord#2, 1023bv16)): bv24; (var x1#2 := (0bv8 ++ and_bv16(firstWord#2, 63bv16)): bv24; (var w#2 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#2, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#2 := add_bv24(w#2, 1bv24); (var v#3 := or_bv24(or_bv24(LeftShift_bv24(u#2, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#2, (0bv19 ++ 10bv5): bv24)), x2#2); v#3))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) == (var firstWord#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var secondWord#3 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv16; (var x2#3 := (0bv8 ++ and_bv16(secondWord#3, 1023bv16)): bv24; (var x1#3 := (0bv8 ++ and_bv16(firstWord#3, 63bv16)): bv24; (var w#3 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#3, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#3 := add_bv24(w#3, 1bv24); (var v#4 := or_bv24(or_bv24(LeftShift_bv24(u#3, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#3, (0bv19 ++ 10bv5): bv24)), x2#3); v#4))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0)) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0))): Seq), s#0)) && $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, s#0), Tclass.Wrappers.Option(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#3 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#3)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) && (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#3))) && (var valueOrError1#2 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#3))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#3 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#3) else (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#3)): Seq; (var valueOrError1#2 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#3))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2) else (var restParts#2 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#2)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#3)), restParts#2)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#4 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#4)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) && (var prefix#4 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#4))) && (var valueOrError1#3 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#4))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#4 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#4) else (var prefix#4 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#4)): Seq); (var valueOrError1#3 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#4))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3) else (var restParts#3 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#3)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#4)), restParts#3)))))))))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> Seq#Equal(Seq.__default.Flatten(TBitvector(16), $LS($LZ), Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0)), s#0) && $Is(Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) || $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0)) && Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0) == $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))): Seq);

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) || $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))) && Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0)) == Lit($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0))))): Seq));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) <==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), s#0))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) <==> Lit(Wrappers.Option.Some_q(Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($LZ), Lit(s#0)))))));

axiom (forall vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue())) ==> $Is(Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) == $Box(Utf16EncodingForm.__default.EncodeScalarValue($Unbox($fh$1x#0): bv24)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0) <==> Utf16EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$1x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue($fh$1x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.EncodeScalarValue($fh$1x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(16), ms#2)) && Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#2 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#2)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(16), ms#3)) && Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#3 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#3)));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq()) ==> Seq#Equal(Utf16EncodingForm.__default.EncodeScalarSequence(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0)), s#0) && $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), TSeq(Tclass.Unicode.ScalarValue())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) } Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) == $Box(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$1x#0): Seq)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) } Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0) <==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$1x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$1x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$1x#0) == $Unbox(Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$1x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#2 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#2)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#2 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#3 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#2); vs#3)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#3 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#3)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#3 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#4 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#3); vs#4)));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Wrappers.Option.Some_q(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0)) && Seq#Equal($Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))): Seq, Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0))) && (!Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> true && Wrappers.Option.None_q(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0))) && $Is(Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.Unicode.ScalarValue()))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) } Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(s#0) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) ==> Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0)) && Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(s#0) then #Wrappers.Option.Some($Box(Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0))) else #Wrappers.Option.None()));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) } Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Lit(s#0)) && (Lit(Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0))) ==> Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0))) && Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Lit(s#0)) then #Wrappers.Option.Some($Box(Lit(Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0))))) else #Wrappers.Option.None()));

const unique class.FileIO.__default: ClassName;

procedure {:verboseName "FileIO.ReadBytesFromFile (well-formedness)"} CheckWellFormed$$FileIO.__default.ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TBitvector(8)), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TBitvector(8)), TSeq(TChar)), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "FileIO.ReadBytesFromFile (call precondtion)"} CallPre$$FileIO.__default.ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap));



procedure {:verboseName "FileIO.ReadBytesFromFile (call postcondition)"} CallPost$$FileIO.__default.ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TBitvector(8)), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TBitvector(8)), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "FileIO.ReadBytesFromFile (correctness)"} Impl$$FileIO.__default.ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(TBitvector(8)), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TBitvector(8)), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FileIO.ReadBytesFromFile (correctness)"} Impl$$FileIO.__default.ReadBytesFromFile(path#0: Seq) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var isError#0: bool;
  var bytesRead#0: Seq where $Is(bytesRead#0, TSeq(TBitvector(8))) && $IsAlloc(bytesRead#0, TSeq(TBitvector(8)), $Heap);
  var errorMsg#0: Seq where $Is(errorMsg#0, TSeq(TChar)) && $IsAlloc(errorMsg#0, TSeq(TChar), $Heap);
  var $rhs##0: bool;
  var $rhs##1: Seq;
  var $rhs##2: Seq;
  var path##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FileIO.ReadBytesFromFile", " | ", path#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/FileIO/FileIO.dfy(36,81): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume true;
    assume true;
    path##0 := path#0;
    call CallPre$$FileIO.__default.INTERNAL__ReadBytesFromFile(path##0);
    call $rhs##0, $rhs##1, $rhs##2 := CallPost$$FileIO.__default.INTERNAL__ReadBytesFromFile(path##0);
    isError#0 := $rhs##0;
    bytesRead#0 := $rhs##1;
    errorMsg#0 := $rhs##2;
    assume {:captureState "libraries/src/FileIO/FileIO.dfy(37,72)"} true;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} isError#0;
    goto anon3;

  anon5_Else:
    assume {:partition} !isError#0;
    goto anon3;

  anon3:
    assume true;
    res#0 := (if isError#0 then #Wrappers.Result.Failure($Box(errorMsg#0)) else #Wrappers.Result.Success($Box(bytesRead#0)));
    defass#res#0 := true;
    assume {:captureState "libraries/src/FileIO/FileIO.dfy(38,68)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "FileIO.WriteBytesToFile (well-formedness)"} CheckWellFormed$$FileIO.__default.WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple0(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple0(), TSeq(TChar)), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "FileIO.WriteBytesToFile (call precondtion)"} CallPre$$FileIO.__default.WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap));



procedure {:verboseName "FileIO.WriteBytesToFile (call postcondition)"} CallPost$$FileIO.__default.WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple0(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple0(), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "FileIO.WriteBytesToFile (correctness)"} Impl$$FileIO.__default.WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple0(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple0(), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FileIO.WriteBytesToFile (correctness)"} Impl$$FileIO.__default.WriteBytesToFile(path#0: Seq, bytes#0: Seq) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var isError#0: bool;
  var errorMsg#0: Seq where $Is(errorMsg#0, TSeq(TChar)) && $IsAlloc(errorMsg#0, TSeq(TChar), $Heap);
  var $rhs##0: bool;
  var $rhs##1: Seq;
  var path##0: Seq;
  var bytes##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FileIO.WriteBytesToFile", " | ", path#0, " | ", bytes#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/FileIO/FileIO.dfy(50,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume true;
    path##0 := path#0;
    assume true;
    bytes##0 := bytes#0;
    call CallPre$$FileIO.__default.INTERNAL__WriteBytesToFile(path##0, bytes##0);
    call $rhs##0, $rhs##1 := CallPost$$FileIO.__default.INTERNAL__WriteBytesToFile(path##0, bytes##0);
    isError#0 := $rhs##0;
    errorMsg#0 := $rhs##1;
    assume {:captureState "libraries/src/FileIO/FileIO.dfy(51,67)"} true;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} isError#0;
    goto anon3;

  anon5_Else:
    assume {:partition} !isError#0;
    goto anon3;

  anon3:
    assume true;
    res#0 := (if isError#0 then #Wrappers.Result.Failure($Box(errorMsg#0)) else #Wrappers.Result.Success($Box(Lit(#_System._tuple#0._#Make0()))));
    defass#res#0 := true;
    assume {:captureState "libraries/src/FileIO/FileIO.dfy(52,61)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "FileIO.INTERNAL_ReadBytesFromFile (well-formedness)"} {:extern} CheckWellFormed$$FileIO.__default.INTERNAL__ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap)) returns (isError#0: bool, bytesRead#0: Seq where $Is(bytesRead#0, TSeq(TBitvector(8))) && $IsAlloc(bytesRead#0, TSeq(TBitvector(8)), $Heap), errorMsg#0: Seq where $Is(errorMsg#0, TSeq(TChar)) && $IsAlloc(errorMsg#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "FileIO.INTERNAL_ReadBytesFromFile (call precondtion)"} {:extern} CallPre$$FileIO.__default.INTERNAL__ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap));



procedure {:verboseName "FileIO.INTERNAL_ReadBytesFromFile (call postcondition)"} {:extern} CallPost$$FileIO.__default.INTERNAL__ReadBytesFromFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap)) returns (isError#0: bool, bytesRead#0: Seq where $Is(bytesRead#0, TSeq(TBitvector(8))) && $IsAlloc(bytesRead#0, TSeq(TBitvector(8)), $Heap), errorMsg#0: Seq where $Is(errorMsg#0, TSeq(TChar)) && $IsAlloc(errorMsg#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "FileIO.INTERNAL_WriteBytesToFile (well-formedness)"} {:extern} CheckWellFormed$$FileIO.__default.INTERNAL__WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap)) returns (isError#0: bool, errorMsg#0: Seq where $Is(errorMsg#0, TSeq(TChar)) && $IsAlloc(errorMsg#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "FileIO.INTERNAL_WriteBytesToFile (call precondtion)"} {:extern} CallPre$$FileIO.__default.INTERNAL__WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap));



procedure {:verboseName "FileIO.INTERNAL_WriteBytesToFile (call postcondition)"} {:extern} CallPost$$FileIO.__default.INTERNAL__WriteBytesToFile(path#0: Seq where $Is(path#0, TSeq(TChar)) && $IsAlloc(path#0, TSeq(TChar), $Heap), bytes#0: Seq where $Is(bytes#0, TSeq(TBitvector(8))) && $IsAlloc(bytes#0, TSeq(TBitvector(8)), $Heap)) returns (isError#0: bool, errorMsg#0: Seq where $Is(errorMsg#0, TSeq(TChar)) && $IsAlloc(errorMsg#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#76 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#76))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#78 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#78)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#114 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#114))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#116 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#116)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#118 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#118)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#114 := Wrappers.Option.value(this); v#114)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#116 := Lit(Wrappers.Option.value(Lit(this))); v#116)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#118 := Lit(Wrappers.Option.value(Lit(this))); v#118)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#76 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#76)) else (var e#76 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#78 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#78))) else (var e#78 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#114 := Wrappers.Result.value(this); s#114) else (var e#114 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#116 := Lit(Wrappers.Result.value(Lit(this))); s#116) else (var e#116 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#118 := Lit(Wrappers.Result.value(Lit(this))); s#118) else (var e#118 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#114 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#114)) else (var e#114 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#114)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#116 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#116))) else (var e#116 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#116)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#118 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#118))) else (var e#118 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#118)))));

const unique class.GeneralInternals.__default: ClassName;

function GeneralInternals.__default.IsLe(x#0: int, y#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int :: { GeneralInternals.__default.IsLe(x#0, y#0) } GeneralInternals.__default.IsLe#canCall(x#0, y#0) || 0 < $FunctionContextHeight ==> (GeneralInternals.__default.IsLe(x#0, y#0) <==> x#0 <= y#0));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int :: {:weight 3} { GeneralInternals.__default.IsLe(LitInt(x#0), LitInt(y#0)) } GeneralInternals.__default.IsLe#canCall(LitInt(x#0), LitInt(y#0)) || 0 < $FunctionContextHeight ==> (GeneralInternals.__default.IsLe(LitInt(x#0), LitInt(y#0)) <==> LitInt(x#0) <= LitInt(y#0)));
}

function GeneralInternals.__default.IsLe#canCall(x#0: int, y#0: int) : bool;

function GeneralInternals.__default.IsLe#requires(int, int) : bool;

axiom (forall x#0: int, y#0: int :: { GeneralInternals.__default.IsLe#requires(x#0, y#0) } GeneralInternals.__default.IsLe#requires(x#0, y#0) <==> true);

procedure {:verboseName "GeneralInternals.IsLe (well-formedness)"} CheckWellformed$$GeneralInternals.__default.IsLe(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GeneralInternals.LemmaInductionHelper (well-formedness)"} CheckWellFormed$$GeneralInternals.__default.LemmaInductionHelper(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap), x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GeneralInternals.LemmaInductionHelper (call precondtion)"} CallPre$$GeneralInternals.__default.LemmaInductionHelper(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap), x#0: int);
  requires {:id "id8892"} n#0 > 0;
  requires {:id "id8893"} (forall i#1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool } LitInt(0) <= i#1 && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id8894"} (forall i#3: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool } i#3 >= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id8895"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool } i#5 < n#0 && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);



procedure {:verboseName "GeneralInternals.LemmaInductionHelper (call postcondition)"} CallPost$$GeneralInternals.__default.LemmaInductionHelper(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap), x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8896"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "GeneralInternals.LemmaInductionHelper (correctness)"} Impl$$GeneralInternals.__default.LemmaInductionHelper(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap), x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id8897"} n#0 > 0;
  requires {:id "id8898"} (forall i#1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool } LitInt(0) <= i#1 && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id8899"} (forall i#3: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool } i#3 >= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id8900"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool } i#5 < n#0 && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8901"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GeneralInternals.LemmaInductionHelper (correctness)"} Impl$$GeneralInternals.__default.LemmaInductionHelper(n#0: int, f#0: HandleType, x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0_0: int;
  var f##0_0: HandleType;
  var x##0_0: int;
  var n##1_0_0: int;
  var f##1_0_0: HandleType;
  var x##1_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "GeneralInternals.LemmaInductionHelper", " | ", n#0, " | ", f#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/GeneralInternals.dfy(27,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} x#0 >= n#0;
    assume true;
    n##0_0 := n#0;
    assume true;
    f##0_0 := f#0;
    assume true;
    x##0_0 := x#0 - n#0;
    assume 0 <= (if x#0 >= n#0 then x#0 else 0 - x#0) || (if x##0_0 >= n##0_0 then x##0_0 else 0 - x##0_0) == (if x#0 >= n#0 then x#0 else 0 - x#0);
    assume (if x##0_0 >= n##0_0 then x##0_0 else 0 - x##0_0) < (if x#0 >= n#0 then x#0 else 0 - x#0);
    call CallPre$$GeneralInternals.__default.LemmaInductionHelper(n##0_0, f##0_0, x##0_0);
    call CallPost$$GeneralInternals.__default.LemmaInductionHelper(n##0_0, f##0_0, x##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/GeneralInternals.dfy(30,39)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0 - n#0 + n#0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/GeneralInternals.dfy(31,27)"} true;
    return;

  anon5_Else:
    assume {:partition} n#0 > x#0;
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} x#0 < 0;
    assume true;
    n##1_0_0 := n#0;
    assume true;
    f##1_0_0 := f#0;
    assume true;
    x##1_0_0 := x#0 + n#0;
    assume 0 <= (if x#0 >= n#0 then x#0 else 0 - x#0) || (if x##1_0_0 >= n##1_0_0 then x##1_0_0 else 0 - x##1_0_0) == (if x#0 >= n#0 then x#0 else 0 - x#0);
    assume (if x##1_0_0 >= n##1_0_0 then x##1_0_0 else 0 - x##1_0_0) < (if x#0 >= n#0 then x#0 else 0 - x#0);
    call CallPre$$GeneralInternals.__default.LemmaInductionHelper(n##1_0_0, f##1_0_0, x##1_0_0);
    call CallPost$$GeneralInternals.__default.LemmaInductionHelper(n##1_0_0, f##1_0_0, x##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/GeneralInternals.dfy(35,39)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0 + n#0 - n#0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/GeneralInternals.dfy(36,27)"} true;
    return;

  anon6_Else:
    assume {:partition} 0 <= x#0;
    return;
}



const unique class.MulInternalsNonlinear.__default: ClassName;

procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictlyPositive (well-formedness)"} CheckWellFormed$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictlyPositive (call precondtion)"} CallPre$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int);



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictlyPositive (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8915"} 0 < x#0 && 0 < y#0 ==> 0 < Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictlyPositive (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8916"} 0 < x#0 && 0 < y#0 ==> 0 < Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternalsNonlinear.LemmaMulStrictlyPositive (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulStrictlyPositive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternalsNonlinear.dfy(19,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "MulInternalsNonlinear.LemmaMulNonzero (well-formedness)"} CheckWellFormed$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulNonzero (call precondtion)"} CallPre$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0: int, y#0: int);



procedure {:verboseName "MulInternalsNonlinear.LemmaMulNonzero (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8918"} Mul(x#0, y#0) != 0 <==> x#0 != 0 && y#0 != 0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulNonzero (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8919"} Mul(x#0, y#0) != 0 <==> x#0 != 0 && y#0 != 0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternalsNonlinear.LemmaMulNonzero (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulNonzero", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternalsNonlinear.dfy(24,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsAssociative (well-formedness)"} CheckWellFormed$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsAssociative (call precondtion)"} CallPre$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsAssociative (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8921"} Mul(x#0, Mul(y#0, z#0)) == Mul(Mul(x#0, y#0), z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsAssociative (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8922"} Mul(x#0, Mul(y#0, z#0)) == Mul(Mul(x#0, y#0), z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternalsNonlinear.LemmaMulIsAssociative (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulIsAssociative", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternalsNonlinear.dfy(29,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsDistributiveAdd (well-formedness)"} CheckWellFormed$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsDistributiveAdd (call precondtion)"} CallPre$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsDistributiveAdd (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8924"} Mul(x#0, y#0 + z#0) == Mul(x#0, y#0) + Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulIsDistributiveAdd (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8925"} Mul(x#0, y#0 + z#0) == Mul(x#0, y#0) + Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternalsNonlinear.LemmaMulIsDistributiveAdd (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulIsDistributiveAdd", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternalsNonlinear.dfy(34,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "MulInternalsNonlinear.LemmaMulOrdering (well-formedness)"} CheckWellFormed$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulOrdering (call precondtion)"} CallPre$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0: int, y#0: int);
  requires {:id "id8931"} x#0 != 0;
  requires {:id "id8932"} y#0 != 0;
  requires {:id "id8933"} LitInt(0) <= Mul(x#0, y#0);



procedure {:verboseName "MulInternalsNonlinear.LemmaMulOrdering (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8934"} Mul(x#0, y#0) >= x#0;
  free ensures {:id "id8935"} Mul(x#0, y#0) >= y#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulOrdering (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id8936"} x#0 != 0;
  requires {:id "id8937"} y#0 != 0;
  requires {:id "id8938"} LitInt(0) <= Mul(x#0, y#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8939"} Mul(x#0, y#0) >= x#0;
  free ensures {:id "id8940"} Mul(x#0, y#0) >= y#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternalsNonlinear.LemmaMulOrdering (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulOrdering", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternalsNonlinear.dfy(42,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictInequality (well-formedness)"} CheckWellFormed$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictInequality (call precondtion)"} CallPre$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int);
  requires {:id "id8944"} x#0 < y#0;
  requires {:id "id8945"} z#0 > 0;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictInequality (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8946"} Mul(x#0, z#0) < Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternalsNonlinear.LemmaMulStrictInequality (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id8947"} x#0 < y#0;
  requires {:id "id8948"} z#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8949"} Mul(x#0, z#0) < Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternalsNonlinear.LemmaMulStrictInequality (correctness)"} Impl$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulStrictInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternalsNonlinear.dfy(49,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



const reveal_MulInternals._default.MulPos: bool;

const unique class.MulInternals.__default: ClassName;

function MulInternals.__default.MulPos($ly: LayerType, $reveal: bool, x#0: int, y#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: int, y#0: int :: { MulInternals.__default.MulPos($LS($ly), true, x#0, y#0) } MulInternals.__default.MulPos#canCall(x#0, y#0) || (0 < $FunctionContextHeight && x#0 >= LitInt(0)) ==> (x#0 != LitInt(0) ==> MulInternals.__default.MulPos#canCall(x#0 - 1, y#0)) && MulInternals.__default.MulPos($LS($ly), true, x#0, y#0) == (if x#0 == LitInt(0) then 0 else y#0 + MulInternals.__default.MulPos($ly, reveal_MulInternals._default.MulPos, x#0 - 1, y#0)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: int, y#0: int :: {:weight 3} { MulInternals.__default.MulPos($LS($ly), true, LitInt(x#0), LitInt(y#0)) } MulInternals.__default.MulPos#canCall(LitInt(x#0), LitInt(y#0)) || (0 < $FunctionContextHeight && LitInt(x#0) >= LitInt(0)) ==> (LitInt(x#0) != LitInt(0) ==> MulInternals.__default.MulPos#canCall(LitInt(x#0 - 1), LitInt(y#0))) && MulInternals.__default.MulPos($LS($ly), true, LitInt(x#0), LitInt(y#0)) == (if LitInt(x#0) == LitInt(0) then 0 else y#0 + MulInternals.__default.MulPos($LS($ly), reveal_MulInternals._default.MulPos, LitInt(x#0 - 1), LitInt(y#0))));
}

function MulInternals.__default.MulPos#canCall(x#0: int, y#0: int) : bool;

axiom (forall $ly: LayerType, $reveal: bool, x#0: int, y#0: int :: { MulInternals.__default.MulPos($LS($ly), $reveal, x#0, y#0) } MulInternals.__default.MulPos($LS($ly), $reveal, x#0, y#0) == MulInternals.__default.MulPos($ly, $reveal, x#0, y#0));

axiom (forall $ly: LayerType, $reveal: bool, x#0: int, y#0: int :: { MulInternals.__default.MulPos(AsFuelBottom($ly), $reveal, x#0, y#0) } MulInternals.__default.MulPos($ly, $reveal, x#0, y#0) == MulInternals.__default.MulPos($LZ, $reveal, x#0, y#0));

function MulInternals.__default.MulPos#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, x#0: int, y#0: int :: { MulInternals.__default.MulPos#requires($ly, x#0, y#0) } MulInternals.__default.MulPos#requires($ly, x#0, y#0) <==> x#0 >= LitInt(0));

procedure {:verboseName "MulInternals.MulPos (well-formedness)"} CheckWellformed$$MulInternals.__default.MulPos(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.MulPos (well-formedness)"} CheckWellformed$$MulInternals.__default.MulPos(x#0: int, y#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##y#0: int;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.MulPos", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(22,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume x#0 >= LitInt(0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} x#0 == LitInt(0);
    assume MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0) == LitInt(0);
    assume true;
    assume $Is(MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0), TInt);
    return;

  anon7_Else:
    assume {:partition} x#0 != LitInt(0);
    ##x#0 := x#0 - 1;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume {:subsumption 0} ##x#0 >= LitInt(0);
    assume ##x#0 >= LitInt(0);
    assume 0 <= x#0 || ##x#0 == x#0;
    assume 0 <= y#0 || ##x#0 < x#0 || ##y#0 == y#0;
    assume ##x#0 < x#0 || (##x#0 == x#0 && ##y#0 < y#0);
    assume MulInternals.__default.MulPos#canCall(x#0 - 1, y#0);
    assume MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0) == y#0 + MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0 - 1, y#0);
    assume MulInternals.__default.MulPos#canCall(x#0 - 1, y#0);
    assume $Is(MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0), TInt);
    return;
}



function MulInternals.__default.MulRecursive(x#0: int, y#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int :: { MulInternals.__default.MulRecursive(x#0, y#0) } MulInternals.__default.MulRecursive#canCall(x#0, y#0) || 1 < $FunctionContextHeight ==> (x#0 >= LitInt(0) ==> MulInternals.__default.MulPos#canCall(x#0, y#0)) && (LitInt(0) > x#0 ==> MulInternals.__default.MulPos#canCall(Mul(LitInt(-1), x#0), y#0)) && MulInternals.__default.MulRecursive(x#0, y#0) == (if x#0 >= LitInt(0) then MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0) else Mul(LitInt(-1), MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, Mul(LitInt(-1), x#0), y#0))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int :: {:weight 3} { MulInternals.__default.MulRecursive(LitInt(x#0), LitInt(y#0)) } MulInternals.__default.MulRecursive#canCall(LitInt(x#0), LitInt(y#0)) || 1 < $FunctionContextHeight ==> (LitInt(x#0) >= LitInt(0) ==> MulInternals.__default.MulPos#canCall(LitInt(x#0), LitInt(y#0))) && (LitInt(0) > LitInt(x#0) ==> MulInternals.__default.MulPos#canCall(LitInt(Mul(LitInt(-1), LitInt(x#0))), LitInt(y#0))) && MulInternals.__default.MulRecursive(LitInt(x#0), LitInt(y#0)) == (if LitInt(x#0) >= LitInt(0) then MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, LitInt(x#0), LitInt(y#0)) else Mul(LitInt(-1), MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, LitInt(Mul(LitInt(-1), LitInt(x#0))), LitInt(y#0)))));
}

function MulInternals.__default.MulRecursive#canCall(x#0: int, y#0: int) : bool;

function MulInternals.__default.MulRecursive#requires(int, int) : bool;

axiom (forall x#0: int, y#0: int :: { MulInternals.__default.MulRecursive#requires(x#0, y#0) } MulInternals.__default.MulRecursive#requires(x#0, y#0) <==> true);

procedure {:verboseName "MulInternals.MulRecursive (well-formedness)"} CheckWellformed$$MulInternals.__default.MulRecursive(x#0: int, y#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.MulRecursive (well-formedness)"} CheckWellformed$$MulInternals.__default.MulRecursive(x#0: int, y#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##y#0: int;
  var ##x#1: int;
  var ##y#1: int;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.MulRecursive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(30,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} x#0 >= LitInt(0);
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume {:subsumption 0} ##x#0 >= LitInt(0);
    assume ##x#0 >= LitInt(0);
    assume MulInternals.__default.MulPos#canCall(x#0, y#0);
    assume MulInternals.__default.MulRecursive(x#0, y#0) == MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0);
    assume MulInternals.__default.MulPos#canCall(x#0, y#0);
    assume $Is(MulInternals.__default.MulRecursive(x#0, y#0), TInt);
    return;

  anon7_Else:
    assume {:partition} LitInt(0) > x#0;
    ##x#1 := Mul(LitInt(-1), x#0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := y#0;
    assume $IsAlloc(##y#1, TInt, $Heap);
    assume {:subsumption 0} ##x#1 >= LitInt(0);
    assume ##x#1 >= LitInt(0);
    assume MulInternals.__default.MulPos#canCall(Mul(LitInt(-1), x#0), y#0);
    assume MulInternals.__default.MulRecursive(x#0, y#0) == Mul(LitInt(-1), MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, Mul(LitInt(-1), x#0), y#0));
    assume MulInternals.__default.MulPos#canCall(Mul(LitInt(-1), x#0), y#0);
    assume $Is(MulInternals.__default.MulRecursive(x#0, y#0), TInt);
    return;
}



procedure {:verboseName "MulInternals.LemmaMulInduction (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulInduction(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulInduction (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulInduction(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id8974"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(LitInt(0)))): bool;
  requires {:id "id8975"} (forall i#1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool } i#1 >= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool);
  requires {:id "id8976"} (forall i#3: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool } i#3 <= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool);



procedure {:verboseName "MulInternals.LemmaMulInduction (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulInduction(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8977"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulInduction (correctness)"} Impl$$MulInternals.__default.LemmaMulInduction(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id8978"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(LitInt(0)))): bool;
  requires {:id "id8979"} (forall i#1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool } i#1 >= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool);
  requires {:id "id8980"} (forall i#3: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool } i#3 <= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8981"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulInduction (correctness)"} Impl$$MulInternals.__default.LemmaMulInduction(f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0_0: int;
  var n##0_0: int;
  var f##0_0: HandleType;
  var x##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulInduction", " | ", f#0} true;
    assume {:print "Types", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(42,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc i#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0))): bool;
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    n##0_0 := LitInt(1);
    assume true;
    f##0_0 := f#0;
    assume true;
    x##0_0 := i#0_0;
    call CallPre$$GeneralInternals.__default.LemmaInductionHelper(n##0_0, f##0_0, x##0_0);
    call CallPost$$GeneralInternals.__default.LemmaInductionHelper(n##0_0, f##0_0, x##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(43,57)"} true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0))): bool;
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall i#0_1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1))): bool } Lit(true) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1))): bool);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(43,59)"} true;
    return;
}



procedure {:verboseName "MulInternals.LemmaMulCommutes (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulCommutes();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulCommutes (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulCommutes();



procedure {:verboseName "MulInternals.LemmaMulCommutes (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulCommutes();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8989"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(y#1, x#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulCommutes (correctness)"} Impl$$MulInternals.__default.LemmaMulCommutes() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id8990"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(y#1, x#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulCommutes (correctness)"} Impl$$MulInternals.__default.LemmaMulCommutes() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var f##0_0: HandleType;
  var $lambdaHeap#0_0: Heap;
  var i#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulCommutes"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(49,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume true;
    assume Mul(x#0_0, y#0_0) == Mul(y#0_0, x#0_0);
    assume false;
    goto anon3;

  anon11_Else:
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc i#0_0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    assume lambdaResult#0_0 <==> Mul(x#0_0, i#0_0) == Mul(i#0_0, x#0_0);
    assume true;
    assume $Is(lambdaResult#0_0, TBool);
    goto anon6;

  anon13_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    f##0_0 := Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $Box(Mul(x#0_0, $Unbox($l#0_1#i#0): int) == Mul($Unbox($l#0_1#i#0): int, x#0_0))), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $IsBox($l#0_1#i#0, TInt)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInduction(f##0_0);
    call CallPost$$MulInternals.__default.LemmaMulInduction(f##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(53,44)"} true;
    assume Mul(x#0_0, y#0_0) == Mul(y#0_0, x#0_0);
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(y#0_1, x#0_1) } { Mul(x#0_1, y#0_1) } Lit(true) ==> Mul(x#0_1, y#0_1) == Mul(y#0_1, x#0_1));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(54,4)"} true;
    return;
}



procedure {:verboseName "MulInternals.LemmaMulSuccessor (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulSuccessor();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulSuccessor (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulSuccessor();



procedure {:verboseName "MulInternals.LemmaMulSuccessor (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulSuccessor();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9001"} (forall x#1: int, y#1: int :: { Mul(x#1 + 1, y#1) } Mul(x#1 + 1, y#1) == Mul(x#1, y#1) + y#1);
  free ensures true;
  free ensures {:id "id9002"} (forall x#3: int, y#3: int :: { Mul(x#3 - 1, y#3) } Mul(x#3 - 1, y#3) == Mul(x#3, y#3) - y#3);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulSuccessor (correctness)"} Impl$$MulInternals.__default.LemmaMulSuccessor() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9003"} (forall x#1: int, y#1: int :: { Mul(x#1 + 1, y#1) } Mul(x#1 + 1, y#1) == Mul(x#1, y#1) + y#1);
  free ensures true;
  free ensures {:id "id9004"} (forall x#3: int, y#3: int :: { Mul(x#3 - 1, y#3) } Mul(x#3 - 1, y#3) == Mul(x#3, y#3) - y#3);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulSuccessor (correctness)"} Impl$$MulInternals.__default.LemmaMulSuccessor() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;
  var x##0_1: int;
  var y##0_1: int;
  var z##0_1: int;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulSuccessor"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(63,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulCommutes();
    call CallPost$$MulInternals.__default.LemmaMulCommutes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(64,22)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(x#0_0 + 1, y#0_0) == Mul(x#0_0, y#0_0) + y#0_0;
    assume true;
    assume Mul(x#0_0 - 1, y#0_0) == Mul(x#0_0, y#0_0) - y#0_0;
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := y#0_0;
    assume true;
    y##0_0 := x#0_0;
    assume true;
    z##0_0 := LitInt(1);
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0_0, y##0_0, z##0_0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(69,40)"} true;
    assume true;
    x##0_1 := y#0_0;
    assume true;
    y##0_1 := x#0_0;
    assume true;
    z##0_1 := LitInt(-1);
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0_1, y##0_1, z##0_1);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0_1, y##0_1, z##0_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(70,41)"} true;
    assume Mul(x#0_0 + 1, y#0_0) == Mul(x#0_0, y#0_0) + y#0_0;
    assume Mul(x#0_0 - 1, y#0_0) == Mul(x#0_0, y#0_0) - y#0_0;
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, _t#0#0_0: int :: { Mul(x#0_1, y#0_1), Mul(_t#0#0_0, y#0_1) } _t#0#0_0 == x#0_1 + 1 && true ==> Mul(_t#0#0_0, y#0_1) == Mul(x#0_1, y#0_1) + y#0_1) && (forall x#0_2: int, y#0_2: int, _t#0#0_1: int :: { Mul(x#0_2, y#0_2), Mul(_t#0#0_1, y#0_2) } _t#0#0_1 == x#0_2 - 1 && true ==> Mul(_t#0#0_1, y#0_2) == Mul(x#0_2, y#0_2) - y#0_2);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(71,4)"} true;
    return;
}



procedure {:verboseName "MulInternals.LemmaMulDistributes (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulDistributes();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulDistributes (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulDistributes();



procedure {:verboseName "MulInternals.LemmaMulDistributes (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulDistributes();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9020"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1 + y#1, z#1) } Mul(x#1 + y#1, z#1) == Mul(x#1, z#1) + Mul(y#1, z#1));
  free ensures true;
  free ensures {:id "id9021"} (forall x#3: int, y#3: int, z#3: int :: { Mul(x#3 - y#3, z#3) } Mul(x#3 - y#3, z#3) == Mul(x#3, z#3) - Mul(y#3, z#3));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulDistributes (correctness)"} Impl$$MulInternals.__default.LemmaMulDistributes() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9022"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1 + y#1, z#1) } Mul(x#1 + y#1, z#1) == Mul(x#1, z#1) + Mul(y#1, z#1));
  free ensures true;
  free ensures {:id "id9023"} (forall x#3: int, y#3: int, z#3: int :: { Mul(x#3 - y#3, z#3) } Mul(x#3 - y#3, z#3) == Mul(x#3, z#3) - Mul(y#3, z#3));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulDistributes (correctness)"} Impl$$MulInternals.__default.LemmaMulDistributes() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var f1#0_0: HandleType where $Is(f1#0_0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f1#0_0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0_0: Heap;
  var i#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: bool;
  var f2#0_0: HandleType where $Is(f2#0_0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f2#0_0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0_1: Heap;
  var i#0_1: int;
  var $_Frame#l0_1: [ref,Field]bool;
  var lambdaResult#0_1: bool;
  var i#0_2: int;
  var i#0_4: int;
  var i#0_6: int;
  var i#0_8: int;
  var f##0_0: HandleType;
  var f##0_1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulDistributes"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(78,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulSuccessor();
    call CallPost$$MulInternals.__default.LemmaMulSuccessor();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(79,23)"} true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    assume true;
    assume true;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume true;
    assume Mul(x#0_0 + y#0_0, z#0_0) == Mul(x#0_0, z#0_0) + Mul(y#0_0, z#0_0);
    assume true;
    assume Mul(x#0_0 - y#0_0, z#0_0) == Mul(x#0_0, z#0_0) - Mul(y#0_0, z#0_0);
    assume false;
    goto anon3;

  anon27_Else:
    goto anon3;

  anon3:
    assume true;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc i#0_0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    assume lambdaResult#0_0 <==> Mul(x#0_0 + i#0_0, z#0_0) == Mul(x#0_0, z#0_0) + Mul(i#0_0, z#0_0);
    assume true;
    assume $Is(lambdaResult#0_0, TBool);
    goto anon6;

  anon29_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon28_Else:
    goto anon7;

  anon7:
    assume true;
    f1#0_0 := Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $Box(Mul(x#0_0 + $Unbox($l#0_1#i#0): int, z#0_0) == Mul(x#0_0, z#0_0) + Mul($Unbox($l#0_1#i#0): int, z#0_0))), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $IsBox($l#0_1#i#0, TInt)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(84,49)"} true;
    assume true;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    havoc $lambdaHeap#0_1;
    assume $IsGoodHeap($lambdaHeap#0_1);
    assume $Heap == $lambdaHeap#0_1 || $HeapSucc($Heap, $lambdaHeap#0_1);
    havoc i#0_1;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} true;
    $_Frame#l0_1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_1, $o, alloc)): bool ==> false);
    assume lambdaResult#0_1 <==> Mul(x#0_0 - i#0_1, z#0_0) == Mul(x#0_0, z#0_0) - Mul(i#0_1, z#0_0);
    assume true;
    assume $Is(lambdaResult#0_1, TBool);
    goto anon10;

  anon31_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume false;
    goto anon11;

  anon30_Else:
    goto anon11;

  anon11:
    assume true;
    f2#0_0 := Lit(AtLayer((lambda $l#0_3#ly#0: LayerType :: Handle1((lambda $l#0_3#heap#0: Heap, $l#0_3#i#0: Box :: $Box(Mul(x#0_0 - $Unbox($l#0_3#i#0): int, z#0_0) == Mul(x#0_0, z#0_0) - Mul($Unbox($l#0_3#i#0): int, z#0_0))), (lambda $l#0_3#heap#0: Heap, $l#0_3#i#0: Box :: $IsBox($l#0_3#i#0, TInt)), (lambda $l#0_3#heap#0: Heap, $l#0_3#i#0: Box :: SetRef_to_SetBox((lambda $l#0_3#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(85,49)"} true;
    havoc i#0_2;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} true;
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} Mul(x#0_0 + i#0_2 + 1, z#0_0) == Mul(x#0_0 + i#0_2 + 1, z#0_0);
    goto anon14;

  anon33_Else:
    assume {:partition} Mul(x#0_0 + i#0_2 + 1, z#0_0) != Mul(x#0_0 + i#0_2 + 1, z#0_0);
    goto anon14;

  anon32_Else:
    assume {:partition} false;
    goto anon14;

  anon14:
    assume true;
    assume (forall i#0_3: int :: { Mul(x#0_0 + i#0_3 + 1, z#0_0) } Mul(x#0_0 + i#0_3 + 1, z#0_0) == Mul(x#0_0 + i#0_3 + 1, z#0_0) && Mul(x#0_0 + i#0_3 + 1, z#0_0) == Mul(x#0_0 + i#0_3, z#0_0) + z#0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(86,111)"} true;
    havoc i#0_4;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} true;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} Mul(x#0_0 + i#0_4 - 1, z#0_0) == Mul(x#0_0 + i#0_4 - 1, z#0_0);
    goto anon17;

  anon35_Else:
    assume {:partition} Mul(x#0_0 + i#0_4 - 1, z#0_0) != Mul(x#0_0 + i#0_4 - 1, z#0_0);
    goto anon17;

  anon34_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume true;
    assume (forall i#0_5: int :: { Mul(x#0_0 + i#0_5 - 1, z#0_0) } Mul(x#0_0 + i#0_5 - 1, z#0_0) == Mul(x#0_0 + i#0_5 - 1, z#0_0) && Mul(x#0_0 + i#0_5 - 1, z#0_0) == Mul(x#0_0 + i#0_5, z#0_0) - z#0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(87,111)"} true;
    havoc i#0_6;
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} Mul(x#0_0 - (i#0_6 + 1), z#0_0) == Mul(x#0_0 - i#0_6 - 1, z#0_0);
    goto anon20;

  anon37_Else:
    assume {:partition} Mul(x#0_0 - (i#0_6 + 1), z#0_0) != Mul(x#0_0 - i#0_6 - 1, z#0_0);
    goto anon20;

  anon36_Else:
    assume {:partition} false;
    goto anon20;

  anon20:
    assume true;
    assume (forall i#0_7: int :: { Mul(x#0_0 - (i#0_7 + 1), z#0_0) } Mul(x#0_0 - (i#0_7 + 1), z#0_0) == Mul(x#0_0 - i#0_7 - 1, z#0_0) && Mul(x#0_0 - i#0_7 - 1, z#0_0) == Mul(x#0_0 - i#0_7, z#0_0) - z#0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(88,111)"} true;
    havoc i#0_8;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} Mul(x#0_0 - (i#0_8 - 1), z#0_0) == Mul(x#0_0 - i#0_8 + 1, z#0_0);
    goto anon23;

  anon39_Else:
    assume {:partition} Mul(x#0_0 - (i#0_8 - 1), z#0_0) != Mul(x#0_0 - i#0_8 + 1, z#0_0);
    goto anon23;

  anon38_Else:
    assume {:partition} false;
    goto anon23;

  anon23:
    assume true;
    assume (forall i#0_9: int :: { Mul(x#0_0 - (i#0_9 - 1), z#0_0) } Mul(x#0_0 - (i#0_9 - 1), z#0_0) == Mul(x#0_0 - i#0_9 + 1, z#0_0) && Mul(x#0_0 - i#0_9 + 1, z#0_0) == Mul(x#0_0 - i#0_9, z#0_0) + z#0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(89,111)"} true;
    assume true;
    f##0_0 := f1#0_0;
    call CallPre$$MulInternals.__default.LemmaMulInduction(f##0_0);
    call CallPost$$MulInternals.__default.LemmaMulInduction(f##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(90,27)"} true;
    assume true;
    f##0_1 := f2#0_0;
    call CallPre$$MulInternals.__default.LemmaMulInduction(f##0_1);
    call CallPost$$MulInternals.__default.LemmaMulInduction(f##0_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(91,27)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f1#0_0, $Box(y#0_0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(92,18)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f2#0_0, $Box(y#0_0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(93,18)"} true;
    assume Mul(x#0_0 + y#0_0, z#0_0) == Mul(x#0_0, z#0_0) + Mul(y#0_0, z#0_0);
    assume Mul(x#0_0 - y#0_0, z#0_0) == Mul(x#0_0, z#0_0) - Mul(y#0_0, z#0_0);
    assume false;
    goto anon25;

  anon26_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int, _t#0#0_0: int :: { Mul(y#0_1, z#0_1), Mul(x#0_1, z#0_1), Mul(_t#0#0_0, z#0_1) } _t#0#0_0 == x#0_1 + y#0_1 && true ==> Mul(_t#0#0_0, z#0_1) == Mul(x#0_1, z#0_1) + Mul(y#0_1, z#0_1)) && (forall x#0_2: int, y#0_2: int, z#0_2: int, _t#0#0_1: int :: { Mul(y#0_2, z#0_2), Mul(x#0_2, z#0_2), Mul(_t#0#0_1, z#0_2) } _t#0#0_1 == x#0_2 - y#0_2 && true ==> Mul(_t#0#0_1, z#0_2) == Mul(x#0_2, z#0_2) - Mul(y#0_2, z#0_2));
    goto anon25;

  anon25:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(94,4)"} true;
    return;
}



function MulInternals.__default.MulAuto() : bool
uses {
axiom 0 <= $FunctionContextHeight ==> MulInternals.__default.MulAuto#canCall() || 0 < $FunctionContextHeight ==> (MulInternals.__default.MulAuto() <==> (forall x#0: int, y#0: int :: { Mul(x#0, y#0) } Mul(x#0, y#0) == Mul(y#0, x#0)) && (forall x#1: int, y#1: int, z#0: int :: { Mul(x#1 + y#1, z#0) } Mul(x#1 + y#1, z#0) == Mul(x#1, z#0) + Mul(y#1, z#0)) && (forall x#2: int, y#2: int, z#1: int :: { Mul(x#2 - y#2, z#1) } Mul(x#2 - y#2, z#1) == Mul(x#2, z#1) - Mul(y#2, z#1)));
axiom 0 <= $FunctionContextHeight ==> MulInternals.__default.MulAuto#canCall() || 0 < $FunctionContextHeight ==> (MulInternals.__default.MulAuto() <==> (forall x#3: int, y#3: int :: { Mul(x#3, y#3) } Mul(x#3, y#3) == Mul(y#3, x#3)) && (forall x#4: int, y#4: int, z#2: int :: { Mul(x#4 + y#4, z#2) } Mul(x#4 + y#4, z#2) == Mul(x#4, z#2) + Mul(y#4, z#2)) && (forall x#5: int, y#5: int, z#3: int :: { Mul(x#5 - y#5, z#3) } Mul(x#5 - y#5, z#3) == Mul(x#5, z#3) - Mul(y#5, z#3)));
}

function MulInternals.__default.MulAuto#canCall() : bool;

function MulInternals.__default.MulAuto#requires() : bool
uses {
axiom MulInternals.__default.MulAuto#requires() <==> true;
}

procedure {:verboseName "MulInternals.MulAuto (well-formedness)"} CheckWellformed$$MulInternals.__default.MulAuto();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulAuto (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulAuto (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulAuto();



procedure {:verboseName "MulInternals.LemmaMulAuto (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulAuto();
  modifies $Heap;
  free ensures MulInternals.__default.MulAuto#canCall();
  free ensures {:id "id9047"} MulInternals.__default.MulAuto#canCall() && Lit(MulInternals.__default.MulAuto()) && (forall x#0: int, y#0: int :: { Mul(x#0, y#0) } Mul(x#0, y#0) == Mul(y#0, x#0)) && (forall x#1: int, y#1: int, z#0: int :: { Mul(x#1 + y#1, z#0) } Mul(x#1 + y#1, z#0) == Mul(x#1, z#0) + Mul(y#1, z#0)) && (forall x#2: int, y#2: int, z#1: int :: { Mul(x#2 - y#2, z#1) } Mul(x#2 - y#2, z#1) == Mul(x#2, z#1) - Mul(y#2, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulAuto (correctness)"} Impl$$MulInternals.__default.LemmaMulAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures MulInternals.__default.MulAuto#canCall();
  free ensures {:id "id9048"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#3: int, y#3: int :: { Mul(x#3, y#3) } Mul(x#3, y#3) == Mul(y#3, x#3));
  free ensures {:id "id9049"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#4: int, y#4: int, z#2: int :: { Mul(x#4 + y#4, z#2) } Mul(x#4 + y#4, z#2) == Mul(x#4, z#2) + Mul(y#4, z#2));
  free ensures {:id "id9050"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#5: int, y#5: int, z#3: int :: { Mul(x#5 - y#5, z#3) } Mul(x#5 - y#5, z#3) == Mul(x#5, z#3) - Mul(y#5, z#3));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulAuto (correctness)"} Impl$$MulInternals.__default.LemmaMulAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(108,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulCommutes();
    call CallPost$$MulInternals.__default.LemmaMulCommutes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(109,22)"} true;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(110,25)"} true;
    return;
}



procedure {:verboseName "MulInternals.LemmaMulInductionAuto (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulInductionAuto(x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulInductionAuto (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulInductionAuto(x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id9062"} Lit(MulInternals.__default.MulAuto()) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(LitInt(0)))): bool;
  requires {:id "id9063"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool);
  requires {:id "id9064"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(i#3, 0) } GeneralInternals.__default.IsLe(i#3, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool);



procedure {:verboseName "MulInternals.LemmaMulInductionAuto (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulInductionAuto(x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures MulInternals.__default.MulAuto#canCall();
  free ensures {:id "id9065"} MulInternals.__default.MulAuto#canCall() && Lit(MulInternals.__default.MulAuto()) && (forall x#1: int, y#0: int :: { Mul(x#1, y#0) } Mul(x#1, y#0) == Mul(y#0, x#1)) && (forall x#2: int, y#1: int, z#0: int :: { Mul(x#2 + y#1, z#0) } Mul(x#2 + y#1, z#0) == Mul(x#2, z#0) + Mul(y#1, z#0)) && (forall x#3: int, y#2: int, z#1: int :: { Mul(x#3 - y#2, z#1) } Mul(x#3 - y#2, z#1) == Mul(x#3, z#1) - Mul(y#2, z#1));
  free ensures true;
  free ensures {:id "id9066"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulInductionAuto (correctness)"} Impl$$MulInternals.__default.LemmaMulInductionAuto(x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id9067"} Lit(MulInternals.__default.MulAuto()) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(LitInt(0)))): bool;
  requires {:id "id9068"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool);
  requires {:id "id9069"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(i#3, 0) } GeneralInternals.__default.IsLe(i#3, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool);
  modifies $Heap;
  free ensures MulInternals.__default.MulAuto#canCall();
  free ensures {:id "id9070"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#4: int, y#3: int :: { Mul(x#4, y#3) } Mul(x#4, y#3) == Mul(y#3, x#4));
  free ensures {:id "id9071"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#5: int, y#4: int, z#2: int :: { Mul(x#5 + y#4, z#2) } Mul(x#5 + y#4, z#2) == Mul(x#5, z#2) + Mul(y#4, z#2));
  free ensures {:id "id9072"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#6: int, y#5: int, z#3: int :: { Mul(x#6 - y#5, z#3) } Mul(x#6 - y#5, z#3) == Mul(x#6, z#3) - Mul(y#5, z#3));
  free ensures true;
  free ensures {:id "id9073"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulInductionAuto (correctness)"} Impl$$MulInternals.__default.LemmaMulInductionAuto(x#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#4: int;
  var ##x#2: int;
  var ##y#2: int;
  var i#6: int;
  var ##x#3: int;
  var ##y#3: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulInductionAuto", " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(120,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulCommutes();
    call CallPost$$MulInternals.__default.LemmaMulCommutes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(121,22)"} true;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(122,25)"} true;
    havoc i#4;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} true;
    ##x#2 := LitInt(0);
    assume $IsAlloc(##x#2, TInt, $Heap);
    ##y#2 := i#4;
    assume $IsAlloc(##y#2, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#4);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#4);
    goto anon3;

  anon12_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#4);
    goto anon3;

  anon3:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#4) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool;
    goto anon5;

  anon13_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#4) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool);
    goto anon5;

  anon11_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#5));
    assume (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool } GeneralInternals.__default.IsLe(LitInt(0), i#5) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 + 1))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(123,70)"} true;
    havoc i#6;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} true;
    ##x#3 := i#6;
    assume $IsAlloc(##x#3, TInt, $Heap);
    ##y#3 := LitInt(0);
    assume $IsAlloc(##y#3, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#6, LitInt(0));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#6, LitInt(0));
    goto anon8;

  anon15_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#6, LitInt(0));
    goto anon8;

  anon8:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#6, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#6))): bool;
    goto anon10;

  anon16_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#6, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#6))): bool);
    goto anon10;

  anon14_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } GeneralInternals.__default.IsLe#canCall(i#7, LitInt(0)));
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } GeneralInternals.__default.IsLe(i#7, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7 - 1))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(124,70)"} true;
    assume true;
    f##0 := f#0;
    call CallPre$$MulInternals.__default.LemmaMulInduction(f##0);
    call CallPost$$MulInternals.__default.LemmaMulInduction(f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(125,24)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(126,15)"} true;
    return;
}



procedure {:verboseName "MulInternals.LemmaMulInductionAutoForall (well-formedness)"} CheckWellFormed$$MulInternals.__default.LemmaMulInductionAutoForall(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.LemmaMulInductionAutoForall (call precondtion)"} CallPre$$MulInternals.__default.LemmaMulInductionAutoForall(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id9091"} Lit(MulInternals.__default.MulAuto()) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(LitInt(0)))): bool;
  requires {:id "id9092"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool);
  requires {:id "id9093"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(i#3, 0) } GeneralInternals.__default.IsLe(i#3, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool);



procedure {:verboseName "MulInternals.LemmaMulInductionAutoForall (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulInductionAutoForall(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures MulInternals.__default.MulAuto#canCall();
  free ensures {:id "id9094"} MulInternals.__default.MulAuto#canCall() && Lit(MulInternals.__default.MulAuto()) && (forall x#0: int, y#0: int :: { Mul(x#0, y#0) } Mul(x#0, y#0) == Mul(y#0, x#0)) && (forall x#1: int, y#1: int, z#0: int :: { Mul(x#1 + y#1, z#0) } Mul(x#1 + y#1, z#0) == Mul(x#1, z#0) + Mul(y#1, z#0)) && (forall x#2: int, y#2: int, z#1: int :: { Mul(x#2 - y#2, z#1) } Mul(x#2 - y#2, z#1) == Mul(x#2, z#1) - Mul(y#2, z#1));
  free ensures true;
  free ensures {:id "id9095"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "MulInternals.LemmaMulInductionAutoForall (correctness)"} Impl$$MulInternals.__default.LemmaMulInductionAutoForall(f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id9096"} Lit(MulInternals.__default.MulAuto()) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(LitInt(0)))): bool;
  requires {:id "id9097"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1 + 1))): bool);
  requires {:id "id9098"} Lit(MulInternals.__default.MulAuto()) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(i#3, 0) } GeneralInternals.__default.IsLe(i#3, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 - 1))): bool);
  modifies $Heap;
  free ensures MulInternals.__default.MulAuto#canCall();
  free ensures {:id "id9099"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#3: int, y#3: int :: { Mul(x#3, y#3) } Mul(x#3, y#3) == Mul(y#3, x#3));
  free ensures {:id "id9100"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#4: int, y#4: int, z#2: int :: { Mul(x#4 + y#4, z#2) } Mul(x#4 + y#4, z#2) == Mul(x#4, z#2) + Mul(y#4, z#2));
  free ensures {:id "id9101"} MulInternals.__default.MulAuto#canCall() ==> Lit(MulInternals.__default.MulAuto()) || (forall x#5: int, y#5: int, z#3: int :: { Mul(x#5 - y#5, z#3) } Mul(x#5 - y#5, z#3) == Mul(x#5, z#3) - Mul(y#5, z#3));
  free ensures true;
  free ensures {:id "id9102"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "MulInternals.LemmaMulInductionAutoForall (correctness)"} Impl$$MulInternals.__default.LemmaMulInductionAutoForall(f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#6: int;
  var ##x#2: int;
  var ##y#2: int;
  var i#8: int;
  var ##x#3: int;
  var ##y#3: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulInductionAutoForall", " | ", f#0} true;
    assume {:print "Types", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(136,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulCommutes();
    call CallPost$$MulInternals.__default.LemmaMulCommutes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(137,22)"} true;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(138,25)"} true;
    havoc i#6;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} true;
    ##x#2 := LitInt(0);
    assume $IsAlloc(##x#2, TInt, $Heap);
    ##y#2 := i#6;
    assume $IsAlloc(##y#2, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#6);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#6);
    goto anon3;

  anon12_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#6);
    goto anon3;

  anon3:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#6) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#6))): bool;
    goto anon5;

  anon13_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#6) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#6))): bool);
    goto anon5;

  anon11_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#7));
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } GeneralInternals.__default.IsLe(LitInt(0), i#7) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7 + 1))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(139,70)"} true;
    havoc i#8;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} true;
    ##x#3 := i#8;
    assume $IsAlloc(##x#3, TInt, $Heap);
    ##y#3 := LitInt(0);
    assume $IsAlloc(##y#3, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#8, LitInt(0));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#8, LitInt(0));
    goto anon8;

  anon15_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#8, LitInt(0));
    goto anon8;

  anon8:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#8, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#8))): bool;
    goto anon10;

  anon16_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#8, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#8))): bool);
    goto anon10;

  anon14_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool } GeneralInternals.__default.IsLe#canCall(i#9, LitInt(0)));
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool } GeneralInternals.__default.IsLe(i#9, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 - 1))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(140,70)"} true;
    assume true;
    f##0 := f#0;
    call CallPre$$MulInternals.__default.LemmaMulInduction(f##0);
    call CallPost$$MulInternals.__default.LemmaMulInduction(f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/MulInternals.dfy(141,24)"} true;
    return;
}



procedure {:verboseName "MulInternals.reveal_MulPos (well-formedness)"} {:verify false} CheckWellFormed$$MulInternals.__default.reveal__MulPos();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "MulInternals.reveal_MulPos (call precondtion)"} {:verify false} CallPre$$MulInternals.__default.reveal__MulPos();



procedure {:verboseName "MulInternals.reveal_MulPos (call postcondition)"} {:verify false} CallPost$$MulInternals.__default.reveal__MulPos();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_MulInternals._default.MulPos;



axiom (forall x#0: int, y#0: int :: { GeneralInternals.__default.IsLe(x#0, y#0) } GeneralInternals.__default.IsLe(x#0, y#0) <==> x#0 <= y#0);

axiom (forall x#0: int, y#0: int :: {:weight 3} { GeneralInternals.__default.IsLe(LitInt(x#0), LitInt(y#0)) } GeneralInternals.__default.IsLe(LitInt(x#0), LitInt(y#0)) <==> LitInt(x#0) <= LitInt(y#0));

const unique class.Mul.__default: ClassName;

procedure {:verboseName "Mul.LemmaMulIsMulRecursive (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsMulRecursive(x#0: int, y#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsMulRecursive (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsMulRecursive(x#0: int, y#0: int);



procedure {:verboseName "Mul.LemmaMulIsMulRecursive (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsMulRecursive(x#0: int, y#0: int);
  modifies $Heap;
  free ensures MulInternals.__default.MulRecursive#canCall(x#0, y#0);
  free ensures {:id "id9118"} Mul(x#0, y#0) == MulInternals.__default.MulRecursive(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsMulRecursive (correctness)"} Impl$$Mul.__default.LemmaMulIsMulRecursive(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures MulInternals.__default.MulRecursive#canCall(x#0, y#0);
  free ensures {:id "id9119"} Mul(x#0, y#0) == MulInternals.__default.MulRecursive(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsMulRecursive (correctness)"} Impl$$Mul.__default.LemmaMulIsMulRecursive(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0_0: int;
  var y##0_0: int;
  var x##1_0: int;
  var y##1_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulRecursive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(27,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} x#0 >= LitInt(0);
    push;
    assume true;
    x##0_0 := x#0;
    assume true;
    y##0_0 := y#0;
    call CallPre$$Mul.__default.LemmaMulIsMulPos(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulIsMulPos(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(28,40)"} true;
    pop;
    goto anon3;

  anon7_Else:
    assume {:partition} LitInt(0) > x#0;
    goto anon3;

  anon3:
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} x#0 <= LitInt(0);
    push;
    assume true;
    x##1_0 := 0 - x#0;
    assume true;
    y##1_0 := y#0;
    call CallPre$$Mul.__default.LemmaMulIsMulPos(x##1_0, y##1_0);
    call CallPost$$Mul.__default.LemmaMulIsMulPos(x##1_0, y##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(29,41)"} true;
    pop;
    goto anon6;

  anon8_Else:
    assume {:partition} LitInt(0) < x#0;
    goto anon6;

  anon6:
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(30,18)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsMulRecursiveAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsMulRecursiveAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsMulRecursiveAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsMulRecursiveAuto();



procedure {:verboseName "Mul.LemmaMulIsMulRecursiveAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsMulRecursiveAuto();
  modifies $Heap;
  free ensures (forall x#1: int, y#1: int :: { MulInternals.__default.MulRecursive(x#1, y#1) } MulInternals.__default.MulRecursive#canCall(x#1, y#1));
  free ensures {:id "id9128"} (forall x#1: int, y#1: int :: { MulInternals.__default.MulRecursive(x#1, y#1) } Mul(x#1, y#1) == MulInternals.__default.MulRecursive(x#1, y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsMulRecursiveAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsMulRecursiveAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: int, y#1: int :: { MulInternals.__default.MulRecursive(x#1, y#1) } MulInternals.__default.MulRecursive#canCall(x#1, y#1));
  free ensures {:id "id9129"} (forall x#1: int, y#1: int :: { MulInternals.__default.MulRecursive(x#1, y#1) } Mul(x#1, y#1) == MulInternals.__default.MulRecursive(x#1, y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsMulRecursiveAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsMulRecursiveAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var ##x#0_0: int;
  var ##y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulRecursiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(35,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##x#0_0 := x#0_0;
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##y#0_0 := y#0_0;
    assume $IsAlloc(##y#0_0, TInt, $Heap);
    assume MulInternals.__default.MulRecursive#canCall(x#0_0, y#0_0);
    assume MulInternals.__default.MulRecursive#canCall(x#0_0, y#0_0);
    assume Mul(x#0_0, y#0_0) == MulInternals.__default.MulRecursive(x#0_0, y#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulIsMulRecursive(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulIsMulRecursive(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(39,34)"} true;
    assume Mul(x#0_0, y#0_0) == MulInternals.__default.MulRecursive(x#0_0, y#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int :: { MulInternals.__default.MulRecursive(x#0_1, y#0_1) } Lit(true) ==> Mul(x#0_1, y#0_1) == MulInternals.__default.MulRecursive(x#0_1, y#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(40,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsMulPos (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsMulPos (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##y#0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulPos", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(45,8): initial state"} true;
    assume x#0 >= LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(47,18): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume {:subsumption 0} ##x#0 >= LitInt(0);
    assume ##x#0 >= LitInt(0);
    assume MulInternals.__default.MulPos#canCall(x#0, y#0);
    assume Mul(x#0, y#0) == MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0);
    return;
}



procedure {:verboseName "Mul.LemmaMulIsMulPos (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int);
  requires {:id "id9138"} x#0 >= LitInt(0);



procedure {:verboseName "Mul.LemmaMulIsMulPos (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int);
  modifies $Heap;
  free ensures MulInternals.__default.MulPos#canCall(x#0, y#0);
  free ensures {:id "id9139"} Mul(x#0, y#0) == MulInternals.__default.MulPos($LS($LS($LZ)), reveal_MulInternals._default.MulPos, x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsMulPos (correctness)"} Impl$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9140"} x#0 >= LitInt(0);
  modifies $Heap;
  free ensures MulInternals.__default.MulPos#canCall(x#0, y#0);
  free ensures {:id "id9141"} Mul(x#0, y#0) == MulInternals.__default.MulPos($LS($LS($LZ)), reveal_MulInternals._default.MulPos, x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsMulPos (correctness)"} Impl$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##x#1: int;
  var ##y#1: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulPos", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(48,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: int, $ih#y0#0: int :: $ih#x0#0 >= LitInt(0) && ((0 <= $ih#x0#0 && $ih#x0#0 < x#0) || ($ih#x0#0 == x#0 && 0 <= $ih#y0#0 && $ih#y0#0 < y#0)) ==> Mul($ih#x0#0, $ih#y0#0) == MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, $ih#x0#0, $ih#y0#0));
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.reveal__MulPos();
    call CallPost$$MulInternals.__default.reveal__MulPos();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(49,18)"} true;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} u#0 >= LitInt(0);
    ##x#1 := u#0;
    assume $IsAlloc(##x#1, TInt, $lambdaHeap#0);
    ##y#1 := y#0;
    assume $IsAlloc(##y#1, TInt, $lambdaHeap#0);
    assume {:subsumption 0} ##x#1 >= LitInt(0);
    assume ##x#1 >= LitInt(0);
    assume MulInternals.__default.MulPos#canCall(u#0, y#0);
    goto anon4;

  anon9_Else:
    assume {:partition} LitInt(0) > u#0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> u#0 >= LitInt(0) ==> Mul(u#0, y#0) == MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, u#0, y#0);
    assume u#0 >= LitInt(0) ==> MulInternals.__default.MulPos#canCall(u#0, y#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume (forall $l#0#u#0: int :: $l#0#u#0 >= LitInt(0) ==> MulInternals.__default.MulPos#canCall($l#0#u#0, y#0));
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box($Unbox($l#1#u#0): int >= LitInt(0) ==> Mul($Unbox($l#1#u#0): int, y#0) == MulInternals.__default.MulPos($l#1#ly#0, reveal_MulInternals._default.MulPos, $Unbox($l#1#u#0): int, y#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(50,67)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulBasics (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulBasics(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulBasics (call precondtion)"} CallPre$$Mul.__default.LemmaMulBasics(x#0: int);



procedure {:verboseName "Mul.LemmaMulBasics (call postcondition)"} CallPost$$Mul.__default.LemmaMulBasics(x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9152"} Mul(LitInt(0), x#0) == LitInt(0);
  free ensures true;
  free ensures {:id "id9153"} Mul(x#0, LitInt(0)) == LitInt(0);
  free ensures true;
  free ensures {:id "id9154"} Mul(LitInt(1), x#0) == x#0;
  free ensures true;
  free ensures {:id "id9155"} Mul(x#0, LitInt(1)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulBasics (correctness)"} Impl$$Mul.__default.LemmaMulBasics(x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9156"} Mul(LitInt(0), x#0) == LitInt(0);
  free ensures true;
  free ensures {:id "id9157"} Mul(x#0, LitInt(0)) == LitInt(0);
  free ensures true;
  free ensures {:id "id9158"} Mul(LitInt(1), x#0) == x#0;
  free ensures true;
  free ensures {:id "id9159"} Mul(x#0, LitInt(1)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulBasics (correctness)"} Impl$$Mul.__default.LemmaMulBasics(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulBasics", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(59,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Mul.LemmaMulBasicsAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulBasicsAuto();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulBasicsAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulBasicsAuto();



procedure {:verboseName "Mul.LemmaMulBasicsAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulBasicsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9168"} (forall x#1: int :: { Mul(0, x#1) } Mul(LitInt(0), x#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id9169"} (forall x#3: int :: { Mul(x#3, 0) } Mul(x#3, LitInt(0)) == LitInt(0));
  free ensures true;
  free ensures {:id "id9170"} (forall x#5: int :: { Mul(1, x#5) } Mul(LitInt(1), x#5) == x#5);
  free ensures true;
  free ensures {:id "id9171"} (forall x#7: int :: { Mul(x#7, 1) } Mul(x#7, LitInt(1)) == x#7);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulBasicsAuto (correctness)"} Impl$$Mul.__default.LemmaMulBasicsAuto() returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9172"} (forall x#1: int :: { Mul(0, x#1) } Mul(LitInt(0), x#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id9173"} (forall x#3: int :: { Mul(x#3, 0) } Mul(x#3, LitInt(0)) == LitInt(0));
  free ensures true;
  free ensures {:id "id9174"} (forall x#5: int :: { Mul(1, x#5) } Mul(LitInt(1), x#5) == x#5);
  free ensures true;
  free ensures {:id "id9175"} (forall x#7: int :: { Mul(x#7, 1) } Mul(x#7, LitInt(1)) == x#7);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulBasicsAuto (correctness)"} Impl$$Mul.__default.LemmaMulBasicsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulBasicsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(67,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Mul.LemmaMulNonzero (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulNonzero(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulNonzero (call precondtion)"} CallPre$$Mul.__default.LemmaMulNonzero(x#0: int, y#0: int);



procedure {:verboseName "Mul.LemmaMulNonzero (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonzero(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9177"} Mul(x#0, y#0) != 0 <==> x#0 != 0 && y#0 != 0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulNonzero (correctness)"} Impl$$Mul.__default.LemmaMulNonzero(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9178"} Mul(x#0, y#0) != 0 <==> x#0 != 0 && y#0 != 0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulNonzero (correctness)"} Impl$$Mul.__default.LemmaMulNonzero(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonzero", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(73,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulNonzero(x##0, y##0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulNonzero(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(74,32)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulNonzeroAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulNonzeroAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulNonzeroAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulNonzeroAuto();



procedure {:verboseName "Mul.LemmaMulNonzeroAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonzeroAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9183"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) != 0 <==> x#1 != 0 && y#1 != 0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulNonzeroAuto (correctness)"} Impl$$Mul.__default.LemmaMulNonzeroAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9184"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) != 0 <==> x#1 != 0 && y#1 != 0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulNonzeroAuto (correctness)"} Impl$$Mul.__default.LemmaMulNonzeroAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonzeroAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(80,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} x#0_0 != 0;
    goto anon4;

  anon10_Else:
    assume {:partition} x#0_0 == 0;
    goto anon4;

  anon4:
    assume true;
    assume Mul(x#0_0, y#0_0) != 0 <==> x#0_0 != 0 && y#0_0 != 0;
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulNonzero(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulNonzero(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(84,27)"} true;
    assume Mul(x#0_0, y#0_0) != 0 <==> x#0_0 != 0 && y#0_0 != 0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(x#0_1, y#0_1) } Lit(true) ==> (Mul(x#0_1, y#0_1) != 0 <==> x#0_1 != 0 && y#0_1 != 0));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(85,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulByZeroIsZeroAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulByZeroIsZeroAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulByZeroIsZeroAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulByZeroIsZeroAuto();



procedure {:verboseName "Mul.LemmaMulByZeroIsZeroAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulByZeroIsZeroAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9192"} (forall x#1: int :: { Mul(0, x#1) } { Mul(x#1, 0) } Mul(x#1, LitInt(0)) == Mul(LitInt(0), x#1) && Mul(LitInt(0), x#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulByZeroIsZeroAuto (correctness)"} Impl$$Mul.__default.LemmaMulByZeroIsZeroAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9193"} (forall x#1: int :: { Mul(0, x#1) } { Mul(x#1, 0) } Mul(x#1, LitInt(0)) == Mul(LitInt(0), x#1) && Mul(LitInt(0), x#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulByZeroIsZeroAuto (correctness)"} Impl$$Mul.__default.LemmaMulByZeroIsZeroAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var x##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulByZeroIsZeroAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(91,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0;
    assume true;
    assume true;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Mul(x#0_0, LitInt(0)) == Mul(LitInt(0), x#0_0);
    goto anon4;

  anon10_Else:
    assume {:partition} Mul(x#0_0, LitInt(0)) != Mul(LitInt(0), x#0_0);
    goto anon4;

  anon4:
    assume true;
    assume Mul(x#0_0, LitInt(0)) == Mul(LitInt(0), x#0_0) && Mul(LitInt(0), x#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    call CallPre$$Mul.__default.LemmaMulBasics(x##0_0);
    call CallPost$$Mul.__default.LemmaMulBasics(x##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(95,23)"} true;
    assume Mul(x#0_0, LitInt(0)) == Mul(LitInt(0), x#0_0);
    assume Mul(LitInt(0), x#0_0) == LitInt(0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int :: { Mul(0, x#0_1) } { Mul(x#0_1, 0) } Lit(true) ==> Mul(x#0_1, LitInt(0)) == Mul(LitInt(0), x#0_1) && Mul(LitInt(0), x#0_1) == LitInt(0));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(96,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsAssociative (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsAssociative (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "Mul.LemmaMulIsAssociative (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9201"} Mul(x#0, Mul(y#0, z#0)) == Mul(Mul(x#0, y#0), z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsAssociative (correctness)"} Impl$$Mul.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9202"} Mul(x#0, Mul(y#0, z#0)) == Mul(Mul(x#0, y#0), z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsAssociative (correctness)"} Impl$$Mul.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var z##0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsAssociative", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(102,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    assume true;
    z##0 := z#0;
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x##0, y##0, z##0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x##0, y##0, z##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(103,41)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsAssociativeAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsAssociativeAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsAssociativeAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();



procedure {:verboseName "Mul.LemmaMulIsAssociativeAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9207"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, Mul(y#1, z#1)) } { Mul(Mul(x#1, y#1), z#1) } Mul(x#1, Mul(y#1, z#1)) == Mul(Mul(x#1, y#1), z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsAssociativeAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsAssociativeAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9208"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, Mul(y#1, z#1)) } { Mul(Mul(x#1, y#1), z#1) } Mul(x#1, Mul(y#1, z#1)) == Mul(Mul(x#1, y#1), z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsAssociativeAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsAssociativeAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsAssociativeAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(110,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(x#0_0, Mul(y#0_0, z#0_0)) == Mul(Mul(x#0_0, y#0_0), z#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulIsAssociative(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulIsAssociative(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(114,36)"} true;
    assume Mul(x#0_0, Mul(y#0_0, z#0_0)) == Mul(Mul(x#0_0, y#0_0), z#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(Mul(x#0_1, y#0_1), z#0_1) } { Mul(x#0_1, Mul(y#0_1, z#0_1)) } Lit(true) ==> Mul(x#0_1, Mul(y#0_1, z#0_1)) == Mul(Mul(x#0_1, y#0_1), z#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(115,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsCommutative (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsCommutative(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsCommutative (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsCommutative(x#0: int, y#0: int);



procedure {:verboseName "Mul.LemmaMulIsCommutative (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsCommutative(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9215"} Mul(x#0, y#0) == Mul(y#0, x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsCommutative (correctness)"} Impl$$Mul.__default.LemmaMulIsCommutative(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9216"} Mul(x#0, y#0) == Mul(y#0, x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsCommutative (correctness)"} Impl$$Mul.__default.LemmaMulIsCommutative(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsCommutative", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(121,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsCommutativeAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsCommutativeAuto();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsCommutativeAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();



procedure {:verboseName "Mul.LemmaMulIsCommutativeAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9219"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(y#1, x#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsCommutativeAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsCommutativeAuto() returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9220"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(y#1, x#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsCommutativeAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsCommutativeAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsCommutativeAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(127,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Mul.LemmaMulOrdering (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulOrdering(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulOrdering (call precondtion)"} CallPre$$Mul.__default.LemmaMulOrdering(x#0: int, y#0: int);
  requires {:id "id9226"} x#0 != 0;
  requires {:id "id9227"} y#0 != 0;
  requires {:id "id9228"} LitInt(0) <= Mul(x#0, y#0);



procedure {:verboseName "Mul.LemmaMulOrdering (call postcondition)"} CallPost$$Mul.__default.LemmaMulOrdering(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9229"} Mul(x#0, y#0) >= x#0;
  free ensures {:id "id9230"} Mul(x#0, y#0) >= y#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulOrdering (correctness)"} Impl$$Mul.__default.LemmaMulOrdering(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9231"} x#0 != 0;
  requires {:id "id9232"} y#0 != 0;
  requires {:id "id9233"} LitInt(0) <= Mul(x#0, y#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9234"} Mul(x#0, y#0) >= x#0;
  free ensures {:id "id9235"} Mul(x#0, y#0) >= y#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulOrdering (correctness)"} Impl$$Mul.__default.LemmaMulOrdering(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulOrdering", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(136,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulOrdering(x##0, y##0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulOrdering(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(137,33)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulOrderingAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulOrderingAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulOrderingAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulOrderingAuto();



procedure {:verboseName "Mul.LemmaMulOrderingAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulOrderingAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9243"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } (0 != x#1 && 0 != y#1 && Mul(x#1, y#1) >= LitInt(0) ==> Mul(x#1, y#1) >= x#1) && (0 != x#1 && 0 != y#1 && Mul(x#1, y#1) >= LitInt(0) ==> Mul(x#1, y#1) >= y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulOrderingAuto (correctness)"} Impl$$Mul.__default.LemmaMulOrderingAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9244"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } (0 != x#1 && 0 != y#1 && Mul(x#1, y#1) >= LitInt(0) ==> Mul(x#1, y#1) >= x#1) && (0 != x#1 && 0 != y#1 && Mul(x#1, y#1) >= LitInt(0) ==> Mul(x#1, y#1) >= y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulOrderingAuto (correctness)"} Impl$$Mul.__default.LemmaMulOrderingAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulOrderingAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(144,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, y#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} 0 != x#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} 0 == x#0_0;
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} 0 != x#0_0 && 0 != y#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(0 != x#0_0 && 0 != y#0_0);
    goto anon5;

  anon5:
    assume true;
    assume 0 != x#0_0 && 0 != y#0_0 && Mul(x#0_0, y#0_0) >= LitInt(0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Mul(x#0_0, y#0_0) >= x#0_0;
    goto anon8;

  anon16_Else:
    assume {:partition} x#0_0 > Mul(x#0_0, y#0_0);
    goto anon8;

  anon8:
    assume true;
    assume Mul(x#0_0, y#0_0) >= x#0_0 && Mul(x#0_0, y#0_0) >= y#0_0;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulOrdering(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulOrdering(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(148,28)"} true;
    assume Mul(x#0_0, y#0_0) >= x#0_0;
    assume Mul(x#0_0, y#0_0) >= y#0_0;
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(x#0_1, y#0_1) } 0 != x#0_1 && 0 != y#0_1 && Mul(x#0_1, y#0_1) >= LitInt(0) ==> Mul(x#0_1, y#0_1) >= x#0_1 && Mul(x#0_1, y#0_1) >= y#0_1);
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(149,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulEquality (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulEquality(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulEquality (call precondtion)"} CallPre$$Mul.__default.LemmaMulEquality(x#0: int, y#0: int, z#0: int);
  requires {:id "id9253"} x#0 == y#0;



procedure {:verboseName "Mul.LemmaMulEquality (call postcondition)"} CallPost$$Mul.__default.LemmaMulEquality(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9254"} Mul(x#0, z#0) == Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulEquality (correctness)"} Impl$$Mul.__default.LemmaMulEquality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9255"} x#0 == y#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9256"} Mul(x#0, z#0) == Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulEquality (correctness)"} Impl$$Mul.__default.LemmaMulEquality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEquality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(155,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Mul.LemmaMulEqualityAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulEqualityAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulEqualityAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulEqualityAuto();



procedure {:verboseName "Mul.LemmaMulEqualityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulEqualityAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9261"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } x#1 == y#1 ==> Mul(x#1, z#1) == Mul(y#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulEqualityAuto (correctness)"} Impl$$Mul.__default.LemmaMulEqualityAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9262"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } x#1 == y#1 ==> Mul(x#1, z#1) == Mul(y#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulEqualityAuto (correctness)"} Impl$$Mul.__default.LemmaMulEqualityAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEqualityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(159,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    assume true;
    assume x#0_0 == y#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(x#0_0, z#0_0) == Mul(y#0_0, z#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulEquality(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulEquality(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(163,31)"} true;
    assume Mul(x#0_0, z#0_0) == Mul(y#0_0, z#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(y#0_1, z#0_1), Mul(x#0_1, z#0_1) } x#0_1 == y#0_1 ==> Mul(x#0_1, z#0_1) == Mul(y#0_1, z#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(164,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulInequality (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulInequality(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulInequality (call precondtion)"} CallPre$$Mul.__default.LemmaMulInequality(x#0: int, y#0: int, z#0: int);
  requires {:id "id9271"} x#0 <= y#0;
  requires {:id "id9272"} z#0 >= LitInt(0);



procedure {:verboseName "Mul.LemmaMulInequality (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequality(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9273"} Mul(x#0, z#0) <= Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulInequality (correctness)"} Impl$$Mul.__default.LemmaMulInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9274"} x#0 <= y#0;
  requires {:id "id9275"} z#0 >= LitInt(0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9276"} Mul(x#0, z#0) <= Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulInequality (correctness)"} Impl$$Mul.__default.LemmaMulInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(172,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := z#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} u#0 >= LitInt(0);
    goto anon4;

  anon9_Else:
    assume {:partition} LitInt(0) > u#0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> u#0 >= LitInt(0) ==> Mul(x#0, u#0) <= Mul(y#0, u#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box($Unbox($l#1#u#0): int >= LitInt(0) ==> Mul(x#0, $Unbox($l#1#u#0): int) <= Mul(y#0, $Unbox($l#1#u#0): int))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(173,60)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulInequalityAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulInequalityAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulInequalityAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulInequalityAuto();



procedure {:verboseName "Mul.LemmaMulInequalityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequalityAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9285"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } x#1 <= y#1 && z#1 >= LitInt(0) ==> Mul(x#1, z#1) <= Mul(y#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulInequalityAuto (correctness)"} Impl$$Mul.__default.LemmaMulInequalityAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9286"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } x#1 <= y#1 && z#1 >= LitInt(0) ==> Mul(x#1, z#1) <= Mul(y#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulInequalityAuto (correctness)"} Impl$$Mul.__default.LemmaMulInequalityAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(179,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} x#0_0 <= y#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} y#0_0 < x#0_0;
    goto anon3;

  anon3:
    assume true;
    assume x#0_0 <= y#0_0 && z#0_0 >= LitInt(0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume Mul(x#0_0, z#0_0) <= Mul(y#0_0, z#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(183,33)"} true;
    assume Mul(x#0_0, z#0_0) <= Mul(y#0_0, z#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(y#0_1, z#0_1), Mul(x#0_1, z#0_1) } x#0_1 <= y#0_1 && z#0_1 >= LitInt(0) ==> Mul(x#0_1, z#0_1) <= Mul(y#0_1, z#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(184,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictInequality (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequality (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int);
  requires {:id "id9295"} x#0 < y#0;
  requires {:id "id9296"} z#0 > 0;



procedure {:verboseName "Mul.LemmaMulStrictInequality (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9297"} Mul(x#0, z#0) < Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequality (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9298"} x#0 < y#0;
  requires {:id "id9299"} z#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9300"} Mul(x#0, z#0) < Mul(y#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictInequality (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var z##0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(192,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    assume true;
    z##0 := z#0;
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x##0, y##0, z##0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x##0, y##0, z##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(193,44)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictInequalityAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictInequalityAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequalityAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictInequalityAuto();



procedure {:verboseName "Mul.LemmaMulStrictInequalityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequalityAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9308"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } x#1 < y#1 && z#1 > 0 ==> Mul(x#1, z#1) < Mul(y#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequalityAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequalityAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9309"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } x#1 < y#1 && z#1 > 0 ==> Mul(x#1, z#1) < Mul(y#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictInequalityAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequalityAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(199,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} x#0_0 < y#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} y#0_0 <= x#0_0;
    goto anon3;

  anon3:
    assume true;
    assume x#0_0 < y#0_0 && z#0_0 > 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume Mul(x#0_0, z#0_0) < Mul(y#0_0, z#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulStrictInequality(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulStrictInequality(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(203,39)"} true;
    assume Mul(x#0_0, z#0_0) < Mul(y#0_0, z#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(y#0_1, z#0_1), Mul(x#0_1, z#0_1) } x#0_1 < y#0_1 && z#0_1 > 0 ==> Mul(x#0_1, z#0_1) < Mul(y#0_1, z#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(204,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulUpperBound (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulUpperBound (call precondtion)"} CallPre$$Mul.__default.LemmaMulUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int);
  requires {:id "id9320"} x#0 <= XBound#0;
  requires {:id "id9321"} y#0 <= YBound#0;
  requires {:id "id9322"} LitInt(0) <= x#0;
  requires {:id "id9323"} LitInt(0) <= y#0;



procedure {:verboseName "Mul.LemmaMulUpperBound (call postcondition)"} CallPost$$Mul.__default.LemmaMulUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9324"} Mul(x#0, y#0) <= Mul(XBound#0, YBound#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulUpperBound (correctness)"} Impl$$Mul.__default.LemmaMulUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id9325"} x#0 <= XBound#0;
  requires {:id "id9326"} y#0 <= YBound#0;
  requires {:id "id9327"} LitInt(0) <= x#0;
  requires {:id "id9328"} LitInt(0) <= y#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9329"} Mul(x#0, y#0) <= Mul(XBound#0, YBound#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulUpperBound (correctness)"} Impl$$Mul.__default.LemmaMulUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var z##0: int;
  var x##1: int;
  var y##1: int;
  var z##1: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUpperBound", " | ", x#0, " | ", XBound#0, " | ", y#0, " | ", YBound#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(214,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := XBound#0;
    assume true;
    z##0 := y#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##0, y##0, z##0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##0, y##0, z##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(215,36)"} true;
    assume true;
    x##1 := y#0;
    assume true;
    y##1 := YBound#0;
    assume true;
    z##1 := XBound#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##1, y##1, z##1);
    call CallPost$$Mul.__default.LemmaMulInequality(x##1, y##1, z##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(216,41)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulUpperBoundAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulUpperBoundAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulUpperBoundAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulUpperBoundAuto();



procedure {:verboseName "Mul.LemmaMulUpperBoundAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulUpperBoundAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9341"} (forall YBound#1: int, y#1: int, XBound#1: int, x#1: int :: { Mul(x#1, y#1), Mul(XBound#1, YBound#1) } x#1 <= XBound#1 && y#1 <= YBound#1 && LitInt(0) <= x#1 && LitInt(0) <= y#1 ==> Mul(x#1, y#1) <= Mul(XBound#1, YBound#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulUpperBoundAuto (correctness)"} Impl$$Mul.__default.LemmaMulUpperBoundAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9342"} (forall YBound#1: int, y#1: int, XBound#1: int, x#1: int :: { Mul(x#1, y#1), Mul(XBound#1, YBound#1) } x#1 <= XBound#1 && y#1 <= YBound#1 && LitInt(0) <= x#1 && LitInt(0) <= y#1 ==> Mul(x#1, y#1) <= Mul(XBound#1, YBound#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulUpperBoundAuto (correctness)"} Impl$$Mul.__default.LemmaMulUpperBoundAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var XBound#0_0: int;
  var y#0_0: int;
  var YBound#0_0: int;
  var x##0_0: int;
  var XBound##0_0: int;
  var y##0_0: int;
  var YBound##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUpperBoundAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(222,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, XBound#0_0, y#0_0, YBound#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} x#0_0 <= XBound#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} XBound#0_0 < x#0_0;
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} x#0_0 <= XBound#0_0 && y#0_0 <= YBound#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(x#0_0 <= XBound#0_0 && y#0_0 <= YBound#0_0);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} x#0_0 <= XBound#0_0 && y#0_0 <= YBound#0_0 && LitInt(0) <= x#0_0;
    goto anon7;

  anon15_Else:
    assume {:partition} !(x#0_0 <= XBound#0_0 && y#0_0 <= YBound#0_0 && LitInt(0) <= x#0_0);
    goto anon7;

  anon7:
    assume true;
    assume x#0_0 <= XBound#0_0 && y#0_0 <= YBound#0_0 && LitInt(0) <= x#0_0 && LitInt(0) <= y#0_0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    assume Mul(x#0_0, y#0_0) <= Mul(XBound#0_0, YBound#0_0);
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    XBound##0_0 := XBound#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    YBound##0_0 := YBound#0_0;
    call CallPre$$Mul.__default.LemmaMulUpperBound(x##0_0, XBound##0_0, y##0_0, YBound##0_0);
    call CallPost$$Mul.__default.LemmaMulUpperBound(x##0_0, XBound##0_0, y##0_0, YBound##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(226,46)"} true;
    assume Mul(x#0_0, y#0_0) <= Mul(XBound#0_0, YBound#0_0);
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, XBound#0_1: int, y#0_1: int, YBound#0_1: int :: { Mul(XBound#0_1, YBound#0_1), Mul(x#0_1, y#0_1) } x#0_1 <= XBound#0_1 && y#0_1 <= YBound#0_1 && LitInt(0) <= x#0_1 && LitInt(0) <= y#0_1 ==> Mul(x#0_1, y#0_1) <= Mul(XBound#0_1, YBound#0_1));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(227,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictUpperBound (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictUpperBound (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int);
  requires {:id "id9353"} x#0 < XBound#0;
  requires {:id "id9354"} y#0 < YBound#0;
  requires {:id "id9355"} 0 < x#0;
  requires {:id "id9356"} 0 < y#0;



procedure {:verboseName "Mul.LemmaMulStrictUpperBound (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9357"} Mul(x#0, y#0) <= Mul(XBound#0 - 1, YBound#0 - 1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictUpperBound (correctness)"} Impl$$Mul.__default.LemmaMulStrictUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id9358"} x#0 < XBound#0;
  requires {:id "id9359"} y#0 < YBound#0;
  requires {:id "id9360"} 0 < x#0;
  requires {:id "id9361"} 0 < y#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9362"} Mul(x#0, y#0) <= Mul(XBound#0 - 1, YBound#0 - 1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictUpperBound (correctness)"} Impl$$Mul.__default.LemmaMulStrictUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var z##0: int;
  var x##1: int;
  var y##1: int;
  var z##1: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictUpperBound", " | ", x#0, " | ", XBound#0, " | ", y#0, " | ", YBound#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(237,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := XBound#0 - 1;
    assume true;
    z##0 := y#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##0, y##0, z##0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##0, y##0, z##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(238,40)"} true;
    assume true;
    x##1 := y#0;
    assume true;
    y##1 := YBound#0 - 1;
    assume true;
    z##1 := XBound#0 - 1;
    call CallPre$$Mul.__default.LemmaMulInequality(x##1, y##1, z##1);
    call CallPost$$Mul.__default.LemmaMulInequality(x##1, y##1, z##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(239,49)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictUpperBoundAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictUpperBoundAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictUpperBoundAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictUpperBoundAuto();



procedure {:verboseName "Mul.LemmaMulStrictUpperBoundAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictUpperBoundAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9374"} (forall YBound#1: int, y#1: int, XBound#1: int, x#1: int :: { Mul(x#1, y#1), Mul(XBound#1 - 1, YBound#1 - 1) } x#1 < XBound#1 && y#1 < YBound#1 && 0 < x#1 && 0 < y#1 ==> Mul(x#1, y#1) <= Mul(XBound#1 - 1, YBound#1 - 1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictUpperBoundAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictUpperBoundAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9375"} (forall YBound#1: int, y#1: int, XBound#1: int, x#1: int :: { Mul(x#1, y#1), Mul(XBound#1 - 1, YBound#1 - 1) } x#1 < XBound#1 && y#1 < YBound#1 && 0 < x#1 && 0 < y#1 ==> Mul(x#1, y#1) <= Mul(XBound#1 - 1, YBound#1 - 1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictUpperBoundAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictUpperBoundAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var XBound#0_0: int;
  var y#0_0: int;
  var YBound#0_0: int;
  var x##0_0: int;
  var XBound##0_0: int;
  var y##0_0: int;
  var YBound##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictUpperBoundAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(245,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, XBound#0_0, y#0_0, YBound#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} x#0_0 < XBound#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} XBound#0_0 <= x#0_0;
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} x#0_0 < XBound#0_0 && y#0_0 < YBound#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(x#0_0 < XBound#0_0 && y#0_0 < YBound#0_0);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} x#0_0 < XBound#0_0 && y#0_0 < YBound#0_0 && 0 < x#0_0;
    goto anon7;

  anon15_Else:
    assume {:partition} !(x#0_0 < XBound#0_0 && y#0_0 < YBound#0_0 && 0 < x#0_0);
    goto anon7;

  anon7:
    assume true;
    assume x#0_0 < XBound#0_0 && y#0_0 < YBound#0_0 && 0 < x#0_0 && 0 < y#0_0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    assume Mul(x#0_0, y#0_0) <= Mul(XBound#0_0 - 1, YBound#0_0 - 1);
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    XBound##0_0 := XBound#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    YBound##0_0 := YBound#0_0;
    call CallPre$$Mul.__default.LemmaMulStrictUpperBound(x##0_0, XBound##0_0, y##0_0, YBound##0_0);
    call CallPost$$Mul.__default.LemmaMulStrictUpperBound(x##0_0, XBound##0_0, y##0_0, YBound##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(256,52)"} true;
    assume Mul(x#0_0, y#0_0) <= Mul(XBound#0_0 - 1, YBound#0_0 - 1);
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, XBound#0_1: int, y#0_1: int, YBound#0_1: int :: { Mul(XBound#0_1 - 1, YBound#0_1 - 1), Mul(x#0_1, y#0_1) } { YBound#0_1 - 1, XBound#0_1 - 1, 0 < y#0_1, 0 < x#0_1 } { YBound#0_1 - 1, 0 < y#0_1, x#0_1 < XBound#0_1 } { XBound#0_1 - 1, 0 < x#0_1, y#0_1 < YBound#0_1 } { y#0_1 < YBound#0_1, x#0_1 < XBound#0_1 } x#0_1 < XBound#0_1 && y#0_1 < YBound#0_1 && 0 < x#0_1 && 0 < y#0_1 ==> Mul(x#0_1, y#0_1) <= Mul(XBound#0_1 - 1, YBound#0_1 - 1));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(257,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulLeftInequality (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulLeftInequality(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulLeftInequality (call precondtion)"} CallPre$$Mul.__default.LemmaMulLeftInequality(x#0: int, y#0: int, z#0: int);
  requires {:id "id9388"} 0 < x#0;



procedure {:verboseName "Mul.LemmaMulLeftInequality (call postcondition)"} CallPost$$Mul.__default.LemmaMulLeftInequality(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9389"} y#0 <= z#0 ==> Mul(x#0, y#0) <= Mul(x#0, z#0);
  free ensures true;
  free ensures {:id "id9390"} y#0 < z#0 ==> Mul(x#0, y#0) < Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulLeftInequality (correctness)"} Impl$$Mul.__default.LemmaMulLeftInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9391"} 0 < x#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9392"} y#0 <= z#0 ==> Mul(x#0, y#0) <= Mul(x#0, z#0);
  free ensures true;
  free ensures {:id "id9393"} y#0 < z#0 ==> Mul(x#0, y#0) < Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulLeftInequality (correctness)"} Impl$$Mul.__default.LemmaMulLeftInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var x##1: int;
  var f##1: HandleType;
  var $lambdaHeap#1: Heap;
  var u#1: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulLeftInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(265,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} u#0 > 0;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} y#0 <= z#0;
    goto anon5;

  anon18_Else:
    assume {:partition} z#0 < y#0;
    goto anon5;

  anon17_Else:
    assume {:partition} 0 >= u#0;
    goto anon5;

  anon5:
    assume lambdaResult#0 <==> u#0 > 0 ==> y#0 <= z#0 ==> Mul(u#0, y#0) <= Mul(u#0, z#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon6;

  anon16_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon15_Else:
    goto anon7;

  anon7:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box($Unbox($l#1#u#0): int > 0 ==> y#0 <= z#0 ==> Mul($Unbox($l#1#u#0): int, y#0) <= Mul($Unbox($l#1#u#0): int, z#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(266,70)"} true;
    assume true;
    x##1 := x#0;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc u#1;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} true;
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} u#1 > 0;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} y#0 < z#0;
    goto anon12;

  anon22_Else:
    assume {:partition} z#0 <= y#0;
    goto anon12;

  anon21_Else:
    assume {:partition} 0 >= u#1;
    goto anon12;

  anon12:
    assume lambdaResult#1 <==> u#1 > 0 ==> y#0 < z#0 ==> Mul(u#1, y#0) < Mul(u#1, z#0);
    assume true;
    assume $Is(lambdaResult#1, TBool);
    goto anon13;

  anon20_Else:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume false;
    goto anon14;

  anon19_Else:
    goto anon14;

  anon14:
    assume true;
    f##1 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: $Box($Unbox($l#3#u#0): int > 0 ==> y#0 < z#0 ==> Mul($Unbox($l#3#u#0): int, y#0) < Mul($Unbox($l#3#u#0): int, z#0))), (lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: $IsBox($l#3#u#0, TInt)), (lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##1, f##1);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##1, f##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(267,68)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulLeftInequalityAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulLeftInequalityAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulLeftInequalityAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulLeftInequalityAuto();



procedure {:verboseName "Mul.LemmaMulLeftInequalityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulLeftInequalityAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9405"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1), Mul(x#1, z#1) } (x#1 > 0 ==> y#1 <= z#1 ==> Mul(x#1, y#1) <= Mul(x#1, z#1)) && (x#1 > 0 ==> y#1 < z#1 ==> Mul(x#1, y#1) < Mul(x#1, z#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulLeftInequalityAuto (correctness)"} Impl$$Mul.__default.LemmaMulLeftInequalityAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9406"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1), Mul(x#1, z#1) } (x#1 > 0 ==> y#1 <= z#1 ==> Mul(x#1, y#1) <= Mul(x#1, z#1)) && (x#1 > 0 ==> y#1 < z#1 ==> Mul(x#1, y#1) < Mul(x#1, z#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulLeftInequalityAuto (correctness)"} Impl$$Mul.__default.LemmaMulLeftInequalityAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulLeftInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(273,2): initial state"} true;
    $_reverifyPost := false;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} z#0_0 < y#0_0;
    goto anon3;

  anon16_Else:
    assume {:partition} y#0_0 <= z#0_0;
    goto anon3;

  anon3:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} y#0_0 <= z#0_0 || y#0_0 < z#0_0;
    goto anon5;

  anon17_Else:
    assume {:partition} !(y#0_0 <= z#0_0 || y#0_0 < z#0_0);
    goto anon5;

  anon5:
    assume true;
    assume (y#0_0 <= z#0_0 || y#0_0 < z#0_0) && 0 < x#0_0;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} y#0_0 <= z#0_0;
    goto anon8;

  anon19_Else:
    assume {:partition} z#0_0 < y#0_0;
    goto anon8;

  anon8:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} y#0_0 <= z#0_0 ==> Mul(x#0_0, y#0_0) <= Mul(x#0_0, z#0_0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} y#0_0 < z#0_0;
    goto anon11;

  anon21_Else:
    assume {:partition} z#0_0 <= y#0_0;
    goto anon11;

  anon20_Else:
    assume {:partition} !(y#0_0 <= z#0_0 ==> Mul(x#0_0, y#0_0) <= Mul(x#0_0, z#0_0));
    goto anon11;

  anon11:
    assume true;
    assume (y#0_0 <= z#0_0 ==> Mul(x#0_0, y#0_0) <= Mul(x#0_0, z#0_0)) && (y#0_0 < z#0_0 ==> Mul(x#0_0, y#0_0) < Mul(x#0_0, z#0_0));
    assume false;
    goto anon12;

  anon18_Else:
    goto anon12;

  anon12:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulLeftInequality(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulLeftInequality(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(277,37)"} true;
    assume y#0_0 <= z#0_0 ==> Mul(x#0_0, y#0_0) <= Mul(x#0_0, z#0_0);
    assume y#0_0 < z#0_0 ==> Mul(x#0_0, y#0_0) < Mul(x#0_0, z#0_0);
    assume false;
    goto anon14;

  anon15_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(x#0_1, z#0_1), Mul(x#0_1, y#0_1) } (y#0_1 <= z#0_1 || y#0_1 < z#0_1) && 0 < x#0_1 ==> (y#0_1 <= z#0_1 ==> Mul(x#0_1, y#0_1) <= Mul(x#0_1, z#0_1)) && (y#0_1 < z#0_1 ==> Mul(x#0_1, y#0_1) < Mul(x#0_1, z#0_1)));
    goto anon14;

  anon14:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(278,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulEqualityConverse (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulEqualityConverse(m#0: int, x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulEqualityConverse (call precondtion)"} CallPre$$Mul.__default.LemmaMulEqualityConverse(m#0: int, x#0: int, y#0: int);
  requires {:id "id9416"} m#0 != 0;
  requires {:id "id9417"} Mul(m#0, x#0) == Mul(m#0, y#0);



procedure {:verboseName "Mul.LemmaMulEqualityConverse (call postcondition)"} CallPost$$Mul.__default.LemmaMulEqualityConverse(m#0: int, x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9418"} x#0 == y#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulEqualityConverse (correctness)"} Impl$$Mul.__default.LemmaMulEqualityConverse(m#0: int, x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9419"} m#0 != 0;
  requires {:id "id9420"} Mul(m#0, x#0) == Mul(m#0, y#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9421"} x#0 == y#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulEqualityConverse (correctness)"} Impl$$Mul.__default.LemmaMulEqualityConverse(m#0: int, x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var x##1: int;
  var f##1: HandleType;
  var $lambdaHeap#1: Heap;
  var u#1: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: bool;
  var x##2: int;
  var f##2: HandleType;
  var $lambdaHeap#2: Heap;
  var u#2: int;
  var $_Frame#l2: [ref,Field]bool;
  var lambdaResult#2: bool;
  var x##3: int;
  var f##3: HandleType;
  var $lambdaHeap#3: Heap;
  var u#3: int;
  var $_Frame#l3: [ref,Field]bool;
  var lambdaResult#3: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEqualityConverse", " | ", m#0, " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(287,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := m#0;
    goto anon33_Then, anon33_Else;

  anon33_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} x#0 > y#0;
    goto anon4;

  anon35_Else:
    assume {:partition} y#0 >= x#0;
    goto anon4;

  anon4:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} x#0 > y#0 && 0 < u#0;
    goto anon6;

  anon36_Else:
    assume {:partition} !(x#0 > y#0 && 0 < u#0);
    goto anon6;

  anon6:
    assume lambdaResult#0 <==> x#0 > y#0 && 0 < u#0 ==> Mul(x#0, u#0) > Mul(y#0, u#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon34_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon33_Else:
    goto anon8;

  anon8:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(x#0 > y#0 && 0 < $Unbox($l#1#u#0): int ==> Mul(x#0, $Unbox($l#1#u#0): int) > Mul(y#0, $Unbox($l#1#u#0): int))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(288,67)"} true;
    assume true;
    x##1 := m#0;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc u#1;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} true;
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} x#0 > y#0;
    goto anon12;

  anon39_Else:
    assume {:partition} y#0 >= x#0;
    goto anon12;

  anon12:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} x#0 > y#0 && 0 > u#1;
    goto anon14;

  anon40_Else:
    assume {:partition} !(x#0 > y#0 && 0 > u#1);
    goto anon14;

  anon14:
    assume lambdaResult#1 <==> x#0 > y#0 && 0 > u#1 ==> Mul(x#0, u#1) < Mul(y#0, u#1);
    assume true;
    assume $Is(lambdaResult#1, TBool);
    goto anon15;

  anon38_Else:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume false;
    goto anon16;

  anon37_Else:
    goto anon16;

  anon16:
    assume true;
    f##1 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: $Box(x#0 > y#0 && 0 > $Unbox($l#3#u#0): int ==> Mul(x#0, $Unbox($l#3#u#0): int) < Mul(y#0, $Unbox($l#3#u#0): int))), (lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: $IsBox($l#3#u#0, TInt)), (lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##1, f##1);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##1, f##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(289,67)"} true;
    assume true;
    x##2 := m#0;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    havoc $lambdaHeap#2;
    assume $IsGoodHeap($lambdaHeap#2);
    assume $Heap == $lambdaHeap#2 || $HeapSucc($Heap, $lambdaHeap#2);
    havoc u#2;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} true;
    $_Frame#l2 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#2, $o, alloc)): bool ==> false);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} x#0 < y#0;
    goto anon20;

  anon43_Else:
    assume {:partition} y#0 <= x#0;
    goto anon20;

  anon20:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} x#0 < y#0 && 0 < u#2;
    goto anon22;

  anon44_Else:
    assume {:partition} !(x#0 < y#0 && 0 < u#2);
    goto anon22;

  anon22:
    assume lambdaResult#2 <==> x#0 < y#0 && 0 < u#2 ==> Mul(x#0, u#2) < Mul(y#0, u#2);
    assume true;
    assume $Is(lambdaResult#2, TBool);
    goto anon23;

  anon42_Else:
    assume {:partition} false;
    goto anon23;

  anon23:
    assume false;
    goto anon24;

  anon41_Else:
    goto anon24;

  anon24:
    assume true;
    f##2 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#u#0: Box :: $Box(x#0 < y#0 && 0 < $Unbox($l#5#u#0): int ==> Mul(x#0, $Unbox($l#5#u#0): int) < Mul(y#0, $Unbox($l#5#u#0): int))), (lambda $l#5#heap#0: Heap, $l#5#u#0: Box :: $IsBox($l#5#u#0, TInt)), (lambda $l#5#heap#0: Heap, $l#5#u#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##2, f##2);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##2, f##2);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(290,67)"} true;
    assume true;
    x##3 := m#0;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    havoc $lambdaHeap#3;
    assume $IsGoodHeap($lambdaHeap#3);
    assume $Heap == $lambdaHeap#3 || $HeapSucc($Heap, $lambdaHeap#3);
    havoc u#3;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} true;
    $_Frame#l3 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3, $o, alloc)): bool ==> false);
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} x#0 < y#0;
    goto anon28;

  anon47_Else:
    assume {:partition} y#0 <= x#0;
    goto anon28;

  anon28:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} x#0 < y#0 && 0 > u#3;
    goto anon30;

  anon48_Else:
    assume {:partition} !(x#0 < y#0 && 0 > u#3);
    goto anon30;

  anon30:
    assume lambdaResult#3 <==> x#0 < y#0 && 0 > u#3 ==> Mul(x#0, u#3) > Mul(y#0, u#3);
    assume true;
    assume $Is(lambdaResult#3, TBool);
    goto anon31;

  anon46_Else:
    assume {:partition} false;
    goto anon31;

  anon31:
    assume false;
    goto anon32;

  anon45_Else:
    goto anon32;

  anon32:
    assume true;
    f##3 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#u#0: Box :: $Box(x#0 < y#0 && 0 > $Unbox($l#7#u#0): int ==> Mul(x#0, $Unbox($l#7#u#0): int) > Mul(y#0, $Unbox($l#7#u#0): int))), (lambda $l#7#heap#0: Heap, $l#7#u#0: Box :: $IsBox($l#7#u#0, TInt)), (lambda $l#7#heap#0: Heap, $l#7#u#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##3, f##3);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##3, f##3);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(291,67)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulEqualityConverseAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulEqualityConverseAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulEqualityConverseAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulEqualityConverseAuto();



procedure {:verboseName "Mul.LemmaMulEqualityConverseAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulEqualityConverseAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9438"} (forall m#1: int, x#1: int, y#1: int :: { Mul(m#1, x#1), Mul(m#1, y#1) } m#1 != 0 && Mul(m#1, x#1) == Mul(m#1, y#1) ==> x#1 == y#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulEqualityConverseAuto (correctness)"} Impl$$Mul.__default.LemmaMulEqualityConverseAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9439"} (forall m#1: int, x#1: int, y#1: int :: { Mul(m#1, x#1), Mul(m#1, y#1) } m#1 != 0 && Mul(m#1, x#1) == Mul(m#1, y#1) ==> x#1 == y#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulEqualityConverseAuto (correctness)"} Impl$$Mul.__default.LemmaMulEqualityConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0_0: int;
  var x#0_0: int;
  var y#0_0: int;
  var m##0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEqualityConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(298,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc m#0_0, x#0_0, y#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} m#0_0 != 0;
    goto anon3;

  anon9_Else:
    assume {:partition} m#0_0 == 0;
    goto anon3;

  anon3:
    assume true;
    assume m#0_0 != 0 && Mul(m#0_0, x#0_0) == Mul(m#0_0, y#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume x#0_0 == y#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    m##0_0 := m#0_0;
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulEqualityConverse(m##0_0, x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulEqualityConverse(m##0_0, x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(302,39)"} true;
    assume x#0_0 == y#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall m#0_1: int, x#0_1: int, y#0_1: int :: { Mul(m#0_1, y#0_1), Mul(m#0_1, x#0_1) } m#0_1 != 0 && Mul(m#0_1, x#0_1) == Mul(m#0_1, y#0_1) ==> x#0_1 == y#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(303,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulInequalityConverse (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulInequalityConverse(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulInequalityConverse (call precondtion)"} CallPre$$Mul.__default.LemmaMulInequalityConverse(x#0: int, y#0: int, z#0: int);
  requires {:id "id9448"} Mul(x#0, z#0) <= Mul(y#0, z#0);
  requires {:id "id9449"} z#0 > 0;



procedure {:verboseName "Mul.LemmaMulInequalityConverse (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequalityConverse(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9450"} x#0 <= y#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulInequalityConverse (correctness)"} Impl$$Mul.__default.LemmaMulInequalityConverse(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9451"} Mul(x#0, z#0) <= Mul(y#0, z#0);
  requires {:id "id9452"} z#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9453"} x#0 <= y#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulInequalityConverse (correctness)"} Impl$$Mul.__default.LemmaMulInequalityConverse(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequalityConverse", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(311,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := z#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Mul(x#0, u#0) <= Mul(y#0, u#0);
    goto anon4;

  anon11_Else:
    assume {:partition} Mul(y#0, u#0) < Mul(x#0, u#0);
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Mul(x#0, u#0) <= Mul(y#0, u#0) && u#0 > 0;
    goto anon6;

  anon12_Else:
    assume {:partition} !(Mul(x#0, u#0) <= Mul(y#0, u#0) && u#0 > 0);
    goto anon6;

  anon6:
    assume lambdaResult#0 <==> Mul(x#0, u#0) <= Mul(y#0, u#0) && u#0 > 0 ==> x#0 <= y#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon10_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon9_Else:
    goto anon8;

  anon8:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mul(x#0, $Unbox($l#1#u#0): int) <= Mul(y#0, $Unbox($l#1#u#0): int) && $Unbox($l#1#u#0): int > 0 ==> x#0 <= y#0)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(312,69)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulInequalityConverseAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulInequalityConverseAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulInequalityConverseAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulInequalityConverseAuto();



procedure {:verboseName "Mul.LemmaMulInequalityConverseAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequalityConverseAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9462"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } Mul(x#1, z#1) <= Mul(y#1, z#1) && z#1 > 0 ==> x#1 <= y#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulInequalityConverseAuto (correctness)"} Impl$$Mul.__default.LemmaMulInequalityConverseAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9463"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } Mul(x#1, z#1) <= Mul(y#1, z#1) && z#1 > 0 ==> x#1 <= y#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulInequalityConverseAuto (correctness)"} Impl$$Mul.__default.LemmaMulInequalityConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequalityConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(319,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Mul(x#0_0, z#0_0) <= Mul(y#0_0, z#0_0);
    goto anon3;

  anon9_Else:
    assume {:partition} Mul(y#0_0, z#0_0) < Mul(x#0_0, z#0_0);
    goto anon3;

  anon3:
    assume true;
    assume Mul(x#0_0, z#0_0) <= Mul(y#0_0, z#0_0) && z#0_0 > 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume x#0_0 <= y#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulInequalityConverse(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulInequalityConverse(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(323,41)"} true;
    assume x#0_0 <= y#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(y#0_1, z#0_1), Mul(x#0_1, z#0_1) } Mul(x#0_1, z#0_1) <= Mul(y#0_1, z#0_1) && z#0_1 > 0 ==> x#0_1 <= y#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(324,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverse (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictInequalityConverse(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverse (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictInequalityConverse(x#0: int, y#0: int, z#0: int);
  requires {:id "id9472"} Mul(x#0, z#0) < Mul(y#0, z#0);
  requires {:id "id9473"} z#0 >= LitInt(0);



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverse (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequalityConverse(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9474"} x#0 < y#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverse (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequalityConverse(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9475"} Mul(x#0, z#0) < Mul(y#0, z#0);
  requires {:id "id9476"} z#0 >= LitInt(0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9477"} x#0 < y#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictInequalityConverse (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequalityConverse(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequalityConverse", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(332,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := z#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Mul(x#0, u#0) < Mul(y#0, u#0);
    goto anon4;

  anon11_Else:
    assume {:partition} Mul(y#0, u#0) <= Mul(x#0, u#0);
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Mul(x#0, u#0) < Mul(y#0, u#0) && u#0 >= LitInt(0);
    goto anon6;

  anon12_Else:
    assume {:partition} !(Mul(x#0, u#0) < Mul(y#0, u#0) && u#0 >= LitInt(0));
    goto anon6;

  anon6:
    assume lambdaResult#0 <==> Mul(x#0, u#0) < Mul(y#0, u#0) && u#0 >= LitInt(0) ==> x#0 < y#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon10_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon9_Else:
    goto anon8;

  anon8:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mul(x#0, $Unbox($l#1#u#0): int) < Mul(y#0, $Unbox($l#1#u#0): int) && $Unbox($l#1#u#0): int >= LitInt(0) ==> x#0 < y#0)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(333,68)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverseAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictInequalityConverseAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverseAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictInequalityConverseAuto();



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverseAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequalityConverseAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9486"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } Mul(x#1, z#1) < Mul(y#1, z#1) && z#1 >= LitInt(0) ==> x#1 < y#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictInequalityConverseAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequalityConverseAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9487"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, z#1), Mul(y#1, z#1) } Mul(x#1, z#1) < Mul(y#1, z#1) && z#1 >= LitInt(0) ==> x#1 < y#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictInequalityConverseAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictInequalityConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequalityConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(340,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Mul(x#0_0, z#0_0) < Mul(y#0_0, z#0_0);
    goto anon3;

  anon9_Else:
    assume {:partition} Mul(y#0_0, z#0_0) <= Mul(x#0_0, z#0_0);
    goto anon3;

  anon3:
    assume true;
    assume Mul(x#0_0, z#0_0) < Mul(y#0_0, z#0_0) && z#0_0 >= LitInt(0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume x#0_0 < y#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulStrictInequalityConverse(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulStrictInequalityConverse(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(344,47)"} true;
    assume x#0_0 < y#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mul(y#0_1, z#0_1), Mul(x#0_1, z#0_1) } Mul(x#0_1, z#0_1) < Mul(y#0_1, z#0_1) && z#0_1 >= LitInt(0) ==> x#0_1 < y#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(345,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveAdd (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAdd (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "Mul.LemmaMulIsDistributiveAdd (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9494"} Mul(x#0, y#0 + z#0) == Mul(x#0, y#0) + Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAdd (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9495"} Mul(x#0, y#0 + z#0) == Mul(x#0, y#0) + Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveAdd (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var z##0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAdd", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(351,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    assume true;
    z##0 := z#0;
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0, y##0, z##0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0, y##0, z##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(352,45)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveAddAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveAddAuto();



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAddAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9500"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1 + z#1) } Mul(x#1, y#1 + z#1) == Mul(x#1, y#1) + Mul(x#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAddAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9501"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1 + z#1) } Mul(x#1, y#1 + z#1) == Mul(x#1, y#1) + Mul(x#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveAddAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAddAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAddAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(358,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(x#0_0, y#0_0 + z#0_0) == Mul(x#0_0, y#0_0) + Mul(x#0_0, z#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAdd(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAdd(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(362,40)"} true;
    assume Mul(x#0_0, y#0_0 + z#0_0) == Mul(x#0_0, y#0_0) + Mul(x#0_0, z#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int, _t#0#0_0: int :: { Mul(x#0_1, z#0_1), Mul(x#0_1, y#0_1), Mul(x#0_1, _t#0#0_0) } _t#0#0_0 == y#0_1 + z#0_1 && true ==> Mul(x#0_1, _t#0#0_0) == Mul(x#0_1, y#0_1) + Mul(x#0_1, z#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(363,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWay (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWay (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWay (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9508"} Mul(y#0 + z#0, x#0) == Mul(y#0, x#0) + Mul(z#0, x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWay (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9509"} Mul(y#0 + z#0, x#0) == Mul(y#0, x#0) + Mul(z#0, x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWay (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAddOtherWay", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(369,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(370,18)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWayAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWayAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto();



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWayAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9514"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1 + z#1, x#1) } Mul(y#1 + z#1, x#1) == Mul(y#1, x#1) + Mul(z#1, x#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWayAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9515"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1 + z#1, x#1) } Mul(y#1 + z#1, x#1) == Mul(y#1, x#1) + Mul(z#1, x#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWayAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAddOtherWayAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(375,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(y#0_0 + z#0_0, x#0_0) == Mul(y#0_0, x#0_0) + Mul(z#0_0, x#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(379,48)"} true;
    assume Mul(y#0_0 + z#0_0, x#0_0) == Mul(y#0_0, x#0_0) + Mul(z#0_0, x#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int, _t#0#0_0: int :: { Mul(z#0_1, x#0_1), Mul(y#0_1, x#0_1), Mul(_t#0#0_0, x#0_1) } _t#0#0_0 == y#0_1 + z#0_1 && true ==> Mul(_t#0#0_0, x#0_1) == Mul(y#0_1, x#0_1) + Mul(z#0_1, x#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(380,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveSub (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveSub(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveSub (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveSub(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "Mul.LemmaMulIsDistributiveSub (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveSub(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9522"} Mul(x#0, y#0 - z#0) == Mul(x#0, y#0) - Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveSub (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveSub(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9523"} Mul(x#0, y#0 - z#0) == Mul(x#0, y#0) - Mul(x#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveSub (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveSub(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveSub", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(386,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(387,18)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveSubAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveSubAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveSubAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveSubAuto();



procedure {:verboseName "Mul.LemmaMulIsDistributiveSubAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveSubAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9528"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1 - z#1) } Mul(x#1, y#1 - z#1) == Mul(x#1, y#1) - Mul(x#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveSubAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveSubAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9529"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1 - z#1) } Mul(x#1, y#1 - z#1) == Mul(x#1, y#1) - Mul(x#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveSubAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveSubAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveSubAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(393,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(x#0_0, y#0_0 - z#0_0) == Mul(x#0_0, y#0_0) - Mul(x#0_0, z#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveSub(x##0_0, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulIsDistributiveSub(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(397,40)"} true;
    assume Mul(x#0_0, y#0_0 - z#0_0) == Mul(x#0_0, y#0_0) - Mul(x#0_0, z#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int, _t#0#0_0: int :: { Mul(x#0_1, z#0_1), Mul(x#0_1, y#0_1), Mul(x#0_1, _t#0#0_0) } _t#0#0_0 == y#0_1 - z#0_1 && true ==> Mul(x#0_1, _t#0#0_0) == Mul(x#0_1, y#0_1) - Mul(x#0_1, z#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(398,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributive (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributive(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributive (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributive(x#0: int, y#0: int, z#0: int);



procedure {:verboseName "Mul.LemmaMulIsDistributive (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributive(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9543"} Mul(x#0, y#0 + z#0) == Mul(x#0, y#0) + Mul(x#0, z#0);
  free ensures true;
  free ensures {:id "id9544"} Mul(x#0, y#0 - z#0) == Mul(x#0, y#0) - Mul(x#0, z#0);
  free ensures true;
  free ensures {:id "id9545"} Mul(y#0 + z#0, x#0) == Mul(y#0, x#0) + Mul(z#0, x#0);
  free ensures true;
  free ensures {:id "id9546"} Mul(y#0 - z#0, x#0) == Mul(y#0, x#0) - Mul(z#0, x#0);
  free ensures true;
  free ensures {:id "id9547"} Mul(x#0, y#0 + z#0) == Mul(y#0 + z#0, x#0);
  free ensures true;
  free ensures {:id "id9548"} Mul(x#0, y#0 - z#0) == Mul(y#0 - z#0, x#0);
  free ensures true;
  free ensures {:id "id9549"} Mul(x#0, y#0) == Mul(y#0, x#0);
  free ensures true;
  free ensures {:id "id9550"} Mul(x#0, z#0) == Mul(z#0, x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributive (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributive(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9551"} Mul(x#0, y#0 + z#0) == Mul(x#0, y#0) + Mul(x#0, z#0);
  free ensures true;
  free ensures {:id "id9552"} Mul(x#0, y#0 - z#0) == Mul(x#0, y#0) - Mul(x#0, z#0);
  free ensures true;
  free ensures {:id "id9553"} Mul(y#0 + z#0, x#0) == Mul(y#0, x#0) + Mul(z#0, x#0);
  free ensures true;
  free ensures {:id "id9554"} Mul(y#0 - z#0, x#0) == Mul(y#0, x#0) - Mul(z#0, x#0);
  free ensures true;
  free ensures {:id "id9555"} Mul(x#0, y#0 + z#0) == Mul(y#0 + z#0, x#0);
  free ensures true;
  free ensures {:id "id9556"} Mul(x#0, y#0 - z#0) == Mul(y#0 - z#0, x#0);
  free ensures true;
  free ensures {:id "id9557"} Mul(x#0, y#0) == Mul(y#0, x#0);
  free ensures true;
  free ensures {:id "id9558"} Mul(x#0, z#0) == Mul(z#0, x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributive (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributive(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributive", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(411,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(412,18)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIsDistributiveAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIsDistributiveAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();



procedure {:verboseName "Mul.LemmaMulIsDistributiveAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9569"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1 + z#1) } Mul(x#1, y#1 + z#1) == Mul(x#1, y#1) + Mul(x#1, z#1));
  free ensures true;
  free ensures {:id "id9570"} (forall x#3: int, y#3: int, z#3: int :: { Mul(x#3, y#3 - z#3) } Mul(x#3, y#3 - z#3) == Mul(x#3, y#3) - Mul(x#3, z#3));
  free ensures true;
  free ensures {:id "id9571"} (forall x#5: int, y#5: int, z#5: int :: { Mul(y#5 + z#5, x#5) } Mul(y#5 + z#5, x#5) == Mul(y#5, x#5) + Mul(z#5, x#5));
  free ensures true;
  free ensures {:id "id9572"} (forall x#7: int, y#7: int, z#7: int :: { Mul(y#7 - z#7, x#7) } Mul(y#7 - z#7, x#7) == Mul(y#7, x#7) - Mul(z#7, x#7));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIsDistributiveAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9573"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, y#1 + z#1) } Mul(x#1, y#1 + z#1) == Mul(x#1, y#1) + Mul(x#1, z#1));
  free ensures true;
  free ensures {:id "id9574"} (forall x#3: int, y#3: int, z#3: int :: { Mul(x#3, y#3 - z#3) } Mul(x#3, y#3 - z#3) == Mul(x#3, y#3) - Mul(x#3, z#3));
  free ensures true;
  free ensures {:id "id9575"} (forall x#5: int, y#5: int, z#5: int :: { Mul(y#5 + z#5, x#5) } Mul(y#5 + z#5, x#5) == Mul(y#5, x#5) + Mul(z#5, x#5));
  free ensures true;
  free ensures {:id "id9576"} (forall x#7: int, y#7: int, z#7: int :: { Mul(y#7 - z#7, x#7) } Mul(y#7 - z#7, x#7) == Mul(y#7, x#7) - Mul(z#7, x#7));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIsDistributiveAuto (correctness)"} Impl$$Mul.__default.LemmaMulIsDistributiveAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(421,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAddAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAddAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(422,35)"} true;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(423,35)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(424,31)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictlyPositive (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyPositive (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int);



procedure {:verboseName "Mul.LemmaMulStrictlyPositive (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9586"} 0 < x#0 && 0 < y#0 ==> 0 < Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyPositive (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9587"} 0 < x#0 && 0 < y#0 ==> 0 < Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictlyPositive (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyPositive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(430,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x##0, y##0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(431,41)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictlyPositiveAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictlyPositiveAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyPositiveAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();



procedure {:verboseName "Mul.LemmaMulStrictlyPositiveAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9594"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } 0 < x#1 && 0 < y#1 ==> 0 < Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyPositiveAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyPositiveAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9595"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } 0 < x#1 && 0 < y#1 ==> 0 < Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictlyPositiveAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyPositiveAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyPositiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(437,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < x#0_0 && 0 < y#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume 0 < Mul(x#0_0, y#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositive(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulStrictlyPositive(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(441,35)"} true;
    assume 0 < Mul(x#0_0, y#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(x#0_1, y#0_1) } 0 < x#0_1 && 0 < y#0_1 ==> 0 < Mul(x#0_1, y#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(442,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictlyIncreases (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictlyIncreases(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyIncreases (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictlyIncreases(x#0: int, y#0: int);
  requires {:id "id9604"} 1 < x#0;
  requires {:id "id9605"} 0 < y#0;



procedure {:verboseName "Mul.LemmaMulStrictlyIncreases (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyIncreases(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9606"} y#0 < Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyIncreases (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyIncreases(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9607"} 1 < x#0;
  requires {:id "id9608"} 0 < y#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9609"} y#0 < Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictlyIncreases (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyIncreases(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyIncreases", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(451,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 1 < u#0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 <= 1;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> 1 < u#0 ==> y#0 < Mul(u#0, y#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(1 < $Unbox($l#1#u#0): int ==> y#0 < Mul($Unbox($l#1#u#0): int, y#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(452,54)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulStrictlyIncreasesAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyIncreasesAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulStrictlyIncreasesAuto();



procedure {:verboseName "Mul.LemmaMulStrictlyIncreasesAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9618"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } 1 < x#1 && 0 < y#1 ==> y#1 < Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulStrictlyIncreasesAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyIncreasesAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9619"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } 1 < x#1 && 0 < y#1 ==> y#1 < Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulStrictlyIncreasesAuto (correctness)"} Impl$$Mul.__default.LemmaMulStrictlyIncreasesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyIncreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(459,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 1 < x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 <= 1;
    goto anon3;

  anon3:
    assume true;
    assume 1 < x#0_0 && 0 < y#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume y#0_0 < Mul(x#0_0, y#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulStrictlyIncreases(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulStrictlyIncreases(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(463,37)"} true;
    assume y#0_0 < Mul(x#0_0, y#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(x#0_1, y#0_1) } 1 < x#0_1 && 0 < y#0_1 ==> y#0_1 < Mul(x#0_1, y#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(464,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIncreases (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIncreases(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIncreases (call precondtion)"} CallPre$$Mul.__default.LemmaMulIncreases(x#0: int, y#0: int);
  requires {:id "id9628"} 0 < x#0;
  requires {:id "id9629"} 0 < y#0;



procedure {:verboseName "Mul.LemmaMulIncreases (call postcondition)"} CallPost$$Mul.__default.LemmaMulIncreases(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9630"} y#0 <= Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIncreases (correctness)"} Impl$$Mul.__default.LemmaMulIncreases(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9631"} 0 < x#0;
  requires {:id "id9632"} 0 < y#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9633"} y#0 <= Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIncreases (correctness)"} Impl$$Mul.__default.LemmaMulIncreases(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIncreases", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(473,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < u#0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 <= 0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> 0 < u#0 ==> y#0 <= Mul(u#0, y#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(0 < $Unbox($l#1#u#0): int ==> y#0 <= Mul($Unbox($l#1#u#0): int, y#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(474,55)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulIncreasesAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulIncreasesAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulIncreasesAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulIncreasesAuto();



procedure {:verboseName "Mul.LemmaMulIncreasesAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIncreasesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9641"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } 0 < x#1 && 0 < y#1 ==> y#1 <= Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulIncreasesAuto (correctness)"} Impl$$Mul.__default.LemmaMulIncreasesAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9642"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } 0 < x#1 && 0 < y#1 ==> y#1 <= Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulIncreasesAuto (correctness)"} Impl$$Mul.__default.LemmaMulIncreasesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIncreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(481,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < x#0_0 && 0 < y#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume y#0_0 <= Mul(x#0_0, y#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulIncreases(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulIncreases(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(485,29)"} true;
    assume y#0_0 <= Mul(x#0_0, y#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(x#0_1, y#0_1) } 0 < x#0_1 && 0 < y#0_1 ==> y#0_1 <= Mul(x#0_1, y#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(486,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulNonnegative (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulNonnegative(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulNonnegative (call precondtion)"} CallPre$$Mul.__default.LemmaMulNonnegative(x#0: int, y#0: int);
  requires {:id "id9651"} LitInt(0) <= x#0;
  requires {:id "id9652"} LitInt(0) <= y#0;



procedure {:verboseName "Mul.LemmaMulNonnegative (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonnegative(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9653"} LitInt(0) <= Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulNonnegative (correctness)"} Impl$$Mul.__default.LemmaMulNonnegative(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9654"} LitInt(0) <= x#0;
  requires {:id "id9655"} LitInt(0) <= y#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9656"} LitInt(0) <= Mul(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulNonnegative (correctness)"} Impl$$Mul.__default.LemmaMulNonnegative(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonnegative", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(494,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 ==> LitInt(0) <= Mul(u#0, y#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int ==> LitInt(0) <= Mul($Unbox($l#1#u#0): int, y#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(495,56)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulNonnegativeAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulNonnegativeAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulNonnegativeAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulNonnegativeAuto();



procedure {:verboseName "Mul.LemmaMulNonnegativeAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9665"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } LitInt(0) <= x#1 && LitInt(0) <= y#1 ==> LitInt(0) <= Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulNonnegativeAuto (correctness)"} Impl$$Mul.__default.LemmaMulNonnegativeAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9666"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } LitInt(0) <= x#1 && LitInt(0) <= y#1 ==> LitInt(0) <= Mul(x#1, y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulNonnegativeAuto (correctness)"} Impl$$Mul.__default.LemmaMulNonnegativeAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonnegativeAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(501,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && LitInt(0) <= y#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume LitInt(0) <= Mul(x#0_0, y#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(505,31)"} true;
    assume LitInt(0) <= Mul(x#0_0, y#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mul(x#0_1, y#0_1) } LitInt(0) <= x#0_1 && LitInt(0) <= y#0_1 ==> LitInt(0) <= Mul(x#0_1, y#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(506,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulUnaryNegation (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulUnaryNegation(x#0: int, y#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulUnaryNegation (call precondtion)"} CallPre$$Mul.__default.LemmaMulUnaryNegation(x#0: int, y#0: int);



procedure {:verboseName "Mul.LemmaMulUnaryNegation (call postcondition)"} CallPost$$Mul.__default.LemmaMulUnaryNegation(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9673"} Mul(0 - x#0, y#0) == 0 - Mul(x#0, y#0);
  free ensures {:id "id9674"} 0 - Mul(x#0, y#0) == Mul(x#0, 0 - y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulUnaryNegation (correctness)"} Impl$$Mul.__default.LemmaMulUnaryNegation(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9675"} Mul(0 - x#0, y#0) == 0 - Mul(x#0, y#0);
  free ensures {:id "id9676"} 0 - Mul(x#0, y#0) == Mul(x#0, 0 - y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulUnaryNegation (correctness)"} Impl$$Mul.__default.LemmaMulUnaryNegation(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUnaryNegation", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(512,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Mul(0 - u#0, y#0) == 0 - Mul(u#0, y#0);
    goto anon4;

  anon9_Else:
    assume {:partition} Mul(0 - u#0, y#0) != 0 - Mul(u#0, y#0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> Mul(0 - u#0, y#0) == 0 - Mul(u#0, y#0) && 0 - Mul(u#0, y#0) == Mul(u#0, 0 - y#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mul(0 - $Unbox($l#1#u#0): int, y#0) == 0 - Mul($Unbox($l#1#u#0): int, y#0) && 0 - Mul($Unbox($l#1#u#0): int, y#0) == Mul($Unbox($l#1#u#0): int, 0 - y#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(513,67)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulUnaryNegationAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulUnaryNegationAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulUnaryNegationAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulUnaryNegationAuto();



procedure {:verboseName "Mul.LemmaMulUnaryNegationAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulUnaryNegationAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9682"} (forall x#1: int, y#1: int :: { Mul(0 - x#1, y#1) } { Mul(x#1, 0 - y#1) } Mul(0 - x#1, y#1) == 0 - Mul(x#1, y#1) && 0 - Mul(x#1, y#1) == Mul(x#1, 0 - y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulUnaryNegationAuto (correctness)"} Impl$$Mul.__default.LemmaMulUnaryNegationAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9683"} (forall x#1: int, y#1: int :: { Mul(0 - x#1, y#1) } { Mul(x#1, 0 - y#1) } Mul(0 - x#1, y#1) == 0 - Mul(x#1, y#1) && 0 - Mul(x#1, y#1) == Mul(x#1, 0 - y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulUnaryNegationAuto (correctness)"} Impl$$Mul.__default.LemmaMulUnaryNegationAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUnaryNegationAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(519,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Mul(0 - x#0_0, y#0_0) == 0 - Mul(x#0_0, y#0_0);
    goto anon4;

  anon10_Else:
    assume {:partition} Mul(0 - x#0_0, y#0_0) != 0 - Mul(x#0_0, y#0_0);
    goto anon4;

  anon4:
    assume true;
    assume Mul(0 - x#0_0, y#0_0) == 0 - Mul(x#0_0, y#0_0) && 0 - Mul(x#0_0, y#0_0) == Mul(x#0_0, 0 - y#0_0);
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulUnaryNegation(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulUnaryNegation(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(523,33)"} true;
    assume Mul(0 - x#0_0, y#0_0) == 0 - Mul(x#0_0, y#0_0);
    assume 0 - Mul(x#0_0, y#0_0) == Mul(x#0_0, 0 - y#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, _t#0#0_0: int :: { Mul(x#0_1, y#0_1), Mul(_t#0#0_0, y#0_1) } _t#0#0_0 == 0 - x#0_1 && true ==> Mul(_t#0#0_0, y#0_1) == 0 - Mul(x#0_1, y#0_1)) && (forall x#0_2: int, y#0_2: int, _t#0#0_1: int :: { Mul(x#0_2, _t#0#0_1), Mul(x#0_2, y#0_2) } _t#0#0_1 == 0 - y#0_2 && true ==> 0 - Mul(x#0_2, y#0_2) == Mul(x#0_2, _t#0#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(524,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulCancelsNegatives (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulCancelsNegatives(x#0: int, y#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulCancelsNegatives (call precondtion)"} CallPre$$Mul.__default.LemmaMulCancelsNegatives(x#0: int, y#0: int);



procedure {:verboseName "Mul.LemmaMulCancelsNegatives (call postcondition)"} CallPost$$Mul.__default.LemmaMulCancelsNegatives(x#0: int, y#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9691"} Mul(x#0, y#0) == Mul(0 - x#0, 0 - y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulCancelsNegatives (correctness)"} Impl$$Mul.__default.LemmaMulCancelsNegatives(x#0: int, y#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9692"} Mul(x#0, y#0) == Mul(0 - x#0, 0 - y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulCancelsNegatives (correctness)"} Impl$$Mul.__default.LemmaMulCancelsNegatives(x#0: int, y#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulCancelsNegatives", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(530,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulUnaryNegationAuto();
    call CallPost$$Mul.__default.LemmaMulUnaryNegationAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(531,31)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulCancelsNegativesAuto (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulCancelsNegativesAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulCancelsNegativesAuto (call precondtion)"} CallPre$$Mul.__default.LemmaMulCancelsNegativesAuto();



procedure {:verboseName "Mul.LemmaMulCancelsNegativesAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulCancelsNegativesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9697"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(0 - x#1, 0 - y#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulCancelsNegativesAuto (correctness)"} Impl$$Mul.__default.LemmaMulCancelsNegativesAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9698"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(0 - x#1, 0 - y#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulCancelsNegativesAuto (correctness)"} Impl$$Mul.__default.LemmaMulCancelsNegativesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var x##0_0: int;
  var y##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulCancelsNegativesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(537,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume Mul(x#0_0, y#0_0) == Mul(0 - x#0_0, 0 - y#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    call CallPre$$Mul.__default.LemmaMulCancelsNegatives(x##0_0, y##0_0);
    call CallPost$$Mul.__default.LemmaMulCancelsNegatives(x##0_0, y##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(541,36)"} true;
    assume Mul(x#0_0, y#0_0) == Mul(0 - x#0_0, 0 - y#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, _t#0#0_0: int, _t#1#0_0: int :: { Mul(_t#0#0_0, _t#1#0_0), Mul(x#0_1, y#0_1) } _t#1#0_0 == 0 - y#0_1 && _t#0#0_0 == 0 - x#0_1 && true ==> Mul(x#0_1, y#0_1) == Mul(_t#0#0_0, _t#1#0_0));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(542,4)"} true;
    return;
}



procedure {:verboseName "Mul.LemmaMulProperties (well-formedness)"} CheckWellFormed$$Mul.__default.LemmaMulProperties();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Mul.LemmaMulProperties (call precondtion)"} CallPre$$Mul.__default.LemmaMulProperties();



procedure {:verboseName "Mul.LemmaMulProperties (call postcondition)"} CallPost$$Mul.__default.LemmaMulProperties();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9754"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(y#1, x#1));
  free ensures true;
  free ensures {:id "id9755"} (forall x#3: int :: { Mul(x#3, 1) } { Mul(1, x#3) } Mul(x#3, LitInt(1)) == Mul(LitInt(1), x#3) && Mul(LitInt(1), x#3) == x#3);
  free ensures true;
  free ensures {:id "id9756"} (forall x#5: int, y#3: int, z#1: int :: { Mul(x#5, z#1), Mul(y#3, z#1) } x#5 < y#3 && z#1 > 0 ==> Mul(x#5, z#1) < Mul(y#3, z#1));
  free ensures true;
  free ensures {:id "id9757"} (forall x#7: int, y#5: int, z#3: int :: { Mul(x#7, z#3), Mul(y#5, z#3) } x#7 <= y#5 && z#3 >= LitInt(0) ==> Mul(x#7, z#3) <= Mul(y#5, z#3));
  free ensures true;
  free ensures {:id "id9758"} (forall x#9: int, y#7: int, z#5: int :: { Mul(x#9, y#7 + z#5) } Mul(x#9, y#7 + z#5) == Mul(x#9, y#7) + Mul(x#9, z#5));
  free ensures true;
  free ensures {:id "id9759"} (forall x#11: int, y#9: int, z#7: int :: { Mul(x#11, y#9 - z#7) } Mul(x#11, y#9 - z#7) == Mul(x#11, y#9) - Mul(x#11, z#7));
  free ensures true;
  free ensures {:id "id9760"} (forall x#13: int, y#11: int, z#9: int :: { Mul(y#11 + z#9, x#13) } Mul(y#11 + z#9, x#13) == Mul(y#11, x#13) + Mul(z#9, x#13));
  free ensures true;
  free ensures {:id "id9761"} (forall x#15: int, y#13: int, z#11: int :: { Mul(y#13 - z#11, x#15) } Mul(y#13 - z#11, x#15) == Mul(y#13, x#15) - Mul(z#11, x#15));
  free ensures true;
  free ensures {:id "id9762"} (forall x#17: int, y#15: int, z#13: int :: { Mul(x#17, Mul(y#15, z#13)) } { Mul(Mul(x#17, y#15), z#13) } Mul(x#17, Mul(y#15, z#13)) == Mul(Mul(x#17, y#15), z#13));
  free ensures true;
  free ensures {:id "id9763"} (forall x#19: int, y#17: int :: { Mul(x#19, y#17) } Mul(x#19, y#17) != 0 <==> x#19 != 0 && y#17 != 0);
  free ensures true;
  free ensures {:id "id9764"} (forall x#21: int, y#19: int :: { Mul(x#21, y#19) } LitInt(0) <= x#21 && LitInt(0) <= y#19 ==> LitInt(0) <= Mul(x#21, y#19));
  free ensures true;
  free ensures {:id "id9765"} (forall x#23: int, y#21: int :: { Mul(x#23, y#21) } (0 < x#23 && 0 < y#21 && LitInt(0) <= Mul(x#23, y#21) ==> x#23 <= Mul(x#23, y#21)) && (0 < x#23 && 0 < y#21 && LitInt(0) <= Mul(x#23, y#21) ==> y#21 <= Mul(x#23, y#21)));
  free ensures true;
  free ensures {:id "id9766"} (forall x#25: int, y#23: int :: { Mul(x#25, y#23) } 1 < x#25 && 0 < y#23 ==> y#23 < Mul(x#25, y#23));
  free ensures true;
  free ensures {:id "id9767"} (forall x#27: int, y#25: int :: { Mul(x#27, y#25) } 0 < x#27 && 0 < y#25 ==> y#25 <= Mul(x#27, y#25));
  free ensures true;
  free ensures {:id "id9768"} (forall x#29: int, y#27: int :: { Mul(x#29, y#27) } 0 < x#29 && 0 < y#27 ==> 0 < Mul(x#29, y#27));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Mul.LemmaMulProperties (correctness)"} Impl$$Mul.__default.LemmaMulProperties() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9769"} (forall x#1: int, y#1: int :: { Mul(x#1, y#1) } Mul(x#1, y#1) == Mul(y#1, x#1));
  free ensures true;
  free ensures {:id "id9770"} (forall x#3: int :: { Mul(x#3, 1) } { Mul(1, x#3) } Mul(x#3, LitInt(1)) == Mul(LitInt(1), x#3) && Mul(LitInt(1), x#3) == x#3);
  free ensures true;
  free ensures {:id "id9771"} (forall x#5: int, y#3: int, z#1: int :: { Mul(x#5, z#1), Mul(y#3, z#1) } x#5 < y#3 && z#1 > 0 ==> Mul(x#5, z#1) < Mul(y#3, z#1));
  free ensures true;
  free ensures {:id "id9772"} (forall x#7: int, y#5: int, z#3: int :: { Mul(x#7, z#3), Mul(y#5, z#3) } x#7 <= y#5 && z#3 >= LitInt(0) ==> Mul(x#7, z#3) <= Mul(y#5, z#3));
  free ensures true;
  free ensures {:id "id9773"} (forall x#9: int, y#7: int, z#5: int :: { Mul(x#9, y#7 + z#5) } Mul(x#9, y#7 + z#5) == Mul(x#9, y#7) + Mul(x#9, z#5));
  free ensures true;
  free ensures {:id "id9774"} (forall x#11: int, y#9: int, z#7: int :: { Mul(x#11, y#9 - z#7) } Mul(x#11, y#9 - z#7) == Mul(x#11, y#9) - Mul(x#11, z#7));
  free ensures true;
  free ensures {:id "id9775"} (forall x#13: int, y#11: int, z#9: int :: { Mul(y#11 + z#9, x#13) } Mul(y#11 + z#9, x#13) == Mul(y#11, x#13) + Mul(z#9, x#13));
  free ensures true;
  free ensures {:id "id9776"} (forall x#15: int, y#13: int, z#11: int :: { Mul(y#13 - z#11, x#15) } Mul(y#13 - z#11, x#15) == Mul(y#13, x#15) - Mul(z#11, x#15));
  free ensures true;
  free ensures {:id "id9777"} (forall x#17: int, y#15: int, z#13: int :: { Mul(x#17, Mul(y#15, z#13)) } { Mul(Mul(x#17, y#15), z#13) } Mul(x#17, Mul(y#15, z#13)) == Mul(Mul(x#17, y#15), z#13));
  free ensures true;
  free ensures {:id "id9778"} (forall x#19: int, y#17: int :: { Mul(x#19, y#17) } Mul(x#19, y#17) != 0 <==> x#19 != 0 && y#17 != 0);
  free ensures true;
  free ensures {:id "id9779"} (forall x#21: int, y#19: int :: { Mul(x#21, y#19) } LitInt(0) <= x#21 && LitInt(0) <= y#19 ==> LitInt(0) <= Mul(x#21, y#19));
  free ensures true;
  free ensures {:id "id9780"} (forall x#23: int, y#21: int :: { Mul(x#23, y#21) } (0 < x#23 && 0 < y#21 && LitInt(0) <= Mul(x#23, y#21) ==> x#23 <= Mul(x#23, y#21)) && (0 < x#23 && 0 < y#21 && LitInt(0) <= Mul(x#23, y#21) ==> y#21 <= Mul(x#23, y#21)));
  free ensures true;
  free ensures {:id "id9781"} (forall x#25: int, y#23: int :: { Mul(x#25, y#23) } 1 < x#25 && 0 < y#23 ==> y#23 < Mul(x#25, y#23));
  free ensures true;
  free ensures {:id "id9782"} (forall x#27: int, y#25: int :: { Mul(x#27, y#25) } 0 < x#27 && 0 < y#25 ==> y#25 <= Mul(x#27, y#25));
  free ensures true;
  free ensures {:id "id9783"} (forall x#29: int, y#27: int :: { Mul(x#29, y#27) } 0 < x#29 && 0 < y#27 ==> 0 < Mul(x#29, y#27));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Mul.LemmaMulProperties (correctness)"} Impl$$Mul.__default.LemmaMulProperties() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Mul.LemmaMulProperties"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(562,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulStrictInequalityAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(563,34)"} true;
    call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(564,28)"} true;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(565,32)"} true;
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(566,31)"} true;
    call CallPre$$Mul.__default.LemmaMulOrderingAuto();
    call CallPost$$Mul.__default.LemmaMulOrderingAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(567,26)"} true;
    call CallPre$$Mul.__default.LemmaMulNonzeroAuto();
    call CallPost$$Mul.__default.LemmaMulNonzeroAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(568,25)"} true;
    call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(569,29)"} true;
    call CallPre$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(570,35)"} true;
    call CallPre$$Mul.__default.LemmaMulIncreasesAuto();
    call CallPost$$Mul.__default.LemmaMulIncreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Mul.dfy(571,27)"} true;
    return;
}



axiom (forall $ly: LayerType, x#0: int, y#0: int :: { MulInternals.__default.MulPos($LS($ly), true, x#0, y#0) } MulInternals.__default.MulPos#canCall(x#0, y#0) || x#0 >= LitInt(0) ==> (x#0 != LitInt(0) ==> MulInternals.__default.MulPos#canCall(x#0 - 1, y#0)) && MulInternals.__default.MulPos($LS($ly), true, x#0, y#0) == (if x#0 == LitInt(0) then 0 else y#0 + MulInternals.__default.MulPos($ly, reveal_MulInternals._default.MulPos, x#0 - 1, y#0)));

axiom (forall $ly: LayerType, x#0: int, y#0: int :: {:weight 3} { MulInternals.__default.MulPos($LS($ly), true, LitInt(x#0), LitInt(y#0)) } MulInternals.__default.MulPos#canCall(LitInt(x#0), LitInt(y#0)) || LitInt(x#0) >= LitInt(0) ==> (LitInt(x#0) != LitInt(0) ==> MulInternals.__default.MulPos#canCall(LitInt(x#0 - 1), LitInt(y#0))) && MulInternals.__default.MulPos($LS($ly), true, LitInt(x#0), LitInt(y#0)) == (if LitInt(x#0) == LitInt(0) then 0 else y#0 + MulInternals.__default.MulPos($LS($ly), reveal_MulInternals._default.MulPos, LitInt(x#0 - 1), LitInt(y#0))));

axiom (forall x#0: int, y#0: int :: { MulInternals.__default.MulRecursive(x#0, y#0) } (x#0 >= LitInt(0) ==> MulInternals.__default.MulPos#canCall(x#0, y#0)) && (LitInt(0) > x#0 ==> MulInternals.__default.MulPos#canCall(Mul(LitInt(-1), x#0), y#0)) && MulInternals.__default.MulRecursive(x#0, y#0) == (if x#0 >= LitInt(0) then MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, x#0, y#0) else Mul(LitInt(-1), MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, Mul(LitInt(-1), x#0), y#0))));

axiom (forall x#0: int, y#0: int :: {:weight 3} { MulInternals.__default.MulRecursive(LitInt(x#0), LitInt(y#0)) } (LitInt(x#0) >= LitInt(0) ==> MulInternals.__default.MulPos#canCall(LitInt(x#0), LitInt(y#0))) && (LitInt(0) > LitInt(x#0) ==> MulInternals.__default.MulPos#canCall(LitInt(Mul(LitInt(-1), LitInt(x#0))), LitInt(y#0))) && MulInternals.__default.MulRecursive(LitInt(x#0), LitInt(y#0)) == (if LitInt(x#0) >= LitInt(0) then MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, LitInt(x#0), LitInt(y#0)) else Mul(LitInt(-1), MulInternals.__default.MulPos($LS($LZ), reveal_MulInternals._default.MulPos, LitInt(Mul(LitInt(-1), LitInt(x#0))), LitInt(y#0)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#12: int, y#12: int :: { Mul(x#12, y#12) } Mul(x#12, y#12) == Mul(y#12, x#12)) && (forall x#13: int, y#13: int, z#8: int :: { Mul(x#13 + y#13, z#8) } Mul(x#13 + y#13, z#8) == Mul(x#13, z#8) + Mul(y#13, z#8)) && (forall x#14: int, y#14: int, z#9: int :: { Mul(x#14 - y#14, z#9) } Mul(x#14 - y#14, z#9) == Mul(x#14, z#9) - Mul(y#14, z#9));

axiom MulInternals.__default.MulAuto() <==> (forall x#15: int, y#15: int :: { Mul(x#15, y#15) } Mul(x#15, y#15) == Mul(y#15, x#15)) && (forall x#16: int, y#16: int, z#10: int :: { Mul(x#16 + y#16, z#10) } Mul(x#16 + y#16, z#10) == Mul(x#16, z#10) + Mul(y#16, z#10)) && (forall x#17: int, y#17: int, z#11: int :: { Mul(x#17 - y#17, z#11) } Mul(x#17 - y#17, z#11) == Mul(x#17, z#11) - Mul(y#17, z#11));

const unique class.ModInternalsNonlinear.__default: ClassName;

procedure {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaModOfZeroIsZero", " | ", m#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(17,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(19,18): post-state"} true;
    assume m#0 != 0;
    assume Mod(0, m#0) == LitInt(0);
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (call precondtion)"} CallPre$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int);
  requires {:id "id9823"} 0 < m#0;



procedure {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9824"} Mod(0, m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9825"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9826"} Mod(0, m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaModOfZeroIsZero", " | ", m#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(20,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaFundamentalDivMod", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(24,8): initial state"} true;
    assume d#0 != 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(26,14): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (call precondtion)"} CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int);
  requires {:id "id9831"} d#0 != 0;



procedure {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9832"} x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9833"} d#0 != 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9834"} x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaFundamentalDivMod", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(27,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.Lemma0ModAnything();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.Lemma0ModAnything()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.Lemma0ModAnything"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(31,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(32,12): post-state"} true;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume m#0 > 0;
    assume m#0 != 0;
    assume Mod(0, m#0) == LitInt(0);
    goto anon4;

  anon5_Else:
    assume m#0 > 0 ==> Mod(0, m#0) == LitInt(0);
    goto anon4;

  anon4:
    assume (forall m#1: int :: { Mod(0, m#1) } m#1 > 0 ==> Mod(0, m#1) == LitInt(0));
    return;
}



procedure {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (call precondtion)"} CallPre$$ModInternalsNonlinear.__default.Lemma0ModAnything();



procedure {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.Lemma0ModAnything();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9840"} (forall m#1: int :: { Mod(0, m#1) } m#1 > 0 ==> Mod(0, m#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (correctness)"} Impl$$ModInternalsNonlinear.__default.Lemma0ModAnything() returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9841"} (forall m#1: int :: { Mod(0, m#1) } m#1 > 0 ==> Mod(0, m#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (correctness)"} Impl$$ModInternalsNonlinear.__default.Lemma0ModAnything() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.Lemma0ModAnything"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(33,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaSmallMod (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaSmallMod (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaSmallMod", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(37,8): initial state"} true;
    assume x#0 < m#0;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(40,18): post-state"} true;
    assume m#0 != 0;
    assume Mod(x#0, m#0) == x#0;
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaSmallMod (call precondtion)"} CallPre$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  requires {:id "id9846"} x#0 < m#0;
  requires {:id "id9847"} 0 < m#0;



procedure {:verboseName "ModInternalsNonlinear.LemmaSmallMod (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9848"} Mod(x#0, m#0) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternalsNonlinear.LemmaSmallMod (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9849"} x#0 < m#0;
  requires {:id "id9850"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9851"} Mod(x#0, m#0) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaSmallMod (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaSmallMod", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(41,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaModRange (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaModRange (well-formedness)"} CheckWellFormed$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaModRange", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(45,8): initial state"} true;
    assume m#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(47,14): post-state"} true;
    assume m#0 != 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= Mod(x#0, m#0);
    assume m#0 != 0;
    goto anon3;

  anon4_Else:
    assume {:partition} Mod(x#0, m#0) < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= Mod(x#0, m#0) && Mod(x#0, m#0) < m#0;
    return;
}



procedure {:verboseName "ModInternalsNonlinear.LemmaModRange (call precondtion)"} CallPre$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int);
  requires {:id "id9856"} m#0 > 0;



procedure {:verboseName "ModInternalsNonlinear.LemmaModRange (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9857"} LitInt(0) <= Mod(x#0, m#0);
  free ensures {:id "id9858"} Mod(x#0, m#0) < m#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternalsNonlinear.LemmaModRange (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9859"} m#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9860"} LitInt(0) <= Mod(x#0, m#0);
  free ensures {:id "id9861"} Mod(x#0, m#0) < m#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternalsNonlinear.LemmaModRange (correctness)"} Impl$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaModRange", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternalsNonlinear.dfy(48,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



const unique class.DivInternalsNonlinear.__default: ClassName;

procedure {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaDivOf0", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(17,8): initial state"} true;
    assume d#0 != 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(19,18): post-state"} true;
    assume d#0 != 0;
    assume Div(0, d#0) == LitInt(0);
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (call precondtion)"} CallPre$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int);
  requires {:id "id9865"} d#0 != 0;



procedure {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9866"} Div(0, d#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9867"} d#0 != 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9868"} Div(0, d#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaDivOf0", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(20,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaDivBySelf", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(24,8): initial state"} true;
    assume d#0 != 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(26,18): post-state"} true;
    assume d#0 != 0;
    assume Div(d#0, d#0) == LitInt(1);
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (call precondtion)"} CallPre$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int);
  requires {:id "id9872"} d#0 != 0;



procedure {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9873"} Div(d#0, d#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9874"} d#0 != 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9875"} Div(d#0, d#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaDivBySelf", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(27,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaSmallDiv();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaSmallDiv()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0: int;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaSmallDiv"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(31,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(32,12): post-state"} true;
    havoc d#0;
    havoc x#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon8_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < d#0;
    assume d#0 > 0;
    assume d#0 != 0;
    assume Div(x#0, d#0) == LitInt(0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= x#0 && x#0 < d#0 && d#0 > 0 ==> Div(x#0, d#0) == LitInt(0);
    goto anon6;

  anon6:
    assume (forall d#1: int, x#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && x#1 < d#1 && d#1 > 0 ==> Div(x#1, d#1) == LitInt(0));
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (call precondtion)"} CallPre$$DivInternalsNonlinear.__default.LemmaSmallDiv();



procedure {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaSmallDiv();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9882"} (forall d#1: int, x#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && x#1 < d#1 && d#1 > 0 ==> Div(x#1, d#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaSmallDiv() returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9883"} (forall d#1: int, x#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && x#1 < d#1 && d#1 > 0 ==> Div(x#1, d#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaSmallDiv() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaSmallDiv"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(33,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (well-formedness)"} CheckWellFormed$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaRealDivGt", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "real", " | ", "real"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(38,8): initial state"} true;
    assume x#0 > y#0;
    assume x#0 >= LitReal(0e0);
    assume y#0 > 0e0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(42,19): post-state"} true;
    assume y#0 != 0e0;
    assume x#0 / y#0 > Real(LitInt(1));
    return;
}



procedure {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (call precondtion)"} CallPre$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real);
  requires {:id "id9889"} x#0 > y#0;
  requires {:id "id9890"} x#0 >= LitReal(0e0);
  requires {:id "id9891"} y#0 > 0e0;



procedure {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9892"} x#0 / y#0 > Real(LitInt(1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9893"} x#0 > y#0;
  requires {:id "id9894"} x#0 >= LitReal(0e0);
  requires {:id "id9895"} y#0 > 0e0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9896"} x#0 / y#0 > Real(LitInt(1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (correctness)"} Impl$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaRealDivGt", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "real", " | ", "real"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternalsNonlinear.dfy(43,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



const reveal_ModInternals._default.ModRecursive: bool;

const unique class.ModInternals.__default: ClassName;

function ModInternals.__default.ModRecursive($ly: LayerType, $reveal: bool, x#0: int, d#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: int, d#0: int :: { ModInternals.__default.ModRecursive($LS($ly), true, x#0, d#0) } ModInternals.__default.ModRecursive#canCall(x#0, d#0) || (0 < $FunctionContextHeight && d#0 > 0) ==> (x#0 < 0 ==> ModInternals.__default.ModRecursive#canCall(d#0 + x#0, d#0)) && (0 <= x#0 ==> d#0 <= x#0 ==> ModInternals.__default.ModRecursive#canCall(x#0 - d#0, d#0)) && ModInternals.__default.ModRecursive($LS($ly), true, x#0, d#0) == (if x#0 < 0 then ModInternals.__default.ModRecursive($ly, reveal_ModInternals._default.ModRecursive, d#0 + x#0, d#0) else (if x#0 < d#0 then x#0 else ModInternals.__default.ModRecursive($ly, reveal_ModInternals._default.ModRecursive, x#0 - d#0, d#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: int, d#0: int :: {:weight 3} { ModInternals.__default.ModRecursive($LS($ly), true, LitInt(x#0), LitInt(d#0)) } ModInternals.__default.ModRecursive#canCall(LitInt(x#0), LitInt(d#0)) || (0 < $FunctionContextHeight && Lit(d#0 > 0)) ==> (Lit(x#0 < 0) ==> ModInternals.__default.ModRecursive#canCall(LitInt(d#0 + x#0), LitInt(d#0))) && (!Lit(x#0 < 0) ==> !Lit(x#0 < d#0) ==> ModInternals.__default.ModRecursive#canCall(LitInt(x#0 - d#0), LitInt(d#0))) && ModInternals.__default.ModRecursive($LS($ly), true, LitInt(x#0), LitInt(d#0)) == (if x#0 < 0 then ModInternals.__default.ModRecursive($LS($ly), reveal_ModInternals._default.ModRecursive, LitInt(d#0 + x#0), LitInt(d#0)) else (if x#0 < d#0 then x#0 else ModInternals.__default.ModRecursive($LS($ly), reveal_ModInternals._default.ModRecursive, LitInt(x#0 - d#0), LitInt(d#0)))));
}

function ModInternals.__default.ModRecursive#canCall(x#0: int, d#0: int) : bool;

axiom (forall $ly: LayerType, $reveal: bool, x#0: int, d#0: int :: { ModInternals.__default.ModRecursive($LS($ly), $reveal, x#0, d#0) } ModInternals.__default.ModRecursive($LS($ly), $reveal, x#0, d#0) == ModInternals.__default.ModRecursive($ly, $reveal, x#0, d#0));

axiom (forall $ly: LayerType, $reveal: bool, x#0: int, d#0: int :: { ModInternals.__default.ModRecursive(AsFuelBottom($ly), $reveal, x#0, d#0) } ModInternals.__default.ModRecursive($ly, $reveal, x#0, d#0) == ModInternals.__default.ModRecursive($LZ, $reveal, x#0, d#0));

function ModInternals.__default.ModRecursive#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, x#0: int, d#0: int :: { ModInternals.__default.ModRecursive#requires($ly, x#0, d#0) } ModInternals.__default.ModRecursive#requires($ly, x#0, d#0) <==> d#0 > 0);

procedure {:verboseName "ModInternals.ModRecursive (well-formedness)"} CheckWellformed$$ModInternals.__default.ModRecursive(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.ModRecursive (well-formedness)"} CheckWellformed$$ModInternals.__default.ModRecursive(x#0: int, d#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##d#0: int;
  var ##x#1: int;
  var ##d#1: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.ModRecursive", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(37,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume d#0 > 0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#0 < 0;
    goto anon4;

  anon11_Else:
    assume {:partition} 0 <= x#0;
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} x#0 < 0;
    ##x#0 := d#0 + x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 > 0;
    assume ##d#0 > 0;
    assume 0 <= (if x#0 < 0 then d#0 - x#0 else x#0) || (if ##x#0 < 0 then ##d#0 - ##x#0 else ##x#0) == (if x#0 < 0 then d#0 - x#0 else x#0);
    assume (if ##x#0 < 0 then ##d#0 - ##x#0 else ##x#0) < (if x#0 < 0 then d#0 - x#0 else x#0);
    assume ModInternals.__default.ModRecursive#canCall(d#0 + x#0, d#0);
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0) == ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, d#0 + x#0, d#0);
    assume ModInternals.__default.ModRecursive#canCall(d#0 + x#0, d#0);
    assume $Is(ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0), TInt);
    return;

  anon13_Else:
    assume {:partition} 0 <= x#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} x#0 < d#0;
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0) == x#0;
    assume true;
    assume $Is(ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0), TInt);
    return;

  anon14_Else:
    assume {:partition} d#0 <= x#0;
    ##x#1 := x#0 - d#0;
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##d#1 := d#0;
    assume $IsAlloc(##d#1, TInt, $Heap);
    assume {:subsumption 0} ##d#1 > 0;
    assume ##d#1 > 0;
    assume 0 <= (if x#0 < 0 then d#0 - x#0 else x#0) || (if ##x#1 < 0 then ##d#1 - ##x#1 else ##x#1) == (if x#0 < 0 then d#0 - x#0 else x#0);
    assume (if ##x#1 < 0 then ##d#1 - ##x#1 else ##x#1) < (if x#0 < 0 then d#0 - x#0 else x#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0 - d#0, d#0);
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0) == ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0 - d#0, d#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0 - d#0, d#0);
    assume $Is(ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0), TInt);
    return;
}



procedure {:verboseName "ModInternals.LemmaModInductionForall (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModInductionForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ModInternals.LemmaModInductionForall (call precondtion)"} CallPre$$ModInternals.__default.LemmaModInductionForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id9924"} n#0 > 0;
  requires {:id "id9925"} (forall i#1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool } LitInt(0) <= i#1 && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id9926"} (forall i#3: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool } i#3 >= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id9927"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool } i#5 < n#0 && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);



procedure {:verboseName "ModInternals.LemmaModInductionForall (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9928"} (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModInductionForall (correctness)"} Impl$$ModInternals.__default.LemmaModInductionForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id9929"} n#0 > 0;
  requires {:id "id9930"} (forall i#1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool } LitInt(0) <= i#1 && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id9931"} (forall i#3: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool } i#3 >= LitInt(0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id9932"} (forall i#5: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool } i#5 < n#0 && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9933"} (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModInductionForall (correctness)"} Impl$$ModInternals.__default.LemmaModInductionForall(n#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0_0: int;
  var n##0_0: int;
  var f##0_0: HandleType;
  var x##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(56,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc i#0_0;
    assume true;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0))): bool;
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    n##0_0 := n#0;
    assume true;
    f##0_0 := f#0;
    assume true;
    x##0_0 := i#0_0;
    call CallPre$$GeneralInternals.__default.LemmaInductionHelper(n##0_0, f##0_0, x##0_0);
    call CallPost$$GeneralInternals.__default.LemmaInductionHelper(n##0_0, f##0_0, x##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(57,57)"} true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0))): bool;
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall i#0_1: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1))): bool } Lit(true) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1))): bool);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(57,59)"} true;
    return;
}



procedure {:verboseName "ModInternals.LemmaModInductionForall2 (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModInductionForall2(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ModInternals.LemmaModInductionForall2 (call precondtion)"} CallPre$$ModInternals.__default.LemmaModInductionForall2(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool), $Heap));
  requires {:id "id9967"} n#0 > 0;
  requires {:id "id9968"} (forall i#1: int, j#1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#1), $Box(j#1))): bool } LitInt(0) <= i#1 && i#1 < n#0 && LitInt(0) <= j#1 && j#1 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#1), $Box(j#1))): bool);
  requires {:id "id9969"} (forall i#3: int, j#3: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3), $Box(j#3))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3 + n#0), $Box(j#3))): bool } i#3 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3), $Box(j#3))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3 + n#0), $Box(j#3))): bool);
  requires {:id "id9970"} (forall i#5: int, j#5: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5 + n#0))): bool } j#5 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5 + n#0))): bool);
  requires {:id "id9971"} (forall i#7: int, j#7: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7), $Box(j#7))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7 - n#0), $Box(j#7))): bool } i#7 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7), $Box(j#7))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7 - n#0), $Box(j#7))): bool);
  requires {:id "id9972"} (forall i#9: int, j#9: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9 - n#0))): bool } j#9 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9 - n#0))): bool);



procedure {:verboseName "ModInternals.LemmaModInductionForall2 (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionForall2(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9973"} (forall i#11: int, j#11: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#11), $Box(j#11))): bool } $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#11), $Box(j#11))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModInductionForall2 (correctness)"} Impl$$ModInternals.__default.LemmaModInductionForall2(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id9974"} n#0 > 0;
  requires {:id "id9975"} (forall i#1: int, j#1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#1), $Box(j#1))): bool } LitInt(0) <= i#1 && i#1 < n#0 && LitInt(0) <= j#1 && j#1 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#1), $Box(j#1))): bool);
  requires {:id "id9976"} (forall i#3: int, j#3: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3), $Box(j#3))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3 + n#0), $Box(j#3))): bool } i#3 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3), $Box(j#3))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#3 + n#0), $Box(j#3))): bool);
  requires {:id "id9977"} (forall i#5: int, j#5: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5 + n#0))): bool } j#5 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#5), $Box(j#5 + n#0))): bool);
  requires {:id "id9978"} (forall i#7: int, j#7: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7), $Box(j#7))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7 - n#0), $Box(j#7))): bool } i#7 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7), $Box(j#7))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#7 - n#0), $Box(j#7))): bool);
  requires {:id "id9979"} (forall i#9: int, j#9: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9 - n#0))): bool } j#9 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#9), $Box(j#9 - n#0))): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id9980"} (forall i#11: int, j#11: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#11), $Box(j#11))): bool } $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#11), $Box(j#11))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModInductionForall2 (correctness)"} Impl$$ModInternals.__default.LemmaModInductionForall2(n#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var i#0_0_0: int;
  var fj#0_0_0: HandleType where $Is(fj#0_0_0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(fj#0_0_0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0_0_0: Heap;
  var j#0_0_0: int;
  var $_Frame#l0_0_0: [ref,Field]bool;
  var lambdaResult#0_0_0: bool;
  var n##0_0_0: int;
  var f##0_0_0: HandleType;
  var fi#0_0: HandleType where $Is(fi#0_0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(fi#0_0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0_0: Heap;
  var i#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: bool;
  var n##0_0: int;
  var f##0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionForall2", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(70,2): initial state"} true;
    $_reverifyPost := false;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume true;
    assume $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(x#0_0), $Box(y#0_0))): bool;
    assume false;
    goto anon3;

  anon22_Else:
    goto anon3;

  anon3:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc i#0_0_0;
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} LitInt(0) <= i#0_0_0;
    goto anon6;

  anon24_Else:
    assume {:partition} i#0_0_0 < LitInt(0);
    goto anon6;

  anon6:
    assume true;
    assume LitInt(0) <= i#0_0_0 && i#0_0_0 < n#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume true;
    assume $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#0_0_0), $Box(y#0_0))): bool;
    assume false;
    goto anon8;

  anon25_Else:
    goto anon8;

  anon8:
    push;
    assume true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    havoc $lambdaHeap#0_0_0;
    assume $IsGoodHeap($lambdaHeap#0_0_0);
    assume $Heap == $lambdaHeap#0_0_0 || $HeapSucc($Heap, $lambdaHeap#0_0_0);
    havoc j#0_0_0;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} true;
    $_Frame#l0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0_0, $o, alloc)): bool ==> false);
    assume lambdaResult#0_0_0 <==> $Unbox(Apply2(TInt, TInt, TBool, $lambdaHeap#0_0_0, f#0, $Box(i#0_0_0), $Box(j#0_0_0))): bool;
    assume true;
    assume $Is(lambdaResult#0_0_0, TBool);
    goto anon11;

  anon27_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    assume false;
    goto anon12;

  anon26_Else:
    goto anon12;

  anon12:
    assume true;
    fj#0_0_0 := Lit(AtLayer((lambda $l#0_0_1#ly#0: LayerType :: Handle1((lambda $l#0_0_1#heap#0: Heap, $l#0_0_1#j#0: Box :: $Box($Unbox(Apply2(TInt, TInt, TBool, $l#0_0_1#heap#0, f#0, $Box(i#0_0_0), $Box($Unbox($l#0_0_1#j#0): int))): bool)), (lambda $l#0_0_1#heap#0: Heap, $l#0_0_1#j#0: Box :: $IsBox($l#0_0_1#j#0, TInt)), (lambda $l#0_0_1#heap#0: Heap, $l#0_0_1#j#0: Box :: SetRef_to_SetBox((lambda $l#0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(77,30)"} true;
    assume true;
    n##0_0_0 := n#0;
    assume true;
    f##0_0_0 := fj#0_0_0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall(n##0_0_0, f##0_0_0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall(n##0_0_0, f##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(78,38)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, fj#0_0_0, $Box(y#0_0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(79,20)"} true;
    pop;
    assume $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#0_0_0), $Box(y#0_0))): bool;
    assume false;
    goto anon14;

  anon23_Else:
    assume (forall i#0_0_1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#0_0_1), $Box(y#0_0))): bool } LitInt(0) <= i#0_0_1 && i#0_0_1 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(i#0_0_1), $Box(y#0_0))): bool);
    goto anon14;

  anon14:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(80,6)"} true;
    assume true;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc i#0_0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    assume lambdaResult#0_0 <==> $Unbox(Apply2(TInt, TInt, TBool, $lambdaHeap#0_0, f#0, $Box(i#0_0), $Box(y#0_0))): bool;
    assume true;
    assume $Is(lambdaResult#0_0, TBool);
    goto anon17;

  anon29_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume false;
    goto anon18;

  anon28_Else:
    goto anon18;

  anon18:
    assume true;
    fi#0_0 := Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $Box($Unbox(Apply2(TInt, TInt, TBool, $l#0_1#heap#0, f#0, $Box($Unbox($l#0_1#i#0): int), $Box(y#0_0))): bool)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $IsBox($l#0_1#i#0, TInt)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(81,28)"} true;
    assume true;
    n##0_0 := n#0;
    assume true;
    f##0_0 := fi#0_0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall(n##0_0, f##0_0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall(n##0_0, f##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(82,36)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, fi#0_0, $Box(x#0_0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(83,18)"} true;
    assume $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(x#0_0), $Box(y#0_0))): bool;
    assume false;
    goto anon20;

  anon21_Else:
    assume (forall x#0_1: int, y#0_1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(x#0_1), $Box(y#0_1))): bool } Lit(true) ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0, $Box(x#0_1), $Box(y#0_1))): bool);
    goto anon20;

  anon20:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(84,4)"} true;
    return;
}



procedure {:verboseName "ModInternals.LemmaDivAddDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaDivAddDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaDivAddDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(89,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(91,24): post-state"} true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
    return;
}



procedure {:verboseName "ModInternals.LemmaDivAddDenominator (call precondtion)"} CallPre$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int);
  requires {:id "id10001"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaDivAddDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10002"} Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaDivAddDenominator (correctness)"} Impl$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10003"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10004"} Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaDivAddDenominator (correctness)"} Impl$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;
  var x##1: int;
  var d##1: int;
  var zp#0: int;
  var x##1_0_0: int;
  var y##1_0_0: int;
  var z##1_0_0: int;
  var x##2_0_0: int;
  var y##2_0_0: int;
  var z##2_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaDivAddDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(92,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(93,32)"} true;
    assume true;
    x##1 := x#0 + n#0;
    assume true;
    d##1 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(94,36)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume x#0 + n#0 == Mul(n#0, Div(x#0 + n#0, n#0)) + Mod(x#0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(95,53)"} true;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume true;
    zp#0 := Div(x#0 + n#0, n#0) - Div(x#0, n#0) - 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(96,37)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    push;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(97,75)"} true;
    pop;
    assume LitInt(0) == Mul(n#0, zp#0) + Mod(x#0 + n#0, n#0) - Mod(x#0, n#0);
    assume false;
    goto anon2;

  anon12_Else:
    goto anon2;

  anon2:
    assume LitInt(0) == Mul(n#0, zp#0) + Mod(x#0 + n#0, n#0) - Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(97,77)"} true;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} zp#0 > 0;
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    push;
    assume true;
    x##1_0_0 := LitInt(1);
    assume true;
    y##1_0_0 := zp#0;
    assume true;
    z##1_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(100,36)"} true;
    assume true;
    assume n#0 <= Mul(zp#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(101,26)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(102,21)"} true;
    pop;
    assume Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
    assume false;
    goto anon5;

  anon14_Else:
    goto anon5;

  anon5:
    assume Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(103,6)"} true;
    pop;
    goto anon7;

  anon13_Else:
    assume {:partition} 0 >= zp#0;
    goto anon7;

  anon7:
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} zp#0 < 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    x##2_0_0 := zp#0;
    assume true;
    y##2_0_0 := LitInt(-1);
    assume true;
    z##2_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(107,37)"} true;
    assume true;
    assume Mul(zp#0, n#0) <= 0 - n#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(108,27)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(109,21)"} true;
    assume Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
    assume false;
    goto anon10;

  anon16_Else:
    goto anon10;

  anon10:
    assume Div(x#0 + n#0, n#0) == Div(x#0, n#0) + 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(110,6)"} true;
    return;

  anon15_Else:
    assume {:partition} 0 <= zp#0;
    return;
}



procedure {:verboseName "ModInternals.LemmaDivSubDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaDivSubDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaDivSubDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(114,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(116,24): post-state"} true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
    return;
}



procedure {:verboseName "ModInternals.LemmaDivSubDenominator (call precondtion)"} CallPre$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int);
  requires {:id "id10041"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaDivSubDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10042"} Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaDivSubDenominator (correctness)"} Impl$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10043"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10044"} Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaDivSubDenominator (correctness)"} Impl$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;
  var x##1: int;
  var d##1: int;
  var zm#0: int;
  var x##1_0_0: int;
  var y##1_0_0: int;
  var z##1_0_0: int;
  var x##2_0_0: int;
  var y##2_0_0: int;
  var z##2_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaDivSubDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(117,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(118,32)"} true;
    assume true;
    x##1 := x#0 - n#0;
    assume true;
    d##1 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(119,36)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume x#0 - n#0 == Mul(n#0, Div(x#0 - n#0, n#0)) + Mod(x#0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(120,53)"} true;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume true;
    zm#0 := Div(x#0 - n#0, n#0) - Div(x#0, n#0) + 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(121,37)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    push;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(122,75)"} true;
    pop;
    assume LitInt(0) == Mul(n#0, zm#0) + Mod(x#0 - n#0, n#0) - Mod(x#0, n#0);
    assume false;
    goto anon2;

  anon12_Else:
    goto anon2;

  anon2:
    assume LitInt(0) == Mul(n#0, zm#0) + Mod(x#0 - n#0, n#0) - Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(122,77)"} true;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} zm#0 > 0;
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    push;
    assume true;
    x##1_0_0 := LitInt(1);
    assume true;
    y##1_0_0 := zm#0;
    assume true;
    z##1_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(125,36)"} true;
    assume true;
    assume n#0 <= Mul(zm#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(126,26)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(127,21)"} true;
    pop;
    assume Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
    assume false;
    goto anon5;

  anon14_Else:
    goto anon5;

  anon5:
    assume Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(128,6)"} true;
    pop;
    goto anon7;

  anon13_Else:
    assume {:partition} 0 >= zm#0;
    goto anon7;

  anon7:
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} zm#0 < 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    x##2_0_0 := zm#0;
    assume true;
    y##2_0_0 := LitInt(-1);
    assume true;
    z##2_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(132,37)"} true;
    assume true;
    assume n#0 <= Mul(zm#0, 0 - n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(133,27)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(134,21)"} true;
    assume Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
    assume false;
    goto anon10;

  anon16_Else:
    goto anon10;

  anon10:
    assume Div(x#0 - n#0, n#0) == Div(x#0, n#0) - 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(135,6)"} true;
    return;

  anon15_Else:
    assume {:partition} 0 <= zm#0;
    return;
}



procedure {:verboseName "ModInternals.LemmaModAddDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModAddDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModAddDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(140,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(142,24): post-state"} true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
    return;
}



procedure {:verboseName "ModInternals.LemmaModAddDenominator (call precondtion)"} CallPre$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int);
  requires {:id "id10081"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaModAddDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10082"} Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModAddDenominator (correctness)"} Impl$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10083"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10084"} Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModAddDenominator (correctness)"} Impl$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;
  var x##1: int;
  var d##1: int;
  var zp#0: int;
  var x##1_0_0: int;
  var y##1_0_0: int;
  var z##1_0_0: int;
  var x##2_0_0: int;
  var y##2_0_0: int;
  var z##2_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModAddDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(143,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(144,32)"} true;
    assume true;
    x##1 := x#0 + n#0;
    assume true;
    d##1 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(145,36)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume x#0 + n#0 == Mul(n#0, Div(x#0 + n#0, n#0)) + Mod(x#0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(146,53)"} true;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume true;
    zp#0 := Div(x#0 + n#0, n#0) - Div(x#0, n#0) - 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(147,37)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    push;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(148,75)"} true;
    pop;
    assume LitInt(0) == Mul(n#0, zp#0) + Mod(x#0 + n#0, n#0) - Mod(x#0, n#0);
    assume false;
    goto anon2;

  anon12_Else:
    goto anon2;

  anon2:
    assume LitInt(0) == Mul(n#0, zp#0) + Mod(x#0 + n#0, n#0) - Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(148,77)"} true;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} zp#0 > 0;
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    push;
    assume true;
    x##1_0_0 := LitInt(1);
    assume true;
    y##1_0_0 := zp#0;
    assume true;
    z##1_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(151,36)"} true;
    assume true;
    assume n#0 <= Mul(zp#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(152,26)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(153,21)"} true;
    pop;
    assume Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
    assume false;
    goto anon5;

  anon14_Else:
    goto anon5;

  anon5:
    assume Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(154,6)"} true;
    pop;
    goto anon7;

  anon13_Else:
    assume {:partition} 0 >= zp#0;
    goto anon7;

  anon7:
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} zp#0 < 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    x##2_0_0 := zp#0;
    assume true;
    y##2_0_0 := LitInt(-1);
    assume true;
    z##2_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(158,37)"} true;
    assume true;
    assume Mul(zp#0, n#0) <= 0 - n#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(159,27)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(160,21)"} true;
    assume Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
    assume false;
    goto anon10;

  anon16_Else:
    goto anon10;

  anon10:
    assume Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(161,6)"} true;
    return;

  anon15_Else:
    assume {:partition} 0 <= zp#0;
    return;
}



procedure {:verboseName "ModInternals.LemmaModSubDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModSubDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModSubDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(165,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(167,24): post-state"} true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
    return;
}



procedure {:verboseName "ModInternals.LemmaModSubDenominator (call precondtion)"} CallPre$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int);
  requires {:id "id10121"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaModSubDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10122"} Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModSubDenominator (correctness)"} Impl$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10123"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10124"} Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModSubDenominator (correctness)"} Impl$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;
  var x##1: int;
  var d##1: int;
  var zm#0: int;
  var x##1_0_0: int;
  var y##1_0_0: int;
  var z##1_0_0: int;
  var x##2_0_0: int;
  var y##2_0_0: int;
  var z##2_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModSubDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(168,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(169,32)"} true;
    assume true;
    x##1 := x#0 - n#0;
    assume true;
    d##1 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1, d##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(170,36)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume x#0 - n#0 == Mul(n#0, Div(x#0 - n#0, n#0)) + Mod(x#0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(171,53)"} true;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume true;
    zm#0 := Div(x#0 - n#0, n#0) - Div(x#0, n#0) + 1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(172,37)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    push;
    call CallPre$$MulInternals.__default.LemmaMulDistributes();
    call CallPost$$MulInternals.__default.LemmaMulDistributes();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(173,75)"} true;
    pop;
    assume LitInt(0) == Mul(n#0, zm#0) + Mod(x#0 - n#0, n#0) - Mod(x#0, n#0);
    assume false;
    goto anon2;

  anon12_Else:
    goto anon2;

  anon2:
    assume LitInt(0) == Mul(n#0, zm#0) + Mod(x#0 - n#0, n#0) - Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(173,77)"} true;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} zm#0 > 0;
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    push;
    assume true;
    x##1_0_0 := LitInt(1);
    assume true;
    y##1_0_0 := zm#0;
    assume true;
    z##1_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##1_0_0, y##1_0_0, z##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(176,36)"} true;
    assume true;
    assume n#0 <= Mul(zm#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(177,26)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(178,21)"} true;
    pop;
    assume Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
    assume false;
    goto anon5;

  anon14_Else:
    goto anon5;

  anon5:
    assume Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(179,6)"} true;
    pop;
    goto anon7;

  anon13_Else:
    assume {:partition} 0 >= zm#0;
    goto anon7;

  anon7:
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} zm#0 < 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    x##2_0_0 := zm#0;
    assume true;
    y##2_0_0 := LitInt(-1);
    assume true;
    z##2_0_0 := n#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##2_0_0, y##2_0_0, z##2_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(183,37)"} true;
    assume true;
    assume n#0 <= Mul(zm#0, 0 - n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(184,27)"} true;
    assume true;
    assume n#0 <= x#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(185,21)"} true;
    assume Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
    assume false;
    goto anon10;

  anon16_Else:
    goto anon10;

  anon10:
    assume Mod(x#0 - n#0, n#0) == Mod(x#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(186,6)"} true;
    return;

  anon15_Else:
    assume {:partition} 0 <= zm#0;
    return;
}



procedure {:verboseName "ModInternals.LemmaModBelowDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModBelowDenominator (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModBelowDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(191,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(193,23): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon3;

  anon4_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon3;

  anon3:
    assume n#0 != 0;
    assume LitInt(0) <= x#0 && x#0 < n#0 <==> Mod(x#0, n#0) == x#0;
    return;
}



procedure {:verboseName "ModInternals.LemmaModBelowDenominator (call precondtion)"} CallPre$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int);
  requires {:id "id10160"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaModBelowDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10161"} LitInt(0) <= x#0 && x#0 < n#0 <==> Mod(x#0, n#0) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModBelowDenominator (correctness)"} Impl$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10162"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10163"} LitInt(0) <= x#0 && x#0 < n#0 <==> Mod(x#0, n#0) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModBelowDenominator (correctness)"} Impl$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var x##0_0_0: int;
  var m##0_0_0: int;
  var x##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModBelowDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(194,2): initial state"} true;
    $_reverifyPost := false;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc x#0_0;
    assume true;
    assume true;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon4;

  anon15_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon4;

  anon4:
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume LitInt(0) <= x#0_0 && x#0_0 < n#0 <==> Mod(x#0_0, n#0) == x#0_0;
    assume false;
    goto anon5;

  anon14_Else:
    goto anon5;

  anon5:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon7;

  anon16_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon7;

  anon7:
    assume true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= x#0_0 && x#0_0 < n#0;
    push;
    assume true;
    assume $Is(x#0_0, Tclass._System.nat());
    x##0_0_0 := x#0_0;
    assume true;
    assume $Is(n#0, Tclass._System.nat());
    m##0_0_0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaSmallMod(x##0_0_0, m##0_0_0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaSmallMod(x##0_0_0, m##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(198,43)"} true;
    pop;
    goto anon10;

  anon17_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && x#0_0 < n#0);
    goto anon10;

  anon10:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    m##0_0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaModRange(x##0_0, m##0_0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaModRange(x##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(199,25)"} true;
    assume LitInt(0) <= x#0_0 && x#0_0 < n#0 <==> Mod(x#0_0, n#0) == x#0_0;
    assume false;
    goto anon12;

  anon13_Else:
    assume (forall x#0_1: int :: { Mod(x#0_1, n#0) } Lit(true) ==> (LitInt(0) <= x#0_1 && x#0_1 < n#0 <==> Mod(x#0_1, n#0) == x#0_1));
    goto anon12;

  anon12:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(200,4)"} true;
    return;
}



procedure {:verboseName "ModInternals.LemmaModBasics (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModBasics(n#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModBasics (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModBasics(n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var x#2: int;
  var x#4: int;
  var x#6: int;
  var x#8: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModBasics", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(204,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(206,13): post-state"} true;
    havoc x#0;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Mod(x#0 + n#0, n#0) == Mod(x#0, n#0);
    assume (forall x#1: int :: { Mod(x#1 + n#0, n#0) } Mod(x#1 + n#0, n#0) == Mod(x#1, n#0));
    havoc x#2;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Mod(x#2 - n#0, n#0) == Mod(x#2, n#0);
    assume (forall x#3: int :: { Mod(x#3 - n#0, n#0) } Mod(x#3 - n#0, n#0) == Mod(x#3, n#0));
    havoc x#4;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Div(x#4 + n#0, n#0) == Div(x#4, n#0) + 1;
    assume (forall x#5: int :: { Div(x#5 + n#0, n#0) } Div(x#5 + n#0, n#0) == Div(x#5, n#0) + 1);
    havoc x#6;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Div(x#6 - n#0, n#0) == Div(x#6, n#0) - 1;
    assume (forall x#7: int :: { Div(x#7 - n#0, n#0) } Div(x#7 - n#0, n#0) == Div(x#7, n#0) - 1);
    havoc x#8;
    assume true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= x#8;
    goto anon3;

  anon4_Else:
    assume {:partition} x#8 < LitInt(0);
    goto anon3;

  anon3:
    assume n#0 != 0;
    assume LitInt(0) <= x#8 && x#8 < n#0 <==> Mod(x#8, n#0) == x#8;
    assume (forall x#9: int :: { Mod(x#9, n#0) } LitInt(0) <= x#9 && x#9 < n#0 <==> Mod(x#9, n#0) == x#9);
    return;
}



procedure {:verboseName "ModInternals.LemmaModBasics (call precondtion)"} CallPre$$ModInternals.__default.LemmaModBasics(n#0: int);
  requires {:id "id10194"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaModBasics (call postcondition)"} CallPost$$ModInternals.__default.LemmaModBasics(n#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10195"} (forall x#1: int :: { Mod(x#1 + n#0, n#0) } Mod(x#1 + n#0, n#0) == Mod(x#1, n#0));
  free ensures true;
  free ensures {:id "id10196"} (forall x#3: int :: { Mod(x#3 - n#0, n#0) } Mod(x#3 - n#0, n#0) == Mod(x#3, n#0));
  free ensures true;
  free ensures {:id "id10197"} (forall x#5: int :: { Div(x#5 + n#0, n#0) } Div(x#5 + n#0, n#0) == Div(x#5, n#0) + 1);
  free ensures true;
  free ensures {:id "id10198"} (forall x#7: int :: { Div(x#7 - n#0, n#0) } Div(x#7 - n#0, n#0) == Div(x#7, n#0) - 1);
  free ensures true;
  free ensures {:id "id10199"} (forall x#9: int :: { Mod(x#9, n#0) } LitInt(0) <= x#9 && x#9 < n#0 <==> Mod(x#9, n#0) == x#9);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModBasics (correctness)"} Impl$$ModInternals.__default.LemmaModBasics(n#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id10200"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10201"} (forall x#1: int :: { Mod(x#1 + n#0, n#0) } Mod(x#1 + n#0, n#0) == Mod(x#1, n#0));
  free ensures true;
  free ensures {:id "id10202"} (forall x#3: int :: { Mod(x#3 - n#0, n#0) } Mod(x#3 - n#0, n#0) == Mod(x#3, n#0));
  free ensures true;
  free ensures {:id "id10203"} (forall x#5: int :: { Div(x#5 + n#0, n#0) } Div(x#5 + n#0, n#0) == Div(x#5, n#0) + 1);
  free ensures true;
  free ensures {:id "id10204"} (forall x#7: int :: { Div(x#7 - n#0, n#0) } Div(x#7 - n#0, n#0) == Div(x#7, n#0) - 1);
  free ensures true;
  free ensures {:id "id10205"} (forall x#9: int :: { Mod(x#9, n#0) } LitInt(0) <= x#9 && x#9 < n#0 <==> Mod(x#9, n#0) == x#9);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModBasics (correctness)"} Impl$$ModInternals.__default.LemmaModBasics(n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var n##0_0: int;
  var x##0_0: int;
  var n##0_1: int;
  var x##0_1: int;
  var n##0_2: int;
  var x##0_2: int;
  var n##0_3: int;
  var x##0_3: int;
  var n##0_4: int;
  var x##0_4: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModBasics", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(211,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0;
    assume true;
    assume true;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Mod(x#0_0 + n#0, n#0) == Mod(x#0_0, n#0);
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Mod(x#0_0 - n#0, n#0) == Mod(x#0_0, n#0);
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(x#0_0 + n#0, n#0) == Div(x#0_0, n#0) + 1;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(x#0_0 - n#0, n#0) == Div(x#0_0, n#0) - 1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon4;

  anon10_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon4;

  anon4:
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume LitInt(0) <= x#0_0 && x#0_0 < n#0 <==> Mod(x#0_0, n#0) == x#0_0;
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    n##0_0 := n#0;
    assume true;
    x##0_0 := x#0_0;
    call CallPre$$ModInternals.__default.LemmaModBelowDenominator(n##0_0, x##0_0);
    call CallPost$$ModInternals.__default.LemmaModBelowDenominator(n##0_0, x##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(219,36)"} true;
    assume true;
    n##0_1 := n#0;
    assume true;
    x##0_1 := x#0_0;
    call CallPre$$ModInternals.__default.LemmaModAddDenominator(n##0_1, x##0_1);
    call CallPost$$ModInternals.__default.LemmaModAddDenominator(n##0_1, x##0_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(220,34)"} true;
    assume true;
    n##0_2 := n#0;
    assume true;
    x##0_2 := x#0_0;
    call CallPre$$ModInternals.__default.LemmaModSubDenominator(n##0_2, x##0_2);
    call CallPost$$ModInternals.__default.LemmaModSubDenominator(n##0_2, x##0_2);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(221,34)"} true;
    assume true;
    n##0_3 := n#0;
    assume true;
    x##0_3 := x#0_0;
    call CallPre$$ModInternals.__default.LemmaDivAddDenominator(n##0_3, x##0_3);
    call CallPost$$ModInternals.__default.LemmaDivAddDenominator(n##0_3, x##0_3);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(222,34)"} true;
    assume true;
    n##0_4 := n#0;
    assume true;
    x##0_4 := x#0_0;
    call CallPre$$ModInternals.__default.LemmaDivSubDenominator(n##0_4, x##0_4);
    call CallPost$$ModInternals.__default.LemmaDivSubDenominator(n##0_4, x##0_4);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(223,34)"} true;
    assume Mod(x#0_0 + n#0, n#0) == Mod(x#0_0, n#0);
    assume Mod(x#0_0 - n#0, n#0) == Mod(x#0_0, n#0);
    assume Div(x#0_0 + n#0, n#0) == Div(x#0_0, n#0) + 1;
    assume Div(x#0_0 - n#0, n#0) == Div(x#0_0, n#0) - 1;
    assume LitInt(0) <= x#0_0 && x#0_0 < n#0 <==> Mod(x#0_0, n#0) == x#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, _t#0#0_0: int :: { Mod(x#0_1, n#0), Mod(_t#0#0_0, n#0) } _t#0#0_0 == x#0_1 + n#0 && true ==> Mod(_t#0#0_0, n#0) == Mod(x#0_1, n#0)) && (forall x#0_2: int, _t#0#0_1: int :: { Mod(x#0_2, n#0), Mod(_t#0#0_1, n#0) } _t#0#0_1 == x#0_2 - n#0 && true ==> Mod(_t#0#0_1, n#0) == Mod(x#0_2, n#0)) && (forall x#0_3: int, _t#0#0_2: int :: { Div(x#0_3, n#0), Div(_t#0#0_2, n#0) } _t#0#0_2 == x#0_3 + n#0 && true ==> Div(_t#0#0_2, n#0) == Div(x#0_3, n#0) + 1) && (forall x#0_4: int, _t#0#0_3: int :: { Div(x#0_4, n#0), Div(_t#0#0_3, n#0) } _t#0#0_3 == x#0_4 - n#0 && true ==> Div(_t#0#0_3, n#0) == Div(x#0_4, n#0) - 1) && (forall x#0_5: int :: { Mod(x#0_5, n#0) } Lit(true) ==> (LitInt(0) <= x#0_5 && x#0_5 < n#0 <==> Mod(x#0_5, n#0) == x#0_5));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(224,4)"} true;
    return;
}



procedure {:verboseName "ModInternals.LemmaQuotientAndRemainder (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaQuotientAndRemainder (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaQuotientAndRemainder", " | ", x#0, " | ", q#0, " | ", r#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(228,37): initial state"} true;
    assume n#0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= r#0;
    goto anon3;

  anon7_Else:
    assume {:partition} r#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= r#0 && r#0 < n#0;
    assume x#0 == Mul(q#0, n#0) + r#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} q#0 > 0;
    goto anon6;

  anon8_Else:
    assume {:partition} 0 >= q#0;
    goto anon6;

  anon6:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(232,15): post-state"} true;
    assume n#0 != 0;
    assume q#0 == Div(x#0, n#0);
    assume n#0 != 0;
    assume r#0 == Mod(x#0, n#0);
    return;
}



procedure {:verboseName "ModInternals.LemmaQuotientAndRemainder (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int);
  requires {:id "id10243"} n#0 > 0;
  requires {:id "id10244"} LitInt(0) <= r#0;
  requires {:id "id10245"} r#0 < n#0;
  requires {:id "id10246"} x#0 == Mul(q#0, n#0) + r#0;



procedure {:verboseName "ModInternals.LemmaQuotientAndRemainder (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10247"} q#0 == Div(x#0, n#0);
  free ensures true;
  free ensures {:id "id10248"} r#0 == Mod(x#0, n#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaQuotientAndRemainder (correctness)"} {:vcs_split_on_every_assert} Impl$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id10249"} n#0 > 0;
  requires {:id "id10250"} LitInt(0) <= r#0;
  requires {:id "id10251"} r#0 < n#0;
  requires {:id "id10252"} x#0 == Mul(q#0, n#0) + r#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10253"} q#0 == Div(x#0, n#0);
  free ensures true;
  free ensures {:id "id10254"} r#0 == Mod(x#0, n#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaQuotientAndRemainder (correctness)"} {:vcs_split_on_every_assert} Impl$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;
  var x##0_1: int;
  var q##0_0: int;
  var r##0_0: int;
  var n##0_0: int;
  var x##1_0_0: int;
  var y##1_0_0: int;
  var z##1_0_0: int;
  var x##1_0_1: int;
  var q##1_0_0: int;
  var r##1_0_0: int;
  var n##1_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaQuotientAndRemainder", " | ", x#0, " | ", q#0, " | ", r#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(235,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$ModInternals.__default.LemmaModBasics(n##0);
    call CallPost$$ModInternals.__default.LemmaModBasics(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(236,21)"} true;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} q#0 > 0;
    assume true;
    x##0_0 := n#0;
    assume true;
    y##0_0 := q#0 - 1;
    assume true;
    z##0_0 := LitInt(1);
    call CallPre$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0_0, y##0_0, z##0_0);
    call CallPost$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(239,66)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(240,33)"} true;
    assume true;
    assume Mul(q#0, n#0) + r#0 == Mul(q#0 - 1, n#0) + n#0 + r#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(241,45)"} true;
    assume true;
    x##0_1 := x#0 - n#0;
    assume true;
    q##0_0 := q#0 - 1;
    assume true;
    r##0_0 := r#0;
    assume true;
    n##0_0 := n#0;
    assume 0 <= (if q#0 > 0 then q#0 else 0 - q#0) || (if q##0_0 > 0 then q##0_0 else 0 - q##0_0) == (if q#0 > 0 then q#0 else 0 - q#0);
    assume (if q##0_0 > 0 then q##0_0 else 0 - q##0_0) < (if q#0 > 0 then q#0 else 0 - q#0);
    call CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x##0_1, q##0_0, r##0_0, n##0_0);
    call CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x##0_1, q##0_0, r##0_0, n##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(242,51)"} true;
    return;

  anon5_Else:
    assume {:partition} 0 >= q#0;
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} q#0 < 0;
    assume true;
    x##1_0_0 := n#0;
    assume true;
    y##1_0_0 := q#0 + 1;
    assume true;
    z##1_0_0 := LitInt(1);
    call CallPre$$Mul.__default.LemmaMulIsDistributiveSub(x##1_0_0, y##1_0_0, z##1_0_0);
    call CallPost$$Mul.__default.LemmaMulIsDistributiveSub(x##1_0_0, y##1_0_0, z##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(245,48)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(246,33)"} true;
    assume true;
    assume Mul(q#0, n#0) + r#0 == Mul(q#0 + 1, n#0) - n#0 + r#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(247,45)"} true;
    assume true;
    x##1_0_1 := x#0 + n#0;
    assume true;
    q##1_0_0 := q#0 + 1;
    assume true;
    r##1_0_0 := r#0;
    assume true;
    n##1_0_0 := n#0;
    assume 0 <= (if q#0 > 0 then q#0 else 0 - q#0) || (if q##1_0_0 > 0 then q##1_0_0 else 0 - q##1_0_0) == (if q#0 > 0 then q#0 else 0 - q#0);
    assume (if q##1_0_0 > 0 then q##1_0_0 else 0 - q##1_0_0) < (if q#0 > 0 then q#0 else 0 - q#0);
    call CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x##1_0_1, q##1_0_0, r##1_0_0, n##1_0_0);
    call CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x##1_0_1, q##1_0_0, r##1_0_0, n##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(248,51)"} true;
    return;

  anon6_Else:
    assume {:partition} 0 <= q#0;
    call CallPre$$DivInternalsNonlinear.__default.LemmaSmallDiv();
    call CallPost$$DivInternalsNonlinear.__default.LemmaSmallDiv();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(251,21)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(r#0, n#0) == LitInt(0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(252,23)"} true;
    return;
}



function ModInternals.__default.ModAuto(n#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || (0 < $FunctionContextHeight && n#0 > 0) ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#0: int :: { Mod(Mod(x#0, n#0), n#0) } Mod(Mod(x#0, n#0), n#0) == Mod(x#0, n#0)) && (forall x#1: int :: { Mod(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Mod(x#1, n#0) == x#1) && (forall x#2: int, y#0: int :: { Mod(x#2 + y#0, n#0) } (var z#0 := Mod(x#2, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Mod(x#2 + y#0, n#0) == z#0) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Mod(x#2 + y#0, n#0) == z#0 - n#0))) && (forall x#3: int, y#1: int :: { Mod(x#3 - y#1, n#0) } (var z#1 := Mod(x#3, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Mod(x#3 - y#1, n#0) == z#1) || (0 - n#0 <= z#1 && z#1 < 0 && Mod(x#3 - y#1, n#0) == z#1 + n#0)))));
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || (0 < $FunctionContextHeight && Lit(n#0 > 0)) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#4: int :: { Mod(Mod(x#4, n#0), n#0) } Mod(Mod(x#4, LitInt(n#0)), LitInt(n#0)) == Mod(x#4, LitInt(n#0))) && (forall x#5: int :: { Mod(x#5, n#0) } LitInt(0) <= x#5 && x#5 < n#0 <==> Mod(x#5, LitInt(n#0)) == x#5) && (forall x#6: int, y#2: int :: { Mod(x#6 + y#2, n#0) } (var z#2 := Mod(x#6, LitInt(n#0)) + Mod(y#2, LitInt(n#0)); (LitInt(0) <= z#2 && z#2 < n#0 && Mod(x#6 + y#2, LitInt(n#0)) == z#2) || (LitInt(n#0) <= z#2 && z#2 < n#0 + n#0 && Mod(x#6 + y#2, LitInt(n#0)) == z#2 - n#0))) && (forall x#7: int, y#3: int :: { Mod(x#7 - y#3, n#0) } (var z#3 := Mod(x#7, LitInt(n#0)) - Mod(y#3, LitInt(n#0)); (LitInt(0) <= z#3 && z#3 < n#0 && Mod(x#7 - y#3, LitInt(n#0)) == z#3) || (LitInt(0 - n#0) <= z#3 && z#3 < 0 && Mod(x#7 - y#3, LitInt(n#0)) == z#3 + n#0)))));
}

function ModInternals.__default.ModAuto#canCall(n#0: int) : bool;

function ModInternals.__default.ModAuto#requires(int) : bool;

axiom (forall n#0: int :: { ModInternals.__default.ModAuto#requires(n#0) } ModInternals.__default.ModAuto#requires(n#0) <==> n#0 > 0);

procedure {:verboseName "ModInternals.ModAuto (well-formedness)"} CheckWellformed$$ModInternals.__default.ModAuto(n#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.ModAuto (well-formedness)"} CheckWellformed$$ModInternals.__default.ModAuto(n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#8: int;
  var x#9: int;
  var x#11: int;
  var y#4: int;
  var z#Z#0: int;
  var let#0#0#0: int;
  var x#13: int;
  var y#5: int;
  var z#Z#1: int;
  var let#1#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.ModAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(257,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume n#0 > 0;
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume false;
    return;

  anon40_Else:
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} Mod(n#0, n#0) == Mod(0 - n#0, n#0);
    assume n#0 != 0;
    goto anon5;

  anon41_Else:
    assume {:partition} Mod(n#0, n#0) != Mod(0 - n#0, n#0);
    goto anon5;

  anon5:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0);
    havoc x#8;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon8;

  anon43_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    goto anon9;

  anon42_Else:
    assume {:partition} !(Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0));
    goto anon9;

  anon9:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0));
    havoc x#9;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} true;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} LitInt(0) <= x#9;
    goto anon13;

  anon46_Else:
    assume {:partition} x#9 < LitInt(0);
    goto anon13;

  anon13:
    assume n#0 != 0;
    goto anon14;

  anon45_Else:
    assume {:partition} false;
    goto anon14;

  anon14:
    goto anon15;

  anon44_Else:
    assume {:partition} !(Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0)));
    goto anon15;

  anon15:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0)) && (forall x#12: int :: { Mod(x#12, n#0) } LitInt(0) <= x#12 && x#12 < n#0 <==> Mod(x#12, n#0) == x#12);
    havoc x#11;
    havoc y#4;
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} true;
    havoc z#Z#0;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume let#0#0#0 == Mod(x#11, n#0) + Mod(y#4, n#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume z#Z#0 == let#0#0#0;
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} LitInt(0) <= z#Z#0;
    goto anon19;

  anon49_Else:
    assume {:partition} z#Z#0 < LitInt(0);
    goto anon19;

  anon19:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} LitInt(0) <= z#Z#0 && z#Z#0 < n#0;
    assume n#0 != 0;
    goto anon21;

  anon50_Else:
    assume {:partition} !(LitInt(0) <= z#Z#0 && z#Z#0 < n#0);
    goto anon21;

  anon21:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} !(LitInt(0) <= z#Z#0 && z#Z#0 < n#0 && Mod(x#11 + y#4, n#0) == z#Z#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} n#0 <= z#Z#0;
    goto anon24;

  anon52_Else:
    assume {:partition} z#Z#0 < n#0;
    goto anon24;

  anon24:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} n#0 <= z#Z#0 && z#Z#0 < n#0 + n#0;
    assume n#0 != 0;
    goto anon26;

  anon53_Else:
    assume {:partition} !(n#0 <= z#Z#0 && z#Z#0 < n#0 + n#0);
    goto anon26;

  anon51_Else:
    assume {:partition} LitInt(0) <= z#Z#0 && z#Z#0 < n#0 && Mod(x#11 + y#4, n#0) == z#Z#0;
    goto anon26;

  anon48_Else:
    assume {:partition} false;
    goto anon26;

  anon26:
    goto anon27;

  anon47_Else:
    assume {:partition} !(Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0)) && (forall x#12: int :: { Mod(x#12, n#0) } LitInt(0) <= x#12 && x#12 < n#0 <==> Mod(x#12, n#0) == x#12));
    goto anon27;

  anon27:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0)) && (forall x#12: int :: { Mod(x#12, n#0) } LitInt(0) <= x#12 && x#12 < n#0 <==> Mod(x#12, n#0) == x#12) && (forall x#14: int, y#6: int :: { Mod(x#14 + y#6, n#0) } (var z#4 := Mod(x#14, n#0) + Mod(y#6, n#0); (LitInt(0) <= z#4 && z#4 < n#0 && Mod(x#14 + y#6, n#0) == z#4) || (n#0 <= z#4 && z#4 < n#0 + n#0 && Mod(x#14 + y#6, n#0) == z#4 - n#0)));
    havoc x#13;
    havoc y#5;
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} true;
    havoc z#Z#1;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume let#1#0#0 == Mod(x#13, n#0) - Mod(y#5, n#0);
    assume true;
    assume $Is(let#1#0#0, TInt);
    assume z#Z#1 == let#1#0#0;
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} LitInt(0) <= z#Z#1;
    goto anon31;

  anon56_Else:
    assume {:partition} z#Z#1 < LitInt(0);
    goto anon31;

  anon31:
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} LitInt(0) <= z#Z#1 && z#Z#1 < n#0;
    assume n#0 != 0;
    goto anon33;

  anon57_Else:
    assume {:partition} !(LitInt(0) <= z#Z#1 && z#Z#1 < n#0);
    goto anon33;

  anon33:
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} !(LitInt(0) <= z#Z#1 && z#Z#1 < n#0 && Mod(x#13 - y#5, n#0) == z#Z#1);
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} 0 - n#0 <= z#Z#1;
    goto anon36;

  anon59_Else:
    assume {:partition} z#Z#1 < 0 - n#0;
    goto anon36;

  anon36:
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} 0 - n#0 <= z#Z#1 && z#Z#1 < 0;
    assume n#0 != 0;
    goto anon38;

  anon60_Else:
    assume {:partition} !(0 - n#0 <= z#Z#1 && z#Z#1 < 0);
    goto anon38;

  anon58_Else:
    assume {:partition} LitInt(0) <= z#Z#1 && z#Z#1 < n#0 && Mod(x#13 - y#5, n#0) == z#Z#1;
    goto anon38;

  anon55_Else:
    assume {:partition} false;
    goto anon38;

  anon38:
    goto anon39;

  anon54_Else:
    assume {:partition} !(Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0)) && (forall x#12: int :: { Mod(x#12, n#0) } LitInt(0) <= x#12 && x#12 < n#0 <==> Mod(x#12, n#0) == x#12) && (forall x#14: int, y#6: int :: { Mod(x#14 + y#6, n#0) } (var z#4 := Mod(x#14, n#0) + Mod(y#6, n#0); (LitInt(0) <= z#4 && z#4 < n#0 && Mod(x#14 + y#6, n#0) == z#4) || (n#0 <= z#4 && z#4 < n#0 + n#0 && Mod(x#14 + y#6, n#0) == z#4 - n#0))));
    goto anon39;

  anon39:
    assume ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#10: int :: { Mod(Mod(x#10, n#0), n#0) } Mod(Mod(x#10, n#0), n#0) == Mod(x#10, n#0)) && (forall x#12: int :: { Mod(x#12, n#0) } LitInt(0) <= x#12 && x#12 < n#0 <==> Mod(x#12, n#0) == x#12) && (forall x#14: int, y#6: int :: { Mod(x#14 + y#6, n#0) } (var z#4 := Mod(x#14, n#0) + Mod(y#6, n#0); (LitInt(0) <= z#4 && z#4 < n#0 && Mod(x#14 + y#6, n#0) == z#4) || (n#0 <= z#4 && z#4 < n#0 + n#0 && Mod(x#14 + y#6, n#0) == z#4 - n#0))) && (forall x#15: int, y#7: int :: { Mod(x#15 - y#7, n#0) } (var z#5 := Mod(x#15, n#0) - Mod(y#7, n#0); (LitInt(0) <= z#5 && z#5 < n#0 && Mod(x#15 - y#7, n#0) == z#5) || (0 - n#0 <= z#5 && z#5 < 0 && Mod(x#15 - y#7, n#0) == z#5 + n#0)));
    assume true;
    assume $Is(ModInternals.__default.ModAuto(n#0), TBool);
    return;
}



procedure {:verboseName "ModInternals.LemmaModAuto (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModAuto(n#0: int);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModAuto (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModAuto(n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(274,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(276,20): post-state"} true;
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume ModInternals.__default.ModAuto#canCall(n#0);
    assume ModInternals.__default.ModAuto(n#0);
    return;
}



procedure {:verboseName "ModInternals.LemmaModAuto (call precondtion)"} CallPre$$ModInternals.__default.LemmaModAuto(n#0: int);
  requires {:id "id10303"} n#0 > 0;



procedure {:verboseName "ModInternals.LemmaModAuto (call postcondition)"} CallPost$$ModInternals.__default.LemmaModAuto(n#0: int);
  modifies $Heap;
  free ensures ModInternals.__default.ModAuto#canCall(n#0);
  free ensures {:id "id10304"} ModInternals.__default.ModAuto#canCall(n#0) && ModInternals.__default.ModAuto(n#0) && Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#0: int :: { Mod(Mod(x#0, n#0), n#0) } Mod(Mod(x#0, n#0), n#0) == Mod(x#0, n#0)) && (forall x#1: int :: { Mod(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Mod(x#1, n#0) == x#1) && (forall x#2: int, y#0: int :: { Mod(x#2 + y#0, n#0) } (var z#0 := Mod(x#2, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Mod(x#2 + y#0, n#0) == z#0) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Mod(x#2 + y#0, n#0) == z#0 - n#0))) && (forall x#3: int, y#1: int :: { Mod(x#3 - y#1, n#0) } (var z#1 := Mod(x#3, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Mod(x#3 - y#1, n#0) == z#1) || (0 - n#0 <= z#1 && z#1 < 0 && Mod(x#3 - y#1, n#0) == z#1 + n#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModAuto (correctness)"} Impl$$ModInternals.__default.LemmaModAuto(n#0: int) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id10305"} n#0 > 0;
  modifies $Heap;
  free ensures ModInternals.__default.ModAuto#canCall(n#0);
  free ensures {:id "id10306"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || Mod(n#0, n#0) == Mod(0 - n#0, n#0);
  free ensures {:id "id10307"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || Mod(0 - n#0, n#0) == LitInt(0);
  free ensures {:id "id10308"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#4: int :: { Mod(Mod(x#4, n#0), n#0) } Mod(Mod(x#4, n#0), n#0) == Mod(x#4, n#0));
  free ensures {:id "id10309"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#5: int :: { Mod(x#5, n#0) } LitInt(0) <= x#5 && x#5 < n#0 <==> Mod(x#5, n#0) == x#5);
  free ensures {:id "id10310"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#6: int, y#2: int :: { Mod(x#6 + y#2, n#0) } (var z#2 := Mod(x#6, n#0) + Mod(y#2, n#0); (LitInt(0) <= z#2 && z#2 < n#0 && Mod(x#6 + y#2, n#0) == z#2) || (n#0 <= z#2 && z#2 < n#0 + n#0 && Mod(x#6 + y#2, n#0) == z#2 - n#0)));
  free ensures {:id "id10311"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#7: int, y#3: int :: { Mod(x#7 - y#3, n#0) } (var z#3 := Mod(x#7, n#0) - Mod(y#3, n#0); (LitInt(0) <= z#3 && z#3 < n#0 && Mod(x#7 - y#3, n#0) == z#3) || (0 - n#0 <= z#3 && z#3 < 0 && Mod(x#7 - y#3, n#0) == z#3 + n#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModAuto (correctness)"} Impl$$ModInternals.__default.LemmaModAuto(n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x#0_0: int;
  var y#0_0: int;
  var z#Z#0_0: int;
  var let#0_0#0#0: int;
  var xq#0_0: int;
  var xr#0_0: int;
  var $rhs#0_0: int;
  var $rhs#0_1: int;
  var x##0_0: int;
  var d##0_0: int;
  var yq#0_0: int;
  var yr#0_0: int;
  var $rhs#0_2: int;
  var $rhs#0_3: int;
  var x##0_1: int;
  var d##0_1: int;
  var x##0_0_0: int;
  var q##0_0_0: int;
  var r##0_0_0: int;
  var n##0_0_0: int;
  var x##0_1_0: int;
  var q##0_1_0: int;
  var r##0_1_0: int;
  var n##0_1_0: int;
  var x#1_0: int;
  var y#1_0: int;
  var z#Z#1_0: int;
  var let#1_0#0#0: int;
  var xq#1_0: int;
  var xr#1_0: int;
  var $rhs#1_0: int;
  var $rhs#1_1: int;
  var x##1_0: int;
  var d##1_0: int;
  var yq#1_0: int;
  var yr#1_0: int;
  var $rhs#1_2: int;
  var $rhs#1_3: int;
  var x##1_1: int;
  var d##1_1: int;
  var x##1_0_0: int;
  var q##1_0_0: int;
  var r##1_0_0: int;
  var n##1_0_0: int;
  var x##1_1_0: int;
  var q##1_1_0: int;
  var r##1_1_0: int;
  var n##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(277,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$ModInternals.__default.LemmaModBasics(n##0);
    call CallPost$$ModInternals.__default.LemmaModBasics(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(278,21)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(279,31)"} true;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAddAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAddAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(280,35)"} true;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(281,35)"} true;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon36_Then, anon36_Else;

  anon36_Then:
    havoc z#Z#0_0;
    assume true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume let#0_0#0#0 == Mod(x#0_0, n#0) + Mod(y#0_0, n#0);
    assume true;
    assume $Is(let#0_0#0#0, TInt);
    assume z#Z#0_0 == let#0_0#0#0;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} LitInt(0) <= z#Z#0_0;
    goto anon4;

  anon37_Else:
    assume {:partition} z#Z#0_0 < LitInt(0);
    goto anon4;

  anon4:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0;
    assume {:subsumption 0} n#0 != 0;
    goto anon6;

  anon38_Else:
    assume {:partition} !(LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0);
    goto anon6;

  anon6:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} !(LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0 && Mod(x#0_0 + y#0_0, n#0) == z#Z#0_0);
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} n#0 <= z#Z#0_0;
    goto anon9;

  anon40_Else:
    assume {:partition} z#Z#0_0 < n#0;
    goto anon9;

  anon9:
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} n#0 <= z#Z#0_0 && z#Z#0_0 < Mul(LitInt(2), n#0);
    assume {:subsumption 0} n#0 != 0;
    goto anon11;

  anon41_Else:
    assume {:partition} !(n#0 <= z#Z#0_0 && z#Z#0_0 < Mul(LitInt(2), n#0));
    goto anon11;

  anon39_Else:
    assume {:partition} LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0 && Mod(x#0_0 + y#0_0, n#0) == z#Z#0_0;
    goto anon11;

  anon11:
    assume true;
    assume (var z#0_0 := Mod(x#0_0, n#0) + Mod(y#0_0, n#0); (LitInt(0) <= z#0_0 && z#0_0 < n#0 && Mod(x#0_0 + y#0_0, n#0) == z#0_0) || (n#0 <= z#0_0 && z#0_0 < Mul(LitInt(2), n#0) && Mod(x#0_0 + y#0_0, n#0) == z#0_0 - n#0));
    assume false;
    goto anon12;

  anon36_Else:
    goto anon12;

  anon12:
    push;
    assume true;
    assume true;
    assume n#0 != 0;
    assume true;
    $rhs#0_0 := Div(x#0_0, n#0);
    assume n#0 != 0;
    assume true;
    $rhs#0_1 := Mod(x#0_0, n#0);
    xq#0_0 := $rhs#0_0;
    xr#0_0 := $rhs#0_1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(288,32)"} true;
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(289,34)"} true;
    assume true;
    assume x#0_0 == Mul(xq#0_0, n#0) + xr#0_0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(290,29)"} true;
    assume true;
    assume true;
    assume n#0 != 0;
    assume true;
    $rhs#0_2 := Div(y#0_0, n#0);
    assume n#0 != 0;
    assume true;
    $rhs#0_3 := Mod(y#0_0, n#0);
    yq#0_0 := $rhs#0_2;
    yr#0_0 := $rhs#0_3;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(291,32)"} true;
    assume true;
    x##0_1 := y#0_0;
    assume true;
    d##0_1 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0_1, d##0_1);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0_1, d##0_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(292,34)"} true;
    assume true;
    assume y#0_0 == Mul(yq#0_0, n#0) + yr#0_0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(293,29)"} true;
    assume true;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} xr#0_0 + yr#0_0 < n#0;
    push;
    assume true;
    x##0_0_0 := x#0_0 + y#0_0;
    assume true;
    q##0_0_0 := xq#0_0 + yq#0_0;
    assume true;
    r##0_0_0 := xr#0_0 + yr#0_0;
    assume true;
    n##0_0_0 := n#0;
    call CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x##0_0_0, q##0_0_0, r##0_0_0, n##0_0_0);
    call CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x##0_0_0, q##0_0_0, r##0_0_0, n##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(295,61)"} true;
    pop;
    goto anon15;

  anon42_Else:
    assume {:partition} n#0 <= xr#0_0 + yr#0_0;
    push;
    assume true;
    x##0_1_0 := x#0_0 + y#0_0;
    assume true;
    q##0_1_0 := xq#0_0 + yq#0_0 + 1;
    assume true;
    r##0_1_0 := xr#0_0 + yr#0_0 - n#0;
    assume true;
    n##0_1_0 := n#0;
    call CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x##0_1_0, q##0_1_0, r##0_1_0, n##0_1_0);
    call CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x##0_1_0, q##0_1_0, r##0_1_0, n##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(298,69)"} true;
    pop;
    goto anon15;

  anon15:
    pop;
    assume (var z#0_0 := Mod(x#0_0, n#0) + Mod(y#0_0, n#0); (LitInt(0) <= z#0_0 && z#0_0 < n#0 && Mod(x#0_0 + y#0_0, n#0) == z#0_0) || (n#0 <= z#0_0 && z#0_0 < Mul(LitInt(2), n#0) && Mod(x#0_0 + y#0_0, n#0) == z#0_0 - n#0));
    assume false;
    goto anon17;

  anon35_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Mod(x#0_1 + y#0_1, n#0) } Lit(true) ==> (var z#0_1 := Mod(x#0_1, n#0) + Mod(y#0_1, n#0); (LitInt(0) <= z#0_1 && z#0_1 < n#0 && Mod(x#0_1 + y#0_1, n#0) == z#0_1) || (n#0 <= z#0_1 && z#0_1 < Mul(LitInt(2), n#0) && Mod(x#0_1 + y#0_1, n#0) == z#0_1 - n#0)));
    goto anon17;

  anon17:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(300,4)"} true;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    havoc x#1_0, y#1_0;
    assume true;
    assume true;
    assume true;
    goto anon44_Then, anon44_Else;

  anon44_Then:
    havoc z#Z#1_0;
    assume true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume let#1_0#0#0 == Mod(x#1_0, n#0) - Mod(y#1_0, n#0);
    assume true;
    assume $Is(let#1_0#0#0, TInt);
    assume z#Z#1_0 == let#1_0#0#0;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} LitInt(0) <= z#Z#1_0;
    goto anon21;

  anon45_Else:
    assume {:partition} z#Z#1_0 < LitInt(0);
    goto anon21;

  anon21:
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0;
    assume {:subsumption 0} n#0 != 0;
    goto anon23;

  anon46_Else:
    assume {:partition} !(LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0);
    goto anon23;

  anon23:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} !(LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0 && Mod(x#1_0 - y#1_0, n#0) == z#Z#1_0);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} 0 - n#0 <= z#Z#1_0;
    goto anon26;

  anon48_Else:
    assume {:partition} z#Z#1_0 < 0 - n#0;
    goto anon26;

  anon26:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} 0 - n#0 <= z#Z#1_0 && z#Z#1_0 < 0;
    assume {:subsumption 0} n#0 != 0;
    goto anon28;

  anon49_Else:
    assume {:partition} !(0 - n#0 <= z#Z#1_0 && z#Z#1_0 < 0);
    goto anon28;

  anon47_Else:
    assume {:partition} LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0 && Mod(x#1_0 - y#1_0, n#0) == z#Z#1_0;
    goto anon28;

  anon28:
    assume true;
    assume (var z#1_0 := Mod(x#1_0, n#0) - Mod(y#1_0, n#0); (LitInt(0) <= z#1_0 && z#1_0 < n#0 && Mod(x#1_0 - y#1_0, n#0) == z#1_0) || (0 - n#0 <= z#1_0 && z#1_0 < 0 && Mod(x#1_0 - y#1_0, n#0) == z#1_0 + n#0));
    assume false;
    goto anon29;

  anon44_Else:
    goto anon29;

  anon29:
    assume true;
    assume true;
    assume n#0 != 0;
    assume true;
    $rhs#1_0 := Div(x#1_0, n#0);
    assume n#0 != 0;
    assume true;
    $rhs#1_1 := Mod(x#1_0, n#0);
    xq#1_0 := $rhs#1_0;
    xr#1_0 := $rhs#1_1;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(307,32)"} true;
    assume true;
    x##1_0 := x#1_0;
    assume true;
    d##1_0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1_0, d##1_0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1_0, d##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(308,34)"} true;
    assume true;
    assume x#1_0 == Mul(xq#1_0, n#0) + xr#1_0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(309,29)"} true;
    assume true;
    assume true;
    assume n#0 != 0;
    assume true;
    $rhs#1_2 := Div(y#1_0, n#0);
    assume n#0 != 0;
    assume true;
    $rhs#1_3 := Mod(y#1_0, n#0);
    yq#1_0 := $rhs#1_2;
    yr#1_0 := $rhs#1_3;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(310,32)"} true;
    assume true;
    x##1_1 := y#1_0;
    assume true;
    d##1_1 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1_1, d##1_1);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##1_1, d##1_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(311,34)"} true;
    assume true;
    assume y#1_0 == Mul(yq#1_0, n#0) + yr#1_0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(312,29)"} true;
    assume true;
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} xr#1_0 - yr#1_0 >= LitInt(0);
    assume true;
    x##1_0_0 := x#1_0 - y#1_0;
    assume true;
    q##1_0_0 := xq#1_0 - yq#1_0;
    assume true;
    r##1_0_0 := xr#1_0 - yr#1_0;
    assume true;
    n##1_0_0 := n#0;
    call CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x##1_0_0, q##1_0_0, r##1_0_0, n##1_0_0);
    call CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x##1_0_0, q##1_0_0, r##1_0_0, n##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(314,61)"} true;
    goto anon32;

  anon50_Else:
    assume {:partition} LitInt(0) > xr#1_0 - yr#1_0;
    assume true;
    x##1_1_0 := x#1_0 - y#1_0;
    assume true;
    q##1_1_0 := xq#1_0 - yq#1_0 - 1;
    assume true;
    r##1_1_0 := xr#1_0 - yr#1_0 + n#0;
    assume true;
    n##1_1_0 := n#0;
    call CallPre$$ModInternals.__default.LemmaQuotientAndRemainder(x##1_1_0, q##1_1_0, r##1_1_0, n##1_1_0);
    call CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x##1_1_0, q##1_1_0, r##1_1_0, n##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(317,69)"} true;
    goto anon32;

  anon32:
    assume (var z#1_0 := Mod(x#1_0, n#0) - Mod(y#1_0, n#0); (LitInt(0) <= z#1_0 && z#1_0 < n#0 && Mod(x#1_0 - y#1_0, n#0) == z#1_0) || (0 - n#0 <= z#1_0 && z#1_0 < 0 && Mod(x#1_0 - y#1_0, n#0) == z#1_0 + n#0));
    assume false;
    goto anon34;

  anon43_Else:
    assume (forall x#1_1: int, y#1_1: int :: { Mod(x#1_1 - y#1_1, n#0) } Lit(true) ==> (var z#1_1 := Mod(x#1_1, n#0) - Mod(y#1_1, n#0); (LitInt(0) <= z#1_1 && z#1_1 < n#0 && Mod(x#1_1 - y#1_1, n#0) == z#1_1) || (0 - n#0 <= z#1_1 && z#1_1 < 0 && Mod(x#1_1 - y#1_1, n#0) == z#1_1 + n#0)));
    goto anon34;

  anon34:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(319,4)"} true;
    return;
}



procedure {:verboseName "ModInternals.LemmaModInductionAuto (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModInductionAuto (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;
  var i#0: int;
  var ##x#0: int;
  var ##y#0: int;
  var i#2: int;
  var ##x#1: int;
  var ##y#1: int;
  var i#4: int;
  var ##x#2: int;
  var ##y#2: int;
  var ##n#1: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionAuto", " | ", n#0, " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(323,8): initial state"} true;
    assume n#0 > 0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume ModInternals.__default.ModAuto#canCall(n#0);
    assume ModInternals.__default.ModAuto(n#0);
    havoc i#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    ##x#0 := LitInt(0);
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := i#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon22_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon5:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0;
    goto anon7;

  anon23_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0);
    goto anon7;

  anon21_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
    havoc i#2;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    ##x#1 := LitInt(0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := i#2;
    assume $IsAlloc(##y#1, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon25_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon10:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool;
    goto anon12;

  anon26_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool);
    goto anon12;

  anon24_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
    havoc i#4;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} true;
    ##x#2 := i#4 + 1;
    assume $IsAlloc(##x#2, TInt, $Heap);
    ##y#2 := n#0;
    assume $IsAlloc(##y#2, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#4 + 1, n#0);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon28_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon15:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool;
    goto anon17;

  anon29_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool);
    goto anon17;

  anon27_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon20_Else:
    assume ModInternals.__default.ModAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool) && (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool) && (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon19:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(328,20): post-state"} true;
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume {:subsumption 0} ##n#1 > 0;
    assume ##n#1 > 0;
    assume ModInternals.__default.ModAuto#canCall(n#0);
    assume ModInternals.__default.ModAuto(n#0);
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
    return;
}



procedure {:verboseName "ModInternals.LemmaModInductionAuto (call precondtion)"} CallPre$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id10392"} n#0 > 0;
  requires {:id "id10393"} ModInternals.__default.ModAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10394"} ModInternals.__default.ModAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10395"} ModInternals.__default.ModAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);



procedure {:verboseName "ModInternals.LemmaModInductionAuto (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures ModInternals.__default.ModAuto#canCall(n#0);
  free ensures {:id "id10396"} ModInternals.__default.ModAuto#canCall(n#0) && ModInternals.__default.ModAuto(n#0) && Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#1: int :: { Mod(Mod(x#1, n#0), n#0) } Mod(Mod(x#1, n#0), n#0) == Mod(x#1, n#0)) && (forall x#2: int :: { Mod(x#2, n#0) } LitInt(0) <= x#2 && x#2 < n#0 <==> Mod(x#2, n#0) == x#2) && (forall x#3: int, y#0: int :: { Mod(x#3 + y#0, n#0) } (var z#0 := Mod(x#3, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Mod(x#3 + y#0, n#0) == z#0) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Mod(x#3 + y#0, n#0) == z#0 - n#0))) && (forall x#4: int, y#1: int :: { Mod(x#4 - y#1, n#0) } (var z#1 := Mod(x#4, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Mod(x#4 - y#1, n#0) == z#1) || (0 - n#0 <= z#1 && z#1 < 0 && Mod(x#4 - y#1, n#0) == z#1 + n#0)));
  free ensures true;
  free ensures {:id "id10397"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModInductionAuto (correctness)"} Impl$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id10398"} n#0 > 0;
  requires {:id "id10399"} ModInternals.__default.ModAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10400"} ModInternals.__default.ModAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10401"} ModInternals.__default.ModAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
  modifies $Heap;
  free ensures ModInternals.__default.ModAuto#canCall(n#0);
  free ensures {:id "id10402"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || Mod(n#0, n#0) == Mod(0 - n#0, n#0);
  free ensures {:id "id10403"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || Mod(0 - n#0, n#0) == LitInt(0);
  free ensures {:id "id10404"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#5: int :: { Mod(Mod(x#5, n#0), n#0) } Mod(Mod(x#5, n#0), n#0) == Mod(x#5, n#0));
  free ensures {:id "id10405"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#6: int :: { Mod(x#6, n#0) } LitInt(0) <= x#6 && x#6 < n#0 <==> Mod(x#6, n#0) == x#6);
  free ensures {:id "id10406"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#7: int, y#2: int :: { Mod(x#7 + y#2, n#0) } (var z#2 := Mod(x#7, n#0) + Mod(y#2, n#0); (LitInt(0) <= z#2 && z#2 < n#0 && Mod(x#7 + y#2, n#0) == z#2) || (n#0 <= z#2 && z#2 < n#0 + n#0 && Mod(x#7 + y#2, n#0) == z#2 - n#0)));
  free ensures {:id "id10407"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#8: int, y#3: int :: { Mod(x#8 - y#3, n#0) } (var z#3 := Mod(x#8, n#0) - Mod(y#3, n#0); (LitInt(0) <= z#3 && z#3 < n#0 && Mod(x#8 - y#3, n#0) == z#3) || (0 - n#0 <= z#3 && z#3 < 0 && Mod(x#8 - y#3, n#0) == z#3 + n#0)));
  free ensures true;
  free ensures {:id "id10408"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModInductionAuto (correctness)"} Impl$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var i#6: int;
  var ##x#3: int;
  var ##y#3: int;
  var i#8: int;
  var ##x#4: int;
  var ##y#4: int;
  var i#10: int;
  var ##x#5: int;
  var ##y#5: int;
  var n##1: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionAuto", " | ", n#0, " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(330,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(331,19)"} true;
    havoc i#6;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    ##x#3 := LitInt(0);
    assume $IsAlloc(##x#3, TInt, $Heap);
    ##y#3 := i#6;
    assume $IsAlloc(##y#3, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#6);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#6);
    goto anon3;

  anon17_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#6);
    goto anon3;

  anon3:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#6) && i#6 < n#0;
    goto anon5;

  anon18_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#6) && i#6 < n#0);
    goto anon5;

  anon16_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } { GeneralInternals.__default.IsLe(0, i#7) } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#7));
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } { GeneralInternals.__default.IsLe(0, i#7) } GeneralInternals.__default.IsLe(LitInt(0), i#7) && i#7 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(332,51)"} true;
    havoc i#8;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} true;
    ##x#4 := LitInt(0);
    assume $IsAlloc(##x#4, TInt, $Heap);
    ##y#4 := i#8;
    assume $IsAlloc(##y#4, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#8);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon8;

  anon20_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon8;

  anon8:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#8))): bool;
    goto anon10;

  anon21_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#8) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#8))): bool);
    goto anon10;

  anon19_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 + n#0))): bool } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#9));
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 + n#0))): bool } GeneralInternals.__default.IsLe(LitInt(0), i#9) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 + n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(333,80)"} true;
    havoc i#10;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} true;
    ##x#5 := i#10 + 1;
    assume $IsAlloc(##x#5, TInt, $Heap);
    ##y#5 := n#0;
    assume $IsAlloc(##y#5, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#10 + 1, n#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#10 + 1, n#0);
    goto anon13;

  anon23_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#10 + 1, n#0);
    goto anon13;

  anon13:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#10 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool;
    goto anon15;

  anon24_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#10 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool);
    goto anon15;

  anon22_Else:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 - n#0))): bool } GeneralInternals.__default.IsLe#canCall(i#11 + 1, n#0));
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 - n#0))): bool } GeneralInternals.__default.IsLe(i#11 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 - n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(334,84)"} true;
    assume true;
    n##1 := n#0;
    assume true;
    f##0 := f#0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(335,33)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(336,15)"} true;
    return;
}



procedure {:verboseName "ModInternals.LemmaModInductionAutoForall (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModInductionAutoForall (well-formedness)"} CheckWellFormed$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;
  var i#0: int;
  var ##x#0: int;
  var ##y#0: int;
  var i#2: int;
  var ##x#1: int;
  var ##y#1: int;
  var i#4: int;
  var ##x#2: int;
  var ##y#2: int;
  var ##n#1: int;
  var i#6: int;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionAutoForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(341,8): initial state"} true;
    assume n#0 > 0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume ModInternals.__default.ModAuto#canCall(n#0);
    assume ModInternals.__default.ModAuto(n#0);
    havoc i#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    ##x#0 := LitInt(0);
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := i#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon22_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon5:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0;
    goto anon7;

  anon23_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0);
    goto anon7;

  anon21_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
    havoc i#2;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    ##x#1 := LitInt(0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := i#2;
    assume $IsAlloc(##y#1, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon25_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon10:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool;
    goto anon12;

  anon26_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool);
    goto anon12;

  anon24_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
    havoc i#4;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} true;
    ##x#2 := i#4 + 1;
    assume $IsAlloc(##x#2, TInt, $Heap);
    ##y#2 := n#0;
    assume $IsAlloc(##y#2, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#4 + 1, n#0);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon28_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon15:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool;
    goto anon17;

  anon29_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool);
    goto anon17;

  anon27_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon20_Else:
    assume ModInternals.__default.ModAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool) && (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool) && (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon19:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(346,20): post-state"} true;
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume {:subsumption 0} ##n#1 > 0;
    assume ##n#1 > 0;
    assume ModInternals.__default.ModAuto#canCall(n#0);
    assume ModInternals.__default.ModAuto(n#0);
    havoc i#6;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#6))): bool;
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
    return;
}



procedure {:verboseName "ModInternals.LemmaModInductionAutoForall (call precondtion)"} CallPre$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id10428"} n#0 > 0;
  requires {:id "id10429"} ModInternals.__default.ModAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10430"} ModInternals.__default.ModAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10431"} ModInternals.__default.ModAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);



procedure {:verboseName "ModInternals.LemmaModInductionAutoForall (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures ModInternals.__default.ModAuto#canCall(n#0);
  free ensures {:id "id10432"} ModInternals.__default.ModAuto#canCall(n#0) && ModInternals.__default.ModAuto(n#0) && Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#0: int :: { Mod(Mod(x#0, n#0), n#0) } Mod(Mod(x#0, n#0), n#0) == Mod(x#0, n#0)) && (forall x#1: int :: { Mod(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Mod(x#1, n#0) == x#1) && (forall x#2: int, y#0: int :: { Mod(x#2 + y#0, n#0) } (var z#0 := Mod(x#2, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Mod(x#2 + y#0, n#0) == z#0) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Mod(x#2 + y#0, n#0) == z#0 - n#0))) && (forall x#3: int, y#1: int :: { Mod(x#3 - y#1, n#0) } (var z#1 := Mod(x#3, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Mod(x#3 - y#1, n#0) == z#1) || (0 - n#0 <= z#1 && z#1 < 0 && Mod(x#3 - y#1, n#0) == z#1 + n#0)));
  free ensures true;
  free ensures {:id "id10433"} (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "ModInternals.LemmaModInductionAutoForall (correctness)"} Impl$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id10434"} n#0 > 0;
  requires {:id "id10435"} ModInternals.__default.ModAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10436"} ModInternals.__default.ModAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10437"} ModInternals.__default.ModAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
  modifies $Heap;
  free ensures ModInternals.__default.ModAuto#canCall(n#0);
  free ensures {:id "id10438"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || Mod(n#0, n#0) == Mod(0 - n#0, n#0);
  free ensures {:id "id10439"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || Mod(0 - n#0, n#0) == LitInt(0);
  free ensures {:id "id10440"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#4: int :: { Mod(Mod(x#4, n#0), n#0) } Mod(Mod(x#4, n#0), n#0) == Mod(x#4, n#0));
  free ensures {:id "id10441"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#5: int :: { Mod(x#5, n#0) } LitInt(0) <= x#5 && x#5 < n#0 <==> Mod(x#5, n#0) == x#5);
  free ensures {:id "id10442"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#6: int, y#2: int :: { Mod(x#6 + y#2, n#0) } (var z#2 := Mod(x#6, n#0) + Mod(y#2, n#0); (LitInt(0) <= z#2 && z#2 < n#0 && Mod(x#6 + y#2, n#0) == z#2) || (n#0 <= z#2 && z#2 < n#0 + n#0 && Mod(x#6 + y#2, n#0) == z#2 - n#0)));
  free ensures {:id "id10443"} ModInternals.__default.ModAuto#canCall(n#0) ==> ModInternals.__default.ModAuto(n#0) || (forall x#7: int, y#3: int :: { Mod(x#7 - y#3, n#0) } (var z#3 := Mod(x#7, n#0) - Mod(y#3, n#0); (LitInt(0) <= z#3 && z#3 < n#0 && Mod(x#7 - y#3, n#0) == z#3) || (0 - n#0 <= z#3 && z#3 < 0 && Mod(x#7 - y#3, n#0) == z#3 + n#0)));
  free ensures true;
  free ensures {:id "id10444"} (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "ModInternals.LemmaModInductionAutoForall (correctness)"} Impl$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var i#8: int;
  var ##x#3: int;
  var ##y#3: int;
  var i#10: int;
  var ##x#4: int;
  var ##y#4: int;
  var i#12: int;
  var ##x#5: int;
  var ##y#5: int;
  var n##1: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionAutoForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(348,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(349,19)"} true;
    havoc i#8;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    ##x#3 := LitInt(0);
    assume $IsAlloc(##x#3, TInt, $Heap);
    ##y#3 := i#8;
    assume $IsAlloc(##y#3, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#8);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon3;

  anon17_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon3;

  anon3:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8) && i#8 < n#0;
    goto anon5;

  anon18_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#8) && i#8 < n#0);
    goto anon5;

  anon16_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool } { GeneralInternals.__default.IsLe(0, i#9) } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#9));
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool } { GeneralInternals.__default.IsLe(0, i#9) } GeneralInternals.__default.IsLe(LitInt(0), i#9) && i#9 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(350,51)"} true;
    havoc i#10;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} true;
    ##x#4 := LitInt(0);
    assume $IsAlloc(##x#4, TInt, $Heap);
    ##y#4 := i#10;
    assume $IsAlloc(##y#4, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#10);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#10);
    goto anon8;

  anon20_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#10);
    goto anon8;

  anon8:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#10) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool;
    goto anon10;

  anon21_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#10) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool);
    goto anon10;

  anon19_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 + n#0))): bool } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#11));
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 + n#0))): bool } GeneralInternals.__default.IsLe(LitInt(0), i#11) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 + n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(351,80)"} true;
    havoc i#12;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} true;
    ##x#5 := i#12 + 1;
    assume $IsAlloc(##x#5, TInt, $Heap);
    ##y#5 := n#0;
    assume $IsAlloc(##y#5, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#12 + 1, n#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#12 + 1, n#0);
    goto anon13;

  anon23_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#12 + 1, n#0);
    goto anon13;

  anon13:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#12 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#12))): bool;
    goto anon15;

  anon24_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#12 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#12))): bool);
    goto anon15;

  anon22_Else:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume (forall i#13: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13 - n#0))): bool } GeneralInternals.__default.IsLe#canCall(i#13 + 1, n#0));
    assume (forall i#13: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13 - n#0))): bool } GeneralInternals.__default.IsLe(i#13 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13 - n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(352,84)"} true;
    assume true;
    n##1 := n#0;
    assume true;
    f##0 := f#0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/ModInternals.dfy(353,33)"} true;
    return;
}



procedure {:verboseName "ModInternals.reveal_ModRecursive (well-formedness)"} {:verify false} CheckWellFormed$$ModInternals.__default.reveal__ModRecursive();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ModInternals.reveal_ModRecursive (call precondtion)"} {:verify false} CallPre$$ModInternals.__default.reveal__ModRecursive();



procedure {:verboseName "ModInternals.reveal_ModRecursive (call postcondition)"} {:verify false} CallPost$$ModInternals.__default.reveal__ModRecursive();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_ModInternals._default.ModRecursive;



axiom MulInternals.__default.MulAuto() <==> (forall x#18: int, y#18: int :: { Mul(x#18, y#18) } Mul(x#18, y#18) == Mul(y#18, x#18)) && (forall x#19: int, y#19: int, z#12: int :: { Mul(x#19 + y#19, z#12) } Mul(x#19 + y#19, z#12) == Mul(x#19, z#12) + Mul(y#19, z#12)) && (forall x#20: int, y#20: int, z#13: int :: { Mul(x#20 - y#20, z#13) } Mul(x#20 - y#20, z#13) == Mul(x#20, z#13) - Mul(y#20, z#13));

axiom MulInternals.__default.MulAuto() <==> (forall x#21: int, y#21: int :: { Mul(x#21, y#21) } Mul(x#21, y#21) == Mul(y#21, x#21)) && (forall x#22: int, y#22: int, z#14: int :: { Mul(x#22 + y#22, z#14) } Mul(x#22 + y#22, z#14) == Mul(x#22, z#14) + Mul(y#22, z#14)) && (forall x#23: int, y#23: int, z#15: int :: { Mul(x#23 - y#23, z#15) } Mul(x#23 - y#23, z#15) == Mul(x#23, z#15) - Mul(y#23, z#15));

const reveal_DivInternals._default.DivPos: bool;

const reveal_DivInternals._default.DivRecursive: bool;

const unique class.DivInternals.__default: ClassName;

function DivInternals.__default.DivPos($ly: LayerType, $reveal: bool, x#0: int, d#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: int, d#0: int :: { DivInternals.__default.DivPos($LS($ly), true, x#0, d#0) } DivInternals.__default.DivPos#canCall(x#0, d#0) || (0 < $FunctionContextHeight && d#0 > 0) ==> (x#0 < 0 ==> DivInternals.__default.DivPos#canCall(x#0 + d#0, d#0)) && (0 <= x#0 ==> d#0 <= x#0 ==> DivInternals.__default.DivPos#canCall(x#0 - d#0, d#0)) && DivInternals.__default.DivPos($LS($ly), true, x#0, d#0) == (if x#0 < 0 then -1 + DivInternals.__default.DivPos($ly, reveal_DivInternals._default.DivPos, x#0 + d#0, d#0) else (if x#0 < d#0 then 0 else 1 + DivInternals.__default.DivPos($ly, reveal_DivInternals._default.DivPos, x#0 - d#0, d#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: int, d#0: int :: {:weight 3} { DivInternals.__default.DivPos($LS($ly), true, LitInt(x#0), LitInt(d#0)) } DivInternals.__default.DivPos#canCall(LitInt(x#0), LitInt(d#0)) || (0 < $FunctionContextHeight && Lit(d#0 > 0)) ==> (Lit(x#0 < 0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0 + d#0), LitInt(d#0))) && (!Lit(x#0 < 0) ==> !Lit(x#0 < d#0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0 - d#0), LitInt(d#0))) && DivInternals.__default.DivPos($LS($ly), true, LitInt(x#0), LitInt(d#0)) == (if x#0 < 0 then -1 + DivInternals.__default.DivPos($LS($ly), reveal_DivInternals._default.DivPos, LitInt(x#0 + d#0), LitInt(d#0)) else (if x#0 < d#0 then 0 else 1 + DivInternals.__default.DivPos($LS($ly), reveal_DivInternals._default.DivPos, LitInt(x#0 - d#0), LitInt(d#0)))));
}

function DivInternals.__default.DivPos#canCall(x#0: int, d#0: int) : bool;

axiom (forall $ly: LayerType, $reveal: bool, x#0: int, d#0: int :: { DivInternals.__default.DivPos($LS($ly), $reveal, x#0, d#0) } DivInternals.__default.DivPos($LS($ly), $reveal, x#0, d#0) == DivInternals.__default.DivPos($ly, $reveal, x#0, d#0));

axiom (forall $ly: LayerType, $reveal: bool, x#0: int, d#0: int :: { DivInternals.__default.DivPos(AsFuelBottom($ly), $reveal, x#0, d#0) } DivInternals.__default.DivPos($ly, $reveal, x#0, d#0) == DivInternals.__default.DivPos($LZ, $reveal, x#0, d#0));

function DivInternals.__default.DivPos#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, x#0: int, d#0: int :: { DivInternals.__default.DivPos#requires($ly, x#0, d#0) } DivInternals.__default.DivPos#requires($ly, x#0, d#0) <==> d#0 > 0);

procedure {:verboseName "DivInternals.DivPos (well-formedness)"} CheckWellformed$$DivInternals.__default.DivPos(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.DivPos (well-formedness)"} CheckWellformed$$DivInternals.__default.DivPos(x#0: int, d#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##d#0: int;
  var ##x#1: int;
  var ##d#1: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.DivPos", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(33,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume d#0 > 0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#0 < 0;
    goto anon4;

  anon11_Else:
    assume {:partition} 0 <= x#0;
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} x#0 < 0;
    ##x#0 := x#0 + d#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 > 0;
    assume ##d#0 > 0;
    assume 0 <= (if x#0 < 0 then d#0 - x#0 else x#0) || (if ##x#0 < 0 then ##d#0 - ##x#0 else ##x#0) == (if x#0 < 0 then d#0 - x#0 else x#0);
    assume (if ##x#0 < 0 then ##d#0 - ##x#0 else ##x#0) < (if x#0 < 0 then d#0 - x#0 else x#0);
    assume DivInternals.__default.DivPos#canCall(x#0 + d#0, d#0);
    assume DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0) == -1 + DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0 + d#0, d#0);
    assume DivInternals.__default.DivPos#canCall(x#0 + d#0, d#0);
    assume $Is(DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0), TInt);
    return;

  anon13_Else:
    assume {:partition} 0 <= x#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} x#0 < d#0;
    assume DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0) == LitInt(0);
    assume true;
    assume $Is(DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0), TInt);
    return;

  anon14_Else:
    assume {:partition} d#0 <= x#0;
    ##x#1 := x#0 - d#0;
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##d#1 := d#0;
    assume $IsAlloc(##d#1, TInt, $Heap);
    assume {:subsumption 0} ##d#1 > 0;
    assume ##d#1 > 0;
    assume 0 <= (if x#0 < 0 then d#0 - x#0 else x#0) || (if ##x#1 < 0 then ##d#1 - ##x#1 else ##x#1) == (if x#0 < 0 then d#0 - x#0 else x#0);
    assume (if ##x#1 < 0 then ##d#1 - ##x#1 else ##x#1) < (if x#0 < 0 then d#0 - x#0 else x#0);
    assume DivInternals.__default.DivPos#canCall(x#0 - d#0, d#0);
    assume DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0) == 1 + DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0 - d#0, d#0);
    assume DivInternals.__default.DivPos#canCall(x#0 - d#0, d#0);
    assume $Is(DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0), TInt);
    return;
}



function DivInternals.__default.DivRecursive($reveal: bool, x#0: int, d#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, d#0: int :: { DivInternals.__default.DivRecursive(true, x#0, d#0) } DivInternals.__default.DivRecursive#canCall(x#0, d#0) || (1 < $FunctionContextHeight && d#0 != 0) ==> (d#0 > 0 ==> DivInternals.__default.DivPos#canCall(x#0, d#0)) && (0 >= d#0 ==> DivInternals.__default.DivPos#canCall(x#0, Mul(LitInt(-1), d#0))) && DivInternals.__default.DivRecursive(true, x#0, d#0) == (if d#0 > 0 then DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0) else Mul(LitInt(-1), DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, Mul(LitInt(-1), d#0)))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, d#0: int :: {:weight 3} { DivInternals.__default.DivRecursive(true, LitInt(x#0), LitInt(d#0)) } DivInternals.__default.DivRecursive#canCall(LitInt(x#0), LitInt(d#0)) || (1 < $FunctionContextHeight && Lit(d#0 != 0)) ==> (Lit(d#0 > 0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0), LitInt(d#0))) && (!Lit(d#0 > 0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0), LitInt(Mul(LitInt(-1), LitInt(d#0))))) && DivInternals.__default.DivRecursive(true, LitInt(x#0), LitInt(d#0)) == (if d#0 > 0 then DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, LitInt(x#0), LitInt(d#0)) else Mul(LitInt(-1), DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, LitInt(x#0), LitInt(Mul(LitInt(-1), LitInt(d#0)))))));
}

function DivInternals.__default.DivRecursive#canCall(x#0: int, d#0: int) : bool;

function DivInternals.__default.DivRecursive#requires(int, int) : bool;

axiom (forall x#0: int, d#0: int :: { DivInternals.__default.DivRecursive#requires(x#0, d#0) } DivInternals.__default.DivRecursive#requires(x#0, d#0) <==> d#0 != 0);

procedure {:verboseName "DivInternals.DivRecursive (well-formedness)"} CheckWellformed$$DivInternals.__default.DivRecursive(x#0: int, d#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.DivRecursive (well-formedness)"} CheckWellformed$$DivInternals.__default.DivRecursive(x#0: int, d#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##d#0: int;
  var ##x#1: int;
  var ##d#1: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.DivRecursive", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(46,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    call CallPre$$DivInternals.__default.reveal__DivPos();
    call CallPost$$DivInternals.__default.reveal__DivPos();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(49,18)"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} d#0 > 0;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 > 0;
    assume ##d#0 > 0;
    assume DivInternals.__default.DivPos#canCall(x#0, d#0);
    assume DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0);
    assume DivInternals.__default.DivPos#canCall(x#0, d#0);
    assume $Is(DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0), TInt);
    return;

  anon7_Else:
    assume {:partition} 0 >= d#0;
    ##x#1 := x#0;
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##d#1 := Mul(LitInt(-1), d#0);
    assume $IsAlloc(##d#1, TInt, $Heap);
    assume {:subsumption 0} ##d#1 > 0;
    assume ##d#1 > 0;
    assume DivInternals.__default.DivPos#canCall(x#0, Mul(LitInt(-1), d#0));
    assume DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == Mul(LitInt(-1), DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, Mul(LitInt(-1), d#0)));
    assume DivInternals.__default.DivPos#canCall(x#0, Mul(LitInt(-1), d#0));
    assume $Is(DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0), TInt);
    return;
}



procedure {:verboseName "DivInternals.LemmaDivBasics (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivBasics(n#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivBasics (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivBasics(n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var x#2: int;
  var x#4: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivBasics", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(57,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(59,19): post-state"} true;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
    assume n#0 != 0;
    goto anon3;

  anon6_Else:
    assume {:partition} Div(n#0, n#0) != 0 - Div(0 - n#0, n#0);
    goto anon3;

  anon3:
    assume Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1);
    havoc x#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon5;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon5;

  anon5:
    assume n#0 != 0;
    assume LitInt(0) <= x#0 && x#0 < n#0 <==> Div(x#0, n#0) == LitInt(0);
    assume (forall x#1: int :: { Div(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Div(x#1, n#0) == LitInt(0));
    havoc x#2;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Div(x#2 + n#0, n#0) == Div(x#2, n#0) + 1;
    assume (forall x#3: int :: { Div(x#3 + n#0, n#0) } Div(x#3 + n#0, n#0) == Div(x#3, n#0) + 1);
    havoc x#4;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume Div(x#4 - n#0, n#0) == Div(x#4, n#0) - 1;
    assume (forall x#5: int :: { Div(x#5 - n#0, n#0) } Div(x#5 - n#0, n#0) == Div(x#5, n#0) - 1);
    return;
}



procedure {:verboseName "DivInternals.LemmaDivBasics (call precondtion)"} CallPre$$DivInternals.__default.LemmaDivBasics(n#0: int);
  requires {:id "id10509"} n#0 > 0;



procedure {:verboseName "DivInternals.LemmaDivBasics (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivBasics(n#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10510"} Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
  free ensures {:id "id10511"} 0 - Div(0 - n#0, n#0) == LitInt(1);
  free ensures true;
  free ensures {:id "id10512"} (forall x#1: int :: { Div(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Div(x#1, n#0) == LitInt(0));
  free ensures true;
  free ensures {:id "id10513"} (forall x#3: int :: { Div(x#3 + n#0, n#0) } Div(x#3 + n#0, n#0) == Div(x#3, n#0) + 1);
  free ensures true;
  free ensures {:id "id10514"} (forall x#5: int :: { Div(x#5 - n#0, n#0) } Div(x#5 - n#0, n#0) == Div(x#5, n#0) - 1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternals.LemmaDivBasics (correctness)"} Impl$$DivInternals.__default.LemmaDivBasics(n#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10515"} n#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10516"} Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
  free ensures {:id "id10517"} 0 - Div(0 - n#0, n#0) == LitInt(1);
  free ensures true;
  free ensures {:id "id10518"} (forall x#1: int :: { Div(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Div(x#1, n#0) == LitInt(0));
  free ensures true;
  free ensures {:id "id10519"} (forall x#3: int :: { Div(x#3 + n#0, n#0) } Div(x#3 + n#0, n#0) == Div(x#3, n#0) + 1);
  free ensures true;
  free ensures {:id "id10520"} (forall x#5: int :: { Div(x#5 - n#0, n#0) } Div(x#5 - n#0, n#0) == Div(x#5, n#0) - 1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivBasics (correctness)"} Impl$$DivInternals.__default.LemmaDivBasics(n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var n##1: int;
  var d##0: int;
  var x#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivBasics", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(63,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(64,19)"} true;
    assume true;
    n##1 := n#0;
    call CallPre$$ModInternals.__default.LemmaModBasics(n##1);
    call CallPost$$ModInternals.__default.LemmaModBasics(n##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(65,21)"} true;
    call CallPre$$DivInternalsNonlinear.__default.LemmaSmallDiv();
    call CallPost$$DivInternalsNonlinear.__default.LemmaSmallDiv();
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(66,19)"} true;
    assume true;
    d##0 := n#0;
    call CallPre$$DivInternalsNonlinear.__default.LemmaDivBySelf(d##0);
    call CallPost$$DivInternalsNonlinear.__default.LemmaDivBySelf(d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(67,21)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0;
    assume true;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(x#0_0, n#0) == LitInt(0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon4;

  anon10_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon4;

  anon4:
    assume true;
    assume LitInt(0) <= x#0_0 && x#0_0 < n#0;
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := n#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(71,34)"} true;
    assume LitInt(0) <= x#0_0;
    assume x#0_0 < n#0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int :: { Div(x#0_1, n#0) } Div(x#0_1, n#0) == LitInt(0) ==> LitInt(0) <= x#0_1 && x#0_1 < n#0);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(72,4)"} true;
    return;
}



function DivInternals.__default.DivAuto(n#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || (0 < $FunctionContextHeight && n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#0: int :: { Div(x#0, n#0) } LitInt(0) <= x#0 && x#0 < n#0 <==> Div(x#0, n#0) == LitInt(0)) && (forall x#1: int, y#0: int :: { Div(x#1 + y#0, n#0) } (var z#0 := Mod(x#1, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Div(x#1 + y#0, n#0) == Div(x#1, n#0) + Div(y#0, n#0)) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Div(x#1 + y#0, n#0) == Div(x#1, n#0) + Div(y#0, n#0) + 1))) && (forall x#2: int, y#1: int :: { Div(x#2 - y#1, n#0) } (var z#1 := Mod(x#2, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Div(x#2 - y#1, n#0) == Div(x#2, n#0) - Div(y#1, n#0)) || (0 - n#0 <= z#1 && z#1 < 0 && Div(x#2 - y#1, n#0) == Div(x#2, n#0) - Div(y#1, n#0) - 1)))));
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || (0 < $FunctionContextHeight && Lit(n#0 > 0)) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#3: int :: { Div(x#3, n#0) } LitInt(0) <= x#3 && x#3 < n#0 <==> Div(x#3, LitInt(n#0)) == LitInt(0)) && (forall x#4: int, y#2: int :: { Div(x#4 + y#2, n#0) } (var z#2 := Mod(x#4, LitInt(n#0)) + Mod(y#2, LitInt(n#0)); (LitInt(0) <= z#2 && z#2 < n#0 && Div(x#4 + y#2, LitInt(n#0)) == Div(x#4, LitInt(n#0)) + Div(y#2, LitInt(n#0))) || (LitInt(n#0) <= z#2 && z#2 < n#0 + n#0 && Div(x#4 + y#2, LitInt(n#0)) == Div(x#4, LitInt(n#0)) + Div(y#2, LitInt(n#0)) + 1))) && (forall x#5: int, y#3: int :: { Div(x#5 - y#3, n#0) } (var z#3 := Mod(x#5, LitInt(n#0)) - Mod(y#3, LitInt(n#0)); (LitInt(0) <= z#3 && z#3 < n#0 && Div(x#5 - y#3, LitInt(n#0)) == Div(x#5, LitInt(n#0)) - Div(y#3, LitInt(n#0))) || (LitInt(0 - n#0) <= z#3 && z#3 < 0 && Div(x#5 - y#3, LitInt(n#0)) == Div(x#5, LitInt(n#0)) - Div(y#3, LitInt(n#0)) - 1)))));
}

function DivInternals.__default.DivAuto#canCall(n#0: int) : bool;

function DivInternals.__default.DivAuto#requires(int) : bool;

axiom (forall n#0: int :: { DivInternals.__default.DivAuto#requires(n#0) } DivInternals.__default.DivAuto#requires(n#0) <==> n#0 > 0);

procedure {:verboseName "DivInternals.DivAuto (well-formedness)"} CheckWellformed$$DivInternals.__default.DivAuto(n#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.DivAuto (well-formedness)"} CheckWellformed$$DivInternals.__default.DivAuto(n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##n#0: int;
  var x#6: int;
  var x#7: int;
  var y#4: int;
  var z#Z#0: int;
  var let#0#0#0: int;
  var x#9: int;
  var y#5: int;
  var z#Z#1: int;
  var let#1#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.DivAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(78,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume n#0 > 0;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume false;
    return;

  anon37_Else:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume ModInternals.__default.ModAuto#canCall(n#0);
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} ModInternals.__default.ModAuto(n#0);
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
    assume n#0 != 0;
    goto anon6;

  anon39_Else:
    assume {:partition} Div(n#0, n#0) != 0 - Div(0 - n#0, n#0);
    goto anon6;

  anon38_Else:
    assume {:partition} !ModInternals.__default.ModAuto(n#0);
    goto anon6;

  anon6:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1);
    havoc x#6;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} true;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} LitInt(0) <= x#6;
    goto anon10;

  anon42_Else:
    assume {:partition} x#6 < LitInt(0);
    goto anon10;

  anon10:
    assume n#0 != 0;
    goto anon11;

  anon41_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    goto anon12;

  anon40_Else:
    assume {:partition} !(ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1));
    goto anon12;

  anon12:
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#8: int :: { Div(x#8, n#0) } LitInt(0) <= x#8 && x#8 < n#0 <==> Div(x#8, n#0) == LitInt(0));
    havoc x#7;
    havoc y#4;
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} true;
    havoc z#Z#0;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume let#0#0#0 == Mod(x#7, n#0) + Mod(y#4, n#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume z#Z#0 == let#0#0#0;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} LitInt(0) <= z#Z#0;
    goto anon16;

  anon45_Else:
    assume {:partition} z#Z#0 < LitInt(0);
    goto anon16;

  anon16:
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} LitInt(0) <= z#Z#0 && z#Z#0 < n#0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon18;

  anon46_Else:
    assume {:partition} !(LitInt(0) <= z#Z#0 && z#Z#0 < n#0);
    goto anon18;

  anon18:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} !(LitInt(0) <= z#Z#0 && z#Z#0 < n#0 && Div(x#7 + y#4, n#0) == Div(x#7, n#0) + Div(y#4, n#0));
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} n#0 <= z#Z#0;
    goto anon21;

  anon48_Else:
    assume {:partition} z#Z#0 < n#0;
    goto anon21;

  anon21:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} n#0 <= z#Z#0 && z#Z#0 < n#0 + n#0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon23;

  anon49_Else:
    assume {:partition} !(n#0 <= z#Z#0 && z#Z#0 < n#0 + n#0);
    goto anon23;

  anon47_Else:
    assume {:partition} LitInt(0) <= z#Z#0 && z#Z#0 < n#0 && Div(x#7 + y#4, n#0) == Div(x#7, n#0) + Div(y#4, n#0);
    goto anon23;

  anon44_Else:
    assume {:partition} false;
    goto anon23;

  anon23:
    goto anon24;

  anon43_Else:
    assume {:partition} !(ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#8: int :: { Div(x#8, n#0) } LitInt(0) <= x#8 && x#8 < n#0 <==> Div(x#8, n#0) == LitInt(0)));
    goto anon24;

  anon24:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#8: int :: { Div(x#8, n#0) } LitInt(0) <= x#8 && x#8 < n#0 <==> Div(x#8, n#0) == LitInt(0)) && (forall x#10: int, y#6: int :: { Div(x#10 + y#6, n#0) } (var z#4 := Mod(x#10, n#0) + Mod(y#6, n#0); (LitInt(0) <= z#4 && z#4 < n#0 && Div(x#10 + y#6, n#0) == Div(x#10, n#0) + Div(y#6, n#0)) || (n#0 <= z#4 && z#4 < n#0 + n#0 && Div(x#10 + y#6, n#0) == Div(x#10, n#0) + Div(y#6, n#0) + 1)));
    havoc x#9;
    havoc y#5;
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} true;
    havoc z#Z#1;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume let#1#0#0 == Mod(x#9, n#0) - Mod(y#5, n#0);
    assume true;
    assume $Is(let#1#0#0, TInt);
    assume z#Z#1 == let#1#0#0;
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} LitInt(0) <= z#Z#1;
    goto anon28;

  anon52_Else:
    assume {:partition} z#Z#1 < LitInt(0);
    goto anon28;

  anon28:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} LitInt(0) <= z#Z#1 && z#Z#1 < n#0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon30;

  anon53_Else:
    assume {:partition} !(LitInt(0) <= z#Z#1 && z#Z#1 < n#0);
    goto anon30;

  anon30:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} !(LitInt(0) <= z#Z#1 && z#Z#1 < n#0 && Div(x#9 - y#5, n#0) == Div(x#9, n#0) - Div(y#5, n#0));
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} 0 - n#0 <= z#Z#1;
    goto anon33;

  anon55_Else:
    assume {:partition} z#Z#1 < 0 - n#0;
    goto anon33;

  anon33:
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} 0 - n#0 <= z#Z#1 && z#Z#1 < 0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon35;

  anon56_Else:
    assume {:partition} !(0 - n#0 <= z#Z#1 && z#Z#1 < 0);
    goto anon35;

  anon54_Else:
    assume {:partition} LitInt(0) <= z#Z#1 && z#Z#1 < n#0 && Div(x#9 - y#5, n#0) == Div(x#9, n#0) - Div(y#5, n#0);
    goto anon35;

  anon51_Else:
    assume {:partition} false;
    goto anon35;

  anon35:
    goto anon36;

  anon50_Else:
    assume {:partition} !(ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#8: int :: { Div(x#8, n#0) } LitInt(0) <= x#8 && x#8 < n#0 <==> Div(x#8, n#0) == LitInt(0)) && (forall x#10: int, y#6: int :: { Div(x#10 + y#6, n#0) } (var z#4 := Mod(x#10, n#0) + Mod(y#6, n#0); (LitInt(0) <= z#4 && z#4 < n#0 && Div(x#10 + y#6, n#0) == Div(x#10, n#0) + Div(y#6, n#0)) || (n#0 <= z#4 && z#4 < n#0 + n#0 && Div(x#10 + y#6, n#0) == Div(x#10, n#0) + Div(y#6, n#0) + 1))));
    goto anon36;

  anon36:
    assume DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#8: int :: { Div(x#8, n#0) } LitInt(0) <= x#8 && x#8 < n#0 <==> Div(x#8, n#0) == LitInt(0)) && (forall x#10: int, y#6: int :: { Div(x#10 + y#6, n#0) } (var z#4 := Mod(x#10, n#0) + Mod(y#6, n#0); (LitInt(0) <= z#4 && z#4 < n#0 && Div(x#10 + y#6, n#0) == Div(x#10, n#0) + Div(y#6, n#0)) || (n#0 <= z#4 && z#4 < n#0 + n#0 && Div(x#10 + y#6, n#0) == Div(x#10, n#0) + Div(y#6, n#0) + 1))) && (forall x#11: int, y#7: int :: { Div(x#11 - y#7, n#0) } (var z#5 := Mod(x#11, n#0) - Mod(y#7, n#0); (LitInt(0) <= z#5 && z#5 < n#0 && Div(x#11 - y#7, n#0) == Div(x#11, n#0) - Div(y#7, n#0)) || (0 - n#0 <= z#5 && z#5 < 0 && Div(x#11 - y#7, n#0) == Div(x#11, n#0) - Div(y#7, n#0) - 1)));
    assume ModInternals.__default.ModAuto#canCall(n#0);
    assume $Is(DivInternals.__default.DivAuto(n#0), TBool);
    return;
}



procedure {:verboseName "DivInternals.LemmaDivAuto (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivAuto(n#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivAuto (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivAuto(n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(95,8): initial state"} true;
    assume n#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(97,20): post-state"} true;
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume DivInternals.__default.DivAuto#canCall(n#0);
    assume DivInternals.__default.DivAuto(n#0);
    return;
}



procedure {:verboseName "DivInternals.LemmaDivAuto (call precondtion)"} CallPre$$DivInternals.__default.LemmaDivAuto(n#0: int);
  requires {:id "id10566"} n#0 > 0;



procedure {:verboseName "DivInternals.LemmaDivAuto (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivAuto(n#0: int);
  modifies $Heap;
  free ensures DivInternals.__default.DivAuto#canCall(n#0);
  free ensures {:id "id10567"} DivInternals.__default.DivAuto#canCall(n#0) && DivInternals.__default.DivAuto(n#0) && ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#0: int :: { Div(x#0, n#0) } LitInt(0) <= x#0 && x#0 < n#0 <==> Div(x#0, n#0) == LitInt(0)) && (forall x#1: int, y#0: int :: { Div(x#1 + y#0, n#0) } (var z#0 := Mod(x#1, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Div(x#1 + y#0, n#0) == Div(x#1, n#0) + Div(y#0, n#0)) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Div(x#1 + y#0, n#0) == Div(x#1, n#0) + Div(y#0, n#0) + 1))) && (forall x#2: int, y#1: int :: { Div(x#2 - y#1, n#0) } (var z#1 := Mod(x#2, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Div(x#2 - y#1, n#0) == Div(x#2, n#0) - Div(y#1, n#0)) || (0 - n#0 <= z#1 && z#1 < 0 && Div(x#2 - y#1, n#0) == Div(x#2, n#0) - Div(y#1, n#0) - 1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternals.LemmaDivAuto (correctness)"} Impl$$DivInternals.__default.LemmaDivAuto(n#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id10568"} n#0 > 0;
  modifies $Heap;
  free ensures DivInternals.__default.DivAuto#canCall(n#0);
  free ensures {:id "id10569"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || ModInternals.__default.ModAuto(n#0);
  free ensures {:id "id10570"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
  free ensures {:id "id10571"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || 0 - Div(0 - n#0, n#0) == LitInt(1);
  free ensures {:id "id10572"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#3: int :: { Div(x#3, n#0) } LitInt(0) <= x#3 && x#3 < n#0 <==> Div(x#3, n#0) == LitInt(0));
  free ensures {:id "id10573"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#4: int, y#2: int :: { Div(x#4 + y#2, n#0) } (var z#2 := Mod(x#4, n#0) + Mod(y#2, n#0); (LitInt(0) <= z#2 && z#2 < n#0 && Div(x#4 + y#2, n#0) == Div(x#4, n#0) + Div(y#2, n#0)) || (n#0 <= z#2 && z#2 < n#0 + n#0 && Div(x#4 + y#2, n#0) == Div(x#4, n#0) + Div(y#2, n#0) + 1)));
  free ensures {:id "id10574"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#5: int, y#3: int :: { Div(x#5 - y#3, n#0) } (var z#3 := Mod(x#5, n#0) - Mod(y#3, n#0); (LitInt(0) <= z#3 && z#3 < n#0 && Div(x#5 - y#3, n#0) == Div(x#5, n#0) - Div(y#3, n#0)) || (0 - n#0 <= z#3 && z#3 < 0 && Div(x#5 - y#3, n#0) == Div(x#5, n#0) - Div(y#3, n#0) - 1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivAuto (correctness)"} Impl$$DivInternals.__default.LemmaDivAuto(n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var n##1: int;
  var x#0_0: int;
  var y#0_0: int;
  var z#Z#0_0: int;
  var let#0_0#0#0: int;
  var f#0_0: HandleType where $Is(f#0_0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool)) && $IsAlloc(f#0_0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool), $Heap);
  var $lambdaHeap#0_0: Heap;
  var xx#0_0: int;
  var yy#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: bool;
  var z#Z#0_1: int;
  var let#0_1#0#0: int;
  var i#0_0_0: int;
  var j#0_0_0: int;
  var i#0_1_0: int;
  var j#0_1_0: int;
  var n##0_0: int;
  var f##0_0: HandleType;
  var x#1_0: int;
  var y#1_0: int;
  var z#Z#1_0: int;
  var let#1_0#0#0: int;
  var f#1_0: HandleType where $Is(f#1_0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool)) && $IsAlloc(f#1_0, Tclass._System.___hTotalFunc2(TInt, TInt, TBool), $Heap);
  var $lambdaHeap#1_0: Heap;
  var xx#1_0: int;
  var yy#1_0: int;
  var $_Frame#l1_0: [ref,Field]bool;
  var lambdaResult#1_0: bool;
  var z#Z#1_1: int;
  var let#1_1#0#0: int;
  var i#1_0_0: int;
  var j#1_0_0: int;
  var i#1_1_0: int;
  var j#1_1_0: int;
  var n##1_0: int;
  var f##1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(98,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(99,19)"} true;
    assume true;
    n##1 := n#0;
    call CallPre$$DivInternals.__default.LemmaDivBasics(n##1);
    call CallPost$$DivInternals.__default.LemmaDivBasics(n##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(100,21)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(0 + n#0, n#0) == LitInt(1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(101,27)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(0 - n#0, n#0) == LitInt(-1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(102,28)"} true;
    goto anon121_Then, anon121_Else;

  anon121_Then:
    havoc x#0_0, y#0_0;
    assume true;
    assume true;
    assume true;
    goto anon122_Then, anon122_Else;

  anon122_Then:
    havoc z#Z#0_0;
    assume true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume let#0_0#0#0 == Mod(x#0_0, n#0) + Mod(y#0_0, n#0);
    assume true;
    assume $Is(let#0_0#0#0, TInt);
    assume z#Z#0_0 == let#0_0#0#0;
    goto anon123_Then, anon123_Else;

  anon123_Then:
    assume {:partition} LitInt(0) <= z#Z#0_0;
    goto anon4;

  anon123_Else:
    assume {:partition} z#Z#0_0 < LitInt(0);
    goto anon4;

  anon4:
    goto anon124_Then, anon124_Else;

  anon124_Then:
    assume {:partition} LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    goto anon6;

  anon124_Else:
    assume {:partition} !(LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0);
    goto anon6;

  anon6:
    goto anon125_Then, anon125_Else;

  anon125_Then:
    assume {:partition} !(LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0 && Div(x#0_0 + y#0_0, n#0) == Div(x#0_0, n#0) + Div(y#0_0, n#0));
    goto anon126_Then, anon126_Else;

  anon126_Then:
    assume {:partition} n#0 <= z#Z#0_0;
    goto anon9;

  anon126_Else:
    assume {:partition} z#Z#0_0 < n#0;
    goto anon9;

  anon9:
    goto anon127_Then, anon127_Else;

  anon127_Then:
    assume {:partition} n#0 <= z#Z#0_0 && z#Z#0_0 < Mul(LitInt(2), n#0);
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    goto anon11;

  anon127_Else:
    assume {:partition} !(n#0 <= z#Z#0_0 && z#Z#0_0 < Mul(LitInt(2), n#0));
    goto anon11;

  anon125_Else:
    assume {:partition} LitInt(0) <= z#Z#0_0 && z#Z#0_0 < n#0 && Div(x#0_0 + y#0_0, n#0) == Div(x#0_0, n#0) + Div(y#0_0, n#0);
    goto anon11;

  anon11:
    assume true;
    assume (var z#0_0 := Mod(x#0_0, n#0) + Mod(y#0_0, n#0); (LitInt(0) <= z#0_0 && z#0_0 < n#0 && Div(x#0_0 + y#0_0, n#0) == Div(x#0_0, n#0) + Div(y#0_0, n#0)) || (n#0 <= z#0_0 && z#0_0 < Mul(LitInt(2), n#0) && Div(x#0_0 + y#0_0, n#0) == Div(x#0_0, n#0) + Div(y#0_0, n#0) + 1));
    assume false;
    goto anon12;

  anon122_Else:
    goto anon12;

  anon12:
    push;
    assume true;
    goto anon128_Then, anon128_Else;

  anon128_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc xx#0_0;
    havoc yy#0_0;
    goto anon129_Then, anon129_Else;

  anon129_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    havoc z#Z#0_1;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume let#0_1#0#0 == Mod(xx#0_0, n#0) + Mod(yy#0_0, n#0);
    assume true;
    assume $Is(let#0_1#0#0, TInt);
    assume z#Z#0_1 == let#0_1#0#0;
    goto anon130_Then, anon130_Else;

  anon130_Then:
    assume {:partition} LitInt(0) <= z#Z#0_1;
    goto anon16;

  anon130_Else:
    assume {:partition} z#Z#0_1 < LitInt(0);
    goto anon16;

  anon16:
    goto anon131_Then, anon131_Else;

  anon131_Then:
    assume {:partition} LitInt(0) <= z#Z#0_1 && z#Z#0_1 < n#0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon18;

  anon131_Else:
    assume {:partition} !(LitInt(0) <= z#Z#0_1 && z#Z#0_1 < n#0);
    goto anon18;

  anon18:
    goto anon132_Then, anon132_Else;

  anon132_Then:
    assume {:partition} !(LitInt(0) <= z#Z#0_1 && z#Z#0_1 < n#0 && Div(xx#0_0 + yy#0_0, n#0) == Div(xx#0_0, n#0) + Div(yy#0_0, n#0));
    goto anon133_Then, anon133_Else;

  anon133_Then:
    assume {:partition} n#0 <= z#Z#0_1;
    goto anon21;

  anon133_Else:
    assume {:partition} z#Z#0_1 < n#0;
    goto anon21;

  anon21:
    goto anon134_Then, anon134_Else;

  anon134_Then:
    assume {:partition} n#0 <= z#Z#0_1 && z#Z#0_1 < Mul(LitInt(2), n#0);
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon23;

  anon134_Else:
    assume {:partition} !(n#0 <= z#Z#0_1 && z#Z#0_1 < Mul(LitInt(2), n#0));
    goto anon23;

  anon132_Else:
    assume {:partition} LitInt(0) <= z#Z#0_1 && z#Z#0_1 < n#0 && Div(xx#0_0 + yy#0_0, n#0) == Div(xx#0_0, n#0) + Div(yy#0_0, n#0);
    goto anon23;

  anon23:
    assume lambdaResult#0_0 <==> (LitInt(0) <= z#Z#0_1 && z#Z#0_1 < n#0 && Div(xx#0_0 + yy#0_0, n#0) == Div(xx#0_0, n#0) + Div(yy#0_0, n#0)) || (n#0 <= z#Z#0_1 && z#Z#0_1 < Mul(LitInt(2), n#0) && Div(xx#0_0 + yy#0_0, n#0) == Div(xx#0_0, n#0) + Div(yy#0_0, n#0) + 1);
    assume true;
    assume $Is(lambdaResult#0_0, TBool);
    goto anon24;

  anon129_Else:
    assume {:partition} false;
    goto anon24;

  anon24:
    assume false;
    goto anon25;

  anon128_Else:
    goto anon25;

  anon25:
    assume true;
    f#0_0 := Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle2((lambda $l#0_1#heap#0: Heap, $l#0_1#xx#0: Box, $l#0_1#yy#0: Box :: $Box((var z#0_2 := Mod($Unbox($l#0_1#xx#0): int, n#0) + Mod($Unbox($l#0_1#yy#0): int, n#0); (LitInt(0) <= z#0_2 && z#0_2 < n#0 && Div($Unbox($l#0_1#xx#0): int + $Unbox($l#0_1#yy#0): int, n#0) == Div($Unbox($l#0_1#xx#0): int, n#0) + Div($Unbox($l#0_1#yy#0): int, n#0)) || (n#0 <= z#0_2 && z#0_2 < Mul(LitInt(2), n#0) && Div($Unbox($l#0_1#xx#0): int + $Unbox($l#0_1#yy#0): int, n#0) == Div($Unbox($l#0_1#xx#0): int, n#0) + Div($Unbox($l#0_1#yy#0): int, n#0) + 1)))), (lambda $l#0_1#heap#0: Heap, $l#0_1#xx#0: Box, $l#0_1#yy#0: Box :: $IsBox($l#0_1#xx#0, TInt) && $IsBox($l#0_1#yy#0, TInt)), (lambda $l#0_1#heap#0: Heap, $l#0_1#xx#0: Box, $l#0_1#yy#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(111,76)"} true;
    goto anon135_Then, anon135_Else;

  anon135_Then:
    havoc i#0_0_0, j#0_0_0;
    assume true;
    assume true;
    assume true;
    goto anon136_Then, anon136_Else;

  anon136_Then:
    goto anon137_Then, anon137_Else;

  anon137_Then:
    assume {:partition} j#0_0_0 >= LitInt(0);
    goto anon29;

  anon137_Else:
    assume {:partition} LitInt(0) > j#0_0_0;
    goto anon29;

  anon29:
    goto anon138_Then, anon138_Else;

  anon138_Then:
    assume {:partition} j#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool;
    goto anon31;

  anon138_Else:
    assume {:partition} !(j#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool);
    goto anon31;

  anon31:
    assume true;
    assume j#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0 + n#0))): bool;
    goto anon139_Then, anon139_Else;

  anon139_Then:
    assume {:partition} i#0_0_0 < n#0;
    goto anon33;

  anon139_Else:
    assume {:partition} n#0 <= i#0_0_0;
    goto anon33;

  anon33:
    goto anon140_Then, anon140_Else;

  anon140_Then:
    assume {:partition} i#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool;
    goto anon35;

  anon140_Else:
    assume {:partition} !(i#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool);
    goto anon35;

  anon35:
    assume true;
    assume i#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0 - n#0), $Box(j#0_0_0))): bool;
    goto anon141_Then, anon141_Else;

  anon141_Then:
    assume {:partition} j#0_0_0 < n#0;
    goto anon37;

  anon141_Else:
    assume {:partition} n#0 <= j#0_0_0;
    goto anon37;

  anon37:
    goto anon142_Then, anon142_Else;

  anon142_Then:
    assume {:partition} j#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool;
    goto anon39;

  anon142_Else:
    assume {:partition} !(j#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool);
    goto anon39;

  anon39:
    assume true;
    assume j#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0 - n#0))): bool;
    goto anon143_Then, anon143_Else;

  anon143_Then:
    assume {:partition} i#0_0_0 >= LitInt(0);
    goto anon41;

  anon143_Else:
    assume {:partition} LitInt(0) > i#0_0_0;
    goto anon41;

  anon41:
    goto anon144_Then, anon144_Else;

  anon144_Then:
    assume {:partition} i#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool;
    goto anon43;

  anon144_Else:
    assume {:partition} !(i#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool);
    goto anon43;

  anon43:
    assume true;
    assume i#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0 + n#0), $Box(j#0_0_0))): bool;
    assume false;
    goto anon44;

  anon136_Else:
    goto anon44;

  anon44:
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_0_0 + n#0 + j#0_0_0, n#0) == Div(i#0_0_0 + j#0_0_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(118,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_0_0 + j#0_0_0 + n#0, n#0) == Div(i#0_0_0 + j#0_0_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(119,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_0_0 - n#0 + j#0_0_0, n#0) == Div(i#0_0_0 + j#0_0_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(120,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_0_0 + j#0_0_0 - n#0, n#0) == Div(i#0_0_0 + j#0_0_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(121,53)"} true;
    pop;
    assume j#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0 + n#0))): bool;
    assume i#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0 - n#0), $Box(j#0_0_0))): bool;
    assume j#0_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0 - n#0))): bool;
    assume i#0_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0), $Box(j#0_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_0 + n#0), $Box(j#0_0_0))): bool;
    assume false;
    goto anon46;

  anon135_Else:
    assume (forall i#0_0_1: int, j#0_0_1: int, _t#0#0_0_0: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_1), $Box(_t#0#0_0_0))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_1), $Box(j#0_0_1))): bool } _t#0#0_0_0 == j#0_0_1 + n#0 && true ==> j#0_0_1 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_1), $Box(j#0_0_1))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_1), $Box(_t#0#0_0_0))): bool) && (forall i#0_0_2: int, j#0_0_2: int, _t#0#0_0_1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(_t#0#0_0_1), $Box(j#0_0_2))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_2), $Box(j#0_0_2))): bool } _t#0#0_0_1 == i#0_0_2 - n#0 && true ==> i#0_0_2 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_2), $Box(j#0_0_2))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(_t#0#0_0_1), $Box(j#0_0_2))): bool) && (forall i#0_0_3: int, j#0_0_3: int, _t#0#0_0_2: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_3), $Box(_t#0#0_0_2))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_3), $Box(j#0_0_3))): bool } _t#0#0_0_2 == j#0_0_3 - n#0 && true ==> j#0_0_3 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_3), $Box(j#0_0_3))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_3), $Box(_t#0#0_0_2))): bool) && (forall i#0_0_4: int, j#0_0_4: int, _t#0#0_0_3: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(_t#0#0_0_3), $Box(j#0_0_4))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_4), $Box(j#0_0_4))): bool } _t#0#0_0_3 == i#0_0_4 + n#0 && true ==> i#0_0_4 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_0_4), $Box(j#0_0_4))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(_t#0#0_0_3), $Box(j#0_0_4))): bool);
    goto anon46;

  anon46:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(122,6)"} true;
    goto anon145_Then, anon145_Else;

  anon145_Then:
    havoc i#0_1_0, j#0_1_0;
    assume true;
    assume true;
    assume true;
    goto anon146_Then, anon146_Else;

  anon146_Then:
    goto anon147_Then, anon147_Else;

  anon147_Then:
    assume {:partition} LitInt(0) <= i#0_1_0;
    goto anon50;

  anon147_Else:
    assume {:partition} i#0_1_0 < LitInt(0);
    goto anon50;

  anon50:
    goto anon148_Then, anon148_Else;

  anon148_Then:
    assume {:partition} LitInt(0) <= i#0_1_0 && i#0_1_0 < n#0;
    goto anon149_Then, anon149_Else;

  anon149_Then:
    assume {:partition} LitInt(0) <= j#0_1_0;
    goto anon53;

  anon149_Else:
    assume {:partition} j#0_1_0 < LitInt(0);
    goto anon53;

  anon148_Else:
    assume {:partition} !(LitInt(0) <= i#0_1_0 && i#0_1_0 < n#0);
    goto anon53;

  anon53:
    goto anon150_Then, anon150_Else;

  anon150_Then:
    assume {:partition} LitInt(0) <= i#0_1_0 && i#0_1_0 < n#0 && LitInt(0) <= j#0_1_0 && j#0_1_0 < n#0;
    goto anon55;

  anon150_Else:
    assume {:partition} !(LitInt(0) <= i#0_1_0 && i#0_1_0 < n#0 && LitInt(0) <= j#0_1_0 && j#0_1_0 < n#0);
    goto anon55;

  anon55:
    assume true;
    assume LitInt(0) <= i#0_1_0 && i#0_1_0 < n#0 && LitInt(0) <= j#0_1_0 && j#0_1_0 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_1_0), $Box(j#0_1_0))): bool;
    assume false;
    goto anon56;

  anon146_Else:
    goto anon56;

  anon56:
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_1_0 + n#0 + j#0_1_0, n#0) == Div(i#0_1_0 + j#0_1_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(126,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_1_0 + j#0_1_0 + n#0, n#0) == Div(i#0_1_0 + j#0_1_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(127,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_1_0 - n#0 + j#0_1_0, n#0) == Div(i#0_1_0 + j#0_1_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(128,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#0_1_0 + j#0_1_0 - n#0, n#0) == Div(i#0_1_0 + j#0_1_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(129,53)"} true;
    pop;
    assume LitInt(0) <= i#0_1_0 && i#0_1_0 < n#0 && LitInt(0) <= j#0_1_0 && j#0_1_0 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_1_0), $Box(j#0_1_0))): bool;
    assume false;
    goto anon58;

  anon145_Else:
    assume (forall i#0_1_1: int, j#0_1_1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_1_1), $Box(j#0_1_1))): bool } Lit(true) ==> LitInt(0) <= i#0_1_1 && i#0_1_1 < n#0 && LitInt(0) <= j#0_1_1 && j#0_1_1 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(i#0_1_1), $Box(j#0_1_1))): bool);
    goto anon58;

  anon58:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(130,6)"} true;
    assume true;
    n##0_0 := n#0;
    assume true;
    f##0_0 := f#0_0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall2(n##0_0, f##0_0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall2(n##0_0, f##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(131,36)"} true;
    assume true;
    assume $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#0_0, $Box(x#0_0), $Box(y#0_0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(132,20)"} true;
    pop;
    assume (var z#0_0 := Mod(x#0_0, n#0) + Mod(y#0_0, n#0); (LitInt(0) <= z#0_0 && z#0_0 < n#0 && Div(x#0_0 + y#0_0, n#0) == Div(x#0_0, n#0) + Div(y#0_0, n#0)) || (n#0 <= z#0_0 && z#0_0 < Mul(LitInt(2), n#0) && Div(x#0_0 + y#0_0, n#0) == Div(x#0_0, n#0) + Div(y#0_0, n#0) + 1));
    assume false;
    goto anon60;

  anon121_Else:
    assume (forall x#0_1: int, y#0_1: int :: { Div(x#0_1 + y#0_1, n#0) } Lit(true) ==> (var z#0_3 := Mod(x#0_1, n#0) + Mod(y#0_1, n#0); (LitInt(0) <= z#0_3 && z#0_3 < n#0 && Div(x#0_1 + y#0_1, n#0) == Div(x#0_1, n#0) + Div(y#0_1, n#0)) || (n#0 <= z#0_3 && z#0_3 < Mul(LitInt(2), n#0) && Div(x#0_1 + y#0_1, n#0) == Div(x#0_1, n#0) + Div(y#0_1, n#0) + 1)));
    goto anon60;

  anon60:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(133,4)"} true;
    goto anon151_Then, anon151_Else;

  anon151_Then:
    havoc x#1_0, y#1_0;
    assume true;
    assume true;
    assume true;
    goto anon152_Then, anon152_Else;

  anon152_Then:
    havoc z#Z#1_0;
    assume true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume let#1_0#0#0 == Mod(x#1_0, n#0) - Mod(y#1_0, n#0);
    assume true;
    assume $Is(let#1_0#0#0, TInt);
    assume z#Z#1_0 == let#1_0#0#0;
    goto anon153_Then, anon153_Else;

  anon153_Then:
    assume {:partition} LitInt(0) <= z#Z#1_0;
    goto anon64;

  anon153_Else:
    assume {:partition} z#Z#1_0 < LitInt(0);
    goto anon64;

  anon64:
    goto anon154_Then, anon154_Else;

  anon154_Then:
    assume {:partition} LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    goto anon66;

  anon154_Else:
    assume {:partition} !(LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0);
    goto anon66;

  anon66:
    goto anon155_Then, anon155_Else;

  anon155_Then:
    assume {:partition} !(LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0 && Div(x#1_0 - y#1_0, n#0) == Div(x#1_0, n#0) - Div(y#1_0, n#0));
    goto anon156_Then, anon156_Else;

  anon156_Then:
    assume {:partition} 0 - n#0 <= z#Z#1_0;
    goto anon69;

  anon156_Else:
    assume {:partition} z#Z#1_0 < 0 - n#0;
    goto anon69;

  anon69:
    goto anon157_Then, anon157_Else;

  anon157_Then:
    assume {:partition} 0 - n#0 <= z#Z#1_0 && z#Z#1_0 < 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    goto anon71;

  anon157_Else:
    assume {:partition} !(0 - n#0 <= z#Z#1_0 && z#Z#1_0 < 0);
    goto anon71;

  anon155_Else:
    assume {:partition} LitInt(0) <= z#Z#1_0 && z#Z#1_0 < n#0 && Div(x#1_0 - y#1_0, n#0) == Div(x#1_0, n#0) - Div(y#1_0, n#0);
    goto anon71;

  anon71:
    assume true;
    assume (var z#1_0 := Mod(x#1_0, n#0) - Mod(y#1_0, n#0); (LitInt(0) <= z#1_0 && z#1_0 < n#0 && Div(x#1_0 - y#1_0, n#0) == Div(x#1_0, n#0) - Div(y#1_0, n#0)) || (0 - n#0 <= z#1_0 && z#1_0 < 0 && Div(x#1_0 - y#1_0, n#0) == Div(x#1_0, n#0) - Div(y#1_0, n#0) - 1));
    assume false;
    goto anon72;

  anon152_Else:
    goto anon72;

  anon72:
    assume true;
    goto anon158_Then, anon158_Else;

  anon158_Then:
    havoc $lambdaHeap#1_0;
    assume $IsGoodHeap($lambdaHeap#1_0);
    assume $Heap == $lambdaHeap#1_0 || $HeapSucc($Heap, $lambdaHeap#1_0);
    havoc xx#1_0;
    havoc yy#1_0;
    goto anon159_Then, anon159_Else;

  anon159_Then:
    assume {:partition} true;
    $_Frame#l1_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0, $o, alloc)): bool ==> false);
    havoc z#Z#1_1;
    assume true;
    assume n#0 != 0;
    assume n#0 != 0;
    assume let#1_1#0#0 == Mod(xx#1_0, n#0) - Mod(yy#1_0, n#0);
    assume true;
    assume $Is(let#1_1#0#0, TInt);
    assume z#Z#1_1 == let#1_1#0#0;
    goto anon160_Then, anon160_Else;

  anon160_Then:
    assume {:partition} LitInt(0) <= z#Z#1_1;
    goto anon76;

  anon160_Else:
    assume {:partition} z#Z#1_1 < LitInt(0);
    goto anon76;

  anon76:
    goto anon161_Then, anon161_Else;

  anon161_Then:
    assume {:partition} LitInt(0) <= z#Z#1_1 && z#Z#1_1 < n#0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon78;

  anon161_Else:
    assume {:partition} !(LitInt(0) <= z#Z#1_1 && z#Z#1_1 < n#0);
    goto anon78;

  anon78:
    goto anon162_Then, anon162_Else;

  anon162_Then:
    assume {:partition} !(LitInt(0) <= z#Z#1_1 && z#Z#1_1 < n#0 && Div(xx#1_0 - yy#1_0, n#0) == Div(xx#1_0, n#0) - Div(yy#1_0, n#0));
    goto anon163_Then, anon163_Else;

  anon163_Then:
    assume {:partition} 0 - n#0 <= z#Z#1_1;
    goto anon81;

  anon163_Else:
    assume {:partition} z#Z#1_1 < 0 - n#0;
    goto anon81;

  anon81:
    goto anon164_Then, anon164_Else;

  anon164_Then:
    assume {:partition} 0 - n#0 <= z#Z#1_1 && z#Z#1_1 < 0;
    assume n#0 != 0;
    assume n#0 != 0;
    assume n#0 != 0;
    goto anon83;

  anon164_Else:
    assume {:partition} !(0 - n#0 <= z#Z#1_1 && z#Z#1_1 < 0);
    goto anon83;

  anon162_Else:
    assume {:partition} LitInt(0) <= z#Z#1_1 && z#Z#1_1 < n#0 && Div(xx#1_0 - yy#1_0, n#0) == Div(xx#1_0, n#0) - Div(yy#1_0, n#0);
    goto anon83;

  anon83:
    assume lambdaResult#1_0 <==> (LitInt(0) <= z#Z#1_1 && z#Z#1_1 < n#0 && Div(xx#1_0 - yy#1_0, n#0) == Div(xx#1_0, n#0) - Div(yy#1_0, n#0)) || (0 - n#0 <= z#Z#1_1 && z#Z#1_1 < 0 && Div(xx#1_0 - yy#1_0, n#0) == Div(xx#1_0, n#0) - Div(yy#1_0, n#0) - 1);
    assume true;
    assume $Is(lambdaResult#1_0, TBool);
    goto anon84;

  anon159_Else:
    assume {:partition} false;
    goto anon84;

  anon84:
    assume false;
    goto anon85;

  anon158_Else:
    goto anon85;

  anon85:
    assume true;
    f#1_0 := Lit(AtLayer((lambda $l#1_1#ly#0: LayerType :: Handle2((lambda $l#1_1#heap#0: Heap, $l#1_1#xx#0: Box, $l#1_1#yy#0: Box :: $Box((var z#1_2 := Mod($Unbox($l#1_1#xx#0): int, n#0) - Mod($Unbox($l#1_1#yy#0): int, n#0); (LitInt(0) <= z#1_2 && z#1_2 < n#0 && Div($Unbox($l#1_1#xx#0): int - $Unbox($l#1_1#yy#0): int, n#0) == Div($Unbox($l#1_1#xx#0): int, n#0) - Div($Unbox($l#1_1#yy#0): int, n#0)) || (0 - n#0 <= z#1_2 && z#1_2 < 0 && Div($Unbox($l#1_1#xx#0): int - $Unbox($l#1_1#yy#0): int, n#0) == Div($Unbox($l#1_1#xx#0): int, n#0) - Div($Unbox($l#1_1#yy#0): int, n#0) - 1)))), (lambda $l#1_1#heap#0: Heap, $l#1_1#xx#0: Box, $l#1_1#yy#0: Box :: $IsBox($l#1_1#xx#0, TInt) && $IsBox($l#1_1#yy#0, TInt)), (lambda $l#1_1#heap#0: Heap, $l#1_1#xx#0: Box, $l#1_1#yy#0: Box :: SetRef_to_SetBox((lambda $l#1_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(142,73)"} true;
    goto anon165_Then, anon165_Else;

  anon165_Then:
    havoc i#1_0_0, j#1_0_0;
    assume true;
    assume true;
    assume true;
    goto anon166_Then, anon166_Else;

  anon166_Then:
    goto anon167_Then, anon167_Else;

  anon167_Then:
    assume {:partition} j#1_0_0 >= LitInt(0);
    goto anon89;

  anon167_Else:
    assume {:partition} LitInt(0) > j#1_0_0;
    goto anon89;

  anon89:
    goto anon168_Then, anon168_Else;

  anon168_Then:
    assume {:partition} j#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool;
    goto anon91;

  anon168_Else:
    assume {:partition} !(j#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool);
    goto anon91;

  anon91:
    assume true;
    assume j#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0 + n#0))): bool;
    goto anon169_Then, anon169_Else;

  anon169_Then:
    assume {:partition} i#1_0_0 < n#0;
    goto anon93;

  anon169_Else:
    assume {:partition} n#0 <= i#1_0_0;
    goto anon93;

  anon93:
    goto anon170_Then, anon170_Else;

  anon170_Then:
    assume {:partition} i#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool;
    goto anon95;

  anon170_Else:
    assume {:partition} !(i#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool);
    goto anon95;

  anon95:
    assume true;
    assume i#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0 - n#0), $Box(j#1_0_0))): bool;
    goto anon171_Then, anon171_Else;

  anon171_Then:
    assume {:partition} j#1_0_0 < n#0;
    goto anon97;

  anon171_Else:
    assume {:partition} n#0 <= j#1_0_0;
    goto anon97;

  anon97:
    goto anon172_Then, anon172_Else;

  anon172_Then:
    assume {:partition} j#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool;
    goto anon99;

  anon172_Else:
    assume {:partition} !(j#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool);
    goto anon99;

  anon99:
    assume true;
    assume j#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0 - n#0))): bool;
    goto anon173_Then, anon173_Else;

  anon173_Then:
    assume {:partition} i#1_0_0 >= LitInt(0);
    goto anon101;

  anon173_Else:
    assume {:partition} LitInt(0) > i#1_0_0;
    goto anon101;

  anon101:
    goto anon174_Then, anon174_Else;

  anon174_Then:
    assume {:partition} i#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool;
    goto anon103;

  anon174_Else:
    assume {:partition} !(i#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool);
    goto anon103;

  anon103:
    assume true;
    assume i#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0 + n#0), $Box(j#1_0_0))): bool;
    assume false;
    goto anon104;

  anon166_Else:
    goto anon104;

  anon104:
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_0_0 + n#0 - j#1_0_0, n#0) == Div(i#1_0_0 - j#1_0_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(149,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_0_0 - (j#1_0_0 - n#0), n#0) == Div(i#1_0_0 - j#1_0_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(150,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_0_0 - n#0 - j#1_0_0, n#0) == Div(i#1_0_0 - j#1_0_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(151,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_0_0 - (j#1_0_0 + n#0), n#0) == Div(i#1_0_0 - j#1_0_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(152,53)"} true;
    pop;
    assume j#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0 + n#0))): bool;
    assume i#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0 - n#0), $Box(j#1_0_0))): bool;
    assume j#1_0_0 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0 - n#0))): bool;
    assume i#1_0_0 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0), $Box(j#1_0_0))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_0 + n#0), $Box(j#1_0_0))): bool;
    assume false;
    goto anon106;

  anon165_Else:
    assume (forall i#1_0_1: int, j#1_0_1: int, _t#0#1_0_0: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_1), $Box(_t#0#1_0_0))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_1), $Box(j#1_0_1))): bool } _t#0#1_0_0 == j#1_0_1 + n#0 && true ==> j#1_0_1 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_1), $Box(j#1_0_1))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_1), $Box(_t#0#1_0_0))): bool) && (forall i#1_0_2: int, j#1_0_2: int, _t#0#1_0_1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(_t#0#1_0_1), $Box(j#1_0_2))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_2), $Box(j#1_0_2))): bool } _t#0#1_0_1 == i#1_0_2 - n#0 && true ==> i#1_0_2 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_2), $Box(j#1_0_2))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(_t#0#1_0_1), $Box(j#1_0_2))): bool) && (forall i#1_0_3: int, j#1_0_3: int, _t#0#1_0_2: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_3), $Box(_t#0#1_0_2))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_3), $Box(j#1_0_3))): bool } _t#0#1_0_2 == j#1_0_3 - n#0 && true ==> j#1_0_3 < n#0 && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_3), $Box(j#1_0_3))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_3), $Box(_t#0#1_0_2))): bool) && (forall i#1_0_4: int, j#1_0_4: int, _t#0#1_0_3: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(_t#0#1_0_3), $Box(j#1_0_4))): bool, $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_4), $Box(j#1_0_4))): bool } _t#0#1_0_3 == i#1_0_4 + n#0 && true ==> i#1_0_4 >= LitInt(0) && $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_0_4), $Box(j#1_0_4))): bool ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(_t#0#1_0_3), $Box(j#1_0_4))): bool);
    goto anon106;

  anon106:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(153,6)"} true;
    goto anon175_Then, anon175_Else;

  anon175_Then:
    havoc i#1_1_0, j#1_1_0;
    assume true;
    assume true;
    assume true;
    goto anon176_Then, anon176_Else;

  anon176_Then:
    goto anon177_Then, anon177_Else;

  anon177_Then:
    assume {:partition} LitInt(0) <= i#1_1_0;
    goto anon110;

  anon177_Else:
    assume {:partition} i#1_1_0 < LitInt(0);
    goto anon110;

  anon110:
    goto anon178_Then, anon178_Else;

  anon178_Then:
    assume {:partition} LitInt(0) <= i#1_1_0 && i#1_1_0 < n#0;
    goto anon179_Then, anon179_Else;

  anon179_Then:
    assume {:partition} LitInt(0) <= j#1_1_0;
    goto anon113;

  anon179_Else:
    assume {:partition} j#1_1_0 < LitInt(0);
    goto anon113;

  anon178_Else:
    assume {:partition} !(LitInt(0) <= i#1_1_0 && i#1_1_0 < n#0);
    goto anon113;

  anon113:
    goto anon180_Then, anon180_Else;

  anon180_Then:
    assume {:partition} LitInt(0) <= i#1_1_0 && i#1_1_0 < n#0 && LitInt(0) <= j#1_1_0 && j#1_1_0 < n#0;
    goto anon115;

  anon180_Else:
    assume {:partition} !(LitInt(0) <= i#1_1_0 && i#1_1_0 < n#0 && LitInt(0) <= j#1_1_0 && j#1_1_0 < n#0);
    goto anon115;

  anon115:
    assume true;
    assume LitInt(0) <= i#1_1_0 && i#1_1_0 < n#0 && LitInt(0) <= j#1_1_0 && j#1_1_0 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_1_0), $Box(j#1_1_0))): bool;
    assume false;
    goto anon116;

  anon176_Else:
    goto anon116;

  anon116:
    push;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_1_0 + n#0 - j#1_1_0, n#0) == Div(i#1_1_0 - j#1_1_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(157,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_1_0 - (j#1_1_0 - n#0), n#0) == Div(i#1_1_0 - j#1_1_0 + n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(158,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_1_0 - n#0 - j#1_1_0, n#0) == Div(i#1_1_0 - j#1_1_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(159,53)"} true;
    assume {:subsumption 0} n#0 != 0;
    assume {:subsumption 0} n#0 != 0;
    assume true;
    assume Div(i#1_1_0 - (j#1_1_0 + n#0), n#0) == Div(i#1_1_0 - j#1_1_0 - n#0, n#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(160,53)"} true;
    pop;
    assume LitInt(0) <= i#1_1_0 && i#1_1_0 < n#0 && LitInt(0) <= j#1_1_0 && j#1_1_0 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_1_0), $Box(j#1_1_0))): bool;
    assume false;
    goto anon118;

  anon175_Else:
    assume (forall i#1_1_1: int, j#1_1_1: int :: { $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_1_1), $Box(j#1_1_1))): bool } Lit(true) ==> LitInt(0) <= i#1_1_1 && i#1_1_1 < n#0 && LitInt(0) <= j#1_1_1 && j#1_1_1 < n#0 ==> $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(i#1_1_1), $Box(j#1_1_1))): bool);
    goto anon118;

  anon118:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(161,6)"} true;
    assume true;
    n##1_0 := n#0;
    assume true;
    f##1_0 := f#1_0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall2(n##1_0, f##1_0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall2(n##1_0, f##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(162,36)"} true;
    assume true;
    assume $Unbox(Apply2(TInt, TInt, TBool, $Heap, f#1_0, $Box(x#1_0), $Box(y#1_0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(163,20)"} true;
    assume (var z#1_0 := Mod(x#1_0, n#0) - Mod(y#1_0, n#0); (LitInt(0) <= z#1_0 && z#1_0 < n#0 && Div(x#1_0 - y#1_0, n#0) == Div(x#1_0, n#0) - Div(y#1_0, n#0)) || (0 - n#0 <= z#1_0 && z#1_0 < 0 && Div(x#1_0 - y#1_0, n#0) == Div(x#1_0, n#0) - Div(y#1_0, n#0) - 1));
    assume false;
    goto anon120;

  anon151_Else:
    assume (forall x#1_1: int, y#1_1: int :: { Div(x#1_1 - y#1_1, n#0) } Lit(true) ==> (var z#1_3 := Mod(x#1_1, n#0) - Mod(y#1_1, n#0); (LitInt(0) <= z#1_3 && z#1_3 < n#0 && Div(x#1_1 - y#1_1, n#0) == Div(x#1_1, n#0) - Div(y#1_1, n#0)) || (0 - n#0 <= z#1_3 && z#1_3 < 0 && Div(x#1_1 - y#1_1, n#0) == Div(x#1_1, n#0) - Div(y#1_1, n#0) - 1)));
    goto anon120;

  anon120:
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(164,4)"} true;
    return;
}



procedure {:verboseName "DivInternals.LemmaDivInductionAuto (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivInductionAuto (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;
  var i#0: int;
  var ##x#0: int;
  var ##y#0: int;
  var i#2: int;
  var ##x#1: int;
  var ##y#1: int;
  var i#4: int;
  var ##x#2: int;
  var ##y#2: int;
  var ##n#1: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivInductionAuto", " | ", n#0, " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(168,8): initial state"} true;
    assume n#0 > 0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume DivInternals.__default.DivAuto#canCall(n#0);
    assume DivInternals.__default.DivAuto(n#0);
    havoc i#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    ##x#0 := LitInt(0);
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := i#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon22_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon5:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0;
    goto anon7;

  anon23_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0);
    goto anon7;

  anon21_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
    havoc i#2;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    ##x#1 := LitInt(0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := i#2;
    assume $IsAlloc(##y#1, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon25_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon10:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool;
    goto anon12;

  anon26_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool);
    goto anon12;

  anon24_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
    havoc i#4;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} true;
    ##x#2 := i#4 + 1;
    assume $IsAlloc(##x#2, TInt, $Heap);
    ##y#2 := n#0;
    assume $IsAlloc(##y#2, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#4 + 1, n#0);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon28_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon15:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool;
    goto anon17;

  anon29_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool);
    goto anon17;

  anon27_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon20_Else:
    assume DivInternals.__default.DivAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool) && (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool) && (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon19:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(173,20): post-state"} true;
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume {:subsumption 0} ##n#1 > 0;
    assume ##n#1 > 0;
    assume DivInternals.__default.DivAuto#canCall(n#0);
    assume DivInternals.__default.DivAuto(n#0);
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
    return;
}



procedure {:verboseName "DivInternals.LemmaDivInductionAuto (call precondtion)"} CallPre$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id10721"} n#0 > 0;
  requires {:id "id10722"} DivInternals.__default.DivAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10723"} DivInternals.__default.DivAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10724"} DivInternals.__default.DivAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);



procedure {:verboseName "DivInternals.LemmaDivInductionAuto (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures DivInternals.__default.DivAuto#canCall(n#0);
  free ensures {:id "id10725"} DivInternals.__default.DivAuto#canCall(n#0) && DivInternals.__default.DivAuto(n#0) && ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#1: int :: { Div(x#1, n#0) } LitInt(0) <= x#1 && x#1 < n#0 <==> Div(x#1, n#0) == LitInt(0)) && (forall x#2: int, y#0: int :: { Div(x#2 + y#0, n#0) } (var z#0 := Mod(x#2, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Div(x#2 + y#0, n#0) == Div(x#2, n#0) + Div(y#0, n#0)) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Div(x#2 + y#0, n#0) == Div(x#2, n#0) + Div(y#0, n#0) + 1))) && (forall x#3: int, y#1: int :: { Div(x#3 - y#1, n#0) } (var z#1 := Mod(x#3, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Div(x#3 - y#1, n#0) == Div(x#3, n#0) - Div(y#1, n#0)) || (0 - n#0 <= z#1 && z#1 < 0 && Div(x#3 - y#1, n#0) == Div(x#3, n#0) - Div(y#1, n#0) - 1)));
  free ensures true;
  free ensures {:id "id10726"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternals.LemmaDivInductionAuto (correctness)"} Impl$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id10727"} n#0 > 0;
  requires {:id "id10728"} DivInternals.__default.DivAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10729"} DivInternals.__default.DivAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10730"} DivInternals.__default.DivAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
  modifies $Heap;
  free ensures DivInternals.__default.DivAuto#canCall(n#0);
  free ensures {:id "id10731"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || ModInternals.__default.ModAuto(n#0);
  free ensures {:id "id10732"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
  free ensures {:id "id10733"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || 0 - Div(0 - n#0, n#0) == LitInt(1);
  free ensures {:id "id10734"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#4: int :: { Div(x#4, n#0) } LitInt(0) <= x#4 && x#4 < n#0 <==> Div(x#4, n#0) == LitInt(0));
  free ensures {:id "id10735"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#5: int, y#2: int :: { Div(x#5 + y#2, n#0) } (var z#2 := Mod(x#5, n#0) + Mod(y#2, n#0); (LitInt(0) <= z#2 && z#2 < n#0 && Div(x#5 + y#2, n#0) == Div(x#5, n#0) + Div(y#2, n#0)) || (n#0 <= z#2 && z#2 < n#0 + n#0 && Div(x#5 + y#2, n#0) == Div(x#5, n#0) + Div(y#2, n#0) + 1)));
  free ensures {:id "id10736"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#6: int, y#3: int :: { Div(x#6 - y#3, n#0) } (var z#3 := Mod(x#6, n#0) - Mod(y#3, n#0); (LitInt(0) <= z#3 && z#3 < n#0 && Div(x#6 - y#3, n#0) == Div(x#6, n#0) - Div(y#3, n#0)) || (0 - n#0 <= z#3 && z#3 < 0 && Div(x#6 - y#3, n#0) == Div(x#6, n#0) - Div(y#3, n#0) - 1)));
  free ensures true;
  free ensures {:id "id10737"} $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivInductionAuto (correctness)"} Impl$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var i#6: int;
  var ##x#3: int;
  var ##y#3: int;
  var i#8: int;
  var ##x#4: int;
  var ##y#4: int;
  var i#10: int;
  var ##x#5: int;
  var ##y#5: int;
  var n##1: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivInductionAuto", " | ", n#0, " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(175,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(176,19)"} true;
    havoc i#6;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    ##x#3 := LitInt(0);
    assume $IsAlloc(##x#3, TInt, $Heap);
    ##y#3 := i#6;
    assume $IsAlloc(##y#3, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#6);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#6);
    goto anon3;

  anon17_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#6);
    goto anon3;

  anon3:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#6) && i#6 < n#0;
    goto anon5;

  anon18_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#6) && i#6 < n#0);
    goto anon5;

  anon16_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } { GeneralInternals.__default.IsLe(0, i#7) } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#7));
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } { GeneralInternals.__default.IsLe(0, i#7) } GeneralInternals.__default.IsLe(LitInt(0), i#7) && i#7 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(177,51)"} true;
    havoc i#8;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} true;
    ##x#4 := LitInt(0);
    assume $IsAlloc(##x#4, TInt, $Heap);
    ##y#4 := i#8;
    assume $IsAlloc(##y#4, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#8);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon8;

  anon20_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon8;

  anon8:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#8))): bool;
    goto anon10;

  anon21_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#8) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#8))): bool);
    goto anon10;

  anon19_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 + n#0))): bool } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#9));
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 + n#0))): bool } GeneralInternals.__default.IsLe(LitInt(0), i#9) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9 + n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(178,80)"} true;
    havoc i#10;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} true;
    ##x#5 := i#10 + 1;
    assume $IsAlloc(##x#5, TInt, $Heap);
    ##y#5 := n#0;
    assume $IsAlloc(##y#5, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#10 + 1, n#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#10 + 1, n#0);
    goto anon13;

  anon23_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#10 + 1, n#0);
    goto anon13;

  anon13:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#10 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool;
    goto anon15;

  anon24_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#10 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool);
    goto anon15;

  anon22_Else:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 - n#0))): bool } GeneralInternals.__default.IsLe#canCall(i#11 + 1, n#0));
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 - n#0))): bool } GeneralInternals.__default.IsLe(i#11 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 - n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(179,84)"} true;
    assume true;
    n##1 := n#0;
    assume true;
    f##0 := f#0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(180,33)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(181,15)"} true;
    return;
}



procedure {:verboseName "DivInternals.LemmaDivInductionAutoForall (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivInductionAutoForall (well-formedness)"} CheckWellFormed$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;
  var i#0: int;
  var ##x#0: int;
  var ##y#0: int;
  var i#2: int;
  var ##x#1: int;
  var ##y#1: int;
  var i#4: int;
  var ##x#2: int;
  var ##y#2: int;
  var ##n#1: int;
  var i#6: int;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivInductionAutoForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(185,8): initial state"} true;
    assume n#0 > 0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume {:subsumption 0} ##n#0 > 0;
    assume ##n#0 > 0;
    assume DivInternals.__default.DivAuto#canCall(n#0);
    assume DivInternals.__default.DivAuto(n#0);
    havoc i#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    ##x#0 := LitInt(0);
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := i#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon22_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0);
    goto anon5;

  anon5:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0;
    goto anon7;

  anon23_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#0) && i#0 < n#0);
    goto anon7;

  anon21_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
    havoc i#2;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    ##x#1 := LitInt(0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := i#2;
    assume $IsAlloc(##y#1, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#2);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon25_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#2);
    goto anon10;

  anon10:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool;
    goto anon12;

  anon26_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#2) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#2))): bool);
    goto anon12;

  anon24_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
    havoc i#4;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} true;
    ##x#2 := i#4 + 1;
    assume $IsAlloc(##x#2, TInt, $Heap);
    ##y#2 := n#0;
    assume $IsAlloc(##y#2, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#4 + 1, n#0);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon28_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#4 + 1, n#0);
    goto anon15;

  anon15:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool;
    goto anon17;

  anon29_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#4 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#4))): bool);
    goto anon17;

  anon27_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon20_Else:
    assume DivInternals.__default.DivAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool) && (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool) && (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
    goto anon19;

  anon19:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(190,20): post-state"} true;
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume {:subsumption 0} ##n#1 > 0;
    assume ##n#1 > 0;
    assume DivInternals.__default.DivAuto#canCall(n#0);
    assume DivInternals.__default.DivAuto(n#0);
    havoc i#6;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#6))): bool;
    assume (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
    return;
}



procedure {:verboseName "DivInternals.LemmaDivInductionAutoForall (call precondtion)"} CallPre$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  requires {:id "id10757"} n#0 > 0;
  requires {:id "id10758"} DivInternals.__default.DivAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10759"} DivInternals.__default.DivAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10760"} DivInternals.__default.DivAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);



procedure {:verboseName "DivInternals.LemmaDivInductionAutoForall (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap));
  modifies $Heap;
  free ensures DivInternals.__default.DivAuto#canCall(n#0);
  free ensures {:id "id10761"} DivInternals.__default.DivAuto#canCall(n#0) && DivInternals.__default.DivAuto(n#0) && ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#0: int :: { Div(x#0, n#0) } LitInt(0) <= x#0 && x#0 < n#0 <==> Div(x#0, n#0) == LitInt(0)) && (forall x#1: int, y#0: int :: { Div(x#1 + y#0, n#0) } (var z#0 := Mod(x#1, n#0) + Mod(y#0, n#0); (LitInt(0) <= z#0 && z#0 < n#0 && Div(x#1 + y#0, n#0) == Div(x#1, n#0) + Div(y#0, n#0)) || (n#0 <= z#0 && z#0 < n#0 + n#0 && Div(x#1 + y#0, n#0) == Div(x#1, n#0) + Div(y#0, n#0) + 1))) && (forall x#2: int, y#1: int :: { Div(x#2 - y#1, n#0) } (var z#1 := Mod(x#2, n#0) - Mod(y#1, n#0); (LitInt(0) <= z#1 && z#1 < n#0 && Div(x#2 - y#1, n#0) == Div(x#2, n#0) - Div(y#1, n#0)) || (0 - n#0 <= z#1 && z#1 < 0 && Div(x#2 - y#1, n#0) == Div(x#2, n#0) - Div(y#1, n#0) - 1)));
  free ensures true;
  free ensures {:id "id10762"} (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivInternals.LemmaDivInductionAutoForall (correctness)"} Impl$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id10763"} n#0 > 0;
  requires {:id "id10764"} DivInternals.__default.DivAuto(n#0) ==> (forall i#1: int :: { GeneralInternals.__default.IsLe(0, i#1) } GeneralInternals.__default.IsLe(LitInt(0), i#1) && i#1 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#1))): bool);
  requires {:id "id10765"} DivInternals.__default.DivAuto(n#0) ==> (forall i#3: int :: { GeneralInternals.__default.IsLe(0, i#3) } GeneralInternals.__default.IsLe(LitInt(0), i#3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#3 + n#0))): bool);
  requires {:id "id10766"} DivInternals.__default.DivAuto(n#0) ==> (forall i#5: int :: { GeneralInternals.__default.IsLe(i#5 + 1, n#0) } GeneralInternals.__default.IsLe(i#5 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#5 - n#0))): bool);
  modifies $Heap;
  free ensures DivInternals.__default.DivAuto#canCall(n#0);
  free ensures {:id "id10767"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || ModInternals.__default.ModAuto(n#0);
  free ensures {:id "id10768"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || Div(n#0, n#0) == 0 - Div(0 - n#0, n#0);
  free ensures {:id "id10769"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || 0 - Div(0 - n#0, n#0) == LitInt(1);
  free ensures {:id "id10770"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#3: int :: { Div(x#3, n#0) } LitInt(0) <= x#3 && x#3 < n#0 <==> Div(x#3, n#0) == LitInt(0));
  free ensures {:id "id10771"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#4: int, y#2: int :: { Div(x#4 + y#2, n#0) } (var z#2 := Mod(x#4, n#0) + Mod(y#2, n#0); (LitInt(0) <= z#2 && z#2 < n#0 && Div(x#4 + y#2, n#0) == Div(x#4, n#0) + Div(y#2, n#0)) || (n#0 <= z#2 && z#2 < n#0 + n#0 && Div(x#4 + y#2, n#0) == Div(x#4, n#0) + Div(y#2, n#0) + 1)));
  free ensures {:id "id10772"} DivInternals.__default.DivAuto#canCall(n#0) ==> DivInternals.__default.DivAuto(n#0) || (forall x#5: int, y#3: int :: { Div(x#5 - y#3, n#0) } (var z#3 := Mod(x#5, n#0) - Mod(y#3, n#0); (LitInt(0) <= z#3 && z#3 < n#0 && Div(x#5 - y#3, n#0) == Div(x#5, n#0) - Div(y#3, n#0)) || (0 - n#0 <= z#3 && z#3 < 0 && Div(x#5 - y#3, n#0) == Div(x#5, n#0) - Div(y#3, n#0) - 1)));
  free ensures true;
  free ensures {:id "id10773"} (forall i#7: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool } $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#7))): bool);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivInternals.LemmaDivInductionAutoForall (correctness)"} Impl$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var i#8: int;
  var ##x#3: int;
  var ##y#3: int;
  var i#10: int;
  var ##x#4: int;
  var ##y#4: int;
  var i#12: int;
  var ##x#5: int;
  var ##y#5: int;
  var n##1: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivInductionAutoForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(192,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := n#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(193,19)"} true;
    havoc i#8;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    ##x#3 := LitInt(0);
    assume $IsAlloc(##x#3, TInt, $Heap);
    ##y#3 := i#8;
    assume $IsAlloc(##y#3, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#8);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon3;

  anon17_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#8);
    goto anon3;

  anon3:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#8) && i#8 < n#0;
    goto anon5;

  anon18_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#8) && i#8 < n#0);
    goto anon5;

  anon16_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool } { GeneralInternals.__default.IsLe(0, i#9) } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#9));
    assume (forall i#9: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool } { GeneralInternals.__default.IsLe(0, i#9) } GeneralInternals.__default.IsLe(LitInt(0), i#9) && i#9 < n#0 ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#9))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(194,51)"} true;
    havoc i#10;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} true;
    ##x#4 := LitInt(0);
    assume $IsAlloc(##x#4, TInt, $Heap);
    ##y#4 := i#10;
    assume $IsAlloc(##y#4, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#10);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#10);
    goto anon8;

  anon20_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#10);
    goto anon8;

  anon8:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#10) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool;
    goto anon10;

  anon21_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#10) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#10))): bool);
    goto anon10;

  anon19_Else:
    assume {:partition} false;
    goto anon10;

  anon10:
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 + n#0))): bool } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#11));
    assume (forall i#11: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 + n#0))): bool } GeneralInternals.__default.IsLe(LitInt(0), i#11) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#11 + n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(195,80)"} true;
    havoc i#12;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} true;
    ##x#5 := i#12 + 1;
    assume $IsAlloc(##x#5, TInt, $Heap);
    ##y#5 := n#0;
    assume $IsAlloc(##y#5, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#12 + 1, n#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#12 + 1, n#0);
    goto anon13;

  anon23_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#12 + 1, n#0);
    goto anon13;

  anon13:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#12 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#12))): bool;
    goto anon15;

  anon24_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#12 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#12))): bool);
    goto anon15;

  anon22_Else:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume (forall i#13: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13 - n#0))): bool } GeneralInternals.__default.IsLe#canCall(i#13 + 1, n#0));
    assume (forall i#13: int :: { $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13))): bool, $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13 - n#0))): bool } GeneralInternals.__default.IsLe(i#13 + 1, n#0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#13 - n#0))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(196,84)"} true;
    assume true;
    n##1 := n#0;
    assume true;
    f##0 := f#0;
    call CallPre$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    call CallPost$$ModInternals.__default.LemmaModInductionForall(n##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Internals/DivInternals.dfy(197,33)"} true;
    return;
}



procedure {:verboseName "DivInternals.reveal_DivPos (well-formedness)"} {:verify false} CheckWellFormed$$DivInternals.__default.reveal__DivPos();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DivInternals.reveal_DivPos (call precondtion)"} {:verify false} CallPre$$DivInternals.__default.reveal__DivPos();



procedure {:verboseName "DivInternals.reveal_DivPos (call postcondition)"} {:verify false} CallPost$$DivInternals.__default.reveal__DivPos();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_DivInternals._default.DivPos;



procedure {:verboseName "DivInternals.reveal_DivRecursive (well-formedness)"} {:verify false} CheckWellFormed$$DivInternals.__default.reveal__DivRecursive();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DivInternals.reveal_DivRecursive (call precondtion)"} {:verify false} CallPre$$DivInternals.__default.reveal__DivRecursive();



procedure {:verboseName "DivInternals.reveal_DivRecursive (call postcondition)"} {:verify false} CallPost$$DivInternals.__default.reveal__DivRecursive();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_DivInternals._default.DivRecursive;



axiom MulInternals.__default.MulAuto() <==> (forall x#24: int, y#24: int :: { Mul(x#24, y#24) } Mul(x#24, y#24) == Mul(y#24, x#24)) && (forall x#25: int, y#25: int, z#16: int :: { Mul(x#25 + y#25, z#16) } Mul(x#25 + y#25, z#16) == Mul(x#25, z#16) + Mul(y#25, z#16)) && (forall x#26: int, y#26: int, z#17: int :: { Mul(x#26 - y#26, z#17) } Mul(x#26 - y#26, z#17) == Mul(x#26, z#17) - Mul(y#26, z#17));

axiom MulInternals.__default.MulAuto() <==> (forall x#27: int, y#27: int :: { Mul(x#27, y#27) } Mul(x#27, y#27) == Mul(y#27, x#27)) && (forall x#28: int, y#28: int, z#18: int :: { Mul(x#28 + y#28, z#18) } Mul(x#28 + y#28, z#18) == Mul(x#28, z#18) + Mul(y#28, z#18)) && (forall x#29: int, y#29: int, z#19: int :: { Mul(x#29 - y#29, z#19) } Mul(x#29 - y#29, z#19) == Mul(x#29, z#19) - Mul(y#29, z#19));

axiom (forall $ly: LayerType, x#0: int, d#0: int :: { ModInternals.__default.ModRecursive($LS($ly), true, x#0, d#0) } ModInternals.__default.ModRecursive#canCall(x#0, d#0) || d#0 > 0 ==> (x#0 < 0 ==> ModInternals.__default.ModRecursive#canCall(d#0 + x#0, d#0)) && (0 <= x#0 ==> d#0 <= x#0 ==> ModInternals.__default.ModRecursive#canCall(x#0 - d#0, d#0)) && ModInternals.__default.ModRecursive($LS($ly), true, x#0, d#0) == (if x#0 < 0 then ModInternals.__default.ModRecursive($ly, reveal_ModInternals._default.ModRecursive, d#0 + x#0, d#0) else (if x#0 < d#0 then x#0 else ModInternals.__default.ModRecursive($ly, reveal_ModInternals._default.ModRecursive, x#0 - d#0, d#0))));

axiom (forall $ly: LayerType, x#0: int, d#0: int :: {:weight 3} { ModInternals.__default.ModRecursive($LS($ly), true, LitInt(x#0), LitInt(d#0)) } ModInternals.__default.ModRecursive#canCall(LitInt(x#0), LitInt(d#0)) || Lit(d#0 > 0) ==> (Lit(x#0 < 0) ==> ModInternals.__default.ModRecursive#canCall(LitInt(d#0 + x#0), LitInt(d#0))) && (!Lit(x#0 < 0) ==> !Lit(x#0 < d#0) ==> ModInternals.__default.ModRecursive#canCall(LitInt(x#0 - d#0), LitInt(d#0))) && ModInternals.__default.ModRecursive($LS($ly), true, LitInt(x#0), LitInt(d#0)) == (if x#0 < 0 then ModInternals.__default.ModRecursive($LS($ly), reveal_ModInternals._default.ModRecursive, LitInt(d#0 + x#0), LitInt(d#0)) else (if x#0 < d#0 then x#0 else ModInternals.__default.ModRecursive($LS($ly), reveal_ModInternals._default.ModRecursive, LitInt(x#0 - d#0), LitInt(d#0)))));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#16: int :: { Mod(Mod(x#16, n#0), n#0) } Mod(Mod(x#16, n#0), n#0) == Mod(x#16, n#0)) && (forall x#17: int :: { Mod(x#17, n#0) } LitInt(0) <= x#17 && x#17 < n#0 <==> Mod(x#17, n#0) == x#17) && (forall x#18: int, y#8: int :: { Mod(x#18 + y#8, n#0) } (var z#6 := Mod(x#18, n#0) + Mod(y#8, n#0); (LitInt(0) <= z#6 && z#6 < n#0 && Mod(x#18 + y#8, n#0) == z#6) || (n#0 <= z#6 && z#6 < n#0 + n#0 && Mod(x#18 + y#8, n#0) == z#6 - n#0))) && (forall x#19: int, y#9: int :: { Mod(x#19 - y#9, n#0) } (var z#7 := Mod(x#19, n#0) - Mod(y#9, n#0); (LitInt(0) <= z#7 && z#7 < n#0 && Mod(x#19 - y#9, n#0) == z#7) || (0 - n#0 <= z#7 && z#7 < 0 && Mod(x#19 - y#9, n#0) == z#7 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#20: int :: { Mod(Mod(x#20, n#0), n#0) } Mod(Mod(x#20, LitInt(n#0)), LitInt(n#0)) == Mod(x#20, LitInt(n#0))) && (forall x#21: int :: { Mod(x#21, n#0) } LitInt(0) <= x#21 && x#21 < n#0 <==> Mod(x#21, LitInt(n#0)) == x#21) && (forall x#22: int, y#10: int :: { Mod(x#22 + y#10, n#0) } (var z#8 := Mod(x#22, LitInt(n#0)) + Mod(y#10, LitInt(n#0)); (LitInt(0) <= z#8 && z#8 < n#0 && Mod(x#22 + y#10, LitInt(n#0)) == z#8) || (LitInt(n#0) <= z#8 && z#8 < n#0 + n#0 && Mod(x#22 + y#10, LitInt(n#0)) == z#8 - n#0))) && (forall x#23: int, y#11: int :: { Mod(x#23 - y#11, n#0) } (var z#9 := Mod(x#23, LitInt(n#0)) - Mod(y#11, LitInt(n#0)); (LitInt(0) <= z#9 && z#9 < n#0 && Mod(x#23 - y#11, LitInt(n#0)) == z#9) || (LitInt(0 - n#0) <= z#9 && z#9 < 0 && Mod(x#23 - y#11, LitInt(n#0)) == z#9 + n#0)))));

const unique class.DivMod.__default: ClassName;

procedure {:verboseName "DivMod.LemmaDivIsDivRecursive (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsDivRecursive (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsDivRecursive", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(34,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(36,31): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 != 0;
    assume ##d#0 != 0;
    assume DivInternals.__default.DivRecursive#canCall(x#0, d#0);
    assume d#0 != 0;
    assume DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == Div(x#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsDivRecursive (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int);
  requires {:id "id10810"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivIsDivRecursive (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int);
  modifies $Heap;
  free ensures DivInternals.__default.DivRecursive#canCall(x#0, d#0);
  free ensures {:id "id10811"} DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == Div(x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsDivRecursive (correctness)"} Impl$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10812"} 0 < d#0;
  modifies $Heap;
  free ensures DivInternals.__default.DivRecursive#canCall(x#0, d#0);
  free ensures {:id "id10813"} DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == Div(x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsDivRecursive (correctness)"} Impl$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##x#1: int;
  var ##d#1: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsDivRecursive", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(37,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivInternals.__default.reveal__DivPos();
    call CallPost$$DivInternals.__default.reveal__DivPos();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(38,18)"} true;
    call CallPre$$DivInternals.__default.reveal__DivRecursive();
    call CallPost$$DivInternals.__default.reveal__DivRecursive();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(39,24)"} true;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##x#1 := u#0;
    assume $IsAlloc(##x#1, TInt, $lambdaHeap#0);
    ##d#1 := d#0;
    assume $IsAlloc(##d#1, TInt, $lambdaHeap#0);
    assume {:subsumption 0} ##d#1 != 0;
    assume ##d#1 != 0;
    assume DivInternals.__default.DivRecursive#canCall(u#0, d#0);
    assume d#0 != 0;
    assume lambdaResult#0 <==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, u#0, d#0) == Div(u#0, d#0);
    assume DivInternals.__default.DivRecursive#canCall(u#0, d#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume (forall $l#0#u#0: int :: DivInternals.__default.DivRecursive#canCall($l#0#u#0, d#0));
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, $Unbox($l#1#u#0): int, d#0) == Div($Unbox($l#1#u#0): int, d#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(40,65)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsDivRecursiveAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsDivRecursiveAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;
  var ##x#0: int;
  var ##d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsDivRecursiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(43,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(44,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume d#0 > 0;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 != 0;
    assume ##d#0 != 0;
    assume DivInternals.__default.DivRecursive#canCall(x#0, d#0);
    assume d#0 != 0;
    assume DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == Div(x#0, d#0);
    goto anon4;

  anon5_Else:
    assume d#0 > 0 ==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0, d#0) == Div(x#0, d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#1, d#1) == Div(x#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsDivRecursiveAuto();



procedure {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsDivRecursiveAuto();
  modifies $Heap;
  free ensures (forall x#1: int, d#1: int :: { Div(x#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive#canCall(x#1, d#1));
  free ensures {:id "id10829"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#1, d#1) == Div(x#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsDivRecursiveAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: int, d#1: int :: { Div(x#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive#canCall(x#1, d#1));
  free ensures {:id "id10830"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#1, d#1) == Div(x#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsDivRecursiveAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var ##x#0_0: int;
  var ##d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsDivRecursiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(45,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivInternals.__default.reveal__DivPos();
    call CallPost$$DivInternals.__default.reveal__DivPos();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(46,18)"} true;
    call CallPre$$DivInternals.__default.reveal__DivRecursive();
    call CallPost$$DivInternals.__default.reveal__DivRecursive();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(47,24)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    assume true;
    assume d#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##x#0_0 := x#0_0;
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##d#0_0 := d#0_0;
    assume $IsAlloc(##d#0_0, TInt, $Heap);
    assume {:subsumption 0} ##d#0_0 != 0;
    assume DivInternals.__default.DivRecursive#canCall(x#0_0, d#0_0);
    assume {:subsumption 0} d#0_0 != 0;
    assume DivInternals.__default.DivRecursive#canCall(x#0_0, d#0_0);
    assume DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0_0, d#0_0) == Div(x#0_0, d#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivIsDivRecursive(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivIsDivRecursive(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(51,34)"} true;
    assume DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0_0, d#0_0) == Div(x#0_0, d#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, d#0_1: int :: { DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0_1, d#0_1) } d#0_1 > 0 ==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, x#0_1, d#0_1) == Div(x#0_1, d#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(52,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivBySelf (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivBySelf(d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivBySelf (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivBySelf(d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBySelf", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(56,8): initial state"} true;
    assume d#0 != 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(58,18): post-state"} true;
    assume d#0 != 0;
    assume Div(d#0, d#0) == LitInt(1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivBySelf (call precondtion)"} CallPre$$DivMod.__default.LemmaDivBySelf(d#0: int);
  requires {:id "id10845"} d#0 != 0;



procedure {:verboseName "DivMod.LemmaDivBySelf (call postcondition)"} CallPost$$DivMod.__default.LemmaDivBySelf(d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10846"} Div(d#0, d#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivBySelf (correctness)"} Impl$$DivMod.__default.LemmaDivBySelf(d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10847"} d#0 != 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10848"} Div(d#0, d#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivBySelf (correctness)"} Impl$$DivMod.__default.LemmaDivBySelf(d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBySelf", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(59,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    d##0 := d#0;
    call CallPre$$DivInternalsNonlinear.__default.LemmaDivBySelf(d##0);
    call CallPost$$DivInternalsNonlinear.__default.LemmaDivBySelf(d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(60,28)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivOf0 (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivOf0(d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivOf0 (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivOf0(d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivOf0", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(64,8): initial state"} true;
    assume d#0 != 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(66,18): post-state"} true;
    assume d#0 != 0;
    assume Div(0, d#0) == LitInt(0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivOf0 (call precondtion)"} CallPre$$DivMod.__default.LemmaDivOf0(d#0: int);
  requires {:id "id10854"} d#0 != 0;



procedure {:verboseName "DivMod.LemmaDivOf0 (call postcondition)"} CallPost$$DivMod.__default.LemmaDivOf0(d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10855"} Div(0, d#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivOf0 (correctness)"} Impl$$DivMod.__default.LemmaDivOf0(d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id10856"} d#0 != 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10857"} Div(0, d#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivOf0 (correctness)"} Impl$$DivMod.__default.LemmaDivOf0(d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivOf0", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(67,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    d##0 := d#0;
    call CallPre$$DivInternalsNonlinear.__default.LemmaDivOf0(d##0);
    call CallPost$$DivInternalsNonlinear.__default.LemmaDivOf0(d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(68,25)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivBasics (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivBasics(x#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivBasics (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivBasics(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBasics", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(73,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(74,19): post-state"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume x#0 != 0;
    assume x#0 != 0;
    assume Div(0, x#0) == LitInt(0);
    goto anon4;

  anon7_Else:
    assume x#0 != 0 ==> Div(0, x#0) == LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(1) != 0;
    assume Div(x#0, LitInt(1)) == x#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume x#0 != 0;
    assume x#0 != 0;
    assume Div(x#0, x#0) == LitInt(1);
    return;

  anon8_Else:
    assume x#0 != 0 ==> Div(x#0, x#0) == LitInt(1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivBasics (call precondtion)"} CallPre$$DivMod.__default.LemmaDivBasics(x#0: int);



procedure {:verboseName "DivMod.LemmaDivBasics (call postcondition)"} CallPost$$DivMod.__default.LemmaDivBasics(x#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10870"} x#0 != 0 ==> Div(0, x#0) == LitInt(0);
  free ensures true;
  free ensures {:id "id10871"} Div(x#0, LitInt(1)) == x#0;
  free ensures true;
  free ensures {:id "id10872"} x#0 != 0 ==> Div(x#0, x#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivBasics (correctness)"} Impl$$DivMod.__default.LemmaDivBasics(x#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10873"} x#0 != 0 ==> Div(0, x#0) == LitInt(0);
  free ensures true;
  free ensures {:id "id10874"} Div(x#0, LitInt(1)) == x#0;
  free ensures true;
  free ensures {:id "id10875"} x#0 != 0 ==> Div(x#0, x#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivBasics (correctness)"} Impl$$DivMod.__default.LemmaDivBasics(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d##0_0: int;
  var d##0_1: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBasics", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(77,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} x#0 != 0;
    assume true;
    d##0_0 := x#0;
    call CallPre$$DivMod.__default.LemmaDivBySelf(d##0_0);
    call CallPost$$DivMod.__default.LemmaDivBySelf(d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(79,23)"} true;
    assume true;
    d##0_1 := x#0;
    call CallPre$$DivMod.__default.LemmaDivOf0(d##0_1);
    call CallPost$$DivMod.__default.LemmaDivOf0(d##0_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(80,20)"} true;
    return;

  anon3_Else:
    assume {:partition} x#0 == 0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivBasicsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivBasicsAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivBasicsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivBasicsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var x#2: int;
  var x#4: int;
  var y#0: int;
  var x#6: int;
  var y#2: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBasicsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(84,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(85,12): post-state"} true;
    havoc x#0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume x#0 != 0;
    assume x#0 != 0;
    assume Div(0, x#0) == LitInt(0);
    goto anon4;

  anon11_Else:
    assume x#0 != 0 ==> Div(0, x#0) == LitInt(0);
    goto anon4;

  anon4:
    assume (forall x#1: int :: { Div(0, x#1) } x#1 != 0 ==> Div(0, x#1) == LitInt(0));
    havoc x#2;
    assume true;
    assume LitInt(1) != 0;
    assume Div(x#2, LitInt(1)) == x#2;
    assume (forall x#3: int :: { Div(x#3, 1) } Div(x#3, LitInt(1)) == x#3);
    havoc x#4;
    havoc y#0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume x#4 >= LitInt(0);
    assume y#0 > 0;
    assume y#0 != 0;
    assume Div(x#4, y#0) >= LitInt(0);
    goto anon7;

  anon12_Else:
    assume x#4 >= LitInt(0) && y#0 > 0 ==> Div(x#4, y#0) >= LitInt(0);
    goto anon7;

  anon7:
    assume (forall x#5: int, y#1: int :: { Div(x#5, y#1) } x#5 >= LitInt(0) && y#1 > 0 ==> Div(x#5, y#1) >= LitInt(0));
    havoc x#6;
    havoc y#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume x#6 >= LitInt(0);
    assume y#2 > 0;
    assume y#2 != 0;
    assume Div(x#6, y#2) <= x#6;
    goto anon10;

  anon13_Else:
    assume x#6 >= LitInt(0) && y#2 > 0 ==> Div(x#6, y#2) <= x#6;
    goto anon10;

  anon10:
    assume (forall x#7: int, y#3: int :: { Div(x#7, y#3) } x#7 >= LitInt(0) && y#3 > 0 ==> Div(x#7, y#3) <= x#7);
    return;
}



procedure {:verboseName "DivMod.LemmaDivBasicsAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivBasicsAuto();



procedure {:verboseName "DivMod.LemmaDivBasicsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivBasicsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10900"} (forall x#1: int :: { Div(0, x#1) } x#1 != 0 ==> Div(0, x#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id10901"} (forall x#3: int :: { Div(x#3, 1) } Div(x#3, LitInt(1)) == x#3);
  free ensures true;
  free ensures {:id "id10902"} (forall x#5: int, y#1: int :: { Div(x#5, y#1) } x#5 >= LitInt(0) && y#1 > 0 ==> Div(x#5, y#1) >= LitInt(0));
  free ensures true;
  free ensures {:id "id10903"} (forall x#7: int, y#3: int :: { Div(x#7, y#3) } x#7 >= LitInt(0) && y#3 > 0 ==> Div(x#7, y#3) <= x#7);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivBasicsAuto (correctness)"} Impl$$DivMod.__default.LemmaDivBasicsAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10904"} (forall x#1: int :: { Div(0, x#1) } x#1 != 0 ==> Div(0, x#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id10905"} (forall x#3: int :: { Div(x#3, 1) } Div(x#3, LitInt(1)) == x#3);
  free ensures true;
  free ensures {:id "id10906"} (forall x#5: int, y#1: int :: { Div(x#5, y#1) } x#5 >= LitInt(0) && y#1 > 0 ==> Div(x#5, y#1) >= LitInt(0));
  free ensures true;
  free ensures {:id "id10907"} (forall x#7: int, y#3: int :: { Div(x#7, y#3) } x#7 >= LitInt(0) && y#3 > 0 ==> Div(x#7, y#3) <= x#7);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivBasicsAuto (correctness)"} Impl$$DivMod.__default.LemmaDivBasicsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var x##0_0: int;
  var x#1_0: int;
  var y#1_0: int;
  var x##1_0: int;
  var d##1_0: int;
  var x##1_1: int;
  var y##1_0: int;
  var z##1_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBasicsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(89,2): initial state"} true;
    $_reverifyPost := false;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    havoc x#0_0;
    assume true;
    assume true;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} x#0_0 != 0;
    assume {:subsumption 0} x#0_0 != 0;
    goto anon4;

  anon19_Else:
    assume {:partition} x#0_0 == 0;
    goto anon4;

  anon4:
    assume true;
    assume x#0_0 != 0 ==> Div(0, x#0_0) == LitInt(0);
    assume {:subsumption 0} LitInt(1) != 0;
    assume true;
    assume Div(x#0_0, LitInt(1)) == x#0_0;
    assume false;
    goto anon5;

  anon18_Else:
    goto anon5;

  anon5:
    push;
    assume true;
    x##0_0 := x#0_0;
    call CallPre$$DivMod.__default.LemmaDivBasics(x##0_0);
    call CallPost$$DivMod.__default.LemmaDivBasics(x##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(94,23)"} true;
    pop;
    assume x#0_0 != 0 ==> Div(0, x#0_0) == LitInt(0);
    assume Div(x#0_0, LitInt(1)) == x#0_0;
    assume false;
    goto anon7;

  anon17_Else:
    assume (forall x#0_1: int :: { Div(x#0_1, 1) } { Div(0, x#0_1) } Lit(true) ==> (x#0_1 != 0 ==> Div(0, x#0_1) == LitInt(0)) && Div(x#0_1, LitInt(1)) == x#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(95,4)"} true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc x#1_0, y#1_0;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} x#1_0 >= LitInt(0);
    goto anon10;

  anon21_Else:
    assume {:partition} LitInt(0) > x#1_0;
    goto anon10;

  anon10:
    assume true;
    assume x#1_0 >= LitInt(0) && y#1_0 > 0;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:subsumption 0} y#1_0 != 0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= Div(x#1_0, y#1_0);
    assume {:subsumption 0} y#1_0 != 0;
    goto anon13;

  anon23_Else:
    assume {:partition} Div(x#1_0, y#1_0) < LitInt(0);
    goto anon13;

  anon13:
    assume true;
    assume LitInt(0) <= Div(x#1_0, y#1_0) && Div(x#1_0, y#1_0) <= x#1_0;
    assume false;
    goto anon14;

  anon22_Else:
    goto anon14;

  anon14:
    assume true;
    x##1_0 := x#1_0;
    assume true;
    d##1_0 := y#1_0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPos(x##1_0, d##1_0);
    call CallPost$$DivMod.__default.LemmaDivPosIsPos(x##1_0, d##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(99,28)"} true;
    assume true;
    x##1_1 := x#1_0;
    assume true;
    y##1_0 := LitInt(1);
    assume true;
    z##1_0 := y#1_0;
    call CallPre$$DivMod.__default.LemmaDivIsOrderedByDenominator(x##1_1, y##1_0, z##1_0);
    call CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominator(x##1_1, y##1_0, z##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(100,45)"} true;
    assume LitInt(0) <= Div(x#1_0, y#1_0);
    assume Div(x#1_0, y#1_0) <= x#1_0;
    assume false;
    goto anon16;

  anon20_Else:
    assume (forall x#1_1: int, y#1_1: int :: { Div(x#1_1, y#1_1) } x#1_1 >= LitInt(0) && y#1_1 > 0 ==> LitInt(0) <= Div(x#1_1, y#1_1) && Div(x#1_1, y#1_1) <= x#1_1);
    goto anon16;

  anon16:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(101,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaSmallDivConverseAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSmallDivConverseAuto();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSmallDivConverseAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSmallDivConverseAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSmallDivConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(106,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(107,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    assume d#0 != 0;
    assume Div(x#0, d#0) == LitInt(0);
    assume x#0 < d#0;
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < d#0 && Div(x#0, d#0) == LitInt(0) ==> x#0 < d#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 && Div(x#1, d#1) == LitInt(0) ==> x#1 < d#1);
    return;
}



procedure {:verboseName "DivMod.LemmaSmallDivConverseAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaSmallDivConverseAuto();



procedure {:verboseName "DivMod.LemmaSmallDivConverseAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaSmallDivConverseAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10934"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 && Div(x#1, d#1) == LitInt(0) ==> x#1 < d#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaSmallDivConverseAuto (correctness)"} Impl$$DivMod.__default.LemmaSmallDivConverseAuto() returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10935"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 && Div(x#1, d#1) == LitInt(0) ==> x#1 < d#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSmallDivConverseAuto (correctness)"} Impl$$DivMod.__default.LemmaSmallDivConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var n##0_0: int;
  var x##0_0: int;
  var f##0_0: HandleType;
  var $lambdaHeap#0_0: Heap;
  var u#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSmallDivConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(108,2): initial state"} true;
    $_reverifyPost := false;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon21_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < d#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon5;

  anon22_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < d#0_0);
    goto anon5;

  anon5:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < d#0_0 && Div(x#0_0, d#0_0) == LitInt(0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume true;
    assume x#0_0 < d#0_0;
    assume false;
    goto anon7;

  anon23_Else:
    goto anon7;

  anon7:
    assume true;
    n##0_0 := d#0_0;
    assume true;
    x##0_0 := x#0_0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc u#0_0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= u#0_0;
    goto anon11;

  anon26_Else:
    assume {:partition} u#0_0 < LitInt(0);
    goto anon11;

  anon11:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} LitInt(0) <= u#0_0 && 0 < d#0_0;
    assume d#0_0 != 0;
    goto anon13;

  anon27_Else:
    assume {:partition} !(LitInt(0) <= u#0_0 && 0 < d#0_0);
    goto anon13;

  anon13:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} LitInt(0) <= u#0_0 && 0 < d#0_0 && Div(u#0_0, d#0_0) == LitInt(0);
    goto anon15;

  anon28_Else:
    assume {:partition} !(LitInt(0) <= u#0_0 && 0 < d#0_0 && Div(u#0_0, d#0_0) == LitInt(0));
    goto anon15;

  anon15:
    assume lambdaResult#0_0 <==> LitInt(0) <= u#0_0 && 0 < d#0_0 && Div(u#0_0, d#0_0) == LitInt(0) ==> u#0_0 < d#0_0;
    assume true;
    assume $Is(lambdaResult#0_0, TBool);
    goto anon16;

  anon25_Else:
    assume {:partition} false;
    goto anon16;

  anon16:
    assume false;
    goto anon17;

  anon24_Else:
    goto anon17;

  anon17:
    assume true;
    f##0_0 := Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#0_1#u#0): int && 0 < d#0_0 && Div($Unbox($l#0_1#u#0): int, d#0_0) == LitInt(0) ==> $Unbox($l#0_1#u#0): int < d#0_0)), (lambda $l#0_1#heap#0: Heap, $l#0_1#u#0: Box :: $IsBox($l#0_1#u#0, TInt)), (lambda $l#0_1#heap#0: Heap, $l#0_1#u#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0_0, x##0_0, f##0_0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0_0, x##0_0, f##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(112,79)"} true;
    assume x#0_0 < d#0_0;
    assume false;
    goto anon19;

  anon20_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && 0 < d#0_1 && Div(x#0_1, d#0_1) == LitInt(0) ==> x#0_1 < d#0_1);
    goto anon19;

  anon19:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(113,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonZero (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonZero (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonZero", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(116,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} x#0 >= d#0;
    goto anon3;

  anon4_Else:
    assume {:partition} d#0 > x#0;
    goto anon3;

  anon3:
    assume x#0 >= d#0 && d#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(118,18): post-state"} true;
    assume d#0 != 0;
    assume Div(x#0, d#0) > 0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonZero (call precondtion)"} CallPre$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int);
  requires {:id "id10947"} x#0 >= d#0;
  requires {:id "id10948"} d#0 > 0;



procedure {:verboseName "DivMod.LemmaDivNonZero (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10949"} Div(x#0, d#0) > 0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivNonZero (correctness)"} Impl$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id10950"} x#0 >= d#0;
  requires {:id "id10951"} d#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10952"} Div(x#0, d#0) > 0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonZero (correctness)"} Impl$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonZero", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(119,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(120,26)"} true;
    assume d#0 != 0;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Div(x#0, d#0) == LitInt(0);
    call CallPre$$DivMod.__default.LemmaSmallDivConverseAuto();
    call CallPost$$DivMod.__default.LemmaSmallDivConverseAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(122,33)"} true;
    return;

  anon3_Else:
    assume {:partition} Div(x#0, d#0) != LitInt(0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonZeroAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonZeroAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonZeroAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonZeroAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonZeroAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(126,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(127,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} x#0 >= d#0;
    goto anon4;

  anon8_Else:
    assume {:partition} d#0 > x#0;
    goto anon4;

  anon4:
    assume x#0 >= d#0 && d#0 > 0;
    assume d#0 != 0;
    assume Div(x#0, d#0) > 0;
    goto anon6;

  anon7_Else:
    assume x#0 >= d#0 && d#0 > 0 ==> Div(x#0, d#0) > 0;
    goto anon6;

  anon6:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } x#1 >= d#1 && d#1 > 0 ==> Div(x#1, d#1) > 0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonZeroAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivNonZeroAuto();



procedure {:verboseName "DivMod.LemmaDivNonZeroAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonZeroAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10963"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } x#1 >= d#1 && d#1 > 0 ==> Div(x#1, d#1) > 0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivNonZeroAuto (correctness)"} Impl$$DivMod.__default.LemmaDivNonZeroAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10964"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } x#1 >= d#1 && d#1 > 0 ==> Div(x#1, d#1) > 0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonZeroAuto (correctness)"} Impl$$DivMod.__default.LemmaDivNonZeroAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;
  var $initHeapForallStmt#0_0: Heap;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonZeroAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(128,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} x#0_0 >= d#0_0;
    goto anon3;

  anon7_Else:
    assume {:partition} d#0_0 > x#0_0;
    goto anon3;

  anon3:
    assume true;
    assume x#0_0 >= d#0_0 && d#0_0 > 0;
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivNonZero(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivNonZero(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(129,52)"} true;
    assume false;
    goto anon5;

  anon6_Else:
    $initHeapForallStmt#0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0_0 == $Heap;
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } x#0_1 >= d#0_1 && d#0_1 > 0 ==> Div(x#0_1, d#0_1) > 0);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(129,54)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedByDenominator", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(135,8): initial state"} true;
    assume LitInt(0) <= x#0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(1) <= y#0;
    goto anon3;

  anon4_Else:
    assume {:partition} y#0 < LitInt(1);
    goto anon3;

  anon3:
    assume LitInt(1) <= y#0 && y#0 <= z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(138,18): post-state"} true;
    assume y#0 != 0;
    assume z#0 != 0;
    assume Div(x#0, y#0) >= Div(x#0, z#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int);
  requires {:id "id10972"} LitInt(0) <= x#0;
  requires {:id "id10973"} LitInt(1) <= y#0;
  requires {:id "id10974"} y#0 <= z#0;



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10975"} Div(x#0, y#0) >= Div(x#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id10976"} LitInt(0) <= x#0;
  requires {:id "id10977"} LitInt(1) <= y#0;
  requires {:id "id10978"} y#0 <= z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id10979"} Div(x#0, y#0) >= Div(x#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var u#0: int;
  var d#0: int;
  var ##x#0: int;
  var ##d#0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;
  var x##1_0: int;
  var y##1_0: int;
  var z##1_0: int;
  var x##1_1: int;
  var y##1_1: int;
  var z##1_1: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedByDenominator", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(140,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivInternals.__default.reveal__DivPos();
    call CallPost$$DivInternals.__default.reveal__DivPos();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(141,18)"} true;
    call CallPre$$DivInternals.__default.reveal__DivRecursive();
    call CallPost$$DivInternals.__default.reveal__DivRecursive();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(142,24)"} true;
    call CallPre$$DivMod.__default.LemmaDivIsDivRecursiveAuto();
    call CallPost$$DivMod.__default.LemmaDivIsDivRecursiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(143,32)"} true;
    havoc u#0;
    havoc d#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} d#0 > 0;
    ##x#0 := u#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 != 0;
    assume DivInternals.__default.DivRecursive#canCall(u#0, d#0);
    assume {:subsumption 0} d#0 != 0;
    goto anon3;

  anon7_Else:
    assume {:partition} 0 >= d#0;
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume (forall u#1: int, d#1: int :: { Div(u#1, d#1) } { DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, u#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive#canCall(u#1, d#1));
    assume (forall u#1: int, d#1: int :: { Div(u#1, d#1) } { DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, u#1, d#1) } d#1 > 0 ==> DivInternals.__default.DivRecursive(reveal_DivInternals._default.DivRecursive, u#1, d#1) == Div(u#1, d#1));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(145,48)"} true;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} x#0 < z#0;
    assume true;
    x##0_0 := LitInt(0);
    assume true;
    y##0_0 := x#0;
    assume true;
    z##0_0 := y#0;
    call CallPre$$DivMod.__default.LemmaDivIsOrdered(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaDivIsOrdered(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(149,32)"} true;
    return;

  anon8_Else:
    assume {:partition} z#0 <= x#0;
    assume true;
    x##1_0 := x#0 - z#0;
    assume true;
    y##1_0 := x#0 - y#0;
    assume true;
    z##1_0 := y#0;
    call CallPre$$DivMod.__default.LemmaDivIsOrdered(x##1_0, y##1_0, z##1_0);
    call CallPost$$DivMod.__default.LemmaDivIsOrdered(x##1_0, y##1_0, z##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(153,40)"} true;
    assume true;
    x##1_1 := x#0 - z#0;
    assume true;
    y##1_1 := y#0;
    assume true;
    z##1_1 := z#0;
    assume 0 <= x#0 || x##1_1 == x#0;
    assume x##1_1 < x#0;
    call CallPre$$DivMod.__default.LemmaDivIsOrderedByDenominator(x##1_1, y##1_1, z##1_1);
    call CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominator(x##1_1, y##1_1, z##1_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(154,49)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var z#0: int;
  var y#0: int;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedByDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(158,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(159,12): post-state"} true;
    havoc z#0;
    havoc y#0;
    havoc x#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume LitInt(0) <= x#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(1) <= y#0;
    goto anon4;

  anon8_Else:
    assume {:partition} y#0 < LitInt(1);
    goto anon4;

  anon4:
    assume LitInt(1) <= y#0 && y#0 <= z#0;
    assume y#0 != 0;
    assume z#0 != 0;
    assume Div(x#0, y#0) >= Div(x#0, z#0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= x#0 && LitInt(1) <= y#0 && y#0 <= z#0 ==> Div(x#0, y#0) >= Div(x#0, z#0);
    goto anon6;

  anon6:
    assume (forall z#1: int, y#1: int, x#1: int :: { Div(x#1, y#1), Div(x#1, z#1) } LitInt(0) <= x#1 && LitInt(1) <= y#1 && y#1 <= z#1 ==> Div(x#1, y#1) >= Div(x#1, z#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto();



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11004"} (forall z#1: int, y#1: int, x#1: int :: { Div(x#1, y#1), Div(x#1, z#1) } LitInt(0) <= x#1 && LitInt(1) <= y#1 && y#1 <= z#1 ==> Div(x#1, y#1) >= Div(x#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11005"} (forall z#1: int, y#1: int, x#1: int :: { Div(x#1, y#1), Div(x#1, z#1) } LitInt(0) <= x#1 && LitInt(1) <= y#1 && y#1 <= z#1 ==> Div(x#1, y#1) >= Div(x#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedByDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(160,2): initial state"} true;
    $_reverifyPost := false;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(1) <= y#0_0;
    goto anon4;

  anon11_Else:
    assume {:partition} y#0_0 < LitInt(1);
    goto anon4;

  anon10_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon4;

  anon4:
    assume true;
    assume LitInt(0) <= x#0_0 && LitInt(1) <= y#0_0 && y#0_0 <= z#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} y#0_0 != 0;
    assume {:subsumption 0} z#0_0 != 0;
    assume true;
    assume Div(x#0_0, y#0_0) >= Div(x#0_0, z#0_0);
    assume false;
    goto anon6;

  anon12_Else:
    goto anon6;

  anon6:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaDivIsOrderedByDenominator(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominator(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(164,45)"} true;
    assume Div(x#0_0, y#0_0) >= Div(x#0_0, z#0_0);
    assume false;
    goto anon8;

  anon9_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Div(x#0_1, z#0_1), Div(x#0_1, y#0_1) } LitInt(0) <= x#0_1 && LitInt(1) <= y#0_1 && y#0_1 <= z#0_1 ==> Div(x#0_1, y#0_1) >= Div(x#0_1, z#0_1));
    goto anon8;

  anon8:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(165,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsStrictlyOrderedByDenominator", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(170,8): initial state"} true;
    assume 0 < x#0;
    assume 1 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(173,19): post-state"} true;
    assume d#0 != 0;
    assume Div(x#0, d#0) < x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int);
  requires {:id "id11017"} 0 < x#0;
  requires {:id "id11018"} 1 < d#0;



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11019"} Div(x#0, d#0) < x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (correctness)"} Impl$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11020"} 0 < x#0;
  requires {:id "id11021"} 1 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11022"} Div(x#0, d#0) < x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (correctness)"} Impl$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsStrictlyOrderedByDenominator", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(175,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < u#0;
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 <= 0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> 0 < u#0 ==> Div(u#0, d#0) < u#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(0 < $Unbox($l#1#u#0): int ==> Div($Unbox($l#1#u#0): int, d#0) < $Unbox($l#1#u#0): int)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(176,57)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(179,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(180,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < x#0;
    assume 1 < d#0;
    assume d#0 != 0;
    assume Div(x#0, d#0) < x#0;
    goto anon4;

  anon5_Else:
    assume 0 < x#0 && 1 < d#0 ==> Div(x#0, d#0) < x#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } 0 < x#1 && 1 < d#1 ==> Div(x#1, d#1) < x#1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto();



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11033"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } 0 < x#1 && 1 < d#1 ==> Div(x#1, d#1) < x#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11034"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } 0 < x#1 && 1 < d#1 ==> Div(x#1, d#1) < x#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(181,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < x#0_0 && 1 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(x#0_0, d#0_0) < x#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(185,50)"} true;
    assume Div(x#0_0, d#0_0) < x#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } 0 < x#0_1 && 1 < d#0_1 ==> Div(x#0_1, d#0_1) < x#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(186,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDividingSums (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDividingSums (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDividingSums", " | ", a#0, " | ", b#0, " | ", d#0, " | ", R#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(191,8): initial state"} true;
    assume 0 < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume R#0 == Mod(a#0, d#0) + Mod(b#0, d#0) - Mod(a#0 + b#0, d#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(194,34): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
    return;
}



procedure {:verboseName "DivMod.LemmaDividingSums (call precondtion)"} CallPre$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int);
  requires {:id "id11050"} 0 < d#0;
  requires {:id "id11051"} R#0 == Mod(a#0, d#0) + Mod(b#0, d#0) - Mod(a#0 + b#0, d#0);



procedure {:verboseName "DivMod.LemmaDividingSums (call postcondition)"} CallPost$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11052"} Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDividingSums (correctness)"} Impl$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id11053"} 0 < d#0;
  requires {:id "id11054"} R#0 == Mod(a#0, d#0) + Mod(b#0, d#0) - Mod(a#0 + b#0, d#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11055"} Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDividingSums (correctness)"} Impl$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0_0_0: int;
  var d##0_0_0: int;
  var x##0_0_1: int;
  var d##0_0_1: int;
  var x##0_0_2: int;
  var d##0_0_2: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDividingSums", " | ", a#0, " | ", b#0, " | ", d#0, " | ", R#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(195,2): initial state"} true;
    $_reverifyPost := false;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume false;
    goto anon4;

  anon5_Else:
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mod(a#0, d#0) + Mod(b#0, d#0) == R#0 + Mod(a#0 + b#0, d#0);
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(a#0, d#0) + Mod(b#0, d#0) == R#0 + Mod(a#0 + b#0, d#0) ==> a#0 + b#0 - Mod(a#0 + b#0, d#0) - R#0 == a#0 - Mod(a#0, d#0) + b#0 - Mod(b#0, d#0);
    assume false;
    goto anon4;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume a#0 + b#0 - Mod(a#0 + b#0, d#0) - R#0 == a#0 - Mod(a#0, d#0) + b#0 - Mod(b#0, d#0);
    assume true;
    x##0_0_0 := a#0 + b#0;
    assume true;
    d##0_0_0 := d#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_0_0, d##0_0_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_0_0, d##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(200,40)"} true;
    assume true;
    x##0_0_1 := a#0;
    assume true;
    d##0_0_1 := d#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_0_1, d##0_0_1);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_0_1, d##0_0_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(201,36)"} true;
    assume true;
    x##0_0_2 := b#0;
    assume true;
    d##0_0_2 := d#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_0_2, d##0_0_2);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_0_2, d##0_0_2);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(202,36)"} true;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} a#0 + b#0 - Mod(a#0 + b#0, d#0) - R#0 == a#0 - Mod(a#0, d#0) + b#0 - Mod(b#0, d#0) ==> Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
    assume false;
    goto anon4;

  anon7_Else:
    goto anon4;

  anon4:
    assume Mod(a#0, d#0) + Mod(b#0, d#0) == R#0 + Mod(a#0 + b#0, d#0) ==> Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
    return;
}



procedure {:verboseName "DivMod.LemmaDividingSumsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDividingSumsAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDividingSumsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDividingSumsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var d#0: int;
  var R#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDividingSumsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(208,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(209,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc d#0;
    havoc R#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume R#0 == Mod(a#0, d#0) + Mod(b#0, d#0) - Mod(a#0 + b#0, d#0);
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
    goto anon4;

  anon5_Else:
    assume 0 < d#0 && R#0 == Mod(a#0, d#0) + Mod(b#0, d#0) - Mod(a#0 + b#0, d#0) ==> Mul(d#0, Div(a#0 + b#0, d#0)) - R#0 == Mul(d#0, Div(a#0, d#0)) + Mul(d#0, Div(b#0, d#0));
    goto anon4;

  anon4:
    assume (forall a#1: int, b#1: int, d#1: int, R#1: int :: { Mul(d#1, Div(a#1 + b#1, d#1)) - R#1, Mul(d#1, Div(a#1, d#1)) + Mul(d#1, Div(b#1, d#1)) } 0 < d#1 && R#1 == Mod(a#1, d#1) + Mod(b#1, d#1) - Mod(a#1 + b#1, d#1) ==> Mul(d#1, Div(a#1 + b#1, d#1)) - R#1 == Mul(d#1, Div(a#1, d#1)) + Mul(d#1, Div(b#1, d#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaDividingSumsAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDividingSumsAuto();



procedure {:verboseName "DivMod.LemmaDividingSumsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDividingSumsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11093"} (forall a#1: int, b#1: int, d#1: int, R#1: int :: { Mul(d#1, Div(a#1 + b#1, d#1)) - R#1, Mul(d#1, Div(a#1, d#1)) + Mul(d#1, Div(b#1, d#1)) } 0 < d#1 && R#1 == Mod(a#1, d#1) + Mod(b#1, d#1) - Mod(a#1 + b#1, d#1) ==> Mul(d#1, Div(a#1 + b#1, d#1)) - R#1 == Mul(d#1, Div(a#1, d#1)) + Mul(d#1, Div(b#1, d#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDividingSumsAuto (correctness)"} Impl$$DivMod.__default.LemmaDividingSumsAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11094"} (forall a#1: int, b#1: int, d#1: int, R#1: int :: { Mul(d#1, Div(a#1 + b#1, d#1)) - R#1, Mul(d#1, Div(a#1, d#1)) + Mul(d#1, Div(b#1, d#1)) } 0 < d#1 && R#1 == Mod(a#1, d#1) + Mod(b#1, d#1) - Mod(a#1 + b#1, d#1) ==> Mul(d#1, Div(a#1 + b#1, d#1)) - R#1 == Mul(d#1, Div(a#1, d#1)) + Mul(d#1, Div(b#1, d#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDividingSumsAuto (correctness)"} Impl$$DivMod.__default.LemmaDividingSumsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var d#0_0: int;
  var R#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var d##0_0: int;
  var R##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDividingSumsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(211,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc a#0_0, b#0_0, d#0_0, R#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < d#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon3;

  anon9_Else:
    assume {:partition} d#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < d#0_0 && R#0_0 == Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) - Mod(a#0_0 + b#0_0, d#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Mul(d#0_0, Div(a#0_0 + b#0_0, d#0_0)) - R#0_0 == Mul(d#0_0, Div(a#0_0, d#0_0)) + Mul(d#0_0, Div(b#0_0, d#0_0));
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    d##0_0 := d#0_0;
    assume true;
    R##0_0 := R#0_0;
    call CallPre$$DivMod.__default.LemmaDividingSums(a##0_0, b##0_0, d##0_0, R##0_0);
    call CallPost$$DivMod.__default.LemmaDividingSums(a##0_0, b##0_0, d##0_0, R##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(215,35)"} true;
    assume Mul(d#0_0, Div(a#0_0 + b#0_0, d#0_0)) - R#0_0 == Mul(d#0_0, Div(a#0_0, d#0_0)) + Mul(d#0_0, Div(b#0_0, d#0_0));
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall a#0_1: int, b#0_1: int, d#0_1: int, R#0_1: int :: { Mul(d#0_1, Div(a#0_1 + b#0_1, d#0_1)) - R#0_1, Mul(d#0_1, Div(a#0_1, d#0_1)) + Mul(d#0_1, Div(b#0_1, d#0_1)) } 0 < d#0_1 && R#0_1 == Mod(a#0_1, d#0_1) + Mod(b#0_1, d#0_1) - Mod(a#0_1 + b#0_1, d#0_1) ==> Mul(d#0_1, Div(a#0_1 + b#0_1, d#0_1)) - R#0_1 == Mul(d#0_1, Div(a#0_1, d#0_1)) + Mul(d#0_1, Div(b#0_1, d#0_1)));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(216,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivPosIsPos (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPosIsPos (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPosIsPos", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(221,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(224,14): post-state"} true;
    assume d#0 != 0;
    assume LitInt(0) <= Div(x#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivPosIsPos (call precondtion)"} CallPre$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int);
  requires {:id "id11110"} LitInt(0) <= x#0;
  requires {:id "id11111"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivPosIsPos (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11112"} LitInt(0) <= Div(x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivPosIsPos (correctness)"} Impl$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11113"} LitInt(0) <= x#0;
  requires {:id "id11114"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11115"} LitInt(0) <= Div(x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPosIsPos (correctness)"} Impl$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPosIsPos", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(225,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0;
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 ==> Div(u#0, d#0) >= LitInt(0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int ==> Div($Unbox($l#1#u#0): int, d#0) >= LitInt(0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(226,59)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivPosIsPosAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPosIsPosAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPosIsPosAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPosIsPosAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPosIsPosAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(229,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(230,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    assume d#0 != 0;
    assume LitInt(0) <= Div(x#0, d#0);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < d#0 ==> LitInt(0) <= Div(x#0, d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> LitInt(0) <= Div(x#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivPosIsPosAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();



procedure {:verboseName "DivMod.LemmaDivPosIsPosAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11126"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> LitInt(0) <= Div(x#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivPosIsPosAuto (correctness)"} Impl$$DivMod.__default.LemmaDivPosIsPosAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11127"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> LitInt(0) <= Div(x#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPosIsPosAuto (correctness)"} Impl$$DivMod.__default.LemmaDivPosIsPosAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPosIsPosAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(231,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume LitInt(0) <= Div(x#0_0, d#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPos(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivPosIsPos(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(235,28)"} true;
    assume LitInt(0) <= Div(x#0_0, d#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && 0 < d#0_1 ==> LitInt(0) <= Div(x#0_1, d#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(236,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivPlusOne (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPlusOne (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPlusOne", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(241,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(243,22): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume 1 + Div(x#0, d#0) == Div(d#0 + x#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivPlusOne (call precondtion)"} CallPre$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int);
  requires {:id "id11138"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivPlusOne (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11139"} 1 + Div(x#0, d#0) == Div(d#0 + x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivPlusOne (correctness)"} Impl$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11140"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11141"} 1 + Div(x#0, d#0) == Div(d#0 + x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPlusOne (correctness)"} Impl$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPlusOne", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(244,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(245,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivPlusOneAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPlusOneAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPlusOneAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivPlusOneAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPlusOneAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(248,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(249,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume 1 + Div(x#0, d#0) == Div(d#0 + x#0, d#0);
    goto anon4;

  anon5_Else:
    assume 0 < d#0 ==> 1 + Div(x#0, d#0) == Div(d#0 + x#0, d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { 1 + Div(x#1, d#1), Div(d#1 + x#1, d#1) } 0 < d#1 ==> 1 + Div(x#1, d#1) == Div(d#1 + x#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivPlusOneAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivPlusOneAuto();



procedure {:verboseName "DivMod.LemmaDivPlusOneAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPlusOneAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11150"} (forall x#1: int, d#1: int :: { 1 + Div(x#1, d#1), Div(d#1 + x#1, d#1) } 0 < d#1 ==> 1 + Div(x#1, d#1) == Div(d#1 + x#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivPlusOneAuto (correctness)"} Impl$$DivMod.__default.LemmaDivPlusOneAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11151"} (forall x#1: int, d#1: int :: { 1 + Div(x#1, d#1), Div(d#1 + x#1, d#1) } 0 < d#1 ==> 1 + Div(x#1, d#1) == Div(d#1 + x#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivPlusOneAuto (correctness)"} Impl$$DivMod.__default.LemmaDivPlusOneAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPlusOneAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(250,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    assume true;
    assume 0 < d#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume 1 + Div(x#0_0, d#0_0) == Div(d#0_0 + x#0_0, d#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivPlusOne(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivPlusOne(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(254,27)"} true;
    assume 1 + Div(x#0_0, d#0_0) == Div(d#0_0 + x#0_0, d#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, d#0_1: int, _t#0#0_0: int :: { Div(_t#0#0_0, d#0_1), Div(x#0_1, d#0_1) } _t#0#0_0 == d#0_1 + x#0_1 && 0 < d#0_1 ==> 1 + Div(x#0_1, d#0_1) == Div(_t#0#0_0, d#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(255,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMinusOne (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMinusOne (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMinusOne", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(260,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(262,23): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume -1 + Div(x#0, d#0) == Div(0 - d#0 + x#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivMinusOne (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int);
  requires {:id "id11163"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivMinusOne (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11164"} -1 + Div(x#0, d#0) == Div(0 - d#0 + x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMinusOne (correctness)"} Impl$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11165"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11166"} -1 + Div(x#0, d#0) == Div(0 - d#0 + x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMinusOne (correctness)"} Impl$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMinusOne", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(263,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(264,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMinusOneAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMinusOneAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMinusOneAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMinusOneAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMinusOneAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(267,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(268,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume -1 + Div(x#0, d#0) == Div(0 - d#0 + x#0, d#0);
    goto anon4;

  anon5_Else:
    assume 0 < d#0 ==> -1 + Div(x#0, d#0) == Div(0 - d#0 + x#0, d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { -1 + Div(x#1, d#1), Div(0 - d#1 + x#1, d#1) } 0 < d#1 ==> -1 + Div(x#1, d#1) == Div(0 - d#1 + x#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivMinusOneAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMinusOneAuto();



procedure {:verboseName "DivMod.LemmaDivMinusOneAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMinusOneAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11175"} (forall x#1: int, d#1: int :: { -1 + Div(x#1, d#1), Div(0 - d#1 + x#1, d#1) } 0 < d#1 ==> -1 + Div(x#1, d#1) == Div(0 - d#1 + x#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMinusOneAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMinusOneAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11176"} (forall x#1: int, d#1: int :: { -1 + Div(x#1, d#1), Div(0 - d#1 + x#1, d#1) } 0 < d#1 ==> -1 + Div(x#1, d#1) == Div(0 - d#1 + x#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMinusOneAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMinusOneAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMinusOneAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(269,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    assume true;
    assume 0 < d#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume -1 + Div(x#0_0, d#0_0) == Div(0 - d#0_0 + x#0_0, d#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivMinusOne(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivMinusOne(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(273,28)"} true;
    assume -1 + Div(x#0_0, d#0_0) == Div(0 - d#0_0 + x#0_0, d#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, d#0_1: int, _t#0#0_0: int :: { Div(_t#0#0_0, d#0_1), Div(x#0_1, d#0_1) } _t#0#0_0 == 0 - d#0_1 + x#0_1 && 0 < d#0_1 ==> -1 + Div(x#0_1, d#0_1) == Div(_t#0#0_0, d#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(274,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaBasicDiv (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBasicDiv(d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBasicDiv (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBasicDiv(d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBasicDiv", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(278,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(280,12): post-state"} true;
    havoc x#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon8_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < d#0;
    assume d#0 != 0;
    assume Div(x#0, d#0) == LitInt(0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= x#0 && x#0 < d#0 ==> Div(x#0, d#0) == LitInt(0);
    goto anon6;

  anon6:
    assume (forall x#1: int :: { Div(x#1, d#0) } LitInt(0) <= x#1 && x#1 < d#0 ==> Div(x#1, d#0) == LitInt(0));
    return;
}



procedure {:verboseName "DivMod.LemmaBasicDiv (call precondtion)"} CallPre$$DivMod.__default.LemmaBasicDiv(d#0: int);
  requires {:id "id11190"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaBasicDiv (call postcondition)"} CallPost$$DivMod.__default.LemmaBasicDiv(d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11191"} (forall x#1: int :: { Div(x#1, d#0) } LitInt(0) <= x#1 && x#1 < d#0 ==> Div(x#1, d#0) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaBasicDiv (correctness)"} Impl$$DivMod.__default.LemmaBasicDiv(d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11192"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11193"} (forall x#1: int :: { Div(x#1, d#0) } LitInt(0) <= x#1 && x#1 < d#0 ==> Div(x#1, d#0) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBasicDiv (correctness)"} Impl$$DivMod.__default.LemmaBasicDiv(d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBasicDiv", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(281,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(282,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaBasicDivAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBasicDivAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBasicDivAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBasicDivAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0: int;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBasicDivAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(285,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(286,12): post-state"} true;
    havoc d#0;
    havoc x#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon8_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < d#0;
    assume d#0 != 0;
    assume Div(x#0, d#0) == LitInt(0);
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= x#0 && x#0 < d#0 ==> Div(x#0, d#0) == LitInt(0);
    goto anon6;

  anon6:
    assume (forall d#1: int, x#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && x#1 < d#1 ==> Div(x#1, d#1) == LitInt(0));
    return;
}



procedure {:verboseName "DivMod.LemmaBasicDivAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaBasicDivAuto();



procedure {:verboseName "DivMod.LemmaBasicDivAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaBasicDivAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11201"} (forall d#1: int, x#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && x#1 < d#1 ==> Div(x#1, d#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaBasicDivAuto (correctness)"} Impl$$DivMod.__default.LemmaBasicDivAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11202"} (forall d#1: int, x#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && x#1 < d#1 ==> Div(x#1, d#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBasicDivAuto (correctness)"} Impl$$DivMod.__default.LemmaBasicDivAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBasicDivAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(287,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && x#0_0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(x#0_0, d#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaBasicDiv(d##0_0);
    call CallPost$$DivMod.__default.LemmaBasicDiv(d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(291,22)"} true;
    assume Div(x#0_0, d#0_0) == LitInt(0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && x#0_1 < d#0_1 ==> Div(x#0_1, d#0_1) == LitInt(0));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(292,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrdered (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrdered (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrdered", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(296,8): initial state"} true;
    assume x#0 <= y#0;
    assume 0 < z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(299,18): post-state"} true;
    assume z#0 != 0;
    assume z#0 != 0;
    assume Div(x#0, z#0) <= Div(y#0, z#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrdered (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int);
  requires {:id "id11214"} x#0 <= y#0;
  requires {:id "id11215"} 0 < z#0;



procedure {:verboseName "DivMod.LemmaDivIsOrdered (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11216"} Div(x#0, z#0) <= Div(y#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsOrdered (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11217"} x#0 <= y#0;
  requires {:id "id11218"} 0 < z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11219"} Div(x#0, z#0) <= Div(y#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrdered (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var xy#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrdered", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(300,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := z#0;
    assume true;
    x##0 := x#0 - y#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc xy#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} xy#0 <= LitInt(0);
    assume z#0 != 0;
    assume z#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} LitInt(0) < xy#0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> xy#0 <= LitInt(0) ==> Div(xy#0 + y#0, z#0) <= Div(y#0, z#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#xy#0: Box :: $Box($Unbox($l#1#xy#0): int <= LitInt(0) ==> Div($Unbox($l#1#xy#0): int + y#0, z#0) <= Div(y#0, z#0))), (lambda $l#1#heap#0: Heap, $l#1#xy#0: Box :: $IsBox($l#1#xy#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#xy#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(301,76)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrderedAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrderedAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrderedAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivIsOrderedAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var z#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(304,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(305,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc z#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume x#0 <= y#0;
    assume 0 < z#0;
    assume z#0 != 0;
    assume z#0 != 0;
    assume Div(x#0, z#0) <= Div(y#0, z#0);
    goto anon4;

  anon5_Else:
    assume x#0 <= y#0 && 0 < z#0 ==> Div(x#0, z#0) <= Div(y#0, z#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, z#1: int :: { Div(x#1, z#1), Div(y#1, z#1) } x#1 <= y#1 && 0 < z#1 ==> Div(x#1, z#1) <= Div(y#1, z#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivIsOrderedAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivIsOrderedAuto();



procedure {:verboseName "DivMod.LemmaDivIsOrderedAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrderedAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11232"} (forall x#1: int, y#1: int, z#1: int :: { Div(x#1, z#1), Div(y#1, z#1) } x#1 <= y#1 && 0 < z#1 ==> Div(x#1, z#1) <= Div(y#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivIsOrderedAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrderedAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11233"} (forall x#1: int, y#1: int, z#1: int :: { Div(x#1, z#1), Div(y#1, z#1) } x#1 <= y#1 && 0 < z#1 ==> Div(x#1, z#1) <= Div(y#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivIsOrderedAuto (correctness)"} Impl$$DivMod.__default.LemmaDivIsOrderedAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(306,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} x#0_0 <= y#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} y#0_0 < x#0_0;
    goto anon3;

  anon3:
    assume true;
    assume x#0_0 <= y#0_0 && 0 < z#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} z#0_0 != 0;
    assume {:subsumption 0} z#0_0 != 0;
    assume true;
    assume Div(x#0_0, z#0_0) <= Div(y#0_0, z#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaDivIsOrdered(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaDivIsOrdered(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(310,32)"} true;
    assume Div(x#0_0, z#0_0) <= Div(y#0_0, z#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Div(y#0_1, z#0_1), Div(x#0_1, z#0_1) } x#0_1 <= y#0_1 && 0 < z#0_1 ==> Div(x#0_1, z#0_1) <= Div(y#0_1, z#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(311,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivDecreases (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDecreases (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDecreases", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(316,8): initial state"} true;
    assume 0 < x#0;
    assume 1 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(319,19): post-state"} true;
    assume d#0 != 0;
    assume Div(x#0, d#0) < x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivDecreases (call precondtion)"} CallPre$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int);
  requires {:id "id11245"} 0 < x#0;
  requires {:id "id11246"} 1 < d#0;



procedure {:verboseName "DivMod.LemmaDivDecreases (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11247"} Div(x#0, d#0) < x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivDecreases (correctness)"} Impl$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11248"} 0 < x#0;
  requires {:id "id11249"} 1 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11250"} Div(x#0, d#0) < x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDecreases (correctness)"} Impl$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDecreases", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(320,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < u#0;
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 <= 0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> 0 < u#0 ==> Div(u#0, d#0) < u#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(0 < $Unbox($l#1#u#0): int ==> Div($Unbox($l#1#u#0): int, d#0) < $Unbox($l#1#u#0): int)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(321,57)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivDecreasesAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDecreasesAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDecreasesAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDecreasesAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDecreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(324,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(325,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < x#0;
    assume 1 < d#0;
    assume d#0 != 0;
    assume Div(x#0, d#0) < x#0;
    goto anon4;

  anon5_Else:
    assume 0 < x#0 && 1 < d#0 ==> Div(x#0, d#0) < x#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } 0 < x#1 && 1 < d#1 ==> Div(x#1, d#1) < x#1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivDecreasesAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivDecreasesAuto();



procedure {:verboseName "DivMod.LemmaDivDecreasesAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11261"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } 0 < x#1 && 1 < d#1 ==> Div(x#1, d#1) < x#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivDecreasesAuto (correctness)"} Impl$$DivMod.__default.LemmaDivDecreasesAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11262"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } 0 < x#1 && 1 < d#1 ==> Div(x#1, d#1) < x#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDecreasesAuto (correctness)"} Impl$$DivMod.__default.LemmaDivDecreasesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDecreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(326,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < x#0_0 && 1 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(x#0_0, d#0_0) < x#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivDecreases(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivDecreases(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(330,29)"} true;
    assume Div(x#0_0, d#0_0) < x#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } 0 < x#0_1 && 1 < d#0_1 ==> Div(x#0_1, d#0_1) < x#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(331,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonincreasing (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonincreasing (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonincreasing", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(336,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(339,19): post-state"} true;
    assume d#0 != 0;
    assume Div(x#0, d#0) <= x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonincreasing (call precondtion)"} CallPre$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int);
  requires {:id "id11273"} LitInt(0) <= x#0;
  requires {:id "id11274"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivNonincreasing (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11275"} Div(x#0, d#0) <= x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivNonincreasing (correctness)"} Impl$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11276"} LitInt(0) <= x#0;
  requires {:id "id11277"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11278"} Div(x#0, d#0) <= x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonincreasing (correctness)"} Impl$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonincreasing", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(340,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0;
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 ==> Div(u#0, d#0) <= u#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int ==> Div($Unbox($l#1#u#0): int, d#0) <= $Unbox($l#1#u#0): int)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(341,59)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonincreasingAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonincreasingAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonincreasingAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivNonincreasingAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonincreasingAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(344,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(345,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    assume d#0 != 0;
    assume Div(x#0, d#0) <= x#0;
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < d#0 ==> Div(x#0, d#0) <= x#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> Div(x#1, d#1) <= x#1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivNonincreasingAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivNonincreasingAuto();



procedure {:verboseName "DivMod.LemmaDivNonincreasingAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonincreasingAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11289"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> Div(x#1, d#1) <= x#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivNonincreasingAuto (correctness)"} Impl$$DivMod.__default.LemmaDivNonincreasingAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11290"} (forall x#1: int, d#1: int :: { Div(x#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> Div(x#1, d#1) <= x#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivNonincreasingAuto (correctness)"} Impl$$DivMod.__default.LemmaDivNonincreasingAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonincreasingAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(346,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(x#0_0, d#0_0) <= x#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivNonincreasing(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivNonincreasing(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(350,33)"} true;
    assume Div(x#0_0, d#0_0) <= x#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && 0 < d#0_1 ==> Div(x#0_1, d#0_1) <= x#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(351,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaSmallMod (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSmallMod (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSmallMod(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSmallMod", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(355,8): initial state"} true;
    assume x#0 < m#0;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(358,18): post-state"} true;
    assume m#0 != 0;
    assume Mod(x#0, m#0) == x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaSmallMod (call precondtion)"} CallPre$$DivMod.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  requires {:id "id11301"} x#0 < m#0;
  requires {:id "id11302"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaSmallMod (call postcondition)"} CallPost$$DivMod.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11303"} Mod(x#0, m#0) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaSmallMod (correctness)"} Impl$$DivMod.__default.LemmaSmallMod(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11304"} x#0 < m#0;
  requires {:id "id11305"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11306"} Mod(x#0, m#0) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSmallMod (correctness)"} Impl$$DivMod.__default.LemmaSmallMod(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var m##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSmallMod", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(359,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    m##0 := m#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaSmallMod(x##0, m##0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaSmallMod(x##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(360,30)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaBreakdown (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBreakdown (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBreakdown", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(363,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < y#0;
    assume 0 < z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(367,14): post-state"} true;
    assume 0 < Mul(y#0, z#0);
    assume Mul(y#0, z#0) != 0;
    assume y#0 != 0;
    assume z#0 != 0;
    assume y#0 != 0;
    assume Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    return;
}



procedure {:verboseName "DivMod.LemmaBreakdown (call precondtion)"} CallPre$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int);
  requires {:id "id11318"} LitInt(0) <= x#0;
  requires {:id "id11319"} 0 < y#0;
  requires {:id "id11320"} 0 < z#0;



procedure {:verboseName "DivMod.LemmaBreakdown (call postcondition)"} CallPost$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11321"} 0 < Mul(y#0, z#0);
  free ensures true;
  free ensures {:id "id11322"} Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaBreakdown (correctness)"} Impl$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id11323"} LitInt(0) <= x#0;
  requires {:id "id11324"} 0 < y#0;
  requires {:id "id11325"} 0 < z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11326"} 0 < Mul(y#0, z#0);
  free ensures true;
  free ensures {:id "id11327"} Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBreakdown (correctness)"} Impl$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;
  var x##0_3_0: int;
  var y##0_3_0: int;
  var z##0_3_0: int;
  var a##0_4_0: int;
  var b##0_4_0: int;
  var c##0_4_0: int;
  var x##1_0_0: int;
  var b##1_0_0: int;
  var c##1_0_0: int;
  var x##1_1_0: int;
  var y##1_1_0: int;
  var x##1_1_1: int;
  var m##1_1_0: int;
  var x##1_2_0: int;
  var y##1_2_0: int;
  var a##1_2_0: int;
  var b##1_2_0: int;
  var d##1_2_0: int;
  var x##1_3_0: int;
  var d##1_3_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBreakdown", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(369,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(370,34)"} true;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := y#0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPos(x##0, d##0);
    call CallPost$$DivMod.__default.LemmaDivPosIsPos(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(371,26)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume LitInt(0) <= Div(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(372,21)"} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume false;
    goto anon7;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    push;
    push;
    assume true;
    a##0_4_0 := x#0;
    assume true;
    b##0_4_0 := y#0;
    assume true;
    c##0_4_0 := z#0;
    call CallPre$$DivMod.__default.LemmaPartBound1(a##0_4_0, b##0_4_0, c##0_4_0);
    call CallPost$$DivMod.__default.LemmaPartBound1(a##0_4_0, b##0_4_0, c##0_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(376,36)"} true;
    pop;
    pop;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) <= Mul(y#0, z#0 - 1) + Mod(Mod(x#0, y#0), Mul(y#0, z#0));
    assume false;
    goto anon7;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    push;
    push;
    assume true;
    x##0_3_0 := x#0;
    assume true;
    y##0_3_0 := y#0;
    assume true;
    z##0_3_0 := z#0;
    call CallPre$$DivMod.__default.LemmaPartBound2(x##0_3_0, y##0_3_0, z##0_3_0);
    call CallPost$$DivMod.__default.LemmaPartBound2(x##0_3_0, y##0_3_0, z##0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(378,35)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < Mul(y#0, z#0 - 1) + y#0;
    assume false;
    goto anon7;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(380,32)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1) + y#0 == Mul(y#0, z#0 - 1) + Mul(y#0, LitInt(1));
    assume false;
    goto anon7;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(382,40)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1) + Mul(y#0, LitInt(1)) == Mul(y#0, z#0 - 1 + 1);
    assume false;
    goto anon7;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume true;
    push;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1 + 1) == Mul(y#0, z#0);
    assume false;
    goto anon7;

  anon21_Else:
    goto anon7;

  anon7:
    assume Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < Mul(y#0, z#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume false;
    goto anon15;

  anon22_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume true;
    x##1_3_0 := x#0;
    assume true;
    d##1_3_0 := y#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##1_3_0, d##1_3_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##1_3_0, d##1_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(389,35)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0, Mul(y#0, z#0)) == Mod(Mul(y#0, Div(x#0, y#0)) + Mod(x#0, y#0), Mul(y#0, z#0));
    assume false;
    goto anon15;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(392,32)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume LitInt(0) <= Mod(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(393,25)"} true;
    assume true;
    x##1_2_0 := y#0;
    assume y#0 != 0;
    assume true;
    y##1_2_0 := Div(x#0, y#0);
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##1_2_0, y##1_2_0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##1_2_0, y##1_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(394,37)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < Mul(y#0, z#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(395,66)"} true;
    assume y#0 != 0;
    assume true;
    a##1_2_0 := Mul(y#0, Div(x#0, y#0));
    assume y#0 != 0;
    assume true;
    b##1_2_0 := Mod(x#0, y#0);
    assume true;
    d##1_2_0 := Mul(y#0, z#0);
    call CallPre$$DivMod.__default.LemmaModAdds(a##1_2_0, b##1_2_0, d##1_2_0);
    call CallPost$$DivMod.__default.LemmaModAdds(a##1_2_0, b##1_2_0, d##1_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(396,47)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)) + Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0));
    assume false;
    goto anon15;

  anon24_Else:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(400,32)"} true;
    assume true;
    x##1_1_0 := z#0;
    assume true;
    y##1_1_0 := y#0;
    call CallPre$$Mul.__default.LemmaMulIncreases(x##1_1_0, y##1_1_0);
    call CallPost$$Mul.__default.LemmaMulIncreases(x##1_1_0, y##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(401,31)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(402,35)"} true;
    assume {:subsumption 0} y#0 != 0;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} Mod(x#0, y#0) < y#0;
    goto anon13;

  anon26_Else:
    assume {:partition} y#0 <= Mod(x#0, y#0);
    goto anon13;

  anon13:
    assume true;
    assume {:subsumption 0} Mod(x#0, y#0) < y#0;
    assume {:subsumption 0} y#0 <= Mul(y#0, z#0);
    assume Mod(x#0, y#0) < y#0 && y#0 <= Mul(y#0, z#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(403,33)"} true;
    assume y#0 != 0;
    assume true;
    assume $Is(Mod(x#0, y#0), Tclass._System.nat());
    x##1_1_1 := Mod(x#0, y#0);
    assume true;
    assume $Is(Mul(y#0, z#0), Tclass._System.nat());
    m##1_1_0 := Mul(y#0, z#0);
    call CallPre$$DivMod.__default.LemmaSmallMod(x##1_1_1, m##1_1_0);
    call CallPost$$DivMod.__default.LemmaSmallMod(x##1_1_1, m##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(404,35)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume Mod(Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(405,41)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(x#0, y#0);
    assume false;
    goto anon15;

  anon25_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume y#0 != 0;
    assume true;
    x##1_0_0 := Div(x#0, y#0);
    assume true;
    b##1_0_0 := y#0;
    assume true;
    c##1_0_0 := z#0;
    call CallPre$$DivMod.__default.LemmaTruncateMiddle(x##1_0_0, b##1_0_0, c##1_0_0);
    call CallPost$$DivMod.__default.LemmaTruncateMiddle(x##1_0_0, b##1_0_0, c##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(408,40)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(x#0, y#0) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    assume false;
    goto anon15;

  anon27_Else:
    goto anon15;

  anon15:
    assume Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    return;
}



procedure {:verboseName "DivMod.LemmaBreakdownAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBreakdownAuto();
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBreakdownAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaBreakdownAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var z#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBreakdownAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(413,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(414,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc z#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < y#0;
    assume 0 < z#0;
    assume 0 < Mul(y#0, z#0);
    assume Mul(y#0, z#0) != 0;
    assume y#0 != 0;
    assume z#0 != 0;
    assume y#0 != 0;
    assume Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < y#0 && 0 < z#0 ==> 0 < Mul(y#0, z#0) && Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, Mul(y#1, z#1)), Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1) } (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> 0 < Mul(y#1, z#1)) && (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(x#1, Mul(y#1, z#1)) == Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaBreakdownAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaBreakdownAuto();



procedure {:verboseName "DivMod.LemmaBreakdownAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaBreakdownAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11441"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, Mul(y#1, z#1)), Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1) } (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> 0 < Mul(y#1, z#1)) && (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(x#1, Mul(y#1, z#1)) == Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaBreakdownAuto (correctness)"} Impl$$DivMod.__default.LemmaBreakdownAuto() returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11442"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, Mul(y#1, z#1)), Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1) } (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> 0 < Mul(y#1, z#1)) && (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(x#1, Mul(y#1, z#1)) == Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaBreakdownAuto (correctness)"} Impl$$DivMod.__default.LemmaBreakdownAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaBreakdownAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(416,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < y#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < y#0_0);
    goto anon5;

  anon5:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < y#0_0 && 0 < z#0_0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} 0 < Mul(y#0_0, z#0_0);
    assume {:subsumption 0} Mul(y#0_0, z#0_0) != 0;
    assume {:subsumption 0} y#0_0 != 0;
    assume {:subsumption 0} z#0_0 != 0;
    assume {:subsumption 0} y#0_0 != 0;
    goto anon8;

  anon16_Else:
    assume {:partition} Mul(y#0_0, z#0_0) <= 0;
    goto anon8;

  anon8:
    assume true;
    assume 0 < Mul(y#0_0, z#0_0) && Mod(x#0_0, Mul(y#0_0, z#0_0)) == Mul(y#0_0, Mod(Div(x#0_0, y#0_0), z#0_0)) + Mod(x#0_0, y#0_0);
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaBreakdown(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaBreakdown(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(420,29)"} true;
    assume 0 < Mul(y#0_0, z#0_0);
    assume Mod(x#0_0, Mul(y#0_0, z#0_0)) == Mul(y#0_0, Mod(Div(x#0_0, y#0_0), z#0_0)) + Mod(x#0_0, y#0_0);
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mod(Div(x#0_1, y#0_1), z#0_1) } { Mod(x#0_1, Mul(y#0_1, z#0_1)) } LitInt(0) <= x#0_1 && 0 < y#0_1 && 0 < z#0_1 ==> 0 < Mul(y#0_1, z#0_1) && Mod(x#0_1, Mul(y#0_1, z#0_1)) == Mul(y#0_1, Mod(Div(x#0_1, y#0_1), z#0_1)) + Mod(x#0_1, y#0_1));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(421,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderUpper (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderUpper (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderUpper", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(424,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(427,18): post-state"} true;
    assume d#0 != 0;
    assume x#0 - d#0 < Mul(Div(x#0, d#0), d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderUpper (call precondtion)"} CallPre$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int);
  requires {:id "id11457"} LitInt(0) <= x#0;
  requires {:id "id11458"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaRemainderUpper (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11459"} x#0 - d#0 < Mul(Div(x#0, d#0), d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRemainderUpper (correctness)"} Impl$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11460"} LitInt(0) <= x#0;
  requires {:id "id11461"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11462"} x#0 - d#0 < Mul(Div(x#0, d#0), d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderUpper (correctness)"} Impl$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderUpper", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(428,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(429,18)"} true;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0;
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 ==> u#0 - d#0 < Mul(Div(u#0, d#0), d#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int ==> $Unbox($l#1#u#0): int - d#0 < Mul(Div($Unbox($l#1#u#0): int, d#0), d#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(430,66)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderUpperAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderUpperAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderUpperAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderUpperAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderUpperAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(433,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(434,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    assume d#0 != 0;
    assume x#0 - d#0 < Mul(Div(x#0, d#0), d#0);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < d#0 ==> x#0 - d#0 < Mul(Div(x#0, d#0), d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { x#1 - d#1, Mul(d#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> x#1 - d#1 < Mul(Div(x#1, d#1), d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderUpperAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaRemainderUpperAuto();



procedure {:verboseName "DivMod.LemmaRemainderUpperAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderUpperAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11475"} (forall x#1: int, d#1: int :: { x#1 - d#1, Mul(d#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> x#1 - d#1 < Mul(Div(x#1, d#1), d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRemainderUpperAuto (correctness)"} Impl$$DivMod.__default.LemmaRemainderUpperAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11476"} (forall x#1: int, d#1: int :: { x#1 - d#1, Mul(d#1, d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> x#1 - d#1 < Mul(Div(x#1, d#1), d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderUpperAuto (correctness)"} Impl$$DivMod.__default.LemmaRemainderUpperAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderUpperAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(435,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume x#0_0 - d#0_0 < Mul(Div(x#0_0, d#0_0), d#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaRemainderUpper(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaRemainderUpper(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(439,31)"} true;
    assume x#0_0 - d#0_0 < Mul(Div(x#0_0, d#0_0), d#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && 0 < d#0_1 ==> x#0_1 - d#0_1 < Mul(Div(x#0_1, d#0_1), d#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(440,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderLower (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderLower (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderLower", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(443,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(446,15): post-state"} true;
    assume d#0 != 0;
    assume x#0 >= Mul(Div(x#0, d#0), d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderLower (call precondtion)"} CallPre$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int);
  requires {:id "id11487"} LitInt(0) <= x#0;
  requires {:id "id11488"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaRemainderLower (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11489"} x#0 >= Mul(Div(x#0, d#0), d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRemainderLower (correctness)"} Impl$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11490"} LitInt(0) <= x#0;
  requires {:id "id11491"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11492"} x#0 >= Mul(Div(x#0, d#0), d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderLower (correctness)"} Impl$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderLower", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(447,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(448,18)"} true;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0;
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 ==> u#0 >= Mul(Div(u#0, d#0), d#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int ==> $Unbox($l#1#u#0): int >= Mul(Div($Unbox($l#1#u#0): int, d#0), d#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(449,63)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderLowerAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderLowerAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderLowerAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderLowerAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderLowerAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(452,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(453,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    assume d#0 != 0;
    assume x#0 >= Mul(Div(x#0, d#0), d#0);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < d#0 ==> x#0 >= Mul(Div(x#0, d#0), d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Mul(Div(x#1, d#1), d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> x#1 >= Mul(Div(x#1, d#1), d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderLowerAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaRemainderLowerAuto();



procedure {:verboseName "DivMod.LemmaRemainderLowerAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderLowerAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11505"} (forall x#1: int, d#1: int :: { Mul(Div(x#1, d#1), d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> x#1 >= Mul(Div(x#1, d#1), d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRemainderLowerAuto (correctness)"} Impl$$DivMod.__default.LemmaRemainderLowerAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11506"} (forall x#1: int, d#1: int :: { Mul(Div(x#1, d#1), d#1) } LitInt(0) <= x#1 && 0 < d#1 ==> x#1 >= Mul(Div(x#1, d#1), d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderLowerAuto (correctness)"} Impl$$DivMod.__default.LemmaRemainderLowerAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderLowerAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(454,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume x#0_0 >= Mul(Div(x#0_0, d#0_0), d#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaRemainderLower(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaRemainderLower(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(458,31)"} true;
    assume x#0_0 >= Mul(Div(x#0_0, d#0_0), d#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && 0 < d#0_1 ==> x#0_1 >= Mul(Div(x#0_1, d#0_1), d#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(459,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainder (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainder (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainder", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(462,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(465,15): post-state"} true;
    assume d#0 != 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0);
    assume d#0 != 0;
    goto anon3;

  anon4_Else:
    assume {:partition} x#0 - Mul(Div(x#0, d#0), d#0) < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0) && x#0 - Mul(Div(x#0, d#0), d#0) < d#0;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainder (call precondtion)"} CallPre$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int);
  requires {:id "id11518"} LitInt(0) <= x#0;
  requires {:id "id11519"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaRemainder (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11520"} LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0);
  free ensures {:id "id11521"} x#0 - Mul(Div(x#0, d#0), d#0) < d#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRemainder (correctness)"} Impl$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11522"} LitInt(0) <= x#0;
  requires {:id "id11523"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11524"} LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0);
  free ensures {:id "id11525"} x#0 - Mul(Div(x#0, d#0), d#0) < d#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainder (correctness)"} Impl$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainder", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(466,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(467,18)"} true;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := x#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0 - Mul(Div(u#0, d#0), d#0);
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 - Mul(Div(u#0, d#0), d#0) < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 - Mul(Div(u#0, d#0), d#0) && u#0 - Mul(Div(u#0, d#0), d#0) < d#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int - Mul(Div($Unbox($l#1#u#0): int, d#0), d#0) && $Unbox($l#1#u#0): int - Mul(Div($Unbox($l#1#u#0): int, d#0), d#0) < d#0)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(468,60)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRemainderAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(471,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(472,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume LitInt(0) <= x#0;
    assume 0 < d#0;
    assume d#0 != 0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0);
    assume d#0 != 0;
    goto anon4;

  anon8_Else:
    assume {:partition} x#0 - Mul(Div(x#0, d#0), d#0) < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0) && x#0 - Mul(Div(x#0, d#0), d#0) < d#0;
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= x#0 && 0 < d#0 ==> LitInt(0) <= x#0 - Mul(Div(x#0, d#0), d#0) && x#0 - Mul(Div(x#0, d#0), d#0) < d#0;
    goto anon6;

  anon6:
    assume (forall x#1: int, d#1: int :: { x#1 - Mul(Div(x#1, d#1), d#1) } (LitInt(0) <= x#1 && 0 < d#1 ==> LitInt(0) <= x#1 - Mul(Div(x#1, d#1), d#1)) && (LitInt(0) <= x#1 && 0 < d#1 ==> x#1 - Mul(Div(x#1, d#1), d#1) < d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaRemainderAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaRemainderAuto();



procedure {:verboseName "DivMod.LemmaRemainderAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11540"} (forall x#1: int, d#1: int :: { x#1 - Mul(Div(x#1, d#1), d#1) } (LitInt(0) <= x#1 && 0 < d#1 ==> LitInt(0) <= x#1 - Mul(Div(x#1, d#1), d#1)) && (LitInt(0) <= x#1 && 0 < d#1 ==> x#1 - Mul(Div(x#1, d#1), d#1) < d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRemainderAuto (correctness)"} Impl$$DivMod.__default.LemmaRemainderAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11541"} (forall x#1: int, d#1: int :: { x#1 - Mul(Div(x#1, d#1), d#1) } (LitInt(0) <= x#1 && 0 < d#1 ==> LitInt(0) <= x#1 - Mul(Div(x#1, d#1), d#1)) && (LitInt(0) <= x#1 && 0 < d#1 ==> x#1 - Mul(Div(x#1, d#1), d#1) < d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRemainderAuto (correctness)"} Impl$$DivMod.__default.LemmaRemainderAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(473,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, d#0_0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon11_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < d#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} d#0_0 != 0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= x#0_0 - Mul(Div(x#0_0, d#0_0), d#0_0);
    assume {:subsumption 0} d#0_0 != 0;
    goto anon6;

  anon13_Else:
    assume {:partition} x#0_0 - Mul(Div(x#0_0, d#0_0), d#0_0) < LitInt(0);
    goto anon6;

  anon6:
    assume true;
    assume LitInt(0) <= x#0_0 - Mul(Div(x#0_0, d#0_0), d#0_0) && x#0_0 - Mul(Div(x#0_0, d#0_0), d#0_0) < d#0_0;
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaRemainder(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaRemainder(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(477,26)"} true;
    assume LitInt(0) <= x#0_0 - Mul(Div(x#0_0, d#0_0), d#0_0);
    assume x#0_0 - Mul(Div(x#0_0, d#0_0), d#0_0) < d#0_0;
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Div(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && 0 < d#0_1 ==> LitInt(0) <= x#0_1 - Mul(Div(x#0_1, d#0_1), d#0_1) && x#0_1 - Mul(Div(x#0_1, d#0_1), d#0_1) < d#0_1);
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(478,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivMod (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivMod (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivMod", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(482,8): initial state"} true;
    assume d#0 != 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(484,14): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivMod (call precondtion)"} CallPre$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int);
  requires {:id "id11554"} d#0 != 0;



procedure {:verboseName "DivMod.LemmaFundamentalDivMod (call postcondition)"} CallPost$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11555"} x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaFundamentalDivMod (correctness)"} Impl$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11556"} d#0 != 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11557"} x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivMod (correctness)"} Impl$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivMod", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(485,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := d#0;
    call CallPre$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    call CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(486,39)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivModAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivModAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivModAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivModAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(489,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(490,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
    goto anon4;

  anon5_Else:
    assume d#0 != 0 ==> x#0 == Mul(d#0, Div(x#0, d#0)) + Mod(x#0, d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Mul(d#1, Div(x#1, d#1)) + Mod(x#1, d#1) } d#1 != 0 ==> x#1 == Mul(d#1, Div(x#1, d#1)) + Mod(x#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivModAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaFundamentalDivModAuto();



procedure {:verboseName "DivMod.LemmaFundamentalDivModAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaFundamentalDivModAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11566"} (forall x#1: int, d#1: int :: { Mul(d#1, Div(x#1, d#1)) + Mod(x#1, d#1) } d#1 != 0 ==> x#1 == Mul(d#1, Div(x#1, d#1)) + Mod(x#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaFundamentalDivModAuto (correctness)"} Impl$$DivMod.__default.LemmaFundamentalDivModAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11567"} (forall x#1: int, d#1: int :: { Mul(d#1, Div(x#1, d#1)) + Mod(x#1, d#1) } d#1 != 0 ==> x#1 == Mul(d#1, Div(x#1, d#1)) + Mod(x#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivModAuto (correctness)"} Impl$$DivMod.__default.LemmaFundamentalDivModAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(491,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    assume true;
    assume d#0_0 != 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume x#0_0 == Mul(d#0_0, Div(x#0_0, d#0_0)) + Mod(x#0_0, d#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(495,34)"} true;
    assume x#0_0 == Mul(d#0_0, Div(x#0_0, d#0_0)) + Mod(x#0_0, d#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Mod(x#0_1, d#0_1) } { Div(x#0_1, d#0_1) } d#0_1 != 0 ==> x#0_1 == Mul(d#0_1, Div(x#0_1, d#0_1)) + Mod(x#0_1, d#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(496,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int where LitInt(0) <= c#0, d#0: int where LitInt(0) <= d#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDenominator", " | ", x#0, " | ", c#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(501,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < c#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(505,18): post-state"} true;
    assume Mul(c#0, d#0) != 0;
    assume c#0 != 0;
    assume d#0 != 0;
    assume Mul(c#0, d#0) != 0;
    assume Div(Div(x#0, c#0), d#0) == Div(x#0, Mul(c#0, d#0));
    return;
}



procedure {:verboseName "DivMod.LemmaDivDenominator (call precondtion)"} CallPre$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int where LitInt(0) <= c#0, d#0: int where LitInt(0) <= d#0);
  requires {:id "id11583"} LitInt(0) <= x#0;
  requires {:id "id11584"} 0 < c#0;
  requires {:id "id11585"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int where LitInt(0) <= c#0, d#0: int where LitInt(0) <= d#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11586"} Mul(c#0, d#0) != 0;
  free ensures true;
  free ensures {:id "id11587"} Div(Div(x#0, c#0), d#0) == Div(x#0, Mul(c#0, d#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivDenominator (correctness)"} Impl$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int where LitInt(0) <= c#0, d#0: int where LitInt(0) <= d#0) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id11588"} LitInt(0) <= x#0;
  requires {:id "id11589"} 0 < c#0;
  requires {:id "id11590"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11591"} Mul(c#0, d#0) != 0;
  free ensures true;
  free ensures {:id "id11592"} Div(Div(x#0, c#0), d#0) == Div(x#0, Mul(c#0, d#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDenominator (correctness)"} Impl$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var R#0: int;
  var x##0: int;
  var d##0: int;
  var x##0_0: int;
  var d##0_0: int;
  var x##0_1: int;
  var y##0_0: int;
  var z##0_0: int;
  var x##1: int;
  var d##1: int;
  var q##0: int;
  var r##0: int;
  var x##2: int;
  var d##2: int;
  var k#0: int;
  var x##3: int;
  var d##3: int;
  var a##1_0_0: int;
  var b##1_0_0: int;
  var m##1_0_0: int;
  var x##1_1_0: int;
  var y##1_1_0: int;
  var x##1_4_0: int;
  var d##1_4_0: int;
  var x##1_4_1: int;
  var a##1_4_0: int;
  var b##1_4_0: int;
  var x##1_8_0: int;
  var y##1_8_0: int;
  var z##1_8_0: int;
  var x##1_9_0: int;
  var y##1_9_0: int;
  var x##1_10_0: int;
  var y##1_10_0: int;
  var z##1_10_0: int;
  var x##1_11_0: int;
  var j##1_11_0: int;
  var d##1_11_0: int;
  var a##1_12_0: int;
  var b##1_12_0: int;
  var m##1_12_0: int;
  var x##2_0_0: int;
  var d##2_0_0: int;
  var m##3_0_0: int;
  var x##3_0_0: int;
  var y##3_0_0: int;
  var x##3_2_0: int;
  var d##3_2_0: int;
  var x##3_7_0: int;
  var d##3_7_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDenominator", " | ", x#0, " | ", c#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(507,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(508,34)"} true;
    assume true;
    assume Mul(c#0, d#0) != 0;
    assume true;
    R#0 := Mod(x#0, Mul(c#0, d#0));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(509,24)"} true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(510,28)"} true;
    assume true;
    x##0 := R#0;
    assume true;
    d##0 := c#0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPos(x##0, d##0);
    call CallPost$$DivMod.__default.LemmaDivPosIsPos(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(512,26)"} true;
    assume c#0 != 0;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} Div(R#0, c#0) >= d#0;
    push;
    assume true;
    x##0_0 := R#0;
    assume true;
    d##0_0 := c#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(514,34)"} true;
    assume true;
    x##0_1 := d#0;
    assume c#0 != 0;
    assume true;
    y##0_0 := Div(R#0, c#0);
    assume true;
    z##0_0 := c#0;
    call CallPre$$Mul.__default.LemmaMulInequality(x##0_1, y##0_0, z##0_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##0_1, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(515,37)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(516,33)"} true;
    assume true;
    assume Lit(false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(517,18)"} true;
    pop;
    goto anon3;

  anon32_Else:
    assume {:partition} d#0 > Div(R#0, c#0);
    goto anon3;

  anon3:
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Div(R#0, c#0) < d#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(519,20)"} true;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(521,24)"} true;
    assume c#0 != 0;
    assume true;
    x##1 := Div(R#0, c#0);
    assume true;
    d##1 := d#0;
    assume true;
    q##0 := LitInt(0);
    assume c#0 != 0;
    assume true;
    r##0 := Div(R#0, c#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivModConverse(x##1, d##1, q##0, r##0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivModConverse(x##1, d##1, q##0, r##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(522,54)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Mod(Div(R#0, c#0), d#0) == Div(R#0, c#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(523,31)"} true;
    assume true;
    x##2 := R#0;
    assume true;
    d##2 := c#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##2, d##2);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##2, d##2);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(525,32)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Mul(c#0, Div(R#0, c#0)) + Mod(R#0, c#0) == R#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(526,35)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Mul(c#0, Mod(Div(R#0, c#0), d#0)) + Mod(R#0, c#0) == R#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(528,41)"} true;
    assume true;
    assume Mul(c#0, d#0) != 0;
    assume true;
    k#0 := Div(x#0, Mul(c#0, d#0));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(530,24)"} true;
    assume true;
    x##3 := x#0;
    assume true;
    d##3 := Mul(c#0, d#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##3, d##3);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##3, d##3);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(531,36)"} true;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume x#0 == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0))) + Mod(x#0, Mul(c#0, d#0));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(532,53)"} true;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume R#0 == x#0 - Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0)));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(533,43)"} true;
    assume true;
    assume R#0 == x#0 - Mul(Mul(c#0, d#0), k#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(534,31)"} true;
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume false;
    goto anon18;

  anon33_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    assume true;
    a##1_12_0 := 0 - k#0;
    assume c#0 != 0;
    assume true;
    b##1_12_0 := Div(x#0, c#0);
    assume true;
    m##1_12_0 := d#0;
    call CallPre$$DivMod.__default.LemmaModMultiplesVanish(a##1_12_0, b##1_12_0, m##1_12_0);
    call CallPost$$DivMod.__default.LemmaModMultiplesVanish(a##1_12_0, b##1_12_0, m##1_12_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(538,45)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(538,74)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0, c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(x#0, c#0) + Mul(0 - k#0, d#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon34_Else:
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    assume true;
    x##1_11_0 := x#0;
    assume true;
    j##1_11_0 := Mul(0 - k#0, d#0);
    assume true;
    d##1_11_0 := c#0;
    call CallPre$$DivMod.__default.LemmaHoistOverDenominator(x##1_11_0, j##1_11_0, d##1_11_0);
    call CallPost$$DivMod.__default.LemmaHoistOverDenominator(x##1_11_0, j##1_11_0, d##1_11_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(540,47)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0, c#0) + Mul(0 - k#0, d#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(x#0 + Mul(Mul(0 - k#0, d#0), c#0), c#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon35_Else:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    assume true;
    x##1_10_0 := 0 - k#0;
    assume true;
    y##1_10_0 := d#0;
    assume true;
    z##1_10_0 := c#0;
    call CallPre$$Mul.__default.LemmaMulIsAssociative(x##1_10_0, y##1_10_0, z##1_10_0);
    call CallPost$$Mul.__default.LemmaMulIsAssociative(x##1_10_0, y##1_10_0, z##1_10_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(542,39)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0 + Mul(Mul(0 - k#0, d#0), c#0), c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(x#0 + Mul(0 - k#0, Mul(d#0, c#0)), c#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon36_Else:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    assume true;
    x##1_9_0 := k#0;
    assume true;
    y##1_9_0 := Mul(d#0, c#0);
    call CallPre$$Mul.__default.LemmaMulUnaryNegation(x##1_9_0, y##1_9_0);
    call CallPost$$Mul.__default.LemmaMulUnaryNegation(x##1_9_0, y##1_9_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(544,39)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0 + Mul(0 - k#0, Mul(d#0, c#0)), c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(x#0 + 0 - Mul(k#0, Mul(d#0, c#0)), c#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon37_Else:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    assume true;
    x##1_8_0 := k#0;
    assume true;
    y##1_8_0 := d#0;
    assume true;
    z##1_8_0 := c#0;
    call CallPre$$Mul.__default.LemmaMulIsAssociative(x##1_8_0, y##1_8_0, z##1_8_0);
    call CallPost$$Mul.__default.LemmaMulIsAssociative(x##1_8_0, y##1_8_0, z##1_8_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(546,38)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0 + 0 - Mul(k#0, Mul(d#0, c#0)), c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(x#0 + 0 - Mul(Mul(k#0, d#0), c#0), c#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon38_Else:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0 + 0 - Mul(Mul(k#0, d#0), c#0), c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(x#0 - Mul(Mul(k#0, d#0), c#0), c#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon39_Else:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(550,35)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(551,35)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(x#0 - Mul(Mul(k#0, d#0), c#0), c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Mod(Div(R#0, c#0), d#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon40_Else:
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mod(Div(R#0, c#0), d#0)) + Mod(x#0, c#0) == Mul(c#0, Div(R#0, c#0)) + Mod(x#0, c#0);
    assume false;
    goto anon18;

  anon41_Else:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    push;
    push;
    assume true;
    x##1_4_0 := R#0;
    assume true;
    d##1_4_0 := c#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##1_4_0, d##1_4_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##1_4_0, d##1_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(555,36)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume R#0 == Mul(c#0, Div(R#0, c#0)) + Mod(R#0, c#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(556,39)"} true;
    assume true;
    x##1_4_1 := x#0;
    assume true;
    a##1_4_0 := c#0;
    assume true;
    b##1_4_0 := d#0;
    call CallPre$$DivMod.__default.LemmaModMod(x##1_4_1, a##1_4_0, b##1_4_0);
    call CallPost$$DivMod.__default.LemmaModMod(x##1_4_1, a##1_4_0, b##1_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(557,28)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Mod(R#0, c#0) == Mod(x#0, c#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(558,29)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(c#0, Div(R#0, c#0)) + Mod(x#0, c#0) == R#0;
    assume false;
    goto anon18;

  anon42_Else:
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume true;
    push;
    push;
    call CallPre$$DivMod.__default.LemmaModIsModRecursiveAuto();
    call CallPost$$DivMod.__default.LemmaModIsModRecursiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(561,36)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} R#0 == Mod(R#0, Mul(c#0, d#0));
    assume false;
    goto anon18;

  anon43_Else:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    push;
    pop;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(R#0, Mul(c#0, d#0)) == Mod(x#0 - Mul(Mul(c#0, d#0), k#0), Mul(c#0, d#0));
    assume false;
    goto anon18;

  anon44_Else:
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    push;
    push;
    assume true;
    x##1_1_0 := Mul(c#0, d#0);
    assume true;
    y##1_1_0 := k#0;
    call CallPre$$Mul.__default.LemmaMulUnaryNegation(x##1_1_0, y##1_1_0);
    call CallPost$$Mul.__default.LemmaMulUnaryNegation(x##1_1_0, y##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(564,39)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0 - Mul(Mul(c#0, d#0), k#0), Mul(c#0, d#0)) == Mod(x#0 + Mul(Mul(c#0, d#0), 0 - k#0), Mul(c#0, d#0));
    assume false;
    goto anon18;

  anon45_Else:
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    push;
    push;
    assume true;
    a##1_0_0 := 0 - k#0;
    assume true;
    b##1_0_0 := x#0;
    assume true;
    m##1_0_0 := Mul(c#0, d#0);
    call CallPre$$DivMod.__default.LemmaModMultiplesVanish(a##1_0_0, b##1_0_0, m##1_0_0);
    call CallPost$$DivMod.__default.LemmaModMultiplesVanish(a##1_0_0, b##1_0_0, m##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(566,45)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0 + Mul(Mul(c#0, d#0), 0 - k#0), Mul(c#0, d#0)) == Mod(x#0, Mul(c#0, d#0));
    assume false;
    goto anon18;

  anon46_Else:
    goto anon18;

  anon18:
    assume Mul(c#0, Mod(Div(x#0, c#0), d#0)) + Mod(x#0, c#0) == Mod(x#0, Mul(c#0, d#0));
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume false;
    goto anon21;

  anon47_Else:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0) - R#0 == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0));
    push;
    push;
    assume true;
    x##2_0_0 := x#0;
    assume true;
    d##2_0_0 := c#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##2_0_0, d##2_0_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##2_0_0, d##2_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(571,36)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0) - R#0 == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0)) ==> x#0 - R#0 == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0));
    assume false;
    goto anon21;

  anon48_Else:
    goto anon21;

  anon21:
    assume Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0) - R#0 == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0)) ==> x#0 - R#0 == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0));
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume true;
    assume false;
    goto anon31;

  anon49_Else:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume true;
    assume true;
    assume c#0 != 0;
    assume true;
    x##3_7_0 := Div(x#0, c#0);
    assume true;
    d##3_7_0 := d#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##3_7_0, d##3_7_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##3_7_0, d##3_7_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(576,40)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Lit(true) ==> Mul(d#0, Div(Div(x#0, c#0), d#0)) == Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0);
    assume false;
    goto anon31;

  anon50_Else:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mul(d#0, Div(Div(x#0, c#0), d#0)) == Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0);
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(d#0, Div(Div(x#0, c#0), d#0)) == Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0) ==> Mul(c#0, Mul(d#0, Div(Div(x#0, c#0), d#0))) == Mul(c#0, Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0));
    assume false;
    goto anon31;

  anon51_Else:
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mul(c#0, Mul(d#0, Div(Div(x#0, c#0), d#0))) == Mul(c#0, Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0));
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(579,35)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(c#0, Mul(d#0, Div(Div(x#0, c#0), d#0))) == Mul(c#0, Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0)) ==> Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(c#0, Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0));
    assume false;
    goto anon31;

  anon52_Else:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(c#0, Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0));
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(581,36)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(c#0, Div(x#0, c#0) - Mod(Div(x#0, c#0), d#0)) ==> Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0));
    assume false;
    goto anon31;

  anon53_Else:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0));
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(c#0, Div(x#0, c#0)) - Mul(c#0, Mod(Div(x#0, c#0), d#0)) ==> Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == x#0 - R#0;
    assume false;
    goto anon31;

  anon54_Else:
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == x#0 - R#0;
    assume true;
    x##3_2_0 := x#0;
    assume true;
    d##3_2_0 := Mul(c#0, d#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##3_2_0, d##3_2_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##3_2_0, d##3_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(584,40)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == x#0 - R#0 ==> Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0))) + Mod(x#0, Mul(c#0, d#0)) - R#0;
    assume false;
    goto anon31;

  anon55_Else:
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0))) + Mod(x#0, Mul(c#0, d#0)) - R#0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0))) + Mod(x#0, Mul(c#0, d#0)) - R#0 ==> Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0)));
    assume false;
    goto anon31;

  anon56_Else:
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0)));
    assume true;
    m##3_0_0 := Mul(c#0, d#0);
    assume c#0 != 0;
    assume d#0 != 0;
    assume true;
    x##3_0_0 := Div(Div(x#0, c#0), d#0);
    assume Mul(c#0, d#0) != 0;
    assume true;
    y##3_0_0 := Div(x#0, Mul(c#0, d#0));
    call CallPre$$Mul.__default.LemmaMulEqualityConverse(m##3_0_0, x##3_0_0, y##3_0_0);
    call CallPost$$Mul.__default.LemmaMulEqualityConverse(m##3_0_0, x##3_0_0, y##3_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(587,65)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(c#0, d#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(c#0, d#0), Div(Div(x#0, c#0), d#0)) == Mul(Mul(c#0, d#0), Div(x#0, Mul(c#0, d#0))) ==> Div(Div(x#0, c#0), d#0) == Div(x#0, Mul(c#0, d#0));
    assume false;
    goto anon31;

  anon57_Else:
    goto anon31;

  anon31:
    assume true ==> Div(Div(x#0, c#0), d#0) == Div(x#0, Mul(c#0, d#0));
    return;
}



procedure {:verboseName "DivMod.LemmaDivDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDenominatorAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivDenominatorAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var c#0: int;
  var d#0: int;
  var x#0: int;
  var c#2: int;
  var d#2: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(592,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(593,12): post-state"} true;
    havoc c#0;
    havoc d#0;
    assume LitInt(0) <= c#0 && LitInt(0) <= d#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume 0 < c#0;
    assume 0 < d#0;
    assume Mul(c#0, d#0) != 0;
    goto anon4;

  anon8_Else:
    assume 0 < c#0 && 0 < d#0 ==> Mul(c#0, d#0) != 0;
    goto anon4;

  anon4:
    assume (forall c#1: int, d#1: int :: { Mul(c#1, d#1) } LitInt(0) <= c#1 && LitInt(0) <= d#1 ==> 0 < c#1 && 0 < d#1 ==> Mul(c#1, d#1) != 0);
    havoc x#0;
    havoc c#2;
    havoc d#2;
    assume LitInt(0) <= c#2 && LitInt(0) <= d#2;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume LitInt(0) <= x#0;
    assume 0 < c#2;
    assume 0 < d#2;
    assume c#2 != 0;
    assume d#2 != 0;
    assume Mul(c#2, d#2) != 0;
    assume Div(Div(x#0, c#2), d#2) == Div(x#0, Mul(c#2, d#2));
    goto anon7;

  anon9_Else:
    assume LitInt(0) <= x#0 && 0 < c#2 && 0 < d#2 ==> Div(Div(x#0, c#2), d#2) == Div(x#0, Mul(c#2, d#2));
    goto anon7;

  anon7:
    assume (forall x#1: int, c#3: int, d#3: int :: { Div(Div(x#1, c#3), d#3) } LitInt(0) <= c#3 && LitInt(0) <= d#3 ==> LitInt(0) <= x#1 && 0 < c#3 && 0 < d#3 ==> Div(Div(x#1, c#3), d#3) == Div(x#1, Mul(c#3, d#3)));
    return;
}



procedure {:verboseName "DivMod.LemmaDivDenominatorAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivDenominatorAuto();



procedure {:verboseName "DivMod.LemmaDivDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDenominatorAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11871"} (forall c#1: int, d#1: int :: { Mul(c#1, d#1) } LitInt(0) <= c#1 && LitInt(0) <= d#1 ==> 0 < c#1 && 0 < d#1 ==> Mul(c#1, d#1) != 0);
  free ensures true;
  free ensures {:id "id11872"} (forall x#1: int, c#3: int, d#3: int :: { Div(Div(x#1, c#3), d#3) } LitInt(0) <= c#3 && LitInt(0) <= d#3 ==> LitInt(0) <= x#1 && 0 < c#3 && 0 < d#3 ==> Div(Div(x#1, c#3), d#3) == Div(x#1, Mul(c#3, d#3)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaDivDenominatorAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11873"} (forall c#1: int, d#1: int :: { Mul(c#1, d#1) } LitInt(0) <= c#1 && LitInt(0) <= d#1 ==> 0 < c#1 && 0 < d#1 ==> Mul(c#1, d#1) != 0);
  free ensures true;
  free ensures {:id "id11874"} (forall x#1: int, c#3: int, d#3: int :: { Div(Div(x#1, c#3), d#3) } LitInt(0) <= c#3 && LitInt(0) <= d#3 ==> LitInt(0) <= x#1 && 0 < c#3 && 0 < d#3 ==> Div(Div(x#1, c#3), d#3) == Div(x#1, Mul(c#3, d#3)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaDivDenominatorAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var c#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var c##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(596,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulNonzeroAuto();
    call CallPost$$Mul.__default.LemmaMulNonzeroAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(597,25)"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, c#0_0, d#0_0;
    assume LitInt(0) <= c#0_0 && LitInt(0) <= d#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon11_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < c#0_0;
    goto anon5;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < c#0_0);
    goto anon5;

  anon5:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < c#0_0 && 0 < d#0_0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} c#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} Mul(c#0_0, d#0_0) != 0;
    assume true;
    assume Div(Div(x#0_0, c#0_0), d#0_0) == Div(x#0_0, Mul(c#0_0, d#0_0));
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    c##0_0 := c#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivDenominator(x##0_0, c##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivDenominator(x##0_0, c##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(601,34)"} true;
    assume Div(Div(x#0_0, c#0_0), d#0_0) == Div(x#0_0, Mul(c#0_0, d#0_0));
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, c#0_1: int, d#0_1: int :: { Div(x#0_1, Mul(c#0_1, d#0_1)) } { Div(Div(x#0_1, c#0_1), d#0_1) } LitInt(0) <= c#0_1 && LitInt(0) <= d#0_1 && LitInt(0) <= x#0_1 && 0 < c#0_1 && 0 < d#0_1 ==> Div(Div(x#0_1, c#0_1), d#0_1) == Div(x#0_1, Mul(c#0_1, d#0_1)));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(602,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulHoistInequality (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulHoistInequality (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulHoistInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(607,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(610,24): post-state"} true;
    assume z#0 != 0;
    assume z#0 != 0;
    assume Mul(x#0, Div(y#0, z#0)) <= Div(Mul(x#0, y#0), z#0);
    return;
}



procedure {:verboseName "DivMod.LemmaMulHoistInequality (call precondtion)"} CallPre$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int);
  requires {:id "id11890"} LitInt(0) <= x#0;
  requires {:id "id11891"} 0 < z#0;



procedure {:verboseName "DivMod.LemmaMulHoistInequality (call postcondition)"} CallPost$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11892"} Mul(x#0, Div(y#0, z#0)) <= Div(Mul(x#0, y#0), z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulHoistInequality (correctness)"} Impl$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id11893"} LitInt(0) <= x#0;
  requires {:id "id11894"} 0 < z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11895"} Mul(x#0, Div(y#0, z#0)) <= Div(Mul(x#0, y#0), z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulHoistInequality (correctness)"} Impl$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0_0_0: int;
  var d##0_0_0: int;
  var x##0_2_0: int;
  var y##0_2_0: int;
  var x##0_2_1: int;
  var y##0_2_1: int;
  var z##0_2_0: int;
  var x##0_4_0: int;
  var d##0_4_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulHoistInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(611,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume false;
    goto anon7;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume true;
    x##0_4_0 := y#0;
    assume true;
    d##0_4_0 := z#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_4_0, d##0_4_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_4_0, d##0_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(614,38)"} true;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Mul(x#0, y#0), z#0) == Div(Mul(x#0, Mul(z#0, Div(y#0, z#0)) + Mod(y#0, z#0)), z#0);
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(616,38)"} true;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Mul(x#0, Mul(z#0, Div(y#0, z#0)) + Mod(y#0, z#0)), z#0) == Div(Mul(x#0, Mul(z#0, Div(y#0, z#0))) + Mul(x#0, Mod(y#0, z#0)), z#0);
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(619,34)"} true;
    assume true;
    x##0_2_0 := x#0;
    assume z#0 != 0;
    assume true;
    y##0_2_0 := Mod(y#0, z#0);
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##0_2_0, y##0_2_0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##0_2_0, y##0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(620,39)"} true;
    assume z#0 != 0;
    assume true;
    x##0_2_1 := Mul(x#0, Mul(z#0, Div(y#0, z#0)));
    assume z#0 != 0;
    assume z#0 != 0;
    assume true;
    y##0_2_1 := Mul(x#0, Mul(z#0, Div(y#0, z#0))) + Mul(x#0, Mod(y#0, z#0));
    assume true;
    z##0_2_0 := z#0;
    call CallPre$$DivMod.__default.LemmaDivIsOrdered(x##0_2_1, y##0_2_1, z##0_2_0);
    call CallPost$$DivMod.__default.LemmaDivIsOrdered(x##0_2_1, y##0_2_1, z##0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(621,82)"} true;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Mul(x#0, Mul(z#0, Div(y#0, z#0))) + Mul(x#0, Mod(y#0, z#0)), z#0) >= Div(Mul(x#0, Mul(z#0, Div(y#0, z#0))), z#0);
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(623,37)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(624,37)"} true;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Mul(x#0, Mul(z#0, Div(y#0, z#0))), z#0) == Div(Mul(z#0, Mul(x#0, Div(y#0, z#0))), z#0);
    assume false;
    goto anon7;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume z#0 != 0;
    assume true;
    x##0_0_0 := Mul(x#0, Div(y#0, z#0));
    assume true;
    d##0_0_0 := z#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##0_0_0, d##0_0_0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##0_0_0, d##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(626,49)"} true;
    assume {:subsumption 0} z#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Mul(z#0, Mul(x#0, Div(y#0, z#0))), z#0) == Mul(x#0, Div(y#0, z#0));
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    assume Div(Mul(x#0, y#0), z#0) >= Mul(x#0, Div(y#0, z#0));
    return;
}



procedure {:verboseName "DivMod.LemmaMulHoistInequalityAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulHoistInequalityAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulHoistInequalityAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulHoistInequalityAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var z#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulHoistInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(631,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(632,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc z#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < z#0;
    assume z#0 != 0;
    assume z#0 != 0;
    assume Mul(x#0, Div(y#0, z#0)) <= Div(Mul(x#0, y#0), z#0);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < z#0 ==> Mul(x#0, Div(y#0, z#0)) <= Div(Mul(x#0, y#0), z#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, Div(y#1, z#1)), Div(Mul(x#1, y#1), z#1) } LitInt(0) <= x#1 && 0 < z#1 ==> Mul(x#1, Div(y#1, z#1)) <= Div(Mul(x#1, y#1), z#1));
    return;
}



procedure {:verboseName "DivMod.LemmaMulHoistInequalityAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMulHoistInequalityAuto();



procedure {:verboseName "DivMod.LemmaMulHoistInequalityAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulHoistInequalityAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11953"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, Div(y#1, z#1)), Div(Mul(x#1, y#1), z#1) } LitInt(0) <= x#1 && 0 < z#1 ==> Mul(x#1, Div(y#1, z#1)) <= Div(Mul(x#1, y#1), z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulHoistInequalityAuto (correctness)"} Impl$$DivMod.__default.LemmaMulHoistInequalityAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11954"} (forall x#1: int, y#1: int, z#1: int :: { Mul(x#1, Div(y#1, z#1)), Div(Mul(x#1, y#1), z#1) } LitInt(0) <= x#1 && 0 < z#1 ==> Mul(x#1, Div(y#1, z#1)) <= Div(Mul(x#1, y#1), z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulHoistInequalityAuto (correctness)"} Impl$$DivMod.__default.LemmaMulHoistInequalityAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulHoistInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(634,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < z#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} z#0_0 != 0;
    assume {:subsumption 0} z#0_0 != 0;
    assume true;
    assume Mul(x#0_0, Div(y#0_0, z#0_0)) <= Div(Mul(x#0_0, y#0_0), z#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaMulHoistInequality(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaMulHoistInequality(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(638,38)"} true;
    assume Mul(x#0_0, Div(y#0_0, z#0_0)) <= Div(Mul(x#0_0, y#0_0), z#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Div(Mul(x#0_1, y#0_1), z#0_1) } { Mul(x#0_1, Div(y#0_1, z#0_1)) } LitInt(0) <= x#0_1 && 0 < z#0_1 ==> Mul(x#0_1, Div(y#0_1, z#0_1)) <= Div(Mul(x#0_1, y#0_1), z#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(639,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotients (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaIndistinguishableQuotients (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaIndistinguishableQuotients", " | ", a#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(642,8): initial state"} true;
    assume 0 < d#0;
    assume d#0 != 0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} LitInt(0) <= a#0 - Mod(a#0, d#0);
    assume d#0 != 0;
    goto anon3;

  anon6_Else:
    assume {:partition} a#0 - Mod(a#0, d#0) < LitInt(0);
    goto anon3;

  anon3:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0;
    assume d#0 != 0;
    goto anon5;

  anon7_Else:
    assume {:partition} !(LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0);
    goto anon5;

  anon5:
    assume LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0 && b#0 < a#0 + d#0 - Mod(a#0, d#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(645,18): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Div(a#0, d#0) == Div(b#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotients (call precondtion)"} CallPre$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int);
  requires {:id "id11970"} 0 < d#0;
  requires {:id "id11971"} LitInt(0) <= a#0 - Mod(a#0, d#0);
  requires {:id "id11972"} a#0 - Mod(a#0, d#0) <= b#0;
  requires {:id "id11973"} b#0 < a#0 + d#0 - Mod(a#0, d#0);



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotients (call postcondition)"} CallPost$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11974"} Div(a#0, d#0) == Div(b#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotients (correctness)"} Impl$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id11975"} 0 < d#0;
  requires {:id "id11976"} LitInt(0) <= a#0 - Mod(a#0, d#0);
  requires {:id "id11977"} a#0 - Mod(a#0, d#0) <= b#0;
  requires {:id "id11978"} b#0 < a#0 + d#0 - Mod(a#0, d#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id11979"} Div(a#0, d#0) == Div(b#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaIndistinguishableQuotients (correctness)"} Impl$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var ab#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var u#Z#0: int;
  var let#0#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaIndistinguishableQuotients", " | ", a#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(646,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := a#0 - b#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc ab#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    havoc u#Z#0;
    assume true;
    assume let#0#0#0 == ab#0 + b#0;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume u#Z#0 == let#0#0#0;
    assume d#0 != 0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= u#Z#0 - Mod(u#Z#0, d#0);
    assume d#0 != 0;
    goto anon4;

  anon13_Else:
    assume {:partition} u#Z#0 - Mod(u#Z#0, d#0) < LitInt(0);
    goto anon4;

  anon4:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= u#Z#0 - Mod(u#Z#0, d#0) && u#Z#0 - Mod(u#Z#0, d#0) <= b#0;
    assume d#0 != 0;
    goto anon6;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= u#Z#0 - Mod(u#Z#0, d#0) && u#Z#0 - Mod(u#Z#0, d#0) <= b#0);
    goto anon6;

  anon6:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= u#Z#0 - Mod(u#Z#0, d#0) && u#Z#0 - Mod(u#Z#0, d#0) <= b#0 && b#0 < u#Z#0 + d#0 - Mod(u#Z#0, d#0);
    assume d#0 != 0;
    assume d#0 != 0;
    goto anon8;

  anon15_Else:
    assume {:partition} !(LitInt(0) <= u#Z#0 - Mod(u#Z#0, d#0) && u#Z#0 - Mod(u#Z#0, d#0) <= b#0 && b#0 < u#Z#0 + d#0 - Mod(u#Z#0, d#0));
    goto anon8;

  anon8:
    assume lambdaResult#0 <==> LitInt(0) <= u#Z#0 - Mod(u#Z#0, d#0) && u#Z#0 - Mod(u#Z#0, d#0) <= b#0 && b#0 < u#Z#0 + d#0 - Mod(u#Z#0, d#0) ==> Div(u#Z#0, d#0) == Div(b#0, d#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon9;

  anon12_Else:
    assume {:partition} false;
    goto anon9;

  anon9:
    assume false;
    goto anon10;

  anon11_Else:
    goto anon10;

  anon10:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#ab#0: Box :: $Box((var u#1 := $Unbox($l#1#ab#0): int + b#0; LitInt(0) <= u#1 - Mod(u#1, d#0) && u#1 - Mod(u#1, d#0) <= b#0 && b#0 < u#1 + d#0 - Mod(u#1, d#0) ==> Div(u#1, d#0) == Div(b#0, d#0)))), (lambda $l#1#heap#0: Heap, $l#1#ab#0: Box :: $IsBox($l#1#ab#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#ab#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(647,114)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaIndistinguishableQuotientsAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaIndistinguishableQuotientsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaIndistinguishableQuotientsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(650,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(651,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc d#0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= a#0 - Mod(a#0, d#0);
    assume d#0 != 0;
    goto anon4;

  anon10_Else:
    assume {:partition} a#0 - Mod(a#0, d#0) < LitInt(0);
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0;
    assume d#0 != 0;
    goto anon6;

  anon11_Else:
    assume {:partition} !(LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0);
    goto anon6;

  anon6:
    assume LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0 && b#0 < a#0 + d#0 - Mod(a#0, d#0);
    assume d#0 != 0;
    assume d#0 != 0;
    assume Div(a#0, d#0) == Div(b#0, d#0);
    goto anon8;

  anon9_Else:
    assume 0 < d#0 && LitInt(0) <= a#0 - Mod(a#0, d#0) && a#0 - Mod(a#0, d#0) <= b#0 && b#0 < a#0 + d#0 - Mod(a#0, d#0) ==> Div(a#0, d#0) == Div(b#0, d#0);
    goto anon8;

  anon8:
    assume (forall a#1: int, b#1: int, d#1: int :: { Div(a#1, d#1), Div(b#1, d#1) } 0 < d#1 && LitInt(0) <= a#1 - Mod(a#1, d#1) && a#1 - Mod(a#1, d#1) <= b#1 && b#1 < a#1 + d#1 - Mod(a#1, d#1) ==> Div(a#1, d#1) == Div(b#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaIndistinguishableQuotientsAuto();



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaIndistinguishableQuotientsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12000"} (forall a#1: int, b#1: int, d#1: int :: { Div(a#1, d#1), Div(b#1, d#1) } 0 < d#1 && LitInt(0) <= a#1 - Mod(a#1, d#1) && a#1 - Mod(a#1, d#1) <= b#1 && b#1 < a#1 + d#1 - Mod(a#1, d#1) ==> Div(a#1, d#1) == Div(b#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (correctness)"} Impl$$DivMod.__default.LemmaIndistinguishableQuotientsAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12001"} (forall a#1: int, b#1: int, d#1: int :: { Div(a#1, d#1), Div(b#1, d#1) } 0 < d#1 && LitInt(0) <= a#1 - Mod(a#1, d#1) && a#1 - Mod(a#1, d#1) <= b#1 && b#1 < a#1 + d#1 - Mod(a#1, d#1) ==> Div(a#1, d#1) == Div(b#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (correctness)"} Impl$$DivMod.__default.LemmaIndistinguishableQuotientsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var d#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaIndistinguishableQuotientsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(653,2): initial state"} true;
    $_reverifyPost := false;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc a#0_0, b#0_0, d#0_0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} 0 < d#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= a#0_0 - Mod(a#0_0, d#0_0);
    assume {:subsumption 0} d#0_0 != 0;
    goto anon4;

  anon13_Else:
    assume {:partition} a#0_0 - Mod(a#0_0, d#0_0) < LitInt(0);
    goto anon4;

  anon4:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= a#0_0 - Mod(a#0_0, d#0_0) && a#0_0 - Mod(a#0_0, d#0_0) <= b#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon6;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= a#0_0 - Mod(a#0_0, d#0_0) && a#0_0 - Mod(a#0_0, d#0_0) <= b#0_0);
    goto anon6;

  anon12_Else:
    assume {:partition} d#0_0 <= 0;
    goto anon6;

  anon6:
    assume true;
    assume 0 < d#0_0 && LitInt(0) <= a#0_0 - Mod(a#0_0, d#0_0) && a#0_0 - Mod(a#0_0, d#0_0) <= b#0_0 && b#0_0 < a#0_0 + d#0_0 - Mod(a#0_0, d#0_0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(a#0_0, d#0_0) == Div(b#0_0, d#0_0);
    assume false;
    goto anon8;

  anon15_Else:
    goto anon8;

  anon8:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaIndistinguishableQuotients(a##0_0, b##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaIndistinguishableQuotients(a##0_0, b##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(657,46)"} true;
    assume Div(a#0_0, d#0_0) == Div(b#0_0, d#0_0);
    assume false;
    goto anon10;

  anon11_Else:
    assume (forall a#0_1: int, b#0_1: int, d#0_1: int :: { Div(b#0_1, d#0_1), Div(a#0_1, d#0_1) } { Div(b#0_1, d#0_1), Mod(a#0_1, d#0_1) } 0 < d#0_1 && LitInt(0) <= a#0_1 - Mod(a#0_1, d#0_1) && a#0_1 - Mod(a#0_1, d#0_1) <= b#0_1 && b#0_1 < a#0_1 + d#0_1 - Mod(a#0_1, d#0_1) ==> Div(a#0_1, d#0_1) == Div(b#0_1, d#0_1));
    goto anon10;

  anon10:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(658,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaTruncateMiddle (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaTruncateMiddle (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaTruncateMiddle", " | ", x#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(662,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < b#0;
    assume 0 < c#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(666,14): post-state"} true;
    assume 0 < Mul(b#0, c#0);
    assume Mul(b#0, c#0) != 0;
    assume c#0 != 0;
    assume Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(b#0, Mod(x#0, c#0));
    return;
}



procedure {:verboseName "DivMod.LemmaTruncateMiddle (call precondtion)"} CallPre$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int);
  requires {:id "id12019"} LitInt(0) <= x#0;
  requires {:id "id12020"} 0 < b#0;
  requires {:id "id12021"} 0 < c#0;



procedure {:verboseName "DivMod.LemmaTruncateMiddle (call postcondition)"} CallPost$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12022"} 0 < Mul(b#0, c#0);
  free ensures true;
  free ensures {:id "id12023"} Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(b#0, Mod(x#0, c#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaTruncateMiddle (correctness)"} Impl$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id12024"} LitInt(0) <= x#0;
  requires {:id "id12025"} 0 < b#0;
  requires {:id "id12026"} 0 < c#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12027"} 0 < Mul(b#0, c#0);
  free ensures true;
  free ensures {:id "id12028"} Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(b#0, Mod(x#0, c#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaTruncateMiddle (correctness)"} Impl$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b##0_0_0: int;
  var d##0_0_0: int;
  var x##0_1_0: int;
  var c##0_1_0: int;
  var d##0_1_0: int;
  var x##0_2_0: int;
  var d##0_2_0: int;
  var x##1_3_0: int;
  var d##1_3_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaTruncateMiddle", " | ", x#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(668,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(669,34)"} true;
    call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(670,29)"} true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume true;
    assume false;
    goto anon5;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume true;
    push;
    push;
    assume true;
    x##0_2_0 := Mul(b#0, x#0);
    assume true;
    d##0_2_0 := Mul(b#0, c#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_2_0, d##0_2_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_2_0, d##0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(673,44)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, x#0) == Mul(Mul(b#0, c#0), Div(Mul(b#0, x#0), Mul(b#0, c#0))) + Mod(Mul(b#0, x#0), Mul(b#0, c#0));
    assume false;
    goto anon5;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    push;
    push;
    assume true;
    x##0_1_0 := Mul(b#0, x#0);
    assume true;
    assume $Is(b#0, Tclass._System.nat());
    c##0_1_0 := b#0;
    assume true;
    assume $Is(c#0, Tclass._System.nat());
    d##0_1_0 := c#0;
    call CallPre$$DivMod.__default.LemmaDivDenominator(x##0_1_0, c##0_1_0, d##0_1_0);
    call CallPost$$DivMod.__default.LemmaDivDenominator(x##0_1_0, c##0_1_0, d##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(675,40)"} true;
    pop;
    pop;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(b#0, c#0), Div(Mul(b#0, x#0), Mul(b#0, c#0))) + Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(Mul(b#0, c#0), Div(Div(Mul(b#0, x#0), b#0), c#0)) + Mod(Mul(b#0, x#0), Mul(b#0, c#0));
    assume false;
    goto anon5;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(677,35)"} true;
    assume true;
    b##0_0_0 := x#0;
    assume true;
    d##0_0_0 := b#0;
    call CallPre$$DivMod.__default.LemmaDivByMultiple(b##0_0_0, d##0_0_0);
    call CallPost$$DivMod.__default.LemmaDivByMultiple(b##0_0_0, d##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(677,61)"} true;
    pop;
    pop;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(b#0, c#0), Div(Div(Mul(b#0, x#0), b#0), c#0)) + Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(Mul(b#0, c#0), Div(x#0, c#0)) + Mod(Mul(b#0, x#0), Mul(b#0, c#0));
    assume false;
    goto anon5;

  anon15_Else:
    goto anon5;

  anon5:
    assume Mul(b#0, x#0) == Mul(Mul(b#0, c#0), Div(x#0, c#0)) + Mod(Mul(b#0, x#0), Mul(b#0, c#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    assume false;
    goto anon11;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume true;
    assume true;
    assume true;
    x##1_3_0 := x#0;
    assume true;
    d##1_3_0 := c#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##1_3_0, d##1_3_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##1_3_0, d##1_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(682,36)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Lit(true) ==> x#0 == Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0);
    assume false;
    goto anon11;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume x#0 == Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0);
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} x#0 == Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0) ==> Mul(b#0, x#0) == Mul(b#0, Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0));
    assume false;
    goto anon11;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Mul(b#0, x#0) == Mul(b#0, Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0));
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(685,36)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, x#0) == Mul(b#0, Mul(c#0, Div(x#0, c#0)) + Mod(x#0, c#0)) ==> Mul(b#0, x#0) == Mul(b#0, Mul(c#0, Div(x#0, c#0))) + Mul(b#0, Mod(x#0, c#0));
    assume false;
    goto anon11;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume Mul(b#0, x#0) == Mul(b#0, Mul(c#0, Div(x#0, c#0))) + Mul(b#0, Mod(x#0, c#0));
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(687,35)"} true;
    assume {:subsumption 0} c#0 != 0;
    assume {:subsumption 0} c#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, x#0) == Mul(b#0, Mul(c#0, Div(x#0, c#0))) + Mul(b#0, Mod(x#0, c#0)) ==> Mul(b#0, x#0) == Mul(Mul(b#0, c#0), Div(x#0, c#0)) + Mul(b#0, Mod(x#0, c#0));
    assume false;
    goto anon11;

  anon20_Else:
    goto anon11;

  anon11:
    assume true ==> Mul(b#0, x#0) == Mul(Mul(b#0, c#0), Div(x#0, c#0)) + Mul(b#0, Mod(x#0, c#0));
    return;
}



procedure {:verboseName "DivMod.LemmaTruncateMiddleAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaTruncateMiddleAuto();
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaTruncateMiddleAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaTruncateMiddleAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var b#0: int;
  var c#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaTruncateMiddleAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(692,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(693,12): post-state"} true;
    havoc x#0;
    havoc b#0;
    havoc c#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < b#0;
    assume 0 < c#0;
    assume 0 < Mul(b#0, c#0);
    assume Mul(b#0, c#0) != 0;
    assume c#0 != 0;
    assume Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(b#0, Mod(x#0, c#0));
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < b#0 && 0 < c#0 && 0 < Mul(b#0, c#0) ==> Mod(Mul(b#0, x#0), Mul(b#0, c#0)) == Mul(b#0, Mod(x#0, c#0));
    goto anon4;

  anon4:
    assume (forall x#1: int, b#1: int, c#1: int :: { Mul(b#1, Mod(x#1, c#1)) } LitInt(0) <= x#1 && 0 < b#1 && 0 < c#1 && 0 < Mul(b#1, c#1) ==> Mod(Mul(b#1, x#1), Mul(b#1, c#1)) == Mul(b#1, Mod(x#1, c#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaTruncateMiddleAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaTruncateMiddleAuto();



procedure {:verboseName "DivMod.LemmaTruncateMiddleAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaTruncateMiddleAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12097"} (forall x#1: int, b#1: int, c#1: int :: { Mul(b#1, Mod(x#1, c#1)) } LitInt(0) <= x#1 && 0 < b#1 && 0 < c#1 && 0 < Mul(b#1, c#1) ==> Mod(Mul(b#1, x#1), Mul(b#1, c#1)) == Mul(b#1, Mod(x#1, c#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaTruncateMiddleAuto (correctness)"} Impl$$DivMod.__default.LemmaTruncateMiddleAuto() returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12098"} (forall x#1: int, b#1: int, c#1: int :: { Mul(b#1, Mod(x#1, c#1)) } LitInt(0) <= x#1 && 0 < b#1 && 0 < c#1 && 0 < Mul(b#1, c#1) ==> Mod(Mul(b#1, x#1), Mul(b#1, c#1)) == Mul(b#1, Mod(x#1, c#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaTruncateMiddleAuto (correctness)"} Impl$$DivMod.__default.LemmaTruncateMiddleAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var b#0_0: int;
  var c#0_0: int;
  var x##0_0: int;
  var b##0_0: int;
  var c##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaTruncateMiddleAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(695,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, b#0_0, c#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < b#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < b#0_0);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < b#0_0 && 0 < c#0_0;
    goto anon7;

  anon15_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < b#0_0 && 0 < c#0_0);
    goto anon7;

  anon7:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < b#0_0 && 0 < c#0_0 && 0 < Mul(b#0_0, c#0_0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} Mul(b#0_0, c#0_0) != 0;
    assume {:subsumption 0} c#0_0 != 0;
    assume true;
    assume Mod(Mul(b#0_0, x#0_0), Mul(b#0_0, c#0_0)) == Mul(b#0_0, Mod(x#0_0, c#0_0));
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    c##0_0 := c#0_0;
    call CallPre$$DivMod.__default.LemmaTruncateMiddle(x##0_0, b##0_0, c##0_0);
    call CallPost$$DivMod.__default.LemmaTruncateMiddle(x##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(699,34)"} true;
    assume Mod(Mul(b#0_0, x#0_0), Mul(b#0_0, c#0_0)) == Mul(b#0_0, Mod(x#0_0, c#0_0));
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, b#0_1: int, c#0_1: int :: { Mul(b#0_1, Mod(x#0_1, c#0_1)) } { Mod(Mul(b#0_1, x#0_1), Mul(b#0_1, c#0_1)) } LitInt(0) <= x#0_1 && 0 < b#0_1 && 0 < c#0_1 && 0 < Mul(b#0_1, c#0_1) ==> Mod(Mul(b#0_1, x#0_1), Mul(b#0_1, c#0_1)) == Mul(b#0_1, Mod(x#0_1, c#0_1)));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(700,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishQuotient", " | ", x#0, " | ", a#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(704,8): initial state"} true;
    assume 0 < x#0;
    assume LitInt(0) <= a#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(708,14): post-state"} true;
    assume 0 < Mul(x#0, d#0);
    assume d#0 != 0;
    assume Mul(x#0, d#0) != 0;
    assume Div(a#0, d#0) == Div(Mul(x#0, a#0), Mul(x#0, d#0));
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int);
  requires {:id "id12113"} 0 < x#0;
  requires {:id "id12114"} LitInt(0) <= a#0;
  requires {:id "id12115"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12116"} 0 < Mul(x#0, d#0);
  free ensures true;
  free ensures {:id "id12117"} Div(a#0, d#0) == Div(Mul(x#0, a#0), Mul(x#0, d#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id12118"} 0 < x#0;
  requires {:id "id12119"} LitInt(0) <= a#0;
  requires {:id "id12120"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12121"} 0 < Mul(x#0, d#0);
  free ensures true;
  free ensures {:id "id12122"} Div(a#0, d#0) == Div(Mul(x#0, a#0), Mul(x#0, d#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var x##0_0_0: int;
  var d##0_0_0: int;
  var x##0_1_0: int;
  var y##0_1_0: int;
  var x##0_1_1: int;
  var c##0_1_0: int;
  var d##0_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishQuotient", " | ", x#0, " | ", a#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(710,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := d#0;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositive(x##0, y##0);
    call CallPost$$Mul.__default.LemmaMulStrictlyPositive(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(711,33)"} true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:subsumption 0} Mul(x#0, d#0) != 0;
    assume true;
    assume false;
    goto anon4;

  anon5_Else:
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:subsumption 0} Mul(x#0, d#0) != 0;
    assume true;
    assume true;
    x##0_1_0 := x#0;
    assume true;
    y##0_1_0 := a#0;
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##0_1_0, y##0_1_0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##0_1_0, y##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(715,33)"} true;
    assume true;
    x##0_1_1 := Mul(x#0, a#0);
    assume true;
    assume $Is(x#0, Tclass._System.nat());
    c##0_1_0 := x#0;
    assume true;
    assume $Is(d#0, Tclass._System.nat());
    d##0_1_0 := d#0;
    call CallPre$$DivMod.__default.LemmaDivDenominator(x##0_1_1, c##0_1_0, d##0_1_0);
    call CallPost$$DivMod.__default.LemmaDivDenominator(x##0_1_1, c##0_1_0, d##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(716,40)"} true;
    assume {:subsumption 0} x#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Mul(x#0, a#0), Mul(x#0, d#0)) == Div(Div(Mul(x#0, a#0), x#0), d#0);
    assume false;
    goto anon4;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} x#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume true;
    x##0_0_0 := a#0;
    assume true;
    d##0_0_0 := x#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##0_0_0, d##0_0_0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##0_0_0, d##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(718,37)"} true;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Div(Div(Mul(x#0, a#0), x#0), d#0) == Div(a#0, d#0);
    assume false;
    goto anon4;

  anon7_Else:
    goto anon4;

  anon4:
    assume Div(Mul(x#0, a#0), Mul(x#0, d#0)) == Div(a#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto();
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var a#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishQuotientAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(723,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(724,12): post-state"} true;
    havoc x#0;
    havoc a#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < x#0;
    assume LitInt(0) <= a#0;
    assume 0 < d#0;
    assume 0 < Mul(x#0, d#0);
    assume d#0 != 0;
    assume Mul(x#0, d#0) != 0;
    assume Div(a#0, d#0) == Div(Mul(x#0, a#0), Mul(x#0, d#0));
    goto anon4;

  anon5_Else:
    assume 0 < x#0 && LitInt(0) <= a#0 && 0 < d#0 ==> 0 < Mul(x#0, d#0) && Div(a#0, d#0) == Div(Mul(x#0, a#0), Mul(x#0, d#0));
    goto anon4;

  anon4:
    assume (forall x#1: int, a#1: int, d#1: int :: { Div(a#1, d#1), Mul(x#1, d#1), Mul(x#1, a#1) } 0 < x#1 && LitInt(0) <= a#1 && 0 < d#1 ==> 0 < Mul(x#1, d#1)) && (forall x#1: int, a#1: int, d#1: int :: { Div(a#1, d#1), Mul(x#1, d#1), Mul(x#1, a#1) } 0 < x#1 && LitInt(0) <= a#1 && 0 < d#1 ==> Div(a#1, d#1) == Div(Mul(x#1, a#1), Mul(x#1, d#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto();



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12152"} (forall x#1: int, a#1: int, d#1: int :: { Div(a#1, d#1), Mul(x#1, d#1), Mul(x#1, a#1) } 0 < x#1 && LitInt(0) <= a#1 && 0 < d#1 ==> 0 < Mul(x#1, d#1));
  free ensures {:id "id12153"} (forall x#1: int, a#1: int, d#1: int :: { Div(a#1, d#1), Mul(x#1, d#1), Mul(x#1, a#1) } 0 < x#1 && LitInt(0) <= a#1 && 0 < d#1 ==> Div(a#1, d#1) == Div(Mul(x#1, a#1), Mul(x#1, d#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto() returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12154"} (forall x#1: int, a#1: int, d#1: int :: { Div(a#1, d#1), Mul(x#1, d#1), Mul(x#1, a#1) } 0 < x#1 && LitInt(0) <= a#1 && 0 < d#1 ==> 0 < Mul(x#1, d#1));
  free ensures {:id "id12155"} (forall x#1: int, a#1: int, d#1: int :: { Div(a#1, d#1), Mul(x#1, d#1), Mul(x#1, a#1) } 0 < x#1 && LitInt(0) <= a#1 && 0 < d#1 ==> Div(a#1, d#1) == Div(Mul(x#1, a#1), Mul(x#1, d#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var a#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var a##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishQuotientAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(726,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, a#0_0, d#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} 0 < x#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} x#0_0 <= 0;
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} 0 < x#0_0 && LitInt(0) <= a#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(0 < x#0_0 && LitInt(0) <= a#0_0);
    goto anon5;

  anon5:
    assume true;
    assume 0 < x#0_0 && LitInt(0) <= a#0_0 && 0 < d#0_0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} 0 < Mul(x#0_0, d#0_0);
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} Mul(x#0_0, d#0_0) != 0;
    goto anon8;

  anon16_Else:
    assume {:partition} Mul(x#0_0, d#0_0) <= 0;
    goto anon8;

  anon8:
    assume true;
    assume 0 < Mul(x#0_0, d#0_0) && Div(a#0_0, d#0_0) == Div(Mul(x#0_0, a#0_0), Mul(x#0_0, d#0_0));
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    a##0_0 := a#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x##0_0, a##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x##0_0, a##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(730,46)"} true;
    assume 0 < Mul(x#0_0, d#0_0);
    assume Div(a#0_0, d#0_0) == Div(Mul(x#0_0, a#0_0), Mul(x#0_0, d#0_0));
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, a#0_1: int, d#0_1: int :: 0 < x#0_1 && LitInt(0) <= a#0_1 && 0 < d#0_1 ==> 0 < Mul(x#0_1, d#0_1)) && (forall x#0_2: int, a#0_2: int, d#0_2: int :: { Mul(x#0_2, d#0_2), Mul(x#0_2, a#0_2) } 0 < x#0_2 && LitInt(0) <= a#0_2 && 0 < d#0_2 ==> Div(a#0_2, d#0_2) == Div(Mul(x#0_2, a#0_2), Mul(x#0_2, d#0_2)));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(731,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRoundDown (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRoundDown (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRoundDown", " | ", a#0, " | ", r#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(736,8): initial state"} true;
    assume 0 < d#0;
    assume d#0 != 0;
    assume Mod(a#0, d#0) == LitInt(0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= r#0;
    goto anon3;

  anon4_Else:
    assume {:partition} r#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= r#0 && r#0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(740,14): post-state"} true;
    assume d#0 != 0;
    assume a#0 == Mul(d#0, Div(a#0 + r#0, d#0));
    return;
}



procedure {:verboseName "DivMod.LemmaRoundDown (call precondtion)"} CallPre$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int);
  requires {:id "id12170"} 0 < d#0;
  requires {:id "id12171"} Mod(a#0, d#0) == LitInt(0);
  requires {:id "id12172"} LitInt(0) <= r#0;
  requires {:id "id12173"} r#0 < d#0;



procedure {:verboseName "DivMod.LemmaRoundDown (call postcondition)"} CallPost$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12174"} a#0 == Mul(d#0, Div(a#0 + r#0, d#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRoundDown (correctness)"} Impl$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12175"} 0 < d#0;
  requires {:id "id12176"} Mod(a#0, d#0) == LitInt(0);
  requires {:id "id12177"} LitInt(0) <= r#0;
  requires {:id "id12178"} r#0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12179"} a#0 == Mul(d#0, Div(a#0 + r#0, d#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRoundDown (correctness)"} Impl$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRoundDown", " | ", a#0, " | ", r#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(741,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(742,18)"} true;
    assume true;
    n##0 := d#0;
    assume true;
    x##0 := a#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Mod(u#0, d#0) == LitInt(0);
    assume d#0 != 0;
    goto anon4;

  anon9_Else:
    assume {:partition} Mod(u#0, d#0) != LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> Mod(u#0, d#0) == LitInt(0) ==> u#0 == Mul(d#0, Div(u#0 + r#0, d#0));
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mod($Unbox($l#1#u#0): int, d#0) == LitInt(0) ==> $Unbox($l#1#u#0): int == Mul(d#0, Div($Unbox($l#1#u#0): int + r#0, d#0)))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(743,75)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaRoundDownAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRoundDownAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRoundDownAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaRoundDownAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0: int;
  var r#0: int;
  var a#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRoundDownAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(746,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(747,12): post-state"} true;
    havoc d#0;
    havoc r#0;
    havoc a#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume Mod(a#0, d#0) == LitInt(0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= r#0;
    goto anon4;

  anon8_Else:
    assume {:partition} r#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= r#0 && r#0 < d#0;
    assume d#0 != 0;
    assume a#0 == Mul(d#0, Div(a#0 + r#0, d#0));
    goto anon6;

  anon7_Else:
    assume 0 < d#0 && Mod(a#0, d#0) == LitInt(0) && LitInt(0) <= r#0 && r#0 < d#0 ==> a#0 == Mul(d#0, Div(a#0 + r#0, d#0));
    goto anon6;

  anon6:
    assume (forall d#1: int, r#1: int, a#1: int :: { Mul(d#1, Div(a#1 + r#1, d#1)) } 0 < d#1 && Mod(a#1, d#1) == LitInt(0) && LitInt(0) <= r#1 && r#1 < d#1 ==> a#1 == Mul(d#1, Div(a#1 + r#1, d#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaRoundDownAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaRoundDownAuto();



procedure {:verboseName "DivMod.LemmaRoundDownAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRoundDownAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12195"} (forall d#1: int, r#1: int, a#1: int :: { Mul(d#1, Div(a#1 + r#1, d#1)) } 0 < d#1 && Mod(a#1, d#1) == LitInt(0) && LitInt(0) <= r#1 && r#1 < d#1 ==> a#1 == Mul(d#1, Div(a#1 + r#1, d#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaRoundDownAuto (correctness)"} Impl$$DivMod.__default.LemmaRoundDownAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12196"} (forall d#1: int, r#1: int, a#1: int :: { Mul(d#1, Div(a#1 + r#1, d#1)) } 0 < d#1 && Mod(a#1, d#1) == LitInt(0) && LitInt(0) <= r#1 && r#1 < d#1 ==> a#1 == Mul(d#1, Div(a#1 + r#1, d#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaRoundDownAuto (correctness)"} Impl$$DivMod.__default.LemmaRoundDownAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var r#0_0: int;
  var d#0_0: int;
  var a##0_0: int;
  var r##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaRoundDownAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(749,2): initial state"} true;
    $_reverifyPost := false;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc a#0_0, r#0_0, d#0_0;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} 0 < d#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon3;

  anon12_Else:
    assume {:partition} d#0_0 <= 0;
    goto anon3;

  anon3:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} 0 < d#0_0 && Mod(a#0_0, d#0_0) == LitInt(0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= r#0_0;
    goto anon6;

  anon14_Else:
    assume {:partition} r#0_0 < LitInt(0);
    goto anon6;

  anon13_Else:
    assume {:partition} !(0 < d#0_0 && Mod(a#0_0, d#0_0) == LitInt(0));
    goto anon6;

  anon6:
    assume true;
    assume 0 < d#0_0 && Mod(a#0_0, d#0_0) == LitInt(0) && LitInt(0) <= r#0_0 && r#0_0 < d#0_0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume a#0_0 == Mul(d#0_0, Div(a#0_0 + r#0_0, d#0_0));
    assume false;
    goto anon8;

  anon15_Else:
    goto anon8;

  anon8:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    r##0_0 := r#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaRoundDown(a##0_0, r##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaRoundDown(a##0_0, r##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(753,29)"} true;
    assume a#0_0 == Mul(d#0_0, Div(a#0_0 + r#0_0, d#0_0));
    assume false;
    goto anon10;

  anon11_Else:
    assume (forall a#0_1: int, r#0_1: int, d#0_1: int :: { Mul(d#0_1, Div(a#0_1 + r#0_1, d#0_1)) } 0 < d#0_1 && Mod(a#0_1, d#0_1) == LitInt(0) && LitInt(0) <= r#0_1 && r#0_1 < d#0_1 ==> a#0_1 == Mul(d#0_1, Div(a#0_1 + r#0_1, d#0_1)));
    goto anon10;

  anon10:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(754,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishFancy", " | ", x#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(758,8): initial state"} true;
    assume 0 < d#0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= b#0;
    goto anon3;

  anon4_Else:
    assume {:partition} b#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= b#0 && b#0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(761,28): post-state"} true;
    assume d#0 != 0;
    assume Div(Mul(d#0, x#0) + b#0, d#0) == x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int);
  requires {:id "id12208"} 0 < d#0;
  requires {:id "id12209"} LitInt(0) <= b#0;
  requires {:id "id12210"} b#0 < d#0;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12211"} Div(Mul(d#0, x#0) + b#0, d#0) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12212"} 0 < d#0;
  requires {:id "id12213"} LitInt(0) <= b#0;
  requires {:id "id12214"} b#0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12215"} Div(Mul(d#0, x#0) + b#0, d#0) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var x##0: int;
  var f##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishFancy", " | ", x#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(762,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(763,19)"} true;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    assume lambdaResult#0 <==> Div(Mul(d#0, u#0) + b#0, d#0) == u#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume true;
    f#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Div(Mul(d#0, $Unbox($l#1#u#0): int) + b#0, d#0) == $Unbox($l#1#u#0): int)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(764,38)"} true;
    assume true;
    x##0 := x#0;
    assume true;
    f##0 := f#0;
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(765,31)"} true;
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(x#0))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(766,15)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0: int;
  var b#0: int;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishFancyAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(769,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(770,12): post-state"} true;
    havoc d#0;
    havoc b#0;
    havoc x#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume 0 < d#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= b#0;
    goto anon4;

  anon8_Else:
    assume {:partition} b#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= b#0 && b#0 < d#0;
    assume d#0 != 0;
    assume Div(Mul(d#0, x#0) + b#0, d#0) == x#0;
    goto anon6;

  anon7_Else:
    assume 0 < d#0 && LitInt(0) <= b#0 && b#0 < d#0 ==> Div(Mul(d#0, x#0) + b#0, d#0) == x#0;
    goto anon6;

  anon6:
    assume (forall d#1: int, b#1: int, x#1: int :: { Div(Mul(d#1, x#1) + b#1, d#1) } 0 < d#1 && LitInt(0) <= b#1 && b#1 < d#1 ==> Div(Mul(d#1, x#1) + b#1, d#1) == x#1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto();



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12230"} (forall d#1: int, b#1: int, x#1: int :: { Div(Mul(d#1, x#1) + b#1, d#1) } 0 < d#1 && LitInt(0) <= b#1 && b#1 < d#1 ==> Div(Mul(d#1, x#1) + b#1, d#1) == x#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12231"} (forall d#1: int, b#1: int, x#1: int :: { Div(Mul(d#1, x#1) + b#1, d#1) } 0 < d#1 && LitInt(0) <= b#1 && b#1 < d#1 ==> Div(Mul(d#1, x#1) + b#1, d#1) == x#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var b#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var b##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishFancyAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(772,2): initial state"} true;
    $_reverifyPost := false;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc x#0_0, b#0_0, d#0_0;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} 0 < d#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= b#0_0;
    goto anon4;

  anon11_Else:
    assume {:partition} b#0_0 < LitInt(0);
    goto anon4;

  anon10_Else:
    assume {:partition} d#0_0 <= 0;
    goto anon4;

  anon4:
    assume true;
    assume 0 < d#0_0 && LitInt(0) <= b#0_0 && b#0_0 < d#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(Mul(d#0_0, x#0_0) + b#0_0, d#0_0) == x#0_0;
    assume false;
    goto anon6;

  anon12_Else:
    goto anon6;

  anon6:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanishFancy(x##0_0, b##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanishFancy(x##0_0, b##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(776,43)"} true;
    assume Div(Mul(d#0_0, x#0_0) + b#0_0, d#0_0) == x#0_0;
    assume false;
    goto anon8;

  anon9_Else:
    assume (forall x#0_1: int, b#0_1: int, d#0_1: int :: { Div(Mul(d#0_1, x#0_1) + b#0_1, d#0_1) } 0 < d#0_1 && LitInt(0) <= b#0_1 && b#0_1 < d#0_1 ==> Div(Mul(d#0_1, x#0_1) + b#0_1, d#0_1) == x#0_1);
    goto anon8;

  anon8:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(777,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanish", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(781,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(783,24): post-state"} true;
    assume d#0 != 0;
    assume Div(Mul(d#0, x#0), d#0) == x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanish (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int);
  requires {:id "id12241"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12242"} Div(Mul(d#0, x#0), d#0) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id12243"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12244"} Div(Mul(d#0, x#0), d#0) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var b##0: int;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanish", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(784,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    b##0 := LitInt(0);
    assume true;
    d##0 := d#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanishFancy(x##0, b##0, d##0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanishFancy(x##0, b##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(785,41)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivMultiplesVanishAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(788,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(789,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume Div(Mul(d#0, x#0), d#0) == x#0;
    goto anon4;

  anon5_Else:
    assume 0 < d#0 ==> Div(Mul(d#0, x#0), d#0) == x#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Div(Mul(d#1, x#1), d#1) } 0 < d#1 ==> Div(Mul(d#1, x#1), d#1) == x#1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivMultiplesVanishAuto();



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12252"} (forall x#1: int, d#1: int :: { Div(Mul(d#1, x#1), d#1) } 0 < d#1 ==> Div(Mul(d#1, x#1), d#1) == x#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12253"} (forall x#1: int, d#1: int :: { Div(Mul(d#1, x#1), d#1) } 0 < d#1 ==> Div(Mul(d#1, x#1), d#1) == x#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaDivMultiplesVanishAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(790,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    assume true;
    assume 0 < d#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(Mul(d#0_0, x#0_0), d#0_0) == x#0_0;
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(794,35)"} true;
    assume Div(Mul(d#0_0, x#0_0), d#0_0) == x#0_0;
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, d#0_1: int :: { Mul(d#0_1, x#0_1) } 0 < d#0_1 ==> Div(Mul(d#0_1, x#0_1), d#0_1) == x#0_1);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(795,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultiple (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultiple (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultiple", " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(799,8): initial state"} true;
    assume LitInt(0) <= b#0;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(802,25): post-state"} true;
    assume d#0 != 0;
    assume Div(Mul(b#0, d#0), d#0) == b#0;
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultiple (call precondtion)"} CallPre$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int);
  requires {:id "id12264"} LitInt(0) <= b#0;
  requires {:id "id12265"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaDivByMultiple (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12266"} Div(Mul(b#0, d#0), d#0) == b#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivByMultiple (correctness)"} Impl$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id12267"} LitInt(0) <= b#0;
  requires {:id "id12268"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12269"} Div(Mul(b#0, d#0), d#0) == b#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultiple (correctness)"} Impl$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultiple", " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(803,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := b#0;
    assume true;
    d##0 := d#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##0, d##0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(804,32)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultipleAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultipleAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultipleAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultipleAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(807,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(808,12): post-state"} true;
    havoc b#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= b#0;
    assume 0 < d#0;
    assume d#0 != 0;
    assume Div(Mul(b#0, d#0), d#0) == b#0;
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= b#0 && 0 < d#0 ==> Div(Mul(b#0, d#0), d#0) == b#0;
    goto anon4;

  anon4:
    assume (forall b#1: int, d#1: int :: { Div(Mul(b#1, d#1), d#1) } LitInt(0) <= b#1 && 0 < d#1 ==> Div(Mul(b#1, d#1), d#1) == b#1);
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultipleAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivByMultipleAuto();



procedure {:verboseName "DivMod.LemmaDivByMultipleAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultipleAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12278"} (forall b#1: int, d#1: int :: { Div(Mul(b#1, d#1), d#1) } LitInt(0) <= b#1 && 0 < d#1 ==> Div(Mul(b#1, d#1), d#1) == b#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivByMultipleAuto (correctness)"} Impl$$DivMod.__default.LemmaDivByMultipleAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12279"} (forall b#1: int, d#1: int :: { Div(Mul(b#1, d#1), d#1) } LitInt(0) <= b#1 && 0 < d#1 ==> Div(Mul(b#1, d#1), d#1) == b#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultipleAuto (correctness)"} Impl$$DivMod.__default.LemmaDivByMultipleAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var d#0_0: int;
  var b##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(809,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc b#0_0, d#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= b#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} b#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= b#0_0 && 0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(Mul(b#0_0, d#0_0), d#0_0) == b#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaDivByMultiple(b##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaDivByMultiple(b##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(813,30)"} true;
    assume Div(Mul(b#0_0, d#0_0), d#0_0) == b#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall b#0_1: int, d#0_1: int :: { Mul(b#0_1, d#0_1) } LitInt(0) <= b#0_1 && 0 < d#0_1 ==> Div(Mul(b#0_1, d#0_1), d#0_1) == b#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(814,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleIsStronglyOrdered", " | ", x#0, " | ", y#0, " | ", m#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(819,8): initial state"} true;
    assume x#0 < y#0;
    assume y#0 == Mul(m#0, z#0);
    assume 0 < z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(823,19): post-state"} true;
    assume z#0 != 0;
    assume z#0 != 0;
    assume Div(x#0, z#0) < Div(y#0, z#0);
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (call precondtion)"} CallPre$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int);
  requires {:id "id12292"} x#0 < y#0;
  requires {:id "id12293"} y#0 == Mul(m#0, z#0);
  requires {:id "id12294"} 0 < z#0;



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12295"} Div(x#0, z#0) < Div(y#0, z#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (correctness)"} Impl$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id12296"} x#0 < y#0;
  requires {:id "id12297"} y#0 == Mul(m#0, z#0);
  requires {:id "id12298"} 0 < z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12299"} Div(x#0, z#0) < Div(y#0, z#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (correctness)"} Impl$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var m##0: int;
  var n##0: int;
  var x##1: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var yx#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var u#Z#0: int;
  var let#0#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleIsStronglyOrdered", " | ", x#0, " | ", y#0, " | ", m#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(824,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := m#0;
    assume true;
    m##0 := z#0;
    call CallPre$$DivMod.__default.LemmaModMultiplesBasic(x##0, m##0);
    call CallPost$$DivMod.__default.LemmaModMultiplesBasic(x##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(825,32)"} true;
    assume true;
    n##0 := z#0;
    assume true;
    x##1 := y#0 - x#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc yx#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    havoc u#Z#0;
    assume true;
    assume let#0#0#0 == yx#0 + x#0;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume u#Z#0 == let#0#0#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#0 < u#Z#0;
    assume z#0 != 0;
    goto anon4;

  anon11_Else:
    assume {:partition} u#Z#0 <= x#0;
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} x#0 < u#Z#0 && Mod(u#Z#0, z#0) == LitInt(0);
    assume z#0 != 0;
    assume z#0 != 0;
    goto anon6;

  anon12_Else:
    assume {:partition} !(x#0 < u#Z#0 && Mod(u#Z#0, z#0) == LitInt(0));
    goto anon6;

  anon6:
    assume lambdaResult#0 <==> x#0 < u#Z#0 && Mod(u#Z#0, z#0) == LitInt(0) ==> Div(x#0, z#0) < Div(u#Z#0, z#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon10_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon9_Else:
    goto anon8;

  anon8:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#yx#0: Box :: $Box((var u#1 := $Unbox($l#1#yx#0): int + x#0; x#0 < u#1 && Mod(u#1, z#0) == LitInt(0) ==> Div(x#0, z#0) < Div(u#1, z#0)))), (lambda $l#1#heap#0: Heap, $l#1#yx#0: Box :: $IsBox($l#1#yx#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#yx#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##1, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(826,97)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var z#0: int;
  var m#0: int;
  var y#0: int;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(829,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(830,12): post-state"} true;
    havoc z#0;
    havoc m#0;
    havoc y#0;
    havoc x#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume x#0 < y#0;
    assume y#0 == Mul(m#0, z#0);
    assume 0 < z#0;
    assume z#0 != 0;
    assume z#0 != 0;
    assume Div(x#0, z#0) < Div(y#0, z#0);
    goto anon4;

  anon5_Else:
    assume x#0 < y#0 && y#0 == Mul(m#0, z#0) && 0 < z#0 ==> Div(x#0, z#0) < Div(y#0, z#0);
    goto anon4;

  anon4:
    assume (forall z#1: int, m#1: int, y#1: int, x#1: int :: { Div(x#1, z#1), Mul(m#1, z#1), Div(y#1, z#1) } x#1 < y#1 && y#1 == Mul(m#1, z#1) && 0 < z#1 ==> Div(x#1, z#1) < Div(y#1, z#1));
    return;
}



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto();



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12318"} (forall z#1: int, m#1: int, y#1: int, x#1: int :: { Div(x#1, z#1), Mul(m#1, z#1), Div(y#1, z#1) } x#1 < y#1 && y#1 == Mul(m#1, z#1) && 0 < z#1 ==> Div(x#1, z#1) < Div(y#1, z#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (correctness)"} Impl$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12319"} (forall z#1: int, m#1: int, y#1: int, x#1: int :: { Div(x#1, z#1), Mul(m#1, z#1), Div(y#1, z#1) } x#1 < y#1 && y#1 == Mul(m#1, z#1) && 0 < z#1 ==> Div(x#1, z#1) < Div(y#1, z#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (correctness)"} Impl$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(832,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, y#0_0, m#0_0, z#0_0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#0_0 < y#0_0;
    goto anon3;

  anon11_Else:
    assume {:partition} y#0_0 <= x#0_0;
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} x#0_0 < y#0_0 && y#0_0 == Mul(m#0_0, z#0_0);
    goto anon5;

  anon12_Else:
    assume {:partition} !(x#0_0 < y#0_0 && y#0_0 == Mul(m#0_0, z#0_0));
    goto anon5;

  anon5:
    assume true;
    assume x#0_0 < y#0_0 && y#0_0 == Mul(m#0_0, z#0_0) && 0 < z#0_0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} z#0_0 != 0;
    assume {:subsumption 0} z#0_0 != 0;
    assume true;
    assume Div(x#0_0, z#0_0) < Div(y#0_0, z#0_0);
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x##0_0, y##0_0, m##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x##0_0, y##0_0, m##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(836,53)"} true;
    assume Div(x#0_0, z#0_0) < Div(y#0_0, z#0_0);
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int, z#0_1: int :: { Div(y#0_1, z#0_1), Div(x#0_1, z#0_1), Mul(m#0_1, z#0_1) } x#0_1 < y#0_1 && y#0_1 == Mul(m#0_1, z#0_1) && 0 < z#0_1 ==> Div(x#0_1, z#0_1) < Div(y#0_1, z#0_1));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(837,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLe (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLe (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLe", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(842,8): initial state"} true;
    assume 0 < b#0;
    assume a#0 <= Mul(b#0, c#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(845,19): post-state"} true;
    assume b#0 != 0;
    assume Div(a#0, b#0) <= c#0;
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLe (call precondtion)"} CallPre$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int);
  requires {:id "id12331"} 0 < b#0;
  requires {:id "id12332"} a#0 <= Mul(b#0, c#0);



procedure {:verboseName "DivMod.LemmaMultiplyDivideLe (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12333"} Div(a#0, b#0) <= c#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMultiplyDivideLe (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id12334"} 0 < b#0;
  requires {:id "id12335"} a#0 <= Mul(b#0, c#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12336"} Div(a#0, b#0) <= c#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLe (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var m##0: int;
  var n##0: int;
  var x##1: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var x##2: int;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLe", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(846,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := c#0;
    assume true;
    m##0 := b#0;
    call CallPre$$DivMod.__default.LemmaModMultiplesBasic(x##0, m##0);
    call CallPost$$DivMod.__default.LemmaModMultiplesBasic(x##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(847,32)"} true;
    assume true;
    n##0 := b#0;
    assume true;
    x##1 := Mul(b#0, c#0) - a#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#0;
    assume b#0 != 0;
    goto anon4;

  anon11_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#0 && Mod(i#0 + a#0, b#0) == LitInt(0);
    assume b#0 != 0;
    assume b#0 != 0;
    goto anon6;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= i#0 && Mod(i#0 + a#0, b#0) == LitInt(0));
    goto anon6;

  anon6:
    assume lambdaResult#0 <==> LitInt(0) <= i#0 && Mod(i#0 + a#0, b#0) == LitInt(0) ==> Div(a#0, b#0) <= Div(i#0 + a#0, b#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon10_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon9_Else:
    goto anon8;

  anon8:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#i#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#i#0): int && Mod($Unbox($l#1#i#0): int + a#0, b#0) == LitInt(0) ==> Div(a#0, b#0) <= Div($Unbox($l#1#i#0): int + a#0, b#0))), (lambda $l#1#heap#0: Heap, $l#1#i#0: Box :: $IsBox($l#1#i#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#i#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##1, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(848,97)"} true;
    assume true;
    x##2 := c#0;
    assume true;
    d##0 := b#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##2, d##0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##2, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(849,33)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLeAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLeAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var c#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLeAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(852,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(853,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc c#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < b#0;
    assume a#0 <= Mul(b#0, c#0);
    assume b#0 != 0;
    assume Div(a#0, b#0) <= c#0;
    goto anon4;

  anon5_Else:
    assume 0 < b#0 && a#0 <= Mul(b#0, c#0) ==> Div(a#0, b#0) <= c#0;
    goto anon4;

  anon4:
    assume (forall a#1: int, b#1: int, c#1: int :: { Div(a#1, b#1), Mul(b#1, c#1) } 0 < b#1 && a#1 <= Mul(b#1, c#1) ==> Div(a#1, b#1) <= c#1);
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMultiplyDivideLeAuto();



procedure {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLeAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12353"} (forall a#1: int, b#1: int, c#1: int :: { Div(a#1, b#1), Mul(b#1, c#1) } 0 < b#1 && a#1 <= Mul(b#1, c#1) ==> Div(a#1, b#1) <= c#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLeAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12354"} (forall a#1: int, b#1: int, c#1: int :: { Div(a#1, b#1), Mul(b#1, c#1) } 0 < b#1 && a#1 <= Mul(b#1, c#1) ==> Div(a#1, b#1) <= c#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLeAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var c#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var c##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLeAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(854,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc a#0_0, b#0_0, c#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < b#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} b#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < b#0_0 && a#0_0 <= Mul(b#0_0, c#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} b#0_0 != 0;
    assume true;
    assume Div(a#0_0, b#0_0) <= c#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    c##0_0 := c#0_0;
    call CallPre$$DivMod.__default.LemmaMultiplyDivideLe(a##0_0, b##0_0, c##0_0);
    call CallPost$$DivMod.__default.LemmaMultiplyDivideLe(a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(858,36)"} true;
    assume Div(a#0_0, b#0_0) <= c#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall a#0_1: int, b#0_1: int, c#0_1: int :: { Div(a#0_1, b#0_1), Mul(b#0_1, c#0_1) } 0 < b#0_1 && a#0_1 <= Mul(b#0_1, c#0_1) ==> Div(a#0_1, b#0_1) <= c#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(859,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLt (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLt (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLt", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(864,8): initial state"} true;
    assume 0 < b#0;
    assume a#0 < Mul(b#0, c#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(867,19): post-state"} true;
    assume b#0 != 0;
    assume Div(a#0, b#0) < c#0;
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLt (call precondtion)"} CallPre$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int);
  requires {:id "id12365"} 0 < b#0;
  requires {:id "id12366"} a#0 < Mul(b#0, c#0);



procedure {:verboseName "DivMod.LemmaMultiplyDivideLt (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12367"} Div(a#0, b#0) < c#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMultiplyDivideLt (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id12368"} 0 < b#0;
  requires {:id "id12369"} a#0 < Mul(b#0, c#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12370"} Div(a#0, b#0) < c#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLt (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var m##0: int;
  var n##0: int;
  var x##1: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var x##2: int;
  var d##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLt", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(868,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := c#0;
    assume true;
    m##0 := b#0;
    call CallPre$$DivMod.__default.LemmaModMultiplesBasic(x##0, m##0);
    call CallPost$$DivMod.__default.LemmaModMultiplesBasic(x##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(869,32)"} true;
    assume true;
    n##0 := b#0;
    assume true;
    x##1 := Mul(b#0, c#0) - a#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} 0 < i#0;
    assume b#0 != 0;
    goto anon4;

  anon11_Else:
    assume {:partition} i#0 <= 0;
    goto anon4;

  anon4:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} 0 < i#0 && Mod(i#0 + a#0, b#0) == LitInt(0);
    assume b#0 != 0;
    assume b#0 != 0;
    goto anon6;

  anon12_Else:
    assume {:partition} !(0 < i#0 && Mod(i#0 + a#0, b#0) == LitInt(0));
    goto anon6;

  anon6:
    assume lambdaResult#0 <==> 0 < i#0 && Mod(i#0 + a#0, b#0) == LitInt(0) ==> Div(a#0, b#0) < Div(i#0 + a#0, b#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon10_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon9_Else:
    goto anon8;

  anon8:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#i#0: Box :: $Box(0 < $Unbox($l#1#i#0): int && Mod($Unbox($l#1#i#0): int + a#0, b#0) == LitInt(0) ==> Div(a#0, b#0) < Div($Unbox($l#1#i#0): int + a#0, b#0))), (lambda $l#1#heap#0: Heap, $l#1#i#0: Box :: $IsBox($l#1#i#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#i#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##1, f##0);
    call CallPost$$DivInternals.__default.LemmaDivInductionAuto(n##0, x##1, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(870,95)"} true;
    assume true;
    x##2 := c#0;
    assume true;
    d##0 := b#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##2, d##0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##2, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(871,33)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLtAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMultiplyDivideLtAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var c#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLtAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(874,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(875,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc c#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < b#0;
    assume a#0 < Mul(b#0, c#0);
    assume b#0 != 0;
    assume Div(a#0, b#0) < c#0;
    goto anon4;

  anon5_Else:
    assume 0 < b#0 && a#0 < Mul(b#0, c#0) ==> Div(a#0, b#0) < c#0;
    goto anon4;

  anon4:
    assume (forall a#1: int, b#1: int, c#1: int :: { Div(a#1, b#1), Mul(b#1, c#1) } 0 < b#1 && a#1 < Mul(b#1, c#1) ==> Div(a#1, b#1) < c#1);
    return;
}



procedure {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMultiplyDivideLtAuto();



procedure {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLtAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12387"} (forall a#1: int, b#1: int, c#1: int :: { Div(a#1, b#1), Mul(b#1, c#1) } 0 < b#1 && a#1 < Mul(b#1, c#1) ==> Div(a#1, b#1) < c#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLtAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12388"} (forall a#1: int, b#1: int, c#1: int :: { Div(a#1, b#1), Mul(b#1, c#1) } 0 < b#1 && a#1 < Mul(b#1, c#1) ==> Div(a#1, b#1) < c#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (correctness)"} Impl$$DivMod.__default.LemmaMultiplyDivideLtAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var c#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var c##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLtAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(876,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc a#0_0, b#0_0, c#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < b#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} b#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < b#0_0 && a#0_0 < Mul(b#0_0, c#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} b#0_0 != 0;
    assume true;
    assume Div(a#0_0, b#0_0) < c#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    c##0_0 := c#0_0;
    call CallPre$$DivMod.__default.LemmaMultiplyDivideLt(a##0_0, b##0_0, c##0_0);
    call CallPost$$DivMod.__default.LemmaMultiplyDivideLt(a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(880,36)"} true;
    assume Div(a#0_0, b#0_0) < c#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall a#0_1: int, b#0_1: int, c#0_1: int :: { Div(a#0_1, b#0_1), Mul(b#0_1, c#0_1) } 0 < b#0_1 && a#0_1 < Mul(b#0_1, c#0_1) ==> Div(a#0_1, b#0_1) < c#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(881,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaHoistOverDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int where LitInt(0) <= d#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaHoistOverDenominator (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaHoistOverDenominator", " | ", x#0, " | ", j#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(885,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(887,22): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Div(x#0, d#0) + j#0 == Div(x#0 + Mul(j#0, d#0), d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaHoistOverDenominator (call precondtion)"} CallPre$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int where LitInt(0) <= d#0);
  requires {:id "id12399"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaHoistOverDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int where LitInt(0) <= d#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12400"} Div(x#0, d#0) + j#0 == Div(x#0 + Mul(j#0, d#0), d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaHoistOverDenominator (correctness)"} Impl$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int where LitInt(0) <= d#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12401"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12402"} Div(x#0, d#0) + j#0 == Div(x#0 + Mul(j#0, d#0), d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaHoistOverDenominator (correctness)"} Impl$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaHoistOverDenominator", " | ", x#0, " | ", j#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(888,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(889,19)"} true;
    assume true;
    x##0 := j#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    assume d#0 != 0;
    assume lambdaResult#0 <==> Div(x#0, d#0) + u#0 == Div(x#0 + Mul(u#0, d#0), d#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Div(x#0, d#0) + $Unbox($l#1#u#0): int == Div(x#0 + Mul($Unbox($l#1#u#0): int, d#0), d#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(890,64)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaHoistOverDenominatorAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaHoistOverDenominatorAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var j#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaHoistOverDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(893,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(894,12): post-state"} true;
    havoc x#0;
    havoc j#0;
    havoc d#0;
    assume LitInt(0) <= d#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Div(x#0, d#0) + j#0 == Div(x#0 + Mul(j#0, d#0), d#0);
    goto anon4;

  anon5_Else:
    assume 0 < d#0 ==> Div(x#0, d#0) + j#0 == Div(x#0 + Mul(j#0, d#0), d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, j#1: int, d#1: int :: { Div(x#1, d#1) + j#1 } LitInt(0) <= d#1 ==> 0 < d#1 ==> Div(x#1, d#1) + j#1 == Div(x#1 + Mul(j#1, d#1), d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaHoistOverDenominatorAuto();



procedure {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaHoistOverDenominatorAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12416"} (forall x#1: int, j#1: int, d#1: int :: { Div(x#1, d#1) + j#1 } LitInt(0) <= d#1 ==> 0 < d#1 ==> Div(x#1, d#1) + j#1 == Div(x#1 + Mul(j#1, d#1), d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaHoistOverDenominatorAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12417"} (forall x#1: int, j#1: int, d#1: int :: { Div(x#1, d#1) + j#1 } LitInt(0) <= d#1 ==> 0 < d#1 ==> Div(x#1, d#1) + j#1 == Div(x#1 + Mul(j#1, d#1), d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (correctness)"} Impl$$DivMod.__default.LemmaHoistOverDenominatorAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var j#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var j##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaHoistOverDenominatorAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(895,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, j#0_0, d#0_0;
    assume LitInt(0) <= d#0_0;
    assume true;
    assume 0 < d#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Div(x#0_0, d#0_0) + j#0_0 == Div(x#0_0 + Mul(j#0_0, d#0_0), d#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    j##0_0 := j#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaHoistOverDenominator(x##0_0, j##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaHoistOverDenominator(x##0_0, j##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(899,40)"} true;
    assume Div(x#0_0, d#0_0) + j#0_0 == Div(x#0_0 + Mul(j#0_0, d#0_0), d#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, j#0_1: int, d#0_1: int, _t#0#0_0: int :: { Div(_t#0#0_0, d#0_1), Div(x#0_1, d#0_1), Mul(j#0_1, d#0_1) } LitInt(0) <= d#0_1 && _t#0#0_0 == x#0_1 + Mul(j#0_1, d#0_1) && 0 < d#0_1 ==> Div(x#0_1, d#0_1) + j#0_1 == Div(_t#0#0_0, d#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(900,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound1 (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound1 (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound1", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(903,8): initial state"} true;
    assume LitInt(0) <= a#0;
    assume 0 < b#0;
    assume 0 < c#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(907,14): post-state"} true;
    assume 0 < Mul(b#0, c#0);
    assume b#0 != 0;
    assume Mul(b#0, c#0) != 0;
    assume Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound1 (call precondtion)"} CallPre$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int);
  requires {:id "id12432"} LitInt(0) <= a#0;
  requires {:id "id12433"} 0 < b#0;
  requires {:id "id12434"} 0 < c#0;



procedure {:verboseName "DivMod.LemmaPartBound1 (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12435"} 0 < Mul(b#0, c#0);
  free ensures true;
  free ensures {:id "id12436"} Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaPartBound1 (correctness)"} Impl$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id12437"} LitInt(0) <= a#0;
  requires {:id "id12438"} 0 < b#0;
  requires {:id "id12439"} 0 < c#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12440"} 0 < Mul(b#0, c#0);
  free ensures true;
  free ensures {:id "id12441"} Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound1 (correctness)"} Impl$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0_2_0: int;
  var d##0_2_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound1", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(909,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(910,34)"} true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume false;
    goto anon5;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    push;
    push;
    assume b#0 != 0;
    assume true;
    x##0_2_0 := Mul(b#0, Div(a#0, b#0));
    assume true;
    d##0_2_0 := Mul(b#0, c#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_2_0, d##0_2_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_2_0, d##0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(913,50)"} true;
    pop;
    pop;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) == Mul(b#0, Div(a#0, b#0)) - Mul(Mul(b#0, c#0), Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)));
    assume false;
    goto anon5;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(915,35)"} true;
    pop;
    pop;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, Div(a#0, b#0)) - Mul(Mul(b#0, c#0), Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) == Mul(b#0, Div(a#0, b#0)) - Mul(b#0, Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))));
    assume false;
    goto anon5;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(917,36)"} true;
    pop;
    pop;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, Div(a#0, b#0)) - Mul(b#0, Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) == Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))));
    assume false;
    goto anon5;

  anon17_Else:
    goto anon5;

  anon5:
    assume Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) == Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume true;
    assume false;
    goto anon13;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume true;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(923,32)"} true;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Lit(true) ==> Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) < Mul(b#0, c#0);
    assume false;
    goto anon13;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) < Mul(b#0, c#0);
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) < Mul(b#0, c#0) ==> Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) < Mul(b#0, c#0);
    assume false;
    goto anon13;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) < Mul(b#0, c#0);
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(926,35)"} true;
    call CallPre$$Mul.__default.LemmaMulStrictInequalityConverseAuto();
    call CallPost$$Mul.__default.LemmaMulStrictInequalityConverseAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(926,75)"} true;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) < Mul(b#0, c#0) ==> Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) < c#0;
    assume false;
    goto anon13;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) < c#0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) < c#0 ==> Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) <= c#0 - 1;
    assume false;
    goto anon13;

  anon22_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) <= c#0 - 1;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(929,35)"} true;
    call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(929,61)"} true;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0))) <= c#0 - 1 ==> Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) <= Mul(b#0, c#0 - 1);
    assume false;
    goto anon13;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) <= Mul(b#0, c#0 - 1);
    assume {:subsumption 0} b#0 != 0;
    assume {:subsumption 0} Mul(b#0, c#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(b#0, Div(a#0, b#0) - Mul(c#0, Div(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)))) <= Mul(b#0, c#0 - 1) ==> Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
    assume false;
    goto anon13;

  anon24_Else:
    goto anon13;

  anon13:
    assume true ==> Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound1Auto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound1Auto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound1Auto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound1Auto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var c#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound1Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(935,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(936,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc c#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= a#0;
    assume 0 < b#0;
    assume 0 < c#0;
    assume 0 < Mul(b#0, c#0);
    assume b#0 != 0;
    assume Mul(b#0, c#0) != 0;
    assume Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= a#0 && 0 < b#0 && 0 < c#0 ==> 0 < Mul(b#0, c#0) && Mod(Mul(b#0, Div(a#0, b#0)), Mul(b#0, c#0)) <= Mul(b#0, c#0 - 1);
    goto anon4;

  anon4:
    assume (forall a#1: int, b#1: int, c#1: int :: { Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) } LitInt(0) <= a#1 && 0 < b#1 && 0 < c#1 ==> 0 < Mul(b#1, c#1)) && (forall a#1: int, b#1: int, c#1: int :: { Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) } LitInt(0) <= a#1 && 0 < b#1 && 0 < c#1 ==> Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) <= Mul(b#1, c#1 - 1));
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound1Auto (call precondtion)"} CallPre$$DivMod.__default.LemmaPartBound1Auto();



procedure {:verboseName "DivMod.LemmaPartBound1Auto (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound1Auto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12536"} (forall a#1: int, b#1: int, c#1: int :: { Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) } LitInt(0) <= a#1 && 0 < b#1 && 0 < c#1 ==> 0 < Mul(b#1, c#1));
  free ensures {:id "id12537"} (forall a#1: int, b#1: int, c#1: int :: { Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) } LitInt(0) <= a#1 && 0 < b#1 && 0 < c#1 ==> Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) <= Mul(b#1, c#1 - 1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaPartBound1Auto (correctness)"} Impl$$DivMod.__default.LemmaPartBound1Auto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12538"} (forall a#1: int, b#1: int, c#1: int :: { Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) } LitInt(0) <= a#1 && 0 < b#1 && 0 < c#1 ==> 0 < Mul(b#1, c#1));
  free ensures {:id "id12539"} (forall a#1: int, b#1: int, c#1: int :: { Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) } LitInt(0) <= a#1 && 0 < b#1 && 0 < c#1 ==> Mod(Mul(b#1, Div(a#1, b#1)), Mul(b#1, c#1)) <= Mul(b#1, c#1 - 1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound1Auto (correctness)"} Impl$$DivMod.__default.LemmaPartBound1Auto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var c#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var c##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound1Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(938,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc a#0_0, b#0_0, c#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= a#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} a#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= a#0_0 && 0 < b#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= a#0_0 && 0 < b#0_0);
    goto anon5;

  anon5:
    assume true;
    assume LitInt(0) <= a#0_0 && 0 < b#0_0 && 0 < c#0_0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} 0 < Mul(b#0_0, c#0_0);
    assume {:subsumption 0} b#0_0 != 0;
    assume {:subsumption 0} Mul(b#0_0, c#0_0) != 0;
    goto anon8;

  anon16_Else:
    assume {:partition} Mul(b#0_0, c#0_0) <= 0;
    goto anon8;

  anon8:
    assume true;
    assume 0 < Mul(b#0_0, c#0_0) && Mod(Mul(b#0_0, Div(a#0_0, b#0_0)), Mul(b#0_0, c#0_0)) <= Mul(b#0_0, c#0_0 - 1);
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    c##0_0 := c#0_0;
    call CallPre$$DivMod.__default.LemmaPartBound1(a##0_0, b##0_0, c##0_0);
    call CallPost$$DivMod.__default.LemmaPartBound1(a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(942,30)"} true;
    assume 0 < Mul(b#0_0, c#0_0);
    assume Mod(Mul(b#0_0, Div(a#0_0, b#0_0)), Mul(b#0_0, c#0_0)) <= Mul(b#0_0, c#0_0 - 1);
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall a#0_1: int, b#0_1: int, c#0_1: int :: LitInt(0) <= a#0_1 && 0 < b#0_1 && 0 < c#0_1 ==> 0 < Mul(b#0_1, c#0_1)) && (forall a#0_2: int, b#0_2: int, c#0_2: int, _t#0#0_0: int :: { Mul(b#0_2, _t#0#0_0), Mul(b#0_2, c#0_2), Mul(b#0_2, Div(a#0_2, b#0_2)) } _t#0#0_0 == c#0_2 - 1 && LitInt(0) <= a#0_2 && 0 < b#0_2 && 0 < c#0_2 ==> Mod(Mul(b#0_2, Div(a#0_2, b#0_2)), Mul(b#0_2, c#0_2)) <= Mul(b#0_2, _t#0#0_0));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(943,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModIsModRecursive (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsModRecursive (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsModRecursive", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(953,8): initial state"} true;
    assume m#0 > 0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} x#0 < 0;
    goto anon4;

  anon5_Else:
    assume {:partition} 0 <= x#0;
    goto anon4;

  anon4:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(955,31): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := m#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 > 0;
    assume ##d#0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume m#0 != 0;
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, m#0) == Mod(x#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModIsModRecursive (call precondtion)"} CallPre$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int);
  requires {:id "id12552"} m#0 > 0;



procedure {:verboseName "DivMod.LemmaModIsModRecursive (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int);
  modifies $Heap;
  free ensures ModInternals.__default.ModRecursive#canCall(x#0, m#0);
  free ensures {:id "id12553"} ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0, m#0) == Mod(x#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModIsModRecursive (correctness)"} Impl$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id12554"} m#0 > 0;
  modifies $Heap;
  free ensures ModInternals.__default.ModRecursive#canCall(x#0, m#0);
  free ensures {:id "id12555"} ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0, m#0) == Mod(x#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsModRecursive (correctness)"} Impl$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var x##0_0_2_0: int;
  var y##0_0_2_0: int;
  var m##0_0_2_0: int;
  var ##x#0_0_3_0: int;
  var ##d#0_0_3_0: int;
  var x##0_0_3_0: int;
  var m##0_0_3_0: int;
  var ##x#0_0_4_0: int;
  var ##d#0_0_4_0: int;
  var ##x#0_0_4_1: int;
  var ##d#0_0_4_1: int;
  var ##x#0_0_0: int;
  var ##d#0_0_0: int;
  var x##1_0_0: int;
  var m##1_0_0: int;
  var x##1_1_0_2_0: int;
  var y##1_1_0_2_0: int;
  var m##1_1_0_2_0: int;
  var ##x#1_1_0_3_0: int;
  var ##d#1_1_0_3_0: int;
  var x##1_1_0_3_0: int;
  var m##1_1_0_3_0: int;
  var ##x#1_1_0_4_0: int;
  var ##d#1_1_0_4_0: int;
  var ##x#1_1_0_4_1: int;
  var ##d#1_1_0_4_1: int;
  var ##x#1_1_0_0: int;
  var ##d#1_1_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsModRecursive", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(957,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: int, $ih#m0#0: int :: $ih#m0#0 > 0 && 0 <= (if $ih#x0#0 < 0 then 0 - $ih#x0#0 + $ih#m0#0 else $ih#x0#0) && (if $ih#x0#0 < 0 then 0 - $ih#x0#0 + $ih#m0#0 else $ih#x0#0) < (if x#0 < 0 then 0 - x#0 + m#0 else x#0) ==> ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, $ih#x0#0, $ih#m0#0) == Mod($ih#x0#0, $ih#m0#0));
    $_reverifyPost := false;
    call CallPre$$ModInternals.__default.reveal__ModRecursive();
    call CallPost$$ModInternals.__default.reveal__ModRecursive();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(958,24)"} true;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} x#0 < 0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##x#0_0_0 := x#0;
    assume $IsAlloc(##x#0_0_0, TInt, $Heap);
    ##d#0_0_0 := m#0;
    assume $IsAlloc(##d#0_0_0, TInt, $Heap);
    assume {:subsumption 0} ##d#0_0_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume false;
    goto anon8;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    ##x#0_0_4_0 := x#0;
    assume $IsAlloc(##x#0_0_4_0, TInt, $Heap);
    ##d#0_0_4_0 := m#0;
    assume $IsAlloc(##d#0_0_4_0, TInt, $Heap);
    assume {:subsumption 0} ##d#0_0_4_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    ##x#0_0_4_1 := x#0 + m#0;
    assume $IsAlloc(##x#0_0_4_1, TInt, $Heap);
    ##d#0_0_4_1 := m#0;
    assume $IsAlloc(##d#0_0_4_1, TInt, $Heap);
    assume {:subsumption 0} ##d#0_0_4_1 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0 + m#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0 + m#0, m#0);
    assume {:subsumption 0} ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0, m#0) == ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0 + m#0, m#0);
    assume false;
    goto anon8;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    ##x#0_0_3_0 := x#0 + m#0;
    assume $IsAlloc(##x#0_0_3_0, TInt, $Heap);
    ##d#0_0_3_0 := m#0;
    assume $IsAlloc(##d#0_0_3_0, TInt, $Heap);
    assume {:subsumption 0} ##d#0_0_3_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0 + m#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0 + m#0, m#0);
    assume true;
    x##0_0_3_0 := x#0 + m#0;
    assume true;
    m##0_0_3_0 := m#0;
    assume 0 <= (if x#0 < 0 then 0 - x#0 + m#0 else x#0) || (if x##0_0_3_0 < 0 then 0 - x##0_0_3_0 + m##0_0_3_0 else x##0_0_3_0) == (if x#0 < 0 then 0 - x#0 + m#0 else x#0);
    assume (if x##0_0_3_0 < 0 then 0 - x##0_0_3_0 + m##0_0_3_0 else x##0_0_3_0) < (if x#0 < 0 then 0 - x#0 + m#0 else x#0);
    call CallPre$$DivMod.__default.LemmaModIsModRecursive(x##0_0_3_0, m##0_0_3_0);
    call CallPost$$DivMod.__default.LemmaModIsModRecursive(x##0_0_3_0, m##0_0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(963,42)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0 + m#0, m#0) == Mod(x#0 + m#0, m#0);
    assume false;
    goto anon8;

  anon22_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume true;
    x##0_0_2_0 := x#0;
    assume true;
    y##0_0_2_0 := m#0;
    assume true;
    m##0_0_2_0 := m#0;
    call CallPre$$DivMod.__default.LemmaAddModNoop(x##0_0_2_0, y##0_0_2_0, m##0_0_2_0);
    call CallPost$$DivMod.__default.LemmaAddModNoop(x##0_0_2_0, y##0_0_2_0, m##0_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(965,34)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0 + m#0, m#0) == Mod(Mod(x#0, m#0) + Mod(m#0, m#0), m#0);
    assume false;
    goto anon8;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModBasicsAuto();
    call CallPost$$DivMod.__default.LemmaModBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(967,30)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, m#0) + Mod(m#0, m#0), m#0) == Mod(Mod(x#0, m#0), m#0);
    assume false;
    goto anon8;

  anon24_Else:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModBasicsAuto();
    call CallPost$$DivMod.__default.LemmaModBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(969,30)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, m#0), m#0) == Mod(x#0, m#0);
    assume false;
    goto anon8;

  anon25_Else:
    goto anon8;

  anon8:
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, m#0) == Mod(x#0, m#0);
    return;

  anon19_Else:
    assume {:partition} 0 <= x#0;
    assume true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} x#0 < m#0;
    assume true;
    assume $Is(x#0, Tclass._System.nat());
    x##1_0_0 := x#0;
    assume true;
    assume $Is(m#0, Tclass._System.nat());
    m##1_0_0 := m#0;
    call CallPre$$DivMod.__default.LemmaSmallMod(x##1_0_0, m##1_0_0);
    call CallPost$$DivMod.__default.LemmaSmallMod(x##1_0_0, m##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(973,25)"} true;
    return;

  anon26_Else:
    assume {:partition} m#0 <= x#0;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    ##x#1_1_0_0 := x#0;
    assume $IsAlloc(##x#1_1_0_0, TInt, $Heap);
    ##d#1_1_0_0 := m#0;
    assume $IsAlloc(##d#1_1_0_0, TInt, $Heap);
    assume {:subsumption 0} ##d#1_1_0_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume false;
    goto anon18;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    ##x#1_1_0_4_0 := x#0;
    assume $IsAlloc(##x#1_1_0_4_0, TInt, $Heap);
    ##d#1_1_0_4_0 := m#0;
    assume $IsAlloc(##d#1_1_0_4_0, TInt, $Heap);
    assume {:subsumption 0} ##d#1_1_0_4_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0, m#0);
    ##x#1_1_0_4_1 := x#0 - m#0;
    assume $IsAlloc(##x#1_1_0_4_1, TInt, $Heap);
    ##d#1_1_0_4_1 := m#0;
    assume $IsAlloc(##d#1_1_0_4_1, TInt, $Heap);
    assume {:subsumption 0} ##d#1_1_0_4_1 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0 - m#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0 - m#0, m#0);
    assume {:subsumption 0} ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0, m#0) == ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0 - m#0, m#0);
    assume false;
    goto anon18;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    ##x#1_1_0_3_0 := x#0 - m#0;
    assume $IsAlloc(##x#1_1_0_3_0, TInt, $Heap);
    ##d#1_1_0_3_0 := m#0;
    assume $IsAlloc(##d#1_1_0_3_0, TInt, $Heap);
    assume {:subsumption 0} ##d#1_1_0_3_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0 - m#0, m#0);
    assume ModInternals.__default.ModRecursive#canCall(x#0 - m#0, m#0);
    assume true;
    x##1_1_0_3_0 := x#0 - m#0;
    assume true;
    m##1_1_0_3_0 := m#0;
    assume 0 <= (if x#0 < 0 then 0 - x#0 + m#0 else x#0) || (if x##1_1_0_3_0 < 0 then 0 - x##1_1_0_3_0 + m##1_1_0_3_0 else x##1_1_0_3_0) == (if x#0 < 0 then 0 - x#0 + m#0 else x#0);
    assume (if x##1_1_0_3_0 < 0 then 0 - x##1_1_0_3_0 + m##1_1_0_3_0 else x##1_1_0_3_0) < (if x#0 < 0 then 0 - x#0 + m#0 else x#0);
    call CallPre$$DivMod.__default.LemmaModIsModRecursive(x##1_1_0_3_0, m##1_1_0_3_0);
    call CallPost$$DivMod.__default.LemmaModIsModRecursive(x##1_1_0_3_0, m##1_1_0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(978,42)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0 - m#0, m#0) == Mod(x#0 - m#0, m#0);
    assume false;
    goto anon18;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume true;
    x##1_1_0_2_0 := x#0;
    assume true;
    y##1_1_0_2_0 := m#0;
    assume true;
    m##1_1_0_2_0 := m#0;
    call CallPre$$DivMod.__default.LemmaSubModNoop(x##1_1_0_2_0, y##1_1_0_2_0, m##1_1_0_2_0);
    call CallPost$$DivMod.__default.LemmaSubModNoop(x##1_1_0_2_0, y##1_1_0_2_0, m##1_1_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(980,34)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0 - m#0, m#0) == Mod(Mod(x#0, m#0) - Mod(m#0, m#0), m#0);
    assume false;
    goto anon18;

  anon30_Else:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModBasicsAuto();
    call CallPost$$DivMod.__default.LemmaModBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(982,30)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, m#0) - Mod(m#0, m#0), m#0) == Mod(Mod(x#0, m#0), m#0);
    assume false;
    goto anon18;

  anon31_Else:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModBasicsAuto();
    call CallPost$$DivMod.__default.LemmaModBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(984,30)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, m#0), m#0) == Mod(x#0, m#0);
    assume false;
    goto anon18;

  anon32_Else:
    goto anon18;

  anon18:
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, m#0) == Mod(x#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModIsModRecursiveAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsModRecursiveAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsModRecursiveAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsModRecursiveAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;
  var ##x#0: int;
  var ##d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsModRecursiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(990,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(991,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume d#0 > 0;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##d#0 := d#0;
    assume $IsAlloc(##d#0, TInt, $Heap);
    assume {:subsumption 0} ##d#0 > 0;
    assume ##d#0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0, d#0);
    assume d#0 != 0;
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0) == Mod(x#0, d#0);
    goto anon4;

  anon5_Else:
    assume d#0 > 0 ==> ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0, d#0) == Mod(x#0, d#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, d#1: int :: { Mod(x#1, d#1) } d#1 > 0 ==> ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#1, d#1) == Mod(x#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModIsModRecursiveAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModIsModRecursiveAuto();



procedure {:verboseName "DivMod.LemmaModIsModRecursiveAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsModRecursiveAuto();
  modifies $Heap;
  free ensures (forall x#1: int, d#1: int :: { Mod(x#1, d#1) } d#1 > 0 ==> ModInternals.__default.ModRecursive#canCall(x#1, d#1));
  free ensures {:id "id12634"} (forall x#1: int, d#1: int :: { Mod(x#1, d#1) } d#1 > 0 ==> ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#1, d#1) == Mod(x#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModIsModRecursiveAuto (correctness)"} Impl$$DivMod.__default.LemmaModIsModRecursiveAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: int, d#1: int :: { Mod(x#1, d#1) } d#1 > 0 ==> ModInternals.__default.ModRecursive#canCall(x#1, d#1));
  free ensures {:id "id12635"} (forall x#1: int, d#1: int :: { Mod(x#1, d#1) } d#1 > 0 ==> ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#1, d#1) == Mod(x#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsModRecursiveAuto (correctness)"} Impl$$DivMod.__default.LemmaModIsModRecursiveAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var ##x#0_0: int;
  var ##d#0_0: int;
  var x##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsModRecursiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(992,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$ModInternals.__default.reveal__ModRecursive();
    call CallPost$$ModInternals.__default.reveal__ModRecursive();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(993,24)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, d#0_0;
    assume true;
    assume true;
    assume d#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##x#0_0 := x#0_0;
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##d#0_0 := d#0_0;
    assume $IsAlloc(##d#0_0, TInt, $Heap);
    assume {:subsumption 0} ##d#0_0 > 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0_0, d#0_0);
    assume {:subsumption 0} d#0_0 != 0;
    assume ModInternals.__default.ModRecursive#canCall(x#0_0, d#0_0);
    assume ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0_0, d#0_0) == Mod(x#0_0, d#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    m##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaModIsModRecursive(x##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModIsModRecursive(x##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(997,34)"} true;
    assume ModInternals.__default.ModRecursive($LS($LS($LZ)), reveal_ModInternals._default.ModRecursive, x#0_0, d#0_0) == Mod(x#0_0, d#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, d#0_1: int :: { ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0_1, d#0_1) } d#0_1 > 0 ==> ModInternals.__default.ModRecursive($LS($LZ), reveal_ModInternals._default.ModRecursive, x#0_1, d#0_1) == Mod(x#0_1, d#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(998,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModBasicsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModBasicsAuto();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModBasicsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModBasicsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0: int;
  var x#0: int;
  var m#2: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBasicsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1003,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1004,12): post-state"} true;
    havoc m#0;
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume m#0 > 0;
    assume m#0 != 0;
    assume Mod(m#0, m#0) == LitInt(0);
    goto anon4;

  anon8_Else:
    assume m#0 > 0 ==> Mod(m#0, m#0) == LitInt(0);
    goto anon4;

  anon4:
    assume (forall m#1: int :: { Mod(m#1, m#1) } m#1 > 0 ==> Mod(m#1, m#1) == LitInt(0));
    havoc x#0;
    havoc m#2;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume m#2 > 0;
    assume m#2 != 0;
    assume m#2 != 0;
    assume m#2 != 0;
    assume Mod(Mod(x#0, m#2), m#2) == Mod(x#0, m#2);
    goto anon7;

  anon9_Else:
    assume m#2 > 0 ==> Mod(Mod(x#0, m#2), m#2) == Mod(x#0, m#2);
    goto anon7;

  anon7:
    assume (forall x#1: int, m#3: int :: { Mod(Mod(x#1, m#3), m#3) } m#3 > 0 ==> Mod(Mod(x#1, m#3), m#3) == Mod(x#1, m#3));
    return;
}



procedure {:verboseName "DivMod.LemmaModBasicsAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModBasicsAuto();



procedure {:verboseName "DivMod.LemmaModBasicsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModBasicsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12657"} (forall m#1: int :: { Mod(m#1, m#1) } m#1 > 0 ==> Mod(m#1, m#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id12658"} (forall x#1: int, m#3: int :: { Mod(Mod(x#1, m#3), m#3) } m#3 > 0 ==> Mod(Mod(x#1, m#3), m#3) == Mod(x#1, m#3));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModBasicsAuto (correctness)"} Impl$$DivMod.__default.LemmaModBasicsAuto() returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12659"} (forall m#1: int :: { Mod(m#1, m#1) } m#1 > 0 ==> Mod(m#1, m#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id12660"} (forall x#1: int, m#3: int :: { Mod(Mod(x#1, m#3), m#3) } m#3 > 0 ==> Mod(Mod(x#1, m#3), m#3) == Mod(x#1, m#3));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModBasicsAuto (correctness)"} Impl$$DivMod.__default.LemmaModBasicsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0_0: int;
  var n##0_0: int;
  var x#1_0: int;
  var m#1_0: int;
  var n##1_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBasicsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1006,2): initial state"} true;
    $_reverifyPost := false;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc m#0_0;
    assume true;
    assume true;
    assume m#0_0 > 0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(m#0_0, m#0_0) == LitInt(0);
    assume false;
    goto anon3;

  anon12_Else:
    goto anon3;

  anon3:
    push;
    assume true;
    n##0_0 := m#0_0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0_0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1010,21)"} true;
    pop;
    assume Mod(m#0_0, m#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon11_Else:
    assume (forall m#0_1: int :: { Mod(m#0_1, m#0_1) } m#0_1 > 0 ==> Mod(m#0_1, m#0_1) == LitInt(0));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1011,4)"} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc x#1_0, m#1_0;
    assume true;
    assume true;
    assume m#1_0 > 0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} m#1_0 != 0;
    assume {:subsumption 0} m#1_0 != 0;
    assume {:subsumption 0} m#1_0 != 0;
    assume true;
    assume Mod(Mod(x#1_0, m#1_0), m#1_0) == Mod(x#1_0, m#1_0);
    assume false;
    goto anon8;

  anon14_Else:
    goto anon8;

  anon8:
    assume true;
    n##1_0 := m#1_0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##1_0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1015,21)"} true;
    assume Mod(Mod(x#1_0, m#1_0), m#1_0) == Mod(x#1_0, m#1_0);
    assume false;
    goto anon10;

  anon13_Else:
    assume (forall x#1_1: int, m#1_1: int :: { Mod(Mod(x#1_1, m#1_1), m#1_1) } m#1_1 > 0 ==> Mod(Mod(x#1_1, m#1_1), m#1_1) == Mod(x#1_1, m#1_1));
    goto anon10;

  anon10:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1016,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModPropertiesAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModPropertiesAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModPropertiesAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModPropertiesAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0: int;
  var x#0: int;
  var m#2: int;
  var x#2: int;
  var m#4: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPropertiesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1021,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1022,12): post-state"} true;
    havoc m#0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume m#0 > 0;
    assume m#0 != 0;
    assume Mod(m#0, m#0) == LitInt(0);
    goto anon4;

  anon13_Else:
    assume m#0 > 0 ==> Mod(m#0, m#0) == LitInt(0);
    goto anon4;

  anon4:
    assume (forall m#1: int :: { Mod(m#1, m#1) } m#1 > 0 ==> Mod(m#1, m#1) == LitInt(0));
    havoc x#0;
    havoc m#2;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume m#2 > 0;
    assume m#2 != 0;
    assume m#2 != 0;
    assume m#2 != 0;
    assume Mod(Mod(x#0, m#2), m#2) == Mod(x#0, m#2);
    goto anon7;

  anon14_Else:
    assume m#2 > 0 ==> Mod(Mod(x#0, m#2), m#2) == Mod(x#0, m#2);
    goto anon7;

  anon7:
    assume (forall x#1: int, m#3: int :: { Mod(Mod(x#1, m#3), m#3) } m#3 > 0 ==> Mod(Mod(x#1, m#3), m#3) == Mod(x#1, m#3));
    havoc x#2;
    havoc m#4;
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume m#4 > 0;
    assume m#4 != 0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} LitInt(0) <= Mod(x#2, m#4);
    assume m#4 != 0;
    goto anon10;

  anon16_Else:
    assume {:partition} Mod(x#2, m#4) < LitInt(0);
    goto anon10;

  anon10:
    assume LitInt(0) <= Mod(x#2, m#4) && Mod(x#2, m#4) < m#4;
    goto anon12;

  anon15_Else:
    assume m#4 > 0 ==> LitInt(0) <= Mod(x#2, m#4) && Mod(x#2, m#4) < m#4;
    goto anon12;

  anon12:
    assume (forall x#3: int, m#5: int :: { Mod(x#3, m#5) } (m#5 > 0 ==> LitInt(0) <= Mod(x#3, m#5)) && (m#5 > 0 ==> Mod(x#3, m#5) < m#5));
    return;
}



procedure {:verboseName "DivMod.LemmaModPropertiesAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModPropertiesAuto();



procedure {:verboseName "DivMod.LemmaModPropertiesAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModPropertiesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12693"} (forall m#1: int :: { Mod(m#1, m#1) } m#1 > 0 ==> Mod(m#1, m#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id12694"} (forall x#1: int, m#3: int :: { Mod(Mod(x#1, m#3), m#3) } m#3 > 0 ==> Mod(Mod(x#1, m#3), m#3) == Mod(x#1, m#3));
  free ensures true;
  free ensures {:id "id12695"} (forall x#3: int, m#5: int :: { Mod(x#3, m#5) } (m#5 > 0 ==> LitInt(0) <= Mod(x#3, m#5)) && (m#5 > 0 ==> Mod(x#3, m#5) < m#5));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModPropertiesAuto (correctness)"} Impl$$DivMod.__default.LemmaModPropertiesAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12696"} (forall m#1: int :: { Mod(m#1, m#1) } m#1 > 0 ==> Mod(m#1, m#1) == LitInt(0));
  free ensures true;
  free ensures {:id "id12697"} (forall x#1: int, m#3: int :: { Mod(Mod(x#1, m#3), m#3) } m#3 > 0 ==> Mod(Mod(x#1, m#3), m#3) == Mod(x#1, m#3));
  free ensures true;
  free ensures {:id "id12698"} (forall x#3: int, m#5: int :: { Mod(x#3, m#5) } (m#5 > 0 ==> LitInt(0) <= Mod(x#3, m#5)) && (m#5 > 0 ==> Mod(x#3, m#5) < m#5));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModPropertiesAuto (correctness)"} Impl$$DivMod.__default.LemmaModPropertiesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var m#0_0: int;
  var n##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPropertiesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1025,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivMod.__default.LemmaModBasicsAuto();
    call CallPost$$DivMod.__default.LemmaModBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1026,24)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, m#0_0;
    assume true;
    assume true;
    assume m#0_0 > 0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:subsumption 0} m#0_0 != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= Mod(x#0_0, m#0_0);
    assume {:subsumption 0} m#0_0 != 0;
    goto anon4;

  anon10_Else:
    assume {:partition} Mod(x#0_0, m#0_0) < LitInt(0);
    goto anon4;

  anon4:
    assume true;
    assume LitInt(0) <= Mod(x#0_0, m#0_0) && Mod(x#0_0, m#0_0) < m#0_0;
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    n##0_0 := m#0_0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0_0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1031,21)"} true;
    assume LitInt(0) <= Mod(x#0_0, m#0_0);
    assume Mod(x#0_0, m#0_0) < m#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, m#0_1: int :: { Mod(x#0_1, m#0_1) } m#0_1 > 0 ==> LitInt(0) <= Mod(x#0_1, m#0_1) && Mod(x#0_1, m#0_1) < m#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1032,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModDecreases (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModDecreases(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModDecreases (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModDecreases(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModDecreases", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1037,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1039,18): post-state"} true;
    assume m#0 != 0;
    assume Mod(x#0, m#0) <= x#0;
    return;
}



procedure {:verboseName "DivMod.LemmaModDecreases (call precondtion)"} CallPre$$DivMod.__default.LemmaModDecreases(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  requires {:id "id12712"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaModDecreases (call postcondition)"} CallPost$$DivMod.__default.LemmaModDecreases(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12713"} Mod(x#0, m#0) <= x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModDecreases (correctness)"} Impl$$DivMod.__default.LemmaModDecreases(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12714"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12715"} Mod(x#0, m#0) <= x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModDecreases (correctness)"} Impl$$DivMod.__default.LemmaModDecreases(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModDecreases", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1040,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1041,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModDecreasesAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModDecreasesAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModDecreasesAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModDecreasesAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModDecreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1044,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1045,12): post-state"} true;
    havoc x#0;
    havoc m#0;
    assume LitInt(0) <= x#0 && LitInt(0) <= m#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume Mod(x#0, m#0) <= x#0;
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(x#0, m#0) <= x#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, m#1: int :: { Mod(x#1, m#1) } LitInt(0) <= x#1 && LitInt(0) <= m#1 ==> 0 < m#1 ==> Mod(x#1, m#1) <= x#1);
    return;
}



procedure {:verboseName "DivMod.LemmaModDecreasesAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModDecreasesAuto();



procedure {:verboseName "DivMod.LemmaModDecreasesAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModDecreasesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12723"} (forall x#1: int, m#1: int :: { Mod(x#1, m#1) } LitInt(0) <= x#1 && LitInt(0) <= m#1 ==> 0 < m#1 ==> Mod(x#1, m#1) <= x#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModDecreasesAuto (correctness)"} Impl$$DivMod.__default.LemmaModDecreasesAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12724"} (forall x#1: int, m#1: int :: { Mod(x#1, m#1) } LitInt(0) <= x#1 && LitInt(0) <= m#1 ==> 0 < m#1 ==> Mod(x#1, m#1) <= x#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModDecreasesAuto (correctness)"} Impl$$DivMod.__default.LemmaModDecreasesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModDecreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1046,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, m#0_0;
    assume LitInt(0) <= x#0_0 && LitInt(0) <= m#0_0;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(x#0_0, m#0_0) <= x#0_0;
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModDecreases(x##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModDecreases(x##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1050,29)"} true;
    assume Mod(x#0_0, m#0_0) <= x#0_0;
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, m#0_1: int :: { Mod(x#0_1, m#0_1) } LitInt(0) <= x#0_1 && LitInt(0) <= m#0_1 && 0 < m#0_1 ==> Mod(x#0_1, m#0_1) <= x#0_1);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1051,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModIsZero (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsZero(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsZero (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsZero(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsZero", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1055,8): initial state"} true;
    assume x#0 > 0;
    assume m#0 > 0;
    assume m#0 != 0;
    assume Mod(x#0, m#0) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1058,14): post-state"} true;
    assume x#0 >= m#0;
    return;
}



procedure {:verboseName "DivMod.LemmaModIsZero (call precondtion)"} CallPre$$DivMod.__default.LemmaModIsZero(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  requires {:id "id12736"} x#0 > 0;
  requires {:id "id12737"} m#0 > 0;
  requires {:id "id12738"} Mod(x#0, m#0) == LitInt(0);



procedure {:verboseName "DivMod.LemmaModIsZero (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsZero(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12739"} x#0 >= m#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModIsZero (correctness)"} Impl$$DivMod.__default.LemmaModIsZero(x#0: int where LitInt(0) <= x#0, m#0: int where LitInt(0) <= m#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id12740"} x#0 > 0;
  requires {:id "id12741"} m#0 > 0;
  requires {:id "id12742"} Mod(x#0, m#0) == LitInt(0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12743"} x#0 >= m#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsZero (correctness)"} Impl$$DivMod.__default.LemmaModIsZero(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0_1_0: int;
  var m##0_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsZero", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1059,2): initial state"} true;
    $_reverifyPost := false;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume true;
    assume false;
    goto anon4;

  anon5_Else:
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume true;
    assume x#0 < m#0;
    assume true;
    x##0_1_0 := x#0;
    assume true;
    m##0_1_0 := m#0;
    call CallPre$$DivMod.__default.LemmaSmallMod(x##0_1_0, m##0_1_0);
    call CallPost$$DivMod.__default.LemmaSmallMod(x##0_1_0, m##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1062,27)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume {:subsumption 0} x#0 < m#0 ==> Mod(x#0, m#0) == x#0;
    assume false;
    goto anon4;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0 != 0;
    assume true;
    assume Mod(x#0, m#0) == x#0;
    assume true;
    assume {:subsumption 0} Mod(x#0, m#0) == x#0 ==> Lit(false);
    assume false;
    goto anon4;

  anon7_Else:
    goto anon4;

  anon4:
    assume x#0 < m#0 ==> false;
    return;
}



procedure {:verboseName "DivMod.LemmaModIsZeroAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsZeroAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsZeroAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModIsZeroAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0: int;
  var x#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsZeroAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1068,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1069,12): post-state"} true;
    havoc m#0;
    havoc x#0;
    assume LitInt(0) <= m#0 && LitInt(0) <= x#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} x#0 > 0;
    goto anon4;

  anon10_Else:
    assume {:partition} 0 >= x#0;
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#0 > 0 && m#0 > 0;
    assume m#0 != 0;
    goto anon6;

  anon11_Else:
    assume {:partition} !(x#0 > 0 && m#0 > 0);
    goto anon6;

  anon6:
    assume x#0 > 0 && m#0 > 0 && Mod(x#0, m#0) == LitInt(0);
    assume x#0 >= m#0;
    goto anon8;

  anon9_Else:
    assume x#0 > 0 && m#0 > 0 && Mod(x#0, m#0) == LitInt(0) ==> x#0 >= m#0;
    goto anon8;

  anon8:
    assume (forall m#1: int, x#1: int :: { Mod(x#1, m#1) } LitInt(0) <= m#1 && LitInt(0) <= x#1 ==> x#1 > 0 && m#1 > 0 && Mod(x#1, m#1) == LitInt(0) ==> x#1 >= m#1);
    return;
}



procedure {:verboseName "DivMod.LemmaModIsZeroAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModIsZeroAuto();



procedure {:verboseName "DivMod.LemmaModIsZeroAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsZeroAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12758"} (forall m#1: int, x#1: int :: { Mod(x#1, m#1) } LitInt(0) <= m#1 && LitInt(0) <= x#1 ==> x#1 > 0 && m#1 > 0 && Mod(x#1, m#1) == LitInt(0) ==> x#1 >= m#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModIsZeroAuto (correctness)"} Impl$$DivMod.__default.LemmaModIsZeroAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12759"} (forall m#1: int, x#1: int :: { Mod(x#1, m#1) } LitInt(0) <= m#1 && LitInt(0) <= x#1 ==> x#1 > 0 && m#1 > 0 && Mod(x#1, m#1) == LitInt(0) ==> x#1 >= m#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModIsZeroAuto (correctness)"} Impl$$DivMod.__default.LemmaModIsZeroAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsZeroAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1071,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, m#0_0;
    assume LitInt(0) <= x#0_0 && LitInt(0) <= m#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#0_0 > 0;
    goto anon3;

  anon11_Else:
    assume {:partition} 0 >= x#0_0;
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} x#0_0 > 0 && m#0_0 > 0;
    assume {:subsumption 0} m#0_0 != 0;
    goto anon5;

  anon12_Else:
    assume {:partition} !(x#0_0 > 0 && m#0_0 > 0);
    goto anon5;

  anon5:
    assume true;
    assume x#0_0 > 0 && m#0_0 > 0 && Mod(x#0_0, m#0_0) == LitInt(0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume true;
    assume x#0_0 >= m#0_0;
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModIsZero(x##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModIsZero(x##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1075,26)"} true;
    assume x#0_0 >= m#0_0;
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, m#0_1: int :: { Mod(x#0_1, m#0_1) } LitInt(0) <= x#0_1 && LitInt(0) <= m#0_1 && x#0_1 > 0 && m#0_1 > 0 && Mod(x#0_1, m#0_1) == LitInt(0) ==> x#0_1 >= m#0_1);
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1076,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesBasic (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesBasic (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesBasic", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1080,8): initial state"} true;
    assume m#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1082,24): post-state"} true;
    assume m#0 != 0;
    assume Mod(Mul(x#0, m#0), m#0) == LitInt(0);
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesBasic (call precondtion)"} CallPre$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int);
  requires {:id "id12769"} m#0 > 0;



procedure {:verboseName "DivMod.LemmaModMultiplesBasic (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12770"} Mod(Mul(x#0, m#0), m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMultiplesBasic (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12771"} m#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12772"} Mod(Mul(x#0, m#0), m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesBasic (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesBasic", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1083,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1084,19)"} true;
    assume true;
    x##0 := x#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume m#0 != 0;
    assume lambdaResult#0 <==> Mod(Mul(u#0, m#0), m#0) == LitInt(0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mod(Mul($Unbox($l#1#u#0): int, m#0), m#0) == LitInt(0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1085,51)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesBasicAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesBasicAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesBasicAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesBasicAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesBasicAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1088,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1089,12): post-state"} true;
    havoc x#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume m#0 > 0;
    assume m#0 != 0;
    assume Mod(Mul(x#0, m#0), m#0) == LitInt(0);
    goto anon4;

  anon5_Else:
    assume m#0 > 0 ==> Mod(Mul(x#0, m#0), m#0) == LitInt(0);
    goto anon4;

  anon4:
    assume (forall x#1: int, m#1: int :: { Mod(Mul(x#1, m#1), m#1) } m#1 > 0 ==> Mod(Mul(x#1, m#1), m#1) == LitInt(0));
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesBasicAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModMultiplesBasicAuto();



procedure {:verboseName "DivMod.LemmaModMultiplesBasicAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesBasicAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12784"} (forall x#1: int, m#1: int :: { Mod(Mul(x#1, m#1), m#1) } m#1 > 0 ==> Mod(Mul(x#1, m#1), m#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMultiplesBasicAuto (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesBasicAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12785"} (forall x#1: int, m#1: int :: { Mod(Mul(x#1, m#1), m#1) } m#1 > 0 ==> Mod(Mul(x#1, m#1), m#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesBasicAuto (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesBasicAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesBasicAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1090,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, m#0_0;
    assume true;
    assume true;
    assume m#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mul(x#0_0, m#0_0), m#0_0) == LitInt(0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModMultiplesBasic(x##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModMultiplesBasic(x##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1094,34)"} true;
    assume Mod(Mul(x#0_0, m#0_0), m#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, m#0_1: int :: { Mul(x#0_1, m#0_1) } m#0_1 > 0 ==> Mod(Mul(x#0_1, m#0_1), m#0_1) == LitInt(0));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1095,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAddMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddMultiplesVanish", " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1100,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1102,24): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(m#0 + b#0, m#0) == Mod(b#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanish (call precondtion)"} CallPre$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int);
  requires {:id "id12796"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12797"} Mod(m#0 + b#0, m#0) == Mod(b#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12798"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12799"} Mod(m#0 + b#0, m#0) == Mod(b#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAddMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddMultiplesVanish", " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1103,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1104,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAddMultiplesVanishAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAddMultiplesVanishAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1107,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1108,12): post-state"} true;
    havoc b#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(m#0 + b#0, m#0) == Mod(b#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(m#0 + b#0, m#0) == Mod(b#0, m#0);
    goto anon4;

  anon4:
    assume (forall b#1: int, m#1: int :: { Mod(b#1, m#1) } 0 < m#1 ==> Mod(m#1 + b#1, m#1) == Mod(b#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModAddMultiplesVanishAuto();



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModAddMultiplesVanishAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12808"} (forall b#1: int, m#1: int :: { Mod(b#1, m#1) } 0 < m#1 ==> Mod(m#1 + b#1, m#1) == Mod(b#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaModAddMultiplesVanishAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12809"} (forall b#1: int, m#1: int :: { Mod(b#1, m#1) } 0 < m#1 ==> Mod(m#1 + b#1, m#1) == Mod(b#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaModAddMultiplesVanishAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var m#0_0: int;
  var b##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1109,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(m#0_0 + b#0_0, m#0_0) == Mod(b#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModAddMultiplesVanish(b##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModAddMultiplesVanish(b##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1113,38)"} true;
    assume Mod(m#0_0 + b#0_0, m#0_0) == Mod(b#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int, m#0_1: int, _t#0#0_0: int :: { Mod(b#0_1, m#0_1), Mod(_t#0#0_0, m#0_1) } _t#0#0_0 == m#0_1 + b#0_1 && 0 < m#0_1 ==> Mod(_t#0#0_0, m#0_1) == Mod(b#0_1, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1114,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubMultiplesVanish", " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1119,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1121,25): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(0 - m#0 + b#0, m#0) == Mod(b#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanish (call precondtion)"} CallPre$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int);
  requires {:id "id12821"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12822"} Mod(0 - m#0 + b#0, m#0) == Mod(b#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12823"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12824"} Mod(0 - m#0 + b#0, m#0) == Mod(b#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubMultiplesVanish", " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1122,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1123,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubMultiplesVanishAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubMultiplesVanishAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1126,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1127,12): post-state"} true;
    havoc b#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(0 - m#0 + b#0, m#0) == Mod(b#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(0 - m#0 + b#0, m#0) == Mod(b#0, m#0);
    goto anon4;

  anon4:
    assume (forall b#1: int, m#1: int :: { Mod(b#1, m#1) } 0 < m#1 ==> Mod(0 - m#1 + b#1, m#1) == Mod(b#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModSubMultiplesVanishAuto();



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubMultiplesVanishAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12833"} (forall b#1: int, m#1: int :: { Mod(b#1, m#1) } 0 < m#1 ==> Mod(0 - m#1 + b#1, m#1) == Mod(b#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaModSubMultiplesVanishAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12834"} (forall b#1: int, m#1: int :: { Mod(b#1, m#1) } 0 < m#1 ==> Mod(0 - m#1 + b#1, m#1) == Mod(b#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaModSubMultiplesVanishAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var m#0_0: int;
  var b##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1128,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(0 - m#0_0 + b#0_0, m#0_0) == Mod(b#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModSubMultiplesVanish(b##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModSubMultiplesVanish(b##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1132,38)"} true;
    assume Mod(0 - m#0_0 + b#0_0, m#0_0) == Mod(b#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int, m#0_1: int, _t#0#0_0: int :: { Mod(b#0_1, m#0_1), Mod(_t#0#0_0, m#0_1) } _t#0#0_0 == 0 - m#0_1 + b#0_1 && 0 < m#0_1 ==> Mod(_t#0#0_0, m#0_1) == Mod(b#0_1, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1133,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesVanish (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesVanish", " | ", a#0, " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1138,8): initial state"} true;
    assume 0 < m#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} a#0 > 0;
    goto anon4;

  anon5_Else:
    assume {:partition} 0 >= a#0;
    goto anon4;

  anon4:
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1141,28): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(m#0, a#0) + b#0, m#0) == Mod(b#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesVanish (call precondtion)"} CallPre$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int);
  requires {:id "id12846"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaModMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12847"} Mod(Mul(m#0, a#0) + b#0, m#0) == Mod(b#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12848"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12849"} Mod(Mul(m#0, a#0) + b#0, m#0) == Mod(b#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesVanish (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesVanish", " | ", a#0, " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1142,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1143,19)"} true;
    assume true;
    x##0 := a#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume m#0 != 0;
    assume m#0 != 0;
    assume lambdaResult#0 <==> Mod(Mul(m#0, u#0) + b#0, m#0) == Mod(b#0, m#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mod(Mul(m#0, $Unbox($l#1#u#0): int) + b#0, m#0) == Mod(b#0, m#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1144,59)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesVanishAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesVanishAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMultiplesVanishAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1147,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1148,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(m#0, a#0) + b#0, m#0) == Mod(b#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(Mul(m#0, a#0) + b#0, m#0) == Mod(b#0, m#0);
    goto anon4;

  anon4:
    assume (forall a#1: int, b#1: int, m#1: int :: { Mod(Mul(m#1, a#1) + b#1, m#1) } 0 < m#1 ==> Mod(Mul(m#1, a#1) + b#1, m#1) == Mod(b#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModMultiplesVanishAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModMultiplesVanishAuto();



procedure {:verboseName "DivMod.LemmaModMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesVanishAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12863"} (forall a#1: int, b#1: int, m#1: int :: { Mod(Mul(m#1, a#1) + b#1, m#1) } 0 < m#1 ==> Mod(Mul(m#1, a#1) + b#1, m#1) == Mod(b#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesVanishAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12864"} (forall a#1: int, b#1: int, m#1: int :: { Mod(Mul(m#1, a#1) + b#1, m#1) } 0 < m#1 ==> Mod(Mul(m#1, a#1) + b#1, m#1) == Mod(b#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMultiplesVanishAuto (correctness)"} Impl$$DivMod.__default.LemmaModMultiplesVanishAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var m#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1149,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc a#0_0, b#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mul(m#0_0, a#0_0) + b#0_0, m#0_0) == Mod(b#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModMultiplesVanish(a##0_0, b##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModMultiplesVanish(a##0_0, b##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1153,38)"} true;
    assume Mod(Mul(m#0_0, a#0_0) + b#0_0, m#0_0) == Mod(b#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall a#0_1: int, b#0_1: int, m#0_1: int, _t#0#0_0: int :: { Mod(b#0_1, m#0_1), Mod(_t#0#0_0, m#0_1), Mul(m#0_1, a#0_1) } _t#0#0_0 == Mul(m#0_1, a#0_1) + b#0_1 && 0 < m#0_1 ==> Mod(_t#0#0_0, m#0_1) == Mod(b#0_1, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1154,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModSubtraction (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubtraction(x#0: int where LitInt(0) <= x#0, s#0: int where LitInt(0) <= s#0, d#0: int where LitInt(0) <= d#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubtraction (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubtraction(x#0: int, s#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubtraction", " | ", x#0, " | ", s#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1158,8): initial state"} true;
    assume 0 < d#0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= s#0;
    assume d#0 != 0;
    goto anon3;

  anon4_Else:
    assume {:partition} s#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= s#0 && s#0 <= Mod(x#0, d#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1161,26): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(x#0, d#0) - Mod(s#0, d#0) == Mod(x#0 - s#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModSubtraction (call precondtion)"} CallPre$$DivMod.__default.LemmaModSubtraction(x#0: int where LitInt(0) <= x#0, s#0: int where LitInt(0) <= s#0, d#0: int where LitInt(0) <= d#0);
  requires {:id "id12879"} 0 < d#0;
  requires {:id "id12880"} LitInt(0) <= s#0;
  requires {:id "id12881"} s#0 <= Mod(x#0, d#0);



procedure {:verboseName "DivMod.LemmaModSubtraction (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubtraction(x#0: int where LitInt(0) <= x#0, s#0: int where LitInt(0) <= s#0, d#0: int where LitInt(0) <= d#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12882"} Mod(x#0, d#0) - Mod(s#0, d#0) == Mod(x#0 - s#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModSubtraction (correctness)"} Impl$$DivMod.__default.LemmaModSubtraction(x#0: int where LitInt(0) <= x#0, s#0: int where LitInt(0) <= s#0, d#0: int where LitInt(0) <= d#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12883"} 0 < d#0;
  requires {:id "id12884"} LitInt(0) <= s#0;
  requires {:id "id12885"} s#0 <= Mod(x#0, d#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12886"} Mod(x#0, d#0) - Mod(s#0, d#0) == Mod(x#0 - s#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubtraction (correctness)"} Impl$$DivMod.__default.LemmaModSubtraction(x#0: int, s#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubtraction", " | ", x#0, " | ", s#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1162,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1163,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModSubtractionAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubtractionAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubtractionAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModSubtractionAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var s#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubtractionAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1166,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1167,12): post-state"} true;
    havoc x#0;
    havoc s#0;
    havoc d#0;
    assume LitInt(0) <= x#0 && LitInt(0) <= s#0 && LitInt(0) <= d#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume 0 < d#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= s#0;
    assume d#0 != 0;
    goto anon4;

  anon8_Else:
    assume {:partition} s#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= s#0 && s#0 <= Mod(x#0, d#0);
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(x#0, d#0) - Mod(s#0, d#0) == Mod(x#0 - s#0, d#0);
    goto anon6;

  anon7_Else:
    assume 0 < d#0 && LitInt(0) <= s#0 && s#0 <= Mod(x#0, d#0) ==> Mod(x#0, d#0) - Mod(s#0, d#0) == Mod(x#0 - s#0, d#0);
    goto anon6;

  anon6:
    assume (forall x#1: int, s#1: int, d#1: int :: { Mod(x#1 - s#1, d#1) } LitInt(0) <= x#1 && LitInt(0) <= s#1 && LitInt(0) <= d#1 ==> 0 < d#1 && LitInt(0) <= s#1 && s#1 <= Mod(x#1, d#1) ==> Mod(x#1, d#1) - Mod(s#1, d#1) == Mod(x#1 - s#1, d#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModSubtractionAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModSubtractionAuto();



procedure {:verboseName "DivMod.LemmaModSubtractionAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubtractionAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12898"} (forall x#1: int, s#1: int, d#1: int :: { Mod(x#1 - s#1, d#1) } LitInt(0) <= x#1 && LitInt(0) <= s#1 && LitInt(0) <= d#1 ==> 0 < d#1 && LitInt(0) <= s#1 && s#1 <= Mod(x#1, d#1) ==> Mod(x#1, d#1) - Mod(s#1, d#1) == Mod(x#1 - s#1, d#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModSubtractionAuto (correctness)"} Impl$$DivMod.__default.LemmaModSubtractionAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12899"} (forall x#1: int, s#1: int, d#1: int :: { Mod(x#1 - s#1, d#1) } LitInt(0) <= x#1 && LitInt(0) <= s#1 && LitInt(0) <= d#1 ==> 0 < d#1 && LitInt(0) <= s#1 && s#1 <= Mod(x#1, d#1) ==> Mod(x#1, d#1) - Mod(s#1, d#1) == Mod(x#1 - s#1, d#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModSubtractionAuto (correctness)"} Impl$$DivMod.__default.LemmaModSubtractionAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var s#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var s##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubtractionAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1169,2): initial state"} true;
    $_reverifyPost := false;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc x#0_0, s#0_0, d#0_0;
    assume LitInt(0) <= x#0_0 && LitInt(0) <= s#0_0 && LitInt(0) <= d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} 0 < d#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= s#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon4;

  anon11_Else:
    assume {:partition} s#0_0 < LitInt(0);
    goto anon4;

  anon10_Else:
    assume {:partition} d#0_0 <= 0;
    goto anon4;

  anon4:
    assume true;
    assume 0 < d#0_0 && LitInt(0) <= s#0_0 && s#0_0 <= Mod(x#0_0, d#0_0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume true;
    assume Mod(x#0_0, d#0_0) - Mod(s#0_0, d#0_0) == Mod(x#0_0 - s#0_0, d#0_0);
    assume false;
    goto anon6;

  anon12_Else:
    goto anon6;

  anon6:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    s##0_0 := s#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaModSubtraction(x##0_0, s##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaModSubtraction(x##0_0, s##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1173,34)"} true;
    assume Mod(x#0_0, d#0_0) - Mod(s#0_0, d#0_0) == Mod(x#0_0 - s#0_0, d#0_0);
    assume false;
    goto anon8;

  anon9_Else:
    assume (forall x#0_1: int, s#0_1: int, d#0_1: int, _t#0#0_0: int :: { Mod(_t#0#0_0, d#0_1), Mod(s#0_1, d#0_1), Mod(x#0_1, d#0_1) } LitInt(0) <= x#0_1 && LitInt(0) <= s#0_1 && LitInt(0) <= d#0_1 && _t#0#0_0 == x#0_1 - s#0_1 && 0 < d#0_1 && LitInt(0) <= s#0_1 && s#0_1 <= Mod(x#0_1, d#0_1) ==> Mod(x#0_1, d#0_1) - Mod(s#0_1, d#0_1) == Mod(_t#0#0_0, d#0_1));
    goto anon8;

  anon8:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1174,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoop (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoop (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1178,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1180,36): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mod(x#0, m#0) + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoop (call precondtion)"} CallPre$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int);
  requires {:id "id12915"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaAddModNoop (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12916"} Mod(Mod(x#0, m#0) + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaAddModNoop (correctness)"} Impl$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12917"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12918"} Mod(Mod(x#0, m#0) + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoop (correctness)"} Impl$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1181,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1182,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoopAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoopAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoopAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoopAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1185,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1186,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mod(x#0, m#0) + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(Mod(x#0, m#0) + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 + y#1, m#1) } 0 < m#1 ==> Mod(Mod(x#1, m#1) + Mod(y#1, m#1), m#1) == Mod(x#1 + y#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoopAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaAddModNoopAuto();



procedure {:verboseName "DivMod.LemmaAddModNoopAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoopAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12929"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 + y#1, m#1) } 0 < m#1 ==> Mod(Mod(x#1, m#1) + Mod(y#1, m#1), m#1) == Mod(x#1 + y#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaAddModNoopAuto (correctness)"} Impl$$DivMod.__default.LemmaAddModNoopAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12930"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 + y#1, m#1) } 0 < m#1 ==> Mod(Mod(x#1, m#1) + Mod(y#1, m#1), m#1) == Mod(x#1 + y#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoopAuto (correctness)"} Impl$$DivMod.__default.LemmaAddModNoopAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1188,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mod(x#0_0, m#0_0) + Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 + y#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaAddModNoop(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaAddModNoop(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1192,30)"} true;
    assume Mod(Mod(x#0_0, m#0_0) + Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 + y#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int, _t#0#0_0: int, _t#1#0_0: int :: { Mod(_t#1#0_0, m#0_1), Mod(_t#0#0_0, m#0_1), Mod(y#0_1, m#0_1), Mod(x#0_1, m#0_1) } _t#1#0_0 == x#0_1 + y#0_1 && _t#0#0_0 == Mod(x#0_1, m#0_1) + Mod(y#0_1, m#0_1) && 0 < m#0_1 ==> Mod(_t#0#0_0, m#0_1) == Mod(_t#1#0_0, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1193,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoopRight (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoopRight (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1197,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1199,30): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(x#0 + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoopRight (call precondtion)"} CallPre$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int);
  requires {:id "id12945"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaAddModNoopRight (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12946"} Mod(x#0 + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaAddModNoopRight (correctness)"} Impl$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12947"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12948"} Mod(x#0 + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoopRight (correctness)"} Impl$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1200,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1201,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoopRightAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoopRightAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoopRightAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaAddModNoopRightAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopRightAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1204,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1205,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(x#0 + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(x#0 + Mod(y#0, m#0), m#0) == Mod(x#0 + y#0, m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 + y#1, m#1) } 0 < m#1 ==> Mod(x#1 + Mod(y#1, m#1), m#1) == Mod(x#1 + y#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaAddModNoopRightAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaAddModNoopRightAuto();



procedure {:verboseName "DivMod.LemmaAddModNoopRightAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoopRightAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12958"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 + y#1, m#1) } 0 < m#1 ==> Mod(x#1 + Mod(y#1, m#1), m#1) == Mod(x#1 + y#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaAddModNoopRightAuto (correctness)"} Impl$$DivMod.__default.LemmaAddModNoopRightAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12959"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 + y#1, m#1) } 0 < m#1 ==> Mod(x#1 + Mod(y#1, m#1), m#1) == Mod(x#1 + y#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaAddModNoopRightAuto (correctness)"} Impl$$DivMod.__default.LemmaAddModNoopRightAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopRightAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1207,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(x#0_0 + Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 + y#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaAddModNoopRight(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaAddModNoopRight(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1211,35)"} true;
    assume Mod(x#0_0 + Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 + y#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int :: { Mod(x#0_1 + y#0_1, m#0_1) } 0 < m#0_1 ==> Mod(x#0_1 + Mod(y#0_1, m#0_1), m#0_1) == Mod(x#0_1 + y#0_1, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1212,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoop (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoop (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1216,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1218,36): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mod(x#0, m#0) - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoop (call precondtion)"} CallPre$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int);
  requires {:id "id12974"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaSubModNoop (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12975"} Mod(Mod(x#0, m#0) - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaSubModNoop (correctness)"} Impl$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id12976"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12977"} Mod(Mod(x#0, m#0) - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoop (correctness)"} Impl$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1219,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1220,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoopAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoopAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoopAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoopAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1223,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1224,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mod(x#0, m#0) - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(Mod(x#0, m#0) - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 - y#1, m#1) } 0 < m#1 ==> Mod(Mod(x#1, m#1) - Mod(y#1, m#1), m#1) == Mod(x#1 - y#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoopAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaSubModNoopAuto();



procedure {:verboseName "DivMod.LemmaSubModNoopAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoopAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12988"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 - y#1, m#1) } 0 < m#1 ==> Mod(Mod(x#1, m#1) - Mod(y#1, m#1), m#1) == Mod(x#1 - y#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaSubModNoopAuto (correctness)"} Impl$$DivMod.__default.LemmaSubModNoopAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id12989"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 - y#1, m#1) } 0 < m#1 ==> Mod(Mod(x#1, m#1) - Mod(y#1, m#1), m#1) == Mod(x#1 - y#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoopAuto (correctness)"} Impl$$DivMod.__default.LemmaSubModNoopAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1226,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mod(x#0_0, m#0_0) - Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 - y#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaSubModNoop(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaSubModNoop(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1230,30)"} true;
    assume Mod(Mod(x#0_0, m#0_0) - Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 - y#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int, _t#0#0_0: int, _t#1#0_0: int :: { Mod(_t#1#0_0, m#0_1), Mod(_t#0#0_0, m#0_1), Mod(y#0_1, m#0_1), Mod(x#0_1, m#0_1) } _t#1#0_0 == x#0_1 - y#0_1 && _t#0#0_0 == Mod(x#0_1, m#0_1) - Mod(y#0_1, m#0_1) && 0 < m#0_1 ==> Mod(_t#0#0_0, m#0_1) == Mod(_t#1#0_0, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1231,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoopRight (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoopRight (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1235,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1237,30): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(x#0 - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoopRight (call precondtion)"} CallPre$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int);
  requires {:id "id13004"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaSubModNoopRight (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13005"} Mod(x#0 - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaSubModNoopRight (correctness)"} Impl$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13006"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13007"} Mod(x#0 - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoopRight (correctness)"} Impl$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1238,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1239,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoopRightAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoopRightAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoopRightAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaSubModNoopRightAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopRightAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1242,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1243,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(x#0 - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(x#0 - Mod(y#0, m#0), m#0) == Mod(x#0 - y#0, m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 - y#1, m#1) } 0 < m#1 ==> Mod(x#1 - Mod(y#1, m#1), m#1) == Mod(x#1 - y#1, m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaSubModNoopRightAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaSubModNoopRightAuto();



procedure {:verboseName "DivMod.LemmaSubModNoopRightAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoopRightAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13017"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 - y#1, m#1) } 0 < m#1 ==> Mod(x#1 - Mod(y#1, m#1), m#1) == Mod(x#1 - y#1, m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaSubModNoopRightAuto (correctness)"} Impl$$DivMod.__default.LemmaSubModNoopRightAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13018"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1 - y#1, m#1) } 0 < m#1 ==> Mod(x#1 - Mod(y#1, m#1), m#1) == Mod(x#1 - y#1, m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaSubModNoopRightAuto (correctness)"} Impl$$DivMod.__default.LemmaSubModNoopRightAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopRightAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1245,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(x#0_0 - Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 - y#0_0, m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaSubModNoopRight(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaSubModNoopRight(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1249,35)"} true;
    assume Mod(x#0_0 - Mod(y#0_0, m#0_0), m#0_0) == Mod(x#0_0 - y#0_0, m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int :: { Mod(x#0_1 - y#0_1, m#0_1) } 0 < m#0_1 ==> Mod(x#0_1 - Mod(y#0_1, m#0_1), m#0_1) == Mod(x#0_1 - y#0_1, m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1250,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModAdds (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAdds (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAdds", " | ", a#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1254,8): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1256,26): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0) + Mul(d#0, Div(Mod(a#0, d#0) + Mod(b#0, d#0), d#0));
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(a#0, d#0) + Mod(b#0, d#0) < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0);
    return;

  anon4_Else:
    assume Mod(a#0, d#0) + Mod(b#0, d#0) < d#0 ==> Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModAdds (call precondtion)"} CallPre$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int);
  requires {:id "id13043"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaModAdds (call postcondition)"} CallPost$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13044"} Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0) + Mul(d#0, Div(Mod(a#0, d#0) + Mod(b#0, d#0), d#0));
  free ensures true;
  free ensures {:id "id13045"} Mod(a#0, d#0) + Mod(b#0, d#0) < d#0 ==> Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModAdds (correctness)"} Impl$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13046"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13047"} Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0) + Mul(d#0, Div(Mod(a#0, d#0) + Mod(b#0, d#0), d#0));
  free ensures true;
  free ensures {:id "id13048"} Mod(a#0, d#0) + Mod(b#0, d#0) < d#0 ==> Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAdds (correctness)"} Impl$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAdds", " | ", a#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1258,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1259,18)"} true;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1260,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModAddsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAddsAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAddsAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModAddsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0: int;
  var b#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1263,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1264,12): post-state"} true;
    havoc a#0;
    havoc b#0;
    havoc d#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume 0 < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0) + Mul(d#0, Div(Mod(a#0, d#0) + Mod(b#0, d#0), d#0));
    assume d#0 != 0;
    assume d#0 != 0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Mod(a#0, d#0) + Mod(b#0, d#0) < d#0;
    assume d#0 != 0;
    assume d#0 != 0;
    assume d#0 != 0;
    goto anon4;

  anon8_Else:
    assume {:partition} d#0 <= Mod(a#0, d#0) + Mod(b#0, d#0);
    goto anon4;

  anon4:
    assume Mod(a#0, d#0) + Mod(b#0, d#0) < d#0 ==> Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0);
    goto anon6;

  anon7_Else:
    assume 0 < d#0 ==> Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0) + Mul(d#0, Div(Mod(a#0, d#0) + Mod(b#0, d#0), d#0)) && (Mod(a#0, d#0) + Mod(b#0, d#0) < d#0 ==> Mod(a#0, d#0) + Mod(b#0, d#0) == Mod(a#0 + b#0, d#0));
    goto anon6;

  anon6:
    assume (forall a#1: int, b#1: int, d#1: int :: { Mod(a#1 + b#1, d#1) } (0 < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) == Mod(a#1 + b#1, d#1) + Mul(d#1, Div(Mod(a#1, d#1) + Mod(b#1, d#1), d#1))) && (0 < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) == Mod(a#1 + b#1, d#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaModAddsAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModAddsAuto();



procedure {:verboseName "DivMod.LemmaModAddsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModAddsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13069"} (forall a#1: int, b#1: int, d#1: int :: { Mod(a#1 + b#1, d#1) } (0 < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) == Mod(a#1 + b#1, d#1) + Mul(d#1, Div(Mod(a#1, d#1) + Mod(b#1, d#1), d#1))) && (0 < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) == Mod(a#1 + b#1, d#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModAddsAuto (correctness)"} Impl$$DivMod.__default.LemmaModAddsAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13070"} (forall a#1: int, b#1: int, d#1: int :: { Mod(a#1 + b#1, d#1) } (0 < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) == Mod(a#1 + b#1, d#1) + Mul(d#1, Div(Mod(a#1, d#1) + Mod(b#1, d#1), d#1))) && (0 < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) < d#1 ==> Mod(a#1, d#1) + Mod(b#1, d#1) == Mod(a#1 + b#1, d#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModAddsAuto (correctness)"} Impl$$DivMod.__default.LemmaModAddsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var d#0_0: int;
  var a##0_0: int;
  var b##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1267,2): initial state"} true;
    $_reverifyPost := false;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc a#0_0, b#0_0, d#0_0;
    assume true;
    assume true;
    assume 0 < d#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) == Mod(a#0_0 + b#0_0, d#0_0) + Mul(d#0_0, Div(Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0), d#0_0));
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) < d#0_0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} d#0_0 != 0;
    goto anon5;

  anon12_Else:
    assume {:partition} d#0_0 <= Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0);
    goto anon5;

  anon11_Else:
    assume {:partition} Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) != Mod(a#0_0 + b#0_0, d#0_0) + Mul(d#0_0, Div(Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0), d#0_0));
    goto anon5;

  anon5:
    assume true;
    assume Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) == Mod(a#0_0 + b#0_0, d#0_0) + Mul(d#0_0, Div(Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0), d#0_0)) && (Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) < d#0_0 ==> Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) == Mod(a#0_0 + b#0_0, d#0_0));
    assume false;
    goto anon6;

  anon10_Else:
    goto anon6;

  anon6:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaModAdds(a##0_0, b##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaModAdds(a##0_0, b##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1272,27)"} true;
    assume Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) == Mod(a#0_0 + b#0_0, d#0_0) + Mul(d#0_0, Div(Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0), d#0_0));
    assume Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) < d#0_0 ==> Mod(a#0_0, d#0_0) + Mod(b#0_0, d#0_0) == Mod(a#0_0 + b#0_0, d#0_0);
    assume false;
    goto anon8;

  anon9_Else:
    assume (forall a#0_1: int, b#0_1: int, d#0_1: int, _t#0#0_0: int :: { Mod(_t#0#0_0, d#0_1), Mod(b#0_1, d#0_1), Mod(a#0_1, d#0_1) } _t#0#0_0 == a#0_1 + b#0_1 && 0 < d#0_1 ==> Mod(a#0_1, d#0_1) + Mod(b#0_1, d#0_1) == Mod(_t#0#0_0, d#0_1) + Mul(d#0_1, Div(Mod(a#0_1, d#0_1) + Mod(b#0_1, d#0_1), d#0_1))) && (forall a#0_2: int, b#0_2: int, d#0_2: int, _t#0#0_1: int :: { Mod(_t#0#0_1, d#0_2), Mod(b#0_2, d#0_2), Mod(a#0_2, d#0_2) } _t#0#0_1 == a#0_2 + b#0_2 && 0 < d#0_2 ==> Mod(a#0_2, d#0_2) + Mod(b#0_2, d#0_2) < d#0_2 ==> Mod(a#0_2, d#0_2) + Mod(b#0_2, d#0_2) == Mod(_t#0#0_1, d#0_2));
    goto anon8;

  anon8:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1273,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModNegNeg (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModNegNeg (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModNegNeg", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1276,37): initial state"} true;
    assume 0 < d#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1278,18): post-state"} true;
    assume d#0 != 0;
    assume d#0 != 0;
    assume Mod(x#0, d#0) == Mod(Mul(x#0, 1 - d#0), d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModNegNeg (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int);
  requires {:id "id13092"} 0 < d#0;



procedure {:verboseName "DivMod.LemmaModNegNeg (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13093"} Mod(x#0, d#0) == Mod(Mul(x#0, 1 - d#0), d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModNegNeg (correctness)"} {:vcs_split_on_every_assert} Impl$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13094"} 0 < d#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13095"} Mod(x#0, d#0) == Mod(Mul(x#0, 1 - d#0), d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModNegNeg (correctness)"} {:vcs_split_on_every_assert} Impl$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0_0: int;
  var f#0_0: HandleType where $Is(f#0_0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0_0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0_0: Heap;
  var i#0_0: int;
  var $_Frame#l0_0: [ref,Field]bool;
  var lambdaResult#0_0: bool;
  var i#0_1: int;
  var ##x#0_0: int;
  var ##y#0_0: int;
  var i#0_2: int;
  var ##x#0_1: int;
  var ##y#0_1: int;
  var x##0_0: int;
  var f##0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModNegNeg", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1279,2): initial state"} true;
    $_reverifyPost := false;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    push;
    assume true;
    n##0_0 := d#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0_0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1282,21)"} true;
    assume true;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0_0;
    assume $IsGoodHeap($lambdaHeap#0_0);
    assume $Heap == $lambdaHeap#0_0 || $HeapSucc($Heap, $lambdaHeap#0_0);
    havoc i#0_0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    $_Frame#l0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_0, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    assume d#0 != 0;
    assume lambdaResult#0_0 <==> Mod(x#0 - Mul(i#0_0, d#0), d#0) == Mod(x#0, d#0);
    assume true;
    assume $Is(lambdaResult#0_0, TBool);
    goto anon4;

  anon24_Else:
    assume {:partition} false;
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon23_Else:
    goto anon5;

  anon5:
    assume true;
    f#0_0 := Lit(AtLayer((lambda $l#0_1#ly#0: LayerType :: Handle1((lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $Box(Mod(x#0 - Mul($Unbox($l#0_1#i#0): int, d#0), d#0) == Mod(x#0, d#0))), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: $IsBox($l#0_1#i#0, TInt)), (lambda $l#0_1#heap#0: Heap, $l#0_1#i#0: Box :: SetRef_to_SetBox((lambda $l#0_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1283,44)"} true;
    assume MulInternals.__default.MulAuto#canCall();
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Lit(MulInternals.__default.MulAuto());
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool;
    havoc i#0_1;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} true;
    ##x#0_0 := LitInt(0);
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##y#0_0 := i#0_1;
    assume $IsAlloc(##y#0_0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0_1);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0_1);
    goto anon10;

  anon28_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0_1);
    goto anon10;

  anon10:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0_1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_1))): bool;
    goto anon12;

  anon29_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(LitInt(0), i#0_1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_1))): bool);
    goto anon12;

  anon27_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    goto anon13;

  anon26_Else:
    assume {:partition} !$Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool;
    goto anon13;

  anon13:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool && (forall i#0_3: int :: { GeneralInternals.__default.IsLe(0, i#0_3) } GeneralInternals.__default.IsLe(LitInt(0), i#0_3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3 + 1))): bool);
    havoc i#0_2;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} true;
    ##x#0_1 := i#0_2;
    assume $IsAlloc(##x#0_1, TInt, $Heap);
    ##y#0_1 := LitInt(0);
    assume $IsAlloc(##y#0_1, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(i#0_2, LitInt(0));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#0_2, LitInt(0));
    goto anon17;

  anon32_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(i#0_2, LitInt(0));
    goto anon17;

  anon17:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} GeneralInternals.__default.IsLe(i#0_2, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_2))): bool;
    goto anon19;

  anon33_Else:
    assume {:partition} !(GeneralInternals.__default.IsLe(i#0_2, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_2))): bool);
    goto anon19;

  anon31_Else:
    assume {:partition} false;
    goto anon19;

  anon19:
    goto anon20;

  anon30_Else:
    assume {:partition} !($Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool && (forall i#0_3: int :: { GeneralInternals.__default.IsLe(0, i#0_3) } GeneralInternals.__default.IsLe(LitInt(0), i#0_3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3 + 1))): bool));
    goto anon20;

  anon25_Else:
    assume {:partition} !Lit(MulInternals.__default.MulAuto());
    goto anon20;

  anon20:
    assume MulInternals.__default.MulAuto#canCall() && (Lit(MulInternals.__default.MulAuto()) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool ==> (forall i#0_3: int :: { GeneralInternals.__default.IsLe(0, i#0_3) } GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0_3)) && ((forall i#0_3: int :: { GeneralInternals.__default.IsLe(0, i#0_3) } GeneralInternals.__default.IsLe(LitInt(0), i#0_3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3 + 1))): bool) ==> (forall i#0_4: int :: { GeneralInternals.__default.IsLe(i#0_4, 0) } GeneralInternals.__default.IsLe#canCall(i#0_4, LitInt(0)))));
    assume {:subsumption 0} Lit(MulInternals.__default.MulAuto()) ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool;
    assume {:subsumption 0} Lit(MulInternals.__default.MulAuto()) ==> (forall i#0_3: int :: { GeneralInternals.__default.IsLe(0, i#0_3) } GeneralInternals.__default.IsLe(LitInt(0), i#0_3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3 + 1))): bool);
    assume {:subsumption 0} Lit(MulInternals.__default.MulAuto()) ==> (forall i#0_4: int :: { GeneralInternals.__default.IsLe(i#0_4, 0) } GeneralInternals.__default.IsLe(i#0_4, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_4))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_4 - 1))): bool);
    assume MulInternals.__default.MulAuto() ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(LitInt(0)))): bool && (forall i#0_3: int :: { GeneralInternals.__default.IsLe(0, i#0_3) } GeneralInternals.__default.IsLe(LitInt(0), i#0_3) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_3 + 1))): bool) && (forall i#0_4: int :: { GeneralInternals.__default.IsLe(i#0_4, 0) } GeneralInternals.__default.IsLe(i#0_4, LitInt(0)) && $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_4))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0_0, $Box(i#0_4 - 1))): bool);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1286,98)"} true;
    assume true;
    x##0_0 := x#0;
    assume true;
    f##0_0 := f#0_0;
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0_0, f##0_0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0_0, f##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1287,33)"} true;
    pop;
    assume Mod(x#0 - Mul(x#0, d#0), d#0) == Mod(x#0, d#0);
    assume false;
    goto anon21;

  anon22_Else:
    goto anon21;

  anon21:
    assume Mod(x#0 - Mul(x#0, d#0), d#0) == Mod(x#0, d#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1288,4)"} true;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1289,18)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverse (well-formedness)"} {:timeLimit 50} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivModConverse (well-formedness)"} {:timeLimit 50} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModConverse", " | ", x#0, " | ", d#0, " | ", q#0, " | ", r#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1293,33): initial state"} true;
    assume d#0 != 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= r#0;
    goto anon3;

  anon4_Else:
    assume {:partition} r#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= r#0 && r#0 < d#0;
    assume x#0 == Mul(q#0, d#0) + r#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1297,14): post-state"} true;
    assume d#0 != 0;
    assume q#0 == Div(x#0, d#0);
    assume d#0 != 0;
    assume r#0 == Mod(x#0, d#0);
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverse (call precondtion)"} {:timeLimit 50} CallPre$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int);
  requires {:id "id13121"} d#0 != 0;
  requires {:id "id13122"} LitInt(0) <= r#0;
  requires {:id "id13123"} r#0 < d#0;
  requires {:id "id13124"} x#0 == Mul(q#0, d#0) + r#0;



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverse (call postcondition)"} {:timeLimit 50} CallPost$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13125"} q#0 == Div(x#0, d#0);
  free ensures true;
  free ensures {:id "id13126"} r#0 == Mod(x#0, d#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverse (correctness)"} {:timeLimit 50} Impl$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13127"} d#0 != 0;
  requires {:id "id13128"} LitInt(0) <= r#0;
  requires {:id "id13129"} r#0 < d#0;
  requires {:id "id13130"} x#0 == Mul(q#0, d#0) + r#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13131"} q#0 == Div(x#0, d#0);
  free ensures true;
  free ensures {:id "id13132"} r#0 == Mod(x#0, d#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivModConverse (correctness)"} {:timeLimit 50} Impl$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var x##1: int;
  var f##1: HandleType;
  var $lambdaHeap#1: Heap;
  var u#1: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModConverse", " | ", x#0, " | ", d#0, " | ", q#0, " | ", r#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1299,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := d#0;
    call CallPre$$DivInternals.__default.LemmaDivAuto(n##0);
    call CallPost$$DivInternals.__default.LemmaDivAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1300,19)"} true;
    assume true;
    x##0 := q#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    assume lambdaResult#0 <==> u#0 == Div(Mul(u#0, d#0) + r#0, d#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon10_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon9_Else:
    goto anon4;

  anon4:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box($Unbox($l#1#u#0): int == Div(Mul($Unbox($l#1#u#0): int, d#0) + r#0, d#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1301,55)"} true;
    assume true;
    x##1 := q#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc u#1;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} true;
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    assume d#0 != 0;
    assume lambdaResult#1 <==> r#0 == Mod(Mul(u#1, d#0) + r#0, d#0);
    assume true;
    assume $Is(lambdaResult#1, TBool);
    goto anon7;

  anon12_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon11_Else:
    goto anon8;

  anon8:
    assume true;
    f##1 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: $Box(r#0 == Mod(Mul($Unbox($l#3#u#0): int, d#0) + r#0, d#0))), (lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: $IsBox($l#3#u#0, TInt)), (lambda $l#3#heap#0: Heap, $l#3#u#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##1, f##1);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##1, f##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1302,55)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (well-formedness)"} {:timeLimit 50} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivModConverseAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (well-formedness)"} {:timeLimit 50} CheckWellFormed$$DivMod.__default.LemmaFundamentalDivModConverseAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var d#0: int;
  var q#0: int;
  var r#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1305,33): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1306,12): post-state"} true;
    havoc x#0;
    havoc d#0;
    havoc q#0;
    havoc r#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume d#0 != 0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= r#0;
    goto anon4;

  anon8_Else:
    assume {:partition} r#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= r#0 && r#0 < d#0;
    assume x#0 == Mul(q#0, d#0) + r#0;
    assume d#0 != 0;
    assume q#0 == Div(x#0, d#0);
    assume d#0 != 0;
    assume r#0 == Mod(x#0, d#0);
    goto anon6;

  anon7_Else:
    assume d#0 != 0 && LitInt(0) <= r#0 && r#0 < d#0 && x#0 == Mul(q#0, d#0) + r#0 ==> q#0 == Div(x#0, d#0) && r#0 == Mod(x#0, d#0);
    goto anon6;

  anon6:
    assume (forall x#1: int, d#1: int, q#1: int, r#1: int :: { Mul(q#1, d#1) + r#1, Mod(x#1, d#1) } (d#1 != 0 && LitInt(0) <= r#1 && r#1 < d#1 && x#1 == Mul(q#1, d#1) + r#1 ==> q#1 == Div(x#1, d#1)) && (d#1 != 0 && LitInt(0) <= r#1 && r#1 < d#1 && x#1 == Mul(q#1, d#1) + r#1 ==> r#1 == Mod(x#1, d#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (call precondtion)"} {:timeLimit 50} CallPre$$DivMod.__default.LemmaFundamentalDivModConverseAuto();



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (call postcondition)"} {:timeLimit 50} CallPost$$DivMod.__default.LemmaFundamentalDivModConverseAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13152"} (forall x#1: int, d#1: int, q#1: int, r#1: int :: { Mul(q#1, d#1) + r#1, Mod(x#1, d#1) } (d#1 != 0 && LitInt(0) <= r#1 && r#1 < d#1 && x#1 == Mul(q#1, d#1) + r#1 ==> q#1 == Div(x#1, d#1)) && (d#1 != 0 && LitInt(0) <= r#1 && r#1 < d#1 && x#1 == Mul(q#1, d#1) + r#1 ==> r#1 == Mod(x#1, d#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (correctness)"} {:timeLimit 50} Impl$$DivMod.__default.LemmaFundamentalDivModConverseAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13153"} (forall x#1: int, d#1: int, q#1: int, r#1: int :: { Mul(q#1, d#1) + r#1, Mod(x#1, d#1) } (d#1 != 0 && LitInt(0) <= r#1 && r#1 < d#1 && x#1 == Mul(q#1, d#1) + r#1 ==> q#1 == Div(x#1, d#1)) && (d#1 != 0 && LitInt(0) <= r#1 && r#1 < d#1 && x#1 == Mul(q#1, d#1) + r#1 ==> r#1 == Mod(x#1, d#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (correctness)"} {:timeLimit 50} Impl$$DivMod.__default.LemmaFundamentalDivModConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var d#0_0: int;
  var q#0_0: int;
  var r#0_0: int;
  var x##0_0: int;
  var d##0_0: int;
  var q##0_0: int;
  var r##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1308,2): initial state"} true;
    $_reverifyPost := false;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc x#0_0, d#0_0, q#0_0, r#0_0;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} d#0_0 != 0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= r#0_0;
    goto anon4;

  anon15_Else:
    assume {:partition} r#0_0 < LitInt(0);
    goto anon4;

  anon14_Else:
    assume {:partition} d#0_0 == 0;
    goto anon4;

  anon4:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} d#0_0 != 0 && LitInt(0) <= r#0_0 && r#0_0 < d#0_0;
    goto anon6;

  anon16_Else:
    assume {:partition} !(d#0_0 != 0 && LitInt(0) <= r#0_0 && r#0_0 < d#0_0);
    goto anon6;

  anon6:
    assume true;
    assume d#0_0 != 0 && LitInt(0) <= r#0_0 && r#0_0 < d#0_0 && x#0_0 == Mul(q#0_0, d#0_0) + r#0_0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} d#0_0 != 0;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} q#0_0 == Div(x#0_0, d#0_0);
    assume {:subsumption 0} d#0_0 != 0;
    goto anon9;

  anon18_Else:
    assume {:partition} q#0_0 != Div(x#0_0, d#0_0);
    goto anon9;

  anon9:
    assume true;
    assume q#0_0 == Div(x#0_0, d#0_0) && r#0_0 == Mod(x#0_0, d#0_0);
    assume false;
    goto anon10;

  anon17_Else:
    goto anon10;

  anon10:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    d##0_0 := d#0_0;
    assume true;
    q##0_0 := q#0_0;
    assume true;
    r##0_0 := r#0_0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivModConverse(x##0_0, d##0_0, q##0_0, r##0_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivModConverse(x##0_0, d##0_0, q##0_0, r##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1312,48)"} true;
    assume q#0_0 == Div(x#0_0, d#0_0);
    assume r#0_0 == Mod(x#0_0, d#0_0);
    assume false;
    goto anon12;

  anon13_Else:
    assume (forall x#0_1: int, d#0_1: int, q#0_1: int, r#0_1: int :: d#0_1 != 0 && LitInt(0) <= r#0_1 && r#0_1 < d#0_1 && x#0_1 == Mul(q#0_1, d#0_1) + r#0_1 ==> q#0_1 == Div(x#0_1, d#0_1) && r#0_1 == Mod(x#0_1, d#0_1));
    goto anon12;

  anon12:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1313,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModPosBound (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModPosBound (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPosBound", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1318,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1322,15): post-state"} true;
    assume m#0 != 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= Mod(x#0, m#0);
    assume m#0 != 0;
    goto anon3;

  anon4_Else:
    assume {:partition} Mod(x#0, m#0) < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= Mod(x#0, m#0) && Mod(x#0, m#0) < m#0;
    return;
}



procedure {:verboseName "DivMod.LemmaModPosBound (call precondtion)"} CallPre$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int);
  requires {:id "id13167"} LitInt(0) <= x#0;
  requires {:id "id13168"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaModPosBound (call postcondition)"} CallPost$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13169"} LitInt(0) <= Mod(x#0, m#0);
  free ensures {:id "id13170"} Mod(x#0, m#0) < m#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModPosBound (correctness)"} Impl$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13171"} LitInt(0) <= x#0;
  requires {:id "id13172"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13173"} LitInt(0) <= Mod(x#0, m#0);
  free ensures {:id "id13174"} Mod(x#0, m#0) < m#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModPosBound (correctness)"} Impl$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPosBound", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1323,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1324,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModPosBoundAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModPosBoundAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModPosBoundAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModPosBoundAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPosBoundAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1327,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1328,12): post-state"} true;
    havoc x#0;
    havoc m#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume LitInt(0) <= x#0;
    assume 0 < m#0;
    assume m#0 != 0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= Mod(x#0, m#0);
    assume m#0 != 0;
    goto anon4;

  anon8_Else:
    assume {:partition} Mod(x#0, m#0) < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= Mod(x#0, m#0) && Mod(x#0, m#0) < m#0;
    goto anon6;

  anon7_Else:
    assume LitInt(0) <= x#0 && 0 < m#0 ==> LitInt(0) <= Mod(x#0, m#0) && Mod(x#0, m#0) < m#0;
    goto anon6;

  anon6:
    assume (forall x#1: int, m#1: int :: { Mod(x#1, m#1) } (LitInt(0) <= x#1 && 0 < m#1 ==> LitInt(0) <= Mod(x#1, m#1)) && (LitInt(0) <= x#1 && 0 < m#1 ==> Mod(x#1, m#1) < m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModPosBoundAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModPosBoundAuto();



procedure {:verboseName "DivMod.LemmaModPosBoundAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModPosBoundAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13184"} (forall x#1: int, m#1: int :: { Mod(x#1, m#1) } (LitInt(0) <= x#1 && 0 < m#1 ==> LitInt(0) <= Mod(x#1, m#1)) && (LitInt(0) <= x#1 && 0 < m#1 ==> Mod(x#1, m#1) < m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModPosBoundAuto (correctness)"} Impl$$DivMod.__default.LemmaModPosBoundAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13185"} (forall x#1: int, m#1: int :: { Mod(x#1, m#1) } (LitInt(0) <= x#1 && 0 < m#1 ==> LitInt(0) <= Mod(x#1, m#1)) && (LitInt(0) <= x#1 && 0 < m#1 ==> Mod(x#1, m#1) < m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModPosBoundAuto (correctness)"} Impl$$DivMod.__default.LemmaModPosBoundAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPosBoundAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1329,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, m#0_0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon11_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < m#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} m#0_0 != 0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= Mod(x#0_0, m#0_0);
    assume {:subsumption 0} m#0_0 != 0;
    goto anon6;

  anon13_Else:
    assume {:partition} Mod(x#0_0, m#0_0) < LitInt(0);
    goto anon6;

  anon6:
    assume true;
    assume LitInt(0) <= Mod(x#0_0, m#0_0) && Mod(x#0_0, m#0_0) < m#0_0;
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModPosBound(x##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModPosBound(x##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1333,28)"} true;
    assume LitInt(0) <= Mod(x#0_0, m#0_0);
    assume Mod(x#0_0, m#0_0) < m#0_0;
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, m#0_1: int :: { Mod(x#0_1, m#0_1) } LitInt(0) <= x#0_1 && 0 < m#0_1 ==> LitInt(0) <= Mod(x#0_1, m#0_1) && Mod(x#0_1, m#0_1) < m#0_1);
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1334,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopLeft (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopLeft (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopLeft", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1337,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1339,28): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopLeft (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int);
  requires {:id "id13199"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaMulModNoopLeft (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13200"} Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopLeft (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13201"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13202"} Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopLeft (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopLeft", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1340,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1341,19)"} true;
    assume true;
    x##0 := y#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume lambdaResult#0 <==> Mod(Mul(Mod(x#0, m#0), u#0), m#0) == Mod(Mul(x#0, u#0), m#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mod(Mul(Mod(x#0, m#0), $Unbox($l#1#u#0): int), m#0) == Mod(Mul(x#0, $Unbox($l#1#u#0): int), m#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1342,63)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopLeftAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopLeftAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopLeftAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopLeftAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopLeftAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1345,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1346,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), y#1), m#1) == Mod(Mul(x#1, y#1), m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopLeftAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopLeftAuto();



procedure {:verboseName "DivMod.LemmaMulModNoopLeftAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopLeftAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13218"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), y#1), m#1) == Mod(Mul(x#1, y#1), m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopLeftAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopLeftAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13219"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), y#1), m#1) == Mod(Mul(x#1, y#1), m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopLeftAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopLeftAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopLeftAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1347,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaMulModNoopLeft(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaMulModNoopLeft(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1351,34)"} true;
    assume Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int :: { Mul(Mod(x#0_1, m#0_1), y#0_1) } 0 < m#0_1 ==> Mod(Mul(Mod(x#0_1, m#0_1), y#0_1), m#0_1) == Mod(Mul(x#0_1, y#0_1), m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1352,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopRight (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopRight (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1355,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1357,28): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopRight (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int);
  requires {:id "id13233"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaMulModNoopRight (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13234"} Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopRight (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13235"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13236"} Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopRight (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1358,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1359,19)"} true;
    assume true;
    x##0 := x#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume lambdaResult#0 <==> Mod(Mul(u#0, Mod(y#0, m#0)), m#0) == Mod(Mul(u#0, y#0), m#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon3;

  anon6_Else:
    assume {:partition} false;
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    assume true;
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(Mod(Mul($Unbox($l#1#u#0): int, Mod(y#0, m#0)), m#0) == Mod(Mul($Unbox($l#1#u#0): int, y#0), m#0))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1360,65)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopRightAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopRightAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopRightAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopRightAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopRightAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1363,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1364,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(x#1, Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopRightAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopRightAuto();



procedure {:verboseName "DivMod.LemmaMulModNoopRightAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopRightAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13252"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(x#1, Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopRightAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopRightAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13253"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(x#1, Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopRightAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopRightAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopRightAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1366,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaMulModNoopRight(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaMulModNoopRight(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1370,35)"} true;
    assume Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int :: { Mul(x#0_1, Mod(y#0_1, m#0_1)) } 0 < m#0_1 ==> Mod(Mul(x#0_1, Mod(y#0_1, m#0_1)), m#0_1) == Mod(Mul(x#0_1, y#0_1), m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1371,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopGeneral (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopGeneral (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopGeneral", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1375,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1377,36): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopGeneral (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int);
  requires {:id "id13276"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaMulModNoopGeneral (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13277"} Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures true;
  free ensures {:id "id13278"} Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures true;
  free ensures {:id "id13279"} Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopGeneral (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id13280"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13281"} Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures true;
  free ensures {:id "id13282"} Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures true;
  free ensures {:id "id13283"} Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopGeneral (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var m##0: int;
  var x##1: int;
  var y##1: int;
  var m##1: int;
  var x##2: int;
  var y##2: int;
  var m##2: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopGeneral", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1380,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1381,28)"} true;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    assume true;
    m##0 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopLeft(x##0, y##0, m##0);
    call CallPost$$DivMod.__default.LemmaMulModNoopLeft(x##0, y##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1382,32)"} true;
    assume true;
    x##1 := x#0;
    assume true;
    y##1 := y#0;
    assume true;
    m##1 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopRight(x##1, y##1, m##1);
    call CallPost$$DivMod.__default.LemmaMulModNoopRight(x##1, y##1, m##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1383,33)"} true;
    assume m#0 != 0;
    assume true;
    x##2 := Mod(x#0, m#0);
    assume true;
    y##2 := y#0;
    assume true;
    m##2 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopRight(x##2, y##2, m##2);
    call CallPost$$DivMod.__default.LemmaMulModNoopRight(x##2, y##2, m##2);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1384,37)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopGeneralAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopGeneralAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopGeneralAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1387,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1388,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, Mod(y#0, m#0)), m#0);
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    goto anon4;

  anon10_Else:
    assume {:partition} Mod(Mul(Mod(x#0, m#0), y#0), m#0) != Mod(Mul(x#0, Mod(y#0, m#0)), m#0);
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, Mod(y#0, m#0)), m#0) && Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0);
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    goto anon6;

  anon11_Else:
    assume {:partition} !(Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, Mod(y#0, m#0)), m#0) && Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0));
    goto anon6;

  anon6:
    assume Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, Mod(y#0, m#0)), m#0) && Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) && Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon8;

  anon9_Else:
    assume 0 < m#0 ==> Mod(Mul(Mod(x#0, m#0), y#0), m#0) == Mod(Mul(x#0, Mod(y#0, m#0)), m#0) && Mod(Mul(x#0, Mod(y#0, m#0)), m#0) == Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) && Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon8;

  anon8:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), y#1), m#1) == Mod(Mul(x#1, Mod(y#1, m#1)), m#1)) && (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } (0 < m#1 ==> Mod(Mul(x#1, Mod(y#1, m#1)), m#1) == Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1)) && (0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopGeneralAuto();



procedure {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopGeneralAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13310"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), y#1), m#1) == Mod(Mul(x#1, Mod(y#1, m#1)), m#1));
  free ensures {:id "id13311"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } (0 < m#1 ==> Mod(Mul(x#1, Mod(y#1, m#1)), m#1) == Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1)) && (0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopGeneralAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13312"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), y#1), m#1) == Mod(Mul(x#1, Mod(y#1, m#1)), m#1));
  free ensures {:id "id13313"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } (0 < m#1 ==> Mod(Mul(x#1, Mod(y#1, m#1)), m#1) == Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1)) && (0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopGeneralAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopGeneralAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1390,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0);
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    goto anon4;

  anon12_Else:
    assume {:partition} Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) != Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0);
    goto anon4;

  anon4:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) && Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0);
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    goto anon6;

  anon13_Else:
    assume {:partition} !(Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) && Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0));
    goto anon6;

  anon6:
    assume true;
    assume Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) && Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0) && Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon7;

  anon11_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaMulModNoopGeneral(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaMulModNoopGeneral(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1394,37)"} true;
    assume Mod(Mul(Mod(x#0_0, m#0_0), y#0_0), m#0_0) == Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0);
    assume Mod(Mul(x#0_0, Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0);
    assume Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int :: { Mul(x#0_1, Mod(y#0_1, m#0_1)) } { Mul(Mod(x#0_1, m#0_1), y#0_1) } 0 < m#0_1 ==> Mod(Mul(Mod(x#0_1, m#0_1), y#0_1), m#0_1) == Mod(Mul(x#0_1, Mod(y#0_1, m#0_1)), m#0_1)) && (forall x#0_2: int, y#0_2: int, m#0_2: int :: { Mul(Mod(x#0_2, m#0_2), Mod(y#0_2, m#0_2)) } 0 < m#0_2 ==> Mod(Mul(x#0_2, Mod(y#0_2, m#0_2)), m#0_2) == Mod(Mul(Mod(x#0_2, m#0_2), Mod(y#0_2, m#0_2)), m#0_2) && Mod(Mul(Mod(x#0_2, m#0_2), Mod(y#0_2, m#0_2)), m#0_2) == Mod(Mul(x#0_2, y#0_2), m#0_2));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1395,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoop (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoop (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1398,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1400,34): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoop (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int);
  requires {:id "id13340"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaMulModNoop (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13341"} Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoop (correctness)"} Impl$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id13342"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13343"} Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoop (correctness)"} Impl$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var m##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1401,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    assume true;
    m##0 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopGeneral(x##0, y##0, m##0);
    call CallPost$$DivMod.__default.LemmaMulModNoopGeneral(x##0, y##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1402,35)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaMulModNoopAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1405,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1406,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon4;

  anon5_Else:
    assume 0 < m#0 ==> Mod(Mul(Mod(x#0, m#0), Mod(y#0, m#0)), m#0) == Mod(Mul(x#0, y#0), m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaMulModNoopAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaMulModNoopAuto();



procedure {:verboseName "DivMod.LemmaMulModNoopAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13354"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaMulModNoopAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13355"} (forall x#1: int, y#1: int, m#1: int :: { Mod(Mul(x#1, y#1), m#1) } 0 < m#1 ==> Mod(Mul(Mod(x#1, m#1), Mod(y#1, m#1)), m#1) == Mod(Mul(x#1, y#1), m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaMulModNoopAuto (correctness)"} Impl$$DivMod.__default.LemmaMulModNoopAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1408,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    assume true;
    assume Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaMulModNoop(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaMulModNoop(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1412,30)"} true;
    assume Mod(Mul(Mod(x#0_0, m#0_0), Mod(y#0_0, m#0_0)), m#0_0) == Mod(Mul(x#0_0, y#0_0), m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int :: { Mul(Mod(x#0_1, m#0_1), Mod(y#0_1, m#0_1)) } 0 < m#0_1 ==> Mod(Mul(Mod(x#0_1, m#0_1), Mod(y#0_1, m#0_1)), m#0_1) == Mod(Mul(x#0_1, y#0_1), m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1413,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModEquivalence (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModEquivalence (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModEquivalence", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1417,8): initial state"} true;
    assume 0 < m#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1419,27): post-state"} true;
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0);
    return;
}



procedure {:verboseName "DivMod.LemmaModEquivalence (call precondtion)"} CallPre$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int);
  requires {:id "id13370"} 0 < m#0;



procedure {:verboseName "DivMod.LemmaModEquivalence (call postcondition)"} CallPost$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13371"} Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModEquivalence (correctness)"} Impl$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id13372"} 0 < m#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13373"} Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModEquivalence (correctness)"} Impl$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModEquivalence", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1420,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    n##0 := m#0;
    call CallPre$$ModInternals.__default.LemmaModAuto(n##0);
    call CallPost$$ModInternals.__default.LemmaModAuto(n##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1421,19)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModEquivalenceAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModEquivalenceAuto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModEquivalenceAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModEquivalenceAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var m#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModEquivalenceAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1424,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1425,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc m#0;
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} 0 < m#0;
    assume m#0 != 0;
    assume m#0 != 0;
    goto anon3;

  anon6_Else:
    assume {:partition} m#0 <= 0;
    goto anon3;

  anon3:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} 0 < m#0;
    assume m#0 != 0;
    goto anon5;

  anon7_Else:
    assume {:partition} m#0 <= 0;
    goto anon5;

  anon5:
    assume 0 < m#0 && Mod(x#0, m#0) == Mod(y#0, m#0) <==> 0 < m#0 && Mod(x#0 - y#0, m#0) == LitInt(0);
    assume (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1, m#1), Mod(y#1, m#1) } 0 < m#1 && Mod(x#1, m#1) == Mod(y#1, m#1) <==> 0 < m#1 && Mod(x#1 - y#1, m#1) == LitInt(0));
    return;
}



procedure {:verboseName "DivMod.LemmaModEquivalenceAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModEquivalenceAuto();



procedure {:verboseName "DivMod.LemmaModEquivalenceAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModEquivalenceAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13381"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1, m#1), Mod(y#1, m#1) } 0 < m#1 && Mod(x#1, m#1) == Mod(y#1, m#1) <==> 0 < m#1 && Mod(x#1 - y#1, m#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModEquivalenceAuto (correctness)"} Impl$$DivMod.__default.LemmaModEquivalenceAuto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13382"} (forall x#1: int, y#1: int, m#1: int :: { Mod(x#1, m#1), Mod(y#1, m#1) } 0 < m#1 && Mod(x#1, m#1) == Mod(y#1, m#1) <==> 0 < m#1 && Mod(x#1 - y#1, m#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModEquivalenceAuto (correctness)"} Impl$$DivMod.__default.LemmaModEquivalenceAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var m#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModEquivalenceAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1427,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, m#0_0;
    assume true;
    assume true;
    assume 0 < m#0_0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:subsumption 0} m#0_0 != 0;
    assume {:subsumption 0} m#0_0 != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} 0 < m#0_0;
    assume {:subsumption 0} m#0_0 != 0;
    goto anon4;

  anon10_Else:
    assume {:partition} m#0_0 <= 0;
    goto anon4;

  anon4:
    assume true;
    assume Mod(x#0_0, m#0_0) == Mod(y#0_0, m#0_0) <==> 0 < m#0_0 && Mod(x#0_0 - y#0_0, m#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModEquivalence(x##0_0, y##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModEquivalence(x##0_0, y##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1431,34)"} true;
    assume Mod(x#0_0, m#0_0) == Mod(y#0_0, m#0_0) <==> 0 < m#0_0 && Mod(x#0_0 - y#0_0, m#0_0) == LitInt(0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, m#0_1: int, _t#0#0_0: int :: { Mod(_t#0#0_0, m#0_1), Mod(y#0_1, m#0_1), Mod(x#0_1, m#0_1) } _t#0#0_0 == x#0_1 - y#0_1 && 0 < m#0_1 ==> (Mod(x#0_1, m#0_1) == Mod(y#0_1, m#0_1) <==> 0 < m#0_1 && Mod(_t#0#0_0, m#0_1) == LitInt(0)));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1432,4)"} true;
    return;
}



function DivMod.__default.IsModEquivalent(x#0: int, y#0: int, m#0: int) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int, m#0: int :: { DivMod.__default.IsModEquivalent(x#0, y#0, m#0) } DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0) || (1 < $FunctionContextHeight && m#0 > 0) ==> (Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0)));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int, m#0: int :: { DivMod.__default.IsModEquivalent(x#0, y#0, m#0) } DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0) || (1 < $FunctionContextHeight && m#0 > 0) ==> (DivMod.__default.IsModEquivalent(x#0, y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0)));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int, y#0: int, m#0: int :: {:weight 3} { DivMod.__default.IsModEquivalent(LitInt(x#0), LitInt(y#0), LitInt(m#0)) } DivMod.__default.IsModEquivalent#canCall(LitInt(x#0), LitInt(y#0), LitInt(m#0)) || (1 < $FunctionContextHeight && Lit(m#0 > 0)) ==> (DivMod.__default.IsModEquivalent(LitInt(x#0), LitInt(y#0), LitInt(m#0)) <==> LitInt(Mod(x#0 - y#0, LitInt(m#0))) == LitInt(0)));
}

function DivMod.__default.IsModEquivalent#canCall(x#0: int, y#0: int, m#0: int) : bool;

function DivMod.__default.IsModEquivalent#requires(int, int, int) : bool;

axiom (forall x#0: int, y#0: int, m#0: int :: { DivMod.__default.IsModEquivalent#requires(x#0, y#0, m#0) } DivMod.__default.IsModEquivalent#requires(x#0, y#0, m#0) <==> m#0 > 0);

procedure {:verboseName "DivMod.IsModEquivalent (well-formedness)"} CheckWellformed$$DivMod.__default.IsModEquivalent(x#0: int, y#0: int, m#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id13391"} Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.IsModEquivalent (well-formedness)"} CheckWellformed$$DivMod.__default.IsModEquivalent(x#0: int, y#0: int, m#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var m##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.IsModEquivalent", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1436,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume m#0 > 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume m#0 != 0;
    assume m#0 != 0;
    assume m#0 != 0;
    assume Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0);
    assume false;
    return;

  anon4_Else:
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    assume true;
    m##0 := m#0;
    call CallPre$$DivMod.__default.LemmaModEquivalence(x##0, y##0, m##0);
    call CallPost$$DivMod.__default.LemmaModEquivalence(x##0, y##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1440,31)"} true;
    assume m#0 != 0;
    assume DivMod.__default.IsModEquivalent(x#0, y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0);
    assume true;
    assume $Is(DivMod.__default.IsModEquivalent(x#0, y#0, m#0), TBool);
    return;
}



procedure {:verboseName "DivMod.LemmaModMulEquivalent (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMulEquivalent (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##y#0: int;
  var ##m#0: int;
  var ##x#1: int;
  var ##y#1: int;
  var ##m#1: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMulEquivalent", " | ", x#0, " | ", y#0, " | ", z#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1445,8): initial state"} true;
    assume m#0 > 0;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    ##m#0 := m#0;
    assume $IsAlloc(##m#0, TInt, $Heap);
    assume {:subsumption 0} ##m#0 > 0;
    assume ##m#0 > 0;
    assume DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0);
    assume DivMod.__default.IsModEquivalent(x#0, y#0, m#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1448,27): post-state"} true;
    ##x#1 := Mul(x#0, z#0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := Mul(y#0, z#0);
    assume $IsAlloc(##y#1, TInt, $Heap);
    ##m#1 := m#0;
    assume $IsAlloc(##m#1, TInt, $Heap);
    assume {:subsumption 0} ##m#1 > 0;
    assume ##m#1 > 0;
    assume DivMod.__default.IsModEquivalent#canCall(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
    assume DivMod.__default.IsModEquivalent(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModMulEquivalent (call precondtion)"} CallPre$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int);
  requires {:id "id13406"} m#0 > 0;
  requires {:id "id13407"} DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0) ==> DivMod.__default.IsModEquivalent(x#0, y#0, m#0) || (Lit(true) ==> Mod(x#0 - y#0, m#0) == LitInt(0));



procedure {:verboseName "DivMod.LemmaModMulEquivalent (call postcondition)"} CallPost$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int);
  modifies $Heap;
  free ensures DivMod.__default.IsModEquivalent#canCall(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
  free ensures {:id "id13408"} DivMod.__default.IsModEquivalent#canCall(Mul(x#0, z#0), Mul(y#0, z#0), m#0) && DivMod.__default.IsModEquivalent(Mul(x#0, z#0), Mul(y#0, z#0), m#0) && Mod(Mul(x#0, z#0) - Mul(y#0, z#0), m#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMulEquivalent (correctness)"} Impl$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id13409"} m#0 > 0;
  free requires {:id "id13410"} DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0) && DivMod.__default.IsModEquivalent(x#0, y#0, m#0) && Mod(x#0 - y#0, m#0) == LitInt(0);
  modifies $Heap;
  free ensures DivMod.__default.IsModEquivalent#canCall(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
  free ensures {:id "id13411"} DivMod.__default.IsModEquivalent#canCall(Mul(x#0, z#0), Mul(y#0, z#0), m#0) ==> DivMod.__default.IsModEquivalent(Mul(x#0, z#0), Mul(y#0, z#0), m#0) || (Lit(true) ==> Mod(Mul(x#0, z#0) - Mul(y#0, z#0), m#0) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMulEquivalent (correctness)"} Impl$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var m##0: int;
  var x##1: int;
  var y##1: int;
  var m##1: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMulEquivalent", " | ", x#0, " | ", y#0, " | ", z#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1449,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := z#0;
    assume true;
    m##0 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopLeft(x##0, y##0, m##0);
    call CallPost$$DivMod.__default.LemmaMulModNoopLeft(x##0, y##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1450,32)"} true;
    assume true;
    x##1 := y#0;
    assume true;
    y##1 := z#0;
    assume true;
    m##1 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopLeft(x##1, y##1, m##1);
    call CallPost$$DivMod.__default.LemmaMulModNoopLeft(x##1, y##1, m##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1451,32)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModMulEquivalentAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMulEquivalentAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMulEquivalentAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMulEquivalentAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var z#0: int;
  var m#0: int;
  var ##x#0: int;
  var ##y#0: int;
  var ##m#0: int;
  var ##x#1: int;
  var ##y#1: int;
  var ##m#1: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMulEquivalentAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1454,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1455,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc z#0;
    havoc m#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume m#0 > 0;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TInt, $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TInt, $Heap);
    ##m#0 := m#0;
    assume $IsAlloc(##m#0, TInt, $Heap);
    assume {:subsumption 0} ##m#0 > 0;
    assume ##m#0 > 0;
    assume DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0);
    assume DivMod.__default.IsModEquivalent(x#0, y#0, m#0);
    ##x#1 := Mul(x#0, z#0);
    assume $IsAlloc(##x#1, TInt, $Heap);
    ##y#1 := Mul(y#0, z#0);
    assume $IsAlloc(##y#1, TInt, $Heap);
    ##m#1 := m#0;
    assume $IsAlloc(##m#1, TInt, $Heap);
    assume {:subsumption 0} ##m#1 > 0;
    assume ##m#1 > 0;
    assume DivMod.__default.IsModEquivalent#canCall(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
    assume DivMod.__default.IsModEquivalent(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
    goto anon4;

  anon5_Else:
    assume m#0 > 0 && DivMod.__default.IsModEquivalent(x#0, y#0, m#0) ==> DivMod.__default.IsModEquivalent(Mul(x#0, z#0), Mul(y#0, z#0), m#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, z#1: int, m#1: int :: { DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1) } m#1 > 0 && DivMod.__default.IsModEquivalent(x#1, y#1, m#1) ==> DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModMulEquivalentAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModMulEquivalentAuto();



procedure {:verboseName "DivMod.LemmaModMulEquivalentAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModMulEquivalentAuto();
  modifies $Heap;
  free ensures (forall x#1: int, y#1: int, z#1: int, m#1: int :: { DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1) } m#1 > 0 ==> DivMod.__default.IsModEquivalent#canCall(x#1, y#1, m#1) && (DivMod.__default.IsModEquivalent(x#1, y#1, m#1) ==> DivMod.__default.IsModEquivalent#canCall(Mul(x#1, z#1), Mul(y#1, z#1), m#1)));
  free ensures {:id "id13423"} (forall x#1: int, y#1: int, z#1: int, m#1: int :: { DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1) } m#1 > 0 && DivMod.__default.IsModEquivalent(x#1, y#1, m#1) ==> DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMulEquivalentAuto (correctness)"} Impl$$DivMod.__default.LemmaModMulEquivalentAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: int, y#1: int, z#1: int, m#1: int :: { DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1) } m#1 > 0 ==> DivMod.__default.IsModEquivalent#canCall(x#1, y#1, m#1) && (DivMod.__default.IsModEquivalent(x#1, y#1, m#1) ==> DivMod.__default.IsModEquivalent#canCall(Mul(x#1, z#1), Mul(y#1, z#1), m#1)));
  free ensures {:id "id13424"} (forall x#1: int, y#1: int, z#1: int, m#1: int :: { DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1) } m#1 > 0 && DivMod.__default.IsModEquivalent(x#1, y#1, m#1) ==> DivMod.__default.IsModEquivalent(Mul(x#1, z#1), Mul(y#1, z#1), m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMulEquivalentAuto (correctness)"} Impl$$DivMod.__default.LemmaModMulEquivalentAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var m#0_0: int;
  var ##x#0_0: int;
  var ##y#0_0: int;
  var ##m#0_0: int;
  var ##x#0_1: int;
  var ##y#0_1: int;
  var ##m#0_1: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMulEquivalentAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1458,2): initial state"} true;
    $_reverifyPost := false;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc x#0_0, y#0_0, z#0_0, m#0_0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} m#0_0 > 0;
    ##x#0_0 := x#0_0;
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##y#0_0 := y#0_0;
    assume $IsAlloc(##y#0_0, TInt, $Heap);
    ##m#0_0 := m#0_0;
    assume $IsAlloc(##m#0_0, TInt, $Heap);
    assume {:subsumption 0} ##m#0_0 > 0;
    assume DivMod.__default.IsModEquivalent#canCall(x#0_0, y#0_0, m#0_0);
    goto anon3;

  anon9_Else:
    assume {:partition} 0 >= m#0_0;
    goto anon3;

  anon3:
    assume m#0_0 > 0 ==> DivMod.__default.IsModEquivalent#canCall(x#0_0, y#0_0, m#0_0);
    assume m#0_0 > 0 && DivMod.__default.IsModEquivalent(x#0_0, y#0_0, m#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##x#0_1 := Mul(x#0_0, z#0_0);
    assume $IsAlloc(##x#0_1, TInt, $Heap);
    ##y#0_1 := Mul(y#0_0, z#0_0);
    assume $IsAlloc(##y#0_1, TInt, $Heap);
    ##m#0_1 := m#0_0;
    assume $IsAlloc(##m#0_1, TInt, $Heap);
    assume {:subsumption 0} ##m#0_1 > 0;
    assume DivMod.__default.IsModEquivalent#canCall(Mul(x#0_0, z#0_0), Mul(y#0_0, z#0_0), m#0_0);
    assume DivMod.__default.IsModEquivalent#canCall(Mul(x#0_0, z#0_0), Mul(y#0_0, z#0_0), m#0_0);
    assume DivMod.__default.IsModEquivalent(Mul(x#0_0, z#0_0), Mul(y#0_0, z#0_0), m#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$DivMod.__default.LemmaModMulEquivalent(x##0_0, y##0_0, z##0_0, m##0_0);
    call CallPost$$DivMod.__default.LemmaModMulEquivalent(x##0_0, y##0_0, z##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1462,39)"} true;
    assume DivMod.__default.IsModEquivalent#canCall(Mul(x#0_0, z#0_0), Mul(y#0_0, z#0_0), m#0_0) ==> DivMod.__default.IsModEquivalent(Mul(x#0_0, z#0_0), Mul(y#0_0, z#0_0), m#0_0) || (Lit(true) ==> Mod(Mul(x#0_0, z#0_0) - Mul(y#0_0, z#0_0), m#0_0) == LitInt(0));
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int, m#0_1: int :: { DivMod.__default.IsModEquivalent(Mul(x#0_1, z#0_1), Mul(y#0_1, z#0_1), m#0_1) } m#0_1 > 0 && DivMod.__default.IsModEquivalent(x#0_1, y#0_1, m#0_1) ==> DivMod.__default.IsModEquivalent(Mul(x#0_1, z#0_1), Mul(y#0_1, z#0_1), m#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1463,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModOrdering (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModOrdering (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModOrdering", " | ", x#0, " | ", k#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1467,8): initial state"} true;
    assume 1 < d#0;
    assume 0 < k#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1470,14): post-state"} true;
    assume 0 < Mul(d#0, k#0);
    assume d#0 != 0;
    assume Mul(d#0, k#0) != 0;
    assume Mod(x#0, d#0) <= Mod(x#0, Mul(d#0, k#0));
    return;
}



procedure {:verboseName "DivMod.LemmaModOrdering (call precondtion)"} CallPre$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int);
  requires {:id "id13438"} 1 < d#0;
  requires {:id "id13439"} 0 < k#0;



procedure {:verboseName "DivMod.LemmaModOrdering (call postcondition)"} CallPost$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13440"} 0 < Mul(d#0, k#0);
  free ensures true;
  free ensures {:id "id13441"} Mod(x#0, d#0) <= Mod(x#0, Mul(d#0, k#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModOrdering (correctness)"} Impl$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id13442"} 1 < d#0;
  requires {:id "id13443"} 0 < k#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13444"} 0 < Mul(d#0, k#0);
  free ensures true;
  free ensures {:id "id13445"} Mod(x#0, d#0) <= Mod(x#0, Mul(d#0, k#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModOrdering (correctness)"} Impl$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var y##0: int;
  var x##0_1_0: int;
  var d##0_1_0: int;
  var x##0_2_0: int;
  var d##0_2_0: int;
  var x##1_0_0: int;
  var m##1_0_0: int;
  var a##1_3_0: int;
  var b##1_3_0: int;
  var m##1_3_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModOrdering", " | ", x#0, " | ", k#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1472,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    x##0 := d#0;
    assume true;
    y##0 := k#0;
    call CallPre$$Mul.__default.LemmaMulStrictlyIncreases(x##0, y##0);
    call CallPost$$Mul.__default.LemmaMulStrictlyIncreases(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1473,34)"} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume false;
    goto anon5;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    push;
    push;
    assume true;
    x##0_2_0 := x#0;
    assume true;
    d##0_2_0 := d#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_2_0, d##0_2_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_2_0, d##0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1476,36)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mod(x#0, d#0) + Mul(d#0, Div(x#0, d#0)) == x#0;
    assume false;
    goto anon5;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume true;
    push;
    push;
    assume true;
    x##0_1_0 := x#0;
    assume true;
    d##0_1_0 := Mul(d#0, k#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_1_0, d##0_1_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_1_0, d##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1478,40)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume true;
    assume {:subsumption 0} x#0 == Mod(x#0, Mul(d#0, k#0)) + Mul(Mul(d#0, k#0), Div(x#0, Mul(d#0, k#0)));
    assume false;
    goto anon5;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1480,35)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0, Mul(d#0, k#0)) + Mul(Mul(d#0, k#0), Div(x#0, Mul(d#0, k#0))) == Mod(x#0, Mul(d#0, k#0)) + Mul(d#0, Mul(k#0, Div(x#0, Mul(d#0, k#0))));
    assume false;
    goto anon5;

  anon16_Else:
    goto anon5;

  anon5:
    assume Mod(x#0, d#0) + Mul(d#0, Div(x#0, d#0)) == Mod(x#0, Mul(d#0, k#0)) + Mul(d#0, Mul(k#0, Div(x#0, Mul(d#0, k#0))));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume false;
    goto anon12;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:subsumption 0} d#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1485,33)"} true;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0, d#0) == Mod(Mod(x#0, d#0), d#0);
    assume false;
    goto anon12;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume d#0 != 0;
    assume Mul(d#0, k#0) != 0;
    assume true;
    a##1_3_0 := Div(x#0, d#0) - Mul(k#0, Div(x#0, Mul(d#0, k#0)));
    assume d#0 != 0;
    assume true;
    b##1_3_0 := Mod(x#0, d#0);
    assume true;
    m##1_3_0 := d#0;
    call CallPre$$DivMod.__default.LemmaModMultiplesVanish(a##1_3_0, b##1_3_0, m##1_3_0);
    call CallPost$$DivMod.__default.LemmaModMultiplesVanish(a##1_3_0, b##1_3_0, m##1_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1487,70)"} true;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, d#0), d#0) == Mod(Mod(x#0, d#0) + Mul(d#0, Div(x#0, d#0) - Mul(k#0, Div(x#0, Mul(d#0, k#0)))), d#0);
    assume false;
    goto anon12;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1489,40)"} true;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, d#0) + Mul(d#0, Div(x#0, d#0) - Mul(k#0, Div(x#0, Mul(d#0, k#0)))), d#0) == Mod(Mod(x#0, d#0) + Mul(d#0, Div(x#0, d#0)) - Mul(d#0, Mul(k#0, Div(x#0, Mul(d#0, k#0)))), d#0);
    assume false;
    goto anon12;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} d#0 != 0;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, d#0) + Mul(d#0, Div(x#0, d#0)) - Mul(d#0, Mul(k#0, Div(x#0, Mul(d#0, k#0)))), d#0) == Mod(Mod(x#0, Mul(d#0, k#0)), d#0);
    assume false;
    goto anon12;

  anon21_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume {:subsumption 0} d#0 != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1492,33)"} true;
    assume Mul(d#0, k#0) != 0;
    assume true;
    assume $Is(Mod(x#0, Mul(d#0, k#0)), Tclass._System.nat());
    x##1_0_0 := Mod(x#0, Mul(d#0, k#0));
    assume true;
    assume $Is(d#0, Tclass._System.nat());
    m##1_0_0 := d#0;
    call CallPre$$DivMod.__default.LemmaModDecreases(x##1_0_0, m##1_0_0);
    call CallPost$$DivMod.__default.LemmaModDecreases(x##1_0_0, m##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1493,42)"} true;
    assume {:subsumption 0} Mul(d#0, k#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mod(x#0, Mul(d#0, k#0)), d#0) <= Mod(x#0, Mul(d#0, k#0));
    assume false;
    goto anon12;

  anon22_Else:
    goto anon12;

  anon12:
    assume Mod(x#0, d#0) <= Mod(x#0, Mul(d#0, k#0));
    return;
}



procedure {:verboseName "DivMod.LemmaModOrderingAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModOrderingAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModOrderingAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModOrderingAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var k#0: int;
  var d#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModOrderingAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1498,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1499,12): post-state"} true;
    havoc x#0;
    havoc k#0;
    havoc d#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 1 < d#0;
    assume 0 < k#0;
    assume 0 < Mul(d#0, k#0);
    assume d#0 != 0;
    assume Mul(d#0, k#0) != 0;
    assume Mod(x#0, d#0) <= Mod(x#0, Mul(d#0, k#0));
    goto anon4;

  anon5_Else:
    assume 1 < d#0 && 0 < k#0 ==> 0 < Mul(d#0, k#0) && Mod(x#0, d#0) <= Mod(x#0, Mul(d#0, k#0));
    goto anon4;

  anon4:
    assume (forall x#1: int, k#1: int, d#1: int :: { Mod(x#1, Mul(d#1, k#1)) } (1 < d#1 && 0 < k#1 ==> 0 < Mul(d#1, k#1)) && (1 < d#1 && 0 < k#1 ==> Mod(x#1, d#1) <= Mod(x#1, Mul(d#1, k#1))));
    return;
}



procedure {:verboseName "DivMod.LemmaModOrderingAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModOrderingAuto();



procedure {:verboseName "DivMod.LemmaModOrderingAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModOrderingAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13525"} (forall x#1: int, k#1: int, d#1: int :: { Mod(x#1, Mul(d#1, k#1)) } (1 < d#1 && 0 < k#1 ==> 0 < Mul(d#1, k#1)) && (1 < d#1 && 0 < k#1 ==> Mod(x#1, d#1) <= Mod(x#1, Mul(d#1, k#1))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModOrderingAuto (correctness)"} Impl$$DivMod.__default.LemmaModOrderingAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13526"} (forall x#1: int, k#1: int, d#1: int :: { Mod(x#1, Mul(d#1, k#1)) } (1 < d#1 && 0 < k#1 ==> 0 < Mul(d#1, k#1)) && (1 < d#1 && 0 < k#1 ==> Mod(x#1, d#1) <= Mod(x#1, Mul(d#1, k#1))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModOrderingAuto (correctness)"} Impl$$DivMod.__default.LemmaModOrderingAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var k#0_0: int;
  var d#0_0: int;
  var x##0_0: int;
  var k##0_0: int;
  var d##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModOrderingAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1501,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, k#0_0, d#0_0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} 1 < d#0_0;
    goto anon3;

  anon11_Else:
    assume {:partition} d#0_0 <= 1;
    goto anon3;

  anon3:
    assume true;
    assume 1 < d#0_0 && 0 < k#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Mul(d#0_0, k#0_0) > 0;
    assume {:subsumption 0} d#0_0 != 0;
    assume {:subsumption 0} Mul(d#0_0, k#0_0) != 0;
    goto anon6;

  anon13_Else:
    assume {:partition} 0 >= Mul(d#0_0, k#0_0);
    goto anon6;

  anon6:
    assume true;
    assume Mul(d#0_0, k#0_0) > 0 && Mod(x#0_0, d#0_0) <= Mod(x#0_0, Mul(d#0_0, k#0_0));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    k##0_0 := k#0_0;
    assume true;
    d##0_0 := d#0_0;
    call CallPre$$DivMod.__default.LemmaModOrdering(x##0_0, k##0_0, d##0_0);
    call CallPost$$DivMod.__default.LemmaModOrdering(x##0_0, k##0_0, d##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1505,31)"} true;
    assume Mul(d#0_0, k#0_0) > 0;
    assume Mod(x#0_0, d#0_0) <= Mod(x#0_0, Mul(d#0_0, k#0_0));
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, k#0_1: int, d#0_1: int :: 1 < d#0_1 && 0 < k#0_1 ==> Mul(d#0_1, k#0_1) > 0) && (forall x#0_2: int, k#0_2: int, d#0_2: int :: { Mod(x#0_2, Mul(d#0_2, k#0_2)) } 1 < d#0_2 && 0 < k#0_2 ==> Mod(x#0_2, d#0_2) <= Mod(x#0_2, Mul(d#0_2, k#0_2)));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1506,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModMod (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMod (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMod", " | ", x#0, " | ", a#0, " | ", b#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1509,8): initial state"} true;
    assume 0 < a#0;
    assume 0 < b#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1512,14): post-state"} true;
    assume 0 < Mul(a#0, b#0);
    assume Mul(a#0, b#0) != 0;
    assume a#0 != 0;
    assume a#0 != 0;
    assume Mod(Mod(x#0, Mul(a#0, b#0)), a#0) == Mod(x#0, a#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModMod (call precondtion)"} CallPre$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int);
  requires {:id "id13542"} 0 < a#0;
  requires {:id "id13543"} 0 < b#0;



procedure {:verboseName "DivMod.LemmaModMod (call postcondition)"} CallPost$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13544"} 0 < Mul(a#0, b#0);
  free ensures true;
  free ensures {:id "id13545"} Mod(Mod(x#0, Mul(a#0, b#0)), a#0) == Mod(x#0, a#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModMod (correctness)"} Impl$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id13546"} 0 < a#0;
  requires {:id "id13547"} 0 < b#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13548"} 0 < Mul(a#0, b#0);
  free ensures true;
  free ensures {:id "id13549"} Mod(Mod(x#0, Mul(a#0, b#0)), a#0) == Mod(x#0, a#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModMod (correctness)"} Impl$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0_1_0: int;
  var d##0_1_0: int;
  var x##0_3_0: int;
  var d##0_3_0: int;
  var x##0: int;
  var d##0: int;
  var q##0: int;
  var r##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMod", " | ", x#0, " | ", a#0, " | ", b#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1514,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1515,34)"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    assume false;
    goto anon6;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume true;
    push;
    push;
    assume true;
    x##0_3_0 := x#0;
    assume true;
    d##0_3_0 := Mul(a#0, b#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_3_0, d##0_3_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_3_0, d##0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1518,40)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume true;
    assume {:subsumption 0} x#0 == Mul(Mul(a#0, b#0), Div(x#0, Mul(a#0, b#0))) + Mod(x#0, Mul(a#0, b#0));
    assume false;
    goto anon6;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1520,35)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume true;
    assume {:subsumption 0} Mul(Mul(a#0, b#0), Div(x#0, Mul(a#0, b#0))) + Mod(x#0, Mul(a#0, b#0)) == Mul(a#0, Mul(b#0, Div(x#0, Mul(a#0, b#0)))) + Mod(x#0, Mul(a#0, b#0));
    assume false;
    goto anon6;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume true;
    push;
    push;
    assume Mul(a#0, b#0) != 0;
    assume true;
    x##0_1_0 := Mod(x#0, Mul(a#0, b#0));
    assume true;
    d##0_1_0 := a#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_1_0, d##0_1_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_1_0, d##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1522,46)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} a#0 != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} a#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(a#0, Mul(b#0, Div(x#0, Mul(a#0, b#0)))) + Mod(x#0, Mul(a#0, b#0)) == Mul(a#0, Mul(b#0, Div(x#0, Mul(a#0, b#0)))) + Mul(a#0, Div(Mod(x#0, Mul(a#0, b#0)), a#0)) + Mod(Mod(x#0, Mul(a#0, b#0)), a#0);
    assume false;
    goto anon6;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} a#0 != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} a#0 != 0;
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1524,36)"} true;
    pop;
    pop;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} a#0 != 0;
    assume {:subsumption 0} Mul(a#0, b#0) != 0;
    assume {:subsumption 0} a#0 != 0;
    assume true;
    assume {:subsumption 0} Mul(a#0, Mul(b#0, Div(x#0, Mul(a#0, b#0)))) + Mul(a#0, Div(Mod(x#0, Mul(a#0, b#0)), a#0)) + Mod(Mod(x#0, Mul(a#0, b#0)), a#0) == Mul(a#0, Mul(b#0, Div(x#0, Mul(a#0, b#0))) + Div(Mod(x#0, Mul(a#0, b#0)), a#0)) + Mod(Mod(x#0, Mul(a#0, b#0)), a#0);
    assume false;
    goto anon6;

  anon11_Else:
    goto anon6;

  anon6:
    assume x#0 == Mul(a#0, Mul(b#0, Div(x#0, Mul(a#0, b#0))) + Div(Mod(x#0, Mul(a#0, b#0)), a#0)) + Mod(Mod(x#0, Mul(a#0, b#0)), a#0);
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1527,28)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1528,31)"} true;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := a#0;
    assume Mul(a#0, b#0) != 0;
    assume Mul(a#0, b#0) != 0;
    assume a#0 != 0;
    assume true;
    q##0 := Mul(b#0, Div(x#0, Mul(a#0, b#0))) + Div(Mod(x#0, Mul(a#0, b#0)), a#0);
    assume Mul(a#0, b#0) != 0;
    assume a#0 != 0;
    assume true;
    r##0 := Mod(Mod(x#0, Mul(a#0, b#0)), a#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivModConverse(x##0, d##0, q##0, r##0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivModConverse(x##0, d##0, q##0, r##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1529,96)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModModAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModModAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModModAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModModAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var a#0: int;
  var b#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModModAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1532,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1533,12): post-state"} true;
    havoc x#0;
    havoc a#0;
    havoc b#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume 0 < a#0;
    assume 0 < b#0;
    assume 0 < Mul(a#0, b#0);
    assume Mul(a#0, b#0) != 0;
    assume a#0 != 0;
    assume a#0 != 0;
    assume Mod(Mod(x#0, Mul(a#0, b#0)), a#0) == Mod(x#0, a#0);
    goto anon4;

  anon5_Else:
    assume 0 < a#0 && 0 < b#0 ==> 0 < Mul(a#0, b#0) && Mod(Mod(x#0, Mul(a#0, b#0)), a#0) == Mod(x#0, a#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, a#1: int, b#1: int :: { Mul(a#1, b#1), Mod(x#1, a#1) } 0 < a#1 && 0 < b#1 ==> 0 < Mul(a#1, b#1)) && (forall x#1: int, a#1: int, b#1: int :: { Mul(a#1, b#1), Mod(x#1, a#1) } 0 < a#1 && 0 < b#1 ==> Mod(Mod(x#1, Mul(a#1, b#1)), a#1) == Mod(x#1, a#1));
    return;
}



procedure {:verboseName "DivMod.LemmaModModAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModModAuto();



procedure {:verboseName "DivMod.LemmaModModAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModModAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13609"} (forall x#1: int, a#1: int, b#1: int :: { Mul(a#1, b#1), Mod(x#1, a#1) } 0 < a#1 && 0 < b#1 ==> 0 < Mul(a#1, b#1));
  free ensures {:id "id13610"} (forall x#1: int, a#1: int, b#1: int :: { Mul(a#1, b#1), Mod(x#1, a#1) } 0 < a#1 && 0 < b#1 ==> Mod(Mod(x#1, Mul(a#1, b#1)), a#1) == Mod(x#1, a#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModModAuto (correctness)"} Impl$$DivMod.__default.LemmaModModAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13611"} (forall x#1: int, a#1: int, b#1: int :: { Mul(a#1, b#1), Mod(x#1, a#1) } 0 < a#1 && 0 < b#1 ==> 0 < Mul(a#1, b#1));
  free ensures {:id "id13612"} (forall x#1: int, a#1: int, b#1: int :: { Mul(a#1, b#1), Mod(x#1, a#1) } 0 < a#1 && 0 < b#1 ==> Mod(Mod(x#1, Mul(a#1, b#1)), a#1) == Mod(x#1, a#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModModAuto (correctness)"} Impl$$DivMod.__default.LemmaModModAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var a#0_0: int;
  var b#0_0: int;
  var x##0_0: int;
  var a##0_0: int;
  var b##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModModAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1535,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, a#0_0, b#0_0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} 0 < a#0_0;
    goto anon3;

  anon11_Else:
    assume {:partition} a#0_0 <= 0;
    goto anon3;

  anon3:
    assume true;
    assume 0 < a#0_0 && 0 < b#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} 0 < Mul(a#0_0, b#0_0);
    assume {:subsumption 0} Mul(a#0_0, b#0_0) != 0;
    assume {:subsumption 0} a#0_0 != 0;
    assume {:subsumption 0} a#0_0 != 0;
    goto anon6;

  anon13_Else:
    assume {:partition} Mul(a#0_0, b#0_0) <= 0;
    goto anon6;

  anon6:
    assume true;
    assume 0 < Mul(a#0_0, b#0_0) && Mod(Mod(x#0_0, Mul(a#0_0, b#0_0)), a#0_0) == Mod(x#0_0, a#0_0);
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    call CallPre$$DivMod.__default.LemmaModMod(x##0_0, a##0_0, b##0_0);
    call CallPost$$DivMod.__default.LemmaModMod(x##0_0, a##0_0, b##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1539,26)"} true;
    assume 0 < Mul(a#0_0, b#0_0);
    assume Mod(Mod(x#0_0, Mul(a#0_0, b#0_0)), a#0_0) == Mod(x#0_0, a#0_0);
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, a#0_1: int, b#0_1: int :: { Mod(x#0_1, Mul(a#0_1, b#0_1)) } 0 < a#0_1 && 0 < b#0_1 ==> 0 < Mul(a#0_1, b#0_1) && Mod(Mod(x#0_1, Mul(a#0_1, b#0_1)), a#0_1) == Mod(x#0_1, a#0_1));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1540,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound2 (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound2 (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound2", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1543,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < y#0;
    assume 0 < z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1547,18): post-state"} true;
    assume Mul(y#0, z#0) > 0;
    assume y#0 != 0;
    assume Mul(y#0, z#0) != 0;
    assume Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < y#0;
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound2 (call precondtion)"} CallPre$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int);
  requires {:id "id13629"} LitInt(0) <= x#0;
  requires {:id "id13630"} 0 < y#0;
  requires {:id "id13631"} 0 < z#0;



procedure {:verboseName "DivMod.LemmaPartBound2 (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13632"} Mul(y#0, z#0) > 0;
  free ensures true;
  free ensures {:id "id13633"} Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < y#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaPartBound2 (correctness)"} Impl$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id13634"} LitInt(0) <= x#0;
  requires {:id "id13635"} 0 < y#0;
  requires {:id "id13636"} 0 < z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13637"} Mul(y#0, z#0) > 0;
  free ensures true;
  free ensures {:id "id13638"} Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < y#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound2 (correctness)"} Impl$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var m##0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound2", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1549,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1550,34)"} true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1551,28)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume Mod(x#0, y#0) < y#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1552,20)"} true;
    call CallPre$$Mul.__default.LemmaMulIncreasesAuto();
    call CallPost$$Mul.__default.LemmaMulIncreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1553,27)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1554,31)"} true;
    assume true;
    assume y#0 <= Mul(y#0, z#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1555,21)"} true;
    assume {:subsumption 0} y#0 != 0;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} LitInt(0) <= Mod(x#0, y#0);
    assume {:subsumption 0} y#0 != 0;
    goto anon2;

  anon3_Else:
    assume {:partition} Mod(x#0, y#0) < LitInt(0);
    goto anon2;

  anon2:
    assume true;
    assume {:subsumption 0} LitInt(0) <= Mod(x#0, y#0);
    assume {:subsumption 0} Mod(x#0, y#0) < Mul(y#0, z#0);
    assume LitInt(0) <= Mod(x#0, y#0) && Mod(x#0, y#0) < Mul(y#0, z#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1556,29)"} true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1557,28)"} true;
    assume y#0 != 0;
    assume true;
    assume $Is(Mod(x#0, y#0), Tclass._System.nat());
    x##0 := Mod(x#0, y#0);
    assume true;
    assume $Is(Mul(y#0, z#0), Tclass._System.nat());
    m##0 := Mul(y#0, z#0);
    call CallPre$$DivMod.__default.LemmaSmallMod(x##0, m##0);
    call CallPost$$DivMod.__default.LemmaSmallMod(x##0, m##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1558,31)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume Mod(Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1559,37)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound2Auto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound2Auto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound2Auto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaPartBound2Auto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var z#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound2Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1562,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1563,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc z#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < y#0;
    assume 0 < z#0;
    assume Mul(y#0, z#0) > 0;
    assume y#0 != 0;
    assume Mul(y#0, z#0) != 0;
    assume Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < y#0;
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < y#0 && 0 < z#0 ==> Mul(y#0, z#0) > 0 && Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < y#0;
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, y#1) } LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mul(y#1, z#1) > 0) && (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, y#1) } LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(Mod(x#1, y#1), Mul(y#1, z#1)) < y#1);
    return;
}



procedure {:verboseName "DivMod.LemmaPartBound2Auto (call precondtion)"} CallPre$$DivMod.__default.LemmaPartBound2Auto();



procedure {:verboseName "DivMod.LemmaPartBound2Auto (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound2Auto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13675"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, y#1) } LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mul(y#1, z#1) > 0);
  free ensures {:id "id13676"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, y#1) } LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(Mod(x#1, y#1), Mul(y#1, z#1)) < y#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaPartBound2Auto (correctness)"} Impl$$DivMod.__default.LemmaPartBound2Auto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13677"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, y#1) } LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mul(y#1, z#1) > 0);
  free ensures {:id "id13678"} (forall x#1: int, y#1: int, z#1: int :: { Mul(y#1, z#1), Mod(x#1, y#1) } LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(Mod(x#1, y#1), Mul(y#1, z#1)) < y#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaPartBound2Auto (correctness)"} Impl$$DivMod.__default.LemmaPartBound2Auto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound2Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1565,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < y#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < y#0_0);
    goto anon5;

  anon5:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < y#0_0 && 0 < z#0_0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Mul(y#0_0, z#0_0) > 0;
    assume {:subsumption 0} y#0_0 != 0;
    assume {:subsumption 0} Mul(y#0_0, z#0_0) != 0;
    goto anon8;

  anon16_Else:
    assume {:partition} 0 >= Mul(y#0_0, z#0_0);
    goto anon8;

  anon8:
    assume true;
    assume Mul(y#0_0, z#0_0) > 0 && Mod(Mod(x#0_0, y#0_0), Mul(y#0_0, z#0_0)) < y#0_0;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaPartBound2(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaPartBound2(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1569,30)"} true;
    assume Mul(y#0_0, z#0_0) > 0;
    assume Mod(Mod(x#0_0, y#0_0), Mul(y#0_0, z#0_0)) < y#0_0;
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: LitInt(0) <= x#0_1 && 0 < y#0_1 && 0 < z#0_1 ==> Mul(y#0_1, z#0_1) > 0) && (forall x#0_2: int, y#0_2: int, z#0_2: int :: { Mod(Mod(x#0_2, y#0_2), Mul(y#0_2, z#0_2)) } LitInt(0) <= x#0_2 && 0 < y#0_2 && 0 < z#0_2 ==> Mod(Mod(x#0_2, y#0_2), Mul(y#0_2, z#0_2)) < y#0_2);
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1570,4)"} true;
    return;
}



procedure {:verboseName "DivMod.LemmaModBreakdown (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModBreakdown (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBreakdown", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1575,8): initial state"} true;
    assume LitInt(0) <= x#0;
    assume 0 < y#0;
    assume 0 < z#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1579,18): post-state"} true;
    assume Mul(y#0, z#0) > 0;
    assume Mul(y#0, z#0) != 0;
    assume y#0 != 0;
    assume z#0 != 0;
    assume y#0 != 0;
    assume Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModBreakdown (call precondtion)"} CallPre$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int);
  requires {:id "id13696"} LitInt(0) <= x#0;
  requires {:id "id13697"} 0 < y#0;
  requires {:id "id13698"} 0 < z#0;



procedure {:verboseName "DivMod.LemmaModBreakdown (call postcondition)"} CallPost$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13699"} Mul(y#0, z#0) > 0;
  free ensures true;
  free ensures {:id "id13700"} Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModBreakdown (correctness)"} Impl$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id13701"} LitInt(0) <= x#0;
  requires {:id "id13702"} 0 < y#0;
  requires {:id "id13703"} 0 < z#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13704"} Mul(y#0, z#0) > 0;
  free ensures true;
  free ensures {:id "id13705"} Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModBreakdown (correctness)"} Impl$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x##0: int;
  var d##0: int;
  var x##0_3_0: int;
  var y##0_3_0: int;
  var z##0_3_0: int;
  var a##0_4_0: int;
  var b##0_4_0: int;
  var c##0_4_0: int;
  var x##1_0_0: int;
  var b##1_0_0: int;
  var c##1_0_0: int;
  var x##1_1_0: int;
  var y##1_1_0: int;
  var x##1_1_1: int;
  var m##1_1_0: int;
  var x##1_2_0: int;
  var y##1_2_0: int;
  var a##1_2_0: int;
  var b##1_2_0: int;
  var d##1_2_0: int;
  var x##1_3_0: int;
  var d##1_3_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBreakdown", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1581,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1582,34)"} true;
    assume true;
    x##0 := x#0;
    assume true;
    d##0 := y#0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPos(x##0, d##0);
    call CallPost$$DivMod.__default.LemmaDivPosIsPos(x##0, d##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1583,26)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume LitInt(0) <= Div(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1584,21)"} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume false;
    goto anon7;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    push;
    push;
    assume true;
    a##0_4_0 := x#0;
    assume true;
    b##0_4_0 := y#0;
    assume true;
    c##0_4_0 := z#0;
    call CallPre$$DivMod.__default.LemmaPartBound1(a##0_4_0, b##0_4_0, c##0_4_0);
    call CallPost$$DivMod.__default.LemmaPartBound1(a##0_4_0, b##0_4_0, c##0_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1588,36)"} true;
    pop;
    pop;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) <= Mul(y#0, z#0 - 1) + Mod(Mod(x#0, y#0), Mul(y#0, z#0));
    assume false;
    goto anon7;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    push;
    push;
    assume true;
    x##0_3_0 := x#0;
    assume true;
    y##0_3_0 := y#0;
    assume true;
    z##0_3_0 := z#0;
    call CallPre$$DivMod.__default.LemmaPartBound2(x##0_3_0, y##0_3_0, z##0_3_0);
    call CallPost$$DivMod.__default.LemmaPartBound2(x##0_3_0, y##0_3_0, z##0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1590,35)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < Mul(y#0, z#0 - 1) + y#0;
    assume false;
    goto anon7;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1592,32)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1) + y#0 == Mul(y#0, z#0 - 1) + Mul(y#0, LitInt(1));
    assume false;
    goto anon7;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1594,40)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1) + Mul(y#0, LitInt(1)) == Mul(y#0, z#0 - 1 + 1);
    assume false;
    goto anon7;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume true;
    push;
    pop;
    assume true;
    assume {:subsumption 0} Mul(y#0, z#0 - 1 + 1) == Mul(y#0, z#0);
    assume false;
    goto anon7;

  anon21_Else:
    goto anon7;

  anon7:
    assume Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < Mul(y#0, z#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume false;
    goto anon15;

  anon22_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume true;
    x##1_3_0 := x#0;
    assume true;
    d##1_3_0 := y#0;
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##1_3_0, d##1_3_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##1_3_0, d##1_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1601,36)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(x#0, Mul(y#0, z#0)) == Mod(Mul(y#0, Div(x#0, y#0)) + Mod(x#0, y#0), Mul(y#0, z#0));
    assume false;
    goto anon15;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1604,32)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume LitInt(0) <= Mod(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1605,25)"} true;
    assume true;
    x##1_2_0 := y#0;
    assume y#0 != 0;
    assume true;
    y##1_2_0 := Div(x#0, y#0);
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##1_2_0, y##1_2_0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##1_2_0, y##1_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1606,37)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) < Mul(y#0, z#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1607,66)"} true;
    assume y#0 != 0;
    assume true;
    a##1_2_0 := Mul(y#0, Div(x#0, y#0));
    assume y#0 != 0;
    assume true;
    b##1_2_0 := Mod(x#0, y#0);
    assume true;
    d##1_2_0 := Mul(y#0, z#0);
    call CallPre$$DivMod.__default.LemmaModAdds(a##1_2_0, b##1_2_0, d##1_2_0);
    call CallPost$$DivMod.__default.LemmaModAdds(a##1_2_0, b##1_2_0, d##1_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1608,47)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)) + Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0));
    assume false;
    goto anon15;

  anon24_Else:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1612,32)"} true;
    assume true;
    x##1_1_0 := z#0;
    assume true;
    y##1_1_0 := y#0;
    call CallPre$$Mul.__default.LemmaMulIncreases(x##1_1_0, y##1_1_0);
    call CallPost$$Mul.__default.LemmaMulIncreases(x##1_1_0, y##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1613,31)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1614,35)"} true;
    assume {:subsumption 0} y#0 != 0;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} Mod(x#0, y#0) < y#0;
    goto anon13;

  anon26_Else:
    assume {:partition} y#0 <= Mod(x#0, y#0);
    goto anon13;

  anon13:
    assume true;
    assume {:subsumption 0} Mod(x#0, y#0) < y#0;
    assume {:subsumption 0} y#0 <= Mul(y#0, z#0);
    assume Mod(x#0, y#0) < y#0 && y#0 <= Mul(y#0, z#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1615,33)"} true;
    assume y#0 != 0;
    assume true;
    assume $Is(Mod(x#0, y#0), Tclass._System.nat());
    x##1_1_1 := Mod(x#0, y#0);
    assume true;
    assume $Is(Mul(y#0, z#0), Tclass._System.nat());
    m##1_1_0 := Mul(y#0, z#0);
    call CallPre$$DivMod.__default.LemmaSmallMod(x##1_1_1, m##1_1_0);
    call CallPost$$DivMod.__default.LemmaSmallMod(x##1_1_1, m##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1616,35)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume Mod(Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(x#0, y#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1617,41)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(Mod(x#0, y#0), Mul(y#0, z#0)) == Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(x#0, y#0);
    assume false;
    goto anon15;

  anon25_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} Mul(y#0, z#0) != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume y#0 != 0;
    assume true;
    x##1_0_0 := Div(x#0, y#0);
    assume true;
    b##1_0_0 := y#0;
    assume true;
    c##1_0_0 := z#0;
    call CallPre$$DivMod.__default.LemmaTruncateMiddle(x##1_0_0, b##1_0_0, c##1_0_0);
    call CallPost$$DivMod.__default.LemmaTruncateMiddle(x##1_0_0, b##1_0_0, c##1_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1620,40)"} true;
    assume {:subsumption 0} y#0 != 0;
    assume {:subsumption 0} z#0 != 0;
    assume {:subsumption 0} y#0 != 0;
    assume true;
    assume {:subsumption 0} Mod(Mul(y#0, Div(x#0, y#0)), Mul(y#0, z#0)) + Mod(x#0, y#0) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    assume false;
    goto anon15;

  anon27_Else:
    goto anon15;

  anon15:
    assume Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    return;
}



procedure {:verboseName "DivMod.LemmaModBreakdownAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModBreakdownAuto();
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModBreakdownAuto (well-formedness)"} CheckWellFormed$$DivMod.__default.LemmaModBreakdownAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var y#0: int;
  var z#0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBreakdownAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1625,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1626,12): post-state"} true;
    havoc x#0;
    havoc y#0;
    havoc z#0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume LitInt(0) <= x#0;
    assume 0 < y#0;
    assume 0 < z#0;
    assume Mul(y#0, z#0) > 0;
    assume Mul(y#0, z#0) != 0;
    assume y#0 != 0;
    assume z#0 != 0;
    assume y#0 != 0;
    assume Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    goto anon4;

  anon5_Else:
    assume LitInt(0) <= x#0 && 0 < y#0 && 0 < z#0 ==> Mul(y#0, z#0) > 0 && Mod(x#0, Mul(y#0, z#0)) == Mul(y#0, Mod(Div(x#0, y#0), z#0)) + Mod(x#0, y#0);
    goto anon4;

  anon4:
    assume (forall x#1: int, y#1: int, z#1: int :: { Mod(x#1, Mul(y#1, z#1)) } (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mul(y#1, z#1) > 0) && (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(x#1, Mul(y#1, z#1)) == Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1)));
    return;
}



procedure {:verboseName "DivMod.LemmaModBreakdownAuto (call precondtion)"} CallPre$$DivMod.__default.LemmaModBreakdownAuto();



procedure {:verboseName "DivMod.LemmaModBreakdownAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModBreakdownAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13819"} (forall x#1: int, y#1: int, z#1: int :: { Mod(x#1, Mul(y#1, z#1)) } (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mul(y#1, z#1) > 0) && (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(x#1, Mul(y#1, z#1)) == Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "DivMod.LemmaModBreakdownAuto (correctness)"} Impl$$DivMod.__default.LemmaModBreakdownAuto() returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id13820"} (forall x#1: int, y#1: int, z#1: int :: { Mod(x#1, Mul(y#1, z#1)) } (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mul(y#1, z#1) > 0) && (LitInt(0) <= x#1 && 0 < y#1 && 0 < z#1 ==> Mod(x#1, Mul(y#1, z#1)) == Mul(y#1, Mod(Div(x#1, y#1), z#1)) + Mod(x#1, y#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DivMod.LemmaModBreakdownAuto (correctness)"} Impl$$DivMod.__default.LemmaModBreakdownAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBreakdownAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1628,2): initial state"} true;
    $_reverifyPost := false;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc x#0_0, y#0_0, z#0_0;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= x#0_0;
    goto anon3;

  anon13_Else:
    assume {:partition} x#0_0 < LitInt(0);
    goto anon3;

  anon3:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= x#0_0 && 0 < y#0_0;
    goto anon5;

  anon14_Else:
    assume {:partition} !(LitInt(0) <= x#0_0 && 0 < y#0_0);
    goto anon5;

  anon5:
    assume true;
    assume LitInt(0) <= x#0_0 && 0 < y#0_0 && 0 < z#0_0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Mul(y#0_0, z#0_0) > 0;
    assume {:subsumption 0} Mul(y#0_0, z#0_0) != 0;
    assume {:subsumption 0} y#0_0 != 0;
    assume {:subsumption 0} z#0_0 != 0;
    assume {:subsumption 0} y#0_0 != 0;
    goto anon8;

  anon16_Else:
    assume {:partition} 0 >= Mul(y#0_0, z#0_0);
    goto anon8;

  anon8:
    assume true;
    assume Mul(y#0_0, z#0_0) > 0 && Mod(x#0_0, Mul(y#0_0, z#0_0)) == Mul(y#0_0, Mod(Div(x#0_0, y#0_0), z#0_0)) + Mod(x#0_0, y#0_0);
    assume false;
    goto anon9;

  anon15_Else:
    goto anon9;

  anon9:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$DivMod.__default.LemmaModBreakdown(x##0_0, y##0_0, z##0_0);
    call CallPost$$DivMod.__default.LemmaModBreakdown(x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1632,32)"} true;
    assume Mul(y#0_0, z#0_0) > 0;
    assume Mod(x#0_0, Mul(y#0_0, z#0_0)) == Mul(y#0_0, Mod(Div(x#0_0, y#0_0), z#0_0)) + Mod(x#0_0, y#0_0);
    assume false;
    goto anon11;

  anon12_Else:
    assume (forall x#0_1: int, y#0_1: int, z#0_1: int :: { Mod(Div(x#0_1, y#0_1), z#0_1) } { Mod(x#0_1, Mul(y#0_1, z#0_1)) } LitInt(0) <= x#0_1 && 0 < y#0_1 && 0 < z#0_1 ==> Mul(y#0_1, z#0_1) > 0 && Mod(x#0_1, Mul(y#0_1, z#0_1)) == Mul(y#0_1, Mod(Div(x#0_1, y#0_1), z#0_1)) + Mod(x#0_1, y#0_1));
    goto anon11;

  anon11:
    assume {:captureState "libraries/src/NonlinearArithmetic/DivMod.dfy(1633,4)"} true;
    return;
}



axiom MulInternals.__default.MulAuto() <==> (forall x#30: int, y#30: int :: { Mul(x#30, y#30) } Mul(x#30, y#30) == Mul(y#30, x#30)) && (forall x#31: int, y#31: int, z#20: int :: { Mul(x#31 + y#31, z#20) } Mul(x#31 + y#31, z#20) == Mul(x#31, z#20) + Mul(y#31, z#20)) && (forall x#32: int, y#32: int, z#21: int :: { Mul(x#32 - y#32, z#21) } Mul(x#32 - y#32, z#21) == Mul(x#32, z#21) - Mul(y#32, z#21));

axiom MulInternals.__default.MulAuto() <==> (forall x#33: int, y#33: int :: { Mul(x#33, y#33) } Mul(x#33, y#33) == Mul(y#33, x#33)) && (forall x#34: int, y#34: int, z#22: int :: { Mul(x#34 + y#34, z#22) } Mul(x#34 + y#34, z#22) == Mul(x#34, z#22) + Mul(y#34, z#22)) && (forall x#35: int, y#35: int, z#23: int :: { Mul(x#35 - y#35, z#23) } Mul(x#35 - y#35, z#23) == Mul(x#35, z#23) - Mul(y#35, z#23));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#24: int :: { Mod(Mod(x#24, n#0), n#0) } Mod(Mod(x#24, n#0), n#0) == Mod(x#24, n#0)) && (forall x#25: int :: { Mod(x#25, n#0) } LitInt(0) <= x#25 && x#25 < n#0 <==> Mod(x#25, n#0) == x#25) && (forall x#26: int, y#12: int :: { Mod(x#26 + y#12, n#0) } (var z#10 := Mod(x#26, n#0) + Mod(y#12, n#0); (LitInt(0) <= z#10 && z#10 < n#0 && Mod(x#26 + y#12, n#0) == z#10) || (n#0 <= z#10 && z#10 < n#0 + n#0 && Mod(x#26 + y#12, n#0) == z#10 - n#0))) && (forall x#27: int, y#13: int :: { Mod(x#27 - y#13, n#0) } (var z#11 := Mod(x#27, n#0) - Mod(y#13, n#0); (LitInt(0) <= z#11 && z#11 < n#0 && Mod(x#27 - y#13, n#0) == z#11) || (0 - n#0 <= z#11 && z#11 < 0 && Mod(x#27 - y#13, n#0) == z#11 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#28: int :: { Mod(Mod(x#28, n#0), n#0) } Mod(Mod(x#28, LitInt(n#0)), LitInt(n#0)) == Mod(x#28, LitInt(n#0))) && (forall x#29: int :: { Mod(x#29, n#0) } LitInt(0) <= x#29 && x#29 < n#0 <==> Mod(x#29, LitInt(n#0)) == x#29) && (forall x#30: int, y#14: int :: { Mod(x#30 + y#14, n#0) } (var z#12 := Mod(x#30, LitInt(n#0)) + Mod(y#14, LitInt(n#0)); (LitInt(0) <= z#12 && z#12 < n#0 && Mod(x#30 + y#14, LitInt(n#0)) == z#12) || (LitInt(n#0) <= z#12 && z#12 < n#0 + n#0 && Mod(x#30 + y#14, LitInt(n#0)) == z#12 - n#0))) && (forall x#31: int, y#15: int :: { Mod(x#31 - y#15, n#0) } (var z#13 := Mod(x#31, LitInt(n#0)) - Mod(y#15, LitInt(n#0)); (LitInt(0) <= z#13 && z#13 < n#0 && Mod(x#31 - y#15, LitInt(n#0)) == z#13) || (LitInt(0 - n#0) <= z#13 && z#13 < 0 && Mod(x#31 - y#15, LitInt(n#0)) == z#13 + n#0)))));

axiom (forall $ly: LayerType, x#0: int, d#0: int :: { DivInternals.__default.DivPos($LS($ly), true, x#0, d#0) } DivInternals.__default.DivPos#canCall(x#0, d#0) || d#0 > 0 ==> (x#0 < 0 ==> DivInternals.__default.DivPos#canCall(x#0 + d#0, d#0)) && (0 <= x#0 ==> d#0 <= x#0 ==> DivInternals.__default.DivPos#canCall(x#0 - d#0, d#0)) && DivInternals.__default.DivPos($LS($ly), true, x#0, d#0) == (if x#0 < 0 then -1 + DivInternals.__default.DivPos($ly, reveal_DivInternals._default.DivPos, x#0 + d#0, d#0) else (if x#0 < d#0 then 0 else 1 + DivInternals.__default.DivPos($ly, reveal_DivInternals._default.DivPos, x#0 - d#0, d#0))));

axiom (forall $ly: LayerType, x#0: int, d#0: int :: {:weight 3} { DivInternals.__default.DivPos($LS($ly), true, LitInt(x#0), LitInt(d#0)) } DivInternals.__default.DivPos#canCall(LitInt(x#0), LitInt(d#0)) || Lit(d#0 > 0) ==> (Lit(x#0 < 0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0 + d#0), LitInt(d#0))) && (!Lit(x#0 < 0) ==> !Lit(x#0 < d#0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0 - d#0), LitInt(d#0))) && DivInternals.__default.DivPos($LS($ly), true, LitInt(x#0), LitInt(d#0)) == (if x#0 < 0 then -1 + DivInternals.__default.DivPos($LS($ly), reveal_DivInternals._default.DivPos, LitInt(x#0 + d#0), LitInt(d#0)) else (if x#0 < d#0 then 0 else 1 + DivInternals.__default.DivPos($LS($ly), reveal_DivInternals._default.DivPos, LitInt(x#0 - d#0), LitInt(d#0)))));

axiom (forall x#0: int, d#0: int :: { DivInternals.__default.DivRecursive(true, x#0, d#0) } DivInternals.__default.DivRecursive#canCall(x#0, d#0) || d#0 != 0 ==> (d#0 > 0 ==> DivInternals.__default.DivPos#canCall(x#0, d#0)) && (0 >= d#0 ==> DivInternals.__default.DivPos#canCall(x#0, Mul(LitInt(-1), d#0))) && DivInternals.__default.DivRecursive(true, x#0, d#0) == (if d#0 > 0 then DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, d#0) else Mul(LitInt(-1), DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, x#0, Mul(LitInt(-1), d#0)))));

axiom (forall x#0: int, d#0: int :: {:weight 3} { DivInternals.__default.DivRecursive(true, LitInt(x#0), LitInt(d#0)) } DivInternals.__default.DivRecursive#canCall(LitInt(x#0), LitInt(d#0)) || Lit(d#0 != 0) ==> (Lit(d#0 > 0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0), LitInt(d#0))) && (!Lit(d#0 > 0) ==> DivInternals.__default.DivPos#canCall(LitInt(x#0), LitInt(Mul(LitInt(-1), LitInt(d#0))))) && DivInternals.__default.DivRecursive(true, LitInt(x#0), LitInt(d#0)) == (if d#0 > 0 then DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, LitInt(x#0), LitInt(d#0)) else Mul(LitInt(-1), DivInternals.__default.DivPos($LS($LZ), reveal_DivInternals._default.DivPos, LitInt(x#0), LitInt(Mul(LitInt(-1), LitInt(d#0)))))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#12: int :: { Div(x#12, n#0) } LitInt(0) <= x#12 && x#12 < n#0 <==> Div(x#12, n#0) == LitInt(0)) && (forall x#13: int, y#8: int :: { Div(x#13 + y#8, n#0) } (var z#6 := Mod(x#13, n#0) + Mod(y#8, n#0); (LitInt(0) <= z#6 && z#6 < n#0 && Div(x#13 + y#8, n#0) == Div(x#13, n#0) + Div(y#8, n#0)) || (n#0 <= z#6 && z#6 < n#0 + n#0 && Div(x#13 + y#8, n#0) == Div(x#13, n#0) + Div(y#8, n#0) + 1))) && (forall x#14: int, y#9: int :: { Div(x#14 - y#9, n#0) } (var z#7 := Mod(x#14, n#0) - Mod(y#9, n#0); (LitInt(0) <= z#7 && z#7 < n#0 && Div(x#14 - y#9, n#0) == Div(x#14, n#0) - Div(y#9, n#0)) || (0 - n#0 <= z#7 && z#7 < 0 && Div(x#14 - y#9, n#0) == Div(x#14, n#0) - Div(y#9, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#15: int :: { Div(x#15, n#0) } LitInt(0) <= x#15 && x#15 < n#0 <==> Div(x#15, LitInt(n#0)) == LitInt(0)) && (forall x#16: int, y#10: int :: { Div(x#16 + y#10, n#0) } (var z#8 := Mod(x#16, LitInt(n#0)) + Mod(y#10, LitInt(n#0)); (LitInt(0) <= z#8 && z#8 < n#0 && Div(x#16 + y#10, LitInt(n#0)) == Div(x#16, LitInt(n#0)) + Div(y#10, LitInt(n#0))) || (LitInt(n#0) <= z#8 && z#8 < n#0 + n#0 && Div(x#16 + y#10, LitInt(n#0)) == Div(x#16, LitInt(n#0)) + Div(y#10, LitInt(n#0)) + 1))) && (forall x#17: int, y#11: int :: { Div(x#17 - y#11, n#0) } (var z#9 := Mod(x#17, LitInt(n#0)) - Mod(y#11, LitInt(n#0)); (LitInt(0) <= z#9 && z#9 < n#0 && Div(x#17 - y#11, LitInt(n#0)) == Div(x#17, LitInt(n#0)) - Div(y#11, LitInt(n#0))) || (LitInt(0 - n#0) <= z#9 && z#9 < 0 && Div(x#17 - y#11, LitInt(n#0)) == Div(x#17, LitInt(n#0)) - Div(y#11, LitInt(n#0)) - 1)))));

const reveal_Power._default.Pow: bool;

const unique class.Power.__default: ClassName;

function Power.__default.Pow($ly: LayerType, $reveal: bool, b#0: int, e#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, b#0: int, e#0: int :: { Power.__default.Pow($LS($ly), true, b#0, e#0) } Power.__default.Pow#canCall(b#0, e#0) || (0 < $FunctionContextHeight && LitInt(0) <= e#0) ==> (e#0 != LitInt(0) ==> Power.__default.Pow#canCall(b#0, e#0 - 1)) && Power.__default.Pow($LS($ly), true, b#0, e#0) == (if e#0 == LitInt(0) then 1 else Mul(b#0, Power.__default.Pow($ly, reveal_Power._default.Pow, b#0, e#0 - 1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, b#0: int, e#0: int :: {:weight 3} { Power.__default.Pow($LS($ly), true, b#0, LitInt(e#0)) } Power.__default.Pow#canCall(b#0, LitInt(e#0)) || (0 < $FunctionContextHeight && LitInt(0) <= e#0) ==> (LitInt(e#0) != LitInt(0) ==> Power.__default.Pow#canCall(b#0, LitInt(e#0 - 1))) && Power.__default.Pow($LS($ly), true, b#0, LitInt(e#0)) == (if LitInt(e#0) == LitInt(0) then 1 else Mul(b#0, Power.__default.Pow($LS($ly), reveal_Power._default.Pow, b#0, LitInt(e#0 - 1)))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, b#0: int, e#0: int :: {:weight 3} { Power.__default.Pow($LS($ly), true, LitInt(b#0), LitInt(e#0)) } Power.__default.Pow#canCall(LitInt(b#0), LitInt(e#0)) || (0 < $FunctionContextHeight && LitInt(0) <= e#0) ==> (LitInt(e#0) != LitInt(0) ==> Power.__default.Pow#canCall(LitInt(b#0), LitInt(e#0 - 1))) && Power.__default.Pow($LS($ly), true, LitInt(b#0), LitInt(e#0)) == (if LitInt(e#0) == LitInt(0) then 1 else Mul(LitInt(b#0), Power.__default.Pow($LS($ly), reveal_Power._default.Pow, LitInt(b#0), LitInt(e#0 - 1)))));
}

function Power.__default.Pow#canCall(b#0: int, e#0: int) : bool;

axiom (forall $ly: LayerType, $reveal: bool, b#0: int, e#0: int :: { Power.__default.Pow($LS($ly), $reveal, b#0, e#0) } Power.__default.Pow($LS($ly), $reveal, b#0, e#0) == Power.__default.Pow($ly, $reveal, b#0, e#0));

axiom (forall $ly: LayerType, $reveal: bool, b#0: int, e#0: int :: { Power.__default.Pow(AsFuelBottom($ly), $reveal, b#0, e#0) } Power.__default.Pow($ly, $reveal, b#0, e#0) == Power.__default.Pow($LZ, $reveal, b#0, e#0));

function Power.__default.Pow#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, b#0: int, e#0: int :: { Power.__default.Pow#requires($ly, b#0, e#0) } LitInt(0) <= e#0 ==> (Power.__default.Pow#requires($ly, b#0, e#0) <==> true));

procedure {:verboseName "Power.Pow (well-formedness)"} CheckWellformed$$Power.__default.Pow(b#0: int, e#0: int where LitInt(0) <= e#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.Pow (well-formedness)"} CheckWellformed$$Power.__default.Pow(b#0: int, e#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.Pow", " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(26,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} e#0 == LitInt(0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0) == LitInt(1);
    assume true;
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), TInt);
    return;

  anon7_Else:
    assume {:partition} e#0 != LitInt(0);
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0 := e#0 - 1;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume 0 <= e#0 || ##e#0 == e#0;
    assume ##e#0 < e#0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0) == Mul(b#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0 - 1));
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), TInt);
    return;
}



procedure {:verboseName "Power.LemmaPow0 (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow0(b#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow0 (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow0(b#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow0", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(36,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(37,22): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, LitInt(0)) == LitInt(1);
    return;
}



procedure {:verboseName "Power.LemmaPow0 (call precondtion)"} CallPre$$Power.__default.LemmaPow0(b#0: int);



procedure {:verboseName "Power.LemmaPow0 (call postcondition)"} CallPost$$Power.__default.LemmaPow0(b#0: int);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, LitInt(0));
  free ensures {:id "id13899"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(0)) == LitInt(1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPow0 (correctness)"} Impl$$Power.__default.LemmaPow0(b#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, LitInt(0));
  free ensures {:id "id13900"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(0)) == LitInt(1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow0 (correctness)"} Impl$$Power.__default.LemmaPow0(b#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow0", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(38,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int :: Lit(true) && 0 <= $ih#b0#0 && $ih#b0#0 < b#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, LitInt(0)) == LitInt(1));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(39,15)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPow0Auto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow0Auto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow0Auto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow0Auto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow0Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(42,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(43,12): post-state"} true;
    havoc b#0;
    assume LitInt(0) <= b#0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, LitInt(0)) == LitInt(1);
    assume (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 0) } LitInt(0) <= b#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, LitInt(0)) == LitInt(1));
    return;
}



procedure {:verboseName "Power.LemmaPow0Auto (call precondtion)"} CallPre$$Power.__default.LemmaPow0Auto();



procedure {:verboseName "Power.LemmaPow0Auto (call postcondition)"} CallPost$$Power.__default.LemmaPow0Auto();
  modifies $Heap;
  free ensures (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 0) } LitInt(0) <= b#1 ==> Power.__default.Pow#canCall(b#1, LitInt(0)));
  free ensures {:id "id13906"} (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 0) } LitInt(0) <= b#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, LitInt(0)) == LitInt(1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPow0Auto (correctness)"} Impl$$Power.__default.LemmaPow0Auto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 0) } LitInt(0) <= b#1 ==> Power.__default.Pow#canCall(b#1, LitInt(0)));
  free ensures {:id "id13907"} (forall b#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, 0) } LitInt(0) <= b#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, LitInt(0)) == LitInt(1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow0Auto (correctness)"} Impl$$Power.__default.LemmaPow0Auto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var b##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow0Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(44,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(45,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0;
    assume LitInt(0) <= b#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0_0 := LitInt(0);
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, LitInt(0));
    assume Power.__default.Pow#canCall(b#0_0, LitInt(0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, LitInt(0)) == LitInt(1);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    call CallPre$$Power.__default.LemmaPow0(b##0_0);
    call CallPost$$Power.__default.LemmaPow0(b##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(49,18)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, LitInt(0)) == LitInt(1);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, 0) } LitInt(0) <= b#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, LitInt(0)) == LitInt(1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(50,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPow1 (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow1(b#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow1 (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow1(b#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow1", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(54,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(55,22): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0 := LitInt(1);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, LitInt(1)) == b#0;
    return;
}



procedure {:verboseName "Power.LemmaPow1 (call precondtion)"} CallPre$$Power.__default.LemmaPow1(b#0: int);



procedure {:verboseName "Power.LemmaPow1 (call postcondition)"} CallPost$$Power.__default.LemmaPow1(b#0: int);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, LitInt(1));
  free ensures {:id "id13918"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1)) == b#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPow1 (correctness)"} Impl$$Power.__default.LemmaPow1(b#0: int) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, LitInt(1));
  free ensures {:id "id13919"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1)) == b#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow1 (correctness)"} Impl$$Power.__default.LemmaPow1(b#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_1_0: int;
  var ##e#0_1_0: int;
  var b##0_1_0: int;
  var ##b#0_2_0: int;
  var ##e#0_2_0: int;
  var ##b#0_2_1: int;
  var ##e#0_2_1: int;
  var ##b#0_0: int;
  var ##e#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow1", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(56,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int :: Lit(true) && 0 <= $ih#b0#0 && $ih#b0#0 < b#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, LitInt(1)) == $ih#b0#0);
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_0 := LitInt(1);
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume false;
    goto anon5;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_2_0 := b#0;
    assume $IsAlloc(##b#0_2_0, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_2_0 := LitInt(1);
    assume $IsAlloc(##e#0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(59,19)"} true;
    ##b#0_2_1 := b#0;
    assume $IsAlloc(##b#0_2_1, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0_2_1 := LitInt(0);
    assume $IsAlloc(##e#0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(0));
    assume Power.__default.Pow#canCall(b#0, LitInt(0));
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1)) == Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(0)));
    assume false;
    goto anon5;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    ##b#0_1_0 := b#0;
    assume $IsAlloc(##b#0_1_0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0_1_0 := LitInt(0);
    assume $IsAlloc(##e#0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(0));
    assume Power.__default.Pow#canCall(b#0, LitInt(0));
    assume true;
    b##0_1_0 := b#0;
    call CallPre$$Power.__default.LemmaPow0(b##0_1_0);
    call CallPost$$Power.__default.LemmaPow0(b##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(61,20)"} true;
    assume true;
    assume {:subsumption 0} Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(0))) == Mul(b#0, LitInt(1));
    assume false;
    goto anon5;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume true;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(63,28)"} true;
    assume true;
    assume {:subsumption 0} Mul(b#0, LitInt(1)) == b#0;
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, LitInt(1)) == b#0;
    return;
}



procedure {:verboseName "Power.LemmaPow1Auto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow1Auto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow1Auto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPow1Auto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow1Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(68,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(69,12): post-state"} true;
    havoc b#0;
    assume LitInt(0) <= b#0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0 := LitInt(1);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, LitInt(1)) == b#0;
    assume (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 1) } LitInt(0) <= b#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, LitInt(1)) == b#1);
    return;
}



procedure {:verboseName "Power.LemmaPow1Auto (call precondtion)"} CallPre$$Power.__default.LemmaPow1Auto();



procedure {:verboseName "Power.LemmaPow1Auto (call postcondition)"} CallPost$$Power.__default.LemmaPow1Auto();
  modifies $Heap;
  free ensures (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 1) } LitInt(0) <= b#1 ==> Power.__default.Pow#canCall(b#1, LitInt(1)));
  free ensures {:id "id13937"} (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 1) } LitInt(0) <= b#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, LitInt(1)) == b#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPow1Auto (correctness)"} Impl$$Power.__default.LemmaPow1Auto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, 1) } LitInt(0) <= b#1 ==> Power.__default.Pow#canCall(b#1, LitInt(1)));
  free ensures {:id "id13938"} (forall b#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, 1) } LitInt(0) <= b#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, LitInt(1)) == b#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPow1Auto (correctness)"} Impl$$Power.__default.LemmaPow1Auto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var b##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPow1Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(70,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(71,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0;
    assume LitInt(0) <= b#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_0 := LitInt(1);
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0_0, LitInt(1));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, LitInt(1)) == b#0_0;
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    call CallPre$$Power.__default.LemmaPow1(b##0_0);
    call CallPost$$Power.__default.LemmaPow1(b##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(75,18)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, LitInt(1)) == b#0_0;
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, 1) } LitInt(0) <= b#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, LitInt(1)) == b#0_1);
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(76,4)"} true;
    return;
}



procedure {:verboseName "Power.Lemma0Pow (well-formedness)"} CheckWellFormed$$Power.__default.Lemma0Pow(e#0: int where LitInt(0) <= e#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.Lemma0Pow (call precondtion)"} CallPre$$Power.__default.Lemma0Pow(e#0: int where LitInt(0) <= e#0);
  requires {:id "id13949"} e#0 > 0;



procedure {:verboseName "Power.Lemma0Pow (call postcondition)"} CallPost$$Power.__default.Lemma0Pow(e#0: int where LitInt(0) <= e#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(LitInt(0), e#0);
  free ensures {:id "id13950"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(0), e#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.Lemma0Pow (correctness)"} Impl$$Power.__default.Lemma0Pow(e#0: int where LitInt(0) <= e#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id13951"} e#0 > 0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(LitInt(0), e#0);
  free ensures {:id "id13952"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(0), e#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.Lemma0Pow (correctness)"} Impl$$Power.__default.Lemma0Pow(e#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.Lemma0Pow", " | ", e#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(83,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#e0#0: int :: LitInt(0) <= $ih#e0#0 && $ih#e0#0 > 0 && 0 <= $ih#e0#0 && $ih#e0#0 < e#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(0), $ih#e0#0) == LitInt(0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(84,15)"} true;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(85,24)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} e#0 != 1;
    assume true;
    assume $Is(e#0 - 1, Tclass._System.nat());
    e##0_0 := e#0 - 1;
    assume 0 <= e#0 || e##0_0 == e#0;
    assume e##0_0 < e#0;
    call CallPre$$Power.__default.Lemma0Pow(e##0_0);
    call CallPost$$Power.__default.Lemma0Pow(e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(87,22)"} true;
    return;

  anon3_Else:
    assume {:partition} e#0 == 1;
    return;
}



procedure {:verboseName "Power.Lemma0PowAuto (well-formedness)"} CheckWellFormed$$Power.__default.Lemma0PowAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.Lemma0PowAuto (call precondtion)"} CallPre$$Power.__default.Lemma0PowAuto();



procedure {:verboseName "Power.Lemma0PowAuto (call postcondition)"} CallPost$$Power.__default.Lemma0PowAuto();
  modifies $Heap;
  free ensures (forall e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 0, e#1) } LitInt(0) <= e#1 ==> e#1 > 0 ==> Power.__default.Pow#canCall(LitInt(0), e#1));
  free ensures {:id "id13966"} (forall e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 0, e#1) } LitInt(0) <= e#1 ==> e#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(0), e#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.Lemma0PowAuto (correctness)"} Impl$$Power.__default.Lemma0PowAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 0, e#1) } LitInt(0) <= e#1 ==> e#1 > 0 ==> Power.__default.Pow#canCall(LitInt(0), e#1));
  free ensures {:id "id13967"} (forall e#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, 0, e#1) } LitInt(0) <= e#1 ==> e#1 > 0 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(0), e#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.Lemma0PowAuto (correctness)"} Impl$$Power.__default.Lemma0PowAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var e#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.Lemma0PowAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(93,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(94,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc e#0_0;
    assume LitInt(0) <= e#0_0;
    assume true;
    assume e#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := LitInt(0);
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(LitInt(0), e#0_0);
    assume Power.__default.Pow#canCall(LitInt(0), e#0_0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(0), e#0_0) == LitInt(0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    e##0_0 := e#0_0;
    call CallPre$$Power.__default.Lemma0Pow(e##0_0);
    call CallPost$$Power.__default.Lemma0Pow(e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(98,18)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(0), e#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall e#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 0, e#0_1) } LitInt(0) <= e#0_1 && e#0_1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(0), e#0_1) == LitInt(0));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(99,4)"} true;
    return;
}



procedure {:verboseName "Power.Lemma1Pow (well-formedness)"} CheckWellFormed$$Power.__default.Lemma1Pow(e#0: int where LitInt(0) <= e#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.Lemma1Pow (call precondtion)"} CallPre$$Power.__default.Lemma1Pow(e#0: int where LitInt(0) <= e#0);



procedure {:verboseName "Power.Lemma1Pow (call postcondition)"} CallPost$$Power.__default.Lemma1Pow(e#0: int where LitInt(0) <= e#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(LitInt(1), e#0);
  free ensures {:id "id13976"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(1), e#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.Lemma1Pow (correctness)"} Impl$$Power.__default.Lemma1Pow(e#0: int where LitInt(0) <= e#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(LitInt(1), e#0);
  free ensures {:id "id13977"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(1), e#0) == LitInt(1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.Lemma1Pow (correctness)"} Impl$$Power.__default.Lemma1Pow(e#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.Lemma1Pow", " | ", e#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(105,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#e0#0: int :: LitInt(0) <= $ih#e0#0 && Lit(true) && 0 <= $ih#e0#0 && $ih#e0#0 < e#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(1), $ih#e0#0) == LitInt(1));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(106,15)"} true;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(107,24)"} true;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} e#0 != 0;
    assume true;
    assume $Is(e#0 - 1, Tclass._System.nat());
    e##0_0 := e#0 - 1;
    assume 0 <= e#0 || e##0_0 == e#0;
    assume e##0_0 < e#0;
    call CallPre$$Power.__default.Lemma1Pow(e##0_0);
    call CallPost$$Power.__default.Lemma1Pow(e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(109,22)"} true;
    return;

  anon3_Else:
    assume {:partition} e#0 == 0;
    return;
}



procedure {:verboseName "Power.Lemma1PowAuto (well-formedness)"} CheckWellFormed$$Power.__default.Lemma1PowAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.Lemma1PowAuto (call precondtion)"} CallPre$$Power.__default.Lemma1PowAuto();



procedure {:verboseName "Power.Lemma1PowAuto (call postcondition)"} CallPost$$Power.__default.Lemma1PowAuto();
  modifies $Heap;
  free ensures (forall e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 1, e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow#canCall(LitInt(1), e#1));
  free ensures {:id "id13989"} (forall e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 1, e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(1), e#1) == LitInt(1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.Lemma1PowAuto (correctness)"} Impl$$Power.__default.Lemma1PowAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 1, e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow#canCall(LitInt(1), e#1));
  free ensures {:id "id13990"} (forall e#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, 1, e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(1), e#1) == LitInt(1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.Lemma1PowAuto (correctness)"} Impl$$Power.__default.Lemma1PowAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var e#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.Lemma1PowAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(115,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(116,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc e#0_0;
    assume LitInt(0) <= e#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := LitInt(1);
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(LitInt(1), e#0_0);
    assume Power.__default.Pow#canCall(LitInt(1), e#0_0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(1), e#0_0) == LitInt(1);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    e##0_0 := e#0_0;
    call CallPre$$Power.__default.Lemma1Pow(e##0_0);
    call CallPost$$Power.__default.Lemma1Pow(e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(120,18)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, LitInt(1), e#0_0) == LitInt(1);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall e#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, 1, e#0_1) } LitInt(0) <= e#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(1), e#0_1) == LitInt(1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(121,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaSquareIsPow2 (well-formedness)"} CheckWellFormed$$Power.__default.LemmaSquareIsPow2(x#0: int where LitInt(0) <= x#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaSquareIsPow2 (well-formedness)"} CheckWellFormed$$Power.__default.LemmaSquareIsPow2(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaSquareIsPow2", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(125,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(126,22): post-state"} true;
    ##b#0 := x#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(2), Tclass._System.nat());
    ##e#0 := LitInt(2);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#0, LitInt(2));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#0, LitInt(2)) == Mul(x#0, x#0);
    return;
}



procedure {:verboseName "Power.LemmaSquareIsPow2 (call precondtion)"} CallPre$$Power.__default.LemmaSquareIsPow2(x#0: int where LitInt(0) <= x#0);



procedure {:verboseName "Power.LemmaSquareIsPow2 (call postcondition)"} CallPost$$Power.__default.LemmaSquareIsPow2(x#0: int where LitInt(0) <= x#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(x#0, LitInt(2));
  free ensures {:id "id14000"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#0, LitInt(2)) == Mul(x#0, x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaSquareIsPow2 (correctness)"} Impl$$Power.__default.LemmaSquareIsPow2(x#0: int where LitInt(0) <= x#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(x#0, LitInt(2));
  free ensures {:id "id14001"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#0, LitInt(2)) == Mul(x#0, x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaSquareIsPow2 (correctness)"} Impl$$Power.__default.LemmaSquareIsPow2(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaSquareIsPow2", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(127,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: int :: LitInt(0) <= $ih#x0#0 && Lit(true) && 0 <= $ih#x0#0 && $ih#x0#0 < x#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#x0#0, LitInt(2)) == Mul($ih#x0#0, $ih#x0#0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(128,15)"} true;
    return;
}



procedure {:verboseName "Power.LemmaSquareIsPow2Auto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaSquareIsPow2Auto();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaSquareIsPow2Auto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaSquareIsPow2Auto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaSquareIsPow2Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(131,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(132,12): post-state"} true;
    havoc x#0;
    assume LitInt(0) <= x#0;
    ##b#0 := x#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(2), Tclass._System.nat());
    ##e#0 := LitInt(2);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#0, LitInt(2));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#0, LitInt(2)) == Mul(x#0, x#0);
    assume (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 2) } LitInt(0) <= x#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, LitInt(2)) == Mul(x#1, x#1));
    return;
}



procedure {:verboseName "Power.LemmaSquareIsPow2Auto (call precondtion)"} CallPre$$Power.__default.LemmaSquareIsPow2Auto();



procedure {:verboseName "Power.LemmaSquareIsPow2Auto (call postcondition)"} CallPost$$Power.__default.LemmaSquareIsPow2Auto();
  modifies $Heap;
  free ensures (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 2) } LitInt(0) <= x#1 ==> Power.__default.Pow#canCall(x#1, LitInt(2)));
  free ensures {:id "id14007"} (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 2) } LitInt(0) <= x#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, LitInt(2)) == Mul(x#1, x#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaSquareIsPow2Auto (correctness)"} Impl$$Power.__default.LemmaSquareIsPow2Auto() returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 2) } LitInt(0) <= x#1 ==> Power.__default.Pow#canCall(x#1, LitInt(2)));
  free ensures {:id "id14008"} (forall x#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#1, 2) } LitInt(0) <= x#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#1, LitInt(2)) == Mul(x#1, x#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaSquareIsPow2Auto (correctness)"} Impl$$Power.__default.LemmaSquareIsPow2Auto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaSquareIsPow2Auto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(133,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(134,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc x#0_0;
    assume LitInt(0) <= x#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := x#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(LitInt(2), Tclass._System.nat());
    ##e#0_0 := LitInt(2);
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#0_0, LitInt(2));
    assume Power.__default.Pow#canCall(x#0_0, LitInt(2));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#0_0, LitInt(2)) == Mul(x#0_0, x#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#0_0, LitInt(2)) == Mul(x#0_0, x#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall x#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#0_1, 2) } LitInt(0) <= x#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#0_1, LitInt(2)) == Mul(x#0_1, x#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(137,5)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowPositive (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowPositive(b#0: int, e#0: int where LitInt(0) <= e#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowPositive (call precondtion)"} CallPre$$Power.__default.LemmaPowPositive(b#0: int, e#0: int where LitInt(0) <= e#0);
  requires {:id "id14017"} b#0 > 0;



procedure {:verboseName "Power.LemmaPowPositive (call postcondition)"} CallPost$$Power.__default.LemmaPowPositive(b#0: int, e#0: int where LitInt(0) <= e#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14018"} 0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowPositive (correctness)"} Impl$$Power.__default.LemmaPowPositive(b#0: int, e#0: int where LitInt(0) <= e#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id14019"} b#0 > 0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14020"} 0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowPositive (correctness)"} Impl$$Power.__default.LemmaPowPositive(b#0: int, e#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var x##0: int;
  var f##0: HandleType;
  var $lambdaHeap#0: Heap;
  var u#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##b#1: int;
  var ##e#1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowPositive", " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(144,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e0#0: int :: LitInt(0) <= $ih#e0#0 && $ih#b0#0 > 0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && 0 <= $ih#e0#0 && $ih#e0#0 < e#0)) ==> 0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e0#0));
    $_reverifyPost := false;
    call CallPre$$Mul.__default.LemmaMulIncreasesAuto();
    call CallPost$$Mul.__default.LemmaMulIncreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(145,27)"} true;
    assume true;
    x##0 := e#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc u#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(0) <= u#0;
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $lambdaHeap#0);
    assume $Is(u#0, Tclass._System.nat());
    ##e#1 := u#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $lambdaHeap#0);
    assume Power.__default.Pow#canCall(b#0, u#0);
    goto anon4;

  anon9_Else:
    assume {:partition} u#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= u#0 ==> 0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, u#0);
    assume LitInt(0) <= u#0 ==> Power.__default.Pow#canCall(b#0, u#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon8_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon7_Else:
    goto anon6;

  anon6:
    assume (forall $l#0#u#0: int :: LitInt(0) <= $l#0#u#0 ==> Power.__default.Pow#canCall(b#0, $l#0#u#0));
    f##0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#u#0): int ==> 0 < Power.__default.Pow($l#1#ly#0, reveal_Power._default.Pow, b#0, $Unbox($l#1#u#0): int))), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: $IsBox($l#1#u#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#u#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(146,59)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowPositiveAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowPositiveAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowPositiveAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowPositiveAuto();



procedure {:verboseName "Power.LemmaPowPositiveAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowPositiveAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= e#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14031"} (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= e#1 ==> b#1 > 0 ==> 0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowPositiveAuto (correctness)"} Impl$$Power.__default.LemmaPowPositiveAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= e#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14032"} (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= e#1 ==> b#1 > 0 ==> 0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowPositiveAuto (correctness)"} Impl$$Power.__default.LemmaPowPositiveAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var b##0_0: int;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowPositiveAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(152,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(153,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0, e#0_0;
    assume LitInt(0) <= e#0_0;
    assume true;
    assume b#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume 0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e##0_0 := e#0_0;
    call CallPre$$Power.__default.LemmaPowPositive(b##0_0, e##0_0);
    call CallPost$$Power.__default.LemmaPowPositive(b##0_0, e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(157,28)"} true;
    assume 0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int, e#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e#0_1) } LitInt(0) <= e#0_1 && b#0_1 > 0 ==> 0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(158,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowAdds (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowAdds (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int, e2#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowAdds", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(162,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(164,28): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(e1#0 + e2#0, Tclass._System.nat());
    ##e#0 := e1#0 + e2#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0);
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e1#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e2#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0));
    return;
}



procedure {:verboseName "Power.LemmaPowAdds (call precondtion)"} CallPre$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);



procedure {:verboseName "Power.LemmaPowAdds (call postcondition)"} CallPost$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0 + e2#0) && Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14042"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + e2#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowAdds (correctness)"} Impl$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0 + e2#0) && Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14043"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + e2#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowAdds (correctness)"} Impl$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_0_0_0: int;
  var ##e#0_0_0_0: int;
  var ##b#0_0_0_1: int;
  var ##e#0_0_0_1: int;
  var ##b#0_0_1_0: int;
  var ##e#0_0_1_0: int;
  var ##b#0_0_1_1: int;
  var ##e#0_0_1_1: int;
  var b##0_0_1_0: int;
  var ##b#0_0_1_2: int;
  var ##e#0_0_1_2: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var ##b#0_0_1: int;
  var ##e#0_0_1: int;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##b#1_0_0_1: int;
  var ##e#1_0_0_1: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var b##1_0_1_0: int;
  var e1##1_0_1_0: int;
  var e2##1_0_1_0: int;
  var ##b#1_0_1_2: int;
  var ##e#1_0_1_2: int;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##b#1_0_2_1: int;
  var ##e#1_0_2_1: int;
  var ##b#1_0_2_2: int;
  var ##e#1_0_2_2: int;
  var ##b#1_0_2_3: int;
  var ##e#1_0_2_3: int;
  var ##b#1_0_3_0: int;
  var ##e#1_0_3_0: int;
  var ##b#1_0_3_1: int;
  var ##e#1_0_3_1: int;
  var ##b#1_0_3_2: int;
  var ##e#1_0_3_2: int;
  var ##b#1_0_3_3: int;
  var ##e#1_0_3_3: int;
  var ##b#1_0_0: int;
  var ##e#1_0_0: int;
  var ##b#1_0_1: int;
  var ##e#1_0_1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowAdds", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(165,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && Lit(true) && 0 <= $ih#e10#0 && $ih#e10#0 < e1#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0 + $ih#e20#0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0)));
    $_reverifyPost := false;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} e1#0 == LitInt(0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    ##e#0_0_0 := e1#0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_1, TInt, $Heap);
    ##e#0_0_1 := e2#0;
    assume $IsAlloc(##e#0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume false;
    goto anon5;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##b#0_0_1_0 := b#0;
    assume $IsAlloc(##b#0_0_1_0, TInt, $Heap);
    ##e#0_0_1_0 := e1#0;
    assume $IsAlloc(##e#0_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#0_0_1_1 := b#0;
    assume $IsAlloc(##b#0_0_1_1, TInt, $Heap);
    ##e#0_0_1_1 := e2#0;
    assume $IsAlloc(##e#0_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume true;
    b##0_0_1_0 := b#0;
    call CallPre$$Power.__default.LemmaPow0(b##0_0_1_0);
    call CallPost$$Power.__default.LemmaPow0(b##0_0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(169,22)"} true;
    ##b#0_0_1_2 := b#0;
    assume $IsAlloc(##b#0_0_1_2, TInt, $Heap);
    ##e#0_0_1_2 := e2#0;
    assume $IsAlloc(##e#0_0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) == Mul(LitInt(1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0));
    assume false;
    goto anon5;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    ##b#0_0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0_0, TInt, $Heap);
    ##e#0_0_0_0 := e2#0;
    assume $IsAlloc(##e#0_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(171,30)"} true;
    ##b#0_0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_0_1, TInt, $Heap);
    assume $Is(0 + e2#0, Tclass._System.nat());
    ##e#0_0_0_1 := 0 + e2#0;
    assume $IsAlloc(##e#0_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, 0 + e2#0);
    assume Power.__default.Pow#canCall(b#0, 0 + e2#0);
    assume {:subsumption 0} Mul(LitInt(1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, 0 + e2#0);
    assume false;
    goto anon5;

  anon16_Else:
    goto anon5;

  anon5:
    assume Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, 0 + e2#0);
    return;

  anon13_Else:
    assume {:partition} e1#0 != LitInt(0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    ##b#1_0_0 := b#0;
    assume $IsAlloc(##b#1_0_0, TInt, $Heap);
    ##e#1_0_0 := e1#0;
    assume $IsAlloc(##e#1_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#1_0_1 := b#0;
    assume $IsAlloc(##b#1_0_1, TInt, $Heap);
    ##e#1_0_1 := e2#0;
    assume $IsAlloc(##e#1_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume false;
    goto anon12;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    ##b#1_0_3_0 := b#0;
    assume $IsAlloc(##b#1_0_3_0, TInt, $Heap);
    ##e#1_0_3_0 := e1#0;
    assume $IsAlloc(##e#1_0_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#1_0_3_1 := b#0;
    assume $IsAlloc(##b#1_0_3_1, TInt, $Heap);
    ##e#1_0_3_1 := e2#0;
    assume $IsAlloc(##e#1_0_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(178,21)"} true;
    ##b#1_0_3_2 := b#0;
    assume $IsAlloc(##b#1_0_3_2, TInt, $Heap);
    assume $Is(e1#0 - 1, Tclass._System.nat());
    ##e#1_0_3_2 := e1#0 - 1;
    assume $IsAlloc(##e#1_0_3_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1);
    ##b#1_0_3_3 := b#0;
    assume $IsAlloc(##b#1_0_3_3, TInt, $Heap);
    ##e#1_0_3_3 := e2#0;
    assume $IsAlloc(##e#1_0_3_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1) && Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) == Mul(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - 1)), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0));
    assume false;
    goto anon12;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    ##b#1_0_2_0 := b#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(e1#0 - 1, Tclass._System.nat());
    ##e#1_0_2_0 := e1#0 - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1);
    ##b#1_0_2_1 := b#0;
    assume $IsAlloc(##b#1_0_2_1, TInt, $Heap);
    ##e#1_0_2_1 := e2#0;
    assume $IsAlloc(##e#1_0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1) && Power.__default.Pow#canCall(b#0, e2#0);
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(180,37)"} true;
    ##b#1_0_2_2 := b#0;
    assume $IsAlloc(##b#1_0_2_2, TInt, $Heap);
    assume $Is(e1#0 - 1, Tclass._System.nat());
    ##e#1_0_2_2 := e1#0 - 1;
    assume $IsAlloc(##e#1_0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1);
    ##b#1_0_2_3 := b#0;
    assume $IsAlloc(##b#1_0_2_3, TInt, $Heap);
    ##e#1_0_2_3 := e2#0;
    assume $IsAlloc(##e#1_0_2_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1) && Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Mul(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - 1)), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) == Mul(b#0, Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - 1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)));
    assume false;
    goto anon12;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##b#1_0_1_0 := b#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(e1#0 - 1, Tclass._System.nat());
    ##e#1_0_1_0 := e1#0 - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1);
    ##b#1_0_1_1 := b#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    ##e#1_0_1_1 := e2#0;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1) && Power.__default.Pow#canCall(b#0, e2#0);
    assume true;
    b##1_0_1_0 := b#0;
    assume true;
    assume $Is(e1#0 - 1, Tclass._System.nat());
    e1##1_0_1_0 := e1#0 - 1;
    assume true;
    e2##1_0_1_0 := e2#0;
    assume 0 <= e1#0 || e1##1_0_1_0 == e1#0;
    assume e1##1_0_1_0 < e1#0;
    call CallPre$$Power.__default.LemmaPowAdds(b##1_0_1_0, e1##1_0_1_0, e2##1_0_1_0);
    call CallPost$$Power.__default.LemmaPowAdds(b##1_0_1_0, e1##1_0_1_0, e2##1_0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(182,37)"} true;
    ##b#1_0_1_2 := b#0;
    assume $IsAlloc(##b#1_0_1_2, TInt, $Heap);
    assume $Is(e1#0 - 1 + e2#0, Tclass._System.nat());
    ##e#1_0_1_2 := e1#0 - 1 + e2#0;
    assume $IsAlloc(##e#1_0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1 + e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1 + e2#0);
    assume {:subsumption 0} Mul(b#0, Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - 1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0))) == Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - 1 + e2#0));
    assume false;
    goto anon12;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    ##b#1_0_0_0 := b#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(e1#0 - 1 + e2#0, Tclass._System.nat());
    ##e#1_0_0_0 := e1#0 - 1 + e2#0;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1 + e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - 1 + e2#0);
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(184,21)"} true;
    ##b#1_0_0_1 := b#0;
    assume $IsAlloc(##b#1_0_0_1, TInt, $Heap);
    assume $Is(e1#0 + e2#0, Tclass._System.nat());
    ##e#1_0_0_1 := e1#0 + e2#0;
    assume $IsAlloc(##e#1_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0);
    assume {:subsumption 0} Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - 1 + e2#0)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + e2#0);
    assume false;
    goto anon12;

  anon21_Else:
    goto anon12;

  anon12:
    assume Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0);
    return;
}



procedure {:verboseName "Power.LemmaPowAddsAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowAddsAuto();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowAddsAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowAddsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var e1#0: int;
  var e2#0: int;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowAddsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(190,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(191,12): post-state"} true;
    havoc b#0;
    havoc e1#0;
    havoc e2#0;
    assume LitInt(0) <= e1#0 && LitInt(0) <= e2#0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(e1#0 + e2#0, Tclass._System.nat());
    ##e#0 := e1#0 + e2#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0);
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e1#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e2#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0));
    assume (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 + e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 + e2#1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1)));
    return;
}



procedure {:verboseName "Power.LemmaPowAddsAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowAddsAuto();



procedure {:verboseName "Power.LemmaPowAddsAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowAddsAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 + e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1 + e2#1) && Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14078"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 + e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 + e2#1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowAddsAuto (correctness)"} Impl$$Power.__default.LemmaPowAddsAuto() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 + e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1 + e2#1) && Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14079"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1 + e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1 + e2#1) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowAddsAuto (correctness)"} Impl$$Power.__default.LemmaPowAddsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_2: int;
  var ##e#0_2: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowAddsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(193,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(194,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(e1#0_0 + e2#0_0, Tclass._System.nat());
    ##e#0_0 := e1#0_0 + e2#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0 + e2#0_0);
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e1#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    ##b#0_2 := b#0_0;
    assume $IsAlloc(##b#0_2, TInt, $Heap);
    ##e#0_2 := e2#0_0;
    assume $IsAlloc(##e#0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0 + e2#0_0) && Power.__default.Pow#canCall(b#0_0, e1#0_0) && Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0 + e2#0_0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0));
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowAdds(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowAdds(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(198,29)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0 + e2#0_0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0));
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1 + e2#0_1) } LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1 + e2#0_1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1)));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(199,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowSubAddCancel (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubAddCancel (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int, e2#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubAddCancel", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(202,8): initial state"} true;
    assume e1#0 >= e2#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(205,41): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0 := e1#0 - e2#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e2#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e1#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    return;
}



procedure {:verboseName "Power.LemmaPowSubAddCancel (call precondtion)"} CallPre$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14091"} e1#0 >= e2#0;



procedure {:verboseName "Power.LemmaPowSubAddCancel (call postcondition)"} CallPost$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0 - e2#0) && Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0);
  free ensures {:id "id14092"} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowSubAddCancel (correctness)"} Impl$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id14093"} e1#0 >= e2#0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0 - e2#0) && Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0);
  free ensures {:id "id14094"} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubAddCancel (correctness)"} Impl$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var b##0: int;
  var e1##0: int;
  var e2##0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubAddCancel", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(206,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && $ih#e10#0 >= $ih#e20#0 && 0 <= $ih#e10#0 && $ih#e10#0 < e1#0 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0 - $ih#e20#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0));
    $_reverifyPost := false;
    assume true;
    b##0 := b#0;
    assume true;
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    e1##0 := e1#0 - e2#0;
    assume true;
    e2##0 := e2#0;
    call CallPre$$Power.__default.LemmaPowAdds(b##0, e1##0, e2##0);
    call CallPost$$Power.__default.LemmaPowAdds(b##0, e1##0, e2##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(207,32)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowSubAddCancelAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubAddCancelAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubAddCancelAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubAddCancelAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var e1#0: int;
  var e2#0: int;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubAddCancelAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(210,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(211,12): post-state"} true;
    havoc b#0;
    havoc e1#0;
    havoc e2#0;
    assume LitInt(0) <= e1#0 && LitInt(0) <= e2#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume e1#0 >= e2#0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0 := e1#0 - e2#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e2#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e1#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    goto anon4;

  anon5_Else:
    assume e1#0 >= e2#0 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    goto anon4;

  anon4:
    assume (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 - e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 && e1#1 >= e2#1 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 - e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1));
    return;
}



procedure {:verboseName "Power.LemmaPowSubAddCancelAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowSubAddCancelAuto();



procedure {:verboseName "Power.LemmaPowSubAddCancelAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowSubAddCancelAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 - e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> e1#1 >= e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1 - e2#1) && Power.__default.Pow#canCall(b#1, e2#1) && Power.__default.Pow#canCall(b#1, e1#1));
  free ensures {:id "id14103"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 - e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 && e1#1 >= e2#1 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 - e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowSubAddCancelAuto (correctness)"} Impl$$Power.__default.LemmaPowSubAddCancelAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1 - e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> e1#1 >= e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1 - e2#1) && Power.__default.Pow#canCall(b#1, e2#1) && Power.__default.Pow#canCall(b#1, e1#1));
  free ensures {:id "id14104"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1 - e2#1) } LitInt(0) <= e1#1 && LitInt(0) <= e2#1 && e1#1 >= e2#1 ==> Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1 - e2#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubAddCancelAuto (correctness)"} Impl$$Power.__default.LemmaPowSubAddCancelAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;
  var $initHeapForallStmt#0_0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubAddCancelAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(213,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(214,15)"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    assume true;
    assume e1#0_0 >= e2#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowSubAddCancel(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowSubAddCancel(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(217,37)"} true;
    assume false;
    goto anon3;

  anon4_Else:
    $initHeapForallStmt#0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0_0 == $Heap;
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int, _t#0#0_0: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, _t#0#0_0) } LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && _t#0#0_0 == e1#0_1 - e2#0_1 && e1#0_1 >= e2#0_1 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, _t#0#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1));
    goto anon3;

  anon3:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(218,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowSubtracts (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubtracts(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubtracts (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubtracts(b#0: int, e1#0: int, e2#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;
  var ##b#4: int;
  var ##e#4: int;
  var ##b#5: int;
  var ##e#5: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubtracts", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(222,8): initial state"} true;
    assume b#0 > 0;
    assume e1#0 <= e2#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(225,23): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e1#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) > 0;
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    assume $Is(e2#0 - e1#0, Tclass._System.nat());
    ##e#1 := e2#0 - e1#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e2#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#3 := b#0;
    assume $IsAlloc(##b#3, TInt, $Heap);
    ##e#3 := e1#0;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) != 0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0));
    ##b#4 := b#0;
    assume $IsAlloc(##b#4, TInt, $Heap);
    ##e#4 := e2#0;
    assume $IsAlloc(##e#4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#5 := b#0;
    assume $IsAlloc(##b#5, TInt, $Heap);
    ##e#5 := e1#0;
    assume $IsAlloc(##e#5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) != 0;
    goto anon3;

  anon4_Else:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0) != Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0));
    goto anon3;

  anon3:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0)) && Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0)) > 0;
    return;
}



procedure {:verboseName "Power.LemmaPowSubtracts (call precondtion)"} CallPre$$Power.__default.LemmaPowSubtracts(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14116"} b#0 > 0;
  requires {:id "id14117"} e1#0 <= e2#0;



procedure {:verboseName "Power.LemmaPowSubtracts (call postcondition)"} CallPost$$Power.__default.LemmaPowSubtracts(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0);
  free ensures {:id "id14118"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) > 0;
  free ensures Power.__default.Pow#canCall(b#0, e2#0 - e1#0) && Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0) && (Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0)) ==> Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0));
  free ensures {:id "id14119"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0 - e1#0) == Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0));
  free ensures {:id "id14120"} Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0)) > 0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowSubtracts (correctness)"} Impl$$Power.__default.LemmaPowSubtracts(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id14121"} b#0 > 0;
  requires {:id "id14122"} e1#0 <= e2#0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0);
  free ensures {:id "id14123"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) > 0;
  free ensures Power.__default.Pow#canCall(b#0, e2#0 - e1#0) && Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0) && (Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0)) ==> Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0));
  free ensures {:id "id14124"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0 - e1#0) == Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0));
  free ensures {:id "id14125"} Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0)) > 0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubtracts (correctness)"} Impl$$Power.__default.LemmaPowSubtracts(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var ##b#0_0_1: int;
  var ##e#0_0_1: int;
  var ##b#0_0_2: int;
  var ##e#0_0_2: int;
  var b##0_0_0: int;
  var ##b#0_0_3: int;
  var ##e#0_0_3: int;
  var d##0_0_0: int;
  var ##b#0_0_4: int;
  var ##e#0_0_4: int;
  var ##b#0_0_5: int;
  var ##e#0_0_5: int;
  var ##b#0_1_0: int;
  var ##e#0_1_0: int;
  var ##b#0_1_1: int;
  var ##e#0_1_1: int;
  var b##0_1_0: int;
  var e1##0_1_0: int;
  var e2##0_1_0: int;
  var ##b#0_1_2: int;
  var ##e#0_1_2: int;
  var ##b#0_1_3: int;
  var ##e#0_1_3: int;
  var ##b#0_1_4: int;
  var ##e#0_1_4: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubtracts", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(227,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && $ih#b0#0 > 0 && $ih#e10#0 <= $ih#e20#0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#e10#0 && $ih#e10#0 < e1#0) || ($ih#e10#0 == e1#0 && 0 <= $ih#e20#0 && $ih#e20#0 < e2#0)))) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0) > 0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0 - $ih#e10#0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0)) && Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0)) > 0);
    $_reverifyPost := false;
    call CallPre$$Power.__default.LemmaPowPositiveAuto();
    call CallPost$$Power.__default.LemmaPowPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(228,26)"} true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e2#0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#0_1 := b#0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e1#0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) != 0;
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0);
    assume false;
    goto anon4;

  anon5_Else:
    goto anon6_Then, anon6_Else;

  anon6_Then:
    ##b#0_1_0 := b#0;
    assume $IsAlloc(##b#0_1_0, TInt, $Heap);
    ##e#0_1_0 := e2#0;
    assume $IsAlloc(##e#0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#0_1_1 := b#0;
    assume $IsAlloc(##b#0_1_1, TInt, $Heap);
    ##e#0_1_1 := e1#0;
    assume $IsAlloc(##e#0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) != 0;
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0);
    assume true;
    b##0_1_0 := b#0;
    assume true;
    e1##0_1_0 := e2#0;
    assume true;
    e2##0_1_0 := e1#0;
    call CallPre$$Power.__default.LemmaPowSubAddCancel(b##0_1_0, e1##0_1_0, e2##0_1_0);
    call CallPost$$Power.__default.LemmaPowSubAddCancel(b##0_1_0, e1##0_1_0, e2##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(231,39)"} true;
    ##b#0_1_2 := b#0;
    assume $IsAlloc(##b#0_1_2, TInt, $Heap);
    assume $Is(e2#0 - e1#0, Tclass._System.nat());
    ##e#0_1_2 := e2#0 - e1#0;
    assume $IsAlloc(##e#0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    ##b#0_1_3 := b#0;
    assume $IsAlloc(##b#0_1_3, TInt, $Heap);
    ##e#0_1_3 := e1#0;
    assume $IsAlloc(##e#0_1_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#0_1_4 := b#0;
    assume $IsAlloc(##b#0_1_4, TInt, $Heap);
    ##e#0_1_4 := e1#0;
    assume $IsAlloc(##e#0_1_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) != 0;
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0) && Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0)) == Div(Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0 - e1#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0)), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0));
    assume false;
    goto anon4;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    assume $Is(e2#0 - e1#0, Tclass._System.nat());
    ##e#0_0_0 := e2#0 - e1#0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    ##b#0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_1, TInt, $Heap);
    ##e#0_0_1 := e1#0;
    assume $IsAlloc(##e#0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#0_0_2 := b#0;
    assume $IsAlloc(##b#0_0_2, TInt, $Heap);
    ##e#0_0_2 := e1#0;
    assume $IsAlloc(##e#0_0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) != 0;
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0) && Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0);
    ##b#0_0_3 := b#0;
    assume $IsAlloc(##b#0_0_3, TInt, $Heap);
    assume $Is(e2#0 - e1#0, Tclass._System.nat());
    ##e#0_0_3 := e2#0 - e1#0;
    assume $IsAlloc(##e#0_0_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    b##0_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0);
    ##b#0_0_4 := b#0;
    assume $IsAlloc(##b#0_0_4, TInt, $Heap);
    ##e#0_0_4 := e1#0;
    assume $IsAlloc(##e#0_0_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    d##0_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    call CallPre$$DivMod.__default.LemmaDivByMultiple(b##0_0_0, d##0_0_0);
    call CallPost$$DivMod.__default.LemmaDivByMultiple(b##0_0_0, d##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(233,55)"} true;
    ##b#0_0_5 := b#0;
    assume $IsAlloc(##b#0_0_5, TInt, $Heap);
    assume $Is(e2#0 - e1#0, Tclass._System.nat());
    ##e#0_0_5 := e2#0 - e1#0;
    assume $IsAlloc(##e#0_0_5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    assume Power.__default.Pow#canCall(b#0, e2#0 - e1#0);
    assume {:subsumption 0} Div(Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0 - e1#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0)), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0 - e1#0);
    assume false;
    goto anon4;

  anon7_Else:
    goto anon4;

  anon4:
    assume Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0 - e1#0);
    return;
}



procedure {:verboseName "Power.LemmaPowSubtractsAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubtractsAuto();
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubtractsAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowSubtractsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var e1#0: int;
  var ##b#0: int;
  var ##e#0: int;
  var e2#0: int;
  var e1#2: int;
  var b#2: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;
  var ##b#4: int;
  var ##e#4: int;
  var ##b#5: int;
  var ##e#5: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubtractsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(238,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(239,12): post-state"} true;
    havoc b#0;
    havoc e1#0;
    assume LitInt(0) <= b#0 && LitInt(0) <= e1#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume b#0 > 0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e1#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) > 0;
    goto anon4;

  anon10_Else:
    assume b#0 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) > 0;
    goto anon4;

  anon4:
    assume (forall b#1: int, e1#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 ==> b#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) > 0);
    havoc e2#0;
    havoc e1#2;
    havoc b#2;
    assume LitInt(0) <= e2#0 && LitInt(0) <= e1#2 && LitInt(0) <= b#2;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume b#2 > 0;
    assume e1#2 <= e2#0;
    ##b#1 := b#2;
    assume $IsAlloc(##b#1, TInt, $Heap);
    assume $Is(e2#0 - e1#2, Tclass._System.nat());
    ##e#1 := e2#0 - e1#2;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e2#0 - e1#2);
    ##b#2 := b#2;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e2#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e2#0);
    ##b#3 := b#2;
    assume $IsAlloc(##b#3, TInt, $Heap);
    ##e#3 := e1#2;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e1#2);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2) != 0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0 - e1#2) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2));
    ##b#4 := b#2;
    assume $IsAlloc(##b#4, TInt, $Heap);
    ##e#4 := e2#0;
    assume $IsAlloc(##e#4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e2#0);
    ##b#5 := b#2;
    assume $IsAlloc(##b#5, TInt, $Heap);
    ##e#5 := e1#2;
    assume $IsAlloc(##e#5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e1#2);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2) != 0;
    goto anon7;

  anon12_Else:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0 - e1#2) != Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2));
    goto anon7;

  anon7:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0 - e1#2) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2)) && Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2)) > 0;
    goto anon9;

  anon11_Else:
    assume b#2 > 0 && e1#2 <= e2#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0 - e1#2) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2)) && Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#2)) > 0;
    goto anon9;

  anon9:
    assume (forall e2#1: int, e1#3: int, b#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) } LitInt(0) <= e2#1 && LitInt(0) <= e1#3 && LitInt(0) <= b#3 ==> (b#3 > 0 && e1#3 <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#3))) && (b#3 > 0 && e1#3 <= e2#1 ==> Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#3)) > 0));
    return;
}



procedure {:verboseName "Power.LemmaPowSubtractsAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowSubtractsAuto();



procedure {:verboseName "Power.LemmaPowSubtractsAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowSubtractsAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e1#1));
  free ensures {:id "id14155"} (forall b#1: int, e1#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 ==> b#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) > 0);
  free ensures (forall e2#1: int, e1#3: int, b#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) } LitInt(0) <= e2#1 && LitInt(0) <= e1#3 && LitInt(0) <= b#3 ==> (b#3 > 0 ==> e1#3 <= e2#1 ==> Power.__default.Pow#canCall(b#3, e2#1 - e1#3) && Power.__default.Pow#canCall(b#3, e2#1) && Power.__default.Pow#canCall(b#3, e1#3)) && ((b#3 > 0 && e1#3 <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#3))) ==> b#3 > 0 ==> e1#3 <= e2#1 ==> Power.__default.Pow#canCall(b#3, e2#1) && Power.__default.Pow#canCall(b#3, e1#3)));
  free ensures {:id "id14156"} (forall e2#1: int, e1#3: int, b#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) } LitInt(0) <= e2#1 && LitInt(0) <= e1#3 && LitInt(0) <= b#3 ==> (b#3 > 0 && e1#3 <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#3))) && (b#3 > 0 && e1#3 <= e2#1 ==> Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#3)) > 0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowSubtractsAuto (correctness)"} Impl$$Power.__default.LemmaPowSubtractsAuto() returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e1#1));
  free ensures {:id "id14157"} (forall b#1: int, e1#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 ==> b#1 > 0 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1) > 0);
  free ensures (forall e2#1: int, e1#3: int, b#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) } LitInt(0) <= e2#1 && LitInt(0) <= e1#3 && LitInt(0) <= b#3 ==> (b#3 > 0 ==> e1#3 <= e2#1 ==> Power.__default.Pow#canCall(b#3, e2#1 - e1#3) && Power.__default.Pow#canCall(b#3, e2#1) && Power.__default.Pow#canCall(b#3, e1#3)) && ((b#3 > 0 && e1#3 <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1 - e1#3) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#3))) ==> b#3 > 0 ==> e1#3 <= e2#1 ==> Power.__default.Pow#canCall(b#3, e2#1) && Power.__default.Pow#canCall(b#3, e1#3)));
  free ensures {:id "id14158"} (forall e2#1: int, e1#3: int, b#3: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e2#1 - e1#3) } LitInt(0) <= e2#1 && LitInt(0) <= e1#3 && LitInt(0) <= b#3 ==> (b#3 > 0 && e1#3 <= e2#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e2#1 - e1#3) == Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e1#3))) && (b#3 > 0 && e1#3 <= e2#1 ==> Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e2#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e1#3)) > 0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowSubtractsAuto (correctness)"} Impl$$Power.__default.LemmaPowSubtractsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_2: int;
  var ##e#0_2: int;
  var ##b#0_3: int;
  var ##e#0_3: int;
  var ##b#0_4: int;
  var ##e#0_4: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubtractsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(243,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(244,15)"} true;
    call CallPre$$Power.__default.LemmaPowPositiveAuto();
    call CallPost$$Power.__default.LemmaPowPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(245,26)"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} b#0_0 > 0;
    goto anon3;

  anon11_Else:
    assume {:partition} 0 >= b#0_0;
    goto anon3;

  anon3:
    assume true;
    assume b#0_0 > 0 && e1#0_0 <= e2#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(e2#0_0 - e1#0_0, Tclass._System.nat());
    ##e#0_0 := e2#0_0 - e1#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0 - e1#0_0);
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e2#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    ##b#0_2 := b#0_0;
    assume $IsAlloc(##b#0_2, TInt, $Heap);
    ##e#0_2 := e1#0_0;
    assume $IsAlloc(##e#0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0) != 0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0 - e1#0_0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0));
    ##b#0_3 := b#0_0;
    assume $IsAlloc(##b#0_3, TInt, $Heap);
    ##e#0_3 := e2#0_0;
    assume $IsAlloc(##e#0_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    ##b#0_4 := b#0_0;
    assume $IsAlloc(##b#0_4, TInt, $Heap);
    ##e#0_4 := e1#0_0;
    assume $IsAlloc(##e#0_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0) != 0;
    goto anon6;

  anon13_Else:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0 - e1#0_0) != Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0));
    goto anon6;

  anon6:
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0 - e1#0_0) && Power.__default.Pow#canCall(b#0_0, e2#0_0) && Power.__default.Pow#canCall(b#0_0, e1#0_0) && (Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0 - e1#0_0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0)) ==> Power.__default.Pow#canCall(b#0_0, e2#0_0) && Power.__default.Pow#canCall(b#0_0, e1#0_0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0 - e1#0_0) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0)) && Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0)) > 0;
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowSubtracts(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowSubtracts(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(250,34)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0 - e1#0_0) == Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0));
    assume Div(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0)) > 0;
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1 - e1#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && b#0_1 > 0 && e1#0_1 <= e2#0_1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1 - e1#0_1) == Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1)) && Div(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1)) > 0);
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(251,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowMultiplies (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int where LitInt(0) <= b#0, c#0: int where LitInt(0) <= c#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowMultiplies (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int, c#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowMultiplies", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(255,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(257,14): post-state"} true;
    assume LitInt(0) <= Mul(b#0, c#0);
    ##b#0 := a#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := b#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0);
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := c#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    ##b#2 := a#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    assume $Is(Mul(b#0, c#0), Tclass._System.nat());
    ##e#2 := Mul(b#0, c#0);
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, Mul(b#0, c#0));
    return;
}



procedure {:verboseName "Power.LemmaPowMultiplies (call precondtion)"} CallPre$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int where LitInt(0) <= b#0, c#0: int where LitInt(0) <= c#0);



procedure {:verboseName "Power.LemmaPowMultiplies (call postcondition)"} CallPost$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int where LitInt(0) <= b#0, c#0: int where LitInt(0) <= c#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14175"} LitInt(0) <= Mul(b#0, c#0);
  free ensures Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0) && Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
  free ensures {:id "id14176"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), c#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowMultiplies (correctness)"} Impl$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int where LitInt(0) <= b#0, c#0: int where LitInt(0) <= c#0) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14177"} LitInt(0) <= Mul(b#0, c#0);
  free ensures Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0) && Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
  free ensures {:id "id14178"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), c#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowMultiplies (correctness)"} Impl$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int, c#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var x##0: int;
  var y##0: int;
  var b##0_0_0_0: int;
  var ##b#0_0_0_0: int;
  var ##e#0_0_0_0: int;
  var ##b#0_0_0_1: int;
  var ##e#0_0_0_1: int;
  var ##b#0_0_0_2: int;
  var ##e#0_0_0_2: int;
  var ##b#0_0_1_0: int;
  var ##e#0_0_1_0: int;
  var b##0_0_1_0: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var x##1_0: int;
  var y##1_0: int;
  var ##b#1_1_0_0: int;
  var ##e#1_1_0_0: int;
  var ##b#1_1_0_1: int;
  var ##e#1_1_0_1: int;
  var ##b#1_1_0_2: int;
  var ##e#1_1_0_2: int;
  var ##b#1_1_0_3: int;
  var ##e#1_1_0_3: int;
  var ##b#1_1_0_4: int;
  var ##e#1_1_0_4: int;
  var ##b#1_1_1_0: int;
  var ##e#1_1_1_0: int;
  var ##b#1_1_1_1: int;
  var ##e#1_1_1_1: int;
  var a##1_1_1_0: int;
  var b##1_1_1_0: int;
  var c##1_1_1_0: int;
  var ##b#1_1_1_2: int;
  var ##e#1_1_1_2: int;
  var ##b#1_1_1_3: int;
  var ##e#1_1_1_3: int;
  var ##b#1_1_1_4: int;
  var ##e#1_1_1_4: int;
  var ##b#1_1_2_0: int;
  var ##e#1_1_2_0: int;
  var ##b#1_1_2_1: int;
  var ##e#1_1_2_1: int;
  var ##b#1_1_2_2: int;
  var ##e#1_1_2_2: int;
  var ##b#1_1_2_3: int;
  var ##e#1_1_2_3: int;
  var ##b#1_1_3_0: int;
  var ##e#1_1_3_0: int;
  var b##1_1_3_0: int;
  var e1##1_1_3_0: int;
  var e2##1_1_3_0: int;
  var ##b#1_1_3_1: int;
  var ##e#1_1_3_1: int;
  var ##b#1_1_3_2: int;
  var ##e#1_1_3_2: int;
  var ##b#1_1_4_0: int;
  var ##e#1_1_4_0: int;
  var ##b#1_1_4_1: int;
  var ##e#1_1_4_1: int;
  var ##b#1_1_0: int;
  var ##e#1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowMultiplies", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(259,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#a0#0: int, $ih#b0#0: int, $ih#c0#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#c0#0 && Lit(true) && 0 <= $ih#c0#0 && $ih#c0#0 < c#0 ==> LitInt(0) <= Mul($ih#b0#0, $ih#c0#0) && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#a0#0, $ih#b0#0), $ih#c0#0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#a0#0, Mul($ih#b0#0, $ih#c0#0)));
    $_reverifyPost := false;
    assume true;
    x##0 := b#0;
    assume true;
    y##0 := c#0;
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##0, y##0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(260,29)"} true;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} c#0 == LitInt(0);
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(262,26)"} true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    ##b#0_0_0 := a#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    assume $Is(Mul(b#0, c#0), Tclass._System.nat());
    ##e#0_0_0 := Mul(b#0, c#0);
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume false;
    goto anon5;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    ##b#0_0_1_0 := a#0;
    assume $IsAlloc(##b#0_0_1_0, TInt, $Heap);
    assume $Is(Mul(b#0, c#0), Tclass._System.nat());
    ##e#0_0_1_0 := Mul(b#0, c#0);
    assume $IsAlloc(##e#0_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume true;
    b##0_0_1_0 := a#0;
    call CallPre$$Power.__default.LemmaPow0(b##0_0_1_0);
    call CallPost$$Power.__default.LemmaPow0(b##0_0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(265,22)"} true;
    assume true;
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0)) == LitInt(1);
    assume false;
    goto anon5;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume true;
    ##b#0_0_0_0 := a#0;
    assume $IsAlloc(##b#0_0_0_0, TInt, $Heap);
    ##e#0_0_0_0 := b#0;
    assume $IsAlloc(##e#0_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    assume Power.__default.Pow#canCall(a#0, b#0);
    b##0_0_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0);
    call CallPre$$Power.__default.LemmaPow0(b##0_0_0_0);
    call CallPost$$Power.__default.LemmaPow0(b##0_0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(267,30)"} true;
    ##b#0_0_0_1 := a#0;
    assume $IsAlloc(##b#0_0_0_1, TInt, $Heap);
    ##e#0_0_0_1 := b#0;
    assume $IsAlloc(##e#0_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#0_0_0_2 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0);
    assume $IsAlloc(##b#0_0_0_2, TInt, $Heap);
    ##e#0_0_0_2 := c#0;
    assume $IsAlloc(##e#0_0_0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    assume {:subsumption 0} LitInt(1) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), c#0);
    assume false;
    goto anon5;

  anon21_Else:
    goto anon5;

  anon5:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, Mul(b#0, c#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    return;

  anon18_Else:
    assume {:partition} c#0 != LitInt(0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume true;
    assume false;
    goto anon10;

  anon22_Else:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(274,30)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(b#0, c#0) - b#0 == Mul(b#0, c#0) - Mul(b#0, LitInt(1));
    assume false;
    goto anon10;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume true;
    push;
    push;
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(276,38)"} true;
    pop;
    pop;
    assume true;
    assume {:subsumption 0} Mul(b#0, c#0) - Mul(b#0, LitInt(1)) == Mul(b#0, c#0 - 1);
    assume false;
    goto anon10;

  anon24_Else:
    goto anon10;

  anon10:
    assume Mul(b#0, c#0) - b#0 == Mul(b#0, c#0 - 1);
    assume true;
    x##1_0 := b#0;
    assume true;
    y##1_0 := c#0 - 1;
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##1_0, y##1_0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##1_0, y##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(279,35)"} true;
    assume true;
    assume LitInt(0) <= Mul(b#0, c#0) - b#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(280,27)"} true;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    ##b#1_1_0 := a#0;
    assume $IsAlloc(##b#1_1_0, TInt, $Heap);
    assume $Is(Mul(b#0, c#0), Tclass._System.nat());
    ##e#1_1_0 := Mul(b#0, c#0);
    assume $IsAlloc(##e#1_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume false;
    goto anon17;

  anon25_Else:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    ##b#1_1_4_0 := a#0;
    assume $IsAlloc(##b#1_1_4_0, TInt, $Heap);
    assume $Is(Mul(b#0, c#0), Tclass._System.nat());
    ##e#1_1_4_0 := Mul(b#0, c#0);
    assume $IsAlloc(##e#1_1_4_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0));
    ##b#1_1_4_1 := a#0;
    assume $IsAlloc(##b#1_1_4_1, TInt, $Heap);
    assume $Is(b#0 + Mul(b#0, c#0) - b#0, Tclass._System.nat());
    ##e#1_1_4_1 := b#0 + Mul(b#0, c#0) - b#0;
    assume $IsAlloc(##e#1_1_4_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0 + Mul(b#0, c#0) - b#0);
    assume Power.__default.Pow#canCall(a#0, b#0 + Mul(b#0, c#0) - b#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0 + Mul(b#0, c#0) - b#0);
    assume false;
    goto anon17;

  anon26_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    ##b#1_1_3_0 := a#0;
    assume $IsAlloc(##b#1_1_3_0, TInt, $Heap);
    assume $Is(b#0 + Mul(b#0, c#0) - b#0, Tclass._System.nat());
    ##e#1_1_3_0 := b#0 + Mul(b#0, c#0) - b#0;
    assume $IsAlloc(##e#1_1_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0 + Mul(b#0, c#0) - b#0);
    assume Power.__default.Pow#canCall(a#0, b#0 + Mul(b#0, c#0) - b#0);
    assume true;
    b##1_1_3_0 := a#0;
    assume true;
    e1##1_1_3_0 := b#0;
    assume true;
    assume $Is(Mul(b#0, c#0) - b#0, Tclass._System.nat());
    e2##1_1_3_0 := Mul(b#0, c#0) - b#0;
    call CallPre$$Power.__default.LemmaPowAdds(b##1_1_3_0, e1##1_1_3_0, e2##1_1_3_0);
    call CallPost$$Power.__default.LemmaPowAdds(b##1_1_3_0, e1##1_1_3_0, e2##1_1_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(285,39)"} true;
    ##b#1_1_3_1 := a#0;
    assume $IsAlloc(##b#1_1_3_1, TInt, $Heap);
    ##e#1_1_3_1 := b#0;
    assume $IsAlloc(##e#1_1_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_3_2 := a#0;
    assume $IsAlloc(##b#1_1_3_2, TInt, $Heap);
    assume $Is(Mul(b#0, c#0) - b#0, Tclass._System.nat());
    ##e#1_1_3_2 := Mul(b#0, c#0) - b#0;
    assume $IsAlloc(##e#1_1_3_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0) - b#0);
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(a#0, Mul(b#0, c#0) - b#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0 + Mul(b#0, c#0) - b#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0) - b#0));
    assume false;
    goto anon17;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    ##b#1_1_2_0 := a#0;
    assume $IsAlloc(##b#1_1_2_0, TInt, $Heap);
    ##e#1_1_2_0 := b#0;
    assume $IsAlloc(##e#1_1_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_2_1 := a#0;
    assume $IsAlloc(##b#1_1_2_1, TInt, $Heap);
    assume $Is(Mul(b#0, c#0) - b#0, Tclass._System.nat());
    ##e#1_1_2_1 := Mul(b#0, c#0) - b#0;
    assume $IsAlloc(##e#1_1_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0) - b#0);
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(a#0, Mul(b#0, c#0) - b#0);
    ##b#1_1_2_2 := a#0;
    assume $IsAlloc(##b#1_1_2_2, TInt, $Heap);
    ##e#1_1_2_2 := b#0;
    assume $IsAlloc(##e#1_1_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_2_3 := a#0;
    assume $IsAlloc(##b#1_1_2_3, TInt, $Heap);
    assume $Is(Mul(b#0, c#0 - 1), Tclass._System.nat());
    ##e#1_1_2_3 := Mul(b#0, c#0 - 1);
    assume $IsAlloc(##e#1_1_2_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0 - 1));
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(a#0, Mul(b#0, c#0 - 1));
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0) - b#0)) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0 - 1)));
    assume false;
    goto anon17;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    ##b#1_1_1_0 := a#0;
    assume $IsAlloc(##b#1_1_1_0, TInt, $Heap);
    ##e#1_1_1_0 := b#0;
    assume $IsAlloc(##e#1_1_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_1_1 := a#0;
    assume $IsAlloc(##b#1_1_1_1, TInt, $Heap);
    assume $Is(Mul(b#0, c#0 - 1), Tclass._System.nat());
    ##e#1_1_1_1 := Mul(b#0, c#0 - 1);
    assume $IsAlloc(##e#1_1_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#0, c#0 - 1));
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(a#0, Mul(b#0, c#0 - 1));
    assume true;
    a##1_1_1_0 := a#0;
    assume true;
    b##1_1_1_0 := b#0;
    assume true;
    assume $Is(c#0 - 1, Tclass._System.nat());
    c##1_1_1_0 := c#0 - 1;
    assume 0 <= c#0 || c##1_1_1_0 == c#0;
    assume c##1_1_1_0 < c#0;
    call CallPre$$Power.__default.LemmaPowMultiplies(a##1_1_1_0, b##1_1_1_0, c##1_1_1_0);
    call CallPost$$Power.__default.LemmaPowMultiplies(a##1_1_1_0, b##1_1_1_0, c##1_1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(288,41)"} true;
    ##b#1_1_1_2 := a#0;
    assume $IsAlloc(##b#1_1_1_2, TInt, $Heap);
    ##e#1_1_1_2 := b#0;
    assume $IsAlloc(##e#1_1_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_1_3 := a#0;
    assume $IsAlloc(##b#1_1_1_3, TInt, $Heap);
    ##e#1_1_1_3 := b#0;
    assume $IsAlloc(##e#1_1_1_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_1_4 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0);
    assume $IsAlloc(##b#1_1_1_4, TInt, $Heap);
    assume $Is(c#0 - 1, Tclass._System.nat());
    ##e#1_1_1_4 := c#0 - 1;
    assume $IsAlloc(##e#1_1_1_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0 - 1);
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0 - 1);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, Mul(b#0, c#0 - 1))) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), c#0 - 1));
    assume false;
    goto anon17;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    ##b#1_1_0_0 := a#0;
    assume $IsAlloc(##b#1_1_0_0, TInt, $Heap);
    ##e#1_1_0_0 := b#0;
    assume $IsAlloc(##e#1_1_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_0_1 := a#0;
    assume $IsAlloc(##b#1_1_0_1, TInt, $Heap);
    ##e#1_1_0_1 := b#0;
    assume $IsAlloc(##e#1_1_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_0_2 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0);
    assume $IsAlloc(##b#1_1_0_2, TInt, $Heap);
    assume $Is(c#0 - 1, Tclass._System.nat());
    ##e#1_1_0_2 := c#0 - 1;
    assume $IsAlloc(##e#1_1_0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0 - 1);
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0 - 1);
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(290,21)"} true;
    ##b#1_1_0_3 := a#0;
    assume $IsAlloc(##b#1_1_0_3, TInt, $Heap);
    ##e#1_1_0_3 := b#0;
    assume $IsAlloc(##e#1_1_0_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#0);
    ##b#1_1_0_4 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0);
    assume $IsAlloc(##b#1_1_0_4, TInt, $Heap);
    ##e#1_1_0_4 := c#0;
    assume $IsAlloc(##e#1_1_0_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    assume Power.__default.Pow#canCall(a#0, b#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), c#0 - 1)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, b#0), c#0);
    assume false;
    goto anon17;

  anon30_Else:
    goto anon17;

  anon17:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, Mul(b#0, c#0)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#0), c#0);
    return;
}



procedure {:verboseName "Power.LemmaPowMultipliesAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowMultipliesAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowMultipliesAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowMultipliesAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var c#0: int;
  var a#0: int;
  var b#2: int;
  var c#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowMultipliesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(296,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(297,12): post-state"} true;
    havoc b#0;
    havoc c#0;
    assume LitInt(0) <= b#0 && LitInt(0) <= c#0;
    assume LitInt(0) <= Mul(b#0, c#0);
    assume (forall b#1: int, c#1: int :: { Mul(b#1, c#1) } LitInt(0) <= b#1 && LitInt(0) <= c#1 ==> LitInt(0) <= Mul(b#1, c#1));
    havoc a#0;
    havoc b#2;
    havoc c#2;
    assume LitInt(0) <= b#2 && LitInt(0) <= c#2;
    ##b#0 := a#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := b#2;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, b#2);
    ##b#1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#2);
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := c#2;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#2), c#2);
    ##b#2 := a#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    assume $Is(Mul(b#2, c#2), Tclass._System.nat());
    ##e#2 := Mul(b#2, c#2);
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, Mul(b#2, c#2));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, b#2), c#2) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, Mul(b#2, c#2));
    assume (forall a#1: int, b#3: int, c#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)) } LitInt(0) <= b#3 && LitInt(0) <= c#3 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, b#3), c#3) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)));
    return;
}



procedure {:verboseName "Power.LemmaPowMultipliesAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowMultipliesAuto();



procedure {:verboseName "Power.LemmaPowMultipliesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowMultipliesAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14233"} (forall b#1: int, c#1: int :: { Mul(b#1, c#1) } LitInt(0) <= b#1 && LitInt(0) <= c#1 ==> LitInt(0) <= Mul(b#1, c#1));
  free ensures (forall a#1: int, b#3: int, c#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)) } LitInt(0) <= b#3 && LitInt(0) <= c#3 ==> Power.__default.Pow#canCall(a#1, b#3) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, b#3), c#3) && Power.__default.Pow#canCall(a#1, Mul(b#3, c#3)));
  free ensures {:id "id14234"} (forall a#1: int, b#3: int, c#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)) } LitInt(0) <= b#3 && LitInt(0) <= c#3 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, b#3), c#3) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowMultipliesAuto (correctness)"} Impl$$Power.__default.LemmaPowMultipliesAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14235"} (forall b#1: int, c#1: int :: { Mul(b#1, c#1) } LitInt(0) <= b#1 && LitInt(0) <= c#1 ==> LitInt(0) <= Mul(b#1, c#1));
  free ensures (forall a#1: int, b#3: int, c#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)) } LitInt(0) <= b#3 && LitInt(0) <= c#3 ==> Power.__default.Pow#canCall(a#1, b#3) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, b#3), c#3) && Power.__default.Pow#canCall(a#1, Mul(b#3, c#3)));
  free ensures {:id "id14236"} (forall a#1: int, b#3: int, c#3: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)) } LitInt(0) <= b#3 && LitInt(0) <= c#3 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#1, b#3), c#3) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#1, Mul(b#3, c#3)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowMultipliesAuto (correctness)"} Impl$$Power.__default.LemmaPowMultipliesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var c#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_2: int;
  var ##e#0_2: int;
  var a##0_0: int;
  var b##0_0: int;
  var c##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowMultipliesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(300,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(301,15)"} true;
    call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(302,29)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc a#0_0, b#0_0, c#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= c#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := a#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := b#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0_0, b#0_0);
    ##b#0_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_0, b#0_0);
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := c#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_0, b#0_0), c#0_0);
    ##b#0_2 := a#0_0;
    assume $IsAlloc(##b#0_2, TInt, $Heap);
    assume $Is(Mul(b#0_0, c#0_0), Tclass._System.nat());
    ##e#0_2 := Mul(b#0_0, c#0_0);
    assume $IsAlloc(##e#0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0_0, Mul(b#0_0, c#0_0));
    assume Power.__default.Pow#canCall(a#0_0, b#0_0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_0, b#0_0), c#0_0) && Power.__default.Pow#canCall(a#0_0, Mul(b#0_0, c#0_0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_0, b#0_0), c#0_0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_0, Mul(b#0_0, c#0_0));
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    c##0_0 := c#0_0;
    call CallPre$$Power.__default.LemmaPowMultiplies(a##0_0, b##0_0, c##0_0);
    call CallPost$$Power.__default.LemmaPowMultiplies(a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(306,33)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0_0, b#0_0), c#0_0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0_0, Mul(b#0_0, c#0_0));
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall a#0_1: int, b#0_1: int, c#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_1, Mul(b#0_1, c#0_1)) } LitInt(0) <= b#0_1 && LitInt(0) <= c#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_1, b#0_1), c#0_1) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_1, Mul(b#0_1, c#0_1)));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(307,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowDistributes (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowDistributes(a#0: int, b#0: int, e#0: int where LitInt(0) <= e#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowDistributes (call precondtion)"} CallPre$$Power.__default.LemmaPowDistributes(a#0: int, b#0: int, e#0: int where LitInt(0) <= e#0);



procedure {:verboseName "Power.LemmaPowDistributes (call postcondition)"} CallPost$$Power.__default.LemmaPowDistributes(a#0: int, b#0: int, e#0: int where LitInt(0) <= e#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(Mul(a#0, b#0), e#0) && Power.__default.Pow#canCall(a#0, e#0) && Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14248"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#0, b#0), e#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowDistributes (correctness)"} Impl$$Power.__default.LemmaPowDistributes(a#0: int, b#0: int, e#0: int where LitInt(0) <= e#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(Mul(a#0, b#0), e#0) && Power.__default.Pow#canCall(a#0, e#0) && Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14249"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#0, b#0), e#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowDistributes (correctness)"} Impl$$Power.__default.LemmaPowDistributes(a#0: int, b#0: int, e#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_0_0_0: int;
  var ##e#0_0_0_0: int;
  var ##b#0_0_0_1: int;
  var ##e#0_0_0_1: int;
  var ##b#0_0_0_2: int;
  var ##e#0_0_0_2: int;
  var ##b#0_0_0_3: int;
  var ##e#0_0_0_3: int;
  var ##b#0_0_1_0: int;
  var ##e#0_0_1_0: int;
  var ##b#0_0_1_1: int;
  var ##e#0_0_1_1: int;
  var ##b#0_0_1_2: int;
  var ##e#0_0_1_2: int;
  var ##b#0_0_1_3: int;
  var ##e#0_0_1_3: int;
  var ##b#0_0_2_0: int;
  var ##e#0_0_2_0: int;
  var a##0_0_2_0: int;
  var b##0_0_2_0: int;
  var e##0_0_2_0: int;
  var ##b#0_0_2_1: int;
  var ##e#0_0_2_1: int;
  var ##b#0_0_2_2: int;
  var ##e#0_0_2_2: int;
  var ##b#0_0_3_0: int;
  var ##e#0_0_3_0: int;
  var ##b#0_0_3_1: int;
  var ##e#0_0_3_1: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowDistributes", " | ", a#0, " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(314,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#a0#0: int, $ih#b0#0: int, $ih#e0#0: int :: LitInt(0) <= $ih#e0#0 && Lit(true) && 0 <= $ih#e0#0 && $ih#e0#0 < e#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul($ih#a0#0, $ih#b0#0), $ih#e0#0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#a0#0, $ih#e0#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e0#0)));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(315,15)"} true;
    call CallPre$$Mul.__default.LemmaMulBasicsAuto();
    call CallPost$$Mul.__default.LemmaMulBasicsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(316,24)"} true;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} e#0 > 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##b#0_0_0 := Mul(a#0, b#0);
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    ##e#0_0_0 := e#0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0);
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##b#0_0_3_0 := Mul(a#0, b#0);
    assume $IsAlloc(##b#0_0_3_0, TInt, $Heap);
    ##e#0_0_3_0 := e#0;
    assume $IsAlloc(##e#0_0_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0);
    ##b#0_0_3_1 := Mul(a#0, b#0);
    assume $IsAlloc(##b#0_0_3_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_3_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0 - 1);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0 - 1);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#0, b#0), e#0) == Mul(Mul(a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#0, b#0), e#0 - 1));
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##b#0_0_2_0 := Mul(a#0, b#0);
    assume $IsAlloc(##b#0_0_2_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_2_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0 - 1);
    assume Power.__default.Pow#canCall(Mul(a#0, b#0), e#0 - 1);
    assume true;
    a##0_0_2_0 := a#0;
    assume true;
    b##0_0_2_0 := b#0;
    assume true;
    assume $Is(e#0 - 1, Tclass._System.nat());
    e##0_0_2_0 := e#0 - 1;
    assume 0 <= e#0 || e##0_0_2_0 == e#0;
    assume e##0_0_2_0 < e#0;
    call CallPre$$Power.__default.LemmaPowDistributes(a##0_0_2_0, b##0_0_2_0, e##0_0_2_0);
    call CallPost$$Power.__default.LemmaPowDistributes(a##0_0_2_0, b##0_0_2_0, e##0_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(321,42)"} true;
    ##b#0_0_2_1 := a#0;
    assume $IsAlloc(##b#0_0_2_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_2_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1);
    ##b#0_0_2_2 := b#0;
    assume $IsAlloc(##b#0_0_2_2, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_2_2 := e#0 - 1;
    assume $IsAlloc(##e#0_0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1) && Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mul(Mul(a#0, b#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#0, b#0), e#0 - 1)) == Mul(Mul(a#0, b#0), Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0 - 1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##b#0_0_1_0 := a#0;
    assume $IsAlloc(##b#0_0_1_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1);
    ##b#0_0_1_1 := b#0;
    assume $IsAlloc(##b#0_0_1_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1) && Power.__default.Pow#canCall(b#0, e#0 - 1);
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(323,37)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(323,66)"} true;
    ##b#0_0_1_2 := a#0;
    assume $IsAlloc(##b#0_0_1_2, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1_2 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1);
    ##b#0_0_1_3 := b#0;
    assume $IsAlloc(##b#0_0_1_3, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1_3 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1) && Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mul(Mul(a#0, b#0), Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0 - 1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1))) == Mul(Mul(a#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0 - 1)), Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)));
    assume false;
    goto anon7;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##b#0_0_0_0 := a#0;
    assume $IsAlloc(##b#0_0_0_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_0_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1);
    ##b#0_0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_0_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_0_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow#canCall(a#0, e#0 - 1) && Power.__default.Pow#canCall(b#0, e#0 - 1);
    ##b#0_0_0_2 := a#0;
    assume $IsAlloc(##b#0_0_0_2, TInt, $Heap);
    ##e#0_0_0_2 := e#0;
    assume $IsAlloc(##e#0_0_0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0, e#0);
    ##b#0_0_0_3 := b#0;
    assume $IsAlloc(##b#0_0_0_3, TInt, $Heap);
    ##e#0_0_0_3 := e#0;
    assume $IsAlloc(##e#0_0_0_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume Power.__default.Pow#canCall(a#0, e#0) && Power.__default.Pow#canCall(b#0, e#0);
    assume {:subsumption 0} Mul(Mul(a#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0 - 1)), Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1))) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0, e#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0));
    assume false;
    goto anon7;

  anon14_Else:
    goto anon7;

  anon7:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#0, b#0), e#0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0, e#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0));
    return;

  anon9_Else:
    assume {:partition} 0 >= e#0;
    return;
}



procedure {:verboseName "Power.LemmaPowDistributesAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowDistributesAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowDistributesAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowDistributesAuto();



procedure {:verboseName "Power.LemmaPowDistributesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowDistributesAuto();
  modifies $Heap;
  free ensures (forall a#1: int, b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#1, b#1), e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow#canCall(Mul(a#1, b#1), e#1) && Power.__default.Pow#canCall(a#1, e#1) && Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14280"} (forall a#1: int, b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#1, b#1), e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#1, b#1), e#1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#1, e#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowDistributesAuto (correctness)"} Impl$$Power.__default.LemmaPowDistributesAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall a#1: int, b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#1, b#1), e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow#canCall(Mul(a#1, b#1), e#1) && Power.__default.Pow#canCall(a#1, e#1) && Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14281"} (forall a#1: int, b#1: int, e#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#1, b#1), e#1) } LitInt(0) <= e#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#1, b#1), e#1) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#1, e#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowDistributesAuto (correctness)"} Impl$$Power.__default.LemmaPowDistributesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var a#0_0: int;
  var b#0_0: int;
  var e#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_2: int;
  var ##e#0_2: int;
  var a##0_0: int;
  var b##0_0: int;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowDistributesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(333,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(334,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc a#0_0, b#0_0, e#0_0;
    assume LitInt(0) <= e#0_0;
    assume true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := Mul(a#0_0, b#0_0);
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mul(a#0_0, b#0_0), e#0_0);
    ##b#0_1 := a#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(a#0_0, e#0_0);
    ##b#0_2 := b#0_0;
    assume $IsAlloc(##b#0_2, TInt, $Heap);
    ##e#0_2 := e#0_0;
    assume $IsAlloc(##e#0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume Power.__default.Pow#canCall(Mul(a#0_0, b#0_0), e#0_0) && Power.__default.Pow#canCall(a#0_0, e#0_0) && Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#0_0, b#0_0), e#0_0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_0, e#0_0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e#0_0));
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    a##0_0 := a#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e##0_0 := e#0_0;
    call CallPre$$Power.__default.LemmaPowDistributes(a##0_0, b##0_0, e##0_0);
    call CallPost$$Power.__default.LemmaPowDistributes(a##0_0, b##0_0, e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(338,34)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(a#0_0, b#0_0), e#0_0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, a#0_0, e#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e#0_0));
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall a#0_1: int, b#0_1: int, e#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#0_1, b#0_1), e#0_1) } LitInt(0) <= e#0_1 && Lit(true) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(a#0_1, b#0_1), e#0_1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, a#0_1, e#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e#0_1)));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(339,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowAuto();
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0: int;
  var ##b#0: int;
  var ##e#0: int;
  var x#2: int;
  var ##b#1: int;
  var ##e#1: int;
  var x#4: int;
  var y#0: int;
  var ##b#2: int;
  var ##e#2: int;
  var x#6: int;
  var y#2: int;
  var ##b#3: int;
  var ##e#3: int;
  var x#8: int;
  var y#4: int;
  var x#10: int;
  var y#6: int;
  var x#12: int;
  var y#8: int;
  var z#0: int;
  var ##b#4: int;
  var ##e#4: int;
  var ##b#5: int;
  var ##e#5: int;
  var ##b#6: int;
  var ##e#6: int;
  var x#14: int;
  var y#10: int;
  var z#2: int;
  var ##b#7: int;
  var ##e#7: int;
  var ##b#8: int;
  var ##e#8: int;
  var ##b#9: int;
  var ##e#9: int;
  var x#16: int;
  var y#12: int;
  var z#4: int;
  var ##b#10: int;
  var ##e#10: int;
  var ##b#11: int;
  var ##e#11: int;
  var ##b#12: int;
  var ##e#12: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(343,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(344,12): post-state"} true;
    havoc x#0;
    assume true;
    ##b#0 := x#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#0, LitInt(0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#0, LitInt(0)) == LitInt(1);
    assume (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 0) } Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, LitInt(0)) == LitInt(1));
    havoc x#2;
    assume true;
    ##b#1 := x#2;
    assume $IsAlloc(##b#1, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#1 := LitInt(1);
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#2, LitInt(1));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#2, LitInt(1)) == x#2;
    assume (forall x#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#3, 1) } Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#3, LitInt(1)) == x#3);
    havoc x#4;
    havoc y#0;
    assume true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume y#0 == LitInt(0);
    ##b#2 := x#4;
    assume $IsAlloc(##b#2, TInt, $Heap);
    assume $Is(y#0, Tclass._System.nat());
    ##e#2 := y#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#4, y#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#4, y#0) == LitInt(1);
    goto anon4;

  anon17_Else:
    assume y#0 == LitInt(0) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#4, y#0) == LitInt(1);
    goto anon4;

  anon4:
    assume (forall x#5: int, y#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#5, y#1) } y#1 == LitInt(0) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#5, y#1) == LitInt(1));
    havoc x#6;
    havoc y#2;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume y#2 == LitInt(1);
    ##b#3 := x#6;
    assume $IsAlloc(##b#3, TInt, $Heap);
    assume $Is(y#2, Tclass._System.nat());
    ##e#3 := y#2;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#6, y#2);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#6, y#2) == x#6;
    goto anon7;

  anon18_Else:
    assume y#2 == LitInt(1) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#6, y#2) == x#6;
    goto anon7;

  anon7:
    assume (forall x#7: int, y#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#7, y#3) } y#3 == LitInt(1) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#7, y#3) == x#7);
    havoc x#8;
    havoc y#4;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume 0 < x#8;
    assume 0 < y#4;
    assume x#8 <= Mul(x#8, y#4);
    goto anon10;

  anon19_Else:
    assume 0 < x#8 && 0 < y#4 ==> x#8 <= Mul(x#8, y#4);
    goto anon10;

  anon10:
    assume (forall x#9: int, y#5: int :: { Mul(x#9, y#5) } 0 < x#9 && 0 < y#5 ==> x#9 <= Mul(x#9, y#5));
    havoc x#10;
    havoc y#6;
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume 0 < x#10;
    assume 1 < y#6;
    assume x#10 < Mul(x#10, y#6);
    goto anon13;

  anon20_Else:
    assume 0 < x#10 && 1 < y#6 ==> x#10 < Mul(x#10, y#6);
    goto anon13;

  anon13:
    assume (forall x#11: int, y#7: int :: { Mul(x#11, y#7) } 0 < x#11 && 1 < y#7 ==> x#11 < Mul(x#11, y#7));
    havoc x#12;
    havoc y#8;
    havoc z#0;
    assume LitInt(0) <= y#8 && LitInt(0) <= z#0;
    ##b#4 := x#12;
    assume $IsAlloc(##b#4, TInt, $Heap);
    assume $Is(y#8 + z#0, Tclass._System.nat());
    ##e#4 := y#8 + z#0;
    assume $IsAlloc(##e#4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#12, y#8 + z#0);
    ##b#5 := x#12;
    assume $IsAlloc(##b#5, TInt, $Heap);
    ##e#5 := y#8;
    assume $IsAlloc(##e#5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#12, y#8);
    ##b#6 := x#12;
    assume $IsAlloc(##b#6, TInt, $Heap);
    ##e#6 := z#0;
    assume $IsAlloc(##e#6, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#12, z#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#12, y#8 + z#0) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#12, y#8), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#12, z#0));
    assume (forall x#13: int, y#9: int, z#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9 + z#1) } LitInt(0) <= y#9 && LitInt(0) <= z#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9 + z#1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, z#1)));
    havoc x#14;
    havoc y#10;
    havoc z#2;
    assume LitInt(0) <= y#10 && LitInt(0) <= z#2;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume y#10 >= z#2;
    ##b#7 := x#14;
    assume $IsAlloc(##b#7, TInt, $Heap);
    assume $Is(y#10 - z#2, Tclass._System.nat());
    ##e#7 := y#10 - z#2;
    assume $IsAlloc(##e#7, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#14, y#10 - z#2);
    ##b#8 := x#14;
    assume $IsAlloc(##b#8, TInt, $Heap);
    ##e#8 := z#2;
    assume $IsAlloc(##e#8, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#14, z#2);
    ##b#9 := x#14;
    assume $IsAlloc(##b#9, TInt, $Heap);
    ##e#9 := y#10;
    assume $IsAlloc(##e#9, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#14, y#10);
    assume Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#14, y#10 - z#2), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#14, z#2)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#14, y#10);
    goto anon16;

  anon21_Else:
    assume y#10 >= z#2 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#14, y#10 - z#2), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#14, z#2)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#14, y#10);
    goto anon16;

  anon16:
    assume (forall x#15: int, y#11: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11 - z#3) } LitInt(0) <= y#11 && LitInt(0) <= z#3 ==> y#11 >= z#3 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11 - z#3), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, z#3)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11));
    havoc x#16;
    havoc y#12;
    havoc z#4;
    assume LitInt(0) <= z#4;
    ##b#10 := Mul(x#16, y#12);
    assume $IsAlloc(##b#10, TInt, $Heap);
    ##e#10 := z#4;
    assume $IsAlloc(##e#10, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mul(x#16, y#12), z#4);
    ##b#11 := x#16;
    assume $IsAlloc(##b#11, TInt, $Heap);
    ##e#11 := z#4;
    assume $IsAlloc(##e#11, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(x#16, z#4);
    ##b#12 := y#12;
    assume $IsAlloc(##b#12, TInt, $Heap);
    ##e#12 := z#4;
    assume $IsAlloc(##e#12, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(y#12, z#4);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#16, y#12), z#4) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#16, z#4), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, y#12, z#4));
    assume (forall x#17: int, y#13: int, z#5: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) } LitInt(0) <= z#5 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#17, z#5), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, y#13, z#5)));
    return;
}



procedure {:verboseName "Power.LemmaPowAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowAuto();



procedure {:verboseName "Power.LemmaPowAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowAuto();
  modifies $Heap;
  free ensures (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 0) } Power.__default.Pow#canCall(x#1, LitInt(0)));
  free ensures {:id "id14325"} (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 0) } Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, LitInt(0)) == LitInt(1));
  free ensures (forall x#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#3, 1) } Power.__default.Pow#canCall(x#3, LitInt(1)));
  free ensures {:id "id14326"} (forall x#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#3, 1) } Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#3, LitInt(1)) == x#3);
  free ensures (forall x#5: int, y#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#5, y#1) } y#1 == LitInt(0) ==> Power.__default.Pow#canCall(x#5, y#1));
  free ensures {:id "id14327"} (forall x#5: int, y#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#5, y#1) } y#1 == LitInt(0) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#5, y#1) == LitInt(1));
  free ensures (forall x#7: int, y#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#7, y#3) } y#3 == LitInt(1) ==> Power.__default.Pow#canCall(x#7, y#3));
  free ensures {:id "id14328"} (forall x#7: int, y#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#7, y#3) } y#3 == LitInt(1) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#7, y#3) == x#7);
  free ensures true;
  free ensures {:id "id14329"} (forall x#9: int, y#5: int :: { Mul(x#9, y#5) } 0 < x#9 && 0 < y#5 ==> x#9 <= Mul(x#9, y#5));
  free ensures true;
  free ensures {:id "id14330"} (forall x#11: int, y#7: int :: { Mul(x#11, y#7) } 0 < x#11 && 1 < y#7 ==> x#11 < Mul(x#11, y#7));
  free ensures (forall x#13: int, y#9: int, z#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9 + z#1) } LitInt(0) <= y#9 && LitInt(0) <= z#1 ==> Power.__default.Pow#canCall(x#13, y#9 + z#1) && Power.__default.Pow#canCall(x#13, y#9) && Power.__default.Pow#canCall(x#13, z#1));
  free ensures {:id "id14331"} (forall x#13: int, y#9: int, z#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9 + z#1) } LitInt(0) <= y#9 && LitInt(0) <= z#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9 + z#1) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, z#1)));
  free ensures (forall x#15: int, y#11: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11 - z#3) } LitInt(0) <= y#11 && LitInt(0) <= z#3 ==> y#11 >= z#3 ==> Power.__default.Pow#canCall(x#15, y#11 - z#3) && Power.__default.Pow#canCall(x#15, z#3) && Power.__default.Pow#canCall(x#15, y#11));
  free ensures {:id "id14332"} (forall x#15: int, y#11: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11 - z#3) } LitInt(0) <= y#11 && LitInt(0) <= z#3 ==> y#11 >= z#3 ==> Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11 - z#3), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, z#3)) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11));
  free ensures (forall x#17: int, y#13: int, z#5: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) } LitInt(0) <= z#5 ==> Power.__default.Pow#canCall(Mul(x#17, y#13), z#5) && Power.__default.Pow#canCall(x#17, z#5) && Power.__default.Pow#canCall(y#13, z#5));
  free ensures {:id "id14333"} (forall x#17: int, y#13: int, z#5: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) } LitInt(0) <= z#5 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) == Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#17, z#5), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, y#13, z#5)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowAuto (correctness)"} Impl$$Power.__default.LemmaPowAuto() returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall x#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#1, 0) } Power.__default.Pow#canCall(x#1, LitInt(0)));
  free ensures {:id "id14334"} (forall x#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#1, 0) } Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#1, LitInt(0)) == LitInt(1));
  free ensures (forall x#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#3, 1) } Power.__default.Pow#canCall(x#3, LitInt(1)));
  free ensures {:id "id14335"} (forall x#3: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#3, 1) } Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#3, LitInt(1)) == x#3);
  free ensures (forall x#5: int, y#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#5, y#1) } y#1 == LitInt(0) ==> Power.__default.Pow#canCall(x#5, y#1));
  free ensures {:id "id14336"} (forall x#5: int, y#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#5, y#1) } y#1 == LitInt(0) ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#5, y#1) == LitInt(1));
  free ensures (forall x#7: int, y#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#7, y#3) } y#3 == LitInt(1) ==> Power.__default.Pow#canCall(x#7, y#3));
  free ensures {:id "id14337"} (forall x#7: int, y#3: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#7, y#3) } y#3 == LitInt(1) ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#7, y#3) == x#7);
  free ensures true;
  free ensures {:id "id14338"} (forall x#9: int, y#5: int :: { Mul(x#9, y#5) } 0 < x#9 && 0 < y#5 ==> x#9 <= Mul(x#9, y#5));
  free ensures true;
  free ensures {:id "id14339"} (forall x#11: int, y#7: int :: { Mul(x#11, y#7) } 0 < x#11 && 1 < y#7 ==> x#11 < Mul(x#11, y#7));
  free ensures (forall x#13: int, y#9: int, z#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#13, y#9 + z#1) } LitInt(0) <= y#9 && LitInt(0) <= z#1 ==> Power.__default.Pow#canCall(x#13, y#9 + z#1) && Power.__default.Pow#canCall(x#13, y#9) && Power.__default.Pow#canCall(x#13, z#1));
  free ensures {:id "id14340"} (forall x#13: int, y#9: int, z#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#13, y#9 + z#1) } LitInt(0) <= y#9 && LitInt(0) <= z#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#13, y#9 + z#1) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#13, y#9), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#13, z#1)));
  free ensures (forall x#15: int, y#11: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, x#15, y#11 - z#3) } LitInt(0) <= y#11 && LitInt(0) <= z#3 ==> y#11 >= z#3 ==> Power.__default.Pow#canCall(x#15, y#11 - z#3) && Power.__default.Pow#canCall(x#15, z#3) && Power.__default.Pow#canCall(x#15, y#11));
  free ensures {:id "id14341"} (forall x#15: int, y#11: int, z#3: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#15, y#11 - z#3) } LitInt(0) <= y#11 && LitInt(0) <= z#3 ==> y#11 >= z#3 ==> Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#15, y#11 - z#3), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#15, z#3)) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#15, y#11));
  free ensures (forall x#17: int, y#13: int, z#5: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) } LitInt(0) <= z#5 ==> Power.__default.Pow#canCall(Mul(x#17, y#13), z#5) && Power.__default.Pow#canCall(x#17, z#5) && Power.__default.Pow#canCall(y#13, z#5));
  free ensures {:id "id14342"} (forall x#17: int, y#13: int, z#5: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) } LitInt(0) <= z#5 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mul(x#17, y#13), z#5) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, x#17, z#5), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, y#13, z#5)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowAuto (correctness)"} Impl$$Power.__default.LemmaPowAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(353,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(354,15)"} true;
    call CallPre$$Power.__default.LemmaPow0Auto();
    call CallPost$$Power.__default.LemmaPow0Auto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(356,19)"} true;
    call CallPre$$Power.__default.LemmaPow1Auto();
    call CallPost$$Power.__default.LemmaPow1Auto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(357,19)"} true;
    call CallPre$$Power.__default.LemmaPowDistributesAuto();
    call CallPost$$Power.__default.LemmaPowDistributesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(359,29)"} true;
    call CallPre$$Power.__default.LemmaPowAddsAuto();
    call CallPost$$Power.__default.LemmaPowAddsAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(360,22)"} true;
    call CallPre$$Power.__default.LemmaPowSubAddCancelAuto();
    call CallPost$$Power.__default.LemmaPowSubAddCancelAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(361,30)"} true;
    call CallPre$$MulInternals.__default.LemmaMulAuto();
    call CallPost$$MulInternals.__default.LemmaMulAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(363,18)"} true;
    call CallPre$$Mul.__default.LemmaMulIncreasesAuto();
    call CallPost$$Mul.__default.LemmaMulIncreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(364,27)"} true;
    call CallPre$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
    call CallPost$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(365,35)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowStrictlyIncreases (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowStrictlyIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreases (call precondtion)"} CallPre$$Power.__default.LemmaPowStrictlyIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14364"} 1 < b#0;
  requires {:id "id14365"} e1#0 < e2#0;



procedure {:verboseName "Power.LemmaPowStrictlyIncreases (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14366"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreases (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  requires {:id "id14367"} 1 < b#0;
  requires {:id "id14368"} e1#0 < e2#0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14369"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowStrictlyIncreases (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreases(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0: Heap;
  var e#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;
  var i#0_0: int;
  var ##x#0_0: int;
  var ##y#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_0_0_0: int;
  var ##e#0_0_0_0: int;
  var ##b#0_0_0_1: int;
  var ##e#0_0_0_1: int;
  var ##b#0_0_1_0: int;
  var ##e#0_0_1_0: int;
  var ##b#0_0_1_1: int;
  var ##e#0_0_1_1: int;
  var b##0_0_1_0: int;
  var e1##0_0_1_0: int;
  var e2##0_0_1_0: int;
  var ##b#0_0_1_2: int;
  var ##e#0_0_1_2: int;
  var ##b#0_0_2_0: int;
  var ##e#0_0_2_0: int;
  var b##0_0_2_0: int;
  var ##b#0_0_2_1: int;
  var ##e#0_0_2_1: int;
  var ##b#0_0_2_2: int;
  var ##e#0_0_2_2: int;
  var ##b#0_0_3_0: int;
  var ##e#0_0_3_0: int;
  var b##0_0_3_0: int;
  var e##0_0_3_0: int;
  var x##0_0_3_0: int;
  var ##b#0_0_3_1: int;
  var ##e#0_0_3_1: int;
  var y##0_0_3_0: int;
  var z##0_0_3_0: int;
  var ##b#0_0_3_2: int;
  var ##e#0_0_3_2: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var x##0: int;
  var f##0: HandleType;
  var ##b#4: int;
  var ##e#4: int;
  var ##b#5: int;
  var ##e#5: int;
  var ##b#6: int;
  var ##e#6: int;
  var ##b#7: int;
  var ##e#7: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreases", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(374,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && 1 < $ih#b0#0 && $ih#e10#0 < $ih#e20#0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#e10#0 && $ih#e10#0 < e1#0) || ($ih#e10#0 == e1#0 && 0 <= $ih#e20#0 && $ih#e20#0 < e2#0)))) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(375,15)"} true;
    call CallPre$$Power.__default.LemmaPowAuto();
    call CallPost$$Power.__default.LemmaPowAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(376,18)"} true;
    assume true;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc e#0;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} 0 < e#0;
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $lambdaHeap#0);
    ##e#2 := e1#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $lambdaHeap#0);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#3 := b#0;
    assume $IsAlloc(##b#3, TInt, $lambdaHeap#0);
    assume $Is(e1#0 + e#0, Tclass._System.nat());
    ##e#3 := e1#0 + e#0;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $lambdaHeap#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e#0);
    goto anon4;

  anon31_Else:
    assume {:partition} e#0 <= 0;
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> 0 < e#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e#0);
    assume 0 < e#0 ==> Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + e#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon30_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon29_Else:
    goto anon6;

  anon6:
    assume (forall $l#0#e#0: int :: 0 < $l#0#e#0 ==> Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + $l#0#e#0));
    f#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#e#0: Box :: $Box(0 < $Unbox($l#1#e#0): int ==> Power.__default.Pow($l#1#ly#0, reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($l#1#ly#0, reveal_Power._default.Pow, b#0, e1#0 + $Unbox($l#1#e#0): int))), (lambda $l#1#heap#0: Heap, $l#1#e#0: Box :: $IsBox($l#1#e#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#e#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(377,55)"} true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    havoc i#0_0;
    assume true;
    ##x#0_0 := LitInt(0);
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##y#0_0 := i#0_0;
    assume $IsAlloc(##y#0_0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0_0);
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0_0);
    goto anon9;

  anon33_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0_0);
    goto anon9;

  anon9:
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0_0);
    assume GeneralInternals.__default.IsLe(LitInt(0), i#0_0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0))): bool;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0 + 1))): bool;
    assume false;
    goto anon11;

  anon34_Else:
    goto anon11;

  anon11:
    push;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} 0 < i#0_0;
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e1#0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#0_1 := b#0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_1 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    goto anon13;

  anon35_Else:
    assume {:partition} i#0_0 <= 0;
    goto anon13;

  anon13:
    assume 0 < i#0_0 ==> Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume {:subsumption 0} 0 < i#0_0 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0);
    assume 0 < i#0_0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(381,50)"} true;
    goto anon36_Then, anon36_Else;

  anon36_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume false;
    goto anon22;

  anon36_Else:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    ##b#0_0_3_0 := b#0;
    assume $IsAlloc(##b#0_0_3_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_3_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    push;
    push;
    assume true;
    b##0_0_3_0 := b#0;
    assume true;
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    e##0_0_3_0 := e1#0 + i#0_0;
    call CallPre$$Power.__default.LemmaPowPositive(b##0_0_3_0, e##0_0_3_0);
    call CallPost$$Power.__default.LemmaPowPositive(b##0_0_3_0, e##0_0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(384,38)"} true;
    ##b#0_0_3_1 := b#0;
    assume $IsAlloc(##b#0_0_3_1, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_3_1 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    x##0_0_3_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0);
    assume true;
    y##0_0_3_0 := LitInt(1);
    assume true;
    z##0_0_3_0 := b#0;
    call CallPre$$Mul.__default.LemmaMulLeftInequality(x##0_0_3_0, y##0_0_3_0, z##0_0_3_0);
    call CallPost$$Mul.__default.LemmaMulLeftInequality(x##0_0_3_0, y##0_0_3_0, z##0_0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(385,55)"} true;
    pop;
    pop;
    ##b#0_0_3_2 := b#0;
    assume $IsAlloc(##b#0_0_3_2, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_3_2 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_3_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0) <= Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), b#0);
    assume false;
    goto anon22;

  anon37_Else:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    ##b#0_0_2_0 := b#0;
    assume $IsAlloc(##b#0_0_2_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_2_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    push;
    push;
    assume true;
    b##0_0_2_0 := b#0;
    call CallPre$$Power.__default.LemmaPow1(b##0_0_2_0);
    call CallPost$$Power.__default.LemmaPow1(b##0_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(387,23)"} true;
    pop;
    pop;
    ##b#0_0_2_1 := b#0;
    assume $IsAlloc(##b#0_0_2_1, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_2_1 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    ##b#0_0_2_2 := b#0;
    assume $IsAlloc(##b#0_0_2_2, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_0_2_2 := LitInt(1);
    assume $IsAlloc(##e#0_0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0) && Power.__default.Pow#canCall(b#0, LitInt(1));
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), b#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1)));
    assume false;
    goto anon22;

  anon38_Else:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    ##b#0_0_1_0 := b#0;
    assume $IsAlloc(##b#0_0_1_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_1_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    ##b#0_0_1_1 := b#0;
    assume $IsAlloc(##b#0_0_1_1, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_0_1_1 := LitInt(1);
    assume $IsAlloc(##e#0_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0) && Power.__default.Pow#canCall(b#0, LitInt(1));
    push;
    push;
    assume true;
    b##0_0_1_0 := b#0;
    assume true;
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    e1##0_0_1_0 := e1#0 + i#0_0;
    assume true;
    assume $Is(LitInt(1), Tclass._System.nat());
    e2##0_0_1_0 := LitInt(1);
    call CallPre$$Power.__default.LemmaPowAdds(b##0_0_1_0, e1##0_0_1_0, e2##0_0_1_0);
    call CallPost$$Power.__default.LemmaPowAdds(b##0_0_1_0, e1##0_0_1_0, e2##0_0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(389,37)"} true;
    pop;
    pop;
    ##b#0_0_1_2 := b#0;
    assume $IsAlloc(##b#0_0_1_2, TInt, $Heap);
    assume $Is(e1#0 + i#0_0 + 1, Tclass._System.nat());
    ##e#0_0_1_2 := e1#0 + i#0_0 + 1;
    assume $IsAlloc(##e#0_0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1))) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0 + 1);
    assume false;
    goto anon22;

  anon39_Else:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    ##b#0_0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0 + 1, Tclass._System.nat());
    ##e#0_0_0_0 := e1#0 + i#0_0 + 1;
    assume $IsAlloc(##e#0_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    push;
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume true;
    assume false;
    goto anon21;

  anon41_Else:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume true;
    push;
    pop;
    assume true;
    assume {:subsumption 0} e1#0 + i#0_0 + 1 == e1#0 + i#0_0 + 1;
    assume false;
    goto anon21;

  anon42_Else:
    goto anon21;

  anon21:
    assume e1#0 + i#0_0 + 1 == e1#0 + i#0_0 + 1;
    pop;
    ##b#0_0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_0_1, TInt, $Heap);
    assume $Is(e1#0 + i#0_0 + 1, Tclass._System.nat());
    ##e#0_0_0_1 := e1#0 + i#0_0 + 1;
    assume $IsAlloc(##e#0_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0 + 1) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0 + 1);
    assume false;
    goto anon22;

  anon40_Else:
    goto anon22;

  anon22:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0 + 1);
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0 + 1))): bool;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(397,19)"} true;
    pop;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0 + 1))): bool;
    assume false;
    goto anon24;

  anon32_Else:
    assume (forall i#0_1: int :: { GeneralInternals.__default.IsLe(0, i#0_1) } GeneralInternals.__default.IsLe(LitInt(0), i#0_1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1 + 1))): bool);
    goto anon24;

  anon24:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(398,4)"} true;
    assume true;
    x##0 := e2#0 - e1#0;
    assume true;
    f##0 := f#0;
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(399,37)"} true;
    ##b#4 := b#0;
    assume $IsAlloc(##b#4, TInt, $Heap);
    ##e#4 := e1#0;
    assume $IsAlloc(##e#4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#5 := b#0;
    assume $IsAlloc(##b#5, TInt, $Heap);
    assume $Is(e1#0 + e2#0 - e1#0, Tclass._System.nat());
    ##e#5 := e1#0 + e2#0 - e1#0;
    assume $IsAlloc(##e#5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0 - e1#0);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0);
    ##b#6 := b#0;
    assume $IsAlloc(##b#6, TInt, $Heap);
    assume $Is(e1#0 + e2#0 - e1#0, Tclass._System.nat());
    ##e#6 := e1#0 + e2#0 - e1#0;
    assume $IsAlloc(##e#6, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0 - e1#0);
    ##b#7 := b#0;
    assume $IsAlloc(##b#7, TInt, $Heap);
    ##e#7 := e2#0;
    assume $IsAlloc(##e#7, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    goto anon26;

  anon43_Else:
    assume {:partition} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    goto anon26;

  anon26:
    assume Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + e2#0 - e1#0) && (Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0) ==> Power.__default.Pow#canCall(b#0, e1#0 + e2#0 - e1#0) && Power.__default.Pow#canCall(b#0, e2#0));
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume true;
    assume 0 < e2#0 - e1#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(401,24)"} true;
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
    assume false;
    goto anon28;

  anon44_Else:
    goto anon28;

  anon28:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0) && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(402,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowStrictlyIncreasesAuto();
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowStrictlyIncreasesAuto();



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreasesAuto();
  modifies $Heap;
  free ensures (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 ==> e1#1 < e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14426"} (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 && e1#1 < e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesAuto (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreasesAuto() returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 ==> e1#1 < e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14427"} (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 && e1#1 < e2#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowStrictlyIncreasesAuto (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreasesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(408,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(409,15)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 1 < b#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} b#0_0 <= 1;
    goto anon3;

  anon3:
    assume true;
    assume 1 < b#0_0 && e1#0_0 < e2#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e1#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e2#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0) && Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowStrictlyIncreases(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowStrictlyIncreases(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(414,42)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && 1 < b#0_1 && e1#0_1 < e2#0_1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(415,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowIncreases (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowIncreases (call precondtion)"} CallPre$$Power.__default.LemmaPowIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14438"} b#0 > 0;
  requires {:id "id14439"} e1#0 <= e2#0;



procedure {:verboseName "Power.LemmaPowIncreases (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14440"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowIncreases (correctness)"} Impl$$Power.__default.LemmaPowIncreases(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  requires {:id "id14441"} b#0 > 0;
  requires {:id "id14442"} e1#0 <= e2#0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14443"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowIncreases (correctness)"} Impl$$Power.__default.LemmaPowIncreases(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var f#0: HandleType where $Is(f#0, Tclass._System.___hTotalFunc1(TInt, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(TInt, TBool), $Heap);
  var $lambdaHeap#0: Heap;
  var e#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;
  var i#0_0: int;
  var ##x#0_0: int;
  var ##y#0_0: int;
  var ##b#0_0_0_0: int;
  var ##e#0_0_0_0: int;
  var ##b#0_0_0_1: int;
  var ##e#0_0_0_1: int;
  var b##0_0_0_0: int;
  var e1##0_0_0_0: int;
  var e2##0_0_0_0: int;
  var ##b#0_0_0_2: int;
  var ##e#0_0_0_2: int;
  var ##b#0_0_1_0: int;
  var ##e#0_0_1_0: int;
  var b##0_0_1_0: int;
  var ##b#0_0_1_1: int;
  var ##e#0_0_1_1: int;
  var ##b#0_0_1_2: int;
  var ##e#0_0_1_2: int;
  var ##b#0_0_2_0: int;
  var ##e#0_0_2_0: int;
  var b##0_0_2_0: int;
  var e##0_0_2_0: int;
  var x##0_0_2_0: int;
  var ##b#0_0_2_1: int;
  var ##e#0_0_2_1: int;
  var y##0_0_2_0: int;
  var z##0_0_2_0: int;
  var ##b#0_0_2_2: int;
  var ##e#0_0_2_2: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var x##0: int;
  var f##0: HandleType;
  var ##b#4: int;
  var ##e#4: int;
  var ##b#5: int;
  var ##e#5: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreases", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(423,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && $ih#b0#0 > 0 && $ih#e10#0 <= $ih#e20#0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#e10#0 && $ih#e10#0 < e1#0) || ($ih#e10#0 == e1#0 && 0 <= $ih#e20#0 && $ih#e20#0 < e2#0)))) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(424,15)"} true;
    call CallPre$$Power.__default.LemmaPowAuto();
    call CallPost$$Power.__default.LemmaPowAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(425,18)"} true;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc e#0;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= e#0;
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $lambdaHeap#0);
    ##e#2 := e1#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $lambdaHeap#0);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#3 := b#0;
    assume $IsAlloc(##b#3, TInt, $lambdaHeap#0);
    assume $Is(e1#0 + e#0, Tclass._System.nat());
    ##e#3 := e1#0 + e#0;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $lambdaHeap#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e#0);
    goto anon4;

  anon23_Else:
    assume {:partition} e#0 < LitInt(0);
    goto anon4;

  anon4:
    assume lambdaResult#0 <==> LitInt(0) <= e#0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e#0);
    assume LitInt(0) <= e#0 ==> Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + e#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon22_Else:
    assume {:partition} false;
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon21_Else:
    goto anon6;

  anon6:
    assume (forall $l#0#e#0: int :: LitInt(0) <= $l#0#e#0 ==> Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + $l#0#e#0));
    f#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#e#0: Box :: $Box(LitInt(0) <= $Unbox($l#1#e#0): int ==> Power.__default.Pow($l#1#ly#0, reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($l#1#ly#0, reveal_Power._default.Pow, b#0, e1#0 + $Unbox($l#1#e#0): int))), (lambda $l#1#heap#0: Heap, $l#1#e#0: Box :: $IsBox($l#1#e#0, TInt)), (lambda $l#1#heap#0: Heap, $l#1#e#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(426,57)"} true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    havoc i#0_0;
    assume true;
    ##x#0_0 := LitInt(0);
    assume $IsAlloc(##x#0_0, TInt, $Heap);
    ##y#0_0 := i#0_0;
    assume $IsAlloc(##y#0_0, TInt, $Heap);
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0_0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} GeneralInternals.__default.IsLe(LitInt(0), i#0_0);
    goto anon9;

  anon25_Else:
    assume {:partition} !GeneralInternals.__default.IsLe(LitInt(0), i#0_0);
    goto anon9;

  anon9:
    assume GeneralInternals.__default.IsLe#canCall(LitInt(0), i#0_0);
    assume GeneralInternals.__default.IsLe(LitInt(0), i#0_0) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0))): bool;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume true;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0 + 1))): bool;
    assume false;
    goto anon11;

  anon26_Else:
    goto anon11;

  anon11:
    push;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume false;
    goto anon16;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    ##b#0_0_2_0 := b#0;
    assume $IsAlloc(##b#0_0_2_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_2_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    push;
    push;
    assume true;
    b##0_0_2_0 := b#0;
    assume true;
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    e##0_0_2_0 := e1#0 + i#0_0;
    call CallPre$$Power.__default.LemmaPowPositive(b##0_0_2_0, e##0_0_2_0);
    call CallPost$$Power.__default.LemmaPowPositive(b##0_0_2_0, e##0_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(432,38)"} true;
    ##b#0_0_2_1 := b#0;
    assume $IsAlloc(##b#0_0_2_1, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_2_1 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    x##0_0_2_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0);
    assume true;
    y##0_0_2_0 := LitInt(1);
    assume true;
    z##0_0_2_0 := b#0;
    call CallPre$$Mul.__default.LemmaMulLeftInequality(x##0_0_2_0, y##0_0_2_0, z##0_0_2_0);
    call CallPost$$Mul.__default.LemmaMulLeftInequality(x##0_0_2_0, y##0_0_2_0, z##0_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(433,55)"} true;
    pop;
    pop;
    ##b#0_0_2_2 := b#0;
    assume $IsAlloc(##b#0_0_2_2, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_2_2 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0) <= Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), b#0);
    assume false;
    goto anon16;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    ##b#0_0_1_0 := b#0;
    assume $IsAlloc(##b#0_0_1_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_1_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    push;
    push;
    assume true;
    b##0_0_1_0 := b#0;
    call CallPre$$Power.__default.LemmaPow1(b##0_0_1_0);
    call CallPost$$Power.__default.LemmaPow1(b##0_0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(435,23)"} true;
    pop;
    pop;
    ##b#0_0_1_1 := b#0;
    assume $IsAlloc(##b#0_0_1_1, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_1_1 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    ##b#0_0_1_2 := b#0;
    assume $IsAlloc(##b#0_0_1_2, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_0_1_2 := LitInt(1);
    assume $IsAlloc(##e#0_0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0) && Power.__default.Pow#canCall(b#0, LitInt(1));
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), b#0) == Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1)));
    assume false;
    goto anon16;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    ##b#0_0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0_0, TInt, $Heap);
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    ##e#0_0_0_0 := e1#0 + i#0_0;
    assume $IsAlloc(##e#0_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0);
    ##b#0_0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_0_1, TInt, $Heap);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##e#0_0_0_1 := LitInt(1);
    assume $IsAlloc(##e#0_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, LitInt(1));
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0) && Power.__default.Pow#canCall(b#0, LitInt(1));
    push;
    push;
    assume true;
    b##0_0_0_0 := b#0;
    assume true;
    assume $Is(e1#0 + i#0_0, Tclass._System.nat());
    e1##0_0_0_0 := e1#0 + i#0_0;
    assume true;
    assume $Is(LitInt(1), Tclass._System.nat());
    e2##0_0_0_0 := LitInt(1);
    call CallPre$$Power.__default.LemmaPowAdds(b##0_0_0_0, e1##0_0_0_0, e2##0_0_0_0);
    call CallPost$$Power.__default.LemmaPowAdds(b##0_0_0_0, e1##0_0_0_0, e2##0_0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(437,37)"} true;
    pop;
    pop;
    ##b#0_0_0_2 := b#0;
    assume $IsAlloc(##b#0_0_0_2, TInt, $Heap);
    assume $Is(e1#0 + i#0_0 + 1, Tclass._System.nat());
    ##e#0_0_0_2 := e1#0 + i#0_0 + 1;
    assume $IsAlloc(##e#0_0_0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume Power.__default.Pow#canCall(b#0, e1#0 + i#0_0 + 1);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, LitInt(1))) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + i#0_0 + 1);
    assume false;
    goto anon16;

  anon30_Else:
    goto anon16;

  anon16:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + i#0_0 + 1);
    pop;
    assume $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_0 + 1))): bool;
    assume false;
    goto anon18;

  anon24_Else:
    assume (forall i#0_1: int :: { GeneralInternals.__default.IsLe(0, i#0_1) } GeneralInternals.__default.IsLe(LitInt(0), i#0_1) && $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1))): bool ==> $Unbox(Apply1(TInt, TBool, $Heap, f#0, $Box(i#0_1 + 1))): bool);
    goto anon18;

  anon18:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(440,4)"} true;
    assume true;
    x##0 := e2#0 - e1#0;
    assume true;
    f##0 := f#0;
    call CallPre$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    call CallPost$$MulInternals.__default.LemmaMulInductionAuto(x##0, f##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(441,37)"} true;
    ##b#4 := b#0;
    assume $IsAlloc(##b#4, TInt, $Heap);
    ##e#4 := e1#0;
    assume $IsAlloc(##e#4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    ##b#5 := b#0;
    assume $IsAlloc(##b#5, TInt, $Heap);
    assume $Is(e1#0 + e2#0 - e1#0, Tclass._System.nat());
    ##e#5 := e1#0 + e2#0 - e1#0;
    assume $IsAlloc(##e#5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 + e2#0 - e1#0);
    assume Power.__default.Pow#canCall(b#0, e1#0) && Power.__default.Pow#canCall(b#0, e1#0 + e2#0 - e1#0);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume true;
    assume LitInt(0) <= e2#0 - e1#0;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(443,25)"} true;
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0);
    assume false;
    goto anon20;

  anon31_Else:
    goto anon20;

  anon20:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 + e2#0 - e1#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(444,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowIncreasesAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowIncreasesAuto();
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowIncreasesAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowIncreasesAuto();



procedure {:verboseName "Power.LemmaPowIncreasesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreasesAuto();
  modifies $Heap;
  free ensures (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 ==> e1#1 <= e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14489"} (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 && e1#1 <= e2#1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowIncreasesAuto (correctness)"} Impl$$Power.__default.LemmaPowIncreasesAuto() returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 ==> e1#1 <= e2#1 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14490"} (forall e2#1: int, e1#1: int, b#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= e2#1 && LitInt(0) <= e1#1 && LitInt(0) <= b#1 ==> 1 < b#1 && e1#1 <= e2#1 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowIncreasesAuto (correctness)"} Impl$$Power.__default.LemmaPowIncreasesAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreasesAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(450,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(451,15)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 1 < b#0_0;
    goto anon3;

  anon9_Else:
    assume {:partition} b#0_0 <= 1;
    goto anon3;

  anon3:
    assume true;
    assume 1 < b#0_0 && e1#0_0 <= e2#0_0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e1#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e2#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0) && Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowIncreases(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowIncreases(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(456,34)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && 1 < b#0_1 && e1#0_1 <= e2#0_1 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(457,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverse (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverse (call precondtion)"} CallPre$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14501"} b#0 > 0;
  requires {:id "id14502"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverse (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14503"} e1#0 < e2#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverse (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  requires {:id "id14504"} b#0 > 0;
  requires {:id "id14505"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14506"} e1#0 < e2#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowStrictlyIncreasesConverse (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreasesConverse", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(466,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && $ih#b0#0 > 0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0) && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#e10#0 && $ih#e10#0 < e1#0) || ($ih#e10#0 == e1#0 && 0 <= $ih#e20#0 && $ih#e20#0 < e2#0)))) ==> $ih#e10#0 < $ih#e20#0);
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} e1#0 >= e2#0;
    assume true;
    b##0_0 := b#0;
    assume true;
    e1##0_0 := e2#0;
    assume true;
    e2##0_0 := e1#0;
    call CallPre$$Power.__default.LemmaPowIncreases(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowIncreases(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(468,34)"} true;
    assume true;
    assume Lit(false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(469,18)"} true;
    return;

  anon3_Else:
    assume {:partition} e2#0 > e1#0;
    return;
}



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverseAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto();
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverseAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto();



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverseAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14515"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> b#1 > 0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) ==> e1#1 < e2#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowStrictlyIncreasesConverseAuto (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto() returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14516"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> b#1 > 0 && Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) ==> e1#1 < e2#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowStrictlyIncreasesConverseAuto (correctness)"} Impl$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreasesConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(477,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(478,15)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} b#0_0 > 0;
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e1#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e2#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    goto anon3;

  anon9_Else:
    assume {:partition} 0 >= b#0_0;
    goto anon3;

  anon3:
    assume b#0_0 > 0 ==> Power.__default.Pow#canCall(b#0_0, e1#0_0) && Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume b#0_0 > 0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume e1#0_0 < e2#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowStrictlyIncreasesConverse(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowStrictlyIncreasesConverse(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(483,50)"} true;
    assume e1#0_0 < e2#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && b#0_1 > 0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1) ==> e1#0_1 < e2#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(484,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowIncreasesConverse (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowIncreasesConverse (call precondtion)"} CallPre$$Power.__default.LemmaPowIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14527"} 1 < b#0;
  requires {:id "id14528"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);



procedure {:verboseName "Power.LemmaPowIncreasesConverse (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14529"} e1#0 <= e2#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowIncreasesConverse (correctness)"} Impl$$Power.__default.LemmaPowIncreasesConverse(b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  requires {:id "id14530"} 1 < b#0;
  requires {:id "id14531"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14532"} e1#0 <= e2#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowIncreasesConverse (correctness)"} Impl$$Power.__default.LemmaPowIncreasesConverse(b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreasesConverse", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(492,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && 1 < $ih#b0#0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0) && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#e10#0 && $ih#e10#0 < e1#0) || ($ih#e10#0 == e1#0 && 0 <= $ih#e20#0 && $ih#e20#0 < e2#0)))) ==> $ih#e10#0 <= $ih#e20#0);
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} e1#0 > e2#0;
    assume true;
    b##0_0 := b#0;
    assume true;
    e1##0_0 := e2#0;
    assume true;
    e2##0_0 := e1#0;
    call CallPre$$Power.__default.LemmaPowStrictlyIncreases(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowStrictlyIncreases(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(494,42)"} true;
    assume true;
    assume Lit(false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(495,18)"} true;
    return;

  anon3_Else:
    assume {:partition} e2#0 >= e1#0;
    return;
}



procedure {:verboseName "Power.LemmaPowIncreasesConverseAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowIncreasesConverseAuto();
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.LemmaPowIncreasesConverseAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowIncreasesConverseAuto();



procedure {:verboseName "Power.LemmaPowIncreasesConverseAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreasesConverseAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> 1 < b#1 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14541"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> 1 < b#1 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) ==> e1#1 <= e2#1);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowIncreasesConverseAuto (correctness)"} Impl$$Power.__default.LemmaPowIncreasesConverseAuto() returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> 1 < b#1 ==> Power.__default.Pow#canCall(b#1, e1#1) && Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14542"} (forall b#1: int, e1#1: int, e2#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e1#1 && LitInt(0) <= e2#1 ==> 1 < b#1 && Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e1#1) <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) ==> e1#1 <= e2#1);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowIncreasesConverseAuto (correctness)"} Impl$$Power.__default.LemmaPowIncreasesConverseAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreasesConverseAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(503,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(504,15)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 1 < b#0_0;
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e1#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e2#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    goto anon3;

  anon9_Else:
    assume {:partition} b#0_0 <= 1;
    goto anon3;

  anon3:
    assume 1 < b#0_0 ==> Power.__default.Pow#canCall(b#0_0, e1#0_0) && Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume 1 < b#0_0 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume true;
    assume e1#0_0 <= e2#0_0;
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowIncreasesConverse(b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowIncreasesConverse(b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(509,42)"} true;
    assume e1#0_0 <= e2#0_0;
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall b#0_1: int, e1#0_1: int, e2#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && 1 < b#0_1 && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1) ==> e1#0_1 <= e2#0_1);
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(510,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPullOutPows (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPullOutPows(b#0: int where LitInt(0) <= b#0, x#0: int where LitInt(0) <= x#0, y#0: int where LitInt(0) <= y#0, z#0: int where LitInt(0) <= z#0);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPullOutPows (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPullOutPows(b#0: int, x#0: int, y#0: int, z#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPullOutPows", " | ", b#0, " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(514,8): initial state"} true;
    assume b#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(516,14): post-state"} true;
    assume LitInt(0) <= Mul(x#0, y#0);
    assume LitInt(0) <= Mul(y#0, z#0);
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(Mul(x#0, y#0), Tclass._System.nat());
    ##e#0 := Mul(x#0, y#0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, Mul(x#0, y#0));
    ##b#1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0));
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := z#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := x#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, x#0);
    ##b#3 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0);
    assume $IsAlloc(##b#3, TInt, $Heap);
    assume $Is(Mul(y#0, z#0), Tclass._System.nat());
    ##e#3 := Mul(y#0, z#0);
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
    return;
}



procedure {:verboseName "Power.LemmaPullOutPows (call precondtion)"} CallPre$$Power.__default.LemmaPullOutPows(b#0: int where LitInt(0) <= b#0, x#0: int where LitInt(0) <= x#0, y#0: int where LitInt(0) <= y#0, z#0: int where LitInt(0) <= z#0);
  requires {:id "id14556"} b#0 > 0;



procedure {:verboseName "Power.LemmaPullOutPows (call postcondition)"} CallPost$$Power.__default.LemmaPullOutPows(b#0: int where LitInt(0) <= b#0, x#0: int where LitInt(0) <= x#0, y#0: int where LitInt(0) <= y#0, z#0: int where LitInt(0) <= z#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14557"} LitInt(0) <= Mul(x#0, y#0);
  free ensures true;
  free ensures {:id "id14558"} LitInt(0) <= Mul(y#0, z#0);
  free ensures Power.__default.Pow#canCall(b#0, Mul(x#0, y#0)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) && Power.__default.Pow#canCall(b#0, x#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
  free ensures {:id "id14559"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPullOutPows (correctness)"} Impl$$Power.__default.LemmaPullOutPows(b#0: int where LitInt(0) <= b#0, x#0: int where LitInt(0) <= x#0, y#0: int where LitInt(0) <= y#0, z#0: int where LitInt(0) <= z#0) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id14560"} b#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14561"} LitInt(0) <= Mul(x#0, y#0);
  free ensures true;
  free ensures {:id "id14562"} LitInt(0) <= Mul(y#0, z#0);
  free ensures Power.__default.Pow#canCall(b#0, Mul(x#0, y#0)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) && Power.__default.Pow#canCall(b#0, x#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
  free ensures {:id "id14563"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPullOutPows (correctness)"} Impl$$Power.__default.LemmaPullOutPows(b#0: int, x#0: int, y#0: int, z#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var x##0: int;
  var y##0: int;
  var x##1: int;
  var y##1: int;
  var b##0: int;
  var e##0: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var ##b#0_0_1: int;
  var ##e#0_0_1: int;
  var ##b#0_0_2: int;
  var ##e#0_0_2: int;
  var a##0_0_0: int;
  var ##b#0_0_3: int;
  var ##e#0_0_3: int;
  var b##0_0_0: int;
  var c##0_0_0: int;
  var ##b#0_0_4: int;
  var ##e#0_0_4: int;
  var ##b#0_0_5: int;
  var ##e#0_0_5: int;
  var ##b#0_1_0: int;
  var ##e#0_1_0: int;
  var ##b#0_1_1: int;
  var ##e#0_1_1: int;
  var a##0_1_0: int;
  var b##0_1_0: int;
  var c##0_1_0: int;
  var ##b#0_1_2: int;
  var ##e#0_1_2: int;
  var ##b#0_1_3: int;
  var ##e#0_1_3: int;
  var ##b#0_1_4: int;
  var ##e#0_1_4: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPullOutPows", " | ", b#0, " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(519,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#x0#0: int, $ih#y0#0: int, $ih#z0#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#x0#0 && LitInt(0) <= $ih#y0#0 && LitInt(0) <= $ih#z0#0 && $ih#b0#0 > 0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#x0#0 && $ih#x0#0 < x#0) || ($ih#x0#0 == x#0 && ((0 <= $ih#y0#0 && $ih#y0#0 < y#0) || ($ih#y0#0 == y#0 && 0 <= $ih#z0#0 && $ih#z0#0 < z#0)))))) ==> LitInt(0) <= Mul($ih#x0#0, $ih#y0#0) && LitInt(0) <= Mul($ih#y0#0, $ih#z0#0) && Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, Mul($ih#x0#0, $ih#y0#0)), $ih#z0#0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#x0#0), Mul($ih#y0#0, $ih#z0#0)));
    $_reverifyPost := false;
    assume true;
    x##0 := x#0;
    assume true;
    y##0 := y#0;
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##0, y##0);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##0, y##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(520,29)"} true;
    assume true;
    x##1 := y#0;
    assume true;
    y##1 := z#0;
    call CallPre$$Mul.__default.LemmaMulNonnegative(x##1, y##1);
    call CallPost$$Mul.__default.LemmaMulNonnegative(x##1, y##1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(521,29)"} true;
    assume true;
    b##0 := b#0;
    assume true;
    e##0 := x#0;
    call CallPre$$Power.__default.LemmaPowPositive(b##0, e##0);
    call CallPost$$Power.__default.LemmaPowPositive(b##0, e##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(522,26)"} true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(Mul(x#0, y#0), Tclass._System.nat());
    ##e#0_0 := Mul(x#0, y#0);
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, Mul(x#0, y#0));
    ##b#0_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0));
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := z#0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0);
    assume Power.__default.Pow#canCall(b#0, Mul(x#0, y#0)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0);
    assume false;
    goto anon4;

  anon5_Else:
    goto anon6_Then, anon6_Else;

  anon6_Then:
    ##b#0_1_0 := b#0;
    assume $IsAlloc(##b#0_1_0, TInt, $Heap);
    assume $Is(Mul(x#0, y#0), Tclass._System.nat());
    ##e#0_1_0 := Mul(x#0, y#0);
    assume $IsAlloc(##e#0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, Mul(x#0, y#0));
    ##b#0_1_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0));
    assume $IsAlloc(##b#0_1_1, TInt, $Heap);
    ##e#0_1_1 := z#0;
    assume $IsAlloc(##e#0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0);
    assume Power.__default.Pow#canCall(b#0, Mul(x#0, y#0)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0);
    assume true;
    a##0_1_0 := b#0;
    assume true;
    b##0_1_0 := x#0;
    assume true;
    c##0_1_0 := y#0;
    call CallPre$$Power.__default.LemmaPowMultiplies(a##0_1_0, b##0_1_0, c##0_1_0);
    call CallPost$$Power.__default.LemmaPowMultiplies(a##0_1_0, b##0_1_0, c##0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(525,35)"} true;
    ##b#0_1_2 := b#0;
    assume $IsAlloc(##b#0_1_2, TInt, $Heap);
    ##e#0_1_2 := x#0;
    assume $IsAlloc(##e#0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, x#0);
    ##b#0_1_3 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0);
    assume $IsAlloc(##b#0_1_3, TInt, $Heap);
    ##e#0_1_3 := y#0;
    assume $IsAlloc(##e#0_1_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0);
    ##b#0_1_4 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0);
    assume $IsAlloc(##b#0_1_4, TInt, $Heap);
    ##e#0_1_4 := z#0;
    assume $IsAlloc(##e#0_1_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0), z#0);
    assume Power.__default.Pow#canCall(b#0, x#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0), z#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, x#0), y#0), z#0);
    assume false;
    goto anon4;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    ##e#0_0_0 := x#0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, x#0);
    ##b#0_0_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0);
    assume $IsAlloc(##b#0_0_1, TInt, $Heap);
    ##e#0_0_1 := y#0;
    assume $IsAlloc(##e#0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0);
    ##b#0_0_2 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0);
    assume $IsAlloc(##b#0_0_2, TInt, $Heap);
    ##e#0_0_2 := z#0;
    assume $IsAlloc(##e#0_0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0), z#0);
    assume Power.__default.Pow#canCall(b#0, x#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), y#0), z#0);
    ##b#0_0_3 := b#0;
    assume $IsAlloc(##b#0_0_3, TInt, $Heap);
    ##e#0_0_3 := x#0;
    assume $IsAlloc(##e#0_0_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, x#0);
    assume Power.__default.Pow#canCall(b#0, x#0);
    a##0_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0);
    assume true;
    b##0_0_0 := y#0;
    assume true;
    c##0_0_0 := z#0;
    call CallPre$$Power.__default.LemmaPowMultiplies(a##0_0_0, b##0_0_0, c##0_0_0);
    call CallPost$$Power.__default.LemmaPowMultiplies(a##0_0_0, b##0_0_0, c##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(527,43)"} true;
    ##b#0_0_4 := b#0;
    assume $IsAlloc(##b#0_0_4, TInt, $Heap);
    ##e#0_0_4 := x#0;
    assume $IsAlloc(##e#0_0_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, x#0);
    ##b#0_0_5 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0);
    assume $IsAlloc(##b#0_0_5, TInt, $Heap);
    assume $Is(Mul(y#0, z#0), Tclass._System.nat());
    ##e#0_0_5 := Mul(y#0, z#0);
    assume $IsAlloc(##e#0_0_5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
    assume Power.__default.Pow#canCall(b#0, x#0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, x#0), y#0), z#0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
    assume false;
    goto anon4;

  anon7_Else:
    goto anon4;

  anon4:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#0)), z#0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#0, z#0));
    return;
}



procedure {:verboseName "Power.LemmaPullOutPowsAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPullOutPowsAuto();
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPullOutPowsAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPullOutPowsAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var y#0: int;
  var z#0: int;
  var b#0: int;
  var x#0: int;
  var y#2: int;
  var z#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPullOutPowsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(532,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(533,12): post-state"} true;
    havoc y#0;
    havoc z#0;
    assume LitInt(0) <= y#0 && LitInt(0) <= z#0;
    assume LitInt(0) <= Mul(z#0, y#0);
    assume LitInt(0) <= Mul(y#0, z#0);
    assume (forall y#1: int, z#1: int :: { Mul(z#1, y#1) } LitInt(0) <= y#1 && LitInt(0) <= z#1 ==> LitInt(0) <= Mul(z#1, y#1) && LitInt(0) <= Mul(y#1, z#1));
    havoc b#0;
    havoc x#0;
    havoc y#2;
    havoc z#2;
    assume LitInt(0) <= b#0 && LitInt(0) <= x#0 && LitInt(0) <= y#2 && LitInt(0) <= z#2;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume b#0 > 0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(Mul(x#0, y#2), Tclass._System.nat());
    ##e#0 := Mul(x#0, y#2);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, Mul(x#0, y#2));
    ##b#1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#2));
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := z#2;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#2)), z#2);
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := x#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, x#0);
    ##b#3 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0);
    assume $IsAlloc(##b#3, TInt, $Heap);
    assume $Is(Mul(y#2, z#2), Tclass._System.nat());
    ##e#3 := Mul(y#2, z#2);
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#2, z#2));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#2)), z#2) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#2, z#2));
    goto anon4;

  anon5_Else:
    assume b#0 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, Mul(x#0, y#2)), z#2) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, x#0), Mul(y#2, z#2));
    goto anon4;

  anon4:
    assume (forall b#1: int, x#1: int, y#3: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) } LitInt(0) <= b#1 && LitInt(0) <= x#1 && LitInt(0) <= y#3 && LitInt(0) <= z#3 ==> b#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, x#1), Mul(y#3, z#3)));
    return;
}



procedure {:verboseName "Power.LemmaPullOutPowsAuto (call precondtion)"} CallPre$$Power.__default.LemmaPullOutPowsAuto();



procedure {:verboseName "Power.LemmaPullOutPowsAuto (call postcondition)"} CallPost$$Power.__default.LemmaPullOutPowsAuto();
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14589"} (forall y#1: int, z#1: int :: { Mul(z#1, y#1) } LitInt(0) <= y#1 && LitInt(0) <= z#1 ==> LitInt(0) <= Mul(z#1, y#1) && LitInt(0) <= Mul(y#1, z#1));
  free ensures (forall b#1: int, x#1: int, y#3: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) } LitInt(0) <= b#1 && LitInt(0) <= x#1 && LitInt(0) <= y#3 && LitInt(0) <= z#3 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, Mul(x#1, y#3)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) && Power.__default.Pow#canCall(b#1, x#1) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, x#1), Mul(y#3, z#3)));
  free ensures {:id "id14590"} (forall b#1: int, x#1: int, y#3: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) } LitInt(0) <= b#1 && LitInt(0) <= x#1 && LitInt(0) <= y#3 && LitInt(0) <= z#3 ==> b#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, x#1), Mul(y#3, z#3)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPullOutPowsAuto (correctness)"} Impl$$Power.__default.LemmaPullOutPowsAuto() returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14591"} (forall y#1: int, z#1: int :: { Mul(z#1, y#1) } LitInt(0) <= y#1 && LitInt(0) <= z#1 ==> LitInt(0) <= Mul(z#1, y#1) && LitInt(0) <= Mul(y#1, z#1));
  free ensures (forall b#1: int, x#1: int, y#3: int, z#3: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) } LitInt(0) <= b#1 && LitInt(0) <= x#1 && LitInt(0) <= y#3 && LitInt(0) <= z#3 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, Mul(x#1, y#3)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) && Power.__default.Pow#canCall(b#1, x#1) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, x#1), Mul(y#3, z#3)));
  free ensures {:id "id14592"} (forall b#1: int, x#1: int, y#3: int, z#3: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) } LitInt(0) <= b#1 && LitInt(0) <= x#1 && LitInt(0) <= y#3 && LitInt(0) <= z#3 ==> b#1 > 0 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, Mul(x#1, y#3)), z#3) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, x#1), Mul(y#3, z#3)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPullOutPowsAuto (correctness)"} Impl$$Power.__default.LemmaPullOutPowsAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var x#0_0: int;
  var y#0_0: int;
  var z#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_2: int;
  var ##e#0_2: int;
  var ##b#0_3: int;
  var ##e#0_3: int;
  var b##0_0: int;
  var x##0_0: int;
  var y##0_0: int;
  var z##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPullOutPowsAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(537,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(538,15)"} true;
    call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(539,29)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0, x#0_0, y#0_0, z#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= x#0_0 && LitInt(0) <= y#0_0 && LitInt(0) <= z#0_0;
    assume true;
    assume b#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    assume $Is(Mul(x#0_0, y#0_0), Tclass._System.nat());
    ##e#0_0 := Mul(x#0_0, y#0_0);
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, Mul(x#0_0, y#0_0));
    ##b#0_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, Mul(x#0_0, y#0_0));
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := z#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, Mul(x#0_0, y#0_0)), z#0_0);
    ##b#0_2 := b#0_0;
    assume $IsAlloc(##b#0_2, TInt, $Heap);
    ##e#0_2 := x#0_0;
    assume $IsAlloc(##e#0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, x#0_0);
    ##b#0_3 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, x#0_0);
    assume $IsAlloc(##b#0_3, TInt, $Heap);
    assume $Is(Mul(y#0_0, z#0_0), Tclass._System.nat());
    ##e#0_3 := Mul(y#0_0, z#0_0);
    assume $IsAlloc(##e#0_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, x#0_0), Mul(y#0_0, z#0_0));
    assume Power.__default.Pow#canCall(b#0_0, Mul(x#0_0, y#0_0)) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, Mul(x#0_0, y#0_0)), z#0_0) && Power.__default.Pow#canCall(b#0_0, x#0_0) && Power.__default.Pow#canCall(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, x#0_0), Mul(y#0_0, z#0_0));
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, Mul(x#0_0, y#0_0)), z#0_0) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, x#0_0), Mul(y#0_0, z#0_0));
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    x##0_0 := x#0_0;
    assume true;
    y##0_0 := y#0_0;
    assume true;
    z##0_0 := z#0_0;
    call CallPre$$Power.__default.LemmaPullOutPows(b##0_0, x##0_0, y##0_0, z##0_0);
    call CallPost$$Power.__default.LemmaPullOutPows(b##0_0, x##0_0, y##0_0, z##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(543,34)"} true;
    assume Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, Mul(x#0_0, y#0_0)), z#0_0) == Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, x#0_0), Mul(y#0_0, z#0_0));
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int, x#0_1: int, y#0_1: int, z#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, Mul(x#0_1, y#0_1)), z#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= x#0_1 && LitInt(0) <= y#0_1 && LitInt(0) <= z#0_1 && b#0_1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, Mul(x#0_1, y#0_1)), z#0_1) == Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, x#0_1), Mul(y#0_1, z#0_1)));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(544,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowDivisionInequality (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowDivisionInequality(x#0: int where LitInt(0) <= x#0, b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowDivisionInequality (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowDivisionInequality(x#0: int, b#0: int, e1#0: int, e2#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowDivisionInequality", " | ", x#0, " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(548,8): initial state"} true;
    assume b#0 > 0;
    assume e2#0 <= e1#0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e1#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume x#0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(552,23): post-state"} true;
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e2#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) > 0;
    ##b#2 := b#0;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e2#0;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#3 := b#0;
    assume $IsAlloc(##b#3, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#3 := e1#0 - e2#0;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    assume Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0);
    return;
}



procedure {:verboseName "Power.LemmaPowDivisionInequality (call precondtion)"} CallPre$$Power.__default.LemmaPowDivisionInequality(x#0: int where LitInt(0) <= x#0, b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  requires {:id "id14611"} b#0 > 0;
  requires {:id "id14612"} e2#0 <= e1#0;
  requires {:id "id14613"} x#0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0);



procedure {:verboseName "Power.LemmaPowDivisionInequality (call postcondition)"} CallPost$$Power.__default.LemmaPowDivisionInequality(x#0: int where LitInt(0) <= x#0, b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14614"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0) > 0;
  free ensures Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
  free ensures {:id "id14615"} Div(x#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - e2#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowDivisionInequality (correctness)"} Impl$$Power.__default.LemmaPowDivisionInequality(x#0: int where LitInt(0) <= x#0, b#0: int where LitInt(0) <= b#0, e1#0: int where LitInt(0) <= e1#0, e2#0: int where LitInt(0) <= e2#0) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id14616"} b#0 > 0;
  requires {:id "id14617"} e2#0 <= e1#0;
  requires {:id "id14618"} x#0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e2#0);
  free ensures {:id "id14619"} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0) > 0;
  free ensures Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
  free ensures {:id "id14620"} Div(x#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - e2#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowDivisionInequality (correctness)"} Impl$$Power.__default.LemmaPowDivisionInequality(x#0: int, b#0: int, e1#0: int, e2#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var ##b#0_1_0: int;
  var ##e#0_1_0: int;
  var ##b#0_1_1: int;
  var ##e#0_1_1: int;
  var ##b#0_1_2: int;
  var ##e#0_1_2: int;
  var ##b#0_2_0: int;
  var ##e#0_2_0: int;
  var ##b#0_2_1: int;
  var ##e#0_2_1: int;
  var ##b#0_2_2: int;
  var ##e#0_2_2: int;
  var b##0_2_0: int;
  var e1##0_2_0: int;
  var e2##0_2_0: int;
  var ##b#0_2_3: int;
  var ##e#0_2_3: int;
  var ##b#0_2_4: int;
  var ##e#0_2_4: int;
  var ##b#0_3_0: int;
  var ##e#0_3_0: int;
  var ##b#0_3_1: int;
  var ##e#0_3_1: int;
  var ##b#0_3_2: int;
  var ##e#0_3_2: int;
  var ##b#0_3_3: int;
  var ##e#0_3_3: int;
  var x##0_3_0: int;
  var d##0_3_0: int;
  var ##b#0_3_4: int;
  var ##e#0_3_4: int;
  var ##b#0_3_5: int;
  var ##e#0_3_5: int;
  var ##b#0_3_6: int;
  var ##e#0_3_6: int;
  var ##b#0_3_7: int;
  var ##e#0_3_7: int;
  var ##b#0_4_0: int;
  var ##e#0_4_0: int;
  var ##b#0_4_1: int;
  var ##e#0_4_1: int;
  var x##0_4_0: int;
  var ##b#0_4_2: int;
  var ##e#0_4_2: int;
  var y##0_4_0: int;
  var ##b#0_4_3: int;
  var ##e#0_4_3: int;
  var z##0_4_0: int;
  var ##b#0_4_4: int;
  var ##e#0_4_4: int;
  var ##b#0_4_5: int;
  var ##e#0_4_5: int;
  var ##b#0_4_6: int;
  var ##e#0_4_6: int;
  var ##b#0_4_7: int;
  var ##e#0_4_7: int;
  var ##b#0_4_8: int;
  var ##e#0_4_8: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowDivisionInequality", " | ", x#0, " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(554,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e10#0: int, $ih#e20#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e10#0 && LitInt(0) <= $ih#e20#0 && $ih#b0#0 > 0 && $ih#e20#0 <= $ih#e10#0 && x#0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0) && ((0 <= x#0 && x#0 < x#0) || (x#0 == x#0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && ((0 <= $ih#e10#0 && $ih#e10#0 < e1#0) || ($ih#e10#0 == e1#0 && 0 <= $ih#e20#0 && $ih#e20#0 < e2#0)))))) ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0) > 0 && Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e20#0)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e10#0 - $ih#e20#0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.LemmaPowPositiveAuto();
    call CallPost$$Power.__default.LemmaPowPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(555,26)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e2#0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_1 := b#0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_1 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    assume false;
    goto anon7;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##b#0_4_0 := b#0;
    assume $IsAlloc(##b#0_4_0, TInt, $Heap);
    ##e#0_4_0 := e2#0;
    assume $IsAlloc(##e#0_4_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_4_1 := b#0;
    assume $IsAlloc(##b#0_4_1, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_4_1 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_4_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    assume Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0);
    ##b#0_4_2 := b#0;
    assume $IsAlloc(##b#0_4_2, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_4_2 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_4_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    x##0_4_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0);
    ##b#0_4_3 := b#0;
    assume $IsAlloc(##b#0_4_3, TInt, $Heap);
    ##e#0_4_3 := e2#0;
    assume $IsAlloc(##e#0_4_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    assume Power.__default.Pow#canCall(b#0, e2#0);
    y##0_4_0 := Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0));
    ##b#0_4_4 := b#0;
    assume $IsAlloc(##b#0_4_4, TInt, $Heap);
    ##e#0_4_4 := e2#0;
    assume $IsAlloc(##e#0_4_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    z##0_4_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0);
    call CallPre$$Mul.__default.LemmaMulInequality(x##0_4_0, y##0_4_0, z##0_4_0);
    call CallPost$$Mul.__default.LemmaMulInequality(x##0_4_0, y##0_4_0, z##0_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(558,71)"} true;
    ##b#0_4_5 := b#0;
    assume $IsAlloc(##b#0_4_5, TInt, $Heap);
    ##e#0_4_5 := e2#0;
    assume $IsAlloc(##e#0_4_5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_4_6 := b#0;
    assume $IsAlloc(##b#0_4_6, TInt, $Heap);
    ##e#0_4_6 := e2#0;
    assume $IsAlloc(##e#0_4_6, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#0_4_7 := b#0;
    assume $IsAlloc(##b#0_4_7, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_4_7 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_4_7, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    ##b#0_4_8 := b#0;
    assume $IsAlloc(##b#0_4_8, TInt, $Heap);
    ##e#0_4_8 := e2#0;
    assume $IsAlloc(##e#0_4_8, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0) ==> Mul(Div(x#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) >= Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0));
    assume false;
    goto anon7;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##b#0_3_0 := b#0;
    assume $IsAlloc(##b#0_3_0, TInt, $Heap);
    ##e#0_3_0 := e2#0;
    assume $IsAlloc(##e#0_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_3_1 := b#0;
    assume $IsAlloc(##b#0_3_1, TInt, $Heap);
    ##e#0_3_1 := e2#0;
    assume $IsAlloc(##e#0_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    ##b#0_3_2 := b#0;
    assume $IsAlloc(##b#0_3_2, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_3_2 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_3_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    ##b#0_3_3 := b#0;
    assume $IsAlloc(##b#0_3_3, TInt, $Heap);
    ##e#0_3_3 := e2#0;
    assume $IsAlloc(##e#0_3_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume Mul(Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0));
    assume true;
    x##0_3_0 := x#0;
    ##b#0_3_4 := b#0;
    assume $IsAlloc(##b#0_3_4, TInt, $Heap);
    ##e#0_3_4 := e2#0;
    assume $IsAlloc(##e#0_3_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    d##0_3_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0);
    call CallPre$$DivMod.__default.LemmaFundamentalDivMod(x##0_3_0, d##0_3_0);
    call CallPost$$DivMod.__default.LemmaFundamentalDivMod(x##0_3_0, d##0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(560,45)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(561,35)"} true;
    ##b#0_3_5 := b#0;
    assume $IsAlloc(##b#0_3_5, TInt, $Heap);
    ##e#0_3_5 := e2#0;
    assume $IsAlloc(##e#0_3_5, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_3_6 := b#0;
    assume $IsAlloc(##b#0_3_6, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_3_6 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_3_6, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    ##b#0_3_7 := b#0;
    assume $IsAlloc(##b#0_3_7, TInt, $Heap);
    ##e#0_3_7 := e2#0;
    assume $IsAlloc(##e#0_3_7, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Mul(Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) ==> x#0 - Mod(x#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) >= Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0));
    assume false;
    goto anon7;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##b#0_2_0 := b#0;
    assume $IsAlloc(##b#0_2_0, TInt, $Heap);
    ##e#0_2_0 := e2#0;
    assume $IsAlloc(##e#0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_2_1 := b#0;
    assume $IsAlloc(##b#0_2_1, TInt, $Heap);
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    ##e#0_2_1 := e1#0 - e2#0;
    assume $IsAlloc(##e#0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0 - e2#0);
    ##b#0_2_2 := b#0;
    assume $IsAlloc(##b#0_2_2, TInt, $Heap);
    ##e#0_2_2 := e2#0;
    assume $IsAlloc(##e#0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0 - e2#0) && Power.__default.Pow#canCall(b#0, e2#0);
    assume x#0 - Mod(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0));
    assume true;
    b##0_2_0 := b#0;
    assume true;
    assume $Is(e1#0 - e2#0, Tclass._System.nat());
    e1##0_2_0 := e1#0 - e2#0;
    assume true;
    e2##0_2_0 := e2#0;
    call CallPre$$Power.__default.LemmaPowAdds(b##0_2_0, e1##0_2_0, e2##0_2_0);
    call CallPost$$Power.__default.LemmaPowAdds(b##0_2_0, e1##0_2_0, e2##0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(563,36)"} true;
    ##b#0_2_3 := b#0;
    assume $IsAlloc(##b#0_2_3, TInt, $Heap);
    ##e#0_2_3 := e2#0;
    assume $IsAlloc(##e#0_2_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_2_4 := b#0;
    assume $IsAlloc(##b#0_2_4, TInt, $Heap);
    ##e#0_2_4 := e1#0;
    assume $IsAlloc(##e#0_2_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} x#0 - Mod(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Mul(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) ==> x#0 - Mod(x#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e2#0)) >= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0);
    assume false;
    goto anon7;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##b#0_1_0 := b#0;
    assume $IsAlloc(##b#0_1_0, TInt, $Heap);
    ##e#0_1_0 := e2#0;
    assume $IsAlloc(##e#0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) != 0;
    ##b#0_1_1 := b#0;
    assume $IsAlloc(##b#0_1_1, TInt, $Heap);
    ##e#0_1_1 := e1#0;
    assume $IsAlloc(##e#0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow#canCall(b#0, e2#0) && Power.__default.Pow#canCall(b#0, e1#0);
    assume x#0 - Mod(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(565,32)"} true;
    ##b#0_1_2 := b#0;
    assume $IsAlloc(##b#0_1_2, TInt, $Heap);
    ##e#0_1_2 := e1#0;
    assume $IsAlloc(##e#0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume {:subsumption 0} x#0 - Mod(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) ==> x#0 >= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e1#0);
    assume false;
    goto anon7;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    ##e#0_0_0 := e1#0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume Power.__default.Pow#canCall(b#0, e1#0);
    assume x#0 >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0);
    assume true;
    assume {:subsumption 0} x#0 >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0) ==> Lit(false);
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    assume Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0)) >= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e1#0 - e2#0) ==> false;
    return;
}



procedure {:verboseName "Power.LemmaPowDivisionInequalityAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowDivisionInequalityAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowDivisionInequalityAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowDivisionInequalityAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var e2#0: int;
  var ##b#0: int;
  var ##e#0: int;
  var x#0: int;
  var b#2: int;
  var e1#0: int;
  var e2#2: int;
  var ##b#1: int;
  var ##e#1: int;
  var ##b#2: int;
  var ##e#2: int;
  var ##b#3: int;
  var ##e#3: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowDivisionInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(571,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(572,12): post-state"} true;
    havoc b#0;
    havoc e2#0;
    assume LitInt(0) <= b#0 && LitInt(0) <= e2#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume b#0 > 0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e2#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e2#0);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) > 0;
    goto anon4;

  anon8_Else:
    assume b#0 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e2#0) > 0;
    goto anon4;

  anon4:
    assume (forall b#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) > 0);
    havoc x#0;
    havoc b#2;
    havoc e1#0;
    havoc e2#2;
    assume LitInt(0) <= x#0 && LitInt(0) <= b#2 && LitInt(0) <= e1#0 && LitInt(0) <= e2#2;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume b#2 > 0;
    assume e2#2 <= e1#0;
    ##b#1 := b#2;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e1#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e1#0);
    assume x#0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#0);
    ##b#2 := b#2;
    assume $IsAlloc(##b#2, TInt, $Heap);
    ##e#2 := e2#2;
    assume $IsAlloc(##e#2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e2#2);
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#2) != 0;
    ##b#3 := b#2;
    assume $IsAlloc(##b#3, TInt, $Heap);
    assume $Is(e1#0 - e2#2, Tclass._System.nat());
    ##e#3 := e1#0 - e2#2;
    assume $IsAlloc(##e#3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#2, e1#0 - e2#2);
    assume Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#2)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#0 - e2#2);
    goto anon7;

  anon9_Else:
    assume b#2 > 0 && e2#2 <= e1#0 && x#0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#0) ==> Div(x#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e2#2)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#2, e1#0 - e2#2);
    goto anon7;

  anon7:
    assume (forall x#1: int, b#3: int, e1#1: int, e2#3: int :: { Div(x#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#3)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1 - e2#3) } LitInt(0) <= x#1 && LitInt(0) <= b#3 && LitInt(0) <= e1#1 && LitInt(0) <= e2#3 ==> b#3 > 0 && e2#3 <= e1#1 && x#1 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1) ==> Div(x#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#3)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1 - e2#3));
    return;
}



procedure {:verboseName "Power.LemmaPowDivisionInequalityAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowDivisionInequalityAuto();



procedure {:verboseName "Power.LemmaPowDivisionInequalityAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowDivisionInequalityAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14673"} (forall b#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) > 0);
  free ensures (forall x#1: int, b#3: int, e1#1: int, e2#3: int :: { Div(x#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#3)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1 - e2#3) } LitInt(0) <= x#1 && LitInt(0) <= b#3 && LitInt(0) <= e1#1 && LitInt(0) <= e2#3 ==> b#3 > 0 ==> e2#3 <= e1#1 ==> Power.__default.Pow#canCall(b#3, e1#1) && (x#1 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1) ==> Power.__default.Pow#canCall(b#3, e2#3) && Power.__default.Pow#canCall(b#3, e1#1 - e2#3)));
  free ensures {:id "id14674"} (forall x#1: int, b#3: int, e1#1: int, e2#3: int :: { Div(x#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#3)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1 - e2#3) } LitInt(0) <= x#1 && LitInt(0) <= b#3 && LitInt(0) <= e1#1 && LitInt(0) <= e2#3 ==> b#3 > 0 && e2#3 <= e1#1 && x#1 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1) ==> Div(x#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#3)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1 - e2#3));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowDivisionInequalityAuto (correctness)"} Impl$$Power.__default.LemmaPowDivisionInequalityAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e2#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow#canCall(b#1, e2#1));
  free ensures {:id "id14675"} (forall b#1: int, e2#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) } LitInt(0) <= b#1 && LitInt(0) <= e2#1 ==> b#1 > 0 ==> Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e2#1) > 0);
  free ensures (forall x#1: int, b#3: int, e1#1: int, e2#3: int :: { Div(x#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e2#3)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1 - e2#3) } LitInt(0) <= x#1 && LitInt(0) <= b#3 && LitInt(0) <= e1#1 && LitInt(0) <= e2#3 ==> b#3 > 0 ==> e2#3 <= e1#1 ==> Power.__default.Pow#canCall(b#3, e1#1) && (x#1 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#3, e1#1) ==> Power.__default.Pow#canCall(b#3, e2#3) && Power.__default.Pow#canCall(b#3, e1#1 - e2#3)));
  free ensures {:id "id14676"} (forall x#1: int, b#3: int, e1#1: int, e2#3: int :: { Div(x#1, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e2#3)), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e1#1 - e2#3) } LitInt(0) <= x#1 && LitInt(0) <= b#3 && LitInt(0) <= e1#1 && LitInt(0) <= e2#3 ==> b#3 > 0 && e2#3 <= e1#1 && x#1 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e1#1) ==> Div(x#1, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e2#3)) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#3, e1#1 - e2#3));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowDivisionInequalityAuto (correctness)"} Impl$$Power.__default.LemmaPowDivisionInequalityAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var x#0_0: int;
  var b#0_0: int;
  var e1#0_0: int;
  var e2#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var ##b#0_2: int;
  var ##e#0_2: int;
  var x##0_0: int;
  var b##0_0: int;
  var e1##0_0: int;
  var e2##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowDivisionInequalityAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(577,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(578,15)"} true;
    call CallPre$$Power.__default.LemmaPowPositiveAuto();
    call CallPost$$Power.__default.LemmaPowPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(579,26)"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc x#0_0, b#0_0, e1#0_0, e2#0_0;
    assume LitInt(0) <= x#0_0 && LitInt(0) <= b#0_0 && LitInt(0) <= e1#0_0 && LitInt(0) <= e2#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} b#0_0 > 0;
    goto anon3;

  anon11_Else:
    assume {:partition} 0 >= b#0_0;
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} b#0_0 > 0 && e2#0_0 <= e1#0_0;
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e1#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0);
    goto anon5;

  anon12_Else:
    assume {:partition} !(b#0_0 > 0 && e2#0_0 <= e1#0_0);
    goto anon5;

  anon5:
    assume b#0_0 > 0 ==> e2#0_0 <= e1#0_0 ==> Power.__default.Pow#canCall(b#0_0, e1#0_0);
    assume b#0_0 > 0 && e2#0_0 <= e1#0_0 && x#0_0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e2#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0);
    assume {:subsumption 0} Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0) != 0;
    ##b#0_2 := b#0_0;
    assume $IsAlloc(##b#0_2, TInt, $Heap);
    assume $Is(e1#0_0 - e2#0_0, Tclass._System.nat());
    ##e#0_2 := e1#0_0 - e2#0_0;
    assume $IsAlloc(##e#0_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e1#0_0 - e2#0_0);
    assume Power.__default.Pow#canCall(b#0_0, e2#0_0) && Power.__default.Pow#canCall(b#0_0, e1#0_0 - e2#0_0);
    assume Div(x#0_0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e2#0_0)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e1#0_0 - e2#0_0);
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    assume true;
    x##0_0 := x#0_0;
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e1##0_0 := e1#0_0;
    assume true;
    e2##0_0 := e2#0_0;
    call CallPre$$Power.__default.LemmaPowDivisionInequality(x##0_0, b##0_0, e1##0_0, e2##0_0);
    call CallPost$$Power.__default.LemmaPowDivisionInequality(x##0_0, b##0_0, e1##0_0, e2##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(585,46)"} true;
    assume Div(x#0_0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e2#0_0)) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e1#0_0 - e2#0_0);
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall x#0_1: int, b#0_1: int, e1#0_1: int, e2#0_1: int :: { Div(x#0_1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1)), Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1 - e2#0_1) } LitInt(0) <= x#0_1 && LitInt(0) <= b#0_1 && LitInt(0) <= e1#0_1 && LitInt(0) <= e2#0_1 && b#0_1 > 0 && e2#0_1 <= e1#0_1 && x#0_1 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1) ==> Div(x#0_1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e2#0_1)) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e1#0_1 - e2#0_1));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(586,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowMod (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowMod(b#0: int where LitInt(0) <= b#0, e#0: int where LitInt(0) <= e#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowMod (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowMod(b#0: int, e#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowMod", " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(590,8): initial state"} true;
    assume b#0 > 0;
    assume e#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(592,26): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume b#0 != 0;
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), b#0) == LitInt(0);
    return;
}



procedure {:verboseName "Power.LemmaPowMod (call precondtion)"} CallPre$$Power.__default.LemmaPowMod(b#0: int where LitInt(0) <= b#0, e#0: int where LitInt(0) <= e#0);
  requires {:id "id14692"} b#0 > 0;
  requires {:id "id14693"} e#0 > 0;



procedure {:verboseName "Power.LemmaPowMod (call postcondition)"} CallPost$$Power.__default.LemmaPowMod(b#0: int where LitInt(0) <= b#0, e#0: int where LitInt(0) <= e#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14694"} Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0), b#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowMod (correctness)"} Impl$$Power.__default.LemmaPowMod(b#0: int where LitInt(0) <= b#0, e#0: int where LitInt(0) <= e#0) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id14695"} b#0 > 0;
  requires {:id "id14696"} e#0 > 0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14697"} Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0), b#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowMod (correctness)"} Impl$$Power.__default.LemmaPowMod(b#0: int, e#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;
  var x##0_0_0: int;
  var ##b#0_0_1: int;
  var ##e#0_0_1: int;
  var m##0_0_0: int;
  var ##b#0_1_0: int;
  var ##e#0_1_0: int;
  var ##b#0_1_1: int;
  var ##e#0_1_1: int;
  var ##b#0_2_0: int;
  var ##e#0_2_0: int;
  var ##b#0_2_1: int;
  var ##e#0_2_1: int;
  var ##b#0_0: int;
  var ##e#0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowMod", " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(593,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e0#0: int :: LitInt(0) <= $ih#b0#0 && LitInt(0) <= $ih#e0#0 && $ih#b0#0 > 0 && $ih#e0#0 > 0 && ((0 <= $ih#b0#0 && $ih#b0#0 < b#0) || ($ih#b0#0 == b#0 && 0 <= $ih#e0#0 && $ih#e0#0 < e#0)) ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e0#0), $ih#b0#0) == LitInt(0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(594,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume {:subsumption 0} b#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume false;
    goto anon5;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_2_0 := b#0;
    assume $IsAlloc(##b#0_2_0, TInt, $Heap);
    ##e#0_2_0 := e#0;
    assume $IsAlloc(##e#0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume {:subsumption 0} b#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0);
    ##b#0_2_1 := b#0;
    assume $IsAlloc(##b#0_2_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_2_1 := e#0 - 1;
    assume $IsAlloc(##e#0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} b#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0), b#0) == Mod(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)), b#0);
    assume false;
    goto anon5;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    ##b#0_1_0 := b#0;
    assume $IsAlloc(##b#0_1_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_1_0 := e#0 - 1;
    assume $IsAlloc(##e#0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} b#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    call CallPre$$Mul.__default.LemmaMulIsAssociativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsAssociativeAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(598,35)"} true;
    ##b#0_1_1 := b#0;
    assume $IsAlloc(##b#0_1_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_1_1 := e#0 - 1;
    assume $IsAlloc(##e#0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} b#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mod(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)), b#0) == Mod(Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1), b#0), b#0);
    assume false;
    goto anon5;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} b#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    call CallPre$$Power.__default.LemmaPowPositiveAuto();
    call CallPost$$Power.__default.LemmaPowPositiveAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(601,30)"} true;
    ##b#0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    x##0_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0 - 1);
    assume true;
    m##0_0_0 := b#0;
    call CallPre$$DivMod.__default.LemmaModMultiplesBasic(x##0_0_0, m##0_0_0);
    call CallPost$$DivMod.__default.LemmaModMultiplesBasic(x##0_0_0, m##0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(602,47)"} true;
    assume true;
    assume {:subsumption 0} Mod(Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1), b#0), b#0) == LitInt(0);
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), b#0) == LitInt(0);
    return;
}



procedure {:verboseName "Power.LemmaPowModAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowModAuto();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowModAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowModAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var e#0: int;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowModAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(608,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(609,12): post-state"} true;
    havoc b#0;
    havoc e#0;
    assume LitInt(0) <= b#0 && LitInt(0) <= e#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume b#0 > 0;
    assume e#0 > 0;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume b#0 != 0;
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), b#0) == LitInt(0);
    goto anon4;

  anon5_Else:
    assume b#0 > 0 && e#0 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), b#0) == LitInt(0);
    goto anon4;

  anon4:
    assume (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 ==> b#1 > 0 && e#1 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1), b#1) == LitInt(0));
    return;
}



procedure {:verboseName "Power.LemmaPowModAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowModAuto();



procedure {:verboseName "Power.LemmaPowModAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowModAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 ==> b#1 > 0 ==> e#1 > 0 ==> Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14727"} (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 ==> b#1 > 0 && e#1 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1), b#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowModAuto (correctness)"} Impl$$Power.__default.LemmaPowModAuto() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 ==> b#1 > 0 ==> e#1 > 0 ==> Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14728"} (forall b#1: int, e#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 ==> b#1 > 0 && e#1 > 0 ==> Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e#1), b#1) == LitInt(0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowModAuto (correctness)"} Impl$$Power.__default.LemmaPowModAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var b##0_0: int;
  var e##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowModAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(611,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(612,15)"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    havoc b#0_0, e#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e#0_0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} b#0_0 > 0;
    goto anon3;

  anon9_Else:
    assume {:partition} 0 >= b#0_0;
    goto anon3;

  anon3:
    assume true;
    assume b#0_0 > 0 && e#0_0 > 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##b#0_0 := b#0_0;
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume {:subsumption 0} b#0_0 != 0;
    assume Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e#0_0), b#0_0) == LitInt(0);
    assume false;
    goto anon5;

  anon10_Else:
    goto anon5;

  anon5:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e##0_0 := e#0_0;
    call CallPre$$Power.__default.LemmaPowMod(b##0_0, e##0_0);
    call CallPost$$Power.__default.LemmaPowMod(b##0_0, e##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(616,23)"} true;
    assume Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e#0_0), b#0_0) == LitInt(0);
    assume false;
    goto anon7;

  anon8_Else:
    assume (forall b#0_1: int, e#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e#0_1 && b#0_1 > 0 && e#0_1 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e#0_1), b#0_1) == LitInt(0));
    goto anon7;

  anon7:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(617,4)"} true;
    return;
}



procedure {:verboseName "Power.LemmaPowModNoop (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int where LitInt(0) <= e#0, m#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowModNoop (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int, m#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowModNoop", " | ", b#0, " | ", e#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(621,8): initial state"} true;
    assume m#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(624,30): post-state"} true;
    assume m#0 != 0;
    ##b#0 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0);
    assume m#0 != 0;
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume m#0 != 0;
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), m#0);
    return;
}



procedure {:verboseName "Power.LemmaPowModNoop (call precondtion)"} CallPre$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int where LitInt(0) <= e#0, m#0: int);
  requires {:id "id14742"} m#0 > 0;



procedure {:verboseName "Power.LemmaPowModNoop (call postcondition)"} CallPost$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int where LitInt(0) <= e#0, m#0: int);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(Mod(b#0, m#0), e#0) && Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14743"} Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0), m#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowModNoop (correctness)"} Impl$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int where LitInt(0) <= e#0, m#0: int) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id14744"} m#0 > 0;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(Mod(b#0, m#0), e#0) && Power.__default.Pow#canCall(b#0, e#0);
  free ensures {:id "id14745"} Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0), m#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowModNoop (correctness)"} Impl$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int, m#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##b#0_0_0_0: int;
  var ##e#0_0_0_0: int;
  var ##b#0_0_0_1: int;
  var ##e#0_0_0_1: int;
  var ##b#0_0_1_0: int;
  var ##e#0_0_1_0: int;
  var ##b#0_0_1_1: int;
  var ##e#0_0_1_1: int;
  var ##b#0_0_2_0: int;
  var ##e#0_0_2_0: int;
  var x##0_0_2_0: int;
  var y##0_0_2_0: int;
  var ##b#0_0_2_1: int;
  var ##e#0_0_2_1: int;
  var m##0_0_2_0: int;
  var ##b#0_0_2_2: int;
  var ##e#0_0_2_2: int;
  var ##b#0_0_3_0: int;
  var ##e#0_0_3_0: int;
  var b##0_0_3_0: int;
  var e##0_0_3_0: int;
  var m##0_0_3_0: int;
  var ##b#0_0_3_1: int;
  var ##e#0_0_3_1: int;
  var ##b#0_0_4_0: int;
  var ##e#0_0_4_0: int;
  var x##0_0_4_0: int;
  var y##0_0_4_0: int;
  var ##b#0_0_4_1: int;
  var ##e#0_0_4_1: int;
  var m##0_0_4_0: int;
  var ##b#0_0_4_2: int;
  var ##e#0_0_4_2: int;
  var ##b#0_0_5_0: int;
  var ##e#0_0_5_0: int;
  var ##b#0_0_5_1: int;
  var ##e#0_0_5_1: int;
  var ##b#0_0_0: int;
  var ##e#0_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowModNoop", " | ", b#0, " | ", e#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(625,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: int, $ih#e0#0: int, $ih#m0#0: int :: LitInt(0) <= $ih#e0#0 && $ih#m0#0 > 0 && 0 <= $ih#e0#0 && $ih#e0#0 < e#0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod($ih#b0#0, $ih#m0#0), $ih#e0#0), $ih#m0#0) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, $ih#b0#0, $ih#e0#0), $ih#m0#0));
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(626,15)"} true;
    call CallPre$$DivMod.__default.LemmaModPropertiesAuto();
    call CallPost$$DivMod.__default.LemmaModPropertiesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(627,28)"} true;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} e#0 > 0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_0 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_0, TInt, $Heap);
    ##e#0_0_0 := e#0;
    assume $IsAlloc(##e#0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0);
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_5_0 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_5_0, TInt, $Heap);
    ##e#0_0_5_0 := e#0;
    assume $IsAlloc(##e#0_0_5_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_5_1 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_5_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_5_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_5_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume {:subsumption 0} Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Mul(Mod(b#0, m#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0 - 1)), m#0);
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_4_0 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_4_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_4_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_4_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume true;
    x##0_0_4_0 := b#0;
    assume m#0 != 0;
    ##b#0_0_4_1 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_4_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_4_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_4_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    y##0_0_4_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0, m#0), e#0 - 1);
    assume true;
    m##0_0_4_0 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopGeneral(x##0_0_4_0, y##0_0_4_0, m##0_0_4_0);
    call CallPost$$DivMod.__default.LemmaMulModNoopGeneral(x##0_0_4_0, y##0_0_4_0, m##0_0_4_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(632,57)"} true;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_4_2 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_4_2, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_4_2 := e#0 - 1;
    assume $IsAlloc(##e#0_0_4_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume {:subsumption 0} Mod(Mul(Mod(b#0, m#0), Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0 - 1)), m#0) == Mod(Mod(Mul(Mod(b#0, m#0), Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0 - 1), m#0)), m#0), m#0);
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_3_0 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0_0_3_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_3_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0 - 1);
    assume true;
    b##0_0_3_0 := b#0;
    assume true;
    assume $Is(e#0 - 1, Tclass._System.nat());
    e##0_0_3_0 := e#0 - 1;
    assume true;
    m##0_0_3_0 := m#0;
    assume 0 <= e#0 || e##0_0_3_0 == e#0;
    assume e##0_0_3_0 < e#0;
    call CallPre$$Power.__default.LemmaPowModNoop(b##0_0_3_0, e##0_0_3_0, m##0_0_3_0);
    call CallPost$$Power.__default.LemmaPowModNoop(b##0_0_3_0, e##0_0_3_0, m##0_0_3_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(634,38)"} true;
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_3_1 := b#0;
    assume $IsAlloc(##b#0_0_3_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_3_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mod(Mod(Mul(Mod(b#0, m#0), Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0, m#0), e#0 - 1), m#0)), m#0), m#0) == Mod(Mod(Mul(Mod(b#0, m#0), Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1), m#0)), m#0), m#0);
    assume false;
    goto anon9;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} m#0 != 0;
    ##b#0_0_2_0 := b#0;
    assume $IsAlloc(##b#0_0_2_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_2_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume true;
    x##0_0_2_0 := b#0;
    ##b#0_0_2_1 := b#0;
    assume $IsAlloc(##b#0_0_2_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_2_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    y##0_0_2_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0 - 1);
    assume true;
    m##0_0_2_0 := m#0;
    call CallPre$$DivMod.__default.LemmaMulModNoopGeneral(x##0_0_2_0, y##0_0_2_0, m##0_0_2_0);
    call CallPost$$DivMod.__default.LemmaMulModNoopGeneral(x##0_0_2_0, y##0_0_2_0, m##0_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(636,53)"} true;
    ##b#0_0_2_2 := b#0;
    assume $IsAlloc(##b#0_0_2_2, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_2_2 := e#0 - 1;
    assume $IsAlloc(##e#0_0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mod(Mod(Mul(Mod(b#0, m#0), Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1), m#0)), m#0), m#0) == Mod(Mod(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)), m#0), m#0);
    assume false;
    goto anon9;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    ##b#0_0_1_0 := b#0;
    assume $IsAlloc(##b#0_0_1_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    ##b#0_0_1_1 := b#0;
    assume $IsAlloc(##b#0_0_1_1, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_1_1 := e#0 - 1;
    assume $IsAlloc(##e#0_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} Mod(Mod(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)), m#0), m#0) == Mod(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)), m#0);
    assume false;
    goto anon9;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    ##b#0_0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0_0, TInt, $Heap);
    assume $Is(e#0 - 1, Tclass._System.nat());
    ##e#0_0_0_0 := e#0 - 1;
    assume $IsAlloc(##e#0_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0 - 1);
    ##b#0_0_0_1 := b#0;
    assume $IsAlloc(##b#0_0_0_1, TInt, $Heap);
    ##e#0_0_0_1 := e#0;
    assume $IsAlloc(##e#0_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume {:subsumption 0} m#0 != 0;
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume {:subsumption 0} Mod(Mul(b#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0 - 1)), m#0) == Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0, e#0), m#0);
    assume false;
    goto anon9;

  anon18_Else:
    goto anon9;

  anon9:
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), m#0);
    return;

  anon11_Else:
    assume {:partition} 0 >= e#0;
    return;
}



procedure {:verboseName "Power.LemmaPowModNoopAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowModNoopAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowModNoopAuto (well-formedness)"} CheckWellFormed$$Power.__default.LemmaPowModNoopAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0: int;
  var e#0: int;
  var m#0: int;
  var ##b#0: int;
  var ##e#0: int;
  var ##b#1: int;
  var ##e#1: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(644,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(645,12): post-state"} true;
    havoc b#0;
    havoc e#0;
    havoc m#0;
    assume LitInt(0) <= b#0 && LitInt(0) <= e#0 && LitInt(0) <= m#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume m#0 > 0;
    assume m#0 != 0;
    ##b#0 := Mod(b#0, m#0);
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := e#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0, m#0), e#0);
    assume m#0 != 0;
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TInt, $Heap);
    ##e#1 := e#0;
    assume $IsAlloc(##e#1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0, e#0);
    assume m#0 != 0;
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), m#0);
    goto anon4;

  anon5_Else:
    assume m#0 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0, m#0), e#0), m#0) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0, e#0), m#0);
    goto anon4;

  anon4:
    assume (forall b#1: int, e#1: int, m#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#1, m#1), e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 && LitInt(0) <= m#1 ==> m#1 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#1, m#1), e#1), m#1) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1), m#1));
    return;
}



procedure {:verboseName "Power.LemmaPowModNoopAuto (call precondtion)"} CallPre$$Power.__default.LemmaPowModNoopAuto();



procedure {:verboseName "Power.LemmaPowModNoopAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowModNoopAuto();
  modifies $Heap;
  free ensures (forall b#1: int, e#1: int, m#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#1, m#1), e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 && LitInt(0) <= m#1 ==> m#1 > 0 ==> Power.__default.Pow#canCall(Mod(b#1, m#1), e#1) && Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14821"} (forall b#1: int, e#1: int, m#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#1, m#1), e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 && LitInt(0) <= m#1 ==> m#1 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#1, m#1), e#1), m#1) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#1, e#1), m#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Power.LemmaPowModNoopAuto (correctness)"} Impl$$Power.__default.LemmaPowModNoopAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall b#1: int, e#1: int, m#1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#1, m#1), e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 && LitInt(0) <= m#1 ==> m#1 > 0 ==> Power.__default.Pow#canCall(Mod(b#1, m#1), e#1) && Power.__default.Pow#canCall(b#1, e#1));
  free ensures {:id "id14822"} (forall b#1: int, e#1: int, m#1: int :: { Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#1, m#1), e#1) } LitInt(0) <= b#1 && LitInt(0) <= e#1 && LitInt(0) <= m#1 ==> m#1 > 0 ==> Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#1, m#1), e#1), m#1) == Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#1, e#1), m#1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Power.LemmaPowModNoopAuto (correctness)"} Impl$$Power.__default.LemmaPowModNoopAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b#0_0: int;
  var e#0_0: int;
  var m#0_0: int;
  var ##b#0_0: int;
  var ##e#0_0: int;
  var ##b#0_1: int;
  var ##e#0_1: int;
  var b##0_0: int;
  var e##0_0: int;
  var m##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Power.LemmaPowModNoopAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(647,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(648,15)"} true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    havoc b#0_0, e#0_0, m#0_0;
    assume LitInt(0) <= b#0_0 && LitInt(0) <= e#0_0 && LitInt(0) <= m#0_0;
    assume true;
    assume m#0_0 > 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:subsumption 0} m#0_0 != 0;
    ##b#0_0 := Mod(b#0_0, m#0_0);
    assume $IsAlloc(##b#0_0, TInt, $Heap);
    ##e#0_0 := e#0_0;
    assume $IsAlloc(##e#0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(Mod(b#0_0, m#0_0), e#0_0);
    assume {:subsumption 0} m#0_0 != 0;
    ##b#0_1 := b#0_0;
    assume $IsAlloc(##b#0_1, TInt, $Heap);
    ##e#0_1 := e#0_0;
    assume $IsAlloc(##e#0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume {:subsumption 0} m#0_0 != 0;
    assume Power.__default.Pow#canCall(Mod(b#0_0, m#0_0), e#0_0) && Power.__default.Pow#canCall(b#0_0, e#0_0);
    assume Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0_0, m#0_0), e#0_0), m#0_0) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_0, e#0_0), m#0_0);
    assume false;
    goto anon3;

  anon7_Else:
    goto anon3;

  anon3:
    assume true;
    b##0_0 := b#0_0;
    assume true;
    e##0_0 := e#0_0;
    assume true;
    m##0_0 := m#0_0;
    call CallPre$$Power.__default.LemmaPowModNoop(b##0_0, e##0_0, m##0_0);
    call CallPost$$Power.__default.LemmaPowModNoop(b##0_0, e##0_0, m##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(652,30)"} true;
    assume Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, Mod(b#0_0, m#0_0), e#0_0), m#0_0) == Mod(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, b#0_0, e#0_0), m#0_0);
    assume false;
    goto anon5;

  anon6_Else:
    assume (forall b#0_1: int, e#0_1: int, m#0_1: int :: { Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0_1, m#0_1), e#0_1) } LitInt(0) <= b#0_1 && LitInt(0) <= e#0_1 && LitInt(0) <= m#0_1 && m#0_1 > 0 ==> Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, Mod(b#0_1, m#0_1), e#0_1), m#0_1) == Mod(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, b#0_1, e#0_1), m#0_1));
    goto anon5;

  anon5:
    assume {:captureState "libraries/src/NonlinearArithmetic/Power.dfy(653,4)"} true;
    return;
}



procedure {:verboseName "Power.reveal_Pow (well-formedness)"} {:verify false} CheckWellFormed$$Power.__default.reveal__Pow();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Power.reveal_Pow (call precondtion)"} {:verify false} CallPre$$Power.__default.reveal__Pow();



procedure {:verboseName "Power.reveal_Pow (call postcondition)"} {:verify false} CallPost$$Power.__default.reveal__Pow();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Power._default.Pow;



axiom MulInternals.__default.MulAuto() <==> (forall x#36: int, y#36: int :: { Mul(x#36, y#36) } Mul(x#36, y#36) == Mul(y#36, x#36)) && (forall x#37: int, y#37: int, z#24: int :: { Mul(x#37 + y#37, z#24) } Mul(x#37 + y#37, z#24) == Mul(x#37, z#24) + Mul(y#37, z#24)) && (forall x#38: int, y#38: int, z#25: int :: { Mul(x#38 - y#38, z#25) } Mul(x#38 - y#38, z#25) == Mul(x#38, z#25) - Mul(y#38, z#25));

axiom MulInternals.__default.MulAuto() <==> (forall x#39: int, y#39: int :: { Mul(x#39, y#39) } Mul(x#39, y#39) == Mul(y#39, x#39)) && (forall x#40: int, y#40: int, z#26: int :: { Mul(x#40 + y#40, z#26) } Mul(x#40 + y#40, z#26) == Mul(x#40, z#26) + Mul(y#40, z#26)) && (forall x#41: int, y#41: int, z#27: int :: { Mul(x#41 - y#41, z#27) } Mul(x#41 - y#41, z#27) == Mul(x#41, z#27) - Mul(y#41, z#27));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#32: int :: { Mod(Mod(x#32, n#0), n#0) } Mod(Mod(x#32, n#0), n#0) == Mod(x#32, n#0)) && (forall x#33: int :: { Mod(x#33, n#0) } LitInt(0) <= x#33 && x#33 < n#0 <==> Mod(x#33, n#0) == x#33) && (forall x#34: int, y#16: int :: { Mod(x#34 + y#16, n#0) } (var z#14 := Mod(x#34, n#0) + Mod(y#16, n#0); (LitInt(0) <= z#14 && z#14 < n#0 && Mod(x#34 + y#16, n#0) == z#14) || (n#0 <= z#14 && z#14 < n#0 + n#0 && Mod(x#34 + y#16, n#0) == z#14 - n#0))) && (forall x#35: int, y#17: int :: { Mod(x#35 - y#17, n#0) } (var z#15 := Mod(x#35, n#0) - Mod(y#17, n#0); (LitInt(0) <= z#15 && z#15 < n#0 && Mod(x#35 - y#17, n#0) == z#15) || (0 - n#0 <= z#15 && z#15 < 0 && Mod(x#35 - y#17, n#0) == z#15 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#36: int :: { Mod(Mod(x#36, n#0), n#0) } Mod(Mod(x#36, LitInt(n#0)), LitInt(n#0)) == Mod(x#36, LitInt(n#0))) && (forall x#37: int :: { Mod(x#37, n#0) } LitInt(0) <= x#37 && x#37 < n#0 <==> Mod(x#37, LitInt(n#0)) == x#37) && (forall x#38: int, y#18: int :: { Mod(x#38 + y#18, n#0) } (var z#16 := Mod(x#38, LitInt(n#0)) + Mod(y#18, LitInt(n#0)); (LitInt(0) <= z#16 && z#16 < n#0 && Mod(x#38 + y#18, LitInt(n#0)) == z#16) || (LitInt(n#0) <= z#16 && z#16 < n#0 + n#0 && Mod(x#38 + y#18, LitInt(n#0)) == z#16 - n#0))) && (forall x#39: int, y#19: int :: { Mod(x#39 - y#19, n#0) } (var z#17 := Mod(x#39, LitInt(n#0)) - Mod(y#19, LitInt(n#0)); (LitInt(0) <= z#17 && z#17 < n#0 && Mod(x#39 - y#19, LitInt(n#0)) == z#17) || (LitInt(0 - n#0) <= z#17 && z#17 < 0 && Mod(x#39 - y#19, LitInt(n#0)) == z#17 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#18: int :: { Div(x#18, n#0) } LitInt(0) <= x#18 && x#18 < n#0 <==> Div(x#18, n#0) == LitInt(0)) && (forall x#19: int, y#12: int :: { Div(x#19 + y#12, n#0) } (var z#10 := Mod(x#19, n#0) + Mod(y#12, n#0); (LitInt(0) <= z#10 && z#10 < n#0 && Div(x#19 + y#12, n#0) == Div(x#19, n#0) + Div(y#12, n#0)) || (n#0 <= z#10 && z#10 < n#0 + n#0 && Div(x#19 + y#12, n#0) == Div(x#19, n#0) + Div(y#12, n#0) + 1))) && (forall x#20: int, y#13: int :: { Div(x#20 - y#13, n#0) } (var z#11 := Mod(x#20, n#0) - Mod(y#13, n#0); (LitInt(0) <= z#11 && z#11 < n#0 && Div(x#20 - y#13, n#0) == Div(x#20, n#0) - Div(y#13, n#0)) || (0 - n#0 <= z#11 && z#11 < 0 && Div(x#20 - y#13, n#0) == Div(x#20, n#0) - Div(y#13, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#21: int :: { Div(x#21, n#0) } LitInt(0) <= x#21 && x#21 < n#0 <==> Div(x#21, LitInt(n#0)) == LitInt(0)) && (forall x#22: int, y#14: int :: { Div(x#22 + y#14, n#0) } (var z#12 := Mod(x#22, LitInt(n#0)) + Mod(y#14, LitInt(n#0)); (LitInt(0) <= z#12 && z#12 < n#0 && Div(x#22 + y#14, LitInt(n#0)) == Div(x#22, LitInt(n#0)) + Div(y#14, LitInt(n#0))) || (LitInt(n#0) <= z#12 && z#12 < n#0 + n#0 && Div(x#22 + y#14, LitInt(n#0)) == Div(x#22, LitInt(n#0)) + Div(y#14, LitInt(n#0)) + 1))) && (forall x#23: int, y#15: int :: { Div(x#23 - y#15, n#0) } (var z#13 := Mod(x#23, LitInt(n#0)) - Mod(y#15, LitInt(n#0)); (LitInt(0) <= z#13 && z#13 < n#0 && Div(x#23 - y#15, LitInt(n#0)) == Div(x#23, LitInt(n#0)) - Div(y#15, LitInt(n#0))) || (LitInt(0 - n#0) <= z#13 && z#13 < 0 && Div(x#23 - y#15, LitInt(n#0)) == Div(x#23, LitInt(n#0)) - Div(y#15, LitInt(n#0)) - 1)))));

axiom (forall x#0: int, y#0: int, m#0: int :: { DivMod.__default.IsModEquivalent(x#0, y#0, m#0) } DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0) || m#0 > 0 ==> (Mod(x#0, m#0) == Mod(y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0)));

axiom (forall x#0: int, y#0: int, m#0: int :: { DivMod.__default.IsModEquivalent(x#0, y#0, m#0) } DivMod.__default.IsModEquivalent#canCall(x#0, y#0, m#0) || m#0 > 0 ==> (DivMod.__default.IsModEquivalent(x#0, y#0, m#0) <==> Mod(x#0 - y#0, m#0) == LitInt(0)));

axiom (forall x#0: int, y#0: int, m#0: int :: {:weight 3} { DivMod.__default.IsModEquivalent(LitInt(x#0), LitInt(y#0), LitInt(m#0)) } DivMod.__default.IsModEquivalent#canCall(LitInt(x#0), LitInt(y#0), LitInt(m#0)) || Lit(m#0 > 0) ==> (DivMod.__default.IsModEquivalent(LitInt(x#0), LitInt(y#0), LitInt(m#0)) <==> LitInt(Mod(x#0 - y#0, LitInt(m#0))) == LitInt(0)));

const reveal_Logarithm._default.Log: bool;

const unique class.Logarithm.__default: ClassName;

function Logarithm.__default.Log($ly: LayerType, $reveal: bool, base#0: int, pow#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, base#0: int, pow#0: int :: { Logarithm.__default.Log($ly, $reveal, base#0, pow#0) } Logarithm.__default.Log#canCall(base#0, pow#0) || (0 < $FunctionContextHeight && LitInt(0) <= base#0 && LitInt(0) <= pow#0 && base#0 > 1) ==> LitInt(0) <= Logarithm.__default.Log($ly, $reveal, base#0, pow#0));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, base#0: int, pow#0: int :: { Logarithm.__default.Log($LS($ly), true, base#0, pow#0) } Logarithm.__default.Log#canCall(base#0, pow#0) || (0 < $FunctionContextHeight && LitInt(0) <= base#0 && LitInt(0) <= pow#0 && base#0 > 1) ==> (base#0 <= pow#0 ==> Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0))) && Logarithm.__default.Log($LS($ly), true, base#0, pow#0) == (if pow#0 < base#0 then 0 else 1 + Logarithm.__default.Log($ly, reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, base#0: int, pow#0: int :: {:weight 3} { Logarithm.__default.Log($LS($ly), true, base#0, LitInt(pow#0)) } Logarithm.__default.Log#canCall(base#0, LitInt(pow#0)) || (0 < $FunctionContextHeight && LitInt(0) <= base#0 && LitInt(0) <= pow#0 && base#0 > 1) ==> (base#0 <= pow#0 ==> Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0))) && Logarithm.__default.Log($LS($ly), true, base#0, LitInt(pow#0)) == (if pow#0 < base#0 then 0 else 1 + Logarithm.__default.Log($LS($ly), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, base#0: int, pow#0: int :: {:weight 3} { Logarithm.__default.Log($LS($ly), true, LitInt(base#0), LitInt(pow#0)) } Logarithm.__default.Log#canCall(LitInt(base#0), LitInt(pow#0)) || (0 < $FunctionContextHeight && LitInt(0) <= base#0 && LitInt(0) <= pow#0 && Lit(base#0 > 1)) ==> (!Lit(pow#0 < base#0) ==> Logarithm.__default.Log#canCall(LitInt(base#0), LitInt(Div(pow#0, LitInt(base#0))))) && Logarithm.__default.Log($LS($ly), true, LitInt(base#0), LitInt(pow#0)) == (if pow#0 < base#0 then 0 else 1 + Logarithm.__default.Log($LS($ly), reveal_Logarithm._default.Log, LitInt(base#0), LitInt(Div(pow#0, LitInt(base#0))))));
}

function Logarithm.__default.Log#canCall(base#0: int, pow#0: int) : bool;

axiom (forall $ly: LayerType, $reveal: bool, base#0: int, pow#0: int :: { Logarithm.__default.Log($LS($ly), $reveal, base#0, pow#0) } Logarithm.__default.Log($LS($ly), $reveal, base#0, pow#0) == Logarithm.__default.Log($ly, $reveal, base#0, pow#0));

axiom (forall $ly: LayerType, $reveal: bool, base#0: int, pow#0: int :: { Logarithm.__default.Log(AsFuelBottom($ly), $reveal, base#0, pow#0) } Logarithm.__default.Log($ly, $reveal, base#0, pow#0) == Logarithm.__default.Log($LZ, $reveal, base#0, pow#0));

function Logarithm.__default.Log#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, base#0: int, pow#0: int :: { Logarithm.__default.Log#requires($ly, base#0, pow#0) } LitInt(0) <= base#0 && LitInt(0) <= pow#0 ==> (Logarithm.__default.Log#requires($ly, base#0, pow#0) <==> base#0 > 1));

procedure {:verboseName "Logarithm.Log (well-formedness)"} CheckWellformed$$Logarithm.__default.Log(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.Log (well-formedness)"} CheckWellformed$$Logarithm.__default.Log(base#0: int, pow#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.Log", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(12,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume LitInt(0) <= Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0);
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} pow#0 < base#0;
    assume $Is(LitInt(0), Tclass._System.nat());
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
    assume true;
    assume $Is(Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0), Tclass._System.nat());
    return;

  anon7_Else:
    assume {:partition} base#0 <= pow#0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(18,27)"} true;
    call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(18,52)"} true;
    assume base#0 != 0;
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    assume $Is(Div(pow#0, base#0), Tclass._System.nat());
    ##pow#0 := Div(pow#0, base#0);
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume 0 <= pow#0 || ##pow#0 == pow#0;
    assume ##pow#0 < pow#0;
    assume Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0));
    assume $Is(1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0)), Tclass._System.nat());
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0));
    assume Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0));
    assume $Is(Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0), Tclass._System.nat());
    return;
}



procedure {:verboseName "Logarithm.LemmaLog0 (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLog0(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLog0 (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLog0(base#0: int, pow#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLog0", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(22,27): initial state"} true;
    assume base#0 > 1;
    assume pow#0 < base#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(25,27): post-state"} true;
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := pow#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
    return;
}



procedure {:verboseName "Logarithm.LemmaLog0 (call precondtion)"} CallPre$$Logarithm.__default.LemmaLog0(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  requires {:id "id14893"} base#0 > 1;
  requires {:id "id14894"} pow#0 < base#0;



procedure {:verboseName "Logarithm.LemmaLog0 (call postcondition)"} CallPost$$Logarithm.__default.LemmaLog0(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  modifies $Heap;
  free ensures Logarithm.__default.Log#canCall(base#0, pow#0);
  free ensures {:id "id14895"} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Logarithm.LemmaLog0 (correctness)"} Impl$$Logarithm.__default.LemmaLog0(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id14896"} base#0 > 1;
  requires {:id "id14897"} pow#0 < base#0;
  modifies $Heap;
  free ensures Logarithm.__default.Log#canCall(base#0, pow#0);
  free ensures {:id "id14898"} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLog0 (correctness)"} Impl$$Logarithm.__default.LemmaLog0(base#0: int, pow#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLog0", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(26,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(27,15)"} true;
    return;
}



procedure {:verboseName "Logarithm.LemmaLogS (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogS(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogS (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogS(base#0: int, pow#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var ##base#1: int;
  var ##pow#1: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogS", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(30,27): initial state"} true;
    assume base#0 > 1;
    assume pow#0 >= base#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(33,23): post-state"} true;
    assume base#0 != 0;
    assume Div(pow#0, base#0) >= LitInt(0);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := pow#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    assume base#0 != 0;
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, Tclass._System.nat(), $Heap);
    assume $Is(Div(pow#0, base#0), Tclass._System.nat());
    ##pow#1 := Div(pow#0, base#0);
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1 > 1;
    assume ##base#1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0));
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0));
    return;
}



procedure {:verboseName "Logarithm.LemmaLogS (call precondtion)"} CallPre$$Logarithm.__default.LemmaLogS(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  requires {:id "id14910"} base#0 > 1;
  requires {:id "id14911"} pow#0 >= base#0;



procedure {:verboseName "Logarithm.LemmaLogS (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogS(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14912"} Div(pow#0, base#0) >= LitInt(0);
  free ensures Logarithm.__default.Log#canCall(base#0, pow#0) && Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0));
  free ensures {:id "id14913"} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) == 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Logarithm.LemmaLogS (correctness)"} Impl$$Logarithm.__default.LemmaLogS(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id14914"} base#0 > 1;
  requires {:id "id14915"} pow#0 >= base#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id14916"} Div(pow#0, base#0) >= LitInt(0);
  free ensures Logarithm.__default.Log#canCall(base#0, pow#0) && Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0));
  free ensures {:id "id14917"} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) == 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogS (correctness)"} Impl$$Logarithm.__default.LemmaLogS(base#0: int, pow#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogS", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(35,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(36,26)"} true;
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(37,15)"} true;
    return;
}



procedure {:verboseName "Logarithm.LemmaLogSAuto (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogSAuto();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogSAuto (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogSAuto()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var pow#0: int;
  var base#0: int;
  var ##base#0: int;
  var ##pow#0: int;
  var ##base#1: int;
  var ##pow#1: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogSAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(40,27): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(41,12): post-state"} true;
    havoc pow#0;
    havoc base#0;
    assume LitInt(0) <= pow#0 && LitInt(0) <= base#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume base#0 > 1;
    assume pow#0 >= base#0;
    assume base#0 != 0;
    assume Div(pow#0, base#0) >= LitInt(0);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := pow#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    assume base#0 != 0;
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, Tclass._System.nat(), $Heap);
    assume $Is(Div(pow#0, base#0), Tclass._System.nat());
    ##pow#1 := Div(pow#0, base#0);
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1 > 1;
    assume ##base#1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0));
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0));
    goto anon4;

  anon5_Else:
    assume base#0 > 1 && pow#0 >= base#0 ==> Div(pow#0, base#0) >= LitInt(0) && Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0));
    goto anon4;

  anon4:
    assume (forall pow#1: int, base#1: int :: { Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)) } LitInt(0) <= pow#1 && LitInt(0) <= base#1 && base#1 > 1 && pow#1 >= base#1 ==> Div(pow#1, base#1) >= LitInt(0) && Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, pow#1) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)));
    return;
}



procedure {:verboseName "Logarithm.LemmaLogSAuto (call precondtion)"} CallPre$$Logarithm.__default.LemmaLogSAuto();



procedure {:verboseName "Logarithm.LemmaLogSAuto (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogSAuto();
  modifies $Heap;
  free ensures (forall pow#1: int, base#1: int :: { Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)) } LitInt(0) <= pow#1 && LitInt(0) <= base#1 ==> base#1 > 1 && pow#1 >= base#1 ==> Div(pow#1, base#1) >= LitInt(0) ==> Logarithm.__default.Log#canCall(base#1, pow#1) && Logarithm.__default.Log#canCall(base#1, Div(pow#1, base#1)));
  free ensures {:id "id14933"} (forall pow#1: int, base#1: int :: { Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)) } LitInt(0) <= pow#1 && LitInt(0) <= base#1 && base#1 > 1 && pow#1 >= base#1 ==> Div(pow#1, base#1) >= LitInt(0) && Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, pow#1) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Logarithm.LemmaLogSAuto (correctness)"} Impl$$Logarithm.__default.LemmaLogSAuto() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall pow#1: int, base#1: int :: { Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)) } LitInt(0) <= pow#1 && LitInt(0) <= base#1 ==> base#1 > 1 && pow#1 >= base#1 ==> Div(pow#1, base#1) >= LitInt(0) ==> Logarithm.__default.Log#canCall(base#1, pow#1) && Logarithm.__default.Log#canCall(base#1, Div(pow#1, base#1)));
  free ensures {:id "id14934"} (forall pow#1: int, base#1: int :: { Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)) } LitInt(0) <= pow#1 && LitInt(0) <= base#1 && base#1 > 1 && pow#1 >= base#1 ==> Div(pow#1, base#1) >= LitInt(0) && Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#1, pow#1) == 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#1, Div(pow#1, base#1)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogSAuto (correctness)"} Impl$$Logarithm.__default.LemmaLogSAuto() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var base#0_0: int;
  var pow#0_0: int;
  var ##base#0_0: int;
  var ##pow#0_0: int;
  var ##base#0_1: int;
  var ##pow#0_1: int;
  var base##0_0: int;
  var pow##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogSAuto"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(47,2): initial state"} true;
    $_reverifyPost := false;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc base#0_0, pow#0_0;
    assume LitInt(0) <= base#0_0 && LitInt(0) <= pow#0_0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} base#0_0 > 1;
    goto anon3;

  anon11_Else:
    assume {:partition} 1 >= base#0_0;
    goto anon3;

  anon3:
    assume true;
    assume base#0_0 > 1 && pow#0_0 >= base#0_0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} base#0_0 != 0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Div(pow#0_0, base#0_0) >= LitInt(0);
    ##base#0_0 := base#0_0;
    assume $IsAlloc(##base#0_0, Tclass._System.nat(), $Heap);
    ##pow#0_0 := pow#0_0;
    assume $IsAlloc(##pow#0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0_0, pow#0_0);
    assume {:subsumption 0} base#0_0 != 0;
    ##base#0_1 := base#0_0;
    assume $IsAlloc(##base#0_1, Tclass._System.nat(), $Heap);
    assume $Is(Div(pow#0_0, base#0_0), Tclass._System.nat());
    ##pow#0_1 := Div(pow#0_0, base#0_0);
    assume $IsAlloc(##pow#0_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_1 > 1;
    assume Logarithm.__default.Log#canCall(base#0_0, Div(pow#0_0, base#0_0));
    goto anon6;

  anon13_Else:
    assume {:partition} LitInt(0) > Div(pow#0_0, base#0_0);
    goto anon6;

  anon6:
    assume Div(pow#0_0, base#0_0) >= LitInt(0) ==> Logarithm.__default.Log#canCall(base#0_0, pow#0_0) && Logarithm.__default.Log#canCall(base#0_0, Div(pow#0_0, base#0_0));
    assume Div(pow#0_0, base#0_0) >= LitInt(0) && Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0_0, pow#0_0) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0_0, Div(pow#0_0, base#0_0));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume true;
    base##0_0 := base#0_0;
    assume true;
    pow##0_0 := pow#0_0;
    call CallPre$$Logarithm.__default.LemmaLogS(base##0_0, pow##0_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##0_0, pow##0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(52,26)"} true;
    assume Div(pow#0_0, base#0_0) >= LitInt(0);
    assume Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0_0, pow#0_0) == 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0_0, Div(pow#0_0, base#0_0));
    assume false;
    goto anon9;

  anon10_Else:
    assume (forall base#0_1: int, pow#0_1: int :: { Div(pow#0_1, base#0_1) } LitInt(0) <= base#0_1 && LitInt(0) <= pow#0_1 && base#0_1 > 1 && pow#0_1 >= base#0_1 ==> Div(pow#0_1, base#0_1) >= LitInt(0) && Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0_1, pow#0_1) == 1 + Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0_1, Div(pow#0_1, base#0_1)));
    goto anon9;

  anon9:
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(53,4)"} true;
    return;
}



procedure {:verboseName "Logarithm.LemmaLogIsOrdered (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogIsOrdered(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0, pow'#0: int where LitInt(0) <= pow'#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogIsOrdered (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogIsOrdered(base#0: int, pow#0: int, pow'#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var ##base#1: int;
  var ##pow#1: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogIsOrdered", " | ", base#0, " | ", pow#0, " | ", pow'#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(56,27): initial state"} true;
    assume base#0 > 1;
    assume pow#0 <= pow'#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(59,27): post-state"} true;
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := pow#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, Tclass._System.nat(), $Heap);
    ##pow#1 := pow'#0;
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1 > 1;
    assume ##base#1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow'#0);
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) <= Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow'#0);
    return;
}



procedure {:verboseName "Logarithm.LemmaLogIsOrdered (call precondtion)"} CallPre$$Logarithm.__default.LemmaLogIsOrdered(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0, pow'#0: int where LitInt(0) <= pow'#0);
  requires {:id "id14951"} base#0 > 1;
  requires {:id "id14952"} pow#0 <= pow'#0;



procedure {:verboseName "Logarithm.LemmaLogIsOrdered (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogIsOrdered(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0, pow'#0: int where LitInt(0) <= pow'#0);
  modifies $Heap;
  free ensures Logarithm.__default.Log#canCall(base#0, pow#0) && Logarithm.__default.Log#canCall(base#0, pow'#0);
  free ensures {:id "id14953"} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) <= Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow'#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Logarithm.LemmaLogIsOrdered (correctness)"} Impl$$Logarithm.__default.LemmaLogIsOrdered(base#0: int where LitInt(0) <= base#0, pow#0: int where LitInt(0) <= pow#0, pow'#0: int where LitInt(0) <= pow'#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id14954"} base#0 > 1;
  requires {:id "id14955"} pow#0 <= pow'#0;
  modifies $Heap;
  free ensures Logarithm.__default.Log#canCall(base#0, pow#0) && Logarithm.__default.Log#canCall(base#0, pow'#0);
  free ensures {:id "id14956"} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) <= Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow'#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogIsOrdered (correctness)"} Impl$$Logarithm.__default.LemmaLogIsOrdered(base#0: int, pow#0: int, pow'#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##base#0_0: int;
  var ##pow#0_0: int;
  var ##base#0_1: int;
  var ##pow#0_1: int;
  var ##base#1_0_0: int;
  var ##pow#1_0_0: int;
  var base##1_1_0: int;
  var pow##1_1_0: int;
  var pow'##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogIsOrdered", " | ", base#0, " | ", pow#0, " | ", pow'#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(61,2): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(62,15)"} true;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} pow'#0 < base#0;
    ##base#0_0 := base#0;
    assume $IsAlloc(##base#0_0, Tclass._System.nat(), $Heap);
    ##pow#0_0 := pow#0;
    assume $IsAlloc(##pow#0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
    ##base#0_1 := base#0;
    assume $IsAlloc(##base#0_1, Tclass._System.nat(), $Heap);
    ##pow#0_1 := pow'#0;
    assume $IsAlloc(##pow#0_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow'#0);
    goto anon3;

  anon8_Else:
    assume {:partition} Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) != LitInt(0);
    goto anon3;

  anon3:
    assume Logarithm.__default.Log#canCall(base#0, pow#0) && (Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0) ==> Logarithm.__default.Log#canCall(base#0, pow'#0));
    assume {:subsumption 0} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
    assume {:subsumption 0} LitInt(0) == Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow'#0);
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0) && LitInt(0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow'#0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(64,51)"} true;
    return;

  anon7_Else:
    assume {:partition} base#0 <= pow'#0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} pow#0 < base#0;
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    ##pow#1_0_0 := pow#0;
    assume $IsAlloc(##pow#1_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    assume Logarithm.__default.Log#canCall(base#0, pow#0);
    assume {:subsumption 0} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, pow#0) == LitInt(0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(66,32)"} true;
    return;

  anon9_Else:
    assume {:partition} base#0 <= pow#0;
    call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(68,28)"} true;
    call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(68,53)"} true;
    call CallPre$$DivMod.__default.LemmaDivIsOrderedAuto();
    call CallPost$$DivMod.__default.LemmaDivIsOrderedAuto();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(68,78)"} true;
    assume true;
    base##1_1_0 := base#0;
    assume base#0 != 0;
    assume true;
    assume $Is(Div(pow#0, base#0), Tclass._System.nat());
    pow##1_1_0 := Div(pow#0, base#0);
    assume base#0 != 0;
    assume true;
    assume $Is(Div(pow'#0, base#0), Tclass._System.nat());
    pow'##1_1_0 := Div(pow'#0, base#0);
    assume 0 <= pow#0 || pow##1_1_0 == pow#0;
    assume pow##1_1_0 < pow#0;
    call CallPre$$Logarithm.__default.LemmaLogIsOrdered(base##1_1_0, pow##1_1_0, pow'##1_1_0);
    call CallPost$$Logarithm.__default.LemmaLogIsOrdered(base##1_1_0, pow##1_1_0, pow'##1_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(69,54)"} true;
    return;
}



procedure {:verboseName "Logarithm.LemmaLogPow (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogPow(base#0: int where LitInt(0) <= base#0, n#0: int where LitInt(0) <= n#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogPow (well-formedness)"} CheckWellFormed$$Logarithm.__default.LemmaLogPow(base#0: int, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b##0: int;
  var e##0: int;
  var ##b#0: int;
  var ##e#0: int;
  var ##base#0: int;
  var ##pow#0: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogPow", " | ", base#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(73,27): initial state"} true;
    assume base#0 > 1;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(75,12): post-state"} true;
    assume true;
    b##0 := base#0;
    assume true;
    e##0 := n#0;
    call CallPre$$Power.__default.LemmaPowPositive(b##0, e##0);
    call CallPost$$Power.__default.LemmaPowPositive(b##0, e##0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(75,37)"} true;
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    ##e#0 := n#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0), Tclass._System.nat());
    ##pow#0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0);
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0)) == n#0;
    return;
}



procedure {:verboseName "Logarithm.LemmaLogPow (call precondtion)"} CallPre$$Logarithm.__default.LemmaLogPow(base#0: int where LitInt(0) <= base#0, n#0: int where LitInt(0) <= n#0);
  requires {:id "id14987"} base#0 > 1;



procedure {:verboseName "Logarithm.LemmaLogPow (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogPow(base#0: int where LitInt(0) <= base#0, n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(base#0, n#0) && Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
  free ensures {:id "id14988"} Lit(true) ==> Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0)) == n#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Logarithm.LemmaLogPow (correctness)"} Impl$$Logarithm.__default.LemmaLogPow(base#0: int where LitInt(0) <= base#0, n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id14989"} base#0 > 1;
  modifies $Heap;
  free ensures Power.__default.Pow#canCall(base#0, n#0) && Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
  free ensures {:id "id14990"} Lit(true) ==> Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0)) == n#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Logarithm.LemmaLogPow (correctness)"} Impl$$Logarithm.__default.LemmaLogPow(base#0: int, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b##1_0: int;
  var e##1_0: int;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##base#1_0_0_0: int;
  var ##pow#1_0_0_0: int;
  var base##1_0_0_0: int;
  var n##1_0_0_0: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##base#1_0_1_0: int;
  var ##pow#1_0_1_0: int;
  var x##1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var d##1_0_1_0: int;
  var ##b#1_0_1_2: int;
  var ##e#1_0_1_2: int;
  var ##base#1_0_1_1: int;
  var ##pow#1_0_1_1: int;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##base#1_0_2_0: int;
  var ##pow#1_0_2_0: int;
  var b##1_0_2_0: int;
  var e##1_0_2_0: int;
  var x##1_0_2_0: int;
  var ##b#1_0_2_1: int;
  var ##e#1_0_2_1: int;
  var y##1_0_2_0: int;
  var x##1_0_2_1: int;
  var ##b#1_0_2_2: int;
  var ##e#1_0_2_2: int;
  var y##1_0_2_1: int;
  var base##1_0_2_0: int;
  var pow##1_0_2_0: int;
  var ##b#1_0_2_3: int;
  var ##e#1_0_2_3: int;
  var ##b#1_0_2_4: int;
  var ##e#1_0_2_4: int;
  var ##base#1_0_2_1: int;
  var ##pow#1_0_2_1: int;
  var ##b#1_0_3_0: int;
  var ##e#1_0_3_0: int;
  var ##base#1_0_3_0: int;
  var ##pow#1_0_3_0: int;
  var ##b#1_0_3_1: int;
  var ##e#1_0_3_1: int;
  var ##base#1_0_3_1: int;
  var ##pow#1_0_3_1: int;
  var ##b#1_0_0: int;
  var ##e#1_0_0: int;
  var ##base#1_0_0: int;
  var ##pow#1_0_0: int;

  anon0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogPow", " | ", base#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(76,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} n#0 == LitInt(0);
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(78,17)"} true;
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(79,17)"} true;
    return;

  anon9_Else:
    assume {:partition} n#0 != LitInt(0);
    assume true;
    b##1_0 := base#0;
    assume true;
    e##1_0 := n#0;
    call CallPre$$Power.__default.LemmaPowPositive(b##1_0, e##1_0);
    call CallPost$$Power.__default.LemmaPowPositive(b##1_0, e##1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(81,31)"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##b#1_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0, TInt, $Heap);
    ##e#1_0_0 := n#0;
    assume $IsAlloc(##e#1_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0);
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0), Tclass._System.nat());
    ##pow#1_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0);
    assume $IsAlloc(##pow#1_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
    assume Power.__default.Pow#canCall(base#0, n#0) && Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##b#1_0_3_0 := base#0;
    assume $IsAlloc(##b#1_0_3_0, TInt, $Heap);
    ##e#1_0_3_0 := n#0;
    assume $IsAlloc(##e#1_0_3_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0);
    ##base#1_0_3_0 := base#0;
    assume $IsAlloc(##base#1_0_3_0, Tclass._System.nat(), $Heap);
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0), Tclass._System.nat());
    ##pow#1_0_3_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0);
    assume $IsAlloc(##pow#1_0_3_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_3_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
    assume Power.__default.Pow#canCall(base#0, n#0) && Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0));
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(84,21)"} true;
    ##b#1_0_3_1 := base#0;
    assume $IsAlloc(##b#1_0_3_1, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_3_1 := n#0 - 1;
    assume $IsAlloc(##e#1_0_3_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    ##base#1_0_3_1 := base#0;
    assume $IsAlloc(##base#1_0_3_1, Tclass._System.nat(), $Heap);
    assume $Is(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), Tclass._System.nat());
    ##pow#1_0_3_1 := Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume $IsAlloc(##pow#1_0_3_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_3_1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)));
    assume Power.__default.Pow#canCall(base#0, n#0 - 1) && Logarithm.__default.Log#canCall(base#0, Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)));
    assume {:subsumption 0} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0)) == Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Mul(base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0 - 1)));
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##b#1_0_2_0 := base#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_2_0 := n#0 - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    ##base#1_0_2_0 := base#0;
    assume $IsAlloc(##base#1_0_2_0, Tclass._System.nat(), $Heap);
    assume $Is(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), Tclass._System.nat());
    ##pow#1_0_2_0 := Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume $IsAlloc(##pow#1_0_2_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_2_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)));
    assume Power.__default.Pow#canCall(base#0, n#0 - 1) && Logarithm.__default.Log#canCall(base#0, Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)));
    assume true;
    b##1_0_2_0 := base#0;
    assume true;
    assume $Is(n#0 - 1, Tclass._System.nat());
    e##1_0_2_0 := n#0 - 1;
    call CallPre$$Power.__default.LemmaPowPositive(b##1_0_2_0, e##1_0_2_0);
    call CallPost$$Power.__default.LemmaPowPositive(b##1_0_2_0, e##1_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(86,39)"} true;
    ##b#1_0_2_1 := base#0;
    assume $IsAlloc(##b#1_0_2_1, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_2_1 := n#0 - 1;
    assume $IsAlloc(##e#1_0_2_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    x##1_0_2_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1);
    assume true;
    y##1_0_2_0 := base#0;
    call CallPre$$Mul.__default.LemmaMulIncreases(x##1_0_2_0, y##1_0_2_0);
    call CallPost$$Mul.__default.LemmaMulIncreases(x##1_0_2_0, y##1_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(87,51)"} true;
    ##b#1_0_2_2 := base#0;
    assume $IsAlloc(##b#1_0_2_2, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_2_2 := n#0 - 1;
    assume $IsAlloc(##e#1_0_2_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    x##1_0_2_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1);
    assume true;
    y##1_0_2_1 := base#0;
    call CallPre$$Mul.__default.LemmaMulIsCommutative(x##1_0_2_1, y##1_0_2_1);
    call CallPost$$Mul.__default.LemmaMulIsCommutative(x##1_0_2_1, y##1_0_2_1);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(88,55)"} true;
    assume true;
    base##1_0_2_0 := base#0;
    ##b#1_0_2_3 := base#0;
    assume $IsAlloc(##b#1_0_2_3, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_2_3 := n#0 - 1;
    assume $IsAlloc(##e#1_0_2_3, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume $Is(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), Tclass._System.nat());
    pow##1_0_2_0 := Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    call CallPre$$Logarithm.__default.LemmaLogS(base##1_0_2_0, pow##1_0_2_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##1_0_2_0, pow##1_0_2_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(89,50)"} true;
    ##b#1_0_2_4 := base#0;
    assume $IsAlloc(##b#1_0_2_4, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_2_4 := n#0 - 1;
    assume $IsAlloc(##e#1_0_2_4, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume {:subsumption 0} base#0 != 0;
    ##base#1_0_2_1 := base#0;
    assume $IsAlloc(##base#1_0_2_1, Tclass._System.nat(), $Heap);
    assume $Is(Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0), Tclass._System.nat());
    ##pow#1_0_2_1 := Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0);
    assume $IsAlloc(##pow#1_0_2_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_2_1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0));
    assume Power.__default.Pow#canCall(base#0, n#0 - 1) && Logarithm.__default.Log#canCall(base#0, Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0));
    assume {:subsumption 0} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Mul(base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0 - 1))) == 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Div(Mul(base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0));
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##b#1_0_1_0 := base#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_1_0 := n#0 - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume {:subsumption 0} base#0 != 0;
    ##base#1_0_1_0 := base#0;
    assume $IsAlloc(##base#1_0_1_0, Tclass._System.nat(), $Heap);
    assume $Is(Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0), Tclass._System.nat());
    ##pow#1_0_1_0 := Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0);
    assume $IsAlloc(##pow#1_0_1_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_1_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0));
    assume Power.__default.Pow#canCall(base#0, n#0 - 1) && Logarithm.__default.Log#canCall(base#0, Div(Mul(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0));
    ##b#1_0_1_1 := base#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_1_1 := n#0 - 1;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    x##1_0_1_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1);
    assume true;
    d##1_0_1_0 := base#0;
    call CallPre$$DivMod.__default.LemmaDivMultiplesVanish(x##1_0_1_0, d##1_0_1_0);
    call CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x##1_0_1_0, d##1_0_1_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(91,57)"} true;
    ##b#1_0_1_2 := base#0;
    assume $IsAlloc(##b#1_0_1_2, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_1_2 := n#0 - 1;
    assume $IsAlloc(##e#1_0_1_2, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    ##base#1_0_1_1 := base#0;
    assume $IsAlloc(##base#1_0_1_1, Tclass._System.nat(), $Heap);
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1), Tclass._System.nat());
    ##pow#1_0_1_1 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1);
    assume $IsAlloc(##pow#1_0_1_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_1_1 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume Power.__default.Pow#canCall(base#0, n#0 - 1) && Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume {:subsumption 0} 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Div(Mul(base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0 - 1)), base#0)) == 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##b#1_0_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(n#0 - 1, Tclass._System.nat());
    ##e#1_0_0_0 := n#0 - 1;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, n#0 - 1);
    ##base#1_0_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0_0, Tclass._System.nat(), $Heap);
    assume $Is(Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1), Tclass._System.nat());
    ##pow#1_0_0_0 := Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1);
    assume $IsAlloc(##pow#1_0_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#1_0_0_0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume Power.__default.Pow#canCall(base#0, n#0 - 1) && Logarithm.__default.Log#canCall(base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0 - 1));
    assume true;
    base##1_0_0_0 := base#0;
    assume true;
    assume $Is(n#0 - 1, Tclass._System.nat());
    n##1_0_0_0 := n#0 - 1;
    assume 0 <= base#0 || base##1_0_0_0 == base#0;
    assume 0 <= n#0 || base##1_0_0_0 < base#0 || n##1_0_0_0 == n#0;
    assume base##1_0_0_0 < base#0 || (base##1_0_0_0 == base#0 && n##1_0_0_0 < n#0);
    call CallPre$$Logarithm.__default.LemmaLogPow(base##1_0_0_0, n##1_0_0_0);
    call CallPost$$Logarithm.__default.LemmaLogPow(base##1_0_0_0, n##1_0_0_0);
    assume {:captureState "libraries/src/NonlinearArithmetic/Logarithm.dfy(93,34)"} true;
    assume true;
    assume {:subsumption 0} 1 + Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, n#0 - 1)) == 1 + n#0 - 1;
    assume false;
    goto anon8;

  anon14_Else:
    goto anon8;

  anon8:
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, n#0)) == 1 + n#0 - 1;
    return;
}



procedure {:verboseName "Logarithm.reveal_Log (well-formedness)"} {:verify false} CheckWellFormed$$Logarithm.__default.reveal__Log();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Logarithm.reveal_Log (call precondtion)"} {:verify false} CallPre$$Logarithm.__default.reveal__Log();



procedure {:verboseName "Logarithm.reveal_Log (call postcondition)"} {:verify false} CallPost$$Logarithm.__default.reveal__Log();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_Logarithm._default.Log;



axiom MulInternals.__default.MulAuto() <==> (forall x#42: int, y#42: int :: { Mul(x#42, y#42) } Mul(x#42, y#42) == Mul(y#42, x#42)) && (forall x#43: int, y#43: int, z#28: int :: { Mul(x#43 + y#43, z#28) } Mul(x#43 + y#43, z#28) == Mul(x#43, z#28) + Mul(y#43, z#28)) && (forall x#44: int, y#44: int, z#29: int :: { Mul(x#44 - y#44, z#29) } Mul(x#44 - y#44, z#29) == Mul(x#44, z#29) - Mul(y#44, z#29));

axiom MulInternals.__default.MulAuto() <==> (forall x#45: int, y#45: int :: { Mul(x#45, y#45) } Mul(x#45, y#45) == Mul(y#45, x#45)) && (forall x#46: int, y#46: int, z#30: int :: { Mul(x#46 + y#46, z#30) } Mul(x#46 + y#46, z#30) == Mul(x#46, z#30) + Mul(y#46, z#30)) && (forall x#47: int, y#47: int, z#31: int :: { Mul(x#47 - y#47, z#31) } Mul(x#47 - y#47, z#31) == Mul(x#47, z#31) - Mul(y#47, z#31));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#40: int :: { Mod(Mod(x#40, n#0), n#0) } Mod(Mod(x#40, n#0), n#0) == Mod(x#40, n#0)) && (forall x#41: int :: { Mod(x#41, n#0) } LitInt(0) <= x#41 && x#41 < n#0 <==> Mod(x#41, n#0) == x#41) && (forall x#42: int, y#20: int :: { Mod(x#42 + y#20, n#0) } (var z#18 := Mod(x#42, n#0) + Mod(y#20, n#0); (LitInt(0) <= z#18 && z#18 < n#0 && Mod(x#42 + y#20, n#0) == z#18) || (n#0 <= z#18 && z#18 < n#0 + n#0 && Mod(x#42 + y#20, n#0) == z#18 - n#0))) && (forall x#43: int, y#21: int :: { Mod(x#43 - y#21, n#0) } (var z#19 := Mod(x#43, n#0) - Mod(y#21, n#0); (LitInt(0) <= z#19 && z#19 < n#0 && Mod(x#43 - y#21, n#0) == z#19) || (0 - n#0 <= z#19 && z#19 < 0 && Mod(x#43 - y#21, n#0) == z#19 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#44: int :: { Mod(Mod(x#44, n#0), n#0) } Mod(Mod(x#44, LitInt(n#0)), LitInt(n#0)) == Mod(x#44, LitInt(n#0))) && (forall x#45: int :: { Mod(x#45, n#0) } LitInt(0) <= x#45 && x#45 < n#0 <==> Mod(x#45, LitInt(n#0)) == x#45) && (forall x#46: int, y#22: int :: { Mod(x#46 + y#22, n#0) } (var z#20 := Mod(x#46, LitInt(n#0)) + Mod(y#22, LitInt(n#0)); (LitInt(0) <= z#20 && z#20 < n#0 && Mod(x#46 + y#22, LitInt(n#0)) == z#20) || (LitInt(n#0) <= z#20 && z#20 < n#0 + n#0 && Mod(x#46 + y#22, LitInt(n#0)) == z#20 - n#0))) && (forall x#47: int, y#23: int :: { Mod(x#47 - y#23, n#0) } (var z#21 := Mod(x#47, LitInt(n#0)) - Mod(y#23, LitInt(n#0)); (LitInt(0) <= z#21 && z#21 < n#0 && Mod(x#47 - y#23, LitInt(n#0)) == z#21) || (LitInt(0 - n#0) <= z#21 && z#21 < 0 && Mod(x#47 - y#23, LitInt(n#0)) == z#21 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#24: int :: { Div(x#24, n#0) } LitInt(0) <= x#24 && x#24 < n#0 <==> Div(x#24, n#0) == LitInt(0)) && (forall x#25: int, y#16: int :: { Div(x#25 + y#16, n#0) } (var z#14 := Mod(x#25, n#0) + Mod(y#16, n#0); (LitInt(0) <= z#14 && z#14 < n#0 && Div(x#25 + y#16, n#0) == Div(x#25, n#0) + Div(y#16, n#0)) || (n#0 <= z#14 && z#14 < n#0 + n#0 && Div(x#25 + y#16, n#0) == Div(x#25, n#0) + Div(y#16, n#0) + 1))) && (forall x#26: int, y#17: int :: { Div(x#26 - y#17, n#0) } (var z#15 := Mod(x#26, n#0) - Mod(y#17, n#0); (LitInt(0) <= z#15 && z#15 < n#0 && Div(x#26 - y#17, n#0) == Div(x#26, n#0) - Div(y#17, n#0)) || (0 - n#0 <= z#15 && z#15 < 0 && Div(x#26 - y#17, n#0) == Div(x#26, n#0) - Div(y#17, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#27: int :: { Div(x#27, n#0) } LitInt(0) <= x#27 && x#27 < n#0 <==> Div(x#27, LitInt(n#0)) == LitInt(0)) && (forall x#28: int, y#18: int :: { Div(x#28 + y#18, n#0) } (var z#16 := Mod(x#28, LitInt(n#0)) + Mod(y#18, LitInt(n#0)); (LitInt(0) <= z#16 && z#16 < n#0 && Div(x#28 + y#18, LitInt(n#0)) == Div(x#28, LitInt(n#0)) + Div(y#18, LitInt(n#0))) || (LitInt(n#0) <= z#16 && z#16 < n#0 + n#0 && Div(x#28 + y#18, LitInt(n#0)) == Div(x#28, LitInt(n#0)) + Div(y#18, LitInt(n#0)) + 1))) && (forall x#29: int, y#19: int :: { Div(x#29 - y#19, n#0) } (var z#17 := Mod(x#29, LitInt(n#0)) - Mod(y#19, LitInt(n#0)); (LitInt(0) <= z#17 && z#17 < n#0 && Div(x#29 - y#19, LitInt(n#0)) == Div(x#29, LitInt(n#0)) - Div(y#19, LitInt(n#0))) || (LitInt(0 - n#0) <= z#17 && z#17 < 0 && Div(x#29 - y#19, LitInt(n#0)) == Div(x#29, LitInt(n#0)) - Div(y#19, LitInt(n#0)) - 1)))));

axiom (forall $ly: LayerType, b#0: int, e#0: int :: { Power.__default.Pow($LS($ly), true, b#0, e#0) } Power.__default.Pow#canCall(b#0, e#0) || LitInt(0) <= e#0 ==> (e#0 != LitInt(0) ==> Power.__default.Pow#canCall(b#0, e#0 - 1)) && Power.__default.Pow($LS($ly), true, b#0, e#0) == (if e#0 == LitInt(0) then 1 else Mul(b#0, Power.__default.Pow($ly, reveal_Power._default.Pow, b#0, e#0 - 1))));

axiom (forall $ly: LayerType, b#0: int, e#0: int :: {:weight 3} { Power.__default.Pow($LS($ly), true, b#0, LitInt(e#0)) } Power.__default.Pow#canCall(b#0, LitInt(e#0)) || LitInt(0) <= e#0 ==> (LitInt(e#0) != LitInt(0) ==> Power.__default.Pow#canCall(b#0, LitInt(e#0 - 1))) && Power.__default.Pow($LS($ly), true, b#0, LitInt(e#0)) == (if LitInt(e#0) == LitInt(0) then 1 else Mul(b#0, Power.__default.Pow($LS($ly), reveal_Power._default.Pow, b#0, LitInt(e#0 - 1)))));

axiom (forall $ly: LayerType, b#0: int, e#0: int :: {:weight 3} { Power.__default.Pow($LS($ly), true, LitInt(b#0), LitInt(e#0)) } Power.__default.Pow#canCall(LitInt(b#0), LitInt(e#0)) || LitInt(0) <= e#0 ==> (LitInt(e#0) != LitInt(0) ==> Power.__default.Pow#canCall(LitInt(b#0), LitInt(e#0 - 1))) && Power.__default.Pow($LS($ly), true, LitInt(b#0), LitInt(e#0)) == (if LitInt(e#0) == LitInt(0) then 1 else Mul(LitInt(b#0), Power.__default.Pow($LS($ly), reveal_Power._default.Pow, LitInt(b#0), LitInt(e#0 - 1)))));

const unique class.StandardLibraryInterop.__default: ClassName;

const unique class.StandardLibraryInterop.WrappersInterop?: ClassName;

function Tclass.StandardLibraryInterop.WrappersInterop?() : Ty
uses {
axiom Tag(Tclass.StandardLibraryInterop.WrappersInterop?()) == Tagclass.StandardLibraryInterop.WrappersInterop? && TagFamily(Tclass.StandardLibraryInterop.WrappersInterop?()) == tytagFamily$WrappersInterop;
}

const unique Tagclass.StandardLibraryInterop.WrappersInterop?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.StandardLibraryInterop.WrappersInterop?()) } $IsBox(bx, Tclass.StandardLibraryInterop.WrappersInterop?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.StandardLibraryInterop.WrappersInterop?()));

axiom (forall $o: ref :: { $Is($o, Tclass.StandardLibraryInterop.WrappersInterop?()) } $Is($o, Tclass.StandardLibraryInterop.WrappersInterop?()) <==> $o == null || dtype($o) == Tclass.StandardLibraryInterop.WrappersInterop?());

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.StandardLibraryInterop.WrappersInterop?(), $h) } $IsAlloc($o, Tclass.StandardLibraryInterop.WrappersInterop?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function StandardLibraryInterop.WrappersInterop.CreateStringSome(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibraryInterop.WrappersInterop.CreateStringSome(s#0) } StandardLibraryInterop.WrappersInterop.CreateStringSome#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(StandardLibraryInterop.WrappersInterop.CreateStringSome(s#0), Tclass.Wrappers.Option(TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { StandardLibraryInterop.WrappersInterop.CreateStringSome(s#0) } StandardLibraryInterop.WrappersInterop.CreateStringSome#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> StandardLibraryInterop.WrappersInterop.CreateStringSome(s#0) == #Wrappers.Option.Some($Box(s#0)));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { StandardLibraryInterop.WrappersInterop.CreateStringSome(Lit(s#0)) } StandardLibraryInterop.WrappersInterop.CreateStringSome#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> StandardLibraryInterop.WrappersInterop.CreateStringSome(Lit(s#0)) == Lit(#Wrappers.Option.Some($Box(Lit(s#0)))));
}

function StandardLibraryInterop.WrappersInterop.CreateStringSome#canCall(s#0: Seq) : bool;

function StandardLibraryInterop.WrappersInterop.CreateStringSome#requires(Seq) : bool;

axiom (forall s#0: Seq :: { StandardLibraryInterop.WrappersInterop.CreateStringSome#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (StandardLibraryInterop.WrappersInterop.CreateStringSome#requires(s#0) <==> true));

procedure {:verboseName "StandardLibraryInterop.WrappersInterop.CreateStringSome (well-formedness)"} CheckWellformed$$StandardLibraryInterop.WrappersInterop.CreateStringSome(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibraryInterop.WrappersInterop.CreateStringNone() : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateStringNone#canCall() || 0 < $FunctionContextHeight ==> $Is(StandardLibraryInterop.WrappersInterop.CreateStringNone(), Tclass.Wrappers.Option(TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateStringNone#canCall() || 0 < $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateStringNone() == Lit(#Wrappers.Option.None());
axiom 0 <= $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateStringNone#canCall() || 0 < $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateStringNone() == Lit(#Wrappers.Option.None());
}

function StandardLibraryInterop.WrappersInterop.CreateStringNone#canCall() : bool;

function StandardLibraryInterop.WrappersInterop.CreateStringNone#requires() : bool
uses {
axiom StandardLibraryInterop.WrappersInterop.CreateStringNone#requires() <==> true;
}

procedure {:verboseName "StandardLibraryInterop.WrappersInterop.CreateStringNone (well-formedness)"} CheckWellformed$$StandardLibraryInterop.WrappersInterop.CreateStringNone();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibraryInterop.WrappersInterop.CreateBooleanSome(b#0: bool) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: { StandardLibraryInterop.WrappersInterop.CreateBooleanSome(b#0) } StandardLibraryInterop.WrappersInterop.CreateBooleanSome#canCall(b#0) || 0 < $FunctionContextHeight ==> $Is(StandardLibraryInterop.WrappersInterop.CreateBooleanSome(b#0), Tclass.Wrappers.Option(TBool)));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: { StandardLibraryInterop.WrappersInterop.CreateBooleanSome(b#0) } StandardLibraryInterop.WrappersInterop.CreateBooleanSome#canCall(b#0) || 0 < $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanSome(b#0) == #Wrappers.Option.Some($Box(b#0)));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: {:weight 3} { StandardLibraryInterop.WrappersInterop.CreateBooleanSome(Lit(b#0)) } StandardLibraryInterop.WrappersInterop.CreateBooleanSome#canCall(Lit(b#0)) || 0 < $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanSome(Lit(b#0)) == Lit(#Wrappers.Option.Some($Box(Lit(b#0)))));
}

function StandardLibraryInterop.WrappersInterop.CreateBooleanSome#canCall(b#0: bool) : bool;

function StandardLibraryInterop.WrappersInterop.CreateBooleanSome#requires(bool) : bool;

axiom (forall b#0: bool :: { StandardLibraryInterop.WrappersInterop.CreateBooleanSome#requires(b#0) } StandardLibraryInterop.WrappersInterop.CreateBooleanSome#requires(b#0) <==> true);

procedure {:verboseName "StandardLibraryInterop.WrappersInterop.CreateBooleanSome (well-formedness)"} CheckWellformed$$StandardLibraryInterop.WrappersInterop.CreateBooleanSome(b#0: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function StandardLibraryInterop.WrappersInterop.CreateBooleanNone() : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanNone#canCall() || 0 < $FunctionContextHeight ==> $Is(StandardLibraryInterop.WrappersInterop.CreateBooleanNone(), Tclass.Wrappers.Option(TBool));
axiom 0 <= $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanNone#canCall() || 0 < $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanNone() == Lit(#Wrappers.Option.None());
axiom 0 <= $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanNone#canCall() || 0 < $FunctionContextHeight ==> StandardLibraryInterop.WrappersInterop.CreateBooleanNone() == Lit(#Wrappers.Option.None());
}

function StandardLibraryInterop.WrappersInterop.CreateBooleanNone#canCall() : bool;

function StandardLibraryInterop.WrappersInterop.CreateBooleanNone#requires() : bool
uses {
axiom StandardLibraryInterop.WrappersInterop.CreateBooleanNone#requires() <==> true;
}

procedure {:verboseName "StandardLibraryInterop.WrappersInterop.CreateBooleanNone (well-formedness)"} CheckWellformed$$StandardLibraryInterop.WrappersInterop.CreateBooleanNone();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.StandardLibraryInterop.WrappersInterop() : Ty
uses {
axiom Tag(Tclass.StandardLibraryInterop.WrappersInterop()) == Tagclass.StandardLibraryInterop.WrappersInterop && TagFamily(Tclass.StandardLibraryInterop.WrappersInterop()) == tytagFamily$WrappersInterop;
}

const unique Tagclass.StandardLibraryInterop.WrappersInterop: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.StandardLibraryInterop.WrappersInterop()) } $IsBox(bx, Tclass.StandardLibraryInterop.WrappersInterop()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.StandardLibraryInterop.WrappersInterop()));

axiom (forall c#0: ref :: { $Is(c#0, Tclass.StandardLibraryInterop.WrappersInterop()) } $Is(c#0, Tclass.StandardLibraryInterop.WrappersInterop()) <==> $Is(c#0, Tclass.StandardLibraryInterop.WrappersInterop?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.StandardLibraryInterop.WrappersInterop(), $h) } $IsAlloc(c#0, Tclass.StandardLibraryInterop.WrappersInterop(), $h) <==> $IsAlloc(c#0, Tclass.StandardLibraryInterop.WrappersInterop?(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#80 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#80))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#82 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#82)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#120 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#120))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#122 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#122)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#124 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#124)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#120 := Wrappers.Option.value(this); v#120)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#122 := Lit(Wrappers.Option.value(Lit(this))); v#122)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#124 := Lit(Wrappers.Option.value(Lit(this))); v#124)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#80 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#80)) else (var e#80 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#82 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#82))) else (var e#82 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#120 := Wrappers.Result.value(this); s#120) else (var e#120 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#122 := Lit(Wrappers.Result.value(Lit(this))); s#122) else (var e#122 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#124 := Lit(Wrappers.Result.value(Lit(this))); s#124) else (var e#124 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#120 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#120)) else (var e#120 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#120)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#122 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#122))) else (var e#122 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#122)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#124 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#124))) else (var e#124 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#124)))));

const unique tytagFamily$WrappersInterop: TyTagFamily;

const unique class.UUID.__default: ClassName;

function UUID.__default.ToByteArray(s#0: Seq) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UUID.__default.ToByteArray(s#0) } UUID.__default.ToByteArray#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Wrappers.Result.Success_q(UUID.__default.ToByteArray(s#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(UUID.__default.ToByteArray(s#0))): Seq) == LitInt(16)) && (Wrappers.Result.Success_q(UUID.__default.ToByteArray(s#0)) ==> Wrappers.Result.Success_q(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(UUID.__default.ToByteArray(s#0))): Seq)) && Seq#Equal($Unbox(Wrappers.Result.value(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(UUID.__default.ToByteArray(s#0))): Seq))): Seq, s#0)) && $Is(UUID.__default.ToByteArray(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));
}

function UUID.__default.ToByteArray#canCall(s#0: Seq) : bool;

function UUID.__default.ToByteArray#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UUID.__default.ToByteArray#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (UUID.__default.ToByteArray#requires(s#0) <==> true));

procedure {:verboseName "UUID.ToByteArray (well-formedness)"} {:extern} CheckWellformed$$UUID.__default.ToByteArray(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15065"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(16);
  free ensures {:id "id15066"} Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.Success_q(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq));
  free ensures {:id "id15067"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq))): Seq, s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UUID.ToByteArray (well-formedness)"} {:extern} CheckWellformed$$UUID.__default.ToByteArray(s#0: Seq) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##b#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "UUID.ToByteArray", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/UUID.dfy(10,42): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(UUID.__default.ToByteArray(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(16);
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(16);
    goto anon5;

  anon5:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    ##b#0 := $Unbox(Wrappers.Result.value(res#0)): Seq;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0) == LitInt(16);
    assume Seq#Length(##b#0) == LitInt(16);
    assume UUID.__default.FromByteArray#canCall($Unbox(Wrappers.Result.value(res#0)): Seq);
    assume Wrappers.Result.Success_q(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq));
    assume Wrappers.Result.Success_q(res#0);
    ##b#1 := $Unbox(Wrappers.Result.value(res#0)): Seq;
    assume $IsAlloc(##b#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1) == LitInt(16);
    assume Seq#Length(##b#1) == LitInt(16);
    assume UUID.__default.FromByteArray#canCall($Unbox(Wrappers.Result.value(res#0)): Seq);
    assume Wrappers.Result.Success_q(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq));
    assume Seq#Equal($Unbox(Wrappers.Result.value(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq))): Seq, s#0);
    goto anon8;

  anon12_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.Success_q(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq)) && Seq#Equal($Unbox(Wrappers.Result.value(UUID.__default.FromByteArray($Unbox(Wrappers.Result.value(res#0)): Seq))): Seq, s#0);
    goto anon8;

  anon8:
    assume false;
    return;

  anon10_Else:
    assume false;
    return;
}



function UUID.__default.FromByteArray(b#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall b#0: Seq :: { UUID.__default.FromByteArray(b#0) } UUID.__default.FromByteArray#canCall(b#0) || (0 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(16)) ==> $Is(UUID.__default.FromByteArray(b#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
}

function UUID.__default.FromByteArray#canCall(b#0: Seq) : bool;

function UUID.__default.FromByteArray#requires(Seq) : bool;

axiom (forall b#0: Seq :: { UUID.__default.FromByteArray#requires(b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UUID.__default.FromByteArray#requires(b#0) <==> Seq#Length(b#0) == LitInt(16)));

procedure {:verboseName "UUID.FromByteArray (well-formedness)"} {:extern} CheckWellformed$$UUID.__default.FromByteArray(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "UUID.GenerateUUID (well-formedness)"} {:extern} CheckWellFormed$$UUID.__default.GenerateUUID() returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar)), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "UUID.GenerateUUID (well-formedness)"} {:extern} CheckWellFormed$$UUID.__default.GenerateUUID() returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "UUID.GenerateUUID"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/UUID.dfy(22,34): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/UUID.dfy(23,25): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume 0 < Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
    return;

  anon4_Else:
    assume Wrappers.Result.Success_q(res#0) ==> 0 < Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
    return;
}



procedure {:verboseName "UUID.GenerateUUID (call precondtion)"} {:extern} CallPre$$UUID.__default.GenerateUUID();



procedure {:verboseName "UUID.GenerateUUID (call postcondition)"} {:extern} CallPost$$UUID.__default.GenerateUUID() returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15086"} Wrappers.Result.Success_q(res#0) ==> 0 < Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function UUID.__default.CreateBytesSuccess(bytes#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { UUID.__default.CreateBytesSuccess(bytes#0) } UUID.__default.CreateBytesSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> $Is(UUID.__default.CreateBytesSuccess(bytes#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: { UUID.__default.CreateBytesSuccess(bytes#0) } UUID.__default.CreateBytesSuccess#canCall(bytes#0) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> UUID.__default.CreateBytesSuccess(bytes#0) == #Wrappers.Result.Success($Box(bytes#0)));
axiom 0 <= $FunctionContextHeight ==> (forall bytes#0: Seq :: {:weight 3} { UUID.__default.CreateBytesSuccess(Lit(bytes#0)) } UUID.__default.CreateBytesSuccess#canCall(Lit(bytes#0)) || (0 < $FunctionContextHeight && $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8()))) ==> UUID.__default.CreateBytesSuccess(Lit(bytes#0)) == Lit(#Wrappers.Result.Success($Box(Lit(bytes#0)))));
}

function UUID.__default.CreateBytesSuccess#canCall(bytes#0: Seq) : bool;

function UUID.__default.CreateBytesSuccess#requires(Seq) : bool;

axiom (forall bytes#0: Seq :: { UUID.__default.CreateBytesSuccess#requires(bytes#0) } $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) ==> (UUID.__default.CreateBytesSuccess#requires(bytes#0) <==> true));

procedure {:verboseName "UUID.CreateBytesSuccess (well-formedness)"} CheckWellformed$$UUID.__default.CreateBytesSuccess(bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function UUID.__default.CreateBytesFailure(error#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UUID.__default.CreateBytesFailure(error#0) } UUID.__default.CreateBytesFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> $Is(UUID.__default.CreateBytesFailure(error#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UUID.__default.CreateBytesFailure(error#0) } UUID.__default.CreateBytesFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UUID.__default.CreateBytesFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: {:weight 3} { UUID.__default.CreateBytesFailure(Lit(error#0)) } UUID.__default.CreateBytesFailure#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UUID.__default.CreateBytesFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function UUID.__default.CreateBytesFailure#canCall(error#0: Seq) : bool;

function UUID.__default.CreateBytesFailure#requires(Seq) : bool;

axiom (forall error#0: Seq :: { UUID.__default.CreateBytesFailure#requires(error#0) } $Is(error#0, TSeq(TChar)) ==> (UUID.__default.CreateBytesFailure#requires(error#0) <==> true));

procedure {:verboseName "UUID.CreateBytesFailure (well-formedness)"} CheckWellformed$$UUID.__default.CreateBytesFailure(error#0: Seq where $Is(error#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function UUID.__default.CreateStringSuccess(s#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UUID.__default.CreateStringSuccess(s#0) } UUID.__default.CreateStringSuccess#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> $Is(UUID.__default.CreateStringSuccess(s#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { UUID.__default.CreateStringSuccess(s#0) } UUID.__default.CreateStringSuccess#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> UUID.__default.CreateStringSuccess(s#0) == #Wrappers.Result.Success($Box(s#0)));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { UUID.__default.CreateStringSuccess(Lit(s#0)) } UUID.__default.CreateStringSuccess#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> UUID.__default.CreateStringSuccess(Lit(s#0)) == Lit(#Wrappers.Result.Success($Box(Lit(s#0)))));
}

function UUID.__default.CreateStringSuccess#canCall(s#0: Seq) : bool;

function UUID.__default.CreateStringSuccess#requires(Seq) : bool;

axiom (forall s#0: Seq :: { UUID.__default.CreateStringSuccess#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (UUID.__default.CreateStringSuccess#requires(s#0) <==> true));

procedure {:verboseName "UUID.CreateStringSuccess (well-formedness)"} CheckWellformed$$UUID.__default.CreateStringSuccess(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function UUID.__default.CreateStringFailure(error#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UUID.__default.CreateStringFailure(error#0) } UUID.__default.CreateStringFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> $Is(UUID.__default.CreateStringFailure(error#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { UUID.__default.CreateStringFailure(error#0) } UUID.__default.CreateStringFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UUID.__default.CreateStringFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: {:weight 3} { UUID.__default.CreateStringFailure(Lit(error#0)) } UUID.__default.CreateStringFailure#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> UUID.__default.CreateStringFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function UUID.__default.CreateStringFailure#canCall(error#0: Seq) : bool;

function UUID.__default.CreateStringFailure#requires(Seq) : bool;

axiom (forall error#0: Seq :: { UUID.__default.CreateStringFailure#requires(error#0) } $Is(error#0, TSeq(TChar)) ==> (UUID.__default.CreateStringFailure#requires(error#0) <==> true));

procedure {:verboseName "UUID.CreateStringFailure (well-formedness)"} CheckWellformed$$UUID.__default.CreateStringFailure(error#0: Seq where $Is(error#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#84 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#84))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#86 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#86)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#126 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#126))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#128 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#128)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#130 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#130)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#126 := Wrappers.Option.value(this); v#126)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#128 := Lit(Wrappers.Option.value(Lit(this))); v#128)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#130 := Lit(Wrappers.Option.value(Lit(this))); v#130)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#84 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#84)) else (var e#84 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#86 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#86))) else (var e#86 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#126 := Wrappers.Result.value(this); s#126) else (var e#126 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#128 := Lit(Wrappers.Result.value(Lit(this))); s#128) else (var e#128 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#130 := Lit(Wrappers.Result.value(Lit(this))); s#130) else (var e#130 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#126 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#126)) else (var e#126 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#126)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#128 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#128))) else (var e#128 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#128)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#130 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#130))) else (var e#130 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#130)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#26 := Div(x#0, LitInt(256)); (var b1#26 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#26)), $Box(b1#26)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#27 := LitInt(Div(x#0, LitInt(256))); (var b1#27 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#27)), $Box(b1#27))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#26 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#26 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#27 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#27 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#26 := Div(x#0, LitInt(16777216)); (var x0#26 := x#0 - Mul(b0#26, LitInt(16777216)); (var b1#26 := Div(x0#26, LitInt(65536)); (var x1#26 := x0#26 - Mul(b1#26, LitInt(65536)); (var b2#26 := Div(x1#26, LitInt(256)); (var b3#26 := Mod(x1#26, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#26)), $Box(b1#26)), $Box(b2#26)), $Box(b3#26)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#27 := LitInt(Div(x#0, LitInt(16777216))); (var x0#27 := LitInt(x#0 - Mul(b0#27, LitInt(16777216))); (var b1#27 := LitInt(Div(x0#27, LitInt(65536))); (var x1#27 := LitInt(x0#27 - Mul(b1#27, LitInt(65536))); (var b2#27 := LitInt(Div(x1#27, LitInt(256))); (var b3#27 := LitInt(Mod(x1#27, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#27)), $Box(b1#27)), $Box(b2#27)), $Box(b3#27))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#26 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#26 := x0#26 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#26 := x1#26 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#26 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#27 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#27 := x0#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#27 := x1#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#27 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#26 := Div(x#0, LitInt(72057594037927936)); (var x0#26 := x#0 - Mul(b0#26, LitInt(72057594037927936)); (var b1#26 := Div(x0#26, LitInt(281474976710656)); (var x1#26 := x0#26 - Mul(b1#26, LitInt(281474976710656)); (var b2#26 := Div(x1#26, LitInt(1099511627776)); (var x2#26 := x1#26 - Mul(b2#26, LitInt(1099511627776)); (var b3#26 := Div(x2#26, LitInt(4294967296)); (var x3#26 := x2#26 - Mul(b3#26, LitInt(4294967296)); (var b4#26 := Div(x3#26, LitInt(16777216)); (var x4#26 := x3#26 - Mul(b4#26, LitInt(16777216)); (var b5#26 := Div(x4#26, LitInt(65536)); (var x5#26 := x4#26 - Mul(b5#26, LitInt(65536)); (var b6#26 := Div(x5#26, LitInt(256)); (var b7#26 := Mod(x5#26, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#26)), $Box(b1#26)), $Box(b2#26)), $Box(b3#26)), $Box(b4#26)), $Box(b5#26)), $Box(b6#26)), $Box(b7#26)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#27 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#27 := LitInt(x#0 - Mul(b0#27, LitInt(72057594037927936))); (var b1#27 := LitInt(Div(x0#27, LitInt(281474976710656))); (var x1#27 := LitInt(x0#27 - Mul(b1#27, LitInt(281474976710656))); (var b2#27 := LitInt(Div(x1#27, LitInt(1099511627776))); (var x2#27 := LitInt(x1#27 - Mul(b2#27, LitInt(1099511627776))); (var b3#27 := LitInt(Div(x2#27, LitInt(4294967296))); (var x3#27 := LitInt(x2#27 - Mul(b3#27, LitInt(4294967296))); (var b4#27 := LitInt(Div(x3#27, LitInt(16777216))); (var x4#27 := LitInt(x3#27 - Mul(b4#27, LitInt(16777216))); (var b5#27 := LitInt(Div(x4#27, LitInt(65536))); (var x5#27 := LitInt(x4#27 - Mul(b5#27, LitInt(65536))); (var b6#27 := LitInt(Div(x5#27, LitInt(256))); (var b7#27 := LitInt(Mod(x5#27, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#27)), $Box(b1#27)), $Box(b2#27)), $Box(b3#27)), $Box(b4#27)), $Box(b5#27)), $Box(b6#27)), $Box(b7#27))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#26 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#26 := x0#26 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#26 := x1#26 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#26 := x2#26 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#26 := x3#26 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#26 := x4#26 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#26 := x5#26 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#27 := x6#26 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#27)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#27 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#27 := x0#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#27 := x1#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#27 := x2#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#27 := x3#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#27 := x4#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#27 := x5#27 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#28 := x6#27 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#28)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#26 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#26)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#26 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#26)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#26)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#27 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#27)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#27 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#27)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#27)): int)));

const unique class.Time.__default: ClassName;

procedure {:verboseName "Time.GetCurrent (well-formedness)"} {:extern} CheckWellFormed$$Time.__default.GetCurrent() returns (res#0: int where LitInt(-9223372036854775808) <= res#0 && res#0 < 9223372036854775808);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Time.GetCurrent (well-formedness)"} {:extern} CheckWellFormed$$Time.__default.GetCurrent() returns (res#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "Time.GetCurrent"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Time.dfy(26,41): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Time.dfy(29,16): post-state"} true;
    newtype$check#0 := LitInt(0);
    assume LitInt(-9223372036854775808) <= newtype$check#0 && newtype$check#0 < 9223372036854775808;
    assume res#0 >= LitInt(0);
    return;
}



procedure {:verboseName "Time.GetCurrent (call precondtion)"} {:extern} CallPre$$Time.__default.GetCurrent();



procedure {:verboseName "Time.GetCurrent (call postcondition)"} {:extern} CallPost$$Time.__default.GetCurrent() returns (res#0: int where LitInt(-9223372036854775808) <= res#0 && res#0 < 9223372036854775808);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15093"} res#0 >= LitInt(0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Time.GetCurrentMilli (well-formedness)"} {:extern} CheckWellFormed$$Time.__default.GetCurrentMilli() returns (res#0: int where LitInt(-9223372036854775808) <= res#0 && res#0 < 9223372036854775808);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Time.GetCurrentMilli (well-formedness)"} {:extern} CheckWellFormed$$Time.__default.GetCurrentMilli() returns (res#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "Time.GetCurrentMilli"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Time.dfy(34,46): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Time.dfy(37,16): post-state"} true;
    newtype$check#0 := LitInt(0);
    assume LitInt(-9223372036854775808) <= newtype$check#0 && newtype$check#0 < 9223372036854775808;
    assume res#0 >= LitInt(0);
    return;
}



procedure {:verboseName "Time.GetCurrentMilli (call precondtion)"} {:extern} CallPre$$Time.__default.GetCurrentMilli();



procedure {:verboseName "Time.GetCurrentMilli (call postcondition)"} {:extern} CallPost$$Time.__default.GetCurrentMilli() returns (res#0: int where LitInt(-9223372036854775808) <= res#0 && res#0 < 9223372036854775808);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15096"} res#0 >= LitInt(0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Time.GetCurrentTimeStamp (well-formedness)"} {:extern} CheckWellFormed$$Time.__default.GetCurrentTimeStamp() returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar)), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Time.GetCurrentTimeStamp (call precondtion)"} {:extern} CallPre$$Time.__default.GetCurrentTimeStamp();



procedure {:verboseName "Time.GetCurrentTimeStamp (call postcondition)"} {:extern} CallPost$$Time.__default.GetCurrentTimeStamp() returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function Time.__default.FormatMilli(diff#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall diff#0: int :: { Time.__default.FormatMilli(diff#0) } Time.__default.FormatMilli#canCall(diff#0) || (0 < $FunctionContextHeight && LitInt(0) <= diff#0) ==> $Is(Time.__default.FormatMilli(diff#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall diff#0: int :: { Time.__default.FormatMilli(diff#0) } Time.__default.FormatMilli#canCall(diff#0) || (0 < $FunctionContextHeight && LitInt(0) <= diff#0) ==> String.__default.Base10Int2String#canCall(Div(diff#0, LitInt(1000))) && String.__default.Base10Int2String#canCall(Mod(diff#0, LitInt(1000))) && Time.__default.FormatMilli(diff#0) == (var whole#0 := String.__default.Base10Int2String(Div(diff#0, LitInt(1000))); (var frac#0 := String.__default.Base10Int2String(Mod(diff#0, LitInt(1000))); (if Seq#Length(frac#0) == LitInt(1) then Seq#Append(Seq#Append(whole#0, Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46))), $Box(char#FromInt(48))), $Box(char#FromInt(48)))), frac#0) else (if Seq#Length(frac#0) == LitInt(2) then Seq#Append(Seq#Append(whole#0, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46))), $Box(char#FromInt(48)))), frac#0) else Seq#Append(Seq#Append(whole#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46)))), frac#0))))));
axiom 0 <= $FunctionContextHeight ==> (forall diff#0: int :: {:weight 3} { Time.__default.FormatMilli(LitInt(diff#0)) } Time.__default.FormatMilli#canCall(LitInt(diff#0)) || (0 < $FunctionContextHeight && LitInt(0) <= diff#0) ==> String.__default.Base10Int2String#canCall(LitInt(Div(diff#0, LitInt(1000)))) && String.__default.Base10Int2String#canCall(LitInt(Mod(diff#0, LitInt(1000)))) && Time.__default.FormatMilli(LitInt(diff#0)) == (var whole#1 := String.__default.Base10Int2String(LitInt(Div(diff#0, LitInt(1000)))); (var frac#1 := String.__default.Base10Int2String(LitInt(Mod(diff#0, LitInt(1000)))); (if Seq#Length(frac#1) == LitInt(1) then Seq#Append(Seq#Append(whole#1, Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46))), $Box(char#FromInt(48))), $Box(char#FromInt(48)))), frac#1) else (if Seq#Length(frac#1) == LitInt(2) then Seq#Append(Seq#Append(whole#1, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46))), $Box(char#FromInt(48)))), frac#1) else Seq#Append(Seq#Append(whole#1, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46)))), frac#1))))));
}

function Time.__default.FormatMilli#canCall(diff#0: int) : bool;

function Time.__default.FormatMilli#requires(int) : bool;

axiom (forall diff#0: int :: { Time.__default.FormatMilli#requires(diff#0) } LitInt(0) <= diff#0 ==> (Time.__default.FormatMilli#requires(diff#0) <==> true));

procedure {:verboseName "Time.FormatMilli (well-formedness)"} CheckWellformed$$Time.__default.FormatMilli(diff#0: int where LitInt(0) <= diff#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Time.FormatMilli (well-formedness)"} CheckWellformed$$Time.__default.FormatMilli(diff#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var whole#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var frac#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##n#1: int;

  anon0:
    assume {:print "Impl", " | ", "Time.FormatMilli", " | ", diff#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Time.dfy(43,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(Time.__default.FormatMilli(diff#0), TSeq(TChar));
    assume false;
    return;

  anon8_Else:
    havoc whole#Z#0;
    assume $Is(whole#Z#0, TSeq(TChar)) && $IsAlloc(whole#Z#0, TSeq(TChar), $Heap);
    assume LitInt(1000) != 0;
    ##n#0 := Div(diff#0, LitInt(1000));
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume String.__default.Base10Int2String#canCall(Div(diff#0, LitInt(1000)));
    assume let#0#0#0 == String.__default.Base10Int2String(Div(diff#0, LitInt(1000)));
    assume String.__default.Base10Int2String#canCall(Div(diff#0, LitInt(1000)));
    assume $Is(let#0#0#0, TSeq(TChar));
    assume whole#Z#0 == let#0#0#0;
    havoc frac#Z#0;
    assume $Is(frac#Z#0, TSeq(TChar)) && $IsAlloc(frac#Z#0, TSeq(TChar), $Heap);
    assume LitInt(1000) != 0;
    ##n#1 := Mod(diff#0, LitInt(1000));
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume String.__default.Base10Int2String#canCall(Mod(diff#0, LitInt(1000)));
    assume let#1#0#0 == String.__default.Base10Int2String(Mod(diff#0, LitInt(1000)));
    assume String.__default.Base10Int2String#canCall(Mod(diff#0, LitInt(1000)));
    assume $Is(let#1#0#0, TSeq(TChar));
    assume frac#Z#0 == let#1#0#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(frac#Z#0) == LitInt(1);
    assume Time.__default.FormatMilli(diff#0) == Seq#Append(Seq#Append(whole#Z#0, Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46))), $Box(char#FromInt(48))), $Box(char#FromInt(48)))), frac#Z#0);
    assume true;
    assume $Is(Time.__default.FormatMilli(diff#0), TSeq(TChar));
    return;

  anon9_Else:
    assume {:partition} Seq#Length(frac#Z#0) != LitInt(1);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Length(frac#Z#0) == LitInt(2);
    assume Time.__default.FormatMilli(diff#0) == Seq#Append(Seq#Append(whole#Z#0, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46))), $Box(char#FromInt(48)))), frac#Z#0);
    assume true;
    assume $Is(Time.__default.FormatMilli(diff#0), TSeq(TChar));
    return;

  anon10_Else:
    assume {:partition} Seq#Length(frac#Z#0) != LitInt(2);
    assume Time.__default.FormatMilli(diff#0) == Seq#Append(Seq#Append(whole#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(46)))), frac#Z#0);
    assume true;
    assume $Is(Time.__default.FormatMilli(diff#0), TSeq(TChar));
    return;
}



function Time.__default.FormatMilliDiff(start#0: int, end#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall start#0: int, end#0: int :: { Time.__default.FormatMilliDiff(start#0, end#0) } Time.__default.FormatMilliDiff#canCall(start#0, end#0) || (1 < $FunctionContextHeight && LitInt(-9223372036854775808) <= start#0 && start#0 < 9223372036854775808 && LitInt(-9223372036854775808) <= end#0 && end#0 < 9223372036854775808 && start#0 >= LitInt(0) && end#0 >= LitInt(0)) ==> $Is(Time.__default.FormatMilliDiff(start#0, end#0), TSeq(TChar)));
axiom 1 <= $FunctionContextHeight ==> (forall start#0: int, end#0: int :: { Time.__default.FormatMilliDiff(start#0, end#0) } Time.__default.FormatMilliDiff#canCall(start#0, end#0) || (1 < $FunctionContextHeight && LitInt(-9223372036854775808) <= start#0 && start#0 < 9223372036854775808 && LitInt(-9223372036854775808) <= end#0 && end#0 < 9223372036854775808 && start#0 >= LitInt(0) && end#0 >= LitInt(0)) ==> (start#0 <= end#0 ==> Time.__default.FormatMilli#canCall(end#0 - start#0)) && (end#0 < start#0 ==> Time.__default.FormatMilli#canCall(start#0 - end#0)) && Time.__default.FormatMilliDiff(start#0, end#0) == (if start#0 <= end#0 then Time.__default.FormatMilli(end#0 - start#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), Time.__default.FormatMilli(start#0 - end#0))));
axiom 1 <= $FunctionContextHeight ==> (forall start#0: int, end#0: int :: {:weight 3} { Time.__default.FormatMilliDiff(LitInt(start#0), LitInt(end#0)) } Time.__default.FormatMilliDiff#canCall(LitInt(start#0), LitInt(end#0)) || (1 < $FunctionContextHeight && LitInt(-9223372036854775808) <= start#0 && start#0 < 9223372036854775808 && LitInt(-9223372036854775808) <= end#0 && end#0 < 9223372036854775808 && LitInt(start#0) >= LitInt(0) && LitInt(end#0) >= LitInt(0)) ==> (LitInt(start#0) <= LitInt(end#0) ==> Time.__default.FormatMilli#canCall(LitInt(end#0 - start#0))) && (LitInt(end#0) < LitInt(start#0) ==> Time.__default.FormatMilli#canCall(LitInt(start#0 - end#0))) && Time.__default.FormatMilliDiff(LitInt(start#0), LitInt(end#0)) == (if LitInt(start#0) <= LitInt(end#0) then Time.__default.FormatMilli(LitInt(end#0 - start#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), Time.__default.FormatMilli(LitInt(start#0 - end#0)))));
}

function Time.__default.FormatMilliDiff#canCall(start#0: int, end#0: int) : bool;

function Time.__default.FormatMilliDiff#requires(int, int) : bool;

axiom (forall start#0: int, end#0: int :: { Time.__default.FormatMilliDiff#requires(start#0, end#0) } LitInt(-9223372036854775808) <= start#0 && start#0 < 9223372036854775808 && LitInt(-9223372036854775808) <= end#0 && end#0 < 9223372036854775808 ==> (Time.__default.FormatMilliDiff#requires(start#0, end#0) <==> start#0 >= LitInt(0) && end#0 >= LitInt(0)));

procedure {:verboseName "Time.FormatMilliDiff (well-formedness)"} CheckWellformed$$Time.__default.FormatMilliDiff(start#0: int where LitInt(-9223372036854775808) <= start#0 && start#0 < 9223372036854775808, end#0: int where LitInt(-9223372036854775808) <= end#0 && end#0 < 9223372036854775808);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Time.FormatMilliDiff (well-formedness)"} CheckWellformed$$Time.__default.FormatMilliDiff(start#0: int, end#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##diff#0: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var ##diff#1: int;

  anon0:
    assume {:print "Impl", " | ", "Time.FormatMilliDiff", " | ", start#0, " | ", end#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Time.dfy(55,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume LitInt(-9223372036854775808) <= newtype$check#0 && newtype$check#0 < 9223372036854775808;
    assume start#0 >= LitInt(0);
    newtype$check#1 := LitInt(0);
    assume LitInt(-9223372036854775808) <= newtype$check#1 && newtype$check#1 < 9223372036854775808;
    assume end#0 >= LitInt(0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(Time.__default.FormatMilliDiff(start#0, end#0), TSeq(TChar));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} start#0 <= end#0;
    newtype$check#2 := end#0;
    assume LitInt(0) <= newtype$check#2;
    newtype$check#3 := end#0;
    assume LitInt(0) <= newtype$check#3;
    newtype$check#4 := start#0;
    assume LitInt(0) <= newtype$check#4;
    newtype$check#5 := start#0;
    assume LitInt(0) <= newtype$check#5;
    assume $Is(end#0 - start#0, Tclass._System.nat());
    ##diff#0 := end#0 - start#0;
    assume $IsAlloc(##diff#0, Tclass._System.nat(), $Heap);
    assume Time.__default.FormatMilli#canCall(end#0 - start#0);
    assume Time.__default.FormatMilliDiff(start#0, end#0) == Time.__default.FormatMilli(end#0 - start#0);
    assume Time.__default.FormatMilli#canCall(end#0 - start#0);
    assume $Is(Time.__default.FormatMilliDiff(start#0, end#0), TSeq(TChar));
    return;

  anon7_Else:
    assume {:partition} end#0 < start#0;
    newtype$check#6 := start#0;
    assume LitInt(0) <= newtype$check#6;
    newtype$check#7 := start#0;
    assume LitInt(0) <= newtype$check#7;
    newtype$check#8 := end#0;
    assume LitInt(0) <= newtype$check#8;
    newtype$check#9 := end#0;
    assume LitInt(0) <= newtype$check#9;
    assume $Is(start#0 - end#0, Tclass._System.nat());
    ##diff#1 := start#0 - end#0;
    assume $IsAlloc(##diff#1, Tclass._System.nat(), $Heap);
    assume Time.__default.FormatMilli#canCall(start#0 - end#0);
    assume Time.__default.FormatMilliDiff(start#0, end#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), Time.__default.FormatMilli(start#0 - end#0));
    assume Time.__default.FormatMilli#canCall(start#0 - end#0);
    assume $Is(Time.__default.FormatMilliDiff(start#0, end#0), TSeq(TChar));
    return;
}



function Time.__default.CreateGetCurrentTimeStampSuccess(value#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall value#0: Seq :: { Time.__default.CreateGetCurrentTimeStampSuccess(value#0) } Time.__default.CreateGetCurrentTimeStampSuccess#canCall(value#0) || (0 < $FunctionContextHeight && $Is(value#0, TSeq(TChar))) ==> $Is(Time.__default.CreateGetCurrentTimeStampSuccess(value#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall value#0: Seq :: { Time.__default.CreateGetCurrentTimeStampSuccess(value#0) } Time.__default.CreateGetCurrentTimeStampSuccess#canCall(value#0) || (0 < $FunctionContextHeight && $Is(value#0, TSeq(TChar))) ==> Time.__default.CreateGetCurrentTimeStampSuccess(value#0) == #Wrappers.Result.Success($Box(value#0)));
axiom 0 <= $FunctionContextHeight ==> (forall value#0: Seq :: {:weight 3} { Time.__default.CreateGetCurrentTimeStampSuccess(Lit(value#0)) } Time.__default.CreateGetCurrentTimeStampSuccess#canCall(Lit(value#0)) || (0 < $FunctionContextHeight && $Is(value#0, TSeq(TChar))) ==> Time.__default.CreateGetCurrentTimeStampSuccess(Lit(value#0)) == Lit(#Wrappers.Result.Success($Box(Lit(value#0)))));
}

function Time.__default.CreateGetCurrentTimeStampSuccess#canCall(value#0: Seq) : bool;

function Time.__default.CreateGetCurrentTimeStampSuccess#requires(Seq) : bool;

axiom (forall value#0: Seq :: { Time.__default.CreateGetCurrentTimeStampSuccess#requires(value#0) } $Is(value#0, TSeq(TChar)) ==> (Time.__default.CreateGetCurrentTimeStampSuccess#requires(value#0) <==> true));

procedure {:verboseName "Time.CreateGetCurrentTimeStampSuccess (well-formedness)"} CheckWellformed$$Time.__default.CreateGetCurrentTimeStampSuccess(value#0: Seq where $Is(value#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Time.__default.CreateGetCurrentTimeStampFailure(error#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { Time.__default.CreateGetCurrentTimeStampFailure(error#0) } Time.__default.CreateGetCurrentTimeStampFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> $Is(Time.__default.CreateGetCurrentTimeStampFailure(error#0), Tclass.Wrappers.Result(TSeq(TChar), TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: { Time.__default.CreateGetCurrentTimeStampFailure(error#0) } Time.__default.CreateGetCurrentTimeStampFailure#canCall(error#0) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> Time.__default.CreateGetCurrentTimeStampFailure(error#0) == #Wrappers.Result.Failure($Box(error#0)));
axiom 0 <= $FunctionContextHeight ==> (forall error#0: Seq :: {:weight 3} { Time.__default.CreateGetCurrentTimeStampFailure(Lit(error#0)) } Time.__default.CreateGetCurrentTimeStampFailure#canCall(Lit(error#0)) || (0 < $FunctionContextHeight && $Is(error#0, TSeq(TChar))) ==> Time.__default.CreateGetCurrentTimeStampFailure(Lit(error#0)) == Lit(#Wrappers.Result.Failure($Box(Lit(error#0)))));
}

function Time.__default.CreateGetCurrentTimeStampFailure#canCall(error#0: Seq) : bool;

function Time.__default.CreateGetCurrentTimeStampFailure#requires(Seq) : bool;

axiom (forall error#0: Seq :: { Time.__default.CreateGetCurrentTimeStampFailure#requires(error#0) } $Is(error#0, TSeq(TChar)) ==> (Time.__default.CreateGetCurrentTimeStampFailure#requires(error#0) <==> true));

procedure {:verboseName "Time.CreateGetCurrentTimeStampFailure (well-formedness)"} CheckWellformed$$Time.__default.CreateGetCurrentTimeStampFailure(error#0: Seq where $Is(error#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#88 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#88))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#90 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#90)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#132 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#132))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#134 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#134)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#136 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#136)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#132 := Wrappers.Option.value(this); v#132)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#134 := Lit(Wrappers.Option.value(Lit(this))); v#134)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#136 := Lit(Wrappers.Option.value(Lit(this))); v#136)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#88 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#88)) else (var e#88 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#90 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#90))) else (var e#90 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#132 := Wrappers.Result.value(this); s#132) else (var e#132 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#134 := Lit(Wrappers.Result.value(Lit(this))); s#134) else (var e#134 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#136 := Lit(Wrappers.Result.value(Lit(this))); s#136) else (var e#136 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#132 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#132)) else (var e#132 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#132)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#134 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#134))) else (var e#134 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#134)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#136 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#136))) else (var e#136 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#136)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#28 := Div(x#0, LitInt(256)); (var b1#28 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#28)), $Box(b1#28)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#29 := LitInt(Div(x#0, LitInt(256))); (var b1#29 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#29)), $Box(b1#29))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#28 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#28 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#29 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#29 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#28 := Div(x#0, LitInt(16777216)); (var x0#28 := x#0 - Mul(b0#28, LitInt(16777216)); (var b1#28 := Div(x0#28, LitInt(65536)); (var x1#28 := x0#28 - Mul(b1#28, LitInt(65536)); (var b2#28 := Div(x1#28, LitInt(256)); (var b3#28 := Mod(x1#28, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#28)), $Box(b1#28)), $Box(b2#28)), $Box(b3#28)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#29 := LitInt(Div(x#0, LitInt(16777216))); (var x0#29 := LitInt(x#0 - Mul(b0#29, LitInt(16777216))); (var b1#29 := LitInt(Div(x0#29, LitInt(65536))); (var x1#29 := LitInt(x0#29 - Mul(b1#29, LitInt(65536))); (var b2#29 := LitInt(Div(x1#29, LitInt(256))); (var b3#29 := LitInt(Mod(x1#29, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#29)), $Box(b1#29)), $Box(b2#29)), $Box(b3#29))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#28 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#28 := x0#28 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#28 := x1#28 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#28 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#29 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#29 := x0#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#29 := x1#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#29 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#28 := Div(x#0, LitInt(72057594037927936)); (var x0#28 := x#0 - Mul(b0#28, LitInt(72057594037927936)); (var b1#28 := Div(x0#28, LitInt(281474976710656)); (var x1#28 := x0#28 - Mul(b1#28, LitInt(281474976710656)); (var b2#28 := Div(x1#28, LitInt(1099511627776)); (var x2#28 := x1#28 - Mul(b2#28, LitInt(1099511627776)); (var b3#28 := Div(x2#28, LitInt(4294967296)); (var x3#28 := x2#28 - Mul(b3#28, LitInt(4294967296)); (var b4#28 := Div(x3#28, LitInt(16777216)); (var x4#28 := x3#28 - Mul(b4#28, LitInt(16777216)); (var b5#28 := Div(x4#28, LitInt(65536)); (var x5#28 := x4#28 - Mul(b5#28, LitInt(65536)); (var b6#28 := Div(x5#28, LitInt(256)); (var b7#28 := Mod(x5#28, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#28)), $Box(b1#28)), $Box(b2#28)), $Box(b3#28)), $Box(b4#28)), $Box(b5#28)), $Box(b6#28)), $Box(b7#28)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#29 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#29 := LitInt(x#0 - Mul(b0#29, LitInt(72057594037927936))); (var b1#29 := LitInt(Div(x0#29, LitInt(281474976710656))); (var x1#29 := LitInt(x0#29 - Mul(b1#29, LitInt(281474976710656))); (var b2#29 := LitInt(Div(x1#29, LitInt(1099511627776))); (var x2#29 := LitInt(x1#29 - Mul(b2#29, LitInt(1099511627776))); (var b3#29 := LitInt(Div(x2#29, LitInt(4294967296))); (var x3#29 := LitInt(x2#29 - Mul(b3#29, LitInt(4294967296))); (var b4#29 := LitInt(Div(x3#29, LitInt(16777216))); (var x4#29 := LitInt(x3#29 - Mul(b4#29, LitInt(16777216))); (var b5#29 := LitInt(Div(x4#29, LitInt(65536))); (var x5#29 := LitInt(x4#29 - Mul(b5#29, LitInt(65536))); (var b6#29 := LitInt(Div(x5#29, LitInt(256))); (var b7#29 := LitInt(Mod(x5#29, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#29)), $Box(b1#29)), $Box(b2#29)), $Box(b3#29)), $Box(b4#29)), $Box(b5#29)), $Box(b6#29)), $Box(b7#29))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#28 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#28 := x0#28 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#28 := x1#28 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#28 := x2#28 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#28 := x3#28 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#28 := x4#28 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#28 := x5#28 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#29 := x6#28 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#29)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#29 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#29 := x0#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#29 := x1#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#29 := x2#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#29 := x3#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#29 := x4#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#29 := x5#29 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#30 := x6#29 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#30)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#28 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#28)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#28 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#28)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#28)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#29 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#29)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#29 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#29)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#29)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#14: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#14)): Seq } LitInt(0) <= i#14 && i#14 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#14)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#15 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#15) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#15)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#15 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#15) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#15)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#15)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#16 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#16) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#16)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#16 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#16) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#16)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#16)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#17 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#17) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#17)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#17 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#17) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#17)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#17)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#9 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#9)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#9)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#10 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#10)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#10)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#11 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#11)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#11)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#9 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#9) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#9) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#9)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#9) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#9))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#9 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#9) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#9) else (var i#9 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#9)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#9)), $Box(Seq#Drop(s#0, i#9 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#10 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#10) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#10) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#10)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#10) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#10))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#10 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#10) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#10) else (var i#10 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#10)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#10)), $Box(Seq#Drop(Lit(s#0), i#10 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#11 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#11) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#11) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#11)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#11) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#11))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#11 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#11) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#11) else (var i#11 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#11)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#11))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#11 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#x#0: Box :: $Box($l#36#x#0 == c#0)), (lambda $l#36#heap#0: Heap, $l#36#x#0: Box :: $IsBox($l#36#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#36#heap#0: Heap, $l#36#x#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#x#0: Box :: $Box($l#34#x#0 == c#0)), (lambda $l#34#heap#0: Heap, $l#34#x#0: Box :: $IsBox($l#34#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#34#heap#0: Heap, $l#34#x#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#x#0: Box :: $Box($l#39#x#0 == c#0)), (lambda $l#39#heap#0: Heap, $l#39#x#0: Box :: $IsBox($l#39#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#39#heap#0: Heap, $l#39#x#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#x#0: Box :: $Box($l#37#x#0 == c#0)), (lambda $l#37#heap#0: Heap, $l#37#x#0: Box :: $IsBox($l#37#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#37#heap#0: Heap, $l#37#x#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#x#0: Box :: $Box($l#42#x#0 == Lit(c#0))), (lambda $l#42#heap#0: Heap, $l#42#x#0: Box :: $IsBox($l#42#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#42#heap#0: Heap, $l#42#x#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#x#0: Box :: $Box($l#40#x#0 == Lit(c#0))), (lambda $l#40#heap#0: Heap, $l#40#x#0: Box :: $IsBox($l#40#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#40#heap#0: Heap, $l#40#x#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#10: int :: { Seq#Index(s#0, j#10) } i#0 <= j#10 && j#10 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#10))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#11: int :: { Seq#Index(s#0, j#11) } i#0 <= j#11 && j#11 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#11))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#10: int :: { Seq#Index(s#0, i#10) } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#10))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#10))) && (forall i#11: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#11) } (LitInt(0) <= i#11 && i#11 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#11))) && (LitInt(0) <= i#11 && i#11 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#11))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#5: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#5) } LitInt(0) <= i#5 && i#5 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#5) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#_v0#0: Box :: value#0), (lambda $l#22#heap#0: Heap, $l#22#_v0#0: Box :: $IsBox($l#22#_v0#0, TInt)), (lambda $l#22#heap#0: Heap, $l#22#_v0#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#_v0#0: Box :: value#0), (lambda $l#24#heap#0: Heap, $l#24#_v0#0: Box :: $IsBox($l#24#_v0#0, TInt)), (lambda $l#24#heap#0: Heap, $l#24#_v0#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#_v0#0: Box :: Lit(value#0)), (lambda $l#26#heap#0: Heap, $l#26#_v0#0: Box :: $IsBox($l#26#_v0#0, TInt)), (lambda $l#26#heap#0: Heap, $l#26#_v0#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#11: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#11) } LitInt(0) <= k#11 ==> k#11 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#11)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#11: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#11) } LitInt(0) <= k#11 && k#11 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#11))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#12: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#12) } LitInt(0) <= k#12 ==> k#12 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#12)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#12: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#12) } LitInt(0) <= k#12 && k#12 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#12))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#13: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#13) } LitInt(0) <= k#13 ==> k#13 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#13)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#13: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#13) } LitInt(0) <= k#13 && k#13 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#13))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#11: int :: { Seq#Index(b#0, i#11) } { Seq#Index(a#0, i#11) } LitInt(0) <= i#11 && i#11 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#11) == Seq#Index(b#0, i#11)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#12: int :: { Seq#Index(b#0, i#12) } { Seq#Index(a#0, i#12) } LitInt(0) <= i#12 && i#12 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#12) == Seq#Index(Lit(b#0), i#12)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#13: int :: { Seq#Index(b#0, i#13) } { Seq#Index(a#0, i#13) } LitInt(0) <= i#13 && i#13 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#13) == Seq#Index(Lit(b#0), i#13)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#24: Box, y#24: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#24, x#24)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#24, y#24)): bool } $IsBox(x#24, StandardLibrary._default.Trichotomous$T) && $IsBox(y#24, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#24, y#24)): bool || x#24 == y#24 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#24, x#24)): bool) && (forall x#25: Box, y#25: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#25, x#25)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#25, y#25)): bool } $IsBox(x#25, StandardLibrary._default.Trichotomous$T) && $IsBox(y#25, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#25, y#25)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#25, x#25)): bool ==> false) && (forall x#26: Box, y#26: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#26, y#26)): bool } $IsBox(x#26, StandardLibrary._default.Trichotomous$T) && $IsBox(y#26, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#26, y#26)): bool ==> x#26 != y#26)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#27: Box, y#27: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#27, x#27)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#27, y#27)): bool } $IsBox(x#27, StandardLibrary._default.Trichotomous$T) && $IsBox(y#27, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#27, y#27)): bool || x#27 == y#27 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#27, x#27)): bool) && (forall x#28: Box, y#28: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#28, x#28)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#28, y#28)): bool } $IsBox(x#28, StandardLibrary._default.Trichotomous$T) && $IsBox(y#28, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#28, y#28)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#28, x#28)): bool ==> false) && (forall x#29: Box, y#29: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#29, y#29)): bool } $IsBox(x#29, StandardLibrary._default.Trichotomous$T) && $IsBox(y#29, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#29, y#29)): bool ==> x#29 != y#29)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#8: Box, y#8: Box, z#8: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#8, z#8)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#8, z#8)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#8, z#8)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#8, y#8)): bool } $IsBox(x#8, StandardLibrary._default.Transitive$T) && $IsBox(y#8, StandardLibrary._default.Transitive$T) && $IsBox(z#8, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#8, y#8)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#8, z#8)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#8, z#8)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#9: Box, y#9: Box, z#9: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#9, z#9)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#9, z#9)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#9, z#9)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#9, y#9)): bool } $IsBox(x#9, StandardLibrary._default.Transitive$T) && $IsBox(y#9, StandardLibrary._default.Transitive$T) && $IsBox(z#9, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#9, y#9)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#9, z#9)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#9, z#9)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#15: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#15)): Seq } LitInt(0) <= i#15 && i#15 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#15)]) && (forall k#5: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#5)) } { s#0[$Box(k#5)] } $Is(k#5, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#5)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#5))) && (forall i#16: int, _t#0#4: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#16)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#4)): Seq } _t#0#4 == i#16 - 1 ==> 0 < i#16 && i#16 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#4)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#16)): Seq, less#0)) && (forall i#17: int, j#5: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#5)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#17)): Seq } LitInt(0) <= i#17 && i#17 < j#5 && j#5 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#17)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#5)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#14 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#14)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#14))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#15 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#15)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#15))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#16 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#16)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#16))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#11: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#11, less#0) } { s#0[$Box(z#11)] } $Is(z#11, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#11)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#11, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#11: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#11, less#0) } { s#0[$Box(z#11)] } $Is(z#11, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#11)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#11, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#12: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#12, less#0) } { s#0[$Box(z#12)] } $Is(z#12, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#12)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#12, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#12: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#12, less#0) } { s#0[$Box(z#12)] } $Is(z#12, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#12)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#12, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#13: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#13, less#0) } { s#0[$Box(z#13)] } $Is(z#13, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#13)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#13, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#13: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#13, less#0) } { s#0[$Box(z#13)] } $Is(z#13, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#13)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#13, Lit(less#0)))));

const unique class.Streams.__default: ClassName;

const unique class.Streams.SeqReader?: ClassName;

function Tclass.Streams.SeqReader?(Ty) : Ty;

const unique Tagclass.Streams.SeqReader?: TyTag;

axiom (forall Streams.SeqReader$T: Ty :: { Tclass.Streams.SeqReader?(Streams.SeqReader$T) } Tag(Tclass.Streams.SeqReader?(Streams.SeqReader$T)) == Tagclass.Streams.SeqReader? && TagFamily(Tclass.Streams.SeqReader?(Streams.SeqReader$T)) == tytagFamily$SeqReader);

function Tclass.Streams.SeqReader?_0(Ty) : Ty;

axiom (forall Streams.SeqReader$T: Ty :: { Tclass.Streams.SeqReader?(Streams.SeqReader$T) } Tclass.Streams.SeqReader?_0(Tclass.Streams.SeqReader?(Streams.SeqReader$T)) == Streams.SeqReader$T);

axiom (forall Streams.SeqReader$T: Ty, bx: Box :: { $IsBox(bx, Tclass.Streams.SeqReader?(Streams.SeqReader$T)) } $IsBox(bx, Tclass.Streams.SeqReader?(Streams.SeqReader$T)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.SeqReader?(Streams.SeqReader$T)));

axiom (forall Streams.SeqReader$T: Ty, $o: ref :: { $Is($o, Tclass.Streams.SeqReader?(Streams.SeqReader$T)) } $Is($o, Tclass.Streams.SeqReader?(Streams.SeqReader$T)) <==> $o == null || dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T));

axiom (forall Streams.SeqReader$T: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Streams.SeqReader?(Streams.SeqReader$T), $h) } $IsAlloc($o, Tclass.Streams.SeqReader?(Streams.SeqReader$T), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

const Streams.SeqReader.Repr: Field
uses {
axiom FDim(Streams.SeqReader.Repr) == 0 && FieldOfDecl(class.Streams.SeqReader?, field$Repr) == Streams.SeqReader.Repr && $IsGhostField(Streams.SeqReader.Repr);
}

axiom (forall Streams.SeqReader$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqReader.Repr)): Set, Tclass.Streams.SeqReader?(Streams.SeqReader$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T) ==> $Is($Unbox(read($h, $o, Streams.SeqReader.Repr)): Set, TSet(Tclass._System.object())));

axiom (forall Streams.SeqReader$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqReader.Repr)): Set, Tclass.Streams.SeqReader?(Streams.SeqReader$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, Streams.SeqReader.Repr)): Set, TSet(Tclass._System.object()), $h));

function Streams.SeqReader.data(Streams.SeqReader$T: Ty, this: ref) : Seq
uses {
axiom 0 < $FunctionContextHeight ==> (forall Streams.SeqReader$T: Ty, $o: ref :: { Streams.SeqReader.data(Streams.SeqReader$T, $o) } $o != null && dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T) ==> $Is(Streams.SeqReader.data(Streams.SeqReader$T, $o), TSeq(Streams.SeqReader$T)));
axiom 0 < $FunctionContextHeight ==> (forall Streams.SeqReader$T: Ty, $h: Heap, $o: ref :: { Streams.SeqReader.data(Streams.SeqReader$T, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(Streams.SeqReader.data(Streams.SeqReader$T, $o), TSeq(Streams.SeqReader$T), $h));
}

const Streams.SeqReader.pos: Field
uses {
axiom FDim(Streams.SeqReader.pos) == 0 && FieldOfDecl(class.Streams.SeqReader?, field$pos) == Streams.SeqReader.pos && !$IsGhostField(Streams.SeqReader.pos);
}

axiom (forall Streams.SeqReader$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqReader.pos)): int, Tclass.Streams.SeqReader?(Streams.SeqReader$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T) ==> $Is($Unbox(read($h, $o, Streams.SeqReader.pos)): int, Tclass._System.nat()));

axiom (forall Streams.SeqReader$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqReader.pos)): int, Tclass.Streams.SeqReader?(Streams.SeqReader$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqReader?(Streams.SeqReader$T) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, Streams.SeqReader.pos)): int, Tclass._System.nat(), $h));

function Streams.SeqReader.Valid(Streams.SeqReader$T: Ty, $heap: Heap, this: ref) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Streams.SeqReader$T: Ty, $Heap: Heap, this: ref :: { Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) } Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap)) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) ==> ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)]);
axiom 1 <= $FunctionContextHeight ==> (forall Streams.SeqReader$T: Ty, $Heap: Heap, this: ref :: { Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this), $IsGoodHeap($Heap) } Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap)) ==> (Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) <==> ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this))));
}

function Streams.SeqReader.Valid#canCall(Streams.SeqReader$T: Ty, $heap: Heap, this: ref) : bool;

function Tclass.Streams.SeqReader(Ty) : Ty;

const unique Tagclass.Streams.SeqReader: TyTag;

axiom (forall Streams.SeqReader$T: Ty :: { Tclass.Streams.SeqReader(Streams.SeqReader$T) } Tag(Tclass.Streams.SeqReader(Streams.SeqReader$T)) == Tagclass.Streams.SeqReader && TagFamily(Tclass.Streams.SeqReader(Streams.SeqReader$T)) == tytagFamily$SeqReader);

function Tclass.Streams.SeqReader_0(Ty) : Ty;

axiom (forall Streams.SeqReader$T: Ty :: { Tclass.Streams.SeqReader(Streams.SeqReader$T) } Tclass.Streams.SeqReader_0(Tclass.Streams.SeqReader(Streams.SeqReader$T)) == Streams.SeqReader$T);

axiom (forall Streams.SeqReader$T: Ty, bx: Box :: { $IsBox(bx, Tclass.Streams.SeqReader(Streams.SeqReader$T)) } $IsBox(bx, Tclass.Streams.SeqReader(Streams.SeqReader$T)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.SeqReader(Streams.SeqReader$T)));

axiom (forall Streams.SeqReader$T: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Streams.SeqReader.Valid(Streams.SeqReader$T, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || ($Unbox(read($h0, this, Streams.SeqReader.Repr)): Set)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Streams.SeqReader.Valid(Streams.SeqReader$T, $h0, this) <==> Streams.SeqReader.Valid(Streams.SeqReader$T, $h1, this)));

function Streams.SeqReader.Valid#requires(Ty, Heap, ref) : bool;

axiom (forall Streams.SeqReader$T: Ty, $Heap: Heap, this: ref :: { Streams.SeqReader.Valid#requires(Streams.SeqReader$T, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap) ==> (Streams.SeqReader.Valid#requires(Streams.SeqReader$T, $Heap, this) <==> true));

procedure {:verboseName "Streams.SeqReader.Valid (well-formedness)"} CheckWellformed$$Streams.SeqReader.Valid(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15129"} Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) ==> ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqReader.Valid (well-formedness)"} CheckWellformed$$Streams.SeqReader.Valid(Streams.SeqReader$T: Ty, this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqReader.Valid", " | ", Streams.SeqReader$T, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(15,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)]);
    b$reqreads#0 := $_ReadsFrame[this, Streams.SeqReader.Repr];
    assume b$reqreads#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqReader?(Streams.SeqReader$T), $Heap);
    assume this == this || (Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))) && !Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))));
    assume this == this || Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this);
    assume ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
    goto anon5;

  anon10_Else:
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) ==> ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
    goto anon5;

  anon5:
    assume false;
    return;

  anon9_Else:
    b$reqreads#1 := $_ReadsFrame[this, Streams.SeqReader.Repr];
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
    b$reqreads#2 := $_ReadsFrame[this, Streams.SeqReader.pos];
    goto anon8;

  anon11_Else:
    assume {:partition} !($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
    goto anon8;

  anon8:
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) <==> ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
    assume true;
    assume $Is(Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this), TBool);
    assume b$reqreads#1;
    assume b$reqreads#2;
    return;
}



procedure {:verboseName "Streams.SeqReader._ctor (well-formedness)"} CheckWellFormed$$Streams.SeqReader.__ctor(Streams.SeqReader$T: Ty, s#0: Seq where $Is(s#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(s#0, TSeq(Streams.SeqReader$T), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Streams.SeqReader._ctor (call precondtion)"} CallPre$$Streams.SeqReader.__ctor(Streams.SeqReader$T: Ty, s#0: Seq where $Is(s#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(s#0, TSeq(Streams.SeqReader$T), $Heap));



procedure {:verboseName "Streams.SeqReader._ctor (call postcondition)"} CallPost$$Streams.SeqReader.__ctor(Streams.SeqReader$T: Ty, s#0: Seq where $Is(s#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(s#0, TSeq(Streams.SeqReader$T), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15142"} $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == LitInt(0);
  free ensures true;
  free ensures {:id "id15143"} Seq#Equal(Streams.SeqReader.data(Streams.SeqReader$T, this), s#0);
  free ensures Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
  free ensures {:id "id15144"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) && Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  free ensures {:id "id15145"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.SeqReader._ctor (correctness)"} Impl$$Streams.SeqReader.__ctor(Streams.SeqReader$T: Ty, s#0: Seq where $Is(s#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(s#0, TSeq(Streams.SeqReader$T), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15146"} $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == LitInt(0);
  free ensures true;
  free ensures {:id "id15147"} Seq#Equal(Streams.SeqReader.data(Streams.SeqReader$T, this), s#0);
  free ensures Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
  free ensures {:id "id15148"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15149"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  free ensures {:id "id15150"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqReader._ctor (correctness)"} Impl$$Streams.SeqReader.__ctor(Streams.SeqReader$T: Ty, s#0: Seq) returns (this: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var this.Repr: Set;
  var this.data: Seq;
  var this.pos: int;
  var defass#this.Repr: bool;
  var defass#this.data: bool;
  var defass#this.pos: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqReader._ctor", " | ", Streams.SeqReader$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(27,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    this.data := s#0;
    defass#this.data := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(28,15)"} true;
    assume true;
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    this.pos := LitInt(0);
    defass#this.pos := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(29,14)"} true;
    assume true;
    assume true;
    this.Repr := Set#UnionOne(Set#Empty(): Set, $Box(this));
    defass#this.Repr := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(30,20)"} true;
    assume defass#this.Repr;
    assume defass#this.data;
    assume defass#this.pos;
    assume !$Unbox(read($Heap, this, alloc)): bool;
    assume $Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set == this.Repr;
    assume Streams.SeqReader.data(Streams.SeqReader$T, this) == this.data;
    assume $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == this.pos;
    $Heap := update($Heap, this, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    return;
}



procedure {:verboseName "Streams.SeqReader.ReadElements (well-formedness)"} CheckWellFormed$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0) returns (elems#0: Seq where $Is(elems#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqReader$T), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqReader.ReadElements (well-formedness)"} CheckWellFormed$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref, n#0: int) returns (elems#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqReader.ReadElements", " | ", Streams.SeqReader$T, " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(33,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqReader?(Streams.SeqReader$T), $Heap);
    assume Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this);
    assume n#0 + $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc elems#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(37,21): post-state"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume n#0 == LitInt(0);
    assume Seq#Equal(elems#0, Seq#Empty(): Seq);
    goto anon4;

  anon8_Else:
    assume n#0 == LitInt(0) ==> Seq#Equal(elems#0, Seq#Empty(): Seq);
    goto anon4;

  anon4:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume n#0 > 0;
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
    assume 0 <= n#0 && n#0 <= Seq#Length(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int));
    assume Seq#Equal(elems#0, Seq#Take(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int), n#0));
    goto anon7;

  anon9_Else:
    assume n#0 > 0 ==> Seq#Equal(elems#0, Seq#Take(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int), n#0));
    goto anon7;

  anon7:
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqReader?(Streams.SeqReader$T), $Heap);
    assume Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this);
    return;
}



procedure {:verboseName "Streams.SeqReader.ReadElements (call precondtion)"} CallPre$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id15173"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15174"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  requires {:id "id15175"} n#0 + $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));



procedure {:verboseName "Streams.SeqReader.ReadElements (call postcondition)"} CallPost$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0) returns (elems#0: Seq where $Is(elems#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqReader$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15176"} n#0 == LitInt(0) ==> Seq#Equal(elems#0, Seq#Empty(): Seq);
  free ensures true;
  free ensures {:id "id15177"} n#0 > 0 ==> Seq#Equal(elems#0, Seq#Take(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int), n#0));
  free ensures true;
  free ensures {:id "id15178"} $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
  free ensures Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
  free ensures {:id "id15179"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) && Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.SeqReader.ReadElements (correctness)"} Impl$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0) returns (defass#elems#0: bool, elems#0: Seq where defass#elems#0 ==> $Is(elems#0, TSeq(Streams.SeqReader$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqReader$T), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id15180"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) && Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  requires {:id "id15181"} n#0 + $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15182"} n#0 == LitInt(0) ==> Seq#Equal(elems#0, Seq#Empty(): Seq);
  free ensures true;
  free ensures {:id "id15183"} n#0 > 0 ==> Seq#Equal(elems#0, Seq#Take(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int), n#0));
  free ensures true;
  free ensures {:id "id15184"} $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
  free ensures Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
  free ensures {:id "id15185"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15186"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqReader.ReadElements (correctness)"} Impl$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref, n#0: int) returns (defass#elems#0: bool, elems#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs#0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqReader.ReadElements", " | ", Streams.SeqReader$T, " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(41,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume 0 <= $Unbox(read($Heap, this, Streams.SeqReader.pos)): int && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
    assume 0 <= n#0 && n#0 <= Seq#Length(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read($Heap, this, Streams.SeqReader.pos)): int));
    assume true;
    elems#0 := Seq#Take(Seq#Drop(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read($Heap, this, Streams.SeqReader.pos)): int), n#0);
    defass#elems#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(42,31)"} true;
    assume true;
    assume $_ModifiesFrame[this, Streams.SeqReader.pos];
    assume true;
    assume $Is($Unbox(read($Heap, this, Streams.SeqReader.pos)): int + n#0, Tclass._System.nat());
    $rhs#0 := $Unbox(read($Heap, this, Streams.SeqReader.pos)): int + n#0;
    $Heap := update($Heap, this, Streams.SeqReader.pos, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "StandardLibrary/src/Streams.dfy(43,20)"} true;
    assume true;
    assume defass#elems#0;
    assume true;
    elems#0 := elems#0;
    defass#elems#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(44,18)"} true;
    assume defass#elems#0;
    return;
}



procedure {:verboseName "Streams.SeqReader.ReadExact (well-formedness)"} CheckWellFormed$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Streams.SeqReader$T), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Streams.SeqReader$T), TSeq(TChar)), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqReader.ReadExact (well-formedness)"} CheckWellFormed$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref, n#0: int) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqReader.ReadExact", " | ", Streams.SeqReader$T, " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(47,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqReader?(Streams.SeqReader$T), $Heap);
    assume Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this);
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(50,37): post-state"} true;
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume n#0 + $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) <==> Wrappers.Result.Success_q(res#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
    goto anon4;

  anon17_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
    goto anon4;

  anon4:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
    goto anon7;

  anon18_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
    goto anon7;

  anon7:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int <= $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0 && $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0 <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
    assume Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int));
    goto anon10;

  anon19_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int));
    goto anon10;

  anon10:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume n#0 > Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) - $Unbox(read($Heap, this, Streams.SeqReader.pos)): int;
    goto anon13;

  anon20_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> n#0 > Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) - $Unbox(read($Heap, this, Streams.SeqReader.pos)): int;
    goto anon13;

  anon13:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), old($Heap));
    assume $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int;
    goto anon16;

  anon21_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int;
    goto anon16;

  anon16:
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqReader?(Streams.SeqReader$T), $Heap);
    assume Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
    assume Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this);
    return;
}



procedure {:verboseName "Streams.SeqReader.ReadExact (call precondtion)"} CallPre$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id15226"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15227"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));



procedure {:verboseName "Streams.SeqReader.ReadExact (call postcondition)"} CallPost$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Streams.SeqReader$T), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Streams.SeqReader$T), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15228"} n#0 + $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) <==> Wrappers.Result.Success_q(res#0);
  free ensures true;
  free ensures {:id "id15229"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
  free ensures true;
  free ensures {:id "id15230"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
  free ensures true;
  free ensures {:id "id15231"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int));
  free ensures true;
  free ensures {:id "id15232"} Wrappers.Result.Failure_q(res#0) ==> n#0 > Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) - $Unbox(read($Heap, this, Streams.SeqReader.pos)): int;
  free ensures true;
  free ensures {:id "id15233"} Wrappers.Result.Failure_q(res#0) ==> $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int;
  free ensures Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
  free ensures {:id "id15234"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) && Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.SeqReader.ReadExact (correctness)"} Impl$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqReader(Streams.SeqReader$T)) && $IsAlloc(this, Tclass.Streams.SeqReader(Streams.SeqReader$T), $Heap), n#0: int where LitInt(0) <= n#0) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(Streams.SeqReader$T), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Streams.SeqReader$T), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15235"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) && Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)] && $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15236"} n#0 + $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) <==> Wrappers.Result.Success_q(res#0);
  free ensures true;
  free ensures {:id "id15237"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
  free ensures true;
  free ensures {:id "id15238"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0;
  free ensures true;
  free ensures {:id "id15239"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Streams.SeqReader$T, this), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int));
  free ensures true;
  free ensures {:id "id15240"} Wrappers.Result.Failure_q(res#0) ==> n#0 > Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) - $Unbox(read($Heap, this, Streams.SeqReader.pos)): int;
  free ensures true;
  free ensures {:id "id15241"} Wrappers.Result.Failure_q(res#0) ==> $Unbox(read($Heap, this, Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), this, Streams.SeqReader.pos)): int;
  free ensures Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this);
  free ensures {:id "id15242"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15243"} Streams.SeqReader.Valid#canCall(Streams.SeqReader$T, $Heap, this) ==> Streams.SeqReader.Valid(Streams.SeqReader$T, $Heap, this) || $Unbox(read($Heap, this, Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqReader.ReadExact (correctness)"} Impl$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref, n#0: int) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var elements#1_0: Seq where $Is(elements#1_0, TSeq(Streams.SeqReader$T)) && $IsAlloc(elements#1_0, TSeq(Streams.SeqReader$T), $Heap);
  var $rhs##1_0: Seq;
  var n##1_0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqReader.ReadExact", " | ", Streams.SeqReader$T, " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(57,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} n#0 > Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) - $Unbox(read($Heap, this, Streams.SeqReader.pos)): int;
    assume true;
    assume true;
    res#0 := Lit(#Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(79))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(103))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(102))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(46)))))));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(59,71)"} true;
    assume defass#res#0;
    return;

  anon4_Else:
    assume {:partition} Seq#Length(Streams.SeqReader.data(Streams.SeqReader$T, this)) - $Unbox(read($Heap, this, Streams.SeqReader.pos)): int >= n#0;
    assume true;
    assume true;
    assume true;
    n##1_0 := n#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this && $f == Streams.SeqReader.pos ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqReader.ReadElements(Streams.SeqReader$T, this, n##1_0);
    call $rhs##1_0 := CallPost$$Streams.SeqReader.ReadElements(Streams.SeqReader$T, this, n##1_0);
    elements#1_0 := $rhs##1_0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(61,39)"} true;
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(elements#1_0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(62,32)"} true;
    assume defass#res#0;
    return;
}



axiom (forall Streams.SeqReader$T: Ty, c#0: ref :: { $Is(c#0, Tclass.Streams.SeqReader(Streams.SeqReader$T)) } $Is(c#0, Tclass.Streams.SeqReader(Streams.SeqReader$T)) <==> $Is(c#0, Tclass.Streams.SeqReader?(Streams.SeqReader$T)) && c#0 != null);

axiom (forall Streams.SeqReader$T: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Streams.SeqReader(Streams.SeqReader$T), $h) } $IsAlloc(c#0, Tclass.Streams.SeqReader(Streams.SeqReader$T), $h) <==> $IsAlloc(c#0, Tclass.Streams.SeqReader?(Streams.SeqReader$T), $h));

const unique class.Streams.ByteReader?: ClassName;

function Tclass.Streams.ByteReader?() : Ty
uses {
axiom Tag(Tclass.Streams.ByteReader?()) == Tagclass.Streams.ByteReader? && TagFamily(Tclass.Streams.ByteReader?()) == tytagFamily$ByteReader;
}

const unique Tagclass.Streams.ByteReader?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Streams.ByteReader?()) } $IsBox(bx, Tclass.Streams.ByteReader?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.ByteReader?()));

axiom (forall $o: ref :: { $Is($o, Tclass.Streams.ByteReader?()) } $Is($o, Tclass.Streams.ByteReader?()) <==> $o == null || dtype($o) == Tclass.Streams.ByteReader?());

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Streams.ByteReader?(), $h) } $IsAlloc($o, Tclass.Streams.ByteReader?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

const Streams.ByteReader.Repr: Field
uses {
axiom FDim(Streams.ByteReader.Repr) == 0 && FieldOfDecl(class.Streams.ByteReader?, field$Repr) == Streams.ByteReader.Repr && $IsGhostField(Streams.ByteReader.Repr);
}

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.ByteReader.Repr)): Set } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.ByteReader?() ==> $Is($Unbox(read($h, $o, Streams.ByteReader.Repr)): Set, TSet(Tclass._System.object())));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.ByteReader.Repr)): Set } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.ByteReader?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, Streams.ByteReader.Repr)): Set, TSet(Tclass._System.object()), $h));

function Streams.ByteReader.reader(this: ref) : ref
uses {
axiom 1 < $FunctionContextHeight ==> (forall $o: ref :: { Streams.ByteReader.reader($o) } $o != null && dtype($o) == Tclass.Streams.ByteReader?() ==> $Is(Streams.ByteReader.reader($o), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8())));
axiom 1 < $FunctionContextHeight ==> (forall $h: Heap, $o: ref :: { Streams.ByteReader.reader($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.ByteReader?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(Streams.ByteReader.reader($o), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), $h));
}

function Streams.ByteReader.Valid($heap: Heap, this: ref) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteReader.Valid($Heap, this) } Streams.ByteReader.Valid#canCall($Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) ==> Streams.ByteReader.Valid($Heap, this) ==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)]);
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteReader.Valid($Heap, this), $IsGoodHeap($Heap) } Streams.ByteReader.Valid#canCall($Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) ==> (($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] ==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] ==> Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) ==> !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] ==> Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this))) && (Streams.ByteReader.Valid($Heap, this) <==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this))));
}

function Streams.ByteReader.Valid#canCall($heap: Heap, this: ref) : bool;

function Tclass.Streams.ByteReader() : Ty
uses {
axiom Tag(Tclass.Streams.ByteReader()) == Tagclass.Streams.ByteReader && TagFamily(Tclass.Streams.ByteReader()) == tytagFamily$ByteReader;
}

const unique Tagclass.Streams.ByteReader: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Streams.ByteReader()) } $IsBox(bx, Tclass.Streams.ByteReader()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.ByteReader()));

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Streams.ByteReader.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || ($Unbox(read($h0, this, Streams.ByteReader.Repr)): Set)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Streams.ByteReader.Valid($h0, this) <==> Streams.ByteReader.Valid($h1, this)));

function Streams.ByteReader.Valid#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { Streams.ByteReader.Valid#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap) ==> (Streams.ByteReader.Valid#requires($Heap, this) <==> true));

procedure {:verboseName "Streams.ByteReader.Valid (well-formedness)"} CheckWellformed$$Streams.ByteReader.Valid(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15253"} Streams.ByteReader.Valid($Heap, this) ==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.Valid (well-formedness)"} CheckWellformed$$Streams.ByteReader.Valid(this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.Valid", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(71,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)]);
    b$reqreads#0 := $_ReadsFrame[this, Streams.ByteReader.Repr];
    assume b$reqreads#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume this == this || (Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))) && !Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))));
    assume this == this || Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
    goto anon5;

  anon16_Else:
    assume Streams.ByteReader.Valid($Heap, this) ==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
    goto anon5;

  anon5:
    assume false;
    return;

  anon15_Else:
    b$reqreads#1 := $_ReadsFrame[this, Streams.ByteReader.Repr];
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
    b$reqreads#2 := $_ReadsFrame[this, Streams.ByteReader.Repr];
    goto anon8;

  anon17_Else:
    assume {:partition} !($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
    goto anon8;

  anon8:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
    assume Streams.ByteReader.reader(this) != null;
    b$reqreads#3 := $_ReadsFrame[Streams.ByteReader.reader(this), Streams.SeqReader.Repr];
    b$reqreads#4 := $_ReadsFrame[this, Streams.ByteReader.Repr];
    goto anon10;

  anon18_Else:
    assume {:partition} !(($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
    goto anon10;

  anon10:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
    assume Streams.ByteReader.reader(this) != null;
    b$reqreads#5 := $_ReadsFrame[Streams.ByteReader.reader(this), Streams.SeqReader.Repr];
    goto anon12;

  anon19_Else:
    assume {:partition} !(($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set));
    goto anon12;

  anon12:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAllocBox($Box(Streams.ByteReader.reader(this)), Tclass.Streams.SeqReader?(Tclass.BoundedInts.uint8()), $Heap);
    b$reqreads#6 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ($o == Streams.ByteReader.reader(this) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box($o)]) ==> $_ReadsFrame[$o, $f]);
    assume Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
    goto anon14;

  anon20_Else:
    assume {:partition} !(($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)]);
    goto anon14;

  anon14:
    assume Streams.ByteReader.Valid($Heap, this) <==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
    assume ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] ==> ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] ==> Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) ==> !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] ==> Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
    assume $Is(Streams.ByteReader.Valid($Heap, this), TBool);
    assume b$reqreads#1;
    assume b$reqreads#2;
    assume b$reqreads#3;
    assume b$reqreads#4;
    assume b$reqreads#5;
    assume b$reqreads#6;
    return;
}



procedure {:verboseName "Streams.ByteReader._ctor (well-formedness)"} CheckWellFormed$$Streams.ByteReader.__ctor(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader._ctor (well-formedness)"} CheckWellFormed$$Streams.ByteReader.__ctor(s#0: Seq) returns (this: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader._ctor", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(79,4): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc this;
    assume {:captureState "StandardLibrary/src/Streams.dfy(80,26): post-state"} true;
    assume Streams.ByteReader.reader(this) != null;
    assume Seq#Equal(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), s#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
    return;
}



procedure {:verboseName "Streams.ByteReader._ctor (call precondtion)"} CallPre$$Streams.ByteReader.__ctor(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "Streams.ByteReader._ctor (call postcondition)"} CallPost$$Streams.ByteReader.__ctor(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15275"} Seq#Equal(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), s#0);
  free ensures true;
  free ensures {:id "id15276"} $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0);
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15277"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures {:id "id15278"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader._ctor (correctness)"} Impl$$Streams.ByteReader.__ctor(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15279"} Seq#Equal(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), s#0);
  free ensures true;
  free ensures {:id "id15280"} $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0);
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15281"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15282"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15283"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15284"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15285"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15286"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures {:id "id15287"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader._ctor (correctness)"} Impl$$Streams.ByteReader.__ctor(s#0: Seq) returns (this: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var this.Repr: Set;
  var this.reader: ref;
  var defass#this.Repr: bool;
  var defass#this.reader: bool;
  var defass#mr#0: bool;
  var mr#0: ref where defass#mr#0 ==> $Is(mr#0, Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8())) && $IsAlloc(mr#0, Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), $Heap);
  var $nw: ref;
  var s##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader._ctor", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(83,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    s##0 := s#0;
    call CallPre$$Streams.SeqReader.__ctor(Tclass.BoundedInts.uint8(), s##0);
    call $nw := CallPost$$Streams.SeqReader.__ctor(Tclass.BoundedInts.uint8(), s##0);
    assume {:captureState "StandardLibrary/src/Streams.dfy(84,39)"} true;
    mr#0 := $nw;
    defass#mr#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(84,39)"} true;
    assume true;
    assume defass#mr#0;
    assume true;
    this.reader := mr#0;
    defass#this.reader := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(85,18)"} true;
    assume true;
    assume defass#mr#0;
    assume mr#0 != null;
    assume true;
    this.Repr := Set#Union(Set#UnionOne(Set#Empty(): Set, $Box(this)), $Unbox(read($Heap, mr#0, Streams.SeqReader.Repr)): Set);
    defass#this.Repr := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(86,30)"} true;
    assume defass#this.Repr;
    assume defass#this.reader;
    assume !$Unbox(read($Heap, this, alloc)): bool;
    assume $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set == this.Repr;
    assume Streams.ByteReader.reader(this) == this.reader;
    $Heap := update($Heap, this, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadByte (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint8(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint8(), TSeq(TChar)), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadByte (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadByte(this: ref) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadByte", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(89,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume Streams.ByteReader.reader(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(92,27): post-state"} true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    assume Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 1;
    goto anon4;

  anon14_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 1;
    goto anon4;

  anon4:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon15_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon7:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1;
    goto anon10;

  anon16_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1;
    goto anon10;

  anon10:
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume $Unbox(Wrappers.Result.value(res#0)): int == $Unbox(Seq#Index(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int)): int;
    goto anon13;

  anon17_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == $Unbox(Seq#Index(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int)): int;
    goto anon13;

  anon13:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadByte (call precondtion)"} CallPre$$Streams.ByteReader.ReadByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  requires {:id "id15331"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15332"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15333"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15334"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15335"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15336"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.ReadByte (call postcondition)"} CallPost$$Streams.ByteReader.ReadByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint8(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint8(), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15337"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 1;
  free ensures true;
  free ensures {:id "id15338"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15339"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1;
  free ensures true;
  free ensures {:id "id15340"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures true;
  free ensures {:id "id15341"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == $Unbox(Seq#Index(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int)): int;
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15342"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.ReadByte (correctness)"} Impl$$Streams.ByteReader.ReadByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint8(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint8(), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  free requires {:id "id15343"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15344"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 1;
  free ensures true;
  free ensures {:id "id15345"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15346"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1;
  free ensures true;
  free ensures {:id "id15347"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 1 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures true;
  free ensures {:id "id15348"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == $Unbox(Seq#Index(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int)): int;
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15349"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15350"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15351"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15352"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15353"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15354"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadByte (correctness)"} Impl$$Streams.ByteReader.ReadByte(this: ref) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
  var $rhs##0: DatatypeType;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadByte", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(98,4): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap) */;
    assume true;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    assume $Is(LitInt(1), Tclass._System.nat());
    n##0 := LitInt(1);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    call $rhs##0 := CallPost$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(99,38)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint8(), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint8(), valueOrError0#0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint8(), valueOrError0#0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(99,38)"} true;
    assume defass#res#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    bytes#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0)): Seq;
    assume {:captureState "StandardLibrary/src/Streams.dfy(99,38)"} true;
    assume true;
    assume Seq#Length(bytes#0) == LitInt(1);
    assume {:captureState "StandardLibrary/src/Streams.dfy(100,25)"} true;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(bytes#0);
    assume true;
    res#0 := #Wrappers.Result.Success(Seq#Index(bytes#0, LitInt(0)));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(101,30)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadBytes (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap), n#0: int where LitInt(0) <= n#0) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadBytes (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadBytes(this: ref, n#0: int) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadBytes", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(104,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume Streams.ByteReader.reader(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(107,27): post-state"} true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    assume Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < n#0;
    goto anon4;

  anon20_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < n#0;
    goto anon4;

  anon4:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon21_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon7:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
    goto anon10;

  anon22_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
    goto anon10;

  anon10:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(0);
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon13;

  anon23_Else:
    assume Wrappers.Result.Success_q(res#0) && Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon13;

  anon13:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0;
    goto anon16;

  anon24_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0;
    goto anon16;

  anon16:
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0 && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    goto anon19;

  anon25_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    goto anon19;

  anon19:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadBytes (call precondtion)"} CallPre$$Streams.ByteReader.ReadBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id15421"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15422"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15423"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15424"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15425"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15426"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.ReadBytes (call postcondition)"} CallPost$$Streams.ByteReader.ReadBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap), n#0: int where LitInt(0) <= n#0) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15427"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < n#0;
  free ensures true;
  free ensures {:id "id15428"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15429"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
  free ensures true;
  free ensures {:id "id15430"} Wrappers.Result.Success_q(res#0) && Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15431"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0;
  free ensures true;
  free ensures {:id "id15432"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures true;
  free ensures {:id "id15433"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15434"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.ReadBytes (correctness)"} Impl$$Streams.ByteReader.ReadBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap), n#0: int where LitInt(0) <= n#0) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  free requires {:id "id15435"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15436"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < n#0;
  free ensures true;
  free ensures {:id "id15437"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15438"} Wrappers.Result.Success_q(res#0) ==> Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == n#0;
  free ensures true;
  free ensures {:id "id15439"} Wrappers.Result.Success_q(res#0) && Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) == LitInt(0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15440"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0;
  free ensures true;
  free ensures {:id "id15441"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures true;
  free ensures {:id "id15442"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + n#0), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15443"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15444"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15445"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15446"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15447"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15448"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadBytes (correctness)"} Impl$$Streams.ByteReader.ReadBytes(this: ref, n#0: int) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
  var $rhs##0: DatatypeType;
  var n##0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadBytes", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(115,4): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap) */;
    assume true;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    n##0 := n#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    call $rhs##0 := CallPost$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(116,38)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(116,38)"} true;
    assume defass#res#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    bytes#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0)): Seq;
    assume {:captureState "StandardLibrary/src/Streams.dfy(116,38)"} true;
    assume true;
    assume Seq#Length(bytes#0) == n#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(117,25)"} true;
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(bytes#0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(118,27)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadUInt16 (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint16(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint16(), TSeq(TChar)), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadUInt16 (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadUInt16(this: ref) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt16", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(121,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume Streams.ByteReader.reader(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(124,27): post-state"} true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    assume Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 2;
    goto anon4;

  anon14_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 2;
    goto anon4;

  anon4:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon15_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon7:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2;
    goto anon10;

  anon16_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2;
    goto anon10;

  anon10:
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2 && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    ##s#0 := Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(2);
    assume Seq#Length(##s#0) == LitInt(2);
    assume StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    assume $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt16(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    goto anon13;

  anon17_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt16(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    goto anon13;

  anon13:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadUInt16 (call precondtion)"} CallPre$$Streams.ByteReader.ReadUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  requires {:id "id15504"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15505"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15506"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15507"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15508"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15509"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.ReadUInt16 (call postcondition)"} CallPost$$Streams.ByteReader.ReadUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint16(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint16(), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15510"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 2;
  free ensures true;
  free ensures {:id "id15511"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15512"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2;
  free ensures true;
  free ensures {:id "id15513"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures Wrappers.Result.Success_q(res#0) ==> StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures {:id "id15514"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt16(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15515"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.ReadUInt16 (correctness)"} Impl$$Streams.ByteReader.ReadUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint16(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint16(), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  free requires {:id "id15516"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15517"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 2;
  free ensures true;
  free ensures {:id "id15518"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15519"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2;
  free ensures true;
  free ensures {:id "id15520"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures Wrappers.Result.Success_q(res#0) ==> StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures {:id "id15521"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt16(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 2), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15522"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15523"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15524"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15525"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15526"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15527"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadUInt16 (correctness)"} Impl$$Streams.ByteReader.ReadUInt16(this: ref) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
  var $rhs##0: DatatypeType;
  var n##0: int;
  var n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__16();
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt16", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(130,4): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap) */;
    assume true;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    assume $Is(LitInt(2), Tclass._System.nat());
    n##0 := LitInt(2);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    call $rhs##0 := CallPost$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(131,38)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint16(), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint16(), valueOrError0#0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint16(), valueOrError0#0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(131,38)"} true;
    assume defass#res#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    bytes#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0)): Seq;
    assume {:captureState "StandardLibrary/src/Streams.dfy(131,38)"} true;
    assume true;
    assume Seq#Length(bytes#0) == LitInt(2);
    assume {:captureState "StandardLibrary/src/Streams.dfy(132,25)"} true;
    assume true;
    ##s#1 := bytes#0;
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(2);
    assume Seq#Length(##s#1) == LitInt(2);
    assume StandardLibrary_mUInt.__default.SeqToUInt16#canCall(bytes#0);
    assume StandardLibrary_mUInt.__default.SeqToUInt16#canCall(bytes#0);
    n#0 := StandardLibrary_mUInt.__default.SeqToUInt16(bytes#0);
    assume {:captureState "StandardLibrary/src/Streams.dfy(133,33)"} true;
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(n#0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(134,23)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadUInt32 (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), TSeq(TChar)), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadUInt32 (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadUInt32(this: ref) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt32", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(137,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume Streams.ByteReader.reader(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(140,19): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon4;

  anon7_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon4;

  anon4:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 4;
    assume Wrappers.Result.Success_q(res#0);
    ##x#0 := $Unbox(Wrappers.Result.value(res#0)): int;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall($Unbox(Wrappers.Result.value(res#0)): int);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume Streams.ByteReader.reader(this) != null;
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int && $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq($Unbox(Wrappers.Result.value(res#0)): int), Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    return;

  anon8_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 4 && Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq($Unbox(Wrappers.Result.value(res#0)): int), Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadUInt32 (call precondtion)"} CallPre$$Streams.ByteReader.ReadUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  requires {:id "id15571"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15572"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15573"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15574"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15575"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15576"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.ReadUInt32 (call postcondition)"} CallPost$$Streams.ByteReader.ReadUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15577"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures true;
  free ensures {:id "id15578"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 4 ==> StandardLibrary_mUInt.__default.UInt32ToSeq#canCall($Unbox(Wrappers.Result.value(res#0)): int);
  free ensures {:id "id15579"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 4;
  free ensures {:id "id15580"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq($Unbox(Wrappers.Result.value(res#0)): int), Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.ReadUInt32 (correctness)"} Impl$$Streams.ByteReader.ReadUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  free requires {:id "id15581"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15582"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15583"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15584"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15585"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15586"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15587"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures true;
  free ensures {:id "id15588"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 4 ==> StandardLibrary_mUInt.__default.UInt32ToSeq#canCall($Unbox(Wrappers.Result.value(res#0)): int);
  free ensures {:id "id15589"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 4;
  free ensures {:id "id15590"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal(StandardLibrary_mUInt.__default.UInt32ToSeq($Unbox(Wrappers.Result.value(res#0)): int), Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadUInt32 (correctness)"} Impl$$Streams.ByteReader.ReadUInt32(this: ref) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
  var $rhs##0: DatatypeType;
  var n##0: int;
  var n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32();
  var ##s#0: Seq;
  var s##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt32", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(145,4): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap) */;
    assume true;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    assume $Is(LitInt(4), Tclass._System.nat());
    n##0 := LitInt(4);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    call $rhs##0 := CallPost$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(146,38)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint32(), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint32(), valueOrError0#0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint32(), valueOrError0#0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(146,38)"} true;
    assume defass#res#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    bytes#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0)): Seq;
    assume {:captureState "StandardLibrary/src/Streams.dfy(146,38)"} true;
    assume true;
    assume Seq#Length(bytes#0) == LitInt(4);
    assume {:captureState "StandardLibrary/src/Streams.dfy(147,25)"} true;
    assume true;
    ##s#0 := bytes#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume StandardLibrary_mUInt.__default.SeqToUInt32#canCall(bytes#0);
    assume StandardLibrary_mUInt.__default.SeqToUInt32#canCall(bytes#0);
    n#0 := StandardLibrary_mUInt.__default.SeqToUInt32(bytes#0);
    assume {:captureState "StandardLibrary/src/Streams.dfy(148,33)"} true;
    assume true;
    s##0 := bytes#0;
    call CallPre$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s##0);
    call CallPost$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s##0);
    assume {:captureState "StandardLibrary/src/Streams.dfy(149,42)"} true;
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(n#0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(150,23)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadUInt64 (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadUInt64(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint64(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint64(), TSeq(TChar)), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadUInt64 (well-formedness)"} CheckWellFormed$$Streams.ByteReader.ReadUInt64(this: ref) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt64", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(153,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    assume Streams.ByteReader.reader(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(156,27): post-state"} true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    assume Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 8;
    goto anon4;

  anon14_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 8;
    goto anon4;

  anon4:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Failure_q(res#0);
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon15_Else:
    assume Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon7;

  anon7:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8;
    goto anon10;

  anon16_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8;
    goto anon10;

  anon10:
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume 0 <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    assume $IsAlloc(this, Tclass.Streams.ByteReader(), old($Heap));
    assume Streams.ByteReader.reader(this) != null;
    assume $IsAlloc(Streams.ByteReader.reader(this), Tclass.Streams.SeqReader(Tclass.BoundedInts.uint8()), old($Heap));
    assume $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8 && $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)));
    ##s#0 := Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(8);
    assume Seq#Length(##s#0) == LitInt(8);
    assume StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    assume $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt64(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    goto anon13;

  anon17_Else:
    assume Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt64(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
    goto anon13;

  anon13:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteReader.ReadUInt64 (call precondtion)"} CallPre$$Streams.ByteReader.ReadUInt64(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  requires {:id "id15651"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15652"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15653"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15654"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15655"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15656"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.ReadUInt64 (call postcondition)"} CallPost$$Streams.ByteReader.ReadUInt64(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint64(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint64(), TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15657"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 8;
  free ensures true;
  free ensures {:id "id15658"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15659"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8;
  free ensures true;
  free ensures {:id "id15660"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures Wrappers.Result.Success_q(res#0) ==> StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures {:id "id15661"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt64(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15662"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.ReadUInt64 (correctness)"} Impl$$Streams.ByteReader.ReadUInt64(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint64(), TSeq(TChar))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint64(), TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  free requires {:id "id15663"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15664"} Wrappers.Result.Failure_q(res#0) ==> Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int < 8;
  free ensures true;
  free ensures {:id "id15665"} Wrappers.Result.Failure_q(res#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == Streams.ByteReader.reader(this) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id15666"} Wrappers.Result.Success_q(res#0) ==> $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8;
  free ensures true;
  free ensures {:id "id15667"} $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8 <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) <==> Wrappers.Result.Success_q(res#0);
  free ensures Wrappers.Result.Success_q(res#0) ==> StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures {:id "id15668"} Wrappers.Result.Success_q(res#0) ==> $Unbox(Wrappers.Result.value(res#0)): int == StandardLibrary_mUInt.__default.SeqToUInt64(Seq#Drop(Seq#Take(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this)), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int + 8), $Unbox(read(old($Heap), Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int));
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15669"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15670"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15671"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15672"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15673"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15674"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteReader.reader(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.ReadUInt64 (correctness)"} Impl$$Streams.ByteReader.ReadUInt64(this: ref) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var bytes#0: Seq where $Is(bytes#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bytes#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
  var $rhs##0: DatatypeType;
  var n##0: int;
  var n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__64();
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt64", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos);
    assume {:captureState "StandardLibrary/src/Streams.dfy(162,4): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap) */;
    assume true;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    assume $Is(LitInt(8), Tclass._System.nat());
    n##0 := LitInt(8);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteReader.reader(this) && $f == Streams.SeqReader.pos ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    call $rhs##0 := CallPost$$Streams.SeqReader.ReadExact(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this), n##0);
    valueOrError0#0 := $rhs##0;
    defass#valueOrError0#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(163,38)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint64(), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint64(), valueOrError0#0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), Tclass.BoundedInts.uint64(), valueOrError0#0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(163,38)"} true;
    assume defass#res#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0);
    bytes#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar), valueOrError0#0)): Seq;
    assume {:captureState "StandardLibrary/src/Streams.dfy(163,38)"} true;
    assume true;
    assume Seq#Length(bytes#0) == LitInt(8);
    assume {:captureState "StandardLibrary/src/Streams.dfy(164,25)"} true;
    assume true;
    ##s#1 := bytes#0;
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(8);
    assume Seq#Length(##s#1) == LitInt(8);
    assume StandardLibrary_mUInt.__default.SeqToUInt64#canCall(bytes#0);
    assume StandardLibrary_mUInt.__default.SeqToUInt64#canCall(bytes#0);
    n#0 := StandardLibrary_mUInt.__default.SeqToUInt64(bytes#0);
    assume {:captureState "StandardLibrary/src/Streams.dfy(165,33)"} true;
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(n#0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(166,23)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Streams.ByteReader.IsDoneReading (well-formedness)"} CheckWellFormed$$Streams.ByteReader.IsDoneReading(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (b#0: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.IsDoneReading (well-formedness)"} CheckWellFormed$$Streams.ByteReader.IsDoneReading(this: ref) returns (b#0: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.IsDoneReading", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(169,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(171,53): post-state"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} b#0;
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    goto anon4;

  anon10_Else:
    assume {:partition} !b#0;
    goto anon4;

  anon4:
    assume b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0);
    goto anon8;

  anon9_Else:
    assume !(b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} !b#0;
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    goto anon7;

  anon11_Else:
    assume {:partition} b#0;
    goto anon7;

  anon7:
    assume !b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int > 0;
    goto anon8;

  anon8:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteReader.IsDoneReading (call precondtion)"} CallPre$$Streams.ByteReader.IsDoneReading(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  requires {:id "id15704"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15705"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15706"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15707"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15708"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15709"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.IsDoneReading (call postcondition)"} CallPost$$Streams.ByteReader.IsDoneReading(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (b#0: bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15710"} (b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0)) || (!b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int > 0);
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15711"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.IsDoneReading (correctness)"} Impl$$Streams.ByteReader.IsDoneReading(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (defass#b#0: bool, b#0: bool, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15712"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15713"} (b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int == LitInt(0)) || (!b#0 && Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) - $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int > 0);
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15714"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15715"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15716"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15717"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15718"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15719"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.IsDoneReading (correctness)"} Impl$$Streams.ByteReader.IsDoneReading(this: ref) returns (defass#b#0: bool, b#0: bool, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.IsDoneReading", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(173,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    b#0 := Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))) == $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int;
    defass#b#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(174,40)"} true;
    assume defass#b#0;
    return;
}



procedure {:verboseName "Streams.ByteReader.GetSizeRead (well-formedness)"} CheckWellFormed$$Streams.ByteReader.GetSizeRead(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (n#0: int where LitInt(0) <= n#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.GetSizeRead (well-formedness)"} CheckWellFormed$$Streams.ByteReader.GetSizeRead(this: ref) returns (n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.GetSizeRead", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(177,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc n#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(179,16): post-state"} true;
    assume Streams.ByteReader.reader(this) != null;
    assume n#0 == $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteReader?(), $Heap);
    assume Streams.ByteReader.Valid#canCall($Heap, this);
    assume Streams.ByteReader.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteReader.GetSizeRead (call precondtion)"} CallPre$$Streams.ByteReader.GetSizeRead(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap));
  requires {:id "id15729"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  requires {:id "id15730"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  requires {:id "id15731"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  requires {:id "id15732"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  requires {:id "id15733"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  requires {:id "id15734"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));



procedure {:verboseName "Streams.ByteReader.GetSizeRead (call postcondition)"} CallPost$$Streams.ByteReader.GetSizeRead(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15735"} n#0 == $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int;
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15736"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteReader.GetSizeRead (correctness)"} Impl$$Streams.ByteReader.GetSizeRead(this: ref where this != null && $Is(this, Tclass.Streams.ByteReader()) && $IsAlloc(this, Tclass.Streams.ByteReader(), $Heap)) returns (defass#n#0: bool, n#0: int where defass#n#0 ==> LitInt(0) <= n#0, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15737"} Streams.ByteReader.Valid#canCall($Heap, this) && Streams.ByteReader.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)] && Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15738"} n#0 == $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int;
  free ensures Streams.ByteReader.Valid#canCall($Heap, this);
  free ensures {:id "id15739"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15740"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))];
  free ensures {:id "id15741"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteReader.Repr)): Set);
  free ensures {:id "id15742"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(this)];
  free ensures {:id "id15743"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || ($Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.Repr)): Set)[$Box(Streams.ByteReader.reader(this))]);
  free ensures {:id "id15744"} Streams.ByteReader.Valid#canCall($Heap, this) ==> Streams.ByteReader.Valid($Heap, this) || (Streams.SeqReader.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) ==> Streams.SeqReader.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteReader.reader(this)) || $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int <= Seq#Length(Streams.SeqReader.data(Tclass.BoundedInts.uint8(), Streams.ByteReader.reader(this))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteReader.GetSizeRead (correctness)"} Impl$$Streams.ByteReader.GetSizeRead(this: ref) returns (defass#n#0: bool, n#0: int, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteReader.GetSizeRead", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(181,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume Streams.ByteReader.reader(this) != null;
    assume true;
    n#0 := $Unbox(read($Heap, Streams.ByteReader.reader(this), Streams.SeqReader.pos)): int;
    defass#n#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(182,23)"} true;
    assume defass#n#0;
    return;
}



axiom (forall c#0: ref :: { $Is(c#0, Tclass.Streams.ByteReader()) } $Is(c#0, Tclass.Streams.ByteReader()) <==> $Is(c#0, Tclass.Streams.ByteReader?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Streams.ByteReader(), $h) } $IsAlloc(c#0, Tclass.Streams.ByteReader(), $h) <==> $IsAlloc(c#0, Tclass.Streams.ByteReader?(), $h));

const unique class.Streams.SeqWriter?: ClassName;

function Tclass.Streams.SeqWriter?(Ty) : Ty;

const unique Tagclass.Streams.SeqWriter?: TyTag;

axiom (forall Streams.SeqWriter$T: Ty :: { Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) } Tag(Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) == Tagclass.Streams.SeqWriter? && TagFamily(Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) == tytagFamily$SeqWriter);

function Tclass.Streams.SeqWriter?_0(Ty) : Ty;

axiom (forall Streams.SeqWriter$T: Ty :: { Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) } Tclass.Streams.SeqWriter?_0(Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) == Streams.SeqWriter$T);

axiom (forall Streams.SeqWriter$T: Ty, bx: Box :: { $IsBox(bx, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) } $IsBox(bx, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)));

axiom (forall Streams.SeqWriter$T: Ty, $o: ref :: { $Is($o, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) } $Is($o, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) <==> $o == null || dtype($o) == Tclass.Streams.SeqWriter?(Streams.SeqWriter$T));

axiom (forall Streams.SeqWriter$T: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T), $h) } $IsAlloc($o, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

const Streams.SeqWriter.Repr: Field
uses {
axiom FDim(Streams.SeqWriter.Repr) == 0 && FieldOfDecl(class.Streams.SeqWriter?, field$Repr) == Streams.SeqWriter.Repr && $IsGhostField(Streams.SeqWriter.Repr);
}

axiom (forall Streams.SeqWriter$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqWriter.Repr)): Set, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) ==> $Is($Unbox(read($h, $o, Streams.SeqWriter.Repr)): Set, TSet(Tclass._System.object())));

axiom (forall Streams.SeqWriter$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqWriter.Repr)): Set, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, Streams.SeqWriter.Repr)): Set, TSet(Tclass._System.object()), $h));

const Streams.SeqWriter.data: Field
uses {
axiom FDim(Streams.SeqWriter.data) == 0 && FieldOfDecl(class.Streams.SeqWriter?, field$data) == Streams.SeqWriter.data && !$IsGhostField(Streams.SeqWriter.data);
}

axiom (forall Streams.SeqWriter$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqWriter.data)): Seq, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) ==> $Is($Unbox(read($h, $o, Streams.SeqWriter.data)): Seq, TSeq(Streams.SeqWriter$T)));

axiom (forall Streams.SeqWriter$T: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.SeqWriter.data)): Seq, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.SeqWriter?(Streams.SeqWriter$T) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, Streams.SeqWriter.data)): Seq, TSeq(Streams.SeqWriter$T), $h));

function Streams.SeqWriter.Valid(Streams.SeqWriter$T: Ty, $heap: Heap, this: ref) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Streams.SeqWriter$T: Ty, $Heap: Heap, this: ref :: { Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) } Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap)) ==> Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) ==> ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)]);
axiom 0 <= $FunctionContextHeight ==> (forall Streams.SeqWriter$T: Ty, $Heap: Heap, this: ref :: { Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this), $IsGoodHeap($Heap) } Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap)) ==> (Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) <==> ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)]));
}

function Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T: Ty, $heap: Heap, this: ref) : bool;

function Tclass.Streams.SeqWriter(Ty) : Ty;

const unique Tagclass.Streams.SeqWriter: TyTag;

axiom (forall Streams.SeqWriter$T: Ty :: { Tclass.Streams.SeqWriter(Streams.SeqWriter$T) } Tag(Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) == Tagclass.Streams.SeqWriter && TagFamily(Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) == tytagFamily$SeqWriter);

function Tclass.Streams.SeqWriter_0(Ty) : Ty;

axiom (forall Streams.SeqWriter$T: Ty :: { Tclass.Streams.SeqWriter(Streams.SeqWriter$T) } Tclass.Streams.SeqWriter_0(Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) == Streams.SeqWriter$T);

axiom (forall Streams.SeqWriter$T: Ty, bx: Box :: { $IsBox(bx, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) } $IsBox(bx, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)));

axiom (forall Streams.SeqWriter$T: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Streams.SeqWriter.Valid(Streams.SeqWriter$T, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || ($Unbox(read($h0, this, Streams.SeqWriter.Repr)): Set)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Streams.SeqWriter.Valid(Streams.SeqWriter$T, $h0, this) <==> Streams.SeqWriter.Valid(Streams.SeqWriter$T, $h1, this)));

function Streams.SeqWriter.Valid#requires(Ty, Heap, ref) : bool;

axiom (forall Streams.SeqWriter$T: Ty, $Heap: Heap, this: ref :: { Streams.SeqWriter.Valid#requires(Streams.SeqWriter$T, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap) ==> (Streams.SeqWriter.Valid#requires(Streams.SeqWriter$T, $Heap, this) <==> true));

procedure {:verboseName "Streams.SeqWriter.Valid (well-formedness)"} CheckWellformed$$Streams.SeqWriter.Valid(Streams.SeqWriter$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15749"} Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) ==> ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqWriter.Valid (well-formedness)"} CheckWellformed$$Streams.SeqWriter.Valid(Streams.SeqWriter$T: Ty, this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqWriter.Valid", " | ", Streams.SeqWriter$T, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(190,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)]);
    b$reqreads#0 := $_ReadsFrame[this, Streams.SeqWriter.Repr];
    assume b$reqreads#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqWriter?(Streams.SeqWriter$T), $Heap);
    assume this == this || (Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))) && !Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))));
    assume this == this || Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
    assume Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this);
    assume ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
    goto anon5;

  anon8_Else:
    assume Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) ==> ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    b$reqreads#1 := $_ReadsFrame[this, Streams.SeqWriter.Repr];
    assume Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) <==> ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
    assume true;
    assume $Is(Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this), TBool);
    assume b$reqreads#1;
    return;
}



procedure {:verboseName "Streams.SeqWriter._ctor (well-formedness)"} CheckWellFormed$$Streams.SeqWriter.__ctor(Streams.SeqWriter$T: Ty) returns (this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Streams.SeqWriter._ctor (call precondtion)"} CallPre$$Streams.SeqWriter.__ctor(Streams.SeqWriter$T: Ty);



procedure {:verboseName "Streams.SeqWriter._ctor (call postcondition)"} CallPost$$Streams.SeqWriter.__ctor(Streams.SeqWriter$T: Ty) returns (this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15760"} Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Empty(): Seq);
  free ensures Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
  free ensures {:id "id15761"} Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) && Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15762"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.SeqWriter._ctor (correctness)"} Impl$$Streams.SeqWriter.__ctor(Streams.SeqWriter$T: Ty) returns (this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15763"} Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Empty(): Seq);
  free ensures Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
  free ensures {:id "id15764"} Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) ==> Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15765"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqWriter._ctor (correctness)"} Impl$$Streams.SeqWriter.__ctor(Streams.SeqWriter$T: Ty) returns (this: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var this.Repr: Set;
  var this.data: Seq;
  var defass#this.Repr: bool;
  var defass#this.data: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqWriter._ctor", " | ", Streams.SeqWriter$T} true;
    assume {:print "Types", " | ", "Ty"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(200,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    this.data := Lit(Seq#Empty(): Seq);
    defass#this.data := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(201,16)"} true;
    assume true;
    assume true;
    this.Repr := Set#UnionOne(Set#Empty(): Set, $Box(this));
    defass#this.Repr := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(202,20)"} true;
    assume defass#this.Repr;
    assume defass#this.data;
    assume !$Unbox(read($Heap, this, alloc)): bool;
    assume $Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set == this.Repr;
    assume $Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq == this.data;
    $Heap := update($Heap, this, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    return;
}



procedure {:verboseName "Streams.SeqWriter.WriteElements (well-formedness)"} CheckWellFormed$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap), elems#0: Seq where $Is(elems#0, TSeq(Streams.SeqWriter$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqWriter$T), $Heap)) returns (n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqWriter.WriteElements (well-formedness)"} CheckWellFormed$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref, elems#0: Seq) returns (n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqWriter.WriteElements", " | ", Streams.SeqWriter$T, " | ", this, " | ", elems#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(205,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqWriter?(Streams.SeqWriter$T), $Heap);
    assume Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
    assume Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this);
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqWriter.data));
    assume $HeapSucc(old($Heap), $Heap);
    havoc n#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(208,16): post-state"} true;
    assume $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), old($Heap));
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} n#0 == Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
    assume $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), old($Heap));
    goto anon3;

  anon10_Else:
    assume {:partition} n#0 != Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
    goto anon3;

  anon3:
    assume n#0 == Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq) && Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq) == Seq#Length(elems#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Length(elems#0) == LitInt(0);
    assume $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, $Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
    goto anon6;

  anon11_Else:
    assume Seq#Length(elems#0) == LitInt(0) ==> Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, $Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
    goto anon6;

  anon6:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Seq#Length(elems#0) > 0;
    assume $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq, elems#0));
    goto anon9;

  anon12_Else:
    assume Seq#Length(elems#0) > 0 ==> Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq, elems#0));
    goto anon9;

  anon9:
    assume 0 <= Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length(elems#0) && Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length(elems#0) <= Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq);
    assume Seq#Equal(elems#0, Seq#Drop($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length(elems#0)));
    assume $IsAllocBox($Box(this), Tclass.Streams.SeqWriter?(Streams.SeqWriter$T), $Heap);
    assume Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
    assume Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this);
    return;
}



procedure {:verboseName "Streams.SeqWriter.WriteElements (call precondtion)"} CallPre$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap), elems#0: Seq where $Is(elems#0, TSeq(Streams.SeqWriter$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqWriter$T), $Heap));
  requires {:id "id15786"} Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) ==> Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];



procedure {:verboseName "Streams.SeqWriter.WriteElements (call postcondition)"} CallPost$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap), elems#0: Seq where $Is(elems#0, TSeq(Streams.SeqWriter$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqWriter$T), $Heap)) returns (n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15787"} n#0 == Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
  free ensures {:id "id15788"} Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq) == Seq#Length(elems#0);
  free ensures true;
  free ensures {:id "id15789"} Seq#Length(elems#0) == LitInt(0) ==> Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, $Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
  free ensures true;
  free ensures {:id "id15790"} Seq#Length(elems#0) > 0 ==> Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq, elems#0));
  free ensures true;
  free ensures {:id "id15791"} Seq#Equal(elems#0, Seq#Drop($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length(elems#0)));
  free ensures Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
  free ensures {:id "id15792"} Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) && Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.SeqWriter.WriteElements (correctness)"} Impl$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref where this != null && $Is(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) && $IsAlloc(this, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $Heap), elems#0: Seq where $Is(elems#0, TSeq(Streams.SeqWriter$T)) && $IsAlloc(elems#0, TSeq(Streams.SeqWriter$T), $Heap)) returns (defass#n#0: bool, n#0: int where defass#n#0 ==> LitInt(0) <= n#0, $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id15793"} Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) && Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) && ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15794"} n#0 == Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
  free ensures {:id "id15795"} Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq) == Seq#Length(elems#0);
  free ensures true;
  free ensures {:id "id15796"} Seq#Length(elems#0) == LitInt(0) ==> Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, $Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq);
  free ensures true;
  free ensures {:id "id15797"} Seq#Length(elems#0) > 0 ==> Seq#Equal($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), this, Streams.SeqWriter.data)): Seq, elems#0));
  free ensures true;
  free ensures {:id "id15798"} Seq#Equal(elems#0, Seq#Drop($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, Seq#Length($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq) - Seq#Length(elems#0)));
  free ensures Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this);
  free ensures {:id "id15799"} Streams.SeqWriter.Valid#canCall(Streams.SeqWriter$T, $Heap, this) ==> Streams.SeqWriter.Valid(Streams.SeqWriter$T, $Heap, this) || ($Unbox(read($Heap, this, Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.SeqWriter.WriteElements (correctness)"} Impl$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref, elems#0: Seq) returns (defass#n#0: bool, n#0: int, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.SeqWriter.WriteElements", " | ", Streams.SeqWriter$T, " | ", this, " | ", elems#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(213,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume $_ModifiesFrame[this, Streams.SeqWriter.data];
    assume true;
    $rhs#0 := Seq#Append($Unbox(read($Heap, this, Streams.SeqWriter.data)): Seq, elems#0);
    $Heap := update($Heap, this, Streams.SeqWriter.data, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "StandardLibrary/src/Streams.dfy(214,26)"} true;
    assume true;
    assume true;
    assume $Is(Seq#Length(elems#0), Tclass._System.nat());
    n#0 := Seq#Length(elems#0);
    defass#n#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(215,20)"} true;
    assume defass#n#0;
    return;
}



axiom (forall Streams.SeqWriter$T: Ty, c#0: ref :: { $Is(c#0, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) } $Is(c#0, Tclass.Streams.SeqWriter(Streams.SeqWriter$T)) <==> $Is(c#0, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T)) && c#0 != null);

axiom (forall Streams.SeqWriter$T: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $h) } $IsAlloc(c#0, Tclass.Streams.SeqWriter(Streams.SeqWriter$T), $h) <==> $IsAlloc(c#0, Tclass.Streams.SeqWriter?(Streams.SeqWriter$T), $h));

const unique class.Streams.ByteWriter?: ClassName;

function Tclass.Streams.ByteWriter?() : Ty
uses {
axiom Tag(Tclass.Streams.ByteWriter?()) == Tagclass.Streams.ByteWriter? && TagFamily(Tclass.Streams.ByteWriter?()) == tytagFamily$ByteWriter;
}

const unique Tagclass.Streams.ByteWriter?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Streams.ByteWriter?()) } $IsBox(bx, Tclass.Streams.ByteWriter?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.ByteWriter?()));

axiom (forall $o: ref :: { $Is($o, Tclass.Streams.ByteWriter?()) } $Is($o, Tclass.Streams.ByteWriter?()) <==> $o == null || dtype($o) == Tclass.Streams.ByteWriter?());

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Streams.ByteWriter?(), $h) } $IsAlloc($o, Tclass.Streams.ByteWriter?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

const Streams.ByteWriter.Repr: Field
uses {
axiom FDim(Streams.ByteWriter.Repr) == 0 && FieldOfDecl(class.Streams.ByteWriter?, field$Repr) == Streams.ByteWriter.Repr && $IsGhostField(Streams.ByteWriter.Repr);
}

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.ByteWriter.Repr)): Set } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.ByteWriter?() ==> $Is($Unbox(read($h, $o, Streams.ByteWriter.Repr)): Set, TSet(Tclass._System.object())));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, Streams.ByteWriter.Repr)): Set } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.ByteWriter?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, Streams.ByteWriter.Repr)): Set, TSet(Tclass._System.object()), $h));

function Streams.ByteWriter.writer(this: ref) : ref
uses {
axiom 1 < $FunctionContextHeight ==> (forall $o: ref :: { Streams.ByteWriter.writer($o) } $o != null && dtype($o) == Tclass.Streams.ByteWriter?() ==> $Is(Streams.ByteWriter.writer($o), Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8())));
axiom 1 < $FunctionContextHeight ==> (forall $h: Heap, $o: ref :: { Streams.ByteWriter.writer($o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.Streams.ByteWriter?() && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(Streams.ByteWriter.writer($o), Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8()), $h));
}

function Streams.ByteWriter.Valid($heap: Heap, this: ref) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.Valid($Heap, this) } Streams.ByteWriter.Valid#canCall($Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap)) ==> Streams.ByteWriter.Valid($Heap, this) ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)]);
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.Valid($Heap, this), $IsGoodHeap($Heap) } Streams.ByteWriter.Valid#canCall($Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap)) ==> (($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] ==> Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) ==> !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] ==> Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this))) && (Streams.ByteWriter.Valid($Heap, this) <==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this))));
}

function Streams.ByteWriter.Valid#canCall($heap: Heap, this: ref) : bool;

function Tclass.Streams.ByteWriter() : Ty
uses {
axiom Tag(Tclass.Streams.ByteWriter()) == Tagclass.Streams.ByteWriter && TagFamily(Tclass.Streams.ByteWriter()) == tytagFamily$ByteWriter;
}

const unique Tagclass.Streams.ByteWriter: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Streams.ByteWriter()) } $IsBox(bx, Tclass.Streams.ByteWriter()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Streams.ByteWriter()));

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Streams.ByteWriter.Valid($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || ($Unbox(read($h0, this, Streams.ByteWriter.Repr)): Set)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Streams.ByteWriter.Valid($h0, this) <==> Streams.ByteWriter.Valid($h1, this)));

function Streams.ByteWriter.Valid#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.Valid#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) ==> (Streams.ByteWriter.Valid#requires($Heap, this) <==> true));

procedure {:verboseName "Streams.ByteWriter.Valid (well-formedness)"} CheckWellformed$$Streams.ByteWriter.Valid(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15807"} Streams.ByteWriter.Valid($Heap, this) ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.Valid (well-formedness)"} CheckWellformed$$Streams.ByteWriter.Valid(this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.Valid", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(223,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)]);
    b$reqreads#0 := $_ReadsFrame[this, Streams.ByteWriter.Repr];
    assume b$reqreads#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume this == this || (Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))) && !Set#Subset(Set#Union($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))));
    assume this == this || Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
    goto anon5;

  anon16_Else:
    assume Streams.ByteWriter.Valid($Heap, this) ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
    goto anon5;

  anon5:
    assume false;
    return;

  anon15_Else:
    b$reqreads#1 := $_ReadsFrame[this, Streams.ByteWriter.Repr];
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
    b$reqreads#2 := $_ReadsFrame[this, Streams.ByteWriter.Repr];
    goto anon8;

  anon17_Else:
    assume {:partition} !($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
    goto anon8;

  anon8:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
    assume Streams.ByteWriter.writer(this) != null;
    b$reqreads#3 := $_ReadsFrame[Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr];
    b$reqreads#4 := $_ReadsFrame[this, Streams.ByteWriter.Repr];
    goto anon10;

  anon18_Else:
    assume {:partition} !(($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);
    goto anon10;

  anon10:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
    assume Streams.ByteWriter.writer(this) != null;
    b$reqreads#5 := $_ReadsFrame[Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr];
    goto anon12;

  anon19_Else:
    assume {:partition} !(($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set));
    goto anon12;

  anon12:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAllocBox($Box(Streams.ByteWriter.writer(this)), Tclass.Streams.SeqWriter?(Tclass.BoundedInts.uint8()), $Heap);
    b$reqreads#6 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ($o == Streams.ByteWriter.writer(this) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box($o)]) ==> $_ReadsFrame[$o, $f]);
    assume Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
    goto anon14;

  anon20_Else:
    assume {:partition} !(($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)]);
    goto anon14;

  anon14:
    assume Streams.ByteWriter.Valid($Heap, this) <==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
    assume ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] ==> Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) ==> !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] ==> Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
    assume $Is(Streams.ByteWriter.Valid($Heap, this), TBool);
    assume b$reqreads#1;
    assume b$reqreads#2;
    assume b$reqreads#3;
    assume b$reqreads#4;
    assume b$reqreads#5;
    assume b$reqreads#6;
    return;
}



procedure {:verboseName "Streams.ByteWriter._ctor (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.__ctor() returns (this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter._ctor (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.__ctor() returns (this: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter._ctor"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(231,4): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc this;
    assume {:captureState "StandardLibrary/src/Streams.dfy(232,26): post-state"} true;
    assume Streams.ByteWriter.writer(this) != null;
    assume Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Empty(): Seq);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
    return;
}



procedure {:verboseName "Streams.ByteWriter._ctor (call precondtion)"} CallPre$$Streams.ByteWriter.__ctor();



procedure {:verboseName "Streams.ByteWriter._ctor (call postcondition)"} CallPost$$Streams.ByteWriter.__ctor() returns (this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15827"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Empty(): Seq);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15828"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  free ensures {:id "id15829"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteWriter._ctor (correctness)"} Impl$$Streams.ByteWriter.__ctor() returns (this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15830"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Empty(): Seq);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15831"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15832"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15833"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15834"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15835"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);
  free ensures {:id "id15836"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter._ctor (correctness)"} Impl$$Streams.ByteWriter.__ctor() returns (this: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var this.Repr: Set;
  var this.writer: ref;
  var defass#this.Repr: bool;
  var defass#this.writer: bool;
  var defass#mw#0: bool;
  var mw#0: ref where defass#mw#0 ==> $Is(mw#0, Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8())) && $IsAlloc(mw#0, Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8()), $Heap);
  var $nw: ref;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter._ctor"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Streams.dfy(234,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    call CallPre$$Streams.SeqWriter.__ctor(Tclass.BoundedInts.uint8());
    call $nw := CallPost$$Streams.SeqWriter.__ctor(Tclass.BoundedInts.uint8());
    assume {:captureState "StandardLibrary/src/Streams.dfy(235,38)"} true;
    mw#0 := $nw;
    defass#mw#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(235,38)"} true;
    assume true;
    assume defass#mw#0;
    assume true;
    this.writer := mw#0;
    defass#this.writer := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(236,18)"} true;
    assume true;
    assume defass#mw#0;
    assume mw#0 != null;
    assume true;
    this.Repr := Set#Union(Set#UnionOne(Set#Empty(): Set, $Box(this)), $Unbox(read($Heap, mw#0, Streams.SeqWriter.Repr)): Set);
    defass#this.Repr := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(237,30)"} true;
    assume defass#this.Repr;
    assume defass#this.writer;
    assume !$Unbox(read($Heap, this, alloc)): bool;
    assume $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set == this.Repr;
    assume Streams.ByteWriter.writer(this) == this.writer;
    $Heap := update($Heap, this, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteByte (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (r#0: int where LitInt(0) <= r#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteByte (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteByte(this: ref, n#0: int) returns (r#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteByte", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(240,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume Streams.ByteWriter.writer(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
    assume $HeapSucc(old($Heap), $Heap);
    havoc r#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(243,26): post-state"} true;
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteWriter(), old($Heap));
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(Streams.ByteWriter.writer(this), Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8()), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(n#0))));
    assume r#0 == LitInt(1);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteByte (call precondtion)"} CallPre$$Streams.ByteWriter.WriteByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__8());
  requires {:id "id15856"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15857"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  requires {:id "id15858"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  requires {:id "id15859"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15860"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);



procedure {:verboseName "Streams.ByteWriter.WriteByte (call postcondition)"} CallPost$$Streams.ByteWriter.WriteByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (r#0: int where LitInt(0) <= r#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15861"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(n#0))));
  free ensures true;
  free ensures {:id "id15862"} r#0 == LitInt(1);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15863"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteWriter.WriteByte (correctness)"} Impl$$Streams.ByteWriter.WriteByte(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (defass#r#0: bool, r#0: int where defass#r#0 ==> LitInt(0) <= r#0, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15864"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15865"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(n#0))));
  free ensures true;
  free ensures {:id "id15866"} r#0 == LitInt(1);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15867"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15868"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15869"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15870"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15871"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteByte (correctness)"} Impl$$Streams.ByteWriter.WriteByte(this: ref, n#0: int) returns (defass#r#0: bool, r#0: int, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: int;
  var elems##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteByte", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(246,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume Streams.ByteWriter.writer(this) != null;
    assume true;
    elems##0 := Seq#Build(Seq#Empty(): Seq, $Box(n#0));
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    call $rhs##0 := CallPost$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    r#0 := $rhs##0;
    defass#r#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(247,36)"} true;
    assume defass#r#0;
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteBytes (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (r#0: int where LitInt(0) <= r#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteBytes (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteBytes(this: ref, s#0: Seq) returns (r#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteBytes", " | ", this, " | ", s#0} true;
    assume {:print "Types", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(250,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume Streams.ByteWriter.writer(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
    assume $HeapSucc(old($Heap), $Heap);
    havoc r#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(253,26): post-state"} true;
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteWriter(), old($Heap));
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(Streams.ByteWriter.writer(this), Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8()), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, s#0));
    assume r#0 == Seq#Length(s#0);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteBytes (call precondtion)"} CallPre$$Streams.ByteWriter.WriteBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id15887"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15888"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  requires {:id "id15889"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  requires {:id "id15890"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15891"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);



procedure {:verboseName "Streams.ByteWriter.WriteBytes (call postcondition)"} CallPost$$Streams.ByteWriter.WriteBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (r#0: int where LitInt(0) <= r#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15892"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, s#0));
  free ensures true;
  free ensures {:id "id15893"} r#0 == Seq#Length(s#0);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15894"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteWriter.WriteBytes (correctness)"} Impl$$Streams.ByteWriter.WriteBytes(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns (defass#r#0: bool, r#0: int where defass#r#0 ==> LitInt(0) <= r#0, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15895"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id15896"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, s#0));
  free ensures true;
  free ensures {:id "id15897"} r#0 == Seq#Length(s#0);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15898"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15899"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15900"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15901"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15902"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteBytes (correctness)"} Impl$$Streams.ByteWriter.WriteBytes(this: ref, s#0: Seq) returns (defass#r#0: bool, r#0: int, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: int;
  var elems##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteBytes", " | ", this, " | ", s#0} true;
    assume {:print "Types", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(256,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume Streams.ByteWriter.writer(this) != null;
    assume true;
    elems##0 := s#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    call $rhs##0 := CallPost$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    r#0 := $rhs##0;
    defass#r#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(257,34)"} true;
    assume defass#r#0;
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteUInt16 (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__16()) returns (r#0: int where LitInt(0) <= r#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteUInt16 (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteUInt16(this: ref, n#0: int) returns (r#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteUInt16", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(260,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume Streams.ByteWriter.writer(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
    assume $HeapSucc(old($Heap), $Heap);
    havoc r#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(263,26): post-state"} true;
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteWriter(), old($Heap));
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(Streams.ByteWriter.writer(this), Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8()), old($Heap));
    ##x#0 := n#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint16(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(n#0);
    assume Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, StandardLibrary_mUInt.__default.UInt16ToSeq(n#0)));
    assume r#0 == LitInt(2);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteUInt16 (call precondtion)"} CallPre$$Streams.ByteWriter.WriteUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__16());
  requires {:id "id15918"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15919"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  requires {:id "id15920"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  requires {:id "id15921"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15922"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);



procedure {:verboseName "Streams.ByteWriter.WriteUInt16 (call postcondition)"} CallPost$$Streams.ByteWriter.WriteUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__16()) returns (r#0: int where LitInt(0) <= r#0);
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(n#0);
  free ensures {:id "id15923"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, StandardLibrary_mUInt.__default.UInt16ToSeq(n#0)));
  free ensures true;
  free ensures {:id "id15924"} r#0 == LitInt(2);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15925"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteWriter.WriteUInt16 (correctness)"} Impl$$Streams.ByteWriter.WriteUInt16(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__16()) returns (defass#r#0: bool, r#0: int where defass#r#0 ==> LitInt(0) <= r#0, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15926"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(n#0);
  free ensures {:id "id15927"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, StandardLibrary_mUInt.__default.UInt16ToSeq(n#0)));
  free ensures true;
  free ensures {:id "id15928"} r#0 == LitInt(2);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15929"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15930"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15931"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15932"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15933"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteUInt16 (correctness)"} Impl$$Streams.ByteWriter.WriteUInt16(this: ref, n#0: int) returns (defass#r#0: bool, r#0: int, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: int;
  var elems##0: Seq;
  var ##x#1: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteUInt16", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(266,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume Streams.ByteWriter.writer(this) != null;
    ##x#1 := n#0;
    assume $IsAlloc(##x#1, Tclass.BoundedInts.uint16(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(n#0);
    assume StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(n#0);
    elems##0 := StandardLibrary_mUInt.__default.UInt16ToSeq(n#0);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    call $rhs##0 := CallPost$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    r#0 := $rhs##0;
    defass#r#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(267,47)"} true;
    assume defass#r#0;
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteUInt32 (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (r#0: int where LitInt(0) <= r#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteUInt32 (well-formedness)"} CheckWellFormed$$Streams.ByteWriter.WriteUInt32(this: ref, n#0: int) returns (r#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteUInt32", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(270,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume Streams.ByteWriter.writer(this) != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
    assume $HeapSucc(old($Heap), $Heap);
    havoc r#0;
    assume {:captureState "StandardLibrary/src/Streams.dfy(273,26): post-state"} true;
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(this, Tclass.Streams.ByteWriter(), old($Heap));
    assume Streams.ByteWriter.writer(this) != null;
    assume $IsAlloc(Streams.ByteWriter.writer(this), Tclass.Streams.SeqWriter(Tclass.BoundedInts.uint8()), old($Heap));
    ##x#0 := n#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(n#0);
    assume Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)));
    assume r#0 == LitInt(4);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    return;
}



procedure {:verboseName "Streams.ByteWriter.WriteUInt32 (call precondtion)"} CallPre$$Streams.ByteWriter.WriteUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id15949"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15950"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  requires {:id "id15951"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  requires {:id "id15952"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  requires {:id "id15953"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);



procedure {:verboseName "Streams.ByteWriter.WriteUInt32 (call postcondition)"} CallPost$$Streams.ByteWriter.WriteUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (r#0: int where LitInt(0) <= r#0);
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(n#0);
  free ensures {:id "id15954"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)));
  free ensures true;
  free ensures {:id "id15955"} r#0 == LitInt(4);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15956"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Streams.ByteWriter.WriteUInt32 (correctness)"} Impl$$Streams.ByteWriter.WriteUInt32(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (defass#r#0: bool, r#0: int where defass#r#0 ==> LitInt(0) <= r#0, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id15957"} Streams.ByteWriter.Valid#canCall($Heap, this) && Streams.ByteWriter.Valid($Heap, this) && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)] && ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))] && Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set) && !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)] && Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this));
  modifies $Heap;
  free ensures StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(n#0);
  free ensures {:id "id15958"} Seq#Equal($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, Seq#Append($Unbox(read(old($Heap), Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq, StandardLibrary_mUInt.__default.UInt32ToSeq(n#0)));
  free ensures true;
  free ensures {:id "id15959"} r#0 == LitInt(4);
  free ensures Streams.ByteWriter.Valid#canCall($Heap, this);
  free ensures {:id "id15960"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15961"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15962"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15963"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15964"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == Streams.ByteWriter.writer(this));
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.WriteUInt32 (correctness)"} Impl$$Streams.ByteWriter.WriteUInt32(this: ref, n#0: int) returns (defass#r#0: bool, r#0: int, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: int;
  var elems##0: Seq;
  var ##x#1: int;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteUInt32", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data);
    assume {:captureState "StandardLibrary/src/Streams.dfy(276,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume Streams.ByteWriter.writer(this) != null;
    ##x#1 := n#0;
    assume $IsAlloc(##x#1, Tclass.BoundedInts.uint32(), $Heap);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(n#0);
    assume StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(n#0);
    elems##0 := StandardLibrary_mUInt.__default.UInt32ToSeq(n#0);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == Streams.ByteWriter.writer(this) && $f == Streams.SeqWriter.data ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    call $rhs##0 := CallPost$$Streams.SeqWriter.WriteElements(Tclass.BoundedInts.uint8(), Streams.ByteWriter.writer(this), elems##0);
    r#0 := $rhs##0;
    defass#r#0 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(277,47)"} true;
    assume defass#r#0;
    return;
}



function Streams.ByteWriter.GetDataWritten($heap: Heap, this: ref) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.GetDataWritten($Heap, this) } Streams.ByteWriter.GetDataWritten#canCall($Heap, this) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) && Streams.ByteWriter.Valid($Heap, this)) ==> Seq#Equal(Streams.ByteWriter.GetDataWritten($Heap, this), $Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq) && Streams.ByteWriter.Valid($Heap, this) && $Is(Streams.ByteWriter.GetDataWritten($Heap, this), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.GetDataWritten($Heap, this), $IsGoodHeap($Heap) } Streams.ByteWriter.GetDataWritten#canCall($Heap, this) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) && Streams.ByteWriter.Valid($Heap, this)) ==> Streams.ByteWriter.GetDataWritten($Heap, this) == $Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq);
}

function Streams.ByteWriter.GetDataWritten#canCall($heap: Heap, this: ref) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Streams.ByteWriter.GetDataWritten($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($Unbox(read($h0, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Streams.ByteWriter.GetDataWritten($h0, this) == Streams.ByteWriter.GetDataWritten($h1, this));

function Streams.ByteWriter.GetDataWritten#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.GetDataWritten#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) ==> (Streams.ByteWriter.GetDataWritten#requires($Heap, this) <==> Streams.ByteWriter.Valid($Heap, this)));

procedure {:verboseName "Streams.ByteWriter.GetDataWritten (well-formedness)"} CheckWellformed$$Streams.ByteWriter.GetDataWritten(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap)) returns (s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15971"} Seq#Equal(s#0, $Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq);
  free ensures {:id "id15972"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15973"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15974"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15975"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15976"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.GetDataWritten (well-formedness)"} CheckWellformed$$Streams.ByteWriter.GetDataWritten(this: ref) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.GetDataWritten", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(280,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)]);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ($o == this || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)]) ==> $_ReadsFrame[$o, $f]);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume b$reqreads#0;
    b$reqreads#1 := $_ReadsFrame[this, Streams.ByteWriter.Repr];
    assume b$reqreads#1;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Streams.ByteWriter.GetDataWritten($Heap, this), TSeq(Tclass.BoundedInts.uint8()));
    assume Streams.ByteWriter.writer(this) != null;
    assume Seq#Equal(s#0, $Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume false;
    return;

  anon4_Else:
    assume Streams.ByteWriter.writer(this) != null;
    b$reqreads#2 := $_ReadsFrame[Streams.ByteWriter.writer(this), Streams.SeqWriter.data];
    assume Streams.ByteWriter.GetDataWritten($Heap, this) == $Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq;
    assume true;
    assume $Is(Streams.ByteWriter.GetDataWritten($Heap, this), TSeq(Tclass.BoundedInts.uint8()));
    assume Streams.ByteWriter.GetDataWritten($Heap, this) == s#0;
    assume b$reqreads#2;
    return;
}



function Streams.ByteWriter.GetSizeWritten($heap: Heap, this: ref) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.GetSizeWritten($Heap, this) } Streams.ByteWriter.GetSizeWritten#canCall($Heap, this) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) && Streams.ByteWriter.Valid($Heap, this)) ==> Streams.ByteWriter.GetSizeWritten($Heap, this) == Seq#Length($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq) && Streams.ByteWriter.Valid($Heap, this) && LitInt(0) <= Streams.ByteWriter.GetSizeWritten($Heap, this));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.GetSizeWritten($Heap, this), $IsGoodHeap($Heap) } Streams.ByteWriter.GetSizeWritten#canCall($Heap, this) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) && Streams.ByteWriter.Valid($Heap, this)) ==> Streams.ByteWriter.GetSizeWritten($Heap, this) == Seq#Length($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq));
}

function Streams.ByteWriter.GetSizeWritten#canCall($heap: Heap, this: ref) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Streams.ByteWriter.GetSizeWritten($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($Unbox(read($h0, this, Streams.ByteWriter.Repr)): Set)[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> Streams.ByteWriter.GetSizeWritten($h0, this) == Streams.ByteWriter.GetSizeWritten($h1, this));

function Streams.ByteWriter.GetSizeWritten#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { Streams.ByteWriter.GetSizeWritten#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap) ==> (Streams.ByteWriter.GetSizeWritten#requires($Heap, this) <==> Streams.ByteWriter.Valid($Heap, this)));

procedure {:verboseName "Streams.ByteWriter.GetSizeWritten (well-formedness)"} CheckWellformed$$Streams.ByteWriter.GetSizeWritten(this: ref where this != null && $Is(this, Tclass.Streams.ByteWriter()) && $IsAlloc(this, Tclass.Streams.ByteWriter(), $Heap)) returns (n#0: int where LitInt(0) <= n#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id15987"} n#0 == Seq#Length($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq);
  free ensures {:id "id15988"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15989"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))];
  free ensures {:id "id15990"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || Set#Subset($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set, $Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set);
  free ensures {:id "id15991"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || !($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(this)];
  free ensures {:id "id15992"} Streams.ByteWriter.Valid#canCall($Heap, this) ==> Streams.ByteWriter.Valid($Heap, this) || (Streams.SeqWriter.Valid#canCall(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) ==> Streams.SeqWriter.Valid(Tclass.BoundedInts.uint8(), $Heap, Streams.ByteWriter.writer(this)) || ($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.Repr)): Set)[$Box(Streams.ByteWriter.writer(this))]);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Streams.ByteWriter.GetSizeWritten (well-formedness)"} CheckWellformed$$Streams.ByteWriter.GetSizeWritten(this: ref) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;

  anon0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.GetSizeWritten", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    assume {:captureState "StandardLibrary/src/Streams.dfy(289,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)]);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ($o == this || ($Unbox(read($Heap, this, Streams.ByteWriter.Repr)): Set)[$Box($o)]) ==> $_ReadsFrame[$o, $f]);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume b$reqreads#0;
    b$reqreads#1 := $_ReadsFrame[this, Streams.ByteWriter.Repr];
    assume b$reqreads#1;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= Streams.ByteWriter.GetSizeWritten($Heap, this);
    assume Streams.ByteWriter.writer(this) != null;
    assume n#0 == Seq#Length($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq);
    assume $IsAllocBox($Box(this), Tclass.Streams.ByteWriter?(), $Heap);
    assume Streams.ByteWriter.Valid#canCall($Heap, this);
    assume Streams.ByteWriter.Valid($Heap, this);
    assume false;
    return;

  anon4_Else:
    assume Streams.ByteWriter.writer(this) != null;
    b$reqreads#2 := $_ReadsFrame[Streams.ByteWriter.writer(this), Streams.SeqWriter.data];
    assume $Is(Seq#Length($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq), Tclass._System.nat());
    assume Streams.ByteWriter.GetSizeWritten($Heap, this) == Seq#Length($Unbox(read($Heap, Streams.ByteWriter.writer(this), Streams.SeqWriter.data)): Seq);
    assume true;
    assume $Is(Streams.ByteWriter.GetSizeWritten($Heap, this), Tclass._System.nat());
    assume Streams.ByteWriter.GetSizeWritten($Heap, this) == n#0;
    assume b$reqreads#2;
    return;
}



axiom (forall c#0: ref :: { $Is(c#0, Tclass.Streams.ByteWriter()) } $Is(c#0, Tclass.Streams.ByteWriter()) <==> $Is(c#0, Tclass.Streams.ByteWriter?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Streams.ByteWriter(), $h) } $IsAlloc(c#0, Tclass.Streams.ByteWriter(), $h) <==> $IsAlloc(c#0, Tclass.Streams.ByteWriter?(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#92 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#92))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#94 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#94)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#138 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#138))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#140 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#140)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#142 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#142)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#138 := Wrappers.Option.value(this); v#138)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#140 := Lit(Wrappers.Option.value(Lit(this))); v#140)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#142 := Lit(Wrappers.Option.value(Lit(this))); v#142)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#92 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#92)) else (var e#92 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#94 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#94))) else (var e#94 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#138 := Wrappers.Result.value(this); s#138) else (var e#138 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#140 := Lit(Wrappers.Result.value(Lit(this))); s#140) else (var e#140 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#142 := Lit(Wrappers.Result.value(Lit(this))); s#142) else (var e#142 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#138 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#138)) else (var e#138 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#138)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#140 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#140))) else (var e#140 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#140)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#142 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#142))) else (var e#142 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#142)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#30 := Div(x#0, LitInt(256)); (var b1#30 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#30)), $Box(b1#30)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#31 := LitInt(Div(x#0, LitInt(256))); (var b1#31 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#31)), $Box(b1#31))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#30 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#30 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#31 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#31 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#30 := Div(x#0, LitInt(16777216)); (var x0#30 := x#0 - Mul(b0#30, LitInt(16777216)); (var b1#30 := Div(x0#30, LitInt(65536)); (var x1#30 := x0#30 - Mul(b1#30, LitInt(65536)); (var b2#30 := Div(x1#30, LitInt(256)); (var b3#30 := Mod(x1#30, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#30)), $Box(b1#30)), $Box(b2#30)), $Box(b3#30)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#31 := LitInt(Div(x#0, LitInt(16777216))); (var x0#31 := LitInt(x#0 - Mul(b0#31, LitInt(16777216))); (var b1#31 := LitInt(Div(x0#31, LitInt(65536))); (var x1#31 := LitInt(x0#31 - Mul(b1#31, LitInt(65536))); (var b2#31 := LitInt(Div(x1#31, LitInt(256))); (var b3#31 := LitInt(Mod(x1#31, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#31)), $Box(b1#31)), $Box(b2#31)), $Box(b3#31))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#30 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#30 := x0#30 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#30 := x1#30 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#30 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#31 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#31 := x0#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#31 := x1#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#31 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#30 := Div(x#0, LitInt(72057594037927936)); (var x0#30 := x#0 - Mul(b0#30, LitInt(72057594037927936)); (var b1#30 := Div(x0#30, LitInt(281474976710656)); (var x1#30 := x0#30 - Mul(b1#30, LitInt(281474976710656)); (var b2#30 := Div(x1#30, LitInt(1099511627776)); (var x2#30 := x1#30 - Mul(b2#30, LitInt(1099511627776)); (var b3#30 := Div(x2#30, LitInt(4294967296)); (var x3#30 := x2#30 - Mul(b3#30, LitInt(4294967296)); (var b4#30 := Div(x3#30, LitInt(16777216)); (var x4#30 := x3#30 - Mul(b4#30, LitInt(16777216)); (var b5#30 := Div(x4#30, LitInt(65536)); (var x5#30 := x4#30 - Mul(b5#30, LitInt(65536)); (var b6#30 := Div(x5#30, LitInt(256)); (var b7#30 := Mod(x5#30, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#30)), $Box(b1#30)), $Box(b2#30)), $Box(b3#30)), $Box(b4#30)), $Box(b5#30)), $Box(b6#30)), $Box(b7#30)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#31 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#31 := LitInt(x#0 - Mul(b0#31, LitInt(72057594037927936))); (var b1#31 := LitInt(Div(x0#31, LitInt(281474976710656))); (var x1#31 := LitInt(x0#31 - Mul(b1#31, LitInt(281474976710656))); (var b2#31 := LitInt(Div(x1#31, LitInt(1099511627776))); (var x2#31 := LitInt(x1#31 - Mul(b2#31, LitInt(1099511627776))); (var b3#31 := LitInt(Div(x2#31, LitInt(4294967296))); (var x3#31 := LitInt(x2#31 - Mul(b3#31, LitInt(4294967296))); (var b4#31 := LitInt(Div(x3#31, LitInt(16777216))); (var x4#31 := LitInt(x3#31 - Mul(b4#31, LitInt(16777216))); (var b5#31 := LitInt(Div(x4#31, LitInt(65536))); (var x5#31 := LitInt(x4#31 - Mul(b5#31, LitInt(65536))); (var b6#31 := LitInt(Div(x5#31, LitInt(256))); (var b7#31 := LitInt(Mod(x5#31, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#31)), $Box(b1#31)), $Box(b2#31)), $Box(b3#31)), $Box(b4#31)), $Box(b5#31)), $Box(b6#31)), $Box(b7#31))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#30 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#30 := x0#30 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#30 := x1#30 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#30 := x2#30 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#30 := x3#30 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#30 := x4#30 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#30 := x5#30 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#31 := x6#30 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#31)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#31 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#31 := x0#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#31 := x1#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#31 := x2#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#31 := x3#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#31 := x4#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#31 := x5#31 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#32 := x6#31 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#32)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#30 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#30)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#30 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#30)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#30)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#31 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#31)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#31 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#31)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#31)): int)));

const unique tytagFamily$SeqReader: TyTagFamily;

const unique tytagFamily$ByteReader: TyTagFamily;

const unique tytagFamily$SeqWriter: TyTagFamily;

const unique tytagFamily$ByteWriter: TyTagFamily;

const unique field$Repr: NameFamily;

const unique field$pos: NameFamily;

const unique field$data: NameFamily;

const unique class.Sorting.__default: ClassName;

function Sorting.__default.Reflexive(Sorting._default.Reflexive$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Sorting._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Sorting.__default.Reflexive(Sorting._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Sorting.__default.Reflexive#canCall(Sorting._default.Reflexive$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool))) ==> (Sorting.__default.Reflexive(Sorting._default.Reflexive$T, R#0) <==> (forall x#0: Box :: { $Unbox(Apply2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool, $Heap, R#0, x#0, x#0)): bool } $IsBox(x#0, Sorting._default.Reflexive$T) ==> $Unbox(Apply2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool, $Heap, R#0, x#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Sorting._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Sorting.__default.Reflexive(Sorting._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Sorting.__default.Reflexive#canCall(Sorting._default.Reflexive$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool))) ==> (Sorting.__default.Reflexive(Sorting._default.Reflexive$T, Lit(R#0)) <==> (forall x#1: Box :: { $Unbox(Apply2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool, $Heap, R#0, x#1, x#1)): bool } $IsBox(x#1, Sorting._default.Reflexive$T) ==> $Unbox(Apply2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#1, x#1)): bool)));
}

function Sorting.__default.Reflexive#canCall(Sorting._default.Reflexive$T: Ty, R#0: HandleType) : bool;

function Sorting.__default.Reflexive#requires(Ty, HandleType) : bool;

axiom (forall Sorting._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Sorting.__default.Reflexive#requires(Sorting._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool)) ==> (Sorting.__default.Reflexive#requires(Sorting._default.Reflexive$T, R#0) <==> true));

procedure {:verboseName "Sorting.Reflexive (well-formedness)"} CheckWellformed$$Sorting.__default.Reflexive(Sorting._default.Reflexive$T: Ty where $AlwaysAllocated(Sorting._default.Reflexive$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Reflexive$T, Sorting._default.Reflexive$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Sorting.__default.AntiSymmetric(Sorting._default.AntiSymmetric$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Sorting._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Sorting.__default.AntiSymmetric(Sorting._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Sorting.__default.AntiSymmetric#canCall(Sorting._default.AntiSymmetric$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool))) ==> (Sorting.__default.AntiSymmetric(Sorting._default.AntiSymmetric$T, R#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, R#0, y#0, x#0)): bool } { $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Sorting._default.AntiSymmetric$T) && $IsBox(y#0, Sorting._default.AntiSymmetric$T) ==> $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, R#0, x#0, y#0)): bool && $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, R#0, y#0, x#0)): bool ==> x#0 == y#0)));
axiom 0 <= $FunctionContextHeight ==> (forall Sorting._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Sorting.__default.AntiSymmetric(Sorting._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Sorting.__default.AntiSymmetric#canCall(Sorting._default.AntiSymmetric$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool))) ==> (Sorting.__default.AntiSymmetric(Sorting._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, R#0, y#1, x#1)): bool } { $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Sorting._default.AntiSymmetric$T) && $IsBox(y#1, Sorting._default.AntiSymmetric$T) ==> $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool && $Unbox(Apply2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#1, x#1)): bool ==> x#1 == y#1)));
}

function Sorting.__default.AntiSymmetric#canCall(Sorting._default.AntiSymmetric$T: Ty, R#0: HandleType) : bool;

function Sorting.__default.AntiSymmetric#requires(Ty, HandleType) : bool;

axiom (forall Sorting._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Sorting.__default.AntiSymmetric#requires(Sorting._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool)) ==> (Sorting.__default.AntiSymmetric#requires(Sorting._default.AntiSymmetric$T, R#0) <==> true));

procedure {:verboseName "Sorting.AntiSymmetric (well-formedness)"} CheckWellformed$$Sorting.__default.AntiSymmetric(Sorting._default.AntiSymmetric$T: Ty where $AlwaysAllocated(Sorting._default.AntiSymmetric$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.AntiSymmetric$T, Sorting._default.AntiSymmetric$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Sorting.__default.Connected(Sorting._default.Connected$T: Ty, R#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Sorting._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Sorting.__default.Connected(Sorting._default.Connected$T, R#0), $IsGoodHeap($Heap) } Sorting.__default.Connected#canCall(Sorting._default.Connected$T, R#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool))) ==> (Sorting.__default.Connected(Sorting._default.Connected$T, R#0) <==> (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, R#0, y#0, x#0)): bool } { $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, R#0, x#0, y#0)): bool } $IsBox(x#0, Sorting._default.Connected$T) && $IsBox(y#0, Sorting._default.Connected$T) ==> $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, R#0, x#0, y#0)): bool || $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, R#0, y#0, x#0)): bool)));
axiom 0 <= $FunctionContextHeight ==> (forall Sorting._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Sorting.__default.Connected(Sorting._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Sorting.__default.Connected#canCall(Sorting._default.Connected$T, Lit(R#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool))) ==> (Sorting.__default.Connected(Sorting._default.Connected$T, Lit(R#0)) <==> (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, R#0, y#1, x#1)): bool } { $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, R#0, x#1, y#1)): bool } $IsBox(x#1, Sorting._default.Connected$T) && $IsBox(y#1, Sorting._default.Connected$T) ==> $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, Lit(R#0), x#1, y#1)): bool || $Unbox(Apply2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool, $Heap, Lit(R#0), y#1, x#1)): bool)));
}

function Sorting.__default.Connected#canCall(Sorting._default.Connected$T: Ty, R#0: HandleType) : bool;

function Sorting.__default.Connected#requires(Ty, HandleType) : bool;

axiom (forall Sorting._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Sorting.__default.Connected#requires(Sorting._default.Connected$T, R#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool)) ==> (Sorting.__default.Connected#requires(Sorting._default.Connected$T, R#0) <==> true));

procedure {:verboseName "Sorting.Connected (well-formedness)"} CheckWellformed$$Sorting.__default.Connected(Sorting._default.Connected$T: Ty where $AlwaysAllocated(Sorting._default.Connected$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.Connected$T, Sorting._default.Connected$T, TBool)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Sorting.__default.TotalOrdering(Sorting._default.TotalOrdering$T: Ty, R#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall Sorting._default.TotalOrdering$T: Ty, R#0: HandleType :: { Sorting.__default.TotalOrdering(Sorting._default.TotalOrdering$T, R#0) } Sorting.__default.TotalOrdering#canCall(Sorting._default.TotalOrdering$T, R#0) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.TotalOrdering$T, Sorting._default.TotalOrdering$T, TBool))) ==> Sorting.__default.Reflexive#canCall(Sorting._default.TotalOrdering$T, R#0) && (Sorting.__default.Reflexive(Sorting._default.TotalOrdering$T, R#0) ==> Sorting.__default.AntiSymmetric#canCall(Sorting._default.TotalOrdering$T, R#0) && (Sorting.__default.AntiSymmetric(Sorting._default.TotalOrdering$T, R#0) ==> StandardLibrary.__default.Transitive#canCall(Sorting._default.TotalOrdering$T, R#0) && (StandardLibrary.__default.Transitive(Sorting._default.TotalOrdering$T, R#0) ==> Sorting.__default.Connected#canCall(Sorting._default.TotalOrdering$T, R#0)))) && (Sorting.__default.TotalOrdering(Sorting._default.TotalOrdering$T, R#0) <==> Sorting.__default.Reflexive(Sorting._default.TotalOrdering$T, R#0) && Sorting.__default.AntiSymmetric(Sorting._default.TotalOrdering$T, R#0) && StandardLibrary.__default.Transitive(Sorting._default.TotalOrdering$T, R#0) && Sorting.__default.Connected(Sorting._default.TotalOrdering$T, R#0)));
axiom 1 <= $FunctionContextHeight ==> (forall Sorting._default.TotalOrdering$T: Ty, R#0: HandleType :: {:weight 3} { Sorting.__default.TotalOrdering(Sorting._default.TotalOrdering$T, Lit(R#0)) } Sorting.__default.TotalOrdering#canCall(Sorting._default.TotalOrdering$T, Lit(R#0)) || (1 < $FunctionContextHeight && $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.TotalOrdering$T, Sorting._default.TotalOrdering$T, TBool))) ==> Sorting.__default.Reflexive#canCall(Sorting._default.TotalOrdering$T, Lit(R#0)) && (Lit(Sorting.__default.Reflexive(Sorting._default.TotalOrdering$T, Lit(R#0))) ==> Sorting.__default.AntiSymmetric#canCall(Sorting._default.TotalOrdering$T, Lit(R#0)) && (Lit(Sorting.__default.AntiSymmetric(Sorting._default.TotalOrdering$T, Lit(R#0))) ==> StandardLibrary.__default.Transitive#canCall(Sorting._default.TotalOrdering$T, Lit(R#0)) && (Lit(StandardLibrary.__default.Transitive(Sorting._default.TotalOrdering$T, Lit(R#0))) ==> Sorting.__default.Connected#canCall(Sorting._default.TotalOrdering$T, Lit(R#0))))) && (Sorting.__default.TotalOrdering(Sorting._default.TotalOrdering$T, Lit(R#0)) <==> Lit(Sorting.__default.Reflexive(Sorting._default.TotalOrdering$T, Lit(R#0)) && Sorting.__default.AntiSymmetric(Sorting._default.TotalOrdering$T, Lit(R#0)) && StandardLibrary.__default.Transitive(Sorting._default.TotalOrdering$T, Lit(R#0)) && Sorting.__default.Connected(Sorting._default.TotalOrdering$T, Lit(R#0)))));
}

function Sorting.__default.TotalOrdering#canCall(Sorting._default.TotalOrdering$T: Ty, R#0: HandleType) : bool;

function Sorting.__default.TotalOrdering#requires(Ty, HandleType) : bool;

axiom (forall Sorting._default.TotalOrdering$T: Ty, R#0: HandleType :: { Sorting.__default.TotalOrdering#requires(Sorting._default.TotalOrdering$T, R#0) } $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.TotalOrdering$T, Sorting._default.TotalOrdering$T, TBool)) ==> (Sorting.__default.TotalOrdering#requires(Sorting._default.TotalOrdering$T, R#0) <==> true));

procedure {:verboseName "Sorting.TotalOrdering (well-formedness)"} CheckWellformed$$Sorting.__default.TotalOrdering(Sorting._default.TotalOrdering$T: Ty where $AlwaysAllocated(Sorting._default.TotalOrdering$T), R#0: HandleType where $Is(R#0, Tclass._System.___hTotalFunc2(Sorting._default.TotalOrdering$T, Sorting._default.TotalOrdering$T, TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Sorting.__default.LexicographicByteSeqBelow(x#0: Seq, y#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: { Sorting.__default.LexicographicByteSeqBelow(x#0, y#0) } Sorting.__default.LexicographicByteSeqBelow#canCall(x#0, y#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, LitInt(0)) && (Sorting.__default.LexicographicByteSeqBelow(x#0, y#0) <==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, LitInt(0))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: {:weight 3} { Sorting.__default.LexicographicByteSeqBelow(Lit(x#0), Lit(y#0)) } Sorting.__default.LexicographicByteSeqBelow#canCall(Lit(x#0), Lit(y#0)) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(Lit(x#0), Lit(y#0), LitInt(0)) && (Sorting.__default.LexicographicByteSeqBelow(Lit(x#0), Lit(y#0)) <==> Lit(Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), Lit(x#0), Lit(y#0), LitInt(0)))));
}

function Sorting.__default.LexicographicByteSeqBelow#canCall(x#0: Seq, y#0: Seq) : bool;

function Sorting.__default.LexicographicByteSeqBelow#requires(Seq, Seq) : bool;

axiom (forall x#0: Seq, y#0: Seq :: { Sorting.__default.LexicographicByteSeqBelow#requires(x#0, y#0) } $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Sorting.__default.LexicographicByteSeqBelow#requires(x#0, y#0) <==> true));

procedure {:verboseName "Sorting.LexicographicByteSeqBelow (well-formedness)"} CheckWellformed$$Sorting.__default.LexicographicByteSeqBelow(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.LexicographicByteSeqBelow (well-formedness)"} CheckWellformed$$Sorting.__default.LexicographicByteSeqBelow(x#0: Seq, y#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.LexicographicByteSeqBelow", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(46,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##n#0 := LitInt(0);
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##x#0);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##y#0);
    assume ##n#0 <= Seq#Length(##x#0) && ##n#0 <= Seq#Length(##y#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, LitInt(0));
    assume Sorting.__default.LexicographicByteSeqBelow(x#0, y#0) <==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, LitInt(0));
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, LitInt(0));
    assume $Is(Sorting.__default.LexicographicByteSeqBelow(x#0, y#0), TBool);
    return;
}



function Sorting.__default.LexicographicByteSeqBelowAux($ly: LayerType, x#0: Seq, y#0: Seq, n#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq, y#0: Seq, n#0: int :: { Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), x#0, y#0, n#0) } Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#0 && n#0 <= Seq#Length(x#0) && n#0 <= Seq#Length(y#0)) ==> (n#0 != Seq#Length(x#0) ==> !(n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) ==> n#0 != Seq#Length(y#0) ==> $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0 + 1)) && (Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), x#0, y#0, n#0) <==> n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($ly, x#0, y#0, n#0 + 1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq, y#0: Seq, n#0: int :: {:weight 3} { Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), Lit(x#0), y#0, LitInt(n#0)) } Sorting.__default.LexicographicByteSeqBelowAux#canCall(Lit(x#0), y#0, LitInt(n#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#0 && LitInt(n#0) <= Seq#Length(Lit(x#0)) && LitInt(n#0) <= Seq#Length(y#0)) ==> (LitInt(n#0) != Seq#Length(Lit(x#0)) ==> !(n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int < $Unbox(Seq#Index(y#0, LitInt(n#0))): int) ==> n#0 != Seq#Length(y#0) ==> $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int == $Unbox(Seq#Index(y#0, LitInt(n#0))): int ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(Lit(x#0), y#0, LitInt(n#0 + 1))) && (Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), Lit(x#0), y#0, LitInt(n#0)) <==> LitInt(n#0) == Seq#Length(Lit(x#0)) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int < $Unbox(Seq#Index(y#0, LitInt(n#0))): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int == $Unbox(Seq#Index(y#0, LitInt(n#0))): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), Lit(x#0), y#0, LitInt(n#0 + 1)))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq, y#0: Seq, n#0: int :: {:weight 3} { Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), Lit(x#0), Lit(y#0), LitInt(n#0)) } Sorting.__default.LexicographicByteSeqBelowAux#canCall(Lit(x#0), Lit(y#0), LitInt(n#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#0 && LitInt(n#0) <= Seq#Length(Lit(x#0)) && LitInt(n#0) <= Seq#Length(Lit(y#0))) ==> (LitInt(n#0) != Seq#Length(Lit(x#0)) ==> !(n#0 != Seq#Length(Lit(y#0)) && $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int < $Unbox(Seq#Index(Lit(y#0), LitInt(n#0))): int) ==> n#0 != Seq#Length(Lit(y#0)) ==> $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int == $Unbox(Seq#Index(Lit(y#0), LitInt(n#0))): int ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(Lit(x#0), Lit(y#0), LitInt(n#0 + 1))) && (Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), Lit(x#0), Lit(y#0), LitInt(n#0)) <==> LitInt(n#0) == Seq#Length(Lit(x#0)) || (n#0 != Seq#Length(Lit(y#0)) && $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int < $Unbox(Seq#Index(Lit(y#0), LitInt(n#0))): int) || (n#0 != Seq#Length(Lit(y#0)) && $Unbox(Seq#Index(Lit(x#0), LitInt(n#0))): int == $Unbox(Seq#Index(Lit(y#0), LitInt(n#0))): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), Lit(x#0), Lit(y#0), LitInt(n#0 + 1)))));
}

function Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0: Seq, y#0: Seq, n#0: int) : bool;

axiom (forall $ly: LayerType, x#0: Seq, y#0: Seq, n#0: int :: { Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), x#0, y#0, n#0) } Sorting.__default.LexicographicByteSeqBelowAux($LS($ly), x#0, y#0, n#0) <==> Sorting.__default.LexicographicByteSeqBelowAux($ly, x#0, y#0, n#0));

axiom (forall $ly: LayerType, x#0: Seq, y#0: Seq, n#0: int :: { Sorting.__default.LexicographicByteSeqBelowAux(AsFuelBottom($ly), x#0, y#0, n#0) } Sorting.__default.LexicographicByteSeqBelowAux($ly, x#0, y#0, n#0) <==> Sorting.__default.LexicographicByteSeqBelowAux($LZ, x#0, y#0, n#0));

function Sorting.__default.LexicographicByteSeqBelowAux#requires(LayerType, Seq, Seq, int) : bool;

axiom (forall $ly: LayerType, x#0: Seq, y#0: Seq, n#0: int :: { Sorting.__default.LexicographicByteSeqBelowAux#requires($ly, x#0, y#0, n#0) } $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#0 ==> (Sorting.__default.LexicographicByteSeqBelowAux#requires($ly, x#0, y#0, n#0) <==> n#0 <= Seq#Length(x#0) && n#0 <= Seq#Length(y#0)));

procedure {:verboseName "Sorting.LexicographicByteSeqBelowAux (well-formedness)"} CheckWellformed$$Sorting.__default.LexicographicByteSeqBelowAux(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())), n#0: int where LitInt(0) <= n#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.LexicographicByteSeqBelowAux (well-formedness)"} CheckWellformed$$Sorting.__default.LexicographicByteSeqBelowAux(x#0: Seq, y#0: Seq, n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.LexicographicByteSeqBelowAux", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(50,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume n#0 <= Seq#Length(x#0);
    assume n#0 <= Seq#Length(y#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} n#0 != Seq#Length(x#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} n#0 != Seq#Length(y#0);
    assume 0 <= n#0 && n#0 < Seq#Length(x#0);
    assume 0 <= n#0 && n#0 < Seq#Length(y#0);
    goto anon6;

  anon14_Else:
    assume {:partition} n#0 == Seq#Length(y#0);
    goto anon6;

  anon13_Else:
    assume {:partition} n#0 == Seq#Length(x#0);
    goto anon6;

  anon6:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} !(n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} n#0 != Seq#Length(y#0);
    assume 0 <= n#0 && n#0 < Seq#Length(x#0);
    assume 0 <= n#0 && n#0 < Seq#Length(y#0);
    goto anon9;

  anon16_Else:
    assume {:partition} n#0 == Seq#Length(y#0);
    goto anon9;

  anon9:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(n#0 + 1, Tclass._System.nat());
    ##n#0 := n#0 + 1;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##x#0);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##y#0);
    assume ##n#0 <= Seq#Length(##x#0) && ##n#0 <= Seq#Length(##y#0);
    assume 0 <= Seq#Length(x#0) - n#0 || Seq#Length(##x#0) - ##n#0 == Seq#Length(x#0) - n#0;
    assume Seq#Length(##x#0) - ##n#0 < Seq#Length(x#0) - n#0;
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0 + 1);
    goto anon11;

  anon17_Else:
    assume {:partition} !(n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int);
    goto anon11;

  anon15_Else:
    assume {:partition} n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int);
    goto anon11;

  anon11:
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) <==> n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0 + 1));
    assume n#0 != Seq#Length(x#0) ==> !(n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) ==> n#0 != Seq#Length(y#0) ==> $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0 + 1);
    assume $Is(Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0), TBool);
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelow (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelow();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function Sorting.__default.LexicographicByteSeqBelow#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $fh$0x#0, $fh$0x#1) } Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $fh$0x#0, $fh$0x#1) == $Box(Sorting.__default.LexicographicByteSeqBelow($Unbox($fh$0x#0): Seq, $Unbox($fh$0x#1): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Requires2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $fh$0x#0, $fh$0x#1) } Requires2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $fh$0x#0, $fh$0x#1) <==> Sorting.__default.LexicographicByteSeqBelow#requires($Unbox($fh$0x#0): Seq, $Unbox($fh$0x#1): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Reads2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $fh$0x#0, $fh$0x#1)[$bx] } Reads2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $fh$0x#0, $fh$0x#1)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq, $fh$0x#1: Seq :: { Sorting.__default.LexicographicByteSeqBelow($fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } Sorting.__default.LexicographicByteSeqBelow($fh$0x#0, $fh$0x#1) <==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box($fh$0x#0), $Box($fh$0x#1))): bool);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelow (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelow()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##R#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelow"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(59,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(60,25): post-state"} true;
    assume 1 != $FunctionContextHeight;
    ##R#0 := Sorting.__default.LexicographicByteSeqBelow#Handle();
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool), $Heap);
    assume Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume Sorting.__default.TotalOrdering(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelow (call precondtion)"} CallPre$$Sorting.__default.AboutLexicographicByteSeqBelow();



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelow (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelow();
  modifies $Heap;
  free ensures Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
  free ensures {:id "id16028"} Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) && Sorting.__default.TotalOrdering(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) && Sorting.__default.Reflexive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) && Sorting.__default.AntiSymmetric(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) && StandardLibrary.__default.Transitive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) && Sorting.__default.Connected(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelow (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelow() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
  free ensures {:id "id16029"} Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.TotalOrdering(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (Sorting.__default.Reflexive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.Reflexive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#4: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#4), $Box(x#4))): bool } $Is(x#4, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#4), $Box(x#4))): bool));
  free ensures {:id "id16030"} Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.TotalOrdering(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (Sorting.__default.AntiSymmetric#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.AntiSymmetric(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#5: Seq, y#3: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#3), $Box(x#5))): bool } { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#5), $Box(y#3))): bool } $Is(x#5, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#3, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#5), $Box(y#3))): bool && $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#3), $Box(x#5))): bool ==> x#5 == y#3));
  free ensures {:id "id16031"} Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.TotalOrdering(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (StandardLibrary.__default.Transitive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> StandardLibrary.__default.Transitive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#6: Seq, y#4: Seq, z#1: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#6), $Box(z#1))): bool, $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#4), $Box(z#1))): bool } { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#4), $Box(z#1))): bool, $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#6), $Box(y#4))): bool } $Is(x#6, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#4, TSeq(Tclass.BoundedInts.uint8())) && $Is(z#1, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#6), $Box(y#4))): bool && $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#4), $Box(z#1))): bool ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#6), $Box(z#1))): bool));
  free ensures {:id "id16032"} Sorting.__default.TotalOrdering#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.TotalOrdering(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (Sorting.__default.Connected#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.Connected(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#7: Seq, y#5: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#5), $Box(x#7))): bool } { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#7), $Box(y#5))): bool } $Is(x#7, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#5, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#7), $Box(y#5))): bool || $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#5), $Box(x#7))): bool));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelow (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelow() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##R#1: HandleType;
  var x#0_0_0: Seq;
  var n#0_0_0: int;
  var x##0_0_0: Seq;
  var n##0_0_0: int;
  var $initHeapForallStmt#0_0_0: Heap;
  var ##R#2: HandleType;
  var x#1_0_0: Seq;
  var y#1_0_0: Seq;
  var n#1_0_0: int;
  var ##x#1_0_0: Seq;
  var ##y#1_0_0: Seq;
  var ##n#1_0_0: int;
  var ##x#1_0_1: Seq;
  var ##y#1_0_1: Seq;
  var ##n#1_0_1: int;
  var x##1_0_0: Seq;
  var y##1_0_0: Seq;
  var n##1_0_0: int;
  var $initHeapForallStmt#1_0_0: Heap;
  var ##R#3: HandleType;
  var x#2_0_0: Seq;
  var y#2_0_0: Seq;
  var z#2_0_0: Seq;
  var n#2_0_0: int;
  var ##x#2_0_0: Seq;
  var ##y#2_0_0: Seq;
  var ##n#2_0_0: int;
  var ##x#2_0_1: Seq;
  var ##y#2_0_1: Seq;
  var ##n#2_0_1: int;
  var x##2_0_0: Seq;
  var y##2_0_0: Seq;
  var z##2_0_0: Seq;
  var n##2_0_0: int;
  var $initHeapForallStmt#2_0_0: Heap;
  var ##R#4: HandleType;
  var x#3_0_0: Seq;
  var y#3_0_0: Seq;
  var n#3_0_0: int;
  var x##3_0_0: Seq;
  var y##3_0_0: Seq;
  var n##3_0_0: int;
  var $initHeapForallStmt#3_0_0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelow"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(61,2): initial state"} true;
    $_reverifyPost := false;
    assume 1 != $FunctionContextHeight;
    ##R#1 := Sorting.__default.LexicographicByteSeqBelow#Handle();
    assume $IsAlloc(##R#1, Tclass._System.___hTotalFunc2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool), $Heap);
    assume Sorting.__default.Reflexive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume Sorting.__default.Reflexive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    goto anon41_Then, anon41_Else;

  anon41_Then:
    push;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    havoc x#0_0_0, n#0_0_0;
    assume $Is(x#0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(0) <= n#0_0_0;
    goto anon4;

  anon43_Else:
    assume {:partition} n#0_0_0 < LitInt(0);
    goto anon4;

  anon4:
    assume true;
    assume LitInt(0) <= n#0_0_0 && n#0_0_0 <= Seq#Length(x#0_0_0);
    assume true;
    x##0_0_0 := x#0_0_0;
    assume true;
    assume $Is(n#0_0_0, Tclass._System.nat());
    n##0_0_0 := n#0_0_0;
    call CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x##0_0_0, n##0_0_0);
    call CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x##0_0_0, n##0_0_0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(64,57)"} true;
    assume false;
    goto anon6;

  anon42_Else:
    $initHeapForallStmt#0_0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0_0_0 == $Heap;
    assume (forall x#0_0_1: Seq, n#0_0_1: int :: { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0_0_1, x#0_0_1, n#0_0_1) } $Is(x#0_0_1, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#0_0_1 && n#0_0_1 <= Seq#Length(x#0_0_1) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0_0_1, x#0_0_1, n#0_0_1));
    goto anon6;

  anon6:
    assume {:captureState "StandardLibrary/src/Sorting.dfy(65,6)"} true;
    pop;
    assume {:subsumption 0} Sorting.__default.Reflexive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.Reflexive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#8: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#8), $Box(x#8))): bool } $Is(x#8, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#8), $Box(x#8))): bool);
    assume false;
    goto anon7;

  anon41_Else:
    goto anon7;

  anon7:
    assume Sorting.__default.Reflexive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume {:captureState "StandardLibrary/src/Sorting.dfy(66,4)"} true;
    assume 1 != $FunctionContextHeight;
    ##R#2 := Sorting.__default.LexicographicByteSeqBelow#Handle();
    assume $IsAlloc(##R#2, Tclass._System.___hTotalFunc2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool), $Heap);
    assume Sorting.__default.AntiSymmetric#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume Sorting.__default.AntiSymmetric#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    goto anon44_Then, anon44_Else;

  anon44_Then:
    push;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    havoc x#1_0_0, y#1_0_0, n#1_0_0;
    assume $Is(x#1_0_0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#1_0_0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#1_0_0;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} n#1_0_0 <= Seq#Length(x#1_0_0);
    goto anon11;

  anon46_Else:
    assume {:partition} Seq#Length(x#1_0_0) < n#1_0_0;
    goto anon11;

  anon11:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0);
    assume {:subsumption 0} 0 <= n#1_0_0 && n#1_0_0 <= Seq#Length(x#1_0_0);
    assume {:subsumption 0} 0 <= n#1_0_0 && n#1_0_0 <= Seq#Length(y#1_0_0);
    goto anon13;

  anon47_Else:
    assume {:partition} !(n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0));
    goto anon13;

  anon13:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0) && Seq#Equal(Seq#Take(x#1_0_0, n#1_0_0), Seq#Take(y#1_0_0, n#1_0_0));
    ##x#1_0_0 := x#1_0_0;
    assume $IsAlloc(##x#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#1_0_0 := y#1_0_0;
    assume $IsAlloc(##y#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#1_0_0 := n#1_0_0;
    assume $IsAlloc(##n#1_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#1_0_0 <= Seq#Length(##x#1_0_0);
    assume {:subsumption 0} ##n#1_0_0 <= Seq#Length(##y#1_0_0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#1_0_0, y#1_0_0, n#1_0_0);
    goto anon15;

  anon48_Else:
    assume {:partition} !(n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0) && Seq#Equal(Seq#Take(x#1_0_0, n#1_0_0), Seq#Take(y#1_0_0, n#1_0_0)));
    goto anon15;

  anon15:
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0) && Seq#Equal(Seq#Take(x#1_0_0, n#1_0_0), Seq#Take(y#1_0_0, n#1_0_0)) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#1_0_0, y#1_0_0, n#1_0_0);
    ##x#1_0_1 := y#1_0_0;
    assume $IsAlloc(##x#1_0_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#1_0_1 := x#1_0_0;
    assume $IsAlloc(##y#1_0_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#1_0_1 := n#1_0_0;
    assume $IsAlloc(##n#1_0_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#1_0_1 <= Seq#Length(##x#1_0_1);
    assume {:subsumption 0} ##n#1_0_1 <= Seq#Length(##y#1_0_1);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#1_0_0, x#1_0_0, n#1_0_0);
    goto anon17;

  anon49_Else:
    assume {:partition} !(n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0) && Seq#Equal(Seq#Take(x#1_0_0, n#1_0_0), Seq#Take(y#1_0_0, n#1_0_0)) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#1_0_0, y#1_0_0, n#1_0_0));
    goto anon17;

  anon17:
    assume n#1_0_0 <= Seq#Length(x#1_0_0) ==> n#1_0_0 <= Seq#Length(y#1_0_0) ==> Seq#Equal(Seq#Take(x#1_0_0, n#1_0_0), Seq#Take(y#1_0_0, n#1_0_0)) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#1_0_0, y#1_0_0, n#1_0_0) && (Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#1_0_0, y#1_0_0, n#1_0_0) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#1_0_0, x#1_0_0, n#1_0_0));
    assume n#1_0_0 <= Seq#Length(x#1_0_0) && n#1_0_0 <= Seq#Length(y#1_0_0) && Seq#Equal(Seq#Take(x#1_0_0, n#1_0_0), Seq#Take(y#1_0_0, n#1_0_0)) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#1_0_0, y#1_0_0, n#1_0_0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#1_0_0, x#1_0_0, n#1_0_0);
    assume true;
    x##1_0_0 := x#1_0_0;
    assume true;
    y##1_0_0 := y#1_0_0;
    assume true;
    n##1_0_0 := n#1_0_0;
    call CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x##1_0_0, y##1_0_0, n##1_0_0);
    call CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x##1_0_0, y##1_0_0, n##1_0_0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(72,64)"} true;
    assume false;
    goto anon19;

  anon45_Else:
    $initHeapForallStmt#1_0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#1_0_0 == $Heap;
    assume (forall x#1_0_1: Seq, y#1_0_1: Seq, n#1_0_1: int :: { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#1_0_1, x#1_0_1, n#1_0_1) } { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#1_0_1, y#1_0_1, n#1_0_1) } { Seq#Take(y#1_0_1, n#1_0_1), Seq#Take(x#1_0_1, n#1_0_1) } { Seq#Take(y#1_0_1, n#1_0_1), Seq#Length(x#1_0_1) } { Seq#Take(x#1_0_1, n#1_0_1), Seq#Length(y#1_0_1) } $Is(x#1_0_1, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#1_0_1, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#1_0_1 && n#1_0_1 <= Seq#Length(x#1_0_1) && n#1_0_1 <= Seq#Length(y#1_0_1) && Seq#Equal(Seq#Take(x#1_0_1, n#1_0_1), Seq#Take(y#1_0_1, n#1_0_1)) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#1_0_1, y#1_0_1, n#1_0_1) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#1_0_1, x#1_0_1, n#1_0_1) ==> Seq#Equal(x#1_0_1, y#1_0_1));
    goto anon19;

  anon19:
    assume {:captureState "StandardLibrary/src/Sorting.dfy(73,6)"} true;
    pop;
    assume {:subsumption 0} Sorting.__default.AntiSymmetric#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.AntiSymmetric(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#9: Seq, y#6: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#6), $Box(x#9))): bool } { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#9), $Box(y#6))): bool } $Is(x#9, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#6, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#9), $Box(y#6))): bool && $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#6), $Box(x#9))): bool ==> x#9 == y#6);
    assume false;
    goto anon20;

  anon44_Else:
    goto anon20;

  anon20:
    assume Sorting.__default.AntiSymmetric(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume {:captureState "StandardLibrary/src/Sorting.dfy(74,4)"} true;
    assume 1 != $FunctionContextHeight;
    ##R#3 := Sorting.__default.LexicographicByteSeqBelow#Handle();
    assume $IsAlloc(##R#3, Tclass._System.___hTotalFunc2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool), $Heap);
    assume StandardLibrary.__default.Transitive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume StandardLibrary.__default.Transitive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    goto anon50_Then, anon50_Else;

  anon50_Then:
    push;
    goto anon51_Then, anon51_Else;

  anon51_Then:
    havoc x#2_0_0, y#2_0_0, z#2_0_0, n#2_0_0;
    assume $Is(x#2_0_0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#2_0_0, TSeq(Tclass.BoundedInts.uint8())) && $Is(z#2_0_0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#2_0_0;
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} n#2_0_0 <= Seq#Length(x#2_0_0);
    goto anon24;

  anon52_Else:
    assume {:partition} Seq#Length(x#2_0_0) < n#2_0_0;
    goto anon24;

  anon24:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0);
    goto anon26;

  anon53_Else:
    assume {:partition} !(n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0));
    goto anon26;

  anon26:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0) && n#2_0_0 <= Seq#Length(z#2_0_0);
    ##x#2_0_0 := x#2_0_0;
    assume $IsAlloc(##x#2_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#2_0_0 := y#2_0_0;
    assume $IsAlloc(##y#2_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#2_0_0 := n#2_0_0;
    assume $IsAlloc(##n#2_0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#2_0_0 <= Seq#Length(##x#2_0_0);
    assume {:subsumption 0} ##n#2_0_0 <= Seq#Length(##y#2_0_0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#2_0_0, y#2_0_0, n#2_0_0);
    goto anon28;

  anon54_Else:
    assume {:partition} !(n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0) && n#2_0_0 <= Seq#Length(z#2_0_0));
    goto anon28;

  anon28:
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0) && n#2_0_0 <= Seq#Length(z#2_0_0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_0, y#2_0_0, n#2_0_0);
    ##x#2_0_1 := y#2_0_0;
    assume $IsAlloc(##x#2_0_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#2_0_1 := z#2_0_0;
    assume $IsAlloc(##y#2_0_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#2_0_1 := n#2_0_0;
    assume $IsAlloc(##n#2_0_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#2_0_1 <= Seq#Length(##x#2_0_1);
    assume {:subsumption 0} ##n#2_0_1 <= Seq#Length(##y#2_0_1);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#2_0_0, z#2_0_0, n#2_0_0);
    goto anon30;

  anon55_Else:
    assume {:partition} !(n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0) && n#2_0_0 <= Seq#Length(z#2_0_0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_0, y#2_0_0, n#2_0_0));
    goto anon30;

  anon30:
    assume n#2_0_0 <= Seq#Length(x#2_0_0) ==> n#2_0_0 <= Seq#Length(y#2_0_0) ==> n#2_0_0 <= Seq#Length(z#2_0_0) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#2_0_0, y#2_0_0, n#2_0_0) && (Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_0, y#2_0_0, n#2_0_0) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#2_0_0, z#2_0_0, n#2_0_0));
    assume n#2_0_0 <= Seq#Length(x#2_0_0) && n#2_0_0 <= Seq#Length(y#2_0_0) && n#2_0_0 <= Seq#Length(z#2_0_0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_0, y#2_0_0, n#2_0_0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#2_0_0, z#2_0_0, n#2_0_0);
    assume true;
    x##2_0_0 := x#2_0_0;
    assume true;
    y##2_0_0 := y#2_0_0;
    assume true;
    z##2_0_0 := z#2_0_0;
    assume true;
    n##2_0_0 := n#2_0_0;
    call CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x##2_0_0, y##2_0_0, z##2_0_0, n##2_0_0);
    call CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x##2_0_0, y##2_0_0, z##2_0_0, n##2_0_0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(80,64)"} true;
    assume false;
    goto anon32;

  anon51_Else:
    $initHeapForallStmt#2_0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#2_0_0 == $Heap;
    assume (forall x#2_0_1: Seq, y#2_0_1: Seq, z#2_0_1: Seq, n#2_0_1: int :: { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_1, z#2_0_1, n#2_0_1), Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#2_0_1, z#2_0_1, n#2_0_1) } { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_1, z#2_0_1, n#2_0_1), Seq#Length(y#2_0_1) } { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#2_0_1, z#2_0_1, n#2_0_1), Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_1, y#2_0_1, n#2_0_1) } { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#2_0_1, z#2_0_1, n#2_0_1), Seq#Length(x#2_0_1) } { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_1, y#2_0_1, n#2_0_1), Seq#Length(z#2_0_1) } $Is(x#2_0_1, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#2_0_1, TSeq(Tclass.BoundedInts.uint8())) && $Is(z#2_0_1, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#2_0_1 && n#2_0_1 <= Seq#Length(x#2_0_1) && n#2_0_1 <= Seq#Length(y#2_0_1) && n#2_0_1 <= Seq#Length(z#2_0_1) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_1, y#2_0_1, n#2_0_1) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#2_0_1, z#2_0_1, n#2_0_1) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#2_0_1, z#2_0_1, n#2_0_1));
    goto anon32;

  anon32:
    assume {:captureState "StandardLibrary/src/Sorting.dfy(81,6)"} true;
    pop;
    assume {:subsumption 0} StandardLibrary.__default.Transitive#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> StandardLibrary.__default.Transitive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#10: Seq, y#7: Seq, z#2: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#10), $Box(z#2))): bool, $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#7), $Box(z#2))): bool } { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#7), $Box(z#2))): bool, $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#10), $Box(y#7))): bool } $Is(x#10, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#7, TSeq(Tclass.BoundedInts.uint8())) && $Is(z#2, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#10), $Box(y#7))): bool && $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#7), $Box(z#2))): bool ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#10), $Box(z#2))): bool);
    assume false;
    goto anon33;

  anon50_Else:
    goto anon33;

  anon33:
    assume StandardLibrary.__default.Transitive(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume {:captureState "StandardLibrary/src/Sorting.dfy(82,4)"} true;
    assume 1 != $FunctionContextHeight;
    ##R#4 := Sorting.__default.LexicographicByteSeqBelow#Handle();
    assume $IsAlloc(##R#4, Tclass._System.___hTotalFunc2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool), $Heap);
    assume Sorting.__default.Connected#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume Sorting.__default.Connected#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    goto anon56_Then, anon56_Else;

  anon56_Then:
    goto anon57_Then, anon57_Else;

  anon57_Then:
    havoc x#3_0_0, y#3_0_0, n#3_0_0;
    assume $Is(x#3_0_0, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#3_0_0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#3_0_0;
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} n#3_0_0 <= Seq#Length(x#3_0_0);
    goto anon37;

  anon58_Else:
    assume {:partition} Seq#Length(x#3_0_0) < n#3_0_0;
    goto anon37;

  anon37:
    assume true;
    assume n#3_0_0 <= Seq#Length(x#3_0_0) && n#3_0_0 <= Seq#Length(y#3_0_0);
    assume true;
    x##3_0_0 := x#3_0_0;
    assume true;
    y##3_0_0 := y#3_0_0;
    assume true;
    n##3_0_0 := n#3_0_0;
    call CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x##3_0_0, y##3_0_0, n##3_0_0);
    call CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x##3_0_0, y##3_0_0, n##3_0_0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(85,60)"} true;
    assume false;
    goto anon39;

  anon57_Else:
    $initHeapForallStmt#3_0_0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#3_0_0 == $Heap;
    assume (forall x#3_0_1: Seq, y#3_0_1: Seq, n#3_0_1: int :: { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#3_0_1, x#3_0_1, n#3_0_1) } { Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#3_0_1, y#3_0_1, n#3_0_1) } $Is(x#3_0_1, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#3_0_1, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= n#3_0_1 && n#3_0_1 <= Seq#Length(x#3_0_1) && n#3_0_1 <= Seq#Length(y#3_0_1) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#3_0_1, y#3_0_1, n#3_0_1) || Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#3_0_1, x#3_0_1, n#3_0_1));
    goto anon39;

  anon39:
    assume {:captureState "StandardLibrary/src/Sorting.dfy(86,6)"} true;
    assume {:subsumption 0} Sorting.__default.Connected#canCall(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) ==> Sorting.__default.Connected(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle()) || (forall x#11: Seq, y#8: Seq :: { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#8), $Box(x#11))): bool } { $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#11), $Box(y#8))): bool } $Is(x#11, TSeq(Tclass.BoundedInts.uint8())) && $Is(y#8, TSeq(Tclass.BoundedInts.uint8())) ==> $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(x#11), $Box(y#8))): bool || $Unbox(Apply2(TSeq(Tclass.BoundedInts.uint8()), TSeq(Tclass.BoundedInts.uint8()), TBool, $Heap, Sorting.__default.LexicographicByteSeqBelow#Handle(), $Box(y#8), $Box(x#11))): bool);
    assume false;
    goto anon40;

  anon56_Else:
    goto anon40;

  anon40:
    assume Sorting.__default.Connected(TSeq(Tclass.BoundedInts.uint8()), Sorting.__default.LexicographicByteSeqBelow#Handle());
    assume {:captureState "StandardLibrary/src/Sorting.dfy(87,4)"} true;
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive", " | ", x#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(90,8): initial state"} true;
    assume n#0 <= Seq#Length(x#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(92,40): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#0 := x#0;
    assume $IsAlloc(##y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##x#0);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##y#0);
    assume ##n#0 <= Seq#Length(##x#0) && ##n#0 <= Seq#Length(##y#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, x#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, x#0, n#0);
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (call precondtion)"} CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id16068"} n#0 <= Seq#Length(x#0);



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, x#0, n#0);
  free ensures {:id "id16069"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, x#0, n#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, x#0, n#0) && (n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(x#0, n#0)): int) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(x#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, x#0, n#0 + 1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id16070"} n#0 <= Seq#Length(x#0);
  modifies $Heap;
  free ensures Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, x#0, n#0);
  free ensures {:id "id16071"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, x#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, x#0, n#0) || n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(x#0, n#0)): int) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(x#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), x#0, x#0, n#0 + 1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive", " | ", x#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(94,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq, $ih#n0#0: int :: $Is($ih#x0#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= $ih#n0#0 && $ih#n0#0 <= Seq#Length($ih#x0#0) && 0 <= Seq#Length($ih#x0#0) - $ih#n0#0 && Seq#Length($ih#x0#0) - $ih#n0#0 < Seq#Length(x#0) - n#0 ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#x0#0, $ih#x0#0, $ih#n0#0));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq, y#0: Seq, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var ##n#0: int;
  var ##x#1: Seq;
  var ##y#1: Seq;
  var ##n#1: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(97,8): initial state"} true;
    assume n#0 <= Seq#Length(x#0);
    assume n#0 <= Seq#Length(y#0);
    assume 0 <= n#0 && n#0 <= Seq#Length(x#0);
    assume 0 <= n#0 && n#0 <= Seq#Length(y#0);
    assume Seq#Equal(Seq#Take(x#0, n#0), Seq#Take(y#0, n#0));
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##x#0);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##y#0);
    assume ##n#0 <= Seq#Length(##x#0) && ##n#0 <= Seq#Length(##y#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0);
    ##x#1 := y#0;
    assume $IsAlloc(##x#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#1 := x#0;
    assume $IsAlloc(##y#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#1 <= Seq#Length(##x#1);
    assume {:subsumption 0} ##n#1 <= Seq#Length(##y#1);
    assume ##n#1 <= Seq#Length(##x#1) && ##n#1 <= Seq#Length(##y#1);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, x#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, x#0, n#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(101,14): post-state"} true;
    assume Seq#Equal(x#0, y#0);
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (call precondtion)"} CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id16084"} n#0 <= Seq#Length(x#0);
  requires {:id "id16085"} n#0 <= Seq#Length(y#0);
  requires {:id "id16086"} Seq#Equal(Seq#Take(x#0, n#0), Seq#Take(y#0, n#0));
  requires {:id "id16087"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) || n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), x#0, y#0, n#0 + 1));
  requires {:id "id16088"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, x#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, x#0, n#0) || n#0 == Seq#Length(y#0) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(y#0, n#0)): int < $Unbox(Seq#Index(x#0, n#0)): int) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(y#0, n#0)): int == $Unbox(Seq#Index(x#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), y#0, x#0, n#0 + 1));



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id16089"} Seq#Equal(x#0, y#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id16090"} n#0 <= Seq#Length(x#0);
  requires {:id "id16091"} n#0 <= Seq#Length(y#0);
  requires {:id "id16092"} Seq#Equal(Seq#Take(x#0, n#0), Seq#Take(y#0, n#0));
  free requires {:id "id16093"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) && (n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0 + 1)));
  free requires {:id "id16094"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, x#0, n#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, x#0, n#0) && (n#0 == Seq#Length(y#0) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(y#0, n#0)): int < $Unbox(Seq#Index(x#0, n#0)): int) || (n#0 != Seq#Length(x#0) && $Unbox(Seq#Index(y#0, n#0)): int == $Unbox(Seq#Index(x#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, x#0, n#0 + 1)));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id16095"} Seq#Equal(x#0, y#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq, y#0: Seq, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(103,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq, $ih#y0#0: Seq, $ih#n0#0: int :: $Is($ih#x0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is($ih#y0#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= $ih#n0#0 && $ih#n0#0 <= Seq#Length($ih#x0#0) && $ih#n0#0 <= Seq#Length($ih#y0#0) && Seq#Equal(Seq#Take($ih#x0#0, $ih#n0#0), Seq#Take($ih#y0#0, $ih#n0#0)) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#x0#0, $ih#y0#0, $ih#n0#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#y0#0, $ih#x0#0, $ih#n0#0) && 0 <= Seq#Length($ih#x0#0) - $ih#n0#0 && Seq#Length($ih#x0#0) - $ih#n0#0 < Seq#Length(x#0) - n#0 ==> Seq#Equal($ih#x0#0, $ih#y0#0));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), z#0: Seq where $Is(z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq, y#0: Seq, z#0: Seq, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var ##n#0: int;
  var ##x#1: Seq;
  var ##y#1: Seq;
  var ##n#1: int;
  var ##x#2: Seq;
  var ##y#2: Seq;
  var ##n#2: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Transitive", " | ", x#0, " | ", y#0, " | ", z#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(106,8): initial state"} true;
    assume n#0 <= Seq#Length(x#0);
    assume n#0 <= Seq#Length(y#0);
    assume n#0 <= Seq#Length(z#0);
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##x#0);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##y#0);
    assume ##n#0 <= Seq#Length(##x#0) && ##n#0 <= Seq#Length(##y#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0);
    ##x#1 := y#0;
    assume $IsAlloc(##x#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#1 := z#0;
    assume $IsAlloc(##y#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#1 <= Seq#Length(##x#1);
    assume {:subsumption 0} ##n#1 <= Seq#Length(##y#1);
    assume ##n#1 <= Seq#Length(##x#1) && ##n#1 <= Seq#Length(##y#1);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, z#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, z#0, n#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(109,40): post-state"} true;
    ##x#2 := x#0;
    assume $IsAlloc(##x#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#2 := z#0;
    assume $IsAlloc(##y#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#2 := n#0;
    assume $IsAlloc(##n#2, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#2 <= Seq#Length(##x#2);
    assume {:subsumption 0} ##n#2 <= Seq#Length(##y#2);
    assume ##n#2 <= Seq#Length(##x#2) && ##n#2 <= Seq#Length(##y#2);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, z#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, z#0, n#0);
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (call precondtion)"} CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), z#0: Seq where $Is(z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id16108"} n#0 <= Seq#Length(x#0);
  requires {:id "id16109"} n#0 <= Seq#Length(y#0);
  requires {:id "id16110"} n#0 <= Seq#Length(z#0);
  requires {:id "id16111"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) || n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), x#0, y#0, n#0 + 1));
  requires {:id "id16112"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, z#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, z#0, n#0) || n#0 == Seq#Length(y#0) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(y#0, n#0)): int < $Unbox(Seq#Index(z#0, n#0)): int) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(y#0, n#0)): int == $Unbox(Seq#Index(z#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), y#0, z#0, n#0 + 1));



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), z#0: Seq where $Is(z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, z#0, n#0);
  free ensures {:id "id16113"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, z#0, n#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, z#0, n#0) && (n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(z#0, n#0)): int) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(z#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, z#0, n#0 + 1)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), z#0: Seq where $Is(z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id16114"} n#0 <= Seq#Length(x#0);
  requires {:id "id16115"} n#0 <= Seq#Length(y#0);
  requires {:id "id16116"} n#0 <= Seq#Length(z#0);
  free requires {:id "id16117"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) && (n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(y#0, n#0)): int) || (n#0 != Seq#Length(y#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(y#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0 + 1)));
  free requires {:id "id16118"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, z#0, n#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, z#0, n#0) && (n#0 == Seq#Length(y#0) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(y#0, n#0)): int < $Unbox(Seq#Index(z#0, n#0)): int) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(y#0, n#0)): int == $Unbox(Seq#Index(z#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, z#0, n#0 + 1)));
  modifies $Heap;
  free ensures Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, z#0, n#0);
  free ensures {:id "id16119"} Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, z#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, z#0, n#0) || n#0 == Seq#Length(x#0) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(x#0, n#0)): int < $Unbox(Seq#Index(z#0, n#0)): int) || (n#0 != Seq#Length(z#0) && $Unbox(Seq#Index(x#0, n#0)): int == $Unbox(Seq#Index(z#0, n#0)): int && Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), x#0, z#0, n#0 + 1));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq, y#0: Seq, z#0: Seq, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Transitive", " | ", x#0, " | ", y#0, " | ", z#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(111,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq, $ih#y0#0: Seq, $ih#z0#0: Seq, $ih#n0#0: int :: $Is($ih#x0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is($ih#y0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is($ih#z0#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= $ih#n0#0 && $ih#n0#0 <= Seq#Length($ih#x0#0) && $ih#n0#0 <= Seq#Length($ih#y0#0) && $ih#n0#0 <= Seq#Length($ih#z0#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#x0#0, $ih#y0#0, $ih#n0#0) && Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#y0#0, $ih#z0#0, $ih#n0#0) && 0 <= Seq#Length($ih#x0#0) - $ih#n0#0 && Seq#Length($ih#x0#0) - $ih#n0#0 < Seq#Length(x#0) - n#0 ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#x0#0, $ih#z0#0, $ih#n0#0));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (well-formedness)"} CheckWellFormed$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq, y#0: Seq, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var ##n#0: int;
  var ##x#1: Seq;
  var ##y#1: Seq;
  var ##n#1: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Connected", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(114,8): initial state"} true;
    assume n#0 <= Seq#Length(x#0);
    assume n#0 <= Seq#Length(y#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(116,50): post-state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##x#0);
    assume {:subsumption 0} ##n#0 <= Seq#Length(##y#0);
    assume ##n#0 <= Seq#Length(##x#0) && ##n#0 <= Seq#Length(##y#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0);
    return;

  anon4_Else:
    assume !Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0);
    ##x#1 := y#0;
    assume $IsAlloc(##x#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##y#1 := x#0;
    assume $IsAlloc(##y#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##n#1 <= Seq#Length(##x#1);
    assume {:subsumption 0} ##n#1 <= Seq#Length(##y#1);
    assume ##n#1 <= Seq#Length(##x#1) && ##n#1 <= Seq#Length(##y#1);
    assume Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, x#0, n#0);
    assume Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), y#0, x#0, n#0);
    return;
}



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (call precondtion)"} CallPre$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  requires {:id "id16129"} n#0 <= Seq#Length(x#0);
  requires {:id "id16130"} n#0 <= Seq#Length(y#0);



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) && (!Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, x#0, n#0));
  free ensures {:id "id16131"} Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), x#0, y#0, n#0) || Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), y#0, x#0, n#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), y#0: Seq where $Is(y#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id16132"} n#0 <= Seq#Length(x#0);
  requires {:id "id16133"} n#0 <= Seq#Length(y#0);
  modifies $Heap;
  free ensures Sorting.__default.LexicographicByteSeqBelowAux#canCall(x#0, y#0, n#0) && (!Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), x#0, y#0, n#0) ==> Sorting.__default.LexicographicByteSeqBelowAux#canCall(y#0, x#0, n#0));
  free ensures {:id "id16134"} Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), x#0, y#0, n#0) || Sorting.__default.LexicographicByteSeqBelowAux($LS($LS($LZ)), y#0, x#0, n#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (correctness)"} Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq, y#0: Seq, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Connected", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(118,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq, $ih#y0#0: Seq, $ih#n0#0: int :: $Is($ih#x0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is($ih#y0#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= $ih#n0#0 && $ih#n0#0 <= Seq#Length($ih#x0#0) && $ih#n0#0 <= Seq#Length($ih#y0#0) && 0 <= Seq#Length($ih#x0#0) - $ih#n0#0 && Seq#Length($ih#x0#0) - $ih#n0#0 < Seq#Length(x#0) - n#0 ==> Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#x0#0, $ih#y0#0, $ih#n0#0) || Sorting.__default.LexicographicByteSeqBelowAux($LS($LZ), $ih#y0#0, $ih#x0#0, $ih#n0#0));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Sorting.SelectionSort (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty where $AlwaysAllocated(Sorting._default.SelectionSort$Data), a#0: ref where $Is(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data)) && $IsAlloc(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data), $Heap), below#0: HandleType where $Is(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool)) && $IsAlloc(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.SelectionSort (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty, a#0: ref, below#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##R#0: HandleType;
  var ##R#1: HandleType;
  var i#0: int;
  var j#0: int;

  anon0:
    assume {:print "Impl", " | ", "Sorting.SelectionSort", " | ", Sorting._default.SelectionSort$Data, " | ", a#0, " | ", below#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == a#0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(125,38): initial state"} true;
    ##R#0 := below#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool), $Heap);
    assume StandardLibrary.__default.Transitive#canCall(Sorting._default.SelectionSort$Data, below#0);
    assume StandardLibrary.__default.Transitive(Sorting._default.SelectionSort$Data, below#0);
    ##R#1 := below#0;
    assume $IsAlloc(##R#1, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool), $Heap);
    assume Sorting.__default.Connected#canCall(Sorting._default.SelectionSort$Data, below#0);
    assume Sorting.__default.Connected(Sorting._default.SelectionSort$Data, below#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == a#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(129,28): post-state"} true;
    assume a#0 != null;
    assume a#0 != null;
    assume $IsAlloc(a#0, Tclass._System.array?(Sorting._default.SelectionSort$Data), old($Heap));
    assume MultiSet#Equal(MultiSet#FromSeq(Seq#FromArray($Heap, a#0)), MultiSet#FromSeq(Seq#FromArray(old($Heap), a#0)));
    havoc i#0;
    havoc j#0;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon10_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < j#0;
    assume a#0 != null;
    goto anon6;

  anon11_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < j#0);
    goto anon6;

  anon6:
    assume LitInt(0) <= i#0 && i#0 < j#0 && j#0 < _System.array.Length(a#0);
    assume a#0 != null;
    assume 0 <= i#0 && i#0 < _System.array.Length(a#0);
    assume a#0 != null;
    assume 0 <= j#0 && j#0 < _System.array.Length(a#0);
    assume $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#0)), read($Heap, a#0, IndexField(j#0)))): bool;
    goto anon8;

  anon9_Else:
    assume LitInt(0) <= i#0 && i#0 < j#0 && j#0 < _System.array.Length(a#0) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#0)), read($Heap, a#0, IndexField(j#0)))): bool;
    goto anon8;

  anon8:
    assume (forall i#1: int, j#1: int :: { read($Heap, a#0, IndexField(j#1)), read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < _System.array.Length(a#0) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#1)), read($Heap, a#0, IndexField(j#1)))): bool);
    return;
}



procedure {:verboseName "Sorting.SelectionSort (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty where $AlwaysAllocated(Sorting._default.SelectionSort$Data), a#0: ref where $Is(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data)) && $IsAlloc(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data), $Heap), below#0: HandleType where $Is(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool)) && $IsAlloc(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool), $Heap));
  requires {:id "id16150"} StandardLibrary.__default.Transitive#canCall(Sorting._default.SelectionSort$Data, below#0) ==> StandardLibrary.__default.Transitive(Sorting._default.SelectionSort$Data, below#0) || (forall x#0: Box, y#0: Box, z#0: Box :: { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#0, z#0)): bool, $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#0, z#0)): bool } { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#0, z#0)): bool, $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#0, y#0)): bool } $IsBox(x#0, Sorting._default.SelectionSort$Data) && $IsBox(y#0, Sorting._default.SelectionSort$Data) && $IsBox(z#0, Sorting._default.SelectionSort$Data) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#0, y#0)): bool && $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#0, z#0)): bool ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#0, z#0)): bool);
  requires {:id "id16151"} Sorting.__default.Connected#canCall(Sorting._default.SelectionSort$Data, below#0) ==> Sorting.__default.Connected(Sorting._default.SelectionSort$Data, below#0) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#1, x#1)): bool } { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#1, y#1)): bool } $IsBox(x#1, Sorting._default.SelectionSort$Data) && $IsBox(y#1, Sorting._default.SelectionSort$Data) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#1, y#1)): bool || $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#1, x#1)): bool);



procedure {:verboseName "Sorting.SelectionSort (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty where $AlwaysAllocated(Sorting._default.SelectionSort$Data), a#0: ref where $Is(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data)) && $IsAlloc(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data), $Heap), below#0: HandleType where $Is(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool)) && $IsAlloc(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id16152"} MultiSet#Equal(MultiSet#FromSeq(Seq#FromArray($Heap, a#0)), MultiSet#FromSeq(Seq#FromArray(old($Heap), a#0)));
  free ensures true;
  free ensures {:id "id16153"} (forall i#1: int, j#1: int :: { read($Heap, a#0, IndexField(j#1)), read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < _System.array.Length(a#0) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#1)), read($Heap, a#0, IndexField(j#1)))): bool);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == a#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Sorting.SelectionSort (correctness)"} {:vcs_split_on_every_assert} Impl$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty where $AlwaysAllocated(Sorting._default.SelectionSort$Data), a#0: ref where $Is(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data)) && $IsAlloc(a#0, Tclass._System.array(Sorting._default.SelectionSort$Data), $Heap), below#0: HandleType where $Is(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool)) && $IsAlloc(below#0, Tclass._System.___hTotalFunc2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id16154"} StandardLibrary.__default.Transitive#canCall(Sorting._default.SelectionSort$Data, below#0) && StandardLibrary.__default.Transitive(Sorting._default.SelectionSort$Data, below#0) && (forall x#2: Box, y#2: Box, z#1: Box :: { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#2, z#1)): bool, $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#2, z#1)): bool } { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#2, z#1)): bool, $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#2, y#2)): bool } $IsBox(x#2, Sorting._default.SelectionSort$Data) && $IsBox(y#2, Sorting._default.SelectionSort$Data) && $IsBox(z#1, Sorting._default.SelectionSort$Data) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#2, y#2)): bool && $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#2, z#1)): bool ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#2, z#1)): bool);
  free requires {:id "id16155"} Sorting.__default.Connected#canCall(Sorting._default.SelectionSort$Data, below#0) && Sorting.__default.Connected(Sorting._default.SelectionSort$Data, below#0) && (forall x#3: Box, y#3: Box :: { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#3, x#3)): bool } { $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#3, y#3)): bool } $IsBox(x#3, Sorting._default.SelectionSort$Data) && $IsBox(y#3, Sorting._default.SelectionSort$Data) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, x#3, y#3)): bool || $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, y#3, x#3)): bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id16156"} MultiSet#Equal(MultiSet#FromSeq(Seq#FromArray($Heap, a#0)), MultiSet#FromSeq(Seq#FromArray(old($Heap), a#0)));
  free ensures true;
  free ensures {:id "id16157"} (forall i#1: int, j#1: int :: { read($Heap, a#0, IndexField(j#1)), read($Heap, a#0, IndexField(i#1)) } LitInt(0) <= i#1 && i#1 < j#1 && j#1 < _System.array.Length(a#0) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#1)), read($Heap, a#0, IndexField(j#1)))): bool);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == a#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Sorting.SelectionSort (correctness)"} {:vcs_split_on_every_assert} Impl$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty, a#0: ref, below#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var m#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var i#2: int;
  var j#2: int;
  var i#4: int;
  var j#4: int;
  var $decr$loop#00: int;
  var mindex#0_0: int;
  var n#0_0: int;
  var $rhs#0_0: int;
  var $rhs#0_1: int;
  var $PreLoopHeap$loop#0_0: Heap;
  var $decr_init$loop#0_00: int;
  var $w$loop#0_0: bool;
  var i#0_0: int;
  var $decr$loop#0_00: int;
  var $obj0: ref;
  var $index0: Field;
  var $obj1: ref;
  var $index1: Field;
  var $rhs#0_2: Box;
  var $rhs#0_3: Box;

  anon0:
    assume {:print "Impl", " | ", "Sorting.SelectionSort", " | ", Sorting._default.SelectionSort$Data, " | ", a#0, " | ", below#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == a#0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(131,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    m#0 := LitInt(0);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(132,14)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := _System.array.Length(a#0) - m#0;
    havoc $w$loop#0;
    goto anon42_LoopHead;

  anon42_LoopHead:
    assume true;
    assume $w$loop#0 ==> LitInt(0) <= m#0;
    assume $w$loop#0 ==> m#0 <= _System.array.Length(a#0);
    assume true;
    assume $w$loop#0 ==> MultiSet#Equal(MultiSet#FromSeq(Seq#FromArray($Heap, a#0)), MultiSet#FromSeq(Seq#FromArray(old($Heap), a#0)));
    assume true;
    assume $w$loop#0 ==> (forall i#3: int, j#3: int :: { read($Heap, a#0, IndexField(j#3)), read($Heap, a#0, IndexField(i#3)) } LitInt(0) <= i#3 && i#3 < j#3 && j#3 < m#0 ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#3)), read($Heap, a#0, IndexField(j#3)))): bool);
    assume true;
    assume $w$loop#0 ==> (forall i#5: int, j#5: int :: { read($Heap, a#0, IndexField(j#5)), read($Heap, a#0, IndexField(i#5)) } LitInt(0) <= i#5 && i#5 < m#0 && m#0 <= j#5 && j#5 < _System.array.Length(a#0) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#5)), read($Heap, a#0, IndexField(j#5)))): bool);
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o] || $o == a#0);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume _System.array.Length(a#0) - m#0 <= $decr_init$loop#00;
    goto anon42_LoopDone, anon42_LoopBody;

  anon42_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(133,4): after some loop iterations"} true;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} !$w$loop#0;
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(0) <= m#0;
    assume {:subsumption 0} a#0 != null;
    goto anon4;

  anon44_Else:
    assume {:partition} m#0 < LitInt(0);
    goto anon4;

  anon4:
    assume true;
    assume LitInt(0) <= m#0 && m#0 <= _System.array.Length(a#0);
    assume a#0 != null;
    assume a#0 != null;
    assume $IsAlloc(a#0, Tclass._System.array?(Sorting._default.SelectionSort$Data), old($Heap));
    assume true;
    assume MultiSet#Equal(MultiSet#FromSeq(Seq#FromArray($Heap, a#0)), MultiSet#FromSeq(Seq#FromArray(old($Heap), a#0)));
    havoc i#2;
    havoc j#2;
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} true;
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon7;

  anon46_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon7;

  anon7:
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < j#2;
    goto anon9;

  anon47_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < j#2);
    goto anon9;

  anon9:
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < j#2 && j#2 < m#0;
    assume a#0 != null;
    assume {:subsumption 0} 0 <= i#2 && i#2 < _System.array.Length(a#0);
    assume a#0 != null;
    assume {:subsumption 0} 0 <= j#2 && j#2 < _System.array.Length(a#0);
    goto anon11;

  anon48_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < j#2 && j#2 < m#0);
    goto anon11;

  anon45_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    assume true;
    assume (forall i#3: int, j#3: int :: { read($Heap, a#0, IndexField(j#3)), read($Heap, a#0, IndexField(i#3)) } LitInt(0) <= i#3 && i#3 < j#3 && j#3 < m#0 ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#3)), read($Heap, a#0, IndexField(j#3)))): bool);
    havoc i#4;
    havoc j#4;
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} true;
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon14;

  anon50_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon14;

  anon14:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < m#0;
    goto anon16;

  anon51_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < m#0);
    goto anon16;

  anon16:
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < m#0 && m#0 <= j#4;
    assume {:subsumption 0} a#0 != null;
    goto anon18;

  anon52_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < m#0 && m#0 <= j#4);
    goto anon18;

  anon18:
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} LitInt(0) <= i#4 && i#4 < m#0 && m#0 <= j#4 && j#4 < _System.array.Length(a#0);
    assume a#0 != null;
    assume {:subsumption 0} 0 <= i#4 && i#4 < _System.array.Length(a#0);
    assume a#0 != null;
    assume {:subsumption 0} 0 <= j#4 && j#4 < _System.array.Length(a#0);
    goto anon20;

  anon53_Else:
    assume {:partition} !(LitInt(0) <= i#4 && i#4 < m#0 && m#0 <= j#4 && j#4 < _System.array.Length(a#0));
    goto anon20;

  anon49_Else:
    assume {:partition} false;
    goto anon20;

  anon20:
    assume true;
    assume (forall i#5: int, j#5: int :: { read($Heap, a#0, IndexField(j#5)), read($Heap, a#0, IndexField(i#5)) } LitInt(0) <= i#5 && i#5 < m#0 && m#0 <= j#5 && j#5 < _System.array.Length(a#0) ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(i#5)), read($Heap, a#0, IndexField(j#5)))): bool);
    assume a#0 != null;
    assume true;
    assume false;
    goto anon21;

  anon43_Else:
    assume {:partition} $w$loop#0;
    goto anon21;

  anon21:
    assume a#0 != null;
    assume true;
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} _System.array.Length(a#0) <= m#0;
    return;

  anon54_Else:
    assume {:partition} m#0 < _System.array.Length(a#0);
    $decr$loop#00 := _System.array.Length(a#0) - m#0;
    assume true;
    assume true;
    assume true;
    $rhs#0_0 := m#0;
    assume true;
    $rhs#0_1 := m#0 + 1;
    mindex#0_0 := $rhs#0_0;
    n#0_0 := $rhs#0_1;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(140,31)"} true;
    $PreLoopHeap$loop#0_0 := $Heap;
    $decr_init$loop#0_00 := _System.array.Length(a#0) - n#0_0;
    havoc $w$loop#0_0;
    goto anon55_LoopHead;

  anon55_LoopHead:
    assume true;
    assume $w$loop#0_0 ==> m#0 <= mindex#0_0;
    assume $w$loop#0_0 ==> mindex#0_0 < n#0_0;
    assume $w$loop#0_0 ==> n#0_0 <= _System.array.Length(a#0);
    assume true;
    assume $w$loop#0_0 ==> (forall i#0_1: int :: { read($Heap, a#0, IndexField(i#0_1)) } m#0 <= i#0_1 && i#0_1 < n#0_0 ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(mindex#0_0)), read($Heap, a#0, IndexField(i#0_1)))): bool);
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0_0[$o] || $o == a#0);
    assume $HeapSucc($PreLoopHeap$loop#0_0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0_0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0_0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume _System.array.Length(a#0) - n#0_0 <= $decr_init$loop#0_00;
    goto anon55_LoopDone, anon55_LoopBody;

  anon55_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(141,6): after some loop iterations"} true;
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} !$w$loop#0_0;
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} m#0 <= mindex#0_0;
    goto anon27;

  anon57_Else:
    assume {:partition} mindex#0_0 < m#0;
    goto anon27;

  anon27:
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} m#0 <= mindex#0_0 && mindex#0_0 < n#0_0;
    assume {:subsumption 0} a#0 != null;
    goto anon29;

  anon58_Else:
    assume {:partition} !(m#0 <= mindex#0_0 && mindex#0_0 < n#0_0);
    goto anon29;

  anon29:
    assume true;
    assume m#0 <= mindex#0_0 && mindex#0_0 < n#0_0 && n#0_0 <= _System.array.Length(a#0);
    havoc i#0_0;
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} true;
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} m#0 <= i#0_0;
    goto anon32;

  anon60_Else:
    assume {:partition} i#0_0 < m#0;
    goto anon32;

  anon32:
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} m#0 <= i#0_0 && i#0_0 < n#0_0;
    assume a#0 != null;
    assume {:subsumption 0} 0 <= mindex#0_0 && mindex#0_0 < _System.array.Length(a#0);
    assume a#0 != null;
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < _System.array.Length(a#0);
    goto anon34;

  anon61_Else:
    assume {:partition} !(m#0 <= i#0_0 && i#0_0 < n#0_0);
    goto anon34;

  anon59_Else:
    assume {:partition} false;
    goto anon34;

  anon34:
    assume true;
    assume (forall i#0_1: int :: { read($Heap, a#0, IndexField(i#0_1)) } m#0 <= i#0_1 && i#0_1 < n#0_0 ==> $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(mindex#0_0)), read($Heap, a#0, IndexField(i#0_1)))): bool);
    assume a#0 != null;
    assume true;
    assume false;
    goto anon35;

  anon56_Else:
    assume {:partition} $w$loop#0_0;
    goto anon35;

  anon35:
    assume a#0 != null;
    assume true;
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume {:partition} _System.array.Length(a#0) <= n#0_0;
    goto anon41;

  anon62_Else:
    assume {:partition} n#0_0 < _System.array.Length(a#0);
    $decr$loop#0_00 := _System.array.Length(a#0) - n#0_0;
    push;
    assume a#0 != null;
    assume 0 <= mindex#0_0 && mindex#0_0 < _System.array.Length(a#0);
    assume a#0 != null;
    assume 0 <= n#0_0 && n#0_0 < _System.array.Length(a#0);
    assume true;
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} !$Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(mindex#0_0)), read($Heap, a#0, IndexField(n#0_0)))): bool;
    push;
    assume true;
    assume true;
    mindex#0_0 := n#0_0;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(146,21)"} true;
    pop;
    goto anon40;

  anon63_Else:
    assume {:partition} $Unbox(Apply2(Sorting._default.SelectionSort$Data, Sorting._default.SelectionSort$Data, TBool, $Heap, below#0, read($Heap, a#0, IndexField(mindex#0_0)), read($Heap, a#0, IndexField(n#0_0)))): bool;
    goto anon40;

  anon40:
    assume true;
    assume true;
    n#0_0 := n#0_0 + 1;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(148,18)"} true;
    pop;
    assume 0 <= $decr$loop#0_00 || _System.array.Length(a#0) - n#0_0 == $decr$loop#0_00;
    assume _System.array.Length(a#0) - n#0_0 < $decr$loop#0_00;
    assume true;
    goto anon55_LoopHead;

  anon55_LoopDone:
    assume {:partition} false;
    goto anon41;

  anon41:
    assume a#0 != null;
    assume 0 <= m#0 && m#0 < _System.array.Length(a#0);
    assume true;
    $obj0 := a#0;
    $index0 := IndexField(m#0);
    assume $_ModifiesFrame[$obj0, $index0];
    assume a#0 != null;
    assume 0 <= mindex#0_0 && mindex#0_0 < _System.array.Length(a#0);
    assume true;
    $obj1 := a#0;
    $index1 := IndexField(mindex#0_0);
    assume $_ModifiesFrame[$obj1, $index1];
    assume a#0 != null;
    assume 0 <= mindex#0_0 && mindex#0_0 < _System.array.Length(a#0);
    assume true;
    $rhs#0_2 := read($Heap, a#0, IndexField(mindex#0_0));
    assume a#0 != null;
    assume 0 <= m#0 && m#0 < _System.array.Length(a#0);
    assume true;
    $rhs#0_3 := read($Heap, a#0, IndexField(m#0));
    assume a#0 != a#0 || mindex#0_0 != m#0 || $rhs#0_3 == $rhs#0_2;
    $Heap := update($Heap, $obj0, $index0, $rhs#0_2);
    assume $IsGoodHeap($Heap);
    $Heap := update($Heap, $obj1, $index1, $rhs#0_3);
    assume $IsGoodHeap($Heap);
    assume {:captureState "StandardLibrary/src/Sorting.dfy(150,40)"} true;
    assume true;
    assume true;
    m#0 := m#0 + 1;
    assume {:captureState "StandardLibrary/src/Sorting.dfy(151,16)"} true;
    assume 0 <= $decr$loop#00 || _System.array.Length(a#0) - m#0 == $decr$loop#00;
    assume _System.array.Length(a#0) - m#0 < $decr$loop#00;
    assume true;
    goto anon42_LoopHead;

  anon42_LoopDone:
    assume {:partition} false;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#96 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#96))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#98 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#98)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#144 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#144))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#146 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#146)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#148 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#148)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#144 := Wrappers.Option.value(this); v#144)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#146 := Lit(Wrappers.Option.value(Lit(this))); v#146)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#148 := Lit(Wrappers.Option.value(Lit(this))); v#148)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#96 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#96)) else (var e#96 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#98 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#98))) else (var e#98 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#144 := Wrappers.Result.value(this); s#144) else (var e#144 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#146 := Lit(Wrappers.Result.value(Lit(this))); s#146) else (var e#146 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#148 := Lit(Wrappers.Result.value(Lit(this))); s#148) else (var e#148 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#144 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#144)) else (var e#144 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#144)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#146 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#146))) else (var e#146 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#146)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#148 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#148))) else (var e#148 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#148)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#32 := Div(x#0, LitInt(256)); (var b1#32 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#32)), $Box(b1#32)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#33 := LitInt(Div(x#0, LitInt(256))); (var b1#33 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#33)), $Box(b1#33))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#32 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#32 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#33 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#33 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#32 := Div(x#0, LitInt(16777216)); (var x0#32 := x#0 - Mul(b0#32, LitInt(16777216)); (var b1#32 := Div(x0#32, LitInt(65536)); (var x1#32 := x0#32 - Mul(b1#32, LitInt(65536)); (var b2#32 := Div(x1#32, LitInt(256)); (var b3#32 := Mod(x1#32, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#32)), $Box(b1#32)), $Box(b2#32)), $Box(b3#32)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#33 := LitInt(Div(x#0, LitInt(16777216))); (var x0#33 := LitInt(x#0 - Mul(b0#33, LitInt(16777216))); (var b1#33 := LitInt(Div(x0#33, LitInt(65536))); (var x1#33 := LitInt(x0#33 - Mul(b1#33, LitInt(65536))); (var b2#33 := LitInt(Div(x1#33, LitInt(256))); (var b3#33 := LitInt(Mod(x1#33, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#33)), $Box(b1#33)), $Box(b2#33)), $Box(b3#33))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#32 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#32 := x0#32 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#32 := x1#32 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#32 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#33 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#33 := x0#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#33 := x1#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#33 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#32 := Div(x#0, LitInt(72057594037927936)); (var x0#32 := x#0 - Mul(b0#32, LitInt(72057594037927936)); (var b1#32 := Div(x0#32, LitInt(281474976710656)); (var x1#32 := x0#32 - Mul(b1#32, LitInt(281474976710656)); (var b2#32 := Div(x1#32, LitInt(1099511627776)); (var x2#32 := x1#32 - Mul(b2#32, LitInt(1099511627776)); (var b3#32 := Div(x2#32, LitInt(4294967296)); (var x3#32 := x2#32 - Mul(b3#32, LitInt(4294967296)); (var b4#32 := Div(x3#32, LitInt(16777216)); (var x4#32 := x3#32 - Mul(b4#32, LitInt(16777216)); (var b5#32 := Div(x4#32, LitInt(65536)); (var x5#32 := x4#32 - Mul(b5#32, LitInt(65536)); (var b6#32 := Div(x5#32, LitInt(256)); (var b7#32 := Mod(x5#32, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#32)), $Box(b1#32)), $Box(b2#32)), $Box(b3#32)), $Box(b4#32)), $Box(b5#32)), $Box(b6#32)), $Box(b7#32)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#33 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#33 := LitInt(x#0 - Mul(b0#33, LitInt(72057594037927936))); (var b1#33 := LitInt(Div(x0#33, LitInt(281474976710656))); (var x1#33 := LitInt(x0#33 - Mul(b1#33, LitInt(281474976710656))); (var b2#33 := LitInt(Div(x1#33, LitInt(1099511627776))); (var x2#33 := LitInt(x1#33 - Mul(b2#33, LitInt(1099511627776))); (var b3#33 := LitInt(Div(x2#33, LitInt(4294967296))); (var x3#33 := LitInt(x2#33 - Mul(b3#33, LitInt(4294967296))); (var b4#33 := LitInt(Div(x3#33, LitInt(16777216))); (var x4#33 := LitInt(x3#33 - Mul(b4#33, LitInt(16777216))); (var b5#33 := LitInt(Div(x4#33, LitInt(65536))); (var x5#33 := LitInt(x4#33 - Mul(b5#33, LitInt(65536))); (var b6#33 := LitInt(Div(x5#33, LitInt(256))); (var b7#33 := LitInt(Mod(x5#33, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#33)), $Box(b1#33)), $Box(b2#33)), $Box(b3#33)), $Box(b4#33)), $Box(b5#33)), $Box(b6#33)), $Box(b7#33))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#32 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#32 := x0#32 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#32 := x1#32 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#32 := x2#32 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#32 := x3#32 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#32 := x4#32 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#32 := x5#32 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#33 := x6#32 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#33)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#33 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#33 := x0#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#33 := x1#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#33 := x2#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#33 := x3#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#33 := x4#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#33 := x5#33 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#34 := x6#33 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#34)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#32 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#32)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#32 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#32)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#32)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#33 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#33)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#33 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#33)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#33)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#18: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#18)): Seq } LitInt(0) <= i#18 && i#18 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#18)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#19 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#19) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#19)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#19 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#19) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#19)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#19)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#20 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#20) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#20)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#20 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#20) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#20)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#20)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#21 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#21) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#21)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#21 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#21) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#21)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#21)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#12 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#12)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#12)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#13 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#13)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#13)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#14 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#14)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#14)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#12 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#12) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#12) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#12)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#12) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#12))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#12 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#12) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#12) else (var i#12 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#12)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#12)), $Box(Seq#Drop(s#0, i#12 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#13 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#13) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#13) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#13)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#13) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#13))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#13 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#13) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#13) else (var i#13 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#13)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#13)), $Box(Seq#Drop(Lit(s#0), i#13 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#14 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#14) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#14) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#14)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#14) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#14))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#14 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#14) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#14) else (var i#14 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#14)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#14))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#14 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#x#0: Box :: $Box($l#45#x#0 == c#0)), (lambda $l#45#heap#0: Heap, $l#45#x#0: Box :: $IsBox($l#45#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#45#heap#0: Heap, $l#45#x#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#x#0: Box :: $Box($l#43#x#0 == c#0)), (lambda $l#43#heap#0: Heap, $l#43#x#0: Box :: $IsBox($l#43#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#43#heap#0: Heap, $l#43#x#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#x#0: Box :: $Box($l#48#x#0 == c#0)), (lambda $l#48#heap#0: Heap, $l#48#x#0: Box :: $IsBox($l#48#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#48#heap#0: Heap, $l#48#x#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#x#0: Box :: $Box($l#46#x#0 == c#0)), (lambda $l#46#heap#0: Heap, $l#46#x#0: Box :: $IsBox($l#46#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#46#heap#0: Heap, $l#46#x#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#x#0: Box :: $Box($l#51#x#0 == Lit(c#0))), (lambda $l#51#heap#0: Heap, $l#51#x#0: Box :: $IsBox($l#51#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#51#heap#0: Heap, $l#51#x#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#x#0: Box :: $Box($l#49#x#0 == Lit(c#0))), (lambda $l#49#heap#0: Heap, $l#49#x#0: Box :: $IsBox($l#49#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#49#heap#0: Heap, $l#49#x#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#12: int :: { Seq#Index(s#0, j#12) } i#0 <= j#12 && j#12 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#12))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#13: int :: { Seq#Index(s#0, j#13) } i#0 <= j#13 && j#13 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#13))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#12: int :: { Seq#Index(s#0, i#12) } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#12))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#12))) && (forall i#13: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#13) } (LitInt(0) <= i#13 && i#13 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#13))) && (LitInt(0) <= i#13 && i#13 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#13))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#6: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#6) } LitInt(0) <= i#6 && i#6 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#6) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#_v0#0: Box :: value#0), (lambda $l#28#heap#0: Heap, $l#28#_v0#0: Box :: $IsBox($l#28#_v0#0, TInt)), (lambda $l#28#heap#0: Heap, $l#28#_v0#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#_v0#0: Box :: value#0), (lambda $l#30#heap#0: Heap, $l#30#_v0#0: Box :: $IsBox($l#30#_v0#0, TInt)), (lambda $l#30#heap#0: Heap, $l#30#_v0#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#_v0#0: Box :: Lit(value#0)), (lambda $l#32#heap#0: Heap, $l#32#_v0#0: Box :: $IsBox($l#32#_v0#0, TInt)), (lambda $l#32#heap#0: Heap, $l#32#_v0#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#14: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#14) } LitInt(0) <= k#14 ==> k#14 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#14)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#14: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#14) } LitInt(0) <= k#14 && k#14 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#14))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#15: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#15) } LitInt(0) <= k#15 ==> k#15 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#15)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#15: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#15) } LitInt(0) <= k#15 && k#15 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#15))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#16: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#16) } LitInt(0) <= k#16 ==> k#16 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#16)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#16: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#16) } LitInt(0) <= k#16 && k#16 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#16))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#14: int :: { Seq#Index(b#0, i#14) } { Seq#Index(a#0, i#14) } LitInt(0) <= i#14 && i#14 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#14) == Seq#Index(b#0, i#14)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#15: int :: { Seq#Index(b#0, i#15) } { Seq#Index(a#0, i#15) } LitInt(0) <= i#15 && i#15 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#15) == Seq#Index(Lit(b#0), i#15)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#16: int :: { Seq#Index(b#0, i#16) } { Seq#Index(a#0, i#16) } LitInt(0) <= i#16 && i#16 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#16) == Seq#Index(Lit(b#0), i#16)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#30: Box, y#30: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#30, x#30)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#30, y#30)): bool } $IsBox(x#30, StandardLibrary._default.Trichotomous$T) && $IsBox(y#30, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#30, y#30)): bool || x#30 == y#30 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#30, x#30)): bool) && (forall x#31: Box, y#31: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#31, x#31)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#31, y#31)): bool } $IsBox(x#31, StandardLibrary._default.Trichotomous$T) && $IsBox(y#31, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#31, y#31)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#31, x#31)): bool ==> false) && (forall x#32: Box, y#32: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#32, y#32)): bool } $IsBox(x#32, StandardLibrary._default.Trichotomous$T) && $IsBox(y#32, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#32, y#32)): bool ==> x#32 != y#32)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#33: Box, y#33: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#33, x#33)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#33, y#33)): bool } $IsBox(x#33, StandardLibrary._default.Trichotomous$T) && $IsBox(y#33, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#33, y#33)): bool || x#33 == y#33 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#33, x#33)): bool) && (forall x#34: Box, y#34: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#34, x#34)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#34, y#34)): bool } $IsBox(x#34, StandardLibrary._default.Trichotomous$T) && $IsBox(y#34, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#34, y#34)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#34, x#34)): bool ==> false) && (forall x#35: Box, y#35: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#35, y#35)): bool } $IsBox(x#35, StandardLibrary._default.Trichotomous$T) && $IsBox(y#35, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#35, y#35)): bool ==> x#35 != y#35)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#10: Box, y#10: Box, z#10: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#10, z#10)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#10, z#10)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#10, z#10)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#10, y#10)): bool } $IsBox(x#10, StandardLibrary._default.Transitive$T) && $IsBox(y#10, StandardLibrary._default.Transitive$T) && $IsBox(z#10, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#10, y#10)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#10, z#10)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#10, z#10)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#11: Box, y#11: Box, z#11: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#11, z#11)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#11, z#11)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#11, z#11)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#11, y#11)): bool } $IsBox(x#11, StandardLibrary._default.Transitive$T) && $IsBox(y#11, StandardLibrary._default.Transitive$T) && $IsBox(z#11, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#11, y#11)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#11, z#11)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#11, z#11)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#18: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#18)): Seq } LitInt(0) <= i#18 && i#18 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#18)]) && (forall k#6: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#6)) } { s#0[$Box(k#6)] } $Is(k#6, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#6)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#6))) && (forall i#19: int, _t#0#5: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#19)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#5)): Seq } _t#0#5 == i#19 - 1 ==> 0 < i#19 && i#19 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#5)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#19)): Seq, less#0)) && (forall i#20: int, j#6: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#6)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#20)): Seq } LitInt(0) <= i#20 && i#20 < j#6 && j#6 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#20)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#6)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#17 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#17)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#17))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#18 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#18)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#18))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#19 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#19)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#19))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#14: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#14, less#0) } { s#0[$Box(z#14)] } $Is(z#14, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#14)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#14, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#14: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#14, less#0) } { s#0[$Box(z#14)] } $Is(z#14, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#14)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#14, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#15: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#15, less#0) } { s#0[$Box(z#15)] } $Is(z#15, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#15)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#15, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#15: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#15, less#0) } { s#0[$Box(z#15)] } $Is(z#15, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#15)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#15, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#16: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#16, less#0) } { s#0[$Box(z#16)] } $Is(z#16, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#16)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#16, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#16: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#16, less#0) } { s#0[$Box(z#16)] } $Is(z#16, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#16)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#16, Lit(less#0)))));

const unique class.SortedSets.__default: ClassName;

procedure {:verboseName "SortedSets.ComputeSetToOrderedSequence (well-formedness)"} {:extern} CheckWellFormed$$SortedSets.__default.ComputeSetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence$T: Ty where $AlwaysAllocated(SortedSets._default.ComputeSetToOrderedSequence$T), s#0: Set where $Is(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T))) && $IsAlloc(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T))) && $IsAlloc(res#0, TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T)), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "SortedSets.ComputeSetToOrderedSequence (well-formedness)"} {:extern} CheckWellFormed$$SortedSets.__default.ComputeSetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence$T: Ty, s#0: Set, less#0: HandleType) returns (res#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##less#0: HandleType;
  var ##R#0: HandleType;
  var ##s#0: Set;
  var ##less#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "SortedSets.ComputeSetToOrderedSequence", " | ", SortedSets._default.ComputeSetToOrderedSequence$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Sets.dfy(11,42): initial state"} true;
    ##less#0 := less#0;
    assume $IsAlloc(##less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, less#0);
    assume StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, less#0);
    ##R#0 := less#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool), $Heap);
    assume StandardLibrary.__default.Transitive#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, less#0);
    assume StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence$T, less#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Sets.dfy(13,16): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T)), $Heap);
    ##less#1 := less#0;
    assume $IsAlloc(##less#1, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool), $Heap);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#0, x#0)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#0, y#0)): bool } $IsBox(x#0, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#0, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#0, x#0)): bool);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#1, x#1)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#1, y#1)): bool } $IsBox(x#1, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#1, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#1, y#1)): bool && $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#1, x#1)): bool ==> false);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#2, y#2)): bool } $IsBox(x#2, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#2, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#2, y#2)): bool ==> x#2 != y#2);
    assume {:subsumption 0} StandardLibrary.__default.Transitive#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) ==> StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) || (forall x#3: Box, y#3: Box, z#0: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#3, z#0)): bool, $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#3, z#0)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#3, z#0)): bool, $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#3, y#3)): bool } $IsBox(x#3, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#3, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(z#0, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#3, y#3)): bool && $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, y#3, z#0)): bool ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, ##less#1, x#3, z#0)): bool);
    assume StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1) && StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence$T, ##less#1);
    assume StandardLibrary.__default.SetToOrderedSequence#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, s#0, less#0);
    assume Seq#Equal(res#0, StandardLibrary.__default.SetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence$T, $LS($LZ), s#0, less#0));
    return;
}



procedure {:verboseName "SortedSets.ComputeSetToOrderedSequence (call precondtion)"} {:extern} CallPre$$SortedSets.__default.ComputeSetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence$T: Ty where $AlwaysAllocated(SortedSets._default.ComputeSetToOrderedSequence$T), s#0: Set where $Is(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T))) && $IsAlloc(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool), $Heap));
  requires {:id "id16238"} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) || (forall x#4: Box, y#4: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#4, x#4)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#4, y#4)): bool } $IsBox(x#4, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#4, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#4, y#4)): bool || x#4 == y#4 || $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#4, x#4)): bool);
  requires {:id "id16239"} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) || (forall x#5: Box, y#5: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#5, x#5)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#5, y#5)): bool } $IsBox(x#5, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#5, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#5, y#5)): bool && $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#5, x#5)): bool ==> false);
  requires {:id "id16240"} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) || (forall x#6: Box, y#6: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#6, y#6)): bool } $IsBox(x#6, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#6, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#6, y#6)): bool ==> x#6 != y#6);
  requires {:id "id16241"} StandardLibrary.__default.Transitive#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) ==> StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence$T, less#0) || (forall x#7: Box, y#7: Box, z#1: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#7, z#1)): bool, $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#7, z#1)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#7, z#1)): bool, $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#7, y#7)): bool } $IsBox(x#7, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(y#7, SortedSets._default.ComputeSetToOrderedSequence$T) && $IsBox(z#1, SortedSets._default.ComputeSetToOrderedSequence$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#7, y#7)): bool && $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, y#7, z#1)): bool ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool, $Heap, less#0, x#7, z#1)): bool);



procedure {:verboseName "SortedSets.ComputeSetToOrderedSequence (call postcondition)"} {:extern} CallPost$$SortedSets.__default.ComputeSetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence$T: Ty where $AlwaysAllocated(SortedSets._default.ComputeSetToOrderedSequence$T), s#0: Set where $Is(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T))) && $IsAlloc(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T)), $Heap), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool)) && $IsAlloc(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence$T, SortedSets._default.ComputeSetToOrderedSequence$T, TBool), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T))) && $IsAlloc(res#0, TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence$T)), $Heap));
  modifies $Heap;
  free ensures StandardLibrary.__default.SetToOrderedSequence#canCall(SortedSets._default.ComputeSetToOrderedSequence$T, s#0, less#0);
  free ensures {:id "id16242"} Seq#Equal(res#0, StandardLibrary.__default.SetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence$T, $LS($LS($LZ)), s#0, less#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T: Ty, s#0: Set, less#0: HandleType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall SortedSets._default.ComputeSetToOrderedSequence2$T: Ty, s#0: Set, less#0: HandleType :: { SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0) } SortedSets.__default.ComputeSetToOrderedSequence2#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0) || (0 < $FunctionContextHeight && $Is(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool)) && StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0) && StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0)) ==> Seq#Equal(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), StandardLibrary.__default.SetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence2$T, $LS($LZ), s#0, less#0)) && Seq.__default.HasNoDuplicates(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T), reveal_Seq._default.HasNoDuplicates, SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0)) && (forall k#0: Seq :: { s#0[$Box(k#0)] } { Seq#Contains(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), $Box(k#0)) } $Is(k#0, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && Seq#Contains(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), $Box(k#0)) ==> s#0[$Box(k#0)]) && (forall k#1: Seq :: { Seq#Contains(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), $Box(k#1)) } { s#0[$Box(k#1)] } $Is(k#1, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && s#0[$Box(k#1)] ==> Seq#Contains(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), $Box(k#1))) && Seq#Length(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0)) == Set#Card(s#0) && $Is(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T))));
}

function SortedSets.__default.ComputeSetToOrderedSequence2#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T: Ty, s#0: Set, less#0: HandleType) : bool;

function SortedSets.__default.ComputeSetToOrderedSequence2#requires(Ty, Set, HandleType) : bool;

axiom (forall SortedSets._default.ComputeSetToOrderedSequence2$T: Ty, s#0: Set, less#0: HandleType :: { SortedSets.__default.ComputeSetToOrderedSequence2#requires(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0) } $Is(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool)) ==> (SortedSets.__default.ComputeSetToOrderedSequence2#requires(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0) <==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0) && StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0)));

procedure {:verboseName "SortedSets.ComputeSetToOrderedSequence2 (well-formedness)"} {:extern} CheckWellformed$$SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T: Ty where $AlwaysAllocated(SortedSets._default.ComputeSetToOrderedSequence2$T), s#0: Set where $Is(s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T))), less#0: HandleType where $Is(less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool))) returns (res#0: Seq where $Is(res#0, TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16243"} Seq#Equal(res#0, StandardLibrary.__default.SetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence2$T, $LS($LS($LZ)), s#0, less#0));
  free ensures {:id "id16244"} Seq.__default.HasNoDuplicates(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T), reveal_Seq._default.HasNoDuplicates, res#0);
  free ensures {:id "id16245"} (forall k#2: Seq :: { s#0[$Box(k#2)] } { Seq#Contains(res#0, $Box(k#2)) } $Is(k#2, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && Seq#Contains(res#0, $Box(k#2)) ==> s#0[$Box(k#2)]);
  free ensures {:id "id16246"} (forall k#3: Seq :: { Seq#Contains(res#0, $Box(k#3)) } { s#0[$Box(k#3)] } $Is(k#3, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && s#0[$Box(k#3)] ==> Seq#Contains(res#0, $Box(k#3)));
  free ensures {:id "id16247"} Seq#Length(res#0) == Set#Card(s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "SortedSets.ComputeSetToOrderedSequence2 (well-formedness)"} {:extern} CheckWellformed$$SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T: Ty, s#0: Set, less#0: HandleType) returns (res#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##less#0: HandleType;
  var ##R#0: HandleType;
  var ##s#0: Set;
  var ##less#1: HandleType;
  var ##xs#0: Seq;
  var k#4: Seq;
  var k#5: Seq;

  anon0:
    assume {:print "Impl", " | ", "SortedSets.ComputeSetToOrderedSequence2", " | ", SortedSets._default.ComputeSetToOrderedSequence2$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    assume {:captureState "StandardLibrary/src/Sets.dfy(15,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##less#0 := less#0;
    assume $IsAlloc(##less#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool), $Heap);
    assume StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0);
    assume StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0);
    ##R#0 := less#0;
    assume $IsAlloc(##R#0, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool), $Heap);
    assume StandardLibrary.__default.Transitive#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0);
    assume StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence2$T, less#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(SortedSets.__default.ComputeSetToOrderedSequence2(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0), TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)));
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSet(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)), $Heap);
    ##less#1 := less#0;
    assume $IsAlloc(##less#1, Tclass._System.___hTotalFunc2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool), $Heap);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) || (forall x#0: Box, y#0: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#0, x#0)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#0, y#0)): bool } $IsBox(x#0, SortedSets._default.ComputeSetToOrderedSequence2$T) && $IsBox(y#0, SortedSets._default.ComputeSetToOrderedSequence2$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#0, y#0)): bool || x#0 == y#0 || $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#0, x#0)): bool);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) || (forall x#1: Box, y#1: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#1, x#1)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#1, y#1)): bool } $IsBox(x#1, SortedSets._default.ComputeSetToOrderedSequence2$T) && $IsBox(y#1, SortedSets._default.ComputeSetToOrderedSequence2$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#1, y#1)): bool && $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#1, x#1)): bool ==> false);
    assume {:subsumption 0} StandardLibrary.__default.Trichotomous#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) ==> StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) || (forall x#2: Box, y#2: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#2, y#2)): bool } $IsBox(x#2, SortedSets._default.ComputeSetToOrderedSequence2$T) && $IsBox(y#2, SortedSets._default.ComputeSetToOrderedSequence2$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#2, y#2)): bool ==> x#2 != y#2);
    assume {:subsumption 0} StandardLibrary.__default.Transitive#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) ==> StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) || (forall x#3: Box, y#3: Box, z#0: Box :: { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#3, z#0)): bool, $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#3, z#0)): bool } { $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#3, z#0)): bool, $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#3, y#3)): bool } $IsBox(x#3, SortedSets._default.ComputeSetToOrderedSequence2$T) && $IsBox(y#3, SortedSets._default.ComputeSetToOrderedSequence2$T) && $IsBox(z#0, SortedSets._default.ComputeSetToOrderedSequence2$T) ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#3, y#3)): bool && $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, y#3, z#0)): bool ==> $Unbox(Apply2(SortedSets._default.ComputeSetToOrderedSequence2$T, SortedSets._default.ComputeSetToOrderedSequence2$T, TBool, $Heap, ##less#1, x#3, z#0)): bool);
    assume StandardLibrary.__default.Trichotomous(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1) && StandardLibrary.__default.Transitive(SortedSets._default.ComputeSetToOrderedSequence2$T, ##less#1);
    assume StandardLibrary.__default.SetToOrderedSequence#canCall(SortedSets._default.ComputeSetToOrderedSequence2$T, s#0, less#0);
    assume Seq#Equal(res#0, StandardLibrary.__default.SetToOrderedSequence(SortedSets._default.ComputeSetToOrderedSequence2$T, $LS($LZ), s#0, less#0));
    ##xs#0 := res#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)), $Heap);
    assume Seq.__default.HasNoDuplicates#canCall(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T), res#0);
    assume Seq.__default.HasNoDuplicates(TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T), reveal_Seq._default.HasNoDuplicates, res#0);
    havoc k#4;
    assume $Is(k#4, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && $IsAlloc(k#4, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T), $Heap);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(res#0, $Box(k#4));
    assume s#0[$Box(k#4)];
    goto anon5;

  anon11_Else:
    assume Seq#Contains(res#0, $Box(k#4)) ==> s#0[$Box(k#4)];
    goto anon5;

  anon5:
    assume (forall k#2: Seq :: { s#0[$Box(k#2)] } { Seq#Contains(res#0, $Box(k#2)) } $Is(k#2, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && Seq#Contains(res#0, $Box(k#2)) ==> s#0[$Box(k#2)]);
    havoc k#5;
    assume $Is(k#5, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && $IsAlloc(k#5, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T), $Heap);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume s#0[$Box(k#5)];
    assume Seq#Contains(res#0, $Box(k#5));
    goto anon8;

  anon12_Else:
    assume s#0[$Box(k#5)] ==> Seq#Contains(res#0, $Box(k#5));
    goto anon8;

  anon8:
    assume (forall k#3: Seq :: { Seq#Contains(res#0, $Box(k#3)) } { s#0[$Box(k#3)] } $Is(k#3, TSeq(SortedSets._default.ComputeSetToOrderedSequence2$T)) && s#0[$Box(k#3)] ==> Seq#Contains(res#0, $Box(k#3)));
    assume Seq#Length(res#0) == Set#Card(s#0);
    assume false;
    return;

  anon10_Else:
    assume false;
    return;
}



function SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T: Ty, s#0: Set) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall SortedSets._default.ComputeSetToSequence$T: Ty, s#0: Set :: { SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0) } SortedSets.__default.ComputeSetToSequence#canCall(SortedSets._default.ComputeSetToSequence$T, s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSet(SortedSets._default.ComputeSetToSequence$T))) ==> Seq.__default.HasNoDuplicates(SortedSets._default.ComputeSetToSequence$T, reveal_Seq._default.HasNoDuplicates, SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0)) && (forall k#0: Box :: { s#0[k#0] } { Seq#Contains(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0), k#0) } $IsBox(k#0, SortedSets._default.ComputeSetToSequence$T) && Seq#Contains(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0), k#0) ==> s#0[k#0]) && (forall k#1: Box :: { Seq#Contains(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0), k#1) } { s#0[k#1] } $IsBox(k#1, SortedSets._default.ComputeSetToSequence$T) && s#0[k#1] ==> Seq#Contains(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0), k#1)) && Seq#Length(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0)) == Set#Card(s#0) && $Is(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0), TSeq(SortedSets._default.ComputeSetToSequence$T)));
}

function SortedSets.__default.ComputeSetToSequence#canCall(SortedSets._default.ComputeSetToSequence$T: Ty, s#0: Set) : bool;

function SortedSets.__default.ComputeSetToSequence#requires(Ty, Set) : bool;

axiom (forall SortedSets._default.ComputeSetToSequence$T: Ty, s#0: Set :: { SortedSets.__default.ComputeSetToSequence#requires(SortedSets._default.ComputeSetToSequence$T, s#0) } $Is(s#0, TSet(SortedSets._default.ComputeSetToSequence$T)) ==> (SortedSets.__default.ComputeSetToSequence#requires(SortedSets._default.ComputeSetToSequence$T, s#0) <==> true));

procedure {:verboseName "SortedSets.ComputeSetToSequence (well-formedness)"} {:extern} CheckWellformed$$SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T: Ty where $AlwaysAllocated(SortedSets._default.ComputeSetToSequence$T), s#0: Set where $Is(s#0, TSet(SortedSets._default.ComputeSetToSequence$T))) returns (res#0: Seq where $Is(res#0, TSeq(SortedSets._default.ComputeSetToSequence$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16265"} Seq.__default.HasNoDuplicates(SortedSets._default.ComputeSetToSequence$T, reveal_Seq._default.HasNoDuplicates, res#0);
  free ensures {:id "id16266"} (forall k#2: Box :: { s#0[k#2] } { Seq#Contains(res#0, k#2) } $IsBox(k#2, SortedSets._default.ComputeSetToSequence$T) && Seq#Contains(res#0, k#2) ==> s#0[k#2]);
  free ensures {:id "id16267"} (forall k#3: Box :: { Seq#Contains(res#0, k#3) } { s#0[k#3] } $IsBox(k#3, SortedSets._default.ComputeSetToSequence$T) && s#0[k#3] ==> Seq#Contains(res#0, k#3));
  free ensures {:id "id16268"} Seq#Length(res#0) == Set#Card(s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "SortedSets.ComputeSetToSequence (well-formedness)"} {:extern} CheckWellformed$$SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T: Ty, s#0: Set) returns (res#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var k#4: Box;
  var k#5: Box;

  anon0:
    assume {:print "Impl", " | ", "SortedSets.ComputeSetToSequence", " | ", SortedSets._default.ComputeSetToSequence$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set"} true;
    assume {:captureState "StandardLibrary/src/Sets.dfy(28,44): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(SortedSets.__default.ComputeSetToSequence(SortedSets._default.ComputeSetToSequence$T, s#0), TSeq(SortedSets._default.ComputeSetToSequence$T));
    ##xs#0 := res#0;
    assume $IsAlloc(##xs#0, TSeq(SortedSets._default.ComputeSetToSequence$T), $Heap);
    assume Seq.__default.HasNoDuplicates#canCall(SortedSets._default.ComputeSetToSequence$T, res#0);
    assume Seq.__default.HasNoDuplicates(SortedSets._default.ComputeSetToSequence$T, reveal_Seq._default.HasNoDuplicates, res#0);
    havoc k#4;
    assume $IsBox(k#4, SortedSets._default.ComputeSetToSequence$T) && $IsAllocBox(k#4, SortedSets._default.ComputeSetToSequence$T, $Heap);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(res#0, k#4);
    assume s#0[k#4];
    goto anon5;

  anon11_Else:
    assume Seq#Contains(res#0, k#4) ==> s#0[k#4];
    goto anon5;

  anon5:
    assume (forall k#2: Box :: { s#0[k#2] } { Seq#Contains(res#0, k#2) } $IsBox(k#2, SortedSets._default.ComputeSetToSequence$T) && Seq#Contains(res#0, k#2) ==> s#0[k#2]);
    havoc k#5;
    assume $IsBox(k#5, SortedSets._default.ComputeSetToSequence$T) && $IsAllocBox(k#5, SortedSets._default.ComputeSetToSequence$T, $Heap);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume s#0[k#5];
    assume Seq#Contains(res#0, k#5);
    goto anon8;

  anon12_Else:
    assume s#0[k#5] ==> Seq#Contains(res#0, k#5);
    goto anon8;

  anon8:
    assume (forall k#3: Box :: { Seq#Contains(res#0, k#3) } { s#0[k#3] } $IsBox(k#3, SortedSets._default.ComputeSetToSequence$T) && s#0[k#3] ==> Seq#Contains(res#0, k#3));
    assume Seq#Length(res#0) == Set#Card(s#0);
    assume false;
    return;

  anon10_Else:
    assume false;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#100 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#100))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#102 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#102)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#150 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#150))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#152 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#152)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#154 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#154)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#150 := Wrappers.Option.value(this); v#150)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#152 := Lit(Wrappers.Option.value(Lit(this))); v#152)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#154 := Lit(Wrappers.Option.value(Lit(this))); v#154)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#100 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#100)) else (var e#100 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#102 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#102))) else (var e#102 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#150 := Wrappers.Result.value(this); s#150) else (var e#150 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#152 := Lit(Wrappers.Result.value(Lit(this))); s#152) else (var e#152 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#154 := Lit(Wrappers.Result.value(Lit(this))); s#154) else (var e#154 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#150 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#150)) else (var e#150 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#150)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#152 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#152))) else (var e#152 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#152)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#154 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#154))) else (var e#154 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#154)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#34 := Div(x#0, LitInt(256)); (var b1#34 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#34)), $Box(b1#34)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#35 := LitInt(Div(x#0, LitInt(256))); (var b1#35 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#35)), $Box(b1#35))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#34 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#34 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#35 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#35 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#34 := Div(x#0, LitInt(16777216)); (var x0#34 := x#0 - Mul(b0#34, LitInt(16777216)); (var b1#34 := Div(x0#34, LitInt(65536)); (var x1#34 := x0#34 - Mul(b1#34, LitInt(65536)); (var b2#34 := Div(x1#34, LitInt(256)); (var b3#34 := Mod(x1#34, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#34)), $Box(b1#34)), $Box(b2#34)), $Box(b3#34)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#35 := LitInt(Div(x#0, LitInt(16777216))); (var x0#35 := LitInt(x#0 - Mul(b0#35, LitInt(16777216))); (var b1#35 := LitInt(Div(x0#35, LitInt(65536))); (var x1#35 := LitInt(x0#35 - Mul(b1#35, LitInt(65536))); (var b2#35 := LitInt(Div(x1#35, LitInt(256))); (var b3#35 := LitInt(Mod(x1#35, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#35)), $Box(b1#35)), $Box(b2#35)), $Box(b3#35))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#34 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#34 := x0#34 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#34 := x1#34 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#34 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#35 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#35 := x0#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#35 := x1#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#35 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#34 := Div(x#0, LitInt(72057594037927936)); (var x0#34 := x#0 - Mul(b0#34, LitInt(72057594037927936)); (var b1#34 := Div(x0#34, LitInt(281474976710656)); (var x1#34 := x0#34 - Mul(b1#34, LitInt(281474976710656)); (var b2#34 := Div(x1#34, LitInt(1099511627776)); (var x2#34 := x1#34 - Mul(b2#34, LitInt(1099511627776)); (var b3#34 := Div(x2#34, LitInt(4294967296)); (var x3#34 := x2#34 - Mul(b3#34, LitInt(4294967296)); (var b4#34 := Div(x3#34, LitInt(16777216)); (var x4#34 := x3#34 - Mul(b4#34, LitInt(16777216)); (var b5#34 := Div(x4#34, LitInt(65536)); (var x5#34 := x4#34 - Mul(b5#34, LitInt(65536)); (var b6#34 := Div(x5#34, LitInt(256)); (var b7#34 := Mod(x5#34, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#34)), $Box(b1#34)), $Box(b2#34)), $Box(b3#34)), $Box(b4#34)), $Box(b5#34)), $Box(b6#34)), $Box(b7#34)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#35 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#35 := LitInt(x#0 - Mul(b0#35, LitInt(72057594037927936))); (var b1#35 := LitInt(Div(x0#35, LitInt(281474976710656))); (var x1#35 := LitInt(x0#35 - Mul(b1#35, LitInt(281474976710656))); (var b2#35 := LitInt(Div(x1#35, LitInt(1099511627776))); (var x2#35 := LitInt(x1#35 - Mul(b2#35, LitInt(1099511627776))); (var b3#35 := LitInt(Div(x2#35, LitInt(4294967296))); (var x3#35 := LitInt(x2#35 - Mul(b3#35, LitInt(4294967296))); (var b4#35 := LitInt(Div(x3#35, LitInt(16777216))); (var x4#35 := LitInt(x3#35 - Mul(b4#35, LitInt(16777216))); (var b5#35 := LitInt(Div(x4#35, LitInt(65536))); (var x5#35 := LitInt(x4#35 - Mul(b5#35, LitInt(65536))); (var b6#35 := LitInt(Div(x5#35, LitInt(256))); (var b7#35 := LitInt(Mod(x5#35, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#35)), $Box(b1#35)), $Box(b2#35)), $Box(b3#35)), $Box(b4#35)), $Box(b5#35)), $Box(b6#35)), $Box(b7#35))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#34 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#34 := x0#34 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#34 := x1#34 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#34 := x2#34 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#34 := x3#34 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#34 := x4#34 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#34 := x5#34 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#35 := x6#34 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#35)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#35 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#35 := x0#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#35 := x1#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#35 := x2#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#35 := x3#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#35 := x4#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#35 := x5#35 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#36 := x6#35 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#36)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#34 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#34)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#34 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#34)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#34)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#35 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#35)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#35 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#35)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#35)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#22: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#22)): Seq } LitInt(0) <= i#22 && i#22 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#22)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#23 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#23) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#23)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#23 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#23) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#23)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#23)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#24 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#24) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#24)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#24 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#24) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#24)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#24)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#25 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#25) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#25)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#25 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#25) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#25)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#25)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#15 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#15)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#15)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#16 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#16)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#16)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#17 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#17)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#17)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#15 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#15) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#15) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#15)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#15) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#15))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#15 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#15) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#15) else (var i#15 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#15)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#15)), $Box(Seq#Drop(s#0, i#15 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#16 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#16) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#16) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#16)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#16) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#16))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#16 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#16) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#16) else (var i#16 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#16)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#16)), $Box(Seq#Drop(Lit(s#0), i#16 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#17 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#17) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#17) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#17)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#17) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#17))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#17 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#17) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#17) else (var i#17 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#17)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#17))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#17 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#x#0: Box :: $Box($l#54#x#0 == c#0)), (lambda $l#54#heap#0: Heap, $l#54#x#0: Box :: $IsBox($l#54#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#54#heap#0: Heap, $l#54#x#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#x#0: Box :: $Box($l#52#x#0 == c#0)), (lambda $l#52#heap#0: Heap, $l#52#x#0: Box :: $IsBox($l#52#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#52#heap#0: Heap, $l#52#x#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#x#0: Box :: $Box($l#57#x#0 == c#0)), (lambda $l#57#heap#0: Heap, $l#57#x#0: Box :: $IsBox($l#57#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#57#heap#0: Heap, $l#57#x#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#x#0: Box :: $Box($l#55#x#0 == c#0)), (lambda $l#55#heap#0: Heap, $l#55#x#0: Box :: $IsBox($l#55#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#55#heap#0: Heap, $l#55#x#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#x#0: Box :: $Box($l#60#x#0 == Lit(c#0))), (lambda $l#60#heap#0: Heap, $l#60#x#0: Box :: $IsBox($l#60#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#60#heap#0: Heap, $l#60#x#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#x#0: Box :: $Box($l#58#x#0 == Lit(c#0))), (lambda $l#58#heap#0: Heap, $l#58#x#0: Box :: $IsBox($l#58#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#58#heap#0: Heap, $l#58#x#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#14: int :: { Seq#Index(s#0, j#14) } i#0 <= j#14 && j#14 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#14))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#15: int :: { Seq#Index(s#0, j#15) } i#0 <= j#15 && j#15 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#15))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#14: int :: { Seq#Index(s#0, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#14))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#14))) && (forall i#15: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#15) } (LitInt(0) <= i#15 && i#15 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#15))) && (LitInt(0) <= i#15 && i#15 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#15))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#7: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#7) } LitInt(0) <= i#7 && i#7 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#7) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#_v0#0: Box :: value#0), (lambda $l#34#heap#0: Heap, $l#34#_v0#0: Box :: $IsBox($l#34#_v0#0, TInt)), (lambda $l#34#heap#0: Heap, $l#34#_v0#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#_v0#0: Box :: value#0), (lambda $l#36#heap#0: Heap, $l#36#_v0#0: Box :: $IsBox($l#36#_v0#0, TInt)), (lambda $l#36#heap#0: Heap, $l#36#_v0#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#_v0#0: Box :: Lit(value#0)), (lambda $l#38#heap#0: Heap, $l#38#_v0#0: Box :: $IsBox($l#38#_v0#0, TInt)), (lambda $l#38#heap#0: Heap, $l#38#_v0#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#17: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#17) } LitInt(0) <= k#17 ==> k#17 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#17)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#17: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#17) } LitInt(0) <= k#17 && k#17 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#17))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#18: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#18) } LitInt(0) <= k#18 ==> k#18 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#18)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#18: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#18) } LitInt(0) <= k#18 && k#18 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#18))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#19: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#19) } LitInt(0) <= k#19 ==> k#19 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#19)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#19: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#19) } LitInt(0) <= k#19 && k#19 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#19))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#17: int :: { Seq#Index(b#0, i#17) } { Seq#Index(a#0, i#17) } LitInt(0) <= i#17 && i#17 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#17) == Seq#Index(b#0, i#17)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#18: int :: { Seq#Index(b#0, i#18) } { Seq#Index(a#0, i#18) } LitInt(0) <= i#18 && i#18 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#18) == Seq#Index(Lit(b#0), i#18)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#19: int :: { Seq#Index(b#0, i#19) } { Seq#Index(a#0, i#19) } LitInt(0) <= i#19 && i#19 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#19) == Seq#Index(Lit(b#0), i#19)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#36: Box, y#36: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#36, x#36)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#36, y#36)): bool } $IsBox(x#36, StandardLibrary._default.Trichotomous$T) && $IsBox(y#36, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#36, y#36)): bool || x#36 == y#36 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#36, x#36)): bool) && (forall x#37: Box, y#37: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#37, x#37)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#37, y#37)): bool } $IsBox(x#37, StandardLibrary._default.Trichotomous$T) && $IsBox(y#37, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#37, y#37)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#37, x#37)): bool ==> false) && (forall x#38: Box, y#38: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#38, y#38)): bool } $IsBox(x#38, StandardLibrary._default.Trichotomous$T) && $IsBox(y#38, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#38, y#38)): bool ==> x#38 != y#38)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#39: Box, y#39: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#39, x#39)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#39, y#39)): bool } $IsBox(x#39, StandardLibrary._default.Trichotomous$T) && $IsBox(y#39, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#39, y#39)): bool || x#39 == y#39 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#39, x#39)): bool) && (forall x#40: Box, y#40: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#40, x#40)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#40, y#40)): bool } $IsBox(x#40, StandardLibrary._default.Trichotomous$T) && $IsBox(y#40, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#40, y#40)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#40, x#40)): bool ==> false) && (forall x#41: Box, y#41: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#41, y#41)): bool } $IsBox(x#41, StandardLibrary._default.Trichotomous$T) && $IsBox(y#41, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#41, y#41)): bool ==> x#41 != y#41)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#12: Box, y#12: Box, z#12: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#12, z#12)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#12, z#12)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#12, z#12)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#12, y#12)): bool } $IsBox(x#12, StandardLibrary._default.Transitive$T) && $IsBox(y#12, StandardLibrary._default.Transitive$T) && $IsBox(z#12, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#12, y#12)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#12, z#12)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#12, z#12)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#13: Box, y#13: Box, z#13: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#13, z#13)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#13, z#13)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#13, z#13)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#13, y#13)): bool } $IsBox(x#13, StandardLibrary._default.Transitive$T) && $IsBox(y#13, StandardLibrary._default.Transitive$T) && $IsBox(z#13, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#13, y#13)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#13, z#13)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#13, z#13)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#21: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#21)): Seq } LitInt(0) <= i#21 && i#21 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#21)]) && (forall k#7: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#7)) } { s#0[$Box(k#7)] } $Is(k#7, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#7)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#7))) && (forall i#22: int, _t#0#6: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#22)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#6)): Seq } _t#0#6 == i#22 - 1 ==> 0 < i#22 && i#22 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#6)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#22)): Seq, less#0)) && (forall i#23: int, j#7: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#7)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#23)): Seq } LitInt(0) <= i#23 && i#23 < j#7 && j#7 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#23)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#7)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#20 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#20)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#20))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#21 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#21)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#21))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#22 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#22)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#22))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#17: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#17, less#0) } { s#0[$Box(z#17)] } $Is(z#17, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#17)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#17, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#17: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#17, less#0) } { s#0[$Box(z#17)] } $Is(z#17, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#17)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#17, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#18: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#18, less#0) } { s#0[$Box(z#18)] } $Is(z#18, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#18)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#18, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#18: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#18, less#0) } { s#0[$Box(z#18)] } $Is(z#18, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#18)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#18, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#19: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#19, less#0) } { s#0[$Box(z#19)] } $Is(z#19, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#19)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#19, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#19: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#19, less#0) } { s#0[$Box(z#19)] } $Is(z#19, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#19)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#19, Lit(less#0)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#20: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#20, x#20)): bool } $IsBox(x#20, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#20, x#20)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#21: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#21, x#21)): bool } $IsBox(x#21, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#21, x#21)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#20: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#20, x#20)): bool } $IsBox(x#20, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#20, x#20)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#21: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#21, x#21)): bool } $IsBox(x#21, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#21, x#21)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#20: Box, y#20: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#20, x#20)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#20, y#20)): bool } $IsBox(x#20, Relations._default.AntiSymmetric$T) && $IsBox(y#20, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#20, y#20)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#20, x#20)): bool ==> x#20 == y#20)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#21: Box, y#21: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#21, x#21)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#21, y#21)): bool } $IsBox(x#21, Relations._default.AntiSymmetric$T) && $IsBox(y#21, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#21, y#21)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#21, x#21)): bool ==> x#21 == y#21)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#20: Box, y#20: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#20, x#20)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#20, y#20)): bool } $IsBox(x#20, Relations._default.Symmetric$T) && $IsBox(y#20, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#20, y#20)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#20, x#20)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#21: Box, y#21: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#21, x#21)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#21, y#21)): bool } $IsBox(x#21, Relations._default.Symmetric$T) && $IsBox(y#21, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#21, y#21)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#21, x#21)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#20: Box, y#20: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#20, x#20)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#20, y#20)): bool } $IsBox(x#20, Relations._default.Connected$T) && $IsBox(y#20, Relations._default.Connected$T) ==> x#20 != y#20 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#20, y#20)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#20, x#20)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#21: Box, y#21: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#21, x#21)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#21, y#21)): bool } $IsBox(x#21, Relations._default.Connected$T) && $IsBox(y#21, Relations._default.Connected$T) ==> x#21 != y#21 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#21, y#21)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#21, x#21)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#20: Box, y#20: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#20, x#20)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#20, y#20)): bool } $IsBox(x#20, Relations._default.StronglyConnected$T) && $IsBox(y#20, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#20, y#20)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#20, x#20)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#21: Box, y#21: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#21, x#21)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#21, y#21)): bool } $IsBox(x#21, Relations._default.StronglyConnected$T) && $IsBox(y#21, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#21, y#21)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#21, x#21)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#20: Box, y#20: Box, z#20: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#20, z#20)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#20, z#20)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#20, z#20)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#20, y#20)): bool } $IsBox(x#20, Relations._default.Transitive$T) && $IsBox(y#20, Relations._default.Transitive$T) && $IsBox(z#20, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#20, y#20)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#20, z#20)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#20, z#20)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#21: Box, y#21: Box, z#21: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#21, z#21)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#21, z#21)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#21, z#21)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#21, y#21)): bool } $IsBox(x#21, Relations._default.Transitive$T) && $IsBox(y#21, Relations._default.Transitive$T) && $IsBox(z#21, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#21, y#21)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#21, z#21)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#21, z#21)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#29: int, j#29: int :: { Seq#Index(a#0, j#29), Seq#Index(a#0, i#29) } LitInt(0) <= i#29 && i#29 < j#29 && j#29 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#29), Seq#Index(a#0, j#29))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#30: int, j#30: int :: { Seq#Index(a#0, j#30), Seq#Index(a#0, i#30) } LitInt(0) <= i#30 && i#30 < j#30 && j#30 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#30), Seq#Index(Lit(a#0), j#30))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#31: int, j#31: int :: { Seq#Index(a#0, j#31), Seq#Index(a#0, i#31) } LitInt(0) <= i#31 && i#31 < j#31 && j#31 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#31), Seq#Index(Lit(a#0), j#31))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#29: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#29)): bool } { s#0[x#29] } $IsBox(x#29, Relations._default.IsLeast$T) && s#0[x#29] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#29)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#30: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#30)): bool } { s#0[x#30] } $IsBox(x#30, Relations._default.IsLeast$T) && Lit(s#0)[x#30] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#30)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#31: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#31)): bool } { s#0[x#31] } $IsBox(x#31, Relations._default.IsLeast$T) && Lit(s#0)[x#31] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#31)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#29: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#29)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#29, min#0)): bool } { s#0[x#29] } $IsBox(x#29, Relations._default.IsMinimal$T) && s#0[x#29] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#29, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#29)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#30: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#30)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#30, min#0)): bool } { s#0[x#30] } $IsBox(x#30, Relations._default.IsMinimal$T) && Lit(s#0)[x#30] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#30, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#30)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#31: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#31)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#31, min#0)): bool } { s#0[x#31] } $IsBox(x#31, Relations._default.IsMinimal$T) && Lit(s#0)[x#31] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#31, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#31)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#29: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#29, max#0)): bool } { s#0[x#29] } $IsBox(x#29, Relations._default.IsGreatest$T) && s#0[x#29] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#29, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#30: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#30, max#0)): bool } { s#0[x#30] } $IsBox(x#30, Relations._default.IsGreatest$T) && Lit(s#0)[x#30] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#30, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#31: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#31, max#0)): bool } { s#0[x#31] } $IsBox(x#31, Relations._default.IsGreatest$T) && Lit(s#0)[x#31] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#31, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#29: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#29, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#29)): bool } { s#0[x#29] } $IsBox(x#29, Relations._default.IsMaximal$T) && s#0[x#29] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#29)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#29, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#30: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#30, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#30)): bool } { s#0[x#30] } $IsBox(x#30, Relations._default.IsMaximal$T) && Lit(s#0)[x#30] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#30)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#30, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#31: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#31, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#31)): bool } { s#0[x#31] } $IsBox(x#31, Relations._default.IsMaximal$T) && Lit(s#0)[x#31] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#31)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#31, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#24 := Div(Seq#Length(a#0), LitInt(2)); (var left#24, right#24 := Seq#Take(a#0, splitIndex#24), Seq#Drop(a#0, splitIndex#24); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#24, lessThanOrEq#0) && (var leftSorted#24 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#24, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#24, lessThanOrEq#0) && (var rightSorted#24 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#24, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#24, rightSorted#24, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#24 := Div(Seq#Length(a#0), LitInt(2)); (var left#24, right#24 := Seq#Take(a#0, splitIndex#24), Seq#Drop(a#0, splitIndex#24); (var leftSorted#24 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#24, lessThanOrEq#0); (var rightSorted#24 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#24, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#24, rightSorted#24, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#25 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#25, right#25 := Seq#Take(Lit(a#0), splitIndex#25), Seq#Drop(Lit(a#0), splitIndex#25); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#25, lessThanOrEq#0) && (var leftSorted#25 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#25, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#25, lessThanOrEq#0) && (var rightSorted#25 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#25, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#25, rightSorted#25, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#25 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#25, right#25 := Seq#Take(Lit(a#0), splitIndex#25), Seq#Drop(Lit(a#0), splitIndex#25); (var leftSorted#25 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#25, lessThanOrEq#0); (var rightSorted#25 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#25, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#25, rightSorted#25, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#26 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#26, right#26 := Seq#Take(Lit(a#0), splitIndex#26), Seq#Drop(Lit(a#0), splitIndex#26); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#26, Lit(lessThanOrEq#0)) && (var leftSorted#26 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#26, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#26, Lit(lessThanOrEq#0)) && (var rightSorted#26 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#26, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#26, rightSorted#26, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#26 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#26, right#26 := Seq#Take(Lit(a#0), splitIndex#26), Seq#Drop(Lit(a#0), splitIndex#26); (var leftSorted#26 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#26, Lit(lessThanOrEq#0)); (var rightSorted#26 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#26, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#26, rightSorted#26, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#16: Box :: $IsBox($y#16, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#16)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#17: Box :: $IsBox($y#17, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#17)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#16: int, j#16: int :: { Seq#Index(xs#0, j#16), Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) && LitInt(0) <= j#16 && j#16 < Seq#Length(xs#0) && i#16 != j#16 ==> Seq#Index(xs#0, i#16) != Seq#Index(xs#0, j#16))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#17: int, j#17: int :: { Seq#Index(xs#0, j#17), Seq#Index(xs#0, i#17) } LitInt(0) <= i#17 && i#17 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#17 && j#17 < Seq#Length(Lit(xs#0)) && i#17 != j#17 ==> Seq#Index(Lit(xs#0), i#17) != Seq#Index(Lit(xs#0), j#17))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#9: int :: { Seq#Index(xs#0, j#9) } LitInt(0) <= j#9 && j#9 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#9) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#9: int :: { Seq#Index(xs#0, j#9) } LitInt(0) <= j#9 && j#9 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#9) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#21 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#21) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#21)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#22 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#22) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#22)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#23 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#23) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#23)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#9: int :: { Seq#Index(xs#0, j#9) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#9 && j#9 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#9) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#9: int :: { Seq#Index(xs#0, j#9) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#9 && j#9 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#9) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#18: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#18), Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#18) == Seq#Index(xs#0, i#18)) && (forall i#19: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#19) } pos#0 <= i#19 && i#19 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#19) == Seq#Index(xs#0, i#19 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#21 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#21), Seq#Drop(xs#0, i#21 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#22 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#22), Seq#Drop(Lit(xs#0), i#22 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#23 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#23), Seq#Drop(Lit(xs#0), i#23 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#18: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#18), Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#18) == Seq#Index(xs#0, i#18)) && (forall i#19: int :: { Seq#Index(xs#0, i#19) } pos#0 <= i#19 && i#19 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#19 + 1) == Seq#Index(xs#0, i#19)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#9: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#9) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#9 - 1) } LitInt(0) <= i#9 && i#9 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#9) == Seq#Index(xs#0, Seq#Length(xs#0) - i#9 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#9: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#9) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#9: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#9) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#9), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#9)), $Unbox(Seq#Index(xs#0, i#9)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#14, b#14 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#14, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#14, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#15, b#15 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#15, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#15, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#9: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#9)): DatatypeType } LitInt(0) <= i#9 && i#9 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#9)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#9), Seq#Index(ys#0, i#9)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#9: int :: { Seq#Contains(xs#0, $Box(k#9)) } Seq#Contains(xs#0, $Box(k#9)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#9) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#9: int :: { Seq#Contains(xs#0, $Box(k#9)) } Seq#Contains(xs#0, $Box(k#9)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#9) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#34: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#34) } LitInt(0) <= i#34 && i#34 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#34) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#34))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#35: int :: { Seq#Index(xs#0, i#35) } LitInt(0) <= i#35 && i#35 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#35)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#35: int :: { Seq#Index(xs#0, i#35) } LitInt(0) <= i#35 && i#35 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#35)))) ==> (forall $l#19#i#0: int :: LitInt(0) <= $l#19#i#0 ==> $l#19#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#19#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#18#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#18#i#0): int))), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $IsBox($l#18#i#0, TInt) && LitInt(0) <= $Unbox($l#18#i#0): int && $Unbox($l#18#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#18#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#18#i#0): int))), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: (exists i#36: int, o#15: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#18#heap#0, f#0, Seq#Index(xs#0, i#36))[$Box(o#15)] } $Is(o#15, Tclass._System.object?()) && LitInt(0) <= i#36 && i#36 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#18#heap#0, f#0, Seq#Index(xs#0, i#36))[$Box(o#15)] && $Box($l#18#o#0) == $Box(o#15))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#25: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#25) } { Seq#Index(xs#0, i#25) } (LitInt(0) <= i#25 && i#25 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#25))): DatatypeType)) && (LitInt(0) <= i#25 && i#25 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#25) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#25))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#26: int :: { Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#26)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#26: int :: { Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#26)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#7 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#7) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#7) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#7 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#7) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#7)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#7) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#7)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#7 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#7) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#7) else (var head#7 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#7); (var valueOrError1#7 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#7) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#7) else (var tail#7 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#7), tail#7)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#25: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#25) } LitInt(0) <= i#25 ==> i#25 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#25)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#25))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#26: int :: { Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#26)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#26: int :: { Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#26)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#16: Box, xs#16: Seq, b#16: Box, b'#16: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#16, x#16, b'#16)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#16), xs#16) } $IsBox(x#16, Seq._default.InvFoldLeft$A) && $Is(xs#16, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#16, Seq._default.InvFoldLeft$B) && $IsBox(b'#16, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#16, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#16), xs#16)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#16, x#16, b'#16)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#16, $Box(xs#16))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#17: Box, xs#17: Seq, b#17: Box, b'#17: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#17, x#17, b'#17)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#17), xs#17) } $IsBox(x#17, Seq._default.InvFoldLeft$A) && $Is(xs#17, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#17, Seq._default.InvFoldLeft$B) && $IsBox(b'#17, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#17, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#17), xs#17)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#17, x#17, b'#17)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#17, $Box(xs#17))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#16: Box, xs#16: Seq, b#16: Box, b'#16: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#16), xs#16), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#16, b#16, b'#16)): bool } $IsBox(x#16, Seq._default.InvFoldRight$A) && $Is(xs#16, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#16, Seq._default.InvFoldRight$B) && $IsBox(b'#16, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#16), b#16)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#16, b#16, b'#16)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#16), xs#16)), b'#16)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#17: Box, xs#17: Seq, b#17: Box, b'#17: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#17), xs#17), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#17, b#17, b'#17)): bool } $IsBox(x#17, Seq._default.InvFoldRight$A) && $Is(xs#17, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#17, Seq._default.InvFoldRight$B) && $IsBox(b'#17, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#17), b#17)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#17, b#17, b'#17)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#17), xs#17)), b'#17)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#16: int :: { Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#16)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#16: int :: { Seq#Index(xs#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#16)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

const unique class.HexStrings.__default: ClassName;

function HexStrings.__default.HexChar(x#0: int) : char
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { HexStrings.__default.HexChar(x#0) } HexStrings.__default.HexChar#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8() && x#0 < 16) ==> ((char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(HexStrings.__default.HexChar(x#0)) && char#ToInt(HexStrings.__default.HexChar(x#0)) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(HexStrings.__default.HexChar(x#0)) && char#ToInt(HexStrings.__default.HexChar(x#0)) <= char#ToInt(Lit(char#FromInt(102))))) && HexStrings.__default.IsHexChar(HexStrings.__default.HexChar(x#0)) && $Is(HexStrings.__default.HexChar(x#0), TChar));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { HexStrings.__default.HexChar(x#0) } HexStrings.__default.HexChar#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8() && x#0 < 16) ==> HexStrings.__default.HexChar(x#0) == (if x#0 < 10 then char#Plus(char#FromInt(48), char#FromInt(x#0)) else char#Plus(char#FromInt(97), char#FromInt(x#0 - 10))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { HexStrings.__default.HexChar(LitInt(x#0)) } HexStrings.__default.HexChar#canCall(LitInt(x#0)) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8() && Lit(x#0 < 16)) ==> HexStrings.__default.HexChar(LitInt(x#0)) == (if x#0 < 10 then char#Plus(char#FromInt(48), char#FromInt(LitInt(x#0))) else char#Plus(char#FromInt(97), char#FromInt(LitInt(x#0 - 10)))));
}

function HexStrings.__default.HexChar#canCall(x#0: int) : bool;

function HexStrings.__default.HexChar#requires(int) : bool;

axiom (forall x#0: int :: { HexStrings.__default.HexChar#requires(x#0) } LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (HexStrings.__default.HexChar#requires(x#0) <==> x#0 < 16));

procedure {:verboseName "HexStrings.HexChar (well-formedness)"} CheckWellformed$$HexStrings.__default.HexChar(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (res#0: char where $Is(res#0, TChar));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16284"} (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(102))));
  free ensures {:id "id16285"} HexStrings.__default.IsHexChar#canCall(res#0) ==> HexStrings.__default.IsHexChar(res#0) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(102))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexChar (well-formedness)"} CheckWellformed$$HexStrings.__default.HexChar(x#0: int) returns (res#0: char)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##ch#0: char;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexChar", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(12,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(16);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume x#0 < 16;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(HexStrings.__default.HexChar(x#0), TChar);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(res#0);
    goto anon5;

  anon16_Else:
    assume {:partition} char#ToInt(res#0) < char#ToInt(Lit(char#FromInt(48)));
    goto anon5;

  anon5:
    assume char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(57)));
    goto anon9;

  anon15_Else:
    assume !(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(57))));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(res#0);
    goto anon8;

  anon17_Else:
    assume {:partition} char#ToInt(res#0) < char#ToInt(Lit(char#FromInt(97)));
    goto anon8;

  anon8:
    assume char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(res#0) && char#ToInt(res#0) <= char#ToInt(Lit(char#FromInt(102)));
    goto anon9;

  anon9:
    ##ch#0 := res#0;
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume HexStrings.__default.IsHexChar#canCall(res#0);
    assume HexStrings.__default.IsHexChar(res#0);
    assume false;
    return;

  anon14_Else:
    newtype$check#1 := LitInt(10);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} x#0 < 10;
    newtype$check#2 := x#0;
    assume char#IsChar(newtype$check#2);
    assume char#IsChar(char#ToInt(Lit(char#FromInt(48))) + char#ToInt(char#FromInt(x#0)));
    assume HexStrings.__default.HexChar(x#0) == char#Plus(char#FromInt(48), char#FromInt(x#0));
    assume true;
    assume $Is(HexStrings.__default.HexChar(x#0), TChar);
    goto anon13;

  anon18_Else:
    assume {:partition} 10 <= x#0;
    newtype$check#3 := LitInt(10);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := x#0 - 10;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := x#0 - 10;
    assume char#IsChar(newtype$check#5);
    assume char#IsChar(char#ToInt(Lit(char#FromInt(97))) + char#ToInt(char#FromInt(x#0 - 10)));
    assume HexStrings.__default.HexChar(x#0) == char#Plus(char#FromInt(97), char#FromInt(x#0 - 10));
    assume true;
    assume $Is(HexStrings.__default.HexChar(x#0), TChar);
    goto anon13;

  anon13:
    assume HexStrings.__default.HexChar(x#0) == res#0;
    return;
}



function HexStrings.__default.IsLooseHexChar(ch#0: char) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall ch#0: char :: { HexStrings.__default.IsLooseHexChar(ch#0) } HexStrings.__default.IsLooseHexChar#canCall(ch#0) || (0 < $FunctionContextHeight && $Is(ch#0, TChar)) ==> (HexStrings.__default.IsLooseHexChar(ch#0) <==> (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(70))))));
axiom 0 <= $FunctionContextHeight ==> (forall ch#0: char :: {:weight 3} { HexStrings.__default.IsLooseHexChar(Lit(ch#0)) } HexStrings.__default.IsLooseHexChar#canCall(Lit(ch#0)) || (0 < $FunctionContextHeight && $Is(ch#0, TChar)) ==> (HexStrings.__default.IsLooseHexChar(Lit(ch#0)) <==> (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(70))))));
}

function HexStrings.__default.IsLooseHexChar#canCall(ch#0: char) : bool;

function HexStrings.__default.IsLooseHexChar#requires(char) : bool;

axiom (forall ch#0: char :: { HexStrings.__default.IsLooseHexChar#requires(ch#0) } $Is(ch#0, TChar) ==> (HexStrings.__default.IsLooseHexChar#requires(ch#0) <==> true));

procedure {:verboseName "HexStrings.IsLooseHexChar (well-formedness)"} CheckWellformed$$HexStrings.__default.IsLooseHexChar(ch#0: char where $Is(ch#0, TChar));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function HexStrings.__default.IsHexChar(ch#0: char) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall ch#0: char :: { HexStrings.__default.IsHexChar(ch#0) } HexStrings.__default.IsHexChar#canCall(ch#0) || (0 < $FunctionContextHeight && $Is(ch#0, TChar)) ==> (HexStrings.__default.IsHexChar(ch#0) <==> (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102))))));
axiom 0 <= $FunctionContextHeight ==> (forall ch#0: char :: {:weight 3} { HexStrings.__default.IsHexChar(Lit(ch#0)) } HexStrings.__default.IsHexChar#canCall(Lit(ch#0)) || (0 < $FunctionContextHeight && $Is(ch#0, TChar)) ==> (HexStrings.__default.IsHexChar(Lit(ch#0)) <==> (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(102))))));
}

function HexStrings.__default.IsHexChar#canCall(ch#0: char) : bool;

function HexStrings.__default.IsHexChar#requires(char) : bool;

axiom (forall ch#0: char :: { HexStrings.__default.IsHexChar#requires(ch#0) } $Is(ch#0, TChar) ==> (HexStrings.__default.IsHexChar#requires(ch#0) <==> true));

procedure {:verboseName "HexStrings.IsHexChar (well-formedness)"} CheckWellformed$$HexStrings.__default.IsHexChar(ch#0: char where $Is(ch#0, TChar));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "HexStrings.PlainIsLooseChar (well-formedness)"} CheckWellFormed$$HexStrings.__default.PlainIsLooseChar(ch#0: char where $Is(ch#0, TChar));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "HexStrings.PlainIsLooseChar (call precondtion)"} CallPre$$HexStrings.__default.PlainIsLooseChar(ch#0: char where $Is(ch#0, TChar));
  requires {:id "id16306"} HexStrings.__default.IsHexChar#canCall(ch#0) ==> HexStrings.__default.IsHexChar(ch#0) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102))));



procedure {:verboseName "HexStrings.PlainIsLooseChar (call postcondition)"} CallPost$$HexStrings.__default.PlainIsLooseChar(ch#0: char where $Is(ch#0, TChar));
  modifies $Heap;
  free ensures HexStrings.__default.IsLooseHexChar#canCall(ch#0);
  free ensures {:id "id16307"} HexStrings.__default.IsLooseHexChar#canCall(ch#0) && HexStrings.__default.IsLooseHexChar(ch#0) && ((char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(70)))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.PlainIsLooseChar (correctness)"} Impl$$HexStrings.__default.PlainIsLooseChar(ch#0: char where $Is(ch#0, TChar)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id16308"} HexStrings.__default.IsHexChar#canCall(ch#0) && HexStrings.__default.IsHexChar(ch#0) && ((char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102)))));
  modifies $Heap;
  free ensures HexStrings.__default.IsLooseHexChar#canCall(ch#0);
  free ensures {:id "id16309"} HexStrings.__default.IsLooseHexChar#canCall(ch#0) ==> HexStrings.__default.IsLooseHexChar(ch#0) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(70))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.PlainIsLooseChar (correctness)"} Impl$$HexStrings.__default.PlainIsLooseChar(ch#0: char) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.PlainIsLooseChar", " | ", ch#0} true;
    assume {:print "Types", " | ", "char"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(41,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "HexStrings.PlainIsLooseString (well-formedness)"} CheckWellFormed$$HexStrings.__default.PlainIsLooseString(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "HexStrings.PlainIsLooseString (call precondtion)"} CallPre$$HexStrings.__default.PlainIsLooseString(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id16312"} HexStrings.__default.IsHexString#canCall(s#0) ==> HexStrings.__default.IsHexString(s#0) || (forall ch#0: char :: { HexStrings.__default.IsHexChar(ch#0) } { Seq#Contains(s#0, $Box(ch#0)) } $Is(ch#0, TChar) && Seq#Contains(s#0, $Box(ch#0)) ==> HexStrings.__default.IsHexChar(ch#0));



procedure {:verboseName "HexStrings.PlainIsLooseString (call postcondition)"} CallPost$$HexStrings.__default.PlainIsLooseString(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures HexStrings.__default.IsLooseHexString#canCall(s#0);
  free ensures {:id "id16313"} HexStrings.__default.IsLooseHexString#canCall(s#0) && HexStrings.__default.IsLooseHexString(s#0) && (forall ch#1: char :: { HexStrings.__default.IsLooseHexChar(ch#1) } { Seq#Contains(s#0, $Box(ch#1)) } $Is(ch#1, TChar) && Seq#Contains(s#0, $Box(ch#1)) ==> HexStrings.__default.IsLooseHexChar(ch#1));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.PlainIsLooseString (correctness)"} Impl$$HexStrings.__default.PlainIsLooseString(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id16314"} HexStrings.__default.IsHexString#canCall(s#0) && HexStrings.__default.IsHexString(s#0) && (forall ch#2: char :: { HexStrings.__default.IsHexChar(ch#2) } { Seq#Contains(s#0, $Box(ch#2)) } $Is(ch#2, TChar) && Seq#Contains(s#0, $Box(ch#2)) ==> HexStrings.__default.IsHexChar(ch#2));
  modifies $Heap;
  free ensures HexStrings.__default.IsLooseHexString#canCall(s#0);
  free ensures {:id "id16315"} HexStrings.__default.IsLooseHexString#canCall(s#0) ==> HexStrings.__default.IsLooseHexString(s#0) || (forall ch#3: char :: { HexStrings.__default.IsLooseHexChar(ch#3) } { Seq#Contains(s#0, $Box(ch#3)) } $Is(ch#3, TChar) && Seq#Contains(s#0, $Box(ch#3)) ==> HexStrings.__default.IsLooseHexChar(ch#3));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.PlainIsLooseString (correctness)"} Impl$$HexStrings.__default.PlainIsLooseString(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.PlainIsLooseString", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(46,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function HexStrings.__default.IsHexString(s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: { HexStrings.__default.IsHexString(s#0) } HexStrings.__default.IsHexString#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (forall ch#0: char :: { HexStrings.__default.IsHexChar(ch#0) } { Seq#Contains(s#0, $Box(ch#0)) } $Is(ch#0, TChar) ==> Seq#Contains(s#0, $Box(ch#0)) ==> HexStrings.__default.IsHexChar#canCall(ch#0)) && (HexStrings.__default.IsHexString(s#0) <==> (forall ch#0: char :: { HexStrings.__default.IsHexChar(ch#0) } { Seq#Contains(s#0, $Box(ch#0)) } $Is(ch#0, TChar) && Seq#Contains(s#0, $Box(ch#0)) ==> HexStrings.__default.IsHexChar(ch#0))));
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { HexStrings.__default.IsHexString(Lit(s#0)) } HexStrings.__default.IsHexString#canCall(Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (forall ch#1: char :: { HexStrings.__default.IsHexChar(ch#1) } { Seq#Contains(s#0, $Box(ch#1)) } $Is(ch#1, TChar) ==> Seq#Contains(s#0, $Box(ch#1)) ==> HexStrings.__default.IsHexChar#canCall(ch#1)) && (HexStrings.__default.IsHexString(Lit(s#0)) <==> (forall ch#1: char :: { HexStrings.__default.IsHexChar(ch#1) } { Seq#Contains(s#0, $Box(ch#1)) } $Is(ch#1, TChar) && Seq#Contains(s#0, $Box(ch#1)) ==> HexStrings.__default.IsHexChar(ch#1))));
}

function HexStrings.__default.IsHexString#canCall(s#0: Seq) : bool;

function HexStrings.__default.IsHexString#requires(Seq) : bool;

axiom (forall s#0: Seq :: { HexStrings.__default.IsHexString#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (HexStrings.__default.IsHexString#requires(s#0) <==> true));

procedure {:verboseName "HexStrings.IsHexString (well-formedness)"} CheckWellformed$$HexStrings.__default.IsHexString(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function HexStrings.__default.IsLooseHexString(s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: { HexStrings.__default.IsLooseHexString(s#0) } HexStrings.__default.IsLooseHexString#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (forall ch#0: char :: { HexStrings.__default.IsLooseHexChar(ch#0) } { Seq#Contains(s#0, $Box(ch#0)) } $Is(ch#0, TChar) ==> Seq#Contains(s#0, $Box(ch#0)) ==> HexStrings.__default.IsLooseHexChar#canCall(ch#0)) && (HexStrings.__default.IsLooseHexString(s#0) <==> (forall ch#0: char :: { HexStrings.__default.IsLooseHexChar(ch#0) } { Seq#Contains(s#0, $Box(ch#0)) } $Is(ch#0, TChar) && Seq#Contains(s#0, $Box(ch#0)) ==> HexStrings.__default.IsLooseHexChar(ch#0))));
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { HexStrings.__default.IsLooseHexString(Lit(s#0)) } HexStrings.__default.IsLooseHexString#canCall(Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (forall ch#1: char :: { HexStrings.__default.IsLooseHexChar(ch#1) } { Seq#Contains(s#0, $Box(ch#1)) } $Is(ch#1, TChar) ==> Seq#Contains(s#0, $Box(ch#1)) ==> HexStrings.__default.IsLooseHexChar#canCall(ch#1)) && (HexStrings.__default.IsLooseHexString(Lit(s#0)) <==> (forall ch#1: char :: { HexStrings.__default.IsLooseHexChar(ch#1) } { Seq#Contains(s#0, $Box(ch#1)) } $Is(ch#1, TChar) && Seq#Contains(s#0, $Box(ch#1)) ==> HexStrings.__default.IsLooseHexChar(ch#1))));
}

function HexStrings.__default.IsLooseHexString#canCall(s#0: Seq) : bool;

function HexStrings.__default.IsLooseHexString#requires(Seq) : bool;

axiom (forall s#0: Seq :: { HexStrings.__default.IsLooseHexString#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (HexStrings.__default.IsLooseHexString#requires(s#0) <==> true));

procedure {:verboseName "HexStrings.IsLooseHexString (well-formedness)"} CheckWellformed$$HexStrings.__default.IsLooseHexString(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function HexStrings.__default.HexVal(ch#0: char) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall ch#0: char :: { HexStrings.__default.HexVal(ch#0) } HexStrings.__default.HexVal#canCall(ch#0) || (1 < $FunctionContextHeight && $Is(ch#0, TChar) && HexStrings.__default.IsLooseHexChar(ch#0)) ==> LitInt(0) <= HexStrings.__default.HexVal(ch#0) && HexStrings.__default.HexVal(ch#0) < 16 && LitInt(0) <= HexStrings.__default.HexVal(ch#0) && HexStrings.__default.HexVal(ch#0) < BoundedInts.__default.TWO__TO__THE__8());
axiom 1 <= $FunctionContextHeight ==> (forall ch#0: char :: { HexStrings.__default.HexVal(ch#0) } HexStrings.__default.HexVal#canCall(ch#0) || (1 < $FunctionContextHeight && $Is(ch#0, TChar) && HexStrings.__default.IsLooseHexChar(ch#0)) ==> HexStrings.__default.HexVal(ch#0) == (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57))) then char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(48))) else (if char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102))) then char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(97))) + 10 else char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(65))) + 10)));
axiom 1 <= $FunctionContextHeight ==> (forall ch#0: char :: {:weight 3} { HexStrings.__default.HexVal(Lit(ch#0)) } HexStrings.__default.HexVal#canCall(Lit(ch#0)) || (1 < $FunctionContextHeight && $Is(ch#0, TChar) && Lit(HexStrings.__default.IsLooseHexChar(Lit(ch#0)))) ==> HexStrings.__default.HexVal(Lit(ch#0)) == (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(57))) then char#ToInt(Lit(ch#0)) - char#ToInt(Lit(char#FromInt(48))) else (if char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(ch#0)) && char#ToInt(Lit(ch#0)) <= char#ToInt(Lit(char#FromInt(102))) then char#ToInt(Lit(ch#0)) - char#ToInt(Lit(char#FromInt(97))) + 10 else char#ToInt(Lit(ch#0)) - char#ToInt(Lit(char#FromInt(65))) + 10)));
}

function HexStrings.__default.HexVal#canCall(ch#0: char) : bool;

function HexStrings.__default.HexVal#requires(char) : bool;

axiom (forall ch#0: char :: { HexStrings.__default.HexVal#requires(ch#0) } $Is(ch#0, TChar) ==> (HexStrings.__default.HexVal#requires(ch#0) <==> HexStrings.__default.IsLooseHexChar(ch#0)));

procedure {:verboseName "HexStrings.HexVal (well-formedness)"} CheckWellformed$$HexStrings.__default.HexVal(ch#0: char where $Is(ch#0, TChar)) returns (res#0: int where LitInt(0) <= res#0 && res#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16318"} LitInt(0) <= res#0;
  free ensures {:id "id16319"} res#0 < 16;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexVal (well-formedness)"} CheckWellformed$$HexStrings.__default.HexVal(ch#0: char) returns (res#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ch#0: char;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexVal", " | ", ch#0} true;
    assume {:print "Types", " | ", "char"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(62,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##ch#0 := ch#0;
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume HexStrings.__default.IsLooseHexChar#canCall(ch#0);
    assume HexStrings.__default.IsLooseHexChar(ch#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume LitInt(0) <= HexStrings.__default.HexVal(ch#0) && HexStrings.__default.HexVal(ch#0) < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= res#0;
    newtype$check#1 := LitInt(16);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon4;

  anon18_Else:
    assume {:partition} res#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= res#0 && res#0 < 16;
    assume false;
    return;

  anon17_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0);
    goto anon7;

  anon19_Else:
    assume {:partition} char#ToInt(ch#0) < char#ToInt(Lit(char#FromInt(48)));
    goto anon7;

  anon7:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)));
    newtype$check#2 := char#ToInt(ch#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(ch#0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#6 := char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    assume HexStrings.__default.HexVal(ch#0) == char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(48)));
    assume true;
    assume $Is(HexStrings.__default.HexVal(ch#0), Tclass.BoundedInts.uint8());
    goto anon16;

  anon20_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57))));
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0);
    goto anon11;

  anon21_Else:
    assume {:partition} char#ToInt(ch#0) < char#ToInt(Lit(char#FromInt(97)));
    goto anon11;

  anon11:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102)));
    newtype$check#7 := char#ToInt(ch#0);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#8 := char#ToInt(ch#0);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#9 := char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#10 := char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#11 := char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#12 := LitInt(10);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#13 := char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(97))) + 10;
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__8();
    assume HexStrings.__default.HexVal(ch#0) == char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(97))) + 10;
    assume true;
    assume $Is(HexStrings.__default.HexVal(ch#0), Tclass.BoundedInts.uint8());
    goto anon16;

  anon22_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102))));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(ch#0);
    goto anon15;

  anon23_Else:
    assume {:partition} char#ToInt(ch#0) < char#ToInt(Lit(char#FromInt(65)));
    goto anon15;

  anon15:
    assume true;
    assume {:subsumption 0} char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(ch#0);
    assume {:subsumption 0} char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(70)));
    assume char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(70)));
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(71,29)"} true;
    newtype$check#14 := char#ToInt(ch#0);
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#15 := char#ToInt(ch#0);
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#16 := char#ToInt(Lit(char#FromInt(65)));
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#17 := char#ToInt(Lit(char#FromInt(65)));
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#18 := char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(65)));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#19 := LitInt(10);
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#20 := char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(65))) + 10;
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__8();
    assume HexStrings.__default.HexVal(ch#0) == char#ToInt(ch#0) - char#ToInt(Lit(char#FromInt(65))) + 10;
    assume true;
    assume $Is(HexStrings.__default.HexVal(ch#0), Tclass.BoundedInts.uint8());
    goto anon16;

  anon16:
    assume HexStrings.__default.HexVal(ch#0) == res#0;
    return;
}



procedure {:verboseName "HexStrings.HexCharRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexCharRoundTrip(ch#0: char where $Is(ch#0, TChar));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexCharRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexCharRoundTrip(ch#0: char)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##ch#0: char;
  var ##ch#1: char;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexCharRoundTrip", " | ", ch#0} true;
    assume {:print "Types", " | ", "char"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(75,8): initial state"} true;
    ##ch#0 := ch#0;
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume HexStrings.__default.IsHexChar#canCall(ch#0);
    assume HexStrings.__default.IsHexChar(ch#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(77,32): post-state"} true;
    ##ch#1 := ch#0;
    assume $IsAlloc(##ch#1, TChar, $Heap);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall(##ch#1) ==> HexStrings.__default.IsLooseHexChar(##ch#1) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##ch#1) && char#ToInt(##ch#1) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##ch#1) && char#ToInt(##ch#1) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##ch#1) && char#ToInt(##ch#1) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar(##ch#1);
    assume HexStrings.__default.HexVal#canCall(ch#0);
    ##x#0 := HexStrings.__default.HexVal(ch#0);
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} ##x#0 < 16;
    assume ##x#0 < 16;
    assume HexStrings.__default.HexChar#canCall(HexStrings.__default.HexVal(ch#0));
    assume HexStrings.__default.HexChar(HexStrings.__default.HexVal(ch#0)) == ch#0;
    return;
}



procedure {:verboseName "HexStrings.HexCharRoundTrip (call precondtion)"} CallPre$$HexStrings.__default.HexCharRoundTrip(ch#0: char where $Is(ch#0, TChar));
  requires {:id "id16354"} HexStrings.__default.IsHexChar#canCall(ch#0) ==> HexStrings.__default.IsHexChar(ch#0) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102))));



procedure {:verboseName "HexStrings.HexCharRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexCharRoundTrip(ch#0: char where $Is(ch#0, TChar));
  modifies $Heap;
  free ensures HexStrings.__default.HexVal#canCall(ch#0) && HexStrings.__default.HexChar#canCall(HexStrings.__default.HexVal(ch#0));
  free ensures {:id "id16355"} HexStrings.__default.HexChar(HexStrings.__default.HexVal(ch#0)) == ch#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.HexCharRoundTrip (correctness)"} Impl$$HexStrings.__default.HexCharRoundTrip(ch#0: char where $Is(ch#0, TChar)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id16356"} HexStrings.__default.IsHexChar#canCall(ch#0) && HexStrings.__default.IsHexChar(ch#0) && ((char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(ch#0) && char#ToInt(ch#0) <= char#ToInt(Lit(char#FromInt(102)))));
  modifies $Heap;
  free ensures HexStrings.__default.HexVal#canCall(ch#0) && HexStrings.__default.HexChar#canCall(HexStrings.__default.HexVal(ch#0));
  free ensures {:id "id16357"} HexStrings.__default.HexChar(HexStrings.__default.HexVal(ch#0)) == ch#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexCharRoundTrip (correctness)"} Impl$$HexStrings.__default.HexCharRoundTrip(ch#0: char) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexCharRoundTrip", " | ", ch#0} true;
    assume {:print "Types", " | ", "char"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(78,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "HexStrings.HexValRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexValRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexValRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexValRoundTrip(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##x#0: int;
  var ##ch#0: char;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexValRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(80,8): initial state"} true;
    newtype$check#0 := LitInt(16);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume x#0 < 16;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(82,31): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} ##x#0 < 16;
    assume ##x#0 < 16;
    assume HexStrings.__default.HexChar#canCall(x#0);
    ##ch#0 := HexStrings.__default.HexChar(x#0);
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall(##ch#0) ==> HexStrings.__default.IsLooseHexChar(##ch#0) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##ch#0) && char#ToInt(##ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##ch#0) && char#ToInt(##ch#0) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##ch#0) && char#ToInt(##ch#0) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar(##ch#0);
    assume HexStrings.__default.HexVal#canCall(HexStrings.__default.HexChar(x#0));
    assume HexStrings.__default.HexVal(HexStrings.__default.HexChar(x#0)) == x#0;
    return;
}



procedure {:verboseName "HexStrings.HexValRoundTrip (call precondtion)"} CallPre$$HexStrings.__default.HexValRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());
  requires {:id "id16363"} x#0 < 16;



procedure {:verboseName "HexStrings.HexValRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexValRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());
  modifies $Heap;
  free ensures HexStrings.__default.HexChar#canCall(x#0) && HexStrings.__default.HexVal#canCall(HexStrings.__default.HexChar(x#0));
  free ensures {:id "id16364"} HexStrings.__default.HexVal(HexStrings.__default.HexChar(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.HexValRoundTrip (correctness)"} Impl$$HexStrings.__default.HexValRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id16365"} x#0 < 16;
  modifies $Heap;
  free ensures HexStrings.__default.HexChar#canCall(x#0) && HexStrings.__default.HexVal#canCall(HexStrings.__default.HexChar(x#0));
  free ensures {:id "id16366"} HexStrings.__default.HexVal(HexStrings.__default.HexChar(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexValRoundTrip (correctness)"} Impl$$HexStrings.__default.HexValRoundTrip(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexValRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(83,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function HexStrings.__default.HexStr(x#0: int) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall x#0: int :: { HexStrings.__default.HexStr(x#0) } HexStrings.__default.HexStr#canCall(x#0) || (2 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> Seq#Length(HexStrings.__default.HexStr(x#0)) == LitInt(2) && $Is(HexStrings.__default.HexStr(x#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: int :: { HexStrings.__default.HexStr(x#0) } HexStrings.__default.HexStr#canCall(x#0) || (2 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (x#0 < 16 ==> HexStrings.__default.HexChar#canCall(x#0)) && (16 <= x#0 ==> HexStrings.__default.HexChar#canCall(Div(x#0, LitInt(16))) && HexStrings.__default.HexChar#canCall(Mod(x#0, LitInt(16)))) && HexStrings.__default.HexStr(x#0) == (if x#0 < 16 then (var res#0 := Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(char#FromInt(48)))), $Box(HexStrings.__default.HexChar(x#0))); res#0) else (var res#1 := Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexChar(Div(x#0, LitInt(16))))), $Box(HexStrings.__default.HexChar(Mod(x#0, LitInt(16))))); res#1)));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { HexStrings.__default.HexStr(LitInt(x#0)) } HexStrings.__default.HexStr#canCall(LitInt(x#0)) || (2 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (Lit(x#0 < 16) ==> HexStrings.__default.HexChar#canCall(LitInt(x#0))) && (!Lit(x#0 < 16) ==> HexStrings.__default.HexChar#canCall(LitInt(Div(x#0, LitInt(16)))) && HexStrings.__default.HexChar#canCall(LitInt(Mod(x#0, LitInt(16))))) && HexStrings.__default.HexStr(LitInt(x#0)) == (if x#0 < 16 then (var res#2 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(char#FromInt(48)))), $Box(Lit(HexStrings.__default.HexChar(LitInt(x#0)))))); res#2) else (var res#3 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(HexStrings.__default.HexChar(LitInt(Div(x#0, LitInt(16))))))), $Box(Lit(HexStrings.__default.HexChar(LitInt(Mod(x#0, LitInt(16)))))))); res#3)));
}

function HexStrings.__default.HexStr#canCall(x#0: int) : bool;

function HexStrings.__default.HexStr#requires(int) : bool;

axiom (forall x#0: int :: { HexStrings.__default.HexStr#requires(x#0) } LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (HexStrings.__default.HexStr#requires(x#0) <==> true));

procedure {:verboseName "HexStrings.HexStr (well-formedness)"} CheckWellformed$$HexStrings.__default.HexStr(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (ret#0: Seq where $Is(ret#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16367"} Seq#Length(ret#0) == LitInt(2);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexStr (well-formedness)"} CheckWellformed$$HexStrings.__default.HexStr(x#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var res#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##x#0: int;
  var res#Z#1: Seq;
  var let#1#0#0: Seq;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##x#1: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var ##x#2: int;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexStr", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(86,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(HexStrings.__default.HexStr(x#0), TSeq(TChar));
    assume Seq#Length(ret#0) == LitInt(2);
    assume false;
    return;

  anon7_Else:
    newtype$check#0 := LitInt(16);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} x#0 < 16;
    havoc res#Z#0;
    assume $Is(res#Z#0, TSeq(TChar)) && $IsAlloc(res#Z#0, TSeq(TChar), $Heap);
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} ##x#0 < 16;
    assume ##x#0 < 16;
    assume HexStrings.__default.HexChar#canCall(x#0);
    assume let#0#0#0 == Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(char#FromInt(48)))), $Box(HexStrings.__default.HexChar(x#0)));
    assume HexStrings.__default.HexChar#canCall(x#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume res#Z#0 == let#0#0#0;
    assume HexStrings.__default.HexStr(x#0) == res#Z#0;
    assume true;
    assume $Is(HexStrings.__default.HexStr(x#0), TSeq(TChar));
    goto anon6;

  anon8_Else:
    assume {:partition} 16 <= x#0;
    havoc res#Z#1;
    assume $Is(res#Z#1, TSeq(TChar)) && $IsAlloc(res#Z#1, TSeq(TChar), $Heap);
    newtype$check#1 := LitInt(16);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume LitInt(16) != 0;
    newtype$check#2 := Div(x#0, LitInt(16));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := Div(x#0, LitInt(16));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := Div(x#0, LitInt(16));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    ##x#1 := Div(x#0, LitInt(16));
    assume $IsAlloc(##x#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} ##x#1 < 16;
    assume ##x#1 < 16;
    assume HexStrings.__default.HexChar#canCall(Div(x#0, LitInt(16)));
    newtype$check#5 := LitInt(16);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    assume LitInt(16) != 0;
    newtype$check#6 := Mod(x#0, LitInt(16));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := Mod(x#0, LitInt(16));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#8 := Mod(x#0, LitInt(16));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    ##x#2 := Mod(x#0, LitInt(16));
    assume $IsAlloc(##x#2, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} ##x#2 < 16;
    assume ##x#2 < 16;
    assume HexStrings.__default.HexChar#canCall(Mod(x#0, LitInt(16)));
    assume let#1#0#0 == Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexChar(Div(x#0, LitInt(16))))), $Box(HexStrings.__default.HexChar(Mod(x#0, LitInt(16)))));
    assume HexStrings.__default.HexChar#canCall(Div(x#0, LitInt(16))) && HexStrings.__default.HexChar#canCall(Mod(x#0, LitInt(16)));
    assume $Is(let#1#0#0, TSeq(TChar));
    assume res#Z#1 == let#1#0#0;
    assume HexStrings.__default.HexStr(x#0) == res#Z#1;
    assume true;
    assume $Is(HexStrings.__default.HexStr(x#0), TSeq(TChar));
    goto anon6;

  anon6:
    assume HexStrings.__default.HexStr(x#0) == ret#0;
    return;
}



function HexStrings.__default.HexValue(x#0: Seq) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: { HexStrings.__default.HexValue(x#0) } HexStrings.__default.HexValue#canCall(x#0) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && Seq#Length(x#0) == LitInt(2) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char)) ==> LitInt(0) <= HexStrings.__default.HexValue(x#0) && HexStrings.__default.HexValue(x#0) < BoundedInts.__default.TWO__TO__THE__8());
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: { HexStrings.__default.HexValue(x#0) } HexStrings.__default.HexValue#canCall(x#0) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && Seq#Length(x#0) == LitInt(2) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char)) ==> HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char) && HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char) && HexStrings.__default.HexValue(x#0) == Mul(HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(0))): char), LitInt(16)) + HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(1))): char));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { HexStrings.__default.HexValue(Lit(x#0)) } HexStrings.__default.HexValue#canCall(Lit(x#0)) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && Seq#Length(Lit(x#0)) == LitInt(2) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(Lit(x#0), LitInt(1))): char)) ==> HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) && HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(Lit(x#0), LitInt(1))): char) && HexStrings.__default.HexValue(Lit(x#0)) == Mul(HexStrings.__default.HexVal($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char), LitInt(16)) + HexStrings.__default.HexVal($Unbox(Seq#Index(Lit(x#0), LitInt(1))): char));
}

function HexStrings.__default.HexValue#canCall(x#0: Seq) : bool;

function HexStrings.__default.HexValue#requires(Seq) : bool;

axiom (forall x#0: Seq :: { HexStrings.__default.HexValue#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (HexStrings.__default.HexValue#requires(x#0) <==> Seq#Length(x#0) == LitInt(2) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char)));

procedure {:verboseName "HexStrings.HexValue (well-formedness)"} CheckWellformed$$HexStrings.__default.HexValue(x#0: Seq where $Is(x#0, TSeq(TChar))) returns (ret#0: int where LitInt(0) <= ret#0 && ret#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexValue (well-formedness)"} CheckWellformed$$HexStrings.__default.HexValue(x#0: Seq) returns (ret#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ch#0: char;
  var ##ch#1: char;
  var ##ch#2: char;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##ch#3: char;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexValue", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(98,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(x#0) == LitInt(2);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    ##ch#0 := $Unbox(Seq#Index(x#0, LitInt(0))): char;
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(x#0);
    ##ch#1 := $Unbox(Seq#Index(x#0, LitInt(1))): char;
    assume $IsAlloc(##ch#1, TChar, $Heap);
    assume HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char);
    assume HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= HexStrings.__default.HexValue(x#0) && HexStrings.__default.HexValue(x#0) < BoundedInts.__default.TWO__TO__THE__8();
    assume false;
    return;

  anon4_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    ##ch#2 := $Unbox(Seq#Index(x#0, LitInt(0))): char;
    assume $IsAlloc(##ch#2, TChar, $Heap);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall(##ch#2) ==> HexStrings.__default.IsLooseHexChar(##ch#2) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##ch#2) && char#ToInt(##ch#2) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##ch#2) && char#ToInt(##ch#2) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##ch#2) && char#ToInt(##ch#2) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar(##ch#2);
    assume HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char);
    newtype$check#0 := LitInt(16);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := Mul(HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(0))): char), LitInt(16));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(x#0);
    ##ch#3 := $Unbox(Seq#Index(x#0, LitInt(1))): char;
    assume $IsAlloc(##ch#3, TChar, $Heap);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall(##ch#3) ==> HexStrings.__default.IsLooseHexChar(##ch#3) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##ch#3) && char#ToInt(##ch#3) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##ch#3) && char#ToInt(##ch#3) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##ch#3) && char#ToInt(##ch#3) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar(##ch#3);
    assume HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char);
    newtype$check#2 := Mul(HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(0))): char), LitInt(16)) + HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(1))): char);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    assume HexStrings.__default.HexValue(x#0) == Mul(HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(0))): char), LitInt(16)) + HexStrings.__default.HexVal($Unbox(Seq#Index(x#0, LitInt(1))): char);
    assume HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char) && HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char);
    assume $Is(HexStrings.__default.HexValue(x#0), Tclass.BoundedInts.uint8());
    assume HexStrings.__default.HexValue(x#0) == ret#0;
    return;
}



procedure {:verboseName "HexStrings.HexValueRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexValueRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexValueRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexValueRoundTrip(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##x#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexValueRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(105,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(106,32): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint8(), $Heap);
    assume HexStrings.__default.HexStr#canCall(x#0);
    ##x#1 := HexStrings.__default.HexStr(x#0);
    assume $IsAlloc(##x#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##x#1) == LitInt(2);
    assume Seq#Length(##x#1) == LitInt(2);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#1, LitInt(0))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1, LitInt(0))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#1, LitInt(1))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1, LitInt(1))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1, LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1, LitInt(1))): char);
    assume HexStrings.__default.HexValue#canCall(HexStrings.__default.HexStr(x#0));
    assume HexStrings.__default.HexValue(HexStrings.__default.HexStr(x#0)) == x#0;
    return;
}



procedure {:verboseName "HexStrings.HexValueRoundTrip (call precondtion)"} CallPre$$HexStrings.__default.HexValueRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());



procedure {:verboseName "HexStrings.HexValueRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexValueRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8());
  modifies $Heap;
  free ensures HexStrings.__default.HexStr#canCall(x#0) && HexStrings.__default.HexValue#canCall(HexStrings.__default.HexStr(x#0));
  free ensures {:id "id16408"} HexStrings.__default.HexValue(HexStrings.__default.HexStr(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.HexValueRoundTrip (correctness)"} Impl$$HexStrings.__default.HexValueRoundTrip(x#0: int where LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__8()) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures HexStrings.__default.HexStr#canCall(x#0) && HexStrings.__default.HexValue#canCall(HexStrings.__default.HexStr(x#0));
  free ensures {:id "id16409"} HexStrings.__default.HexValue(HexStrings.__default.HexStr(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexValueRoundTrip (correctness)"} Impl$$HexStrings.__default.HexValueRoundTrip(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexValueRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(107,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "HexStrings.HexStrRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexStrRoundTrip(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexStrRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.HexStrRoundTrip(x#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##ch#0: char;
  var ##ch#1: char;
  var ##x#0: Seq;
  var ##x#1: int;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexStrRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(108,8): initial state"} true;
    assume Seq#Length(x#0) == LitInt(2);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    ##ch#0 := $Unbox(Seq#Index(x#0, LitInt(0))): char;
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume HexStrings.__default.IsHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume HexStrings.__default.IsHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(x#0);
    ##ch#1 := $Unbox(Seq#Index(x#0, LitInt(1))): char;
    assume $IsAlloc(##ch#1, TChar, $Heap);
    assume HexStrings.__default.IsHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char);
    assume HexStrings.__default.IsHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(111,32): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##x#0) == LitInt(2);
    assume Seq#Length(##x#0) == LitInt(2);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#0, LitInt(0))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(0))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#0, LitInt(1))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(1))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(1))): char);
    assume HexStrings.__default.HexValue#canCall(x#0);
    ##x#1 := HexStrings.__default.HexValue(x#0);
    assume $IsAlloc(##x#1, Tclass.BoundedInts.uint8(), $Heap);
    assume HexStrings.__default.HexStr#canCall(HexStrings.__default.HexValue(x#0));
    assume Seq#Equal(HexStrings.__default.HexStr(HexStrings.__default.HexValue(x#0)), x#0);
    return;
}



procedure {:verboseName "HexStrings.HexStrRoundTrip (call precondtion)"} CallPre$$HexStrings.__default.HexStrRoundTrip(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap));
  requires {:id "id16419"} Seq#Length(x#0) == LitInt(2);
  requires {:id "id16420"} HexStrings.__default.IsHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char) ==> HexStrings.__default.IsHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102))));
  requires {:id "id16421"} HexStrings.__default.IsHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char) ==> HexStrings.__default.IsHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102))));



procedure {:verboseName "HexStrings.HexStrRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexStrRoundTrip(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures HexStrings.__default.HexValue#canCall(x#0) && HexStrings.__default.HexStr#canCall(HexStrings.__default.HexValue(x#0));
  free ensures {:id "id16422"} Seq#Equal(HexStrings.__default.HexStr(HexStrings.__default.HexValue(x#0)), x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.HexStrRoundTrip (correctness)"} Impl$$HexStrings.__default.HexStrRoundTrip(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id16423"} Seq#Length(x#0) == LitInt(2);
  free requires {:id "id16424"} HexStrings.__default.IsHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(0))): char) && HexStrings.__default.IsHexChar($Unbox(Seq#Index(x#0, LitInt(0))): char) && ((char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102)))));
  free requires {:id "id16425"} HexStrings.__default.IsHexChar#canCall($Unbox(Seq#Index(x#0, LitInt(1))): char) && HexStrings.__default.IsHexChar($Unbox(Seq#Index(x#0, LitInt(1))): char) && ((char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102)))));
  modifies $Heap;
  free ensures HexStrings.__default.HexValue#canCall(x#0) && HexStrings.__default.HexStr#canCall(HexStrings.__default.HexValue(x#0));
  free ensures {:id "id16426"} Seq#Equal(HexStrings.__default.HexStr(HexStrings.__default.HexValue(x#0)), x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexStrRoundTrip (correctness)"} Impl$$HexStrings.__default.HexStrRoundTrip(x#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexStrRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(112,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function HexStrings.__default.ToHexString($ly: LayerType, val#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { HexStrings.__default.ToHexString($ly, val#0) } HexStrings.__default.ToHexString#canCall(val#0) || (3 < $FunctionContextHeight && $Is(val#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq#Length(HexStrings.__default.ToHexString($ly, val#0)) == Mul(LitInt(2), Seq#Length(val#0)) && $Is(HexStrings.__default.ToHexString($ly, val#0), Tclass.HexStrings.HexString()));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { HexStrings.__default.ToHexString($LS($ly), val#0) } HexStrings.__default.ToHexString#canCall(val#0) || (3 < $FunctionContextHeight && $Is(val#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Seq#Length(val#0) != LitInt(0) ==> HexStrings.__default.HexStr#canCall($Unbox(Seq#Index(val#0, LitInt(0))): int) && HexStrings.__default.ToHexString#canCall(Seq#Drop(val#0, LitInt(1)))) && HexStrings.__default.ToHexString($LS($ly), val#0) == (if Seq#Length(val#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(HexStrings.__default.HexStr($Unbox(Seq#Index(val#0, LitInt(0))): int), HexStrings.__default.ToHexString($ly, Seq#Drop(val#0, LitInt(1))))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: {:weight 3} { HexStrings.__default.ToHexString($LS($ly), Lit(val#0)) } HexStrings.__default.ToHexString#canCall(Lit(val#0)) || (3 < $FunctionContextHeight && $Is(val#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Seq#Length(Lit(val#0)) != LitInt(0) ==> HexStrings.__default.HexStr#canCall($Unbox(Seq#Index(Lit(val#0), LitInt(0))): int) && HexStrings.__default.ToHexString#canCall(Lit(Seq#Drop(Lit(val#0), LitInt(1))))) && HexStrings.__default.ToHexString($LS($ly), Lit(val#0)) == (if Seq#Length(Lit(val#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(HexStrings.__default.HexStr($Unbox(Seq#Index(Lit(val#0), LitInt(0))): int), HexStrings.__default.ToHexString($LS($ly), Lit(Seq#Drop(Lit(val#0), LitInt(1)))))));
}

function HexStrings.__default.ToHexString#canCall(val#0: Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { HexStrings.__default.ToHexString($LS($ly), val#0) } HexStrings.__default.ToHexString($LS($ly), val#0) == HexStrings.__default.ToHexString($ly, val#0));

axiom (forall $ly: LayerType, val#0: Seq :: { HexStrings.__default.ToHexString(AsFuelBottom($ly), val#0) } HexStrings.__default.ToHexString($ly, val#0) == HexStrings.__default.ToHexString($LZ, val#0));

function Tclass.HexStrings.HexString() : Ty
uses {
axiom Tag(Tclass.HexStrings.HexString()) == Tagclass.HexStrings.HexString && TagFamily(Tclass.HexStrings.HexString()) == tytagFamily$HexString;
}

const unique Tagclass.HexStrings.HexString: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.HexStrings.HexString()) } $IsBox(bx, Tclass.HexStrings.HexString()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.HexStrings.HexString()));

function HexStrings.__default.ToHexString#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { HexStrings.__default.ToHexString#requires($ly, val#0) } $Is(val#0, TSeq(Tclass.BoundedInts.uint8())) ==> (HexStrings.__default.ToHexString#requires($ly, val#0) <==> true));

procedure {:verboseName "HexStrings.ToHexString (well-formedness)"} CheckWellformed$$HexStrings.__default.ToHexString(val#0: Seq where $Is(val#0, TSeq(Tclass.BoundedInts.uint8()))) returns (ret#0: Seq where $Is(ret#0, Tclass.HexStrings.HexString()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16427"} Seq#Length(ret#0) == Mul(LitInt(2), Seq#Length(val#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.ToHexString (well-formedness)"} CheckWellformed$$HexStrings.__default.ToHexString(val#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##val#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.ToHexString", " | ", val#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(115,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(HexStrings.__default.ToHexString($LS($LZ), val#0), Tclass.HexStrings.HexString());
    assume Seq#Length(ret#0) == Mul(LitInt(2), Seq#Length(val#0));
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(val#0) == LitInt(0);
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.HexStrings.HexString());
    assume HexStrings.__default.ToHexString($LS($LZ), val#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(HexStrings.__default.ToHexString($LS($LZ), val#0), Tclass.HexStrings.HexString());
    goto anon6;

  anon8_Else:
    assume {:partition} Seq#Length(val#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(val#0);
    ##x#0 := $Unbox(Seq#Index(val#0, LitInt(0))): int;
    assume $IsAlloc(##x#0, Tclass.BoundedInts.uint8(), $Heap);
    assume HexStrings.__default.HexStr#canCall($Unbox(Seq#Index(val#0, LitInt(0))): int);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(val#0);
    ##val#0 := Seq#Drop(val#0, LitInt(1));
    assume $IsAlloc(##val#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Seq#Rank(##val#0) < Seq#Rank(val#0);
    assume HexStrings.__default.ToHexString#canCall(Seq#Drop(val#0, LitInt(1)));
    assume $Is(Seq#Append(HexStrings.__default.HexStr($Unbox(Seq#Index(val#0, LitInt(0))): int), HexStrings.__default.ToHexString($LS($LZ), Seq#Drop(val#0, LitInt(1)))), Tclass.HexStrings.HexString());
    assume HexStrings.__default.ToHexString($LS($LZ), val#0) == Seq#Append(HexStrings.__default.HexStr($Unbox(Seq#Index(val#0, LitInt(0))): int), HexStrings.__default.ToHexString($LS($LZ), Seq#Drop(val#0, LitInt(1))));
    assume HexStrings.__default.HexStr#canCall($Unbox(Seq#Index(val#0, LitInt(0))): int) && HexStrings.__default.ToHexString#canCall(Seq#Drop(val#0, LitInt(1)));
    assume $Is(HexStrings.__default.ToHexString($LS($LZ), val#0), Tclass.HexStrings.HexString());
    goto anon6;

  anon6:
    assume HexStrings.__default.ToHexString($LS($LZ), val#0) == ret#0;
    return;
}



function HexStrings.__default.FromHexString($ly: LayerType, data#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, data#0: Seq :: { HexStrings.__default.FromHexString($ly, data#0) } HexStrings.__default.FromHexString#canCall(data#0) || (3 < $FunctionContextHeight && $Is(data#0, Tclass.HexStrings.LooseHexString())) ==> Seq#Length(HexStrings.__default.FromHexString($ly, data#0)) == Div(Seq#Length(data#0) + 1, LitInt(2)) && $Is(HexStrings.__default.FromHexString($ly, data#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, data#0: Seq :: { HexStrings.__default.FromHexString($LS($ly), data#0) } HexStrings.__default.FromHexString#canCall(data#0) || (3 < $FunctionContextHeight && $Is(data#0, Tclass.HexStrings.LooseHexString())) ==> (Seq#Length(data#0) != LitInt(0) ==> (Mod(Seq#Length(data#0), LitInt(2)) == LitInt(1) ==> HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(data#0, LitInt(0))): char) && HexStrings.__default.FromHexString#canCall(Seq#Drop(data#0, LitInt(1)))) && (Mod(Seq#Length(data#0), LitInt(2)) != LitInt(1) ==> HexStrings.__default.HexValue#canCall(Seq#Take(data#0, LitInt(2))) && HexStrings.__default.FromHexString#canCall(Seq#Drop(data#0, LitInt(2))))) && HexStrings.__default.FromHexString($LS($ly), data#0) == (if Seq#Length(data#0) == LitInt(0) then Seq#Empty(): Seq else (if Mod(Seq#Length(data#0), LitInt(2)) == LitInt(1) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexVal($Unbox(Seq#Index(data#0, LitInt(0))): char))), HexStrings.__default.FromHexString($ly, Seq#Drop(data#0, LitInt(1)))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexValue(Seq#Take(data#0, LitInt(2))))), HexStrings.__default.FromHexString($ly, Seq#Drop(data#0, LitInt(2)))))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, data#0: Seq :: {:weight 3} { HexStrings.__default.FromHexString($LS($ly), Lit(data#0)) } HexStrings.__default.FromHexString#canCall(Lit(data#0)) || (3 < $FunctionContextHeight && $Is(data#0, Tclass.HexStrings.LooseHexString())) ==> (Seq#Length(Lit(data#0)) != LitInt(0) ==> (Mod(Seq#Length(Lit(data#0)), LitInt(2)) == LitInt(1) ==> HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(Lit(data#0), LitInt(0))): char) && HexStrings.__default.FromHexString#canCall(Lit(Seq#Drop(Lit(data#0), LitInt(1))))) && (Mod(Seq#Length(Lit(data#0)), LitInt(2)) != LitInt(1) ==> HexStrings.__default.HexValue#canCall(Lit(Seq#Take(Lit(data#0), LitInt(2)))) && HexStrings.__default.FromHexString#canCall(Lit(Seq#Drop(Lit(data#0), LitInt(2)))))) && HexStrings.__default.FromHexString($LS($ly), Lit(data#0)) == (if Seq#Length(Lit(data#0)) == LitInt(0) then Seq#Empty(): Seq else (if Mod(Seq#Length(Lit(data#0)), LitInt(2)) == LitInt(1) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexVal($Unbox(Seq#Index(Lit(data#0), LitInt(0))): char))), HexStrings.__default.FromHexString($LS($ly), Lit(Seq#Drop(Lit(data#0), LitInt(1))))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(HexStrings.__default.HexValue(Lit(Seq#Take(Lit(data#0), LitInt(2))))))), HexStrings.__default.FromHexString($LS($ly), Lit(Seq#Drop(Lit(data#0), LitInt(2))))))));
}

function HexStrings.__default.FromHexString#canCall(data#0: Seq) : bool;

axiom (forall $ly: LayerType, data#0: Seq :: { HexStrings.__default.FromHexString($LS($ly), data#0) } HexStrings.__default.FromHexString($LS($ly), data#0) == HexStrings.__default.FromHexString($ly, data#0));

axiom (forall $ly: LayerType, data#0: Seq :: { HexStrings.__default.FromHexString(AsFuelBottom($ly), data#0) } HexStrings.__default.FromHexString($ly, data#0) == HexStrings.__default.FromHexString($LZ, data#0));

function Tclass.HexStrings.LooseHexString() : Ty
uses {
axiom Tag(Tclass.HexStrings.LooseHexString()) == Tagclass.HexStrings.LooseHexString && TagFamily(Tclass.HexStrings.LooseHexString()) == tytagFamily$LooseHexString;
}

const unique Tagclass.HexStrings.LooseHexString: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.HexStrings.LooseHexString()) } $IsBox(bx, Tclass.HexStrings.LooseHexString()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.HexStrings.LooseHexString()));

function HexStrings.__default.FromHexString#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, data#0: Seq :: { HexStrings.__default.FromHexString#requires($ly, data#0) } $Is(data#0, Tclass.HexStrings.LooseHexString()) ==> (HexStrings.__default.FromHexString#requires($ly, data#0) <==> true));

procedure {:verboseName "HexStrings.FromHexString (well-formedness)"} CheckWellformed$$HexStrings.__default.FromHexString(data#0: Seq where $Is(data#0, Tclass.HexStrings.LooseHexString())) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16437"} Seq#Length(ret#0) == Div(Seq#Length(data#0) + 1, LitInt(2));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.FromHexString (well-formedness)"} CheckWellformed$$HexStrings.__default.FromHexString(data#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ch#0: char;
  var ##data#0: Seq;
  var ##x#0: Seq;
  var ##data#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.FromHexString", " | ", data#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(125,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(HexStrings.__default.FromHexString($LS($LZ), data#0), TSeq(Tclass.BoundedInts.uint8()));
    assume LitInt(2) != 0;
    assume Seq#Length(ret#0) == Div(Seq#Length(data#0) + 1, LitInt(2));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Length(data#0) == LitInt(0);
    assume HexStrings.__default.FromHexString($LS($LZ), data#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(HexStrings.__default.FromHexString($LS($LZ), data#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon10_Else:
    assume {:partition} Seq#Length(data#0) != LitInt(0);
    assume LitInt(2) != 0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Mod(Seq#Length(data#0), LitInt(2)) == LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(data#0);
    ##ch#0 := $Unbox(Seq#Index(data#0, LitInt(0))): char;
    assume $IsAlloc(##ch#0, TChar, $Heap);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall(##ch#0) ==> HexStrings.__default.IsLooseHexChar(##ch#0) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##ch#0) && char#ToInt(##ch#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##ch#0) && char#ToInt(##ch#0) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##ch#0) && char#ToInt(##ch#0) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar(##ch#0);
    assume HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(data#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(data#0);
    assume $Is(Seq#Drop(data#0, LitInt(1)), Tclass.HexStrings.LooseHexString());
    ##data#0 := Seq#Drop(data#0, LitInt(1));
    assume $IsAlloc(##data#0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume Seq#Rank(##data#0) < Seq#Rank(data#0);
    assume HexStrings.__default.FromHexString#canCall(Seq#Drop(data#0, LitInt(1)));
    assume HexStrings.__default.FromHexString($LS($LZ), data#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexVal($Unbox(Seq#Index(data#0, LitInt(0))): char))), HexStrings.__default.FromHexString($LS($LZ), Seq#Drop(data#0, LitInt(1))));
    assume HexStrings.__default.HexVal#canCall($Unbox(Seq#Index(data#0, LitInt(0))): char) && HexStrings.__default.FromHexString#canCall(Seq#Drop(data#0, LitInt(1)));
    assume $Is(HexStrings.__default.FromHexString($LS($LZ), data#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon11_Else:
    assume {:partition} Mod(Seq#Length(data#0), LitInt(2)) != LitInt(1);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(data#0);
    ##x#0 := Seq#Take(data#0, LitInt(2));
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##x#0) == LitInt(2);
    assume Seq#Length(##x#0) == LitInt(2);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#0, LitInt(0))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(0))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#0, LitInt(1))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(1))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(0))): char) && HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#0, LitInt(1))): char);
    assume HexStrings.__default.HexValue#canCall(Seq#Take(data#0, LitInt(2)));
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(data#0);
    assume $Is(Seq#Drop(data#0, LitInt(2)), Tclass.HexStrings.LooseHexString());
    ##data#1 := Seq#Drop(data#0, LitInt(2));
    assume $IsAlloc(##data#1, Tclass.HexStrings.LooseHexString(), $Heap);
    assume Seq#Rank(##data#1) < Seq#Rank(data#0);
    assume HexStrings.__default.FromHexString#canCall(Seq#Drop(data#0, LitInt(2)));
    assume HexStrings.__default.FromHexString($LS($LZ), data#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexValue(Seq#Take(data#0, LitInt(2))))), HexStrings.__default.FromHexString($LS($LZ), Seq#Drop(data#0, LitInt(2))));
    assume HexStrings.__default.HexValue#canCall(Seq#Take(data#0, LitInt(2))) && HexStrings.__default.FromHexString#canCall(Seq#Drop(data#0, LitInt(2)));
    assume $Is(HexStrings.__default.FromHexString($LS($LZ), data#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon8:
    assume HexStrings.__default.FromHexString($LS($LZ), data#0) == ret#0;
    return;
}



procedure {:verboseName "HexStrings.ToHexStringRoundTrip (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.ToHexStringRoundTrip (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##data#0: Seq;
  var ##val#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.ToHexStringRoundTrip", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(136,37): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume HexStrings.__default.IsHexString#canCall(s#0);
    assume HexStrings.__default.IsHexString(s#0);
    assume LitInt(2) != 0;
    assume Mod(Seq#Length(s#0), LitInt(2)) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(139,42): post-state"} true;
    assume $Is(s#0, Tclass.HexStrings.LooseHexString());
    ##data#0 := s#0;
    assume $IsAlloc(##data#0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(s#0);
    ##val#0 := HexStrings.__default.FromHexString($LS($LZ), s#0);
    assume $IsAlloc(##val#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume Seq#Equal(HexStrings.__default.ToHexString($LS($LZ), HexStrings.__default.FromHexString($LS($LZ), s#0)), s#0);
    return;
}



procedure {:verboseName "HexStrings.ToHexStringRoundTrip (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id16462"} HexStrings.__default.IsHexString#canCall(s#0) ==> HexStrings.__default.IsHexString(s#0) || (forall ch#0: char :: { HexStrings.__default.IsHexChar(ch#0) } { Seq#Contains(s#0, $Box(ch#0)) } $Is(ch#0, TChar) && Seq#Contains(s#0, $Box(ch#0)) ==> HexStrings.__default.IsHexChar(ch#0));
  requires {:id "id16463"} Mod(Seq#Length(s#0), LitInt(2)) == LitInt(0);



procedure {:verboseName "HexStrings.ToHexStringRoundTrip (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures HexStrings.__default.FromHexString#canCall(s#0) && HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
  free ensures {:id "id16464"} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), HexStrings.__default.FromHexString($LS($LS($LZ)), s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.ToHexStringRoundTrip (correctness)"} {:vcs_split_on_every_assert} Impl$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  free requires {:id "id16465"} HexStrings.__default.IsHexString#canCall(s#0) && HexStrings.__default.IsHexString(s#0) && (forall ch#1: char :: { HexStrings.__default.IsHexChar(ch#1) } { Seq#Contains(s#0, $Box(ch#1)) } $Is(ch#1, TChar) && Seq#Contains(s#0, $Box(ch#1)) ==> HexStrings.__default.IsHexChar(ch#1));
  requires {:id "id16466"} Mod(Seq#Length(s#0), LitInt(2)) == LitInt(0);
  modifies $Heap;
  free ensures HexStrings.__default.FromHexString#canCall(s#0) && HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
  free ensures {:id "id16467"} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), HexStrings.__default.FromHexString($LS($LS($LZ)), s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.ToHexStringRoundTrip (correctness)"} {:vcs_split_on_every_assert} Impl$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##data#0_0: Seq;
  var ##val#0_0: Seq;
  var x##1_0_0: Seq;
  var ##data#1_0_0: Seq;
  var ##x#1_0_0: Seq;
  var ##data#1_0_1: Seq;
  var ##val#1_0_0: Seq;
  var x##1_1_0: Seq;
  var ##data#1_1_0: Seq;
  var ##x#1_1_0: Seq;
  var ##data#1_1_1: Seq;
  var ##val#1_1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.ToHexStringRoundTrip", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(140,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq :: $Is($ih#s0#0, TSeq(TChar)) && HexStrings.__default.IsHexString($ih#s0#0) && Mod(Seq#Length($ih#s0#0), LitInt(2)) == LitInt(0) && Seq#Rank($ih#s0#0) < Seq#Rank(s#0) ==> Seq#Equal(HexStrings.__default.ToHexString($LS($LZ), HexStrings.__default.FromHexString($LS($LZ), $ih#s0#0)), $ih#s0#0));
    $_reverifyPost := false;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume $Is(s#0, Tclass.HexStrings.LooseHexString());
    ##data#0_0 := s#0;
    assume $IsAlloc(##data#0_0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(s#0);
    ##val#0_0 := HexStrings.__default.FromHexString($LS($LZ), s#0);
    assume $IsAlloc(##val#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume HexStrings.__default.FromHexString#canCall(s#0) && HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume {:subsumption 0} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), HexStrings.__default.FromHexString($LS($LS($LZ)), s#0)), s#0);
    assume Seq#Equal(HexStrings.__default.ToHexString($LS($LZ), HexStrings.__default.FromHexString($LS($LZ), s#0)), s#0);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(142,47)"} true;
    return;

  anon5_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(2);
    assume true;
    x##1_0_0 := s#0;
    call CallPre$$HexStrings.__default.HexStrRoundTrip(x##1_0_0);
    call CallPost$$HexStrings.__default.HexStrRoundTrip(x##1_0_0);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(145,24)"} true;
    assume $Is(s#0, Tclass.HexStrings.LooseHexString());
    ##data#1_0_0 := s#0;
    assume $IsAlloc(##data#1_0_0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(s#0);
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##x#1_0_0 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##x#1_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##x#1_0_0) == LitInt(2);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1_0_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.HexValue#canCall(Seq#Take(s#0, LitInt(2)));
    assume HexStrings.__default.FromHexString#canCall(s#0) && HexStrings.__default.HexValue#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} Seq#Equal(HexStrings.__default.FromHexString($LS($LS($LZ)), s#0), Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexValue(Seq#Take(s#0, LitInt(2))))));
    assume Seq#Equal(HexStrings.__default.FromHexString($LS($LZ), s#0), Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexValue(Seq#Take(s#0, LitInt(2))))));
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(146,51)"} true;
    assume $Is(s#0, Tclass.HexStrings.LooseHexString());
    ##data#1_0_1 := s#0;
    assume $IsAlloc(##data#1_0_1, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(s#0);
    ##val#1_0_0 := HexStrings.__default.FromHexString($LS($LZ), s#0);
    assume $IsAlloc(##val#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume HexStrings.__default.FromHexString#canCall(s#0) && HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume {:subsumption 0} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), HexStrings.__default.FromHexString($LS($LS($LZ)), s#0)), s#0);
    assume Seq#Equal(HexStrings.__default.ToHexString($LS($LZ), HexStrings.__default.FromHexString($LS($LZ), s#0)), s#0);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(147,47)"} true;
    return;

  anon6_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(2);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    assume true;
    x##1_1_0 := Seq#Take(s#0, LitInt(2));
    call CallPre$$HexStrings.__default.HexStrRoundTrip(x##1_1_0);
    call CallPost$$HexStrings.__default.HexStrRoundTrip(x##1_1_0);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(149,29)"} true;
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    assume $Is(Seq#Take(s#0, LitInt(2)), Tclass.HexStrings.LooseHexString());
    ##data#1_1_0 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##data#1_1_0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} 0 <= LitInt(2) && LitInt(2) <= Seq#Length(s#0);
    ##x#1_1_0 := Seq#Take(s#0, LitInt(2));
    assume $IsAlloc(##x#1_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##x#1_1_0) == LitInt(2);
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume {:subsumption 0} HexStrings.__default.IsLooseHexChar#canCall($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) ==> HexStrings.__default.IsLooseHexChar($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(102)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##x#1_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(70))));
    assume HexStrings.__default.HexValue#canCall(Seq#Take(s#0, LitInt(2)));
    assume HexStrings.__default.FromHexString#canCall(Seq#Take(s#0, LitInt(2))) && HexStrings.__default.HexValue#canCall(Seq#Take(s#0, LitInt(2)));
    assume {:subsumption 0} Seq#Equal(HexStrings.__default.FromHexString($LS($LS($LZ)), Seq#Take(s#0, LitInt(2))), Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexValue(Seq#Take(s#0, LitInt(2))))));
    assume Seq#Equal(HexStrings.__default.FromHexString($LS($LZ), Seq#Take(s#0, LitInt(2))), Seq#Build(Seq#Empty(): Seq, $Box(HexStrings.__default.HexValue(Seq#Take(s#0, LitInt(2))))));
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(150,56)"} true;
    assume $Is(s#0, Tclass.HexStrings.LooseHexString());
    ##data#1_1_1 := s#0;
    assume $IsAlloc(##data#1_1_1, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(s#0);
    ##val#1_1_0 := HexStrings.__default.FromHexString($LS($LZ), s#0);
    assume $IsAlloc(##val#1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume HexStrings.__default.FromHexString#canCall(s#0) && HexStrings.__default.ToHexString#canCall(HexStrings.__default.FromHexString($LS($LZ), s#0));
    assume {:subsumption 0} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), HexStrings.__default.FromHexString($LS($LS($LZ)), s#0)), s#0);
    assume Seq#Equal(HexStrings.__default.ToHexString($LS($LZ), HexStrings.__default.FromHexString($LS($LZ), s#0)), s#0);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(151,47)"} true;
    return;
}



procedure {:verboseName "HexStrings.FromHexStringRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.FromHexStringRoundTrip (well-formedness)"} CheckWellFormed$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##val#0: Seq;
  var ##data#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.FromHexStringRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(155,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(156,42): post-state"} true;
    ##val#0 := x#0;
    assume $IsAlloc(##val#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HexStrings.__default.ToHexString#canCall(x#0);
    assume $Is(HexStrings.__default.ToHexString($LS($LZ), x#0), Tclass.HexStrings.LooseHexString());
    ##data#0 := HexStrings.__default.ToHexString($LS($LZ), x#0);
    assume $IsAlloc(##data#0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(HexStrings.__default.ToHexString($LS($LZ), x#0));
    assume Seq#Equal(HexStrings.__default.FromHexString($LS($LZ), HexStrings.__default.ToHexString($LS($LZ), x#0)), x#0);
    return;
}



procedure {:verboseName "HexStrings.FromHexStringRoundTrip (call precondtion)"} CallPre$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "HexStrings.FromHexStringRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures HexStrings.__default.ToHexString#canCall(x#0) && HexStrings.__default.FromHexString#canCall(HexStrings.__default.ToHexString($LS($LZ), x#0));
  free ensures {:id "id16499"} Seq#Equal(HexStrings.__default.FromHexString($LS($LS($LZ)), HexStrings.__default.ToHexString($LS($LS($LZ)), x#0)), x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.FromHexStringRoundTrip (correctness)"} Impl$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq where $Is(x#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures HexStrings.__default.ToHexString#canCall(x#0) && HexStrings.__default.FromHexString#canCall(HexStrings.__default.ToHexString($LS($LZ), x#0));
  free ensures {:id "id16500"} Seq#Equal(HexStrings.__default.FromHexString($LS($LS($LZ)), HexStrings.__default.ToHexString($LS($LS($LZ)), x#0)), x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.FromHexStringRoundTrip (correctness)"} Impl$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.FromHexStringRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(157,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq :: $Is($ih#x0#0, TSeq(Tclass.BoundedInts.uint8())) && Lit(true) && Seq#Rank($ih#x0#0) < Seq#Rank(x#0) ==> Seq#Equal(HexStrings.__default.FromHexString($LS($LZ), HexStrings.__default.ToHexString($LS($LZ), $ih#x0#0)), $ih#x0#0));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "HexStrings.EmptyHexStrings (well-formedness)"} CheckWellFormed$$HexStrings.__default.EmptyHexStrings();
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.EmptyHexStrings (well-formedness)"} CheckWellFormed$$HexStrings.__default.EmptyHexStrings()
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##val#0: Seq;
  var ##data#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.EmptyHexStrings"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(159,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(160,28): post-state"} true;
    ##val#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##val#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume HexStrings.__default.ToHexString#canCall(Lit(Seq#Empty(): Seq));
    assume Seq#Equal(HexStrings.__default.ToHexString($LS($LZ), Lit(Seq#Empty(): Seq)), Seq#Empty(): Seq);
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.HexStrings.LooseHexString());
    ##data#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##data#0, Tclass.HexStrings.LooseHexString(), $Heap);
    assume HexStrings.__default.FromHexString#canCall(Lit(Seq#Empty(): Seq));
    assume Seq#Equal(HexStrings.__default.FromHexString($LS($LZ), Lit(Seq#Empty(): Seq)), Seq#Empty(): Seq);
    return;
}



procedure {:verboseName "HexStrings.EmptyHexStrings (call precondtion)"} CallPre$$HexStrings.__default.EmptyHexStrings();



procedure {:verboseName "HexStrings.EmptyHexStrings (call postcondition)"} CallPost$$HexStrings.__default.EmptyHexStrings();
  modifies $Heap;
  free ensures HexStrings.__default.ToHexString#canCall(Lit(Seq#Empty(): Seq));
  free ensures {:id "id16504"} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), Lit(Seq#Empty(): Seq)), Seq#Empty(): Seq);
  free ensures HexStrings.__default.FromHexString#canCall(Lit(Seq#Empty(): Seq));
  free ensures {:id "id16505"} Seq#Equal(HexStrings.__default.FromHexString($LS($LS($LZ)), Lit(Seq#Empty(): Seq)), Seq#Empty(): Seq);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "HexStrings.EmptyHexStrings (correctness)"} Impl$$HexStrings.__default.EmptyHexStrings() returns ($_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures HexStrings.__default.ToHexString#canCall(Lit(Seq#Empty(): Seq));
  free ensures {:id "id16506"} Seq#Equal(HexStrings.__default.ToHexString($LS($LS($LZ)), Lit(Seq#Empty(): Seq)), Seq#Empty(): Seq);
  free ensures HexStrings.__default.FromHexString#canCall(Lit(Seq#Empty(): Seq));
  free ensures {:id "id16507"} Seq#Equal(HexStrings.__default.FromHexString($LS($LS($LZ)), Lit(Seq#Empty(): Seq)), Seq#Empty(): Seq);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.EmptyHexStrings (correctness)"} Impl$$HexStrings.__default.EmptyHexStrings() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.EmptyHexStrings"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(162,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "HexStrings.HexString (well-formedness)"} CheckWellFormed$$HexStrings.HexString(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.HexString (well-formedness)"} CheckWellFormed$$HexStrings.HexString(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.HexString", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(58,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := x#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume HexStrings.__default.IsHexString#canCall(x#0);
    assume HexStrings.__default.IsHexString(x#0);
    return;

  anon4_Else:
    assume HexStrings.__default.IsHexString#canCall(Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} HexStrings.__default.IsHexString#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(HexStrings.__default.IsHexString(Lit(Seq#Empty(): Seq))) || (forall ch#0: char :: { HexStrings.__default.IsHexChar(ch#0) } { Seq#Contains(Seq#Empty(): Seq, $Box(ch#0)) } $Is(ch#0, TChar) && Seq#Contains(Seq#Empty(): Seq, $Box(ch#0)) ==> HexStrings.__default.IsHexChar(ch#0));
    return;
}



axiom (forall x#0: Seq :: { $Is(x#0, Tclass.HexStrings.HexString()) } $Is(x#0, Tclass.HexStrings.HexString()) <==> $Is(x#0, TSeq(TChar)) && HexStrings.__default.IsHexString(x#0));

axiom (forall x#0: Seq, $h: Heap :: { $IsAlloc(x#0, Tclass.HexStrings.HexString(), $h) } $IsAlloc(x#0, Tclass.HexStrings.HexString(), $h) <==> $IsAlloc(x#0, TSeq(TChar), $h));

procedure {:verboseName "HexStrings.LooseHexString (well-formedness)"} CheckWellFormed$$HexStrings.LooseHexString(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "HexStrings.LooseHexString (well-formedness)"} CheckWellFormed$$HexStrings.LooseHexString(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "HexStrings.LooseHexString", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/HexStrings.dfy(59,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := x#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume HexStrings.__default.IsLooseHexString#canCall(x#0);
    assume HexStrings.__default.IsLooseHexString(x#0);
    return;

  anon4_Else:
    assume HexStrings.__default.IsLooseHexString#canCall(Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} HexStrings.__default.IsLooseHexString#canCall(Lit(Seq#Empty(): Seq)) ==> Lit(HexStrings.__default.IsLooseHexString(Lit(Seq#Empty(): Seq))) || (forall ch#0: char :: { HexStrings.__default.IsLooseHexChar(ch#0) } { Seq#Contains(Seq#Empty(): Seq, $Box(ch#0)) } $Is(ch#0, TChar) && Seq#Contains(Seq#Empty(): Seq, $Box(ch#0)) ==> HexStrings.__default.IsLooseHexChar(ch#0));
    return;
}



axiom (forall x#0: Seq :: { $Is(x#0, Tclass.HexStrings.LooseHexString()) } $Is(x#0, Tclass.HexStrings.LooseHexString()) <==> $Is(x#0, TSeq(TChar)) && HexStrings.__default.IsLooseHexString(x#0));

axiom (forall x#0: Seq, $h: Heap :: { $IsAlloc(x#0, Tclass.HexStrings.LooseHexString(), $h) } $IsAlloc(x#0, Tclass.HexStrings.LooseHexString(), $h) <==> $IsAlloc(x#0, TSeq(TChar), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#104 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#104))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#106 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#106)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#156 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#156))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#158 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#158)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#160 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#160)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#156 := Wrappers.Option.value(this); v#156)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#158 := Lit(Wrappers.Option.value(Lit(this))); v#158)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#160 := Lit(Wrappers.Option.value(Lit(this))); v#160)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#104 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#104)) else (var e#104 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#106 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#106))) else (var e#106 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#156 := Wrappers.Result.value(this); s#156) else (var e#156 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#158 := Lit(Wrappers.Result.value(Lit(this))); s#158) else (var e#158 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#160 := Lit(Wrappers.Result.value(Lit(this))); s#160) else (var e#160 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#156 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#156)) else (var e#156 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#156)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#158 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#158))) else (var e#158 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#158)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#160 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#160))) else (var e#160 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#160)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#36 := Div(x#0, LitInt(256)); (var b1#36 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#36)), $Box(b1#36)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#37 := LitInt(Div(x#0, LitInt(256))); (var b1#37 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#37)), $Box(b1#37))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#36 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#36 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#37 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#37 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#36 := Div(x#0, LitInt(16777216)); (var x0#36 := x#0 - Mul(b0#36, LitInt(16777216)); (var b1#36 := Div(x0#36, LitInt(65536)); (var x1#36 := x0#36 - Mul(b1#36, LitInt(65536)); (var b2#36 := Div(x1#36, LitInt(256)); (var b3#36 := Mod(x1#36, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#36)), $Box(b1#36)), $Box(b2#36)), $Box(b3#36)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#37 := LitInt(Div(x#0, LitInt(16777216))); (var x0#37 := LitInt(x#0 - Mul(b0#37, LitInt(16777216))); (var b1#37 := LitInt(Div(x0#37, LitInt(65536))); (var x1#37 := LitInt(x0#37 - Mul(b1#37, LitInt(65536))); (var b2#37 := LitInt(Div(x1#37, LitInt(256))); (var b3#37 := LitInt(Mod(x1#37, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#37)), $Box(b1#37)), $Box(b2#37)), $Box(b3#37))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#36 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#36 := x0#36 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#36 := x1#36 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#36 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#37 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#37 := x0#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#37 := x1#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#37 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#36 := Div(x#0, LitInt(72057594037927936)); (var x0#36 := x#0 - Mul(b0#36, LitInt(72057594037927936)); (var b1#36 := Div(x0#36, LitInt(281474976710656)); (var x1#36 := x0#36 - Mul(b1#36, LitInt(281474976710656)); (var b2#36 := Div(x1#36, LitInt(1099511627776)); (var x2#36 := x1#36 - Mul(b2#36, LitInt(1099511627776)); (var b3#36 := Div(x2#36, LitInt(4294967296)); (var x3#36 := x2#36 - Mul(b3#36, LitInt(4294967296)); (var b4#36 := Div(x3#36, LitInt(16777216)); (var x4#36 := x3#36 - Mul(b4#36, LitInt(16777216)); (var b5#36 := Div(x4#36, LitInt(65536)); (var x5#36 := x4#36 - Mul(b5#36, LitInt(65536)); (var b6#36 := Div(x5#36, LitInt(256)); (var b7#36 := Mod(x5#36, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#36)), $Box(b1#36)), $Box(b2#36)), $Box(b3#36)), $Box(b4#36)), $Box(b5#36)), $Box(b6#36)), $Box(b7#36)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#37 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#37 := LitInt(x#0 - Mul(b0#37, LitInt(72057594037927936))); (var b1#37 := LitInt(Div(x0#37, LitInt(281474976710656))); (var x1#37 := LitInt(x0#37 - Mul(b1#37, LitInt(281474976710656))); (var b2#37 := LitInt(Div(x1#37, LitInt(1099511627776))); (var x2#37 := LitInt(x1#37 - Mul(b2#37, LitInt(1099511627776))); (var b3#37 := LitInt(Div(x2#37, LitInt(4294967296))); (var x3#37 := LitInt(x2#37 - Mul(b3#37, LitInt(4294967296))); (var b4#37 := LitInt(Div(x3#37, LitInt(16777216))); (var x4#37 := LitInt(x3#37 - Mul(b4#37, LitInt(16777216))); (var b5#37 := LitInt(Div(x4#37, LitInt(65536))); (var x5#37 := LitInt(x4#37 - Mul(b5#37, LitInt(65536))); (var b6#37 := LitInt(Div(x5#37, LitInt(256))); (var b7#37 := LitInt(Mod(x5#37, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#37)), $Box(b1#37)), $Box(b2#37)), $Box(b3#37)), $Box(b4#37)), $Box(b5#37)), $Box(b6#37)), $Box(b7#37))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#36 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#36 := x0#36 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#36 := x1#36 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#36 := x2#36 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#36 := x3#36 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#36 := x4#36 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#36 := x5#36 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#37 := x6#36 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#37)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#37 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#37 := x0#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#37 := x1#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#37 := x2#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#37 := x3#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#37 := x4#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#37 := x5#37 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#38 := x6#37 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#38)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#36 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#36)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#36 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#36)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#36)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#37 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#37)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#37 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#37)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#37)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#26: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#26)): Seq } LitInt(0) <= i#26 && i#26 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#26)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#27 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#27) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#27)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#27 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#27) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#27)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#27)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#28 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#28) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#28)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#28 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#28) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#28)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#28)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#29 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#29) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#29)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#29 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#29) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#29)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#29)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#18 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#18)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#18)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#19 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#19)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#19)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#20 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#20)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#20)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#18 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#18) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#18) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#18)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#18) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#18))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#18 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#18) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#18) else (var i#18 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#18)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#18)), $Box(Seq#Drop(s#0, i#18 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#19 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#19) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#19) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#19)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#19) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#19))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#19 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#19) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#19) else (var i#19 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#19)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#19)), $Box(Seq#Drop(Lit(s#0), i#19 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#20 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#20) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#20) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#20)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#20) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#20))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#20 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#20) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#20) else (var i#20 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#20)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#20))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#20 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#x#0: Box :: $Box($l#63#x#0 == c#0)), (lambda $l#63#heap#0: Heap, $l#63#x#0: Box :: $IsBox($l#63#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#63#heap#0: Heap, $l#63#x#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#x#0: Box :: $Box($l#61#x#0 == c#0)), (lambda $l#61#heap#0: Heap, $l#61#x#0: Box :: $IsBox($l#61#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#61#heap#0: Heap, $l#61#x#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#x#0: Box :: $Box($l#66#x#0 == c#0)), (lambda $l#66#heap#0: Heap, $l#66#x#0: Box :: $IsBox($l#66#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#66#heap#0: Heap, $l#66#x#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#x#0: Box :: $Box($l#64#x#0 == c#0)), (lambda $l#64#heap#0: Heap, $l#64#x#0: Box :: $IsBox($l#64#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#64#heap#0: Heap, $l#64#x#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#x#0: Box :: $Box($l#69#x#0 == Lit(c#0))), (lambda $l#69#heap#0: Heap, $l#69#x#0: Box :: $IsBox($l#69#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#69#heap#0: Heap, $l#69#x#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#x#0: Box :: $Box($l#67#x#0 == Lit(c#0))), (lambda $l#67#heap#0: Heap, $l#67#x#0: Box :: $IsBox($l#67#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#67#heap#0: Heap, $l#67#x#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#16: int :: { Seq#Index(s#0, j#16) } i#0 <= j#16 && j#16 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#16))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#17: int :: { Seq#Index(s#0, j#17) } i#0 <= j#17 && j#17 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#17))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#16: int :: { Seq#Index(s#0, i#16) } LitInt(0) <= i#16 && i#16 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#16))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#16))) && (forall i#17: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#17) } (LitInt(0) <= i#17 && i#17 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#17))) && (LitInt(0) <= i#17 && i#17 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#17))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#8: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#8) } LitInt(0) <= i#8 && i#8 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#8) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#_v0#0: Box :: value#0), (lambda $l#40#heap#0: Heap, $l#40#_v0#0: Box :: $IsBox($l#40#_v0#0, TInt)), (lambda $l#40#heap#0: Heap, $l#40#_v0#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#_v0#0: Box :: value#0), (lambda $l#42#heap#0: Heap, $l#42#_v0#0: Box :: $IsBox($l#42#_v0#0, TInt)), (lambda $l#42#heap#0: Heap, $l#42#_v0#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#_v0#0: Box :: Lit(value#0)), (lambda $l#44#heap#0: Heap, $l#44#_v0#0: Box :: $IsBox($l#44#_v0#0, TInt)), (lambda $l#44#heap#0: Heap, $l#44#_v0#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#20: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#20) } LitInt(0) <= k#20 ==> k#20 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#20)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#20: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#20) } LitInt(0) <= k#20 && k#20 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#20))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#21: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#21) } LitInt(0) <= k#21 ==> k#21 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#21)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#21: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#21) } LitInt(0) <= k#21 && k#21 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#21))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#22: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#22) } LitInt(0) <= k#22 ==> k#22 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#22)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#22: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#22) } LitInt(0) <= k#22 && k#22 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#22))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#20: int :: { Seq#Index(b#0, i#20) } { Seq#Index(a#0, i#20) } LitInt(0) <= i#20 && i#20 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#20) == Seq#Index(b#0, i#20)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#21: int :: { Seq#Index(b#0, i#21) } { Seq#Index(a#0, i#21) } LitInt(0) <= i#21 && i#21 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#21) == Seq#Index(Lit(b#0), i#21)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#22: int :: { Seq#Index(b#0, i#22) } { Seq#Index(a#0, i#22) } LitInt(0) <= i#22 && i#22 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#22) == Seq#Index(Lit(b#0), i#22)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#42: Box, y#42: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#42, x#42)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#42, y#42)): bool } $IsBox(x#42, StandardLibrary._default.Trichotomous$T) && $IsBox(y#42, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#42, y#42)): bool || x#42 == y#42 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#42, x#42)): bool) && (forall x#43: Box, y#43: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#43, x#43)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#43, y#43)): bool } $IsBox(x#43, StandardLibrary._default.Trichotomous$T) && $IsBox(y#43, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#43, y#43)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#43, x#43)): bool ==> false) && (forall x#44: Box, y#44: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#44, y#44)): bool } $IsBox(x#44, StandardLibrary._default.Trichotomous$T) && $IsBox(y#44, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#44, y#44)): bool ==> x#44 != y#44)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#45: Box, y#45: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#45, x#45)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#45, y#45)): bool } $IsBox(x#45, StandardLibrary._default.Trichotomous$T) && $IsBox(y#45, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#45, y#45)): bool || x#45 == y#45 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#45, x#45)): bool) && (forall x#46: Box, y#46: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#46, x#46)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#46, y#46)): bool } $IsBox(x#46, StandardLibrary._default.Trichotomous$T) && $IsBox(y#46, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#46, y#46)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#46, x#46)): bool ==> false) && (forall x#47: Box, y#47: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#47, y#47)): bool } $IsBox(x#47, StandardLibrary._default.Trichotomous$T) && $IsBox(y#47, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#47, y#47)): bool ==> x#47 != y#47)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#14: Box, y#14: Box, z#14: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#14, z#14)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#14, z#14)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#14, z#14)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#14, y#14)): bool } $IsBox(x#14, StandardLibrary._default.Transitive$T) && $IsBox(y#14, StandardLibrary._default.Transitive$T) && $IsBox(z#14, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#14, y#14)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#14, z#14)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#14, z#14)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#15: Box, y#15: Box, z#15: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#15, z#15)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#15, z#15)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#15, z#15)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#15, y#15)): bool } $IsBox(x#15, StandardLibrary._default.Transitive$T) && $IsBox(y#15, StandardLibrary._default.Transitive$T) && $IsBox(z#15, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#15, y#15)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#15, z#15)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#15, z#15)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#24: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#24)): Seq } LitInt(0) <= i#24 && i#24 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#24)]) && (forall k#8: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#8)) } { s#0[$Box(k#8)] } $Is(k#8, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#8)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#8))) && (forall i#25: int, _t#0#7: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#25)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#7)): Seq } _t#0#7 == i#25 - 1 ==> 0 < i#25 && i#25 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#7)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#25)): Seq, less#0)) && (forall i#26: int, j#8: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#8)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#26)): Seq } LitInt(0) <= i#26 && i#26 < j#8 && j#8 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#26)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#8)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#23 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#23)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#23))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#24 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#24)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#24))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#25 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#25)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#25))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#20: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#20, less#0) } { s#0[$Box(z#20)] } $Is(z#20, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#20)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#20, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#20: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#20, less#0) } { s#0[$Box(z#20)] } $Is(z#20, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#20)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#20, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#21: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#21, less#0) } { s#0[$Box(z#21)] } $Is(z#21, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#21)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#21, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#21: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#21, less#0) } { s#0[$Box(z#21)] } $Is(z#21, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#21)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#21, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#22: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#22, less#0) } { s#0[$Box(z#22)] } $Is(z#22, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#22)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#22, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#22: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#22, less#0) } { s#0[$Box(z#22)] } $Is(z#22, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#22)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#22, Lit(less#0)))));

const unique tytagFamily$HexString: TyTagFamily;

const unique tytagFamily$LooseHexString: TyTagFamily;

const reveal_GetOpt._default.Filter: bool;

const reveal_GetOpt._default.IndexOf: bool;

const unique class.GetOpt.__default: ClassName;

procedure {:verboseName "GetOpt.Example (well-formedness)"} CheckWellFormed$$GetOpt.__default.Example(args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))) && $IsAlloc(args#0, TSeq(TSeq(TChar)), $Heap)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, TSeq(TChar))) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, TSeq(TChar)), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GetOpt.Example (call precondtion)"} CallPre$$GetOpt.__default.Example(args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))) && $IsAlloc(args#0, TSeq(TSeq(TChar)), $Heap));
  requires {:id "id16518"} 0 < Seq#Length(args#0);



procedure {:verboseName "GetOpt.Example (call postcondition)"} CallPost$$GetOpt.__default.Example(args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))) && $IsAlloc(args#0, TSeq(TSeq(TChar)), $Heap)) returns (output#0: DatatypeType where $Is(output#0, Tclass.Wrappers.Result(TBool, TSeq(TChar))) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "GetOpt.Example (correctness)"} Impl$$GetOpt.__default.Example(args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))) && $IsAlloc(args#0, TSeq(TSeq(TChar)), $Heap)) returns (defass#output#0: bool, output#0: DatatypeType where defass#output#0 ==> $Is(output#0, Tclass.Wrappers.Result(TBool, TSeq(TChar))) && $IsAlloc(output#0, Tclass.Wrappers.Result(TBool, TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  requires {:id "id16519"} 0 < Seq#Length(args#0);
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.GetOpt.Param() : Ty
uses {
axiom Tag(Tclass.GetOpt.Param()) == Tagclass.GetOpt.Param && TagFamily(Tclass.GetOpt.Param()) == tytagFamily$Param;
}

const unique Tagclass.GetOpt.Param: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Param()) } $IsBox(bx, Tclass.GetOpt.Param()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Param()));

function GetOpt.__default.NullChar() : char
uses {
axiom GetOpt.__default.NullChar(): char == char#FromInt(LitInt(0));
axiom 0 < $FunctionContextHeight ==> $Is(GetOpt.__default.NullChar(), TChar);
}

function Tclass.GetOpt.Options() : Ty
uses {
axiom Tag(Tclass.GetOpt.Options()) == Tagclass.GetOpt.Options && TagFamily(Tclass.GetOpt.Options()) == tytagFamily$Options;
}

const unique Tagclass.GetOpt.Options: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Options()) } $IsBox(bx, Tclass.GetOpt.Options()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Options()));

function Tclass.GetOpt.Parsed() : Ty
uses {
axiom Tag(Tclass.GetOpt.Parsed()) == Tagclass.GetOpt.Parsed && TagFamily(Tclass.GetOpt.Parsed()) == tytagFamily$Parsed;
}

const unique Tagclass.GetOpt.Parsed: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Parsed()) } $IsBox(bx, Tclass.GetOpt.Parsed()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Parsed()));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Example (correctness)"} Impl$$GetOpt.__default.Example(args#0: Seq) returns (defass#output#0: bool, output#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var MyOptions#0: Seq where $Is(MyOptions#0, TSeq(Tclass.GetOpt.Param())) && $IsAlloc(MyOptions#0, TSeq(Tclass.GetOpt.Param()), $Heap);
  var opts#0: DatatypeType where $Is(opts#0, Tclass.GetOpt.Options()) && $IsAlloc(opts#0, Tclass.GetOpt.Options(), $Heap);
  var x#0: DatatypeType where $Is(x#0, Tclass.GetOpt.Parsed()) && $IsAlloc(x#0, Tclass.GetOpt.Parsed(), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
  var ##opts#0: DatatypeType;
  var ##args#0: Seq;
  var h#0: DatatypeType where $Is(h#0, Tclass.Wrappers.Option(TSeq(TChar))) && $IsAlloc(h#0, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
  var ##opts#1: DatatypeType;
  var ##args#1: DatatypeType;
  var ##prefix#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Example", " | ", args#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(115,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    MyOptions#0 := Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.Param.Flag(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(111)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(115)))), GetOpt.__default.NullChar(), Lit(false), Lit(false), Lit(#GetOpt.Visibility.Normal()), Lit(Seq#Empty(): Seq), Lit(Seq#Empty(): Seq)))), $Box(Lit(#GetOpt.Param.Opt(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(119))), $Box(char#FromInt(111)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(121)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(121)))), Lit(char#FromInt(116)), Lit(#GetOpt.Unused.UnusedOk()), Lit(false), Lit(#GetOpt.Visibility.Normal()), Lit(Seq#Empty(): Seq), Lit(Seq#Empty(): Seq), Lit(#GetOpt.Tri.No()))))), $Box(#GetOpt.Param.Command(#GetOpt.Options.Options(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(117))), $Box(char#FromInt(102))), $Box(char#FromInt(102)))), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(#GetOpt.Param.Opt(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(119))), $Box(char#FromInt(111)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(121)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(121)))), Lit(char#FromInt(116)), Lit(#GetOpt.Unused.UnusedOk()), Lit(false), Lit(#GetOpt.Visibility.Normal()), Lit(Seq#Empty(): Seq), Lit(Seq#Empty(): Seq), Lit(#GetOpt.Tri.No()))))), $Box(#GetOpt.Param.Flag(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(111)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(115)))), GetOpt.__default.NullChar(), Lit(false), Lit(false), Lit(#GetOpt.Visibility.Normal()), Lit(Seq#Empty(): Seq), Lit(Seq#Empty(): Seq))))))));
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(123,5)"} true;
    assume true;
    assume true;
    opts#0 := #GetOpt.Options.Options(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(109))), $Box(char#FromInt(121))), $Box(char#FromInt(80))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(103)))), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(117))), $Box(char#FromInt(102))), $Box(char#FromInt(102)))), MyOptions#0);
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(125,63)"} true;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap) */;
    assume true;
    ##opts#0 := opts#0;
    assume $IsAlloc(##opts#0, Tclass.GetOpt.Options(), $Heap);
    ##args#0 := args#0;
    assume $IsAlloc(##args#0, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} 0 < Seq#Length(##args#0);
    assume 0 < Seq#Length(##args#0);
    assume GetOpt.__default.GetOptions#canCall(opts#0, args#0);
    assume GetOpt.__default.GetOptions#canCall(opts#0, args#0);
    valueOrError0#0 := GetOpt.__default.GetOptions(opts#0, args#0);
    defass#valueOrError0#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(126,35)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), TBool, valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), TBool, valueOrError0#0);
    output#0 := Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), TBool, valueOrError0#0);
    defass#output#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(126,35)"} true;
    assume defass#output#0;
    pop;
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0);
    assume GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0)): DatatypeType);
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0);
    x#0 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError0#0)): DatatypeType;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(126,35)"} true;
    assume true;
    ##opts#1 := opts#0;
    assume $IsAlloc(##opts#1, Tclass.GetOpt.Options(), $Heap);
    ##args#1 := x#0;
    assume $IsAlloc(##args#1, Tclass.GetOpt.Parsed(), $Heap);
    ##prefix#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##prefix#0, TSeq(TChar), $Heap);
    assume GetOpt.__default.NeedsHelp#canCall(opts#0, x#0, Lit(Seq#Empty(): Seq));
    assume GetOpt.__default.NeedsHelp#canCall(opts#0, x#0, Lit(Seq#Empty(): Seq));
    h#0 := GetOpt.__default.NeedsHelp($LS($LZ), opts#0, x#0, Lit(Seq#Empty(): Seq));
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(127,31)"} true;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Option.Some_q(h#0);
    push;
    assume Wrappers.Option.Some_q(h#0);
    assume true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(129,19)"} true;
    assume true;
    assume true;
    output#0 := Lit(#Wrappers.Result.Success($Box(Lit(true))));
    defass#output#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(130,26)"} true;
    assume defass#output#0;
    pop;
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Option.Some_q(h#0);
    assume true;
    assume true;
    output#0 := Lit(#Wrappers.Result.Success($Box(Lit(true))));
    defass#output#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(135,24)"} true;
    assume defass#output#0;
    return;
}



function GetOpt.__default.Filter(GetOpt._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $heap: Heap, f#0: HandleType, xs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(GetOpt._default.Filter$T)) && $IsAlloc(xs#0, TSeq(GetOpt._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#2: int :: { Seq#Index(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#2) } LitInt(0) <= i#2 ==> i#2 < Seq#Length(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#2)) ==> $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#2))): bool) && $Is(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(GetOpt._default.Filter$T)));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { $IsAlloc(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(GetOpt._default.Filter$T), $Heap) } GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(GetOpt._default.Filter$T)) && $IsAlloc(xs#0, TSeq(GetOpt._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> $IsAlloc(GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(GetOpt._default.Filter$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $Heap, f#0, xs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool)) && $Is(xs#0, TSeq(GetOpt._default.Filter$T)) && (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#3)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, reveal_GetOpt._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));
}

function GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T: Ty, $heap: Heap, f#0: HandleType, xs#0: Seq) : bool;

axiom (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($ly), $reveal, $Heap, f#0, xs#0) } GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($ly), $reveal, $Heap, f#0, xs#0) == GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0));

axiom (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { GetOpt.__default.Filter(GetOpt._default.Filter$T, AsFuelBottom($ly), $reveal, $Heap, f#0, xs#0) } GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) == GetOpt.__default.Filter(GetOpt._default.Filter$T, $LZ, $reveal, $Heap, f#0, xs#0));

axiom (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $h0: Heap, $h1: Heap, f#0: HandleType, xs#0: Seq :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $h1, f#0, xs#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && (GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $h0, f#0, xs#0) || ($Is(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool)) && $Is(xs#0, TSeq(GetOpt._default.Filter$T)))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && (exists i#0: int, o#0: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $h0, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $h0, f#0, xs#0) == GetOpt.__default.Filter(GetOpt._default.Filter$T, $ly, $reveal, $h1, f#0, xs#0));

function GetOpt.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq) : bool;

axiom (forall GetOpt._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { GetOpt.__default.Filter#requires(GetOpt._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool)) && $Is(xs#0, TSeq(GetOpt._default.Filter$T)) ==> (GetOpt.__default.Filter#requires(GetOpt._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#3: int :: { Seq#Index(xs#0, i#3) } LitInt(0) <= i#3 && i#3 < Seq#Length(xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#3)))));

procedure {:verboseName "GetOpt.Filter (well-formedness)"} CheckWellformed$$GetOpt.__default.Filter(GetOpt._default.Filter$T: Ty, f#0: HandleType where $Is(f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool)), xs#0: Seq where $Is(xs#0, TSeq(GetOpt._default.Filter$T))) returns (result#0: Seq where $Is(result#0, TSeq(GetOpt._default.Filter$T)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16539"} Seq#Length(result#0) <= Seq#Length(xs#0);
  free ensures {:id "id16540"} (forall i#4: int :: { Seq#Index(result#0, i#4) } LitInt(0) <= i#4 ==> i#4 < Seq#Length(result#0) && Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4)) ==> $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4))): bool);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Filter (well-formedness)"} CheckWellformed$$GetOpt.__default.Filter(GetOpt._default.Filter$T: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#5: int;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var i#6: int;
  var o#1: ref;
  var ##x0#1: Box;
  var b$reqreads#1: bool;
  var i#7: int;
  var o#2: ref;
  var ##x0#2: Box;
  var i#8: int;
  var ##x0#3: Box;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Filter", " | ", GetOpt._default.Filter$T, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(140,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> (exists i#0: int, o#0: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#0))[$Box(o#0)] && $Box($o) == $Box(o#0)));
    havoc i#5;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= i#5;
    goto anon4;

  anon33_Else:
    assume {:partition} i#5 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap);
    assume 0 <= i#5 && i#5 < Seq#Length(xs#0);
    ##x0#0 := Seq#Index(xs#0, i#5);
    assume $IsAllocBox(##x0#0, GetOpt._default.Filter$T, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#5));
    assume Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon6;

  anon32_Else:
    assume LitInt(0) <= i#5 && i#5 < Seq#Length(xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#5));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)));
    assume b$reqreads#0;
    havoc i#6;
    havoc o#1;
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} $Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap);
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} LitInt(0) <= i#6;
    goto anon9;

  anon35_Else:
    assume {:partition} i#6 < LitInt(0);
    goto anon9;

  anon9:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap);
    assume 0 <= i#6 && i#6 < Seq#Length(xs#0);
    ##x0#1 := Seq#Index(xs#0, i#6);
    assume $IsAllocBox(##x0#1, GetOpt._default.Filter$T, $Heap);
    assume Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Reads1#canCall(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6));
    goto anon11;

  anon36_Else:
    assume {:partition} !(LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0));
    goto anon11;

  anon11:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6))[$Box(o#1)];
    goto anon13;

  anon37_Else:
    assume {:partition} !(LitInt(0) <= i#6 && i#6 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#6))[$Box(o#1)]);
    goto anon13;

  anon34_Else:
    assume {:partition} !($Is(o#1, Tclass._System.object?()) && $IsAlloc(o#1, Tclass._System.object?(), $Heap));
    goto anon13;

  anon13:
    assume b$reqreads#1;
    havoc i#7;
    havoc o#2;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} LitInt(0) <= i#7;
    goto anon16;

  anon39_Else:
    assume {:partition} i#7 < LitInt(0);
    goto anon16;

  anon16:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap);
    assume 0 <= i#7 && i#7 < Seq#Length(xs#0);
    ##x0#2 := Seq#Index(xs#0, i#7);
    assume $IsAllocBox(##x0#2, GetOpt._default.Filter$T, $Heap);
    assume Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7));
    assume Reads1#canCall(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7));
    goto anon18;

  anon40_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0));
    goto anon18;

  anon18:
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)];
    goto anon20;

  anon41_Else:
    assume {:partition} !(LitInt(0) <= i#7 && i#7 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#7))[$Box(o#2)]);
    goto anon20;

  anon38_Else:
    assume {:partition} !($Is(o#2, Tclass._System.object?()) && $IsAlloc(o#2, Tclass._System.object?(), $Heap));
    goto anon20;

  anon20:
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume $Is(GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, xs#0), TSeq(GetOpt._default.Filter$T));
    assume Seq#Length(result#0) <= Seq#Length(xs#0);
    havoc i#8;
    assume LitInt(0) <= i#8;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume i#8 < Seq#Length(result#0);
    assume $IsAllocBox($Box(f#0), Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap);
    assume 0 <= i#8 && i#8 < Seq#Length(result#0);
    ##x0#3 := Seq#Index(result#0, i#8);
    assume $IsAllocBox(##x0#3, GetOpt._default.Filter$T, $Heap);
    assume Requires1#canCall(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8));
    assume Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8));
    assume 0 <= i#8 && i#8 < Seq#Length(result#0);
    assume Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8));
    assume $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8))): bool;
    goto anon24;

  anon43_Else:
    assume i#8 < Seq#Length(result#0) && Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8)) ==> $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#8))): bool;
    goto anon24;

  anon24:
    assume (forall i#4: int :: { Seq#Index(result#0, i#4) } LitInt(0) <= i#4 ==> i#4 < Seq#Length(result#0) && Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4)) ==> $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(result#0, i#4))): bool);
    assume false;
    return;

  anon42_Else:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} Seq#Length(xs#0) == LitInt(0);
    assume GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, xs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, xs#0), TSeq(GetOpt._default.Filter$T));
    goto anon31;

  anon44_Else:
    assume {:partition} Seq#Length(xs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    assume Requires1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)));
    b$reqreads#2 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    goto anon30;

  anon45_Else:
    assume {:partition} !$Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool;
    goto anon30;

  anon30:
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##f#0 := f#0;
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(GetOpt._default.Filter$T, TBool), $Heap);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(GetOpt._default.Filter$T), $Heap);
    assume {:subsumption 0} (forall i#9: int :: { Seq#Index(##xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#9)));
    assume (forall i#9: int :: { Seq#Index(##xs#0, i#9) } LitInt(0) <= i#9 && i#9 < Seq#Length(##xs#0) ==> Requires1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#9)));
    b$reqreads#3 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#10: int, o#3: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#10))[$Box(o#3)] } $Is(o#3, Tclass._System.object?()) && LitInt(0) <= i#10 && i#10 < Seq#Length(##xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#10))[$Box(o#3)] && $Box($o) == $Box(o#3)) ==> $_ReadsFrame[$o, $f]);
    assume (Set#Subset((lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))), (lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5)))) && !Set#Subset((lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5))), (lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))))) || (Set#Equal((lambda $y#0: Box :: (exists i#11: int, o#4: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] } $Is(o#4, Tclass._System.object?()) && LitInt(0) <= i#11 && i#11 < Seq#Length(##xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#11))[$Box(o#4)] && $y#0 == $Box(o#4))), (lambda $y#1: Box :: (exists i#12: int, o#5: ref :: { Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] } $Is(o#5, Tclass._System.object?()) && LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) && Reads1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#12))[$Box(o#5)] && $y#1 == $Box(o#5)))) && Seq#Rank(##xs#0) < Seq#Rank(xs#0));
    assume GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, xs#0) == Seq#Append((if $Unbox(Apply1(GetOpt._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))));
    assume GetOpt.__default.Filter#canCall(GetOpt._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)));
    assume $Is(GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, xs#0), TSeq(GetOpt._default.Filter$T));
    goto anon31;

  anon31:
    assume GetOpt.__default.Filter(GetOpt._default.Filter$T, $LS($LZ), reveal_GetOpt._default.Filter, $Heap, f#0, xs#0) == result#0;
    assume b$reqreads#2;
    assume b$reqreads#3;
    return;
}



procedure {:verboseName "GetOpt.NullChar (well-formedness)"} CheckWellFormed$$GetOpt.__default.NullChar();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.NullChar (well-formedness)"} CheckWellFormed$$GetOpt.__default.NullChar()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.NullChar"} true;
    assume {:print "Types"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(153,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume char#IsChar(newtype$check#0);
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(GetOpt.__default.NullChar(), TChar, $h) } $IsGoodHeap($h) ==> $IsAlloc(GetOpt.__default.NullChar(), TChar, $h));

function GetOpt.__default.IsHelp(args#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall args#0: DatatypeType :: { GetOpt.__default.IsHelp(args#0) } GetOpt.__default.IsHelp#canCall(args#0) || (2 < $FunctionContextHeight && $Is(args#0, Tclass.GetOpt.Parsed())) ==> GetOpt.Parsed.Parsed_q(args#0) && (Seq#Length(GetOpt.Parsed.params(args#0)) != 0 ==> GetOpt.Parsed.Parsed_q(args#0) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(GetOpt.Parsed.params(args#0), LitInt(0))): DatatypeType)) && (GetOpt.__default.IsHelp(args#0) <==> Seq#Length(GetOpt.Parsed.params(args#0)) != 0 && Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(GetOpt.Parsed.params(args#0), LitInt(0))): DatatypeType), GetOpt.__default.HELP__STR())));
axiom 2 <= $FunctionContextHeight ==> (forall args#0: DatatypeType :: {:weight 3} { GetOpt.__default.IsHelp(Lit(args#0)) } GetOpt.__default.IsHelp#canCall(Lit(args#0)) || (2 < $FunctionContextHeight && $Is(args#0, Tclass.GetOpt.Parsed())) ==> GetOpt.Parsed.Parsed_q(Lit(args#0)) && (Seq#Length(Lit(GetOpt.Parsed.params(Lit(args#0)))) != 0 ==> GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(GetOpt.Parsed.params(Lit(args#0))), LitInt(0))): DatatypeType)) && (GetOpt.__default.IsHelp(Lit(args#0)) <==> Seq#Length(Lit(GetOpt.Parsed.params(Lit(args#0)))) != 0 && Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(GetOpt.Parsed.params(Lit(args#0))), LitInt(0))): DatatypeType), GetOpt.__default.HELP__STR())));
}

function GetOpt.__default.IsHelp#canCall(args#0: DatatypeType) : bool;

function GetOpt.__default.IsHelp#requires(DatatypeType) : bool;

axiom (forall args#0: DatatypeType :: { GetOpt.__default.IsHelp#requires(args#0) } $Is(args#0, Tclass.GetOpt.Parsed()) ==> (GetOpt.__default.IsHelp#requires(args#0) <==> true));

function GetOpt.__default.HELP__STR() : Seq
uses {
axiom GetOpt.__default.HELP__STR(): Seq == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(112))));
axiom 0 < $FunctionContextHeight ==> $Is(GetOpt.__default.HELP__STR(), TSeq(TChar));
}

procedure {:verboseName "GetOpt.IsHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.IsHelp(args#0: DatatypeType where $Is(args#0, Tclass.GetOpt.Parsed()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.IsHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.IsHelp(args#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.IsHelp", " | ", args#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(244,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    assume GetOpt.Parsed.Parsed_q(args#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(GetOpt.Parsed.params(args#0)) != 0;
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(GetOpt.Parsed.params(args#0));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(GetOpt.Parsed.params(args#0), LitInt(0))): DatatypeType);
    goto anon5;

  anon7_Else:
    assume {:partition} Seq#Length(GetOpt.Parsed.params(args#0)) == 0;
    goto anon5;

  anon5:
    assume GetOpt.__default.IsHelp(args#0) <==> Seq#Length(GetOpt.Parsed.params(args#0)) != 0 && Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(GetOpt.Parsed.params(args#0), LitInt(0))): DatatypeType), GetOpt.__default.HELP__STR());
    assume GetOpt.Parsed.Parsed_q(args#0) && (Seq#Length(GetOpt.Parsed.params(args#0)) != 0 ==> GetOpt.Parsed.Parsed_q(args#0) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(GetOpt.Parsed.params(args#0), LitInt(0))): DatatypeType));
    assume $Is(GetOpt.__default.IsHelp(args#0), TBool);
    return;
}



function GetOpt.__default.NeedsHelp($ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq) : DatatypeType
uses {
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.NeedsHelp($ly, opts#0, args#0, prefix#0) } GetOpt.__default.NeedsHelp#canCall(opts#0, args#0, prefix#0) || (6 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed()) && $Is(prefix#0, TSeq(TChar))) ==> $Is(GetOpt.__default.NeedsHelp($ly, opts#0, args#0, prefix#0), Tclass.Wrappers.Option(TSeq(TChar))));
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.NeedsHelp($LS($ly), opts#0, args#0, prefix#0) } GetOpt.__default.NeedsHelp#canCall(opts#0, args#0, prefix#0) || (6 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed()) && $Is(prefix#0, TSeq(TChar))) ==> GetOpt.__default.IsHelp#canCall(args#0) && (GetOpt.__default.IsHelp(args#0) ==> GetOpt.__default.GetHelp#canCall(opts#0, prefix#0)) && (!GetOpt.__default.IsHelp(args#0) ==> GetOpt.Parsed.Parsed_q(args#0) && (Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0)) ==> GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType) && GetOpt.__default.GetSubOptions#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0)) && (var valueOrError0#0 := GetOpt.__default.GetSubOptions($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#0) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#0) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), TSeq(TChar), valueOrError0#0)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#0) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#0) && (var pos#0 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#0)): int; GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.__default.NeedsHelp#canCall(GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#0)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType, Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(args#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))))))))) && GetOpt.__default.NeedsHelp($LS($ly), opts#0, args#0, prefix#0) == (if GetOpt.__default.IsHelp(args#0) then #Wrappers.Option.Some($Box(GetOpt.__default.GetHelp(opts#0, prefix#0))) else (if Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0)) then (var valueOrError0#0 := GetOpt.__default.GetSubOptions($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#0) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), TSeq(TChar), valueOrError0#0) else (var pos#0 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#0)): int; GetOpt.__default.NeedsHelp($ly, GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#0)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType, Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(args#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))))))) else #Wrappers.Option.None())));
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq :: {:weight 3} { GetOpt.__default.NeedsHelp($LS($ly), Lit(opts#0), Lit(args#0), Lit(prefix#0)) } GetOpt.__default.NeedsHelp#canCall(Lit(opts#0), Lit(args#0), Lit(prefix#0)) || (6 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed()) && $Is(prefix#0, TSeq(TChar))) ==> GetOpt.__default.IsHelp#canCall(Lit(args#0)) && (Lit(GetOpt.__default.IsHelp(Lit(args#0))) ==> GetOpt.__default.GetHelp#canCall(Lit(opts#0), Lit(prefix#0))) && (!Lit(GetOpt.__default.IsHelp(Lit(args#0))) ==> GetOpt.Parsed.Parsed_q(Lit(args#0)) && (Lit(Wrappers.Option.Some_q(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))) ==> GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.Parsed.Parsed_q(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType)) && GetOpt.__default.GetSubOptions#canCall(Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.command(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType))), LitInt(0)) && (var valueOrError0#1 := Lit(GetOpt.__default.GetSubOptions($LS($LZ), Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.command(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType))), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#1) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#1) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), TSeq(TChar), valueOrError0#1)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#1) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#1) && (var pos#1 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#1)): int; GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.__default.NeedsHelp#canCall(GetOpt.Param.options($Unbox(Seq#Index(Lit(GetOpt.Options.params(Lit(opts#0))), pos#1)): DatatypeType), Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType), Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(Lit(args#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))))))))) && GetOpt.__default.NeedsHelp($LS($ly), Lit(opts#0), Lit(args#0), Lit(prefix#0)) == (if GetOpt.__default.IsHelp(Lit(args#0)) then #Wrappers.Option.Some($Box(Lit(GetOpt.__default.GetHelp(Lit(opts#0), Lit(prefix#0))))) else (if Wrappers.Option.Some_q(Lit(GetOpt.Parsed.subcommand(Lit(args#0)))) then (var valueOrError0#1 := Lit(GetOpt.__default.GetSubOptions($LS($LZ), Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.command(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType))), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#1) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), TSeq(TChar), valueOrError0#1) else (var pos#1 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#1)): int); GetOpt.__default.NeedsHelp($LS($ly), GetOpt.Param.options($Unbox(Seq#Index(Lit(GetOpt.Options.params(Lit(opts#0))), pos#1)): DatatypeType), Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType), Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(Lit(args#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))))))) else #Wrappers.Option.None())));
}

function GetOpt.__default.NeedsHelp#canCall(opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq) : bool;

axiom (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.NeedsHelp($LS($ly), opts#0, args#0, prefix#0) } GetOpt.__default.NeedsHelp($LS($ly), opts#0, args#0, prefix#0) == GetOpt.__default.NeedsHelp($ly, opts#0, args#0, prefix#0));

axiom (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.NeedsHelp(AsFuelBottom($ly), opts#0, args#0, prefix#0) } GetOpt.__default.NeedsHelp($ly, opts#0, args#0, prefix#0) == GetOpt.__default.NeedsHelp($LZ, opts#0, args#0, prefix#0));

function GetOpt.__default.NeedsHelp#requires(LayerType, DatatypeType, DatatypeType, Seq) : bool;

axiom (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.NeedsHelp#requires($ly, opts#0, args#0, prefix#0) } $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed()) && $Is(prefix#0, TSeq(TChar)) ==> (GetOpt.__default.NeedsHelp#requires($ly, opts#0, args#0, prefix#0) <==> true));

procedure {:verboseName "GetOpt.NeedsHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.NeedsHelp(opts#0: DatatypeType where $Is(opts#0, Tclass.GetOpt.Options()), args#0: DatatypeType where $Is(args#0, Tclass.GetOpt.Parsed()), prefix#0: Seq where $Is(prefix#0, TSeq(TChar)));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.NeedsHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.NeedsHelp(opts#0: DatatypeType, args#0: DatatypeType, prefix#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: DatatypeType;
  var ##opts#0: DatatypeType;
  var ##prefix#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##opts#1: Seq;
  var ##name#0: Seq;
  var ##pos#0: int;
  var pos#Z#0: int;
  var let#1#0#0: int;
  var ##opts#2: DatatypeType;
  var ##args#1: DatatypeType;
  var ##prefix#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.NeedsHelp", " | ", opts#0, " | ", args#0, " | ", prefix#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(250,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0), Tclass.Wrappers.Option(TSeq(TChar)));
    assume false;
    return;

  anon10_Else:
    ##args#0 := args#0;
    assume $IsAlloc(##args#0, Tclass.GetOpt.Parsed(), $Heap);
    assume GetOpt.__default.IsHelp#canCall(args#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} GetOpt.__default.IsHelp(args#0);
    ##opts#0 := opts#0;
    assume $IsAlloc(##opts#0, Tclass.GetOpt.Options(), $Heap);
    ##prefix#0 := prefix#0;
    assume $IsAlloc(##prefix#0, TSeq(TChar), $Heap);
    assume GetOpt.__default.GetHelp#canCall(opts#0, prefix#0);
    assume GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0) == #Wrappers.Option.Some($Box(GetOpt.__default.GetHelp(opts#0, prefix#0)));
    assume GetOpt.__default.GetHelp#canCall(opts#0, prefix#0);
    assume $Is(GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;

  anon11_Else:
    assume {:partition} !GetOpt.__default.IsHelp(args#0);
    assume GetOpt.Parsed.Parsed_q(args#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume GetOpt.Options.Options_q(opts#0);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    assume GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    ##opts#1 := GetOpt.Options.params(opts#0);
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##name#0 := GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    ##pos#0 := LitInt(0);
    assume $IsAlloc(##pos#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#0 <= Seq#Length(##opts#1);
    assume ##pos#0 <= Seq#Length(##opts#1);
    assume GetOpt.__default.GetSubOptions#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0));
    assume let#0#0#0 == GetOpt.__default.GetSubOptions($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0));
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType) && GetOpt.__default.GetSubOptions#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#Z#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume {:subsumption 0} Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.None_q(valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), TSeq(TChar), valueOrError0#Z#0);
    assume GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0) == Wrappers.Option.PropagateFailure(Tclass._System.nat(), TSeq(TChar), valueOrError0#Z#0);
    assume Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), TSeq(TChar), valueOrError0#Z#0);
    assume $Is(GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;

  anon13_Else:
    assume {:partition} !Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#Z#0);
    havoc pos#Z#0;
    assume LitInt(0) <= pos#Z#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume {:subsumption 0} Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Some_q(valueOrError0#Z#0);
    assume Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#Z#0)): int;
    assume Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass._System.nat());
    assume pos#Z#0 == let#1#0#0;
    assume GetOpt.Options.Options_q(opts#0);
    assume 0 <= pos#Z#0 && pos#Z#0 < Seq#Length(GetOpt.Options.params(opts#0));
    assume GetOpt.Param.Command_q($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#Z#0)): DatatypeType);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    assume GetOpt.Parsed.Parsed_q(args#0);
    ##opts#2 := GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#Z#0)): DatatypeType);
    assume $IsAlloc(##opts#2, Tclass.GetOpt.Options(), $Heap);
    ##args#1 := $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType;
    assume $IsAlloc(##args#1, Tclass.GetOpt.Parsed(), $Heap);
    ##prefix#1 := Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(args#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))));
    assume $IsAlloc(##prefix#1, TSeq(TChar), $Heap);
    assume DtRank(##opts#2) < DtRank(opts#0) || (DtRank(##opts#2) == DtRank(opts#0) && (DtRank(##args#1) < DtRank(args#0) || (DtRank(##args#1) == DtRank(args#0) && Seq#Rank(##prefix#1) < Seq#Rank(prefix#0))));
    assume GetOpt.__default.NeedsHelp#canCall(GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#Z#0)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType, Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(args#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))));
    assume GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0) == GetOpt.__default.NeedsHelp($LS($LZ), GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#Z#0)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType, Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(args#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))));
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.__default.NeedsHelp#canCall(GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), pos#Z#0)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType, Seq#Append(Seq#Append(prefix#0, GetOpt.Parsed.command(args#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32)))));
    assume $Is(GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;

  anon12_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    assume GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(GetOpt.__default.NeedsHelp($LS($LZ), opts#0, args#0, prefix#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;
}



procedure {:verboseName "GetOpt.HELP_STR (well-formedness)"} CheckWellFormed$$GetOpt.__default.HELP__STR();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(GetOpt.__default.HELP__STR(), TSeq(TChar), $h) } $IsGoodHeap($h) ==> $IsAlloc(GetOpt.__default.HELP__STR(), TSeq(TChar), $h));

function GetOpt.__default.HELP__PARAM() : DatatypeType
uses {
axiom GetOpt.__default.HELP__PARAM(): DatatypeType == #GetOpt.Param.Flag(GetOpt.__default.HELP__STR(), Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(84))), $Box(char#FromInt(104))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(112))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(120))), $Box(char#FromInt(116))), $Box(char#FromInt(46)))), GetOpt.__default.NullChar(), Lit(true), Lit(true), Lit(#GetOpt.Visibility.Normal()), Lit(Seq#Empty(): Seq), Lit(Seq#Empty(): Seq));
axiom 2 < $FunctionContextHeight ==> $Is(GetOpt.__default.HELP__PARAM(), Tclass.GetOpt.Param());
}

procedure {:verboseName "GetOpt.HELP_PARAM (well-formedness)"} CheckWellFormed$$GetOpt.__default.HELP__PARAM();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



axiom 2 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(GetOpt.__default.HELP__PARAM(), Tclass.GetOpt.Param(), $h) } $IsGoodHeap($h) ==> $IsAlloc(GetOpt.__default.HELP__PARAM(), Tclass.GetOpt.Param(), $h));

function GetOpt.__default.GetHelp(opts#0: DatatypeType, prefix#0: Seq) : Seq
uses {
axiom 5 <= $FunctionContextHeight ==> (forall opts#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.GetHelp(opts#0, prefix#0) } GetOpt.__default.GetHelp#canCall(opts#0, prefix#0) || (5 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(prefix#0, TSeq(TChar))) ==> $Is(GetOpt.__default.GetHelp(opts#0, prefix#0), TSeq(TChar)));
axiom 5 <= $FunctionContextHeight ==> (forall opts#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.GetHelp(opts#0, prefix#0) } GetOpt.__default.GetHelp#canCall(opts#0, prefix#0) || (5 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(prefix#0, TSeq(TChar))) ==> GetOpt.Options.Options_q(opts#0) && (var newOpts#0 := Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); GetOpt.__default.GetLongLen#canCall(newOpts#0, LitInt(6)) && (var longLen#0 := GetOpt.__default.GetLongLen($LS($LZ), newOpts#0, LitInt(6)); GetOpt.__default.GetCommandLen#canCall(newOpts#0, LitInt(0)) && (var commandLen#0 := GetOpt.__default.GetCommandLen($LS($LZ), newOpts#0, LitInt(0)); (commandLen#0 == LitInt(0) ==> GetOpt.Options.Options_q(opts#0) && GetOpt.Options.Options_q(opts#0) && GetOpt.__default.GetHelp2#canCall(newOpts#0, longLen#0)) && (commandLen#0 != LitInt(0) ==> GetOpt.Options.Options_q(opts#0) && GetOpt.Options.Options_q(opts#0) && GetOpt.__default.GetCmdHelp#canCall(newOpts#0, commandLen#0) && GetOpt.__default.GetHelp2#canCall(newOpts#0, longLen#0))))) && GetOpt.__default.GetHelp(opts#0, prefix#0) == (var newOpts#0 := Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (var longLen#0 := GetOpt.__default.GetLongLen($LS($LZ), newOpts#0, LitInt(6)); (var commandLen#0 := GetOpt.__default.GetCommandLen($LS($LZ), newOpts#0, LitInt(0)); (if commandLen#0 == LitInt(0) then Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(83))), $Box(char#FromInt(65))), $Box(char#FromInt(71))), $Box(char#FromInt(69))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), prefix#0), GetOpt.Options.name(opts#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(10)))), GetOpt.Options.help(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10)))), GetOpt.__default.GetHelp2($LS($LZ), newOpts#0, longLen#0)) else Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(83))), $Box(char#FromInt(65))), $Box(char#FromInt(71))), $Box(char#FromInt(69))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(opts#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(10)))), GetOpt.Options.help(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(65))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(115))), $Box(char#FromInt(58))), $Box(char#FromInt(10)))), GetOpt.__default.GetCmdHelp($LS($LZ), newOpts#0, commandLen#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(65))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(58))), $Box(char#FromInt(10)))), GetOpt.__default.GetHelp2($LS($LZ), newOpts#0, longLen#0)))))));
axiom 5 <= $FunctionContextHeight ==> (forall opts#0: DatatypeType, prefix#0: Seq :: {:weight 3} { GetOpt.__default.GetHelp(Lit(opts#0), Lit(prefix#0)) } GetOpt.__default.GetHelp#canCall(Lit(opts#0), Lit(prefix#0)) || (5 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(prefix#0, TSeq(TChar))) ==> GetOpt.Options.Options_q(Lit(opts#0)) && (var newOpts#1 := Seq#Append(GetOpt.Options.params(Lit(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); GetOpt.__default.GetLongLen#canCall(newOpts#1, LitInt(6)) && (var longLen#1 := GetOpt.__default.GetLongLen($LS($LZ), newOpts#1, LitInt(6)); GetOpt.__default.GetCommandLen#canCall(newOpts#1, LitInt(0)) && (var commandLen#1 := GetOpt.__default.GetCommandLen($LS($LZ), newOpts#1, LitInt(0)); (commandLen#1 == LitInt(0) ==> GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.__default.GetHelp2#canCall(newOpts#1, longLen#1)) && (commandLen#1 != LitInt(0) ==> GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.__default.GetCmdHelp#canCall(newOpts#1, commandLen#1) && GetOpt.__default.GetHelp2#canCall(newOpts#1, longLen#1))))) && GetOpt.__default.GetHelp(Lit(opts#0), Lit(prefix#0)) == (var newOpts#1 := Seq#Append(GetOpt.Options.params(Lit(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (var longLen#1 := GetOpt.__default.GetLongLen($LS($LZ), newOpts#1, LitInt(6)); (var commandLen#1 := GetOpt.__default.GetCommandLen($LS($LZ), newOpts#1, LitInt(0)); (if commandLen#1 == LitInt(0) then Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(83))), $Box(char#FromInt(65))), $Box(char#FromInt(71))), $Box(char#FromInt(69))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), prefix#0), GetOpt.Options.name(Lit(opts#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(10)))), GetOpt.Options.help(Lit(opts#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10)))), GetOpt.__default.GetHelp2($LS($LZ), newOpts#1, longLen#1)) else Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(83))), $Box(char#FromInt(65))), $Box(char#FromInt(71))), $Box(char#FromInt(69))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(Lit(opts#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(10)))), GetOpt.Options.help(Lit(opts#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(65))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(115))), $Box(char#FromInt(58))), $Box(char#FromInt(10)))), GetOpt.__default.GetCmdHelp($LS($LZ), newOpts#1, commandLen#1)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(65))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(58))), $Box(char#FromInt(10)))), GetOpt.__default.GetHelp2($LS($LZ), newOpts#1, longLen#1)))))));
}

function GetOpt.__default.GetHelp#canCall(opts#0: DatatypeType, prefix#0: Seq) : bool;

function GetOpt.__default.GetHelp#requires(DatatypeType, Seq) : bool;

axiom (forall opts#0: DatatypeType, prefix#0: Seq :: { GetOpt.__default.GetHelp#requires(opts#0, prefix#0) } $Is(opts#0, Tclass.GetOpt.Options()) && $Is(prefix#0, TSeq(TChar)) ==> (GetOpt.__default.GetHelp#requires(opts#0, prefix#0) <==> true));

procedure {:verboseName "GetOpt.GetHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetHelp(opts#0: DatatypeType where $Is(opts#0, Tclass.GetOpt.Options()), prefix#0: Seq where $Is(prefix#0, TSeq(TChar)));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetHelp(opts#0: DatatypeType, prefix#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newOpts#Z#0: Seq;
  var let#0#0#0: Seq;
  var longLen#Z#0: int;
  var let#1#0#0: int;
  var ##opts#0: Seq;
  var ##max#0: int;
  var commandLen#Z#0: int;
  var let#2#0#0: int;
  var ##opts#1: Seq;
  var ##max#1: int;
  var ##opts#2: Seq;
  var ##longLen#0: int;
  var ##opts#3: Seq;
  var ##commandLen#0: int;
  var ##opts#4: Seq;
  var ##longLen#1: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetHelp", " | ", opts#0, " | ", prefix#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(264,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(GetOpt.__default.GetHelp(opts#0, prefix#0), TSeq(TChar));
    assume false;
    return;

  anon6_Else:
    havoc newOpts#Z#0;
    assume $Is(newOpts#Z#0, TSeq(Tclass.GetOpt.Param())) && $IsAlloc(newOpts#Z#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume GetOpt.Options.Options_q(opts#0);
    assume let#0#0#0 == Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM())));
    assume GetOpt.Options.Options_q(opts#0);
    assume $Is(let#0#0#0, TSeq(Tclass.GetOpt.Param()));
    assume newOpts#Z#0 == let#0#0#0;
    havoc longLen#Z#0;
    assume LitInt(0) <= longLen#Z#0;
    ##opts#0 := newOpts#Z#0;
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume $Is(LitInt(6), Tclass._System.nat());
    ##max#0 := LitInt(6);
    assume $IsAlloc(##max#0, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.GetLongLen#canCall(newOpts#Z#0, LitInt(6));
    assume let#1#0#0 == GetOpt.__default.GetLongLen($LS($LZ), newOpts#Z#0, LitInt(6));
    assume GetOpt.__default.GetLongLen#canCall(newOpts#Z#0, LitInt(6));
    assume $Is(let#1#0#0, Tclass._System.nat());
    assume longLen#Z#0 == let#1#0#0;
    havoc commandLen#Z#0;
    assume LitInt(0) <= commandLen#Z#0;
    ##opts#1 := newOpts#Z#0;
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##max#1 := LitInt(0);
    assume $IsAlloc(##max#1, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.GetCommandLen#canCall(newOpts#Z#0, LitInt(0));
    assume let#2#0#0 == GetOpt.__default.GetCommandLen($LS($LZ), newOpts#Z#0, LitInt(0));
    assume GetOpt.__default.GetCommandLen#canCall(newOpts#Z#0, LitInt(0));
    assume $Is(let#2#0#0, Tclass._System.nat());
    assume commandLen#Z#0 == let#2#0#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} commandLen#Z#0 == LitInt(0);
    assume GetOpt.Options.Options_q(opts#0);
    assume GetOpt.Options.Options_q(opts#0);
    ##opts#2 := newOpts#Z#0;
    assume $IsAlloc(##opts#2, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longLen#0 := longLen#Z#0;
    assume $IsAlloc(##longLen#0, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.GetHelp2#canCall(newOpts#Z#0, longLen#Z#0);
    assume GetOpt.__default.GetHelp(opts#0, prefix#0) == Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(83))), $Box(char#FromInt(65))), $Box(char#FromInt(71))), $Box(char#FromInt(69))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), prefix#0), GetOpt.Options.name(opts#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(10)))), GetOpt.Options.help(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10)))), GetOpt.__default.GetHelp2($LS($LZ), newOpts#Z#0, longLen#Z#0));
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Options.Options_q(opts#0) && GetOpt.__default.GetHelp2#canCall(newOpts#Z#0, longLen#Z#0);
    assume $Is(GetOpt.__default.GetHelp(opts#0, prefix#0), TSeq(TChar));
    return;

  anon7_Else:
    assume {:partition} commandLen#Z#0 != LitInt(0);
    assume GetOpt.Options.Options_q(opts#0);
    assume GetOpt.Options.Options_q(opts#0);
    ##opts#3 := newOpts#Z#0;
    assume $IsAlloc(##opts#3, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##commandLen#0 := commandLen#Z#0;
    assume $IsAlloc(##commandLen#0, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.GetCmdHelp#canCall(newOpts#Z#0, commandLen#Z#0);
    ##opts#4 := newOpts#Z#0;
    assume $IsAlloc(##opts#4, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longLen#1 := longLen#Z#0;
    assume $IsAlloc(##longLen#1, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.GetHelp2#canCall(newOpts#Z#0, longLen#Z#0);
    assume GetOpt.__default.GetHelp(opts#0, prefix#0) == Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(83))), $Box(char#FromInt(65))), $Box(char#FromInt(71))), $Box(char#FromInt(69))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(opts#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(91))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(115))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(46))), $Box(char#FromInt(93))), $Box(char#FromInt(10)))), GetOpt.Options.help(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(65))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(115))), $Box(char#FromInt(58))), $Box(char#FromInt(10)))), GetOpt.__default.GetCmdHelp($LS($LZ), newOpts#Z#0, commandLen#Z#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(65))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(58))), $Box(char#FromInt(10)))), GetOpt.__default.GetHelp2($LS($LZ), newOpts#Z#0, longLen#Z#0));
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Options.Options_q(opts#0) && GetOpt.__default.GetCmdHelp#canCall(newOpts#Z#0, commandLen#Z#0) && GetOpt.__default.GetHelp2#canCall(newOpts#Z#0, longLen#Z#0);
    assume $Is(GetOpt.__default.GetHelp(opts#0, prefix#0), TSeq(TChar));
    return;
}



function GetOpt.__default.OptValue($ly: LayerType, args#0: Seq, arg#0: Seq) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.OptValue($ly, args#0, arg#0) } GetOpt.__default.OptValue#canCall(args#0, arg#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar))) ==> $Is(GetOpt.__default.OptValue($ly, args#0, arg#0), Tclass.Wrappers.Option(TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.OptValue($LS($ly), args#0, arg#0) } GetOpt.__default.OptValue#canCall(args#0, arg#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) && (!Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0) ==> GetOpt.__default.OptValue#canCall(Seq#Drop(args#0, LitInt(1)), arg#0))) && GetOpt.__default.OptValue($LS($ly), args#0, arg#0) == (if Seq#Length(args#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0) then GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) else GetOpt.__default.OptValue($ly, Seq#Drop(args#0, LitInt(1)), arg#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: {:weight 3} { GetOpt.__default.OptValue($LS($ly), Lit(args#0), Lit(arg#0)) } GetOpt.__default.OptValue#canCall(Lit(args#0), Lit(arg#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), arg#0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) && (!Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), arg#0) ==> GetOpt.__default.OptValue#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(arg#0)))) && GetOpt.__default.OptValue($LS($ly), Lit(args#0), Lit(arg#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), arg#0) then GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) else GetOpt.__default.OptValue($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(arg#0)))));
}

function GetOpt.__default.OptValue#canCall(args#0: Seq, arg#0: Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.OptValue($LS($ly), args#0, arg#0) } GetOpt.__default.OptValue($LS($ly), args#0, arg#0) == GetOpt.__default.OptValue($ly, args#0, arg#0));

axiom (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.OptValue(AsFuelBottom($ly), args#0, arg#0) } GetOpt.__default.OptValue($ly, args#0, arg#0) == GetOpt.__default.OptValue($LZ, args#0, arg#0));

function Tclass.GetOpt.OneArg() : Ty
uses {
axiom Tag(Tclass.GetOpt.OneArg()) == Tagclass.GetOpt.OneArg && TagFamily(Tclass.GetOpt.OneArg()) == tytagFamily$OneArg;
}

const unique Tagclass.GetOpt.OneArg: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.OneArg()) } $IsBox(bx, Tclass.GetOpt.OneArg()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.OneArg()));

function GetOpt.__default.OptValue#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.OptValue#requires($ly, args#0, arg#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar)) ==> (GetOpt.__default.OptValue#requires($ly, args#0, arg#0) <==> true));

procedure {:verboseName "GetOpt.OptValue (well-formedness)"} CheckWellformed$$GetOpt.__default.OptValue(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), arg#0: Seq where $Is(arg#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.OptValue (well-formedness)"} CheckWellformed$$GetOpt.__default.OptValue(args#0: Seq, arg#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##arg#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.OptValue", " | ", args#0, " | ", arg#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(296,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(GetOpt.__default.OptValue($LS($LZ), args#0, arg#0), Tclass.Wrappers.Option(TSeq(TChar)));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.OptValue($LS($LZ), args#0, arg#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(GetOpt.__default.OptValue($LS($LZ), args#0, arg#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;

  anon9_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume GetOpt.__default.OptValue($LS($LZ), args#0, arg#0) == GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume $Is(GetOpt.__default.OptValue($LS($LZ), args#0, arg#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##arg#0 := arg#0;
    assume $IsAlloc(##arg#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Seq#Rank(##arg#0) < Seq#Rank(arg#0));
    assume GetOpt.__default.OptValue#canCall(Seq#Drop(args#0, LitInt(1)), arg#0);
    assume GetOpt.__default.OptValue($LS($LZ), args#0, arg#0) == GetOpt.__default.OptValue($LS($LZ), Seq#Drop(args#0, LitInt(1)), arg#0);
    assume GetOpt.__default.OptValue#canCall(Seq#Drop(args#0, LitInt(1)), arg#0);
    assume $Is(GetOpt.__default.OptValue($LS($LZ), args#0, arg#0), Tclass.Wrappers.Option(TSeq(TChar)));
    return;
}



function GetOpt.__default.FlagCount($ly: LayerType, args#0: Seq, arg#0: Seq) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.FlagCount($ly, args#0, arg#0) } GetOpt.__default.FlagCount#canCall(args#0, arg#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar))) ==> LitInt(0) <= GetOpt.__default.FlagCount($ly, args#0, arg#0));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.FlagCount($LS($ly), args#0, arg#0) } GetOpt.__default.FlagCount#canCall(args#0, arg#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0) ==> GetOpt.__default.FlagCount#canCall(Seq#Drop(args#0, LitInt(1)), arg#0)) && (!Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0) ==> GetOpt.__default.FlagCount#canCall(Seq#Drop(args#0, LitInt(1)), arg#0))) && GetOpt.__default.FlagCount($LS($ly), args#0, arg#0) == (if Seq#Length(args#0) == LitInt(0) then 0 else (if Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0) then 1 + GetOpt.__default.FlagCount($ly, Seq#Drop(args#0, LitInt(1)), arg#0) else GetOpt.__default.FlagCount($ly, Seq#Drop(args#0, LitInt(1)), arg#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: {:weight 3} { GetOpt.__default.FlagCount($LS($ly), Lit(args#0), Lit(arg#0)) } GetOpt.__default.FlagCount#canCall(Lit(args#0), Lit(arg#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), arg#0) ==> GetOpt.__default.FlagCount#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(arg#0))) && (!Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), arg#0) ==> GetOpt.__default.FlagCount#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(arg#0)))) && GetOpt.__default.FlagCount($LS($ly), Lit(args#0), Lit(arg#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then 0 else (if Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), arg#0) then 1 + GetOpt.__default.FlagCount($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(arg#0)) else GetOpt.__default.FlagCount($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(arg#0)))));
}

function GetOpt.__default.FlagCount#canCall(args#0: Seq, arg#0: Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.FlagCount($LS($ly), args#0, arg#0) } GetOpt.__default.FlagCount($LS($ly), args#0, arg#0) == GetOpt.__default.FlagCount($ly, args#0, arg#0));

axiom (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.FlagCount(AsFuelBottom($ly), args#0, arg#0) } GetOpt.__default.FlagCount($ly, args#0, arg#0) == GetOpt.__default.FlagCount($LZ, args#0, arg#0));

function GetOpt.__default.FlagCount#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, arg#0: Seq :: { GetOpt.__default.FlagCount#requires($ly, args#0, arg#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(arg#0, TSeq(TChar)) ==> (GetOpt.__default.FlagCount#requires($ly, args#0, arg#0) <==> true));

procedure {:verboseName "GetOpt.FlagCount (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagCount(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), arg#0: Seq where $Is(arg#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.FlagCount (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagCount(args#0: Seq, arg#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##arg#0: Seq;
  var ##args#1: Seq;
  var ##arg#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.FlagCount", " | ", args#0, " | ", arg#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(308,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume LitInt(0) <= GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0);
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0) == LitInt(0);
    assume true;
    assume $Is(GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0), Tclass._System.nat());
    return;

  anon9_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##arg#0 := arg#0;
    assume $IsAlloc(##arg#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Seq#Rank(##arg#0) < Seq#Rank(arg#0));
    assume GetOpt.__default.FlagCount#canCall(Seq#Drop(args#0, LitInt(1)), arg#0);
    assume $Is(1 + GetOpt.__default.FlagCount($LS($LZ), Seq#Drop(args#0, LitInt(1)), arg#0), Tclass._System.nat());
    assume GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0) == 1 + GetOpt.__default.FlagCount($LS($LZ), Seq#Drop(args#0, LitInt(1)), arg#0);
    assume GetOpt.__default.FlagCount#canCall(Seq#Drop(args#0, LitInt(1)), arg#0);
    assume $Is(GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0), Tclass._System.nat());
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), arg#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##arg#1 := arg#0;
    assume $IsAlloc(##arg#1, TSeq(TChar), $Heap);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Seq#Rank(##arg#1) < Seq#Rank(arg#0));
    assume GetOpt.__default.FlagCount#canCall(Seq#Drop(args#0, LitInt(1)), arg#0);
    assume GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0) == GetOpt.__default.FlagCount($LS($LZ), Seq#Drop(args#0, LitInt(1)), arg#0);
    assume GetOpt.__default.FlagCount#canCall(Seq#Drop(args#0, LitInt(1)), arg#0);
    assume $Is(GetOpt.__default.FlagCount($LS($LZ), args#0, arg#0), Tclass._System.nat());
    return;
}



function GetOpt.__default.OptMapLast($ly: LayerType, args#0: Seq, theMap#0: Map) : Map
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapLast($ly, args#0, theMap#0) } GetOpt.__default.OptMapLast#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar)))) ==> $Is(GetOpt.__default.OptMapLast($ly, args#0, theMap#0), TMap(TSeq(TChar), TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapLast($LS($ly), args#0, theMap#0) } GetOpt.__default.OptMapLast#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar)))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapLast#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.OptMapLast#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0))) && GetOpt.__default.OptMapLast($LS($ly), args#0, theMap#0) == (if Seq#Length(args#0) == LitInt(0) then theMap#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) then GetOpt.__default.OptMapLast($ly, Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))) else GetOpt.__default.OptMapLast($ly, Seq#Drop(args#0, LitInt(1)), theMap#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: {:weight 3} { GetOpt.__default.OptMapLast($LS($ly), Lit(args#0), Lit(theMap#0)) } GetOpt.__default.OptMapLast#canCall(Lit(args#0), Lit(theMap#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar)))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.OptMapLast#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.OptMapLast#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)))) && GetOpt.__default.OptMapLast($LS($ly), Lit(args#0), Lit(theMap#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then theMap#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) then GetOpt.__default.OptMapLast($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))) else GetOpt.__default.OptMapLast($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)))));
}

function GetOpt.__default.OptMapLast#canCall(args#0: Seq, theMap#0: Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapLast($LS($ly), args#0, theMap#0) } GetOpt.__default.OptMapLast($LS($ly), args#0, theMap#0) == GetOpt.__default.OptMapLast($ly, args#0, theMap#0));

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapLast(AsFuelBottom($ly), args#0, theMap#0) } GetOpt.__default.OptMapLast($ly, args#0, theMap#0) == GetOpt.__default.OptMapLast($LZ, args#0, theMap#0));

function GetOpt.__default.OptMapLast#requires(LayerType, Seq, Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapLast#requires($ly, args#0, theMap#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar))) ==> (GetOpt.__default.OptMapLast#requires($ly, args#0, theMap#0) <==> true));

procedure {:verboseName "GetOpt.OptMapLast (well-formedness)"} CheckWellformed$$GetOpt.__default.OptMapLast(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), theMap#0: Map where $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.OptMapLast (well-formedness)"} CheckWellformed$$GetOpt.__default.OptMapLast(args#0: Seq, theMap#0: Map)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##theMap#0: Map;
  var ##args#1: Seq;
  var ##theMap#1: Map;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.OptMapLast", " | ", args#0, " | ", theMap#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(318,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TChar)));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0) == theMap#0;
    assume true;
    assume $Is(GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TChar)));
    return;

  anon9_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#0 := Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)));
    assume $IsAlloc(##theMap#0, TMap(TSeq(TChar), TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#0), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#0)));
    assume GetOpt.__default.OptMapLast#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapLast($LS($LZ), Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapLast#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume $Is(GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TChar)));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#1 := theMap#0;
    assume $IsAlloc(##theMap#1, TMap(TSeq(TChar), TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#1), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#1)));
    assume GetOpt.__default.OptMapLast#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapLast($LS($LZ), Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.OptMapLast#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume $Is(GetOpt.__default.OptMapLast($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TChar)));
    return;
}



function GetOpt.__default.FlagsSet($ly: LayerType, args#0: Seq, theSet#0: Set) : Set
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagsSet($ly, args#0, theSet#0) } GetOpt.__default.FlagsSet#canCall(args#0, theSet#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar)))) ==> $Is(GetOpt.__default.FlagsSet($ly, args#0, theSet#0), TSet(TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagsSet($LS($ly), args#0, theSet#0) } GetOpt.__default.FlagsSet#canCall(args#0, theSet#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar)))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.FlagsSet#canCall(Seq#Drop(args#0, LitInt(1)), theSet#0)) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagsSet#canCall(Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))))) && GetOpt.__default.FlagsSet($LS($ly), args#0, theSet#0) == (if Seq#Length(args#0) == LitInt(0) then theSet#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) then GetOpt.__default.FlagsSet($ly, Seq#Drop(args#0, LitInt(1)), theSet#0) else GetOpt.__default.FlagsSet($ly, Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: {:weight 3} { GetOpt.__default.FlagsSet($LS($ly), Lit(args#0), Lit(theSet#0)) } GetOpt.__default.FlagsSet#canCall(Lit(args#0), Lit(theSet#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar)))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.FlagsSet#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theSet#0))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.FlagsSet#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))))) && GetOpt.__default.FlagsSet($LS($ly), Lit(args#0), Lit(theSet#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then theSet#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) then GetOpt.__default.FlagsSet($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theSet#0)) else GetOpt.__default.FlagsSet($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))))));
}

function GetOpt.__default.FlagsSet#canCall(args#0: Seq, theSet#0: Set) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagsSet($LS($ly), args#0, theSet#0) } GetOpt.__default.FlagsSet($LS($ly), args#0, theSet#0) == GetOpt.__default.FlagsSet($ly, args#0, theSet#0));

axiom (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagsSet(AsFuelBottom($ly), args#0, theSet#0) } GetOpt.__default.FlagsSet($ly, args#0, theSet#0) == GetOpt.__default.FlagsSet($LZ, args#0, theSet#0));

function GetOpt.__default.FlagsSet#requires(LayerType, Seq, Set) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagsSet#requires($ly, args#0, theSet#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar))) ==> (GetOpt.__default.FlagsSet#requires($ly, args#0, theSet#0) <==> true));

procedure {:verboseName "GetOpt.FlagsSet (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagsSet(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), theSet#0: Set where $Is(theSet#0, TSet(TSeq(TChar))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.FlagsSet (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagsSet(args#0: Seq, theSet#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##theSet#0: Set;
  var ##args#1: Seq;
  var ##theSet#1: Set;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.FlagsSet", " | ", args#0, " | ", theSet#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(328,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0), TSet(TSeq(TChar)));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0) == theSet#0;
    assume true;
    assume $Is(GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0), TSet(TSeq(TChar)));
    return;

  anon9_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theSet#0 := theSet#0;
    assume $IsAlloc(##theSet#0, TSet(TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Set#Subset(##theSet#0, theSet#0) && !Set#Subset(theSet#0, ##theSet#0));
    assume GetOpt.__default.FlagsSet#canCall(Seq#Drop(args#0, LitInt(1)), theSet#0);
    assume GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0) == GetOpt.__default.FlagsSet($LS($LZ), Seq#Drop(args#0, LitInt(1)), theSet#0);
    assume GetOpt.__default.FlagsSet#canCall(Seq#Drop(args#0, LitInt(1)), theSet#0);
    assume $Is(GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0), TSet(TSeq(TChar)));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theSet#1 := Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume $IsAlloc(##theSet#1, TSet(TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Set#Subset(##theSet#1, theSet#0) && !Set#Subset(theSet#0, ##theSet#1));
    assume GetOpt.__default.FlagsSet#canCall(Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0) == GetOpt.__default.FlagsSet($LS($LZ), Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagsSet#canCall(Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume $Is(GetOpt.__default.FlagsSet($LS($LZ), args#0, theSet#0), TSet(TSeq(TChar)));
    return;
}



function GetOpt.__default.OptMapList($ly: LayerType, args#0: Seq, theMap#0: Map) : Map
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapList($ly, args#0, theMap#0) } GetOpt.__default.OptMapList#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TSeq(TChar)))) && (forall k#0: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#0)]): Seq } { Map#Domain(theMap#0)[$Box(k#0)] } $Is(k#0, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#0)] ==> 0 < Seq#Length($Unbox(Map#Elements(theMap#0)[$Box(k#0)]): Seq))) ==> (forall k#1: Seq :: { $Unbox(Map#Elements(GetOpt.__default.OptMapList($ly, args#0, theMap#0))[$Box(k#1)]): Seq } { Map#Domain(GetOpt.__default.OptMapList($ly, args#0, theMap#0))[$Box(k#1)] } $Is(k#1, TSeq(TChar)) && Map#Domain(GetOpt.__default.OptMapList($ly, args#0, theMap#0))[$Box(k#1)] ==> 0 < Seq#Length($Unbox(Map#Elements(GetOpt.__default.OptMapList($ly, args#0, theMap#0))[$Box(k#1)]): Seq)) && $Is(GetOpt.__default.OptMapList($ly, args#0, theMap#0), TMap(TSeq(TChar), TSeq(TSeq(TChar)))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapList($LS($ly), args#0, theMap#0) } GetOpt.__default.OptMapList#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TSeq(TChar)))) && (forall k#2: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#2)]): Seq } { Map#Domain(theMap#0)[$Box(k#2)] } $Is(k#2, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#2)] ==> 0 < Seq#Length($Unbox(Map#Elements(theMap#0)[$Box(k#2)]): Seq))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))))) && (!Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0))) && GetOpt.__default.OptMapList($LS($ly), args#0, theMap#0) == (if Seq#Length(args#0) == LitInt(0) then theMap#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) then (if Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] then GetOpt.__default.OptMapList($ly, Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))))) else GetOpt.__default.OptMapList($ly, Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))))) else GetOpt.__default.OptMapList($ly, Seq#Drop(args#0, LitInt(1)), theMap#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: {:weight 3} { GetOpt.__default.OptMapList($LS($ly), Lit(args#0), Lit(theMap#0)) } GetOpt.__default.OptMapList#canCall(Lit(args#0), Lit(theMap#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TSeq(TChar)))) && (forall k#3: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#3)]): Seq } { Map#Domain(theMap#0)[$Box(k#3)] } $Is(k#3, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#3)] ==> 0 < Seq#Length($Unbox(Map#Elements(Lit(theMap#0))[$Box(k#3)]): Seq))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.OptMapList#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(Lit(theMap#0))[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))))))) && (!Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.OptMapList#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.OptMapList#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)))) && GetOpt.__default.OptMapList($LS($ly), Lit(args#0), Lit(theMap#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then theMap#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) then (if Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] then GetOpt.__default.OptMapList($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(Lit(theMap#0))[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))))) else GetOpt.__default.OptMapList($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))))) else GetOpt.__default.OptMapList($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)))));
}

function GetOpt.__default.OptMapList#canCall(args#0: Seq, theMap#0: Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapList($LS($ly), args#0, theMap#0) } GetOpt.__default.OptMapList($LS($ly), args#0, theMap#0) == GetOpt.__default.OptMapList($ly, args#0, theMap#0));

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapList(AsFuelBottom($ly), args#0, theMap#0) } GetOpt.__default.OptMapList($ly, args#0, theMap#0) == GetOpt.__default.OptMapList($LZ, args#0, theMap#0));

function GetOpt.__default.OptMapList#requires(LayerType, Seq, Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapList#requires($ly, args#0, theMap#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TSeq(TChar)))) ==> (GetOpt.__default.OptMapList#requires($ly, args#0, theMap#0) <==> (forall k#2: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#2)]): Seq } { Map#Domain(theMap#0)[$Box(k#2)] } $Is(k#2, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#2)] ==> 0 < Seq#Length($Unbox(Map#Elements(theMap#0)[$Box(k#2)]): Seq))));

procedure {:verboseName "GetOpt.OptMapList (well-formedness)"} CheckWellformed$$GetOpt.__default.OptMapList(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), theMap#0: Map where $Is(theMap#0, TMap(TSeq(TChar), TSeq(TSeq(TChar))))) returns (ret#0: Map where $Is(ret#0, TMap(TSeq(TChar), TSeq(TSeq(TChar)))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16638"} (forall k#4: Seq :: { $Unbox(Map#Elements(ret#0)[$Box(k#4)]): Seq } { Map#Domain(ret#0)[$Box(k#4)] } $Is(k#4, TSeq(TChar)) && Map#Domain(ret#0)[$Box(k#4)] ==> 0 < Seq#Length($Unbox(Map#Elements(ret#0)[$Box(k#4)]): Seq));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.OptMapList (well-formedness)"} CheckWellformed$$GetOpt.__default.OptMapList(args#0: Seq, theMap#0: Map) returns (ret#0: Map)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#5: Seq;
  var k#6: Seq;
  var ##args#0: Seq;
  var ##theMap#0: Map;
  var ##args#1: Seq;
  var ##theMap#1: Map;
  var ##args#2: Seq;
  var ##theMap#2: Map;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.OptMapList", " | ", args#0, " | ", theMap#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(338,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    havoc k#5;
    assume $Is(k#5, TSeq(TChar)) && $IsAlloc(k#5, TSeq(TChar), $Heap);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Map#Domain(theMap#0)[$Box(k#5)];
    assume Map#Domain(theMap#0)[$Box(k#5)];
    assume 0 < Seq#Length($Unbox(Map#Elements(theMap#0)[$Box(k#5)]): Seq);
    goto anon4;

  anon17_Else:
    assume Map#Domain(theMap#0)[$Box(k#5)] ==> 0 < Seq#Length($Unbox(Map#Elements(theMap#0)[$Box(k#5)]): Seq);
    goto anon4;

  anon4:
    assume (forall k#0: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#0)]): Seq } { Map#Domain(theMap#0)[$Box(k#0)] } $Is(k#0, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#0)] ==> 0 < Seq#Length($Unbox(Map#Elements(theMap#0)[$Box(k#0)]): Seq));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $Is(GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TSeq(TChar))));
    havoc k#6;
    assume $Is(k#6, TSeq(TChar)) && $IsAlloc(k#6, TSeq(TChar), $Heap);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Map#Domain(ret#0)[$Box(k#6)];
    assume Map#Domain(ret#0)[$Box(k#6)];
    assume 0 < Seq#Length($Unbox(Map#Elements(ret#0)[$Box(k#6)]): Seq);
    goto anon8;

  anon19_Else:
    assume Map#Domain(ret#0)[$Box(k#6)] ==> 0 < Seq#Length($Unbox(Map#Elements(ret#0)[$Box(k#6)]): Seq);
    goto anon8;

  anon8:
    assume (forall k#4: Seq :: { $Unbox(Map#Elements(ret#0)[$Box(k#4)]): Seq } { Map#Domain(ret#0)[$Box(k#4)] } $Is(k#4, TSeq(TChar)) && Map#Domain(ret#0)[$Box(k#4)] ==> 0 < Seq#Length($Unbox(Map#Elements(ret#0)[$Box(k#4)]): Seq));
    assume false;
    return;

  anon18_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0) == theMap#0;
    assume true;
    assume $Is(GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TSeq(TChar))));
    goto anon16;

  anon20_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#0 := Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))));
    assume $IsAlloc(##theMap#0, TMap(TSeq(TChar), TSeq(TSeq(TChar))), $Heap);
    assume {:subsumption 0} (forall k#7: Seq :: { $Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): Seq } { Map#Domain(##theMap#0)[$Box(k#7)] } $Is(k#7, TSeq(TChar)) && Map#Domain(##theMap#0)[$Box(k#7)] ==> 0 < Seq#Length($Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): Seq));
    assume (forall k#7: Seq :: { $Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): Seq } { Map#Domain(##theMap#0)[$Box(k#7)] } $Is(k#7, TSeq(TChar)) && Map#Domain(##theMap#0)[$Box(k#7)] ==> 0 < Seq#Length($Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): Seq));
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#0), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#0)));
    assume GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))));
    assume GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapList($LS($LZ), Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Append($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): Seq, Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))));
    assume $Is(GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TSeq(TChar))));
    goto anon16;

  anon22_Else:
    assume {:partition} !Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#1 := Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume $IsAlloc(##theMap#1, TMap(TSeq(TChar), TSeq(TSeq(TChar))), $Heap);
    assume {:subsumption 0} (forall k#8: Seq :: { $Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): Seq } { Map#Domain(##theMap#1)[$Box(k#8)] } $Is(k#8, TSeq(TChar)) && Map#Domain(##theMap#1)[$Box(k#8)] ==> 0 < Seq#Length($Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): Seq));
    assume (forall k#8: Seq :: { $Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): Seq } { Map#Domain(##theMap#1)[$Box(k#8)] } $Is(k#8, TSeq(TChar)) && Map#Domain(##theMap#1)[$Box(k#8)] ==> 0 < Seq#Length($Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): Seq));
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#1), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#1)));
    assume GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))));
    assume GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapList($LS($LZ), Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))));
    assume $Is(GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TSeq(TChar))));
    goto anon16;

  anon21_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#2 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#2, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#2 := theMap#0;
    assume $IsAlloc(##theMap#2, TMap(TSeq(TChar), TSeq(TSeq(TChar))), $Heap);
    assume {:subsumption 0} (forall k#9: Seq :: { $Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): Seq } { Map#Domain(##theMap#2)[$Box(k#9)] } $Is(k#9, TSeq(TChar)) && Map#Domain(##theMap#2)[$Box(k#9)] ==> 0 < Seq#Length($Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): Seq));
    assume (forall k#9: Seq :: { $Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): Seq } { Map#Domain(##theMap#2)[$Box(k#9)] } $Is(k#9, TSeq(TChar)) && Map#Domain(##theMap#2)[$Box(k#9)] ==> 0 < Seq#Length($Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): Seq));
    assume Seq#Rank(##args#2) < Seq#Rank(args#0) || (Seq#Rank(##args#2) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#2), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#2)));
    assume GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapList($LS($LZ), Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.OptMapList#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume $Is(GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), TSeq(TSeq(TChar))));
    goto anon16;

  anon16:
    assume GetOpt.__default.OptMapList($LS($LZ), args#0, theMap#0) == ret#0;
    return;
}



function GetOpt.__default.FlagMapCount($ly: LayerType, args#0: Seq, theMap#0: Map) : Map
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.FlagMapCount($ly, args#0, theMap#0) } GetOpt.__default.FlagMapCount#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), Tclass._System.nat())) && (forall k#0: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#0)]): int } { Map#Domain(theMap#0)[$Box(k#0)] } $Is(k#0, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#0)] ==> 0 < $Unbox(Map#Elements(theMap#0)[$Box(k#0)]): int)) ==> (forall k#1: Seq :: { $Unbox(Map#Elements(GetOpt.__default.FlagMapCount($ly, args#0, theMap#0))[$Box(k#1)]): int } { Map#Domain(GetOpt.__default.FlagMapCount($ly, args#0, theMap#0))[$Box(k#1)] } $Is(k#1, TSeq(TChar)) && Map#Domain(GetOpt.__default.FlagMapCount($ly, args#0, theMap#0))[$Box(k#1)] ==> 0 < $Unbox(Map#Elements(GetOpt.__default.FlagMapCount($ly, args#0, theMap#0))[$Box(k#1)]): int) && $Is(GetOpt.__default.FlagMapCount($ly, args#0, theMap#0), TMap(TSeq(TChar), Tclass._System.nat())));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.FlagMapCount($LS($ly), args#0, theMap#0) } GetOpt.__default.FlagMapCount#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), Tclass._System.nat())) && (forall k#2: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#2)]): int } { Map#Domain(theMap#0)[$Box(k#2)] } $Is(k#2, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#2)] ==> 0 < $Unbox(Map#Elements(theMap#0)[$Box(k#2)]): int)) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0)) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1)))) && (!Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(LitInt(1))))))) && GetOpt.__default.FlagMapCount($LS($ly), args#0, theMap#0) == (if Seq#Length(args#0) == LitInt(0) then theMap#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) then GetOpt.__default.FlagMapCount($ly, Seq#Drop(args#0, LitInt(1)), theMap#0) else (if Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] then GetOpt.__default.FlagMapCount($ly, Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1))) else GetOpt.__default.FlagMapCount($ly, Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(LitInt(1))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: {:weight 3} { GetOpt.__default.FlagMapCount($LS($ly), Lit(args#0), Lit(theMap#0)) } GetOpt.__default.FlagMapCount#canCall(Lit(args#0), Lit(theMap#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), Tclass._System.nat())) && (forall k#3: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#3)]): int } { Map#Domain(theMap#0)[$Box(k#3)] } $Is(k#3, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#3)] ==> 0 < $Unbox(Map#Elements(Lit(theMap#0))[$Box(k#3)]): int)) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.FlagMapCount#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.FlagMapCount#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(Lit(theMap#0))[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))]): int + 1)))) && (!Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.FlagMapCount#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box(LitInt(1))))))) && GetOpt.__default.FlagMapCount($LS($ly), Lit(args#0), Lit(theMap#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then theMap#0 else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) then GetOpt.__default.FlagMapCount($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)) else (if Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] then GetOpt.__default.FlagMapCount($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(Lit(theMap#0))[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))]): int + 1))) else GetOpt.__default.FlagMapCount($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), $Box(LitInt(1))))))));
}

function GetOpt.__default.FlagMapCount#canCall(args#0: Seq, theMap#0: Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.FlagMapCount($LS($ly), args#0, theMap#0) } GetOpt.__default.FlagMapCount($LS($ly), args#0, theMap#0) == GetOpt.__default.FlagMapCount($ly, args#0, theMap#0));

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.FlagMapCount(AsFuelBottom($ly), args#0, theMap#0) } GetOpt.__default.FlagMapCount($ly, args#0, theMap#0) == GetOpt.__default.FlagMapCount($LZ, args#0, theMap#0));

function GetOpt.__default.FlagMapCount#requires(LayerType, Seq, Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.FlagMapCount#requires($ly, args#0, theMap#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), Tclass._System.nat())) ==> (GetOpt.__default.FlagMapCount#requires($ly, args#0, theMap#0) <==> (forall k#2: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#2)]): int } { Map#Domain(theMap#0)[$Box(k#2)] } $Is(k#2, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#2)] ==> 0 < $Unbox(Map#Elements(theMap#0)[$Box(k#2)]): int)));

procedure {:verboseName "GetOpt.FlagMapCount (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagMapCount(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), theMap#0: Map where $Is(theMap#0, TMap(TSeq(TChar), Tclass._System.nat()))) returns (ret#0: Map where $Is(ret#0, TMap(TSeq(TChar), Tclass._System.nat())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16673"} (forall k#4: Seq :: { $Unbox(Map#Elements(ret#0)[$Box(k#4)]): int } { Map#Domain(ret#0)[$Box(k#4)] } $Is(k#4, TSeq(TChar)) && Map#Domain(ret#0)[$Box(k#4)] ==> 0 < $Unbox(Map#Elements(ret#0)[$Box(k#4)]): int);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.FlagMapCount (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagMapCount(args#0: Seq, theMap#0: Map) returns (ret#0: Map)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#5: Seq;
  var k#6: Seq;
  var ##args#0: Seq;
  var ##theMap#0: Map;
  var newtype$check#0: int;
  var ##args#1: Seq;
  var ##theMap#1: Map;
  var ##args#2: Seq;
  var ##theMap#2: Map;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.FlagMapCount", " | ", args#0, " | ", theMap#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(353,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    havoc k#5;
    assume $Is(k#5, TSeq(TChar)) && $IsAlloc(k#5, TSeq(TChar), $Heap);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Map#Domain(theMap#0)[$Box(k#5)];
    assume Map#Domain(theMap#0)[$Box(k#5)];
    assume 0 < $Unbox(Map#Elements(theMap#0)[$Box(k#5)]): int;
    goto anon4;

  anon17_Else:
    assume Map#Domain(theMap#0)[$Box(k#5)] ==> 0 < $Unbox(Map#Elements(theMap#0)[$Box(k#5)]): int;
    goto anon4;

  anon4:
    assume (forall k#0: Seq :: { $Unbox(Map#Elements(theMap#0)[$Box(k#0)]): int } { Map#Domain(theMap#0)[$Box(k#0)] } $Is(k#0, TSeq(TChar)) && Map#Domain(theMap#0)[$Box(k#0)] ==> 0 < $Unbox(Map#Elements(theMap#0)[$Box(k#0)]): int);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $Is(GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), Tclass._System.nat()));
    havoc k#6;
    assume $Is(k#6, TSeq(TChar)) && $IsAlloc(k#6, TSeq(TChar), $Heap);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Map#Domain(ret#0)[$Box(k#6)];
    assume Map#Domain(ret#0)[$Box(k#6)];
    assume 0 < $Unbox(Map#Elements(ret#0)[$Box(k#6)]): int;
    goto anon8;

  anon19_Else:
    assume Map#Domain(ret#0)[$Box(k#6)] ==> 0 < $Unbox(Map#Elements(ret#0)[$Box(k#6)]): int;
    goto anon8;

  anon8:
    assume (forall k#4: Seq :: { $Unbox(Map#Elements(ret#0)[$Box(k#4)]): int } { Map#Domain(ret#0)[$Box(k#4)] } $Is(k#4, TSeq(TChar)) && Map#Domain(ret#0)[$Box(k#4)] ==> 0 < $Unbox(Map#Elements(ret#0)[$Box(k#4)]): int);
    assume false;
    return;

  anon18_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0) == theMap#0;
    assume true;
    assume $Is(GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), Tclass._System.nat()));
    goto anon16;

  anon20_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#0 := theMap#0;
    assume $IsAlloc(##theMap#0, TMap(TSeq(TChar), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} (forall k#7: Seq :: { $Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): int } { Map#Domain(##theMap#0)[$Box(k#7)] } $Is(k#7, TSeq(TChar)) && Map#Domain(##theMap#0)[$Box(k#7)] ==> 0 < $Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): int);
    assume (forall k#7: Seq :: { $Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): int } { Map#Domain(##theMap#0)[$Box(k#7)] } $Is(k#7, TSeq(TChar)) && Map#Domain(##theMap#0)[$Box(k#7)] ==> 0 < $Unbox(Map#Elements(##theMap#0)[$Box(k#7)]): int);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#0), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#0)));
    assume GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0) == GetOpt.__default.FlagMapCount($LS($LZ), Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume $Is(GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), Tclass._System.nat()));
    goto anon16;

  anon21_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    newtype$check#0 := $Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1;
    assume LitInt(0) <= newtype$check#0;
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#1 := Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1));
    assume $IsAlloc(##theMap#1, TMap(TSeq(TChar), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} (forall k#8: Seq :: { $Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): int } { Map#Domain(##theMap#1)[$Box(k#8)] } $Is(k#8, TSeq(TChar)) && Map#Domain(##theMap#1)[$Box(k#8)] ==> 0 < $Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): int);
    assume (forall k#8: Seq :: { $Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): int } { Map#Domain(##theMap#1)[$Box(k#8)] } $Is(k#8, TSeq(TChar)) && Map#Domain(##theMap#1)[$Box(k#8)] ==> 0 < $Unbox(Map#Elements(##theMap#1)[$Box(k#8)]): int);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#1), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#1)));
    assume GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1)));
    assume GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0) == GetOpt.__default.FlagMapCount($LS($LZ), Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1)));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box($Unbox(Map#Elements(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))]): int + 1)));
    assume $Is(GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), Tclass._System.nat()));
    goto anon16;

  anon22_Else:
    assume {:partition} !Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume $Is(LitInt(1), Tclass._System.nat());
    ##args#2 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#2, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#2 := Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(LitInt(1)));
    assume $IsAlloc(##theMap#2, TMap(TSeq(TChar), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} (forall k#9: Seq :: { $Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): int } { Map#Domain(##theMap#2)[$Box(k#9)] } $Is(k#9, TSeq(TChar)) && Map#Domain(##theMap#2)[$Box(k#9)] ==> 0 < $Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): int);
    assume (forall k#9: Seq :: { $Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): int } { Map#Domain(##theMap#2)[$Box(k#9)] } $Is(k#9, TSeq(TChar)) && Map#Domain(##theMap#2)[$Box(k#9)] ==> 0 < $Unbox(Map#Elements(##theMap#2)[$Box(k#9)]): int);
    assume Seq#Rank(##args#2) < Seq#Rank(args#0) || (Seq#Rank(##args#2) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#2), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#2)));
    assume GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(LitInt(1))));
    assume GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0) == GetOpt.__default.FlagMapCount($LS($LZ), Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(LitInt(1))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagMapCount#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), $Box(LitInt(1))));
    assume $Is(GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0), TMap(TSeq(TChar), Tclass._System.nat()));
    goto anon16;

  anon16:
    assume GetOpt.__default.FlagMapCount($LS($LZ), args#0, theMap#0) == ret#0;
    return;
}



function GetOpt.__default.FlagSetCheck($ly: LayerType, args#0: Seq, theSet#0: Set) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagSetCheck($ly, args#0, theSet#0) } GetOpt.__default.FlagSetCheck#canCall(args#0, theSet#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar)))) ==> $Is(GetOpt.__default.FlagSetCheck($ly, args#0, theSet#0), Tclass.Wrappers.Result(TSet(TSeq(TChar)), TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagSetCheck($LS($ly), args#0, theSet#0) } GetOpt.__default.FlagSetCheck#canCall(args#0, theSet#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar)))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (theSet#0[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) && (!theSet#0[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagSetCheck#canCall(Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.FlagSetCheck#canCall(Seq#Drop(args#0, LitInt(1)), theSet#0))) && GetOpt.__default.FlagSetCheck($LS($ly), args#0, theSet#0) == (if Seq#Length(args#0) == LitInt(0) then #Wrappers.Result.Success($Box(theSet#0)) else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) then (if theSet#0[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))) else GetOpt.__default.FlagSetCheck($ly, Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))) else GetOpt.__default.FlagSetCheck($ly, Seq#Drop(args#0, LitInt(1)), theSet#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: {:weight 3} { GetOpt.__default.FlagSetCheck($LS($ly), Lit(args#0), Lit(theSet#0)) } GetOpt.__default.FlagSetCheck#canCall(Lit(args#0), Lit(theSet#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar)))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Lit(theSet#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) && (!Lit(theSet#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.FlagSetCheck#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.FlagSetCheck#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theSet#0)))) && GetOpt.__default.FlagSetCheck($LS($ly), Lit(args#0), Lit(theSet#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(theSet#0))) else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) then (if Lit(theSet#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))) else GetOpt.__default.FlagSetCheck($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))))) else GetOpt.__default.FlagSetCheck($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theSet#0)))));
}

function GetOpt.__default.FlagSetCheck#canCall(args#0: Seq, theSet#0: Set) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagSetCheck($LS($ly), args#0, theSet#0) } GetOpt.__default.FlagSetCheck($LS($ly), args#0, theSet#0) == GetOpt.__default.FlagSetCheck($ly, args#0, theSet#0));

axiom (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagSetCheck(AsFuelBottom($ly), args#0, theSet#0) } GetOpt.__default.FlagSetCheck($ly, args#0, theSet#0) == GetOpt.__default.FlagSetCheck($LZ, args#0, theSet#0));

function GetOpt.__default.FlagSetCheck#requires(LayerType, Seq, Set) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theSet#0: Set :: { GetOpt.__default.FlagSetCheck#requires($ly, args#0, theSet#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theSet#0, TSet(TSeq(TChar))) ==> (GetOpt.__default.FlagSetCheck#requires($ly, args#0, theSet#0) <==> true));

procedure {:verboseName "GetOpt.FlagSetCheck (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagSetCheck(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), theSet#0: Set where $Is(theSet#0, TSet(TSeq(TChar))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.FlagSetCheck (well-formedness)"} CheckWellformed$$GetOpt.__default.FlagSetCheck(args#0: Seq, theSet#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##theSet#0: Set;
  var ##args#1: Seq;
  var ##theSet#1: Set;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.FlagSetCheck", " | ", args#0, " | ", theSet#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(368,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0), Tclass.Wrappers.Result(TSet(TSeq(TChar)), TSeq(TChar)));
    assume false;
    return;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0) == #Wrappers.Result.Success($Box(theSet#0));
    assume true;
    assume $Is(GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0), Tclass.Wrappers.Result(TSet(TSeq(TChar)), TSeq(TChar)));
    return;

  anon11_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} theSet#0[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume $Is(GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0), Tclass.Wrappers.Result(TSet(TSeq(TChar)), TSeq(TChar)));
    return;

  anon13_Else:
    assume {:partition} !theSet#0[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theSet#0 := Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume $IsAlloc(##theSet#0, TSet(TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Set#Subset(##theSet#0, theSet#0) && !Set#Subset(theSet#0, ##theSet#0));
    assume GetOpt.__default.FlagSetCheck#canCall(Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0) == GetOpt.__default.FlagSetCheck($LS($LZ), Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.FlagSetCheck#canCall(Seq#Drop(args#0, LitInt(1)), Set#Union(theSet#0, Set#UnionOne(Set#Empty(): Set, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))));
    assume $Is(GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0), Tclass.Wrappers.Result(TSet(TSeq(TChar)), TSeq(TChar)));
    return;

  anon12_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theSet#1 := theSet#0;
    assume $IsAlloc(##theSet#1, TSet(TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Set#Subset(##theSet#1, theSet#0) && !Set#Subset(theSet#0, ##theSet#1));
    assume GetOpt.__default.FlagSetCheck#canCall(Seq#Drop(args#0, LitInt(1)), theSet#0);
    assume GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0) == GetOpt.__default.FlagSetCheck($LS($LZ), Seq#Drop(args#0, LitInt(1)), theSet#0);
    assume GetOpt.__default.FlagSetCheck#canCall(Seq#Drop(args#0, LitInt(1)), theSet#0);
    assume $Is(GetOpt.__default.FlagSetCheck($LS($LZ), args#0, theSet#0), Tclass.Wrappers.Result(TSet(TSeq(TChar)), TSeq(TChar)));
    return;
}



function GetOpt.__default.OptMapCheck($ly: LayerType, args#0: Seq, theMap#0: Map) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapCheck($ly, args#0, theMap#0) } GetOpt.__default.OptMapCheck#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar)))) ==> $Is(GetOpt.__default.OptMapCheck($ly, args#0, theMap#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), TSeq(TChar)), TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapCheck($LS($ly), args#0, theMap#0) } GetOpt.__default.OptMapCheck#canCall(args#0, theMap#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar)))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) && (!Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapCheck#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.OptMapCheck#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0))) && GetOpt.__default.OptMapCheck($LS($ly), args#0, theMap#0) == (if Seq#Length(args#0) == LitInt(0) then #Wrappers.Result.Success($Box(theMap#0)) else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)) then (if Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)))) else GetOpt.__default.OptMapCheck($ly, Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))))) else GetOpt.__default.OptMapCheck($ly, Seq#Drop(args#0, LitInt(1)), theMap#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: {:weight 3} { GetOpt.__default.OptMapCheck($LS($ly), Lit(args#0), Lit(theMap#0)) } GetOpt.__default.OptMapCheck#canCall(Lit(args#0), Lit(theMap#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar)))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) && (!Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && GetOpt.__default.OptMapCheck#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))))) && (!Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.OptMapCheck#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)))) && GetOpt.__default.OptMapCheck($LS($ly), Lit(args#0), Lit(theMap#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(theMap#0))) else (if Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)) then (if Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)))) else GetOpt.__default.OptMapCheck($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Map#Build(Lit(theMap#0), $Box(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType))))) else GetOpt.__default.OptMapCheck($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(theMap#0)))));
}

function GetOpt.__default.OptMapCheck#canCall(args#0: Seq, theMap#0: Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapCheck($LS($ly), args#0, theMap#0) } GetOpt.__default.OptMapCheck($LS($ly), args#0, theMap#0) == GetOpt.__default.OptMapCheck($ly, args#0, theMap#0));

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapCheck(AsFuelBottom($ly), args#0, theMap#0) } GetOpt.__default.OptMapCheck($ly, args#0, theMap#0) == GetOpt.__default.OptMapCheck($LZ, args#0, theMap#0));

function GetOpt.__default.OptMapCheck#requires(LayerType, Seq, Map) : bool;

axiom (forall $ly: LayerType, args#0: Seq, theMap#0: Map :: { GetOpt.__default.OptMapCheck#requires($ly, args#0, theMap#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar))) ==> (GetOpt.__default.OptMapCheck#requires($ly, args#0, theMap#0) <==> true));

procedure {:verboseName "GetOpt.OptMapCheck (well-formedness)"} CheckWellformed$$GetOpt.__default.OptMapCheck(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), theMap#0: Map where $Is(theMap#0, TMap(TSeq(TChar), TSeq(TChar))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.OptMapCheck (well-formedness)"} CheckWellformed$$GetOpt.__default.OptMapCheck(args#0: Seq, theMap#0: Map)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##theMap#0: Map;
  var ##args#1: Seq;
  var ##theMap#1: Map;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.OptMapCheck", " | ", args#0, " | ", theMap#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(381,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), TSeq(TChar)), TSeq(TChar)));
    assume false;
    return;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0) == #Wrappers.Result.Success($Box(theMap#0));
    assume true;
    assume $Is(GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), TSeq(TChar)), TSeq(TChar)));
    return;

  anon11_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume $Is(GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), TSeq(TChar)), TSeq(TChar)));
    return;

  anon13_Else:
    assume {:partition} !Map#Domain(theMap#0)[$Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    assume Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#0 := Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)));
    assume $IsAlloc(##theMap#0, TMap(TSeq(TChar), TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#0), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#0)));
    assume GetOpt.__default.OptMapCheck#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapCheck($LS($LZ), Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && GetOpt.__default.OptMapCheck#canCall(Seq#Drop(args#0, LitInt(1)), Map#Build(theMap#0, $Box(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType)), Wrappers.Option.value(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType))));
    assume $Is(GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), TSeq(TChar)), TSeq(TChar)));
    return;

  anon12_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.OneArg.value($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#1 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##theMap#1 := theMap#0;
    assume $IsAlloc(##theMap#1, TMap(TSeq(TChar), TSeq(TChar)), $Heap);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Set#Subset(Map#Domain(##theMap#1), Map#Domain(theMap#0)) && !Set#Subset(Map#Domain(theMap#0), Map#Domain(##theMap#1)));
    assume GetOpt.__default.OptMapCheck#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0) == GetOpt.__default.OptMapCheck($LS($LZ), Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume GetOpt.__default.OptMapCheck#canCall(Seq#Drop(args#0, LitInt(1)), theMap#0);
    assume $Is(GetOpt.__default.OptMapCheck($LS($LZ), args#0, theMap#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), TSeq(TChar)), TSeq(TChar)));
    return;
}



function GetOpt.__default.GetHelpHelp(opt#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType :: { GetOpt.__default.GetHelpHelp(opt#0) } GetOpt.__default.GetHelpHelp#canCall(opt#0) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param())) ==> $Is(GetOpt.__default.GetHelpHelp(opt#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType :: { GetOpt.__default.GetHelpHelp(opt#0) } GetOpt.__default.GetHelpHelp#canCall(opt#0) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param())) ==> (!GetOpt.Param.Command_q(opt#0) ==> !GetOpt.Param.Flag_q(opt#0) ==> GetOpt.Param.Required#canCall(opt#0) && (!GetOpt.Param.Required(opt#0) ==> GetOpt.Param.HasDefault#canCall(opt#0))) && GetOpt.__default.GetHelpHelp(opt#0) == (if GetOpt.Param.Command_q(opt#0) then Seq#Empty(): Seq else (if GetOpt.Param.Flag_q(opt#0) then GetOpt.Param.help(opt#0) else Seq#Append(GetOpt.Param.help(opt#0), (if GetOpt.Param.Required(opt#0) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(40))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(41))) else (if GetOpt.Param.HasDefault(opt#0) then Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(40))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Unused.val(GetOpt.Param.unused(opt#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(41)))) else Seq#Empty(): Seq))))));
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType :: {:weight 3} { GetOpt.__default.GetHelpHelp(Lit(opt#0)) } GetOpt.__default.GetHelpHelp#canCall(Lit(opt#0)) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param())) ==> (!Lit(GetOpt.Param.Command_q(Lit(opt#0))) ==> !Lit(GetOpt.Param.Flag_q(Lit(opt#0))) ==> GetOpt.Param.Required#canCall(Lit(opt#0)) && (!Lit(GetOpt.Param.Required(Lit(opt#0))) ==> GetOpt.Param.HasDefault#canCall(Lit(opt#0)))) && GetOpt.__default.GetHelpHelp(Lit(opt#0)) == (if GetOpt.Param.Command_q(Lit(opt#0)) then Seq#Empty(): Seq else (if GetOpt.Param.Flag_q(Lit(opt#0)) then GetOpt.Param.help(Lit(opt#0)) else Seq#Append(GetOpt.Param.help(Lit(opt#0)), (if GetOpt.Param.Required(Lit(opt#0)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(40))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(41))) else (if GetOpt.Param.HasDefault(Lit(opt#0)) then Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(40))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Unused.val(Lit(GetOpt.Param.unused(Lit(opt#0))))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(41)))) else Seq#Empty(): Seq))))));
}

function GetOpt.__default.GetHelpHelp#canCall(opt#0: DatatypeType) : bool;

function GetOpt.__default.GetHelpHelp#requires(DatatypeType) : bool;

axiom (forall opt#0: DatatypeType :: { GetOpt.__default.GetHelpHelp#requires(opt#0) } $Is(opt#0, Tclass.GetOpt.Param()) ==> (GetOpt.__default.GetHelpHelp#requires(opt#0) <==> true));

procedure {:verboseName "GetOpt.GetHelpHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetHelpHelp(opt#0: DatatypeType where $Is(opt#0, Tclass.GetOpt.Param()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetHelpHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetHelpHelp(opt#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetHelpHelp", " | ", opt#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(396,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(GetOpt.__default.GetHelpHelp(opt#0), TSeq(TChar));
    assume false;
    return;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} GetOpt.Param.Command_q(opt#0);
    assume GetOpt.__default.GetHelpHelp(opt#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.__default.GetHelpHelp(opt#0), TSeq(TChar));
    return;

  anon14_Else:
    assume {:partition} !GetOpt.Param.Command_q(opt#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} GetOpt.Param.Flag_q(opt#0);
    assume GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    assume GetOpt.__default.GetHelpHelp(opt#0) == GetOpt.Param.help(opt#0);
    assume true;
    assume $Is(GetOpt.__default.GetHelpHelp(opt#0), TSeq(TChar));
    return;

  anon15_Else:
    assume {:partition} !GetOpt.Param.Flag_q(opt#0);
    assume GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    assume $IsAllocBox($Box(opt#0), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.Required#canCall(opt#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} GetOpt.Param.Required(opt#0);
    goto anon12;

  anon16_Else:
    assume {:partition} !GetOpt.Param.Required(opt#0);
    assume $IsAllocBox($Box(opt#0), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.HasDefault#canCall(opt#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GetOpt.Param.HasDefault(opt#0);
    assume GetOpt.Param.Opt_q(opt#0);
    assume GetOpt.Unused.Default_q(GetOpt.Param.unused(opt#0));
    goto anon12;

  anon17_Else:
    assume {:partition} !GetOpt.Param.HasDefault(opt#0);
    goto anon12;

  anon12:
    assume GetOpt.__default.GetHelpHelp(opt#0) == Seq#Append(GetOpt.Param.help(opt#0), (if GetOpt.Param.Required(opt#0) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(40))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(41))) else (if GetOpt.Param.HasDefault(opt#0) then Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(40))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Unused.val(GetOpt.Param.unused(opt#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(41)))) else Seq#Empty(): Seq)));
    assume GetOpt.Param.Required#canCall(opt#0) && (!GetOpt.Param.Required(opt#0) ==> GetOpt.Param.HasDefault#canCall(opt#0));
    assume $Is(GetOpt.__default.GetHelpHelp(opt#0), TSeq(TChar));
    return;
}



function GetOpt.__default.OneHelp(opt#0: DatatypeType, longLen#0: int) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType, longLen#0: int :: { GetOpt.__default.OneHelp(opt#0, longLen#0) } GetOpt.__default.OneHelp#canCall(opt#0, longLen#0) || (3 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0) ==> $Is(GetOpt.__default.OneHelp(opt#0, longLen#0), TSeq(TChar)));
axiom 3 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType, longLen#0: int :: { GetOpt.__default.OneHelp(opt#0, longLen#0) } GetOpt.__default.OneHelp#canCall(opt#0, longLen#0) || (3 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0) ==> (!GetOpt.Param.Command_q(opt#0) ==> GetOpt.Param.ShowHelp#canCall(opt#0)) && (!(GetOpt.Param.Command_q(opt#0) || !GetOpt.Param.ShowHelp(opt#0)) ==> GetOpt.__default.GetShortHelp#canCall(opt#0) && GetOpt.__default.GetLongHelp#canCall(opt#0, longLen#0) && GetOpt.__default.GetHelpHelp#canCall(opt#0)) && GetOpt.__default.OneHelp(opt#0, longLen#0) == (if GetOpt.Param.Command_q(opt#0) || !GetOpt.Param.ShowHelp(opt#0) then Seq#Empty(): Seq else Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(GetOpt.__default.GetShortHelp(opt#0), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.__default.GetLongHelp(opt#0, longLen#0)), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.__default.GetHelpHelp(opt#0)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))))));
axiom 3 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType, longLen#0: int :: {:weight 3} { GetOpt.__default.OneHelp(Lit(opt#0), LitInt(longLen#0)) } GetOpt.__default.OneHelp#canCall(Lit(opt#0), LitInt(longLen#0)) || (3 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0) ==> (!Lit(GetOpt.Param.Command_q(Lit(opt#0))) ==> GetOpt.Param.ShowHelp#canCall(Lit(opt#0))) && (!(GetOpt.Param.Command_q(Lit(opt#0)) || !Lit(GetOpt.Param.ShowHelp(Lit(opt#0)))) ==> GetOpt.__default.GetShortHelp#canCall(Lit(opt#0)) && GetOpt.__default.GetLongHelp#canCall(Lit(opt#0), LitInt(longLen#0)) && GetOpt.__default.GetHelpHelp#canCall(Lit(opt#0))) && GetOpt.__default.OneHelp(Lit(opt#0), LitInt(longLen#0)) == (if GetOpt.Param.Command_q(Lit(opt#0)) || !Lit(GetOpt.Param.ShowHelp(Lit(opt#0))) then Seq#Empty(): Seq else Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(GetOpt.__default.GetShortHelp(Lit(opt#0)), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.__default.GetLongHelp(Lit(opt#0), LitInt(longLen#0))), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.__default.GetHelpHelp(Lit(opt#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))))));
}

function GetOpt.__default.OneHelp#canCall(opt#0: DatatypeType, longLen#0: int) : bool;

function GetOpt.__default.OneHelp#requires(DatatypeType, int) : bool;

axiom (forall opt#0: DatatypeType, longLen#0: int :: { GetOpt.__default.OneHelp#requires(opt#0, longLen#0) } $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0 ==> (GetOpt.__default.OneHelp#requires(opt#0, longLen#0) <==> true));

procedure {:verboseName "GetOpt.OneHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.OneHelp(opt#0: DatatypeType where $Is(opt#0, Tclass.GetOpt.Param()), longLen#0: int where LitInt(0) <= longLen#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function GetOpt.__default.GetCommandHelp(opt#0: DatatypeType, commandLen#0: int) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType, commandLen#0: int :: { GetOpt.__default.GetCommandHelp(opt#0, commandLen#0) } GetOpt.__default.GetCommandHelp#canCall(opt#0, commandLen#0) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= commandLen#0 && GetOpt.Param.Command_q(opt#0)) ==> $Is(GetOpt.__default.GetCommandHelp(opt#0, commandLen#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, opt#0: DatatypeType, commandLen#0: int :: { GetOpt.__default.GetCommandHelp(opt#0, commandLen#0), $IsGoodHeap($Heap) } GetOpt.__default.GetCommandHelp#canCall(opt#0, commandLen#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= commandLen#0 && GetOpt.Param.Command_q(opt#0)) ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && (Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))) < commandLen#0 ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && GetOpt.Options.Options_q(GetOpt.Param.options(opt#0))) && (commandLen#0 <= Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))) ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#0))) && GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && GetOpt.__default.GetCommandHelp(opt#0, commandLen#0) == (var name#0 := (if Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))) < commandLen#0 then Seq#Append(GetOpt.Options.name(GetOpt.Param.options(opt#0)), Seq#Create(TChar, $Heap, commandLen#0 - Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))) else GetOpt.Options.name(GetOpt.Param.options(opt#0))); Seq#Append(Seq#Append(Seq#Append(name#0, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.Options.help(GetOpt.Param.options(opt#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, opt#0: DatatypeType, commandLen#0: int :: {:weight 3} { GetOpt.__default.GetCommandHelp(Lit(opt#0), LitInt(commandLen#0)), $IsGoodHeap($Heap) } GetOpt.__default.GetCommandHelp#canCall(Lit(opt#0), LitInt(commandLen#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= commandLen#0 && Lit(GetOpt.Param.Command_q(Lit(opt#0)))) ==> GetOpt.Options.Options_q(Lit(GetOpt.Param.options(Lit(opt#0)))) && (Seq#Length(Lit(GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(opt#0)))))) < commandLen#0 ==> GetOpt.Options.Options_q(Lit(GetOpt.Param.options(Lit(opt#0)))) && GetOpt.Options.Options_q(Lit(GetOpt.Param.options(Lit(opt#0))))) && (commandLen#0 <= Seq#Length(Lit(GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(opt#0)))))) ==> GetOpt.Options.Options_q(Lit(GetOpt.Param.options(Lit(opt#0))))) && GetOpt.Options.Options_q(Lit(GetOpt.Param.options(Lit(opt#0)))) && GetOpt.__default.GetCommandHelp(Lit(opt#0), LitInt(commandLen#0)) == (var name#1 := (if Seq#Length(Lit(GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(opt#0)))))) < commandLen#0 then Seq#Append(GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(opt#0)))), Seq#Create(TChar, $Heap, commandLen#0 - Seq#Length(Lit(GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(opt#0)))))), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: $IsBox($l#3#i#0, TInt)), (lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) else GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(opt#0))))); Seq#Append(Seq#Append(Seq#Append(name#1, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.Options.help(Lit(GetOpt.Param.options(Lit(opt#0))))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))))));
}

function GetOpt.__default.GetCommandHelp#canCall(opt#0: DatatypeType, commandLen#0: int) : bool;

function GetOpt.__default.GetCommandHelp#requires(DatatypeType, int) : bool;

axiom (forall $Heap: Heap, opt#0: DatatypeType, commandLen#0: int :: { GetOpt.__default.GetCommandHelp#requires(opt#0, commandLen#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= commandLen#0 ==> (GetOpt.__default.GetCommandHelp#requires(opt#0, commandLen#0) <==> GetOpt.Param.Command_q(opt#0)));

procedure {:verboseName "GetOpt.GetCommandHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetCommandHelp(opt#0: DatatypeType where $Is(opt#0, Tclass.GetOpt.Param()), commandLen#0: int where LitInt(0) <= commandLen#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetCommandHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetCommandHelp(opt#0: DatatypeType, commandLen#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var name#Z#0: Seq;
  var let#0#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: char;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetCommandHelp", " | ", opt#0, " | ", commandLen#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(420,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume GetOpt.Param.Command_q(opt#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(GetOpt.__default.GetCommandHelp(opt#0, commandLen#0), TSeq(TChar));
    assume false;
    return;

  anon11_Else:
    havoc name#Z#0;
    assume $Is(name#Z#0, TSeq(TChar)) && $IsAlloc(name#Z#0, TSeq(TChar), $Heap);
    assume GetOpt.Param.Command_q(opt#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))) < commandLen#0;
    assume GetOpt.Param.Command_q(opt#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume GetOpt.Param.Command_q(opt#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume 0 <= commandLen#0 - Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0)));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == Lit(char#FromInt(32));
    assume true;
    assume $Is(lambdaResult#0, TChar);
    goto anon7;

  anon14_Else:
    assume {:partition} false;
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon13_Else:
    goto anon8;

  anon8:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < commandLen#0 - Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))) ==> Requires1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < commandLen#0 - Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume let#0#0#0 == Seq#Append(GetOpt.Options.name(GetOpt.Param.options(opt#0)), Seq#Create(TChar, $Heap, commandLen#0 - Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0))), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))));
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume $Is(let#0#0#0, TSeq(TChar));
    goto anon10;

  anon12_Else:
    assume {:partition} commandLen#0 <= Seq#Length(GetOpt.Options.name(GetOpt.Param.options(opt#0)));
    assume GetOpt.Param.Command_q(opt#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume let#0#0#0 == GetOpt.Options.name(GetOpt.Param.options(opt#0));
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume $Is(let#0#0#0, TSeq(TChar));
    goto anon10;

  anon10:
    assume name#Z#0 == let#0#0#0;
    assume GetOpt.Param.Command_q(opt#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume GetOpt.__default.GetCommandHelp(opt#0, commandLen#0) == Seq#Append(Seq#Append(Seq#Append(name#Z#0, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))), GetOpt.Options.help(GetOpt.Param.options(opt#0))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))));
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#0));
    assume $Is(GetOpt.__default.GetCommandHelp(opt#0, commandLen#0), TSeq(TChar));
    assume b$reqreads#0;
    return;
}



function GetOpt.__default.GetShortHelp(opt#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType :: { GetOpt.__default.GetShortHelp(opt#0) } GetOpt.__default.GetShortHelp#canCall(opt#0) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param())) ==> $Is(GetOpt.__default.GetShortHelp(opt#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType :: { GetOpt.__default.GetShortHelp(opt#0) } GetOpt.__default.GetShortHelp#canCall(opt#0) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param())) ==> GetOpt.__default.GetShortHelp(opt#0) == (if GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0) then (if GetOpt.Param.short(opt#0) != GetOpt.__default.NullChar() then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.Param.short(opt#0)))) else Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))) else Seq#Empty(): Seq));
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType :: {:weight 3} { GetOpt.__default.GetShortHelp(Lit(opt#0)) } GetOpt.__default.GetShortHelp#canCall(Lit(opt#0)) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param())) ==> GetOpt.__default.GetShortHelp(Lit(opt#0)) == (if GetOpt.Param.Opt_q(Lit(opt#0)) || GetOpt.Param.Flag_q(Lit(opt#0)) then (if GetOpt.Param.short(Lit(opt#0)) != GetOpt.__default.NullChar() then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), Seq#Build(Seq#Empty(): Seq, $Box(Lit(GetOpt.Param.short(Lit(opt#0)))))) else Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32)))) else Seq#Empty(): Seq));
}

function GetOpt.__default.GetShortHelp#canCall(opt#0: DatatypeType) : bool;

function GetOpt.__default.GetShortHelp#requires(DatatypeType) : bool;

axiom (forall opt#0: DatatypeType :: { GetOpt.__default.GetShortHelp#requires(opt#0) } $Is(opt#0, Tclass.GetOpt.Param()) ==> (GetOpt.__default.GetShortHelp#requires(opt#0) <==> true));

procedure {:verboseName "GetOpt.GetShortHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetShortHelp(opt#0: DatatypeType where $Is(opt#0, Tclass.GetOpt.Param())) returns (output#0: Seq where $Is(output#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetShortHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetShortHelp(opt#0: DatatypeType) returns (output#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetShortHelp", " | ", opt#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(431,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(GetOpt.__default.GetShortHelp(opt#0), TSeq(TChar));
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} !GetOpt.Param.Opt_q(opt#0);
    goto anon5;

  anon12_Else:
    assume {:partition} GetOpt.Param.Opt_q(opt#0);
    goto anon5;

  anon5:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    assume GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} GetOpt.Param.short(opt#0) != GetOpt.__default.NullChar();
    assume GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    assume GetOpt.__default.GetShortHelp(opt#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.Param.short(opt#0))));
    assume true;
    assume $Is(GetOpt.__default.GetShortHelp(opt#0), TSeq(TChar));
    goto anon10;

  anon14_Else:
    assume {:partition} GetOpt.Param.short(opt#0) == GetOpt.__default.NullChar();
    assume GetOpt.__default.GetShortHelp(opt#0) == Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(32))));
    assume true;
    assume $Is(GetOpt.__default.GetShortHelp(opt#0), TSeq(TChar));
    goto anon10;

  anon13_Else:
    assume {:partition} !(GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0));
    assume GetOpt.__default.GetShortHelp(opt#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.__default.GetShortHelp(opt#0), TSeq(TChar));
    goto anon10;

  anon10:
    assume GetOpt.__default.GetShortHelp(opt#0) == output#0;
    return;
}



function GetOpt.__default.GetLongHelp(opt#0: DatatypeType, longLen#0: int) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall opt#0: DatatypeType, longLen#0: int :: { GetOpt.__default.GetLongHelp(opt#0, longLen#0) } GetOpt.__default.GetLongHelp#canCall(opt#0, longLen#0) || (2 < $FunctionContextHeight && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0) ==> $Is(GetOpt.__default.GetLongHelp(opt#0, longLen#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, opt#0: DatatypeType, longLen#0: int :: { GetOpt.__default.GetLongHelp(opt#0, longLen#0), $IsGoodHeap($Heap) } GetOpt.__default.GetLongHelp#canCall(opt#0, longLen#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0) ==> GetOpt.__default.GetLongHelp(opt#0, longLen#0) == (if GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0) then (var tmp#0 := Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), GetOpt.Param.name(opt#0)), (if GetOpt.Param.Opt_q(opt#0) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(61))), GetOpt.Param.argName(opt#0)) else Seq#Empty(): Seq)); (if Seq#Length(tmp#0) < longLen#0 then Seq#Append(tmp#0, Seq#Create(TChar, $Heap, longLen#0 - Seq#Length(tmp#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))) else tmp#0)) else Seq#Empty(): Seq));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, opt#0: DatatypeType, longLen#0: int :: {:weight 3} { GetOpt.__default.GetLongHelp(Lit(opt#0), LitInt(longLen#0)), $IsGoodHeap($Heap) } GetOpt.__default.GetLongHelp#canCall(Lit(opt#0), LitInt(longLen#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0) ==> GetOpt.__default.GetLongHelp(Lit(opt#0), LitInt(longLen#0)) == (if GetOpt.Param.Opt_q(Lit(opt#0)) || GetOpt.Param.Flag_q(Lit(opt#0)) then (var tmp#1 := Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), GetOpt.Param.name(Lit(opt#0))), (if GetOpt.Param.Opt_q(Lit(opt#0)) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(61))), GetOpt.Param.argName(Lit(opt#0))) else Seq#Empty(): Seq)); (if Seq#Length(tmp#1) < longLen#0 then Seq#Append(tmp#1, Seq#Create(TChar, $Heap, longLen#0 - Seq#Length(tmp#1), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt)), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) else tmp#1)) else Seq#Empty(): Seq));
}

function GetOpt.__default.GetLongHelp#canCall(opt#0: DatatypeType, longLen#0: int) : bool;

function GetOpt.__default.GetLongHelp#requires(DatatypeType, int) : bool;

axiom (forall $Heap: Heap, opt#0: DatatypeType, longLen#0: int :: { GetOpt.__default.GetLongHelp#requires(opt#0, longLen#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(opt#0, Tclass.GetOpt.Param()) && LitInt(0) <= longLen#0 ==> (GetOpt.__default.GetLongHelp#requires(opt#0, longLen#0) <==> true));

procedure {:verboseName "GetOpt.GetLongHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetLongHelp(opt#0: DatatypeType where $Is(opt#0, Tclass.GetOpt.Param()), longLen#0: int where LitInt(0) <= longLen#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetLongHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetLongHelp(opt#0: DatatypeType, longLen#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var tmp#Z#0: Seq;
  var let#0#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: char;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetLongHelp", " | ", opt#0, " | ", longLen#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(442,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $Is(GetOpt.__default.GetLongHelp(opt#0, longLen#0), TSeq(TChar));
    assume false;
    return;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} !GetOpt.Param.Opt_q(opt#0);
    goto anon5;

  anon19_Else:
    assume {:partition} GetOpt.Param.Opt_q(opt#0);
    goto anon5;

  anon5:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    havoc tmp#Z#0;
    assume $Is(tmp#Z#0, TSeq(TChar)) && $IsAlloc(tmp#Z#0, TSeq(TChar), $Heap);
    assume GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} GetOpt.Param.Opt_q(opt#0);
    assume GetOpt.Param.Opt_q(opt#0);
    goto anon9;

  anon21_Else:
    assume {:partition} !GetOpt.Param.Opt_q(opt#0);
    goto anon9;

  anon9:
    assume let#0#0#0 == Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), GetOpt.Param.name(opt#0)), (if GetOpt.Param.Opt_q(opt#0) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(61))), GetOpt.Param.argName(opt#0)) else Seq#Empty(): Seq));
    assume true;
    assume $Is(let#0#0#0, TSeq(TChar));
    assume tmp#Z#0 == let#0#0#0;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Length(tmp#Z#0) < longLen#0;
    assume 0 <= longLen#0 - Seq#Length(tmp#Z#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == Lit(char#FromInt(32));
    assume true;
    assume $Is(lambdaResult#0, TChar);
    goto anon13;

  anon24_Else:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume false;
    goto anon14;

  anon23_Else:
    goto anon14;

  anon14:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < longLen#0 - Seq#Length(tmp#Z#0) ==> Requires1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < longLen#0 - Seq#Length(tmp#Z#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume GetOpt.__default.GetLongHelp(opt#0, longLen#0) == Seq#Append(tmp#Z#0, Seq#Create(TChar, $Heap, longLen#0 - Seq#Length(tmp#Z#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(Lit(char#FromInt(32)))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))));
    assume true;
    assume $Is(GetOpt.__default.GetLongHelp(opt#0, longLen#0), TSeq(TChar));
    goto anon17;

  anon22_Else:
    assume {:partition} longLen#0 <= Seq#Length(tmp#Z#0);
    assume GetOpt.__default.GetLongHelp(opt#0, longLen#0) == tmp#Z#0;
    assume true;
    assume $Is(GetOpt.__default.GetLongHelp(opt#0, longLen#0), TSeq(TChar));
    goto anon17;

  anon20_Else:
    assume {:partition} !(GetOpt.Param.Opt_q(opt#0) || GetOpt.Param.Flag_q(opt#0));
    assume GetOpt.__default.GetLongHelp(opt#0, longLen#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.__default.GetLongHelp(opt#0, longLen#0), TSeq(TChar));
    goto anon17;

  anon17:
    assume b$reqreads#0;
    return;
}



function GetOpt.__default.GetHelp2($ly: LayerType, opts#0: Seq, longLen#0: int) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, longLen#0: int :: { GetOpt.__default.GetHelp2($ly, opts#0, longLen#0) } GetOpt.__default.GetHelp2#canCall(opts#0, longLen#0) || (4 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= longLen#0) ==> $Is(GetOpt.__default.GetHelp2($ly, opts#0, longLen#0), TSeq(TChar)));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, longLen#0: int :: { GetOpt.__default.GetHelp2($LS($ly), opts#0, longLen#0) } GetOpt.__default.GetHelp2#canCall(opts#0, longLen#0) || (4 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= longLen#0) ==> (Seq#Length(opts#0) != LitInt(0) ==> GetOpt.__default.OneHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, longLen#0) && GetOpt.__default.GetHelp2#canCall(Seq#Drop(opts#0, LitInt(1)), longLen#0)) && GetOpt.__default.GetHelp2($LS($ly), opts#0, longLen#0) == (if Seq#Length(opts#0) == LitInt(0) then Seq#Empty(): Seq else (var x#0 := GetOpt.__default.OneHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, longLen#0); Seq#Append(x#0, GetOpt.__default.GetHelp2($ly, Seq#Drop(opts#0, LitInt(1)), longLen#0)))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, longLen#0: int :: {:weight 3} { GetOpt.__default.GetHelp2($LS($ly), Lit(opts#0), LitInt(longLen#0)) } GetOpt.__default.GetHelp2#canCall(Lit(opts#0), LitInt(longLen#0)) || (4 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= longLen#0) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> GetOpt.__default.OneHelp#canCall($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(longLen#0)) && GetOpt.__default.GetHelp2#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), LitInt(longLen#0))) && GetOpt.__default.GetHelp2($LS($ly), Lit(opts#0), LitInt(longLen#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#1 := GetOpt.__default.OneHelp($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(longLen#0)); Seq#Append(x#1, GetOpt.__default.GetHelp2($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), LitInt(longLen#0))))));
}

function GetOpt.__default.GetHelp2#canCall(opts#0: Seq, longLen#0: int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, longLen#0: int :: { GetOpt.__default.GetHelp2($LS($ly), opts#0, longLen#0) } GetOpt.__default.GetHelp2($LS($ly), opts#0, longLen#0) == GetOpt.__default.GetHelp2($ly, opts#0, longLen#0));

axiom (forall $ly: LayerType, opts#0: Seq, longLen#0: int :: { GetOpt.__default.GetHelp2(AsFuelBottom($ly), opts#0, longLen#0) } GetOpt.__default.GetHelp2($ly, opts#0, longLen#0) == GetOpt.__default.GetHelp2($LZ, opts#0, longLen#0));

function GetOpt.__default.GetHelp2#requires(LayerType, Seq, int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, longLen#0: int :: { GetOpt.__default.GetHelp2#requires($ly, opts#0, longLen#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= longLen#0 ==> (GetOpt.__default.GetHelp2#requires($ly, opts#0, longLen#0) <==> true));

procedure {:verboseName "GetOpt.GetHelp2 (well-formedness)"} CheckWellformed$$GetOpt.__default.GetHelp2(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), longLen#0: int where LitInt(0) <= longLen#0);
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetHelp2 (well-formedness)"} CheckWellformed$$GetOpt.__default.GetHelp2(opts#0: Seq, longLen#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##opt#0: DatatypeType;
  var ##longLen#0: int;
  var ##opts#0: Seq;
  var ##longLen#1: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetHelp2", " | ", opts#0, " | ", longLen#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(459,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(GetOpt.__default.GetHelp2($LS($LZ), opts#0, longLen#0), TSeq(TChar));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.GetHelp2($LS($LZ), opts#0, longLen#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.__default.GetHelp2($LS($LZ), opts#0, longLen#0), TSeq(TChar));
    return;

  anon7_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    havoc x#Z#0;
    assume $Is(x#Z#0, TSeq(TChar)) && $IsAlloc(x#Z#0, TSeq(TChar), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    ##opt#0 := $Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType;
    assume $IsAlloc(##opt#0, Tclass.GetOpt.Param(), $Heap);
    ##longLen#0 := longLen#0;
    assume $IsAlloc(##longLen#0, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.OneHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, longLen#0);
    assume let#0#0#0 == GetOpt.__default.OneHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, longLen#0);
    assume GetOpt.__default.OneHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, longLen#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume x#Z#0 == let#0#0#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longLen#1 := longLen#0;
    assume $IsAlloc(##longLen#1, Tclass._System.nat(), $Heap);
    assume 0 <= longLen#0 || Seq#Rank(##opts#0) < Seq#Rank(opts#0) || ##longLen#1 == longLen#0;
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && ##longLen#1 < longLen#0);
    assume GetOpt.__default.GetHelp2#canCall(Seq#Drop(opts#0, LitInt(1)), longLen#0);
    assume GetOpt.__default.GetHelp2($LS($LZ), opts#0, longLen#0) == Seq#Append(x#Z#0, GetOpt.__default.GetHelp2($LS($LZ), Seq#Drop(opts#0, LitInt(1)), longLen#0));
    assume GetOpt.__default.GetHelp2#canCall(Seq#Drop(opts#0, LitInt(1)), longLen#0);
    assume $Is(GetOpt.__default.GetHelp2($LS($LZ), opts#0, longLen#0), TSeq(TChar));
    return;
}



function GetOpt.__default.GetCmdHelp($ly: LayerType, opts#0: Seq, commandLen#0: int) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, commandLen#0: int :: { GetOpt.__default.GetCmdHelp($ly, opts#0, commandLen#0) } GetOpt.__default.GetCmdHelp#canCall(opts#0, commandLen#0) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= commandLen#0) ==> $Is(GetOpt.__default.GetCmdHelp($ly, opts#0, commandLen#0), TSeq(TChar)));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, commandLen#0: int :: { GetOpt.__default.GetCmdHelp($LS($ly), opts#0, commandLen#0) } GetOpt.__default.GetCmdHelp#canCall(opts#0, commandLen#0) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= commandLen#0) ==> (Seq#Length(opts#0) != LitInt(0) ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.__default.GetCommandHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, commandLen#0)) && GetOpt.__default.GetCmdHelp#canCall(Seq#Drop(opts#0, LitInt(1)), commandLen#0)) && GetOpt.__default.GetCmdHelp($LS($ly), opts#0, commandLen#0) == (if Seq#Length(opts#0) == LitInt(0) then Seq#Empty(): Seq else (var x#0 := (if GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) then GetOpt.__default.GetCommandHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, commandLen#0) else Seq#Empty(): Seq); Seq#Append(x#0, GetOpt.__default.GetCmdHelp($ly, Seq#Drop(opts#0, LitInt(1)), commandLen#0)))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, commandLen#0: int :: {:weight 3} { GetOpt.__default.GetCmdHelp($LS($ly), Lit(opts#0), LitInt(commandLen#0)) } GetOpt.__default.GetCmdHelp#canCall(Lit(opts#0), LitInt(commandLen#0)) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= commandLen#0) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.__default.GetCommandHelp#canCall($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(commandLen#0))) && GetOpt.__default.GetCmdHelp#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), LitInt(commandLen#0))) && GetOpt.__default.GetCmdHelp($LS($ly), Lit(opts#0), LitInt(commandLen#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then Seq#Empty(): Seq else (var x#1 := (if GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) then GetOpt.__default.GetCommandHelp($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(commandLen#0)) else Seq#Empty(): Seq); Seq#Append(x#1, GetOpt.__default.GetCmdHelp($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), LitInt(commandLen#0))))));
}

function GetOpt.__default.GetCmdHelp#canCall(opts#0: Seq, commandLen#0: int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, commandLen#0: int :: { GetOpt.__default.GetCmdHelp($LS($ly), opts#0, commandLen#0) } GetOpt.__default.GetCmdHelp($LS($ly), opts#0, commandLen#0) == GetOpt.__default.GetCmdHelp($ly, opts#0, commandLen#0));

axiom (forall $ly: LayerType, opts#0: Seq, commandLen#0: int :: { GetOpt.__default.GetCmdHelp(AsFuelBottom($ly), opts#0, commandLen#0) } GetOpt.__default.GetCmdHelp($ly, opts#0, commandLen#0) == GetOpt.__default.GetCmdHelp($LZ, opts#0, commandLen#0));

function GetOpt.__default.GetCmdHelp#requires(LayerType, Seq, int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, commandLen#0: int :: { GetOpt.__default.GetCmdHelp#requires($ly, opts#0, commandLen#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= commandLen#0 ==> (GetOpt.__default.GetCmdHelp#requires($ly, opts#0, commandLen#0) <==> true));

procedure {:verboseName "GetOpt.GetCmdHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetCmdHelp(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), commandLen#0: int where LitInt(0) <= commandLen#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetCmdHelp (well-formedness)"} CheckWellformed$$GetOpt.__default.GetCmdHelp(opts#0: Seq, commandLen#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##opt#0: DatatypeType;
  var ##commandLen#0: int;
  var ##opts#0: Seq;
  var ##commandLen#1: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetCmdHelp", " | ", opts#0, " | ", commandLen#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(468,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(GetOpt.__default.GetCmdHelp($LS($LZ), opts#0, commandLen#0), TSeq(TChar));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.GetCmdHelp($LS($LZ), opts#0, commandLen#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.__default.GetCmdHelp($LS($LZ), opts#0, commandLen#0), TSeq(TChar));
    return;

  anon10_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    havoc x#Z#0;
    assume $Is(x#Z#0, TSeq(TChar)) && $IsAlloc(x#Z#0, TSeq(TChar), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    ##opt#0 := $Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType;
    assume $IsAlloc(##opt#0, Tclass.GetOpt.Param(), $Heap);
    ##commandLen#0 := commandLen#0;
    assume $IsAlloc(##commandLen#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} GetOpt.Param.Command_q(##opt#0);
    assume GetOpt.Param.Command_q(##opt#0);
    assume GetOpt.__default.GetCommandHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, commandLen#0);
    assume let#0#0#0 == GetOpt.__default.GetCommandHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, commandLen#0);
    assume GetOpt.__default.GetCommandHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, commandLen#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    goto anon8;

  anon11_Else:
    assume {:partition} !GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume let#0#0#0 == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(let#0#0#0, TSeq(TChar));
    goto anon8;

  anon8:
    assume x#Z#0 == let#0#0#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##commandLen#1 := commandLen#0;
    assume $IsAlloc(##commandLen#1, Tclass._System.nat(), $Heap);
    assume 0 <= commandLen#0 || Seq#Rank(##opts#0) < Seq#Rank(opts#0) || ##commandLen#1 == commandLen#0;
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && ##commandLen#1 < commandLen#0);
    assume GetOpt.__default.GetCmdHelp#canCall(Seq#Drop(opts#0, LitInt(1)), commandLen#0);
    assume GetOpt.__default.GetCmdHelp($LS($LZ), opts#0, commandLen#0) == Seq#Append(x#Z#0, GetOpt.__default.GetCmdHelp($LS($LZ), Seq#Drop(opts#0, LitInt(1)), commandLen#0));
    assume GetOpt.__default.GetCmdHelp#canCall(Seq#Drop(opts#0, LitInt(1)), commandLen#0);
    assume $Is(GetOpt.__default.GetCmdHelp($LS($LZ), opts#0, commandLen#0), TSeq(TChar));
    return;
}



function GetOpt.__default.GetLongLen($ly: LayerType, opts#0: Seq, max#0: int) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetLongLen($ly, opts#0, max#0) } GetOpt.__default.GetLongLen#canCall(opts#0, max#0) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0) ==> LitInt(0) <= GetOpt.__default.GetLongLen($ly, opts#0, max#0));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetLongLen($LS($ly), opts#0, max#0) } GetOpt.__default.GetLongLen#canCall(opts#0, max#0) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0) ==> (Seq#Length(opts#0) != LitInt(0) ==> GetOpt.__default.GetLongHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, LitInt(0)) && (var x#0 := Seq#Length(GetOpt.__default.GetLongHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, LitInt(0))); (var newMax#0 := (if x#0 > max#0 then x#0 else max#0); GetOpt.__default.GetLongLen#canCall(Seq#Drop(opts#0, LitInt(1)), newMax#0)))) && GetOpt.__default.GetLongLen($LS($ly), opts#0, max#0) == (if Seq#Length(opts#0) == LitInt(0) then max#0 else (var x#0 := Seq#Length(GetOpt.__default.GetLongHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, LitInt(0))); (var newMax#0 := (if x#0 > max#0 then x#0 else max#0); GetOpt.__default.GetLongLen($ly, Seq#Drop(opts#0, LitInt(1)), newMax#0)))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, max#0: int :: {:weight 3} { GetOpt.__default.GetLongLen($LS($ly), Lit(opts#0), LitInt(max#0)) } GetOpt.__default.GetLongLen#canCall(Lit(opts#0), LitInt(max#0)) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> GetOpt.__default.GetLongHelp#canCall($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(0)) && (var x#1 := Seq#Length(GetOpt.__default.GetLongHelp($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(0))); (var newMax#1 := (if x#1 > max#0 then x#1 else max#0); GetOpt.__default.GetLongLen#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), newMax#1)))) && GetOpt.__default.GetLongLen($LS($ly), Lit(opts#0), LitInt(max#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then max#0 else (var x#1 := Seq#Length(GetOpt.__default.GetLongHelp($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType, LitInt(0))); (var newMax#1 := (if x#1 > max#0 then x#1 else max#0); GetOpt.__default.GetLongLen($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), newMax#1)))));
}

function GetOpt.__default.GetLongLen#canCall(opts#0: Seq, max#0: int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetLongLen($LS($ly), opts#0, max#0) } GetOpt.__default.GetLongLen($LS($ly), opts#0, max#0) == GetOpt.__default.GetLongLen($ly, opts#0, max#0));

axiom (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetLongLen(AsFuelBottom($ly), opts#0, max#0) } GetOpt.__default.GetLongLen($ly, opts#0, max#0) == GetOpt.__default.GetLongLen($LZ, opts#0, max#0));

function GetOpt.__default.GetLongLen#requires(LayerType, Seq, int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetLongLen#requires($ly, opts#0, max#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0 ==> (GetOpt.__default.GetLongLen#requires($ly, opts#0, max#0) <==> true));

procedure {:verboseName "GetOpt.GetLongLen (well-formedness)"} CheckWellformed$$GetOpt.__default.GetLongLen(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), max#0: int where LitInt(0) <= max#0);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetLongLen (well-formedness)"} CheckWellformed$$GetOpt.__default.GetLongLen(opts#0: Seq, max#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#Z#0: int;
  var let#0#0#0: int;
  var ##opt#0: DatatypeType;
  var ##longLen#0: int;
  var newMax#Z#0: int;
  var let#1#0#0: int;
  var ##opts#0: Seq;
  var ##max#0: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetLongLen", " | ", opts#0, " | ", max#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(481,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume LitInt(0) <= GetOpt.__default.GetLongLen($LS($LZ), opts#0, max#0);
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.GetLongLen($LS($LZ), opts#0, max#0) == max#0;
    assume true;
    assume $Is(GetOpt.__default.GetLongLen($LS($LZ), opts#0, max#0), Tclass._System.nat());
    return;

  anon10_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    havoc x#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    ##opt#0 := $Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType;
    assume $IsAlloc(##opt#0, Tclass.GetOpt.Param(), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##longLen#0 := LitInt(0);
    assume $IsAlloc(##longLen#0, Tclass._System.nat(), $Heap);
    assume GetOpt.__default.GetLongHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, LitInt(0));
    assume let#0#0#0 == Seq#Length(GetOpt.__default.GetLongHelp($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, LitInt(0)));
    assume GetOpt.__default.GetLongHelp#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType, LitInt(0));
    assume $Is(let#0#0#0, TInt);
    assume x#Z#0 == let#0#0#0;
    havoc newMax#Z#0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} x#Z#0 > max#0;
    assume let#1#0#0 == x#Z#0;
    assume true;
    assume $Is(let#1#0#0, TInt);
    goto anon8;

  anon11_Else:
    assume {:partition} max#0 >= x#Z#0;
    assume let#1#0#0 == max#0;
    assume true;
    assume $Is(let#1#0#0, TInt);
    goto anon8;

  anon8:
    assume newMax#Z#0 == let#1#0#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume $Is(newMax#Z#0, Tclass._System.nat());
    ##max#0 := newMax#Z#0;
    assume $IsAlloc(##max#0, Tclass._System.nat(), $Heap);
    assume 0 <= max#0 || Seq#Rank(##opts#0) < Seq#Rank(opts#0) || ##max#0 == max#0;
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && ##max#0 < max#0);
    assume GetOpt.__default.GetLongLen#canCall(Seq#Drop(opts#0, LitInt(1)), newMax#Z#0);
    assume GetOpt.__default.GetLongLen($LS($LZ), opts#0, max#0) == GetOpt.__default.GetLongLen($LS($LZ), Seq#Drop(opts#0, LitInt(1)), newMax#Z#0);
    assume GetOpt.__default.GetLongLen#canCall(Seq#Drop(opts#0, LitInt(1)), newMax#Z#0);
    assume $Is(GetOpt.__default.GetLongLen($LS($LZ), opts#0, max#0), Tclass._System.nat());
    return;
}



function GetOpt.__default.GetCommandLen($ly: LayerType, opts#0: Seq, max#0: int) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetCommandLen($ly, opts#0, max#0) } GetOpt.__default.GetCommandLen#canCall(opts#0, max#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0) ==> LitInt(0) <= GetOpt.__default.GetCommandLen($ly, opts#0, max#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetCommandLen($LS($ly), opts#0, max#0) } GetOpt.__default.GetCommandLen#canCall(opts#0, max#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0) ==> (Seq#Length(opts#0) != LitInt(0) ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))) && (var x#0 := (if GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) then Seq#Length(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))) else 0); (var newMax#0 := (if x#0 > max#0 then x#0 else max#0); GetOpt.__default.GetCommandLen#canCall(Seq#Drop(opts#0, LitInt(1)), newMax#0)))) && GetOpt.__default.GetCommandLen($LS($ly), opts#0, max#0) == (if Seq#Length(opts#0) == LitInt(0) then max#0 else (var x#0 := (if GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) then Seq#Length(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))) else 0); (var newMax#0 := (if x#0 > max#0 then x#0 else max#0); GetOpt.__default.GetCommandLen($ly, Seq#Drop(opts#0, LitInt(1)), newMax#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, max#0: int :: {:weight 3} { GetOpt.__default.GetCommandLen($LS($ly), Lit(opts#0), LitInt(max#0)) } GetOpt.__default.GetCommandLen#canCall(Lit(opts#0), LitInt(max#0)) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))) && (var x#1 := (if GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) then Seq#Length(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))) else 0); (var newMax#1 := (if x#1 > max#0 then x#1 else max#0); GetOpt.__default.GetCommandLen#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), newMax#1)))) && GetOpt.__default.GetCommandLen($LS($ly), Lit(opts#0), LitInt(max#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then max#0 else (var x#1 := (if GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) then Seq#Length(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))) else 0); (var newMax#1 := (if x#1 > max#0 then x#1 else max#0); GetOpt.__default.GetCommandLen($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), newMax#1)))));
}

function GetOpt.__default.GetCommandLen#canCall(opts#0: Seq, max#0: int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetCommandLen($LS($ly), opts#0, max#0) } GetOpt.__default.GetCommandLen($LS($ly), opts#0, max#0) == GetOpt.__default.GetCommandLen($ly, opts#0, max#0));

axiom (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetCommandLen(AsFuelBottom($ly), opts#0, max#0) } GetOpt.__default.GetCommandLen($ly, opts#0, max#0) == GetOpt.__default.GetCommandLen($LZ, opts#0, max#0));

function GetOpt.__default.GetCommandLen#requires(LayerType, Seq, int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, max#0: int :: { GetOpt.__default.GetCommandLen#requires($ly, opts#0, max#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && LitInt(0) <= max#0 ==> (GetOpt.__default.GetCommandLen#requires($ly, opts#0, max#0) <==> true));

procedure {:verboseName "GetOpt.GetCommandLen (well-formedness)"} CheckWellformed$$GetOpt.__default.GetCommandLen(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), max#0: int where LitInt(0) <= max#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetCommandLen (well-formedness)"} CheckWellformed$$GetOpt.__default.GetCommandLen(opts#0: Seq, max#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#Z#0: int;
  var let#0#0#0: int;
  var newMax#Z#0: int;
  var let#1#0#0: int;
  var ##opts#0: Seq;
  var ##max#0: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetCommandLen", " | ", opts#0, " | ", max#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(491,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume LitInt(0) <= GetOpt.__default.GetCommandLen($LS($LZ), opts#0, max#0);
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.GetCommandLen($LS($LZ), opts#0, max#0) == max#0;
    assume true;
    assume $Is(GetOpt.__default.GetCommandLen($LS($LZ), opts#0, max#0), Tclass._System.nat());
    return;

  anon13_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    havoc x#Z#0;
    assume true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    assume let#0#0#0 == Seq#Length(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)));
    assume GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    assume $Is(let#0#0#0, TInt);
    goto anon8;

  anon14_Else:
    assume {:partition} !GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume let#0#0#0 == LitInt(0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    goto anon8;

  anon8:
    assume x#Z#0 == let#0#0#0;
    havoc newMax#Z#0;
    assume true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} x#Z#0 > max#0;
    assume let#1#0#0 == x#Z#0;
    assume true;
    assume $Is(let#1#0#0, TInt);
    goto anon11;

  anon15_Else:
    assume {:partition} max#0 >= x#Z#0;
    assume let#1#0#0 == max#0;
    assume true;
    assume $Is(let#1#0#0, TInt);
    goto anon11;

  anon11:
    assume newMax#Z#0 == let#1#0#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume $Is(newMax#Z#0, Tclass._System.nat());
    ##max#0 := newMax#Z#0;
    assume $IsAlloc(##max#0, Tclass._System.nat(), $Heap);
    assume 0 <= max#0 || Seq#Rank(##opts#0) < Seq#Rank(opts#0) || ##max#0 == max#0;
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && ##max#0 < max#0);
    assume GetOpt.__default.GetCommandLen#canCall(Seq#Drop(opts#0, LitInt(1)), newMax#Z#0);
    assume GetOpt.__default.GetCommandLen($LS($LZ), opts#0, max#0) == GetOpt.__default.GetCommandLen($LS($LZ), Seq#Drop(opts#0, LitInt(1)), newMax#Z#0);
    assume GetOpt.__default.GetCommandLen#canCall(Seq#Drop(opts#0, LitInt(1)), newMax#Z#0);
    assume $Is(GetOpt.__default.GetCommandLen($LS($LZ), opts#0, max#0), Tclass._System.nat());
    return;
}



function GetOpt.__default.AddShortAlias($ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map :: { GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) } GetOpt.__default.AddShortAlias#canCall(aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) || (2 < $FunctionContextHeight && $Is(aliases#0, TSeq(TChar)) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(name#0, TSeq(TChar)) && $Is(origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(origAliases#0, TSeq(TChar)) && $Is(origShortMap#0, TMap(TChar, TSeq(TChar))) && Map#Domain(origLongMap#0)[$Box(name#0)] && (forall x#0: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(shortMap#0)[$Box(x#0)] ==> Map#Domain(origLongMap#0)[Map#Elements(shortMap#0)[$Box(x#0)]]) && (forall k#0: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#0)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#0)]): Seq } { Map#Domain(shortMap#0)[$Box(k#0)] } { Map#Domain(origShortMap#0)[$Box(k#0)] } $Is(k#0, TChar) && Map#Domain(origShortMap#0)[$Box(k#0)] ==> Map#Domain(shortMap#0)[$Box(k#0)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#0)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#0)]): Seq)) && (forall k#1: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(k#1)]): Seq } { Map#Domain(shortMap#0)[$Box(k#1)] } { Seq#Contains(aliases#0, $Box(k#1)) } { Seq#Contains(origAliases#0, $Box(k#1)) } $Is(k#1, TChar) && Seq#Contains(origAliases#0, $Box(k#1)) ==> (Seq#Contains(aliases#0, $Box(k#1)) || Map#Domain(shortMap#0)[$Box(k#1)]) && (Seq#Contains(aliases#0, $Box(k#1)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#1)]): Seq, name#0))) && (forall k#2: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#2)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#2)]): Seq } { Map#Domain(origShortMap#0)[$Box(k#2)] } { Map#Domain(shortMap#0)[$Box(k#2)] } $Is(k#2, TChar) && Map#Domain(shortMap#0)[$Box(k#2)] ==> (Map#Domain(origShortMap#0)[$Box(k#2)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#2)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#2)]): Seq)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#2)]): Seq, name#0))) ==> (Wrappers.Result.Success_q(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0)) ==> (forall k#3: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#3)]): Seq } { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#3)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#3)] } { Map#Domain(origShortMap#0)[$Box(k#3)] } $Is(k#3, TChar) && Map#Domain(origShortMap#0)[$Box(k#3)] ==> Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#3)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#3)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#3)]): Seq)) && (forall k#4: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#4)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#4)] } { Seq#Contains(origAliases#0, $Box(k#4)) } $Is(k#4, TChar) && Seq#Contains(origAliases#0, $Box(k#4)) ==> Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#4)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(k#4)]): Seq, name#0)) && (forall x#1: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(x#1)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(x#1)] ==> Map#Domain(origLongMap#0)[Map#Elements($Unbox(Wrappers.Result.value(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0))): Map)[$Box(x#1)]])) && $Is(GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map :: { GetOpt.__default.AddShortAlias($LS($ly), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) } GetOpt.__default.AddShortAlias#canCall(aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) || (2 < $FunctionContextHeight && $Is(aliases#0, TSeq(TChar)) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(name#0, TSeq(TChar)) && $Is(origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(origAliases#0, TSeq(TChar)) && $Is(origShortMap#0, TMap(TChar, TSeq(TChar))) && Map#Domain(origLongMap#0)[$Box(name#0)] && (forall x#2: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#2)]): Seq } { Map#Domain(shortMap#0)[$Box(x#2)] } $Is(x#2, TChar) && Map#Domain(shortMap#0)[$Box(x#2)] ==> Map#Domain(origLongMap#0)[Map#Elements(shortMap#0)[$Box(x#2)]]) && (forall k#5: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#5)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#5)]): Seq } { Map#Domain(shortMap#0)[$Box(k#5)] } { Map#Domain(origShortMap#0)[$Box(k#5)] } $Is(k#5, TChar) && Map#Domain(origShortMap#0)[$Box(k#5)] ==> Map#Domain(shortMap#0)[$Box(k#5)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#5)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#5)]): Seq)) && (forall k#6: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(k#6)]): Seq } { Map#Domain(shortMap#0)[$Box(k#6)] } { Seq#Contains(aliases#0, $Box(k#6)) } { Seq#Contains(origAliases#0, $Box(k#6)) } $Is(k#6, TChar) && Seq#Contains(origAliases#0, $Box(k#6)) ==> (Seq#Contains(aliases#0, $Box(k#6)) || Map#Domain(shortMap#0)[$Box(k#6)]) && (Seq#Contains(aliases#0, $Box(k#6)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#6)]): Seq, name#0))) && (forall k#7: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#7)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#7)]): Seq } { Map#Domain(origShortMap#0)[$Box(k#7)] } { Map#Domain(shortMap#0)[$Box(k#7)] } $Is(k#7, TChar) && Map#Domain(shortMap#0)[$Box(k#7)] ==> (Map#Domain(origShortMap#0)[$Box(k#7)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#7)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#7)]): Seq)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#7)]): Seq, name#0))) ==> (Seq#Length(aliases#0) != LitInt(0) ==> !Map#Domain(shortMap#0)[Seq#Index(aliases#0, LitInt(0))] ==> GetOpt.__default.AddShortAlias#canCall(Seq#Drop(aliases#0, LitInt(1)), Map#Build(shortMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(name#0)), name#0, origLongMap#0, origAliases#0, origShortMap#0)) && GetOpt.__default.AddShortAlias($LS($ly), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == (if Seq#Length(aliases#0) == LitInt(0) then #Wrappers.Result.Success($Box(shortMap#0)) else (if Map#Domain(shortMap#0)[Seq#Index(aliases#0, LitInt(0))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Drop(Seq#Take(aliases#0, LitInt(1)), LitInt(0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), name#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(46)))))) else GetOpt.__default.AddShortAlias($ly, Seq#Drop(aliases#0, LitInt(1)), Map#Build(shortMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(name#0)), name#0, origLongMap#0, origAliases#0, origShortMap#0))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map :: {:weight 3} { GetOpt.__default.AddShortAlias($LS($ly), Lit(aliases#0), Lit(shortMap#0), Lit(name#0), Lit(origLongMap#0), Lit(origAliases#0), Lit(origShortMap#0)) } GetOpt.__default.AddShortAlias#canCall(Lit(aliases#0), Lit(shortMap#0), Lit(name#0), Lit(origLongMap#0), Lit(origAliases#0), Lit(origShortMap#0)) || (2 < $FunctionContextHeight && $Is(aliases#0, TSeq(TChar)) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(name#0, TSeq(TChar)) && $Is(origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(origAliases#0, TSeq(TChar)) && $Is(origShortMap#0, TMap(TChar, TSeq(TChar))) && Map#Domain(origLongMap#0)[$Box(name#0)] && (forall x#3: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#3)]): Seq } { Map#Domain(shortMap#0)[$Box(x#3)] } $Is(x#3, TChar) && Map#Domain(shortMap#0)[$Box(x#3)] ==> Map#Domain(origLongMap#0)[Map#Elements(Lit(shortMap#0))[$Box(x#3)]]) && (forall k#8: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#8)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#8)]): Seq } { Map#Domain(shortMap#0)[$Box(k#8)] } { Map#Domain(origShortMap#0)[$Box(k#8)] } $Is(k#8, TChar) && Map#Domain(origShortMap#0)[$Box(k#8)] ==> Map#Domain(shortMap#0)[$Box(k#8)] && Seq#Equal($Unbox(Map#Elements(Lit(shortMap#0))[$Box(k#8)]): Seq, $Unbox(Map#Elements(Lit(origShortMap#0))[$Box(k#8)]): Seq)) && (forall k#9: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(k#9)]): Seq } { Map#Domain(shortMap#0)[$Box(k#9)] } { Seq#Contains(aliases#0, $Box(k#9)) } { Seq#Contains(origAliases#0, $Box(k#9)) } $Is(k#9, TChar) && Seq#Contains(origAliases#0, $Box(k#9)) ==> (Seq#Contains(aliases#0, $Box(k#9)) || Map#Domain(shortMap#0)[$Box(k#9)]) && (Seq#Contains(aliases#0, $Box(k#9)) || Seq#Equal($Unbox(Map#Elements(Lit(shortMap#0))[$Box(k#9)]): Seq, name#0))) && (forall k#10: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#10)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#10)]): Seq } { Map#Domain(origShortMap#0)[$Box(k#10)] } { Map#Domain(shortMap#0)[$Box(k#10)] } $Is(k#10, TChar) && Map#Domain(shortMap#0)[$Box(k#10)] ==> (Map#Domain(origShortMap#0)[$Box(k#10)] && Seq#Equal($Unbox(Map#Elements(Lit(shortMap#0))[$Box(k#10)]): Seq, $Unbox(Map#Elements(Lit(origShortMap#0))[$Box(k#10)]): Seq)) || Seq#Equal($Unbox(Map#Elements(Lit(shortMap#0))[$Box(k#10)]): Seq, name#0))) ==> (Seq#Length(Lit(aliases#0)) != LitInt(0) ==> !Map#Domain(shortMap#0)[Seq#Index(Lit(aliases#0), LitInt(0))] ==> GetOpt.__default.AddShortAlias#canCall(Lit(Seq#Drop(Lit(aliases#0), LitInt(1))), Map#Build(Lit(shortMap#0), Seq#Index(Lit(aliases#0), LitInt(0)), $Box(Lit(name#0))), Lit(name#0), Lit(origLongMap#0), Lit(origAliases#0), Lit(origShortMap#0))) && GetOpt.__default.AddShortAlias($LS($ly), Lit(aliases#0), Lit(shortMap#0), Lit(name#0), Lit(origLongMap#0), Lit(origAliases#0), Lit(origShortMap#0)) == (if Seq#Length(Lit(aliases#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(shortMap#0))) else (if Map#Domain(shortMap#0)[Seq#Index(Lit(aliases#0), LitInt(0))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Drop(Seq#Take(Lit(aliases#0), LitInt(1)), LitInt(0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), name#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(46)))))) else GetOpt.__default.AddShortAlias($LS($ly), Lit(Seq#Drop(Lit(aliases#0), LitInt(1))), Map#Build(Lit(shortMap#0), Seq#Index(Lit(aliases#0), LitInt(0)), $Box(Lit(name#0))), Lit(name#0), Lit(origLongMap#0), Lit(origAliases#0), Lit(origShortMap#0)))));
}

function GetOpt.__default.AddShortAlias#canCall(aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map) : bool;

axiom (forall $ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map :: { GetOpt.__default.AddShortAlias($LS($ly), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) } GetOpt.__default.AddShortAlias($LS($ly), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0));

axiom (forall $ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map :: { GetOpt.__default.AddShortAlias(AsFuelBottom($ly), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) } GetOpt.__default.AddShortAlias($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == GetOpt.__default.AddShortAlias($LZ, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0));

function GetOpt.__default.AddShortAlias#requires(LayerType, Seq, Map, Seq, Map, Seq, Map) : bool;

axiom (forall $ly: LayerType, aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map :: { GetOpt.__default.AddShortAlias#requires($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) } $Is(aliases#0, TSeq(TChar)) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(name#0, TSeq(TChar)) && $Is(origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(origAliases#0, TSeq(TChar)) && $Is(origShortMap#0, TMap(TChar, TSeq(TChar))) ==> (GetOpt.__default.AddShortAlias#requires($ly, aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) <==> Map#Domain(origLongMap#0)[$Box(name#0)] && (forall x#2: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#2)]): Seq } { Map#Domain(shortMap#0)[$Box(x#2)] } $Is(x#2, TChar) && Map#Domain(shortMap#0)[$Box(x#2)] ==> Map#Domain(origLongMap#0)[Map#Elements(shortMap#0)[$Box(x#2)]]) && (forall k#5: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#5)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#5)]): Seq } { Map#Domain(shortMap#0)[$Box(k#5)] } { Map#Domain(origShortMap#0)[$Box(k#5)] } $Is(k#5, TChar) && Map#Domain(origShortMap#0)[$Box(k#5)] ==> Map#Domain(shortMap#0)[$Box(k#5)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#5)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#5)]): Seq)) && (forall k#6: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(k#6)]): Seq } { Map#Domain(shortMap#0)[$Box(k#6)] } { Seq#Contains(aliases#0, $Box(k#6)) } { Seq#Contains(origAliases#0, $Box(k#6)) } $Is(k#6, TChar) && Seq#Contains(origAliases#0, $Box(k#6)) ==> (Seq#Contains(aliases#0, $Box(k#6)) || Map#Domain(shortMap#0)[$Box(k#6)]) && (Seq#Contains(aliases#0, $Box(k#6)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#6)]): Seq, name#0))) && (forall k#7: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#7)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#7)]): Seq } { Map#Domain(origShortMap#0)[$Box(k#7)] } { Map#Domain(shortMap#0)[$Box(k#7)] } $Is(k#7, TChar) && Map#Domain(shortMap#0)[$Box(k#7)] ==> (Map#Domain(origShortMap#0)[$Box(k#7)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#7)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#7)]): Seq)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#7)]): Seq, name#0))));

procedure {:verboseName "GetOpt.AddShortAlias (well-formedness)"} CheckWellformed$$GetOpt.__default.AddShortAlias(aliases#0: Seq where $Is(aliases#0, TSeq(TChar)), shortMap#0: Map where $Is(shortMap#0, TMap(TChar, TSeq(TChar))), name#0: Seq where $Is(name#0, TSeq(TChar)), origLongMap#0: Map where $Is(origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())), origAliases#0: Seq where $Is(origAliases#0, TSeq(TChar)), origShortMap#0: Map where $Is(origShortMap#0, TMap(TChar, TSeq(TChar)))) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16821"} Wrappers.Result.Success_q(ret#0) ==> (forall k#11: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#11)]): Seq } { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)] } { Map#Domain(origShortMap#0)[$Box(k#11)] } $Is(k#11, TChar) && Map#Domain(origShortMap#0)[$Box(k#11)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#11)]): Seq));
  free ensures {:id "id16822"} Wrappers.Result.Success_q(ret#0) ==> (forall k#12: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)] } { Seq#Contains(origAliases#0, $Box(k#12)) } $Is(k#12, TChar) && Seq#Contains(origAliases#0, $Box(k#12)) ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)]): Seq, name#0));
  free ensures {:id "id16823"} Wrappers.Result.Success_q(ret#0) ==> (forall x#4: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)] ==> Map#Domain(origLongMap#0)[Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)]]);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.AddShortAlias (well-formedness)"} CheckWellformed$$GetOpt.__default.AddShortAlias(aliases#0: Seq, shortMap#0: Map, name#0: Seq, origLongMap#0: Map, origAliases#0: Seq, origShortMap#0: Map) returns (ret#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#5: char;
  var k#13: char;
  var k#14: char;
  var k#15: char;
  var k#16: char;
  var k#17: char;
  var x#6: char;
  var ##aliases#0: Seq;
  var ##shortMap#0: Map;
  var ##name#0: Seq;
  var ##origLongMap#0: Map;
  var ##origAliases#0: Seq;
  var ##origShortMap#0: Map;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.AddShortAlias", " | ", aliases#0, " | ", shortMap#0, " | ", name#0, " | ", origLongMap#0, " | ", origAliases#0, " | ", origShortMap#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map", " | ", "Seq", " | ", "Map", " | ", "Seq", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(501,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume true;
    assume Map#Domain(origLongMap#0)[$Box(name#0)];
    havoc x#5;
    assume $Is(x#5, TChar);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume Map#Domain(shortMap#0)[$Box(x#5)];
    assume Map#Domain(shortMap#0)[$Box(x#5)];
    assume Map#Domain(origLongMap#0)[Map#Elements(shortMap#0)[$Box(x#5)]];
    goto anon4;

  anon43_Else:
    assume Map#Domain(shortMap#0)[$Box(x#5)] ==> Map#Domain(origLongMap#0)[Map#Elements(shortMap#0)[$Box(x#5)]];
    goto anon4;

  anon4:
    assume (forall x#0: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(shortMap#0)[$Box(x#0)] ==> Map#Domain(origLongMap#0)[Map#Elements(shortMap#0)[$Box(x#0)]]);
    havoc k#13;
    assume $Is(k#13, TChar);
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume Map#Domain(origShortMap#0)[$Box(k#13)];
    assume Map#Domain(shortMap#0)[$Box(k#13)];
    assume Map#Domain(shortMap#0)[$Box(k#13)];
    assume Map#Domain(origShortMap#0)[$Box(k#13)];
    assume Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#13)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#13)]): Seq);
    goto anon7;

  anon44_Else:
    assume Map#Domain(origShortMap#0)[$Box(k#13)] ==> Map#Domain(shortMap#0)[$Box(k#13)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#13)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#13)]): Seq);
    goto anon7;

  anon7:
    assume (forall k#0: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#0)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#0)]): Seq } { Map#Domain(shortMap#0)[$Box(k#0)] } { Map#Domain(origShortMap#0)[$Box(k#0)] } $Is(k#0, TChar) && Map#Domain(origShortMap#0)[$Box(k#0)] ==> Map#Domain(shortMap#0)[$Box(k#0)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#0)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#0)]): Seq));
    havoc k#14;
    assume $Is(k#14, TChar);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume Seq#Contains(origAliases#0, $Box(k#14));
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume Seq#Contains(aliases#0, $Box(k#14));
    goto anon14;

  anon46_Else:
    assume !Seq#Contains(aliases#0, $Box(k#14));
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} Map#Domain(shortMap#0)[$Box(k#14)];
    assume Map#Domain(shortMap#0)[$Box(k#14)];
    goto anon12;

  anon47_Else:
    assume {:partition} !Map#Domain(shortMap#0)[$Box(k#14)];
    goto anon12;

  anon12:
    assume Map#Domain(shortMap#0)[$Box(k#14)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#14)]): Seq, name#0);
    goto anon14;

  anon45_Else:
    assume Seq#Contains(origAliases#0, $Box(k#14)) ==> Seq#Contains(aliases#0, $Box(k#14)) || (Map#Domain(shortMap#0)[$Box(k#14)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#14)]): Seq, name#0));
    goto anon14;

  anon14:
    assume (forall k#1: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(k#1)]): Seq } { Map#Domain(shortMap#0)[$Box(k#1)] } { Seq#Contains(aliases#0, $Box(k#1)) } { Seq#Contains(origAliases#0, $Box(k#1)) } $Is(k#1, TChar) && Seq#Contains(origAliases#0, $Box(k#1)) ==> (Seq#Contains(aliases#0, $Box(k#1)) || Map#Domain(shortMap#0)[$Box(k#1)]) && (Seq#Contains(aliases#0, $Box(k#1)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#1)]): Seq, name#0)));
    havoc k#15;
    assume $Is(k#15, TChar);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume Map#Domain(shortMap#0)[$Box(k#15)];
    goto anon49_Then, anon49_Else;

  anon49_Then:
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} Map#Domain(origShortMap#0)[$Box(k#15)];
    assume Map#Domain(shortMap#0)[$Box(k#15)];
    assume Map#Domain(origShortMap#0)[$Box(k#15)];
    goto anon18;

  anon50_Else:
    assume {:partition} !Map#Domain(origShortMap#0)[$Box(k#15)];
    goto anon18;

  anon18:
    assume Map#Domain(origShortMap#0)[$Box(k#15)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#15)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#15)]): Seq);
    goto anon21;

  anon49_Else:
    assume !(Map#Domain(origShortMap#0)[$Box(k#15)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#15)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#15)]): Seq));
    assume Map#Domain(shortMap#0)[$Box(k#15)];
    assume Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#15)]): Seq, name#0);
    goto anon21;

  anon48_Else:
    assume Map#Domain(shortMap#0)[$Box(k#15)] ==> (Map#Domain(origShortMap#0)[$Box(k#15)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#15)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#15)]): Seq)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#15)]): Seq, name#0);
    goto anon21;

  anon21:
    assume (forall k#2: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#2)]): Seq } { $Unbox(Map#Elements(shortMap#0)[$Box(k#2)]): Seq } { Map#Domain(origShortMap#0)[$Box(k#2)] } { Map#Domain(shortMap#0)[$Box(k#2)] } $Is(k#2, TChar) && Map#Domain(shortMap#0)[$Box(k#2)] ==> (Map#Domain(origShortMap#0)[$Box(k#2)] && Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#2)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#2)]): Seq)) || Seq#Equal($Unbox(Map#Elements(shortMap#0)[$Box(k#2)]): Seq, name#0));
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume $Is(GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)));
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume Wrappers.Result.Success_q(ret#0);
    havoc k#16;
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume {:partition} $Is(k#16, TChar);
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume {:partition} Map#Domain(origShortMap#0)[$Box(k#16)];
    assume Wrappers.Result.Success_q(ret#0);
    goto anon55_Then, anon55_Else;

  anon55_Then:
    assume {:partition} Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#16)];
    assume Wrappers.Result.Success_q(ret#0);
    assume Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#16)];
    assume Map#Domain(origShortMap#0)[$Box(k#16)];
    goto anon27;

  anon55_Else:
    assume {:partition} !Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#16)];
    goto anon27;

  anon54_Else:
    assume {:partition} !Map#Domain(origShortMap#0)[$Box(k#16)];
    goto anon27;

  anon53_Else:
    assume {:partition} !$Is(k#16, TChar);
    goto anon27;

  anon27:
    assume (forall k#11: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#11)]): Seq } { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)] } { Map#Domain(origShortMap#0)[$Box(k#11)] } $Is(k#11, TChar) && Map#Domain(origShortMap#0)[$Box(k#11)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#11)]): Seq));
    havoc k#17;
    goto anon56_Then, anon56_Else;

  anon56_Then:
    assume {:partition} $Is(k#17, TChar);
    goto anon57_Then, anon57_Else;

  anon57_Then:
    assume {:partition} Seq#Contains(origAliases#0, $Box(k#17));
    assume Wrappers.Result.Success_q(ret#0);
    goto anon58_Then, anon58_Else;

  anon58_Then:
    assume {:partition} Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#17)];
    assume Wrappers.Result.Success_q(ret#0);
    assume Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#17)];
    goto anon31;

  anon58_Else:
    assume {:partition} !Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#17)];
    goto anon31;

  anon57_Else:
    assume {:partition} !Seq#Contains(origAliases#0, $Box(k#17));
    goto anon31;

  anon56_Else:
    assume {:partition} !$Is(k#17, TChar);
    goto anon31;

  anon31:
    assume (forall k#12: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)] } { Seq#Contains(origAliases#0, $Box(k#12)) } $Is(k#12, TChar) && Seq#Contains(origAliases#0, $Box(k#12)) ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)]): Seq, name#0));
    havoc x#6;
    goto anon59_Then, anon59_Else;

  anon59_Then:
    assume {:partition} $Is(x#6, TChar);
    assume Wrappers.Result.Success_q(ret#0);
    goto anon60_Then, anon60_Else;

  anon60_Then:
    assume {:partition} Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#6)];
    assume Wrappers.Result.Success_q(ret#0);
    assume Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#6)];
    goto anon34;

  anon60_Else:
    assume {:partition} !Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#6)];
    goto anon34;

  anon59_Else:
    assume {:partition} !$Is(x#6, TChar);
    goto anon34;

  anon34:
    assume (forall x#4: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)] ==> Map#Domain(origLongMap#0)[Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)]]);
    goto anon36;

  anon52_Else:
    assume Wrappers.Result.Success_q(ret#0) ==> (forall k#11: char :: { $Unbox(Map#Elements(origShortMap#0)[$Box(k#11)]): Seq } { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)] } { Map#Domain(origShortMap#0)[$Box(k#11)] } $Is(k#11, TChar) && Map#Domain(origShortMap#0)[$Box(k#11)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#11)]): Seq, $Unbox(Map#Elements(origShortMap#0)[$Box(k#11)]): Seq)) && (forall k#12: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)] } { Seq#Contains(origAliases#0, $Box(k#12)) } $Is(k#12, TChar) && Seq#Contains(origAliases#0, $Box(k#12)) ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)] && Seq#Equal($Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#12)]): Seq, name#0)) && (forall x#4: char :: { $Unbox(Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)]): Seq } { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)] ==> Map#Domain(origLongMap#0)[Map#Elements($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(x#4)]]);
    goto anon36;

  anon36:
    assume false;
    return;

  anon51_Else:
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume {:partition} Seq#Length(aliases#0) == LitInt(0);
    assume GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == #Wrappers.Result.Success($Box(shortMap#0));
    assume true;
    assume $Is(GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)));
    goto anon42;

  anon61_Else:
    assume {:partition} Seq#Length(aliases#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(aliases#0);
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume {:partition} Map#Domain(shortMap#0)[Seq#Index(aliases#0, LitInt(0))];
    assume 0 <= LitInt(0) && LitInt(0) <= Seq#Length(aliases#0);
    assume LitInt(0) <= LitInt(1) && LitInt(1) <= Seq#Length(aliases#0);
    assume GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Drop(Seq#Take(aliases#0, LitInt(1)), LitInt(0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), name#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)));
    goto anon42;

  anon62_Else:
    assume {:partition} !Map#Domain(shortMap#0)[Seq#Index(aliases#0, LitInt(0))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(aliases#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(aliases#0);
    ##aliases#0 := Seq#Drop(aliases#0, LitInt(1));
    assume $IsAlloc(##aliases#0, TSeq(TChar), $Heap);
    ##shortMap#0 := Map#Build(shortMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(name#0));
    assume $IsAlloc(##shortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    ##name#0 := name#0;
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    ##origLongMap#0 := origLongMap#0;
    assume $IsAlloc(##origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##origAliases#0 := origAliases#0;
    assume $IsAlloc(##origAliases#0, TSeq(TChar), $Heap);
    ##origShortMap#0 := origShortMap#0;
    assume $IsAlloc(##origShortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    assume {:subsumption 0} Map#Domain(##origLongMap#0)[$Box(##name#0)];
    assume Map#Domain(##origLongMap#0)[$Box(##name#0)];
    assume {:subsumption 0} (forall x#7: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#7)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#7)] } $Is(x#7, TChar) && Map#Domain(##shortMap#0)[$Box(x#7)] ==> Map#Domain(##origLongMap#0)[Map#Elements(##shortMap#0)[$Box(x#7)]]);
    assume (forall x#7: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#7)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#7)] } $Is(x#7, TChar) && Map#Domain(##shortMap#0)[$Box(x#7)] ==> Map#Domain(##origLongMap#0)[Map#Elements(##shortMap#0)[$Box(x#7)]]);
    assume {:subsumption 0} (forall k#18: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#18)]): Seq } { $Unbox(Map#Elements(##shortMap#0)[$Box(k#18)]): Seq } { Map#Domain(##shortMap#0)[$Box(k#18)] } { Map#Domain(##origShortMap#0)[$Box(k#18)] } $Is(k#18, TChar) && Map#Domain(##origShortMap#0)[$Box(k#18)] ==> Map#Domain(##shortMap#0)[$Box(k#18)] && Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#18)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#18)]): Seq));
    assume (forall k#18: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#18)]): Seq } { $Unbox(Map#Elements(##shortMap#0)[$Box(k#18)]): Seq } { Map#Domain(##shortMap#0)[$Box(k#18)] } { Map#Domain(##origShortMap#0)[$Box(k#18)] } $Is(k#18, TChar) && Map#Domain(##origShortMap#0)[$Box(k#18)] ==> Map#Domain(##shortMap#0)[$Box(k#18)] && Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#18)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#18)]): Seq));
    assume {:subsumption 0} (forall k#19: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(k#19)]): Seq } { Map#Domain(##shortMap#0)[$Box(k#19)] } { Seq#Contains(##aliases#0, $Box(k#19)) } { Seq#Contains(##origAliases#0, $Box(k#19)) } $Is(k#19, TChar) && Seq#Contains(##origAliases#0, $Box(k#19)) ==> (Seq#Contains(##aliases#0, $Box(k#19)) || Map#Domain(##shortMap#0)[$Box(k#19)]) && (Seq#Contains(##aliases#0, $Box(k#19)) || Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#19)]): Seq, ##name#0)));
    assume (forall k#19: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(k#19)]): Seq } { Map#Domain(##shortMap#0)[$Box(k#19)] } { Seq#Contains(##aliases#0, $Box(k#19)) } { Seq#Contains(##origAliases#0, $Box(k#19)) } $Is(k#19, TChar) && Seq#Contains(##origAliases#0, $Box(k#19)) ==> (Seq#Contains(##aliases#0, $Box(k#19)) || Map#Domain(##shortMap#0)[$Box(k#19)]) && (Seq#Contains(##aliases#0, $Box(k#19)) || Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#19)]): Seq, ##name#0)));
    assume {:subsumption 0} (forall k#20: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#20)]): Seq } { $Unbox(Map#Elements(##shortMap#0)[$Box(k#20)]): Seq } { Map#Domain(##origShortMap#0)[$Box(k#20)] } { Map#Domain(##shortMap#0)[$Box(k#20)] } $Is(k#20, TChar) && Map#Domain(##shortMap#0)[$Box(k#20)] ==> (Map#Domain(##origShortMap#0)[$Box(k#20)] && Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#20)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#20)]): Seq)) || Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#20)]): Seq, ##name#0));
    assume (forall k#20: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#20)]): Seq } { $Unbox(Map#Elements(##shortMap#0)[$Box(k#20)]): Seq } { Map#Domain(##origShortMap#0)[$Box(k#20)] } { Map#Domain(##shortMap#0)[$Box(k#20)] } $Is(k#20, TChar) && Map#Domain(##shortMap#0)[$Box(k#20)] ==> (Map#Domain(##origShortMap#0)[$Box(k#20)] && Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#20)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#20)]): Seq)) || Seq#Equal($Unbox(Map#Elements(##shortMap#0)[$Box(k#20)]): Seq, ##name#0));
    assume Seq#Rank(##aliases#0) < Seq#Rank(aliases#0) || (Seq#Rank(##aliases#0) == Seq#Rank(aliases#0) && ((Set#Subset(Map#Domain(##shortMap#0), Map#Domain(shortMap#0)) && !Set#Subset(Map#Domain(shortMap#0), Map#Domain(##shortMap#0))) || (Set#Equal(Map#Domain(##shortMap#0), Map#Domain(shortMap#0)) && (Seq#Rank(##name#0) < Seq#Rank(name#0) || (Seq#Rank(##name#0) == Seq#Rank(name#0) && ((Set#Subset(Map#Domain(##origLongMap#0), Map#Domain(origLongMap#0)) && !Set#Subset(Map#Domain(origLongMap#0), Map#Domain(##origLongMap#0))) || (Set#Equal(Map#Domain(##origLongMap#0), Map#Domain(origLongMap#0)) && (Seq#Rank(##origAliases#0) < Seq#Rank(origAliases#0) || (Seq#Rank(##origAliases#0) == Seq#Rank(origAliases#0) && Set#Subset(Map#Domain(##origShortMap#0), Map#Domain(origShortMap#0)) && !Set#Subset(Map#Domain(origShortMap#0), Map#Domain(##origShortMap#0)))))))))));
    assume GetOpt.__default.AddShortAlias#canCall(Seq#Drop(aliases#0, LitInt(1)), Map#Build(shortMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(name#0)), name#0, origLongMap#0, origAliases#0, origShortMap#0);
    assume GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == GetOpt.__default.AddShortAlias($LS($LZ), Seq#Drop(aliases#0, LitInt(1)), Map#Build(shortMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(name#0)), name#0, origLongMap#0, origAliases#0, origShortMap#0);
    assume GetOpt.__default.AddShortAlias#canCall(Seq#Drop(aliases#0, LitInt(1)), Map#Build(shortMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(name#0)), name#0, origLongMap#0, origAliases#0, origShortMap#0);
    assume $Is(GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)));
    goto anon42;

  anon42:
    assume GetOpt.__default.AddShortAlias($LS($LZ), aliases#0, shortMap#0, name#0, origLongMap#0, origAliases#0, origShortMap#0) == ret#0;
    return;
}



function GetOpt.__default.AddLongAlias($ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType :: { GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0) } GetOpt.__default.AddLongAlias#canCall(aliases#0, longMap#0, opt#0) || (2 < $FunctionContextHeight && $Is(aliases#0, TSeq(TSeq(TChar))) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(opt#0, Tclass.GetOpt.Param())) ==> (Wrappers.Result.Success_q(GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0)) ==> (forall k#0: Seq :: { Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0))): Map)[$Box(k#0)] } { Map#Domain(longMap#0)[$Box(k#0)] } $Is(k#0, TSeq(TChar)) && Map#Domain(longMap#0)[$Box(k#0)] ==> Map#Domain($Unbox(Wrappers.Result.value(GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0))): Map)[$Box(k#0)])) && $Is(GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType :: { GetOpt.__default.AddLongAlias($LS($ly), aliases#0, longMap#0, opt#0) } GetOpt.__default.AddLongAlias#canCall(aliases#0, longMap#0, opt#0) || (2 < $FunctionContextHeight && $Is(aliases#0, TSeq(TSeq(TChar))) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(opt#0, Tclass.GetOpt.Param())) ==> (Seq#Length(aliases#0) != LitInt(0) ==> !Map#Domain(longMap#0)[Seq#Index(aliases#0, LitInt(0))] ==> GetOpt.__default.AddLongAlias#canCall(Seq#Drop(aliases#0, LitInt(1)), Map#Build(longMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(opt#0)), opt#0)) && GetOpt.__default.AddLongAlias($LS($ly), aliases#0, longMap#0, opt#0) == (if Seq#Length(aliases#0) == LitInt(0) then #Wrappers.Result.Success($Box(longMap#0)) else (if Map#Domain(longMap#0)[Seq#Index(aliases#0, LitInt(0))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(76))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), $Unbox(Seq#Index(aliases#0, LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(46)))))) else GetOpt.__default.AddLongAlias($ly, Seq#Drop(aliases#0, LitInt(1)), Map#Build(longMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(opt#0)), opt#0))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType :: {:weight 3} { GetOpt.__default.AddLongAlias($LS($ly), Lit(aliases#0), Lit(longMap#0), Lit(opt#0)) } GetOpt.__default.AddLongAlias#canCall(Lit(aliases#0), Lit(longMap#0), Lit(opt#0)) || (2 < $FunctionContextHeight && $Is(aliases#0, TSeq(TSeq(TChar))) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(opt#0, Tclass.GetOpt.Param())) ==> (Seq#Length(Lit(aliases#0)) != LitInt(0) ==> !Map#Domain(longMap#0)[Seq#Index(Lit(aliases#0), LitInt(0))] ==> GetOpt.__default.AddLongAlias#canCall(Lit(Seq#Drop(Lit(aliases#0), LitInt(1))), Map#Build(Lit(longMap#0), Seq#Index(Lit(aliases#0), LitInt(0)), $Box(Lit(opt#0))), Lit(opt#0))) && GetOpt.__default.AddLongAlias($LS($ly), Lit(aliases#0), Lit(longMap#0), Lit(opt#0)) == (if Seq#Length(Lit(aliases#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(longMap#0))) else (if Map#Domain(longMap#0)[Seq#Index(Lit(aliases#0), LitInt(0))] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(76))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), $Unbox(Seq#Index(Lit(aliases#0), LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(46)))))) else GetOpt.__default.AddLongAlias($LS($ly), Lit(Seq#Drop(Lit(aliases#0), LitInt(1))), Map#Build(Lit(longMap#0), Seq#Index(Lit(aliases#0), LitInt(0)), $Box(Lit(opt#0))), Lit(opt#0)))));
}

function GetOpt.__default.AddLongAlias#canCall(aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType :: { GetOpt.__default.AddLongAlias($LS($ly), aliases#0, longMap#0, opt#0) } GetOpt.__default.AddLongAlias($LS($ly), aliases#0, longMap#0, opt#0) == GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0));

axiom (forall $ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType :: { GetOpt.__default.AddLongAlias(AsFuelBottom($ly), aliases#0, longMap#0, opt#0) } GetOpt.__default.AddLongAlias($ly, aliases#0, longMap#0, opt#0) == GetOpt.__default.AddLongAlias($LZ, aliases#0, longMap#0, opt#0));

function GetOpt.__default.AddLongAlias#requires(LayerType, Seq, Map, DatatypeType) : bool;

axiom (forall $ly: LayerType, aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType :: { GetOpt.__default.AddLongAlias#requires($ly, aliases#0, longMap#0, opt#0) } $Is(aliases#0, TSeq(TSeq(TChar))) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(opt#0, Tclass.GetOpt.Param()) ==> (GetOpt.__default.AddLongAlias#requires($ly, aliases#0, longMap#0, opt#0) <==> true));

procedure {:verboseName "GetOpt.AddLongAlias (well-formedness)"} CheckWellformed$$GetOpt.__default.AddLongAlias(aliases#0: Seq where $Is(aliases#0, TSeq(TSeq(TChar))), longMap#0: Map where $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())), opt#0: DatatypeType where $Is(opt#0, Tclass.GetOpt.Param())) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16883"} Wrappers.Result.Success_q(ret#0) ==> (forall k#1: Seq :: { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#1)] } { Map#Domain(longMap#0)[$Box(k#1)] } $Is(k#1, TSeq(TChar)) && Map#Domain(longMap#0)[$Box(k#1)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#1)]);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.AddLongAlias (well-formedness)"} CheckWellformed$$GetOpt.__default.AddLongAlias(aliases#0: Seq, longMap#0: Map, opt#0: DatatypeType) returns (ret#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#2: Seq;
  var ##aliases#0: Seq;
  var ##longMap#0: Map;
  var ##opt#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.AddLongAlias", " | ", aliases#0, " | ", longMap#0, " | ", opt#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(529,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume Wrappers.Result.Success_q(ret#0);
    havoc k#2;
    assume $Is(k#2, TSeq(TChar)) && $IsAlloc(k#2, TSeq(TChar), $Heap);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Map#Domain(longMap#0)[$Box(k#2)];
    assume Wrappers.Result.Success_q(ret#0);
    assume Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#2)];
    goto anon6;

  anon17_Else:
    assume Map#Domain(longMap#0)[$Box(k#2)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#2)];
    goto anon6;

  anon6:
    assume (forall k#1: Seq :: { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#1)] } { Map#Domain(longMap#0)[$Box(k#1)] } $Is(k#1, TSeq(TChar)) && Map#Domain(longMap#0)[$Box(k#1)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#1)]);
    goto anon8;

  anon16_Else:
    assume Wrappers.Result.Success_q(ret#0) ==> (forall k#1: Seq :: { Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#1)] } { Map#Domain(longMap#0)[$Box(k#1)] } $Is(k#1, TSeq(TChar)) && Map#Domain(longMap#0)[$Box(k#1)] ==> Map#Domain($Unbox(Wrappers.Result.value(ret#0)): Map)[$Box(k#1)]);
    goto anon8;

  anon8:
    assume false;
    return;

  anon15_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Seq#Length(aliases#0) == LitInt(0);
    assume GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0) == #Wrappers.Result.Success($Box(longMap#0));
    assume true;
    assume $Is(GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)));
    goto anon14;

  anon18_Else:
    assume {:partition} Seq#Length(aliases#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(aliases#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Map#Domain(longMap#0)[Seq#Index(aliases#0, LitInt(0))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(aliases#0);
    assume GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(76))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), $Unbox(Seq#Index(aliases#0, LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)));
    goto anon14;

  anon19_Else:
    assume {:partition} !Map#Domain(longMap#0)[Seq#Index(aliases#0, LitInt(0))];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(aliases#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(aliases#0);
    ##aliases#0 := Seq#Drop(aliases#0, LitInt(1));
    assume $IsAlloc(##aliases#0, TSeq(TSeq(TChar)), $Heap);
    ##longMap#0 := Map#Build(longMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(opt#0));
    assume $IsAlloc(##longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##opt#0 := opt#0;
    assume $IsAlloc(##opt#0, Tclass.GetOpt.Param(), $Heap);
    assume Seq#Rank(##aliases#0) < Seq#Rank(aliases#0) || (Seq#Rank(##aliases#0) == Seq#Rank(aliases#0) && ((Set#Subset(Map#Domain(##longMap#0), Map#Domain(longMap#0)) && !Set#Subset(Map#Domain(longMap#0), Map#Domain(##longMap#0))) || (Set#Equal(Map#Domain(##longMap#0), Map#Domain(longMap#0)) && DtRank(##opt#0) < DtRank(opt#0))));
    assume GetOpt.__default.AddLongAlias#canCall(Seq#Drop(aliases#0, LitInt(1)), Map#Build(longMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(opt#0)), opt#0);
    assume GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0) == GetOpt.__default.AddLongAlias($LS($LZ), Seq#Drop(aliases#0, LitInt(1)), Map#Build(longMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(opt#0)), opt#0);
    assume GetOpt.__default.AddLongAlias#canCall(Seq#Drop(aliases#0, LitInt(1)), Map#Build(longMap#0, Seq#Index(aliases#0, LitInt(0)), $Box(opt#0)), opt#0);
    assume $Is(GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)));
    goto anon14;

  anon14:
    assume GetOpt.__default.AddLongAlias($LS($LZ), aliases#0, longMap#0, opt#0) == ret#0;
    return;
}



function GetOpt.__default.GetMaps($ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map :: { GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0) } GetOpt.__default.GetMaps#canCall(opts#0, longMap#0, shortMap#0, commandMap#0) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(commandMap#0, Tclass.GetOpt.CommandMap()) && (forall x#0: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(shortMap#0)[$Box(x#0)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#0)]])) ==> (Wrappers.Result.Success_q(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0)) ==> (forall x#1: char :: { $Unbox(Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0))): DatatypeType)): Map)[$Box(x#1)]): Seq } { Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0))): DatatypeType)): Map)[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0))): DatatypeType)): Map)[$Box(x#1)] ==> Map#Domain($Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.value(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0))): DatatypeType)): Map)[Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0))): DatatypeType)): Map)[$Box(x#1)]])) && $Is(GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map :: { GetOpt.__default.GetMaps($LS($ly), opts#0, longMap#0, shortMap#0, commandMap#0) } GetOpt.__default.GetMaps#canCall(opts#0, longMap#0, shortMap#0, commandMap#0) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(commandMap#0, Tclass.GetOpt.CommandMap()) && (forall x#2: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#2)]): Seq } { Map#Domain(shortMap#0)[$Box(x#2)] } $Is(x#2, TChar) && Map#Domain(shortMap#0)[$Box(x#2)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#2)]])) ==> (Seq#Length(opts#0) != LitInt(0) ==> (var opt#0 := $Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType; (GetOpt.Param.Command_q(opt#0) ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#0)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#0))))) && (var valueOrError0#0 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#0)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#0))))); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#0) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#0)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#0)) && GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), longMap#0, shortMap#0, Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#0))), $Box(GetOpt.Param.options(opt#0))))))) && (!GetOpt.Param.Command_q(opt#0) ==> Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#0))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#0)))) && (var valueOrError1#0 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#0))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#0)))); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError1#0) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#0) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#0)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#0) ==> (var newLongMap#0 := Map#Build(longMap#0, $Box(GetOpt.Param.name(opt#0)), $Box(opt#0)); GetOpt.Param.ShortAlias#canCall(opt#0) && GetOpt.Param.ShortAlias#canCall(opt#0) && GetOpt.__default.AddShortAlias#canCall(GetOpt.Param.ShortAlias(opt#0), shortMap#0, GetOpt.Param.name(opt#0), newLongMap#0, GetOpt.Param.ShortAlias(opt#0), shortMap#0) && (var valueOrError2#0 := GetOpt.__default.AddShortAlias($LS($LZ), GetOpt.Param.ShortAlias(opt#0), shortMap#0, GetOpt.Param.name(opt#0), newLongMap#0, GetOpt.Param.ShortAlias(opt#0), shortMap#0); Wrappers.Result.IsFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0) && (Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#0)) && (!Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0) && (var newShortMap#0 := $Unbox(Wrappers.Result.Extract(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0)): Map; GetOpt.Param.LongAlias#canCall(opt#0) && GetOpt.__default.AddLongAlias#canCall(GetOpt.Param.LongAlias(opt#0), newLongMap#0, opt#0) && (var valueOrError3#0 := GetOpt.__default.AddLongAlias($LS($LZ), GetOpt.Param.LongAlias(opt#0), newLongMap#0, opt#0); Wrappers.Result.IsFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0) && (Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0) ==> Wrappers.Result.PropagateFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#0)) && (!Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0) ==> Wrappers.Result.Extract#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0) && (var newLongMap#1 := $Unbox(Wrappers.Result.Extract(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0)): Map; (GetOpt.Param.short(opt#0) != GetOpt.__default.NullChar() ==> (var short#0 := GetOpt.Param.short(opt#0); !Map#Domain(newShortMap#0)[$Box(short#0)] ==> GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#1, $Box(GetOpt.Param.name(opt#0)), $Box(opt#0)), Map#Build(newShortMap#0, $Box(short#0), $Box(GetOpt.Param.name(opt#0))), commandMap#0))) && (GetOpt.Param.short(opt#0) == GetOpt.__default.NullChar() ==> GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#1, $Box(GetOpt.Param.name(opt#0)), $Box(opt#0)), newShortMap#0, commandMap#0)))))))))))))) && GetOpt.__default.GetMaps($LS($ly), opts#0, longMap#0, shortMap#0, commandMap#0) == (if Seq#Length(opts#0) == LitInt(0) then #Wrappers.Result.Success($Box(#_System._tuple#3._#Make3($Box(longMap#0), $Box(shortMap#0), $Box(commandMap#0)))) else (var opt#0 := $Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType; (if GetOpt.Param.Command_q(opt#0) then (var valueOrError0#0 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#0)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#0))))); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#0) else GetOpt.__default.GetMaps($ly, Seq#Drop(opts#0, LitInt(1)), longMap#0, shortMap#0, Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#0))), $Box(GetOpt.Param.options(opt#0)))))) else (var valueOrError1#0 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#0))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#0)))); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#0) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#0) else (var newLongMap#0 := Map#Build(longMap#0, $Box(GetOpt.Param.name(opt#0)), $Box(opt#0)); (var valueOrError2#0 := GetOpt.__default.AddShortAlias($LS($LZ), GetOpt.Param.ShortAlias(opt#0), shortMap#0, GetOpt.Param.name(opt#0), newLongMap#0, GetOpt.Param.ShortAlias(opt#0), shortMap#0); (if Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0) then Wrappers.Result.PropagateFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#0) else (var newShortMap#0 := $Unbox(Wrappers.Result.Extract(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#0)): Map; (var valueOrError3#0 := GetOpt.__default.AddLongAlias($LS($LZ), GetOpt.Param.LongAlias(opt#0), newLongMap#0, opt#0); (if Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0) then Wrappers.Result.PropagateFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#0) else (var newLongMap#1 := $Unbox(Wrappers.Result.Extract(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#0)): Map; (if GetOpt.Param.short(opt#0) != GetOpt.__default.NullChar() then (var short#0 := GetOpt.Param.short(opt#0); (if Map#Domain(newShortMap#0)[$Box(short#0)] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(short#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Param.name(opt#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), $Unbox(Map#Elements(newShortMap#0)[$Box(short#0)]): Seq))) else GetOpt.__default.GetMaps($ly, Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#1, $Box(GetOpt.Param.name(opt#0)), $Box(opt#0)), Map#Build(newShortMap#0, $Box(short#0), $Box(GetOpt.Param.name(opt#0))), commandMap#0))) else GetOpt.__default.GetMaps($ly, Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#1, $Box(GetOpt.Param.name(opt#0)), $Box(opt#0)), newShortMap#0, commandMap#0)))))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map :: {:weight 3} { GetOpt.__default.GetMaps($LS($ly), Lit(opts#0), Lit(longMap#0), Lit(shortMap#0), Lit(commandMap#0)) } GetOpt.__default.GetMaps#canCall(Lit(opts#0), Lit(longMap#0), Lit(shortMap#0), Lit(commandMap#0)) || (3 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(commandMap#0, Tclass.GetOpt.CommandMap()) && (forall x#3: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#3)]): Seq } { Map#Domain(shortMap#0)[$Box(x#3)] } $Is(x#3, TChar) && Map#Domain(shortMap#0)[$Box(x#3)] ==> Map#Domain(longMap#0)[Map#Elements(Lit(shortMap#0))[$Box(x#3)]])) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> (var opt#1 := $Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType; (GetOpt.Param.Command_q(opt#1) ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#1)) && GetOpt.Options.Options_q(GetOpt.Param.options(opt#1)) && Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#1)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#1))))) && (var valueOrError0#1 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#1)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#1))))); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#1) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#1)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) ==> GetOpt.Options.Options_q(GetOpt.Param.options(opt#1)) && GetOpt.__default.GetMaps#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(longMap#0), Lit(shortMap#0), Map#Build(Lit(commandMap#0), $Box(GetOpt.Options.name(GetOpt.Param.options(opt#1))), $Box(GetOpt.Param.options(opt#1))))))) && (!GetOpt.Param.Command_q(opt#1) ==> Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#1))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#1)))) && (var valueOrError1#1 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#1))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#1)))); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError1#1) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#1) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#1)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#1) ==> (var newLongMap#2 := Map#Build(Lit(longMap#0), $Box(GetOpt.Param.name(opt#1)), $Box(opt#1)); GetOpt.Param.ShortAlias#canCall(opt#1) && GetOpt.Param.ShortAlias#canCall(opt#1) && GetOpt.__default.AddShortAlias#canCall(GetOpt.Param.ShortAlias(opt#1), Lit(shortMap#0), GetOpt.Param.name(opt#1), newLongMap#2, GetOpt.Param.ShortAlias(opt#1), Lit(shortMap#0)) && (var valueOrError2#1 := GetOpt.__default.AddShortAlias($LS($LZ), GetOpt.Param.ShortAlias(opt#1), Lit(shortMap#0), GetOpt.Param.name(opt#1), newLongMap#2, GetOpt.Param.ShortAlias(opt#1), Lit(shortMap#0)); Wrappers.Result.IsFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1) && (Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#1)) && (!Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1) && (var newShortMap#1 := $Unbox(Wrappers.Result.Extract(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1)): Map; GetOpt.Param.LongAlias#canCall(opt#1) && GetOpt.__default.AddLongAlias#canCall(GetOpt.Param.LongAlias(opt#1), newLongMap#2, opt#1) && (var valueOrError3#1 := GetOpt.__default.AddLongAlias($LS($LZ), GetOpt.Param.LongAlias(opt#1), newLongMap#2, opt#1); Wrappers.Result.IsFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1) && (Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1) ==> Wrappers.Result.PropagateFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#1)) && (!Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1) ==> Wrappers.Result.Extract#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1) && (var newLongMap#3 := $Unbox(Wrappers.Result.Extract(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1)): Map; (GetOpt.Param.short(opt#1) != GetOpt.__default.NullChar() ==> (var short#1 := GetOpt.Param.short(opt#1); !Map#Domain(newShortMap#1)[$Box(short#1)] ==> GetOpt.__default.GetMaps#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Map#Build(newLongMap#3, $Box(GetOpt.Param.name(opt#1)), $Box(opt#1)), Map#Build(newShortMap#1, $Box(short#1), $Box(GetOpt.Param.name(opt#1))), Lit(commandMap#0)))) && (GetOpt.Param.short(opt#1) == GetOpt.__default.NullChar() ==> GetOpt.__default.GetMaps#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Map#Build(newLongMap#3, $Box(GetOpt.Param.name(opt#1)), $Box(opt#1)), newShortMap#1, Lit(commandMap#0))))))))))))))) && GetOpt.__default.GetMaps($LS($ly), Lit(opts#0), Lit(longMap#0), Lit(shortMap#0), Lit(commandMap#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#_System._tuple#3._#Make3($Box(Lit(longMap#0)), $Box(Lit(shortMap#0)), $Box(Lit(commandMap#0)))))) else (var opt#1 := $Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType; (if GetOpt.Param.Command_q(opt#1) then (var valueOrError0#1 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#1)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#1))))); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#1) else GetOpt.__default.GetMaps($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(longMap#0), Lit(shortMap#0), Map#Build(Lit(commandMap#0), $Box(GetOpt.Options.name(GetOpt.Param.options(opt#1))), $Box(GetOpt.Param.options(opt#1)))))) else (var valueOrError1#1 := Wrappers.__default.Need(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#1))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#1)))); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#1) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#1) else (var newLongMap#2 := Map#Build(Lit(longMap#0), $Box(GetOpt.Param.name(opt#1)), $Box(opt#1)); (var valueOrError2#1 := GetOpt.__default.AddShortAlias($LS($LZ), GetOpt.Param.ShortAlias(opt#1), Lit(shortMap#0), GetOpt.Param.name(opt#1), newLongMap#2, GetOpt.Param.ShortAlias(opt#1), Lit(shortMap#0)); (if Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1) then Wrappers.Result.PropagateFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#1) else (var newShortMap#1 := $Unbox(Wrappers.Result.Extract(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#1)): Map; (var valueOrError3#1 := GetOpt.__default.AddLongAlias($LS($LZ), GetOpt.Param.LongAlias(opt#1), newLongMap#2, opt#1); (if Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1) then Wrappers.Result.PropagateFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#1) else (var newLongMap#3 := $Unbox(Wrappers.Result.Extract(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#1)): Map; (if GetOpt.Param.short(opt#1) != GetOpt.__default.NullChar() then (var short#1 := GetOpt.Param.short(opt#1); (if Map#Domain(newShortMap#1)[$Box(short#1)] then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(short#1))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Param.name(opt#1)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), $Unbox(Map#Elements(newShortMap#1)[$Box(short#1)]): Seq))) else GetOpt.__default.GetMaps($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Map#Build(newLongMap#3, $Box(GetOpt.Param.name(opt#1)), $Box(opt#1)), Map#Build(newShortMap#1, $Box(short#1), $Box(GetOpt.Param.name(opt#1))), Lit(commandMap#0)))) else GetOpt.__default.GetMaps($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Map#Build(newLongMap#3, $Box(GetOpt.Param.name(opt#1)), $Box(opt#1)), newShortMap#1, Lit(commandMap#0))))))))))))))));
}

function GetOpt.__default.GetMaps#canCall(opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map :: { GetOpt.__default.GetMaps($LS($ly), opts#0, longMap#0, shortMap#0, commandMap#0) } GetOpt.__default.GetMaps($LS($ly), opts#0, longMap#0, shortMap#0, commandMap#0) == GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0));

axiom (forall $ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map :: { GetOpt.__default.GetMaps(AsFuelBottom($ly), opts#0, longMap#0, shortMap#0, commandMap#0) } GetOpt.__default.GetMaps($ly, opts#0, longMap#0, shortMap#0, commandMap#0) == GetOpt.__default.GetMaps($LZ, opts#0, longMap#0, shortMap#0, commandMap#0));

function Tclass.GetOpt.CommandMap() : Ty
uses {
axiom Tag(Tclass.GetOpt.CommandMap()) == Tagclass.GetOpt.CommandMap && TagFamily(Tclass.GetOpt.CommandMap()) == tytagFamily$CommandMap;
}

const unique Tagclass.GetOpt.CommandMap: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.CommandMap()) } $IsBox(bx, Tclass.GetOpt.CommandMap()) ==> $Box($Unbox(bx): Map) == bx && $Is($Unbox(bx): Map, Tclass.GetOpt.CommandMap()));

function GetOpt.__default.GetMaps#requires(LayerType, Seq, Map, Map, Map) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map :: { GetOpt.__default.GetMaps#requires($ly, opts#0, longMap#0, shortMap#0, commandMap#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(commandMap#0, Tclass.GetOpt.CommandMap()) ==> (GetOpt.__default.GetMaps#requires($ly, opts#0, longMap#0, shortMap#0, commandMap#0) <==> (forall x#2: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#2)]): Seq } { Map#Domain(shortMap#0)[$Box(x#2)] } $Is(x#2, TChar) && Map#Domain(shortMap#0)[$Box(x#2)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#2)]])));

procedure {:verboseName "GetOpt.GetMaps (well-formedness)"} CheckWellformed$$GetOpt.__default.GetMaps(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), longMap#0: Map where $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())), shortMap#0: Map where $Is(shortMap#0, TMap(TChar, TSeq(TChar))), commandMap#0: Map where $Is(commandMap#0, Tclass.GetOpt.CommandMap())) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id16900"} Wrappers.Result.Success_q(ret#0) ==> (forall x#4: char :: { $Unbox(Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)]): Seq } { Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)] ==> Map#Domain($Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)]]);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetMaps (well-formedness)"} CheckWellformed$$GetOpt.__default.GetMaps(opts#0: Seq, longMap#0: Map, shortMap#0: Map, commandMap#0: Map) returns (ret#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#5: char;
  var x#6: char;
  var opt#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##condition#0: bool;
  var ##error#0: Seq;
  var ##opts#0: Seq;
  var ##longMap#0: Map;
  var ##shortMap#0: Map;
  var ##commandMap#0: Map;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##condition#1: bool;
  var ##error#1: Seq;
  var newLongMap#Z#0: Map;
  var let#3#0#0: Map;
  var valueOrError2#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##aliases#0: Seq;
  var ##shortMap#1: Map;
  var ##name#0: Seq;
  var ##origLongMap#0: Map;
  var ##origAliases#0: Seq;
  var ##origShortMap#0: Map;
  var newShortMap#Z#0: Map;
  var let#5#0#0: Map;
  var valueOrError3#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##aliases#1: Seq;
  var ##longMap#1: Map;
  var ##opt#0: DatatypeType;
  var newLongMap#Z#1: Map;
  var let#7#0#0: Map;
  var short#Z#0: char;
  var let#8#0#0: char;
  var ##opts#1: Seq;
  var ##longMap#2: Map;
  var ##shortMap#2: Map;
  var ##commandMap#1: Map;
  var ##opts#2: Seq;
  var ##longMap#3: Map;
  var ##shortMap#3: Map;
  var ##commandMap#2: Map;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetMaps", " | ", opts#0, " | ", longMap#0, " | ", shortMap#0, " | ", commandMap#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map", " | ", "Map", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(546,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume true;
    assume true;
    assume $Is(Lit(Map#Empty(): Map), Tclass.GetOpt.CommandMap());
    havoc x#5;
    assume $Is(x#5, TChar);
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume Map#Domain(shortMap#0)[$Box(x#5)];
    assume Map#Domain(shortMap#0)[$Box(x#5)];
    assume Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#5)]];
    goto anon4;

  anon30_Else:
    assume Map#Domain(shortMap#0)[$Box(x#5)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#5)]];
    goto anon4;

  anon4:
    assume (forall x#0: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(shortMap#0)[$Box(x#0)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#0)]]);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume Wrappers.Result.Success_q(ret#0);
    havoc x#6;
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} $Is(x#6, TChar);
    assume Wrappers.Result.Success_q(ret#0);
    assume _System.Tuple3.___hMake3_q($Unbox(Wrappers.Result.value(ret#0)): DatatypeType);
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#6)];
    assume Wrappers.Result.Success_q(ret#0);
    assume _System.Tuple3.___hMake3_q($Unbox(Wrappers.Result.value(ret#0)): DatatypeType);
    assume Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#6)];
    assume Wrappers.Result.Success_q(ret#0);
    assume _System.Tuple3.___hMake3_q($Unbox(Wrappers.Result.value(ret#0)): DatatypeType);
    goto anon9;

  anon34_Else:
    assume {:partition} !Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#6)];
    goto anon9;

  anon33_Else:
    assume {:partition} !$Is(x#6, TChar);
    goto anon9;

  anon9:
    assume (forall x#4: char :: { $Unbox(Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)]): Seq } { Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)] ==> Map#Domain($Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)]]);
    goto anon11;

  anon32_Else:
    assume Wrappers.Result.Success_q(ret#0) ==> (forall x#4: char :: { $Unbox(Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)]): Seq } { Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)] ==> Map#Domain($Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[Map#Elements($Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Map)[$Box(x#4)]]);
    goto anon11;

  anon11:
    assume false;
    return;

  anon31_Else:
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == #Wrappers.Result.Success($Box(#_System._tuple#3._#Make3($Box(longMap#0), $Box(shortMap#0), $Box(commandMap#0))));
    assume true;
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon35_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    havoc opt#Z#0;
    assume $Is(opt#Z#0, Tclass.GetOpt.Param()) && $IsAlloc(opt#Z#0, Tclass.GetOpt.Param(), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume let#0#0#0 == $Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType;
    assume true;
    assume $Is(let#0#0#0, Tclass.GetOpt.Param());
    assume opt#Z#0 == let#0#0#0;
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} GetOpt.Param.Command_q(opt#Z#0);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume GetOpt.Param.Command_q(opt#Z#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#Z#0));
    assume GetOpt.Param.Command_q(opt#Z#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#Z#0));
    ##condition#0 := !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))];
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)));
    assume $IsAlloc(##error#0, TSeq(TChar), $Heap);
    assume Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))));
    assume let#1#0#0 == Wrappers.__default.Need(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))));
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#Z#0)) && GetOpt.Options.Options_q(GetOpt.Param.options(opt#Z#0)) && Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(commandMap#0)[$Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Options.name(GetOpt.Param.options(opt#Z#0)))));
    assume $Is(let#1#0#0, Tclass.Wrappers.Outcome(TSeq(TChar)));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#Z#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#Z#0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError0#Z#0);
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon37_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#Z#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume GetOpt.Param.Command_q(opt#Z#0);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#Z#0));
    assume GetOpt.Param.Command_q(opt#Z#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longMap#0 := longMap#0;
    assume $IsAlloc(##longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#0 := shortMap#0;
    assume $IsAlloc(##shortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    assume $Is(Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0))), $Box(GetOpt.Param.options(opt#Z#0))), Tclass.GetOpt.CommandMap());
    ##commandMap#0 := Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0))), $Box(GetOpt.Param.options(opt#Z#0)));
    assume $IsAlloc(##commandMap#0, Tclass.GetOpt.CommandMap(), $Heap);
    assume {:subsumption 0} (forall x#7: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#7)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#7)] } $Is(x#7, TChar) && Map#Domain(##shortMap#0)[$Box(x#7)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#7)]]);
    assume (forall x#7: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#7)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#7)] } $Is(x#7, TChar) && Map#Domain(##shortMap#0)[$Box(x#7)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#7)]]);
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && ((Set#Subset(Map#Domain(##longMap#0), Map#Domain(longMap#0)) && !Set#Subset(Map#Domain(longMap#0), Map#Domain(##longMap#0))) || (Set#Equal(Map#Domain(##longMap#0), Map#Domain(longMap#0)) && ((Set#Subset(Map#Domain(##shortMap#0), Map#Domain(shortMap#0)) && !Set#Subset(Map#Domain(shortMap#0), Map#Domain(##shortMap#0))) || (Set#Equal(Map#Domain(##shortMap#0), Map#Domain(shortMap#0)) && Set#Subset(Map#Domain(##commandMap#0), Map#Domain(commandMap#0)) && !Set#Subset(Map#Domain(commandMap#0), Map#Domain(##commandMap#0)))))));
    assume GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), longMap#0, shortMap#0, Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0))), $Box(GetOpt.Param.options(opt#Z#0))));
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == GetOpt.__default.GetMaps($LS($LZ), Seq#Drop(opts#0, LitInt(1)), longMap#0, shortMap#0, Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0))), $Box(GetOpt.Param.options(opt#Z#0))));
    assume GetOpt.Options.Options_q(GetOpt.Param.options(opt#Z#0)) && GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), longMap#0, shortMap#0, Map#Build(commandMap#0, $Box(GetOpt.Options.name(GetOpt.Param.options(opt#Z#0))), $Box(GetOpt.Param.options(opt#Z#0))));
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon36_Else:
    assume {:partition} !GetOpt.Param.Command_q(opt#Z#0);
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    ##condition#1 := !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#Z#0))];
    assume $IsAlloc(##condition#1, TBool, $Heap);
    ##error#1 := Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#Z#0));
    assume $IsAlloc(##error#1, TSeq(TChar), $Heap);
    assume Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#Z#0))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#Z#0))));
    assume let#2#0#0 == Wrappers.__default.Need(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#Z#0))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#Z#0))));
    assume Wrappers.__default.Need#canCall(TSeq(TChar), !Map#Domain(longMap#0)[$Box(GetOpt.Param.name(opt#Z#0))], $Box(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), GetOpt.Param.name(opt#Z#0))));
    assume $Is(let#2#0#0, Tclass.Wrappers.Outcome(TSeq(TChar)));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError1#Z#0);
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError1#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError1#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#Z#0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError1#Z#0);
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon38_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError1#Z#0);
    havoc newLongMap#Z#0;
    assume $Is(newLongMap#Z#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $IsAlloc(newLongMap#Z#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    assume let#3#0#0 == Map#Build(longMap#0, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0));
    assume true;
    assume $Is(let#3#0#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()));
    assume newLongMap#Z#0 == let#3#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)), $Heap);
    assume $IsAllocBox($Box(opt#Z#0), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.ShortAlias#canCall(opt#Z#0);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    assume $IsAllocBox($Box(opt#Z#0), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.ShortAlias#canCall(opt#Z#0);
    ##aliases#0 := GetOpt.Param.ShortAlias(opt#Z#0);
    assume $IsAlloc(##aliases#0, TSeq(TChar), $Heap);
    ##shortMap#1 := shortMap#0;
    assume $IsAlloc(##shortMap#1, TMap(TChar, TSeq(TChar)), $Heap);
    ##name#0 := GetOpt.Param.name(opt#Z#0);
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    ##origLongMap#0 := newLongMap#Z#0;
    assume $IsAlloc(##origLongMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##origAliases#0 := GetOpt.Param.ShortAlias(opt#Z#0);
    assume $IsAlloc(##origAliases#0, TSeq(TChar), $Heap);
    ##origShortMap#0 := shortMap#0;
    assume $IsAlloc(##origShortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    assume {:subsumption 0} Map#Domain(##origLongMap#0)[$Box(##name#0)];
    assume Map#Domain(##origLongMap#0)[$Box(##name#0)];
    assume {:subsumption 0} (forall x#8: char :: { $Unbox(Map#Elements(##shortMap#1)[$Box(x#8)]): Seq } { Map#Domain(##shortMap#1)[$Box(x#8)] } $Is(x#8, TChar) && Map#Domain(##shortMap#1)[$Box(x#8)] ==> Map#Domain(##origLongMap#0)[Map#Elements(##shortMap#1)[$Box(x#8)]]);
    assume (forall x#8: char :: { $Unbox(Map#Elements(##shortMap#1)[$Box(x#8)]): Seq } { Map#Domain(##shortMap#1)[$Box(x#8)] } $Is(x#8, TChar) && Map#Domain(##shortMap#1)[$Box(x#8)] ==> Map#Domain(##origLongMap#0)[Map#Elements(##shortMap#1)[$Box(x#8)]]);
    assume {:subsumption 0} (forall k#0: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#0)]): Seq } { $Unbox(Map#Elements(##shortMap#1)[$Box(k#0)]): Seq } { Map#Domain(##shortMap#1)[$Box(k#0)] } { Map#Domain(##origShortMap#0)[$Box(k#0)] } $Is(k#0, TChar) && Map#Domain(##origShortMap#0)[$Box(k#0)] ==> Map#Domain(##shortMap#1)[$Box(k#0)] && Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#0)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#0)]): Seq));
    assume (forall k#0: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#0)]): Seq } { $Unbox(Map#Elements(##shortMap#1)[$Box(k#0)]): Seq } { Map#Domain(##shortMap#1)[$Box(k#0)] } { Map#Domain(##origShortMap#0)[$Box(k#0)] } $Is(k#0, TChar) && Map#Domain(##origShortMap#0)[$Box(k#0)] ==> Map#Domain(##shortMap#1)[$Box(k#0)] && Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#0)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#0)]): Seq));
    assume {:subsumption 0} (forall k#1: char :: { $Unbox(Map#Elements(##shortMap#1)[$Box(k#1)]): Seq } { Map#Domain(##shortMap#1)[$Box(k#1)] } { Seq#Contains(##aliases#0, $Box(k#1)) } { Seq#Contains(##origAliases#0, $Box(k#1)) } $Is(k#1, TChar) && Seq#Contains(##origAliases#0, $Box(k#1)) ==> (Seq#Contains(##aliases#0, $Box(k#1)) || Map#Domain(##shortMap#1)[$Box(k#1)]) && (Seq#Contains(##aliases#0, $Box(k#1)) || Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#1)]): Seq, ##name#0)));
    assume (forall k#1: char :: { $Unbox(Map#Elements(##shortMap#1)[$Box(k#1)]): Seq } { Map#Domain(##shortMap#1)[$Box(k#1)] } { Seq#Contains(##aliases#0, $Box(k#1)) } { Seq#Contains(##origAliases#0, $Box(k#1)) } $Is(k#1, TChar) && Seq#Contains(##origAliases#0, $Box(k#1)) ==> (Seq#Contains(##aliases#0, $Box(k#1)) || Map#Domain(##shortMap#1)[$Box(k#1)]) && (Seq#Contains(##aliases#0, $Box(k#1)) || Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#1)]): Seq, ##name#0)));
    assume {:subsumption 0} (forall k#2: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#2)]): Seq } { $Unbox(Map#Elements(##shortMap#1)[$Box(k#2)]): Seq } { Map#Domain(##origShortMap#0)[$Box(k#2)] } { Map#Domain(##shortMap#1)[$Box(k#2)] } $Is(k#2, TChar) && Map#Domain(##shortMap#1)[$Box(k#2)] ==> (Map#Domain(##origShortMap#0)[$Box(k#2)] && Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#2)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#2)]): Seq)) || Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#2)]): Seq, ##name#0));
    assume (forall k#2: char :: { $Unbox(Map#Elements(##origShortMap#0)[$Box(k#2)]): Seq } { $Unbox(Map#Elements(##shortMap#1)[$Box(k#2)]): Seq } { Map#Domain(##origShortMap#0)[$Box(k#2)] } { Map#Domain(##shortMap#1)[$Box(k#2)] } $Is(k#2, TChar) && Map#Domain(##shortMap#1)[$Box(k#2)] ==> (Map#Domain(##origShortMap#0)[$Box(k#2)] && Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#2)]): Seq, $Unbox(Map#Elements(##origShortMap#0)[$Box(k#2)]): Seq)) || Seq#Equal($Unbox(Map#Elements(##shortMap#1)[$Box(k#2)]): Seq, ##name#0));
    assume GetOpt.__default.AddShortAlias#canCall(GetOpt.Param.ShortAlias(opt#Z#0), shortMap#0, GetOpt.Param.name(opt#Z#0), newLongMap#Z#0, GetOpt.Param.ShortAlias(opt#Z#0), shortMap#0);
    assume let#4#0#0 == GetOpt.__default.AddShortAlias($LS($LZ), GetOpt.Param.ShortAlias(opt#Z#0), shortMap#0, GetOpt.Param.name(opt#Z#0), newLongMap#Z#0, GetOpt.Param.ShortAlias(opt#Z#0), shortMap#0);
    assume GetOpt.Param.ShortAlias#canCall(opt#Z#0) && GetOpt.Param.ShortAlias#canCall(opt#Z#0) && GetOpt.__default.AddShortAlias#canCall(GetOpt.Param.ShortAlias(opt#Z#0), shortMap#0, GetOpt.Param.name(opt#Z#0), newLongMap#Z#0, GetOpt.Param.ShortAlias(opt#Z#0), shortMap#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)));
    assume valueOrError2#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#Z#0);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#Z#0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == Wrappers.Result.PropagateFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError2#Z#0);
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon39_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#Z#0);
    havoc newShortMap#Z#0;
    assume $Is(newShortMap#Z#0, TMap(TChar, TSeq(TChar))) && $IsAlloc(newShortMap#Z#0, TMap(TChar, TSeq(TChar)), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TMap(TChar, TSeq(TChar)), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#Z#0);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#Z#0)): Map;
    assume Wrappers.Result.Extract#canCall(TMap(TChar, TSeq(TChar)), TSeq(TChar), valueOrError2#Z#0);
    assume $Is(let#5#0#0, TMap(TChar, TSeq(TChar)));
    assume newShortMap#Z#0 == let#5#0#0;
    havoc valueOrError3#Z#0;
    assume $Is(valueOrError3#Z#0, Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar))) && $IsAlloc(valueOrError3#Z#0, Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)), $Heap);
    assume $IsAllocBox($Box(opt#Z#0), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.LongAlias#canCall(opt#Z#0);
    ##aliases#1 := GetOpt.Param.LongAlias(opt#Z#0);
    assume $IsAlloc(##aliases#1, TSeq(TSeq(TChar)), $Heap);
    ##longMap#1 := newLongMap#Z#0;
    assume $IsAlloc(##longMap#1, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##opt#0 := opt#Z#0;
    assume $IsAlloc(##opt#0, Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.__default.AddLongAlias#canCall(GetOpt.Param.LongAlias(opt#Z#0), newLongMap#Z#0, opt#Z#0);
    assume let#6#0#0 == GetOpt.__default.AddLongAlias($LS($LZ), GetOpt.Param.LongAlias(opt#Z#0), newLongMap#Z#0, opt#Z#0);
    assume GetOpt.Param.LongAlias#canCall(opt#Z#0) && GetOpt.__default.AddLongAlias#canCall(GetOpt.Param.LongAlias(opt#Z#0), newLongMap#Z#0, opt#Z#0);
    assume $Is(let#6#0#0, Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)));
    assume valueOrError3#Z#0 == let#6#0#0;
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#Z#0);
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#Z#0);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#Z#0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == Wrappers.Result.PropagateFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), valueOrError3#Z#0);
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon40_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#Z#0);
    havoc newLongMap#Z#1;
    assume $Is(newLongMap#Z#1, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $IsAlloc(newLongMap#Z#1, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Extract#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#Z#0);
    assume let#7#0#0 == $Unbox(Wrappers.Result.Extract(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#Z#0)): Map;
    assume Wrappers.Result.Extract#canCall(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TSeq(TChar), valueOrError3#Z#0);
    assume $Is(let#7#0#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()));
    assume newLongMap#Z#1 == let#7#0#0;
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} GetOpt.Param.short(opt#Z#0) != GetOpt.__default.NullChar();
    havoc short#Z#0;
    assume $Is(short#Z#0, TChar);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    assume let#8#0#0 == GetOpt.Param.short(opt#Z#0);
    assume true;
    assume $Is(let#8#0#0, TChar);
    assume short#Z#0 == let#8#0#0;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} Map#Domain(newShortMap#Z#0)[$Box(short#Z#0)];
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    assume Map#Domain(newShortMap#Z#0)[$Box(short#Z#0)];
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(68))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(short#Z#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Param.name(opt#Z#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), $Unbox(Map#Elements(newShortMap#Z#0)[$Box(short#Z#0)]): Seq)));
    assume true;
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon42_Else:
    assume {:partition} !Map#Domain(newShortMap#Z#0)[$Box(short#Z#0)];
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    ##opts#1 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longMap#2 := Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0));
    assume $IsAlloc(##longMap#2, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#2 := Map#Build(newShortMap#Z#0, $Box(short#Z#0), $Box(GetOpt.Param.name(opt#Z#0)));
    assume $IsAlloc(##shortMap#2, TMap(TChar, TSeq(TChar)), $Heap);
    ##commandMap#1 := commandMap#0;
    assume $IsAlloc(##commandMap#1, Tclass.GetOpt.CommandMap(), $Heap);
    assume {:subsumption 0} (forall x#9: char :: { $Unbox(Map#Elements(##shortMap#2)[$Box(x#9)]): Seq } { Map#Domain(##shortMap#2)[$Box(x#9)] } $Is(x#9, TChar) && Map#Domain(##shortMap#2)[$Box(x#9)] ==> Map#Domain(##longMap#2)[Map#Elements(##shortMap#2)[$Box(x#9)]]);
    assume (forall x#9: char :: { $Unbox(Map#Elements(##shortMap#2)[$Box(x#9)]): Seq } { Map#Domain(##shortMap#2)[$Box(x#9)] } $Is(x#9, TChar) && Map#Domain(##shortMap#2)[$Box(x#9)] ==> Map#Domain(##longMap#2)[Map#Elements(##shortMap#2)[$Box(x#9)]]);
    assume Seq#Rank(##opts#1) < Seq#Rank(opts#0) || (Seq#Rank(##opts#1) == Seq#Rank(opts#0) && ((Set#Subset(Map#Domain(##longMap#2), Map#Domain(longMap#0)) && !Set#Subset(Map#Domain(longMap#0), Map#Domain(##longMap#2))) || (Set#Equal(Map#Domain(##longMap#2), Map#Domain(longMap#0)) && ((Set#Subset(Map#Domain(##shortMap#2), Map#Domain(shortMap#0)) && !Set#Subset(Map#Domain(shortMap#0), Map#Domain(##shortMap#2))) || (Set#Equal(Map#Domain(##shortMap#2), Map#Domain(shortMap#0)) && Set#Subset(Map#Domain(##commandMap#1), Map#Domain(commandMap#0)) && !Set#Subset(Map#Domain(commandMap#0), Map#Domain(##commandMap#1)))))));
    assume GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0)), Map#Build(newShortMap#Z#0, $Box(short#Z#0), $Box(GetOpt.Param.name(opt#Z#0))), commandMap#0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == GetOpt.__default.GetMaps($LS($LZ), Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0)), Map#Build(newShortMap#Z#0, $Box(short#Z#0), $Box(GetOpt.Param.name(opt#Z#0))), commandMap#0);
    assume GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0)), Map#Build(newShortMap#Z#0, $Box(short#Z#0), $Box(GetOpt.Param.name(opt#Z#0))), commandMap#0);
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon41_Else:
    assume {:partition} GetOpt.Param.short(opt#Z#0) == GetOpt.__default.NullChar();
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q(opt#Z#0) || GetOpt.Param.Flag_q(opt#Z#0);
    ##opts#2 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#2, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longMap#3 := Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0));
    assume $IsAlloc(##longMap#3, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#3 := newShortMap#Z#0;
    assume $IsAlloc(##shortMap#3, TMap(TChar, TSeq(TChar)), $Heap);
    ##commandMap#2 := commandMap#0;
    assume $IsAlloc(##commandMap#2, Tclass.GetOpt.CommandMap(), $Heap);
    assume {:subsumption 0} (forall x#10: char :: { $Unbox(Map#Elements(##shortMap#3)[$Box(x#10)]): Seq } { Map#Domain(##shortMap#3)[$Box(x#10)] } $Is(x#10, TChar) && Map#Domain(##shortMap#3)[$Box(x#10)] ==> Map#Domain(##longMap#3)[Map#Elements(##shortMap#3)[$Box(x#10)]]);
    assume (forall x#10: char :: { $Unbox(Map#Elements(##shortMap#3)[$Box(x#10)]): Seq } { Map#Domain(##shortMap#3)[$Box(x#10)] } $Is(x#10, TChar) && Map#Domain(##shortMap#3)[$Box(x#10)] ==> Map#Domain(##longMap#3)[Map#Elements(##shortMap#3)[$Box(x#10)]]);
    assume Seq#Rank(##opts#2) < Seq#Rank(opts#0) || (Seq#Rank(##opts#2) == Seq#Rank(opts#0) && ((Set#Subset(Map#Domain(##longMap#3), Map#Domain(longMap#0)) && !Set#Subset(Map#Domain(longMap#0), Map#Domain(##longMap#3))) || (Set#Equal(Map#Domain(##longMap#3), Map#Domain(longMap#0)) && ((Set#Subset(Map#Domain(##shortMap#3), Map#Domain(shortMap#0)) && !Set#Subset(Map#Domain(shortMap#0), Map#Domain(##shortMap#3))) || (Set#Equal(Map#Domain(##shortMap#3), Map#Domain(shortMap#0)) && Set#Subset(Map#Domain(##commandMap#2), Map#Domain(commandMap#0)) && !Set#Subset(Map#Domain(commandMap#0), Map#Domain(##commandMap#2)))))));
    assume GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0)), newShortMap#Z#0, commandMap#0);
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == GetOpt.__default.GetMaps($LS($LZ), Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0)), newShortMap#Z#0, commandMap#0);
    assume GetOpt.__default.GetMaps#canCall(Seq#Drop(opts#0, LitInt(1)), Map#Build(newLongMap#Z#1, $Box(GetOpt.Param.name(opt#Z#0)), $Box(opt#Z#0)), newShortMap#Z#0, commandMap#0);
    assume $Is(GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    goto anon29;

  anon29:
    assume GetOpt.__default.GetMaps($LS($LZ), opts#0, longMap#0, shortMap#0, commandMap#0) == ret#0;
    return;
}



function GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.Print$T: Ty, x#0: Box :: { GetOpt.__default.Print(GetOpt._default.Print$T, x#0) } GetOpt.__default.Print#canCall(GetOpt._default.Print$T, x#0) || (0 < $FunctionContextHeight && $IsBox(x#0, GetOpt._default.Print$T)) ==> $Is(GetOpt.__default.Print(GetOpt._default.Print$T, x#0), Tclass.Wrappers.Outcome(TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.Print$T: Ty, x#0: Box :: { GetOpt.__default.Print(GetOpt._default.Print$T, x#0) } GetOpt.__default.Print#canCall(GetOpt._default.Print$T, x#0) || (0 < $FunctionContextHeight && $IsBox(x#0, GetOpt._default.Print$T)) ==> GetOpt.__default.Print(GetOpt._default.Print$T, x#0) == Lit(#Wrappers.Outcome.Pass()));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.Print$T: Ty, x#0: Box :: {:weight 3} { GetOpt.__default.Print(GetOpt._default.Print$T, Lit(x#0)) } GetOpt.__default.Print#canCall(GetOpt._default.Print$T, Lit(x#0)) || (0 < $FunctionContextHeight && $IsBox(x#0, GetOpt._default.Print$T)) ==> GetOpt.__default.Print(GetOpt._default.Print$T, Lit(x#0)) == Lit(#Wrappers.Outcome.Pass()));
}

function GetOpt.__default.Print#canCall(GetOpt._default.Print$T: Ty, x#0: Box) : bool;

function GetOpt.__default.Print#requires(Ty, Box) : bool;

axiom (forall GetOpt._default.Print$T: Ty, x#0: Box :: { GetOpt.__default.Print#requires(GetOpt._default.Print$T, x#0) } $IsBox(x#0, GetOpt._default.Print$T) ==> (GetOpt.__default.Print#requires(GetOpt._default.Print$T, x#0) <==> true));

procedure {:verboseName "GetOpt.Print (well-formedness)"} CheckWellformed$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box where $IsBox(x#0, GetOpt._default.Print$T));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GetOpt.Print (correctness)"} Impl$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box where $IsBox(x#0, GetOpt._default.Print$T) && $IsAllocBox(x#0, GetOpt._default.Print$T, $Heap)) returns (defass##result#0: bool, #result#0: DatatypeType where defass##result#0 ==> $Is(#result#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(#result#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Outcome(#result#0) && $IsA#Wrappers.Outcome(GetOpt.__default.Print(GetOpt._default.Print$T, x#0)) && GetOpt.__default.Print#canCall(GetOpt._default.Print$T, x#0);
  free ensures {:id "id16980"} Wrappers.Outcome#Equal(#result#0, GetOpt.__default.Print(GetOpt._default.Print$T, x#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Print (correctness)"} Impl$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box) returns (defass##result#0: bool, #result#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Print", " | ", GetOpt._default.Print$T, " | ", x#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(579,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(580,16)"} true;
    assume true;
    assume true;
    #result#0 := Lit(#Wrappers.Outcome.Pass());
    defass##result#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(581,15)"} true;
    assume defass##result#0;
    assume GetOpt.__default.Print#canCall(GetOpt._default.Print$T, x#0);
    return;
}



function GetOpt.__default.ArgExists($ly: LayerType, args#0: Seq, name#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, name#0: Seq :: { GetOpt.__default.ArgExists($LS($ly), args#0, name#0) } GetOpt.__default.ArgExists#canCall(args#0, name#0) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(name#0, TSeq(TChar))) ==> (Seq#Length(args#0) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType) && (!Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), name#0) ==> GetOpt.__default.ArgExists#canCall(Seq#Drop(args#0, LitInt(1)), name#0))) && (GetOpt.__default.ArgExists($LS($ly), args#0, name#0) <==> (if Seq#Length(args#0) == LitInt(0) then false else (if Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), name#0) then true else GetOpt.__default.ArgExists($ly, Seq#Drop(args#0, LitInt(1)), name#0)))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, name#0: Seq :: {:weight 3} { GetOpt.__default.ArgExists($LS($ly), Lit(args#0), Lit(name#0)) } GetOpt.__default.ArgExists#canCall(Lit(args#0), Lit(name#0)) || (1 < $FunctionContextHeight && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(name#0, TSeq(TChar))) ==> (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType) && (!Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), name#0) ==> GetOpt.__default.ArgExists#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(name#0)))) && (GetOpt.__default.ArgExists($LS($ly), Lit(args#0), Lit(name#0)) <==> (if Seq#Length(Lit(args#0)) == LitInt(0) then false else (if Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(Lit(args#0), LitInt(0))): DatatypeType), name#0) then true else GetOpt.__default.ArgExists($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(name#0))))));
}

function GetOpt.__default.ArgExists#canCall(args#0: Seq, name#0: Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, name#0: Seq :: { GetOpt.__default.ArgExists($LS($ly), args#0, name#0) } GetOpt.__default.ArgExists($LS($ly), args#0, name#0) <==> GetOpt.__default.ArgExists($ly, args#0, name#0));

axiom (forall $ly: LayerType, args#0: Seq, name#0: Seq :: { GetOpt.__default.ArgExists(AsFuelBottom($ly), args#0, name#0) } GetOpt.__default.ArgExists($ly, args#0, name#0) <==> GetOpt.__default.ArgExists($LZ, args#0, name#0));

function GetOpt.__default.ArgExists#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, name#0: Seq :: { GetOpt.__default.ArgExists#requires($ly, args#0, name#0) } $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(name#0, TSeq(TChar)) ==> (GetOpt.__default.ArgExists#requires($ly, args#0, name#0) <==> true));

procedure {:verboseName "GetOpt.ArgExists (well-formedness)"} CheckWellformed$$GetOpt.__default.ArgExists(args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), name#0: Seq where $Is(name#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.ArgExists (well-formedness)"} CheckWellformed$$GetOpt.__default.ArgExists(args#0: Seq, name#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##name#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.ArgExists", " | ", args#0, " | ", name#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(584,29): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.ArgExists($LS($LZ), args#0, name#0) <==> Lit(false);
    assume true;
    assume $Is(GetOpt.__default.ArgExists($LS($LZ), args#0, name#0), TBool);
    return;

  anon9_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.OneArg.OneArg_q($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), name#0);
    assume GetOpt.__default.ArgExists($LS($LZ), args#0, name#0) <==> Lit(true);
    assume true;
    assume $Is(GetOpt.__default.ArgExists($LS($LZ), args#0, name#0), TBool);
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(GetOpt.OneArg.name($Unbox(Seq#Index(args#0, LitInt(0))): DatatypeType), name#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##name#0 := name#0;
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Seq#Rank(##name#0) < Seq#Rank(name#0));
    assume GetOpt.__default.ArgExists#canCall(Seq#Drop(args#0, LitInt(1)), name#0);
    assume GetOpt.__default.ArgExists($LS($LZ), args#0, name#0) <==> GetOpt.__default.ArgExists($LS($LZ), Seq#Drop(args#0, LitInt(1)), name#0);
    assume GetOpt.__default.ArgExists#canCall(Seq#Drop(args#0, LitInt(1)), name#0);
    assume $Is(GetOpt.__default.ArgExists($LS($LZ), args#0, name#0), TBool);
    return;
}



function GetOpt.__default.PostProcess2($ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq :: { GetOpt.__default.PostProcess2($ly, opts#0, args#0, newArgs#0) } GetOpt.__default.PostProcess2#canCall(opts#0, args#0, newArgs#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(newArgs#0, TSeq(Tclass.GetOpt.OneArg()))) ==> $Is(GetOpt.__default.PostProcess2($ly, opts#0, args#0, newArgs#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq :: { GetOpt.__default.PostProcess2($LS($ly), opts#0, args#0, newArgs#0) } GetOpt.__default.PostProcess2#canCall(opts#0, args#0, newArgs#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(newArgs#0, TSeq(Tclass.GetOpt.OneArg()))) ==> (Seq#Length(opts#0) != LitInt(0) ==> (GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.Param.Required#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && (GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.__default.ArgExists#canCall(args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))) && (!(GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))) ==> (GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.Param.HasDefault#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && (GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.__default.ArgExists#canCall(args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))) && (GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) ==> GetOpt.__default.PostProcess2#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))))))))) && (!(GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))) ==> GetOpt.__default.PostProcess2#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, newArgs#0)))) && GetOpt.__default.PostProcess2($LS($ly), opts#0, args#0, newArgs#0) == (if Seq#Length(opts#0) == LitInt(0) then #Wrappers.Result.Success($Box(newArgs#0)) else (if GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46)))))) else (if GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) then GetOpt.__default.PostProcess2($ly, Seq#Drop(opts#0, LitInt(1)), args#0, Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))))))))) else GetOpt.__default.PostProcess2($ly, Seq#Drop(opts#0, LitInt(1)), args#0, newArgs#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq :: {:weight 3} { GetOpt.__default.PostProcess2($LS($ly), Lit(opts#0), Lit(args#0), Lit(newArgs#0)) } GetOpt.__default.PostProcess2#canCall(Lit(opts#0), Lit(args#0), Lit(newArgs#0)) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(newArgs#0, TSeq(Tclass.GetOpt.OneArg()))) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> (GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.Param.Required#canCall($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && (GetOpt.Param.Required($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.__default.ArgExists#canCall(Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)))) && (!(GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))) ==> (GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.Param.HasDefault#canCall($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && (GetOpt.Param.HasDefault($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.__default.ArgExists#canCall(Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)))) && (GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) ==> GetOpt.__default.PostProcess2#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)))))))))) && (!(GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))) ==> GetOpt.__default.PostProcess2#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Lit(newArgs#0))))) && GetOpt.__default.PostProcess2($LS($ly), Lit(opts#0), Lit(args#0), Lit(newArgs#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(newArgs#0))) else (if GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46)))))) else (if GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), Lit(args#0), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) then GetOpt.__default.PostProcess2($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))))))))) else GetOpt.__default.PostProcess2($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Lit(newArgs#0))))));
}

function GetOpt.__default.PostProcess2#canCall(opts#0: Seq, args#0: Seq, newArgs#0: Seq) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq :: { GetOpt.__default.PostProcess2($LS($ly), opts#0, args#0, newArgs#0) } GetOpt.__default.PostProcess2($LS($ly), opts#0, args#0, newArgs#0) == GetOpt.__default.PostProcess2($ly, opts#0, args#0, newArgs#0));

axiom (forall $ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq :: { GetOpt.__default.PostProcess2(AsFuelBottom($ly), opts#0, args#0, newArgs#0) } GetOpt.__default.PostProcess2($ly, opts#0, args#0, newArgs#0) == GetOpt.__default.PostProcess2($LZ, opts#0, args#0, newArgs#0));

function GetOpt.__default.PostProcess2#requires(LayerType, Seq, Seq, Seq) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, args#0: Seq, newArgs#0: Seq :: { GetOpt.__default.PostProcess2#requires($ly, opts#0, args#0, newArgs#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(newArgs#0, TSeq(Tclass.GetOpt.OneArg())) ==> (GetOpt.__default.PostProcess2#requires($ly, opts#0, args#0, newArgs#0) <==> true));

procedure {:verboseName "GetOpt.PostProcess2 (well-formedness)"} CheckWellformed$$GetOpt.__default.PostProcess2(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), args#0: Seq where $Is(args#0, TSeq(Tclass.GetOpt.OneArg())), newArgs#0: Seq where $Is(newArgs#0, TSeq(Tclass.GetOpt.OneArg())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.PostProcess2 (well-formedness)"} CheckWellformed$$GetOpt.__default.PostProcess2(opts#0: Seq, args#0: Seq, newArgs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: Seq;
  var ##name#0: Seq;
  var ##args#1: Seq;
  var ##name#1: Seq;
  var ##opts#0: Seq;
  var ##args#2: Seq;
  var ##newArgs#0: Seq;
  var ##opts#1: Seq;
  var ##args#3: Seq;
  var ##newArgs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.PostProcess2", " | ", opts#0, " | ", args#0, " | ", newArgs#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(594,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $Is(GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)));
    assume false;
    return;

  anon18_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0) == #Wrappers.Result.Success($Box(newArgs#0));
    assume true;
    assume $Is(GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)));
    return;

  anon19_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume $IsAllocBox(Seq#Index(opts#0, LitInt(0)), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.Required#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon7;

  anon20_Else:
    assume {:partition} !GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon7;

  anon7:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    ##args#0 := args#0;
    assume $IsAlloc(##args#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##name#0 := GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    assume GetOpt.__default.ArgExists#canCall(args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    goto anon9;

  anon21_Else:
    assume {:partition} !(GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    goto anon9;

  anon9:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)));
    return;

  anon22_Else:
    assume {:partition} !(GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.Required($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume $IsAllocBox(Seq#Index(opts#0, LitInt(0)), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.HasDefault#canCall($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon13;

  anon23_Else:
    assume {:partition} !GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon13;

  anon13:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    ##args#1 := args#0;
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##name#1 := GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume $IsAlloc(##name#1, TSeq(TChar), $Heap);
    assume GetOpt.__default.ArgExists#canCall(args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    goto anon15;

  anon24_Else:
    assume {:partition} !(GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    goto anon15;

  anon15:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume GetOpt.Unused.Default_q(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#2 := args#0;
    assume $IsAlloc(##args#2, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##newArgs#0 := Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))))))));
    assume $IsAlloc(##newArgs#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && (Seq#Rank(##args#2) < Seq#Rank(args#0) || (Seq#Rank(##args#2) == Seq#Rank(args#0) && Seq#Rank(##newArgs#0) < Seq#Rank(newArgs#0))));
    assume GetOpt.__default.PostProcess2#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))))))));
    assume GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0) == GetOpt.__default.PostProcess2($LS($LZ), Seq#Drop(opts#0, LitInt(1)), args#0, Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))))))));
    assume GetOpt.__default.PostProcess2#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, Seq#Append(newArgs#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some($Box(GetOpt.Unused.val(GetOpt.Param.unused($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))))))));
    assume $Is(GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)));
    return;

  anon25_Else:
    assume {:partition} !(GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && GetOpt.Param.HasDefault($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) && !GetOpt.__default.ArgExists($LS($LZ), args#0, GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#1 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#3 := args#0;
    assume $IsAlloc(##args#3, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##newArgs#1 := newArgs#0;
    assume $IsAlloc(##newArgs#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume Seq#Rank(##opts#1) < Seq#Rank(opts#0) || (Seq#Rank(##opts#1) == Seq#Rank(opts#0) && (Seq#Rank(##args#3) < Seq#Rank(args#0) || (Seq#Rank(##args#3) == Seq#Rank(args#0) && Seq#Rank(##newArgs#1) < Seq#Rank(newArgs#0))));
    assume GetOpt.__default.PostProcess2#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, newArgs#0);
    assume GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0) == GetOpt.__default.PostProcess2($LS($LZ), Seq#Drop(opts#0, LitInt(1)), args#0, newArgs#0);
    assume GetOpt.__default.PostProcess2#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, newArgs#0);
    assume $Is(GetOpt.__default.PostProcess2($LS($LZ), opts#0, args#0, newArgs#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)));
    return;
}



function GetOpt.__default.GetSubOptions($ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: { GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0) } GetOpt.__default.GetSubOptions#canCall(opts#0, name#0, pos#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(name#0, TSeq(TChar)) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(opts#0)) ==> (Wrappers.Option.Some_q(GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0)) ==> 0 < Seq#Length(opts#0) && $Unbox(Wrappers.Option.value(GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0))): int < Seq#Length(opts#0) && GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0))): int)): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0))): int)): DatatypeType)), name#0)) && $Is(GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0), Tclass.Wrappers.Option(Tclass._System.nat())));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: { GetOpt.__default.GetSubOptions($LS($ly), opts#0, name#0, pos#0) } GetOpt.__default.GetSubOptions#canCall(opts#0, name#0, pos#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(name#0, TSeq(TChar)) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(opts#0)) ==> (Seq#Length(opts#0) != pos#0 ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType) ==> GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType))) && (!(GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType)), name#0)) ==> GetOpt.__default.GetSubOptions#canCall(opts#0, name#0, pos#0 + 1))) && GetOpt.__default.GetSubOptions($LS($ly), opts#0, name#0, pos#0) == (if Seq#Length(opts#0) == pos#0 then #Wrappers.Option.None() else (if GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType)), name#0) then #Wrappers.Option.Some($Box(pos#0)) else GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0 + 1))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: {:weight 3} { GetOpt.__default.GetSubOptions($LS($ly), Lit(opts#0), name#0, LitInt(pos#0)) } GetOpt.__default.GetSubOptions#canCall(Lit(opts#0), name#0, LitInt(pos#0)) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(name#0, TSeq(TChar)) && LitInt(0) <= pos#0 && LitInt(pos#0) <= Seq#Length(Lit(opts#0))) ==> (Seq#Length(Lit(opts#0)) != LitInt(pos#0) ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType) ==> GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType))) && (!(GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType)), name#0)) ==> GetOpt.__default.GetSubOptions#canCall(Lit(opts#0), name#0, LitInt(pos#0 + 1)))) && GetOpt.__default.GetSubOptions($LS($ly), Lit(opts#0), name#0, LitInt(pos#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(pos#0) then #Wrappers.Option.None() else (if GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType)), name#0) then #Wrappers.Option.Some($Box(LitInt(pos#0))) else GetOpt.__default.GetSubOptions($LS($ly), Lit(opts#0), name#0, LitInt(pos#0 + 1)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: {:weight 3} { GetOpt.__default.GetSubOptions($LS($ly), Lit(opts#0), Lit(name#0), LitInt(pos#0)) } GetOpt.__default.GetSubOptions#canCall(Lit(opts#0), Lit(name#0), LitInt(pos#0)) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(name#0, TSeq(TChar)) && LitInt(0) <= pos#0 && LitInt(pos#0) <= Seq#Length(Lit(opts#0))) ==> (Seq#Length(Lit(opts#0)) != LitInt(pos#0) ==> (GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType) ==> GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType))) && (!(GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType)), name#0)) ==> GetOpt.__default.GetSubOptions#canCall(Lit(opts#0), Lit(name#0), LitInt(pos#0 + 1)))) && GetOpt.__default.GetSubOptions($LS($ly), Lit(opts#0), Lit(name#0), LitInt(pos#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(pos#0) then #Wrappers.Option.None() else (if GetOpt.Param.Command_q($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(Lit(opts#0), LitInt(pos#0))): DatatypeType)), name#0) then #Wrappers.Option.Some($Box(LitInt(pos#0))) else GetOpt.__default.GetSubOptions($LS($ly), Lit(opts#0), Lit(name#0), LitInt(pos#0 + 1)))));
}

function GetOpt.__default.GetSubOptions#canCall(opts#0: Seq, name#0: Seq, pos#0: int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: { GetOpt.__default.GetSubOptions($LS($ly), opts#0, name#0, pos#0) } GetOpt.__default.GetSubOptions($LS($ly), opts#0, name#0, pos#0) == GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0));

axiom (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: { GetOpt.__default.GetSubOptions(AsFuelBottom($ly), opts#0, name#0, pos#0) } GetOpt.__default.GetSubOptions($ly, opts#0, name#0, pos#0) == GetOpt.__default.GetSubOptions($LZ, opts#0, name#0, pos#0));

function GetOpt.__default.GetSubOptions#requires(LayerType, Seq, Seq, int) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, name#0: Seq, pos#0: int :: { GetOpt.__default.GetSubOptions#requires($ly, opts#0, name#0, pos#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(name#0, TSeq(TChar)) && LitInt(0) <= pos#0 ==> (GetOpt.__default.GetSubOptions#requires($ly, opts#0, name#0, pos#0) <==> pos#0 <= Seq#Length(opts#0)));

procedure {:verboseName "GetOpt.GetSubOptions (well-formedness)"} CheckWellformed$$GetOpt.__default.GetSubOptions(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), name#0: Seq where $Is(name#0, TSeq(TChar)), pos#0: int where LitInt(0) <= pos#0) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Option(Tclass._System.nat())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17013"} Wrappers.Option.Some_q(ret#0) ==> 0 < Seq#Length(opts#0);
  free ensures {:id "id17014"} Wrappers.Option.Some_q(ret#0) ==> $Unbox(Wrappers.Option.value(ret#0)): int < Seq#Length(opts#0);
  free ensures {:id "id17015"} Wrappers.Option.Some_q(ret#0) ==> GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType);
  free ensures {:id "id17016"} Wrappers.Option.Some_q(ret#0) ==> Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType)), name#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetSubOptions (well-formedness)"} CheckWellformed$$GetOpt.__default.GetSubOptions(opts#0: Seq, name#0: Seq, pos#0: int) returns (ret#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##opts#0: Seq;
  var ##name#0: Seq;
  var ##pos#0: int;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetSubOptions", " | ", opts#0, " | ", name#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(607,28): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    assume pos#0 <= Seq#Length(opts#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Option.Some_q(ret#0);
    assume 0 < Seq#Length(opts#0);
    assume Wrappers.Option.Some_q(ret#0);
    assume $Unbox(Wrappers.Option.value(ret#0)): int < Seq#Length(opts#0);
    assume Wrappers.Option.Some_q(ret#0);
    assume 0 <= $Unbox(Wrappers.Option.value(ret#0)): int && $Unbox(Wrappers.Option.value(ret#0)): int < Seq#Length(opts#0);
    assume GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType);
    assume Wrappers.Option.Some_q(ret#0);
    assume 0 <= $Unbox(Wrappers.Option.value(ret#0)): int && $Unbox(Wrappers.Option.value(ret#0)): int < Seq#Length(opts#0);
    assume GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType);
    assume GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType));
    assume Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType)), name#0);
    goto anon5;

  anon15_Else:
    assume Wrappers.Option.Some_q(ret#0) ==> 0 < Seq#Length(opts#0) && $Unbox(Wrappers.Option.value(ret#0)): int < Seq#Length(opts#0) && GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, $Unbox(Wrappers.Option.value(ret#0)): int)): DatatypeType)), name#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(opts#0) == pos#0;
    assume GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon13;

  anon16_Else:
    assume {:partition} Seq#Length(opts#0) != pos#0;
    assume 0 <= pos#0 && pos#0 < Seq#Length(opts#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType);
    assume 0 <= pos#0 && pos#0 < Seq#Length(opts#0);
    assume GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType);
    assume GetOpt.Options.Options_q(GetOpt.Param.options($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType));
    goto anon10;

  anon17_Else:
    assume {:partition} !GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType);
    goto anon10;

  anon10:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType)), name#0);
    assume GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0) == #Wrappers.Option.Some($Box(pos#0));
    assume true;
    assume $Is(GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon13;

  anon18_Else:
    assume {:partition} !(GetOpt.Param.Command_q($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType) && Seq#Equal(GetOpt.Options.name(GetOpt.Param.options($Unbox(Seq#Index(opts#0, pos#0)): DatatypeType)), name#0));
    ##opts#0 := opts#0;
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##name#0 := name#0;
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    assume $Is(pos#0 + 1, Tclass._System.nat());
    ##pos#0 := pos#0 + 1;
    assume $IsAlloc(##pos#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#0 <= Seq#Length(##opts#0);
    assume ##pos#0 <= Seq#Length(##opts#0);
    assume 0 <= Seq#Length(opts#0) - pos#0 || Seq#Length(##opts#0) - ##pos#0 == Seq#Length(opts#0) - pos#0;
    assume Seq#Length(##opts#0) - ##pos#0 < Seq#Length(opts#0) - pos#0;
    assume GetOpt.__default.GetSubOptions#canCall(opts#0, name#0, pos#0 + 1);
    assume GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0) == GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0 + 1);
    assume GetOpt.__default.GetSubOptions#canCall(opts#0, name#0, pos#0 + 1);
    assume $Is(GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0), Tclass.Wrappers.Option(Tclass._System.nat()));
    goto anon13;

  anon13:
    assume GetOpt.__default.GetSubOptions($LS($LZ), opts#0, name#0, pos#0) == ret#0;
    return;
}



function GetOpt.__default.PostProcess($ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType :: { GetOpt.__default.PostProcess($ly, opts#0, args#0) } GetOpt.__default.PostProcess#canCall(opts#0, args#0) || (3 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed())) ==> $Is(GetOpt.__default.PostProcess($ly, opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType :: { GetOpt.__default.PostProcess($LS($ly), opts#0, args#0) } GetOpt.__default.PostProcess#canCall(opts#0, args#0) || (3 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed())) ==> GetOpt.__default.IsHelp#canCall(args#0) && (!GetOpt.__default.IsHelp(args#0) ==> GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.__default.PostProcess2#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.params(args#0), Lit(Seq#Empty(): Seq)) && (var valueOrError0#0 := GetOpt.__default.PostProcess2($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.params(args#0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#0) && GetOpt.Parsed.Parsed_q(args#0) && (Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0)) ==> GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType) && GetOpt.__default.GetSubOptions#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0)) && (var optPos#0 := GetOpt.__default.GetSubOptions($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0)); Wrappers.Option.Some_q(optPos#0) ==> GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.__default.PostProcess#canCall(GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#0)): int)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType) && (var valueOrError1#0 := GetOpt.__default.PostProcess($ly, GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#0)): int)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#0) && (var dt_update_tmp#0#0 := args#0; GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#0#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#0#0)))))) && (!Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0)) ==> (var dt_update_tmp#1#0 := args#0; GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#0)))))) && GetOpt.__default.PostProcess($LS($ly), opts#0, args#0) == (if GetOpt.__default.IsHelp(args#0) then #Wrappers.Result.Success($Box(args#0)) else (var valueOrError0#0 := GetOpt.__default.PostProcess2($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.params(args#0), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#0) else (var newParams#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#0)): Seq; (if Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0)) then (var optPos#0 := GetOpt.__default.GetSubOptions($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0)); (if Wrappers.Option.Some_q(optPos#0) then (var valueOrError1#0 := GetOpt.__default.PostProcess($ly, GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#0)): int)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#0) else (var sub#0 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box((var dt_update_tmp#0#0 := args#0; (var dt_update#subcommand#0#0 := #Wrappers.Option.Some($Box(sub#0)); (var dt_update#params#0#0 := Seq#Append(GetOpt.Parsed.params(args#0), newParams#0); #GetOpt.Parsed.Parsed(GetOpt.Parsed.command(dt_update_tmp#0#0), dt_update#params#0#0, GetOpt.Parsed.files(dt_update_tmp#0#0), dt_update#subcommand#0#0))))))))) else #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(71))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(58))), $Box(char#FromInt(58))), $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(80))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(115)))))))) else #Wrappers.Result.Success($Box((var dt_update_tmp#1#0 := args#0; (var dt_update#params#1#0 := Seq#Append(GetOpt.Parsed.params(args#0), newParams#0); #GetOpt.Parsed.Parsed(GetOpt.Parsed.command(dt_update_tmp#1#0), dt_update#params#1#0, GetOpt.Parsed.files(dt_update_tmp#1#0), GetOpt.Parsed.subcommand(dt_update_tmp#1#0))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType :: {:weight 3} { GetOpt.__default.PostProcess($LS($ly), Lit(opts#0), Lit(args#0)) } GetOpt.__default.PostProcess#canCall(Lit(opts#0), Lit(args#0)) || (3 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed())) ==> GetOpt.__default.IsHelp#canCall(Lit(args#0)) && (!Lit(GetOpt.__default.IsHelp(Lit(args#0))) ==> GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.__default.PostProcess2#canCall(Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.params(Lit(args#0))), Lit(Seq#Empty(): Seq)) && (var valueOrError0#1 := Lit(GetOpt.__default.PostProcess2($LS($LZ), Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.params(Lit(args#0))), Lit(Seq#Empty(): Seq))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#1) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && (Lit(Wrappers.Option.Some_q(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))) ==> GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.Parsed.Parsed_q(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType)) && GetOpt.__default.GetSubOptions#canCall(Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.command(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType))), LitInt(0)) && (var optPos#1 := Lit(GetOpt.__default.GetSubOptions($LS($LZ), Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.command(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType))), LitInt(0))); Wrappers.Option.Some_q(optPos#1) ==> GetOpt.Options.Options_q(Lit(opts#0)) && GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.__default.PostProcess#canCall(GetOpt.Param.options($Unbox(Seq#Index(Lit(GetOpt.Options.params(Lit(opts#0))), $Unbox(Wrappers.Option.value(optPos#1)): int)): DatatypeType), Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType)) && (var valueOrError1#1 := GetOpt.__default.PostProcess($LS($ly), GetOpt.Param.options($Unbox(Seq#Index(Lit(GetOpt.Options.params(Lit(opts#0))), $Unbox(Wrappers.Option.value(optPos#1)): int)): DatatypeType), Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#1) && (var dt_update_tmp#0#1 := Lit(args#0); GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.Parsed.Parsed_q(dt_update_tmp#0#1) && GetOpt.Parsed.Parsed_q(dt_update_tmp#0#1)))))) && (!Lit(Wrappers.Option.Some_q(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))) ==> (var dt_update_tmp#1#1 := Lit(args#0); GetOpt.Parsed.Parsed_q(Lit(args#0)) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#1) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#1) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#1)))))) && GetOpt.__default.PostProcess($LS($ly), Lit(opts#0), Lit(args#0)) == (if GetOpt.__default.IsHelp(Lit(args#0)) then #Wrappers.Result.Success($Box(Lit(args#0))) else (var valueOrError0#1 := Lit(GetOpt.__default.PostProcess2($LS($LZ), Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.params(Lit(args#0))), Lit(Seq#Empty(): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#1) else (var newParams#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#1)): Seq); (if Wrappers.Option.Some_q(Lit(GetOpt.Parsed.subcommand(Lit(args#0)))) then (var optPos#1 := Lit(GetOpt.__default.GetSubOptions($LS($LZ), Lit(GetOpt.Options.params(Lit(opts#0))), Lit(GetOpt.Parsed.command(Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType))), LitInt(0))); (if Wrappers.Option.Some_q(optPos#1) then (var valueOrError1#1 := GetOpt.__default.PostProcess($LS($ly), GetOpt.Param.options($Unbox(Seq#Index(Lit(GetOpt.Options.params(Lit(opts#0))), LitInt($Unbox(Wrappers.Option.value(optPos#1)): int))): DatatypeType), Lit($Unbox(Wrappers.Option.value(Lit(GetOpt.Parsed.subcommand(Lit(args#0))))): DatatypeType)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#1) else (var sub#1 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#1)): DatatypeType; #Wrappers.Result.Success($Box((var dt_update_tmp#0#1 := Lit(args#0); (var dt_update#subcommand#0#1 := #Wrappers.Option.Some($Box(sub#1)); (var dt_update#params#0#1 := Seq#Append(GetOpt.Parsed.params(Lit(args#0)), newParams#1); #GetOpt.Parsed.Parsed(Lit(GetOpt.Parsed.command(dt_update_tmp#0#1)), dt_update#params#0#1, Lit(GetOpt.Parsed.files(dt_update_tmp#0#1)), dt_update#subcommand#0#1))))))))) else #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(71))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(58))), $Box(char#FromInt(58))), $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(80))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(115)))))))) else #Wrappers.Result.Success($Box((var dt_update_tmp#1#1 := Lit(args#0); (var dt_update#params#1#1 := Seq#Append(GetOpt.Parsed.params(Lit(args#0)), newParams#1); #GetOpt.Parsed.Parsed(Lit(GetOpt.Parsed.command(dt_update_tmp#1#1)), dt_update#params#1#1, Lit(GetOpt.Parsed.files(dt_update_tmp#1#1)), Lit(GetOpt.Parsed.subcommand(dt_update_tmp#1#1)))))))))))));
}

function GetOpt.__default.PostProcess#canCall(opts#0: DatatypeType, args#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType :: { GetOpt.__default.PostProcess($LS($ly), opts#0, args#0) } GetOpt.__default.PostProcess($LS($ly), opts#0, args#0) == GetOpt.__default.PostProcess($ly, opts#0, args#0));

axiom (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType :: { GetOpt.__default.PostProcess(AsFuelBottom($ly), opts#0, args#0) } GetOpt.__default.PostProcess($ly, opts#0, args#0) == GetOpt.__default.PostProcess($LZ, opts#0, args#0));

function GetOpt.__default.PostProcess#requires(LayerType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, opts#0: DatatypeType, args#0: DatatypeType :: { GetOpt.__default.PostProcess#requires($ly, opts#0, args#0) } $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, Tclass.GetOpt.Parsed()) ==> (GetOpt.__default.PostProcess#requires($ly, opts#0, args#0) <==> true));

procedure {:verboseName "GetOpt.PostProcess (well-formedness)"} CheckWellformed$$GetOpt.__default.PostProcess(opts#0: DatatypeType where $Is(opts#0, Tclass.GetOpt.Options()), args#0: DatatypeType where $Is(args#0, Tclass.GetOpt.Parsed()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.PostProcess (well-formedness)"} CheckWellformed$$GetOpt.__default.PostProcess(opts#0: DatatypeType, args#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##args#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##opts#0: Seq;
  var ##args#1: Seq;
  var ##newArgs#0: Seq;
  var newParams#Z#0: Seq;
  var let#1#0#0: Seq;
  var optPos#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##opts#1: Seq;
  var ##name#0: Seq;
  var ##pos#0: int;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##opts#2: DatatypeType;
  var ##args#2: DatatypeType;
  var sub#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var dt_update#subcommand#0#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var dt_update#params#0#Z#0: Seq;
  var let#7#0#0: Seq;
  var dt_update_tmp#1#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var dt_update#params#1#Z#0: Seq;
  var let#9#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.PostProcess", " | ", opts#0, " | ", args#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(620,32): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    assume false;
    return;

  anon14_Else:
    ##args#0 := args#0;
    assume $IsAlloc(##args#0, Tclass.GetOpt.Parsed(), $Heap);
    assume GetOpt.__default.IsHelp#canCall(args#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} GetOpt.__default.IsHelp(args#0);
    assume GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0) == #Wrappers.Result.Success($Box(args#0));
    assume true;
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    return;

  anon15_Else:
    assume {:partition} !GetOpt.__default.IsHelp(args#0);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)), $Heap);
    assume GetOpt.Options.Options_q(opts#0);
    assume GetOpt.Parsed.Parsed_q(args#0);
    ##opts#0 := GetOpt.Options.params(opts#0);
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#1 := GetOpt.Parsed.params(args#0);
    assume $IsAlloc(##args#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##newArgs#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##newArgs#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume GetOpt.__default.PostProcess2#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.params(args#0), Lit(Seq#Empty(): Seq));
    assume let#0#0#0 == GetOpt.__default.PostProcess2($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.params(args#0), Lit(Seq#Empty(): Seq));
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.__default.PostProcess2#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.params(args#0), Lit(Seq#Empty(): Seq));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    return;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#Z#0);
    havoc newParams#Z#0;
    assume $Is(newParams#Z#0, TSeq(Tclass.GetOpt.OneArg())) && $IsAlloc(newParams#Z#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.GetOpt.OneArg()), TSeq(TChar), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.GetOpt.OneArg()));
    assume newParams#Z#0 == let#1#0#0;
    assume GetOpt.Parsed.Parsed_q(args#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    havoc optPos#Z#0;
    assume $Is(optPos#Z#0, Tclass.Wrappers.Option(Tclass._System.nat())) && $IsAlloc(optPos#Z#0, Tclass.Wrappers.Option(Tclass._System.nat()), $Heap);
    assume GetOpt.Options.Options_q(opts#0);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    assume GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    ##opts#1 := GetOpt.Options.params(opts#0);
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##name#0 := GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    assume $IsAlloc(##name#0, TSeq(TChar), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##pos#0 := LitInt(0);
    assume $IsAlloc(##pos#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##pos#0 <= Seq#Length(##opts#1);
    assume ##pos#0 <= Seq#Length(##opts#1);
    assume GetOpt.__default.GetSubOptions#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0));
    assume let#2#0#0 == GetOpt.__default.GetSubOptions($LS($LZ), GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0));
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType) && GetOpt.__default.GetSubOptions#canCall(GetOpt.Options.params(opts#0), GetOpt.Parsed.command($Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType), LitInt(0));
    assume $Is(let#2#0#0, Tclass.Wrappers.Option(Tclass._System.nat()));
    assume optPos#Z#0 == let#2#0#0;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Option.Some_q(optPos#Z#0);
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume GetOpt.Options.Options_q(opts#0);
    assume Wrappers.Option.Some_q(optPos#Z#0);
    assume 0 <= $Unbox(Wrappers.Option.value(optPos#Z#0)): int && $Unbox(Wrappers.Option.value(optPos#Z#0)): int < Seq#Length(GetOpt.Options.params(opts#0));
    assume GetOpt.Param.Command_q($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#Z#0)): int)): DatatypeType);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    ##opts#2 := GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#Z#0)): int)): DatatypeType);
    assume $IsAlloc(##opts#2, Tclass.GetOpt.Options(), $Heap);
    ##args#2 := $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType;
    assume $IsAlloc(##args#2, Tclass.GetOpt.Parsed(), $Heap);
    assume DtRank(##opts#2) < DtRank(opts#0) || (DtRank(##opts#2) == DtRank(opts#0) && DtRank(##args#2) < DtRank(args#0));
    assume GetOpt.__default.PostProcess#canCall(GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#Z#0)): int)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    assume let#3#0#0 == GetOpt.__default.PostProcess($LS($LZ), GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#Z#0)): int)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    assume GetOpt.Options.Options_q(opts#0) && GetOpt.Parsed.Parsed_q(args#0) && GetOpt.__default.PostProcess#canCall(GetOpt.Param.options($Unbox(Seq#Index(GetOpt.Options.params(opts#0), $Unbox(Wrappers.Option.value(optPos#Z#0)): int)): DatatypeType), $Unbox(Wrappers.Option.value(GetOpt.Parsed.subcommand(args#0))): DatatypeType);
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0) == Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    return;

  anon19_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0);
    havoc sub#Z#0;
    assume $Is(sub#Z#0, Tclass.GetOpt.Parsed()) && $IsAlloc(sub#Z#0, Tclass.GetOpt.Parsed(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0);
    assume GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0)): DatatypeType);
    assume let#4#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError1#Z#0);
    assume $Is(let#4#0#0, Tclass.GetOpt.Parsed());
    assume sub#Z#0 == let#4#0#0;
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.GetOpt.Parsed()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.GetOpt.Parsed(), $Heap);
    assume let#5#0#0 == args#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.GetOpt.Parsed());
    assume dt_update_tmp#0#Z#0 == let#5#0#0;
    havoc dt_update#subcommand#0#Z#0;
    assume $Is(dt_update#subcommand#0#Z#0, Tclass.Wrappers.Option(Tclass.GetOpt.Parsed())) && $IsAlloc(dt_update#subcommand#0#Z#0, Tclass.Wrappers.Option(Tclass.GetOpt.Parsed()), $Heap);
    assume let#6#0#0 == #Wrappers.Option.Some($Box(sub#Z#0));
    assume true;
    assume $Is(let#6#0#0, Tclass.Wrappers.Option(Tclass.GetOpt.Parsed()));
    assume dt_update#subcommand#0#Z#0 == let#6#0#0;
    havoc dt_update#params#0#Z#0;
    assume $Is(dt_update#params#0#Z#0, TSeq(Tclass.GetOpt.OneArg())) && $IsAlloc(dt_update#params#0#Z#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume let#7#0#0 == Seq#Append(GetOpt.Parsed.params(args#0), newParams#Z#0);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume $Is(let#7#0#0, TSeq(Tclass.GetOpt.OneArg()));
    assume dt_update#params#0#Z#0 == let#7#0#0;
    assume GetOpt.Parsed.Parsed_q(dt_update_tmp#0#Z#0);
    assume GetOpt.Parsed.Parsed_q(dt_update_tmp#0#Z#0);
    assume GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0) == #Wrappers.Result.Success($Box((var dt_update_tmp#0#2 := args#0; (var dt_update#subcommand#0#2 := #Wrappers.Option.Some($Box(sub#Z#0)); (var dt_update#params#0#2 := Seq#Append(GetOpt.Parsed.params(args#0), newParams#Z#0); #GetOpt.Parsed.Parsed(GetOpt.Parsed.command(dt_update_tmp#0#2), dt_update#params#0#2, GetOpt.Parsed.files(dt_update_tmp#0#2), dt_update#subcommand#0#2))))));
    assume (var dt_update_tmp#0#2 := args#0; GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#0#2) && GetOpt.Parsed.Parsed_q(dt_update_tmp#0#2));
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    return;

  anon18_Else:
    assume {:partition} !Wrappers.Option.Some_q(optPos#Z#0);
    assume GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0) == Lit(#Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(71))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(58))), $Box(char#FromInt(58))), $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(80))), $Box(char#FromInt(114))), $Box(char#FromInt(111))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(115)))))));
    assume true;
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    return;

  anon17_Else:
    assume {:partition} !Wrappers.Option.Some_q(GetOpt.Parsed.subcommand(args#0));
    havoc dt_update_tmp#1#Z#0;
    assume $Is(dt_update_tmp#1#Z#0, Tclass.GetOpt.Parsed()) && $IsAlloc(dt_update_tmp#1#Z#0, Tclass.GetOpt.Parsed(), $Heap);
    assume let#8#0#0 == args#0;
    assume true;
    assume $Is(let#8#0#0, Tclass.GetOpt.Parsed());
    assume dt_update_tmp#1#Z#0 == let#8#0#0;
    havoc dt_update#params#1#Z#0;
    assume $Is(dt_update#params#1#Z#0, TSeq(Tclass.GetOpt.OneArg())) && $IsAlloc(dt_update#params#1#Z#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume let#9#0#0 == Seq#Append(GetOpt.Parsed.params(args#0), newParams#Z#0);
    assume GetOpt.Parsed.Parsed_q(args#0);
    assume $Is(let#9#0#0, TSeq(Tclass.GetOpt.OneArg()));
    assume dt_update#params#1#Z#0 == let#9#0#0;
    assume GetOpt.Parsed.Parsed_q(dt_update_tmp#1#Z#0);
    assume GetOpt.Parsed.Parsed_q(dt_update_tmp#1#Z#0);
    assume GetOpt.Parsed.Parsed_q(dt_update_tmp#1#Z#0);
    assume GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0) == #Wrappers.Result.Success($Box((var dt_update_tmp#1#2 := args#0; (var dt_update#params#1#2 := Seq#Append(GetOpt.Parsed.params(args#0), newParams#Z#0); #GetOpt.Parsed.Parsed(GetOpt.Parsed.command(dt_update_tmp#1#2), dt_update#params#1#2, GetOpt.Parsed.files(dt_update_tmp#1#2), GetOpt.Parsed.subcommand(dt_update_tmp#1#2))))));
    assume (var dt_update_tmp#1#2 := args#0; GetOpt.Parsed.Parsed_q(args#0) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#2) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#2) && GetOpt.Parsed.Parsed_q(dt_update_tmp#1#2));
    assume $Is(GetOpt.__default.PostProcess($LS($LZ), opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    return;
}



function GetOpt.__default.AllDigits($ly: LayerType, s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { GetOpt.__default.AllDigits($LS($ly), s#0) } GetOpt.__default.AllDigits#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(s#0) != LitInt(0) ==> char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) ==> GetOpt.__default.AllDigits#canCall(Seq#Drop(s#0, LitInt(1)))) && (GetOpt.__default.AllDigits($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(0) then true else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) then GetOpt.__default.AllDigits($ly, Seq#Drop(s#0, LitInt(1))) else false))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { GetOpt.__default.AllDigits($LS($ly), Lit(s#0)) } GetOpt.__default.AllDigits#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) ==> GetOpt.__default.AllDigits#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && (GetOpt.__default.AllDigits($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(0) then true else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) then GetOpt.__default.AllDigits($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1)))) else false))));
}

function GetOpt.__default.AllDigits#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { GetOpt.__default.AllDigits($LS($ly), s#0) } GetOpt.__default.AllDigits($LS($ly), s#0) <==> GetOpt.__default.AllDigits($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { GetOpt.__default.AllDigits(AsFuelBottom($ly), s#0) } GetOpt.__default.AllDigits($ly, s#0) <==> GetOpt.__default.AllDigits($LZ, s#0));

function GetOpt.__default.AllDigits#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { GetOpt.__default.AllDigits#requires($ly, s#0) } $Is(s#0, TSeq(TChar)) ==> (GetOpt.__default.AllDigits#requires($ly, s#0) <==> true));

procedure {:verboseName "GetOpt.AllDigits (well-formedness)"} CheckWellformed$$GetOpt.__default.AllDigits(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.AllDigits (well-formedness)"} CheckWellformed$$GetOpt.__default.AllDigits(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.AllDigits", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(637,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume false;
    return;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume GetOpt.__default.AllDigits($LS($LZ), s#0) <==> Lit(true);
    assume true;
    assume $Is(GetOpt.__default.AllDigits($LS($LZ), s#0), TBool);
    return;

  anon11_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon7;

  anon12_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) < char#ToInt(Lit(char#FromInt(48)));
    goto anon7;

  anon7:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##s#0) < Seq#Rank(s#0);
    assume GetOpt.__default.AllDigits#canCall(Seq#Drop(s#0, LitInt(1)));
    assume GetOpt.__default.AllDigits($LS($LZ), s#0) <==> GetOpt.__default.AllDigits($LS($LZ), Seq#Drop(s#0, LitInt(1)));
    assume GetOpt.__default.AllDigits#canCall(Seq#Drop(s#0, LitInt(1)));
    assume $Is(GetOpt.__default.AllDigits($LS($LZ), s#0), TBool);
    return;

  anon13_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))));
    assume GetOpt.__default.AllDigits($LS($LZ), s#0) <==> Lit(false);
    assume true;
    assume $Is(GetOpt.__default.AllDigits($LS($LZ), s#0), TBool);
    return;
}



function GetOpt.__default.ValidPositional(s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: { GetOpt.__default.ValidPositional(s#0) } GetOpt.__default.ValidPositional#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(s#0) != LitInt(0) ==> $Unbox(Seq#Index(s#0, LitInt(0))): char == char#FromInt(45) ==> GetOpt.__default.AllDigits#canCall(Seq#Drop(s#0, LitInt(1)))) && (GetOpt.__default.ValidPositional(s#0) <==> (if Seq#Length(s#0) == LitInt(0) then true else (if $Unbox(Seq#Index(s#0, LitInt(0))): char != char#FromInt(45) then true else GetOpt.__default.AllDigits($LS($LZ), Seq#Drop(s#0, LitInt(1)))))));
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { GetOpt.__default.ValidPositional(Lit(s#0)) } GetOpt.__default.ValidPositional#canCall(Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> $Unbox(Seq#Index(Lit(s#0), LitInt(0))): char == char#FromInt(45) ==> GetOpt.__default.AllDigits#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))))) && (GetOpt.__default.ValidPositional(Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(0) then true else (if $Unbox(Seq#Index(Lit(s#0), LitInt(0))): char != char#FromInt(45) then true else GetOpt.__default.AllDigits($LS($LZ), Lit(Seq#Drop(Lit(s#0), LitInt(1))))))));
}

function GetOpt.__default.ValidPositional#canCall(s#0: Seq) : bool;

function GetOpt.__default.ValidPositional#requires(Seq) : bool;

axiom (forall s#0: Seq :: { GetOpt.__default.ValidPositional#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (GetOpt.__default.ValidPositional#requires(s#0) <==> true));

procedure {:verboseName "GetOpt.ValidPositional (well-formedness)"} CheckWellformed$$GetOpt.__default.ValidPositional(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.ValidPositional (well-formedness)"} CheckWellformed$$GetOpt.__default.ValidPositional(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.ValidPositional", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(646,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume GetOpt.__default.ValidPositional(s#0) <==> Lit(true);
    assume true;
    assume $Is(GetOpt.__default.ValidPositional(s#0), TBool);
    return;

  anon9_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): char != char#FromInt(45);
    assume GetOpt.__default.ValidPositional(s#0) <==> Lit(true);
    assume true;
    assume $Is(GetOpt.__default.ValidPositional(s#0), TBool);
    return;

  anon10_Else:
    assume {:partition} $Unbox(Seq#Index(s#0, LitInt(0))): char == char#FromInt(45);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#0 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume GetOpt.__default.AllDigits#canCall(Seq#Drop(s#0, LitInt(1)));
    assume GetOpt.__default.ValidPositional(s#0) <==> GetOpt.__default.AllDigits($LS($LZ), Seq#Drop(s#0, LitInt(1)));
    assume GetOpt.__default.AllDigits#canCall(Seq#Drop(s#0, LitInt(1)));
    assume $Is(GetOpt.__default.ValidPositional(s#0), TBool);
    return;
}



function GetOpt.__default.TestPositionals($ly: LayerType, opts#0: Seq, optional#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, optional#0: DatatypeType :: { GetOpt.__default.TestPositionals($ly, opts#0, optional#0) } GetOpt.__default.TestPositionals#canCall(opts#0, optional#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(optional#0, Tclass.Wrappers.Option(TSeq(TChar)))) ==> $Is(GetOpt.__default.TestPositionals($ly, opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, optional#0: DatatypeType :: { GetOpt.__default.TestPositionals($LS($ly), opts#0, optional#0) } GetOpt.__default.TestPositionals#canCall(opts#0, optional#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(optional#0, Tclass.Wrappers.Option(TSeq(TChar)))) ==> (Seq#Length(opts#0) != LitInt(0) ==> (!GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0)) && (GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0)) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe()) ==> GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))))) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe()) ==> Wrappers.Option.None_q(optional#0) ==> GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0))))) && GetOpt.__default.TestPositionals($LS($ly), opts#0, optional#0) == (if Seq#Length(opts#0) == LitInt(0) then #Wrappers.Outcome.Pass() else (if !GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) then GetOpt.__default.TestPositionals($ly, Seq#Drop(opts#0, LitInt(1)), optional#0) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No()) then GetOpt.__default.TestPositionals($ly, Seq#Drop(opts#0, LitInt(1)), optional#0) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe()) then GetOpt.__default.TestPositionals($ly, Seq#Drop(opts#0, LitInt(1)), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)))) else (if Wrappers.Option.None_q(optional#0) then GetOpt.__default.TestPositionals($ly, Seq#Drop(opts#0, LitInt(1)), optional#0) else #Wrappers.Outcome.Fail($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(108))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(119))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), $Unbox(Wrappers.Option.value(optional#0)): Seq), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(46))))))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, optional#0: DatatypeType :: {:weight 3} { GetOpt.__default.TestPositionals($LS($ly), Lit(opts#0), Lit(optional#0)) } GetOpt.__default.TestPositionals#canCall(Lit(opts#0), Lit(optional#0)) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(optional#0, Tclass.Wrappers.Option(TSeq(TChar)))) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> (!GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.__default.TestPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(optional#0))) && (GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> GetOpt.__default.TestPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(optional#0))) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe()) ==> GetOpt.__default.TestPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType))))) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe()) ==> Lit(Wrappers.Option.None_q(Lit(optional#0))) ==> GetOpt.__default.TestPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(optional#0)))))) && GetOpt.__default.TestPositionals($LS($ly), Lit(opts#0), Lit(optional#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then #Wrappers.Outcome.Pass() else (if !GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) then GetOpt.__default.TestPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(optional#0)) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.No()) then GetOpt.__default.TestPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(optional#0)) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe()) then GetOpt.__default.TestPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)))) else (if Wrappers.Option.None_q(Lit(optional#0)) then GetOpt.__default.TestPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(optional#0)) else #Wrappers.Outcome.Fail($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(108))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(119))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), $Unbox(Wrappers.Option.value(Lit(optional#0))): Seq), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(46))))))))))));
}

function GetOpt.__default.TestPositionals#canCall(opts#0: Seq, optional#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, optional#0: DatatypeType :: { GetOpt.__default.TestPositionals($LS($ly), opts#0, optional#0) } GetOpt.__default.TestPositionals($LS($ly), opts#0, optional#0) == GetOpt.__default.TestPositionals($ly, opts#0, optional#0));

axiom (forall $ly: LayerType, opts#0: Seq, optional#0: DatatypeType :: { GetOpt.__default.TestPositionals(AsFuelBottom($ly), opts#0, optional#0) } GetOpt.__default.TestPositionals($ly, opts#0, optional#0) == GetOpt.__default.TestPositionals($LZ, opts#0, optional#0));

function GetOpt.__default.TestPositionals#requires(LayerType, Seq, DatatypeType) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, optional#0: DatatypeType :: { GetOpt.__default.TestPositionals#requires($ly, opts#0, optional#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(optional#0, Tclass.Wrappers.Option(TSeq(TChar))) ==> (GetOpt.__default.TestPositionals#requires($ly, opts#0, optional#0) <==> true));

procedure {:verboseName "GetOpt.TestPositionals (well-formedness)"} CheckWellformed$$GetOpt.__default.TestPositionals(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), optional#0: DatatypeType where $Is(optional#0, Tclass.Wrappers.Option(TSeq(TChar))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.TestPositionals (well-formedness)"} CheckWellformed$$GetOpt.__default.TestPositionals(opts#0: Seq, optional#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##opts#0: Seq;
  var ##optional#0: DatatypeType;
  var ##opts#1: Seq;
  var ##optional#1: DatatypeType;
  var ##opts#2: Seq;
  var ##optional#2: DatatypeType;
  var ##opts#3: Seq;
  var ##optional#3: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.TestPositionals", " | ", opts#0, " | ", optional#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(656,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0) == Lit(#Wrappers.Outcome.Pass());
    assume true;
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    return;

  anon15_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} !GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##optional#0 := optional#0;
    assume $IsAlloc(##optional#0, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && DtRank(##optional#0) < DtRank(optional#0));
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0) == GetOpt.__default.TestPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    return;

  anon16_Else:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No());
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#1 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##optional#1 := optional#0;
    assume $IsAlloc(##optional#1, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume Seq#Rank(##opts#1) < Seq#Rank(opts#0) || (Seq#Rank(##opts#1) == Seq#Rank(opts#0) && DtRank(##optional#1) < DtRank(optional#0));
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0) == GetOpt.__default.TestPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    return;

  anon17_Else:
    assume {:partition} !GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No());
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe());
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    ##opts#2 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#2, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##optional#2 := #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)));
    assume $IsAlloc(##optional#2, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume Seq#Rank(##opts#2) < Seq#Rank(opts#0) || (Seq#Rank(##opts#2) == Seq#Rank(opts#0) && DtRank(##optional#2) < DtRank(optional#0));
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))));
    assume GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0) == GetOpt.__default.TestPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))));
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), #Wrappers.Option.Some($Box(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType))));
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    return;

  anon18_Else:
    assume {:partition} !GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe());
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Wrappers.Option.None_q(optional#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#3 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#3, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##optional#3 := optional#0;
    assume $IsAlloc(##optional#3, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume Seq#Rank(##opts#3) < Seq#Rank(opts#0) || (Seq#Rank(##opts#3) == Seq#Rank(opts#0) && DtRank(##optional#3) < DtRank(optional#0));
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0) == GetOpt.__default.TestPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume GetOpt.__default.TestPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), optional#0);
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    return;

  anon19_Else:
    assume {:partition} !Wrappers.Option.None_q(optional#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume Wrappers.Option.Some_q(optional#0);
    assume GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0) == #Wrappers.Outcome.Fail($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(108))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(119))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), $Unbox(Wrappers.Option.value(optional#0)): Seq), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.TestPositionals($LS($LZ), opts#0, optional#0), Tclass.Wrappers.Outcome(TSeq(TChar)));
    return;
}



function GetOpt.__default.GetPositionals($ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq :: { GetOpt.__default.GetPositionals($ly, opts#0, args#0, params#0) } GetOpt.__default.GetPositionals#canCall(opts#0, args#0, params#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(params#0, TSeq(Tclass.GetOpt.OneArg()))) ==> (Wrappers.Result.Success_q(GetOpt.__default.GetPositionals($ly, opts#0, args#0, params#0)) ==> Seq#Length($Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.value(GetOpt.__default.GetPositionals($ly, opts#0, args#0, params#0))): DatatypeType)): Seq) <= Seq#Length(args#0)) && $Is(GetOpt.__default.GetPositionals($ly, opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq :: { GetOpt.__default.GetPositionals($LS($ly), opts#0, args#0, params#0) } GetOpt.__default.GetPositionals#canCall(opts#0, args#0, params#0) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(params#0, TSeq(Tclass.GetOpt.OneArg()))) ==> (Seq#Length(opts#0) != LitInt(0) ==> (!GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, params#0)) && (GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, params#0)) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Yes()) ==> Seq#Length(args#0) != LitInt(0) ==> GetOpt.__default.ValidPositional#canCall($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && (GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq) ==> GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0)))))))))) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Yes()) ==> Seq#Length(args#0) != LitInt(0) ==> GetOpt.__default.ValidPositional#canCall($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && (GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq) ==> GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))))))))) && GetOpt.__default.GetPositionals($LS($ly), opts#0, args#0, params#0) == (if Seq#Length(opts#0) == LitInt(0) then #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(args#0), $Box(params#0)))) else (if !GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) then GetOpt.__default.GetPositionals($ly, Seq#Drop(opts#0, LitInt(1)), args#0, params#0) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No()) then GetOpt.__default.GetPositionals($ly, Seq#Drop(opts#0, LitInt(1)), args#0, params#0) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Yes()) then (if Seq#Length(args#0) == LitInt(0) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(101))), $Box(char#FromInt(39))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(115))), $Box(char#FromInt(46)))))) else (if GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq) then GetOpt.__default.GetPositionals($ly, Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0)))))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(46)))))))) else (if Seq#Length(args#0) == LitInt(0) then #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(args#0), $Box(params#0)))) else (if GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq) then GetOpt.__default.GetPositionals($ly, Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0)))))))) else #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(args#0), $Box(params#0)))))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq :: {:weight 3} { GetOpt.__default.GetPositionals($LS($ly), Lit(opts#0), Lit(args#0), Lit(params#0)) } GetOpt.__default.GetPositionals#canCall(Lit(opts#0), Lit(args#0), Lit(params#0)) || (2 < $FunctionContextHeight && $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(params#0, TSeq(Tclass.GetOpt.OneArg()))) ==> (Seq#Length(Lit(opts#0)) != LitInt(0) ==> (!GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> GetOpt.__default.GetPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Lit(params#0))) && (GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> GetOpt.__default.GetPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Lit(params#0))) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.No()) ==> $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)) && (GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.Yes()) ==> Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.__default.ValidPositional#canCall($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && (GetOpt.__default.ValidPositional($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) ==> GetOpt.__default.GetPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(0)))))))))) && (!GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.Yes()) ==> Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.__default.ValidPositional#canCall($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && (GetOpt.__default.ValidPositional($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) ==> GetOpt.__default.GetPositionals#canCall(Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(0))))))))))))) && GetOpt.__default.GetPositionals($LS($ly), Lit(opts#0), Lit(args#0), Lit(params#0)) == (if Seq#Length(Lit(opts#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(args#0)), $Box(Lit(params#0)))))) else (if !GetOpt.Param.Opt_q($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType) then GetOpt.__default.GetPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Lit(params#0)) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.No()) then GetOpt.__default.GetPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(args#0), Lit(params#0)) else (if GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #GetOpt.Tri.Yes()) then (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(101))), $Box(char#FromInt(39))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(115))), $Box(char#FromInt(46)))))) else (if GetOpt.__default.ValidPositional($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) then GetOpt.__default.GetPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(0)))))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(46)))))))) else (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(args#0)), $Box(Lit(params#0)))))) else (if GetOpt.__default.ValidPositional($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) then GetOpt.__default.GetPositionals($LS($ly), Lit(Seq#Drop(Lit(opts#0), LitInt(1))), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(Lit(opts#0), LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(0)))))))) else #Wrappers.Result.Success($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(args#0)), $Box(Lit(params#0)))))))))))));
}

function GetOpt.__default.GetPositionals#canCall(opts#0: Seq, args#0: Seq, params#0: Seq) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq :: { GetOpt.__default.GetPositionals($LS($ly), opts#0, args#0, params#0) } GetOpt.__default.GetPositionals($LS($ly), opts#0, args#0, params#0) == GetOpt.__default.GetPositionals($ly, opts#0, args#0, params#0));

axiom (forall $ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq :: { GetOpt.__default.GetPositionals(AsFuelBottom($ly), opts#0, args#0, params#0) } GetOpt.__default.GetPositionals($ly, opts#0, args#0, params#0) == GetOpt.__default.GetPositionals($LZ, opts#0, args#0, params#0));

function GetOpt.__default.GetPositionals#requires(LayerType, Seq, Seq, Seq) : bool;

axiom (forall $ly: LayerType, opts#0: Seq, args#0: Seq, params#0: Seq :: { GetOpt.__default.GetPositionals#requires($ly, opts#0, args#0, params#0) } $Is(opts#0, TSeq(Tclass.GetOpt.Param())) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(params#0, TSeq(Tclass.GetOpt.OneArg())) ==> (GetOpt.__default.GetPositionals#requires($ly, opts#0, args#0, params#0) <==> true));

procedure {:verboseName "GetOpt.GetPositionals (well-formedness)"} CheckWellformed$$GetOpt.__default.GetPositionals(opts#0: Seq where $Is(opts#0, TSeq(Tclass.GetOpt.Param())), args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))), params#0: Seq where $Is(params#0, TSeq(Tclass.GetOpt.OneArg()))) returns (ret#0: DatatypeType where $Is(ret#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17116"} Wrappers.Result.Success_q(ret#0) ==> Seq#Length($Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Seq) <= Seq#Length(args#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetPositionals (well-formedness)"} CheckWellformed$$GetOpt.__default.GetPositionals(opts#0: Seq, args#0: Seq, params#0: Seq) returns (ret#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##opts#0: Seq;
  var ##args#0: Seq;
  var ##params#0: Seq;
  var ##opts#1: Seq;
  var ##args#1: Seq;
  var ##params#1: Seq;
  var ##s#0: Seq;
  var ##opts#2: Seq;
  var ##args#2: Seq;
  var ##params#2: Seq;
  var ##s#1: Seq;
  var ##opts#3: Seq;
  var ##args#3: Seq;
  var ##params#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetPositionals", " | ", opts#0, " | ", args#0, " | ", params#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(672,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume Wrappers.Result.Success_q(ret#0);
    assume Wrappers.Result.Success_q(ret#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Result.value(ret#0)): DatatypeType);
    assume Seq#Length($Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Seq) <= Seq#Length(args#0);
    goto anon5;

  anon25_Else:
    assume Wrappers.Result.Success_q(ret#0) ==> Seq#Length($Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.value(ret#0)): DatatypeType)): Seq) <= Seq#Length(args#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon24_Else:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} Seq#Length(opts#0) == LitInt(0);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(args#0), $Box(params#0))));
    assume true;
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon26_Else:
    assume {:partition} Seq#Length(opts#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} !GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#0 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#0 := args#0;
    assume $IsAlloc(##args#0, TSeq(TSeq(TChar)), $Heap);
    ##params#0 := params#0;
    assume $IsAlloc(##params#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume Seq#Rank(##opts#0) < Seq#Rank(opts#0) || (Seq#Rank(##opts#0) == Seq#Rank(opts#0) && (Seq#Rank(##args#0) < Seq#Rank(args#0) || (Seq#Rank(##args#0) == Seq#Rank(args#0) && Seq#Rank(##params#0) < Seq#Rank(params#0))));
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, params#0);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == GetOpt.__default.GetPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), args#0, params#0);
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, params#0);
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon27_Else:
    assume {:partition} GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No());
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    ##opts#1 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#1 := args#0;
    assume $IsAlloc(##args#1, TSeq(TSeq(TChar)), $Heap);
    ##params#1 := params#0;
    assume $IsAlloc(##params#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume Seq#Rank(##opts#1) < Seq#Rank(opts#0) || (Seq#Rank(##opts#1) == Seq#Rank(opts#0) && (Seq#Rank(##args#1) < Seq#Rank(args#0) || (Seq#Rank(##args#1) == Seq#Rank(args#0) && Seq#Rank(##params#1) < Seq#Rank(params#0))));
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, params#0);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == GetOpt.__default.GetPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), args#0, params#0);
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), args#0, params#0);
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon28_Else:
    assume {:partition} !GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.No());
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Yes());
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(101))), $Box(char#FromInt(39))), $Box(char#FromInt(118))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(115))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon30_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    ##s#0 := $Unbox(Seq#Index(args#0, LitInt(0))): Seq;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume GetOpt.__default.ValidPositional#canCall($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    ##opts#2 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#2, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#2 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#2, TSeq(TSeq(TChar)), $Heap);
    ##params#2 := Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0)))))));
    assume $IsAlloc(##params#2, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume Seq#Rank(##opts#2) < Seq#Rank(opts#0) || (Seq#Rank(##opts#2) == Seq#Rank(opts#0) && (Seq#Rank(##args#2) < Seq#Rank(args#0) || (Seq#Rank(##args#2) == Seq#Rank(args#0) && Seq#Rank(##params#2) < Seq#Rank(params#0))));
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))));
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == GetOpt.__default.GetPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))));
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))));
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon31_Else:
    assume {:partition} !GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(80))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(115))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(32))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon29_Else:
    assume {:partition} !GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Yes());
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume $IsA#GetOpt.Tri(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType));
    assume GetOpt.Tri#Equal(GetOpt.Param.positional($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #GetOpt.Tri.Maybe());
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(690,40)"} true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(args#0), $Box(params#0))));
    assume true;
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon32_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    ##s#1 := $Unbox(Seq#Index(args#0, LitInt(0))): Seq;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume GetOpt.__default.ValidPositional#canCall($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(opts#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(opts#0);
    assume GetOpt.Param.Opt_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType) || GetOpt.Param.Flag_q($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    ##opts#3 := Seq#Drop(opts#0, LitInt(1));
    assume $IsAlloc(##opts#3, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#3 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#3, TSeq(TSeq(TChar)), $Heap);
    ##params#3 := Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0)))))));
    assume $IsAlloc(##params#3, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume Seq#Rank(##opts#3) < Seq#Rank(opts#0) || (Seq#Rank(##opts#3) == Seq#Rank(opts#0) && (Seq#Rank(##args#3) < Seq#Rank(args#0) || (Seq#Rank(##args#3) == Seq#Rank(args#0) && Seq#Rank(##params#3) < Seq#Rank(params#0))));
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))));
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == GetOpt.__default.GetPositionals($LS($LZ), Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))));
    assume GetOpt.__default.GetPositionals#canCall(Seq#Drop(opts#0, LitInt(1)), Seq#Drop(args#0, LitInt(1)), Seq#Append(params#0, Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.name($Unbox(Seq#Index(opts#0, LitInt(0))): DatatypeType), #Wrappers.Option.Some(Seq#Index(args#0, LitInt(0))))))));
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon33_Else:
    assume {:partition} !GetOpt.__default.ValidPositional($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(args#0), $Box(params#0))));
    assume true;
    assume $Is(GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    goto anon23;

  anon23:
    assume GetOpt.__default.GetPositionals($LS($LZ), opts#0, args#0, params#0) == ret#0;
    return;
}



function GetOpt.__default.GetOptions(opts#0: DatatypeType, args#0: Seq) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall opts#0: DatatypeType, args#0: Seq :: { GetOpt.__default.GetOptions(opts#0, args#0) } GetOpt.__default.GetOptions#canCall(opts#0, args#0) || (5 < $FunctionContextHeight && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, TSeq(TSeq(TChar))) && 0 < Seq#Length(args#0)) ==> $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, opts#0: DatatypeType, args#0: Seq :: { GetOpt.__default.GetOptions(opts#0, args#0), $IsGoodHeap($Heap) } GetOpt.__default.GetOptions#canCall(opts#0, args#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, TSeq(TSeq(TChar))) && 0 < Seq#Length(args#0)) ==> GetOpt.Options.Options_q(opts#0) && (var newOpts#0 := Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (forall $l#1#o#0: DatatypeType :: $Is($l#1#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#1#o#0)) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#2#o#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#o#0: Box :: $IsBox($l#2#o#0, Tclass.GetOpt.Param())), (lambda $l#2#heap#0: Heap, $l#2#o#0: Box :: SetRef_to_SetBox((lambda $l#2#o#1: ref :: false))))), $LS($LZ))), newOpts#0) && (var inherits#0 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#3#o#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#o#0: Box :: $IsBox($l#3#o#0, Tclass.GetOpt.Param())), (lambda $l#3#heap#0: Heap, $l#3#o#0: Box :: SetRef_to_SetBox((lambda $l#3#o#1: ref :: false))))), $LS($LZ))), newOpts#0); GetOpt.__default.TestPositionals#canCall(newOpts#0, Lit(#Wrappers.Option.None())) && (var valueOrError0#0 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#0, Lit(#Wrappers.Option.None())); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#0) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#0)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) ==> GetOpt.__default.GetPositionals#canCall(newOpts#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq)) && (var valueOrError1#0 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) && (var newArgs#0, params#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq; GetOpt.__default.GetMaps#canCall(newOpts#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)) && (var valueOrError2#0 := GetOpt.__default.GetMaps($LS($LZ), newOpts#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) && (var longMap#0, shortMap#0, commandMap#0 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map; (var context#0 := #GetOpt.Context.Context(longMap#0, shortMap#0, inherits#0, commandMap#0, $Unbox(Seq#Index(args#0, LitInt(0))): Seq); GetOpt.__default.GetOptions2#canCall(newArgs#0, context#0, params#0, Lit(Seq#Empty(): Seq)) && (var valueOrError3#0 := GetOpt.__default.GetOptions2($LS($LZ), newArgs#0, context#0, params#0, Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#0)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) && (var result#0 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0)): DatatypeType; GetOpt.__default.PostProcess#canCall(opts#0, result#0))))))))))))))) && GetOpt.__default.GetOptions(opts#0, args#0) == (var newOpts#0 := Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (var inherits#0 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#0#o#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#o#0: Box :: $IsBox($l#0#o#0, Tclass.GetOpt.Param())), (lambda $l#0#heap#0: Heap, $l#0#o#0: Box :: SetRef_to_SetBox((lambda $l#0#o#1: ref :: false))))), $LS($LZ))), newOpts#0); (var valueOrError0#0 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#0, Lit(#Wrappers.Option.None())); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#0) else (var valueOrError1#0 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#0) else (var newArgs#0, params#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq; (var valueOrError2#0 := GetOpt.__default.GetMaps($LS($LZ), newOpts#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#0) else (var longMap#0, shortMap#0, commandMap#0 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map; (var context#0 := #GetOpt.Context.Context(longMap#0, shortMap#0, inherits#0, commandMap#0, $Unbox(Seq#Index(args#0, LitInt(0))): Seq); (var valueOrError3#0 := GetOpt.__default.GetOptions2($LS($LZ), newArgs#0, context#0, params#0, Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#0) else (var result#0 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0)): DatatypeType; GetOpt.__default.PostProcess($LS($LZ), opts#0, result#0))))))))))))))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, opts#0: DatatypeType, args#0: Seq :: {:weight 3} { GetOpt.__default.GetOptions(opts#0, Lit(args#0)), $IsGoodHeap($Heap) } GetOpt.__default.GetOptions#canCall(opts#0, Lit(args#0)) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, TSeq(TSeq(TChar))) && 0 < Seq#Length(Lit(args#0))) ==> GetOpt.Options.Options_q(opts#0) && (var newOpts#1 := Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (forall $l#5#o#0: DatatypeType :: $Is($l#5#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#5#o#0)) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#6#o#0): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#o#0: Box :: $IsBox($l#6#o#0, Tclass.GetOpt.Param())), (lambda $l#6#heap#0: Heap, $l#6#o#0: Box :: SetRef_to_SetBox((lambda $l#6#o#1: ref :: false))))), $LS($LZ))), newOpts#1) && (var inherits#1 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#7#o#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#o#0: Box :: $IsBox($l#7#o#0, Tclass.GetOpt.Param())), (lambda $l#7#heap#0: Heap, $l#7#o#0: Box :: SetRef_to_SetBox((lambda $l#7#o#1: ref :: false))))), $LS($LZ))), newOpts#1); GetOpt.__default.TestPositionals#canCall(newOpts#1, Lit(#Wrappers.Option.None())) && (var valueOrError0#1 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#1, Lit(#Wrappers.Option.None())); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#1) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#1)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) ==> GetOpt.__default.GetPositionals#canCall(newOpts#1, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)) && (var valueOrError1#1 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#1, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) && (var newArgs#1, params#1 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq; GetOpt.__default.GetMaps#canCall(newOpts#1, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)) && (var valueOrError2#1 := GetOpt.__default.GetMaps($LS($LZ), newOpts#1, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) && (var longMap#1, shortMap#1, commandMap#1 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map; (var context#1 := #GetOpt.Context.Context(longMap#1, shortMap#1, inherits#1, commandMap#1, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); GetOpt.__default.GetOptions2#canCall(newArgs#1, context#1, params#1, Lit(Seq#Empty(): Seq)) && (var valueOrError3#1 := GetOpt.__default.GetOptions2($LS($LZ), newArgs#1, context#1, params#1, Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#1)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) && (var result#1 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1)): DatatypeType; GetOpt.__default.PostProcess#canCall(opts#0, result#1))))))))))))))) && GetOpt.__default.GetOptions(opts#0, Lit(args#0)) == (var newOpts#1 := Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (var inherits#1 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#4#o#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#o#0: Box :: $IsBox($l#4#o#0, Tclass.GetOpt.Param())), (lambda $l#4#heap#0: Heap, $l#4#o#0: Box :: SetRef_to_SetBox((lambda $l#4#o#1: ref :: false))))), $LS($LZ))), newOpts#1); (var valueOrError0#1 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#1, Lit(#Wrappers.Option.None())); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#1) else (var valueOrError1#1 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#1, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#1) else (var newArgs#1, params#1 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq; (var valueOrError2#1 := GetOpt.__default.GetMaps($LS($LZ), newOpts#1, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#1) else (var longMap#1, shortMap#1, commandMap#1 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map; (var context#1 := #GetOpt.Context.Context(longMap#1, shortMap#1, inherits#1, commandMap#1, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); (var valueOrError3#1 := GetOpt.__default.GetOptions2($LS($LZ), newArgs#1, context#1, params#1, Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#1) else (var result#1 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1)): DatatypeType; GetOpt.__default.PostProcess($LS($LZ), opts#0, result#1))))))))))))))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, opts#0: DatatypeType, args#0: Seq :: {:weight 3} { GetOpt.__default.GetOptions(Lit(opts#0), Lit(args#0)), $IsGoodHeap($Heap) } GetOpt.__default.GetOptions#canCall(Lit(opts#0), Lit(args#0)) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, TSeq(TSeq(TChar))) && 0 < Seq#Length(Lit(args#0))) ==> GetOpt.Options.Options_q(Lit(opts#0)) && (var newOpts#2 := Seq#Append(GetOpt.Options.params(Lit(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (forall $l#9#o#0: DatatypeType :: $Is($l#9#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#9#o#0)) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#10#o#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#o#0: Box :: $IsBox($l#10#o#0, Tclass.GetOpt.Param())), (lambda $l#10#heap#0: Heap, $l#10#o#0: Box :: SetRef_to_SetBox((lambda $l#10#o#1: ref :: false))))), $LS($LZ))), newOpts#2) && (var inherits#2 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#11#o#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#o#0: Box :: $IsBox($l#11#o#0, Tclass.GetOpt.Param())), (lambda $l#11#heap#0: Heap, $l#11#o#0: Box :: SetRef_to_SetBox((lambda $l#11#o#1: ref :: false))))), $LS($LZ))), newOpts#2); GetOpt.__default.TestPositionals#canCall(newOpts#2, Lit(#Wrappers.Option.None())) && (var valueOrError0#2 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#2, Lit(#Wrappers.Option.None())); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#2) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#2) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#2)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#2) ==> GetOpt.__default.GetPositionals#canCall(newOpts#2, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)) && (var valueOrError1#2 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#2, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) && (var newArgs#2, params#2 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq; GetOpt.__default.GetMaps#canCall(newOpts#2, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)) && (var valueOrError2#2 := GetOpt.__default.GetMaps($LS($LZ), newOpts#2, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) && (var longMap#2, shortMap#2, commandMap#2 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map; (var context#2 := #GetOpt.Context.Context(longMap#2, shortMap#2, inherits#2, commandMap#2, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); GetOpt.__default.GetOptions2#canCall(newArgs#2, context#2, params#2, Lit(Seq#Empty(): Seq)) && (var valueOrError3#2 := GetOpt.__default.GetOptions2($LS($LZ), newArgs#2, context#2, params#2, Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#2)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) && (var result#2 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2)): DatatypeType; GetOpt.__default.PostProcess#canCall(Lit(opts#0), result#2))))))))))))))) && GetOpt.__default.GetOptions(Lit(opts#0), Lit(args#0)) == (var newOpts#2 := Seq#Append(GetOpt.Options.params(Lit(opts#0)), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM()))); (var inherits#2 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#8#o#0): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#o#0: Box :: $IsBox($l#8#o#0, Tclass.GetOpt.Param())), (lambda $l#8#heap#0: Heap, $l#8#o#0: Box :: SetRef_to_SetBox((lambda $l#8#o#1: ref :: false))))), $LS($LZ))), newOpts#2); (var valueOrError0#2 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#2, Lit(#Wrappers.Option.None())); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#2) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#2) else (var valueOrError1#2 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#2, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#2) else (var newArgs#2, params#2 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq; (var valueOrError2#2 := GetOpt.__default.GetMaps($LS($LZ), newOpts#2, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#2) else (var longMap#2, shortMap#2, commandMap#2 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map; (var context#2 := #GetOpt.Context.Context(longMap#2, shortMap#2, inherits#2, commandMap#2, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); (var valueOrError3#2 := GetOpt.__default.GetOptions2($LS($LZ), newArgs#2, context#2, params#2, Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#2) else (var result#2 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2)): DatatypeType; GetOpt.__default.PostProcess($LS($LZ), Lit(opts#0), result#2))))))))))))))));
}

function GetOpt.__default.GetOptions#canCall(opts#0: DatatypeType, args#0: Seq) : bool;

function GetOpt.__default.GetOptions#requires(DatatypeType, Seq) : bool;

axiom (forall $Heap: Heap, opts#0: DatatypeType, args#0: Seq :: { GetOpt.__default.GetOptions#requires(opts#0, args#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(opts#0, Tclass.GetOpt.Options()) && $Is(args#0, TSeq(TSeq(TChar))) ==> (GetOpt.__default.GetOptions#requires(opts#0, args#0) <==> 0 < Seq#Length(args#0)));

procedure {:verboseName "GetOpt.GetOptions (well-formedness)"} CheckWellformed$$GetOpt.__default.GetOptions(opts#0: DatatypeType where $Is(opts#0, Tclass.GetOpt.Options()), args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.GetOpt.Context() : Ty
uses {
axiom Tag(Tclass.GetOpt.Context()) == Tagclass.GetOpt.Context && TagFamily(Tclass.GetOpt.Context()) == tytagFamily$Context;
}

const unique Tagclass.GetOpt.Context: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Context()) } $IsBox(bx, Tclass.GetOpt.Context()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Context()));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetOptions (well-formedness)"} CheckWellformed$$GetOpt.__default.GetOptions(opts#0: DatatypeType, args#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newOpts#Z#0: Seq;
  var let#0#0#0: Seq;
  var inherits#Z#0: Seq;
  var let#1#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var o#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##opts#0: Seq;
  var ##optional#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##opts#1: Seq;
  var ##args#0: Seq;
  var ##params#0: Seq;
  var newArgs#Z#0: Seq;
  var params#Z#0: Seq;
  var let#4#0#0: DatatypeType;
  var valueOrError2#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##opts#2: Seq;
  var ##longMap#0: Map;
  var ##shortMap#0: Map;
  var ##commandMap#0: Map;
  var longMap#Z#0: Map;
  var shortMap#Z#0: Map;
  var commandMap#Z#0: Map;
  var let#6#0#0: DatatypeType;
  var context#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var valueOrError3#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var ##args#1: Seq;
  var ##context#0: DatatypeType;
  var ##parms#0: Seq;
  var ##files#0: Seq;
  var result#Z#0: DatatypeType;
  var let#9#0#0: DatatypeType;
  var ##opts#3: DatatypeType;
  var ##args#2: DatatypeType;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetOptions", " | ", opts#0, " | ", args#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(699,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume 0 < Seq#Length(args#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    assume false;
    return;

  anon17_Else:
    havoc newOpts#Z#0;
    assume $Is(newOpts#Z#0, TSeq(Tclass.GetOpt.Param())) && $IsAlloc(newOpts#Z#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume GetOpt.Options.Options_q(opts#0);
    assume let#0#0#0 == Seq#Append(GetOpt.Options.params(opts#0), Seq#Build(Seq#Empty(): Seq, $Box(GetOpt.__default.HELP__PARAM())));
    assume GetOpt.Options.Options_q(opts#0);
    assume $Is(let#0#0#0, TSeq(Tclass.GetOpt.Param()));
    assume newOpts#Z#0 == let#0#0#0;
    havoc inherits#Z#0;
    assume $Is(inherits#Z#0, TSeq(Tclass.GetOpt.Param())) && $IsAlloc(inherits#Z#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc o#0;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} $Is(o#0, Tclass.GetOpt.Param()) && $IsAlloc(o#0, Tclass.GetOpt.Param(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(o#0), Tclass.GetOpt.Param(), $lambdaHeap#0);
    assume GetOpt.Param.Inherits#canCall(o#0);
    assume lambdaResult#0 <==> GetOpt.Param.Inherits(o#0);
    assume GetOpt.Param.Inherits#canCall(o#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon6;

  anon19_Else:
    assume {:partition} !($Is(o#0, Tclass.GetOpt.Param()) && $IsAlloc(o#0, Tclass.GetOpt.Param(), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon18_Else:
    goto anon7;

  anon7:
    ##f#0 := Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#13#o#0): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#o#0: Box :: $IsBox($l#13#o#0, Tclass.GetOpt.Param())), (lambda $l#13#heap#0: Heap, $l#13#o#0: Box :: SetRef_to_SetBox((lambda $l#13#o#1: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.GetOpt.Param(), TBool), $Heap);
    ##xs#0 := newOpts#Z#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#1: ref :: { Reads1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#1)] && $Box($o) == $Box(o#1)) ==> $_ReadsFrame[$o, $f]);
    assume GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#14#o#0): DatatypeType))), (lambda $l#14#heap#0: Heap, $l#14#o#0: Box :: $IsBox($l#14#o#0, Tclass.GetOpt.Param())), (lambda $l#14#heap#0: Heap, $l#14#o#0: Box :: SetRef_to_SetBox((lambda $l#14#o#1: ref :: false))))), $LS($LZ))), newOpts#Z#0);
    assume let#1#0#0 == GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#16#o#0): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#o#0: Box :: $IsBox($l#16#o#0, Tclass.GetOpt.Param())), (lambda $l#16#heap#0: Heap, $l#16#o#0: Box :: SetRef_to_SetBox((lambda $l#16#o#1: ref :: false))))), $LS($LZ))), newOpts#Z#0);
    assume (forall $l#17#o#0: DatatypeType :: $Is($l#17#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#17#o#0)) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#18#o#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#o#0: Box :: $IsBox($l#18#o#0, Tclass.GetOpt.Param())), (lambda $l#18#heap#0: Heap, $l#18#o#0: Box :: SetRef_to_SetBox((lambda $l#18#o#1: ref :: false))))), $LS($LZ))), newOpts#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.GetOpt.Param()));
    assume inherits#Z#0 == let#1#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    ##opts#0 := newOpts#Z#0;
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##optional#0 := Lit(#Wrappers.Option.None());
    assume $IsAlloc(##optional#0, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.__default.TestPositionals#canCall(newOpts#Z#0, Lit(#Wrappers.Option.None()));
    assume let#2#0#0 == GetOpt.__default.TestPositionals($LS($LZ), newOpts#Z#0, Lit(#Wrappers.Option.None()));
    assume GetOpt.__default.TestPositionals#canCall(newOpts#Z#0, Lit(#Wrappers.Option.None()));
    assume $Is(let#2#0#0, Tclass.Wrappers.Outcome(TSeq(TChar)));
    assume valueOrError0#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#Z#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume GetOpt.__default.GetOptions(opts#0, args#0) == Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon16;

  anon20_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#Z#0);
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##opts#1 := newOpts#Z#0;
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(TSeq(TChar)), $Heap);
    ##params#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##params#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume GetOpt.__default.GetPositionals#canCall(newOpts#Z#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq));
    assume let#3#0#0 == GetOpt.__default.GetPositionals($LS($LZ), newOpts#Z#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq));
    assume GetOpt.__default.GetPositionals#canCall(newOpts#Z#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq));
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume GetOpt.__default.GetOptions(opts#0, args#0) == Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon16;

  anon21_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    havoc newArgs#Z#0;
    havoc params#Z#0;
    assume $Is(newArgs#Z#0, TSeq(TSeq(TChar))) && $IsAlloc(newArgs#Z#0, TSeq(TSeq(TChar)), $Heap) && $Is(params#Z#0, TSeq(Tclass.GetOpt.OneArg())) && $IsAlloc(params#Z#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0)): DatatypeType);
    assume let#4#0#0 == $Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    assume $Is(let#4#0#0, Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())));
    assume _System.Tuple2.___hMake2_q(let#4#0#0);
    assume #_System._tuple#2._#Make2($Box(newArgs#Z#0), $Box(params#Z#0)) == let#4#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    ##opts#2 := newOpts#Z#0;
    assume $IsAlloc(##opts#2, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longMap#0 := Lit(Map#Empty(): Map);
    assume $IsAlloc(##longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#0 := Lit(Map#Empty(): Map);
    assume $IsAlloc(##shortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    assume $Is(Lit(Map#Empty(): Map), Tclass.GetOpt.CommandMap());
    ##commandMap#0 := Lit(Map#Empty(): Map);
    assume $IsAlloc(##commandMap#0, Tclass.GetOpt.CommandMap(), $Heap);
    assume {:subsumption 0} (forall x#0: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(##shortMap#0)[$Box(x#0)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#0)]]);
    assume (forall x#0: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(##shortMap#0)[$Box(x#0)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#0)]]);
    assume GetOpt.__default.GetMaps#canCall(newOpts#Z#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map));
    assume let#5#0#0 == GetOpt.__default.GetMaps($LS($LZ), newOpts#Z#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map));
    assume GetOpt.__default.GetMaps#canCall(newOpts#Z#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map));
    assume $Is(let#5#0#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    assume valueOrError2#Z#0 == let#5#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#Z#0);
    assume GetOpt.__default.GetOptions(opts#0, args#0) == Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#Z#0);
    assume $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon16;

  anon22_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    havoc longMap#Z#0;
    havoc shortMap#Z#0;
    havoc commandMap#Z#0;
    assume $Is(longMap#Z#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $IsAlloc(longMap#Z#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap) && $Is(shortMap#Z#0, TMap(TChar, TSeq(TChar))) && $IsAlloc(shortMap#Z#0, TMap(TChar, TSeq(TChar)), $Heap) && $Is(commandMap#Z#0, Tclass.GetOpt.CommandMap()) && $IsAlloc(commandMap#Z#0, Tclass.GetOpt.CommandMap(), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    assume _System.Tuple3.___hMake3_q($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0)): DatatypeType);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    assume $Is(let#6#0#0, Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()));
    assume _System.Tuple3.___hMake3_q(let#6#0#0);
    assume #_System._tuple#3._#Make3($Box(longMap#Z#0), $Box(shortMap#Z#0), $Box(commandMap#Z#0)) == let#6#0#0;
    havoc context#Z#0;
    assume $Is(context#Z#0, Tclass.GetOpt.Context()) && $IsAlloc(context#Z#0, Tclass.GetOpt.Context(), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume let#7#0#0 == #GetOpt.Context.Context(longMap#Z#0, shortMap#Z#0, inherits#Z#0, commandMap#Z#0, $Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume true;
    assume $Is(let#7#0#0, Tclass.GetOpt.Context());
    assume context#Z#0 == let#7#0#0;
    havoc valueOrError3#Z#0;
    assume $Is(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))) && $IsAlloc(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    ##args#1 := newArgs#Z#0;
    assume $IsAlloc(##args#1, TSeq(TSeq(TChar)), $Heap);
    ##context#0 := context#Z#0;
    assume $IsAlloc(##context#0, Tclass.GetOpt.Context(), $Heap);
    ##parms#0 := params#Z#0;
    assume $IsAlloc(##parms#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##files#0, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#1: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#1)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#1)] ==> Map#Domain(GetOpt.Context.longMap(##context#0))[Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#1)]]);
    assume (forall x#1: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#1)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#1)] ==> Map#Domain(GetOpt.Context.longMap(##context#0))[Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#1)]]);
    assume GetOpt.__default.GetOptions2#canCall(newArgs#Z#0, context#Z#0, params#Z#0, Lit(Seq#Empty(): Seq));
    assume let#8#0#0 == GetOpt.__default.GetOptions2($LS($LZ), newArgs#Z#0, context#Z#0, params#Z#0, Lit(Seq#Empty(): Seq));
    assume GetOpt.__default.GetOptions2#canCall(newArgs#Z#0, context#Z#0, params#Z#0, Lit(Seq#Empty(): Seq));
    assume $Is(let#8#0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    assume valueOrError3#Z#0 == let#8#0#0;
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#Z#0);
    assume GetOpt.__default.GetOptions(opts#0, args#0) == Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#Z#0);
    assume $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon16;

  anon23_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    havoc result#Z#0;
    assume $Is(result#Z#0, Tclass.GetOpt.Parsed()) && $IsAlloc(result#Z#0, Tclass.GetOpt.Parsed(), $Heap);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    assume GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0)): DatatypeType);
    assume let#9#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    assume $Is(let#9#0#0, Tclass.GetOpt.Parsed());
    assume result#Z#0 == let#9#0#0;
    ##opts#3 := opts#0;
    assume $IsAlloc(##opts#3, Tclass.GetOpt.Options(), $Heap);
    ##args#2 := result#Z#0;
    assume $IsAlloc(##args#2, Tclass.GetOpt.Parsed(), $Heap);
    assume GetOpt.__default.PostProcess#canCall(opts#0, result#Z#0);
    assume GetOpt.__default.GetOptions(opts#0, args#0) == GetOpt.__default.PostProcess($LS($LZ), opts#0, result#Z#0);
    assume GetOpt.__default.PostProcess#canCall(opts#0, result#Z#0);
    assume $Is(GetOpt.__default.GetOptions(opts#0, args#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon16;

  anon16:
    assume b$reqreads#0;
    return;
}



function GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(GetOpt._default.IndexOf$T)) && $IsBox(v#0, GetOpt._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#0: int :: { Seq#Index(xs#0, j#0) } LitInt(0) <= j#0 && j#0 < GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#0) != v#0) && LitInt(0) <= GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), true, xs#0, v#0) } GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, xs#0, v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(GetOpt._default.IndexOf$T)) && $IsBox(v#0, GetOpt._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(xs#0, LitInt(0)) != v#0 ==> GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), true, xs#0, v#0) == (if Seq#Index(xs#0, LitInt(0)) == v#0 then 0 else 1 + GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, reveal_GetOpt._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), true, Lit(xs#0), v#0) } GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Lit(xs#0), v#0) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(GetOpt._default.IndexOf$T)) && $IsBox(v#0, GetOpt._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then 0 else 1 + GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), reveal_GetOpt._default.IndexOf, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)));
axiom 0 <= $FunctionContextHeight ==> (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Lit(xs#0), Lit(v#0)) || (0 < $FunctionContextHeight && $Is(xs#0, TSeq(GetOpt._default.IndexOf$T)) && $IsBox(v#0, GetOpt._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> (Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then 0 else 1 + GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), reveal_GetOpt._default.IndexOf, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))));
}

function GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T: Ty, xs#0: Seq, v#0: Box) : bool;

axiom (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), $reveal, xs#0, v#0) } GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($ly), $reveal, xs#0, v#0) == GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, AsFuelBottom($ly), $reveal, xs#0, v#0) } GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $ly, $reveal, xs#0, v#0) == GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LZ, $reveal, xs#0, v#0));

function GetOpt.__default.IndexOf#requires(Ty, LayerType, Seq, Box) : bool;

axiom (forall GetOpt._default.IndexOf$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { GetOpt.__default.IndexOf#requires(GetOpt._default.IndexOf$T, $ly, xs#0, v#0) } $Is(xs#0, TSeq(GetOpt._default.IndexOf$T)) && $IsBox(v#0, GetOpt._default.IndexOf$T) ==> (GetOpt.__default.IndexOf#requires(GetOpt._default.IndexOf$T, $ly, xs#0, v#0) <==> Seq#Contains(xs#0, v#0)));

procedure {:verboseName "GetOpt.IndexOf (well-formedness)"} CheckWellformed$$GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(GetOpt._default.IndexOf$T)), v#0: Box where $IsBox(v#0, GetOpt._default.IndexOf$T)) returns (i#0: int where LitInt(0) <= i#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17203"} i#0 < Seq#Length(xs#0);
  free ensures {:id "id17204"} Seq#Index(xs#0, i#0) == v#0;
  free ensures {:id "id17205"} (forall j#1: int :: { Seq#Index(xs#0, j#1) } LitInt(0) <= j#1 && j#1 < i#0 ==> Seq#Index(xs#0, j#1) != v#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.IndexOf (well-formedness)"} CheckWellformed$$GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T: Ty, xs#0: Seq, v#0: Box) returns (i#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#2: int;
  var ##xs#0: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.IndexOf", " | ", GetOpt._default.IndexOf$T, " | ", xs#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(723,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Contains(xs#0, v#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume LitInt(0) <= GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, xs#0, v#0);
    assume i#0 < Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, i#0) == v#0;
    havoc j#2;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= j#2;
    goto anon5;

  anon14_Else:
    assume {:partition} j#2 < LitInt(0);
    goto anon5;

  anon5:
    assume LitInt(0) <= j#2 && j#2 < i#0;
    assume 0 <= j#2 && j#2 < Seq#Length(xs#0);
    assume Seq#Index(xs#0, j#2) != v#0;
    goto anon7;

  anon13_Else:
    assume LitInt(0) <= j#2 && j#2 < i#0 ==> Seq#Index(xs#0, j#2) != v#0;
    goto anon7;

  anon7:
    assume (forall j#1: int :: { Seq#Index(xs#0, j#1) } LitInt(0) <= j#1 && j#1 < i#0 ==> Seq#Index(xs#0, j#1) != v#0);
    assume false;
    return;

  anon12_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(xs#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Index(xs#0, LitInt(0)) == v#0;
    assume $Is(LitInt(0), Tclass._System.nat());
    assume GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, xs#0, v#0) == LitInt(0);
    assume true;
    assume $Is(GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, xs#0, v#0), Tclass._System.nat());
    goto anon11;

  anon15_Else:
    assume {:partition} Seq#Index(xs#0, LitInt(0)) != v#0;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(xs#0);
    ##xs#0 := Seq#Drop(xs#0, LitInt(1));
    assume $IsAlloc(##xs#0, TSeq(GetOpt._default.IndexOf$T), $Heap);
    ##v#0 := v#0;
    assume $IsAllocBox(##v#0, GetOpt._default.IndexOf$T, $Heap);
    assume {:subsumption 0} Seq#Contains(##xs#0, ##v#0);
    assume Seq#Contains(##xs#0, ##v#0);
    assume Seq#Rank(##xs#0) < Seq#Rank(xs#0);
    assume GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume $Is(1 + GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0), Tclass._System.nat());
    assume GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, xs#0, v#0) == 1 + GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume GetOpt.__default.IndexOf#canCall(GetOpt._default.IndexOf$T, Seq#Drop(xs#0, LitInt(1)), v#0);
    assume $Is(GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, xs#0, v#0), Tclass._System.nat());
    goto anon11;

  anon11:
    assume GetOpt.__default.IndexOf(GetOpt._default.IndexOf$T, $LS($LZ), reveal_GetOpt._default.IndexOf, xs#0, v#0) == i#0;
    return;
}



function GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0) } GetOpt.__default.SplitOnce#canCall(GetOpt._default.SplitOnce$T, s#0, delim#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)) && $IsBox(delim#0, GetOpt._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0))): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0))): Seq), s#0) && !Seq#Contains($Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0))): Seq, delim#0) && $Is(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(GetOpt._default.SplitOnce$T), TSeq(GetOpt._default.SplitOnce$T))));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { $IsAlloc(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(GetOpt._default.SplitOnce$T), TSeq(GetOpt._default.SplitOnce$T)), $Heap) } (GetOpt.__default.SplitOnce#canCall(GetOpt._default.SplitOnce$T, s#0, delim#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)) && $IsAlloc(s#0, TSeq(GetOpt._default.SplitOnce$T), $Heap) && $IsBox(delim#0, GetOpt._default.SplitOnce$T) && $IsAllocBox(delim#0, GetOpt._default.SplitOnce$T, $Heap) && Seq#Contains(s#0, delim#0))) && $IsGoodHeap($Heap) ==> $IsAlloc(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(GetOpt._default.SplitOnce$T), TSeq(GetOpt._default.SplitOnce$T)), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0) } GetOpt.__default.SplitOnce#canCall(GetOpt._default.SplitOnce$T, s#0, delim#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)) && $IsBox(delim#0, GetOpt._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> GetOpt.__default.IndexOf#canCall(GetOpt._default.SplitOnce$T, s#0, delim#0) && GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0) == (var i#0 := GetOpt.__default.IndexOf(GetOpt._default.SplitOnce$T, $LS($LZ), reveal_GetOpt._default.IndexOf, s#0, delim#0); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#0)), $Box(Seq#Drop(s#0, i#0 + 1)))));
axiom 1 <= $FunctionContextHeight ==> (forall GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, Lit(s#0), delim#0) } GetOpt.__default.SplitOnce#canCall(GetOpt._default.SplitOnce$T, Lit(s#0), delim#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)) && $IsBox(delim#0, GetOpt._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> GetOpt.__default.IndexOf#canCall(GetOpt._default.SplitOnce$T, Lit(s#0), delim#0) && GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#1 := GetOpt.__default.IndexOf(GetOpt._default.SplitOnce$T, $LS($LZ), reveal_GetOpt._default.IndexOf, Lit(s#0), delim#0); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#1)), $Box(Seq#Drop(Lit(s#0), i#1 + 1)))));
axiom 1 <= $FunctionContextHeight ==> (forall GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } GetOpt.__default.SplitOnce#canCall(GetOpt._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)) && $IsBox(delim#0, GetOpt._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> GetOpt.__default.IndexOf#canCall(GetOpt._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) && GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#2 := GetOpt.__default.IndexOf(GetOpt._default.SplitOnce$T, $LS($LZ), reveal_GetOpt._default.IndexOf, Lit(s#0), Lit(delim#0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#2)), $Box(Seq#Drop(Lit(s#0), i#2 + 1)))));
}

function GetOpt.__default.SplitOnce#canCall(GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box) : bool;

function GetOpt.__default.SplitOnce#requires(Ty, Seq, Box) : bool;

axiom (forall GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { GetOpt.__default.SplitOnce#requires(GetOpt._default.SplitOnce$T, s#0, delim#0) } $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)) && $IsBox(delim#0, GetOpt._default.SplitOnce$T) ==> (GetOpt.__default.SplitOnce#requires(GetOpt._default.SplitOnce$T, s#0, delim#0) <==> Seq#Contains(s#0, delim#0)));

procedure {:verboseName "GetOpt.SplitOnce (well-formedness)"} CheckWellformed$$GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T: Ty, s#0: Seq where $Is(s#0, TSeq(GetOpt._default.SplitOnce$T)), delim#0: Box where $IsBox(delim#0, GetOpt._default.SplitOnce$T)) returns (res#0: DatatypeType where $Is(res#0, Tclass._System.Tuple2(TSeq(GetOpt._default.SplitOnce$T), TSeq(GetOpt._default.SplitOnce$T))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17224"} Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(res#0)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(res#0)): Seq), s#0);
  free ensures {:id "id17225"} !Seq#Contains($Unbox(_System.Tuple2._0(res#0)): Seq, delim#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.SplitOnce (well-formedness)"} CheckWellformed$$GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#Z#0: int;
  var let#0#0#0: int;
  var ##xs#0: Seq;
  var ##v#0: Box;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.SplitOnce", " | ", GetOpt._default.SplitOnce$T, " | ", s#0, " | ", delim#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(732,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Contains(s#0, delim#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(GetOpt._default.SplitOnce$T), TSeq(GetOpt._default.SplitOnce$T)));
    assume _System.Tuple2.___hMake2_q(res#0);
    assume _System.Tuple2.___hMake2_q(res#0);
    assume Seq#Equal(Seq#Append(Seq#Append($Unbox(_System.Tuple2._0(res#0)): Seq, Seq#Build(Seq#Empty(): Seq, delim#0)), $Unbox(_System.Tuple2._1(res#0)): Seq), s#0);
    assume _System.Tuple2.___hMake2_q(res#0);
    assume !Seq#Contains($Unbox(_System.Tuple2._0(res#0)): Seq, delim#0);
    assume false;
    return;

  anon4_Else:
    havoc i#Z#0;
    assume LitInt(0) <= i#Z#0;
    ##xs#0 := s#0;
    assume $IsAlloc(##xs#0, TSeq(GetOpt._default.SplitOnce$T), $Heap);
    ##v#0 := delim#0;
    assume $IsAllocBox(##v#0, GetOpt._default.SplitOnce$T, $Heap);
    assume {:subsumption 0} Seq#Contains(##xs#0, ##v#0);
    assume Seq#Contains(##xs#0, ##v#0);
    assume GetOpt.__default.IndexOf#canCall(GetOpt._default.SplitOnce$T, s#0, delim#0);
    assume let#0#0#0 == GetOpt.__default.IndexOf(GetOpt._default.SplitOnce$T, $LS($LZ), reveal_GetOpt._default.IndexOf, s#0, delim#0);
    assume GetOpt.__default.IndexOf#canCall(GetOpt._default.SplitOnce$T, s#0, delim#0);
    assume $Is(let#0#0#0, Tclass._System.nat());
    assume i#Z#0 == let#0#0#0;
    assume 0 <= i#Z#0 && i#Z#0 <= Seq#Length(s#0);
    assume 0 <= i#Z#0 + 1 && i#Z#0 + 1 <= Seq#Length(s#0);
    assume GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0) == #_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#Z#0)), $Box(Seq#Drop(s#0, i#Z#0 + 1)));
    assume true;
    assume $Is(GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0), Tclass._System.Tuple2(TSeq(GetOpt._default.SplitOnce$T), TSeq(GetOpt._default.SplitOnce$T)));
    assume GetOpt.__default.SplitOnce(GetOpt._default.SplitOnce$T, s#0, delim#0) == res#0;
    return;
}



function GetOpt.__default.GetOptions2($ly: LayerType, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: { GetOpt.__default.GetOptions2($ly, args#0, context#0, parms#0, files#0) } GetOpt.__default.GetOptions2#canCall(args#0, context#0, parms#0, files#0) || (4 < $FunctionContextHeight && $Is(args#0, TSeq(TSeq(TChar))) && $Is(context#0, Tclass.GetOpt.Context()) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(files#0, TSeq(TSeq(TChar))) && (forall x#0: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#0)]): Seq } { Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#0)] ==> Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#0)]])) ==> $Is(GetOpt.__default.GetOptions2($ly, args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: { GetOpt.__default.GetOptions2($LS($ly), args#0, context#0, parms#0, files#0), $IsGoodHeap($Heap) } GetOpt.__default.GetOptions2#canCall(args#0, context#0, parms#0, files#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(context#0, Tclass.GetOpt.Context()) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(files#0, TSeq(TSeq(TChar))) && (forall x#1: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#1)]): Seq } { Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#1)] ==> Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#1)]])) ==> (Seq#Length(args#0) == LitInt(0) ==> GetOpt.Context.Context_q(context#0)) && (Seq#Length(args#0) != LitInt(0) ==> GetOpt.Context.Context_q(context#0) && (Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))] ==> (forall $l#1#o#0: DatatypeType :: $Is($l#1#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#1#o#0)) && GetOpt.Context.Context_q(context#0) && GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#2#o#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#o#0: Box :: $IsBox($l#2#o#0, Tclass.GetOpt.Param())), (lambda $l#2#heap#0: Heap, $l#2#o#0: Box :: SetRef_to_SetBox((lambda $l#2#o#1: ref :: false))))), $ly)), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType)) && (var inherits#0 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#3#o#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#o#0: Box :: $IsBox($l#3#o#0, Tclass.GetOpt.Param())), (lambda $l#3#heap#0: Heap, $l#3#o#0: Box :: SetRef_to_SetBox((lambda $l#3#o#1: ref :: false))))), $ly)), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType)); GetOpt.Context.Context_q(context#0) && GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType) && GetOpt.Context.Context_q(context#0) && (var newOpts#0 := Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType), GetOpt.Context.inherits(context#0)); GetOpt.__default.TestPositionals#canCall(newOpts#0, Lit(#Wrappers.Option.None())) && (var valueOrError0#0 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#0, Lit(#Wrappers.Option.None())); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#0) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#0)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) ==> GetOpt.__default.GetPositionals#canCall(newOpts#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq)) && (var valueOrError1#0 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) && (var newArgs#0, params#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq; GetOpt.__default.GetMaps#canCall(newOpts#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)) && (var valueOrError2#0 := GetOpt.__default.GetMaps($LS($LZ), newOpts#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) && (var longMap#0, shortMap#0, commandSet#0 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map; GetOpt.Context.Context_q(context#0) && (var newContext#0 := #GetOpt.Context.Context(longMap#0, shortMap#0, Seq#Append(GetOpt.Context.inherits(context#0), inherits#0), commandSet#0, $Unbox(Seq#Index(args#0, LitInt(0))): Seq); (var lostArgs#0 := Seq#Length(args#0) - Seq#Length(newArgs#0); GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, lostArgs#0), newContext#0, params#0, Lit(Seq#Empty(): Seq)) && (var valueOrError3#0 := GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, lostArgs#0), newContext#0, params#0, Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#0)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) && GetOpt.Context.Context_q(context#0)))))))))))))))) && (!Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))] ==> (Seq#Equal($Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) ==> GetOpt.Context.Context_q(context#0)) && (!Seq#Equal($Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) ==> (Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))) ==> (var longOpt#0 := Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(2)); (Seq#Contains(longOpt#0, $Box(char#FromInt(61))) ==> GetOpt.__default.SplitOnce#canCall(TChar, longOpt#0, $Box(Lit(char#FromInt(61)))) && (var opt#0, arg#0 := $Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(TChar, longOpt#0, $Box(Lit(char#FromInt(61)))))): Seq, $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(TChar, longOpt#0, $Box(Lit(char#FromInt(61)))))): Seq; GetOpt.Context.Context_q(context#0) && (Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#0)] ==> GetOpt.Context.Context_q(context#0) && GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#0)]): DatatypeType) && (GetOpt.Param.NeedsArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#0)]): DatatypeType) ==> GetOpt.Context.Context_q(context#0) && GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#0))) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#0)))), files#0))))) && (!Seq#Contains(longOpt#0, $Box(char#FromInt(61))) ==> GetOpt.Context.Context_q(context#0) && (Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#0)] ==> GetOpt.Context.Context_q(context#0) && (var opt#1 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#0)]): DatatypeType; GetOpt.Param.NeedsArg#canCall(opt#1) && (GetOpt.Param.NeedsArg(opt#1) ==> 2 <= Seq#Length(args#0) ==> GetOpt.Param.MakeArg#canCall(opt#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0)) && (!GetOpt.Param.NeedsArg(opt#1) ==> !(GetOpt.Param.Flag_q(opt#1) && GetOpt.Param.solo(opt#1) && (Seq#Length(args#0) != 1 || Seq#Length(parms#0) != 0 || Seq#Length(files#0) != 0)) ==> GetOpt.Param.MakeArg#canCall(opt#1, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#1, Lit(#Wrappers.Option.None()))), files#0))))))) && (!(Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))))) ==> (Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq) ==> GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))))) && (!Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))) ==> GetOpt.Context.Context_q(context#0) && GetOpt.Context.Context_q(context#0) && GetOpt.__default.GetShort#canCall(Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq)) && (var valueOrError4#0 := GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#0)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0) && (var newParms#0, nextParm#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0)): DatatypeType)): DatatypeType; (Wrappers.Option.None_q(nextParm#0) ==> GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, newParms#0), files#0)) && (!Wrappers.Option.None_q(nextParm#0) ==> Seq#Length(args#0) != LitInt(1) ==> GetOpt.Context.Context_q(context#0) && (var longOpt#1 := $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[Wrappers.Option.value(nextParm#0)]): Seq; GetOpt.Context.Context_q(context#0) && (var opt#2 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#1)]): DatatypeType; GetOpt.Param.MakeArg#canCall(opt#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(Seq#Append(parms#0, newParms#0), GetOpt.Param.MakeArg(opt#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0)))))))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))))) ==> GetOpt.Context.Context_q(context#0) && (Map#Card(GetOpt.Context.commands(context#0)) == LitInt(0) ==> GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))))) && (Map#Card(GetOpt.Context.commands(context#0)) != LitInt(0) ==> GetOpt.Context.Context_q(context#0) && GetOpt.Context.Context_q(context#0)))))))) && GetOpt.__default.GetOptions2($LS($ly), args#0, context#0, parms#0, files#0) == (if Seq#Length(args#0) == LitInt(0) then #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, files#0, Lit(#Wrappers.Option.None())))) else (if Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))] then (var inherits#0 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#0#o#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#o#0: Box :: $IsBox($l#0#o#0, Tclass.GetOpt.Param())), (lambda $l#0#heap#0: Heap, $l#0#o#0: Box :: SetRef_to_SetBox((lambda $l#0#o#1: ref :: false))))), $ly)), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType)); (var newOpts#0 := Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType), GetOpt.Context.inherits(context#0)); (var valueOrError0#0 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#0, Lit(#Wrappers.Option.None())); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#0) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#0) else (var valueOrError1#0 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#0) else (var newArgs#0, params#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#0)): DatatypeType)): Seq; (var valueOrError2#0 := GetOpt.__default.GetMaps($LS($LZ), newOpts#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#0) else (var longMap#0, shortMap#0, commandSet#0 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#0)): DatatypeType)): Map; (var newContext#0 := #GetOpt.Context.Context(longMap#0, shortMap#0, Seq#Append(GetOpt.Context.inherits(context#0), inherits#0), commandSet#0, $Unbox(Seq#Index(args#0, LitInt(0))): Seq); (var lostArgs#0 := Seq#Length(args#0) - Seq#Length(newArgs#0); (var valueOrError3#0 := GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, lostArgs#0), newContext#0, params#0, Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#0) else (var result#0 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#0)): DatatypeType; #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, files#0, #Wrappers.Option.Some($Box(result#0)))))))))))))))))))) else (if Seq#Equal($Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) then #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, Seq#Append(files#0, Seq#Drop(args#0, LitInt(1))), Lit(#Wrappers.Option.None())))) else (if Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))) then (var longOpt#0 := Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(2)); (if Seq#Contains(longOpt#0, $Box(char#FromInt(61))) then (var opt#0, arg#0 := $Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(TChar, longOpt#0, $Box(Lit(char#FromInt(61)))))): Seq, $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(TChar, longOpt#0, $Box(Lit(char#FromInt(61)))))): Seq; (if Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#0)] then (if GetOpt.Param.NeedsArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#0)]): DatatypeType) then GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#0)))), files#0) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46)))))))) else (if Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#0)] then (var opt#1 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#0)]): DatatypeType; (if GetOpt.Param.NeedsArg(opt#1) then (if Seq#Length(args#0) < 2 then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0)) else (if GetOpt.Param.Flag_q(opt#1) && GetOpt.Param.solo(opt#1) && (Seq#Length(args#0) != 1 || Seq#Length(parms#0) != 0 || Seq#Length(files#0) != 0) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), longOpt#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(117))), $Box(char#FromInt(102))), $Box(char#FromInt(102))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(108))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#1, Lit(#Wrappers.Option.None()))), files#0)))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))))))) else (if Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq) then GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0))))) else (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))) then (var valueOrError4#0 := GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#0) else (var newParms#0, nextParm#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#0)): DatatypeType)): DatatypeType; (if Wrappers.Option.None_q(nextParm#0) then GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, newParms#0), files#0) else (if Seq#Length(args#0) == LitInt(1) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(nextParm#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else (var longOpt#1 := $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[Wrappers.Option.value(nextParm#0)]): Seq; (var opt#2 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#1)]): DatatypeType; GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(Seq#Append(parms#0, newParms#0), GetOpt.Param.MakeArg(opt#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0)))))))) else (if Map#Card(GetOpt.Context.commands(context#0)) == LitInt(0) then GetOpt.__default.GetOptions2($ly, Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Context.command(context#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(82))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), GetOpt.Context.command(context#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(112))), $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(97))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: {:weight 3} { GetOpt.__default.GetOptions2($LS($ly), Lit(args#0), context#0, parms#0, files#0), $IsGoodHeap($Heap) } GetOpt.__default.GetOptions2#canCall(Lit(args#0), context#0, parms#0, files#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(context#0, Tclass.GetOpt.Context()) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(files#0, TSeq(TSeq(TChar))) && (forall x#2: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#2)]): Seq } { Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#2)] } $Is(x#2, TChar) && Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#2)] ==> Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#2)]])) ==> (Seq#Length(Lit(args#0)) == LitInt(0) ==> GetOpt.Context.Context_q(context#0)) && (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.Context.Context_q(context#0) && (Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))] ==> (forall $l#5#o#0: DatatypeType :: $Is($l#5#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#5#o#0)) && GetOpt.Context.Context_q(context#0) && GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#6#o#0): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#o#0: Box :: $IsBox($l#6#o#0, Tclass.GetOpt.Param())), (lambda $l#6#heap#0: Heap, $l#6#o#0: Box :: SetRef_to_SetBox((lambda $l#6#o#1: ref :: false))))), $LS($ly))), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType)) && (var inherits#1 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#7#o#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#o#0: Box :: $IsBox($l#7#o#0, Tclass.GetOpt.Param())), (lambda $l#7#heap#0: Heap, $l#7#o#0: Box :: SetRef_to_SetBox((lambda $l#7#o#1: ref :: false))))), $LS($ly))), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType)); GetOpt.Context.Context_q(context#0) && GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType) && GetOpt.Context.Context_q(context#0) && (var newOpts#1 := Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType), GetOpt.Context.inherits(context#0)); GetOpt.__default.TestPositionals#canCall(newOpts#1, Lit(#Wrappers.Option.None())) && (var valueOrError0#1 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#1, Lit(#Wrappers.Option.None())); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#1) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#1)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) ==> GetOpt.__default.GetPositionals#canCall(newOpts#1, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)) && (var valueOrError1#1 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#1, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) && (var newArgs#1, params#1 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq; GetOpt.__default.GetMaps#canCall(newOpts#1, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)) && (var valueOrError2#1 := GetOpt.__default.GetMaps($LS($LZ), newOpts#1, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) && (var longMap#1, shortMap#1, commandSet#1 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map; GetOpt.Context.Context_q(context#0) && (var newContext#1 := #GetOpt.Context.Context(longMap#1, shortMap#1, Seq#Append(GetOpt.Context.inherits(context#0), inherits#1), commandSet#1, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); (var lostArgs#1 := Seq#Length(Lit(args#0)) - Seq#Length(newArgs#1); GetOpt.__default.GetOptions2#canCall(Seq#Drop(Lit(args#0), lostArgs#1), newContext#1, params#1, Lit(Seq#Empty(): Seq)) && (var valueOrError3#1 := GetOpt.__default.GetOptions2($LS($ly), Seq#Drop(Lit(args#0), lostArgs#1), newContext#1, params#1, Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#1)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) && GetOpt.Context.Context_q(context#0)))))))))))))))) && (!Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))] ==> (Seq#Equal($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) ==> GetOpt.Context.Context_q(context#0)) && (!Seq#Equal($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) ==> (Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))) ==> (var longOpt#2 := Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(2)); (Seq#Contains(longOpt#2, $Box(char#FromInt(61))) ==> GetOpt.__default.SplitOnce#canCall(TChar, longOpt#2, $Box(Lit(char#FromInt(61)))) && (var opt#3, arg#1 := $Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(TChar, longOpt#2, $Box(Lit(char#FromInt(61)))))): Seq, $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(TChar, longOpt#2, $Box(Lit(char#FromInt(61)))))): Seq; GetOpt.Context.Context_q(context#0) && (Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#3)] ==> GetOpt.Context.Context_q(context#0) && GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#3)]): DatatypeType) && (GetOpt.Param.NeedsArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#3)]): DatatypeType) ==> GetOpt.Context.Context_q(context#0) && GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#3)]): DatatypeType, #Wrappers.Option.Some($Box(arg#1))) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#3)]): DatatypeType, #Wrappers.Option.Some($Box(arg#1)))), files#0))))) && (!Seq#Contains(longOpt#2, $Box(char#FromInt(61))) ==> GetOpt.Context.Context_q(context#0) && (Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#2)] ==> GetOpt.Context.Context_q(context#0) && (var opt#4 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#2)]): DatatypeType; GetOpt.Param.NeedsArg#canCall(opt#4) && (GetOpt.Param.NeedsArg(opt#4) ==> 2 <= Seq#Length(Lit(args#0)) ==> GetOpt.Param.MakeArg#canCall(opt#4, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(2))), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#4, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), files#0)) && (!GetOpt.Param.NeedsArg(opt#4) ==> !(GetOpt.Param.Flag_q(opt#4) && GetOpt.Param.solo(opt#4) && (Seq#Length(Lit(args#0)) != 1 || Seq#Length(parms#0) != 0 || Seq#Length(files#0) != 0)) ==> GetOpt.Param.MakeArg#canCall(opt#4, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#4, Lit(#Wrappers.Option.None()))), files#0))))))) && (!(Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))))) ==> (Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) ==> GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0)))))) && (!Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))) ==> GetOpt.Context.Context_q(context#0) && GetOpt.Context.Context_q(context#0) && GetOpt.__default.GetShort#canCall(Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq)) && (var valueOrError4#1 := GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#1)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1) && (var newParms#1, nextParm#1 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1)): DatatypeType)): DatatypeType; (Wrappers.Option.None_q(nextParm#1) ==> GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, Seq#Append(parms#0, newParms#1), files#0)) && (!Wrappers.Option.None_q(nextParm#1) ==> Seq#Length(Lit(args#0)) != LitInt(1) ==> GetOpt.Context.Context_q(context#0) && (var longOpt#3 := $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[Wrappers.Option.value(nextParm#1)]): Seq; GetOpt.Context.Context_q(context#0) && (var opt#5 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#3)]): DatatypeType; GetOpt.Param.MakeArg#canCall(opt#5, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(2))), context#0, Seq#Append(Seq#Append(parms#0, newParms#1), GetOpt.Param.MakeArg(opt#5, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), files#0)))))))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))))) ==> GetOpt.Context.Context_q(context#0) && (Map#Card(GetOpt.Context.commands(context#0)) == LitInt(0) ==> GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0)))))) && (Map#Card(GetOpt.Context.commands(context#0)) != LitInt(0) ==> GetOpt.Context.Context_q(context#0) && GetOpt.Context.Context_q(context#0)))))))) && GetOpt.__default.GetOptions2($LS($ly), Lit(args#0), context#0, parms#0, files#0) == (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, files#0, Lit(#Wrappers.Option.None())))) else (if Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))] then (var inherits#1 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#4#o#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#o#0: Box :: $IsBox($l#4#o#0, Tclass.GetOpt.Param())), (lambda $l#4#heap#0: Heap, $l#4#o#0: Box :: SetRef_to_SetBox((lambda $l#4#o#1: ref :: false))))), $LS($ly))), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType)); (var newOpts#1 := Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType), GetOpt.Context.inherits(context#0)); (var valueOrError0#1 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#1, Lit(#Wrappers.Option.None())); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#1) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#1) else (var valueOrError1#1 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#1, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#1) else (var newArgs#1, params#1 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#1)): DatatypeType)): Seq; (var valueOrError2#1 := GetOpt.__default.GetMaps($LS($LZ), newOpts#1, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#1) else (var longMap#1, shortMap#1, commandSet#1 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#1)): DatatypeType)): Map; (var newContext#1 := #GetOpt.Context.Context(longMap#1, shortMap#1, Seq#Append(GetOpt.Context.inherits(context#0), inherits#1), commandSet#1, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); (var lostArgs#1 := Seq#Length(Lit(args#0)) - Seq#Length(newArgs#1); (var valueOrError3#1 := GetOpt.__default.GetOptions2($LS($ly), Seq#Drop(Lit(args#0), lostArgs#1), newContext#1, params#1, Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#1) else (var result#1 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#1)): DatatypeType; #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, files#0, #Wrappers.Option.Some($Box(result#1)))))))))))))))))))) else (if Seq#Equal($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) then #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, Seq#Append(files#0, Seq#Drop(Lit(args#0), LitInt(1))), Lit(#Wrappers.Option.None())))) else (if Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))) then (var longOpt#2 := Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(2)); (if Seq#Contains(longOpt#2, $Box(char#FromInt(61))) then (var opt#3, arg#1 := $Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(TChar, longOpt#2, $Box(Lit(char#FromInt(61)))))): Seq, $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(TChar, longOpt#2, $Box(Lit(char#FromInt(61)))))): Seq; (if Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#3)] then (if GetOpt.Param.NeedsArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#3)]): DatatypeType) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#3)]): DatatypeType, #Wrappers.Option.Some($Box(arg#1)))), files#0) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#3), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#3), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46)))))))) else (if Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#2)] then (var opt#4 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#2)]): DatatypeType; (if GetOpt.Param.NeedsArg(opt#4) then (if Seq#Length(Lit(args#0)) < 2 then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#2), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(2))), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#4, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), files#0)) else (if GetOpt.Param.Flag_q(opt#4) && GetOpt.Param.solo(opt#4) && (Seq#Length(Lit(args#0)) != 1 || Seq#Length(parms#0) != 0 || Seq#Length(files#0) != 0) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), longOpt#2), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(117))), $Box(char#FromInt(102))), $Box(char#FromInt(102))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(108))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#4, Lit(#Wrappers.Option.None()))), files#0)))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#2), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))))))) else (if Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0))))) else (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))) then (var valueOrError4#1 := GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#1) else (var newParms#1, nextParm#1 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#1)): DatatypeType)): DatatypeType; (if Wrappers.Option.None_q(nextParm#1) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, Seq#Append(parms#0, newParms#1), files#0) else (if Seq#Length(Lit(args#0)) == LitInt(1) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(nextParm#1))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else (var longOpt#3 := $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[Wrappers.Option.value(nextParm#1)]): Seq; (var opt#5 := $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#3)]): DatatypeType; GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(2))), context#0, Seq#Append(Seq#Append(parms#0, newParms#1), GetOpt.Param.MakeArg(opt#5, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), files#0)))))))) else (if Map#Card(GetOpt.Context.commands(context#0)) == LitInt(0) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Context.command(context#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(82))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), GetOpt.Context.command(context#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(112))), $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(97))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: {:weight 3} { GetOpt.__default.GetOptions2($LS($ly), Lit(args#0), Lit(context#0), Lit(parms#0), Lit(files#0)), $IsGoodHeap($Heap) } GetOpt.__default.GetOptions2#canCall(Lit(args#0), Lit(context#0), Lit(parms#0), Lit(files#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(context#0, Tclass.GetOpt.Context()) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(files#0, TSeq(TSeq(TChar))) && (forall x#3: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#3)]): Seq } { Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#3)] } $Is(x#3, TChar) && Map#Domain(GetOpt.Context.shortMap(Lit(context#0)))[$Box(x#3)] ==> Map#Domain(GetOpt.Context.longMap(Lit(context#0)))[Map#Elements(Lit(GetOpt.Context.shortMap(Lit(context#0))))[$Box(x#3)]])) ==> (Seq#Length(Lit(args#0)) == LitInt(0) ==> GetOpt.Context.Context_q(Lit(context#0))) && (Seq#Length(Lit(args#0)) != LitInt(0) ==> GetOpt.Context.Context_q(Lit(context#0)) && (Map#Domain(GetOpt.Context.commands(Lit(context#0)))[Seq#Index(Lit(args#0), LitInt(0))] ==> (forall $l#9#o#0: DatatypeType :: $Is($l#9#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#9#o#0)) && GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.Options.Options_q($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#10#o#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#o#0: Box :: $IsBox($l#10#o#0, Tclass.GetOpt.Param())), (lambda $l#10#heap#0: Heap, $l#10#o#0: Box :: SetRef_to_SetBox((lambda $l#10#o#1: ref :: false))))), $LS($ly))), GetOpt.Options.params($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType)) && (var inherits#2 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#11#o#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#o#0: Box :: $IsBox($l#11#o#0, Tclass.GetOpt.Param())), (lambda $l#11#heap#0: Heap, $l#11#o#0: Box :: SetRef_to_SetBox((lambda $l#11#o#1: ref :: false))))), $LS($ly))), GetOpt.Options.params($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType)); GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.Options.Options_q($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType) && GetOpt.Context.Context_q(Lit(context#0)) && (var newOpts#2 := Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType), GetOpt.Context.inherits(Lit(context#0))); GetOpt.__default.TestPositionals#canCall(newOpts#2, Lit(#Wrappers.Option.None())) && (var valueOrError0#2 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#2, Lit(#Wrappers.Option.None())); Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#2) && (Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#2) ==> Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#2)) && (!Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#2) ==> GetOpt.__default.GetPositionals#canCall(newOpts#2, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)) && (var valueOrError1#2 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#2, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) && (var newArgs#2, params#2 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq; GetOpt.__default.GetMaps#canCall(newOpts#2, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)) && (var valueOrError2#2 := GetOpt.__default.GetMaps($LS($LZ), newOpts#2, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) && (var longMap#2, shortMap#2, commandSet#2 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map; GetOpt.Context.Context_q(Lit(context#0)) && (var newContext#2 := #GetOpt.Context.Context(longMap#2, shortMap#2, Seq#Append(GetOpt.Context.inherits(Lit(context#0)), inherits#2), commandSet#2, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); (var lostArgs#2 := Seq#Length(Lit(args#0)) - Seq#Length(newArgs#2); GetOpt.__default.GetOptions2#canCall(Seq#Drop(Lit(args#0), lostArgs#2), newContext#2, params#2, Lit(Seq#Empty(): Seq)) && (var valueOrError3#2 := GetOpt.__default.GetOptions2($LS($ly), Seq#Drop(Lit(args#0), lostArgs#2), newContext#2, params#2, Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) && (Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#2)) && (!Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) ==> Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) && GetOpt.Context.Context_q(Lit(context#0))))))))))))))))) && (!Map#Domain(GetOpt.Context.commands(Lit(context#0)))[Seq#Index(Lit(args#0), LitInt(0))] ==> (Seq#Equal($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) ==> GetOpt.Context.Context_q(Lit(context#0))) && (!Seq#Equal($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) ==> (Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))) ==> (var longOpt#4 := Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(2)); (Seq#Contains(longOpt#4, $Box(char#FromInt(61))) ==> GetOpt.__default.SplitOnce#canCall(TChar, longOpt#4, $Box(Lit(char#FromInt(61)))) && (var opt#6, arg#2 := $Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(TChar, longOpt#4, $Box(Lit(char#FromInt(61)))))): Seq, $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(TChar, longOpt#4, $Box(Lit(char#FromInt(61)))))): Seq; GetOpt.Context.Context_q(Lit(context#0)) && (Map#Domain(GetOpt.Context.longMap(Lit(context#0)))[$Box(opt#6)] ==> GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(opt#6)]): DatatypeType) && (GetOpt.Param.NeedsArg($Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(opt#6)]): DatatypeType) ==> GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(opt#6)]): DatatypeType, #Wrappers.Option.Some($Box(arg#2))) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(opt#6)]): DatatypeType, #Wrappers.Option.Some($Box(arg#2)))), Lit(files#0)))))) && (!Seq#Contains(longOpt#4, $Box(char#FromInt(61))) ==> GetOpt.Context.Context_q(Lit(context#0)) && (Map#Domain(GetOpt.Context.longMap(Lit(context#0)))[$Box(longOpt#4)] ==> GetOpt.Context.Context_q(Lit(context#0)) && (var opt#7 := $Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(longOpt#4)]): DatatypeType; GetOpt.Param.NeedsArg#canCall(opt#7) && (GetOpt.Param.NeedsArg(opt#7) ==> 2 <= Seq#Length(Lit(args#0)) ==> GetOpt.Param.MakeArg#canCall(opt#7, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(2))), Lit(context#0), Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#7, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), Lit(files#0))) && (!GetOpt.Param.NeedsArg(opt#7) ==> !(GetOpt.Param.Flag_q(opt#7) && GetOpt.Param.solo(opt#7) && (Seq#Length(Lit(args#0)) != 1 || Seq#Length(Lit(parms#0)) != 0 || Seq#Length(Lit(files#0)) != 0)) ==> GetOpt.Param.MakeArg#canCall(opt#7, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#7, Lit(#Wrappers.Option.None()))), Lit(files#0)))))))) && (!(Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))))) ==> (Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) ==> GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Lit(parms#0), Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0)))))) && (!Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))) ==> GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.__default.GetShort#canCall(Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(1)), Lit(GetOpt.Context.longMap(Lit(context#0))), Lit(GetOpt.Context.shortMap(Lit(context#0))), Lit(Seq#Empty(): Seq)) && (var valueOrError4#2 := GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(1)), Lit(GetOpt.Context.longMap(Lit(context#0))), Lit(GetOpt.Context.shortMap(Lit(context#0))), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2) && (Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#2)) && (!Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2) ==> Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2) && (var newParms#2, nextParm#2 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2)): DatatypeType)): DatatypeType; (Wrappers.Option.None_q(nextParm#2) ==> GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Seq#Append(parms#0, newParms#2), Lit(files#0))) && (!Wrappers.Option.None_q(nextParm#2) ==> Seq#Length(Lit(args#0)) != LitInt(1) ==> GetOpt.Context.Context_q(Lit(context#0)) && (var longOpt#5 := $Unbox(Map#Elements(Lit(GetOpt.Context.shortMap(Lit(context#0))))[Wrappers.Option.value(nextParm#2)]): Seq; GetOpt.Context.Context_q(Lit(context#0)) && (var opt#8 := $Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(longOpt#5)]): DatatypeType; GetOpt.Param.MakeArg#canCall(opt#8, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(2))), Lit(context#0), Seq#Append(Seq#Append(parms#0, newParms#2), GetOpt.Param.MakeArg(opt#8, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), Lit(files#0))))))))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))))) ==> GetOpt.Context.Context_q(Lit(context#0)) && (Map#Card(Lit(GetOpt.Context.commands(Lit(context#0)))) == LitInt(0) ==> GetOpt.__default.GetOptions2#canCall(Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Lit(parms#0), Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0)))))) && (Map#Card(Lit(GetOpt.Context.commands(Lit(context#0)))) != LitInt(0) ==> GetOpt.Context.Context_q(Lit(context#0)) && GetOpt.Context.Context_q(Lit(context#0))))))))) && GetOpt.__default.GetOptions2($LS($ly), Lit(args#0), Lit(context#0), Lit(parms#0), Lit(files#0)) == (if Seq#Length(Lit(args#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#GetOpt.Parsed.Parsed(Lit(GetOpt.Context.command(Lit(context#0))), Lit(parms#0), Lit(files#0), Lit(#Wrappers.Option.None()))))) else (if Map#Domain(GetOpt.Context.commands(Lit(context#0)))[Seq#Index(Lit(args#0), LitInt(0))] then (var inherits#2 := GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#8#o#0): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#o#0: Box :: $IsBox($l#8#o#0, Tclass.GetOpt.Param())), (lambda $l#8#heap#0: Heap, $l#8#o#0: Box :: SetRef_to_SetBox((lambda $l#8#o#1: ref :: false))))), $LS($ly))), GetOpt.Options.params($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType)); (var newOpts#2 := Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(Lit(GetOpt.Context.commands(Lit(context#0))))[Seq#Index(Lit(args#0), LitInt(0))]): DatatypeType), GetOpt.Context.inherits(Lit(context#0))); (var valueOrError0#2 := GetOpt.__default.TestPositionals($LS($LZ), newOpts#2, Lit(#Wrappers.Option.None())); (if Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#2) then Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#2) else (var valueOrError1#2 := GetOpt.__default.GetPositionals($LS($LZ), newOpts#2, Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#2) else (var newArgs#2, params#2 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#2)): DatatypeType)): Seq; (var valueOrError2#2 := GetOpt.__default.GetMaps($LS($LZ), newOpts#2, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#2) else (var longMap#2, shortMap#2, commandSet#2 := $Unbox(_System.Tuple3._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map, $Unbox(_System.Tuple3._2($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#2)): DatatypeType)): Map; (var newContext#2 := #GetOpt.Context.Context(longMap#2, shortMap#2, Seq#Append(GetOpt.Context.inherits(Lit(context#0)), inherits#2), commandSet#2, $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq); (var lostArgs#2 := Seq#Length(Lit(args#0)) - Seq#Length(newArgs#2); (var valueOrError3#2 := GetOpt.__default.GetOptions2($LS($ly), Seq#Drop(Lit(args#0), lostArgs#2), newContext#2, params#2, Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2) then Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#2) else (var result#2 := $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#2)): DatatypeType; #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(Lit(GetOpt.Context.command(Lit(context#0))), Lit(parms#0), Lit(files#0), #Wrappers.Option.Some($Box(result#2)))))))))))))))))))) else (if Seq#Equal($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) then #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(Lit(GetOpt.Context.command(Lit(context#0))), Lit(parms#0), Seq#Append(files#0, Seq#Drop(Lit(args#0), LitInt(1))), Lit(#Wrappers.Option.None())))) else (if Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))) then (var longOpt#4 := Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(2)); (if Seq#Contains(longOpt#4, $Box(char#FromInt(61))) then (var opt#6, arg#2 := $Unbox(_System.Tuple2._0(GetOpt.__default.SplitOnce(TChar, longOpt#4, $Box(Lit(char#FromInt(61)))))): Seq, $Unbox(_System.Tuple2._1(GetOpt.__default.SplitOnce(TChar, longOpt#4, $Box(Lit(char#FromInt(61)))))): Seq; (if Map#Domain(GetOpt.Context.longMap(Lit(context#0)))[$Box(opt#6)] then (if GetOpt.Param.NeedsArg($Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(opt#6)]): DatatypeType) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(opt#6)]): DatatypeType, #Wrappers.Option.Some($Box(arg#2)))), Lit(files#0)) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#6), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#6), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46)))))))) else (if Map#Domain(GetOpt.Context.longMap(Lit(context#0)))[$Box(longOpt#4)] then (var opt#7 := $Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(longOpt#4)]): DatatypeType; (if GetOpt.Param.NeedsArg(opt#7) then (if Seq#Length(Lit(args#0)) < 2 then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#4), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(2))), Lit(context#0), Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#7, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), Lit(files#0))) else (if GetOpt.Param.Flag_q(opt#7) && GetOpt.Param.solo(opt#7) && (Seq#Length(Lit(args#0)) != 1 || Seq#Length(Lit(parms#0)) != 0 || Seq#Length(Lit(files#0)) != 0) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), longOpt#4), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(117))), $Box(char#FromInt(102))), $Box(char#FromInt(102))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(108))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#7, Lit(#Wrappers.Option.None()))), Lit(files#0))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#4), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))))))) else (if Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Lit(parms#0), Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0))))) else (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))) then (var valueOrError4#2 := GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq, LitInt(1)), Lit(GetOpt.Context.longMap(Lit(context#0))), Lit(GetOpt.Context.shortMap(Lit(context#0))), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2) then Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#2) else (var newParms#2, nextParm#2 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2)): DatatypeType)): Seq, $Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#2)): DatatypeType)): DatatypeType; (if Wrappers.Option.None_q(nextParm#2) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Seq#Append(parms#0, newParms#2), Lit(files#0)) else (if Seq#Length(Lit(args#0)) == LitInt(1) then #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(nextParm#2))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46)))))) else (var longOpt#5 := $Unbox(Map#Elements(Lit(GetOpt.Context.shortMap(Lit(context#0))))[Wrappers.Option.value(nextParm#2)]): Seq; (var opt#8 := $Unbox(Map#Elements(Lit(GetOpt.Context.longMap(Lit(context#0))))[$Box(longOpt#5)]): DatatypeType; GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(2))), Lit(context#0), Seq#Append(Seq#Append(parms#0, newParms#2), GetOpt.Param.MakeArg(opt#8, #Wrappers.Option.Some(Seq#Index(Lit(args#0), LitInt(1))))), Lit(files#0))))))))) else (if Map#Card(Lit(GetOpt.Context.commands(Lit(context#0)))) == LitInt(0) then GetOpt.__default.GetOptions2($LS($ly), Lit(Seq#Drop(Lit(args#0), LitInt(1))), Lit(context#0), Lit(parms#0), Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(args#0), LitInt(0))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Unbox(Seq#Index(Lit(args#0), LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Context.command(Lit(context#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(82))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), GetOpt.Context.command(Lit(context#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(112))), $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(97))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))))))))))));
}

function GetOpt.__default.GetOptions2#canCall(args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq) : bool;

axiom (forall $ly: LayerType, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: { GetOpt.__default.GetOptions2($LS($ly), args#0, context#0, parms#0, files#0) } GetOpt.__default.GetOptions2($LS($ly), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($ly, args#0, context#0, parms#0, files#0));

axiom (forall $ly: LayerType, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: { GetOpt.__default.GetOptions2(AsFuelBottom($ly), args#0, context#0, parms#0, files#0) } GetOpt.__default.GetOptions2($ly, args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LZ, args#0, context#0, parms#0, files#0));

function GetOpt.__default.GetOptions2#requires(LayerType, Seq, DatatypeType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq :: { GetOpt.__default.GetOptions2#requires($ly, args#0, context#0, parms#0, files#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(args#0, TSeq(TSeq(TChar))) && $Is(context#0, Tclass.GetOpt.Context()) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(files#0, TSeq(TSeq(TChar))) ==> (GetOpt.__default.GetOptions2#requires($ly, args#0, context#0, parms#0, files#0) <==> (forall x#1: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#1)]): Seq } { Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#1)] ==> Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#1)]])));

procedure {:verboseName "GetOpt.GetOptions2 (well-formedness)"} CheckWellformed$$GetOpt.__default.GetOptions2(args#0: Seq where $Is(args#0, TSeq(TSeq(TChar))), context#0: DatatypeType where $Is(context#0, Tclass.GetOpt.Context()), parms#0: Seq where $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())), files#0: Seq where $Is(files#0, TSeq(TSeq(TChar))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetOptions2 (well-formedness)"} CheckWellformed$$GetOpt.__default.GetOptions2(args#0: Seq, context#0: DatatypeType, parms#0: Seq, files#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#4: char;
  var inherits#Z#0: Seq;
  var let#0#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var o#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var newOpts#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##opts#0: Seq;
  var ##optional#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##opts#1: Seq;
  var ##args#0: Seq;
  var ##params#0: Seq;
  var newArgs#Z#0: Seq;
  var params#Z#0: Seq;
  var let#4#0#0: DatatypeType;
  var valueOrError2#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##opts#2: Seq;
  var ##longMap#0: Map;
  var ##shortMap#0: Map;
  var ##commandMap#0: Map;
  var longMap#Z#0: Map;
  var shortMap#Z#0: Map;
  var commandSet#Z#0: Map;
  var let#6#0#0: DatatypeType;
  var newContext#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var lostArgs#Z#0: int;
  var let#8#0#0: int;
  var valueOrError3#Z#0: DatatypeType;
  var let#9#0#0: DatatypeType;
  var ##args#1: Seq;
  var ##context#0: DatatypeType;
  var ##parms#0: Seq;
  var ##files#0: Seq;
  var result#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;
  var longOpt#Z#0: Seq;
  var let#11#0#0: Seq;
  var opt#Z#0: Seq;
  var arg#Z#0: Seq;
  var let#12#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##delim#0: char;
  var ##value#0: DatatypeType;
  var ##args#2: Seq;
  var ##context#1: DatatypeType;
  var ##parms#1: Seq;
  var ##files#1: Seq;
  var opt#Z#1: DatatypeType;
  var let#13#0#0: DatatypeType;
  var ##value#1: DatatypeType;
  var ##args#3: Seq;
  var ##context#2: DatatypeType;
  var ##parms#2: Seq;
  var ##files#2: Seq;
  var ##value#2: DatatypeType;
  var ##args#4: Seq;
  var ##context#3: DatatypeType;
  var ##parms#3: Seq;
  var ##files#3: Seq;
  var ##args#5: Seq;
  var ##context#4: DatatypeType;
  var ##parms#4: Seq;
  var ##files#4: Seq;
  var valueOrError4#Z#0: DatatypeType;
  var let#14#0#0: DatatypeType;
  var ##arg#0: Seq;
  var ##longMap#1: Map;
  var ##shortMap#1: Map;
  var ##parms#5: Seq;
  var newParms#Z#0: Seq;
  var nextParm#Z#0: DatatypeType;
  var let#15#0#0: DatatypeType;
  var ##args#6: Seq;
  var ##context#5: DatatypeType;
  var ##parms#6: Seq;
  var ##files#5: Seq;
  var longOpt#Z#1: Seq;
  var let#16#0#0: Seq;
  var opt#Z#2: DatatypeType;
  var let#17#0#0: DatatypeType;
  var ##value#3: DatatypeType;
  var ##args#7: Seq;
  var ##context#6: DatatypeType;
  var ##parms#7: Seq;
  var ##files#6: Seq;
  var ##args#8: Seq;
  var ##context#7: DatatypeType;
  var ##parms#8: Seq;
  var ##files#7: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetOptions2", " | ", args#0, " | ", context#0, " | ", parms#0, " | ", files#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "DatatypeType", " | ", "Seq", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(741,32): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume true;
    havoc x#4;
    assume $Is(x#4, TChar);
    goto anon61_Then, anon61_Else;

  anon61_Then:
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#4)];
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#4)];
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#4)]];
    goto anon4;

  anon61_Else:
    assume Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#4)] ==> Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#4)]];
    goto anon4;

  anon4:
    assume (forall x#0: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#0)]): Seq } { Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(GetOpt.Context.shortMap(context#0))[$Box(x#0)] ==> Map#Domain(GetOpt.Context.longMap(context#0))[Map#Elements(GetOpt.Context.shortMap(context#0))[$Box(x#0)]]);
    goto anon62_Then, anon62_Else;

  anon62_Then:
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    assume false;
    return;

  anon62_Else:
    goto anon63_Then, anon63_Else;

  anon63_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(0);
    assume GetOpt.Context.Context_q(context#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, files#0, Lit(#Wrappers.Option.None()))));
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon63_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.Context.Context_q(context#0);
    goto anon64_Then, anon64_Else;

  anon64_Then:
    assume {:partition} Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))];
    havoc inherits#Z#0;
    assume $Is(inherits#Z#0, TSeq(Tclass.GetOpt.Param())) && $IsAlloc(inherits#Z#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    goto anon65_Then, anon65_Else;

  anon65_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc o#0;
    goto anon66_Then, anon66_Else;

  anon66_Then:
    assume {:partition} $Is(o#0, Tclass.GetOpt.Param()) && $IsAlloc(o#0, Tclass.GetOpt.Param(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(o#0), Tclass.GetOpt.Param(), $lambdaHeap#0);
    assume GetOpt.Param.Inherits#canCall(o#0);
    assume lambdaResult#0 <==> GetOpt.Param.Inherits(o#0);
    assume GetOpt.Param.Inherits#canCall(o#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon12;

  anon66_Else:
    assume {:partition} !($Is(o#0, Tclass.GetOpt.Param()) && $IsAlloc(o#0, Tclass.GetOpt.Param(), $lambdaHeap#0));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon65_Else:
    goto anon13;

  anon13:
    assume GetOpt.Context.Context_q(context#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))];
    assume GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType);
    ##f#0 := Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#13#o#0): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#o#0: Box :: $IsBox($l#13#o#0, Tclass.GetOpt.Param())), (lambda $l#13#heap#0: Heap, $l#13#o#0: Box :: SetRef_to_SetBox((lambda $l#13#o#1: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.GetOpt.Param(), TBool), $Heap);
    ##xs#0 := GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType);
    assume $IsAlloc(##xs#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#1: ref :: { Reads1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#1)] } $Is(o#1, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.GetOpt.Param(), TBool, $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#1)] && $Box($o) == $Box(o#1)) ==> $_ReadsFrame[$o, $f]);
    assume GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#14#o#0): DatatypeType))), (lambda $l#14#heap#0: Heap, $l#14#o#0: Box :: $IsBox($l#14#o#0, Tclass.GetOpt.Param())), (lambda $l#14#heap#0: Heap, $l#14#o#0: Box :: SetRef_to_SetBox((lambda $l#14#o#1: ref :: false))))), $LS($LZ))), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType));
    assume let#0#0#0 == GetOpt.__default.Filter(Tclass.GetOpt.Param(), $LS($LZ), reveal_GetOpt._default.Filter, $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#16#o#0): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#o#0: Box :: $IsBox($l#16#o#0, Tclass.GetOpt.Param())), (lambda $l#16#heap#0: Heap, $l#16#o#0: Box :: SetRef_to_SetBox((lambda $l#16#o#1: ref :: false))))), $LS($LZ))), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType));
    assume (forall $l#17#o#0: DatatypeType :: $Is($l#17#o#0, Tclass.GetOpt.Param()) ==> GetOpt.Param.Inherits#canCall($l#17#o#0)) && GetOpt.Context.Context_q(context#0) && GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType) && GetOpt.__default.Filter#canCall(Tclass.GetOpt.Param(), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#o#0: Box :: $Box(GetOpt.Param.Inherits($Unbox($l#18#o#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#o#0: Box :: $IsBox($l#18#o#0, Tclass.GetOpt.Param())), (lambda $l#18#heap#0: Heap, $l#18#o#0: Box :: SetRef_to_SetBox((lambda $l#18#o#1: ref :: false))))), $LS($LZ))), GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType));
    assume $Is(let#0#0#0, TSeq(Tclass.GetOpt.Param()));
    assume inherits#Z#0 == let#0#0#0;
    havoc newOpts#Z#0;
    assume $Is(newOpts#Z#0, TSeq(Tclass.GetOpt.Param())) && $IsAlloc(newOpts#Z#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    assume GetOpt.Context.Context_q(context#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))];
    assume GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType);
    assume GetOpt.Context.Context_q(context#0);
    assume let#1#0#0 == Seq#Append(GetOpt.Options.params($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType), GetOpt.Context.inherits(context#0));
    assume GetOpt.Context.Context_q(context#0) && GetOpt.Options.Options_q($Unbox(Map#Elements(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))]): DatatypeType) && GetOpt.Context.Context_q(context#0);
    assume $Is(let#1#0#0, TSeq(Tclass.GetOpt.Param()));
    assume newOpts#Z#0 == let#1#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    ##opts#0 := newOpts#Z#0;
    assume $IsAlloc(##opts#0, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##optional#0 := Lit(#Wrappers.Option.None());
    assume $IsAlloc(##optional#0, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.__default.TestPositionals#canCall(newOpts#Z#0, Lit(#Wrappers.Option.None()));
    assume let#2#0#0 == GetOpt.__default.TestPositionals($LS($LZ), newOpts#Z#0, Lit(#Wrappers.Option.None()));
    assume GetOpt.__default.TestPositionals#canCall(newOpts#Z#0, Lit(#Wrappers.Option.None()));
    assume $Is(let#2#0#0, Tclass.Wrappers.Outcome(TSeq(TChar)));
    assume valueOrError0#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(TSeq(TChar), valueOrError0#Z#0);
    goto anon67_Then, anon67_Else;

  anon67_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == Wrappers.Outcome.PropagateFailure(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError0#Z#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon67_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(TSeq(TChar), valueOrError0#Z#0);
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##opts#1 := newOpts#Z#0;
    assume $IsAlloc(##opts#1, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##args#0 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#0, TSeq(TSeq(TChar)), $Heap);
    ##params#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##params#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume GetOpt.__default.GetPositionals#canCall(newOpts#Z#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq));
    assume let#3#0#0 == GetOpt.__default.GetPositionals($LS($LZ), newOpts#Z#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq));
    assume GetOpt.__default.GetPositionals#canCall(newOpts#Z#0, Seq#Drop(args#0, LitInt(1)), Lit(Seq#Empty(): Seq));
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)));
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    goto anon68_Then, anon68_Else;

  anon68_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError1#Z#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon68_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    havoc newArgs#Z#0;
    havoc params#Z#0;
    assume $Is(newArgs#Z#0, TSeq(TSeq(TChar))) && $IsAlloc(newArgs#Z#0, TSeq(TSeq(TChar)), $Heap) && $Is(params#Z#0, TSeq(Tclass.GetOpt.OneArg())) && $IsAlloc(params#Z#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0)): DatatypeType);
    assume let#4#0#0 == $Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())), TSeq(TChar), valueOrError1#Z#0);
    assume $Is(let#4#0#0, Tclass._System.Tuple2(TSeq(TSeq(TChar)), TSeq(Tclass.GetOpt.OneArg())));
    assume _System.Tuple2.___hMake2_q(let#4#0#0);
    assume #_System._tuple#2._#Make2($Box(newArgs#Z#0), $Box(params#Z#0)) == let#4#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    ##opts#2 := newOpts#Z#0;
    assume $IsAlloc(##opts#2, TSeq(Tclass.GetOpt.Param()), $Heap);
    ##longMap#0 := Lit(Map#Empty(): Map);
    assume $IsAlloc(##longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#0 := Lit(Map#Empty(): Map);
    assume $IsAlloc(##shortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    assume $Is(Lit(Map#Empty(): Map), Tclass.GetOpt.CommandMap());
    ##commandMap#0 := Lit(Map#Empty(): Map);
    assume $IsAlloc(##commandMap#0, Tclass.GetOpt.CommandMap(), $Heap);
    assume {:subsumption 0} (forall x#5: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#5)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#5)] } $Is(x#5, TChar) && Map#Domain(##shortMap#0)[$Box(x#5)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#5)]]);
    assume (forall x#5: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#5)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#5)] } $Is(x#5, TChar) && Map#Domain(##shortMap#0)[$Box(x#5)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#5)]]);
    assume GetOpt.__default.GetMaps#canCall(newOpts#Z#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map));
    assume let#5#0#0 == GetOpt.__default.GetMaps($LS($LZ), newOpts#Z#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map));
    assume GetOpt.__default.GetMaps#canCall(newOpts#Z#0, Lit(Map#Empty(): Map), Lit(Map#Empty(): Map), Lit(Map#Empty(): Map));
    assume $Is(let#5#0#0, Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)));
    assume valueOrError2#Z#0 == let#5#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    goto anon69_Then, anon69_Else;

  anon69_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#Z#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == Wrappers.Result.PropagateFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError2#Z#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon69_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    havoc longMap#Z#0;
    havoc shortMap#Z#0;
    havoc commandSet#Z#0;
    assume $Is(longMap#Z#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $IsAlloc(longMap#Z#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap) && $Is(shortMap#Z#0, TMap(TChar, TSeq(TChar))) && $IsAlloc(shortMap#Z#0, TMap(TChar, TSeq(TChar)), $Heap) && $Is(commandSet#Z#0, Tclass.GetOpt.CommandMap()) && $IsAlloc(commandSet#Z#0, Tclass.GetOpt.CommandMap(), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    assume _System.Tuple3.___hMake3_q($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0)): DatatypeType);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()), TSeq(TChar), valueOrError2#Z#0);
    assume $Is(let#6#0#0, Tclass._System.Tuple3(TMap(TSeq(TChar), Tclass.GetOpt.Param()), TMap(TChar, TSeq(TChar)), Tclass.GetOpt.CommandMap()));
    assume _System.Tuple3.___hMake3_q(let#6#0#0);
    assume #_System._tuple#3._#Make3($Box(longMap#Z#0), $Box(shortMap#Z#0), $Box(commandSet#Z#0)) == let#6#0#0;
    havoc newContext#Z#0;
    assume $Is(newContext#Z#0, Tclass.GetOpt.Context()) && $IsAlloc(newContext#Z#0, Tclass.GetOpt.Context(), $Heap);
    assume GetOpt.Context.Context_q(context#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume let#7#0#0 == #GetOpt.Context.Context(longMap#Z#0, shortMap#Z#0, Seq#Append(GetOpt.Context.inherits(context#0), inherits#Z#0), commandSet#Z#0, $Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(let#7#0#0, Tclass.GetOpt.Context());
    assume newContext#Z#0 == let#7#0#0;
    havoc lostArgs#Z#0;
    assume true;
    assume let#8#0#0 == Seq#Length(args#0) - Seq#Length(newArgs#Z#0);
    assume true;
    assume $Is(let#8#0#0, TInt);
    assume lostArgs#Z#0 == let#8#0#0;
    havoc valueOrError3#Z#0;
    assume $Is(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar))) && $IsAlloc(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume 0 <= lostArgs#Z#0 && lostArgs#Z#0 <= Seq#Length(args#0);
    ##args#1 := Seq#Drop(args#0, lostArgs#Z#0);
    assume $IsAlloc(##args#1, TSeq(TSeq(TChar)), $Heap);
    ##context#0 := newContext#Z#0;
    assume $IsAlloc(##context#0, Tclass.GetOpt.Context(), $Heap);
    ##parms#0 := params#Z#0;
    assume $IsAlloc(##parms#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##files#0, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#6: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#6)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#6)] } $Is(x#6, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#6)] ==> Map#Domain(GetOpt.Context.longMap(##context#0))[Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#6)]]);
    assume (forall x#6: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#6)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#6)] } $Is(x#6, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#0))[$Box(x#6)] ==> Map#Domain(GetOpt.Context.longMap(##context#0))[Map#Elements(GetOpt.Context.shortMap(##context#0))[$Box(x#6)]]);
    assume Seq#Rank(##args#1) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, lostArgs#Z#0), newContext#Z#0, params#Z#0, Lit(Seq#Empty(): Seq));
    assume let#9#0#0 == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, lostArgs#Z#0), newContext#Z#0, params#Z#0, Lit(Seq#Empty(): Seq));
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, lostArgs#Z#0), newContext#Z#0, params#Z#0, Lit(Seq#Empty(): Seq));
    assume $Is(let#9#0#0, Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    assume valueOrError3#Z#0 == let#9#0#0;
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    goto anon70_Then, anon70_Else;

  anon70_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#Z#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == Wrappers.Result.PropagateFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError3#Z#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon70_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    havoc result#Z#0;
    assume $Is(result#Z#0, Tclass.GetOpt.Parsed()) && $IsAlloc(result#Z#0, Tclass.GetOpt.Parsed(), $Heap);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    assume GetOpt.Parsed.Parsed_q($Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0)): DatatypeType);
    assume let#10#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.GetOpt.Parsed(), TSeq(TChar), valueOrError3#Z#0);
    assume $Is(let#10#0#0, Tclass.GetOpt.Parsed());
    assume result#Z#0 == let#10#0#0;
    assume GetOpt.Context.Context_q(context#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, files#0, #Wrappers.Option.Some($Box(result#Z#0)))));
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon64_Else:
    assume {:partition} !Map#Domain(GetOpt.Context.commands(context#0))[Seq#Index(args#0, LitInt(0))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    goto anon71_Then, anon71_Else;

  anon71_Then:
    assume {:partition} Seq#Equal($Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))));
    assume GetOpt.Context.Context_q(context#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Success($Box(#GetOpt.Parsed.Parsed(GetOpt.Context.command(context#0), parms#0, Seq#Append(files#0, Seq#Drop(args#0, LitInt(1))), Lit(#Wrappers.Option.None()))));
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon71_Else:
    assume {:partition} !Seq#Equal($Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    goto anon72_Then, anon72_Else;

  anon72_Then:
    assume {:partition} Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))));
    havoc longOpt#Z#0;
    assume $Is(longOpt#Z#0, TSeq(TChar)) && $IsAlloc(longOpt#Z#0, TSeq(TChar), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume let#11#0#0 == Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(2));
    assume true;
    assume $Is(let#11#0#0, TSeq(TChar));
    assume longOpt#Z#0 == let#11#0#0;
    goto anon73_Then, anon73_Else;

  anon73_Then:
    assume {:partition} Seq#Contains(longOpt#Z#0, $Box(char#FromInt(61)));
    havoc opt#Z#0;
    havoc arg#Z#0;
    assume $Is(opt#Z#0, TSeq(TChar)) && $IsAlloc(opt#Z#0, TSeq(TChar), $Heap) && $Is(arg#Z#0, TSeq(TChar)) && $IsAlloc(arg#Z#0, TSeq(TChar), $Heap);
    ##s#0 := longOpt#Z#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    ##delim#0 := Lit(char#FromInt(61));
    assume $IsAlloc(##delim#0, TChar, $Heap);
    assume {:subsumption 0} Seq#Contains(##s#0, $Box(##delim#0));
    assume Seq#Contains(##s#0, $Box(##delim#0));
    assume GetOpt.__default.SplitOnce#canCall(TChar, longOpt#Z#0, $Box(Lit(char#FromInt(61))));
    assume _System.Tuple2.___hMake2_q(GetOpt.__default.SplitOnce(TChar, longOpt#Z#0, $Box(Lit(char#FromInt(61)))));
    assume let#12#0#0 == GetOpt.__default.SplitOnce(TChar, longOpt#Z#0, $Box(Lit(char#FromInt(61))));
    assume GetOpt.__default.SplitOnce#canCall(TChar, longOpt#Z#0, $Box(Lit(char#FromInt(61))));
    assume $Is(let#12#0#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)));
    assume _System.Tuple2.___hMake2_q(let#12#0#0);
    assume #_System._tuple#2._#Make2($Box(opt#Z#0), $Box(arg#Z#0)) == let#12#0#0;
    assume GetOpt.Context.Context_q(context#0);
    goto anon74_Then, anon74_Else;

  anon74_Then:
    assume {:partition} Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)];
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)];
    assume $IsAllocBox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)], Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType);
    goto anon75_Then, anon75_Else;

  anon75_Then:
    assume {:partition} GetOpt.Param.NeedsArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)];
    assume $IsAllocBox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)], Tclass.GetOpt.Param(), $Heap);
    ##value#0 := #Wrappers.Option.Some($Box(arg#Z#0));
    assume $IsAlloc(##value#0, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#Z#0)));
    ##args#2 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#2, TSeq(TSeq(TChar)), $Heap);
    ##context#1 := context#0;
    assume $IsAlloc(##context#1, Tclass.GetOpt.Context(), $Heap);
    ##parms#1 := Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#Z#0))));
    assume $IsAlloc(##parms#1, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#1 := files#0;
    assume $IsAlloc(##files#1, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#7: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#1))[$Box(x#7)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#1))[$Box(x#7)] } $Is(x#7, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#1))[$Box(x#7)] ==> Map#Domain(GetOpt.Context.longMap(##context#1))[Map#Elements(GetOpt.Context.shortMap(##context#1))[$Box(x#7)]]);
    assume (forall x#7: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#1))[$Box(x#7)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#1))[$Box(x#7)] } $Is(x#7, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#1))[$Box(x#7)] ==> Map#Domain(GetOpt.Context.longMap(##context#1))[Map#Elements(GetOpt.Context.shortMap(##context#1))[$Box(x#7)]]);
    assume Seq#Rank(##args#2) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#Z#0)))), files#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#Z#0)))), files#0);
    assume GetOpt.Context.Context_q(context#0) && GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#Z#0))) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(arg#Z#0)))), files#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon75_Else:
    assume {:partition} !GetOpt.Param.NeedsArg($Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)]): DatatypeType);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(107))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon74_Else:
    assume {:partition} !Map#Domain(GetOpt.Context.longMap(context#0))[$Box(opt#Z#0)];
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), opt#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon73_Else:
    assume {:partition} !Seq#Contains(longOpt#Z#0, $Box(char#FromInt(61)));
    assume GetOpt.Context.Context_q(context#0);
    goto anon76_Then, anon76_Else;

  anon76_Then:
    assume {:partition} Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#Z#0)];
    havoc opt#Z#1;
    assume $Is(opt#Z#1, Tclass.GetOpt.Param()) && $IsAlloc(opt#Z#1, Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#Z#0)];
    assume let#13#0#0 == $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#Z#0)]): DatatypeType;
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(let#13#0#0, Tclass.GetOpt.Param());
    assume opt#Z#1 == let#13#0#0;
    assume $IsAllocBox($Box(opt#Z#1), Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.NeedsArg#canCall(opt#Z#1);
    goto anon77_Then, anon77_Else;

  anon77_Then:
    assume {:partition} GetOpt.Param.NeedsArg(opt#Z#1);
    goto anon78_Then, anon78_Else;

  anon78_Then:
    assume {:partition} Seq#Length(args#0) < 2;
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon78_Else:
    assume {:partition} 2 <= Seq#Length(args#0);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(args#0);
    assume $IsAllocBox($Box(opt#Z#1), Tclass.GetOpt.Param(), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(args#0);
    ##value#1 := #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)));
    assume $IsAlloc(##value#1, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.Param.MakeArg#canCall(opt#Z#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))));
    ##args#3 := Seq#Drop(args#0, LitInt(2));
    assume $IsAlloc(##args#3, TSeq(TSeq(TChar)), $Heap);
    ##context#2 := context#0;
    assume $IsAlloc(##context#2, Tclass.GetOpt.Context(), $Heap);
    ##parms#2 := Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)))));
    assume $IsAlloc(##parms#2, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#2 := files#0;
    assume $IsAlloc(##files#2, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#8: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#2))[$Box(x#8)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#2))[$Box(x#8)] } $Is(x#8, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#2))[$Box(x#8)] ==> Map#Domain(GetOpt.Context.longMap(##context#2))[Map#Elements(GetOpt.Context.shortMap(##context#2))[$Box(x#8)]]);
    assume (forall x#8: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#2))[$Box(x#8)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#2))[$Box(x#8)] } $Is(x#8, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#2))[$Box(x#8)] ==> Map#Domain(GetOpt.Context.longMap(##context#2))[Map#Elements(GetOpt.Context.shortMap(##context#2))[$Box(x#8)]]);
    assume Seq#Rank(##args#3) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0);
    assume GetOpt.Param.MakeArg#canCall(opt#Z#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon77_Else:
    assume {:partition} !GetOpt.Param.NeedsArg(opt#Z#1);
    goto anon79_Then, anon79_Else;

  anon79_Then:
    assume {:partition} GetOpt.Param.Flag_q(opt#Z#1);
    assume GetOpt.Param.Flag_q(opt#Z#1);
    goto anon38;

  anon79_Else:
    assume {:partition} !GetOpt.Param.Flag_q(opt#Z#1);
    goto anon38;

  anon38:
    goto anon80_Then, anon80_Else;

  anon80_Then:
    assume {:partition} GetOpt.Param.Flag_q(opt#Z#1) && GetOpt.Param.solo(opt#Z#1);
    goto anon81_Then, anon81_Else;

  anon81_Then:
    assume {:partition} Seq#Length(args#0) == 1;
    goto anon41;

  anon81_Else:
    assume {:partition} Seq#Length(args#0) != 1;
    goto anon41;

  anon41:
    goto anon82_Then, anon82_Else;

  anon82_Then:
    assume {:partition} !(Seq#Length(args#0) != 1 || Seq#Length(parms#0) != 0);
    goto anon43;

  anon82_Else:
    assume {:partition} Seq#Length(args#0) != 1 || Seq#Length(parms#0) != 0;
    goto anon43;

  anon80_Else:
    assume {:partition} !(GetOpt.Param.Flag_q(opt#Z#1) && GetOpt.Param.solo(opt#Z#1));
    goto anon43;

  anon43:
    goto anon83_Then, anon83_Else;

  anon83_Then:
    assume {:partition} GetOpt.Param.Flag_q(opt#Z#1) && GetOpt.Param.solo(opt#Z#1) && (Seq#Length(args#0) != 1 || Seq#Length(parms#0) != 0 || Seq#Length(files#0) != 0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), longOpt#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(117))), $Box(char#FromInt(102))), $Box(char#FromInt(102))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(108))), $Box(char#FromInt(121))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon83_Else:
    assume {:partition} !(GetOpt.Param.Flag_q(opt#Z#1) && GetOpt.Param.solo(opt#Z#1) && (Seq#Length(args#0) != 1 || Seq#Length(parms#0) != 0 || Seq#Length(files#0) != 0));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume $IsAllocBox($Box(opt#Z#1), Tclass.GetOpt.Param(), $Heap);
    ##value#2 := Lit(#Wrappers.Option.None());
    assume $IsAlloc(##value#2, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.Param.MakeArg#canCall(opt#Z#1, Lit(#Wrappers.Option.None()));
    ##args#4 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#4, TSeq(TSeq(TChar)), $Heap);
    ##context#3 := context#0;
    assume $IsAlloc(##context#3, Tclass.GetOpt.Context(), $Heap);
    ##parms#3 := Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, Lit(#Wrappers.Option.None())));
    assume $IsAlloc(##parms#3, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#3 := files#0;
    assume $IsAlloc(##files#3, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#9: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#3))[$Box(x#9)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#3))[$Box(x#9)] } $Is(x#9, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#3))[$Box(x#9)] ==> Map#Domain(GetOpt.Context.longMap(##context#3))[Map#Elements(GetOpt.Context.shortMap(##context#3))[$Box(x#9)]]);
    assume (forall x#9: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#3))[$Box(x#9)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#3))[$Box(x#9)] } $Is(x#9, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#3))[$Box(x#9)] ==> Map#Domain(GetOpt.Context.longMap(##context#3))[Map#Elements(GetOpt.Context.shortMap(##context#3))[$Box(x#9)]]);
    assume Seq#Rank(##args#4) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, Lit(#Wrappers.Option.None()))), files#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, Lit(#Wrappers.Option.None()))), files#0);
    assume GetOpt.Param.MakeArg#canCall(opt#Z#1, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, GetOpt.Param.MakeArg(opt#Z#1, Lit(#Wrappers.Option.None()))), files#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon76_Else:
    assume {:partition} !Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#Z#0)];
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), longOpt#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon72_Else:
    assume {:partition} !(Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(45))))));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    goto anon84_Then, anon84_Else;

  anon84_Then:
    assume {:partition} Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    ##args#5 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#5, TSeq(TSeq(TChar)), $Heap);
    ##context#4 := context#0;
    assume $IsAlloc(##context#4, Tclass.GetOpt.Context(), $Heap);
    ##parms#4 := parms#0;
    assume $IsAlloc(##parms#4, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#4 := Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0))));
    assume $IsAlloc(##files#4, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#10: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#4))[$Box(x#10)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#4))[$Box(x#10)] } $Is(x#10, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#4))[$Box(x#10)] ==> Map#Domain(GetOpt.Context.longMap(##context#4))[Map#Elements(GetOpt.Context.shortMap(##context#4))[$Box(x#10)]]);
    assume (forall x#10: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#4))[$Box(x#10)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#4))[$Box(x#10)] } $Is(x#10, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#4))[$Box(x#10)] ==> Map#Domain(GetOpt.Context.longMap(##context#4))[Map#Elements(GetOpt.Context.shortMap(##context#4))[$Box(x#10)]]);
    assume Seq#Rank(##args#5) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))));
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))));
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))));
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon84_Else:
    assume {:partition} !Seq#Equal(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    goto anon85_Then, anon85_Else;

  anon85_Then:
    assume {:partition} Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))));
    havoc valueOrError4#Z#0;
    assume $Is(valueOrError4#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar))) && $IsAlloc(valueOrError4#Z#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq);
    assume GetOpt.Context.Context_q(context#0);
    assume GetOpt.Context.Context_q(context#0);
    ##arg#0 := Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1));
    assume $IsAlloc(##arg#0, TSeq(TChar), $Heap);
    ##longMap#1 := GetOpt.Context.longMap(context#0);
    assume $IsAlloc(##longMap#1, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#1 := GetOpt.Context.shortMap(context#0);
    assume $IsAlloc(##shortMap#1, TMap(TChar, TSeq(TChar)), $Heap);
    ##parms#5 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##parms#5, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume {:subsumption 0} (forall x#11: char :: { $Unbox(Map#Elements(##shortMap#1)[$Box(x#11)]): Seq } { Map#Domain(##shortMap#1)[$Box(x#11)] } $Is(x#11, TChar) && Map#Domain(##shortMap#1)[$Box(x#11)] ==> Map#Domain(##longMap#1)[Map#Elements(##shortMap#1)[$Box(x#11)]]);
    assume (forall x#11: char :: { $Unbox(Map#Elements(##shortMap#1)[$Box(x#11)]): Seq } { Map#Domain(##shortMap#1)[$Box(x#11)] } $Is(x#11, TChar) && Map#Domain(##shortMap#1)[$Box(x#11)] ==> Map#Domain(##longMap#1)[Map#Elements(##shortMap#1)[$Box(x#11)]]);
    assume GetOpt.__default.GetShort#canCall(Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq));
    assume let#14#0#0 == GetOpt.__default.GetShort($LS($LZ), Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq));
    assume GetOpt.Context.Context_q(context#0) && GetOpt.Context.Context_q(context#0) && GetOpt.__default.GetShort#canCall(Seq#Drop($Unbox(Seq#Index(args#0, LitInt(0))): Seq, LitInt(1)), GetOpt.Context.longMap(context#0), GetOpt.Context.shortMap(context#0), Lit(Seq#Empty(): Seq));
    assume $Is(let#14#0#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    assume valueOrError4#Z#0 == let#14#0#0;
    assume $IsAllocBox($Box(valueOrError4#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0);
    goto anon86_Then, anon86_Else;

  anon86_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0);
    assume $IsAllocBox($Box(valueOrError4#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError4#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError4#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#Z#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == Wrappers.Result.PropagateFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), Tclass.GetOpt.Parsed(), valueOrError4#Z#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon86_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0);
    havoc newParms#Z#0;
    havoc nextParm#Z#0;
    assume $Is(newParms#Z#0, TSeq(Tclass.GetOpt.OneArg())) && $IsAlloc(newParms#Z#0, TSeq(Tclass.GetOpt.OneArg()), $Heap) && $Is(nextParm#Z#0, Tclass.Wrappers.Option(TChar)) && $IsAlloc(nextParm#Z#0, Tclass.Wrappers.Option(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError4#Z#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError4#Z#0);
    assume Wrappers.Result.Success_q(valueOrError4#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0)): DatatypeType);
    assume let#15#0#0 == $Unbox(Wrappers.Result.Extract(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar), valueOrError4#Z#0);
    assume $Is(let#15#0#0, Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)));
    assume _System.Tuple2.___hMake2_q(let#15#0#0);
    assume #_System._tuple#2._#Make2($Box(newParms#Z#0), $Box(nextParm#Z#0)) == let#15#0#0;
    goto anon87_Then, anon87_Else;

  anon87_Then:
    assume {:partition} Wrappers.Option.None_q(nextParm#Z#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    ##args#6 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#6, TSeq(TSeq(TChar)), $Heap);
    ##context#5 := context#0;
    assume $IsAlloc(##context#5, Tclass.GetOpt.Context(), $Heap);
    ##parms#6 := Seq#Append(parms#0, newParms#Z#0);
    assume $IsAlloc(##parms#6, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#5 := files#0;
    assume $IsAlloc(##files#5, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#12: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#5))[$Box(x#12)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#5))[$Box(x#12)] } $Is(x#12, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#5))[$Box(x#12)] ==> Map#Domain(GetOpt.Context.longMap(##context#5))[Map#Elements(GetOpt.Context.shortMap(##context#5))[$Box(x#12)]]);
    assume (forall x#12: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#5))[$Box(x#12)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#5))[$Box(x#12)] } $Is(x#12, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#5))[$Box(x#12)] ==> Map#Domain(GetOpt.Context.longMap(##context#5))[Map#Elements(GetOpt.Context.shortMap(##context#5))[$Box(x#12)]]);
    assume Seq#Rank(##args#6) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, newParms#Z#0), files#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, newParms#Z#0), files#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, Seq#Append(parms#0, newParms#Z#0), files#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon87_Else:
    assume {:partition} !Wrappers.Option.None_q(nextParm#Z#0);
    goto anon88_Then, anon88_Else;

  anon88_Then:
    assume {:partition} Seq#Length(args#0) == LitInt(1);
    assume Wrappers.Option.Some_q(nextParm#Z#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), Seq#Build(Seq#Empty(): Seq, Wrappers.Option.value(nextParm#Z#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(105))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(98))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon88_Else:
    assume {:partition} Seq#Length(args#0) != LitInt(1);
    havoc longOpt#Z#1;
    assume $Is(longOpt#Z#1, TSeq(TChar)) && $IsAlloc(longOpt#Z#1, TSeq(TChar), $Heap);
    assume GetOpt.Context.Context_q(context#0);
    assume Wrappers.Option.Some_q(nextParm#Z#0);
    assume Map#Domain(GetOpt.Context.shortMap(context#0))[Wrappers.Option.value(nextParm#Z#0)];
    assume let#16#0#0 == $Unbox(Map#Elements(GetOpt.Context.shortMap(context#0))[Wrappers.Option.value(nextParm#Z#0)]): Seq;
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(let#16#0#0, TSeq(TChar));
    assume longOpt#Z#1 == let#16#0#0;
    havoc opt#Z#2;
    assume $Is(opt#Z#2, Tclass.GetOpt.Param()) && $IsAlloc(opt#Z#2, Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Context.Context_q(context#0);
    assume Map#Domain(GetOpt.Context.longMap(context#0))[$Box(longOpt#Z#1)];
    assume let#17#0#0 == $Unbox(Map#Elements(GetOpt.Context.longMap(context#0))[$Box(longOpt#Z#1)]): DatatypeType;
    assume GetOpt.Context.Context_q(context#0);
    assume $Is(let#17#0#0, Tclass.GetOpt.Param());
    assume opt#Z#2 == let#17#0#0;
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(args#0);
    assume $IsAllocBox($Box(opt#Z#2), Tclass.GetOpt.Param(), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(args#0);
    ##value#3 := #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)));
    assume $IsAlloc(##value#3, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.Param.MakeArg#canCall(opt#Z#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))));
    ##args#7 := Seq#Drop(args#0, LitInt(2));
    assume $IsAlloc(##args#7, TSeq(TSeq(TChar)), $Heap);
    ##context#6 := context#0;
    assume $IsAlloc(##context#6, Tclass.GetOpt.Context(), $Heap);
    ##parms#7 := Seq#Append(Seq#Append(parms#0, newParms#Z#0), GetOpt.Param.MakeArg(opt#Z#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)))));
    assume $IsAlloc(##parms#7, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#6 := files#0;
    assume $IsAlloc(##files#6, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#13: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#6))[$Box(x#13)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#6))[$Box(x#13)] } $Is(x#13, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#6))[$Box(x#13)] ==> Map#Domain(GetOpt.Context.longMap(##context#6))[Map#Elements(GetOpt.Context.shortMap(##context#6))[$Box(x#13)]]);
    assume (forall x#13: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#6))[$Box(x#13)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#6))[$Box(x#13)] } $Is(x#13, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#6))[$Box(x#13)] ==> Map#Domain(GetOpt.Context.longMap(##context#6))[Map#Elements(GetOpt.Context.shortMap(##context#6))[$Box(x#13)]]);
    assume Seq#Rank(##args#7) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(Seq#Append(parms#0, newParms#Z#0), GetOpt.Param.MakeArg(opt#Z#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(Seq#Append(parms#0, newParms#Z#0), GetOpt.Param.MakeArg(opt#Z#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0);
    assume GetOpt.Param.MakeArg#canCall(opt#Z#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1)))) && GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(2)), context#0, Seq#Append(Seq#Append(parms#0, newParms#Z#0), GetOpt.Param.MakeArg(opt#Z#2, #Wrappers.Option.Some(Seq#Index(args#0, LitInt(1))))), files#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon85_Else:
    assume {:partition} !(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) < Seq#Length($Unbox(Seq#Index(args#0, LitInt(0))): Seq) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))))));
    assume GetOpt.Context.Context_q(context#0);
    goto anon89_Then, anon89_Else;

  anon89_Then:
    assume {:partition} Map#Card(GetOpt.Context.commands(context#0)) == LitInt(0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(args#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    ##args#8 := Seq#Drop(args#0, LitInt(1));
    assume $IsAlloc(##args#8, TSeq(TSeq(TChar)), $Heap);
    ##context#7 := context#0;
    assume $IsAlloc(##context#7, Tclass.GetOpt.Context(), $Heap);
    ##parms#8 := parms#0;
    assume $IsAlloc(##parms#8, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    ##files#7 := Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0))));
    assume $IsAlloc(##files#7, TSeq(TSeq(TChar)), $Heap);
    assume {:subsumption 0} (forall x#14: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#7))[$Box(x#14)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#7))[$Box(x#14)] } $Is(x#14, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#7))[$Box(x#14)] ==> Map#Domain(GetOpt.Context.longMap(##context#7))[Map#Elements(GetOpt.Context.shortMap(##context#7))[$Box(x#14)]]);
    assume (forall x#14: char :: { $Unbox(Map#Elements(GetOpt.Context.shortMap(##context#7))[$Box(x#14)]): Seq } { Map#Domain(GetOpt.Context.shortMap(##context#7))[$Box(x#14)] } $Is(x#14, TChar) && Map#Domain(GetOpt.Context.shortMap(##context#7))[$Box(x#14)] ==> Map#Domain(GetOpt.Context.longMap(##context#7))[Map#Elements(GetOpt.Context.shortMap(##context#7))[$Box(x#14)]]);
    assume Seq#Rank(##args#8) < Seq#Rank(args#0);
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))));
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == GetOpt.__default.GetOptions2($LS($LZ), Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))));
    assume GetOpt.__default.GetOptions2#canCall(Seq#Drop(args#0, LitInt(1)), context#0, parms#0, Seq#Append(files#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(args#0, LitInt(0)))));
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon89_Else:
    assume {:partition} Map#Card(GetOpt.Context.commands(context#0)) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(args#0);
    assume GetOpt.Context.Context_q(context#0);
    assume GetOpt.Context.Context_q(context#0);
    assume GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(109))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Unbox(Seq#Index(args#0, LitInt(0))): Seq), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32)))), GetOpt.Context.command(context#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(10))), $Box(char#FromInt(82))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39)))), GetOpt.Context.command(context#0)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(32))), $Box(char#FromInt(45))), $Box(char#FromInt(45))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(108))), $Box(char#FromInt(112))), $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(97))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(46))))));
    assume GetOpt.Context.Context_q(context#0) && GetOpt.Context.Context_q(context#0);
    assume $Is(GetOpt.__default.GetOptions2($LS($LZ), args#0, context#0, parms#0, files#0), Tclass.Wrappers.Result(Tclass.GetOpt.Parsed(), TSeq(TChar)));
    goto anon60;

  anon60:
    assume b$reqreads#0;
    return;
}



function GetOpt.__default.GetShort($ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq :: { GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0) } GetOpt.__default.GetShort#canCall(arg#0, longMap#0, shortMap#0, parms#0) || (3 < $FunctionContextHeight && $Is(arg#0, TSeq(TChar)) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && (forall x#0: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(shortMap#0)[$Box(x#0)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#0)]])) ==> (Wrappers.Result.Success_q(GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0)) && Wrappers.Option.Some_q($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0))): DatatypeType)): DatatypeType) ==> Map#Domain(shortMap#0)[Wrappers.Option.value($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0))): DatatypeType)): DatatypeType)]) && $Is(GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq :: { GetOpt.__default.GetShort($LS($ly), arg#0, longMap#0, shortMap#0, parms#0) } GetOpt.__default.GetShort#canCall(arg#0, longMap#0, shortMap#0, parms#0) || (3 < $FunctionContextHeight && $Is(arg#0, TSeq(TChar)) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && (forall x#1: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#1)]): Seq } { Map#Domain(shortMap#0)[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain(shortMap#0)[$Box(x#1)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#1)]])) ==> (Seq#Length(arg#0) != LitInt(0) ==> (var ch#0 := $Unbox(Seq#Index(arg#0, LitInt(0))): char; Map#Domain(shortMap#0)[$Box(ch#0)] ==> (var opt#0 := $Unbox(Map#Elements(shortMap#0)[$Box(ch#0)]): Seq; GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType) && (GetOpt.Param.NeedsArg($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType) ==> Seq#Length(arg#0) != LitInt(1) ==> GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType, #Wrappers.Option.Some($Box(Seq#Drop(arg#0, LitInt(1)))))) && (!GetOpt.Param.NeedsArg($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType) ==> GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetShort#canCall(Seq#Drop(arg#0, LitInt(1)), longMap#0, shortMap#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType, Lit(#Wrappers.Option.None())))))))) && GetOpt.__default.GetShort($LS($ly), arg#0, longMap#0, shortMap#0, parms#0) == (if Seq#Length(arg#0) == LitInt(0) then #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(parms#0), $Box(Lit(#Wrappers.Option.None()))))) else (var ch#0 := $Unbox(Seq#Index(arg#0, LitInt(0))): char; (if Map#Domain(shortMap#0)[$Box(ch#0)] then (var opt#0 := $Unbox(Map#Elements(shortMap#0)[$Box(ch#0)]): Seq; (if GetOpt.Param.NeedsArg($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType) then (if Seq#Length(arg#0) == LitInt(1) then #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(parms#0), $Box(#Wrappers.Option.Some($Box(ch#0)))))) else #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType, #Wrappers.Option.Some($Box(Seq#Drop(arg#0, LitInt(1))))))), $Box(Lit(#Wrappers.Option.None())))))) else GetOpt.__default.GetShort($ly, Seq#Drop(arg#0, LitInt(1)), longMap#0, shortMap#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#0)]): DatatypeType, Lit(#Wrappers.Option.None())))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(ch#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall $ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq :: {:weight 3} { GetOpt.__default.GetShort($LS($ly), Lit(arg#0), Lit(longMap#0), Lit(shortMap#0), Lit(parms#0)) } GetOpt.__default.GetShort#canCall(Lit(arg#0), Lit(longMap#0), Lit(shortMap#0), Lit(parms#0)) || (3 < $FunctionContextHeight && $Is(arg#0, TSeq(TChar)) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) && (forall x#2: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#2)]): Seq } { Map#Domain(shortMap#0)[$Box(x#2)] } $Is(x#2, TChar) && Map#Domain(shortMap#0)[$Box(x#2)] ==> Map#Domain(longMap#0)[Map#Elements(Lit(shortMap#0))[$Box(x#2)]])) ==> (Seq#Length(Lit(arg#0)) != LitInt(0) ==> (var ch#1 := $Unbox(Seq#Index(Lit(arg#0), LitInt(0))): char; Map#Domain(shortMap#0)[$Box(ch#1)] ==> (var opt#1 := $Unbox(Map#Elements(Lit(shortMap#0))[$Box(ch#1)]): Seq; GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType) && (GetOpt.Param.NeedsArg($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType) ==> Seq#Length(Lit(arg#0)) != LitInt(1) ==> GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType, Lit(#Wrappers.Option.Some($Box(Lit(Seq#Drop(Lit(arg#0), LitInt(1)))))))) && (!GetOpt.Param.NeedsArg($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType) ==> GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetShort#canCall(Lit(Seq#Drop(Lit(arg#0), LitInt(1))), Lit(longMap#0), Lit(shortMap#0), Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType, Lit(#Wrappers.Option.None())))))))) && GetOpt.__default.GetShort($LS($ly), Lit(arg#0), Lit(longMap#0), Lit(shortMap#0), Lit(parms#0)) == (if Seq#Length(Lit(arg#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(parms#0)), $Box(Lit(#Wrappers.Option.None())))))) else (var ch#1 := $Unbox(Seq#Index(Lit(arg#0), LitInt(0))): char; (if Map#Domain(shortMap#0)[$Box(ch#1)] then (var opt#1 := $Unbox(Map#Elements(Lit(shortMap#0))[$Box(ch#1)]): Seq; (if GetOpt.Param.NeedsArg($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType) then (if Seq#Length(Lit(arg#0)) == LitInt(1) then #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(Lit(parms#0)), $Box(#Wrappers.Option.Some($Box(ch#1)))))) else #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType, Lit(#Wrappers.Option.Some($Box(Lit(Seq#Drop(Lit(arg#0), LitInt(1))))))))), $Box(Lit(#Wrappers.Option.None())))))) else GetOpt.__default.GetShort($LS($ly), Lit(Seq#Drop(Lit(arg#0), LitInt(1))), Lit(longMap#0), Lit(shortMap#0), Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(Lit(longMap#0))[$Box(opt#1)]): DatatypeType, Lit(#Wrappers.Option.None())))))) else #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(ch#1))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))))))));
}

function GetOpt.__default.GetShort#canCall(arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq) : bool;

axiom (forall $ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq :: { GetOpt.__default.GetShort($LS($ly), arg#0, longMap#0, shortMap#0, parms#0) } GetOpt.__default.GetShort($LS($ly), arg#0, longMap#0, shortMap#0, parms#0) == GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0));

axiom (forall $ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq :: { GetOpt.__default.GetShort(AsFuelBottom($ly), arg#0, longMap#0, shortMap#0, parms#0) } GetOpt.__default.GetShort($ly, arg#0, longMap#0, shortMap#0, parms#0) == GetOpt.__default.GetShort($LZ, arg#0, longMap#0, shortMap#0, parms#0));

function GetOpt.__default.GetShort#requires(LayerType, Seq, Map, Map, Seq) : bool;

axiom (forall $ly: LayerType, arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq :: { GetOpt.__default.GetShort#requires($ly, arg#0, longMap#0, shortMap#0, parms#0) } $Is(arg#0, TSeq(TChar)) && $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(shortMap#0, TMap(TChar, TSeq(TChar))) && $Is(parms#0, TSeq(Tclass.GetOpt.OneArg())) ==> (GetOpt.__default.GetShort#requires($ly, arg#0, longMap#0, shortMap#0, parms#0) <==> (forall x#1: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#1)]): Seq } { Map#Domain(shortMap#0)[$Box(x#1)] } $Is(x#1, TChar) && Map#Domain(shortMap#0)[$Box(x#1)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#1)]])));

procedure {:verboseName "GetOpt.GetShort (well-formedness)"} CheckWellformed$$GetOpt.__default.GetShort(arg#0: Seq where $Is(arg#0, TSeq(TChar)), longMap#0: Map where $Is(longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())), shortMap#0: Map where $Is(shortMap#0, TMap(TChar, TSeq(TChar))), parms#0: Seq where $Is(parms#0, TSeq(Tclass.GetOpt.OneArg()))) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17368"} Wrappers.Result.Success_q(res#0) && Wrappers.Option.Some_q($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType) ==> Map#Domain(shortMap#0)[Wrappers.Option.value($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType)];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.GetShort (well-formedness)"} CheckWellformed$$GetOpt.__default.GetShort(arg#0: Seq, longMap#0: Map, shortMap#0: Map, parms#0: Seq) returns (res#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#3: char;
  var ch#Z#0: char;
  var let#0#0#0: char;
  var opt#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##value#0: DatatypeType;
  var ##value#1: DatatypeType;
  var ##arg#0: Seq;
  var ##longMap#0: Map;
  var ##shortMap#0: Map;
  var ##parms#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.GetShort", " | ", arg#0, " | ", longMap#0, " | ", shortMap#0, " | ", parms#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Map", " | ", "Map", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(807,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    havoc x#3;
    assume $Is(x#3, TChar);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Map#Domain(shortMap#0)[$Box(x#3)];
    assume Map#Domain(shortMap#0)[$Box(x#3)];
    assume Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#3)]];
    goto anon4;

  anon19_Else:
    assume Map#Domain(shortMap#0)[$Box(x#3)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#3)]];
    goto anon4;

  anon4:
    assume (forall x#0: char :: { $Unbox(Map#Elements(shortMap#0)[$Box(x#0)]): Seq } { Map#Domain(shortMap#0)[$Box(x#0)] } $Is(x#0, TChar) && Map#Domain(shortMap#0)[$Box(x#0)] ==> Map#Domain(longMap#0)[Map#Elements(shortMap#0)[$Box(x#0)]]);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume $Is(GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Result.value(res#0)): DatatypeType);
    assume Wrappers.Option.Some_q($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType);
    assume Wrappers.Result.Success_q(res#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Result.value(res#0)): DatatypeType);
    assume Wrappers.Option.Some_q($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType);
    assume Map#Domain(shortMap#0)[Wrappers.Option.value($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType)];
    goto anon8;

  anon21_Else:
    assume Wrappers.Result.Success_q(res#0) && Wrappers.Option.Some_q($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType) ==> Map#Domain(shortMap#0)[Wrappers.Option.value($Unbox(_System.Tuple2._1($Unbox(Wrappers.Result.value(res#0)): DatatypeType)): DatatypeType)];
    goto anon8;

  anon8:
    assume false;
    return;

  anon20_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Length(arg#0) == LitInt(0);
    assume GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(parms#0), $Box(Lit(#Wrappers.Option.None())))));
    assume true;
    assume $Is(GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    goto anon18;

  anon22_Else:
    assume {:partition} Seq#Length(arg#0) != LitInt(0);
    havoc ch#Z#0;
    assume $Is(ch#Z#0, TChar);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(arg#0);
    assume let#0#0#0 == $Unbox(Seq#Index(arg#0, LitInt(0))): char;
    assume true;
    assume $Is(let#0#0#0, TChar);
    assume ch#Z#0 == let#0#0#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Map#Domain(shortMap#0)[$Box(ch#Z#0)];
    havoc opt#Z#0;
    assume $Is(opt#Z#0, TSeq(TChar)) && $IsAlloc(opt#Z#0, TSeq(TChar), $Heap);
    assume Map#Domain(shortMap#0)[$Box(ch#Z#0)];
    assume let#1#0#0 == $Unbox(Map#Elements(shortMap#0)[$Box(ch#Z#0)]): Seq;
    assume true;
    assume $Is(let#1#0#0, TSeq(TChar));
    assume opt#Z#0 == let#1#0#0;
    assume Map#Domain(longMap#0)[$Box(opt#Z#0)];
    assume $IsAllocBox(Map#Elements(longMap#0)[$Box(opt#Z#0)], Tclass.GetOpt.Param(), $Heap);
    assume GetOpt.Param.NeedsArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} GetOpt.Param.NeedsArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Seq#Length(arg#0) == LitInt(1);
    assume GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(parms#0), $Box(#Wrappers.Option.Some($Box(ch#Z#0))))));
    assume true;
    assume $Is(GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    goto anon18;

  anon25_Else:
    assume {:partition} Seq#Length(arg#0) != LitInt(1);
    assume Map#Domain(longMap#0)[$Box(opt#Z#0)];
    assume $IsAllocBox(Map#Elements(longMap#0)[$Box(opt#Z#0)], Tclass.GetOpt.Param(), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(arg#0);
    ##value#0 := #Wrappers.Option.Some($Box(Seq#Drop(arg#0, LitInt(1))));
    assume $IsAlloc(##value#0, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(Seq#Drop(arg#0, LitInt(1)))));
    assume GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(Seq#Drop(arg#0, LitInt(1))))))), $Box(Lit(#Wrappers.Option.None())))));
    assume GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, #Wrappers.Option.Some($Box(Seq#Drop(arg#0, LitInt(1)))));
    assume $Is(GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    goto anon18;

  anon24_Else:
    assume {:partition} !GetOpt.Param.NeedsArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(arg#0);
    assume Map#Domain(longMap#0)[$Box(opt#Z#0)];
    assume $IsAllocBox(Map#Elements(longMap#0)[$Box(opt#Z#0)], Tclass.GetOpt.Param(), $Heap);
    ##value#1 := Lit(#Wrappers.Option.None());
    assume $IsAlloc(##value#1, Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    assume GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, Lit(#Wrappers.Option.None()));
    ##arg#0 := Seq#Drop(arg#0, LitInt(1));
    assume $IsAlloc(##arg#0, TSeq(TChar), $Heap);
    ##longMap#0 := longMap#0;
    assume $IsAlloc(##longMap#0, TMap(TSeq(TChar), Tclass.GetOpt.Param()), $Heap);
    ##shortMap#0 := shortMap#0;
    assume $IsAlloc(##shortMap#0, TMap(TChar, TSeq(TChar)), $Heap);
    ##parms#0 := Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, Lit(#Wrappers.Option.None())));
    assume $IsAlloc(##parms#0, TSeq(Tclass.GetOpt.OneArg()), $Heap);
    assume {:subsumption 0} (forall x#4: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#4)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain(##shortMap#0)[$Box(x#4)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#4)]]);
    assume (forall x#4: char :: { $Unbox(Map#Elements(##shortMap#0)[$Box(x#4)]): Seq } { Map#Domain(##shortMap#0)[$Box(x#4)] } $Is(x#4, TChar) && Map#Domain(##shortMap#0)[$Box(x#4)] ==> Map#Domain(##longMap#0)[Map#Elements(##shortMap#0)[$Box(x#4)]]);
    assume Seq#Rank(##arg#0) < Seq#Rank(arg#0) || (Seq#Rank(##arg#0) == Seq#Rank(arg#0) && ((Set#Subset(Map#Domain(##longMap#0), Map#Domain(longMap#0)) && !Set#Subset(Map#Domain(longMap#0), Map#Domain(##longMap#0))) || (Set#Equal(Map#Domain(##longMap#0), Map#Domain(longMap#0)) && ((Set#Subset(Map#Domain(##shortMap#0), Map#Domain(shortMap#0)) && !Set#Subset(Map#Domain(shortMap#0), Map#Domain(##shortMap#0))) || (Set#Equal(Map#Domain(##shortMap#0), Map#Domain(shortMap#0)) && Seq#Rank(##parms#0) < Seq#Rank(parms#0))))));
    assume GetOpt.__default.GetShort#canCall(Seq#Drop(arg#0, LitInt(1)), longMap#0, shortMap#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, Lit(#Wrappers.Option.None()))));
    assume GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0) == GetOpt.__default.GetShort($LS($LZ), Seq#Drop(arg#0, LitInt(1)), longMap#0, shortMap#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, Lit(#Wrappers.Option.None()))));
    assume GetOpt.Param.MakeArg#canCall($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, Lit(#Wrappers.Option.None())) && GetOpt.__default.GetShort#canCall(Seq#Drop(arg#0, LitInt(1)), longMap#0, shortMap#0, Seq#Append(parms#0, GetOpt.Param.MakeArg($Unbox(Map#Elements(longMap#0)[$Box(opt#Z#0)]): DatatypeType, Lit(#Wrappers.Option.None()))));
    assume $Is(GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    goto anon18;

  anon23_Else:
    assume {:partition} !Map#Domain(shortMap#0)[$Box(ch#Z#0)];
    assume GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0) == #Wrappers.Result.Failure($Box(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(104))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(ch#Z#0))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(103))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(122))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(46))))));
    assume true;
    assume $Is(GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(Tclass.GetOpt.OneArg()), Tclass.Wrappers.Option(TChar)), TSeq(TChar)));
    goto anon18;

  anon18:
    assume GetOpt.__default.GetShort($LS($LZ), arg#0, longMap#0, shortMap#0, parms#0) == res#0;
    return;
}



procedure {:verboseName "GetOpt.reveal_Filter (well-formedness)"} {:verify false} CheckWellFormed$$GetOpt.__default.reveal__Filter();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GetOpt.reveal_Filter (call precondtion)"} {:verify false} CallPre$$GetOpt.__default.reveal__Filter();



procedure {:verboseName "GetOpt.reveal_Filter (call postcondition)"} {:verify false} CallPost$$GetOpt.__default.reveal__Filter();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_GetOpt._default.Filter;



procedure {:verboseName "GetOpt.reveal_IndexOf (well-formedness)"} {:verify false} CheckWellFormed$$GetOpt.__default.reveal__IndexOf();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GetOpt.reveal_IndexOf (call precondtion)"} {:verify false} CallPre$$GetOpt.__default.reveal__IndexOf();



procedure {:verboseName "GetOpt.reveal_IndexOf (call postcondition)"} {:verify false} CallPost$$GetOpt.__default.reveal__IndexOf();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_GetOpt._default.IndexOf;



procedure {:verboseName "GetOpt.Print (well-formedness)"} CheckWellFormed$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box where $IsBox(x#0, GetOpt._default.Print$T) && $IsAllocBox(x#0, GetOpt._default.Print$T, $Heap)) returns (#result#0: DatatypeType where $Is(#result#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(#result#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "GetOpt.Print (call precondtion)"} CallPre$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box where $IsBox(x#0, GetOpt._default.Print$T) && $IsAllocBox(x#0, GetOpt._default.Print$T, $Heap));



procedure {:verboseName "GetOpt.Print (call postcondition)"} CallPost$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box where $IsBox(x#0, GetOpt._default.Print$T) && $IsAllocBox(x#0, GetOpt._default.Print$T, $Heap)) returns (#result#0: DatatypeType where $Is(#result#0, Tclass.Wrappers.Outcome(TSeq(TChar))) && $IsAlloc(#result#0, Tclass.Wrappers.Outcome(TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Outcome(#result#0) && $IsA#Wrappers.Outcome(GetOpt.__default.Print(GetOpt._default.Print$T, x#0)) && GetOpt.__default.Print#canCall(GetOpt._default.Print$T, x#0);
  free ensures {:id "id17401"} Wrappers.Outcome#Equal(#result#0, GetOpt.__default.Print(GetOpt._default.Print$T, x#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function #GetOpt.Tri.Yes() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Tri.Yes()) == ##GetOpt.Tri.Yes;
axiom $Is(#GetOpt.Tri.Yes(), Tclass.GetOpt.Tri());
axiom #GetOpt.Tri.Yes() == Lit(#GetOpt.Tri.Yes());
}

const unique ##GetOpt.Tri.Yes: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Tri.Yes()) == ##GetOpt.Tri.Yes;
}

function GetOpt.Tri.Yes_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Tri.Yes_q(d) } GetOpt.Tri.Yes_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Tri.Yes);

axiom (forall d: DatatypeType :: { GetOpt.Tri.Yes_q(d) } GetOpt.Tri.Yes_q(d) ==> d == #GetOpt.Tri.Yes());

function Tclass.GetOpt.Tri() : Ty
uses {
axiom Tag(Tclass.GetOpt.Tri()) == Tagclass.GetOpt.Tri && TagFamily(Tclass.GetOpt.Tri()) == tytagFamily$Tri;
}

const unique Tagclass.GetOpt.Tri: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Tri()) } $IsBox(bx, Tclass.GetOpt.Tri()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Tri()));

function #GetOpt.Tri.No() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Tri.No()) == ##GetOpt.Tri.No;
axiom $Is(#GetOpt.Tri.No(), Tclass.GetOpt.Tri());
axiom #GetOpt.Tri.No() == Lit(#GetOpt.Tri.No());
}

const unique ##GetOpt.Tri.No: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Tri.No()) == ##GetOpt.Tri.No;
}

function GetOpt.Tri.No_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Tri.No_q(d) } GetOpt.Tri.No_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Tri.No);

axiom (forall d: DatatypeType :: { GetOpt.Tri.No_q(d) } GetOpt.Tri.No_q(d) ==> d == #GetOpt.Tri.No());

function #GetOpt.Tri.Maybe() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Tri.Maybe()) == ##GetOpt.Tri.Maybe;
axiom $Is(#GetOpt.Tri.Maybe(), Tclass.GetOpt.Tri());
axiom #GetOpt.Tri.Maybe() == Lit(#GetOpt.Tri.Maybe());
}

const unique ##GetOpt.Tri.Maybe: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Tri.Maybe()) == ##GetOpt.Tri.Maybe;
}

function GetOpt.Tri.Maybe_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Tri.Maybe_q(d) } GetOpt.Tri.Maybe_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Tri.Maybe);

axiom (forall d: DatatypeType :: { GetOpt.Tri.Maybe_q(d) } GetOpt.Tri.Maybe_q(d) ==> d == #GetOpt.Tri.Maybe());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Tri(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Tri()) ==> $IsAlloc(d, Tclass.GetOpt.Tri(), $h));

function $IsA#GetOpt.Tri(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Tri(d) } $IsA#GetOpt.Tri(d) ==> GetOpt.Tri.Yes_q(d) || GetOpt.Tri.No_q(d) || GetOpt.Tri.Maybe_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Tri.Maybe_q(d), $Is(d, Tclass.GetOpt.Tri()) } { GetOpt.Tri.No_q(d), $Is(d, Tclass.GetOpt.Tri()) } { GetOpt.Tri.Yes_q(d), $Is(d, Tclass.GetOpt.Tri()) } $Is(d, Tclass.GetOpt.Tri()) ==> GetOpt.Tri.Yes_q(d) || GetOpt.Tri.No_q(d) || GetOpt.Tri.Maybe_q(d));

function GetOpt.Tri#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Tri#Equal(a, b), GetOpt.Tri.Yes_q(a) } { GetOpt.Tri#Equal(a, b), GetOpt.Tri.Yes_q(b) } GetOpt.Tri.Yes_q(a) && GetOpt.Tri.Yes_q(b) ==> GetOpt.Tri#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Tri#Equal(a, b), GetOpt.Tri.No_q(a) } { GetOpt.Tri#Equal(a, b), GetOpt.Tri.No_q(b) } GetOpt.Tri.No_q(a) && GetOpt.Tri.No_q(b) ==> GetOpt.Tri#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Tri#Equal(a, b), GetOpt.Tri.Maybe_q(a) } { GetOpt.Tri#Equal(a, b), GetOpt.Tri.Maybe_q(b) } GetOpt.Tri.Maybe_q(a) && GetOpt.Tri.Maybe_q(b) ==> GetOpt.Tri#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Tri#Equal(a, b) } GetOpt.Tri#Equal(a, b) <==> a == b);

const unique class.GetOpt.Tri: ClassName;

function #GetOpt.Visibility.Normal() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Visibility.Normal()) == ##GetOpt.Visibility.Normal;
axiom $Is(#GetOpt.Visibility.Normal(), Tclass.GetOpt.Visibility());
axiom #GetOpt.Visibility.Normal() == Lit(#GetOpt.Visibility.Normal());
}

const unique ##GetOpt.Visibility.Normal: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Visibility.Normal()) == ##GetOpt.Visibility.Normal;
}

function GetOpt.Visibility.Normal_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Normal_q(d) } GetOpt.Visibility.Normal_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Visibility.Normal);

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Normal_q(d) } GetOpt.Visibility.Normal_q(d) ==> d == #GetOpt.Visibility.Normal());

function Tclass.GetOpt.Visibility() : Ty
uses {
axiom Tag(Tclass.GetOpt.Visibility()) == Tagclass.GetOpt.Visibility && TagFamily(Tclass.GetOpt.Visibility()) == tytagFamily$Visibility;
}

const unique Tagclass.GetOpt.Visibility: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Visibility()) } $IsBox(bx, Tclass.GetOpt.Visibility()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Visibility()));

function #GetOpt.Visibility.Hidden() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Visibility.Hidden()) == ##GetOpt.Visibility.Hidden;
axiom $Is(#GetOpt.Visibility.Hidden(), Tclass.GetOpt.Visibility());
axiom #GetOpt.Visibility.Hidden() == Lit(#GetOpt.Visibility.Hidden());
}

const unique ##GetOpt.Visibility.Hidden: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Visibility.Hidden()) == ##GetOpt.Visibility.Hidden;
}

function GetOpt.Visibility.Hidden_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Hidden_q(d) } GetOpt.Visibility.Hidden_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Visibility.Hidden);

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Hidden_q(d) } GetOpt.Visibility.Hidden_q(d) ==> d == #GetOpt.Visibility.Hidden());

function #GetOpt.Visibility.Deprecated() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Visibility.Deprecated()) == ##GetOpt.Visibility.Deprecated;
axiom $Is(#GetOpt.Visibility.Deprecated(), Tclass.GetOpt.Visibility());
axiom #GetOpt.Visibility.Deprecated() == Lit(#GetOpt.Visibility.Deprecated());
}

const unique ##GetOpt.Visibility.Deprecated: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Visibility.Deprecated()) == ##GetOpt.Visibility.Deprecated;
}

function GetOpt.Visibility.Deprecated_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Deprecated_q(d) } GetOpt.Visibility.Deprecated_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Visibility.Deprecated);

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Deprecated_q(d) } GetOpt.Visibility.Deprecated_q(d) ==> d == #GetOpt.Visibility.Deprecated());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Visibility(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Visibility()) ==> $IsAlloc(d, Tclass.GetOpt.Visibility(), $h));

function $IsA#GetOpt.Visibility(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Visibility(d) } $IsA#GetOpt.Visibility(d) ==> GetOpt.Visibility.Normal_q(d) || GetOpt.Visibility.Hidden_q(d) || GetOpt.Visibility.Deprecated_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Visibility.Deprecated_q(d), $Is(d, Tclass.GetOpt.Visibility()) } { GetOpt.Visibility.Hidden_q(d), $Is(d, Tclass.GetOpt.Visibility()) } { GetOpt.Visibility.Normal_q(d), $Is(d, Tclass.GetOpt.Visibility()) } $Is(d, Tclass.GetOpt.Visibility()) ==> GetOpt.Visibility.Normal_q(d) || GetOpt.Visibility.Hidden_q(d) || GetOpt.Visibility.Deprecated_q(d));

function GetOpt.Visibility#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Visibility#Equal(a, b), GetOpt.Visibility.Normal_q(a) } { GetOpt.Visibility#Equal(a, b), GetOpt.Visibility.Normal_q(b) } GetOpt.Visibility.Normal_q(a) && GetOpt.Visibility.Normal_q(b) ==> GetOpt.Visibility#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Visibility#Equal(a, b), GetOpt.Visibility.Hidden_q(a) } { GetOpt.Visibility#Equal(a, b), GetOpt.Visibility.Hidden_q(b) } GetOpt.Visibility.Hidden_q(a) && GetOpt.Visibility.Hidden_q(b) ==> GetOpt.Visibility#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Visibility#Equal(a, b), GetOpt.Visibility.Deprecated_q(a) } { GetOpt.Visibility#Equal(a, b), GetOpt.Visibility.Deprecated_q(b) } GetOpt.Visibility.Deprecated_q(a) && GetOpt.Visibility.Deprecated_q(b) ==> GetOpt.Visibility#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Visibility#Equal(a, b) } GetOpt.Visibility#Equal(a, b) <==> a == b);

const unique class.GetOpt.Visibility: ClassName;

function #GetOpt.Options.Options(Seq, Seq, Seq) : DatatypeType;

const unique ##GetOpt.Options.Options: DtCtorId
uses {
axiom (forall a#24#0#0: Seq, a#24#1#0: Seq, a#24#2#0: Seq :: { #GetOpt.Options.Options(a#24#0#0, a#24#1#0, a#24#2#0) } DatatypeCtorId(#GetOpt.Options.Options(a#24#0#0, a#24#1#0, a#24#2#0)) == ##GetOpt.Options.Options);
}

function GetOpt.Options.Options_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Options.Options_q(d) } GetOpt.Options.Options_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Options.Options);

axiom (forall d: DatatypeType :: { GetOpt.Options.Options_q(d) } GetOpt.Options.Options_q(d) ==> (exists a#25#0#0: Seq, a#25#1#0: Seq, a#25#2#0: Seq :: d == #GetOpt.Options.Options(a#25#0#0, a#25#1#0, a#25#2#0)));

axiom (forall a#26#0#0: Seq, a#26#1#0: Seq, a#26#2#0: Seq :: { $Is(#GetOpt.Options.Options(a#26#0#0, a#26#1#0, a#26#2#0), Tclass.GetOpt.Options()) } $Is(#GetOpt.Options.Options(a#26#0#0, a#26#1#0, a#26#2#0), Tclass.GetOpt.Options()) <==> $Is(a#26#0#0, TSeq(TChar)) && $Is(a#26#1#0, TSeq(TChar)) && $Is(a#26#2#0, TSeq(Tclass.GetOpt.Param())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Options.name(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Options.Options_q(d) && $IsAlloc(d, Tclass.GetOpt.Options(), $h) ==> $IsAlloc(GetOpt.Options.name(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Options.help(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Options.Options_q(d) && $IsAlloc(d, Tclass.GetOpt.Options(), $h) ==> $IsAlloc(GetOpt.Options.help(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Options.params(d), TSeq(Tclass.GetOpt.Param()), $h) } $IsGoodHeap($h) && GetOpt.Options.Options_q(d) && $IsAlloc(d, Tclass.GetOpt.Options(), $h) ==> $IsAlloc(GetOpt.Options.params(d), TSeq(Tclass.GetOpt.Param()), $h));

axiom (forall a#27#0#0: Seq, a#27#1#0: Seq, a#27#2#0: Seq :: { #GetOpt.Options.Options(Lit(a#27#0#0), Lit(a#27#1#0), Lit(a#27#2#0)) } #GetOpt.Options.Options(Lit(a#27#0#0), Lit(a#27#1#0), Lit(a#27#2#0)) == Lit(#GetOpt.Options.Options(a#27#0#0, a#27#1#0, a#27#2#0)));

function GetOpt.Options.name(DatatypeType) : Seq;

axiom (forall a#28#0#0: Seq, a#28#1#0: Seq, a#28#2#0: Seq :: { #GetOpt.Options.Options(a#28#0#0, a#28#1#0, a#28#2#0) } GetOpt.Options.name(#GetOpt.Options.Options(a#28#0#0, a#28#1#0, a#28#2#0)) == a#28#0#0);

axiom (forall a#29#0#0: Seq, a#29#1#0: Seq, a#29#2#0: Seq, i: int :: { Seq#Index(a#29#0#0, i), #GetOpt.Options.Options(a#29#0#0, a#29#1#0, a#29#2#0) } 0 <= i && i < Seq#Length(a#29#0#0) ==> DtRank($Unbox(Seq#Index(a#29#0#0, i)): DatatypeType) < DtRank(#GetOpt.Options.Options(a#29#0#0, a#29#1#0, a#29#2#0)));

axiom (forall a#30#0#0: Seq, a#30#1#0: Seq, a#30#2#0: Seq :: { #GetOpt.Options.Options(a#30#0#0, a#30#1#0, a#30#2#0) } Seq#Rank(a#30#0#0) < DtRank(#GetOpt.Options.Options(a#30#0#0, a#30#1#0, a#30#2#0)));

function GetOpt.Options.help(DatatypeType) : Seq;

axiom (forall a#31#0#0: Seq, a#31#1#0: Seq, a#31#2#0: Seq :: { #GetOpt.Options.Options(a#31#0#0, a#31#1#0, a#31#2#0) } GetOpt.Options.help(#GetOpt.Options.Options(a#31#0#0, a#31#1#0, a#31#2#0)) == a#31#1#0);

axiom (forall a#32#0#0: Seq, a#32#1#0: Seq, a#32#2#0: Seq, i: int :: { Seq#Index(a#32#1#0, i), #GetOpt.Options.Options(a#32#0#0, a#32#1#0, a#32#2#0) } 0 <= i && i < Seq#Length(a#32#1#0) ==> DtRank($Unbox(Seq#Index(a#32#1#0, i)): DatatypeType) < DtRank(#GetOpt.Options.Options(a#32#0#0, a#32#1#0, a#32#2#0)));

axiom (forall a#33#0#0: Seq, a#33#1#0: Seq, a#33#2#0: Seq :: { #GetOpt.Options.Options(a#33#0#0, a#33#1#0, a#33#2#0) } Seq#Rank(a#33#1#0) < DtRank(#GetOpt.Options.Options(a#33#0#0, a#33#1#0, a#33#2#0)));

function GetOpt.Options.params(DatatypeType) : Seq;

axiom (forall a#34#0#0: Seq, a#34#1#0: Seq, a#34#2#0: Seq :: { #GetOpt.Options.Options(a#34#0#0, a#34#1#0, a#34#2#0) } GetOpt.Options.params(#GetOpt.Options.Options(a#34#0#0, a#34#1#0, a#34#2#0)) == a#34#2#0);

axiom (forall a#35#0#0: Seq, a#35#1#0: Seq, a#35#2#0: Seq, i: int :: { Seq#Index(a#35#2#0, i), #GetOpt.Options.Options(a#35#0#0, a#35#1#0, a#35#2#0) } 0 <= i && i < Seq#Length(a#35#2#0) ==> DtRank($Unbox(Seq#Index(a#35#2#0, i)): DatatypeType) < DtRank(#GetOpt.Options.Options(a#35#0#0, a#35#1#0, a#35#2#0)));

axiom (forall a#36#0#0: Seq, a#36#1#0: Seq, a#36#2#0: Seq :: { #GetOpt.Options.Options(a#36#0#0, a#36#1#0, a#36#2#0) } Seq#Rank(a#36#2#0) < DtRank(#GetOpt.Options.Options(a#36#0#0, a#36#1#0, a#36#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Options(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Options()) ==> $IsAlloc(d, Tclass.GetOpt.Options(), $h));

function $IsA#GetOpt.Options(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Options(d) } $IsA#GetOpt.Options(d) ==> GetOpt.Options.Options_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Options.Options_q(d), $Is(d, Tclass.GetOpt.Options()) } $Is(d, Tclass.GetOpt.Options()) ==> GetOpt.Options.Options_q(d));

function GetOpt.Options#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Options#Equal(a, b) } GetOpt.Options#Equal(a, b) <==> Seq#Equal(GetOpt.Options.name(a), GetOpt.Options.name(b)) && Seq#Equal(GetOpt.Options.help(a), GetOpt.Options.help(b)) && Seq#Equal(GetOpt.Options.params(a), GetOpt.Options.params(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Options#Equal(a, b) } GetOpt.Options#Equal(a, b) <==> a == b);

const unique class.GetOpt.Options: ClassName;

function #GetOpt.Unused.UnusedOk() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Unused.UnusedOk()) == ##GetOpt.Unused.UnusedOk;
axiom $Is(#GetOpt.Unused.UnusedOk(), Tclass.GetOpt.Unused());
axiom #GetOpt.Unused.UnusedOk() == Lit(#GetOpt.Unused.UnusedOk());
}

const unique ##GetOpt.Unused.UnusedOk: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Unused.UnusedOk()) == ##GetOpt.Unused.UnusedOk;
}

function GetOpt.Unused.UnusedOk_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Unused.UnusedOk_q(d) } GetOpt.Unused.UnusedOk_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Unused.UnusedOk);

axiom (forall d: DatatypeType :: { GetOpt.Unused.UnusedOk_q(d) } GetOpt.Unused.UnusedOk_q(d) ==> d == #GetOpt.Unused.UnusedOk());

function Tclass.GetOpt.Unused() : Ty
uses {
axiom Tag(Tclass.GetOpt.Unused()) == Tagclass.GetOpt.Unused && TagFamily(Tclass.GetOpt.Unused()) == tytagFamily$Unused;
}

const unique Tagclass.GetOpt.Unused: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.GetOpt.Unused()) } $IsBox(bx, Tclass.GetOpt.Unused()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.GetOpt.Unused()));

function #GetOpt.Unused.Required() : DatatypeType
uses {
axiom DatatypeCtorId(#GetOpt.Unused.Required()) == ##GetOpt.Unused.Required;
axiom $Is(#GetOpt.Unused.Required(), Tclass.GetOpt.Unused());
axiom #GetOpt.Unused.Required() == Lit(#GetOpt.Unused.Required());
}

const unique ##GetOpt.Unused.Required: DtCtorId
uses {
axiom DatatypeCtorId(#GetOpt.Unused.Required()) == ##GetOpt.Unused.Required;
}

function GetOpt.Unused.Required_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Unused.Required_q(d) } GetOpt.Unused.Required_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Unused.Required);

axiom (forall d: DatatypeType :: { GetOpt.Unused.Required_q(d) } GetOpt.Unused.Required_q(d) ==> d == #GetOpt.Unused.Required());

function #GetOpt.Unused.Default(Seq) : DatatypeType;

const unique ##GetOpt.Unused.Default: DtCtorId
uses {
axiom (forall a#45#0#0: Seq :: { #GetOpt.Unused.Default(a#45#0#0) } DatatypeCtorId(#GetOpt.Unused.Default(a#45#0#0)) == ##GetOpt.Unused.Default);
}

function GetOpt.Unused.Default_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Unused.Default_q(d) } GetOpt.Unused.Default_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Unused.Default);

axiom (forall d: DatatypeType :: { GetOpt.Unused.Default_q(d) } GetOpt.Unused.Default_q(d) ==> (exists a#46#0#0: Seq :: d == #GetOpt.Unused.Default(a#46#0#0)));

axiom (forall a#47#0#0: Seq :: { $Is(#GetOpt.Unused.Default(a#47#0#0), Tclass.GetOpt.Unused()) } $Is(#GetOpt.Unused.Default(a#47#0#0), Tclass.GetOpt.Unused()) <==> $Is(a#47#0#0, TSeq(TChar)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Unused.val(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Unused.Default_q(d) && $IsAlloc(d, Tclass.GetOpt.Unused(), $h) ==> $IsAlloc(GetOpt.Unused.val(d), TSeq(TChar), $h));

axiom (forall a#48#0#0: Seq :: { #GetOpt.Unused.Default(Lit(a#48#0#0)) } #GetOpt.Unused.Default(Lit(a#48#0#0)) == Lit(#GetOpt.Unused.Default(a#48#0#0)));

function GetOpt.Unused.val(DatatypeType) : Seq;

axiom (forall a#49#0#0: Seq :: { #GetOpt.Unused.Default(a#49#0#0) } GetOpt.Unused.val(#GetOpt.Unused.Default(a#49#0#0)) == a#49#0#0);

axiom (forall a#50#0#0: Seq, i: int :: { Seq#Index(a#50#0#0, i), #GetOpt.Unused.Default(a#50#0#0) } 0 <= i && i < Seq#Length(a#50#0#0) ==> DtRank($Unbox(Seq#Index(a#50#0#0, i)): DatatypeType) < DtRank(#GetOpt.Unused.Default(a#50#0#0)));

axiom (forall a#51#0#0: Seq :: { #GetOpt.Unused.Default(a#51#0#0) } Seq#Rank(a#51#0#0) < DtRank(#GetOpt.Unused.Default(a#51#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Unused(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Unused()) ==> $IsAlloc(d, Tclass.GetOpt.Unused(), $h));

function $IsA#GetOpt.Unused(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Unused(d) } $IsA#GetOpt.Unused(d) ==> GetOpt.Unused.UnusedOk_q(d) || GetOpt.Unused.Required_q(d) || GetOpt.Unused.Default_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Unused.Default_q(d), $Is(d, Tclass.GetOpt.Unused()) } { GetOpt.Unused.Required_q(d), $Is(d, Tclass.GetOpt.Unused()) } { GetOpt.Unused.UnusedOk_q(d), $Is(d, Tclass.GetOpt.Unused()) } $Is(d, Tclass.GetOpt.Unused()) ==> GetOpt.Unused.UnusedOk_q(d) || GetOpt.Unused.Required_q(d) || GetOpt.Unused.Default_q(d));

function GetOpt.Unused#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Unused#Equal(a, b), GetOpt.Unused.UnusedOk_q(a) } { GetOpt.Unused#Equal(a, b), GetOpt.Unused.UnusedOk_q(b) } GetOpt.Unused.UnusedOk_q(a) && GetOpt.Unused.UnusedOk_q(b) ==> GetOpt.Unused#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Unused#Equal(a, b), GetOpt.Unused.Required_q(a) } { GetOpt.Unused#Equal(a, b), GetOpt.Unused.Required_q(b) } GetOpt.Unused.Required_q(a) && GetOpt.Unused.Required_q(b) ==> GetOpt.Unused#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Unused#Equal(a, b), GetOpt.Unused.Default_q(a) } { GetOpt.Unused#Equal(a, b), GetOpt.Unused.Default_q(b) } GetOpt.Unused.Default_q(a) && GetOpt.Unused.Default_q(b) ==> (GetOpt.Unused#Equal(a, b) <==> Seq#Equal(GetOpt.Unused.val(a), GetOpt.Unused.val(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Unused#Equal(a, b) } GetOpt.Unused#Equal(a, b) <==> a == b);

const unique class.GetOpt.Unused: ClassName;

function #GetOpt.Param.Opt(Seq, Seq, Seq, char, DatatypeType, bool, DatatypeType, Seq, Seq, DatatypeType) : DatatypeType;

const unique ##GetOpt.Param.Opt: DtCtorId
uses {
axiom (forall a#52#0#0: Seq, a#52#1#0: Seq, a#52#2#0: Seq, a#52#3#0: char, a#52#4#0: DatatypeType, a#52#5#0: bool, a#52#6#0: DatatypeType, a#52#7#0: Seq, a#52#8#0: Seq, a#52#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#52#0#0, a#52#1#0, a#52#2#0, a#52#3#0, a#52#4#0, a#52#5#0, a#52#6#0, a#52#7#0, a#52#8#0, a#52#9#0) } DatatypeCtorId(#GetOpt.Param.Opt(a#52#0#0, a#52#1#0, a#52#2#0, a#52#3#0, a#52#4#0, a#52#5#0, a#52#6#0, a#52#7#0, a#52#8#0, a#52#9#0)) == ##GetOpt.Param.Opt);
}

function GetOpt.Param.Opt_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Param.Opt_q(d) } GetOpt.Param.Opt_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Param.Opt);

procedure {:verboseName "#GetOpt.Param.Opt (well-formedness)"} CheckWellformed$$#GetOpt.Param.Opt(name#0: Seq where $Is(name#0, TSeq(TChar)), help#0: Seq where $Is(help#0, TSeq(TChar)), argName#0: Seq where $Is(argName#0, TSeq(TChar)), short#0: char where $Is(short#0, TChar), unused#0: DatatypeType where $Is(unused#0, Tclass.GetOpt.Unused()), inherit#0: bool, vis#0: DatatypeType where $Is(vis#0, Tclass.GetOpt.Visibility()), shortAlias#0: Seq where $Is(shortAlias#0, TSeq(TChar)), longAlias#0: Seq where $Is(longAlias#0, TSeq(TSeq(TChar))), positional#0: DatatypeType where $Is(positional#0, Tclass.GetOpt.Tri()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall d: DatatypeType :: { GetOpt.Param.Opt_q(d) } GetOpt.Param.Opt_q(d) ==> (exists a#0#0#0: Seq, a#0#1#0: Seq, a#0#2#0: Seq, a#0#3#0: char, a#0#4#0: DatatypeType, a#0#5#0: bool, a#0#6#0: DatatypeType, a#0#7#0: Seq, a#0#8#0: Seq, a#0#9#0: DatatypeType :: d == #GetOpt.Param.Opt(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0, a#0#5#0, a#0#6#0, a#0#7#0, a#0#8#0, a#0#9#0)));

axiom (forall a#1#0#0: Seq, a#1#1#0: Seq, a#1#2#0: Seq, a#1#3#0: char, a#1#4#0: DatatypeType, a#1#5#0: bool, a#1#6#0: DatatypeType, a#1#7#0: Seq, a#1#8#0: Seq, a#1#9#0: DatatypeType :: { $Is(#GetOpt.Param.Opt(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0, a#1#5#0, a#1#6#0, a#1#7#0, a#1#8#0, a#1#9#0), Tclass.GetOpt.Param()) } $Is(#GetOpt.Param.Opt(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0, a#1#5#0, a#1#6#0, a#1#7#0, a#1#8#0, a#1#9#0), Tclass.GetOpt.Param()) <==> $Is(a#1#0#0, TSeq(TChar)) && $Is(a#1#1#0, TSeq(TChar)) && $Is(a#1#2#0, TSeq(TChar)) && $Is(a#1#3#0, TChar) && $Is(a#1#4#0, Tclass.GetOpt.Unused()) && $Is(a#1#5#0, TBool) && $Is(a#1#6#0, Tclass.GetOpt.Visibility()) && $Is(a#1#7#0, TSeq(TChar)) && $Is(a#1#8#0, TSeq(TSeq(TChar))) && $Is(a#1#9#0, Tclass.GetOpt.Tri()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.name(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.name(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.help(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.help(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.argName(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.argName(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.short(d), TChar, $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.short(d), TChar, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.unused(d), Tclass.GetOpt.Unused(), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.unused(d), Tclass.GetOpt.Unused(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.inherit(d), TBool, $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.inherit(d), TBool, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.vis(d), Tclass.GetOpt.Visibility(), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.vis(d), Tclass.GetOpt.Visibility(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.shortAlias(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.shortAlias(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.longAlias(d), TSeq(TSeq(TChar)), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.longAlias(d), TSeq(TSeq(TChar)), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.positional(d), Tclass.GetOpt.Tri(), $h) } $IsGoodHeap($h) && GetOpt.Param.Opt_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.positional(d), Tclass.GetOpt.Tri(), $h));

axiom (forall a#2#0#0: Seq, a#2#1#0: Seq, a#2#2#0: Seq, a#2#3#0: char, a#2#4#0: DatatypeType, a#2#5#0: bool, a#2#6#0: DatatypeType, a#2#7#0: Seq, a#2#8#0: Seq, a#2#9#0: DatatypeType :: { #GetOpt.Param.Opt(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0), Lit(a#2#3#0), Lit(a#2#4#0), Lit(a#2#5#0), Lit(a#2#6#0), Lit(a#2#7#0), Lit(a#2#8#0), Lit(a#2#9#0)) } #GetOpt.Param.Opt(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0), Lit(a#2#3#0), Lit(a#2#4#0), Lit(a#2#5#0), Lit(a#2#6#0), Lit(a#2#7#0), Lit(a#2#8#0), Lit(a#2#9#0)) == Lit(#GetOpt.Param.Opt(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0, a#2#5#0, a#2#6#0, a#2#7#0, a#2#8#0, a#2#9#0)));

function GetOpt.Param.name(DatatypeType) : Seq;

axiom (forall a#3#0#0: Seq, a#3#1#0: Seq, a#3#2#0: Seq, a#3#3#0: char, a#3#4#0: DatatypeType, a#3#5#0: bool, a#3#6#0: DatatypeType, a#3#7#0: Seq, a#3#8#0: Seq, a#3#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0, a#3#5#0, a#3#6#0, a#3#7#0, a#3#8#0, a#3#9#0) } GetOpt.Param.name(#GetOpt.Param.Opt(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0, a#3#5#0, a#3#6#0, a#3#7#0, a#3#8#0, a#3#9#0)) == a#3#0#0);

axiom (forall a#4#0#0: Seq, a#4#1#0: Seq, a#4#2#0: Seq, a#4#3#0: char, a#4#4#0: DatatypeType, a#4#5#0: bool, a#4#6#0: DatatypeType, a#4#7#0: Seq, a#4#8#0: Seq, a#4#9#0: DatatypeType, i: int :: { Seq#Index(a#4#0#0, i), #GetOpt.Param.Opt(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0, a#4#5#0, a#4#6#0, a#4#7#0, a#4#8#0, a#4#9#0) } 0 <= i && i < Seq#Length(a#4#0#0) ==> DtRank($Unbox(Seq#Index(a#4#0#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Opt(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0, a#4#5#0, a#4#6#0, a#4#7#0, a#4#8#0, a#4#9#0)));

axiom (forall a#5#0#0: Seq, a#5#1#0: Seq, a#5#2#0: Seq, a#5#3#0: char, a#5#4#0: DatatypeType, a#5#5#0: bool, a#5#6#0: DatatypeType, a#5#7#0: Seq, a#5#8#0: Seq, a#5#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0, a#5#5#0, a#5#6#0, a#5#7#0, a#5#8#0, a#5#9#0) } Seq#Rank(a#5#0#0) < DtRank(#GetOpt.Param.Opt(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0, a#5#5#0, a#5#6#0, a#5#7#0, a#5#8#0, a#5#9#0)));

function GetOpt.Param.help(DatatypeType) : Seq;

axiom (forall a#6#0#0: Seq, a#6#1#0: Seq, a#6#2#0: Seq, a#6#3#0: char, a#6#4#0: DatatypeType, a#6#5#0: bool, a#6#6#0: DatatypeType, a#6#7#0: Seq, a#6#8#0: Seq, a#6#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0, a#6#5#0, a#6#6#0, a#6#7#0, a#6#8#0, a#6#9#0) } GetOpt.Param.help(#GetOpt.Param.Opt(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0, a#6#5#0, a#6#6#0, a#6#7#0, a#6#8#0, a#6#9#0)) == a#6#1#0);

axiom (forall a#7#0#0: Seq, a#7#1#0: Seq, a#7#2#0: Seq, a#7#3#0: char, a#7#4#0: DatatypeType, a#7#5#0: bool, a#7#6#0: DatatypeType, a#7#7#0: Seq, a#7#8#0: Seq, a#7#9#0: DatatypeType, i: int :: { Seq#Index(a#7#1#0, i), #GetOpt.Param.Opt(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0, a#7#5#0, a#7#6#0, a#7#7#0, a#7#8#0, a#7#9#0) } 0 <= i && i < Seq#Length(a#7#1#0) ==> DtRank($Unbox(Seq#Index(a#7#1#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Opt(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0, a#7#5#0, a#7#6#0, a#7#7#0, a#7#8#0, a#7#9#0)));

axiom (forall a#8#0#0: Seq, a#8#1#0: Seq, a#8#2#0: Seq, a#8#3#0: char, a#8#4#0: DatatypeType, a#8#5#0: bool, a#8#6#0: DatatypeType, a#8#7#0: Seq, a#8#8#0: Seq, a#8#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0, a#8#5#0, a#8#6#0, a#8#7#0, a#8#8#0, a#8#9#0) } Seq#Rank(a#8#1#0) < DtRank(#GetOpt.Param.Opt(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0, a#8#5#0, a#8#6#0, a#8#7#0, a#8#8#0, a#8#9#0)));

function GetOpt.Param.argName(DatatypeType) : Seq;

axiom (forall a#9#0#0: Seq, a#9#1#0: Seq, a#9#2#0: Seq, a#9#3#0: char, a#9#4#0: DatatypeType, a#9#5#0: bool, a#9#6#0: DatatypeType, a#9#7#0: Seq, a#9#8#0: Seq, a#9#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0, a#9#5#0, a#9#6#0, a#9#7#0, a#9#8#0, a#9#9#0) } GetOpt.Param.argName(#GetOpt.Param.Opt(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0, a#9#5#0, a#9#6#0, a#9#7#0, a#9#8#0, a#9#9#0)) == a#9#2#0);

axiom (forall a#10#0#0: Seq, a#10#1#0: Seq, a#10#2#0: Seq, a#10#3#0: char, a#10#4#0: DatatypeType, a#10#5#0: bool, a#10#6#0: DatatypeType, a#10#7#0: Seq, a#10#8#0: Seq, a#10#9#0: DatatypeType, i: int :: { Seq#Index(a#10#2#0, i), #GetOpt.Param.Opt(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0, a#10#5#0, a#10#6#0, a#10#7#0, a#10#8#0, a#10#9#0) } 0 <= i && i < Seq#Length(a#10#2#0) ==> DtRank($Unbox(Seq#Index(a#10#2#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Opt(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0, a#10#5#0, a#10#6#0, a#10#7#0, a#10#8#0, a#10#9#0)));

axiom (forall a#11#0#0: Seq, a#11#1#0: Seq, a#11#2#0: Seq, a#11#3#0: char, a#11#4#0: DatatypeType, a#11#5#0: bool, a#11#6#0: DatatypeType, a#11#7#0: Seq, a#11#8#0: Seq, a#11#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0, a#11#6#0, a#11#7#0, a#11#8#0, a#11#9#0) } Seq#Rank(a#11#2#0) < DtRank(#GetOpt.Param.Opt(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0, a#11#6#0, a#11#7#0, a#11#8#0, a#11#9#0)));

function GetOpt.Param.short(DatatypeType) : char;

axiom (forall a#12#0#0: Seq, a#12#1#0: Seq, a#12#2#0: Seq, a#12#3#0: char, a#12#4#0: DatatypeType, a#12#5#0: bool, a#12#6#0: DatatypeType, a#12#7#0: Seq, a#12#8#0: Seq, a#12#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0, a#12#6#0, a#12#7#0, a#12#8#0, a#12#9#0) } GetOpt.Param.short(#GetOpt.Param.Opt(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0, a#12#6#0, a#12#7#0, a#12#8#0, a#12#9#0)) == a#12#3#0);

function GetOpt.Param.unused(DatatypeType) : DatatypeType;

axiom (forall a#13#0#0: Seq, a#13#1#0: Seq, a#13#2#0: Seq, a#13#3#0: char, a#13#4#0: DatatypeType, a#13#5#0: bool, a#13#6#0: DatatypeType, a#13#7#0: Seq, a#13#8#0: Seq, a#13#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0, a#13#6#0, a#13#7#0, a#13#8#0, a#13#9#0) } GetOpt.Param.unused(#GetOpt.Param.Opt(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0, a#13#6#0, a#13#7#0, a#13#8#0, a#13#9#0)) == a#13#4#0);

axiom (forall a#14#0#0: Seq, a#14#1#0: Seq, a#14#2#0: Seq, a#14#3#0: char, a#14#4#0: DatatypeType, a#14#5#0: bool, a#14#6#0: DatatypeType, a#14#7#0: Seq, a#14#8#0: Seq, a#14#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0, a#14#6#0, a#14#7#0, a#14#8#0, a#14#9#0) } DtRank(a#14#4#0) < DtRank(#GetOpt.Param.Opt(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0, a#14#6#0, a#14#7#0, a#14#8#0, a#14#9#0)));

function GetOpt.Param.inherit(DatatypeType) : bool;

axiom (forall a#15#0#0: Seq, a#15#1#0: Seq, a#15#2#0: Seq, a#15#3#0: char, a#15#4#0: DatatypeType, a#15#5#0: bool, a#15#6#0: DatatypeType, a#15#7#0: Seq, a#15#8#0: Seq, a#15#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0, a#15#6#0, a#15#7#0, a#15#8#0, a#15#9#0) } GetOpt.Param.inherit(#GetOpt.Param.Opt(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0, a#15#6#0, a#15#7#0, a#15#8#0, a#15#9#0)) <==> a#15#5#0);

function GetOpt.Param.vis(DatatypeType) : DatatypeType;

axiom (forall a#16#0#0: Seq, a#16#1#0: Seq, a#16#2#0: Seq, a#16#3#0: char, a#16#4#0: DatatypeType, a#16#5#0: bool, a#16#6#0: DatatypeType, a#16#7#0: Seq, a#16#8#0: Seq, a#16#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0, a#16#6#0, a#16#7#0, a#16#8#0, a#16#9#0) } GetOpt.Param.vis(#GetOpt.Param.Opt(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0, a#16#6#0, a#16#7#0, a#16#8#0, a#16#9#0)) == a#16#6#0);

axiom (forall a#17#0#0: Seq, a#17#1#0: Seq, a#17#2#0: Seq, a#17#3#0: char, a#17#4#0: DatatypeType, a#17#5#0: bool, a#17#6#0: DatatypeType, a#17#7#0: Seq, a#17#8#0: Seq, a#17#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0, a#17#6#0, a#17#7#0, a#17#8#0, a#17#9#0) } DtRank(a#17#6#0) < DtRank(#GetOpt.Param.Opt(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0, a#17#6#0, a#17#7#0, a#17#8#0, a#17#9#0)));

function GetOpt.Param.shortAlias(DatatypeType) : Seq;

axiom (forall a#18#0#0: Seq, a#18#1#0: Seq, a#18#2#0: Seq, a#18#3#0: char, a#18#4#0: DatatypeType, a#18#5#0: bool, a#18#6#0: DatatypeType, a#18#7#0: Seq, a#18#8#0: Seq, a#18#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0, a#18#6#0, a#18#7#0, a#18#8#0, a#18#9#0) } GetOpt.Param.shortAlias(#GetOpt.Param.Opt(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0, a#18#6#0, a#18#7#0, a#18#8#0, a#18#9#0)) == a#18#7#0);

axiom (forall a#19#0#0: Seq, a#19#1#0: Seq, a#19#2#0: Seq, a#19#3#0: char, a#19#4#0: DatatypeType, a#19#5#0: bool, a#19#6#0: DatatypeType, a#19#7#0: Seq, a#19#8#0: Seq, a#19#9#0: DatatypeType, i: int :: { Seq#Index(a#19#7#0, i), #GetOpt.Param.Opt(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0, a#19#5#0, a#19#6#0, a#19#7#0, a#19#8#0, a#19#9#0) } 0 <= i && i < Seq#Length(a#19#7#0) ==> DtRank($Unbox(Seq#Index(a#19#7#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Opt(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0, a#19#5#0, a#19#6#0, a#19#7#0, a#19#8#0, a#19#9#0)));

axiom (forall a#20#0#0: Seq, a#20#1#0: Seq, a#20#2#0: Seq, a#20#3#0: char, a#20#4#0: DatatypeType, a#20#5#0: bool, a#20#6#0: DatatypeType, a#20#7#0: Seq, a#20#8#0: Seq, a#20#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0, a#20#4#0, a#20#5#0, a#20#6#0, a#20#7#0, a#20#8#0, a#20#9#0) } Seq#Rank(a#20#7#0) < DtRank(#GetOpt.Param.Opt(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0, a#20#4#0, a#20#5#0, a#20#6#0, a#20#7#0, a#20#8#0, a#20#9#0)));

function GetOpt.Param.longAlias(DatatypeType) : Seq;

axiom (forall a#21#0#0: Seq, a#21#1#0: Seq, a#21#2#0: Seq, a#21#3#0: char, a#21#4#0: DatatypeType, a#21#5#0: bool, a#21#6#0: DatatypeType, a#21#7#0: Seq, a#21#8#0: Seq, a#21#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0, a#21#5#0, a#21#6#0, a#21#7#0, a#21#8#0, a#21#9#0) } GetOpt.Param.longAlias(#GetOpt.Param.Opt(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0, a#21#5#0, a#21#6#0, a#21#7#0, a#21#8#0, a#21#9#0)) == a#21#8#0);

axiom (forall a#22#0#0: Seq, a#22#1#0: Seq, a#22#2#0: Seq, a#22#3#0: char, a#22#4#0: DatatypeType, a#22#5#0: bool, a#22#6#0: DatatypeType, a#22#7#0: Seq, a#22#8#0: Seq, a#22#9#0: DatatypeType, i: int :: { Seq#Index(a#22#8#0, i), #GetOpt.Param.Opt(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0, a#22#5#0, a#22#6#0, a#22#7#0, a#22#8#0, a#22#9#0) } 0 <= i && i < Seq#Length(a#22#8#0) ==> DtRank($Unbox(Seq#Index(a#22#8#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Opt(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0, a#22#5#0, a#22#6#0, a#22#7#0, a#22#8#0, a#22#9#0)));

axiom (forall a#23#0#0: Seq, a#23#1#0: Seq, a#23#2#0: Seq, a#23#3#0: char, a#23#4#0: DatatypeType, a#23#5#0: bool, a#23#6#0: DatatypeType, a#23#7#0: Seq, a#23#8#0: Seq, a#23#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0, a#23#5#0, a#23#6#0, a#23#7#0, a#23#8#0, a#23#9#0) } Seq#Rank(a#23#8#0) < DtRank(#GetOpt.Param.Opt(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0, a#23#5#0, a#23#6#0, a#23#7#0, a#23#8#0, a#23#9#0)));

function GetOpt.Param.positional(DatatypeType) : DatatypeType;

axiom (forall a#24#0#0: Seq, a#24#1#0: Seq, a#24#2#0: Seq, a#24#3#0: char, a#24#4#0: DatatypeType, a#24#5#0: bool, a#24#6#0: DatatypeType, a#24#7#0: Seq, a#24#8#0: Seq, a#24#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0, a#24#5#0, a#24#6#0, a#24#7#0, a#24#8#0, a#24#9#0) } GetOpt.Param.positional(#GetOpt.Param.Opt(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0, a#24#5#0, a#24#6#0, a#24#7#0, a#24#8#0, a#24#9#0)) == a#24#9#0);

axiom (forall a#25#0#0: Seq, a#25#1#0: Seq, a#25#2#0: Seq, a#25#3#0: char, a#25#4#0: DatatypeType, a#25#5#0: bool, a#25#6#0: DatatypeType, a#25#7#0: Seq, a#25#8#0: Seq, a#25#9#0: DatatypeType :: { #GetOpt.Param.Opt(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0, a#25#5#0, a#25#6#0, a#25#7#0, a#25#8#0, a#25#9#0) } DtRank(a#25#9#0) < DtRank(#GetOpt.Param.Opt(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0, a#25#5#0, a#25#6#0, a#25#7#0, a#25#8#0, a#25#9#0)));

function #GetOpt.Param.Flag(Seq, Seq, char, bool, bool, DatatypeType, Seq, Seq) : DatatypeType;

const unique ##GetOpt.Param.Flag: DtCtorId
uses {
axiom (forall a#26#0#0: Seq, a#26#1#0: Seq, a#26#2#0: char, a#26#3#0: bool, a#26#4#0: bool, a#26#5#0: DatatypeType, a#26#6#0: Seq, a#26#7#0: Seq :: { #GetOpt.Param.Flag(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0, a#26#5#0, a#26#6#0, a#26#7#0) } DatatypeCtorId(#GetOpt.Param.Flag(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0, a#26#5#0, a#26#6#0, a#26#7#0)) == ##GetOpt.Param.Flag);
}

function GetOpt.Param.Flag_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Param.Flag_q(d) } GetOpt.Param.Flag_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Param.Flag);

procedure {:verboseName "#GetOpt.Param.Flag (well-formedness)"} CheckWellformed$$#GetOpt.Param.Flag(name#0: Seq where $Is(name#0, TSeq(TChar)), help#0: Seq where $Is(help#0, TSeq(TChar)), short#0: char where $Is(short#0, TChar), solo#0: bool, inherit#0: bool, vis#0: DatatypeType where $Is(vis#0, Tclass.GetOpt.Visibility()), shortAlias#0: Seq where $Is(shortAlias#0, TSeq(TChar)), longAlias#0: Seq where $Is(longAlias#0, TSeq(TSeq(TChar))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall d: DatatypeType :: { GetOpt.Param.Flag_q(d) } GetOpt.Param.Flag_q(d) ==> (exists a#0#0#0: Seq, a#0#1#0: Seq, a#0#2#0: char, a#0#3#0: bool, a#0#4#0: bool, a#0#5#0: DatatypeType, a#0#6#0: Seq, a#0#7#0: Seq :: d == #GetOpt.Param.Flag(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0, a#0#5#0, a#0#6#0, a#0#7#0)));

axiom (forall a#1#0#0: Seq, a#1#1#0: Seq, a#1#2#0: char, a#1#3#0: bool, a#1#4#0: bool, a#1#5#0: DatatypeType, a#1#6#0: Seq, a#1#7#0: Seq :: { $Is(#GetOpt.Param.Flag(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0, a#1#5#0, a#1#6#0, a#1#7#0), Tclass.GetOpt.Param()) } $Is(#GetOpt.Param.Flag(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0, a#1#5#0, a#1#6#0, a#1#7#0), Tclass.GetOpt.Param()) <==> $Is(a#1#0#0, TSeq(TChar)) && $Is(a#1#1#0, TSeq(TChar)) && $Is(a#1#2#0, TChar) && $Is(a#1#3#0, TBool) && $Is(a#1#4#0, TBool) && $Is(a#1#5#0, Tclass.GetOpt.Visibility()) && $Is(a#1#6#0, TSeq(TChar)) && $Is(a#1#7#0, TSeq(TSeq(TChar))));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.name(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.name(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.help(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.help(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.short(d), TChar, $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.short(d), TChar, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.solo(d), TBool, $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.solo(d), TBool, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.inherit(d), TBool, $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.inherit(d), TBool, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.vis(d), Tclass.GetOpt.Visibility(), $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.vis(d), Tclass.GetOpt.Visibility(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.shortAlias(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.shortAlias(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.longAlias(d), TSeq(TSeq(TChar)), $h) } $IsGoodHeap($h) && GetOpt.Param.Flag_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.longAlias(d), TSeq(TSeq(TChar)), $h));

axiom (forall a#2#0#0: Seq, a#2#1#0: Seq, a#2#2#0: char, a#2#3#0: bool, a#2#4#0: bool, a#2#5#0: DatatypeType, a#2#6#0: Seq, a#2#7#0: Seq :: { #GetOpt.Param.Flag(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0), Lit(a#2#3#0), Lit(a#2#4#0), Lit(a#2#5#0), Lit(a#2#6#0), Lit(a#2#7#0)) } #GetOpt.Param.Flag(Lit(a#2#0#0), Lit(a#2#1#0), Lit(a#2#2#0), Lit(a#2#3#0), Lit(a#2#4#0), Lit(a#2#5#0), Lit(a#2#6#0), Lit(a#2#7#0)) == Lit(#GetOpt.Param.Flag(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0, a#2#5#0, a#2#6#0, a#2#7#0)));

axiom (forall a#3#0#0: Seq, a#3#1#0: Seq, a#3#2#0: char, a#3#3#0: bool, a#3#4#0: bool, a#3#5#0: DatatypeType, a#3#6#0: Seq, a#3#7#0: Seq :: { #GetOpt.Param.Flag(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0, a#3#5#0, a#3#6#0, a#3#7#0) } GetOpt.Param.name(#GetOpt.Param.Flag(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0, a#3#5#0, a#3#6#0, a#3#7#0)) == a#3#0#0);

axiom (forall a#4#0#0: Seq, a#4#1#0: Seq, a#4#2#0: char, a#4#3#0: bool, a#4#4#0: bool, a#4#5#0: DatatypeType, a#4#6#0: Seq, a#4#7#0: Seq, i: int :: { Seq#Index(a#4#0#0, i), #GetOpt.Param.Flag(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0, a#4#5#0, a#4#6#0, a#4#7#0) } 0 <= i && i < Seq#Length(a#4#0#0) ==> DtRank($Unbox(Seq#Index(a#4#0#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Flag(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0, a#4#5#0, a#4#6#0, a#4#7#0)));

axiom (forall a#5#0#0: Seq, a#5#1#0: Seq, a#5#2#0: char, a#5#3#0: bool, a#5#4#0: bool, a#5#5#0: DatatypeType, a#5#6#0: Seq, a#5#7#0: Seq :: { #GetOpt.Param.Flag(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0, a#5#5#0, a#5#6#0, a#5#7#0) } Seq#Rank(a#5#0#0) < DtRank(#GetOpt.Param.Flag(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0, a#5#5#0, a#5#6#0, a#5#7#0)));

axiom (forall a#6#0#0: Seq, a#6#1#0: Seq, a#6#2#0: char, a#6#3#0: bool, a#6#4#0: bool, a#6#5#0: DatatypeType, a#6#6#0: Seq, a#6#7#0: Seq :: { #GetOpt.Param.Flag(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0, a#6#5#0, a#6#6#0, a#6#7#0) } GetOpt.Param.help(#GetOpt.Param.Flag(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0, a#6#5#0, a#6#6#0, a#6#7#0)) == a#6#1#0);

axiom (forall a#7#0#0: Seq, a#7#1#0: Seq, a#7#2#0: char, a#7#3#0: bool, a#7#4#0: bool, a#7#5#0: DatatypeType, a#7#6#0: Seq, a#7#7#0: Seq, i: int :: { Seq#Index(a#7#1#0, i), #GetOpt.Param.Flag(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0, a#7#5#0, a#7#6#0, a#7#7#0) } 0 <= i && i < Seq#Length(a#7#1#0) ==> DtRank($Unbox(Seq#Index(a#7#1#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Flag(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0, a#7#5#0, a#7#6#0, a#7#7#0)));

axiom (forall a#8#0#0: Seq, a#8#1#0: Seq, a#8#2#0: char, a#8#3#0: bool, a#8#4#0: bool, a#8#5#0: DatatypeType, a#8#6#0: Seq, a#8#7#0: Seq :: { #GetOpt.Param.Flag(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0, a#8#5#0, a#8#6#0, a#8#7#0) } Seq#Rank(a#8#1#0) < DtRank(#GetOpt.Param.Flag(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0, a#8#5#0, a#8#6#0, a#8#7#0)));

axiom (forall a#9#0#0: Seq, a#9#1#0: Seq, a#9#2#0: char, a#9#3#0: bool, a#9#4#0: bool, a#9#5#0: DatatypeType, a#9#6#0: Seq, a#9#7#0: Seq :: { #GetOpt.Param.Flag(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0, a#9#5#0, a#9#6#0, a#9#7#0) } GetOpt.Param.short(#GetOpt.Param.Flag(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0, a#9#5#0, a#9#6#0, a#9#7#0)) == a#9#2#0);

function GetOpt.Param.solo(DatatypeType) : bool;

axiom (forall a#10#0#0: Seq, a#10#1#0: Seq, a#10#2#0: char, a#10#3#0: bool, a#10#4#0: bool, a#10#5#0: DatatypeType, a#10#6#0: Seq, a#10#7#0: Seq :: { #GetOpt.Param.Flag(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0, a#10#5#0, a#10#6#0, a#10#7#0) } GetOpt.Param.solo(#GetOpt.Param.Flag(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0, a#10#5#0, a#10#6#0, a#10#7#0)) <==> a#10#3#0);

axiom (forall a#11#0#0: Seq, a#11#1#0: Seq, a#11#2#0: char, a#11#3#0: bool, a#11#4#0: bool, a#11#5#0: DatatypeType, a#11#6#0: Seq, a#11#7#0: Seq :: { #GetOpt.Param.Flag(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0, a#11#6#0, a#11#7#0) } GetOpt.Param.inherit(#GetOpt.Param.Flag(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0, a#11#6#0, a#11#7#0)) <==> a#11#4#0);

axiom (forall a#12#0#0: Seq, a#12#1#0: Seq, a#12#2#0: char, a#12#3#0: bool, a#12#4#0: bool, a#12#5#0: DatatypeType, a#12#6#0: Seq, a#12#7#0: Seq :: { #GetOpt.Param.Flag(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0, a#12#6#0, a#12#7#0) } GetOpt.Param.vis(#GetOpt.Param.Flag(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0, a#12#6#0, a#12#7#0)) == a#12#5#0);

axiom (forall a#13#0#0: Seq, a#13#1#0: Seq, a#13#2#0: char, a#13#3#0: bool, a#13#4#0: bool, a#13#5#0: DatatypeType, a#13#6#0: Seq, a#13#7#0: Seq :: { #GetOpt.Param.Flag(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0, a#13#6#0, a#13#7#0) } DtRank(a#13#5#0) < DtRank(#GetOpt.Param.Flag(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0, a#13#6#0, a#13#7#0)));

axiom (forall a#14#0#0: Seq, a#14#1#0: Seq, a#14#2#0: char, a#14#3#0: bool, a#14#4#0: bool, a#14#5#0: DatatypeType, a#14#6#0: Seq, a#14#7#0: Seq :: { #GetOpt.Param.Flag(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0, a#14#6#0, a#14#7#0) } GetOpt.Param.shortAlias(#GetOpt.Param.Flag(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0, a#14#6#0, a#14#7#0)) == a#14#6#0);

axiom (forall a#15#0#0: Seq, a#15#1#0: Seq, a#15#2#0: char, a#15#3#0: bool, a#15#4#0: bool, a#15#5#0: DatatypeType, a#15#6#0: Seq, a#15#7#0: Seq, i: int :: { Seq#Index(a#15#6#0, i), #GetOpt.Param.Flag(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0, a#15#6#0, a#15#7#0) } 0 <= i && i < Seq#Length(a#15#6#0) ==> DtRank($Unbox(Seq#Index(a#15#6#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Flag(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0, a#15#6#0, a#15#7#0)));

axiom (forall a#16#0#0: Seq, a#16#1#0: Seq, a#16#2#0: char, a#16#3#0: bool, a#16#4#0: bool, a#16#5#0: DatatypeType, a#16#6#0: Seq, a#16#7#0: Seq :: { #GetOpt.Param.Flag(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0, a#16#6#0, a#16#7#0) } Seq#Rank(a#16#6#0) < DtRank(#GetOpt.Param.Flag(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0, a#16#6#0, a#16#7#0)));

axiom (forall a#17#0#0: Seq, a#17#1#0: Seq, a#17#2#0: char, a#17#3#0: bool, a#17#4#0: bool, a#17#5#0: DatatypeType, a#17#6#0: Seq, a#17#7#0: Seq :: { #GetOpt.Param.Flag(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0, a#17#6#0, a#17#7#0) } GetOpt.Param.longAlias(#GetOpt.Param.Flag(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0, a#17#6#0, a#17#7#0)) == a#17#7#0);

axiom (forall a#18#0#0: Seq, a#18#1#0: Seq, a#18#2#0: char, a#18#3#0: bool, a#18#4#0: bool, a#18#5#0: DatatypeType, a#18#6#0: Seq, a#18#7#0: Seq, i: int :: { Seq#Index(a#18#7#0, i), #GetOpt.Param.Flag(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0, a#18#6#0, a#18#7#0) } 0 <= i && i < Seq#Length(a#18#7#0) ==> DtRank($Unbox(Seq#Index(a#18#7#0, i)): DatatypeType) < DtRank(#GetOpt.Param.Flag(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0, a#18#6#0, a#18#7#0)));

axiom (forall a#19#0#0: Seq, a#19#1#0: Seq, a#19#2#0: char, a#19#3#0: bool, a#19#4#0: bool, a#19#5#0: DatatypeType, a#19#6#0: Seq, a#19#7#0: Seq :: { #GetOpt.Param.Flag(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0, a#19#5#0, a#19#6#0, a#19#7#0) } Seq#Rank(a#19#7#0) < DtRank(#GetOpt.Param.Flag(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0, a#19#5#0, a#19#6#0, a#19#7#0)));

function #GetOpt.Param.Command(DatatypeType) : DatatypeType;

const unique ##GetOpt.Param.Command: DtCtorId
uses {
axiom (forall a#20#0#0: DatatypeType :: { #GetOpt.Param.Command(a#20#0#0) } DatatypeCtorId(#GetOpt.Param.Command(a#20#0#0)) == ##GetOpt.Param.Command);
}

function GetOpt.Param.Command_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Param.Command_q(d) } GetOpt.Param.Command_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Param.Command);

axiom (forall d: DatatypeType :: { GetOpt.Param.Command_q(d) } GetOpt.Param.Command_q(d) ==> (exists a#21#0#0: DatatypeType :: d == #GetOpt.Param.Command(a#21#0#0)));

axiom (forall a#22#0#0: DatatypeType :: { $Is(#GetOpt.Param.Command(a#22#0#0), Tclass.GetOpt.Param()) } $Is(#GetOpt.Param.Command(a#22#0#0), Tclass.GetOpt.Param()) <==> $Is(a#22#0#0, Tclass.GetOpt.Options()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Param.options(d), Tclass.GetOpt.Options(), $h) } $IsGoodHeap($h) && GetOpt.Param.Command_q(d) && $IsAlloc(d, Tclass.GetOpt.Param(), $h) ==> $IsAlloc(GetOpt.Param.options(d), Tclass.GetOpt.Options(), $h));

axiom (forall a#23#0#0: DatatypeType :: { #GetOpt.Param.Command(Lit(a#23#0#0)) } #GetOpt.Param.Command(Lit(a#23#0#0)) == Lit(#GetOpt.Param.Command(a#23#0#0)));

function GetOpt.Param.options(DatatypeType) : DatatypeType;

axiom (forall a#24#0#0: DatatypeType :: { #GetOpt.Param.Command(a#24#0#0) } GetOpt.Param.options(#GetOpt.Param.Command(a#24#0#0)) == a#24#0#0);

axiom (forall a#25#0#0: DatatypeType :: { #GetOpt.Param.Command(a#25#0#0) } DtRank(a#25#0#0) < DtRank(#GetOpt.Param.Command(a#25#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Param(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Param()) ==> $IsAlloc(d, Tclass.GetOpt.Param(), $h));

function $IsA#GetOpt.Param(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Param(d) } $IsA#GetOpt.Param(d) ==> GetOpt.Param.Opt_q(d) || GetOpt.Param.Flag_q(d) || GetOpt.Param.Command_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Param.Command_q(d), $Is(d, Tclass.GetOpt.Param()) } { GetOpt.Param.Flag_q(d), $Is(d, Tclass.GetOpt.Param()) } { GetOpt.Param.Opt_q(d), $Is(d, Tclass.GetOpt.Param()) } $Is(d, Tclass.GetOpt.Param()) ==> GetOpt.Param.Opt_q(d) || GetOpt.Param.Flag_q(d) || GetOpt.Param.Command_q(d));

function GetOpt.Param#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Param#Equal(a, b), GetOpt.Param.Opt_q(a) } { GetOpt.Param#Equal(a, b), GetOpt.Param.Opt_q(b) } GetOpt.Param.Opt_q(a) && GetOpt.Param.Opt_q(b) ==> (GetOpt.Param#Equal(a, b) <==> Seq#Equal(GetOpt.Param.name(a), GetOpt.Param.name(b)) && Seq#Equal(GetOpt.Param.help(a), GetOpt.Param.help(b)) && Seq#Equal(GetOpt.Param.argName(a), GetOpt.Param.argName(b)) && GetOpt.Param.short(a) == GetOpt.Param.short(b) && GetOpt.Unused#Equal(GetOpt.Param.unused(a), GetOpt.Param.unused(b)) && (GetOpt.Param.inherit(a) <==> GetOpt.Param.inherit(b)) && GetOpt.Visibility#Equal(GetOpt.Param.vis(a), GetOpt.Param.vis(b)) && Seq#Equal(GetOpt.Param.shortAlias(a), GetOpt.Param.shortAlias(b)) && Seq#Equal(GetOpt.Param.longAlias(a), GetOpt.Param.longAlias(b)) && GetOpt.Tri#Equal(GetOpt.Param.positional(a), GetOpt.Param.positional(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Param#Equal(a, b), GetOpt.Param.Flag_q(a) } { GetOpt.Param#Equal(a, b), GetOpt.Param.Flag_q(b) } GetOpt.Param.Flag_q(a) && GetOpt.Param.Flag_q(b) ==> (GetOpt.Param#Equal(a, b) <==> Seq#Equal(GetOpt.Param.name(a), GetOpt.Param.name(b)) && Seq#Equal(GetOpt.Param.help(a), GetOpt.Param.help(b)) && GetOpt.Param.short(a) == GetOpt.Param.short(b) && (GetOpt.Param.solo(a) <==> GetOpt.Param.solo(b)) && (GetOpt.Param.inherit(a) <==> GetOpt.Param.inherit(b)) && GetOpt.Visibility#Equal(GetOpt.Param.vis(a), GetOpt.Param.vis(b)) && Seq#Equal(GetOpt.Param.shortAlias(a), GetOpt.Param.shortAlias(b)) && Seq#Equal(GetOpt.Param.longAlias(a), GetOpt.Param.longAlias(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Param#Equal(a, b), GetOpt.Param.Command_q(a) } { GetOpt.Param#Equal(a, b), GetOpt.Param.Command_q(b) } GetOpt.Param.Command_q(a) && GetOpt.Param.Command_q(b) ==> (GetOpt.Param#Equal(a, b) <==> GetOpt.Options#Equal(GetOpt.Param.options(a), GetOpt.Param.options(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Param#Equal(a, b) } GetOpt.Param#Equal(a, b) <==> a == b);

const unique class.GetOpt.Param: ClassName;

function GetOpt.Param.NeedsArg(this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.NeedsArg(this) } GetOpt.Param.NeedsArg#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.NeedsArg(this) <==> GetOpt.Param.Opt_q(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.NeedsArg(Lit(this)) } GetOpt.Param.NeedsArg#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.NeedsArg(Lit(this)) <==> Lit(GetOpt.Param.Opt_q(Lit(this)))));
}

function GetOpt.Param.NeedsArg#canCall(this: DatatypeType) : bool;

function GetOpt.Param.NeedsArg#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.NeedsArg#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.NeedsArg#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.NeedsArg (well-formedness)"} CheckWellformed$$GetOpt.Param.NeedsArg(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function GetOpt.Param.Inherits(this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.Inherits(this) } GetOpt.Param.Inherits#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.Inherits(this) <==> (GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this)) && GetOpt.Param.inherit(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.Inherits(Lit(this)) } GetOpt.Param.Inherits#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.Inherits(Lit(this)) <==> Lit((GetOpt.Param.Opt_q(Lit(this)) || GetOpt.Param.Flag_q(Lit(this))) && GetOpt.Param.inherit(Lit(this)))));
}

function GetOpt.Param.Inherits#canCall(this: DatatypeType) : bool;

function GetOpt.Param.Inherits#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.Inherits#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.Inherits#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.Inherits (well-formedness)"} CheckWellformed$$GetOpt.Param.Inherits(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.Inherits (well-formedness)"} CheckWellformed$$GetOpt.Param.Inherits(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.Inherits", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(194,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} !GetOpt.Param.Opt_q(this);
    goto anon5;

  anon9_Else:
    assume {:partition} GetOpt.Param.Opt_q(this);
    goto anon5;

  anon5:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    assume GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    goto anon7;

  anon10_Else:
    assume {:partition} !(GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this));
    goto anon7;

  anon7:
    assume GetOpt.Param.Inherits(this) <==> (GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this)) && GetOpt.Param.inherit(this);
    assume true;
    assume $Is(GetOpt.Param.Inherits(this), TBool);
    return;
}



function GetOpt.Param.ShowHelp(this: DatatypeType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.ShowHelp(this) } GetOpt.Param.ShowHelp#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (!GetOpt.Param.Command_q(this) ==> $IsA#GetOpt.Visibility(GetOpt.Param.vis(this))) && (GetOpt.Param.ShowHelp(this) <==> GetOpt.Param.Command_q(this) || GetOpt.Visibility#Equal(GetOpt.Param.vis(this), #GetOpt.Visibility.Normal())));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.ShowHelp(Lit(this)) } GetOpt.Param.ShowHelp#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (!Lit(GetOpt.Param.Command_q(Lit(this))) ==> $IsA#GetOpt.Visibility(Lit(GetOpt.Param.vis(Lit(this))))) && (GetOpt.Param.ShowHelp(Lit(this)) <==> GetOpt.Param.Command_q(Lit(this)) || GetOpt.Visibility#Equal(GetOpt.Param.vis(Lit(this)), #GetOpt.Visibility.Normal())));
}

function GetOpt.Param.ShowHelp#canCall(this: DatatypeType) : bool;

function GetOpt.Param.ShowHelp#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.ShowHelp#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.ShowHelp#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.ShowHelp (well-formedness)"} CheckWellformed$$GetOpt.Param.ShowHelp(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.ShowHelp (well-formedness)"} CheckWellformed$$GetOpt.Param.ShowHelp(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.ShowHelp", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(198,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !GetOpt.Param.Command_q(this);
    assume GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    goto anon5;

  anon7_Else:
    assume {:partition} GetOpt.Param.Command_q(this);
    goto anon5;

  anon5:
    assume GetOpt.Param.ShowHelp(this) <==> GetOpt.Param.Command_q(this) || GetOpt.Visibility#Equal(GetOpt.Param.vis(this), #GetOpt.Visibility.Normal());
    assume !GetOpt.Param.Command_q(this) ==> $IsA#GetOpt.Visibility(GetOpt.Param.vis(this));
    assume $Is(GetOpt.Param.ShowHelp(this), TBool);
    return;
}



function GetOpt.Param.KeepResult(this: DatatypeType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.KeepResult(this) } GetOpt.Param.KeepResult#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (!GetOpt.Param.Command_q(this) ==> $IsA#GetOpt.Visibility(GetOpt.Param.vis(this))) && (GetOpt.Param.KeepResult(this) <==> GetOpt.Param.Command_q(this) || !GetOpt.Visibility#Equal(GetOpt.Param.vis(this), #GetOpt.Visibility.Deprecated())));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.KeepResult(Lit(this)) } GetOpt.Param.KeepResult#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (!Lit(GetOpt.Param.Command_q(Lit(this))) ==> $IsA#GetOpt.Visibility(Lit(GetOpt.Param.vis(Lit(this))))) && (GetOpt.Param.KeepResult(Lit(this)) <==> GetOpt.Param.Command_q(Lit(this)) || !GetOpt.Visibility#Equal(GetOpt.Param.vis(Lit(this)), #GetOpt.Visibility.Deprecated())));
}

function GetOpt.Param.KeepResult#canCall(this: DatatypeType) : bool;

function GetOpt.Param.KeepResult#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.KeepResult#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.KeepResult#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.KeepResult (well-formedness)"} CheckWellformed$$GetOpt.Param.KeepResult(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.KeepResult (well-formedness)"} CheckWellformed$$GetOpt.Param.KeepResult(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.KeepResult", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(202,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !GetOpt.Param.Command_q(this);
    assume GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    goto anon5;

  anon7_Else:
    assume {:partition} GetOpt.Param.Command_q(this);
    goto anon5;

  anon5:
    assume GetOpt.Param.KeepResult(this) <==> GetOpt.Param.Command_q(this) || !GetOpt.Visibility#Equal(GetOpt.Param.vis(this), #GetOpt.Visibility.Deprecated());
    assume !GetOpt.Param.Command_q(this) ==> $IsA#GetOpt.Visibility(GetOpt.Param.vis(this));
    assume $Is(GetOpt.Param.KeepResult(this), TBool);
    return;
}



function GetOpt.Param.Name(this: DatatypeType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.Name(this) } GetOpt.Param.Name#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> $Is(GetOpt.Param.Name(this), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.Name(this) } GetOpt.Param.Name#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.Command_q(this) ==> GetOpt.Options.Options_q(GetOpt.Param.options(this))) && GetOpt.Param.Name(this) == (if GetOpt.Param.Command_q(this) then GetOpt.Options.name(GetOpt.Param.options(this)) else GetOpt.Param.name(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.Name(Lit(this)) } GetOpt.Param.Name#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (Lit(GetOpt.Param.Command_q(Lit(this))) ==> GetOpt.Options.Options_q(Lit(GetOpt.Param.options(Lit(this))))) && GetOpt.Param.Name(Lit(this)) == (if GetOpt.Param.Command_q(Lit(this)) then GetOpt.Options.name(Lit(GetOpt.Param.options(Lit(this)))) else GetOpt.Param.name(Lit(this))));
}

function GetOpt.Param.Name#canCall(this: DatatypeType) : bool;

function GetOpt.Param.Name#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.Name#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.Name#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.Name (well-formedness)"} CheckWellformed$$GetOpt.Param.Name(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.Name (well-formedness)"} CheckWellformed$$GetOpt.Param.Name(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.Name", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(206,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(GetOpt.Param.Name(this), TSeq(TChar));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} GetOpt.Param.Command_q(this);
    assume GetOpt.Param.Command_q(this);
    assume GetOpt.Options.Options_q(GetOpt.Param.options(this));
    assume GetOpt.Param.Name(this) == GetOpt.Options.name(GetOpt.Param.options(this));
    assume GetOpt.Options.Options_q(GetOpt.Param.options(this));
    assume $Is(GetOpt.Param.Name(this), TSeq(TChar));
    return;

  anon7_Else:
    assume {:partition} !GetOpt.Param.Command_q(this);
    assume GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    assume GetOpt.Param.Name(this) == GetOpt.Param.name(this);
    assume true;
    assume $Is(GetOpt.Param.Name(this), TSeq(TChar));
    return;
}



function GetOpt.Param.MakeArg(this: DatatypeType, value#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, value#0: DatatypeType :: { GetOpt.Param.MakeArg(this, value#0) } GetOpt.Param.MakeArg#canCall(this, value#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param()) && $Is(value#0, Tclass.Wrappers.Option(TSeq(TChar)))) ==> $Is(GetOpt.Param.MakeArg(this, value#0), TSeq(Tclass.GetOpt.OneArg())));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, value#0: DatatypeType :: { GetOpt.Param.MakeArg(this, value#0) } GetOpt.Param.MakeArg#canCall(this, value#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param()) && $Is(value#0, Tclass.Wrappers.Option(TSeq(TChar)))) ==> GetOpt.Param.KeepResult#canCall(this) && (GetOpt.Param.KeepResult(this) ==> GetOpt.Param.Name#canCall(this)) && GetOpt.Param.MakeArg(this, value#0) == (if GetOpt.Param.KeepResult(this) then Seq#Build(Seq#Empty(): Seq, $Box(#GetOpt.OneArg.OneArg(GetOpt.Param.Name(this), value#0))) else Seq#Empty(): Seq));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, value#0: DatatypeType :: {:weight 3} { GetOpt.Param.MakeArg(Lit(this), Lit(value#0)) } GetOpt.Param.MakeArg#canCall(Lit(this), Lit(value#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param()) && $Is(value#0, Tclass.Wrappers.Option(TSeq(TChar)))) ==> GetOpt.Param.KeepResult#canCall(Lit(this)) && (Lit(GetOpt.Param.KeepResult(Lit(this))) ==> GetOpt.Param.Name#canCall(Lit(this))) && GetOpt.Param.MakeArg(Lit(this), Lit(value#0)) == (if GetOpt.Param.KeepResult(Lit(this)) then Seq#Build(Seq#Empty(): Seq, $Box(Lit(#GetOpt.OneArg.OneArg(Lit(GetOpt.Param.Name(Lit(this))), Lit(value#0))))) else Seq#Empty(): Seq));
}

function GetOpt.Param.MakeArg#canCall(this: DatatypeType, value#0: DatatypeType) : bool;

function GetOpt.Param.MakeArg#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, value#0: DatatypeType :: { GetOpt.Param.MakeArg#requires(this, value#0) } $Is(this, Tclass.GetOpt.Param()) && $Is(value#0, Tclass.Wrappers.Option(TSeq(TChar))) ==> (GetOpt.Param.MakeArg#requires(this, value#0) <==> true));

procedure {:verboseName "GetOpt.Param.MakeArg (well-formedness)"} CheckWellformed$$GetOpt.Param.MakeArg(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap), value#0: DatatypeType where $Is(value#0, Tclass.Wrappers.Option(TSeq(TChar))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function GetOpt.Param.ShortAlias(this: DatatypeType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.ShortAlias(this) } GetOpt.Param.ShortAlias#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> $Is(GetOpt.Param.ShortAlias(this), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.ShortAlias(this) } GetOpt.Param.ShortAlias#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> GetOpt.Param.ShortAlias(this) == (if GetOpt.Param.Command_q(this) then Seq#Empty(): Seq else GetOpt.Param.shortAlias(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.ShortAlias(Lit(this)) } GetOpt.Param.ShortAlias#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> GetOpt.Param.ShortAlias(Lit(this)) == (if GetOpt.Param.Command_q(Lit(this)) then Seq#Empty(): Seq else GetOpt.Param.shortAlias(Lit(this))));
}

function GetOpt.Param.ShortAlias#canCall(this: DatatypeType) : bool;

function GetOpt.Param.ShortAlias#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.ShortAlias#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.ShortAlias#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.ShortAlias (well-formedness)"} CheckWellformed$$GetOpt.Param.ShortAlias(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.ShortAlias (well-formedness)"} CheckWellformed$$GetOpt.Param.ShortAlias(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.ShortAlias", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(220,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(GetOpt.Param.ShortAlias(this), TSeq(TChar));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} GetOpt.Param.Command_q(this);
    assume GetOpt.Param.ShortAlias(this) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.Param.ShortAlias(this), TSeq(TChar));
    return;

  anon7_Else:
    assume {:partition} !GetOpt.Param.Command_q(this);
    assume GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    assume GetOpt.Param.ShortAlias(this) == GetOpt.Param.shortAlias(this);
    assume true;
    assume $Is(GetOpt.Param.ShortAlias(this), TSeq(TChar));
    return;
}



function GetOpt.Param.LongAlias(this: DatatypeType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.LongAlias(this) } GetOpt.Param.LongAlias#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> $Is(GetOpt.Param.LongAlias(this), TSeq(TSeq(TChar))));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.LongAlias(this) } GetOpt.Param.LongAlias#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> GetOpt.Param.LongAlias(this) == (if GetOpt.Param.Command_q(this) then Seq#Empty(): Seq else GetOpt.Param.longAlias(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.LongAlias(Lit(this)) } GetOpt.Param.LongAlias#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> GetOpt.Param.LongAlias(Lit(this)) == (if GetOpt.Param.Command_q(Lit(this)) then Seq#Empty(): Seq else GetOpt.Param.longAlias(Lit(this))));
}

function GetOpt.Param.LongAlias#canCall(this: DatatypeType) : bool;

function GetOpt.Param.LongAlias#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.LongAlias#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.LongAlias#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.LongAlias (well-formedness)"} CheckWellformed$$GetOpt.Param.LongAlias(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.LongAlias (well-formedness)"} CheckWellformed$$GetOpt.Param.LongAlias(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.LongAlias", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(227,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(GetOpt.Param.LongAlias(this), TSeq(TSeq(TChar)));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} GetOpt.Param.Command_q(this);
    assume GetOpt.Param.LongAlias(this) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(GetOpt.Param.LongAlias(this), TSeq(TSeq(TChar)));
    return;

  anon7_Else:
    assume {:partition} !GetOpt.Param.Command_q(this);
    assume GetOpt.Param.Opt_q(this) || GetOpt.Param.Flag_q(this);
    assume GetOpt.Param.LongAlias(this) == GetOpt.Param.longAlias(this);
    assume true;
    assume $Is(GetOpt.Param.LongAlias(this), TSeq(TSeq(TChar)));
    return;
}



function GetOpt.Param.Required(this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.Required(this) } GetOpt.Param.Required#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.Required(this) <==> GetOpt.Param.Opt_q(this) && GetOpt.Unused.Required_q(GetOpt.Param.unused(this))));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.Required(Lit(this)) } GetOpt.Param.Required#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.Required(Lit(this)) <==> Lit(GetOpt.Param.Opt_q(Lit(this)) && GetOpt.Unused.Required_q(Lit(GetOpt.Param.unused(Lit(this)))))));
}

function GetOpt.Param.Required#canCall(this: DatatypeType) : bool;

function GetOpt.Param.Required#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.Required#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.Required#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.Required (well-formedness)"} CheckWellformed$$GetOpt.Param.Required(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.Required (well-formedness)"} CheckWellformed$$GetOpt.Param.Required(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.Required", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(234,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} GetOpt.Param.Opt_q(this);
    assume GetOpt.Param.Opt_q(this);
    goto anon5;

  anon7_Else:
    assume {:partition} !GetOpt.Param.Opt_q(this);
    goto anon5;

  anon5:
    assume GetOpt.Param.Required(this) <==> GetOpt.Param.Opt_q(this) && GetOpt.Unused.Required_q(GetOpt.Param.unused(this));
    assume true;
    assume $Is(GetOpt.Param.Required(this), TBool);
    return;
}



function GetOpt.Param.HasDefault(this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { GetOpt.Param.HasDefault(this) } GetOpt.Param.HasDefault#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.HasDefault(this) <==> GetOpt.Param.Opt_q(this) && GetOpt.Unused.Default_q(GetOpt.Param.unused(this))));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { GetOpt.Param.HasDefault(Lit(this)) } GetOpt.Param.HasDefault#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.GetOpt.Param())) ==> (GetOpt.Param.HasDefault(Lit(this)) <==> Lit(GetOpt.Param.Opt_q(Lit(this)) && GetOpt.Unused.Default_q(Lit(GetOpt.Param.unused(Lit(this)))))));
}

function GetOpt.Param.HasDefault#canCall(this: DatatypeType) : bool;

function GetOpt.Param.HasDefault#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { GetOpt.Param.HasDefault#requires(this) } $Is(this, Tclass.GetOpt.Param()) ==> (GetOpt.Param.HasDefault#requires(this) <==> true));

procedure {:verboseName "GetOpt.Param.HasDefault (well-formedness)"} CheckWellformed$$GetOpt.Param.HasDefault(this: DatatypeType where $Is(this, Tclass.GetOpt.Param()) && $IsAlloc(this, Tclass.GetOpt.Param(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.Param.HasDefault (well-formedness)"} CheckWellformed$$GetOpt.Param.HasDefault(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.Param.HasDefault", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(238,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} GetOpt.Param.Opt_q(this);
    assume GetOpt.Param.Opt_q(this);
    goto anon5;

  anon7_Else:
    assume {:partition} !GetOpt.Param.Opt_q(this);
    goto anon5;

  anon5:
    assume GetOpt.Param.HasDefault(this) <==> GetOpt.Param.Opt_q(this) && GetOpt.Unused.Default_q(GetOpt.Param.unused(this));
    assume true;
    assume $Is(GetOpt.Param.HasDefault(this), TBool);
    return;
}



function #GetOpt.OneArg.OneArg(Seq, DatatypeType) : DatatypeType;

const unique ##GetOpt.OneArg.OneArg: DtCtorId
uses {
axiom (forall a#0#0#0: Seq, a#0#1#0: DatatypeType :: { #GetOpt.OneArg.OneArg(a#0#0#0, a#0#1#0) } DatatypeCtorId(#GetOpt.OneArg.OneArg(a#0#0#0, a#0#1#0)) == ##GetOpt.OneArg.OneArg);
}

function GetOpt.OneArg.OneArg_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.OneArg.OneArg_q(d) } GetOpt.OneArg.OneArg_q(d) <==> DatatypeCtorId(d) == ##GetOpt.OneArg.OneArg);

axiom (forall d: DatatypeType :: { GetOpt.OneArg.OneArg_q(d) } GetOpt.OneArg.OneArg_q(d) ==> (exists a#1#0#0: Seq, a#1#1#0: DatatypeType :: d == #GetOpt.OneArg.OneArg(a#1#0#0, a#1#1#0)));

axiom (forall a#2#0#0: Seq, a#2#1#0: DatatypeType :: { $Is(#GetOpt.OneArg.OneArg(a#2#0#0, a#2#1#0), Tclass.GetOpt.OneArg()) } $Is(#GetOpt.OneArg.OneArg(a#2#0#0, a#2#1#0), Tclass.GetOpt.OneArg()) <==> $Is(a#2#0#0, TSeq(TChar)) && $Is(a#2#1#0, Tclass.Wrappers.Option(TSeq(TChar))));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.OneArg.name(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.OneArg.OneArg_q(d) && $IsAlloc(d, Tclass.GetOpt.OneArg(), $h) ==> $IsAlloc(GetOpt.OneArg.name(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.OneArg.value(d), Tclass.Wrappers.Option(TSeq(TChar)), $h) } $IsGoodHeap($h) && GetOpt.OneArg.OneArg_q(d) && $IsAlloc(d, Tclass.GetOpt.OneArg(), $h) ==> $IsAlloc(GetOpt.OneArg.value(d), Tclass.Wrappers.Option(TSeq(TChar)), $h));

axiom (forall a#3#0#0: Seq, a#3#1#0: DatatypeType :: { #GetOpt.OneArg.OneArg(Lit(a#3#0#0), Lit(a#3#1#0)) } #GetOpt.OneArg.OneArg(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#GetOpt.OneArg.OneArg(a#3#0#0, a#3#1#0)));

function GetOpt.OneArg.name(DatatypeType) : Seq;

axiom (forall a#4#0#0: Seq, a#4#1#0: DatatypeType :: { #GetOpt.OneArg.OneArg(a#4#0#0, a#4#1#0) } GetOpt.OneArg.name(#GetOpt.OneArg.OneArg(a#4#0#0, a#4#1#0)) == a#4#0#0);

axiom (forall a#5#0#0: Seq, a#5#1#0: DatatypeType, i: int :: { Seq#Index(a#5#0#0, i), #GetOpt.OneArg.OneArg(a#5#0#0, a#5#1#0) } 0 <= i && i < Seq#Length(a#5#0#0) ==> DtRank($Unbox(Seq#Index(a#5#0#0, i)): DatatypeType) < DtRank(#GetOpt.OneArg.OneArg(a#5#0#0, a#5#1#0)));

axiom (forall a#6#0#0: Seq, a#6#1#0: DatatypeType :: { #GetOpt.OneArg.OneArg(a#6#0#0, a#6#1#0) } Seq#Rank(a#6#0#0) < DtRank(#GetOpt.OneArg.OneArg(a#6#0#0, a#6#1#0)));

function GetOpt.OneArg.value(DatatypeType) : DatatypeType;

axiom (forall a#7#0#0: Seq, a#7#1#0: DatatypeType :: { #GetOpt.OneArg.OneArg(a#7#0#0, a#7#1#0) } GetOpt.OneArg.value(#GetOpt.OneArg.OneArg(a#7#0#0, a#7#1#0)) == a#7#1#0);

axiom (forall a#8#0#0: Seq, a#8#1#0: DatatypeType :: { #GetOpt.OneArg.OneArg(a#8#0#0, a#8#1#0) } DtRank(a#8#1#0) < DtRank(#GetOpt.OneArg.OneArg(a#8#0#0, a#8#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.OneArg(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.OneArg()) ==> $IsAlloc(d, Tclass.GetOpt.OneArg(), $h));

function $IsA#GetOpt.OneArg(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.OneArg(d) } $IsA#GetOpt.OneArg(d) ==> GetOpt.OneArg.OneArg_q(d));

axiom (forall d: DatatypeType :: { GetOpt.OneArg.OneArg_q(d), $Is(d, Tclass.GetOpt.OneArg()) } $Is(d, Tclass.GetOpt.OneArg()) ==> GetOpt.OneArg.OneArg_q(d));

function GetOpt.OneArg#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.OneArg#Equal(a, b) } GetOpt.OneArg#Equal(a, b) <==> Seq#Equal(GetOpt.OneArg.name(a), GetOpt.OneArg.name(b)) && Wrappers.Option#Equal(GetOpt.OneArg.value(a), GetOpt.OneArg.value(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.OneArg#Equal(a, b) } GetOpt.OneArg#Equal(a, b) <==> a == b);

const unique class.GetOpt.OneArg: ClassName;

function #GetOpt.Parsed.Parsed(Seq, Seq, Seq, DatatypeType) : DatatypeType;

const unique ##GetOpt.Parsed.Parsed: DtCtorId
uses {
axiom (forall a#9#0#0: Seq, a#9#1#0: Seq, a#9#2#0: Seq, a#9#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0) } DatatypeCtorId(#GetOpt.Parsed.Parsed(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0)) == ##GetOpt.Parsed.Parsed);
}

function GetOpt.Parsed.Parsed_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Parsed.Parsed_q(d) } GetOpt.Parsed.Parsed_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Parsed.Parsed);

axiom (forall d: DatatypeType :: { GetOpt.Parsed.Parsed_q(d) } GetOpt.Parsed.Parsed_q(d) ==> (exists a#10#0#0: Seq, a#10#1#0: Seq, a#10#2#0: Seq, a#10#3#0: DatatypeType :: d == #GetOpt.Parsed.Parsed(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0)));

axiom (forall a#11#0#0: Seq, a#11#1#0: Seq, a#11#2#0: Seq, a#11#3#0: DatatypeType :: { $Is(#GetOpt.Parsed.Parsed(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0), Tclass.GetOpt.Parsed()) } $Is(#GetOpt.Parsed.Parsed(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0), Tclass.GetOpt.Parsed()) <==> $Is(a#11#0#0, TSeq(TChar)) && $Is(a#11#1#0, TSeq(Tclass.GetOpt.OneArg())) && $Is(a#11#2#0, TSeq(TSeq(TChar))) && $Is(a#11#3#0, Tclass.Wrappers.Option(Tclass.GetOpt.Parsed())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Parsed.command(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Parsed.Parsed_q(d) && $IsAlloc(d, Tclass.GetOpt.Parsed(), $h) ==> $IsAlloc(GetOpt.Parsed.command(d), TSeq(TChar), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Parsed.params(d), TSeq(Tclass.GetOpt.OneArg()), $h) } $IsGoodHeap($h) && GetOpt.Parsed.Parsed_q(d) && $IsAlloc(d, Tclass.GetOpt.Parsed(), $h) ==> $IsAlloc(GetOpt.Parsed.params(d), TSeq(Tclass.GetOpt.OneArg()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Parsed.files(d), TSeq(TSeq(TChar)), $h) } $IsGoodHeap($h) && GetOpt.Parsed.Parsed_q(d) && $IsAlloc(d, Tclass.GetOpt.Parsed(), $h) ==> $IsAlloc(GetOpt.Parsed.files(d), TSeq(TSeq(TChar)), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Parsed.subcommand(d), Tclass.Wrappers.Option(Tclass.GetOpt.Parsed()), $h) } $IsGoodHeap($h) && GetOpt.Parsed.Parsed_q(d) && $IsAlloc(d, Tclass.GetOpt.Parsed(), $h) ==> $IsAlloc(GetOpt.Parsed.subcommand(d), Tclass.Wrappers.Option(Tclass.GetOpt.Parsed()), $h));

axiom (forall a#12#0#0: Seq, a#12#1#0: Seq, a#12#2#0: Seq, a#12#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(Lit(a#12#0#0), Lit(a#12#1#0), Lit(a#12#2#0), Lit(a#12#3#0)) } #GetOpt.Parsed.Parsed(Lit(a#12#0#0), Lit(a#12#1#0), Lit(a#12#2#0), Lit(a#12#3#0)) == Lit(#GetOpt.Parsed.Parsed(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0)));

function GetOpt.Parsed.command(DatatypeType) : Seq;

axiom (forall a#13#0#0: Seq, a#13#1#0: Seq, a#13#2#0: Seq, a#13#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0) } GetOpt.Parsed.command(#GetOpt.Parsed.Parsed(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0)) == a#13#0#0);

axiom (forall a#14#0#0: Seq, a#14#1#0: Seq, a#14#2#0: Seq, a#14#3#0: DatatypeType, i: int :: { Seq#Index(a#14#0#0, i), #GetOpt.Parsed.Parsed(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0) } 0 <= i && i < Seq#Length(a#14#0#0) ==> DtRank($Unbox(Seq#Index(a#14#0#0, i)): DatatypeType) < DtRank(#GetOpt.Parsed.Parsed(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0)));

axiom (forall a#15#0#0: Seq, a#15#1#0: Seq, a#15#2#0: Seq, a#15#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0) } Seq#Rank(a#15#0#0) < DtRank(#GetOpt.Parsed.Parsed(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0)));

function GetOpt.Parsed.params(DatatypeType) : Seq;

axiom (forall a#16#0#0: Seq, a#16#1#0: Seq, a#16#2#0: Seq, a#16#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0) } GetOpt.Parsed.params(#GetOpt.Parsed.Parsed(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0)) == a#16#1#0);

axiom (forall a#17#0#0: Seq, a#17#1#0: Seq, a#17#2#0: Seq, a#17#3#0: DatatypeType, i: int :: { Seq#Index(a#17#1#0, i), #GetOpt.Parsed.Parsed(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0) } 0 <= i && i < Seq#Length(a#17#1#0) ==> DtRank($Unbox(Seq#Index(a#17#1#0, i)): DatatypeType) < DtRank(#GetOpt.Parsed.Parsed(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0)));

axiom (forall a#18#0#0: Seq, a#18#1#0: Seq, a#18#2#0: Seq, a#18#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0) } Seq#Rank(a#18#1#0) < DtRank(#GetOpt.Parsed.Parsed(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0)));

function GetOpt.Parsed.files(DatatypeType) : Seq;

axiom (forall a#19#0#0: Seq, a#19#1#0: Seq, a#19#2#0: Seq, a#19#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0) } GetOpt.Parsed.files(#GetOpt.Parsed.Parsed(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0)) == a#19#2#0);

axiom (forall a#20#0#0: Seq, a#20#1#0: Seq, a#20#2#0: Seq, a#20#3#0: DatatypeType, i: int :: { Seq#Index(a#20#2#0, i), #GetOpt.Parsed.Parsed(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0) } 0 <= i && i < Seq#Length(a#20#2#0) ==> DtRank($Unbox(Seq#Index(a#20#2#0, i)): DatatypeType) < DtRank(#GetOpt.Parsed.Parsed(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0)));

axiom (forall a#21#0#0: Seq, a#21#1#0: Seq, a#21#2#0: Seq, a#21#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0) } Seq#Rank(a#21#2#0) < DtRank(#GetOpt.Parsed.Parsed(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0)));

function GetOpt.Parsed.subcommand(DatatypeType) : DatatypeType;

axiom (forall a#22#0#0: Seq, a#22#1#0: Seq, a#22#2#0: Seq, a#22#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0) } GetOpt.Parsed.subcommand(#GetOpt.Parsed.Parsed(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0)) == a#22#3#0);

axiom (forall a#23#0#0: Seq, a#23#1#0: Seq, a#23#2#0: Seq, a#23#3#0: DatatypeType :: { #GetOpt.Parsed.Parsed(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0) } DtRank(a#23#3#0) < DtRank(#GetOpt.Parsed.Parsed(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Parsed(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Parsed()) ==> $IsAlloc(d, Tclass.GetOpt.Parsed(), $h));

function $IsA#GetOpt.Parsed(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Parsed(d) } $IsA#GetOpt.Parsed(d) ==> GetOpt.Parsed.Parsed_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Parsed.Parsed_q(d), $Is(d, Tclass.GetOpt.Parsed()) } $Is(d, Tclass.GetOpt.Parsed()) ==> GetOpt.Parsed.Parsed_q(d));

function GetOpt.Parsed#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Parsed#Equal(a, b) } GetOpt.Parsed#Equal(a, b) <==> Seq#Equal(GetOpt.Parsed.command(a), GetOpt.Parsed.command(b)) && Seq#Equal(GetOpt.Parsed.params(a), GetOpt.Parsed.params(b)) && Seq#Equal(GetOpt.Parsed.files(a), GetOpt.Parsed.files(b)) && Wrappers.Option#Equal(GetOpt.Parsed.subcommand(a), GetOpt.Parsed.subcommand(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Parsed#Equal(a, b) } GetOpt.Parsed#Equal(a, b) <==> a == b);

const unique class.GetOpt.Parsed: ClassName;

procedure {:verboseName "GetOpt.CommandMap (well-formedness)"} CheckWellFormed$$GetOpt.CommandMap(x#0: Map where $Is(x#0, TMap(TSeq(TChar), Tclass.GetOpt.Options())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "GetOpt.CommandMap (well-formedness)"} CheckWellFormed$$GetOpt.CommandMap(x#0: Map)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "GetOpt.CommandMap", " | ", x#0} true;
    assume {:print "Types", " | ", "Map"} true;
    assume {:captureState "StandardLibrary/src/GetOpt.dfy(394,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    havoc k#0;
    assume $Is(k#0, TSeq(TChar)) && $IsAlloc(k#0, TSeq(TChar), $Heap);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Map#Domain(x#0)[$Box(k#0)];
    assume Map#Domain(x#0)[$Box(k#0)];
    assume GetOpt.Options.Options_q($Unbox(Map#Elements(x#0)[$Box(k#0)]): DatatypeType);
    assume Seq#Equal(GetOpt.Options.name($Unbox(Map#Elements(x#0)[$Box(k#0)]): DatatypeType), k#0);
    goto anon5;

  anon8_Else:
    assume Map#Domain(x#0)[$Box(k#0)] ==> Seq#Equal(GetOpt.Options.name($Unbox(Map#Elements(x#0)[$Box(k#0)]): DatatypeType), k#0);
    goto anon5;

  anon5:
    assume (forall k#1: Seq :: $Is(k#1, TSeq(TChar)) && Map#Domain(x#0)[$Box(k#1)] ==> Seq#Equal(GetOpt.Options.name($Unbox(Map#Elements(x#0)[$Box(k#1)]): DatatypeType), k#1));
    return;

  anon7_Else:
    assume (forall k#2: Seq :: $Is(k#2, TSeq(TChar)) ==> Map#Domain(Map#Empty(): Map)[$Box(k#2)] ==> GetOpt.Options.Options_q($Unbox(Map#Elements(Lit(Map#Empty(): Map))[$Box(k#2)]): DatatypeType));
    assume (forall k#2: Seq :: $Is(k#2, TSeq(TChar)) && Map#Domain(Map#Empty(): Map)[$Box(k#2)] ==> Seq#Equal(GetOpt.Options.name($Unbox(Map#Elements(Lit(Map#Empty(): Map))[$Box(k#2)]): DatatypeType), k#2));
    return;
}



axiom (forall x#0: Map :: { $Is(x#0, Tclass.GetOpt.CommandMap()) } $Is(x#0, Tclass.GetOpt.CommandMap()) <==> $Is(x#0, TMap(TSeq(TChar), Tclass.GetOpt.Options())) && (forall k#1: Seq :: $Is(k#1, TSeq(TChar)) && Map#Domain(x#0)[$Box(k#1)] ==> Seq#Equal(GetOpt.Options.name($Unbox(Map#Elements(x#0)[$Box(k#1)]): DatatypeType), k#1)));

axiom (forall x#0: Map, $h: Heap :: { $IsAlloc(x#0, Tclass.GetOpt.CommandMap(), $h) } $IsAlloc(x#0, Tclass.GetOpt.CommandMap(), $h) <==> $IsAlloc(x#0, TMap(TSeq(TChar), Tclass.GetOpt.Options()), $h));

function #GetOpt.Context.Context(Map, Map, Seq, Map, Seq) : DatatypeType;

const unique ##GetOpt.Context.Context: DtCtorId
uses {
axiom (forall a#0#0#0: Map, a#0#1#0: Map, a#0#2#0: Seq, a#0#3#0: Map, a#0#4#0: Seq :: { #GetOpt.Context.Context(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0) } DatatypeCtorId(#GetOpt.Context.Context(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0, a#0#4#0)) == ##GetOpt.Context.Context);
}

function GetOpt.Context.Context_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { GetOpt.Context.Context_q(d) } GetOpt.Context.Context_q(d) <==> DatatypeCtorId(d) == ##GetOpt.Context.Context);

axiom (forall d: DatatypeType :: { GetOpt.Context.Context_q(d) } GetOpt.Context.Context_q(d) ==> (exists a#1#0#0: Map, a#1#1#0: Map, a#1#2#0: Seq, a#1#3#0: Map, a#1#4#0: Seq :: d == #GetOpt.Context.Context(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0, a#1#4#0)));

axiom (forall a#2#0#0: Map, a#2#1#0: Map, a#2#2#0: Seq, a#2#3#0: Map, a#2#4#0: Seq :: { $Is(#GetOpt.Context.Context(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0), Tclass.GetOpt.Context()) } $Is(#GetOpt.Context.Context(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0, a#2#4#0), Tclass.GetOpt.Context()) <==> $Is(a#2#0#0, TMap(TSeq(TChar), Tclass.GetOpt.Param())) && $Is(a#2#1#0, TMap(TChar, TSeq(TChar))) && $Is(a#2#2#0, TSeq(Tclass.GetOpt.Param())) && $Is(a#2#3#0, Tclass.GetOpt.CommandMap()) && $Is(a#2#4#0, TSeq(TChar)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Context.longMap(d), TMap(TSeq(TChar), Tclass.GetOpt.Param()), $h) } $IsGoodHeap($h) && GetOpt.Context.Context_q(d) && $IsAlloc(d, Tclass.GetOpt.Context(), $h) ==> $IsAlloc(GetOpt.Context.longMap(d), TMap(TSeq(TChar), Tclass.GetOpt.Param()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Context.shortMap(d), TMap(TChar, TSeq(TChar)), $h) } $IsGoodHeap($h) && GetOpt.Context.Context_q(d) && $IsAlloc(d, Tclass.GetOpt.Context(), $h) ==> $IsAlloc(GetOpt.Context.shortMap(d), TMap(TChar, TSeq(TChar)), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Context.inherits(d), TSeq(Tclass.GetOpt.Param()), $h) } $IsGoodHeap($h) && GetOpt.Context.Context_q(d) && $IsAlloc(d, Tclass.GetOpt.Context(), $h) ==> $IsAlloc(GetOpt.Context.inherits(d), TSeq(Tclass.GetOpt.Param()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Context.commands(d), Tclass.GetOpt.CommandMap(), $h) } $IsGoodHeap($h) && GetOpt.Context.Context_q(d) && $IsAlloc(d, Tclass.GetOpt.Context(), $h) ==> $IsAlloc(GetOpt.Context.commands(d), Tclass.GetOpt.CommandMap(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(GetOpt.Context.command(d), TSeq(TChar), $h) } $IsGoodHeap($h) && GetOpt.Context.Context_q(d) && $IsAlloc(d, Tclass.GetOpt.Context(), $h) ==> $IsAlloc(GetOpt.Context.command(d), TSeq(TChar), $h));

axiom (forall a#3#0#0: Map, a#3#1#0: Map, a#3#2#0: Seq, a#3#3#0: Map, a#3#4#0: Seq :: { #GetOpt.Context.Context(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0), Lit(a#3#3#0), Lit(a#3#4#0)) } #GetOpt.Context.Context(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0), Lit(a#3#3#0), Lit(a#3#4#0)) == Lit(#GetOpt.Context.Context(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0, a#3#4#0)));

function GetOpt.Context.longMap(DatatypeType) : Map;

axiom (forall a#4#0#0: Map, a#4#1#0: Map, a#4#2#0: Seq, a#4#3#0: Map, a#4#4#0: Seq :: { #GetOpt.Context.Context(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0) } GetOpt.Context.longMap(#GetOpt.Context.Context(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0, a#4#4#0)) == a#4#0#0);

axiom (forall a#5#0#0: Map, a#5#1#0: Map, a#5#2#0: Seq, a#5#3#0: Map, a#5#4#0: Seq, d: DatatypeType :: { Map#Domain(a#5#0#0)[$Box(d)], #GetOpt.Context.Context(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0) } Map#Domain(a#5#0#0)[$Box(d)] ==> DtRank(d) < DtRank(#GetOpt.Context.Context(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0, a#5#4#0)));

axiom (forall a#6#0#0: Map, a#6#1#0: Map, a#6#2#0: Seq, a#6#3#0: Map, a#6#4#0: Seq, bx: Box :: { Map#Domain(a#6#0#0)[bx], #GetOpt.Context.Context(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0) } Map#Domain(a#6#0#0)[bx] ==> DtRank($Unbox(Map#Elements(a#6#0#0)[bx]): DatatypeType) < DtRank(#GetOpt.Context.Context(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0, a#6#4#0)));

function GetOpt.Context.shortMap(DatatypeType) : Map;

axiom (forall a#7#0#0: Map, a#7#1#0: Map, a#7#2#0: Seq, a#7#3#0: Map, a#7#4#0: Seq :: { #GetOpt.Context.Context(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0) } GetOpt.Context.shortMap(#GetOpt.Context.Context(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0, a#7#4#0)) == a#7#1#0);

axiom (forall a#8#0#0: Map, a#8#1#0: Map, a#8#2#0: Seq, a#8#3#0: Map, a#8#4#0: Seq, d: DatatypeType :: { Map#Domain(a#8#1#0)[$Box(d)], #GetOpt.Context.Context(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0) } Map#Domain(a#8#1#0)[$Box(d)] ==> DtRank(d) < DtRank(#GetOpt.Context.Context(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0, a#8#4#0)));

axiom (forall a#9#0#0: Map, a#9#1#0: Map, a#9#2#0: Seq, a#9#3#0: Map, a#9#4#0: Seq, bx: Box :: { Map#Domain(a#9#1#0)[bx], #GetOpt.Context.Context(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0) } Map#Domain(a#9#1#0)[bx] ==> DtRank($Unbox(Map#Elements(a#9#1#0)[bx]): DatatypeType) < DtRank(#GetOpt.Context.Context(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0, a#9#4#0)));

function GetOpt.Context.inherits(DatatypeType) : Seq;

axiom (forall a#10#0#0: Map, a#10#1#0: Map, a#10#2#0: Seq, a#10#3#0: Map, a#10#4#0: Seq :: { #GetOpt.Context.Context(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0) } GetOpt.Context.inherits(#GetOpt.Context.Context(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0)) == a#10#2#0);

axiom (forall a#11#0#0: Map, a#11#1#0: Map, a#11#2#0: Seq, a#11#3#0: Map, a#11#4#0: Seq, i: int :: { Seq#Index(a#11#2#0, i), #GetOpt.Context.Context(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0) } 0 <= i && i < Seq#Length(a#11#2#0) ==> DtRank($Unbox(Seq#Index(a#11#2#0, i)): DatatypeType) < DtRank(#GetOpt.Context.Context(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0)));

axiom (forall a#12#0#0: Map, a#12#1#0: Map, a#12#2#0: Seq, a#12#3#0: Map, a#12#4#0: Seq :: { #GetOpt.Context.Context(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0) } Seq#Rank(a#12#2#0) < DtRank(#GetOpt.Context.Context(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0)));

function GetOpt.Context.commands(DatatypeType) : Map;

axiom (forall a#13#0#0: Map, a#13#1#0: Map, a#13#2#0: Seq, a#13#3#0: Map, a#13#4#0: Seq :: { #GetOpt.Context.Context(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0) } GetOpt.Context.commands(#GetOpt.Context.Context(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0)) == a#13#3#0);

axiom (forall a#14#0#0: Map, a#14#1#0: Map, a#14#2#0: Seq, a#14#3#0: Map, a#14#4#0: Seq, d: DatatypeType :: { Map#Domain(a#14#3#0)[$Box(d)], #GetOpt.Context.Context(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0) } Map#Domain(a#14#3#0)[$Box(d)] ==> DtRank(d) < DtRank(#GetOpt.Context.Context(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0)));

axiom (forall a#15#0#0: Map, a#15#1#0: Map, a#15#2#0: Seq, a#15#3#0: Map, a#15#4#0: Seq, bx: Box :: { Map#Domain(a#15#3#0)[bx], #GetOpt.Context.Context(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0) } Map#Domain(a#15#3#0)[bx] ==> DtRank($Unbox(Map#Elements(a#15#3#0)[bx]): DatatypeType) < DtRank(#GetOpt.Context.Context(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0)));

function GetOpt.Context.command(DatatypeType) : Seq;

axiom (forall a#16#0#0: Map, a#16#1#0: Map, a#16#2#0: Seq, a#16#3#0: Map, a#16#4#0: Seq :: { #GetOpt.Context.Context(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0) } GetOpt.Context.command(#GetOpt.Context.Context(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0)) == a#16#4#0);

axiom (forall a#17#0#0: Map, a#17#1#0: Map, a#17#2#0: Seq, a#17#3#0: Map, a#17#4#0: Seq, i: int :: { Seq#Index(a#17#4#0, i), #GetOpt.Context.Context(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0) } 0 <= i && i < Seq#Length(a#17#4#0) ==> DtRank($Unbox(Seq#Index(a#17#4#0, i)): DatatypeType) < DtRank(#GetOpt.Context.Context(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0)));

axiom (forall a#18#0#0: Map, a#18#1#0: Map, a#18#2#0: Seq, a#18#3#0: Map, a#18#4#0: Seq :: { #GetOpt.Context.Context(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0) } Seq#Rank(a#18#4#0) < DtRank(#GetOpt.Context.Context(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.GetOpt.Context(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.GetOpt.Context()) ==> $IsAlloc(d, Tclass.GetOpt.Context(), $h));

function $IsA#GetOpt.Context(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#GetOpt.Context(d) } $IsA#GetOpt.Context(d) ==> GetOpt.Context.Context_q(d));

axiom (forall d: DatatypeType :: { GetOpt.Context.Context_q(d), $Is(d, Tclass.GetOpt.Context()) } $Is(d, Tclass.GetOpt.Context()) ==> GetOpt.Context.Context_q(d));

function GetOpt.Context#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Context#Equal(a, b) } GetOpt.Context#Equal(a, b) <==> Map#Equal(GetOpt.Context.longMap(a), GetOpt.Context.longMap(b)) && Map#Equal(GetOpt.Context.shortMap(a), GetOpt.Context.shortMap(b)) && Seq#Equal(GetOpt.Context.inherits(a), GetOpt.Context.inherits(b)) && Map#Equal(GetOpt.Context.commands(a), GetOpt.Context.commands(b)) && Seq#Equal(GetOpt.Context.command(a), GetOpt.Context.command(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { GetOpt.Context#Equal(a, b) } GetOpt.Context#Equal(a, b) <==> a == b);

const unique class.GetOpt.Context: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#108 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#108))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#110 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#110)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#162 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#162))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#164 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#164)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#166 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#166)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#162 := Wrappers.Option.value(this); v#162)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#164 := Lit(Wrappers.Option.value(Lit(this))); v#164)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#166 := Lit(Wrappers.Option.value(Lit(this))); v#166)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#108 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#108)) else (var e#108 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#110 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#110))) else (var e#110 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#162 := Wrappers.Result.value(this); s#162) else (var e#162 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#164 := Lit(Wrappers.Result.value(Lit(this))); s#164) else (var e#164 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#166 := Lit(Wrappers.Result.value(Lit(this))); s#166) else (var e#166 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#162 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#162)) else (var e#162 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#162)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#164 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#164))) else (var e#164 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#164)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#166 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#166))) else (var e#166 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#166)))));

const unique tytagFamily$Param: TyTagFamily;

const unique tytagFamily$Options: TyTagFamily;

const unique tytagFamily$Parsed: TyTagFamily;

const unique tytagFamily$OneArg: TyTagFamily;

const unique tytagFamily$CommandMap: TyTagFamily;

const unique tytagFamily$Context: TyTagFamily;

const unique tytagFamily$Tri: TyTagFamily;

const unique tytagFamily$Visibility: TyTagFamily;

const unique tytagFamily$Unused: TyTagFamily;

const unique class.FloatCompare.__default: ClassName;

function FloatCompare.__default.Less() : int
uses {
axiom FloatCompare.__default.Less(): int == LitInt(-1);
axiom 1 < $FunctionContextHeight ==> $Is(FloatCompare.__default.Less(), Tclass.FloatCompare.CompareType());
}

procedure {:verboseName "FloatCompare.Less (well-formedness)"} CheckWellFormed$$FloatCompare.__default.Less();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.Less (well-formedness)"} CheckWellFormed$$FloatCompare.__default.Less()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.Less"} true;
    assume {:print "Types"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(26,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    assume true;
    return;
}



function Tclass.FloatCompare.CompareType() : Ty
uses {
axiom Tag(Tclass.FloatCompare.CompareType()) == Tagclass.FloatCompare.CompareType && TagFamily(Tclass.FloatCompare.CompareType()) == tytagFamily$CompareType;
}

const unique Tagclass.FloatCompare.CompareType: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.FloatCompare.CompareType()) } $IsBox(bx, Tclass.FloatCompare.CompareType()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.FloatCompare.CompareType()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(FloatCompare.__default.Less(), Tclass.FloatCompare.CompareType(), $h) } $IsGoodHeap($h) ==> $IsAlloc(FloatCompare.__default.Less(), Tclass.FloatCompare.CompareType(), $h));

function FloatCompare.__default.Equal() : int
uses {
axiom FloatCompare.__default.Equal(): int == LitInt(0);
axiom 1 < $FunctionContextHeight ==> $Is(FloatCompare.__default.Equal(), Tclass.FloatCompare.CompareType());
}

procedure {:verboseName "FloatCompare.Equal (well-formedness)"} CheckWellFormed$$FloatCompare.__default.Equal();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.Equal (well-formedness)"} CheckWellFormed$$FloatCompare.__default.Equal()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.Equal"} true;
    assume {:print "Types"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(27,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    assume true;
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(FloatCompare.__default.Equal(), Tclass.FloatCompare.CompareType(), $h) } $IsGoodHeap($h) ==> $IsAlloc(FloatCompare.__default.Equal(), Tclass.FloatCompare.CompareType(), $h));

function FloatCompare.__default.Greater() : int
uses {
axiom FloatCompare.__default.Greater(): int == LitInt(1);
axiom 1 < $FunctionContextHeight ==> $Is(FloatCompare.__default.Greater(), Tclass.FloatCompare.CompareType());
}

procedure {:verboseName "FloatCompare.Greater (well-formedness)"} CheckWellFormed$$FloatCompare.__default.Greater();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.Greater (well-formedness)"} CheckWellFormed$$FloatCompare.__default.Greater()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.Greater"} true;
    assume {:print "Types"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(28,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(1);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    assume true;
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(FloatCompare.__default.Greater(), Tclass.FloatCompare.CompareType(), $h) } $IsGoodHeap($h) ==> $IsAlloc(FloatCompare.__default.Greater(), Tclass.FloatCompare.CompareType(), $h));

function FloatCompare.__default.StrToIntInner($ly: LayerType, s#0: Seq, acc#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq, acc#0: int :: { FloatCompare.__default.StrToIntInner($LS($ly), s#0, acc#0) } FloatCompare.__default.StrToIntInner#canCall(s#0, acc#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(s#0) != LitInt(0) ==> (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) ==> FloatCompare.__default.StrToIntInner#canCall(Seq#Drop(s#0, LitInt(1)), Mul(acc#0, LitInt(10)) + char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48))))) && (!(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) ==> FloatCompare.__default.StrToIntInner#canCall(Seq#Drop(s#0, LitInt(1)), acc#0))) && FloatCompare.__default.StrToIntInner($LS($ly), s#0, acc#0) == (if Seq#Length(s#0) == LitInt(0) then acc#0 else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) then FloatCompare.__default.StrToIntInner($ly, Seq#Drop(s#0, LitInt(1)), Mul(acc#0, LitInt(10)) + char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48)))) else FloatCompare.__default.StrToIntInner($ly, Seq#Drop(s#0, LitInt(1)), acc#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq, acc#0: int :: {:weight 3} { FloatCompare.__default.StrToIntInner($LS($ly), Lit(s#0), LitInt(acc#0)) } FloatCompare.__default.StrToIntInner#canCall(Lit(s#0), LitInt(acc#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) ==> FloatCompare.__default.StrToIntInner#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))), Mul(LitInt(acc#0), LitInt(10)) + char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48))))) && (!(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) ==> FloatCompare.__default.StrToIntInner#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(1))), LitInt(acc#0)))) && FloatCompare.__default.StrToIntInner($LS($ly), Lit(s#0), LitInt(acc#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then acc#0 else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) then FloatCompare.__default.StrToIntInner($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), Mul(LitInt(acc#0), LitInt(10)) + char#ToInt($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48)))) else FloatCompare.__default.StrToIntInner($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(1))), LitInt(acc#0)))));
}

function FloatCompare.__default.StrToIntInner#canCall(s#0: Seq, acc#0: int) : bool;

axiom (forall $ly: LayerType, s#0: Seq, acc#0: int :: { FloatCompare.__default.StrToIntInner($LS($ly), s#0, acc#0) } FloatCompare.__default.StrToIntInner($LS($ly), s#0, acc#0) == FloatCompare.__default.StrToIntInner($ly, s#0, acc#0));

axiom (forall $ly: LayerType, s#0: Seq, acc#0: int :: { FloatCompare.__default.StrToIntInner(AsFuelBottom($ly), s#0, acc#0) } FloatCompare.__default.StrToIntInner($ly, s#0, acc#0) == FloatCompare.__default.StrToIntInner($LZ, s#0, acc#0));

function FloatCompare.__default.StrToIntInner#requires(LayerType, Seq, int) : bool;

axiom (forall $ly: LayerType, s#0: Seq, acc#0: int :: { FloatCompare.__default.StrToIntInner#requires($ly, s#0, acc#0) } $Is(s#0, TSeq(TChar)) ==> (FloatCompare.__default.StrToIntInner#requires($ly, s#0, acc#0) <==> true));

procedure {:verboseName "FloatCompare.StrToIntInner (well-formedness)"} CheckWellformed$$FloatCompare.__default.StrToIntInner(s#0: Seq where $Is(s#0, TSeq(TChar)), acc#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.StrToIntInner (well-formedness)"} CheckWellformed$$FloatCompare.__default.StrToIntInner(s#0: Seq, acc#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##acc#0: int;
  var ##s#1: Seq;
  var ##acc#1: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.StrToIntInner", " | ", s#0, " | ", acc#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(32,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume false;
    return;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume FloatCompare.__default.StrToIntInner($LS($LZ), s#0, acc#0) == acc#0;
    assume true;
    assume $Is(FloatCompare.__default.StrToIntInner($LS($LZ), s#0, acc#0), TInt);
    return;

  anon11_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    goto anon7;

  anon12_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) < char#ToInt(Lit(char#FromInt(48)));
    goto anon7;

  anon7:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##s#0 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    ##acc#0 := Mul(acc#0, LitInt(10)) + char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48)));
    assume $IsAlloc(##acc#0, TInt, $Heap);
    assume 0 <= acc#0 || Seq#Rank(##s#0) < Seq#Rank(s#0) || ##acc#0 == acc#0;
    assume Seq#Rank(##s#0) < Seq#Rank(s#0) || (Seq#Rank(##s#0) == Seq#Rank(s#0) && ##acc#0 < acc#0);
    assume FloatCompare.__default.StrToIntInner#canCall(Seq#Drop(s#0, LitInt(1)), Mul(acc#0, LitInt(10)) + char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48))));
    assume FloatCompare.__default.StrToIntInner($LS($LZ), s#0, acc#0) == FloatCompare.__default.StrToIntInner($LS($LZ), Seq#Drop(s#0, LitInt(1)), Mul(acc#0, LitInt(10)) + char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48))));
    assume FloatCompare.__default.StrToIntInner#canCall(Seq#Drop(s#0, LitInt(1)), Mul(acc#0, LitInt(10)) + char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) - char#ToInt(Lit(char#FromInt(48))));
    assume $Is(FloatCompare.__default.StrToIntInner($LS($LZ), s#0, acc#0), TInt);
    return;

  anon13_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, LitInt(1));
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    ##acc#1 := acc#0;
    assume $IsAlloc(##acc#1, TInt, $Heap);
    assume 0 <= acc#0 || Seq#Rank(##s#1) < Seq#Rank(s#0) || ##acc#1 == acc#0;
    assume Seq#Rank(##s#1) < Seq#Rank(s#0) || (Seq#Rank(##s#1) == Seq#Rank(s#0) && ##acc#1 < acc#0);
    assume FloatCompare.__default.StrToIntInner#canCall(Seq#Drop(s#0, LitInt(1)), acc#0);
    assume FloatCompare.__default.StrToIntInner($LS($LZ), s#0, acc#0) == FloatCompare.__default.StrToIntInner($LS($LZ), Seq#Drop(s#0, LitInt(1)), acc#0);
    assume FloatCompare.__default.StrToIntInner#canCall(Seq#Drop(s#0, LitInt(1)), acc#0);
    assume $Is(FloatCompare.__default.StrToIntInner($LS($LZ), s#0, acc#0), TInt);
    return;
}



function FloatCompare.__default.SkipLeadingSpace($ly: LayerType, val#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingSpace($ly, val#0) } FloatCompare.__default.SkipLeadingSpace#canCall(val#0) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(FloatCompare.__default.SkipLeadingSpace($ly, val#0)) == LitInt(0) || char#ToInt($Unbox(Seq#Index(FloatCompare.__default.SkipLeadingSpace($ly, val#0), LitInt(0))): char) > char#ToInt(Lit(char#FromInt(32)))) && $Is(FloatCompare.__default.SkipLeadingSpace($ly, val#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingSpace($LS($ly), val#0) } FloatCompare.__default.SkipLeadingSpace#canCall(val#0) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(val#0) > 0 && char#ToInt($Unbox(Seq#Index(val#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(32))) ==> FloatCompare.__default.SkipLeadingSpace#canCall(Seq#Drop(val#0, LitInt(1)))) && FloatCompare.__default.SkipLeadingSpace($LS($ly), val#0) == (if Seq#Length(val#0) > 0 && char#ToInt($Unbox(Seq#Index(val#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(32))) then FloatCompare.__default.SkipLeadingSpace($ly, Seq#Drop(val#0, LitInt(1))) else val#0));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: {:weight 3} { FloatCompare.__default.SkipLeadingSpace($LS($ly), Lit(val#0)) } FloatCompare.__default.SkipLeadingSpace#canCall(Lit(val#0)) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(Lit(val#0)) > 0 && char#ToInt($Unbox(Seq#Index(Lit(val#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(32))) ==> FloatCompare.__default.SkipLeadingSpace#canCall(Lit(Seq#Drop(Lit(val#0), LitInt(1))))) && FloatCompare.__default.SkipLeadingSpace($LS($ly), Lit(val#0)) == (if Seq#Length(Lit(val#0)) > 0 && char#ToInt($Unbox(Seq#Index(Lit(val#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(32))) then FloatCompare.__default.SkipLeadingSpace($LS($ly), Lit(Seq#Drop(Lit(val#0), LitInt(1)))) else val#0));
}

function FloatCompare.__default.SkipLeadingSpace#canCall(val#0: Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingSpace($LS($ly), val#0) } FloatCompare.__default.SkipLeadingSpace($LS($ly), val#0) == FloatCompare.__default.SkipLeadingSpace($ly, val#0));

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingSpace(AsFuelBottom($ly), val#0) } FloatCompare.__default.SkipLeadingSpace($ly, val#0) == FloatCompare.__default.SkipLeadingSpace($LZ, val#0));

function FloatCompare.__default.SkipLeadingSpace#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingSpace#requires($ly, val#0) } $Is(val#0, TSeq(TChar)) ==> (FloatCompare.__default.SkipLeadingSpace#requires($ly, val#0) <==> true));

procedure {:verboseName "FloatCompare.SkipLeadingSpace (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipLeadingSpace(val#0: Seq where $Is(val#0, TSeq(TChar))) returns (ret#0: Seq where $Is(ret#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17450"} Seq#Length(ret#0) == LitInt(0) || char#ToInt($Unbox(Seq#Index(ret#0, LitInt(0))): char) > char#ToInt(Lit(char#FromInt(32)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.SkipLeadingSpace (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipLeadingSpace(val#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##val#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.SkipLeadingSpace", " | ", val#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(44,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(FloatCompare.__default.SkipLeadingSpace($LS($LZ), val#0), TSeq(TChar));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Seq#Length(ret#0) == LitInt(0);
    goto anon5;

  anon13_Else:
    assume Seq#Length(ret#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    assume char#ToInt($Unbox(Seq#Index(ret#0, LitInt(0))): char) > char#ToInt(Lit(char#FromInt(32)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Length(val#0) > 0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(val#0);
    goto anon8;

  anon14_Else:
    assume {:partition} 0 >= Seq#Length(val#0);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(val#0) > 0 && char#ToInt($Unbox(Seq#Index(val#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(32)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(val#0);
    ##val#0 := Seq#Drop(val#0, LitInt(1));
    assume $IsAlloc(##val#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##val#0) < Seq#Rank(val#0);
    assume FloatCompare.__default.SkipLeadingSpace#canCall(Seq#Drop(val#0, LitInt(1)));
    assume FloatCompare.__default.SkipLeadingSpace($LS($LZ), val#0) == FloatCompare.__default.SkipLeadingSpace($LS($LZ), Seq#Drop(val#0, LitInt(1)));
    assume FloatCompare.__default.SkipLeadingSpace#canCall(Seq#Drop(val#0, LitInt(1)));
    assume $Is(FloatCompare.__default.SkipLeadingSpace($LS($LZ), val#0), TSeq(TChar));
    goto anon11;

  anon15_Else:
    assume {:partition} !(Seq#Length(val#0) > 0 && char#ToInt($Unbox(Seq#Index(val#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(32))));
    assume FloatCompare.__default.SkipLeadingSpace($LS($LZ), val#0) == val#0;
    assume true;
    assume $Is(FloatCompare.__default.SkipLeadingSpace($LS($LZ), val#0), TSeq(TChar));
    goto anon11;

  anon11:
    assume FloatCompare.__default.SkipLeadingSpace($LS($LZ), val#0) == ret#0;
    return;
}



function FloatCompare.__default.StrToInt(s#0: Seq, acc#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq, acc#0: int :: { FloatCompare.__default.StrToInt(s#0, acc#0) } FloatCompare.__default.StrToInt#canCall(s#0, acc#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> FloatCompare.__default.SkipLeadingSpace#canCall(s#0) && (var tmp#0 := FloatCompare.__default.SkipLeadingSpace($LS($LZ), s#0); Seq#Length(tmp#0) != LitInt(0) ==> ($Unbox(Seq#Index(tmp#0, LitInt(0))): char == Lit(char#FromInt(45)) ==> FloatCompare.__default.StrToIntInner#canCall(s#0, LitInt(0))) && ($Unbox(Seq#Index(tmp#0, LitInt(0))): char != Lit(char#FromInt(45)) ==> FloatCompare.__default.StrToIntInner#canCall(s#0, LitInt(0)))) && FloatCompare.__default.StrToInt(s#0, acc#0) == (var tmp#0 := FloatCompare.__default.SkipLeadingSpace($LS($LZ), s#0); (if Seq#Length(tmp#0) == LitInt(0) then 0 else (if $Unbox(Seq#Index(tmp#0, LitInt(0))): char == Lit(char#FromInt(45)) then 0 - FloatCompare.__default.StrToIntInner($LS($LZ), s#0, LitInt(0)) else FloatCompare.__default.StrToIntInner($LS($LZ), s#0, LitInt(0))))));
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq, acc#0: int :: {:weight 3} { FloatCompare.__default.StrToInt(Lit(s#0), LitInt(acc#0)) } FloatCompare.__default.StrToInt#canCall(Lit(s#0), LitInt(acc#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> FloatCompare.__default.SkipLeadingSpace#canCall(Lit(s#0)) && (var tmp#1 := Lit(FloatCompare.__default.SkipLeadingSpace($LS($LZ), Lit(s#0))); Seq#Length(tmp#1) != LitInt(0) ==> ($Unbox(Seq#Index(tmp#1, LitInt(0))): char == Lit(char#FromInt(45)) ==> FloatCompare.__default.StrToIntInner#canCall(Lit(s#0), LitInt(0))) && ($Unbox(Seq#Index(tmp#1, LitInt(0))): char != Lit(char#FromInt(45)) ==> FloatCompare.__default.StrToIntInner#canCall(Lit(s#0), LitInt(0)))) && FloatCompare.__default.StrToInt(Lit(s#0), LitInt(acc#0)) == (var tmp#1 := Lit(FloatCompare.__default.SkipLeadingSpace($LS($LZ), Lit(s#0))); (if Seq#Length(tmp#1) == LitInt(0) then 0 else (if $Unbox(Seq#Index(tmp#1, LitInt(0))): char == Lit(char#FromInt(45)) then 0 - FloatCompare.__default.StrToIntInner($LS($LZ), Lit(s#0), LitInt(0)) else FloatCompare.__default.StrToIntInner($LS($LZ), Lit(s#0), LitInt(0))))));
}

function FloatCompare.__default.StrToInt#canCall(s#0: Seq, acc#0: int) : bool;

function FloatCompare.__default.StrToInt#requires(Seq, int) : bool;

axiom (forall s#0: Seq, acc#0: int :: { FloatCompare.__default.StrToInt#requires(s#0, acc#0) } $Is(s#0, TSeq(TChar)) ==> (FloatCompare.__default.StrToInt#requires(s#0, acc#0) <==> true));

procedure {:verboseName "FloatCompare.StrToInt (well-formedness)"} CheckWellformed$$FloatCompare.__default.StrToInt(s#0: Seq where $Is(s#0, TSeq(TChar)), acc#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.StrToInt (well-formedness)"} CheckWellformed$$FloatCompare.__default.StrToInt(s#0: Seq, acc#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var tmp#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##val#0: Seq;
  var ##s#0: Seq;
  var ##acc#0: int;
  var ##s#1: Seq;
  var ##acc#1: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.StrToInt", " | ", s#0, " | ", acc#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(54,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume false;
    return;

  anon8_Else:
    havoc tmp#Z#0;
    assume $Is(tmp#Z#0, TSeq(TChar)) && $IsAlloc(tmp#Z#0, TSeq(TChar), $Heap);
    ##val#0 := s#0;
    assume $IsAlloc(##val#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SkipLeadingSpace#canCall(s#0);
    assume let#0#0#0 == FloatCompare.__default.SkipLeadingSpace($LS($LZ), s#0);
    assume FloatCompare.__default.SkipLeadingSpace#canCall(s#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume tmp#Z#0 == let#0#0#0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(tmp#Z#0) == LitInt(0);
    assume FloatCompare.__default.StrToInt(s#0, acc#0) == LitInt(0);
    assume true;
    assume $Is(FloatCompare.__default.StrToInt(s#0, acc#0), TInt);
    return;

  anon9_Else:
    assume {:partition} Seq#Length(tmp#Z#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(tmp#Z#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} $Unbox(Seq#Index(tmp#Z#0, LitInt(0))): char == Lit(char#FromInt(45));
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    ##acc#0 := LitInt(0);
    assume $IsAlloc(##acc#0, TInt, $Heap);
    assume FloatCompare.__default.StrToIntInner#canCall(s#0, LitInt(0));
    assume FloatCompare.__default.StrToInt(s#0, acc#0) == 0 - FloatCompare.__default.StrToIntInner($LS($LZ), s#0, LitInt(0));
    assume FloatCompare.__default.StrToIntInner#canCall(s#0, LitInt(0));
    assume $Is(FloatCompare.__default.StrToInt(s#0, acc#0), TInt);
    return;

  anon10_Else:
    assume {:partition} $Unbox(Seq#Index(tmp#Z#0, LitInt(0))): char != Lit(char#FromInt(45));
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    ##acc#1 := LitInt(0);
    assume $IsAlloc(##acc#1, TInt, $Heap);
    assume FloatCompare.__default.StrToIntInner#canCall(s#0, LitInt(0));
    assume FloatCompare.__default.StrToInt(s#0, acc#0) == FloatCompare.__default.StrToIntInner($LS($LZ), s#0, LitInt(0));
    assume FloatCompare.__default.StrToIntInner#canCall(s#0, LitInt(0));
    assume $Is(FloatCompare.__default.StrToInt(s#0, acc#0), TInt);
    return;
}



function FloatCompare.__default.SplitE(x#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SplitE(x#0) } FloatCompare.__default.SplitE#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> $Is(FloatCompare.__default.SplitE(x#0), Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)))));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SplitE(x#0) } FloatCompare.__default.SplitE#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> StandardLibrary.__default.SplitOnce_q#canCall(TChar, x#0, $Box(Lit(char#FromInt(101)))) && (var parts#0 := StandardLibrary.__default.SplitOnce_q(TChar, x#0, $Box(Lit(char#FromInt(101)))); !Wrappers.Option.Some_q(parts#0) ==> StandardLibrary.__default.SplitOnce_q#canCall(TChar, x#0, $Box(Lit(char#FromInt(69))))) && FloatCompare.__default.SplitE(x#0) == (var parts#0 := StandardLibrary.__default.SplitOnce_q(TChar, x#0, $Box(Lit(char#FromInt(101)))); (if Wrappers.Option.Some_q(parts#0) then parts#0 else StandardLibrary.__default.SplitOnce_q(TChar, x#0, $Box(Lit(char#FromInt(69)))))));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.SplitE(Lit(x#0)) } FloatCompare.__default.SplitE#canCall(Lit(x#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> StandardLibrary.__default.SplitOnce_q#canCall(TChar, Lit(x#0), $Box(Lit(char#FromInt(101)))) && (var parts#1 := Lit(StandardLibrary.__default.SplitOnce_q(TChar, Lit(x#0), $Box(Lit(char#FromInt(101))))); !Wrappers.Option.Some_q(parts#1) ==> StandardLibrary.__default.SplitOnce_q#canCall(TChar, Lit(x#0), $Box(Lit(char#FromInt(69))))) && FloatCompare.__default.SplitE(Lit(x#0)) == (var parts#1 := Lit(StandardLibrary.__default.SplitOnce_q(TChar, Lit(x#0), $Box(Lit(char#FromInt(101))))); (if Wrappers.Option.Some_q(parts#1) then parts#1 else StandardLibrary.__default.SplitOnce_q(TChar, Lit(x#0), $Box(Lit(char#FromInt(69)))))));
}

function FloatCompare.__default.SplitE#canCall(x#0: Seq) : bool;

function FloatCompare.__default.SplitE#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.SplitE#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.SplitE#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.SplitE (well-formedness)"} CheckWellformed$$FloatCompare.__default.SplitE(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function FloatCompare.__default.SplitExp(x#0: Seq) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SplitExp(x#0) } FloatCompare.__default.SplitExp#canCall(x#0) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> $Is(FloatCompare.__default.SplitExp(x#0), Tclass._System.Tuple2(TSeq(TChar), TInt)));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SplitExp(x#0) } FloatCompare.__default.SplitExp#canCall(x#0) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.SplitE#canCall(x#0) && (var parts#0 := FloatCompare.__default.SplitE(x#0); Wrappers.Option.Some_q(parts#0) ==> _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#0)): DatatypeType) && _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#0)): DatatypeType) && FloatCompare.__default.StrToInt#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#0)): DatatypeType)): Seq, LitInt(0))) && FloatCompare.__default.SplitExp(x#0) == (var parts#0 := FloatCompare.__default.SplitE(x#0); (if Wrappers.Option.Some_q(parts#0) then #_System._tuple#2._#Make2(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#0)): DatatypeType), $Box(FloatCompare.__default.StrToInt($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#0)): DatatypeType)): Seq, LitInt(0)))) else #_System._tuple#2._#Make2($Box(x#0), $Box(LitInt(0))))));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.SplitExp(Lit(x#0)) } FloatCompare.__default.SplitExp#canCall(Lit(x#0)) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.SplitE#canCall(Lit(x#0)) && (var parts#1 := Lit(FloatCompare.__default.SplitE(Lit(x#0))); Wrappers.Option.Some_q(parts#1) ==> _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#1)): DatatypeType) && _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#1)): DatatypeType) && FloatCompare.__default.StrToInt#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#1)): DatatypeType)): Seq, LitInt(0))) && FloatCompare.__default.SplitExp(Lit(x#0)) == (var parts#1 := Lit(FloatCompare.__default.SplitE(Lit(x#0))); (if Wrappers.Option.Some_q(parts#1) then #_System._tuple#2._#Make2($Box(Lit($Unbox(_System.Tuple2._0(Lit($Unbox(Wrappers.Option.value(parts#1)): DatatypeType))): Seq)), $Box(LitInt(FloatCompare.__default.StrToInt(Lit($Unbox(_System.Tuple2._1(Lit($Unbox(Wrappers.Option.value(parts#1)): DatatypeType))): Seq), LitInt(0))))) else #_System._tuple#2._#Make2($Box(Lit(x#0)), $Box(LitInt(0))))));
}

function FloatCompare.__default.SplitExp#canCall(x#0: Seq) : bool;

function FloatCompare.__default.SplitExp#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.SplitExp#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.SplitExp#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.SplitExp (well-formedness)"} CheckWellformed$$FloatCompare.__default.SplitExp(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.SplitExp (well-formedness)"} CheckWellformed$$FloatCompare.__default.SplitExp(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var parts#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##x#0: Seq;
  var ##s#0: Seq;
  var ##acc#0: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.SplitExp", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(76,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(FloatCompare.__default.SplitExp(x#0), Tclass._System.Tuple2(TSeq(TChar), TInt));
    assume false;
    return;

  anon6_Else:
    havoc parts#Z#0;
    assume $Is(parts#Z#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)))) && $IsAlloc(parts#Z#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))), $Heap);
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SplitE#canCall(x#0);
    assume let#0#0#0 == FloatCompare.__default.SplitE(x#0);
    assume FloatCompare.__default.SplitE#canCall(x#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))));
    assume parts#Z#0 == let#0#0#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Wrappers.Option.Some_q(parts#Z#0);
    assume Wrappers.Option.Some_q(parts#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType);
    assume Wrappers.Option.Some_q(parts#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType);
    ##s#0 := $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    ##acc#0 := LitInt(0);
    assume $IsAlloc(##acc#0, TInt, $Heap);
    assume FloatCompare.__default.StrToInt#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq, LitInt(0));
    assume FloatCompare.__default.SplitExp(x#0) == #_System._tuple#2._#Make2(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType), $Box(FloatCompare.__default.StrToInt($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq, LitInt(0))));
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType) && _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType) && FloatCompare.__default.StrToInt#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq, LitInt(0));
    assume $Is(FloatCompare.__default.SplitExp(x#0), Tclass._System.Tuple2(TSeq(TChar), TInt));
    return;

  anon7_Else:
    assume {:partition} !Wrappers.Option.Some_q(parts#Z#0);
    assume FloatCompare.__default.SplitExp(x#0) == #_System._tuple#2._#Make2($Box(x#0), $Box(LitInt(0)));
    assume true;
    assume $Is(FloatCompare.__default.SplitExp(x#0), Tclass._System.Tuple2(TSeq(TChar), TInt));
    return;
}



function FloatCompare.__default.SkipLeadingZeros($ly: LayerType, val#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingZeros($ly, val#0) } FloatCompare.__default.SkipLeadingZeros#canCall(val#0) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(FloatCompare.__default.SkipLeadingZeros($ly, val#0)) == LitInt(0) || $Unbox(Seq#Index(FloatCompare.__default.SkipLeadingZeros($ly, val#0), LitInt(0))): char != char#FromInt(48)) && $Is(FloatCompare.__default.SkipLeadingZeros($ly, val#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingZeros($LS($ly), val#0) } FloatCompare.__default.SkipLeadingZeros#canCall(val#0) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, LitInt(0))): char == Lit(char#FromInt(48)) ==> FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Drop(val#0, LitInt(1)))) && FloatCompare.__default.SkipLeadingZeros($LS($ly), val#0) == (if Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, LitInt(0))): char == Lit(char#FromInt(48)) then FloatCompare.__default.SkipLeadingZeros($ly, Seq#Drop(val#0, LitInt(1))) else val#0));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: {:weight 3} { FloatCompare.__default.SkipLeadingZeros($LS($ly), Lit(val#0)) } FloatCompare.__default.SkipLeadingZeros#canCall(Lit(val#0)) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(Lit(val#0)) > 0 && $Unbox(Seq#Index(Lit(val#0), LitInt(0))): char == Lit(char#FromInt(48)) ==> FloatCompare.__default.SkipLeadingZeros#canCall(Lit(Seq#Drop(Lit(val#0), LitInt(1))))) && FloatCompare.__default.SkipLeadingZeros($LS($ly), Lit(val#0)) == (if Seq#Length(Lit(val#0)) > 0 && $Unbox(Seq#Index(Lit(val#0), LitInt(0))): char == Lit(char#FromInt(48)) then FloatCompare.__default.SkipLeadingZeros($LS($ly), Lit(Seq#Drop(Lit(val#0), LitInt(1)))) else val#0));
}

function FloatCompare.__default.SkipLeadingZeros#canCall(val#0: Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingZeros($LS($ly), val#0) } FloatCompare.__default.SkipLeadingZeros($LS($ly), val#0) == FloatCompare.__default.SkipLeadingZeros($ly, val#0));

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingZeros(AsFuelBottom($ly), val#0) } FloatCompare.__default.SkipLeadingZeros($ly, val#0) == FloatCompare.__default.SkipLeadingZeros($LZ, val#0));

function FloatCompare.__default.SkipLeadingZeros#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipLeadingZeros#requires($ly, val#0) } $Is(val#0, TSeq(TChar)) ==> (FloatCompare.__default.SkipLeadingZeros#requires($ly, val#0) <==> true));

procedure {:verboseName "FloatCompare.SkipLeadingZeros (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipLeadingZeros(val#0: Seq where $Is(val#0, TSeq(TChar))) returns (ret#0: Seq where $Is(ret#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17477"} Seq#Length(ret#0) == LitInt(0) || $Unbox(Seq#Index(ret#0, LitInt(0))): char != char#FromInt(48);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.SkipLeadingZeros (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipLeadingZeros(val#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##val#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.SkipLeadingZeros", " | ", val#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(86,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(FloatCompare.__default.SkipLeadingZeros($LS($LZ), val#0), TSeq(TChar));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Seq#Length(ret#0) == LitInt(0);
    goto anon5;

  anon13_Else:
    assume Seq#Length(ret#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    assume $Unbox(Seq#Index(ret#0, LitInt(0))): char != char#FromInt(48);
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Length(val#0) > 0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(val#0);
    goto anon8;

  anon14_Else:
    assume {:partition} 0 >= Seq#Length(val#0);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, LitInt(0))): char == Lit(char#FromInt(48));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(val#0);
    ##val#0 := Seq#Drop(val#0, LitInt(1));
    assume $IsAlloc(##val#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##val#0) < Seq#Rank(val#0);
    assume FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Drop(val#0, LitInt(1)));
    assume FloatCompare.__default.SkipLeadingZeros($LS($LZ), val#0) == FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Drop(val#0, LitInt(1)));
    assume FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Drop(val#0, LitInt(1)));
    assume $Is(FloatCompare.__default.SkipLeadingZeros($LS($LZ), val#0), TSeq(TChar));
    goto anon11;

  anon15_Else:
    assume {:partition} !(Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, LitInt(0))): char == Lit(char#FromInt(48)));
    assume FloatCompare.__default.SkipLeadingZeros($LS($LZ), val#0) == val#0;
    assume true;
    assume $Is(FloatCompare.__default.SkipLeadingZeros($LS($LZ), val#0), TSeq(TChar));
    goto anon11;

  anon11:
    assume FloatCompare.__default.SkipLeadingZeros($LS($LZ), val#0) == ret#0;
    return;
}



function FloatCompare.__default.SkipTrailingZeros($ly: LayerType, val#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipTrailingZeros($ly, val#0) } FloatCompare.__default.SkipTrailingZeros#canCall(val#0) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(FloatCompare.__default.SkipTrailingZeros($ly, val#0)) == LitInt(0) || $Unbox(Seq#Index(FloatCompare.__default.SkipTrailingZeros($ly, val#0), Seq#Length(FloatCompare.__default.SkipTrailingZeros($ly, val#0)) - 1)): char != char#FromInt(48)) && $Is(FloatCompare.__default.SkipTrailingZeros($ly, val#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipTrailingZeros($LS($ly), val#0) } FloatCompare.__default.SkipTrailingZeros#canCall(val#0) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, Seq#Length(val#0) - 1)): char == Lit(char#FromInt(48)) ==> FloatCompare.__default.SkipTrailingZeros#canCall(Seq#Take(val#0, Seq#Length(val#0) - 1))) && FloatCompare.__default.SkipTrailingZeros($LS($ly), val#0) == (if Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, Seq#Length(val#0) - 1)): char == Lit(char#FromInt(48)) then FloatCompare.__default.SkipTrailingZeros($ly, Seq#Take(val#0, Seq#Length(val#0) - 1)) else val#0));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, val#0: Seq :: {:weight 3} { FloatCompare.__default.SkipTrailingZeros($LS($ly), Lit(val#0)) } FloatCompare.__default.SkipTrailingZeros#canCall(Lit(val#0)) || (0 < $FunctionContextHeight && $Is(val#0, TSeq(TChar))) ==> (Seq#Length(Lit(val#0)) > 0 && $Unbox(Seq#Index(Lit(val#0), Seq#Length(Lit(val#0)) - 1)): char == Lit(char#FromInt(48)) ==> FloatCompare.__default.SkipTrailingZeros#canCall(Seq#Take(Lit(val#0), Seq#Length(Lit(val#0)) - 1))) && FloatCompare.__default.SkipTrailingZeros($LS($ly), Lit(val#0)) == (if Seq#Length(Lit(val#0)) > 0 && $Unbox(Seq#Index(Lit(val#0), Seq#Length(Lit(val#0)) - 1)): char == Lit(char#FromInt(48)) then FloatCompare.__default.SkipTrailingZeros($LS($ly), Seq#Take(Lit(val#0), Seq#Length(Lit(val#0)) - 1)) else val#0));
}

function FloatCompare.__default.SkipTrailingZeros#canCall(val#0: Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipTrailingZeros($LS($ly), val#0) } FloatCompare.__default.SkipTrailingZeros($LS($ly), val#0) == FloatCompare.__default.SkipTrailingZeros($ly, val#0));

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipTrailingZeros(AsFuelBottom($ly), val#0) } FloatCompare.__default.SkipTrailingZeros($ly, val#0) == FloatCompare.__default.SkipTrailingZeros($LZ, val#0));

function FloatCompare.__default.SkipTrailingZeros#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, val#0: Seq :: { FloatCompare.__default.SkipTrailingZeros#requires($ly, val#0) } $Is(val#0, TSeq(TChar)) ==> (FloatCompare.__default.SkipTrailingZeros#requires($ly, val#0) <==> true));

procedure {:verboseName "FloatCompare.SkipTrailingZeros (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipTrailingZeros(val#0: Seq where $Is(val#0, TSeq(TChar))) returns (ret#0: Seq where $Is(ret#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17488"} Seq#Length(ret#0) == LitInt(0) || $Unbox(Seq#Index(ret#0, Seq#Length(ret#0) - 1)): char != char#FromInt(48);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.SkipTrailingZeros (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipTrailingZeros(val#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##val#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.SkipTrailingZeros", " | ", val#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(96,35): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(FloatCompare.__default.SkipTrailingZeros($LS($LZ), val#0), TSeq(TChar));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Seq#Length(ret#0) == LitInt(0);
    goto anon5;

  anon13_Else:
    assume Seq#Length(ret#0) != LitInt(0);
    assume 0 <= Seq#Length(ret#0) - 1 && Seq#Length(ret#0) - 1 < Seq#Length(ret#0);
    assume $Unbox(Seq#Index(ret#0, Seq#Length(ret#0) - 1)): char != char#FromInt(48);
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Length(val#0) > 0;
    assume 0 <= Seq#Length(val#0) - 1 && Seq#Length(val#0) - 1 < Seq#Length(val#0);
    goto anon8;

  anon14_Else:
    assume {:partition} 0 >= Seq#Length(val#0);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, Seq#Length(val#0) - 1)): char == Lit(char#FromInt(48));
    assume 0 <= Seq#Length(val#0) - 1 && Seq#Length(val#0) - 1 <= Seq#Length(val#0);
    ##val#0 := Seq#Take(val#0, Seq#Length(val#0) - 1);
    assume $IsAlloc(##val#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##val#0) < Seq#Rank(val#0);
    assume FloatCompare.__default.SkipTrailingZeros#canCall(Seq#Take(val#0, Seq#Length(val#0) - 1));
    assume FloatCompare.__default.SkipTrailingZeros($LS($LZ), val#0) == FloatCompare.__default.SkipTrailingZeros($LS($LZ), Seq#Take(val#0, Seq#Length(val#0) - 1));
    assume FloatCompare.__default.SkipTrailingZeros#canCall(Seq#Take(val#0, Seq#Length(val#0) - 1));
    assume $Is(FloatCompare.__default.SkipTrailingZeros($LS($LZ), val#0), TSeq(TChar));
    goto anon11;

  anon15_Else:
    assume {:partition} !(Seq#Length(val#0) > 0 && $Unbox(Seq#Index(val#0, Seq#Length(val#0) - 1)): char == Lit(char#FromInt(48)));
    assume FloatCompare.__default.SkipTrailingZeros($LS($LZ), val#0) == val#0;
    assume true;
    assume $Is(FloatCompare.__default.SkipTrailingZeros($LS($LZ), val#0), TSeq(TChar));
    goto anon11;

  anon11:
    assume FloatCompare.__default.SkipTrailingZeros($LS($LZ), val#0) == ret#0;
    return;
}



function FloatCompare.__default.SplitDot(x#0: Seq) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SplitDot(x#0) } FloatCompare.__default.SplitDot#canCall(x#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> $Is(FloatCompare.__default.SplitDot(x#0), Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SplitDot(x#0) } FloatCompare.__default.SplitDot#canCall(x#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> StandardLibrary.__default.SplitOnce_q#canCall(TChar, x#0, $Box(Lit(char#FromInt(46)))) && (var parts#0 := StandardLibrary.__default.SplitOnce_q(TChar, x#0, $Box(Lit(char#FromInt(46)))); (Wrappers.Option.Some_q(parts#0) ==> _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#0)): DatatypeType) && FloatCompare.__default.SkipLeadingZeros#canCall($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#0)): DatatypeType)): Seq) && _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#0)): DatatypeType) && FloatCompare.__default.SkipTrailingZeros#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#0)): DatatypeType)): Seq)) && (!Wrappers.Option.Some_q(parts#0) ==> FloatCompare.__default.SkipLeadingZeros#canCall(x#0))) && FloatCompare.__default.SplitDot(x#0) == (var parts#0 := StandardLibrary.__default.SplitOnce_q(TChar, x#0, $Box(Lit(char#FromInt(46)))); (if Wrappers.Option.Some_q(parts#0) then #_System._tuple#2._#Make2($Box(FloatCompare.__default.SkipLeadingZeros($LS($LZ), $Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#0)): DatatypeType)): Seq)), $Box(FloatCompare.__default.SkipTrailingZeros($LS($LZ), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#0)): DatatypeType)): Seq))) else #_System._tuple#2._#Make2($Box(FloatCompare.__default.SkipLeadingZeros($LS($LZ), x#0)), $Box(Lit(Seq#Empty(): Seq))))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.SplitDot(Lit(x#0)) } FloatCompare.__default.SplitDot#canCall(Lit(x#0)) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> StandardLibrary.__default.SplitOnce_q#canCall(TChar, Lit(x#0), $Box(Lit(char#FromInt(46)))) && (var parts#1 := Lit(StandardLibrary.__default.SplitOnce_q(TChar, Lit(x#0), $Box(Lit(char#FromInt(46))))); (Wrappers.Option.Some_q(parts#1) ==> _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#1)): DatatypeType) && FloatCompare.__default.SkipLeadingZeros#canCall($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#1)): DatatypeType)): Seq) && _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#1)): DatatypeType) && FloatCompare.__default.SkipTrailingZeros#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#1)): DatatypeType)): Seq)) && (!Wrappers.Option.Some_q(parts#1) ==> FloatCompare.__default.SkipLeadingZeros#canCall(Lit(x#0)))) && FloatCompare.__default.SplitDot(Lit(x#0)) == (var parts#1 := Lit(StandardLibrary.__default.SplitOnce_q(TChar, Lit(x#0), $Box(Lit(char#FromInt(46))))); (if Wrappers.Option.Some_q(parts#1) then #_System._tuple#2._#Make2($Box(Lit(FloatCompare.__default.SkipLeadingZeros($LS($LZ), Lit($Unbox(_System.Tuple2._0(Lit($Unbox(Wrappers.Option.value(parts#1)): DatatypeType))): Seq)))), $Box(Lit(FloatCompare.__default.SkipTrailingZeros($LS($LZ), Lit($Unbox(_System.Tuple2._1(Lit($Unbox(Wrappers.Option.value(parts#1)): DatatypeType))): Seq))))) else #_System._tuple#2._#Make2($Box(Lit(FloatCompare.__default.SkipLeadingZeros($LS($LZ), Lit(x#0)))), $Box(Lit(Seq#Empty(): Seq))))));
}

function FloatCompare.__default.SplitDot#canCall(x#0: Seq) : bool;

function FloatCompare.__default.SplitDot#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.SplitDot#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.SplitDot#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.SplitDot (well-formedness)"} CheckWellformed$$FloatCompare.__default.SplitDot(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.SplitDot (well-formedness)"} CheckWellformed$$FloatCompare.__default.SplitDot(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var parts#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##delim#0: char;
  var ##val#0: Seq;
  var ##val#1: Seq;
  var ##val#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.SplitDot", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(106,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(FloatCompare.__default.SplitDot(x#0), Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)));
    assume false;
    return;

  anon6_Else:
    havoc parts#Z#0;
    assume $Is(parts#Z#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)))) && $IsAlloc(parts#Z#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))), $Heap);
    ##s#0 := x#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    ##delim#0 := Lit(char#FromInt(46));
    assume $IsAlloc(##delim#0, TChar, $Heap);
    assume StandardLibrary.__default.SplitOnce_q#canCall(TChar, x#0, $Box(Lit(char#FromInt(46))));
    assume let#0#0#0 == StandardLibrary.__default.SplitOnce_q(TChar, x#0, $Box(Lit(char#FromInt(46))));
    assume StandardLibrary.__default.SplitOnce_q#canCall(TChar, x#0, $Box(Lit(char#FromInt(46))));
    assume $Is(let#0#0#0, Tclass.Wrappers.Option(Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))));
    assume parts#Z#0 == let#0#0#0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Wrappers.Option.Some_q(parts#Z#0);
    assume Wrappers.Option.Some_q(parts#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType);
    ##val#0 := $Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq;
    assume $IsAlloc(##val#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SkipLeadingZeros#canCall($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq);
    assume Wrappers.Option.Some_q(parts#Z#0);
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType);
    ##val#1 := $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq;
    assume $IsAlloc(##val#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SkipTrailingZeros#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq);
    assume FloatCompare.__default.SplitDot(x#0) == #_System._tuple#2._#Make2($Box(FloatCompare.__default.SkipLeadingZeros($LS($LZ), $Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq)), $Box(FloatCompare.__default.SkipTrailingZeros($LS($LZ), $Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq)));
    assume _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType) && FloatCompare.__default.SkipLeadingZeros#canCall($Unbox(_System.Tuple2._0($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq) && _System.Tuple2.___hMake2_q($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType) && FloatCompare.__default.SkipTrailingZeros#canCall($Unbox(_System.Tuple2._1($Unbox(Wrappers.Option.value(parts#Z#0)): DatatypeType)): Seq);
    assume $Is(FloatCompare.__default.SplitDot(x#0), Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)));
    return;

  anon7_Else:
    assume {:partition} !Wrappers.Option.Some_q(parts#Z#0);
    ##val#2 := x#0;
    assume $IsAlloc(##val#2, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SkipLeadingZeros#canCall(x#0);
    assume FloatCompare.__default.SplitDot(x#0) == #_System._tuple#2._#Make2($Box(FloatCompare.__default.SkipLeadingZeros($LS($LZ), x#0)), $Box(Lit(Seq#Empty(): Seq)));
    assume FloatCompare.__default.SkipLeadingZeros#canCall(x#0);
    assume $Is(FloatCompare.__default.SplitDot(x#0), Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)));
    return;
}



function FloatCompare.__default.StrCmp($ly: LayerType, x#0: Seq, y#0: Seq) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq, y#0: Seq :: { FloatCompare.__default.StrCmp($ly, x#0, y#0) } FloatCompare.__default.StrCmp#canCall(x#0, y#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> LitInt(-1) <= FloatCompare.__default.StrCmp($ly, x#0, y#0) && FloatCompare.__default.StrCmp($ly, x#0, y#0) <= LitInt(1));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq, y#0: Seq :: { FloatCompare.__default.StrCmp($LS($ly), x#0, y#0) } FloatCompare.__default.StrCmp#canCall(x#0, y#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> (!(Seq#Length(x#0) == LitInt(0) && Seq#Length(y#0) == LitInt(0)) ==> Seq#Length(x#0) != LitInt(0) ==> Seq#Length(y#0) != LitInt(0) ==> char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) ==> char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char) >= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) ==> FloatCompare.__default.StrCmp#canCall(Seq#Drop(x#0, LitInt(1)), Seq#Drop(y#0, LitInt(1)))) && FloatCompare.__default.StrCmp($LS($ly), x#0, y#0) == (if Seq#Length(x#0) == LitInt(0) && Seq#Length(y#0) == LitInt(0) then 0 else (if Seq#Length(x#0) == LitInt(0) then -1 else (if Seq#Length(y#0) == LitInt(0) then 1 else (if char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) < char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char) then -1 else (if char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) > char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char) then 1 else FloatCompare.__default.StrCmp($ly, Seq#Drop(x#0, LitInt(1)), Seq#Drop(y#0, LitInt(1)))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq, y#0: Seq :: {:weight 3} { FloatCompare.__default.StrCmp($LS($ly), Lit(x#0), Lit(y#0)) } FloatCompare.__default.StrCmp#canCall(Lit(x#0), Lit(y#0)) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> (!(Seq#Length(Lit(x#0)) == LitInt(0) && Seq#Length(Lit(y#0)) == LitInt(0)) ==> Seq#Length(Lit(x#0)) != LitInt(0) ==> Seq#Length(Lit(y#0)) != LitInt(0) ==> char#ToInt($Unbox(Seq#Index(Lit(y#0), LitInt(0))): char) <= char#ToInt($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) ==> char#ToInt($Unbox(Seq#Index(Lit(y#0), LitInt(0))): char) >= char#ToInt($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) ==> FloatCompare.__default.StrCmp#canCall(Lit(Seq#Drop(Lit(x#0), LitInt(1))), Lit(Seq#Drop(Lit(y#0), LitInt(1))))) && FloatCompare.__default.StrCmp($LS($ly), Lit(x#0), Lit(y#0)) == (if Seq#Length(Lit(x#0)) == LitInt(0) && Seq#Length(Lit(y#0)) == LitInt(0) then 0 else (if Seq#Length(Lit(x#0)) == LitInt(0) then -1 else (if Seq#Length(Lit(y#0)) == LitInt(0) then 1 else (if char#ToInt($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) < char#ToInt($Unbox(Seq#Index(Lit(y#0), LitInt(0))): char) then -1 else (if char#ToInt($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) > char#ToInt($Unbox(Seq#Index(Lit(y#0), LitInt(0))): char) then 1 else FloatCompare.__default.StrCmp($LS($ly), Lit(Seq#Drop(Lit(x#0), LitInt(1))), Lit(Seq#Drop(Lit(y#0), LitInt(1))))))))));
}

function FloatCompare.__default.StrCmp#canCall(x#0: Seq, y#0: Seq) : bool;

axiom (forall $ly: LayerType, x#0: Seq, y#0: Seq :: { FloatCompare.__default.StrCmp($LS($ly), x#0, y#0) } FloatCompare.__default.StrCmp($LS($ly), x#0, y#0) == FloatCompare.__default.StrCmp($ly, x#0, y#0));

axiom (forall $ly: LayerType, x#0: Seq, y#0: Seq :: { FloatCompare.__default.StrCmp(AsFuelBottom($ly), x#0, y#0) } FloatCompare.__default.StrCmp($ly, x#0, y#0) == FloatCompare.__default.StrCmp($LZ, x#0, y#0));

function FloatCompare.__default.StrCmp#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, x#0: Seq, y#0: Seq :: { FloatCompare.__default.StrCmp#requires($ly, x#0, y#0) } $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar)) ==> (FloatCompare.__default.StrCmp#requires($ly, x#0, y#0) <==> true));

procedure {:verboseName "FloatCompare.StrCmp (well-formedness)"} CheckWellformed$$FloatCompare.__default.StrCmp(x#0: Seq where $Is(x#0, TSeq(TChar)), y#0: Seq where $Is(y#0, TSeq(TChar))) returns (ret#0: int where LitInt(-1) <= ret#0 && ret#0 <= LitInt(1));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.StrCmp (well-formedness)"} CheckWellformed$$FloatCompare.__default.StrCmp(x#0: Seq, y#0: Seq) returns (ret#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##x#0: Seq;
  var ##y#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.StrCmp", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(116,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume LitInt(-1) <= FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) && FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) <= LitInt(1);
    assume false;
    return;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Seq#Length(x#0) == LitInt(0);
    goto anon5;

  anon18_Else:
    assume {:partition} Seq#Length(x#0) != LitInt(0);
    goto anon5;

  anon5:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Length(x#0) == LitInt(0) && Seq#Length(y#0) == LitInt(0);
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == LitInt(0);
    assume true;
    assume $Is(FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon16;

  anon19_Else:
    assume {:partition} !(Seq#Length(x#0) == LitInt(0) && Seq#Length(y#0) == LitInt(0));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Seq#Length(x#0) == LitInt(0);
    newtype$check#1 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 <= LitInt(1);
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == LitInt(-1);
    assume true;
    assume $Is(FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon16;

  anon20_Else:
    assume {:partition} Seq#Length(x#0) != LitInt(0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Seq#Length(y#0) == LitInt(0);
    newtype$check#2 := LitInt(1);
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 <= LitInt(1);
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == LitInt(1);
    assume true;
    assume $Is(FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon16;

  anon21_Else:
    assume {:partition} Seq#Length(y#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(y#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) < char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char);
    newtype$check#3 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 <= LitInt(1);
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == LitInt(-1);
    assume true;
    assume $Is(FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon16;

  anon22_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(y#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) > char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char);
    newtype$check#4 := LitInt(1);
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 <= LitInt(1);
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == LitInt(1);
    assume true;
    assume $Is(FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon16;

  anon23_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(y#0, LitInt(0))): char) >= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(x#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(y#0);
    ##x#0 := Seq#Drop(x#0, LitInt(1));
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    ##y#0 := Seq#Drop(y#0, LitInt(1));
    assume $IsAlloc(##y#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##x#0) < Seq#Rank(x#0) || (Seq#Rank(##x#0) == Seq#Rank(x#0) && Seq#Rank(##y#0) < Seq#Rank(y#0));
    assume FloatCompare.__default.StrCmp#canCall(Seq#Drop(x#0, LitInt(1)), Seq#Drop(y#0, LitInt(1)));
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == FloatCompare.__default.StrCmp($LS($LZ), Seq#Drop(x#0, LitInt(1)), Seq#Drop(y#0, LitInt(1)));
    assume FloatCompare.__default.StrCmp#canCall(Seq#Drop(x#0, LitInt(1)), Seq#Drop(y#0, LitInt(1)));
    assume $Is(FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon16;

  anon16:
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == ret#0;
    return;
}



procedure {:verboseName "FloatCompare.StrCmpSymmetric (well-formedness)"} CheckWellFormed$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.StrCmpSymmetric (well-formedness)"} CheckWellFormed$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq, y#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##y#0: Seq;
  var newtype$check#0: int;
  var ##x#1: Seq;
  var ##y#1: Seq;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.StrCmpSymmetric", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(132,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(133,24): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    ##y#0 := y#0;
    assume $IsAlloc(##y#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.StrCmp#canCall(x#0, y#0);
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    ##x#1 := y#0;
    assume $IsAlloc(##x#1, TSeq(TChar), $Heap);
    ##y#1 := x#0;
    assume $IsAlloc(##y#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.StrCmp#canCall(y#0, x#0);
    newtype$check#1 := 0 - FloatCompare.__default.StrCmp($LS($LZ), y#0, x#0);
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 <= LitInt(1);
    assume FloatCompare.__default.StrCmp($LS($LZ), x#0, y#0) == 0 - FloatCompare.__default.StrCmp($LS($LZ), y#0, x#0);
    return;
}



procedure {:verboseName "FloatCompare.StrCmpSymmetric (call precondtion)"} CallPre$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap));



procedure {:verboseName "FloatCompare.StrCmpSymmetric (call postcondition)"} CallPost$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures FloatCompare.__default.StrCmp#canCall(x#0, y#0) && FloatCompare.__default.StrCmp#canCall(y#0, x#0);
  free ensures {:id "id17527"} FloatCompare.__default.StrCmp($LS($LS($LZ)), x#0, y#0) == 0 - FloatCompare.__default.StrCmp($LS($LS($LZ)), y#0, x#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "FloatCompare.StrCmpSymmetric (correctness)"} Impl$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq where $Is(x#0, TSeq(TChar)) && $IsAlloc(x#0, TSeq(TChar), $Heap), y#0: Seq where $Is(y#0, TSeq(TChar)) && $IsAlloc(y#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures FloatCompare.__default.StrCmp#canCall(x#0, y#0) && FloatCompare.__default.StrCmp#canCall(y#0, x#0);
  free ensures {:id "id17528"} FloatCompare.__default.StrCmp($LS($LS($LZ)), x#0, y#0) == 0 - FloatCompare.__default.StrCmp($LS($LS($LZ)), y#0, x#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.StrCmpSymmetric (correctness)"} Impl$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq, y#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.StrCmpSymmetric", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(134,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#x0#0: Seq, $ih#y0#0: Seq :: $Is($ih#x0#0, TSeq(TChar)) && $Is($ih#y0#0, TSeq(TChar)) && Lit(true) && (Seq#Rank($ih#x0#0) < Seq#Rank(x#0) || (Seq#Rank($ih#x0#0) == Seq#Rank(x#0) && Seq#Rank($ih#y0#0) < Seq#Rank(y#0))) ==> FloatCompare.__default.StrCmp($LS($LZ), $ih#x0#0, $ih#y0#0) == 0 - FloatCompare.__default.StrCmp($LS($LZ), $ih#y0#0, $ih#x0#0));
    $_reverifyPost := false;
    return;
}



function FloatCompare.__default.AppendZeros(x#0: Seq, newLength#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq, newLength#0: int :: { FloatCompare.__default.AppendZeros(x#0, newLength#0) } FloatCompare.__default.AppendZeros#canCall(x#0, newLength#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && LitInt(0) <= newLength#0 && Seq#Length(x#0) < newLength#0) ==> Seq#Length(FloatCompare.__default.AppendZeros(x#0, newLength#0)) == newLength#0 && $Is(FloatCompare.__default.AppendZeros(x#0, newLength#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, x#0: Seq, newLength#0: int :: { FloatCompare.__default.AppendZeros(x#0, newLength#0), $IsGoodHeap($Heap) } FloatCompare.__default.AppendZeros#canCall(x#0, newLength#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(x#0, TSeq(TChar)) && LitInt(0) <= newLength#0 && Seq#Length(x#0) < newLength#0) ==> FloatCompare.__default.AppendZeros(x#0, newLength#0) == Seq#Append(x#0, Seq#Create(TChar, $Heap, newLength#0 - Seq#Length(x#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(Lit(char#FromInt(48)))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, x#0: Seq, newLength#0: int :: {:weight 3} { FloatCompare.__default.AppendZeros(Lit(x#0), LitInt(newLength#0)), $IsGoodHeap($Heap) } FloatCompare.__default.AppendZeros#canCall(Lit(x#0), LitInt(newLength#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(x#0, TSeq(TChar)) && LitInt(0) <= newLength#0 && Seq#Length(Lit(x#0)) < newLength#0) ==> FloatCompare.__default.AppendZeros(Lit(x#0), LitInt(newLength#0)) == Seq#Append(x#0, Seq#Create(TChar, $Heap, newLength#0 - Seq#Length(Lit(x#0)), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(Lit(char#FromInt(48)))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt)), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))));
}

function FloatCompare.__default.AppendZeros#canCall(x#0: Seq, newLength#0: int) : bool;

function FloatCompare.__default.AppendZeros#requires(Seq, int) : bool;

axiom (forall $Heap: Heap, x#0: Seq, newLength#0: int :: { FloatCompare.__default.AppendZeros#requires(x#0, newLength#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(x#0, TSeq(TChar)) && LitInt(0) <= newLength#0 ==> (FloatCompare.__default.AppendZeros#requires(x#0, newLength#0) <==> Seq#Length(x#0) < newLength#0));

procedure {:verboseName "FloatCompare.AppendZeros (well-formedness)"} CheckWellformed$$FloatCompare.__default.AppendZeros(x#0: Seq where $Is(x#0, TSeq(TChar)), newLength#0: int where LitInt(0) <= newLength#0) returns (ret#0: Seq where $Is(ret#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17529"} Seq#Length(ret#0) == newLength#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.AppendZeros (well-formedness)"} CheckWellformed$$FloatCompare.__default.AppendZeros(x#0: Seq, newLength#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: char;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.AppendZeros", " | ", x#0, " | ", newLength#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(137,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(x#0) < newLength#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(FloatCompare.__default.AppendZeros(x#0, newLength#0), TSeq(TChar));
    assume Seq#Length(ret#0) == newLength#0;
    assume false;
    return;

  anon8_Else:
    assume 0 <= newLength#0 - Seq#Length(x#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == Lit(char#FromInt(48));
    assume true;
    assume $Is(lambdaResult#0, TChar);
    goto anon6;

  anon10_Else:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon9_Else:
    goto anon7;

  anon7:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < newLength#0 - Seq#Length(x#0) ==> Requires1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Lit(char#FromInt(48)))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < newLength#0 - Seq#Length(x#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Lit(char#FromInt(48)))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume FloatCompare.__default.AppendZeros(x#0, newLength#0) == Seq#Append(x#0, Seq#Create(TChar, $Heap, newLength#0 - Seq#Length(x#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(Lit(char#FromInt(48)))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))));
    assume true;
    assume $Is(FloatCompare.__default.AppendZeros(x#0, newLength#0), TSeq(TChar));
    assume FloatCompare.__default.AppendZeros(x#0, newLength#0) == ret#0;
    assume b$reqreads#0;
    return;
}



function FloatCompare.__default.CompareFloatInner(x#0: Seq, y#0: Seq) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: { FloatCompare.__default.CompareFloatInner(x#0, y#0) } FloatCompare.__default.CompareFloatInner#canCall(x#0, y#0) || (3 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> LitInt(-1) <= FloatCompare.__default.CompareFloatInner(x#0, y#0) && FloatCompare.__default.CompareFloatInner(x#0, y#0) <= LitInt(1));
axiom 3 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: { FloatCompare.__default.CompareFloatInner(x#0, y#0) } FloatCompare.__default.CompareFloatInner#canCall(x#0, y#0) || (3 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> FloatCompare.__default.SplitExp#canCall(x#0) && (var xParts#0 := FloatCompare.__default.SplitExp(x#0); FloatCompare.__default.SplitExp#canCall(y#0) && (var yParts#0 := FloatCompare.__default.SplitExp(y#0); _System.Tuple2.___hMake2_q(xParts#0) && FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(xParts#0)): Seq) && (var xNum#0 := FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(xParts#0)): Seq); _System.Tuple2.___hMake2_q(yParts#0) && FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(yParts#0)): Seq) && (var yNum#0 := FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(yParts#0)): Seq); _System.Tuple2.___hMake2_q(xNum#0) && _System.Tuple2.___hMake2_q(xNum#0) && FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(xNum#0)): Seq, $Unbox(_System.Tuple2._1(xNum#0)): Seq)) && (var xDigits#0 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(xNum#0)): Seq, $Unbox(_System.Tuple2._1(xNum#0)): Seq)); _System.Tuple2.___hMake2_q(yNum#0) && _System.Tuple2.___hMake2_q(yNum#0) && FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(yNum#0)): Seq, $Unbox(_System.Tuple2._1(yNum#0)): Seq)) && (var yDigits#0 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(yNum#0)): Seq, $Unbox(_System.Tuple2._1(yNum#0)): Seq)); _System.Tuple2.___hMake2_q(xParts#0) && _System.Tuple2.___hMake2_q(xNum#0) && (var xExp#0 := $Unbox(_System.Tuple2._1(xParts#0)): int - Seq#Length($Unbox(_System.Tuple2._1(xNum#0)): Seq); _System.Tuple2.___hMake2_q(yParts#0) && _System.Tuple2.___hMake2_q(yNum#0) && (var yExp#0 := $Unbox(_System.Tuple2._1(yParts#0)): int - Seq#Length($Unbox(_System.Tuple2._1(yNum#0)): Seq); (var logX#0 := xExp#0 + Seq#Length(xDigits#0); (var logY#0 := yExp#0 + Seq#Length(yDigits#0); logY#0 >= logX#0 ==> logX#0 >= logY#0 ==> (Seq#Length(xDigits#0) < Seq#Length(yDigits#0) ==> FloatCompare.__default.AppendZeros#canCall(xDigits#0, Seq#Length(yDigits#0)) && FloatCompare.__default.StrCmp#canCall(FloatCompare.__default.AppendZeros(xDigits#0, Seq#Length(yDigits#0)), yDigits#0)) && (Seq#Length(yDigits#0) <= Seq#Length(xDigits#0) ==> (Seq#Length(yDigits#0) < Seq#Length(xDigits#0) ==> FloatCompare.__default.AppendZeros#canCall(yDigits#0, Seq#Length(xDigits#0)) && FloatCompare.__default.StrCmp#canCall(xDigits#0, FloatCompare.__default.AppendZeros(yDigits#0, Seq#Length(xDigits#0)))) && (Seq#Length(xDigits#0) <= Seq#Length(yDigits#0) ==> FloatCompare.__default.StrCmp#canCall(xDigits#0, yDigits#0))))))))))))) && FloatCompare.__default.CompareFloatInner(x#0, y#0) == (var xParts#0 := FloatCompare.__default.SplitExp(x#0); (var yParts#0 := FloatCompare.__default.SplitExp(y#0); (var xNum#0 := FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(xParts#0)): Seq); (var yNum#0 := FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(yParts#0)): Seq); (var xDigits#0 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(xNum#0)): Seq, $Unbox(_System.Tuple2._1(xNum#0)): Seq)); (var yDigits#0 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(yNum#0)): Seq, $Unbox(_System.Tuple2._1(yNum#0)): Seq)); (var xExp#0 := $Unbox(_System.Tuple2._1(xParts#0)): int - Seq#Length($Unbox(_System.Tuple2._1(xNum#0)): Seq); (var yExp#0 := $Unbox(_System.Tuple2._1(yParts#0)): int - Seq#Length($Unbox(_System.Tuple2._1(yNum#0)): Seq); (var logX#0 := xExp#0 + Seq#Length(xDigits#0); (var logY#0 := yExp#0 + Seq#Length(yDigits#0); (if logX#0 > logY#0 then 1 else (if logY#0 > logX#0 then -1 else (if Seq#Length(xDigits#0) < Seq#Length(yDigits#0) then FloatCompare.__default.StrCmp($LS($LZ), FloatCompare.__default.AppendZeros(xDigits#0, Seq#Length(yDigits#0)), yDigits#0) else (if Seq#Length(yDigits#0) < Seq#Length(xDigits#0) then FloatCompare.__default.StrCmp($LS($LZ), xDigits#0, FloatCompare.__default.AppendZeros(yDigits#0, Seq#Length(xDigits#0))) else FloatCompare.__default.StrCmp($LS($LZ), xDigits#0, yDigits#0))))))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: {:weight 3} { FloatCompare.__default.CompareFloatInner(Lit(x#0), Lit(y#0)) } FloatCompare.__default.CompareFloatInner#canCall(Lit(x#0), Lit(y#0)) || (3 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> FloatCompare.__default.SplitExp#canCall(Lit(x#0)) && (var xParts#1 := Lit(FloatCompare.__default.SplitExp(Lit(x#0))); FloatCompare.__default.SplitExp#canCall(Lit(y#0)) && (var yParts#1 := Lit(FloatCompare.__default.SplitExp(Lit(y#0))); _System.Tuple2.___hMake2_q(xParts#1) && FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(xParts#1)): Seq) && (var xNum#1 := FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(xParts#1)): Seq); _System.Tuple2.___hMake2_q(yParts#1) && FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(yParts#1)): Seq) && (var yNum#1 := FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(yParts#1)): Seq); _System.Tuple2.___hMake2_q(xNum#1) && _System.Tuple2.___hMake2_q(xNum#1) && FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(xNum#1)): Seq, $Unbox(_System.Tuple2._1(xNum#1)): Seq)) && (var xDigits#1 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(xNum#1)): Seq, $Unbox(_System.Tuple2._1(xNum#1)): Seq)); _System.Tuple2.___hMake2_q(yNum#1) && _System.Tuple2.___hMake2_q(yNum#1) && FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(yNum#1)): Seq, $Unbox(_System.Tuple2._1(yNum#1)): Seq)) && (var yDigits#1 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(yNum#1)): Seq, $Unbox(_System.Tuple2._1(yNum#1)): Seq)); _System.Tuple2.___hMake2_q(xParts#1) && _System.Tuple2.___hMake2_q(xNum#1) && (var xExp#1 := $Unbox(_System.Tuple2._1(xParts#1)): int - Seq#Length($Unbox(_System.Tuple2._1(xNum#1)): Seq); _System.Tuple2.___hMake2_q(yParts#1) && _System.Tuple2.___hMake2_q(yNum#1) && (var yExp#1 := $Unbox(_System.Tuple2._1(yParts#1)): int - Seq#Length($Unbox(_System.Tuple2._1(yNum#1)): Seq); (var logX#1 := xExp#1 + Seq#Length(xDigits#1); (var logY#1 := yExp#1 + Seq#Length(yDigits#1); logY#1 >= logX#1 ==> logX#1 >= logY#1 ==> (Seq#Length(xDigits#1) < Seq#Length(yDigits#1) ==> FloatCompare.__default.AppendZeros#canCall(xDigits#1, Seq#Length(yDigits#1)) && FloatCompare.__default.StrCmp#canCall(FloatCompare.__default.AppendZeros(xDigits#1, Seq#Length(yDigits#1)), yDigits#1)) && (Seq#Length(yDigits#1) <= Seq#Length(xDigits#1) ==> (Seq#Length(yDigits#1) < Seq#Length(xDigits#1) ==> FloatCompare.__default.AppendZeros#canCall(yDigits#1, Seq#Length(xDigits#1)) && FloatCompare.__default.StrCmp#canCall(xDigits#1, FloatCompare.__default.AppendZeros(yDigits#1, Seq#Length(xDigits#1)))) && (Seq#Length(xDigits#1) <= Seq#Length(yDigits#1) ==> FloatCompare.__default.StrCmp#canCall(xDigits#1, yDigits#1))))))))))))) && FloatCompare.__default.CompareFloatInner(Lit(x#0), Lit(y#0)) == (var xParts#1 := Lit(FloatCompare.__default.SplitExp(Lit(x#0))); (var yParts#1 := Lit(FloatCompare.__default.SplitExp(Lit(y#0))); (var xNum#1 := Lit(FloatCompare.__default.SplitDot(Lit($Unbox(_System.Tuple2._0(xParts#1)): Seq))); (var yNum#1 := Lit(FloatCompare.__default.SplitDot(Lit($Unbox(_System.Tuple2._0(yParts#1)): Seq))); (var xDigits#1 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(xNum#1)): Seq, $Unbox(_System.Tuple2._1(xNum#1)): Seq)); (var yDigits#1 := FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(yNum#1)): Seq, $Unbox(_System.Tuple2._1(yNum#1)): Seq)); (var xExp#1 := $Unbox(_System.Tuple2._1(xParts#1)): int - Seq#Length(Lit($Unbox(_System.Tuple2._1(xNum#1)): Seq)); (var yExp#1 := $Unbox(_System.Tuple2._1(yParts#1)): int - Seq#Length(Lit($Unbox(_System.Tuple2._1(yNum#1)): Seq)); (var logX#1 := xExp#1 + Seq#Length(xDigits#1); (var logY#1 := yExp#1 + Seq#Length(yDigits#1); (if logX#1 > logY#1 then 1 else (if logY#1 > logX#1 then -1 else (if Seq#Length(xDigits#1) < Seq#Length(yDigits#1) then FloatCompare.__default.StrCmp($LS($LZ), FloatCompare.__default.AppendZeros(xDigits#1, Seq#Length(yDigits#1)), yDigits#1) else (if Seq#Length(yDigits#1) < Seq#Length(xDigits#1) then FloatCompare.__default.StrCmp($LS($LZ), xDigits#1, FloatCompare.__default.AppendZeros(yDigits#1, Seq#Length(xDigits#1))) else FloatCompare.__default.StrCmp($LS($LZ), xDigits#1, yDigits#1))))))))))))))));
}

function FloatCompare.__default.CompareFloatInner#canCall(x#0: Seq, y#0: Seq) : bool;

function FloatCompare.__default.CompareFloatInner#requires(Seq, Seq) : bool;

axiom (forall x#0: Seq, y#0: Seq :: { FloatCompare.__default.CompareFloatInner#requires(x#0, y#0) } $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar)) ==> (FloatCompare.__default.CompareFloatInner#requires(x#0, y#0) <==> true));

procedure {:verboseName "FloatCompare.CompareFloatInner (well-formedness)"} CheckWellformed$$FloatCompare.__default.CompareFloatInner(x#0: Seq where $Is(x#0, TSeq(TChar)), y#0: Seq where $Is(y#0, TSeq(TChar))) returns (ret#0: int where LitInt(-1) <= ret#0 && ret#0 <= LitInt(1));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.CompareFloatInner (well-formedness)"} CheckWellformed$$FloatCompare.__default.CompareFloatInner(x#0: Seq, y#0: Seq) returns (ret#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var xParts#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##x#0: Seq;
  var yParts#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##x#1: Seq;
  var xNum#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##x#2: Seq;
  var yNum#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##x#3: Seq;
  var xDigits#Z#0: Seq;
  var let#4#0#0: Seq;
  var ##val#0: Seq;
  var yDigits#Z#0: Seq;
  var let#5#0#0: Seq;
  var ##val#1: Seq;
  var xExp#Z#0: int;
  var let#6#0#0: int;
  var yExp#Z#0: int;
  var let#7#0#0: int;
  var logX#Z#0: int;
  var let#8#0#0: int;
  var logY#Z#0: int;
  var let#9#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##x#4: Seq;
  var ##newLength#0: int;
  var ##x#5: Seq;
  var ##y#0: Seq;
  var ##x#6: Seq;
  var ##newLength#1: int;
  var ##x#7: Seq;
  var ##y#1: Seq;
  var ##x#8: Seq;
  var ##y#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.CompareFloatInner", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(145,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume LitInt(-1) <= FloatCompare.__default.CompareFloatInner(x#0, y#0) && FloatCompare.__default.CompareFloatInner(x#0, y#0) <= LitInt(1);
    assume false;
    return;

  anon13_Else:
    havoc xParts#Z#0;
    assume $Is(xParts#Z#0, Tclass._System.Tuple2(TSeq(TChar), TInt)) && $IsAlloc(xParts#Z#0, Tclass._System.Tuple2(TSeq(TChar), TInt), $Heap);
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SplitExp#canCall(x#0);
    assume _System.Tuple2.___hMake2_q(FloatCompare.__default.SplitExp(x#0));
    assume let#0#0#0 == FloatCompare.__default.SplitExp(x#0);
    assume FloatCompare.__default.SplitExp#canCall(x#0);
    assume $Is(let#0#0#0, Tclass._System.Tuple2(TSeq(TChar), TInt));
    assume xParts#Z#0 == let#0#0#0;
    havoc yParts#Z#0;
    assume $Is(yParts#Z#0, Tclass._System.Tuple2(TSeq(TChar), TInt)) && $IsAlloc(yParts#Z#0, Tclass._System.Tuple2(TSeq(TChar), TInt), $Heap);
    ##x#1 := y#0;
    assume $IsAlloc(##x#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SplitExp#canCall(y#0);
    assume _System.Tuple2.___hMake2_q(FloatCompare.__default.SplitExp(y#0));
    assume let#1#0#0 == FloatCompare.__default.SplitExp(y#0);
    assume FloatCompare.__default.SplitExp#canCall(y#0);
    assume $Is(let#1#0#0, Tclass._System.Tuple2(TSeq(TChar), TInt));
    assume yParts#Z#0 == let#1#0#0;
    havoc xNum#Z#0;
    assume $Is(xNum#Z#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))) && $IsAlloc(xNum#Z#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)), $Heap);
    assume _System.Tuple2.___hMake2_q(xParts#Z#0);
    ##x#2 := $Unbox(_System.Tuple2._0(xParts#Z#0)): Seq;
    assume $IsAlloc(##x#2, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(xParts#Z#0)): Seq);
    assume _System.Tuple2.___hMake2_q(FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(xParts#Z#0)): Seq));
    assume let#2#0#0 == FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(xParts#Z#0)): Seq);
    assume _System.Tuple2.___hMake2_q(xParts#Z#0) && FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(xParts#Z#0)): Seq);
    assume $Is(let#2#0#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)));
    assume xNum#Z#0 == let#2#0#0;
    havoc yNum#Z#0;
    assume $Is(yNum#Z#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar))) && $IsAlloc(yNum#Z#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)), $Heap);
    assume _System.Tuple2.___hMake2_q(yParts#Z#0);
    ##x#3 := $Unbox(_System.Tuple2._0(yParts#Z#0)): Seq;
    assume $IsAlloc(##x#3, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(yParts#Z#0)): Seq);
    assume _System.Tuple2.___hMake2_q(FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(yParts#Z#0)): Seq));
    assume let#3#0#0 == FloatCompare.__default.SplitDot($Unbox(_System.Tuple2._0(yParts#Z#0)): Seq);
    assume _System.Tuple2.___hMake2_q(yParts#Z#0) && FloatCompare.__default.SplitDot#canCall($Unbox(_System.Tuple2._0(yParts#Z#0)): Seq);
    assume $Is(let#3#0#0, Tclass._System.Tuple2(TSeq(TChar), TSeq(TChar)));
    assume yNum#Z#0 == let#3#0#0;
    havoc xDigits#Z#0;
    assume $Is(xDigits#Z#0, TSeq(TChar)) && $IsAlloc(xDigits#Z#0, TSeq(TChar), $Heap);
    assume _System.Tuple2.___hMake2_q(xNum#Z#0);
    assume _System.Tuple2.___hMake2_q(xNum#Z#0);
    ##val#0 := Seq#Append($Unbox(_System.Tuple2._0(xNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(xNum#Z#0)): Seq);
    assume $IsAlloc(##val#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(xNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(xNum#Z#0)): Seq));
    assume let#4#0#0 == FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(xNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(xNum#Z#0)): Seq));
    assume _System.Tuple2.___hMake2_q(xNum#Z#0) && _System.Tuple2.___hMake2_q(xNum#Z#0) && FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(xNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(xNum#Z#0)): Seq));
    assume $Is(let#4#0#0, TSeq(TChar));
    assume xDigits#Z#0 == let#4#0#0;
    havoc yDigits#Z#0;
    assume $Is(yDigits#Z#0, TSeq(TChar)) && $IsAlloc(yDigits#Z#0, TSeq(TChar), $Heap);
    assume _System.Tuple2.___hMake2_q(yNum#Z#0);
    assume _System.Tuple2.___hMake2_q(yNum#Z#0);
    ##val#1 := Seq#Append($Unbox(_System.Tuple2._0(yNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(yNum#Z#0)): Seq);
    assume $IsAlloc(##val#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(yNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(yNum#Z#0)): Seq));
    assume let#5#0#0 == FloatCompare.__default.SkipLeadingZeros($LS($LZ), Seq#Append($Unbox(_System.Tuple2._0(yNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(yNum#Z#0)): Seq));
    assume _System.Tuple2.___hMake2_q(yNum#Z#0) && _System.Tuple2.___hMake2_q(yNum#Z#0) && FloatCompare.__default.SkipLeadingZeros#canCall(Seq#Append($Unbox(_System.Tuple2._0(yNum#Z#0)): Seq, $Unbox(_System.Tuple2._1(yNum#Z#0)): Seq));
    assume $Is(let#5#0#0, TSeq(TChar));
    assume yDigits#Z#0 == let#5#0#0;
    havoc xExp#Z#0;
    assume true;
    assume _System.Tuple2.___hMake2_q(xParts#Z#0);
    assume _System.Tuple2.___hMake2_q(xNum#Z#0);
    assume let#6#0#0 == $Unbox(_System.Tuple2._1(xParts#Z#0)): int - Seq#Length($Unbox(_System.Tuple2._1(xNum#Z#0)): Seq);
    assume _System.Tuple2.___hMake2_q(xParts#Z#0) && _System.Tuple2.___hMake2_q(xNum#Z#0);
    assume $Is(let#6#0#0, TInt);
    assume xExp#Z#0 == let#6#0#0;
    havoc yExp#Z#0;
    assume true;
    assume _System.Tuple2.___hMake2_q(yParts#Z#0);
    assume _System.Tuple2.___hMake2_q(yNum#Z#0);
    assume let#7#0#0 == $Unbox(_System.Tuple2._1(yParts#Z#0)): int - Seq#Length($Unbox(_System.Tuple2._1(yNum#Z#0)): Seq);
    assume _System.Tuple2.___hMake2_q(yParts#Z#0) && _System.Tuple2.___hMake2_q(yNum#Z#0);
    assume $Is(let#7#0#0, TInt);
    assume yExp#Z#0 == let#7#0#0;
    havoc logX#Z#0;
    assume true;
    assume let#8#0#0 == xExp#Z#0 + Seq#Length(xDigits#Z#0);
    assume true;
    assume $Is(let#8#0#0, TInt);
    assume logX#Z#0 == let#8#0#0;
    havoc logY#Z#0;
    assume true;
    assume let#9#0#0 == yExp#Z#0 + Seq#Length(yDigits#Z#0);
    assume true;
    assume $Is(let#9#0#0, TInt);
    assume logY#Z#0 == let#9#0#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} logX#Z#0 > logY#Z#0;
    newtype$check#0 := LitInt(1);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    assume FloatCompare.__default.CompareFloatInner(x#0, y#0) == LitInt(1);
    assume true;
    assume $Is(FloatCompare.__default.CompareFloatInner(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon14_Else:
    assume {:partition} logY#Z#0 >= logX#Z#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} logY#Z#0 > logX#Z#0;
    newtype$check#1 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 <= LitInt(1);
    assume FloatCompare.__default.CompareFloatInner(x#0, y#0) == LitInt(-1);
    assume true;
    assume $Is(FloatCompare.__default.CompareFloatInner(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon15_Else:
    assume {:partition} logX#Z#0 >= logY#Z#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(xDigits#Z#0) < Seq#Length(yDigits#Z#0);
    ##x#4 := xDigits#Z#0;
    assume $IsAlloc(##x#4, TSeq(TChar), $Heap);
    assume $Is(Seq#Length(yDigits#Z#0), Tclass._System.nat());
    ##newLength#0 := Seq#Length(yDigits#Z#0);
    assume $IsAlloc(##newLength#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} Seq#Length(##x#4) < ##newLength#0;
    assume Seq#Length(##x#4) < ##newLength#0;
    assume FloatCompare.__default.AppendZeros#canCall(xDigits#Z#0, Seq#Length(yDigits#Z#0));
    ##x#5 := FloatCompare.__default.AppendZeros(xDigits#Z#0, Seq#Length(yDigits#Z#0));
    assume $IsAlloc(##x#5, TSeq(TChar), $Heap);
    ##y#0 := yDigits#Z#0;
    assume $IsAlloc(##y#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.StrCmp#canCall(FloatCompare.__default.AppendZeros(xDigits#Z#0, Seq#Length(yDigits#Z#0)), yDigits#Z#0);
    assume FloatCompare.__default.CompareFloatInner(x#0, y#0) == FloatCompare.__default.StrCmp($LS($LZ), FloatCompare.__default.AppendZeros(xDigits#Z#0, Seq#Length(yDigits#Z#0)), yDigits#Z#0);
    assume FloatCompare.__default.AppendZeros#canCall(xDigits#Z#0, Seq#Length(yDigits#Z#0)) && FloatCompare.__default.StrCmp#canCall(FloatCompare.__default.AppendZeros(xDigits#Z#0, Seq#Length(yDigits#Z#0)), yDigits#Z#0);
    assume $Is(FloatCompare.__default.CompareFloatInner(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon16_Else:
    assume {:partition} Seq#Length(yDigits#Z#0) <= Seq#Length(xDigits#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Length(yDigits#Z#0) < Seq#Length(xDigits#Z#0);
    ##x#6 := yDigits#Z#0;
    assume $IsAlloc(##x#6, TSeq(TChar), $Heap);
    assume $Is(Seq#Length(xDigits#Z#0), Tclass._System.nat());
    ##newLength#1 := Seq#Length(xDigits#Z#0);
    assume $IsAlloc(##newLength#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} Seq#Length(##x#6) < ##newLength#1;
    assume Seq#Length(##x#6) < ##newLength#1;
    assume FloatCompare.__default.AppendZeros#canCall(yDigits#Z#0, Seq#Length(xDigits#Z#0));
    ##x#7 := xDigits#Z#0;
    assume $IsAlloc(##x#7, TSeq(TChar), $Heap);
    ##y#1 := FloatCompare.__default.AppendZeros(yDigits#Z#0, Seq#Length(xDigits#Z#0));
    assume $IsAlloc(##y#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.StrCmp#canCall(xDigits#Z#0, FloatCompare.__default.AppendZeros(yDigits#Z#0, Seq#Length(xDigits#Z#0)));
    assume FloatCompare.__default.CompareFloatInner(x#0, y#0) == FloatCompare.__default.StrCmp($LS($LZ), xDigits#Z#0, FloatCompare.__default.AppendZeros(yDigits#Z#0, Seq#Length(xDigits#Z#0)));
    assume FloatCompare.__default.AppendZeros#canCall(yDigits#Z#0, Seq#Length(xDigits#Z#0)) && FloatCompare.__default.StrCmp#canCall(xDigits#Z#0, FloatCompare.__default.AppendZeros(yDigits#Z#0, Seq#Length(xDigits#Z#0)));
    assume $Is(FloatCompare.__default.CompareFloatInner(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon17_Else:
    assume {:partition} Seq#Length(xDigits#Z#0) <= Seq#Length(yDigits#Z#0);
    ##x#8 := xDigits#Z#0;
    assume $IsAlloc(##x#8, TSeq(TChar), $Heap);
    ##y#2 := yDigits#Z#0;
    assume $IsAlloc(##y#2, TSeq(TChar), $Heap);
    assume FloatCompare.__default.StrCmp#canCall(xDigits#Z#0, yDigits#Z#0);
    assume FloatCompare.__default.CompareFloatInner(x#0, y#0) == FloatCompare.__default.StrCmp($LS($LZ), xDigits#Z#0, yDigits#Z#0);
    assume FloatCompare.__default.StrCmp#canCall(xDigits#Z#0, yDigits#Z#0);
    assume $Is(FloatCompare.__default.CompareFloatInner(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon12:
    assume FloatCompare.__default.CompareFloatInner(x#0, y#0) == ret#0;
    return;
}



function FloatCompare.__default.IsNegative(x#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.IsNegative(x#0) } FloatCompare.__default.IsNegative#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> (FloatCompare.__default.IsNegative(x#0) <==> Seq#Length(x#0) > 0 && $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(45))));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.IsNegative(Lit(x#0)) } FloatCompare.__default.IsNegative#canCall(Lit(x#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> (FloatCompare.__default.IsNegative(Lit(x#0)) <==> Seq#Length(Lit(x#0)) > 0 && $Unbox(Seq#Index(Lit(x#0), LitInt(0))): char == Lit(char#FromInt(45))));
}

function FloatCompare.__default.IsNegative#canCall(x#0: Seq) : bool;

function FloatCompare.__default.IsNegative#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.IsNegative#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.IsNegative#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.IsNegative (well-formedness)"} CheckWellformed$$FloatCompare.__default.IsNegative(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.IsNegative (well-formedness)"} CheckWellformed$$FloatCompare.__default.IsNegative(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.IsNegative", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(185,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(x#0) > 0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    goto anon5;

  anon7_Else:
    assume {:partition} 0 >= Seq#Length(x#0);
    goto anon5;

  anon5:
    assume FloatCompare.__default.IsNegative(x#0) <==> Seq#Length(x#0) > 0 && $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(45));
    assume true;
    assume $Is(FloatCompare.__default.IsNegative(x#0), TBool);
    return;
}



function FloatCompare.__default.SkipLeadingPlus(x#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SkipLeadingPlus(x#0) } FloatCompare.__default.SkipLeadingPlus#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> $Is(FloatCompare.__default.SkipLeadingPlus(x#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.SkipLeadingPlus(x#0) } FloatCompare.__default.SkipLeadingPlus#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.SkipLeadingPlus(x#0) == (if 0 < Seq#Length(x#0) && $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(43)) then Seq#Drop(x#0, LitInt(1)) else x#0));
axiom 0 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.SkipLeadingPlus(Lit(x#0)) } FloatCompare.__default.SkipLeadingPlus#canCall(Lit(x#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.SkipLeadingPlus(Lit(x#0)) == (if 0 < Seq#Length(Lit(x#0)) && $Unbox(Seq#Index(Lit(x#0), LitInt(0))): char == Lit(char#FromInt(43)) then Seq#Drop(Lit(x#0), LitInt(1)) else x#0));
}

function FloatCompare.__default.SkipLeadingPlus#canCall(x#0: Seq) : bool;

function FloatCompare.__default.SkipLeadingPlus#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.SkipLeadingPlus#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.SkipLeadingPlus#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.SkipLeadingPlus (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipLeadingPlus(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.SkipLeadingPlus (well-formedness)"} CheckWellformed$$FloatCompare.__default.SkipLeadingPlus(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.SkipLeadingPlus", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(191,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(FloatCompare.__default.SkipLeadingPlus(x#0), TSeq(TChar));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} 0 < Seq#Length(x#0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    goto anon5;

  anon9_Else:
    assume {:partition} Seq#Length(x#0) <= 0;
    goto anon5;

  anon5:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} 0 < Seq#Length(x#0) && $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(43));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(x#0);
    assume FloatCompare.__default.SkipLeadingPlus(x#0) == Seq#Drop(x#0, LitInt(1));
    assume true;
    assume $Is(FloatCompare.__default.SkipLeadingPlus(x#0), TSeq(TChar));
    return;

  anon10_Else:
    assume {:partition} !(0 < Seq#Length(x#0) && $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(43)));
    assume FloatCompare.__default.SkipLeadingPlus(x#0) == x#0;
    assume true;
    assume $Is(FloatCompare.__default.SkipLeadingPlus(x#0), TSeq(TChar));
    return;
}



function FloatCompare.__default.IsZero($ly: LayerType, x#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq :: { FloatCompare.__default.IsZero($LS($ly), x#0) } FloatCompare.__default.IsZero#canCall(x#0) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> (Seq#Length(x#0) != LitInt(0) ==> $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(48)) || $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(46)) ==> FloatCompare.__default.IsZero#canCall(Seq#Drop(x#0, LitInt(1)))) && (FloatCompare.__default.IsZero($LS($ly), x#0) <==> (if Seq#Length(x#0) == LitInt(0) then true else (if $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(48)) || $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(46)) then FloatCompare.__default.IsZero($ly, Seq#Drop(x#0, LitInt(1))) else (if char#ToInt(Lit(char#FromInt(49))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) then false else true)))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, x#0: Seq :: {:weight 3} { FloatCompare.__default.IsZero($LS($ly), Lit(x#0)) } FloatCompare.__default.IsZero#canCall(Lit(x#0)) || (0 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> (Seq#Length(Lit(x#0)) != LitInt(0) ==> $Unbox(Seq#Index(Lit(x#0), LitInt(0))): char == Lit(char#FromInt(48)) || $Unbox(Seq#Index(Lit(x#0), LitInt(0))): char == Lit(char#FromInt(46)) ==> FloatCompare.__default.IsZero#canCall(Lit(Seq#Drop(Lit(x#0), LitInt(1))))) && (FloatCompare.__default.IsZero($LS($ly), Lit(x#0)) <==> (if Seq#Length(Lit(x#0)) == LitInt(0) then true else (if $Unbox(Seq#Index(Lit(x#0), LitInt(0))): char == Lit(char#FromInt(48)) || $Unbox(Seq#Index(Lit(x#0), LitInt(0))): char == Lit(char#FromInt(46)) then FloatCompare.__default.IsZero($LS($ly), Lit(Seq#Drop(Lit(x#0), LitInt(1)))) else (if char#ToInt(Lit(char#FromInt(49))) <= char#ToInt($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Lit(x#0), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))) then false else true)))));
}

function FloatCompare.__default.IsZero#canCall(x#0: Seq) : bool;

axiom (forall $ly: LayerType, x#0: Seq :: { FloatCompare.__default.IsZero($LS($ly), x#0) } FloatCompare.__default.IsZero($LS($ly), x#0) <==> FloatCompare.__default.IsZero($ly, x#0));

axiom (forall $ly: LayerType, x#0: Seq :: { FloatCompare.__default.IsZero(AsFuelBottom($ly), x#0) } FloatCompare.__default.IsZero($ly, x#0) <==> FloatCompare.__default.IsZero($LZ, x#0));

function FloatCompare.__default.IsZero#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, x#0: Seq :: { FloatCompare.__default.IsZero#requires($ly, x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.IsZero#requires($ly, x#0) <==> true));

procedure {:verboseName "FloatCompare.IsZero (well-formedness)"} CheckWellformed$$FloatCompare.__default.IsZero(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.IsZero (well-formedness)"} CheckWellformed$$FloatCompare.__default.IsZero(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.IsZero", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(201,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(x#0) == LitInt(0);
    assume FloatCompare.__default.IsZero($LS($LZ), x#0) <==> Lit(true);
    assume true;
    assume $Is(FloatCompare.__default.IsZero($LS($LZ), x#0), TBool);
    return;

  anon15_Else:
    assume {:partition} Seq#Length(x#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} $Unbox(Seq#Index(x#0, LitInt(0))): char != Lit(char#FromInt(48));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    goto anon7;

  anon16_Else:
    assume {:partition} $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(48));
    goto anon7;

  anon7:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(48)) || $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(46));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(x#0);
    ##x#0 := Seq#Drop(x#0, LitInt(1));
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume Seq#Rank(##x#0) < Seq#Rank(x#0);
    assume FloatCompare.__default.IsZero#canCall(Seq#Drop(x#0, LitInt(1)));
    assume FloatCompare.__default.IsZero($LS($LZ), x#0) <==> FloatCompare.__default.IsZero($LS($LZ), Seq#Drop(x#0, LitInt(1)));
    assume FloatCompare.__default.IsZero#canCall(Seq#Drop(x#0, LitInt(1)));
    assume $Is(FloatCompare.__default.IsZero($LS($LZ), x#0), TBool);
    return;

  anon17_Else:
    assume {:partition} !($Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(48)) || $Unbox(Seq#Index(x#0, LitInt(0))): char == Lit(char#FromInt(46)));
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(49))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(x#0);
    goto anon11;

  anon18_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) < char#ToInt(Lit(char#FromInt(49)));
    goto anon11;

  anon11:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(49))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)));
    assume FloatCompare.__default.IsZero($LS($LZ), x#0) <==> Lit(false);
    assume true;
    assume $Is(FloatCompare.__default.IsZero($LS($LZ), x#0), TBool);
    return;

  anon19_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(49))) <= char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(x#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57))));
    assume FloatCompare.__default.IsZero($LS($LZ), x#0) <==> Lit(true);
    assume true;
    assume $Is(FloatCompare.__default.IsZero($LS($LZ), x#0), TBool);
    return;
}



function FloatCompare.__default.RecognizeZero(x#0: Seq) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.RecognizeZero(x#0) } FloatCompare.__default.RecognizeZero#canCall(x#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> $Is(FloatCompare.__default.RecognizeZero(x#0), TSeq(TChar)));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.RecognizeZero(x#0) } FloatCompare.__default.RecognizeZero#canCall(x#0) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.IsNegative#canCall(x#0) && (FloatCompare.__default.IsNegative(x#0) ==> FloatCompare.__default.IsZero#canCall(Seq#Drop(x#0, LitInt(1)))) && (!FloatCompare.__default.IsNegative(x#0) ==> FloatCompare.__default.IsZero#canCall(x#0)) && FloatCompare.__default.RecognizeZero(x#0) == (if FloatCompare.__default.IsNegative(x#0) then (if FloatCompare.__default.IsZero($LS($LZ), Seq#Drop(x#0, LitInt(1))) then Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))) else x#0) else (if FloatCompare.__default.IsZero($LS($LZ), x#0) then Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))) else x#0)));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.RecognizeZero(Lit(x#0)) } FloatCompare.__default.RecognizeZero#canCall(Lit(x#0)) || (1 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.IsNegative#canCall(Lit(x#0)) && (Lit(FloatCompare.__default.IsNegative(Lit(x#0))) ==> FloatCompare.__default.IsZero#canCall(Lit(Seq#Drop(Lit(x#0), LitInt(1))))) && (!Lit(FloatCompare.__default.IsNegative(Lit(x#0))) ==> FloatCompare.__default.IsZero#canCall(Lit(x#0))) && FloatCompare.__default.RecognizeZero(Lit(x#0)) == (if FloatCompare.__default.IsNegative(Lit(x#0)) then (if FloatCompare.__default.IsZero($LS($LZ), Lit(Seq#Drop(Lit(x#0), LitInt(1)))) then Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))) else x#0) else (if FloatCompare.__default.IsZero($LS($LZ), Lit(x#0)) then Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))) else x#0)));
}

function FloatCompare.__default.RecognizeZero#canCall(x#0: Seq) : bool;

function FloatCompare.__default.RecognizeZero#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.RecognizeZero#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.RecognizeZero#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.RecognizeZero (well-formedness)"} CheckWellformed$$FloatCompare.__default.RecognizeZero(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.RecognizeZero (well-formedness)"} CheckWellformed$$FloatCompare.__default.RecognizeZero(x#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: Seq;
  var ##x#1: Seq;
  var ##x#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.RecognizeZero", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(214,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(FloatCompare.__default.RecognizeZero(x#0), TSeq(TChar));
    assume false;
    return;

  anon10_Else:
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsNegative#canCall(x#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} FloatCompare.__default.IsNegative(x#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(x#0);
    ##x#1 := Seq#Drop(x#0, LitInt(1));
    assume $IsAlloc(##x#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsZero#canCall(Seq#Drop(x#0, LitInt(1)));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} FloatCompare.__default.IsZero($LS($LZ), Seq#Drop(x#0, LitInt(1)));
    assume FloatCompare.__default.RecognizeZero(x#0) == Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))));
    assume true;
    assume $Is(FloatCompare.__default.RecognizeZero(x#0), TSeq(TChar));
    return;

  anon12_Else:
    assume {:partition} !FloatCompare.__default.IsZero($LS($LZ), Seq#Drop(x#0, LitInt(1)));
    assume FloatCompare.__default.RecognizeZero(x#0) == x#0;
    assume true;
    assume $Is(FloatCompare.__default.RecognizeZero(x#0), TSeq(TChar));
    return;

  anon11_Else:
    assume {:partition} !FloatCompare.__default.IsNegative(x#0);
    ##x#2 := x#0;
    assume $IsAlloc(##x#2, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsZero#canCall(x#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} FloatCompare.__default.IsZero($LS($LZ), x#0);
    assume FloatCompare.__default.RecognizeZero(x#0) == Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))));
    assume true;
    assume $Is(FloatCompare.__default.RecognizeZero(x#0), TSeq(TChar));
    return;

  anon13_Else:
    assume {:partition} !FloatCompare.__default.IsZero($LS($LZ), x#0);
    assume FloatCompare.__default.RecognizeZero(x#0) == x#0;
    assume true;
    assume $Is(FloatCompare.__default.RecognizeZero(x#0), TSeq(TChar));
    return;
}



function FloatCompare.__default.CleanNumber(x#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.CleanNumber(x#0) } FloatCompare.__default.CleanNumber#canCall(x#0) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> $Is(FloatCompare.__default.CleanNumber(x#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: { FloatCompare.__default.CleanNumber(x#0) } FloatCompare.__default.CleanNumber#canCall(x#0) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.SkipLeadingSpace#canCall(x#0) && FloatCompare.__default.SkipLeadingPlus#canCall(FloatCompare.__default.SkipLeadingSpace($LS($LZ), x#0)) && FloatCompare.__default.RecognizeZero#canCall(FloatCompare.__default.SkipLeadingPlus(FloatCompare.__default.SkipLeadingSpace($LS($LZ), x#0))) && FloatCompare.__default.CleanNumber(x#0) == FloatCompare.__default.RecognizeZero(FloatCompare.__default.SkipLeadingPlus(FloatCompare.__default.SkipLeadingSpace($LS($LZ), x#0))));
axiom 2 <= $FunctionContextHeight ==> (forall x#0: Seq :: {:weight 3} { FloatCompare.__default.CleanNumber(Lit(x#0)) } FloatCompare.__default.CleanNumber#canCall(Lit(x#0)) || (2 < $FunctionContextHeight && $Is(x#0, TSeq(TChar))) ==> FloatCompare.__default.SkipLeadingSpace#canCall(Lit(x#0)) && FloatCompare.__default.SkipLeadingPlus#canCall(Lit(FloatCompare.__default.SkipLeadingSpace($LS($LZ), Lit(x#0)))) && FloatCompare.__default.RecognizeZero#canCall(Lit(FloatCompare.__default.SkipLeadingPlus(Lit(FloatCompare.__default.SkipLeadingSpace($LS($LZ), Lit(x#0)))))) && FloatCompare.__default.CleanNumber(Lit(x#0)) == Lit(FloatCompare.__default.RecognizeZero(Lit(FloatCompare.__default.SkipLeadingPlus(Lit(FloatCompare.__default.SkipLeadingSpace($LS($LZ), Lit(x#0))))))));
}

function FloatCompare.__default.CleanNumber#canCall(x#0: Seq) : bool;

function FloatCompare.__default.CleanNumber#requires(Seq) : bool;

axiom (forall x#0: Seq :: { FloatCompare.__default.CleanNumber#requires(x#0) } $Is(x#0, TSeq(TChar)) ==> (FloatCompare.__default.CleanNumber#requires(x#0) <==> true));

procedure {:verboseName "FloatCompare.CleanNumber (well-formedness)"} CheckWellformed$$FloatCompare.__default.CleanNumber(x#0: Seq where $Is(x#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function FloatCompare.__default.CompareFloat(x#0: Seq, y#0: Seq) : int
uses {
axiom 4 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: { FloatCompare.__default.CompareFloat(x#0, y#0) } FloatCompare.__default.CompareFloat#canCall(x#0, y#0) || (4 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> LitInt(-1) <= FloatCompare.__default.CompareFloat(x#0, y#0) && FloatCompare.__default.CompareFloat(x#0, y#0) <= LitInt(1));
axiom 4 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: { FloatCompare.__default.CompareFloat(x#0, y#0) } FloatCompare.__default.CompareFloat#canCall(x#0, y#0) || (4 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> FloatCompare.__default.CleanNumber#canCall(x#0) && (var x#1 := FloatCompare.__default.CleanNumber(x#0); FloatCompare.__default.CleanNumber#canCall(y#0) && (var y#1 := FloatCompare.__default.CleanNumber(y#0); FloatCompare.__default.IsNegative#canCall(x#1) && (FloatCompare.__default.IsNegative(x#1) ==> FloatCompare.__default.IsNegative#canCall(y#1)) && (FloatCompare.__default.IsNegative(x#1) && FloatCompare.__default.IsNegative(y#1) ==> FloatCompare.__default.CompareFloatInner#canCall(Seq#Drop(y#1, LitInt(1)), Seq#Drop(x#1, LitInt(1)))) && (!(FloatCompare.__default.IsNegative(x#1) && FloatCompare.__default.IsNegative(y#1)) ==> FloatCompare.__default.IsNegative#canCall(x#1) && (!FloatCompare.__default.IsNegative(x#1) ==> FloatCompare.__default.IsNegative#canCall(y#1) && (!FloatCompare.__default.IsNegative(y#1) ==> FloatCompare.__default.CompareFloatInner#canCall(x#1, y#1)))))) && FloatCompare.__default.CompareFloat(x#0, y#0) == (var x#1 := FloatCompare.__default.CleanNumber(x#0); (var y#1 := FloatCompare.__default.CleanNumber(y#0); (if FloatCompare.__default.IsNegative(x#1) && FloatCompare.__default.IsNegative(y#1) then FloatCompare.__default.CompareFloatInner(Seq#Drop(y#1, LitInt(1)), Seq#Drop(x#1, LitInt(1))) else (if FloatCompare.__default.IsNegative(x#1) then -1 else (if FloatCompare.__default.IsNegative(y#1) then 1 else FloatCompare.__default.CompareFloatInner(x#1, y#1)))))));
axiom 4 <= $FunctionContextHeight ==> (forall x#0: Seq, y#0: Seq :: {:weight 3} { FloatCompare.__default.CompareFloat(Lit(x#0), Lit(y#0)) } FloatCompare.__default.CompareFloat#canCall(Lit(x#0), Lit(y#0)) || (4 < $FunctionContextHeight && $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar))) ==> FloatCompare.__default.CleanNumber#canCall(Lit(x#0)) && (var x#2 := Lit(FloatCompare.__default.CleanNumber(Lit(x#0))); FloatCompare.__default.CleanNumber#canCall(Lit(y#0)) && (var y#2 := Lit(FloatCompare.__default.CleanNumber(Lit(y#0))); FloatCompare.__default.IsNegative#canCall(x#2) && (FloatCompare.__default.IsNegative(x#2) ==> FloatCompare.__default.IsNegative#canCall(y#2)) && (FloatCompare.__default.IsNegative(x#2) && FloatCompare.__default.IsNegative(y#2) ==> FloatCompare.__default.CompareFloatInner#canCall(Seq#Drop(y#2, LitInt(1)), Seq#Drop(x#2, LitInt(1)))) && (!(FloatCompare.__default.IsNegative(x#2) && FloatCompare.__default.IsNegative(y#2)) ==> FloatCompare.__default.IsNegative#canCall(x#2) && (!FloatCompare.__default.IsNegative(x#2) ==> FloatCompare.__default.IsNegative#canCall(y#2) && (!FloatCompare.__default.IsNegative(y#2) ==> FloatCompare.__default.CompareFloatInner#canCall(x#2, y#2)))))) && FloatCompare.__default.CompareFloat(Lit(x#0), Lit(y#0)) == (var x#2 := Lit(FloatCompare.__default.CleanNumber(Lit(x#0))); (var y#2 := Lit(FloatCompare.__default.CleanNumber(Lit(y#0))); (if FloatCompare.__default.IsNegative(x#2) && FloatCompare.__default.IsNegative(y#2) then FloatCompare.__default.CompareFloatInner(Lit(Seq#Drop(y#2, LitInt(1))), Lit(Seq#Drop(x#2, LitInt(1)))) else (if FloatCompare.__default.IsNegative(x#2) then -1 else (if FloatCompare.__default.IsNegative(y#2) then 1 else FloatCompare.__default.CompareFloatInner(x#2, y#2)))))));
}

function FloatCompare.__default.CompareFloat#canCall(x#0: Seq, y#0: Seq) : bool;

function FloatCompare.__default.CompareFloat#requires(Seq, Seq) : bool;

axiom (forall x#0: Seq, y#0: Seq :: { FloatCompare.__default.CompareFloat#requires(x#0, y#0) } $Is(x#0, TSeq(TChar)) && $Is(y#0, TSeq(TChar)) ==> (FloatCompare.__default.CompareFloat#requires(x#0, y#0) <==> true));

procedure {:verboseName "FloatCompare.CompareFloat (well-formedness)"} CheckWellformed$$FloatCompare.__default.CompareFloat(x#0: Seq where $Is(x#0, TSeq(TChar)), y#0: Seq where $Is(y#0, TSeq(TChar))) returns (ret#0: int where LitInt(-1) <= ret#0 && ret#0 <= LitInt(1));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.CompareFloat (well-formedness)"} CheckWellformed$$FloatCompare.__default.CompareFloat(x#0: Seq, y#0: Seq) returns (ret#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var x#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##x#0: Seq;
  var y#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##x#1: Seq;
  var ##x#2: Seq;
  var ##x#3: Seq;
  var ##x#4: Seq;
  var ##y#0: Seq;
  var ##x#5: Seq;
  var newtype$check#0: int;
  var ##x#6: Seq;
  var newtype$check#1: int;
  var ##x#7: Seq;
  var ##y#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.CompareFloat", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(233,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume LitInt(-1) <= FloatCompare.__default.CompareFloat(x#0, y#0) && FloatCompare.__default.CompareFloat(x#0, y#0) <= LitInt(1);
    assume false;
    return;

  anon13_Else:
    havoc x#Z#0;
    assume $Is(x#Z#0, TSeq(TChar)) && $IsAlloc(x#Z#0, TSeq(TChar), $Heap);
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.CleanNumber#canCall(x#0);
    assume let#0#0#0 == FloatCompare.__default.CleanNumber(x#0);
    assume FloatCompare.__default.CleanNumber#canCall(x#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume x#Z#0 == let#0#0#0;
    havoc y#Z#0;
    assume $Is(y#Z#0, TSeq(TChar)) && $IsAlloc(y#Z#0, TSeq(TChar), $Heap);
    ##x#1 := y#0;
    assume $IsAlloc(##x#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.CleanNumber#canCall(y#0);
    assume let#1#0#0 == FloatCompare.__default.CleanNumber(y#0);
    assume FloatCompare.__default.CleanNumber#canCall(y#0);
    assume $Is(let#1#0#0, TSeq(TChar));
    assume y#Z#0 == let#1#0#0;
    ##x#2 := x#Z#0;
    assume $IsAlloc(##x#2, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsNegative#canCall(x#Z#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} FloatCompare.__default.IsNegative(x#Z#0);
    ##x#3 := y#Z#0;
    assume $IsAlloc(##x#3, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsNegative#canCall(y#Z#0);
    goto anon5;

  anon14_Else:
    assume {:partition} !FloatCompare.__default.IsNegative(x#Z#0);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} FloatCompare.__default.IsNegative(x#Z#0) && FloatCompare.__default.IsNegative(y#Z#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(y#Z#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(x#Z#0);
    ##x#4 := Seq#Drop(y#Z#0, LitInt(1));
    assume $IsAlloc(##x#4, TSeq(TChar), $Heap);
    ##y#0 := Seq#Drop(x#Z#0, LitInt(1));
    assume $IsAlloc(##y#0, TSeq(TChar), $Heap);
    assume FloatCompare.__default.CompareFloatInner#canCall(Seq#Drop(y#Z#0, LitInt(1)), Seq#Drop(x#Z#0, LitInt(1)));
    assume FloatCompare.__default.CompareFloat(x#0, y#0) == FloatCompare.__default.CompareFloatInner(Seq#Drop(y#Z#0, LitInt(1)), Seq#Drop(x#Z#0, LitInt(1)));
    assume FloatCompare.__default.CompareFloatInner#canCall(Seq#Drop(y#Z#0, LitInt(1)), Seq#Drop(x#Z#0, LitInt(1)));
    assume $Is(FloatCompare.__default.CompareFloat(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon15_Else:
    assume {:partition} !(FloatCompare.__default.IsNegative(x#Z#0) && FloatCompare.__default.IsNegative(y#Z#0));
    ##x#5 := x#Z#0;
    assume $IsAlloc(##x#5, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsNegative#canCall(x#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} FloatCompare.__default.IsNegative(x#Z#0);
    newtype$check#0 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 <= LitInt(1);
    assume FloatCompare.__default.CompareFloat(x#0, y#0) == LitInt(-1);
    assume true;
    assume $Is(FloatCompare.__default.CompareFloat(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon16_Else:
    assume {:partition} !FloatCompare.__default.IsNegative(x#Z#0);
    ##x#6 := y#Z#0;
    assume $IsAlloc(##x#6, TSeq(TChar), $Heap);
    assume FloatCompare.__default.IsNegative#canCall(y#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} FloatCompare.__default.IsNegative(y#Z#0);
    newtype$check#1 := LitInt(1);
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 <= LitInt(1);
    assume FloatCompare.__default.CompareFloat(x#0, y#0) == LitInt(1);
    assume true;
    assume $Is(FloatCompare.__default.CompareFloat(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon17_Else:
    assume {:partition} !FloatCompare.__default.IsNegative(y#Z#0);
    ##x#7 := x#Z#0;
    assume $IsAlloc(##x#7, TSeq(TChar), $Heap);
    ##y#1 := y#Z#0;
    assume $IsAlloc(##y#1, TSeq(TChar), $Heap);
    assume FloatCompare.__default.CompareFloatInner#canCall(x#Z#0, y#Z#0);
    assume FloatCompare.__default.CompareFloat(x#0, y#0) == FloatCompare.__default.CompareFloatInner(x#Z#0, y#Z#0);
    assume FloatCompare.__default.CompareFloatInner#canCall(x#Z#0, y#Z#0);
    assume $Is(FloatCompare.__default.CompareFloat(x#0, y#0), Tclass.FloatCompare.CompareType());
    goto anon12;

  anon12:
    assume FloatCompare.__default.CompareFloat(x#0, y#0) == ret#0;
    return;
}



procedure {:verboseName "FloatCompare.CompareType (well-formedness)"} CheckWellFormed$$FloatCompare.CompareType(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "FloatCompare.CompareType (well-formedness)"} CheckWellFormed$$FloatCompare.CompareType(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "FloatCompare.CompareType", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/FloatCompare.dfy(25,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(-1) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(-1);
    goto anon4;

  anon4:
    assume LitInt(-1) <= x#0 && x#0 <= LitInt(1);
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(-1) <= LitInt(0);
    assume {:subsumption 0} LitInt(0) <= LitInt(1);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.FloatCompare.CompareType()) } $Is(x#0, Tclass.FloatCompare.CompareType()) <==> LitInt(-1) <= x#0 && x#0 <= LitInt(1));

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.FloatCompare.CompareType(), $h) } $IsAlloc(x#0, Tclass.FloatCompare.CompareType(), $h));

const unique class.FloatCompare.CompareType: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#112 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#112))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#114 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#114)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#168 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#168))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#170 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#170)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#172 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#172)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#168 := Wrappers.Option.value(this); v#168)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#170 := Lit(Wrappers.Option.value(Lit(this))); v#170)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#172 := Lit(Wrappers.Option.value(Lit(this))); v#172)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#112 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#112)) else (var e#112 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#114 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#114))) else (var e#114 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#168 := Wrappers.Result.value(this); s#168) else (var e#168 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#170 := Lit(Wrappers.Result.value(Lit(this))); s#170) else (var e#170 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#172 := Lit(Wrappers.Result.value(Lit(this))); s#172) else (var e#172 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#168 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#168)) else (var e#168 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#168)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#170 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#170))) else (var e#170 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#170)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#172 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#172))) else (var e#172 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#172)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#38 := Div(x#0, LitInt(256)); (var b1#38 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#38)), $Box(b1#38)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#39 := LitInt(Div(x#0, LitInt(256))); (var b1#39 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#39)), $Box(b1#39))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#38 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#38 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#39 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#39 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#38 := Div(x#0, LitInt(16777216)); (var x0#38 := x#0 - Mul(b0#38, LitInt(16777216)); (var b1#38 := Div(x0#38, LitInt(65536)); (var x1#38 := x0#38 - Mul(b1#38, LitInt(65536)); (var b2#38 := Div(x1#38, LitInt(256)); (var b3#38 := Mod(x1#38, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#38)), $Box(b1#38)), $Box(b2#38)), $Box(b3#38)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#39 := LitInt(Div(x#0, LitInt(16777216))); (var x0#39 := LitInt(x#0 - Mul(b0#39, LitInt(16777216))); (var b1#39 := LitInt(Div(x0#39, LitInt(65536))); (var x1#39 := LitInt(x0#39 - Mul(b1#39, LitInt(65536))); (var b2#39 := LitInt(Div(x1#39, LitInt(256))); (var b3#39 := LitInt(Mod(x1#39, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#39)), $Box(b1#39)), $Box(b2#39)), $Box(b3#39))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#38 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#38 := x0#38 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#38 := x1#38 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#38 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#39 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#39 := x0#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#39 := x1#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#39 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#38 := Div(x#0, LitInt(72057594037927936)); (var x0#38 := x#0 - Mul(b0#38, LitInt(72057594037927936)); (var b1#38 := Div(x0#38, LitInt(281474976710656)); (var x1#38 := x0#38 - Mul(b1#38, LitInt(281474976710656)); (var b2#38 := Div(x1#38, LitInt(1099511627776)); (var x2#38 := x1#38 - Mul(b2#38, LitInt(1099511627776)); (var b3#38 := Div(x2#38, LitInt(4294967296)); (var x3#38 := x2#38 - Mul(b3#38, LitInt(4294967296)); (var b4#38 := Div(x3#38, LitInt(16777216)); (var x4#38 := x3#38 - Mul(b4#38, LitInt(16777216)); (var b5#38 := Div(x4#38, LitInt(65536)); (var x5#38 := x4#38 - Mul(b5#38, LitInt(65536)); (var b6#38 := Div(x5#38, LitInt(256)); (var b7#38 := Mod(x5#38, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#38)), $Box(b1#38)), $Box(b2#38)), $Box(b3#38)), $Box(b4#38)), $Box(b5#38)), $Box(b6#38)), $Box(b7#38)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#39 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#39 := LitInt(x#0 - Mul(b0#39, LitInt(72057594037927936))); (var b1#39 := LitInt(Div(x0#39, LitInt(281474976710656))); (var x1#39 := LitInt(x0#39 - Mul(b1#39, LitInt(281474976710656))); (var b2#39 := LitInt(Div(x1#39, LitInt(1099511627776))); (var x2#39 := LitInt(x1#39 - Mul(b2#39, LitInt(1099511627776))); (var b3#39 := LitInt(Div(x2#39, LitInt(4294967296))); (var x3#39 := LitInt(x2#39 - Mul(b3#39, LitInt(4294967296))); (var b4#39 := LitInt(Div(x3#39, LitInt(16777216))); (var x4#39 := LitInt(x3#39 - Mul(b4#39, LitInt(16777216))); (var b5#39 := LitInt(Div(x4#39, LitInt(65536))); (var x5#39 := LitInt(x4#39 - Mul(b5#39, LitInt(65536))); (var b6#39 := LitInt(Div(x5#39, LitInt(256))); (var b7#39 := LitInt(Mod(x5#39, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#39)), $Box(b1#39)), $Box(b2#39)), $Box(b3#39)), $Box(b4#39)), $Box(b5#39)), $Box(b6#39)), $Box(b7#39))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#38 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#38 := x0#38 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#38 := x1#38 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#38 := x2#38 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#38 := x3#38 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#38 := x4#38 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#38 := x5#38 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#39 := x6#38 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#39)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#39 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#39 := x0#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#39 := x1#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#39 := x2#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#39 := x3#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#39 := x4#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#39 := x5#39 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#40 := x6#39 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#40)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#38 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#38)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#38 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#38)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#38)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#39 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#39)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#39 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#39)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#39)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#30: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#30)): Seq } LitInt(0) <= i#30 && i#30 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#30)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#31 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#31) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#31)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#31 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#31) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#31)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#31)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#32 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#32) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#32)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#32 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#32) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#32)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#32)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#33 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#33) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#33)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#33 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#33) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#33)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#33)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#21 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#21)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#21)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#22 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#22)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#22)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#23 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#23)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#23)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#21 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#21) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#21) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#21)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#21) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#21))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#21 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#21) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#21) else (var i#21 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#21)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#21)), $Box(Seq#Drop(s#0, i#21 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#22 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#22) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#22) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#22)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#22) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#22))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#22 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#22) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#22) else (var i#22 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#22)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#22)), $Box(Seq#Drop(Lit(s#0), i#22 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#23 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#23) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#23) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#23)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#23) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#23))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#23 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#23) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#23) else (var i#23 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#23)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#23))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#23 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#x#0: Box :: $Box($l#72#x#0 == c#0)), (lambda $l#72#heap#0: Heap, $l#72#x#0: Box :: $IsBox($l#72#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#72#heap#0: Heap, $l#72#x#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#x#0: Box :: $Box($l#70#x#0 == c#0)), (lambda $l#70#heap#0: Heap, $l#70#x#0: Box :: $IsBox($l#70#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#70#heap#0: Heap, $l#70#x#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#x#0: Box :: $Box($l#75#x#0 == c#0)), (lambda $l#75#heap#0: Heap, $l#75#x#0: Box :: $IsBox($l#75#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#75#heap#0: Heap, $l#75#x#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#x#0: Box :: $Box($l#73#x#0 == c#0)), (lambda $l#73#heap#0: Heap, $l#73#x#0: Box :: $IsBox($l#73#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#73#heap#0: Heap, $l#73#x#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#x#0: Box :: $Box($l#78#x#0 == Lit(c#0))), (lambda $l#78#heap#0: Heap, $l#78#x#0: Box :: $IsBox($l#78#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#78#heap#0: Heap, $l#78#x#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#x#0: Box :: $Box($l#76#x#0 == Lit(c#0))), (lambda $l#76#heap#0: Heap, $l#76#x#0: Box :: $IsBox($l#76#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#76#heap#0: Heap, $l#76#x#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#18: int :: { Seq#Index(s#0, j#18) } i#0 <= j#18 && j#18 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#18))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#19: int :: { Seq#Index(s#0, j#19) } i#0 <= j#19 && j#19 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#19))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#18: int :: { Seq#Index(s#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#18))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#18))) && (forall i#19: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#19) } (LitInt(0) <= i#19 && i#19 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#19))) && (LitInt(0) <= i#19 && i#19 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#19))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#9: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#9) } LitInt(0) <= i#9 && i#9 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#9) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#_v0#0: Box :: value#0), (lambda $l#46#heap#0: Heap, $l#46#_v0#0: Box :: $IsBox($l#46#_v0#0, TInt)), (lambda $l#46#heap#0: Heap, $l#46#_v0#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#_v0#0: Box :: value#0), (lambda $l#48#heap#0: Heap, $l#48#_v0#0: Box :: $IsBox($l#48#_v0#0, TInt)), (lambda $l#48#heap#0: Heap, $l#48#_v0#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#_v0#0: Box :: Lit(value#0)), (lambda $l#50#heap#0: Heap, $l#50#_v0#0: Box :: $IsBox($l#50#_v0#0, TInt)), (lambda $l#50#heap#0: Heap, $l#50#_v0#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#23: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#23) } LitInt(0) <= k#23 ==> k#23 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#23)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#23: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#23) } LitInt(0) <= k#23 && k#23 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#23))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#24: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#24) } LitInt(0) <= k#24 ==> k#24 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#24)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#24: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#24) } LitInt(0) <= k#24 && k#24 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#24))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#25: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#25) } LitInt(0) <= k#25 ==> k#25 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#25)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#25: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#25) } LitInt(0) <= k#25 && k#25 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#25))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#23: int :: { Seq#Index(b#0, i#23) } { Seq#Index(a#0, i#23) } LitInt(0) <= i#23 && i#23 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#23) == Seq#Index(b#0, i#23)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#24: int :: { Seq#Index(b#0, i#24) } { Seq#Index(a#0, i#24) } LitInt(0) <= i#24 && i#24 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#24) == Seq#Index(Lit(b#0), i#24)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#25: int :: { Seq#Index(b#0, i#25) } { Seq#Index(a#0, i#25) } LitInt(0) <= i#25 && i#25 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#25) == Seq#Index(Lit(b#0), i#25)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#48: Box, y#48: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#48, x#48)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#48, y#48)): bool } $IsBox(x#48, StandardLibrary._default.Trichotomous$T) && $IsBox(y#48, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#48, y#48)): bool || x#48 == y#48 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#48, x#48)): bool) && (forall x#49: Box, y#49: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#49, x#49)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#49, y#49)): bool } $IsBox(x#49, StandardLibrary._default.Trichotomous$T) && $IsBox(y#49, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#49, y#49)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#49, x#49)): bool ==> false) && (forall x#50: Box, y#50: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#50, y#50)): bool } $IsBox(x#50, StandardLibrary._default.Trichotomous$T) && $IsBox(y#50, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#50, y#50)): bool ==> x#50 != y#50)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#51: Box, y#51: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#51, x#51)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#51, y#51)): bool } $IsBox(x#51, StandardLibrary._default.Trichotomous$T) && $IsBox(y#51, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#51, y#51)): bool || x#51 == y#51 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#51, x#51)): bool) && (forall x#52: Box, y#52: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#52, x#52)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#52, y#52)): bool } $IsBox(x#52, StandardLibrary._default.Trichotomous$T) && $IsBox(y#52, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#52, y#52)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#52, x#52)): bool ==> false) && (forall x#53: Box, y#53: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#53, y#53)): bool } $IsBox(x#53, StandardLibrary._default.Trichotomous$T) && $IsBox(y#53, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#53, y#53)): bool ==> x#53 != y#53)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#16: Box, y#16: Box, z#16: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#16, z#16)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#16, z#16)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#16, z#16)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#16, y#16)): bool } $IsBox(x#16, StandardLibrary._default.Transitive$T) && $IsBox(y#16, StandardLibrary._default.Transitive$T) && $IsBox(z#16, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#16, y#16)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#16, z#16)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#16, z#16)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#17: Box, y#17: Box, z#17: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#17, z#17)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#17, z#17)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#17, z#17)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#17, y#17)): bool } $IsBox(x#17, StandardLibrary._default.Transitive$T) && $IsBox(y#17, StandardLibrary._default.Transitive$T) && $IsBox(z#17, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#17, y#17)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#17, z#17)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#17, z#17)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#27: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#27)): Seq } LitInt(0) <= i#27 && i#27 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#27)]) && (forall k#9: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#9)) } { s#0[$Box(k#9)] } $Is(k#9, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#9)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#9))) && (forall i#28: int, _t#0#8: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#28)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#8)): Seq } _t#0#8 == i#28 - 1 ==> 0 < i#28 && i#28 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#8)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#28)): Seq, less#0)) && (forall i#29: int, j#9: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#9)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#29)): Seq } LitInt(0) <= i#29 && i#29 < j#9 && j#9 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#29)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#9)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#26 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#26)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#26))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#27 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#27)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#27))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#28 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#28)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#28))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#23: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#23, less#0) } { s#0[$Box(z#23)] } $Is(z#23, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#23)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#23, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#23: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#23, less#0) } { s#0[$Box(z#23)] } $Is(z#23, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#23)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#23, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#24: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#24, less#0) } { s#0[$Box(z#24)] } $Is(z#24, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#24)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#24, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#24: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#24, less#0) } { s#0[$Box(z#24)] } $Is(z#24, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#24)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#24, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#25: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#25, less#0) } { s#0[$Box(z#25)] } $Is(z#25, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#25)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#25, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#25: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#25, less#0) } { s#0[$Box(z#25)] } $Is(z#25, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#25)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#25, Lit(less#0)))));

const unique tytagFamily$CompareType: TyTagFamily;

const unique class.ConcurrentCall.__default: ClassName;

function Tclass.ConcurrentCall.Callee() : Ty
uses {
axiom Tag(Tclass.ConcurrentCall.Callee()) == Tagclass.ConcurrentCall.Callee && TagFamily(Tclass.ConcurrentCall.Callee()) == tytagFamily$Callee;
}

const unique Tagclass.ConcurrentCall.Callee: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.ConcurrentCall.Callee()) } $IsBox(bx, Tclass.ConcurrentCall.Callee()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.ConcurrentCall.Callee()));

procedure {:verboseName "ConcurrentCall.ConcurrentCall (well-formedness)"} {:extern} CheckWellFormed$$ConcurrentCall.__default.ConcurrentCall(callee#0: ref where $Is(callee#0, Tclass.ConcurrentCall.Callee()) && $IsAlloc(callee#0, Tclass.ConcurrentCall.Callee(), $Heap), serialIters#0: int where LitInt(0) <= serialIters#0 && serialIters#0 < BoundedInts.__default.TWO__TO__THE__32(), concurrentIters#0: int where LitInt(0) <= concurrentIters#0 && concurrentIters#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ConcurrentCall.ConcurrentCall (call precondtion)"} {:extern} CallPre$$ConcurrentCall.__default.ConcurrentCall(callee#0: ref where $Is(callee#0, Tclass.ConcurrentCall.Callee()) && $IsAlloc(callee#0, Tclass.ConcurrentCall.Callee(), $Heap), serialIters#0: int where LitInt(0) <= serialIters#0 && serialIters#0 < BoundedInts.__default.TWO__TO__THE__32(), concurrentIters#0: int where LitInt(0) <= concurrentIters#0 && concurrentIters#0 < BoundedInts.__default.TWO__TO__THE__32());



procedure {:verboseName "ConcurrentCall.ConcurrentCall (call postcondition)"} {:extern} CallPost$$ConcurrentCall.__default.ConcurrentCall(callee#0: ref where $Is(callee#0, Tclass.ConcurrentCall.Callee()) && $IsAlloc(callee#0, Tclass.ConcurrentCall.Callee(), $Heap), serialIters#0: int where LitInt(0) <= serialIters#0 && serialIters#0 < BoundedInts.__default.TWO__TO__THE__32(), concurrentIters#0: int where LitInt(0) <= concurrentIters#0 && concurrentIters#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



const unique class.ConcurrentCall.Callee?: ClassName;

function Tclass.ConcurrentCall.Callee?() : Ty
uses {
axiom Tag(Tclass.ConcurrentCall.Callee?()) == Tagclass.ConcurrentCall.Callee? && TagFamily(Tclass.ConcurrentCall.Callee?()) == tytagFamily$Callee;
}

const unique Tagclass.ConcurrentCall.Callee?: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.ConcurrentCall.Callee?()) } $IsBox(bx, Tclass.ConcurrentCall.Callee?()) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.ConcurrentCall.Callee?()));

axiom (forall $o: ref :: { $Is($o, Tclass.ConcurrentCall.Callee?()) } $Is($o, Tclass.ConcurrentCall.Callee?()) <==> $o == null || implements$ConcurrentCall.Callee(dtype($o)));

axiom (forall $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.ConcurrentCall.Callee?(), $h) } $IsAlloc($o, Tclass.ConcurrentCall.Callee?(), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$ConcurrentCall.Callee(ty: Ty) : bool;

const ConcurrentCall.Callee.Modifies: Field
uses {
axiom FDim(ConcurrentCall.Callee.Modifies) == 0 && FieldOfDecl(class.ConcurrentCall.Callee?, field$Modifies) == ConcurrentCall.Callee.Modifies && $IsGhostField(ConcurrentCall.Callee.Modifies);
}

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, ConcurrentCall.Callee.Modifies)): Set } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.ConcurrentCall.Callee?()) ==> $Is($Unbox(read($h, $o, ConcurrentCall.Callee.Modifies)): Set, TSet(Tclass._System.object())));

axiom (forall $h: Heap, $o: ref :: { $Unbox(read($h, $o, ConcurrentCall.Callee.Modifies)): Set } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.ConcurrentCall.Callee?()) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, ConcurrentCall.Callee.Modifies)): Set, TSet(Tclass._System.object()), $h));

function ConcurrentCall.Callee.ValidState($heap: Heap, this: ref) : bool;

function ConcurrentCall.Callee.ValidState#canCall($heap: Heap, this: ref) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), ConcurrentCall.Callee.ValidState($h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.ConcurrentCall.Callee()) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (ConcurrentCall.Callee.ValidState($h0, this) <==> ConcurrentCall.Callee.ValidState($h1, this)));

function ConcurrentCall.Callee.ValidState#requires(Heap, ref) : bool;

axiom (forall $Heap: Heap, this: ref :: { ConcurrentCall.Callee.ValidState#requires($Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.ConcurrentCall.Callee()) && $IsAlloc(this, Tclass.ConcurrentCall.Callee(), $Heap) ==> (ConcurrentCall.Callee.ValidState#requires($Heap, this) <==> true));

procedure {:verboseName "ConcurrentCall.Callee.ValidState (well-formedness)"} CheckWellformed$$ConcurrentCall.Callee.ValidState(this: ref where this != null && $Is(this, Tclass.ConcurrentCall.Callee()) && $IsAlloc(this, Tclass.ConcurrentCall.Callee(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ConcurrentCall.Callee.call (well-formedness)"} CheckWellFormed$$ConcurrentCall.Callee.call(this: ref where this != null && $Is(this, Tclass.ConcurrentCall.Callee()) && $IsAlloc(this, Tclass.ConcurrentCall.Callee(), $Heap), serialPos#0: int where LitInt(0) <= serialPos#0 && serialPos#0 < BoundedInts.__default.TWO__TO__THE__32(), concurrentPos#0: int where LitInt(0) <= concurrentPos#0 && concurrentPos#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "ConcurrentCall.Callee.call (call precondtion)"} CallPre$$ConcurrentCall.Callee.call(this: ref where this != null && $Is(this, Tclass.ConcurrentCall.Callee()) && $IsAlloc(this, Tclass.ConcurrentCall.Callee(), $Heap), serialPos#0: int where LitInt(0) <= serialPos#0 && serialPos#0 < BoundedInts.__default.TWO__TO__THE__32(), concurrentPos#0: int where LitInt(0) <= concurrentPos#0 && concurrentPos#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id17615"} ConcurrentCall.Callee.ValidState($Heap, this);



procedure {:verboseName "ConcurrentCall.Callee.call (call postcondition)"} CallPost$$ConcurrentCall.Callee.call(this: ref where this != null && $Is(this, Tclass.ConcurrentCall.Callee()) && $IsAlloc(this, Tclass.ConcurrentCall.Callee(), $Heap), serialPos#0: int where LitInt(0) <= serialPos#0 && serialPos#0 < BoundedInts.__default.TWO__TO__THE__32(), concurrentPos#0: int where LitInt(0) <= concurrentPos#0 && concurrentPos#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures ConcurrentCall.Callee.ValidState#canCall($Heap, this);
  free ensures {:id "id17616"} ConcurrentCall.Callee.ValidState($Heap, this);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || ($Unbox(read(old($Heap), this, ConcurrentCall.Callee.Modifies)): Set)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall c#0: ref :: { $Is(c#0, Tclass.ConcurrentCall.Callee()) } $Is(c#0, Tclass.ConcurrentCall.Callee()) <==> $Is(c#0, Tclass.ConcurrentCall.Callee?()) && c#0 != null);

axiom (forall c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.ConcurrentCall.Callee(), $h) } $IsAlloc(c#0, Tclass.ConcurrentCall.Callee(), $h) <==> $IsAlloc(c#0, Tclass.ConcurrentCall.Callee?(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#116 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#116))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#118 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#118)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#174 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#174))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#176 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#176)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#178 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#178)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#174 := Wrappers.Option.value(this); v#174)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#176 := Lit(Wrappers.Option.value(Lit(this))); v#176)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#178 := Lit(Wrappers.Option.value(Lit(this))); v#178)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#116 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#116)) else (var e#116 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#118 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#118))) else (var e#118 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#174 := Wrappers.Result.value(this); s#174) else (var e#174 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#176 := Lit(Wrappers.Result.value(Lit(this))); s#176) else (var e#176 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#178 := Lit(Wrappers.Result.value(Lit(this))); s#178) else (var e#178 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#174 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#174)) else (var e#174 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#174)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#176 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#176))) else (var e#176 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#176)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#178 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#178))) else (var e#178 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#178)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#40 := Div(x#0, LitInt(256)); (var b1#40 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#40)), $Box(b1#40)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#41 := LitInt(Div(x#0, LitInt(256))); (var b1#41 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#41)), $Box(b1#41))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#40 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#40 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#41 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#41 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#40 := Div(x#0, LitInt(16777216)); (var x0#40 := x#0 - Mul(b0#40, LitInt(16777216)); (var b1#40 := Div(x0#40, LitInt(65536)); (var x1#40 := x0#40 - Mul(b1#40, LitInt(65536)); (var b2#40 := Div(x1#40, LitInt(256)); (var b3#40 := Mod(x1#40, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#40)), $Box(b1#40)), $Box(b2#40)), $Box(b3#40)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#41 := LitInt(Div(x#0, LitInt(16777216))); (var x0#41 := LitInt(x#0 - Mul(b0#41, LitInt(16777216))); (var b1#41 := LitInt(Div(x0#41, LitInt(65536))); (var x1#41 := LitInt(x0#41 - Mul(b1#41, LitInt(65536))); (var b2#41 := LitInt(Div(x1#41, LitInt(256))); (var b3#41 := LitInt(Mod(x1#41, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#41)), $Box(b1#41)), $Box(b2#41)), $Box(b3#41))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#40 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#40 := x0#40 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#40 := x1#40 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#40 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#41 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#41 := x0#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#41 := x1#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#41 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#40 := Div(x#0, LitInt(72057594037927936)); (var x0#40 := x#0 - Mul(b0#40, LitInt(72057594037927936)); (var b1#40 := Div(x0#40, LitInt(281474976710656)); (var x1#40 := x0#40 - Mul(b1#40, LitInt(281474976710656)); (var b2#40 := Div(x1#40, LitInt(1099511627776)); (var x2#40 := x1#40 - Mul(b2#40, LitInt(1099511627776)); (var b3#40 := Div(x2#40, LitInt(4294967296)); (var x3#40 := x2#40 - Mul(b3#40, LitInt(4294967296)); (var b4#40 := Div(x3#40, LitInt(16777216)); (var x4#40 := x3#40 - Mul(b4#40, LitInt(16777216)); (var b5#40 := Div(x4#40, LitInt(65536)); (var x5#40 := x4#40 - Mul(b5#40, LitInt(65536)); (var b6#40 := Div(x5#40, LitInt(256)); (var b7#40 := Mod(x5#40, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#40)), $Box(b1#40)), $Box(b2#40)), $Box(b3#40)), $Box(b4#40)), $Box(b5#40)), $Box(b6#40)), $Box(b7#40)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#41 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#41 := LitInt(x#0 - Mul(b0#41, LitInt(72057594037927936))); (var b1#41 := LitInt(Div(x0#41, LitInt(281474976710656))); (var x1#41 := LitInt(x0#41 - Mul(b1#41, LitInt(281474976710656))); (var b2#41 := LitInt(Div(x1#41, LitInt(1099511627776))); (var x2#41 := LitInt(x1#41 - Mul(b2#41, LitInt(1099511627776))); (var b3#41 := LitInt(Div(x2#41, LitInt(4294967296))); (var x3#41 := LitInt(x2#41 - Mul(b3#41, LitInt(4294967296))); (var b4#41 := LitInt(Div(x3#41, LitInt(16777216))); (var x4#41 := LitInt(x3#41 - Mul(b4#41, LitInt(16777216))); (var b5#41 := LitInt(Div(x4#41, LitInt(65536))); (var x5#41 := LitInt(x4#41 - Mul(b5#41, LitInt(65536))); (var b6#41 := LitInt(Div(x5#41, LitInt(256))); (var b7#41 := LitInt(Mod(x5#41, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#41)), $Box(b1#41)), $Box(b2#41)), $Box(b3#41)), $Box(b4#41)), $Box(b5#41)), $Box(b6#41)), $Box(b7#41))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#40 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#40 := x0#40 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#40 := x1#40 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#40 := x2#40 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#40 := x3#40 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#40 := x4#40 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#40 := x5#40 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#41 := x6#40 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#41)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#41 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#41 := x0#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#41 := x1#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#41 := x2#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#41 := x3#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#41 := x4#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#41 := x5#41 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#42 := x6#41 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#42)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#40 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#40)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#40 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#40)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#40)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#41 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#41)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#41 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#41)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#41)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#34: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#34)): Seq } LitInt(0) <= i#34 && i#34 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#34)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#35 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#35) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#35)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#35 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#35) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#35)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#35)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#36 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#36) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#36)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#36 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#36) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#36)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#36)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#37 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#37) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#37)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#37 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#37) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#37)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#37)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#24 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#24)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#24)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#25 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#25)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#25)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#26 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#26)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#26)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#24 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#24) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#24) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#24)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#24) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#24))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#24 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#24) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#24) else (var i#24 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#24)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#24)), $Box(Seq#Drop(s#0, i#24 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#25 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#25) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#25) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#25)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#25) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#25))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#25 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#25) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#25) else (var i#25 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#25)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#25)), $Box(Seq#Drop(Lit(s#0), i#25 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#26 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#26) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#26) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#26)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#26) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#26))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#26 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#26) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#26) else (var i#26 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#26)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#26))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#26 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#x#0: Box :: $Box($l#81#x#0 == c#0)), (lambda $l#81#heap#0: Heap, $l#81#x#0: Box :: $IsBox($l#81#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#81#heap#0: Heap, $l#81#x#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#x#0: Box :: $Box($l#79#x#0 == c#0)), (lambda $l#79#heap#0: Heap, $l#79#x#0: Box :: $IsBox($l#79#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#79#heap#0: Heap, $l#79#x#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#x#0: Box :: $Box($l#84#x#0 == c#0)), (lambda $l#84#heap#0: Heap, $l#84#x#0: Box :: $IsBox($l#84#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#84#heap#0: Heap, $l#84#x#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#x#0: Box :: $Box($l#82#x#0 == c#0)), (lambda $l#82#heap#0: Heap, $l#82#x#0: Box :: $IsBox($l#82#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#82#heap#0: Heap, $l#82#x#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#x#0: Box :: $Box($l#87#x#0 == Lit(c#0))), (lambda $l#87#heap#0: Heap, $l#87#x#0: Box :: $IsBox($l#87#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#87#heap#0: Heap, $l#87#x#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#x#0: Box :: $Box($l#85#x#0 == Lit(c#0))), (lambda $l#85#heap#0: Heap, $l#85#x#0: Box :: $IsBox($l#85#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#85#heap#0: Heap, $l#85#x#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#20: int :: { Seq#Index(s#0, j#20) } i#0 <= j#20 && j#20 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#20))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#21: int :: { Seq#Index(s#0, j#21) } i#0 <= j#21 && j#21 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#21))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#20: int :: { Seq#Index(s#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#20))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#20))) && (forall i#21: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#21) } (LitInt(0) <= i#21 && i#21 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#21))) && (LitInt(0) <= i#21 && i#21 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#21))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#10: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#10) } LitInt(0) <= i#10 && i#10 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#10) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#_v0#0: Box :: value#0), (lambda $l#52#heap#0: Heap, $l#52#_v0#0: Box :: $IsBox($l#52#_v0#0, TInt)), (lambda $l#52#heap#0: Heap, $l#52#_v0#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#_v0#0: Box :: value#0), (lambda $l#54#heap#0: Heap, $l#54#_v0#0: Box :: $IsBox($l#54#_v0#0, TInt)), (lambda $l#54#heap#0: Heap, $l#54#_v0#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#_v0#0: Box :: Lit(value#0)), (lambda $l#56#heap#0: Heap, $l#56#_v0#0: Box :: $IsBox($l#56#_v0#0, TInt)), (lambda $l#56#heap#0: Heap, $l#56#_v0#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#26: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#26) } LitInt(0) <= k#26 ==> k#26 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#26)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#26: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#26) } LitInt(0) <= k#26 && k#26 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#26))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#27: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#27) } LitInt(0) <= k#27 ==> k#27 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#27)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#27: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#27) } LitInt(0) <= k#27 && k#27 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#27))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#28: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#28) } LitInt(0) <= k#28 ==> k#28 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#28)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#28: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#28) } LitInt(0) <= k#28 && k#28 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#28))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#26: int :: { Seq#Index(b#0, i#26) } { Seq#Index(a#0, i#26) } LitInt(0) <= i#26 && i#26 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#26) == Seq#Index(b#0, i#26)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#27: int :: { Seq#Index(b#0, i#27) } { Seq#Index(a#0, i#27) } LitInt(0) <= i#27 && i#27 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#27) == Seq#Index(Lit(b#0), i#27)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#28: int :: { Seq#Index(b#0, i#28) } { Seq#Index(a#0, i#28) } LitInt(0) <= i#28 && i#28 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#28) == Seq#Index(Lit(b#0), i#28)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#54: Box, y#54: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#54, x#54)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#54, y#54)): bool } $IsBox(x#54, StandardLibrary._default.Trichotomous$T) && $IsBox(y#54, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#54, y#54)): bool || x#54 == y#54 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#54, x#54)): bool) && (forall x#55: Box, y#55: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#55, x#55)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#55, y#55)): bool } $IsBox(x#55, StandardLibrary._default.Trichotomous$T) && $IsBox(y#55, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#55, y#55)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#55, x#55)): bool ==> false) && (forall x#56: Box, y#56: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#56, y#56)): bool } $IsBox(x#56, StandardLibrary._default.Trichotomous$T) && $IsBox(y#56, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#56, y#56)): bool ==> x#56 != y#56)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#57: Box, y#57: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#57, x#57)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#57, y#57)): bool } $IsBox(x#57, StandardLibrary._default.Trichotomous$T) && $IsBox(y#57, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#57, y#57)): bool || x#57 == y#57 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#57, x#57)): bool) && (forall x#58: Box, y#58: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#58, x#58)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#58, y#58)): bool } $IsBox(x#58, StandardLibrary._default.Trichotomous$T) && $IsBox(y#58, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#58, y#58)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#58, x#58)): bool ==> false) && (forall x#59: Box, y#59: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#59, y#59)): bool } $IsBox(x#59, StandardLibrary._default.Trichotomous$T) && $IsBox(y#59, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#59, y#59)): bool ==> x#59 != y#59)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#18: Box, y#18: Box, z#18: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#18, z#18)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#18, z#18)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#18, z#18)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#18, y#18)): bool } $IsBox(x#18, StandardLibrary._default.Transitive$T) && $IsBox(y#18, StandardLibrary._default.Transitive$T) && $IsBox(z#18, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#18, y#18)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#18, z#18)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#18, z#18)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#19: Box, y#19: Box, z#19: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#19, z#19)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#19, z#19)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#19, z#19)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#19, y#19)): bool } $IsBox(x#19, StandardLibrary._default.Transitive$T) && $IsBox(y#19, StandardLibrary._default.Transitive$T) && $IsBox(z#19, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#19, y#19)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#19, z#19)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#19, z#19)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#30: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#30)): Seq } LitInt(0) <= i#30 && i#30 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#30)]) && (forall k#10: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#10)) } { s#0[$Box(k#10)] } $Is(k#10, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#10)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#10))) && (forall i#31: int, _t#0#9: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#31)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#9)): Seq } _t#0#9 == i#31 - 1 ==> 0 < i#31 && i#31 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#9)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#31)): Seq, less#0)) && (forall i#32: int, j#10: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#10)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#32)): Seq } LitInt(0) <= i#32 && i#32 < j#10 && j#10 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#32)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#10)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#29 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#29)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#29))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#30 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#30)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#30))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#31 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#31)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#31))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#26: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#26, less#0) } { s#0[$Box(z#26)] } $Is(z#26, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#26)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#26, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#26: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#26, less#0) } { s#0[$Box(z#26)] } $Is(z#26, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#26)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#26, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#27: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#27, less#0) } { s#0[$Box(z#27)] } $Is(z#27, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#27)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#27, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#27: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#27, less#0) } { s#0[$Box(z#27)] } $Is(z#27, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#27)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#27, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#28: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#28, less#0) } { s#0[$Box(z#28)] } $Is(z#28, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#28)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#28, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#28: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#28, less#0) } { s#0[$Box(z#28)] } $Is(z#28, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#28)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#28, Lit(less#0)))));

const unique tytagFamily$Callee: TyTagFamily;

const unique field$Modifies: NameFamily;

const unique class.Base64.__default: ClassName;

function Base64.__default.IsBase64Char(c#0: char) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall c#0: char :: { Base64.__default.IsBase64Char(c#0) } Base64.__default.IsBase64Char#canCall(c#0) || (0 < $FunctionContextHeight && $Is(c#0, TChar)) ==> (Base64.__default.IsBase64Char(c#0) <==> c#0 == Lit(char#FromInt(43)) || c#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122))))));
axiom 0 <= $FunctionContextHeight ==> (forall c#0: char :: {:weight 3} { Base64.__default.IsBase64Char(Lit(c#0)) } Base64.__default.IsBase64Char#canCall(Lit(c#0)) || (0 < $FunctionContextHeight && $Is(c#0, TChar)) ==> (Base64.__default.IsBase64Char(Lit(c#0)) <==> Lit(c#0) == Lit(char#FromInt(43)) || Lit(c#0) == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(122))))));
}

function Base64.__default.IsBase64Char#canCall(c#0: char) : bool;

function Base64.__default.IsBase64Char#requires(char) : bool;

axiom (forall c#0: char :: { Base64.__default.IsBase64Char#requires(c#0) } $Is(c#0, TChar) ==> (Base64.__default.IsBase64Char#requires(c#0) <==> true));

procedure {:verboseName "Base64.IsBase64Char (well-formedness)"} CheckWellformed$$Base64.__default.IsBase64Char(c#0: char where $Is(c#0, TChar));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function Base64.__default.IsUnpaddedBase64String(s#0: Seq) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.IsUnpaddedBase64String(s#0) } Base64.__default.IsUnpaddedBase64String#canCall(s#0) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) ==> (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char#canCall(k#0))) && (Base64.__default.IsUnpaddedBase64String(s#0) <==> Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0))));
axiom 1 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.IsUnpaddedBase64String(Lit(s#0)) } Base64.__default.IsUnpaddedBase64String#canCall(Lit(s#0)) || (1 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) ==> (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(s#0, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(s#0, $Box(k#1)) ==> Base64.__default.IsBase64Char#canCall(k#1))) && (Base64.__default.IsUnpaddedBase64String(Lit(s#0)) <==> Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) && (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(s#0, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(s#0, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1))));
}

function Base64.__default.IsUnpaddedBase64String#canCall(s#0: Seq) : bool;

function Base64.__default.IsUnpaddedBase64String#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.IsUnpaddedBase64String#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.IsUnpaddedBase64String#requires(s#0) <==> true));

procedure {:verboseName "Base64.IsUnpaddedBase64String (well-formedness)"} CheckWellformed$$Base64.__default.IsUnpaddedBase64String(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IsUnpaddedBase64String (well-formedness)"} CheckWellformed$$Base64.__default.IsUnpaddedBase64String(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#2: char;
  var ##c#0: char;

  anon0:
    assume {:print "Impl", " | ", "Base64.IsUnpaddedBase64String", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(26,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    assume LitInt(4) != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    havoc k#2;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} $Is(k#2, TChar);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Contains(s#0, $Box(k#2));
    ##c#0 := k#2;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(k#2);
    goto anon7;

  anon12_Else:
    assume {:partition} !Seq#Contains(s#0, $Box(k#2));
    goto anon7;

  anon11_Else:
    assume {:partition} !$Is(k#2, TChar);
    goto anon7;

  anon7:
    goto anon8;

  anon10_Else:
    assume {:partition} Mod(Seq#Length(s#0), LitInt(4)) != LitInt(0);
    goto anon8;

  anon8:
    assume Base64.__default.IsUnpaddedBase64String(s#0) <==> Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (forall k#3: char :: { Base64.__default.IsBase64Char(k#3) } { Seq#Contains(s#0, $Box(k#3)) } $Is(k#3, TChar) ==> Seq#Contains(s#0, $Box(k#3)) ==> Base64.__default.IsBase64Char(k#3));
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) ==> (forall k#3: char :: { Base64.__default.IsBase64Char(k#3) } { Seq#Contains(s#0, $Box(k#3)) } $Is(k#3, TChar) ==> Seq#Contains(s#0, $Box(k#3)) ==> Base64.__default.IsBase64Char#canCall(k#3));
    assume $Is(Base64.__default.IsUnpaddedBase64String(s#0), TBool);
    return;
}



function Base64.__default.IndexToChar(i#0: int) : char
uses {
axiom 1 <= $FunctionContextHeight ==> (forall i#0: int :: { Base64.__default.IndexToChar(i#0) } Base64.__default.IndexToChar#canCall(i#0) || (1 < $FunctionContextHeight && LitInt(0) <= i#0 && i#0 < 64) ==> Base64.__default.IsBase64Char(Base64.__default.IndexToChar(i#0)) && $Is(Base64.__default.IndexToChar(i#0), TChar));
axiom 1 <= $FunctionContextHeight ==> (forall i#0: int :: { Base64.__default.IndexToChar(i#0) } Base64.__default.IndexToChar#canCall(i#0) || (1 < $FunctionContextHeight && LitInt(0) <= i#0 && i#0 < 64) ==> Base64.__default.IndexToChar(i#0) == (if i#0 == LitInt(63) then char#FromInt(47) else (if i#0 == LitInt(62) then char#FromInt(43) else (if LitInt(52) <= i#0 && i#0 <= LitInt(61) then char#FromInt(i#0 - 4) else (if LitInt(26) <= i#0 && i#0 <= LitInt(51) then char#Plus(char#FromInt(i#0), char#FromInt(LitInt(71))) else char#Plus(char#FromInt(i#0), char#FromInt(LitInt(65))))))));
axiom 1 <= $FunctionContextHeight ==> (forall i#0: int :: {:weight 3} { Base64.__default.IndexToChar(LitInt(i#0)) } Base64.__default.IndexToChar#canCall(LitInt(i#0)) || (1 < $FunctionContextHeight && LitInt(0) <= i#0 && i#0 < 64) ==> Base64.__default.IndexToChar(LitInt(i#0)) == (if LitInt(i#0) == LitInt(63) then char#FromInt(47) else (if LitInt(i#0) == LitInt(62) then char#FromInt(43) else (if LitInt(52) <= LitInt(i#0) && LitInt(i#0) <= LitInt(61) then char#FromInt(LitInt(i#0 - 4)) else (if LitInt(26) <= LitInt(i#0) && LitInt(i#0) <= LitInt(51) then char#Plus(char#FromInt(LitInt(i#0)), char#FromInt(LitInt(71))) else char#Plus(char#FromInt(LitInt(i#0)), char#FromInt(LitInt(65))))))));
}

function Base64.__default.IndexToChar#canCall(i#0: int) : bool;

function Base64.__default.IndexToChar#requires(int) : bool;

axiom (forall i#0: int :: { Base64.__default.IndexToChar#requires(i#0) } LitInt(0) <= i#0 && i#0 < 64 ==> (Base64.__default.IndexToChar#requires(i#0) <==> true));

procedure {:verboseName "Base64.IndexToChar (well-formedness)"} CheckWellformed$$Base64.__default.IndexToChar(i#0: int where LitInt(0) <= i#0 && i#0 < 64) returns (c#0: char where $Is(c#0, TChar));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17625"} Base64.__default.IsBase64Char#canCall(c#0) ==> Base64.__default.IsBase64Char(c#0) || c#0 == Lit(char#FromInt(43)) || c#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IndexToChar (well-formedness)"} CheckWellformed$$Base64.__default.IndexToChar(i#0: int) returns (c#0: char)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.IndexToChar", " | ", i#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(31,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume $Is(Base64.__default.IndexToChar(i#0), TChar);
    ##c#0 := c#0;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(c#0);
    assume Base64.__default.IsBase64Char(c#0);
    assume false;
    return;

  anon17_Else:
    newtype$check#0 := LitInt(63);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 64;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} i#0 == LitInt(63);
    assume Base64.__default.IndexToChar(i#0) == Lit(char#FromInt(47));
    assume true;
    assume $Is(Base64.__default.IndexToChar(i#0), TChar);
    goto anon16;

  anon18_Else:
    assume {:partition} i#0 != LitInt(63);
    newtype$check#1 := LitInt(62);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 64;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} i#0 == LitInt(62);
    assume Base64.__default.IndexToChar(i#0) == Lit(char#FromInt(43));
    assume true;
    assume $Is(Base64.__default.IndexToChar(i#0), TChar);
    goto anon16;

  anon19_Else:
    assume {:partition} i#0 != LitInt(62);
    newtype$check#2 := LitInt(52);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 64;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(52) <= i#0;
    newtype$check#3 := LitInt(61);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 64;
    goto anon9;

  anon20_Else:
    assume {:partition} i#0 < LitInt(52);
    goto anon9;

  anon9:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} LitInt(52) <= i#0 && i#0 <= LitInt(61);
    newtype$check#4 := LitInt(4);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 64;
    newtype$check#5 := i#0 - 4;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 64;
    newtype$check#6 := i#0 - 4;
    assume char#IsChar(newtype$check#6);
    assume Base64.__default.IndexToChar(i#0) == char#FromInt(i#0 - 4);
    assume true;
    assume $Is(Base64.__default.IndexToChar(i#0), TChar);
    goto anon16;

  anon21_Else:
    assume {:partition} !(LitInt(52) <= i#0 && i#0 <= LitInt(61));
    newtype$check#7 := LitInt(26);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 64;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(26) <= i#0;
    newtype$check#8 := LitInt(51);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 64;
    goto anon13;

  anon22_Else:
    assume {:partition} i#0 < LitInt(26);
    goto anon13;

  anon13:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(26) <= i#0 && i#0 <= LitInt(51);
    newtype$check#9 := i#0;
    assume char#IsChar(newtype$check#9);
    newtype$check#10 := LitInt(71);
    assume char#IsChar(newtype$check#10);
    assume char#IsChar(char#ToInt(char#FromInt(i#0)) + char#ToInt(char#FromInt(LitInt(71))));
    assume Base64.__default.IndexToChar(i#0) == char#Plus(char#FromInt(i#0), char#FromInt(LitInt(71)));
    assume true;
    assume $Is(Base64.__default.IndexToChar(i#0), TChar);
    goto anon16;

  anon23_Else:
    assume {:partition} !(LitInt(26) <= i#0 && i#0 <= LitInt(51));
    newtype$check#11 := i#0;
    assume char#IsChar(newtype$check#11);
    newtype$check#12 := LitInt(65);
    assume char#IsChar(newtype$check#12);
    assume char#IsChar(char#ToInt(char#FromInt(i#0)) + char#ToInt(char#FromInt(LitInt(65))));
    assume Base64.__default.IndexToChar(i#0) == char#Plus(char#FromInt(i#0), char#FromInt(LitInt(65)));
    assume true;
    assume $Is(Base64.__default.IndexToChar(i#0), TChar);
    goto anon16;

  anon16:
    assume Base64.__default.IndexToChar(i#0) == c#0;
    return;
}



function Base64.__default.CharToIndex(c#0: char) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall c#0: char :: { Base64.__default.CharToIndex(c#0) } Base64.__default.CharToIndex#canCall(c#0) || (2 < $FunctionContextHeight && $Is(c#0, TChar) && Base64.__default.IsBase64Char(c#0)) ==> Base64.__default.IndexToChar(Base64.__default.CharToIndex(c#0)) == c#0 && LitInt(0) <= Base64.__default.CharToIndex(c#0) && Base64.__default.CharToIndex(c#0) < 64);
axiom 2 <= $FunctionContextHeight ==> (forall c#0: char :: { Base64.__default.CharToIndex(c#0) } Base64.__default.CharToIndex#canCall(c#0) || (2 < $FunctionContextHeight && $Is(c#0, TChar) && Base64.__default.IsBase64Char(c#0)) ==> Base64.__default.CharToIndex(c#0) == (if c#0 == Lit(char#FromInt(47)) then 63 else (if c#0 == Lit(char#FromInt(43)) then 62 else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57))) then char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4)))) else (if char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122))) then char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71)))) else char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65)))))))));
axiom 2 <= $FunctionContextHeight ==> (forall c#0: char :: {:weight 3} { Base64.__default.CharToIndex(Lit(c#0)) } Base64.__default.CharToIndex#canCall(Lit(c#0)) || (2 < $FunctionContextHeight && $Is(c#0, TChar) && Lit(Base64.__default.IsBase64Char(Lit(c#0)))) ==> Base64.__default.CharToIndex(Lit(c#0)) == (if Lit(c#0) == Lit(char#FromInt(47)) then 63 else (if Lit(c#0) == Lit(char#FromInt(43)) then 62 else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(57))) then char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4)))) else (if char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(122))) then char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71)))) else char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65)))))))));
}

function Base64.__default.CharToIndex#canCall(c#0: char) : bool;

function Base64.__default.CharToIndex#requires(char) : bool;

axiom (forall c#0: char :: { Base64.__default.CharToIndex#requires(c#0) } $Is(c#0, TChar) ==> (Base64.__default.CharToIndex#requires(c#0) <==> Base64.__default.IsBase64Char(c#0)));

procedure {:verboseName "Base64.CharToIndex (well-formedness)"} CheckWellformed$$Base64.__default.CharToIndex(c#0: char where $Is(c#0, TChar)) returns (i#0: int where LitInt(0) <= i#0 && i#0 < 64);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17648"} Base64.__default.IndexToChar(i#0) == c#0;



function Tclass.Base64.index() : Ty
uses {
axiom Tag(Tclass.Base64.index()) == Tagclass.Base64.index && TagFamily(Tclass.Base64.index()) == tytagFamily$index;
}

const unique Tagclass.Base64.index: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Base64.index()) } $IsBox(bx, Tclass.Base64.index()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.Base64.index()));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.CharToIndex (well-formedness)"} CheckWellformed$$Base64.__default.CharToIndex(c#0: char) returns (i#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##i#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.CharToIndex", " | ", c#0} true;
    assume {:print "Types", " | ", "char"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(47,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##c#0 := c#0;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(c#0);
    assume Base64.__default.IsBase64Char(c#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume LitInt(0) <= Base64.__default.CharToIndex(c#0) && Base64.__default.CharToIndex(c#0) < 64;
    ##i#0 := i#0;
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall(i#0);
    assume Base64.__default.IndexToChar(i#0) == c#0;
    assume false;
    return;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} c#0 == Lit(char#FromInt(47));
    newtype$check#0 := LitInt(63);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 64;
    assume Base64.__default.CharToIndex(c#0) == LitInt(63);
    assume true;
    assume $Is(Base64.__default.CharToIndex(c#0), Tclass.Base64.index());
    goto anon16;

  anon18_Else:
    assume {:partition} c#0 != Lit(char#FromInt(47));
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} c#0 == Lit(char#FromInt(43));
    newtype$check#1 := LitInt(62);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 64;
    assume Base64.__default.CharToIndex(c#0) == LitInt(62);
    assume true;
    assume $Is(Base64.__default.CharToIndex(c#0), Tclass.Base64.index());
    goto anon16;

  anon19_Else:
    assume {:partition} c#0 != Lit(char#FromInt(43));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0);
    goto anon9;

  anon20_Else:
    assume {:partition} char#ToInt(c#0) < char#ToInt(Lit(char#FromInt(48)));
    goto anon9;

  anon9:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57)));
    newtype$check#2 := LitInt(4);
    assume char#IsChar(newtype$check#2);
    assume char#IsChar(char#ToInt(c#0) + char#ToInt(char#FromInt(LitInt(4))));
    newtype$check#3 := char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4))));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 64;
    newtype$check#4 := char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4))));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 64;
    assume Base64.__default.CharToIndex(c#0) == char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4))));
    assume true;
    assume $Is(Base64.__default.CharToIndex(c#0), Tclass.Base64.index());
    goto anon16;

  anon21_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57))));
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0);
    goto anon13;

  anon22_Else:
    assume {:partition} char#ToInt(c#0) < char#ToInt(Lit(char#FromInt(97)));
    goto anon13;

  anon13:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122)));
    newtype$check#5 := LitInt(71);
    assume char#IsChar(newtype$check#5);
    assume char#IsChar(char#ToInt(c#0) - char#ToInt(char#FromInt(LitInt(71))));
    newtype$check#6 := char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71))));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 64;
    newtype$check#7 := char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71))));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 64;
    assume Base64.__default.CharToIndex(c#0) == char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71))));
    assume true;
    assume $Is(Base64.__default.CharToIndex(c#0), Tclass.Base64.index());
    goto anon16;

  anon23_Else:
    assume {:partition} !(char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122))));
    newtype$check#8 := LitInt(65);
    assume char#IsChar(newtype$check#8);
    assume char#IsChar(char#ToInt(c#0) - char#ToInt(char#FromInt(LitInt(65))));
    newtype$check#9 := char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65))));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 64;
    newtype$check#10 := char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65))));
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 64;
    assume Base64.__default.CharToIndex(c#0) == char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65))));
    assume true;
    assume $Is(Base64.__default.CharToIndex(c#0), Tclass.Base64.index());
    goto anon16;

  anon16:
    assume Base64.__default.CharToIndex(c#0) == i#0;
    return;
}



procedure {:verboseName "Base64.CharToIndexToChar (well-formedness)"} CheckWellFormed$$Base64.__default.CharToIndexToChar(x#0: char where $Is(x#0, TChar));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.CharToIndexToChar (well-formedness)"} CheckWellFormed$$Base64.__default.CharToIndexToChar(x#0: char)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##c#1: char;
  var ##i#0: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.CharToIndexToChar", " | ", x#0} true;
    assume {:print "Types", " | ", "char"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(59,8): initial state"} true;
    ##c#0 := x#0;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(x#0);
    assume Base64.__default.IsBase64Char(x#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(61,40): post-state"} true;
    ##c#1 := x#0;
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#1) ==> Base64.__default.IsBase64Char(##c#1) || ##c#1 == Lit(char#FromInt(43)) || ##c#1 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#1);
    assume Base64.__default.CharToIndex#canCall(x#0);
    ##i#0 := Base64.__default.CharToIndex(x#0);
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall(Base64.__default.CharToIndex(x#0));
    assume Base64.__default.IndexToChar(Base64.__default.CharToIndex(x#0)) == x#0;
    return;
}



procedure {:verboseName "Base64.CharToIndexToChar (call precondtion)"} CallPre$$Base64.__default.CharToIndexToChar(x#0: char where $Is(x#0, TChar));
  requires {:id "id17674"} Base64.__default.IsBase64Char#canCall(x#0) ==> Base64.__default.IsBase64Char(x#0) || x#0 == Lit(char#FromInt(43)) || x#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(x#0) && char#ToInt(x#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(x#0) && char#ToInt(x#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(x#0) && char#ToInt(x#0) <= char#ToInt(Lit(char#FromInt(122))));



procedure {:verboseName "Base64.CharToIndexToChar (call postcondition)"} CallPost$$Base64.__default.CharToIndexToChar(x#0: char where $Is(x#0, TChar));
  modifies $Heap;
  free ensures Base64.__default.CharToIndex#canCall(x#0) && Base64.__default.IndexToChar#canCall(Base64.__default.CharToIndex(x#0));
  free ensures {:id "id17675"} Base64.__default.IndexToChar(Base64.__default.CharToIndex(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.CharToIndexToChar (correctness)"} Impl$$Base64.__default.CharToIndexToChar(x#0: char where $Is(x#0, TChar)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id17676"} Base64.__default.IsBase64Char#canCall(x#0) && Base64.__default.IsBase64Char(x#0) && (x#0 == Lit(char#FromInt(43)) || x#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(x#0) && char#ToInt(x#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(x#0) && char#ToInt(x#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(x#0) && char#ToInt(x#0) <= char#ToInt(Lit(char#FromInt(122)))));
  modifies $Heap;
  free ensures Base64.__default.CharToIndex#canCall(x#0) && Base64.__default.IndexToChar#canCall(Base64.__default.CharToIndex(x#0));
  free ensures {:id "id17677"} Base64.__default.IndexToChar(Base64.__default.CharToIndex(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.CharToIndexToChar (correctness)"} Impl$$Base64.__default.CharToIndexToChar(x#0: char) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.CharToIndexToChar", " | ", x#0} true;
    assume {:print "Types", " | ", "char"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(62,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.IndexToCharToIndex (well-formedness)"} CheckWellFormed$$Base64.__default.IndexToCharToIndex(x#0: int where LitInt(0) <= x#0 && x#0 < 64);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IndexToCharToIndex (well-formedness)"} CheckWellFormed$$Base64.__default.IndexToCharToIndex(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##i#0: int;
  var ##c#0: char;

  anon0:
    assume {:print "Impl", " | ", "Base64.IndexToCharToIndex", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(64,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(65,40): post-state"} true;
    ##i#0 := x#0;
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall(x#0);
    ##c#0 := Base64.__default.IndexToChar(x#0);
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#0) ==> Base64.__default.IsBase64Char(##c#0) || ##c#0 == Lit(char#FromInt(43)) || ##c#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#0);
    assume Base64.__default.CharToIndex#canCall(Base64.__default.IndexToChar(x#0));
    assume Base64.__default.CharToIndex(Base64.__default.IndexToChar(x#0)) == x#0;
    return;
}



procedure {:verboseName "Base64.IndexToCharToIndex (call precondtion)"} CallPre$$Base64.__default.IndexToCharToIndex(x#0: int where LitInt(0) <= x#0 && x#0 < 64);



procedure {:verboseName "Base64.IndexToCharToIndex (call postcondition)"} CallPost$$Base64.__default.IndexToCharToIndex(x#0: int where LitInt(0) <= x#0 && x#0 < 64);
  modifies $Heap;
  free ensures Base64.__default.IndexToChar#canCall(x#0) && Base64.__default.CharToIndex#canCall(Base64.__default.IndexToChar(x#0));
  free ensures {:id "id17680"} Base64.__default.CharToIndex(Base64.__default.IndexToChar(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.IndexToCharToIndex (correctness)"} Impl$$Base64.__default.IndexToCharToIndex(x#0: int where LitInt(0) <= x#0 && x#0 < 64) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.IndexToChar#canCall(x#0) && Base64.__default.CharToIndex#canCall(Base64.__default.IndexToChar(x#0));
  free ensures {:id "id17681"} Base64.__default.CharToIndex(Base64.__default.IndexToChar(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IndexToCharToIndex (correctness)"} Impl$$Base64.__default.IndexToCharToIndex(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.IndexToCharToIndex", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(66,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.UInt24ToSeq(x#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { Base64.__default.UInt24ToSeq(x#0) } Base64.__default.UInt24ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < 16777216) ==> Seq#Length(Base64.__default.UInt24ToSeq(x#0)) == LitInt(3) && Mul($Unbox(Seq#Index(Base64.__default.UInt24ToSeq(x#0), LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(Base64.__default.UInt24ToSeq(x#0), LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(Base64.__default.UInt24ToSeq(x#0), LitInt(2))): int == x#0 && $Is(Base64.__default.UInt24ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { Base64.__default.UInt24ToSeq(x#0) } Base64.__default.UInt24ToSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToSeq(x#0) == (var b0#0 := Div(x#0, LitInt(65536)); (var x0#0 := x#0 - Mul(b0#0, LitInt(65536)); (var b1#0 := Div(x0#0, LitInt(256)); (var b2#0 := Mod(x0#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0)), $Box(b1#0)), $Box(b2#0)))))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { Base64.__default.UInt24ToSeq(LitInt(x#0)) } Base64.__default.UInt24ToSeq#canCall(LitInt(x#0)) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToSeq(LitInt(x#0)) == (var b0#1 := LitInt(Div(x#0, LitInt(65536))); (var x0#1 := LitInt(x#0 - Mul(b0#1, LitInt(65536))); (var b1#1 := LitInt(Div(x0#1, LitInt(256))); (var b2#1 := LitInt(Mod(x0#1, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#1)), $Box(b1#1)), $Box(b2#1))))))));
}

function Base64.__default.UInt24ToSeq#canCall(x#0: int) : bool;

function Base64.__default.UInt24ToSeq#requires(int) : bool;

axiom (forall x#0: int :: { Base64.__default.UInt24ToSeq#requires(x#0) } LitInt(0) <= x#0 && x#0 < 16777216 ==> (Base64.__default.UInt24ToSeq#requires(x#0) <==> true));

procedure {:verboseName "Base64.UInt24ToSeq (well-formedness)"} CheckWellformed$$Base64.__default.UInt24ToSeq(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17682"} Seq#Length(ret#0) == LitInt(3);
  free ensures {:id "id17683"} Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(ret#0, LitInt(2))): int == x#0;



function Tclass.Base64.uint24() : Ty
uses {
axiom Tag(Tclass.Base64.uint24()) == Tagclass.Base64.uint24 && TagFamily(Tclass.Base64.uint24()) == tytagFamily$uint24;
}

const unique Tagclass.Base64.uint24: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.Base64.uint24()) } $IsBox(bx, Tclass.Base64.uint24()) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.Base64.uint24()));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.UInt24ToSeq (well-formedness)"} CheckWellformed$$Base64.__default.UInt24ToSeq(x#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var b0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var x0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var b1#Z#0: int;
  var let#2#0#0: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var b2#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#25: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.UInt24ToSeq", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(68,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.UInt24ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(ret#0) == LitInt(3);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    newtype$check#0 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 16777216;
    newtype$check#1 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 16777216;
    newtype$check#2 := LitInt(65536);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 16777216;
    newtype$check#3 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 16777216;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(ret#0);
    newtype$check#4 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 16777216;
    newtype$check#5 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 16777216;
    newtype$check#6 := LitInt(256);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 16777216;
    newtype$check#7 := Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 16777216;
    newtype$check#8 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 16777216;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(ret#0);
    newtype$check#9 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 16777216;
    newtype$check#10 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 16777216;
    newtype$check#11 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < 16777216;
    assume Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(ret#0, LitInt(2))): int == x#0;
    assume false;
    return;

  anon4_Else:
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#12 := LitInt(65536);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < 16777216;
    assume LitInt(65536) != 0;
    newtype$check#13 := Div(x#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < 16777216;
    newtype$check#14 := Div(x#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#15 := Div(x#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0#0#0 == Div(x#0, LitInt(65536));
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0 == let#0#0#0;
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < 16777216;
    newtype$check#16 := b0#Z#0;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < 16777216;
    newtype$check#17 := b0#Z#0;
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < 16777216;
    newtype$check#18 := LitInt(65536);
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < 16777216;
    newtype$check#19 := Mul(b0#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < 16777216;
    newtype$check#20 := x#0 - Mul(b0#Z#0, LitInt(65536));
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < 16777216;
    assume let#1#0#0 == x#0 - Mul(b0#Z#0, LitInt(65536));
    assume true;
    assume $Is(let#1#0#0, Tclass.Base64.uint24());
    assume x0#Z#0 == let#1#0#0;
    havoc b1#Z#0;
    assume LitInt(0) <= b1#Z#0 && b1#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#21 := LitInt(256);
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < 16777216;
    assume LitInt(256) != 0;
    newtype$check#22 := Div(x0#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < 16777216;
    newtype$check#23 := Div(x0#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#24 := Div(x0#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#2#0#0 == Div(x0#Z#0, LitInt(256));
    assume true;
    assume $Is(let#2#0#0, Tclass.BoundedInts.uint8());
    assume b1#Z#0 == let#2#0#0;
    havoc b2#Z#0;
    assume LitInt(0) <= b2#Z#0 && b2#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#25 := LitInt(256);
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < 16777216;
    assume LitInt(256) != 0;
    newtype$check#26 := Mod(x0#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < 16777216;
    newtype$check#27 := Mod(x0#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#28 := Mod(x0#Z#0, LitInt(256));
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#3#0#0 == Mod(x0#Z#0, LitInt(256));
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint8());
    assume b2#Z#0 == let#3#0#0;
    assume Base64.__default.UInt24ToSeq(x#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#Z#0)), $Box(b1#Z#0)), $Box(b2#Z#0));
    assume true;
    assume $Is(Base64.__default.UInt24ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Base64.__default.UInt24ToSeq(x#0) == ret#0;
    return;
}



function Base64.__default.SeqToUInt24(s#0: Seq) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.SeqToUInt24(s#0) } Base64.__default.SeqToUInt24#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.SeqToUInt24(s#0)), s#0) && LitInt(0) <= Base64.__default.SeqToUInt24(s#0) && Base64.__default.SeqToUInt24(s#0) < 16777216);
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.SeqToUInt24(s#0) } Base64.__default.SeqToUInt24#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Base64.__default.SeqToUInt24(s#0) == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int);
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.SeqToUInt24(Lit(s#0)) } Base64.__default.SeqToUInt24#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> Base64.__default.SeqToUInt24(Lit(s#0)) == Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int);
}

function Base64.__default.SeqToUInt24#canCall(s#0: Seq) : bool;

function Base64.__default.SeqToUInt24#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.SeqToUInt24#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.SeqToUInt24#requires(s#0) <==> Seq#Length(s#0) == LitInt(3)));

procedure {:verboseName "Base64.SeqToUInt24 (well-formedness)"} CheckWellformed$$Base64.__default.SeqToUInt24(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) returns (x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17731"} Seq#Equal(Base64.__default.UInt24ToSeq(x#0), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.SeqToUInt24 (well-formedness)"} CheckWellformed$$Base64.__default.SeqToUInt24(s#0: Seq) returns (x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.SeqToUInt24", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(80,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(3);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= Base64.__default.SeqToUInt24(s#0) && Base64.__default.SeqToUInt24(s#0) < 16777216;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToSeq#canCall(x#0);
    assume Seq#Equal(Base64.__default.UInt24ToSeq(x#0), s#0);
    assume false;
    return;

  anon4_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 16777216;
    newtype$check#1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 16777216;
    newtype$check#2 := LitInt(65536);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 16777216;
    newtype$check#3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(65536));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 16777216;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 16777216;
    newtype$check#5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 16777216;
    newtype$check#6 := LitInt(256);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 16777216;
    newtype$check#7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 16777216;
    newtype$check#8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 16777216;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 16777216;
    newtype$check#10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 16777216;
    newtype$check#11 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < 16777216;
    assume Base64.__default.SeqToUInt24(s#0) == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume true;
    assume $Is(Base64.__default.SeqToUInt24(s#0), Tclass.Base64.uint24());
    assume Base64.__default.SeqToUInt24(s#0) == x#0;
    return;
}



procedure {:verboseName "Base64.UInt24ToSeqToUInt24 (well-formedness)"} CheckWellFormed$$Base64.__default.UInt24ToSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.UInt24ToSeqToUInt24 (well-formedness)"} CheckWellFormed$$Base64.__default.UInt24ToSeqToUInt24(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.UInt24ToSeqToUInt24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(87,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(88,40): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToSeq#canCall(x#0);
    ##s#0 := Base64.__default.UInt24ToSeq(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(3);
    assume Seq#Length(##s#0) == LitInt(3);
    assume Base64.__default.SeqToUInt24#canCall(Base64.__default.UInt24ToSeq(x#0));
    assume Base64.__default.SeqToUInt24(Base64.__default.UInt24ToSeq(x#0)) == x#0;
    return;
}



procedure {:verboseName "Base64.UInt24ToSeqToUInt24 (call precondtion)"} CallPre$$Base64.__default.UInt24ToSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);



procedure {:verboseName "Base64.UInt24ToSeqToUInt24 (call postcondition)"} CallPost$$Base64.__default.UInt24ToSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);
  modifies $Heap;
  free ensures Base64.__default.UInt24ToSeq#canCall(x#0) && Base64.__default.SeqToUInt24#canCall(Base64.__default.UInt24ToSeq(x#0));
  free ensures {:id "id17753"} Base64.__default.SeqToUInt24(Base64.__default.UInt24ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.UInt24ToSeqToUInt24 (correctness)"} Impl$$Base64.__default.UInt24ToSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.UInt24ToSeq#canCall(x#0) && Base64.__default.SeqToUInt24#canCall(Base64.__default.UInt24ToSeq(x#0));
  free ensures {:id "id17754"} Base64.__default.SeqToUInt24(Base64.__default.UInt24ToSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.UInt24ToSeqToUInt24 (correctness)"} Impl$$Base64.__default.UInt24ToSeqToUInt24(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.UInt24ToSeqToUInt24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(89,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.SeqToUInt24ToSeq (well-formedness)"} CheckWellFormed$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.SeqToUInt24ToSeq (well-formedness)"} CheckWellFormed$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.SeqToUInt24ToSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(91,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(3);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(93,40): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(3);
    assume Seq#Length(##s#0) == LitInt(3);
    assume Base64.__default.SeqToUInt24#canCall(s#0);
    ##x#0 := Base64.__default.SeqToUInt24(s#0);
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToSeq#canCall(Base64.__default.SeqToUInt24(s#0));
    assume Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.SeqToUInt24(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.SeqToUInt24ToSeq (call precondtion)"} CallPre$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id17758"} Seq#Length(s#0) == LitInt(3);



procedure {:verboseName "Base64.SeqToUInt24ToSeq (call postcondition)"} CallPost$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.SeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToSeq#canCall(Base64.__default.SeqToUInt24(s#0));
  free ensures {:id "id17759"} Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.SeqToUInt24(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.SeqToUInt24ToSeq (correctness)"} Impl$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id17760"} Seq#Length(s#0) == LitInt(3);
  modifies $Heap;
  free ensures Base64.__default.SeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToSeq#canCall(Base64.__default.SeqToUInt24(s#0));
  free ensures {:id "id17761"} Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.SeqToUInt24(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.SeqToUInt24ToSeq (correctness)"} Impl$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.SeqToUInt24ToSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(94,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.UInt24ToIndexSeq(x#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { Base64.__default.UInt24ToIndexSeq(x#0) } Base64.__default.UInt24ToIndexSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < 16777216) ==> Seq#Length(Base64.__default.UInt24ToIndexSeq(x#0)) == LitInt(4) && Mul($Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(3))): int == x#0 && $Is(Base64.__default.UInt24ToIndexSeq(x#0), TSeq(Tclass.Base64.index())));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: { Base64.__default.UInt24ToIndexSeq(x#0) } Base64.__default.UInt24ToIndexSeq#canCall(x#0) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToIndexSeq(x#0) == (var b0#0 := Div(x#0, LitInt(262144)); (var x0#0 := x#0 - Mul(b0#0, LitInt(262144)); (var b1#0 := Div(x0#0, LitInt(4096)); (var x1#0 := x0#0 - Mul(b1#0, LitInt(4096)); (var b2#0 := Div(x1#0, LitInt(64)); (var b3#0 := Mod(x1#0, LitInt(64)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#0)), $Box(b1#0)), $Box(b2#0)), $Box(b3#0)))))))));
axiom 1 <= $FunctionContextHeight ==> (forall x#0: int :: {:weight 3} { Base64.__default.UInt24ToIndexSeq(LitInt(x#0)) } Base64.__default.UInt24ToIndexSeq#canCall(LitInt(x#0)) || (1 < $FunctionContextHeight && LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToIndexSeq(LitInt(x#0)) == (var b0#1 := LitInt(Div(x#0, LitInt(262144))); (var x0#1 := LitInt(x#0 - Mul(b0#1, LitInt(262144))); (var b1#1 := LitInt(Div(x0#1, LitInt(4096))); (var x1#1 := LitInt(x0#1 - Mul(b1#1, LitInt(4096))); (var b2#1 := LitInt(Div(x1#1, LitInt(64))); (var b3#1 := LitInt(Mod(x1#1, LitInt(64))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#1)), $Box(b1#1)), $Box(b2#1)), $Box(b3#1))))))))));
}

function Base64.__default.UInt24ToIndexSeq#canCall(x#0: int) : bool;

function Base64.__default.UInt24ToIndexSeq#requires(int) : bool;

axiom (forall x#0: int :: { Base64.__default.UInt24ToIndexSeq#requires(x#0) } LitInt(0) <= x#0 && x#0 < 16777216 ==> (Base64.__default.UInt24ToIndexSeq#requires(x#0) <==> true));

procedure {:verboseName "Base64.UInt24ToIndexSeq (well-formedness)"} CheckWellformed$$Base64.__default.UInt24ToIndexSeq(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.Base64.index())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17762"} Seq#Length(ret#0) == LitInt(4);
  free ensures {:id "id17763"} Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(ret#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(ret#0, LitInt(3))): int == x#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.UInt24ToIndexSeq (well-formedness)"} CheckWellformed$$Base64.__default.UInt24ToIndexSeq(x#0: int) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var b0#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var x0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var b1#Z#0: int;
  var let#2#0#0: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;
  var newtype$check#29: int;
  var x1#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#30: int;
  var newtype$check#31: int;
  var newtype$check#32: int;
  var newtype$check#33: int;
  var newtype$check#34: int;
  var b2#Z#0: int;
  var let#4#0#0: int;
  var newtype$check#35: int;
  var newtype$check#36: int;
  var newtype$check#37: int;
  var newtype$check#38: int;
  var b3#Z#0: int;
  var let#5#0#0: int;
  var newtype$check#39: int;
  var newtype$check#40: int;
  var newtype$check#41: int;
  var newtype$check#42: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.UInt24ToIndexSeq", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(96,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.UInt24ToIndexSeq(x#0), TSeq(Tclass.Base64.index()));
    assume Seq#Length(ret#0) == LitInt(4);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ret#0);
    newtype$check#0 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 16777216;
    newtype$check#1 := $Unbox(Seq#Index(ret#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 16777216;
    newtype$check#2 := LitInt(262144);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 16777216;
    newtype$check#3 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(262144));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 16777216;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(ret#0);
    newtype$check#4 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 16777216;
    newtype$check#5 := $Unbox(Seq#Index(ret#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 16777216;
    newtype$check#6 := LitInt(4096);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 16777216;
    newtype$check#7 := Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(4096));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 16777216;
    newtype$check#8 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(4096));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 16777216;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(ret#0);
    newtype$check#9 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 16777216;
    newtype$check#10 := $Unbox(Seq#Index(ret#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 16777216;
    newtype$check#11 := LitInt(64);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < 16777216;
    newtype$check#12 := Mul($Unbox(Seq#Index(ret#0, LitInt(2))): int, LitInt(64));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < 16777216;
    newtype$check#13 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(ret#0, LitInt(2))): int, LitInt(64));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < 16777216;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(ret#0);
    newtype$check#14 := $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < 16777216;
    newtype$check#15 := $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < 16777216;
    newtype$check#16 := Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(ret#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(ret#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < 16777216;
    assume Mul($Unbox(Seq#Index(ret#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(ret#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(ret#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(ret#0, LitInt(3))): int == x#0;
    assume false;
    return;

  anon4_Else:
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < 64;
    newtype$check#17 := LitInt(262144);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < 16777216;
    assume LitInt(262144) != 0;
    newtype$check#18 := Div(x#0, LitInt(262144));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < 16777216;
    newtype$check#19 := Div(x#0, LitInt(262144));
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < 64;
    newtype$check#20 := Div(x#0, LitInt(262144));
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < 64;
    assume let#0#0#0 == Div(x#0, LitInt(262144));
    assume true;
    assume $Is(let#0#0#0, Tclass.Base64.index());
    assume b0#Z#0 == let#0#0#0;
    havoc x0#Z#0;
    assume LitInt(0) <= x0#Z#0 && x0#Z#0 < 16777216;
    newtype$check#21 := b0#Z#0;
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < 16777216;
    newtype$check#22 := b0#Z#0;
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < 16777216;
    newtype$check#23 := LitInt(262144);
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < 16777216;
    newtype$check#24 := Mul(b0#Z#0, LitInt(262144));
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < 16777216;
    newtype$check#25 := x#0 - Mul(b0#Z#0, LitInt(262144));
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < 16777216;
    assume let#1#0#0 == x#0 - Mul(b0#Z#0, LitInt(262144));
    assume true;
    assume $Is(let#1#0#0, Tclass.Base64.uint24());
    assume x0#Z#0 == let#1#0#0;
    havoc b1#Z#0;
    assume LitInt(0) <= b1#Z#0 && b1#Z#0 < 64;
    newtype$check#26 := LitInt(4096);
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < 16777216;
    assume LitInt(4096) != 0;
    newtype$check#27 := Div(x0#Z#0, LitInt(4096));
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < 16777216;
    newtype$check#28 := Div(x0#Z#0, LitInt(4096));
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < 64;
    newtype$check#29 := Div(x0#Z#0, LitInt(4096));
    assume LitInt(0) <= newtype$check#29 && newtype$check#29 < 64;
    assume let#2#0#0 == Div(x0#Z#0, LitInt(4096));
    assume true;
    assume $Is(let#2#0#0, Tclass.Base64.index());
    assume b1#Z#0 == let#2#0#0;
    havoc x1#Z#0;
    assume LitInt(0) <= x1#Z#0 && x1#Z#0 < 16777216;
    newtype$check#30 := b1#Z#0;
    assume LitInt(0) <= newtype$check#30 && newtype$check#30 < 16777216;
    newtype$check#31 := b1#Z#0;
    assume LitInt(0) <= newtype$check#31 && newtype$check#31 < 16777216;
    newtype$check#32 := LitInt(4096);
    assume LitInt(0) <= newtype$check#32 && newtype$check#32 < 16777216;
    newtype$check#33 := Mul(b1#Z#0, LitInt(4096));
    assume LitInt(0) <= newtype$check#33 && newtype$check#33 < 16777216;
    newtype$check#34 := x0#Z#0 - Mul(b1#Z#0, LitInt(4096));
    assume LitInt(0) <= newtype$check#34 && newtype$check#34 < 16777216;
    assume let#3#0#0 == x0#Z#0 - Mul(b1#Z#0, LitInt(4096));
    assume true;
    assume $Is(let#3#0#0, Tclass.Base64.uint24());
    assume x1#Z#0 == let#3#0#0;
    havoc b2#Z#0;
    assume LitInt(0) <= b2#Z#0 && b2#Z#0 < 64;
    newtype$check#35 := LitInt(64);
    assume LitInt(0) <= newtype$check#35 && newtype$check#35 < 16777216;
    assume LitInt(64) != 0;
    newtype$check#36 := Div(x1#Z#0, LitInt(64));
    assume LitInt(0) <= newtype$check#36 && newtype$check#36 < 16777216;
    newtype$check#37 := Div(x1#Z#0, LitInt(64));
    assume LitInt(0) <= newtype$check#37 && newtype$check#37 < 64;
    newtype$check#38 := Div(x1#Z#0, LitInt(64));
    assume LitInt(0) <= newtype$check#38 && newtype$check#38 < 64;
    assume let#4#0#0 == Div(x1#Z#0, LitInt(64));
    assume true;
    assume $Is(let#4#0#0, Tclass.Base64.index());
    assume b2#Z#0 == let#4#0#0;
    havoc b3#Z#0;
    assume LitInt(0) <= b3#Z#0 && b3#Z#0 < 64;
    newtype$check#39 := LitInt(64);
    assume LitInt(0) <= newtype$check#39 && newtype$check#39 < 16777216;
    assume LitInt(64) != 0;
    newtype$check#40 := Mod(x1#Z#0, LitInt(64));
    assume LitInt(0) <= newtype$check#40 && newtype$check#40 < 16777216;
    newtype$check#41 := Mod(x1#Z#0, LitInt(64));
    assume LitInt(0) <= newtype$check#41 && newtype$check#41 < 64;
    newtype$check#42 := Mod(x1#Z#0, LitInt(64));
    assume LitInt(0) <= newtype$check#42 && newtype$check#42 < 64;
    assume let#5#0#0 == Mod(x1#Z#0, LitInt(64));
    assume true;
    assume $Is(let#5#0#0, Tclass.Base64.index());
    assume b3#Z#0 == let#5#0#0;
    assume Base64.__default.UInt24ToIndexSeq(x#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#Z#0)), $Box(b1#Z#0)), $Box(b2#Z#0)), $Box(b3#Z#0));
    assume true;
    assume $Is(Base64.__default.UInt24ToIndexSeq(x#0), TSeq(Tclass.Base64.index()));
    assume Base64.__default.UInt24ToIndexSeq(x#0) == ret#0;
    return;
}



function Base64.__default.IndexSeqToUInt24(s#0: Seq) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.IndexSeqToUInt24(s#0) } Base64.__default.IndexSeqToUInt24#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.IndexSeqToUInt24(s#0)), s#0) && LitInt(0) <= Base64.__default.IndexSeqToUInt24(s#0) && Base64.__default.IndexSeqToUInt24(s#0) < 16777216);
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.IndexSeqToUInt24(s#0) } Base64.__default.IndexSeqToUInt24#canCall(s#0) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24(s#0) == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(s#0, LitInt(3))): int);
axiom 2 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.IndexSeqToUInt24(Lit(s#0)) } Base64.__default.IndexSeqToUInt24#canCall(Lit(s#0)) || (2 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24(Lit(s#0)) == Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int);
}

function Base64.__default.IndexSeqToUInt24#canCall(s#0: Seq) : bool;

function Base64.__default.IndexSeqToUInt24#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.IndexSeqToUInt24#requires(s#0) } $Is(s#0, TSeq(Tclass.Base64.index())) ==> (Base64.__default.IndexSeqToUInt24#requires(s#0) <==> Seq#Length(s#0) == LitInt(4)));

procedure {:verboseName "Base64.IndexSeqToUInt24 (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$Base64.__default.IndexSeqToUInt24(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index()))) returns (x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17831"} Seq#Equal(Base64.__default.UInt24ToIndexSeq(x#0), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IndexSeqToUInt24 (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$Base64.__default.IndexSeqToUInt24(s#0: Seq) returns (x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.IndexSeqToUInt24", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(114,47): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(4);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= Base64.__default.IndexSeqToUInt24(s#0) && Base64.__default.IndexSeqToUInt24(s#0) < 16777216;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToIndexSeq#canCall(x#0);
    assume Seq#Equal(Base64.__default.UInt24ToIndexSeq(x#0), s#0);
    assume false;
    return;

  anon4_Else:
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    newtype$check#0 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 16777216;
    newtype$check#1 := $Unbox(Seq#Index(s#0, LitInt(0))): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 16777216;
    newtype$check#2 := LitInt(262144);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 16777216;
    newtype$check#3 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < 16777216;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    newtype$check#4 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < 16777216;
    newtype$check#5 := $Unbox(Seq#Index(s#0, LitInt(1))): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < 16777216;
    newtype$check#6 := LitInt(4096);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < 16777216;
    newtype$check#7 := Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < 16777216;
    newtype$check#8 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < 16777216;
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    newtype$check#9 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < 16777216;
    newtype$check#10 := $Unbox(Seq#Index(s#0, LitInt(2))): int;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < 16777216;
    newtype$check#11 := LitInt(64);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < 16777216;
    newtype$check#12 := Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(64));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < 16777216;
    newtype$check#13 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(64));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < 16777216;
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    newtype$check#14 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < 16777216;
    newtype$check#15 := $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < 16777216;
    newtype$check#16 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < 16777216;
    assume Base64.__default.IndexSeqToUInt24(s#0) == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(s#0, LitInt(3))): int;
    assume true;
    assume $Is(Base64.__default.IndexSeqToUInt24(s#0), Tclass.Base64.uint24());
    assume Base64.__default.IndexSeqToUInt24(s#0) == x#0;
    return;
}



procedure {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (well-formedness)"} CheckWellFormed$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (well-formedness)"} CheckWellFormed$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##x#0: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.UInt24ToIndexSeqToUInt24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(121,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(122,50): post-state"} true;
    ##x#0 := x#0;
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToIndexSeq#canCall(x#0);
    ##s#0 := Base64.__default.UInt24ToIndexSeq(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume Base64.__default.IndexSeqToUInt24#canCall(Base64.__default.UInt24ToIndexSeq(x#0));
    assume Base64.__default.IndexSeqToUInt24(Base64.__default.UInt24ToIndexSeq(x#0)) == x#0;
    return;
}



procedure {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (call precondtion)"} CallPre$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);



procedure {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (call postcondition)"} CallPost$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216);
  modifies $Heap;
  free ensures Base64.__default.UInt24ToIndexSeq#canCall(x#0) && Base64.__default.IndexSeqToUInt24#canCall(Base64.__default.UInt24ToIndexSeq(x#0));
  free ensures {:id "id17859"} Base64.__default.IndexSeqToUInt24(Base64.__default.UInt24ToIndexSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (correctness)"} Impl$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int where LitInt(0) <= x#0 && x#0 < 16777216) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.UInt24ToIndexSeq#canCall(x#0) && Base64.__default.IndexSeqToUInt24#canCall(Base64.__default.UInt24ToIndexSeq(x#0));
  free ensures {:id "id17860"} Base64.__default.IndexSeqToUInt24(Base64.__default.UInt24ToIndexSeq(x#0)) == x#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (correctness)"} Impl$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.UInt24ToIndexSeqToUInt24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(123,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (well-formedness)"} CheckWellFormed$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (well-formedness)"} CheckWellFormed$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.IndexSeqToUInt24ToIndexSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(125,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(4);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(127,50): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume Base64.__default.IndexSeqToUInt24#canCall(s#0);
    ##x#0 := Base64.__default.IndexSeqToUInt24(s#0);
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0));
    assume Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.IndexSeqToUInt24(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (call precondtion)"} CallPre$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  requires {:id "id17864"} Seq#Length(s#0) == LitInt(4);



procedure {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (call postcondition)"} CallPost$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.IndexSeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0));
  free ensures {:id "id17865"} Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.IndexSeqToUInt24(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (correctness)"} Impl$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id17866"} Seq#Length(s#0) == LitInt(4);
  modifies $Heap;
  free ensures Base64.__default.IndexSeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0));
  free ensures {:id "id17867"} Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.IndexSeqToUInt24(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (correctness)"} Impl$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.IndexSeqToUInt24ToIndexSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(128,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.DecodeBlock(s#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.DecodeBlock(s#0) } Base64.__default.DecodeBlock#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Seq#Length(Base64.__default.DecodeBlock(s#0)) == LitInt(3) && Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(Base64.__default.DecodeBlock(s#0))), s#0) && $Is(Base64.__default.DecodeBlock(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.DecodeBlock(s#0) } Base64.__default.DecodeBlock#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0)) && Base64.__default.DecodeBlock(s#0) == Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(s#0)));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.DecodeBlock(Lit(s#0)) } Base64.__default.DecodeBlock#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24#canCall(Lit(s#0)) && Base64.__default.UInt24ToSeq#canCall(LitInt(Base64.__default.IndexSeqToUInt24(Lit(s#0)))) && Base64.__default.DecodeBlock(Lit(s#0)) == Lit(Base64.__default.UInt24ToSeq(LitInt(Base64.__default.IndexSeqToUInt24(Lit(s#0))))));
}

function Base64.__default.DecodeBlock#canCall(s#0: Seq) : bool;

function Base64.__default.DecodeBlock#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.DecodeBlock#requires(s#0) } $Is(s#0, TSeq(Tclass.Base64.index())) ==> (Base64.__default.DecodeBlock#requires(s#0) <==> Seq#Length(s#0) == LitInt(4)));

procedure {:verboseName "Base64.DecodeBlock (well-formedness)"} CheckWellformed$$Base64.__default.DecodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index()))) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17868"} Seq#Length(ret#0) == LitInt(3);
  free ensures {:id "id17869"} Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(ret#0)), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeBlock (well-formedness)"} CheckWellformed$$Base64.__default.DecodeBlock(s#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;
  var ##s#1: Seq;
  var ##x#1: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(130,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(4);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.DecodeBlock(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(ret#0) == LitInt(3);
    ##s#0 := ret#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(3);
    assume Seq#Length(##s#0) == LitInt(3);
    assume Base64.__default.SeqToUInt24#canCall(ret#0);
    ##x#0 := Base64.__default.SeqToUInt24(ret#0);
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.SeqToUInt24(ret#0));
    assume Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(ret#0)), s#0);
    assume false;
    return;

  anon4_Else:
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(4);
    assume Seq#Length(##s#1) == LitInt(4);
    assume Base64.__default.IndexSeqToUInt24#canCall(s#0);
    ##x#1 := Base64.__default.IndexSeqToUInt24(s#0);
    assume $IsAlloc(##x#1, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0));
    assume Base64.__default.DecodeBlock(s#0) == Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(s#0));
    assume Base64.__default.IndexSeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0));
    assume $Is(Base64.__default.DecodeBlock(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Base64.__default.DecodeBlock(s#0) == ret#0;
    return;
}



function Base64.__default.EncodeBlock(s#0: Seq) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.EncodeBlock(s#0) } Base64.__default.EncodeBlock#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Seq#Length(Base64.__default.EncodeBlock(s#0)) == LitInt(4) && Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(Base64.__default.EncodeBlock(s#0))), s#0) && Seq#Equal(Base64.__default.DecodeBlock(Base64.__default.EncodeBlock(s#0)), s#0) && $Is(Base64.__default.EncodeBlock(s#0), TSeq(Tclass.Base64.index())));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.EncodeBlock(s#0) } Base64.__default.EncodeBlock#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Base64.__default.SeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.SeqToUInt24(s#0)) && Base64.__default.EncodeBlock(s#0) == Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(s#0)));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.EncodeBlock(Lit(s#0)) } Base64.__default.EncodeBlock#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> Base64.__default.SeqToUInt24#canCall(Lit(s#0)) && Base64.__default.UInt24ToIndexSeq#canCall(LitInt(Base64.__default.SeqToUInt24(Lit(s#0)))) && Base64.__default.EncodeBlock(Lit(s#0)) == Lit(Base64.__default.UInt24ToIndexSeq(LitInt(Base64.__default.SeqToUInt24(Lit(s#0))))));
}

function Base64.__default.EncodeBlock#canCall(s#0: Seq) : bool;

function Base64.__default.EncodeBlock#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.EncodeBlock#requires(s#0) } $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.EncodeBlock#requires(s#0) <==> Seq#Length(s#0) == LitInt(3)));

procedure {:verboseName "Base64.EncodeBlock (well-formedness)"} CheckWellformed$$Base64.__default.EncodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8()))) returns (ret#0: Seq where $Is(ret#0, TSeq(Tclass.Base64.index())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17877"} Seq#Length(ret#0) == LitInt(4);
  free ensures {:id "id17878"} Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(ret#0)), s#0);
  free ensures {:id "id17879"} Seq#Equal(Base64.__default.DecodeBlock(ret#0), s#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeBlock (well-formedness)"} CheckWellformed$$Base64.__default.EncodeBlock(s#0: Seq) returns (ret#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##x#0: int;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##x#1: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(138,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(s#0) == LitInt(3);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.EncodeBlock(s#0), TSeq(Tclass.Base64.index()));
    assume Seq#Length(ret#0) == LitInt(4);
    ##s#0 := ret#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume Base64.__default.IndexSeqToUInt24#canCall(ret#0);
    ##x#0 := Base64.__default.IndexSeqToUInt24(ret#0);
    assume $IsAlloc(##x#0, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToSeq#canCall(Base64.__default.IndexSeqToUInt24(ret#0));
    assume Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(ret#0)), s#0);
    ##s#1 := ret#0;
    assume $IsAlloc(##s#1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(4);
    assume Seq#Length(##s#1) == LitInt(4);
    assume Base64.__default.DecodeBlock#canCall(ret#0);
    assume Seq#Equal(Base64.__default.DecodeBlock(ret#0), s#0);
    assume false;
    return;

  anon4_Else:
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) == LitInt(3);
    assume Seq#Length(##s#2) == LitInt(3);
    assume Base64.__default.SeqToUInt24#canCall(s#0);
    ##x#1 := Base64.__default.SeqToUInt24(s#0);
    assume $IsAlloc(##x#1, Tclass.Base64.uint24(), $Heap);
    assume Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.SeqToUInt24(s#0));
    assume Base64.__default.EncodeBlock(s#0) == Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(s#0));
    assume Base64.__default.SeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.SeqToUInt24(s#0));
    assume $Is(Base64.__default.EncodeBlock(s#0), TSeq(Tclass.Base64.index()));
    assume Base64.__default.EncodeBlock(s#0) == ret#0;
    return;
}



procedure {:verboseName "Base64.EncodeDecodeBlock (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecodeBlock (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecodeBlock(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(147,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(3);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(149,40): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(3);
    assume Seq#Length(##s#0) == LitInt(3);
    assume Base64.__default.EncodeBlock#canCall(s#0);
    ##s#1 := Base64.__default.EncodeBlock(s#0);
    assume $IsAlloc(##s#1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(4);
    assume Seq#Length(##s#1) == LitInt(4);
    assume Base64.__default.DecodeBlock#canCall(Base64.__default.EncodeBlock(s#0));
    assume Seq#Equal(Base64.__default.DecodeBlock(Base64.__default.EncodeBlock(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.EncodeDecodeBlock (call precondtion)"} CallPre$$Base64.__default.EncodeDecodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id17893"} Seq#Length(s#0) == LitInt(3);



procedure {:verboseName "Base64.EncodeDecodeBlock (call postcondition)"} CallPost$$Base64.__default.EncodeDecodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.EncodeBlock#canCall(s#0) && Base64.__default.DecodeBlock#canCall(Base64.__default.EncodeBlock(s#0));
  free ensures {:id "id17894"} Seq#Equal(Base64.__default.DecodeBlock(Base64.__default.EncodeBlock(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeDecodeBlock (correctness)"} Impl$$Base64.__default.EncodeDecodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id17895"} Seq#Length(s#0) == LitInt(3);
  modifies $Heap;
  free ensures Base64.__default.EncodeBlock#canCall(s#0) && Base64.__default.DecodeBlock#canCall(Base64.__default.EncodeBlock(s#0));
  free ensures {:id "id17896"} Seq#Equal(Base64.__default.DecodeBlock(Base64.__default.EncodeBlock(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecodeBlock (correctness)"} Impl$$Base64.__default.EncodeDecodeBlock(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(150,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.DecodeEncodeBlock (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncodeBlock (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncodeBlock(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(152,8): initial state"} true;
    assume Seq#Length(s#0) == LitInt(4);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(154,40): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(4);
    assume Seq#Length(##s#0) == LitInt(4);
    assume Base64.__default.DecodeBlock#canCall(s#0);
    ##s#1 := Base64.__default.DecodeBlock(s#0);
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(3);
    assume Seq#Length(##s#1) == LitInt(3);
    assume Base64.__default.EncodeBlock#canCall(Base64.__default.DecodeBlock(s#0));
    assume Seq#Equal(Base64.__default.EncodeBlock(Base64.__default.DecodeBlock(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.DecodeEncodeBlock (call precondtion)"} CallPre$$Base64.__default.DecodeEncodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  requires {:id "id17901"} Seq#Length(s#0) == LitInt(4);



procedure {:verboseName "Base64.DecodeEncodeBlock (call postcondition)"} CallPost$$Base64.__default.DecodeEncodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeBlock#canCall(s#0) && Base64.__default.EncodeBlock#canCall(Base64.__default.DecodeBlock(s#0));
  free ensures {:id "id17902"} Seq#Equal(Base64.__default.EncodeBlock(Base64.__default.DecodeBlock(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.DecodeEncodeBlock (correctness)"} Impl$$Base64.__default.DecodeEncodeBlock(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id17903"} Seq#Length(s#0) == LitInt(4);
  modifies $Heap;
  free ensures Base64.__default.DecodeBlock#canCall(s#0) && Base64.__default.EncodeBlock#canCall(Base64.__default.DecodeBlock(s#0));
  free ensures {:id "id17904"} Seq#Equal(Base64.__default.EncodeBlock(Base64.__default.DecodeBlock(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncodeBlock (correctness)"} Impl$$Base64.__default.DecodeEncodeBlock(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(155,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.DecodeRecursively($ly: LayerType, s#0: Seq) : Seq
uses {
axiom 5 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively($ly, s#0) } Base64.__default.DecodeRecursively#canCall(s#0) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0)) ==> Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3)) && Mod(Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)), LitInt(3)) == LitInt(0) && (Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)) == LitInt(0) ==> Seq#Length(s#0) == LitInt(0)) && (Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)) != 0 ==> Seq#Equal(Base64.__default.EncodeBlock(Seq#Take(Base64.__default.DecodeRecursively($ly, s#0), LitInt(3))), Seq#Take(s#0, LitInt(4)))) && $Is(Base64.__default.DecodeRecursively($ly, s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 5 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively($LS($ly), s#0) } Base64.__default.DecodeRecursively#canCall(s#0) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0)) ==> (Seq#Length(s#0) != LitInt(0) ==> Base64.__default.DecodeBlock#canCall(Seq#Take(s#0, LitInt(4))) && Base64.__default.DecodeRecursively#canCall(Seq#Drop(s#0, LitInt(4)))) && Base64.__default.DecodeRecursively($LS($ly), s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.DecodeBlock(Seq#Take(s#0, LitInt(4))), Base64.__default.DecodeRecursively($ly, Seq#Drop(s#0, LitInt(4))))));
axiom 5 <= $FunctionContextHeight ==> (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Base64.__default.DecodeRecursively($LS($ly), Lit(s#0)) } Base64.__default.DecodeRecursively#canCall(Lit(s#0)) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0)) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> Base64.__default.DecodeBlock#canCall(Lit(Seq#Take(Lit(s#0), LitInt(4)))) && Base64.__default.DecodeRecursively#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(4))))) && Base64.__default.DecodeRecursively($LS($ly), Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.DecodeBlock(Lit(Seq#Take(Lit(s#0), LitInt(4)))), Base64.__default.DecodeRecursively($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(4)))))));
}

function Base64.__default.DecodeRecursively#canCall(s#0: Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively($LS($ly), s#0) } Base64.__default.DecodeRecursively($LS($ly), s#0) == Base64.__default.DecodeRecursively($ly, s#0));

axiom (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively(AsFuelBottom($ly), s#0) } Base64.__default.DecodeRecursively($ly, s#0) == Base64.__default.DecodeRecursively($LZ, s#0));

function Base64.__default.DecodeRecursively#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively#requires($ly, s#0) } $Is(s#0, TSeq(Tclass.Base64.index())) ==> (Base64.__default.DecodeRecursively#requires($ly, s#0) <==> Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0)));

procedure {:verboseName "Base64.DecodeRecursively (well-formedness)"} CheckWellformed$$Base64.__default.DecodeRecursively(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index()))) returns (b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17905"} Seq#Length(b#0) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3));
  free ensures {:id "id17906"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
  free ensures {:id "id17907"} Seq#Length(b#0) == LitInt(0) ==> Seq#Length(s#0) == LitInt(0);
  free ensures {:id "id17908"} Seq#Length(b#0) != 0 ==> Seq#Equal(Base64.__default.EncodeBlock(Seq#Take(b#0, LitInt(3))), Seq#Take(s#0, LitInt(4)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeRecursively (well-formedness)"} CheckWellformed$$Base64.__default.DecodeRecursively(s#0: Seq) returns (b#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeRecursively", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(157,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(Base64.__default.DecodeRecursively($LS($LZ), s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume LitInt(4) != 0;
    assume Seq#Length(b#0) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3));
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Seq#Length(b#0) == LitInt(0);
    assume Seq#Length(s#0) == LitInt(0);
    goto anon5;

  anon14_Else:
    assume Seq#Length(b#0) == LitInt(0) ==> Seq#Length(s#0) == LitInt(0);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Seq#Length(b#0) != 0;
    assume 0 <= LitInt(3) && LitInt(3) <= Seq#Length(b#0);
    ##s#0 := Seq#Take(b#0, LitInt(3));
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#0) == LitInt(3);
    assume Seq#Length(##s#0) == LitInt(3);
    assume Base64.__default.EncodeBlock#canCall(Seq#Take(b#0, LitInt(3)));
    assume 0 <= LitInt(4) && LitInt(4) <= Seq#Length(s#0);
    assume Seq#Equal(Base64.__default.EncodeBlock(Seq#Take(b#0, LitInt(3))), Seq#Take(s#0, LitInt(4)));
    goto anon8;

  anon15_Else:
    assume Seq#Length(b#0) != 0 ==> Seq#Equal(Base64.__default.EncodeBlock(Seq#Take(b#0, LitInt(3))), Seq#Take(s#0, LitInt(4)));
    goto anon8;

  anon8:
    assume false;
    return;

  anon13_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(0);
    assume Base64.__default.DecodeRecursively($LS($LZ), s#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Base64.__default.DecodeRecursively($LS($LZ), s#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon16_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(0);
    assume 0 <= LitInt(4) && LitInt(4) <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, LitInt(4));
    assume $IsAlloc(##s#1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(4);
    assume Seq#Length(##s#1) == LitInt(4);
    assume Base64.__default.DecodeBlock#canCall(Seq#Take(s#0, LitInt(4)));
    assume 0 <= LitInt(4) && LitInt(4) <= Seq#Length(s#0);
    ##s#2 := Seq#Drop(s#0, LitInt(4));
    assume $IsAlloc(##s#2, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0);
    assume Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0);
    assume 0 <= Seq#Length(s#0) || Seq#Length(##s#2) == Seq#Length(s#0);
    assume Seq#Length(##s#2) < Seq#Length(s#0);
    assume Base64.__default.DecodeRecursively#canCall(Seq#Drop(s#0, LitInt(4)));
    assume Base64.__default.DecodeRecursively($LS($LZ), s#0) == Seq#Append(Base64.__default.DecodeBlock(Seq#Take(s#0, LitInt(4))), Base64.__default.DecodeRecursively($LS($LZ), Seq#Drop(s#0, LitInt(4))));
    assume Base64.__default.DecodeBlock#canCall(Seq#Take(s#0, LitInt(4))) && Base64.__default.DecodeRecursively#canCall(Seq#Drop(s#0, LitInt(4)));
    assume $Is(Base64.__default.DecodeRecursively($LS($LZ), s#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon12:
    assume Base64.__default.DecodeRecursively($LS($LZ), s#0) == b#0;
    return;
}



function Base64.__default.EncodeRecursively($ly: LayerType, b#0: Seq) : Seq
uses {
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively($ly, b#0) } Base64.__default.EncodeRecursively#canCall(b#0) || (6 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> Seq#Length(Base64.__default.EncodeRecursively($ly, b#0)) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) && Mod(Seq#Length(Base64.__default.EncodeRecursively($ly, b#0)), LitInt(4)) == LitInt(0) && Seq#Equal(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.EncodeRecursively($ly, b#0)), b#0) && $Is(Base64.__default.EncodeRecursively($ly, b#0), TSeq(Tclass.Base64.index())));
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively($LS($ly), b#0) } Base64.__default.EncodeRecursively#canCall(b#0) || (6 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> (Seq#Length(b#0) != LitInt(0) ==> Base64.__default.EncodeBlock#canCall(Seq#Take(b#0, LitInt(3))) && Base64.__default.EncodeRecursively#canCall(Seq#Drop(b#0, LitInt(3)))) && Base64.__default.EncodeRecursively($LS($ly), b#0) == (if Seq#Length(b#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.EncodeBlock(Seq#Take(b#0, LitInt(3))), Base64.__default.EncodeRecursively($ly, Seq#Drop(b#0, LitInt(3))))));
axiom 6 <= $FunctionContextHeight ==> (forall $ly: LayerType, b#0: Seq :: {:weight 3} { Base64.__default.EncodeRecursively($LS($ly), Lit(b#0)) } Base64.__default.EncodeRecursively#canCall(Lit(b#0)) || (6 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0)) ==> (Seq#Length(Lit(b#0)) != LitInt(0) ==> Base64.__default.EncodeBlock#canCall(Lit(Seq#Take(Lit(b#0), LitInt(3)))) && Base64.__default.EncodeRecursively#canCall(Lit(Seq#Drop(Lit(b#0), LitInt(3))))) && Base64.__default.EncodeRecursively($LS($ly), Lit(b#0)) == (if Seq#Length(Lit(b#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.EncodeBlock(Lit(Seq#Take(Lit(b#0), LitInt(3)))), Base64.__default.EncodeRecursively($LS($ly), Lit(Seq#Drop(Lit(b#0), LitInt(3)))))));
}

function Base64.__default.EncodeRecursively#canCall(b#0: Seq) : bool;

axiom (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively($LS($ly), b#0) } Base64.__default.EncodeRecursively($LS($ly), b#0) == Base64.__default.EncodeRecursively($ly, b#0));

axiom (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively(AsFuelBottom($ly), b#0) } Base64.__default.EncodeRecursively($ly, b#0) == Base64.__default.EncodeRecursively($LZ, b#0));

function Base64.__default.EncodeRecursively#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively#requires($ly, b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.EncodeRecursively#requires($ly, b#0) <==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)));

procedure {:verboseName "Base64.EncodeRecursively (well-formedness)"} CheckWellformed$$Base64.__default.EncodeRecursively(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17933"} Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
  free ensures {:id "id17934"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  free ensures {:id "id17935"} Seq#Equal(Base64.__default.DecodeRecursively($LS($LS($LZ)), s#0), b#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeRecursively (well-formedness)"} CheckWellformed$$Base64.__default.EncodeRecursively(b#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeRecursively", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(169,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(Base64.__default.EncodeRecursively($LS($LZ), b#0), TSeq(Tclass.Base64.index()));
    assume LitInt(3) != 0;
    assume Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(s#0);
    assume Seq#Equal(Base64.__default.DecodeRecursively($LS($LZ), s#0), b#0);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Seq#Length(b#0) == LitInt(0);
    assume Base64.__default.EncodeRecursively($LS($LZ), b#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Base64.__default.EncodeRecursively($LS($LZ), b#0), TSeq(Tclass.Base64.index()));
    goto anon6;

  anon8_Else:
    assume {:partition} Seq#Length(b#0) != LitInt(0);
    assume 0 <= LitInt(3) && LitInt(3) <= Seq#Length(b#0);
    ##s#1 := Seq#Take(b#0, LitInt(3));
    assume $IsAlloc(##s#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(3);
    assume Seq#Length(##s#1) == LitInt(3);
    assume Base64.__default.EncodeBlock#canCall(Seq#Take(b#0, LitInt(3)));
    assume 0 <= LitInt(3) && LitInt(3) <= Seq#Length(b#0);
    ##b#0 := Seq#Drop(b#0, LitInt(3));
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Seq#Rank(##b#0) < Seq#Rank(b#0);
    assume Base64.__default.EncodeRecursively#canCall(Seq#Drop(b#0, LitInt(3)));
    assume Base64.__default.EncodeRecursively($LS($LZ), b#0) == Seq#Append(Base64.__default.EncodeBlock(Seq#Take(b#0, LitInt(3))), Base64.__default.EncodeRecursively($LS($LZ), Seq#Drop(b#0, LitInt(3))));
    assume Base64.__default.EncodeBlock#canCall(Seq#Take(b#0, LitInt(3))) && Base64.__default.EncodeRecursively#canCall(Seq#Drop(b#0, LitInt(3)));
    assume $Is(Base64.__default.EncodeRecursively($LS($LZ), b#0), TSeq(Tclass.Base64.index()));
    goto anon6;

  anon6:
    assume Base64.__default.EncodeRecursively($LS($LZ), b#0) == s#0;
    return;
}



procedure {:verboseName "Base64.DecodeEncodeRecursively (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncodeRecursively(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncodeRecursively (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncodeRecursively(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeRecursively", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(179,8): initial state"} true;
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(181,52): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(s#0);
    ##b#0 := Base64.__default.DecodeRecursively($LS($LZ), s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), s#0));
    assume Seq#Equal(Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.DecodeEncodeRecursively (call precondtion)"} CallPre$$Base64.__default.DecodeEncodeRecursively(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  requires {:id "id17957"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);



procedure {:verboseName "Base64.DecodeEncodeRecursively (call postcondition)"} CallPost$$Base64.__default.DecodeEncodeRecursively(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeRecursively#canCall(s#0) && Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), s#0));
  free ensures {:id "id17958"} Seq#Equal(Base64.__default.EncodeRecursively($LS($LS($LZ)), Base64.__default.DecodeRecursively($LS($LS($LZ)), s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.DecodeEncodeRecursively (correctness)"} Impl$$Base64.__default.DecodeEncodeRecursively(s#0: Seq where $Is(s#0, TSeq(Tclass.Base64.index())) && $IsAlloc(s#0, TSeq(Tclass.Base64.index()), $Heap)) returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  requires {:id "id17959"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  modifies $Heap;
  free ensures Base64.__default.DecodeRecursively#canCall(s#0) && Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), s#0));
  free ensures {:id "id17960"} Seq#Equal(Base64.__default.EncodeRecursively($LS($LS($LZ)), Base64.__default.DecodeRecursively($LS($LS($LZ)), s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncodeRecursively (correctness)"} Impl$$Base64.__default.DecodeEncodeRecursively(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeRecursively", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(182,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#s0#0: Seq :: $Is($ih#s0#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length($ih#s0#0), LitInt(4)) == LitInt(0) && Seq#Rank($ih#s0#0) < Seq#Rank(s#0) ==> Seq#Equal(Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), $ih#s0#0)), $ih#s0#0));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.EncodeDecodeRecursively (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecodeRecursively(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecodeRecursively (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecodeRecursively(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeRecursively", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(184,8): initial state"} true;
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(186,52): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeRecursively#canCall(b#0);
    ##s#0 := Base64.__default.EncodeRecursively($LS($LZ), b#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0));
    assume Seq#Equal(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.EncodeRecursively($LS($LZ), b#0)), b#0);
    return;
}



procedure {:verboseName "Base64.EncodeDecodeRecursively (call precondtion)"} CallPre$$Base64.__default.EncodeDecodeRecursively(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id17966"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);



procedure {:verboseName "Base64.EncodeDecodeRecursively (call postcondition)"} CallPost$$Base64.__default.EncodeDecodeRecursively(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.EncodeRecursively#canCall(b#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0));
  free ensures {:id "id17967"} Seq#Equal(Base64.__default.DecodeRecursively($LS($LS($LZ)), Base64.__default.EncodeRecursively($LS($LS($LZ)), b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeDecodeRecursively (correctness)"} Impl$$Base64.__default.EncodeDecodeRecursively(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 7 == $FunctionContextHeight;
  requires {:id "id17968"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
  modifies $Heap;
  free ensures Base64.__default.EncodeRecursively#canCall(b#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0));
  free ensures {:id "id17969"} Seq#Equal(Base64.__default.DecodeRecursively($LS($LS($LZ)), Base64.__default.EncodeRecursively($LS($LS($LZ)), b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecodeRecursively (correctness)"} Impl$$Base64.__default.EncodeDecodeRecursively(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeRecursively", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(187,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#b0#0: Seq :: $Is($ih#b0#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length($ih#b0#0), LitInt(3)) == LitInt(0) && Seq#Rank($ih#b0#0) < Seq#Rank(b#0) ==> Seq#Equal(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.EncodeRecursively($LS($LZ), $ih#b0#0)), $ih#b0#0));
    $_reverifyPost := false;
    return;
}



function Base64.__default.FromCharsToIndices(s#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.FromCharsToIndices(s#0) } Base64.__default.FromCharsToIndices#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0))) ==> Seq#Length(Base64.__default.FromCharsToIndices(s#0)) == Seq#Length(s#0) && (forall k#1: int :: { $Unbox(Seq#Index(s#0, k#1)): char } { $Unbox(Seq#Index(Base64.__default.FromCharsToIndices(s#0), k#1)): int } LitInt(0) <= k#1 && k#1 < Seq#Length(Base64.__default.FromCharsToIndices(s#0)) ==> Base64.__default.IndexToChar($Unbox(Seq#Index(Base64.__default.FromCharsToIndices(s#0), k#1)): int) == $Unbox(Seq#Index(s#0, k#1)): char) && $Is(Base64.__default.FromCharsToIndices(s#0), TSeq(Tclass.Base64.index())));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { Base64.__default.FromCharsToIndices(s#0), $IsGoodHeap($Heap) } Base64.__default.FromCharsToIndices#canCall(s#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2))) ==> (forall $l#1#i#0: int :: LitInt(0) <= $l#1#i#0 && $l#1#i#0 < Seq#Length(s#0) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, $l#1#i#0)): char)) && Base64.__default.FromCharsToIndices(s#0) == Seq#Create(Tclass.Base64.index(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, $Unbox($l#0#i#0): int)): char))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(s#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Base64.__default.FromCharsToIndices(Lit(s#0)), $IsGoodHeap($Heap) } Base64.__default.FromCharsToIndices#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall k#3: char :: { Base64.__default.IsBase64Char(k#3) } { Seq#Contains(s#0, $Box(k#3)) } $Is(k#3, TChar) ==> Seq#Contains(s#0, $Box(k#3)) ==> Base64.__default.IsBase64Char(k#3))) ==> (forall $l#3#i#0: int :: LitInt(0) <= $l#3#i#0 && $l#3#i#0 < Seq#Length(Lit(s#0)) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), $l#3#i#0)): char)) && Base64.__default.FromCharsToIndices(Lit(s#0)) == Seq#Create(Tclass.Base64.index(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), $Unbox($l#2#i#0): int)): char))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))));
}

function Base64.__default.FromCharsToIndices#canCall(s#0: Seq) : bool;

function Base64.__default.FromCharsToIndices#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { Base64.__default.FromCharsToIndices#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (Base64.__default.FromCharsToIndices#requires(s#0) <==> (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2))));

procedure {:verboseName "Base64.FromCharsToIndices (well-formedness)"} CheckWellformed$$Base64.__default.FromCharsToIndices(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (b#0: Seq where $Is(b#0, TSeq(Tclass.Base64.index())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17970"} Seq#Length(b#0) == Seq#Length(s#0);
  free ensures {:id "id17971"} (forall k#4: int :: { $Unbox(Seq#Index(s#0, k#4)): char } { $Unbox(Seq#Index(b#0, k#4)): int } LitInt(0) <= k#4 && k#4 < Seq#Length(b#0) ==> Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, k#4)): int) == $Unbox(Seq#Index(s#0, k#4)): char);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.FromCharsToIndices (well-formedness)"} CheckWellformed$$Base64.__default.FromCharsToIndices(s#0: Seq) returns (b#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#5: char;
  var ##c#0: char;
  var k#6: int;
  var ##i#0: int;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: int;
  var ##c#1: char;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.FromCharsToIndices", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(189,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc k#5;
    assume $Is(k#5, TChar);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Seq#Contains(s#0, $Box(k#5));
    ##c#0 := k#5;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(k#5);
    assume Base64.__default.IsBase64Char(k#5);
    goto anon4;

  anon19_Else:
    assume Seq#Contains(s#0, $Box(k#5)) ==> Base64.__default.IsBase64Char(k#5);
    goto anon4;

  anon4:
    assume (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume $Is(Base64.__default.FromCharsToIndices(s#0), TSeq(Tclass.Base64.index()));
    assume Seq#Length(b#0) == Seq#Length(s#0);
    havoc k#6;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= k#6;
    goto anon8;

  anon22_Else:
    assume {:partition} k#6 < LitInt(0);
    goto anon8;

  anon8:
    assume LitInt(0) <= k#6 && k#6 < Seq#Length(b#0);
    assume 0 <= k#6 && k#6 < Seq#Length(b#0);
    ##i#0 := $Unbox(Seq#Index(b#0, k#6)): int;
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(b#0, k#6)): int);
    assume 0 <= k#6 && k#6 < Seq#Length(s#0);
    assume Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, k#6)): int) == $Unbox(Seq#Index(s#0, k#6)): char;
    goto anon10;

  anon21_Else:
    assume LitInt(0) <= k#6 && k#6 < Seq#Length(b#0) ==> Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, k#6)): int) == $Unbox(Seq#Index(s#0, k#6)): char;
    goto anon10;

  anon10:
    assume (forall k#4: int :: { $Unbox(Seq#Index(s#0, k#4)): char } { $Unbox(Seq#Index(b#0, k#4)): int } LitInt(0) <= k#4 && k#4 < Seq#Length(b#0) ==> Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, k#4)): int) == $Unbox(Seq#Index(s#0, k#4)): char);
    assume false;
    return;

  anon20_Else:
    assume 0 <= Seq#Length(s#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon15;

  anon25_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon15;

  anon15:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    ##c#1 := $Unbox(Seq#Index(s#0, i#0)): char;
    assume $IsAlloc(##c#1, TChar, $lambdaHeap#0);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#1) ==> Base64.__default.IsBase64Char(##c#1) || ##c#1 == Lit(char#FromInt(43)) || ##c#1 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#1);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, i#0)): char);
    assume lambdaResult#0 == Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, i#0)): char);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, i#0)): char);
    assume $Is(lambdaResult#0, Tclass.Base64.index());
    goto anon17;

  anon26_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < Seq#Length(s#0));
    goto anon17;

  anon24_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume false;
    goto anon18;

  anon23_Else:
    goto anon18;

  anon18:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(s#0) ==> Requires1(TInt, Tclass.Base64.index(), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, $Unbox($l#4#i#0): int)): char))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(s#0)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(s#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, Tclass.Base64.index(), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, $Unbox($l#4#i#0): int)): char))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(s#0)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume Base64.__default.FromCharsToIndices(s#0) == Seq#Create(Tclass.Base64.index(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, $Unbox($l#6#i#0): int)): char))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt) && LitInt(0) <= $Unbox($l#6#i#0): int && $Unbox($l#6#i#0): int < Seq#Length(s#0)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume (forall $l#7#i#0: int :: LitInt(0) <= $l#7#i#0 && $l#7#i#0 < Seq#Length(s#0) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, $l#7#i#0)): char));
    assume $Is(Base64.__default.FromCharsToIndices(s#0), TSeq(Tclass.Base64.index()));
    assume Base64.__default.FromCharsToIndices(s#0) == b#0;
    assume b$reqreads#0;
    return;
}



function Base64.__default.FromIndicesToChars(b#0: Seq) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.FromIndicesToChars(b#0) } Base64.__default.FromIndicesToChars#canCall(b#0) || (4 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.Base64.index()))) ==> (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(Base64.__default.FromIndicesToChars(b#0), $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(Base64.__default.FromIndicesToChars(b#0), $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0)) && Seq#Length(Base64.__default.FromIndicesToChars(b#0)) == Seq#Length(b#0) && (forall k#1: int :: { $Unbox(Seq#Index(b#0, k#1)): int } { $Unbox(Seq#Index(Base64.__default.FromIndicesToChars(b#0), k#1)): char } LitInt(0) <= k#1 && k#1 < Seq#Length(Base64.__default.FromIndicesToChars(b#0)) ==> Base64.__default.CharToIndex($Unbox(Seq#Index(Base64.__default.FromIndicesToChars(b#0), k#1)): char) == $Unbox(Seq#Index(b#0, k#1)): int) && Seq#Equal(Base64.__default.FromCharsToIndices(Base64.__default.FromIndicesToChars(b#0)), b#0) && $Is(Base64.__default.FromIndicesToChars(b#0), TSeq(TChar)));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, b#0: Seq :: { Base64.__default.FromIndicesToChars(b#0), $IsGoodHeap($Heap) } Base64.__default.FromIndicesToChars#canCall(b#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(b#0, TSeq(Tclass.Base64.index()))) ==> (forall $l#1#i#0: int :: LitInt(0) <= $l#1#i#0 && $l#1#i#0 < Seq#Length(b#0) ==> Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(b#0, $l#1#i#0)): int)) && Base64.__default.FromIndicesToChars(b#0) == Seq#Create(TChar, $Heap, Seq#Length(b#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, $Unbox($l#0#i#0): int)): int))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(b#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, b#0: Seq :: {:weight 3} { Base64.__default.FromIndicesToChars(Lit(b#0)), $IsGoodHeap($Heap) } Base64.__default.FromIndicesToChars#canCall(Lit(b#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(b#0, TSeq(Tclass.Base64.index()))) ==> (forall $l#3#i#0: int :: LitInt(0) <= $l#3#i#0 && $l#3#i#0 < Seq#Length(Lit(b#0)) ==> Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(Lit(b#0), $l#3#i#0)): int)) && Base64.__default.FromIndicesToChars(Lit(b#0)) == Seq#Create(TChar, $Heap, Seq#Length(Lit(b#0)), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(Lit(b#0), $Unbox($l#2#i#0): int)): int))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(Lit(b#0))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))));
}

function Base64.__default.FromIndicesToChars#canCall(b#0: Seq) : bool;

function Base64.__default.FromIndicesToChars#requires(Seq) : bool;

axiom (forall $Heap: Heap, b#0: Seq :: { Base64.__default.FromIndicesToChars#requires(b#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(b#0, TSeq(Tclass.Base64.index())) ==> (Base64.__default.FromIndicesToChars#requires(b#0) <==> true));

procedure {:verboseName "Base64.FromIndicesToChars (well-formedness)"} CheckWellformed$$Base64.__default.FromIndicesToChars(b#0: Seq where $Is(b#0, TSeq(Tclass.Base64.index()))) returns (s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id17991"} (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2));
  free ensures {:id "id17992"} Seq#Length(s#0) == Seq#Length(b#0);
  free ensures {:id "id17993"} (forall k#3: int :: { $Unbox(Seq#Index(b#0, k#3)): int } { $Unbox(Seq#Index(s#0, k#3)): char } LitInt(0) <= k#3 && k#3 < Seq#Length(s#0) ==> Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, k#3)): char) == $Unbox(Seq#Index(b#0, k#3)): int);
  free ensures {:id "id17994"} Seq#Equal(Base64.__default.FromCharsToIndices(s#0), b#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.FromIndicesToChars (well-formedness)"} CheckWellformed$$Base64.__default.FromIndicesToChars(b#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#4: char;
  var ##c#0: char;
  var k#5: int;
  var ##c#1: char;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: char;
  var ##i#0: int;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.FromIndicesToChars", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(197,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(Base64.__default.FromIndicesToChars(b#0), TSeq(TChar));
    havoc k#4;
    assume $Is(k#4, TChar);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume Seq#Contains(s#0, $Box(k#4));
    ##c#0 := k#4;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(k#4);
    assume Base64.__default.IsBase64Char(k#4);
    goto anon5;

  anon20_Else:
    assume Seq#Contains(s#0, $Box(k#4)) ==> Base64.__default.IsBase64Char(k#4);
    goto anon5;

  anon5:
    assume (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2));
    assume Seq#Length(s#0) == Seq#Length(b#0);
    havoc k#5;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= k#5;
    goto anon8;

  anon22_Else:
    assume {:partition} k#5 < LitInt(0);
    goto anon8;

  anon8:
    assume LitInt(0) <= k#5 && k#5 < Seq#Length(s#0);
    assume 0 <= k#5 && k#5 < Seq#Length(s#0);
    ##c#1 := $Unbox(Seq#Index(s#0, k#5)): char;
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#1) ==> Base64.__default.IsBase64Char(##c#1) || ##c#1 == Lit(char#FromInt(43)) || ##c#1 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#1);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, k#5)): char);
    assume 0 <= k#5 && k#5 < Seq#Length(b#0);
    assume Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, k#5)): char) == $Unbox(Seq#Index(b#0, k#5)): int;
    goto anon10;

  anon21_Else:
    assume LitInt(0) <= k#5 && k#5 < Seq#Length(s#0) ==> Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, k#5)): char) == $Unbox(Seq#Index(b#0, k#5)): int;
    goto anon10;

  anon10:
    assume (forall k#3: int :: { $Unbox(Seq#Index(b#0, k#3)): int } { $Unbox(Seq#Index(s#0, k#3)): char } LitInt(0) <= k#3 && k#3 < Seq#Length(s#0) ==> Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, k#3)): char) == $Unbox(Seq#Index(b#0, k#3)): int);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#6: char :: { Base64.__default.IsBase64Char(k#6) } { Seq#Contains(##s#0, $Box(k#6)) } $Is(k#6, TChar) ==> Seq#Contains(##s#0, $Box(k#6)) ==> Base64.__default.IsBase64Char(k#6));
    assume (forall k#6: char :: { Base64.__default.IsBase64Char(k#6) } { Seq#Contains(##s#0, $Box(k#6)) } $Is(k#6, TChar) ==> Seq#Contains(##s#0, $Box(k#6)) ==> Base64.__default.IsBase64Char(k#6));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    assume Seq#Equal(Base64.__default.FromCharsToIndices(s#0), b#0);
    assume false;
    return;

  anon19_Else:
    assume 0 <= Seq#Length(b#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon15;

  anon25_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon15;

  anon15:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < Seq#Length(b#0);
    assume 0 <= i#0 && i#0 < Seq#Length(b#0);
    ##i#0 := $Unbox(Seq#Index(b#0, i#0)): int;
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $lambdaHeap#0);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(b#0, i#0)): int);
    assume lambdaResult#0 == Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, i#0)): int);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(b#0, i#0)): int);
    assume $Is(lambdaResult#0, TChar);
    goto anon17;

  anon26_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < Seq#Length(b#0));
    goto anon17;

  anon24_Else:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume false;
    goto anon18;

  anon23_Else:
    goto anon18;

  anon18:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(b#0) ==> Requires1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, $Unbox($l#4#i#0): int)): int))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(b#0)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(b#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, $Unbox($l#4#i#0): int)): int))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(b#0)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume Base64.__default.FromIndicesToChars(b#0) == Seq#Create(TChar, $Heap, Seq#Length(b#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, $Unbox($l#6#i#0): int)): int))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt) && LitInt(0) <= $Unbox($l#6#i#0): int && $Unbox($l#6#i#0): int < Seq#Length(b#0)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume (forall $l#7#i#0: int :: LitInt(0) <= $l#7#i#0 && $l#7#i#0 < Seq#Length(b#0) ==> Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(b#0, $l#7#i#0)): int));
    assume $Is(Base64.__default.FromIndicesToChars(b#0), TSeq(TChar));
    assume Base64.__default.FromIndicesToChars(b#0) == s#0;
    assume b$reqreads#0;
    return;
}



procedure {:verboseName "Base64.FromCharsToIndicesToChars (well-formedness)"} CheckWellFormed$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.FromCharsToIndicesToChars (well-formedness)"} CheckWellFormed$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var k#0: char;
  var ##c#0: char;
  var ##s#0: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.FromCharsToIndicesToChars", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(206,8): initial state"} true;
    havoc k#0;
    assume $Is(k#0, TChar);
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume Seq#Contains(s#0, $Box(k#0));
    ##c#0 := k#0;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall(k#0);
    assume Base64.__default.IsBase64Char(k#0);
    goto anon4;

  anon5_Else:
    assume Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0);
    goto anon4;

  anon4:
    assume (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(s#0, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(s#0, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(208,54): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(##s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(##s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2));
    assume (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(##s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(##s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    ##b#0 := Base64.__default.FromCharsToIndices(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume Seq#Equal(Base64.__default.FromIndicesToChars(Base64.__default.FromCharsToIndices(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.FromCharsToIndicesToChars (call precondtion)"} CallPre$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18022"} (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(s#0, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(s#0, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1));



procedure {:verboseName "Base64.FromCharsToIndicesToChars (call postcondition)"} CallPost$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
  free ensures {:id "id18023"} Seq#Equal(Base64.__default.FromIndicesToChars(Base64.__default.FromCharsToIndices(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.FromCharsToIndicesToChars (correctness)"} Impl$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id18024"} (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(s#0, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(s#0, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1));
  modifies $Heap;
  free ensures Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
  free ensures {:id "id18025"} Seq#Equal(Base64.__default.FromIndicesToChars(Base64.__default.FromCharsToIndices(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.FromCharsToIndicesToChars (correctness)"} Impl$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.FromCharsToIndicesToChars", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(209,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.FromIndicesToCharsToIndices (well-formedness)"} CheckWellFormed$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq where $Is(b#0, TSeq(Tclass.Base64.index())) && $IsAlloc(b#0, TSeq(Tclass.Base64.index()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.FromIndicesToCharsToIndices (well-formedness)"} CheckWellFormed$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.FromIndicesToCharsToIndices", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(211,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(212,54): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(b#0);
    ##s#0 := Base64.__default.FromIndicesToChars(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.FromCharsToIndices#canCall(Base64.__default.FromIndicesToChars(b#0));
    assume Seq#Equal(Base64.__default.FromCharsToIndices(Base64.__default.FromIndicesToChars(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64.FromIndicesToCharsToIndices (call precondtion)"} CallPre$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq where $Is(b#0, TSeq(Tclass.Base64.index())) && $IsAlloc(b#0, TSeq(Tclass.Base64.index()), $Heap));



procedure {:verboseName "Base64.FromIndicesToCharsToIndices (call postcondition)"} CallPost$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq where $Is(b#0, TSeq(Tclass.Base64.index())) && $IsAlloc(b#0, TSeq(Tclass.Base64.index()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.FromIndicesToChars#canCall(b#0) && Base64.__default.FromCharsToIndices#canCall(Base64.__default.FromIndicesToChars(b#0));
  free ensures {:id "id18028"} Seq#Equal(Base64.__default.FromCharsToIndices(Base64.__default.FromIndicesToChars(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.FromIndicesToCharsToIndices (correctness)"} Impl$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq where $Is(b#0, TSeq(Tclass.Base64.index())) && $IsAlloc(b#0, TSeq(Tclass.Base64.index()), $Heap)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.FromIndicesToChars#canCall(b#0) && Base64.__default.FromCharsToIndices#canCall(Base64.__default.FromIndicesToChars(b#0));
  free ensures {:id "id18029"} Seq#Equal(Base64.__default.FromCharsToIndices(Base64.__default.FromIndicesToChars(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.FromIndicesToCharsToIndices (correctness)"} Impl$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.FromIndicesToCharsToIndices", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(213,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.DecodeUnpadded(s#0: Seq) : Seq
uses {
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.DecodeUnpadded(s#0) } Base64.__default.DecodeUnpadded#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.IsUnpaddedBase64String(s#0)) ==> Seq#Length(Base64.__default.DecodeUnpadded(s#0)) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3)) && Mod(Seq#Length(Base64.__default.DecodeUnpadded(s#0)), LitInt(3)) == LitInt(0) && $Is(Base64.__default.DecodeUnpadded(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.DecodeUnpadded(s#0) } Base64.__default.DecodeUnpadded#canCall(s#0) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.IsUnpaddedBase64String(s#0)) ==> Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0)) && Base64.__default.DecodeUnpadded(s#0) == Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0)));
axiom 6 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.DecodeUnpadded(Lit(s#0)) } Base64.__default.DecodeUnpadded#canCall(Lit(s#0)) || (6 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Lit(Base64.__default.IsUnpaddedBase64String(Lit(s#0)))) ==> Base64.__default.FromCharsToIndices#canCall(Lit(s#0)) && Base64.__default.DecodeRecursively#canCall(Lit(Base64.__default.FromCharsToIndices(Lit(s#0)))) && Base64.__default.DecodeUnpadded(Lit(s#0)) == Lit(Base64.__default.DecodeRecursively($LS($LZ), Lit(Base64.__default.FromCharsToIndices(Lit(s#0))))));
}

function Base64.__default.DecodeUnpadded#canCall(s#0: Seq) : bool;

function Base64.__default.DecodeUnpadded#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.DecodeUnpadded#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.DecodeUnpadded#requires(s#0) <==> Base64.__default.IsUnpaddedBase64String(s#0)));

procedure {:verboseName "Base64.DecodeUnpadded (well-formedness)"} CheckWellformed$$Base64.__default.DecodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18030"} Seq#Length(b#0) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3));
  free ensures {:id "id18031"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeUnpadded (well-formedness)"} CheckWellformed$$Base64.__default.DecodeUnpadded(s#0: Seq) returns (b#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(215,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(s#0);
    assume Base64.__default.IsUnpaddedBase64String(s#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.DecodeUnpadded(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume LitInt(4) != 0;
    assume Seq#Length(b#0) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3));
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    assume false;
    return;

  anon4_Else:
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#1, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#1, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#1, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#1, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    ##s#2 := Base64.__default.FromCharsToIndices(s#0);
    assume $IsAlloc(##s#2, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0);
    assume Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume Base64.__default.DecodeUnpadded(s#0) == Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume $Is(Base64.__default.DecodeUnpadded(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Base64.__default.DecodeUnpadded(s#0) == b#0;
    return;
}



function Base64.__default.EncodeUnpadded(b#0: Seq) : Seq
uses {
axiom 7 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.EncodeUnpadded(b#0) } Base64.__default.EncodeUnpadded#canCall(b#0) || (7 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> Base64.__default.IsUnpaddedBase64String(Base64.__default.EncodeUnpadded(b#0)) && Seq#Length(Base64.__default.EncodeUnpadded(b#0)) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) && Seq#Equal(Base64.__default.DecodeUnpadded(Base64.__default.EncodeUnpadded(b#0)), b#0) && Mod(Seq#Length(Base64.__default.EncodeUnpadded(b#0)), LitInt(4)) == LitInt(0) && $Is(Base64.__default.EncodeUnpadded(b#0), TSeq(TChar)));
axiom 7 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.EncodeUnpadded(b#0) } Base64.__default.EncodeUnpadded#canCall(b#0) || (7 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> Base64.__default.EncodeRecursively#canCall(b#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0)) && Base64.__default.EncodeUnpadded(b#0) == Base64.__default.FromIndicesToChars(Base64.__default.EncodeRecursively($LS($LZ), b#0)));
axiom 7 <= $FunctionContextHeight ==> (forall b#0: Seq :: {:weight 3} { Base64.__default.EncodeUnpadded(Lit(b#0)) } Base64.__default.EncodeUnpadded#canCall(Lit(b#0)) || (7 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0)) ==> Base64.__default.EncodeRecursively#canCall(Lit(b#0)) && Base64.__default.FromIndicesToChars#canCall(Lit(Base64.__default.EncodeRecursively($LS($LZ), Lit(b#0)))) && Base64.__default.EncodeUnpadded(Lit(b#0)) == Lit(Base64.__default.FromIndicesToChars(Lit(Base64.__default.EncodeRecursively($LS($LZ), Lit(b#0))))));
}

function Base64.__default.EncodeUnpadded#canCall(b#0: Seq) : bool;

function Base64.__default.EncodeUnpadded#requires(Seq) : bool;

axiom (forall b#0: Seq :: { Base64.__default.EncodeUnpadded#requires(b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.EncodeUnpadded#requires(b#0) <==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)));

procedure {:verboseName "Base64.EncodeUnpadded (well-formedness)"} CheckWellformed$$Base64.__default.EncodeUnpadded(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18041"} Base64.__default.IsUnpaddedBase64String#canCall(s#0) ==> Base64.__default.IsUnpaddedBase64String(s#0) || Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  free ensures {:id "id18042"} Base64.__default.IsUnpaddedBase64String#canCall(s#0) ==> Base64.__default.IsUnpaddedBase64String(s#0) || (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
  free ensures {:id "id18043"} Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
  free ensures {:id "id18044"} Seq#Equal(Base64.__default.DecodeUnpadded(s#0), b#0);
  free ensures {:id "id18045"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeUnpadded (well-formedness)"} CheckWellformed$$Base64.__default.EncodeUnpadded(b#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;
  var ##b#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeUnpadded", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(223,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.EncodeUnpadded(b#0), TSeq(TChar));
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(s#0);
    assume Base64.__default.IsUnpaddedBase64String(s#0);
    assume LitInt(3) != 0;
    assume Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#1) ==> Base64.__default.IsUnpaddedBase64String(##s#1) || Mod(Seq#Length(##s#1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#1) ==> Base64.__default.IsUnpaddedBase64String(##s#1) || (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(##s#1, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(##s#1, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1));
    assume Base64.__default.IsUnpaddedBase64String(##s#1);
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    assume Seq#Equal(Base64.__default.DecodeUnpadded(s#0), b#0);
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    assume false;
    return;

  anon4_Else:
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeRecursively#canCall(b#0);
    ##b#1 := Base64.__default.EncodeRecursively($LS($LZ), b#0);
    assume $IsAlloc(##b#1, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0));
    assume Base64.__default.EncodeUnpadded(b#0) == Base64.__default.FromIndicesToChars(Base64.__default.EncodeRecursively($LS($LZ), b#0));
    assume Base64.__default.EncodeRecursively#canCall(b#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0));
    assume $Is(Base64.__default.EncodeUnpadded(b#0), TSeq(TChar));
    assume Base64.__default.EncodeUnpadded(b#0) == s#0;
    return;
}



procedure {:verboseName "Base64.EncodeDecodeUnpadded (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecodeUnpadded (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeUnpadded", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(233,8): initial state"} true;
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(235,46): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(b#0);
    ##s#0 := Base64.__default.EncodeUnpadded(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0) ==> Base64.__default.IsUnpaddedBase64String(##s#0) || Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0) ==> Base64.__default.IsUnpaddedBase64String(##s#0) || (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.IsUnpaddedBase64String(##s#0);
    assume Base64.__default.DecodeUnpadded#canCall(Base64.__default.EncodeUnpadded(b#0));
    assume Seq#Equal(Base64.__default.DecodeUnpadded(Base64.__default.EncodeUnpadded(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64.EncodeDecodeUnpadded (call precondtion)"} CallPre$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id18065"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);



procedure {:verboseName "Base64.EncodeDecodeUnpadded (call postcondition)"} CallPost$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.EncodeUnpadded#canCall(b#0) && Base64.__default.DecodeUnpadded#canCall(Base64.__default.EncodeUnpadded(b#0));
  free ensures {:id "id18066"} Seq#Equal(Base64.__default.DecodeUnpadded(Base64.__default.EncodeUnpadded(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeDecodeUnpadded (correctness)"} Impl$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  requires {:id "id18067"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
  modifies $Heap;
  free ensures Base64.__default.EncodeUnpadded#canCall(b#0) && Base64.__default.DecodeUnpadded#canCall(Base64.__default.EncodeUnpadded(b#0));
  free ensures {:id "id18068"} Seq#Equal(Base64.__default.DecodeUnpadded(Base64.__default.EncodeUnpadded(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecodeUnpadded (correctness)"} Impl$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeUnpadded", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(236,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.DecodeEncodeUnpadded (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncodeUnpadded (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(238,8): initial state"} true;
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(s#0);
    assume Base64.__default.IsUnpaddedBase64String(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(241,46): post-state"} true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#1) ==> Base64.__default.IsUnpaddedBase64String(##s#1) || Mod(Seq#Length(##s#1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#1) ==> Base64.__default.IsUnpaddedBase64String(##s#1) || (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#1, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#1, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.IsUnpaddedBase64String(##s#1);
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.DecodeEncodeUnpadded (call precondtion)"} CallPre$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18076"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  requires {:id "id18077"} Base64.__default.IsUnpaddedBase64String#canCall(s#0) ==> Base64.__default.IsUnpaddedBase64String(s#0) || Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  requires {:id "id18078"} Base64.__default.IsUnpaddedBase64String#canCall(s#0) ==> Base64.__default.IsUnpaddedBase64String(s#0) || (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(s#0, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(s#0, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1));



procedure {:verboseName "Base64.DecodeEncodeUnpadded (call postcondition)"} CallPost$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
  free ensures {:id "id18079"} Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.DecodeEncodeUnpadded (correctness)"} Impl$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  requires {:id "id18080"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  free requires {:id "id18081"} Base64.__default.IsUnpaddedBase64String#canCall(s#0) && Base64.__default.IsUnpaddedBase64String(s#0) && Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(s#0, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(s#0, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2));
  modifies $Heap;
  free ensures Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
  free ensures {:id "id18082"} Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncodeUnpadded (correctness)"} Impl$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var fromCharsToIndicesS#0: Seq where $Is(fromCharsToIndicesS#0, TSeq(Tclass.Base64.index())) && $IsAlloc(fromCharsToIndicesS#0, TSeq(Tclass.Base64.index()), $Heap);
  var ##s#2: Seq;
  var ##s#0_0_0: Seq;
  var ##b#0_0_0: Seq;
  var s##0_0_0: Seq;
  var ##b#0_1_0: Seq;
  var ##s#0_1_0: Seq;
  var ##b#0_1_1: Seq;
  var ##s#0_2_0: Seq;
  var ##s#0_2_1: Seq;
  var ##b#0_2_0: Seq;
  var ##b#0_2_1: Seq;
  var s##0_2_0: Seq;
  var ##b#0_2_2: Seq;
  var ##s#0_3_0: Seq;
  var ##b#0_3_0: Seq;
  var ##s#0_3_1: Seq;
  var ##s#0_3_2: Seq;
  var ##b#0_3_1: Seq;
  var ##b#0_3_2: Seq;
  var ##s#0_4_0: Seq;
  var ##s#0_4_1: Seq;
  var ##b#0_4_0: Seq;
  var ##s#0_4_2: Seq;
  var ##b#0_4_1: Seq;
  var ##s#0_5_0: Seq;
  var ##b#0_5_0: Seq;
  var ##s#0_5_1: Seq;
  var ##s#0_5_2: Seq;
  var ##b#0_5_1: Seq;
  var ##s#0_0: Seq;
  var ##b#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(242,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#3: char :: { Base64.__default.IsBase64Char(k#3) } { Seq#Contains(##s#2, $Box(k#3)) } $Is(k#3, TChar) ==> Seq#Contains(##s#2, $Box(k#3)) ==> Base64.__default.IsBase64Char(k#3));
    assume (forall k#3: char :: { Base64.__default.IsBase64Char(k#3) } { Seq#Contains(##s#2, $Box(k#3)) } $Is(k#3, TChar) ==> Seq#Contains(##s#2, $Box(k#3)) ==> Base64.__default.IsBase64Char(k#3));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    fromCharsToIndicesS#0 := Base64.__default.FromCharsToIndices(s#0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(243,52)"} true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_0) || Mod(Seq#Length(##s#0_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_0) || (forall k#0_0: char :: { Base64.__default.IsBase64Char(k#0_0) } { Seq#Contains(##s#0_0, $Box(k#0_0)) } $Is(k#0_0, TChar) ==> Seq#Contains(##s#0_0, $Box(k#0_0)) ==> Base64.__default.IsBase64Char(k#0_0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0_0 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume false;
    goto anon8;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##s#0_5_0 := s#0;
    assume $IsAlloc(##s#0_5_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_5_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_5_0) || Mod(Seq#Length(##s#0_5_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_5_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_5_0) || (forall k#0_5_0: char :: { Base64.__default.IsBase64Char(k#0_5_0) } { Seq#Contains(##s#0_5_0, $Box(k#0_5_0)) } $Is(k#0_5_0, TChar) ==> Seq#Contains(##s#0_5_0, $Box(k#0_5_0)) ==> Base64.__default.IsBase64Char(k#0_5_0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0_5_0 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0_5_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_5_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    ##s#0_5_1 := s#0;
    assume $IsAlloc(##s#0_5_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#0_5_1: char :: { Base64.__default.IsBase64Char(k#0_5_1) } { Seq#Contains(##s#0_5_1, $Box(k#0_5_1)) } $Is(k#0_5_1, TChar) ==> Seq#Contains(##s#0_5_1, $Box(k#0_5_1)) ==> Base64.__default.IsBase64Char(k#0_5_1));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    ##s#0_5_2 := Base64.__default.FromCharsToIndices(s#0);
    assume $IsAlloc(##s#0_5_2, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_5_2), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0));
    ##b#0_5_1 := Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0));
    assume $IsAlloc(##b#0_5_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_5_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0)));
    assume Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0)) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0)));
    assume {:subsumption 0} Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)), Base64.__default.EncodeUnpadded(Base64.__default.DecodeRecursively($LS($LS($LZ)), Base64.__default.FromCharsToIndices(s#0))));
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##s#0_4_0 := s#0;
    assume $IsAlloc(##s#0_4_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#0_4_0: char :: { Base64.__default.IsBase64Char(k#0_4_0) } { Seq#Contains(##s#0_4_0, $Box(k#0_4_0)) } $Is(k#0_4_0, TChar) ==> Seq#Contains(##s#0_4_0, $Box(k#0_4_0)) ==> Base64.__default.IsBase64Char(k#0_4_0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    ##s#0_4_1 := Base64.__default.FromCharsToIndices(s#0);
    assume $IsAlloc(##s#0_4_1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_4_1), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0));
    ##b#0_4_0 := Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0));
    assume $IsAlloc(##b#0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_4_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0)));
    assume Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0)) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0)));
    ##s#0_4_2 := fromCharsToIndicesS#0;
    assume $IsAlloc(##s#0_4_2, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_4_2), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    ##b#0_4_1 := Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0);
    assume $IsAlloc(##b#0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_4_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    assume {:subsumption 0} Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeRecursively($LS($LS($LZ)), Base64.__default.FromCharsToIndices(s#0))), Base64.__default.EncodeUnpadded(Base64.__default.DecodeRecursively($LS($LS($LZ)), fromCharsToIndicesS#0)));
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##s#0_3_0 := fromCharsToIndicesS#0;
    assume $IsAlloc(##s#0_3_0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_3_0), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    ##b#0_3_0 := Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0);
    assume $IsAlloc(##b#0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_3_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(fromCharsToIndicesS#0), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(251,43)"} true;
    ##s#0_3_1 := fromCharsToIndicesS#0;
    assume $IsAlloc(##s#0_3_1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_3_1), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    assume {:subsumption 0} Mod(Seq#Length(Base64.__default.DecodeRecursively($LS($LS($LZ)), fromCharsToIndicesS#0)), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)), LitInt(3)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(252,62)"} true;
    ##s#0_3_2 := fromCharsToIndicesS#0;
    assume $IsAlloc(##s#0_3_2, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_3_2), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    ##b#0_3_1 := Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0);
    assume $IsAlloc(##b#0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_3_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    ##b#0_3_2 := Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    assume $IsAlloc(##b#0_3_2, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)));
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0) && Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)));
    assume {:subsumption 0} Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeRecursively($LS($LS($LZ)), fromCharsToIndicesS#0)), Base64.__default.FromIndicesToChars(Base64.__default.EncodeRecursively($LS($LS($LZ)), Base64.__default.DecodeRecursively($LS($LS($LZ)), fromCharsToIndicesS#0))));
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(fromCharsToIndicesS#0), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(251,43)"} true;
    ##s#0_2_0 := fromCharsToIndicesS#0;
    assume $IsAlloc(##s#0_2_0, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_2_0), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    assume {:subsumption 0} Mod(Seq#Length(Base64.__default.DecodeRecursively($LS($LS($LZ)), fromCharsToIndicesS#0)), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)), LitInt(3)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(252,62)"} true;
    ##s#0_2_1 := fromCharsToIndicesS#0;
    assume $IsAlloc(##s#0_2_1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##s#0_2_1), LitInt(4)) == LitInt(0);
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0);
    ##b#0_2_0 := Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0);
    assume $IsAlloc(##b#0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_2_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    ##b#0_2_1 := Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0));
    assume $IsAlloc(##b#0_2_1, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)));
    assume Base64.__default.DecodeRecursively#canCall(fromCharsToIndicesS#0) && Base64.__default.EncodeRecursively#canCall(Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), Base64.__default.DecodeRecursively($LS($LZ), fromCharsToIndicesS#0)));
    assume true;
    s##0_2_0 := fromCharsToIndicesS#0;
    call CallPre$$Base64.__default.DecodeEncodeRecursively(s##0_2_0);
    call CallPost$$Base64.__default.DecodeEncodeRecursively(s##0_2_0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(254,53)"} true;
    ##b#0_2_2 := fromCharsToIndicesS#0;
    assume $IsAlloc(##b#0_2_2, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(fromCharsToIndicesS#0);
    assume Base64.__default.FromIndicesToChars#canCall(fromCharsToIndicesS#0);
    assume {:subsumption 0} Seq#Equal(Base64.__default.FromIndicesToChars(Base64.__default.EncodeRecursively($LS($LS($LZ)), Base64.__default.DecodeRecursively($LS($LS($LZ)), fromCharsToIndicesS#0))), Base64.__default.FromIndicesToChars(fromCharsToIndicesS#0));
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##b#0_1_0 := fromCharsToIndicesS#0;
    assume $IsAlloc(##b#0_1_0, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(fromCharsToIndicesS#0);
    assume Base64.__default.FromIndicesToChars#canCall(fromCharsToIndicesS#0);
    ##s#0_1_0 := s#0;
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#0_1_0: char :: { Base64.__default.IsBase64Char(k#0_1_0) } { Seq#Contains(##s#0_1_0, $Box(k#0_1_0)) } $Is(k#0_1_0, TChar) ==> Seq#Contains(##s#0_1_0, $Box(k#0_1_0)) ==> Base64.__default.IsBase64Char(k#0_1_0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    ##b#0_1_1 := Base64.__default.FromCharsToIndices(s#0);
    assume $IsAlloc(##b#0_1_1, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume {:subsumption 0} Seq#Equal(Base64.__default.FromIndicesToChars(fromCharsToIndicesS#0), Base64.__default.FromIndicesToChars(Base64.__default.FromCharsToIndices(s#0)));
    assume false;
    goto anon8;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall k#0_0_0: char :: { Base64.__default.IsBase64Char(k#0_0_0) } { Seq#Contains(##s#0_0_0, $Box(k#0_0_0)) } $Is(k#0_0_0, TChar) ==> Seq#Contains(##s#0_0_0, $Box(k#0_0_0)) ==> Base64.__default.IsBase64Char(k#0_0_0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0);
    ##b#0_0_0 := Base64.__default.FromCharsToIndices(s#0);
    assume $IsAlloc(##b#0_0_0, TSeq(Tclass.Base64.index()), $Heap);
    assume Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.FromCharsToIndices(s#0));
    assume true;
    s##0_0_0 := s#0;
    call CallPre$$Base64.__default.FromCharsToIndicesToChars(s##0_0_0);
    call CallPost$$Base64.__default.FromCharsToIndicesToChars(s##0_0_0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(258,37)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.FromIndicesToChars(Base64.__default.FromCharsToIndices(s#0)), s#0);
    assume false;
    goto anon8;

  anon15_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)), s#0);
    return;
}



function Base64.__default.Is1Padding(s#0: Seq) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Is1Padding(s#0) } Base64.__default.Is1Padding#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(s#0) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char))))) && (Base64.__default.Is1Padding(s#0) <==> Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.Is1Padding(Lit(s#0)) } Base64.__default.Is1Padding#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(Lit(s#0)) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char))))) && (Base64.__default.Is1Padding(Lit(s#0)) <==> Seq#Length(Lit(s#0)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): char == Lit(char#FromInt(61))));
}

function Base64.__default.Is1Padding#canCall(s#0: Seq) : bool;

function Base64.__default.Is1Padding#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.Is1Padding#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.Is1Padding#requires(s#0) <==> true));

procedure {:verboseName "Base64.Is1Padding (well-formedness)"} CheckWellformed$$Base64.__default.Is1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Is1Padding (well-formedness)"} CheckWellformed$$Base64.__default.Is1Padding(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##c#1: char;
  var ##c#2: char;
  var ##c#3: char;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.Is1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(263,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##c#0 := $Unbox(Seq#Index(s#0, LitInt(0))): char;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char);
    goto anon5;

  anon15_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(4);
    goto anon5;

  anon5:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    ##c#1 := $Unbox(Seq#Index(s#0, LitInt(1))): char;
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char);
    goto anon7;

  anon16_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char));
    goto anon7;

  anon7:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    ##c#2 := $Unbox(Seq#Index(s#0, LitInt(2))): char;
    assume $IsAlloc(##c#2, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char);
    goto anon9;

  anon17_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char));
    goto anon9;

  anon9:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    ##c#3 := $Unbox(Seq#Index(s#0, LitInt(2))): char;
    assume $IsAlloc(##c#3, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#3) ==> Base64.__default.IsBase64Char(##c#3) || ##c#3 == Lit(char#FromInt(43)) || ##c#3 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#3) && char#ToInt(##c#3) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#3) && char#ToInt(##c#3) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#3) && char#ToInt(##c#3) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#3);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char);
    newtype$check#0 := LitInt(4);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 64;
    assume LitInt(4) != 0;
    newtype$check#1 := Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 64;
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 64;
    goto anon11;

  anon18_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char));
    goto anon11;

  anon11:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    goto anon13;

  anon19_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0));
    goto anon13;

  anon13:
    assume Base64.__default.Is1Padding(s#0) <==> Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));
    assume Seq#Length(s#0) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char))));
    assume $Is(Base64.__default.Is1Padding(s#0), TBool);
    return;
}



function Base64.__default.Decode1Padding(s#0: Seq) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Decode1Padding(s#0) } Base64.__default.Decode1Padding#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.Is1Padding(s#0)) ==> Seq#Length(Base64.__default.Decode1Padding(s#0)) == LitInt(2) && $Is(Base64.__default.Decode1Padding(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Decode1Padding(s#0) } Base64.__default.Decode1Padding#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.Is1Padding(s#0)) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0)))) && Base64.__default.Decode1Padding(s#0) == (var d#0 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(d#0, LitInt(0))), Seq#Index(d#0, LitInt(1)))));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.Decode1Padding(Lit(s#0)) } Base64.__default.Decode1Padding#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Lit(Base64.__default.Is1Padding(Lit(s#0)))) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char))), $Box(LitInt(0)))) && Base64.__default.Decode1Padding(Lit(s#0)) == (var d#1 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(d#1, LitInt(0))), Seq#Index(d#1, LitInt(1)))));
}

function Base64.__default.Decode1Padding#canCall(s#0: Seq) : bool;

function Base64.__default.Decode1Padding#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.Decode1Padding#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.Decode1Padding#requires(s#0) <==> Base64.__default.Is1Padding(s#0)));

procedure {:verboseName "Base64.Decode1Padding (well-formedness)"} CheckWellformed$$Base64.__default.Decode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18141"} Seq#Length(b#0) == LitInt(2);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Decode1Padding (well-formedness)"} CheckWellformed$$Base64.__default.Decode1Padding(s#0: Seq) returns (b#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var d#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##c#0: char;
  var ##c#1: char;
  var ##c#2: char;
  var newtype$check#0: int;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.Decode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(273,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(s#0);
    assume Base64.__default.Is1Padding(s#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.Decode1Padding(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(b#0) == LitInt(2);
    assume false;
    return;

  anon4_Else:
    havoc d#Z#0;
    assume $Is(d#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(d#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##c#0 := $Unbox(Seq#Index(s#0, LitInt(0))): char;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#0) ==> Base64.__default.IsBase64Char(##c#0) || ##c#0 == Lit(char#FromInt(43)) || ##c#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#0);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    ##c#1 := $Unbox(Seq#Index(s#0, LitInt(1))): char;
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#1) ==> Base64.__default.IsBase64Char(##c#1) || ##c#1 == Lit(char#FromInt(43)) || ##c#1 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#1);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    ##c#2 := $Unbox(Seq#Index(s#0, LitInt(2))): char;
    assume $IsAlloc(##c#2, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#2) ==> Base64.__default.IsBase64Char(##c#2) || ##c#2 == Lit(char#FromInt(43)) || ##c#2 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#2) && char#ToInt(##c#2) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#2) && char#ToInt(##c#2) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#2) && char#ToInt(##c#2) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#2);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 64;
    ##s#1 := Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0)));
    assume $IsAlloc(##s#1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(4);
    assume Seq#Length(##s#1) == LitInt(4);
    assume Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0))));
    assume let#0#0#0 == Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0))));
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0))));
    assume $Is(let#0#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume d#Z#0 == let#0#0#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(d#Z#0);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(d#Z#0);
    assume Base64.__default.Decode1Padding(s#0) == Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(d#Z#0, LitInt(0))), Seq#Index(d#Z#0, LitInt(1)));
    assume true;
    assume $Is(Base64.__default.Decode1Padding(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Base64.__default.Decode1Padding(s#0) == b#0;
    return;
}



function Base64.__default.Encode1Padding(b#0: Seq) : Seq
uses {
axiom 5 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.Encode1Padding(b#0) } Base64.__default.Encode1Padding#canCall(b#0) || (5 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(2)) ==> Base64.__default.Is1Padding(Base64.__default.Encode1Padding(b#0)) && Seq#Equal(Base64.__default.Decode1Padding(Base64.__default.Encode1Padding(b#0)), b#0) && Mod(Seq#Length(Base64.__default.Encode1Padding(b#0)), LitInt(4)) == LitInt(0) && $Is(Base64.__default.Encode1Padding(b#0), TSeq(TChar)));
axiom 5 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.Encode1Padding(b#0) } Base64.__default.Encode1Padding#canCall(b#0) || (5 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(2)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)))) && (var e#0 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#0, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#0, LitInt(1))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#0, LitInt(2))): int)) && Base64.__default.Encode1Padding(b#0) == (var e#0 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#0, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#0, LitInt(1))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#0, LitInt(2))): int))), $Box(Lit(char#FromInt(61))))));
axiom 5 <= $FunctionContextHeight ==> (forall b#0: Seq :: {:weight 3} { Base64.__default.Encode1Padding(Lit(b#0)) } Base64.__default.Encode1Padding#canCall(Lit(b#0)) || (5 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(b#0)) == LitInt(2)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), Seq#Index(Lit(b#0), LitInt(1))), $Box(LitInt(0)))) && (var e#1 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), Seq#Index(Lit(b#0), LitInt(1))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#1, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#1, LitInt(1))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#1, LitInt(2))): int)) && Base64.__default.Encode1Padding(Lit(b#0)) == (var e#1 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), Seq#Index(Lit(b#0), LitInt(1))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#1, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#1, LitInt(1))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#1, LitInt(2))): int))), $Box(Lit(char#FromInt(61))))));
}

function Base64.__default.Encode1Padding#canCall(b#0: Seq) : bool;

function Base64.__default.Encode1Padding#requires(Seq) : bool;

axiom (forall b#0: Seq :: { Base64.__default.Encode1Padding#requires(b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.Encode1Padding#requires(b#0) <==> Seq#Length(b#0) == LitInt(2)));

procedure {:verboseName "Base64.Encode1Padding (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$Base64.__default.Encode1Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18158"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || Seq#Length(s#0) == LitInt(4);
  free ensures {:id "id18159"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  free ensures {:id "id18160"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  free ensures {:id "id18161"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) || $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  free ensures {:id "id18162"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0);
  free ensures {:id "id18163"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));
  free ensures {:id "id18164"} Seq#Equal(Base64.__default.Decode1Padding(s#0), b#0);
  free ensures {:id "id18165"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Encode1Padding (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$Base64.__default.Encode1Padding(b#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var e#Z#0: Seq;
  var let#0#0#0: Seq;
  var newtype$check#0: int;
  var ##s#2: Seq;
  var ##i#0: int;
  var ##i#1: int;
  var ##i#2: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.Encode1Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(282,47): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(b#0) == LitInt(2);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.Encode1Padding(b#0), TSeq(TChar));
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(s#0);
    assume Base64.__default.Is1Padding(s#0);
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || Seq#Length(##s#1) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(0))): char) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(1))): char) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(2))): char) || $Unbox(Seq#Index(##s#1, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#1, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || $Unbox(Seq#Index(##s#1, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is1Padding(##s#1);
    assume Base64.__default.Decode1Padding#canCall(s#0);
    assume Seq#Equal(Base64.__default.Decode1Padding(s#0), b#0);
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    assume false;
    return;

  anon4_Else:
    havoc e#Z#0;
    assume $Is(e#Z#0, TSeq(Tclass.Base64.index())) && $IsAlloc(e#Z#0, TSeq(Tclass.Base64.index()), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(b#0);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(b#0);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    ##s#2 := Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)));
    assume $IsAlloc(##s#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) == LitInt(3);
    assume Seq#Length(##s#2) == LitInt(3);
    assume Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0))));
    assume let#0#0#0 == Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0))));
    assume Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0))));
    assume $Is(let#0#0#0, TSeq(Tclass.Base64.index()));
    assume e#Z#0 == let#0#0#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(e#Z#0);
    ##i#0 := $Unbox(Seq#Index(e#Z#0, LitInt(0))): int;
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(0))): int);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(e#Z#0);
    ##i#1 := $Unbox(Seq#Index(e#Z#0, LitInt(1))): int;
    assume $IsAlloc(##i#1, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(1))): int);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(e#Z#0);
    ##i#2 := $Unbox(Seq#Index(e#Z#0, LitInt(2))): int;
    assume $IsAlloc(##i#2, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(2))): int);
    assume Base64.__default.Encode1Padding(b#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#Z#0, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#Z#0, LitInt(1))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#Z#0, LitInt(2))): int))), $Box(Lit(char#FromInt(61))));
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(1))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(2))): int);
    assume $Is(Base64.__default.Encode1Padding(b#0), TSeq(TChar));
    assume Base64.__default.Encode1Padding(b#0) == s#0;
    return;
}



procedure {:verboseName "Base64.DecodeEncode1Padding (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncode1Padding (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncode1Padding(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(293,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(s#0);
    assume Base64.__default.Is1Padding(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(295,46): post-state"} true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || Seq#Length(##s#1) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(0))): char) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(1))): char) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(2))): char) || $Unbox(Seq#Index(##s#1, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#1, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#1) ==> Base64.__default.Is1Padding(##s#1) || $Unbox(Seq#Index(##s#1, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is1Padding(##s#1);
    assume Base64.__default.Decode1Padding#canCall(s#0);
    ##b#0 := Base64.__default.Decode1Padding(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0) == LitInt(2);
    assume Seq#Length(##b#0) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(s#0));
    assume Seq#Equal(Base64.__default.Encode1Padding(Base64.__default.Decode1Padding(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.DecodeEncode1Padding (call precondtion)"} CallPre$$Base64.__default.DecodeEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18197"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || Seq#Length(s#0) == LitInt(4);
  requires {:id "id18198"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18199"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18200"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) || $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18201"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0);
  requires {:id "id18202"} Base64.__default.Is1Padding#canCall(s#0) ==> Base64.__default.Is1Padding(s#0) || $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64.DecodeEncode1Padding (call postcondition)"} CallPost$$Base64.__default.DecodeEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Decode1Padding#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(s#0));
  free ensures {:id "id18203"} Seq#Equal(Base64.__default.Encode1Padding(Base64.__default.Decode1Padding(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.DecodeEncode1Padding (correctness)"} Impl$$Base64.__default.DecodeEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  free requires {:id "id18204"} Base64.__default.Is1Padding#canCall(s#0) && Base64.__default.Is1Padding(s#0) && Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.Decode1Padding#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(s#0));
  free ensures {:id "id18205"} Seq#Equal(Base64.__default.Encode1Padding(Base64.__default.Decode1Padding(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncode1Padding (correctness)"} Impl$$Base64.__default.DecodeEncode1Padding(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(296,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.EncodeDecode1Padding (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecode1Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecode1Padding (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecode1Padding(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecode1Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(298,8): initial state"} true;
    assume Seq#Length(b#0) == LitInt(2);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(300,46): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0) == LitInt(2);
    assume Seq#Length(##b#0) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(b#0);
    ##s#0 := Base64.__default.Encode1Padding(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0) ==> Base64.__default.Is1Padding(##s#0) || Seq#Length(##s#0) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0) ==> Base64.__default.Is1Padding(##s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0, LitInt(0))): char) || $Unbox(Seq#Index(##s#0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0) ==> Base64.__default.Is1Padding(##s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0, LitInt(1))): char) || $Unbox(Seq#Index(##s#0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0) ==> Base64.__default.Is1Padding(##s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0, LitInt(2))): char) || $Unbox(Seq#Index(##s#0, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0) ==> Base64.__default.Is1Padding(##s#0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0) ==> Base64.__default.Is1Padding(##s#0) || $Unbox(Seq#Index(##s#0, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is1Padding(##s#0);
    assume Base64.__default.Decode1Padding#canCall(Base64.__default.Encode1Padding(b#0));
    assume Seq#Equal(Base64.__default.Decode1Padding(Base64.__default.Encode1Padding(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64.EncodeDecode1Padding (call precondtion)"} CallPre$$Base64.__default.EncodeDecode1Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id18215"} Seq#Length(b#0) == LitInt(2);



procedure {:verboseName "Base64.EncodeDecode1Padding (call postcondition)"} CallPost$$Base64.__default.EncodeDecode1Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode1Padding#canCall(b#0) && Base64.__default.Decode1Padding#canCall(Base64.__default.Encode1Padding(b#0));
  free ensures {:id "id18216"} Seq#Equal(Base64.__default.Decode1Padding(Base64.__default.Encode1Padding(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeDecode1Padding (correctness)"} Impl$$Base64.__default.EncodeDecode1Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  requires {:id "id18217"} Seq#Length(b#0) == LitInt(2);
  modifies $Heap;
  free ensures Base64.__default.Encode1Padding#canCall(b#0) && Base64.__default.Decode1Padding#canCall(Base64.__default.Encode1Padding(b#0));
  free ensures {:id "id18218"} Seq#Equal(Base64.__default.Decode1Padding(Base64.__default.Encode1Padding(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecode1Padding (correctness)"} Impl$$Base64.__default.EncodeDecode1Padding(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecode1Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(301,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.Is2Padding(s#0: Seq) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Is2Padding(s#0) } Base64.__default.Is2Padding#canCall(s#0) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(s#0) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char)))) && (Base64.__default.Is2Padding(s#0) <==> Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61))));
axiom 3 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.Is2Padding(Lit(s#0)) } Base64.__default.Is2Padding#canCall(Lit(s#0)) || (3 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Seq#Length(Lit(s#0)) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char)))) && (Base64.__default.Is2Padding(Lit(s#0)) <==> Seq#Length(Lit(s#0)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): char == Lit(char#FromInt(61))));
}

function Base64.__default.Is2Padding#canCall(s#0: Seq) : bool;

function Base64.__default.Is2Padding#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.Is2Padding#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.Is2Padding#requires(s#0) <==> true));

procedure {:verboseName "Base64.Is2Padding (well-formedness)"} CheckWellformed$$Base64.__default.Is2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Is2Padding (well-formedness)"} CheckWellformed$$Base64.__default.Is2Padding(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##c#1: char;
  var ##c#2: char;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.Is2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(303,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##c#0 := $Unbox(Seq#Index(s#0, LitInt(0))): char;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char);
    goto anon5;

  anon15_Else:
    assume {:partition} Seq#Length(s#0) != LitInt(4);
    goto anon5;

  anon5:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    ##c#1 := $Unbox(Seq#Index(s#0, LitInt(1))): char;
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char);
    goto anon7;

  anon16_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char));
    goto anon7;

  anon7:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    ##c#2 := $Unbox(Seq#Index(s#0, LitInt(1))): char;
    assume $IsAlloc(##c#2, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#2) ==> Base64.__default.IsBase64Char(##c#2) || ##c#2 == Lit(char#FromInt(43)) || ##c#2 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#2) && char#ToInt(##c#2) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#2) && char#ToInt(##c#2) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#2) && char#ToInt(##c#2) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#2);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char);
    newtype$check#0 := LitInt(16);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 64;
    assume LitInt(16) != 0;
    newtype$check#1 := Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 64;
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < 64;
    goto anon9;

  anon17_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char));
    goto anon9;

  anon9:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume 0 <= LitInt(2) && LitInt(2) < Seq#Length(s#0);
    goto anon11;

  anon18_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0));
    goto anon11;

  anon11:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61));
    assume 0 <= LitInt(3) && LitInt(3) < Seq#Length(s#0);
    goto anon13;

  anon19_Else:
    assume {:partition} !(Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61)));
    goto anon13;

  anon13:
    assume Base64.__default.Is2Padding(s#0) <==> Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));
    assume Seq#Length(s#0) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char)));
    assume $Is(Base64.__default.Is2Padding(s#0), TBool);
    return;
}



function Base64.__default.Decode2Padding(s#0: Seq) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Decode2Padding(s#0) } Base64.__default.Decode2Padding#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.Is2Padding(s#0)) ==> Seq#Length(Base64.__default.Decode2Padding(s#0)) == LitInt(1) && $Is(Base64.__default.Decode2Padding(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Decode2Padding(s#0) } Base64.__default.Decode2Padding#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.Is2Padding(s#0)) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))) && Base64.__default.Decode2Padding(s#0) == (var d#0 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Empty(): Seq, Seq#Index(d#0, LitInt(0)))));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.Decode2Padding(Lit(s#0)) } Base64.__default.Decode2Padding#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Lit(Base64.__default.Is2Padding(Lit(s#0)))) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))) && Base64.__default.Decode2Padding(Lit(s#0)) == (var d#1 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Empty(): Seq, Seq#Index(d#1, LitInt(0)))));
}

function Base64.__default.Decode2Padding#canCall(s#0: Seq) : bool;

function Base64.__default.Decode2Padding#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.Decode2Padding#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.Decode2Padding#requires(s#0) <==> Base64.__default.Is2Padding(s#0)));

procedure {:verboseName "Base64.Decode2Padding (well-formedness)"} CheckWellformed$$Base64.__default.Decode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18230"} Seq#Length(b#0) == LitInt(1);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Decode2Padding (well-formedness)"} CheckWellformed$$Base64.__default.Decode2Padding(s#0: Seq) returns (b#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var d#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##c#0: char;
  var ##c#1: char;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.Decode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(313,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(s#0);
    assume Base64.__default.Is2Padding(s#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.Decode2Padding(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Seq#Length(b#0) == LitInt(1);
    assume false;
    return;

  anon4_Else:
    havoc d#Z#0;
    assume $Is(d#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(d#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(s#0);
    ##c#0 := $Unbox(Seq#Index(s#0, LitInt(0))): char;
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#0) ==> Base64.__default.IsBase64Char(##c#0) || ##c#0 == Lit(char#FromInt(43)) || ##c#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#0) && char#ToInt(##c#0) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#0);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(s#0);
    ##c#1 := $Unbox(Seq#Index(s#0, LitInt(1))): char;
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64Char#canCall(##c#1) ==> Base64.__default.IsBase64Char(##c#1) || ##c#1 == Lit(char#FromInt(43)) || ##c#1 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(##c#1) && char#ToInt(##c#1) <= char#ToInt(Lit(char#FromInt(122))));
    assume Base64.__default.IsBase64Char(##c#1);
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < 64;
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < 64;
    ##s#1 := Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)));
    assume $IsAlloc(##s#1, TSeq(Tclass.Base64.index()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#1) == LitInt(4);
    assume Seq#Length(##s#1) == LitInt(4);
    assume Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0))));
    assume let#0#0#0 == Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0))));
    assume Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0))));
    assume $Is(let#0#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume d#Z#0 == let#0#0#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(d#Z#0);
    assume Base64.__default.Decode2Padding(s#0) == Seq#Build(Seq#Empty(): Seq, Seq#Index(d#Z#0, LitInt(0)));
    assume true;
    assume $Is(Base64.__default.Decode2Padding(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume Base64.__default.Decode2Padding(s#0) == b#0;
    return;
}



function Base64.__default.Encode2Padding(b#0: Seq) : Seq
uses {
axiom 5 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.Encode2Padding(b#0) } Base64.__default.Encode2Padding#canCall(b#0) || (5 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(1)) ==> Base64.__default.Is2Padding(Base64.__default.Encode2Padding(b#0)) && Seq#Equal(Base64.__default.Decode2Padding(Base64.__default.Encode2Padding(b#0)), b#0) && Mod(Seq#Length(Base64.__default.Encode2Padding(b#0)), LitInt(4)) == LitInt(0) && $Is(Base64.__default.Encode2Padding(b#0), TSeq(TChar)));
axiom 5 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.Encode2Padding(b#0) } Base64.__default.Encode2Padding#canCall(b#0) || (5 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(1)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))) && (var e#0 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#0, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#0, LitInt(1))): int)) && Base64.__default.Encode2Padding(b#0) == (var e#0 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#0, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#0, LitInt(1))): int))), $Box(Lit(char#FromInt(61)))), $Box(Lit(char#FromInt(61))))));
axiom 5 <= $FunctionContextHeight ==> (forall b#0: Seq :: {:weight 3} { Base64.__default.Encode2Padding(Lit(b#0)) } Base64.__default.Encode2Padding#canCall(Lit(b#0)) || (5 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(b#0)) == LitInt(1)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))) && (var e#1 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#1, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#1, LitInt(1))): int)) && Base64.__default.Encode2Padding(Lit(b#0)) == (var e#1 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#1, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#1, LitInt(1))): int))), $Box(Lit(char#FromInt(61)))), $Box(Lit(char#FromInt(61))))));
}

function Base64.__default.Encode2Padding#canCall(b#0: Seq) : bool;

function Base64.__default.Encode2Padding#requires(Seq) : bool;

axiom (forall b#0: Seq :: { Base64.__default.Encode2Padding#requires(b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.Encode2Padding#requires(b#0) <==> Seq#Length(b#0) == LitInt(1)));

procedure {:verboseName "Base64.Encode2Padding (well-formedness)"} CheckWellformed$$Base64.__default.Encode2Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18245"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || Seq#Length(s#0) == LitInt(4);
  free ensures {:id "id18246"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  free ensures {:id "id18247"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  free ensures {:id "id18248"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0);
  free ensures {:id "id18249"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61));
  free ensures {:id "id18250"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));
  free ensures {:id "id18251"} Seq#Equal(Base64.__default.Decode2Padding(s#0), b#0);
  free ensures {:id "id18252"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Encode2Padding (well-formedness)"} CheckWellformed$$Base64.__default.Encode2Padding(b#0: Seq) returns (s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var e#Z#0: Seq;
  var let#0#0#0: Seq;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##s#2: Seq;
  var ##i#0: int;
  var ##i#1: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.Encode2Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(322,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(b#0) == LitInt(1);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(Base64.__default.Encode2Padding(b#0), TSeq(TChar));
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(s#0);
    assume Base64.__default.Is2Padding(s#0);
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || Seq#Length(##s#1) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(0))): char) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(1))): char) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#1, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || $Unbox(Seq#Index(##s#1, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || $Unbox(Seq#Index(##s#1, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is2Padding(##s#1);
    assume Base64.__default.Decode2Padding#canCall(s#0);
    assume Seq#Equal(Base64.__default.Decode2Padding(s#0), b#0);
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    assume false;
    return;

  anon4_Else:
    havoc e#Z#0;
    assume $Is(e#Z#0, TSeq(Tclass.Base64.index())) && $IsAlloc(e#Z#0, TSeq(Tclass.Base64.index()), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(b#0);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##s#2 := Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)));
    assume $IsAlloc(##s#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##s#2) == LitInt(3);
    assume Seq#Length(##s#2) == LitInt(3);
    assume Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0))));
    assume let#0#0#0 == Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0))));
    assume Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0))));
    assume $Is(let#0#0#0, TSeq(Tclass.Base64.index()));
    assume e#Z#0 == let#0#0#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(e#Z#0);
    ##i#0 := $Unbox(Seq#Index(e#Z#0, LitInt(0))): int;
    assume $IsAlloc(##i#0, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(0))): int);
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(e#Z#0);
    ##i#1 := $Unbox(Seq#Index(e#Z#0, LitInt(1))): int;
    assume $IsAlloc(##i#1, Tclass.Base64.index(), $Heap);
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(1))): int);
    assume Base64.__default.Encode2Padding(b#0) == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#Z#0, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#Z#0, LitInt(1))): int))), $Box(Lit(char#FromInt(61)))), $Box(Lit(char#FromInt(61))));
    assume Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#Z#0, LitInt(1))): int);
    assume $Is(Base64.__default.Encode2Padding(b#0), TSeq(TChar));
    assume Base64.__default.Encode2Padding(b#0) == s#0;
    return;
}



procedure {:verboseName "Base64.DecodeEncode2Padding (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncode2Padding (well-formedness)"} CheckWellFormed$$Base64.__default.DecodeEncode2Padding(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(334,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(s#0);
    assume Base64.__default.Is2Padding(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(336,46): post-state"} true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || Seq#Length(##s#1) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(0))): char) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#1, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#1, LitInt(1))): char) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#1, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#1, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || $Unbox(Seq#Index(##s#1, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#1) ==> Base64.__default.Is2Padding(##s#1) || $Unbox(Seq#Index(##s#1, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is2Padding(##s#1);
    assume Base64.__default.Decode2Padding#canCall(s#0);
    ##b#0 := Base64.__default.Decode2Padding(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0) == LitInt(1);
    assume Seq#Length(##b#0) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(s#0));
    assume Seq#Equal(Base64.__default.Encode2Padding(Base64.__default.Decode2Padding(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64.DecodeEncode2Padding (call precondtion)"} CallPre$$Base64.__default.DecodeEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18283"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || Seq#Length(s#0) == LitInt(4);
  requires {:id "id18284"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18285"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(s#0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18286"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0);
  requires {:id "id18287"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61));
  requires {:id "id18288"} Base64.__default.Is2Padding#canCall(s#0) ==> Base64.__default.Is2Padding(s#0) || $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64.DecodeEncode2Padding (call postcondition)"} CallPost$$Base64.__default.DecodeEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Decode2Padding#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(s#0));
  free ensures {:id "id18289"} Seq#Equal(Base64.__default.Encode2Padding(Base64.__default.Decode2Padding(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.DecodeEncode2Padding (correctness)"} Impl$$Base64.__default.DecodeEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  free requires {:id "id18290"} Base64.__default.Is2Padding#canCall(s#0) && Base64.__default.Is2Padding(s#0) && Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.Decode2Padding#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(s#0));
  free ensures {:id "id18291"} Seq#Equal(Base64.__default.Encode2Padding(Base64.__default.Decode2Padding(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeEncode2Padding (correctness)"} Impl$$Base64.__default.DecodeEncode2Padding(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeEncode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(337,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64.EncodeDecode2Padding (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecode2Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecode2Padding (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeDecode2Padding(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecode2Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(339,8): initial state"} true;
    assume Seq#Length(b#0) == LitInt(1);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(341,46): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0) == LitInt(1);
    assume Seq#Length(##b#0) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(b#0);
    ##s#0 := Base64.__default.Encode2Padding(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0) ==> Base64.__default.Is2Padding(##s#0) || Seq#Length(##s#0) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0) ==> Base64.__default.Is2Padding(##s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0, LitInt(0))): char) || $Unbox(Seq#Index(##s#0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0) ==> Base64.__default.Is2Padding(##s#0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0, LitInt(1))): char) || $Unbox(Seq#Index(##s#0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0) ==> Base64.__default.Is2Padding(##s#0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0) ==> Base64.__default.Is2Padding(##s#0) || $Unbox(Seq#Index(##s#0, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0) ==> Base64.__default.Is2Padding(##s#0) || $Unbox(Seq#Index(##s#0, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is2Padding(##s#0);
    assume Base64.__default.Decode2Padding#canCall(Base64.__default.Encode2Padding(b#0));
    assume Seq#Equal(Base64.__default.Decode2Padding(Base64.__default.Encode2Padding(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64.EncodeDecode2Padding (call precondtion)"} CallPre$$Base64.__default.EncodeDecode2Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id18301"} Seq#Length(b#0) == LitInt(1);



procedure {:verboseName "Base64.EncodeDecode2Padding (call postcondition)"} CallPost$$Base64.__default.EncodeDecode2Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode2Padding#canCall(b#0) && Base64.__default.Decode2Padding#canCall(Base64.__default.Encode2Padding(b#0));
  free ensures {:id "id18302"} Seq#Equal(Base64.__default.Decode2Padding(Base64.__default.Encode2Padding(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeDecode2Padding (correctness)"} Impl$$Base64.__default.EncodeDecode2Padding(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 6 == $FunctionContextHeight;
  requires {:id "id18303"} Seq#Length(b#0) == LitInt(1);
  modifies $Heap;
  free ensures Base64.__default.Encode2Padding#canCall(b#0) && Base64.__default.Decode2Padding#canCall(Base64.__default.Encode2Padding(b#0));
  free ensures {:id "id18304"} Seq#Equal(Base64.__default.Decode2Padding(Base64.__default.Encode2Padding(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeDecode2Padding (correctness)"} Impl$$Base64.__default.EncodeDecode2Padding(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeDecode2Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(342,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.IsBase64String(s#0: Seq) : bool
uses {
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.IsBase64String(s#0) } Base64.__default.IsBase64String#canCall(s#0) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (var finalBlockStart#0 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) ==> Base64.__default.IsUnpaddedBase64String#canCall(s#0) && (!Base64.__default.IsUnpaddedBase64String(s#0) ==> Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, finalBlockStart#0)) && (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#0)) ==> Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, finalBlockStart#0)) && (!Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#0)) ==> Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, finalBlockStart#0)))))) && (Base64.__default.IsBase64String(s#0) <==> (var finalBlockStart#0 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#0))))))));
axiom 4 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.IsBase64String(Lit(s#0)) } Base64.__default.IsBase64String#canCall(Lit(s#0)) || (4 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (var finalBlockStart#1 := Seq#Length(Lit(s#0)) - 4; Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) ==> Base64.__default.IsUnpaddedBase64String#canCall(Lit(s#0)) && (!Lit(Base64.__default.IsUnpaddedBase64String(Lit(s#0))) ==> Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(Lit(s#0), finalBlockStart#1)) && (Base64.__default.IsUnpaddedBase64String(Seq#Take(Lit(s#0), finalBlockStart#1)) ==> Base64.__default.Is1Padding#canCall(Seq#Drop(Lit(s#0), finalBlockStart#1)) && (!Base64.__default.Is1Padding(Seq#Drop(Lit(s#0), finalBlockStart#1)) ==> Base64.__default.Is2Padding#canCall(Seq#Drop(Lit(s#0), finalBlockStart#1)))))) && (Base64.__default.IsBase64String(Lit(s#0)) <==> (var finalBlockStart#1 := Seq#Length(Lit(s#0)) - 4; Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(Lit(s#0)) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(Lit(s#0), finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(Lit(s#0), finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(Lit(s#0), finalBlockStart#1))))))));
}

function Base64.__default.IsBase64String#canCall(s#0: Seq) : bool;

function Base64.__default.IsBase64String#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.IsBase64String#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.IsBase64String#requires(s#0) <==> true));

procedure {:verboseName "Base64.IsBase64String (well-formedness)"} CheckWellformed$$Base64.__default.IsBase64String(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.IsBase64String (well-formedness)"} CheckWellformed$$Base64.__default.IsBase64String(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var finalBlockStart#Z#0: int;
  var let#0#0#0: int;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.IsBase64String", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(344,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    havoc finalBlockStart#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(s#0) - 4;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume finalBlockStart#Z#0 == let#0#0#0;
    assume LitInt(4) != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(s#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} !Base64.__default.IsUnpaddedBase64String(s#0);
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    ##s#1 := Seq#Take(s#0, finalBlockStart#Z#0);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, finalBlockStart#Z#0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#Z#0));
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    ##s#2 := Seq#Drop(s#0, finalBlockStart#Z#0);
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, finalBlockStart#Z#0));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} !Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#Z#0));
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    ##s#3 := Seq#Drop(s#0, finalBlockStart#Z#0);
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, finalBlockStart#Z#0));
    goto anon8;

  anon13_Else:
    assume {:partition} Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#Z#0));
    goto anon8;

  anon12_Else:
    assume {:partition} !Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#Z#0));
    goto anon8;

  anon11_Else:
    assume {:partition} Base64.__default.IsUnpaddedBase64String(s#0);
    goto anon8;

  anon10_Else:
    assume {:partition} Mod(Seq#Length(s#0), LitInt(4)) != LitInt(0);
    goto anon8;

  anon8:
    assume Base64.__default.IsBase64String(s#0) <==> Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#Z#0)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#Z#0)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#Z#0)))));
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) ==> Base64.__default.IsUnpaddedBase64String#canCall(s#0) && (!Base64.__default.IsUnpaddedBase64String(s#0) ==> Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, finalBlockStart#Z#0)) && (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#Z#0)) ==> Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, finalBlockStart#Z#0)) && (!Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#Z#0)) ==> Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, finalBlockStart#Z#0)))));
    assume $Is(Base64.__default.IsBase64String(s#0), TBool);
    return;
}



function Base64.__default.DecodeValid(s#0: Seq) : Seq
uses {
axiom 7 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.DecodeValid(s#0) } Base64.__default.DecodeValid#canCall(s#0) || (7 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.IsBase64String(s#0)) ==> $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 7 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.DecodeValid(s#0) } Base64.__default.DecodeValid#canCall(s#0) || (7 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Base64.__default.IsBase64String(s#0)) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalBlockStart#0 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#0), Seq#Drop(s#0, finalBlockStart#0); Base64.__default.Is1Padding#canCall(suffix#0) && (Base64.__default.Is1Padding(suffix#0) ==> Base64.__default.DecodeUnpadded#canCall(prefix#0) && Base64.__default.Decode1Padding#canCall(suffix#0)) && (!Base64.__default.Is1Padding(suffix#0) ==> Base64.__default.Is2Padding#canCall(suffix#0) && (Base64.__default.Is2Padding(suffix#0) ==> Base64.__default.DecodeUnpadded#canCall(prefix#0) && Base64.__default.Decode2Padding#canCall(suffix#0)) && (!Base64.__default.Is2Padding(suffix#0) ==> Base64.__default.DecodeUnpadded#canCall(s#0)))))) && Base64.__default.DecodeValid(s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else (var finalBlockStart#0 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#0), Seq#Drop(s#0, finalBlockStart#0); (if Base64.__default.Is1Padding(suffix#0) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#0), Base64.__default.Decode1Padding(suffix#0)) else (if Base64.__default.Is2Padding(suffix#0) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#0), Base64.__default.Decode2Padding(suffix#0)) else Base64.__default.DecodeUnpadded(s#0)))))));
axiom 7 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.DecodeValid(Lit(s#0)) } Base64.__default.DecodeValid#canCall(Lit(s#0)) || (7 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && Lit(Base64.__default.IsBase64String(Lit(s#0)))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalBlockStart#1 := Seq#Length(Lit(s#0)) - 4; (var prefix#1, suffix#1 := Seq#Take(Lit(s#0), finalBlockStart#1), Seq#Drop(Lit(s#0), finalBlockStart#1); Base64.__default.Is1Padding#canCall(suffix#1) && (Base64.__default.Is1Padding(suffix#1) ==> Base64.__default.DecodeUnpadded#canCall(prefix#1) && Base64.__default.Decode1Padding#canCall(suffix#1)) && (!Base64.__default.Is1Padding(suffix#1) ==> Base64.__default.Is2Padding#canCall(suffix#1) && (Base64.__default.Is2Padding(suffix#1) ==> Base64.__default.DecodeUnpadded#canCall(prefix#1) && Base64.__default.Decode2Padding#canCall(suffix#1)) && (!Base64.__default.Is2Padding(suffix#1) ==> Base64.__default.DecodeUnpadded#canCall(Lit(s#0))))))) && Base64.__default.DecodeValid(Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else (var finalBlockStart#1 := Seq#Length(Lit(s#0)) - 4; (var prefix#1, suffix#1 := Seq#Take(Lit(s#0), finalBlockStart#1), Seq#Drop(Lit(s#0), finalBlockStart#1); (if Base64.__default.Is1Padding(suffix#1) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#1), Base64.__default.Decode1Padding(suffix#1)) else (if Base64.__default.Is2Padding(suffix#1) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#1), Base64.__default.Decode2Padding(suffix#1)) else Base64.__default.DecodeUnpadded(Lit(s#0))))))));
}

function Base64.__default.DecodeValid#canCall(s#0: Seq) : bool;

function Base64.__default.DecodeValid#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.DecodeValid#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.DecodeValid#requires(s#0) <==> Base64.__default.IsBase64String(s#0)));

procedure {:verboseName "Base64.DecodeValid (well-formedness)"} CheckWellformed$$Base64.__default.DecodeValid(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.DecodeValid (well-formedness)"} CheckWellformed$$Base64.__default.DecodeValid(s#0: Seq) returns (b#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var finalBlockStart#Z#0: int;
  var let#0#0#0: int;
  var prefix#Z#0: Seq;
  var suffix#Z#0: Seq;
  var let#1#0#0: Seq;
  var let#1#1#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;
  var ##s#6: Seq;
  var ##s#7: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.DecodeValid", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(352,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    assume Base64.__default.DecodeValid(s#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon10;

  anon12_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    havoc finalBlockStart#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(s#0) - 4;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume finalBlockStart#Z#0 == let#0#0#0;
    havoc prefix#Z#0;
    havoc suffix#Z#0;
    assume $Is(prefix#Z#0, TSeq(TChar)) && $IsAlloc(prefix#Z#0, TSeq(TChar), $Heap) && $Is(suffix#Z#0, TSeq(TChar)) && $IsAlloc(suffix#Z#0, TSeq(TChar), $Heap);
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    assume let#1#0#0 == Seq#Take(s#0, finalBlockStart#Z#0);
    assume true;
    assume $Is(let#1#0#0, TSeq(TChar));
    assume prefix#Z#0 == let#1#0#0;
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    assume let#1#1#0 == Seq#Drop(s#0, finalBlockStart#Z#0);
    assume true;
    assume $Is(let#1#1#0, TSeq(TChar));
    assume suffix#Z#0 == let#1#1#0;
    ##s#1 := suffix#Z#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(suffix#Z#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Base64.__default.Is1Padding(suffix#Z#0);
    ##s#2 := prefix#Z#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#2) ==> Base64.__default.IsUnpaddedBase64String(##s#2) || Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#2) ==> Base64.__default.IsUnpaddedBase64String(##s#2) || (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#2, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#2, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.IsUnpaddedBase64String(##s#2);
    assume Base64.__default.DecodeUnpadded#canCall(prefix#Z#0);
    ##s#3 := suffix#Z#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#3) ==> Base64.__default.Is1Padding(##s#3) || Seq#Length(##s#3) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#3) ==> Base64.__default.Is1Padding(##s#3) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#3, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#3, LitInt(0))): char) || $Unbox(Seq#Index(##s#3, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#3, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#3) ==> Base64.__default.Is1Padding(##s#3) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#3, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#3, LitInt(1))): char) || $Unbox(Seq#Index(##s#3, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#3, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#3) ==> Base64.__default.Is1Padding(##s#3) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#3, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#3, LitInt(2))): char) || $Unbox(Seq#Index(##s#3, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#3, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#3, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#3, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#3) ==> Base64.__default.Is1Padding(##s#3) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#3, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#3) ==> Base64.__default.Is1Padding(##s#3) || $Unbox(Seq#Index(##s#3, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is1Padding(##s#3);
    assume Base64.__default.Decode1Padding#canCall(suffix#Z#0);
    assume Base64.__default.DecodeValid(s#0) == Seq#Append(Base64.__default.DecodeUnpadded(prefix#Z#0), Base64.__default.Decode1Padding(suffix#Z#0));
    assume Base64.__default.DecodeUnpadded#canCall(prefix#Z#0) && Base64.__default.Decode1Padding#canCall(suffix#Z#0);
    assume $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon10;

  anon13_Else:
    assume {:partition} !Base64.__default.Is1Padding(suffix#Z#0);
    ##s#4 := suffix#Z#0;
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(suffix#Z#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Base64.__default.Is2Padding(suffix#Z#0);
    ##s#5 := prefix#Z#0;
    assume $IsAlloc(##s#5, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#5) ==> Base64.__default.IsUnpaddedBase64String(##s#5) || Mod(Seq#Length(##s#5), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#5) ==> Base64.__default.IsUnpaddedBase64String(##s#5) || (forall k#1: char :: { Base64.__default.IsBase64Char(k#1) } { Seq#Contains(##s#5, $Box(k#1)) } $Is(k#1, TChar) ==> Seq#Contains(##s#5, $Box(k#1)) ==> Base64.__default.IsBase64Char(k#1));
    assume Base64.__default.IsUnpaddedBase64String(##s#5);
    assume Base64.__default.DecodeUnpadded#canCall(prefix#Z#0);
    ##s#6 := suffix#Z#0;
    assume $IsAlloc(##s#6, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#6) ==> Base64.__default.Is2Padding(##s#6) || Seq#Length(##s#6) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#6) ==> Base64.__default.Is2Padding(##s#6) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#6, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#6, LitInt(0))): char) || $Unbox(Seq#Index(##s#6, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#6, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#6, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#6, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#6, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#6, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#6, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#6, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#6) ==> Base64.__default.Is2Padding(##s#6) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#6, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#6, LitInt(1))): char) || $Unbox(Seq#Index(##s#6, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#6, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#6, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#6, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#6, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#6, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#6, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#6, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#6) ==> Base64.__default.Is2Padding(##s#6) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#6, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#6) ==> Base64.__default.Is2Padding(##s#6) || $Unbox(Seq#Index(##s#6, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#6) ==> Base64.__default.Is2Padding(##s#6) || $Unbox(Seq#Index(##s#6, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is2Padding(##s#6);
    assume Base64.__default.Decode2Padding#canCall(suffix#Z#0);
    assume Base64.__default.DecodeValid(s#0) == Seq#Append(Base64.__default.DecodeUnpadded(prefix#Z#0), Base64.__default.Decode2Padding(suffix#Z#0));
    assume Base64.__default.DecodeUnpadded#canCall(prefix#Z#0) && Base64.__default.Decode2Padding#canCall(suffix#Z#0);
    assume $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon10;

  anon14_Else:
    assume {:partition} !Base64.__default.Is2Padding(suffix#Z#0);
    ##s#7 := s#0;
    assume $IsAlloc(##s#7, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#7) ==> Base64.__default.IsUnpaddedBase64String(##s#7) || Mod(Seq#Length(##s#7), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#7) ==> Base64.__default.IsUnpaddedBase64String(##s#7) || (forall k#2: char :: { Base64.__default.IsBase64Char(k#2) } { Seq#Contains(##s#7, $Box(k#2)) } $Is(k#2, TChar) ==> Seq#Contains(##s#7, $Box(k#2)) ==> Base64.__default.IsBase64Char(k#2));
    assume Base64.__default.IsUnpaddedBase64String(##s#7);
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    assume Base64.__default.DecodeValid(s#0) == Base64.__default.DecodeUnpadded(s#0);
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    assume $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon10;

  anon10:
    assume Base64.__default.DecodeValid(s#0) == b#0;
    return;
}



procedure {:verboseName "Base64.AboutDecodeValid (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64.__default.AboutDecodeValid(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.AboutDecodeValid (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64.__default.AboutDecodeValid(s#0: Seq, b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var finalBlockStart#Z#0: int;
  var let#0#0#0: int;
  var prefix#Z#0: Seq;
  var suffix#Z#0: Seq;
  var let#1#0#0: Seq;
  var let#1#1#0: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;
  var ##s#5: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.AboutDecodeValid", " | ", s#0, " | ", b#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(366,37): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1) ==> Base64.__default.IsBase64String(##s#1) || (var finalBlockStart#0 := Seq#Length(##s#1) - 4; Mod(Seq#Length(##s#1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1) ==> Base64.__default.IsBase64String(##s#1) || (var finalBlockStart#0 := Seq#Length(##s#1) - 4; Base64.__default.IsUnpaddedBase64String(##s#1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#1);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Seq#Equal(b#0, Base64.__default.DecodeValid(s#0));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(368,21): post-state"} true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume LitInt(4) <= Seq#Length(s#0);
    havoc finalBlockStart#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(s#0) - 4;
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume finalBlockStart#Z#0 == let#0#0#0;
    havoc prefix#Z#0;
    havoc suffix#Z#0;
    assume $Is(prefix#Z#0, TSeq(TChar)) && $IsAlloc(prefix#Z#0, TSeq(TChar), $Heap) && $Is(suffix#Z#0, TSeq(TChar)) && $IsAlloc(suffix#Z#0, TSeq(TChar), $Heap);
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    assume let#1#0#0 == Seq#Take(s#0, finalBlockStart#Z#0);
    assume true;
    assume $Is(let#1#0#0, TSeq(TChar));
    assume prefix#Z#0 == let#1#0#0;
    assume 0 <= finalBlockStart#Z#0 && finalBlockStart#Z#0 <= Seq#Length(s#0);
    assume let#1#1#0 == Seq#Drop(s#0, finalBlockStart#Z#0);
    assume true;
    assume $Is(let#1#1#0, TSeq(TChar));
    assume suffix#Z#0 == let#1#1#0;
    ##s#2 := suffix#Z#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(suffix#Z#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Base64.__default.Is1Padding(suffix#Z#0);
    assume LitInt(3) != 0;
    goto anon4;

  anon15_Else:
    assume {:partition} !Base64.__default.Is1Padding(suffix#Z#0);
    goto anon4;

  anon4:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Base64.__default.Is1Padding(suffix#Z#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2);
    ##s#3 := suffix#Z#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(suffix#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Base64.__default.Is2Padding(suffix#Z#0);
    assume LitInt(3) != 0;
    goto anon7;

  anon17_Else:
    assume {:partition} !Base64.__default.Is2Padding(suffix#Z#0);
    goto anon7;

  anon16_Else:
    assume {:partition} !(Base64.__default.Is1Padding(suffix#Z#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2));
    goto anon7;

  anon7:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} (Base64.__default.Is1Padding(suffix#Z#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)) && (Base64.__default.Is2Padding(suffix#Z#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1));
    ##s#4 := suffix#Z#0;
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(suffix#Z#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} !Base64.__default.Is1Padding(suffix#Z#0);
    ##s#5 := suffix#Z#0;
    assume $IsAlloc(##s#5, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(suffix#Z#0);
    goto anon10;

  anon19_Else:
    assume {:partition} Base64.__default.Is1Padding(suffix#Z#0);
    goto anon10;

  anon10:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} !Base64.__default.Is1Padding(suffix#Z#0) && !Base64.__default.Is2Padding(suffix#Z#0);
    assume LitInt(3) != 0;
    goto anon12;

  anon20_Else:
    assume {:partition} !(!Base64.__default.Is1Padding(suffix#Z#0) && !Base64.__default.Is2Padding(suffix#Z#0));
    goto anon12;

  anon18_Else:
    assume {:partition} !((Base64.__default.Is1Padding(suffix#Z#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)) && (Base64.__default.Is2Padding(suffix#Z#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)));
    goto anon12;

  anon12:
    assume (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); (Base64.__default.Is1Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)) && (Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)) && (!Base64.__default.Is1Padding(suffix#0) && !Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0))));
    return;

  anon14_Else:
    assume LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); (Base64.__default.Is1Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)) && (Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)) && (!Base64.__default.Is1Padding(suffix#0) && !Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0))));
    return;
}



procedure {:verboseName "Base64.AboutDecodeValid (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$Base64.__default.AboutDecodeValid(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id18362"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18363"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2)))));
  requires {:id "id18364"} Seq#Equal(b#0, Base64.__default.DecodeValid(s#0));



procedure {:verboseName "Base64.AboutDecodeValid (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64.__default.AboutDecodeValid(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var suffix#0 := Seq#Drop(s#0, finalBlockStart#1); Base64.__default.Is1Padding#canCall(suffix#0) && ((Base64.__default.Is1Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)) ==> Base64.__default.Is2Padding#canCall(suffix#0) && ((Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)) ==> Base64.__default.Is1Padding#canCall(suffix#0) && (!Base64.__default.Is1Padding(suffix#0) ==> Base64.__default.Is2Padding#canCall(suffix#0))))));
  free ensures {:id "id18365"} LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); Base64.__default.Is1Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)));
  free ensures {:id "id18366"} LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)));
  free ensures {:id "id18367"} LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); !Base64.__default.Is1Padding(suffix#0) && !Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.AboutDecodeValid (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64.__default.AboutDecodeValid(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap), b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 8 == $FunctionContextHeight;
  free requires {:id "id18368"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#3 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#3)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#3)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#3))))));
  requires {:id "id18369"} Seq#Equal(b#0, Base64.__default.DecodeValid(s#0));
  modifies $Heap;
  free ensures LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var suffix#0 := Seq#Drop(s#0, finalBlockStart#1); Base64.__default.Is1Padding#canCall(suffix#0) && ((Base64.__default.Is1Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)) ==> Base64.__default.Is2Padding#canCall(suffix#0) && ((Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)) ==> Base64.__default.Is1Padding#canCall(suffix#0) && (!Base64.__default.Is1Padding(suffix#0) ==> Base64.__default.Is2Padding#canCall(suffix#0))))));
  free ensures {:id "id18370"} LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); Base64.__default.Is1Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2)));
  free ensures {:id "id18371"} LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1)));
  free ensures {:id "id18372"} LitInt(4) <= Seq#Length(s#0) ==> (var finalBlockStart#1 := Seq#Length(s#0) - 4; (var prefix#0, suffix#0 := Seq#Take(s#0, finalBlockStart#1), Seq#Drop(s#0, finalBlockStart#1); !Base64.__default.Is1Padding(suffix#0) && !Base64.__default.Is2Padding(suffix#0) ==> Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.AboutDecodeValid (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64.__default.AboutDecodeValid(s#0: Seq, b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var finalBlockStart#0_0: int;
  var prefix#0_0: Seq where $Is(prefix#0_0, TSeq(TChar)) && $IsAlloc(prefix#0_0, TSeq(TChar), $Heap);
  var suffix#0_0: Seq where $Is(suffix#0_0, TSeq(TChar)) && $IsAlloc(suffix#0_0, TSeq(TChar), $Heap);
  var $rhs#0_0: Seq;
  var $rhs#0_1: Seq;
  var ##s#0_1_0: Seq;
  var ##s#0_1_0_0: Seq;
  var x#0_1_0_0: Seq where $Is(x#0_1_0_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0_1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var y#0_1_0_0: Seq where $Is(y#0_1_0_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0_1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var $rhs#0_1_0_0: Seq;
  var ##s#0_1_0_1: Seq;
  var $rhs#0_1_0_1: Seq;
  var ##s#0_1_0_2: Seq;
  var x##0_1_0_0: int;
  var k##0_1_0_0: int;
  var n##0_1_0_0: int;
  var ##s#0_1_1_0: Seq;
  var x#0_1_1_0_0: Seq where $Is(x#0_1_1_0_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(x#0_1_1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var y#0_1_1_0_0: Seq where $Is(y#0_1_1_0_0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(y#0_1_1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
  var $rhs#0_1_1_0_0: Seq;
  var ##s#0_1_1_0_0: Seq;
  var $rhs#0_1_1_0_1: Seq;
  var ##s#0_1_1_0_1: Seq;
  var x##0_1_1_0_0: int;
  var k##0_1_1_0_0: int;
  var n##0_1_1_0_0: int;
  var ##s#0_1_1_1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.AboutDecodeValid", " | ", s#0, " | ", b#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(373,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(4) <= Seq#Length(s#0);
    assume true;
    assume true;
    finalBlockStart#0_0 := Seq#Length(s#0) - 4;
    assume {:captureState "StandardLibrary/src/Base64.dfy(375,36)"} true;
    assume true;
    assume true;
    assume 0 <= finalBlockStart#0_0 && finalBlockStart#0_0 <= Seq#Length(s#0);
    assume true;
    $rhs#0_0 := Seq#Take(s#0, finalBlockStart#0_0);
    assume 0 <= finalBlockStart#0_0 && finalBlockStart#0_0 <= Seq#Length(s#0);
    assume true;
    $rhs#0_1 := Seq#Drop(s#0, finalBlockStart#0_0);
    prefix#0_0 := $rhs#0_0;
    suffix#0_0 := $rhs#0_1;
    assume {:captureState "StandardLibrary/src/Base64.dfy(376,70)"} true;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    return;

  anon14_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    ##s#0_1_0 := suffix#0_0;
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(suffix#0_0);
    assume Base64.__default.Is1Padding#canCall(suffix#0_0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Base64.__default.Is1Padding(suffix#0_0);
    ##s#0_1_0_0 := suffix#0_0;
    assume $IsAlloc(##s#0_1_0_0, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(suffix#0_0);
    assume Base64.__default.Is2Padding#canCall(suffix#0_0);
    assume !Base64.__default.Is2Padding(suffix#0_0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(380,34)"} true;
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(prefix#0_0), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(381,32)"} true;
    assume true;
    assume true;
    ##s#0_1_0_1 := prefix#0_0;
    assume $IsAlloc(##s#0_1_0_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_0_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_0_1) || Mod(Seq#Length(##s#0_1_0_1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_0_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_0_1) || (forall k#0_1_0_0: char :: { Base64.__default.IsBase64Char(k#0_1_0_0) } { Seq#Contains(##s#0_1_0_1, $Box(k#0_1_0_0)) } $Is(k#0_1_0_0, TChar) ==> Seq#Contains(##s#0_1_0_1, $Box(k#0_1_0_0)) ==> Base64.__default.IsBase64Char(k#0_1_0_0));
    assume Base64.__default.IsUnpaddedBase64String(##s#0_1_0_1);
    assume Base64.__default.DecodeUnpadded#canCall(prefix#0_0);
    assume Base64.__default.DecodeUnpadded#canCall(prefix#0_0);
    $rhs#0_1_0_0 := Base64.__default.DecodeUnpadded(prefix#0_0);
    ##s#0_1_0_2 := suffix#0_0;
    assume $IsAlloc(##s#0_1_0_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0_2) ==> Base64.__default.Is1Padding(##s#0_1_0_2) || Seq#Length(##s#0_1_0_2) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0_2) ==> Base64.__default.Is1Padding(##s#0_1_0_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0_2) ==> Base64.__default.Is1Padding(##s#0_1_0_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0_2) ==> Base64.__default.Is1Padding(##s#0_1_0_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0_2) ==> Base64.__default.Is1Padding(##s#0_1_0_2) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0_1_0_2, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0_2) ==> Base64.__default.Is1Padding(##s#0_1_0_2) || $Unbox(Seq#Index(##s#0_1_0_2, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is1Padding(##s#0_1_0_2);
    assume Base64.__default.Decode1Padding#canCall(suffix#0_0);
    assume Base64.__default.Decode1Padding#canCall(suffix#0_0);
    $rhs#0_1_0_1 := Base64.__default.Decode1Padding(suffix#0_0);
    x#0_1_0_0 := $rhs#0_1_0_0;
    y#0_1_0_0 := $rhs#0_1_0_1;
    assume {:captureState "StandardLibrary/src/Base64.dfy(382,66)"} true;
    assume true;
    assume Seq#Equal(b#0, Seq#Append(x#0_1_0_0, y#0_1_0_0));
    assume {:captureState "StandardLibrary/src/Base64.dfy(383,25)"} true;
    assume {:subsumption 0} LitInt(3) != 0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(x#0_1_0_0) == Mul(Div(Seq#Length(x#0_1_0_0), LitInt(3)), LitInt(3));
    goto anon6;

  anon16_Else:
    assume {:partition} Seq#Length(x#0_1_0_0) != Mul(Div(Seq#Length(x#0_1_0_0), LitInt(3)), LitInt(3));
    goto anon6;

  anon6:
    assume true;
    assume {:subsumption 0} Seq#Length(x#0_1_0_0) == Mul(Div(Seq#Length(x#0_1_0_0), LitInt(3)), LitInt(3));
    assume {:subsumption 0} Seq#Length(y#0_1_0_0) == LitInt(2);
    assume Seq#Length(x#0_1_0_0) == Mul(Div(Seq#Length(x#0_1_0_0), LitInt(3)), LitInt(3)) && Seq#Length(y#0_1_0_0) == LitInt(2);
    assume {:captureState "StandardLibrary/src/Base64.dfy(384,45)"} true;
    assume LitInt(3) != 0;
    assume true;
    assume $Is(Div(Seq#Length(x#0_1_0_0), LitInt(3)), Tclass._System.nat());
    x##0_1_0_0 := Div(Seq#Length(x#0_1_0_0), LitInt(3));
    assume true;
    assume $Is(Seq#Length(y#0_1_0_0), Tclass._System.nat());
    k##0_1_0_0 := Seq#Length(y#0_1_0_0);
    assume true;
    assume $Is(Seq#Length(b#0), Tclass._System.nat());
    n##0_1_0_0 := Seq#Length(b#0);
    call CallPre$$Base64.__default.Mod3(x##0_1_0_0, k##0_1_0_0, n##0_1_0_0);
    call CallPost$$Base64.__default.Mod3(x##0_1_0_0, k##0_1_0_0, n##0_1_0_0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(385,31)"} true;
    return;

  anon15_Else:
    assume {:partition} !Base64.__default.Is1Padding(suffix#0_0);
    ##s#0_1_1_0 := suffix#0_0;
    assume $IsAlloc(##s#0_1_1_0, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(suffix#0_0);
    assume Base64.__default.Is2Padding#canCall(suffix#0_0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Base64.__default.Is2Padding(suffix#0_0);
    assume true;
    assume true;
    ##s#0_1_1_0_0 := prefix#0_0;
    assume $IsAlloc(##s#0_1_1_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_1_0_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_1_0_0) || Mod(Seq#Length(##s#0_1_1_0_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_1_0_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_1_0_0) || (forall k#0_1_1_0_0: char :: { Base64.__default.IsBase64Char(k#0_1_1_0_0) } { Seq#Contains(##s#0_1_1_0_0, $Box(k#0_1_1_0_0)) } $Is(k#0_1_1_0_0, TChar) ==> Seq#Contains(##s#0_1_1_0_0, $Box(k#0_1_1_0_0)) ==> Base64.__default.IsBase64Char(k#0_1_1_0_0));
    assume Base64.__default.IsUnpaddedBase64String(##s#0_1_1_0_0);
    assume Base64.__default.DecodeUnpadded#canCall(prefix#0_0);
    assume Base64.__default.DecodeUnpadded#canCall(prefix#0_0);
    $rhs#0_1_1_0_0 := Base64.__default.DecodeUnpadded(prefix#0_0);
    ##s#0_1_1_0_1 := suffix#0_0;
    assume $IsAlloc(##s#0_1_1_0_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_1_0_1) ==> Base64.__default.Is2Padding(##s#0_1_1_0_1) || Seq#Length(##s#0_1_1_0_1) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_1_0_1) ==> Base64.__default.Is2Padding(##s#0_1_1_0_1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) || $Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_1_0_1) ==> Base64.__default.Is2Padding(##s#0_1_1_0_1) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) || $Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_1_0_1) ==> Base64.__default.Is2Padding(##s#0_1_1_0_1) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_1_0_1) ==> Base64.__default.Is2Padding(##s#0_1_1_0_1) || $Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_1_0_1) ==> Base64.__default.Is2Padding(##s#0_1_1_0_1) || $Unbox(Seq#Index(##s#0_1_1_0_1, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is2Padding(##s#0_1_1_0_1);
    assume Base64.__default.Decode2Padding#canCall(suffix#0_0);
    assume Base64.__default.Decode2Padding#canCall(suffix#0_0);
    $rhs#0_1_1_0_1 := Base64.__default.Decode2Padding(suffix#0_0);
    x#0_1_1_0_0 := $rhs#0_1_1_0_0;
    y#0_1_1_0_0 := $rhs#0_1_1_0_1;
    assume {:captureState "StandardLibrary/src/Base64.dfy(387,66)"} true;
    assume true;
    assume Seq#Equal(b#0, Seq#Append(x#0_1_1_0_0, y#0_1_1_0_0));
    assume {:captureState "StandardLibrary/src/Base64.dfy(388,25)"} true;
    assume {:subsumption 0} LitInt(3) != 0;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Seq#Length(x#0_1_1_0_0) == Mul(Div(Seq#Length(x#0_1_1_0_0), LitInt(3)), LitInt(3));
    goto anon10;

  anon18_Else:
    assume {:partition} Seq#Length(x#0_1_1_0_0) != Mul(Div(Seq#Length(x#0_1_1_0_0), LitInt(3)), LitInt(3));
    goto anon10;

  anon10:
    assume true;
    assume {:subsumption 0} Seq#Length(x#0_1_1_0_0) == Mul(Div(Seq#Length(x#0_1_1_0_0), LitInt(3)), LitInt(3));
    assume {:subsumption 0} Seq#Length(y#0_1_1_0_0) == LitInt(1);
    assume Seq#Length(x#0_1_1_0_0) == Mul(Div(Seq#Length(x#0_1_1_0_0), LitInt(3)), LitInt(3)) && Seq#Length(y#0_1_1_0_0) == LitInt(1);
    assume {:captureState "StandardLibrary/src/Base64.dfy(389,45)"} true;
    assume LitInt(3) != 0;
    assume true;
    assume $Is(Div(Seq#Length(x#0_1_1_0_0), LitInt(3)), Tclass._System.nat());
    x##0_1_1_0_0 := Div(Seq#Length(x#0_1_1_0_0), LitInt(3));
    assume true;
    assume $Is(Seq#Length(y#0_1_1_0_0), Tclass._System.nat());
    k##0_1_1_0_0 := Seq#Length(y#0_1_1_0_0);
    assume true;
    assume $Is(Seq#Length(b#0), Tclass._System.nat());
    n##0_1_1_0_0 := Seq#Length(b#0);
    call CallPre$$Base64.__default.Mod3(x##0_1_1_0_0, k##0_1_1_0_0, n##0_1_1_0_0);
    call CallPost$$Base64.__default.Mod3(x##0_1_1_0_0, k##0_1_1_0_0, n##0_1_1_0_0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(390,31)"} true;
    return;

  anon17_Else:
    assume {:partition} !Base64.__default.Is2Padding(suffix#0_0);
    ##s#0_1_1_1_0 := s#0;
    assume $IsAlloc(##s#0_1_1_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_1_1_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_1_1_0) || Mod(Seq#Length(##s#0_1_1_1_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_1_1_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_1_1_0) || (forall k#0_1_1_1_0: char :: { Base64.__default.IsBase64Char(k#0_1_1_1_0) } { Seq#Contains(##s#0_1_1_1_0, $Box(k#0_1_1_1_0)) } $Is(k#0_1_1_1_0, TChar) ==> Seq#Contains(##s#0_1_1_1_0, $Box(k#0_1_1_1_0)) ==> Base64.__default.IsBase64Char(k#0_1_1_1_0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    assume Seq#Equal(b#0, Base64.__default.DecodeUnpadded(s#0));
    assume {:captureState "StandardLibrary/src/Base64.dfy(392,37)"} true;
    return;

  anon13_Else:
    assume {:partition} Seq#Length(s#0) < LitInt(4);
    return;
}



procedure {:verboseName "Base64.Mod3 (well-formedness)"} CheckWellFormed$$Base64.__default.Mod3(x#0: int where LitInt(0) <= x#0, k#0: int where LitInt(0) <= k#0, n#0: int where LitInt(0) <= n#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Mod3 (well-formedness)"} CheckWellFormed$$Base64.__default.Mod3(x#0: int, k#0: int, n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.Mod3", " | ", x#0, " | ", k#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(397,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= k#0;
    goto anon3;

  anon4_Else:
    assume {:partition} k#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= k#0 && k#0 < 3;
    assume n#0 == Mul(LitInt(3), x#0) + k#0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(399,18): post-state"} true;
    assume LitInt(3) != 0;
    assume Mod(n#0, LitInt(3)) == k#0;
    return;
}



procedure {:verboseName "Base64.Mod3 (call precondtion)"} CallPre$$Base64.__default.Mod3(x#0: int where LitInt(0) <= x#0, k#0: int where LitInt(0) <= k#0, n#0: int where LitInt(0) <= n#0);
  requires {:id "id18436"} LitInt(0) <= k#0;
  requires {:id "id18437"} k#0 < 3;
  requires {:id "id18438"} n#0 == Mul(LitInt(3), x#0) + k#0;



procedure {:verboseName "Base64.Mod3 (call postcondition)"} CallPost$$Base64.__default.Mod3(x#0: int where LitInt(0) <= x#0, k#0: int where LitInt(0) <= k#0, n#0: int where LitInt(0) <= n#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id18439"} Mod(n#0, LitInt(3)) == k#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.Mod3 (correctness)"} Impl$$Base64.__default.Mod3(x#0: int where LitInt(0) <= x#0, k#0: int where LitInt(0) <= k#0, n#0: int where LitInt(0) <= n#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id18440"} LitInt(0) <= k#0;
  requires {:id "id18441"} k#0 < 3;
  requires {:id "id18442"} n#0 == Mul(LitInt(3), x#0) + k#0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id18443"} Mod(n#0, LitInt(3)) == k#0;
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Mod3 (correctness)"} Impl$$Base64.__default.Mod3(x#0: int, k#0: int, n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.Mod3", " | ", x#0, " | ", k#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(400,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.Decode(s#0: Seq) : DatatypeType
uses {
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Decode(s#0) } Base64.__default.Decode#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Success_q(Base64.__default.Decode(s#0))) && (!Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Failure_q(Base64.__default.Decode(s#0))) && $Is(Base64.__default.Decode(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.Decode(s#0) } Base64.__default.Decode#canCall(s#0) || (8 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> Base64.__default.IsBase64String#canCall(s#0) && (Base64.__default.IsBase64String(s#0) ==> Base64.__default.DecodeValid#canCall(s#0)) && Base64.__default.Decode(s#0) == (if Base64.__default.IsBase64String(s#0) then #Wrappers.Result.Success($Box(Base64.__default.DecodeValid(s#0))) else #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(84))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(100))))))));
axiom 8 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.Decode(Lit(s#0)) } Base64.__default.Decode#canCall(Lit(s#0)) || (8 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> Base64.__default.IsBase64String#canCall(Lit(s#0)) && (Lit(Base64.__default.IsBase64String(Lit(s#0))) ==> Base64.__default.DecodeValid#canCall(Lit(s#0))) && Base64.__default.Decode(Lit(s#0)) == (if Base64.__default.IsBase64String(Lit(s#0)) then #Wrappers.Result.Success($Box(Lit(Base64.__default.DecodeValid(Lit(s#0))))) else #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(84))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(100))))))));
}

function Base64.__default.Decode#canCall(s#0: Seq) : bool;

function Base64.__default.Decode#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.Decode#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.Decode#requires(s#0) <==> true));

procedure {:verboseName "Base64.Decode (well-formedness)"} CheckWellformed$$Base64.__default.Decode(s#0: Seq where $Is(s#0, TSeq(TChar))) returns (b#0: DatatypeType where $Is(b#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18444"} Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Success_q(b#0);
  free ensures {:id "id18445"} !Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Failure_q(b#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Decode (well-formedness)"} CheckWellformed$$Base64.__default.Decode(s#0: Seq) returns (b#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.Decode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(403,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(Base64.__default.Decode(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Wrappers.Result.Success_q(b#0);
    goto anon5;

  anon14_Else:
    assume Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Success_q(b#0);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume !Base64.__default.IsBase64String(s#0);
    assume Wrappers.Result.Failure_q(b#0);
    goto anon8;

  anon15_Else:
    assume !Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Failure_q(b#0);
    goto anon8;

  anon8:
    assume false;
    return;

  anon13_Else:
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Base64.__default.IsBase64String(s#0);
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#0 := Seq#Length(##s#3) - 4; Mod(Seq#Length(##s#3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#0 := Seq#Length(##s#3) - 4; Base64.__default.IsUnpaddedBase64String(##s#3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#3, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#3, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#3, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#3);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Base64.__default.Decode(s#0) == #Wrappers.Result.Success($Box(Base64.__default.DecodeValid(s#0)));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume $Is(Base64.__default.Decode(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)));
    goto anon12;

  anon16_Else:
    assume {:partition} !Base64.__default.IsBase64String(s#0);
    assume Base64.__default.Decode(s#0) == Lit(#Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(84))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(100)))))));
    assume true;
    assume $Is(Base64.__default.Decode(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar)));
    goto anon12;

  anon12:
    assume Base64.__default.Decode(s#0) == b#0;
    return;
}



function Base64.__default.StringIs7Bit(s#0: Seq) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { Base64.__default.StringIs7Bit(s#0) } Base64.__default.StringIs7Bit#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Base64.__default.StringIs7Bit(s#0) <==> (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < char#ToInt(char#FromInt(LitInt(128))))));
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: {:weight 3} { Base64.__default.StringIs7Bit(Lit(s#0)) } Base64.__default.StringIs7Bit#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar))) ==> (Base64.__default.StringIs7Bit(Lit(s#0)) <==> (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#1)): char) < char#ToInt(char#FromInt(LitInt(128))))));
}

function Base64.__default.StringIs7Bit#canCall(s#0: Seq) : bool;

function Base64.__default.StringIs7Bit#requires(Seq) : bool;

axiom (forall s#0: Seq :: { Base64.__default.StringIs7Bit#requires(s#0) } $Is(s#0, TSeq(TChar)) ==> (Base64.__default.StringIs7Bit#requires(s#0) <==> true));

procedure {:verboseName "Base64.StringIs7Bit (well-formedness)"} CheckWellformed$$Base64.__default.StringIs7Bit(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.StringIs7Bit (well-formedness)"} CheckWellformed$$Base64.__default.StringIs7Bit(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var i#2: int;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "Base64.StringIs7Bit", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(410,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    havoc i#2;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= i#2;
    goto anon6;

  anon11_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon6;

  anon6:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#2 && i#2 < Seq#Length(s#0);
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    newtype$check#0 := LitInt(128);
    assume char#IsChar(newtype$check#0);
    goto anon8;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= i#2 && i#2 < Seq#Length(s#0));
    goto anon8;

  anon10_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume Base64.__default.StringIs7Bit(s#0) <==> (forall i#3: int :: { $Unbox(Seq#Index(s#0, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#3)): char) < char#ToInt(char#FromInt(LitInt(128))));
    assume true;
    assume $Is(Base64.__default.StringIs7Bit(s#0), TBool);
    return;
}



procedure {:verboseName "Base64.ConcatMod4Sequences (well-formedness)"} CheckWellFormed$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq where $Is(s#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(s#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap), t#0: Seq where $Is(t#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(t#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.ConcatMod4Sequences (well-formedness)"} CheckWellFormed$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq, t#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.ConcatMod4Sequences", " | ", Base64._default.ConcatMod4Sequences$T, " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(414,8): initial state"} true;
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(t#0), LitInt(4)) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(417,24): post-state"} true;
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(Seq#Append(s#0, t#0)), LitInt(4)) == LitInt(0);
    return;
}



procedure {:verboseName "Base64.ConcatMod4Sequences (call precondtion)"} CallPre$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq where $Is(s#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(s#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap), t#0: Seq where $Is(t#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(t#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap));
  requires {:id "id18466"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  requires {:id "id18467"} Mod(Seq#Length(t#0), LitInt(4)) == LitInt(0);



procedure {:verboseName "Base64.ConcatMod4Sequences (call postcondition)"} CallPost$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq where $Is(s#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(s#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap), t#0: Seq where $Is(t#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(t#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id18468"} Mod(Seq#Length(Seq#Append(s#0, t#0)), LitInt(4)) == LitInt(0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.ConcatMod4Sequences (correctness)"} Impl$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq where $Is(s#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(s#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap), t#0: Seq where $Is(t#0, TSeq(Base64._default.ConcatMod4Sequences$T)) && $IsAlloc(t#0, TSeq(Base64._default.ConcatMod4Sequences$T), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id18469"} Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
  requires {:id "id18470"} Mod(Seq#Length(t#0), LitInt(4)) == LitInt(0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id18471"} Mod(Seq#Length(Seq#Append(s#0, t#0)), LitInt(4)) == LitInt(0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.ConcatMod4Sequences (correctness)"} Impl$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq, t#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.ConcatMod4Sequences", " | ", Base64._default.ConcatMod4Sequences$T, " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(418,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function Base64.__default.Encode(b#0: Seq) : Seq
uses {
axiom 8 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.Encode(b#0) } Base64.__default.Encode#canCall(b#0) || (8 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Base64.__default.StringIs7Bit(Base64.__default.Encode(b#0)) && Mod(Seq#Length(Base64.__default.Encode(b#0)), LitInt(4)) == LitInt(0) && Base64.__default.IsBase64String(Base64.__default.Encode(b#0)) && $Is(Base64.__default.Encode(b#0), TSeq(TChar)));
axiom 8 <= $FunctionContextHeight ==> (forall b#0: Seq :: { Base64.__default.Encode(b#0) } Base64.__default.Encode#canCall(b#0) || (8 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Base64.__default.EncodeUnpadded#canCall(b#0)) && (Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0) ==> (Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1))) && (Mod(Seq#Length(b#0), LitInt(3)) != LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2)))) && Base64.__default.Encode(b#0) == (if Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) then (var s#0 := Base64.__default.EncodeUnpadded(b#0); s#0) else (if Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1) then (var s1#0, s2#0 := Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1)), Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1)); (var s#1 := Seq#Append(s1#0, s2#0); s#1)) else (var s1#1, s2#1 := Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2)), Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2)); (var s#2 := Seq#Append(s1#1, s2#1); s#2)))));
axiom 8 <= $FunctionContextHeight ==> (forall b#0: Seq :: {:weight 3} { Base64.__default.Encode(Lit(b#0)) } Base64.__default.Encode#canCall(Lit(b#0)) || (8 < $FunctionContextHeight && $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0) ==> Base64.__default.EncodeUnpadded#canCall(Lit(b#0))) && (Mod(Seq#Length(Lit(b#0)), LitInt(3)) != LitInt(0) ==> (Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 1))) && (Mod(Seq#Length(Lit(b#0)), LitInt(3)) != LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 2)))) && Base64.__default.Encode(Lit(b#0)) == (if Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0) then (var s#3 := Lit(Base64.__default.EncodeUnpadded(Lit(b#0))); s#3) else (if Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(1) then (var s1#2, s2#2 := Base64.__default.EncodeUnpadded(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 1)), Base64.__default.Encode2Padding(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 1)); (var s#4 := Seq#Append(s1#2, s2#2); s#4)) else (var s1#3, s2#3 := Base64.__default.EncodeUnpadded(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 2)), Base64.__default.Encode1Padding(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 2)); (var s#5 := Seq#Append(s1#3, s2#3); s#5)))));
}

function Base64.__default.Encode#canCall(b#0: Seq) : bool;

function Base64.__default.Encode#requires(Seq) : bool;

axiom (forall b#0: Seq :: { Base64.__default.Encode#requires(b#0) } $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Base64.__default.Encode#requires(b#0) <==> true));

procedure {:verboseName "Base64.Encode (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$Base64.__default.Encode(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8()))) returns (s#6: Seq where $Is(s#6, TSeq(TChar)));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id18472"} Base64.__default.StringIs7Bit#canCall(s#6) ==> Base64.__default.StringIs7Bit(s#6) || (forall i#0: int :: { $Unbox(Seq#Index(s#6, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#6) ==> char#ToInt($Unbox(Seq#Index(s#6, i#0)): char) < char#ToInt(char#FromInt(LitInt(128))));
  free ensures {:id "id18473"} Mod(Seq#Length(s#6), LitInt(4)) == LitInt(0);
  free ensures {:id "id18474"} Base64.__default.IsBase64String#canCall(s#6) ==> Base64.__default.IsBase64String(s#6) || (var finalBlockStart#0 := Seq#Length(s#6) - 4; Mod(Seq#Length(s#6), LitInt(4)) == LitInt(0));
  free ensures {:id "id18475"} Base64.__default.IsBase64String#canCall(s#6) ==> Base64.__default.IsBase64String(s#6) || (var finalBlockStart#0 := Seq#Length(s#6) - 4; Base64.__default.IsUnpaddedBase64String(s#6) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#6, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(s#6, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(s#6, finalBlockStart#0)))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.Encode (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$Base64.__default.Encode(b#0: Seq) returns (s#6: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var s#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##b#0: Seq;
  var s1#Z#0: Seq;
  var s2#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##b#1: Seq;
  var let#1#1#0: Seq;
  var ##b#2: Seq;
  var s##0: Seq;
  var t##0: Seq;
  var s#Z#1: Seq;
  var let#2#0#0: Seq;
  var s1#Z#1: Seq;
  var s2#Z#1: Seq;
  var let#3#0#0: Seq;
  var ##b#3: Seq;
  var let#3#1#0: Seq;
  var ##b#4: Seq;
  var s##1: Seq;
  var t##1: Seq;
  var s#Z#2: Seq;
  var let#4#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.Encode", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(421,47): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(Base64.__default.Encode(b#0), TSeq(TChar));
    ##s#0 := s#6;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.StringIs7Bit#canCall(s#6);
    assume Base64.__default.StringIs7Bit(s#6);
    assume LitInt(4) != 0;
    assume Mod(Seq#Length(s#6), LitInt(4)) == LitInt(0);
    ##s#1 := s#6;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#6);
    assume Base64.__default.IsBase64String(s#6);
    assume false;
    return;

  anon9_Else:
    assume LitInt(3) != 0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(b#0);
    assume let#0#0#0 == Base64.__default.EncodeUnpadded(b#0);
    assume Base64.__default.EncodeUnpadded#canCall(b#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume s#Z#0 == let#0#0#0;
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(s#Z#0), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(429,25)"} true;
    assume Base64.__default.Encode(b#0) == s#Z#0;
    assume true;
    assume $Is(Base64.__default.Encode(b#0), TSeq(TChar));
    goto anon8;

  anon10_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0);
    assume LitInt(3) != 0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1);
    assume true;
    assume Seq#Length(b#0) >= LitInt(1);
    assume {:captureState "StandardLibrary/src/Base64.dfy(432,21)"} true;
    havoc s1#Z#0;
    havoc s2#Z#0;
    assume $Is(s1#Z#0, TSeq(TChar)) && $IsAlloc(s1#Z#0, TSeq(TChar), $Heap) && $Is(s2#Z#0, TSeq(TChar)) && $IsAlloc(s2#Z#0, TSeq(TChar), $Heap);
    assume 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume let#1#0#0 == Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume $Is(let#1#0#0, TSeq(TChar));
    assume s1#Z#0 == let#1#0#0;
    assume 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#2 := Seq#Drop(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#2) == LitInt(1);
    assume Seq#Length(##b#2) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume let#1#1#0 == Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume $Is(let#1#1#0, TSeq(TChar));
    assume s2#Z#0 == let#1#1#0;
    assume true;
    s##0 := s1#Z#0;
    assume true;
    t##0 := s2#Z#0;
    call CallPre$$Base64.__default.ConcatMod4Sequences(TChar, s##0, t##0);
    call CallPost$$Base64.__default.ConcatMod4Sequences(TChar, s##0, t##0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(434,32)"} true;
    havoc s#Z#1;
    assume $Is(s#Z#1, TSeq(TChar)) && $IsAlloc(s#Z#1, TSeq(TChar), $Heap);
    assume let#2#0#0 == Seq#Append(s1#Z#0, s2#Z#0);
    assume true;
    assume $Is(let#2#0#0, TSeq(TChar));
    assume s#Z#1 == let#2#0#0;
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(s#Z#1), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(436,25)"} true;
    assume Base64.__default.Encode(b#0) == s#Z#1;
    assume true;
    assume $Is(Base64.__default.Encode(b#0), TSeq(TChar));
    goto anon8;

  anon11_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(1);
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2);
    assume {:captureState "StandardLibrary/src/Base64.dfy(439,25)"} true;
    assume true;
    assume Seq#Length(b#0) >= LitInt(2);
    assume {:captureState "StandardLibrary/src/Base64.dfy(440,21)"} true;
    havoc s1#Z#1;
    havoc s2#Z#1;
    assume $Is(s1#Z#1, TSeq(TChar)) && $IsAlloc(s1#Z#1, TSeq(TChar), $Heap) && $Is(s2#Z#1, TSeq(TChar)) && $IsAlloc(s2#Z#1, TSeq(TChar), $Heap);
    assume 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#3 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#3), LitInt(3)) == LitInt(0);
    assume Mod(Seq#Length(##b#3), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume let#3#0#0 == Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume $Is(let#3#0#0, TSeq(TChar));
    assume s1#Z#1 == let#3#0#0;
    assume 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#4 := Seq#Drop(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#4, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#4) == LitInt(2);
    assume Seq#Length(##b#4) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume let#3#1#0 == Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume $Is(let#3#1#0, TSeq(TChar));
    assume s2#Z#1 == let#3#1#0;
    assume true;
    s##1 := s1#Z#1;
    assume true;
    t##1 := s2#Z#1;
    call CallPre$$Base64.__default.ConcatMod4Sequences(TChar, s##1, t##1);
    call CallPost$$Base64.__default.ConcatMod4Sequences(TChar, s##1, t##1);
    assume {:captureState "StandardLibrary/src/Base64.dfy(442,32)"} true;
    havoc s#Z#2;
    assume $Is(s#Z#2, TSeq(TChar)) && $IsAlloc(s#Z#2, TSeq(TChar), $Heap);
    assume let#4#0#0 == Seq#Append(s1#Z#1, s2#Z#1);
    assume true;
    assume $Is(let#4#0#0, TSeq(TChar));
    assume s#Z#2 == let#4#0#0;
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(s#Z#2), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(444,25)"} true;
    assume Base64.__default.Encode(b#0) == s#Z#2;
    assume true;
    assume $Is(Base64.__default.Encode(b#0), TSeq(TChar));
    goto anon8;

  anon8:
    assume Base64.__default.Encode(b#0) == s#6;
    return;
}



procedure {:verboseName "Base64.EncodeLengthExact (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeLengthExact(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeLengthExact (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeLengthExact(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeLengthExact", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(448,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(449,12): post-state"} true;
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    assume let#0#0#0 == Base64.__default.Encode(b#0);
    assume Base64.__default.Encode#canCall(b#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume s#Z#0 == let#0#0#0;
    assume LitInt(3) != 0;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    assume LitInt(3) != 0;
    goto anon3;

  anon7_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0);
    goto anon3;

  anon3:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#Z#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
    assume LitInt(3) != 0;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != 0;
    assume LitInt(3) != 0;
    goto anon6;

  anon9_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == 0;
    goto anon6;

  anon8_Else:
    assume {:partition} !(Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#Z#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)));
    goto anon6;

  anon6:
    assume (var s#0 := Base64.__default.Encode(b#0); (Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4))) && (Mod(Seq#Length(b#0), LitInt(3)) != 0 ==> Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4));
    return;
}



procedure {:verboseName "Base64.EncodeLengthExact (call precondtion)"} CallPre$$Base64.__default.EncodeLengthExact(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "Base64.EncodeLengthExact (call postcondition)"} CallPost$$Base64.__default.EncodeLengthExact(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0);
  free ensures {:id "id18530"} (var s#0 := Base64.__default.Encode(b#0); Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)));
  free ensures {:id "id18531"} (var s#0 := Base64.__default.Encode(b#0); Mod(Seq#Length(b#0), LitInt(3)) != 0 ==> Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeLengthExact (correctness)"} Impl$$Base64.__default.EncodeLengthExact(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0);
  free ensures {:id "id18532"} (var s#0 := Base64.__default.Encode(b#0); Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)));
  free ensures {:id "id18533"} (var s#0 := Base64.__default.Encode(b#0); Mod(Seq#Length(b#0), LitInt(3)) != 0 ==> Seq#Length(s#0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeLengthExact (correctness)"} Impl$$Base64.__default.EncodeLengthExact(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s#1: Seq where $Is(s#1, TSeq(TChar)) && $IsAlloc(s#1, TSeq(TChar), $Heap);
  var ##b#1: Seq;
  var ##b#0_0: Seq;
  var ##b#1_0_0: Seq;
  var ##b#1_0_1: Seq;
  var ##b#1_0_0_2_0: Seq;
  var ##b#1_0_0_2_1: Seq;
  var ##b#1_0_0_3_0: Seq;
  var ##b#1_0_0_3_1: Seq;
  var ##b#1_0_0_3_2: Seq;
  var ##b#1_0_0_3_3: Seq;
  var ##b#1_0_0_4_0: Seq;
  var ##b#1_0_0_4_1: Seq;
  var ##b#1_1_0: Seq;
  var ##b#1_1_1: Seq;
  var ##b#1_1_0_2_0: Seq;
  var ##b#1_1_0_2_1: Seq;
  var ##b#1_1_0_3_0: Seq;
  var ##b#1_1_0_3_1: Seq;
  var ##b#1_1_0_3_2: Seq;
  var ##b#1_1_0_3_3: Seq;
  var ##b#1_1_0_4_0: Seq;
  var ##b#1_1_0_4_1: Seq;
  var s#Z#1_1_0: Seq;
  var let#1_1_0#0#0: Seq;
  var ##b#1_1_2: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeLengthExact", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(452,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##b#1 := b#0;
    assume $IsAlloc(##b#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    assume Base64.__default.Encode#canCall(b#0);
    s#1 := Base64.__default.Encode(b#0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(453,22)"} true;
    assume LitInt(3) != 0;
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(b#0);
    assume Base64.__default.EncodeUnpadded#canCall(b#0);
    assume Seq#Equal(s#1, Base64.__default.EncodeUnpadded(b#0));
    assume {:captureState "StandardLibrary/src/Base64.dfy(455,35)"} true;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume Seq#Length(s#1) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
    assume {:captureState "StandardLibrary/src/Base64.dfy(456,31)"} true;
    return;

  anon24_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0);
    assume LitInt(3) != 0;
    assume true;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1);
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_0_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_1 := Seq#Drop(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_0_1) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Seq#Equal(s#1, Seq#Append(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1)), Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1))));
    assume {:captureState "StandardLibrary/src/Base64.dfy(458,81)"} true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume true;
    assume false;
    goto anon10;

  anon26_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume true;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_4_0 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_0_0_4_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_4_1 := Seq#Drop(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_0_0_4_1) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} Seq#Length(s#1) == Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1))) + Seq#Length(Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1)));
    assume false;
    goto anon10;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_3_0 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_0_0_3_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_3_1 := Seq#Drop(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_0_0_3_1) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_3_2 := Seq#Drop(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_3_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_0_0_3_2) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1));
    assume Seq#Length(Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1))) == LitInt(4);
    assume {:captureState "StandardLibrary/src/Base64.dfy(463,56)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_3_3 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_3_3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_0_0_3_3), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1))) + Seq#Length(Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1))) == Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1))) + 4;
    assume false;
    goto anon10;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_2_0 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_0_0_2_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    ##b#1_0_0_2_1 := Seq#Take(b#0, Seq#Length(b#0) - 1);
    assume $IsAlloc(##b#1_0_0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_0_0_2_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1));
    assume Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1))) == Mul(Div(Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 1)), LitInt(3)), LitInt(4));
    assume {:captureState "StandardLibrary/src/Base64.dfy(465,79)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1))) + 4 == Mul(Div(Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 1)), LitInt(3)), LitInt(4)) + 4;
    assume false;
    goto anon10;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 1 && Seq#Length(b#0) - 1 <= Seq#Length(b#0);
    assume true;
    assume Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 1)) == Seq#Length(b#0) - 1;
    assume {:captureState "StandardLibrary/src/Base64.dfy(467,46)"} true;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} Mul(Div(Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 1)), LitInt(3)), LitInt(4)) + 4 == Mul(Div(Seq#Length(b#0) - 1, LitInt(3)), LitInt(4)) + 4;
    assume false;
    goto anon10;

  anon30_Else:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} LitInt(3) != 0;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume Div(Seq#Length(b#0) - 1, LitInt(3)) == Div(Seq#Length(b#0), LitInt(3));
    assume {:captureState "StandardLibrary/src/Base64.dfy(469,43)"} true;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} Mul(Div(Seq#Length(b#0) - 1, LitInt(3)), LitInt(4)) + 4 == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4;
    assume false;
    goto anon10;

  anon31_Else:
    goto anon10;

  anon10:
    assume Seq#Length(s#1) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4;
    return;

  anon25_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(1);
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_1_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_1 := Seq#Drop(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_1_1) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Seq#Equal(s#1, Seq#Append(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2)), Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2))));
    assume {:captureState "StandardLibrary/src/Base64.dfy(473,81)"} true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume true;
    assume false;
    goto anon18;

  anon32_Else:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume true;
    push;
    pop;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_4_0 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_1_0_4_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_4_1 := Seq#Drop(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_1_0_4_1) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume {:subsumption 0} Seq#Length(s#1) == Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2))) + Seq#Length(Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2)));
    assume false;
    goto anon18;

  anon33_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_3_0 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_1_0_3_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_3_1 := Seq#Drop(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_1_0_3_1) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    push;
    push;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_3_2 := Seq#Drop(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_3_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#1_1_0_3_2) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2));
    assume Seq#Length(Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2))) == LitInt(4);
    assume {:captureState "StandardLibrary/src/Base64.dfy(478,56)"} true;
    pop;
    pop;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_3_3 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_3_3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_1_0_3_3), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume {:subsumption 0} Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2))) + Seq#Length(Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2))) == Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2))) + 4;
    assume false;
    goto anon18;

  anon34_Else:
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_2_0 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_1_0_2_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    push;
    push;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    ##b#1_1_0_2_1 := Seq#Take(b#0, Seq#Length(b#0) - 2);
    assume $IsAlloc(##b#1_1_0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#1_1_0_2_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2));
    assume Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2))) == Mul(Div(Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 2)), LitInt(3)), LitInt(4));
    assume {:captureState "StandardLibrary/src/Base64.dfy(480,79)"} true;
    pop;
    pop;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} Seq#Length(Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2))) + 4 == Mul(Div(Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 2)), LitInt(3)), LitInt(4)) + 4;
    assume false;
    goto anon18;

  anon35_Else:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    push;
    push;
    assume {:subsumption 0} 0 <= Seq#Length(b#0) - 2 && Seq#Length(b#0) - 2 <= Seq#Length(b#0);
    assume true;
    assume Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 2)) == Seq#Length(b#0) - 2;
    assume {:captureState "StandardLibrary/src/Base64.dfy(482,46)"} true;
    pop;
    pop;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} Mul(Div(Seq#Length(Seq#Take(b#0, Seq#Length(b#0) - 2)), LitInt(3)), LitInt(4)) + 4 == Mul(Div(Seq#Length(b#0) - 2, LitInt(3)), LitInt(4)) + 4;
    assume false;
    goto anon18;

  anon36_Else:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    push;
    push;
    assume {:subsumption 0} LitInt(3) != 0;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume Div(Seq#Length(b#0) - 2, LitInt(3)) == Div(Seq#Length(b#0), LitInt(3));
    assume {:captureState "StandardLibrary/src/Base64.dfy(484,43)"} true;
    pop;
    pop;
    assume {:subsumption 0} LitInt(3) != 0;
    assume true;
    assume {:subsumption 0} Mul(Div(Seq#Length(b#0) - 2, LitInt(3)), LitInt(4)) + 4 == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4;
    assume false;
    goto anon18;

  anon37_Else:
    goto anon18;

  anon18:
    assume Seq#Length(s#1) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4;
    havoc s#Z#1_1_0;
    assume $Is(s#Z#1_1_0, TSeq(TChar)) && $IsAlloc(s#Z#1_1_0, TSeq(TChar), $Heap);
    ##b#1_1_2 := b#0;
    assume $IsAlloc(##b#1_1_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    assume let#1_1_0#0#0 == Base64.__default.Encode(b#0);
    assume Base64.__default.Encode#canCall(b#0);
    assume $Is(let#1_1_0#0#0, TSeq(TChar));
    assume s#Z#1_1_0 == let#1_1_0#0#0;
    assume {:subsumption 0} LitInt(3) != 0;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    assume {:subsumption 0} LitInt(3) != 0;
    goto anon20;

  anon38_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0);
    goto anon20;

  anon20:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#Z#1_1_0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4));
    assume {:subsumption 0} LitInt(3) != 0;
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != 0;
    assume {:subsumption 0} LitInt(3) != 0;
    goto anon23;

  anon40_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == 0;
    goto anon23;

  anon39_Else:
    assume {:partition} !(Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#Z#1_1_0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)));
    goto anon23;

  anon23:
    assume Base64.__default.Encode#canCall(b#0);
    assume {:subsumption 0} (var s#1_1_0 := Base64.__default.Encode(b#0); Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#1_1_0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)));
    assume {:subsumption 0} (var s#1_1_0 := Base64.__default.Encode(b#0); Mod(Seq#Length(b#0), LitInt(3)) != 0 ==> Seq#Length(s#1_1_0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4);
    assume (var s#1_1_0 := Base64.__default.Encode(b#0); (Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Seq#Length(s#1_1_0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4))) && (Mod(Seq#Length(b#0), LitInt(3)) != 0 ==> Seq#Length(s#1_1_0) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4));
    assume {:captureState "StandardLibrary/src/Base64.dfy(489,59)"} true;
    return;
}



procedure {:verboseName "Base64.EncodeLengthBound (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeLengthBound(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeLengthBound (well-formedness)"} CheckWellFormed$$Base64.__default.EncodeLengthBound(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeLengthBound", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(493,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64.dfy(494,12): post-state"} true;
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    assume let#0#0#0 == Base64.__default.Encode(b#0);
    assume Base64.__default.Encode#canCall(b#0);
    assume $Is(let#0#0#0, TSeq(TChar));
    assume s#Z#0 == let#0#0#0;
    assume LitInt(3) != 0;
    assume (var s#0 := Base64.__default.Encode(b#0); Seq#Length(s#0) <= Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4);
    return;
}



procedure {:verboseName "Base64.EncodeLengthBound (call precondtion)"} CallPre$$Base64.__default.EncodeLengthBound(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "Base64.EncodeLengthBound (call postcondition)"} CallPost$$Base64.__default.EncodeLengthBound(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0);
  free ensures {:id "id18640"} (var s#0 := Base64.__default.Encode(b#0); Seq#Length(s#0) <= Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64.EncodeLengthBound (correctness)"} Impl$$Base64.__default.EncodeLengthBound(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0);
  free ensures {:id "id18641"} (var s#0 := Base64.__default.Encode(b#0); Seq#Length(s#0) <= Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) + 4);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.EncodeLengthBound (correctness)"} Impl$$Base64.__default.EncodeLengthBound(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b##0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64.EncodeLengthBound", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64.dfy(496,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    b##0 := b#0;
    call CallPre$$Base64.__default.EncodeLengthExact(b##0);
    call CallPost$$Base64.__default.EncodeLengthExact(b##0);
    assume {:captureState "StandardLibrary/src/Base64.dfy(497,24)"} true;
    return;
}



procedure {:verboseName "Base64.index (well-formedness)"} CheckWellFormed$$Base64.index(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.index (well-formedness)"} CheckWellFormed$$Base64.index(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.index", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(15,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < 64;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 64);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.Base64.index()) } $Is(x#0, Tclass.Base64.index()) <==> LitInt(0) <= x#0 && x#0 < 64);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.Base64.index(), $h) } $IsAlloc(x#0, Tclass.Base64.index(), $h));

const unique class.Base64.index: ClassName;

procedure {:verboseName "Base64.uint24 (well-formedness)"} CheckWellFormed$$Base64.uint24(x#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64.uint24 (well-formedness)"} CheckWellFormed$$Base64.uint24(x#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64.uint24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "StandardLibrary/src/Base64.dfy(18,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} LitInt(0) <= x#0;
    goto anon4;

  anon7_Else:
    assume {:partition} x#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= x#0 && x#0 < 16777216;
    return;

  anon6_Else:
    assume true;
    assume {:subsumption 0} LitInt(0) <= LitInt(0);
    assume {:subsumption 0} Lit(0 < 16777216);
    return;
}



axiom (forall x#0: int :: { $Is(x#0, Tclass.Base64.uint24()) } $Is(x#0, Tclass.Base64.uint24()) <==> LitInt(0) <= x#0 && x#0 < 16777216);

axiom (forall x#0: int, $h: Heap :: { $IsAlloc(x#0, Tclass.Base64.uint24(), $h) } $IsAlloc(x#0, Tclass.Base64.uint24(), $h));

const unique class.Base64.uint24: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#120 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#120))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#122 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#122)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#180 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#180))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#182 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#182)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#184 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#184)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#180 := Wrappers.Option.value(this); v#180)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#182 := Lit(Wrappers.Option.value(Lit(this))); v#182)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#184 := Lit(Wrappers.Option.value(Lit(this))); v#184)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#120 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#120)) else (var e#120 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#122 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#122))) else (var e#122 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#180 := Wrappers.Result.value(this); s#180) else (var e#180 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#182 := Lit(Wrappers.Result.value(Lit(this))); s#182) else (var e#182 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#184 := Lit(Wrappers.Result.value(Lit(this))); s#184) else (var e#184 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#180 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#180)) else (var e#180 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#180)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#182 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#182))) else (var e#182 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#182)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#184 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#184))) else (var e#184 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#184)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#42 := Div(x#0, LitInt(256)); (var b1#42 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#42)), $Box(b1#42)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#43 := LitInt(Div(x#0, LitInt(256))); (var b1#43 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#43)), $Box(b1#43))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#42 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#42 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#43 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#43 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#42 := Div(x#0, LitInt(16777216)); (var x0#42 := x#0 - Mul(b0#42, LitInt(16777216)); (var b1#42 := Div(x0#42, LitInt(65536)); (var x1#42 := x0#42 - Mul(b1#42, LitInt(65536)); (var b2#42 := Div(x1#42, LitInt(256)); (var b3#42 := Mod(x1#42, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#42)), $Box(b1#42)), $Box(b2#42)), $Box(b3#42)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#43 := LitInt(Div(x#0, LitInt(16777216))); (var x0#43 := LitInt(x#0 - Mul(b0#43, LitInt(16777216))); (var b1#43 := LitInt(Div(x0#43, LitInt(65536))); (var x1#43 := LitInt(x0#43 - Mul(b1#43, LitInt(65536))); (var b2#43 := LitInt(Div(x1#43, LitInt(256))); (var b3#43 := LitInt(Mod(x1#43, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#43)), $Box(b1#43)), $Box(b2#43)), $Box(b3#43))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#42 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#42 := x0#42 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#42 := x1#42 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#42 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#43 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#43 := x0#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#43 := x1#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#43 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#42 := Div(x#0, LitInt(72057594037927936)); (var x0#42 := x#0 - Mul(b0#42, LitInt(72057594037927936)); (var b1#42 := Div(x0#42, LitInt(281474976710656)); (var x1#42 := x0#42 - Mul(b1#42, LitInt(281474976710656)); (var b2#42 := Div(x1#42, LitInt(1099511627776)); (var x2#42 := x1#42 - Mul(b2#42, LitInt(1099511627776)); (var b3#42 := Div(x2#42, LitInt(4294967296)); (var x3#42 := x2#42 - Mul(b3#42, LitInt(4294967296)); (var b4#42 := Div(x3#42, LitInt(16777216)); (var x4#42 := x3#42 - Mul(b4#42, LitInt(16777216)); (var b5#42 := Div(x4#42, LitInt(65536)); (var x5#42 := x4#42 - Mul(b5#42, LitInt(65536)); (var b6#42 := Div(x5#42, LitInt(256)); (var b7#42 := Mod(x5#42, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#42)), $Box(b1#42)), $Box(b2#42)), $Box(b3#42)), $Box(b4#42)), $Box(b5#42)), $Box(b6#42)), $Box(b7#42)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#43 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#43 := LitInt(x#0 - Mul(b0#43, LitInt(72057594037927936))); (var b1#43 := LitInt(Div(x0#43, LitInt(281474976710656))); (var x1#43 := LitInt(x0#43 - Mul(b1#43, LitInt(281474976710656))); (var b2#43 := LitInt(Div(x1#43, LitInt(1099511627776))); (var x2#43 := LitInt(x1#43 - Mul(b2#43, LitInt(1099511627776))); (var b3#43 := LitInt(Div(x2#43, LitInt(4294967296))); (var x3#43 := LitInt(x2#43 - Mul(b3#43, LitInt(4294967296))); (var b4#43 := LitInt(Div(x3#43, LitInt(16777216))); (var x4#43 := LitInt(x3#43 - Mul(b4#43, LitInt(16777216))); (var b5#43 := LitInt(Div(x4#43, LitInt(65536))); (var x5#43 := LitInt(x4#43 - Mul(b5#43, LitInt(65536))); (var b6#43 := LitInt(Div(x5#43, LitInt(256))); (var b7#43 := LitInt(Mod(x5#43, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#43)), $Box(b1#43)), $Box(b2#43)), $Box(b3#43)), $Box(b4#43)), $Box(b5#43)), $Box(b6#43)), $Box(b7#43))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#42 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#42 := x0#42 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#42 := x1#42 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#42 := x2#42 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#42 := x3#42 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#42 := x4#42 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#42 := x5#42 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#43 := x6#42 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#43)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#43 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#43 := x0#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#43 := x1#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#43 := x2#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#43 := x3#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#43 := x4#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#43 := x5#43 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#44 := x6#43 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#44)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#42 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#42)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#42 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#42)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#42)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#43 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#43)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#43 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#43)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#43)): int)));

const unique tytagFamily$index: TyTagFamily;

const unique tytagFamily$uint24: TyTagFamily;

const unique class.Base64Lemmas.__default: ClassName;

procedure {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncodeEmpty", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(14,8): initial state"} true;
    assume Seq#Equal(s#0, Seq#Empty(): Seq);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(16,35): post-state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#0);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18654"} Seq#Equal(s#0, Seq#Empty(): Seq);



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18655"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id18656"} Seq#Equal(s#0, Seq#Empty(): Seq);
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18657"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncodeEmpty", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(17,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(19,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume !Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#2 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume !Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(24,35): post-state"} true;
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#0 := Seq#Length(##s#3) - 4; Mod(Seq#Length(##s#3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#0 := Seq#Length(##s#3) - 4; Base64.__default.IsUnpaddedBase64String(##s#3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#3, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#3, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#3, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#3);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18667"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18668"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#1)))));
  requires {:id "id18669"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18670"} !Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  requires {:id "id18671"} !Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18672"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  free requires {:id "id18673"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2))))));
  requires {:id "id18674"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18675"} !Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  requires {:id "id18676"} !Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18677"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0_0_0: Seq;
  var ##b#0_0_0: Seq;
  var s##0_0_0: Seq;
  var ##s#0_1_0: Seq;
  var ##b#0_1_0: Seq;
  var ##s#0_1_1: Seq;
  var ##b#0_1_1: Seq;
  var ##s#0_2_0: Seq;
  var ##b#0_2_0: Seq;
  var ##s#0_2_1: Seq;
  var ##b#0_2_1: Seq;
  var ##s#0_0: Seq;
  var ##b#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(25,2): initial state"} true;
    $_reverifyPost := false;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0) ==> Base64.__default.IsBase64String(##s#0_0) || (var finalBlockStart#0_0 := Seq#Length(##s#0_0) - 4; Mod(Seq#Length(##s#0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0) ==> Base64.__default.IsBase64String(##s#0_0) || (var finalBlockStart#0_0 := Seq#Length(##s#0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_0, finalBlockStart#0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_0, finalBlockStart#0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_0, finalBlockStart#0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon5;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##s#0_2_0 := s#0;
    assume $IsAlloc(##s#0_2_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_0) ==> Base64.__default.IsBase64String(##s#0_2_0) || (var finalBlockStart#0_2_0 := Seq#Length(##s#0_2_0) - 4; Mod(Seq#Length(##s#0_2_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_0) ==> Base64.__default.IsBase64String(##s#0_2_0) || (var finalBlockStart#0_2_0 := Seq#Length(##s#0_2_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_2_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_2_0, finalBlockStart#0_2_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_2_0, finalBlockStart#0_2_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_2_0, finalBlockStart#0_2_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_2_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    ##s#0_2_1 := s#0;
    assume $IsAlloc(##s#0_2_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_2_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_2_1) || Mod(Seq#Length(##s#0_2_1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_2_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_2_1) || (forall k#0_2_0: char :: { Base64.__default.IsBase64Char(k#0_2_0) } { Seq#Contains(##s#0_2_1, $Box(k#0_2_0)) } $Is(k#0_2_0, TChar) ==> Seq#Contains(##s#0_2_1, $Box(k#0_2_0)) ==> Base64.__default.IsBase64Char(k#0_2_0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0_2_1 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), Base64.__default.Encode(Base64.__default.DecodeUnpadded(s#0)));
    assume false;
    goto anon5;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    ##s#0_1_0 := s#0;
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_0) || Mod(Seq#Length(##s#0_1_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_0) || (forall k#0_1_0: char :: { Base64.__default.IsBase64Char(k#0_1_0) } { Seq#Contains(##s#0_1_0, $Box(k#0_1_0)) } $Is(k#0_1_0, TChar) ==> Seq#Contains(##s#0_1_0, $Box(k#0_1_0)) ==> Base64.__default.IsBase64Char(k#0_1_0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0_1_0 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeUnpadded(s#0));
    ##s#0_1_1 := s#0;
    assume $IsAlloc(##s#0_1_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_1) || Mod(Seq#Length(##s#0_1_1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_1_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_1_1) || (forall k#0_1_1: char :: { Base64.__default.IsBase64Char(k#0_1_1) } { Seq#Contains(##s#0_1_1, $Box(k#0_1_1)) } $Is(k#0_1_1, TChar) ==> Seq#Contains(##s#0_1_1, $Box(k#0_1_1)) ==> Base64.__default.IsBase64Char(k#0_1_1));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0_1_1 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0_1_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_1_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeUnpadded(s#0)), Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)));
    assume false;
    goto anon5;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_0_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_0_0) || Mod(Seq#Length(##s#0_0_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_0_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_0_0) || (forall k#0_0_0: char :: { Base64.__default.IsBase64Char(k#0_0_0) } { Seq#Contains(##s#0_0_0, $Box(k#0_0_0)) } $Is(k#0_0_0, TChar) ==> Seq#Contains(##s#0_0_0, $Box(k#0_0_0)) ==> Base64.__default.IsBase64Char(k#0_0_0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0);
    ##b#0_0_0 := Base64.__default.DecodeUnpadded(s#0);
    assume $IsAlloc(##b#0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_0_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume Base64.__default.DecodeUnpadded#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(s#0));
    assume true;
    s##0_0_0 := s#0;
    call CallPre$$Base64.__default.DecodeEncodeUnpadded(s##0_0_0);
    call CallPost$$Base64.__default.DecodeEncodeUnpadded(s##0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(32,32)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(s#0)), s#0);
    assume false;
    goto anon5;

  anon9_Else:
    goto anon5;

  anon5:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(37,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(41,53): post-state"} true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Base64.__default.IsUnpaddedBase64String(##s#2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#2, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#2, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#2, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#2);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Mod(Seq#Length(##s#3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Base64.__default.IsUnpaddedBase64String(##s#3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#3, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#3, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(##s#3, finalBlockStart#1)))));
    assume Base64.__default.IsBase64String(##s#3);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#4 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#4) ==> Base64.__default.IsUnpaddedBase64String(##s#4) || Mod(Seq#Length(##s#4), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#4) ==> Base64.__default.IsUnpaddedBase64String(##s#4) || (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#4, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#4, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.IsUnpaddedBase64String(##s#4);
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume Seq#Equal(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2), Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18711"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18712"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2)))));
  requires {:id "id18713"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18714"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4);
  requires {:id "id18715"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18716"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18717"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18718"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char), LitInt(4)) == LitInt(0);
  requires {:id "id18719"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18720"} Seq#Equal(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2), Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  free requires {:id "id18721"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#3 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#3)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#3)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#3))))));
  requires {:id "id18722"} Seq#Length(s#0) >= LitInt(4);
  free requires {:id "id18723"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18724"} Seq#Equal(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2), Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(42,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(44,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(48,53): post-state"} true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Base64.__default.IsUnpaddedBase64String(##s#2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#2, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#2, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#2, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#2);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Mod(Seq#Length(##s#3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Base64.__default.IsUnpaddedBase64String(##s#3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#3, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#3, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(##s#3, finalBlockStart#1)))));
    assume Base64.__default.IsBase64String(##s#3);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#4 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#4) ==> Base64.__default.Is1Padding(##s#4) || Seq#Length(##s#4) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#4) ==> Base64.__default.Is1Padding(##s#4) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#4, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#4, LitInt(0))): char) || $Unbox(Seq#Index(##s#4, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#4, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#4) ==> Base64.__default.Is1Padding(##s#4) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#4, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#4, LitInt(1))): char) || $Unbox(Seq#Index(##s#4, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#4, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#4) ==> Base64.__default.Is1Padding(##s#4) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#4, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#4, LitInt(2))): char) || $Unbox(Seq#Index(##s#4, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#4, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#4) ==> Base64.__default.Is1Padding(##s#4) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#4, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#4) ==> Base64.__default.Is1Padding(##s#4) || $Unbox(Seq#Index(##s#4, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is1Padding(##s#4);
    assume Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Seq#Equal(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2), Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18742"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18743"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2)))));
  requires {:id "id18744"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18745"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4);
  requires {:id "id18746"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18747"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18748"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18749"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char), LitInt(4)) == LitInt(0);
  requires {:id "id18750"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18751"} Seq#Equal(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2), Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  free requires {:id "id18752"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#3 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#3)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#3)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#3))))));
  requires {:id "id18753"} Seq#Length(s#0) >= LitInt(4);
  free requires {:id "id18754"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18755"} Seq#Equal(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2), Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(49,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(51,37): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(55,35): post-state"} true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Base64.__default.IsUnpaddedBase64String(##s#2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#2, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#2, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#2, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#2);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18763"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18764"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#1)))));
  requires {:id "id18765"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18766"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4);
  requires {:id "id18767"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18768"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18769"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18770"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char), LitInt(4)) == LitInt(0);
  requires {:id "id18771"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18772"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id18773"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2))))));
  requires {:id "id18774"} Seq#Length(s#0) >= LitInt(4);
  free requires {:id "id18775"} Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18776"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s##0_0_0: Seq;
  var i##0_0_0: int;
  var ##s#0_1_0: Seq;
  var ##b#0_1_0: Seq;
  var s##0_1_0: Seq;
  var ##s#0_2_0: Seq;
  var ##s#0_2_1: Seq;
  var ##b#0_2_0: Seq;
  var s##0_2_0: Seq;
  var ##s#0_2_2: Seq;
  var ##b#0_2_1: Seq;
  var ##s#0_3_0: Seq;
  var ##s#0_3_1: Seq;
  var ##b#0_3_0: Seq;
  var ##s#0_3_2: Seq;
  var ##s#0_3_3: Seq;
  var ##b#0_3_1: Seq;
  var s##0_3_0: Seq;
  var ##s#0_3_4: Seq;
  var ##s#0_3_5: Seq;
  var ##b#0_3_2: Seq;
  var ##s#0_4_0: Seq;
  var ##s#0_4_1: Seq;
  var ##s#0_4_2: Seq;
  var ##s#0_4_3: Seq;
  var ##b#0_4_0: Seq;
  var ##s#0_4_4: Seq;
  var ##s#0_4_5: Seq;
  var ##b#0_4_1: Seq;
  var s##0_4_0: Seq;
  var ##s#0_4_6: Seq;
  var ##s#0_4_7: Seq;
  var ##b#0_4_2: Seq;
  var ##s#0_4_8: Seq;
  var ##s#0_4_9: Seq;
  var ##b#0_4_3: Seq;
  var ##s#0_5_0: Seq;
  var ##b#0_5_0: Seq;
  var ##s#0_5_1: Seq;
  var ##s#0_5_2: Seq;
  var ##s#0_5_3: Seq;
  var ##s#0_5_4: Seq;
  var ##b#0_5_1: Seq;
  var ##s#0_5_5: Seq;
  var ##s#0_5_6: Seq;
  var ##b#0_5_2: Seq;
  var ##s#0_0: Seq;
  var ##b#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(56,2): initial state"} true;
    $_reverifyPost := false;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0) ==> Base64.__default.IsBase64String(##s#0_0) || (var finalBlockStart#0_0 := Seq#Length(##s#0_0) - 4; Mod(Seq#Length(##s#0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0) ==> Base64.__default.IsBase64String(##s#0_0) || (var finalBlockStart#0_0 := Seq#Length(##s#0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_0, finalBlockStart#0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_0, finalBlockStart#0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_0, finalBlockStart#0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon12;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    ##s#0_5_0 := s#0;
    assume $IsAlloc(##s#0_5_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_0) ==> Base64.__default.IsBase64String(##s#0_5_0) || (var finalBlockStart#0_5_0 := Seq#Length(##s#0_5_0) - 4; Mod(Seq#Length(##s#0_5_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_0) ==> Base64.__default.IsBase64String(##s#0_5_0) || (var finalBlockStart#0_5_0 := Seq#Length(##s#0_5_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_0, finalBlockStart#0_5_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_0, finalBlockStart#0_5_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_0, finalBlockStart#0_5_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_5_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_5_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    ##s#0_5_1 := s#0;
    assume $IsAlloc(##s#0_5_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_1) ==> Base64.__default.IsBase64String(##s#0_5_1) || (var finalBlockStart#0_5_1 := Seq#Length(##s#0_5_1) - 4; Mod(Seq#Length(##s#0_5_1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_1) ==> Base64.__default.IsBase64String(##s#0_5_1) || (var finalBlockStart#0_5_1 := Seq#Length(##s#0_5_1) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_1, finalBlockStart#0_5_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_1, finalBlockStart#0_5_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_1, finalBlockStart#0_5_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Mod(Seq#Length(Base64.__default.DecodeValid(s#0)), LitInt(3)) == LitInt(2);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(60,38)"} true;
    ##s#0_5_2 := s#0;
    assume $IsAlloc(##s#0_5_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_2) ==> Base64.__default.IsBase64String(##s#0_5_2) || (var finalBlockStart#0_5_2 := Seq#Length(##s#0_5_2) - 4; Mod(Seq#Length(##s#0_5_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_2) ==> Base64.__default.IsBase64String(##s#0_5_2) || (var finalBlockStart#0_5_2 := Seq#Length(##s#0_5_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_2, finalBlockStart#0_5_2)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_2, finalBlockStart#0_5_2)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_2, finalBlockStart#0_5_2)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume LitInt(2) <= Seq#Length(Base64.__default.DecodeValid(s#0));
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(61,34)"} true;
    ##s#0_5_3 := s#0;
    assume $IsAlloc(##s#0_5_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_3) ==> Base64.__default.IsBase64String(##s#0_5_3) || (var finalBlockStart#0_5_3 := Seq#Length(##s#0_5_3) - 4; Mod(Seq#Length(##s#0_5_3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_3) ==> Base64.__default.IsBase64String(##s#0_5_3) || (var finalBlockStart#0_5_3 := Seq#Length(##s#0_5_3) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_3, finalBlockStart#0_5_3)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_3, finalBlockStart#0_5_3)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_3, finalBlockStart#0_5_3)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_5_4 := s#0;
    assume $IsAlloc(##s#0_5_4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_4) ==> Base64.__default.IsBase64String(##s#0_5_4) || (var finalBlockStart#0_5_4 := Seq#Length(##s#0_5_4) - 4; Mod(Seq#Length(##s#0_5_4), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_4) ==> Base64.__default.IsBase64String(##s#0_5_4) || (var finalBlockStart#0_5_4 := Seq#Length(##s#0_5_4) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_4) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_4, finalBlockStart#0_5_4)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_4, finalBlockStart#0_5_4)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_4, finalBlockStart#0_5_4)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_5_1 := Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_5_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_5_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    ##s#0_5_5 := s#0;
    assume $IsAlloc(##s#0_5_5, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_5) ==> Base64.__default.IsBase64String(##s#0_5_5) || (var finalBlockStart#0_5_5 := Seq#Length(##s#0_5_5) - 4; Mod(Seq#Length(##s#0_5_5), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_5) ==> Base64.__default.IsBase64String(##s#0_5_5) || (var finalBlockStart#0_5_5 := Seq#Length(##s#0_5_5) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_5) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_5, finalBlockStart#0_5_5)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_5, finalBlockStart#0_5_5)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_5, finalBlockStart#0_5_5)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_5_6 := s#0;
    assume $IsAlloc(##s#0_5_6, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_6) ==> Base64.__default.IsBase64String(##s#0_5_6) || (var finalBlockStart#0_5_6 := Seq#Length(##s#0_5_6) - 4; Mod(Seq#Length(##s#0_5_6), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_6) ==> Base64.__default.IsBase64String(##s#0_5_6) || (var finalBlockStart#0_5_6 := Seq#Length(##s#0_5_6) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_6) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_6, finalBlockStart#0_5_6)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_6, finalBlockStart#0_5_6)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_6, finalBlockStart#0_5_6)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_5_2 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_5_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_5_2) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2)) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), Seq#Append(Base64.__default.EncodeUnpadded(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2)), Base64.__default.Encode1Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2))));
    assume false;
    goto anon12;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##s#0_4_0 := s#0;
    assume $IsAlloc(##s#0_4_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_0) ==> Base64.__default.IsBase64String(##s#0_4_0) || (var finalBlockStart#0_4_0 := Seq#Length(##s#0_4_0) - 4; Mod(Seq#Length(##s#0_4_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_0) ==> Base64.__default.IsBase64String(##s#0_4_0) || (var finalBlockStart#0_4_0 := Seq#Length(##s#0_4_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_0, finalBlockStart#0_4_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_0, finalBlockStart#0_4_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_0, finalBlockStart#0_4_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Mod(Seq#Length(Base64.__default.DecodeValid(s#0)), LitInt(3)) == LitInt(2);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(60,38)"} true;
    ##s#0_4_1 := s#0;
    assume $IsAlloc(##s#0_4_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_1) ==> Base64.__default.IsBase64String(##s#0_4_1) || (var finalBlockStart#0_4_1 := Seq#Length(##s#0_4_1) - 4; Mod(Seq#Length(##s#0_4_1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_1) ==> Base64.__default.IsBase64String(##s#0_4_1) || (var finalBlockStart#0_4_1 := Seq#Length(##s#0_4_1) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_1, finalBlockStart#0_4_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_1, finalBlockStart#0_4_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_1, finalBlockStart#0_4_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume LitInt(2) <= Seq#Length(Base64.__default.DecodeValid(s#0));
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(61,34)"} true;
    ##s#0_4_2 := s#0;
    assume $IsAlloc(##s#0_4_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_2) ==> Base64.__default.IsBase64String(##s#0_4_2) || (var finalBlockStart#0_4_2 := Seq#Length(##s#0_4_2) - 4; Mod(Seq#Length(##s#0_4_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_2) ==> Base64.__default.IsBase64String(##s#0_4_2) || (var finalBlockStart#0_4_2 := Seq#Length(##s#0_4_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_2, finalBlockStart#0_4_2)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_2, finalBlockStart#0_4_2)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_2, finalBlockStart#0_4_2)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_4_3 := s#0;
    assume $IsAlloc(##s#0_4_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_3) ==> Base64.__default.IsBase64String(##s#0_4_3) || (var finalBlockStart#0_4_3 := Seq#Length(##s#0_4_3) - 4; Mod(Seq#Length(##s#0_4_3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_3) ==> Base64.__default.IsBase64String(##s#0_4_3) || (var finalBlockStart#0_4_3 := Seq#Length(##s#0_4_3) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_3, finalBlockStart#0_4_3)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_3, finalBlockStart#0_4_3)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_3, finalBlockStart#0_4_3)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_4_0 := Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_4_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    ##s#0_4_4 := s#0;
    assume $IsAlloc(##s#0_4_4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_4) ==> Base64.__default.IsBase64String(##s#0_4_4) || (var finalBlockStart#0_4_4 := Seq#Length(##s#0_4_4) - 4; Mod(Seq#Length(##s#0_4_4), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_4) ==> Base64.__default.IsBase64String(##s#0_4_4) || (var finalBlockStart#0_4_4 := Seq#Length(##s#0_4_4) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_4) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_4, finalBlockStart#0_4_4)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_4, finalBlockStart#0_4_4)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_4, finalBlockStart#0_4_4)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_4_5 := s#0;
    assume $IsAlloc(##s#0_4_5, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_5) ==> Base64.__default.IsBase64String(##s#0_4_5) || (var finalBlockStart#0_4_5 := Seq#Length(##s#0_4_5) - 4; Mod(Seq#Length(##s#0_4_5), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_5) ==> Base64.__default.IsBase64String(##s#0_4_5) || (var finalBlockStart#0_4_5 := Seq#Length(##s#0_4_5) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_5) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_5, finalBlockStart#0_4_5)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_5, finalBlockStart#0_4_5)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_5, finalBlockStart#0_4_5)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_4_1 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_4_1) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2)) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume true;
    s##0_4_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s##0_4_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s##0_4_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(63,52)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_4_6 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_4_6, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(65,27)"} true;
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume false;
    goto anon5;

  anon16_Else:
    goto anon5;

  anon5:
    assume Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(66,6)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_4_7 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_4_7, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_4_7) ==> Base64.__default.IsUnpaddedBase64String(##s#0_4_7) || Mod(Seq#Length(##s#0_4_7), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_4_7) ==> Base64.__default.IsUnpaddedBase64String(##s#0_4_7) || (forall k#0_4_0: char :: { Base64.__default.IsBase64Char(k#0_4_0) } { Seq#Contains(##s#0_4_7, $Box(k#0_4_0)) } $Is(k#0_4_0, TChar) ==> Seq#Contains(##s#0_4_7, $Box(k#0_4_0)) ==> Base64.__default.IsBase64Char(k#0_4_0));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    ##b#0_4_2 := Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_4_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_4_2), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
    ##s#0_4_8 := s#0;
    assume $IsAlloc(##s#0_4_8, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_8) ==> Base64.__default.IsBase64String(##s#0_4_8) || (var finalBlockStart#0_4_6 := Seq#Length(##s#0_4_8) - 4; Mod(Seq#Length(##s#0_4_8), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_8) ==> Base64.__default.IsBase64String(##s#0_4_8) || (var finalBlockStart#0_4_6 := Seq#Length(##s#0_4_8) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_8) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_8, finalBlockStart#0_4_6)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_8, finalBlockStart#0_4_6)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_8, finalBlockStart#0_4_6)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_4_9 := s#0;
    assume $IsAlloc(##s#0_4_9, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_9) ==> Base64.__default.IsBase64String(##s#0_4_9) || (var finalBlockStart#0_4_7 := Seq#Length(##s#0_4_9) - 4; Mod(Seq#Length(##s#0_4_9), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_9) ==> Base64.__default.IsBase64String(##s#0_4_9) || (var finalBlockStart#0_4_7 := Seq#Length(##s#0_4_9) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_9) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_9, finalBlockStart#0_4_7)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_9, finalBlockStart#0_4_7)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_9, finalBlockStart#0_4_7)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_4_3 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_4_3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_4_3) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4)) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Base64.__default.EncodeUnpadded(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2)), Base64.__default.Encode1Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2))), Seq#Append(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))), Base64.__default.Encode1Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2))));
    assume false;
    goto anon12;

  anon15_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_3_0 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_3_0, TSeq(TChar), $Heap);
    assume Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:subsumption 0} LitInt(4) != 0;
    assume true;
    assume Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(65,27)"} true;
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume false;
    goto anon8;

  anon18_Else:
    goto anon8;

  anon8:
    assume Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(66,6)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_3_1 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_3_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_3_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_3_1) || Mod(Seq#Length(##s#0_3_1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_3_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_3_1) || (forall k#0_3_0: char :: { Base64.__default.IsBase64Char(k#0_3_0) } { Seq#Contains(##s#0_3_1, $Box(k#0_3_0)) } $Is(k#0_3_0, TChar) ==> Seq#Contains(##s#0_3_1, $Box(k#0_3_0)) ==> Base64.__default.IsBase64Char(k#0_3_0));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    ##b#0_3_0 := Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_3_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
    ##s#0_3_2 := s#0;
    assume $IsAlloc(##s#0_3_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_2) ==> Base64.__default.IsBase64String(##s#0_3_2) || (var finalBlockStart#0_3_0 := Seq#Length(##s#0_3_2) - 4; Mod(Seq#Length(##s#0_3_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_2) ==> Base64.__default.IsBase64String(##s#0_3_2) || (var finalBlockStart#0_3_0 := Seq#Length(##s#0_3_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_2, finalBlockStart#0_3_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_2, finalBlockStart#0_3_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_2, finalBlockStart#0_3_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_3_3 := s#0;
    assume $IsAlloc(##s#0_3_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_3) ==> Base64.__default.IsBase64String(##s#0_3_3) || (var finalBlockStart#0_3_1 := Seq#Length(##s#0_3_3) - 4; Mod(Seq#Length(##s#0_3_3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_3) ==> Base64.__default.IsBase64String(##s#0_3_3) || (var finalBlockStart#0_3_1 := Seq#Length(##s#0_3_3) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_3, finalBlockStart#0_3_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_3, finalBlockStart#0_3_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_3, finalBlockStart#0_3_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_3_1 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_3_1) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4)) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    s##0_3_0 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    call CallPre$$Base64.__default.DecodeEncodeUnpadded(s##0_3_0);
    call CallPost$$Base64.__default.DecodeEncodeUnpadded(s##0_3_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(68,45)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_3_4 := s#0;
    assume $IsAlloc(##s#0_3_4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_4) ==> Base64.__default.IsBase64String(##s#0_3_4) || (var finalBlockStart#0_3_2 := Seq#Length(##s#0_3_4) - 4; Mod(Seq#Length(##s#0_3_4), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_4) ==> Base64.__default.IsBase64String(##s#0_3_4) || (var finalBlockStart#0_3_2 := Seq#Length(##s#0_3_4) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_4) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_4, finalBlockStart#0_3_2)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_4, finalBlockStart#0_3_2)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_4, finalBlockStart#0_3_2)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_3_5 := s#0;
    assume $IsAlloc(##s#0_3_5, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_5) ==> Base64.__default.IsBase64String(##s#0_3_5) || (var finalBlockStart#0_3_3 := Seq#Length(##s#0_3_5) - 4; Mod(Seq#Length(##s#0_3_5), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_5) ==> Base64.__default.IsBase64String(##s#0_3_5) || (var finalBlockStart#0_3_3 := Seq#Length(##s#0_3_5) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_5) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_5, finalBlockStart#0_3_3)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_5, finalBlockStart#0_3_3)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_5, finalBlockStart#0_3_3)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_3_2 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_3_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_3_2) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))), Base64.__default.Encode1Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2))), Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode1Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2))));
    assume false;
    goto anon12;

  anon17_Else:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_2_0 := s#0;
    assume $IsAlloc(##s#0_2_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_0) ==> Base64.__default.IsBase64String(##s#0_2_0) || (var finalBlockStart#0_2_0 := Seq#Length(##s#0_2_0) - 4; Mod(Seq#Length(##s#0_2_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_0) ==> Base64.__default.IsBase64String(##s#0_2_0) || (var finalBlockStart#0_2_0 := Seq#Length(##s#0_2_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_2_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_2_0, finalBlockStart#0_2_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_2_0, finalBlockStart#0_2_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_2_0, finalBlockStart#0_2_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_2_1 := s#0;
    assume $IsAlloc(##s#0_2_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_1) ==> Base64.__default.IsBase64String(##s#0_2_1) || (var finalBlockStart#0_2_1 := Seq#Length(##s#0_2_1) - 4; Mod(Seq#Length(##s#0_2_1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_1) ==> Base64.__default.IsBase64String(##s#0_2_1) || (var finalBlockStart#0_2_1 := Seq#Length(##s#0_2_1) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_2_1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_2_1, finalBlockStart#0_2_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_2_1, finalBlockStart#0_2_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_2_1, finalBlockStart#0_2_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 2 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_2_0 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2);
    assume $IsAlloc(##b#0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_2_0) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2));
    assume true;
    s##0_2_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s##0_2_0);
    call CallPost$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s##0_2_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(70,51)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_2_2 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_2_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_2_2) ==> Base64.__default.Is1Padding(##s#0_2_2) || Seq#Length(##s#0_2_2) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_2_2) ==> Base64.__default.Is1Padding(##s#0_2_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) || $Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_2_2) ==> Base64.__default.Is1Padding(##s#0_2_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) || $Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_2_2) ==> Base64.__default.Is1Padding(##s#0_2_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) || $Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_2_2) ==> Base64.__default.Is1Padding(##s#0_2_2) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_2_2) ==> Base64.__default.Is1Padding(##s#0_2_2) || $Unbox(Seq#Index(##s#0_2_2, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    ##b#0_2_1 := Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_2_1) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode1Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 2))), Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode1Padding(Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)))));
    assume false;
    goto anon12;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_1_0 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0) ==> Base64.__default.Is1Padding(##s#0_1_0) || Seq#Length(##s#0_1_0) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0) ==> Base64.__default.Is1Padding(##s#0_1_0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) || $Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0) ==> Base64.__default.Is1Padding(##s#0_1_0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) || $Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0) ==> Base64.__default.Is1Padding(##s#0_1_0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) || $Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0) ==> Base64.__default.Is1Padding(##s#0_1_0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is1Padding#canCall(##s#0_1_0) ==> Base64.__default.Is1Padding(##s#0_1_0) || $Unbox(Seq#Index(##s#0_1_0, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    ##b#0_1_0 := Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_1_0) == LitInt(2);
    assume Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume Base64.__default.Decode1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Encode1Padding#canCall(Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    s##0_1_0 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    call CallPre$$Base64.__default.DecodeEncode1Padding(s##0_1_0);
    call CallPost$$Base64.__default.DecodeEncode1Padding(s##0_1_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(72,45)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode1Padding(Base64.__default.Decode1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)))), Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume false;
    goto anon12;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    assume true;
    s##0_0_0 := s#0;
    assume true;
    assume $Is(Seq#Length(s#0) - 4, Tclass._System.nat());
    i##0_0_0 := Seq#Length(s#0) - 4;
    call CallPre$$StandardLibrary.__default.SeqPartsMakeWhole(TChar, s##0_0_0, i##0_0_0);
    call CallPost$$StandardLibrary.__default.SeqPartsMakeWhole(TChar, s##0_0_0, i##0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(74,40)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Seq#Drop(s#0, Seq#Length(s#0) - 4)), s#0);
    assume false;
    goto anon12;

  anon21_Else:
    goto anon12;

  anon12:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(79,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(83,53): post-state"} true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Base64.__default.IsUnpaddedBase64String(##s#2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#2, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#2, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#2, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#2);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Mod(Seq#Length(##s#3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Base64.__default.IsUnpaddedBase64String(##s#3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#3, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#3, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(##s#3, finalBlockStart#1)))));
    assume Base64.__default.IsBase64String(##s#3);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#4 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#4) ==> Base64.__default.IsUnpaddedBase64String(##s#4) || Mod(Seq#Length(##s#4), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#4) ==> Base64.__default.IsUnpaddedBase64String(##s#4) || (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(##s#4, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(##s#4, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0));
    assume Base64.__default.IsUnpaddedBase64String(##s#4);
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume Seq#Equal(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1), Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18918"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18919"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2)))));
  requires {:id "id18920"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18921"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4);
  requires {:id "id18922"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18923"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18924"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char), LitInt(16)) == LitInt(0);
  requires {:id "id18925"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(61));
  requires {:id "id18926"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18927"} Seq#Equal(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1), Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  free requires {:id "id18928"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#3 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#3)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#3)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#3))))));
  requires {:id "id18929"} Seq#Length(s#0) >= LitInt(4);
  free requires {:id "id18930"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18931"} Seq#Equal(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1), Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(84,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##s#3: Seq;
  var ##s#4: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(86,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(90,53): post-state"} true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Base64.__default.IsUnpaddedBase64String(##s#2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#2, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#2, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#2, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#2);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#3 := s#0;
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Mod(Seq#Length(##s#3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#3) ==> Base64.__default.IsBase64String(##s#3) || (var finalBlockStart#1 := Seq#Length(##s#3) - 4; Base64.__default.IsUnpaddedBase64String(##s#3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#3, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#3, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(##s#3, finalBlockStart#1)))));
    assume Base64.__default.IsBase64String(##s#3);
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#4 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#4) ==> Base64.__default.Is2Padding(##s#4) || Seq#Length(##s#4) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#4) ==> Base64.__default.Is2Padding(##s#4) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#4, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#4, LitInt(0))): char) || $Unbox(Seq#Index(##s#4, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#4, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#4) ==> Base64.__default.Is2Padding(##s#4) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#4, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#4, LitInt(1))): char) || $Unbox(Seq#Index(##s#4, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#4, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#4, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#4) ==> Base64.__default.Is2Padding(##s#4) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#4, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#4) ==> Base64.__default.Is2Padding(##s#4) || $Unbox(Seq#Index(##s#4, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#4) ==> Base64.__default.Is2Padding(##s#4) || $Unbox(Seq#Index(##s#4, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Is2Padding(##s#4);
    assume Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Seq#Equal(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1), Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18949"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18950"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#2 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2)))));
  requires {:id "id18951"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18952"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4);
  requires {:id "id18953"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18954"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18955"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char), LitInt(16)) == LitInt(0);
  requires {:id "id18956"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(61));
  requires {:id "id18957"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18958"} Seq#Equal(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1), Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  free requires {:id "id18959"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#3 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#3)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#3)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#3))))));
  requires {:id "id18960"} Seq#Length(s#0) >= LitInt(4);
  free requires {:id "id18961"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
  free ensures {:id "id18962"} Seq#Equal(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1), Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (correctness)"} Impl$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(91,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(93,37): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    assume Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(97,35): post-state"} true;
    ##s#2 := s#0;
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Mod(Seq#Length(##s#2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#2) ==> Base64.__default.IsBase64String(##s#2) || (var finalBlockStart#0 := Seq#Length(##s#2) - 4; Base64.__default.IsUnpaddedBase64String(##s#2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#2, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#2, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#2, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#2);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id18970"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id18971"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#1)))));
  requires {:id "id18972"} Seq#Length(s#0) >= LitInt(4);
  requires {:id "id18973"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4);
  requires {:id "id18974"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18975"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
  requires {:id "id18976"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char), LitInt(16)) == LitInt(0);
  requires {:id "id18977"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(61));
  requires {:id "id18978"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) ==> Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) || $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));



procedure {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18979"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id18980"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2))))));
  requires {:id "id18981"} Seq#Length(s#0) >= LitInt(4);
  free requires {:id "id18982"} Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Seq#Length(Seq#Drop(s#0, Seq#Length(s#0) - 4)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(Seq#Drop(s#0, Seq#Length(s#0) - 4), LitInt(3))): char == Lit(char#FromInt(61));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id18983"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s##0_0_0: Seq;
  var i##0_0_0: int;
  var ##s#0_1_0: Seq;
  var ##b#0_1_0: Seq;
  var s##0_1_0: Seq;
  var ##s#0_2_0: Seq;
  var ##s#0_2_1: Seq;
  var ##b#0_2_0: Seq;
  var s##0_2_0: Seq;
  var ##s#0_2_2: Seq;
  var ##b#0_2_1: Seq;
  var ##s#0_3_0: Seq;
  var ##b#0_3_0: Seq;
  var ##s#0_3_1: Seq;
  var ##s#0_3_2: Seq;
  var ##b#0_3_1: Seq;
  var s##0_3_0: Seq;
  var ##s#0_3_3: Seq;
  var ##s#0_3_4: Seq;
  var ##b#0_3_2: Seq;
  var ##s#0_4_0: Seq;
  var ##s#0_4_1: Seq;
  var ##s#0_4_2: Seq;
  var ##s#0_4_3: Seq;
  var ##b#0_4_0: Seq;
  var ##s#0_4_4: Seq;
  var ##s#0_4_5: Seq;
  var ##b#0_4_1: Seq;
  var s##0_4_0: Seq;
  var ##s#0_4_6: Seq;
  var ##b#0_4_2: Seq;
  var ##s#0_4_7: Seq;
  var ##s#0_4_8: Seq;
  var ##b#0_4_3: Seq;
  var ##s#0_5_0: Seq;
  var ##b#0_5_0: Seq;
  var ##s#0_5_1: Seq;
  var ##s#0_5_2: Seq;
  var ##s#0_5_3: Seq;
  var ##s#0_5_4: Seq;
  var ##b#0_5_1: Seq;
  var ##s#0_5_5: Seq;
  var ##s#0_5_6: Seq;
  var ##b#0_5_2: Seq;
  var ##s#0_0: Seq;
  var ##b#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(98,2): initial state"} true;
    $_reverifyPost := false;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0) ==> Base64.__default.IsBase64String(##s#0_0) || (var finalBlockStart#0_0 := Seq#Length(##s#0_0) - 4; Mod(Seq#Length(##s#0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0) ==> Base64.__default.IsBase64String(##s#0_0) || (var finalBlockStart#0_0 := Seq#Length(##s#0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_0, finalBlockStart#0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_0, finalBlockStart#0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_0, finalBlockStart#0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon8;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    ##s#0_5_0 := s#0;
    assume $IsAlloc(##s#0_5_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_0) ==> Base64.__default.IsBase64String(##s#0_5_0) || (var finalBlockStart#0_5_0 := Seq#Length(##s#0_5_0) - 4; Mod(Seq#Length(##s#0_5_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_0) ==> Base64.__default.IsBase64String(##s#0_5_0) || (var finalBlockStart#0_5_0 := Seq#Length(##s#0_5_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_0, finalBlockStart#0_5_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_0, finalBlockStart#0_5_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_0, finalBlockStart#0_5_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_5_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_5_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_5_1 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_5_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_5_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_5_1) || Mod(Seq#Length(##s#0_5_1), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_5_1) ==> Base64.__default.IsUnpaddedBase64String(##s#0_5_1) || (forall k#0_5_0: char :: { Base64.__default.IsBase64Char(k#0_5_0) } { Seq#Contains(##s#0_5_1, $Box(k#0_5_0)) } $Is(k#0_5_0, TChar) ==> Seq#Contains(##s#0_5_1, $Box(k#0_5_0)) ==> Base64.__default.IsBase64Char(k#0_5_0));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume Mod(Seq#Length(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))), LitInt(3)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(102,50)"} true;
    ##s#0_5_2 := s#0;
    assume $IsAlloc(##s#0_5_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_2) ==> Base64.__default.IsBase64String(##s#0_5_2) || (var finalBlockStart#0_5_1 := Seq#Length(##s#0_5_2) - 4; Mod(Seq#Length(##s#0_5_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_2) ==> Base64.__default.IsBase64String(##s#0_5_2) || (var finalBlockStart#0_5_1 := Seq#Length(##s#0_5_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_2, finalBlockStart#0_5_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_2, finalBlockStart#0_5_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_2, finalBlockStart#0_5_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Mod(Seq#Length(Base64.__default.DecodeValid(s#0)), LitInt(3)) == LitInt(1);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(103,38)"} true;
    ##s#0_5_3 := s#0;
    assume $IsAlloc(##s#0_5_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_3) ==> Base64.__default.IsBase64String(##s#0_5_3) || (var finalBlockStart#0_5_2 := Seq#Length(##s#0_5_3) - 4; Mod(Seq#Length(##s#0_5_3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_3) ==> Base64.__default.IsBase64String(##s#0_5_3) || (var finalBlockStart#0_5_2 := Seq#Length(##s#0_5_3) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_3, finalBlockStart#0_5_2)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_3, finalBlockStart#0_5_2)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_3, finalBlockStart#0_5_2)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_5_4 := s#0;
    assume $IsAlloc(##s#0_5_4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_4) ==> Base64.__default.IsBase64String(##s#0_5_4) || (var finalBlockStart#0_5_3 := Seq#Length(##s#0_5_4) - 4; Mod(Seq#Length(##s#0_5_4), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_4) ==> Base64.__default.IsBase64String(##s#0_5_4) || (var finalBlockStart#0_5_3 := Seq#Length(##s#0_5_4) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_4) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_4, finalBlockStart#0_5_3)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_4, finalBlockStart#0_5_3)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_4, finalBlockStart#0_5_3)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_5_1 := Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_5_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_5_1), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    ##s#0_5_5 := s#0;
    assume $IsAlloc(##s#0_5_5, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_5) ==> Base64.__default.IsBase64String(##s#0_5_5) || (var finalBlockStart#0_5_4 := Seq#Length(##s#0_5_5) - 4; Mod(Seq#Length(##s#0_5_5), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_5) ==> Base64.__default.IsBase64String(##s#0_5_5) || (var finalBlockStart#0_5_4 := Seq#Length(##s#0_5_5) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_5) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_5, finalBlockStart#0_5_4)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_5, finalBlockStart#0_5_4)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_5, finalBlockStart#0_5_4)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_5_6 := s#0;
    assume $IsAlloc(##s#0_5_6, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_6) ==> Base64.__default.IsBase64String(##s#0_5_6) || (var finalBlockStart#0_5_5 := Seq#Length(##s#0_5_6) - 4; Mod(Seq#Length(##s#0_5_6), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_5_6) ==> Base64.__default.IsBase64String(##s#0_5_6) || (var finalBlockStart#0_5_5 := Seq#Length(##s#0_5_6) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_5_6) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_5_6, finalBlockStart#0_5_5)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_5_6, finalBlockStart#0_5_5)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_5_6, finalBlockStart#0_5_5)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_5_2 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_5_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_5_2) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1)) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), Seq#Append(Base64.__default.EncodeUnpadded(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1)), Base64.__default.Encode2Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1))));
    assume false;
    goto anon8;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_4_0 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_4_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_4_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_4_0) || Mod(Seq#Length(##s#0_4_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_4_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_4_0) || (forall k#0_4_0: char :: { Base64.__default.IsBase64Char(k#0_4_0) } { Seq#Contains(##s#0_4_0, $Box(k#0_4_0)) } $Is(k#0_4_0, TChar) ==> Seq#Contains(##s#0_4_0, $Box(k#0_4_0)) ==> Base64.__default.IsBase64Char(k#0_4_0));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume Mod(Seq#Length(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))), LitInt(3)) == LitInt(0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(102,50)"} true;
    ##s#0_4_1 := s#0;
    assume $IsAlloc(##s#0_4_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_1) ==> Base64.__default.IsBase64String(##s#0_4_1) || (var finalBlockStart#0_4_0 := Seq#Length(##s#0_4_1) - 4; Mod(Seq#Length(##s#0_4_1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_1) ==> Base64.__default.IsBase64String(##s#0_4_1) || (var finalBlockStart#0_4_0 := Seq#Length(##s#0_4_1) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_1, finalBlockStart#0_4_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_1, finalBlockStart#0_4_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_1, finalBlockStart#0_4_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} LitInt(3) != 0;
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume Mod(Seq#Length(Base64.__default.DecodeValid(s#0)), LitInt(3)) == LitInt(1);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(103,38)"} true;
    ##s#0_4_2 := s#0;
    assume $IsAlloc(##s#0_4_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_2) ==> Base64.__default.IsBase64String(##s#0_4_2) || (var finalBlockStart#0_4_1 := Seq#Length(##s#0_4_2) - 4; Mod(Seq#Length(##s#0_4_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_2) ==> Base64.__default.IsBase64String(##s#0_4_2) || (var finalBlockStart#0_4_1 := Seq#Length(##s#0_4_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_2, finalBlockStart#0_4_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_2, finalBlockStart#0_4_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_2, finalBlockStart#0_4_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_4_3 := s#0;
    assume $IsAlloc(##s#0_4_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_3) ==> Base64.__default.IsBase64String(##s#0_4_3) || (var finalBlockStart#0_4_2 := Seq#Length(##s#0_4_3) - 4; Mod(Seq#Length(##s#0_4_3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_3) ==> Base64.__default.IsBase64String(##s#0_4_3) || (var finalBlockStart#0_4_2 := Seq#Length(##s#0_4_3) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_3, finalBlockStart#0_4_2)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_3, finalBlockStart#0_4_2)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_3, finalBlockStart#0_4_2)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_4_0 := Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_4_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    ##s#0_4_4 := s#0;
    assume $IsAlloc(##s#0_4_4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_4) ==> Base64.__default.IsBase64String(##s#0_4_4) || (var finalBlockStart#0_4_3 := Seq#Length(##s#0_4_4) - 4; Mod(Seq#Length(##s#0_4_4), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_4) ==> Base64.__default.IsBase64String(##s#0_4_4) || (var finalBlockStart#0_4_3 := Seq#Length(##s#0_4_4) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_4) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_4, finalBlockStart#0_4_3)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_4, finalBlockStart#0_4_3)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_4, finalBlockStart#0_4_3)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_4_5 := s#0;
    assume $IsAlloc(##s#0_4_5, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_5) ==> Base64.__default.IsBase64String(##s#0_4_5) || (var finalBlockStart#0_4_4 := Seq#Length(##s#0_4_5) - 4; Mod(Seq#Length(##s#0_4_5), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_5) ==> Base64.__default.IsBase64String(##s#0_4_5) || (var finalBlockStart#0_4_4 := Seq#Length(##s#0_4_5) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_5) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_5, finalBlockStart#0_4_4)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_5, finalBlockStart#0_4_4)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_5, finalBlockStart#0_4_4)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_4_1 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_4_1) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.EncodeUnpadded#canCall(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1)) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume true;
    s##0_4_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s##0_4_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s##0_4_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(105,52)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_4_6 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_4_6, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_4_6) ==> Base64.__default.IsUnpaddedBase64String(##s#0_4_6) || Mod(Seq#Length(##s#0_4_6), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_4_6) ==> Base64.__default.IsUnpaddedBase64String(##s#0_4_6) || (forall k#0_4_1: char :: { Base64.__default.IsBase64Char(k#0_4_1) } { Seq#Contains(##s#0_4_6, $Box(k#0_4_1)) } $Is(k#0_4_1, TChar) ==> Seq#Contains(##s#0_4_6, $Box(k#0_4_1)) ==> Base64.__default.IsBase64Char(k#0_4_1));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    ##b#0_4_2 := Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_4_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_4_2), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
    ##s#0_4_7 := s#0;
    assume $IsAlloc(##s#0_4_7, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_7) ==> Base64.__default.IsBase64String(##s#0_4_7) || (var finalBlockStart#0_4_5 := Seq#Length(##s#0_4_7) - 4; Mod(Seq#Length(##s#0_4_7), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_7) ==> Base64.__default.IsBase64String(##s#0_4_7) || (var finalBlockStart#0_4_5 := Seq#Length(##s#0_4_7) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_7) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_7, finalBlockStart#0_4_5)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_7, finalBlockStart#0_4_5)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_7, finalBlockStart#0_4_5)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_4_8 := s#0;
    assume $IsAlloc(##s#0_4_8, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_8) ==> Base64.__default.IsBase64String(##s#0_4_8) || (var finalBlockStart#0_4_6 := Seq#Length(##s#0_4_8) - 4; Mod(Seq#Length(##s#0_4_8), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_4_8) ==> Base64.__default.IsBase64String(##s#0_4_8) || (var finalBlockStart#0_4_6 := Seq#Length(##s#0_4_8) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_4_8) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_4_8, finalBlockStart#0_4_6)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_4_8, finalBlockStart#0_4_6)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_4_8, finalBlockStart#0_4_6)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_4_3 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_4_3, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_4_3) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4)) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Base64.__default.EncodeUnpadded(Seq#Take(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1)), Base64.__default.Encode2Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1))), Seq#Append(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))), Base64.__default.Encode2Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1))));
    assume false;
    goto anon8;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_3_0 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_3_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_3_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_3_0) || Mod(Seq#Length(##s#0_3_0), LitInt(4)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.IsUnpaddedBase64String#canCall(##s#0_3_0) ==> Base64.__default.IsUnpaddedBase64String(##s#0_3_0) || (forall k#0_3_0: char :: { Base64.__default.IsBase64Char(k#0_3_0) } { Seq#Contains(##s#0_3_0, $Box(k#0_3_0)) } $Is(k#0_3_0, TChar) ==> Seq#Contains(##s#0_3_0, $Box(k#0_3_0)) ==> Base64.__default.IsBase64Char(k#0_3_0));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4));
    ##b#0_3_0 := Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Mod(Seq#Length(##b#0_3_0), LitInt(3)) == LitInt(0);
    assume Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4)));
    ##s#0_3_1 := s#0;
    assume $IsAlloc(##s#0_3_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_1) ==> Base64.__default.IsBase64String(##s#0_3_1) || (var finalBlockStart#0_3_0 := Seq#Length(##s#0_3_1) - 4; Mod(Seq#Length(##s#0_3_1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_1) ==> Base64.__default.IsBase64String(##s#0_3_1) || (var finalBlockStart#0_3_0 := Seq#Length(##s#0_3_1) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_1, finalBlockStart#0_3_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_1, finalBlockStart#0_3_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_1, finalBlockStart#0_3_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_3_2 := s#0;
    assume $IsAlloc(##s#0_3_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_2) ==> Base64.__default.IsBase64String(##s#0_3_2) || (var finalBlockStart#0_3_1 := Seq#Length(##s#0_3_2) - 4; Mod(Seq#Length(##s#0_3_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_2) ==> Base64.__default.IsBase64String(##s#0_3_2) || (var finalBlockStart#0_3_1 := Seq#Length(##s#0_3_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_2, finalBlockStart#0_3_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_2, finalBlockStart#0_3_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_2, finalBlockStart#0_3_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_3_1 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_3_1) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume Base64.__default.DecodeUnpadded#canCall(Seq#Take(s#0, Seq#Length(s#0) - 4)) && Base64.__default.EncodeUnpadded#canCall(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    s##0_3_0 := Seq#Take(s#0, Seq#Length(s#0) - 4);
    call CallPre$$Base64.__default.DecodeEncodeUnpadded(s##0_3_0);
    call CallPost$$Base64.__default.DecodeEncodeUnpadded(s##0_3_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(107,45)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_3_3 := s#0;
    assume $IsAlloc(##s#0_3_3, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_3) ==> Base64.__default.IsBase64String(##s#0_3_3) || (var finalBlockStart#0_3_2 := Seq#Length(##s#0_3_3) - 4; Mod(Seq#Length(##s#0_3_3), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_3) ==> Base64.__default.IsBase64String(##s#0_3_3) || (var finalBlockStart#0_3_2 := Seq#Length(##s#0_3_3) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_3) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_3, finalBlockStart#0_3_2)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_3, finalBlockStart#0_3_2)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_3, finalBlockStart#0_3_2)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_3_4 := s#0;
    assume $IsAlloc(##s#0_3_4, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_4) ==> Base64.__default.IsBase64String(##s#0_3_4) || (var finalBlockStart#0_3_3 := Seq#Length(##s#0_3_4) - 4; Mod(Seq#Length(##s#0_3_4), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_3_4) ==> Base64.__default.IsBase64String(##s#0_3_4) || (var finalBlockStart#0_3_3 := Seq#Length(##s#0_3_4) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_3_4) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_3_4, finalBlockStart#0_3_3)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_3_4, finalBlockStart#0_3_3)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_3_4, finalBlockStart#0_3_3)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_3_2 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_3_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_3_2) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Base64.__default.EncodeUnpadded(Base64.__default.DecodeUnpadded(Seq#Take(s#0, Seq#Length(s#0) - 4))), Base64.__default.Encode2Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1))), Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode2Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1))));
    assume false;
    goto anon8;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_2_0 := s#0;
    assume $IsAlloc(##s#0_2_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_0) ==> Base64.__default.IsBase64String(##s#0_2_0) || (var finalBlockStart#0_2_0 := Seq#Length(##s#0_2_0) - 4; Mod(Seq#Length(##s#0_2_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_0) ==> Base64.__default.IsBase64String(##s#0_2_0) || (var finalBlockStart#0_2_0 := Seq#Length(##s#0_2_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_2_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_2_0, finalBlockStart#0_2_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_2_0, finalBlockStart#0_2_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_2_0, finalBlockStart#0_2_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##s#0_2_1 := s#0;
    assume $IsAlloc(##s#0_2_1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_1) ==> Base64.__default.IsBase64String(##s#0_2_1) || (var finalBlockStart#0_2_1 := Seq#Length(##s#0_2_1) - 4; Mod(Seq#Length(##s#0_2_1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_2_1) ==> Base64.__default.IsBase64String(##s#0_2_1) || (var finalBlockStart#0_2_1 := Seq#Length(##s#0_2_1) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_2_1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_2_1, finalBlockStart#0_2_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_2_1, finalBlockStart#0_2_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_2_1, finalBlockStart#0_2_1)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 && Seq#Length(Base64.__default.DecodeValid(s#0)) - 1 <= Seq#Length(Base64.__default.DecodeValid(s#0));
    ##b#0_2_0 := Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1);
    assume $IsAlloc(##b#0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_2_0) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1));
    assume true;
    s##0_2_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s##0_2_0);
    call CallPost$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s##0_2_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(109,51)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_2_2 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_2_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_2_2) ==> Base64.__default.Is2Padding(##s#0_2_2) || Seq#Length(##s#0_2_2) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_2_2) ==> Base64.__default.Is2Padding(##s#0_2_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) || $Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_2_2) ==> Base64.__default.Is2Padding(##s#0_2_2) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) || $Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_2_2) ==> Base64.__default.Is2Padding(##s#0_2_2) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0_2_2, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_2_2) ==> Base64.__default.Is2Padding(##s#0_2_2) || $Unbox(Seq#Index(##s#0_2_2, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_2_2) ==> Base64.__default.Is2Padding(##s#0_2_2) || $Unbox(Seq#Index(##s#0_2_2, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    ##b#0_2_1 := Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_2_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_2_1) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode2Padding(Seq#Drop(Base64.__default.DecodeValid(s#0), Seq#Length(Base64.__default.DecodeValid(s#0)) - 1))), Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode2Padding(Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)))));
    assume false;
    goto anon8;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#0_1_0 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_0) ==> Base64.__default.Is2Padding(##s#0_1_0) || Seq#Length(##s#0_1_0) == LitInt(4);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_0) ==> Base64.__default.Is2Padding(##s#0_1_0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) || $Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(0))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_0) ==> Base64.__default.Is2Padding(##s#0_1_0) || (Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) ==> Base64.__default.IsBase64Char($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) || $Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char == Lit(char#FromInt(43)) || $Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) && char#ToInt($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char) <= char#ToInt(Lit(char#FromInt(122)))));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_0) ==> Base64.__default.Is2Padding(##s#0_1_0) || Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(##s#0_1_0, LitInt(1))): char), LitInt(16)) == LitInt(0);
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_0) ==> Base64.__default.Is2Padding(##s#0_1_0) || $Unbox(Seq#Index(##s#0_1_0, LitInt(2))): char == Lit(char#FromInt(61));
    assume {:subsumption 0} Base64.__default.Is2Padding#canCall(##s#0_1_0) ==> Base64.__default.Is2Padding(##s#0_1_0) || $Unbox(Seq#Index(##s#0_1_0, LitInt(3))): char == Lit(char#FromInt(61));
    assume Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    ##b#0_1_0 := Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    assume $IsAlloc(##b#0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##b#0_1_0) == LitInt(1);
    assume Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume Base64.__default.Decode2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4)) && Base64.__default.Encode2Padding#canCall(Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    s##0_1_0 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    call CallPre$$Base64.__default.DecodeEncode2Padding(s##0_1_0);
    call CallPost$$Base64.__default.DecodeEncode2Padding(s##0_1_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(111,45)"} true;
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Base64.__default.Encode2Padding(Base64.__default.Decode2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)))), Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    assume false;
    goto anon8;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume {:subsumption 0} 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    assume true;
    assume true;
    s##0_0_0 := s#0;
    assume true;
    assume $Is(Seq#Length(s#0) - 4, Tclass._System.nat());
    i##0_0_0 := Seq#Length(s#0) - 4;
    call CallPre$$StandardLibrary.__default.SeqPartsMakeWhole(TChar, s##0_0_0, i##0_0_0);
    call CallPost$$StandardLibrary.__default.SeqPartsMakeWhole(TChar, s##0_0_0, i##0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(113,40)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Take(s#0, Seq#Length(s#0) - 4), Seq#Drop(s#0, Seq#Length(s#0) - 4)), s#0);
    assume false;
    goto anon8;

  anon15_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncode (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncode (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(118,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(120,35): post-state"} true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1) ==> Base64.__default.IsBase64String(##s#1) || (var finalBlockStart#0 := Seq#Length(##s#1) - 4; Mod(Seq#Length(##s#1), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1) ==> Base64.__default.IsBase64String(##s#1) || (var finalBlockStart#0 := Seq#Length(##s#1) - 4; Base64.__default.IsUnpaddedBase64String(##s#1) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#1);
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeValidEncode (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id19110"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id19111"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#1 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#1)))));



procedure {:verboseName "Base64Lemmas.DecodeValidEncode (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id19112"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeValidEncode (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id19113"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2))))));
  modifies $Heap;
  free ensures Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
  free ensures {:id "id19114"} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeValidEncode (correctness)"} Impl$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0_0_0_0: Seq;
  var ##b#0_0_0_0: Seq;
  var s##0_0_0_0: Seq;
  var ##s#0_0_0: Seq;
  var ##b#0_0_0: Seq;
  var ##s#1_0: Seq;
  var ##s#1_0_0_0_0: Seq;
  var ##b#1_0_0_0_0: Seq;
  var s##1_0_0_0_0: Seq;
  var ##s#1_0_0_0: Seq;
  var ##b#1_0_0_0: Seq;
  var ##s#1_1_0: Seq;
  var ##s#1_1_0_0_0_0: Seq;
  var ##b#1_1_0_0_0_0: Seq;
  var s##1_1_0_0_0_0: Seq;
  var ##s#1_1_0_0_0: Seq;
  var ##b#1_1_0_0_0: Seq;
  var ##s#1_1_1_0_0_0: Seq;
  var ##b#1_1_1_0_0_0: Seq;
  var s##1_1_1_0_0_0: Seq;
  var ##s#1_1_1_0_0: Seq;
  var ##b#1_1_1_0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(121,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Equal(s#0, Seq#Empty(): Seq);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0_0) ==> Base64.__default.IsBase64String(##s#0_0_0) || (var finalBlockStart#0_0_0 := Seq#Length(##s#0_0_0) - 4; Mod(Seq#Length(##s#0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0_0) ==> Base64.__default.IsBase64String(##s#0_0_0) || (var finalBlockStart#0_0_0 := Seq#Length(##s#0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_0_0, finalBlockStart#0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_0_0, finalBlockStart#0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_0_0, finalBlockStart#0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon4;

  anon24_Else:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    ##s#0_0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0_0_0) ==> Base64.__default.IsBase64String(##s#0_0_0_0) || (var finalBlockStart#0_0_0_0 := Seq#Length(##s#0_0_0_0) - 4; Mod(Seq#Length(##s#0_0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0_0_0) ==> Base64.__default.IsBase64String(##s#0_0_0_0) || (var finalBlockStart#0_0_0_0 := Seq#Length(##s#0_0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_0_0_0, finalBlockStart#0_0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_0_0_0, finalBlockStart#0_0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_0_0_0, finalBlockStart#0_0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#0_0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#0_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume true;
    s##0_0_0_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s##0_0_0_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s##0_0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(125,36)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    assume false;
    goto anon4;

  anon25_Else:
    goto anon4;

  anon4:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;

  anon23_Else:
    assume {:partition} !Seq#Equal(s#0, Seq#Empty(): Seq);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1_0 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1_0, TSeq(TChar), $Heap);
    assume Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    goto anon7;

  anon26_Else:
    assume {:partition} LitInt(4) > Seq#Length(s#0);
    goto anon7;

  anon7:
    assume Seq#Length(s#0) >= LitInt(4) ==> Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(4) && Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    goto anon28_Then, anon28_Else;

  anon28_Then:
    ##s#1_0_0_0 := s#0;
    assume $IsAlloc(##s#1_0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_0_0_0) ==> Base64.__default.IsBase64String(##s#1_0_0_0) || (var finalBlockStart#1_0_0_0 := Seq#Length(##s#1_0_0_0) - 4; Mod(Seq#Length(##s#1_0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_0_0_0) ==> Base64.__default.IsBase64String(##s#1_0_0_0) || (var finalBlockStart#1_0_0_0 := Seq#Length(##s#1_0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#1_0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1_0_0_0, finalBlockStart#1_0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1_0_0_0, finalBlockStart#1_0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1_0_0_0, finalBlockStart#1_0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#1_0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#1_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon11;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    ##s#1_0_0_0_0 := s#0;
    assume $IsAlloc(##s#1_0_0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_0_0_0_0) ==> Base64.__default.IsBase64String(##s#1_0_0_0_0) || (var finalBlockStart#1_0_0_0_0 := Seq#Length(##s#1_0_0_0_0) - 4; Mod(Seq#Length(##s#1_0_0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_0_0_0_0) ==> Base64.__default.IsBase64String(##s#1_0_0_0_0) || (var finalBlockStart#1_0_0_0_0 := Seq#Length(##s#1_0_0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#1_0_0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1_0_0_0_0, finalBlockStart#1_0_0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1_0_0_0_0, finalBlockStart#1_0_0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1_0_0_0_0, finalBlockStart#1_0_0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#1_0_0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#1_0_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume true;
    s##1_0_0_0_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidEncode1Padding(s##1_0_0_0_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidEncode1Padding(s##1_0_0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(131,39)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    assume false;
    goto anon11;

  anon29_Else:
    goto anon11;

  anon11:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;

  anon27_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(4) && Base64.__default.Is1Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(4);
    assume 0 <= Seq#Length(s#0) - 4 && Seq#Length(s#0) - 4 <= Seq#Length(s#0);
    ##s#1_1_0 := Seq#Drop(s#0, Seq#Length(s#0) - 4);
    assume $IsAlloc(##s#1_1_0, TSeq(TChar), $Heap);
    assume Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    goto anon14;

  anon30_Else:
    assume {:partition} LitInt(4) > Seq#Length(s#0);
    goto anon14;

  anon14:
    assume Seq#Length(s#0) >= LitInt(4) ==> Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} Seq#Length(s#0) >= LitInt(4) && Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    ##s#1_1_0_0_0 := s#0;
    assume $IsAlloc(##s#1_1_0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_0_0_0) ==> Base64.__default.IsBase64String(##s#1_1_0_0_0) || (var finalBlockStart#1_1_0_0_0 := Seq#Length(##s#1_1_0_0_0) - 4; Mod(Seq#Length(##s#1_1_0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_0_0_0) ==> Base64.__default.IsBase64String(##s#1_1_0_0_0) || (var finalBlockStart#1_1_0_0_0 := Seq#Length(##s#1_1_0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#1_1_0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1_1_0_0_0, finalBlockStart#1_1_0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1_1_0_0_0, finalBlockStart#1_1_0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1_1_0_0_0, finalBlockStart#1_1_0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#1_1_0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#1_1_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon18;

  anon32_Else:
    goto anon33_Then, anon33_Else;

  anon33_Then:
    ##s#1_1_0_0_0_0 := s#0;
    assume $IsAlloc(##s#1_1_0_0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_0_0_0_0) ==> Base64.__default.IsBase64String(##s#1_1_0_0_0_0) || (var finalBlockStart#1_1_0_0_0_0 := Seq#Length(##s#1_1_0_0_0_0) - 4; Mod(Seq#Length(##s#1_1_0_0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_0_0_0_0) ==> Base64.__default.IsBase64String(##s#1_1_0_0_0_0) || (var finalBlockStart#1_1_0_0_0_0 := Seq#Length(##s#1_1_0_0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#1_1_0_0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1_1_0_0_0_0, finalBlockStart#1_1_0_0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1_1_0_0_0_0, finalBlockStart#1_1_0_0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1_1_0_0_0_0, finalBlockStart#1_1_0_0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#1_1_0_0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#1_1_0_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume true;
    s##1_1_0_0_0_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidEncode2Padding(s##1_1_0_0_0_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidEncode2Padding(s##1_1_0_0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(137,39)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    assume false;
    goto anon18;

  anon33_Else:
    goto anon18;

  anon18:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;

  anon31_Else:
    assume {:partition} !(Seq#Length(s#0) >= LitInt(4) && Base64.__default.Is2Padding(Seq#Drop(s#0, Seq#Length(s#0) - 4)));
    goto anon34_Then, anon34_Else;

  anon34_Then:
    ##s#1_1_1_0_0 := s#0;
    assume $IsAlloc(##s#1_1_1_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_1_0_0) ==> Base64.__default.IsBase64String(##s#1_1_1_0_0) || (var finalBlockStart#1_1_1_0_0 := Seq#Length(##s#1_1_1_0_0) - 4; Mod(Seq#Length(##s#1_1_1_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_1_0_0) ==> Base64.__default.IsBase64String(##s#1_1_1_0_0) || (var finalBlockStart#1_1_1_0_0 := Seq#Length(##s#1_1_1_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#1_1_1_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1_1_1_0_0, finalBlockStart#1_1_1_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1_1_1_0_0, finalBlockStart#1_1_1_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1_1_1_0_0, finalBlockStart#1_1_1_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#1_1_1_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#1_1_1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume false;
    goto anon22;

  anon34_Else:
    goto anon35_Then, anon35_Else;

  anon35_Then:
    ##s#1_1_1_0_0_0 := s#0;
    assume $IsAlloc(##s#1_1_1_0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_1_0_0_0) ==> Base64.__default.IsBase64String(##s#1_1_1_0_0_0) || (var finalBlockStart#1_1_1_0_0_0 := Seq#Length(##s#1_1_1_0_0_0) - 4; Mod(Seq#Length(##s#1_1_1_0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#1_1_1_0_0_0) ==> Base64.__default.IsBase64String(##s#1_1_1_0_0_0) || (var finalBlockStart#1_1_1_0_0_0 := Seq#Length(##s#1_1_1_0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#1_1_1_0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#1_1_1_0_0_0, finalBlockStart#1_1_1_0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#1_1_1_0_0_0, finalBlockStart#1_1_1_0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#1_1_1_0_0_0, finalBlockStart#1_1_1_0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(s#0);
    ##b#1_1_1_0_0_0 := Base64.__default.DecodeValid(s#0);
    assume $IsAlloc(##b#1_1_1_0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume Base64.__default.DecodeValid#canCall(s#0) && Base64.__default.Encode#canCall(Base64.__default.DecodeValid(s#0));
    assume true;
    s##1_1_1_0_0_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s##1_1_1_0_0_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s##1_1_1_0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(143,39)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    assume false;
    goto anon22;

  anon35_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(Base64.__default.Encode(Base64.__default.DecodeValid(s#0)), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(149,37): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(150,35): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#0);
    assume Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19152"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19153"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid (correctness)"} {:vcs_split_on_every_assert} Impl$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var b##0_0: Seq;
  var b##1_0_0: Seq;
  var b##1_1_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(151,2): initial state"} true;
    $_reverifyPost := false;
    assume LitInt(3) != 0;
    assume true;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    assume true;
    b##0_0 := b#0;
    call CallPre$$Base64Lemmas.__default.EncodeDecodeValid0(b##0_0);
    call CallPost$$Base64Lemmas.__default.EncodeDecodeValid0(b##0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(153,27)"} true;
    return;

  anon5_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0);
    assume LitInt(3) != 0;
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1);
    assume true;
    b##1_0_0 := b#0;
    call CallPre$$Base64Lemmas.__default.EncodeDecodeValid1(b##1_0_0);
    call CallPost$$Base64Lemmas.__default.EncodeDecodeValid1(b##1_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(156,27)"} true;
    return;

  anon6_Else:
    assume {:partition} Mod(Seq#Length(b#0), LitInt(3)) != LitInt(1);
    assume true;
    b##1_1_0 := b#0;
    call CallPre$$Base64Lemmas.__default.EncodeDecodeValid2(b##1_1_0);
    call CallPost$$Base64Lemmas.__default.EncodeDecodeValid2(b##1_1_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(159,27)"} true;
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid0 (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid0 (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid0", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(163,8): initial state"} true;
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(165,35): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#0);
    assume Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid0 (call precondtion)"} CallPre$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id19167"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid0 (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19168"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid0 (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id19169"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0);
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19170"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid0 (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid0", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(166,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid1 (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid1 (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid1", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(168,8): initial state"} true;
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(170,35): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#0);
    assume Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid1 (call precondtion)"} CallPre$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id19176"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1);



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid1 (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19177"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid1 (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id19178"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1);
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19179"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid1 (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid1", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(171,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid2 (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid2 (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid2", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(173,8): initial state"} true;
    assume LitInt(3) != 0;
    assume Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(175,35): post-state"} true;
    ##b#0 := b#0;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Mod(Seq#Length(##s#0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0) ==> Base64.__default.IsBase64String(##s#0) || (var finalBlockStart#0 := Seq#Length(##s#0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0, finalBlockStart#0)))));
    assume Base64.__default.IsBase64String(##s#0);
    assume Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid2 (call precondtion)"} CallPre$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id19185"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2);



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid2 (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19186"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.EncodeDecodeValid2 (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id19187"} Mod(Seq#Length(b#0), LitInt(3)) == LitInt(2);
  modifies $Heap;
  free ensures Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19188"} Seq#Equal(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)), b#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecodeValid2 (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid2", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(176,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeEncode (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeEncode (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.DecodeEncode(s#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##b#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeEncode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(179,8): initial state"} true;
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(s#0);
    assume Base64.__default.IsBase64String(s#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(181,36): post-state"} true;
    ##s#1 := s#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume Base64.__default.Decode#canCall(s#0);
    assume Wrappers.Result.Success_q(Base64.__default.Decode(s#0));
    ##b#0 := $Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq;
    assume $IsAlloc(##b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
    assume Seq#Equal(Base64.__default.Encode($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.DecodeEncode (call precondtion)"} CallPre$$Base64Lemmas.__default.DecodeEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  requires {:id "id19192"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#0 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0));
  requires {:id "id19193"} Base64.__default.IsBase64String#canCall(s#0) ==> Base64.__default.IsBase64String(s#0) || (var finalBlockStart#0 := Seq#Length(s#0) - 4; Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#0)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#0)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#0)))));



procedure {:verboseName "Base64Lemmas.DecodeEncode (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap));
  modifies $Heap;
  free ensures Base64.__default.Decode#canCall(s#0) && Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
  free ensures {:id "id19194"} Seq#Equal(Base64.__default.Encode($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq), s#0);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.DecodeEncode (correctness)"} Impl$$Base64Lemmas.__default.DecodeEncode(s#0: Seq where $Is(s#0, TSeq(TChar)) && $IsAlloc(s#0, TSeq(TChar), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id19195"} Base64.__default.IsBase64String#canCall(s#0) && Base64.__default.IsBase64String(s#0) && (var finalBlockStart#1 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#1)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#1)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#1))))));
  modifies $Heap;
  free ensures Base64.__default.Decode#canCall(s#0) && Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
  free ensures {:id "id19196"} Seq#Equal(Base64.__default.Encode($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq), s#0);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.DecodeEncode (correctness)"} Impl$$Base64Lemmas.__default.DecodeEncode(s#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##s#0_0_0: Seq;
  var ##b#0_0_0: Seq;
  var s##0_0_0: Seq;
  var ##s#0_0: Seq;
  var ##b#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeEncode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(182,2): initial state"} true;
    $_reverifyPost := false;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0_0 := s#0;
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume Base64.__default.Decode#canCall(s#0);
    assume Wrappers.Result.Success_q(Base64.__default.Decode(s#0));
    ##b#0_0 := $Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq;
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
    assume Base64.__default.Decode#canCall(s#0) && Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
    assume false;
    goto anon3;

  anon4_Else:
    goto anon5_Then, anon5_Else;

  anon5_Then:
    ##s#0_0_0 := s#0;
    assume $IsAlloc(##s#0_0_0, TSeq(TChar), $Heap);
    assume Base64.__default.Decode#canCall(s#0);
    assume Wrappers.Result.Success_q(Base64.__default.Decode(s#0));
    ##b#0_0_0 := $Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq;
    assume $IsAlloc(##b#0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
    assume Base64.__default.Decode#canCall(s#0) && Base64.__default.Encode#canCall($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq);
    assume true;
    s##0_0_0 := s#0;
    call CallPre$$Base64Lemmas.__default.DecodeValidEncode(s##0_0_0);
    call CallPost$$Base64Lemmas.__default.DecodeValidEncode(s##0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(185,29)"} true;
    assume true;
    assume {:subsumption 0} Seq#Equal(Base64.__default.Encode($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq), s#0);
    assume false;
    goto anon3;

  anon5_Else:
    goto anon3;

  anon3:
    assume Seq#Equal(Base64.__default.Encode($Unbox(Wrappers.Result.value(Base64.__default.Decode(s#0))): Seq), s#0);
    return;
}



procedure {:verboseName "Base64Lemmas.EncodeDecode (well-formedness)"} CheckWellFormed$$Base64Lemmas.__default.EncodeDecode(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Base64Lemmas.EncodeDecode (call precondtion)"} CallPre$$Base64Lemmas.__default.EncodeDecode(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "Base64Lemmas.EncodeDecode (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecode(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(Base64.__default.Decode(Base64.__default.Encode(b#0))) && Base64.__default.Encode#canCall(b#0) && Base64.__default.Decode#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19204"} Wrappers.Result#Equal(Base64.__default.Decode(Base64.__default.Encode(b#0)), #Wrappers.Result.Success($Box(b#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "Base64Lemmas.EncodeDecode (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecode(b#0: Seq where $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(b#0, TSeq(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(Base64.__default.Decode(Base64.__default.Encode(b#0))) && Base64.__default.Encode#canCall(b#0) && Base64.__default.Decode#canCall(Base64.__default.Encode(b#0));
  free ensures {:id "id19205"} Wrappers.Result#Equal(Base64.__default.Decode(Base64.__default.Encode(b#0)), #Wrappers.Result.Success($Box(b#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Base64Lemmas.EncodeDecode (correctness)"} Impl$$Base64Lemmas.__default.EncodeDecode(b#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#0_0_0: Seq;
  var ##s#0_0_0: Seq;
  var b##0_0_0: Seq;
  var ##b#0_1_0: Seq;
  var ##s#0_1_0: Seq;
  var ##b#0_1_1: Seq;
  var ##s#0_1_1: Seq;
  var ##b#0_1_2: Seq;
  var ##s#0_1_2: Seq;
  var ##b#0_0: Seq;
  var ##s#0_0: Seq;

  anon0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecode", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(192,2): initial state"} true;
    $_reverifyPost := false;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    ##b#0_0 := b#0;
    assume $IsAlloc(##b#0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0_0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0_0, TSeq(TChar), $Heap);
    assume Base64.__default.Decode#canCall(Base64.__default.Encode(b#0));
    assume Base64.__default.Encode#canCall(b#0) && Base64.__default.Decode#canCall(Base64.__default.Encode(b#0));
    assume false;
    goto anon4;

  anon5_Else:
    goto anon6_Then, anon6_Else;

  anon6_Then:
    ##b#0_1_0 := b#0;
    assume $IsAlloc(##b#0_1_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0_1_0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0_1_0, TSeq(TChar), $Heap);
    assume Base64.__default.Decode#canCall(Base64.__default.Encode(b#0));
    assume Base64.__default.Encode#canCall(b#0) && Base64.__default.Decode#canCall(Base64.__default.Encode(b#0));
    ##b#0_1_1 := b#0;
    assume $IsAlloc(##b#0_1_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0_1_1 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0_1_1, TSeq(TChar), $Heap);
    assume Base64.__default.IsBase64String#canCall(Base64.__default.Encode(b#0));
    assume Base64.__default.Encode#canCall(b#0) && Base64.__default.IsBase64String#canCall(Base64.__default.Encode(b#0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(Base64.__default.Encode(b#0)) ==> Base64.__default.IsBase64String(Base64.__default.Encode(b#0)) || (var finalBlockStart#0_1_0 := Seq#Length(Base64.__default.Encode(b#0)) - 4; Mod(Seq#Length(Base64.__default.Encode(b#0)), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(Base64.__default.Encode(b#0)) ==> Base64.__default.IsBase64String(Base64.__default.Encode(b#0)) || (var finalBlockStart#0_1_0 := Seq#Length(Base64.__default.Encode(b#0)) - 4; Base64.__default.IsUnpaddedBase64String(Base64.__default.Encode(b#0)) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(Base64.__default.Encode(b#0), finalBlockStart#0_1_0)) && (Base64.__default.Is1Padding(Seq#Drop(Base64.__default.Encode(b#0), finalBlockStart#0_1_0)) || Base64.__default.Is2Padding(Seq#Drop(Base64.__default.Encode(b#0), finalBlockStart#0_1_0)))));
    assume Base64.__default.IsBase64String(Base64.__default.Encode(b#0));
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(195,41)"} true;
    ##b#0_1_2 := b#0;
    assume $IsAlloc(##b#0_1_2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0_1_2 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0_1_2, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_1_2) ==> Base64.__default.IsBase64String(##s#0_1_2) || (var finalBlockStart#0_1_1 := Seq#Length(##s#0_1_2) - 4; Mod(Seq#Length(##s#0_1_2), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_1_2) ==> Base64.__default.IsBase64String(##s#0_1_2) || (var finalBlockStart#0_1_1 := Seq#Length(##s#0_1_2) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_1_2) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_1_2, finalBlockStart#0_1_1)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_1_2, finalBlockStart#0_1_1)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_1_2, finalBlockStart#0_1_1)))));
    assume Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume {:subsumption 0} Wrappers.Result#Equal(Base64.__default.Decode(Base64.__default.Encode(b#0)), #Wrappers.Result.Success($Box(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)))));
    assume false;
    goto anon4;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    ##b#0_0_0 := b#0;
    assume $IsAlloc(##b#0_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume Base64.__default.Encode#canCall(b#0);
    ##s#0_0_0 := Base64.__default.Encode(b#0);
    assume $IsAlloc(##s#0_0_0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0_0) ==> Base64.__default.IsBase64String(##s#0_0_0) || (var finalBlockStart#0_0_0 := Seq#Length(##s#0_0_0) - 4; Mod(Seq#Length(##s#0_0_0), LitInt(4)) == LitInt(0));
    assume {:subsumption 0} Base64.__default.IsBase64String#canCall(##s#0_0_0) ==> Base64.__default.IsBase64String(##s#0_0_0) || (var finalBlockStart#0_0_0 := Seq#Length(##s#0_0_0) - 4; Base64.__default.IsUnpaddedBase64String(##s#0_0_0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(##s#0_0_0, finalBlockStart#0_0_0)) && (Base64.__default.Is1Padding(Seq#Drop(##s#0_0_0, finalBlockStart#0_0_0)) || Base64.__default.Is2Padding(Seq#Drop(##s#0_0_0, finalBlockStart#0_0_0)))));
    assume Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume Base64.__default.Encode#canCall(b#0) && Base64.__default.DecodeValid#canCall(Base64.__default.Encode(b#0));
    assume true;
    b##0_0_0 := b#0;
    call CallPre$$Base64Lemmas.__default.EncodeDecodeValid(b##0_0_0);
    call CallPost$$Base64Lemmas.__default.EncodeDecodeValid(b##0_0_0);
    assume {:captureState "StandardLibrary/src/Base64Lemmas.dfy(197,29)"} true;
    assume true;
    assume {:subsumption 0} Wrappers.Result#Equal(#Wrappers.Result.Success($Box(Base64.__default.DecodeValid(Base64.__default.Encode(b#0)))), #Wrappers.Result.Success($Box(b#0)));
    assume false;
    goto anon4;

  anon7_Else:
    goto anon4;

  anon4:
    assume Wrappers.Result#Equal(Base64.__default.Decode(Base64.__default.Encode(b#0)), #Wrappers.Result.Success($Box(b#0)));
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#124 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#124))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#126 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#126)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#186 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#186))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#188 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#188)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#190 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#190)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#186 := Wrappers.Option.value(this); v#186)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#188 := Lit(Wrappers.Option.value(Lit(this))); v#188)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#190 := Lit(Wrappers.Option.value(Lit(this))); v#190)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#124 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#124)) else (var e#124 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#126 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#126))) else (var e#126 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#186 := Wrappers.Result.value(this); s#186) else (var e#186 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#188 := Lit(Wrappers.Result.value(Lit(this))); s#188) else (var e#188 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#190 := Lit(Wrappers.Result.value(Lit(this))); s#190) else (var e#190 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#186 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#186)) else (var e#186 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#186)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#188 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#188))) else (var e#188 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#188)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#190 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#190))) else (var e#190 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#190)))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(x#0) == (var b0#44 := Div(x#0, LitInt(256)); (var b1#44 := Mod(x#0, LitInt(256)); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#44)), $Box(b1#44)))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt16ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> StandardLibrary_mUInt.__default.UInt16ToSeq(LitInt(x#0)) == (var b0#45 := LitInt(Div(x#0, LitInt(256))); (var b1#45 := LitInt(Mod(x#0, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#45)), $Box(b1#45))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt16(s#0) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(s#0) == (var x0#44 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(256)); x0#44 + $Unbox(Seq#Index(s#0, LitInt(1))): int));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt16#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> StandardLibrary_mUInt.__default.SeqToUInt16(Lit(s#0)) == (var x0#45 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(256)); x0#45 + $Unbox(Seq#Index(Lit(s#0), LitInt(1))): int));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(x#0) == (var b0#44 := Div(x#0, LitInt(16777216)); (var x0#44 := x#0 - Mul(b0#44, LitInt(16777216)); (var b1#44 := Div(x0#44, LitInt(65536)); (var x1#44 := x0#44 - Mul(b1#44, LitInt(65536)); (var b2#44 := Div(x1#44, LitInt(256)); (var b3#44 := Mod(x1#44, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#44)), $Box(b1#44)), $Box(b2#44)), $Box(b3#44)))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt32ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> StandardLibrary_mUInt.__default.UInt32ToSeq(LitInt(x#0)) == (var b0#45 := LitInt(Div(x#0, LitInt(16777216))); (var x0#45 := LitInt(x#0 - Mul(b0#45, LitInt(16777216))); (var b1#45 := LitInt(Div(x0#45, LitInt(65536))); (var x1#45 := LitInt(x0#45 - Mul(b1#45, LitInt(65536))); (var b2#45 := LitInt(Div(x1#45, LitInt(256))); (var b3#45 := LitInt(Mod(x1#45, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#45)), $Box(b1#45)), $Box(b2#45)), $Box(b3#45))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt32(s#0) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(s#0) == (var x0#44 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(16777216)); (var x1#44 := x0#44 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(65536)); (var x2#44 := x1#44 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(256)); x2#44 + $Unbox(Seq#Index(s#0, LitInt(3))): int))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt32#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> StandardLibrary_mUInt.__default.SeqToUInt32(Lit(s#0)) == (var x0#45 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(16777216)); (var x1#45 := x0#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(65536)); (var x2#45 := x1#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(256)); x2#45 + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int))));

axiom (forall x#0: int :: { StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(x#0) == (var b0#44 := Div(x#0, LitInt(72057594037927936)); (var x0#44 := x#0 - Mul(b0#44, LitInt(72057594037927936)); (var b1#44 := Div(x0#44, LitInt(281474976710656)); (var x1#44 := x0#44 - Mul(b1#44, LitInt(281474976710656)); (var b2#44 := Div(x1#44, LitInt(1099511627776)); (var x2#44 := x1#44 - Mul(b2#44, LitInt(1099511627776)); (var b3#44 := Div(x2#44, LitInt(4294967296)); (var x3#44 := x2#44 - Mul(b3#44, LitInt(4294967296)); (var b4#44 := Div(x3#44, LitInt(16777216)); (var x4#44 := x3#44 - Mul(b4#44, LitInt(16777216)); (var b5#44 := Div(x4#44, LitInt(65536)); (var x5#44 := x4#44 - Mul(b5#44, LitInt(65536)); (var b6#44 := Div(x5#44, LitInt(256)); (var b7#44 := Mod(x5#44, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#44)), $Box(b1#44)), $Box(b2#44)), $Box(b3#44)), $Box(b4#44)), $Box(b5#44)), $Box(b6#44)), $Box(b7#44)))))))))))))))));

axiom (forall x#0: int :: {:weight 3} { StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) } StandardLibrary_mUInt.__default.UInt64ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < BoundedInts.__default.TWO__TO__THE__64()) ==> StandardLibrary_mUInt.__default.UInt64ToSeq(LitInt(x#0)) == (var b0#45 := LitInt(Div(x#0, LitInt(72057594037927936))); (var x0#45 := LitInt(x#0 - Mul(b0#45, LitInt(72057594037927936))); (var b1#45 := LitInt(Div(x0#45, LitInt(281474976710656))); (var x1#45 := LitInt(x0#45 - Mul(b1#45, LitInt(281474976710656))); (var b2#45 := LitInt(Div(x1#45, LitInt(1099511627776))); (var x2#45 := LitInt(x1#45 - Mul(b2#45, LitInt(1099511627776))); (var b3#45 := LitInt(Div(x2#45, LitInt(4294967296))); (var x3#45 := LitInt(x2#45 - Mul(b3#45, LitInt(4294967296))); (var b4#45 := LitInt(Div(x3#45, LitInt(16777216))); (var x4#45 := LitInt(x3#45 - Mul(b4#45, LitInt(16777216))); (var b5#45 := LitInt(Div(x4#45, LitInt(65536))); (var x5#45 := LitInt(x4#45 - Mul(b5#45, LitInt(65536))); (var b6#45 := LitInt(Div(x5#45, LitInt(256))); (var b7#45 := LitInt(Mod(x5#45, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#45)), $Box(b1#45)), $Box(b2#45)), $Box(b3#45)), $Box(b4#45)), $Box(b5#45)), $Box(b6#45)), $Box(b7#45))))))))))))))))));

axiom (forall s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToUInt64(s#0) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(s#0) == (var x0#44 := Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(72057594037927936)); (var x1#44 := x0#44 + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(281474976710656)); (var x2#44 := x1#44 + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(1099511627776)); (var x3#44 := x2#44 + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(4294967296)); (var x4#44 := x3#44 + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(16777216)); (var x5#44 := x4#44 + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(65536)); (var x6#44 := x5#44 + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(256)); (var x#45 := x6#44 + $Unbox(Seq#Index(s#0, LitInt(7))): int; x#45)))))))));

axiom (forall s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToUInt64#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(8)) ==> StandardLibrary_mUInt.__default.SeqToUInt64(Lit(s#0)) == (var x0#45 := Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(72057594037927936)); (var x1#45 := x0#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(281474976710656)); (var x2#45 := x1#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(1099511627776)); (var x3#45 := x2#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(4294967296)); (var x4#45 := x3#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(16777216)); (var x5#45 := x4#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(65536)); (var x6#45 := x5#45 + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(256)); (var x#46 := x6#45 + $Unbox(Seq#Index(Lit(s#0), LitInt(7))): int; x#46)))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) } StandardLibrary_mUInt.__default.SeqToNat#canCall(s#0) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#44 := Seq#Length(s#0) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(s#0, finalIndex#44)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#44 := Seq#Length(s#0) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($ly, Seq#Take(s#0, finalIndex#44)), LitInt(256)) + $Unbox(Seq#Index(s#0, finalIndex#44)): int)));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) } StandardLibrary_mUInt.__default.SeqToNat#canCall(Lit(s#0)) || $Is(s#0, TSeq(Tclass.BoundedInts.uint8())) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalIndex#45 := Seq#Length(Lit(s#0)) - 1; StandardLibrary_mUInt.__default.SeqToNat#canCall(Seq#Take(Lit(s#0), finalIndex#45)))) && StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then 0 else (var finalIndex#45 := Seq#Length(Lit(s#0)) - 1; Mul(StandardLibrary_mUInt.__default.SeqToNat($LS($ly), Seq#Take(Lit(s#0), finalIndex#45)), LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), finalIndex#45)): int)));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> (!Seq#Contains(s#0, delim#0) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(s#0)))) && (Seq#Equal(s#0, Seq#Empty(): Seq) ==> Seq#Equal(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Empty(): Seq))))) && 0 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) && (forall i#38: int :: { $Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#38)): Seq } LitInt(0) <= i#38 && i#38 < Seq#Length(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0)) ==> !Seq#Contains($Unbox(Seq#Index(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), i#38)): Seq, delim#0)) && Seq#Equal(StandardLibrary.__default.Join(StandardLibrary._default.Split$T, $LS($LZ), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), Seq#Build(Seq#Empty(): Seq, delim#0)), s#0) && $Is(StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, s#0, delim#0), TSeq(TSeq(StandardLibrary._default.Split$T))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)) && (var i#39 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); Wrappers.Option.Some_q(i#39) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#39)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), s#0, delim#0) == (var i#39 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#39) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#39)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $ly, Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#39)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(s#0)))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)) && (var i#40 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.Some_q(i#40) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#40)): int + 1), delim#0)) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), delim#0) == (var i#40 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.Some_q(i#40) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#40)): int))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#40)): int + 1), delim#0)) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.Split$T: Ty, $ly: LayerType, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.Split$T)) && $IsBox(delim#0, StandardLibrary._default.Split$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var i#41 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.Some_q(i#41) ==> StandardLibrary.__default.Split#canCall(StandardLibrary._default.Split$T, Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#41)): int + 1), Lit(delim#0))) && StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(s#0), Lit(delim#0)) == (var i#41 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.Split$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.Some_q(i#41) then Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#41)): int))))), StandardLibrary.__default.Split(StandardLibrary._default.Split$T, $LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#41)): int + 1))), Lit(delim#0))) else Seq#Build(Seq#Empty(): Seq, $Box(Lit(s#0))))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, s#0, delim#0) == (var i#27 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, s#0, delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(s#0, $Unbox(Wrappers.Option.value(i#27)): int)), $Box(Seq#Drop(s#0, $Unbox(Wrappers.Option.value(i#27)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0) == (var i#28 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), delim#0, LitInt(0)); #_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), $Unbox(Wrappers.Option.value(i#28)): int)), $Box(Seq#Drop(Lit(s#0), $Unbox(Wrappers.Option.value(i#28)): int + 1)))));

axiom (forall StandardLibrary._default.SplitOnce$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce$T) && Seq#Contains(s#0, delim#0)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0)) && StandardLibrary.__default.SplitOnce(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0)) == (var i#29 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce$T, Lit(s#0), Lit(delim#0), LitInt(0))); Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#29)): int)))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt($Unbox(Wrappers.Option.value(i#29)): int + 1))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)) && (var valueOrError0#27 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#27) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#27) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#27)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#27) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#27))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, s#0, delim#0) == (var valueOrError0#27 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, s#0, delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#27) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#27) else (var i#27 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#27)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(s#0, i#27)), $Box(Seq#Drop(s#0, i#27 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)) && (var valueOrError0#28 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#28) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#28) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#28)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#28) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#28))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0) == (var valueOrError0#28 := StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), delim#0, LitInt(0)); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#28) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#28) else (var i#28 := $Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#28)): int; #Wrappers.Option.Some($Box(#_System._tuple#2._#Make2($Box(Seq#Take(Lit(s#0), i#28)), $Box(Seq#Drop(Lit(s#0), i#28 + 1)))))))));

axiom (forall StandardLibrary._default.SplitOnce?$T: Ty, s#0: Seq, delim#0: Box :: {:weight 3} { StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) } StandardLibrary.__default.SplitOnce_q#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) || ($Is(s#0, TSeq(StandardLibrary._default.SplitOnce?$T)) && $IsBox(delim#0, StandardLibrary._default.SplitOnce?$T)) ==> StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0)) && (var valueOrError0#29 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); Wrappers.Option.IsFailure#canCall(Tclass._System.nat(), valueOrError0#29) && (Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#29) ==> Wrappers.Option.PropagateFailure#canCall(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#29)) && (!Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#29) ==> Wrappers.Option.Extract#canCall(Tclass._System.nat(), valueOrError0#29))) && StandardLibrary.__default.SplitOnce_q(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0)) == (var valueOrError0#29 := Lit(StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.SplitOnce?$T, Lit(s#0), Lit(delim#0), LitInt(0))); (if Wrappers.Option.IsFailure(Tclass._System.nat(), valueOrError0#29) then Wrappers.Option.PropagateFailure(Tclass._System.nat(), Tclass._System.Tuple2(TSeq(StandardLibrary._default.SplitOnce?$T), TSeq(StandardLibrary._default.SplitOnce?$T)), valueOrError0#29) else (var i#29 := LitInt($Unbox(Wrappers.Option.Extract(Tclass._System.nat(), valueOrError0#29)): int); Lit(#Wrappers.Option.Some($Box(Lit(#_System._tuple#2._#Make2($Box(Lit(Seq#Take(Lit(s#0), i#29))), $Box(Lit(Seq#Drop(Lit(s#0), LitInt(i#29 + 1)))))))))))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, s#0, Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#x#0: Box :: $Box($l#90#x#0 == c#0)), (lambda $l#90#heap#0: Heap, $l#90#x#0: Box :: $IsBox($l#90#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#90#heap#0: Heap, $l#90#x#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ))), i#0) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, s#0, c#0, i#0) == StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), s#0, Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#x#0: Box :: $Box($l#88#x#0 == c#0)), (lambda $l#88#heap#0: Heap, $l#88#x#0: Box :: $IsBox($l#88#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#88#heap#0: Heap, $l#88#x#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ))), i#0));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#x#0: Box :: $Box($l#93#x#0 == c#0)), (lambda $l#93#heap#0: Heap, $l#93#x#0: Box :: $IsBox($l#93#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#93#heap#0: Heap, $l#93#x#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), c#0, LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#x#0: Box :: $Box($l#91#x#0 == c#0)), (lambda $l#91#heap#0: Heap, $l#91#x#0: Box :: $IsBox($l#91#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#91#heap#0: Heap, $l#91#x#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndexMatching$T: Ty, s#0: Seq, c#0: Box, i#0: int :: {:weight 3} { StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) } StandardLibrary.__default.FindIndexMatching#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) || ($Is(s#0, TSeq(StandardLibrary._default.FindIndexMatching$T)) && $IsBox(c#0, StandardLibrary._default.FindIndexMatching$T) && LitInt(0) <= i#0 && LitInt(i#0) <= Seq#Length(Lit(s#0))) ==> StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(AtLayer((lambda $l#96#ly#0: LayerType :: Handle1((lambda $l#96#heap#0: Heap, $l#96#x#0: Box :: $Box($l#96#x#0 == Lit(c#0))), (lambda $l#96#heap#0: Heap, $l#96#x#0: Box :: $IsBox($l#96#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#96#heap#0: Heap, $l#96#x#0: Box :: SetRef_to_SetBox((lambda $l#96#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0)) && StandardLibrary.__default.FindIndexMatching(StandardLibrary._default.FindIndexMatching$T, Lit(s#0), Lit(c#0), LitInt(i#0)) == Lit(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndexMatching$T, $LS($LZ), Lit(s#0), Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#x#0: Box :: $Box($l#94#x#0 == Lit(c#0))), (lambda $l#94#heap#0: Heap, $l#94#x#0: Box :: $IsBox($l#94#x#0, StandardLibrary._default.FindIndexMatching$T)), (lambda $l#94#heap#0: Heap, $l#94#x#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ))), LitInt(i#0))));

axiom (forall StandardLibrary._default.FindIndex$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType, i#0: int :: { StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), $IsGoodHeap($Heap) } StandardLibrary.__default.FindIndex#canCall(StandardLibrary._default.FindIndex$T, s#0, f#0, i#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.FindIndex$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.FindIndex$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.FindIndex$T, TBool), $Heap) && LitInt(0) <= i#0 && i#0 <= Seq#Length(s#0)) ==> (Wrappers.Option.Some_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> i#0 <= $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int && $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int))): bool && (forall j#22: int :: { Seq#Index(s#0, j#22) } i#0 <= j#22 && j#22 < $Unbox(Wrappers.Option.value(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0))): int ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#22))): bool)) && (Wrappers.Option.None_q(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0)) ==> (forall j#23: int :: { Seq#Index(s#0, j#23) } i#0 <= j#23 && j#23 < Seq#Length(s#0) ==> !$Unbox(Apply1(StandardLibrary._default.FindIndex$T, TBool, $Heap, f#0, Seq#Index(s#0, j#23))): bool)) && $Is(StandardLibrary.__default.FindIndex(StandardLibrary._default.FindIndex$T, $ly, s#0, f#0, i#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall StandardLibrary._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Seq, f#0: HandleType :: { StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Filter#canCall(StandardLibrary._default.Filter$T, s#0, f#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(StandardLibrary._default.Filter$T)) && $IsAlloc(s#0, TSeq(StandardLibrary._default.Filter$T), $Heap) && $Is(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hTotalFunc1(StandardLibrary._default.Filter$T, TBool), $Heap)) ==> (forall i#22: int :: { Seq#Index(s#0, i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(s#0) && $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(s#0, i#22))): bool ==> Seq#Contains(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), Seq#Index(s#0, i#22))) && (forall i#23: int :: { Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#23) } (LitInt(0) <= i#23 && i#23 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> Seq#Contains(s#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#23))) && (LitInt(0) <= i#23 && i#23 < Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) ==> $Unbox(Apply1(StandardLibrary._default.Filter$T, TBool, $Heap, f#0, Seq#Index(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), i#23))): bool)) && Seq#Length(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0)) <= Seq#Length(s#0) && $Is(StandardLibrary.__default.Filter(StandardLibrary._default.Filter$T, $ly, s#0, f#0), TSeq(StandardLibrary._default.Filter$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> Seq#Length(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0)) == n#0 && (forall i#11: int :: { Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#11) } LitInt(0) <= i#11 && i#11 < n#0 ==> Seq#Index(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), i#11) == value#0) && $Is(StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), TSeq(StandardLibrary._default.Fill$T)));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, n#0) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, n#0) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, n#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#_v0#0: Box :: value#0), (lambda $l#58#heap#0: Heap, $l#58#_v0#0: Box :: $IsBox($l#58#_v0#0, TInt)), (lambda $l#58#heap#0: Heap, $l#58#_v0#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, value#0, LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#_v0#0: Box :: value#0), (lambda $l#60#heap#0: Heap, $l#60#_v0#0: Box :: $IsBox($l#60#_v0#0, TInt)), (lambda $l#60#heap#0: Heap, $l#60#_v0#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.Fill$T: Ty, $Heap: Heap, value#0: Box, n#0: int :: {:weight 3} { StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Fill#canCall(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) || ($IsGoodHeap($Heap) && $IsBox(value#0, StandardLibrary._default.Fill$T) && LitInt(0) <= n#0) ==> StandardLibrary.__default.Fill(StandardLibrary._default.Fill$T, Lit(value#0), LitInt(n#0)) == Seq#Create(StandardLibrary._default.Fill$T, $Heap, LitInt(n#0), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#_v0#0: Box :: Lit(value#0)), (lambda $l#62#heap#0: Heap, $l#62#_v0#0: Box :: $IsBox($l#62#_v0#0, TInt)), (lambda $l#62#heap#0: Heap, $l#62#_v0#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#29: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#29) } LitInt(0) <= k#29 ==> k#29 <= Seq#Length(a#0) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#29)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0) <==> (exists k#29: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#29) } LitInt(0) <= k#29 && k#29 <= Seq#Length(a#0) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#29))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#30: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#30) } LitInt(0) <= k#30 ==> k#30 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#30)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0) <==> (exists k#30: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#30) } LitInt(0) <= k#30 && k#30 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), less#0, k#30))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqual$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) } StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqual$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqual$T, StandardLibrary._default.LexicographicLessOrEqual$T, TBool))) ==> (forall k#31: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#31) } LitInt(0) <= k#31 ==> k#31 <= Seq#Length(Lit(a#0)) ==> StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#31)) && (StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0)) <==> (exists k#31: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, a#0, b#0, less#0, k#31) } LitInt(0) <= k#31 && k#31 <= Seq#Length(Lit(a#0)) && StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqual$T, Lit(a#0), Lit(b#0), Lit(less#0), k#31))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= lengthOfCommonPrefix#0 && lengthOfCommonPrefix#0 <= Seq#Length(a#0)) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, a#0, b#0, less#0, lengthOfCommonPrefix#0) <==> lengthOfCommonPrefix#0 <= Seq#Length(b#0) && (forall i#29: int :: { Seq#Index(b#0, i#29) } { Seq#Index(a#0, i#29) } LitInt(0) <= i#29 && i#29 < lengthOfCommonPrefix#0 ==> Seq#Index(a#0, i#29) == Seq#Index(b#0, i#29)) && (lengthOfCommonPrefix#0 == Seq#Length(a#0) || (lengthOfCommonPrefix#0 < Seq#Length(b#0) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(a#0, lengthOfCommonPrefix#0), Seq#Index(b#0, lengthOfCommonPrefix#0))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), less#0, LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#30: int :: { Seq#Index(b#0, i#30) } { Seq#Index(a#0, i#30) } LitInt(0) <= i#30 && i#30 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#30) == Seq#Index(Lit(b#0), i#30)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, less#0, Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.LexicographicLessOrEqualAux$T: Ty, $Heap: Heap, a#0: Seq, b#0: Seq, less#0: HandleType, lengthOfCommonPrefix#0: int :: {:weight 3} { StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.LexicographicLessOrEqualAux#canCall(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(b#0, TSeq(StandardLibrary._default.LexicographicLessOrEqualAux$T)) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool)) && LitInt(0) <= lengthOfCommonPrefix#0 && LitInt(0) <= LitInt(lengthOfCommonPrefix#0) && LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(a#0))) ==> (StandardLibrary.__default.LexicographicLessOrEqualAux(StandardLibrary._default.LexicographicLessOrEqualAux$T, Lit(a#0), Lit(b#0), Lit(less#0), LitInt(lengthOfCommonPrefix#0)) <==> LitInt(lengthOfCommonPrefix#0) <= Seq#Length(Lit(b#0)) && (forall i#31: int :: { Seq#Index(b#0, i#31) } { Seq#Index(a#0, i#31) } LitInt(0) <= i#31 && i#31 < lengthOfCommonPrefix#0 ==> Seq#Index(Lit(a#0), i#31) == Seq#Index(Lit(b#0), i#31)) && (LitInt(lengthOfCommonPrefix#0) == Seq#Length(Lit(a#0)) || (lengthOfCommonPrefix#0 < Seq#Length(Lit(b#0)) && $Unbox(Apply2(StandardLibrary._default.LexicographicLessOrEqualAux$T, StandardLibrary._default.LexicographicLessOrEqualAux$T, TBool, $Heap, Lit(less#0), Seq#Index(Lit(a#0), LitInt(lengthOfCommonPrefix#0)), Seq#Index(Lit(b#0), LitInt(lengthOfCommonPrefix#0)))): bool))));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, less#0) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, less#0) <==> (forall x#60: Box, y#60: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#60, x#60)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#60, y#60)): bool } $IsBox(x#60, StandardLibrary._default.Trichotomous$T) && $IsBox(y#60, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#60, y#60)): bool || x#60 == y#60 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#60, x#60)): bool) && (forall x#61: Box, y#61: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#61, x#61)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#61, y#61)): bool } $IsBox(x#61, StandardLibrary._default.Trichotomous$T) && $IsBox(y#61, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#61, y#61)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#61, x#61)): bool ==> false) && (forall x#62: Box, y#62: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#62, y#62)): bool } $IsBox(x#62, StandardLibrary._default.Trichotomous$T) && $IsBox(y#62, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#62, y#62)): bool ==> x#62 != y#62)));

axiom (forall StandardLibrary._default.Trichotomous$T: Ty, $Heap: Heap, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Trichotomous#canCall(StandardLibrary._default.Trichotomous$T, Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool))) ==> (StandardLibrary.__default.Trichotomous(StandardLibrary._default.Trichotomous$T, Lit(less#0)) <==> (forall x#63: Box, y#63: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#63, x#63)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#63, y#63)): bool } $IsBox(x#63, StandardLibrary._default.Trichotomous$T) && $IsBox(y#63, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#63, y#63)): bool || x#63 == y#63 || $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#63, x#63)): bool) && (forall x#64: Box, y#64: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, y#64, x#64)): bool } { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#64, y#64)): bool } $IsBox(x#64, StandardLibrary._default.Trichotomous$T) && $IsBox(y#64, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#64, y#64)): bool && $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), y#64, x#64)): bool ==> false) && (forall x#65: Box, y#65: Box :: { $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, less#0, x#65, y#65)): bool } $IsBox(x#65, StandardLibrary._default.Trichotomous$T) && $IsBox(y#65, StandardLibrary._default.Trichotomous$T) ==> $Unbox(Apply2(StandardLibrary._default.Trichotomous$T, StandardLibrary._default.Trichotomous$T, TBool, $Heap, Lit(less#0), x#65, y#65)): bool ==> x#65 != y#65)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, R#0) <==> (forall x#20: Box, y#20: Box, z#20: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#20, z#20)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#20, z#20)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#20, z#20)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#20, y#20)): bool } $IsBox(x#20, StandardLibrary._default.Transitive$T) && $IsBox(y#20, StandardLibrary._default.Transitive$T) && $IsBox(z#20, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#20, y#20)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#20, z#20)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#20, z#20)): bool)));

axiom (forall StandardLibrary._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.Transitive#canCall(StandardLibrary._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool))) ==> (StandardLibrary.__default.Transitive(StandardLibrary._default.Transitive$T, Lit(R#0)) <==> (forall x#21: Box, y#21: Box, z#21: Box :: { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#21, z#21)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#21, z#21)): bool } { $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, y#21, z#21)): bool, $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, R#0, x#21, y#21)): bool } $IsBox(x#21, StandardLibrary._default.Transitive$T) && $IsBox(y#21, StandardLibrary._default.Transitive$T) && $IsBox(z#21, StandardLibrary._default.Transitive$T) ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#21, y#21)): bool && $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), y#21, z#21)): bool ==> $Unbox(Apply2(StandardLibrary._default.Transitive$T, StandardLibrary._default.Transitive$T, TBool, $Heap, Lit(R#0), x#21, z#21)): bool)));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> Set#Card(s#0) == Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) && (forall i#33: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#33)): Seq } LitInt(0) <= i#33 && i#33 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> s#0[Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#33)]) && (forall k#11: Seq :: { Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#11)) } { s#0[$Box(k#11)] } $Is(k#11, TSeq(StandardLibrary._default.SetToOrderedSequence$T)) ==> s#0[$Box(k#11)] ==> Seq#Contains(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), $Box(k#11))) && (forall i#34: int, _t#0#10: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#34)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#10)): Seq } _t#0#10 == i#34 - 1 ==> 0 < i#34 && i#34 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.SetToOrderedSequence$T, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), _t#0#10)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#34)): Seq, less#0)) && (forall i#35: int, j#11: int :: { $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#11)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#35)): Seq } LitInt(0) <= i#35 && i#35 < j#11 && j#11 < Seq#Length(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0)) ==> !Seq#Equal($Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), i#35)): Seq, $Unbox(Seq#Index(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), j#11)): Seq)) && $Is(StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, s#0, less#0), TSeq(TSeq(StandardLibrary._default.SetToOrderedSequence$T))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), s#0, less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#32 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, s#0, less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#32)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $ly, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#32))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, less#0) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, less#0)) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0)))), less#0)) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), less#0) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#33 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), less#0); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#33)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#33))), less#0)))));

axiom (forall StandardLibrary._default.SetToOrderedSequence$T: Ty, $ly: LayerType, $Heap: Heap, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)), $IsGoodHeap($Heap) } StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(StandardLibrary._default.SetToOrderedSequence$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.SetToOrderedSequence$T, StandardLibrary._default.SetToOrderedSequence$T, TBool)) && Lit(StandardLibrary.__default.Trichotomous(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)) && StandardLibrary.__default.Transitive(StandardLibrary._default.SetToOrderedSequence$T, Lit(less#0)))) ==> (!Set#Equal(s#0, Set#Empty(): Set) ==> $let#0$canCall(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)) && StandardLibrary.__default.SetToOrderedSequence#canCall(StandardLibrary._default.SetToOrderedSequence$T, Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box($let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0))))), Lit(less#0))) && StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Lit(s#0), Lit(less#0)) == (if Set#Equal(s#0, Set#Empty(): Set) then Seq#Empty(): Seq else (var a#34 := $let#0_a(StandardLibrary._default.SetToOrderedSequence$T, Lit(s#0), Lit(less#0)); Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(a#34)), StandardLibrary.__default.SetToOrderedSequence(StandardLibrary._default.SetToOrderedSequence$T, $LS($ly), Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set, $Box(a#34))), Lit(less#0))))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (s#0[$Box(a#0)] ==> (forall z#29: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#29, less#0) } { s#0[$Box(z#29)] } $Is(z#29, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#29)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, a#0, z#29, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, a#0, s#0, less#0) <==> s#0[$Box(a#0)] && (forall z#29: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#29, less#0) } { s#0[$Box(z#29)] } $Is(z#29, TSeq(StandardLibrary._default.IsMinimum$T)) ==> s#0[$Box(z#29)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#29, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#30: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#30, less#0) } { s#0[$Box(z#30)] } $Is(z#30, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#30)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#30, less#0))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), less#0) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#30: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#30, less#0) } { s#0[$Box(z#30)] } $Is(z#30, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#30)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#30, less#0))));

axiom (forall StandardLibrary._default.IsMinimum$T: Ty, a#0: Seq, s#0: Set, less#0: HandleType :: {:weight 3} { StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) } StandardLibrary.__default.IsMinimum#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) || ($Is(a#0, TSeq(StandardLibrary._default.IsMinimum$T)) && $Is(s#0, TSet(TSeq(StandardLibrary._default.IsMinimum$T))) && $Is(less#0, Tclass._System.___hTotalFunc2(StandardLibrary._default.IsMinimum$T, StandardLibrary._default.IsMinimum$T, TBool))) ==> (Lit(s#0)[$Box(Lit(a#0))] ==> (forall z#31: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#31, less#0) } { s#0[$Box(z#31)] } $Is(z#31, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#31)] ==> StandardLibrary.__default.LexicographicLessOrEqual#canCall(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#31, Lit(less#0)))) && (StandardLibrary.__default.IsMinimum(StandardLibrary._default.IsMinimum$T, Lit(a#0), Lit(s#0), Lit(less#0)) <==> Lit(s#0)[$Box(Lit(a#0))] && (forall z#31: Seq :: { StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, a#0, z#31, less#0) } { s#0[$Box(z#31)] } $Is(z#31, TSeq(StandardLibrary._default.IsMinimum$T)) ==> Lit(s#0)[$Box(z#31)] ==> StandardLibrary.__default.LexicographicLessOrEqual(StandardLibrary._default.IsMinimum$T, Lit(a#0), z#31, Lit(less#0)))));

axiom (forall c#0: char :: { Base64.__default.IsBase64Char(c#0) } Base64.__default.IsBase64Char#canCall(c#0) || $Is(c#0, TChar) ==> (Base64.__default.IsBase64Char(c#0) <==> c#0 == Lit(char#FromInt(43)) || c#0 == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122))))));

axiom (forall c#0: char :: {:weight 3} { Base64.__default.IsBase64Char(Lit(c#0)) } Base64.__default.IsBase64Char#canCall(Lit(c#0)) || $Is(c#0, TChar) ==> (Base64.__default.IsBase64Char(Lit(c#0)) <==> Lit(c#0) == Lit(char#FromInt(43)) || Lit(c#0) == Lit(char#FromInt(47)) || (char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(57)))) || (char#ToInt(Lit(char#FromInt(65))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(90)))) || (char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(122))))));

axiom (forall s#0: Seq :: { Base64.__default.IsUnpaddedBase64String(s#0) } Base64.__default.IsUnpaddedBase64String#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) ==> (forall k#4: char :: { Base64.__default.IsBase64Char(k#4) } { Seq#Contains(s#0, $Box(k#4)) } $Is(k#4, TChar) ==> Seq#Contains(s#0, $Box(k#4)) ==> Base64.__default.IsBase64Char#canCall(k#4))) && (Base64.__default.IsUnpaddedBase64String(s#0) <==> Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (forall k#4: char :: { Base64.__default.IsBase64Char(k#4) } { Seq#Contains(s#0, $Box(k#4)) } $Is(k#4, TChar) ==> Seq#Contains(s#0, $Box(k#4)) ==> Base64.__default.IsBase64Char(k#4))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.IsUnpaddedBase64String(Lit(s#0)) } Base64.__default.IsUnpaddedBase64String#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) ==> (forall k#5: char :: { Base64.__default.IsBase64Char(k#5) } { Seq#Contains(s#0, $Box(k#5)) } $Is(k#5, TChar) ==> Seq#Contains(s#0, $Box(k#5)) ==> Base64.__default.IsBase64Char#canCall(k#5))) && (Base64.__default.IsUnpaddedBase64String(Lit(s#0)) <==> Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) && (forall k#5: char :: { Base64.__default.IsBase64Char(k#5) } { Seq#Contains(s#0, $Box(k#5)) } $Is(k#5, TChar) ==> Seq#Contains(s#0, $Box(k#5)) ==> Base64.__default.IsBase64Char(k#5))));

axiom (forall i#0: int :: { Base64.__default.IndexToChar(i#0) } Base64.__default.IndexToChar#canCall(i#0) || (LitInt(0) <= i#0 && i#0 < 64) ==> Base64.__default.IsBase64Char(Base64.__default.IndexToChar(i#0)) && $Is(Base64.__default.IndexToChar(i#0), TChar));

axiom (forall i#0: int :: { Base64.__default.IndexToChar(i#0) } Base64.__default.IndexToChar#canCall(i#0) || (LitInt(0) <= i#0 && i#0 < 64) ==> Base64.__default.IndexToChar(i#0) == (if i#0 == LitInt(63) then char#FromInt(47) else (if i#0 == LitInt(62) then char#FromInt(43) else (if LitInt(52) <= i#0 && i#0 <= LitInt(61) then char#FromInt(i#0 - 4) else (if LitInt(26) <= i#0 && i#0 <= LitInt(51) then char#Plus(char#FromInt(i#0), char#FromInt(LitInt(71))) else char#Plus(char#FromInt(i#0), char#FromInt(LitInt(65))))))));

axiom (forall i#0: int :: {:weight 3} { Base64.__default.IndexToChar(LitInt(i#0)) } Base64.__default.IndexToChar#canCall(LitInt(i#0)) || (LitInt(0) <= i#0 && i#0 < 64) ==> Base64.__default.IndexToChar(LitInt(i#0)) == (if LitInt(i#0) == LitInt(63) then char#FromInt(47) else (if LitInt(i#0) == LitInt(62) then char#FromInt(43) else (if LitInt(52) <= LitInt(i#0) && LitInt(i#0) <= LitInt(61) then char#FromInt(LitInt(i#0 - 4)) else (if LitInt(26) <= LitInt(i#0) && LitInt(i#0) <= LitInt(51) then char#Plus(char#FromInt(LitInt(i#0)), char#FromInt(LitInt(71))) else char#Plus(char#FromInt(LitInt(i#0)), char#FromInt(LitInt(65))))))));

axiom (forall c#0: char :: { Base64.__default.CharToIndex(c#0) } Base64.__default.CharToIndex#canCall(c#0) || ($Is(c#0, TChar) && Base64.__default.IsBase64Char(c#0)) ==> Base64.__default.IndexToChar(Base64.__default.CharToIndex(c#0)) == c#0 && LitInt(0) <= Base64.__default.CharToIndex(c#0) && Base64.__default.CharToIndex(c#0) < 64);

axiom (forall c#0: char :: { Base64.__default.CharToIndex(c#0) } Base64.__default.CharToIndex#canCall(c#0) || ($Is(c#0, TChar) && Base64.__default.IsBase64Char(c#0)) ==> Base64.__default.CharToIndex(c#0) == (if c#0 == Lit(char#FromInt(47)) then 63 else (if c#0 == Lit(char#FromInt(43)) then 62 else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(57))) then char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4)))) else (if char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(c#0) && char#ToInt(c#0) <= char#ToInt(Lit(char#FromInt(122))) then char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71)))) else char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65)))))))));

axiom (forall c#0: char :: {:weight 3} { Base64.__default.CharToIndex(Lit(c#0)) } Base64.__default.CharToIndex#canCall(Lit(c#0)) || ($Is(c#0, TChar) && Lit(Base64.__default.IsBase64Char(Lit(c#0)))) ==> Base64.__default.CharToIndex(Lit(c#0)) == (if Lit(c#0) == Lit(char#FromInt(47)) then 63 else (if Lit(c#0) == Lit(char#FromInt(43)) then 62 else (if char#ToInt(Lit(char#FromInt(48))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(57))) then char#ToInt(char#Plus(c#0, char#FromInt(LitInt(4)))) else (if char#ToInt(Lit(char#FromInt(97))) <= char#ToInt(Lit(c#0)) && char#ToInt(Lit(c#0)) <= char#ToInt(Lit(char#FromInt(122))) then char#ToInt(char#Minus(c#0, char#FromInt(LitInt(71)))) else char#ToInt(char#Minus(c#0, char#FromInt(LitInt(65)))))))));

axiom (forall x#0: int :: { Base64.__default.UInt24ToSeq(x#0) } Base64.__default.UInt24ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < 16777216) ==> Seq#Length(Base64.__default.UInt24ToSeq(x#0)) == LitInt(3) && Mul($Unbox(Seq#Index(Base64.__default.UInt24ToSeq(x#0), LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(Base64.__default.UInt24ToSeq(x#0), LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(Base64.__default.UInt24ToSeq(x#0), LitInt(2))): int == x#0 && $Is(Base64.__default.UInt24ToSeq(x#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall x#0: int :: { Base64.__default.UInt24ToSeq(x#0) } Base64.__default.UInt24ToSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToSeq(x#0) == (var b0#2 := Div(x#0, LitInt(65536)); (var x0#2 := x#0 - Mul(b0#2, LitInt(65536)); (var b1#2 := Div(x0#2, LitInt(256)); (var b2#2 := Mod(x0#2, LitInt(256)); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#2)), $Box(b1#2)), $Box(b2#2)))))));

axiom (forall x#0: int :: {:weight 3} { Base64.__default.UInt24ToSeq(LitInt(x#0)) } Base64.__default.UInt24ToSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToSeq(LitInt(x#0)) == (var b0#3 := LitInt(Div(x#0, LitInt(65536))); (var x0#3 := LitInt(x#0 - Mul(b0#3, LitInt(65536))); (var b1#3 := LitInt(Div(x0#3, LitInt(256))); (var b2#3 := LitInt(Mod(x0#3, LitInt(256))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#3)), $Box(b1#3)), $Box(b2#3))))))));

axiom (forall s#0: Seq :: { Base64.__default.SeqToUInt24(s#0) } Base64.__default.SeqToUInt24#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.SeqToUInt24(s#0)), s#0) && LitInt(0) <= Base64.__default.SeqToUInt24(s#0) && Base64.__default.SeqToUInt24(s#0) < 16777216);

axiom (forall s#0: Seq :: { Base64.__default.SeqToUInt24(s#0) } Base64.__default.SeqToUInt24#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Base64.__default.SeqToUInt24(s#0) == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(s#0, LitInt(2))): int);

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.SeqToUInt24(Lit(s#0)) } Base64.__default.SeqToUInt24#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> Base64.__default.SeqToUInt24(Lit(s#0)) == Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(65536)) + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256)) + $Unbox(Seq#Index(Lit(s#0), LitInt(2))): int);

axiom (forall x#0: int :: { Base64.__default.UInt24ToIndexSeq(x#0) } Base64.__default.UInt24ToIndexSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < 16777216) ==> Seq#Length(Base64.__default.UInt24ToIndexSeq(x#0)) == LitInt(4) && Mul($Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(Base64.__default.UInt24ToIndexSeq(x#0), LitInt(3))): int == x#0 && $Is(Base64.__default.UInt24ToIndexSeq(x#0), TSeq(Tclass.Base64.index())));

axiom (forall x#0: int :: { Base64.__default.UInt24ToIndexSeq(x#0) } Base64.__default.UInt24ToIndexSeq#canCall(x#0) || (LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToIndexSeq(x#0) == (var b0#2 := Div(x#0, LitInt(262144)); (var x0#2 := x#0 - Mul(b0#2, LitInt(262144)); (var b1#2 := Div(x0#2, LitInt(4096)); (var x1#2 := x0#2 - Mul(b1#2, LitInt(4096)); (var b2#2 := Div(x1#2, LitInt(64)); (var b3#2 := Mod(x1#2, LitInt(64)); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#2)), $Box(b1#2)), $Box(b2#2)), $Box(b3#2)))))))));

axiom (forall x#0: int :: {:weight 3} { Base64.__default.UInt24ToIndexSeq(LitInt(x#0)) } Base64.__default.UInt24ToIndexSeq#canCall(LitInt(x#0)) || (LitInt(0) <= x#0 && x#0 < 16777216) ==> Base64.__default.UInt24ToIndexSeq(LitInt(x#0)) == (var b0#3 := LitInt(Div(x#0, LitInt(262144))); (var x0#3 := LitInt(x#0 - Mul(b0#3, LitInt(262144))); (var b1#3 := LitInt(Div(x0#3, LitInt(4096))); (var x1#3 := LitInt(x0#3 - Mul(b1#3, LitInt(4096))); (var b2#3 := LitInt(Div(x1#3, LitInt(64))); (var b3#3 := LitInt(Mod(x1#3, LitInt(64))); Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(b0#3)), $Box(b1#3)), $Box(b2#3)), $Box(b3#3))))))))));

axiom (forall s#0: Seq :: { Base64.__default.IndexSeqToUInt24(s#0) } Base64.__default.IndexSeqToUInt24#canCall(s#0) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.IndexSeqToUInt24(s#0)), s#0) && LitInt(0) <= Base64.__default.IndexSeqToUInt24(s#0) && Base64.__default.IndexSeqToUInt24(s#0) < 16777216);

axiom (forall s#0: Seq :: { Base64.__default.IndexSeqToUInt24(s#0) } Base64.__default.IndexSeqToUInt24#canCall(s#0) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24(s#0) == Mul($Unbox(Seq#Index(s#0, LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(s#0, LitInt(3))): int);

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.IndexSeqToUInt24(Lit(s#0)) } Base64.__default.IndexSeqToUInt24#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24(Lit(s#0)) == Mul($Unbox(Seq#Index(Lit(s#0), LitInt(0))): int, LitInt(262144)) + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(4096)) + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(64)) + $Unbox(Seq#Index(Lit(s#0), LitInt(3))): int);

axiom (forall s#0: Seq :: { Base64.__default.DecodeBlock(s#0) } Base64.__default.DecodeBlock#canCall(s#0) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Seq#Length(Base64.__default.DecodeBlock(s#0)) == LitInt(3) && Seq#Equal(Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(Base64.__default.DecodeBlock(s#0))), s#0) && $Is(Base64.__default.DecodeBlock(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall s#0: Seq :: { Base64.__default.DecodeBlock(s#0) } Base64.__default.DecodeBlock#canCall(s#0) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(s#0) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToSeq#canCall(Base64.__default.IndexSeqToUInt24(s#0)) && Base64.__default.DecodeBlock(s#0) == Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(s#0)));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.DecodeBlock(Lit(s#0)) } Base64.__default.DecodeBlock#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> Base64.__default.IndexSeqToUInt24#canCall(Lit(s#0)) && Base64.__default.UInt24ToSeq#canCall(LitInt(Base64.__default.IndexSeqToUInt24(Lit(s#0)))) && Base64.__default.DecodeBlock(Lit(s#0)) == Lit(Base64.__default.UInt24ToSeq(LitInt(Base64.__default.IndexSeqToUInt24(Lit(s#0))))));

axiom (forall s#0: Seq :: { Base64.__default.EncodeBlock(s#0) } Base64.__default.EncodeBlock#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Seq#Length(Base64.__default.EncodeBlock(s#0)) == LitInt(4) && Seq#Equal(Base64.__default.UInt24ToSeq(Base64.__default.IndexSeqToUInt24(Base64.__default.EncodeBlock(s#0))), s#0) && Seq#Equal(Base64.__default.DecodeBlock(Base64.__default.EncodeBlock(s#0)), s#0) && $Is(Base64.__default.EncodeBlock(s#0), TSeq(Tclass.Base64.index())));

axiom (forall s#0: Seq :: { Base64.__default.EncodeBlock(s#0) } Base64.__default.EncodeBlock#canCall(s#0) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(s#0) == LitInt(3)) ==> Base64.__default.SeqToUInt24#canCall(s#0) && Base64.__default.UInt24ToIndexSeq#canCall(Base64.__default.SeqToUInt24(s#0)) && Base64.__default.EncodeBlock(s#0) == Base64.__default.UInt24ToIndexSeq(Base64.__default.SeqToUInt24(s#0)));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.EncodeBlock(Lit(s#0)) } Base64.__default.EncodeBlock#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> Base64.__default.SeqToUInt24#canCall(Lit(s#0)) && Base64.__default.UInt24ToIndexSeq#canCall(LitInt(Base64.__default.SeqToUInt24(Lit(s#0)))) && Base64.__default.EncodeBlock(Lit(s#0)) == Lit(Base64.__default.UInt24ToIndexSeq(LitInt(Base64.__default.SeqToUInt24(Lit(s#0))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively($ly, s#0) } Base64.__default.DecodeRecursively#canCall(s#0) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0)) ==> Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3)) && Mod(Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)), LitInt(3)) == LitInt(0) && (Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)) == LitInt(0) ==> Seq#Length(s#0) == LitInt(0)) && (Seq#Length(Base64.__default.DecodeRecursively($ly, s#0)) != 0 ==> Seq#Equal(Base64.__default.EncodeBlock(Seq#Take(Base64.__default.DecodeRecursively($ly, s#0), LitInt(3))), Seq#Take(s#0, LitInt(4)))) && $Is(Base64.__default.DecodeRecursively($ly, s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, s#0: Seq :: { Base64.__default.DecodeRecursively($LS($ly), s#0) } Base64.__default.DecodeRecursively#canCall(s#0) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0)) ==> (Seq#Length(s#0) != LitInt(0) ==> Base64.__default.DecodeBlock#canCall(Seq#Take(s#0, LitInt(4))) && Base64.__default.DecodeRecursively#canCall(Seq#Drop(s#0, LitInt(4)))) && Base64.__default.DecodeRecursively($LS($ly), s#0) == (if Seq#Length(s#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.DecodeBlock(Seq#Take(s#0, LitInt(4))), Base64.__default.DecodeRecursively($ly, Seq#Drop(s#0, LitInt(4))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Base64.__default.DecodeRecursively($LS($ly), Lit(s#0)) } Base64.__default.DecodeRecursively#canCall(Lit(s#0)) || ($Is(s#0, TSeq(Tclass.Base64.index())) && Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0)) ==> (Seq#Length(Lit(s#0)) != LitInt(0) ==> Base64.__default.DecodeBlock#canCall(Lit(Seq#Take(Lit(s#0), LitInt(4)))) && Base64.__default.DecodeRecursively#canCall(Lit(Seq#Drop(Lit(s#0), LitInt(4))))) && Base64.__default.DecodeRecursively($LS($ly), Lit(s#0)) == (if Seq#Length(Lit(s#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.DecodeBlock(Lit(Seq#Take(Lit(s#0), LitInt(4)))), Base64.__default.DecodeRecursively($LS($ly), Lit(Seq#Drop(Lit(s#0), LitInt(4)))))));

axiom (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively($ly, b#0) } Base64.__default.EncodeRecursively#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> Seq#Length(Base64.__default.EncodeRecursively($ly, b#0)) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) && Mod(Seq#Length(Base64.__default.EncodeRecursively($ly, b#0)), LitInt(4)) == LitInt(0) && Seq#Equal(Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.EncodeRecursively($ly, b#0)), b#0) && $Is(Base64.__default.EncodeRecursively($ly, b#0), TSeq(Tclass.Base64.index())));

axiom (forall $ly: LayerType, b#0: Seq :: { Base64.__default.EncodeRecursively($LS($ly), b#0) } Base64.__default.EncodeRecursively#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> (Seq#Length(b#0) != LitInt(0) ==> Base64.__default.EncodeBlock#canCall(Seq#Take(b#0, LitInt(3))) && Base64.__default.EncodeRecursively#canCall(Seq#Drop(b#0, LitInt(3)))) && Base64.__default.EncodeRecursively($LS($ly), b#0) == (if Seq#Length(b#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.EncodeBlock(Seq#Take(b#0, LitInt(3))), Base64.__default.EncodeRecursively($ly, Seq#Drop(b#0, LitInt(3))))));

axiom (forall $ly: LayerType, b#0: Seq :: {:weight 3} { Base64.__default.EncodeRecursively($LS($ly), Lit(b#0)) } Base64.__default.EncodeRecursively#canCall(Lit(b#0)) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0)) ==> (Seq#Length(Lit(b#0)) != LitInt(0) ==> Base64.__default.EncodeBlock#canCall(Lit(Seq#Take(Lit(b#0), LitInt(3)))) && Base64.__default.EncodeRecursively#canCall(Lit(Seq#Drop(Lit(b#0), LitInt(3))))) && Base64.__default.EncodeRecursively($LS($ly), Lit(b#0)) == (if Seq#Length(Lit(b#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(Base64.__default.EncodeBlock(Lit(Seq#Take(Lit(b#0), LitInt(3)))), Base64.__default.EncodeRecursively($LS($ly), Lit(Seq#Drop(Lit(b#0), LitInt(3)))))));

axiom (forall s#0: Seq :: { Base64.__default.FromCharsToIndices(s#0) } Base64.__default.FromCharsToIndices#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && (forall k#0: char :: { Base64.__default.IsBase64Char(k#0) } { Seq#Contains(s#0, $Box(k#0)) } $Is(k#0, TChar) ==> Seq#Contains(s#0, $Box(k#0)) ==> Base64.__default.IsBase64Char(k#0))) ==> Seq#Length(Base64.__default.FromCharsToIndices(s#0)) == Seq#Length(s#0) && (forall k#7: int :: { $Unbox(Seq#Index(s#0, k#7)): char } { $Unbox(Seq#Index(Base64.__default.FromCharsToIndices(s#0), k#7)): int } LitInt(0) <= k#7 && k#7 < Seq#Length(Base64.__default.FromCharsToIndices(s#0)) ==> Base64.__default.IndexToChar($Unbox(Seq#Index(Base64.__default.FromCharsToIndices(s#0), k#7)): int) == $Unbox(Seq#Index(s#0, k#7)): char) && $Is(Base64.__default.FromCharsToIndices(s#0), TSeq(Tclass.Base64.index())));

axiom (forall $Heap: Heap, s#0: Seq :: { Base64.__default.FromCharsToIndices#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (Base64.__default.FromCharsToIndices#requires(s#0) <==> (forall k#8: char :: { Base64.__default.IsBase64Char(k#8) } { Seq#Contains(s#0, $Box(k#8)) } $Is(k#8, TChar) ==> Seq#Contains(s#0, $Box(k#8)) ==> Base64.__default.IsBase64Char(k#8))));

axiom (forall $Heap: Heap, s#0: Seq :: { Base64.__default.FromCharsToIndices(s#0), $IsGoodHeap($Heap) } Base64.__default.FromCharsToIndices#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall k#8: char :: { Base64.__default.IsBase64Char(k#8) } { Seq#Contains(s#0, $Box(k#8)) } $Is(k#8, TChar) ==> Seq#Contains(s#0, $Box(k#8)) ==> Base64.__default.IsBase64Char(k#8))) ==> (forall $l#9#i#0: int :: LitInt(0) <= $l#9#i#0 && $l#9#i#0 < Seq#Length(s#0) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, $l#9#i#0)): char)) && Base64.__default.FromCharsToIndices(s#0) == Seq#Create(Tclass.Base64.index(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, $Unbox($l#8#i#0): int)): char))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(s#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Base64.__default.FromCharsToIndices(Lit(s#0)), $IsGoodHeap($Heap) } Base64.__default.FromCharsToIndices#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall k#9: char :: { Base64.__default.IsBase64Char(k#9) } { Seq#Contains(s#0, $Box(k#9)) } $Is(k#9, TChar) ==> Seq#Contains(s#0, $Box(k#9)) ==> Base64.__default.IsBase64Char(k#9))) ==> (forall $l#11#i#0: int :: LitInt(0) <= $l#11#i#0 && $l#11#i#0 < Seq#Length(Lit(s#0)) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), $l#11#i#0)): char)) && Base64.__default.FromCharsToIndices(Lit(s#0)) == Seq#Create(Tclass.Base64.index(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), $Unbox($l#10#i#0): int)): char))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $IsBox($l#10#i#0, TInt) && LitInt(0) <= $Unbox($l#10#i#0): int && $Unbox($l#10#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall b#0: Seq :: { Base64.__default.FromIndicesToChars(b#0) } Base64.__default.FromIndicesToChars#canCall(b#0) || $Is(b#0, TSeq(Tclass.Base64.index())) ==> (forall k#7: char :: { Base64.__default.IsBase64Char(k#7) } { Seq#Contains(Base64.__default.FromIndicesToChars(b#0), $Box(k#7)) } $Is(k#7, TChar) ==> Seq#Contains(Base64.__default.FromIndicesToChars(b#0), $Box(k#7)) ==> Base64.__default.IsBase64Char(k#7)) && Seq#Length(Base64.__default.FromIndicesToChars(b#0)) == Seq#Length(b#0) && (forall k#8: int :: { $Unbox(Seq#Index(b#0, k#8)): int } { $Unbox(Seq#Index(Base64.__default.FromIndicesToChars(b#0), k#8)): char } LitInt(0) <= k#8 && k#8 < Seq#Length(Base64.__default.FromIndicesToChars(b#0)) ==> Base64.__default.CharToIndex($Unbox(Seq#Index(Base64.__default.FromIndicesToChars(b#0), k#8)): char) == $Unbox(Seq#Index(b#0, k#8)): int) && Seq#Equal(Base64.__default.FromCharsToIndices(Base64.__default.FromIndicesToChars(b#0)), b#0) && $Is(Base64.__default.FromIndicesToChars(b#0), TSeq(TChar)));

axiom (forall $Heap: Heap, b#0: Seq :: { Base64.__default.FromIndicesToChars(b#0), $IsGoodHeap($Heap) } Base64.__default.FromIndicesToChars#canCall(b#0) || ($IsGoodHeap($Heap) && $Is(b#0, TSeq(Tclass.Base64.index()))) ==> (forall $l#9#i#0: int :: LitInt(0) <= $l#9#i#0 && $l#9#i#0 < Seq#Length(b#0) ==> Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(b#0, $l#9#i#0)): int)) && Base64.__default.FromIndicesToChars(b#0) == Seq#Create(TChar, $Heap, Seq#Length(b#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(b#0, $Unbox($l#8#i#0): int)): int))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(b#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, b#0: Seq :: {:weight 3} { Base64.__default.FromIndicesToChars(Lit(b#0)), $IsGoodHeap($Heap) } Base64.__default.FromIndicesToChars#canCall(Lit(b#0)) || ($IsGoodHeap($Heap) && $Is(b#0, TSeq(Tclass.Base64.index()))) ==> (forall $l#11#i#0: int :: LitInt(0) <= $l#11#i#0 && $l#11#i#0 < Seq#Length(Lit(b#0)) ==> Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(Lit(b#0), $l#11#i#0)): int)) && Base64.__default.FromIndicesToChars(Lit(b#0)) == Seq#Create(TChar, $Heap, Seq#Length(Lit(b#0)), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(Lit(b#0), $Unbox($l#10#i#0): int)): int))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $IsBox($l#10#i#0, TInt) && LitInt(0) <= $Unbox($l#10#i#0): int && $Unbox($l#10#i#0): int < Seq#Length(Lit(b#0))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall s#0: Seq :: { Base64.__default.DecodeUnpadded(s#0) } Base64.__default.DecodeUnpadded#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.IsUnpaddedBase64String(s#0)) ==> Seq#Length(Base64.__default.DecodeUnpadded(s#0)) == Mul(Div(Seq#Length(s#0), LitInt(4)), LitInt(3)) && Mod(Seq#Length(Base64.__default.DecodeUnpadded(s#0)), LitInt(3)) == LitInt(0) && $Is(Base64.__default.DecodeUnpadded(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall s#0: Seq :: { Base64.__default.DecodeUnpadded(s#0) } Base64.__default.DecodeUnpadded#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.IsUnpaddedBase64String(s#0)) ==> Base64.__default.FromCharsToIndices#canCall(s#0) && Base64.__default.DecodeRecursively#canCall(Base64.__default.FromCharsToIndices(s#0)) && Base64.__default.DecodeUnpadded(s#0) == Base64.__default.DecodeRecursively($LS($LZ), Base64.__default.FromCharsToIndices(s#0)));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.DecodeUnpadded(Lit(s#0)) } Base64.__default.DecodeUnpadded#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(Base64.__default.IsUnpaddedBase64String(Lit(s#0)))) ==> Base64.__default.FromCharsToIndices#canCall(Lit(s#0)) && Base64.__default.DecodeRecursively#canCall(Lit(Base64.__default.FromCharsToIndices(Lit(s#0)))) && Base64.__default.DecodeUnpadded(Lit(s#0)) == Lit(Base64.__default.DecodeRecursively($LS($LZ), Lit(Base64.__default.FromCharsToIndices(Lit(s#0))))));

axiom (forall b#0: Seq :: { Base64.__default.EncodeUnpadded(b#0) } Base64.__default.EncodeUnpadded#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> Base64.__default.IsUnpaddedBase64String(Base64.__default.EncodeUnpadded(b#0)) && Seq#Length(Base64.__default.EncodeUnpadded(b#0)) == Mul(Div(Seq#Length(b#0), LitInt(3)), LitInt(4)) && Seq#Equal(Base64.__default.DecodeUnpadded(Base64.__default.EncodeUnpadded(b#0)), b#0) && Mod(Seq#Length(Base64.__default.EncodeUnpadded(b#0)), LitInt(4)) == LitInt(0) && $Is(Base64.__default.EncodeUnpadded(b#0), TSeq(TChar)));

axiom (forall b#0: Seq :: { Base64.__default.EncodeUnpadded(b#0) } Base64.__default.EncodeUnpadded#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0)) ==> Base64.__default.EncodeRecursively#canCall(b#0) && Base64.__default.FromIndicesToChars#canCall(Base64.__default.EncodeRecursively($LS($LZ), b#0)) && Base64.__default.EncodeUnpadded(b#0) == Base64.__default.FromIndicesToChars(Base64.__default.EncodeRecursively($LS($LZ), b#0)));

axiom (forall b#0: Seq :: {:weight 3} { Base64.__default.EncodeUnpadded(Lit(b#0)) } Base64.__default.EncodeUnpadded#canCall(Lit(b#0)) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0)) ==> Base64.__default.EncodeRecursively#canCall(Lit(b#0)) && Base64.__default.FromIndicesToChars#canCall(Lit(Base64.__default.EncodeRecursively($LS($LZ), Lit(b#0)))) && Base64.__default.EncodeUnpadded(Lit(b#0)) == Lit(Base64.__default.FromIndicesToChars(Lit(Base64.__default.EncodeRecursively($LS($LZ), Lit(b#0))))));

axiom (forall s#0: Seq :: { Base64.__default.Is1Padding(s#0) } Base64.__default.Is1Padding#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (Seq#Length(s#0) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char))))) && (Base64.__default.Is1Padding(s#0) <==> Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.Is1Padding(Lit(s#0)) } Base64.__default.Is1Padding#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (Seq#Length(Lit(s#0)) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char))))) && (Base64.__default.Is1Padding(Lit(s#0)) <==> Seq#Length(Lit(s#0)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char), LitInt(4)) == LitInt(0) && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): char == Lit(char#FromInt(61))));

axiom (forall s#0: Seq :: { Base64.__default.Decode1Padding(s#0) } Base64.__default.Decode1Padding#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.Is1Padding(s#0)) ==> Seq#Length(Base64.__default.Decode1Padding(s#0)) == LitInt(2) && $Is(Base64.__default.Decode1Padding(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall s#0: Seq :: { Base64.__default.Decode1Padding(s#0) } Base64.__default.Decode1Padding#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.Is1Padding(s#0)) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(2))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0)))) && Base64.__default.Decode1Padding(s#0) == (var d#2 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(2))): char))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(d#2, LitInt(0))), Seq#Index(d#2, LitInt(1)))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.Decode1Padding(Lit(s#0)) } Base64.__default.Decode1Padding#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(Base64.__default.Is1Padding(Lit(s#0)))) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char))), $Box(LitInt(0)))) && Base64.__default.Decode1Padding(Lit(s#0)) == (var d#3 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(2))): char))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(d#3, LitInt(0))), Seq#Index(d#3, LitInt(1)))));

axiom (forall b#0: Seq :: { Base64.__default.Encode1Padding(b#0) } Base64.__default.Encode1Padding#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(2)) ==> Base64.__default.Is1Padding(Base64.__default.Encode1Padding(b#0)) && Seq#Equal(Base64.__default.Decode1Padding(Base64.__default.Encode1Padding(b#0)), b#0) && Mod(Seq#Length(Base64.__default.Encode1Padding(b#0)), LitInt(4)) == LitInt(0) && $Is(Base64.__default.Encode1Padding(b#0), TSeq(TChar)));

axiom (forall b#0: Seq :: { Base64.__default.Encode1Padding(b#0) } Base64.__default.Encode1Padding#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(2)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)))) && (var e#2 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#2, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#2, LitInt(1))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#2, LitInt(2))): int)) && Base64.__default.Encode1Padding(b#0) == (var e#2 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), Seq#Index(b#0, LitInt(1))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#2, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#2, LitInt(1))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#2, LitInt(2))): int))), $Box(Lit(char#FromInt(61))))));

axiom (forall b#0: Seq :: {:weight 3} { Base64.__default.Encode1Padding(Lit(b#0)) } Base64.__default.Encode1Padding#canCall(Lit(b#0)) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(b#0)) == LitInt(2)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), Seq#Index(Lit(b#0), LitInt(1))), $Box(LitInt(0)))) && (var e#3 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), Seq#Index(Lit(b#0), LitInt(1))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#3, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#3, LitInt(1))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#3, LitInt(2))): int)) && Base64.__default.Encode1Padding(Lit(b#0)) == (var e#3 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), Seq#Index(Lit(b#0), LitInt(1))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#3, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#3, LitInt(1))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#3, LitInt(2))): int))), $Box(Lit(char#FromInt(61))))));

axiom (forall s#0: Seq :: { Base64.__default.Is2Padding(s#0) } Base64.__default.Is2Padding#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (Seq#Length(s#0) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char)))) && (Base64.__default.Is2Padding(s#0) <==> Seq#Length(s#0) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(s#0, LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(s#0, LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(s#0, LitInt(3))): char == Lit(char#FromInt(61))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.Is2Padding(Lit(s#0)) } Base64.__default.Is2Padding#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (Seq#Length(Lit(s#0)) == LitInt(4) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) ==> Base64.__default.IsBase64Char#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && (Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char)))) && (Base64.__default.Is2Padding(Lit(s#0)) <==> Seq#Length(Lit(s#0)) == LitInt(4) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.IsBase64Char($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Mod(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char), LitInt(16)) == LitInt(0) && $Unbox(Seq#Index(Lit(s#0), LitInt(2))): char == Lit(char#FromInt(61)) && $Unbox(Seq#Index(Lit(s#0), LitInt(3))): char == Lit(char#FromInt(61))));

axiom (forall s#0: Seq :: { Base64.__default.Decode2Padding(s#0) } Base64.__default.Decode2Padding#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.Is2Padding(s#0)) ==> Seq#Length(Base64.__default.Decode2Padding(s#0)) == LitInt(1) && $Is(Base64.__default.Decode2Padding(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall s#0: Seq :: { Base64.__default.Decode2Padding(s#0) } Base64.__default.Decode2Padding#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.Is2Padding(s#0)) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(s#0, LitInt(1))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))) && Base64.__default.Decode2Padding(s#0) == (var d#2 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(s#0, LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Empty(): Seq, Seq#Index(d#2, LitInt(0)))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.Decode2Padding(Lit(s#0)) } Base64.__default.Decode2Padding#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(Base64.__default.Is2Padding(Lit(s#0)))) ==> Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char) && Base64.__default.CharToIndex#canCall($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char) && Base64.__default.DecodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))) && Base64.__default.Decode2Padding(Lit(s#0)) == (var d#3 := Base64.__default.DecodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(0))): char))), $Box(Base64.__default.CharToIndex($Unbox(Seq#Index(Lit(s#0), LitInt(1))): char))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Empty(): Seq, Seq#Index(d#3, LitInt(0)))));

axiom (forall b#0: Seq :: { Base64.__default.Encode2Padding(b#0) } Base64.__default.Encode2Padding#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(1)) ==> Base64.__default.Is2Padding(Base64.__default.Encode2Padding(b#0)) && Seq#Equal(Base64.__default.Decode2Padding(Base64.__default.Encode2Padding(b#0)), b#0) && Mod(Seq#Length(Base64.__default.Encode2Padding(b#0)), LitInt(4)) == LitInt(0) && $Is(Base64.__default.Encode2Padding(b#0), TSeq(TChar)));

axiom (forall b#0: Seq :: { Base64.__default.Encode2Padding(b#0) } Base64.__default.Encode2Padding#canCall(b#0) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(b#0) == LitInt(1)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))) && (var e#2 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#2, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#2, LitInt(1))): int)) && Base64.__default.Encode2Padding(b#0) == (var e#2 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(b#0, LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#2, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#2, LitInt(1))): int))), $Box(Lit(char#FromInt(61)))), $Box(Lit(char#FromInt(61))))));

axiom (forall b#0: Seq :: {:weight 3} { Base64.__default.Encode2Padding(Lit(b#0)) } Base64.__default.Encode2Padding#canCall(Lit(b#0)) || ($Is(b#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(b#0)) == LitInt(1)) ==> Base64.__default.EncodeBlock#canCall(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))) && (var e#3 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#3, LitInt(0))): int) && Base64.__default.IndexToChar#canCall($Unbox(Seq#Index(e#3, LitInt(1))): int)) && Base64.__default.Encode2Padding(Lit(b#0)) == (var e#3 := Base64.__default.EncodeBlock(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(b#0), LitInt(0))), $Box(LitInt(0))), $Box(LitInt(0)))); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#3, LitInt(0))): int))), $Box(Base64.__default.IndexToChar($Unbox(Seq#Index(e#3, LitInt(1))): int))), $Box(Lit(char#FromInt(61)))), $Box(Lit(char#FromInt(61))))));

axiom (forall s#0: Seq :: { Base64.__default.IsBase64String(s#0) } Base64.__default.IsBase64String#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) ==> Base64.__default.IsUnpaddedBase64String#canCall(s#0) && (!Base64.__default.IsUnpaddedBase64String(s#0) ==> Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) ==> Base64.__default.Is1Padding#canCall(Seq#Drop(s#0, finalBlockStart#2)) && (!Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) ==> Base64.__default.Is2Padding#canCall(Seq#Drop(s#0, finalBlockStart#2)))))) && (Base64.__default.IsBase64String(s#0) <==> (var finalBlockStart#2 := Seq#Length(s#0) - 4; Mod(Seq#Length(s#0), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(s#0) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(s#0, finalBlockStart#2)) && (Base64.__default.Is1Padding(Seq#Drop(s#0, finalBlockStart#2)) || Base64.__default.Is2Padding(Seq#Drop(s#0, finalBlockStart#2))))))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.IsBase64String(Lit(s#0)) } Base64.__default.IsBase64String#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (var finalBlockStart#3 := Seq#Length(Lit(s#0)) - 4; Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) ==> Base64.__default.IsUnpaddedBase64String#canCall(Lit(s#0)) && (!Lit(Base64.__default.IsUnpaddedBase64String(Lit(s#0))) ==> Base64.__default.IsUnpaddedBase64String#canCall(Seq#Take(Lit(s#0), finalBlockStart#3)) && (Base64.__default.IsUnpaddedBase64String(Seq#Take(Lit(s#0), finalBlockStart#3)) ==> Base64.__default.Is1Padding#canCall(Seq#Drop(Lit(s#0), finalBlockStart#3)) && (!Base64.__default.Is1Padding(Seq#Drop(Lit(s#0), finalBlockStart#3)) ==> Base64.__default.Is2Padding#canCall(Seq#Drop(Lit(s#0), finalBlockStart#3)))))) && (Base64.__default.IsBase64String(Lit(s#0)) <==> (var finalBlockStart#3 := Seq#Length(Lit(s#0)) - 4; Mod(Seq#Length(Lit(s#0)), LitInt(4)) == LitInt(0) && (Base64.__default.IsUnpaddedBase64String(Lit(s#0)) || (Base64.__default.IsUnpaddedBase64String(Seq#Take(Lit(s#0), finalBlockStart#3)) && (Base64.__default.Is1Padding(Seq#Drop(Lit(s#0), finalBlockStart#3)) || Base64.__default.Is2Padding(Seq#Drop(Lit(s#0), finalBlockStart#3))))))));

axiom (forall s#0: Seq :: { Base64.__default.DecodeValid(s#0) } Base64.__default.DecodeValid#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.IsBase64String(s#0)) ==> $Is(Base64.__default.DecodeValid(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall s#0: Seq :: { Base64.__default.DecodeValid(s#0) } Base64.__default.DecodeValid#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && Base64.__default.IsBase64String(s#0)) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalBlockStart#2 := Seq#Length(s#0) - 4; (var prefix#2, suffix#2 := Seq#Take(s#0, finalBlockStart#2), Seq#Drop(s#0, finalBlockStart#2); Base64.__default.Is1Padding#canCall(suffix#2) && (Base64.__default.Is1Padding(suffix#2) ==> Base64.__default.DecodeUnpadded#canCall(prefix#2) && Base64.__default.Decode1Padding#canCall(suffix#2)) && (!Base64.__default.Is1Padding(suffix#2) ==> Base64.__default.Is2Padding#canCall(suffix#2) && (Base64.__default.Is2Padding(suffix#2) ==> Base64.__default.DecodeUnpadded#canCall(prefix#2) && Base64.__default.Decode2Padding#canCall(suffix#2)) && (!Base64.__default.Is2Padding(suffix#2) ==> Base64.__default.DecodeUnpadded#canCall(s#0)))))) && Base64.__default.DecodeValid(s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else (var finalBlockStart#2 := Seq#Length(s#0) - 4; (var prefix#2, suffix#2 := Seq#Take(s#0, finalBlockStart#2), Seq#Drop(s#0, finalBlockStart#2); (if Base64.__default.Is1Padding(suffix#2) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#2), Base64.__default.Decode1Padding(suffix#2)) else (if Base64.__default.Is2Padding(suffix#2) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#2), Base64.__default.Decode2Padding(suffix#2)) else Base64.__default.DecodeUnpadded(s#0)))))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.DecodeValid(Lit(s#0)) } Base64.__default.DecodeValid#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TChar)) && Lit(Base64.__default.IsBase64String(Lit(s#0)))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> (var finalBlockStart#3 := Seq#Length(Lit(s#0)) - 4; (var prefix#3, suffix#3 := Seq#Take(Lit(s#0), finalBlockStart#3), Seq#Drop(Lit(s#0), finalBlockStart#3); Base64.__default.Is1Padding#canCall(suffix#3) && (Base64.__default.Is1Padding(suffix#3) ==> Base64.__default.DecodeUnpadded#canCall(prefix#3) && Base64.__default.Decode1Padding#canCall(suffix#3)) && (!Base64.__default.Is1Padding(suffix#3) ==> Base64.__default.Is2Padding#canCall(suffix#3) && (Base64.__default.Is2Padding(suffix#3) ==> Base64.__default.DecodeUnpadded#canCall(prefix#3) && Base64.__default.Decode2Padding#canCall(suffix#3)) && (!Base64.__default.Is2Padding(suffix#3) ==> Base64.__default.DecodeUnpadded#canCall(Lit(s#0))))))) && Base64.__default.DecodeValid(Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else (var finalBlockStart#3 := Seq#Length(Lit(s#0)) - 4; (var prefix#3, suffix#3 := Seq#Take(Lit(s#0), finalBlockStart#3), Seq#Drop(Lit(s#0), finalBlockStart#3); (if Base64.__default.Is1Padding(suffix#3) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#3), Base64.__default.Decode1Padding(suffix#3)) else (if Base64.__default.Is2Padding(suffix#3) then Seq#Append(Base64.__default.DecodeUnpadded(prefix#3), Base64.__default.Decode2Padding(suffix#3)) else Base64.__default.DecodeUnpadded(Lit(s#0))))))));

axiom (forall s#0: Seq :: { Base64.__default.Decode(s#0) } Base64.__default.Decode#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Success_q(Base64.__default.Decode(s#0))) && (!Base64.__default.IsBase64String(s#0) ==> Wrappers.Result.Failure_q(Base64.__default.Decode(s#0))) && $Is(Base64.__default.Decode(s#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), TSeq(TChar))));

axiom (forall s#0: Seq :: { Base64.__default.Decode(s#0) } Base64.__default.Decode#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> Base64.__default.IsBase64String#canCall(s#0) && (Base64.__default.IsBase64String(s#0) ==> Base64.__default.DecodeValid#canCall(s#0)) && Base64.__default.Decode(s#0) == (if Base64.__default.IsBase64String(s#0) then #Wrappers.Result.Success($Box(Base64.__default.DecodeValid(s#0))) else #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(84))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(100))))))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.Decode(Lit(s#0)) } Base64.__default.Decode#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> Base64.__default.IsBase64String#canCall(Lit(s#0)) && (Lit(Base64.__default.IsBase64String(Lit(s#0))) ==> Base64.__default.DecodeValid#canCall(Lit(s#0))) && Base64.__default.Decode(Lit(s#0)) == (if Base64.__default.IsBase64String(Lit(s#0)) then #Wrappers.Result.Success($Box(Lit(Base64.__default.DecodeValid(Lit(s#0))))) else #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(84))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(102))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(100))))))));

axiom (forall s#0: Seq :: { Base64.__default.StringIs7Bit(s#0) } Base64.__default.StringIs7Bit#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> (Base64.__default.StringIs7Bit(s#0) <==> (forall i#4: int :: { $Unbox(Seq#Index(s#0, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(s#0) ==> char#ToInt($Unbox(Seq#Index(s#0, i#4)): char) < char#ToInt(char#FromInt(LitInt(128))))));

axiom (forall s#0: Seq :: {:weight 3} { Base64.__default.StringIs7Bit(Lit(s#0)) } Base64.__default.StringIs7Bit#canCall(Lit(s#0)) || $Is(s#0, TSeq(TChar)) ==> (Base64.__default.StringIs7Bit(Lit(s#0)) <==> (forall i#5: int :: { $Unbox(Seq#Index(s#0, i#5)): char } LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(s#0)) ==> char#ToInt($Unbox(Seq#Index(Lit(s#0), i#5)): char) < char#ToInt(char#FromInt(LitInt(128))))));

axiom (forall b#0: Seq :: { Base64.__default.Encode(b#0) } Base64.__default.Encode#canCall(b#0) || $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> Base64.__default.StringIs7Bit(Base64.__default.Encode(b#0)) && Mod(Seq#Length(Base64.__default.Encode(b#0)), LitInt(4)) == LitInt(0) && Base64.__default.IsBase64String(Base64.__default.Encode(b#0)) && $Is(Base64.__default.Encode(b#0), TSeq(TChar)));

axiom (forall b#0: Seq :: { Base64.__default.Encode(b#0) } Base64.__default.Encode#canCall(b#0) || $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) ==> Base64.__default.EncodeUnpadded#canCall(b#0)) && (Mod(Seq#Length(b#0), LitInt(3)) != LitInt(0) ==> (Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 1))) && (Mod(Seq#Length(b#0), LitInt(3)) != LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(b#0, Seq#Length(b#0) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(b#0, Seq#Length(b#0) - 2)))) && Base64.__default.Encode(b#0) == (if Mod(Seq#Length(b#0), LitInt(3)) == LitInt(0) then (var s#7 := Base64.__default.EncodeUnpadded(b#0); s#7) else (if Mod(Seq#Length(b#0), LitInt(3)) == LitInt(1) then (var s1#4, s2#4 := Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 1)), Base64.__default.Encode2Padding(Seq#Drop(b#0, Seq#Length(b#0) - 1)); (var s#8 := Seq#Append(s1#4, s2#4); s#8)) else (var s1#5, s2#5 := Base64.__default.EncodeUnpadded(Seq#Take(b#0, Seq#Length(b#0) - 2)), Base64.__default.Encode1Padding(Seq#Drop(b#0, Seq#Length(b#0) - 2)); (var s#9 := Seq#Append(s1#5, s2#5); s#9)))));

axiom (forall b#0: Seq :: {:weight 3} { Base64.__default.Encode(Lit(b#0)) } Base64.__default.Encode#canCall(Lit(b#0)) || $Is(b#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0) ==> Base64.__default.EncodeUnpadded#canCall(Lit(b#0))) && (Mod(Seq#Length(Lit(b#0)), LitInt(3)) != LitInt(0) ==> (Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 1)) && Base64.__default.Encode2Padding#canCall(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 1))) && (Mod(Seq#Length(Lit(b#0)), LitInt(3)) != LitInt(1) ==> Base64.__default.EncodeUnpadded#canCall(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 2)) && Base64.__default.Encode1Padding#canCall(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 2)))) && Base64.__default.Encode(Lit(b#0)) == (if Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(0) then (var s#10 := Lit(Base64.__default.EncodeUnpadded(Lit(b#0))); s#10) else (if Mod(Seq#Length(Lit(b#0)), LitInt(3)) == LitInt(1) then (var s1#6, s2#6 := Base64.__default.EncodeUnpadded(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 1)), Base64.__default.Encode2Padding(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 1)); (var s#11 := Seq#Append(s1#6, s2#6); s#11)) else (var s1#7, s2#7 := Base64.__default.EncodeUnpadded(Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 2)), Base64.__default.Encode1Padding(Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - 2)); (var s#12 := Seq#Append(s1#7, s2#7); s#12)))));

const unique class.Actions.__default: ClassName;

function Tclass.Actions.DeterministicAction(Ty, Ty) : Ty;

const unique Tagclass.Actions.DeterministicAction: TyTag;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty :: { Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R) } Tag(Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == Tagclass.Actions.DeterministicAction && TagFamily(Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == tytagFamily$DeterministicAction);

function Tclass.Actions.DeterministicAction_0(Ty) : Ty;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty :: { Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R) } Tclass.Actions.DeterministicAction_0(Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == Actions.DeterministicAction$A);

function Tclass.Actions.DeterministicAction_1(Ty) : Ty;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty :: { Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R) } Tclass.Actions.DeterministicAction_1(Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == Actions.DeterministicAction$R);

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) } $IsBox(bx, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)));

procedure {:verboseName "Actions.DeterministicMap (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMap$A), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(Actions._default.DeterministicMap$R)) && $IsAlloc(res#0, TSeq(Actions._default.DeterministicMap$R), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.Actions.DeterministicAction?(Ty, Ty) : Ty;

const unique Tagclass.Actions.DeterministicAction?: TyTag;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty :: { Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R) } Tag(Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == Tagclass.Actions.DeterministicAction? && TagFamily(Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == tytagFamily$DeterministicAction);

function Tclass.Actions.DeterministicAction?_0(Ty) : Ty;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty :: { Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R) } Tclass.Actions.DeterministicAction?_0(Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == Actions.DeterministicAction$A);

function Tclass.Actions.DeterministicAction?_1(Ty) : Ty;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty :: { Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R) } Tclass.Actions.DeterministicAction?_1(Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) == Actions.DeterministicAction$R);

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) } $IsBox(bx, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicMap (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref, s#0: Seq) returns (res#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##a#0: Box;
  var ##r#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicMap", " | ", Actions._default.DeterministicMap$A, " | ", Actions._default.DeterministicMap$R, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(104,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(109,16): post-state"} true;
    assume Seq#Length(s#0) == Seq#Length(res#0);
    havoc i#0;
    assume true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon4;

  anon8_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R), $Heap);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume 0 <= i#0 && i#0 < Seq#Length(res#0);
    ##a#0 := Seq#Index(s#0, i#0);
    assume $IsAllocBox(##a#0, Actions._default.DeterministicMap$A, $Heap);
    ##r#0 := Seq#Index(res#0, i#0);
    assume $IsAllocBox(##r#0, Actions._default.DeterministicMap$R, $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#0), Seq#Index(res#0, i#0));
    assume Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#0), Seq#Index(res#0, i#0));
    goto anon6;

  anon7_Else:
    assume true && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#0), Seq#Index(res#0, i#0));
    goto anon6;

  anon6:
    assume (forall i#1: int :: { Seq#Index(res#0, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#1), Seq#Index(res#0, i#1)));
    return;
}



procedure {:verboseName "Actions.DeterministicMap (call precondtion)"} CallPre$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMap$A), $Heap));



procedure {:verboseName "Actions.DeterministicMap (call postcondition)"} CallPost$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMap$A), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(Actions._default.DeterministicMap$R)) && $IsAlloc(res#0, TSeq(Actions._default.DeterministicMap$R), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19253"} Seq#Length(s#0) == Seq#Length(res#0);
  free ensures (forall i#1: int :: { Seq#Index(res#0, i#1) } { Seq#Index(s#0, i#1) } Lit(true) ==> LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#1), Seq#Index(res#0, i#1)));
  free ensures {:id "id19254"} (forall i#1: int :: { Seq#Index(res#0, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#1), Seq#Index(res#0, i#1)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.DeterministicMap (correctness)"} Impl$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMap$A), $Heap)) returns (defass#res#0: bool, res#0: Seq where defass#res#0 ==> $Is(res#0, TSeq(Actions._default.DeterministicMap$R)) && $IsAlloc(res#0, TSeq(Actions._default.DeterministicMap$R), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19255"} Seq#Length(s#0) == Seq#Length(res#0);
  free ensures (forall i#1: int :: { Seq#Index(res#0, i#1) } { Seq#Index(s#0, i#1) } Lit(true) ==> LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#1), Seq#Index(res#0, i#1)));
  free ensures {:id "id19256"} (forall i#1: int :: { Seq#Index(res#0, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, i#1), Seq#Index(res#0, i#1)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicMap (correctness)"} Impl$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var rs#0: Seq where $Is(rs#0, TSeq(Actions._default.DeterministicMap$R)) && $IsAlloc(rs#0, TSeq(Actions._default.DeterministicMap$R), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#0: int;
  var ##a#1: Box;
  var ##r#1: Box;
  var defass#r#0_0: bool;
  var r#0_0: Box where defass#r#0_0 ==> $IsBox(r#0_0, Actions._default.DeterministicMap$R) && $IsAllocBox(r#0_0, Actions._default.DeterministicMap$R, $Heap);
  var $rhs##0_0: Box;
  var a##0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicMap", " | ", Actions._default.DeterministicMap$A, " | ", Actions._default.DeterministicMap$R, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(115,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    rs#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(116,16)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(s#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon14_LoopHead;

  anon14_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(rs#0);
    assume $w$loop#0 ==> (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, j#1), Seq#Index(rs#0, j#1)));
    assume $w$loop#0 ==> (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, j#1), Seq#Index(rs#0, j#1)));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon14_LoopDone, anon14_LoopBody;

  anon14_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(117,4): after some loop iterations"} true;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(rs#0);
    havoc j#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Lit(true);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= j#0;
    goto anon6;

  anon18_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon6;

  anon17_Else:
    assume {:partition} !Lit(true);
    goto anon6;

  anon6:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} true && LitInt(0) <= j#0 && j#0 < i#2;
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R), $Heap);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(rs#0);
    ##a#1 := Seq#Index(s#0, j#0);
    assume $IsAllocBox(##a#1, Actions._default.DeterministicMap$A, $Heap);
    ##r#1 := Seq#Index(rs#0, j#0);
    assume $IsAllocBox(##r#1, Actions._default.DeterministicMap$R, $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, j#0), Seq#Index(rs#0, j#0));
    goto anon8;

  anon19_Else:
    assume {:partition} !(true && LitInt(0) <= j#0 && j#0 < i#2);
    goto anon8;

  anon16_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, j#1), Seq#Index(rs#0, j#1)));
    assume (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, j#1), Seq#Index(rs#0, j#1)));
    assume false;
    goto anon9;

  anon15_Else:
    assume {:partition} $w$loop#0;
    goto anon9;

  anon9:
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} i#2 == i#2#hi;
    goto anon12;

  anon20_Else:
    assume {:partition} i#2 != i#2#hi;
    push;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#2);
    call CallPre$$Actions.DeterministicAction.Invoke(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, a##0_0);
    call $rhs##0_0 := CallPost$$Actions.DeterministicAction.Invoke(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, a##0_0);
    r#0_0 := $rhs##0_0;
    defass#r#0_0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(124,34)"} true;
    assume true;
    assume defass#r#0_0;
    assume true;
    rs#0 := Seq#Append(rs#0, Seq#Build(Seq#Empty(): Seq, r#0_0));
    assume {:captureState "StandardLibrary/src/Actions.dfy(125,20)"} true;
    pop;
    i#2 := i#2 + 1;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(rs#0) ==> (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, Seq#Index(s#0, j#1), Seq#Index(rs#0, j#1)));
    goto anon14_LoopHead;

  anon14_LoopDone:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume true;
    assume true;
    res#0 := rs#0;
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(127,13)"} true;
    assume defass#res#0;
    return;
}



function Tclass.Actions.DeterministicActionWithResult(Ty, Ty, Ty) : Ty;

const unique Tagclass.Actions.DeterministicActionWithResult: TyTag;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tag(Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Tagclass.Actions.DeterministicActionWithResult && TagFamily(Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == tytagFamily$DeterministicActionWithResult);

function Tclass.Actions.DeterministicActionWithResult_0(Ty) : Ty;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tclass.Actions.DeterministicActionWithResult_0(Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Actions.DeterministicActionWithResult$A);

function Tclass.Actions.DeterministicActionWithResult_1(Ty) : Ty;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tclass.Actions.DeterministicActionWithResult_1(Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Actions.DeterministicActionWithResult$R);

function Tclass.Actions.DeterministicActionWithResult_2(Ty) : Ty;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tclass.Actions.DeterministicActionWithResult_2(Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Actions.DeterministicActionWithResult$E);

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) } $IsBox(bx, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)));

procedure {:verboseName "Actions.DeterministicMapWithResult (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMapWithResult$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicMapWithResult$R), Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicMapWithResult$R), Actions._default.DeterministicMapWithResult$E), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicMapWithResult (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##a#0: Box;
  var ##r#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicMapWithResult", " | ", Actions._default.DeterministicMapWithResult$A, " | ", Actions._default.DeterministicMapWithResult$R, " | ", Actions._default.DeterministicMapWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(133,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(140,6): post-state"} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length(s#0) == Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
    goto anon4;

  anon13_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
    goto anon4;

  anon4:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Wrappers.Result.Success_q(res#0);
    havoc i#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Lit(true);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon9;

  anon17_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon9;

  anon16_Else:
    assume {:partition} !Lit(true);
    goto anon9;

  anon9:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} true && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)), $Heap);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume Wrappers.Result.Success_q(res#0);
    assume 0 <= i#0 && i#0 < Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
    ##a#0 := Seq#Index(s#0, i#0);
    assume $IsAllocBox(##a#0, Actions._default.DeterministicMapWithResult$A, $Heap);
    ##r#0 := #Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#0));
    assume $IsAlloc(##r#0, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#0), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#0))));
    goto anon11;

  anon18_Else:
    assume {:partition} !(true && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0));
    goto anon11;

  anon15_Else:
    assume {:partition} false;
    goto anon11;

  anon11:
    assume (forall i#1: int :: { Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1)))));
    return;

  anon14_Else:
    assume Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1)))));
    return;
}



procedure {:verboseName "Actions.DeterministicMapWithResult (call precondtion)"} CallPre$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMapWithResult$A), $Heap));



procedure {:verboseName "Actions.DeterministicMapWithResult (call postcondition)"} CallPost$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMapWithResult$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicMapWithResult$R), Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicMapWithResult$R), Actions._default.DeterministicMapWithResult$E), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19288"} Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
  free ensures Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1) } { Seq#Index(s#0, i#1) } Lit(true) ==> LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1)))));
  free ensures {:id "id19289"} Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1)))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.DeterministicMapWithResult (correctness)"} Impl$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicMapWithResult$A), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicMapWithResult$R), Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicMapWithResult$R), Actions._default.DeterministicMapWithResult$E), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19290"} Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
  free ensures Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1) } { Seq#Index(s#0, i#1) } Lit(true) ==> LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1)))));
  free ensures {:id "id19291"} Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1) } { Seq#Index(s#0, i#1) } true && LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index($Unbox(Wrappers.Result.value(res#0)): Seq, i#1)))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicMapWithResult (correctness)"} Impl$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var rs#0: Seq where $Is(rs#0, TSeq(Actions._default.DeterministicMapWithResult$R)) && $IsAlloc(rs#0, TSeq(Actions._default.DeterministicMapWithResult$R), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#0: int;
  var ##a#1: Box;
  var ##r#1: DatatypeType;
  var defass#r#0_0: bool;
  var r#0_0: Box where defass#r#0_0 ==> $IsBox(r#0_0, Actions._default.DeterministicMapWithResult$R) && $IsAllocBox(r#0_0, Actions._default.DeterministicMapWithResult$R, $Heap);
  var defass#valueOrError0#0_0: bool;
  var valueOrError0#0_0: DatatypeType where defass#valueOrError0#0_0 ==> $Is(valueOrError0#0_0, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(valueOrError0#0_0, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap);
  var $rhs##0_0: DatatypeType;
  var a##0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicMapWithResult", " | ", Actions._default.DeterministicMapWithResult$A, " | ", Actions._default.DeterministicMapWithResult$R, " | ", Actions._default.DeterministicMapWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(149,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    rs#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(150,16)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(s#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon18_LoopHead;

  anon18_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(rs#0);
    assume $w$loop#0 ==> (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(rs#0, j#1)))));
    assume $w$loop#0 ==> (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(rs#0, j#1)))));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon18_LoopDone, anon18_LoopBody;

  anon18_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(151,4): after some loop iterations"} true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(rs#0);
    havoc j#0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Lit(true);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= j#0;
    goto anon6;

  anon22_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon6;

  anon21_Else:
    assume {:partition} !Lit(true);
    goto anon6;

  anon6:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} true && LitInt(0) <= j#0 && j#0 < i#2;
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)), $Heap);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(rs#0);
    ##a#1 := Seq#Index(s#0, j#0);
    assume $IsAllocBox(##a#1, Actions._default.DeterministicMapWithResult$A, $Heap);
    ##r#1 := #Wrappers.Result.Success(Seq#Index(rs#0, j#0));
    assume $IsAlloc(##r#1, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, j#0), $Box(#Wrappers.Result.Success(Seq#Index(rs#0, j#0))));
    goto anon8;

  anon23_Else:
    assume {:partition} !(true && LitInt(0) <= j#0 && j#0 < i#2);
    goto anon8;

  anon20_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(rs#0, j#1)))));
    assume (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(rs#0, j#1)))));
    assume false;
    goto anon9;

  anon19_Else:
    assume {:partition} $w$loop#0;
    goto anon9;

  anon9:
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} i#2 == i#2#hi;
    goto anon16;

  anon24_Else:
    assume {:partition} i#2 != i#2#hi;
    push;
    havoc valueOrError0#0_0 /* where defass#valueOrError0#0_0 ==> $Is(valueOrError0#0_0, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E)) && $IsAlloc(valueOrError0#0_0, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap) */;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#2);
    call CallPre$$Actions.DeterministicActionWithResult.Invoke(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, action#0, a##0_0);
    call $rhs##0_0 := CallPost$$Actions.DeterministicActionWithResult.Invoke(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, action#0, a##0_0);
    valueOrError0#0_0 := $rhs##0_0;
    defass#valueOrError0#0_0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(158,34)"} true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    assume Wrappers.Result.IsFailure#canCall(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Result.IsFailure(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    push;
    assume true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0_0);
    assume Wrappers.Result.Failure_q(valueOrError0#0_0);
    assume Wrappers.Result.PropagateFailure#canCall(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, TSeq(Actions._default.DeterministicMapWithResult$R), valueOrError0#0_0);
    assume Wrappers.Result.PropagateFailure#canCall(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, TSeq(Actions._default.DeterministicMapWithResult$R), valueOrError0#0_0);
    res#0 := Wrappers.Result.PropagateFailure(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, TSeq(Actions._default.DeterministicMapWithResult$R), valueOrError0#0_0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(158,34)"} true;
    assume defass#res#0;
    pop;
    pop;
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    assume true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0_0);
    assume Wrappers.Result.Success_q(valueOrError0#0_0);
    assume Wrappers.Result.Extract#canCall(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    assume Wrappers.Result.Extract#canCall(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    r#0_0 := Wrappers.Result.Extract(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, valueOrError0#0_0);
    defass#r#0_0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(158,34)"} true;
    assume true;
    assume defass#r#0_0;
    assume true;
    rs#0 := Seq#Append(rs#0, Seq#Build(Seq#Empty(): Seq, r#0_0));
    assume {:captureState "StandardLibrary/src/Actions.dfy(159,20)"} true;
    pop;
    i#2 := i#2 + 1;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(rs#0) ==> (forall j#1: int :: { Seq#Index(rs#0, j#1) } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicMapWithResult$A, Tclass.Wrappers.Result(Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(rs#0, j#1)))));
    goto anon18_LoopHead;

  anon18_LoopDone:
    assume {:partition} false;
    goto anon16;

  anon16:
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(rs#0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(161,22)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Actions.DeterministicFlatMap (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R))) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R)), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMap$A), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(res#0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicFlatMap (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref, s#0: Seq) returns (res#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: Box;
  var fm#0: Seq;
  var ##a#0: Box;
  var ##r#0: Seq;
  var k#0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicFlatMap", " | ", Actions._default.DeterministicFlatMap$A, " | ", Actions._default.DeterministicFlatMap$R, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(170,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(176,6): post-state"} true;
    havoc i#0;
    assume $IsBox(i#0, Actions._default.DeterministicFlatMap$A) && $IsAllocBox(i#0, Actions._default.DeterministicFlatMap$A, $Heap);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Seq#Contains(s#0, i#0);
    assume true;
    havoc fm#0;
    assume $Is(fm#0, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(fm#0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R)), $Heap);
    ##a#0 := i#0;
    assume $IsAllocBox(##a#0, Actions._default.DeterministicFlatMap$A, $Heap);
    ##r#0 := fm#0;
    assume $IsAlloc(##r#0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#0, $Box(fm#0));
    assume Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#0, $Box(fm#0));
    havoc k#0;
    assume $IsBox(k#0, Actions._default.DeterministicFlatMap$R) && $IsAllocBox(k#0, Actions._default.DeterministicFlatMap$R, $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume Seq#Contains(fm#0, k#0);
    assume Seq#Contains(res#0, k#0);
    goto anon5;

  anon9_Else:
    assume Seq#Contains(fm#0, k#0) ==> Seq#Contains(res#0, k#0);
    goto anon5;

  anon5:
    assume (forall k#1: Box :: { Seq#Contains(res#0, k#1) } { Seq#Contains(fm#0, k#1) } $IsBox(k#1, Actions._default.DeterministicFlatMap$R) && Seq#Contains(fm#0, k#1) ==> Seq#Contains(res#0, k#1));
    goto anon7;

  anon8_Else:
    assume Seq#Contains(s#0, i#0) ==> true && (exists fm#1: Seq :: { Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#0, $Box(fm#1)) } $Is(fm#1, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(fm#1, TSeq(Actions._default.DeterministicFlatMap$R), $Heap) && Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#0, $Box(fm#1)) && (forall k#2: Box :: { Seq#Contains(res#0, k#2) } { Seq#Contains(fm#1, k#2) } $IsBox(k#2, Actions._default.DeterministicFlatMap$R) && Seq#Contains(fm#1, k#2) ==> Seq#Contains(res#0, k#2)));
    goto anon7;

  anon7:
    assume (forall i#1: Box :: { Seq#Contains(s#0, i#1) } $IsBox(i#1, Actions._default.DeterministicFlatMap$A) ==> Seq#Contains(s#0, i#1) ==> (exists fm#2: Seq :: { Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) } $Is(fm#2, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(fm#2, TSeq(Actions._default.DeterministicFlatMap$R), $Heap) && Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) && (forall k#3: Box :: { Seq#Contains(res#0, k#3) } { Seq#Contains(fm#2, k#3) } $IsBox(k#3, Actions._default.DeterministicFlatMap$R) && Seq#Contains(fm#2, k#3) ==> Seq#Contains(res#0, k#3))));
    return;
}



procedure {:verboseName "Actions.DeterministicFlatMap (call precondtion)"} CallPre$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R))) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R)), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMap$A), $Heap));



procedure {:verboseName "Actions.DeterministicFlatMap (call postcondition)"} CallPost$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R))) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R)), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMap$A), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(res#0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap));
  modifies $Heap;
  free ensures (forall i#1: Box :: { Seq#Contains(s#0, i#1) } $IsBox(i#1, Actions._default.DeterministicFlatMap$A) ==> Seq#Contains(s#0, i#1) ==> (forall fm#2: Seq :: { Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) } $Is(fm#2, TSeq(Actions._default.DeterministicFlatMap$R)) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2))));
  free ensures {:id "id19330"} (forall i#1: Box :: { Seq#Contains(s#0, i#1) } $IsBox(i#1, Actions._default.DeterministicFlatMap$A) ==> Seq#Contains(s#0, i#1) ==> (exists fm#2: Seq :: { Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) } $Is(fm#2, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(fm#2, TSeq(Actions._default.DeterministicFlatMap$R), $Heap) && Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) && (forall k#3: Box :: { Seq#Contains(res#0, k#3) } { Seq#Contains(fm#2, k#3) } $IsBox(k#3, Actions._default.DeterministicFlatMap$R) && Seq#Contains(fm#2, k#3) ==> Seq#Contains(res#0, k#3))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.DeterministicFlatMap (correctness)"} Impl$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R))) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R)), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMap$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMap$A), $Heap)) returns (defass#res#0: bool, res#0: Seq where defass#res#0 ==> $Is(res#0, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(res#0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall i#1: Box :: { Seq#Contains(s#0, i#1) } $IsBox(i#1, Actions._default.DeterministicFlatMap$A) ==> Seq#Contains(s#0, i#1) ==> (forall fm#2: Seq :: { Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) } $Is(fm#2, TSeq(Actions._default.DeterministicFlatMap$R)) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2))));
  free ensures {:id "id19331"} (forall i#1: Box :: { Seq#Contains(s#0, i#1) } $IsBox(i#1, Actions._default.DeterministicFlatMap$A) ==> Seq#Contains(s#0, i#1) ==> (exists fm#2: Seq :: { Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) } $Is(fm#2, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(fm#2, TSeq(Actions._default.DeterministicFlatMap$R), $Heap) && Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, i#1, $Box(fm#2)) && (forall k#3: Box :: { Seq#Contains(res#0, k#3) } { Seq#Contains(fm#2, k#3) } $IsBox(k#3, Actions._default.DeterministicFlatMap$R) && Seq#Contains(fm#2, k#3) ==> Seq#Contains(res#0, k#3))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicFlatMap (correctness)"} Impl$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var parts#0: Seq where $Is(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMap$R))) && $IsAlloc(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMap$R)), $Heap);
  var rs#0: Seq where $Is(rs#0, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(rs#0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#0: int;
  var ##a#1: Box;
  var ##r#1: Seq;
  var b#0: Box;
  var r#0_0: Seq where $Is(r#0_0, TSeq(Actions._default.DeterministicFlatMap$R)) && $IsAlloc(r#0_0, TSeq(Actions._default.DeterministicFlatMap$R), $Heap);
  var $rhs##0_0: Seq;
  var a##0_0: Box;
  var $tmp##0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicFlatMap", " | ", Actions._default.DeterministicFlatMap$A, " | ", Actions._default.DeterministicFlatMap$R, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(181,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    parts#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(182,25)"} true;
    assume true;
    assume true;
    rs#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(183,16)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(s#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon18_LoopHead;

  anon18_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(parts#0);
    assume $w$loop#0 ==> (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#1), Seq#Index(parts#0, j#1)));
    assume $w$loop#0 ==> (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } (true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#1), Seq#Index(parts#0, j#1))) && (true && LitInt(0) <= j#1 && j#1 < i#2 ==> (forall b#1: Box :: { Seq#Contains(rs#0, b#1) } { Seq#Contains($Unbox(Seq#Index(parts#0, j#1)): Seq, b#1) } $IsBox(b#1, Actions._default.DeterministicFlatMap$R) && Seq#Contains($Unbox(Seq#Index(parts#0, j#1)): Seq, b#1) ==> Seq#Contains(rs#0, b#1))));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon18_LoopDone, anon18_LoopBody;

  anon18_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(184,4): after some loop iterations"} true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(parts#0);
    havoc j#0;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Lit(true);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} LitInt(0) <= j#0;
    goto anon6;

  anon22_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon6;

  anon21_Else:
    assume {:partition} !Lit(true);
    goto anon6;

  anon6:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} true && LitInt(0) <= j#0 && j#0 < i#2;
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R)), $Heap);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(parts#0);
    ##a#1 := Seq#Index(s#0, j#0);
    assume $IsAllocBox(##a#1, Actions._default.DeterministicFlatMap$A, $Heap);
    ##r#1 := $Unbox(Seq#Index(parts#0, j#0)): Seq;
    assume $IsAlloc(##r#1, TSeq(Actions._default.DeterministicFlatMap$R), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#0), Seq#Index(parts#0, j#0));
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#0), Seq#Index(parts#0, j#0));
    havoc b#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} $IsBox(b#0, Actions._default.DeterministicFlatMap$R) && $IsAllocBox(b#0, Actions._default.DeterministicFlatMap$R, $Heap);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(parts#0);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} Seq#Contains($Unbox(Seq#Index(parts#0, j#0)): Seq, b#0);
    goto anon11;

  anon26_Else:
    assume {:partition} !Seq#Contains($Unbox(Seq#Index(parts#0, j#0)): Seq, b#0);
    goto anon11;

  anon25_Else:
    assume {:partition} !($IsBox(b#0, Actions._default.DeterministicFlatMap$R) && $IsAllocBox(b#0, Actions._default.DeterministicFlatMap$R, $Heap));
    goto anon11;

  anon11:
    goto anon12;

  anon24_Else:
    assume {:partition} !Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#0), Seq#Index(parts#0, j#0));
    goto anon12;

  anon23_Else:
    assume {:partition} !(true && LitInt(0) <= j#0 && j#0 < i#2);
    goto anon12;

  anon20_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#1), Seq#Index(parts#0, j#1)));
    assume (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } (true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#1), Seq#Index(parts#0, j#1))) && (true && LitInt(0) <= j#1 && j#1 < i#2 ==> (forall b#1: Box :: { Seq#Contains(rs#0, b#1) } { Seq#Contains($Unbox(Seq#Index(parts#0, j#1)): Seq, b#1) } $IsBox(b#1, Actions._default.DeterministicFlatMap$R) && Seq#Contains($Unbox(Seq#Index(parts#0, j#1)): Seq, b#1) ==> Seq#Contains(rs#0, b#1))));
    assume false;
    goto anon13;

  anon19_Else:
    assume {:partition} $w$loop#0;
    goto anon13;

  anon13:
    assume true;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} i#2 == i#2#hi;
    goto anon16;

  anon27_Else:
    assume {:partition} i#2 != i#2#hi;
    push;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#2);
    call CallPre$$Actions.DeterministicAction.Invoke(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, a##0_0);
    call $tmp##0_0 := CallPost$$Actions.DeterministicAction.Invoke(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, a##0_0);
    havoc $rhs##0_0;
    assume $rhs##0_0 == $Unbox($tmp##0_0): Seq;
    r#0_0 := $rhs##0_0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(192,34)"} true;
    assume true;
    assume true;
    rs#0 := Seq#Append(rs#0, r#0_0);
    assume {:captureState "StandardLibrary/src/Actions.dfy(193,18)"} true;
    assume true;
    assume true;
    parts#0 := Seq#Append(parts#0, Seq#Build(Seq#Empty(): Seq, $Box(r#0_0)));
    assume {:captureState "StandardLibrary/src/Actions.dfy(194,26)"} true;
    pop;
    i#2 := i#2 + 1;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(parts#0) ==> (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMap$A, TSeq(Actions._default.DeterministicFlatMap$R), action#0, Seq#Index(s#0, j#1), Seq#Index(parts#0, j#1)));
    goto anon18_LoopHead;

  anon18_LoopDone:
    assume {:partition} false;
    goto anon16;

  anon16:
    assume true;
    assume true;
    res#0 := rs#0;
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(196,13)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Actions.DeterministicFlatMapWithResult (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), parts#0: Seq where $Is(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R))) && $IsAlloc(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R)), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicFlatMapWithResult (well-formedness)"} CheckWellFormed$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType, parts#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##xs#0: Seq;
  var i#0: int;
  var ##a#0: Box;
  var ##r#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicFlatMapWithResult", " | ", Actions._default.DeterministicFlatMapWithResult$A, " | ", Actions._default.DeterministicFlatMapWithResult$R, " | ", Actions._default.DeterministicFlatMapWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(206,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0, parts#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(213,6): post-state"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length(s#0) == Seq#Length(parts#0);
    assume Wrappers.Result.Success_q(res#0);
    ##xs#0 := parts#0;
    assume $IsAlloc(##xs#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R)), $Heap);
    assume Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0);
    assume Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LZ), parts#0));
    havoc i#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon5;

  anon12_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon5;

  anon5:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)), $Heap);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume 0 <= i#0 && i#0 < Seq#Length(parts#0);
    ##a#0 := Seq#Index(s#0, i#0);
    assume $IsAllocBox(##a#0, Actions._default.DeterministicFlatMapWithResult$A, $Heap);
    ##r#0 := #Wrappers.Result.Success(Seq#Index(parts#0, i#0));
    assume $IsAlloc(##r#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#0), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#0))));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#0), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#0))));
    assume 0 <= i#0 && i#0 < Seq#Length(parts#0);
    assume Wrappers.Result.Success_q(res#0);
    goto anon8;

  anon14_Else:
    assume {:partition} !Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#0), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#0))));
    goto anon8;

  anon13_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < Seq#Length(s#0));
    goto anon8;

  anon11_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume (forall i#1: int :: { $Unbox(Seq#Index(parts#0, i#1)): Seq } { Seq#Index(s#0, i#1) } (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#1))))) && (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, i#1)): Seq), MultiSet#FromSeq($Unbox(Wrappers.Result.value(res#0)): Seq))));
    return;

  anon10_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length(parts#0) && Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LZ), parts#0)) && (forall i#1: int :: { $Unbox(Seq#Index(parts#0, i#1)): Seq } { Seq#Index(s#0, i#1) } (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#1))))) && (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, i#1)): Seq), MultiSet#FromSeq($Unbox(Wrappers.Result.value(res#0)): Seq))));
    return;
}



procedure {:verboseName "Actions.DeterministicFlatMapWithResult (call precondtion)"} CallPre$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A), $Heap));



procedure {:verboseName "Actions.DeterministicFlatMapWithResult (call postcondition)"} CallPost$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), parts#0: Seq where $Is(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R))) && $IsAlloc(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R)), $Heap));
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length(parts#0) ==> Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0) && (Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LZ), parts#0)) ==> (forall i#1: int :: { $Unbox(Seq#Index(parts#0, i#1)): Seq } { Seq#Index(s#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#1))))));
  free ensures {:id "id19365"} Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length(parts#0);
  free ensures {:id "id19366"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LS($LZ)), parts#0));
  free ensures {:id "id19367"} Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { $Unbox(Seq#Index(parts#0, i#1)): Seq } { Seq#Index(s#0, i#1) } (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#1))))) && (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, i#1)): Seq), MultiSet#FromSeq($Unbox(Wrappers.Result.value(res#0)): Seq))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.DeterministicFlatMapWithResult (correctness)"} Impl$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.DeterministicFlatMapWithResult$A), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap), defass#parts#0: bool, parts#0: Seq where defass#parts#0 ==> $Is(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R))) && $IsAlloc(parts#0, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R)), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length(parts#0) ==> Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0) && (Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LZ), parts#0)) ==> (forall i#1: int :: { $Unbox(Seq#Index(parts#0, i#1)): Seq } { Seq#Index(s#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#1))))));
  free ensures {:id "id19368"} Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) == Seq#Length(parts#0);
  free ensures {:id "id19369"} Wrappers.Result.Success_q(res#0) ==> Seq#Equal($Unbox(Wrappers.Result.value(res#0)): Seq, Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LS($LZ)), parts#0));
  free ensures {:id "id19370"} Wrappers.Result.Success_q(res#0) ==> (forall i#1: int :: { $Unbox(Seq#Index(parts#0, i#1)): Seq } { Seq#Index(s#0, i#1) } (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, i#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, i#1))))) && (LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, i#1)): Seq), MultiSet#FromSeq($Unbox(Wrappers.Result.value(res#0)): Seq))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicFlatMapWithResult (correctness)"} Impl$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: DatatypeType, defass#parts#0: bool, parts#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var rs#0: Seq where $Is(rs#0, TSeq(Actions._default.DeterministicFlatMapWithResult$R)) && $IsAlloc(rs#0, TSeq(Actions._default.DeterministicFlatMapWithResult$R), $Heap);
  var i#2: int;
  var i#2#lo: int;
  var i#2#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#parts#0: bool;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#0: int;
  var ##a#1: Box;
  var ##r#1: DatatypeType;
  var ##xs#1: Seq;
  var r#0_0: Seq where $Is(r#0_0, TSeq(Actions._default.DeterministicFlatMapWithResult$R)) && $IsAlloc(r#0_0, TSeq(Actions._default.DeterministicFlatMapWithResult$R), $Heap);
  var defass#valueOrError0#0_0: bool;
  var valueOrError0#0_0: DatatypeType where defass#valueOrError0#0_0 ==> $Is(valueOrError0#0_0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(valueOrError0#0_0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap);
  var $rhs##0_0: DatatypeType;
  var a##0_0: Box;
  var xs##0_0: Seq;
  var ys##0_0: Seq;
  var $rhs#0: DatatypeType;
  var $rhs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicFlatMapWithResult", " | ", Actions._default.DeterministicFlatMapWithResult$A, " | ", Actions._default.DeterministicFlatMapWithResult$R, " | ", Actions._default.DeterministicFlatMapWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(221,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    parts#0 := Lit(Seq#Empty(): Seq);
    defass#parts#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(222,15)"} true;
    assume true;
    assume true;
    rs#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(223,16)"} true;
    i#2#lo := LitInt(0);
    i#2#hi := Seq#Length(s#0);
    assume i#2#lo <= i#2#hi;
    i#2 := i#2#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#parts#0 := defass#parts#0;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon19_LoopHead;

  anon19_LoopHead:
    assume i#2#lo <= i#2 && i#2 <= i#2#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(parts#0);
    assume $w$loop#0 ==> (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#1)))));
    assume $w$loop#0 ==> (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } (true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#1))))) && (true && LitInt(0) <= j#1 && j#1 < i#2 ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, j#1)): Seq), MultiSet#FromSeq(rs#0))));
    assume $w$loop#0 ==> Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0);
    assume $w$loop#0 ==> Seq#Equal(Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LS($LZ)), parts#0), rs#0);
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#parts#0 ==> defass#parts#0;
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon19_LoopDone, anon19_LoopBody;

  anon19_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(224,4): after some loop iterations"} true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#2 && i#2 <= Seq#Length(s#0);
    assume defass#parts#0;
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(parts#0);
    havoc j#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Lit(true);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= j#0;
    goto anon6;

  anon23_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon6;

  anon22_Else:
    assume {:partition} !Lit(true);
    goto anon6;

  anon6:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true && LitInt(0) <= j#0 && j#0 < i#2;
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)), $Heap);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(s#0);
    assume defass#parts#0;
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(parts#0);
    ##a#1 := Seq#Index(s#0, j#0);
    assume $IsAllocBox(##a#1, Actions._default.DeterministicFlatMapWithResult$A, $Heap);
    ##r#1 := #Wrappers.Result.Success(Seq#Index(parts#0, j#0));
    assume $IsAlloc(##r#1, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#0), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#0))));
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#0), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#0))));
    assume defass#parts#0;
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(parts#0);
    goto anon9;

  anon25_Else:
    assume {:partition} !Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#0), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#0))));
    goto anon9;

  anon24_Else:
    assume {:partition} !(true && LitInt(0) <= j#0 && j#0 < i#2);
    goto anon9;

  anon21_Else:
    assume {:partition} false;
    goto anon9;

  anon9:
    assume (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#1)))));
    assume (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } (true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#1))))) && (true && LitInt(0) <= j#1 && j#1 < i#2 ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, j#1)): Seq), MultiSet#FromSeq(rs#0))));
    assume defass#parts#0;
    ##xs#1 := parts#0;
    assume $IsAlloc(##xs#1, TSeq(TSeq(Actions._default.DeterministicFlatMapWithResult$R)), $Heap);
    assume Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0);
    assume Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0);
    assume Seq#Equal(Seq.__default.Flatten(Actions._default.DeterministicFlatMapWithResult$R, $LS($LZ), parts#0), rs#0);
    assume false;
    goto anon10;

  anon20_Else:
    assume {:partition} $w$loop#0;
    goto anon10;

  anon10:
    assume true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} i#2 == i#2#hi;
    goto anon17;

  anon26_Else:
    assume {:partition} i#2 != i#2#hi;
    push;
    havoc valueOrError0#0_0 /* where defass#valueOrError0#0_0 ==> $Is(valueOrError0#0_0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E)) && $IsAlloc(valueOrError0#0_0, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap) */;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#2 && i#2 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#2);
    call CallPre$$Actions.DeterministicActionWithResult.Invoke(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, action#0, a##0_0);
    call $rhs##0_0 := CallPost$$Actions.DeterministicActionWithResult.Invoke(Actions._default.DeterministicFlatMapWithResult$A, TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, action#0, a##0_0);
    valueOrError0#0_0 := $rhs##0_0;
    defass#valueOrError0#0_0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(233,34)"} true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0);
    push;
    assume true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0_0);
    assume Wrappers.Result.Failure_q(valueOrError0#0_0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, TSeq(Actions._default.DeterministicFlatMapWithResult$R), valueOrError0#0_0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, TSeq(Actions._default.DeterministicFlatMapWithResult$R), valueOrError0#0_0);
    res#0 := Wrappers.Result.PropagateFailure(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, TSeq(Actions._default.DeterministicFlatMapWithResult$R), valueOrError0#0_0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(233,34)"} true;
    assume defass#res#0;
    assume defass#parts#0;
    pop;
    pop;
    return;

  anon27_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0);
    assume true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0_0);
    assume Wrappers.Result.Success_q(valueOrError0#0_0);
    assume Wrappers.Result.Extract#canCall(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0);
    assume Wrappers.Result.Extract#canCall(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0);
    r#0_0 := $Unbox(Wrappers.Result.Extract(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E, valueOrError0#0_0)): Seq;
    assume {:captureState "StandardLibrary/src/Actions.dfy(233,34)"} true;
    assume true;
    assume true;
    rs#0 := Seq#Append(rs#0, r#0_0);
    assume {:captureState "StandardLibrary/src/Actions.dfy(234,18)"} true;
    assume defass#parts#0;
    assume true;
    xs##0_0 := parts#0;
    assume true;
    ys##0_0 := Seq#Build(Seq#Empty(): Seq, $Box(r#0_0));
    call CallPre$$Seq.__default.LemmaFlattenConcat(Actions._default.DeterministicFlatMapWithResult$R, xs##0_0, ys##0_0);
    call CallPost$$Seq.__default.LemmaFlattenConcat(Actions._default.DeterministicFlatMapWithResult$R, xs##0_0, ys##0_0);
    assume {:captureState "StandardLibrary/src/Actions.dfy(235,36)"} true;
    assume true;
    assume defass#parts#0;
    assume true;
    parts#0 := Seq#Append(parts#0, Seq#Build(Seq#Empty(): Seq, $Box(r#0_0)));
    defass#parts#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(236,26)"} true;
    pop;
    i#2 := i#2 + 1;
    assume Seq#Length(Seq#Take(s#0, i#2)) == Seq#Length(parts#0) ==> (forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } Lit(true) ==> LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#1))))) && ((forall j#1: int :: { $Unbox(Seq#Index(parts#0, j#1)): Seq } { Seq#Index(s#0, j#1) } (true && LitInt(0) <= j#1 && j#1 < i#2 ==> Actions.DeterministicAction.Ensures(Actions._default.DeterministicFlatMapWithResult$A, Tclass.Wrappers.Result(TSeq(Actions._default.DeterministicFlatMapWithResult$R), Actions._default.DeterministicFlatMapWithResult$E), action#0, Seq#Index(s#0, j#1), $Box(#Wrappers.Result.Success(Seq#Index(parts#0, j#1))))) && (true && LitInt(0) <= j#1 && j#1 < i#2 ==> MultiSet#Subset(MultiSet#FromSeq($Unbox(Seq#Index(parts#0, j#1)): Seq), MultiSet#FromSeq(rs#0)))) ==> Seq.__default.Flatten#canCall(Actions._default.DeterministicFlatMapWithResult$R, parts#0));
    goto anon19_LoopHead;

  anon19_LoopDone:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume true;
    assume true;
    assume true;
    $rhs#0 := #Wrappers.Result.Success($Box(rs#0));
    assume defass#parts#0;
    assume true;
    $rhs#1 := parts#0;
    res#0 := $rhs#0;
    defass#res#0 := true;
    parts#0 := $rhs#1;
    defass#parts#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(238,29)"} true;
    assume defass#res#0;
    assume defass#parts#0;
    return;
}



procedure {:verboseName "Actions.Filter (well-formedness)"} CheckWellFormed$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(s#0, TSeq(Actions._default.Filter$A), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(res#0, TSeq(Actions._default.Filter$A), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.Filter (well-formedness)"} CheckWellFormed$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref, s#0: Seq) returns (res#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var j#0: Box;
  var ##a#0: Box;
  var ##r#0: bool;

  anon0:
    assume {:print "Impl", " | ", "Actions.Filter", " | ", Actions._default.Filter$A, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(246,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(251,16): post-state"} true;
    assume Seq#Length(s#0) >= Seq#Length(res#0);
    havoc j#0;
    assume $IsBox(j#0, Actions._default.Filter$A) && $IsAllocBox(j#0, Actions._default.Filter$A, $Heap);
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume Seq#Contains(res#0, j#0);
    assume Seq#Contains(s#0, j#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.Filter$A, TBool), $Heap);
    ##a#0 := j#0;
    assume $IsAllocBox(##a#0, Actions._default.Filter$A, $Heap);
    ##r#0 := Lit(true);
    assume $IsAlloc(##r#0, TBool, $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#0, $Box(Lit(true)));
    assume Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#0, $Box(Lit(true)));
    goto anon4;

  anon5_Else:
    assume Seq#Contains(res#0, j#0) ==> Seq#Contains(s#0, j#0) && Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#0, $Box(Lit(true)));
    goto anon4;

  anon4:
    assume (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(true)) } { Seq#Contains(s#0, j#1) } { Seq#Contains(res#0, j#1) } $IsBox(j#1, Actions._default.Filter$A) ==> (Seq#Contains(res#0, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains(res#0, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(Lit(true)))));
    return;
}



procedure {:verboseName "Actions.Filter (call precondtion)"} CallPre$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(s#0, TSeq(Actions._default.Filter$A), $Heap));



procedure {:verboseName "Actions.Filter (call postcondition)"} CallPost$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(s#0, TSeq(Actions._default.Filter$A), $Heap)) returns (res#0: Seq where $Is(res#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(res#0, TSeq(Actions._default.Filter$A), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19425"} Seq#Length(s#0) >= Seq#Length(res#0);
  free ensures (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(true)) } { Seq#Contains(s#0, j#1) } { Seq#Contains(res#0, j#1) } $IsBox(j#1, Actions._default.Filter$A) ==> (Seq#Contains(res#0, j#1) ==> Seq#Contains(s#0, j#1)) ==> Seq#Contains(res#0, j#1) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#1, $Box(Lit(true))));
  free ensures {:id "id19426"} (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(true)) } { Seq#Contains(s#0, j#1) } { Seq#Contains(res#0, j#1) } $IsBox(j#1, Actions._default.Filter$A) ==> (Seq#Contains(res#0, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains(res#0, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(Lit(true)))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.Filter (correctness)"} Impl$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool)) && $IsAlloc(action#0, Tclass.Actions.DeterministicAction(Actions._default.Filter$A, TBool), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(s#0, TSeq(Actions._default.Filter$A), $Heap)) returns (defass#res#0: bool, res#0: Seq where defass#res#0 ==> $Is(res#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(res#0, TSeq(Actions._default.Filter$A), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19427"} Seq#Length(s#0) >= Seq#Length(res#0);
  free ensures (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(true)) } { Seq#Contains(s#0, j#1) } { Seq#Contains(res#0, j#1) } $IsBox(j#1, Actions._default.Filter$A) ==> (Seq#Contains(res#0, j#1) ==> Seq#Contains(s#0, j#1)) ==> Seq#Contains(res#0, j#1) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#1, $Box(Lit(true))));
  free ensures {:id "id19428"} (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(true)) } { Seq#Contains(s#0, j#1) } { Seq#Contains(res#0, j#1) } $IsBox(j#1, Actions._default.Filter$A) ==> (Seq#Contains(res#0, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains(res#0, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#1, $Box(Lit(true)))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.Filter (correctness)"} Impl$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var rs#0: Seq where $Is(rs#0, TSeq(Actions._default.Filter$A)) && $IsAlloc(rs#0, TSeq(Actions._default.Filter$A), $Heap);
  var i#0: int;
  var i#0#lo: int;
  var i#0#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#2: Box;
  var ##a#1: Box;
  var ##r#1: bool;
  var r#0_0: bool;
  var $rhs##0_0: bool;
  var a##0_0: Box;
  var $tmp##0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.Filter", " | ", Actions._default.Filter$A, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(258,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    rs#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(259,16)"} true;
    i#0#lo := LitInt(0);
    i#0#hi := Seq#Length(s#0);
    assume i#0#lo <= i#0#hi;
    i#0 := i#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon15_LoopHead;

  anon15_LoopHead:
    assume i#0#lo <= i#0 && i#0 <= i#0#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#0)) >= Seq#Length(rs#0);
    assume $w$loop#0 ==> (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(true)) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.Filter$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) ==> Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#3, $Box(Lit(true))));
    assume $w$loop#0 ==> (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(true)) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.Filter$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) && (Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(Lit(true)))));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon15_LoopDone, anon15_LoopBody;

  anon15_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(260,4): after some loop iterations"} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#0)) >= Seq#Length(rs#0);
    havoc j#2;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $IsBox(j#2, Actions._default.Filter$A) && $IsAllocBox(j#2, Actions._default.Filter$A, $Heap);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Seq#Contains(rs#0, j#2);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Seq#Contains(s#0, j#2);
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.Filter$A, TBool), $Heap);
    ##a#1 := j#2;
    assume $IsAllocBox(##a#1, Actions._default.Filter$A, $Heap);
    ##r#1 := Lit(true);
    assume $IsAlloc(##r#1, TBool, $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#2, $Box(Lit(true)));
    goto anon6;

  anon19_Else:
    assume {:partition} !Seq#Contains(s#0, j#2);
    goto anon6;

  anon18_Else:
    assume {:partition} !Seq#Contains(rs#0, j#2);
    goto anon6;

  anon17_Else:
    assume {:partition} !($IsBox(j#2, Actions._default.Filter$A) && $IsAllocBox(j#2, Actions._default.Filter$A, $Heap));
    goto anon6;

  anon6:
    assume (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(true)) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.Filter$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) ==> Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#3, $Box(Lit(true))));
    assume (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(true)) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.Filter$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) && (Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(Lit(true)))));
    assume false;
    goto anon7;

  anon16_Else:
    assume {:partition} $w$loop#0;
    goto anon7;

  anon7:
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} i#0 == i#0#hi;
    goto anon13;

  anon20_Else:
    assume {:partition} i#0 != i#0#hi;
    push;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#0);
    call CallPre$$Actions.DeterministicAction.Invoke(Actions._default.Filter$A, TBool, action#0, a##0_0);
    call $tmp##0_0 := CallPost$$Actions.DeterministicAction.Invoke(Actions._default.Filter$A, TBool, action#0, a##0_0);
    havoc $rhs##0_0;
    assume $rhs##0_0 <==> $Unbox($tmp##0_0): bool;
    r#0_0 := $rhs##0_0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(268,34)"} true;
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} r#0_0;
    push;
    assume true;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume true;
    rs#0 := Seq#Append(rs#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, i#0)));
    assume {:captureState "StandardLibrary/src/Actions.dfy(270,25)"} true;
    pop;
    goto anon12;

  anon21_Else:
    assume {:partition} !r#0_0;
    goto anon12;

  anon12:
    pop;
    i#0 := i#0 + 1;
    assume Seq#Length(Seq#Take(s#0, i#0)) >= Seq#Length(rs#0) ==> (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.Filter$A, TBool, action#0, j#3, $Box(true)) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.Filter$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) ==> Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.Filter$A, TBool, action#0, j#3, $Box(Lit(true))));
    goto anon15_LoopHead;

  anon15_LoopDone:
    assume {:partition} false;
    goto anon13;

  anon13:
    assume true;
    assume true;
    res#0 := rs#0;
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(273,13)"} true;
    assume defass#res#0;
    return;
}



procedure {:verboseName "Actions.FilterWithResult (well-formedness)"} CheckWellFormed$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.FilterWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.FilterWithResult$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.FilterWithResult$A), Actions._default.FilterWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.FilterWithResult$A), Actions._default.FilterWithResult$E), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.FilterWithResult (well-formedness)"} CheckWellFormed$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var j#0: Box;
  var ##a#0: Box;
  var ##r#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "Actions.FilterWithResult", " | ", Actions._default.FilterWithResult$A, " | ", Actions._default.FilterWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(279,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(286,6): post-state"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Length(s#0) >= Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
    havoc j#0;
    assume $IsBox(j#0, Actions._default.FilterWithResult$A) && $IsAllocBox(j#0, Actions._default.FilterWithResult$A, $Heap);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(res#0);
    assume Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#0);
    assume Seq#Contains(s#0, j#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E)), $Heap);
    ##a#0 := j#0;
    assume $IsAllocBox(##a#0, Actions._default.FilterWithResult$A, $Heap);
    ##r#0 := Lit(#Wrappers.Result.Success($Box(Lit(true))));
    assume $IsAlloc(##r#0, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#0, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))));
    assume Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#0, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))));
    goto anon5;

  anon8_Else:
    assume Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#0) ==> Seq#Contains(s#0, j#0) && Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#0, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))));
    goto anon5;

  anon5:
    assume (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#1) } { Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) } $IsBox(j#1, Actions._default.FilterWithResult$A) ==> (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))))));
    return;

  anon7_Else:
    assume Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) >= Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) && (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#1) } { Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) } $IsBox(j#1, Actions._default.FilterWithResult$A) ==> (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))))));
    return;
}



procedure {:verboseName "Actions.FilterWithResult (call precondtion)"} CallPre$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.FilterWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.FilterWithResult$A), $Heap));



procedure {:verboseName "Actions.FilterWithResult (call postcondition)"} CallPost$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.FilterWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.FilterWithResult$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.FilterWithResult$A), Actions._default.FilterWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.FilterWithResult$A), Actions._default.FilterWithResult$E), $Heap));
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) >= Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) ==> (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#1) } { Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) } $IsBox(j#1, Actions._default.FilterWithResult$A) ==> (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Seq#Contains(s#0, j#1)) ==> Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true)))))));
  free ensures {:id "id19458"} Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) >= Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
  free ensures {:id "id19459"} Wrappers.Result.Success_q(res#0) ==> (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#1) } { Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) } $IsBox(j#1, Actions._default.FilterWithResult$A) ==> (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.FilterWithResult (correctness)"} Impl$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E)) && $IsAlloc(action#0, Tclass.Actions.DeterministicActionWithResult(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.FilterWithResult$A)) && $IsAlloc(s#0, TSeq(Actions._default.FilterWithResult$A), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.FilterWithResult$A), Actions._default.FilterWithResult$E)) && $IsAlloc(res#0, Tclass.Wrappers.Result(TSeq(Actions._default.FilterWithResult$A), Actions._default.FilterWithResult$E), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) >= Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq) ==> (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#1) } { Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) } $IsBox(j#1, Actions._default.FilterWithResult$A) ==> (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Seq#Contains(s#0, j#1)) ==> Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true)))))));
  free ensures {:id "id19460"} Wrappers.Result.Success_q(res#0) ==> Seq#Length(s#0) >= Seq#Length($Unbox(Wrappers.Result.value(res#0)): Seq);
  free ensures {:id "id19461"} Wrappers.Result.Success_q(res#0) ==> (forall j#1: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#1) } { Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) } $IsBox(j#1, Actions._default.FilterWithResult$A) ==> (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Seq#Contains(s#0, j#1)) && (Seq#Contains($Unbox(Wrappers.Result.value(res#0)): Seq, j#1) ==> Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#1, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))))));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.FilterWithResult (correctness)"} Impl$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var rs#0: Seq where $Is(rs#0, TSeq(Actions._default.FilterWithResult$A)) && $IsAlloc(rs#0, TSeq(Actions._default.FilterWithResult$A), $Heap);
  var i#0: int;
  var i#0#lo: int;
  var i#0#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#2: Box;
  var ##a#1: Box;
  var ##r#1: DatatypeType;
  var r#0_0: bool;
  var defass#valueOrError0#0_0: bool;
  var valueOrError0#0_0: DatatypeType where defass#valueOrError0#0_0 ==> $Is(valueOrError0#0_0, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E)) && $IsAlloc(valueOrError0#0_0, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap);
  var $rhs##0_0: DatatypeType;
  var a##0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "Actions.FilterWithResult", " | ", Actions._default.FilterWithResult$A, " | ", Actions._default.FilterWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "StandardLibrary/src/Actions.dfy(293,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    rs#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(294,16)"} true;
    i#0#lo := LitInt(0);
    i#0#hi := Seq#Length(s#0);
    assume i#0#lo <= i#0#hi;
    i#0 := i#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon19_LoopHead;

  anon19_LoopHead:
    assume i#0#lo <= i#0 && i#0 <= i#0#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#0)) >= Seq#Length(rs#0);
    assume $w$loop#0 ==> (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.FilterWithResult$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) ==> Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true)))))));
    assume $w$loop#0 ==> (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.FilterWithResult$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) && (Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))))));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon19_LoopDone, anon19_LoopBody;

  anon19_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(295,4): after some loop iterations"} true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(s#0);
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#0)) >= Seq#Length(rs#0);
    havoc j#2;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $IsBox(j#2, Actions._default.FilterWithResult$A) && $IsAllocBox(j#2, Actions._default.FilterWithResult$A, $Heap);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Contains(rs#0, j#2);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Contains(s#0, j#2);
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.DeterministicAction?(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E)), $Heap);
    ##a#1 := j#2;
    assume $IsAllocBox(##a#1, Actions._default.FilterWithResult$A, $Heap);
    ##r#1 := Lit(#Wrappers.Result.Success($Box(Lit(true))));
    assume $IsAlloc(##r#1, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap);
    assume Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#2, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))));
    goto anon6;

  anon23_Else:
    assume {:partition} !Seq#Contains(s#0, j#2);
    goto anon6;

  anon22_Else:
    assume {:partition} !Seq#Contains(rs#0, j#2);
    goto anon6;

  anon21_Else:
    assume {:partition} !($IsBox(j#2, Actions._default.FilterWithResult$A) && $IsAllocBox(j#2, Actions._default.FilterWithResult$A, $Heap));
    goto anon6;

  anon6:
    assume (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.FilterWithResult$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) ==> Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true)))))));
    assume (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.FilterWithResult$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) && (Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true))))))));
    assume false;
    goto anon7;

  anon20_Else:
    assume {:partition} $w$loop#0;
    goto anon7;

  anon7:
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} i#0 == i#0#hi;
    goto anon17;

  anon24_Else:
    assume {:partition} i#0 != i#0#hi;
    push;
    havoc valueOrError0#0_0 /* where defass#valueOrError0#0_0 ==> $Is(valueOrError0#0_0, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E)) && $IsAlloc(valueOrError0#0_0, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap) */;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#0);
    call CallPre$$Actions.DeterministicActionWithResult.Invoke(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E, action#0, a##0_0);
    call $rhs##0_0 := CallPost$$Actions.DeterministicActionWithResult.Invoke(Actions._default.FilterWithResult$A, TBool, Actions._default.FilterWithResult$E, action#0, a##0_0);
    valueOrError0#0_0 := $rhs##0_0;
    defass#valueOrError0#0_0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(303,34)"} true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0);
    assume Wrappers.Result.IsFailure#canCall(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Result.IsFailure(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0);
    push;
    assume true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0_0);
    assume Wrappers.Result.Failure_q(valueOrError0#0_0);
    assume Wrappers.Result.PropagateFailure#canCall(TBool, Actions._default.FilterWithResult$E, TSeq(Actions._default.FilterWithResult$A), valueOrError0#0_0);
    assume Wrappers.Result.PropagateFailure#canCall(TBool, Actions._default.FilterWithResult$E, TSeq(Actions._default.FilterWithResult$A), valueOrError0#0_0);
    res#0 := Wrappers.Result.PropagateFailure(TBool, Actions._default.FilterWithResult$E, TSeq(Actions._default.FilterWithResult$A), valueOrError0#0_0);
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(303,34)"} true;
    assume defass#res#0;
    pop;
    pop;
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0);
    assume true;
    assume defass#valueOrError0#0_0;
    assume $IsAllocBox($Box(valueOrError0#0_0), Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0_0);
    assume Wrappers.Result.Success_q(valueOrError0#0_0);
    assume Wrappers.Result.Extract#canCall(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0);
    assume Wrappers.Result.Extract#canCall(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0);
    r#0_0 := $Unbox(Wrappers.Result.Extract(TBool, Actions._default.FilterWithResult$E, valueOrError0#0_0)): bool;
    assume {:captureState "StandardLibrary/src/Actions.dfy(303,34)"} true;
    assume true;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} r#0_0;
    push;
    assume true;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume true;
    rs#0 := Seq#Append(rs#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(s#0, i#0)));
    assume {:captureState "StandardLibrary/src/Actions.dfy(305,25)"} true;
    pop;
    goto anon16;

  anon26_Else:
    assume {:partition} !r#0_0;
    goto anon16;

  anon16:
    pop;
    i#0 := i#0 + 1;
    assume Seq#Length(Seq#Take(s#0, i#0)) >= Seq#Length(rs#0) ==> (forall j#3: Box :: { Actions.DeterministicAction.Ensures(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(#Wrappers.Result.Success($Box(true)))) } { Seq#Contains(s#0, j#3) } { Seq#Contains(rs#0, j#3) } $IsBox(j#3, Actions._default.FilterWithResult$A) ==> (Seq#Contains(rs#0, j#3) ==> Seq#Contains(s#0, j#3)) ==> Seq#Contains(rs#0, j#3) ==> Actions.DeterministicAction.Ensures#canCall(Actions._default.FilterWithResult$A, Tclass.Wrappers.Result(TBool, Actions._default.FilterWithResult$E), action#0, j#3, $Box(Lit(#Wrappers.Result.Success($Box(Lit(true)))))));
    goto anon19_LoopHead;

  anon19_LoopDone:
    assume {:partition} false;
    goto anon17;

  anon17:
    assume true;
    assume true;
    res#0 := #Wrappers.Result.Success($Box(rs#0));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(308,22)"} true;
    assume defass#res#0;
    return;
}



function Tclass.Actions.ActionWithResult(Ty, Ty, Ty) : Ty;

const unique Tagclass.Actions.ActionWithResult: TyTag;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tag(Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Tagclass.Actions.ActionWithResult && TagFamily(Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == tytagFamily$ActionWithResult);

function Tclass.Actions.ActionWithResult_0(Ty) : Ty;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tclass.Actions.ActionWithResult_0(Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Actions.ActionWithResult$A);

function Tclass.Actions.ActionWithResult_1(Ty) : Ty;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tclass.Actions.ActionWithResult_1(Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Actions.ActionWithResult$R);

function Tclass.Actions.ActionWithResult_2(Ty) : Ty;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tclass.Actions.ActionWithResult_2(Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Actions.ActionWithResult$E);

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) } $IsBox(bx, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)));

function Tclass.Actions.ActionInvoke(Ty, Ty) : Ty;

const unique Tagclass.Actions.ActionInvoke: TyTag;

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty :: { Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R) } Tag(Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) == Tagclass.Actions.ActionInvoke && TagFamily(Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) == tytagFamily$ActionInvoke);

function Tclass.Actions.ActionInvoke_0(Ty) : Ty;

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty :: { Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R) } Tclass.Actions.ActionInvoke_0(Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) == Actions.ActionInvoke$A);

function Tclass.Actions.ActionInvoke_1(Ty) : Ty;

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty :: { Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R) } Tclass.Actions.ActionInvoke_1(Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) == Actions.ActionInvoke$R);

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) } $IsBox(bx, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)));

procedure {:verboseName "Actions.ReduceToSuccess (well-formedness)"} CheckWellFormed$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)) && $IsAlloc(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.ReduceToSuccess$A)) && $IsAlloc(s#0, TSeq(Actions._default.ReduceToSuccess$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, TSeq(Actions._default.ReduceToSuccess$E))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, TSeq(Actions._default.ReduceToSuccess$E)), $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function Actions.Action.Modifies(Actions.Action$A: Ty, Actions.Action$R: Ty, this: ref) : Set
uses {
axiom 0 < $FunctionContextHeight ==> (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $o: ref :: { Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, $o) } $o != null && $Is($o, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) ==> $Is(Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, $o), TSet(Tclass._System.object())));
axiom 0 < $FunctionContextHeight ==> (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $h: Heap, $o: ref :: { Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && $Is($o, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, $o), TSet(Tclass._System.object()), $h));
}

function Tclass.Actions.Action?(Ty, Ty) : Ty;

const unique Tagclass.Actions.Action?: TyTag;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty :: { Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R) } Tag(Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) == Tagclass.Actions.Action? && TagFamily(Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) == tytagFamily$Action);

function Tclass.Actions.Action?_0(Ty) : Ty;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty :: { Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R) } Tclass.Actions.Action?_0(Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) == Actions.Action$A);

function Tclass.Actions.Action?_1(Ty) : Ty;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty :: { Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R) } Tclass.Actions.Action?_1(Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) == Actions.Action$R);

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) } $IsBox(bx, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.ReduceToSuccess (well-formedness)"} CheckWellFormed$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType, attemptsState#0: Seq)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var i#0: int;
  var ##xs#0: Seq;
  var ##xs#1: Seq;
  var ##xs#2: Seq;
  var ##xs#3: Seq;
  var ##xs#4: Seq;
  var ##a#0: Box;
  var ##r#0: DatatypeType;
  var ##attemptsState#0: Seq;
  var i#2: int;
  var ##xs#5: Seq;
  var i#4: int;

  anon0:
    assume {:print "Impl", " | ", "Actions.ReduceToSuccess", " | ", Actions._default.ReduceToSuccess$A, " | ", Actions._default.ReduceToSuccess$B, " | ", Actions._default.ReduceToSuccess$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)]);
    assume {:captureState "StandardLibrary/src/Actions.dfy(318,9): initial state"} true;
    assume 0 < Seq#Length(s#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.Action?(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), $Heap);
    assume Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume action#0 != null;
    assume action#0 != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc res#0, attemptsState#0;
    assume {:captureState "StandardLibrary/src/Actions.dfy(330,14): post-state"} true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} 0 < Seq#Length(attemptsState#0);
    goto anon3;

  anon21_Else:
    assume {:partition} Seq#Length(attemptsState#0) <= 0;
    goto anon3;

  anon3:
    assume 0 < Seq#Length(attemptsState#0) && Seq#Length(attemptsState#0) <= Seq#Length(s#0);
    havoc i#0;
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon6;

  anon23_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon6;

  anon6:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(attemptsState#0);
    assume 0 <= i#0 && i#0 < Seq#Length(attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#0)): DatatypeType);
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, i#0)): DatatypeType) == Seq#Index(s#0, i#0);
    goto anon8;

  anon22_Else:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, i#0)): DatatypeType) == Seq#Index(s#0, i#0);
    goto anon8;

  anon8:
    assume (forall i#1: int :: { Seq#Index(s#0, i#1) } { $Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType) == Seq#Index(s#0, i#1));
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.Action?(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), $Heap);
    assume Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume Wrappers.Result.Success_q(res#0);
    ##xs#0 := attemptsState#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#0) > 0;
    assume Seq#Length(##xs#0) > 0;
    assume Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume Wrappers.Result.Success_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType);
    ##xs#1 := attemptsState#0;
    assume $IsAlloc(##xs#1, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#1) > 0;
    assume Seq#Length(##xs#1) > 0;
    assume Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume Wrappers.Result.Success_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType);
    assume Wrappers.Result.Success_q(res#0);
    assume Wrappers.Result.value($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) == Wrappers.Result.value(res#0);
    assume action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.Action?(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), $Heap);
    ##xs#2 := attemptsState#0;
    assume $IsAlloc(##xs#2, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#2) > 0;
    assume Seq#Length(##xs#2) > 0;
    assume Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    ##xs#3 := attemptsState#0;
    assume $IsAlloc(##xs#3, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#3) > 0;
    assume Seq#Length(##xs#3) > 0;
    assume Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    ##xs#4 := attemptsState#0;
    assume $IsAlloc(##xs#4, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#4) > 0;
    assume Seq#Length(##xs#4) > 0;
    assume Seq.__default.DropLast#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    ##a#0 := Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType);
    assume $IsAllocBox(##a#0, Actions._default.ReduceToSuccess$A, $Heap);
    ##r#0 := $Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType;
    assume $IsAlloc(##r#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap);
    ##attemptsState#0 := Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    assume $IsAlloc(##attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume Actions.Action.Ensures#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0));
    assume Actions.Action.Ensures(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0));
    havoc i#2;
    assume true;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= i#2;
    ##xs#5 := attemptsState#0;
    assume $IsAlloc(##xs#5, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap);
    assume {:subsumption 0} Seq#Length(##xs#5) > 0;
    assume Seq#Length(##xs#5) > 0;
    assume Seq.__default.DropLast#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0);
    goto anon12;

  anon26_Else:
    assume {:partition} i#2 < LitInt(0);
    goto anon12;

  anon12:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0));
    assume 0 <= i#2 && i#2 < Seq#Length(attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#2)): DatatypeType);
    assume Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#2)): DatatypeType)): DatatypeType);
    goto anon14;

  anon25_Else:
    assume LitInt(0) <= i#2 && i#2 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#2)): DatatypeType)): DatatypeType);
    goto anon14;

  anon14:
    assume (forall i#3: int :: { $Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType } LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType)): DatatypeType));
    return;

  anon24_Else:
    assume !Wrappers.Result.Success_q(res#0);
    assume Seq#Length(attemptsState#0) == Seq#Length(s#0);
    havoc i#4;
    assume true;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} LitInt(0) <= i#4;
    goto anon18;

  anon28_Else:
    assume {:partition} i#4 < LitInt(0);
    goto anon18;

  anon18:
    assume LitInt(0) <= i#4 && i#4 < Seq#Length(attemptsState#0);
    assume 0 <= i#4 && i#4 < Seq#Length(attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#4)): DatatypeType);
    assume Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#4)): DatatypeType)): DatatypeType);
    goto anon20;

  anon27_Else:
    assume LitInt(0) <= i#4 && i#4 < Seq#Length(attemptsState#0) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#4)): DatatypeType)): DatatypeType);
    goto anon20;

  anon20:
    assume (forall i#5: int :: { $Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType } LitInt(0) <= i#5 && i#5 < Seq#Length(attemptsState#0) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType)): DatatypeType));
    return;
}



procedure {:verboseName "Actions.ReduceToSuccess (call precondtion)"} CallPre$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)) && $IsAlloc(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.ReduceToSuccess$A)) && $IsAlloc(s#0, TSeq(Actions._default.ReduceToSuccess$A), $Heap));
  requires {:id "id19527"} 0 < Seq#Length(s#0);
  requires {:id "id19528"} Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);



procedure {:verboseName "Actions.ReduceToSuccess (call postcondition)"} CallPost$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)) && $IsAlloc(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.ReduceToSuccess$A)) && $IsAlloc(s#0, TSeq(Actions._default.ReduceToSuccess$A), $Heap)) returns (res#0: DatatypeType where $Is(res#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, TSeq(Actions._default.ReduceToSuccess$E))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, TSeq(Actions._default.ReduceToSuccess$E)), $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19529"} 0 < Seq#Length(attemptsState#0);
  free ensures {:id "id19530"} Seq#Length(attemptsState#0) <= Seq#Length(s#0);
  free ensures (forall i#1: int :: { Seq#Index(s#0, i#1) } { $Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType));
  free ensures {:id "id19531"} (forall i#1: int :: { Seq#Index(s#0, i#1) } { $Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType) == Seq#Index(s#0, i#1));
  free ensures Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
  free ensures {:id "id19532"} Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
  free ensures (Wrappers.Result.Success_q(res#0) ==> Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && (Wrappers.Result.Success_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) ==> Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && (Wrappers.Result.value($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) == Wrappers.Result.value(res#0) ==> Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && Seq.__default.DropLast#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.Action.Ensures#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) && (Actions.Action.Ensures(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> (forall i#3: int :: { $Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType } (LitInt(0) <= i#3 ==> Seq.__default.DropLast#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) && (LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType))))))) && (!Wrappers.Result.Success_q(res#0) ==> Seq#Length(attemptsState#0) == Seq#Length(s#0) ==> (forall i#5: int :: { $Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType } LitInt(0) <= i#5 && i#5 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType)));
  free ensures {:id "id19533"} Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.Success_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType);
  free ensures {:id "id19534"} Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.value($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) == Wrappers.Result.value(res#0);
  free ensures {:id "id19535"} Wrappers.Result.Success_q(res#0) ==> Actions.Action.Ensures(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0));
  free ensures {:id "id19536"} Wrappers.Result.Success_q(res#0) ==> (forall i#3: int :: { $Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType } LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType)): DatatypeType));
  free ensures {:id "id19537"} !Wrappers.Result.Success_q(res#0) ==> Seq#Length(attemptsState#0) == Seq#Length(s#0);
  free ensures {:id "id19538"} !Wrappers.Result.Success_q(res#0) ==> (forall i#5: int :: { $Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType } LitInt(0) <= i#5 && i#5 < Seq#Length(attemptsState#0) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType)): DatatypeType));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "Actions.ReduceToSuccess (correctness)"} Impl$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref where $Is(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)) && $IsAlloc(action#0, Tclass.Actions.ActionWithResult(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap), s#0: Seq where $Is(s#0, TSeq(Actions._default.ReduceToSuccess$A)) && $IsAlloc(s#0, TSeq(Actions._default.ReduceToSuccess$A), $Heap)) returns (defass#res#0: bool, res#0: DatatypeType where defass#res#0 ==> $Is(res#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, TSeq(Actions._default.ReduceToSuccess$E))) && $IsAlloc(res#0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, TSeq(Actions._default.ReduceToSuccess$E)), $Heap), defass#attemptsState#0: bool, attemptsState#0: Seq where defass#attemptsState#0 ==> $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id19539"} 0 < Seq#Length(s#0);
  requires {:id "id19540"} Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id19541"} 0 < Seq#Length(attemptsState#0);
  free ensures {:id "id19542"} Seq#Length(attemptsState#0) <= Seq#Length(s#0);
  free ensures (forall i#1: int :: { Seq#Index(s#0, i#1) } { $Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType));
  free ensures {:id "id19543"} (forall i#1: int :: { Seq#Index(s#0, i#1) } { $Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType } LitInt(0) <= i#1 && i#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, i#1)): DatatypeType) == Seq#Index(s#0, i#1));
  free ensures Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
  free ensures {:id "id19544"} Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
  free ensures (Wrappers.Result.Success_q(res#0) ==> Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && (Wrappers.Result.Success_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) ==> Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && (Wrappers.Result.value($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) == Wrappers.Result.value(res#0) ==> Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType) && Seq.__default.DropLast#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0) && Actions.Action.Ensures#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) && (Actions.Action.Ensures(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> (forall i#3: int :: { $Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType } (LitInt(0) <= i#3 ==> Seq.__default.DropLast#canCall(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) && (LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType))))))) && (!Wrappers.Result.Success_q(res#0) ==> Seq#Length(attemptsState#0) == Seq#Length(s#0) ==> (forall i#5: int :: { $Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType } LitInt(0) <= i#5 && i#5 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType)));
  free ensures {:id "id19545"} Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.Success_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType);
  free ensures {:id "id19546"} Wrappers.Result.Success_q(res#0) ==> Wrappers.Result.value($Unbox(Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType)): DatatypeType) == Wrappers.Result.value(res#0);
  free ensures {:id "id19547"} Wrappers.Result.Success_q(res#0) ==> Actions.Action.Ensures(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0, Actions.ActionInvoke.input($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Actions.ActionInvoke.output($Unbox(Seq.__default.Last(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)): DatatypeType), Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0));
  free ensures {:id "id19548"} Wrappers.Result.Success_q(res#0) ==> (forall i#3: int :: { $Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType } LitInt(0) <= i#3 && i#3 < Seq#Length(Seq.__default.DropLast(Tclass.Actions.ActionInvoke(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), attemptsState#0)) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#3)): DatatypeType)): DatatypeType));
  free ensures {:id "id19549"} !Wrappers.Result.Success_q(res#0) ==> Seq#Length(attemptsState#0) == Seq#Length(s#0);
  free ensures {:id "id19550"} !Wrappers.Result.Success_q(res#0) ==> (forall i#5: int :: { $Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType } LitInt(0) <= i#5 && i#5 < Seq#Length(attemptsState#0) ==> Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, i#5)): DatatypeType)): DatatypeType));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty) : HandleType;

function Actions.__default.pluckErrors(Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType) : Box
uses {
axiom 0 <= $FunctionContextHeight ==> (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType :: { Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) } Actions.__default.pluckErrors#canCall(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) || (0 < $FunctionContextHeight && $Is(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E)) && Wrappers.Result.Failure_q(r#0)) ==> Wrappers.Result.error(r#0) == Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) && $IsBox(Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0), Actions._default.pluckErrors$E));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType :: { $IsAllocBox(Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0), Actions._default.pluckErrors$E, $Heap) } (Actions.__default.pluckErrors#canCall(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) || (0 < $FunctionContextHeight && $Is(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $Heap) && Wrappers.Result.Failure_q(r#0))) && $IsGoodHeap($Heap) ==> $IsAllocBox(Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0), Actions._default.pluckErrors$E, $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType :: { Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) } Actions.__default.pluckErrors#canCall(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) || (0 < $FunctionContextHeight && $Is(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E)) && Wrappers.Result.Failure_q(r#0)) ==> Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) == Wrappers.Result.error(r#0));
axiom 0 <= $FunctionContextHeight ==> (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType :: {:weight 3} { Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, Lit(r#0)) } Actions.__default.pluckErrors#canCall(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, Lit(r#0)) || (0 < $FunctionContextHeight && $Is(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E)) && Lit(Wrappers.Result.Failure_q(Lit(r#0)))) ==> Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, Lit(r#0)) == Lit(Wrappers.Result.error(Lit(r#0))));
}

function Actions.__default.pluckErrors#canCall(Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType) : bool;

axiom (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $fh$0x#0) } Apply1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $fh$0x#0) == Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, $Unbox($fh$0x#0): DatatypeType));

axiom (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $fh$0x#0) } Requires1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $fh$0x#0) <==> Actions.__default.pluckErrors#requires(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $fh$0x#0)[$bx] } Reads1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $fh$0x#0)[$bx] <==> false);

axiom (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, $heap: Heap, $fh$0x#0: DatatypeType :: { Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, $fh$0x#0), $IsGoodHeap($heap) } Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, $fh$0x#0) == Apply1(Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), Actions._default.pluckErrors$E, $heap, Actions.__default.pluckErrors#Handle(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E), $Box($fh$0x#0)));

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.ReduceToSuccess (correctness)"} Impl$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref, s#0: Seq) returns (defass#res#0: bool, res#0: DatatypeType, defass#attemptsState#0: bool, attemptsState#0: Seq, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var attemptedResults#0: Seq where $Is(attemptedResults#0, TSeq(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E))) && $IsAlloc(attemptedResults#0, TSeq(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), $Heap);
  var i#6: int;
  var i#6#lo: int;
  var i#6#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#attemptsState#0: bool;
  var preLoop$loop#0$defass#res#0: bool;
  var $w$loop#0: bool;
  var j#0: int;
  var defass#attempt#0_0: bool;
  var attempt#0_0: DatatypeType where defass#attempt#0_0 ==> $Is(attempt#0_0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)) && $IsAlloc(attempt#0_0, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap);
  var $rhs##0_0: DatatypeType;
  var a##0_0: Box;
  var attemptsState##0_0: Seq;
  var $rhs#0_0_0: DatatypeType;
  var $rhs#0_0_1: Seq;
  var ##f#0: HandleType;
  var ##xs#6: Seq;

  anon0:
    assume {:print "Impl", " | ", "Actions.ReduceToSuccess", " | ", Actions._default.ReduceToSuccess$A, " | ", Actions._default.ReduceToSuccess$B, " | ", Actions._default.ReduceToSuccess$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)]);
    assume {:captureState "StandardLibrary/src/Actions.dfy(355,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    attemptedResults#0 := Lit(Seq#Empty(): Seq);
    assume {:captureState "StandardLibrary/src/Actions.dfy(356,30)"} true;
    assume true;
    assume true;
    attemptsState#0 := Lit(Seq#Empty(): Seq);
    defass#attemptsState#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(357,23)"} true;
    i#6#lo := LitInt(0);
    i#6#hi := Seq#Length(s#0);
    assume i#6#lo <= i#6#hi;
    i#6 := i#6#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#attemptsState#0 := defass#attemptsState#0;
    preLoop$loop#0$defass#res#0 := defass#res#0;
    havoc $w$loop#0;
    goto anon21_LoopHead;

  anon21_LoopHead:
    assume i#6#lo <= i#6 && i#6 <= i#6#hi;
    assume true;
    assume $w$loop#0 ==> Seq#Length(Seq#Take(s#0, i#6)) == Seq#Length(attemptsState#0);
    assume $w$loop#0 ==> Seq#Length(attemptsState#0) == Seq#Length(attemptedResults#0);
    assume $w$loop#0 ==> (forall j#1: int :: { $Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType } { Seq#Index(s#0, j#1) } { $Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) && (Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) == Seq#Index(s#0, j#1) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) && (Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) ==> $IsA#Wrappers.Result($Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType) && $IsA#Wrappers.Result($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType))));
    assume $w$loop#0 ==> (forall j#1: int :: { $Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType } { Seq#Index(s#0, j#1) } { $Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) == Seq#Index(s#0, j#1) && Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) && Wrappers.Result#Equal($Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType, $Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType));
    assume $w$loop#0 ==> Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume $w$loop#0 ==> Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o] || Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#attemptsState#0 ==> defass#attemptsState#0;
    assume preLoop$loop#0$defass#res#0 ==> defass#res#0;
    assume true;
    goto anon21_LoopDone, anon21_LoopBody;

  anon21_LoopBody:
    assume {:partition} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(358,4): after some loop iterations"} true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} !$w$loop#0;
    assume {:subsumption 0} 0 <= i#6 && i#6 <= Seq#Length(s#0);
    assume defass#attemptsState#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Length(Seq#Take(s#0, i#6)) == Seq#Length(attemptsState#0);
    assume defass#attemptsState#0;
    goto anon4;

  anon23_Else:
    assume {:partition} Seq#Length(Seq#Take(s#0, i#6)) != Seq#Length(attemptsState#0);
    goto anon4;

  anon4:
    assume true;
    assume Seq#Length(Seq#Take(s#0, i#6)) == Seq#Length(attemptsState#0) && Seq#Length(attemptsState#0) == Seq#Length(attemptedResults#0);
    havoc j#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} true;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= j#0;
    assume defass#attemptsState#0;
    goto anon7;

  anon25_Else:
    assume {:partition} j#0 < LitInt(0);
    goto anon7;

  anon7:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} LitInt(0) <= j#0 && j#0 < Seq#Length(attemptsState#0);
    assume defass#attemptsState#0;
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(s#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType) == Seq#Index(s#0, j#0);
    assume defass#attemptsState#0;
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType);
    goto anon10;

  anon27_Else:
    assume {:partition} Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType) != Seq#Index(s#0, j#0);
    goto anon10;

  anon10:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType) == Seq#Index(s#0, j#0) && Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(attemptedResults#0);
    assume defass#attemptsState#0;
    assume {:subsumption 0} 0 <= j#0 && j#0 < Seq#Length(attemptsState#0);
    assume Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType);
    goto anon12;

  anon28_Else:
    assume {:partition} !(Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType) == Seq#Index(s#0, j#0) && Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#0)): DatatypeType)): DatatypeType));
    goto anon12;

  anon26_Else:
    assume {:partition} !(LitInt(0) <= j#0 && j#0 < Seq#Length(attemptsState#0));
    goto anon12;

  anon24_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume (forall j#1: int :: { $Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType } { Seq#Index(s#0, j#1) } { $Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) && (Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) == Seq#Index(s#0, j#1) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) && (Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) ==> $IsA#Wrappers.Result($Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType) && $IsA#Wrappers.Result($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType))));
    assume (forall j#1: int :: { $Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType } { Seq#Index(s#0, j#1) } { $Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) == Seq#Index(s#0, j#1) && Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) && Wrappers.Result#Equal($Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType, $Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType));
    assume {:subsumption 0} action#0 != null;
    assume $IsAllocBox($Box(action#0), Tclass.Actions.Action?(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), $Heap);
    assume Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume Actions.Action.Invariant(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0);
    assume false;
    goto anon13;

  anon22_Else:
    assume {:partition} $w$loop#0;
    goto anon13;

  anon13:
    assume true;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} i#6 == i#6#hi;
    goto anon20;

  anon29_Else:
    assume {:partition} i#6 != i#6#hi;
    push;
    assume true;
    assume true;
    assume action#0 != null;
    assume 0 <= i#6 && i#6 < Seq#Length(s#0);
    assume true;
    a##0_0 := Seq#Index(s#0, i#6);
    assume defass#attemptsState#0;
    assume true;
    attemptsState##0_0 := attemptsState#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Actions.Action.Modifies(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), action#0)[$Box($o)] ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$Actions.ActionWithResult.Invoke(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E, action#0, a##0_0, attemptsState##0_0);
    call $rhs##0_0 := CallPost$$Actions.ActionWithResult.Invoke(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E, action#0, a##0_0, attemptsState##0_0);
    attempt#0_0 := $rhs##0_0;
    defass#attempt#0_0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(368,55)"} true;
    assume true;
    assume defass#attemptsState#0;
    assume 0 <= i#6 && i#6 < Seq#Length(s#0);
    assume defass#attempt#0_0;
    assume true;
    attemptsState#0 := Seq#Append(attemptsState#0, Seq#Build(Seq#Empty(): Seq, $Box(#Actions.ActionInvoke.ActionInvoke(Seq#Index(s#0, i#6), $Box(attempt#0_0)))));
    defass#attemptsState#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(370,68)"} true;
    assume true;
    assume defass#attempt#0_0;
    assume true;
    attemptedResults#0 := Seq#Append(attemptedResults#0, Seq#Build(Seq#Empty(): Seq, $Box(attempt#0_0)));
    assume {:captureState "StandardLibrary/src/Actions.dfy(371,54)"} true;
    assume defass#attempt#0_0;
    assume true;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} Wrappers.Result.Success_q(attempt#0_0);
    push;
    assume true;
    assume true;
    assume defass#attempt#0_0;
    assume Wrappers.Result.Success_q(attempt#0_0);
    assume true;
    $rhs#0_0_0 := #Wrappers.Result.Success(Wrappers.Result.value(attempt#0_0));
    assume defass#attemptsState#0;
    assume true;
    $rhs#0_0_1 := attemptsState#0;
    res#0 := $rhs#0_0_0;
    defass#res#0 := true;
    attemptsState#0 := $rhs#0_0_1;
    defass#attemptsState#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(374,52)"} true;
    assume defass#res#0;
    assume defass#attemptsState#0;
    pop;
    pop;
    return;

  anon30_Else:
    assume {:partition} !Wrappers.Result.Success_q(attempt#0_0);
    pop;
    i#6 := i#6 + 1;
    assume Seq#Length(Seq#Take(s#0, i#6)) == Seq#Length(attemptsState#0) && Seq#Length(attemptsState#0) == Seq#Length(attemptedResults#0) ==> (forall j#1: int :: { $Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType } { Seq#Index(s#0, j#1) } { $Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) && (Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) == Seq#Index(s#0, j#1) ==> Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) && (Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) ==> $IsA#Wrappers.Result($Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType) && $IsA#Wrappers.Result($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) && Actions.ActionInvoke.ActionInvoke_q($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)))) && ((forall j#1: int :: { $Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType } { Seq#Index(s#0, j#1) } { $Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(attemptsState#0) ==> Actions.ActionInvoke.input($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType) == Seq#Index(s#0, j#1) && Wrappers.Result.Failure_q($Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType) && Wrappers.Result#Equal($Unbox(Seq#Index(attemptedResults#0, j#1)): DatatypeType, $Unbox(Actions.ActionInvoke.output($Unbox(Seq#Index(attemptsState#0, j#1)): DatatypeType)): DatatypeType)) ==> Actions.Action.Invariant#canCall(Actions._default.ReduceToSuccess$A, Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), $Heap, action#0));
    goto anon21_LoopHead;

  anon21_LoopDone:
    assume {:partition} false;
    goto anon20;

  anon20:
    assume true;
    assume 0 != $FunctionContextHeight;
    ##f#0 := Actions.__default.pluckErrors#Handle(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E);
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), Actions._default.ReduceToSuccess$E), $Heap);
    ##xs#6 := attemptedResults#0;
    assume $IsAlloc(##xs#6, TSeq(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E)), $Heap);
    assume {:subsumption 0} (forall i#7: int :: { $Unbox(Seq#Index(##xs#6, i#7)): DatatypeType } LitInt(0) <= i#7 && i#7 < Seq#Length(##xs#6) ==> Requires1(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), Actions._default.ReduceToSuccess$E, $Heap, ##f#0, Seq#Index(##xs#6, i#7)));
    assume (forall i#7: int :: { $Unbox(Seq#Index(##xs#6, i#7)): DatatypeType } LitInt(0) <= i#7 && i#7 < Seq#Length(##xs#6) ==> Requires1(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), Actions._default.ReduceToSuccess$E, $Heap, ##f#0, Seq#Index(##xs#6, i#7)));
    assume Seq.__default.Map#canCall(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), Actions._default.ReduceToSuccess$E, $Heap, Actions.__default.pluckErrors#Handle(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), attemptedResults#0);
    assume Seq.__default.Map#canCall(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), Actions._default.ReduceToSuccess$E, $Heap, Actions.__default.pluckErrors#Handle(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), attemptedResults#0);
    res#0 := #Wrappers.Result.Failure($Box(Seq.__default.Map(Tclass.Wrappers.Result(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), Actions._default.ReduceToSuccess$E, reveal_Seq._default.Map, $Heap, Actions.__default.pluckErrors#Handle(Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E), attemptedResults#0)));
    defass#res#0 := true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(377,58)"} true;
    assume defass#res#0;
    assume defass#attemptsState#0;
    return;
}



function Actions.__default.pluckErrors#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType :: { Actions.__default.pluckErrors#requires(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) } $Is(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E)) ==> (Actions.__default.pluckErrors#requires(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) <==> Wrappers.Result.Failure_q(r#0)));

procedure {:verboseName "Actions.pluckErrors (well-formedness)"} CheckWellformed$$Actions.__default.pluckErrors(Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E))) returns (e#0: Box where $IsBox(e#0, Actions._default.pluckErrors$E));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19602"} Wrappers.Result.error(r#0) == e#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.pluckErrors (well-formedness)"} CheckWellformed$$Actions.__default.pluckErrors(Actions._default.pluckErrors$B: Ty, Actions._default.pluckErrors$E: Ty, r#0: DatatypeType) returns (e#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "Actions.pluckErrors", " | ", Actions._default.pluckErrors$B, " | ", Actions._default.pluckErrors$E, " | ", r#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "StandardLibrary/src/Actions.dfy(380,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Wrappers.Result.Failure_q(r#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0), Actions._default.pluckErrors$E);
    assume Wrappers.Result.Failure_q(r#0);
    assume Wrappers.Result.error(r#0) == e#0;
    assume false;
    return;

  anon4_Else:
    assume Wrappers.Result.Failure_q(r#0);
    assume Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) == Wrappers.Result.error(r#0);
    assume true;
    assume $IsBox(Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0), Actions._default.pluckErrors$E);
    assume Actions.__default.pluckErrors(Actions._default.pluckErrors$B, Actions._default.pluckErrors$E, r#0) == e#0;
    return;
}



function #Actions.ActionInvoke.ActionInvoke(Box, Box) : DatatypeType;

const unique ##Actions.ActionInvoke.ActionInvoke: DtCtorId
uses {
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: { #Actions.ActionInvoke.ActionInvoke(a#0#0#0, a#0#1#0) } DatatypeCtorId(#Actions.ActionInvoke.ActionInvoke(a#0#0#0, a#0#1#0)) == ##Actions.ActionInvoke.ActionInvoke);
}

function Actions.ActionInvoke.ActionInvoke_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { Actions.ActionInvoke.ActionInvoke_q(d) } Actions.ActionInvoke.ActionInvoke_q(d) <==> DatatypeCtorId(d) == ##Actions.ActionInvoke.ActionInvoke);

axiom (forall d: DatatypeType :: { Actions.ActionInvoke.ActionInvoke_q(d) } Actions.ActionInvoke.ActionInvoke_q(d) ==> (exists a#1#0#0: Box, a#1#1#0: Box :: d == #Actions.ActionInvoke.ActionInvoke(a#1#0#0, a#1#1#0)));

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty, a#2#0#0: Box, a#2#1#0: Box :: { $Is(#Actions.ActionInvoke.ActionInvoke(a#2#0#0, a#2#1#0), Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) } $Is(#Actions.ActionInvoke.ActionInvoke(a#2#0#0, a#2#1#0), Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) <==> $IsBox(a#2#0#0, Actions.ActionInvoke$A) && $IsBox(a#2#1#0, Actions.ActionInvoke$R));

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty, a#2#0#0: Box, a#2#1#0: Box, $h: Heap :: { $IsAlloc(#Actions.ActionInvoke.ActionInvoke(a#2#0#0, a#2#1#0), Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#Actions.ActionInvoke.ActionInvoke(a#2#0#0, a#2#1#0), Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R), $h) <==> $IsAllocBox(a#2#0#0, Actions.ActionInvoke$A, $h) && $IsAllocBox(a#2#1#0, Actions.ActionInvoke$R, $h)));

axiom (forall d: DatatypeType, Actions.ActionInvoke$A: Ty, $h: Heap :: { $IsAllocBox(Actions.ActionInvoke.input(d), Actions.ActionInvoke$A, $h) } $IsGoodHeap($h) && Actions.ActionInvoke.ActionInvoke_q(d) && (exists Actions.ActionInvoke$R: Ty :: { $IsAlloc(d, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R), $h) } $IsAlloc(d, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R), $h)) ==> $IsAllocBox(Actions.ActionInvoke.input(d), Actions.ActionInvoke$A, $h));

axiom (forall d: DatatypeType, Actions.ActionInvoke$R: Ty, $h: Heap :: { $IsAllocBox(Actions.ActionInvoke.output(d), Actions.ActionInvoke$R, $h) } $IsGoodHeap($h) && Actions.ActionInvoke.ActionInvoke_q(d) && (exists Actions.ActionInvoke$A: Ty :: { $IsAlloc(d, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R), $h) } $IsAlloc(d, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R), $h)) ==> $IsAllocBox(Actions.ActionInvoke.output(d), Actions.ActionInvoke$R, $h));

axiom (forall a#3#0#0: Box, a#3#1#0: Box :: { #Actions.ActionInvoke.ActionInvoke(Lit(a#3#0#0), Lit(a#3#1#0)) } #Actions.ActionInvoke.ActionInvoke(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#Actions.ActionInvoke.ActionInvoke(a#3#0#0, a#3#1#0)));

function Actions.ActionInvoke.input(DatatypeType) : Box;

axiom (forall a#4#0#0: Box, a#4#1#0: Box :: { #Actions.ActionInvoke.ActionInvoke(a#4#0#0, a#4#1#0) } Actions.ActionInvoke.input(#Actions.ActionInvoke.ActionInvoke(a#4#0#0, a#4#1#0)) == a#4#0#0);

axiom (forall a#5#0#0: Box, a#5#1#0: Box :: { #Actions.ActionInvoke.ActionInvoke(a#5#0#0, a#5#1#0) } BoxRank(a#5#0#0) < DtRank(#Actions.ActionInvoke.ActionInvoke(a#5#0#0, a#5#1#0)));

function Actions.ActionInvoke.output(DatatypeType) : Box;

axiom (forall a#6#0#0: Box, a#6#1#0: Box :: { #Actions.ActionInvoke.ActionInvoke(a#6#0#0, a#6#1#0) } Actions.ActionInvoke.output(#Actions.ActionInvoke.ActionInvoke(a#6#0#0, a#6#1#0)) == a#6#1#0);

axiom (forall a#7#0#0: Box, a#7#1#0: Box :: { #Actions.ActionInvoke.ActionInvoke(a#7#0#0, a#7#1#0) } BoxRank(a#7#1#0) < DtRank(#Actions.ActionInvoke.ActionInvoke(a#7#0#0, a#7#1#0)));

function $IsA#Actions.ActionInvoke(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#Actions.ActionInvoke(d) } $IsA#Actions.ActionInvoke(d) ==> Actions.ActionInvoke.ActionInvoke_q(d));

axiom (forall Actions.ActionInvoke$A: Ty, Actions.ActionInvoke$R: Ty, d: DatatypeType :: { Actions.ActionInvoke.ActionInvoke_q(d), $Is(d, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) } $Is(d, Tclass.Actions.ActionInvoke(Actions.ActionInvoke$A, Actions.ActionInvoke$R)) ==> Actions.ActionInvoke.ActionInvoke_q(d));

function Actions.ActionInvoke#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { Actions.ActionInvoke#Equal(a, b) } Actions.ActionInvoke#Equal(a, b) <==> Actions.ActionInvoke.input(a) == Actions.ActionInvoke.input(b) && Actions.ActionInvoke.output(a) == Actions.ActionInvoke.output(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { Actions.ActionInvoke#Equal(a, b) } Actions.ActionInvoke#Equal(a, b) <==> a == b);

const unique class.Actions.ActionInvoke: ClassName;

const unique class.Actions.Action?: ClassName;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $o: ref :: { $Is($o, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) } $Is($o, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) <==> $o == null || implements$Actions.Action(dtype($o), Actions.Action$A, Actions.Action$R));

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R), $h) } $IsAlloc($o, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$Actions.Action(ty: Ty, Actions.Action$A: Ty, Actions.Action$R: Ty) : bool;

function Tclass.Actions.Action(Ty, Ty) : Ty;

const unique Tagclass.Actions.Action: TyTag;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty :: { Tclass.Actions.Action(Actions.Action$A, Actions.Action$R) } Tag(Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) == Tagclass.Actions.Action && TagFamily(Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) == tytagFamily$Action);

function Tclass.Actions.Action_0(Ty) : Ty;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty :: { Tclass.Actions.Action(Actions.Action$A, Actions.Action$R) } Tclass.Actions.Action_0(Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) == Actions.Action$A);

function Tclass.Actions.Action_1(Ty) : Ty;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty :: { Tclass.Actions.Action(Actions.Action$A, Actions.Action$R) } Tclass.Actions.Action_1(Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) == Actions.Action$R);

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) } $IsBox(bx, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)));

procedure {:verboseName "Actions.Action.Invoke (well-formedness)"} CheckWellFormed$$Actions.Action.Invoke(Actions.Action$A: Ty, Actions.Action$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap), a#0: Box where $IsBox(a#0, Actions.Action$A) && $IsAllocBox(a#0, Actions.Action$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R)), $Heap)) returns (r#0: Box where $IsBox(r#0, Actions.Action$R) && $IsAllocBox(r#0, Actions.Action$R, $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Actions.Action.Invoke (call precondtion)"} CallPre$$Actions.Action.Invoke(Actions.Action$A: Ty, Actions.Action$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap), a#0: Box where $IsBox(a#0, Actions.Action$A) && $IsAllocBox(a#0, Actions.Action$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R)), $Heap));
  requires {:id "id19612"} Actions.Action.Invariant(Actions.Action$A, Actions.Action$R, $Heap, this);



procedure {:verboseName "Actions.Action.Invoke (call postcondition)"} CallPost$$Actions.Action.Invoke(Actions.Action$A: Ty, Actions.Action$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap), a#0: Box where $IsBox(a#0, Actions.Action$A) && $IsAllocBox(a#0, Actions.Action$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R)), $Heap)) returns (r#0: Box where $IsBox(r#0, Actions.Action$R) && $IsAllocBox(r#0, Actions.Action$R, $Heap));
  modifies $Heap;
  free ensures Actions.Action.Invariant#canCall(Actions.Action$A, Actions.Action$R, $Heap, this);
  free ensures {:id "id19613"} Actions.Action.Invariant(Actions.Action$A, Actions.Action$R, $Heap, this);
  free ensures Actions.Action.Ensures#canCall(Actions.Action$A, Actions.Action$R, $Heap, this, a#0, r#0, attemptsState#0);
  free ensures {:id "id19614"} Actions.Action.Ensures(Actions.Action$A, Actions.Action$R, $Heap, this, a#0, r#0, attemptsState#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, this)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



function Actions.Action.Invariant(Actions.Action$A: Ty, Actions.Action$R: Ty, $heap: Heap, this: ref) : bool;

function Actions.Action.Invariant#canCall(Actions.Action$A: Ty, Actions.Action$R: Ty, $heap: Heap, this: ref) : bool;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Actions.Action.Invariant(Actions.Action$A, Actions.Action$R, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, this)[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Actions.Action.Invariant(Actions.Action$A, Actions.Action$R, $h0, this) <==> Actions.Action.Invariant(Actions.Action$A, Actions.Action$R, $h1, this)));

function Actions.Action.Invariant#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $Heap: Heap, this: ref :: { Actions.Action.Invariant#requires(Actions.Action$A, Actions.Action$R, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap) ==> (Actions.Action.Invariant#requires(Actions.Action$A, Actions.Action$R, $Heap, this) <==> true));

procedure {:verboseName "Actions.Action.Invariant (well-formedness)"} CheckWellformed$$Actions.Action.Invariant(Actions.Action$A: Ty, Actions.Action$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Actions.Action.Ensures(Actions.Action$A: Ty, Actions.Action$R: Ty, $heap: Heap, this: ref, a#0: Box, r#0: Box, attemptsState#0: Seq) : bool;

function Actions.Action.Ensures#canCall(Actions.Action$A: Ty, Actions.Action$R: Ty, $heap: Heap, this: ref, a#0: Box, r#0: Box, attemptsState#0: Seq) : bool;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $h0: Heap, $h1: Heap, this: ref, a#0: Box, r#0: Box, attemptsState#0: Seq :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Actions.Action.Ensures(Actions.Action$A, Actions.Action$R, $h1, this, a#0, r#0, attemptsState#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && (Actions.Action.Ensures#canCall(Actions.Action$A, Actions.Action$R, $h0, this, a#0, r#0, attemptsState#0) || ($IsBox(a#0, Actions.Action$A) && $IsBox(r#0, Actions.Action$R) && $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R))))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, this)[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (Actions.Action.Ensures(Actions.Action$A, Actions.Action$R, $h0, this, a#0, r#0, attemptsState#0) <==> Actions.Action.Ensures(Actions.Action$A, Actions.Action$R, $h1, this, a#0, r#0, attemptsState#0)));

function Actions.Action.Ensures#requires(Ty, Ty, Heap, ref, Box, Box, Seq) : bool;

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, $Heap: Heap, this: ref, a#0: Box, r#0: Box, attemptsState#0: Seq :: { Actions.Action.Ensures#requires(Actions.Action$A, Actions.Action$R, $Heap, this, a#0, r#0, attemptsState#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap) && $IsBox(a#0, Actions.Action$A) && $IsBox(r#0, Actions.Action$R) && $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R))) ==> (Actions.Action.Ensures#requires(Actions.Action$A, Actions.Action$R, $Heap, this, a#0, r#0, attemptsState#0) <==> true));

procedure {:verboseName "Actions.Action.Ensures (well-formedness)"} CheckWellformed$$Actions.Action.Ensures(Actions.Action$A: Ty, Actions.Action$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) && $IsAlloc(this, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $Heap), a#0: Box where $IsBox(a#0, Actions.Action$A), r#0: Box where $IsBox(r#0, Actions.Action$R), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.Action$A, Actions.Action$R))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, c#0: ref :: { $Is(c#0, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) } $Is(c#0, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R)) <==> $Is(c#0, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R)) && c#0 != null);

axiom (forall Actions.Action$A: Ty, Actions.Action$R: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $h) } $IsAlloc(c#0, Tclass.Actions.Action(Actions.Action$A, Actions.Action$R), $h) <==> $IsAlloc(c#0, Tclass.Actions.Action?(Actions.Action$A, Actions.Action$R), $h));

const unique class.Actions.ActionWithResult?: ClassName;

function Tclass.Actions.ActionWithResult?(Ty, Ty, Ty) : Ty;

const unique Tagclass.Actions.ActionWithResult?: TyTag;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tag(Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Tagclass.Actions.ActionWithResult? && TagFamily(Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == tytagFamily$ActionWithResult);

function Tclass.Actions.ActionWithResult?_0(Ty) : Ty;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tclass.Actions.ActionWithResult?_0(Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Actions.ActionWithResult$A);

function Tclass.Actions.ActionWithResult?_1(Ty) : Ty;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tclass.Actions.ActionWithResult?_1(Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Actions.ActionWithResult$R);

function Tclass.Actions.ActionWithResult?_2(Ty) : Ty;

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty :: { Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E) } Tclass.Actions.ActionWithResult?_2(Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) == Actions.ActionWithResult$E);

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) } $IsBox(bx, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)));

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, $o: ref :: { $Is($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) } $Is($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) <==> $o == null || implements$Actions.ActionWithResult(dtype($o), Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E));

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $h) } $IsAlloc($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$Actions.ActionWithResult(ty: Ty, Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty) : bool;

procedure {:verboseName "Actions.ActionWithResult.Invoke (well-formedness)"} CheckWellFormed$$Actions.ActionWithResult.Invoke(Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.ActionWithResult$A) && $IsAllocBox(a#0, Actions.ActionWithResult$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E))), $Heap)) returns (r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Actions.ActionWithResult.Invoke (override check)"} OverrideCheck$$Actions.ActionWithResult.Invoke(Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.ActionWithResult$A) && $IsAllocBox(a#0, Actions.ActionWithResult$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E))), $Heap)) returns (r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.ActionWithResult.Invoke (override check)"} OverrideCheck$$Actions.ActionWithResult.Invoke(Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, this: ref, a#0: Box, attemptsState#0: Seq) returns (r#0: DatatypeType)
{
  var Actions.Action$A: Ty;
  var Actions.Action$R: Ty;

  anon0:
    assume {:print "Impl", " | ", "Actions.ActionWithResult.Invoke", " | ", Actions.ActionWithResult$A, " | ", Actions.ActionWithResult$R, " | ", Actions.ActionWithResult$E, " | ", this, " | ", a#0, " | ", attemptsState#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box", " | ", "Seq"} true;
    assume Actions.Action$A == Actions.ActionWithResult$A;
    assume Actions.Action$R == Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E);
    assume Actions.Action.Invariant(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);
    assume Actions.Action.Invariant(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);
    assume Set#Subset(Actions.Action.Modifies(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), this), Actions.Action.Modifies(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), this));
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Actions.Action.Modifies(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), this)[$Box($o)] ==> Actions.Action.Modifies(Actions.Action$A, Actions.Action$R, this)[$Box($o)]);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || Actions.Action.Modifies(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), this)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume Actions.Action.Invariant(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);
    assume Actions.Action.Ensures(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this, a#0, $Box(r#0), attemptsState#0);
    assume Actions.Action.Invariant(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);
    assume Actions.Action.Ensures(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this, a#0, $Box(r#0), attemptsState#0);
    return;
}



procedure {:verboseName "Actions.ActionWithResult.Invoke (call precondtion)"} CallPre$$Actions.ActionWithResult.Invoke(Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.ActionWithResult$A) && $IsAllocBox(a#0, Actions.ActionWithResult$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E))), $Heap));
  requires {:id "id19627"} Actions.Action.Invariant(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);



procedure {:verboseName "Actions.ActionWithResult.Invoke (call postcondition)"} CallPost$$Actions.ActionWithResult.Invoke(Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.ActionWithResult$A) && $IsAllocBox(a#0, Actions.ActionWithResult$A, $Heap), attemptsState#0: Seq where $Is(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)))) && $IsAlloc(attemptsState#0, TSeq(Tclass.Actions.ActionInvoke(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E))), $Heap)) returns (r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap));
  modifies $Heap;
  free ensures Actions.Action.Invariant#canCall(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);
  free ensures {:id "id19628"} Actions.Action.Invariant(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this);
  free ensures Actions.Action.Ensures#canCall(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this, a#0, $Box(r#0), attemptsState#0);
  free ensures {:id "id19629"} Actions.Action.Ensures(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), $Heap, this, a#0, $Box(r#0), attemptsState#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || Actions.Action.Modifies(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E), this)[$Box($o)]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, c#0: ref :: { $Is(c#0, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) } $Is(c#0, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) <==> $Is(c#0, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) && c#0 != null);

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $h) } $IsAlloc(c#0, Tclass.Actions.ActionWithResult(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $h) <==> $IsAlloc(c#0, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $h));

const unique class.Actions.DeterministicAction?: ClassName;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, $o: ref :: { $Is($o, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) } $Is($o, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) <==> $o == null || implements$Actions.DeterministicAction(dtype($o), Actions.DeterministicAction$A, Actions.DeterministicAction$R));

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $h) } $IsAlloc($o, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$Actions.DeterministicAction(ty: Ty, Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty) : bool;

procedure {:verboseName "Actions.DeterministicAction.Invoke (well-formedness)"} CheckWellFormed$$Actions.DeterministicAction.Invoke(Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) && $IsAlloc(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicAction$A) && $IsAllocBox(a#0, Actions.DeterministicAction$A, $Heap)) returns (r#0: Box where $IsBox(r#0, Actions.DeterministicAction$R) && $IsAllocBox(r#0, Actions.DeterministicAction$R, $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Actions.DeterministicAction.Invoke (call precondtion)"} CallPre$$Actions.DeterministicAction.Invoke(Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) && $IsAlloc(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicAction$A) && $IsAllocBox(a#0, Actions.DeterministicAction$A, $Heap));



procedure {:verboseName "Actions.DeterministicAction.Invoke (call postcondition)"} CallPost$$Actions.DeterministicAction.Invoke(Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) && $IsAlloc(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicAction$A) && $IsAllocBox(a#0, Actions.DeterministicAction$A, $Heap)) returns (r#0: Box where $IsBox(r#0, Actions.DeterministicAction$R) && $IsAllocBox(r#0, Actions.DeterministicAction$R, $Heap));
  modifies $Heap;
  free ensures Actions.DeterministicAction.Ensures#canCall(Actions.DeterministicAction$A, Actions.DeterministicAction$R, this, a#0, r#0);
  free ensures {:id "id19631"} Actions.DeterministicAction.Ensures(Actions.DeterministicAction$A, Actions.DeterministicAction$R, this, a#0, r#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function Actions.DeterministicAction.Ensures(Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref, a#0: Box, r#0: Box) : bool;

function Actions.DeterministicAction.Ensures#canCall(Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref, a#0: Box, r#0: Box) : bool;

function Actions.DeterministicAction.Ensures#requires(Ty, Ty, ref, Box, Box) : bool;

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref, a#0: Box, r#0: Box :: { Actions.DeterministicAction.Ensures#requires(Actions.DeterministicAction$A, Actions.DeterministicAction$R, this, a#0, r#0) } this != null && $Is(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) && $IsBox(a#0, Actions.DeterministicAction$A) && $IsBox(r#0, Actions.DeterministicAction$R) ==> (Actions.DeterministicAction.Ensures#requires(Actions.DeterministicAction$A, Actions.DeterministicAction$R, this, a#0, r#0) <==> true));

procedure {:verboseName "Actions.DeterministicAction.Ensures (well-formedness)"} CheckWellformed$$Actions.DeterministicAction.Ensures(Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) && $IsAlloc(this, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicAction$A), r#0: Box where $IsBox(r#0, Actions.DeterministicAction$R));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, c#0: ref :: { $Is(c#0, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) } $Is(c#0, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) <==> $Is(c#0, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R)) && c#0 != null);

axiom (forall Actions.DeterministicAction$A: Ty, Actions.DeterministicAction$R: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $h) } $IsAlloc(c#0, Tclass.Actions.DeterministicAction(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $h) <==> $IsAlloc(c#0, Tclass.Actions.DeterministicAction?(Actions.DeterministicAction$A, Actions.DeterministicAction$R), $h));

const unique class.Actions.DeterministicActionWithResult?: ClassName;

function Tclass.Actions.DeterministicActionWithResult?(Ty, Ty, Ty) : Ty;

const unique Tagclass.Actions.DeterministicActionWithResult?: TyTag;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tag(Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Tagclass.Actions.DeterministicActionWithResult? && TagFamily(Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == tytagFamily$DeterministicActionWithResult);

function Tclass.Actions.DeterministicActionWithResult?_0(Ty) : Ty;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tclass.Actions.DeterministicActionWithResult?_0(Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Actions.DeterministicActionWithResult$A);

function Tclass.Actions.DeterministicActionWithResult?_1(Ty) : Ty;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tclass.Actions.DeterministicActionWithResult?_1(Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Actions.DeterministicActionWithResult$R);

function Tclass.Actions.DeterministicActionWithResult?_2(Ty) : Ty;

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty :: { Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E) } Tclass.Actions.DeterministicActionWithResult?_2(Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) == Actions.DeterministicActionWithResult$E);

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, bx: Box :: { $IsBox(bx, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) } $IsBox(bx, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)));

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, $o: ref :: { $Is($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) } $Is($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) <==> $o == null || implements$Actions.DeterministicActionWithResult(dtype($o), Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E));

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $h) } $IsAlloc($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$Actions.DeterministicActionWithResult(ty: Ty, Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty) : bool;

procedure {:verboseName "Actions.DeterministicActionWithResult.Invoke (well-formedness)"} CheckWellFormed$$Actions.DeterministicActionWithResult.Invoke(Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicActionWithResult$A) && $IsAllocBox(a#0, Actions.DeterministicActionWithResult$A, $Heap)) returns (r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "Actions.DeterministicActionWithResult.Invoke (override check)"} OverrideCheck$$Actions.DeterministicActionWithResult.Invoke(Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicActionWithResult$A) && $IsAllocBox(a#0, Actions.DeterministicActionWithResult$A, $Heap)) returns (r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "Actions.DeterministicActionWithResult.Invoke (override check)"} OverrideCheck$$Actions.DeterministicActionWithResult.Invoke(Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, this: ref, a#0: Box) returns (r#0: DatatypeType)
{
  var Actions.DeterministicAction$A: Ty;
  var Actions.DeterministicAction$R: Ty;

  anon0:
    assume {:print "Impl", " | ", "Actions.DeterministicActionWithResult.Invoke", " | ", Actions.DeterministicActionWithResult$A, " | ", Actions.DeterministicActionWithResult$R, " | ", Actions.DeterministicActionWithResult$E, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    assume Actions.DeterministicAction$A == Actions.DeterministicActionWithResult$A;
    assume Actions.DeterministicAction$R == Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E);
    assume true;
    assume (forall $o: ref, $f: Field :: true);
    assume (forall $o: ref, $f: Field :: true);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    assume Actions.DeterministicAction.Ensures(Actions.DeterministicActionWithResult$A, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), this, a#0, $Box(r#0));
    assume Actions.DeterministicAction.Ensures(Actions.DeterministicActionWithResult$A, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), this, a#0, $Box(r#0));
    return;
}



procedure {:verboseName "Actions.DeterministicActionWithResult.Invoke (call precondtion)"} CallPre$$Actions.DeterministicActionWithResult.Invoke(Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicActionWithResult$A) && $IsAllocBox(a#0, Actions.DeterministicActionWithResult$A, $Heap));



procedure {:verboseName "Actions.DeterministicActionWithResult.Invoke (call postcondition)"} CallPost$$Actions.DeterministicActionWithResult.Invoke(Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, this: ref where this != null && $Is(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(this, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap), a#0: Box where $IsBox(a#0, Actions.DeterministicActionWithResult$A) && $IsAllocBox(a#0, Actions.DeterministicActionWithResult$A, $Heap)) returns (r#0: DatatypeType where $Is(r#0, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && $IsAlloc(r#0, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $Heap));
  modifies $Heap;
  free ensures Actions.DeterministicAction.Ensures#canCall(Actions.DeterministicActionWithResult$A, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), this, a#0, $Box(r#0));
  free ensures {:id "id19638"} Actions.DeterministicAction.Ensures(Actions.DeterministicActionWithResult$A, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), this, a#0, $Box(r#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, c#0: ref :: { $Is(c#0, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) } $Is(c#0, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) <==> $Is(c#0, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) && c#0 != null);

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $h) } $IsAlloc(c#0, Tclass.Actions.DeterministicActionWithResult(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $h) <==> $IsAlloc(c#0, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#128 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#128))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#130 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#130)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#192 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#192))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#194 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#194)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#196 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#196)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#192 := Wrappers.Option.value(this); v#192)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#194 := Lit(Wrappers.Option.value(Lit(this))); v#194)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#196 := Lit(Wrappers.Option.value(Lit(this))); v#196)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#128 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#128)) else (var e#128 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#130 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#130))) else (var e#130 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#192 := Wrappers.Result.value(this); s#192) else (var e#192 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#194 := Lit(Wrappers.Result.value(Lit(this))); s#194) else (var e#194 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#196 := Lit(Wrappers.Result.value(Lit(this))); s#196) else (var e#196 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#192 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#192)) else (var e#192 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#192)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#194 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#194))) else (var e#194 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#194)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#196 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#196))) else (var e#196 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#196)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#22: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#22, x#22)): bool } $IsBox(x#22, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#22, x#22)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#23: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#23, x#23)): bool } $IsBox(x#23, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#23, x#23)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#22: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#22, x#22)): bool } $IsBox(x#22, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#22, x#22)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#23: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#23, x#23)): bool } $IsBox(x#23, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#23, x#23)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#22: Box, y#22: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#22, x#22)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#22, y#22)): bool } $IsBox(x#22, Relations._default.AntiSymmetric$T) && $IsBox(y#22, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#22, y#22)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#22, x#22)): bool ==> x#22 == y#22)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#23: Box, y#23: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#23, x#23)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#23, y#23)): bool } $IsBox(x#23, Relations._default.AntiSymmetric$T) && $IsBox(y#23, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#23, y#23)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#23, x#23)): bool ==> x#23 == y#23)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#22: Box, y#22: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#22, x#22)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#22, y#22)): bool } $IsBox(x#22, Relations._default.Symmetric$T) && $IsBox(y#22, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#22, y#22)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#22, x#22)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#23: Box, y#23: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#23, x#23)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#23, y#23)): bool } $IsBox(x#23, Relations._default.Symmetric$T) && $IsBox(y#23, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#23, y#23)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#23, x#23)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#22: Box, y#22: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#22, x#22)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#22, y#22)): bool } $IsBox(x#22, Relations._default.Connected$T) && $IsBox(y#22, Relations._default.Connected$T) ==> x#22 != y#22 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#22, y#22)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#22, x#22)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#23: Box, y#23: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#23, x#23)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#23, y#23)): bool } $IsBox(x#23, Relations._default.Connected$T) && $IsBox(y#23, Relations._default.Connected$T) ==> x#23 != y#23 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#23, y#23)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#23, x#23)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#22: Box, y#22: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#22, x#22)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#22, y#22)): bool } $IsBox(x#22, Relations._default.StronglyConnected$T) && $IsBox(y#22, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#22, y#22)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#22, x#22)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#23: Box, y#23: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#23, x#23)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#23, y#23)): bool } $IsBox(x#23, Relations._default.StronglyConnected$T) && $IsBox(y#23, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#23, y#23)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#23, x#23)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#22: Box, y#22: Box, z#22: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#22, z#22)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#22, z#22)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#22, z#22)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#22, y#22)): bool } $IsBox(x#22, Relations._default.Transitive$T) && $IsBox(y#22, Relations._default.Transitive$T) && $IsBox(z#22, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#22, y#22)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#22, z#22)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#22, z#22)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#23: Box, y#23: Box, z#23: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#23, z#23)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#23, z#23)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#23, z#23)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#23, y#23)): bool } $IsBox(x#23, Relations._default.Transitive$T) && $IsBox(y#23, Relations._default.Transitive$T) && $IsBox(z#23, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#23, y#23)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#23, z#23)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#23, z#23)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#32: int, j#32: int :: { Seq#Index(a#0, j#32), Seq#Index(a#0, i#32) } LitInt(0) <= i#32 && i#32 < j#32 && j#32 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#32), Seq#Index(a#0, j#32))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#33: int, j#33: int :: { Seq#Index(a#0, j#33), Seq#Index(a#0, i#33) } LitInt(0) <= i#33 && i#33 < j#33 && j#33 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#33), Seq#Index(Lit(a#0), j#33))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#34: int, j#34: int :: { Seq#Index(a#0, j#34), Seq#Index(a#0, i#34) } LitInt(0) <= i#34 && i#34 < j#34 && j#34 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#34), Seq#Index(Lit(a#0), j#34))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#32: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#32)): bool } { s#0[x#32] } $IsBox(x#32, Relations._default.IsLeast$T) && s#0[x#32] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#32)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#33: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#33)): bool } { s#0[x#33] } $IsBox(x#33, Relations._default.IsLeast$T) && Lit(s#0)[x#33] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#33)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#34: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#34)): bool } { s#0[x#34] } $IsBox(x#34, Relations._default.IsLeast$T) && Lit(s#0)[x#34] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#34)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#32: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#32)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#32, min#0)): bool } { s#0[x#32] } $IsBox(x#32, Relations._default.IsMinimal$T) && s#0[x#32] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#32, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#32)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#33: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#33)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#33, min#0)): bool } { s#0[x#33] } $IsBox(x#33, Relations._default.IsMinimal$T) && Lit(s#0)[x#33] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#33, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#33)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#34: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#34)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#34, min#0)): bool } { s#0[x#34] } $IsBox(x#34, Relations._default.IsMinimal$T) && Lit(s#0)[x#34] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#34, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#34)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#32: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#32, max#0)): bool } { s#0[x#32] } $IsBox(x#32, Relations._default.IsGreatest$T) && s#0[x#32] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#32, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#33: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#33, max#0)): bool } { s#0[x#33] } $IsBox(x#33, Relations._default.IsGreatest$T) && Lit(s#0)[x#33] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#33, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#34: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#34, max#0)): bool } { s#0[x#34] } $IsBox(x#34, Relations._default.IsGreatest$T) && Lit(s#0)[x#34] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#34, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#32: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#32, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#32)): bool } { s#0[x#32] } $IsBox(x#32, Relations._default.IsMaximal$T) && s#0[x#32] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#32)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#32, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#33: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#33, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#33)): bool } { s#0[x#33] } $IsBox(x#33, Relations._default.IsMaximal$T) && Lit(s#0)[x#33] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#33)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#33, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#34: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#34, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#34)): bool } { s#0[x#34] } $IsBox(x#34, Relations._default.IsMaximal$T) && Lit(s#0)[x#34] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#34)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#34, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#27 := Div(Seq#Length(a#0), LitInt(2)); (var left#27, right#27 := Seq#Take(a#0, splitIndex#27), Seq#Drop(a#0, splitIndex#27); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#27, lessThanOrEq#0) && (var leftSorted#27 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#27, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#27, lessThanOrEq#0) && (var rightSorted#27 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#27, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#27, rightSorted#27, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#27 := Div(Seq#Length(a#0), LitInt(2)); (var left#27, right#27 := Seq#Take(a#0, splitIndex#27), Seq#Drop(a#0, splitIndex#27); (var leftSorted#27 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#27, lessThanOrEq#0); (var rightSorted#27 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#27, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#27, rightSorted#27, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#28 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#28, right#28 := Seq#Take(Lit(a#0), splitIndex#28), Seq#Drop(Lit(a#0), splitIndex#28); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#28, lessThanOrEq#0) && (var leftSorted#28 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#28, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#28, lessThanOrEq#0) && (var rightSorted#28 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#28, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#28, rightSorted#28, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#28 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#28, right#28 := Seq#Take(Lit(a#0), splitIndex#28), Seq#Drop(Lit(a#0), splitIndex#28); (var leftSorted#28 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#28, lessThanOrEq#0); (var rightSorted#28 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#28, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#28, rightSorted#28, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#29 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#29, right#29 := Seq#Take(Lit(a#0), splitIndex#29), Seq#Drop(Lit(a#0), splitIndex#29); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#29, Lit(lessThanOrEq#0)) && (var leftSorted#29 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#29, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#29, Lit(lessThanOrEq#0)) && (var rightSorted#29 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#29, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#29, rightSorted#29, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#29 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#29, right#29 := Seq#Take(Lit(a#0), splitIndex#29), Seq#Drop(Lit(a#0), splitIndex#29); (var leftSorted#29 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#29, Lit(lessThanOrEq#0)); (var rightSorted#29 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#29, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#29, rightSorted#29, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#18: Box :: $IsBox($y#18, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#18)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#19: Box :: $IsBox($y#19, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#19)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#18: int, j#18: int :: { Seq#Index(xs#0, j#18), Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) && LitInt(0) <= j#18 && j#18 < Seq#Length(xs#0) && i#18 != j#18 ==> Seq#Index(xs#0, i#18) != Seq#Index(xs#0, j#18))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#19: int, j#19: int :: { Seq#Index(xs#0, j#19), Seq#Index(xs#0, i#19) } LitInt(0) <= i#19 && i#19 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#19 && j#19 < Seq#Length(Lit(xs#0)) && i#19 != j#19 ==> Seq#Index(Lit(xs#0), i#19) != Seq#Index(Lit(xs#0), j#19))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#10: int :: { Seq#Index(xs#0, j#10) } LitInt(0) <= j#10 && j#10 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#10) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#10: int :: { Seq#Index(xs#0, j#10) } LitInt(0) <= j#10 && j#10 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#10) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#24 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#24) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#24)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#25 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#25) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#25)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#26 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#26) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#26)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#10: int :: { Seq#Index(xs#0, j#10) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#10 && j#10 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#10) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#10: int :: { Seq#Index(xs#0, j#10) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#10 && j#10 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#10) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#20: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#20), Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#20) == Seq#Index(xs#0, i#20)) && (forall i#21: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#21) } pos#0 <= i#21 && i#21 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#21) == Seq#Index(xs#0, i#21 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#24 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#24), Seq#Drop(xs#0, i#24 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#25 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#25), Seq#Drop(Lit(xs#0), i#25 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#26 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#26), Seq#Drop(Lit(xs#0), i#26 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#20: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#20), Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#20) == Seq#Index(xs#0, i#20)) && (forall i#21: int :: { Seq#Index(xs#0, i#21) } pos#0 <= i#21 && i#21 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#21 + 1) == Seq#Index(xs#0, i#21)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#10: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#10) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#10 - 1) } LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#10) == Seq#Index(xs#0, Seq#Length(xs#0) - i#10 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#10: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#10) } LitInt(0) <= i#10 && i#10 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#10) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#10: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#10) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#10) } LitInt(0) <= i#10 && i#10 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#10), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#10)), $Unbox(Seq#Index(xs#0, i#10)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#16, b#16 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#16, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#16, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#17, b#17 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#17, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#17, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#10: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#10)): DatatypeType } LitInt(0) <= i#10 && i#10 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#10)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#10), Seq#Index(ys#0, i#10)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#10: int :: { Seq#Contains(xs#0, $Box(k#10)) } Seq#Contains(xs#0, $Box(k#10)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#10) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#10: int :: { Seq#Contains(xs#0, $Box(k#10)) } Seq#Contains(xs#0, $Box(k#10)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#10) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#37: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#37) } LitInt(0) <= i#37 && i#37 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#37) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#37))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#38: int :: { Seq#Index(xs#0, i#38) } LitInt(0) <= i#38 && i#38 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#38)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#38: int :: { Seq#Index(xs#0, i#38) } LitInt(0) <= i#38 && i#38 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#38)))) ==> (forall $l#21#i#0: int :: LitInt(0) <= $l#21#i#0 ==> $l#21#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#21#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#20#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#20#i#0): int))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $IsBox($l#20#i#0, TInt) && LitInt(0) <= $Unbox($l#20#i#0): int && $Unbox($l#20#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#20#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#20#i#0): int))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: (exists i#39: int, o#16: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#20#heap#0, f#0, Seq#Index(xs#0, i#39))[$Box(o#16)] } $Is(o#16, Tclass._System.object?()) && LitInt(0) <= i#39 && i#39 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#20#heap#0, f#0, Seq#Index(xs#0, i#39))[$Box(o#16)] && $Box($l#20#o#0) == $Box(o#16))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#27: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#27) } { Seq#Index(xs#0, i#27) } (LitInt(0) <= i#27 && i#27 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#27))): DatatypeType)) && (LitInt(0) <= i#27 && i#27 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#27) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#27))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#28: int :: { Seq#Index(xs#0, i#28) } LitInt(0) <= i#28 && i#28 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#28)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#28: int :: { Seq#Index(xs#0, i#28) } LitInt(0) <= i#28 && i#28 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#28)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#8 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#8) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#8) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#8 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#8) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#8)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#8) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#8)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#8 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#8) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#8) else (var head#8 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#8); (var valueOrError1#8 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#8) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#8) else (var tail#8 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#8)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#8), tail#8)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#27: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#27) } LitInt(0) <= i#27 ==> i#27 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#27)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#27))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#28: int :: { Seq#Index(xs#0, i#28) } LitInt(0) <= i#28 && i#28 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#28)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#28: int :: { Seq#Index(xs#0, i#28) } LitInt(0) <= i#28 && i#28 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#28)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#18: Box, xs#18: Seq, b#18: Box, b'#18: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#18, x#18, b'#18)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#18), xs#18) } $IsBox(x#18, Seq._default.InvFoldLeft$A) && $Is(xs#18, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#18, Seq._default.InvFoldLeft$B) && $IsBox(b'#18, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#18, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#18), xs#18)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#18, x#18, b'#18)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#18, $Box(xs#18))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#19: Box, xs#19: Seq, b#19: Box, b'#19: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#19, x#19, b'#19)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#19), xs#19) } $IsBox(x#19, Seq._default.InvFoldLeft$A) && $Is(xs#19, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#19, Seq._default.InvFoldLeft$B) && $IsBox(b'#19, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#19, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#19), xs#19)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#19, x#19, b'#19)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#19, $Box(xs#19))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#18: Box, xs#18: Seq, b#18: Box, b'#18: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#18), xs#18), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#18, b#18, b'#18)): bool } $IsBox(x#18, Seq._default.InvFoldRight$A) && $Is(xs#18, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#18, Seq._default.InvFoldRight$B) && $IsBox(b'#18, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#18), b#18)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#18, b#18, b'#18)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#18), xs#18)), b'#18)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#19: Box, xs#19: Seq, b#19: Box, b'#19: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#19), xs#19), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#19, b#19, b'#19)): bool } $IsBox(x#19, Seq._default.InvFoldRight$A) && $Is(xs#19, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#19, Seq._default.InvFoldRight$B) && $IsBox(b'#19, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#19), b#19)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#19, b#19, b'#19)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#19), xs#19)), b'#19)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#17: int :: { Seq#Index(xs#0, i#17) } LitInt(0) <= i#17 && i#17 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#17)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#17: int :: { Seq#Index(xs#0, i#17) } LitInt(0) <= i#17 && i#17 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#17)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, $o: ref :: { $Is($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) } $o != null && $Is($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E)) ==> $Is($o, Tclass.Actions.Action(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E))));

axiom (forall Actions.ActionWithResult$A: Ty, Actions.ActionWithResult$R: Ty, Actions.ActionWithResult$E: Ty, $o: ref, $heap: Heap :: { $IsAlloc($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $heap) } $o != null && $IsAlloc($o, Tclass.Actions.ActionWithResult?(Actions.ActionWithResult$A, Actions.ActionWithResult$R, Actions.ActionWithResult$E), $heap) ==> $IsAlloc($o, Tclass.Actions.Action(Actions.ActionWithResult$A, Tclass.Wrappers.Result(Actions.ActionWithResult$R, Actions.ActionWithResult$E)), $heap));

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, $o: ref :: { $Is($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) } $o != null && $Is($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)) ==> $Is($o, Tclass.Actions.DeterministicAction(Actions.DeterministicActionWithResult$A, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E))));

axiom (forall Actions.DeterministicActionWithResult$A: Ty, Actions.DeterministicActionWithResult$R: Ty, Actions.DeterministicActionWithResult$E: Ty, $o: ref, $heap: Heap :: { $IsAlloc($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $heap) } $o != null && $IsAlloc($o, Tclass.Actions.DeterministicActionWithResult?(Actions.DeterministicActionWithResult$A, Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E), $heap) ==> $IsAlloc($o, Tclass.Actions.DeterministicAction(Actions.DeterministicActionWithResult$A, Tclass.Wrappers.Result(Actions.DeterministicActionWithResult$R, Actions.DeterministicActionWithResult$E)), $heap));

const unique tytagFamily$DeterministicAction: TyTagFamily;

const unique tytagFamily$DeterministicActionWithResult: TyTagFamily;

const unique tytagFamily$ActionWithResult: TyTagFamily;

const unique tytagFamily$ActionInvoke: TyTagFamily;

const unique tytagFamily$Action: TyTagFamily;

const unique class.DafnyLibraries.__default: ClassName;

const unique class.DafnyLibraries.MutableMapTrait?: ClassName;

function Tclass.DafnyLibraries.MutableMapTrait?(Ty, Ty) : Ty;

const unique Tagclass.DafnyLibraries.MutableMapTrait?: TyTag;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty :: { Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V) } Tag(Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == Tagclass.DafnyLibraries.MutableMapTrait? && TagFamily(Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == tytagFamily$MutableMapTrait);

function Tclass.DafnyLibraries.MutableMapTrait?_0(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty :: { Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V) } Tclass.DafnyLibraries.MutableMapTrait?_0(Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == DafnyLibraries.MutableMapTrait$K);

function Tclass.DafnyLibraries.MutableMapTrait?_1(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty :: { Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V) } Tclass.DafnyLibraries.MutableMapTrait?_1(Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == DafnyLibraries.MutableMapTrait$V);

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, bx: Box :: { $IsBox(bx, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) } $IsBox(bx, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)));

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $o: ref :: { $Is($o, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) } $Is($o, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) <==> $o == null || implements$DafnyLibraries.MutableMapTrait(dtype($o), DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V));

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $h) } $IsAlloc($o, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function implements$DafnyLibraries.MutableMapTrait(ty: Ty, DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty) : bool;

function DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : Map
uses {
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) } DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> $Is(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TMap(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)));
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TMap(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) } DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TMap(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap));
}

function DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : bool;

function Tclass.DafnyLibraries.MutableMapTrait(Ty, Ty) : Ty;

const unique Tagclass.DafnyLibraries.MutableMapTrait: TyTag;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty :: { Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V) } Tag(Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == Tagclass.DafnyLibraries.MutableMapTrait && TagFamily(Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == tytagFamily$MutableMapTrait);

function Tclass.DafnyLibraries.MutableMapTrait_0(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty :: { Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V) } Tclass.DafnyLibraries.MutableMapTrait_0(Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == DafnyLibraries.MutableMapTrait$K);

function Tclass.DafnyLibraries.MutableMapTrait_1(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty :: { Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V) } Tclass.DafnyLibraries.MutableMapTrait_1(Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) == DafnyLibraries.MutableMapTrait$V);

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, bx: Box :: { $IsBox(bx, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) } $IsBox(bx, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)));

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this) == DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this));

function DafnyLibraries.MutableMapTrait.content#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.content#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) ==> (DafnyLibraries.MutableMapTrait.content#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.content (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DafnyLibraries.MutableMapTrait.Put (well-formedness)"} CheckWellFormed$$DafnyLibraries.MutableMapTrait.Put(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMapTrait$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMapTrait$V, $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Put (well-formedness)"} CheckWellFormed$$DafnyLibraries.MutableMapTrait.Put(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref, k#0: Box, v#0: Box)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Put", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this, " | ", k#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(25,11): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(27,29): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Map#Equal(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Build(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this), k#0, v#0));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0];
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    goto anon4;

  anon7_Else:
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    goto anon4;

  anon4:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume !Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Set#Equal(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    return;

  anon8_Else:
    assume !Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> Set#Equal(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMapTrait.Put (call precondtion)"} CallPre$$DafnyLibraries.MutableMapTrait.Put(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMapTrait$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMapTrait$V, $Heap));



procedure {:verboseName "DafnyLibraries.MutableMapTrait.Put (call postcondition)"} CallPost$$DafnyLibraries.MutableMapTrait.Put(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMapTrait$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMapTrait$V, $Heap));
  modifies $Heap;
  free ensures DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
  free ensures {:id "id19654"} Map#Equal(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Build(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this), k#0, v#0));
  free ensures DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this) && (Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this));
  free ensures {:id "id19655"} Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
  free ensures DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this) && (!Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this));
  free ensures {:id "id19656"} !Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> Set#Equal(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



function DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : Set
uses {
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) } DafnyLibraries.MutableMapTrait.Keys#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> Set#Equal(DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))) && $Is(DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$K)));
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$K), $Heap) } DafnyLibraries.MutableMapTrait.Keys#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$K), $Heap));
}

function DafnyLibraries.MutableMapTrait.Keys#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this) == DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this));

function DafnyLibraries.MutableMapTrait.Keys#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Keys#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) ==> (DafnyLibraries.MutableMapTrait.Keys#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.Keys (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) returns (keys#0: Set where $Is(keys#0, TSet(DafnyLibraries.MutableMapTrait$K)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19657"} Set#Equal(keys#0, Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Keys (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref) returns (keys#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Keys", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(31,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$K));
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume Set#Equal(keys#0, Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



function DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) } DafnyLibraries.MutableMapTrait.HasKey#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap)) ==> (DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0]));
}

function DafnyLibraries.MutableMapTrait.HasKey#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref, k#0: Box :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this, k#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && (DafnyLibraries.MutableMapTrait.HasKey#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this, k#0) || $IsBox(k#0, DafnyLibraries.MutableMapTrait$K)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this, k#0) <==> DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this, k#0)));

function DafnyLibraries.MutableMapTrait.HasKey#requires(Ty, Ty, Heap, ref, Box) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMapTrait.HasKey#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) ==> (DafnyLibraries.MutableMapTrait.HasKey#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.HasKey (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19659"} DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.HasKey (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref, k#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##k#0: Box;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.HasKey", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(35,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    ##k#0 := k#0;
    assume $IsAllocBox(##k#0, DafnyLibraries.MutableMapTrait$K, $Heap);
    assume (this == this && k#0 == k#0) || (Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this))) && !Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this))));
    assume (this == this && k#0 == k#0) || DafnyLibraries.MutableMapTrait.HasKey#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0];
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



function DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : Set
uses {
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) } DafnyLibraries.MutableMapTrait.Values#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> Set#Equal(DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))) && $Is(DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$V)));
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$V), $Heap) } DafnyLibraries.MutableMapTrait.Values#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$V), $Heap));
}

function DafnyLibraries.MutableMapTrait.Values#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this) == DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this));

function DafnyLibraries.MutableMapTrait.Values#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Values#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) ==> (DafnyLibraries.MutableMapTrait.Values#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.Values (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) returns (values#0: Set where $Is(values#0, TSet(DafnyLibraries.MutableMapTrait$V)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19662"} Set#Equal(values#0, Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Values (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref) returns (values#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Values", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(39,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(DafnyLibraries.MutableMapTrait$V));
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume Set#Equal(values#0, Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



function DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : Set
uses {
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) } DafnyLibraries.MutableMapTrait.Items#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> Set#Equal(DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Items(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))) && Set#Equal(DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), (lambda $y#0: Box :: (exists k#0: Box :: { Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0] } { Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0] } $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0] && $y#0 == $Box(#_System._tuple#2._#Make2(k#0, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0]))))) && $Is(DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V))));
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)), $Heap) } DafnyLibraries.MutableMapTrait.Items#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)), $Heap));
}

function DafnyLibraries.MutableMapTrait.Items#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this) == DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this));

function DafnyLibraries.MutableMapTrait.Items#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Items#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) ==> (DafnyLibraries.MutableMapTrait.Items#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.Items (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) returns (items#0: Set where $Is(items#0, TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19664"} Set#Equal(items#0, Map#Items(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));
  free ensures {:id "id19665"} Set#Equal(items#0, (lambda $y#1: Box :: (exists k#1: Box :: { Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1] } { Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1] } $IsBox(k#1, DafnyLibraries.MutableMapTrait$K) && Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1] && $y#1 == $Box(#_System._tuple#2._#Make2(k#1, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1])))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Items (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref) returns (items#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#2: Box;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Items", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(43,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)));
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume Set#Equal(items#0, Map#Items(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));
    havoc k#2;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} $IsBox(k#2, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#2, DafnyLibraries.MutableMapTrait$K, $Heap);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#2];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#2];
    goto anon5;

  anon9_Else:
    assume {:partition} !Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#2];
    goto anon5;

  anon8_Else:
    assume {:partition} !($IsBox(k#2, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#2, DafnyLibraries.MutableMapTrait$K, $Heap));
    goto anon5;

  anon5:
    assume Set#Equal(items#0, (lambda $y#2: Box :: (exists k#1: Box :: { Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1] } { Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1] } $IsBox(k#1, DafnyLibraries.MutableMapTrait$K) && Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1] && $y#2 == $Box(#_System._tuple#2._#Make2(k#1, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#1])))));
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



function DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref, k#0: Box) : Box
uses {
axiom 3 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) } DafnyLibraries.MutableMapTrait.Select#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap) && DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0)) ==> Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0)] && Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0] == DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) && $IsBox(DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0), DafnyLibraries.MutableMapTrait$V));
axiom 3 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { $IsAllocBox(DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0), DafnyLibraries.MutableMapTrait$V, $Heap) } DafnyLibraries.MutableMapTrait.Select#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap) && DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0)) ==> $IsAllocBox(DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0), DafnyLibraries.MutableMapTrait$V, $Heap));
}

function DafnyLibraries.MutableMapTrait.Select#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref, k#0: Box :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this, k#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && (DafnyLibraries.MutableMapTrait.Select#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this, k#0) || $IsBox(k#0, DafnyLibraries.MutableMapTrait$K)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this, k#0) == DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this, k#0));

function DafnyLibraries.MutableMapTrait.Select#requires(Ty, Ty, Heap, ref, Box) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMapTrait.Select#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) ==> (DafnyLibraries.MutableMapTrait.Select#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0) <==> DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0)));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.Select (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K)) returns (v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMapTrait$V));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19669"} Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[v#0];
  free ensures {:id "id19670"} Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0] == v#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Select (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref, k#0: Box) returns (v#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##k#0: Box;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Select", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(48,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    ##k#0 := k#0;
    assume $IsAllocBox(##k#0, DafnyLibraries.MutableMapTrait$K, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $_ReadsFrame[$o, $f]);
    assume DafnyLibraries.MutableMapTrait.HasKey#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0);
    assume DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0);
    assume b$reqreads#0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this, k#0), DafnyLibraries.MutableMapTrait$V);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[v#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0];
    assume Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))[k#0] == v#0;
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMapTrait.Remove (well-formedness)"} CheckWellFormed$$DafnyLibraries.MutableMapTrait.Remove(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Remove (well-formedness)"} CheckWellFormed$$DafnyLibraries.MutableMapTrait.Remove(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref, k#0: Box)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Remove", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(54,11): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(56,29): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Map#Equal(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Subtract(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this), Set#UnionOne(Set#Empty(): Set, k#0)));
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0];
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), old($Heap));
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
    assume Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)));
    return;

  anon4_Else:
    assume Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)));
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMapTrait.Remove (call precondtion)"} CallPre$$DafnyLibraries.MutableMapTrait.Remove(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap));



procedure {:verboseName "DafnyLibraries.MutableMapTrait.Remove (call postcondition)"} CallPost$$DafnyLibraries.MutableMapTrait.Remove(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMapTrait$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMapTrait$K, $Heap));
  modifies $Heap;
  free ensures DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this);
  free ensures {:id "id19685"} Map#Equal(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), Map#Subtract(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this), Set#UnionOne(Set#Empty(): Set, k#0)));
  free ensures DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this) && (Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this) && DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this));
  free ensures {:id "id19686"} Map#Domain(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, old($Heap), this)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



function DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) } DafnyLibraries.MutableMapTrait.Size#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) ==> DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) == Set#Card(Map#Items(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this))));
}

function DafnyLibraries.MutableMapTrait.Size#canCall(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h0, this) == DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $h1, this));

function DafnyLibraries.MutableMapTrait.Size#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Size#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap) ==> (DafnyLibraries.MutableMapTrait.Size#requires(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMapTrait.Size (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap)) returns (size#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19687"} size#0 == Set#Card(Map#Items(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMapTrait.Size (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, this: ref) returns (size#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMapTrait.Size", " | ", DafnyLibraries.MutableMapTrait$K, " | ", DafnyLibraries.MutableMapTrait$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(59,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $Heap);
    assume DafnyLibraries.MutableMapTrait.content#canCall(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this);
    assume size#0 == Set#Card(Map#Items(DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V, $Heap, this)));
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, c#0: ref :: { $Is(c#0, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) } $Is(c#0, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) <==> $Is(c#0, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V)) && c#0 != null);

axiom (forall DafnyLibraries.MutableMapTrait$K: Ty, DafnyLibraries.MutableMapTrait$V: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $h) } $IsAlloc(c#0, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $h) <==> $IsAlloc(c#0, Tclass.DafnyLibraries.MutableMapTrait?(DafnyLibraries.MutableMapTrait$K, DafnyLibraries.MutableMapTrait$V), $h));

const unique class.DafnyLibraries.MutableMap?: ClassName;

function Tclass.DafnyLibraries.MutableMap?(Ty, Ty) : Ty
uses {
axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: implements$DafnyLibraries.MutableMapTrait(Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V));
}

const unique Tagclass.DafnyLibraries.MutableMap?: TyTag;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: { Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V) } Tag(Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == Tagclass.DafnyLibraries.MutableMap? && TagFamily(Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == tytagFamily$MutableMap);

function Tclass.DafnyLibraries.MutableMap?_0(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: { Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V) } Tclass.DafnyLibraries.MutableMap?_0(Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == DafnyLibraries.MutableMap$K);

function Tclass.DafnyLibraries.MutableMap?_1(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: { Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V) } Tclass.DafnyLibraries.MutableMap?_1(Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == DafnyLibraries.MutableMap$V);

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, bx: Box :: { $IsBox(bx, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) } $IsBox(bx, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)));

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $o: ref :: { $Is($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) } $Is($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) <==> $o == null || dtype($o) == Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V));

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $h) } $IsAlloc($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

function Tclass.DafnyLibraries.MutableMap(Ty, Ty) : Ty;

const unique Tagclass.DafnyLibraries.MutableMap: TyTag;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: { Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V) } Tag(Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == Tagclass.DafnyLibraries.MutableMap && TagFamily(Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == tytagFamily$MutableMap);

function Tclass.DafnyLibraries.MutableMap_0(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: { Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V) } Tclass.DafnyLibraries.MutableMap_0(Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == DafnyLibraries.MutableMap$K);

function Tclass.DafnyLibraries.MutableMap_1(Ty) : Ty;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty :: { Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V) } Tclass.DafnyLibraries.MutableMap_1(Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) == DafnyLibraries.MutableMap$V);

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, bx: Box :: { $IsBox(bx, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) } $IsBox(bx, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)));

procedure {:verboseName "DafnyLibraries.MutableMap._ctor (well-formedness)"} {:extern} CheckWellFormed$$DafnyLibraries.MutableMap.__ctor(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty) returns (this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DafnyLibraries.MutableMap._ctor (call precondtion)"} {:extern} CallPre$$DafnyLibraries.MutableMap.__ctor(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty);



procedure {:verboseName "DafnyLibraries.MutableMap._ctor (call postcondition)"} {:extern} CallPost$$DafnyLibraries.MutableMap.__ctor(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty) returns (this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap));
  modifies $Heap;
  free ensures DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
  free ensures {:id "id19690"} Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Empty(): Map);
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



function DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : Map
uses {
axiom 0 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) } DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> $Is(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)));
axiom 0 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) } DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap));
}

function DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this) == DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this));

function DafnyLibraries.MutableMap.content#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.content#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) ==> (DafnyLibraries.MutableMap.content#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) <==> true));

axiom 0 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (0 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> DafnyLibraries.MutableMapTrait.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this));

procedure {:verboseName "DafnyLibraries.MutableMap.content (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "DafnyLibraries.MutableMap.content (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.content (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.content", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Put (well-formedness)"} {:extern} CheckWellFormed$$DafnyLibraries.MutableMap.Put(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMap$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMap$V, $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Put (well-formedness)"} {:extern} CheckWellFormed$$DafnyLibraries.MutableMap.Put(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box, v#0: Box)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Put", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(71,21): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(73,29): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Build(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), k#0, v#0));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0];
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    goto anon4;

  anon7_Else:
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    goto anon4;

  anon4:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume !Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Set#Equal(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    return;

  anon8_Else:
    assume !Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Put (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Put(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMap$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMap$V, $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Put (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Put(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box, v#0: Box)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Put", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box", " | ", "Box"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume true;
    assume {:extern} (forall $o: ref, $f: Field :: true);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Build(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), k#0, v#0));
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    assume !Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    assume Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Build(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), k#0, v#0));
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    assume !Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Put (call precondtion)"} {:extern} CallPre$$DafnyLibraries.MutableMap.Put(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMap$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMap$V, $Heap));



procedure {:verboseName "DafnyLibraries.MutableMap.Put (call postcondition)"} {:extern} CallPost$$DafnyLibraries.MutableMap.Put(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap), v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMap$V) && $IsAllocBox(v#0, DafnyLibraries.MutableMap$V, $Heap));
  modifies $Heap;
  free ensures DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
  free ensures {:id "id19716"} Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Build(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), k#0, v#0));
  free ensures DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this) && (Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this));
  free ensures {:id "id19717"} Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
  free ensures DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this) && (!Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this));
  free ensures {:id "id19718"} !Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)), Set#UnionOne(Set#Empty(): Set, v#0)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



function DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : Set
uses {
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) } DafnyLibraries.MutableMap.Keys#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> Set#Equal(DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))) && $Is(DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$K)));
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$K), $Heap) } DafnyLibraries.MutableMap.Keys#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$K), $Heap));
}

function DafnyLibraries.MutableMap.Keys#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this) == DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this));

function DafnyLibraries.MutableMap.Keys#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Keys#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) ==> (DafnyLibraries.MutableMap.Keys#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.Keys#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> DafnyLibraries.MutableMapTrait.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this));

procedure {:verboseName "DafnyLibraries.MutableMap.Keys (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (keys#0: Set where $Is(keys#0, TSet(DafnyLibraries.MutableMap$K)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19719"} Set#Equal(keys#0, Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Keys (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (keys#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Keys", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(77,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$K));
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Set#Equal(keys#0, Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Keys (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (keys#0: Set where $Is(keys#0, TSet(DafnyLibraries.MutableMap$K)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Keys (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (keys#0: Set)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Keys", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    assume Set#Equal(keys#0, Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume DafnyLibraries.MutableMap.Keys(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == keys#0;
    assume Set#Equal(keys#0, Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    return;
}



function DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) } DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap)) ==> (DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0]));
}

function DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref, k#0: Box :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this, k#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && (DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this, k#0) || $IsBox(k#0, DafnyLibraries.MutableMap$K)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this, k#0) <==> DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this, k#0)));

function DafnyLibraries.MutableMap.HasKey#requires(Ty, Ty, Heap, ref, Box) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.HasKey#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) ==> (DafnyLibraries.MutableMap.HasKey#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> (DafnyLibraries.MutableMapTrait.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)));

procedure {:verboseName "DafnyLibraries.MutableMap.HasKey (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19725"} DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.HasKey (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##k#0: Box;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.HasKey", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(81,24): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    ##k#0 := k#0;
    assume $IsAllocBox(##k#0, DafnyLibraries.MutableMap$K, $Heap);
    assume (this == this && k#0 == k#0) || (Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this))) && !Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this))));
    assume (this == this && k#0 == k#0) || DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0];
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.HasKey (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.HasKey (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.HasKey", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0];
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0];
    return;
}



function DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : Set
uses {
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) } DafnyLibraries.MutableMap.Values#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> Set#Equal(DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))) && $Is(DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$V)));
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$V), $Heap) } DafnyLibraries.MutableMap.Values#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$V), $Heap));
}

function DafnyLibraries.MutableMap.Values#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this) == DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this));

function DafnyLibraries.MutableMap.Values#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Values#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) ==> (DafnyLibraries.MutableMap.Values#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.Values#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> DafnyLibraries.MutableMapTrait.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this));

procedure {:verboseName "DafnyLibraries.MutableMap.Values (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (values#0: Set where $Is(values#0, TSet(DafnyLibraries.MutableMap$V)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19732"} Set#Equal(values#0, Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Values (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (values#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Values", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(85,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(DafnyLibraries.MutableMap$V));
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Set#Equal(values#0, Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Values (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (values#0: Set where $Is(values#0, TSet(DafnyLibraries.MutableMap$V)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Values (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (values#0: Set)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Values", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    assume Set#Equal(values#0, Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume DafnyLibraries.MutableMap.Values(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == values#0;
    assume Set#Equal(values#0, Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    return;
}



function DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : Set
uses {
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) } DafnyLibraries.MutableMap.Items#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> Set#Equal(DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))) && Set#Equal(DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), (lambda $y#0: Box :: (exists k#0: Box :: { Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] } { Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] } $IsBox(k#0, DafnyLibraries.MutableMap$K) && Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] && $y#0 == $Box(#_System._tuple#2._#Make2(k#0, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0]))))) && $Is(DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))));
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { $IsAlloc(DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $Heap) } DafnyLibraries.MutableMap.Items#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $Heap));
}

function DafnyLibraries.MutableMap.Items#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this) == DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this));

function DafnyLibraries.MutableMap.Items#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Items#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) ==> (DafnyLibraries.MutableMap.Items#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.Items#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> DafnyLibraries.MutableMapTrait.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this));

procedure {:verboseName "DafnyLibraries.MutableMap.Items (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (items#0: Set where $Is(items#0, TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19738"} Set#Equal(items#0, Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
  free ensures {:id "id19739"} Set#Equal(items#0, (lambda $y#1: Box :: (exists k#1: Box :: { Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] } { Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] } $IsBox(k#1, DafnyLibraries.MutableMap$K) && Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] && $y#1 == $Box(#_System._tuple#2._#Make2(k#1, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1])))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Items (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (items#0: Set)
{
  var $_ReadsFrame: [ref,Field]bool;
  var k#2: Box;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Items", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(89,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)));
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Set#Equal(items#0, Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    havoc k#2;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} $IsBox(k#2, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#2, DafnyLibraries.MutableMap$K, $Heap);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#2];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#2];
    goto anon5;

  anon9_Else:
    assume {:partition} !Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#2];
    goto anon5;

  anon8_Else:
    assume {:partition} !($IsBox(k#2, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#2, DafnyLibraries.MutableMap$K, $Heap));
    goto anon5;

  anon5:
    assume Set#Equal(items#0, (lambda $y#2: Box :: (exists k#1: Box :: { Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] } { Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] } $IsBox(k#1, DafnyLibraries.MutableMap$K) && Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] && $y#2 == $Box(#_System._tuple#2._#Make2(k#1, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1])))));
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Items (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (items#0: Set where $Is(items#0, TSet(Tclass._System.Tuple2(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Items (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (items#0: Set)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Items", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    assume Set#Equal(items#0, Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume Set#Equal(items#0, (lambda $y#3: Box :: (exists k#1: Box :: { Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] } { Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] } $IsBox(k#1, DafnyLibraries.MutableMap$K) && Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1] && $y#3 == $Box(#_System._tuple#2._#Make2(k#1, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#1])))));
    assume DafnyLibraries.MutableMap.Items(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == items#0;
    assume Set#Equal(items#0, Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume Set#Equal(items#0, (lambda $y#4: Box :: (exists k#3: Box :: { Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#3] } { Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#3] } $IsBox(k#3, DafnyLibraries.MutableMap$K) && Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#3] && $y#4 == $Box(#_System._tuple#2._#Make2(k#3, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#3])))));
    return;
}



function DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref, k#0: Box) : Box
uses {
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) } DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap) && DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) ==> Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)] && Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && $IsBox(DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), DafnyLibraries.MutableMap$V));
axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { $IsAllocBox(DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), DafnyLibraries.MutableMap$V, $Heap) } DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap) && DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) ==> $IsAllocBox(DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), DafnyLibraries.MutableMap$V, $Heap));
}

function DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref, k#0: Box :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this, k#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && (DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this, k#0) || $IsBox(k#0, DafnyLibraries.MutableMap$K)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this, k#0) == DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this, k#0));

function DafnyLibraries.MutableMap.Select#requires(Ty, Ty, Heap, ref, Box) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.Select#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) ==> (DafnyLibraries.MutableMap.Select#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)));

axiom 2 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (2 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> DafnyLibraries.MutableMapTrait.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) == DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0));

procedure {:verboseName "DafnyLibraries.MutableMap.Select (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K)) returns (v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMap$V));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19749"} Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[v#0];
  free ensures {:id "id19750"} Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == v#0;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Select (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box) returns (v#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##k#0: Box;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Select", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(94,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    ##k#0 := k#0;
    assume $IsAllocBox(##k#0, DafnyLibraries.MutableMap$K, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $_ReadsFrame[$o, $f]);
    assume DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume b$reqreads#0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsBox(DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), DafnyLibraries.MutableMap$V);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[v#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0];
    assume Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == v#0;
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Select (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K)) returns (v#0: Box where $IsBox(v#0, DafnyLibraries.MutableMap$V));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Select (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box) returns (v#0: Box)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Select", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    assume Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[v#0];
    assume Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == v#0;
    assume DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) == v#0;
    assume Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[v#0];
    assume Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == v#0;
    return;
}



function DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref, k#0: Box) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) } DafnyLibraries.MutableMap.SelectOpt#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap)) ==> (Wrappers.Option.Some_q(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) ==> DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[Wrappers.Option.value(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0))] && Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == Wrappers.Option.value(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0))) && (Wrappers.Option.None_q(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) ==> !DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) && $Is(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V)));
axiom 3 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { $IsAlloc(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V), $Heap) } DafnyLibraries.MutableMap.SelectOpt#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap)) ==> $IsAlloc(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V), $Heap));
axiom 3 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.SelectOpt#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K)) ==> DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && (DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) ==> DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) && DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) == (if DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) then #Wrappers.Option.Some(DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0)) else #Wrappers.Option.None()));
}

function DafnyLibraries.MutableMap.SelectOpt#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref, k#0: Box) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref, k#0: Box :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this, k#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && (DafnyLibraries.MutableMap.SelectOpt#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this, k#0) || $IsBox(k#0, DafnyLibraries.MutableMap$K)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this, k#0) == DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this, k#0));

function DafnyLibraries.MutableMap.SelectOpt#requires(Ty, Ty, Heap, ref, Box) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref, k#0: Box :: { DafnyLibraries.MutableMap.SelectOpt#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) && $IsBox(k#0, DafnyLibraries.MutableMap$K) ==> (DafnyLibraries.MutableMap.SelectOpt#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) <==> true));

procedure {:verboseName "DafnyLibraries.MutableMap.SelectOpt (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19764"} Wrappers.Option.Some_q(o#0) ==> DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
  free ensures {:id "id19765"} Wrappers.Option.Some_q(o#0) ==> Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[Wrappers.Option.value(o#0)];
  free ensures {:id "id19766"} Wrappers.Option.Some_q(o#0) ==> Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == Wrappers.Option.value(o#0);
  free ensures {:id "id19767"} Wrappers.Option.None_q(o#0) ==> !DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.SelectOpt (well-formedness)"} CheckWellformed$$DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box) returns (o#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##k#0: Box;
  var ##k#1: Box;
  var ##k#2: Box;
  var ##k#3: Box;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.SelectOpt", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(100,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume $Is(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Wrappers.Option.Some_q(o#0);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    ##k#0 := k#0;
    assume $IsAllocBox(##k#0, DafnyLibraries.MutableMap$K, $Heap);
    assume DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume Wrappers.Option.Some_q(o#0);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    goto anon5;

  anon19_Else:
    assume {:partition} !DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    goto anon5;

  anon5:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[Wrappers.Option.value(o#0)];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0];
    assume Wrappers.Option.Some_q(o#0);
    goto anon7;

  anon20_Else:
    assume {:partition} !(DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[Wrappers.Option.value(o#0)]);
    goto anon7;

  anon7:
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[Wrappers.Option.value(o#0)] && Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == Wrappers.Option.value(o#0);
    goto anon9;

  anon18_Else:
    assume Wrappers.Option.Some_q(o#0) ==> DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) && Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[Wrappers.Option.value(o#0)] && Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))[k#0] == Wrappers.Option.value(o#0);
    goto anon9;

  anon9:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Wrappers.Option.None_q(o#0);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    ##k#1 := k#0;
    assume $IsAllocBox(##k#1, DafnyLibraries.MutableMap$K, $Heap);
    assume DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume !DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    goto anon12;

  anon21_Else:
    assume Wrappers.Option.None_q(o#0) ==> !DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    goto anon12;

  anon12:
    assume false;
    return;

  anon17_Else:
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    ##k#2 := k#0;
    assume $IsAllocBox(##k#2, DafnyLibraries.MutableMap$K, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $_ReadsFrame[$o, $f]);
    assume DafnyLibraries.MutableMap.HasKey#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    ##k#3 := k#0;
    assume $IsAllocBox(##k#3, DafnyLibraries.MutableMap$K, $Heap);
    assume {:subsumption 0} DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, ##k#3);
    assume DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, ##k#3);
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $_ReadsFrame[$o, $f]);
    assume DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) == #Wrappers.Option.Some(DafnyLibraries.MutableMap.Select(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0));
    assume DafnyLibraries.MutableMap.Select#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume $Is(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V));
    goto anon16;

  anon22_Else:
    assume {:partition} !DafnyLibraries.MutableMap.HasKey(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0);
    assume DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) == Lit(#Wrappers.Option.None());
    assume true;
    assume $Is(DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0), Tclass.Wrappers.Option(DafnyLibraries.MutableMap$V));
    goto anon16;

  anon16:
    assume DafnyLibraries.MutableMap.SelectOpt(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this, k#0) == o#0;
    assume b$reqreads#0;
    assume b$reqreads#1;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Remove (well-formedness)"} {:extern} CheckWellFormed$$DafnyLibraries.MutableMap.Remove(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Remove (well-formedness)"} {:extern} CheckWellFormed$$DafnyLibraries.MutableMap.Remove(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Remove", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(111,21): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(113,29): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Subtract(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), Set#UnionOne(Set#Empty(): Set, k#0)));
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0];
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0];
    assume $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), old($Heap));
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
    assume Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)));
    return;

  anon4_Else:
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)));
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Remove (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Remove(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Remove (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Remove(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref, k#0: Box)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Remove", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this, " | ", k#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume true;
    assume {:extern} (forall $o: ref, $f: Field :: true);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
    assume $HeapSucc(old($Heap), $Heap);
    assume Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Subtract(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), Set#UnionOne(Set#Empty(): Set, k#0)));
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)));
    assume Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Subtract(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), Set#UnionOne(Set#Empty(): Set, k#0)));
    assume Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)));
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Remove (call precondtion)"} {:extern} CallPre$$DafnyLibraries.MutableMap.Remove(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap));



procedure {:verboseName "DafnyLibraries.MutableMap.Remove (call postcondition)"} {:extern} CallPost$$DafnyLibraries.MutableMap.Remove(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap), k#0: Box where $IsBox(k#0, DafnyLibraries.MutableMap$K) && $IsAllocBox(k#0, DafnyLibraries.MutableMap$K, $Heap));
  modifies $Heap;
  free ensures DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this);
  free ensures {:id "id19799"} Map#Equal(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), Map#Subtract(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this), Set#UnionOne(Set#Empty(): Set, k#0)));
  free ensures DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this) && (Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this) && DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this));
  free ensures {:id "id19800"} Map#Domain(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0] ==> Set#Equal(Set#Union(Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)), Set#UnionOne(Set#Empty(): Set, Map#Elements(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this))[k#0])), Map#Values(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, old($Heap), this)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this);
  free ensures $HeapSucc(old($Heap), $Heap);



function DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) } DafnyLibraries.MutableMap.Size#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) ==> DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == Set#Card(Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this))));
}

function DafnyLibraries.MutableMap.Size#canCall(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $heap: Heap, this: ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h0, this) == DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $h1, this));

function DafnyLibraries.MutableMap.Size#requires(Ty, Ty, Heap, ref) : bool;

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMap.Size#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap) ==> (DafnyLibraries.MutableMap.Size#requires(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) <==> true));

axiom 1 <= $FunctionContextHeight ==> (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $Heap: Heap, this: ref :: { DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)), $IsGoodHeap($Heap) } { DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this), $IsGoodHeap($Heap) } DafnyLibraries.MutableMap.Size#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V))) ==> DafnyLibraries.MutableMapTrait.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this));

procedure {:verboseName "DafnyLibraries.MutableMap.Size (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (size#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19801"} size#0 == Set#Card(Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Size (well-formedness)"} {:extern} CheckWellformed$$DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (size#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Size", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/MutableMap/MutableMap.dfy(116,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(this), Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap);
    assume DafnyLibraries.MutableMap.content#canCall(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this);
    assume size#0 == Set#Card(Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume false;
    return;

  anon4_Else:
    assume false;
    return;
}



procedure {:verboseName "DafnyLibraries.MutableMap.Size (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref where this != null && $Is(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && $IsAlloc(this, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $Heap)) returns (size#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "DafnyLibraries.MutableMap.Size (override check)"} {:extern} OverrideCheck$$DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, this: ref) returns (size#0: int)
{
  var DafnyLibraries.MutableMapTrait$K: Ty;
  var DafnyLibraries.MutableMapTrait$V: Ty;
  var MutableMap_$_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "DafnyLibraries.MutableMap.Size", " | ", DafnyLibraries.MutableMap$K, " | ", DafnyLibraries.MutableMap$V, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref"} true;
    assume DafnyLibraries.MutableMapTrait$K == DafnyLibraries.MutableMap$K;
    assume DafnyLibraries.MutableMapTrait$V == DafnyLibraries.MutableMap$V;
    assume Set#Subset(Set#UnionOne(Set#Empty(): Set, $Box(this)), Set#UnionOne(Set#Empty(): Set, $Box(this)));
    MutableMap_$_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this);
    assume {:extern} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == this ==> $o == this);
    assume size#0 == Set#Card(Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    assume DafnyLibraries.MutableMap.Size(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this) == size#0;
    assume size#0 == Set#Card(Map#Items(DafnyLibraries.MutableMap.content(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V, $Heap, this)));
    return;
}



axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, c#0: ref :: { $Is(c#0, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) } $Is(c#0, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) <==> $Is(c#0, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) && c#0 != null);

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $h) } $IsAlloc(c#0, Tclass.DafnyLibraries.MutableMap(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $h) <==> $IsAlloc(c#0, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#132 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#132))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#134 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#134)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#198 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#198))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#200 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#200)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#202 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#202)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#198 := Wrappers.Option.value(this); v#198)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#200 := Lit(Wrappers.Option.value(Lit(this))); v#200)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#202 := Lit(Wrappers.Option.value(Lit(this))); v#202)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#132 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#132)) else (var e#132 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#134 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#134))) else (var e#134 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#198 := Wrappers.Result.value(this); s#198) else (var e#198 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#200 := Lit(Wrappers.Result.value(Lit(this))); s#200) else (var e#200 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#202 := Lit(Wrappers.Result.value(Lit(this))); s#202) else (var e#202 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#198 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#198)) else (var e#198 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#198)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#200 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#200))) else (var e#200 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#200)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#202 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#202))) else (var e#202 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#202)))));

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $o: ref :: { $Is($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) } $o != null && $Is($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)) ==> $Is($o, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V)));

axiom (forall DafnyLibraries.MutableMap$K: Ty, DafnyLibraries.MutableMap$V: Ty, $o: ref, $heap: Heap :: { $IsAlloc($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $heap) } $o != null && $IsAlloc($o, Tclass.DafnyLibraries.MutableMap?(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $heap) ==> $IsAlloc($o, Tclass.DafnyLibraries.MutableMapTrait(DafnyLibraries.MutableMap$K, DafnyLibraries.MutableMap$V), $heap));

const unique tytagFamily$MutableMapTrait: TyTagFamily;

const unique tytagFamily$MutableMap: TyTagFamily;

const unique class.JSON_mUtils_mViews_mCore.__default: ClassName;

function JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0: DatatypeType, rv#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(lv#0, rv#0) || (2 < $FunctionContextHeight && $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(lv#0) && JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && (JSON_mUtils_mViews_mCore.View__.end(lv#0) == JSON_mUtils_mViews_mCore.View__.beg(rv#0) ==> JSON_mUtils_mViews_mCore.View__.View_q(lv#0) && JSON_mUtils_mViews_mCore.View__.View_q(rv#0)) && (JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0) <==> JSON_mUtils_mViews_mCore.View__.end(lv#0) == JSON_mUtils_mViews_mCore.View__.beg(rv#0) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(lv#0), JSON_mUtils_mViews_mCore.View__.s(rv#0))));
axiom 2 <= $FunctionContextHeight ==> (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(Lit(lv#0), Lit(rv#0)) || (2 < $FunctionContextHeight && $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(lv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && (LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(lv#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(rv#0))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(lv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0))) && (JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)) <==> LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(lv#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(rv#0))) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(lv#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(rv#0)))));
}

function JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(lv#0: DatatypeType, rv#0: DatatypeType) : bool;

function Tclass.JSON_mUtils_mViews_mCore.View() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mViews_mCore.View()) == Tagclass.JSON_mUtils_mViews_mCore.View && TagFamily(Tclass.JSON_mUtils_mViews_mCore.View()) == tytagFamily$View;
}

const unique Tagclass.JSON_mUtils_mViews_mCore.View: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mViews_mCore.View()) } $IsBox(bx, Tclass.JSON_mUtils_mViews_mCore.View()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mViews_mCore.View()));

function JSON_mUtils_mViews_mCore.__default.Adjacent#requires(DatatypeType, DatatypeType) : bool;

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Adjacent#requires(lv#0, rv#0) } $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mCore.__default.Adjacent#requires(lv#0, rv#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Core.Adjacent (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0: DatatypeType where $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()), rv#0: DatatypeType where $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.__default.Merge(lv#0: DatatypeType, rv#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || (3 < $FunctionContextHeight && $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0)), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(lv#0), JSON_mUtils_mViews_mCore.View__.Bytes(rv#0))) && $Is(JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0), Tclass.JSON_mUtils_mViews_mCore.View()));
axiom 3 <= $FunctionContextHeight ==> (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || (3 < $FunctionContextHeight && $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#0 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#0)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#0 := lv#0; (var dt_update#end#0#0 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#0), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#0), dt_update#end#0#0))));
axiom 3 <= $FunctionContextHeight ==> (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || (3 < $FunctionContextHeight && $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#1 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#1) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#1)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#1 := Lit(lv#0); (var dt_update#end#0#1 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#1)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#1)), dt_update#end#0#1)))));
}

function JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0: DatatypeType, rv#0: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.__default.Merge#requires(DatatypeType, DatatypeType) : bool;

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge#requires(lv#0, rv#0) } $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mCore.__default.Merge#requires(lv#0, rv#0) <==> JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)));

procedure {:verboseName "JSON.Utils.Views.Core.Merge (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.__default.Merge(lv#0: DatatypeType where $Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()), rv#0: DatatypeType where $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View())) returns (v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19808"} Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(lv#0), JSON_mUtils_mViews_mCore.View__.Bytes(rv#0)));



function Tclass.JSON_mUtils_mViews_mCore.View__() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mViews_mCore.View__()) == Tagclass.JSON_mUtils_mViews_mCore.View__ && TagFamily(Tclass.JSON_mUtils_mViews_mCore.View__()) == tytagFamily$View_;
}

const unique Tagclass.JSON_mUtils_mViews_mCore.View__: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mViews_mCore.View__()) } $IsBox(bx, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mViews_mCore.View__()));

function JSON_mUtils_mViews_mCore.View__.Valid_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Valid_q(this): bool } JSON_mUtils_mViews_mCore.View__.Valid_q(this): bool <==> LitInt(0) <= JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.beg(this) <= JSON_mUtils_mViews_mCore.View__.end(this) && JSON_mUtils_mViews_mCore.View__.end(this) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s(this)) && Seq#Length(JSON_mUtils_mViews_mCore.View__.s(this)) < BoundedInts.__default.TWO__TO__THE__32());
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Valid_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> $Is(JSON_mUtils_mViews_mCore.View__.Valid_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Valid_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.Valid_q($o), TBool, $h));
}

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.Merge (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.__default.Merge(lv#0: DatatypeType, rv#0: DatatypeType) returns (v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##lv#0: DatatypeType;
  var ##rv#0: DatatypeType;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#end#0#Z#0: int;
  var let#1#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.Merge", " | ", lv#0, " | ", rv#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(117,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##lv#0 := lv#0;
    assume $IsAlloc(##lv#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    ##rv#0 := rv#0;
    assume $IsAlloc(##rv#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(lv#0, rv#0);
    assume JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0), Tclass.JSON_mUtils_mViews_mCore.View());
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume $IsAllocBox($Box(lv#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(lv#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(lv#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(lv#0);
    assume $IsAllocBox($Box(rv#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(rv#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(rv#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(rv#0);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(lv#0), JSON_mUtils_mViews_mCore.View__.Bytes(rv#0)));
    assume false;
    return;

  anon4_Else:
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume let#0#0#0 == lv#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mCore.View());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#end#0#Z#0;
    assume LitInt(0) <= dt_update#end#0#Z#0 && dt_update#end#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.View_q(rv#0);
    assume let#1#0#0 == JSON_mUtils_mViews_mCore.View__.end(rv#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(rv#0);
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#end#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#Z#0);
    assume $Is(#JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#Z#0), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#Z#0), dt_update#end#0#Z#0), Tclass.JSON_mUtils_mViews_mCore.View());
    assume JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#Z#0), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#Z#0), dt_update#end#0#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#Z#0);
    assume $Is(JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0), Tclass.JSON_mUtils_mViews_mCore.View());
    assume JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == v#0;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Core.View (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View__()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(8,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(#JSON.Utils.Views.Core.View_.View(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0))));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View__(), $h));

function #JSON.Utils.Views.Core.View_.View(Seq, int, int) : DatatypeType;

const unique ##JSON.Utils.Views.Core.View_.View: DtCtorId
uses {
axiom (forall a#0#0#0: Seq, a#0#1#0: int, a#0#2#0: int :: { #JSON.Utils.Views.Core.View_.View(a#0#0#0, a#0#1#0, a#0#2#0) } DatatypeCtorId(#JSON.Utils.Views.Core.View_.View(a#0#0#0, a#0#1#0, a#0#2#0)) == ##JSON.Utils.Views.Core.View_.View);
}

function JSON_mUtils_mViews_mCore.View__.View_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.View_q(d) } JSON_mUtils_mViews_mCore.View__.View_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Views.Core.View_.View);

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.View_q(d) } JSON_mUtils_mViews_mCore.View__.View_q(d) ==> (exists a#1#0#0: Seq, a#1#1#0: int, a#1#2#0: int :: d == #JSON.Utils.Views.Core.View_.View(a#1#0#0, a#1#1#0, a#1#2#0)));

axiom (forall a#2#0#0: Seq, a#2#1#0: int, a#2#2#0: int :: { $Is(#JSON.Utils.Views.Core.View_.View(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mUtils_mViews_mCore.View__()) } $Is(#JSON.Utils.Views.Core.View_.View(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mUtils_mViews_mCore.View__()) <==> $Is(a#2#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#2#1#0, Tclass.BoundedInts.uint32()) && $Is(a#2#2#0, Tclass.BoundedInts.uint32()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mCore.View__.s(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mCore.View__.View_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.s(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mCore.View__.beg(d), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mCore.View__.View_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.beg(d), Tclass.BoundedInts.uint32(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mCore.View__.end(d), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mCore.View__.View_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.end(d), Tclass.BoundedInts.uint32(), $h));

axiom (forall a#3#0#0: Seq, a#3#1#0: int, a#3#2#0: int :: { #JSON.Utils.Views.Core.View_.View(Lit(a#3#0#0), LitInt(a#3#1#0), LitInt(a#3#2#0)) } #JSON.Utils.Views.Core.View_.View(Lit(a#3#0#0), LitInt(a#3#1#0), LitInt(a#3#2#0)) == Lit(#JSON.Utils.Views.Core.View_.View(a#3#0#0, a#3#1#0, a#3#2#0)));

function JSON_mUtils_mViews_mCore.View__.s(DatatypeType) : Seq;

axiom (forall a#4#0#0: Seq, a#4#1#0: int, a#4#2#0: int :: { #JSON.Utils.Views.Core.View_.View(a#4#0#0, a#4#1#0, a#4#2#0) } JSON_mUtils_mViews_mCore.View__.s(#JSON.Utils.Views.Core.View_.View(a#4#0#0, a#4#1#0, a#4#2#0)) == a#4#0#0);

axiom (forall a#5#0#0: Seq, a#5#1#0: int, a#5#2#0: int, i: int :: { Seq#Index(a#5#0#0, i), #JSON.Utils.Views.Core.View_.View(a#5#0#0, a#5#1#0, a#5#2#0) } 0 <= i && i < Seq#Length(a#5#0#0) ==> DtRank($Unbox(Seq#Index(a#5#0#0, i)): DatatypeType) < DtRank(#JSON.Utils.Views.Core.View_.View(a#5#0#0, a#5#1#0, a#5#2#0)));

axiom (forall a#6#0#0: Seq, a#6#1#0: int, a#6#2#0: int :: { #JSON.Utils.Views.Core.View_.View(a#6#0#0, a#6#1#0, a#6#2#0) } Seq#Rank(a#6#0#0) < DtRank(#JSON.Utils.Views.Core.View_.View(a#6#0#0, a#6#1#0, a#6#2#0)));

function JSON_mUtils_mViews_mCore.View__.beg(DatatypeType) : int;

axiom (forall a#7#0#0: Seq, a#7#1#0: int, a#7#2#0: int :: { #JSON.Utils.Views.Core.View_.View(a#7#0#0, a#7#1#0, a#7#2#0) } JSON_mUtils_mViews_mCore.View__.beg(#JSON.Utils.Views.Core.View_.View(a#7#0#0, a#7#1#0, a#7#2#0)) == a#7#1#0);

function JSON_mUtils_mViews_mCore.View__.end(DatatypeType) : int;

axiom (forall a#8#0#0: Seq, a#8#1#0: int, a#8#2#0: int :: { #JSON.Utils.Views.Core.View_.View(a#8#0#0, a#8#1#0, a#8#2#0) } JSON_mUtils_mViews_mCore.View__.end(#JSON.Utils.Views.Core.View_.View(a#8#0#0, a#8#1#0, a#8#2#0)) == a#8#2#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mViews_mCore.View__(), $h));

function $IsA#JSON_mUtils_mViews_mCore.View__(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mViews_mCore.View__(d) } $IsA#JSON_mUtils_mViews_mCore.View__(d) ==> JSON_mUtils_mViews_mCore.View__.View_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.View_q(d), $Is(d, Tclass.JSON_mUtils_mViews_mCore.View__()) } $Is(d, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> JSON_mUtils_mViews_mCore.View__.View_q(d));

function JSON_mUtils_mViews_mCore.View__#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mCore.View__#Equal(a, b) } JSON_mUtils_mViews_mCore.View__#Equal(a, b) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(a), JSON_mUtils_mViews_mCore.View__.s(b)) && JSON_mUtils_mViews_mCore.View__.beg(a) == JSON_mUtils_mViews_mCore.View__.beg(b) && JSON_mUtils_mViews_mCore.View__.end(a) == JSON_mUtils_mViews_mCore.View__.end(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mCore.View__#Equal(a, b) } JSON_mUtils_mViews_mCore.View__#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mViews_mCore.View__: ClassName;

procedure {:verboseName "JSON.Utils.Views.Core.View_.Valid? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.Valid_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.View__.Empty() : DatatypeType
uses {
axiom JSON_mUtils_mViews_mCore.View__.Empty(): DatatypeType == Lit(#JSON.Utils.Views.Core.View_.View(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0)));
axiom 2 < $FunctionContextHeight ==> $Is(JSON_mUtils_mViews_mCore.View__.Empty(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Utils.Views.Core.View_.Empty (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.Empty();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Empty (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.Empty()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Empty"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(13,17): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume $Is(Lit(#JSON.Utils.Views.Core.View_.View(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0))), Tclass.JSON_mUtils_mViews_mCore.View());
    return;
}



axiom 2 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mCore.View__.Empty(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.Empty(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mUtils_mViews_mCore.View__.Empty_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Empty_q(this): bool } JSON_mUtils_mViews_mCore.View__.Empty_q(this): bool <==> JSON_mUtils_mViews_mCore.View__.beg(this) == JSON_mUtils_mViews_mCore.View__.end(this));
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Empty_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> $Is(JSON_mUtils_mViews_mCore.View__.Empty_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Empty_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.Empty_q($o), TBool, $h));
}

procedure {:verboseName "JSON.Utils.Views.Core.View_.Empty? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.Empty_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.View__.Length(this: DatatypeType) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Length(this) } JSON_mUtils_mViews_mCore.View__.Length#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mViews_mCore.View__.Length(this) && JSON_mUtils_mViews_mCore.View__.Length(this) < BoundedInts.__default.TWO__TO__THE__32());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Length(this) } JSON_mUtils_mViews_mCore.View__.Length#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.Length(this) == JSON_mUtils_mViews_mCore.View__.end(this) - JSON_mUtils_mViews_mCore.View__.beg(this));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Length(Lit(this)) } JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.Length(Lit(this)) == LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this)) - JSON_mUtils_mViews_mCore.View__.beg(Lit(this))));
}

function JSON_mUtils_mViews_mCore.View__.Length#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.View__.Length#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Length#requires(this) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> (JSON_mUtils_mViews_mCore.View__.Length#requires(this) <==> JSON_mUtils_mViews_mCore.View__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Views.Core.View_.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Length(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Length(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Length", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(19,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mViews_mCore.View__.Length(this) && JSON_mUtils_mViews_mCore.View__.Length(this) < BoundedInts.__default.TWO__TO__THE__32();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.end(this) - JSON_mUtils_mViews_mCore.View__.beg(this);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.Length(this) == JSON_mUtils_mViews_mCore.View__.end(this) - JSON_mUtils_mViews_mCore.View__.beg(this);
    assume JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume $Is(JSON_mUtils_mViews_mCore.View__.Length(this), Tclass.BoundedInts.uint32());
    return;
}



function JSON_mUtils_mViews_mCore.View__.Bytes(this: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Bytes(this) } JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> $Is(JSON_mUtils_mViews_mCore.View__.Bytes(this), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Bytes(this) } JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.Bytes(this) == Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.end(this)), JSON_mUtils_mViews_mCore.View__.beg(this)));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Bytes(Lit(this)) } JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.Bytes(Lit(this)) == Lit(Seq#Drop(Seq#Take(Lit(JSON_mUtils_mViews_mCore.View__.s(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this)))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))))));
}

function JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.View__.Bytes#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Bytes#requires(this) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> (JSON_mUtils_mViews_mCore.View__.Bytes#requires(this) <==> JSON_mUtils_mViews_mCore.View__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Views.Core.View_.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Bytes(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Bytes(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Bytes", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(23,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mViews_mCore.View__.Bytes(this), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume 0 <= JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.beg(this) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s(this));
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume JSON_mUtils_mViews_mCore.View__.beg(this) <= JSON_mUtils_mViews_mCore.View__.end(this) && JSON_mUtils_mViews_mCore.View__.end(this) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s(this));
    assume JSON_mUtils_mViews_mCore.View__.Bytes(this) == Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.end(this)), JSON_mUtils_mViews_mCore.View__.beg(this));
    assume JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume $Is(JSON_mUtils_mViews_mCore.View__.Bytes(this), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0: Seq) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) || (2 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)), bs#0) && $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0), Tclass.JSON_mUtils_mViews_mCore.View()));
axiom 2 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) || (2 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) == #JSON.Utils.Views.Core.View_.View(bs#0, LitInt(0), Seq#Length(bs#0)));
axiom 2 <= $FunctionContextHeight ==> (forall bs#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(bs#0)) || (2 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)) == #JSON.Utils.Views.Core.View_.View(Lit(bs#0), LitInt(0), Seq#Length(Lit(bs#0))));
}

function JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0: Seq) : bool;

function JSON_mUtils_mViews_mCore.View__.OfBytes#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfBytes#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mUtils_mViews_mCore.View__.OfBytes#requires(bs#0) <==> Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()));

procedure {:verboseName "JSON.Utils.Views.Core.View_.OfBytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) returns (v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19835"} Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), bs#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.OfBytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0: Seq) returns (v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.OfBytes", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(27,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0), Tclass.JSON_mUtils_mViews_mCore.View());
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), bs#0);
    assume false;
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Is(#JSON.Utils.Views.Core.View_.View(bs#0, LitInt(0), Seq#Length(bs#0)), Tclass.JSON_mUtils_mViews_mCore.View());
    assume JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) == #JSON.Utils.Views.Core.View_.View(bs#0, LitInt(0), Seq#Length(bs#0));
    assume true;
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0), Tclass.JSON_mUtils_mViews_mCore.View());
    assume JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) == v#0;
    return;
}



function JSON_mUtils_mViews_mCore.View__.OfString(s#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(TChar)) && (forall c#0: char :: { Seq#Contains(s#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(s#0, $Box(c#0)) ==> char#ToInt(c#0) < 256)) ==> $Is(JSON_mUtils_mViews_mCore.View__.OfString(s#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#1: char :: { Seq#Contains(s#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(s#0, $Box(c#1)) ==> char#ToInt(c#1) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#0#i#0): int)): char))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(s#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#2: char :: { Seq#Contains(s#0, $Box(c#2)) } $Is(c#2, TChar) && Seq#Contains(s#0, $Box(c#2)) ==> char#ToInt(c#2) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#2#i#0): int)): char))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))));
}

function JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0: Seq) : bool;

function JSON_mUtils_mViews_mCore.View__.OfString#requires(Seq) : bool;

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#1: char :: { Seq#Contains(s#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(s#0, $Box(c#1)) ==> char#ToInt(c#1) < 256)));

procedure {:verboseName "JSON.Utils.Views.Core.View_.OfString (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.OfString(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.OfString (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.OfString(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: char;
  var $lambdaHeap#0: Heap;
  var i#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.OfString", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(34,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc c#3;
    assume $Is(c#3, TChar);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Seq#Contains(s#0, $Box(c#3));
    assume char#ToInt(c#3) < 256;
    goto anon4;

  anon14_Else:
    assume Seq#Contains(s#0, $Box(c#3)) ==> char#ToInt(c#3) < 256;
    goto anon4;

  anon4:
    assume (forall c#0: char :: { Seq#Contains(s#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(s#0, $Box(c#0)) ==> char#ToInt(c#0) < 256);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfString(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon15_Else:
    assume 0 <= Seq#Length(s#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon10;

  anon18_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon10;

  anon10:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < Seq#Length(s#0);
    assume {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(s#0);
    assume true;
    assume Seq#Contains(s#0, Seq#Index(s#0, i#0));
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(38,24)"} true;
    assume 0 <= i#0 && i#0 < Seq#Length(s#0);
    newtype$check#0 := char#ToInt($Unbox(Seq#Index(s#0, i#0)): char);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt($Unbox(Seq#Index(s#0, i#0)): char);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#0 == char#ToInt($Unbox(Seq#Index(s#0, i#0)): char);
    assume true;
    assume $Is(lambdaResult#0, Tclass.BoundedInts.uint8());
    goto anon12;

  anon19_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < Seq#Length(s#0));
    goto anon12;

  anon17_Else:
    assume {:partition} false;
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon16_Else:
    goto anon13;

  anon13:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(s#0) ==> Requires1(TInt, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#4#i#0): int)): char))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(s#0)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(s#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#4#i#0): int)): char))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(s#0)), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#6#i#0): int)): char))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt) && LitInt(0) <= $Unbox($l#6#i#0): int && $Unbox($l#6#i#0): int < Seq#Length(s#0)), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfString(s#0), TSeq(Tclass.BoundedInts.uint8()));
    assume b$reqreads#0;
    return;
}



function JSON_mUtils_mViews_mCore.View__.SliceOf_q(this: DatatypeType, v'#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.SliceOf_q(this, v'#0) } JSON_mUtils_mViews_mCore.View__.SliceOf_q#canCall(this, v'#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.beg(v'#0) <= JSON_mUtils_mViews_mCore.View__.beg(this) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(v'#0))) && (JSON_mUtils_mViews_mCore.View__.SliceOf_q(this, v'#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) && JSON_mUtils_mViews_mCore.View__.beg(v'#0) <= JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.end(this) <= JSON_mUtils_mViews_mCore.View__.end(v'#0)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.SliceOf_q(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mCore.View__.SliceOf_q#canCall(Lit(this), Lit(v'#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) <= LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)))) && (JSON_mUtils_mViews_mCore.View__.SliceOf_q(Lit(this), Lit(v'#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) && LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) <= LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) && LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this))) <= LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(v'#0)))));
}

function JSON_mUtils_mViews_mCore.View__.SliceOf_q#canCall(this: DatatypeType, v'#0: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.View__.SliceOf_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.SliceOf_q#requires(this, v'#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mCore.View__.SliceOf_q#requires(this, v'#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Core.View_.SliceOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.SliceOf_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), v'#0: DatatypeType where $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(this: DatatypeType, v'#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(this, v'#0) } JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#canCall(this, v'#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.beg(v'#0) == JSON_mUtils_mViews_mCore.View__.beg(this) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(v'#0))) && (JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(this, v'#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) && JSON_mUtils_mViews_mCore.View__.beg(v'#0) == JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.end(this) < JSON_mUtils_mViews_mCore.View__.end(v'#0)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#canCall(Lit(this), Lit(v'#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)))) && (JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(Lit(this), Lit(v'#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) && LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) && JSON_mUtils_mViews_mCore.View__.end(Lit(this)) < JSON_mUtils_mViews_mCore.View__.end(Lit(v'#0))));
}

function JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#canCall(this: DatatypeType, v'#0: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#requires(this, v'#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#requires(this, v'#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Core.View_.StrictPrefixOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), v'#0: DatatypeType where $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(this: DatatypeType, v'#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(this, v'#0) } JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#canCall(this, v'#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.beg(v'#0) < JSON_mUtils_mViews_mCore.View__.beg(this) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(v'#0))) && (JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(this, v'#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) && JSON_mUtils_mViews_mCore.View__.beg(v'#0) < JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.end(this) == JSON_mUtils_mViews_mCore.View__.end(v'#0)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#canCall(Lit(this), Lit(v'#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Lit(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0)) < JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)))) && (JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(Lit(this), Lit(v'#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) && JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0)) < JSON_mUtils_mViews_mCore.View__.beg(Lit(this)) && LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this))) == LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(v'#0)))));
}

function JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#canCall(this: DatatypeType, v'#0: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#requires(this, v'#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#requires(this, v'#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Core.View_.StrictSuffixOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), v'#0: DatatypeType where $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType, c#0: int) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: int :: { JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0) } JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, c#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) && (JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(this), Seq#Build(Seq#Empty(): Seq, $Box(c#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: int :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Byte_q(Lit(this), LitInt(c#0)) } JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(Lit(this), LitInt(c#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(this)) && (JSON_mUtils_mViews_mCore.View__.Byte_q(Lit(this), LitInt(c#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(this)), Seq#Build(Seq#Empty(): Seq, $Box(LitInt(c#0))))));
}

function JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this: DatatypeType, c#0: int) : bool;

function JSON_mUtils_mViews_mCore.View__.Byte_q#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, c#0: int :: { JSON_mUtils_mViews_mCore.View__.Byte_q#requires(this, c#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mUtils_mViews_mCore.View__.Byte_q#requires(this, c#0) <==> JSON_mUtils_mViews_mCore.View__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Views.Core.View_.Byte? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), c#0: int where LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Byte? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType, c#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Byte?", " | ", this, " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(53,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(this), Seq#Build(Seq#Empty(): Seq, $Box(c#0)));
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
    assume $Is(JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0), TBool);
    return;
}



procedure {:verboseName "JSON.Utils.Views.Core.View_.Byte? (correctness)"} Impl$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), c#0: int where LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (defass##result#0: bool, #result#0: bool, $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id19866"} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, c#0);
  free ensures {:id "id19867"} #result#0 <==> JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Byte? (correctness)"} Impl$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType, c#0: int) returns (defass##result#0: bool, #result#0: bool, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##idx#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Byte?", " | ", this, " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(57,16): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Length(this) == LitInt(1);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(this, ##idx#0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, ##idx#0) || JSON_mUtils_mViews_mCore.View__.beg(this) + ##idx#0 < JSON_mUtils_mViews_mCore.View__.end(this);
    assume JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, ##idx#0);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall(this, LitInt(0));
    goto anon2;

  anon4_Else:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Length(this) != LitInt(1);
    goto anon2;

  anon2:
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && (JSON_mUtils_mViews_mCore.View__.Length(this) == LitInt(1) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(this, LitInt(0)));
    #result#0 := JSON_mUtils_mViews_mCore.View__.Length(this) == LitInt(1) && JSON_mUtils_mViews_mCore.View__.At(this, LitInt(0)) == c#0;
    defass##result#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(58,40)"} true;
    assume defass##result#0;
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, c#0);
    return;
}



function JSON_mUtils_mViews_mCore.View__.Char_q(this: DatatypeType, c#0: char) : bool
uses {
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mViews_mCore.View__.Char_q(this, c#0) } JSON_mUtils_mViews_mCore.View__.Char_q#canCall(this, c#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(c#0, TChar) && JSON_mUtils_mViews_mCore.View__.Valid_q(this) && char#ToInt(c#0) < 256) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, char#ToInt(c#0)) && (JSON_mUtils_mViews_mCore.View__.Char_q(this, c#0) <==> JSON_mUtils_mViews_mCore.View__.Byte_q(this, char#ToInt(c#0))));
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: char :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Char_q(Lit(this), Lit(c#0)) } JSON_mUtils_mViews_mCore.View__.Char_q#canCall(Lit(this), Lit(c#0)) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(c#0, TChar) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this)) && char#ToInt(Lit(c#0)) < 256) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(Lit(this), char#ToInt(Lit(c#0))) && (JSON_mUtils_mViews_mCore.View__.Char_q(Lit(this), Lit(c#0)) <==> JSON_mUtils_mViews_mCore.View__.Byte_q(Lit(this), char#ToInt(Lit(c#0)))));
}

function JSON_mUtils_mViews_mCore.View__.Char_q#canCall(this: DatatypeType, c#0: char) : bool;

function JSON_mUtils_mViews_mCore.View__.Char_q#requires(DatatypeType, char) : bool;

axiom (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mViews_mCore.View__.Char_q#requires(this, c#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(c#0, TChar) ==> (JSON_mUtils_mViews_mCore.View__.Char_q#requires(this, c#0) <==> JSON_mUtils_mViews_mCore.View__.Valid_q(this) && char#ToInt(c#0) < 256));

procedure {:verboseName "JSON.Utils.Views.Core.View_.Char? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Char_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), c#0: char where $Is(c#0, TChar));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Char? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Char_q(this: DatatypeType, c#0: char)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##c#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Char?", " | ", this, " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "char"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(61,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume char#ToInt(c#0) < 256;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0 := char#ToInt(c#0);
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, char#ToInt(c#0));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(this, c#0) <==> JSON_mUtils_mViews_mCore.View__.Byte_q(this, char#ToInt(c#0));
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, char#ToInt(c#0));
    assume $Is(JSON_mUtils_mViews_mCore.View__.Char_q(this, c#0), TBool);
    return;
}



function JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this: DatatypeType, idx#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0) } JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(this, idx#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0) <==> JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0 < JSON_mUtils_mViews_mCore.View__.end(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.ValidIndex_q(Lit(this), LitInt(idx#0)) } JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(Lit(this), LitInt(idx#0)) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (JSON_mUtils_mViews_mCore.View__.ValidIndex_q(Lit(this), LitInt(idx#0)) <==> Lit(JSON_mUtils_mViews_mCore.View__.beg(Lit(this)) + idx#0 < JSON_mUtils_mViews_mCore.View__.end(Lit(this)))));
}

function JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(this: DatatypeType, idx#0: int) : bool;

function JSON_mUtils_mViews_mCore.View__.ValidIndex_q#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.ValidIndex_q#requires(this, idx#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mViews_mCore.View__.ValidIndex_q#requires(this, idx#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Core.View_.ValidIndex? (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mCore.View__.At(this: DatatypeType, idx#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.At(this, idx#0) } JSON_mUtils_mViews_mCore.View__.At#canCall(this, idx#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mViews_mCore.View__.Valid_q(this) && JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0)) ==> LitInt(0) <= JSON_mUtils_mViews_mCore.View__.At(this, idx#0) && JSON_mUtils_mViews_mCore.View__.At(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.At(this, idx#0) } JSON_mUtils_mViews_mCore.View__.At#canCall(this, idx#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mViews_mCore.View__.Valid_q(this) && JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0)) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.At(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0)): int);
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.At(Lit(this), LitInt(idx#0)) } JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(this), LitInt(idx#0)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this)) && Lit(JSON_mUtils_mViews_mCore.View__.ValidIndex_q(Lit(this), LitInt(idx#0)))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.At(Lit(this), LitInt(idx#0)) == $Unbox(Seq#Index(Lit(JSON_mUtils_mViews_mCore.View__.s(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this)) + idx#0))): int);
}

function JSON_mUtils_mViews_mCore.View__.At#canCall(this: DatatypeType, idx#0: int) : bool;

function JSON_mUtils_mViews_mCore.View__.At#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.At#requires(this, idx#0) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mViews_mCore.View__.At#requires(this, idx#0) <==> JSON_mUtils_mViews_mCore.View__.Valid_q(this) && JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0)));

procedure {:verboseName "JSON.Utils.Views.Core.View_.At (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.At(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.At (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.At(this: DatatypeType, idx#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##idx#0: int;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.At", " | ", this, " | ", idx#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(72,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##idx#0 := idx#0;
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(this, idx#0);
    assume JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mViews_mCore.View__.At(this, idx#0) && JSON_mUtils_mViews_mCore.View__.At(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0 && JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0 < Seq#Length(JSON_mUtils_mViews_mCore.View__.s(this));
    assume JSON_mUtils_mViews_mCore.View__.At(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0)): int;
    assume JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume $Is(JSON_mUtils_mViews_mCore.View__.At(this, idx#0), Tclass.BoundedInts.uint8());
    return;
}



function JSON_mUtils_mViews_mCore.View__.Peek(this: DatatypeType) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Peek(this) } JSON_mUtils_mViews_mCore.View__.Peek#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> (JSON_mUtils_mViews_mCore.View__.Peek(this) < 0 <==> JSON_mUtils_mViews_mCore.View__.Empty_q(this)) && LitInt(-1) <= JSON_mUtils_mViews_mCore.View__.Peek(this) && JSON_mUtils_mViews_mCore.View__.Peek(this) < BoundedInts.__default.TWO__TO__THE__8());
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Peek(this) } JSON_mUtils_mViews_mCore.View__.Peek#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> (!JSON_mUtils_mViews_mCore.View__.Empty_q(this) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(this, LitInt(0))) && JSON_mUtils_mViews_mCore.View__.Peek(this) == (if JSON_mUtils_mViews_mCore.View__.Empty_q(this) then -1 else JSON_mUtils_mViews_mCore.View__.At(this, LitInt(0))));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Peek(Lit(this)) } JSON_mUtils_mViews_mCore.View__.Peek#canCall(Lit(this)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mViews_mCore.View__.Empty_q(Lit(this)) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(this), LitInt(0))) && JSON_mUtils_mViews_mCore.View__.Peek(Lit(this)) == (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit(this)) then -1 else JSON_mUtils_mViews_mCore.View__.At(Lit(this), LitInt(0))));
}

function JSON_mUtils_mViews_mCore.View__.Peek#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mViews_mCore.View__.Peek#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Peek#requires(this) } $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> (JSON_mUtils_mViews_mCore.View__.Peek#requires(this) <==> JSON_mUtils_mViews_mCore.View__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Views.Core.View_.Peek (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Peek(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap)) returns (r#0: int where LitInt(-1) <= r#0 && r#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19888"} r#0 < 0 <==> JSON_mUtils_mViews_mCore.View__.Empty_q(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Peek (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mCore.View__.Peek(this: DatatypeType) returns (r#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##idx#0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Peek", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(79,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume LitInt(-1) <= JSON_mUtils_mViews_mCore.View__.Peek(this) && JSON_mUtils_mViews_mCore.View__.Peek(this) < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume r#0 < 0 <==> JSON_mUtils_mViews_mCore.View__.Empty_q(this);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Empty_q(this);
    newtype$check#1 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mViews_mCore.View__.Peek(this) == LitInt(-1);
    assume true;
    assume $Is(JSON_mUtils_mViews_mCore.View__.Peek(this), Tclass.BoundedInts.opt__byte());
    goto anon6;

  anon8_Else:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Empty_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(this, ##idx#0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, ##idx#0) || JSON_mUtils_mViews_mCore.View__.beg(this) + ##idx#0 < JSON_mUtils_mViews_mCore.View__.end(this);
    assume JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, ##idx#0);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall(this, LitInt(0));
    newtype$check#3 := JSON_mUtils_mViews_mCore.View__.At(this, LitInt(0));
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := JSON_mUtils_mViews_mCore.View__.At(this, LitInt(0));
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mViews_mCore.View__.Peek(this) == JSON_mUtils_mViews_mCore.View__.At(this, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At#canCall(this, LitInt(0));
    assume $Is(JSON_mUtils_mViews_mCore.View__.Peek(this), Tclass.BoundedInts.opt__byte());
    goto anon6;

  anon6:
    assume JSON_mUtils_mViews_mCore.View__.Peek(this) == r#0;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), start#0: int where LitInt(0) <= start#0 && start#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType, dest#0: ref, start#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.CopyTo", " | ", this, " | ", dest#0, " | ", start#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(87,11): initial state"} true;
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    assume dest#0 != null;
    assume start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    assume start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) < BoundedInts.__default.TWO__TO__THE__32();
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(92,44): post-state"} true;
    assume dest#0 != null;
    assume 0 <= start#0 && start#0 <= _System.array.Length(dest#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    newtype$check#1 := start#0 + JSON_mUtils_mViews_mCore.View__.Length(this);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume start#0 <= start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) && start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), start#0), JSON_mUtils_mViews_mCore.View__.Bytes(this));
    assume dest#0 != null;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    newtype$check#2 := start#0 + JSON_mUtils_mViews_mCore.View__.Length(this);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) && start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
    assume dest#0 != null;
    assume $IsAlloc(dest#0, Tclass._System.array?(Tclass.BoundedInts.uint8()), old($Heap));
    assume $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), old($Heap));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    newtype$check#3 := start#0 + JSON_mUtils_mViews_mCore.View__.Length(this);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) && start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)));
    return;
}



procedure {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (call precondtion)"} CallPre$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), start#0: int where LitInt(0) <= start#0 && start#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id19926"} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
  requires {:id "id19927"} start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
  requires {:id "id19928"} start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) < BoundedInts.__default.TWO__TO__THE__32();



procedure {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (call postcondition)"} CallPost$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), start#0: int where LitInt(0) <= start#0 && start#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
  free ensures {:id "id19929"} Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), start#0), JSON_mUtils_mViews_mCore.View__.Bytes(this));
  free ensures JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
  free ensures {:id "id19930"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (correctness)"} Impl$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), start#0: int where LitInt(0) <= start#0 && start#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id19931"} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
  requires {:id "id19932"} start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
  requires {:id "id19933"} start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) < BoundedInts.__default.TWO__TO__THE__32();
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
  free ensures {:id "id19934"} Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), start#0), JSON_mUtils_mViews_mCore.View__.Bytes(this));
  free ensures JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
  free ensures {:id "id19935"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (correctness)"} Impl$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType, dest#0: ref, start#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var idx#0: int;
  var idx#0#lo: int;
  var newtype$check#4: int;
  var idx#0#hi: int;
  var idx#0#x: int;
  var $PreLoopHeap$loop#0: Heap;
  var $w$loop#0: bool;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#0_0: int;
  var $rhs#0_0: int;
  var newtype$check#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.CopyTo", " | ", this, " | ", dest#0, " | ", start#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(94,4): initial state"} true;
    $_reverifyPost := false;
    newtype$check#4 := LitInt(0);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    idx#0#lo := LitInt(0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    idx#0#hi := JSON_mUtils_mViews_mCore.View__.Length(this);
    assume idx#0#lo <= idx#0#hi;
    havoc idx#0#x;
    assume idx#0#lo <= idx#0#x && idx#0#x <= idx#0#hi;
    assume $Is(idx#0#x, Tclass.BoundedInts.uint32());
    idx#0 := idx#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    havoc $w$loop#0;
    goto anon6_LoopHead;

  anon6_LoopHead:
    assume idx#0#lo <= idx#0 && idx#0 <= idx#0#hi;
    assume $w$loop#0 ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
    assume $w$loop#0 ==> Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, dest#0), start#0 + idx#0), start#0), Seq#Take(JSON_mUtils_mViews_mCore.View__.Bytes(this), idx#0));
    assume $w$loop#0 ==> JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    assume $w$loop#0 ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o] || $o == dest#0);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume true;
    goto anon6_LoopDone, anon6_LoopBody;

  anon6_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(95,6): after some loop iterations"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !$w$loop#0;
    assume dest#0 != null;
    assume {:subsumption 0} 0 <= start#0 && start#0 <= _System.array.Length(dest#0);
    newtype$check#5 := start#0 + idx#0;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    assume {:subsumption 0} start#0 <= start#0 + idx#0 && start#0 + idx#0 <= _System.array.Length(dest#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
    assume {:subsumption 0} 0 <= idx#0 && idx#0 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.Bytes(this));
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this);
    assume Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, dest#0), start#0 + idx#0), start#0), Seq#Take(JSON_mUtils_mViews_mCore.View__.Bytes(this), idx#0));
    assume dest#0 != null;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    newtype$check#6 := start#0 + JSON_mUtils_mViews_mCore.View__.Length(this);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__32();
    assume {:subsumption 0} 0 <= start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) && start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
    assume dest#0 != null;
    assume $IsAlloc(dest#0, Tclass._System.array?(Tclass.BoundedInts.uint8()), old($Heap));
    assume $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), old($Heap));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    newtype$check#7 := start#0 + JSON_mUtils_mViews_mCore.View__.Length(this);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__32();
    assume {:subsumption 0} 0 <= start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) && start#0 + JSON_mUtils_mViews_mCore.View__.Length(this) <= _System.array.Length(dest#0);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(this);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), start#0 + JSON_mUtils_mViews_mCore.View__.Length(this)));
    assume false;
    goto anon3;

  anon7_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} idx#0 == idx#0#hi;
    return;

  anon8_Else:
    assume {:partition} idx#0 != idx#0#hi;
    assume dest#0 != null;
    newtype$check#0_0 := start#0 + idx#0;
    assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= start#0 + idx#0 && start#0 + idx#0 < _System.array.Length(dest#0);
    assume true;
    assume $_ModifiesFrame[dest#0, IndexField(start#0 + idx#0)];
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    assume JSON_mUtils_mViews_mCore.View__.View_q(this);
    newtype$check#0_1 := JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0;
    assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0 && JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0 < Seq#Length(JSON_mUtils_mViews_mCore.View__.s(this));
    assume JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this);
    $rhs#0_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0)): int;
    $Heap := update($Heap, dest#0, IndexField(start#0 + idx#0), $Box($rhs#0_0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(99,41)"} true;
    idx#0 := idx#0 + 1;
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) && (Seq#Equal(Seq#Drop(Seq#Take(Seq#FromArray($Heap, dest#0), start#0 + idx#0), start#0), Seq#Take(JSON_mUtils_mViews_mCore.View__.Bytes(this), idx#0)) ==> JSON_mUtils_mViews_mCore.View__.Length#canCall(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(this));
    goto anon6_LoopHead;

  anon6_LoopDone:
    assume {:partition} false;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Core.View_.Byte? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), c#0: int where LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (#result#0: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Core.View_.Byte? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType, c#0: int) returns (#result#0: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##c#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Byte?", " | ", this, " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(53,14): initial state"} true;
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc #result#0;
    assume {:captureState "libraries/src/JSON/Utils/Views.dfy(57,6): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := c#0;
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(this);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, c#0);
    assume #result#0 <==> JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0);
    return;
}



procedure {:verboseName "JSON.Utils.Views.Core.View_.Byte? (call precondtion)"} CallPre$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), c#0: int where LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
  requires {:id "id19971"} JSON_mUtils_mViews_mCore.View__.Valid_q(this);



procedure {:verboseName "JSON.Utils.Views.Core.View_.Byte? (call postcondition)"} CallPost$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap), c#0: int where LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (#result#0: bool);
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, c#0);
  free ensures {:id "id19972"} #result#0 <==> JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0);
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



const unique tytagFamily$View: TyTagFamily;

const unique tytagFamily$View_: TyTagFamily;

const reveal_JSON.Utils.Views.Writers.Writer_.Append: bool;

const unique class.JSON_mUtils_mViews_mWriters.__default: ClassName;

function #JSON.Utils.Views.Writers.Chain.Empty() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Views.Writers.Chain.Empty()) == ##JSON.Utils.Views.Writers.Chain.Empty;
axiom $Is(#JSON.Utils.Views.Writers.Chain.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Chain());
axiom #JSON.Utils.Views.Writers.Chain.Empty() == Lit(#JSON.Utils.Views.Writers.Chain.Empty());
}

const unique ##JSON.Utils.Views.Writers.Chain.Empty: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Views.Writers.Chain.Empty()) == ##JSON.Utils.Views.Writers.Chain.Empty;
}

function JSON_mUtils_mViews_mWriters.Chain.Empty_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Empty_q(d) } JSON_mUtils_mViews_mWriters.Chain.Empty_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Views.Writers.Chain.Empty);

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Empty_q(d) } JSON_mUtils_mViews_mWriters.Chain.Empty_q(d) ==> d == #JSON.Utils.Views.Writers.Chain.Empty());

function Tclass.JSON_mUtils_mViews_mWriters.Chain() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mViews_mWriters.Chain()) == Tagclass.JSON_mUtils_mViews_mWriters.Chain && TagFamily(Tclass.JSON_mUtils_mViews_mWriters.Chain()) == tytagFamily$Chain;
}

const unique Tagclass.JSON_mUtils_mViews_mWriters.Chain: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mViews_mWriters.Chain()) } $IsBox(bx, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mViews_mWriters.Chain()));

function #JSON.Utils.Views.Writers.Chain.Chain(DatatypeType, DatatypeType) : DatatypeType;

const unique ##JSON.Utils.Views.Writers.Chain.Chain: DtCtorId
uses {
axiom (forall a#26#0#0: DatatypeType, a#26#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#26#0#0, a#26#1#0) } DatatypeCtorId(#JSON.Utils.Views.Writers.Chain.Chain(a#26#0#0, a#26#1#0)) == ##JSON.Utils.Views.Writers.Chain.Chain);
}

function JSON_mUtils_mViews_mWriters.Chain.Chain_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) } JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Views.Writers.Chain.Chain);

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) } JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) ==> (exists a#27#0#0: DatatypeType, a#27#1#0: DatatypeType :: d == #JSON.Utils.Views.Writers.Chain.Chain(a#27#0#0, a#27#1#0)));

axiom (forall a#28#0#0: DatatypeType, a#28#1#0: DatatypeType :: { $Is(#JSON.Utils.Views.Writers.Chain.Chain(a#28#0#0, a#28#1#0), Tclass.JSON_mUtils_mViews_mWriters.Chain()) } $Is(#JSON.Utils.Views.Writers.Chain.Chain(a#28#0#0, a#28#1#0), Tclass.JSON_mUtils_mViews_mWriters.Chain()) <==> $Is(a#28#0#0, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(a#28#1#0, Tclass.JSON_mUtils_mViews_mCore.View()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mWriters.Chain.previous(d), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Chain.previous(d), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mWriters.Chain.v(d), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Chain.v(d), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom (forall a#29#0#0: DatatypeType, a#29#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(Lit(a#29#0#0), Lit(a#29#1#0)) } #JSON.Utils.Views.Writers.Chain.Chain(Lit(a#29#0#0), Lit(a#29#1#0)) == Lit(#JSON.Utils.Views.Writers.Chain.Chain(a#29#0#0, a#29#1#0)));

function JSON_mUtils_mViews_mWriters.Chain.previous(DatatypeType) : DatatypeType;

axiom (forall a#30#0#0: DatatypeType, a#30#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#30#0#0, a#30#1#0) } JSON_mUtils_mViews_mWriters.Chain.previous(#JSON.Utils.Views.Writers.Chain.Chain(a#30#0#0, a#30#1#0)) == a#30#0#0);

axiom (forall a#31#0#0: DatatypeType, a#31#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#31#0#0, a#31#1#0) } DtRank(a#31#0#0) < DtRank(#JSON.Utils.Views.Writers.Chain.Chain(a#31#0#0, a#31#1#0)));

function JSON_mUtils_mViews_mWriters.Chain.v(DatatypeType) : DatatypeType;

axiom (forall a#32#0#0: DatatypeType, a#32#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#32#0#0, a#32#1#0) } JSON_mUtils_mViews_mWriters.Chain.v(#JSON.Utils.Views.Writers.Chain.Chain(a#32#0#0, a#32#1#0)) == a#32#1#0);

axiom (forall a#33#0#0: DatatypeType, a#33#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#33#0#0, a#33#1#0) } DtRank(a#33#1#0) < DtRank(#JSON.Utils.Views.Writers.Chain.Chain(a#33#0#0, a#33#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h));

function $IsA#JSON_mUtils_mViews_mWriters.Chain(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mViews_mWriters.Chain(d) } $IsA#JSON_mUtils_mViews_mWriters.Chain(d) ==> JSON_mUtils_mViews_mWriters.Chain.Empty_q(d) || JSON_mUtils_mViews_mWriters.Chain.Chain_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Chain_q(d), $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Chain()) } { JSON_mUtils_mViews_mWriters.Chain.Empty_q(d), $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Chain()) } $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> JSON_mUtils_mViews_mWriters.Chain.Empty_q(d) || JSON_mUtils_mViews_mWriters.Chain.Chain_q(d));

function JSON_mUtils_mViews_mWriters.Chain#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain#Equal(a, b), JSON_mUtils_mViews_mWriters.Chain.Empty_q(a) } { JSON_mUtils_mViews_mWriters.Chain#Equal(a, b), JSON_mUtils_mViews_mWriters.Chain.Empty_q(b) } JSON_mUtils_mViews_mWriters.Chain.Empty_q(a) && JSON_mUtils_mViews_mWriters.Chain.Empty_q(b) ==> JSON_mUtils_mViews_mWriters.Chain#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain#Equal(a, b), JSON_mUtils_mViews_mWriters.Chain.Chain_q(a) } { JSON_mUtils_mViews_mWriters.Chain#Equal(a, b), JSON_mUtils_mViews_mWriters.Chain.Chain_q(b) } JSON_mUtils_mViews_mWriters.Chain.Chain_q(a) && JSON_mUtils_mViews_mWriters.Chain.Chain_q(b) ==> (JSON_mUtils_mViews_mWriters.Chain#Equal(a, b) <==> JSON_mUtils_mViews_mWriters.Chain#Equal(JSON_mUtils_mViews_mWriters.Chain.previous(a), JSON_mUtils_mViews_mWriters.Chain.previous(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mUtils_mViews_mWriters.Chain.v(a), JSON_mUtils_mViews_mWriters.Chain.v(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain#Equal(a, b) } JSON_mUtils_mViews_mWriters.Chain#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mViews_mWriters.Chain: ClassName;

function JSON_mUtils_mViews_mWriters.Chain.Length($ly: LayerType, this: DatatypeType) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length($ly, this) } JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Chain.Length($ly, this));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> (!JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) ==> JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this)) && JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this))) && JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), this) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) then 0 else JSON_mUtils_mViews_mWriters.Chain.Length($ly, JSON_mUtils_mViews_mWriters.Chain.previous(this)) + JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mWriters.Chain.v(this))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), Lit(this)) } JSON_mUtils_mViews_mWriters.Chain.Length#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> (!Lit(JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Chain.Length#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) && JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))))) && JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), Lit(this)) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this)) then 0 else JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) + JSON_mUtils_mViews_mCore.View__.Length(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))))));
}

function JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this: DatatypeType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), this) == JSON_mUtils_mViews_mWriters.Chain.Length($ly, this));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length(AsFuelBottom($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Length($ly, this) == JSON_mUtils_mViews_mWriters.Chain.Length($LZ, this));

function JSON_mUtils_mViews_mWriters.Chain.Length#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length#requires($ly, this) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (JSON_mUtils_mViews_mWriters.Chain.Length#requires($ly, this) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Chain.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Length(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Chain.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Length(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.Length", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(17,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume LitInt(0) <= JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this);
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Empty_q(this);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this) == LitInt(0);
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this), Tclass._System.nat());
    return;

  anon7_Else:
    assume {:partition} !JSON_mUtils_mViews_mWriters.Chain.Empty_q(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Chain.previous(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume DtRank(JSON_mUtils_mViews_mWriters.Chain.previous(this)) < DtRank(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this));
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Chain.v(this)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.previous(this)) + JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mWriters.Chain.v(this)), Tclass._System.nat());
    assume JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.previous(this)) + JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this)) && JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this), Tclass._System.nat());
    return;
}



function JSON_mUtils_mViews_mWriters.Chain.Count($ly: LayerType, this: DatatypeType) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count($ly, this) } JSON_mUtils_mViews_mWriters.Chain.Count#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Chain.Count($ly, this));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Count#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> (!JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) ==> JSON_mUtils_mViews_mWriters.Chain.Count#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this))) && JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), this) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) then 0 else JSON_mUtils_mViews_mWriters.Chain.Count($ly, JSON_mUtils_mViews_mWriters.Chain.previous(this)) + 1));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), Lit(this)) } JSON_mUtils_mViews_mWriters.Chain.Count#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> (!Lit(JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Chain.Count#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this))))) && JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), Lit(this)) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this)) then 0 else JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) + 1));
}

function JSON_mUtils_mViews_mWriters.Chain.Count#canCall(this: DatatypeType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), this) == JSON_mUtils_mViews_mWriters.Chain.Count($ly, this));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count(AsFuelBottom($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Count($ly, this) == JSON_mUtils_mViews_mWriters.Chain.Count($LZ, this));

function JSON_mUtils_mViews_mWriters.Chain.Count#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count#requires($ly, this) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (JSON_mUtils_mViews_mWriters.Chain.Count#requires($ly, this) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Chain.Count (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Count(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Chain.Count (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Count(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.Count", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(22,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume LitInt(0) <= JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), this);
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Empty_q(this);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), this) == LitInt(0);
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), this), Tclass._System.nat());
    return;

  anon7_Else:
    assume {:partition} !JSON_mUtils_mViews_mWriters.Chain.Empty_q(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Chain.previous(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume DtRank(JSON_mUtils_mViews_mWriters.Chain.previous(this)) < DtRank(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Count#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this));
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.previous(this)) + 1, Tclass._System.nat());
    assume JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), this) == JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.previous(this)) + 1;
    assume JSON_mUtils_mViews_mWriters.Chain.Count#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this));
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Count($LS($LZ), this), Tclass._System.nat());
    return;
}



function JSON_mUtils_mViews_mWriters.Chain.Bytes($ly: LayerType, this: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this) } JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> Seq#Length(JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this)) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this) && $Is(JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> (!JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) ==> JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this)) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this))) && JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), this) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) then Seq#Empty(): Seq else Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, JSON_mUtils_mViews_mWriters.Chain.previous(this)), JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mWriters.Chain.v(this)))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), Lit(this)) } JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain())) ==> (!Lit(JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))))) && JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), Lit(this)) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this)) then Seq#Empty(): Seq else Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))), JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this)))))));
}

function JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this: DatatypeType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), this) == JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes(AsFuelBottom($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this) == JSON_mUtils_mViews_mWriters.Chain.Bytes($LZ, this));

function JSON_mUtils_mViews_mWriters.Chain.Bytes#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes#requires($ly, this) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (JSON_mUtils_mViews_mWriters.Chain.Bytes#requires($ly, this) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Chain.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Bytes(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap)) returns (bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id19997"} Seq#Length(bs#0) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LS($LZ)), this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Chain.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Bytes(this: DatatypeType) returns (bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.Bytes", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this), TSeq(Tclass.BoundedInts.uint8()));
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this);
    assume Seq#Length(bs#0) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Empty_q(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this), TSeq(Tclass.BoundedInts.uint8()));
    goto anon6;

  anon8_Else:
    assume {:partition} !JSON_mUtils_mViews_mWriters.Chain.Empty_q(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Chain.previous(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume DtRank(JSON_mUtils_mViews_mWriters.Chain.previous(this)) < DtRank(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this));
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Chain.v(this)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this) == Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.previous(this)), JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mWriters.Chain.v(this)));
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this)) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this), TSeq(Tclass.BoundedInts.uint8()));
    goto anon6;

  anon6:
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this) == bs#0;
    return;
}



function JSON_mUtils_mViews_mWriters.Chain.Append(this: DatatypeType, v'#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) } JSON_mUtils_mViews_mWriters.Chain.Append#canCall(this, v'#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0))) && $Is(JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Chain()));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) } JSON_mUtils_mViews_mWriters.Chain.Append#canCall(this, v'#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) ==> JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0)) && (JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) && JSON_mUtils_mViews_mCore.__default.Adjacent(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0) ==> JSON_mUtils_mViews_mCore.__default.Merge#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0)) && JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) == (if JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) && JSON_mUtils_mViews_mCore.__default.Adjacent(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0) then #JSON.Utils.Views.Writers.Chain.Chain(JSON_mUtils_mViews_mWriters.Chain.previous(this), JSON_mUtils_mViews_mCore.__default.Merge(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0)) else #JSON.Utils.Views.Writers.Chain.Chain(this, v'#0)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Append(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mWriters.Chain.Append#canCall(Lit(this), Lit(v'#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (Lit(JSON_mUtils_mViews_mWriters.Chain.Chain_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0))) && (Lit(JSON_mUtils_mViews_mWriters.Chain.Chain_q(Lit(this)) && JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0))) ==> JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0))) && JSON_mUtils_mViews_mWriters.Chain.Append(Lit(this), Lit(v'#0)) == (if JSON_mUtils_mViews_mWriters.Chain.Chain_q(Lit(this)) && JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0)) then #JSON.Utils.Views.Writers.Chain.Chain(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this))), Lit(JSON_mUtils_mViews_mCore.__default.Merge(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0)))) else #JSON.Utils.Views.Writers.Chain.Chain(Lit(this), Lit(v'#0))));
}

function JSON_mUtils_mViews_mWriters.Chain.Append#canCall(this: DatatypeType, v'#0: DatatypeType) : bool;

function JSON_mUtils_mViews_mWriters.Chain.Append#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Append#requires(this, v'#0) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mWriters.Chain.Append#requires(this, v'#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Chain.Append (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Append(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap), v'#0: DatatypeType where $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) returns (c#0: DatatypeType where $Is(c#0, Tclass.JSON_mUtils_mViews_mWriters.Chain()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20006"} Seq#Equal(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LS($LZ)), c#0), Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LS($LZ)), this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Chain.Append (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Chain.Append(this: DatatypeType, v'#0: DatatypeType) returns (c#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##lv#0: DatatypeType;
  var ##rv#0: DatatypeType;
  var ##lv#1: DatatypeType;
  var ##rv#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.Append", " | ", this, " | ", v'#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(34,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Chain());
    assume $IsAllocBox($Box(c#0), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(c#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this);
    assume $IsAllocBox($Box(v'#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v'#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), c#0), Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0)));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    ##lv#0 := JSON_mUtils_mViews_mWriters.Chain.v(this);
    assume $IsAlloc(##lv#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    ##rv#0 := v'#0;
    assume $IsAlloc(##rv#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0);
    goto anon5;

  anon10_Else:
    assume {:partition} !JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    goto anon5;

  anon5:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) && JSON_mUtils_mViews_mCore.__default.Adjacent(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0);
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    ##lv#1 := JSON_mUtils_mViews_mWriters.Chain.v(this);
    assume $IsAlloc(##lv#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    ##rv#1 := v'#0;
    assume $IsAlloc(##rv#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(##lv#1, ##rv#1) ==> JSON_mUtils_mViews_mCore.__default.Adjacent(##lv#1, ##rv#1) || JSON_mUtils_mViews_mCore.View__.end(##lv#1) == JSON_mUtils_mViews_mCore.View__.beg(##rv#1);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(##lv#1, ##rv#1) ==> JSON_mUtils_mViews_mCore.__default.Adjacent(##lv#1, ##rv#1) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(##lv#1), JSON_mUtils_mViews_mCore.View__.s(##rv#1));
    assume JSON_mUtils_mViews_mCore.__default.Adjacent(##lv#1, ##rv#1);
    assume JSON_mUtils_mViews_mCore.__default.Merge#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.__default.Merge(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0));
    assume JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) == #JSON.Utils.Views.Writers.Chain.Chain(JSON_mUtils_mViews_mWriters.Chain.previous(this), JSON_mUtils_mViews_mCore.__default.Merge(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0));
    assume JSON_mUtils_mViews_mCore.__default.Merge#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0);
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Chain());
    goto anon8;

  anon11_Else:
    assume {:partition} !(JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) && JSON_mUtils_mViews_mCore.__default.Adjacent(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0));
    assume JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) == #JSON.Utils.Views.Writers.Chain.Chain(this, v'#0);
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Chain());
    goto anon8;

  anon8:
    assume JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) == c#0;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType, dest#0: ref, end#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.CopyTo", " | ", this, " | ", dest#0, " | ", end#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(43,28): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} end#0 == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this);
    assume dest#0 != null;
    goto anon3;

  anon4_Else:
    assume {:partition} end#0 != JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this);
    goto anon3;

  anon3:
    assume end#0 == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this) && JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this) <= _System.array.Length(dest#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(46,26): post-state"} true;
    assume dest#0 != null;
    assume 0 <= end#0 && end#0 <= _System.array.Length(dest#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), end#0), JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this));
    assume dest#0 != null;
    assume 0 <= end#0 && end#0 <= _System.array.Length(dest#0);
    assume dest#0 != null;
    assume $IsAlloc(dest#0, Tclass._System.array?(Tclass.BoundedInts.uint8()), old($Heap));
    assume 0 <= end#0 && end#0 <= _System.array.Length(dest#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), end#0), Seq#Drop(Seq#FromArray(old($Heap), dest#0), end#0));
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (call precondtion)"} CallPre$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id20028"} end#0 == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LS($LZ)), this);
  requires {:id "id20029"} JSON_mUtils_mViews_mWriters.Chain.Length($LS($LS($LZ)), this) <= _System.array.Length(dest#0);



procedure {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (call postcondition)"} CallPost$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this);
  free ensures {:id "id20030"} Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), end#0), JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LS($LZ)), this));
  free ensures true;
  free ensures {:id "id20031"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), end#0), Seq#Drop(Seq#FromArray(old($Heap), dest#0), end#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (correctness)"} Impl$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id20032"} end#0 == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LS($LZ)), this);
  requires {:id "id20033"} JSON_mUtils_mViews_mWriters.Chain.Length($LS($LS($LZ)), this) <= _System.array.Length(dest#0);
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this);
  free ensures {:id "id20034"} Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), end#0), JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LS($LZ)), this));
  free ensures true;
  free ensures {:id "id20035"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), end#0), Seq#Drop(Seq#FromArray(old($Heap), dest#0), end#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (correctness)"} Impl$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType, dest#0: ref, end#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var end#0_0: int where LitInt(0) <= end#0_0 && end#0_0 < BoundedInts.__default.TWO__TO__THE__32();
  var newtype$check#0_0: int;
  var dest##0_0: ref;
  var start##0_0: int;
  var dest##0_1: ref;
  var end##0_0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.CopyTo", " | ", this, " | ", dest#0, " | ", end#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(48,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume true;
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Chain.v(this)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this));
    newtype$check#0_0 := end#0 - JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this));
    end#0_0 := end#0 - JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mWriters.Chain.v(this));
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(50,35)"} true;
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume true;
    assume true;
    dest##0_0 := dest#0;
    assume true;
    start##0_0 := end#0_0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == dest##0_0 ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mViews_mCore.View__.CopyTo(JSON_mUtils_mViews_mWriters.Chain.v(this), dest##0_0, start##0_0);
    call CallPost$$JSON_mUtils_mViews_mCore.View__.CopyTo(JSON_mUtils_mViews_mWriters.Chain.v(this), dest##0_0, start##0_0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(51,27)"} true;
    assume JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    assume true;
    assume true;
    dest##0_1 := dest#0;
    assume true;
    end##0_0 := end#0_0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == dest##0_1 ==> $_ModifiesFrame[$o, $f]);
    assume 0 <= end#0 || DtRank(JSON_mUtils_mViews_mWriters.Chain.previous(this)) < DtRank(this) || (dest##0_1 == null && dest#0 != null) || end##0_0 == end#0;
    assume DtRank(JSON_mUtils_mViews_mWriters.Chain.previous(this)) < DtRank(this) || (DtRank(JSON_mUtils_mViews_mWriters.Chain.previous(this)) == DtRank(this) && ((dest##0_1 == null && dest#0 != null) || ((dest##0_1 != null <==> dest#0 != null) && end##0_0 < end#0)));
    call CallPre$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(JSON_mUtils_mViews_mWriters.Chain.previous(this), dest##0_1, end##0_0);
    call CallPost$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(JSON_mUtils_mViews_mWriters.Chain.previous(this), dest##0_1, end##0_0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(52,34)"} true;
    return;

  anon3_Else:
    assume {:partition} !JSON_mUtils_mViews_mWriters.Chain.Chain_q(this);
    return;
}



function Tclass.JSON_mUtils_mViews_mWriters.Writer__() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mViews_mWriters.Writer__()) == Tagclass.JSON_mUtils_mViews_mWriters.Writer__ && TagFamily(Tclass.JSON_mUtils_mViews_mWriters.Writer__()) == tytagFamily$Writer_;
}

const unique Tagclass.JSON_mUtils_mViews_mWriters.Writer__: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) } $IsBox(bx, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mViews_mWriters.Writer__()));

procedure {:verboseName "JSON.Utils.Views.Writers.Writer (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer(w#0: DatatypeType where $Is(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this): bool } JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this): bool <==> JSON_mUtils_mViews_mWriters.Writer__.length(this) == (if JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)) >= BoundedInts.__default.TWO__TO__THE__32() then BoundedInts.__default.UINT32__MAX() else JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this))));
axiom 1 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o), TBool));
axiom 1 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o), TBool, $h));
}

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer(w#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer", " | ", w#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(57,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(w#0);
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(Lit(#JSON.Utils.Views.Writers.Writer_.Writer(LitInt(0), Lit(#JSON.Utils.Views.Writers.Chain.Empty()))));
    return;
}



function Tclass.JSON_mUtils_mViews_mWriters.Writer() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mViews_mWriters.Writer()) == Tagclass.JSON_mUtils_mViews_mWriters.Writer && TagFamily(Tclass.JSON_mUtils_mViews_mWriters.Writer()) == tytagFamily$Writer;
}

const unique Tagclass.JSON_mUtils_mViews_mWriters.Writer: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mViews_mWriters.Writer()) } $IsBox(bx, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall w#0: DatatypeType :: { $Is(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) } $Is(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) <==> $Is(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(w#0));

axiom (forall w#0: DatatypeType, $h: Heap :: { $IsAlloc(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h) } $IsAlloc(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h) <==> $IsAlloc(w#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h));

function #JSON.Utils.Views.Writers.Writer_.Writer(int, DatatypeType) : DatatypeType;

const unique ##JSON.Utils.Views.Writers.Writer_.Writer: DtCtorId
uses {
axiom (forall a#0#0#0: int, a#0#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Writer_.Writer(a#0#0#0, a#0#1#0) } DatatypeCtorId(#JSON.Utils.Views.Writers.Writer_.Writer(a#0#0#0, a#0#1#0)) == ##JSON.Utils.Views.Writers.Writer_.Writer);
}

function JSON_mUtils_mViews_mWriters.Writer__.Writer_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d) } JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Views.Writers.Writer_.Writer);

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d) } JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d) ==> (exists a#1#0#0: int, a#1#1#0: DatatypeType :: d == #JSON.Utils.Views.Writers.Writer_.Writer(a#1#0#0, a#1#1#0)));

axiom (forall a#2#0#0: int, a#2#1#0: DatatypeType :: { $Is(#JSON.Utils.Views.Writers.Writer_.Writer(a#2#0#0, a#2#1#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__()) } $Is(#JSON.Utils.Views.Writers.Writer_.Writer(a#2#0#0, a#2#1#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__()) <==> $Is(a#2#0#0, Tclass.BoundedInts.uint32()) && $Is(a#2#1#0, Tclass.JSON_mUtils_mViews_mWriters.Chain()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.length(d), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.length(d), Tclass.BoundedInts.uint32(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.chain(d), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h) } $IsGoodHeap($h) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.chain(d), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $h));

axiom (forall a#3#0#0: int, a#3#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Writer_.Writer(LitInt(a#3#0#0), Lit(a#3#1#0)) } #JSON.Utils.Views.Writers.Writer_.Writer(LitInt(a#3#0#0), Lit(a#3#1#0)) == Lit(#JSON.Utils.Views.Writers.Writer_.Writer(a#3#0#0, a#3#1#0)));

function JSON_mUtils_mViews_mWriters.Writer__.length(DatatypeType) : int;

axiom (forall a#4#0#0: int, a#4#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Writer_.Writer(a#4#0#0, a#4#1#0) } JSON_mUtils_mViews_mWriters.Writer__.length(#JSON.Utils.Views.Writers.Writer_.Writer(a#4#0#0, a#4#1#0)) == a#4#0#0);

function JSON_mUtils_mViews_mWriters.Writer__.chain(DatatypeType) : DatatypeType;

axiom (forall a#5#0#0: int, a#5#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Writer_.Writer(a#5#0#0, a#5#1#0) } JSON_mUtils_mViews_mWriters.Writer__.chain(#JSON.Utils.Views.Writers.Writer_.Writer(a#5#0#0, a#5#1#0)) == a#5#1#0);

axiom (forall a#6#0#0: int, a#6#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Writer_.Writer(a#6#0#0, a#6#1#0) } DtRank(a#6#1#0) < DtRank(#JSON.Utils.Views.Writers.Writer_.Writer(a#6#0#0, a#6#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h));

function $IsA#JSON_mUtils_mViews_mWriters.Writer__(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mViews_mWriters.Writer__(d) } $IsA#JSON_mUtils_mViews_mWriters.Writer__(d) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d), $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) } $Is(d, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(d));

function JSON_mUtils_mViews_mWriters.Writer__#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__#Equal(a, b) } JSON_mUtils_mViews_mWriters.Writer__#Equal(a, b) <==> JSON_mUtils_mViews_mWriters.Writer__.length(a) == JSON_mUtils_mViews_mWriters.Writer__.length(b) && JSON_mUtils_mViews_mWriters.Chain#Equal(JSON_mUtils_mViews_mWriters.Writer__.chain(a), JSON_mUtils_mViews_mWriters.Writer__.chain(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__#Equal(a, b) } JSON_mUtils_mViews_mWriters.Writer__#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mViews_mWriters.Writer__: ClassName;

function JSON_mUtils_mViews_mWriters.Writer__.Empty() : DatatypeType
uses {
axiom JSON_mUtils_mViews_mWriters.Writer__.Empty(): DatatypeType == Lit(#JSON.Utils.Views.Writers.Writer_.Writer(LitInt(0), Lit(#JSON.Utils.Views.Writers.Chain.Empty())));
axiom 3 < $FunctionContextHeight ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Writer());
}

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Empty (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.Empty();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.Empty (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.Empty()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.Empty"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(60,17): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume $Is(Lit(#JSON.Utils.Views.Writers.Writer_.Writer(LitInt(0), Lit(#JSON.Utils.Views.Writers.Chain.Empty()))), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    return;
}



axiom 3 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h));

function JSON_mUtils_mViews_mWriters.Writer__.Empty_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Empty_q(this): bool } JSON_mUtils_mViews_mWriters.Writer__.Empty_q(this): bool <==> JSON_mUtils_mViews_mWriters.Chain.Empty_q(JSON_mUtils_mViews_mWriters.Writer__.chain(this)));
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o), TBool, $h));
}

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Empty? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.Empty_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this): bool } JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this): bool <==> JSON_mUtils_mViews_mWriters.Writer__.length(this) != BoundedInts.__default.UINT32__MAX());
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o), TBool, $h));
}

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Unsaturated? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mViews_mWriters.Writer__.Length(this: DatatypeType) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Length(this) } JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__())) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Writer__.Length(this));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Length(this) } JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__())) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this)) && JSON_mUtils_mViews_mWriters.Writer__.Length(this) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.Length(Lit(this)) } JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__())) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mWriters.Chain.Length#canCall(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this)))) && JSON_mUtils_mViews_mWriters.Writer__.Length(Lit(this)) == LitInt(JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))))));
}

function JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mViews_mWriters.Writer__.Length#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Length#requires(this) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> (JSON_mUtils_mViews_mWriters.Writer__.Length#requires(this) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Length(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Valid? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.Valid? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.Valid?", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(67,16): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.chain(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)) >= BoundedInts.__default.TWO__TO__THE__32();
    goto anon3;

  anon4_Else:
    assume {:partition} BoundedInts.__default.TWO__TO__THE__32() > JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.chain(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    newtype$check#0 := JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon3;

  anon3:
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this)) && (BoundedInts.__default.TWO__TO__THE__32() > JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this)));
    return;
}



function JSON_mUtils_mViews_mWriters.Writer__.Bytes(this: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) } JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__())) ==> Seq#Length(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this)) == JSON_mUtils_mViews_mWriters.Writer__.Length(this) && $Is(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) } JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__())) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this)) && JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) == JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.Bytes(Lit(this)) } JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(Lit(this)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__())) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this)))) && JSON_mUtils_mViews_mWriters.Writer__.Bytes(Lit(this)) == Lit(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))))));
}

function JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mViews_mWriters.Writer__.Bytes#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Bytes#requires(this) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> (JSON_mUtils_mViews_mWriters.Writer__.Bytes#requires(this) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Bytes(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap)) returns (bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20058"} Seq#Length(bs#0) == JSON_mUtils_mViews_mWriters.Writer__.Length(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Bytes(this: DatatypeType) returns (bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.Bytes", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(72,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), TSeq(Tclass.BoundedInts.uint8()));
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this);
    assume Seq#Length(bs#0) == JSON_mUtils_mViews_mWriters.Writer__.Length(this);
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.chain(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) == JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this));
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), TSeq(Tclass.BoundedInts.uint8()));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) == bs#0;
    return;
}



function JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0: int, b#0: int) : int
uses {
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) } JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(a#0, b#0) || (0 < $FunctionContextHeight && LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) < BoundedInts.__default.TWO__TO__THE__32());
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) } JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(a#0, b#0) || (0 < $FunctionContextHeight && LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) == (if a#0 <= BoundedInts.__default.UINT32__MAX() - b#0 then a#0 + b#0 else BoundedInts.__default.UINT32__MAX()));
axiom 0 <= $FunctionContextHeight ==> (forall a#0: int, b#0: int :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(LitInt(a#0), LitInt(b#0)) } JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(LitInt(a#0), LitInt(b#0)) || (0 < $FunctionContextHeight && LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(LitInt(a#0), LitInt(b#0)) == (if LitInt(a#0) <= BoundedInts.__default.UINT32__MAX() - b#0 then a#0 + b#0 else BoundedInts.__default.UINT32__MAX()));
}

function JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(a#0: int, b#0: int) : bool;

function JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#requires(int, int) : bool;

axiom (forall a#0: int, b#0: int :: { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#requires(a#0, b#0) } LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#requires(a#0, b#0) <==> true));

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.SaturatedAddU32 (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0: int where LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32(), b#0: int where LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.SaturatedAddU32 (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0: int, b#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.SaturatedAddU32", " | ", a#0, " | ", b#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(78,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume LitInt(0) <= JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := BoundedInts.__default.UINT32__MAX() - b#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} a#0 <= BoundedInts.__default.UINT32__MAX() - b#0;
    newtype$check#1 := a#0 + b#0;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) == a#0 + b#0;
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0), Tclass.BoundedInts.uint32());
    return;

  anon7_Else:
    assume {:partition} BoundedInts.__default.UINT32__MAX() - b#0 < a#0;
    assume JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) == BoundedInts.__default.UINT32__MAX();
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0), Tclass.BoundedInts.uint32());
    return;
}



function JSON_mUtils_mViews_mWriters.Writer__.Append($reveal: bool, this: DatatypeType, v'#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0) } JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(this, v'#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this)) ==> (JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0)) <==> JSON_mUtils_mViews_mCore.View__.Length(v'#0) < BoundedInts.__default.UINT32__MAX() - JSON_mUtils_mViews_mWriters.Writer__.length(this)) && Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0))) && $Is(JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Append(true, this, v'#0) } JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(this, v'#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this)) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(v'#0) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0) && JSON_mUtils_mViews_mWriters.Writer__.Append(true, this, v'#0) == #JSON.Utils.Views.Writers.Writer_.Writer(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)), JSON_mUtils_mViews_mWriters.Chain.Append(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.Append(true, Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(this), Lit(v'#0)) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(LitInt(JSON_mUtils_mViews_mWriters.Writer__.length(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.Length(Lit(v'#0)))) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mWriters.Chain.Append#canCall(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))), Lit(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append(true, Lit(this), Lit(v'#0)) == Lit(#JSON.Utils.Views.Writers.Writer_.Writer(LitInt(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(LitInt(JSON_mUtils_mViews_mWriters.Writer__.length(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.Length(Lit(v'#0))))), Lit(JSON_mUtils_mViews_mWriters.Chain.Append(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))), Lit(v'#0))))));
}

function JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(this: DatatypeType, v'#0: DatatypeType) : bool;

function JSON_mUtils_mViews_mWriters.Writer__.Append#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Append#requires(this, v'#0) } $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mViews_mWriters.Writer__.Append#requires(this, v'#0) <==> JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Append (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Append(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap), v'#0: DatatypeType where $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) returns (rw#0: DatatypeType where $Is(rw#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20066"} JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(rw#0) <==> JSON_mUtils_mViews_mCore.View__.Length(v'#0) < BoundedInts.__default.UINT32__MAX() - JSON_mUtils_mViews_mWriters.Writer__.length(this);
  free ensures {:id "id20067"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(rw#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.Append (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Append(this: DatatypeType, v'#0: DatatypeType) returns (rw#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##a#0: int;
  var ##b#0: int;
  var ##v'#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.Append", " | ", this, " | ", v'#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(83,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(v'#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(v'#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    newtype$check#0 := BoundedInts.__default.UINT32__MAX() - JSON_mUtils_mViews_mWriters.Writer__.length(this);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(rw#0) <==> JSON_mUtils_mViews_mCore.View__.Length(v'#0) < BoundedInts.__default.UINT32__MAX() - JSON_mUtils_mViews_mWriters.Writer__.length(this);
    assume $IsAllocBox($Box(rw#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(rw#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
    assume $IsAllocBox($Box(v'#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v'#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(rw#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0)));
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume $IsAllocBox($Box(v'#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v'#0);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(v'#0);
    ##a#0 := JSON_mUtils_mViews_mWriters.Writer__.length(this);
    assume $IsAlloc(##a#0, Tclass.BoundedInts.uint32(), $Heap);
    ##b#0 := JSON_mUtils_mViews_mCore.View__.Length(v'#0);
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint32(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.chain(this)), Tclass.JSON_mUtils_mViews_mWriters.Chain(), $Heap);
    ##v'#0 := v'#0;
    assume $IsAlloc(##v'#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Chain.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0);
    assume $Is(#JSON.Utils.Views.Writers.Writer_.Writer(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)), JSON_mUtils_mViews_mWriters.Chain.Append(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0)), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, this, v'#0) == #JSON.Utils.Views.Writers.Writer_.Writer(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)), JSON_mUtils_mViews_mWriters.Chain.Append(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(v'#0) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0);
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, this, v'#0) == rw#0;
    return;
}



function JSON_mUtils_mViews_mWriters.Writer__.Then($heap: Heap, this: DatatypeType, fn#0: HandleType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType, fn#0: HandleType :: { JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0) } JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, this, fn#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap) && $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $IsAlloc(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this) && Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType, fn#0: HandleType :: { JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, this, fn#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap) && $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this) && Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))) ==> JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))): DatatypeType);
}

function JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($heap: Heap, this: DatatypeType, fn#0: HandleType) : bool;

axiom (forall $h0: Heap, $h1: Heap, this: DatatypeType, fn#0: HandleType :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JSON_mUtils_mViews_mWriters.Writer__.Then($h1, this, fn#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && (JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($h0, this, fn#0) || $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()))) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && Reads1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h0, fn#0, $Box(this))[$Box($o)] ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> JSON_mUtils_mViews_mWriters.Writer__.Then($h0, this, fn#0) == JSON_mUtils_mViews_mWriters.Writer__.Then($h1, this, fn#0));

function JSON_mUtils_mViews_mWriters.Writer__.Then#requires(Heap, DatatypeType, HandleType) : bool;

axiom (forall $Heap: Heap, this: DatatypeType, fn#0: HandleType :: { JSON_mUtils_mViews_mWriters.Writer__.Then#requires($Heap, this, fn#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap) && $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (JSON_mUtils_mViews_mWriters.Writer__.Then#requires($Heap, this, fn#0) <==> JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this) && Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))));

procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.Then (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Then(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap), fn#0: HandleType where $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.Then (well-formedness)"} CheckWellformed$$JSON_mUtils_mViews_mWriters.Writer__.Then(this: DatatypeType, fn#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##x0#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##x0#1: DatatypeType;
  var b$reqreads#1: bool;
  var ##x0#2: DatatypeType;
  var b$reqreads#2: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.Then", " | ", this, " | ", fn#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "HandleType"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(92,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> Reads1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))[$Box($o)]);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
    assume $IsAllocBox($Box(fn#0), Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    ##x0#0 := this;
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(##x0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    assume Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    assume b$reqreads#0;
    assume $IsAllocBox($Box(fn#0), Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    ##x0#1 := this;
    assume $IsAlloc(##x0#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Reads1#canCall(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    assume b$reqreads#1;
    assume $IsAllocBox($Box(fn#0), Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    ##x0#2 := this;
    assume $IsAlloc(##x0#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    assume Reads1#canCall(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume false;
    return;

  anon4_Else:
    assume $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this));
    b$reqreads#2 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))): DatatypeType;
    assume true;
    assume $Is(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume b$reqreads#2;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType, dest#0: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.CopyTo", " | ", this, " | ", dest#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(100,28): initial state"} true;
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
    assume JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this);
    assume dest#0 != null;
    assume JSON_mUtils_mViews_mWriters.Writer__.Length(this) <= _System.array.Length(dest#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(105,29): post-state"} true;
    assume dest#0 != null;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume 0 <= JSON_mUtils_mViews_mWriters.Writer__.length(this) && JSON_mUtils_mViews_mWriters.Writer__.length(this) <= _System.array.Length(dest#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)), JSON_mUtils_mViews_mWriters.Writer__.Bytes(this));
    assume dest#0 != null;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume 0 <= JSON_mUtils_mViews_mWriters.Writer__.length(this) && JSON_mUtils_mViews_mWriters.Writer__.length(this) <= _System.array.Length(dest#0);
    assume dest#0 != null;
    assume $IsAlloc(dest#0, Tclass._System.array?(Tclass.BoundedInts.uint8()), old($Heap));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), old($Heap));
    assume 0 <= JSON_mUtils_mViews_mWriters.Writer__.length(this) && JSON_mUtils_mViews_mWriters.Writer__.length(this) <= _System.array.Length(dest#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)));
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (call precondtion)"} CallPre$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));
  requires {:id "id20105"} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
  requires {:id "id20106"} JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this);
  requires {:id "id20107"} JSON_mUtils_mViews_mWriters.Writer__.Length(this) <= _System.array.Length(dest#0);



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (call postcondition)"} CallPost$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
  free ensures {:id "id20108"} Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)), JSON_mUtils_mViews_mWriters.Writer__.Bytes(this));
  free ensures JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
  free ensures {:id "id20109"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (correctness)"} Impl$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id20110"} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
  requires {:id "id20111"} JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this);
  requires {:id "id20112"} JSON_mUtils_mViews_mWriters.Writer__.Length(this) <= _System.array.Length(dest#0);
  modifies $Heap;
  free ensures JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
  free ensures {:id "id20113"} Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)), JSON_mUtils_mViews_mWriters.Writer__.Bytes(this));
  free ensures JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
  free ensures {:id "id20114"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)), Seq#Drop(Seq#FromArray(old($Heap), dest#0), JSON_mUtils_mViews_mWriters.Writer__.length(this)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (correctness)"} Impl$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType, dest#0: ref) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var dest##0: ref;
  var end##0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.CopyTo", " | ", this, " | ", dest#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(107,4): initial state"} true;
    $_reverifyPost := false;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume true;
    dest##0 := dest#0;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    end##0 := JSON_mUtils_mViews_mWriters.Writer__.length(this);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == dest##0 ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(JSON_mUtils_mViews_mWriters.Writer__.chain(this), dest##0, end##0);
    call CallPost$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(JSON_mUtils_mViews_mWriters.Writer__.chain(this), dest##0, end##0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(108,32)"} true;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap)) returns (bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (well-formedness)"} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType) returns (bs#0: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.ToArray", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(111,11): initial state"} true;
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
    assume JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc bs#0;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(114,14): post-state"} true;
    assume bs#0 != null && !$Unbox(read(old($Heap), bs#0, alloc)): bool;
    assume bs#0 != null;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
    assume Seq#Equal(Seq#FromArray($Heap, bs#0), JSON_mUtils_mViews_mWriters.Writer__.Bytes(this));
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (call precondtion)"} CallPre$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap));
  requires {:id "id20123"} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
  requires {:id "id20124"} JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this);



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (call postcondition)"} CallPost$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap)) returns (bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id20125"} bs#0 != null && !$Unbox(read(old($Heap), bs#0, alloc)): bool;
  free ensures JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
  free ensures {:id "id20126"} Seq#Equal(Seq#FromArray($Heap, bs#0), JSON_mUtils_mViews_mWriters.Writer__.Bytes(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (correctness)"} Impl$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap)) returns (defass#bs#0: bool, bs#0: ref where defass#bs#0 ==> $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap), $_reverifyPost: bool);
  free requires 4 == $FunctionContextHeight;
  requires {:id "id20127"} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this);
  requires {:id "id20128"} JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(this);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id20129"} bs#0 != null && !$Unbox(read(old($Heap), bs#0, alloc)): bool;
  free ensures JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this);
  free ensures {:id "id20130"} Seq#Equal(Seq#FromArray($Heap, bs#0), JSON_mUtils_mViews_mWriters.Writer__.Bytes(this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (correctness)"} Impl$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType) returns (defass#bs#0: bool, bs#0: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $nw: ref;
  var dest##0: ref;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.ToArray", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(116,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this);
    assume 0 <= JSON_mUtils_mViews_mWriters.Writer__.length(this);
    assume 0 == JSON_mUtils_mViews_mWriters.Writer__.length(this);
    havoc $nw;
    assume $nw != null && $Is($nw, Tclass._System.array?(Tclass.BoundedInts.uint8()));
    assume !$Unbox(read($Heap, $nw, alloc)): bool;
    assume _System.array.Length($nw) == JSON_mUtils_mViews_mWriters.Writer__.length(this);
    $Heap := update($Heap, $nw, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    bs#0 := $nw;
    defass#bs#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(117,28)"} true;
    assume true;
    assume defass#bs#0;
    assume true;
    dest##0 := bs#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == dest##0 ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this, dest##0);
    call CallPost$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this, dest##0);
    assume {:captureState "libraries/src/JSON/Utils/Views.Writers.dfy(118,16)"} true;
    assume defass#bs#0;
    return;
}



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.reveal_Append (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mUtils_mViews_mWriters.Writer__.reveal__Append();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.reveal_Append (call precondtion)"} {:verify false} CallPre$$JSON_mUtils_mViews_mWriters.Writer__.reveal__Append();



procedure {:verboseName "JSON.Utils.Views.Writers.Writer_.reveal_Append (call postcondition)"} {:verify false} CallPost$$JSON_mUtils_mViews_mWriters.Writer__.reveal__Append();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.Utils.Views.Writers.Writer_.Append;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#136 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#136))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#138 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#138)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#204 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#204))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#206 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#206)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#208 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#208)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#204 := Wrappers.Option.value(this); v#204)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#206 := Lit(Wrappers.Option.value(Lit(this))); v#206)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#208 := Lit(Wrappers.Option.value(Lit(this))); v#208)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#136 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#136)) else (var e#136 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#138 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#138))) else (var e#138 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#204 := Wrappers.Result.value(this); s#204) else (var e#204 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#206 := Lit(Wrappers.Result.value(Lit(this))); s#206) else (var e#206 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#208 := Lit(Wrappers.Result.value(Lit(this))); s#208) else (var e#208 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#204 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#204)) else (var e#204 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#204)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#206 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#206))) else (var e#206 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#206)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#208 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#208))) else (var e#208 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#208)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(lv#0) && JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && (JSON_mUtils_mViews_mCore.View__.end(lv#0) == JSON_mUtils_mViews_mCore.View__.beg(rv#0) ==> JSON_mUtils_mViews_mCore.View__.View_q(lv#0) && JSON_mUtils_mViews_mCore.View__.View_q(rv#0)) && (JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0) <==> JSON_mUtils_mViews_mCore.View__.end(lv#0) == JSON_mUtils_mViews_mCore.View__.beg(rv#0) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(lv#0), JSON_mUtils_mViews_mCore.View__.s(rv#0))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(lv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && (LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(lv#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(rv#0))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(lv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0))) && (JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)) <==> LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(lv#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(rv#0))) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(lv#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(rv#0)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0)), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(lv#0), JSON_mUtils_mViews_mCore.View__.Bytes(rv#0))) && $Is(JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0), Tclass.JSON_mUtils_mViews_mCore.View()));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#2 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#2) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#2)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#2 := lv#0; (var dt_update#end#0#2 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#2), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#2), dt_update#end#0#2))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#3 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#3) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#3)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#3 := Lit(lv#0); (var dt_update#end#0#3 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#3)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#3)), dt_update#end#0#3)))));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Valid_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> $Is(JSON_mUtils_mViews_mCore.View__.Valid_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Valid_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.Valid_q($o), TBool, $h));

axiom $Is(JSON_mUtils_mViews_mCore.View__.Empty(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mCore.View__.Empty(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.Empty(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Empty_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) ==> $Is(JSON_mUtils_mViews_mCore.View__.Empty_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Empty_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mCore.View__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mCore.View__.Empty_q($o), TBool, $h));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Length(this) } JSON_mUtils_mViews_mCore.View__.Length#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mViews_mCore.View__.Length(this) && JSON_mUtils_mViews_mCore.View__.Length(this) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Length(this) } JSON_mUtils_mViews_mCore.View__.Length#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.Length(this) == JSON_mUtils_mViews_mCore.View__.end(this) - JSON_mUtils_mViews_mCore.View__.beg(this));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Length(Lit(this)) } JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.Length(Lit(this)) == LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this)) - JSON_mUtils_mViews_mCore.View__.beg(Lit(this))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Bytes(this) } JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> $Is(JSON_mUtils_mViews_mCore.View__.Bytes(this), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Bytes(this) } JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.Bytes(this) == Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.end(this)), JSON_mUtils_mViews_mCore.View__.beg(this)));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Bytes(Lit(this)) } JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.Bytes(Lit(this)) == Lit(Seq#Drop(Seq#Take(Lit(JSON_mUtils_mViews_mCore.View__.s(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this)))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))))));

axiom (forall bs#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) || ($Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)), bs#0) && $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0), Tclass.JSON_mUtils_mViews_mCore.View()));

axiom (forall bs#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) || ($Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0) == #JSON.Utils.Views.Core.View_.View(bs#0, LitInt(0), Seq#Length(bs#0)));

axiom (forall bs#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(bs#0)) || ($Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)) == #JSON.Utils.Views.Core.View_.View(Lit(bs#0), LitInt(0), Seq#Length(Lit(bs#0))));

axiom (forall s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && (forall c#0: char :: { Seq#Contains(s#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(s#0, $Box(c#0)) ==> char#ToInt(c#0) < 256)) ==> $Is(JSON_mUtils_mViews_mCore.View__.OfString(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#4: char :: { Seq#Contains(s#0, $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(s#0, $Box(c#4)) ==> char#ToInt(c#4) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#4: char :: { Seq#Contains(s#0, $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(s#0, $Box(c#4)) ==> char#ToInt(c#4) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#8#i#0): int)): char))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(s#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#5: char :: { Seq#Contains(s#0, $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(s#0, $Box(c#5)) ==> char#ToInt(c#5) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#10#i#0): int)): char))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $IsBox($l#10#i#0, TInt) && LitInt(0) <= $Unbox($l#10#i#0): int && $Unbox($l#10#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.SliceOf_q(this, v'#0) } JSON_mUtils_mViews_mCore.View__.SliceOf_q#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.beg(v'#0) <= JSON_mUtils_mViews_mCore.View__.beg(this) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(v'#0))) && (JSON_mUtils_mViews_mCore.View__.SliceOf_q(this, v'#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) && JSON_mUtils_mViews_mCore.View__.beg(v'#0) <= JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.end(this) <= JSON_mUtils_mViews_mCore.View__.end(v'#0)));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.SliceOf_q(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mCore.View__.SliceOf_q#canCall(Lit(this), Lit(v'#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) <= LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)))) && (JSON_mUtils_mViews_mCore.View__.SliceOf_q(Lit(this), Lit(v'#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) && LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) <= LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) && LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this))) <= LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(v'#0)))));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(this, v'#0) } JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.beg(v'#0) == JSON_mUtils_mViews_mCore.View__.beg(this) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(v'#0))) && (JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(this, v'#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) && JSON_mUtils_mViews_mCore.View__.beg(v'#0) == JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.end(this) < JSON_mUtils_mViews_mCore.View__.end(v'#0)));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q#canCall(Lit(this), Lit(v'#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)))) && (JSON_mUtils_mViews_mCore.View__.StrictPrefixOf_q(Lit(this), Lit(v'#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) && LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0))) == LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) && JSON_mUtils_mViews_mCore.View__.end(Lit(this)) < JSON_mUtils_mViews_mCore.View__.end(Lit(v'#0))));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(this, v'#0) } JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) ==> JSON_mUtils_mViews_mCore.View__.View_q(v'#0) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.beg(v'#0) < JSON_mUtils_mViews_mCore.View__.beg(this) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(v'#0))) && (JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(this, v'#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(v'#0), JSON_mUtils_mViews_mCore.View__.s(this)) && JSON_mUtils_mViews_mCore.View__.beg(v'#0) < JSON_mUtils_mViews_mCore.View__.beg(this) && JSON_mUtils_mViews_mCore.View__.end(this) == JSON_mUtils_mViews_mCore.View__.end(v'#0)));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q#canCall(Lit(this), Lit(v'#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (Lit(JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0)) < JSON_mUtils_mViews_mCore.View__.beg(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v'#0)))) && (JSON_mUtils_mViews_mCore.View__.StrictSuffixOf_q(Lit(this), Lit(v'#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.s(Lit(v'#0)), JSON_mUtils_mViews_mCore.View__.s(Lit(this))) && JSON_mUtils_mViews_mCore.View__.beg(Lit(v'#0)) < JSON_mUtils_mViews_mCore.View__.beg(Lit(this)) && LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(this))) == LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(v'#0)))));

axiom (forall this: DatatypeType, c#0: int :: { JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0) } JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, c#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(this) && (JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(this), Seq#Build(Seq#Empty(): Seq, $Box(c#0)))));

axiom (forall this: DatatypeType, c#0: int :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Byte_q(Lit(this), LitInt(c#0)) } JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(Lit(this), LitInt(c#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(this)) && (JSON_mUtils_mViews_mCore.View__.Byte_q(Lit(this), LitInt(c#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(this)), Seq#Build(Seq#Empty(): Seq, $Box(LitInt(c#0))))));

axiom (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mViews_mCore.View__.Char_q(this, c#0) } JSON_mUtils_mViews_mCore.View__.Char_q#canCall(this, c#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(c#0, TChar) && JSON_mUtils_mViews_mCore.View__.Valid_q(this) && char#ToInt(c#0) < 256) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(this, char#ToInt(c#0)) && (JSON_mUtils_mViews_mCore.View__.Char_q(this, c#0) <==> JSON_mUtils_mViews_mCore.View__.Byte_q(this, char#ToInt(c#0))));

axiom (forall this: DatatypeType, c#0: char :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Char_q(Lit(this), Lit(c#0)) } JSON_mUtils_mViews_mCore.View__.Char_q#canCall(Lit(this), Lit(c#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && $Is(c#0, TChar) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this)) && char#ToInt(Lit(c#0)) < 256) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(Lit(this), char#ToInt(Lit(c#0))) && (JSON_mUtils_mViews_mCore.View__.Char_q(Lit(this), Lit(c#0)) <==> JSON_mUtils_mViews_mCore.View__.Byte_q(Lit(this), char#ToInt(Lit(c#0)))));

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0) } JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && (JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0) <==> JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0 < JSON_mUtils_mViews_mCore.View__.end(this)));

axiom (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.ValidIndex_q(Lit(this), LitInt(idx#0)) } JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(Lit(this), LitInt(idx#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && (JSON_mUtils_mViews_mCore.View__.ValidIndex_q(Lit(this), LitInt(idx#0)) <==> Lit(JSON_mUtils_mViews_mCore.View__.beg(Lit(this)) + idx#0 < JSON_mUtils_mViews_mCore.View__.end(Lit(this)))));

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.At(this, idx#0) } JSON_mUtils_mViews_mCore.View__.At#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mViews_mCore.View__.Valid_q(this) && JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0)) ==> LitInt(0) <= JSON_mUtils_mViews_mCore.View__.At(this, idx#0) && JSON_mUtils_mViews_mCore.View__.At(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mViews_mCore.View__.At(this, idx#0) } JSON_mUtils_mViews_mCore.View__.At#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mViews_mCore.View__.Valid_q(this) && JSON_mUtils_mViews_mCore.View__.ValidIndex_q(this, idx#0)) ==> JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.View_q(this) && JSON_mUtils_mViews_mCore.View__.At(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s(this), JSON_mUtils_mViews_mCore.View__.beg(this) + idx#0)): int);

axiom (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.At(Lit(this), LitInt(idx#0)) } JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(this), LitInt(idx#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this)) && Lit(JSON_mUtils_mViews_mCore.View__.ValidIndex_q(Lit(this), LitInt(idx#0)))) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.At(Lit(this), LitInt(idx#0)) == $Unbox(Seq#Index(Lit(JSON_mUtils_mViews_mCore.View__.s(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(this)) + idx#0))): int);

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Peek(this) } JSON_mUtils_mViews_mCore.View__.Peek#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> (JSON_mUtils_mViews_mCore.View__.Peek(this) < 0 <==> JSON_mUtils_mViews_mCore.View__.Empty_q(this)) && LitInt(-1) <= JSON_mUtils_mViews_mCore.View__.Peek(this) && JSON_mUtils_mViews_mCore.View__.Peek(this) < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mCore.View__.Peek(this) } JSON_mUtils_mViews_mCore.View__.Peek#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(this)) ==> (!JSON_mUtils_mViews_mCore.View__.Empty_q(this) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(this, LitInt(0))) && JSON_mUtils_mViews_mCore.View__.Peek(this) == (if JSON_mUtils_mViews_mCore.View__.Empty_q(this) then -1 else JSON_mUtils_mViews_mCore.View__.At(this, LitInt(0))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.Peek(Lit(this)) } JSON_mUtils_mViews_mCore.View__.Peek#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mViews_mCore.View__()) && JSON_mUtils_mViews_mCore.View__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mViews_mCore.View__.Empty_q(Lit(this)) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(this), LitInt(0))) && JSON_mUtils_mViews_mCore.View__.Peek(Lit(this)) == (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit(this)) then -1 else JSON_mUtils_mViews_mCore.View__.At(Lit(this), LitInt(0))));

const unique tytagFamily$Chain: TyTagFamily;

const unique tytagFamily$Writer_: TyTagFamily;

const unique tytagFamily$Writer: TyTagFamily;

const unique class.JSON_mUtils_mLexers_mCore.__default: ClassName;

function #JSON.Utils.Lexers.Core.LexerResult.Accept() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Lexers.Core.LexerResult.Accept()) == ##JSON.Utils.Lexers.Core.LexerResult.Accept;
axiom #JSON.Utils.Lexers.Core.LexerResult.Accept() == Lit(#JSON.Utils.Lexers.Core.LexerResult.Accept());
}

const unique ##JSON.Utils.Lexers.Core.LexerResult.Accept: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Lexers.Core.LexerResult.Accept()) == ##JSON.Utils.Lexers.Core.LexerResult.Accept;
}

function JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Lexers.Core.LexerResult.Accept);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d) ==> d == #JSON.Utils.Lexers.Core.LexerResult.Accept());

function Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Ty, Ty) : Ty;

const unique Tagclass.JSON_mUtils_mLexers_mCore.LexerResult: TyTag;

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty :: { Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R) } Tag(Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) == Tagclass.JSON_mUtils_mLexers_mCore.LexerResult && TagFamily(Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) == tytagFamily$LexerResult);

function Tclass.JSON_mUtils_mLexers_mCore.LexerResult_0(Ty) : Ty;

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty :: { Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R) } Tclass.JSON_mUtils_mLexers_mCore.LexerResult_0(Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) == JSON.Utils.Lexers.Core.LexerResult$T);

function Tclass.JSON_mUtils_mLexers_mCore.LexerResult_1(Ty) : Ty;

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty :: { Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R) } Tclass.JSON_mUtils_mLexers_mCore.LexerResult_1(Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) == JSON.Utils.Lexers.Core.LexerResult$R);

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $IsBox(bx, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty :: { $Is(#JSON.Utils.Lexers.Core.LexerResult.Accept(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $Is(#JSON.Utils.Lexers.Core.LexerResult.Accept(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, $h: Heap :: { $IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Accept(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsGoodHeap($h) ==> $IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Accept(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h));

function #JSON.Utils.Lexers.Core.LexerResult.Reject(Box) : DatatypeType;

const unique ##JSON.Utils.Lexers.Core.LexerResult.Reject: DtCtorId
uses {
axiom (forall a#26#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(a#26#0#0) } DatatypeCtorId(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#26#0#0)) == ##JSON.Utils.Lexers.Core.LexerResult.Reject);
}

function JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Lexers.Core.LexerResult.Reject);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) ==> (exists a#27#0#0: Box :: d == #JSON.Utils.Lexers.Core.LexerResult.Reject(a#27#0#0)));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#28#0#0: Box :: { $Is(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#28#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $Is(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#28#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) <==> $IsBox(a#28#0#0, JSON.Utils.Lexers.Core.LexerResult$R));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#28#0#0: Box, $h: Heap :: { $IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#28#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#28#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) <==> $IsAllocBox(a#28#0#0, JSON.Utils.Lexers.Core.LexerResult$R, $h)));

axiom (forall d: DatatypeType, JSON.Utils.Lexers.Core.LexerResult$R: Ty, $h: Heap :: { $IsAllocBox(JSON_mUtils_mLexers_mCore.LexerResult.err(d), JSON.Utils.Lexers.Core.LexerResult$R, $h) } $IsGoodHeap($h) && JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) && (exists JSON.Utils.Lexers.Core.LexerResult$T: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h)) ==> $IsAllocBox(JSON_mUtils_mLexers_mCore.LexerResult.err(d), JSON.Utils.Lexers.Core.LexerResult$R, $h));

axiom (forall a#29#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(Lit(a#29#0#0)) } #JSON.Utils.Lexers.Core.LexerResult.Reject(Lit(a#29#0#0)) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#29#0#0)));

function JSON_mUtils_mLexers_mCore.LexerResult.err(DatatypeType) : Box;

axiom (forall a#30#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(a#30#0#0) } JSON_mUtils_mLexers_mCore.LexerResult.err(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#30#0#0)) == a#30#0#0);

axiom (forall a#31#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(a#31#0#0) } BoxRank(a#31#0#0) < DtRank(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#31#0#0)));

function #JSON.Utils.Lexers.Core.LexerResult.Partial(Box) : DatatypeType;

const unique ##JSON.Utils.Lexers.Core.LexerResult.Partial: DtCtorId
uses {
axiom (forall a#32#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(a#32#0#0) } DatatypeCtorId(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#32#0#0)) == ##JSON.Utils.Lexers.Core.LexerResult.Partial);
}

function JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Lexers.Core.LexerResult.Partial);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) ==> (exists a#33#0#0: Box :: d == #JSON.Utils.Lexers.Core.LexerResult.Partial(a#33#0#0)));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#34#0#0: Box :: { $Is(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#34#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $Is(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#34#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) <==> $IsBox(a#34#0#0, JSON.Utils.Lexers.Core.LexerResult$T));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#34#0#0: Box, $h: Heap :: { $IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#34#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#34#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) <==> $IsAllocBox(a#34#0#0, JSON.Utils.Lexers.Core.LexerResult$T, $h)));

axiom (forall d: DatatypeType, JSON.Utils.Lexers.Core.LexerResult$T: Ty, $h: Heap :: { $IsAllocBox(JSON_mUtils_mLexers_mCore.LexerResult.st(d), JSON.Utils.Lexers.Core.LexerResult$T, $h) } $IsGoodHeap($h) && JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) && (exists JSON.Utils.Lexers.Core.LexerResult$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h)) ==> $IsAllocBox(JSON_mUtils_mLexers_mCore.LexerResult.st(d), JSON.Utils.Lexers.Core.LexerResult$T, $h));

axiom (forall a#35#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(Lit(a#35#0#0)) } #JSON.Utils.Lexers.Core.LexerResult.Partial(Lit(a#35#0#0)) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#35#0#0)));

function JSON_mUtils_mLexers_mCore.LexerResult.st(DatatypeType) : Box;

axiom (forall a#36#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(a#36#0#0) } JSON_mUtils_mLexers_mCore.LexerResult.st(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#36#0#0)) == a#36#0#0);

axiom (forall a#37#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(a#37#0#0) } BoxRank(a#37#0#0) < DtRank(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#37#0#0)));

function $IsA#JSON_mUtils_mLexers_mCore.LexerResult(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mLexers_mCore.LexerResult(d) } $IsA#JSON_mUtils_mLexers_mCore.LexerResult(d) ==> JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d) || JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) || JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d), $Is(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } { JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d), $Is(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } { JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d), $Is(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $Is(d, Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) ==> JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(d) || JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) || JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d));

function JSON_mUtils_mLexers_mCore.LexerResult#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b), JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(a) } { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b), JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(b) } JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(a) && JSON_mUtils_mLexers_mCore.LexerResult.Accept_q(b) ==> JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b), JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(a) } { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b), JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(b) } JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(a) && JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(b) ==> (JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b) <==> JSON_mUtils_mLexers_mCore.LexerResult.err(a) == JSON_mUtils_mLexers_mCore.LexerResult.err(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b), JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(a) } { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b), JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(b) } JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(a) && JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(b) ==> (JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b) <==> JSON_mUtils_mLexers_mCore.LexerResult.st(a) == JSON_mUtils_mLexers_mCore.LexerResult.st(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b) } JSON_mUtils_mLexers_mCore.LexerResult#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mLexers_mCore.LexerResult: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#140 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#140))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#142 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#142)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#210 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#210))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#212 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#212)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#214 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#214)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#210 := Wrappers.Option.value(this); v#210)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#212 := Lit(Wrappers.Option.value(Lit(this))); v#212)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#214 := Lit(Wrappers.Option.value(Lit(this))); v#214)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#140 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#140)) else (var e#140 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#142 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#142))) else (var e#142 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#210 := Wrappers.Result.value(this); s#210) else (var e#210 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#212 := Lit(Wrappers.Result.value(Lit(this))); s#212) else (var e#212 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#214 := Lit(Wrappers.Result.value(Lit(this))); s#214) else (var e#214 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#210 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#210)) else (var e#210 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#210)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#212 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#212))) else (var e#212 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#212)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#214 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#214))) else (var e#214 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#214)))));

const unique tytagFamily$LexerResult: TyTagFamily;

const unique class.JSON_mUtils_mLexers_mStrings.__default: ClassName;

function JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart() : bool
uses {
axiom JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(): bool <==> Lit(false);
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(), TBool);
}

procedure {:verboseName "JSON.Utils.Lexers.Strings.StringBodyLexerStart (well-formedness)"} CheckWellFormed$$JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(), TBool, $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(), TBool, $h));

function JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) || (1 < $FunctionContextHeight && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> $Is(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $Heap) } (JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) || (1 < $FunctionContextHeight && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8())) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) || (1 < $FunctionContextHeight && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) == (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(!escaped#0)) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0 then #JSON.Utils.Lexers.Core.LexerResult.Accept() else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(false))))));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, Lit(escaped#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, Lit(escaped#0), LitInt(byte#0)) || (1 < $FunctionContextHeight && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, Lit(escaped#0), LitInt(byte#0)) == (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(!Lit(escaped#0))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !Lit(escaped#0) then #JSON.Utils.Lexers.Core.LexerResult.Accept() else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(false))))));
}

function JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int) : bool;

function JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(Ty, bool, int) : bool;

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) } LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) <==> true));

procedure {:verboseName "JSON.Utils.Lexers.Strings.StringBody (well-formedness)"} CheckWellformed$$JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int where LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Lexers.Strings.StringBody (well-formedness)"} CheckWellformed$$JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Lexers.Strings.StringBody", " | ", JSON.Utils.Lexers.Strings._default.StringBody$R, " | ", escaped#0, " | ", byte#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "bool", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Lexers.dfy(27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R));
    assume false;
    return;

  anon10_Else:
    newtype$check#0 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(92)));
    assume JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) == #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(!escaped#0));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R));
    return;

  anon11_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(92)));
    newtype$check#2 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34)));
    goto anon7;

  anon12_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(34)));
    goto anon7;

  anon7:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0;
    assume JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Accept());
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R));
    return;

  anon13_Else:
    assume {:partition} !(byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0);
    assume JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(false))));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R));
    return;
}



function JSON_mUtils_mLexers_mStrings.__default.StringLexerStart() : DatatypeType
uses {
axiom JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(): DatatypeType == Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Start());
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState());
}

procedure {:verboseName "JSON.Utils.Lexers.Strings.StringLexerStart (well-formedness)"} CheckWellFormed$$JSON_mUtils_mLexers_mStrings.__default.StringLexerStart();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) == Tagclass.JSON_mUtils_mLexers_mStrings.StringLexerState && TagFamily(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) == tytagFamily$StringLexerState;
}

const unique Tagclass.JSON_mUtils_mLexers_mStrings.StringLexerState: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) } $IsBox(bx, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h));

function JSON_mUtils_mLexers_mStrings.__default.String(st#0: DatatypeType, byte#0: int) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || (1 < $FunctionContextHeight && $Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar))));
axiom 1 <= $FunctionContextHeight ==> (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || (1 < $FunctionContextHeight && $Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#0 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#0))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));
axiom 1 <= $FunctionContextHeight ==> (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || (1 < $FunctionContextHeight && $Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#2 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#2))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#2 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));
}

function JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0: DatatypeType, byte#0: int) : bool;

function JSON_mUtils_mLexers_mStrings.__default.String#requires(DatatypeType, int) : bool;

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String#requires(st#0, byte#0) } $Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mUtils_mLexers_mStrings.__default.String#requires(st#0, byte#0) <==> true));

procedure {:verboseName "JSON.Utils.Lexers.Strings.String (well-formedness)"} CheckWellformed$$JSON_mUtils_mLexers_mStrings.__default.String(st#0: DatatypeType where $Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()), byte#0: int where LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Lexers.Strings.String (well-formedness)"} CheckWellformed$$JSON_mUtils_mLexers_mStrings.__default.String(st#0: DatatypeType, byte#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#0#0: bool;
  var escaped#Z#0: bool;
  var let#0#0#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Lexers.Strings.String", " | ", st#0, " | ", byte#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Lexers.dfy(38,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    assume false;
    return;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} st#0 == #JSON.Utils.Lexers.Strings.StringLexerState.Start();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34)));
    assume JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    return;

  anon18_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(34)));
    assume JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101)))))));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    return;

  anon17_Else:
    assume {:partition} st#0 != #JSON.Utils.Lexers.Strings.StringLexerState.Start();
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} st#0 == #JSON.Utils.Lexers.Strings.StringLexerState.Body(_mcc#0#0);
    havoc escaped#Z#0;
    assume true;
    assume let#0#0#0 <==> _mcc#0#0;
    assume true;
    assume $Is(let#0#0#0, TBool);
    assume escaped#Z#0 <==> let#0#0#0;
    newtype$check#0 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(92)));
    assume JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#Z#0)));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    return;

  anon20_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(92)));
    newtype$check#2 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34)));
    goto anon11;

  anon21_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(34)));
    goto anon11;

  anon11:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#Z#0;
    assume JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    return;

  anon22_Else:
    assume {:partition} !(byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#Z#0);
    assume JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))));
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    return;

  anon19_Else:
    assume {:partition} st#0 != #JSON.Utils.Lexers.Strings.StringLexerState.Body(_mcc#0#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} st#0 == #JSON.Utils.Lexers.Strings.StringLexerState.End();
    assume JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Accept());
    assume true;
    assume $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar)));
    return;

  anon23_Else:
    assume {:partition} st#0 != #JSON.Utils.Lexers.Strings.StringLexerState.End();
    assume false;
    return;
}



function #JSON.Utils.Lexers.Strings.StringLexerState.Start() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Lexers.Strings.StringLexerState.Start()) == ##JSON.Utils.Lexers.Strings.StringLexerState.Start;
axiom $Is(#JSON.Utils.Lexers.Strings.StringLexerState.Start(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState());
axiom #JSON.Utils.Lexers.Strings.StringLexerState.Start() == Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Start());
}

const unique ##JSON.Utils.Lexers.Strings.StringLexerState.Start: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Lexers.Strings.StringLexerState.Start()) == ##JSON.Utils.Lexers.Strings.StringLexerState.Start;
}

function JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d) } JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Lexers.Strings.StringLexerState.Start);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d) } JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d) ==> d == #JSON.Utils.Lexers.Strings.StringLexerState.Start());

function #JSON.Utils.Lexers.Strings.StringLexerState.Body(bool) : DatatypeType;

const unique ##JSON.Utils.Lexers.Strings.StringLexerState.Body: DtCtorId
uses {
axiom (forall a#4#0#0: bool :: { #JSON.Utils.Lexers.Strings.StringLexerState.Body(a#4#0#0) } DatatypeCtorId(#JSON.Utils.Lexers.Strings.StringLexerState.Body(a#4#0#0)) == ##JSON.Utils.Lexers.Strings.StringLexerState.Body);
}

function JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) } JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Lexers.Strings.StringLexerState.Body);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) } JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) ==> (exists a#5#0#0: bool :: d == #JSON.Utils.Lexers.Strings.StringLexerState.Body(a#5#0#0)));

axiom (forall a#6#0#0: bool :: { $Is(#JSON.Utils.Lexers.Strings.StringLexerState.Body(a#6#0#0), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) } $Is(#JSON.Utils.Lexers.Strings.StringLexerState.Body(a#6#0#0), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) <==> $Is(a#6#0#0, TBool));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(d), TBool, $h) } $IsGoodHeap($h) && JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(d), TBool, $h));

axiom (forall a#7#0#0: bool :: { #JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(a#7#0#0)) } #JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(a#7#0#0)) == Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(a#7#0#0)));

function JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(DatatypeType) : bool;

axiom (forall a#8#0#0: bool :: { #JSON.Utils.Lexers.Strings.StringLexerState.Body(a#8#0#0) } JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(#JSON.Utils.Lexers.Strings.StringLexerState.Body(a#8#0#0)) <==> a#8#0#0);

function #JSON.Utils.Lexers.Strings.StringLexerState.End() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Lexers.Strings.StringLexerState.End()) == ##JSON.Utils.Lexers.Strings.StringLexerState.End;
axiom $Is(#JSON.Utils.Lexers.Strings.StringLexerState.End(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState());
axiom #JSON.Utils.Lexers.Strings.StringLexerState.End() == Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End());
}

const unique ##JSON.Utils.Lexers.Strings.StringLexerState.End: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Lexers.Strings.StringLexerState.End()) == ##JSON.Utils.Lexers.Strings.StringLexerState.End;
}

function JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d) } JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Lexers.Strings.StringLexerState.End);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d) } JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d) ==> d == #JSON.Utils.Lexers.Strings.StringLexerState.End());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h));

function $IsA#JSON_mUtils_mLexers_mStrings.StringLexerState(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mLexers_mStrings.StringLexerState(d) } $IsA#JSON_mUtils_mLexers_mStrings.StringLexerState(d) ==> JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d) || JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) || JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d), $Is(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) } { JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d), $Is(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) } { JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d), $Is(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) } $Is(d, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) ==> JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(d) || JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(d) || JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(d));

function JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b), JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(a) } { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b), JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(b) } JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(a) && JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(b) ==> JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b), JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(a) } { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b), JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(b) } JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(a) && JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(b) ==> (JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b) <==> JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(a) <==> JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b), JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(a) } { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b), JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(b) } JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(a) && JSON_mUtils_mLexers_mStrings.StringLexerState.End_q(b) ==> JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b) } JSON_mUtils_mLexers_mStrings.StringLexerState#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mLexers_mStrings.StringLexerState: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#144 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#144))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#146 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#146)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#216 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#216))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#218 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#218)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#220 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#220)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#216 := Wrappers.Option.value(this); v#216)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#218 := Lit(Wrappers.Option.value(Lit(this))); v#218)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#220 := Lit(Wrappers.Option.value(Lit(this))); v#220)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#144 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#144)) else (var e#144 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#146 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#146))) else (var e#146 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#216 := Wrappers.Result.value(this); s#216) else (var e#216 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#218 := Lit(Wrappers.Result.value(Lit(this))); s#218) else (var e#218 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#220 := Lit(Wrappers.Result.value(Lit(this))); s#220) else (var e#220 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#216 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#216)) else (var e#216 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#216)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#218 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#218))) else (var e#218 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#218)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#220 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#220))) else (var e#220 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#220)))));

axiom (forall a#4#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(a#4#0#0) } DatatypeCtorId(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#4#0#0)) == ##JSON.Utils.Lexers.Core.LexerResult.Reject);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Reject_q(d) ==> (exists a#5#0#0: Box :: d == #JSON.Utils.Lexers.Core.LexerResult.Reject(a#5#0#0)));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#6#0#0: Box :: { $Is(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#6#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $Is(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#6#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) <==> $IsBox(a#6#0#0, JSON.Utils.Lexers.Core.LexerResult$R));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#6#0#0: Box, $h: Heap :: { $IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#6#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#6#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) <==> $IsAllocBox(a#6#0#0, JSON.Utils.Lexers.Core.LexerResult$R, $h)));

axiom (forall a#7#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(Lit(a#7#0#0)) } #JSON.Utils.Lexers.Core.LexerResult.Reject(Lit(a#7#0#0)) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#7#0#0)));

axiom (forall a#8#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(a#8#0#0) } JSON_mUtils_mLexers_mCore.LexerResult.err(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#8#0#0)) == a#8#0#0);

axiom (forall a#9#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Reject(a#9#0#0) } BoxRank(a#9#0#0) < DtRank(#JSON.Utils.Lexers.Core.LexerResult.Reject(a#9#0#0)));

axiom (forall a#10#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(a#10#0#0) } DatatypeCtorId(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#10#0#0)) == ##JSON.Utils.Lexers.Core.LexerResult.Partial);

axiom (forall d: DatatypeType :: { JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) } JSON_mUtils_mLexers_mCore.LexerResult.Partial_q(d) ==> (exists a#11#0#0: Box :: d == #JSON.Utils.Lexers.Core.LexerResult.Partial(a#11#0#0)));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#12#0#0: Box :: { $Is(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#12#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) } $Is(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#12#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R)) <==> $IsBox(a#12#0#0, JSON.Utils.Lexers.Core.LexerResult$T));

axiom (forall JSON.Utils.Lexers.Core.LexerResult$T: Ty, JSON.Utils.Lexers.Core.LexerResult$R: Ty, a#12#0#0: Box, $h: Heap :: { $IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#12#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#12#0#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Lexers.Core.LexerResult$T, JSON.Utils.Lexers.Core.LexerResult$R), $h) <==> $IsAllocBox(a#12#0#0, JSON.Utils.Lexers.Core.LexerResult$T, $h)));

axiom (forall a#13#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(Lit(a#13#0#0)) } #JSON.Utils.Lexers.Core.LexerResult.Partial(Lit(a#13#0#0)) == Lit(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#13#0#0)));

axiom (forall a#14#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(a#14#0#0) } JSON_mUtils_mLexers_mCore.LexerResult.st(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#14#0#0)) == a#14#0#0);

axiom (forall a#15#0#0: Box :: { #JSON.Utils.Lexers.Core.LexerResult.Partial(a#15#0#0) } BoxRank(a#15#0#0) < DtRank(#JSON.Utils.Lexers.Core.LexerResult.Partial(a#15#0#0)));

const unique tytagFamily$StringLexerState: TyTagFamily;

const unique class.JSON_mUtils_mCursors.__default: ClassName;

function #JSON.Utils.Cursors.Split.SP(Box, DatatypeType) : DatatypeType;

const unique ##JSON.Utils.Cursors.Split.SP: DtCtorId
uses {
axiom (forall a#22#0#0: Box, a#22#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#22#0#0, a#22#1#0) } DatatypeCtorId(#JSON.Utils.Cursors.Split.SP(a#22#0#0, a#22#1#0)) == ##JSON.Utils.Cursors.Split.SP);
}

function JSON_mUtils_mCursors.Split.SP_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Split.SP_q(d) } JSON_mUtils_mCursors.Split.SP_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Cursors.Split.SP);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Split.SP_q(d) } JSON_mUtils_mCursors.Split.SP_q(d) ==> (exists a#23#0#0: Box, a#23#1#0: DatatypeType :: d == #JSON.Utils.Cursors.Split.SP(a#23#0#0, a#23#1#0)));

function Tclass.JSON_mUtils_mCursors.Split(Ty) : Ty;

const unique Tagclass.JSON_mUtils_mCursors.Split: TyTag;

axiom (forall JSON.Utils.Cursors.Split$T: Ty :: { Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T) } Tag(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) == Tagclass.JSON_mUtils_mCursors.Split && TagFamily(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) == tytagFamily$Split);

function Tclass.JSON_mUtils_mCursors.Split_0(Ty) : Ty;

axiom (forall JSON.Utils.Cursors.Split$T: Ty :: { Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T) } Tclass.JSON_mUtils_mCursors.Split_0(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) == JSON.Utils.Cursors.Split$T);

axiom (forall JSON.Utils.Cursors.Split$T: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) } $IsBox(bx, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)));

function Tclass.JSON_mUtils_mCursors.FreshCursor() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mCursors.FreshCursor()) == Tagclass.JSON_mUtils_mCursors.FreshCursor && TagFamily(Tclass.JSON_mUtils_mCursors.FreshCursor()) == tytagFamily$FreshCursor;
}

const unique Tagclass.JSON_mUtils_mCursors.FreshCursor: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mCursors.FreshCursor()) } $IsBox(bx, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mCursors.FreshCursor()));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, a#24#0#0: Box, a#24#1#0: DatatypeType :: { $Is(#JSON.Utils.Cursors.Split.SP(a#24#0#0, a#24#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) } $Is(#JSON.Utils.Cursors.Split.SP(a#24#0#0, a#24#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) <==> $IsBox(a#24#0#0, JSON.Utils.Cursors.Split$T) && $Is(a#24#1#0, Tclass.JSON_mUtils_mCursors.FreshCursor()));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, a#24#0#0: Box, a#24#1#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.Split.SP(a#24#0#0, a#24#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Cursors.Split.SP(a#24#0#0, a#24#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) <==> $IsAllocBox(a#24#0#0, JSON.Utils.Cursors.Split$T, $h) && $IsAlloc(a#24#1#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $h)));

axiom (forall d: DatatypeType, JSON.Utils.Cursors.Split$T: Ty, $h: Heap :: { $IsAllocBox(JSON_mUtils_mCursors.Split.t(d), JSON.Utils.Cursors.Split$T, $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.Split.SP_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) ==> $IsAllocBox(JSON_mUtils_mCursors.Split.t(d), JSON.Utils.Cursors.Split$T, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.Split.cs(d), Tclass.JSON_mUtils_mCursors.FreshCursor(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.Split.SP_q(d) && (exists JSON.Utils.Cursors.Split$T: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h)) ==> $IsAlloc(JSON_mUtils_mCursors.Split.cs(d), Tclass.JSON_mUtils_mCursors.FreshCursor(), $h));

axiom (forall a#25#0#0: Box, a#25#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(Lit(a#25#0#0), Lit(a#25#1#0)) } #JSON.Utils.Cursors.Split.SP(Lit(a#25#0#0), Lit(a#25#1#0)) == Lit(#JSON.Utils.Cursors.Split.SP(a#25#0#0, a#25#1#0)));

function JSON_mUtils_mCursors.Split.t(DatatypeType) : Box;

axiom (forall a#26#0#0: Box, a#26#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#26#0#0, a#26#1#0) } JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP(a#26#0#0, a#26#1#0)) == a#26#0#0);

axiom (forall a#27#0#0: Box, a#27#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#27#0#0, a#27#1#0) } BoxRank(a#27#0#0) < DtRank(#JSON.Utils.Cursors.Split.SP(a#27#0#0, a#27#1#0)));

function JSON_mUtils_mCursors.Split.cs(DatatypeType) : DatatypeType;

axiom (forall a#28#0#0: Box, a#28#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#28#0#0, a#28#1#0) } JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP(a#28#0#0, a#28#1#0)) == a#28#1#0);

axiom (forall a#29#0#0: Box, a#29#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#29#0#0, a#29#1#0) } DtRank(a#29#1#0) < DtRank(#JSON.Utils.Cursors.Split.SP(a#29#0#0, a#29#1#0)));

function $IsA#JSON_mUtils_mCursors.Split(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mCursors.Split(d) } $IsA#JSON_mUtils_mCursors.Split(d) ==> JSON_mUtils_mCursors.Split.SP_q(d));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, d: DatatypeType :: { JSON_mUtils_mCursors.Split.SP_q(d), $Is(d, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) } $Is(d, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) ==> JSON_mUtils_mCursors.Split.SP_q(d));

function JSON_mUtils_mCursors.Split#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.Split#Equal(a, b) } JSON_mUtils_mCursors.Split#Equal(a, b) <==> JSON_mUtils_mCursors.Split.t(a) == JSON_mUtils_mCursors.Split.t(b) && JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(a), JSON_mUtils_mCursors.Split.cs(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.Split#Equal(a, b) } JSON_mUtils_mCursors.Split#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mCursors.Split: ClassName;

function JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(this)) && (JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, JSON_mUtils_mCursors.Split.t(this))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(this))))));
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(cs0#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this)))) && (JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(Lit(cs0#0)), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, Lit(JSON_mUtils_mCursors.Split.t(Lit(this))))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))))))));
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(cs0#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this)))) && (JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(Lit(cs0#0)), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(spec#0), Lit(JSON_mUtils_mCursors.Split.t(Lit(this))))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))))))));
}

function JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType) : bool;

function Tclass.JSON_mUtils_mCursors.Cursor() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mCursors.Cursor()) == Tagclass.JSON_mUtils_mCursors.Cursor && TagFamily(Tclass.JSON_mUtils_mCursors.Cursor()) == tytagFamily$Cursor;
}

const unique Tagclass.JSON_mUtils_mCursors.Cursor: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mCursors.Cursor()) } $IsBox(bx, Tclass.JSON_mUtils_mCursors.Cursor()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mCursors.Cursor()));

function JSON_mUtils_mCursors.Split.BytesSplitFrom_q#requires(Ty, DatatypeType, DatatypeType, HandleType) : bool;

axiom (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.BytesSplitFrom_q#requires(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#requires(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.Split.BytesSplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap), cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()), spec#0: HandleType where $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.JSON_mUtils_mCursors.Cursor__() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mCursors.Cursor__()) == Tagclass.JSON_mUtils_mCursors.Cursor__ && TagFamily(Tclass.JSON_mUtils_mCursors.Cursor__()) == tytagFamily$Cursor_;
}

const unique Tagclass.JSON_mUtils_mCursors.Cursor__: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mCursors.Cursor__()) } $IsBox(bx, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mCursors.Cursor__()));

function JSON_mUtils_mCursors.Cursor__.Valid_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Valid_q(this): bool } JSON_mUtils_mCursors.Cursor__.Valid_q(this): bool <==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.beg(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) && JSON_mUtils_mCursors.Cursor__.point(this) <= JSON_mUtils_mCursors.Cursor__.end(this) && JSON_mUtils_mCursors.Cursor__.end(this) <= Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this)) && Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this)) < BoundedInts.__default.TWO__TO__THE__32());
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Valid_q($o) } $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Is(JSON_mUtils_mCursors.Cursor__.Valid_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Valid_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.Valid_q($o), TBool, $h));
}

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Split.BytesSplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Split.BytesSplitFrom?", " | ", JSON.Utils.Cursors.Split$T, " | ", this, " | ", cs0#0, " | ", spec#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(16,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(this);
    assume JSON_mUtils_mCursors.Split.SP_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(this)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, JSON_mUtils_mCursors.Split.t(this))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(this))));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(this));
    assume $Is(JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType) : bool
uses {
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) } JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)) && (JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) } JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)) && (JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) } JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0))) && (JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)))));
}

function JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType) : bool;

function JSON_mUtils_mCursors.Split.SplitFrom_q#requires(Ty, DatatypeType, DatatypeType, HandleType) : bool;

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.SplitFrom_q#requires(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mUtils_mCursors.Split.SplitFrom_q#requires(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.Split.SplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap), cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()), spec#0: HandleType where $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Split.SplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Split.SplitFrom?", " | ", JSON.Utils.Cursors.Split$T, " | ", this, " | ", cs0#0, " | ", spec#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(20,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    assume JSON_mUtils_mCursors.Split.SP_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(this)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs0#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap);
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := spec#0;
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0);
    goto anon5;

  anon7_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0);
    assume JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0));
    assume $Is(JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType) : bool
uses {
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) } JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)) && (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) } JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)) && (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) } JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0))) && (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)))));
}

function JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType) : bool;

function JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#requires(Ty, DatatypeType, DatatypeType, HandleType) : bool;

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#requires(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#requires(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.Split.StrictlySplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap), cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()), spec#0: HandleType where $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Split.StrictlySplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Split.StrictlySplitFrom?", " | ", JSON.Utils.Cursors.Split$T, " | ", this, " | ", cs0#0, " | ", spec#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(24,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    assume JSON_mUtils_mCursors.Split.SP_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(this)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs0#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(this));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap);
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := spec#0;
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0);
    goto anon5;

  anon7_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0);
    assume JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0));
    assume $Is(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0), TBool);
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor(ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor__()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor(ps#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor", " | ", ps#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(30,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))));
    return;
}



axiom (forall ps#0: DatatypeType :: { $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()) } $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()) <==> $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0));

axiom (forall ps#0: DatatypeType, $h: Heap :: { $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor(), $h) } $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor(), $h) <==> $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $h));

procedure {:verboseName "JSON.Utils.Cursors.FreshCursor (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.FreshCursor(ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mCursors.Cursor__.BOF_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.BOF_q(this): bool } JSON_mUtils_mCursors.Cursor__.BOF_q(this): bool <==> JSON_mUtils_mCursors.Cursor__.point(this) == JSON_mUtils_mCursors.Cursor__.beg(this));
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.BOF_q($o) } $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Is(JSON_mUtils_mCursors.Cursor__.BOF_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.BOF_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.BOF_q($o), TBool, $h));
}

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.FreshCursor (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.FreshCursor(ps#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.FreshCursor", " | ", ps#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(32,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(ps#0);
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0)));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(newtype$check#3);
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))));
    return;
}



axiom (forall ps#0: DatatypeType :: { $Is(ps#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) } $Is(ps#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) <==> $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.BOF_q(ps#0));

axiom (forall ps#0: DatatypeType, $h: Heap :: { $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $h) } $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $h) <==> $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor(), $h));

function #JSON.Utils.Cursors.CursorError.EOF() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Cursors.CursorError.EOF()) == ##JSON.Utils.Cursors.CursorError.EOF;
axiom #JSON.Utils.Cursors.CursorError.EOF() == Lit(#JSON.Utils.Cursors.CursorError.EOF());
}

const unique ##JSON.Utils.Cursors.CursorError.EOF: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Cursors.CursorError.EOF()) == ##JSON.Utils.Cursors.CursorError.EOF;
}

function JSON_mUtils_mCursors.CursorError.EOF_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.EOF_q(d) } JSON_mUtils_mCursors.CursorError.EOF_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Cursors.CursorError.EOF);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.EOF_q(d) } JSON_mUtils_mCursors.CursorError.EOF_q(d) ==> d == #JSON.Utils.Cursors.CursorError.EOF());

function Tclass.JSON_mUtils_mCursors.CursorError(Ty) : Ty;

const unique Tagclass.JSON_mUtils_mCursors.CursorError: TyTag;

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty :: { Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R) } Tag(Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) == Tagclass.JSON_mUtils_mCursors.CursorError && TagFamily(Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) == tytagFamily$CursorError);

function Tclass.JSON_mUtils_mCursors.CursorError_0(Ty) : Ty;

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty :: { Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R) } Tclass.JSON_mUtils_mCursors.CursorError_0(Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) == JSON.Utils.Cursors.CursorError$R);

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } $IsBox(bx, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty :: { $Is(#JSON.Utils.Cursors.CursorError.EOF(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } $Is(#JSON.Utils.Cursors.CursorError.EOF(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.CursorError.EOF(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsGoodHeap($h) ==> $IsAlloc(#JSON.Utils.Cursors.CursorError.EOF(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h));

function #JSON.Utils.Cursors.CursorError.ExpectingByte(int, int) : DatatypeType;

const unique ##JSON.Utils.Cursors.CursorError.ExpectingByte: DtCtorId
uses {
axiom (forall a#4#0#0: int, a#4#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingByte(a#4#0#0, a#4#1#0) } DatatypeCtorId(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#4#0#0, a#4#1#0)) == ##JSON.Utils.Cursors.CursorError.ExpectingByte);
}

function JSON_mUtils_mCursors.CursorError.ExpectingByte_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) } JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Cursors.CursorError.ExpectingByte);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) } JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) ==> (exists a#5#0#0: int, a#5#1#0: int :: d == #JSON.Utils.Cursors.CursorError.ExpectingByte(a#5#0#0, a#5#1#0)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, a#6#0#0: int, a#6#1#0: int :: { $Is(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#6#0#0, a#6#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } $Is(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#6#0#0, a#6#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) <==> $Is(a#6#0#0, Tclass.BoundedInts.uint8()) && $Is(a#6#1#0, Tclass.BoundedInts.opt__byte()));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, a#6#0#0: int, a#6#1#0: int, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#6#0#0, a#6#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#6#0#0, a#6#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) <==> $IsAlloc(a#6#0#0, Tclass.BoundedInts.uint8(), $h) && $IsAlloc(a#6#1#0, Tclass.BoundedInts.opt__byte(), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.CursorError.expected(d), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) && (exists JSON.Utils.Cursors.CursorError$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h)) ==> $IsAlloc(JSON_mUtils_mCursors.CursorError.expected(d), Tclass.BoundedInts.uint8(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.CursorError.b(d), Tclass.BoundedInts.opt__byte(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) && (exists JSON.Utils.Cursors.CursorError$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h)) ==> $IsAlloc(JSON_mUtils_mCursors.CursorError.b(d), Tclass.BoundedInts.opt__byte(), $h));

axiom (forall a#7#0#0: int, a#7#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(a#7#0#0), LitInt(a#7#1#0)) } #JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(a#7#0#0), LitInt(a#7#1#0)) == Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#7#0#0, a#7#1#0)));

function JSON_mUtils_mCursors.CursorError.expected(DatatypeType) : int;

axiom (forall a#8#0#0: int, a#8#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingByte(a#8#0#0, a#8#1#0) } JSON_mUtils_mCursors.CursorError.expected(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#8#0#0, a#8#1#0)) == a#8#0#0);

function JSON_mUtils_mCursors.CursorError.b(DatatypeType) : int;

axiom (forall a#9#0#0: int, a#9#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingByte(a#9#0#0, a#9#1#0) } JSON_mUtils_mCursors.CursorError.b(#JSON.Utils.Cursors.CursorError.ExpectingByte(a#9#0#0, a#9#1#0)) == a#9#1#0);

function #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq, int) : DatatypeType;

const unique ##JSON.Utils.Cursors.CursorError.ExpectingAnyByte: DtCtorId
uses {
axiom (forall a#10#0#0: Seq, a#10#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#10#0#0, a#10#1#0) } DatatypeCtorId(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#10#0#0, a#10#1#0)) == ##JSON.Utils.Cursors.CursorError.ExpectingAnyByte);
}

function JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) } JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Cursors.CursorError.ExpectingAnyByte);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) } JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) ==> (exists a#11#0#0: Seq, a#11#1#0: int :: d == #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#11#0#0, a#11#1#0)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, a#12#0#0: Seq, a#12#1#0: int :: { $Is(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#12#0#0, a#12#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } $Is(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#12#0#0, a#12#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) <==> $Is(a#12#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#12#1#0, Tclass.BoundedInts.opt__byte()));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, a#12#0#0: Seq, a#12#1#0: int, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#12#0#0, a#12#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#12#0#0, a#12#1#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) <==> $IsAlloc(a#12#0#0, TSeq(Tclass.BoundedInts.uint8()), $h) && $IsAlloc(a#12#1#0, Tclass.BoundedInts.opt__byte(), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.CursorError.expected__sq(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) && (exists JSON.Utils.Cursors.CursorError$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h)) ==> $IsAlloc(JSON_mUtils_mCursors.CursorError.expected__sq(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.CursorError.b(d), Tclass.BoundedInts.opt__byte(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) && (exists JSON.Utils.Cursors.CursorError$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h)) ==> $IsAlloc(JSON_mUtils_mCursors.CursorError.b(d), Tclass.BoundedInts.opt__byte(), $h));

axiom (forall a#13#0#0: Seq, a#13#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Lit(a#13#0#0), LitInt(a#13#1#0)) } #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Lit(a#13#0#0), LitInt(a#13#1#0)) == Lit(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#13#0#0, a#13#1#0)));

function JSON_mUtils_mCursors.CursorError.expected__sq(DatatypeType) : Seq;

axiom (forall a#14#0#0: Seq, a#14#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#14#0#0, a#14#1#0) } JSON_mUtils_mCursors.CursorError.expected__sq(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#14#0#0, a#14#1#0)) == a#14#0#0);

axiom (forall a#15#0#0: Seq, a#15#1#0: int, i: int :: { Seq#Index(a#15#0#0, i), #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#15#0#0, a#15#1#0) } 0 <= i && i < Seq#Length(a#15#0#0) ==> DtRank($Unbox(Seq#Index(a#15#0#0, i)): DatatypeType) < DtRank(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#15#0#0, a#15#1#0)));

axiom (forall a#16#0#0: Seq, a#16#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#16#0#0, a#16#1#0) } Seq#Rank(a#16#0#0) < DtRank(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#16#0#0, a#16#1#0)));

axiom (forall a#17#0#0: Seq, a#17#1#0: int :: { #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#17#0#0, a#17#1#0) } JSON_mUtils_mCursors.CursorError.b(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(a#17#0#0, a#17#1#0)) == a#17#1#0);

function #JSON.Utils.Cursors.CursorError.OtherError(Box) : DatatypeType;

const unique ##JSON.Utils.Cursors.CursorError.OtherError: DtCtorId
uses {
axiom (forall a#18#0#0: Box :: { #JSON.Utils.Cursors.CursorError.OtherError(a#18#0#0) } DatatypeCtorId(#JSON.Utils.Cursors.CursorError.OtherError(a#18#0#0)) == ##JSON.Utils.Cursors.CursorError.OtherError);
}

function JSON_mUtils_mCursors.CursorError.OtherError_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.OtherError_q(d) } JSON_mUtils_mCursors.CursorError.OtherError_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Cursors.CursorError.OtherError);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.OtherError_q(d) } JSON_mUtils_mCursors.CursorError.OtherError_q(d) ==> (exists a#19#0#0: Box :: d == #JSON.Utils.Cursors.CursorError.OtherError(a#19#0#0)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, a#20#0#0: Box :: { $Is(#JSON.Utils.Cursors.CursorError.OtherError(a#20#0#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } $Is(#JSON.Utils.Cursors.CursorError.OtherError(a#20#0#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) <==> $IsBox(a#20#0#0, JSON.Utils.Cursors.CursorError$R));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, a#20#0#0: Box, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.CursorError.OtherError(a#20#0#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Cursors.CursorError.OtherError(a#20#0#0), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) <==> $IsAllocBox(a#20#0#0, JSON.Utils.Cursors.CursorError$R, $h)));

axiom (forall d: DatatypeType, JSON.Utils.Cursors.CursorError$R: Ty, $h: Heap :: { $IsAllocBox(JSON_mUtils_mCursors.CursorError.err(d), JSON.Utils.Cursors.CursorError$R, $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.CursorError.OtherError_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $h) ==> $IsAllocBox(JSON_mUtils_mCursors.CursorError.err(d), JSON.Utils.Cursors.CursorError$R, $h));

axiom (forall a#21#0#0: Box :: { #JSON.Utils.Cursors.CursorError.OtherError(Lit(a#21#0#0)) } #JSON.Utils.Cursors.CursorError.OtherError(Lit(a#21#0#0)) == Lit(#JSON.Utils.Cursors.CursorError.OtherError(a#21#0#0)));

function JSON_mUtils_mCursors.CursorError.err(DatatypeType) : Box;

axiom (forall a#22#0#0: Box :: { #JSON.Utils.Cursors.CursorError.OtherError(a#22#0#0) } JSON_mUtils_mCursors.CursorError.err(#JSON.Utils.Cursors.CursorError.OtherError(a#22#0#0)) == a#22#0#0);

axiom (forall a#23#0#0: Box :: { #JSON.Utils.Cursors.CursorError.OtherError(a#23#0#0) } BoxRank(a#23#0#0) < DtRank(#JSON.Utils.Cursors.CursorError.OtherError(a#23#0#0)));

function $IsA#JSON_mUtils_mCursors.CursorError(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mCursors.CursorError(d) } $IsA#JSON_mUtils_mCursors.CursorError(d) ==> JSON_mUtils_mCursors.CursorError.EOF_q(d) || JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) || JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) || JSON_mUtils_mCursors.CursorError.OtherError_q(d));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, d: DatatypeType :: { JSON_mUtils_mCursors.CursorError.OtherError_q(d), $Is(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } { JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d), $Is(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } { JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d), $Is(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } { JSON_mUtils_mCursors.CursorError.EOF_q(d), $Is(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) } $Is(d, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) ==> JSON_mUtils_mCursors.CursorError.EOF_q(d) || JSON_mUtils_mCursors.CursorError.ExpectingByte_q(d) || JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(d) || JSON_mUtils_mCursors.CursorError.OtherError_q(d));

function JSON_mUtils_mCursors.CursorError#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.EOF_q(a) } { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.EOF_q(b) } JSON_mUtils_mCursors.CursorError.EOF_q(a) && JSON_mUtils_mCursors.CursorError.EOF_q(b) ==> JSON_mUtils_mCursors.CursorError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.ExpectingByte_q(a) } { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.ExpectingByte_q(b) } JSON_mUtils_mCursors.CursorError.ExpectingByte_q(a) && JSON_mUtils_mCursors.CursorError.ExpectingByte_q(b) ==> (JSON_mUtils_mCursors.CursorError#Equal(a, b) <==> JSON_mUtils_mCursors.CursorError.expected(a) == JSON_mUtils_mCursors.CursorError.expected(b) && JSON_mUtils_mCursors.CursorError.b(a) == JSON_mUtils_mCursors.CursorError.b(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(a) } { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(b) } JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(a) && JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(b) ==> (JSON_mUtils_mCursors.CursorError#Equal(a, b) <==> Seq#Equal(JSON_mUtils_mCursors.CursorError.expected__sq(a), JSON_mUtils_mCursors.CursorError.expected__sq(b)) && JSON_mUtils_mCursors.CursorError.b(a) == JSON_mUtils_mCursors.CursorError.b(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.OtherError_q(a) } { JSON_mUtils_mCursors.CursorError#Equal(a, b), JSON_mUtils_mCursors.CursorError.OtherError_q(b) } JSON_mUtils_mCursors.CursorError.OtherError_q(a) && JSON_mUtils_mCursors.CursorError.OtherError_q(b) ==> (JSON_mUtils_mCursors.CursorError#Equal(a, b) <==> JSON_mUtils_mCursors.CursorError.err(a) == JSON_mUtils_mCursors.CursorError.err(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.CursorError#Equal(a, b) } JSON_mUtils_mCursors.CursorError#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mCursors.CursorError: ClassName;

function JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R: Ty, this: DatatypeType, pr#0: HandleType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.CursorError$R: Ty, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#0 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#0 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#0 := (if b#0 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#0)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#0)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#0)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#1 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#0 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#1 := (if b#1 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#1)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#0 := Seq#Create(TChar, $Heap, Seq#Length(bs0#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#0, $Unbox($l#0#idx#0): int)): int))), (lambda $l#0#heap#0: Heap, $l#0#idx#0: Box :: $IsBox($l#0#idx#0, TInt) && LitInt(0) <= $Unbox($l#0#idx#0): int && $Unbox($l#0#idx#0): int < Seq#Length(bs0#0)), (lambda $l#0#heap#0: Heap, $l#0#idx#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#1))))) else (var err#0 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#0)): Seq)))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#4 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#2 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#4 := (if b#4 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#4)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#2)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#4)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#5 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#2 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#5 := (if b#5 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#5)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#2 := Seq#Create(TChar, $Heap, Seq#Length(bs0#2), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#2, $Unbox($l#3#idx#0): int)): int))), (lambda $l#3#heap#0: Heap, $l#3#idx#0: Box :: $IsBox($l#3#idx#0, TInt) && LitInt(0) <= $Unbox($l#3#idx#0): int && $Unbox($l#3#idx#0): int < Seq#Length(bs0#2)), (lambda $l#3#heap#0: Heap, $l#3#idx#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#2), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#5))))) else (var err#2 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#2)): Seq)))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#8 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#4 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#8 := (if b#8 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#8)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#4)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#8)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#9 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#4 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#9 := (if b#9 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#9)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#4 := Seq#Create(TChar, $Heap, Seq#Length(bs0#4), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#4, $Unbox($l#6#idx#0): int)): int))), (lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: $IsBox($l#6#idx#0, TInt) && LitInt(0) <= $Unbox($l#6#idx#0): int && $Unbox($l#6#idx#0): int < Seq#Length(bs0#4)), (lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#4), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#9))))) else (var err#4 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#4)): Seq)))));
}

function JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R: Ty, this: DatatypeType, pr#0: HandleType) : bool;

function JSON_mUtils_mCursors.CursorError.ToString#requires(Ty, DatatypeType, HandleType) : bool;

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString#requires(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar))) ==> (JSON_mUtils_mCursors.CursorError.ToString#requires(JSON.Utils.Cursors.CursorError$R, this, pr#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.CursorError.ToString (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap), pr#0: HandleType where $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.CursorError.ToString (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R: Ty, this: DatatypeType, pr#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#4#0: Box;
  var err#Z#0: Box;
  var let#0#0#0: Box;
  var _mcc#2#0: Seq;
  var _mcc#3#0: int;
  var b#Z#0: int;
  var let#1#0#0: int;
  var bs0#Z#0: Seq;
  var let#2#0#0: Seq;
  var c#Z#0: Seq;
  var let#3#0#0: Seq;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var c0s#Z#0: Seq;
  var let#4#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var idx#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: char;
  var newtype$check#2: int;
  var _mcc#0#0: int;
  var _mcc#1#0: int;
  var b#Z#1: int;
  var let#5#0#0: int;
  var b0#Z#0: int;
  var let#6#0#0: int;
  var c#Z#1: Seq;
  var let#7#0#0: Seq;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.CursorError.ToString", " | ", JSON.Utils.Cursors.CursorError$R, " | ", this, " | ", pr#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(41,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar));
    assume false;
    return;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} this == #JSON.Utils.Cursors.CursorError.EOF();
    assume JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar));
    goto anon22;

  anon24_Else:
    assume {:partition} this != #JSON.Utils.Cursors.CursorError.EOF();
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} this == #JSON.Utils.Cursors.CursorError.ExpectingByte(_mcc#0#0, _mcc#1#0);
    assume LitInt(0) <= _mcc#0#0 && _mcc#0#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume LitInt(-1) <= _mcc#1#0 && _mcc#1#0 < BoundedInts.__default.TWO__TO__THE__8();
    havoc b#Z#1;
    assume LitInt(-1) <= b#Z#1 && b#Z#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#5#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.BoundedInts.opt__byte());
    assume b#Z#1 == let#5#0#0;
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#6#0#0 == _mcc#0#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0 == let#6#0#0;
    havoc c#Z#1;
    assume $Is(c#Z#1, TSeq(TChar)) && $IsAlloc(c#Z#1, TSeq(TChar), $Heap);
    newtype$check#3 := LitInt(0);
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} b#Z#1 > 0;
    newtype$check#4 := b#Z#1;
    assume char#IsChar(newtype$check#4);
    assume let#7#0#0 == Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#Z#1)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))));
    assume true;
    assume $Is(let#7#0#0, TSeq(TChar));
    goto anon8;

  anon26_Else:
    assume {:partition} 0 >= b#Z#1;
    assume let#7#0#0 == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(let#7#0#0, TSeq(TChar));
    goto anon8;

  anon8:
    assume c#Z#1 == let#7#0#0;
    newtype$check#5 := b0#Z#0;
    assume char#IsChar(newtype$check#5);
    assume JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#Z#0)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#Z#1);
    assume true;
    assume $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar));
    goto anon22;

  anon25_Else:
    assume {:partition} this != #JSON.Utils.Cursors.CursorError.ExpectingByte(_mcc#0#0, _mcc#1#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} this == #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(_mcc#2#0, _mcc#3#0);
    assume $Is(_mcc#2#0, TSeq(Tclass.BoundedInts.uint8()));
    assume LitInt(-1) <= _mcc#3#0 && _mcc#3#0 < BoundedInts.__default.TWO__TO__THE__8();
    havoc b#Z#0;
    assume LitInt(-1) <= b#Z#0 && b#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#1#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.opt__byte());
    assume b#Z#0 == let#1#0#0;
    havoc bs0#Z#0;
    assume $Is(bs0#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bs0#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume let#2#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#2#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume bs0#Z#0 == let#2#0#0;
    havoc c#Z#0;
    assume $Is(c#Z#0, TSeq(TChar)) && $IsAlloc(c#Z#0, TSeq(TChar), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} b#Z#0 > 0;
    newtype$check#1 := b#Z#0;
    assume char#IsChar(newtype$check#1);
    assume let#3#0#0 == Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#Z#0)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))));
    assume true;
    assume $Is(let#3#0#0, TSeq(TChar));
    goto anon12;

  anon28_Else:
    assume {:partition} 0 >= b#Z#0;
    assume let#3#0#0 == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(let#3#0#0, TSeq(TChar));
    goto anon12;

  anon12:
    assume c#Z#0 == let#3#0#0;
    havoc c0s#Z#0;
    assume $Is(c0s#Z#0, TSeq(TChar)) && $IsAlloc(c0s#Z#0, TSeq(TChar), $Heap);
    assume 0 <= Seq#Length(bs0#Z#0);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc idx#0;
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} LitInt(0) <= idx#0;
    goto anon16;

  anon31_Else:
    assume {:partition} idx#0 < LitInt(0);
    goto anon16;

  anon16:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} LitInt(0) <= idx#0 && idx#0 < Seq#Length(bs0#Z#0);
    assume 0 <= idx#0 && idx#0 < Seq#Length(bs0#Z#0);
    newtype$check#2 := $Unbox(Seq#Index(bs0#Z#0, idx#0)): int;
    assume char#IsChar(newtype$check#2);
    assume lambdaResult#0 == char#FromInt($Unbox(Seq#Index(bs0#Z#0, idx#0)): int);
    assume true;
    assume $Is(lambdaResult#0, TChar);
    goto anon18;

  anon32_Else:
    assume {:partition} !(LitInt(0) <= idx#0 && idx#0 < Seq#Length(bs0#Z#0));
    goto anon18;

  anon30_Else:
    assume {:partition} false;
    goto anon18;

  anon18:
    assume false;
    goto anon19;

  anon29_Else:
    goto anon19;

  anon19:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(bs0#Z#0) ==> Requires1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#Z#0, $Unbox($l#9#idx#0): int)): int))), (lambda $l#9#heap#0: Heap, $l#9#idx#0: Box :: $IsBox($l#9#idx#0, TInt) && LitInt(0) <= $Unbox($l#9#idx#0): int && $Unbox($l#9#idx#0): int < Seq#Length(bs0#Z#0)), (lambda $l#9#heap#0: Heap, $l#9#idx#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(bs0#Z#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#Z#0, $Unbox($l#9#idx#0): int)): int))), (lambda $l#9#heap#0: Heap, $l#9#idx#0: Box :: $IsBox($l#9#idx#0, TInt) && LitInt(0) <= $Unbox($l#9#idx#0): int && $Unbox($l#9#idx#0): int < Seq#Length(bs0#Z#0)), (lambda $l#9#heap#0: Heap, $l#9#idx#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume let#4#0#0 == Seq#Create(TChar, $Heap, Seq#Length(bs0#Z#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#Z#0, $Unbox($l#11#idx#0): int)): int))), (lambda $l#11#heap#0: Heap, $l#11#idx#0: Box :: $IsBox($l#11#idx#0, TInt) && LitInt(0) <= $Unbox($l#11#idx#0): int && $Unbox($l#11#idx#0): int < Seq#Length(bs0#Z#0)), (lambda $l#11#heap#0: Heap, $l#11#idx#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume $Is(let#4#0#0, TSeq(TChar));
    assume c0s#Z#0 == let#4#0#0;
    assume JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#Z#0);
    assume true;
    assume $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar));
    goto anon22;

  anon27_Else:
    assume {:partition} this != #JSON.Utils.Cursors.CursorError.ExpectingAnyByte(_mcc#2#0, _mcc#3#0);
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} this == #JSON.Utils.Cursors.CursorError.OtherError(_mcc#4#0);
    assume $IsBox(_mcc#4#0, JSON.Utils.Cursors.CursorError$R);
    havoc err#Z#0;
    assume $IsBox(err#Z#0, JSON.Utils.Cursors.CursorError$R) && $IsAllocBox(err#Z#0, JSON.Utils.Cursors.CursorError$R, $Heap);
    assume let#0#0#0 == _mcc#4#0;
    assume true;
    assume $IsBox(let#0#0#0, JSON.Utils.Cursors.CursorError$R);
    assume err#Z#0 == let#0#0#0;
    assume JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#Z#0)): Seq;
    assume true;
    assume $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar));
    goto anon22;

  anon33_Else:
    assume {:partition} this != #JSON.Utils.Cursors.CursorError.OtherError(_mcc#4#0);
    assume false;
    goto anon22;

  anon22:
    assume b$reqreads#0;
    return;
}



function #JSON.Utils.Cursors.Cursor_.Cursor(Seq, int, int, int) : DatatypeType;

const unique ##JSON.Utils.Cursors.Cursor_.Cursor: DtCtorId
uses {
axiom (forall a#0#0#0: Seq, a#0#1#0: int, a#0#2#0: int, a#0#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0) } DatatypeCtorId(#JSON.Utils.Cursors.Cursor_.Cursor(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0)) == ##JSON.Utils.Cursors.Cursor_.Cursor);
}

function JSON_mUtils_mCursors.Cursor__.Cursor_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Cursor_q(d) } JSON_mUtils_mCursors.Cursor__.Cursor_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Cursors.Cursor_.Cursor);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Cursor_q(d) } JSON_mUtils_mCursors.Cursor__.Cursor_q(d) ==> (exists a#1#0#0: Seq, a#1#1#0: int, a#1#2#0: int, a#1#3#0: int :: d == #JSON.Utils.Cursors.Cursor_.Cursor(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0)));

axiom (forall a#2#0#0: Seq, a#2#1#0: int, a#2#2#0: int, a#2#3#0: int :: { $Is(#JSON.Utils.Cursors.Cursor_.Cursor(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), Tclass.JSON_mUtils_mCursors.Cursor__()) } $Is(#JSON.Utils.Cursors.Cursor_.Cursor(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), Tclass.JSON_mUtils_mCursors.Cursor__()) <==> $Is(a#2#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#2#1#0, Tclass.BoundedInts.uint32()) && $Is(a#2#2#0, Tclass.BoundedInts.uint32()) && $Is(a#2#3#0, Tclass.BoundedInts.uint32()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.s(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.Cursor__.Cursor_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.s(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.beg(d), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.Cursor__.Cursor_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.beg(d), Tclass.BoundedInts.uint32(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.point(d), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.Cursor__.Cursor_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.point(d), Tclass.BoundedInts.uint32(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.end(d), Tclass.BoundedInts.uint32(), $h) } $IsGoodHeap($h) && JSON_mUtils_mCursors.Cursor__.Cursor_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.end(d), Tclass.BoundedInts.uint32(), $h));

axiom (forall a#3#0#0: Seq, a#3#1#0: int, a#3#2#0: int, a#3#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(Lit(a#3#0#0), LitInt(a#3#1#0), LitInt(a#3#2#0), LitInt(a#3#3#0)) } #JSON.Utils.Cursors.Cursor_.Cursor(Lit(a#3#0#0), LitInt(a#3#1#0), LitInt(a#3#2#0), LitInt(a#3#3#0)) == Lit(#JSON.Utils.Cursors.Cursor_.Cursor(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0)));

function JSON_mUtils_mCursors.Cursor__.s(DatatypeType) : Seq;

axiom (forall a#4#0#0: Seq, a#4#1#0: int, a#4#2#0: int, a#4#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0) } JSON_mUtils_mCursors.Cursor__.s(#JSON.Utils.Cursors.Cursor_.Cursor(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0)) == a#4#0#0);

axiom (forall a#5#0#0: Seq, a#5#1#0: int, a#5#2#0: int, a#5#3#0: int, i: int :: { Seq#Index(a#5#0#0, i), #JSON.Utils.Cursors.Cursor_.Cursor(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0) } 0 <= i && i < Seq#Length(a#5#0#0) ==> DtRank($Unbox(Seq#Index(a#5#0#0, i)): DatatypeType) < DtRank(#JSON.Utils.Cursors.Cursor_.Cursor(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0)));

axiom (forall a#6#0#0: Seq, a#6#1#0: int, a#6#2#0: int, a#6#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0) } Seq#Rank(a#6#0#0) < DtRank(#JSON.Utils.Cursors.Cursor_.Cursor(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0)));

function JSON_mUtils_mCursors.Cursor__.beg(DatatypeType) : int;

axiom (forall a#7#0#0: Seq, a#7#1#0: int, a#7#2#0: int, a#7#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0) } JSON_mUtils_mCursors.Cursor__.beg(#JSON.Utils.Cursors.Cursor_.Cursor(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0)) == a#7#1#0);

function JSON_mUtils_mCursors.Cursor__.point(DatatypeType) : int;

axiom (forall a#8#0#0: Seq, a#8#1#0: int, a#8#2#0: int, a#8#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0) } JSON_mUtils_mCursors.Cursor__.point(#JSON.Utils.Cursors.Cursor_.Cursor(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0)) == a#8#2#0);

function JSON_mUtils_mCursors.Cursor__.end(DatatypeType) : int;

axiom (forall a#9#0#0: Seq, a#9#1#0: int, a#9#2#0: int, a#9#3#0: int :: { #JSON.Utils.Cursors.Cursor_.Cursor(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0) } JSON_mUtils_mCursors.Cursor__.end(#JSON.Utils.Cursors.Cursor_.Cursor(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0)) == a#9#3#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mCursors.Cursor__(), $h));

function $IsA#JSON_mUtils_mCursors.Cursor__(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mCursors.Cursor__(d) } $IsA#JSON_mUtils_mCursors.Cursor__(d) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Cursor_q(d), $Is(d, Tclass.JSON_mUtils_mCursors.Cursor__()) } $Is(d, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(d));

function JSON_mUtils_mCursors.Cursor__#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.Cursor__#Equal(a, b) } JSON_mUtils_mCursors.Cursor__#Equal(a, b) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(a), JSON_mUtils_mCursors.Cursor__.s(b)) && JSON_mUtils_mCursors.Cursor__.beg(a) == JSON_mUtils_mCursors.Cursor__.beg(b) && JSON_mUtils_mCursors.Cursor__.point(a) == JSON_mUtils_mCursors.Cursor__.point(b) && JSON_mUtils_mCursors.Cursor__.end(a) == JSON_mUtils_mCursors.Cursor__.end(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mCursors.Cursor__#Equal(a, b) } JSON_mUtils_mCursors.Cursor__#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mCursors.Cursor__: ClassName;

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Valid? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.Valid_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.BOF? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.BOF_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mCursors.Cursor__.EOF_q(this: DatatypeType) : bool
uses {
axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.EOF_q(this): bool } JSON_mUtils_mCursors.Cursor__.EOF_q(this): bool <==> JSON_mUtils_mCursors.Cursor__.point(this) == JSON_mUtils_mCursors.Cursor__.end(this));
axiom 0 < $FunctionContextHeight ==> (forall $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.EOF_q($o) } $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Is(JSON_mUtils_mCursors.Cursor__.EOF_q($o), TBool));
axiom 0 < $FunctionContextHeight ==> (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.EOF_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.EOF_q($o), TBool, $h));
}

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.EOF? (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.EOF_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mCursors.Cursor__.OfView(v#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.OfView(v#0) } JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) || (3 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> $Is(JSON_mUtils_mCursors.Cursor__.OfView(v#0), Tclass.JSON_mUtils_mCursors.FreshCursor()));
axiom 3 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.OfView(v#0) } JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) || (3 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mCursors.Cursor__.OfView(v#0) == #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mViews_mCore.View__.s(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.end(v#0)));
axiom 3 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)) } JSON_mUtils_mCursors.Cursor__.OfView#canCall(Lit(v#0)) || (3 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)) == Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mViews_mCore.View__.s(Lit(v#0))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v#0))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v#0))), LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(v#0))))));
}

function JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.OfView#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.OfView#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mUtils_mCursors.Cursor__.OfView#requires(v#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.OfView (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.OfView(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.OfView (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.OfView(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.OfView", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(66,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.OfView(v#0), Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mViews_mCore.View__.View_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(v#0);
    assume $Is(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mViews_mCore.View__.s(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.end(v#0)), Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume JSON_mUtils_mCursors.Cursor__.OfView(v#0) == #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mViews_mCore.View__.s(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.end(v#0));
    assume JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.OfView(v#0), Tclass.JSON_mUtils_mCursors.FreshCursor());
    return;
}



function JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0: Seq) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) } JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(bs#0) || (3 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> $Is(JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0), Tclass.JSON_mUtils_mCursors.FreshCursor()));
axiom 3 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) } JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(bs#0) || (3 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) == #JSON.Utils.Cursors.Cursor_.Cursor(bs#0, LitInt(0), LitInt(0), Seq#Length(bs#0)));
axiom 3 <= $FunctionContextHeight ==> (forall bs#0: Seq :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.OfBytes(Lit(bs#0)) } JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(Lit(bs#0)) || (3 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.OfBytes(Lit(bs#0)) == #JSON.Utils.Cursors.Cursor_.Cursor(Lit(bs#0), LitInt(0), LitInt(0), Seq#Length(Lit(bs#0))));
}

function JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(bs#0: Seq) : bool;

function JSON_mUtils_mCursors.Cursor__.OfBytes#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { JSON_mUtils_mCursors.Cursor__.OfBytes#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mUtils_mCursors.Cursor__.OfBytes#requires(bs#0) <==> Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.OfBytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.OfBytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.OfBytes", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(70,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0), Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume false;
    return;

  anon4_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Is(#JSON.Utils.Cursors.Cursor_.Cursor(bs#0, LitInt(0), LitInt(0), Seq#Length(bs#0)), Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) == #JSON.Utils.Cursors.Cursor_.Cursor(bs#0, LitInt(0), LitInt(0), Seq#Length(bs#0));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0), Tclass.JSON_mUtils_mCursors.FreshCursor());
    return;
}



function JSON_mUtils_mCursors.Cursor__.Bytes(this: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Bytes(this) } JSON_mUtils_mCursors.Cursor__.Bytes#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $Is(JSON_mUtils_mCursors.Cursor__.Bytes(this), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Bytes(this) } JSON_mUtils_mCursors.Cursor__.Bytes#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Bytes(this) == Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.end(this)), JSON_mUtils_mCursors.Cursor__.beg(this)));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Bytes(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Bytes(Lit(this)) == Lit(Seq#Drop(Seq#Take(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))), LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))))));
}

function JSON_mUtils_mCursors.Cursor__.Bytes#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.Bytes#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Bytes#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.Bytes#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Bytes(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Bytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Bytes(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Bytes", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(76,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Bytes(this), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.beg(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.end(this) && JSON_mUtils_mCursors.Cursor__.end(this) <= Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume JSON_mUtils_mCursors.Cursor__.Bytes(this) == Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.end(this)), JSON_mUtils_mCursors.Cursor__.beg(this));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Bytes(this), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this: DatatypeType, other#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#0: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#0)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#0)): int } LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#0 && idx#0 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#0)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#0)): int)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0)))) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) && JSON_mUtils_mCursors.Cursor__.point(this) > JSON_mUtils_mCursors.Cursor__.point(other#0)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(Lit(this), Lit(other#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0))))) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(Lit(this), Lit(other#0)) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0))) && LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(other#0))) && JSON_mUtils_mCursors.Cursor__.point(Lit(this)) > JSON_mUtils_mCursors.Cursor__.point(Lit(other#0))));
}

function JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this: DatatypeType, other#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#requires(this, other#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#requires(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.StrictlyAdvancedFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), other#0: DatatypeType where $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor())) returns (b#0: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20231"} b#0 ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0);
  free ensures {:id "id20232"} b#0 ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int } LitInt(0) <= idx#1 && idx#1 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#1 && idx#1 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.StrictlyAdvancedFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this: DatatypeType, other#0: DatatypeType) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var idx#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.StrictlyAdvancedFrom?", " | ", this, " | ", other#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(82,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume b#0;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    assume $IsAllocBox($Box(other#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(other#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(other#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0);
    goto anon5;

  anon24_Else:
    assume b#0 ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0);
    goto anon5;

  anon5:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume b#0;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    assume JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    assume JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0);
    havoc idx#2;
    assume LitInt(0) <= idx#2 && idx#2 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#2;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    goto anon10;

  anon28_Else:
    assume {:partition} idx#2 < JSON_mUtils_mCursors.Cursor__.beg(this);
    goto anon10;

  anon10:
    assume JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#2 && idx#2 < JSON_mUtils_mCursors.Cursor__.point(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume 0 <= idx#2 && idx#2 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    assume 0 <= idx#2 && idx#2 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(other#0));
    assume $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#2)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#2)): int;
    goto anon12;

  anon27_Else:
    assume JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#2 && idx#2 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#2)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#2)): int;
    goto anon12;

  anon12:
    assume (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int } LitInt(0) <= idx#1 && idx#1 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#1 && idx#1 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int);
    goto anon15;

  anon26_Else:
    assume JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int } LitInt(0) <= idx#1 && idx#1 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#1 && idx#1 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int);
    goto anon15;

  anon25_Else:
    assume b#0 ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int } LitInt(0) <= idx#1 && idx#1 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#1 && idx#1 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#1)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#1)): int);
    goto anon15;

  anon15:
    assume false;
    return;

  anon23_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon18;

  anon29_Else:
    assume {:partition} !Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0));
    goto anon18;

  anon18:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon20;

  anon30_Else:
    assume {:partition} !(Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0));
    goto anon20;

  anon20:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon22;

  anon31_Else:
    assume {:partition} !(Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0));
    goto anon22;

  anon22:
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) && JSON_mUtils_mCursors.Cursor__.point(this) > JSON_mUtils_mCursors.Cursor__.point(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0))));
    assume $Is(JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0), TBool);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) <==> b#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this: DatatypeType, other#0: DatatypeType) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(this, other#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0)));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(Lit(this), Lit(other#0)) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(Lit(this)) && $IsA#JSON_mUtils_mCursors.Cursor__(Lit(other#0)) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(Lit(this), Lit(other#0))));
}

function JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(this: DatatypeType, other#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#requires(this, other#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#requires(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.AdvancedFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), other#0: DatatypeType where $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.AdvancedFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this: DatatypeType, other#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.AdvancedFrom?", " | ", this, " | ", other#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(96,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__#Equal(this, other#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := other#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0);
    goto anon5;

  anon7_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__#Equal(this, other#0);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0);
    assume $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0));
    assume $Is(JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this, other#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this: DatatypeType, other#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.Length(this) < JSON_mUtils_mCursors.Cursor__.Length(other#0));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0))) && (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0)));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(Lit(this), Lit(other#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) > JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)))) && (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0)) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) && JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) > JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0)) && LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(other#0)))));
}

function JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this: DatatypeType, other#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#requires(this, other#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#requires(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.StrictSuffixOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), other#0: DatatypeType where $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20255"} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.Length(this) < JSON_mUtils_mCursors.Cursor__.Length(other#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.StrictSuffixOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this: DatatypeType, other#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.StrictSuffixOf?", " | ", this, " | ", other#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(103,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := other#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume (JSON_mUtils_mCursors.Cursor__#Equal(this, this) && JSON_mUtils_mCursors.Cursor__#Equal(other#0, other#0)) || DtRank(this) < DtRank(this) || (DtRank(this) == DtRank(this) && DtRank(##other#0) < DtRank(other#0));
    assume (JSON_mUtils_mCursors.Cursor__#Equal(this, this) && JSON_mUtils_mCursors.Cursor__#Equal(other#0, other#0)) || JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(this);
    assume $IsAllocBox($Box(other#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Length(this) < JSON_mUtils_mCursors.Cursor__.Length(other#0);
    goto anon5;

  anon12_Else:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.Length(this) < JSON_mUtils_mCursors.Cursor__.Length(other#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon11_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon8;

  anon13_Else:
    assume {:partition} !Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0));
    goto anon8;

  anon8:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0);
    goto anon10;

  anon14_Else:
    assume {:partition} !(Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0));
    goto anon10;

  anon10:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0)));
    assume $Is(JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this: DatatypeType, other#0: DatatypeType) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(this, other#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0)));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SuffixOf_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(Lit(this), Lit(other#0)) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(Lit(this)) && $IsA#JSON_mUtils_mCursors.Cursor__(Lit(other#0)) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.SuffixOf_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0))));
}

function JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(this: DatatypeType, other#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.SuffixOf_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixOf_q#requires(this, other#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mUtils_mCursors.Cursor__.SuffixOf_q#requires(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SuffixOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), other#0: DatatypeType where $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SuffixOf? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this: DatatypeType, other#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SuffixOf?", " | ", this, " | ", other#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(113,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__#Equal(this, other#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := other#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0);
    goto anon5;

  anon7_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__#Equal(this, other#0);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0);
    assume $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0));
    assume $Is(JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this, other#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this: DatatypeType, other#0: DatatypeType) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this, other#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.BOF_q(this) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0)));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(this), Lit(other#0)) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (JSON_mUtils_mCursors.Cursor__.BOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__.BOF_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0))));
}

function JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this: DatatypeType, other#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#requires(this, other#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#requires(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.StrictlySplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), other#0: DatatypeType where $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.StrictlySplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this: DatatypeType, other#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.StrictlySplitFrom?", " | ", this, " | ", other#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(120,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := other#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0);
    goto anon5;

  anon7_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(this);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.BOF_q(this) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this: DatatypeType, other#0: DatatypeType) : bool
uses {
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(this, other#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0)));
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(Lit(this), Lit(other#0)) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(Lit(this)) && $IsA#JSON_mUtils_mCursors.Cursor__(Lit(other#0)) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(this), Lit(other#0))));
}

function JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(this: DatatypeType, other#0: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.SplitFrom_q#requires(DatatypeType, DatatypeType) : bool;

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SplitFrom_q#requires(this, other#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#requires(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), other#0: DatatypeType where $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SplitFrom? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this: DatatypeType, other#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SplitFrom?", " | ", this, " | ", other#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(127,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__#Equal(this, other#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := other#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this, other#0);
    goto anon5;

  anon7_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__#Equal(this, other#0);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0);
    assume $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this, other#0));
    assume $Is(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this, other#0), TBool);
    return;
}



function JSON_mUtils_mCursors.Cursor__.Prefix(this: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Prefix(this) } JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $Is(JSON_mUtils_mCursors.Cursor__.Prefix(this), Tclass.JSON_mUtils_mViews_mCore.View()));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Prefix(this) } JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Prefix(this) == #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), JSON_mUtils_mCursors.Cursor__.point(this)));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Prefix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Prefix#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Prefix(Lit(this)) == Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))))));
}

function JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.Prefix#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Prefix#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.Prefix#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Prefix (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Prefix(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Prefix (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Prefix(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Prefix", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(134,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Prefix(this), Tclass.JSON_mUtils_mViews_mCore.View());
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(#JSON.Utils.Views.Core.View_.View(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), JSON_mUtils_mCursors.Cursor__.point(this)), Tclass.JSON_mUtils_mViews_mCore.View());
    assume JSON_mUtils_mCursors.Cursor__.Prefix(this) == #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), JSON_mUtils_mCursors.Cursor__.point(this));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Prefix(this), Tclass.JSON_mUtils_mViews_mCore.View());
    return;
}



function JSON_mUtils_mCursors.Cursor__.Suffix(this: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $Is(JSON_mUtils_mCursors.Cursor__.Suffix(this), Tclass.JSON_mUtils_mCursors.Cursor()));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#0 := this; (var dt_update#beg#0#0 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), dt_update#beg#0#0, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#1 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#1 := Lit(this); (var dt_update#beg#0#1 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#1)), dt_update#beg#0#1, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#1)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#1)))))));
}

function JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.Suffix#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.Suffix#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Suffix (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Suffix(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Suffix (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Suffix(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#beg#0#Z#0: int;
  var let#1#0#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Suffix", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(138,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Suffix(this), Tclass.JSON_mUtils_mCursors.Cursor());
    assume false;
    return;

  anon4_Else:
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#0#0#0 == this;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#beg#0#Z#0;
    assume LitInt(0) <= dt_update#beg#0#Z#0 && dt_update#beg#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume let#1#0#0 == JSON_mUtils_mCursors.Cursor__.point(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#beg#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume $Is(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#Z#0), dt_update#beg#0#Z#0, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#Z#0), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.Suffix(this) == #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#Z#0), dt_update#beg#0#Z#0, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#Z#0), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Suffix(this), Tclass.JSON_mUtils_mCursors.Cursor());
    return;
}



function JSON_mUtils_mCursors.Cursor__.Split(this: DatatypeType) : DatatypeType
uses {
axiom 6 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || (6 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#0#v#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $IsBox($l#0#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#1#v#0): DatatypeType))), (lambda $l#1#heap#0: Heap, $l#1#v#0: Box :: $IsBox($l#1#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#1#heap#0: Heap, $l#1#v#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#2#v#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: $IsBox($l#2#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));
axiom 6 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || (6 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) && JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) && JSON_mUtils_mCursors.Cursor__.Split(this) == #JSON.Utils.Cursors.Split.SP($Box(JSON_mUtils_mCursors.Cursor__.Prefix(this)), JSON_mUtils_mCursors.Cursor__.Suffix(this)));
axiom 6 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Split(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(this)) || (6 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Prefix#canCall(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Split(Lit(this)) == Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(JSON_mUtils_mCursors.Cursor__.Prefix(Lit(this)))), Lit(JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this))))));
}

function JSON_mUtils_mCursors.Cursor__.Split#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.Split#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.Split#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Split (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Split(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap)) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20284"} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#3#v#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $IsBox($l#3#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#4#v#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $IsBox($l#4#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this));
  free ensures {:id "id20285"} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#3#v#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $IsBox($l#3#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#4#v#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $IsBox($l#4#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#5#v#0): DatatypeType))), (lambda $l#5#heap#0: Heap, $l#5#v#0: Box :: $IsBox($l#5#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#5#heap#0: Heap, $l#5#v#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#6#v#0): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: $IsBox($l#6#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(this), Seq#Append($Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#7#v#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: $IsBox($l#7#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#0)))));
  free ensures {:id "id20286"} JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#11#v#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $IsBox($l#11#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#0)));
  free ensures {:id "id20287"} JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#11#v#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $IsBox($l#11#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#0)), JSON_mUtils_mCursors.Cursor__.s(this))));
  free ensures {:id "id20288"} JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#11#v#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $IsBox($l#11#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#0)) > JSON_mUtils_mCursors.Cursor__.beg(this)));
  free ensures {:id "id20289"} JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#11#v#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $IsBox($l#11#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#0)) == JSON_mUtils_mCursors.Cursor__.end(this)));
  free ensures {:id "id20290"} JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#11#v#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: $IsBox($l#11#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#11#heap#0: Heap, $l#11#v#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#12#v#0): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: $IsBox($l#12#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#13#v#0): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#v#0: Box :: $IsBox($l#13#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#13#heap#0: Heap, $l#13#v#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(this), Seq#Append($Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#14#v#0): DatatypeType))), (lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: $IsBox($l#14#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#0)))));
  free ensures {:id "id20291"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#0)));
  free ensures {:id "id20292"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#0)), JSON_mUtils_mCursors.Cursor__.s(this))));
  free ensures {:id "id20293"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#0)) > JSON_mUtils_mCursors.Cursor__.beg(this)));
  free ensures {:id "id20294"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#0)) == JSON_mUtils_mCursors.Cursor__.end(this)));
  free ensures {:id "id20295"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#19#v#0): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: $IsBox($l#19#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#20#v#0): DatatypeType))), (lambda $l#20#heap#0: Heap, $l#20#v#0: Box :: $IsBox($l#20#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#20#heap#0: Heap, $l#20#v#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(this), Seq#Append($Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#21#v#0): DatatypeType))), (lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: $IsBox($l#21#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#0)))));
  free ensures {:id "id20296"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#0)), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20297"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#0)) > JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20298"} !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#0)) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20299"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(sp#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Split (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Split(this: DatatypeType) returns (sp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var v#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var $lambdaHeap#1: Heap;
  var v#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#2: Heap;
  var v#2: DatatypeType;
  var $_Frame#l2: [ref,Field]bool;
  var lambdaResult#2: Seq;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var ##other#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Split", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(142,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc v#0;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $lambdaHeap#0);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume lambdaResult#0 == JSON_mUtils_mViews_mCore.View__.Bytes(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon5;

  anon26_Else:
    assume {:partition} !($Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $lambdaHeap#0));
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon25_Else:
    goto anon6;

  anon6:
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##cs0#0 := this;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#25#v#0): DatatypeType))), (lambda $l#25#heap#0: Heap, $l#25#v#0: Box :: $IsBox($l#25#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#25#heap#0: Heap, $l#25#v#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#26#v#0): DatatypeType))), (lambda $l#26#heap#0: Heap, $l#26#v#0: Box :: $IsBox($l#26#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#26#heap#0: Heap, $l#26#v#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#27#v#0): DatatypeType))), (lambda $l#27#heap#0: Heap, $l#27#v#0: Box :: $IsBox($l#27#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#27#heap#0: Heap, $l#27#v#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))));
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this);
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc v#1;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} $Is(v#1, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(v#1), Tclass.JSON_mUtils_mViews_mCore.View__(), $lambdaHeap#1);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#1);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#1);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#1);
    assume lambdaResult#1 == JSON_mUtils_mViews_mCore.View__.Bytes(v#1);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#1);
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon10;

  anon29_Else:
    assume {:partition} !($Is(v#1, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $lambdaHeap#1));
    goto anon10;

  anon10:
    assume false;
    goto anon11;

  anon28_Else:
    goto anon11;

  anon11:
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##cs0#1 := this;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#29#v#0): DatatypeType))), (lambda $l#29#heap#0: Heap, $l#29#v#0: Box :: $IsBox($l#29#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#29#heap#0: Heap, $l#29#v#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#30#v#0): DatatypeType))), (lambda $l#30#heap#0: Heap, $l#30#v#0: Box :: $IsBox($l#30#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#30#heap#0: Heap, $l#30#v#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#31#v#0): DatatypeType))), (lambda $l#31#heap#0: Heap, $l#31#v#0: Box :: $IsBox($l#31#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#31#heap#0: Heap, $l#31#v#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))));
    goto anon13;

  anon27_Else:
    assume JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#32#v#0): DatatypeType))), (lambda $l#32#heap#0: Heap, $l#32#v#0: Box :: $IsBox($l#32#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#32#heap#0: Heap, $l#32#v#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))));
    goto anon13;

  anon13:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume !JSON_mUtils_mCursors.Cursor__.BOF_q(this);
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    goto anon31_Then, anon31_Else;

  anon31_Then:
    havoc $lambdaHeap#2;
    assume $IsGoodHeap($lambdaHeap#2);
    assume $Heap == $lambdaHeap#2 || $HeapSucc($Heap, $lambdaHeap#2);
    havoc v#2;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} $Is(v#2, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(v#2, Tclass.JSON_mUtils_mViews_mCore.View(), $lambdaHeap#2);
    $_Frame#l2 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#2, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(v#2), Tclass.JSON_mUtils_mViews_mCore.View__(), $lambdaHeap#2);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#2);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#2);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#2);
    assume lambdaResult#2 == JSON_mUtils_mViews_mCore.View__.Bytes(v#2);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#2);
    assume $Is(lambdaResult#2, TSeq(Tclass.BoundedInts.uint8()));
    goto anon17;

  anon32_Else:
    assume {:partition} !($Is(v#2, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(v#2, Tclass.JSON_mUtils_mViews_mCore.View(), $lambdaHeap#2));
    goto anon17;

  anon17:
    assume false;
    goto anon18;

  anon31_Else:
    goto anon18;

  anon18:
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##cs0#2 := this;
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#34#v#0): DatatypeType))), (lambda $l#34#heap#0: Heap, $l#34#v#0: Box :: $IsBox($l#34#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#34#heap#0: Heap, $l#34#v#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#35#v#0): DatatypeType))), (lambda $l#35#heap#0: Heap, $l#35#v#0: Box :: $IsBox($l#35#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#35#heap#0: Heap, $l#35#v#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))));
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#36#v#0): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#v#0: Box :: $IsBox($l#36#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#36#heap#0: Heap, $l#36#v#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), this);
    goto anon20;

  anon33_Else:
    assume {:partition} !JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#36#v#0): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#v#0: Box :: $IsBox($l#36#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#36#heap#0: Heap, $l#36#v#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))));
    goto anon20;

  anon20:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#37#v#0): DatatypeType))), (lambda $l#37#heap#0: Heap, $l#37#v#0: Box :: $IsBox($l#37#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#37#heap#0: Heap, $l#37#v#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this);
    goto anon22;

  anon30_Else:
    assume !JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), sp#0, this, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#38#v#0): DatatypeType))), (lambda $l#38#heap#0: Heap, $l#38#v#0: Box :: $IsBox($l#38#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#38#heap#0: Heap, $l#38#v#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), this);
    goto anon22;

  anon22:
    assume JSON_mUtils_mCursors.Split.SP_q(sp#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume false;
    return;

  anon24_Else:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this);
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mCursors.Cursor__.Prefix(this));
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Suffix(this));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Suffix(this), Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume JSON_mUtils_mCursors.Cursor__.Split(this) == #JSON.Utils.Cursors.Split.SP($Box(JSON_mUtils_mCursors.Cursor__.Prefix(this)), JSON_mUtils_mCursors.Cursor__.Suffix(this));
    assume JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) && JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Cursor__.Split(this) == sp#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.PrefixLength(this: DatatypeType) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.PrefixLength(this) } JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.PrefixLength(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength(this) < BoundedInts.__default.TWO__TO__THE__32());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.PrefixLength(this) } JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength(this) == JSON_mUtils_mCursors.Cursor__.point(this) - JSON_mUtils_mCursors.Cursor__.beg(this));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.PrefixLength(Lit(this)) } JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.PrefixLength(Lit(this)) == LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - JSON_mUtils_mCursors.Cursor__.beg(Lit(this))));
}

function JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.PrefixLength#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.PrefixLength#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.PrefixLength#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixLength (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.PrefixLength(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixLength (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.PrefixLength(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.PrefixLength", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(151,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mCursors.Cursor__.PrefixLength(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength(this) < BoundedInts.__default.TWO__TO__THE__32();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.point(this) - JSON_mUtils_mCursors.Cursor__.beg(this);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.PrefixLength(this) == JSON_mUtils_mCursors.Cursor__.point(this) - JSON_mUtils_mCursors.Cursor__.beg(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.PrefixLength(this), Tclass.BoundedInts.uint32());
    return;
}



function JSON_mUtils_mCursors.Cursor__.SuffixLength(this: DatatypeType) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixLength(this) } JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.SuffixLength(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < BoundedInts.__default.TWO__TO__THE__32());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixLength(this) } JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength(this) == JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.point(this));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SuffixLength(Lit(this)) } JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SuffixLength(Lit(this)) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)) - JSON_mUtils_mCursors.Cursor__.point(Lit(this))));
}

function JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.SuffixLength#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixLength#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.SuffixLength#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SuffixLength (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SuffixLength(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SuffixLength (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SuffixLength(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SuffixLength", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(155,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mCursors.Cursor__.SuffixLength(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < BoundedInts.__default.TWO__TO__THE__32();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.point(this);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength(this) == JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.point(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.SuffixLength(this), Tclass.BoundedInts.uint32());
    return;
}



function JSON_mUtils_mCursors.Cursor__.Length(this: DatatypeType) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Length(this) } JSON_mUtils_mCursors.Cursor__.Length#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.Length(this) && JSON_mUtils_mCursors.Cursor__.Length(this) < BoundedInts.__default.TWO__TO__THE__32());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Length(this) } JSON_mUtils_mCursors.Cursor__.Length#canCall(this) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Length(this) == JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.beg(this));
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Length(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(this)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Length(Lit(this)) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)) - JSON_mUtils_mCursors.Cursor__.beg(Lit(this))));
}

function JSON_mUtils_mCursors.Cursor__.Length#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.Length#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Length#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.Length#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Length(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Length (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Length(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Length", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(159,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mCursors.Cursor__.Length(this) && JSON_mUtils_mCursors.Cursor__.Length(this) < BoundedInts.__default.TWO__TO__THE__32();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.beg(this);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.Length(this) == JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.beg(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Length(this), Tclass.BoundedInts.uint32());
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(163,10): initial state"} true;
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(165,23): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.PrefixLength(this) + JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.Length(this) == JSON_mUtils_mCursors.Cursor__.PrefixLength(this) + JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (call precondtion)"} CallPre$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  requires {:id "id20340"} JSON_mUtils_mCursors.Cursor__.Valid_q(this);



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (call postcondition)"} CallPost$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mCursors.Cursor__.Length#canCall(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
  free ensures {:id "id20341"} JSON_mUtils_mCursors.Cursor__.Length(this) == JSON_mUtils_mCursors.Cursor__.PrefixLength(this) + JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (correctness)"} Impl$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id20342"} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
  modifies $Heap;
  free ensures JSON_mUtils_mCursors.Cursor__.Length#canCall(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
  free ensures {:id "id20343"} JSON_mUtils_mCursors.Cursor__.Length(this) == JSON_mUtils_mCursors.Cursor__.PrefixLength(this) + JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (correctness)"} Impl$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(166,4): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#this0#0: DatatypeType :: $Is($ih#this0#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q($ih#this0#0) && DtRank($ih#this0#0) < DtRank(this) ==> JSON_mUtils_mCursors.Cursor__.Length($ih#this0#0) == JSON_mUtils_mCursors.Cursor__.PrefixLength($ih#this0#0) + JSON_mUtils_mCursors.Cursor__.SuffixLength($ih#this0#0));
    $_reverifyPost := false;
    return;
}



function JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this: DatatypeType, idx#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0) } JSON_mUtils_mCursors.Cursor__.ValidIndex_q#canCall(this, idx#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && (JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0) <==> JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.ValidIndex_q(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.ValidIndex_q#canCall(Lit(this), LitInt(idx#0)) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && (JSON_mUtils_mCursors.Cursor__.ValidIndex_q(Lit(this), LitInt(idx#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(Lit(this)))));
}

function JSON_mUtils_mCursors.Cursor__.ValidIndex_q#canCall(this: DatatypeType, idx#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.ValidIndex_q#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.ValidIndex_q#requires(this, idx#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.ValidIndex_q#requires(this, idx#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.ValidIndex? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mCursors.Cursor__.At(this: DatatypeType, idx#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.At(this, idx#0) } JSON_mUtils_mCursors.Cursor__.At#canCall(this, idx#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.At(this, idx#0) && JSON_mUtils_mCursors.Cursor__.At(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.At(this, idx#0) } JSON_mUtils_mCursors.Cursor__.At#canCall(this, idx#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.At(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0)): int);
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.At(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.At#canCall(Lit(this), LitInt(idx#0)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Lit(JSON_mUtils_mCursors.Cursor__.ValidIndex_q(Lit(this), LitInt(idx#0)))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.At(Lit(this), LitInt(idx#0)) == $Unbox(Seq#Index(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) + idx#0))): int);
}

function JSON_mUtils_mCursors.Cursor__.At#canCall(this: DatatypeType, idx#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.At#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.At#requires(this, idx#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.At#requires(this, idx#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.At (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.At(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.At (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.At(this: DatatypeType, idx#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##idx#0: int;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.At", " | ", this, " | ", idx#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(172,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##idx#0 := idx#0;
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume JSON_mUtils_mCursors.Cursor__.ValidIndex_q#canCall(this, idx#0);
    assume JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mCursors.Cursor__.At(this, idx#0) && JSON_mUtils_mCursors.Cursor__.At(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0 && JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume JSON_mUtils_mCursors.Cursor__.At(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0)): int;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.At(this, idx#0), Tclass.BoundedInts.uint8());
    return;
}



function JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this: DatatypeType, idx#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0) } JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, idx#0) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && (JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0) <==> JSON_mUtils_mCursors.Cursor__.point(this) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(this)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(Lit(this), LitInt(idx#0)) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && (JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(Lit(this), LitInt(idx#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(Lit(this)))));
}

function JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this: DatatypeType, idx#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#requires(this, idx#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#requires(this, idx#0) <==> true));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.ValidSuffixIndex? (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mCursors.Cursor__.SuffixAt(this: DatatypeType, idx#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) } JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, idx#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8());
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) } JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, idx#0) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this) + idx#0)): int);
axiom 1 <= $FunctionContextHeight ==> (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(idx#0)) || (1 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Lit(JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(Lit(this), LitInt(idx#0)))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(idx#0)) == $Unbox(Seq#Index(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + idx#0))): int);
}

function JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this: DatatypeType, idx#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.SuffixAt#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.SuffixAt#requires(this, idx#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.SuffixAt#requires(this, idx#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SuffixAt (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SuffixAt(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SuffixAt (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SuffixAt(this: DatatypeType, idx#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##idx#0: int;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SuffixAt", " | ", this, " | ", idx#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(183,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##idx#0 := idx#0;
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, idx#0);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume LitInt(0) <= JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8();
    assume false;
    return;

  anon4_Else:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.point(this) + idx#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= JSON_mUtils_mCursors.Cursor__.point(this) + idx#0 && JSON_mUtils_mCursors.Cursor__.point(this) + idx#0 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this) + idx#0)): int;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0), Tclass.BoundedInts.uint8());
    return;
}



function JSON_mUtils_mCursors.Cursor__.Peek(this: DatatypeType) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Peek(this) } JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.Peek(this) < 0 <==> JSON_mUtils_mCursors.Cursor__.EOF_q(this)) && LitInt(-1) <= JSON_mUtils_mCursors.Cursor__.Peek(this) && JSON_mUtils_mCursors.Cursor__.Peek(this) < BoundedInts.__default.TWO__TO__THE__8());
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Peek(this) } JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0))) && JSON_mUtils_mCursors.Cursor__.Peek(this) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then -1 else JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then -1 else JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0))));
}

function JSON_mUtils_mCursors.Cursor__.Peek#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.Peek#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Peek#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.Peek#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Peek (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Peek(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap)) returns (r#0: int where LitInt(-1) <= r#0 && r#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20356"} r#0 < 0 <==> JSON_mUtils_mCursors.Cursor__.EOF_q(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Peek (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Peek(this: DatatypeType) returns (r#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##idx#0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Peek", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(190,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume LitInt(-1) <= JSON_mUtils_mCursors.Cursor__.Peek(this) && JSON_mUtils_mCursors.Cursor__.Peek(this) < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume r#0 < 0 <==> JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    newtype$check#1 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Cursor__.Peek(this) == LitInt(-1);
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.Peek(this), Tclass.BoundedInts.opt__byte());
    goto anon6;

  anon8_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, ##idx#0) ==> JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0) || JSON_mUtils_mCursors.Cursor__.point(this) + ##idx#0 < JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0));
    newtype$check#3 := JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0));
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0));
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Cursor__.Peek(this) == JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0));
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Peek(this), Tclass.BoundedInts.opt__byte());
    goto anon6;

  anon6:
    assume JSON_mUtils_mCursors.Cursor__.Peek(this) == r#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.LookingAt(this: DatatypeType, c#0: char) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) } JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(this, c#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c#0) < 256) ==> (JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0)) == char#ToInt(c#0)));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) } JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(this, c#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c#0) < 256) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) <==> JSON_mUtils_mCursors.Cursor__.Peek(this) == char#ToInt(c#0)));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, c#0: char :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.LookingAt(Lit(this), Lit(c#0)) } JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(Lit(this), Lit(c#0)) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && char#ToInt(Lit(c#0)) < 256) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mCursors.Cursor__.LookingAt(Lit(this), Lit(c#0)) <==> LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))) == char#ToInt(Lit(c#0))));
}

function JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(this: DatatypeType, c#0: char) : bool;

function JSON_mUtils_mCursors.Cursor__.LookingAt#requires(DatatypeType, char) : bool;

axiom (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mCursors.Cursor__.LookingAt#requires(this, c#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) ==> (JSON_mUtils_mCursors.Cursor__.LookingAt#requires(this, c#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c#0) < 256));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.LookingAt (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.LookingAt(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), c#0: char where $Is(c#0, TChar)) returns (b#0: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20369"} b#0 <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0)) == char#ToInt(c#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.LookingAt (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.LookingAt(this: DatatypeType, c#0: char) returns (b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##idx#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.LookingAt", " | ", this, " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "char"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(198,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume char#ToInt(c#0) < 256;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, ##idx#0) ==> JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0) || JSON_mUtils_mCursors.Cursor__.point(this) + ##idx#0 < JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0));
    newtype$check#1 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(c#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon4;

  anon7_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    goto anon4;

  anon4:
    assume b#0 <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0)) == char#ToInt(c#0);
    assume false;
    return;

  anon6_Else:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(this);
    newtype$check#3 := char#ToInt(c#0);
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(c#0);
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) <==> JSON_mUtils_mCursors.Cursor__.Peek(this) == char#ToInt(c#0);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(this);
    assume $Is(JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0), TBool);
    assume JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) <==> b#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.Skip(this: DatatypeType, n#0: int) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (n#0 == LitInt(0) ==> JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), this)) && (n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), this)) && $Is(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor()));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
axiom 3 <= $FunctionContextHeight ==> (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || (3 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#1 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#1 := Lit(this); (var dt_update#point#0#1 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#1)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#1)), dt_update#point#0#1, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#1)))))));
}

function JSON_mUtils_mCursors.Cursor__.Skip#canCall(this: DatatypeType, n#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.Skip#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip#requires(this, n#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.Skip#requires(this, n#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Skip (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Skip(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20383"} n#0 == LitInt(0) ==> JSON_mUtils_mCursors.Cursor__#Equal(ps#0, this);
  free ensures {:id "id20384"} n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(ps#0), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20385"} n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.beg(ps#0) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20386"} n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.end(ps#0) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20387"} n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.point(ps#0) > JSON_mUtils_mCursors.Cursor__.point(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Skip (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Skip(this: DatatypeType, n#0: int) returns (ps#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##other#0: DatatypeType;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#point#0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Skip", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(206,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon11_Then, anon11_Else;

  anon11_Then:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume n#0 == LitInt(0);
    assume JSON_mUtils_mCursors.Cursor__#Equal(ps#0, this);
    goto anon5;

  anon11_Else:
    assume n#0 == LitInt(0) ==> JSON_mUtils_mCursors.Cursor__#Equal(ps#0, this);
    goto anon5;

  anon5:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume n#0 > 0;
    assume $IsAllocBox($Box(ps#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
    goto anon8;

  anon12_Else:
    assume n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
    goto anon8;

  anon8:
    assume false;
    return;

  anon10_Else:
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#0#0#0 == this;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#point#0#Z#0;
    assume LitInt(0) <= dt_update#point#0#Z#0 && dt_update#point#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#2 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == JSON_mUtils_mCursors.Cursor__.point(this) + n#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume $Is(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#Z#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#Z#0), dt_update#point#0#Z#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#Z#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#Z#0), dt_update#point#0#Z#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == ps#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.Unskip(this: DatatypeType, n#0: int) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> $Is(JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor()));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || (2 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#1 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#1)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#1 := Lit(this); (var dt_update#point#0#1 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#1)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#1)), dt_update#point#0#1, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#1)))))));
}

function JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this: DatatypeType, n#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.Unskip#requires(DatatypeType, int) : bool;

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip#requires(this, n#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.Unskip#requires(this, n#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Unskip (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Unskip(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), n#0: int where LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Unskip (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Unskip(this: DatatypeType, n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#point#0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Unskip", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(215,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor());
    assume false;
    return;

  anon4_Else:
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#0#0#0 == this;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#point#0#Z#0;
    assume LitInt(0) <= dt_update#point#0#Z#0 && dt_update#point#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    newtype$check#0 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == JSON_mUtils_mCursors.Cursor__.point(this) - n#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume $Is(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#Z#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#Z#0), dt_update#point#0#Z#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#Z#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#Z#0), dt_update#point#0#Z#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor());
    return;
}



function JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) || (4 < $FunctionContextHeight && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && $IsAllocBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R, $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)), $Heap));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#0))) else #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))))));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), err#0) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), err#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), err#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#0))) else #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1)))))));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), Lit(err#0)) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), Lit(err#0)) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), Lit(err#0)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError(Lit(err#0))))) else #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1)))))));
}

function JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box) : bool;

function JSON_mUtils_mCursors.Cursor__.Get#requires(Ty, DatatypeType, Box) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { JSON_mUtils_mCursors.Cursor__.Get#requires(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) ==> (JSON_mUtils_mCursors.Cursor__.Get#requires(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.Get (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), err#0: Box where $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R)) returns (ppr#0: DatatypeType where $Is(ppr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20417"} Wrappers.Result.Success_q(ppr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20418"} Wrappers.Result.Success_q(ppr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.beg($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20419"} Wrappers.Result.Success_q(ppr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.end($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20420"} Wrappers.Result.Success_q(ppr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType) > JSON_mUtils_mCursors.Cursor__.point(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.Get (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box) returns (ppr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var newtype$check#0: int;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.Get", " | ", JSON.Utils.Cursors.Cursor_.Get$R, " | ", this, " | ", err#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "Box"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(222,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(ppr#0);
    assume Wrappers.Result.Success_q(ppr#0);
    assume $IsAllocBox(Wrappers.Result.value(ppr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this);
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(ppr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(ppr#0)): DatatypeType, this);
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) == #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#0)));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)));
    goto anon9;

  anon12_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##n#0 := LitInt(1);
    assume $IsAlloc(##n#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))));
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)));
    goto anon9;

  anon9:
    assume JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) == ppr#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0)) ==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this)) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0)) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this))): int == b#0) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || (4 < $FunctionContextHeight && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)), $Heap));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#0 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#0 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#0 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#0 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#0))))));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#1 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#1 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#1 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#1 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#1)))))));
}

function JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int) : bool;

function JSON_mUtils_mCursors.Cursor__.AssertByte#requires(Ty, DatatypeType, int) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte#requires(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mUtils_mCursors.Cursor__.AssertByte#requires(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.AssertByte (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), b#0: int where LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20434"} Wrappers.Result.Success_q(pr#0) ==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
  free ensures {:id "id20435"} Wrappers.Result.Success_q(pr#0) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this))): int == b#0;
  free ensures {:id "id20436"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20437"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.beg($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20438"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.end($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20439"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) > JSON_mUtils_mCursors.Cursor__.point(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.AssertByte (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var nxt#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.AssertByte", " | ", JSON.Utils.Cursors.Cursor_.AssertByte$R, " | ", this, " | ", b#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(230,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    goto anon5;

  anon17_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    goto anon5;

  anon5:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.point(this) && JSON_mUtils_mCursors.Cursor__.point(this) < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this))): int == b#0;
    goto anon8;

  anon18_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this))): int == b#0;
    goto anon8;

  anon8:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon11;

  anon19_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon11;

  anon11:
    assume false;
    return;

  anon16_Else:
    havoc nxt#Z#0;
    assume LitInt(-1) <= nxt#Z#0 && nxt#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(this);
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.Peek(this);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(this);
    assume $Is(let#0#0#0, Tclass.BoundedInts.opt__byte());
    assume nxt#Z#0 == let#0#0#0;
    newtype$check#0 := b#0;
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := b#0;
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} nxt#Z#0 == b#0;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    ##n#0 := LitInt(1);
    assume $IsAlloc(##n#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))));
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)));
    goto anon15;

  anon20_Else:
    assume {:partition} nxt#Z#0 != b#0;
    assume JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#Z#0)));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)));
    goto anon15;

  anon15:
    assume JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == pr#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#0: int :: { Seq#Contains(bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#0)) ==> b#0 < 256)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0))): DatatypeType, this)) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0)) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0))): DatatypeType, this)) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0)) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.point(this)), Seq#Drop(bs#0, offset#0))) && $Is(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || (5 < $FunctionContextHeight && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#0: int :: { Seq#Contains(bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#0)) ==> b#0 < 256))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#1: int :: { Seq#Contains(bs#0, $Box(b#1)) } LitInt(0) <= b#1 && b#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#1)) ==> b#1 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0) && (var ps#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#0, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#0) else (var ps#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#0, bs#0, offset#0 + 1))))));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#2: int :: { Seq#Contains(bs#0, $Box(b#2)) } LitInt(0) <= b#2 && b#2 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#2)) ==> b#2 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1) && (var ps#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#1, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#1) else (var ps#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#1, bs#0, offset#0 + 1))))));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#3: int :: { Seq#Contains(bs#0, $Box(b#3)) } LitInt(0) <= b#3 && b#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#3)) ==> b#3 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2) && (var ps#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#2, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#2) else (var ps#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#2, Lit(bs#0), LitInt(offset#0 + 1)))))));
}

function JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, this: DatatypeType, bs#0: Seq, offset#0: int) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, AsFuelBottom($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) == JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LZ, this, bs#0, offset#0));

function JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(Ty, LayerType, DatatypeType, Seq, int) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#1: int :: { Seq#Contains(bs#0, $Box(b#1)) } LitInt(0) <= b#1 && b#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#1)) ==> b#1 < 256)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.AssertBytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())), offset#0: int where LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20465"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__#Equal($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
  free ensures {:id "id20466"} Wrappers.Result.Success_q(pr#0) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20467"} Wrappers.Result.Success_q(pr#0) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.beg($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20468"} Wrappers.Result.Success_q(pr#0) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.end($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20469"} Wrappers.Result.Success_q(pr#0) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) > JSON_mUtils_mCursors.Cursor__.point(this);
  free ensures {:id "id20470"} Wrappers.Result.Success_q(pr#0) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.point(this)), Seq#Drop(bs#0, offset#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.AssertBytes (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, this: DatatypeType, bs#0: Seq, offset#0: int) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var b#4: int;
  var ##other#0: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var ##other#1: DatatypeType;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var ##b#0: int;
  var ps#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var ##bs#0: Seq;
  var ##offset#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.AssertBytes", " | ", JSON.Utils.Cursors.Cursor_.AssertBytes$R, " | ", this, " | ", bs#0, " | ", offset#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(241,30): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume offset#0 <= Seq#Length(bs#0);
    havoc b#4;
    assume LitInt(0) <= b#4 && b#4 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Seq#Contains(bs#0, $Box(b#4));
    assume b#4 < 256;
    goto anon4;

  anon21_Else:
    assume Seq#Contains(bs#0, $Box(b#4)) ==> b#4 < 256;
    goto anon4;

  anon4:
    assume (forall b#0: int :: { Seq#Contains(bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#0)) ==> b#0 < 256);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon8;

  anon23_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon8;

  anon8:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume Wrappers.Result.Success_q(pr#0);
    newtype$check#3 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#4 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    assume offset#0 < Seq#Length(bs#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#1 := this;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon11;

  anon24_Else:
    assume Wrappers.Result.Success_q(pr#0) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon11;

  anon11:
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.point(this) && JSON_mUtils_mCursors.Cursor__.point(this) <= Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume Wrappers.Result.Success_q(pr#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.point(this) <= JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) && JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) <= Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    assume 0 <= offset#0 && offset#0 <= Seq#Length(bs#0);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.point(this)), Seq#Drop(bs#0, offset#0));
    goto anon14;

  anon25_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.point(this)), Seq#Drop(bs#0, offset#0));
    goto anon14;

  anon14:
    assume false;
    return;

  anon22_Else:
    newtype$check#5 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#6 := Seq#Length(bs#0);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} offset#0 == Seq#Length(bs#0);
    assume $Is(#Wrappers.Result.Success($Box(this)), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0) == #Wrappers.Result.Success($Box(this));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    goto anon20;

  anon26_Else:
    assume {:partition} offset#0 != Seq#Length(bs#0);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume 0 <= offset#0 && offset#0 < Seq#Length(bs#0);
    newtype$check#7 := $Unbox(Seq#Index(bs#0, offset#0)): int;
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#8 := $Unbox(Seq#Index(bs#0, offset#0)): int;
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    ##b#0 := $Unbox(Seq#Index(bs#0, offset#0)): int;
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int);
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#Z#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    goto anon20;

  anon27_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0);
    havoc ps#Z#0;
    assume $Is(ps#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(ps#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume ps#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(ps#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#9 := LitInt(1);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#10 := offset#0 + 1;
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__32();
    ##bs#0 := bs#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##offset#0 := offset#0 + 1;
    assume $IsAlloc(##offset#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#Z#0);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume {:subsumption 0} ##offset#0 <= Seq#Length(##bs#0);
    assume ##offset#0 <= Seq#Length(##bs#0);
    assume {:subsumption 0} (forall b#5: int :: { Seq#Contains(##bs#0, $Box(b#5)) } LitInt(0) <= b#5 && b#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##bs#0, $Box(b#5)) ==> b#5 < 256);
    assume (forall b#5: int :: { Seq#Contains(##bs#0, $Box(b#5)) } LitInt(0) <= b#5 && b#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##bs#0, $Box(b#5)) ==> b#5 < 256);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.SuffixLength(this) || JSON_mUtils_mCursors.Cursor__.SuffixLength(ps#Z#0) == JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength(ps#Z#0) < JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#Z#0, bs#0, offset#0 + 1);
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0) == JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), ps#Z#0, bs#0, offset#0 + 1);
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#Z#0, bs#0, offset#0 + 1);
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)));
    goto anon20;

  anon20:
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($LZ), this, bs#0, offset#0) == pr#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) } JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) || (5 < $FunctionContextHeight && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R)), $Heap));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) } JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0)) && JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) == JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0)));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), Lit(c0#0)) } JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), Lit(c0#0)) || (5 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && char#ToInt(Lit(c0#0)) < 256) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), char#ToInt(Lit(c0#0))) && JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), Lit(c0#0)) == JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), char#ToInt(Lit(c0#0))));
}

function JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char) : bool;

function JSON_mUtils_mCursors.Cursor__.AssertChar#requires(Ty, DatatypeType, char) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { JSON_mUtils_mCursors.Cursor__.AssertChar#requires(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) ==> (JSON_mUtils_mCursors.Cursor__.AssertChar#requires(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.AssertChar (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), c0#0: char where $Is(c0#0, TChar)) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20530"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20531"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.beg($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20532"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.end($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20533"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(pr#0)): DatatypeType) > JSON_mUtils_mCursors.Cursor__.point(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.AssertChar (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##b#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.AssertChar", " | ", JSON.Utils.Cursors.Cursor_.AssertChar$R, " | ", this, " | ", c0#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "char"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(257,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume char#ToInt(c0#0) < 256;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R)));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := char#ToInt(c0#0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(c0#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##b#0 := char#ToInt(c0#0);
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0));
    assume JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) == JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0));
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0));
    assume $Is(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R)));
    assume JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) == pr#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.SkipByte(this: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SkipByte(this) } JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(this) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipByte(this), this) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipByte(this), this)) && $Is(JSON_mUtils_mCursors.Cursor__.SkipByte(this), Tclass.JSON_mUtils_mCursors.Cursor()));
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SkipByte(this) } JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(this) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipByte(this) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then this else JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))));
axiom 4 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipByte(Lit(this)) } JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(Lit(this)) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipByte(Lit(this)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then this else JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))));
}

function JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(this: DatatypeType) : bool;

function JSON_mUtils_mCursors.Cursor__.SkipByte#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SkipByte#requires(this) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> (JSON_mUtils_mCursors.Cursor__.SkipByte#requires(this) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipByte (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipByte(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap)) returns (ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20547"} JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__#Equal(ps#0, this) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
  free ensures {:id "id20548"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(ps#0), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20549"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.beg(ps#0) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20550"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.end(ps#0) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20551"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.point(ps#0) > JSON_mUtils_mCursors.Cursor__.point(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipByte (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipByte(this: DatatypeType) returns (ps#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##other#1: DatatypeType;
  var newtype$check#0: int;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipByte", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(265,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipByte(this), Tclass.JSON_mUtils_mCursors.Cursor());
    assume $IsAllocBox($Box(ps#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(ps#0, this);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(ps#0, this);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(ps#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#1 := this;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
    goto anon5;

  anon11_Else:
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.SkipByte(this) == this;
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipByte(this), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon9;

  anon12_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##n#0 := LitInt(1);
    assume $IsAlloc(##n#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume JSON_mUtils_mCursors.Cursor__.SkipByte(this) == JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipByte(this), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon9;

  anon9:
    assume JSON_mUtils_mCursors.Cursor__.SkipByte(this) == ps#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.SkipIf(this: DatatypeType, p#0: HandleType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(this, p#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), this) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), this)) && $Is(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(this, p#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool then this else JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(this), p#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), Lit(p#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(this), Lit(p#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), Lit(p#0)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))));
}

function JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(this: DatatypeType, p#0: HandleType) : bool;

function JSON_mUtils_mCursors.Cursor__.SkipIf#requires(DatatypeType, HandleType) : bool;

axiom (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipIf#requires(this, p#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) ==> (JSON_mUtils_mCursors.Cursor__.SkipIf#requires(this, p#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipIf (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipIf(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) returns (ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20569"} JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__#Equal(ps#0, this) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
  free ensures {:id "id20570"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(ps#0), JSON_mUtils_mCursors.Cursor__.s(this));
  free ensures {:id "id20571"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.beg(ps#0) == JSON_mUtils_mCursors.Cursor__.beg(this);
  free ensures {:id "id20572"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.end(ps#0) == JSON_mUtils_mCursors.Cursor__.end(this);
  free ensures {:id "id20573"} !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__.point(ps#0) > JSON_mUtils_mCursors.Cursor__.point(this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipIf (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipIf(this: DatatypeType, p#0: HandleType) returns (ps#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var newtype$check#0: int;
  var ##idx#0: int;
  var ##other#1: DatatypeType;
  var newtype$check#1: int;
  var ##idx#1: int;
  var newtype$check#2: int;
  var ##n#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipIf", " | ", this, " | ", p#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(275,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), Tclass.JSON_mUtils_mCursors.Cursor());
    assume $IsAllocBox($Box(ps#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(ps#0, this);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(ps#0, this);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, ##idx#0) ==> JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0) || JSON_mUtils_mCursors.Cursor__.point(this) + ##idx#0 < JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0));
    assume $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool;
    assume $IsAllocBox($Box(ps#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#1 := this;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(ps#0, this);
    assume JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
    goto anon5;

  anon13_Else:
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#1 := LitInt(0);
    assume $IsAlloc(##idx#1, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, ##idx#1) ==> JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#1) || JSON_mUtils_mCursors.Cursor__.point(this) + ##idx#1 < JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#1);
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0));
    goto anon8;

  anon14_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    goto anon8;

  anon8:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool;
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0) == this;
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon11;

  anon15_Else:
    assume {:partition} !(JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    ##n#0 := LitInt(1);
    assume $IsAlloc(##n#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0) == JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon11;

  anon11:
    assume JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0) == ps#0;
    return;
}



function JSON_mUtils_mCursors.Cursor__.SkipWhile($ly: LayerType, this: DatatypeType, p#0: HandleType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#0: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#0)): int } LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#0 && idx#0 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#0)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), this, p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool then this else JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0)));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(this), p#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), p#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), p#0)));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), Lit(p#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(this), Lit(p#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(p#0))) && JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), Lit(p#0)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(p#0))));
}

function JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this: DatatypeType, p#0: HandleType) : bool;

axiom (forall $ly: LayerType, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), this, p#0) } JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), this, p#0) == JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0));

axiom (forall $ly: LayerType, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile(AsFuelBottom($ly), this, p#0) } JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0) == JSON_mUtils_mCursors.Cursor__.SkipWhile($LZ, this, p#0));

function JSON_mUtils_mCursors.Cursor__.SkipWhile#requires(LayerType, DatatypeType, HandleType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile#requires($ly, this, p#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) ==> (JSON_mUtils_mCursors.Cursor__.SkipWhile#requires($ly, this, p#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) returns (ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20598"} JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(ps#0, this) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(ps#0, this) || JSON_mUtils_mCursors.Cursor__#Equal(ps#0, this) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(ps#0, this);
  free ensures {:id "id20599"} (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(ps#0), idx#1)): int } LitInt(0) <= idx#1 && idx#1 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#1 && idx#1 < JSON_mUtils_mCursors.Cursor__.point(ps#0) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(ps#0), idx#1)): int))): bool);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType, p#0: HandleType) returns (ps#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var idx#2: int;
  var newtype$check#0: int;
  var ##idx#0: int;
  var newtype$check#1: int;
  var ##n#0: int;
  var ##p#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhile", " | ", this, " | ", p#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(285,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0), Tclass.JSON_mUtils_mCursors.Cursor());
    assume $IsAllocBox($Box(ps#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(ps#0, this);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(ps#0, this);
    havoc idx#2;
    assume LitInt(0) <= idx#2 && idx#2 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.point(this) <= idx#2;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(ps#0);
    goto anon5;

  anon16_Else:
    assume {:partition} idx#2 < JSON_mUtils_mCursors.Cursor__.point(this);
    goto anon5;

  anon5:
    assume JSON_mUtils_mCursors.Cursor__.point(this) <= idx#2 && idx#2 < JSON_mUtils_mCursors.Cursor__.point(ps#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(ps#0);
    assume 0 <= idx#2 && idx#2 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(ps#0));
    assume $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(ps#0), idx#2)): int))): bool;
    goto anon7;

  anon15_Else:
    assume JSON_mUtils_mCursors.Cursor__.point(this) <= idx#2 && idx#2 < JSON_mUtils_mCursors.Cursor__.point(ps#0) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(ps#0), idx#2)): int))): bool;
    goto anon7;

  anon7:
    assume (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(ps#0), idx#1)): int } LitInt(0) <= idx#1 && idx#1 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#1 && idx#1 < JSON_mUtils_mCursors.Cursor__.point(ps#0) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(ps#0), idx#1)): int))): bool);
    assume false;
    return;

  anon14_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, ##idx#0) ==> JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0) || JSON_mUtils_mCursors.Cursor__.point(this) + ##idx#0 < JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, ##idx#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0));
    goto anon10;

  anon17_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    goto anon10;

  anon10:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool;
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0) == this;
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon13;

  anon18_Else:
    assume {:partition} !(JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#1 := LitInt(1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    ##n#0 := LitInt(1);
    assume $IsAlloc(##n#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##p#0 := p#0;
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume 0 <= JSON_mUtils_mCursors.Cursor__.SuffixLength(this) || JSON_mUtils_mCursors.Cursor__.SuffixLength(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))) == JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))) < JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0) == JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon13;

  anon13:
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0) == ps#0;
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (correctness)"} Impl$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap)) returns (defass#ps#0: bool, ps#0: DatatypeType where defass#ps#0 ==> $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap), $_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id20623"} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mCursors.Cursor__(ps#0) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
  free ensures {:id "id20624"} JSON_mUtils_mCursors.Cursor__#Equal(ps#0, JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), this, p#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (correctness)"} Impl$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType, p#0: HandleType) returns (defass#ps#0: bool, ps#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var point'#0: int where LitInt(0) <= point'#0 && point'#0 < BoundedInts.__default.TWO__TO__THE__32();
  var end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32();
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#ps#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#point#0#Z#0: int;
  var let#1#0#0: int;
  var dt_update_tmp#1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var dt_update#point#1#Z#0: int;
  var let#3#0#0: int;
  var ##p#1: HandleType;
  var ##p#2: HandleType;
  var $decr$loop#00: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhile", " | ", this, " | ", p#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(293,16): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    point'#0 := JSON_mUtils_mCursors.Cursor__.point(this);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(294,30)"} true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    end#0 := JSON_mUtils_mCursors.Cursor__.end(this);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(295,25)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#ps#0 := defass#ps#0;
    $decr_init$loop#00 := end#0 - point'#0;
    havoc $w$loop#0;
    goto anon10_LoopHead;

  anon10_LoopHead:
    assume $w$loop#0 ==> (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume $w$loop#0 ==> JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    assume $w$loop#0 ==> $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0)) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0)) && (var dt_update_tmp#1#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
    assume $w$loop#0 ==> JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0), JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), this, p#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#ps#0 ==> defass#ps#0;
    assume end#0 - point'#0 <= $decr_init$loop#00;
    goto anon10_LoopDone, anon10_LoopBody;

  anon10_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(296,6): after some loop iterations"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} !$w$loop#0;
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#0#0#0 == this;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#point#0#Z#0;
    assume LitInt(0) <= dt_update#point#0#Z#0 && dt_update#point#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == point'#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    havoc dt_update_tmp#1#Z#0;
    assume $Is(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#2#0#0 == this;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#1#Z#0 == let#2#0#0;
    havoc dt_update#point#1#Z#0;
    assume LitInt(0) <= dt_update#point#1#Z#0 && dt_update#point#1#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#3#0#0 == point'#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#1#Z#0 == let#3#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume $IsAllocBox($Box((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##p#1 := p#0;
    assume $IsAlloc(##p#1, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0));
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##p#2 := p#0;
    assume $IsAlloc(##p#2, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0));
    assume $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0)) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0)) && (var dt_update_tmp#1#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
    assume JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0), JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0));
    assume true;
    assume false;
    goto anon3;

  anon11_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} point'#0 < end#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume 0 <= point'#0 && point'#0 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    goto anon5;

  anon12_Else:
    assume {:partition} end#0 <= point'#0;
    goto anon5;

  anon5:
    assume point'#0 < end#0 ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} !(point'#0 < end#0 && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), point'#0)): int))): bool);
    goto anon8;

  anon13_Else:
    assume {:partition} point'#0 < end#0 && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), point'#0)): int))): bool;
    $decr$loop#00 := end#0 - point'#0;
    push;
    assume true;
    newtype$check#0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#0_1 := point'#0 + 1;
    assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    point'#0 := point'#0 + 1;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(300,28)"} true;
    pop;
    assume 0 <= $decr$loop#00 || end#0 - point'#0 == $decr$loop#00;
    assume end#0 - point'#0 < $decr$loop#00;
    assume (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && (JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0))))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0)) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0)) && (var dt_update_tmp#1#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), p#0) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0));
    goto anon10_LoopHead;

  anon10_LoopDone:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), point'#0, JSON_mUtils_mCursors.Cursor__.end(this)), Tclass.JSON_mUtils_mCursors.Cursor());
    ps#0 := #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), point'#0, JSON_mUtils_mCursors.Cursor__.end(this));
    defass#ps#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(302,55)"} true;
    assume defass#ps#0;
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
    return;
}



function JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || (4 < $FunctionContextHeight && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))));
axiom 4 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || (4 < $FunctionContextHeight && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#2 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#2)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#0 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#0)))) else (var st#1 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#1))))));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#4 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#4)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#2 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#2)))) else (var st#3 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#3))))));
axiom 4 <= $FunctionContextHeight ==> (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#6 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#6)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#4 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#4)))) else (var st#5 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#5))))));
}

function JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType, step#0: HandleType, st#0: Box) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, AsFuelBottom($ly), this, step#0, st#0) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LZ, this, step#0, st#0));

function JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#requires(Ty, Ty, LayerType, DatatypeType, HandleType, Box) : bool;

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#requires(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) ==> (JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#requires(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this)));

procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), step#0: HandleType where $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))), st#0: Box where $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A)) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20651"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__#Equal($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (well-formedness)"} CheckWellformed$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType, step#0: HandleType, st#0: Box) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var _mcc#3#0: Box;
  var st#Z#0: Box;
  var let#0#0#0: Box;
  var newtype$check#0: int;
  var ##n#0: int;
  var ##step#0: HandleType;
  var ##st#0: Box;
  var _mcc#2#0: Box;
  var err#Z#0: Box;
  var let#1#0#0: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhileLexer", " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, " | ", this, " | ", step#0, " | ", st#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "Box"} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(305,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $Is(this, Tclass.JSON_mUtils_mCursors.Cursor());
    ##other#0 := this;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon5;

  anon15_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, this);
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(this);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType == #JSON.Utils.Lexers.Core.LexerResult.Accept();
    assume $Is(#Wrappers.Result.Success($Box(this)), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0) == #Wrappers.Result.Success($Box(this));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    goto anon13;

  anon16_Else:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType != #JSON.Utils.Lexers.Core.LexerResult.Accept();
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType == #JSON.Utils.Lexers.Core.LexerResult.Reject(_mcc#2#0);
    assume $IsBox(_mcc#2#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R);
    havoc err#Z#0;
    assume $IsBox(err#Z#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R) && $IsAllocBox(err#Z#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $Heap);
    assume let#1#0#0 == _mcc#2#0;
    assume true;
    assume $IsBox(let#1#0#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R);
    assume err#Z#0 == let#1#0#0;
    assume $Is(#Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0) == #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#Z#0)));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    goto anon13;

  anon17_Else:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType != #JSON.Utils.Lexers.Core.LexerResult.Reject(_mcc#2#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType == #JSON.Utils.Lexers.Core.LexerResult.Partial(_mcc#3#0);
    assume $IsBox(_mcc#3#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A);
    havoc st#Z#0;
    assume $IsBox(st#Z#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#Z#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    assume let#0#0#0 == _mcc#3#0;
    assume true;
    assume $IsBox(let#0#0#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A);
    assume st#Z#0 == let#0#0#0;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $Is(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    assume true;
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    goto anon13;

  anon19_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##n#0 := LitInt(1);
    assume $IsAlloc(##n#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.point(this) + ##n#0 <= JSON_mUtils_mCursors.Cursor__.end(this);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##step#0 := step#0;
    assume $IsAlloc(##step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap);
    ##st#0 := st#Z#0;
    assume $IsAllocBox(##st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)));
    assume 0 <= JSON_mUtils_mCursors.Cursor__.SuffixLength(this) || JSON_mUtils_mCursors.Cursor__.SuffixLength(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))) == JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))) < JSON_mUtils_mCursors.Cursor__.SuffixLength(this);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#Z#0);
    assume $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    goto anon13;

  anon18_Else:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType != #JSON.Utils.Lexers.Core.LexerResult.Partial(_mcc#3#0);
    assume false;
    goto anon13;

  anon13:
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (correctness)"} Impl$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), step#0: HandleType where $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap), st#0: Box where $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap)) returns (defass#pr#0: bool, pr#0: DatatypeType where defass#pr#0 ==> $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap), $_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id20679"} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(pr#0) && $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
  free ensures {:id "id20680"} Wrappers.Result#Equal(pr#0, JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LS($LZ)), this, step#0, st#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (correctness)"} Impl$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType, step#0: HandleType, st#0: Box) returns (defass#pr#0: bool, pr#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var point'#0: int where LitInt(0) <= point'#0 && point'#0 < BoundedInts.__default.TWO__TO__THE__32();
  var end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32();
  var defass#st'#0: bool;
  var st'#0: Box where defass#st'#0 ==> $IsBox(st'#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st'#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#pr#0: bool;
  var preLoop$loop#0$defass#st'#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#point#0#Z#0: int;
  var let#1#0#0: int;
  var dt_update_tmp#1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var dt_update#point#1#Z#0: int;
  var let#3#0#0: int;
  var ##step#1: HandleType;
  var ##st#1: Box;
  var ##step#2: HandleType;
  var ##st#2: Box;
  var dt_update_tmp#2#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var dt_update#point#2#Z#0: int;
  var let#5#0#0: int;
  var $decr$loop#00: int;
  var eof#0: bool;
  var minusone#0: int where LitInt(-1) <= minusone#0 && minusone#0 < BoundedInts.__default.TWO__TO__THE__8();
  var newtype$check#0_0: int;
  var c#0: int where LitInt(-1) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var _mcc#1#0: Box;
  var st''#0: Box;
  var let#0_0_0#0#0: Box;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var _mcc#0#0: Box;
  var err#6: Box;
  var let#0_1_0#0#0: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhileLexer", " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, " | ", this, " | ", step#0, " | ", st#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(317,16): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    point'#0 := JSON_mUtils_mCursors.Cursor__.point(this);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(318,25)"} true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    end#0 := JSON_mUtils_mCursors.Cursor__.end(this);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(319,25)"} true;
    assume true;
    assume true;
    st'#0 := st#0;
    defass#st'#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(320,19)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#pr#0 := defass#pr#0;
    preLoop$loop#0$defass#st'#0 := defass#st'#0;
    $decr_init$loop#00 := JSON_mUtils_mCursors.Cursor__.SuffixLength((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0)))));
    havoc $w$loop#0;
    goto anon17_LoopHead;

  anon17_LoopHead:
    assume $w$loop#0 ==> (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume $w$loop#0 ==> JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    assume $w$loop#0 ==> $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0)) && $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0)) && (var dt_update_tmp#1#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    assume $w$loop#0 ==> Wrappers.Result#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LS($LZ)), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0), JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LS($LZ)), this, step#0, st#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#pr#0 ==> defass#pr#0;
    assume preLoop$loop#0$defass#st'#0 ==> defass#st'#0;
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0))))) <= $decr_init$loop#00;
    goto anon17_LoopDone, anon17_LoopBody;

  anon17_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(321,6): after some loop iterations"} true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} !$w$loop#0;
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#0#0#0 == this;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#point#0#Z#0;
    assume LitInt(0) <= dt_update#point#0#Z#0 && dt_update#point#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == point'#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    havoc dt_update_tmp#1#Z#0;
    assume $Is(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#2#0#0 == this;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#1#Z#0 == let#2#0#0;
    havoc dt_update#point#1#Z#0;
    assume LitInt(0) <= dt_update#point#1#Z#0 && dt_update#point#1#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#3#0#0 == point'#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#1#Z#0 == let#3#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume $IsAllocBox($Box((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume defass#st'#0;
    ##step#1 := step#0;
    assume $IsAlloc(##step#1, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap);
    ##st#1 := st'#0;
    assume $IsAllocBox(##st#1, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##step#2 := step#0;
    assume $IsAlloc(##step#2, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap);
    ##st#2 := st#0;
    assume $IsAllocBox(##st#2, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    assume $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0)) && $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0)) && (var dt_update_tmp#1#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    assume Wrappers.Result#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0), JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0));
    havoc dt_update_tmp#2#Z#0;
    assume $Is(dt_update_tmp#2#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(dt_update_tmp#2#Z#0, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume let#4#0#0 == this;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Cursor__());
    assume dt_update_tmp#2#Z#0 == let#4#0#0;
    havoc dt_update#point#2#Z#0;
    assume LitInt(0) <= dt_update#point#2#Z#0 && dt_update#point#2#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#5#0#0 == point'#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#2#Z#0 == let#5#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#2#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#2#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#2#Z#0);
    assume $IsAllocBox($Box((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0)))));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0)))));
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0)))));
    assume (var dt_update_tmp#2#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#2#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#2#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#2#0)) && JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0)))));
    assume false;
    goto anon3;

  anon18_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} !Lit(true);
    goto anon16;

  anon19_Else:
    assume {:partition} Lit(true);
    $decr$loop#00 := JSON_mUtils_mCursors.Cursor__.SuffixLength((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0)))));
    assume true;
    assume true;
    eof#0 := point'#0 == end#0;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(326,32)"} true;
    assume true;
    newtype$check#0_0 := LitInt(-1);
    assume LitInt(-1) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    minusone#0 := LitInt(-1);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(327,36)"} true;
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} eof#0;
    goto anon8;

  anon20_Else:
    assume {:partition} !eof#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume 0 <= point'#0 && point'#0 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(this));
    newtype$check#0_1 := $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), point'#0)): int;
    assume LitInt(-1) <= newtype$check#0_1 && newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_2 := $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), point'#0)): int;
    assume LitInt(-1) <= newtype$check#0_2 && newtype$check#0_2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon8;

  anon8:
    assume !eof#0 ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    c#0 := (if eof#0 then minusone#0 else $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), point'#0)): int);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(328,69)"} true;
    assume defass#st'#0;
    assume true;
    havoc _mcc#1#0;
    havoc _mcc#0#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st'#0, $Box(c#0))): DatatypeType == #JSON.Utils.Lexers.Core.LexerResult.Accept();
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this);
    assume $Is(#Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), point'#0, JSON_mUtils_mCursors.Cursor__.end(this)))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)));
    pr#0 := #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), point'#0, JSON_mUtils_mCursors.Cursor__.end(this))));
    defass#pr#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(330,81)"} true;
    assume defass#pr#0;
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    return;

  anon21_Else:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st'#0, $Box(c#0))): DatatypeType != #JSON.Utils.Lexers.Core.LexerResult.Accept();
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st'#0, $Box(c#0))): DatatypeType == #JSON.Utils.Lexers.Core.LexerResult.Reject(_mcc#0#0);
    assume $IsBox(_mcc#0#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R) && $IsAllocBox(_mcc#0#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $Heap);
    havoc err#6;
    assume $IsBox(err#6, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R) && $IsAllocBox(err#6, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $Heap);
    assume let#0_1_0#0#0 == _mcc#0#0;
    assume true;
    assume $IsBox(let#0_1_0#0#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R);
    assume err#6 == let#0_1_0#0#0;
    assume true;
    assume true;
    pr#0 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#6)));
    defass#pr#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(331,59)"} true;
    assume defass#pr#0;
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    return;

  anon22_Else:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st'#0, $Box(c#0))): DatatypeType != #JSON.Utils.Lexers.Core.LexerResult.Reject(_mcc#0#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st'#0, $Box(c#0))): DatatypeType == #JSON.Utils.Lexers.Core.LexerResult.Partial(_mcc#1#0);
    assume $IsBox(_mcc#1#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(_mcc#1#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    havoc st''#0;
    assume $IsBox(st''#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st''#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    assume let#0_0_0#0#0 == _mcc#1#0;
    assume true;
    assume $IsBox(let#0_0_0#0#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A);
    assume st''#0 == let#0_0_0#0#0;
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} eof#0;
    assume true;
    assume true;
    pr#0 := Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    defass#pr#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(333,38)"} true;
    assume defass#pr#0;
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    return;

  anon24_Else:
    assume {:partition} !eof#0;
    assume true;
    assume true;
    st'#0 := st''#0;
    defass#st'#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(334,28)"} true;
    assume true;
    newtype$check#0_0_1_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0_1_0 && newtype$check#0_0_1_0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#0_0_1_1 := point'#0 + 1;
    assume LitInt(0) <= newtype$check#0_0_1_1 && newtype$check#0_0_1_1 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    point'#0 := point'#0 + 1;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(334,50)"} true;
    goto anon15;

  anon23_Else:
    assume {:partition} $Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st'#0, $Box(c#0))): DatatypeType != #JSON.Utils.Lexers.Core.LexerResult.Partial(_mcc#1#0);
    assume false;
    goto anon15;

  anon15:
    assume 0 <= $decr$loop#00 || JSON_mUtils_mCursors.Cursor__.SuffixLength((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0))))) == $decr$loop#00;
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength((var dt_update_tmp#2#0 := this; (var dt_update#point#2#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#2#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#2#0), dt_update#point#2#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#2#0))))) < $decr$loop#00;
    assume (var dt_update_tmp#0#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && (JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := this; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0))))) ==> $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0)) && $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0)) && (var dt_update_tmp#1#0 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, (var dt_update_tmp#1#0 := this; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), step#0, st'#0) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0));
    goto anon17_LoopHead;

  anon17_LoopDone:
    assume {:partition} false;
    goto anon16;

  anon16:
    assume defass#pr#0;
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap)) returns (ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType, p#0: HandleType) returns (ps#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##p#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhile", " | ", this, " | ", p#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(285,13): initial state"} true;
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc ps#0;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(293,6): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##p#0 := p#0;
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0));
    assume JSON_mUtils_mCursors.Cursor__#Equal(ps#0, JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0));
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (call precondtion)"} CallPre$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap));
  requires {:id "id20734"} JSON_mUtils_mCursors.Cursor__.Valid_q(this);



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (call postcondition)"} CallPost$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), p#0: HandleType where $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap)) returns (ps#0: DatatypeType where $Is(ps#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(ps#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap));
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mCursors.Cursor__(ps#0) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), this, p#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0);
  free ensures {:id "id20735"} JSON_mUtils_mCursors.Cursor__#Equal(ps#0, JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), this, p#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), step#0: HandleType where $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap), st#0: Box where $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap)) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (well-formedness)"} CheckWellFormed$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType, step#0: HandleType, st#0: Box) returns (pr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##step#0: HandleType;
  var ##st#0: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhileLexer", " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, " | ", this, " | ", step#0, " | ", st#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(305,13): initial state"} true;
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc pr#0;
    assume {:captureState "libraries/src/JSON/Utils/Cursors.dfy(317,6): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##step#0 := step#0;
    assume $IsAlloc(##step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap);
    ##st#0 := st#0;
    assume $IsAllocBox(##st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(this);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    assume Wrappers.Result#Equal(pr#0, JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0));
    return;
}



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (call precondtion)"} CallPre$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), step#0: HandleType where $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap), st#0: Box where $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap));
  requires {:id "id20768"} JSON_mUtils_mCursors.Cursor__.Valid_q(this);



procedure {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (call postcondition)"} CallPost$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap), step#0: HandleType where $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap), st#0: Box where $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap)) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(pr#0) && $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LZ), this, step#0, st#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
  free ensures {:id "id20769"} Wrappers.Result#Equal(pr#0, JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($LS($LZ)), this, step#0, st#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#148 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#148))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#150 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#150)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#222 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#222))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#224 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#224)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#226 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#226)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#222 := Wrappers.Option.value(this); v#222)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#224 := Lit(Wrappers.Option.value(Lit(this))); v#224)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#226 := Lit(Wrappers.Option.value(Lit(this))); v#226)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#148 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#148)) else (var e#148 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#150 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#150))) else (var e#150 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#222 := Wrappers.Result.value(this); s#222) else (var e#222 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#224 := Lit(Wrappers.Result.value(Lit(this))); s#224) else (var e#224 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#226 := Lit(Wrappers.Result.value(Lit(this))); s#226) else (var e#226 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#222 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#222)) else (var e#222 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#222)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#224 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#224))) else (var e#224 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#224)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#226 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#226))) else (var e#226 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#226)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#4 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#4) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#4)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#4 := lv#0; (var dt_update#end#0#4 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#4), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#4), dt_update#end#0#4))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#5 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#5) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#5)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#5 := Lit(lv#0); (var dt_update#end#0#5 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#5)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#5)), dt_update#end#0#5)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#6: char :: { Seq#Contains(s#0, $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(s#0, $Box(c#6)) ==> char#ToInt(c#6) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#6: char :: { Seq#Contains(s#0, $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(s#0, $Box(c#6)) ==> char#ToInt(c#6) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#12#i#0): int)): char))), (lambda $l#12#heap#0: Heap, $l#12#i#0: Box :: $IsBox($l#12#i#0, TInt) && LitInt(0) <= $Unbox($l#12#i#0): int && $Unbox($l#12#i#0): int < Seq#Length(s#0)), (lambda $l#12#heap#0: Heap, $l#12#i#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#7: char :: { Seq#Contains(s#0, $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(s#0, $Box(c#7)) ==> char#ToInt(c#7) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#14#i#0): int)): char))), (lambda $l#14#heap#0: Heap, $l#14#i#0: Box :: $IsBox($l#14#i#0, TInt) && LitInt(0) <= $Unbox($l#14#i#0): int && $Unbox($l#14#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#14#heap#0: Heap, $l#14#i#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))));

const unique tytagFamily$Split: TyTagFamily;

const unique tytagFamily$FreshCursor: TyTagFamily;

const unique tytagFamily$Cursor: TyTagFamily;

const unique tytagFamily$Cursor_: TyTagFamily;

const unique tytagFamily$CursorError: TyTagFamily;

const reveal_JSON.Utils.Parsers._default.ParserWitness: bool;

const reveal_JSON.Utils.Parsers._default.SubParserWitness: bool;

const unique class.JSON_mUtils_mParsers.__default: ClassName;

function JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty, $reveal: bool) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty, $reveal: bool :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal) } JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R) || 2 < $FunctionContextHeight ==> JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal)) && $Is(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty, $reveal: bool :: { $IsAlloc(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R), $Heap) } (JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R) || 2 < $FunctionContextHeight) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R) || 2 < $FunctionContextHeight ==> JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $IsBox($l#0#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#1#heap#0: Heap, $l#1#_v1#0: Box :: $IsBox($l#1#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#1#heap#0: Heap, $l#1#_v1#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R) || 2 < $FunctionContextHeight ==> JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#4#heap#0: Heap, $l#4#_v0#0: Box :: $IsBox($l#4#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#4#heap#0: Heap, $l#4#_v0#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#5#heap#0: Heap, $l#5#_v1#0: Box :: $IsBox($l#5#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#5#heap#0: Heap, $l#5#_v1#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))))));
}

function JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty) : bool;

function Tclass.JSON_mUtils_mParsers.Parser__(Ty, Ty) : Ty;

const unique Tagclass.JSON_mUtils_mParsers.Parser__: TyTag;

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty :: { Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R) } Tag(Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) == Tagclass.JSON_mUtils_mParsers.Parser__ && TagFamily(Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) == tytagFamily$Parser_);

function Tclass.JSON_mUtils_mParsers.Parser___0(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty :: { Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R) } Tclass.JSON_mUtils_mParsers.Parser___0(Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) == JSON.Utils.Parsers.Parser_$T);

function Tclass.JSON_mUtils_mParsers.Parser___1(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty :: { Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R) } Tclass.JSON_mUtils_mParsers.Parser___1(Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) == JSON.Utils.Parsers.Parser_$R);

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) } $IsBox(bx, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)));

function JSON_mUtils_mParsers.__default.ParserWitness#requires(Ty, Ty) : bool;

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness#requires(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R) } JSON_mUtils_mParsers.__default.ParserWitness#requires(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R) <==> true);

procedure {:verboseName "JSON.Utils.Parsers.ParserWitness (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty) returns (p#0: DatatypeType where $Is(p#0, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20828"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, p#0) ==> JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, p#0) || (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.ParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.ParserWitness$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#0), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.ParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.ParserWitness$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#0), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers._default.ParserWitness$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.ParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.ParserWitness$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#0), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(p#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Parsers.ParserWitness (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty) returns (p#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var _v0#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var $lambdaHeap#1: Heap;
  var _v1#0: Box;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Parsers.ParserWitness", " | ", JSON.Utils.Parsers._default.ParserWitness$T, " | ", JSON.Utils.Parsers._default.ParserWitness$R} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty"} true;
    assume {:captureState "libraries/src/JSON/Utils/Parsers.dfy(26,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, reveal_JSON.Utils.Parsers._default.ParserWitness), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R));
    assume $IsAllocBox($Box(p#0), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, p#0);
    assume JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, p#0);
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc _v0#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Is(_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    assume true;
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.ParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.ParserWitness$R)));
    goto anon6;

  anon14_Else:
    assume {:partition} !($Is(_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon13_Else:
    goto anon7;

  anon7:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc _v1#0;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} $IsBox(_v1#0, JSON.Utils.Parsers._default.ParserWitness$T) && $IsAllocBox(_v1#0, JSON.Utils.Parsers._default.ParserWitness$T, $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    assume lambdaResult#1 == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon10;

  anon16_Else:
    assume {:partition} !($IsBox(_v1#0, JSON.Utils.Parsers._default.ParserWitness$T) && $IsAllocBox(_v1#0, JSON.Utils.Parsers._default.ParserWitness$T, $lambdaHeap#1));
    goto anon10;

  anon10:
    assume false;
    goto anon11;

  anon15_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, reveal_JSON.Utils.Parsers._default.ParserWitness) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: $IsBox($l#12#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#13#heap#0: Heap, $l#13#_v1#0: Box :: $IsBox($l#13#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#13#heap#0: Heap, $l#13#_v1#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume true;
    assume $Is(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, reveal_JSON.Utils.Parsers._default.ParserWitness), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R));
    assume JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, reveal_JSON.Utils.Parsers._default.ParserWitness) == p#0;
    return;
}



function JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty, $reveal: bool) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty, $reveal: bool :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal) } JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R) || 2 < $FunctionContextHeight ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal)) && $Is(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty, $reveal: bool :: { $IsAlloc(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R), $Heap) } (JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R) || 2 < $FunctionContextHeight) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R) || 2 < $FunctionContextHeight ==> JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#cs#0: Box :: $Box(Lit(false))), (lambda $l#0#heap#0: Heap, $l#0#cs#0: Box :: $IsBox($l#0#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#0#heap#0: Heap, $l#0#cs#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#1#heap#0: Heap, $l#1#cs#0: Box :: $IsBox($l#1#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#1#heap#0: Heap, $l#1#cs#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#2#heap#0: Heap, $l#2#_v2#0: Box :: $IsBox($l#2#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#2#heap#0: Heap, $l#2#_v2#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))));
axiom 2 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R) || 2 < $FunctionContextHeight ==> JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#cs#0: Box :: $Box(Lit(false))), (lambda $l#6#heap#0: Heap, $l#6#cs#0: Box :: $IsBox($l#6#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#6#heap#0: Heap, $l#6#cs#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#7#heap#0: Heap, $l#7#cs#0: Box :: $IsBox($l#7#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#7#heap#0: Heap, $l#7#cs#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#8#heap#0: Heap, $l#8#_v2#0: Box :: $IsBox($l#8#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#8#heap#0: Heap, $l#8#_v2#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))))));
}

function JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty) : bool;

function Tclass.JSON_mUtils_mParsers.SubParser__(Ty, Ty) : Ty;

const unique Tagclass.JSON_mUtils_mParsers.SubParser__: TyTag;

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty :: { Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R) } Tag(Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) == Tagclass.JSON_mUtils_mParsers.SubParser__ && TagFamily(Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) == tytagFamily$SubParser_);

function Tclass.JSON_mUtils_mParsers.SubParser___0(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty :: { Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R) } Tclass.JSON_mUtils_mParsers.SubParser___0(Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) == JSON.Utils.Parsers.SubParser_$T);

function Tclass.JSON_mUtils_mParsers.SubParser___1(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty :: { Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R) } Tclass.JSON_mUtils_mParsers.SubParser___1(Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) == JSON.Utils.Parsers.SubParser_$R);

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) } $IsBox(bx, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)));

function JSON_mUtils_mParsers.__default.SubParserWitness#requires(Ty, Ty) : bool;

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness#requires(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R) } JSON_mUtils_mParsers.__default.SubParserWitness#requires(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R) <==> true);

procedure {:verboseName "JSON.Utils.Parsers.SubParserWitness (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty) returns (subp#0: DatatypeType where $Is(subp#0, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20834"} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0) || (forall cs'#0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.SubParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.SubParserWitness$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(subp#0), $Box(cs'#0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(subp#0), $Box(cs'#0))): bool } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(subp#0), $Box(cs'#0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.SubParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.SubParserWitness$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(subp#0), $Box(cs'#0)));
  free ensures {:id "id20835"} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0) || (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(subp#0), $Box(cs'#1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(subp#0)) } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(subp#0)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(subp#0), $Box(cs'#1))): bool);
  free ensures {:id "id20836"} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0) || (forall cs'#2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.SubParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.SubParserWitness$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(subp#0), $Box(cs'#2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(subp#0), $Box(cs'#2))): bool } $Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(subp#0), $Box(cs'#2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.SubParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.SubParserWitness$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(subp#0), $Box(cs'#2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers._default.SubParserWitness$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.SubParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.SubParserWitness$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(subp#0), $Box(cs'#2))): DatatypeType)): DatatypeType, cs'#2, JSON_mUtils_mParsers.SubParser__.spec(subp#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Parsers.SubParserWitness (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty) returns (subp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var $lambdaHeap#0: Heap;
  var cs#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var $lambdaHeap#1: Heap;
  var cs#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: DatatypeType;
  var $lambdaHeap#2: Heap;
  var _v2#0: Box;
  var $_Frame#l2: [ref,Field]bool;
  var lambdaResult#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Parsers.SubParserWitness", " | ", JSON.Utils.Parsers._default.SubParserWitness$T, " | ", JSON.Utils.Parsers._default.SubParserWitness$R} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty"} true;
    assume {:captureState "libraries/src/JSON/Utils/Parsers.dfy(55,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, reveal_JSON.Utils.Parsers._default.SubParserWitness), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R));
    assume $IsAllocBox($Box(subp#0), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, subp#0);
    assume false;
    return;

  anon16_Else:
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Is(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Tclass.JSON_mUtils_mCursors.Cursor());
    goto anon17_Then, anon17_Else;

  anon17_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc cs#0;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 <==> Lit(false);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon6;

  anon18_Else:
    assume {:partition} !($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon17_Else:
    goto anon7;

  anon7:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc cs#1;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    assume lambdaResult#1 == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    assume true;
    assume $Is(lambdaResult#1, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers._default.SubParserWitness$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers._default.SubParserWitness$R)));
    goto anon10;

  anon20_Else:
    assume {:partition} !($Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#1));
    goto anon10;

  anon10:
    assume false;
    goto anon11;

  anon19_Else:
    goto anon11;

  anon11:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    havoc $lambdaHeap#2;
    assume $IsGoodHeap($lambdaHeap#2);
    assume $Heap == $lambdaHeap#2 || $HeapSucc($Heap, $lambdaHeap#2);
    havoc _v2#0;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} $IsBox(_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T) && $IsAllocBox(_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T, $lambdaHeap#2);
    $_Frame#l2 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#2, $o, alloc)): bool ==> false);
    assume lambdaResult#2 == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(lambdaResult#2, TSeq(Tclass.BoundedInts.uint8()));
    goto anon14;

  anon22_Else:
    assume {:partition} !($IsBox(_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T) && $IsAllocBox(_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T, $lambdaHeap#2));
    goto anon14;

  anon14:
    assume false;
    goto anon15;

  anon21_Else:
    goto anon15;

  anon15:
    assume JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, reveal_JSON.Utils.Parsers._default.SubParserWitness) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#cs#0: Box :: $Box(Lit(false))), (lambda $l#18#heap#0: Heap, $l#18#cs#0: Box :: $IsBox($l#18#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#18#heap#0: Heap, $l#18#cs#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#19#heap#0: Heap, $l#19#cs#0: Box :: $IsBox($l#19#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#19#heap#0: Heap, $l#19#cs#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#20#heap#0: Heap, $l#20#_v2#0: Box :: $IsBox($l#20#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#20#heap#0: Heap, $l#20#_v2#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))));
    assume true;
    assume $Is(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, reveal_JSON.Utils.Parsers._default.SubParserWitness), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R));
    assume JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, reveal_JSON.Utils.Parsers._default.SubParserWitness) == subp#0;
    return;
}



procedure {:verboseName "JSON.Utils.Parsers.reveal_ParserWitness (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mUtils_mParsers.__default.reveal__ParserWitness();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Parsers.reveal_ParserWitness (call precondtion)"} {:verify false} CallPre$$JSON_mUtils_mParsers.__default.reveal__ParserWitness();



procedure {:verboseName "JSON.Utils.Parsers.reveal_ParserWitness (call postcondition)"} {:verify false} CallPost$$JSON_mUtils_mParsers.__default.reveal__ParserWitness();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.Utils.Parsers._default.ParserWitness;



procedure {:verboseName "JSON.Utils.Parsers.reveal_SubParserWitness (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mUtils_mParsers.__default.reveal__SubParserWitness();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Parsers.reveal_SubParserWitness (call precondtion)"} {:verify false} CallPre$$JSON_mUtils_mParsers.__default.reveal__SubParserWitness();



procedure {:verboseName "JSON.Utils.Parsers.reveal_SubParserWitness (call postcondition)"} {:verify false} CallPost$$JSON_mUtils_mParsers.__default.reveal__SubParserWitness();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.Utils.Parsers._default.SubParserWitness;



procedure {:verboseName "JSON.Utils.Parsers.Parser (well-formedness)"} CheckWellFormed$$JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty, p#0: DatatypeType where $Is(p#0, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Parsers.Parser (well-formedness)"} CheckWellFormed$$JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty, p#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Parsers.Parser", " | ", JSON.Utils.Parsers.Parser$T, " | ", JSON.Utils.Parsers.Parser$R, " | ", p#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Parsers.dfy(16,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(p#0), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, p#0);
    assume JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, p#0);
    return;

  anon4_Else:
    assume JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness));
    assume JSON_mUtils_mParsers.__default.ParserWitness#canCall(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R) && JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness));
    assume {:subsumption 0} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness)) ==> JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness)) || (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness)), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness)), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness)), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, reveal_JSON.Utils.Parsers._default.ParserWitness))));
    return;
}



function Tclass.JSON_mUtils_mParsers.Parser(Ty, Ty) : Ty;

const unique Tagclass.JSON_mUtils_mParsers.Parser: TyTag;

axiom (forall JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty :: { Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R) } Tag(Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) == Tagclass.JSON_mUtils_mParsers.Parser && TagFamily(Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) == tytagFamily$Parser);

function Tclass.JSON_mUtils_mParsers.Parser_0(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty :: { Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R) } Tclass.JSON_mUtils_mParsers.Parser_0(Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) == JSON.Utils.Parsers.Parser$T);

function Tclass.JSON_mUtils_mParsers.Parser_1(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty :: { Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R) } Tclass.JSON_mUtils_mParsers.Parser_1(Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) == JSON.Utils.Parsers.Parser$R);

axiom (forall JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) } $IsBox(bx, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)));

axiom (forall JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty, p#0: DatatypeType :: { $Is(p#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) } $Is(p#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) <==> $Is(p#0, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R)) && JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R, p#0));

axiom (forall JSON.Utils.Parsers.Parser$T: Ty, JSON.Utils.Parsers.Parser$R: Ty, p#0: DatatypeType, $h: Heap :: { $IsAlloc(p#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R), $h) } $IsAlloc(p#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R), $h) <==> $IsAlloc(p#0, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser$T, JSON.Utils.Parsers.Parser$R), $h));

function #JSON.Utils.Parsers.Parser_.Parser(HandleType, HandleType) : DatatypeType;

const unique ##JSON.Utils.Parsers.Parser_.Parser: DtCtorId
uses {
axiom (forall a#0#0#0: HandleType, a#0#1#0: HandleType :: { #JSON.Utils.Parsers.Parser_.Parser(a#0#0#0, a#0#1#0) } DatatypeCtorId(#JSON.Utils.Parsers.Parser_.Parser(a#0#0#0, a#0#1#0)) == ##JSON.Utils.Parsers.Parser_.Parser);
}

function JSON_mUtils_mParsers.Parser__.Parser_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Parser_q(d) } JSON_mUtils_mParsers.Parser__.Parser_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Parsers.Parser_.Parser);

axiom (forall d: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Parser_q(d) } JSON_mUtils_mParsers.Parser__.Parser_q(d) ==> (exists a#1#0#0: HandleType, a#1#1#0: HandleType :: d == #JSON.Utils.Parsers.Parser_.Parser(a#1#0#0, a#1#1#0)));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, a#2#0#0: HandleType, a#2#1#0: HandleType :: { $Is(#JSON.Utils.Parsers.Parser_.Parser(a#2#0#0, a#2#1#0), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) } $Is(#JSON.Utils.Parsers.Parser_.Parser(a#2#0#0, a#2#1#0), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) <==> $Is(a#2#0#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)))) && $Is(a#2#1#0, Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.Parser_$T, TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, a#2#0#0: HandleType, a#2#1#0: HandleType, $h: Heap :: { $IsAlloc(#JSON.Utils.Parsers.Parser_.Parser(a#2#0#0, a#2#1#0), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Parsers.Parser_.Parser(a#2#0#0, a#2#1#0), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $h) <==> $IsAlloc(a#2#0#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R))), $h) && $IsAlloc(a#2#1#0, Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.Parser_$T, TSeq(Tclass.BoundedInts.uint8())), $h)));

axiom (forall d: DatatypeType, JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $h: Heap :: { $IsAlloc(JSON_mUtils_mParsers.Parser__.fn(d), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R))), $h) } $IsGoodHeap($h) && JSON_mUtils_mParsers.Parser__.Parser_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $h) ==> $IsAlloc(JSON_mUtils_mParsers.Parser__.fn(d), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R))), $h));

axiom (forall d: DatatypeType, JSON.Utils.Parsers.Parser_$T: Ty, $h: Heap :: { $IsAlloc(JSON_mUtils_mParsers.Parser__.spec(d), Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.Parser_$T, TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && JSON_mUtils_mParsers.Parser__.Parser_q(d) && (exists JSON.Utils.Parsers.Parser_$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $h)) ==> $IsAlloc(JSON_mUtils_mParsers.Parser__.spec(d), Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.Parser_$T, TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall a#3#0#0: HandleType, a#3#1#0: HandleType :: { #JSON.Utils.Parsers.Parser_.Parser(Lit(a#3#0#0), Lit(a#3#1#0)) } #JSON.Utils.Parsers.Parser_.Parser(Lit(a#3#0#0), Lit(a#3#1#0)) == Lit(#JSON.Utils.Parsers.Parser_.Parser(a#3#0#0, a#3#1#0)));

function JSON_mUtils_mParsers.Parser__.fn(DatatypeType) : HandleType;

axiom (forall a#4#0#0: HandleType, a#4#1#0: HandleType :: { #JSON.Utils.Parsers.Parser_.Parser(a#4#0#0, a#4#1#0) } JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(a#4#0#0, a#4#1#0)) == a#4#0#0);

function JSON_mUtils_mParsers.Parser__.spec(DatatypeType) : HandleType;

axiom (forall a#5#0#0: HandleType, a#5#1#0: HandleType :: { #JSON.Utils.Parsers.Parser_.Parser(a#5#0#0, a#5#1#0) } JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(a#5#0#0, a#5#1#0)) == a#5#1#0);

function $IsA#JSON_mUtils_mParsers.Parser__(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mParsers.Parser__(d) } $IsA#JSON_mUtils_mParsers.Parser__(d) ==> JSON_mUtils_mParsers.Parser__.Parser_q(d));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, d: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Parser_q(d), $Is(d, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) } $Is(d, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) ==> JSON_mUtils_mParsers.Parser__.Parser_q(d));

function JSON_mUtils_mParsers.Parser__#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mParsers.Parser__#Equal(a, b) } JSON_mUtils_mParsers.Parser__#Equal(a, b) <==> JSON_mUtils_mParsers.Parser__.fn(a) == JSON_mUtils_mParsers.Parser__.fn(b) && JSON_mUtils_mParsers.Parser__.spec(a) == JSON_mUtils_mParsers.Parser__.spec(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mParsers.Parser__#Equal(a, b) } JSON_mUtils_mParsers.Parser__#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mParsers.Parser__: ClassName;

function JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(this)))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#1))): DatatypeType } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#1))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#1))): DatatypeType)): DatatypeType, cs'#1, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#1))): DatatypeType } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#1))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#1))): DatatypeType)): DatatypeType, cs'#1, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));
}

function JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, this: DatatypeType) : bool;

function JSON_mUtils_mParsers.Parser__.Valid_q#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q#requires(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap) ==> (JSON_mUtils_mParsers.Parser__.Valid_q#requires(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> true));

procedure {:verboseName "JSON.Utils.Parsers.Parser_.Valid? (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Parsers.Parser_.Valid? (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var cs'#2: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Parsers.Parser_.Valid?", " | ", JSON.Utils.Parsers.Parser_$T, " | ", JSON.Utils.Parsers.Parser_$R, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Parsers.dfy(21,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume false;
    return;

  anon7_Else:
    havoc cs'#2;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} $Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(this);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#2))): DatatypeType);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(this);
    assume Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#2))): DatatypeType);
    assume $IsAllocBox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#2))): DatatypeType), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(this);
    ##cs0#0 := cs'#2;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mUtils_mParsers.Parser__.spec(this);
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.Parser_$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#2))): DatatypeType)): DatatypeType, cs'#2, JSON_mUtils_mParsers.Parser__.spec(this));
    goto anon6;

  anon9_Else:
    assume {:partition} !Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#2))): DatatypeType);
    goto anon6;

  anon8_Else:
    assume {:partition} !($Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap));
    goto anon6;

  anon6:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#3: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#3))): DatatypeType } $Is(cs'#3, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#3))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#3))): DatatypeType)): DatatypeType, cs'#3, JSON_mUtils_mParsers.Parser__.spec(this)));
    assume (forall cs'#3: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#3))): DatatypeType } $Is(cs'#3, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#3))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#3))): DatatypeType)): DatatypeType, cs'#3, JSON_mUtils_mParsers.Parser__.spec(this))));
    assume $Is(JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), TBool);
    return;
}



function #JSON.Utils.Parsers.SubParser_.SubParser(DatatypeType, HandleType, HandleType, HandleType) : DatatypeType;

const unique ##JSON.Utils.Parsers.SubParser_.SubParser: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: HandleType, a#0#2#0: HandleType, a#0#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0) } DatatypeCtorId(#JSON.Utils.Parsers.SubParser_.SubParser(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0)) == ##JSON.Utils.Parsers.SubParser_.SubParser);
}

function JSON_mUtils_mParsers.SubParser__.SubParser_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.SubParser_q(d) } JSON_mUtils_mParsers.SubParser__.SubParser_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Parsers.SubParser_.SubParser);

axiom (forall d: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.SubParser_q(d) } JSON_mUtils_mParsers.SubParser__.SubParser_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: HandleType, a#1#2#0: HandleType, a#1#3#0: HandleType :: d == #JSON.Utils.Parsers.SubParser_.SubParser(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0)));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, a#2#0#0: DatatypeType, a#2#1#0: HandleType, a#2#2#0: HandleType, a#2#3#0: HandleType :: { $Is(#JSON.Utils.Parsers.SubParser_.SubParser(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) } $Is(#JSON.Utils.Parsers.SubParser_.SubParser(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) <==> $Is(a#2#0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(a#2#1#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool)) && $Is(a#2#2#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)))) && $Is(a#2#3#0, Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.SubParser_$T, TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, a#2#0#0: DatatypeType, a#2#1#0: HandleType, a#2#2#0: HandleType, a#2#3#0: HandleType, $h: Heap :: { $IsAlloc(#JSON.Utils.Parsers.SubParser_.SubParser(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Parsers.SubParser_.SubParser(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h) <==> $IsAlloc(a#2#0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $h) && $IsAlloc(a#2#1#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool), $h) && $IsAlloc(a#2#2#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R))), $h) && $IsAlloc(a#2#3#0, Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.SubParser_$T, TSeq(Tclass.BoundedInts.uint8())), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mParsers.SubParser__.cs(d), Tclass.JSON_mUtils_mCursors.Cursor(), $h) } $IsGoodHeap($h) && JSON_mUtils_mParsers.SubParser__.SubParser_q(d) && (exists JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h)) ==> $IsAlloc(JSON_mUtils_mParsers.SubParser__.cs(d), Tclass.JSON_mUtils_mCursors.Cursor(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mUtils_mParsers.SubParser__.pre(d), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool), $h) } $IsGoodHeap($h) && JSON_mUtils_mParsers.SubParser__.SubParser_q(d) && (exists JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h)) ==> $IsAlloc(JSON_mUtils_mParsers.SubParser__.pre(d), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool), $h));

axiom (forall d: DatatypeType, JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $h: Heap :: { $IsAlloc(JSON_mUtils_mParsers.SubParser__.fn(d), Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R))), $h) } $IsGoodHeap($h) && JSON_mUtils_mParsers.SubParser__.SubParser_q(d) && $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h) ==> $IsAlloc(JSON_mUtils_mParsers.SubParser__.fn(d), Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R))), $h));

axiom (forall d: DatatypeType, JSON.Utils.Parsers.SubParser_$T: Ty, $h: Heap :: { $IsAlloc(JSON_mUtils_mParsers.SubParser__.spec(d), Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.SubParser_$T, TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) && JSON_mUtils_mParsers.SubParser__.SubParser_q(d) && (exists JSON.Utils.Parsers.SubParser_$R: Ty :: { $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h) } $IsAlloc(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $h)) ==> $IsAlloc(JSON_mUtils_mParsers.SubParser__.spec(d), Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.SubParser_$T, TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: HandleType, a#3#2#0: HandleType, a#3#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0), Lit(a#3#3#0)) } #JSON.Utils.Parsers.SubParser_.SubParser(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0), Lit(a#3#3#0)) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0)));

function JSON_mUtils_mParsers.SubParser__.cs(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: HandleType, a#4#2#0: HandleType, a#4#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0) } JSON_mUtils_mParsers.SubParser__.cs(#JSON.Utils.Parsers.SubParser_.SubParser(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: HandleType, a#5#2#0: HandleType, a#5#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0) } DtRank(a#5#0#0) < DtRank(#JSON.Utils.Parsers.SubParser_.SubParser(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0)));

function JSON_mUtils_mParsers.SubParser__.pre(DatatypeType) : HandleType;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: HandleType, a#6#2#0: HandleType, a#6#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0) } JSON_mUtils_mParsers.SubParser__.pre(#JSON.Utils.Parsers.SubParser_.SubParser(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0)) == a#6#1#0);

function JSON_mUtils_mParsers.SubParser__.fn(DatatypeType) : HandleType;

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: HandleType, a#7#2#0: HandleType, a#7#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0) } JSON_mUtils_mParsers.SubParser__.fn(#JSON.Utils.Parsers.SubParser_.SubParser(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0)) == a#7#2#0);

function JSON_mUtils_mParsers.SubParser__.spec(DatatypeType) : HandleType;

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: HandleType, a#8#2#0: HandleType, a#8#3#0: HandleType :: { #JSON.Utils.Parsers.SubParser_.SubParser(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0) } JSON_mUtils_mParsers.SubParser__.spec(#JSON.Utils.Parsers.SubParser_.SubParser(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0)) == a#8#3#0);

function $IsA#JSON_mUtils_mParsers.SubParser__(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mParsers.SubParser__(d) } $IsA#JSON_mUtils_mParsers.SubParser__(d) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(d));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, d: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.SubParser_q(d), $Is(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) } $Is(d, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(d));

function JSON_mUtils_mParsers.SubParser__#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mParsers.SubParser__#Equal(a, b) } JSON_mUtils_mParsers.SubParser__#Equal(a, b) <==> JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mParsers.SubParser__.cs(a), JSON_mUtils_mParsers.SubParser__.cs(b)) && JSON_mUtils_mParsers.SubParser__.pre(a) == JSON_mUtils_mParsers.SubParser__.pre(b) && JSON_mUtils_mParsers.SubParser__.fn(a) == JSON_mUtils_mParsers.SubParser__.fn(b) && JSON_mUtils_mParsers.SubParser__.spec(a) == JSON_mUtils_mParsers.SubParser__.spec(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mParsers.SubParser__#Equal(a, b) } JSON_mUtils_mParsers.SubParser__#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mParsers.SubParser__: ClassName;

function JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, this: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#0))): bool } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#0))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#0)))) && ((forall cs'#0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#0))): bool } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#0))) ==> (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#1))): bool) ==> (forall cs'#2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#2))): bool } $Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#2))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#2))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#2))): DatatypeType)): DatatypeType, cs'#2, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#0))): bool } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#0))) && (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#1))): bool) && (forall cs'#2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#2))): bool } $Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#2))): DatatypeType)): DatatypeType, cs'#2, JSON_mUtils_mParsers.SubParser__.spec(this)))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#3: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#3)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#3))): bool } $Is(cs'#3, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#3))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#3)))) && ((forall cs'#3: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#3)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#3))): bool } $Is(cs'#3, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#3))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#3))) ==> (forall cs'#4: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#4))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#4, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#4, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#4, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#4, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#4: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#4))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#4, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#4, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#4, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#4))): bool) ==> (forall cs'#5: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#5))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#5))): bool } $Is(cs'#5, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#5))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType)): DatatypeType, cs'#5, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#3: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#3)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#3))): bool } $Is(cs'#3, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#3))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#3))) && (forall cs'#4: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#4))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#4, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#4, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#4, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#4))): bool) && (forall cs'#5: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#5))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#5))): bool } $Is(cs'#5, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#5))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType)): DatatypeType, cs'#5, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));
}

function JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, this: DatatypeType) : bool;

function JSON_mUtils_mParsers.SubParser__.Valid_q#requires(Ty, Ty, DatatypeType) : bool;

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q#requires(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap) ==> (JSON_mUtils_mParsers.SubParser__.Valid_q#requires(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> true));

procedure {:verboseName "JSON.Utils.Parsers.SubParser_.Valid? (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, this: DatatypeType where $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Parsers.SubParser_.Valid? (well-formedness)"} CheckWellformed$$JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var cs'#6: DatatypeType;
  var ##x0#0: DatatypeType;
  var cs'#7: DatatypeType;
  var ##other#0: DatatypeType;
  var cs'#9: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Parsers.SubParser_.Valid?", " | ", JSON.Utils.Parsers.SubParser_$T, " | ", JSON.Utils.Parsers.SubParser_$R, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Parsers.dfy(45,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume false;
    return;

  anon18_Else:
    havoc cs'#6;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} $Is(cs'#6, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#6, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#6))): bool;
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    assume $IsAllocBox($Box(JSON_mUtils_mParsers.SubParser__.fn(this)), Tclass._System.___hFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R))), $Heap);
    ##x0#0 := cs'#6;
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(##x0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#6));
    goto anon6;

  anon20_Else:
    assume {:partition} !$Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#6))): bool;
    goto anon6;

  anon19_Else:
    assume {:partition} !($Is(cs'#6, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#6, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap));
    goto anon6;

  anon6:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} (forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)));
    havoc cs'#7;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} $Is(cs'#7, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#7, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(cs'#7), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(this);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#7);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#7);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#7, JSON_mUtils_mParsers.SubParser__.cs(this));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#7, JSON_mUtils_mParsers.SubParser__.cs(this));
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    goto anon10;

  anon23_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#7, JSON_mUtils_mParsers.SubParser__.cs(this));
    goto anon10;

  anon22_Else:
    assume {:partition} !($Is(cs'#7, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#7, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap));
    goto anon10;

  anon10:
    goto anon11;

  anon21_Else:
    assume {:partition} !(forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)));
    goto anon11;

  anon11:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} (forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8))) && (forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool);
    havoc cs'#9;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} $Is(cs'#9, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#9, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#9))): bool;
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9));
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9))): DatatypeType);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9));
    assume Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9))): DatatypeType);
    assume $IsAllocBox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9))): DatatypeType), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(this);
    ##cs0#0 := cs'#9;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mUtils_mParsers.SubParser__.spec(this);
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Parsers.SubParser_$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9))): DatatypeType)): DatatypeType, cs'#9, JSON_mUtils_mParsers.SubParser__.spec(this));
    goto anon16;

  anon27_Else:
    assume {:partition} !Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#9))): DatatypeType);
    goto anon16;

  anon26_Else:
    assume {:partition} !$Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#9))): bool;
    goto anon16;

  anon25_Else:
    assume {:partition} !($Is(cs'#9, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#9, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap));
    goto anon16;

  anon16:
    goto anon17;

  anon24_Else:
    assume {:partition} !((forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8))) && (forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool));
    goto anon17;

  anon17:
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8))) && (forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool) && (forall cs'#11: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#11))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#11))): bool } $Is(cs'#11, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#11))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#11))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#11))): DatatypeType)): DatatypeType, cs'#11, JSON_mUtils_mParsers.SubParser__.spec(this)));
    assume (forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)))) && ((forall cs'#8: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#8))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#8))) ==> (forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#10, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#10))): bool) ==> (forall cs'#11: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#11))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#11))): bool } $Is(cs'#11, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#11))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#11))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#11))): DatatypeType)): DatatypeType, cs'#11, JSON_mUtils_mParsers.SubParser__.spec(this)))))));
    assume $Is(JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), TBool);
    assume b$reqreads#0;
    return;
}



procedure {:verboseName "JSON.Utils.Parsers.SubParser (well-formedness)"} CheckWellFormed$$JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty, p#0: DatatypeType where $Is(p#0, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Parsers.SubParser (well-formedness)"} CheckWellFormed$$JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty, p#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Parsers.SubParser", " | ", JSON.Utils.Parsers.SubParser$T, " | ", JSON.Utils.Parsers.SubParser$R, " | ", p#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Parsers.dfy(52,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(p#0), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, p#0);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, p#0);
    return;

  anon4_Else:
    assume JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness));
    assume JSON_mUtils_mParsers.__default.SubParserWitness#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R) && JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness));
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)) || (forall cs'#0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#0))): bool } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#0)));
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)) || (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness))) } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1, JSON_mUtils_mParsers.SubParser__.cs(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#1))): bool);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)) || (forall cs'#2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#2))): bool } $Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness)), $Box(cs'#2))): DatatypeType)): DatatypeType, cs'#2, JSON_mUtils_mParsers.SubParser__.spec(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, reveal_JSON.Utils.Parsers._default.SubParserWitness))));
    return;
}



function Tclass.JSON_mUtils_mParsers.SubParser(Ty, Ty) : Ty;

const unique Tagclass.JSON_mUtils_mParsers.SubParser: TyTag;

axiom (forall JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty :: { Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R) } Tag(Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) == Tagclass.JSON_mUtils_mParsers.SubParser && TagFamily(Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) == tytagFamily$SubParser);

function Tclass.JSON_mUtils_mParsers.SubParser_0(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty :: { Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R) } Tclass.JSON_mUtils_mParsers.SubParser_0(Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) == JSON.Utils.Parsers.SubParser$T);

function Tclass.JSON_mUtils_mParsers.SubParser_1(Ty) : Ty;

axiom (forall JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty :: { Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R) } Tclass.JSON_mUtils_mParsers.SubParser_1(Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) == JSON.Utils.Parsers.SubParser$R);

axiom (forall JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) } $IsBox(bx, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)));

axiom (forall JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty, p#0: DatatypeType :: { $Is(p#0, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) } $Is(p#0, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) <==> $Is(p#0, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R)) && JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R, p#0));

axiom (forall JSON.Utils.Parsers.SubParser$T: Ty, JSON.Utils.Parsers.SubParser$R: Ty, p#0: DatatypeType, $h: Heap :: { $IsAlloc(p#0, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R), $h) } $IsAlloc(p#0, Tclass.JSON_mUtils_mParsers.SubParser(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R), $h) <==> $IsAlloc(p#0, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser$T, JSON.Utils.Parsers.SubParser$R), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#152 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#152))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#154 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#154)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#228 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#228))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#230 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#230)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#232 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#232)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#228 := Wrappers.Option.value(this); v#228)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#230 := Lit(Wrappers.Option.value(Lit(this))); v#230)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#232 := Lit(Wrappers.Option.value(Lit(this))); v#232)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#152 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#152)) else (var e#152 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#154 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#154))) else (var e#154 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#228 := Wrappers.Result.value(this); s#228) else (var e#228 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#230 := Lit(Wrappers.Result.value(Lit(this))); s#230) else (var e#230 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#232 := Lit(Wrappers.Result.value(Lit(this))); s#232) else (var e#232 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#228 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#228)) else (var e#228 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#228)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#230 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#230))) else (var e#230 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#230)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#232 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#232))) else (var e#232 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#232)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#6 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#6) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#6)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#6 := lv#0; (var dt_update#end#0#6 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#6), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#6), dt_update#end#0#6))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#7 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#7) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#7)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#7 := Lit(lv#0); (var dt_update#end#0#7 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#7)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#7)), dt_update#end#0#7)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#8: char :: { Seq#Contains(s#0, $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(s#0, $Box(c#8)) ==> char#ToInt(c#8) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#8: char :: { Seq#Contains(s#0, $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(s#0, $Box(c#8)) ==> char#ToInt(c#8) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#16#i#0): int)): char))), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $IsBox($l#16#i#0, TInt) && LitInt(0) <= $Unbox($l#16#i#0): int && $Unbox($l#16#i#0): int < Seq#Length(s#0)), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#9: char :: { Seq#Contains(s#0, $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(s#0, $Box(c#9)) ==> char#ToInt(c#9) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#18#i#0): int)): char))), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $IsBox($l#18#i#0, TInt) && LitInt(0) <= $Unbox($l#18#i#0): int && $Unbox($l#18#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall a#16#0#0: Box, a#16#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#16#0#0, a#16#1#0) } DatatypeCtorId(#JSON.Utils.Cursors.Split.SP(a#16#0#0, a#16#1#0)) == ##JSON.Utils.Cursors.Split.SP);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Split.SP_q(d) } JSON_mUtils_mCursors.Split.SP_q(d) ==> (exists a#17#0#0: Box, a#17#1#0: DatatypeType :: d == #JSON.Utils.Cursors.Split.SP(a#17#0#0, a#17#1#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, a#18#0#0: Box, a#18#1#0: DatatypeType :: { $Is(#JSON.Utils.Cursors.Split.SP(a#18#0#0, a#18#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) } $Is(#JSON.Utils.Cursors.Split.SP(a#18#0#0, a#18#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) <==> $IsBox(a#18#0#0, JSON.Utils.Cursors.Split$T) && $Is(a#18#1#0, Tclass.JSON_mUtils_mCursors.FreshCursor()));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, a#18#0#0: Box, a#18#1#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.Split.SP(a#18#0#0, a#18#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Cursors.Split.SP(a#18#0#0, a#18#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) <==> $IsAllocBox(a#18#0#0, JSON.Utils.Cursors.Split$T, $h) && $IsAlloc(a#18#1#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $h)));

axiom (forall a#19#0#0: Box, a#19#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(Lit(a#19#0#0), Lit(a#19#1#0)) } #JSON.Utils.Cursors.Split.SP(Lit(a#19#0#0), Lit(a#19#1#0)) == Lit(#JSON.Utils.Cursors.Split.SP(a#19#0#0, a#19#1#0)));

axiom (forall a#20#0#0: Box, a#20#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#20#0#0, a#20#1#0) } JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP(a#20#0#0, a#20#1#0)) == a#20#0#0);

axiom (forall a#21#0#0: Box, a#21#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#21#0#0, a#21#1#0) } BoxRank(a#21#0#0) < DtRank(#JSON.Utils.Cursors.Split.SP(a#21#0#0, a#21#1#0)));

axiom (forall a#22#0#0: Box, a#22#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#22#0#0, a#22#1#0) } JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP(a#22#0#0, a#22#1#0)) == a#22#1#0);

axiom (forall a#23#0#0: Box, a#23#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#23#0#0, a#23#1#0) } DtRank(a#23#1#0) < DtRank(#JSON.Utils.Cursors.Split.SP(a#23#0#0, a#23#1#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(this)) && (JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, JSON_mUtils_mCursors.Split.t(this))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(this))))));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(cs0#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this)))) && (JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(Lit(cs0#0)), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, Lit(JSON_mUtils_mCursors.Split.t(Lit(this))))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))))))));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, $Heap: Heap, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(cs0#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this)))) && (JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(Lit(cs0#0)), Seq#Append($Unbox(Apply1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(spec#0), Lit(JSON_mUtils_mCursors.Split.t(Lit(this))))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))))))));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) } JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)) && (JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) } JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)) && (JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) } JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0))) && (JSON_mUtils_mCursors.Split.SplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)))));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) } JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)) && (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(this), cs0#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, this, cs0#0, spec#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) } JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)) && (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), spec#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, this: DatatypeType, cs0#0: DatatypeType, spec#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) } JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.Split$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0))) && (JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(this))), Lit(cs0#0)) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(JSON.Utils.Cursors.Split$T, Lit(this), Lit(cs0#0), Lit(spec#0)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> $Is(JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), TSeq(TChar)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#12 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#6 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#12 := (if b#12 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#12)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#6)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#12)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#13 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#6 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#13 := (if b#13 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#13)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#6 := Seq#Create(TChar, $Heap, Seq#Length(bs0#6), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#6, $Unbox($l#13#idx#0): int)): int))), (lambda $l#13#heap#0: Heap, $l#13#idx#0: Box :: $IsBox($l#13#idx#0, TInt) && LitInt(0) <= $Unbox($l#13#idx#0): int && $Unbox($l#13#idx#0): int < Seq#Length(bs0#6)), (lambda $l#13#heap#0: Heap, $l#13#idx#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#6), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#13))))) else (var err#6 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#6)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#16 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#8 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#16 := (if b#16 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#16)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#8)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#16)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#17 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#8 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#17 := (if b#17 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#17)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#8 := Seq#Create(TChar, $Heap, Seq#Length(bs0#8), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#8, $Unbox($l#16#idx#0): int)): int))), (lambda $l#16#heap#0: Heap, $l#16#idx#0: Box :: $IsBox($l#16#idx#0, TInt) && LitInt(0) <= $Unbox($l#16#idx#0): int && $Unbox($l#16#idx#0): int < Seq#Length(bs0#8)), (lambda $l#16#heap#0: Heap, $l#16#idx#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#8), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#17))))) else (var err#8 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#8)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#20 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#10 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#20 := (if b#20 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#20)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#10)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#20)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#21 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#10 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#21 := (if b#21 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#21)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#10 := Seq#Create(TChar, $Heap, Seq#Length(bs0#10), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#10, $Unbox($l#19#idx#0): int)): int))), (lambda $l#19#heap#0: Heap, $l#19#idx#0: Box :: $IsBox($l#19#idx#0, TInt) && LitInt(0) <= $Unbox($l#19#idx#0): int && $Unbox($l#19#idx#0): int < Seq#Length(bs0#10)), (lambda $l#19#heap#0: Heap, $l#19#idx#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#10), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#21))))) else (var err#10 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#10)): Seq)))));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Valid_q($o) } $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Is(JSON_mUtils_mCursors.Cursor__.Valid_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Valid_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.Valid_q($o), TBool, $h));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.BOF_q($o) } $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Is(JSON_mUtils_mCursors.Cursor__.BOF_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.BOF_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.BOF_q($o), TBool, $h));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.EOF_q($o) } $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) ==> $Is(JSON_mUtils_mCursors.Cursor__.EOF_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.EOF_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc($o, Tclass.JSON_mUtils_mCursors.Cursor__(), $h) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.EOF_q($o), TBool, $h));

axiom (forall v#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.OfView(v#0) } JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> $Is(JSON_mUtils_mCursors.Cursor__.OfView(v#0), Tclass.JSON_mUtils_mCursors.FreshCursor()));

axiom (forall v#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.OfView(v#0) } JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mViews_mCore.View__.View_q(v#0) && JSON_mUtils_mCursors.Cursor__.OfView(v#0) == #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mViews_mCore.View__.s(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.beg(v#0), JSON_mUtils_mViews_mCore.View__.end(v#0)));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)) } JSON_mUtils_mCursors.Cursor__.OfView#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.View_q(Lit(v#0)) && JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)) == Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mViews_mCore.View__.s(Lit(v#0))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v#0))), LitInt(JSON_mUtils_mViews_mCore.View__.beg(Lit(v#0))), LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(v#0))))));

axiom (forall bs#0: Seq :: { JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) } JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(bs#0) || ($Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> $Is(JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0), Tclass.JSON_mUtils_mCursors.FreshCursor()));

axiom (forall bs#0: Seq :: { JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) } JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(bs#0) || ($Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.OfBytes(bs#0) == #JSON.Utils.Cursors.Cursor_.Cursor(bs#0, LitInt(0), LitInt(0), Seq#Length(bs#0)));

axiom (forall bs#0: Seq :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.OfBytes(Lit(bs#0)) } JSON_mUtils_mCursors.Cursor__.OfBytes#canCall(Lit(bs#0)) || ($Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.OfBytes(Lit(bs#0)) == #JSON.Utils.Cursors.Cursor_.Cursor(Lit(bs#0), LitInt(0), LitInt(0), Seq#Length(Lit(bs#0))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Bytes(this) } JSON_mUtils_mCursors.Cursor__.Bytes#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $Is(JSON_mUtils_mCursors.Cursor__.Bytes(this), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Bytes(this) } JSON_mUtils_mCursors.Cursor__.Bytes#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Bytes(this) == Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.end(this)), JSON_mUtils_mCursors.Cursor__.beg(this)));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Bytes(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Bytes#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Bytes(Lit(this)) == Lit(Seq#Drop(Seq#Take(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))), LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#3: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#3)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#3)): int } LitInt(0) <= idx#3 && idx#3 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#3 && idx#3 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#3)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#3)): int)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0)))) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) && JSON_mUtils_mCursors.Cursor__.point(this) > JSON_mUtils_mCursors.Cursor__.point(other#0)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(Lit(this), Lit(other#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0))))) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(Lit(this), Lit(other#0)) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0))) && LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(other#0))) && JSON_mUtils_mCursors.Cursor__.point(Lit(this)) > JSON_mUtils_mCursors.Cursor__.point(Lit(other#0))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall(Lit(this), Lit(other#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(Lit(this)) && $IsA#JSON_mUtils_mCursors.Cursor__(Lit(other#0)) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(Lit(this), Lit(other#0))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.Length(this) < JSON_mUtils_mCursors.Cursor__.Length(other#0));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0) && (JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(other#0))) && (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.s(other#0)) && JSON_mUtils_mCursors.Cursor__.beg(this) > JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(Lit(this), Lit(other#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)) && (Lit(JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) > JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(other#0)))) && (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0)) <==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(Lit(this)), JSON_mUtils_mCursors.Cursor__.s(Lit(other#0))) && JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) > JSON_mUtils_mCursors.Cursor__.beg(Lit(other#0)) && LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this))) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(other#0)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.SuffixOf_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SuffixOf_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(Lit(this), Lit(other#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(Lit(this)) && $IsA#JSON_mUtils_mCursors.Cursor__(Lit(other#0)) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.SuffixOf_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__.BOF_q(this) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(this, other#0)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(this), Lit(other#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (JSON_mUtils_mCursors.Cursor__.BOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__.BOF_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(Lit(this), Lit(other#0))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $IsA#JSON_mUtils_mCursors.Cursor__(this) && $IsA#JSON_mUtils_mCursors.Cursor__(other#0) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(this, other#0)) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(this, other#0) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(this, other#0)));

axiom (forall this: DatatypeType, other#0: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(this), Lit(other#0)) } JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(Lit(this), Lit(other#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(Lit(this)) && $IsA#JSON_mUtils_mCursors.Cursor__(Lit(other#0)) && (!JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(Lit(this), Lit(other#0))) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(this), Lit(other#0)) <==> JSON_mUtils_mCursors.Cursor__#Equal(this, other#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(this), Lit(other#0))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Prefix(this) } JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $Is(JSON_mUtils_mCursors.Cursor__.Prefix(this), Tclass.JSON_mUtils_mViews_mCore.View()));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Prefix(this) } JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Prefix(this) == #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this), JSON_mUtils_mCursors.Cursor__.point(this)));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Prefix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Prefix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Prefix(Lit(this)) == Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> $Is(JSON_mUtils_mCursors.Cursor__.Suffix(this), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#2 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#2 := this; (var dt_update#beg#0#2 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#2), dt_update#beg#0#2, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#2), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#2)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#3 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#3 := Lit(this); (var dt_update#beg#0#3 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#3)), dt_update#beg#0#3, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#3)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#3)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#39#v#0): DatatypeType))), (lambda $l#39#heap#0: Heap, $l#39#v#0: Box :: $IsBox($l#39#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#39#heap#0: Heap, $l#39#v#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#40#v#0): DatatypeType))), (lambda $l#40#heap#0: Heap, $l#40#v#0: Box :: $IsBox($l#40#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#40#heap#0: Heap, $l#40#v#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#41#v#0): DatatypeType))), (lambda $l#41#heap#0: Heap, $l#41#v#0: Box :: $IsBox($l#41#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#41#heap#0: Heap, $l#41#v#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Prefix#canCall(this) && JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) && JSON_mUtils_mCursors.Cursor__.Split(this) == #JSON.Utils.Cursors.Split.SP($Box(JSON_mUtils_mCursors.Cursor__.Prefix(this)), JSON_mUtils_mCursors.Cursor__.Suffix(this)));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Split(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Prefix#canCall(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Split(Lit(this)) == Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(JSON_mUtils_mCursors.Cursor__.Prefix(Lit(this)))), Lit(JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.PrefixLength(this) } JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.PrefixLength(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength(this) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.PrefixLength(this) } JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.PrefixLength(this) == JSON_mUtils_mCursors.Cursor__.point(this) - JSON_mUtils_mCursors.Cursor__.beg(this));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.PrefixLength(Lit(this)) } JSON_mUtils_mCursors.Cursor__.PrefixLength#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.PrefixLength(Lit(this)) == LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - JSON_mUtils_mCursors.Cursor__.beg(Lit(this))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixLength(this) } JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.SuffixLength(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SuffixLength(this) } JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixLength(this) == JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.point(this));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SuffixLength(Lit(this)) } JSON_mUtils_mCursors.Cursor__.SuffixLength#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SuffixLength(Lit(this)) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)) - JSON_mUtils_mCursors.Cursor__.point(Lit(this))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Length(this) } JSON_mUtils_mCursors.Cursor__.Length#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.Length(this) && JSON_mUtils_mCursors.Cursor__.Length(this) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Length(this) } JSON_mUtils_mCursors.Cursor__.Length#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Length(this) == JSON_mUtils_mCursors.Cursor__.end(this) - JSON_mUtils_mCursors.Cursor__.beg(this));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Length(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Length(Lit(this)) == LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)) - JSON_mUtils_mCursors.Cursor__.beg(Lit(this))));

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0) } JSON_mUtils_mCursors.Cursor__.ValidIndex_q#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && (JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0) <==> JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(this)));

axiom (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.ValidIndex_q(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.ValidIndex_q#canCall(Lit(this), LitInt(idx#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && (JSON_mUtils_mCursors.Cursor__.ValidIndex_q(Lit(this), LitInt(idx#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(Lit(this)))));

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.At(this, idx#0) } JSON_mUtils_mCursors.Cursor__.At#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.At(this, idx#0) && JSON_mUtils_mCursors.Cursor__.At(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.At(this, idx#0) } JSON_mUtils_mCursors.Cursor__.At#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidIndex_q(this, idx#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.At(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.beg(this) + idx#0)): int);

axiom (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.At(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.At#canCall(Lit(this), LitInt(idx#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Lit(JSON_mUtils_mCursors.Cursor__.ValidIndex_q(Lit(this), LitInt(idx#0)))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.At(Lit(this), LitInt(idx#0)) == $Unbox(Seq#Index(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this)) + idx#0))): int);

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0) } JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && (JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0) <==> JSON_mUtils_mCursors.Cursor__.point(this) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(this)));

axiom (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q#canCall(Lit(this), LitInt(idx#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && (JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(Lit(this), LitInt(idx#0)) <==> Lit(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + idx#0 < JSON_mUtils_mCursors.Cursor__.end(Lit(this)))));

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) } JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0)) ==> LitInt(0) <= JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall this: DatatypeType, idx#0: int :: { JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) } JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, idx#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(this, idx#0)) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, idx#0) == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this) + idx#0)): int);

axiom (forall this: DatatypeType, idx#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(idx#0)) } JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(idx#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Lit(JSON_mUtils_mCursors.Cursor__.ValidSuffixIndex_q(Lit(this), LitInt(idx#0)))) ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(idx#0)) == $Unbox(Seq#Index(Lit(JSON_mUtils_mCursors.Cursor__.s(Lit(this))), LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + idx#0))): int);

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Peek(this) } JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.Peek(this) < 0 <==> JSON_mUtils_mCursors.Cursor__.EOF_q(this)) && LitInt(-1) <= JSON_mUtils_mCursors.Cursor__.Peek(this) && JSON_mUtils_mCursors.Cursor__.Peek(this) < BoundedInts.__default.TWO__TO__THE__8());

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Peek(this) } JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0))) && JSON_mUtils_mCursors.Cursor__.Peek(this) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then -1 else JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then -1 else JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0))));

axiom (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) } JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(this, c#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c#0) < 256) ==> (JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this) && JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0)) == char#ToInt(c#0)));

axiom (forall this: DatatypeType, c#0: char :: { JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) } JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(this, c#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c#0) < 256) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mCursors.Cursor__.LookingAt(this, c#0) <==> JSON_mUtils_mCursors.Cursor__.Peek(this) == char#ToInt(c#0)));

axiom (forall this: DatatypeType, c#0: char :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.LookingAt(Lit(this), Lit(c#0)) } JSON_mUtils_mCursors.Cursor__.LookingAt#canCall(Lit(this), Lit(c#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && char#ToInt(Lit(c#0)) < 256) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mCursors.Cursor__.LookingAt(Lit(this), Lit(c#0)) <==> LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))) == char#ToInt(Lit(c#0))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (n#0 == LitInt(0) ==> JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), this)) && (n#0 > 0 ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), this)) && $Is(JSON_mUtils_mCursors.Cursor__.Skip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#2 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#2 := this; (var dt_update#point#0#2 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#2), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#2), dt_update#point#0#2, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#2)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#3 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#3 := Lit(this); (var dt_update#point#0#3 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#3)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#3)), dt_update#point#0#3, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#3)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> $Is(JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#2 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#2)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#2 := this; (var dt_update#point#0#2 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#2), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#2), dt_update#point#0#2, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#2)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#3 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#3)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#3 := Lit(this); (var dt_update#point#0#3 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#3)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#3)), dt_update#point#0#3, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#3)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R))));

axiom (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) || ($IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && $IsAllocBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R, $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.Get$R)), $Heap));

axiom (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, this, err#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#0))) else #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), err#0) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), err#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), err#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#0))) else #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.Get$R: Ty, this: DatatypeType, err#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), Lit(err#0)) } JSON_mUtils_mCursors.Cursor__.Get#canCall(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), Lit(err#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsBox(err#0, JSON.Utils.Cursors.Cursor_.Get$R) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.Get(JSON.Utils.Cursors.Cursor_.Get$R, Lit(this), Lit(err#0)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError(Lit(err#0))))) else #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0)) ==> !JSON_mUtils_mCursors.Cursor__.EOF_q(this)) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0)) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point(this))): int == b#0) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R))));

axiom (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertByte$R)), $Heap));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#2 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#2 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#2 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#2 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#2))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#3 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#3 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#3 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#3 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#3)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#0: int :: { Seq#Contains(bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#0)) ==> b#0 < 256)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0))): DatatypeType, this)) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0)) && offset#0 < Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0))): DatatypeType, this)) && (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0)) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mCursors.Cursor__.s(this), JSON_mUtils_mCursors.Cursor__.point($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.point(this)), Seq#Drop(bs#0, offset#0))) && $Is(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R))));

axiom (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#0: int :: { Seq#Contains(bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#0)) ==> b#0 < 256))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R)), $Heap));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#6: int :: { Seq#Contains(bs#0, $Box(b#6)) } LitInt(0) <= b#6 && b#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#6)) ==> b#6 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#6: int :: { Seq#Contains(bs#0, $Box(b#6)) } LitInt(0) <= b#6 && b#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#6)) ==> b#6 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3) && (var ps#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#3, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#3) else (var ps#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#3, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#7: int :: { Seq#Contains(bs#0, $Box(b#7)) } LitInt(0) <= b#7 && b#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#7)) ==> b#7 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4) && (var ps#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#4, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#4) else (var ps#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#4, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#8: int :: { Seq#Contains(bs#0, $Box(b#8)) } LitInt(0) <= b#8 && b#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#8)) ==> b#8 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5) && (var ps#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#5, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#5) else (var ps#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#5, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) } JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R))));

axiom (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) || ($IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertChar$R)), $Heap));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: { JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) } JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && char#ToInt(c0#0) < 256) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0)) && JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, c0#0) == JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertChar$R, this, char#ToInt(c0#0)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertChar$R: Ty, this: DatatypeType, c0#0: char :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), Lit(c0#0)) } JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), Lit(c0#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(c0#0, TChar) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && char#ToInt(Lit(c0#0)) < 256) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), char#ToInt(Lit(c0#0))) && JSON_mUtils_mCursors.Cursor__.AssertChar(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), Lit(c0#0)) == JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertChar$R, Lit(this), char#ToInt(Lit(c0#0))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SkipByte(this) } JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipByte(this), this) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipByte(this), this)) && $Is(JSON_mUtils_mCursors.Cursor__.SkipByte(this), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.SkipByte(this) } JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipByte(this) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then this else JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipByte(Lit(this)) } JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipByte(Lit(this)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then this else JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))));

axiom (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), this) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) && $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool ==> JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), this)) && $Is(JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipIf(this, p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool then this else JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1))));

axiom (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(this), p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))));

axiom (forall $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), Lit(p#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(this), Lit(p#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(this), Lit(p#0)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#3: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#3)): int } LitInt(0) <= idx#3 && idx#3 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#3 && idx#3 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#3)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(this, LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), this, p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(JSON_mUtils_mCursors.Cursor__.SuffixAt(this, LitInt(0))))): bool then this else JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), p#0)));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(this), p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), p#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), p#0) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), p#0)));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), Lit(p#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(this), Lit(p#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (!JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.SuffixAt#canCall(Lit(this), LitInt(0))) && (!(JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(p#0))) && JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(this), Lit(p#0)) == (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) || !$Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(p#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.SuffixAt(Lit(this), LitInt(0)))))): bool then this else JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(p#0))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (Wrappers.Result.Success_q(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0))): DatatypeType, this)) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))));

axiom (forall $Heap: Heap, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, this: DatatypeType, step#0: HandleType, st#0: Box :: { $IsAlloc(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap) } (JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsAlloc(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && $IsAllocBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, this, step#0, st#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R)), $Heap));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#8 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#8)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#7 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#7)))) else (var st#7 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#7))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#10 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#10)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#9 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#9)))) else (var st#9 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#9))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#12 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#12)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#11 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#11)))) else (var st#11 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#11))))));

const unique tytagFamily$Parser_: TyTagFamily;

const unique tytagFamily$SubParser_: TyTagFamily;

const unique tytagFamily$Parser: TyTagFamily;

const unique tytagFamily$SubParser: TyTagFamily;

const unique class.JSON_mUtils_mStr_mParametricConversion.__default: ClassName;

function JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly: LayerType, n#0: int, base#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#0: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#0 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#0 := Seq#Append(digits'#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#1 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#1 := Seq#Append(digits'#1, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#2 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#2 := Seq#Append(digits'#2, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#2))));
}

function JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0: int, base#0: int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits(AsFuelBottom($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) == JSON_mUtils_mStr_mParametricConversion.__default.Digits($LZ, n#0, base#0));

function JSON_mUtils_mStr_mParametricConversion.__default.Digits#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits#requires($ly, n#0, base#0) } LitInt(0) <= n#0 ==> (JSON_mUtils_mStr_mParametricConversion.__default.Digits#requires($ly, n#0, base#0) <==> base#0 > 1));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.Digits(n#0: int where LitInt(0) <= n#0, base#0: int) returns (digits#3: Seq where $Is(digits#3, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20874"} n#0 == LitInt(0) ==> Seq#Length(digits#3) == LitInt(0);
  free ensures {:id "id20875"} n#0 > 0 ==> Seq#Length(digits#3) == Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, n#0) + 1;
  free ensures {:id "id20876"} (forall d#1: int :: { Seq#Contains(digits#3, $Box(d#1)) } Seq#Contains(digits#3, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.Digits(n#0: int, base#0: int) returns (digits#3: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var d#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var digits'#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#1: int;
  var digits#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##base#2: int;
  var ##pow#1: int;
  var base##1_0_0: int;
  var pow##1_0_0: int;
  var d##1_0_0_0: int;
  var base##1_1_0: int;
  var pow##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.Digits", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume n#0 == LitInt(0);
    assume Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon30_Else:
    assume n#0 == LitInt(0) ==> Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume n#0 > 0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon31_Else:
    assume n#0 > 0 ==> Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon8:
    havoc d#2;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume Seq#Contains(digits#3, $Box(d#2));
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= d#2;
    goto anon11;

  anon33_Else:
    assume {:partition} d#2 < LitInt(0);
    goto anon11;

  anon11:
    assume LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon32_Else:
    assume Seq#Contains(digits#3, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon13:
    assume (forall d#1: int :: { Seq#Contains(digits#3, $Box(d#1)) } Seq#Contains(digits#3, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);
    assume false;
    return;

  anon29_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} n#0 == LitInt(0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(35,49)"} true;
    assume {:subsumption 0} Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, LitInt(0)) == LitInt(1);
    assume false;
    goto anon17;

  anon35_Else:
    goto anon17;

  anon17:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, LitInt(0)) == LitInt(1);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(35,52)"} true;
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon34_Else:
    assume {:partition} n#0 != LitInt(0);
    call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(38,29)"} true;
    call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(38,54)"} true;
    havoc digits'#Z#0;
    assume $Is(digits'#Z#0, TSeq(TInt)) && $IsAlloc(digits'#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume $Is(Div(n#0, base#0), Tclass._System.nat());
    ##n#0 := Div(n#0, base#0);
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume {:subsumption 0} ##base#1 > 1;
    assume ##base#1 > 1;
    assume 0 <= n#0 || ##n#0 == n#0;
    assume ##n#0 < n#0;
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume let#0#0#0 == JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), Div(n#0, base#0), base#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume $Is(let#0#0#0, TSeq(TInt));
    assume digits'#Z#0 == let#0#0#0;
    havoc digits#Z#0;
    assume $Is(digits#Z#0, TSeq(TInt)) && $IsAlloc(digits#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume let#1#0#0 == Seq#Append(digits'#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))));
    assume true;
    assume $Is(let#1#0#0, TSeq(TInt));
    assume digits#Z#0 == let#1#0#0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#2 := base#0;
    assume $IsAlloc(##base#2, Tclass._System.nat(), $Heap);
    ##pow#1 := n#0;
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#2 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume true;
    assume Seq#Length(digits#Z#0) == Seq#Length(digits'#Z#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(42,42)"} true;
    assume true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} n#0 < base#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_0_0 := base#0;
    assume true;
    pow##1_0_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    call CallPost$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(44,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume true;
    d##1_0_0_0 := base#0;
    call CallPre$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    call CallPost$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(45,57)"} true;
    assume Div(n#0, base#0) == LitInt(0);
    assume false;
    goto anon22;

  anon38_Else:
    goto anon22;

  anon22:
    assume Div(n#0, base#0) == LitInt(0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(45,59)"} true;
    goto anon26;

  anon37_Else:
    assume {:partition} base#0 <= n#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_1_0 := base#0;
    assume true;
    pow##1_1_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(47,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    call CallPre$$DivMod.__default.LemmaDivNonZeroAuto();
    call CallPost$$DivMod.__default.LemmaDivNonZeroAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(48,58)"} true;
    assume Div(n#0, base#0) > 0;
    assume false;
    goto anon25;

  anon39_Else:
    goto anon25;

  anon25:
    assume Div(n#0, base#0) > 0;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(48,60)"} true;
    goto anon26;

  anon26:
    assume {:subsumption 0} Seq#Length(digits#Z#0) == Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    assume false;
    goto anon27;

  anon36_Else:
    goto anon27;

  anon27:
    assume Seq#Length(digits#Z#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(50,8)"} true;
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#Z#0;
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon28:
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#3;
    return;
}



function JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly: LayerType, digits#0: Seq, chars#0: Seq) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || (1 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#0: Box :: { Seq#Contains(chars#0, c#0) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#0) } $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#0) ==> Seq#Contains(chars#0, c#0)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, $ly: LayerType, digits#0: Seq, chars#0: Seq :: { $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) } (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || (1 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $IsAlloc(digits#0, TSeq(TInt), $Heap) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0)))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || (1 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || (1 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#2: int :: { Seq#Contains(digits#0, $Box(d#2)) } Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));
}

function JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0: Seq, chars#0: Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits(AsFuelBottom($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) == JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LZ, digits#0, chars#0));

function Tclass.JSON_mUtils_mStr_mParametricConversion.Char() : Ty;

function JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.OfDigits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.OfDigits(digits#0: Seq where $Is(digits#0, TSeq(TInt)), chars#0: Seq where $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20933"} (forall c#1: Box :: { Seq#Contains(chars#0, c#1) } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Seq#Contains(chars#0, c#1));
  free ensures {:id "id20934"} Seq#Length(str#0) == Seq#Length(digits#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.OfDigits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.OfDigits(digits#0: Seq, chars#0: Seq) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var d#3: int;
  var c#2: Box;
  var d#4: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.OfDigits", " | ", digits#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(54,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc d#3;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Seq#Contains(digits#0, $Box(d#3));
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} LitInt(0) <= d#3;
    goto anon4;

  anon19_Else:
    assume {:partition} d#3 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= d#3 && d#3 < Seq#Length(chars#0);
    goto anon6;

  anon18_Else:
    assume Seq#Contains(digits#0, $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < Seq#Length(chars#0);
    goto anon6;

  anon6:
    assume (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    havoc c#2;
    assume $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Seq#Contains(str#0, c#2);
    assume Seq#Contains(chars#0, c#2);
    goto anon10;

  anon21_Else:
    assume Seq#Contains(str#0, c#2) ==> Seq#Contains(chars#0, c#2);
    goto anon10;

  anon10:
    assume (forall c#1: Box :: { Seq#Contains(chars#0, c#1) } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Seq#Contains(chars#0, c#1));
    assume Seq#Length(str#0) == Seq#Length(digits#0);
    assume false;
    return;

  anon20_Else:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Seq#Equal(digits#0, Seq#Empty(): Seq);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), digits#0, chars#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon17;

  anon22_Else:
    assume {:partition} !Seq#Equal(digits#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(digits#0);
    assume true;
    assume Seq#Contains(digits#0, Seq#Index(digits#0, LitInt(0)));
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(61,34)"} true;
    havoc d#4;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} true;
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(digits#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} Seq#Contains(Seq#Drop(digits#0, LitInt(1)), $Box(d#4));
    goto anon16;

  anon24_Else:
    assume {:partition} !Seq#Contains(Seq#Drop(digits#0, LitInt(1)), $Box(d#4));
    goto anon16;

  anon23_Else:
    assume {:partition} false;
    goto anon16;

  anon16:
    assume true;
    assume (forall d#5: int :: { Seq#Contains(digits#0, $Box(d#5)) } { Seq#Contains(Seq#Drop(digits#0, 1), $Box(d#5)) } Seq#Contains(Seq#Drop(digits#0, LitInt(1)), $Box(d#5)) ==> Seq#Contains(digits#0, $Box(d#5)));
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(62,57)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(digits#0);
    assume 0 <= $Unbox(Seq#Index(digits#0, LitInt(0))): int && $Unbox(Seq#Index(digits#0, LitInt(0))): int < Seq#Length(chars#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(digits#0);
    ##digits#0 := Seq#Drop(digits#0, LitInt(1));
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    assume {:subsumption 0} (forall d#6: int :: { Seq#Contains(##digits#0, $Box(d#6)) } Seq#Contains(##digits#0, $Box(d#6)) ==> LitInt(0) <= d#6 && d#6 < Seq#Length(##chars#0));
    assume (forall d#6: int :: { Seq#Contains(##digits#0, $Box(d#6)) } Seq#Contains(##digits#0, $Box(d#6)) ==> LitInt(0) <= d#6 && d#6 < Seq#Length(##chars#0));
    assume Seq#Rank(##digits#0) < Seq#Rank(digits#0) || (Seq#Rank(##digits#0) == Seq#Rank(digits#0) && Seq#Rank(##chars#0) < Seq#Rank(chars#0));
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), digits#0, chars#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), Seq#Drop(digits#0, LitInt(1)), chars#0));
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon17;

  anon17:
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), digits#0, chars#0) == str#0;
    return;
}



function JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0: int, chars#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (2 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#0: Box :: { Seq#Contains(chars#0, c#0) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#0) } $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#0) ==> Seq#Contains(chars#0, c#0)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, n#0: int, chars#0: Seq :: { $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) } (JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (2 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) && Seq#Length(chars#0) > 1)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap));
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (2 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#0 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#0 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0))));
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (2 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#1 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#1) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#1 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0)))));
}

function JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0: int, chars#0: Seq) : bool;

function JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#requires(int, Seq) : bool;

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#requires(n#0, chars#0) } LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#requires(n#0, chars#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0: int where LitInt(0) <= n#0, chars#0: Seq where $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20956"} Seq#Length(str#0) == Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1;
  free ensures {:id "id20957"} (forall c#1: Box :: { Seq#Contains(chars#0, c#1) } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Seq#Contains(chars#0, c#1));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0: int, chars#0: Seq) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var c#2: Box;
  var base#Z#0: int;
  var let#0#0#0: int;
  var ##n#0: int;
  var ##base#1: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.OfNat_any", " | ", n#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(66,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    assume $Is(Seq#Length(chars#0), Tclass._System.nat());
    ##base#0 := Seq#Length(chars#0);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(Seq#Length(chars#0), n#0);
    assume Seq#Length(str#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1;
    havoc c#2;
    assume $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(str#0, c#2);
    assume Seq#Contains(chars#0, c#2);
    goto anon5;

  anon11_Else:
    assume Seq#Contains(str#0, c#2) ==> Seq#Contains(chars#0, c#2);
    goto anon5;

  anon5:
    assume (forall c#1: Box :: { Seq#Contains(chars#0, c#1) } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Seq#Contains(chars#0, c#1));
    assume false;
    return;

  anon10_Else:
    havoc base#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(chars#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume base#Z#0 == let#0#0#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} n#0 == LitInt(0);
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(72,32)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0)));
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon9;

  anon12_Else:
    assume {:partition} n#0 != LitInt(0);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#Z#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume {:subsumption 0} ##base#1 > 1;
    assume ##base#1 > 1;
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#Z#0);
    ##digits#0 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#Z#0);
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    assume {:subsumption 0} (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#Z#0) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon9;

  anon9:
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == str#0;
    return;
}



function JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0: Seq, minus#0: Box, is_digit#0: HandleType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#0: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#0)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#0) } $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#0) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#0)): bool)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#1: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#1)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#1) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#1)): bool)));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#2: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#2)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#2) } $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#2) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#2)): bool)));
}

function JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0: Seq, minus#0: Box, is_digit#0: HandleType) : bool;

function JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#requires(Seq, Box, HandleType) : bool;

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool)) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.NumberStr (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), minus#0: Box where $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), is_digit#0: HandleType where $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.NumberStr (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0: Seq, minus#0: Box, is_digit#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.NumberStr", " | ", str#0, " | ", minus#0, " | ", is_digit#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Box", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(76,14): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Seq#Index(str#0, LitInt(0)) != minus#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    goto anon6;

  anon14_Else:
    assume {:partition} Seq#Index(str#0, LitInt(0)) == minus#0;
    goto anon6;

  anon6:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool;
    havoc c#3;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#3);
    goto anon10;

  anon17_Else:
    assume {:partition} !Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#3);
    goto anon10;

  anon16_Else:
    assume {:partition} !($IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap));
    goto anon10;

  anon10:
    goto anon11;

  anon15_Else:
    assume {:partition} !(Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool);
    goto anon11;

  anon13_Else:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11;

  anon11:
    assume JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#4: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#4)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#4) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#4)): bool);
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), TBool);
    return;
}



function JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0: int, chars#0: Seq, minus#0: Box) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (3 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(Seq#Contains(chars#0, $l#0#c#0))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, n#0: int, chars#0: Seq, minus#0: Box :: { $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) } (JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (3 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap) && Seq#Length(chars#0) > 1)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (3 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, minus#0), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(0 - n#0, chars#0))));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || (3 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, minus#0), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), Lit(minus#0)) || (3 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
}

function JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0: int, chars#0: Seq, minus#0: Box) : bool;

function JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#requires(int, Seq, Box) : bool;

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) } $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.OfInt_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0: int, chars#0: Seq where $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), minus#0: Box where $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id20980"} JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Seq#Contains(chars#0, $l#1#c#0))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Seq#Contains(chars#0, $l#2#c#0))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.OfInt_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0: int, chars#0: Seq, minus#0: Box) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: Box;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##str#0: Seq;
  var ##minus#0: Box;
  var ##is_digit#0: HandleType;
  var ##n#0: int;
  var ##chars#0: Seq;
  var ##n#1: int;
  var ##chars#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.OfInt_any", " | ", n#0, " | ", chars#0, " | ", minus#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(82,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 <==> Seq#Contains(chars#0, c#0);
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon5;

  anon13_Else:
    assume {:partition} !($IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $lambdaHeap#0));
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon12_Else:
    goto anon6;

  anon6:
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##minus#0 := minus#0;
    assume $IsAllocBox(##minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    ##is_digit#0 := Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(Seq#Contains(chars#0, $l#4#c#0))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool), $Heap);
    assume JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(Seq#Contains(chars#0, $l#5#c#0))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(Seq#Contains(chars#0, $l#6#c#0))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume false;
    return;

  anon11_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} n#0 >= LitInt(0);
    assume $Is(n#0, Tclass._System.nat());
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    assume {:subsumption 0} Seq#Length(##chars#0) > 1;
    assume Seq#Length(##chars#0) > 1;
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) == JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon10;

  anon14_Else:
    assume {:partition} LitInt(0) > n#0;
    assume $Is(0 - n#0, Tclass._System.nat());
    ##n#1 := 0 - n#0;
    assume $IsAlloc(##n#1, Tclass._System.nat(), $Heap);
    ##chars#1 := chars#0;
    assume $IsAlloc(##chars#1, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    assume {:subsumption 0} Seq#Length(##chars#1) > 1;
    assume Seq#Length(##chars#1) > 1;
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(0 - n#0, chars#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, minus#0), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(0 - n#0, chars#0));
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(0 - n#0, chars#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()));
    goto anon10;

  anon10:
    assume JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) == str#0;
    return;
}



function JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly: LayerType, str#0: Seq, base#0: int, digits#0: Map) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: Box :: { Map#Domain(digits#0)[c#0] } { Seq#Contains(str#0, c#0) } $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#0) ==> Map#Domain(digits#0)[c#0])) ==> LitInt(0) <= JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#1: Box :: { Map#Domain(digits#0)[c#1] } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Map#Domain(digits#0)[c#1])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#2: Box :: { Map#Domain(digits#0)[c#2] } { Seq#Contains(str#0, c#2) } $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#2) ==> Map#Domain(digits#0)[c#2])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));
}

function JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0: Seq, base#0: int, digits#0: Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any(AsFuelBottom($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) == JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LZ, str#0, base#0, digits#0));

function JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires(LayerType, Seq, int, Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#1: Box :: { Map#Domain(digits#0)[c#1] } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Map#Domain(digits#0)[c#1])));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()))) returns (n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any(str#0: Seq, base#0: int, digits#0: Map) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: Box;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.ToNat_any", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(90,42): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 0;
    havoc c#3;
    assume $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, c#3);
    assume Map#Domain(digits#0)[c#3];
    goto anon4;

  anon10_Else:
    assume Seq#Contains(str#0, c#3) ==> Map#Domain(digits#0)[c#3];
    goto anon4;

  anon4:
    assume (forall c#0: Box :: { Map#Domain(digits#0)[c#0] } { Seq#Contains(str#0, c#0) } $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#0) ==> Map#Domain(digits#0)[c#0]);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume LitInt(0) <= JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == LitInt(0);
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon12_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(96,32)"} true;
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} (forall c#4: Box :: { Map#Domain(##digits#0)[c#4] } { Seq#Contains(##str#0, c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#0, c#4) ==> Map#Domain(##digits#0)[c#4]);
    assume (forall c#4: Box :: { Map#Domain(##digits#0)[c#4] } { Seq#Contains(##str#0, c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#0, c#4) ==> Map#Domain(##digits#0)[c#4]);
    assume 0 <= base#0 || Seq#Rank(##str#0) < Seq#Rank(str#0) || ##base#0 == base#0;
    assume Seq#Rank(##str#0) < Seq#Rank(str#0) || (Seq#Rank(##str#0) == Seq#Rank(str#0) && (##base#0 < base#0 || (##base#0 == base#0 && Set#Subset(Map#Domain(##digits#0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(##digits#0)))));
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume $Is(Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int, Tclass._System.nat());
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int;
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon9:
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == n#0;
    return;
}



procedure {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var c#0: Box;
  var c#2: Box;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(100,29): initial state"} true;
    assume base#0 > 0;
    havoc c#0;
    assume $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Seq#Contains(str#0, c#0);
    assume Map#Domain(digits#0)[c#0];
    goto anon4;

  anon8_Else:
    assume Seq#Contains(str#0, c#0) ==> Map#Domain(digits#0)[c#0];
    goto anon4;

  anon4:
    assume (forall c#1: Box :: { Map#Domain(digits#0)[c#1] } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Map#Domain(digits#0)[c#1]);
    havoc c#2;
    assume $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume Seq#Contains(str#0, c#2);
    assume Map#Domain(digits#0)[c#2];
    assume $Unbox(Map#Elements(digits#0)[c#2]): int < base#0;
    goto anon7;

  anon9_Else:
    assume Seq#Contains(str#0, c#2) ==> $Unbox(Map#Elements(digits#0)[c#2]): int < base#0;
    goto anon7;

  anon7:
    assume (forall c#3: Box :: { $Unbox(Map#Elements(digits#0)[c#3]): int } { Seq#Contains(str#0, c#3) } $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#3) ==> $Unbox(Map#Elements(digits#0)[c#3]): int < base#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(104,43): post-state"} true;
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} (forall c#4: Box :: { Map#Domain(##digits#0)[c#4] } { Seq#Contains(##str#0, c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#0, c#4) ==> Map#Domain(##digits#0)[c#4]);
    assume (forall c#4: Box :: { Map#Domain(##digits#0)[c#4] } { Seq#Contains(##str#0, c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#0, c#4) ==> Map#Domain(##digits#0)[c#4]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#0 := Seq#Length(str#0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
    return;
}



procedure {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (call precondtion)"} CallPre$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap));
  requires {:id "id21024"} base#0 > 0;
  requires {:id "id21025"} (forall c#1: Box :: { Map#Domain(digits#0)[c#1] } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Map#Domain(digits#0)[c#1]);
  requires {:id "id21026"} (forall c#3: Box :: { $Unbox(Map#Elements(digits#0)[c#3]): int } { Seq#Contains(str#0, c#3) } $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#3) ==> $Unbox(Map#Elements(digits#0)[c#3]): int < base#0);



procedure {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id21027"} JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (correctness)"} Impl$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id21028"} base#0 > 0;
  requires {:id "id21029"} (forall c#1: Box :: { Map#Domain(digits#0)[c#1] } { Seq#Contains(str#0, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#1) ==> Map#Domain(digits#0)[c#1]);
  requires {:id "id21030"} (forall c#3: Box :: { $Unbox(Map#Elements(digits#0)[c#3]): int } { Seq#Contains(str#0, c#3) } $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#3) ==> $Unbox(Map#Elements(digits#0)[c#3]): int < base#0);
  modifies $Heap;
  free ensures JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id21031"} JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (correctness)"} Impl$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##b#1_0_0_1: int;
  var ##e#1_0_0_1: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var ##str#1_0_2_0: Seq;
  var ##base#1_0_2_0: int;
  var ##digits#1_0_2_0: Map;
  var str##1_0_2_0: Seq;
  var base##1_0_2_0: int;
  var digits##1_0_2_0: Map;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##str#1_0_3_0: Seq;
  var ##base#1_0_3_0: int;
  var ##digits#1_0_3_0: Map;
  var ##str#1_0_3_1: Seq;
  var ##base#1_0_3_1: int;
  var ##digits#1_0_3_1: Map;
  var ##str#1_0_4_0: Seq;
  var ##base#1_0_4_0: int;
  var ##digits#1_0_4_0: Map;
  var ##str#1_0_4_1: Seq;
  var ##base#1_0_4_1: int;
  var ##digits#1_0_4_1: Map;
  var ##str#1_0_0: Seq;
  var ##base#1_0_0: int;
  var ##digits#1_0_0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(105,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(107,19)"} true;
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##str#1_0_0 := str#0;
    assume $IsAlloc(##str#1_0_0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_0 := digits#0;
    assume $IsAlloc(##digits#1_0_0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 0;
    assume {:subsumption 0} (forall c#1_0_0: Box :: { Map#Domain(##digits#1_0_0)[c#1_0_0] } { Seq#Contains(##str#1_0_0, c#1_0_0) } $IsBox(c#1_0_0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1_0_0, c#1_0_0) ==> Map#Domain(##digits#1_0_0)[c#1_0_0]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume false;
    goto anon9;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##str#1_0_4_0 := str#0;
    assume $IsAlloc(##str#1_0_4_0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1_0_4_0 := base#0;
    assume $IsAlloc(##base#1_0_4_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_0 := digits#0;
    assume $IsAlloc(##digits#1_0_4_0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_0 > 0;
    assume {:subsumption 0} (forall c#1_0_4_0: Box :: { Map#Domain(##digits#1_0_4_0)[c#1_0_4_0] } { Seq#Contains(##str#1_0_4_0, c#1_0_4_0) } $IsBox(c#1_0_4_0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1_0_4_0, c#1_0_4_0) ==> Map#Domain(##digits#1_0_4_0)[c#1_0_4_0]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_4_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_4_1, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1_0_4_1 := base#0;
    assume $IsAlloc(##base#1_0_4_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_1 := digits#0;
    assume $IsAlloc(##digits#1_0_4_1, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_1 > 0;
    assume {:subsumption 0} (forall c#1_0_4_1: Box :: { Map#Domain(##digits#1_0_4_1)[c#1_0_4_1] } { Seq#Contains(##str#1_0_4_1, c#1_0_4_1) } $IsBox(c#1_0_4_1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1_0_4_1, c#1_0_4_1) ==> Map#Domain(##digits#1_0_4_1)[c#1_0_4_1]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) <= Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1_0_3_0 := base#0;
    assume $IsAlloc(##base#1_0_3_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_0 := digits#0;
    assume $IsAlloc(##digits#1_0_3_0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_0 > 0;
    assume {:subsumption 0} (forall c#1_0_3_0: Box :: { Map#Domain(##digits#1_0_3_0)[c#1_0_3_0] } { Seq#Contains(##str#1_0_3_0, c#1_0_3_0) } $IsBox(c#1_0_3_0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1_0_3_0, c#1_0_3_0) ==> Map#Domain(##digits#1_0_3_0)[c#1_0_3_0]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_1, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1_0_3_1 := base#0;
    assume $IsAlloc(##base#1_0_3_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_1 := digits#0;
    assume $IsAlloc(##digits#1_0_3_1, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_1 > 0;
    assume {:subsumption 0} (forall c#1_0_3_1: Box :: { Map#Domain(##digits#1_0_3_1)[c#1_0_3_1] } { Seq#Contains(##str#1_0_3_1, c#1_0_3_1) } $IsBox(c#1_0_3_1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1_0_3_1, c#1_0_3_1) ==> Map#Domain(##digits#1_0_3_1)[c#1_0_3_1]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int <= Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + base#0 - 1;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_2_0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1_0_2_0 := base#0;
    assume $IsAlloc(##base#1_0_2_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_2_0 := digits#0;
    assume $IsAlloc(##digits#1_0_2_0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_2_0 > 0;
    assume {:subsumption 0} (forall c#1_0_2_0: Box :: { Map#Domain(##digits#1_0_2_0)[c#1_0_2_0] } { Seq#Contains(##str#1_0_2_0, c#1_0_2_0) } $IsBox(c#1_0_2_0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1_0_2_0, c#1_0_2_0) ==> Map#Domain(##digits#1_0_2_0)[c#1_0_2_0]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    assume true;
    str##1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume true;
    base##1_0_2_0 := base#0;
    assume true;
    digits##1_0_2_0 := digits#0;
    assume 0 <= base#0 || Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || base##1_0_2_0 == base#0;
    assume Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0_2_0) == Seq#Rank(str#0) && (base##1_0_2_0 < base#0 || (base##1_0_2_0 == base#0 && Set#Subset(Map#Domain(digits##1_0_2_0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(digits##1_0_2_0)))));
    call CallPre$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    call CallPost$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(113,55)"} true;
    call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(114,36)"} true;
    ##b#1_0_2_0 := base#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_2_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume {:subsumption 0} Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LS($LZ)), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + base#0 - 1 <= Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0) - 1) - 1, base#0) + base#0 - 1;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##b#1_0_1_0 := base#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(116,40)"} true;
    ##b#1_0_1_1 := base#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_1 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0) - 1) - 1, base#0) + base#0 - 1 <= Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0) - 1), base#0) - 1;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    ##b#1_0_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_0_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(118,23)"} true;
    call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(118,53)"} true;
    ##b#1_0_0_1 := base#0;
    assume $IsAlloc(##b#1_0_0_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#1_0_0_1 := Seq#Length(str#0);
    assume $IsAlloc(##e#1_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume {:subsumption 0} Mul(Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0) - 1), base#0) - 1 <= Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) - 1;
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) - 1;
    return;
}



function JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0: Seq, minus#0: Box, base#0: int, digits#0: Map) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));
axiom 2 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Map#Domain(digits#0)[$l#2#c#0])), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
axiom 2 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(Map#Domain(digits#0)[$l#3#c#0])), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
}

function JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0: Seq, minus#0: Box, base#0: int, digits#0: Map) : bool;

function JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(Seq, Box, int, Map) : bool;

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.Utils.Str.ParametricConversion.ToInt_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), minus#0: Box where $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()))) returns (s#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricConversion.ToInt_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0: Seq, minus#0: Box, base#0: int, digits#0: Map) returns (s#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: Box;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##str#0: Seq;
  var ##minus#0: Box;
  var ##is_digit#0: HandleType;
  var ##str#1: Seq;
  var ##base#0: int;
  var ##digits#0: Map;
  var ##str#2: Seq;
  var ##base#1: int;
  var ##digits#1: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.ToInt_any", " | ", str#0, " | ", minus#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Box", " | ", "int", " | ", "Map"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(124,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 0;
    assume !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 <==> Map#Domain(digits#0)[c#0];
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon4;

  anon14_Else:
    assume {:partition} !($IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon13_Else:
    goto anon5;

  anon5:
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##minus#0 := minus#0;
    assume $IsAllocBox(##minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap);
    ##is_digit#0 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(Map#Domain(digits#0)[$l#5#c#0])), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool), $Heap);
    assume JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(Map#Domain(digits#0)[$l#6#c#0])), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Map#Domain(digits#0)[$l#7#c#0])), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume false;
    return;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    ##str#1 := Seq#Drop(str#0, LitInt(1));
    assume $IsAlloc(##str#1, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} (forall c#1: Box :: { Map#Domain(##digits#0)[c#1] } { Seq#Contains(##str#1, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1, c#1) ==> Map#Domain(##digits#0)[c#1]);
    assume (forall c#1: Box :: { Map#Domain(##digits#0)[c#1] } { Seq#Contains(##str#1, c#1) } $IsBox(c#1, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#1, c#1) ==> Map#Domain(##digits#0)[c#1]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0), TInt);
    goto anon12;

  anon16_Else:
    assume {:partition} !(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    goto anon11;

  anon17_Else:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11;

  anon11:
    assume true;
    assume Seq#Equal(str#0, Seq#Empty(): Seq) || Seq#Equal(str#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), Seq#Drop(str#0, LitInt(1))));
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(131,54)"} true;
    ##str#2 := str#0;
    assume $IsAlloc(##str#2, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, Tclass._System.nat(), $Heap);
    ##digits#1 := digits#0;
    assume $IsAlloc(##digits#1, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1 > 0;
    assume ##base#1 > 0;
    assume {:subsumption 0} (forall c#2: Box :: { Map#Domain(##digits#1)[c#2] } { Seq#Contains(##str#2, c#2) } $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#2, c#2) ==> Map#Domain(##digits#1)[c#2]);
    assume (forall c#2: Box :: { Map#Domain(##digits#1)[c#2] } { Seq#Contains(##str#2, c#2) } $IsBox(c#2, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(##str#2, c#2) ==> Map#Domain(##digits#1)[c#2]);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0);
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume $Is(JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0), TInt);
    goto anon12;

  anon12:
    assume JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == s#0;
    return;
}



const unique class.JSON_mUtils_mStr_mParametricConversion.Char: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#156 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#156))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#158 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#158)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#234 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#234))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#236 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#236)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#238 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#238)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#234 := Wrappers.Option.value(this); v#234)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#236 := Lit(Wrappers.Option.value(Lit(this))); v#236)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#238 := Lit(Wrappers.Option.value(Lit(this))); v#238)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#156 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#156)) else (var e#156 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#158 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#158))) else (var e#158 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#234 := Wrappers.Result.value(this); s#234) else (var e#234 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#236 := Lit(Wrappers.Result.value(Lit(this))); s#236) else (var e#236 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#238 := Lit(Wrappers.Result.value(Lit(this))); s#238) else (var e#238 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#234 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#234)) else (var e#234 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#234)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#236 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#236))) else (var e#236 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#236)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#238 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#238))) else (var e#238 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#238)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#48: int, y#48: int :: { Mul(x#48, y#48) } Mul(x#48, y#48) == Mul(y#48, x#48)) && (forall x#49: int, y#49: int, z#32: int :: { Mul(x#49 + y#49, z#32) } Mul(x#49 + y#49, z#32) == Mul(x#49, z#32) + Mul(y#49, z#32)) && (forall x#50: int, y#50: int, z#33: int :: { Mul(x#50 - y#50, z#33) } Mul(x#50 - y#50, z#33) == Mul(x#50, z#33) - Mul(y#50, z#33));

axiom MulInternals.__default.MulAuto() <==> (forall x#51: int, y#51: int :: { Mul(x#51, y#51) } Mul(x#51, y#51) == Mul(y#51, x#51)) && (forall x#52: int, y#52: int, z#34: int :: { Mul(x#52 + y#52, z#34) } Mul(x#52 + y#52, z#34) == Mul(x#52, z#34) + Mul(y#52, z#34)) && (forall x#53: int, y#53: int, z#35: int :: { Mul(x#53 - y#53, z#35) } Mul(x#53 - y#53, z#35) == Mul(x#53, z#35) - Mul(y#53, z#35));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#48: int :: { Mod(Mod(x#48, n#0), n#0) } Mod(Mod(x#48, n#0), n#0) == Mod(x#48, n#0)) && (forall x#49: int :: { Mod(x#49, n#0) } LitInt(0) <= x#49 && x#49 < n#0 <==> Mod(x#49, n#0) == x#49) && (forall x#50: int, y#24: int :: { Mod(x#50 + y#24, n#0) } (var z#22 := Mod(x#50, n#0) + Mod(y#24, n#0); (LitInt(0) <= z#22 && z#22 < n#0 && Mod(x#50 + y#24, n#0) == z#22) || (n#0 <= z#22 && z#22 < n#0 + n#0 && Mod(x#50 + y#24, n#0) == z#22 - n#0))) && (forall x#51: int, y#25: int :: { Mod(x#51 - y#25, n#0) } (var z#23 := Mod(x#51, n#0) - Mod(y#25, n#0); (LitInt(0) <= z#23 && z#23 < n#0 && Mod(x#51 - y#25, n#0) == z#23) || (0 - n#0 <= z#23 && z#23 < 0 && Mod(x#51 - y#25, n#0) == z#23 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#52: int :: { Mod(Mod(x#52, n#0), n#0) } Mod(Mod(x#52, LitInt(n#0)), LitInt(n#0)) == Mod(x#52, LitInt(n#0))) && (forall x#53: int :: { Mod(x#53, n#0) } LitInt(0) <= x#53 && x#53 < n#0 <==> Mod(x#53, LitInt(n#0)) == x#53) && (forall x#54: int, y#26: int :: { Mod(x#54 + y#26, n#0) } (var z#24 := Mod(x#54, LitInt(n#0)) + Mod(y#26, LitInt(n#0)); (LitInt(0) <= z#24 && z#24 < n#0 && Mod(x#54 + y#26, LitInt(n#0)) == z#24) || (LitInt(n#0) <= z#24 && z#24 < n#0 + n#0 && Mod(x#54 + y#26, LitInt(n#0)) == z#24 - n#0))) && (forall x#55: int, y#27: int :: { Mod(x#55 - y#27, n#0) } (var z#25 := Mod(x#55, LitInt(n#0)) - Mod(y#27, LitInt(n#0)); (LitInt(0) <= z#25 && z#25 < n#0 && Mod(x#55 - y#27, LitInt(n#0)) == z#25) || (LitInt(0 - n#0) <= z#25 && z#25 < 0 && Mod(x#55 - y#27, LitInt(n#0)) == z#25 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#30: int :: { Div(x#30, n#0) } LitInt(0) <= x#30 && x#30 < n#0 <==> Div(x#30, n#0) == LitInt(0)) && (forall x#31: int, y#20: int :: { Div(x#31 + y#20, n#0) } (var z#18 := Mod(x#31, n#0) + Mod(y#20, n#0); (LitInt(0) <= z#18 && z#18 < n#0 && Div(x#31 + y#20, n#0) == Div(x#31, n#0) + Div(y#20, n#0)) || (n#0 <= z#18 && z#18 < n#0 + n#0 && Div(x#31 + y#20, n#0) == Div(x#31, n#0) + Div(y#20, n#0) + 1))) && (forall x#32: int, y#21: int :: { Div(x#32 - y#21, n#0) } (var z#19 := Mod(x#32, n#0) - Mod(y#21, n#0); (LitInt(0) <= z#19 && z#19 < n#0 && Div(x#32 - y#21, n#0) == Div(x#32, n#0) - Div(y#21, n#0)) || (0 - n#0 <= z#19 && z#19 < 0 && Div(x#32 - y#21, n#0) == Div(x#32, n#0) - Div(y#21, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#33: int :: { Div(x#33, n#0) } LitInt(0) <= x#33 && x#33 < n#0 <==> Div(x#33, LitInt(n#0)) == LitInt(0)) && (forall x#34: int, y#22: int :: { Div(x#34 + y#22, n#0) } (var z#20 := Mod(x#34, LitInt(n#0)) + Mod(y#22, LitInt(n#0)); (LitInt(0) <= z#20 && z#20 < n#0 && Div(x#34 + y#22, LitInt(n#0)) == Div(x#34, LitInt(n#0)) + Div(y#22, LitInt(n#0))) || (LitInt(n#0) <= z#20 && z#20 < n#0 + n#0 && Div(x#34 + y#22, LitInt(n#0)) == Div(x#34, LitInt(n#0)) + Div(y#22, LitInt(n#0)) + 1))) && (forall x#35: int, y#23: int :: { Div(x#35 - y#23, n#0) } (var z#21 := Mod(x#35, LitInt(n#0)) - Mod(y#23, LitInt(n#0)); (LitInt(0) <= z#21 && z#21 < n#0 && Div(x#35 - y#23, LitInt(n#0)) == Div(x#35, LitInt(n#0)) - Div(y#23, LitInt(n#0))) || (LitInt(0 - n#0) <= z#21 && z#21 < 0 && Div(x#35 - y#23, LitInt(n#0)) == Div(x#35, LitInt(n#0)) - Div(y#23, LitInt(n#0)) - 1)))));

axiom (forall $ly: LayerType, $reveal: bool, base#0: int, pow#0: int :: { Logarithm.__default.Log($ly, $reveal, base#0, pow#0) } Logarithm.__default.Log#canCall(base#0, pow#0) || (LitInt(0) <= base#0 && LitInt(0) <= pow#0 && base#0 > 1) ==> LitInt(0) <= Logarithm.__default.Log($ly, $reveal, base#0, pow#0));

axiom (forall $ly: LayerType, base#0: int, pow#0: int :: { Logarithm.__default.Log($LS($ly), true, base#0, pow#0) } Logarithm.__default.Log#canCall(base#0, pow#0) || (LitInt(0) <= base#0 && LitInt(0) <= pow#0 && base#0 > 1) ==> (base#0 <= pow#0 ==> Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0))) && Logarithm.__default.Log($LS($ly), true, base#0, pow#0) == (if pow#0 < base#0 then 0 else 1 + Logarithm.__default.Log($ly, reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0))));

axiom (forall $ly: LayerType, base#0: int, pow#0: int :: {:weight 3} { Logarithm.__default.Log($LS($ly), true, base#0, LitInt(pow#0)) } Logarithm.__default.Log#canCall(base#0, LitInt(pow#0)) || (LitInt(0) <= base#0 && LitInt(0) <= pow#0 && base#0 > 1) ==> (base#0 <= pow#0 ==> Logarithm.__default.Log#canCall(base#0, Div(pow#0, base#0))) && Logarithm.__default.Log($LS($ly), true, base#0, LitInt(pow#0)) == (if pow#0 < base#0 then 0 else 1 + Logarithm.__default.Log($LS($ly), reveal_Logarithm._default.Log, base#0, Div(pow#0, base#0))));

axiom (forall $ly: LayerType, base#0: int, pow#0: int :: {:weight 3} { Logarithm.__default.Log($LS($ly), true, LitInt(base#0), LitInt(pow#0)) } Logarithm.__default.Log#canCall(LitInt(base#0), LitInt(pow#0)) || (LitInt(0) <= base#0 && LitInt(0) <= pow#0 && Lit(base#0 > 1)) ==> (!Lit(pow#0 < base#0) ==> Logarithm.__default.Log#canCall(LitInt(base#0), LitInt(Div(pow#0, LitInt(base#0))))) && Logarithm.__default.Log($LS($ly), true, LitInt(base#0), LitInt(pow#0)) == (if pow#0 < base#0 then 0 else 1 + Logarithm.__default.Log($LS($ly), reveal_Logarithm._default.Log, LitInt(base#0), LitInt(Div(pow#0, LitInt(base#0))))));

const unique class.JSON_mUtils_mStr_mParametricEscaping.__default: ClassName;

function JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) } (JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) && (!special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0))) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if special#0[Seq#Index(str#0, LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, escape#0), Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0))) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, escape#0), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), Lit(escape#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0)))) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, Lit(escape#0)), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))))));
}

function JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0: Seq, special#0: Set, escape#0: Box) : bool;

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) == JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape(AsFuelBottom($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0) == JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LZ, str#0, special#0, escape#0));

function Tclass.JSON_mUtils_mStr_mParametricEscaping.Char() : Ty;

function JSON_mUtils_mStr_mParametricEscaping.__default.Escape#requires(LayerType, Seq, Set, Box) : bool;

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape#requires($ly, str#0, special#0, escape#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) ==> (JSON_mUtils_mStr_mParametricEscaping.__default.Escape#requires($ly, str#0, special#0, escape#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.ParametricEscaping.Escape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricEscaping.__default.Escape(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())), special#0: Set where $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())), escape#0: Box where $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricEscaping.Escape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricEscaping.__default.Escape(str#0: Seq, special#0: Set, escape#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##str#0: Seq;
  var ##special#0: Set;
  var ##escape#0: Box;
  var ##str#1: Seq;
  var ##special#1: Set;
  var ##escape#1: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricEscaping.Escape", " | ", str#0, " | ", special#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set", " | ", "Box"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(142,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0) == str#0;
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
    return;

  anon9_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} special#0[Seq#Index(str#0, LitInt(0))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    ##str#0 := Seq#Drop(str#0, LitInt(1));
    assume $IsAlloc(##str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    ##special#0 := special#0;
    assume $IsAlloc(##special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    ##escape#0 := escape#0;
    assume $IsAllocBox(##escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap);
    assume Seq#Rank(##str#0) < Seq#Rank(str#0) || (Seq#Rank(##str#0) == Seq#Rank(str#0) && Set#Subset(##special#0, special#0) && !Set#Subset(special#0, ##special#0));
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0) == Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, escape#0), Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), Seq#Drop(str#0, LitInt(1)), special#0, escape#0));
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0);
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
    return;

  anon10_Else:
    assume {:partition} !special#0[Seq#Index(str#0, LitInt(0))];
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    ##str#1 := Seq#Drop(str#0, LitInt(1));
    assume $IsAlloc(##str#1, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    ##special#1 := special#0;
    assume $IsAlloc(##special#1, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    ##escape#1 := escape#0;
    assume $IsAllocBox(##escape#1, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap);
    assume Seq#Rank(##str#1) < Seq#Rank(str#0) || (Seq#Rank(##str#1) == Seq#Rank(str#0) && Set#Subset(##special#1, special#0) && !Set#Subset(special#0, ##special#1));
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), Seq#Drop(str#0, LitInt(1)), special#0, escape#0));
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0);
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
    return;
}



function JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly: LayerType, str#0: Seq, escape#0: Box) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, $ly: LayerType, str#0: Seq, escape#0: Box :: { $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap) } (JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#0 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#0)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#0 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#0))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#0 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#0) else (var tl#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#0)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#0 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#0) else (var tl#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#1)))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#1 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#1)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#1 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#1))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#1 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#1) else (var tl#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#2)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#1 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#1) else (var tl#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#3)))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#2 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#2)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#2 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#2))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#2 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#2) else (var tl#4 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#2)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#4)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#2 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#2) else (var tl#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#2)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#5)))))))));
}

function JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0: Seq, escape#0: Box) : bool;

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape(AsFuelBottom($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0) == JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LZ, str#0, escape#0));

function Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) == Tagclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError && TagFamily(Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) == tytagFamily$UnescapeError;
}

const unique Tagclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) } $IsBox(bx, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));

function JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#requires(LayerType, Seq, Box) : bool;

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#requires($ly, str#0, escape#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) ==> (JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#requires($ly, str#0, escape#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())), escape#0: Box where $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape(str#0: Seq, escape#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: Seq;
  var ##escape#0: Box;
  var tl#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##str#1: Seq;
  var ##escape#1: Box;
  var tl#Z#1: Seq;
  var let#3#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricEscaping.Unescape", " | ", str#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Box"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(151,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == #Wrappers.Result.Success($Box(str#0));
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    return;

  anon15_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Index(str#0, LitInt(0)) == escape#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Length(str#0) > 1;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(str#0);
    ##str#0 := Seq#Drop(str#0, LitInt(2));
    assume $IsAlloc(##str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    ##escape#0 := escape#0;
    assume $IsAllocBox(##escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap);
    assume Seq#Rank(##str#0) < Seq#Rank(str#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0);
    assume let#0#0#0 == JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), Seq#Drop(str#0, LitInt(2)), escape#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#Z#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#Z#0);
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    return;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#Z#0);
    havoc tl#Z#0;
    assume $Is(tl#Z#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(tl#Z#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
    assume tl#Z#0 == let#1#0#0;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(str#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#Z#0)));
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    return;

  anon17_Else:
    assume {:partition} 1 >= Seq#Length(str#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS()))));
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    return;

  anon16_Else:
    assume {:partition} Seq#Index(str#0, LitInt(0)) != escape#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    ##str#1 := Seq#Drop(str#0, LitInt(1));
    assume $IsAlloc(##str#1, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    ##escape#1 := escape#0;
    assume $IsAllocBox(##escape#1, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap);
    assume Seq#Rank(##str#1) < Seq#Rank(str#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0);
    assume let#2#0#0 == JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), Seq#Drop(str#0, LitInt(1)), escape#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0);
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#Z#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#Z#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#Z#0);
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    return;

  anon19_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#Z#0);
    havoc tl#Z#1;
    assume $Is(tl#Z#1, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(tl#Z#1, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()));
    assume tl#Z#1 == let#3#0#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#Z#1)));
    assume true;
    assume $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()));
    return;
}



procedure {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape_Escape (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), special#0: Set where $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), escape#0: Box where $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape_Escape (call precondtion)"} CallPre$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), special#0: Set where $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), escape#0: Box where $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap));
  requires {:id "id21149"} special#0[escape#0];



procedure {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape_Escape (call postcondition)"} CallPost$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), special#0: Set where $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), escape#0: Box where $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0)) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0);
  free ensures {:id "id21150"} Wrappers.Result#Equal(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LS($LZ)), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LS($LZ)), str#0, special#0, escape#0), escape#0), #Wrappers.Result.Success($Box(str#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape_Escape (correctness)"} Impl$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), special#0: Set where $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap), escape#0: Box where $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  requires {:id "id21151"} special#0[escape#0];
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LZ), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0)) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0);
  free ensures {:id "id21152"} Wrappers.Result#Equal(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($LS($LZ)), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($LS($LZ)), str#0, special#0, escape#0), escape#0), #Wrappers.Result.Success($Box(str#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape_Escape (correctness)"} Impl$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0: Seq, special#0: Set, escape#0: Box) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var str##1_0: Seq;
  var special##1_0: Set;
  var escape##1_0: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricEscaping.Unescape_Escape", " | ", str#0, " | ", special#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(162,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    return;

  anon3_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    assume true;
    assume Seq#Equal(str#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), Seq#Drop(str#0, LitInt(1))));
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(165,41)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    assume true;
    str##1_0 := Seq#Drop(str#0, LitInt(1));
    assume true;
    special##1_0 := special#0;
    assume true;
    escape##1_0 := escape#0;
    assume Seq#Rank(str##1_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0) == Seq#Rank(str#0) && Set#Subset(special##1_0, special#0) && !Set#Subset(special#0, special##1_0));
    call CallPre$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str##1_0, special##1_0, escape##1_0);
    call CallPost$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str##1_0, special##1_0, escape##1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(166,50)"} true;
    return;
}



const unique class.JSON_mUtils_mStr_mParametricEscaping.Char: ClassName;

function #JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS()) == ##JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS;
axiom $Is(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS(), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError());
axiom #JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS() == Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS());
}

const unique ##JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS()) == ##JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS;
}

function JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d) } JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS);

axiom (forall d: DatatypeType :: { JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d) } JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d) ==> d == #JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), $h));

function $IsA#JSON_mUtils_mStr_mParametricEscaping.UnescapeError(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mStr_mParametricEscaping.UnescapeError(d) } $IsA#JSON_mUtils_mStr_mParametricEscaping.UnescapeError(d) ==> JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d), $Is(d, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) } $Is(d, Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()) ==> JSON_mUtils_mStr_mParametricEscaping.UnescapeError.EscapeAtEOS_q(d));

function JSON_mUtils_mStr_mParametricEscaping.UnescapeError#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mStr_mParametricEscaping.UnescapeError#Equal(a, b) } JSON_mUtils_mStr_mParametricEscaping.UnescapeError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mStr_mParametricEscaping.UnescapeError#Equal(a, b) } JSON_mUtils_mStr_mParametricEscaping.UnescapeError#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mStr_mParametricEscaping.UnescapeError: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#160 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#160))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#162 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#162)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#240 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#240))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#242 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#242)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#244 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#244)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#240 := Wrappers.Option.value(this); v#240)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#242 := Lit(Wrappers.Option.value(Lit(this))); v#242)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#244 := Lit(Wrappers.Option.value(Lit(this))); v#244)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#160 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#160)) else (var e#160 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#162 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#162))) else (var e#162 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#240 := Wrappers.Result.value(this); s#240) else (var e#240 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#242 := Lit(Wrappers.Result.value(Lit(this))); s#242) else (var e#242 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#244 := Lit(Wrappers.Result.value(Lit(this))); s#244) else (var e#244 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#240 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#240)) else (var e#240 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#240)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#242 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#242))) else (var e#242 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#242)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#244 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#244))) else (var e#244 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#244)))));

const unique tytagFamily$UnescapeError: TyTagFamily;

const unique class.JSON_mUtils_mStr_mCharStrConversion.__default: ClassName;

function JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly: LayerType, n#0: int, base#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#0: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#0 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#0 := Seq#Append(digits'#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#1 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#1 := Seq#Append(digits'#1, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#2 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#2 := Seq#Append(digits'#2, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#2))));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0: int, base#0: int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits(AsFuelBottom($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LZ, n#0, base#0));

function JSON_mUtils_mStr_mCharStrConversion.__default.Digits#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits#requires($ly, n#0, base#0) } LitInt(0) <= n#0 ==> (JSON_mUtils_mStr_mCharStrConversion.__default.Digits#requires($ly, n#0, base#0) <==> base#0 > 1));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.Digits(n#0: int where LitInt(0) <= n#0, base#0: int) returns (digits#3: Seq where $Is(digits#3, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.CharStrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.Digits(n#0: int, base#0: int) returns (digits#3: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var d#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var digits'#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#1: int;
  var digits#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##base#2: int;
  var ##pow#1: int;
  var base##1_0_0: int;
  var pow##1_0_0: int;
  var d##1_0_0_0: int;
  var base##1_1_0: int;
  var pow##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrConversion.Digits", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume n#0 == LitInt(0);
    assume Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon30_Else:
    assume n#0 == LitInt(0) ==> Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume n#0 > 0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon31_Else:
    assume n#0 > 0 ==> Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon8:
    havoc d#2;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume Seq#Contains(digits#3, $Box(d#2));
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= d#2;
    goto anon11;

  anon33_Else:
    assume {:partition} d#2 < LitInt(0);
    goto anon11;

  anon11:
    assume LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon32_Else:
    assume Seq#Contains(digits#3, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon13:
    assume (forall d#1: int :: { Seq#Contains(digits#3, $Box(d#1)) } Seq#Contains(digits#3, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);
    assume false;
    return;

  anon29_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} n#0 == LitInt(0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](35,49)"} true;
    assume true;
    assume false;
    goto anon17;

  anon35_Else:
    goto anon17;

  anon17:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, LitInt(0)) == LitInt(1);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](35,52)"} true;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon34_Else:
    assume {:partition} n#0 != LitInt(0);
    free call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](38,29)"} true;
    free call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](38,54)"} true;
    havoc digits'#Z#0;
    assume $Is(digits'#Z#0, TSeq(TInt)) && $IsAlloc(digits'#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume $Is(Div(n#0, base#0), Tclass._System.nat());
    ##n#0 := Div(n#0, base#0);
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume 0 <= n#0 || ##n#0 == n#0;
    assume ##n#0 < n#0;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume let#0#0#0 == JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), Div(n#0, base#0), base#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume $Is(let#0#0#0, TSeq(TInt));
    assume digits'#Z#0 == let#0#0#0;
    havoc digits#Z#0;
    assume $Is(digits#Z#0, TSeq(TInt)) && $IsAlloc(digits#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume let#1#0#0 == Seq#Append(digits'#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))));
    assume true;
    assume $Is(let#1#0#0, TSeq(TInt));
    assume digits#Z#0 == let#1#0#0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#2 := base#0;
    assume $IsAlloc(##base#2, Tclass._System.nat(), $Heap);
    ##pow#1 := n#0;
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#2 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume true;
    assume Seq#Length(digits#Z#0) == Seq#Length(digits'#Z#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](42,42)"} true;
    assume true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} n#0 < base#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_0_0 := base#0;
    assume true;
    pow##1_0_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    call CallPost$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](44,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume true;
    d##1_0_0_0 := base#0;
    call CallPre$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    call CallPost$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](45,57)"} true;
    assume Div(n#0, base#0) == LitInt(0);
    assume false;
    goto anon22;

  anon38_Else:
    goto anon22;

  anon22:
    assume Div(n#0, base#0) == LitInt(0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](45,59)"} true;
    goto anon26;

  anon37_Else:
    assume {:partition} base#0 <= n#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_1_0 := base#0;
    assume true;
    pow##1_1_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](47,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    call CallPre$$DivMod.__default.LemmaDivNonZeroAuto();
    call CallPost$$DivMod.__default.LemmaDivNonZeroAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](48,58)"} true;
    assume Div(n#0, base#0) > 0;
    assume false;
    goto anon25;

  anon39_Else:
    goto anon25;

  anon25:
    assume Div(n#0, base#0) > 0;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](48,60)"} true;
    goto anon26;

  anon26:
    assume true;
    assume false;
    goto anon27;

  anon36_Else:
    goto anon27;

  anon27:
    assume Seq#Length(digits#Z#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](50,8)"} true;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#Z#0;
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon28:
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#3;
    return;
}



function JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly: LayerType, digits#0: Seq, chars#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#0: char :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#2: int :: { Seq#Contains(digits#0, $Box(d#2)) } Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0: Seq, chars#0: Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits(AsFuelBottom($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LZ, digits#0, chars#0));

function JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.OfDigits (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits(digits#0: Seq where $Is(digits#0, TSeq(TInt)), chars#0: Seq where $Is(chars#0, TSeq(TChar))) returns (str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#0: char :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#0 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#0 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0))));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#1 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#1) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#1 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0)))));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0: int, chars#0: Seq) : bool;

function JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#requires(int, Seq) : bool;

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#requires(n#0, chars#0) } LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#requires(n#0, chars#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0: int where LitInt(0) <= n#0, chars#0: Seq where $Is(chars#0, TSeq(TChar))) returns (str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.CharStrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var c#2: char;
  var base#Z#0: int;
  var let#0#0#0: int;
  var ##n#0: int;
  var ##base#1: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrConversion.OfNat_any", " | ", n#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](66,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar));
    assume $Is(Seq#Length(chars#0), Tclass._System.nat());
    ##base#0 := Seq#Length(chars#0);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(Seq#Length(chars#0), n#0);
    assume Seq#Length(str#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1;
    havoc c#2;
    assume $Is(c#2, TChar);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(str#0, $Box(c#2));
    assume Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon11_Else:
    assume Seq#Contains(str#0, $Box(c#2)) ==> Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon5:
    assume (forall c#1: char :: { Seq#Contains(chars#0, $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(chars#0, $Box(c#1)));
    assume false;
    return;

  anon10_Else:
    havoc base#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(chars#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume base#Z#0 == let#0#0#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} n#0 == LitInt(0);
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](72,32)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(chars#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0)));
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar));
    goto anon9;

  anon12_Else:
    assume {:partition} n#0 != LitInt(0);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#Z#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#Z#0);
    ##digits#0 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0);
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(TChar), $Heap);
    assume true;
    assume (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#Z#0) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar));
    goto anon9;

  anon9:
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == str#0;
    return;
}



function JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0: Seq, minus#0: char, is_digit#0: HandleType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#0: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#0))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#0)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#0))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#1: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#1))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#1)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#1))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#2: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#2))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#2)) } $Is(c#2, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#2)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#2))): bool)));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0: Seq, minus#0: char, is_digit#0: HandleType) : bool;

function JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#requires(Seq, char, HandleType) : bool;

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.NumberStr (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0: Seq where $Is(str#0, TSeq(TChar)), minus#0: char where $Is(minus#0, TChar), is_digit#0: HandleType where $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0: int, chars#0: Seq, minus#0: char) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(Seq#Contains(chars#0, $l#0#c#0))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar)), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(0 - n#0, chars#0))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), Lit(minus#0)) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0: int, chars#0: Seq, minus#0: char) : bool;

function JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#requires(int, Seq, char) : bool;

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) } $Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.OfInt_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0: int, chars#0: Seq where $Is(chars#0, TSeq(TChar)), minus#0: char where $Is(minus#0, TChar)) returns (str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly: LayerType, str#0: Seq, base#0: int, digits#0: Map) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#0: char :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#1: char :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#2: char :: { Map#Domain(digits#0)[$Box(c#2)] } { Seq#Contains(str#0, $Box(c#2)) } $Is(c#2, TChar) && Seq#Contains(str#0, $Box(c#2)) ==> Map#Domain(digits#0)[$Box(c#2)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0: Seq, base#0: int, digits#0: Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any(AsFuelBottom($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LZ, str#0, base#0, digits#0));

function JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires(LayerType, Seq, int, Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#1: char :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any(str#0: Seq where $Is(str#0, TSeq(TChar)), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(TChar, Tclass._System.nat()))) returns (n#0: int where LitInt(0) <= n#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any(str#0: Seq, base#0: int, digits#0: Map) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: char;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrConversion.ToNat_any", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](90,42): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 0;
    havoc c#3;
    assume $Is(c#3, TChar);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, $Box(c#3));
    assume Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon10_Else:
    assume Seq#Contains(str#0, $Box(c#3)) ==> Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon4:
    assume (forall c#0: char :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)]);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume LitInt(0) <= JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == LitInt(0);
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon12_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](96,32)"} true;
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume true;
    assume ##base#0 > 0;
    assume true;
    assume (forall c#4: char :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume 0 <= base#0 || Seq#Rank(##str#0) < Seq#Rank(str#0) || ##base#0 == base#0;
    assume Seq#Rank(##str#0) < Seq#Rank(str#0) || (Seq#Rank(##str#0) == Seq#Rank(str#0) && (##base#0 < base#0 || (##base#0 == base#0 && Set#Subset(Map#Domain(##digits#0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(##digits#0)))));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume $Is(Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int, Tclass._System.nat());
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume $Is(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon9:
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == n#0;
    return;
}



procedure {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_bound (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(TChar, Tclass._System.nat())) && $IsAlloc(digits#0, TMap(TChar, Tclass._System.nat()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_bound (call precondtion)"} CallPre$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(TChar, Tclass._System.nat())) && $IsAlloc(digits#0, TMap(TChar, Tclass._System.nat()), $Heap));
  requires {:id "id21290"} base#0 > 0;
  requires {:id "id21291"} (forall c#1: char :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id21292"} (forall c#3: char :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } $Is(c#3, TChar) && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);



procedure {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(TChar, Tclass._System.nat())) && $IsAlloc(digits#0, TMap(TChar, Tclass._System.nat()), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id21293"} JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_bound (correctness)"} Impl$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(TChar, Tclass._System.nat())) && $IsAlloc(digits#0, TMap(TChar, Tclass._System.nat()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id21294"} base#0 > 0;
  requires {:id "id21295"} (forall c#1: char :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id21296"} (forall c#3: char :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } $Is(c#3, TChar) && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);
  modifies $Heap;
  free ensures JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id21297"} $_reverifyPost ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_bound (correctness)"} Impl$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##b#1_0_0_1: int;
  var ##e#1_0_0_1: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var ##str#1_0_2_0: Seq;
  var ##base#1_0_2_0: int;
  var ##digits#1_0_2_0: Map;
  var str##1_0_2_0: Seq;
  var base##1_0_2_0: int;
  var digits##1_0_2_0: Map;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##str#1_0_3_0: Seq;
  var ##base#1_0_3_0: int;
  var ##digits#1_0_3_0: Map;
  var ##str#1_0_3_1: Seq;
  var ##base#1_0_3_1: int;
  var ##digits#1_0_3_1: Map;
  var ##str#1_0_4_0: Seq;
  var ##base#1_0_4_0: int;
  var ##digits#1_0_4_0: Map;
  var ##str#1_0_4_1: Seq;
  var ##base#1_0_4_1: int;
  var ##digits#1_0_4_1: Map;
  var ##str#1_0_0: Seq;
  var ##base#1_0_0: int;
  var ##digits#1_0_0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](105,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](107,19)"} true;
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##str#1_0_0 := str#0;
    assume $IsAlloc(##str#1_0_0, TSeq(TChar), $Heap);
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_0 := digits#0;
    assume $IsAlloc(##digits#1_0_0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 0;
    assume {:subsumption 0} (forall c#1_0_0: char :: { Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)] } { Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) } $Is(c#1_0_0, TChar) && Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) ==> Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume false;
    goto anon9;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##str#1_0_4_0 := str#0;
    assume $IsAlloc(##str#1_0_4_0, TSeq(TChar), $Heap);
    ##base#1_0_4_0 := base#0;
    assume $IsAlloc(##base#1_0_4_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_0 := digits#0;
    assume $IsAlloc(##digits#1_0_4_0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_0 > 0;
    assume {:subsumption 0} (forall c#1_0_4_0: char :: { Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)] } { Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) } $Is(c#1_0_4_0, TChar) && Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) ==> Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_4_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_4_1, TSeq(TChar), $Heap);
    ##base#1_0_4_1 := base#0;
    assume $IsAlloc(##base#1_0_4_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_1 := digits#0;
    assume $IsAlloc(##digits#1_0_4_1, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_1 > 0;
    assume {:subsumption 0} (forall c#1_0_4_1: char :: { Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)] } { Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) } $Is(c#1_0_4_1, TChar) && Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) ==> Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_0, TSeq(TChar), $Heap);
    ##base#1_0_3_0 := base#0;
    assume $IsAlloc(##base#1_0_3_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_0 := digits#0;
    assume $IsAlloc(##digits#1_0_3_0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_0 > 0;
    assume {:subsumption 0} (forall c#1_0_3_0: char :: { Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)] } { Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) } $Is(c#1_0_3_0, TChar) && Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) ==> Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_1, TSeq(TChar), $Heap);
    ##base#1_0_3_1 := base#0;
    assume $IsAlloc(##base#1_0_3_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_1 := digits#0;
    assume $IsAlloc(##digits#1_0_3_1, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_1 > 0;
    assume {:subsumption 0} (forall c#1_0_3_1: char :: { Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)] } { Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) } $Is(c#1_0_3_1, TChar) && Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) ==> Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_2_0, TSeq(TChar), $Heap);
    ##base#1_0_2_0 := base#0;
    assume $IsAlloc(##base#1_0_2_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_2_0 := digits#0;
    assume $IsAlloc(##digits#1_0_2_0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_2_0 > 0;
    assume {:subsumption 0} (forall c#1_0_2_0: char :: { Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)] } { Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) } $Is(c#1_0_2_0, TChar) && Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) ==> Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    assume true;
    str##1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume true;
    base##1_0_2_0 := base#0;
    assume true;
    digits##1_0_2_0 := digits#0;
    assume 0 <= base#0 || Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || base##1_0_2_0 == base#0;
    assume Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0_2_0) == Seq#Rank(str#0) && (base##1_0_2_0 < base#0 || (base##1_0_2_0 == base#0 && Set#Subset(Map#Domain(digits##1_0_2_0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(digits##1_0_2_0)))));
    call CallPre$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    call CallPost$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](113,55)"} true;
    free call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](114,36)"} true;
    ##b#1_0_2_0 := base#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_2_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##b#1_0_1_0 := base#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](116,40)"} true;
    ##b#1_0_1_1 := base#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_1 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    ##b#1_0_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_0_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](118,23)"} true;
    free call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrConversion](118,53)"} true;
    ##b#1_0_0_1 := base#0;
    assume $IsAlloc(##b#1_0_0_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#1_0_0_1 := Seq#Length(str#0);
    assume $IsAlloc(##e#1_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume true;
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) - 1;
    return;
}



function JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0: Seq, minus#0: char, base#0: int, digits#0: Map) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TChar)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Map#Domain(digits#0)[$l#2#c#0])), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar)), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(Map#Domain(digits#0)[$l#3#c#0])), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar)), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
}

function JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0: Seq, minus#0: char, base#0: int, digits#0: Map) : bool;

function JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(Seq, char, int, Map) : bool;

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TChar)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.Utils.Str.CharStrConversion.ToInt_any (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0: Seq where $Is(str#0, TSeq(TChar)), minus#0: char where $Is(minus#0, TChar), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(TChar, Tclass._System.nat()))) returns (s#0: int);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#164 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#164))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#166 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#166)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#246 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#246))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#248 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#248)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#250 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#250)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#246 := Wrappers.Option.value(this); v#246)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#248 := Lit(Wrappers.Option.value(Lit(this))); v#248)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#250 := Lit(Wrappers.Option.value(Lit(this))); v#250)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#164 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#164)) else (var e#164 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#166 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#166))) else (var e#166 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#246 := Wrappers.Result.value(this); s#246) else (var e#246 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#248 := Lit(Wrappers.Result.value(Lit(this))); s#248) else (var e#248 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#250 := Lit(Wrappers.Result.value(Lit(this))); s#250) else (var e#250 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#246 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#246)) else (var e#246 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#246)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#248 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#248))) else (var e#248 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#248)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#250 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#250))) else (var e#250 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#250)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#54: int, y#54: int :: { Mul(x#54, y#54) } Mul(x#54, y#54) == Mul(y#54, x#54)) && (forall x#55: int, y#55: int, z#36: int :: { Mul(x#55 + y#55, z#36) } Mul(x#55 + y#55, z#36) == Mul(x#55, z#36) + Mul(y#55, z#36)) && (forall x#56: int, y#56: int, z#37: int :: { Mul(x#56 - y#56, z#37) } Mul(x#56 - y#56, z#37) == Mul(x#56, z#37) - Mul(y#56, z#37));

axiom MulInternals.__default.MulAuto() <==> (forall x#57: int, y#57: int :: { Mul(x#57, y#57) } Mul(x#57, y#57) == Mul(y#57, x#57)) && (forall x#58: int, y#58: int, z#38: int :: { Mul(x#58 + y#58, z#38) } Mul(x#58 + y#58, z#38) == Mul(x#58, z#38) + Mul(y#58, z#38)) && (forall x#59: int, y#59: int, z#39: int :: { Mul(x#59 - y#59, z#39) } Mul(x#59 - y#59, z#39) == Mul(x#59, z#39) - Mul(y#59, z#39));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#56: int :: { Mod(Mod(x#56, n#0), n#0) } Mod(Mod(x#56, n#0), n#0) == Mod(x#56, n#0)) && (forall x#57: int :: { Mod(x#57, n#0) } LitInt(0) <= x#57 && x#57 < n#0 <==> Mod(x#57, n#0) == x#57) && (forall x#58: int, y#28: int :: { Mod(x#58 + y#28, n#0) } (var z#26 := Mod(x#58, n#0) + Mod(y#28, n#0); (LitInt(0) <= z#26 && z#26 < n#0 && Mod(x#58 + y#28, n#0) == z#26) || (n#0 <= z#26 && z#26 < n#0 + n#0 && Mod(x#58 + y#28, n#0) == z#26 - n#0))) && (forall x#59: int, y#29: int :: { Mod(x#59 - y#29, n#0) } (var z#27 := Mod(x#59, n#0) - Mod(y#29, n#0); (LitInt(0) <= z#27 && z#27 < n#0 && Mod(x#59 - y#29, n#0) == z#27) || (0 - n#0 <= z#27 && z#27 < 0 && Mod(x#59 - y#29, n#0) == z#27 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#60: int :: { Mod(Mod(x#60, n#0), n#0) } Mod(Mod(x#60, LitInt(n#0)), LitInt(n#0)) == Mod(x#60, LitInt(n#0))) && (forall x#61: int :: { Mod(x#61, n#0) } LitInt(0) <= x#61 && x#61 < n#0 <==> Mod(x#61, LitInt(n#0)) == x#61) && (forall x#62: int, y#30: int :: { Mod(x#62 + y#30, n#0) } (var z#28 := Mod(x#62, LitInt(n#0)) + Mod(y#30, LitInt(n#0)); (LitInt(0) <= z#28 && z#28 < n#0 && Mod(x#62 + y#30, LitInt(n#0)) == z#28) || (LitInt(n#0) <= z#28 && z#28 < n#0 + n#0 && Mod(x#62 + y#30, LitInt(n#0)) == z#28 - n#0))) && (forall x#63: int, y#31: int :: { Mod(x#63 - y#31, n#0) } (var z#29 := Mod(x#63, LitInt(n#0)) - Mod(y#31, LitInt(n#0)); (LitInt(0) <= z#29 && z#29 < n#0 && Mod(x#63 - y#31, LitInt(n#0)) == z#29) || (LitInt(0 - n#0) <= z#29 && z#29 < 0 && Mod(x#63 - y#31, LitInt(n#0)) == z#29 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#36: int :: { Div(x#36, n#0) } LitInt(0) <= x#36 && x#36 < n#0 <==> Div(x#36, n#0) == LitInt(0)) && (forall x#37: int, y#24: int :: { Div(x#37 + y#24, n#0) } (var z#22 := Mod(x#37, n#0) + Mod(y#24, n#0); (LitInt(0) <= z#22 && z#22 < n#0 && Div(x#37 + y#24, n#0) == Div(x#37, n#0) + Div(y#24, n#0)) || (n#0 <= z#22 && z#22 < n#0 + n#0 && Div(x#37 + y#24, n#0) == Div(x#37, n#0) + Div(y#24, n#0) + 1))) && (forall x#38: int, y#25: int :: { Div(x#38 - y#25, n#0) } (var z#23 := Mod(x#38, n#0) - Mod(y#25, n#0); (LitInt(0) <= z#23 && z#23 < n#0 && Div(x#38 - y#25, n#0) == Div(x#38, n#0) - Div(y#25, n#0)) || (0 - n#0 <= z#23 && z#23 < 0 && Div(x#38 - y#25, n#0) == Div(x#38, n#0) - Div(y#25, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#39: int :: { Div(x#39, n#0) } LitInt(0) <= x#39 && x#39 < n#0 <==> Div(x#39, LitInt(n#0)) == LitInt(0)) && (forall x#40: int, y#26: int :: { Div(x#40 + y#26, n#0) } (var z#24 := Mod(x#40, LitInt(n#0)) + Mod(y#26, LitInt(n#0)); (LitInt(0) <= z#24 && z#24 < n#0 && Div(x#40 + y#26, LitInt(n#0)) == Div(x#40, LitInt(n#0)) + Div(y#26, LitInt(n#0))) || (LitInt(n#0) <= z#24 && z#24 < n#0 + n#0 && Div(x#40 + y#26, LitInt(n#0)) == Div(x#40, LitInt(n#0)) + Div(y#26, LitInt(n#0)) + 1))) && (forall x#41: int, y#27: int :: { Div(x#41 - y#27, n#0) } (var z#25 := Mod(x#41, LitInt(n#0)) - Mod(y#27, LitInt(n#0)); (LitInt(0) <= z#25 && z#25 < n#0 && Div(x#41 - y#27, LitInt(n#0)) == Div(x#41, LitInt(n#0)) - Div(y#27, LitInt(n#0))) || (LitInt(0 - n#0) <= z#25 && z#25 < 0 && Div(x#41 - y#27, LitInt(n#0)) == Div(x#41, LitInt(n#0)) - Div(y#27, LitInt(n#0)) - 1)))));

const unique class.JSON_mUtils_mStr_mCharStrEscaping.__default: ClassName;

function JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly: LayerType, str#0: Seq, special#0: Set, escape#0: char) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, str#0, special#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(TChar)));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) && (!special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if special#0[Seq#Index(str#0, LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(escape#0)), Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), escape#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(escape#0)), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), Lit(escape#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0)))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(escape#0))), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))))));
}

function JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0: Seq, special#0: Set, escape#0: char) : bool;

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, str#0, special#0, escape#0));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape(AsFuelBottom($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, str#0, special#0, escape#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LZ, str#0, special#0, escape#0));

function JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#requires(LayerType, Seq, Set, char) : bool;

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#requires($ly, str#0, special#0, escape#0) } $Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar) ==> (JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#requires($ly, str#0, special#0, escape#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.CharStrEscaping.Escape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrEscaping.__default.Escape(str#0: Seq where $Is(str#0, TSeq(TChar)), special#0: Set where $Is(special#0, TSet(TChar)), escape#0: char where $Is(escape#0, TChar));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly: LayerType, str#0: Seq, escape#0: char) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError())));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#0 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#0)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#0 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#0))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#0 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#0) else (var tl#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#0)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#0 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#0) else (var tl#1 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#1)))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#1 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#1)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#1 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#1))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#1 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#1) else (var tl#2 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#2)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#1 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#1) else (var tl#3 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#3)))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#2 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#2)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#2 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#2))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#2 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#2) else (var tl#4 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#2)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#4)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#2 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#2) else (var tl#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#2)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#5)))))))));
}

function JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0: Seq, escape#0: char) : bool;

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, str#0, escape#0));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape(AsFuelBottom($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, str#0, escape#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LZ, str#0, escape#0));

function Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) == Tagclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError && TagFamily(Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) == tytagFamily$UnescapeError;
}

const unique Tagclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) } $IsBox(bx, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));

function JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#requires(LayerType, Seq, char) : bool;

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#requires($ly, str#0, escape#0) } $Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar) ==> (JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#requires($ly, str#0, escape#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape(str#0: Seq where $Is(str#0, TSeq(TChar)), escape#0: char where $Is(escape#0, TChar));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape(str#0: Seq, escape#0: char)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: Seq;
  var ##escape#0: char;
  var tl#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##str#1: Seq;
  var ##escape#1: char;
  var tl#Z#1: Seq;
  var let#3#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrEscaping.Unescape", " | ", str#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "char"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrEscaping](151,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == #Wrappers.Result.Success($Box(str#0));
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    return;

  anon15_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Length(str#0) > 1;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume 0 <= LitInt(2) && LitInt(2) <= Seq#Length(str#0);
    ##str#0 := Seq#Drop(str#0, LitInt(2));
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    ##escape#0 := escape#0;
    assume $IsAlloc(##escape#0, TChar, $Heap);
    assume Seq#Rank(##str#0) < Seq#Rank(str#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0);
    assume let#0#0#0 == JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), Seq#Drop(str#0, LitInt(2)), escape#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#Z#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#Z#0);
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    return;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#Z#0);
    havoc tl#Z#0;
    assume $Is(tl#Z#0, TSeq(TChar)) && $IsAlloc(tl#Z#0, TSeq(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(TChar));
    assume tl#Z#0 == let#1#0#0;
    assume 0 <= LitInt(1) && LitInt(1) < Seq#Length(str#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#Z#0)));
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    return;

  anon17_Else:
    assume {:partition} 1 >= Seq#Length(str#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS()))));
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    return;

  anon16_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    ##str#1 := Seq#Drop(str#0, LitInt(1));
    assume $IsAlloc(##str#1, TSeq(TChar), $Heap);
    ##escape#1 := escape#0;
    assume $IsAlloc(##escape#1, TChar, $Heap);
    assume Seq#Rank(##str#1) < Seq#Rank(str#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0);
    assume let#2#0#0 == JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), Seq#Drop(str#0, LitInt(1)), escape#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0);
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#Z#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#Z#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#Z#0);
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    return;

  anon19_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#Z#0);
    havoc tl#Z#1;
    assume $Is(tl#Z#1, TSeq(TChar)) && $IsAlloc(tl#Z#1, TSeq(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(TChar));
    assume tl#Z#1 == let#3#0#0;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#Z#1)));
    assume true;
    assume $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()));
    return;
}



procedure {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape_Escape (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), special#0: Set where $Is(special#0, TSet(TChar)) && $IsAlloc(special#0, TSet(TChar), $Heap), escape#0: char where $Is(escape#0, TChar));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape_Escape (call precondtion)"} CallPre$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), special#0: Set where $Is(special#0, TSet(TChar)) && $IsAlloc(special#0, TSet(TChar), $Heap), escape#0: char where $Is(escape#0, TChar));
  requires {:id "id21406"} special#0[$Box(escape#0)];



procedure {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape_Escape (call postcondition)"} CallPost$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), special#0: Set where $Is(special#0, TSet(TChar)) && $IsAlloc(special#0, TSet(TChar), $Heap), escape#0: char where $Is(escape#0, TChar));
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0)) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, special#0, escape#0) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0);
  free ensures {:id "id21407"} Wrappers.Result#Equal(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LS($LZ)), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LS($LZ)), str#0, special#0, escape#0), escape#0), #Wrappers.Result.Success($Box(str#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape_Escape (correctness)"} Impl$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0: Seq where $Is(str#0, TSeq(TChar)) && $IsAlloc(str#0, TSeq(TChar), $Heap), special#0: Set where $Is(special#0, TSet(TChar)) && $IsAlloc(special#0, TSet(TChar), $Heap), escape#0: char where $Is(escape#0, TChar)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id21408"} special#0[$Box(escape#0)];
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0)) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, special#0, escape#0) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), str#0, special#0, escape#0), escape#0);
  free ensures {:id "id21409"} $_reverifyPost ==> Wrappers.Result#Equal(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LS($LZ)), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LS($LZ)), str#0, special#0, escape#0), escape#0), #Wrappers.Result.Success($Box(str#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape_Escape (correctness)"} Impl$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0: Seq, special#0: Set, escape#0: char) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var str##1_0: Seq;
  var special##1_0: Set;
  var escape##1_0: char;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrEscaping.Unescape_Escape", " | ", str#0, " | ", special#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set", " | ", "char"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrEscaping](162,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    return;

  anon3_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(str#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    assume true;
    assume Seq#Equal(str#0, Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), Seq#Drop(str#0, LitInt(1))));
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrEscaping](165,41)"} true;
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(str#0);
    assume true;
    str##1_0 := Seq#Drop(str#0, LitInt(1));
    assume true;
    special##1_0 := special#0;
    assume true;
    escape##1_0 := escape#0;
    assume Seq#Rank(str##1_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0) == Seq#Rank(str#0) && Set#Subset(special##1_0, special#0) && !Set#Subset(special#0, special##1_0));
    call CallPre$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str##1_0, special##1_0, escape##1_0);
    call CallPost$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str##1_0, special##1_0, escape##1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[CharStrEscaping](166,50)"} true;
    return;
}



function #JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS()) == ##JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS;
axiom $Is(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS(), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError());
axiom #JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS() == Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS());
}

const unique ##JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS()) == ##JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS;
}

function JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d) } JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS);

axiom (forall d: DatatypeType :: { JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d) } JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d) ==> d == #JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), $h));

function $IsA#JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(d) } $IsA#JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(d) ==> JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d), $Is(d, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) } $Is(d, Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError()) ==> JSON_mUtils_mStr_mCharStrEscaping.UnescapeError.EscapeAtEOS_q(d));

function JSON_mUtils_mStr_mCharStrEscaping.UnescapeError#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mStr_mCharStrEscaping.UnescapeError#Equal(a, b) } JSON_mUtils_mStr_mCharStrEscaping.UnescapeError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mStr_mCharStrEscaping.UnescapeError#Equal(a, b) } JSON_mUtils_mStr_mCharStrEscaping.UnescapeError#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#168 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#168))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#170 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#170)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#252 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#252))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#254 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#254)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#256 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#256)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#252 := Wrappers.Option.value(this); v#252)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#254 := Lit(Wrappers.Option.value(Lit(this))); v#254)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#256 := Lit(Wrappers.Option.value(Lit(this))); v#256)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#168 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#168)) else (var e#168 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#170 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#170))) else (var e#170 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#252 := Wrappers.Result.value(this); s#252) else (var e#252 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#254 := Lit(Wrappers.Result.value(Lit(this))); s#254) else (var e#254 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#256 := Lit(Wrappers.Result.value(Lit(this))); s#256) else (var e#256 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#252 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#252)) else (var e#252 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#252)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#254 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#254))) else (var e#254 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#254)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#256 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#256))) else (var e#256 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#256)))));

const unique class.JSON_mUtils_mStr.__default: ClassName;

function JSON_mUtils_mStr.__default.HEX__DIGITS() : Seq
uses {
axiom JSON_mUtils_mStr.__default.HEX__DIGITS(): Seq == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))), $Box(char#FromInt(49))), $Box(char#FromInt(50))), $Box(char#FromInt(51))), $Box(char#FromInt(52))), $Box(char#FromInt(53))), $Box(char#FromInt(54))), $Box(char#FromInt(55))), $Box(char#FromInt(56))), $Box(char#FromInt(57))), $Box(char#FromInt(65))), $Box(char#FromInt(66))), $Box(char#FromInt(67))), $Box(char#FromInt(68))), $Box(char#FromInt(69))), $Box(char#FromInt(70))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mUtils_mStr.__default.HEX__DIGITS(), TSeq(TChar));
}

procedure {:verboseName "JSON.Utils.Str.HEX_DIGITS (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr.__default.HEX__DIGITS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mStr.__default.HEX__DIGITS(), TSeq(TChar), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mStr.__default.HEX__DIGITS(), TSeq(TChar), $h));

function JSON_mUtils_mStr.__default.HEX__TABLE() : Map
uses {
axiom JSON_mUtils_mStr.__default.HEX__TABLE(): Map == Lit(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Empty(): Map, $Box(Lit(char#FromInt(48))), $Box(LitInt(0))), $Box(Lit(char#FromInt(49))), $Box(LitInt(1))), $Box(Lit(char#FromInt(50))), $Box(LitInt(2))), $Box(Lit(char#FromInt(51))), $Box(LitInt(3))), $Box(Lit(char#FromInt(52))), $Box(LitInt(4))), $Box(Lit(char#FromInt(53))), $Box(LitInt(5))), $Box(Lit(char#FromInt(54))), $Box(LitInt(6))), $Box(Lit(char#FromInt(55))), $Box(LitInt(7))), $Box(Lit(char#FromInt(56))), $Box(LitInt(8))), $Box(Lit(char#FromInt(57))), $Box(LitInt(9))), $Box(Lit(char#FromInt(97))), $Box(LitInt(10))), $Box(Lit(char#FromInt(98))), $Box(LitInt(11))), $Box(Lit(char#FromInt(99))), $Box(LitInt(12))), $Box(Lit(char#FromInt(100))), $Box(LitInt(13))), $Box(Lit(char#FromInt(101))), $Box(LitInt(14))), $Box(Lit(char#FromInt(102))), $Box(LitInt(15))), $Box(Lit(char#FromInt(65))), $Box(LitInt(10))), $Box(Lit(char#FromInt(66))), $Box(LitInt(11))), $Box(Lit(char#FromInt(67))), $Box(LitInt(12))), $Box(Lit(char#FromInt(68))), $Box(LitInt(13))), $Box(Lit(char#FromInt(69))), $Box(LitInt(14))), $Box(Lit(char#FromInt(70))), $Box(LitInt(15))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, TInt));
}

procedure {:verboseName "JSON.Utils.Str.HEX_TABLE (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr.__default.HEX__TABLE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, TInt), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, TInt), $h));

function JSON_mUtils_mStr.__default.OfNat(n#0: int, base#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (1 < $FunctionContextHeight && LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#0: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#0)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#0)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#0))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (1 < $FunctionContextHeight && LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0)) && JSON_mUtils_mStr.__default.OfNat(n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0)));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.OfNat(LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.OfNat#canCall(LitInt(n#0), LitInt(base#0)) || (1 < $FunctionContextHeight && LitInt(0) <= n#0 && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0))) && JSON_mUtils_mStr.__default.OfNat(LitInt(n#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0))));
}

function JSON_mUtils_mStr.__default.OfNat#canCall(n#0: int, base#0: int) : bool;

function JSON_mUtils_mStr.__default.OfNat#requires(int, int) : bool;

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat#requires(n#0, base#0) } LitInt(0) <= n#0 ==> (JSON_mUtils_mStr.__default.OfNat#requires(n#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16)));

procedure {:verboseName "JSON.Utils.Str.OfNat (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.OfNat(n#0: int where LitInt(0) <= n#0, base#0: int) returns (str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id21417"} Seq#Length(str#0) == Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, base#0, n#0) + 1;
  free ensures {:id "id21418"} (forall c#1: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#1)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.OfNat (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.OfNat(n#0: int, base#0: int) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var c#2: char;
  var ##n#0: int;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.OfNat", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(188,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(2) <= base#0;
    goto anon3;

  anon9_Else:
    assume {:partition} base#0 < LitInt(2);
    goto anon3;

  anon3:
    assume LitInt(2) <= base#0 && base#0 <= LitInt(16);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar));
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Seq#Length(str#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    havoc c#2;
    assume $Is(c#2, TChar);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(str#0, $Box(c#2));
    assume 0 <= base#0 && base#0 <= Seq#Length(JSON_mUtils_mStr.__default.HEX__DIGITS());
    assume Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#2));
    goto anon7;

  anon11_Else:
    assume Seq#Contains(str#0, $Box(c#2)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#2));
    goto anon7;

  anon7:
    assume (forall c#1: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#1)));
    assume false;
    return;

  anon10_Else:
    assume 0 <= base#0 && base#0 <= Seq#Length(JSON_mUtils_mStr.__default.HEX__DIGITS());
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##chars#0 := Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0);
    assume $IsAlloc(##chars#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} Seq#Length(##chars#0) > 1;
    assume Seq#Length(##chars#0) > 1;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0));
    assume JSON_mUtils_mStr.__default.OfNat(n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0));
    assume $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar));
    assume JSON_mUtils_mStr.__default.OfNat(n#0, base#0) == str#0;
    return;
}



function JSON_mUtils_mStr.__default.OfInt(n#0: int, base#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (1 < $FunctionContextHeight && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#0#c#0))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, TChar)), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (1 < $FunctionContextHeight && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45))) && JSON_mUtils_mStr.__default.OfInt(n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45))));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(n#0), LitInt(base#0)) || (1 < $FunctionContextHeight && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0)), Lit(char#FromInt(45))) && JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0)), Lit(char#FromInt(45))));
}

function JSON_mUtils_mStr.__default.OfInt#canCall(n#0: int, base#0: int) : bool;

function JSON_mUtils_mStr.__default.OfInt#requires(int, int) : bool;

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt#requires(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#requires(n#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16));

procedure {:verboseName "JSON.Utils.Str.OfInt (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.OfInt(n#0: int, base#0: int) returns (str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id21432"} JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#1#c#0))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TChar)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.OfInt (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.OfInt(n#0: int, base#0: int) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##str#0: Seq;
  var ##minus#0: char;
  var ##is_digit#0: HandleType;
  var ##n#0: int;
  var ##chars#0: Seq;
  var ##minus#1: char;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.OfInt", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(196,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(2) <= base#0;
    goto anon3;

  anon10_Else:
    assume {:partition} base#0 < LitInt(2);
    goto anon3;

  anon3:
    assume LitInt(2) <= base#0 && base#0 <= LitInt(16);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume 0 <= base#0 && base#0 <= Seq#Length(JSON_mUtils_mStr.__default.HEX__DIGITS());
    assume lambdaResult#0 <==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#0));
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon7;

  anon13_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon12_Else:
    goto anon8;

  anon8:
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    ##minus#0 := Lit(char#FromInt(45));
    assume $IsAlloc(##minus#0, TChar, $Heap);
    ##is_digit#0 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#3#c#0))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, TChar)), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool), $Heap);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#4#c#0))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, TChar)), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#5#c#0))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar)), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume false;
    return;

  anon11_Else:
    assume 0 <= base#0 && base#0 <= Seq#Length(JSON_mUtils_mStr.__default.HEX__DIGITS());
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##chars#0 := Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0);
    assume $IsAlloc(##chars#0, TSeq(TChar), $Heap);
    ##minus#1 := Lit(char#FromInt(45));
    assume $IsAlloc(##minus#1, TChar, $Heap);
    assume {:subsumption 0} Seq#Length(##chars#0) > 1;
    assume Seq#Length(##chars#0) > 1;
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45)));
    assume JSON_mUtils_mStr.__default.OfInt(n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45)));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45)));
    assume $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar));
    assume JSON_mUtils_mStr.__default.OfInt(n#0, base#0) == str#0;
    return;
}



function JSON_mUtils_mStr.__default.ToNat(str#0: Seq, base#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#0: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int < base#0)) ==> JSON_mUtils_mStr.__default.ToNat(str#0, base#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) && LitInt(0) <= JSON_mUtils_mStr.__default.ToNat(str#0, base#0));
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#1: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#2: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#2)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#2)] } { Seq#Contains(str#0, $Box(c#2)) } $Is(c#2, TChar) && Seq#Contains(str#0, $Box(c#2)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#2)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#2)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));
}

function JSON_mUtils_mStr.__default.ToNat#canCall(str#0: Seq, base#0: int) : bool;

function JSON_mUtils_mStr.__default.ToNat#requires(Seq, int) : bool;

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#1: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } $Is(c#1, TChar) && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#1)]): int < base#0)));

procedure {:verboseName "JSON.Utils.Str.ToNat (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.ToNat(str#0: Seq where $Is(str#0, TSeq(TChar)), base#0: int) returns (n#0: int where LitInt(0) <= n#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id21441"} n#0 < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ToNat (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.ToNat(str#0: Seq, base#0: int) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: char;
  var ##b#0: int;
  var ##e#0: int;
  var str##0: Seq;
  var base##0: int;
  var digits##0: Map;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ToNat", " | ", str#0, " | ", base#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(203,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} LitInt(2) <= base#0;
    goto anon3;

  anon9_Else:
    assume {:partition} base#0 < LitInt(2);
    goto anon3;

  anon3:
    assume LitInt(2) <= base#0 && base#0 <= LitInt(16);
    havoc c#3;
    assume $Is(c#3, TChar);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, $Box(c#3));
    assume Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#3)];
    assume Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#3)];
    assume $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#3)]): int < base#0;
    goto anon6;

  anon10_Else:
    assume Seq#Contains(str#0, $Box(c#3)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#3)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#3)]): int < base#0;
    goto anon6;

  anon6:
    assume (forall c#0: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int < base#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume LitInt(0) <= JSON_mUtils_mStr.__default.ToNat(str#0, base#0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#0 := Seq#Length(str#0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume n#0 < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
    assume false;
    return;

  anon11_Else:
    assume true;
    str##0 := str#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##0 := base#0;
    assume true;
    assume $Is(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, Tclass._System.nat()));
    digits##0 := JSON_mUtils_mStr.__default.HEX__TABLE();
    call CallPre$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str##0, base##0, digits##0);
    call CallPost$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str##0, base##0, digits##0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(208,54)"} true;
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    assume $Is(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, Tclass._System.nat()));
    ##digits#0 := JSON_mUtils_mStr.__default.HEX__TABLE();
    assume $IsAlloc(##digits#0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} (forall c#4: char :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume (forall c#4: char :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE());
    assume JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE());
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE());
    assume $Is(JSON_mUtils_mStr.__default.ToNat(str#0, base#0), Tclass._System.nat());
    assume JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == n#0;
    return;
}



function JSON_mUtils_mStr.__default.ToInt(str#0: Seq, base#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#1#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#1#c#0]): int < base#0)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TChar)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#2#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#2#c#0]): int < base#0)), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, TChar)), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));
}

function JSON_mUtils_mStr.__default.ToInt#canCall(str#0: Seq, base#0: int) : bool;

function JSON_mUtils_mStr.__default.ToInt#requires(Seq, int) : bool;

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#1#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#1#c#0]): int < base#0)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, TChar)), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.Utils.Str.ToInt (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.ToInt(str#0: Seq where $Is(str#0, TSeq(TChar)), base#0: int) returns (n#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.ToInt (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.ToInt(str#0: Seq, base#0: int) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var ##str#0: Seq;
  var ##minus#0: char;
  var ##is_digit#0: HandleType;
  var ##str#1: Seq;
  var ##minus#1: char;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ToInt", " | ", str#0, " | ", base#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(212,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(2) <= base#0;
    goto anon3;

  anon12_Else:
    assume {:partition} base#0 < LitInt(2);
    goto anon3;

  anon3:
    assume LitInt(2) <= base#0 && base#0 <= LitInt(16);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Is(c#0, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)];
    assume Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)];
    goto anon7;

  anon15_Else:
    assume {:partition} !Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)];
    goto anon7;

  anon7:
    assume lambdaResult#0 <==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int < base#0;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon8;

  anon14_Else:
    assume {:partition} !$Is(c#0, TChar);
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon13_Else:
    goto anon9;

  anon9:
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    ##minus#0 := Lit(char#FromInt(45));
    assume $IsAlloc(##minus#0, TChar, $Heap);
    ##is_digit#0 := Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#4#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#4#c#0]): int < base#0)), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, TChar)), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool), $Heap);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#5#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#5#c#0]): int < base#0)), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar)), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#6#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#6#c#0]): int < base#0)), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, TChar)), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume false;
    return;

  anon16_Else:
    ##str#1 := str#0;
    assume $IsAlloc(##str#1, TSeq(TChar), $Heap);
    ##minus#1 := Lit(char#FromInt(45));
    assume $IsAlloc(##minus#1, TChar, $Heap);
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    assume $Is(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, Tclass._System.nat()));
    ##digits#0 := JSON_mUtils_mStr.__default.HEX__TABLE();
    assume $IsAlloc(##digits#0, TMap(TChar, Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} !Seq#Equal(##str#1, Seq#Build(Seq#Empty(): Seq, $Box(##minus#1)));
    assume !Seq#Equal(##str#1, Seq#Build(Seq#Empty(): Seq, $Box(##minus#1)));
    assume {:subsumption 0} JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(##str#1, ##minus#1, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Map#Domain(##digits#0)[$l#7#c#0])), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar)), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(##str#1, ##minus#1, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Map#Domain(##digits#0)[$l#8#c#0])), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar)), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(##str#1, ##minus#1, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(##digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE());
    assume JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE());
    assume JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE());
    assume $Is(JSON_mUtils_mStr.__default.ToInt(str#0, base#0), TInt);
    assume JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == n#0;
    return;
}



function JSON_mUtils_mStr.__default.EscapeQuotes(str#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mUtils_mStr.__default.EscapeQuotes(str#0) } JSON_mUtils_mStr.__default.EscapeQuotes#canCall(str#0) || (0 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> $Is(JSON_mUtils_mStr.__default.EscapeQuotes(str#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mUtils_mStr.__default.EscapeQuotes(str#0) } JSON_mUtils_mStr.__default.EscapeQuotes#canCall(str#0) || (0 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.EscapeQuotes(str#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), str#0, Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92))));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.EscapeQuotes(Lit(str#0)) } JSON_mUtils_mStr.__default.EscapeQuotes#canCall(Lit(str#0)) || (0 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(str#0), Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.EscapeQuotes(Lit(str#0)) == Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), Lit(str#0), Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92)))));
}

function JSON_mUtils_mStr.__default.EscapeQuotes#canCall(str#0: Seq) : bool;

function JSON_mUtils_mStr.__default.EscapeQuotes#requires(Seq) : bool;

axiom (forall str#0: Seq :: { JSON_mUtils_mStr.__default.EscapeQuotes#requires(str#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.EscapeQuotes#requires(str#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.EscapeQuotes (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.EscapeQuotes(str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr.__default.UnescapeQuotes(str#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mUtils_mStr.__default.UnescapeQuotes(str#0) } JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(str#0) || (0 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> $Is(JSON_mUtils_mStr.__default.UnescapeQuotes(str#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError())));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mUtils_mStr.__default.UnescapeQuotes(str#0) } JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(str#0) || (0 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.UnescapeQuotes(str#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, Lit(char#FromInt(92))));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.UnescapeQuotes(Lit(str#0)) } JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(Lit(str#0)) || (0 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.UnescapeQuotes(Lit(str#0)) == Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), Lit(str#0), Lit(char#FromInt(92)))));
}

function JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(str#0: Seq) : bool;

function JSON_mUtils_mStr.__default.UnescapeQuotes#requires(Seq) : bool;

axiom (forall str#0: Seq :: { JSON_mUtils_mStr.__default.UnescapeQuotes#requires(str#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.UnescapeQuotes#requires(str#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.UnescapeQuotes (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.UnescapeQuotes(str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Str.Test (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr.__default.Test();
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Str.Test (call precondtion)"} CallPre$$JSON_mUtils_mStr.__default.Test();



procedure {:verboseName "JSON.Utils.Str.Test (call postcondition)"} CallPost$$JSON_mUtils_mStr.__default.Test();
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Str.Test (correctness)"} Impl$$JSON_mUtils_mStr.__default.Test() returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.Test (correctness)"} Impl$$JSON_mUtils_mStr.__default.Test() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##n#0: int;
  var ##base#0: int;
  var ##n#1: int;
  var ##base#1: int;
  var ##n#2: int;
  var ##base#2: int;
  var ##n#3: int;
  var ##base#3: int;
  var ##n#4: int;
  var ##base#4: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.Test"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(228,16): initial state"} true;
    $_reverifyPost := false;
    ##n#0 := LitInt(0);
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##base#0 := LitInt(10);
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#0;
    assume {:subsumption 0} ##base#0 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(0), LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(0), LitInt(10));
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} !Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(0), LitInt(10)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))));
    assume true;
    assume false;
    goto anon2;

  anon10_Else:
    assume {:partition} Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(0), LitInt(10)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(48))));
    goto anon2;

  anon2:
    ##n#1 := LitInt(3);
    assume $IsAlloc(##n#1, TInt, $Heap);
    ##base#1 := LitInt(10);
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#1;
    assume {:subsumption 0} ##base#1 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(3), LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(3), LitInt(10));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} !Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(3), LitInt(10)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(51))));
    assume true;
    assume false;
    goto anon4;

  anon11_Else:
    assume {:partition} Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(3), LitInt(10)), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(51))));
    goto anon4;

  anon4:
    ##n#2 := LitInt(302);
    assume $IsAlloc(##n#2, TInt, $Heap);
    ##base#2 := LitInt(10);
    assume $IsAlloc(##base#2, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#2;
    assume {:subsumption 0} ##base#2 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(302), LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(302), LitInt(10));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} !Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(302), LitInt(10)), Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(51))), $Box(char#FromInt(48))), $Box(char#FromInt(50))));
    assume true;
    assume false;
    goto anon6;

  anon12_Else:
    assume {:partition} Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(302), LitInt(10)), Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(51))), $Box(char#FromInt(48))), $Box(char#FromInt(50))));
    goto anon6;

  anon6:
    ##n#3 := LitInt(-3);
    assume $IsAlloc(##n#3, TInt, $Heap);
    ##base#3 := LitInt(10);
    assume $IsAlloc(##base#3, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#3;
    assume {:subsumption 0} ##base#3 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(-3), LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(-3), LitInt(10));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} !Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(-3), LitInt(10)), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(51))));
    assume true;
    assume false;
    goto anon8;

  anon13_Else:
    assume {:partition} Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(-3), LitInt(10)), Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(51))));
    goto anon8;

  anon8:
    ##n#4 := LitInt(-302);
    assume $IsAlloc(##n#4, TInt, $Heap);
    ##base#4 := LitInt(10);
    assume $IsAlloc(##base#4, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#4;
    assume {:subsumption 0} ##base#4 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(-302), LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(-302), LitInt(10));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} !Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(-302), LitInt(10)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(51))), $Box(char#FromInt(48))), $Box(char#FromInt(50))));
    assume true;
    assume false;
    return;

  anon14_Else:
    assume {:partition} Seq#Equal(JSON_mUtils_mStr.__default.OfInt(LitInt(-302), LitInt(10)), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45))), $Box(char#FromInt(51))), $Box(char#FromInt(48))), $Box(char#FromInt(50))));
    return;
}



function JSON_mUtils_mStr.__default.OfBool(b#0: bool) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: { JSON_mUtils_mStr.__default.OfBool(b#0) } JSON_mUtils_mStr.__default.OfBool#canCall(b#0) || 0 < $FunctionContextHeight ==> $Is(JSON_mUtils_mStr.__default.OfBool(b#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: { JSON_mUtils_mStr.__default.OfBool(b#0) } JSON_mUtils_mStr.__default.OfBool#canCall(b#0) || 0 < $FunctionContextHeight ==> JSON_mUtils_mStr.__default.OfBool(b#0) == (if b#0 then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: {:weight 3} { JSON_mUtils_mStr.__default.OfBool(Lit(b#0)) } JSON_mUtils_mStr.__default.OfBool#canCall(Lit(b#0)) || 0 < $FunctionContextHeight ==> JSON_mUtils_mStr.__default.OfBool(Lit(b#0)) == (if b#0 then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))));
}

function JSON_mUtils_mStr.__default.OfBool#canCall(b#0: bool) : bool;

function JSON_mUtils_mStr.__default.OfBool#requires(bool) : bool;

axiom (forall b#0: bool :: { JSON_mUtils_mStr.__default.OfBool#requires(b#0) } JSON_mUtils_mStr.__default.OfBool#requires(b#0) <==> true);

procedure {:verboseName "JSON.Utils.Str.OfBool (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.OfBool(b#0: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr.__default.OfChar(c#0: char) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall c#0: char :: { JSON_mUtils_mStr.__default.OfChar(c#0) } JSON_mUtils_mStr.__default.OfChar#canCall(c#0) || (0 < $FunctionContextHeight && $Is(c#0, TChar)) ==> $Is(JSON_mUtils_mStr.__default.OfChar(c#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall c#0: char :: { JSON_mUtils_mStr.__default.OfChar(c#0) } JSON_mUtils_mStr.__default.OfChar#canCall(c#0) || (0 < $FunctionContextHeight && $Is(c#0, TChar)) ==> JSON_mUtils_mStr.__default.OfChar(c#0) == Seq#Build(Seq#Empty(): Seq, $Box(c#0)));
axiom 0 <= $FunctionContextHeight ==> (forall c#0: char :: {:weight 3} { JSON_mUtils_mStr.__default.OfChar(Lit(c#0)) } JSON_mUtils_mStr.__default.OfChar#canCall(Lit(c#0)) || (0 < $FunctionContextHeight && $Is(c#0, TChar)) ==> JSON_mUtils_mStr.__default.OfChar(Lit(c#0)) == Lit(Seq#Build(Seq#Empty(): Seq, $Box(Lit(c#0)))));
}

function JSON_mUtils_mStr.__default.OfChar#canCall(c#0: char) : bool;

function JSON_mUtils_mStr.__default.OfChar#requires(char) : bool;

axiom (forall c#0: char :: { JSON_mUtils_mStr.__default.OfChar#requires(c#0) } $Is(c#0, TChar) ==> (JSON_mUtils_mStr.__default.OfChar#requires(c#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.OfChar (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.OfChar(c#0: char where $Is(c#0, TChar));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mStr.__default.Join($ly: LayerType, sep#0: Seq, strs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join($ly, sep#0, strs#0) } JSON_mUtils_mStr.__default.Join#canCall(sep#0, strs#0) || (0 < $FunctionContextHeight && $Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar)))) ==> $Is(JSON_mUtils_mStr.__default.Join($ly, sep#0, strs#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join($LS($ly), sep#0, strs#0) } JSON_mUtils_mStr.__default.Join#canCall(sep#0, strs#0) || (0 < $FunctionContextHeight && $Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar)))) ==> (Seq#Length(strs#0) != LitInt(0) ==> Seq#Length(strs#0) != LitInt(1) ==> JSON_mUtils_mStr.__default.Join#canCall(sep#0, Seq#Drop(strs#0, LitInt(1)))) && JSON_mUtils_mStr.__default.Join($LS($ly), sep#0, strs#0) == (if Seq#Length(strs#0) == LitInt(0) then Seq#Empty(): Seq else (if Seq#Length(strs#0) == LitInt(1) then $Unbox(Seq#Index(strs#0, LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(strs#0, LitInt(0))): Seq, sep#0), JSON_mUtils_mStr.__default.Join($ly, sep#0, Seq#Drop(strs#0, LitInt(1)))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.Join($LS($ly), Lit(sep#0), Lit(strs#0)) } JSON_mUtils_mStr.__default.Join#canCall(Lit(sep#0), Lit(strs#0)) || (0 < $FunctionContextHeight && $Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar)))) ==> (Seq#Length(Lit(strs#0)) != LitInt(0) ==> Seq#Length(Lit(strs#0)) != LitInt(1) ==> JSON_mUtils_mStr.__default.Join#canCall(Lit(sep#0), Lit(Seq#Drop(Lit(strs#0), LitInt(1))))) && JSON_mUtils_mStr.__default.Join($LS($ly), Lit(sep#0), Lit(strs#0)) == (if Seq#Length(Lit(strs#0)) == LitInt(0) then Seq#Empty(): Seq else (if Seq#Length(Lit(strs#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(strs#0), LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(Lit(strs#0), LitInt(0))): Seq, sep#0), JSON_mUtils_mStr.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(strs#0), LitInt(1))))))));
}

function JSON_mUtils_mStr.__default.Join#canCall(sep#0: Seq, strs#0: Seq) : bool;

axiom (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join($LS($ly), sep#0, strs#0) } JSON_mUtils_mStr.__default.Join($LS($ly), sep#0, strs#0) == JSON_mUtils_mStr.__default.Join($ly, sep#0, strs#0));

axiom (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join(AsFuelBottom($ly), sep#0, strs#0) } JSON_mUtils_mStr.__default.Join($ly, sep#0, strs#0) == JSON_mUtils_mStr.__default.Join($LZ, sep#0, strs#0));

function JSON_mUtils_mStr.__default.Join#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join#requires($ly, sep#0, strs#0) } $Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar))) ==> (JSON_mUtils_mStr.__default.Join#requires($ly, sep#0, strs#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.Join (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.Join(sep#0: Seq where $Is(sep#0, TSeq(TChar)), strs#0: Seq where $Is(strs#0, TSeq(TSeq(TChar))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.Join (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.Join(sep#0: Seq, strs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##sep#0: Seq;
  var ##strs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.Join", " | ", sep#0, " | ", strs#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(244,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0), TSeq(TChar));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Length(strs#0) == LitInt(0);
    assume JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0), TSeq(TChar));
    return;

  anon9_Else:
    assume {:partition} Seq#Length(strs#0) != LitInt(0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Length(strs#0) == LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(strs#0);
    assume JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0) == $Unbox(Seq#Index(strs#0, LitInt(0))): Seq;
    assume true;
    assume $Is(JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0), TSeq(TChar));
    return;

  anon10_Else:
    assume {:partition} Seq#Length(strs#0) != LitInt(1);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(strs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(strs#0);
    ##sep#0 := sep#0;
    assume $IsAlloc(##sep#0, TSeq(TChar), $Heap);
    ##strs#0 := Seq#Drop(strs#0, LitInt(1));
    assume $IsAlloc(##strs#0, TSeq(TSeq(TChar)), $Heap);
    assume Seq#Rank(##sep#0) < Seq#Rank(sep#0) || (Seq#Rank(##sep#0) == Seq#Rank(sep#0) && Seq#Rank(##strs#0) < Seq#Rank(strs#0));
    assume JSON_mUtils_mStr.__default.Join#canCall(sep#0, Seq#Drop(strs#0, LitInt(1)));
    assume JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0) == Seq#Append(Seq#Append($Unbox(Seq#Index(strs#0, LitInt(0))): Seq, sep#0), JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, Seq#Drop(strs#0, LitInt(1))));
    assume JSON_mUtils_mStr.__default.Join#canCall(sep#0, Seq#Drop(strs#0, LitInt(1)));
    assume $Is(JSON_mUtils_mStr.__default.Join($LS($LZ), sep#0, strs#0), TSeq(TChar));
    return;
}



function JSON_mUtils_mStr.__default.Concat($ly: LayerType, strs#0: Seq) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat($ly, strs#0) } JSON_mUtils_mStr.__default.Concat#canCall(strs#0) || (0 < $FunctionContextHeight && $Is(strs#0, TSeq(TSeq(TChar)))) ==> $Is(JSON_mUtils_mStr.__default.Concat($ly, strs#0), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat($LS($ly), strs#0) } JSON_mUtils_mStr.__default.Concat#canCall(strs#0) || (0 < $FunctionContextHeight && $Is(strs#0, TSeq(TSeq(TChar)))) ==> (Seq#Length(strs#0) != LitInt(0) ==> JSON_mUtils_mStr.__default.Concat#canCall(Seq#Drop(strs#0, LitInt(1)))) && JSON_mUtils_mStr.__default.Concat($LS($ly), strs#0) == (if Seq#Length(strs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(strs#0, LitInt(0))): Seq, JSON_mUtils_mStr.__default.Concat($ly, Seq#Drop(strs#0, LitInt(1))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, strs#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.Concat($LS($ly), Lit(strs#0)) } JSON_mUtils_mStr.__default.Concat#canCall(Lit(strs#0)) || (0 < $FunctionContextHeight && $Is(strs#0, TSeq(TSeq(TChar)))) ==> (Seq#Length(Lit(strs#0)) != LitInt(0) ==> JSON_mUtils_mStr.__default.Concat#canCall(Lit(Seq#Drop(Lit(strs#0), LitInt(1))))) && JSON_mUtils_mStr.__default.Concat($LS($ly), Lit(strs#0)) == (if Seq#Length(Lit(strs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(Lit(strs#0), LitInt(0))): Seq, JSON_mUtils_mStr.__default.Concat($LS($ly), Lit(Seq#Drop(Lit(strs#0), LitInt(1)))))));
}

function JSON_mUtils_mStr.__default.Concat#canCall(strs#0: Seq) : bool;

axiom (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat($LS($ly), strs#0) } JSON_mUtils_mStr.__default.Concat($LS($ly), strs#0) == JSON_mUtils_mStr.__default.Concat($ly, strs#0));

axiom (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat(AsFuelBottom($ly), strs#0) } JSON_mUtils_mStr.__default.Concat($ly, strs#0) == JSON_mUtils_mStr.__default.Concat($LZ, strs#0));

function JSON_mUtils_mStr.__default.Concat#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat#requires($ly, strs#0) } $Is(strs#0, TSeq(TSeq(TChar))) ==> (JSON_mUtils_mStr.__default.Concat#requires($ly, strs#0) <==> true));

procedure {:verboseName "JSON.Utils.Str.Concat (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.Concat(strs#0: Seq where $Is(strs#0, TSeq(TSeq(TChar))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.Concat (well-formedness)"} CheckWellformed$$JSON_mUtils_mStr.__default.Concat(strs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##strs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.Concat", " | ", strs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(250,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(JSON_mUtils_mStr.__default.Concat($LS($LZ), strs#0), TSeq(TChar));
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Seq#Length(strs#0) == LitInt(0);
    assume JSON_mUtils_mStr.__default.Concat($LS($LZ), strs#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mUtils_mStr.__default.Concat($LS($LZ), strs#0), TSeq(TChar));
    return;

  anon7_Else:
    assume {:partition} Seq#Length(strs#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(strs#0);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(strs#0);
    ##strs#0 := Seq#Drop(strs#0, LitInt(1));
    assume $IsAlloc(##strs#0, TSeq(TSeq(TChar)), $Heap);
    assume Seq#Rank(##strs#0) < Seq#Rank(strs#0);
    assume JSON_mUtils_mStr.__default.Concat#canCall(Seq#Drop(strs#0, LitInt(1)));
    assume JSON_mUtils_mStr.__default.Concat($LS($LZ), strs#0) == Seq#Append($Unbox(Seq#Index(strs#0, LitInt(0))): Seq, JSON_mUtils_mStr.__default.Concat($LS($LZ), Seq#Drop(strs#0, LitInt(1))));
    assume JSON_mUtils_mStr.__default.Concat#canCall(Seq#Drop(strs#0, LitInt(1)));
    assume $Is(JSON_mUtils_mStr.__default.Concat($LS($LZ), strs#0), TSeq(TChar));
    return;
}



procedure {:verboseName "JSON.Utils.Str.Concat_Join (well-formedness)"} CheckWellFormed$$JSON_mUtils_mStr.__default.Concat__Join(strs#0: Seq where $Is(strs#0, TSeq(TSeq(TChar))) && $IsAlloc(strs#0, TSeq(TSeq(TChar)), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Str.Concat_Join (call precondtion)"} CallPre$$JSON_mUtils_mStr.__default.Concat__Join(strs#0: Seq where $Is(strs#0, TSeq(TSeq(TChar))) && $IsAlloc(strs#0, TSeq(TSeq(TChar)), $Heap));



procedure {:verboseName "JSON.Utils.Str.Concat_Join (call postcondition)"} CallPost$$JSON_mUtils_mStr.__default.Concat__Join(strs#0: Seq where $Is(strs#0, TSeq(TSeq(TChar))) && $IsAlloc(strs#0, TSeq(TSeq(TChar)), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mStr.__default.Concat#canCall(strs#0) && JSON_mUtils_mStr.__default.Join#canCall(Lit(Seq#Empty(): Seq), strs#0);
  free ensures {:id "id21501"} Seq#Equal(JSON_mUtils_mStr.__default.Concat($LS($LS($LZ)), strs#0), JSON_mUtils_mStr.__default.Join($LS($LS($LZ)), Lit(Seq#Empty(): Seq), strs#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Str.Concat_Join (correctness)"} Impl$$JSON_mUtils_mStr.__default.Concat__Join(strs#0: Seq where $Is(strs#0, TSeq(TSeq(TChar))) && $IsAlloc(strs#0, TSeq(TSeq(TChar)), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mUtils_mStr.__default.Concat#canCall(strs#0) && JSON_mUtils_mStr.__default.Join#canCall(Lit(Seq#Empty(): Seq), strs#0);
  free ensures {:id "id21502"} Seq#Equal(JSON_mUtils_mStr.__default.Concat($LS($LS($LZ)), strs#0), JSON_mUtils_mStr.__default.Join($LS($LS($LZ)), Lit(Seq#Empty(): Seq), strs#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Str.Concat_Join (correctness)"} Impl$$JSON_mUtils_mStr.__default.Concat__Join(strs#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.Concat_Join", " | ", strs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy(257,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#strs0#0: Seq :: $Is($ih#strs0#0, TSeq(TSeq(TChar))) && Lit(true) && Seq#Rank($ih#strs0#0) < Seq#Rank(strs#0) ==> Seq#Equal(JSON_mUtils_mStr.__default.Concat($LS($LZ), $ih#strs0#0), JSON_mUtils_mStr.__default.Join($LS($LZ), Lit(Seq#Empty(): Seq), $ih#strs0#0)));
    $_reverifyPost := false;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#172 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#172))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#174 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#174)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#258 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#258))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#260 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#260)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#262 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#262)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#258 := Wrappers.Option.value(this); v#258)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#260 := Lit(Wrappers.Option.value(Lit(this))); v#260)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#262 := Lit(Wrappers.Option.value(Lit(this))); v#262)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#172 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#172)) else (var e#172 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#174 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#174))) else (var e#174 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#258 := Wrappers.Result.value(this); s#258) else (var e#258 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#260 := Lit(Wrappers.Result.value(Lit(this))); s#260) else (var e#260 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#262 := Lit(Wrappers.Result.value(Lit(this))); s#262) else (var e#262 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#258 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#258)) else (var e#258 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#258)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#260 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#260))) else (var e#260 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#260)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#262 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#262))) else (var e#262 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#262)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#60: int, y#60: int :: { Mul(x#60, y#60) } Mul(x#60, y#60) == Mul(y#60, x#60)) && (forall x#61: int, y#61: int, z#40: int :: { Mul(x#61 + y#61, z#40) } Mul(x#61 + y#61, z#40) == Mul(x#61, z#40) + Mul(y#61, z#40)) && (forall x#62: int, y#62: int, z#41: int :: { Mul(x#62 - y#62, z#41) } Mul(x#62 - y#62, z#41) == Mul(x#62, z#41) - Mul(y#62, z#41));

axiom MulInternals.__default.MulAuto() <==> (forall x#63: int, y#63: int :: { Mul(x#63, y#63) } Mul(x#63, y#63) == Mul(y#63, x#63)) && (forall x#64: int, y#64: int, z#42: int :: { Mul(x#64 + y#64, z#42) } Mul(x#64 + y#64, z#42) == Mul(x#64, z#42) + Mul(y#64, z#42)) && (forall x#65: int, y#65: int, z#43: int :: { Mul(x#65 - y#65, z#43) } Mul(x#65 - y#65, z#43) == Mul(x#65, z#43) - Mul(y#65, z#43));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#64: int :: { Mod(Mod(x#64, n#0), n#0) } Mod(Mod(x#64, n#0), n#0) == Mod(x#64, n#0)) && (forall x#65: int :: { Mod(x#65, n#0) } LitInt(0) <= x#65 && x#65 < n#0 <==> Mod(x#65, n#0) == x#65) && (forall x#66: int, y#32: int :: { Mod(x#66 + y#32, n#0) } (var z#30 := Mod(x#66, n#0) + Mod(y#32, n#0); (LitInt(0) <= z#30 && z#30 < n#0 && Mod(x#66 + y#32, n#0) == z#30) || (n#0 <= z#30 && z#30 < n#0 + n#0 && Mod(x#66 + y#32, n#0) == z#30 - n#0))) && (forall x#67: int, y#33: int :: { Mod(x#67 - y#33, n#0) } (var z#31 := Mod(x#67, n#0) - Mod(y#33, n#0); (LitInt(0) <= z#31 && z#31 < n#0 && Mod(x#67 - y#33, n#0) == z#31) || (0 - n#0 <= z#31 && z#31 < 0 && Mod(x#67 - y#33, n#0) == z#31 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#68: int :: { Mod(Mod(x#68, n#0), n#0) } Mod(Mod(x#68, LitInt(n#0)), LitInt(n#0)) == Mod(x#68, LitInt(n#0))) && (forall x#69: int :: { Mod(x#69, n#0) } LitInt(0) <= x#69 && x#69 < n#0 <==> Mod(x#69, LitInt(n#0)) == x#69) && (forall x#70: int, y#34: int :: { Mod(x#70 + y#34, n#0) } (var z#32 := Mod(x#70, LitInt(n#0)) + Mod(y#34, LitInt(n#0)); (LitInt(0) <= z#32 && z#32 < n#0 && Mod(x#70 + y#34, LitInt(n#0)) == z#32) || (LitInt(n#0) <= z#32 && z#32 < n#0 + n#0 && Mod(x#70 + y#34, LitInt(n#0)) == z#32 - n#0))) && (forall x#71: int, y#35: int :: { Mod(x#71 - y#35, n#0) } (var z#33 := Mod(x#71, LitInt(n#0)) - Mod(y#35, LitInt(n#0)); (LitInt(0) <= z#33 && z#33 < n#0 && Mod(x#71 - y#35, LitInt(n#0)) == z#33) || (LitInt(0 - n#0) <= z#33 && z#33 < 0 && Mod(x#71 - y#35, LitInt(n#0)) == z#33 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#42: int :: { Div(x#42, n#0) } LitInt(0) <= x#42 && x#42 < n#0 <==> Div(x#42, n#0) == LitInt(0)) && (forall x#43: int, y#28: int :: { Div(x#43 + y#28, n#0) } (var z#26 := Mod(x#43, n#0) + Mod(y#28, n#0); (LitInt(0) <= z#26 && z#26 < n#0 && Div(x#43 + y#28, n#0) == Div(x#43, n#0) + Div(y#28, n#0)) || (n#0 <= z#26 && z#26 < n#0 + n#0 && Div(x#43 + y#28, n#0) == Div(x#43, n#0) + Div(y#28, n#0) + 1))) && (forall x#44: int, y#29: int :: { Div(x#44 - y#29, n#0) } (var z#27 := Mod(x#44, n#0) - Mod(y#29, n#0); (LitInt(0) <= z#27 && z#27 < n#0 && Div(x#44 - y#29, n#0) == Div(x#44, n#0) - Div(y#29, n#0)) || (0 - n#0 <= z#27 && z#27 < 0 && Div(x#44 - y#29, n#0) == Div(x#44, n#0) - Div(y#29, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#45: int :: { Div(x#45, n#0) } LitInt(0) <= x#45 && x#45 < n#0 <==> Div(x#45, LitInt(n#0)) == LitInt(0)) && (forall x#46: int, y#30: int :: { Div(x#46 + y#30, n#0) } (var z#28 := Mod(x#46, LitInt(n#0)) + Mod(y#30, LitInt(n#0)); (LitInt(0) <= z#28 && z#28 < n#0 && Div(x#46 + y#30, LitInt(n#0)) == Div(x#46, LitInt(n#0)) + Div(y#30, LitInt(n#0))) || (LitInt(n#0) <= z#28 && z#28 < n#0 + n#0 && Div(x#46 + y#30, LitInt(n#0)) == Div(x#46, LitInt(n#0)) + Div(y#30, LitInt(n#0)) + 1))) && (forall x#47: int, y#31: int :: { Div(x#47 - y#31, n#0) } (var z#29 := Mod(x#47, LitInt(n#0)) - Mod(y#31, LitInt(n#0)); (LitInt(0) <= z#29 && z#29 < n#0 && Div(x#47 - y#31, LitInt(n#0)) == Div(x#47, LitInt(n#0)) - Div(y#31, LitInt(n#0))) || (LitInt(0 - n#0) <= z#29 && z#29 < 0 && Div(x#47 - y#31, LitInt(n#0)) == Div(x#47, LitInt(n#0)) - Div(y#31, LitInt(n#0)) - 1)))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#3: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#3 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#4 := Seq#Append(digits'#3, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#4))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#4 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#5 := Seq#Append(digits'#4, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#5))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#5 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#6 := Seq#Append(digits'#5, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#6))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#3: Box :: { Seq#Contains(chars#0, c#3) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#3) } $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#3) ==> Seq#Contains(chars#0, c#3)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $Heap: Heap, $ly: LayerType, digits#0: Seq, chars#0: Seq :: { $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) } (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $IsAlloc(digits#0, TSeq(TInt), $Heap) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0)))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#8: int :: { Seq#Contains(digits#0, $Box(d#8)) } Seq#Contains(digits#0, $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#3: Box :: { Seq#Contains(chars#0, c#3) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#3) } $IsBox(c#3, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#3) ==> Seq#Contains(chars#0, c#3)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $Heap: Heap, n#0: int, chars#0: Seq :: { $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) } (JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) && Seq#Length(chars#0) > 1)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#2 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#2) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#2 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#3 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#3) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#3 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#5: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#5)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#5) } $IsBox(c#5, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#5) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#5)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#6: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#6)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#6) } $IsBox(c#6, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#6) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#6)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#7: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#7)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#7) } $IsBox(c#7, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#7) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#7)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Seq#Contains(chars#0, $l#7#c#0))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $Heap: Heap, n#0: int, chars#0: Seq, minus#0: Box :: { $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) } (JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsAlloc(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $IsAllocBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), $Heap) && Seq#Length(chars#0) > 1)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char()), $Heap));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, minus#0), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(0 - n#0, chars#0))));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, minus#0), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), Lit(minus#0)) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: Box :: { Map#Domain(digits#0)[c#0] } { Seq#Contains(str#0, c#0) } $IsBox(c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#0) ==> Map#Domain(digits#0)[c#0])) ==> LitInt(0) <= JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#5: Box :: { Map#Domain(digits#0)[c#5] } { Seq#Contains(str#0, c#5) } $IsBox(c#5, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#5) ==> Map#Domain(digits#0)[c#5])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#5: Box :: { Map#Domain(digits#0)[c#5] } { Seq#Contains(str#0, c#5) } $IsBox(c#5, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#5) ==> Map#Domain(digits#0)[c#5])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#6: Box :: { Map#Domain(digits#0)[c#6] } { Seq#Contains(str#0, c#6) } $IsBox(c#6, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#6) ==> Map#Domain(digits#0)[c#6])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Map#Domain(digits#0)[$l#10#c#0])), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(digits#0)[$l#11#c#0])), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())));

axiom (forall $Heap: Heap, $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) } (JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) && (!special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0))) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if special#0[Seq#Index(str#0, LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, escape#0), Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)))));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0))) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, escape#0), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)))));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $Is(special#0, TSet(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mParametricEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0)))) && JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, Lit(escape#0)), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mParametricEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> $Is(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError())));

axiom (forall $Heap: Heap, $ly: LayerType, str#0: Seq, escape#0: Box :: { $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap) } (JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsAlloc(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), $Heap) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()) && $IsAllocBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char(), $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError()), $Heap));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#3 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#3)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#3 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#3))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#3 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#3) else (var tl#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#6)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#3 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#3) else (var tl#7 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#7)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#4 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#4)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#4 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#4))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#4 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#4) else (var tl#8 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#8)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#4 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#4) else (var tl#9 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#9)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#5 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#5)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#5 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#5))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#5 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#5) else (var tl#10 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#10)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#5 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#5) else (var tl#11 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#11)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#3: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#3 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#4 := Seq#Append(digits'#3, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#4))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#4 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#5 := Seq#Append(digits'#4, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#5))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#5 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#6 := Seq#Append(digits'#5, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#6))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#3: char :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) } $Is(c#3, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#8: int :: { Seq#Contains(digits#0, $Box(d#8)) } Seq#Contains(digits#0, $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#3: char :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) } $Is(c#3, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#2 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#2) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#2 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#3 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#3) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#3 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#5: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#5))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#5)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#5))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#6: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#6))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#6)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#6))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#7: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#7))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#7)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#7))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Seq#Contains(chars#0, $l#7#c#0))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar)), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(0 - n#0, chars#0))));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), Lit(minus#0)) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), Lit(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#0: char :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#5: char :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#5: char :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#6: char :: { Map#Domain(digits#0)[$Box(c#6)] } { Seq#Contains(str#0, $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(str#0, $Box(c#6)) ==> Map#Domain(digits#0)[$Box(c#6)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Map#Domain(digits#0)[$l#10#c#0])), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar)), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(digits#0)[$l#11#c#0])), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, TChar)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, str#0, special#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, str#0, special#0, escape#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, special#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) && (!special#0[Seq#Index(str#0, LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Seq#Drop(str#0, LitInt(1)), special#0, escape#0))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), str#0, special#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if special#0[Seq#Index(str#0, LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(escape#0)), Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($ly, Seq#Drop(str#0, LitInt(1)), special#0, escape#0)))));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(escape#0)), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), escape#0)))));

axiom (forall $ly: LayerType, str#0: Seq, special#0: Set, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(str#0), Lit(special#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(special#0, TSet(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) && (!Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0)))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(str#0), Lit(special#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then str#0 else (if Lit(special#0)[Seq#Index(Lit(str#0), LitInt(0))] then Seq#Append(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(Lit(escape#0))), Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(special#0), Lit(escape#0))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> $Is(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, str#0, escape#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError())));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#3 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#3)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#3 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#3))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#3 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#3) else (var tl#6 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#6)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#3 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#3) else (var tl#7 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#7)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#4 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#4)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#4 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#4) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#4)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#4))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#4 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#4) else (var tl#8 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#8)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#4 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#4) else (var tl#9 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#9)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#5 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#5)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#5 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#5) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#5)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#5))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#5 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#5) else (var tl#10 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#10)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#5 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#5) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#5) else (var tl#11 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#11)))))))));

const unique class.JSON_mUtils_mSeq.__default: ClassName;

procedure {:verboseName "JSON.Utils.Seq.Neutral (well-formedness)"} CheckWellFormed$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0: Ty, l#0: Seq where $Is(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0)) && $IsAlloc(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Seq.Neutral (call precondtion)"} CallPre$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0: Ty, l#0: Seq where $Is(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0)) && $IsAlloc(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0), $Heap));



procedure {:verboseName "JSON.Utils.Seq.Neutral (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0: Ty, l#0: Seq where $Is(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0)) && $IsAlloc(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21508"} Seq#Equal(l#0, Seq#Append(l#0, Seq#Empty(): Seq));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Seq.Neutral (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0: Ty, l#0: Seq where $Is(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0)) && $IsAlloc(l#0, TSeq(JSON.Utils.Seq._default.Neutral$_T0), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21509"} Seq#Equal(l#0, Seq#Append(l#0, Seq#Empty(): Seq));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Seq.Neutral (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0: Ty, l#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Neutral", " | ", JSON.Utils.Seq._default.Neutral$_T0, " | ", l#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Seq.dfy(6,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.Utils.Seq.Assoc (well-formedness)"} CheckWellFormed$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Seq.Assoc (call precondtion)"} CallPre$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap));



procedure {:verboseName "JSON.Utils.Seq.Assoc (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21511"} Seq#Equal(Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Append(a#0, Seq#Append(b#0, c#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Seq.Assoc (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc$_T0), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21512"} Seq#Equal(Seq#Append(Seq#Append(a#0, b#0), c#0), Seq#Append(a#0, Seq#Append(b#0, c#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Seq.Assoc (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0: Ty, a#0: Seq, b#0: Seq, c#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Assoc", " | ", JSON.Utils.Seq._default.Assoc$_T0, " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Seq.dfy(11,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.Utils.Seq.Assoc' (well-formedness)"} CheckWellFormed$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Seq.Assoc' (call precondtion)"} CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap));



procedure {:verboseName "JSON.Utils.Seq.Assoc' (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21514"} Seq#Equal(Seq#Append(a#0, Seq#Append(b#0, c#0)), Seq#Append(Seq#Append(a#0, b#0), c#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Seq.Assoc' (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc'$_T0), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21515"} Seq#Equal(Seq#Append(a#0, Seq#Append(b#0, c#0)), Seq#Append(Seq#Append(a#0, b#0), c#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Seq.Assoc' (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0: Ty, a#0: Seq, b#0: Seq, c#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Assoc'", " | ", JSON.Utils.Seq._default.Assoc'$_T0, " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Seq.dfy(17,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.Utils.Seq.Assoc2 (well-formedness)"} CheckWellFormed$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), d#0: Seq where $Is(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Utils.Seq.Assoc2 (call precondtion)"} CallPre$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), d#0: Seq where $Is(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap));



procedure {:verboseName "JSON.Utils.Seq.Assoc2 (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), d#0: Seq where $Is(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21517"} Seq#Equal(Seq#Append(Seq#Append(Seq#Append(a#0, b#0), c#0), d#0), Seq#Append(a#0, Seq#Append(Seq#Append(b#0, c#0), d#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Utils.Seq.Assoc2 (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0: Ty, a#0: Seq where $Is(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(a#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), b#0: Seq where $Is(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(b#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), c#0: Seq where $Is(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(c#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap), d#0: Seq where $Is(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0)) && $IsAlloc(d#0, TSeq(JSON.Utils.Seq._default.Assoc2$_T0), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21518"} Seq#Equal(Seq#Append(Seq#Append(Seq#Append(a#0, b#0), c#0), d#0), Seq#Append(a#0, Seq#Append(Seq#Append(b#0, c#0), d#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Seq.Assoc2 (correctness)"} Impl$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0: Ty, a#0: Seq, b#0: Seq, c#0: Seq, d#0: Seq) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Assoc2", " | ", JSON.Utils.Seq._default.Assoc2$_T0, " | ", a#0, " | ", b#0, " | ", c#0, " | ", d#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Seq.dfy(22,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



const unique class.JSON_mUtils_mVectors.__default: ClassName;

function JSON_mUtils_mVectors.__default.OOM__FAILURE() : DatatypeType
uses {
axiom JSON_mUtils_mVectors.__default.OOM__FAILURE(): DatatypeType == Lit(#Wrappers.Outcome.Fail($Box(Lit(#JSON.Utils.Vectors.VectorError.OutOfMemory()))));
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mUtils_mVectors.__default.OOM__FAILURE(), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()));
}

procedure {:verboseName "JSON.Utils.Vectors.OOM_FAILURE (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.__default.OOM__FAILURE();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.JSON_mUtils_mVectors.VectorError() : Ty
uses {
axiom Tag(Tclass.JSON_mUtils_mVectors.VectorError()) == Tagclass.JSON_mUtils_mVectors.VectorError && TagFamily(Tclass.JSON_mUtils_mVectors.VectorError()) == tytagFamily$VectorError;
}

const unique Tagclass.JSON_mUtils_mVectors.VectorError: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mVectors.VectorError()) } $IsBox(bx, Tclass.JSON_mUtils_mVectors.VectorError()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mUtils_mVectors.VectorError()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mVectors.__default.OOM__FAILURE(), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mVectors.__default.OOM__FAILURE(), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $h));

function #JSON.Utils.Vectors.VectorError.OutOfMemory() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Utils.Vectors.VectorError.OutOfMemory()) == ##JSON.Utils.Vectors.VectorError.OutOfMemory;
axiom $Is(#JSON.Utils.Vectors.VectorError.OutOfMemory(), Tclass.JSON_mUtils_mVectors.VectorError());
axiom #JSON.Utils.Vectors.VectorError.OutOfMemory() == Lit(#JSON.Utils.Vectors.VectorError.OutOfMemory());
}

const unique ##JSON.Utils.Vectors.VectorError.OutOfMemory: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Utils.Vectors.VectorError.OutOfMemory()) == ##JSON.Utils.Vectors.VectorError.OutOfMemory;
}

function JSON_mUtils_mVectors.VectorError.OutOfMemory_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d) } JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d) <==> DatatypeCtorId(d) == ##JSON.Utils.Vectors.VectorError.OutOfMemory);

axiom (forall d: DatatypeType :: { JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d) } JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d) ==> d == #JSON.Utils.Vectors.VectorError.OutOfMemory());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mUtils_mVectors.VectorError(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mUtils_mVectors.VectorError()) ==> $IsAlloc(d, Tclass.JSON_mUtils_mVectors.VectorError(), $h));

function $IsA#JSON_mUtils_mVectors.VectorError(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mUtils_mVectors.VectorError(d) } $IsA#JSON_mUtils_mVectors.VectorError(d) ==> JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d));

axiom (forall d: DatatypeType :: { JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d), $Is(d, Tclass.JSON_mUtils_mVectors.VectorError()) } $Is(d, Tclass.JSON_mUtils_mVectors.VectorError()) ==> JSON_mUtils_mVectors.VectorError.OutOfMemory_q(d));

function JSON_mUtils_mVectors.VectorError#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mVectors.VectorError#Equal(a, b) } JSON_mUtils_mVectors.VectorError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mUtils_mVectors.VectorError#Equal(a, b) } JSON_mUtils_mVectors.VectorError#Equal(a, b) <==> a == b);

const unique class.JSON_mUtils_mVectors.VectorError: ClassName;

const unique class.JSON_mUtils_mVectors.Vector?: ClassName;

function Tclass.JSON_mUtils_mVectors.Vector?(Ty) : Ty;

const unique Tagclass.JSON_mUtils_mVectors.Vector?: TyTag;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty :: { Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } Tag(Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) == Tagclass.JSON_mUtils_mVectors.Vector? && TagFamily(Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) == tytagFamily$Vector);

function Tclass.JSON_mUtils_mVectors.Vector?_0(Ty) : Ty;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty :: { Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } Tclass.JSON_mUtils_mVectors.Vector?_0(Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) == JSON.Utils.Vectors.Vector$A);

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) } $IsBox(bx, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { $Is($o, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) } $Is($o, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) <==> $o == null || dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref, $h: Heap :: { $IsAlloc($o, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $h) } $IsAlloc($o, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $h) <==> $o == null || $Unbox(read($h, $o, alloc)): bool);

const JSON_mUtils_mVectors.Vector.items: Field
uses {
axiom FDim(JSON_mUtils_mVectors.Vector.items) == 0 && FieldOfDecl(class.JSON_mUtils_mVectors.Vector?, field$items) == JSON_mUtils_mVectors.Vector.items && $IsGhostField(JSON_mUtils_mVectors.Vector.items);
}

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.items)): Seq, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.items)): Seq, TSeq(JSON.Utils.Vectors.Vector$A)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.items)): Seq, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.items)): Seq, TSeq(JSON.Utils.Vectors.Vector$A), $h));

const JSON_mUtils_mVectors.Vector.Repr: Field
uses {
axiom FDim(JSON_mUtils_mVectors.Vector.Repr) == 0 && FieldOfDecl(class.JSON_mUtils_mVectors.Vector?, field$Repr) == JSON_mUtils_mVectors.Vector.Repr && $IsGhostField(JSON_mUtils_mVectors.Vector.Repr);
}

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.Repr)): Set, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.Repr)): Set, TSet(Tclass._System.object())));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.Repr)): Set, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.Repr)): Set, TSet(Tclass._System.object()), $h));

function JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A: Ty, this: ref) : Box
uses {
axiom 0 < $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o) } $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $IsBox(JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o), JSON.Utils.Vectors.Vector$A));
axiom 0 < $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAllocBox(JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o), JSON.Utils.Vectors.Vector$A, $h));
}

const JSON_mUtils_mVectors.Vector.size: Field
uses {
axiom FDim(JSON_mUtils_mVectors.Vector.size) == 0 && FieldOfDecl(class.JSON_mUtils_mVectors.Vector?, field$size) == JSON_mUtils_mVectors.Vector.size && !$IsGhostField(JSON_mUtils_mVectors.Vector.size);
}

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.size)): int, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.size)): int, Tclass.BoundedInts.uint32()));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.size)): int, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.size)): int, Tclass.BoundedInts.uint32(), $h));

const JSON_mUtils_mVectors.Vector.capacity: Field
uses {
axiom FDim(JSON_mUtils_mVectors.Vector.capacity) == 0 && FieldOfDecl(class.JSON_mUtils_mVectors.Vector?, field$capacity) == JSON_mUtils_mVectors.Vector.capacity && !$IsGhostField(JSON_mUtils_mVectors.Vector.capacity);
}

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.capacity)): int, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.capacity)): int, Tclass.BoundedInts.uint32()));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.capacity)): int, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.capacity)): int, Tclass.BoundedInts.uint32(), $h));

const JSON_mUtils_mVectors.Vector.data: Field
uses {
axiom FDim(JSON_mUtils_mVectors.Vector.data) == 0 && FieldOfDecl(class.JSON_mUtils_mVectors.Vector?, field$data) == JSON_mUtils_mVectors.Vector.data && !$IsGhostField(JSON_mUtils_mVectors.Vector.data);
}

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.data)): ref, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.data)): ref, Tclass._System.array(JSON.Utils.Vectors.Vector$A)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { $Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.data)): ref, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc($Unbox(read($h, $o, JSON_mUtils_mVectors.Vector.data)): ref, Tclass._System.array(JSON.Utils.Vectors.Vector$A), $h));

function JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A: Ty, this: ref) : int
uses {
axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this): int } JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this): int == BoundedInts.__default.UINT32__MAX());
axiom 0 < $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o) } $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is(JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32()));
axiom 0 < $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32(), $h));
}

function Tclass.JSON_mUtils_mVectors.Vector(Ty) : Ty;

const unique Tagclass.JSON_mUtils_mVectors.Vector: TyTag;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty :: { Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A) } Tag(Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) == Tagclass.JSON_mUtils_mVectors.Vector && TagFamily(Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) == tytagFamily$Vector);

function Tclass.JSON_mUtils_mVectors.Vector_0(Ty) : Ty;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty :: { Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A) } Tclass.JSON_mUtils_mVectors.Vector_0(Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) == JSON.Utils.Vectors.Vector$A);

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) } $IsBox(bx, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)));

procedure {:verboseName "JSON.Utils.Vectors.Vector.MAX_CAPACITY (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A: Ty, this: ref) : int
uses {
axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this): int } JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this): int == Div(BoundedInts.__default.UINT32__MAX(), LitInt(2)));
axiom 0 < $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o) } $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is(JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32()));
axiom 0 < $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32(), $h));
}

procedure {:verboseName "JSON.Utils.Vectors.Vector.MAX_CAPACITY_BEFORE_DOUBLING (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.MAX_CAPACITY_BEFORE_DOUBLING (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A: Ty, this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.MAX_CAPACITY_BEFORE_DOUBLING", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(23,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := LitInt(2);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume LitInt(2) != 0;
    newtype$check#1 := Div(BoundedInts.__default.UINT32__MAX(), LitInt(2));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    return;
}



function JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A: Ty, $heap: Heap, this: ref) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) } JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box(this)]);
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this), $IsGoodHeap($Heap) } JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) ==> (JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) <==> Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int))));
}

function JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A: Ty, $heap: Heap, this: ref) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || ($Unbox(read($h0, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)]) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> (JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $h0, this) <==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $h1, this)));

function JSON_mUtils_mVectors.Vector.Valid_q#requires(Ty, Heap, ref) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Valid_q#requires(JSON.Utils.Vectors.Vector$A, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) ==> (JSON_mUtils_mVectors.Vector.Valid_q#requires(JSON.Utils.Vectors.Vector$A, $Heap, this) <==> true));

procedure {:verboseName "JSON.Utils.Vectors.Vector.Valid? (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id21522"} JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box(this)];



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Valid? (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A: Ty, this: ref)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var newtype$check#0: int;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;
  var b$reqreads#10: bool;
  var b$reqreads#11: bool;
  var b$reqreads#12: bool;
  var b$reqreads#13: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Valid?", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;
    b$reqreads#10 := true;
    b$reqreads#11 := true;
    b$reqreads#12 := true;
    b$reqreads#13 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(25,20): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)]);
    b$reqreads#0 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.Repr];
    assume b$reqreads#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume this == this || (Set#Subset(Set#Union($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))) && !Set#Subset(Set#Union($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this))), Set#Union($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#Empty(): Set, $Box(this)))));
    assume this == this || JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box(this)];
    goto anon5;

  anon18_Else:
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box(this)];
    goto anon5;

  anon5:
    assume false;
    return;

  anon17_Else:
    b$reqreads#1 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.Repr];
    b$reqreads#2 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
    b$reqreads#3 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.capacity];
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon8;

  anon19_Else:
    assume {:partition} !Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
    goto anon8;

  anon8:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
    b$reqreads#4 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    b$reqreads#5 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.capacity];
    goto anon10;

  anon20_Else:
    assume {:partition} !(Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0);
    goto anon10;

  anon10:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    b$reqreads#6 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.size];
    b$reqreads#7 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.capacity];
    goto anon12;

  anon21_Else:
    assume {:partition} !(Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int);
    goto anon12;

  anon12:
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    b$reqreads#8 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.size];
    b$reqreads#9 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.items];
    goto anon14;

  anon22_Else:
    assume {:partition} !(Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int);
    goto anon14;

  anon14:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
    b$reqreads#10 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.items];
    b$reqreads#11 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    b$reqreads#12 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.size];
    assume 0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    b$reqreads#13 := (forall $i: int :: { $_ReadsFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($i)] } 0 <= $i && $i < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int ==> $_ReadsFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($i)]);
    goto anon16;

  anon23_Else:
    assume {:partition} !(Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq));
    goto anon16;

  anon16:
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) <==> Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
    assume true;
    assume $Is(JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this), TBool);
    assume b$reqreads#1;
    assume b$reqreads#2;
    assume b$reqreads#3;
    assume b$reqreads#4;
    assume b$reqreads#5;
    assume b$reqreads#6;
    assume b$reqreads#7;
    assume b$reqreads#8;
    assume b$reqreads#9;
    assume b$reqreads#10;
    assume b$reqreads#11;
    assume b$reqreads#12;
    assume b$reqreads#13;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector._ctor (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.__ctor(JSON.Utils.Vectors.Vector$A: Ty, a0#0: Box where $IsBox(a0#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a0#0, JSON.Utils.Vectors.Vector$A, $Heap), initial_capacity#0: int where LitInt(0) <= initial_capacity#0 && initial_capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector._ctor (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.__ctor(JSON.Utils.Vectors.Vector$A: Ty, a0#0: Box, initial_capacity#0: int) returns (this: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector._ctor", " | ", JSON.Utils.Vectors.Vector$A, " | ", a0#0, " | ", initial_capacity#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(37,4): initial state"} true;
    newtype$check#0 := LitInt(8);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    newtype$check#1 := LitInt(0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume initial_capacity#0 > 0;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc this;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(39,19): post-state"} true;
    newtype$check#2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == LitInt(0);
    assume Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Empty(): Seq);
    assume (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector._ctor (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.__ctor(JSON.Utils.Vectors.Vector$A: Ty, a0#0: Box where $IsBox(a0#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a0#0, JSON.Utils.Vectors.Vector$A, $Heap), initial_capacity#0: int where LitInt(0) <= initial_capacity#0 && initial_capacity#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id21554"} initial_capacity#0 > 0;



procedure {:verboseName "JSON.Utils.Vectors.Vector._ctor (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.__ctor(JSON.Utils.Vectors.Vector$A: Ty, a0#0: Box where $IsBox(a0#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a0#0, JSON.Utils.Vectors.Vector$A, $Heap), initial_capacity#0: int where LitInt(0) <= initial_capacity#0 && initial_capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21555"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == LitInt(0);
  free ensures true;
  free ensures {:id "id21556"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Empty(): Seq);
  free ensures true;
  free ensures {:id "id21557"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21558"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures !$Unbox(read(old($Heap), this, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector._ctor (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.__ctor(JSON.Utils.Vectors.Vector$A: Ty, a0#0: Box where $IsBox(a0#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a0#0, JSON.Utils.Vectors.Vector$A, $Heap), initial_capacity#0: int where LitInt(0) <= initial_capacity#0 && initial_capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id21559"} initial_capacity#0 > 0;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21560"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == LitInt(0);
  free ensures true;
  free ensures {:id "id21561"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Empty(): Seq);
  free ensures true;
  free ensures {:id "id21562"} (forall $o: ref :: { $o != null } ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] ==> $o != null) && (forall $o: ref :: { ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] } ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)] ==> !$Unbox(read(old($Heap), $o, alloc)): bool);
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21563"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21564"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21565"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21566"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21567"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21568"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector._ctor (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.__ctor(JSON.Utils.Vectors.Vector$A: Ty, a0#0: Box, initial_capacity#0: int) returns (this: ref, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var this.items: Seq;
  var this.Repr: Set;
  var this.a: Box;
  var this.size: int;
  var this.capacity: int;
  var this.data: ref;
  var defass#this.items: bool;
  var defass#this.Repr: bool;
  var defass#this.a: bool;
  var defass#this.size: bool;
  var defass#this.capacity: bool;
  var defass#this.data: bool;
  var newtype$check#3: int;
  var $lambdaHeap#0: Heap;
  var _v0#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Box;
  var $nw: ref;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector._ctor", " | ", JSON.Utils.Vectors.Vector$A, " | ", a0#0, " | ", initial_capacity#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(43,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    this.a := a0#0;
    defass#this.a := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(44,13)"} true;
    assume true;
    assume true;
    this.items := Lit(Seq#Empty(): Seq);
    defass#this.items := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(45,17)"} true;
    assume true;
    newtype$check#3 := LitInt(0);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    this.size := LitInt(0);
    defass#this.size := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(46,15)"} true;
    assume true;
    assume true;
    this.capacity := initial_capacity#0;
    defass#this.capacity := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(47,34)"} true;
    assume true;
    assume 0 <= initial_capacity#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc _v0#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} LitInt(0) <= _v0#0;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == a0#0;
    assume true;
    assume $IsBox(lambdaResult#0, JSON.Utils.Vectors.Vector$A);
    goto anon3;

  anon6_Else:
    assume {:partition} _v0#0 < LitInt(0);
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    havoc $nw;
    assume $nw != null && $Is($nw, Tclass._System.array?(JSON.Utils.Vectors.Vector$A));
    assume !$Unbox(read($Heap, $nw, alloc)): bool;
    assume _System.array.Length($nw) == initial_capacity#0;
    assume {:subsumption 0} (forall arrayinit#0#i0#0: int :: 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < initial_capacity#0 ==> Requires1(Tclass._System.nat(), JSON.Utils.Vectors.Vector$A, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: a0#0), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $IsBox($l#0#_v0#0, Tclass._System.nat())), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    assume (forall arrayinit#0#i0#0: int :: { read($Heap, $nw, IndexField(arrayinit#0#i0#0)) } 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < initial_capacity#0 ==> read($Heap, $nw, IndexField(arrayinit#0#i0#0)) == Apply1(Tclass._System.nat(), JSON.Utils.Vectors.Vector$A, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: a0#0), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $IsBox($l#0#_v0#0, Tclass._System.nat())), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    $Heap := update($Heap, $nw, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    this.data := $nw;
    defass#this.data := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(48,46)"} true;
    assume true;
    assume defass#this.data;
    assume true;
    this.Repr := Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), $Box(this.data));
    defass#this.Repr := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(49,26)"} true;
    assume defass#this.items;
    assume defass#this.Repr;
    assume defass#this.a;
    assume defass#this.size;
    assume defass#this.capacity;
    assume defass#this.data;
    assume !$Unbox(read($Heap, this, alloc)): bool;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq == this.items;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set == this.Repr;
    assume JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, this) == this.a;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == this.size;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == this.capacity;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref == this.data;
    $Heap := update($Heap, this, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    return;
}



function JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A: Ty, $heap: Heap, this: ref, idx#0: int) : Box
uses {
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) } JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) && read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0) && $IsBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { $IsAllocBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A, $Heap) } JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> $IsAllocBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A, $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), $IsGoodHeap($Heap) } JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)));
}

function JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A: Ty, $heap: Heap, this: ref, idx#0: int) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h0: Heap, $h1: Heap, this: ref, idx#0: int :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $h1, this, idx#0) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && (JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $h0, this, idx#0) || (LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32())) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || $o == $Unbox(read($h0, this, JSON_mUtils_mVectors.Vector.data)): ref) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $h0, this, idx#0) == JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $h1, this, idx#0));

function JSON_mUtils_mVectors.Vector.At#requires(Ty, Heap, ref, int) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { JSON_mUtils_mVectors.Vector.At#requires(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mVectors.Vector.At#requires(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) <==> idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)));

procedure {:verboseName "JSON.Utils.Vectors.Vector.At (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id21586"} a#0 == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0));
  free ensures {:id "id21587"} read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.At (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A: Ty, this: ref, idx#0: int) returns (a#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.At", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", idx#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(52,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    b$reqreads#0 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.size];
    assume idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ($o == this || ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)]) ==> $_ReadsFrame[$o, $f]);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume b$reqreads#0;
    assume b$reqreads#1;
    b$reqreads#2 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    assume b$reqreads#2;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $IsBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A);
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= idx#0 && idx#0 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} a#0 == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0));
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= idx#0 && idx#0 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume 0 <= idx#0 && idx#0 < Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
    goto anon4;

  anon7_Else:
    assume {:partition} a#0 != read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0));
    goto anon4;

  anon4:
    assume a#0 == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) && read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0);
    assume false;
    return;

  anon6_Else:
    b$reqreads#3 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= idx#0 && idx#0 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    b$reqreads#4 := $_ReadsFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)];
    assume JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0));
    assume true;
    assume $IsBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A);
    assume JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) == a#0;
    assume b$reqreads#3;
    assume b$reqreads#4;
    return;
}



function JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A: Ty, $heap: Heap, this: ref) : Box
uses {
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) } JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) && read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1) && $IsBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { $IsAllocBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A, $Heap) } JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> $IsAllocBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A, $Heap));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), $IsGoodHeap($Heap) } JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)));
}

function JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A: Ty, $heap: Heap, this: ref) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h0: Heap, $h1: Heap, this: ref :: { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $h1, this) } $IsGoodHeap($h0) && $IsGoodHeap($h1) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsHeapAnchor($h0) && $HeapSucc($h0, $h1) ==> (forall $o: ref, $f: Field :: $o != null && ($o == this || $o == $Unbox(read($h0, this, JSON_mUtils_mVectors.Vector.data)): ref) ==> read($h0, $o, $f) == read($h1, $o, $f)) ==> JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $h0, this) == JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $h1, this));

function JSON_mUtils_mVectors.Vector.Top#requires(Ty, Heap, ref) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Top#requires(JSON.Utils.Vectors.Vector$A, $Heap, this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) ==> (JSON_mUtils_mVectors.Vector.Top#requires(JSON.Utils.Vectors.Vector$A, $Heap, this) <==> 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)));

procedure {:verboseName "JSON.Utils.Vectors.Vector.Top (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) returns (a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id21605"} a#0 == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1));
  free ensures {:id "id21606"} read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Top (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A: Ty, this: ref) returns (a#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Top", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(61,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    b$reqreads#0 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.size];
    assume 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && ($o == this || ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box($o)]) ==> $_ReadsFrame[$o, $f]);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume b$reqreads#0;
    assume b$reqreads#1;
    b$reqreads#2 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    assume b$reqreads#2;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $IsBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A);
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    newtype$check#1 := LitInt(1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} a#0 == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1));
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    newtype$check#3 := LitInt(1);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#4 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    newtype$check#5 := LitInt(1);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#6 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 < Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
    goto anon4;

  anon7_Else:
    assume {:partition} a#0 != read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1));
    goto anon4;

  anon4:
    assume a#0 == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) && read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1);
    assume false;
    return;

  anon6_Else:
    b$reqreads#3 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.data];
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    b$reqreads#4 := $_ReadsFrame[this, JSON_mUtils_mVectors.Vector.size];
    newtype$check#7 := LitInt(1);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#8 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__32();
    assume 0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    b$reqreads#5 := $_ReadsFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)];
    assume JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1));
    assume true;
    assume $IsBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A);
    assume JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) == a#0;
    assume b$reqreads#3;
    assume b$reqreads#4;
    assume b$reqreads#5;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Put (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32(), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Put (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref, idx#0: int, a#0: Box)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Put", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", idx#0, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(70,11): initial state"} true;
    assume idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref || $o == this);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(74,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume 0 <= idx#0 && idx#0 < Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq);
    assume Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Update($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0, a#0));
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Put (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32(), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  requires {:id "id21641"} idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
  requires {:id "id21642"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id21643"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id21644"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21645"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21646"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id21647"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));



procedure {:verboseName "JSON.Utils.Vectors.Vector.Put (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32(), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21648"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21649"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Update($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0, a#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.Put (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), idx#0: int where LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32(), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  requires {:id "id21650"} idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
  free requires {:id "id21651"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21652"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21653"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21654"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21655"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21656"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21657"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21658"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Update($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0, a#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Put (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref, idx#0: int, a#0: Box) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs#0: Box;
  var $rhs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Put", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", idx#0, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(76,4): initial state"} true;
    $_reverifyPost := false;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= idx#0 && idx#0 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume true;
    assume $_ModifiesFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)];
    assume true;
    $rhs#0 := a#0;
    $Heap := update($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0), $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(77,20)"} true;
    assume true;
    assume $_ModifiesFrame[this, JSON_mUtils_mVectors.Vector.items];
    assume 0 <= idx#0 && idx#0 < Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
    assume true;
    $rhs#1 := Seq#Update($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0, a#0);
    $Heap := update($Heap, this, JSON_mUtils_mVectors.Vector.items, $Box($rhs#1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(78,30)"} true;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_data#0: ref where $Is(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A), $Heap), count#0: int where LitInt(0) <= count#0 && count#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref, new_data#0: ref, count#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.CopyFrom", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", new_data#0, " | ", count#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(81,11): initial state"} true;
    assume new_data#0 != null;
    assume count#0 <= _System.array.Length(new_data#0);
    assume count#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(86,28): post-state"} true;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= count#0 && count#0 <= _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume new_data#0 != null;
    assume 0 <= count#0 && count#0 <= _System.array.Length(new_data#0);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Take(Seq#FromArray($Heap, new_data#0), count#0));
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= count#0 && count#0 <= _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume $IsAlloc($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref, Tclass._System.array?(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume 0 <= count#0 && count#0 <= _System.array.Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Drop(Seq#FromArray(old($Heap), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref), count#0));
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_data#0: ref where $Is(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A), $Heap), count#0: int where LitInt(0) <= count#0 && count#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id21685"} count#0 <= _System.array.Length(new_data#0);
  requires {:id "id21686"} count#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21687"} _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;



procedure {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_data#0: ref where $Is(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A), $Heap), count#0: int where LitInt(0) <= count#0 && count#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21688"} Seq#Equal(Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Take(Seq#FromArray($Heap, new_data#0), count#0));
  free ensures true;
  free ensures {:id "id21689"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Drop(Seq#FromArray(old($Heap), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref), count#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_data#0: ref where $Is(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(new_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A), $Heap), count#0: int where LitInt(0) <= count#0 && count#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id21690"} count#0 <= _System.array.Length(new_data#0);
  requires {:id "id21691"} count#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21692"} _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id21693"} Seq#Equal(Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Take(Seq#FromArray($Heap, new_data#0), count#0));
  free ensures true;
  free ensures {:id "id21694"} Seq#Equal(Seq#Drop(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Drop(Seq#FromArray(old($Heap), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref), count#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref, new_data#0: ref, count#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var idx#0: int;
  var idx#0#lo: int;
  var newtype$check#0: int;
  var idx#0#hi: int;
  var idx#0#x: int;
  var $PreLoopHeap$loop#0: Heap;
  var $w$loop#0: bool;
  var $rhs#0_0: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.CopyFrom", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", new_data#0, " | ", count#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(88,4): initial state"} true;
    $_reverifyPost := false;
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    idx#0#lo := LitInt(0);
    idx#0#hi := count#0;
    assume idx#0#lo <= idx#0#hi;
    havoc idx#0#x;
    assume idx#0#lo <= idx#0#x && idx#0#x <= idx#0#hi;
    assume $Is(idx#0#x, Tclass.BoundedInts.uint32());
    idx#0 := idx#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    havoc $w$loop#0;
    goto anon6_LoopHead;

  anon6_LoopHead:
    assume idx#0#lo <= idx#0 && idx#0 <= idx#0#hi;
    assume true;
    assume $w$loop#0 ==> idx#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume true;
    assume $w$loop#0 ==> _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume true;
    assume $w$loop#0 ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), idx#0), Seq#Take(Seq#FromArray($Heap, new_data#0), idx#0));
    assume true;
    assume $w$loop#0 ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Drop(Seq#FromArray(old($Heap), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref), count#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o] || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume true;
    goto anon6_LoopDone, anon6_LoopBody;

  anon6_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(89,6): after some loop iterations"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} !$w$loop#0;
    assume true;
    assume idx#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume {:subsumption 0} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume true;
    assume _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume {:subsumption 0} 0 <= idx#0 && idx#0 <= _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume new_data#0 != null;
    assume {:subsumption 0} 0 <= idx#0 && idx#0 <= _System.array.Length(new_data#0);
    assume true;
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), idx#0), Seq#Take(Seq#FromArray($Heap, new_data#0), idx#0));
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume {:subsumption 0} 0 <= count#0 && count#0 <= _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume $IsAlloc($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref, Tclass._System.array?(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume {:subsumption 0} 0 <= count#0 && count#0 <= _System.array.Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume true;
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), count#0), Seq#Drop(Seq#FromArray(old($Heap), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref), count#0));
    assume false;
    goto anon3;

  anon7_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} idx#0 == idx#0#hi;
    return;

  anon8_Else:
    assume {:partition} idx#0 != idx#0#hi;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= idx#0 && idx#0 < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume true;
    assume $_ModifiesFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)];
    assume new_data#0 != null;
    assume 0 <= idx#0 && idx#0 < _System.array.Length(new_data#0);
    assume true;
    $rhs#0_0 := read($Heap, new_data#0, IndexField(idx#0));
    $Heap := update($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0), $rhs#0_0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(95,34)"} true;
    idx#0 := idx#0 + 1;
    assume true;
    goto anon6_LoopHead;

  anon6_LoopDone:
    assume {:partition} false;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Realloc (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_capacity#0: int where LitInt(0) <= new_capacity#0 && new_capacity#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Realloc (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref, new_capacity#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Realloc", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", new_capacity#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(99,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume new_capacity#0 > $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume this != null;
    assume this != null;
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(103,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == new_capacity#0;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Realloc (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_capacity#0: int where LitInt(0) <= new_capacity#0 && new_capacity#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id21732"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id21733"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id21734"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21735"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21736"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id21737"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  requires {:id "id21738"} new_capacity#0 > $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;



procedure {:verboseName "JSON.Utils.Vectors.Vector.Realloc (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_capacity#0: int where LitInt(0) <= new_capacity#0 && new_capacity#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21739"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21740"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == new_capacity#0;
  free ensures true;
  free ensures {:id "id21741"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.Realloc (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), new_capacity#0: int where LitInt(0) <= new_capacity#0 && new_capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id21742"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  requires {:id "id21743"} new_capacity#0 > $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21744"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21745"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21746"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21747"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21748"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21749"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21750"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == new_capacity#0;
  free ensures true;
  free ensures {:id "id21751"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Realloc (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref, new_capacity#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var old_data#0: ref where $Is(old_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(old_data#0, Tclass._System.array(JSON.Utils.Vectors.Vector$A), $Heap);
  var old_capacity#0: int where LitInt(0) <= old_capacity#0 && old_capacity#0 < BoundedInts.__default.TWO__TO__THE__32();
  var $rhs#0: ref;
  var $rhs#1: int;
  var $obj0: ref;
  var $obj1: ref;
  var $rhs#2: ref;
  var $lambdaHeap#0: Heap;
  var _v1#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Box;
  var $nw: ref;
  var $rhs#3: int;
  var new_data##0: ref;
  var count##0: int;
  var $rhs#4: Set;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Realloc", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", new_capacity#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(106,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    assume true;
    $rhs#0 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref;
    assume true;
    $rhs#1 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    old_data#0 := $rhs#0;
    old_capacity#0 := $rhs#1;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(107,50)"} true;
    assume true;
    $obj0 := this;
    assume $_ModifiesFrame[$obj0, JSON_mUtils_mVectors.Vector.data];
    assume true;
    $obj1 := this;
    assume $_ModifiesFrame[$obj1, JSON_mUtils_mVectors.Vector.capacity];
    assume 0 <= new_capacity#0;
    goto anon5_Then, anon5_Else;

  anon5_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc _v1#0;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} LitInt(0) <= _v1#0;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, this);
    assume true;
    assume $IsBox(lambdaResult#0, JSON.Utils.Vectors.Vector$A);
    goto anon3;

  anon6_Else:
    assume {:partition} _v1#0 < LitInt(0);
    goto anon3;

  anon3:
    assume false;
    goto anon4;

  anon5_Else:
    goto anon4;

  anon4:
    havoc $nw;
    assume $nw != null && $Is($nw, Tclass._System.array?(JSON.Utils.Vectors.Vector$A));
    assume !$Unbox(read($Heap, $nw, alloc)): bool;
    assume _System.array.Length($nw) == new_capacity#0;
    assume {:subsumption 0} (forall arrayinit#0#i0#0: int :: 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < new_capacity#0 ==> Requires1(Tclass._System.nat(), JSON.Utils.Vectors.Vector$A, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v1#0: Box :: JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, this)), (lambda $l#0#heap#0: Heap, $l#0#_v1#0: Box :: $IsBox($l#0#_v1#0, Tclass._System.nat())), (lambda $l#0#heap#0: Heap, $l#0#_v1#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    assume (forall arrayinit#0#i0#0: int :: { read($Heap, $nw, IndexField(arrayinit#0#i0#0)) } 0 <= arrayinit#0#i0#0 && arrayinit#0#i0#0 < new_capacity#0 ==> read($Heap, $nw, IndexField(arrayinit#0#i0#0)) == Apply1(Tclass._System.nat(), JSON.Utils.Vectors.Vector$A, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v1#0: Box :: JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, this)), (lambda $l#0#heap#0: Heap, $l#0#_v1#0: Box :: $IsBox($l#0#_v1#0, Tclass._System.nat())), (lambda $l#0#heap#0: Heap, $l#0#_v1#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))), $Box(arrayinit#0#i0#0)));
    $Heap := update($Heap, $nw, alloc, $Box(true));
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    $rhs#2 := $nw;
    assume true;
    $rhs#3 := new_capacity#0;
    $Heap := update($Heap, $obj0, JSON_mUtils_mVectors.Vector.data, $Box($rhs#2));
    assume $IsGoodHeap($Heap);
    $Heap := update($Heap, $obj1, JSON_mUtils_mVectors.Vector.capacity, $Box($rhs#3));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(108,65)"} true;
    assume true;
    assume true;
    new_data##0 := old_data#0;
    assume true;
    count##0 := old_capacity#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A, this, new_data##0, count##0);
    call CallPost$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A, this, new_data##0, count##0);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(109,38)"} true;
    assume true;
    assume $_ModifiesFrame[this, JSON_mUtils_mVectors.Vector.Repr];
    assume true;
    $rhs#4 := Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data));
    $Heap := update($Heap, this, JSON_mUtils_mVectors.Vector.Repr, $Box($rhs#4));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(110,26)"} true;
    return;
}



function JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, capacity#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> LitInt(0) <= JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) && JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) < BoundedInts.__default.TWO__TO__THE__32());
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, capacity#0) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) == (if capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), capacity#0) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this)));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: {:weight 3} { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, LitInt(capacity#0)) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, LitInt(capacity#0)) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, LitInt(capacity#0)) == (if capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), LitInt(capacity#0)) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this)));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: {:weight 3} { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, Lit(this), LitInt(capacity#0)) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, Lit(this), LitInt(capacity#0)) || (1 < $FunctionContextHeight && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, Lit(this), LitInt(capacity#0)) == (if capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, Lit(this)) then Mul(LitInt(2), LitInt(capacity#0)) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, Lit(this))));
}

function JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int) : bool;

function JSON_mUtils_mVectors.Vector.DefaultNewCapacity#requires(Ty, ref, int) : bool;

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: { JSON_mUtils_mVectors.Vector.DefaultNewCapacity#requires(JSON.Utils.Vectors.Vector$A, this, capacity#0) } this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mVectors.Vector.DefaultNewCapacity#requires(JSON.Utils.Vectors.Vector$A, this, capacity#0) <==> true));

procedure {:verboseName "JSON.Utils.Vectors.Vector.DefaultNewCapacity (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), capacity#0: int where LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.DefaultNewCapacity (well-formedness)"} CheckWellformed$$JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.DefaultNewCapacity", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", capacity#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(113,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume LitInt(0) <= JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) && JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume false;
    return;

  anon6_Else:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this);
    newtype$check#0 := LitInt(2);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := Mul(LitInt(2), capacity#0);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) == Mul(LitInt(2), capacity#0);
    assume true;
    assume $Is(JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0), Tclass.BoundedInts.uint32());
    return;

  anon7_Else:
    assume {:partition} JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) <= capacity#0;
    assume JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) == JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
    assume true;
    assume $Is(JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0), Tclass.BoundedInts.uint32());
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref) returns (o#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.ReallocDefault", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(119,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume this != null;
    assume this != null;
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc(old($Heap), $Heap);
    havoc o#0;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(122,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume Wrappers.Outcome.Fail_q(o#0) <==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int == JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Wrappers.Outcome.Fail_q(o#0);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume $IsAlloc($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, Tclass._System.array(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon4;

  anon10_Else:
    assume Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)) && (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Outcome.Pass_q(o#0);
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this);
    newtype$check#0 := LitInt(2);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    newtype$check#1 := Mul(LitInt(2), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon8;

  anon12_Else:
    assume {:partition} JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) <= $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    goto anon8;

  anon8:
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == (if $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this));
    return;

  anon11_Else:
    assume Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool && $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == (if $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this));
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  requires {:id "id21800"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id21801"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id21802"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21803"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21804"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id21805"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));



procedure {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21806"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21807"} Wrappers.Outcome.Fail_q(o#0) <==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int == JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
  free ensures true;
  free ensures {:id "id21808"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures {:id "id21809"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id21810"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
  free ensures {:id "id21811"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
  free ensures {:id "id21812"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == (if $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) returns (defass#o#0: bool, o#0: DatatypeType where defass#o#0 ==> $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id21813"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21814"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21815"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21816"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21817"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21818"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21819"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21820"} Wrappers.Outcome.Fail_q(o#0) <==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int == JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
  free ensures true;
  free ensures {:id "id21821"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures {:id "id21822"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id21823"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
  free ensures {:id "id21824"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
  free ensures {:id "id21825"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == (if $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref) returns (defass#o#0: bool, o#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var new_capacity##0: int;
  var ##capacity#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.ReallocDefault", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(133,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int == JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
    push;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Outcome.Fail($Box(Lit(#JSON.Utils.Vectors.VectorError.OutOfMemory()))));
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(135,32)"} true;
    assume defass#o#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
    assume true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    ##capacity#0 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume $IsAlloc(##capacity#0, Tclass.BoundedInts.uint32(), $Heap);
    assume JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int);
    assume JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int);
    new_capacity##0 := JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int);
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A, this, new_capacity##0);
    call CallPost$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A, this, new_capacity##0);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(137,43)"} true;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Outcome.Pass());
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(138,17)"} true;
    assume defass#o#0;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Ensure (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), reserved#0: int where LitInt(0) <= reserved#0 && reserved#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Ensure (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref, reserved#0: int) returns (o#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Ensure", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", reserved#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(141,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume this != null;
    assume this != null;
    assume this != null;
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc(old($Heap), $Heap);
    havoc o#0;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(144,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    newtype$check#0 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume Wrappers.Outcome.Pass_q(o#0);
    goto anon4;

  anon10_Else:
    assume reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int ==> Wrappers.Outcome.Pass_q(o#0);
    goto anon4;

  anon4:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Outcome.Pass_q(o#0);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    goto anon7;

  anon11_Else:
    assume Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    goto anon7;

  anon7:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Wrappers.Outcome.Fail_q(o#0);
    newtype$check#1 := JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume reserved#0 > JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    return;

  anon12_Else:
    assume Wrappers.Outcome.Fail_q(o#0) ==> reserved#0 > JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Ensure (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), reserved#0: int where LitInt(0) <= reserved#0 && reserved#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id21852"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id21853"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id21854"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21855"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21856"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id21857"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));



procedure {:verboseName "JSON.Utils.Vectors.Vector.Ensure (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), reserved#0: int where LitInt(0) <= reserved#0 && reserved#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21858"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21859"} reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int ==> Wrappers.Outcome.Pass_q(o#0);
  free ensures true;
  free ensures {:id "id21860"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures true;
  free ensures {:id "id21861"} Wrappers.Outcome.Fail_q(o#0) ==> reserved#0 > JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.Ensure (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), reserved#0: int where LitInt(0) <= reserved#0 && reserved#0 < BoundedInts.__default.TWO__TO__THE__32()) returns (defass#o#0: bool, o#0: DatatypeType where defass#o#0 ==> $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  free requires {:id "id21862"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21863"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21864"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21865"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21866"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21867"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21868"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21869"} reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int ==> Wrappers.Outcome.Pass_q(o#0);
  free ensures true;
  free ensures {:id "id21870"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures true;
  free ensures {:id "id21871"} Wrappers.Outcome.Fail_q(o#0) ==> reserved#0 > JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || $o == this || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Ensure (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref, reserved#0: int) returns (defass#o#0: bool, o#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var new_capacity#0: int where LitInt(0) <= new_capacity#0 && new_capacity#0 < BoundedInts.__default.TWO__TO__THE__32();
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#o#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var $decr$loop#00: int;
  var ##capacity#2_0: int;
  var new_capacity##0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Ensure", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", reserved#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(152,4): initial state"} true;
    $_reverifyPost := false;
    newtype$check#2 := JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} reserved#0 > JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    push;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Outcome.Fail($Box(Lit(#JSON.Utils.Vectors.VectorError.OutOfMemory()))));
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(154,32)"} true;
    assume defass#o#0;
    pop;
    return;

  anon16_Else:
    assume {:partition} JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int >= reserved#0;
    newtype$check#3 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} reserved#0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    push;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Outcome.Pass());
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(157,19)"} true;
    assume defass#o#0;
    pop;
    return;

  anon17_Else:
    assume {:partition} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int < reserved#0;
    assume true;
    assume true;
    new_capacity#0 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(159,34)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#o#0 := defass#o#0;
    $decr_init$loop#00 := JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - new_capacity#0;
    havoc $w$loop#0;
    goto anon18_LoopHead;

  anon18_LoopHead:
    assume true;
    assume $w$loop#0 ==> new_capacity#0 >= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o] || $o == this || $o == this || $o == this || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $o == this || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#o#0 ==> defass#o#0;
    assume JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - new_capacity#0 <= $decr_init$loop#00;
    goto anon18_LoopDone, anon18_LoopBody;

  anon18_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(160,6): after some loop iterations"} true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} !$w$loop#0;
    assume true;
    assume new_capacity#0 >= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    newtype$check#4 := JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - new_capacity#0;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    assume false;
    goto anon11;

  anon19_Else:
    assume {:partition} $w$loop#0;
    goto anon11;

  anon11:
    newtype$check#5 := new_capacity#0 - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} new_capacity#0 - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int >= reserved#0;
    goto anon14;

  anon20_Else:
    assume {:partition} reserved#0 > new_capacity#0 - $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int;
    $decr$loop#00 := JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - new_capacity#0;
    push;
    assume true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    ##capacity#2_0 := new_capacity#0;
    assume $IsAlloc(##capacity#2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, new_capacity#0);
    assume JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, new_capacity#0);
    new_capacity#0 := JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, new_capacity#0);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(164,56)"} true;
    pop;
    assume 0 <= $decr$loop#00 || JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - new_capacity#0 == $decr$loop#00;
    assume JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) - new_capacity#0 < $decr$loop#00;
    assume true;
    goto anon18_LoopHead;

  anon18_LoopDone:
    assume {:partition} false;
    goto anon14;

  anon14:
    assume true;
    assume true;
    new_capacity##0 := new_capacity#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A, this, new_capacity##0);
    call CallPost$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A, this, new_capacity##0);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(166,27)"} true;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Outcome.Pass());
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(167,17)"} true;
    assume defass#o#0;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.PopFast (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.PopFast (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.PopFast", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(170,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int > 0;
    assume this != null;
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(174,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    newtype$check#1 := LitInt(1);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#2 := $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume 0 <= Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1 && Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1 <= Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq);
    assume Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1));
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.PopFast (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  requires {:id "id21906"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id21907"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id21908"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21909"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21910"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id21911"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  requires {:id "id21912"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int > 0;



procedure {:verboseName "JSON.Utils.Vectors.Vector.PopFast (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21913"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21914"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int - 1;
  free ensures true;
  free ensures {:id "id21915"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.PopFast (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id21916"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  requires {:id "id21917"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int > 0;
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21918"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21919"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21920"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21921"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21922"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21923"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21924"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int - 1;
  free ensures true;
  free ensures {:id "id21925"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Length($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.PopFast (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs#0: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var $rhs#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.PopFast", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items));
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(177,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume $_ModifiesFrame[this, JSON_mUtils_mVectors.Vector.size];
    newtype$check#3 := LitInt(1);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#4 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    $rhs#0 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1;
    $Heap := update($Heap, this, JSON_mUtils_mVectors.Vector.size, $Box($rhs#0));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(178,22)"} true;
    assume true;
    assume $_ModifiesFrame[this, JSON_mUtils_mVectors.Vector.items];
    assume 0 <= Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1 && Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1 <= Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
    assume true;
    $rhs#1 := Seq#Take($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) - 1);
    $Heap := update($Heap, this, JSON_mUtils_mVectors.Vector.items, $Box($rhs#1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(179,35)"} true;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.PushFast (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.PushFast (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref, a#0: Box)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.PushFast", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(182,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume this != null;
    assume this != null;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(186,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0)));
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.PushFast (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  requires {:id "id21946"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id21947"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id21948"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21949"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id21950"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id21951"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  requires {:id "id21952"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;



procedure {:verboseName "JSON.Utils.Vectors.Vector.PushFast (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21953"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21954"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
  free ensures true;
  free ensures {:id "id21955"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.PushFast (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id21956"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  requires {:id "id21957"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id21958"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id21959"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id21960"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21961"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id21962"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id21963"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id21964"} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
  free ensures true;
  free ensures {:id "id21965"} Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0)));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> read($Heap, $o, $f) == read(old($Heap), $o, $f) || ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items) || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.PushFast (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref, a#0: Box) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs#0: Box;
  var $rhs#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var $rhs#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.PushFast", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> ($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(189,4): initial state"} true;
    $_reverifyPost := false;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null;
    assume 0 <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int < _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume true;
    assume $_ModifiesFrame[$Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int)];
    assume true;
    $rhs#0 := a#0;
    $Heap := update($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int), $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(190,21)"} true;
    assume true;
    assume $_ModifiesFrame[this, JSON_mUtils_mVectors.Vector.size];
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#3 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int + 1;
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    $rhs#1 := $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int + 1;
    $Heap := update($Heap, this, JSON_mUtils_mVectors.Vector.size, $Box($rhs#1));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(191,22)"} true;
    assume true;
    assume $_ModifiesFrame[this, JSON_mUtils_mVectors.Vector.items];
    assume true;
    $rhs#2 := Seq#Append($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0));
    $Heap := update($Heap, this, JSON_mUtils_mVectors.Vector.items, $Box($rhs#2));
    assume $IsGoodHeap($Heap);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(192,26)"} true;
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Push (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Push (well-formedness)"} CheckWellFormed$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref, a#0: Box) returns (o#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Push", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(195,11): initial state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume $HeapSucc(old($Heap), $Heap);
    havoc o#0;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(198,20): post-state"} true;
    assume $IsAllocBox($Box(this), Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $Heap);
    assume JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
    assume JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume Wrappers.Outcome.Fail_q(o#0);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    assume $IsAlloc($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, Tclass._System.array(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon4;

  anon9_Else:
    assume Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)) && (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    goto anon4;

  anon4:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Wrappers.Outcome.Pass_q(o#0);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#1 := $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__32();
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0)));
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int >= $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
    return;

  anon11_Else:
    assume $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int != $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int;
    assume $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this && ($f == JSON_mUtils_mVectors.Vector.data || $f == alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    return;

  anon10_Else:
    assume Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1 && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int >= $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int && (if $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int then $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool else (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this && ($f == JSON_mUtils_mVectors.Vector.data || $f == alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)));
    return;
}



procedure {:verboseName "JSON.Utils.Vectors.Vector.Push (call precondtion)"} CallPre$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap));
  requires {:id "id22006"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  requires {:id "id22007"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  requires {:id "id22008"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id22009"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  requires {:id "id22010"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  requires {:id "id22011"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));



procedure {:verboseName "JSON.Utils.Vectors.Vector.Push (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap)) returns (o#0: DatatypeType where $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id22012"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id22013"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures {:id "id22014"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id22015"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
  free ensures {:id "id22016"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
  free ensures {:id "id22017"} Wrappers.Outcome.Pass_q(o#0) ==> Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0)));
  free ensures {:id "id22018"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int >= $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id22019"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
  free ensures {:id "id22020"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int != $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this && ($f == JSON_mUtils_mVectors.Vector.data || $f == alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.Utils.Vectors.Vector.Push (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref where this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap), a#0: Box where $IsBox(a#0, JSON.Utils.Vectors.Vector$A) && $IsAllocBox(a#0, JSON.Utils.Vectors.Vector$A, $Heap)) returns (defass#o#0: bool, o#0: DatatypeType where defass#o#0 ==> $Is(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(o#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap), $_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  free requires {:id "id22021"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) && Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  modifies $Heap;
  free ensures JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this);
  free ensures {:id "id22022"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data)));
  free ensures {:id "id22023"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0;
  free ensures {:id "id22024"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id22025"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id22026"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq);
  free ensures {:id "id22027"} JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) || Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int));
  free ensures true;
  free ensures {:id "id22028"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures {:id "id22029"} Wrappers.Outcome.Fail_q(o#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures true;
  free ensures {:id "id22030"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int < JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this);
  free ensures {:id "id22031"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int + 1;
  free ensures {:id "id22032"} Wrappers.Outcome.Pass_q(o#0) ==> Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Append($Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Build(Seq#Empty(): Seq, a#0)));
  free ensures {:id "id22033"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int >= $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int;
  free ensures {:id "id22034"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int ==> $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref != null && !$Unbox(read(old($Heap), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, alloc)): bool;
  free ensures {:id "id22035"} Wrappers.Outcome.Pass_q(o#0) ==> $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.size)): int != $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.capacity)): int ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == this && ($f == JSON_mUtils_mVectors.Vector.data || $f == alloc) ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == this || $o == $Unbox(read(old($Heap), this, JSON_mUtils_mVectors.Vector.data)): ref);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Utils.Vectors.Vector.Push (correctness)"} Impl$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref, a#0: Box) returns (defass#o#0: bool, o#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0_0: DatatypeType where $Is(d#0_0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError())) && $IsAlloc(d#0_0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $Heap);
  var $rhs##0_0: DatatypeType;
  var a##0: Box;

  anon0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Push", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == this || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(208,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    push;
    assume true;
    assume true;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (($o == this && $f == JSON_mUtils_mVectors.Vector.capacity) || ($o == this && $f == JSON_mUtils_mVectors.Vector.data) || ($o == this && $f == JSON_mUtils_mVectors.Vector.Repr) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A, this);
    call $rhs##0_0 := CallPost$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A, this);
    d#0_0 := $rhs##0_0;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(210,33)"} true;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Outcome.Fail_q(d#0_0);
    push;
    assume true;
    assume true;
    o#0 := d#0_0;
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(211,29)"} true;
    assume defass#o#0;
    pop;
    pop;
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Outcome.Fail_q(d#0_0);
    pop;
    goto anon7;

  anon9_Else:
    assume {:partition} $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int != $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int;
    goto anon7;

  anon7:
    assume true;
    assume true;
    a##0 := a#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (($o == this && $f == JSON_mUtils_mVectors.Vector.size) || ($o == this && $f == JSON_mUtils_mVectors.Vector.items) || $o == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A, this, a##0);
    call CallPost$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A, this, a##0);
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(213,17)"} true;
    assume true;
    assume true;
    o#0 := Lit(#Wrappers.Outcome.Pass());
    defass#o#0 := true;
    assume {:captureState "libraries/src/JSON/Utils/Vectors.dfy(214,17)"} true;
    assume defass#o#0;
    return;
}



axiom (forall JSON.Utils.Vectors.Vector$A: Ty, c#0: ref :: { $Is(c#0, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) } $Is(c#0, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) <==> $Is(c#0, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A)) && c#0 != null);

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, c#0: ref, $h: Heap :: { $IsAlloc(c#0, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $h) } $IsAlloc(c#0, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $h) <==> $IsAlloc(c#0, Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#176 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#176))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#178 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#178)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#264 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#264))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#266 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#266)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#268 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#268)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#264 := Wrappers.Option.value(this); v#264)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#266 := Lit(Wrappers.Option.value(Lit(this))); v#266)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#268 := Lit(Wrappers.Option.value(Lit(this))); v#268)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#176 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#176)) else (var e#176 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#178 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#178))) else (var e#178 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#264 := Wrappers.Result.value(this); s#264) else (var e#264 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#266 := Lit(Wrappers.Result.value(Lit(this))); s#266) else (var e#266 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#268 := Lit(Wrappers.Result.value(Lit(this))); s#268) else (var e#268 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#264 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#264)) else (var e#264 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#264)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#266 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#266))) else (var e#266 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#266)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#268 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#268))) else (var e#268 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#268)))));

const unique tytagFamily$VectorError: TyTagFamily;

const unique tytagFamily$Vector: TyTagFamily;

const unique field$items: NameFamily;

const unique field$size: NameFamily;

const unique field$capacity: NameFamily;

const unique class.JSON_mErrors.__default: ClassName;

function #JSON.Errors.DeserializationError.UnterminatedSequence() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.UnterminatedSequence()) == ##JSON.Errors.DeserializationError.UnterminatedSequence;
axiom $Is(#JSON.Errors.DeserializationError.UnterminatedSequence(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.UnterminatedSequence() == Lit(#JSON.Errors.DeserializationError.UnterminatedSequence());
}

const unique ##JSON.Errors.DeserializationError.UnterminatedSequence: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.UnterminatedSequence()) == ##JSON.Errors.DeserializationError.UnterminatedSequence;
}

function JSON_mErrors.DeserializationError.UnterminatedSequence_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.UnterminatedSequence_q(d) } JSON_mErrors.DeserializationError.UnterminatedSequence_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.UnterminatedSequence);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.UnterminatedSequence_q(d) } JSON_mErrors.DeserializationError.UnterminatedSequence_q(d) ==> d == #JSON.Errors.DeserializationError.UnterminatedSequence());

function Tclass.JSON_mErrors.DeserializationError() : Ty
uses {
axiom Tag(Tclass.JSON_mErrors.DeserializationError()) == Tagclass.JSON_mErrors.DeserializationError && TagFamily(Tclass.JSON_mErrors.DeserializationError()) == tytagFamily$DeserializationError;
}

const unique Tagclass.JSON_mErrors.DeserializationError: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mErrors.DeserializationError()) } $IsBox(bx, Tclass.JSON_mErrors.DeserializationError()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mErrors.DeserializationError()));

function #JSON.Errors.DeserializationError.UnsupportedEscape(Seq) : DatatypeType;

const unique ##JSON.Errors.DeserializationError.UnsupportedEscape: DtCtorId
uses {
axiom (forall a#26#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(a#26#0#0) } DatatypeCtorId(#JSON.Errors.DeserializationError.UnsupportedEscape(a#26#0#0)) == ##JSON.Errors.DeserializationError.UnsupportedEscape);
}

function JSON_mErrors.DeserializationError.UnsupportedEscape_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) } JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.UnsupportedEscape);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) } JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) ==> (exists a#27#0#0: Seq :: d == #JSON.Errors.DeserializationError.UnsupportedEscape(a#27#0#0)));

axiom (forall a#28#0#0: Seq :: { $Is(#JSON.Errors.DeserializationError.UnsupportedEscape(a#28#0#0), Tclass.JSON_mErrors.DeserializationError()) } $Is(#JSON.Errors.DeserializationError.UnsupportedEscape(a#28#0#0), Tclass.JSON_mErrors.DeserializationError()) <==> $Is(a#28#0#0, TSeq(TChar)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.DeserializationError.str(d), TSeq(TChar), $h) } $IsGoodHeap($h) && JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h) ==> $IsAlloc(JSON_mErrors.DeserializationError.str(d), TSeq(TChar), $h));

axiom (forall a#29#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(Lit(a#29#0#0)) } #JSON.Errors.DeserializationError.UnsupportedEscape(Lit(a#29#0#0)) == Lit(#JSON.Errors.DeserializationError.UnsupportedEscape(a#29#0#0)));

function JSON_mErrors.DeserializationError.str(DatatypeType) : Seq;

axiom (forall a#30#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(a#30#0#0) } JSON_mErrors.DeserializationError.str(#JSON.Errors.DeserializationError.UnsupportedEscape(a#30#0#0)) == a#30#0#0);

axiom (forall a#31#0#0: Seq, i: int :: { Seq#Index(a#31#0#0, i), #JSON.Errors.DeserializationError.UnsupportedEscape(a#31#0#0) } 0 <= i && i < Seq#Length(a#31#0#0) ==> DtRank($Unbox(Seq#Index(a#31#0#0, i)): DatatypeType) < DtRank(#JSON.Errors.DeserializationError.UnsupportedEscape(a#31#0#0)));

axiom (forall a#32#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(a#32#0#0) } Seq#Rank(a#32#0#0) < DtRank(#JSON.Errors.DeserializationError.UnsupportedEscape(a#32#0#0)));

function #JSON.Errors.DeserializationError.EscapeAtEOS() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.EscapeAtEOS()) == ##JSON.Errors.DeserializationError.EscapeAtEOS;
axiom $Is(#JSON.Errors.DeserializationError.EscapeAtEOS(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.EscapeAtEOS() == Lit(#JSON.Errors.DeserializationError.EscapeAtEOS());
}

const unique ##JSON.Errors.DeserializationError.EscapeAtEOS: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.EscapeAtEOS()) == ##JSON.Errors.DeserializationError.EscapeAtEOS;
}

function JSON_mErrors.DeserializationError.EscapeAtEOS_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.EscapeAtEOS_q(d) } JSON_mErrors.DeserializationError.EscapeAtEOS_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.EscapeAtEOS);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.EscapeAtEOS_q(d) } JSON_mErrors.DeserializationError.EscapeAtEOS_q(d) ==> d == #JSON.Errors.DeserializationError.EscapeAtEOS());

function #JSON.Errors.DeserializationError.EmptyNumber() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.EmptyNumber()) == ##JSON.Errors.DeserializationError.EmptyNumber;
axiom $Is(#JSON.Errors.DeserializationError.EmptyNumber(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.EmptyNumber() == Lit(#JSON.Errors.DeserializationError.EmptyNumber());
}

const unique ##JSON.Errors.DeserializationError.EmptyNumber: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.EmptyNumber()) == ##JSON.Errors.DeserializationError.EmptyNumber;
}

function JSON_mErrors.DeserializationError.EmptyNumber_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.EmptyNumber_q(d) } JSON_mErrors.DeserializationError.EmptyNumber_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.EmptyNumber);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.EmptyNumber_q(d) } JSON_mErrors.DeserializationError.EmptyNumber_q(d) ==> d == #JSON.Errors.DeserializationError.EmptyNumber());

function #JSON.Errors.DeserializationError.ExpectingEOF() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.ExpectingEOF()) == ##JSON.Errors.DeserializationError.ExpectingEOF;
axiom $Is(#JSON.Errors.DeserializationError.ExpectingEOF(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.ExpectingEOF() == Lit(#JSON.Errors.DeserializationError.ExpectingEOF());
}

const unique ##JSON.Errors.DeserializationError.ExpectingEOF: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.ExpectingEOF()) == ##JSON.Errors.DeserializationError.ExpectingEOF;
}

function JSON_mErrors.DeserializationError.ExpectingEOF_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingEOF_q(d) } JSON_mErrors.DeserializationError.ExpectingEOF_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.ExpectingEOF);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingEOF_q(d) } JSON_mErrors.DeserializationError.ExpectingEOF_q(d) ==> d == #JSON.Errors.DeserializationError.ExpectingEOF());

function #JSON.Errors.DeserializationError.IntOverflow() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.IntOverflow()) == ##JSON.Errors.DeserializationError.IntOverflow;
axiom $Is(#JSON.Errors.DeserializationError.IntOverflow(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.IntOverflow() == Lit(#JSON.Errors.DeserializationError.IntOverflow());
}

const unique ##JSON.Errors.DeserializationError.IntOverflow: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.IntOverflow()) == ##JSON.Errors.DeserializationError.IntOverflow;
}

function JSON_mErrors.DeserializationError.IntOverflow_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.IntOverflow_q(d) } JSON_mErrors.DeserializationError.IntOverflow_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.IntOverflow);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.IntOverflow_q(d) } JSON_mErrors.DeserializationError.IntOverflow_q(d) ==> d == #JSON.Errors.DeserializationError.IntOverflow());

function #JSON.Errors.DeserializationError.ReachedEOF() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.ReachedEOF()) == ##JSON.Errors.DeserializationError.ReachedEOF;
axiom $Is(#JSON.Errors.DeserializationError.ReachedEOF(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.ReachedEOF() == Lit(#JSON.Errors.DeserializationError.ReachedEOF());
}

const unique ##JSON.Errors.DeserializationError.ReachedEOF: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.ReachedEOF()) == ##JSON.Errors.DeserializationError.ReachedEOF;
}

function JSON_mErrors.DeserializationError.ReachedEOF_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ReachedEOF_q(d) } JSON_mErrors.DeserializationError.ReachedEOF_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.ReachedEOF);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ReachedEOF_q(d) } JSON_mErrors.DeserializationError.ReachedEOF_q(d) ==> d == #JSON.Errors.DeserializationError.ReachedEOF());

function #JSON.Errors.DeserializationError.ExpectingByte(int, int) : DatatypeType;

const unique ##JSON.Errors.DeserializationError.ExpectingByte: DtCtorId
uses {
axiom (forall a#53#0#0: int, a#53#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(a#53#0#0, a#53#1#0) } DatatypeCtorId(#JSON.Errors.DeserializationError.ExpectingByte(a#53#0#0, a#53#1#0)) == ##JSON.Errors.DeserializationError.ExpectingByte);
}

function JSON_mErrors.DeserializationError.ExpectingByte_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingByte_q(d) } JSON_mErrors.DeserializationError.ExpectingByte_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.ExpectingByte);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingByte_q(d) } JSON_mErrors.DeserializationError.ExpectingByte_q(d) ==> (exists a#54#0#0: int, a#54#1#0: int :: d == #JSON.Errors.DeserializationError.ExpectingByte(a#54#0#0, a#54#1#0)));

axiom (forall a#55#0#0: int, a#55#1#0: int :: { $Is(#JSON.Errors.DeserializationError.ExpectingByte(a#55#0#0, a#55#1#0), Tclass.JSON_mErrors.DeserializationError()) } $Is(#JSON.Errors.DeserializationError.ExpectingByte(a#55#0#0, a#55#1#0), Tclass.JSON_mErrors.DeserializationError()) <==> $Is(a#55#0#0, Tclass.BoundedInts.uint8()) && $Is(a#55#1#0, Tclass.BoundedInts.opt__byte()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.DeserializationError.expected(d), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) && JSON_mErrors.DeserializationError.ExpectingByte_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h) ==> $IsAlloc(JSON_mErrors.DeserializationError.expected(d), Tclass.BoundedInts.uint8(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.DeserializationError.b(d), Tclass.BoundedInts.opt__byte(), $h) } $IsGoodHeap($h) && JSON_mErrors.DeserializationError.ExpectingByte_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h) ==> $IsAlloc(JSON_mErrors.DeserializationError.b(d), Tclass.BoundedInts.opt__byte(), $h));

axiom (forall a#56#0#0: int, a#56#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(LitInt(a#56#0#0), LitInt(a#56#1#0)) } #JSON.Errors.DeserializationError.ExpectingByte(LitInt(a#56#0#0), LitInt(a#56#1#0)) == Lit(#JSON.Errors.DeserializationError.ExpectingByte(a#56#0#0, a#56#1#0)));

function JSON_mErrors.DeserializationError.expected(DatatypeType) : int;

axiom (forall a#57#0#0: int, a#57#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(a#57#0#0, a#57#1#0) } JSON_mErrors.DeserializationError.expected(#JSON.Errors.DeserializationError.ExpectingByte(a#57#0#0, a#57#1#0)) == a#57#0#0);

function JSON_mErrors.DeserializationError.b(DatatypeType) : int;

axiom (forall a#58#0#0: int, a#58#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(a#58#0#0, a#58#1#0) } JSON_mErrors.DeserializationError.b(#JSON.Errors.DeserializationError.ExpectingByte(a#58#0#0, a#58#1#0)) == a#58#1#0);

function #JSON.Errors.DeserializationError.ExpectingAnyByte(Seq, int) : DatatypeType;

const unique ##JSON.Errors.DeserializationError.ExpectingAnyByte: DtCtorId
uses {
axiom (forall a#59#0#0: Seq, a#59#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#59#0#0, a#59#1#0) } DatatypeCtorId(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#59#0#0, a#59#1#0)) == ##JSON.Errors.DeserializationError.ExpectingAnyByte);
}

function JSON_mErrors.DeserializationError.ExpectingAnyByte_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) } JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.ExpectingAnyByte);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) } JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) ==> (exists a#60#0#0: Seq, a#60#1#0: int :: d == #JSON.Errors.DeserializationError.ExpectingAnyByte(a#60#0#0, a#60#1#0)));

axiom (forall a#61#0#0: Seq, a#61#1#0: int :: { $Is(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#61#0#0, a#61#1#0), Tclass.JSON_mErrors.DeserializationError()) } $Is(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#61#0#0, a#61#1#0), Tclass.JSON_mErrors.DeserializationError()) <==> $Is(a#61#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#61#1#0, Tclass.BoundedInts.opt__byte()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.DeserializationError.expected__sq(d), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) && JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h) ==> $IsAlloc(JSON_mErrors.DeserializationError.expected__sq(d), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.DeserializationError.b(d), Tclass.BoundedInts.opt__byte(), $h) } $IsGoodHeap($h) && JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h) ==> $IsAlloc(JSON_mErrors.DeserializationError.b(d), Tclass.BoundedInts.opt__byte(), $h));

axiom (forall a#62#0#0: Seq, a#62#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(Lit(a#62#0#0), LitInt(a#62#1#0)) } #JSON.Errors.DeserializationError.ExpectingAnyByte(Lit(a#62#0#0), LitInt(a#62#1#0)) == Lit(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#62#0#0, a#62#1#0)));

function JSON_mErrors.DeserializationError.expected__sq(DatatypeType) : Seq;

axiom (forall a#63#0#0: Seq, a#63#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#63#0#0, a#63#1#0) } JSON_mErrors.DeserializationError.expected__sq(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#63#0#0, a#63#1#0)) == a#63#0#0);

axiom (forall a#64#0#0: Seq, a#64#1#0: int, i: int :: { Seq#Index(a#64#0#0, i), #JSON.Errors.DeserializationError.ExpectingAnyByte(a#64#0#0, a#64#1#0) } 0 <= i && i < Seq#Length(a#64#0#0) ==> DtRank($Unbox(Seq#Index(a#64#0#0, i)): DatatypeType) < DtRank(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#64#0#0, a#64#1#0)));

axiom (forall a#65#0#0: Seq, a#65#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#65#0#0, a#65#1#0) } Seq#Rank(a#65#0#0) < DtRank(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#65#0#0, a#65#1#0)));

axiom (forall a#66#0#0: Seq, a#66#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#66#0#0, a#66#1#0) } JSON_mErrors.DeserializationError.b(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#66#0#0, a#66#1#0)) == a#66#1#0);

function #JSON.Errors.DeserializationError.InvalidUnicode() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.InvalidUnicode()) == ##JSON.Errors.DeserializationError.InvalidUnicode;
axiom $Is(#JSON.Errors.DeserializationError.InvalidUnicode(), Tclass.JSON_mErrors.DeserializationError());
axiom #JSON.Errors.DeserializationError.InvalidUnicode() == Lit(#JSON.Errors.DeserializationError.InvalidUnicode());
}

const unique ##JSON.Errors.DeserializationError.InvalidUnicode: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.DeserializationError.InvalidUnicode()) == ##JSON.Errors.DeserializationError.InvalidUnicode;
}

function JSON_mErrors.DeserializationError.InvalidUnicode_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.InvalidUnicode_q(d) } JSON_mErrors.DeserializationError.InvalidUnicode_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.DeserializationError.InvalidUnicode);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.InvalidUnicode_q(d) } JSON_mErrors.DeserializationError.InvalidUnicode_q(d) ==> d == #JSON.Errors.DeserializationError.InvalidUnicode());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mErrors.DeserializationError()) ==> $IsAlloc(d, Tclass.JSON_mErrors.DeserializationError(), $h));

function $IsA#JSON_mErrors.DeserializationError(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mErrors.DeserializationError(d) } $IsA#JSON_mErrors.DeserializationError(d) ==> JSON_mErrors.DeserializationError.UnterminatedSequence_q(d) || JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) || JSON_mErrors.DeserializationError.EscapeAtEOS_q(d) || JSON_mErrors.DeserializationError.EmptyNumber_q(d) || JSON_mErrors.DeserializationError.ExpectingEOF_q(d) || JSON_mErrors.DeserializationError.IntOverflow_q(d) || JSON_mErrors.DeserializationError.ReachedEOF_q(d) || JSON_mErrors.DeserializationError.ExpectingByte_q(d) || JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) || JSON_mErrors.DeserializationError.InvalidUnicode_q(d));

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.InvalidUnicode_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.ExpectingByte_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.ReachedEOF_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.IntOverflow_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.ExpectingEOF_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.EmptyNumber_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.EscapeAtEOS_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.UnsupportedEscape_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } { JSON_mErrors.DeserializationError.UnterminatedSequence_q(d), $Is(d, Tclass.JSON_mErrors.DeserializationError()) } $Is(d, Tclass.JSON_mErrors.DeserializationError()) ==> JSON_mErrors.DeserializationError.UnterminatedSequence_q(d) || JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) || JSON_mErrors.DeserializationError.EscapeAtEOS_q(d) || JSON_mErrors.DeserializationError.EmptyNumber_q(d) || JSON_mErrors.DeserializationError.ExpectingEOF_q(d) || JSON_mErrors.DeserializationError.IntOverflow_q(d) || JSON_mErrors.DeserializationError.ReachedEOF_q(d) || JSON_mErrors.DeserializationError.ExpectingByte_q(d) || JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) || JSON_mErrors.DeserializationError.InvalidUnicode_q(d));

function JSON_mErrors.DeserializationError#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.UnterminatedSequence_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.UnterminatedSequence_q(b) } JSON_mErrors.DeserializationError.UnterminatedSequence_q(a) && JSON_mErrors.DeserializationError.UnterminatedSequence_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.UnsupportedEscape_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.UnsupportedEscape_q(b) } JSON_mErrors.DeserializationError.UnsupportedEscape_q(a) && JSON_mErrors.DeserializationError.UnsupportedEscape_q(b) ==> (JSON_mErrors.DeserializationError#Equal(a, b) <==> Seq#Equal(JSON_mErrors.DeserializationError.str(a), JSON_mErrors.DeserializationError.str(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.EscapeAtEOS_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.EscapeAtEOS_q(b) } JSON_mErrors.DeserializationError.EscapeAtEOS_q(a) && JSON_mErrors.DeserializationError.EscapeAtEOS_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.EmptyNumber_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.EmptyNumber_q(b) } JSON_mErrors.DeserializationError.EmptyNumber_q(a) && JSON_mErrors.DeserializationError.EmptyNumber_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ExpectingEOF_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ExpectingEOF_q(b) } JSON_mErrors.DeserializationError.ExpectingEOF_q(a) && JSON_mErrors.DeserializationError.ExpectingEOF_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.IntOverflow_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.IntOverflow_q(b) } JSON_mErrors.DeserializationError.IntOverflow_q(a) && JSON_mErrors.DeserializationError.IntOverflow_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ReachedEOF_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ReachedEOF_q(b) } JSON_mErrors.DeserializationError.ReachedEOF_q(a) && JSON_mErrors.DeserializationError.ReachedEOF_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ExpectingByte_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ExpectingByte_q(b) } JSON_mErrors.DeserializationError.ExpectingByte_q(a) && JSON_mErrors.DeserializationError.ExpectingByte_q(b) ==> (JSON_mErrors.DeserializationError#Equal(a, b) <==> JSON_mErrors.DeserializationError.expected(a) == JSON_mErrors.DeserializationError.expected(b) && JSON_mErrors.DeserializationError.b(a) == JSON_mErrors.DeserializationError.b(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ExpectingAnyByte_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.ExpectingAnyByte_q(b) } JSON_mErrors.DeserializationError.ExpectingAnyByte_q(a) && JSON_mErrors.DeserializationError.ExpectingAnyByte_q(b) ==> (JSON_mErrors.DeserializationError#Equal(a, b) <==> Seq#Equal(JSON_mErrors.DeserializationError.expected__sq(a), JSON_mErrors.DeserializationError.expected__sq(b)) && JSON_mErrors.DeserializationError.b(a) == JSON_mErrors.DeserializationError.b(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.InvalidUnicode_q(a) } { JSON_mErrors.DeserializationError#Equal(a, b), JSON_mErrors.DeserializationError.InvalidUnicode_q(b) } JSON_mErrors.DeserializationError.InvalidUnicode_q(a) && JSON_mErrors.DeserializationError.InvalidUnicode_q(b) ==> JSON_mErrors.DeserializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.DeserializationError#Equal(a, b) } JSON_mErrors.DeserializationError#Equal(a, b) <==> a == b);

const unique class.JSON_mErrors.DeserializationError: ClassName;

function JSON_mErrors.DeserializationError.ToString(this: DatatypeType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this) } JSON_mErrors.DeserializationError.ToString#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mErrors.DeserializationError())) ==> $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#0 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#0)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#0 := JSON_mErrors.DeserializationError.b(this); (var b0#0 := JSON_mErrors.DeserializationError.expected(this); (var c#0 := (if b#0 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#0)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#0)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#0)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#1 := JSON_mErrors.DeserializationError.b(this); (var bs0#0 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#1 := (if b#1 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#1)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#0 := Seq#Create(TChar, $Heap, Seq#Length(bs0#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#0, $Unbox($l#0#idx#0): int)): int))), (lambda $l#0#heap#0: Heap, $l#0#idx#0: Box :: $IsBox($l#0#idx#0, TInt) && LitInt(0) <= $Unbox($l#0#idx#0): int && $Unbox($l#0#idx#0): int < Seq#Length(bs0#0)), (lambda $l#0#heap#0: Heap, $l#0#idx#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#1))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#2 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#2)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#4 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#2 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#4 := (if b#4 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#4)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#2)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#4)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#5 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#2 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#5 := (if b#5 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#5)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#2 := Seq#Create(TChar, $Heap, Seq#Length(bs0#2), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#2, $Unbox($l#3#idx#0): int)): int))), (lambda $l#3#heap#0: Heap, $l#3#idx#0: Box :: $IsBox($l#3#idx#0, TInt) && LitInt(0) <= $Unbox($l#3#idx#0): int && $Unbox($l#3#idx#0): int < Seq#Length(bs0#2)), (lambda $l#3#heap#0: Heap, $l#3#idx#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#2), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#5))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));
}

function JSON_mErrors.DeserializationError.ToString#canCall(this: DatatypeType) : bool;

function JSON_mErrors.DeserializationError.ToString#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString#requires(this), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap) ==> (JSON_mErrors.DeserializationError.ToString#requires(this) <==> true));

procedure {:verboseName "JSON.Errors.DeserializationError.ToString (well-formedness)"} CheckWellformed$$JSON_mErrors.DeserializationError.ToString(this: DatatypeType where $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Errors.DeserializationError.ToString (well-formedness)"} CheckWellformed$$JSON_mErrors.DeserializationError.ToString(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#3#0: Seq;
  var _mcc#4#0: int;
  var b#Z#0: int;
  var let#0#0#0: int;
  var bs0#Z#0: Seq;
  var let#1#0#0: Seq;
  var c#Z#0: Seq;
  var let#2#0#0: Seq;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var c0s#Z#0: Seq;
  var let#3#0#0: Seq;
  var $lambdaHeap#0: Heap;
  var idx#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: char;
  var newtype$check#2: int;
  var _mcc#1#0: int;
  var _mcc#2#0: int;
  var b#Z#1: int;
  var let#4#0#0: int;
  var b0#Z#0: int;
  var let#5#0#0: int;
  var c#Z#1: Seq;
  var let#6#0#0: Seq;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var _mcc#0#0: Seq;
  var str#Z#0: Seq;
  var let#7#0#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Errors.DeserializationError.ToString", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Errors.dfy(24,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    assume false;
    return;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.UnterminatedSequence();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon30_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.UnterminatedSequence();
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.UnsupportedEscape(_mcc#0#0);
    assume $Is(_mcc#0#0, TSeq(TChar));
    havoc str#Z#0;
    assume $Is(str#Z#0, TSeq(TChar)) && $IsAlloc(str#Z#0, TSeq(TChar), $Heap);
    assume let#7#0#0 == _mcc#0#0;
    assume true;
    assume $Is(let#7#0#0, TSeq(TChar));
    assume str#Z#0 == let#7#0#0;
    assume JSON_mErrors.DeserializationError.ToString(this) == Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#Z#0);
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon31_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.UnsupportedEscape(_mcc#0#0);
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.EscapeAtEOS();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon32_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.EscapeAtEOS();
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.EmptyNumber();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon33_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.EmptyNumber();
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.ExpectingEOF();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon34_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.ExpectingEOF();
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.IntOverflow();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon35_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.IntOverflow();
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.ReachedEOF();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon36_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.ReachedEOF();
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.ExpectingByte(_mcc#1#0, _mcc#2#0);
    assume LitInt(0) <= _mcc#1#0 && _mcc#1#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume LitInt(-1) <= _mcc#2#0 && _mcc#2#0 < BoundedInts.__default.TWO__TO__THE__8();
    havoc b#Z#1;
    assume LitInt(-1) <= b#Z#1 && b#Z#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#4#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.BoundedInts.opt__byte());
    assume b#Z#1 == let#4#0#0;
    havoc b0#Z#0;
    assume LitInt(0) <= b0#Z#0 && b0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#5#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.BoundedInts.uint8());
    assume b0#Z#0 == let#5#0#0;
    havoc c#Z#1;
    assume $Is(c#Z#1, TSeq(TChar)) && $IsAlloc(c#Z#1, TSeq(TChar), $Heap);
    newtype$check#3 := LitInt(0);
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} b#Z#1 > 0;
    newtype$check#4 := b#Z#1;
    assume char#IsChar(newtype$check#4);
    assume let#6#0#0 == Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#Z#1)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))));
    assume true;
    assume $Is(let#6#0#0, TSeq(TChar));
    goto anon14;

  anon38_Else:
    assume {:partition} 0 >= b#Z#1;
    assume let#6#0#0 == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(let#6#0#0, TSeq(TChar));
    goto anon14;

  anon14:
    assume c#Z#1 == let#6#0#0;
    newtype$check#5 := b0#Z#0;
    assume char#IsChar(newtype$check#5);
    assume JSON_mErrors.DeserializationError.ToString(this) == Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#Z#0)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#Z#1);
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon37_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.ExpectingByte(_mcc#1#0, _mcc#2#0);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.ExpectingAnyByte(_mcc#3#0, _mcc#4#0);
    assume $Is(_mcc#3#0, TSeq(Tclass.BoundedInts.uint8()));
    assume LitInt(-1) <= _mcc#4#0 && _mcc#4#0 < BoundedInts.__default.TWO__TO__THE__8();
    havoc b#Z#0;
    assume LitInt(-1) <= b#Z#0 && b#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#0#0#0 == _mcc#4#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.opt__byte());
    assume b#Z#0 == let#0#0#0;
    havoc bs0#Z#0;
    assume $Is(bs0#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bs0#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume let#1#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume bs0#Z#0 == let#1#0#0;
    havoc c#Z#0;
    assume $Is(c#Z#0, TSeq(TChar)) && $IsAlloc(c#Z#0, TSeq(TChar), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} b#Z#0 > 0;
    newtype$check#1 := b#Z#0;
    assume char#IsChar(newtype$check#1);
    assume let#2#0#0 == Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#Z#0)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))));
    assume true;
    assume $Is(let#2#0#0, TSeq(TChar));
    goto anon18;

  anon40_Else:
    assume {:partition} 0 >= b#Z#0;
    assume let#2#0#0 == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))));
    assume true;
    assume $Is(let#2#0#0, TSeq(TChar));
    goto anon18;

  anon18:
    assume c#Z#0 == let#2#0#0;
    havoc c0s#Z#0;
    assume $Is(c0s#Z#0, TSeq(TChar)) && $IsAlloc(c0s#Z#0, TSeq(TChar), $Heap);
    assume 0 <= Seq#Length(bs0#Z#0);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc idx#0;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} LitInt(0) <= idx#0;
    goto anon22;

  anon43_Else:
    assume {:partition} idx#0 < LitInt(0);
    goto anon22;

  anon22:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} LitInt(0) <= idx#0 && idx#0 < Seq#Length(bs0#Z#0);
    assume 0 <= idx#0 && idx#0 < Seq#Length(bs0#Z#0);
    newtype$check#2 := $Unbox(Seq#Index(bs0#Z#0, idx#0)): int;
    assume char#IsChar(newtype$check#2);
    assume lambdaResult#0 == char#FromInt($Unbox(Seq#Index(bs0#Z#0, idx#0)): int);
    assume true;
    assume $Is(lambdaResult#0, TChar);
    goto anon24;

  anon44_Else:
    assume {:partition} !(LitInt(0) <= idx#0 && idx#0 < Seq#Length(bs0#Z#0));
    goto anon24;

  anon42_Else:
    assume {:partition} false;
    goto anon24;

  anon24:
    assume false;
    goto anon25;

  anon41_Else:
    goto anon25;

  anon25:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(bs0#Z#0) ==> Requires1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#Z#0, $Unbox($l#6#idx#0): int)): int))), (lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: $IsBox($l#6#idx#0, TInt) && LitInt(0) <= $Unbox($l#6#idx#0): int && $Unbox($l#6#idx#0): int < Seq#Length(bs0#Z#0)), (lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(bs0#Z#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, TChar, $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#Z#0, $Unbox($l#6#idx#0): int)): int))), (lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: $IsBox($l#6#idx#0, TInt) && LitInt(0) <= $Unbox($l#6#idx#0): int && $Unbox($l#6#idx#0): int < Seq#Length(bs0#Z#0)), (lambda $l#6#heap#0: Heap, $l#6#idx#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume let#3#0#0 == Seq#Create(TChar, $Heap, Seq#Length(bs0#Z#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#Z#0, $Unbox($l#8#idx#0): int)): int))), (lambda $l#8#heap#0: Heap, $l#8#idx#0: Box :: $IsBox($l#8#idx#0, TInt) && LitInt(0) <= $Unbox($l#8#idx#0): int && $Unbox($l#8#idx#0): int < Seq#Length(bs0#Z#0)), (lambda $l#8#heap#0: Heap, $l#8#idx#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume $Is(let#3#0#0, TSeq(TChar));
    assume c0s#Z#0 == let#3#0#0;
    assume JSON_mErrors.DeserializationError.ToString(this) == Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#Z#0), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#Z#0);
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon39_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.ExpectingAnyByte(_mcc#3#0, _mcc#4#0);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} this == #JSON.Errors.DeserializationError.InvalidUnicode();
    assume JSON_mErrors.DeserializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))));
    assume true;
    assume $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar));
    goto anon28;

  anon45_Else:
    assume {:partition} this != #JSON.Errors.DeserializationError.InvalidUnicode();
    assume false;
    goto anon28;

  anon28:
    assume b$reqreads#0;
    return;
}



function #JSON.Errors.SerializationError.OutOfMemory() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.SerializationError.OutOfMemory()) == ##JSON.Errors.SerializationError.OutOfMemory;
axiom $Is(#JSON.Errors.SerializationError.OutOfMemory(), Tclass.JSON_mErrors.SerializationError());
axiom #JSON.Errors.SerializationError.OutOfMemory() == Lit(#JSON.Errors.SerializationError.OutOfMemory());
}

const unique ##JSON.Errors.SerializationError.OutOfMemory: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.SerializationError.OutOfMemory()) == ##JSON.Errors.SerializationError.OutOfMemory;
}

function JSON_mErrors.SerializationError.OutOfMemory_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.OutOfMemory_q(d) } JSON_mErrors.SerializationError.OutOfMemory_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.SerializationError.OutOfMemory);

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.OutOfMemory_q(d) } JSON_mErrors.SerializationError.OutOfMemory_q(d) ==> d == #JSON.Errors.SerializationError.OutOfMemory());

function Tclass.JSON_mErrors.SerializationError() : Ty
uses {
axiom Tag(Tclass.JSON_mErrors.SerializationError()) == Tagclass.JSON_mErrors.SerializationError && TagFamily(Tclass.JSON_mErrors.SerializationError()) == tytagFamily$SerializationError;
}

const unique Tagclass.JSON_mErrors.SerializationError: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mErrors.SerializationError()) } $IsBox(bx, Tclass.JSON_mErrors.SerializationError()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mErrors.SerializationError()));

function #JSON.Errors.SerializationError.IntTooLarge(int) : DatatypeType;

const unique ##JSON.Errors.SerializationError.IntTooLarge: DtCtorId
uses {
axiom (forall a#4#0#0: int :: { #JSON.Errors.SerializationError.IntTooLarge(a#4#0#0) } DatatypeCtorId(#JSON.Errors.SerializationError.IntTooLarge(a#4#0#0)) == ##JSON.Errors.SerializationError.IntTooLarge);
}

function JSON_mErrors.SerializationError.IntTooLarge_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.IntTooLarge_q(d) } JSON_mErrors.SerializationError.IntTooLarge_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.SerializationError.IntTooLarge);

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.IntTooLarge_q(d) } JSON_mErrors.SerializationError.IntTooLarge_q(d) ==> (exists a#5#0#0: int :: d == #JSON.Errors.SerializationError.IntTooLarge(a#5#0#0)));

axiom (forall a#6#0#0: int :: { $Is(#JSON.Errors.SerializationError.IntTooLarge(a#6#0#0), Tclass.JSON_mErrors.SerializationError()) } $Is(#JSON.Errors.SerializationError.IntTooLarge(a#6#0#0), Tclass.JSON_mErrors.SerializationError()) <==> $Is(a#6#0#0, TInt));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.SerializationError.i(d), TInt, $h) } $IsGoodHeap($h) && JSON_mErrors.SerializationError.IntTooLarge_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.SerializationError(), $h) ==> $IsAlloc(JSON_mErrors.SerializationError.i(d), TInt, $h));

axiom (forall a#7#0#0: int :: { #JSON.Errors.SerializationError.IntTooLarge(LitInt(a#7#0#0)) } #JSON.Errors.SerializationError.IntTooLarge(LitInt(a#7#0#0)) == Lit(#JSON.Errors.SerializationError.IntTooLarge(a#7#0#0)));

function JSON_mErrors.SerializationError.i(DatatypeType) : int;

axiom (forall a#8#0#0: int :: { #JSON.Errors.SerializationError.IntTooLarge(a#8#0#0) } JSON_mErrors.SerializationError.i(#JSON.Errors.SerializationError.IntTooLarge(a#8#0#0)) == a#8#0#0);

function #JSON.Errors.SerializationError.StringTooLong(Seq) : DatatypeType;

const unique ##JSON.Errors.SerializationError.StringTooLong: DtCtorId
uses {
axiom (forall a#9#0#0: Seq :: { #JSON.Errors.SerializationError.StringTooLong(a#9#0#0) } DatatypeCtorId(#JSON.Errors.SerializationError.StringTooLong(a#9#0#0)) == ##JSON.Errors.SerializationError.StringTooLong);
}

function JSON_mErrors.SerializationError.StringTooLong_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.StringTooLong_q(d) } JSON_mErrors.SerializationError.StringTooLong_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.SerializationError.StringTooLong);

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.StringTooLong_q(d) } JSON_mErrors.SerializationError.StringTooLong_q(d) ==> (exists a#10#0#0: Seq :: d == #JSON.Errors.SerializationError.StringTooLong(a#10#0#0)));

axiom (forall a#11#0#0: Seq :: { $Is(#JSON.Errors.SerializationError.StringTooLong(a#11#0#0), Tclass.JSON_mErrors.SerializationError()) } $Is(#JSON.Errors.SerializationError.StringTooLong(a#11#0#0), Tclass.JSON_mErrors.SerializationError()) <==> $Is(a#11#0#0, TSeq(TChar)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mErrors.SerializationError.s(d), TSeq(TChar), $h) } $IsGoodHeap($h) && JSON_mErrors.SerializationError.StringTooLong_q(d) && $IsAlloc(d, Tclass.JSON_mErrors.SerializationError(), $h) ==> $IsAlloc(JSON_mErrors.SerializationError.s(d), TSeq(TChar), $h));

axiom (forall a#12#0#0: Seq :: { #JSON.Errors.SerializationError.StringTooLong(Lit(a#12#0#0)) } #JSON.Errors.SerializationError.StringTooLong(Lit(a#12#0#0)) == Lit(#JSON.Errors.SerializationError.StringTooLong(a#12#0#0)));

function JSON_mErrors.SerializationError.s(DatatypeType) : Seq;

axiom (forall a#13#0#0: Seq :: { #JSON.Errors.SerializationError.StringTooLong(a#13#0#0) } JSON_mErrors.SerializationError.s(#JSON.Errors.SerializationError.StringTooLong(a#13#0#0)) == a#13#0#0);

axiom (forall a#14#0#0: Seq, i: int :: { Seq#Index(a#14#0#0, i), #JSON.Errors.SerializationError.StringTooLong(a#14#0#0) } 0 <= i && i < Seq#Length(a#14#0#0) ==> DtRank($Unbox(Seq#Index(a#14#0#0, i)): DatatypeType) < DtRank(#JSON.Errors.SerializationError.StringTooLong(a#14#0#0)));

axiom (forall a#15#0#0: Seq :: { #JSON.Errors.SerializationError.StringTooLong(a#15#0#0) } Seq#Rank(a#15#0#0) < DtRank(#JSON.Errors.SerializationError.StringTooLong(a#15#0#0)));

function #JSON.Errors.SerializationError.InvalidUnicode() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Errors.SerializationError.InvalidUnicode()) == ##JSON.Errors.SerializationError.InvalidUnicode;
axiom $Is(#JSON.Errors.SerializationError.InvalidUnicode(), Tclass.JSON_mErrors.SerializationError());
axiom #JSON.Errors.SerializationError.InvalidUnicode() == Lit(#JSON.Errors.SerializationError.InvalidUnicode());
}

const unique ##JSON.Errors.SerializationError.InvalidUnicode: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Errors.SerializationError.InvalidUnicode()) == ##JSON.Errors.SerializationError.InvalidUnicode;
}

function JSON_mErrors.SerializationError.InvalidUnicode_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.InvalidUnicode_q(d) } JSON_mErrors.SerializationError.InvalidUnicode_q(d) <==> DatatypeCtorId(d) == ##JSON.Errors.SerializationError.InvalidUnicode);

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.InvalidUnicode_q(d) } JSON_mErrors.SerializationError.InvalidUnicode_q(d) ==> d == #JSON.Errors.SerializationError.InvalidUnicode());

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mErrors.SerializationError(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mErrors.SerializationError()) ==> $IsAlloc(d, Tclass.JSON_mErrors.SerializationError(), $h));

function $IsA#JSON_mErrors.SerializationError(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mErrors.SerializationError(d) } $IsA#JSON_mErrors.SerializationError(d) ==> JSON_mErrors.SerializationError.OutOfMemory_q(d) || JSON_mErrors.SerializationError.IntTooLarge_q(d) || JSON_mErrors.SerializationError.StringTooLong_q(d) || JSON_mErrors.SerializationError.InvalidUnicode_q(d));

axiom (forall d: DatatypeType :: { JSON_mErrors.SerializationError.InvalidUnicode_q(d), $Is(d, Tclass.JSON_mErrors.SerializationError()) } { JSON_mErrors.SerializationError.StringTooLong_q(d), $Is(d, Tclass.JSON_mErrors.SerializationError()) } { JSON_mErrors.SerializationError.IntTooLarge_q(d), $Is(d, Tclass.JSON_mErrors.SerializationError()) } { JSON_mErrors.SerializationError.OutOfMemory_q(d), $Is(d, Tclass.JSON_mErrors.SerializationError()) } $Is(d, Tclass.JSON_mErrors.SerializationError()) ==> JSON_mErrors.SerializationError.OutOfMemory_q(d) || JSON_mErrors.SerializationError.IntTooLarge_q(d) || JSON_mErrors.SerializationError.StringTooLong_q(d) || JSON_mErrors.SerializationError.InvalidUnicode_q(d));

function JSON_mErrors.SerializationError#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.OutOfMemory_q(a) } { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.OutOfMemory_q(b) } JSON_mErrors.SerializationError.OutOfMemory_q(a) && JSON_mErrors.SerializationError.OutOfMemory_q(b) ==> JSON_mErrors.SerializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.IntTooLarge_q(a) } { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.IntTooLarge_q(b) } JSON_mErrors.SerializationError.IntTooLarge_q(a) && JSON_mErrors.SerializationError.IntTooLarge_q(b) ==> (JSON_mErrors.SerializationError#Equal(a, b) <==> JSON_mErrors.SerializationError.i(a) == JSON_mErrors.SerializationError.i(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.StringTooLong_q(a) } { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.StringTooLong_q(b) } JSON_mErrors.SerializationError.StringTooLong_q(a) && JSON_mErrors.SerializationError.StringTooLong_q(b) ==> (JSON_mErrors.SerializationError#Equal(a, b) <==> Seq#Equal(JSON_mErrors.SerializationError.s(a), JSON_mErrors.SerializationError.s(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.InvalidUnicode_q(a) } { JSON_mErrors.SerializationError#Equal(a, b), JSON_mErrors.SerializationError.InvalidUnicode_q(b) } JSON_mErrors.SerializationError.InvalidUnicode_q(a) && JSON_mErrors.SerializationError.InvalidUnicode_q(b) ==> JSON_mErrors.SerializationError#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mErrors.SerializationError#Equal(a, b) } JSON_mErrors.SerializationError#Equal(a, b) <==> a == b);

const unique class.JSON_mErrors.SerializationError: ClassName;

function JSON_mErrors.SerializationError.ToString(this: DatatypeType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mErrors.SerializationError())) ==> $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar)));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mErrors.SerializationError())) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#1 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#1, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#0 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#0, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#0 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#0)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));
axiom 0 <= $FunctionContextHeight ==> (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || (0 < $FunctionContextHeight && $Is(this, Tclass.JSON_mErrors.SerializationError())) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#3 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#3, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#2 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#2, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#2 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#2)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));
}

function JSON_mErrors.SerializationError.ToString#canCall(this: DatatypeType) : bool;

function JSON_mErrors.SerializationError.ToString#requires(DatatypeType) : bool;

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString#requires(this) } $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (JSON_mErrors.SerializationError.ToString#requires(this) <==> true));

procedure {:verboseName "JSON.Errors.SerializationError.ToString (well-formedness)"} CheckWellformed$$JSON_mErrors.SerializationError.ToString(this: DatatypeType where $Is(this, Tclass.JSON_mErrors.SerializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.SerializationError(), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Errors.SerializationError.ToString (well-formedness)"} CheckWellformed$$JSON_mErrors.SerializationError.ToString(this: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#1#0: Seq;
  var s#Z#0: Seq;
  var let#0#0#0: Seq;
  var _mcc#0#0: int;
  var i#Z#0: int;
  var let#1#0#0: int;
  var ##n#0: int;
  var ##base#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Errors.SerializationError.ToString", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Errors.dfy(50,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} this == #JSON.Errors.SerializationError.OutOfMemory();
    assume JSON_mErrors.SerializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))));
    assume true;
    assume $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar));
    return;

  anon10_Else:
    assume {:partition} this != #JSON.Errors.SerializationError.OutOfMemory();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} this == #JSON.Errors.SerializationError.IntTooLarge(_mcc#0#0);
    havoc i#Z#0;
    assume true;
    assume let#1#0#0 == _mcc#0#0;
    assume true;
    assume $Is(let#1#0#0, TInt);
    assume i#Z#0 == let#1#0#0;
    ##n#0 := i#Z#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##base#0 := LitInt(10);
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#0;
    assume {:subsumption 0} ##base#0 <= LitInt(16);
    assume LitInt(2) <= ##base#0 && ##base#0 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(i#Z#0, LitInt(10));
    assume JSON_mErrors.SerializationError.ToString(this) == Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#Z#0, LitInt(10)));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(i#Z#0, LitInt(10));
    assume $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar));
    return;

  anon11_Else:
    assume {:partition} this != #JSON.Errors.SerializationError.IntTooLarge(_mcc#0#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} this == #JSON.Errors.SerializationError.StringTooLong(_mcc#1#0);
    assume $Is(_mcc#1#0, TSeq(TChar));
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    assume let#0#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#0#0#0, TSeq(TChar));
    assume s#Z#0 == let#0#0#0;
    assume JSON_mErrors.SerializationError.ToString(this) == Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#Z#0);
    assume true;
    assume $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar));
    return;

  anon12_Else:
    assume {:partition} this != #JSON.Errors.SerializationError.StringTooLong(_mcc#1#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} this == #JSON.Errors.SerializationError.InvalidUnicode();
    assume JSON_mErrors.SerializationError.ToString(this) == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))));
    assume true;
    assume $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar));
    return;

  anon13_Else:
    assume {:partition} this != #JSON.Errors.SerializationError.InvalidUnicode();
    assume false;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#180 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#180))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#182 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#182)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#270 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#270))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#272 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#272)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#274 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#274)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#270 := Wrappers.Option.value(this); v#270)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#272 := Lit(Wrappers.Option.value(Lit(this))); v#272)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#274 := Lit(Wrappers.Option.value(Lit(this))); v#274)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#180 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#180)) else (var e#180 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#182 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#182))) else (var e#182 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#270 := Wrappers.Result.value(this); s#270) else (var e#270 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#272 := Lit(Wrappers.Result.value(Lit(this))); s#272) else (var e#272 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#274 := Lit(Wrappers.Result.value(Lit(this))); s#274) else (var e#274 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#270 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#270)) else (var e#270 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#270)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#272 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#272))) else (var e#272 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#272)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#274 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#274))) else (var e#274 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#274)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#66: int, y#66: int :: { Mul(x#66, y#66) } Mul(x#66, y#66) == Mul(y#66, x#66)) && (forall x#67: int, y#67: int, z#44: int :: { Mul(x#67 + y#67, z#44) } Mul(x#67 + y#67, z#44) == Mul(x#67, z#44) + Mul(y#67, z#44)) && (forall x#68: int, y#68: int, z#45: int :: { Mul(x#68 - y#68, z#45) } Mul(x#68 - y#68, z#45) == Mul(x#68, z#45) - Mul(y#68, z#45));

axiom MulInternals.__default.MulAuto() <==> (forall x#69: int, y#69: int :: { Mul(x#69, y#69) } Mul(x#69, y#69) == Mul(y#69, x#69)) && (forall x#70: int, y#70: int, z#46: int :: { Mul(x#70 + y#70, z#46) } Mul(x#70 + y#70, z#46) == Mul(x#70, z#46) + Mul(y#70, z#46)) && (forall x#71: int, y#71: int, z#47: int :: { Mul(x#71 - y#71, z#47) } Mul(x#71 - y#71, z#47) == Mul(x#71, z#47) - Mul(y#71, z#47));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#72: int :: { Mod(Mod(x#72, n#0), n#0) } Mod(Mod(x#72, n#0), n#0) == Mod(x#72, n#0)) && (forall x#73: int :: { Mod(x#73, n#0) } LitInt(0) <= x#73 && x#73 < n#0 <==> Mod(x#73, n#0) == x#73) && (forall x#74: int, y#36: int :: { Mod(x#74 + y#36, n#0) } (var z#34 := Mod(x#74, n#0) + Mod(y#36, n#0); (LitInt(0) <= z#34 && z#34 < n#0 && Mod(x#74 + y#36, n#0) == z#34) || (n#0 <= z#34 && z#34 < n#0 + n#0 && Mod(x#74 + y#36, n#0) == z#34 - n#0))) && (forall x#75: int, y#37: int :: { Mod(x#75 - y#37, n#0) } (var z#35 := Mod(x#75, n#0) - Mod(y#37, n#0); (LitInt(0) <= z#35 && z#35 < n#0 && Mod(x#75 - y#37, n#0) == z#35) || (0 - n#0 <= z#35 && z#35 < 0 && Mod(x#75 - y#37, n#0) == z#35 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#76: int :: { Mod(Mod(x#76, n#0), n#0) } Mod(Mod(x#76, LitInt(n#0)), LitInt(n#0)) == Mod(x#76, LitInt(n#0))) && (forall x#77: int :: { Mod(x#77, n#0) } LitInt(0) <= x#77 && x#77 < n#0 <==> Mod(x#77, LitInt(n#0)) == x#77) && (forall x#78: int, y#38: int :: { Mod(x#78 + y#38, n#0) } (var z#36 := Mod(x#78, LitInt(n#0)) + Mod(y#38, LitInt(n#0)); (LitInt(0) <= z#36 && z#36 < n#0 && Mod(x#78 + y#38, LitInt(n#0)) == z#36) || (LitInt(n#0) <= z#36 && z#36 < n#0 + n#0 && Mod(x#78 + y#38, LitInt(n#0)) == z#36 - n#0))) && (forall x#79: int, y#39: int :: { Mod(x#79 - y#39, n#0) } (var z#37 := Mod(x#79, LitInt(n#0)) - Mod(y#39, LitInt(n#0)); (LitInt(0) <= z#37 && z#37 < n#0 && Mod(x#79 - y#39, LitInt(n#0)) == z#37) || (LitInt(0 - n#0) <= z#37 && z#37 < 0 && Mod(x#79 - y#39, LitInt(n#0)) == z#37 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#48: int :: { Div(x#48, n#0) } LitInt(0) <= x#48 && x#48 < n#0 <==> Div(x#48, n#0) == LitInt(0)) && (forall x#49: int, y#32: int :: { Div(x#49 + y#32, n#0) } (var z#30 := Mod(x#49, n#0) + Mod(y#32, n#0); (LitInt(0) <= z#30 && z#30 < n#0 && Div(x#49 + y#32, n#0) == Div(x#49, n#0) + Div(y#32, n#0)) || (n#0 <= z#30 && z#30 < n#0 + n#0 && Div(x#49 + y#32, n#0) == Div(x#49, n#0) + Div(y#32, n#0) + 1))) && (forall x#50: int, y#33: int :: { Div(x#50 - y#33, n#0) } (var z#31 := Mod(x#50, n#0) - Mod(y#33, n#0); (LitInt(0) <= z#31 && z#31 < n#0 && Div(x#50 - y#33, n#0) == Div(x#50, n#0) - Div(y#33, n#0)) || (0 - n#0 <= z#31 && z#31 < 0 && Div(x#50 - y#33, n#0) == Div(x#50, n#0) - Div(y#33, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#51: int :: { Div(x#51, n#0) } LitInt(0) <= x#51 && x#51 < n#0 <==> Div(x#51, LitInt(n#0)) == LitInt(0)) && (forall x#52: int, y#34: int :: { Div(x#52 + y#34, n#0) } (var z#32 := Mod(x#52, LitInt(n#0)) + Mod(y#34, LitInt(n#0)); (LitInt(0) <= z#32 && z#32 < n#0 && Div(x#52 + y#34, LitInt(n#0)) == Div(x#52, LitInt(n#0)) + Div(y#34, LitInt(n#0))) || (LitInt(n#0) <= z#32 && z#32 < n#0 + n#0 && Div(x#52 + y#34, LitInt(n#0)) == Div(x#52, LitInt(n#0)) + Div(y#34, LitInt(n#0)) + 1))) && (forall x#53: int, y#35: int :: { Div(x#53 - y#35, n#0) } (var z#33 := Mod(x#53, LitInt(n#0)) - Mod(y#35, LitInt(n#0)); (LitInt(0) <= z#33 && z#33 < n#0 && Div(x#53 - y#35, LitInt(n#0)) == Div(x#53, LitInt(n#0)) - Div(y#35, LitInt(n#0))) || (LitInt(0 - n#0) <= z#33 && z#33 < 0 && Div(x#53 - y#35, LitInt(n#0)) == Div(x#53, LitInt(n#0)) - Div(y#35, LitInt(n#0)) - 1)))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#4: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) ==> LitInt(0) <= d#4 && d#4 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#6 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#7 := Seq#Append(digits'#6, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#7))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#7 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#8 := Seq#Append(digits'#7, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#8))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#8 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#9 := Seq#Append(digits'#8, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#9))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#4: Box :: { Seq#Contains(chars#0, c#4) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#4) ==> Seq#Contains(chars#0, c#4)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#10: int :: { Seq#Contains(digits#0, $Box(d#10)) } Seq#Contains(digits#0, $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#4: Box :: { Seq#Contains(chars#0, c#4) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#4) } $IsBox(c#4, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#4) ==> Seq#Contains(chars#0, c#4)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#4 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#4) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#4 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#5 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#5) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#5 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#8: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#8)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#8) } $IsBox(c#8, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#8) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#8)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#9: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#9)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#9) } $IsBox(c#9, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#9) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#9)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#10: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#10)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#10) } $IsBox(c#10, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#10) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#10)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Seq#Contains(chars#0, $l#8#c#0))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#7: Box :: { Map#Domain(digits#0)[c#7] } { Seq#Contains(str#0, c#7) } $IsBox(c#7, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#7) ==> Map#Domain(digits#0)[c#7])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#7: Box :: { Map#Domain(digits#0)[c#7] } { Seq#Contains(str#0, c#7) } $IsBox(c#7, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#7) ==> Map#Domain(digits#0)[c#7])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#8: Box :: { Map#Domain(digits#0)[c#8] } { Seq#Contains(str#0, c#8) } $IsBox(c#8, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#8) ==> Map#Domain(digits#0)[c#8])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(digits#0)[$l#14#c#0])), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Map#Domain(digits#0)[$l#15#c#0])), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#6 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#6)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#6 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#6))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#6 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#6) else (var tl#12 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#12)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#6 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#6) else (var tl#13 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#13)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#7 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#7)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#7 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#7))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#7 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#7) else (var tl#14 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#14)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#7 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#7) else (var tl#15 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#15)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#8 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#8) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#8)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#8 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#8) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#8)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#8))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#8 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#8) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#8) else (var tl#16 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#8)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#16)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#8 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#8) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#8) else (var tl#17 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#8)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#17)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#4: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) ==> LitInt(0) <= d#4 && d#4 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#6 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#7 := Seq#Append(digits'#6, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#7))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#7 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#8 := Seq#Append(digits'#7, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#8))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#8 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#9 := Seq#Append(digits'#8, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#9))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#4: char :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#10: int :: { Seq#Contains(digits#0, $Box(d#10)) } Seq#Contains(digits#0, $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#4: char :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#4 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#4) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#4 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#5 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#5) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#5 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#8: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#8))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#8)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#8))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#9: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#9))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#9)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#9))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#10: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#10))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#10)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#10))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Seq#Contains(chars#0, $l#8#c#0))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar)), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#7: char :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#7: char :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#8: char :: { Map#Domain(digits#0)[$Box(c#8)] } { Seq#Contains(str#0, $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(str#0, $Box(c#8)) ==> Map#Domain(digits#0)[$Box(c#8)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(digits#0)[$l#14#c#0])), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, TChar)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Map#Domain(digits#0)[$l#15#c#0])), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#6 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#6)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#6 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#6) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#6)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#6))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#6 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#6) else (var tl#12 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#12)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#6 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#6) else (var tl#13 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#13)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#7 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#7)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#7 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#7) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#7)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#7))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#7 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#7) else (var tl#14 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#14)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#7 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#7) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#7) else (var tl#15 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#15)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#8 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#8) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#8)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#8)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#8 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#8) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#8)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#8))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#8 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#8) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#8) else (var tl#16 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#8)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#16)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#8 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#8) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#8) else (var tl#17 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#8)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#17)))))))));

axiom $Is(JSON_mUtils_mStr.__default.HEX__DIGITS(), TSeq(TChar));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mStr.__default.HEX__DIGITS(), TSeq(TChar), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mStr.__default.HEX__DIGITS(), TSeq(TChar), $h));

axiom $Is(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, TInt));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, TInt), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mStr.__default.HEX__TABLE(), TMap(TChar, TInt), $h));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#3: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#3)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#3)) } $Is(c#3, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#3)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#3))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0)) && JSON_mUtils_mStr.__default.OfNat(n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0)));

axiom (forall n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.OfNat(LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.OfNat#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0))) && JSON_mUtils_mStr.__default.OfNat(LitInt(n#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#6#c#0))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, TChar)), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45))) && JSON_mUtils_mStr.__default.OfInt(n#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), Lit(char#FromInt(45))));

axiom (forall n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0)), Lit(char#FromInt(45))) && JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(LitInt(n#0), Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), LitInt(base#0)), Lit(char#FromInt(45))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#0: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } $Is(c#0, TChar) && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#0)]): int < base#0)) ==> JSON_mUtils_mStr.__default.ToNat(str#0, base#0) < Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) && LitInt(0) <= JSON_mUtils_mStr.__default.ToNat(str#0, base#0));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#5: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#5: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#5)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#6: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#6)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#6)] } { Seq#Contains(str#0, $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(str#0, $Box(c#6)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#6)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#6)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#11#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#11#c#0]): int < base#0)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, TChar)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#11#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#11#c#0]): int < base#0)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, TChar)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#12#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#12#c#0]): int < base#0)), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar)), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq :: { JSON_mUtils_mStr.__default.EscapeQuotes(str#0) } JSON_mUtils_mStr.__default.EscapeQuotes#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> $Is(JSON_mUtils_mStr.__default.EscapeQuotes(str#0), TSeq(TChar)));

axiom (forall str#0: Seq :: { JSON_mUtils_mStr.__default.EscapeQuotes(str#0) } JSON_mUtils_mStr.__default.EscapeQuotes#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(str#0, Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.EscapeQuotes(str#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), str#0, Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92))));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.EscapeQuotes(Lit(str#0)) } JSON_mUtils_mStr.__default.EscapeQuotes#canCall(Lit(str#0)) || $Is(str#0, TSeq(TChar)) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Escape#canCall(Lit(str#0), Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.EscapeQuotes(Lit(str#0)) == Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Escape($LS($LZ), Lit(str#0), Lit(Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(Lit(char#FromInt(34)))), $Box(Lit(char#FromInt(39))))), Lit(char#FromInt(92)))));

axiom (forall str#0: Seq :: { JSON_mUtils_mStr.__default.UnescapeQuotes(str#0) } JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> $Is(JSON_mUtils_mStr.__default.UnescapeQuotes(str#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError())));

axiom (forall str#0: Seq :: { JSON_mUtils_mStr.__default.UnescapeQuotes(str#0) } JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.UnescapeQuotes(str#0) == JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), str#0, Lit(char#FromInt(92))));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.UnescapeQuotes(Lit(str#0)) } JSON_mUtils_mStr.__default.UnescapeQuotes#canCall(Lit(str#0)) || $Is(str#0, TSeq(TChar)) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(char#FromInt(92))) && JSON_mUtils_mStr.__default.UnescapeQuotes(Lit(str#0)) == Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($LZ), Lit(str#0), Lit(char#FromInt(92)))));

axiom (forall b#0: bool :: { JSON_mUtils_mStr.__default.OfBool(b#0) } $Is(JSON_mUtils_mStr.__default.OfBool(b#0), TSeq(TChar)));

axiom (forall b#0: bool :: { JSON_mUtils_mStr.__default.OfBool(b#0) } JSON_mUtils_mStr.__default.OfBool(b#0) == (if b#0 then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))));

axiom (forall b#0: bool :: {:weight 3} { JSON_mUtils_mStr.__default.OfBool(Lit(b#0)) } JSON_mUtils_mStr.__default.OfBool(Lit(b#0)) == (if b#0 then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))));

axiom (forall c#0: char :: { JSON_mUtils_mStr.__default.OfChar(c#0) } JSON_mUtils_mStr.__default.OfChar#canCall(c#0) || $Is(c#0, TChar) ==> $Is(JSON_mUtils_mStr.__default.OfChar(c#0), TSeq(TChar)));

axiom (forall c#0: char :: { JSON_mUtils_mStr.__default.OfChar(c#0) } JSON_mUtils_mStr.__default.OfChar#canCall(c#0) || $Is(c#0, TChar) ==> JSON_mUtils_mStr.__default.OfChar(c#0) == Seq#Build(Seq#Empty(): Seq, $Box(c#0)));

axiom (forall c#0: char :: {:weight 3} { JSON_mUtils_mStr.__default.OfChar(Lit(c#0)) } JSON_mUtils_mStr.__default.OfChar#canCall(Lit(c#0)) || $Is(c#0, TChar) ==> JSON_mUtils_mStr.__default.OfChar(Lit(c#0)) == Lit(Seq#Build(Seq#Empty(): Seq, $Box(Lit(c#0)))));

axiom (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join($ly, sep#0, strs#0) } JSON_mUtils_mStr.__default.Join#canCall(sep#0, strs#0) || ($Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar)))) ==> $Is(JSON_mUtils_mStr.__default.Join($ly, sep#0, strs#0), TSeq(TChar)));

axiom (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: { JSON_mUtils_mStr.__default.Join($LS($ly), sep#0, strs#0) } JSON_mUtils_mStr.__default.Join#canCall(sep#0, strs#0) || ($Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar)))) ==> (Seq#Length(strs#0) != LitInt(0) ==> Seq#Length(strs#0) != LitInt(1) ==> JSON_mUtils_mStr.__default.Join#canCall(sep#0, Seq#Drop(strs#0, LitInt(1)))) && JSON_mUtils_mStr.__default.Join($LS($ly), sep#0, strs#0) == (if Seq#Length(strs#0) == LitInt(0) then Seq#Empty(): Seq else (if Seq#Length(strs#0) == LitInt(1) then $Unbox(Seq#Index(strs#0, LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(strs#0, LitInt(0))): Seq, sep#0), JSON_mUtils_mStr.__default.Join($ly, sep#0, Seq#Drop(strs#0, LitInt(1)))))));

axiom (forall $ly: LayerType, sep#0: Seq, strs#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.Join($LS($ly), Lit(sep#0), Lit(strs#0)) } JSON_mUtils_mStr.__default.Join#canCall(Lit(sep#0), Lit(strs#0)) || ($Is(sep#0, TSeq(TChar)) && $Is(strs#0, TSeq(TSeq(TChar)))) ==> (Seq#Length(Lit(strs#0)) != LitInt(0) ==> Seq#Length(Lit(strs#0)) != LitInt(1) ==> JSON_mUtils_mStr.__default.Join#canCall(Lit(sep#0), Lit(Seq#Drop(Lit(strs#0), LitInt(1))))) && JSON_mUtils_mStr.__default.Join($LS($ly), Lit(sep#0), Lit(strs#0)) == (if Seq#Length(Lit(strs#0)) == LitInt(0) then Seq#Empty(): Seq else (if Seq#Length(Lit(strs#0)) == LitInt(1) then $Unbox(Seq#Index(Lit(strs#0), LitInt(0))): Seq else Seq#Append(Seq#Append($Unbox(Seq#Index(Lit(strs#0), LitInt(0))): Seq, sep#0), JSON_mUtils_mStr.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(strs#0), LitInt(1))))))));

axiom (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat($ly, strs#0) } JSON_mUtils_mStr.__default.Concat#canCall(strs#0) || $Is(strs#0, TSeq(TSeq(TChar))) ==> $Is(JSON_mUtils_mStr.__default.Concat($ly, strs#0), TSeq(TChar)));

axiom (forall $ly: LayerType, strs#0: Seq :: { JSON_mUtils_mStr.__default.Concat($LS($ly), strs#0) } JSON_mUtils_mStr.__default.Concat#canCall(strs#0) || $Is(strs#0, TSeq(TSeq(TChar))) ==> (Seq#Length(strs#0) != LitInt(0) ==> JSON_mUtils_mStr.__default.Concat#canCall(Seq#Drop(strs#0, LitInt(1)))) && JSON_mUtils_mStr.__default.Concat($LS($ly), strs#0) == (if Seq#Length(strs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(strs#0, LitInt(0))): Seq, JSON_mUtils_mStr.__default.Concat($ly, Seq#Drop(strs#0, LitInt(1))))));

axiom (forall $ly: LayerType, strs#0: Seq :: {:weight 3} { JSON_mUtils_mStr.__default.Concat($LS($ly), Lit(strs#0)) } JSON_mUtils_mStr.__default.Concat#canCall(Lit(strs#0)) || $Is(strs#0, TSeq(TSeq(TChar))) ==> (Seq#Length(Lit(strs#0)) != LitInt(0) ==> JSON_mUtils_mStr.__default.Concat#canCall(Lit(Seq#Drop(Lit(strs#0), LitInt(1))))) && JSON_mUtils_mStr.__default.Concat($LS($ly), Lit(strs#0)) == (if Seq#Length(Lit(strs#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Seq#Index(Lit(strs#0), LitInt(0))): Seq, JSON_mUtils_mStr.__default.Concat($LS($ly), Lit(Seq#Drop(Lit(strs#0), LitInt(1)))))));

const unique tytagFamily$DeserializationError: TyTagFamily;

const unique tytagFamily$SerializationError: TyTagFamily;

const unique class.JSON_mValues.__default: ClassName;

function JSON_mValues.__default.Int(n#0: int) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mValues.__default.Int(n#0) } JSON_mValues.__default.Int#canCall(n#0) || 1 < $FunctionContextHeight ==> $Is(JSON_mValues.__default.Int(n#0), Tclass.JSON_mValues.Decimal()));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mValues.__default.Int(n#0) } JSON_mValues.__default.Int#canCall(n#0) || 1 < $FunctionContextHeight ==> JSON_mValues.__default.Int(n#0) == #JSON.Values.Decimal.Decimal(n#0, LitInt(0)));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { JSON_mValues.__default.Int(LitInt(n#0)) } JSON_mValues.__default.Int#canCall(LitInt(n#0)) || 1 < $FunctionContextHeight ==> JSON_mValues.__default.Int(LitInt(n#0)) == Lit(#JSON.Values.Decimal.Decimal(LitInt(n#0), LitInt(0))));
}

function JSON_mValues.__default.Int#canCall(n#0: int) : bool;

function Tclass.JSON_mValues.Decimal() : Ty
uses {
axiom Tag(Tclass.JSON_mValues.Decimal()) == Tagclass.JSON_mValues.Decimal && TagFamily(Tclass.JSON_mValues.Decimal()) == tytagFamily$Decimal;
}

const unique Tagclass.JSON_mValues.Decimal: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mValues.Decimal()) } $IsBox(bx, Tclass.JSON_mValues.Decimal()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mValues.Decimal()));

function JSON_mValues.__default.Int#requires(int) : bool;

axiom (forall n#0: int :: { JSON_mValues.__default.Int#requires(n#0) } JSON_mValues.__default.Int#requires(n#0) <==> true);

procedure {:verboseName "JSON.Values.Int (well-formedness)"} CheckWellformed$$JSON_mValues.__default.Int(n#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function #JSON.Values.Decimal.Decimal(int, int) : DatatypeType;

const unique ##JSON.Values.Decimal.Decimal: DtCtorId
uses {
axiom (forall a#0#0#0: int, a#0#1#0: int :: { #JSON.Values.Decimal.Decimal(a#0#0#0, a#0#1#0) } DatatypeCtorId(#JSON.Values.Decimal.Decimal(a#0#0#0, a#0#1#0)) == ##JSON.Values.Decimal.Decimal);
}

function JSON_mValues.Decimal.Decimal_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.Decimal.Decimal_q(d) } JSON_mValues.Decimal.Decimal_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.Decimal.Decimal);

axiom (forall d: DatatypeType :: { JSON_mValues.Decimal.Decimal_q(d) } JSON_mValues.Decimal.Decimal_q(d) ==> (exists a#1#0#0: int, a#1#1#0: int :: d == #JSON.Values.Decimal.Decimal(a#1#0#0, a#1#1#0)));

axiom (forall a#2#0#0: int, a#2#1#0: int :: { $Is(#JSON.Values.Decimal.Decimal(a#2#0#0, a#2#1#0), Tclass.JSON_mValues.Decimal()) } $Is(#JSON.Values.Decimal.Decimal(a#2#0#0, a#2#1#0), Tclass.JSON_mValues.Decimal()) <==> $Is(a#2#0#0, TInt) && $Is(a#2#1#0, TInt));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.Decimal.n(d), TInt, $h) } $IsGoodHeap($h) && JSON_mValues.Decimal.Decimal_q(d) && $IsAlloc(d, Tclass.JSON_mValues.Decimal(), $h) ==> $IsAlloc(JSON_mValues.Decimal.n(d), TInt, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.Decimal.e10(d), TInt, $h) } $IsGoodHeap($h) && JSON_mValues.Decimal.Decimal_q(d) && $IsAlloc(d, Tclass.JSON_mValues.Decimal(), $h) ==> $IsAlloc(JSON_mValues.Decimal.e10(d), TInt, $h));

axiom (forall a#3#0#0: int, a#3#1#0: int :: { #JSON.Values.Decimal.Decimal(LitInt(a#3#0#0), LitInt(a#3#1#0)) } #JSON.Values.Decimal.Decimal(LitInt(a#3#0#0), LitInt(a#3#1#0)) == Lit(#JSON.Values.Decimal.Decimal(a#3#0#0, a#3#1#0)));

function JSON_mValues.Decimal.n(DatatypeType) : int;

axiom (forall a#4#0#0: int, a#4#1#0: int :: { #JSON.Values.Decimal.Decimal(a#4#0#0, a#4#1#0) } JSON_mValues.Decimal.n(#JSON.Values.Decimal.Decimal(a#4#0#0, a#4#1#0)) == a#4#0#0);

function JSON_mValues.Decimal.e10(DatatypeType) : int;

axiom (forall a#5#0#0: int, a#5#1#0: int :: { #JSON.Values.Decimal.Decimal(a#5#0#0, a#5#1#0) } JSON_mValues.Decimal.e10(#JSON.Values.Decimal.Decimal(a#5#0#0, a#5#1#0)) == a#5#1#0);

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mValues.Decimal(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mValues.Decimal()) ==> $IsAlloc(d, Tclass.JSON_mValues.Decimal(), $h));

function $IsA#JSON_mValues.Decimal(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mValues.Decimal(d) } $IsA#JSON_mValues.Decimal(d) ==> JSON_mValues.Decimal.Decimal_q(d));

axiom (forall d: DatatypeType :: { JSON_mValues.Decimal.Decimal_q(d), $Is(d, Tclass.JSON_mValues.Decimal()) } $Is(d, Tclass.JSON_mValues.Decimal()) ==> JSON_mValues.Decimal.Decimal_q(d));

function JSON_mValues.Decimal#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.Decimal#Equal(a, b) } JSON_mValues.Decimal#Equal(a, b) <==> JSON_mValues.Decimal.n(a) == JSON_mValues.Decimal.n(b) && JSON_mValues.Decimal.e10(a) == JSON_mValues.Decimal.e10(b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.Decimal#Equal(a, b) } JSON_mValues.Decimal#Equal(a, b) <==> a == b);

const unique class.JSON_mValues.Decimal: ClassName;

function #JSON.Values.JSON.Null() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Values.JSON.Null()) == ##JSON.Values.JSON.Null;
axiom $Is(#JSON.Values.JSON.Null(), Tclass.JSON_mValues.JSON());
axiom #JSON.Values.JSON.Null() == Lit(#JSON.Values.JSON.Null());
}

const unique ##JSON.Values.JSON.Null: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Values.JSON.Null()) == ##JSON.Values.JSON.Null;
}

function JSON_mValues.JSON.Null_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Null_q(d) } JSON_mValues.JSON.Null_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.JSON.Null);

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Null_q(d) } JSON_mValues.JSON.Null_q(d) ==> d == #JSON.Values.JSON.Null());

function Tclass.JSON_mValues.JSON() : Ty
uses {
axiom Tag(Tclass.JSON_mValues.JSON()) == Tagclass.JSON_mValues.JSON && TagFamily(Tclass.JSON_mValues.JSON()) == tytagFamily$JSON;
}

const unique Tagclass.JSON_mValues.JSON: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mValues.JSON()) } $IsBox(bx, Tclass.JSON_mValues.JSON()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mValues.JSON()));

function #JSON.Values.JSON.Bool(bool) : DatatypeType;

const unique ##JSON.Values.JSON.Bool: DtCtorId
uses {
axiom (forall a#10#0#0: bool :: { #JSON.Values.JSON.Bool(a#10#0#0) } DatatypeCtorId(#JSON.Values.JSON.Bool(a#10#0#0)) == ##JSON.Values.JSON.Bool);
}

function JSON_mValues.JSON.Bool_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Bool_q(d) } JSON_mValues.JSON.Bool_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.JSON.Bool);

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Bool_q(d) } JSON_mValues.JSON.Bool_q(d) ==> (exists a#11#0#0: bool :: d == #JSON.Values.JSON.Bool(a#11#0#0)));

axiom (forall a#12#0#0: bool :: { $Is(#JSON.Values.JSON.Bool(a#12#0#0), Tclass.JSON_mValues.JSON()) } $Is(#JSON.Values.JSON.Bool(a#12#0#0), Tclass.JSON_mValues.JSON()) <==> $Is(a#12#0#0, TBool));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.JSON.b(d), TBool, $h) } $IsGoodHeap($h) && JSON_mValues.JSON.Bool_q(d) && $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h) ==> $IsAlloc(JSON_mValues.JSON.b(d), TBool, $h));

axiom (forall a#13#0#0: bool :: { #JSON.Values.JSON.Bool(Lit(a#13#0#0)) } #JSON.Values.JSON.Bool(Lit(a#13#0#0)) == Lit(#JSON.Values.JSON.Bool(a#13#0#0)));

function JSON_mValues.JSON.b(DatatypeType) : bool;

axiom (forall a#14#0#0: bool :: { #JSON.Values.JSON.Bool(a#14#0#0) } JSON_mValues.JSON.b(#JSON.Values.JSON.Bool(a#14#0#0)) <==> a#14#0#0);

function #JSON.Values.JSON.String(Seq) : DatatypeType;

const unique ##JSON.Values.JSON.String: DtCtorId
uses {
axiom (forall a#15#0#0: Seq :: { #JSON.Values.JSON.String(a#15#0#0) } DatatypeCtorId(#JSON.Values.JSON.String(a#15#0#0)) == ##JSON.Values.JSON.String);
}

function JSON_mValues.JSON.String_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.String_q(d) } JSON_mValues.JSON.String_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.JSON.String);

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.String_q(d) } JSON_mValues.JSON.String_q(d) ==> (exists a#16#0#0: Seq :: d == #JSON.Values.JSON.String(a#16#0#0)));

axiom (forall a#17#0#0: Seq :: { $Is(#JSON.Values.JSON.String(a#17#0#0), Tclass.JSON_mValues.JSON()) } $Is(#JSON.Values.JSON.String(a#17#0#0), Tclass.JSON_mValues.JSON()) <==> $Is(a#17#0#0, TSeq(TChar)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.JSON.str(d), TSeq(TChar), $h) } $IsGoodHeap($h) && JSON_mValues.JSON.String_q(d) && $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h) ==> $IsAlloc(JSON_mValues.JSON.str(d), TSeq(TChar), $h));

axiom (forall a#18#0#0: Seq :: { #JSON.Values.JSON.String(Lit(a#18#0#0)) } #JSON.Values.JSON.String(Lit(a#18#0#0)) == Lit(#JSON.Values.JSON.String(a#18#0#0)));

function JSON_mValues.JSON.str(DatatypeType) : Seq;

axiom (forall a#19#0#0: Seq :: { #JSON.Values.JSON.String(a#19#0#0) } JSON_mValues.JSON.str(#JSON.Values.JSON.String(a#19#0#0)) == a#19#0#0);

axiom (forall a#20#0#0: Seq, i: int :: { Seq#Index(a#20#0#0, i), #JSON.Values.JSON.String(a#20#0#0) } 0 <= i && i < Seq#Length(a#20#0#0) ==> DtRank($Unbox(Seq#Index(a#20#0#0, i)): DatatypeType) < DtRank(#JSON.Values.JSON.String(a#20#0#0)));

axiom (forall a#21#0#0: Seq :: { #JSON.Values.JSON.String(a#21#0#0) } Seq#Rank(a#21#0#0) < DtRank(#JSON.Values.JSON.String(a#21#0#0)));

function #JSON.Values.JSON.Number(DatatypeType) : DatatypeType;

const unique ##JSON.Values.JSON.Number: DtCtorId
uses {
axiom (forall a#22#0#0: DatatypeType :: { #JSON.Values.JSON.Number(a#22#0#0) } DatatypeCtorId(#JSON.Values.JSON.Number(a#22#0#0)) == ##JSON.Values.JSON.Number);
}

function JSON_mValues.JSON.Number_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Number_q(d) } JSON_mValues.JSON.Number_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.JSON.Number);

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Number_q(d) } JSON_mValues.JSON.Number_q(d) ==> (exists a#23#0#0: DatatypeType :: d == #JSON.Values.JSON.Number(a#23#0#0)));

axiom (forall a#24#0#0: DatatypeType :: { $Is(#JSON.Values.JSON.Number(a#24#0#0), Tclass.JSON_mValues.JSON()) } $Is(#JSON.Values.JSON.Number(a#24#0#0), Tclass.JSON_mValues.JSON()) <==> $Is(a#24#0#0, Tclass.JSON_mValues.Decimal()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.JSON.num(d), Tclass.JSON_mValues.Decimal(), $h) } $IsGoodHeap($h) && JSON_mValues.JSON.Number_q(d) && $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h) ==> $IsAlloc(JSON_mValues.JSON.num(d), Tclass.JSON_mValues.Decimal(), $h));

axiom (forall a#25#0#0: DatatypeType :: { #JSON.Values.JSON.Number(Lit(a#25#0#0)) } #JSON.Values.JSON.Number(Lit(a#25#0#0)) == Lit(#JSON.Values.JSON.Number(a#25#0#0)));

function JSON_mValues.JSON.num(DatatypeType) : DatatypeType;

axiom (forall a#26#0#0: DatatypeType :: { #JSON.Values.JSON.Number(a#26#0#0) } JSON_mValues.JSON.num(#JSON.Values.JSON.Number(a#26#0#0)) == a#26#0#0);

axiom (forall a#27#0#0: DatatypeType :: { #JSON.Values.JSON.Number(a#27#0#0) } DtRank(a#27#0#0) < DtRank(#JSON.Values.JSON.Number(a#27#0#0)));

function #JSON.Values.JSON.Object(Seq) : DatatypeType;

const unique ##JSON.Values.JSON.Object: DtCtorId
uses {
axiom (forall a#28#0#0: Seq :: { #JSON.Values.JSON.Object(a#28#0#0) } DatatypeCtorId(#JSON.Values.JSON.Object(a#28#0#0)) == ##JSON.Values.JSON.Object);
}

function JSON_mValues.JSON.Object_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Object_q(d) } JSON_mValues.JSON.Object_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.JSON.Object);

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Object_q(d) } JSON_mValues.JSON.Object_q(d) ==> (exists a#29#0#0: Seq :: d == #JSON.Values.JSON.Object(a#29#0#0)));

axiom (forall a#30#0#0: Seq :: { $Is(#JSON.Values.JSON.Object(a#30#0#0), Tclass.JSON_mValues.JSON()) } $Is(#JSON.Values.JSON.Object(a#30#0#0), Tclass.JSON_mValues.JSON()) <==> $Is(a#30#0#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.JSON.obj(d), TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $h) } $IsGoodHeap($h) && JSON_mValues.JSON.Object_q(d) && $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h) ==> $IsAlloc(JSON_mValues.JSON.obj(d), TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $h));

axiom (forall a#31#0#0: Seq :: { #JSON.Values.JSON.Object(Lit(a#31#0#0)) } #JSON.Values.JSON.Object(Lit(a#31#0#0)) == Lit(#JSON.Values.JSON.Object(a#31#0#0)));

function JSON_mValues.JSON.obj(DatatypeType) : Seq;

axiom (forall a#32#0#0: Seq :: { #JSON.Values.JSON.Object(a#32#0#0) } JSON_mValues.JSON.obj(#JSON.Values.JSON.Object(a#32#0#0)) == a#32#0#0);

axiom (forall a#33#0#0: Seq, i: int :: { Seq#Index(a#33#0#0, i), #JSON.Values.JSON.Object(a#33#0#0) } 0 <= i && i < Seq#Length(a#33#0#0) ==> DtRank($Unbox(Seq#Index(a#33#0#0, i)): DatatypeType) < DtRank(#JSON.Values.JSON.Object(a#33#0#0)));

axiom (forall a#34#0#0: Seq :: { #JSON.Values.JSON.Object(a#34#0#0) } Seq#Rank(a#34#0#0) < DtRank(#JSON.Values.JSON.Object(a#34#0#0)));

function #JSON.Values.JSON.Array(Seq) : DatatypeType;

const unique ##JSON.Values.JSON.Array: DtCtorId
uses {
axiom (forall a#35#0#0: Seq :: { #JSON.Values.JSON.Array(a#35#0#0) } DatatypeCtorId(#JSON.Values.JSON.Array(a#35#0#0)) == ##JSON.Values.JSON.Array);
}

function JSON_mValues.JSON.Array_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Array_q(d) } JSON_mValues.JSON.Array_q(d) <==> DatatypeCtorId(d) == ##JSON.Values.JSON.Array);

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Array_q(d) } JSON_mValues.JSON.Array_q(d) ==> (exists a#36#0#0: Seq :: d == #JSON.Values.JSON.Array(a#36#0#0)));

axiom (forall a#37#0#0: Seq :: { $Is(#JSON.Values.JSON.Array(a#37#0#0), Tclass.JSON_mValues.JSON()) } $Is(#JSON.Values.JSON.Array(a#37#0#0), Tclass.JSON_mValues.JSON()) <==> $Is(a#37#0#0, TSeq(Tclass.JSON_mValues.JSON())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mValues.JSON.arr(d), TSeq(Tclass.JSON_mValues.JSON()), $h) } $IsGoodHeap($h) && JSON_mValues.JSON.Array_q(d) && $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h) ==> $IsAlloc(JSON_mValues.JSON.arr(d), TSeq(Tclass.JSON_mValues.JSON()), $h));

axiom (forall a#38#0#0: Seq :: { #JSON.Values.JSON.Array(Lit(a#38#0#0)) } #JSON.Values.JSON.Array(Lit(a#38#0#0)) == Lit(#JSON.Values.JSON.Array(a#38#0#0)));

function JSON_mValues.JSON.arr(DatatypeType) : Seq;

axiom (forall a#39#0#0: Seq :: { #JSON.Values.JSON.Array(a#39#0#0) } JSON_mValues.JSON.arr(#JSON.Values.JSON.Array(a#39#0#0)) == a#39#0#0);

axiom (forall a#40#0#0: Seq, i: int :: { Seq#Index(a#40#0#0, i), #JSON.Values.JSON.Array(a#40#0#0) } 0 <= i && i < Seq#Length(a#40#0#0) ==> DtRank($Unbox(Seq#Index(a#40#0#0, i)): DatatypeType) < DtRank(#JSON.Values.JSON.Array(a#40#0#0)));

axiom (forall a#41#0#0: Seq :: { #JSON.Values.JSON.Array(a#41#0#0) } Seq#Rank(a#41#0#0) < DtRank(#JSON.Values.JSON.Array(a#41#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mValues.JSON()) ==> $IsAlloc(d, Tclass.JSON_mValues.JSON(), $h));

function $IsA#JSON_mValues.JSON(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mValues.JSON(d) } $IsA#JSON_mValues.JSON(d) ==> JSON_mValues.JSON.Null_q(d) || JSON_mValues.JSON.Bool_q(d) || JSON_mValues.JSON.String_q(d) || JSON_mValues.JSON.Number_q(d) || JSON_mValues.JSON.Object_q(d) || JSON_mValues.JSON.Array_q(d));

axiom (forall d: DatatypeType :: { JSON_mValues.JSON.Array_q(d), $Is(d, Tclass.JSON_mValues.JSON()) } { JSON_mValues.JSON.Object_q(d), $Is(d, Tclass.JSON_mValues.JSON()) } { JSON_mValues.JSON.Number_q(d), $Is(d, Tclass.JSON_mValues.JSON()) } { JSON_mValues.JSON.String_q(d), $Is(d, Tclass.JSON_mValues.JSON()) } { JSON_mValues.JSON.Bool_q(d), $Is(d, Tclass.JSON_mValues.JSON()) } { JSON_mValues.JSON.Null_q(d), $Is(d, Tclass.JSON_mValues.JSON()) } $Is(d, Tclass.JSON_mValues.JSON()) ==> JSON_mValues.JSON.Null_q(d) || JSON_mValues.JSON.Bool_q(d) || JSON_mValues.JSON.String_q(d) || JSON_mValues.JSON.Number_q(d) || JSON_mValues.JSON.Object_q(d) || JSON_mValues.JSON.Array_q(d));

function JSON_mValues.JSON#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Null_q(a) } { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Null_q(b) } JSON_mValues.JSON.Null_q(a) && JSON_mValues.JSON.Null_q(b) ==> JSON_mValues.JSON#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Bool_q(a) } { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Bool_q(b) } JSON_mValues.JSON.Bool_q(a) && JSON_mValues.JSON.Bool_q(b) ==> (JSON_mValues.JSON#Equal(a, b) <==> JSON_mValues.JSON.b(a) <==> JSON_mValues.JSON.b(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.String_q(a) } { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.String_q(b) } JSON_mValues.JSON.String_q(a) && JSON_mValues.JSON.String_q(b) ==> (JSON_mValues.JSON#Equal(a, b) <==> Seq#Equal(JSON_mValues.JSON.str(a), JSON_mValues.JSON.str(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Number_q(a) } { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Number_q(b) } JSON_mValues.JSON.Number_q(a) && JSON_mValues.JSON.Number_q(b) ==> (JSON_mValues.JSON#Equal(a, b) <==> JSON_mValues.Decimal#Equal(JSON_mValues.JSON.num(a), JSON_mValues.JSON.num(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Object_q(a) } { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Object_q(b) } JSON_mValues.JSON.Object_q(a) && JSON_mValues.JSON.Object_q(b) ==> (JSON_mValues.JSON#Equal(a, b) <==> Seq#Equal(JSON_mValues.JSON.obj(a), JSON_mValues.JSON.obj(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Array_q(a) } { JSON_mValues.JSON#Equal(a, b), JSON_mValues.JSON.Array_q(b) } JSON_mValues.JSON.Array_q(a) && JSON_mValues.JSON.Array_q(b) ==> (JSON_mValues.JSON#Equal(a, b) <==> Seq#Equal(JSON_mValues.JSON.arr(a), JSON_mValues.JSON.arr(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mValues.JSON#Equal(a, b) } JSON_mValues.JSON#Equal(a, b) <==> a == b);

const unique class.JSON_mValues.JSON: ClassName;

const unique tytagFamily$Decimal: TyTagFamily;

const unique tytagFamily$JSON: TyTagFamily;

const unique class.JSON_mSpec.__default: ClassName;

function JSON_mSpec.__default.EscapeUnicode(c#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall c#0: int :: { JSON_mSpec.__default.EscapeUnicode(c#0) } JSON_mSpec.__default.EscapeUnicode#canCall(c#0) || (0 < $FunctionContextHeight && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> $Is(JSON_mSpec.__default.EscapeUnicode(c#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, c#0: int :: { JSON_mSpec.__default.EscapeUnicode(c#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(c#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(c#0, LitInt(16)) && (var sStr#0 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#0)) && JSON_mSpec.__default.EscapeUnicode(c#0) == (var sStr#0 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); (var s#0 := UnicodeStrings.__default.ASCIIToUTF16(sStr#0); Seq#Append(s#0, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: $IsBox($l#0#_v0#0, TInt)), (lambda $l#0#heap#0: Heap, $l#0#_v0#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, c#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(LitInt(c#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(LitInt(c#0), LitInt(16)) && (var sStr#1 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#1)) && JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)) == (var sStr#1 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); (var s#1 := Lit(UnicodeStrings.__default.ASCIIToUTF16(sStr#1)); Seq#Append(s#1, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#1), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#2#heap#0: Heap, $l#2#_v0#0: Box :: $IsBox($l#2#_v0#0, TInt)), (lambda $l#2#heap#0: Heap, $l#2#_v0#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))))));
}

function JSON_mSpec.__default.EscapeUnicode#canCall(c#0: int) : bool;

function JSON_mSpec.__default.EscapeUnicode#requires(int) : bool;

axiom (forall $Heap: Heap, c#0: int :: { JSON_mSpec.__default.EscapeUnicode#requires(c#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() ==> (JSON_mSpec.__default.EscapeUnicode#requires(c#0) <==> true));

procedure {:verboseName "JSON.Spec.EscapeUnicode (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.EscapeUnicode(c#0: int where LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.EscapeUnicode (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.EscapeUnicode(c#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var sStr#Z#0: Seq;
  var let#0#0#0: Seq;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##n#0: int;
  var ##base#0: int;
  var p##0: HandleType;
  var $lambdaHeap#0: Heap;
  var c#1: char;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var xs##0: Seq;
  var s#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##s#0: Seq;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var newtype$check#0_3: int;
  var ##base#0_0: int;
  var ##pow#0_0: int;
  var ##base#0_1: int;
  var ##pow#0_1: int;
  var base##0_0_0: int;
  var pow##0_0_0: int;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var pow'##0_0_0: int;
  var ##base#0_2: int;
  var ##pow#0_2: int;
  var $lambdaHeap#1: Heap;
  var _v0#0: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.EscapeUnicode", " | ", c#0} true;
    assume {:print "Types", " | ", "int"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(37,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume $Is(JSON_mSpec.__default.EscapeUnicode(c#0), TSeq(Tclass.BoundedInts.uint16()));
    assume false;
    return;

  anon20_Else:
    havoc sStr#Z#0;
    assume $Is(sStr#Z#0, TSeq(TChar)) && $IsAlloc(sStr#Z#0, TSeq(TChar), $Heap);
    newtype$check#0 := c#0;
    assume LitInt(0) <= newtype$check#0;
    newtype$check#1 := c#0;
    assume LitInt(0) <= newtype$check#1;
    ##n#0 := c#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#0 := LitInt(16);
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#0;
    assume {:subsumption 0} ##base#0 <= LitInt(16);
    assume LitInt(2) <= ##base#0 && ##base#0 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfNat#canCall(c#0, LitInt(16));
    assume let#0#0#0 == JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16));
    assume JSON_mUtils_mStr.__default.OfNat#canCall(c#0, LitInt(16));
    assume $Is(let#0#0#0, TSeq(TChar));
    assume sStr#Z#0 == let#0#0#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#1;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} $Is(c#1, TChar);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} LitInt(0) <= char#ToInt(c#1);
    goto anon7;

  anon23_Else:
    assume {:partition} char#ToInt(c#1) < LitInt(0);
    goto anon7;

  anon7:
    assume lambdaResult#0 <==> LitInt(0) <= char#ToInt(c#1) && char#ToInt(c#1) < 128;
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon8;

  anon22_Else:
    assume {:partition} !$Is(c#1, TChar);
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon21_Else:
    goto anon9;

  anon9:
    assume true;
    p##0 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(LitInt(0) <= char#ToInt($Unbox($l#5#c#0): char) && char#ToInt($Unbox($l#5#c#0): char) < 128)), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, TChar)), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume true;
    xs##0 := sStr#Z#0;
    call CallPre$$Seq.__default.MembershipImpliesIndexing(TChar, p##0, xs##0);
    call CallPost$$Seq.__default.MembershipImpliesIndexing(TChar, p##0, xs##0);
    assume {:captureState "libraries/src/JSON/Spec.dfy(39,64)"} true;
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(s#Z#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##s#0 := sStr#Z#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#Z#0);
    assume let#1#0#0 == UnicodeStrings.__default.ASCIIToUTF16(sStr#Z#0);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint16()));
    assume s#Z#0 == let#1#0#0;
    assume true;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    newtype$check#0_0 := c#0;
    assume LitInt(0) <= newtype$check#0_0;
    newtype$check#0_1 := c#0;
    assume LitInt(0) <= newtype$check#0_1;
    assume true;
    assume c#0 <= LitInt(65535);
    assume {:captureState "libraries/src/JSON/Spec.dfy(42,31)"} true;
    newtype$check#0_2 := c#0;
    assume LitInt(0) <= newtype$check#0_2;
    newtype$check#0_3 := c#0;
    assume LitInt(0) <= newtype$check#0_3;
    assume $Is(LitInt(16), Tclass._System.nat());
    ##base#0_0 := LitInt(16);
    assume $IsAlloc(##base#0_0, Tclass._System.nat(), $Heap);
    ##pow#0_0 := c#0;
    assume $IsAlloc(##pow#0_0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_0 > 1;
    assume Logarithm.__default.Log#canCall(LitInt(16), c#0);
    assume $Is(LitInt(16), Tclass._System.nat());
    ##base#0_1 := LitInt(16);
    assume $IsAlloc(##base#0_1, Tclass._System.nat(), $Heap);
    assume $Is(LitInt(65535), Tclass._System.nat());
    ##pow#0_1 := LitInt(65535);
    assume $IsAlloc(##pow#0_1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_1 > 1;
    assume Logarithm.__default.Log#canCall(LitInt(16), LitInt(65535));
    assume Logarithm.__default.Log#canCall(LitInt(16), c#0) && Logarithm.__default.Log#canCall(LitInt(16), LitInt(65535));
    goto anon25_Then, anon25_Else;

  anon25_Then:
    push;
    assume true;
    assume $Is(LitInt(16), Tclass._System.nat());
    base##0_0_0 := LitInt(16);
    newtype$check#0_0_0 := c#0;
    assume LitInt(0) <= newtype$check#0_0_0;
    newtype$check#0_0_1 := c#0;
    assume LitInt(0) <= newtype$check#0_0_1;
    assume true;
    pow##0_0_0 := c#0;
    assume true;
    assume $Is(LitInt(65535), Tclass._System.nat());
    pow'##0_0_0 := LitInt(65535);
    call CallPre$$Logarithm.__default.LemmaLogIsOrdered(base##0_0_0, pow##0_0_0, pow'##0_0_0);
    call CallPost$$Logarithm.__default.LemmaLogIsOrdered(base##0_0_0, pow##0_0_0, pow'##0_0_0);
    assume {:captureState "libraries/src/JSON/Spec.dfy(44,47)"} true;
    pop;
    assume {:subsumption 0} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, LitInt(16), c#0) <= Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, LitInt(16), LitInt(65535));
    assume false;
    goto anon12;

  anon25_Else:
    goto anon12;

  anon12:
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, LitInt(16), c#0) <= Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, LitInt(16), LitInt(65535));
    assume {:captureState "libraries/src/JSON/Spec.dfy(45,6)"} true;
    assume $Is(LitInt(16), Tclass._System.nat());
    ##base#0_2 := LitInt(16);
    assume $IsAlloc(##base#0_2, Tclass._System.nat(), $Heap);
    assume $Is(LitInt(65535), Tclass._System.nat());
    ##pow#0_2 := LitInt(65535);
    assume $IsAlloc(##pow#0_2, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0_2 > 1;
    assume Logarithm.__default.Log#canCall(LitInt(16), LitInt(65535));
    assume Logarithm.__default.Log#canCall(LitInt(16), LitInt(65535));
    goto anon26_Then, anon26_Else;

  anon26_Then:
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/JSON/Spec.dfy(46,50)"} true;
    assume {:subsumption 0} Logarithm.__default.Log($LS($LS($LZ)), reveal_Logarithm._default.Log, LitInt(16), LitInt(65535)) == LitInt(3);
    assume false;
    goto anon14;

  anon26_Else:
    goto anon14;

  anon14:
    assume Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, LitInt(16), LitInt(65535)) == LitInt(3);
    assume {:captureState "libraries/src/JSON/Spec.dfy(46,53)"} true;
    assume Seq#Length(s#Z#0) <= LitInt(4);
    assume false;
    goto anon15;

  anon24_Else:
    goto anon15;

  anon15:
    assume Seq#Length(s#Z#0) <= LitInt(4);
    assume {:captureState "libraries/src/JSON/Spec.dfy(47,4)"} true;
    assume 0 <= 4 - Seq#Length(s#Z#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc _v0#0;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} true;
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#2 := char#ToInt(Lit(char#FromInt(32)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(32)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__16();
    assume lambdaResult#1 == char#ToInt(Lit(char#FromInt(32)));
    assume true;
    assume $Is(lambdaResult#1, Tclass.BoundedInts.uint16());
    goto anon18;

  anon28_Else:
    assume {:partition} false;
    goto anon18;

  anon18:
    assume false;
    goto anon19;

  anon27_Else:
    goto anon19;

  anon19:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < 4 - Seq#Length(s#Z#0) ==> Requires1(TInt, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: $IsBox($l#6#_v0#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < 4 - Seq#Length(s#Z#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: $IsBox($l#6#_v0#0, TInt)), (lambda $l#6#heap#0: Heap, $l#6#_v0#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    assume JSON_mSpec.__default.EscapeUnicode(c#0) == Seq#Append(s#Z#0, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#Z#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#8#heap#0: Heap, $l#8#_v0#0: Box :: $IsBox($l#8#_v0#0, TInt)), (lambda $l#8#heap#0: Heap, $l#8#_v0#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))));
    assume true;
    assume $Is(JSON_mSpec.__default.EscapeUnicode(c#0), TSeq(Tclass.BoundedInts.uint16()));
    assume b$reqreads#0;
    return;
}



function JSON_mSpec.__default.Escape($ly: LayerType, str#0: Seq, start#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($ly, str#0, start#0) } JSON_mSpec.__default.Escape#canCall(str#0, start#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> $Is(JSON_mSpec.__default.Escape($ly, str#0, start#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) } JSON_mSpec.__default.Escape#canCall(str#0, start#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(str#0) > start#0 ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(34) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(92) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(8) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(12) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(10) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(13) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(9) ==> (var c#0 := $Unbox(Seq#Index(str#0, start#0)): int; c#0 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#0))))))))) && JSON_mSpec.__default.Escape#canCall(str#0, start#0 + 1)) && JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) == (if start#0 >= Seq#Length(str#0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#0 := $Unbox(Seq#Index(str#0, start#0)): int; (if c#0 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#0)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))))))))))), JSON_mSpec.__default.Escape($ly, str#0, start#0 + 1))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(34) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(92) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(8) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(12) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(10) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(13) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(9) ==> (var c#1 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; c#1 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#1))))))))) && JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0 + 1))) && JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#1 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; (if c#1 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#1)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0)))))))))))), JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0 + 1)))));
}

function JSON_mSpec.__default.Escape#canCall(str#0: Seq, start#0: int) : bool;

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) } JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) == JSON_mSpec.__default.Escape($ly, str#0, start#0));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape(AsFuelBottom($ly), str#0, start#0) } JSON_mSpec.__default.Escape($ly, str#0, start#0) == JSON_mSpec.__default.Escape($LZ, str#0, start#0));

function JSON_mSpec.__default.Escape#requires(LayerType, Seq, int) : bool;

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape#requires($ly, str#0, start#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 ==> (JSON_mSpec.__default.Escape#requires($ly, str#0, start#0) <==> true));

procedure {:verboseName "JSON.Spec.Escape (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Escape(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())), start#0: int where LitInt(0) <= start#0);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.Escape (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Escape(str#0: Seq, start#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##s#0: Seq;
  var newtype$check#1: int;
  var ##s#1: Seq;
  var newtype$check#2: int;
  var ##s#2: Seq;
  var newtype$check#3: int;
  var ##s#3: Seq;
  var newtype$check#4: int;
  var ##s#4: Seq;
  var newtype$check#5: int;
  var ##s#5: Seq;
  var newtype$check#6: int;
  var ##s#6: Seq;
  var c#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#7: int;
  var ##s#7: Seq;
  var ##c#0: int;
  var ##str#0: Seq;
  var ##start#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.Escape", " | ", str#0, " | ", start#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(51,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume $Is(JSON_mSpec.__default.Escape($LS($LZ), str#0, start#0), TSeq(Tclass.BoundedInts.uint16()));
    assume false;
    return;

  anon23_Else:
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} start#0 >= Seq#Length(str#0);
    assume JSON_mSpec.__default.Escape($LS($LZ), str#0, start#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mSpec.__default.Escape($LS($LZ), str#0, start#0), TSeq(Tclass.BoundedInts.uint16()));
    return;

  anon24_Else:
    assume {:partition} Seq#Length(str#0) > start#0;
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#0 := LitInt(34);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(34);
    ##s#0 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))));
    goto anon22;

  anon25_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(34);
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#1 := LitInt(92);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(92);
    ##s#1 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))));
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#1: int :: { $Unbox(Seq#Index(##s#1, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) < 128);
    assume (forall i#1: int :: { $Unbox(Seq#Index(##s#1, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))));
    goto anon22;

  anon26_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(92);
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#2 := LitInt(8);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(8);
    ##s#2 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))));
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##s#2, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) < 128);
    assume (forall i#2: int :: { $Unbox(Seq#Index(##s#2, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))));
    goto anon22;

  anon27_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(8);
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#3 := LitInt(12);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(12);
    ##s#3 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))));
    assume $IsAlloc(##s#3, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##s#3, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#3) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#3, i#3)): char) && char#ToInt($Unbox(Seq#Index(##s#3, i#3)): char) < 128);
    assume (forall i#3: int :: { $Unbox(Seq#Index(##s#3, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#3) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#3, i#3)): char) && char#ToInt($Unbox(Seq#Index(##s#3, i#3)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))));
    goto anon22;

  anon28_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(12);
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#4 := LitInt(10);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(10);
    ##s#4 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))));
    assume $IsAlloc(##s#4, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#4: int :: { $Unbox(Seq#Index(##s#4, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##s#4) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#4, i#4)): char) && char#ToInt($Unbox(Seq#Index(##s#4, i#4)): char) < 128);
    assume (forall i#4: int :: { $Unbox(Seq#Index(##s#4, i#4)): char } LitInt(0) <= i#4 && i#4 < Seq#Length(##s#4) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#4, i#4)): char) && char#ToInt($Unbox(Seq#Index(##s#4, i#4)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))));
    goto anon22;

  anon29_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(10);
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#5 := LitInt(13);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(13);
    ##s#5 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))));
    assume $IsAlloc(##s#5, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#5: int :: { $Unbox(Seq#Index(##s#5, i#5)): char } LitInt(0) <= i#5 && i#5 < Seq#Length(##s#5) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#5, i#5)): char) && char#ToInt($Unbox(Seq#Index(##s#5, i#5)): char) < 128);
    assume (forall i#5: int :: { $Unbox(Seq#Index(##s#5, i#5)): char } LitInt(0) <= i#5 && i#5 < Seq#Length(##s#5) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#5, i#5)): char) && char#ToInt($Unbox(Seq#Index(##s#5, i#5)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))));
    goto anon22;

  anon30_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(13);
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#6 := LitInt(9);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == LitInt(9);
    ##s#6 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))));
    assume $IsAlloc(##s#6, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#6: int :: { $Unbox(Seq#Index(##s#6, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(##s#6) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#6, i#6)): char) && char#ToInt($Unbox(Seq#Index(##s#6, i#6)): char) < 128);
    assume (forall i#6: int :: { $Unbox(Seq#Index(##s#6, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(##s#6) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#6, i#6)): char) && char#ToInt($Unbox(Seq#Index(##s#6, i#6)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))));
    goto anon22;

  anon31_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != LitInt(9);
    havoc c#Z#0;
    assume LitInt(0) <= c#Z#0 && c#Z#0 < BoundedInts.__default.TWO__TO__THE__16();
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    assume let#0#0#0 == $Unbox(Seq#Index(str#0, start#0)): int;
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint16());
    assume c#Z#0 == let#0#0#0;
    newtype$check#7 := LitInt(31);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} c#Z#0 < 31;
    ##s#7 := Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))));
    assume $IsAlloc(##s#7, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#7: int :: { $Unbox(Seq#Index(##s#7, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(##s#7) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#7, i#7)): char) && char#ToInt($Unbox(Seq#Index(##s#7, i#7)): char) < 128);
    assume (forall i#7: int :: { $Unbox(Seq#Index(##s#7, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(##s#7) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#7, i#7)): char) && char#ToInt($Unbox(Seq#Index(##s#7, i#7)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117)))));
    ##c#0 := c#Z#0;
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint16(), $Heap);
    assume JSON_mSpec.__default.EscapeUnicode#canCall(c#Z#0);
    goto anon22;

  anon32_Else:
    assume {:partition} 31 <= c#Z#0;
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    goto anon22;

  anon22:
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(start#0 + 1, Tclass._System.nat());
    ##start#0 := start#0 + 1;
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume 0 <= Seq#Length(str#0) - start#0 || Seq#Length(##str#0) - ##start#0 == Seq#Length(str#0) - start#0;
    assume Seq#Length(##str#0) - ##start#0 < Seq#Length(str#0) - start#0;
    assume JSON_mSpec.__default.Escape#canCall(str#0, start#0 + 1);
    assume JSON_mSpec.__default.Escape($LS($LZ), str#0, start#0) == Seq#Append((if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#2 := $Unbox(Seq#Index(str#0, start#0)): int; (if c#2 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#2)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))))))))))), JSON_mSpec.__default.Escape($LS($LZ), str#0, start#0 + 1));
    assume ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(34) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(92) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(8) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(12) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(10) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(13) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(9) ==> (var c#2 := $Unbox(Seq#Index(str#0, start#0)): int; c#2 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#2))))))))) && JSON_mSpec.__default.Escape#canCall(str#0, start#0 + 1);
    assume $Is(JSON_mSpec.__default.Escape($LS($LZ), str#0, start#0), TSeq(Tclass.BoundedInts.uint16()));
    return;
}



function JSON_mSpec.__default.EscapeToUTF8(str#0: Seq, start#0: int) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) } JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, start#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> $Is(JSON_mSpec.__default.EscapeToUTF8(str#0, start#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 2 <= $FunctionContextHeight ==> (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) } JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, start#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(str#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#0 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (var utf16#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#0, LitInt(0)) && (var escaped#0 := JSON_mSpec.__default.Escape($LS($LZ), utf16#0, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#0) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#0 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (var utf32#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == (var valueOrError0#0 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var utf16#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; (var escaped#0 := JSON_mSpec.__default.Escape($LS($LZ), utf16#0, LitInt(0)); (var valueOrError1#0 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0) else (var utf32#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): Seq; Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))));
axiom 2 <= $FunctionContextHeight ==> (forall str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(start#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(str#0)) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#1 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (var utf16#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#1, LitInt(0)) && (var escaped#1 := JSON_mSpec.__default.Escape($LS($LZ), utf16#1, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#1) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#1), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#1 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#1), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (var utf32#1 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#1) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#1), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) == (var valueOrError0#1 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var utf16#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq); (var escaped#1 := Lit(JSON_mSpec.__default.Escape($LS($LZ), utf16#1, LitInt(0))); (var valueOrError1#1 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.FromUTF16Checked(escaped#1)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#1) else (var utf32#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1)): Seq); Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF8Checked(utf32#1)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))))))))))));
}

function JSON_mSpec.__default.EscapeToUTF8#canCall(str#0: Seq, start#0: int) : bool;

function JSON_mSpec.__default.EscapeToUTF8#requires(Seq, int) : bool;

axiom (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8#requires(str#0, start#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0 ==> (JSON_mSpec.__default.EscapeToUTF8#requires(str#0, start#0) <==> true));

procedure {:verboseName "JSON.Spec.EscapeToUTF8 (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.EscapeToUTF8(str#0: Seq where $Is(str#0, TSeq(TChar)), start#0: int where LitInt(0) <= start#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.EscapeToUTF8 (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.EscapeToUTF8(str#0: Seq, start#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##error#0: DatatypeType;
  var utf16#Z#0: Seq;
  var let#1#0#0: Seq;
  var escaped#Z#0: Seq;
  var let#2#0#0: Seq;
  var ##str#0: Seq;
  var ##start#0: int;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##bs#0: Seq;
  var ##error#1: DatatypeType;
  var utf32#Z#0: Seq;
  var let#4#0#0: Seq;
  var ##s#1: Seq;
  var ##error#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.EscapeToUTF8", " | ", str#0, " | ", start#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(70,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mSpec.__default.EscapeToUTF8(str#0, start#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon8_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##s#0 := str#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume UnicodeStrings.__default.ToUTF16Checked#canCall(str#0);
    assume $IsAllocBox($Box(UnicodeStrings.__default.ToUTF16Checked(str#0)), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16())), $Heap);
    ##error#0 := Lit(#JSON.Errors.SerializationError.InvalidUnicode());
    assume $IsAlloc(##error#0, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume let#0#0#0 == Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume UnicodeStrings.__default.ToUTF16Checked#canCall(str#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mSpec.__default.EscapeToUTF8(str#0, start#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon9_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc utf16#Z#0;
    assume $Is(utf16#Z#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(utf16#Z#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint16()));
    assume utf16#Z#0 == let#1#0#0;
    havoc escaped#Z#0;
    assume $Is(escaped#Z#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(escaped#Z#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##str#0 := utf16#Z#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##start#0 := LitInt(0);
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume JSON_mSpec.__default.Escape#canCall(utf16#Z#0, LitInt(0));
    assume let#2#0#0 == JSON_mSpec.__default.Escape($LS($LZ), utf16#Z#0, LitInt(0));
    assume JSON_mSpec.__default.Escape#canCall(utf16#Z#0, LitInt(0));
    assume $Is(let#2#0#0, TSeq(Tclass.BoundedInts.uint16()));
    assume escaped#Z#0 == let#2#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##bs#0 := escaped#Z#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#Z#0);
    assume $IsAllocBox($Box(UnicodeStrings.__default.FromUTF16Checked(escaped#Z#0)), Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    ##error#1 := Lit(#JSON.Errors.SerializationError.InvalidUnicode());
    assume $IsAlloc(##error#1, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#Z#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume let#3#0#0 == Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#Z#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#Z#0) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#Z#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume $Is(JSON_mSpec.__default.EscapeToUTF8(str#0, start#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    havoc utf32#Z#0;
    assume $Is(utf32#Z#0, TSeq(TChar)) && $IsAlloc(utf32#Z#0, TSeq(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume let#4#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(let#4#0#0, TSeq(TChar));
    assume utf32#Z#0 == let#4#0#0;
    ##s#1 := utf32#Z#0;
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#Z#0);
    assume $IsAllocBox($Box(UnicodeStrings.__default.ToUTF8Checked(utf32#Z#0)), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##error#2 := Lit(#JSON.Errors.SerializationError.InvalidUnicode());
    assume $IsAlloc(##error#2, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#Z#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#Z#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#Z#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#Z#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())));
    assume $Is(JSON_mSpec.__default.EscapeToUTF8(str#0, start#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSpec.__default.String(str#0: Seq) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mSpec.__default.String(str#0) } JSON_mSpec.__default.String#canCall(str#0) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> $Is(JSON_mSpec.__default.String(str#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mSpec.__default.String(str#0) } JSON_mSpec.__default.String#canCall(str#0) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0)) && (var valueOrError0#0 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(str#0) == (var valueOrError0#0 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var inBytes#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#0), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq :: {:weight 3} { JSON_mSpec.__default.String(Lit(str#0)) } JSON_mSpec.__default.String#canCall(Lit(str#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(0)) && (var valueOrError0#1 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(Lit(str#0)) == (var valueOrError0#1 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var inBytes#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#1), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));
}

function JSON_mSpec.__default.String#canCall(str#0: Seq) : bool;

function JSON_mSpec.__default.String#requires(Seq) : bool;

axiom (forall str#0: Seq :: { JSON_mSpec.__default.String#requires(str#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mSpec.__default.String#requires(str#0) <==> true));

procedure {:verboseName "JSON.Spec.String (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.String(str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.String (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.String(str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: Seq;
  var ##start#0: int;
  var inBytes#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##s#0: Seq;
  var ##s#1: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.String", " | ", str#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(78,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(JSON_mSpec.__default.String(str#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon6_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    ##start#0 := LitInt(0);
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0));
    assume let#0#0#0 == JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0));
    assume JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mSpec.__default.String(str#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mSpec.__default.String(str#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon7_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc inBytes#Z#0;
    assume $Is(inBytes#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(inBytes#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume inBytes#Z#0 == let#1#0#0;
    ##s#0 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34)))));
    ##s#1 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))));
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#1: int :: { $Unbox(Seq#Index(##s#1, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) < 128);
    assume (forall i#1: int :: { $Unbox(Seq#Index(##s#1, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34)))));
    assume JSON_mSpec.__default.String(str#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#Z#0), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34)))));
    assume $Is(JSON_mSpec.__default.String(str#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;
}



procedure {:verboseName "JSON.Spec.OfIntOnlyASCII (well-formedness)"} CheckWellFormed$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.OfIntOnlyASCII (well-formedness)"} CheckWellFormed$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#0: int;
  var i#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.OfIntOnlyASCII", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Spec.dfy(83,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/Spec.dfy(85,6): post-state"} true;
    assume true;
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##base#0 := LitInt(10);
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#0;
    assume {:subsumption 0} ##base#0 <= LitInt(16);
    assume LitInt(2) <= ##base#0 && ##base#0 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
    assume let#0#0#0 == JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
    assume $Is(let#0#0#0, TSeq(TChar));
    assume s#Z#0 == let#0#0#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Lit(true);
    havoc i#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon5;

  anon12_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon5;

  anon5:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} LitInt(0) <= i#0 && i#0 < Seq#Length(s#Z#0);
    assume 0 <= i#0 && i#0 < Seq#Length(s#Z#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#Z#0, i#0)): char);
    assume 0 <= i#0 && i#0 < Seq#Length(s#Z#0);
    goto anon8;

  anon14_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#Z#0, i#0)): char) < LitInt(0);
    goto anon8;

  anon13_Else:
    assume {:partition} !(LitInt(0) <= i#0 && i#0 < Seq#Length(s#Z#0));
    goto anon8;

  anon11_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    goto anon9;

  anon10_Else:
    assume {:partition} !Lit(true);
    goto anon9;

  anon9:
    assume (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); true && (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128));
    return;
}



procedure {:verboseName "JSON.Spec.OfIntOnlyASCII (call precondtion)"} CallPre$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int);



procedure {:verboseName "JSON.Spec.OfIntOnlyASCII (call postcondition)"} CallPost$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int);
  modifies $Heap;
  free ensures Lit(true) ==> JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
  free ensures {:id "id22214"} Lit(true);
  free ensures {:id "id22215"} (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); Lit(true));
  free ensures {:id "id22216"} (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Spec.OfIntOnlyASCII (correctness)"} Impl$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures Lit(true) ==> JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
  free ensures {:id "id22217"} Lit(true);
  free ensures {:id "id22218"} (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); Lit(true));
  free ensures {:id "id22219"} (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); (forall i#1: int :: { $Unbox(Seq#Index(s#0, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#1)): char) < 128));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.OfIntOnlyASCII (correctness)"} Impl$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var s#1: Seq where $Is(s#1, TSeq(TChar)) && $IsAlloc(s#1, TSeq(TChar), $Heap);
  var ##n#1: int;
  var ##base#1: int;
  var i#0_0: int;
  var isHexDigit#0_1_0: HandleType where $Is(isHexDigit#0_1_0, Tclass._System.___hTotalFunc1(TChar, TBool)) && $IsAlloc(isHexDigit#0_1_0, Tclass._System.___hTotalFunc1(TChar, TBool), $Heap);
  var $lambdaHeap#0_1_0: Heap;
  var c#0_1_0: char;
  var $_Frame#l0_1_0: [ref,Field]bool;
  var lambdaResult#0_1_0: bool;
  var ##str#0_1_0: Seq;
  var ##minus#0_1_0: char;
  var ##is_digit#0_1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.OfIntOnlyASCII", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Spec.dfy(87,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##n#1 := n#0;
    assume $IsAlloc(##n#1, TInt, $Heap);
    ##base#1 := LitInt(10);
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#1;
    assume {:subsumption 0} ##base#1 <= LitInt(16);
    assume LitInt(2) <= ##base#1 && ##base#1 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
    s#1 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10));
    assume {:captureState "libraries/src/JSON/Spec.dfy(88,25)"} true;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    havoc i#0_0;
    assume true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= i#0_0;
    goto anon3;

  anon18_Else:
    assume {:partition} i#0_0 < LitInt(0);
    goto anon3;

  anon3:
    assume true;
    assume LitInt(0) <= i#0_0 && i#0_0 < Seq#Length(s#1);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < Seq#Length(s#1);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#1, i#0_0)): char);
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < Seq#Length(s#1);
    goto anon6;

  anon20_Else:
    assume {:partition} char#ToInt($Unbox(Seq#Index(s#1, i#0_0)): char) < LitInt(0);
    goto anon6;

  anon6:
    assume true;
    assume LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#1, i#0_0)): char) && char#ToInt($Unbox(Seq#Index(s#1, i#0_0)): char) < 128;
    assume false;
    goto anon7;

  anon19_Else:
    goto anon7;

  anon7:
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} i#0_0 == LitInt(0);
    goto anon14;

  anon21_Else:
    assume {:partition} i#0_0 != LitInt(0);
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#0_1_0;
    assume $IsGoodHeap($lambdaHeap#0_1_0);
    assume $Heap == $lambdaHeap#0_1_0 || $HeapSucc($Heap, $lambdaHeap#0_1_0);
    havoc c#0_1_0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#0_1_0, TChar);
    $_Frame#l0_1_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0_1_0, $o, alloc)): bool ==> false);
    assume lambdaResult#0_1_0 <==> Seq#Contains(JSON_mUtils_mStr.__default.HEX__DIGITS(), $Box(c#0_1_0));
    assume true;
    assume $Is(lambdaResult#0_1_0, TBool);
    goto anon12;

  anon23_Else:
    assume {:partition} !$Is(c#0_1_0, TChar);
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon22_Else:
    goto anon13;

  anon13:
    assume true;
    isHexDigit#0_1_0 := Lit(AtLayer((lambda $l#0_1_1#ly#0: LayerType :: Handle1((lambda $l#0_1_1#heap#0: Heap, $l#0_1_1#c#0: Box :: $Box(Seq#Contains(JSON_mUtils_mStr.__default.HEX__DIGITS(), $l#0_1_1#c#0))), (lambda $l#0_1_1#heap#0: Heap, $l#0_1_1#c#0: Box :: $IsBox($l#0_1_1#c#0, TChar)), (lambda $l#0_1_1#heap#0: Heap, $l#0_1_1#c#0: Box :: SetRef_to_SetBox((lambda $l#0_1_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/Spec.dfy(92,46)"} true;
    ##str#0_1_0 := s#1;
    assume $IsAlloc(##str#0_1_0, TSeq(TChar), $Heap);
    ##minus#0_1_0 := Lit(char#FromInt(45));
    assume $IsAlloc(##minus#0_1_0, TChar, $Heap);
    ##is_digit#0_1_0 := isHexDigit#0_1_0;
    assume $IsAlloc(##is_digit#0_1_0, Tclass._System.___hTotalFunc1(TChar, TBool), $Heap);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0);
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0);
    assume {:subsumption 0} JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0) || (!Seq#Equal(s#1, Seq#Empty(): Seq) ==> $Unbox(Seq#Index(s#1, LitInt(0))): char == Lit(char#FromInt(45)) || $Unbox(Apply1(TChar, TBool, $Heap, isHexDigit#0_1_0, $Box($Unbox(Seq#Index(s#1, LitInt(0))): char))): bool);
    assume {:subsumption 0} JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0) || (!Seq#Equal(s#1, Seq#Empty(): Seq) ==> (forall c#0_1_1: char :: { $Unbox(Apply1(TChar, TBool, $Heap, isHexDigit#0_1_0, $Box(c#0_1_1))): bool } { Seq#Contains(Seq#Drop(s#1, 1), $Box(c#0_1_1)) } $Is(c#0_1_1, TChar) && Seq#Contains(Seq#Drop(s#1, LitInt(1)), $Box(c#0_1_1)) ==> $Unbox(Apply1(TChar, TBool, $Heap, isHexDigit#0_1_0, $Box(c#0_1_1))): bool));
    assume JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(s#1, Lit(char#FromInt(45)), isHexDigit#0_1_0);
    assume {:captureState "libraries/src/JSON/Spec.dfy(93,62)"} true;
    assume {:subsumption 0} 0 <= i#0_0 && i#0_0 < Seq#Length(s#1);
    assume true;
    assume $Unbox(Apply1(TChar, TBool, $Heap, isHexDigit#0_1_0, $Box($Unbox(Seq#Index(s#1, i#0_0)): char))): bool;
    assume {:captureState "libraries/src/JSON/Spec.dfy(94,31)"} true;
    goto anon14;

  anon14:
    assume LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#1, i#0_0)): char);
    assume char#ToInt($Unbox(Seq#Index(s#1, i#0_0)): char) < 128;
    assume false;
    goto anon16;

  anon17_Else:
    assume (forall i#0_1: int :: { $Unbox(Seq#Index(s#1, i#0_1)): char } LitInt(0) <= i#0_1 && i#0_1 < Seq#Length(s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#1, i#0_1)): char) && char#ToInt($Unbox(Seq#Index(s#1, i#0_1)): char) < 128);
    goto anon16;

  anon16:
    assume {:captureState "libraries/src/JSON/Spec.dfy(96,4)"} true;
    return;
}



function JSON_mSpec.__default.IntToBytes(n#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSpec.__default.IntToBytes(n#0) } JSON_mSpec.__default.IntToBytes#canCall(n#0) || 1 < $FunctionContextHeight ==> $Is(JSON_mSpec.__default.IntToBytes(n#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSpec.__default.IntToBytes(n#0) } JSON_mSpec.__default.IntToBytes#canCall(n#0) || 1 < $FunctionContextHeight ==> JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10)) && (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0)) && JSON_mSpec.__default.IntToBytes(n#0) == (var s#0 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8(s#0)));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { JSON_mSpec.__default.IntToBytes(LitInt(n#0)) } JSON_mSpec.__default.IntToBytes#canCall(LitInt(n#0)) || 1 < $FunctionContextHeight ==> JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(n#0), LitInt(10)) && (var s#1 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#1)) && JSON_mSpec.__default.IntToBytes(LitInt(n#0)) == (var s#1 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); Lit(UnicodeStrings.__default.ASCIIToUTF8(s#1))));
}

function JSON_mSpec.__default.IntToBytes#canCall(n#0: int) : bool;

function JSON_mSpec.__default.IntToBytes#requires(int) : bool;

axiom (forall n#0: int :: { JSON_mSpec.__default.IntToBytes#requires(n#0) } JSON_mSpec.__default.IntToBytes#requires(n#0) <==> true);

procedure {:verboseName "JSON.Spec.IntToBytes (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.IntToBytes(n#0: int);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.IntToBytes (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.IntToBytes(n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var s#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#0: int;
  var n##0: int;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.IntToBytes", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(99,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mSpec.__default.IntToBytes(n#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##base#0 := LitInt(10);
    assume $IsAlloc(##base#0, TInt, $Heap);
    assume {:subsumption 0} LitInt(2) <= ##base#0;
    assume {:subsumption 0} ##base#0 <= LitInt(16);
    assume LitInt(2) <= ##base#0 && ##base#0 <= LitInt(16);
    assume JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
    assume let#0#0#0 == JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10));
    assume JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10));
    assume $Is(let#0#0#0, TSeq(TChar));
    assume s#Z#0 == let#0#0#0;
    assume true;
    n##0 := n#0;
    call CallPre$$JSON_mSpec.__default.OfIntOnlyASCII(n##0);
    call CallPost$$JSON_mSpec.__default.OfIntOnlyASCII(n##0);
    assume {:captureState "libraries/src/JSON/Spec.dfy(101,20)"} true;
    ##s#0 := s#Z#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(s#Z#0);
    assume JSON_mSpec.__default.IntToBytes(n#0) == UnicodeStrings.__default.ASCIIToUTF8(s#Z#0);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(s#Z#0);
    assume $Is(JSON_mSpec.__default.IntToBytes(n#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mSpec.__default.Number(dec#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall dec#0: DatatypeType :: { JSON_mSpec.__default.Number(dec#0) } JSON_mSpec.__default.Number#canCall(dec#0) || (2 < $FunctionContextHeight && $Is(dec#0, Tclass.JSON_mValues.Decimal())) ==> $Is(JSON_mSpec.__default.Number(dec#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 2 <= $FunctionContextHeight ==> (forall dec#0: DatatypeType :: { JSON_mSpec.__default.Number(dec#0) } JSON_mSpec.__default.Number#canCall(dec#0) || (2 < $FunctionContextHeight && $Is(dec#0, Tclass.JSON_mValues.Decimal())) ==> JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && (JSON_mValues.Decimal.e10(dec#0) != LitInt(0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))) && JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.e10(dec#0))) && JSON_mSpec.__default.Number(dec#0) == #Wrappers.Result.Success($Box(Seq#Append(JSON_mSpec.__default.IntToBytes(JSON_mValues.Decimal.n(dec#0)), (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))), JSON_mSpec.__default.IntToBytes(JSON_mValues.Decimal.e10(dec#0))))))));
axiom 2 <= $FunctionContextHeight ==> (forall dec#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.Number(Lit(dec#0)) } JSON_mSpec.__default.Number#canCall(Lit(dec#0)) || (2 < $FunctionContextHeight && $Is(dec#0, Tclass.JSON_mValues.Decimal())) ==> JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSpec.__default.IntToBytes#canCall(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && (LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) != LitInt(0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSpec.__default.IntToBytes#canCall(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))) && JSON_mSpec.__default.Number(Lit(dec#0)) == #Wrappers.Result.Success($Box(Seq#Append(JSON_mSpec.__default.IntToBytes(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))), (if LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))), JSON_mSpec.__default.IntToBytes(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))))));
}

function JSON_mSpec.__default.Number#canCall(dec#0: DatatypeType) : bool;

function JSON_mSpec.__default.Number#requires(DatatypeType) : bool;

axiom (forall dec#0: DatatypeType :: { JSON_mSpec.__default.Number#requires(dec#0) } $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> (JSON_mSpec.__default.Number#requires(dec#0) <==> true));

procedure {:verboseName "JSON.Spec.Number (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Number(dec#0: DatatypeType where $Is(dec#0, Tclass.JSON_mValues.Decimal()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.Number (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Number(dec#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##n#0: int;
  var ##s#0: Seq;
  var ##n#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.Number", " | ", dec#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(105,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mSpec.__default.Number(dec#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon7_Else:
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    ##n#0 := JSON_mValues.Decimal.n(dec#0);
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.n(dec#0));
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} JSON_mValues.Decimal.e10(dec#0) == LitInt(0);
    goto anon6;

  anon8_Else:
    assume {:partition} JSON_mValues.Decimal.e10(dec#0) != LitInt(0);
    ##s#0 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101)))));
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    ##n#1 := JSON_mValues.Decimal.e10(dec#0);
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.e10(dec#0));
    goto anon6;

  anon6:
    assume JSON_mSpec.__default.Number(dec#0) == #Wrappers.Result.Success($Box(Seq#Append(JSON_mSpec.__default.IntToBytes(JSON_mValues.Decimal.n(dec#0)), (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))), JSON_mSpec.__default.IntToBytes(JSON_mValues.Decimal.e10(dec#0)))))));
    assume JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && (JSON_mValues.Decimal.e10(dec#0) != LitInt(0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))) && JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.e10(dec#0)));
    assume $Is(JSON_mSpec.__default.Number(dec#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSpec.__default.KeyValue($ly: LayerType, kv#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($ly, kv#0) } JSON_mSpec.__default.KeyValue#canCall(kv#0) || (4 < $FunctionContextHeight && $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> $Is(JSON_mSpec.__default.KeyValue($ly, kv#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($LS($ly), kv#0) } JSON_mSpec.__default.KeyValue#canCall(kv#0) || (4 < $FunctionContextHeight && $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq) && (var valueOrError0#0 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.JSON#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType) && (var valueOrError1#0 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), kv#0) == (var valueOrError0#0 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var key#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; (var valueOrError1#0 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0) else (var value#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#0, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#0))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, kv#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) } JSON_mSpec.__default.KeyValue#canCall(Lit(kv#0)) || (4 < $FunctionContextHeight && $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.String#canCall(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq)) && (var valueOrError0#1 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.JSON#canCall(Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType)) && (var valueOrError1#1 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) == (var valueOrError0#1 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var key#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq); (var valueOrError1#1 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#1) else (var value#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#1, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#1))))))))));
}

function JSON_mSpec.__default.KeyValue#canCall(kv#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($LS($ly), kv#0) } JSON_mSpec.__default.KeyValue($LS($ly), kv#0) == JSON_mSpec.__default.KeyValue($ly, kv#0));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue(AsFuelBottom($ly), kv#0) } JSON_mSpec.__default.KeyValue($ly, kv#0) == JSON_mSpec.__default.KeyValue($LZ, kv#0));

function JSON_mSpec.__default.KeyValue#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue#requires($ly, kv#0) } $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> (JSON_mSpec.__default.KeyValue#requires($ly, kv#0) <==> true));

procedure {:verboseName "JSON.Spec.KeyValue (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.KeyValue(kv#0: DatatypeType where $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.KeyValue (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.KeyValue(kv#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: Seq;
  var key#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##js#0: DatatypeType;
  var value#Z#0: Seq;
  var let#3#0#0: Seq;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.KeyValue", " | ", kv#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(111,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mSpec.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon8_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume _System.Tuple2.___hMake2_q(kv#0);
    ##str#0 := $Unbox(_System.Tuple2._0(kv#0)): Seq;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    assume JSON_mSpec.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq);
    assume let#0#0#0 == JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq);
    assume _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mSpec.__default.KeyValue($LS($LZ), kv#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mSpec.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon9_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc key#Z#0;
    assume $Is(key#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(key#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume key#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume _System.Tuple2.___hMake2_q(kv#0);
    ##js#0 := $Unbox(_System.Tuple2._1(kv#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume DtRank(##js#0) < DtRank(kv#0);
    assume JSON_mSpec.__default.JSON#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType);
    assume let#2#0#0 == JSON_mSpec.__default.JSON($LS($LZ), $Unbox(_System.Tuple2._1(kv#0)): DatatypeType);
    assume _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.JSON#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType);
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume JSON_mSpec.__default.KeyValue($LS($LZ), kv#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume $Is(JSON_mSpec.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    havoc value#Z#0;
    assume $Is(value#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(value#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume value#Z#0 == let#3#0#0;
    ##s#0 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))));
    assume JSON_mSpec.__default.KeyValue($LS($LZ), kv#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#Z#0, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#Z#0)));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))));
    assume $Is(JSON_mSpec.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSpec.__default.Join($ly: LayerType, sep#0: Seq, items#0: Seq) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($ly, sep#0, items#0) } JSON_mSpec.__default.Join#canCall(sep#0, items#0) || (1 < $FunctionContextHeight && $Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> $Is(JSON_mSpec.__default.Join($ly, sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) } JSON_mSpec.__default.Join#canCall(sep#0, items#0) || (1 < $FunctionContextHeight && $Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(items#0) != LitInt(0) ==> (var valueOrError0#0 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Seq#Length(items#0) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(sep#0, Seq#Drop(items#0, LitInt(1))) && (var valueOrError1#0 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0))))))) && JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) == (if Seq#Length(items#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#0 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var first#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; (if Seq#Length(items#0) == LitInt(1) then #Wrappers.Result.Success($Box(first#0)) else (var valueOrError1#0 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#0) else (var rest#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#0, sep#0), rest#0))))))))))));
axiom 1 <= $FunctionContextHeight ==> (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: {:weight 3} { JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) } JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(items#0)) || (1 < $FunctionContextHeight && $Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(Lit(items#0)) != LitInt(0) ==> (var valueOrError0#1 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Seq#Length(Lit(items#0)) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1)))) && (var valueOrError1#1 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1))))))) && JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) == (if Seq#Length(Lit(items#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#1 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var first#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; (if Seq#Length(Lit(items#0)) == LitInt(1) then #Wrappers.Result.Success($Box(first#1)) else (var valueOrError1#1 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#1) else (var rest#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#1, sep#0), rest#1))))))))))));
}

function JSON_mSpec.__default.Join#canCall(sep#0: Seq, items#0: Seq) : bool;

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) } JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) == JSON_mSpec.__default.Join($ly, sep#0, items#0));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join(AsFuelBottom($ly), sep#0, items#0) } JSON_mSpec.__default.Join($ly, sep#0, items#0) == JSON_mSpec.__default.Join($LZ, sep#0, items#0));

function JSON_mSpec.__default.Join#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join#requires($ly, sep#0, items#0) } $Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()))) ==> (JSON_mSpec.__default.Join#requires($ly, sep#0, items#0) <==> true));

procedure {:verboseName "JSON.Spec.Join (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Join(sep#0: Seq where $Is(sep#0, TSeq(Tclass.BoundedInts.uint8())), items#0: Seq where $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.Join (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Join(sep#0: Seq, items#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var first#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##sep#0: Seq;
  var ##items#0: Seq;
  var rest#Z#0: Seq;
  var let#3#0#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.Join", " | ", sep#0, " | ", items#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(117,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Seq#Length(items#0) == LitInt(0);
    assume JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0) == Lit(#Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))));
    assume true;
    assume $Is(JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon13_Else:
    assume {:partition} Seq#Length(items#0) != LitInt(0);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(items#0);
    assume let#0#0#0 == $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType;
    assume true;
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon14_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc first#Z#0;
    assume $Is(first#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(first#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume first#Z#0 == let#1#0#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Length(items#0) == LitInt(1);
    assume JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0) == #Wrappers.Result.Success($Box(first#Z#0));
    assume true;
    assume $Is(JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon15_Else:
    assume {:partition} Seq#Length(items#0) != LitInt(1);
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(items#0);
    ##sep#0 := sep#0;
    assume $IsAlloc(##sep#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##items#0 := Seq#Drop(items#0, LitInt(1));
    assume $IsAlloc(##items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())), $Heap);
    assume Seq#Rank(##sep#0) < Seq#Rank(sep#0) || (Seq#Rank(##sep#0) == Seq#Rank(sep#0) && Seq#Rank(##items#0) < Seq#Rank(items#0));
    assume JSON_mSpec.__default.Join#canCall(sep#0, Seq#Drop(items#0, LitInt(1)));
    assume let#2#0#0 == JSON_mSpec.__default.Join($LS($LZ), sep#0, Seq#Drop(items#0, LitInt(1)));
    assume JSON_mSpec.__default.Join#canCall(sep#0, Seq#Drop(items#0, LitInt(1)));
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#Z#0);
    assume $Is(JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    havoc rest#Z#0;
    assume $Is(rest#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(rest#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume rest#Z#0 == let#3#0#0;
    assume JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#Z#0, sep#0), rest#Z#0)));
    assume true;
    assume $Is(JSON_mSpec.__default.Join($LS($LZ), sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSpec.__default.Object($ly: LayerType, obj#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: Seq :: { JSON_mSpec.__default.Object($ly, obj#0) } JSON_mSpec.__default.Object#canCall(obj#0) || (4 < $FunctionContextHeight && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> $Is(JSON_mSpec.__default.Object($ly, obj#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSpec.__default.Object($LS($ly), obj#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(obj#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#1#i#0: int :: LitInt(0) <= $l#1#i#0 && $l#1#i#0 < Seq#Length(obj#0) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, $l#1#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#2#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#2#i#0): int)): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(obj#0)), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly)))) && (var valueOrError0#0 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#3#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#3#i#0): int)): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: $IsBox($l#3#i#0, TInt) && LitInt(0) <= $Unbox($l#3#i#0): int && $Unbox($l#3#i#0): int < Seq#Length(obj#0)), (lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), obj#0) == (var valueOrError0#0 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#0#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#0#i#0): int)): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(obj#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var middle#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#0), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: {:weight 3} { JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(Lit(obj#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#5#i#0: int :: LitInt(0) <= $l#5#i#0 && $l#5#i#0 < Seq#Length(Lit(obj#0)) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(Lit(obj#0), $l#5#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#6#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#6#i#0): int)): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt) && LitInt(0) <= $Unbox($l#6#i#0): int && $Unbox($l#6#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#1 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#7#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#7#i#0): int)): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#i#0: Box :: $IsBox($l#7#i#0, TInt) && LitInt(0) <= $Unbox($l#7#i#0): int && $Unbox($l#7#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#7#heap#0: Heap, $l#7#i#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)) == (var valueOrError0#1 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#4#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#4#i#0): int)): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var middle#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#1), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));
}

function JSON_mSpec.__default.Object#canCall(obj#0: Seq) : bool;

axiom (forall $ly: LayerType, obj#0: Seq :: { JSON_mSpec.__default.Object($LS($ly), obj#0) } JSON_mSpec.__default.Object($LS($ly), obj#0) == JSON_mSpec.__default.Object($ly, obj#0));

axiom (forall $ly: LayerType, obj#0: Seq :: { JSON_mSpec.__default.Object(AsFuelBottom($ly), obj#0) } JSON_mSpec.__default.Object($ly, obj#0) == JSON_mSpec.__default.Object($LZ, obj#0));

function JSON_mSpec.__default.Object#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSpec.__default.Object#requires($ly, obj#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> (JSON_mSpec.__default.Object#requires($ly, obj#0) <==> true));

procedure {:verboseName "JSON.Spec.Object (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Object(obj#0: Seq where $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.Object (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Object(obj#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var i#1: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##kv#0: DatatypeType;
  var ##sep#0: Seq;
  var ##items#0: Seq;
  var middle#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.Object", " | ", obj#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(129,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mSpec.__default.Object($LS($LZ), obj#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon14_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##s#0 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))));
    assume 0 <= Seq#Length(obj#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#1;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= i#1;
    goto anon7;

  anon17_Else:
    assume {:partition} i#1 < LitInt(0);
    goto anon7;

  anon7:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= i#1 && i#1 < Seq#Length(obj#0);
    assume 0 <= i#1 && i#1 < Seq#Length(obj#0);
    ##kv#0 := $Unbox(Seq#Index(obj#0, i#1)): DatatypeType;
    assume $IsAlloc(##kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), $lambdaHeap#0);
    assume DtRank(##kv#0) < Seq#Rank(obj#0);
    assume JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, i#1)): DatatypeType);
    assume lambdaResult#0 == JSON_mSpec.__default.KeyValue($LS($LZ), $Unbox(Seq#Index(obj#0, i#1)): DatatypeType);
    assume JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, i#1)): DatatypeType);
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon9;

  anon18_Else:
    assume {:partition} !(LitInt(0) <= i#1 && i#1 < Seq#Length(obj#0));
    goto anon9;

  anon16_Else:
    assume {:partition} false;
    goto anon9;

  anon9:
    assume false;
    goto anon10;

  anon15_Else:
    goto anon10;

  anon10:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(obj#0) ==> Requires1(TInt, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#8#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#8#i#0): int)): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(obj#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(obj#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#8#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#8#i#0): int)): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(obj#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    ##sep#0 := Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))));
    assume $IsAlloc(##sep#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##items#0 := Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#10#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#10#i#0): int)): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $IsBox($l#10#i#0, TInt) && LitInt(0) <= $Unbox($l#10#i#0): int && $Unbox($l#10#i#0): int < Seq#Length(obj#0)), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAlloc(##items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())), $Heap);
    assume JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#11#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#11#i#0): int)): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#i#0: Box :: $IsBox($l#11#i#0, TInt) && LitInt(0) <= $Unbox($l#11#i#0): int && $Unbox($l#11#i#0): int < Seq#Length(obj#0)), (lambda $l#11#heap#0: Heap, $l#11#i#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))));
    assume let#0#0#0 == JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#13#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#13#i#0): int)): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#i#0: Box :: $IsBox($l#13#i#0, TInt) && LitInt(0) <= $Unbox($l#13#i#0): int && $Unbox($l#13#i#0): int < Seq#Length(obj#0)), (lambda $l#13#heap#0: Heap, $l#13#i#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#14#i#0: int :: LitInt(0) <= $l#14#i#0 && $l#14#i#0 < Seq#Length(obj#0) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, $l#14#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#15#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#15#i#0): int)): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#i#0: Box :: $IsBox($l#15#i#0, TInt) && LitInt(0) <= $Unbox($l#15#i#0): int && $Unbox($l#15#i#0): int < Seq#Length(obj#0)), (lambda $l#15#heap#0: Heap, $l#15#i#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mSpec.__default.Object($LS($LZ), obj#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mSpec.__default.Object($LS($LZ), obj#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon13;

  anon19_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc middle#Z#0;
    assume $Is(middle#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(middle#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume middle#Z#0 == let#1#0#0;
    ##s#1 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))));
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##s#1, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) < 128);
    assume (forall i#2: int :: { $Unbox(Seq#Index(##s#1, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123)))));
    ##s#2 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))));
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##s#2, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) < 128);
    assume (forall i#3: int :: { $Unbox(Seq#Index(##s#2, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125)))));
    assume JSON_mSpec.__default.Object($LS($LZ), obj#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#Z#0), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125)))));
    assume $Is(JSON_mSpec.__default.Object($LS($LZ), obj#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon13;

  anon13:
    assume b$reqreads#0;
    return;
}



function JSON_mSpec.__default.Array($ly: LayerType, arr#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: Seq :: { JSON_mSpec.__default.Array($ly, arr#0) } JSON_mSpec.__default.Array#canCall(arr#0) || (4 < $FunctionContextHeight && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> $Is(JSON_mSpec.__default.Array($ly, arr#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSpec.__default.Array($LS($ly), arr#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(arr#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#1#i#0: int :: LitInt(0) <= $l#1#i#0 && $l#1#i#0 < Seq#Length(arr#0) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, $l#1#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#2#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#2#i#0): int)): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: $IsBox($l#2#i#0, TInt) && LitInt(0) <= $Unbox($l#2#i#0): int && $Unbox($l#2#i#0): int < Seq#Length(arr#0)), (lambda $l#2#heap#0: Heap, $l#2#i#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly)))) && (var valueOrError0#0 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#3#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#3#i#0): int)): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: $IsBox($l#3#i#0, TInt) && LitInt(0) <= $Unbox($l#3#i#0): int && $Unbox($l#3#i#0): int < Seq#Length(arr#0)), (lambda $l#3#heap#0: Heap, $l#3#i#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), arr#0) == (var valueOrError0#0 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#0#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#0#i#0): int)): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: $IsBox($l#0#i#0, TInt) && LitInt(0) <= $Unbox($l#0#i#0): int && $Unbox($l#0#i#0): int < Seq#Length(arr#0)), (lambda $l#0#heap#0: Heap, $l#0#i#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var middle#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#0), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: {:weight 3} { JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(Lit(arr#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#5#i#0: int :: LitInt(0) <= $l#5#i#0 && $l#5#i#0 < Seq#Length(Lit(arr#0)) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(Lit(arr#0), $l#5#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#6#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#6#i#0): int)): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: $IsBox($l#6#i#0, TInt) && LitInt(0) <= $Unbox($l#6#i#0): int && $Unbox($l#6#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#6#heap#0: Heap, $l#6#i#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#1 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#7#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#7#i#0): int)): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#i#0: Box :: $IsBox($l#7#i#0, TInt) && LitInt(0) <= $Unbox($l#7#i#0): int && $Unbox($l#7#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#7#heap#0: Heap, $l#7#i#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)) == (var valueOrError0#1 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#4#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#4#i#0): int)): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: $IsBox($l#4#i#0, TInt) && LitInt(0) <= $Unbox($l#4#i#0): int && $Unbox($l#4#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#4#heap#0: Heap, $l#4#i#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var middle#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#1), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));
}

function JSON_mSpec.__default.Array#canCall(arr#0: Seq) : bool;

axiom (forall $ly: LayerType, arr#0: Seq :: { JSON_mSpec.__default.Array($LS($ly), arr#0) } JSON_mSpec.__default.Array($LS($ly), arr#0) == JSON_mSpec.__default.Array($ly, arr#0));

axiom (forall $ly: LayerType, arr#0: Seq :: { JSON_mSpec.__default.Array(AsFuelBottom($ly), arr#0) } JSON_mSpec.__default.Array($ly, arr#0) == JSON_mSpec.__default.Array($LZ, arr#0));

function JSON_mSpec.__default.Array#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSpec.__default.Array#requires($ly, arr#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON())) ==> (JSON_mSpec.__default.Array#requires($ly, arr#0) <==> true));

procedure {:verboseName "JSON.Spec.Array (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Array(arr#0: Seq where $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.Array (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.Array(arr#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var i#1: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##js#0: DatatypeType;
  var ##sep#0: Seq;
  var ##items#0: Seq;
  var middle#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.Array", " | ", arr#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(134,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mSpec.__default.Array($LS($LZ), arr#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon14_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##s#0 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))));
    assume 0 <= Seq#Length(arr#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc i#1;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} true;
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= i#1;
    goto anon7;

  anon17_Else:
    assume {:partition} i#1 < LitInt(0);
    goto anon7;

  anon7:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} LitInt(0) <= i#1 && i#1 < Seq#Length(arr#0);
    assume 0 <= i#1 && i#1 < Seq#Length(arr#0);
    ##js#0 := $Unbox(Seq#Index(arr#0, i#1)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $lambdaHeap#0);
    assume DtRank(##js#0) < Seq#Rank(arr#0);
    assume JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, i#1)): DatatypeType);
    assume lambdaResult#0 == JSON_mSpec.__default.JSON($LS($LZ), $Unbox(Seq#Index(arr#0, i#1)): DatatypeType);
    assume JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, i#1)): DatatypeType);
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon9;

  anon18_Else:
    assume {:partition} !(LitInt(0) <= i#1 && i#1 < Seq#Length(arr#0));
    goto anon9;

  anon16_Else:
    assume {:partition} false;
    goto anon9;

  anon9:
    assume false;
    goto anon10;

  anon15_Else:
    goto anon10;

  anon10:
    assume {:subsumption 0} (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(arr#0) ==> Requires1(TInt, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#8#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#8#i#0): int)): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(arr#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0)));
    b$reqreads#0 := (forall seqinit#0#i0#0: int :: 0 <= seqinit#0#i0#0 && seqinit#0#i0#0 < Seq#Length(arr#0) ==> (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(TInt, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#8#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#8#i#0): int)): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: $IsBox($l#8#i#0, TInt) && LitInt(0) <= $Unbox($l#8#i#0): int && $Unbox($l#8#i#0): int < Seq#Length(arr#0)), (lambda $l#8#heap#0: Heap, $l#8#i#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), $Box(seqinit#0#i0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]));
    ##sep#0 := Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))));
    assume $IsAlloc(##sep#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##items#0 := Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#10#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#10#i#0): int)): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: $IsBox($l#10#i#0, TInt) && LitInt(0) <= $Unbox($l#10#i#0): int && $Unbox($l#10#i#0): int < Seq#Length(arr#0)), (lambda $l#10#heap#0: Heap, $l#10#i#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAlloc(##items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())), $Heap);
    assume JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#11#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#11#i#0): int)): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#i#0: Box :: $IsBox($l#11#i#0, TInt) && LitInt(0) <= $Unbox($l#11#i#0): int && $Unbox($l#11#i#0): int < Seq#Length(arr#0)), (lambda $l#11#heap#0: Heap, $l#11#i#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))));
    assume let#0#0#0 == JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#13#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#13#i#0): int)): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#i#0: Box :: $IsBox($l#13#i#0, TInt) && LitInt(0) <= $Unbox($l#13#i#0): int && $Unbox($l#13#i#0): int < Seq#Length(arr#0)), (lambda $l#13#heap#0: Heap, $l#13#i#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#14#i#0: int :: LitInt(0) <= $l#14#i#0 && $l#14#i#0 < Seq#Length(arr#0) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, $l#14#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#15#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#15#i#0): int)): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#i#0: Box :: $IsBox($l#15#i#0, TInt) && LitInt(0) <= $Unbox($l#15#i#0): int && $Unbox($l#15#i#0): int < Seq#Length(arr#0)), (lambda $l#15#heap#0: Heap, $l#15#i#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mSpec.__default.Array($LS($LZ), arr#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mSpec.__default.Array($LS($LZ), arr#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon13;

  anon19_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc middle#Z#0;
    assume $Is(middle#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(middle#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume middle#Z#0 == let#1#0#0;
    ##s#1 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))));
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##s#1, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) < 128);
    assume (forall i#2: int :: { $Unbox(Seq#Index(##s#1, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#2)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91)))));
    ##s#2 := Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))));
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#3: int :: { $Unbox(Seq#Index(##s#2, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) < 128);
    assume (forall i#3: int :: { $Unbox(Seq#Index(##s#2, i#3)): char } LitInt(0) <= i#3 && i#3 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#3)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93)))));
    assume JSON_mSpec.__default.Array($LS($LZ), arr#0) == #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#Z#0), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93)))));
    assume $Is(JSON_mSpec.__default.Array($LS($LZ), arr#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon13;

  anon13:
    assume b$reqreads#0;
    return;
}



function JSON_mSpec.__default.JSON($ly: LayerType, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($ly, js#0) } JSON_mSpec.__default.JSON#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSpec.__default.JSON($ly, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($LS($ly), js#0) } JSON_mSpec.__default.JSON#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> (JSON_mValues.JSON.Null_q(js#0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!JSON_mValues.JSON.Null_q(js#0) ==> (JSON_mValues.JSON.Bool_q(js#0) ==> (var b#1 := JSON_mValues.JSON.b(js#0); (b#1 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#1 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!JSON_mValues.JSON.Bool_q(js#0) ==> (JSON_mValues.JSON.String_q(js#0) ==> (var str#1 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String#canCall(str#1))) && (!JSON_mValues.JSON.String_q(js#0) ==> (JSON_mValues.JSON.Number_q(js#0) ==> (var dec#1 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number#canCall(dec#1))) && (!JSON_mValues.JSON.Number_q(js#0) ==> (JSON_mValues.JSON.Object_q(js#0) ==> (var obj#1 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object#canCall(obj#1))) && (!JSON_mValues.JSON.Object_q(js#0) ==> (var arr#1 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array#canCall(arr#1))))))) && JSON_mSpec.__default.JSON($LS($ly), js#0) == (if JSON_mValues.JSON.Null_q(js#0) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(js#0) then (var b#0 := JSON_mValues.JSON.b(js#0); #Wrappers.Result.Success($Box((if b#0 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(js#0) then (var str#0 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String(str#0)) else (if JSON_mValues.JSON.Number_q(js#0) then (var dec#0 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number(dec#0)) else (if JSON_mValues.JSON.Object_q(js#0) then (var obj#0 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object($ly, obj#0)) else (var arr#0 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array($ly, arr#0))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) } JSON_mSpec.__default.JSON#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> (Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (var b#3 := Lit(JSON_mValues.JSON.b(Lit(js#0))); (b#3 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#3 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (var str#3 := Lit(JSON_mValues.JSON.str(Lit(js#0))); JSON_mSpec.__default.String#canCall(str#3))) && (!Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (var dec#3 := Lit(JSON_mValues.JSON.num(Lit(js#0))); JSON_mSpec.__default.Number#canCall(dec#3))) && (!Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var obj#3 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); JSON_mSpec.__default.Object#canCall(obj#3))) && (!Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var arr#3 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); JSON_mSpec.__default.Array#canCall(arr#3))))))) && JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) == (if JSON_mValues.JSON.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(Lit(js#0)) then (var b#2 := Lit(JSON_mValues.JSON.b(Lit(js#0))); #Wrappers.Result.Success($Box((if b#2 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(Lit(js#0)) then (var str#2 := Lit(JSON_mValues.JSON.str(Lit(js#0))); Lit(JSON_mSpec.__default.String(str#2))) else (if JSON_mValues.JSON.Number_q(Lit(js#0)) then (var dec#2 := Lit(JSON_mValues.JSON.num(Lit(js#0))); Lit(JSON_mSpec.__default.Number(dec#2))) else (if JSON_mValues.JSON.Object_q(Lit(js#0)) then (var obj#2 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); Lit(JSON_mSpec.__default.Object($LS($ly), obj#2))) else (var arr#2 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); Lit(JSON_mSpec.__default.Array($LS($ly), arr#2)))))))));
}

function JSON_mSpec.__default.JSON#canCall(js#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($LS($ly), js#0) } JSON_mSpec.__default.JSON($LS($ly), js#0) == JSON_mSpec.__default.JSON($ly, js#0));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON(AsFuelBottom($ly), js#0) } JSON_mSpec.__default.JSON($ly, js#0) == JSON_mSpec.__default.JSON($LZ, js#0));

function JSON_mSpec.__default.JSON#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON#requires($ly, js#0) } $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mSpec.__default.JSON#requires($ly, js#0) <==> true));

procedure {:verboseName "JSON.Spec.JSON (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.JSON(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Spec.JSON (well-formedness)"} CheckWellformed$$JSON_mSpec.__default.JSON(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#4#0: Seq;
  var arr#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##arr#0: Seq;
  var _mcc#3#0: Seq;
  var obj#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##obj#0: Seq;
  var _mcc#2#0: DatatypeType;
  var dec#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##dec#0: DatatypeType;
  var _mcc#1#0: Seq;
  var str#Z#0: Seq;
  var let#3#0#0: Seq;
  var ##str#0: Seq;
  var _mcc#0#0: bool;
  var b#Z#0: bool;
  var let#4#0#0: bool;
  var ##s#0: Seq;
  var ##s#1: Seq;
  var ##s#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Spec.JSON", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Spec.dfy(139,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Null();
    ##s#2 := Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108))));
    assume $IsAlloc(##s#2, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#2: int :: { $Unbox(Seq#Index(##s#2, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) < 128);
    assume (forall i#2: int :: { $Unbox(Seq#Index(##s#2, i#2)): char } LitInt(0) <= i#2 && i#2 < Seq#Length(##s#2) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) && char#ToInt($Unbox(Seq#Index(##s#2, i#2)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))));
    assume JSON_mSpec.__default.JSON($LS($LZ), js#0) == Lit(#Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))));
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))));
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon15_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Null();
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Bool(_mcc#0#0);
    havoc b#Z#0;
    assume true;
    assume let#4#0#0 <==> _mcc#0#0;
    assume true;
    assume $Is(let#4#0#0, TBool);
    assume b#Z#0 <==> let#4#0#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} b#Z#0;
    ##s#0 := Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))));
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume (forall i#0: int :: { $Unbox(Seq#Index(##s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(##s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(##s#0, i#0)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))));
    goto anon8;

  anon17_Else:
    assume {:partition} !b#Z#0;
    ##s#1 := Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))));
    assume $IsAlloc(##s#1, TSeq(TChar), $Heap);
    assume {:subsumption 0} (forall i#1: int :: { $Unbox(Seq#Index(##s#1, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) < 128);
    assume (forall i#1: int :: { $Unbox(Seq#Index(##s#1, i#1)): char } LitInt(0) <= i#1 && i#1 < Seq#Length(##s#1) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) && char#ToInt($Unbox(Seq#Index(##s#1, i#1)): char) < 128);
    assume UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))));
    goto anon8;

  anon8:
    assume JSON_mSpec.__default.JSON($LS($LZ), js#0) == #Wrappers.Result.Success($Box((if b#Z#0 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))));
    assume (b#Z#0 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#Z#0 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))));
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon16_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Bool(_mcc#0#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.String(_mcc#1#0);
    assume $Is(_mcc#1#0, TSeq(TChar));
    havoc str#Z#0;
    assume $Is(str#Z#0, TSeq(TChar)) && $IsAlloc(str#Z#0, TSeq(TChar), $Heap);
    assume let#3#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#3#0#0, TSeq(TChar));
    assume str#Z#0 == let#3#0#0;
    ##str#0 := str#Z#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    assume JSON_mSpec.__default.String#canCall(str#Z#0);
    assume JSON_mSpec.__default.JSON($LS($LZ), js#0) == JSON_mSpec.__default.String(str#Z#0);
    assume JSON_mSpec.__default.String#canCall(str#Z#0);
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon18_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.String(_mcc#1#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Number(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mValues.Decimal());
    havoc dec#Z#0;
    assume $Is(dec#Z#0, Tclass.JSON_mValues.Decimal()) && $IsAlloc(dec#Z#0, Tclass.JSON_mValues.Decimal(), $Heap);
    assume let#2#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mValues.Decimal());
    assume dec#Z#0 == let#2#0#0;
    ##dec#0 := dec#Z#0;
    assume $IsAlloc(##dec#0, Tclass.JSON_mValues.Decimal(), $Heap);
    assume JSON_mSpec.__default.Number#canCall(dec#Z#0);
    assume JSON_mSpec.__default.JSON($LS($LZ), js#0) == JSON_mSpec.__default.Number(dec#Z#0);
    assume JSON_mSpec.__default.Number#canCall(dec#Z#0);
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon19_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Number(_mcc#2#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Object(_mcc#3#0);
    assume $Is(_mcc#3#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
    havoc obj#Z#0;
    assume $Is(obj#Z#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) && $IsAlloc(obj#Z#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $Heap);
    assume let#1#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#1#0#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
    assume obj#Z#0 == let#1#0#0;
    ##obj#0 := obj#Z#0;
    assume $IsAlloc(##obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $Heap);
    assume Seq#Rank(##obj#0) < DtRank(js#0);
    assume JSON_mSpec.__default.Object#canCall(obj#Z#0);
    assume JSON_mSpec.__default.JSON($LS($LZ), js#0) == JSON_mSpec.__default.Object($LS($LZ), obj#Z#0);
    assume JSON_mSpec.__default.Object#canCall(obj#Z#0);
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon20_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Object(_mcc#3#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Array(_mcc#4#0);
    assume $Is(_mcc#4#0, TSeq(Tclass.JSON_mValues.JSON()));
    havoc arr#Z#0;
    assume $Is(arr#Z#0, TSeq(Tclass.JSON_mValues.JSON())) && $IsAlloc(arr#Z#0, TSeq(Tclass.JSON_mValues.JSON()), $Heap);
    assume let#0#0#0 == _mcc#4#0;
    assume true;
    assume $Is(let#0#0#0, TSeq(Tclass.JSON_mValues.JSON()));
    assume arr#Z#0 == let#0#0#0;
    ##arr#0 := arr#Z#0;
    assume $IsAlloc(##arr#0, TSeq(Tclass.JSON_mValues.JSON()), $Heap);
    assume Seq#Rank(##arr#0) < DtRank(js#0);
    assume JSON_mSpec.__default.Array#canCall(arr#Z#0);
    assume JSON_mSpec.__default.JSON($LS($LZ), js#0) == JSON_mSpec.__default.Array($LS($LZ), arr#Z#0);
    assume JSON_mSpec.__default.Array#canCall(arr#Z#0);
    assume $Is(JSON_mSpec.__default.JSON($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon21_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Array(_mcc#4#0);
    assume false;
    return;
}



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#184 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#184))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#186 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#186)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#276 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#276))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#278 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#278)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#280 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#280)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#276 := Wrappers.Option.value(this); v#276)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#278 := Lit(Wrappers.Option.value(Lit(this))); v#278)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#280 := Lit(Wrappers.Option.value(Lit(this))); v#280)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#184 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#184)) else (var e#184 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#186 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#186))) else (var e#186 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#276 := Wrappers.Result.value(this); s#276) else (var e#276 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#278 := Lit(Wrappers.Result.value(Lit(this))); s#278) else (var e#278 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#280 := Lit(Wrappers.Result.value(Lit(this))); s#280) else (var e#280 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#276 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#276)) else (var e#276 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#276)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#278 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#278))) else (var e#278 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#278)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#280 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#280))) else (var e#280 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#280)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#24: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#24, x#24)): bool } $IsBox(x#24, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#24, x#24)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#25: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#25, x#25)): bool } $IsBox(x#25, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#25, x#25)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#24: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#24, x#24)): bool } $IsBox(x#24, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#24, x#24)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#25: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#25, x#25)): bool } $IsBox(x#25, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#25, x#25)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#24: Box, y#24: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#24, x#24)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#24, y#24)): bool } $IsBox(x#24, Relations._default.AntiSymmetric$T) && $IsBox(y#24, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#24, y#24)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#24, x#24)): bool ==> x#24 == y#24)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#25: Box, y#25: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#25, x#25)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#25, y#25)): bool } $IsBox(x#25, Relations._default.AntiSymmetric$T) && $IsBox(y#25, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#25, y#25)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#25, x#25)): bool ==> x#25 == y#25)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#24: Box, y#24: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#24, x#24)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#24, y#24)): bool } $IsBox(x#24, Relations._default.Symmetric$T) && $IsBox(y#24, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#24, y#24)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#24, x#24)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#25: Box, y#25: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#25, x#25)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#25, y#25)): bool } $IsBox(x#25, Relations._default.Symmetric$T) && $IsBox(y#25, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#25, y#25)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#25, x#25)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#24: Box, y#24: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#24, x#24)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#24, y#24)): bool } $IsBox(x#24, Relations._default.Connected$T) && $IsBox(y#24, Relations._default.Connected$T) ==> x#24 != y#24 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#24, y#24)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#24, x#24)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#25: Box, y#25: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#25, x#25)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#25, y#25)): bool } $IsBox(x#25, Relations._default.Connected$T) && $IsBox(y#25, Relations._default.Connected$T) ==> x#25 != y#25 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#25, y#25)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#25, x#25)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#24: Box, y#24: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#24, x#24)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#24, y#24)): bool } $IsBox(x#24, Relations._default.StronglyConnected$T) && $IsBox(y#24, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#24, y#24)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#24, x#24)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#25: Box, y#25: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#25, x#25)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#25, y#25)): bool } $IsBox(x#25, Relations._default.StronglyConnected$T) && $IsBox(y#25, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#25, y#25)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#25, x#25)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#24: Box, y#24: Box, z#24: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#24, z#24)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#24, z#24)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#24, z#24)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#24, y#24)): bool } $IsBox(x#24, Relations._default.Transitive$T) && $IsBox(y#24, Relations._default.Transitive$T) && $IsBox(z#24, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#24, y#24)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#24, z#24)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#24, z#24)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#25: Box, y#25: Box, z#25: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#25, z#25)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#25, z#25)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#25, z#25)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#25, y#25)): bool } $IsBox(x#25, Relations._default.Transitive$T) && $IsBox(y#25, Relations._default.Transitive$T) && $IsBox(z#25, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#25, y#25)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#25, z#25)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#25, z#25)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#35: int, j#35: int :: { Seq#Index(a#0, j#35), Seq#Index(a#0, i#35) } LitInt(0) <= i#35 && i#35 < j#35 && j#35 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#35), Seq#Index(a#0, j#35))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#36: int, j#36: int :: { Seq#Index(a#0, j#36), Seq#Index(a#0, i#36) } LitInt(0) <= i#36 && i#36 < j#36 && j#36 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#36), Seq#Index(Lit(a#0), j#36))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#37: int, j#37: int :: { Seq#Index(a#0, j#37), Seq#Index(a#0, i#37) } LitInt(0) <= i#37 && i#37 < j#37 && j#37 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#37), Seq#Index(Lit(a#0), j#37))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#35: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#35)): bool } { s#0[x#35] } $IsBox(x#35, Relations._default.IsLeast$T) && s#0[x#35] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#35)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#36: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#36)): bool } { s#0[x#36] } $IsBox(x#36, Relations._default.IsLeast$T) && Lit(s#0)[x#36] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#36)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#37: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#37)): bool } { s#0[x#37] } $IsBox(x#37, Relations._default.IsLeast$T) && Lit(s#0)[x#37] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#37)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#35: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#35)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#35, min#0)): bool } { s#0[x#35] } $IsBox(x#35, Relations._default.IsMinimal$T) && s#0[x#35] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#35, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#35)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#36: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#36)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#36, min#0)): bool } { s#0[x#36] } $IsBox(x#36, Relations._default.IsMinimal$T) && Lit(s#0)[x#36] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#36, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#36)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#37: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#37)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#37, min#0)): bool } { s#0[x#37] } $IsBox(x#37, Relations._default.IsMinimal$T) && Lit(s#0)[x#37] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#37, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#37)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#35: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#35, max#0)): bool } { s#0[x#35] } $IsBox(x#35, Relations._default.IsGreatest$T) && s#0[x#35] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#35, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#36: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#36, max#0)): bool } { s#0[x#36] } $IsBox(x#36, Relations._default.IsGreatest$T) && Lit(s#0)[x#36] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#36, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#37: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#37, max#0)): bool } { s#0[x#37] } $IsBox(x#37, Relations._default.IsGreatest$T) && Lit(s#0)[x#37] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#37, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#35: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#35, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#35)): bool } { s#0[x#35] } $IsBox(x#35, Relations._default.IsMaximal$T) && s#0[x#35] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#35)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#35, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#36: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#36, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#36)): bool } { s#0[x#36] } $IsBox(x#36, Relations._default.IsMaximal$T) && Lit(s#0)[x#36] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#36)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#36, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#37: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#37, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#37)): bool } { s#0[x#37] } $IsBox(x#37, Relations._default.IsMaximal$T) && Lit(s#0)[x#37] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#37)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#37, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#30 := Div(Seq#Length(a#0), LitInt(2)); (var left#30, right#30 := Seq#Take(a#0, splitIndex#30), Seq#Drop(a#0, splitIndex#30); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#30, lessThanOrEq#0) && (var leftSorted#30 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#30, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#30, lessThanOrEq#0) && (var rightSorted#30 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#30, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#30, rightSorted#30, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#30 := Div(Seq#Length(a#0), LitInt(2)); (var left#30, right#30 := Seq#Take(a#0, splitIndex#30), Seq#Drop(a#0, splitIndex#30); (var leftSorted#30 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#30, lessThanOrEq#0); (var rightSorted#30 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#30, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#30, rightSorted#30, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#31 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#31, right#31 := Seq#Take(Lit(a#0), splitIndex#31), Seq#Drop(Lit(a#0), splitIndex#31); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#31, lessThanOrEq#0) && (var leftSorted#31 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#31, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#31, lessThanOrEq#0) && (var rightSorted#31 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#31, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#31, rightSorted#31, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#31 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#31, right#31 := Seq#Take(Lit(a#0), splitIndex#31), Seq#Drop(Lit(a#0), splitIndex#31); (var leftSorted#31 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#31, lessThanOrEq#0); (var rightSorted#31 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#31, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#31, rightSorted#31, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#32 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#32, right#32 := Seq#Take(Lit(a#0), splitIndex#32), Seq#Drop(Lit(a#0), splitIndex#32); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#32, Lit(lessThanOrEq#0)) && (var leftSorted#32 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#32, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#32, Lit(lessThanOrEq#0)) && (var rightSorted#32 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#32, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#32, rightSorted#32, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#32 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#32, right#32 := Seq#Take(Lit(a#0), splitIndex#32), Seq#Drop(Lit(a#0), splitIndex#32); (var leftSorted#32 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#32, Lit(lessThanOrEq#0)); (var rightSorted#32 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#32, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#32, rightSorted#32, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#20: Box :: $IsBox($y#20, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#20)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#21: Box :: $IsBox($y#21, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#21)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#20: int, j#20: int :: { Seq#Index(xs#0, j#20), Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) && LitInt(0) <= j#20 && j#20 < Seq#Length(xs#0) && i#20 != j#20 ==> Seq#Index(xs#0, i#20) != Seq#Index(xs#0, j#20))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#21: int, j#21: int :: { Seq#Index(xs#0, j#21), Seq#Index(xs#0, i#21) } LitInt(0) <= i#21 && i#21 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#21 && j#21 < Seq#Length(Lit(xs#0)) && i#21 != j#21 ==> Seq#Index(Lit(xs#0), i#21) != Seq#Index(Lit(xs#0), j#21))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#11: int :: { Seq#Index(xs#0, j#11) } LitInt(0) <= j#11 && j#11 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#11) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#11: int :: { Seq#Index(xs#0, j#11) } LitInt(0) <= j#11 && j#11 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#11) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#27 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#27) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#27)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#28 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#28) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#28)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#29 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#29) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#29)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#11: int :: { Seq#Index(xs#0, j#11) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#11 && j#11 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#11) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#11: int :: { Seq#Index(xs#0, j#11) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#11 && j#11 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#11) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#22: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#22), Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#22) == Seq#Index(xs#0, i#22)) && (forall i#23: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#23) } pos#0 <= i#23 && i#23 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#23) == Seq#Index(xs#0, i#23 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#27 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#27), Seq#Drop(xs#0, i#27 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#28 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#28), Seq#Drop(Lit(xs#0), i#28 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#29 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#29), Seq#Drop(Lit(xs#0), i#29 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#22: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#22), Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#22) == Seq#Index(xs#0, i#22)) && (forall i#23: int :: { Seq#Index(xs#0, i#23) } pos#0 <= i#23 && i#23 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#23 + 1) == Seq#Index(xs#0, i#23)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#11: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#11) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#11 - 1) } LitInt(0) <= i#11 && i#11 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#11) == Seq#Index(xs#0, Seq#Length(xs#0) - i#11 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#11: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#11) } LitInt(0) <= i#11 && i#11 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#11) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#11: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#11) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#11) } LitInt(0) <= i#11 && i#11 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#11), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#11)), $Unbox(Seq#Index(xs#0, i#11)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#18, b#18 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#18, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#18, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#19, b#19 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#19, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#19, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#11: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#11)): DatatypeType } LitInt(0) <= i#11 && i#11 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#11)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#11), Seq#Index(ys#0, i#11)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#11: int :: { Seq#Contains(xs#0, $Box(k#11)) } Seq#Contains(xs#0, $Box(k#11)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#11) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#11: int :: { Seq#Contains(xs#0, $Box(k#11)) } Seq#Contains(xs#0, $Box(k#11)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#11) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#40: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#40) } LitInt(0) <= i#40 && i#40 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#40) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#40))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#41: int :: { Seq#Index(xs#0, i#41) } LitInt(0) <= i#41 && i#41 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#41)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#41: int :: { Seq#Index(xs#0, i#41) } LitInt(0) <= i#41 && i#41 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#41)))) ==> (forall $l#23#i#0: int :: LitInt(0) <= $l#23#i#0 ==> $l#23#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#23#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#22#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#22#i#0): int))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $IsBox($l#22#i#0, TInt) && LitInt(0) <= $Unbox($l#22#i#0): int && $Unbox($l#22#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#22#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#22#i#0): int))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: (exists i#42: int, o#17: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#22#heap#0, f#0, Seq#Index(xs#0, i#42))[$Box(o#17)] } $Is(o#17, Tclass._System.object?()) && LitInt(0) <= i#42 && i#42 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#22#heap#0, f#0, Seq#Index(xs#0, i#42))[$Box(o#17)] && $Box($l#22#o#0) == $Box(o#17))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#29: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#29) } { Seq#Index(xs#0, i#29) } (LitInt(0) <= i#29 && i#29 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#29))): DatatypeType)) && (LitInt(0) <= i#29 && i#29 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#29) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#29))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#30: int :: { Seq#Index(xs#0, i#30) } LitInt(0) <= i#30 && i#30 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#30)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#30: int :: { Seq#Index(xs#0, i#30) } LitInt(0) <= i#30 && i#30 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#30)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#9 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#9) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#9) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#9 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#9) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#9)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#9) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#9)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#9 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#9) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#9) else (var head#9 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#9); (var valueOrError1#9 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#9) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#9) else (var tail#9 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#9)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#9), tail#9)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#29: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#29) } LitInt(0) <= i#29 ==> i#29 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#29)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#29))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#30: int :: { Seq#Index(xs#0, i#30) } LitInt(0) <= i#30 && i#30 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#30)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#30: int :: { Seq#Index(xs#0, i#30) } LitInt(0) <= i#30 && i#30 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#30)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#20: Box, xs#20: Seq, b#20: Box, b'#20: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#20, x#20, b'#20)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#20), xs#20) } $IsBox(x#20, Seq._default.InvFoldLeft$A) && $Is(xs#20, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#20, Seq._default.InvFoldLeft$B) && $IsBox(b'#20, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#20, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#20), xs#20)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#20, x#20, b'#20)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#20, $Box(xs#20))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#21: Box, xs#21: Seq, b#21: Box, b'#21: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#21, x#21, b'#21)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#21), xs#21) } $IsBox(x#21, Seq._default.InvFoldLeft$A) && $Is(xs#21, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#21, Seq._default.InvFoldLeft$B) && $IsBox(b'#21, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#21, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#21), xs#21)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#21, x#21, b'#21)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#21, $Box(xs#21))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#20: Box, xs#20: Seq, b#20: Box, b'#20: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#20), xs#20), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#20, b#20, b'#20)): bool } $IsBox(x#20, Seq._default.InvFoldRight$A) && $Is(xs#20, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#20, Seq._default.InvFoldRight$B) && $IsBox(b'#20, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#20), b#20)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#20, b#20, b'#20)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#20), xs#20)), b'#20)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#21: Box, xs#21: Seq, b#21: Box, b'#21: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#21), xs#21), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#21, b#21, b'#21)): bool } $IsBox(x#21, Seq._default.InvFoldRight$A) && $Is(xs#21, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#21, Seq._default.InvFoldRight$B) && $IsBox(b'#21, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#21), b#21)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#21, b#21, b'#21)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#21), xs#21)), b'#21)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#18: int :: { Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#18)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#18: int :: { Seq#Index(xs#0, i#18) } LitInt(0) <= i#18 && i#18 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#18)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#10 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#10)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#11 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#11)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#7: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#7) } $IsBox(x#7, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#7))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#7: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#7) } $IsBox(x#7, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#7))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#7: Box, x2#7: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#7), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#7) } $IsBox(x1#7, Functions._default.Injective$X) && $IsBox(x2#7, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#7) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#7) ==> x1#7 == x2#7)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#12: int :: { Seq#Take(s#0, i#12) } 0 < i#12 && i#12 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#12))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> (Seq#Length(s#0) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(2) ==> (Seq#Length(s#0) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(3) ==> Seq#Length(s#0) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0)))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then (var b#17 := Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0); b#17) else (if Seq#Length(s#0) == LitInt(2) then (var b#18 := Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#18) else (if Seq#Length(s#0) == LitInt(3) then (var b#19 := Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0); b#19) else (if Seq#Length(s#0) == LitInt(4) then (var b#20 := Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0); b#20) else false))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> (Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(2) ==> (Seq#Length(Lit(s#0)) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(3) ==> Seq#Length(Lit(s#0)) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0))))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then (var b#21 := Lit(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0))); b#21) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#22 := Lit(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#22) else (if Seq#Length(Lit(s#0)) == LitInt(3) then (var b#23 := Lit(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0))); b#23) else (if Seq#Length(Lit(s#0)) == LitInt(4) then (var b#24 := Lit(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0))); b#24) else false))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstByte#4 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#4) && le_bv8(firstByte#4, 127bv8))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#5) && le_bv8(firstByte#5, 127bv8))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstByte#4 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#4 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#4) && le_bv8(firstByte#4, 223bv8) && le_bv8(128bv8, secondByte#4) && le_bv8(secondByte#4, 191bv8)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; le_bv8(194bv8, firstByte#5) && le_bv8(firstByte#5, 223bv8) && le_bv8(128bv8, secondByte#5) && le_bv8(secondByte#5, 191bv8)))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> (var firstByte#4 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#4 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#4 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; ((firstByte#4 == Lit(224bv8) && le_bv8(160bv8, secondByte#4) && le_bv8(secondByte#4, 191bv8)) || (le_bv8(225bv8, firstByte#4) && le_bv8(firstByte#4, 236bv8) && le_bv8(128bv8, secondByte#4) && le_bv8(secondByte#4, 191bv8)) || (firstByte#4 == Lit(237bv8) && le_bv8(128bv8, secondByte#4) && le_bv8(secondByte#4, 159bv8)) || (le_bv8(238bv8, firstByte#4) && le_bv8(firstByte#4, 239bv8) && le_bv8(128bv8, secondByte#4) && le_bv8(secondByte#4, 191bv8))) && le_bv8(128bv8, thirdByte#4) && le_bv8(thirdByte#4, 191bv8))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; ((firstByte#5 == Lit(224bv8) && le_bv8(160bv8, secondByte#5) && le_bv8(secondByte#5, 191bv8)) || (le_bv8(225bv8, firstByte#5) && le_bv8(firstByte#5, 236bv8) && le_bv8(128bv8, secondByte#5) && le_bv8(secondByte#5, 191bv8)) || (firstByte#5 == Lit(237bv8) && le_bv8(128bv8, secondByte#5) && le_bv8(secondByte#5, 159bv8)) || (le_bv8(238bv8, firstByte#5) && le_bv8(firstByte#5, 239bv8) && le_bv8(128bv8, secondByte#5) && le_bv8(secondByte#5, 191bv8))) && le_bv8(128bv8, thirdByte#5) && le_bv8(thirdByte#5, 191bv8))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> (var firstByte#4 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#4 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#4 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#4 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; ((firstByte#4 == Lit(240bv8) && le_bv8(144bv8, secondByte#4) && le_bv8(secondByte#4, 191bv8)) || (le_bv8(241bv8, firstByte#4) && le_bv8(firstByte#4, 243bv8) && le_bv8(128bv8, secondByte#4) && le_bv8(secondByte#4, 191bv8)) || (firstByte#4 == Lit(244bv8) && le_bv8(128bv8, secondByte#4) && le_bv8(secondByte#4, 143bv8))) && le_bv8(128bv8, thirdByte#4) && le_bv8(thirdByte#4, 191bv8) && le_bv8(128bv8, fourthByte#4) && le_bv8(fourthByte#4, 191bv8)))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; (var fourthByte#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(3))): bv8; ((firstByte#5 == Lit(240bv8) && le_bv8(144bv8, secondByte#5) && le_bv8(secondByte#5, 191bv8)) || (le_bv8(241bv8, firstByte#5) && le_bv8(firstByte#5, 243bv8) && le_bv8(128bv8, secondByte#5) && le_bv8(secondByte#5, 191bv8)) || (firstByte#5 == Lit(244bv8) && le_bv8(128bv8, secondByte#5) && le_bv8(secondByte#5, 143bv8))) && le_bv8(128bv8, thirdByte#5) && le_bv8(thirdByte#5, 191bv8) && le_bv8(128bv8, fourthByte#5) && le_bv8(fourthByte#5, 191bv8)))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#8: int :: { Seq#Take(s#0, i#8) } 0 < i#8 && i#8 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#8))) <==> true && Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#3 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#3) && Seq#Length(prefix#3) <= Seq#Length(s#0) && Seq#Equal(prefix#3, Seq#Take(s#0, Seq#Length(prefix#3))) && (forall i#9: int :: { Seq#Take(s#0, i#9) } 0 < i#9 && i#9 < Seq#Length(prefix#3) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#9))))) && $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == (var x#4 := and_bv24(v#0, 127bv24)[7:0]; (var firstByte#5 := (0bv1 ++ x#4): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#5)))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) == (var x#5 := Lit(and_bv24(v#0, 127bv24))[7:0]; (var firstByte#6 := (0bv1 ++ x#5): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#6)))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == (var x#4 := and_bv24(v#0, 63bv24)[6:0]; (var y#4 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#5 := or_bv8(192bv8, (0bv3 ++ y#4): bv8); (var secondByte#5 := or_bv8(128bv8, (0bv2 ++ x#4): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#5)), $Box(secondByte#5)))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) == (var x#5 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#5 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#6 := or_bv8(192bv8, (0bv3 ++ y#5): bv8); (var secondByte#6 := or_bv8(128bv8, (0bv2 ++ x#5): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#6)), $Box(secondByte#6)))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == (var x#4 := and_bv24(v#0, 63bv24)[6:0]; (var y#4 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#4 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#5 := or_bv8(224bv8, (0bv4 ++ z#4): bv8); (var secondByte#5 := or_bv8(128bv8, (0bv2 ++ y#4): bv8); (var thirdByte#5 := or_bv8(128bv8, (0bv2 ++ x#4): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#5)), $Box(secondByte#5)), $Box(thirdByte#5)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) == (var x#5 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#5 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#5 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#6 := or_bv8(224bv8, (0bv4 ++ z#5): bv8); (var secondByte#6 := or_bv8(128bv8, (0bv2 ++ y#5): bv8); (var thirdByte#6 := or_bv8(128bv8, (0bv2 ++ x#5): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#6)), $Box(secondByte#6)), $Box(thirdByte#6)))))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == (var x#4 := and_bv24(v#0, 63bv24)[6:0]; (var y#4 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#4 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#4 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#4 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#5 := or_bv8(240bv8, (0bv5 ++ u1#4): bv8); (var secondByte#5 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#4): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#4): bv8); (var thirdByte#5 := or_bv8(128bv8, (0bv2 ++ y#4): bv8); (var fourthByte#5 := or_bv8(128bv8, (0bv2 ++ x#4): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#5)), $Box(secondByte#5)), $Box(thirdByte#5)), $Box(fourthByte#5))))))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) == (var x#5 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#5 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#5 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#5 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#5 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#6 := or_bv8(240bv8, (0bv5 ++ u1#5): bv8); (var secondByte#6 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#5): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#5): bv8); (var thirdByte#6 := or_bv8(128bv8, (0bv2 ++ y#5): bv8); (var fourthByte#6 := or_bv8(128bv8, (0bv2 ++ x#5): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#6)), $Box(secondByte#6)), $Box(thirdByte#6)), $Box(fourthByte#6))))))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (var firstByte#4 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var x#4 := firstByte#4[7:0]; (0bv17 ++ x#4): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) == (var firstByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var x#5 := firstByte#5[7:0]; (0bv17 ++ x#5): bv24)));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == (var firstByte#4 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#4 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var y#4 := (0bv16 ++ and_bv8(firstByte#4, 31bv8)): bv24; (var x#4 := (0bv16 ++ and_bv8(secondByte#4, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#4, (0bv19 ++ 6bv5): bv24), x#4))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) == (var firstByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var y#5 := (0bv16 ++ and_bv8(firstByte#5, 31bv8)): bv24; (var x#5 := (0bv16 ++ and_bv8(secondByte#5, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#5, (0bv19 ++ 6bv5): bv24), x#5))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == (var firstByte#4 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#4 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#4 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var z#4 := (0bv16 ++ and_bv8(firstByte#4, 15bv8)): bv24; (var y#4 := (0bv16 ++ and_bv8(secondByte#4, 63bv8)): bv24; (var x#4 := (0bv16 ++ and_bv8(thirdByte#4, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#4, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#4, (0bv19 ++ 6bv5): bv24)), x#4))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) == (var firstByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var z#5 := (0bv16 ++ and_bv8(firstByte#5, 15bv8)): bv24; (var y#5 := (0bv16 ++ and_bv8(secondByte#5, 63bv8)): bv24; (var x#5 := (0bv16 ++ and_bv8(thirdByte#5, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#5, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#5, (0bv19 ++ 6bv5): bv24)), x#5))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == (var firstByte#4 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#4 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#4 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var fourthByte#4 := $Unbox(Seq#Index(m#0, LitInt(3))): bv8; (var u1#4 := (0bv16 ++ and_bv8(firstByte#4, 7bv8)): bv24; (var u2#4 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#4, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#4 := (0bv16 ++ and_bv8(secondByte#4, 15bv8)): bv24; (var y#4 := (0bv16 ++ and_bv8(thirdByte#4, 63bv8)): bv24; (var x#4 := (0bv16 ++ and_bv8(fourthByte#4, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#4, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#4, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#4, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#4, (0bv19 ++ 6bv5): bv24)), x#4)))))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) == (var firstByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var fourthByte#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(3))): bv8; (var u1#5 := (0bv16 ++ and_bv8(firstByte#5, 7bv8)): bv24; (var u2#5 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#5, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#5 := (0bv16 ++ and_bv8(secondByte#5, 15bv8)): bv24; (var y#5 := (0bv16 ++ and_bv8(thirdByte#5, 63bv8)): bv24; (var x#5 := (0bv16 ++ and_bv8(fourthByte#5, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#5, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#5, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#5, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#5, (0bv19 ++ 6bv5): bv24)), x#5)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#5 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#5)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) && (var prefix#5 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#5))) && (var valueOrError1#4 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#5))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#5 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#5) else (var prefix#5 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5)): Seq; (var valueOrError1#4 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#5))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) else (var restParts#4 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#5)), restParts#4)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#6 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#6)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) && (var prefix#6 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#6))) && (var valueOrError1#5 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#6))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#6 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#6) else (var prefix#6 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6)): Seq); (var valueOrError1#5 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#6))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) else (var restParts#5 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#6)), restParts#5)))))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) == $Box(Utf8EncodingForm.__default.EncodeScalarValue($Unbox($fh$2x#0): bv24)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) <==> Utf8EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$2x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue($fh$2x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.EncodeScalarValue($fh$2x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#4 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(8), ms#4)) && Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#4 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#4)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#5 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(8), ms#5)) && Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#5 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#5)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) } Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) == $Box(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$2x#0): Seq)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) } Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) <==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$2x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$2x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$2x#0) == $Unbox(Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$2x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#4 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#4)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#4 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#5 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#4); vs#5)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#5 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#5)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#5 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#6 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#5); vs#6)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#6: int :: { Seq#Take(s#0, i#6) } 0 < i#6 && i#6 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#6))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> Seq#Length(s#0) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#5 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#5) else false))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#6 := Lit(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#6) else false))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstWord#4 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#4) && le_bv16(firstWord#4, 55295bv16)) || (le_bv16(57344bv16, firstWord#4) && le_bv16(firstWord#4, 65535bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (le_bv16(0bv16, firstWord#5) && le_bv16(firstWord#5, 55295bv16)) || (le_bv16(57344bv16, firstWord#5) && le_bv16(firstWord#5, 65535bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstWord#4 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (var secondWord#4 := $Unbox(Seq#Index(s#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#4) && le_bv16(firstWord#4, 56319bv16) && le_bv16(56320bv16, secondWord#4) && le_bv16(secondWord#4, 57343bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (var secondWord#5 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv16; le_bv16(55296bv16, firstWord#5) && le_bv16(firstWord#5, 56319bv16) && le_bv16(56320bv16, secondWord#5) && le_bv16(secondWord#5, 57343bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#13: int :: { Seq#Take(s#0, i#13) } 0 < i#13 && i#13 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#13))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#6 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#6) && Seq#Length(prefix#6) <= Seq#Length(s#0) && Seq#Equal(prefix#6, Seq#Take(s#0, Seq#Length(prefix#6))) && (forall i#14: int :: { Seq#Take(s#0, i#14) } 0 < i#14 && i#14 < Seq#Length(prefix#6) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#14))))) && (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#15: int :: { Seq#Take(s#0, i#15) } 0 < i#15 && i#15 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#15))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#7 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#7) && Seq#Length(prefix#7) <= Seq#Length(s#0) && Seq#Equal(prefix#7, Seq#Take(s#0, Seq#Length(prefix#7))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#7))) && $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == (var firstWord#5 := v#0[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#5))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) == (var firstWord#6 := Lit(v#0)[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#6))));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == (var x2#4 := and_bv24(v#0, 1023bv24)[10:0]; (var x1#4 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#4 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#4 := sub_bv5(u#4, 1bv5)[4:0]; (var firstWord#5 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#4): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#4): bv16); (var secondWord#5 := or_bv16(56320bv16, (0bv6 ++ x2#4): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#5)), $Box(secondWord#5)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) == (var x2#5 := Lit(and_bv24(v#0, 1023bv24))[10:0]; (var x1#5 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#5 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#5 := sub_bv5(u#5, 1bv5)[4:0]; (var firstWord#6 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#5): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#5): bv16); (var secondWord#6 := or_bv16(56320bv16, (0bv6 ++ x2#5): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#6)), $Box(secondWord#6)))))))));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (var firstWord#4 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var x#4 := firstWord#4; (0bv8 ++ x#4): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) == (var firstWord#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var x#5 := firstWord#5; (0bv8 ++ x#5): bv24)));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == (var firstWord#4 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#4 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; (var x2#4 := (0bv8 ++ and_bv16(secondWord#4, 1023bv16)): bv24; (var x1#4 := (0bv8 ++ and_bv16(firstWord#4, 63bv16)): bv24; (var w#4 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#4, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#4 := add_bv24(w#4, 1bv24); (var v#5 := or_bv24(or_bv24(LeftShift_bv24(u#4, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#4, (0bv19 ++ 10bv5): bv24)), x2#4); v#5))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) == (var firstWord#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var secondWord#5 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv16; (var x2#5 := (0bv8 ++ and_bv16(secondWord#5, 1023bv16)): bv24; (var x1#5 := (0bv8 ++ and_bv16(firstWord#5, 63bv16)): bv24; (var w#5 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#5, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#5 := add_bv24(w#5, 1bv24); (var v#6 := or_bv24(or_bv24(LeftShift_bv24(u#5, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#5, (0bv19 ++ 10bv5): bv24)), x2#5); v#6))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#5 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#5)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) && (var prefix#5 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#5))) && (var valueOrError1#4 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#5))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#5 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#5) else (var prefix#5 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#5)): Seq; (var valueOrError1#4 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#5))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4) else (var restParts#4 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#4)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#5)), restParts#4)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#6 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#6)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) && (var prefix#6 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#6))) && (var valueOrError1#5 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#6))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#6 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#6) else (var prefix#6 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#6)): Seq); (var valueOrError1#5 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#6))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5) else (var restParts#5 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#5)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#6)), restParts#5)))))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) == $Box(Utf16EncodingForm.__default.EncodeScalarValue($Unbox($fh$2x#0): bv24)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0) <==> Utf16EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$2x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue($fh$2x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.EncodeScalarValue($fh$2x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#4 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(16), ms#4)) && Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#4 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#4)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#5 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(16), ms#5)) && Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#5 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#5)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) } Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) == $Box(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$2x#0): Seq)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) } Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0) <==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$2x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$2x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$2x#0) == $Unbox(Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$2x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#4 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#4)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#4 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#5 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#4); vs#5)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#5 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#5)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#5 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#6 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#5); vs#6)));

axiom (forall s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> Seq#Length(s#0) == LitInt(0) ==> UnicodeStrings.__default.IsWellFormedString(s#0));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#21#c#0): char)))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#22#c#0): char)))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TChar)), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))), s#0)) && (UnicodeStrings.__default.IsWellFormedString(s#0) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#19#c#0): char)))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, TChar)), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))), s#0))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.IsWellFormedString(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#25#c#0): char)))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar)), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#26#c#0): char)))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TChar)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (UnicodeStrings.__default.IsWellFormedString(Lit(s#0)) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#23#c#0): char)))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))));

axiom (forall s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> $Is(UnicodeStrings.__default.ToUTF8Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint8()))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#32#c#0): char)))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, TChar)), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))), s#0) && (var asCodeUnits#2 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#35#c#0): char)))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, TChar)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))), s#0); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#2) && (var valueOrError0#2 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#2); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) && (var utf32#2 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#2) && (var asUtf8CodeUnits#2 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#2); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(nat_from_bv8($Unbox($l#34#c#0): bv8))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, TBitvector(8))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#2)))))) && UnicodeStrings.__default.ToUTF8Checked(s#0) == (var asCodeUnits#2 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#29#c#0): char)))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))), s#0); (var valueOrError0#2 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#2); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var utf32#2 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2)): Seq; (var asUtf8CodeUnits#2 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#2); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(nat_from_bv8($Unbox($l#30#c#0): bv8))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TBitvector(8))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#2)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#39#c#0): char)))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, TChar)), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && (var asCodeUnits#3 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#42#c#0): char)))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, TChar)), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#3) && (var valueOrError0#3 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#3); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) && (var utf32#3 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#3) && (var asUtf8CodeUnits#3 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#3); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(nat_from_bv8($Unbox($l#41#c#0): bv8))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, TBitvector(8))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#3)))))) && UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)) == (var asCodeUnits#3 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#36#c#0): char)))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, TChar)), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); (var valueOrError0#3 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#3); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var utf32#3 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3)): Seq; (var asUtf8CodeUnits#3 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#3); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(nat_from_bv8($Unbox($l#37#c#0): bv8))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, TBitvector(8))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#3)))))))));

axiom (forall bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> $Is(UnicodeStrings.__default.FromUTF8Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar))));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(nat_to_bv8($Unbox($l#32#c#0): int))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))), bs#0) && (var asCodeUnits#2 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(nat_to_bv8($Unbox($l#35#c#0): int))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.BoundedInts.uint8())), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))), bs#0); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#2) && (var valueOrError0#2 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#2); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#2)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) && (var utf32#2 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#2) && (var asUtf16CodeUnits#2 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#2); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#34#cu#0): bv16)))), (lambda $l#34#heap#0: Heap, $l#34#cu#0: Box :: $IsBox($l#34#cu#0, TBitvector(16))), (lambda $l#34#heap#0: Heap, $l#34#cu#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#2)))))) && UnicodeStrings.__default.FromUTF8Checked(bs#0) == (var asCodeUnits#2 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(nat_to_bv8($Unbox($l#29#c#0): int))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint8())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))), bs#0); (var valueOrError0#2 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#2); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#2) else (var utf32#2 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#2)): Seq; (var asUtf16CodeUnits#2 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#2); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#30#cu#0): bv16)))), (lambda $l#30#heap#0: Heap, $l#30#cu#0: Box :: $IsBox($l#30#cu#0, TBitvector(16))), (lambda $l#30#heap#0: Heap, $l#30#cu#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#2)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(nat_to_bv8($Unbox($l#39#c#0): int))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.BoundedInts.uint8())), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && (var asCodeUnits#3 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(nat_to_bv8($Unbox($l#42#c#0): int))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.BoundedInts.uint8())), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#3) && (var valueOrError0#3 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#3); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#3)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) && (var utf32#3 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#3) && (var asUtf16CodeUnits#3 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#3); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#41#cu#0): bv16)))), (lambda $l#41#heap#0: Heap, $l#41#cu#0: Box :: $IsBox($l#41#cu#0, TBitvector(16))), (lambda $l#41#heap#0: Heap, $l#41#cu#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#3)))))) && UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)) == (var asCodeUnits#3 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(nat_to_bv8($Unbox($l#36#c#0): int))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); (var valueOrError0#3 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#3); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#3) else (var utf32#3 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#3)): Seq; (var asUtf16CodeUnits#3 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#3); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#37#cu#0): bv16)))), (lambda $l#37#heap#0: Heap, $l#37#cu#0: Box :: $IsBox($l#37#cu#0, TBitvector(16))), (lambda $l#37#heap#0: Heap, $l#37#cu#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#3)))))))));

axiom (forall s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || $Is(s#0, TSeq(TChar)) ==> $Is(UnicodeStrings.__default.ToUTF16Checked(s#0), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16()))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#34#c#0): char)))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, TChar)), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#35#c#0): char)))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, TChar)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))), s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#36#c#0): char)))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, TChar)), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), s#0)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(char#ToInt($Unbox($l#38#c#0): char))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, TChar)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))), s#0)) && UnicodeStrings.__default.ToUTF16Checked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#31#c#0): char)))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, TChar)), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), s#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(char#ToInt($Unbox($l#32#c#0): char))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, TChar)), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))), s#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#42#c#0): char)))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, TChar)), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#43#c#0): char)))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, TChar)), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#44#c#0): char)))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, TChar)), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(char#ToInt($Unbox($l#46#c#0): char))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, TChar)), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#39#c#0): char)))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, TChar)), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(char#ToInt($Unbox($l#40#c#0): char))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, TChar)), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))) else #Wrappers.Option.None()));

axiom (forall bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint16())) ==> $Is(UnicodeStrings.__default.FromUTF16Checked(bs#0), Tclass.Wrappers.Option(TSeq(TChar))));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(nat_to_bv16($Unbox($l#34#c#0): int))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.BoundedInts.uint16())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), bs#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(nat_to_bv16($Unbox($l#35#c#0): int))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.BoundedInts.uint16())), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))), bs#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(nat_to_bv16($Unbox($l#36#c#0): int))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint16())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), bs#0)) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(char#FromInt($Unbox($l#38#c#0): int))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.BoundedInts.uint16())), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))), bs#0)) && UnicodeStrings.__default.FromUTF16Checked(bs#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(nat_to_bv16($Unbox($l#31#c#0): int))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.BoundedInts.uint16())), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), bs#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(char#FromInt($Unbox($l#32#c#0): int))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint16())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))), bs#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(nat_to_bv16($Unbox($l#42#c#0): int))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.BoundedInts.uint16())), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(nat_to_bv16($Unbox($l#43#c#0): int))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint16())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(nat_to_bv16($Unbox($l#44#c#0): int))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.BoundedInts.uint16())), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(char#FromInt($Unbox($l#46#c#0): int))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint16())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(nat_to_bv16($Unbox($l#39#c#0): int))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.BoundedInts.uint16())), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(char#FromInt($Unbox($l#40#c#0): int))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.BoundedInts.uint16())), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)))) else #Wrappers.Option.None()));

axiom (forall s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)) ==> $Is(UnicodeStrings.__default.ASCIIToUTF8(s#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF8#requires(s#0) <==> (forall i#6: int :: { $Unbox(Seq#Index(s#0, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#6: int :: { $Unbox(Seq#Index(s#0, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(char#ToInt($Unbox($l#15#c#0): char))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#15#c#0): char) && char#ToInt($Unbox($l#15#c#0): char) < 128), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(char#ToInt($Unbox($l#13#c#0): char))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#13#c#0): char) && char#ToInt($Unbox($l#13#c#0): char) < 128), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#7: int :: { $Unbox(Seq#Index(s#0, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#7)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#7)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(char#ToInt($Unbox($l#18#c#0): char))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#18#c#0): char) && char#ToInt($Unbox($l#18#c#0): char) < 128), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(char#ToInt($Unbox($l#16#c#0): char))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#16#c#0): char) && char#ToInt($Unbox($l#16#c#0): char) < 128), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom (forall s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || ($Is(s#0, TSeq(TChar)) && (forall i#0: int :: { $Unbox(Seq#Index(s#0, i#0)): char } LitInt(0) <= i#0 && i#0 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#0)): char) < 128)) ==> $Is(UnicodeStrings.__default.ASCIIToUTF16(s#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF16#requires(s#0) <==> (forall i#6: int :: { $Unbox(Seq#Index(s#0, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#6: int :: { $Unbox(Seq#Index(s#0, i#6)): char } LitInt(0) <= i#6 && i#6 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#6)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(char#ToInt($Unbox($l#15#c#0): char))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#15#c#0): char) && char#ToInt($Unbox($l#15#c#0): char) < 128), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(char#ToInt($Unbox($l#13#c#0): char))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#13#c#0): char) && char#ToInt($Unbox($l#13#c#0): char) < 128), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#7: int :: { $Unbox(Seq#Index(s#0, i#7)): char } LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#7)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#7)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(char#ToInt($Unbox($l#18#c#0): char))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#18#c#0): char) && char#ToInt($Unbox($l#18#c#0): char) < 128), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(char#ToInt($Unbox($l#16#c#0): char))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#16#c#0): char) && char#ToInt($Unbox($l#16#c#0): char) < 128), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom MulInternals.__default.MulAuto() <==> (forall x#72: int, y#72: int :: { Mul(x#72, y#72) } Mul(x#72, y#72) == Mul(y#72, x#72)) && (forall x#73: int, y#73: int, z#48: int :: { Mul(x#73 + y#73, z#48) } Mul(x#73 + y#73, z#48) == Mul(x#73, z#48) + Mul(y#73, z#48)) && (forall x#74: int, y#74: int, z#49: int :: { Mul(x#74 - y#74, z#49) } Mul(x#74 - y#74, z#49) == Mul(x#74, z#49) - Mul(y#74, z#49));

axiom MulInternals.__default.MulAuto() <==> (forall x#75: int, y#75: int :: { Mul(x#75, y#75) } Mul(x#75, y#75) == Mul(y#75, x#75)) && (forall x#76: int, y#76: int, z#50: int :: { Mul(x#76 + y#76, z#50) } Mul(x#76 + y#76, z#50) == Mul(x#76, z#50) + Mul(y#76, z#50)) && (forall x#77: int, y#77: int, z#51: int :: { Mul(x#77 - y#77, z#51) } Mul(x#77 - y#77, z#51) == Mul(x#77, z#51) - Mul(y#77, z#51));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#80: int :: { Mod(Mod(x#80, n#0), n#0) } Mod(Mod(x#80, n#0), n#0) == Mod(x#80, n#0)) && (forall x#81: int :: { Mod(x#81, n#0) } LitInt(0) <= x#81 && x#81 < n#0 <==> Mod(x#81, n#0) == x#81) && (forall x#82: int, y#40: int :: { Mod(x#82 + y#40, n#0) } (var z#38 := Mod(x#82, n#0) + Mod(y#40, n#0); (LitInt(0) <= z#38 && z#38 < n#0 && Mod(x#82 + y#40, n#0) == z#38) || (n#0 <= z#38 && z#38 < n#0 + n#0 && Mod(x#82 + y#40, n#0) == z#38 - n#0))) && (forall x#83: int, y#41: int :: { Mod(x#83 - y#41, n#0) } (var z#39 := Mod(x#83, n#0) - Mod(y#41, n#0); (LitInt(0) <= z#39 && z#39 < n#0 && Mod(x#83 - y#41, n#0) == z#39) || (0 - n#0 <= z#39 && z#39 < 0 && Mod(x#83 - y#41, n#0) == z#39 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#84: int :: { Mod(Mod(x#84, n#0), n#0) } Mod(Mod(x#84, LitInt(n#0)), LitInt(n#0)) == Mod(x#84, LitInt(n#0))) && (forall x#85: int :: { Mod(x#85, n#0) } LitInt(0) <= x#85 && x#85 < n#0 <==> Mod(x#85, LitInt(n#0)) == x#85) && (forall x#86: int, y#42: int :: { Mod(x#86 + y#42, n#0) } (var z#40 := Mod(x#86, LitInt(n#0)) + Mod(y#42, LitInt(n#0)); (LitInt(0) <= z#40 && z#40 < n#0 && Mod(x#86 + y#42, LitInt(n#0)) == z#40) || (LitInt(n#0) <= z#40 && z#40 < n#0 + n#0 && Mod(x#86 + y#42, LitInt(n#0)) == z#40 - n#0))) && (forall x#87: int, y#43: int :: { Mod(x#87 - y#43, n#0) } (var z#41 := Mod(x#87, LitInt(n#0)) - Mod(y#43, LitInt(n#0)); (LitInt(0) <= z#41 && z#41 < n#0 && Mod(x#87 - y#43, LitInt(n#0)) == z#41) || (LitInt(0 - n#0) <= z#41 && z#41 < 0 && Mod(x#87 - y#43, LitInt(n#0)) == z#41 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#54: int :: { Div(x#54, n#0) } LitInt(0) <= x#54 && x#54 < n#0 <==> Div(x#54, n#0) == LitInt(0)) && (forall x#55: int, y#36: int :: { Div(x#55 + y#36, n#0) } (var z#34 := Mod(x#55, n#0) + Mod(y#36, n#0); (LitInt(0) <= z#34 && z#34 < n#0 && Div(x#55 + y#36, n#0) == Div(x#55, n#0) + Div(y#36, n#0)) || (n#0 <= z#34 && z#34 < n#0 + n#0 && Div(x#55 + y#36, n#0) == Div(x#55, n#0) + Div(y#36, n#0) + 1))) && (forall x#56: int, y#37: int :: { Div(x#56 - y#37, n#0) } (var z#35 := Mod(x#56, n#0) - Mod(y#37, n#0); (LitInt(0) <= z#35 && z#35 < n#0 && Div(x#56 - y#37, n#0) == Div(x#56, n#0) - Div(y#37, n#0)) || (0 - n#0 <= z#35 && z#35 < 0 && Div(x#56 - y#37, n#0) == Div(x#56, n#0) - Div(y#37, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#57: int :: { Div(x#57, n#0) } LitInt(0) <= x#57 && x#57 < n#0 <==> Div(x#57, LitInt(n#0)) == LitInt(0)) && (forall x#58: int, y#38: int :: { Div(x#58 + y#38, n#0) } (var z#36 := Mod(x#58, LitInt(n#0)) + Mod(y#38, LitInt(n#0)); (LitInt(0) <= z#36 && z#36 < n#0 && Div(x#58 + y#38, LitInt(n#0)) == Div(x#58, LitInt(n#0)) + Div(y#38, LitInt(n#0))) || (LitInt(n#0) <= z#36 && z#36 < n#0 + n#0 && Div(x#58 + y#38, LitInt(n#0)) == Div(x#58, LitInt(n#0)) + Div(y#38, LitInt(n#0)) + 1))) && (forall x#59: int, y#39: int :: { Div(x#59 - y#39, n#0) } (var z#37 := Mod(x#59, LitInt(n#0)) - Mod(y#39, LitInt(n#0)); (LitInt(0) <= z#37 && z#37 < n#0 && Div(x#59 - y#39, LitInt(n#0)) == Div(x#59, LitInt(n#0)) - Div(y#39, LitInt(n#0))) || (LitInt(0 - n#0) <= z#37 && z#37 < 0 && Div(x#59 - y#39, LitInt(n#0)) == Div(x#59, LitInt(n#0)) - Div(y#39, LitInt(n#0)) - 1)))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#5: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#5)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#5)) ==> LitInt(0) <= d#5 && d#5 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#9 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#10 := Seq#Append(digits'#9, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#10))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#10 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#11 := Seq#Append(digits'#10, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#11))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#11 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#12 := Seq#Append(digits'#11, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#12))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#5: Box :: { Seq#Contains(chars#0, c#5) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#5) } $IsBox(c#5, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#5) ==> Seq#Contains(chars#0, c#5)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#11: int :: { Seq#Contains(digits#0, $Box(d#11)) } Seq#Contains(digits#0, $Box(d#11)) ==> LitInt(0) <= d#11 && d#11 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#11: int :: { Seq#Contains(digits#0, $Box(d#11)) } Seq#Contains(digits#0, $Box(d#11)) ==> LitInt(0) <= d#11 && d#11 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#12: int :: { Seq#Contains(digits#0, $Box(d#12)) } Seq#Contains(digits#0, $Box(d#12)) ==> LitInt(0) <= d#12 && d#12 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#5: Box :: { Seq#Contains(chars#0, c#5) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#5) } $IsBox(c#5, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#5) ==> Seq#Contains(chars#0, c#5)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#6 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#6) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#6), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#6 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#6), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#7 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#7) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#7), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#7 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#7), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#11: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#11)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#11) } $IsBox(c#11, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#11) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#11)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#12: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#12)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#12) } $IsBox(c#12, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#12) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#12)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#13: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#13)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#13) } $IsBox(c#13, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#13) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#13)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Seq#Contains(chars#0, $l#9#c#0))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#9: Box :: { Map#Domain(digits#0)[c#9] } { Seq#Contains(str#0, c#9) } $IsBox(c#9, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#9) ==> Map#Domain(digits#0)[c#9])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#9: Box :: { Map#Domain(digits#0)[c#9] } { Seq#Contains(str#0, c#9) } $IsBox(c#9, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#9) ==> Map#Domain(digits#0)[c#9])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#10: Box :: { Map#Domain(digits#0)[c#10] } { Seq#Contains(str#0, c#10) } $IsBox(c#10, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#10) ==> Map#Domain(digits#0)[c#10])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Map#Domain(digits#0)[$l#17#c#0])), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Map#Domain(digits#0)[$l#17#c#0])), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(Map#Domain(digits#0)[$l#18#c#0])), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(Map#Domain(digits#0)[$l#19#c#0])), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#9 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#9) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#9)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#9 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#9) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#9)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#9))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#9 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#9) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#9) else (var tl#18 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#9)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#18)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#9 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#9) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#9) else (var tl#19 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#9)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#19)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#10 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#10) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#10)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#10 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#10) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#10)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#10))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#10 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#10) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#10) else (var tl#20 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#10)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#20)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#10 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#10) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#10) else (var tl#21 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#10)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#21)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#11 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#11) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#11)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#11 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#11) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#11)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#11))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#11 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#11) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#11) else (var tl#22 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#11)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#22)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#11 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#11) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#11) else (var tl#23 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#11)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#23)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#5: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#5)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#5)) ==> LitInt(0) <= d#5 && d#5 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#9 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#10 := Seq#Append(digits'#9, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#10))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#10 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#11 := Seq#Append(digits'#10, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#11))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#11 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#12 := Seq#Append(digits'#11, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#12))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#5: char :: { Seq#Contains(chars#0, $Box(c#5)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#5)) ==> Seq#Contains(chars#0, $Box(c#5))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#11: int :: { Seq#Contains(digits#0, $Box(d#11)) } Seq#Contains(digits#0, $Box(d#11)) ==> LitInt(0) <= d#11 && d#11 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#11: int :: { Seq#Contains(digits#0, $Box(d#11)) } Seq#Contains(digits#0, $Box(d#11)) ==> LitInt(0) <= d#11 && d#11 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#12: int :: { Seq#Contains(digits#0, $Box(d#12)) } Seq#Contains(digits#0, $Box(d#12)) ==> LitInt(0) <= d#12 && d#12 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#5: char :: { Seq#Contains(chars#0, $Box(c#5)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#5)) ==> Seq#Contains(chars#0, $Box(c#5))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#6 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#6) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#6), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#6 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#6), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#7 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#7) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#7), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#7 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#7), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#11: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#11))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#11)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#11))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#12: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#12))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#12)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#12))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#13: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#13))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#13)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#13))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Seq#Contains(chars#0, $l#9#c#0))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#9: char :: { Map#Domain(digits#0)[$Box(c#9)] } { Seq#Contains(str#0, $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(str#0, $Box(c#9)) ==> Map#Domain(digits#0)[$Box(c#9)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#9: char :: { Map#Domain(digits#0)[$Box(c#9)] } { Seq#Contains(str#0, $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(str#0, $Box(c#9)) ==> Map#Domain(digits#0)[$Box(c#9)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#10: char :: { Map#Domain(digits#0)[$Box(c#10)] } { Seq#Contains(str#0, $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(str#0, $Box(c#10)) ==> Map#Domain(digits#0)[$Box(c#10)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Map#Domain(digits#0)[$l#17#c#0])), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Map#Domain(digits#0)[$l#17#c#0])), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(Map#Domain(digits#0)[$l#18#c#0])), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(Map#Domain(digits#0)[$l#19#c#0])), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, TChar)), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#9 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#9) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#9)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#9)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#9 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#9) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#9)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#9))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#9 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#9) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#9) else (var tl#18 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#9)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#18)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#9 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#9) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#9) else (var tl#19 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#9)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#19)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#10 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#10) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#10)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#10)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#10 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#10) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#10)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#10))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#10 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#10) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#10) else (var tl#20 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#10)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#20)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#10 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#10) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#10) else (var tl#21 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#10)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#21)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#11 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#11) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#11)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#11)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#11 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#11) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#11)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#11))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#11 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#11) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#11) else (var tl#22 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#11)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#22)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#11 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#11) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#11) else (var tl#23 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#11)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#23)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#4: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#4)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#4)) } $Is(c#4, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#4)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#4))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#7#c#0))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, TChar)), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#7: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#7: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#7)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#8: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#8)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#8)] } { Seq#Contains(str#0, $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(str#0, $Box(c#8)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#8)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#8)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#14#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#14#c#0]): int < base#0)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, TChar)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#14#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#14#c#0]): int < base#0)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, TChar)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#15#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#15#c#0]): int < base#0)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall a#4#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(a#4#0#0) } DatatypeCtorId(#JSON.Errors.DeserializationError.UnsupportedEscape(a#4#0#0)) == ##JSON.Errors.DeserializationError.UnsupportedEscape);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) } JSON_mErrors.DeserializationError.UnsupportedEscape_q(d) ==> (exists a#5#0#0: Seq :: d == #JSON.Errors.DeserializationError.UnsupportedEscape(a#5#0#0)));

axiom (forall a#6#0#0: Seq :: { $Is(#JSON.Errors.DeserializationError.UnsupportedEscape(a#6#0#0), Tclass.JSON_mErrors.DeserializationError()) } $Is(#JSON.Errors.DeserializationError.UnsupportedEscape(a#6#0#0), Tclass.JSON_mErrors.DeserializationError()) <==> $Is(a#6#0#0, TSeq(TChar)));

axiom (forall a#7#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(Lit(a#7#0#0)) } #JSON.Errors.DeserializationError.UnsupportedEscape(Lit(a#7#0#0)) == Lit(#JSON.Errors.DeserializationError.UnsupportedEscape(a#7#0#0)));

axiom (forall a#8#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(a#8#0#0) } JSON_mErrors.DeserializationError.str(#JSON.Errors.DeserializationError.UnsupportedEscape(a#8#0#0)) == a#8#0#0);

axiom (forall a#9#0#0: Seq, i: int :: { Seq#Index(a#9#0#0, i), #JSON.Errors.DeserializationError.UnsupportedEscape(a#9#0#0) } 0 <= i && i < Seq#Length(a#9#0#0) ==> DtRank($Unbox(Seq#Index(a#9#0#0, i)): DatatypeType) < DtRank(#JSON.Errors.DeserializationError.UnsupportedEscape(a#9#0#0)));

axiom (forall a#10#0#0: Seq :: { #JSON.Errors.DeserializationError.UnsupportedEscape(a#10#0#0) } Seq#Rank(a#10#0#0) < DtRank(#JSON.Errors.DeserializationError.UnsupportedEscape(a#10#0#0)));

axiom (forall a#31#0#0: int, a#31#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(a#31#0#0, a#31#1#0) } DatatypeCtorId(#JSON.Errors.DeserializationError.ExpectingByte(a#31#0#0, a#31#1#0)) == ##JSON.Errors.DeserializationError.ExpectingByte);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingByte_q(d) } JSON_mErrors.DeserializationError.ExpectingByte_q(d) ==> (exists a#32#0#0: int, a#32#1#0: int :: d == #JSON.Errors.DeserializationError.ExpectingByte(a#32#0#0, a#32#1#0)));

axiom (forall a#33#0#0: int, a#33#1#0: int :: { $Is(#JSON.Errors.DeserializationError.ExpectingByte(a#33#0#0, a#33#1#0), Tclass.JSON_mErrors.DeserializationError()) } $Is(#JSON.Errors.DeserializationError.ExpectingByte(a#33#0#0, a#33#1#0), Tclass.JSON_mErrors.DeserializationError()) <==> $Is(a#33#0#0, Tclass.BoundedInts.uint8()) && $Is(a#33#1#0, Tclass.BoundedInts.opt__byte()));

axiom (forall a#34#0#0: int, a#34#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(LitInt(a#34#0#0), LitInt(a#34#1#0)) } #JSON.Errors.DeserializationError.ExpectingByte(LitInt(a#34#0#0), LitInt(a#34#1#0)) == Lit(#JSON.Errors.DeserializationError.ExpectingByte(a#34#0#0, a#34#1#0)));

axiom (forall a#35#0#0: int, a#35#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(a#35#0#0, a#35#1#0) } JSON_mErrors.DeserializationError.expected(#JSON.Errors.DeserializationError.ExpectingByte(a#35#0#0, a#35#1#0)) == a#35#0#0);

axiom (forall a#36#0#0: int, a#36#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingByte(a#36#0#0, a#36#1#0) } JSON_mErrors.DeserializationError.b(#JSON.Errors.DeserializationError.ExpectingByte(a#36#0#0, a#36#1#0)) == a#36#1#0);

axiom (forall a#37#0#0: Seq, a#37#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#37#0#0, a#37#1#0) } DatatypeCtorId(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#37#0#0, a#37#1#0)) == ##JSON.Errors.DeserializationError.ExpectingAnyByte);

axiom (forall d: DatatypeType :: { JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) } JSON_mErrors.DeserializationError.ExpectingAnyByte_q(d) ==> (exists a#38#0#0: Seq, a#38#1#0: int :: d == #JSON.Errors.DeserializationError.ExpectingAnyByte(a#38#0#0, a#38#1#0)));

axiom (forall a#39#0#0: Seq, a#39#1#0: int :: { $Is(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#39#0#0, a#39#1#0), Tclass.JSON_mErrors.DeserializationError()) } $Is(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#39#0#0, a#39#1#0), Tclass.JSON_mErrors.DeserializationError()) <==> $Is(a#39#0#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(a#39#1#0, Tclass.BoundedInts.opt__byte()));

axiom (forall a#40#0#0: Seq, a#40#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(Lit(a#40#0#0), LitInt(a#40#1#0)) } #JSON.Errors.DeserializationError.ExpectingAnyByte(Lit(a#40#0#0), LitInt(a#40#1#0)) == Lit(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#40#0#0, a#40#1#0)));

axiom (forall a#41#0#0: Seq, a#41#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#41#0#0, a#41#1#0) } JSON_mErrors.DeserializationError.expected__sq(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#41#0#0, a#41#1#0)) == a#41#0#0);

axiom (forall a#42#0#0: Seq, a#42#1#0: int, i: int :: { Seq#Index(a#42#0#0, i), #JSON.Errors.DeserializationError.ExpectingAnyByte(a#42#0#0, a#42#1#0) } 0 <= i && i < Seq#Length(a#42#0#0) ==> DtRank($Unbox(Seq#Index(a#42#0#0, i)): DatatypeType) < DtRank(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#42#0#0, a#42#1#0)));

axiom (forall a#43#0#0: Seq, a#43#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#43#0#0, a#43#1#0) } Seq#Rank(a#43#0#0) < DtRank(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#43#0#0, a#43#1#0)));

axiom (forall a#44#0#0: Seq, a#44#1#0: int :: { #JSON.Errors.DeserializationError.ExpectingAnyByte(a#44#0#0, a#44#1#0) } JSON_mErrors.DeserializationError.b(#JSON.Errors.DeserializationError.ExpectingAnyByte(a#44#0#0, a#44#1#0)) == a#44#1#0);

axiom (forall this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this) } JSON_mErrors.DeserializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.DeserializationError()) ==> $Is(JSON_mErrors.DeserializationError.ToString(this), TSeq(TChar)));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#4 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#4)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#8 := JSON_mErrors.DeserializationError.b(this); (var b0#4 := JSON_mErrors.DeserializationError.expected(this); (var c#8 := (if b#8 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#8)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#4)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#8)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#9 := JSON_mErrors.DeserializationError.b(this); (var bs0#4 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#9 := (if b#9 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#9)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#4 := Seq#Create(TChar, $Heap, Seq#Length(bs0#4), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#4, $Unbox($l#10#idx#0): int)): int))), (lambda $l#10#heap#0: Heap, $l#10#idx#0: Box :: $IsBox($l#10#idx#0, TInt) && LitInt(0) <= $Unbox($l#10#idx#0): int && $Unbox($l#10#idx#0): int < Seq#Length(bs0#4)), (lambda $l#10#heap#0: Heap, $l#10#idx#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#4), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#9))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#6 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#6)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#12 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#6 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#12 := (if b#12 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#12)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#6)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#12)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#13 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#6 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#13 := (if b#13 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#13)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#6 := Seq#Create(TChar, $Heap, Seq#Length(bs0#6), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#6, $Unbox($l#13#idx#0): int)): int))), (lambda $l#13#heap#0: Heap, $l#13#idx#0: Box :: $IsBox($l#13#idx#0, TInt) && LitInt(0) <= $Unbox($l#13#idx#0): int && $Unbox($l#13#idx#0): int < Seq#Length(bs0#6)), (lambda $l#13#heap#0: Heap, $l#13#idx#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#6), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#13))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> $Is(JSON_mErrors.SerializationError.ToString(this), TSeq(TChar)));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#5 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#5, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#4 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#4, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#4 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#4)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#7 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#7, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#6 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#6, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#6 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#6)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall n#0: int :: { JSON_mValues.__default.Int(n#0) } $Is(JSON_mValues.__default.Int(n#0), Tclass.JSON_mValues.Decimal()));

axiom (forall n#0: int :: { JSON_mValues.__default.Int(n#0) } JSON_mValues.__default.Int(n#0) == #JSON.Values.Decimal.Decimal(n#0, LitInt(0)));

axiom (forall n#0: int :: {:weight 3} { JSON_mValues.__default.Int(LitInt(n#0)) } JSON_mValues.__default.Int(LitInt(n#0)) == Lit(#JSON.Values.Decimal.Decimal(LitInt(n#0), LitInt(0))));

const unique class.JSON_mGrammar.__default: ClassName;

function JSON_mGrammar.__default.EMPTY() : DatatypeType
uses {
axiom JSON_mGrammar.__default.EMPTY(): DatatypeType == Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.EMPTY (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.EMPTY();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.EMPTY (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.EMPTY()
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.EMPTY"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(16,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##bs#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.View_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.DOUBLEQUOTE() : DatatypeType
uses {
axiom JSON_mGrammar.__default.DOUBLEQUOTE(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(34))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.DOUBLEQUOTE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.DOUBLEQUOTE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.DOUBLEQUOTE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.DOUBLEQUOTE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.DOUBLEQUOTE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(17,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(34)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(34))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(34)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(34))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.PERIOD() : DatatypeType
uses {
axiom JSON_mGrammar.__default.PERIOD(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(46))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.PERIOD(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.PERIOD (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.PERIOD();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.PERIOD (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.PERIOD()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.PERIOD"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(18,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(46)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(46)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(46)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(46))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(46)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(46))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.PERIOD(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.PERIOD(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.E() : DatatypeType
uses {
axiom JSON_mGrammar.__default.E(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.E(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.E (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.E();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.E (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.E()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.E"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(19,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.E(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.E(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.COLON() : DatatypeType
uses {
axiom JSON_mGrammar.__default.COLON(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(58))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.COLON(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.COLON (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.COLON();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.COLON (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.COLON()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.COLON"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(20,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(58)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(58)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(58)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(58))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(58)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(58))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.COLON(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.COLON(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.COMMA() : DatatypeType
uses {
axiom JSON_mGrammar.__default.COMMA(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.COMMA(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.COMMA (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.COMMA();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.COMMA (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.COMMA()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.COMMA"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(21,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.COMMA(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.COMMA(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.LBRACE() : DatatypeType
uses {
axiom JSON_mGrammar.__default.LBRACE(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(123))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.LBRACE(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.LBRACE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.LBRACE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.LBRACE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.LBRACE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.LBRACE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(22,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(123)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(123)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(123)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(123))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(123)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(123))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.LBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.LBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.RBRACE() : DatatypeType
uses {
axiom JSON_mGrammar.__default.RBRACE(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(125))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.RBRACE(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.RBRACE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.RBRACE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.RBRACE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.RBRACE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.RBRACE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(23,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(125)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(125)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(125)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(125))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(125)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(125))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.RBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.RBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.LBRACKET() : DatatypeType
uses {
axiom JSON_mGrammar.__default.LBRACKET(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(91))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.LBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.LBRACKET (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.LBRACKET();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.LBRACKET (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.LBRACKET()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.LBRACKET"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(24,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(91)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(91)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(91)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(91))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(91)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(91))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.LBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.LBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.RBRACKET() : DatatypeType
uses {
axiom JSON_mGrammar.__default.RBRACKET(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(93))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.RBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.RBRACKET (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.RBRACKET();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.RBRACKET (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.RBRACKET()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.RBRACKET"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(25,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(93)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(93)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(93)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(93))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(93)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(93))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.RBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.RBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.MINUS() : DatatypeType
uses {
axiom JSON_mGrammar.__default.MINUS(): DatatypeType == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.MINUS(), Tclass.JSON_mUtils_mViews_mCore.View());
}

procedure {:verboseName "JSON.Grammar.MINUS (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.MINUS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.MINUS (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.MINUS()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.MINUS"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(26,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45)))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))));
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.MINUS(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.MINUS(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function JSON_mGrammar.__default.Blank_q(b#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall b#0: int :: { JSON_mGrammar.__default.Blank_q(b#0) } JSON_mGrammar.__default.Blank_q#canCall(b#0) || (0 < $FunctionContextHeight && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Blank_q(b#0) <==> b#0 == LitInt(32) || b#0 == LitInt(9) || b#0 == LitInt(10) || b#0 == LitInt(13)));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: int :: {:weight 3} { JSON_mGrammar.__default.Blank_q(LitInt(b#0)) } JSON_mGrammar.__default.Blank_q#canCall(LitInt(b#0)) || (0 < $FunctionContextHeight && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Blank_q(LitInt(b#0)) <==> LitInt(b#0) == LitInt(32) || LitInt(b#0) == LitInt(9) || LitInt(b#0) == LitInt(10) || LitInt(b#0) == LitInt(13)));
}

function JSON_mGrammar.__default.Blank_q#canCall(b#0: int) : bool;

function JSON_mGrammar.__default.Blank_q#requires(int) : bool;

axiom (forall b#0: int :: { JSON_mGrammar.__default.Blank_q#requires(b#0) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mGrammar.__default.Blank_q#requires(b#0) <==> true));

procedure {:verboseName "JSON.Grammar.Blank? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Blank_q(b#0: int where LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Blank? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Blank_q(b#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Blank?", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(41,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume false;
    return;

  anon10_Else:
    newtype$check#0 := LitInt(32);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} b#0 != LitInt(32);
    newtype$check#1 := LitInt(9);
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon11_Else:
    assume {:partition} b#0 == LitInt(32);
    goto anon5;

  anon5:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} !(b#0 == LitInt(32) || b#0 == LitInt(9));
    newtype$check#2 := LitInt(10);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon7;

  anon12_Else:
    assume {:partition} b#0 == LitInt(32) || b#0 == LitInt(9);
    goto anon7;

  anon7:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} !(b#0 == LitInt(32) || b#0 == LitInt(9) || b#0 == LitInt(10));
    newtype$check#3 := LitInt(13);
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon9;

  anon13_Else:
    assume {:partition} b#0 == LitInt(32) || b#0 == LitInt(9) || b#0 == LitInt(10);
    goto anon9;

  anon9:
    assume JSON_mGrammar.__default.Blank_q(b#0) <==> b#0 == LitInt(32) || b#0 == LitInt(9) || b#0 == LitInt(10) || b#0 == LitInt(13);
    assume true;
    assume $Is(JSON_mGrammar.__default.Blank_q(b#0), TBool);
    return;
}



function JSON_mGrammar.__default.Blanks_q(v#0: DatatypeType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (forall b#0: int :: { JSON_mGrammar.__default.Blank_q(b#0) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#0))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#0: int :: { JSON_mGrammar.__default.Blank_q(b#0) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) ==> JSON_mGrammar.__default.Blank_q(b#0))));
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (forall b#1: int :: { JSON_mGrammar.__default.Blank_q(b#1) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#1)) } LitInt(0) <= b#1 && b#1 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#1)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#1))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#1: int :: { JSON_mGrammar.__default.Blank_q(b#1) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#1)) } LitInt(0) <= b#1 && b#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#1)) ==> JSON_mGrammar.__default.Blank_q(b#1))));
}

function JSON_mGrammar.__default.Blanks_q#canCall(v#0: DatatypeType) : bool;

function JSON_mGrammar.__default.Blanks_q#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mGrammar.__default.Blanks_q#requires(v#0) <==> true));

procedure {:verboseName "JSON.Grammar.Blanks? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Blanks_q(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Blanks? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Blanks_q(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b#2: int;
  var ##b#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Blanks?", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(42,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume false;
    return;

  anon7_Else:
    havoc b#2;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= b#2 && b#2 < BoundedInts.__default.TWO__TO__THE__8();
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#2));
    ##b#0 := b#2;
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume JSON_mGrammar.__default.Blank_q#canCall(b#2);
    goto anon6;

  anon9_Else:
    assume {:partition} !Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#2));
    goto anon6;

  anon8_Else:
    assume {:partition} !(LitInt(0) <= b#2 && b#2 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon6;

  anon6:
    assume JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#3: int :: { JSON_mGrammar.__default.Blank_q(b#3) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) } LitInt(0) <= b#3 && b#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) ==> JSON_mGrammar.__default.Blank_q(b#3));
    assume (forall b#3: int :: { JSON_mGrammar.__default.Blank_q(b#3) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) } LitInt(0) <= b#3 && b#3 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#3)));
    assume $Is(JSON_mGrammar.__default.Blanks_q(v#0), TBool);
    return;
}



function JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq) : bool
uses {
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S)))) ==> (forall idx#0: int :: { $Unbox(Seq#Index(s#0, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#0)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#0: int :: { $Unbox(Seq#Index(s#0, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length(s#0) - 1))));
axiom 5 <= $FunctionContextHeight ==> (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || (5 < $FunctionContextHeight && $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S)))) ==> (forall idx#1: int :: { $Unbox(Seq#Index(s#0, idx#1)): DatatypeType } LitInt(0) <= idx#1 && idx#1 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#1)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#1: int :: { $Unbox(Seq#Index(s#0, idx#1)): DatatypeType } LitInt(0) <= idx#1 && idx#1 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#1)): DatatypeType)) <==> idx#1 == Seq#Length(Lit(s#0)) - 1))));
}

function JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq) : bool;

function Tclass.JSON_mGrammar.Suffixed(Ty, Ty) : Ty;

const unique Tagclass.JSON_mGrammar.Suffixed: TyTag;

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty :: { Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S) } Tag(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) == Tagclass.JSON_mGrammar.Suffixed && TagFamily(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) == tytagFamily$Suffixed);

function Tclass.JSON_mGrammar.Suffixed_0(Ty) : Ty;

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty :: { Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S) } Tclass.JSON_mGrammar.Suffixed_0(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) == JSON.Grammar.Suffixed$T);

function Tclass.JSON_mGrammar.Suffixed_1(Ty) : Ty;

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty :: { Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S) } Tclass.JSON_mGrammar.Suffixed_1(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) == JSON.Grammar.Suffixed$S);

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) } $IsBox(bx, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)));

function JSON_mGrammar.__default.NoTrailingSuffix#requires(Ty, Ty, Seq) : bool;

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix#requires(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (JSON_mGrammar.__default.NoTrailingSuffix#requires(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> true));

procedure {:verboseName "JSON.Grammar.NoTrailingSuffix (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq where $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.NoTrailingSuffix (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var idx#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.NoTrailingSuffix", " | ", JSON.Grammar._default.NoTrailingSuffix$S, " | ", JSON.Grammar._default.NoTrailingSuffix$D, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(54,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume false;
    return;

  anon9_Else:
    havoc idx#2;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} LitInt(0) <= idx#2;
    goto anon6;

  anon11_Else:
    assume {:partition} idx#2 < LitInt(0);
    goto anon6;

  anon6:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= idx#2 && idx#2 < Seq#Length(s#0);
    assume 0 <= idx#2 && idx#2 < Seq#Length(s#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#2)): DatatypeType);
    goto anon8;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= idx#2 && idx#2 < Seq#Length(s#0));
    goto anon8;

  anon10_Else:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#3: int :: { $Unbox(Seq#Index(s#0, idx#3)): DatatypeType } LitInt(0) <= idx#3 && idx#3 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#3)): DatatypeType)) <==> idx#3 == Seq#Length(s#0) - 1));
    assume (forall idx#3: int :: { $Unbox(Seq#Index(s#0, idx#3)): DatatypeType } LitInt(0) <= idx#3 && idx#3 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#3)): DatatypeType));
    assume $Is(JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0), TBool);
    return;
}



function JSON_mGrammar.__default.NULL() : Seq
uses {
axiom JSON_mGrammar.__default.NULL(): Seq == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(110))))), $Box(char#ToInt(Lit(char#FromInt(117))))), $Box(char#ToInt(Lit(char#FromInt(108))))), $Box(char#ToInt(Lit(char#FromInt(108)))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.NULL(), TSeq(Tclass.BoundedInts.uint8()));
}

procedure {:verboseName "JSON.Grammar.NULL (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.NULL();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.NULL (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.NULL()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.NULL"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(61,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(110)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(110)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(117)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(117)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(108)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(108)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#6 := char#ToInt(Lit(char#FromInt(108)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(108)));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.NULL(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.NULL(), TSeq(Tclass.BoundedInts.uint8()), $h));

function JSON_mGrammar.__default.TRUE() : Seq
uses {
axiom JSON_mGrammar.__default.TRUE(): Seq == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(116))))), $Box(char#ToInt(Lit(char#FromInt(114))))), $Box(char#ToInt(Lit(char#FromInt(117))))), $Box(char#ToInt(Lit(char#FromInt(101)))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.TRUE(), TSeq(Tclass.BoundedInts.uint8()));
}

procedure {:verboseName "JSON.Grammar.TRUE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.TRUE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.TRUE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.TRUE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.TRUE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(62,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(116)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(116)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(114)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(114)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(117)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(117)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#6 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.TRUE(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.TRUE(), TSeq(Tclass.BoundedInts.uint8()), $h));

function JSON_mGrammar.__default.FALSE() : Seq
uses {
axiom JSON_mGrammar.__default.FALSE(): Seq == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(102))))), $Box(char#ToInt(Lit(char#FromInt(97))))), $Box(char#ToInt(Lit(char#FromInt(108))))), $Box(char#ToInt(Lit(char#FromInt(115))))), $Box(char#ToInt(Lit(char#FromInt(101)))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mGrammar.__default.FALSE(), TSeq(Tclass.BoundedInts.uint8()));
}

procedure {:verboseName "JSON.Grammar.FALSE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.FALSE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.FALSE (well-formedness)"} CheckWellFormed$$JSON_mGrammar.__default.FALSE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.FALSE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(63,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(102)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(102)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(108)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(108)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#6 := char#ToInt(Lit(char#FromInt(115)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(115)));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#8 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#9 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.FALSE(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.FALSE(), TSeq(Tclass.BoundedInts.uint8()), $h));

function JSON_mGrammar.__default.Null_q(v#0: DatatypeType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Null_q(v#0) } JSON_mGrammar.__default.Null_q#canCall(v#0) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (JSON_mGrammar.__default.Null_q(v#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mGrammar.__default.NULL())));
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Null_q(Lit(v#0)) } JSON_mGrammar.__default.Null_q#canCall(Lit(v#0)) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (JSON_mGrammar.__default.Null_q(Lit(v#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), JSON_mGrammar.__default.NULL())));
}

function JSON_mGrammar.__default.Null_q#canCall(v#0: DatatypeType) : bool;

function JSON_mGrammar.__default.Null_q#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Null_q#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mGrammar.__default.Null_q#requires(v#0) <==> true));

procedure {:verboseName "JSON.Grammar.Null? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Null_q(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Null? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Null_q(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Null?", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(65,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume JSON_mGrammar.__default.Null_q(v#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mGrammar.__default.NULL());
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume $Is(JSON_mGrammar.__default.Null_q(v#0), TBool);
    return;
}



function JSON_mGrammar.__default.Bool_q(v#0: DatatypeType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Bool_q(v#0) } JSON_mGrammar.__default.Bool_q#canCall(v#0) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (JSON_mGrammar.__default.Bool_q(v#0) <==> JSON_mUtils_mViews_mCore.View__.Bytes(v#0) == JSON_mGrammar.__default.TRUE() || JSON_mUtils_mViews_mCore.View__.Bytes(v#0) == JSON_mGrammar.__default.FALSE()));
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Bool_q(Lit(v#0)) } JSON_mGrammar.__default.Bool_q#canCall(Lit(v#0)) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (JSON_mGrammar.__default.Bool_q(Lit(v#0)) <==> Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0))) == JSON_mGrammar.__default.TRUE() || Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0))) == JSON_mGrammar.__default.FALSE()));
}

function JSON_mGrammar.__default.Bool_q#canCall(v#0: DatatypeType) : bool;

function JSON_mGrammar.__default.Bool_q#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Bool_q#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mGrammar.__default.Bool_q#requires(v#0) <==> true));

procedure {:verboseName "JSON.Grammar.Bool? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Bool_q(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Bool? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Bool_q(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Bool?", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(66,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume JSON_mGrammar.__default.Bool_q(v#0) <==> JSON_mUtils_mViews_mCore.View__.Bytes(v#0) == JSON_mGrammar.__default.TRUE() || JSON_mUtils_mViews_mCore.View__.Bytes(v#0) == JSON_mGrammar.__default.FALSE();
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume $Is(JSON_mGrammar.__default.Bool_q(v#0), TBool);
    return;
}



function JSON_mGrammar.__default.Digit_q(b#0: int) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall b#0: int :: { JSON_mGrammar.__default.Digit_q(b#0) } JSON_mGrammar.__default.Digit_q#canCall(b#0) || (0 < $FunctionContextHeight && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Digit_q(b#0) <==> char#ToInt(Lit(char#FromInt(48))) <= b#0 && b#0 <= char#ToInt(Lit(char#FromInt(57)))));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: int :: {:weight 3} { JSON_mGrammar.__default.Digit_q(LitInt(b#0)) } JSON_mGrammar.__default.Digit_q#canCall(LitInt(b#0)) || (0 < $FunctionContextHeight && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Digit_q(LitInt(b#0)) <==> char#ToInt(Lit(char#FromInt(48))) <= LitInt(b#0) && LitInt(b#0) <= char#ToInt(Lit(char#FromInt(57)))));
}

function JSON_mGrammar.__default.Digit_q#canCall(b#0: int) : bool;

function JSON_mGrammar.__default.Digit_q#requires(int) : bool;

axiom (forall b#0: int :: { JSON_mGrammar.__default.Digit_q#requires(b#0) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mGrammar.__default.Digit_q#requires(b#0) <==> true));

procedure {:verboseName "JSON.Grammar.Digit? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Digit_q(b#0: int where LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Digit? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Digit_q(b#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Digit?", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(67,12): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume false;
    return;

  anon6_Else:
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} char#ToInt(Lit(char#FromInt(48))) <= b#0;
    newtype$check#2 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon7_Else:
    assume {:partition} b#0 < char#ToInt(Lit(char#FromInt(48)));
    goto anon5;

  anon5:
    assume JSON_mGrammar.__default.Digit_q(b#0) <==> char#ToInt(Lit(char#FromInt(48))) <= b#0 && b#0 <= char#ToInt(Lit(char#FromInt(57)));
    assume true;
    assume $Is(JSON_mGrammar.__default.Digit_q(b#0), TBool);
    return;
}



function JSON_mGrammar.__default.Digits_q(v#0: DatatypeType) : bool
uses {
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (forall b#0: int :: { JSON_mGrammar.__default.Digit_q(b#0) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#0))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#0: int :: { JSON_mGrammar.__default.Digit_q(b#0) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#0)) ==> JSON_mGrammar.__default.Digit_q(b#0))));
axiom 1 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || (1 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (forall b#1: int :: { JSON_mGrammar.__default.Digit_q(b#1) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#1)) } LitInt(0) <= b#1 && b#1 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#1)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#1))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#1: int :: { JSON_mGrammar.__default.Digit_q(b#1) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#1)) } LitInt(0) <= b#1 && b#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#1)) ==> JSON_mGrammar.__default.Digit_q(b#1))));
}

function JSON_mGrammar.__default.Digits_q#canCall(v#0: DatatypeType) : bool;

function JSON_mGrammar.__default.Digits_q#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mGrammar.__default.Digits_q#requires(v#0) <==> true));

procedure {:verboseName "JSON.Grammar.Digits? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Digits_q(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Digits? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Digits_q(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var b#2: int;
  var ##b#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Digits?", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(68,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume false;
    return;

  anon7_Else:
    havoc b#2;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} LitInt(0) <= b#2 && b#2 < BoundedInts.__default.TWO__TO__THE__8();
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#2));
    ##b#0 := b#2;
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume JSON_mGrammar.__default.Digit_q#canCall(b#2);
    goto anon6;

  anon9_Else:
    assume {:partition} !Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#2));
    goto anon6;

  anon8_Else:
    assume {:partition} !(LitInt(0) <= b#2 && b#2 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon6;

  anon6:
    assume JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#3: int :: { JSON_mGrammar.__default.Digit_q(b#3) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) } LitInt(0) <= b#3 && b#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) ==> JSON_mGrammar.__default.Digit_q(b#3));
    assume (forall b#3: int :: { JSON_mGrammar.__default.Digit_q(b#3) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) } LitInt(0) <= b#3 && b#3 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#3)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#3)));
    assume $Is(JSON_mGrammar.__default.Digits_q(v#0), TBool);
    return;
}



function JSON_mGrammar.__default.Num_q(v#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Num_q(v#0) } JSON_mGrammar.__default.Num_q#canCall(v#0) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mGrammar.__default.Digits_q#canCall(v#0) && (JSON_mGrammar.__default.Num_q(v#0) <==> JSON_mGrammar.__default.Digits_q(v#0) && !JSON_mUtils_mViews_mCore.View__.Empty_q(v#0)));
axiom 2 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Num_q(Lit(v#0)) } JSON_mGrammar.__default.Num_q#canCall(Lit(v#0)) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) && (JSON_mGrammar.__default.Num_q(Lit(v#0)) <==> JSON_mGrammar.__default.Digits_q(Lit(v#0)) && !JSON_mUtils_mViews_mCore.View__.Empty_q(Lit(v#0))));
}

function JSON_mGrammar.__default.Num_q#canCall(v#0: DatatypeType) : bool;

function JSON_mGrammar.__default.Num_q#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Num_q#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mGrammar.__default.Num_q#requires(v#0) <==> true));

procedure {:verboseName "JSON.Grammar.Num? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Num_q(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mGrammar.__default.Int_q(v#0: DatatypeType) : bool
uses {
axiom 3 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Int_q(v#0) } JSON_mGrammar.__default.Int_q#canCall(v#0) || (3 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(48))) && (!JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48))) ==> JSON_mGrammar.__default.Num_q#canCall(v#0) && (JSON_mGrammar.__default.Num_q(v#0) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(v#0, LitInt(0)))) && (JSON_mGrammar.__default.Int_q(v#0) <==> JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48))) || (JSON_mGrammar.__default.Num_q(v#0) && JSON_mUtils_mViews_mCore.View__.At(v#0, LitInt(0)) != char#ToInt(Lit(char#FromInt(48))))));
axiom 3 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Int_q(Lit(v#0)) } JSON_mGrammar.__default.Int_q#canCall(Lit(v#0)) || (3 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(Lit(v#0), Lit(char#FromInt(48))) && (!Lit(JSON_mUtils_mViews_mCore.View__.Char_q(Lit(v#0), Lit(char#FromInt(48)))) ==> JSON_mGrammar.__default.Num_q#canCall(Lit(v#0)) && (Lit(JSON_mGrammar.__default.Num_q(Lit(v#0))) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(v#0), LitInt(0)))) && (JSON_mGrammar.__default.Int_q(Lit(v#0)) <==> JSON_mUtils_mViews_mCore.View__.Char_q(Lit(v#0), Lit(char#FromInt(48))) || (JSON_mGrammar.__default.Num_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.At(Lit(v#0), LitInt(0)) != char#ToInt(Lit(char#FromInt(48))))));
}

function JSON_mGrammar.__default.Int_q#canCall(v#0: DatatypeType) : bool;

function JSON_mGrammar.__default.Int_q#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Int_q#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mGrammar.__default.Int_q#requires(v#0) <==> true));

procedure {:verboseName "JSON.Grammar.Int? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Int_q(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.Int? (well-formedness)"} CheckWellformed$$JSON_mGrammar.__default.Int_q(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##v#0: DatatypeType;
  var newtype$check#0: int;
  var ##idx#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.Int?", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(70,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume false;
    return;

  anon7_Else:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(48));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(48)));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48)));
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Num_q#canCall(v#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} JSON_mGrammar.__default.Num_q(v#0);
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(v#0, ##idx#0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q(v#0, ##idx#0) || JSON_mUtils_mViews_mCore.View__.beg(v#0) + ##idx#0 < JSON_mUtils_mViews_mCore.View__.end(v#0);
    assume JSON_mUtils_mViews_mCore.View__.ValidIndex_q(v#0, ##idx#0);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall(v#0, LitInt(0));
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon6;

  anon9_Else:
    assume {:partition} !JSON_mGrammar.__default.Num_q(v#0);
    goto anon6;

  anon8_Else:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48)));
    goto anon6;

  anon6:
    assume JSON_mGrammar.__default.Int_q(v#0) <==> JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48))) || (JSON_mGrammar.__default.Num_q(v#0) && JSON_mUtils_mViews_mCore.View__.At(v#0, LitInt(0)) != char#ToInt(Lit(char#FromInt(48))));
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(48))) && (!JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48))) ==> JSON_mGrammar.__default.Num_q#canCall(v#0) && (JSON_mGrammar.__default.Num_q(v#0) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(v#0, LitInt(0))));
    assume $Is(JSON_mGrammar.__default.Int_q(v#0), TBool);
    return;
}



procedure {:verboseName "JSON.Grammar.jchar (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jchar(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jchar (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jchar(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##bs#0: Seq;
  var newtype$check#3: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jchar", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(28,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(v#0);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.Length(v#0) == LitInt(1);
    return;

  anon4_Else:
    newtype$check#1 := char#ToInt(Lit(char#FromInt(98)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(98)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98)))))));
    newtype$check#3 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98))))));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#3);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98)))))) && JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98)))))));
    assume JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(98))))))) == LitInt(1);
    return;
}



function Tclass.JSON_mGrammar.jchar() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jchar()) == Tagclass.JSON_mGrammar.jchar && TagFamily(Tclass.JSON_mGrammar.jchar()) == tytagFamily$jchar;
}

const unique Tagclass.JSON_mGrammar.jchar: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jchar()) } $IsBox(bx, Tclass.JSON_mGrammar.jchar()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jchar()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jchar()) } $Is(v#0, Tclass.JSON_mGrammar.jchar()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Length(v#0) == LitInt(1));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jchar(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jchar(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jquote (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jquote(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jquote (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jquote(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jquote", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(29,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(34));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(34)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(34)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.DOUBLEQUOTE();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.DOUBLEQUOTE(), Lit(char#FromInt(34)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.DOUBLEQUOTE(), Lit(char#FromInt(34))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.DOUBLEQUOTE(), Lit(char#FromInt(34))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.DOUBLEQUOTE(), char#ToInt(Lit(char#FromInt(34)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.DOUBLEQUOTE(), char#ToInt(Lit(char#FromInt(34)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.DOUBLEQUOTE()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(34)))))));
    return;
}



function Tclass.JSON_mGrammar.jquote() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jquote()) == Tagclass.JSON_mGrammar.jquote && TagFamily(Tclass.JSON_mGrammar.jquote()) == tytagFamily$jquote;
}

const unique Tagclass.JSON_mGrammar.jquote: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jquote()) } $IsBox(bx, Tclass.JSON_mGrammar.jquote()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jquote()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jquote()) } $Is(v#0, Tclass.JSON_mGrammar.jquote()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(34))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jquote(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jquote(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jperiod (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jperiod(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jperiod (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jperiod(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jperiod", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(30,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(46));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(46)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(46)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.PERIOD();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.PERIOD(), Lit(char#FromInt(46)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.PERIOD(), Lit(char#FromInt(46))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.PERIOD(), Lit(char#FromInt(46))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.PERIOD(), char#ToInt(Lit(char#FromInt(46)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.PERIOD(), char#ToInt(Lit(char#FromInt(46)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.PERIOD()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(46)))))));
    return;
}



function Tclass.JSON_mGrammar.jperiod() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jperiod()) == Tagclass.JSON_mGrammar.jperiod && TagFamily(Tclass.JSON_mGrammar.jperiod()) == tytagFamily$jperiod;
}

const unique Tagclass.JSON_mGrammar.jperiod: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jperiod()) } $IsBox(bx, Tclass.JSON_mGrammar.jperiod()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jperiod()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jperiod()) } $Is(v#0, Tclass.JSON_mGrammar.jperiod()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(46))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jperiod(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jperiod(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.je (well-formedness)"} CheckWellFormed$$JSON_mGrammar.je(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.je (well-formedness)"} CheckWellFormed$$JSON_mGrammar.je(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##c#1: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.je", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(31,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(101));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(101)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(101)));
    return;

  anon7_Else:
    assume !JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(101)));
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := Lit(char#FromInt(69));
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#1) < 256;
    assume char#ToInt(##c#1) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(69)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(69)));
    return;

  anon6_Else:
    newtype$check#0 := JSON_mGrammar.__default.E();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.E(), Lit(char#FromInt(101))) && (!JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.E(), Lit(char#FromInt(101))) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.E(), Lit(char#FromInt(69))));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.E(), Lit(char#FromInt(101))) || JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.E(), Lit(char#FromInt(69)));
    return;
}



function Tclass.JSON_mGrammar.je() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.je()) == Tagclass.JSON_mGrammar.je && TagFamily(Tclass.JSON_mGrammar.je()) == tytagFamily$je;
}

const unique Tagclass.JSON_mGrammar.je: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.je()) } $IsBox(bx, Tclass.JSON_mGrammar.je()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.je()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.je()) } $Is(v#0, Tclass.JSON_mGrammar.je()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && (JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(101))) || JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(69)))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.je(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.je(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jcolon (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jcolon(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jcolon (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jcolon(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jcolon", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(32,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(58));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(58)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(58)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.COLON();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.COLON(), Lit(char#FromInt(58)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.COLON(), Lit(char#FromInt(58))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.COLON(), Lit(char#FromInt(58))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.COLON(), char#ToInt(Lit(char#FromInt(58)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.COLON(), char#ToInt(Lit(char#FromInt(58)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.COLON()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(58)))))));
    return;
}



function Tclass.JSON_mGrammar.jcolon() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jcolon()) == Tagclass.JSON_mGrammar.jcolon && TagFamily(Tclass.JSON_mGrammar.jcolon()) == tytagFamily$jcolon;
}

const unique Tagclass.JSON_mGrammar.jcolon: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jcolon()) } $IsBox(bx, Tclass.JSON_mGrammar.jcolon()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jcolon()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jcolon()) } $Is(v#0, Tclass.JSON_mGrammar.jcolon()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(58))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jcolon(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jcolon(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jcomma (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jcomma(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jcomma (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jcomma(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jcomma", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(33,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(44)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(44)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.COMMA();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.COMMA(), Lit(char#FromInt(44)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.COMMA(), Lit(char#FromInt(44))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.COMMA(), Lit(char#FromInt(44))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.COMMA(), char#ToInt(Lit(char#FromInt(44)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.COMMA(), char#ToInt(Lit(char#FromInt(44)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.COMMA()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44)))))));
    return;
}



function Tclass.JSON_mGrammar.jcomma() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jcomma()) == Tagclass.JSON_mGrammar.jcomma && TagFamily(Tclass.JSON_mGrammar.jcomma()) == tytagFamily$jcomma;
}

const unique Tagclass.JSON_mGrammar.jcomma: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jcomma()) } $IsBox(bx, Tclass.JSON_mGrammar.jcomma()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jcomma()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jcomma()) } $Is(v#0, Tclass.JSON_mGrammar.jcomma()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(44))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jcomma(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jcomma(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jlbrace (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jlbrace(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jlbrace (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jlbrace(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jlbrace", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(34,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(123));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(123)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(123)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.LBRACE();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.LBRACE(), Lit(char#FromInt(123)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.LBRACE(), Lit(char#FromInt(123))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.LBRACE(), Lit(char#FromInt(123))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.LBRACE(), char#ToInt(Lit(char#FromInt(123)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.LBRACE(), char#ToInt(Lit(char#FromInt(123)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.LBRACE()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(123)))))));
    return;
}



function Tclass.JSON_mGrammar.jlbrace() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jlbrace()) == Tagclass.JSON_mGrammar.jlbrace && TagFamily(Tclass.JSON_mGrammar.jlbrace()) == tytagFamily$jlbrace;
}

const unique Tagclass.JSON_mGrammar.jlbrace: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jlbrace()) } $IsBox(bx, Tclass.JSON_mGrammar.jlbrace()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jlbrace()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jlbrace()) } $Is(v#0, Tclass.JSON_mGrammar.jlbrace()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(123))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jlbrace(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jlbrace(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jrbrace (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jrbrace(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jrbrace (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jrbrace(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jrbrace", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(35,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(125));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(125)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(125)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.RBRACE();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.RBRACE(), Lit(char#FromInt(125)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.RBRACE(), Lit(char#FromInt(125))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.RBRACE(), Lit(char#FromInt(125))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.RBRACE(), char#ToInt(Lit(char#FromInt(125)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.RBRACE(), char#ToInt(Lit(char#FromInt(125)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.RBRACE()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(125)))))));
    return;
}



function Tclass.JSON_mGrammar.jrbrace() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jrbrace()) == Tagclass.JSON_mGrammar.jrbrace && TagFamily(Tclass.JSON_mGrammar.jrbrace()) == tytagFamily$jrbrace;
}

const unique Tagclass.JSON_mGrammar.jrbrace: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jrbrace()) } $IsBox(bx, Tclass.JSON_mGrammar.jrbrace()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jrbrace()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jrbrace()) } $Is(v#0, Tclass.JSON_mGrammar.jrbrace()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(125))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jrbrace(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jrbrace(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jlbracket (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jlbracket(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jlbracket (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jlbracket(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jlbracket", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(36,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(91));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(91)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(91)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.LBRACKET();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.LBRACKET(), Lit(char#FromInt(91)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.LBRACKET(), Lit(char#FromInt(91))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.LBRACKET(), Lit(char#FromInt(91))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.LBRACKET(), char#ToInt(Lit(char#FromInt(91)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.LBRACKET(), char#ToInt(Lit(char#FromInt(91)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.LBRACKET()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(91)))))));
    return;
}



function Tclass.JSON_mGrammar.jlbracket() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jlbracket()) == Tagclass.JSON_mGrammar.jlbracket && TagFamily(Tclass.JSON_mGrammar.jlbracket()) == tytagFamily$jlbracket;
}

const unique Tagclass.JSON_mGrammar.jlbracket: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jlbracket()) } $IsBox(bx, Tclass.JSON_mGrammar.jlbracket()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jlbracket()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jlbracket()) } $Is(v#0, Tclass.JSON_mGrammar.jlbracket()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(91))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jlbracket(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jlbracket(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jrbracket (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jrbracket(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jrbracket (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jrbracket(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jrbracket", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(37,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(93));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(93)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(93)));
    return;

  anon4_Else:
    newtype$check#0 := JSON_mGrammar.__default.RBRACKET();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.RBRACKET(), Lit(char#FromInt(93)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.RBRACKET(), Lit(char#FromInt(93))) ==> JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.RBRACKET(), Lit(char#FromInt(93))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mGrammar.__default.RBRACKET(), char#ToInt(Lit(char#FromInt(93)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mGrammar.__default.RBRACKET(), char#ToInt(Lit(char#FromInt(93)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.__default.RBRACKET()), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(93)))))));
    return;
}



function Tclass.JSON_mGrammar.jrbracket() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jrbracket()) == Tagclass.JSON_mGrammar.jrbracket && TagFamily(Tclass.JSON_mGrammar.jrbracket()) == tytagFamily$jrbracket;
}

const unique Tagclass.JSON_mGrammar.jrbracket: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jrbracket()) } $IsBox(bx, Tclass.JSON_mGrammar.jrbracket()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jrbracket()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jrbracket()) } $Is(v#0, Tclass.JSON_mGrammar.jrbracket()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(93))));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jrbracket(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jrbracket(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jminus (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jminus(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jminus (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jminus(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jminus", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(38,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(45));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(45)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45)));
    return;

  anon7_Else:
    assume !JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45)));
    assume JSON_mUtils_mViews_mCore.View__.Empty_q(v#0);
    return;

  anon6_Else:
    newtype$check#0 := JSON_mGrammar.__default.MINUS();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.MINUS(), Lit(char#FromInt(45)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.MINUS(), Lit(char#FromInt(45))) || JSON_mUtils_mViews_mCore.View__.Empty_q(JSON_mGrammar.__default.MINUS());
    return;
}



function Tclass.JSON_mGrammar.jminus() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jminus()) == Tagclass.JSON_mGrammar.jminus && TagFamily(Tclass.JSON_mGrammar.jminus()) == tytagFamily$jminus;
}

const unique Tagclass.JSON_mGrammar.jminus: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jminus()) } $IsBox(bx, Tclass.JSON_mGrammar.jminus()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jminus()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jminus()) } $Is(v#0, Tclass.JSON_mGrammar.jminus()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && (JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45))) || JSON_mUtils_mViews_mCore.View__.Empty_q(v#0)));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jminus(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jminus(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jsign (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jsign(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jsign (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jsign(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: char;
  var ##c#1: char;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jsign", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(39,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(45));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(45)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45)));
    return;

  anon10_Else:
    assume !JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45)));
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := Lit(char#FromInt(43));
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume {:subsumption 0} char#ToInt(##c#1) < 256;
    assume char#ToInt(##c#1) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(43)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(43)));
    return;

  anon9_Else:
    assume !(JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45))) || JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(43))));
    assume JSON_mUtils_mViews_mCore.View__.Empty_q(v#0);
    return;

  anon8_Else:
    newtype$check#0 := JSON_mGrammar.__default.EMPTY();
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.EMPTY(), Lit(char#FromInt(45))) && (!JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.EMPTY(), Lit(char#FromInt(45))) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(JSON_mGrammar.__default.EMPTY(), Lit(char#FromInt(43))));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.EMPTY(), Lit(char#FromInt(45))) || JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mGrammar.__default.EMPTY(), Lit(char#FromInt(43))) || JSON_mUtils_mViews_mCore.View__.Empty_q(JSON_mGrammar.__default.EMPTY());
    return;
}



function Tclass.JSON_mGrammar.jsign() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jsign()) == Tagclass.JSON_mGrammar.jsign && TagFamily(Tclass.JSON_mGrammar.jsign()) == tytagFamily$jsign;
}

const unique Tagclass.JSON_mGrammar.jsign: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jsign()) } $IsBox(bx, Tclass.JSON_mGrammar.jsign()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jsign()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jsign()) } $Is(v#0, Tclass.JSON_mGrammar.jsign()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && (JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(45))) || JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(43))) || JSON_mUtils_mViews_mCore.View__.Empty_q(v#0)));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jsign(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jsign(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jblanks (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jblanks(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jblanks (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jblanks(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jblanks", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(43,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Blanks_q#canCall(v#0);
    assume JSON_mGrammar.__default.Blanks_q(v#0);
    return;

  anon4_Else:
    ##bs#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.View_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    newtype$check#0 := Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq)) && JSON_mGrammar.__default.Blanks_q#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    assume {:subsumption 0} JSON_mGrammar.__default.Blanks_q#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)))) ==> Lit(JSON_mGrammar.__default.Blanks_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))))) || (forall b#0: int :: { JSON_mGrammar.__default.Blank_q(b#0) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Empty(): Seq)), $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)))), $Box(b#0)) ==> JSON_mGrammar.__default.Blank_q(b#0));
    return;
}



function Tclass.JSON_mGrammar.jblanks() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jblanks()) == Tagclass.JSON_mGrammar.jblanks && TagFamily(Tclass.JSON_mGrammar.jblanks()) == tytagFamily$jblanks;
}

const unique Tagclass.JSON_mGrammar.jblanks: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jblanks()) } $IsBox(bx, Tclass.JSON_mGrammar.jblanks()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jblanks()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jblanks()) } $Is(v#0, Tclass.JSON_mGrammar.jblanks()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mGrammar.__default.Blanks_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jblanks(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jblanks(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function #JSON.Grammar.Structural.Structural(DatatypeType, Box, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Structural.Structural: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Box, a#0#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#0#0#0, a#0#1#0, a#0#2#0) } DatatypeCtorId(#JSON.Grammar.Structural.Structural(a#0#0#0, a#0#1#0, a#0#2#0)) == ##JSON.Grammar.Structural.Structural);
}

function JSON_mGrammar.Structural.Structural_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Structural.Structural_q(d) } JSON_mGrammar.Structural.Structural_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Structural.Structural);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Structural.Structural_q(d) } JSON_mGrammar.Structural.Structural_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Box, a#1#2#0: DatatypeType :: d == #JSON.Grammar.Structural.Structural(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.JSON_mGrammar.Structural(Ty) : Ty;

const unique Tagclass.JSON_mGrammar.Structural: TyTag;

axiom (forall JSON.Grammar.Structural$T: Ty :: { Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T) } Tag(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) == Tagclass.JSON_mGrammar.Structural && TagFamily(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) == tytagFamily$Structural);

function Tclass.JSON_mGrammar.Structural_0(Ty) : Ty;

axiom (forall JSON.Grammar.Structural$T: Ty :: { Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T) } Tclass.JSON_mGrammar.Structural_0(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) == JSON.Grammar.Structural$T);

axiom (forall JSON.Grammar.Structural$T: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) } $IsBox(bx, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)));

axiom (forall JSON.Grammar.Structural$T: Ty, a#2#0#0: DatatypeType, a#2#1#0: Box, a#2#2#0: DatatypeType :: { $Is(#JSON.Grammar.Structural.Structural(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) } $Is(#JSON.Grammar.Structural.Structural(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) <==> $Is(a#2#0#0, Tclass.JSON_mGrammar.jblanks()) && $IsBox(a#2#1#0, JSON.Grammar.Structural$T) && $Is(a#2#2#0, Tclass.JSON_mGrammar.jblanks()));

axiom (forall JSON.Grammar.Structural$T: Ty, a#2#0#0: DatatypeType, a#2#1#0: Box, a#2#2#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Grammar.Structural.Structural(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Grammar.Structural.Structural(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h) <==> $IsAlloc(a#2#0#0, Tclass.JSON_mGrammar.jblanks(), $h) && $IsAllocBox(a#2#1#0, JSON.Grammar.Structural$T, $h) && $IsAlloc(a#2#2#0, Tclass.JSON_mGrammar.jblanks(), $h)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Structural.before(d), Tclass.JSON_mGrammar.jblanks(), $h) } $IsGoodHeap($h) && JSON_mGrammar.Structural.Structural_q(d) && (exists JSON.Grammar.Structural$T: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h)) ==> $IsAlloc(JSON_mGrammar.Structural.before(d), Tclass.JSON_mGrammar.jblanks(), $h));

axiom (forall d: DatatypeType, JSON.Grammar.Structural$T: Ty, $h: Heap :: { $IsAllocBox(JSON_mGrammar.Structural.t(d), JSON.Grammar.Structural$T, $h) } $IsGoodHeap($h) && JSON_mGrammar.Structural.Structural_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h) ==> $IsAllocBox(JSON_mGrammar.Structural.t(d), JSON.Grammar.Structural$T, $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Structural.after(d), Tclass.JSON_mGrammar.jblanks(), $h) } $IsGoodHeap($h) && JSON_mGrammar.Structural.Structural_q(d) && (exists JSON.Grammar.Structural$T: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T), $h)) ==> $IsAlloc(JSON_mGrammar.Structural.after(d), Tclass.JSON_mGrammar.jblanks(), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Box, a#3#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) } #JSON.Grammar.Structural.Structural(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) == Lit(#JSON.Grammar.Structural.Structural(a#3#0#0, a#3#1#0, a#3#2#0)));

function JSON_mGrammar.Structural.before(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Box, a#4#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#4#0#0, a#4#1#0, a#4#2#0) } JSON_mGrammar.Structural.before(#JSON.Grammar.Structural.Structural(a#4#0#0, a#4#1#0, a#4#2#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Box, a#5#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#5#0#0, a#5#1#0, a#5#2#0) } DtRank(a#5#0#0) < DtRank(#JSON.Grammar.Structural.Structural(a#5#0#0, a#5#1#0, a#5#2#0)));

function JSON_mGrammar.Structural.t(DatatypeType) : Box;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Box, a#6#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#6#0#0, a#6#1#0, a#6#2#0) } JSON_mGrammar.Structural.t(#JSON.Grammar.Structural.Structural(a#6#0#0, a#6#1#0, a#6#2#0)) == a#6#1#0);

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Box, a#7#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#7#0#0, a#7#1#0, a#7#2#0) } BoxRank(a#7#1#0) < DtRank(#JSON.Grammar.Structural.Structural(a#7#0#0, a#7#1#0, a#7#2#0)));

function JSON_mGrammar.Structural.after(DatatypeType) : DatatypeType;

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Box, a#8#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#8#0#0, a#8#1#0, a#8#2#0) } JSON_mGrammar.Structural.after(#JSON.Grammar.Structural.Structural(a#8#0#0, a#8#1#0, a#8#2#0)) == a#8#2#0);

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Box, a#9#2#0: DatatypeType :: { #JSON.Grammar.Structural.Structural(a#9#0#0, a#9#1#0, a#9#2#0) } DtRank(a#9#2#0) < DtRank(#JSON.Grammar.Structural.Structural(a#9#0#0, a#9#1#0, a#9#2#0)));

function $IsA#JSON_mGrammar.Structural(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.Structural(d) } $IsA#JSON_mGrammar.Structural(d) ==> JSON_mGrammar.Structural.Structural_q(d));

axiom (forall JSON.Grammar.Structural$T: Ty, d: DatatypeType :: { JSON_mGrammar.Structural.Structural_q(d), $Is(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) } $Is(d, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Structural$T)) ==> JSON_mGrammar.Structural.Structural_q(d));

function JSON_mGrammar.Structural#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Structural#Equal(a, b) } JSON_mGrammar.Structural#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.Structural.before(a), JSON_mGrammar.Structural.before(b)) && JSON_mGrammar.Structural.t(a) == JSON_mGrammar.Structural.t(b) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.Structural.after(a), JSON_mGrammar.Structural.after(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Structural#Equal(a, b) } JSON_mGrammar.Structural#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.Structural: ClassName;

function #JSON.Grammar.Maybe.Empty() : DatatypeType
uses {
axiom DatatypeCtorId(#JSON.Grammar.Maybe.Empty()) == ##JSON.Grammar.Maybe.Empty;
axiom #JSON.Grammar.Maybe.Empty() == Lit(#JSON.Grammar.Maybe.Empty());
}

const unique ##JSON.Grammar.Maybe.Empty: DtCtorId
uses {
axiom DatatypeCtorId(#JSON.Grammar.Maybe.Empty()) == ##JSON.Grammar.Maybe.Empty;
}

function JSON_mGrammar.Maybe.Empty_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Maybe.Empty_q(d) } JSON_mGrammar.Maybe.Empty_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Maybe.Empty);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Maybe.Empty_q(d) } JSON_mGrammar.Maybe.Empty_q(d) ==> d == #JSON.Grammar.Maybe.Empty());

function Tclass.JSON_mGrammar.Maybe(Ty) : Ty;

const unique Tagclass.JSON_mGrammar.Maybe: TyTag;

axiom (forall JSON.Grammar.Maybe$T: Ty :: { Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T) } Tag(Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) == Tagclass.JSON_mGrammar.Maybe && TagFamily(Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) == tytagFamily$Maybe);

function Tclass.JSON_mGrammar.Maybe_0(Ty) : Ty;

axiom (forall JSON.Grammar.Maybe$T: Ty :: { Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T) } Tclass.JSON_mGrammar.Maybe_0(Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) == JSON.Grammar.Maybe$T);

axiom (forall JSON.Grammar.Maybe$T: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) } $IsBox(bx, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)));

axiom (forall JSON.Grammar.Maybe$T: Ty :: { $Is(#JSON.Grammar.Maybe.Empty(), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) } $Is(#JSON.Grammar.Maybe.Empty(), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)));

axiom (forall JSON.Grammar.Maybe$T: Ty, $h: Heap :: { $IsAlloc(#JSON.Grammar.Maybe.Empty(), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T), $h) } $IsGoodHeap($h) ==> $IsAlloc(#JSON.Grammar.Maybe.Empty(), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T), $h));

function #JSON.Grammar.Maybe.NonEmpty(Box) : DatatypeType;

const unique ##JSON.Grammar.Maybe.NonEmpty: DtCtorId
uses {
axiom (forall a#14#0#0: Box :: { #JSON.Grammar.Maybe.NonEmpty(a#14#0#0) } DatatypeCtorId(#JSON.Grammar.Maybe.NonEmpty(a#14#0#0)) == ##JSON.Grammar.Maybe.NonEmpty);
}

function JSON_mGrammar.Maybe.NonEmpty_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Maybe.NonEmpty_q(d) } JSON_mGrammar.Maybe.NonEmpty_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Maybe.NonEmpty);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Maybe.NonEmpty_q(d) } JSON_mGrammar.Maybe.NonEmpty_q(d) ==> (exists a#15#0#0: Box :: d == #JSON.Grammar.Maybe.NonEmpty(a#15#0#0)));

axiom (forall JSON.Grammar.Maybe$T: Ty, a#16#0#0: Box :: { $Is(#JSON.Grammar.Maybe.NonEmpty(a#16#0#0), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) } $Is(#JSON.Grammar.Maybe.NonEmpty(a#16#0#0), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) <==> $IsBox(a#16#0#0, JSON.Grammar.Maybe$T));

axiom (forall JSON.Grammar.Maybe$T: Ty, a#16#0#0: Box, $h: Heap :: { $IsAlloc(#JSON.Grammar.Maybe.NonEmpty(a#16#0#0), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Grammar.Maybe.NonEmpty(a#16#0#0), Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T), $h) <==> $IsAllocBox(a#16#0#0, JSON.Grammar.Maybe$T, $h)));

axiom (forall d: DatatypeType, JSON.Grammar.Maybe$T: Ty, $h: Heap :: { $IsAllocBox(JSON_mGrammar.Maybe.t(d), JSON.Grammar.Maybe$T, $h) } $IsGoodHeap($h) && JSON_mGrammar.Maybe.NonEmpty_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T), $h) ==> $IsAllocBox(JSON_mGrammar.Maybe.t(d), JSON.Grammar.Maybe$T, $h));

axiom (forall a#17#0#0: Box :: { #JSON.Grammar.Maybe.NonEmpty(Lit(a#17#0#0)) } #JSON.Grammar.Maybe.NonEmpty(Lit(a#17#0#0)) == Lit(#JSON.Grammar.Maybe.NonEmpty(a#17#0#0)));

function JSON_mGrammar.Maybe.t(DatatypeType) : Box;

axiom (forall a#18#0#0: Box :: { #JSON.Grammar.Maybe.NonEmpty(a#18#0#0) } JSON_mGrammar.Maybe.t(#JSON.Grammar.Maybe.NonEmpty(a#18#0#0)) == a#18#0#0);

axiom (forall a#19#0#0: Box :: { #JSON.Grammar.Maybe.NonEmpty(a#19#0#0) } BoxRank(a#19#0#0) < DtRank(#JSON.Grammar.Maybe.NonEmpty(a#19#0#0)));

function $IsA#JSON_mGrammar.Maybe(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.Maybe(d) } $IsA#JSON_mGrammar.Maybe(d) ==> JSON_mGrammar.Maybe.Empty_q(d) || JSON_mGrammar.Maybe.NonEmpty_q(d));

axiom (forall JSON.Grammar.Maybe$T: Ty, d: DatatypeType :: { JSON_mGrammar.Maybe.NonEmpty_q(d), $Is(d, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) } { JSON_mGrammar.Maybe.Empty_q(d), $Is(d, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) } $Is(d, Tclass.JSON_mGrammar.Maybe(JSON.Grammar.Maybe$T)) ==> JSON_mGrammar.Maybe.Empty_q(d) || JSON_mGrammar.Maybe.NonEmpty_q(d));

function JSON_mGrammar.Maybe#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Maybe#Equal(a, b), JSON_mGrammar.Maybe.Empty_q(a) } { JSON_mGrammar.Maybe#Equal(a, b), JSON_mGrammar.Maybe.Empty_q(b) } JSON_mGrammar.Maybe.Empty_q(a) && JSON_mGrammar.Maybe.Empty_q(b) ==> JSON_mGrammar.Maybe#Equal(a, b));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Maybe#Equal(a, b), JSON_mGrammar.Maybe.NonEmpty_q(a) } { JSON_mGrammar.Maybe#Equal(a, b), JSON_mGrammar.Maybe.NonEmpty_q(b) } JSON_mGrammar.Maybe.NonEmpty_q(a) && JSON_mGrammar.Maybe.NonEmpty_q(b) ==> (JSON_mGrammar.Maybe#Equal(a, b) <==> JSON_mGrammar.Maybe.t(a) == JSON_mGrammar.Maybe.t(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Maybe#Equal(a, b) } JSON_mGrammar.Maybe#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.Maybe: ClassName;

function #JSON.Grammar.Suffixed.Suffixed(Box, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Suffixed.Suffixed: DtCtorId
uses {
axiom (forall a#20#0#0: Box, a#20#1#0: DatatypeType :: { #JSON.Grammar.Suffixed.Suffixed(a#20#0#0, a#20#1#0) } DatatypeCtorId(#JSON.Grammar.Suffixed.Suffixed(a#20#0#0, a#20#1#0)) == ##JSON.Grammar.Suffixed.Suffixed);
}

function JSON_mGrammar.Suffixed.Suffixed_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Suffixed.Suffixed_q(d) } JSON_mGrammar.Suffixed.Suffixed_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Suffixed.Suffixed);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Suffixed.Suffixed_q(d) } JSON_mGrammar.Suffixed.Suffixed_q(d) ==> (exists a#21#0#0: Box, a#21#1#0: DatatypeType :: d == #JSON.Grammar.Suffixed.Suffixed(a#21#0#0, a#21#1#0)));

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty, a#22#0#0: Box, a#22#1#0: DatatypeType :: { $Is(#JSON.Grammar.Suffixed.Suffixed(a#22#0#0, a#22#1#0), Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) } $Is(#JSON.Grammar.Suffixed.Suffixed(a#22#0#0, a#22#1#0), Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) <==> $IsBox(a#22#0#0, JSON.Grammar.Suffixed$T) && $Is(a#22#1#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Suffixed$S))));

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty, a#22#0#0: Box, a#22#1#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Grammar.Suffixed.Suffixed(a#22#0#0, a#22#1#0), Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Grammar.Suffixed.Suffixed(a#22#0#0, a#22#1#0), Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S), $h) <==> $IsAllocBox(a#22#0#0, JSON.Grammar.Suffixed$T, $h) && $IsAlloc(a#22#1#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Suffixed$S)), $h)));

axiom (forall d: DatatypeType, JSON.Grammar.Suffixed$T: Ty, $h: Heap :: { $IsAllocBox(JSON_mGrammar.Suffixed.t(d), JSON.Grammar.Suffixed$T, $h) } $IsGoodHeap($h) && JSON_mGrammar.Suffixed.Suffixed_q(d) && (exists JSON.Grammar.Suffixed$S: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S), $h)) ==> $IsAllocBox(JSON_mGrammar.Suffixed.t(d), JSON.Grammar.Suffixed$T, $h));

axiom (forall d: DatatypeType, JSON.Grammar.Suffixed$S: Ty, $h: Heap :: { $IsAlloc(JSON_mGrammar.Suffixed.suffix(d), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Suffixed$S)), $h) } $IsGoodHeap($h) && JSON_mGrammar.Suffixed.Suffixed_q(d) && (exists JSON.Grammar.Suffixed$T: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S), $h)) ==> $IsAlloc(JSON_mGrammar.Suffixed.suffix(d), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(JSON.Grammar.Suffixed$S)), $h));

axiom (forall a#23#0#0: Box, a#23#1#0: DatatypeType :: { #JSON.Grammar.Suffixed.Suffixed(Lit(a#23#0#0), Lit(a#23#1#0)) } #JSON.Grammar.Suffixed.Suffixed(Lit(a#23#0#0), Lit(a#23#1#0)) == Lit(#JSON.Grammar.Suffixed.Suffixed(a#23#0#0, a#23#1#0)));

function JSON_mGrammar.Suffixed.t(DatatypeType) : Box;

axiom (forall a#24#0#0: Box, a#24#1#0: DatatypeType :: { #JSON.Grammar.Suffixed.Suffixed(a#24#0#0, a#24#1#0) } JSON_mGrammar.Suffixed.t(#JSON.Grammar.Suffixed.Suffixed(a#24#0#0, a#24#1#0)) == a#24#0#0);

axiom (forall a#25#0#0: Box, a#25#1#0: DatatypeType :: { #JSON.Grammar.Suffixed.Suffixed(a#25#0#0, a#25#1#0) } BoxRank(a#25#0#0) < DtRank(#JSON.Grammar.Suffixed.Suffixed(a#25#0#0, a#25#1#0)));

function JSON_mGrammar.Suffixed.suffix(DatatypeType) : DatatypeType;

axiom (forall a#26#0#0: Box, a#26#1#0: DatatypeType :: { #JSON.Grammar.Suffixed.Suffixed(a#26#0#0, a#26#1#0) } JSON_mGrammar.Suffixed.suffix(#JSON.Grammar.Suffixed.Suffixed(a#26#0#0, a#26#1#0)) == a#26#1#0);

axiom (forall a#27#0#0: Box, a#27#1#0: DatatypeType :: { #JSON.Grammar.Suffixed.Suffixed(a#27#0#0, a#27#1#0) } DtRank(a#27#1#0) < DtRank(#JSON.Grammar.Suffixed.Suffixed(a#27#0#0, a#27#1#0)));

function $IsA#JSON_mGrammar.Suffixed(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.Suffixed(d) } $IsA#JSON_mGrammar.Suffixed(d) ==> JSON_mGrammar.Suffixed.Suffixed_q(d));

axiom (forall JSON.Grammar.Suffixed$T: Ty, JSON.Grammar.Suffixed$S: Ty, d: DatatypeType :: { JSON_mGrammar.Suffixed.Suffixed_q(d), $Is(d, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) } $Is(d, Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.Suffixed$T, JSON.Grammar.Suffixed$S)) ==> JSON_mGrammar.Suffixed.Suffixed_q(d));

function JSON_mGrammar.Suffixed#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Suffixed#Equal(a, b) } JSON_mGrammar.Suffixed#Equal(a, b) <==> JSON_mGrammar.Suffixed.t(a) == JSON_mGrammar.Suffixed.t(b) && JSON_mGrammar.Maybe#Equal(JSON_mGrammar.Suffixed.suffix(a), JSON_mGrammar.Suffixed.suffix(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Suffixed#Equal(a, b) } JSON_mGrammar.Suffixed#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.Suffixed: ClassName;

procedure {:verboseName "JSON.Grammar.SuffixedSequence (well-formedness)"} CheckWellFormed$$JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty, s#0: Seq where $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S))));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.SuffixedSequence (well-formedness)"} CheckWellFormed$$JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty, s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.SuffixedSequence", " | ", JSON.Grammar.SuffixedSequence$D, " | ", JSON.Grammar.SuffixedSequence$S, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(53,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##s#0 := s#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar.SuffixedSequence$S, JSON.Grammar.SuffixedSequence$D, s#0);
    assume JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar.SuffixedSequence$S, JSON.Grammar.SuffixedSequence$D, s#0);
    return;

  anon4_Else:
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar.SuffixedSequence$S, JSON.Grammar.SuffixedSequence$D, Lit(Seq#Empty(): Seq));
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar.SuffixedSequence$S, JSON.Grammar.SuffixedSequence$D, Lit(Seq#Empty(): Seq)) ==> Lit(JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar.SuffixedSequence$S, JSON.Grammar.SuffixedSequence$D, Lit(Seq#Empty(): Seq))) || (forall idx#0: int :: { $Unbox(Seq#Index(Seq#Empty(): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length(Lit(Seq#Empty(): Seq)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(Seq#Empty(): Seq), idx#0)): DatatypeType)) <==> idx#0 == Seq#Length(Lit(Seq#Empty(): Seq)) - 1));
    return;
}



function Tclass.JSON_mGrammar.SuffixedSequence(Ty, Ty) : Ty;

const unique Tagclass.JSON_mGrammar.SuffixedSequence: TyTag;

axiom (forall JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty :: { Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S) } Tag(Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) == Tagclass.JSON_mGrammar.SuffixedSequence && TagFamily(Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) == tytagFamily$SuffixedSequence);

function Tclass.JSON_mGrammar.SuffixedSequence_0(Ty) : Ty;

axiom (forall JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty :: { Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S) } Tclass.JSON_mGrammar.SuffixedSequence_0(Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) == JSON.Grammar.SuffixedSequence$D);

function Tclass.JSON_mGrammar.SuffixedSequence_1(Ty) : Ty;

axiom (forall JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty :: { Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S) } Tclass.JSON_mGrammar.SuffixedSequence_1(Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) == JSON.Grammar.SuffixedSequence$S);

axiom (forall JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) } $IsBox(bx, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)));

axiom (forall JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty, s#0: Seq :: { $Is(s#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) } $Is(s#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)) <==> $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S))) && JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar.SuffixedSequence$S, JSON.Grammar.SuffixedSequence$D, s#0));

axiom (forall JSON.Grammar.SuffixedSequence$D: Ty, JSON.Grammar.SuffixedSequence$S: Ty, s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S), $h) } $IsAlloc(s#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S), $h) <==> $IsAlloc(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar.SuffixedSequence$D, JSON.Grammar.SuffixedSequence$S)), $h));

function #JSON.Grammar.Bracketed.Bracketed(DatatypeType, Seq, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Bracketed.Bracketed: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq, a#0#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#0#0#0, a#0#1#0, a#0#2#0) } DatatypeCtorId(#JSON.Grammar.Bracketed.Bracketed(a#0#0#0, a#0#1#0, a#0#2#0)) == ##JSON.Grammar.Bracketed.Bracketed);
}

function JSON_mGrammar.Bracketed.Bracketed_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Bracketed.Bracketed_q(d) } JSON_mGrammar.Bracketed.Bracketed_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Bracketed.Bracketed);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Bracketed.Bracketed_q(d) } JSON_mGrammar.Bracketed.Bracketed_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq, a#1#2#0: DatatypeType :: d == #JSON.Grammar.Bracketed.Bracketed(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.JSON_mGrammar.Bracketed(Ty, Ty, Ty, Ty) : Ty;

const unique Tagclass.JSON_mGrammar.Bracketed: TyTag;

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty :: { Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R) } Tag(Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) == Tagclass.JSON_mGrammar.Bracketed && TagFamily(Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) == tytagFamily$Bracketed);

function Tclass.JSON_mGrammar.Bracketed_0(Ty) : Ty;

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty :: { Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R) } Tclass.JSON_mGrammar.Bracketed_0(Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) == JSON.Grammar.Bracketed$L);

function Tclass.JSON_mGrammar.Bracketed_1(Ty) : Ty;

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty :: { Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R) } Tclass.JSON_mGrammar.Bracketed_1(Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) == JSON.Grammar.Bracketed$D);

function Tclass.JSON_mGrammar.Bracketed_2(Ty) : Ty;

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty :: { Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R) } Tclass.JSON_mGrammar.Bracketed_2(Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) == JSON.Grammar.Bracketed$S);

function Tclass.JSON_mGrammar.Bracketed_3(Ty) : Ty;

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty :: { Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R) } Tclass.JSON_mGrammar.Bracketed_3(Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) == JSON.Grammar.Bracketed$R);

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty, bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) } $IsBox(bx, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)));

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty, a#2#0#0: DatatypeType, a#2#1#0: Seq, a#2#2#0: DatatypeType :: { $Is(#JSON.Grammar.Bracketed.Bracketed(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) } $Is(#JSON.Grammar.Bracketed.Bracketed(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) <==> $Is(a#2#0#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$L)) && $Is(a#2#1#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S)) && $Is(a#2#2#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$R)));

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty, a#2#0#0: DatatypeType, a#2#1#0: Seq, a#2#2#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Grammar.Bracketed.Bracketed(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Grammar.Bracketed.Bracketed(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) <==> $IsAlloc(a#2#0#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$L), $h) && $IsAlloc(a#2#1#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S), $h) && $IsAlloc(a#2#2#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$R), $h)));

axiom (forall d: DatatypeType, JSON.Grammar.Bracketed$L: Ty, $h: Heap :: { $IsAlloc(JSON_mGrammar.Bracketed.l(d), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$L), $h) } $IsGoodHeap($h) && JSON_mGrammar.Bracketed.Bracketed_q(d) && (exists JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h)) ==> $IsAlloc(JSON_mGrammar.Bracketed.l(d), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$L), $h));

axiom (forall d: DatatypeType, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, $h: Heap :: { $IsAlloc(JSON_mGrammar.Bracketed.data(d), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S), $h) } $IsGoodHeap($h) && JSON_mGrammar.Bracketed.Bracketed_q(d) && (exists JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$R: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h)) ==> $IsAlloc(JSON_mGrammar.Bracketed.data(d), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S), $h));

axiom (forall d: DatatypeType, JSON.Grammar.Bracketed$R: Ty, $h: Heap :: { $IsAlloc(JSON_mGrammar.Bracketed.r(d), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$R), $h) } $IsGoodHeap($h) && JSON_mGrammar.Bracketed.Bracketed_q(d) && (exists JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty :: { $IsAlloc(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) } $IsAlloc(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h)) ==> $IsAlloc(JSON_mGrammar.Bracketed.r(d), Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$R), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq, a#3#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) } #JSON.Grammar.Bracketed.Bracketed(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) == Lit(#JSON.Grammar.Bracketed.Bracketed(a#3#0#0, a#3#1#0, a#3#2#0)));

function JSON_mGrammar.Bracketed.l(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq, a#4#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#4#0#0, a#4#1#0, a#4#2#0) } JSON_mGrammar.Bracketed.l(#JSON.Grammar.Bracketed.Bracketed(a#4#0#0, a#4#1#0, a#4#2#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq, a#5#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#5#0#0, a#5#1#0, a#5#2#0) } DtRank(a#5#0#0) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#5#0#0, a#5#1#0, a#5#2#0)));

function JSON_mGrammar.Bracketed.data(DatatypeType) : Seq;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq, a#6#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#6#0#0, a#6#1#0, a#6#2#0) } JSON_mGrammar.Bracketed.data(#JSON.Grammar.Bracketed.Bracketed(a#6#0#0, a#6#1#0, a#6#2#0)) == a#6#1#0);

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq, a#7#2#0: DatatypeType, i: int :: { Seq#Index(a#7#1#0, i), #JSON.Grammar.Bracketed.Bracketed(a#7#0#0, a#7#1#0, a#7#2#0) } 0 <= i && i < Seq#Length(a#7#1#0) ==> DtRank($Unbox(Seq#Index(a#7#1#0, i)): DatatypeType) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#7#0#0, a#7#1#0, a#7#2#0)));

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq, a#8#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#8#0#0, a#8#1#0, a#8#2#0) } Seq#Rank(a#8#1#0) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#8#0#0, a#8#1#0, a#8#2#0)));

function JSON_mGrammar.Bracketed.r(DatatypeType) : DatatypeType;

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq, a#9#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#9#0#0, a#9#1#0, a#9#2#0) } JSON_mGrammar.Bracketed.r(#JSON.Grammar.Bracketed.Bracketed(a#9#0#0, a#9#1#0, a#9#2#0)) == a#9#2#0);

axiom (forall a#10#0#0: DatatypeType, a#10#1#0: Seq, a#10#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#10#0#0, a#10#1#0, a#10#2#0) } DtRank(a#10#2#0) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#10#0#0, a#10#1#0, a#10#2#0)));

function $IsA#JSON_mGrammar.Bracketed(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.Bracketed(d) } $IsA#JSON_mGrammar.Bracketed(d) ==> JSON_mGrammar.Bracketed.Bracketed_q(d));

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty, d: DatatypeType :: { JSON_mGrammar.Bracketed.Bracketed_q(d), $Is(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) } $Is(d, Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) ==> JSON_mGrammar.Bracketed.Bracketed_q(d));

function JSON_mGrammar.Bracketed#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Bracketed#Equal(a, b) } JSON_mGrammar.Bracketed#Equal(a, b) <==> JSON_mGrammar.Structural#Equal(JSON_mGrammar.Bracketed.l(a), JSON_mGrammar.Bracketed.l(b)) && Seq#Equal(JSON_mGrammar.Bracketed.data(a), JSON_mGrammar.Bracketed.data(b)) && JSON_mGrammar.Structural#Equal(JSON_mGrammar.Bracketed.r(a), JSON_mGrammar.Bracketed.r(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Bracketed#Equal(a, b) } JSON_mGrammar.Bracketed#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.Bracketed: ClassName;

procedure {:verboseName "JSON.Grammar.jnull (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jnull(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jnull (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jnull(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jnull", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(72,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Null_q#canCall(v#0);
    assume JSON_mGrammar.__default.Null_q(v#0);
    return;

  anon4_Else:
    ##bs#0 := JSON_mGrammar.__default.NULL();
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL());
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL()));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL());
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL()) && JSON_mGrammar.__default.Null_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL()));
    assume {:subsumption 0} JSON_mGrammar.__default.Null_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())) ==> JSON_mGrammar.__default.Null_q(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())), JSON_mGrammar.__default.NULL());
    return;
}



function Tclass.JSON_mGrammar.jnull() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jnull()) == Tagclass.JSON_mGrammar.jnull && TagFamily(Tclass.JSON_mGrammar.jnull()) == tytagFamily$jnull;
}

const unique Tagclass.JSON_mGrammar.jnull: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jnull()) } $IsBox(bx, Tclass.JSON_mGrammar.jnull()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jnull()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jnull()) } $Is(v#0, Tclass.JSON_mGrammar.jnull()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mGrammar.__default.Null_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jnull(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jnull(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jbool (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jbool(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jbool (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jbool(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jbool", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(73,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Bool_q#canCall(v#0);
    assume JSON_mGrammar.__default.Bool_q(v#0);
    return;

  anon4_Else:
    ##bs#0 := JSON_mGrammar.__default.TRUE();
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.TRUE());
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE()));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE());
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.TRUE()) && JSON_mGrammar.__default.Bool_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE()));
    assume {:subsumption 0} JSON_mGrammar.__default.Bool_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE())) ==> JSON_mGrammar.__default.Bool_q(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE())) || JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE())) == JSON_mGrammar.__default.TRUE() || JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.TRUE())) == JSON_mGrammar.__default.FALSE();
    return;
}



function Tclass.JSON_mGrammar.jbool() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jbool()) == Tagclass.JSON_mGrammar.jbool && TagFamily(Tclass.JSON_mGrammar.jbool()) == tytagFamily$jbool;
}

const unique Tagclass.JSON_mGrammar.jbool: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jbool()) } $IsBox(bx, Tclass.JSON_mGrammar.jbool()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jbool()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jbool()) } $Is(v#0, Tclass.JSON_mGrammar.jbool()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mGrammar.__default.Bool_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jbool(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jbool(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jdigits (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jdigits(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jdigits (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jdigits(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jdigits", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(74,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Digits_q#canCall(v#0);
    assume JSON_mGrammar.__default.Digits_q(v#0);
    return;

  anon4_Else:
    ##bs#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.View_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    newtype$check#0 := Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq)) && JSON_mGrammar.__default.Digits_q#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    assume {:subsumption 0} JSON_mGrammar.__default.Digits_q#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)))) ==> Lit(JSON_mGrammar.__default.Digits_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))))) || (forall b#0: int :: { JSON_mGrammar.__default.Digit_q(b#0) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Empty(): Seq)), $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)))), $Box(b#0)) ==> JSON_mGrammar.__default.Digit_q(b#0));
    return;
}



function Tclass.JSON_mGrammar.jdigits() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jdigits()) == Tagclass.JSON_mGrammar.jdigits && TagFamily(Tclass.JSON_mGrammar.jdigits()) == tytagFamily$jdigits;
}

const unique Tagclass.JSON_mGrammar.jdigits: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jdigits()) } $IsBox(bx, Tclass.JSON_mGrammar.jdigits()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jdigits()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jdigits()) } $Is(v#0, Tclass.JSON_mGrammar.jdigits()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mGrammar.__default.Digits_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jdigits(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jdigits(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jnum (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jnum(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jnum (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jnum(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;
  var newtype$check#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jnum", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(75,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Num_q#canCall(v#0);
    assume JSON_mGrammar.__default.Num_q(v#0);
    return;

  anon4_Else:
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))));
    newtype$check#2 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#2);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))) && JSON_mGrammar.__default.Num_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))));
    assume {:subsumption 0} JSON_mGrammar.__default.Num_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) ==> JSON_mGrammar.__default.Num_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) || (JSON_mGrammar.__default.Digits_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) ==> JSON_mGrammar.__default.Digits_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))));
    assume {:subsumption 0} JSON_mGrammar.__default.Num_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) ==> JSON_mGrammar.__default.Num_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) || !JSON_mUtils_mViews_mCore.View__.Empty_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))));
    return;
}



function Tclass.JSON_mGrammar.jnum() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jnum()) == Tagclass.JSON_mGrammar.jnum && TagFamily(Tclass.JSON_mGrammar.jnum()) == tytagFamily$jnum;
}

const unique Tagclass.JSON_mGrammar.jnum: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jnum()) } $IsBox(bx, Tclass.JSON_mGrammar.jnum()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jnum()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jnum()) } $Is(v#0, Tclass.JSON_mGrammar.jnum()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mGrammar.__default.Num_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jnum(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jnum(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jint (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jint(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jint (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jint(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;
  var newtype$check#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jint", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(76,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mGrammar.__default.Int_q#canCall(v#0);
    assume JSON_mGrammar.__default.Int_q(v#0);
    return;

  anon4_Else:
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))));
    newtype$check#2 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#2);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))) && JSON_mGrammar.__default.Int_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))));
    assume {:subsumption 0} JSON_mGrammar.__default.Int_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) ==> JSON_mGrammar.__default.Int_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) || JSON_mUtils_mViews_mCore.View__.Char_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))), Lit(char#FromInt(48))) || (JSON_mGrammar.__default.Num_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))))) && JSON_mUtils_mViews_mCore.View__.At(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48)))))), LitInt(0)) != char#ToInt(Lit(char#FromInt(48))));
    return;
}



function Tclass.JSON_mGrammar.jint() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jint()) == Tagclass.JSON_mGrammar.jint && TagFamily(Tclass.JSON_mGrammar.jint()) == tytagFamily$jint;
}

const unique Tagclass.JSON_mGrammar.jint: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jint()) } $IsBox(bx, Tclass.JSON_mGrammar.jint()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jint()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jint()) } $Is(v#0, Tclass.JSON_mGrammar.jint()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mGrammar.__default.Int_q(v#0));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jint(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jint(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.Grammar.jstr (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jstr(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Grammar.jstr (well-formedness)"} CheckWellFormed$$JSON_mGrammar.jstr(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Grammar.jstr", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Grammar.dfy(77,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume true;
    return;

  anon4_Else:
    ##bs#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.View_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    newtype$check#0 := Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume true;
    assume Lit(true);
    return;
}



function Tclass.JSON_mGrammar.jstr() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jstr()) == Tagclass.JSON_mGrammar.jstr && TagFamily(Tclass.JSON_mGrammar.jstr()) == tytagFamily$jstr;
}

const unique Tagclass.JSON_mGrammar.jstr: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jstr()) } $IsBox(bx, Tclass.JSON_mGrammar.jstr()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jstr()));

axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mGrammar.jstr()) } $Is(v#0, Tclass.JSON_mGrammar.jstr()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(true));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mGrammar.jstr(), $h) } $IsAlloc(v#0, Tclass.JSON_mGrammar.jstr(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

function #JSON.Grammar.jstring.JString(DatatypeType, DatatypeType, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.jstring.JString: DtCtorId
uses {
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: DatatypeType, a#0#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#0#0#0, a#0#1#0, a#0#2#0) } DatatypeCtorId(#JSON.Grammar.jstring.JString(a#0#0#0, a#0#1#0, a#0#2#0)) == ##JSON.Grammar.jstring.JString);
}

function JSON_mGrammar.jstring.JString_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.jstring.JString_q(d) } JSON_mGrammar.jstring.JString_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.jstring.JString);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jstring.JString_q(d) } JSON_mGrammar.jstring.JString_q(d) ==> (exists a#1#0#0: DatatypeType, a#1#1#0: DatatypeType, a#1#2#0: DatatypeType :: d == #JSON.Grammar.jstring.JString(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.JSON_mGrammar.jstring() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jstring()) == Tagclass.JSON_mGrammar.jstring && TagFamily(Tclass.JSON_mGrammar.jstring()) == tytagFamily$jstring;
}

const unique Tagclass.JSON_mGrammar.jstring: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jstring()) } $IsBox(bx, Tclass.JSON_mGrammar.jstring()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jstring()));

axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType, a#2#2#0: DatatypeType :: { $Is(#JSON.Grammar.jstring.JString(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.jstring()) } $Is(#JSON.Grammar.jstring.JString(a#2#0#0, a#2#1#0, a#2#2#0), Tclass.JSON_mGrammar.jstring()) <==> $Is(a#2#0#0, Tclass.JSON_mGrammar.jquote()) && $Is(a#2#1#0, Tclass.JSON_mGrammar.jstr()) && $Is(a#2#2#0, Tclass.JSON_mGrammar.jquote()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jstring.lq(d), Tclass.JSON_mGrammar.jquote(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jstring.JString_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jstring(), $h) ==> $IsAlloc(JSON_mGrammar.jstring.lq(d), Tclass.JSON_mGrammar.jquote(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jstring.contents(d), Tclass.JSON_mGrammar.jstr(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jstring.JString_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jstring(), $h) ==> $IsAlloc(JSON_mGrammar.jstring.contents(d), Tclass.JSON_mGrammar.jstr(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jstring.rq(d), Tclass.JSON_mGrammar.jquote(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jstring.JString_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jstring(), $h) ==> $IsAlloc(JSON_mGrammar.jstring.rq(d), Tclass.JSON_mGrammar.jquote(), $h));

axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType, a#3#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) } #JSON.Grammar.jstring.JString(Lit(a#3#0#0), Lit(a#3#1#0), Lit(a#3#2#0)) == Lit(#JSON.Grammar.jstring.JString(a#3#0#0, a#3#1#0, a#3#2#0)));

function JSON_mGrammar.jstring.lq(DatatypeType) : DatatypeType;

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType, a#4#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#4#0#0, a#4#1#0, a#4#2#0) } JSON_mGrammar.jstring.lq(#JSON.Grammar.jstring.JString(a#4#0#0, a#4#1#0, a#4#2#0)) == a#4#0#0);

axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType, a#5#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#5#0#0, a#5#1#0, a#5#2#0) } DtRank(a#5#0#0) < DtRank(#JSON.Grammar.jstring.JString(a#5#0#0, a#5#1#0, a#5#2#0)));

function JSON_mGrammar.jstring.contents(DatatypeType) : DatatypeType;

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType, a#6#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#6#0#0, a#6#1#0, a#6#2#0) } JSON_mGrammar.jstring.contents(#JSON.Grammar.jstring.JString(a#6#0#0, a#6#1#0, a#6#2#0)) == a#6#1#0);

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType, a#7#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#7#0#0, a#7#1#0, a#7#2#0) } DtRank(a#7#1#0) < DtRank(#JSON.Grammar.jstring.JString(a#7#0#0, a#7#1#0, a#7#2#0)));

function JSON_mGrammar.jstring.rq(DatatypeType) : DatatypeType;

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType, a#8#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#8#0#0, a#8#1#0, a#8#2#0) } JSON_mGrammar.jstring.rq(#JSON.Grammar.jstring.JString(a#8#0#0, a#8#1#0, a#8#2#0)) == a#8#2#0);

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: DatatypeType, a#9#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#9#0#0, a#9#1#0, a#9#2#0) } DtRank(a#9#2#0) < DtRank(#JSON.Grammar.jstring.JString(a#9#0#0, a#9#1#0, a#9#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mGrammar.jstring(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mGrammar.jstring()) ==> $IsAlloc(d, Tclass.JSON_mGrammar.jstring(), $h));

function $IsA#JSON_mGrammar.jstring(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.jstring(d) } $IsA#JSON_mGrammar.jstring(d) ==> JSON_mGrammar.jstring.JString_q(d));

axiom (forall d: DatatypeType :: { JSON_mGrammar.jstring.JString_q(d), $Is(d, Tclass.JSON_mGrammar.jstring()) } $Is(d, Tclass.JSON_mGrammar.jstring()) ==> JSON_mGrammar.jstring.JString_q(d));

function JSON_mGrammar.jstring#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jstring#Equal(a, b) } JSON_mGrammar.jstring#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jstring.lq(a), JSON_mGrammar.jstring.lq(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jstring.contents(a), JSON_mGrammar.jstring.contents(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jstring.rq(a), JSON_mGrammar.jstring.rq(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jstring#Equal(a, b) } JSON_mGrammar.jstring#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.jstring: ClassName;

function #JSON.Grammar.jKeyValue.KeyValue(DatatypeType, DatatypeType, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.jKeyValue.KeyValue: DtCtorId
uses {
axiom (forall a#10#0#0: DatatypeType, a#10#1#0: DatatypeType, a#10#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#10#0#0, a#10#1#0, a#10#2#0) } DatatypeCtorId(#JSON.Grammar.jKeyValue.KeyValue(a#10#0#0, a#10#1#0, a#10#2#0)) == ##JSON.Grammar.jKeyValue.KeyValue);
}

function JSON_mGrammar.jKeyValue.KeyValue_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.jKeyValue.KeyValue_q(d) } JSON_mGrammar.jKeyValue.KeyValue_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.jKeyValue.KeyValue);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jKeyValue.KeyValue_q(d) } JSON_mGrammar.jKeyValue.KeyValue_q(d) ==> (exists a#11#0#0: DatatypeType, a#11#1#0: DatatypeType, a#11#2#0: DatatypeType :: d == #JSON.Grammar.jKeyValue.KeyValue(a#11#0#0, a#11#1#0, a#11#2#0)));

function Tclass.JSON_mGrammar.jKeyValue() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jKeyValue()) == Tagclass.JSON_mGrammar.jKeyValue && TagFamily(Tclass.JSON_mGrammar.jKeyValue()) == tytagFamily$jKeyValue;
}

const unique Tagclass.JSON_mGrammar.jKeyValue: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jKeyValue()) } $IsBox(bx, Tclass.JSON_mGrammar.jKeyValue()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jKeyValue()));

function Tclass.JSON_mGrammar.Value() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.Value()) == Tagclass.JSON_mGrammar.Value && TagFamily(Tclass.JSON_mGrammar.Value()) == tytagFamily$Value;
}

const unique Tagclass.JSON_mGrammar.Value: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.Value()) } $IsBox(bx, Tclass.JSON_mGrammar.Value()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.Value()));

axiom (forall a#12#0#0: DatatypeType, a#12#1#0: DatatypeType, a#12#2#0: DatatypeType :: { $Is(#JSON.Grammar.jKeyValue.KeyValue(a#12#0#0, a#12#1#0, a#12#2#0), Tclass.JSON_mGrammar.jKeyValue()) } $Is(#JSON.Grammar.jKeyValue.KeyValue(a#12#0#0, a#12#1#0, a#12#2#0), Tclass.JSON_mGrammar.jKeyValue()) <==> $Is(a#12#0#0, Tclass.JSON_mGrammar.jstring()) && $Is(a#12#1#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) && $Is(a#12#2#0, Tclass.JSON_mGrammar.Value()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jKeyValue.k(d), Tclass.JSON_mGrammar.jstring(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jKeyValue.KeyValue_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jKeyValue(), $h) ==> $IsAlloc(JSON_mGrammar.jKeyValue.k(d), Tclass.JSON_mGrammar.jstring(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jKeyValue.colon(d), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $h) } $IsGoodHeap($h) && JSON_mGrammar.jKeyValue.KeyValue_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jKeyValue(), $h) ==> $IsAlloc(JSON_mGrammar.jKeyValue.colon(d), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jKeyValue.v(d), Tclass.JSON_mGrammar.Value(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jKeyValue.KeyValue_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jKeyValue(), $h) ==> $IsAlloc(JSON_mGrammar.jKeyValue.v(d), Tclass.JSON_mGrammar.Value(), $h));

axiom (forall a#13#0#0: DatatypeType, a#13#1#0: DatatypeType, a#13#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(Lit(a#13#0#0), Lit(a#13#1#0), Lit(a#13#2#0)) } #JSON.Grammar.jKeyValue.KeyValue(Lit(a#13#0#0), Lit(a#13#1#0), Lit(a#13#2#0)) == Lit(#JSON.Grammar.jKeyValue.KeyValue(a#13#0#0, a#13#1#0, a#13#2#0)));

function JSON_mGrammar.jKeyValue.k(DatatypeType) : DatatypeType;

axiom (forall a#14#0#0: DatatypeType, a#14#1#0: DatatypeType, a#14#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#14#0#0, a#14#1#0, a#14#2#0) } JSON_mGrammar.jKeyValue.k(#JSON.Grammar.jKeyValue.KeyValue(a#14#0#0, a#14#1#0, a#14#2#0)) == a#14#0#0);

axiom (forall a#15#0#0: DatatypeType, a#15#1#0: DatatypeType, a#15#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#15#0#0, a#15#1#0, a#15#2#0) } DtRank(a#15#0#0) < DtRank(#JSON.Grammar.jKeyValue.KeyValue(a#15#0#0, a#15#1#0, a#15#2#0)));

function JSON_mGrammar.jKeyValue.colon(DatatypeType) : DatatypeType;

axiom (forall a#16#0#0: DatatypeType, a#16#1#0: DatatypeType, a#16#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#16#0#0, a#16#1#0, a#16#2#0) } JSON_mGrammar.jKeyValue.colon(#JSON.Grammar.jKeyValue.KeyValue(a#16#0#0, a#16#1#0, a#16#2#0)) == a#16#1#0);

axiom (forall a#17#0#0: DatatypeType, a#17#1#0: DatatypeType, a#17#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#17#0#0, a#17#1#0, a#17#2#0) } DtRank(a#17#1#0) < DtRank(#JSON.Grammar.jKeyValue.KeyValue(a#17#0#0, a#17#1#0, a#17#2#0)));

function JSON_mGrammar.jKeyValue.v(DatatypeType) : DatatypeType;

axiom (forall a#18#0#0: DatatypeType, a#18#1#0: DatatypeType, a#18#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#18#0#0, a#18#1#0, a#18#2#0) } JSON_mGrammar.jKeyValue.v(#JSON.Grammar.jKeyValue.KeyValue(a#18#0#0, a#18#1#0, a#18#2#0)) == a#18#2#0);

axiom (forall a#19#0#0: DatatypeType, a#19#1#0: DatatypeType, a#19#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#19#0#0, a#19#1#0, a#19#2#0) } DtRank(a#19#2#0) < DtRank(#JSON.Grammar.jKeyValue.KeyValue(a#19#0#0, a#19#1#0, a#19#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mGrammar.jKeyValue(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mGrammar.jKeyValue()) ==> $IsAlloc(d, Tclass.JSON_mGrammar.jKeyValue(), $h));

function $IsA#JSON_mGrammar.jKeyValue(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.jKeyValue(d) } $IsA#JSON_mGrammar.jKeyValue(d) ==> JSON_mGrammar.jKeyValue.KeyValue_q(d));

axiom (forall d: DatatypeType :: { JSON_mGrammar.jKeyValue.KeyValue_q(d), $Is(d, Tclass.JSON_mGrammar.jKeyValue()) } $Is(d, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mGrammar.jKeyValue.KeyValue_q(d));

function JSON_mGrammar.jKeyValue#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jKeyValue#Equal(a, b) } JSON_mGrammar.jKeyValue#Equal(a, b) <==> JSON_mGrammar.jstring#Equal(JSON_mGrammar.jKeyValue.k(a), JSON_mGrammar.jKeyValue.k(b)) && JSON_mGrammar.Structural#Equal(JSON_mGrammar.jKeyValue.colon(a), JSON_mGrammar.jKeyValue.colon(b)) && JSON_mGrammar.Value#Equal(JSON_mGrammar.jKeyValue.v(a), JSON_mGrammar.jKeyValue.v(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jKeyValue#Equal(a, b) } JSON_mGrammar.jKeyValue#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.jKeyValue: ClassName;

function #JSON.Grammar.jfrac.JFrac(DatatypeType, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.jfrac.JFrac: DtCtorId
uses {
axiom (forall a#20#0#0: DatatypeType, a#20#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#20#0#0, a#20#1#0) } DatatypeCtorId(#JSON.Grammar.jfrac.JFrac(a#20#0#0, a#20#1#0)) == ##JSON.Grammar.jfrac.JFrac);
}

function JSON_mGrammar.jfrac.JFrac_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.jfrac.JFrac_q(d) } JSON_mGrammar.jfrac.JFrac_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.jfrac.JFrac);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jfrac.JFrac_q(d) } JSON_mGrammar.jfrac.JFrac_q(d) ==> (exists a#21#0#0: DatatypeType, a#21#1#0: DatatypeType :: d == #JSON.Grammar.jfrac.JFrac(a#21#0#0, a#21#1#0)));

function Tclass.JSON_mGrammar.jfrac() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jfrac()) == Tagclass.JSON_mGrammar.jfrac && TagFamily(Tclass.JSON_mGrammar.jfrac()) == tytagFamily$jfrac;
}

const unique Tagclass.JSON_mGrammar.jfrac: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jfrac()) } $IsBox(bx, Tclass.JSON_mGrammar.jfrac()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jfrac()));

axiom (forall a#22#0#0: DatatypeType, a#22#1#0: DatatypeType :: { $Is(#JSON.Grammar.jfrac.JFrac(a#22#0#0, a#22#1#0), Tclass.JSON_mGrammar.jfrac()) } $Is(#JSON.Grammar.jfrac.JFrac(a#22#0#0, a#22#1#0), Tclass.JSON_mGrammar.jfrac()) <==> $Is(a#22#0#0, Tclass.JSON_mGrammar.jperiod()) && $Is(a#22#1#0, Tclass.JSON_mGrammar.jnum()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jfrac.period(d), Tclass.JSON_mGrammar.jperiod(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jfrac.JFrac_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jfrac(), $h) ==> $IsAlloc(JSON_mGrammar.jfrac.period(d), Tclass.JSON_mGrammar.jperiod(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jfrac.num(d), Tclass.JSON_mGrammar.jnum(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jfrac.JFrac_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jfrac(), $h) ==> $IsAlloc(JSON_mGrammar.jfrac.num(d), Tclass.JSON_mGrammar.jnum(), $h));

axiom (forall a#23#0#0: DatatypeType, a#23#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(Lit(a#23#0#0), Lit(a#23#1#0)) } #JSON.Grammar.jfrac.JFrac(Lit(a#23#0#0), Lit(a#23#1#0)) == Lit(#JSON.Grammar.jfrac.JFrac(a#23#0#0, a#23#1#0)));

function JSON_mGrammar.jfrac.period(DatatypeType) : DatatypeType;

axiom (forall a#24#0#0: DatatypeType, a#24#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#24#0#0, a#24#1#0) } JSON_mGrammar.jfrac.period(#JSON.Grammar.jfrac.JFrac(a#24#0#0, a#24#1#0)) == a#24#0#0);

axiom (forall a#25#0#0: DatatypeType, a#25#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#25#0#0, a#25#1#0) } DtRank(a#25#0#0) < DtRank(#JSON.Grammar.jfrac.JFrac(a#25#0#0, a#25#1#0)));

function JSON_mGrammar.jfrac.num(DatatypeType) : DatatypeType;

axiom (forall a#26#0#0: DatatypeType, a#26#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#26#0#0, a#26#1#0) } JSON_mGrammar.jfrac.num(#JSON.Grammar.jfrac.JFrac(a#26#0#0, a#26#1#0)) == a#26#1#0);

axiom (forall a#27#0#0: DatatypeType, a#27#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#27#0#0, a#27#1#0) } DtRank(a#27#1#0) < DtRank(#JSON.Grammar.jfrac.JFrac(a#27#0#0, a#27#1#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mGrammar.jfrac(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mGrammar.jfrac()) ==> $IsAlloc(d, Tclass.JSON_mGrammar.jfrac(), $h));

function $IsA#JSON_mGrammar.jfrac(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.jfrac(d) } $IsA#JSON_mGrammar.jfrac(d) ==> JSON_mGrammar.jfrac.JFrac_q(d));

axiom (forall d: DatatypeType :: { JSON_mGrammar.jfrac.JFrac_q(d), $Is(d, Tclass.JSON_mGrammar.jfrac()) } $Is(d, Tclass.JSON_mGrammar.jfrac()) ==> JSON_mGrammar.jfrac.JFrac_q(d));

function JSON_mGrammar.jfrac#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jfrac#Equal(a, b) } JSON_mGrammar.jfrac#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jfrac.period(a), JSON_mGrammar.jfrac.period(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jfrac.num(a), JSON_mGrammar.jfrac.num(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jfrac#Equal(a, b) } JSON_mGrammar.jfrac#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.jfrac: ClassName;

function #JSON.Grammar.jexp.JExp(DatatypeType, DatatypeType, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.jexp.JExp: DtCtorId
uses {
axiom (forall a#28#0#0: DatatypeType, a#28#1#0: DatatypeType, a#28#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#28#0#0, a#28#1#0, a#28#2#0) } DatatypeCtorId(#JSON.Grammar.jexp.JExp(a#28#0#0, a#28#1#0, a#28#2#0)) == ##JSON.Grammar.jexp.JExp);
}

function JSON_mGrammar.jexp.JExp_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.jexp.JExp_q(d) } JSON_mGrammar.jexp.JExp_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.jexp.JExp);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jexp.JExp_q(d) } JSON_mGrammar.jexp.JExp_q(d) ==> (exists a#29#0#0: DatatypeType, a#29#1#0: DatatypeType, a#29#2#0: DatatypeType :: d == #JSON.Grammar.jexp.JExp(a#29#0#0, a#29#1#0, a#29#2#0)));

function Tclass.JSON_mGrammar.jexp() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jexp()) == Tagclass.JSON_mGrammar.jexp && TagFamily(Tclass.JSON_mGrammar.jexp()) == tytagFamily$jexp;
}

const unique Tagclass.JSON_mGrammar.jexp: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jexp()) } $IsBox(bx, Tclass.JSON_mGrammar.jexp()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jexp()));

axiom (forall a#30#0#0: DatatypeType, a#30#1#0: DatatypeType, a#30#2#0: DatatypeType :: { $Is(#JSON.Grammar.jexp.JExp(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.JSON_mGrammar.jexp()) } $Is(#JSON.Grammar.jexp.JExp(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.JSON_mGrammar.jexp()) <==> $Is(a#30#0#0, Tclass.JSON_mGrammar.je()) && $Is(a#30#1#0, Tclass.JSON_mGrammar.jsign()) && $Is(a#30#2#0, Tclass.JSON_mGrammar.jnum()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jexp.e(d), Tclass.JSON_mGrammar.je(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jexp.JExp_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jexp(), $h) ==> $IsAlloc(JSON_mGrammar.jexp.e(d), Tclass.JSON_mGrammar.je(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jexp.sign(d), Tclass.JSON_mGrammar.jsign(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jexp.JExp_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jexp(), $h) ==> $IsAlloc(JSON_mGrammar.jexp.sign(d), Tclass.JSON_mGrammar.jsign(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jexp.num(d), Tclass.JSON_mGrammar.jnum(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jexp.JExp_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jexp(), $h) ==> $IsAlloc(JSON_mGrammar.jexp.num(d), Tclass.JSON_mGrammar.jnum(), $h));

axiom (forall a#31#0#0: DatatypeType, a#31#1#0: DatatypeType, a#31#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(Lit(a#31#0#0), Lit(a#31#1#0), Lit(a#31#2#0)) } #JSON.Grammar.jexp.JExp(Lit(a#31#0#0), Lit(a#31#1#0), Lit(a#31#2#0)) == Lit(#JSON.Grammar.jexp.JExp(a#31#0#0, a#31#1#0, a#31#2#0)));

function JSON_mGrammar.jexp.e(DatatypeType) : DatatypeType;

axiom (forall a#32#0#0: DatatypeType, a#32#1#0: DatatypeType, a#32#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#32#0#0, a#32#1#0, a#32#2#0) } JSON_mGrammar.jexp.e(#JSON.Grammar.jexp.JExp(a#32#0#0, a#32#1#0, a#32#2#0)) == a#32#0#0);

axiom (forall a#33#0#0: DatatypeType, a#33#1#0: DatatypeType, a#33#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#33#0#0, a#33#1#0, a#33#2#0) } DtRank(a#33#0#0) < DtRank(#JSON.Grammar.jexp.JExp(a#33#0#0, a#33#1#0, a#33#2#0)));

function JSON_mGrammar.jexp.sign(DatatypeType) : DatatypeType;

axiom (forall a#34#0#0: DatatypeType, a#34#1#0: DatatypeType, a#34#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#34#0#0, a#34#1#0, a#34#2#0) } JSON_mGrammar.jexp.sign(#JSON.Grammar.jexp.JExp(a#34#0#0, a#34#1#0, a#34#2#0)) == a#34#1#0);

axiom (forall a#35#0#0: DatatypeType, a#35#1#0: DatatypeType, a#35#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#35#0#0, a#35#1#0, a#35#2#0) } DtRank(a#35#1#0) < DtRank(#JSON.Grammar.jexp.JExp(a#35#0#0, a#35#1#0, a#35#2#0)));

function JSON_mGrammar.jexp.num(DatatypeType) : DatatypeType;

axiom (forall a#36#0#0: DatatypeType, a#36#1#0: DatatypeType, a#36#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#36#0#0, a#36#1#0, a#36#2#0) } JSON_mGrammar.jexp.num(#JSON.Grammar.jexp.JExp(a#36#0#0, a#36#1#0, a#36#2#0)) == a#36#2#0);

axiom (forall a#37#0#0: DatatypeType, a#37#1#0: DatatypeType, a#37#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#37#0#0, a#37#1#0, a#37#2#0) } DtRank(a#37#2#0) < DtRank(#JSON.Grammar.jexp.JExp(a#37#0#0, a#37#1#0, a#37#2#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mGrammar.jexp(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mGrammar.jexp()) ==> $IsAlloc(d, Tclass.JSON_mGrammar.jexp(), $h));

function $IsA#JSON_mGrammar.jexp(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.jexp(d) } $IsA#JSON_mGrammar.jexp(d) ==> JSON_mGrammar.jexp.JExp_q(d));

axiom (forall d: DatatypeType :: { JSON_mGrammar.jexp.JExp_q(d), $Is(d, Tclass.JSON_mGrammar.jexp()) } $Is(d, Tclass.JSON_mGrammar.jexp()) ==> JSON_mGrammar.jexp.JExp_q(d));

function JSON_mGrammar.jexp#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jexp#Equal(a, b) } JSON_mGrammar.jexp#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jexp.e(a), JSON_mGrammar.jexp.e(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jexp.sign(a), JSON_mGrammar.jexp.sign(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jexp.num(a), JSON_mGrammar.jexp.num(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jexp#Equal(a, b) } JSON_mGrammar.jexp#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.jexp: ClassName;

function #JSON.Grammar.jnumber.JNumber(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.jnumber.JNumber: DtCtorId
uses {
axiom (forall a#38#0#0: DatatypeType, a#38#1#0: DatatypeType, a#38#2#0: DatatypeType, a#38#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#38#0#0, a#38#1#0, a#38#2#0, a#38#3#0) } DatatypeCtorId(#JSON.Grammar.jnumber.JNumber(a#38#0#0, a#38#1#0, a#38#2#0, a#38#3#0)) == ##JSON.Grammar.jnumber.JNumber);
}

function JSON_mGrammar.jnumber.JNumber_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.jnumber.JNumber_q(d) } JSON_mGrammar.jnumber.JNumber_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.jnumber.JNumber);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jnumber.JNumber_q(d) } JSON_mGrammar.jnumber.JNumber_q(d) ==> (exists a#39#0#0: DatatypeType, a#39#1#0: DatatypeType, a#39#2#0: DatatypeType, a#39#3#0: DatatypeType :: d == #JSON.Grammar.jnumber.JNumber(a#39#0#0, a#39#1#0, a#39#2#0, a#39#3#0)));

function Tclass.JSON_mGrammar.jnumber() : Ty
uses {
axiom Tag(Tclass.JSON_mGrammar.jnumber()) == Tagclass.JSON_mGrammar.jnumber && TagFamily(Tclass.JSON_mGrammar.jnumber()) == tytagFamily$jnumber;
}

const unique Tagclass.JSON_mGrammar.jnumber: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mGrammar.jnumber()) } $IsBox(bx, Tclass.JSON_mGrammar.jnumber()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mGrammar.jnumber()));

axiom (forall a#40#0#0: DatatypeType, a#40#1#0: DatatypeType, a#40#2#0: DatatypeType, a#40#3#0: DatatypeType :: { $Is(#JSON.Grammar.jnumber.JNumber(a#40#0#0, a#40#1#0, a#40#2#0, a#40#3#0), Tclass.JSON_mGrammar.jnumber()) } $Is(#JSON.Grammar.jnumber.JNumber(a#40#0#0, a#40#1#0, a#40#2#0, a#40#3#0), Tclass.JSON_mGrammar.jnumber()) <==> $Is(a#40#0#0, Tclass.JSON_mGrammar.jminus()) && $Is(a#40#1#0, Tclass.JSON_mGrammar.jnum()) && $Is(a#40#2#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $Is(a#40#3#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jnumber.minus(d), Tclass.JSON_mGrammar.jminus(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jnumber.JNumber_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jnumber(), $h) ==> $IsAlloc(JSON_mGrammar.jnumber.minus(d), Tclass.JSON_mGrammar.jminus(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jnumber.num(d), Tclass.JSON_mGrammar.jnum(), $h) } $IsGoodHeap($h) && JSON_mGrammar.jnumber.JNumber_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jnumber(), $h) ==> $IsAlloc(JSON_mGrammar.jnumber.num(d), Tclass.JSON_mGrammar.jnum(), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jnumber.frac(d), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $h) } $IsGoodHeap($h) && JSON_mGrammar.jnumber.JNumber_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jnumber(), $h) ==> $IsAlloc(JSON_mGrammar.jnumber.frac(d), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $h));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.jnumber.exp(d), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $h) } $IsGoodHeap($h) && JSON_mGrammar.jnumber.JNumber_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.jnumber(), $h) ==> $IsAlloc(JSON_mGrammar.jnumber.exp(d), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $h));

axiom (forall a#41#0#0: DatatypeType, a#41#1#0: DatatypeType, a#41#2#0: DatatypeType, a#41#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(Lit(a#41#0#0), Lit(a#41#1#0), Lit(a#41#2#0), Lit(a#41#3#0)) } #JSON.Grammar.jnumber.JNumber(Lit(a#41#0#0), Lit(a#41#1#0), Lit(a#41#2#0), Lit(a#41#3#0)) == Lit(#JSON.Grammar.jnumber.JNumber(a#41#0#0, a#41#1#0, a#41#2#0, a#41#3#0)));

function JSON_mGrammar.jnumber.minus(DatatypeType) : DatatypeType;

axiom (forall a#42#0#0: DatatypeType, a#42#1#0: DatatypeType, a#42#2#0: DatatypeType, a#42#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#42#0#0, a#42#1#0, a#42#2#0, a#42#3#0) } JSON_mGrammar.jnumber.minus(#JSON.Grammar.jnumber.JNumber(a#42#0#0, a#42#1#0, a#42#2#0, a#42#3#0)) == a#42#0#0);

axiom (forall a#43#0#0: DatatypeType, a#43#1#0: DatatypeType, a#43#2#0: DatatypeType, a#43#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#43#0#0, a#43#1#0, a#43#2#0, a#43#3#0) } DtRank(a#43#0#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#43#0#0, a#43#1#0, a#43#2#0, a#43#3#0)));

function JSON_mGrammar.jnumber.num(DatatypeType) : DatatypeType;

axiom (forall a#44#0#0: DatatypeType, a#44#1#0: DatatypeType, a#44#2#0: DatatypeType, a#44#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#44#0#0, a#44#1#0, a#44#2#0, a#44#3#0) } JSON_mGrammar.jnumber.num(#JSON.Grammar.jnumber.JNumber(a#44#0#0, a#44#1#0, a#44#2#0, a#44#3#0)) == a#44#1#0);

axiom (forall a#45#0#0: DatatypeType, a#45#1#0: DatatypeType, a#45#2#0: DatatypeType, a#45#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#45#0#0, a#45#1#0, a#45#2#0, a#45#3#0) } DtRank(a#45#1#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#45#0#0, a#45#1#0, a#45#2#0, a#45#3#0)));

function JSON_mGrammar.jnumber.frac(DatatypeType) : DatatypeType;

axiom (forall a#46#0#0: DatatypeType, a#46#1#0: DatatypeType, a#46#2#0: DatatypeType, a#46#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#46#0#0, a#46#1#0, a#46#2#0, a#46#3#0) } JSON_mGrammar.jnumber.frac(#JSON.Grammar.jnumber.JNumber(a#46#0#0, a#46#1#0, a#46#2#0, a#46#3#0)) == a#46#2#0);

axiom (forall a#47#0#0: DatatypeType, a#47#1#0: DatatypeType, a#47#2#0: DatatypeType, a#47#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#47#0#0, a#47#1#0, a#47#2#0, a#47#3#0) } DtRank(a#47#2#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#47#0#0, a#47#1#0, a#47#2#0, a#47#3#0)));

function JSON_mGrammar.jnumber.exp(DatatypeType) : DatatypeType;

axiom (forall a#48#0#0: DatatypeType, a#48#1#0: DatatypeType, a#48#2#0: DatatypeType, a#48#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0) } JSON_mGrammar.jnumber.exp(#JSON.Grammar.jnumber.JNumber(a#48#0#0, a#48#1#0, a#48#2#0, a#48#3#0)) == a#48#3#0);

axiom (forall a#49#0#0: DatatypeType, a#49#1#0: DatatypeType, a#49#2#0: DatatypeType, a#49#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#49#0#0, a#49#1#0, a#49#2#0, a#49#3#0) } DtRank(a#49#3#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#49#0#0, a#49#1#0, a#49#2#0, a#49#3#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mGrammar.jnumber(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mGrammar.jnumber()) ==> $IsAlloc(d, Tclass.JSON_mGrammar.jnumber(), $h));

function $IsA#JSON_mGrammar.jnumber(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.jnumber(d) } $IsA#JSON_mGrammar.jnumber(d) ==> JSON_mGrammar.jnumber.JNumber_q(d));

axiom (forall d: DatatypeType :: { JSON_mGrammar.jnumber.JNumber_q(d), $Is(d, Tclass.JSON_mGrammar.jnumber()) } $Is(d, Tclass.JSON_mGrammar.jnumber()) ==> JSON_mGrammar.jnumber.JNumber_q(d));

function JSON_mGrammar.jnumber#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jnumber#Equal(a, b) } JSON_mGrammar.jnumber#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jnumber.minus(a), JSON_mGrammar.jnumber.minus(b)) && JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.jnumber.num(a), JSON_mGrammar.jnumber.num(b)) && JSON_mGrammar.Maybe#Equal(JSON_mGrammar.jnumber.frac(a), JSON_mGrammar.jnumber.frac(b)) && JSON_mGrammar.Maybe#Equal(JSON_mGrammar.jnumber.exp(a), JSON_mGrammar.jnumber.exp(b)));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.jnumber#Equal(a, b) } JSON_mGrammar.jnumber#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.jnumber: ClassName;

function #JSON.Grammar.Value.Null(DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Value.Null: DtCtorId
uses {
axiom (forall a#50#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(a#50#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Null(a#50#0#0)) == ##JSON.Grammar.Value.Null);
}

function JSON_mGrammar.Value.Null_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Null_q(d) } JSON_mGrammar.Value.Null_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Value.Null);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Null_q(d) } JSON_mGrammar.Value.Null_q(d) ==> (exists a#51#0#0: DatatypeType :: d == #JSON.Grammar.Value.Null(a#51#0#0)));

axiom (forall a#52#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Null(a#52#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Null(a#52#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#52#0#0, Tclass.JSON_mGrammar.jnull()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Value.n(d), Tclass.JSON_mGrammar.jnull(), $h) } $IsGoodHeap($h) && JSON_mGrammar.Value.Null_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) ==> $IsAlloc(JSON_mGrammar.Value.n(d), Tclass.JSON_mGrammar.jnull(), $h));

axiom (forall a#53#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(Lit(a#53#0#0)) } #JSON.Grammar.Value.Null(Lit(a#53#0#0)) == Lit(#JSON.Grammar.Value.Null(a#53#0#0)));

function JSON_mGrammar.Value.n(DatatypeType) : DatatypeType;

axiom (forall a#54#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(a#54#0#0) } JSON_mGrammar.Value.n(#JSON.Grammar.Value.Null(a#54#0#0)) == a#54#0#0);

axiom (forall a#55#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(a#55#0#0) } DtRank(a#55#0#0) < DtRank(#JSON.Grammar.Value.Null(a#55#0#0)));

function #JSON.Grammar.Value.Bool(DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Value.Bool: DtCtorId
uses {
axiom (forall a#56#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(a#56#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Bool(a#56#0#0)) == ##JSON.Grammar.Value.Bool);
}

function JSON_mGrammar.Value.Bool_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Bool_q(d) } JSON_mGrammar.Value.Bool_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Value.Bool);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Bool_q(d) } JSON_mGrammar.Value.Bool_q(d) ==> (exists a#57#0#0: DatatypeType :: d == #JSON.Grammar.Value.Bool(a#57#0#0)));

axiom (forall a#58#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Bool(a#58#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Bool(a#58#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#58#0#0, Tclass.JSON_mGrammar.jbool()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Value.b(d), Tclass.JSON_mGrammar.jbool(), $h) } $IsGoodHeap($h) && JSON_mGrammar.Value.Bool_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) ==> $IsAlloc(JSON_mGrammar.Value.b(d), Tclass.JSON_mGrammar.jbool(), $h));

axiom (forall a#59#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(Lit(a#59#0#0)) } #JSON.Grammar.Value.Bool(Lit(a#59#0#0)) == Lit(#JSON.Grammar.Value.Bool(a#59#0#0)));

function JSON_mGrammar.Value.b(DatatypeType) : DatatypeType;

axiom (forall a#60#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(a#60#0#0) } JSON_mGrammar.Value.b(#JSON.Grammar.Value.Bool(a#60#0#0)) == a#60#0#0);

axiom (forall a#61#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(a#61#0#0) } DtRank(a#61#0#0) < DtRank(#JSON.Grammar.Value.Bool(a#61#0#0)));

function #JSON.Grammar.Value.String(DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Value.String: DtCtorId
uses {
axiom (forall a#62#0#0: DatatypeType :: { #JSON.Grammar.Value.String(a#62#0#0) } DatatypeCtorId(#JSON.Grammar.Value.String(a#62#0#0)) == ##JSON.Grammar.Value.String);
}

function JSON_mGrammar.Value.String_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.String_q(d) } JSON_mGrammar.Value.String_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Value.String);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.String_q(d) } JSON_mGrammar.Value.String_q(d) ==> (exists a#63#0#0: DatatypeType :: d == #JSON.Grammar.Value.String(a#63#0#0)));

axiom (forall a#64#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.String(a#64#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.String(a#64#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#64#0#0, Tclass.JSON_mGrammar.jstring()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Value.str(d), Tclass.JSON_mGrammar.jstring(), $h) } $IsGoodHeap($h) && JSON_mGrammar.Value.String_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) ==> $IsAlloc(JSON_mGrammar.Value.str(d), Tclass.JSON_mGrammar.jstring(), $h));

axiom (forall a#65#0#0: DatatypeType :: { #JSON.Grammar.Value.String(Lit(a#65#0#0)) } #JSON.Grammar.Value.String(Lit(a#65#0#0)) == Lit(#JSON.Grammar.Value.String(a#65#0#0)));

function JSON_mGrammar.Value.str(DatatypeType) : DatatypeType;

axiom (forall a#66#0#0: DatatypeType :: { #JSON.Grammar.Value.String(a#66#0#0) } JSON_mGrammar.Value.str(#JSON.Grammar.Value.String(a#66#0#0)) == a#66#0#0);

axiom (forall a#67#0#0: DatatypeType :: { #JSON.Grammar.Value.String(a#67#0#0) } DtRank(a#67#0#0) < DtRank(#JSON.Grammar.Value.String(a#67#0#0)));

function #JSON.Grammar.Value.Number(DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Value.Number: DtCtorId
uses {
axiom (forall a#68#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(a#68#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Number(a#68#0#0)) == ##JSON.Grammar.Value.Number);
}

function JSON_mGrammar.Value.Number_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Number_q(d) } JSON_mGrammar.Value.Number_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Value.Number);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Number_q(d) } JSON_mGrammar.Value.Number_q(d) ==> (exists a#69#0#0: DatatypeType :: d == #JSON.Grammar.Value.Number(a#69#0#0)));

axiom (forall a#70#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Number(a#70#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Number(a#70#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#70#0#0, Tclass.JSON_mGrammar.jnumber()));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Value.num(d), Tclass.JSON_mGrammar.jnumber(), $h) } $IsGoodHeap($h) && JSON_mGrammar.Value.Number_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) ==> $IsAlloc(JSON_mGrammar.Value.num(d), Tclass.JSON_mGrammar.jnumber(), $h));

axiom (forall a#71#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(Lit(a#71#0#0)) } #JSON.Grammar.Value.Number(Lit(a#71#0#0)) == Lit(#JSON.Grammar.Value.Number(a#71#0#0)));

function JSON_mGrammar.Value.num(DatatypeType) : DatatypeType;

axiom (forall a#72#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(a#72#0#0) } JSON_mGrammar.Value.num(#JSON.Grammar.Value.Number(a#72#0#0)) == a#72#0#0);

axiom (forall a#73#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(a#73#0#0) } DtRank(a#73#0#0) < DtRank(#JSON.Grammar.Value.Number(a#73#0#0)));

function #JSON.Grammar.Value.Object(DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Value.Object: DtCtorId
uses {
axiom (forall a#74#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(a#74#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Object(a#74#0#0)) == ##JSON.Grammar.Value.Object);
}

function JSON_mGrammar.Value.Object_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Object_q(d) } JSON_mGrammar.Value.Object_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Value.Object);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Object_q(d) } JSON_mGrammar.Value.Object_q(d) ==> (exists a#75#0#0: DatatypeType :: d == #JSON.Grammar.Value.Object(a#75#0#0)));

axiom (forall a#76#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Object(a#76#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Object(a#76#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#76#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Value.obj(d), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $h) } $IsGoodHeap($h) && JSON_mGrammar.Value.Object_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) ==> $IsAlloc(JSON_mGrammar.Value.obj(d), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $h));

axiom (forall a#77#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(Lit(a#77#0#0)) } #JSON.Grammar.Value.Object(Lit(a#77#0#0)) == Lit(#JSON.Grammar.Value.Object(a#77#0#0)));

function JSON_mGrammar.Value.obj(DatatypeType) : DatatypeType;

axiom (forall a#78#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(a#78#0#0) } JSON_mGrammar.Value.obj(#JSON.Grammar.Value.Object(a#78#0#0)) == a#78#0#0);

axiom (forall a#79#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(a#79#0#0) } DtRank(a#79#0#0) < DtRank(#JSON.Grammar.Value.Object(a#79#0#0)));

function #JSON.Grammar.Value.Array(DatatypeType) : DatatypeType;

const unique ##JSON.Grammar.Value.Array: DtCtorId
uses {
axiom (forall a#80#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(a#80#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Array(a#80#0#0)) == ##JSON.Grammar.Value.Array);
}

function JSON_mGrammar.Value.Array_q(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Array_q(d) } JSON_mGrammar.Value.Array_q(d) <==> DatatypeCtorId(d) == ##JSON.Grammar.Value.Array);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Array_q(d) } JSON_mGrammar.Value.Array_q(d) ==> (exists a#81#0#0: DatatypeType :: d == #JSON.Grammar.Value.Array(a#81#0#0)));

axiom (forall a#82#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Array(a#82#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Array(a#82#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#82#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(JSON_mGrammar.Value.arr(d), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $h) } $IsGoodHeap($h) && JSON_mGrammar.Value.Array_q(d) && $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) ==> $IsAlloc(JSON_mGrammar.Value.arr(d), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $h));

axiom (forall a#83#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(Lit(a#83#0#0)) } #JSON.Grammar.Value.Array(Lit(a#83#0#0)) == Lit(#JSON.Grammar.Value.Array(a#83#0#0)));

function JSON_mGrammar.Value.arr(DatatypeType) : DatatypeType;

axiom (forall a#84#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(a#84#0#0) } JSON_mGrammar.Value.arr(#JSON.Grammar.Value.Array(a#84#0#0)) == a#84#0#0);

axiom (forall a#85#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(a#85#0#0) } DtRank(a#85#0#0) < DtRank(#JSON.Grammar.Value.Array(a#85#0#0)));

axiom (forall d: DatatypeType, $h: Heap :: { $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h) } $IsGoodHeap($h) && $Is(d, Tclass.JSON_mGrammar.Value()) ==> $IsAlloc(d, Tclass.JSON_mGrammar.Value(), $h));

function $IsA#JSON_mGrammar.Value(DatatypeType) : bool;

axiom (forall d: DatatypeType :: { $IsA#JSON_mGrammar.Value(d) } $IsA#JSON_mGrammar.Value(d) ==> JSON_mGrammar.Value.Null_q(d) || JSON_mGrammar.Value.Bool_q(d) || JSON_mGrammar.Value.String_q(d) || JSON_mGrammar.Value.Number_q(d) || JSON_mGrammar.Value.Object_q(d) || JSON_mGrammar.Value.Array_q(d));

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Array_q(d), $Is(d, Tclass.JSON_mGrammar.Value()) } { JSON_mGrammar.Value.Object_q(d), $Is(d, Tclass.JSON_mGrammar.Value()) } { JSON_mGrammar.Value.Number_q(d), $Is(d, Tclass.JSON_mGrammar.Value()) } { JSON_mGrammar.Value.String_q(d), $Is(d, Tclass.JSON_mGrammar.Value()) } { JSON_mGrammar.Value.Bool_q(d), $Is(d, Tclass.JSON_mGrammar.Value()) } { JSON_mGrammar.Value.Null_q(d), $Is(d, Tclass.JSON_mGrammar.Value()) } $Is(d, Tclass.JSON_mGrammar.Value()) ==> JSON_mGrammar.Value.Null_q(d) || JSON_mGrammar.Value.Bool_q(d) || JSON_mGrammar.Value.String_q(d) || JSON_mGrammar.Value.Number_q(d) || JSON_mGrammar.Value.Object_q(d) || JSON_mGrammar.Value.Array_q(d));

function JSON_mGrammar.Value#Equal(DatatypeType, DatatypeType) : bool;

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Null_q(a) } { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Null_q(b) } JSON_mGrammar.Value.Null_q(a) && JSON_mGrammar.Value.Null_q(b) ==> (JSON_mGrammar.Value#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.Value.n(a), JSON_mGrammar.Value.n(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Bool_q(a) } { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Bool_q(b) } JSON_mGrammar.Value.Bool_q(a) && JSON_mGrammar.Value.Bool_q(b) ==> (JSON_mGrammar.Value#Equal(a, b) <==> JSON_mUtils_mViews_mCore.View__#Equal(JSON_mGrammar.Value.b(a), JSON_mGrammar.Value.b(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.String_q(a) } { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.String_q(b) } JSON_mGrammar.Value.String_q(a) && JSON_mGrammar.Value.String_q(b) ==> (JSON_mGrammar.Value#Equal(a, b) <==> JSON_mGrammar.jstring#Equal(JSON_mGrammar.Value.str(a), JSON_mGrammar.Value.str(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Number_q(a) } { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Number_q(b) } JSON_mGrammar.Value.Number_q(a) && JSON_mGrammar.Value.Number_q(b) ==> (JSON_mGrammar.Value#Equal(a, b) <==> JSON_mGrammar.jnumber#Equal(JSON_mGrammar.Value.num(a), JSON_mGrammar.Value.num(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Object_q(a) } { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Object_q(b) } JSON_mGrammar.Value.Object_q(a) && JSON_mGrammar.Value.Object_q(b) ==> (JSON_mGrammar.Value#Equal(a, b) <==> JSON_mGrammar.Bracketed#Equal(JSON_mGrammar.Value.obj(a), JSON_mGrammar.Value.obj(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Array_q(a) } { JSON_mGrammar.Value#Equal(a, b), JSON_mGrammar.Value.Array_q(b) } JSON_mGrammar.Value.Array_q(a) && JSON_mGrammar.Value.Array_q(b) ==> (JSON_mGrammar.Value#Equal(a, b) <==> JSON_mGrammar.Bracketed#Equal(JSON_mGrammar.Value.arr(a), JSON_mGrammar.Value.arr(b))));

axiom (forall a: DatatypeType, b: DatatypeType :: { JSON_mGrammar.Value#Equal(a, b) } JSON_mGrammar.Value#Equal(a, b) <==> a == b);

const unique class.JSON_mGrammar.Value: ClassName;

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#8 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#8) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#8)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#8 := lv#0; (var dt_update#end#0#8 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#8), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#8), dt_update#end#0#8))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#9 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#9) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#9)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#9 := Lit(lv#0); (var dt_update#end#0#9 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#9)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#9)), dt_update#end#0#9)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#10: char :: { Seq#Contains(s#0, $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(s#0, $Box(c#10)) ==> char#ToInt(c#10) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#10: char :: { Seq#Contains(s#0, $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(s#0, $Box(c#10)) ==> char#ToInt(c#10) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#20#i#0): int)): char))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $IsBox($l#20#i#0, TInt) && LitInt(0) <= $Unbox($l#20#i#0): int && $Unbox($l#20#i#0): int < Seq#Length(s#0)), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#11: char :: { Seq#Contains(s#0, $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(s#0, $Box(c#11)) ==> char#ToInt(c#11) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#22#i#0): int)): char))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $IsBox($l#22#i#0, TInt) && LitInt(0) <= $Unbox($l#22#i#0): int && $Unbox($l#22#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))));

const unique tytagFamily$Suffixed: TyTagFamily;

const unique tytagFamily$jchar: TyTagFamily;

const unique tytagFamily$jquote: TyTagFamily;

const unique tytagFamily$jperiod: TyTagFamily;

const unique tytagFamily$je: TyTagFamily;

const unique tytagFamily$jcolon: TyTagFamily;

const unique tytagFamily$jcomma: TyTagFamily;

const unique tytagFamily$jlbrace: TyTagFamily;

const unique tytagFamily$jrbrace: TyTagFamily;

const unique tytagFamily$jlbracket: TyTagFamily;

const unique tytagFamily$jrbracket: TyTagFamily;

const unique tytagFamily$jminus: TyTagFamily;

const unique tytagFamily$jsign: TyTagFamily;

const unique tytagFamily$jblanks: TyTagFamily;

const unique tytagFamily$Structural: TyTagFamily;

const unique tytagFamily$Maybe: TyTagFamily;

const unique tytagFamily$SuffixedSequence: TyTagFamily;

const unique tytagFamily$Bracketed: TyTagFamily;

const unique tytagFamily$jnull: TyTagFamily;

const unique tytagFamily$jbool: TyTagFamily;

const unique tytagFamily$jdigits: TyTagFamily;

const unique tytagFamily$jnum: TyTagFamily;

const unique tytagFamily$jint: TyTagFamily;

const unique tytagFamily$jstr: TyTagFamily;

const unique tytagFamily$jstring: TyTagFamily;

const unique tytagFamily$jKeyValue: TyTagFamily;

const unique tytagFamily$Value: TyTagFamily;

const unique tytagFamily$jfrac: TyTagFamily;

const unique tytagFamily$jexp: TyTagFamily;

const unique tytagFamily$jnumber: TyTagFamily;

const unique class.JSON_mSerializer_mByteStrConversion.__default: ClassName;

function JSON_mSerializer_mByteStrConversion.__default.Digits($ly: LayerType, n#0: int, base#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#0: int :: { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) } Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < base#0) && $Is(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#0 := JSON_mSerializer_mByteStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#0 := Seq#Append(digits'#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#1 := JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#1 := Seq#Append(digits'#1, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#2 := Lit(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#2 := Seq#Append(digits'#2, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#2))));
}

function JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0: int, base#0: int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits(AsFuelBottom($ly), n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) == JSON_mSerializer_mByteStrConversion.__default.Digits($LZ, n#0, base#0));

function JSON_mSerializer_mByteStrConversion.__default.Digits#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits#requires($ly, n#0, base#0) } LitInt(0) <= n#0 ==> (JSON_mSerializer_mByteStrConversion.__default.Digits#requires($ly, n#0, base#0) <==> base#0 > 1));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.Digits(n#0: int where LitInt(0) <= n#0, base#0: int) returns (digits#3: Seq where $Is(digits#3, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.ByteStrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.Digits(n#0: int, base#0: int) returns (digits#3: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var d#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var digits'#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#1: int;
  var digits#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##base#2: int;
  var ##pow#1: int;
  var base##1_0_0: int;
  var pow##1_0_0: int;
  var d##1_0_0_0: int;
  var base##1_1_0: int;
  var pow##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.ByteStrConversion.Digits", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume n#0 == LitInt(0);
    assume Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon30_Else:
    assume n#0 == LitInt(0) ==> Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume n#0 > 0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon31_Else:
    assume n#0 > 0 ==> Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon8:
    havoc d#2;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume Seq#Contains(digits#3, $Box(d#2));
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= d#2;
    goto anon11;

  anon33_Else:
    assume {:partition} d#2 < LitInt(0);
    goto anon11;

  anon11:
    assume LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon32_Else:
    assume Seq#Contains(digits#3, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon13:
    assume (forall d#1: int :: { Seq#Contains(digits#3, $Box(d#1)) } Seq#Contains(digits#3, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);
    assume false;
    return;

  anon29_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} n#0 == LitInt(0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](35,49)"} true;
    assume true;
    assume false;
    goto anon17;

  anon35_Else:
    goto anon17;

  anon17:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, LitInt(0)) == LitInt(1);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](35,52)"} true;
    assume JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon34_Else:
    assume {:partition} n#0 != LitInt(0);
    free call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](38,29)"} true;
    free call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](38,54)"} true;
    havoc digits'#Z#0;
    assume $Is(digits'#Z#0, TSeq(TInt)) && $IsAlloc(digits'#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume $Is(Div(n#0, base#0), Tclass._System.nat());
    ##n#0 := Div(n#0, base#0);
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume 0 <= n#0 || ##n#0 == n#0;
    assume ##n#0 < n#0;
    assume JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume let#0#0#0 == JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), Div(n#0, base#0), base#0);
    assume JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume $Is(let#0#0#0, TSeq(TInt));
    assume digits'#Z#0 == let#0#0#0;
    havoc digits#Z#0;
    assume $Is(digits#Z#0, TSeq(TInt)) && $IsAlloc(digits#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume let#1#0#0 == Seq#Append(digits'#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))));
    assume true;
    assume $Is(let#1#0#0, TSeq(TInt));
    assume digits#Z#0 == let#1#0#0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#2 := base#0;
    assume $IsAlloc(##base#2, Tclass._System.nat(), $Heap);
    ##pow#1 := n#0;
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#2 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume true;
    assume Seq#Length(digits#Z#0) == Seq#Length(digits'#Z#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](42,42)"} true;
    assume true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} n#0 < base#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_0_0 := base#0;
    assume true;
    pow##1_0_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    call CallPost$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](44,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume true;
    d##1_0_0_0 := base#0;
    call CallPre$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    call CallPost$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](45,57)"} true;
    assume Div(n#0, base#0) == LitInt(0);
    assume false;
    goto anon22;

  anon38_Else:
    goto anon22;

  anon22:
    assume Div(n#0, base#0) == LitInt(0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](45,59)"} true;
    goto anon26;

  anon37_Else:
    assume {:partition} base#0 <= n#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_1_0 := base#0;
    assume true;
    pow##1_1_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](47,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    call CallPre$$DivMod.__default.LemmaDivNonZeroAuto();
    call CallPost$$DivMod.__default.LemmaDivNonZeroAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](48,58)"} true;
    assume Div(n#0, base#0) > 0;
    assume false;
    goto anon25;

  anon39_Else:
    goto anon25;

  anon25:
    assume Div(n#0, base#0) > 0;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](48,60)"} true;
    goto anon26;

  anon26:
    assume true;
    assume false;
    goto anon27;

  anon36_Else:
    goto anon27;

  anon27:
    assume Seq#Length(digits#Z#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](50,8)"} true;
    assume JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#Z#0;
    assume true;
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon28:
    assume JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#3;
    return;
}



function JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly: LayerType, digits#0: Seq, chars#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#0: int :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && Seq#Length(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#2: int :: { Seq#Contains(digits#0, $Box(d#2)) } Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));
}

function JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0: Seq, chars#0: Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits(AsFuelBottom($ly), digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) == JSON_mSerializer_mByteStrConversion.__default.OfDigits($LZ, digits#0, chars#0));

function JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.OfDigits (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.OfDigits(digits#0: Seq where $Is(digits#0, TSeq(TInt)), chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint8()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#0: int :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> (var base#0 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#0 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0))));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#1 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#1) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#1 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0)))));
}

function JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0: int, chars#0: Seq) : bool;

function JSON_mSerializer_mByteStrConversion.__default.OfNat__any#requires(int, Seq) : bool;

axiom (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any#requires(n#0, chars#0) } LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mSerializer_mByteStrConversion.__default.OfNat__any#requires(n#0, chars#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0: int where LitInt(0) <= n#0, chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint8()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.ByteStrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var c#2: int;
  var base#Z#0: int;
  var let#0#0#0: int;
  var ##n#0: int;
  var ##base#1: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.ByteStrConversion.OfNat_any", " | ", n#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](66,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8()));
    assume $Is(Seq#Length(chars#0), Tclass._System.nat());
    ##base#0 := Seq#Length(chars#0);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(Seq#Length(chars#0), n#0);
    assume Seq#Length(str#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1;
    havoc c#2;
    assume LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(str#0, $Box(c#2));
    assume Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon11_Else:
    assume Seq#Contains(str#0, $Box(c#2)) ==> Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon5:
    assume (forall c#1: int :: { Seq#Contains(chars#0, $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(chars#0, $Box(c#1)));
    assume false;
    return;

  anon10_Else:
    havoc base#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(chars#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume base#Z#0 == let#0#0#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} n#0 == LitInt(0);
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](72,32)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(chars#0);
    assume JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0)));
    assume true;
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon9;

  anon12_Else:
    assume {:partition} n#0 != LitInt(0);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#Z#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#Z#0);
    ##digits#0 := JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0);
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume true;
    assume (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#Z#0) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon9;

  anon9:
    assume JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == str#0;
    return;
}



function JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0: Seq, minus#0: int, is_digit#0: HandleType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#0: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#0))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#0))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#1: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#1))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#1)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#1))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#2: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#2))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#2)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box(c#2))): bool)));
}

function JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(str#0: Seq, minus#0: int, is_digit#0: HandleType) : bool;

function JSON_mSerializer_mByteStrConversion.__default.NumberStr#requires(Seq, int, HandleType) : bool;

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mSerializer_mByteStrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0) <==> true));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.NumberStr (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8(), is_digit#0: HandleType where $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0: int, chars#0: Seq, minus#0: int) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> JSON_mSerializer_mByteStrConversion.__default.NumberStr(JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(Seq#Contains(chars#0, $l#0#c#0))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint8())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mSerializer_mByteStrConversion.__default.OfNat__any(0 - n#0, chars#0))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
}

function JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0: int, chars#0: Seq, minus#0: int) : bool;

function JSON_mSerializer_mByteStrConversion.__default.OfInt__any#requires(int, Seq, int) : bool;

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mSerializer_mByteStrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) } $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mSerializer_mByteStrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.OfInt_any (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0: int, chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly: LayerType, str#0: Seq, base#0: int, digits#0: Map) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#2: int :: { Map#Domain(digits#0)[$Box(c#2)] } { Seq#Contains(str#0, $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#2)) ==> Map#Domain(digits#0)[$Box(c#2)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));
}

function JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0: Seq, base#0: int, digits#0: Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any(AsFuelBottom($ly), str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) == JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LZ, str#0, base#0, digits#0));

function JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires(LayerType, Seq, int, Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.ToNat__any(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()))) returns (n#0: int where LitInt(0) <= n#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.ToNat__any(str#0: Seq, base#0: int, digits#0: Map) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: int;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.ByteStrConversion.ToNat_any", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](90,42): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 0;
    havoc c#3;
    assume LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, $Box(c#3));
    assume Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon10_Else:
    assume Seq#Contains(str#0, $Box(c#3)) ==> Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon4:
    assume (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)]);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume LitInt(0) <= JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == LitInt(0);
    assume true;
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon12_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](96,32)"} true;
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume true;
    assume ##base#0 > 0;
    assume true;
    assume (forall c#4: int :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume 0 <= base#0 || Seq#Rank(##str#0) < Seq#Rank(str#0) || ##base#0 == base#0;
    assume Seq#Rank(##str#0) < Seq#Rank(str#0) || (Seq#Rank(##str#0) == Seq#Rank(str#0) && (##base#0 < base#0 || (##base#0 == base#0 && Set#Subset(Map#Domain(##digits#0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(##digits#0)))));
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume $Is(Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int, Tclass._System.nat());
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int;
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume $Is(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon9:
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == n#0;
    return;
}



procedure {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_bound (well-formedness)"} CheckWellFormed$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_bound (call precondtion)"} CallPre$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap));
  requires {:id "id22676"} base#0 > 0;
  requires {:id "id22677"} (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id22678"} (forall c#3: int :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);



procedure {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap));
  modifies $Heap;
  free ensures JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id22679"} JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_bound (correctness)"} Impl$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id22680"} base#0 > 0;
  requires {:id "id22681"} (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id22682"} (forall c#3: int :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);
  modifies $Heap;
  free ensures JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id22683"} $_reverifyPost ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_bound (correctness)"} Impl$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##b#1_0_0_1: int;
  var ##e#1_0_0_1: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var ##str#1_0_2_0: Seq;
  var ##base#1_0_2_0: int;
  var ##digits#1_0_2_0: Map;
  var str##1_0_2_0: Seq;
  var base##1_0_2_0: int;
  var digits##1_0_2_0: Map;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##str#1_0_3_0: Seq;
  var ##base#1_0_3_0: int;
  var ##digits#1_0_3_0: Map;
  var ##str#1_0_3_1: Seq;
  var ##base#1_0_3_1: int;
  var ##digits#1_0_3_1: Map;
  var ##str#1_0_4_0: Seq;
  var ##base#1_0_4_0: int;
  var ##digits#1_0_4_0: Map;
  var ##str#1_0_4_1: Seq;
  var ##base#1_0_4_1: int;
  var ##digits#1_0_4_1: Map;
  var ##str#1_0_0: Seq;
  var ##base#1_0_0: int;
  var ##digits#1_0_0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.ByteStrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](105,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](107,19)"} true;
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##str#1_0_0 := str#0;
    assume $IsAlloc(##str#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_0 := digits#0;
    assume $IsAlloc(##digits#1_0_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 0;
    assume {:subsumption 0} (forall c#1_0_0: int :: { Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)] } { Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) } LitInt(0) <= c#1_0_0 && c#1_0_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) ==> Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)]);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume false;
    goto anon9;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##str#1_0_4_0 := str#0;
    assume $IsAlloc(##str#1_0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_4_0 := base#0;
    assume $IsAlloc(##base#1_0_4_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_0 := digits#0;
    assume $IsAlloc(##digits#1_0_4_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_0 > 0;
    assume {:subsumption 0} (forall c#1_0_4_0: int :: { Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)] } { Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) } LitInt(0) <= c#1_0_4_0 && c#1_0_4_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) ==> Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)]);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_4_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_4_1 := base#0;
    assume $IsAlloc(##base#1_0_4_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_1 := digits#0;
    assume $IsAlloc(##digits#1_0_4_1, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_1 > 0;
    assume {:subsumption 0} (forall c#1_0_4_1: int :: { Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)] } { Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) } LitInt(0) <= c#1_0_4_1 && c#1_0_4_1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) ==> Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)]);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_3_0 := base#0;
    assume $IsAlloc(##base#1_0_3_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_0 := digits#0;
    assume $IsAlloc(##digits#1_0_3_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_0 > 0;
    assume {:subsumption 0} (forall c#1_0_3_0: int :: { Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)] } { Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) } LitInt(0) <= c#1_0_3_0 && c#1_0_3_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) ==> Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)]);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_3_1 := base#0;
    assume $IsAlloc(##base#1_0_3_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_1 := digits#0;
    assume $IsAlloc(##digits#1_0_3_1, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_1 > 0;
    assume {:subsumption 0} (forall c#1_0_3_1: int :: { Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)] } { Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) } LitInt(0) <= c#1_0_3_1 && c#1_0_3_1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) ==> Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)]);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_2_0 := base#0;
    assume $IsAlloc(##base#1_0_2_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_2_0 := digits#0;
    assume $IsAlloc(##digits#1_0_2_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_2_0 > 0;
    assume {:subsumption 0} (forall c#1_0_2_0: int :: { Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)] } { Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) } LitInt(0) <= c#1_0_2_0 && c#1_0_2_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) ==> Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)]);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    assume true;
    str##1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume true;
    base##1_0_2_0 := base#0;
    assume true;
    digits##1_0_2_0 := digits#0;
    assume 0 <= base#0 || Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || base##1_0_2_0 == base#0;
    assume Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0_2_0) == Seq#Rank(str#0) && (base##1_0_2_0 < base#0 || (base##1_0_2_0 == base#0 && Set#Subset(Map#Domain(digits##1_0_2_0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(digits##1_0_2_0)))));
    call CallPre$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    call CallPost$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](113,55)"} true;
    free call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](114,36)"} true;
    ##b#1_0_2_0 := base#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_2_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##b#1_0_1_0 := base#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](116,40)"} true;
    ##b#1_0_1_1 := base#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_1 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    ##b#1_0_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_0_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](118,23)"} true;
    free call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](118,53)"} true;
    ##b#1_0_0_1 := base#0;
    assume $IsAlloc(##b#1_0_0_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#1_0_0_1 := Seq#Length(str#0);
    assume $IsAlloc(##e#1_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume true;
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) - 1;
    return;
}



function JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0: Seq, minus#0: int, base#0: int, digits#0: Map) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Map#Domain(digits#0)[$l#2#c#0])), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.BoundedInts.uint8())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(Map#Domain(digits#0)[$l#3#c#0])), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
}

function JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(str#0: Seq, minus#0: int, base#0: int, digits#0: Map) : bool;

function JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(Seq, int, int, Map) : bool;

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.Serializer.ByteStrConversion.ToInt_any (well-formedness)"} CheckWellformed$$JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8(), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()))) returns (s#0: int);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#188 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#188))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#190 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#190)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#282 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#282))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#284 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#284)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#286 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#286)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#282 := Wrappers.Option.value(this); v#282)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#284 := Lit(Wrappers.Option.value(Lit(this))); v#284)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#286 := Lit(Wrappers.Option.value(Lit(this))); v#286)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#188 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#188)) else (var e#188 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#190 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#190))) else (var e#190 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#282 := Wrappers.Result.value(this); s#282) else (var e#282 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#284 := Lit(Wrappers.Result.value(Lit(this))); s#284) else (var e#284 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#286 := Lit(Wrappers.Result.value(Lit(this))); s#286) else (var e#286 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#282 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#282)) else (var e#282 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#282)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#284 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#284))) else (var e#284 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#284)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#286 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#286))) else (var e#286 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#286)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#78: int, y#78: int :: { Mul(x#78, y#78) } Mul(x#78, y#78) == Mul(y#78, x#78)) && (forall x#79: int, y#79: int, z#52: int :: { Mul(x#79 + y#79, z#52) } Mul(x#79 + y#79, z#52) == Mul(x#79, z#52) + Mul(y#79, z#52)) && (forall x#80: int, y#80: int, z#53: int :: { Mul(x#80 - y#80, z#53) } Mul(x#80 - y#80, z#53) == Mul(x#80, z#53) - Mul(y#80, z#53));

axiom MulInternals.__default.MulAuto() <==> (forall x#81: int, y#81: int :: { Mul(x#81, y#81) } Mul(x#81, y#81) == Mul(y#81, x#81)) && (forall x#82: int, y#82: int, z#54: int :: { Mul(x#82 + y#82, z#54) } Mul(x#82 + y#82, z#54) == Mul(x#82, z#54) + Mul(y#82, z#54)) && (forall x#83: int, y#83: int, z#55: int :: { Mul(x#83 - y#83, z#55) } Mul(x#83 - y#83, z#55) == Mul(x#83, z#55) - Mul(y#83, z#55));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#88: int :: { Mod(Mod(x#88, n#0), n#0) } Mod(Mod(x#88, n#0), n#0) == Mod(x#88, n#0)) && (forall x#89: int :: { Mod(x#89, n#0) } LitInt(0) <= x#89 && x#89 < n#0 <==> Mod(x#89, n#0) == x#89) && (forall x#90: int, y#44: int :: { Mod(x#90 + y#44, n#0) } (var z#42 := Mod(x#90, n#0) + Mod(y#44, n#0); (LitInt(0) <= z#42 && z#42 < n#0 && Mod(x#90 + y#44, n#0) == z#42) || (n#0 <= z#42 && z#42 < n#0 + n#0 && Mod(x#90 + y#44, n#0) == z#42 - n#0))) && (forall x#91: int, y#45: int :: { Mod(x#91 - y#45, n#0) } (var z#43 := Mod(x#91, n#0) - Mod(y#45, n#0); (LitInt(0) <= z#43 && z#43 < n#0 && Mod(x#91 - y#45, n#0) == z#43) || (0 - n#0 <= z#43 && z#43 < 0 && Mod(x#91 - y#45, n#0) == z#43 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#92: int :: { Mod(Mod(x#92, n#0), n#0) } Mod(Mod(x#92, LitInt(n#0)), LitInt(n#0)) == Mod(x#92, LitInt(n#0))) && (forall x#93: int :: { Mod(x#93, n#0) } LitInt(0) <= x#93 && x#93 < n#0 <==> Mod(x#93, LitInt(n#0)) == x#93) && (forall x#94: int, y#46: int :: { Mod(x#94 + y#46, n#0) } (var z#44 := Mod(x#94, LitInt(n#0)) + Mod(y#46, LitInt(n#0)); (LitInt(0) <= z#44 && z#44 < n#0 && Mod(x#94 + y#46, LitInt(n#0)) == z#44) || (LitInt(n#0) <= z#44 && z#44 < n#0 + n#0 && Mod(x#94 + y#46, LitInt(n#0)) == z#44 - n#0))) && (forall x#95: int, y#47: int :: { Mod(x#95 - y#47, n#0) } (var z#45 := Mod(x#95, LitInt(n#0)) - Mod(y#47, LitInt(n#0)); (LitInt(0) <= z#45 && z#45 < n#0 && Mod(x#95 - y#47, LitInt(n#0)) == z#45) || (LitInt(0 - n#0) <= z#45 && z#45 < 0 && Mod(x#95 - y#47, LitInt(n#0)) == z#45 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#60: int :: { Div(x#60, n#0) } LitInt(0) <= x#60 && x#60 < n#0 <==> Div(x#60, n#0) == LitInt(0)) && (forall x#61: int, y#40: int :: { Div(x#61 + y#40, n#0) } (var z#38 := Mod(x#61, n#0) + Mod(y#40, n#0); (LitInt(0) <= z#38 && z#38 < n#0 && Div(x#61 + y#40, n#0) == Div(x#61, n#0) + Div(y#40, n#0)) || (n#0 <= z#38 && z#38 < n#0 + n#0 && Div(x#61 + y#40, n#0) == Div(x#61, n#0) + Div(y#40, n#0) + 1))) && (forall x#62: int, y#41: int :: { Div(x#62 - y#41, n#0) } (var z#39 := Mod(x#62, n#0) - Mod(y#41, n#0); (LitInt(0) <= z#39 && z#39 < n#0 && Div(x#62 - y#41, n#0) == Div(x#62, n#0) - Div(y#41, n#0)) || (0 - n#0 <= z#39 && z#39 < 0 && Div(x#62 - y#41, n#0) == Div(x#62, n#0) - Div(y#41, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#63: int :: { Div(x#63, n#0) } LitInt(0) <= x#63 && x#63 < n#0 <==> Div(x#63, LitInt(n#0)) == LitInt(0)) && (forall x#64: int, y#42: int :: { Div(x#64 + y#42, n#0) } (var z#40 := Mod(x#64, LitInt(n#0)) + Mod(y#42, LitInt(n#0)); (LitInt(0) <= z#40 && z#40 < n#0 && Div(x#64 + y#42, LitInt(n#0)) == Div(x#64, LitInt(n#0)) + Div(y#42, LitInt(n#0))) || (LitInt(n#0) <= z#40 && z#40 < n#0 + n#0 && Div(x#64 + y#42, LitInt(n#0)) == Div(x#64, LitInt(n#0)) + Div(y#42, LitInt(n#0)) + 1))) && (forall x#65: int, y#43: int :: { Div(x#65 - y#43, n#0) } (var z#41 := Mod(x#65, LitInt(n#0)) - Mod(y#43, LitInt(n#0)); (LitInt(0) <= z#41 && z#41 < n#0 && Div(x#65 - y#43, LitInt(n#0)) == Div(x#65, LitInt(n#0)) - Div(y#43, LitInt(n#0))) || (LitInt(0 - n#0) <= z#41 && z#41 < 0 && Div(x#65 - y#43, LitInt(n#0)) == Div(x#65, LitInt(n#0)) - Div(y#43, LitInt(n#0)) - 1)))));

const unique class.JSON_mSerializer.__default: ClassName;

function JSON_mSerializer.__default.Bool(b#0: bool) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: { JSON_mSerializer.__default.Bool(b#0) } JSON_mSerializer.__default.Bool#canCall(b#0) || 0 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.Bool(b#0), Tclass.JSON_mGrammar.jbool()));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: { JSON_mSerializer.__default.Bool(b#0) } JSON_mSerializer.__default.Bool#canCall(b#0) || 0 < $FunctionContextHeight ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())) && JSON_mSerializer.__default.Bool(b#0) == JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())));
axiom 0 <= $FunctionContextHeight ==> (forall b#0: bool :: {:weight 3} { JSON_mSerializer.__default.Bool(Lit(b#0)) } JSON_mSerializer.__default.Bool#canCall(Lit(b#0)) || 0 < $FunctionContextHeight ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())) && JSON_mSerializer.__default.Bool(Lit(b#0)) == JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())));
}

function JSON_mSerializer.__default.Bool#canCall(b#0: bool) : bool;

function JSON_mSerializer.__default.Bool#requires(bool) : bool;

axiom (forall b#0: bool :: { JSON_mSerializer.__default.Bool#requires(b#0) } JSON_mSerializer.__default.Bool#requires(b#0) <==> true);

procedure {:verboseName "JSON.Serializer.Bool (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Bool(b#0: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Bool (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Bool(b#0: bool)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Bool", " | ", b#0} true;
    assume {:print "Types", " | ", "bool"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(41,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mSerializer.__default.Bool(b#0), Tclass.JSON_mGrammar.jbool());
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} b#0;
    goto anon6;

  anon8_Else:
    assume {:partition} !b#0;
    goto anon6;

  anon6:
    ##bs#0 := (if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE());
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE()));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())));
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())), Tclass.JSON_mGrammar.jbool());
    assume JSON_mSerializer.__default.Bool(b#0) == JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE()));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE()));
    assume $Is(JSON_mSerializer.__default.Bool(b#0), Tclass.JSON_mGrammar.jbool());
    return;
}



function JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: { JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0) } JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T, s#0, err#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError())) ==> $Is(JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: { JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0) } JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T, s#0, err#0) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), Seq#Length(s#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(err#0)) && JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0) == Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), Seq#Length(s#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(err#0)));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, Lit(s#0), Lit(err#0)) } JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T, Lit(s#0), Lit(err#0)) || (0 < $FunctionContextHeight && $Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), Seq#Length(Lit(s#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(err#0))) && JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, Lit(s#0), Lit(err#0)) == Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), Seq#Length(Lit(s#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(err#0))));
}

function JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType) : bool;

function JSON_mSerializer.__default.CheckLength#requires(Ty, Seq, DatatypeType) : bool;

axiom (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: { JSON_mSerializer.__default.CheckLength#requires(JSON.Serializer._default.CheckLength$T, s#0, err#0) } $Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError()) ==> (JSON_mSerializer.__default.CheckLength#requires(JSON.Serializer._default.CheckLength$T, s#0, err#0) <==> true));

procedure {:verboseName "JSON.Serializer.CheckLength (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq where $Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)), err#0: DatatypeType where $Is(err#0, Tclass.JSON_mErrors.SerializationError()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mSerializer.__default.String(str#0: Seq) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mSerializer.__default.String(str#0) } JSON_mSerializer.__default.String#canCall(str#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> $Is(JSON_mSerializer.__default.String(str#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError())));
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mSerializer.__default.String(str#0) } JSON_mSerializer.__default.String#canCall(str#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0)) && (var valueOrError0#0 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (var bs#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#0, #JSON.Errors.SerializationError.StringTooLong(str#0)) && (var valueOrError1#0 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#0, #JSON.Errors.SerializationError.StringTooLong(str#0)); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#0)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0)))))) && JSON_mSerializer.__default.String(str#0) == (var valueOrError0#0 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#0) else (var bs#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; (var valueOrError1#0 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#0, #JSON.Errors.SerializationError.StringTooLong(str#0)); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#0) else #Wrappers.Result.Success($Box(#JSON.Grammar.jstring.JString(JSON_mGrammar.__default.DOUBLEQUOTE(), JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0), JSON_mGrammar.__default.DOUBLEQUOTE())))))))));
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq :: {:weight 3} { JSON_mSerializer.__default.String(Lit(str#0)) } JSON_mSerializer.__default.String#canCall(Lit(str#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(TChar))) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(0)) && (var valueOrError0#1 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (var bs#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#1, Lit(#JSON.Errors.SerializationError.StringTooLong(Lit(str#0)))) && (var valueOrError1#1 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#1, Lit(#JSON.Errors.SerializationError.StringTooLong(Lit(str#0)))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#1)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#1)))))) && JSON_mSerializer.__default.String(Lit(str#0)) == (var valueOrError0#1 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#1) else (var bs#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq); (var valueOrError1#1 := Lit(JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#1, Lit(#JSON.Errors.SerializationError.StringTooLong(Lit(str#0))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#1) else #Wrappers.Result.Success($Box(#JSON.Grammar.jstring.JString(JSON_mGrammar.__default.DOUBLEQUOTE(), Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#1)), JSON_mGrammar.__default.DOUBLEQUOTE())))))))));
}

function JSON_mSerializer.__default.String#canCall(str#0: Seq) : bool;

function JSON_mSerializer.__default.String#requires(Seq) : bool;

axiom (forall str#0: Seq :: { JSON_mSerializer.__default.String#requires(str#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mSerializer.__default.String#requires(str#0) <==> true));

procedure {:verboseName "JSON.Serializer.String (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.String(str#0: Seq where $Is(str#0, TSeq(TChar)));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.String (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.String(str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: Seq;
  var ##start#0: int;
  var bs#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##err#0: DatatypeType;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.String", " | ", str#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(49,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mSerializer.__default.String(str#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon8_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    ##start#0 := LitInt(0);
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0));
    assume let#0#0#0 == JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0));
    assume JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#Z#0);
    assume JSON_mSerializer.__default.String(str#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.String(str#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon9_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc bs#Z#0;
    assume $Is(bs#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume bs#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##s#0 := bs#Z#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##err#0 := #JSON.Errors.SerializationError.StringTooLong(str#0);
    assume $IsAlloc(##err#0, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#Z#0, #JSON.Errors.SerializationError.StringTooLong(str#0));
    assume let#2#0#0 == JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#Z#0, #JSON.Errors.SerializationError.StringTooLong(str#0));
    assume JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#Z#0, #JSON.Errors.SerializationError.StringTooLong(str#0));
    assume $Is(let#2#0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError1#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError1#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#Z#0);
    assume JSON_mSerializer.__default.String(str#0) == Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#Z#0);
    assume $Is(JSON_mSerializer.__default.String(str#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mGrammar.jquote());
    ##bs#0 := bs#Z#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#Z#0));
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#Z#0), Tclass.JSON_mGrammar.jstr());
    assume $Is(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mGrammar.jquote());
    assume JSON_mSerializer.__default.String(str#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.jstring.JString(JSON_mGrammar.__default.DOUBLEQUOTE(), JSON_mUtils_mViews_mCore.View__.OfBytes(bs#Z#0), JSON_mGrammar.__default.DOUBLEQUOTE())));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#Z#0);
    assume $Is(JSON_mSerializer.__default.String(str#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSerializer.__default.Sign(n#0: int) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSerializer.__default.Sign(n#0) } JSON_mSerializer.__default.Sign#canCall(n#0) || 0 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.Sign(n#0), Tclass.JSON_mGrammar.jminus()));
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSerializer.__default.Sign(n#0) } JSON_mSerializer.__default.Sign#canCall(n#0) || 0 < $FunctionContextHeight ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)) && JSON_mSerializer.__default.Sign(n#0) == JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)));
axiom 0 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { JSON_mSerializer.__default.Sign(LitInt(n#0)) } JSON_mSerializer.__default.Sign#canCall(LitInt(n#0)) || 0 < $FunctionContextHeight ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)) && JSON_mSerializer.__default.Sign(LitInt(n#0)) == JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)));
}

function JSON_mSerializer.__default.Sign#canCall(n#0: int) : bool;

function JSON_mSerializer.__default.Sign#requires(int) : bool;

axiom (forall n#0: int :: { JSON_mSerializer.__default.Sign#requires(n#0) } JSON_mSerializer.__default.Sign#requires(n#0) <==> true);

procedure {:verboseName "JSON.Serializer.Sign (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Sign(n#0: int);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Sign (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Sign(n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Sign", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(55,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mSerializer.__default.Sign(n#0), Tclass.JSON_mGrammar.jminus());
    assume false;
    return;

  anon7_Else:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} n#0 < 0;
    newtype$check#0 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon6;

  anon8_Else:
    assume {:partition} 0 <= n#0;
    goto anon6;

  anon6:
    ##bs#0 := (if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq);
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)));
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)), Tclass.JSON_mGrammar.jminus());
    assume JSON_mSerializer.__default.Sign(n#0) == JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq));
    assume $Is(JSON_mSerializer.__default.Sign(n#0), Tclass.JSON_mGrammar.jminus());
    return;
}



function JSON_mSerializer.__default.DIGITS() : Seq
uses {
axiom JSON_mSerializer.__default.DIGITS(): Seq == Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(48))))), $Box(char#ToInt(Lit(char#FromInt(49))))), $Box(char#ToInt(Lit(char#FromInt(50))))), $Box(char#ToInt(Lit(char#FromInt(51))))), $Box(char#ToInt(Lit(char#FromInt(52))))), $Box(char#ToInt(Lit(char#FromInt(53))))), $Box(char#ToInt(Lit(char#FromInt(54))))), $Box(char#ToInt(Lit(char#FromInt(55))))), $Box(char#ToInt(Lit(char#FromInt(56))))), $Box(char#ToInt(Lit(char#FromInt(57)))));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.DIGITS(), TSeq(Tclass.BoundedInts.uint8()));
}

procedure {:verboseName "JSON.Serializer.DIGITS (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.DIGITS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.DIGITS (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.DIGITS()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.DIGITS"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(64,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(49)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(49)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(50)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(50)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#6 := char#ToInt(Lit(char#FromInt(51)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(51)));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#8 := char#ToInt(Lit(char#FromInt(52)));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#9 := char#ToInt(Lit(char#FromInt(52)));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#10 := char#ToInt(Lit(char#FromInt(53)));
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#11 := char#ToInt(Lit(char#FromInt(53)));
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#12 := char#ToInt(Lit(char#FromInt(54)));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#13 := char#ToInt(Lit(char#FromInt(54)));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#14 := char#ToInt(Lit(char#FromInt(55)));
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#15 := char#ToInt(Lit(char#FromInt(55)));
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#16 := char#ToInt(Lit(char#FromInt(56)));
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#17 := char#ToInt(Lit(char#FromInt(56)));
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#18 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#19 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.DIGITS(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.DIGITS(), TSeq(Tclass.BoundedInts.uint8()), $h));

function JSON_mSerializer.__default.MINUS() : int
uses {
axiom JSON_mSerializer.__default.MINUS(): int == char#ToInt(Lit(char#FromInt(45)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.MINUS(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.Serializer.MINUS (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.MINUS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.MINUS (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.MINUS()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.MINUS"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(70,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h));

function JSON_mSerializer.__default.Int_k(n#0: int) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSerializer.__default.Int_k(n#0) } JSON_mSerializer.__default.Int_k#canCall(n#0) || 1 < $FunctionContextHeight ==> (forall c#0: int :: { Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#0)) } { Seq#Contains(JSON_mSerializer.__default.Int_k(n#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer.__default.Int_k(n#0), $Box(c#0)) ==> Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#0)) || c#0 == JSON_mSerializer.__default.MINUS()) && $Is(JSON_mSerializer.__default.Int_k(n#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSerializer.__default.Int_k(n#0) } JSON_mSerializer.__default.Int_k#canCall(n#0) || 1 < $FunctionContextHeight ==> JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()) && JSON_mSerializer.__default.Int_k(n#0) == JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()));
axiom 1 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { JSON_mSerializer.__default.Int_k(LitInt(n#0)) } JSON_mSerializer.__default.Int_k#canCall(LitInt(n#0)) || 1 < $FunctionContextHeight ==> JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()) && JSON_mSerializer.__default.Int_k(LitInt(n#0)) == JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()));
}

function JSON_mSerializer.__default.Int_k#canCall(n#0: int) : bool;

function JSON_mSerializer.__default.Int_k#requires(int) : bool;

axiom (forall n#0: int :: { JSON_mSerializer.__default.Int_k#requires(n#0) } JSON_mSerializer.__default.Int_k#requires(n#0) <==> true);

procedure {:verboseName "JSON.Serializer.Int' (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Int_k(n#0: int) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id22802"} (forall c#1: int :: { Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#1)) || c#1 == JSON_mSerializer.__default.MINUS());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Int' (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Int_k(n#0: int) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#2: int;
  var ##n#0: int;
  var ##chars#0: Seq;
  var ##minus#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Int'", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(72,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mSerializer.__default.Int_k(n#0), TSeq(Tclass.BoundedInts.uint8()));
    havoc c#2;
    assume LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, $Box(c#2));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#2));
    goto anon7;

  anon11_Else:
    assume !Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#2));
    assume c#2 == JSON_mSerializer.__default.MINUS();
    goto anon7;

  anon10_Else:
    assume Seq#Contains(str#0, $Box(c#2)) ==> Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#2)) || c#2 == JSON_mSerializer.__default.MINUS();
    goto anon7;

  anon7:
    assume (forall c#1: int :: { Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#1)) || c#1 == JSON_mSerializer.__default.MINUS());
    assume false;
    return;

  anon9_Else:
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    ##chars#0 := JSON_mSerializer.__default.DIGITS();
    assume $IsAlloc(##chars#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##minus#0 := JSON_mSerializer.__default.MINUS();
    assume $IsAlloc(##minus#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} Seq#Length(##chars#0) > 1;
    assume Seq#Length(##chars#0) > 1;
    assume JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS());
    assume JSON_mSerializer.__default.Int_k(n#0) == JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS());
    assume JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS());
    assume $Is(JSON_mSerializer.__default.Int_k(n#0), TSeq(Tclass.BoundedInts.uint8()));
    assume JSON_mSerializer.__default.Int_k(n#0) == str#0;
    return;
}



function JSON_mSerializer.__default.Int(n#0: int) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSerializer.__default.Int(n#0) } JSON_mSerializer.__default.Int#canCall(n#0) || 2 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.Int(n#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError())));
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int :: { JSON_mSerializer.__default.Int(n#0) } JSON_mSerializer.__default.Int#canCall(n#0) || 2 < $FunctionContextHeight ==> JSON_mSerializer.__default.Int_k#canCall(n#0) && (var bs#0 := JSON_mSerializer.__default.Int_k(n#0); JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#0, #JSON.Errors.SerializationError.IntTooLarge(n#0)) && (var valueOrError0#0 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#0, #JSON.Errors.SerializationError.IntTooLarge(n#0)); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#0)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0)))) && JSON_mSerializer.__default.Int(n#0) == (var bs#0 := JSON_mSerializer.__default.Int_k(n#0); (var valueOrError0#0 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#0, #JSON.Errors.SerializationError.IntTooLarge(n#0)); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#0) else #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))))));
axiom 2 <= $FunctionContextHeight ==> (forall n#0: int :: {:weight 3} { JSON_mSerializer.__default.Int(LitInt(n#0)) } JSON_mSerializer.__default.Int#canCall(LitInt(n#0)) || 2 < $FunctionContextHeight ==> JSON_mSerializer.__default.Int_k#canCall(LitInt(n#0)) && (var bs#1 := Lit(JSON_mSerializer.__default.Int_k(LitInt(n#0))); JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#1, Lit(#JSON.Errors.SerializationError.IntTooLarge(LitInt(n#0)))) && (var valueOrError0#1 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#1, Lit(#JSON.Errors.SerializationError.IntTooLarge(LitInt(n#0)))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#1)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#1)))) && JSON_mSerializer.__default.Int(LitInt(n#0)) == (var bs#1 := Lit(JSON_mSerializer.__default.Int_k(LitInt(n#0))); (var valueOrError0#1 := Lit(JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#1, Lit(#JSON.Errors.SerializationError.IntTooLarge(LitInt(n#0))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#1) else #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#1))))))));
}

function JSON_mSerializer.__default.Int#canCall(n#0: int) : bool;

function JSON_mSerializer.__default.Int#requires(int) : bool;

axiom (forall n#0: int :: { JSON_mSerializer.__default.Int#requires(n#0) } JSON_mSerializer.__default.Int#requires(n#0) <==> true);

procedure {:verboseName "JSON.Serializer.Int (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Int(n#0: int);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Int (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Int(n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var bs#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##err#0: DatatypeType;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Int", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(78,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(JSON_mSerializer.__default.Int(n#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon6_Else:
    havoc bs#Z#0;
    assume $Is(bs#Z#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#Z#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume JSON_mSerializer.__default.Int_k#canCall(n#0);
    assume let#0#0#0 == JSON_mSerializer.__default.Int_k(n#0);
    assume JSON_mSerializer.__default.Int_k#canCall(n#0);
    assume $Is(let#0#0#0, TSeq(Tclass.BoundedInts.uint8()));
    assume bs#Z#0 == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##s#0 := bs#Z#0;
    assume $IsAlloc(##s#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##err#0 := #JSON.Errors.SerializationError.IntTooLarge(n#0);
    assume $IsAlloc(##err#0, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#Z#0, #JSON.Errors.SerializationError.IntTooLarge(n#0));
    assume let#1#0#0 == JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#Z#0, #JSON.Errors.SerializationError.IntTooLarge(n#0));
    assume JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#Z#0, #JSON.Errors.SerializationError.IntTooLarge(n#0));
    assume $Is(let#1#0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#Z#0);
    assume JSON_mSerializer.__default.Int(n#0) == Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.Int(n#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon7_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    ##bs#0 := bs#Z#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#Z#0));
    assume JSON_mSerializer.__default.Int(n#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#Z#0)));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#Z#0);
    assume $Is(JSON_mSerializer.__default.Int(n#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSerializer.__default.Number(dec#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall dec#0: DatatypeType :: { JSON_mSerializer.__default.Number(dec#0) } JSON_mSerializer.__default.Number#canCall(dec#0) || (3 < $FunctionContextHeight && $Is(dec#0, Tclass.JSON_mValues.Decimal())) ==> $Is(JSON_mSerializer.__default.Number(dec#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError())));
axiom 3 <= $FunctionContextHeight ==> (forall dec#0: DatatypeType :: { JSON_mSerializer.__default.Number(dec#0) } JSON_mSerializer.__default.Number#canCall(dec#0) || (3 < $FunctionContextHeight && $Is(dec#0, Tclass.JSON_mValues.Decimal())) ==> JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && Math.__default.Abs#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0))) && (var valueOrError0#0 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && JSON_mValues.Decimal.Decimal_q(dec#0) && (JSON_mValues.Decimal.e10(dec#0) != LitInt(0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))) && JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.e10(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && Math.__default.Abs#canCall(JSON_mValues.Decimal.e10(dec#0)) && JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))) && (var valueOrError2#0 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0)))) && (var valueOrError1#0 := (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#0 := JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0)); (var valueOrError2#0 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#0) else (var num#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#0, sign#0, num#1))))))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0))))) && JSON_mSerializer.__default.Number(dec#0) == (var minus#0 := JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.n(dec#0)); (var valueOrError0#0 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#0) else (var num#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; (var frac#0 := Lit(#JSON.Grammar.Maybe.Empty()); (var valueOrError1#0 := (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#0 := JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0)); (var valueOrError2#0 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#0) else (var num#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#0, sign#0, num#1))))))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#0) else (var exp#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.jnumber.JNumber(minus#0, num#0, Lit(#JSON.Grammar.Maybe.Empty()), exp#0))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall dec#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.Number(Lit(dec#0)) } JSON_mSerializer.__default.Number#canCall(Lit(dec#0)) || (3 < $FunctionContextHeight && $Is(dec#0, Tclass.JSON_mValues.Decimal())) ==> JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSerializer.__default.Sign#canCall(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && Math.__default.Abs#canCall(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))) && JSON_mSerializer.__default.Int#canCall(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))))) && (var valueOrError0#1 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.n(Lit(dec#0))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && (LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) != LitInt(0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSerializer.__default.Sign#canCall(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0)))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && Math.__default.Abs#canCall(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0)))) && JSON_mSerializer.__default.Int#canCall(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0)))))) && (var valueOrError2#1 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1)))) && (var valueOrError1#1 := (if LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#1 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#1 := Lit(JSON_mSerializer.__default.Sign(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))); (var valueOrError2#1 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#1) else (var num#3 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#1, sign#1, num#3))))))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1))))) && JSON_mSerializer.__default.Number(Lit(dec#0)) == (var minus#1 := Lit(JSON_mSerializer.__default.Sign(LitInt(JSON_mValues.Decimal.n(Lit(dec#0))))); (var valueOrError0#1 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.n(Lit(dec#0))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#1) else (var num#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): DatatypeType); (var frac#1 := Lit(#JSON.Grammar.Maybe.Empty()); (var valueOrError1#1 := (if LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#1 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#1 := Lit(JSON_mSerializer.__default.Sign(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))); (var valueOrError2#1 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#1) else (var num#3 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#1, sign#1, num#3))))))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#1) else (var exp#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.jnumber.JNumber(minus#1, num#2, Lit(#JSON.Grammar.Maybe.Empty()), exp#1))))))))))));
}

function JSON_mSerializer.__default.Number#canCall(dec#0: DatatypeType) : bool;

function JSON_mSerializer.__default.Number#requires(DatatypeType) : bool;

axiom (forall dec#0: DatatypeType :: { JSON_mSerializer.__default.Number#requires(dec#0) } $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> (JSON_mSerializer.__default.Number#requires(dec#0) <==> true));

procedure {:verboseName "JSON.Serializer.Number (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Number(dec#0: DatatypeType where $Is(dec#0, Tclass.JSON_mValues.Decimal()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Number (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Number(dec#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var minus#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##n#0: int;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##a#0: int;
  var ##n#1: int;
  var num#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var frac#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var e#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##bs#0: Seq;
  var sign#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##n#2: int;
  var valueOrError2#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##a#1: int;
  var ##n#3: int;
  var num#Z#1: DatatypeType;
  var let#8#0#0: DatatypeType;
  var exp#Z#0: DatatypeType;
  var let#9#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Number", " | ", dec#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(84,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(JSON_mSerializer.__default.Number(dec#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon13_Else:
    havoc minus#Z#0;
    assume $Is(minus#Z#0, Tclass.JSON_mGrammar.jminus()) && $IsAlloc(minus#Z#0, Tclass.JSON_mGrammar.jminus(), $Heap);
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    ##n#0 := JSON_mValues.Decimal.n(dec#0);
    assume $IsAlloc(##n#0, TInt, $Heap);
    assume JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.n(dec#0));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.n(dec#0)));
    assume let#0#0#0 == JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.n(dec#0));
    assume JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.n(dec#0));
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.jminus());
    assume minus#Z#0 == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    ##a#0 := JSON_mValues.Decimal.n(dec#0);
    assume $IsAlloc(##a#0, TInt, $Heap);
    assume Math.__default.Abs#canCall(JSON_mValues.Decimal.n(dec#0));
    ##n#1 := Math.__default.Abs(JSON_mValues.Decimal.n(dec#0));
    assume $IsAlloc(##n#1, TInt, $Heap);
    assume JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0)));
    assume let#1#0#0 == JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0)));
    assume JSON_mValues.Decimal.Decimal_q(dec#0) && Math.__default.Abs#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0)));
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#Z#0);
    assume JSON_mSerializer.__default.Number(dec#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.Number(dec#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon14_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc num#Z#0;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType);
    assume $Is($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType, Tclass.JSON_mGrammar.jnum());
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mGrammar.jnum());
    assume num#Z#0 == let#2#0#0;
    havoc frac#Z#0;
    assume $Is(frac#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $IsAlloc(frac#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    assume let#3#0#0 == Lit(#JSON.Grammar.Maybe.Empty());
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()));
    assume frac#Z#0 == let#3#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} JSON_mValues.Decimal.e10(dec#0) == LitInt(0);
    assume let#4#0#0 == Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))));
    assume true;
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()));
    goto anon10;

  anon15_Else:
    assume {:partition} JSON_mValues.Decimal.e10(dec#0) != LitInt(0);
    havoc e#Z#0;
    assume $Is(e#Z#0, Tclass.JSON_mGrammar.je()) && $IsAlloc(e#Z#0, Tclass.JSON_mGrammar.je(), $Heap);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101))))));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))));
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))), Tclass.JSON_mGrammar.je());
    assume let#5#0#0 == JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101))))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101))))));
    assume $Is(let#5#0#0, Tclass.JSON_mGrammar.je());
    assume e#Z#0 == let#5#0#0;
    havoc sign#Z#0;
    assume $Is(sign#Z#0, Tclass.JSON_mGrammar.jsign()) && $IsAlloc(sign#Z#0, Tclass.JSON_mGrammar.jsign(), $Heap);
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    ##n#2 := JSON_mValues.Decimal.e10(dec#0);
    assume $IsAlloc(##n#2, TInt, $Heap);
    assume JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.e10(dec#0));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0)));
    assume $Is(JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0)), Tclass.JSON_mGrammar.jsign());
    assume let#6#0#0 == JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0));
    assume JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.e10(dec#0));
    assume $Is(let#6#0#0, Tclass.JSON_mGrammar.jsign());
    assume sign#Z#0 == let#6#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume JSON_mValues.Decimal.Decimal_q(dec#0);
    ##a#1 := JSON_mValues.Decimal.e10(dec#0);
    assume $IsAlloc(##a#1, TInt, $Heap);
    assume Math.__default.Abs#canCall(JSON_mValues.Decimal.e10(dec#0));
    ##n#3 := Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0));
    assume $IsAlloc(##n#3, TInt, $Heap);
    assume JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0)));
    assume let#7#0#0 == JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0)));
    assume JSON_mValues.Decimal.Decimal_q(dec#0) && Math.__default.Abs#canCall(JSON_mValues.Decimal.e10(dec#0)) && JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0)));
    assume $Is(let#7#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError2#Z#0 == let#7#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#Z#0);
    assume let#4#0#0 == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#Z#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()));
    goto anon10;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    havoc num#Z#1;
    assume $Is(num#Z#1, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#1, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0)): DatatypeType);
    assume $Is($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0)): DatatypeType, Tclass.JSON_mGrammar.jnum());
    assume let#8#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    assume $Is(let#8#0#0, Tclass.JSON_mGrammar.jnum());
    assume num#Z#1 == let#8#0#0;
    assume let#4#0#0 == #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#Z#0, sign#Z#0, num#Z#1)))));
    assume true;
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()));
    goto anon10;

  anon10:
    assume valueOrError1#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#Z#0);
    assume JSON_mSerializer.__default.Number(dec#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#Z#0);
    assume $Is(JSON_mSerializer.__default.Number(dec#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon17_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    havoc exp#Z#0;
    assume $Is(exp#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())) && $IsAlloc(exp#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume let#9#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(let#9#0#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()));
    assume exp#Z#0 == let#9#0#0;
    assume JSON_mSerializer.__default.Number(dec#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.jnumber.JNumber(minus#Z#0, num#Z#0, Lit(#JSON.Grammar.Maybe.Empty()), exp#Z#0)));
    assume true;
    assume $Is(JSON_mSerializer.__default.Number(dec#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T: Ty, v#0: Box) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) } JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, v#0) || (0 < $FunctionContextHeight && $IsBox(v#0, JSON.Serializer._default.MkStructural$T)) ==> $Is(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { $IsAlloc(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T), $Heap) } (JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, v#0) || (0 < $FunctionContextHeight && $IsBox(v#0, JSON.Serializer._default.MkStructural$T) && $IsAllocBox(v#0, JSON.Serializer._default.MkStructural$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) } JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, v#0) || (0 < $FunctionContextHeight && $IsBox(v#0, JSON.Serializer._default.MkStructural$T)) ==> JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) == #JSON.Grammar.Structural.Structural(JSON_mGrammar.__default.EMPTY(), v#0, JSON_mGrammar.__default.EMPTY()));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: {:weight 3} { JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, Lit(v#0)) } JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, Lit(v#0)) || (0 < $FunctionContextHeight && $IsBox(v#0, JSON.Serializer._default.MkStructural$T)) ==> JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, Lit(v#0)) == #JSON.Grammar.Structural.Structural(JSON_mGrammar.__default.EMPTY(), Lit(v#0), JSON_mGrammar.__default.EMPTY()));
}

function JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T: Ty, v#0: Box) : bool;

function JSON_mSerializer.__default.MkStructural#requires(Ty, Box) : bool;

axiom (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { JSON_mSerializer.__default.MkStructural#requires(JSON.Serializer._default.MkStructural$T, v#0) } $IsBox(v#0, JSON.Serializer._default.MkStructural$T) ==> (JSON_mSerializer.__default.MkStructural#requires(JSON.Serializer._default.MkStructural$T, v#0) <==> true));

procedure {:verboseName "JSON.Serializer.MkStructural (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T: Ty, v#0: Box where $IsBox(v#0, JSON.Serializer._default.MkStructural$T));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.MkStructural (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T: Ty, v#0: Box)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.MkStructural", " | ", JSON.Serializer._default.MkStructural$T, " | ", v#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(99,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T));
    assume false;
    return;

  anon4_Else:
    assume $Is(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mGrammar.jblanks());
    assume $Is(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mGrammar.jblanks());
    assume JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) == #JSON.Grammar.Structural.Structural(JSON_mGrammar.__default.EMPTY(), v#0, JSON_mGrammar.__default.EMPTY());
    assume true;
    assume $Is(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T));
    return;
}



function JSON_mSerializer.__default.COLON() : DatatypeType
uses {
axiom JSON_mSerializer.__default.COLON(): DatatypeType == JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COLON()));
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.COLON(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()));
}

procedure {:verboseName "JSON.Serializer.COLON (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.COLON();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.COLON (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.COLON()
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.COLON"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(103,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##v#0 := JSON_mGrammar.__default.COLON();
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COLON()));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COLON())));
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COLON()));
    assume $Is(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COLON())), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()));
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.COLON(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.COLON(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $h));

function JSON_mSerializer.__default.KeyValue($ly: LayerType, kv#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue($ly, kv#0) } JSON_mSerializer.__default.KeyValue#canCall(kv#0) || (4 < $FunctionContextHeight && $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> $Is(JSON_mSerializer.__default.KeyValue($ly, kv#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue($LS($ly), kv#0) } JSON_mSerializer.__default.KeyValue#canCall(kv#0) || (4 < $FunctionContextHeight && $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> _System.Tuple2.___hMake2_q(kv#0) && JSON_mSerializer.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq) && (var valueOrError0#0 := JSON_mSerializer.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && _System.Tuple2.___hMake2_q(kv#0) && JSON_mSerializer.__default.Value#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType) && (var valueOrError1#0 := JSON_mSerializer.__default.Value($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0))))) && JSON_mSerializer.__default.KeyValue($LS($ly), kv#0) == (var valueOrError0#0 := JSON_mSerializer.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#0) else (var k#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; (var valueOrError1#0 := JSON_mSerializer.__default.Value($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#0) else (var v#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.jKeyValue.KeyValue(k#0, JSON_mSerializer.__default.COLON(), v#0))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, kv#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.KeyValue($LS($ly), Lit(kv#0)) } JSON_mSerializer.__default.KeyValue#canCall(Lit(kv#0)) || (4 < $FunctionContextHeight && $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSerializer.__default.String#canCall(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq)) && (var valueOrError0#1 := Lit(JSON_mSerializer.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSerializer.__default.Value#canCall(Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType)) && (var valueOrError1#1 := Lit(JSON_mSerializer.__default.Value($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1))))) && JSON_mSerializer.__default.KeyValue($LS($ly), Lit(kv#0)) == (var valueOrError0#1 := Lit(JSON_mSerializer.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#1) else (var k#1 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): DatatypeType); (var valueOrError1#1 := Lit(JSON_mSerializer.__default.Value($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#1) else (var v#1 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Grammar.jKeyValue.KeyValue(k#1, JSON_mSerializer.__default.COLON(), v#1))))))))));
}

function JSON_mSerializer.__default.KeyValue#canCall(kv#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue($LS($ly), kv#0) } JSON_mSerializer.__default.KeyValue($LS($ly), kv#0) == JSON_mSerializer.__default.KeyValue($ly, kv#0));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue(AsFuelBottom($ly), kv#0) } JSON_mSerializer.__default.KeyValue($ly, kv#0) == JSON_mSerializer.__default.KeyValue($LZ, kv#0));

function JSON_mSerializer.__default.KeyValue#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue#requires($ly, kv#0) } $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> (JSON_mSerializer.__default.KeyValue#requires($ly, kv#0) <==> true));

procedure {:verboseName "JSON.Serializer.KeyValue (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.KeyValue(kv#0: DatatypeType where $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.KeyValue (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.KeyValue(kv#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: Seq;
  var k#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##js#0: DatatypeType;
  var v#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.KeyValue", " | ", kv#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(106,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon8_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume _System.Tuple2.___hMake2_q(kv#0);
    ##str#0 := $Unbox(_System.Tuple2._0(kv#0)): Seq;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    assume JSON_mSerializer.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq);
    assume let#0#0#0 == JSON_mSerializer.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq);
    assume _System.Tuple2.___hMake2_q(kv#0) && JSON_mSerializer.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#Z#0);
    assume JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon9_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc k#Z#0;
    assume $Is(k#Z#0, Tclass.JSON_mGrammar.jstring()) && $IsAlloc(k#Z#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume JSON_mGrammar.jstring.JString_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mGrammar.jstring());
    assume k#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume _System.Tuple2.___hMake2_q(kv#0);
    ##js#0 := $Unbox(_System.Tuple2._1(kv#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume DtRank(##js#0) < DtRank(kv#0);
    assume JSON_mSerializer.__default.Value#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType);
    assume let#2#0#0 == JSON_mSerializer.__default.Value($LS($LZ), $Unbox(_System.Tuple2._1(kv#0)): DatatypeType);
    assume _System.Tuple2.___hMake2_q(kv#0) && JSON_mSerializer.__default.Value#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType);
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#Z#0);
    assume JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#Z#0);
    assume $Is(JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    havoc v#Z#0;
    assume $Is(v#Z#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#Z#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, Tclass.JSON_mGrammar.Value());
    assume v#Z#0 == let#3#0#0;
    assume JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.jKeyValue.KeyValue(k#Z#0, JSON_mSerializer.__default.COLON(), v#Z#0)));
    assume true;
    assume $Is(JSON_mSerializer.__default.KeyValue($LS($LZ), kv#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()));
    return;
}



function JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0) || (0 < $FunctionContextHeight && $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> $Is(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S)));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { $IsAlloc(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S), $Heap) } (JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0) || (0 < $FunctionContextHeight && $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $IsAlloc(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D), $Heap) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && $IsAlloc(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S), $Heap) && LitInt(0) <= start#0)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S), $Heap));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), ds#0, suffix#0, start#0) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0) || (0 < $FunctionContextHeight && $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> (Seq#Length(ds#0) > start#0 ==> start#0 != Seq#Length(ds#0) - 1 ==> JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0 + 1)) && JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), ds#0, suffix#0, start#0) == (if start#0 >= Seq#Length(ds#0) then Seq#Empty(): Seq else (if start#0 == Seq#Length(ds#0) - 1 then Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), Lit(#JSON.Grammar.Maybe.Empty())))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), #JSON.Grammar.Maybe.NonEmpty($Box(suffix#0))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0 + 1)))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: {:weight 3} { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), suffix#0, LitInt(start#0)) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), suffix#0, LitInt(start#0)) || (0 < $FunctionContextHeight && $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(ds#0)) > LitInt(start#0) ==> LitInt(start#0) != Seq#Length(Lit(ds#0)) - 1 ==> JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), suffix#0, LitInt(start#0 + 1))) && JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), suffix#0, LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(ds#0)) then Seq#Empty(): Seq else (if LitInt(start#0) == Seq#Length(Lit(ds#0)) - 1 then Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), Lit(#JSON.Grammar.Maybe.Empty())))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), #JSON.Grammar.Maybe.NonEmpty($Box(suffix#0))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), suffix#0, LitInt(start#0 + 1))))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: {:weight 3} { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), Lit(suffix#0), LitInt(start#0)) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), Lit(suffix#0), LitInt(start#0)) || (0 < $FunctionContextHeight && $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(ds#0)) > LitInt(start#0) ==> LitInt(start#0) != Seq#Length(Lit(ds#0)) - 1 ==> JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), Lit(suffix#0), LitInt(start#0 + 1))) && JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), Lit(suffix#0), LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(ds#0)) then Seq#Empty(): Seq else (if LitInt(start#0) == Seq#Length(Lit(ds#0)) - 1 then Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), Lit(#JSON.Grammar.Maybe.Empty())))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit(suffix#0))))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), Lit(suffix#0), LitInt(start#0 + 1))))));
}

function JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, ds#0: Seq, suffix#0: DatatypeType, start#0: int) : bool;

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), ds#0, suffix#0, start#0) } JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), ds#0, suffix#0, start#0) == JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0));

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, AsFuelBottom($ly), ds#0, suffix#0, start#0) } JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0) == JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LZ, ds#0, suffix#0, start#0));

function JSON_mSerializer.__default.MkSuffixedSequence#requires(Ty, Ty, LayerType, Seq, DatatypeType, int) : bool;

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence#requires(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0) } $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0 ==> (JSON_mSerializer.__default.MkSuffixedSequence#requires(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0) <==> true));

procedure {:verboseName "JSON.Serializer.MkSuffixedSequence (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, ds#0: Seq where $Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)), suffix#0: DatatypeType where $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)), start#0: int where LitInt(0) <= start#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.MkSuffixedSequence (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, ds#0: Seq, suffix#0: DatatypeType, start#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ds#0: Seq;
  var ##suffix#0: DatatypeType;
  var ##start#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.MkSuffixedSequence", " | ", JSON.Serializer._default.MkSuffixedSequence$D, " | ", JSON.Serializer._default.MkSuffixedSequence$S, " | ", ds#0, " | ", suffix#0, " | ", start#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq", " | ", "DatatypeType", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(112,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    assume false;
    return;

  anon8_Else:
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} start#0 >= Seq#Length(ds#0);
    assume $Is(Lit(Seq#Empty(): Seq), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    assume JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    return;

  anon9_Else:
    assume {:partition} Seq#Length(ds#0) > start#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} start#0 == Seq#Length(ds#0) - 1;
    assume 0 <= start#0 && start#0 < Seq#Length(ds#0);
    assume $Is(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), Lit(#JSON.Grammar.Maybe.Empty())))), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    assume JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0) == Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), Lit(#JSON.Grammar.Maybe.Empty()))));
    assume true;
    assume $Is(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    return;

  anon10_Else:
    assume {:partition} start#0 != Seq#Length(ds#0) - 1;
    assume 0 <= start#0 && start#0 < Seq#Length(ds#0);
    ##ds#0 := ds#0;
    assume $IsAlloc(##ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D), $Heap);
    ##suffix#0 := suffix#0;
    assume $IsAlloc(##suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S), $Heap);
    assume $Is(start#0 + 1, Tclass._System.nat());
    ##start#0 := start#0 + 1;
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume 0 <= Seq#Length(ds#0) - start#0 || Seq#Length(##ds#0) - ##start#0 == Seq#Length(ds#0) - start#0;
    assume Seq#Length(##ds#0) - ##start#0 < Seq#Length(ds#0) - start#0;
    assume JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0 + 1);
    assume $Is(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), #JSON.Grammar.Maybe.NonEmpty($Box(suffix#0))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0 + 1)), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    assume JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0) == Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), #JSON.Grammar.Maybe.NonEmpty($Box(suffix#0))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0 + 1));
    assume JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0 + 1);
    assume $Is(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($LZ), ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S));
    return;
}



function JSON_mSerializer.__default.COMMA() : DatatypeType
uses {
axiom JSON_mSerializer.__default.COMMA(): DatatypeType == JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COMMA()));
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mSerializer.__default.COMMA(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()));
}

procedure {:verboseName "JSON.Serializer.COMMA (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.COMMA();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.COMMA (well-formedness)"} CheckWellFormed$$JSON_mSerializer.__default.COMMA()
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.COMMA"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(121,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    ##v#0 := JSON_mGrammar.__default.COMMA();
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COMMA()));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COMMA())));
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COMMA()));
    assume $Is(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.COMMA())), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()));
    return;
}



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.COMMA(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.COMMA(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $h));

function JSON_mSerializer.__default.Object($ly: LayerType, obj#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: Seq :: { JSON_mSerializer.__default.Object($ly, obj#0) } JSON_mSerializer.__default.Object#canCall(obj#0) || (4 < $FunctionContextHeight && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> $Is(JSON_mSerializer.__default.Object($ly, obj#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSerializer.__default.Object($LS($ly), obj#0), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Object#canCall(obj#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> (forall $l#1#v#0: DatatypeType :: $Is($l#1#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> Seq#Contains(obj#0, $Box($l#1#v#0)) ==> JSON_mSerializer.__default.KeyValue#canCall($l#1#v#0)) && Seq.__default.MapWithResult#canCall(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#2#ly#0, $Unbox($l#2#v#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: $IsBox($l#2#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#2#v#0)), (lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly)), obj#0) && (var valueOrError0#0 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#3#ly#0, $Unbox($l#3#v#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $IsBox($l#3#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#3#v#0)), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $ly)), obj#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (var items#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), items#0, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()))))) && JSON_mSerializer.__default.Object($LS($ly), obj#0) == (var valueOrError0#0 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#0#ly#0, $Unbox($l#0#v#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $IsBox($l#0#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#0#v#0)), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)), obj#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var items#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#0, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE())))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: {:weight 3} { JSON_mSerializer.__default.Object($LS($ly), Lit(obj#0)), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Object#canCall(Lit(obj#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> (forall $l#5#v#0: DatatypeType :: $Is($l#5#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> Seq#Contains(obj#0, $Box($l#5#v#0)) ==> JSON_mSerializer.__default.KeyValue#canCall($l#5#v#0)) && Seq.__default.MapWithResult#canCall(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#6#ly#0, $Unbox($l#6#v#0): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: $IsBox($l#6#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#6#v#0)), (lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($ly))), Lit(obj#0)) && (var valueOrError0#1 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#7#ly#0, $Unbox($l#7#v#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: $IsBox($l#7#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#7#v#0)), (lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($ly))), Lit(obj#0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (var items#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), items#1, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()))))) && JSON_mSerializer.__default.Object($LS($ly), Lit(obj#0)) == (var valueOrError0#1 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#4#ly#0, $Unbox($l#4#v#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $IsBox($l#4#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#4#v#0)), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($ly))), Lit(obj#0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var items#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#1, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE())))))))));
}

function JSON_mSerializer.__default.Object#canCall(obj#0: Seq) : bool;

axiom (forall $ly: LayerType, obj#0: Seq :: { JSON_mSerializer.__default.Object($LS($ly), obj#0) } JSON_mSerializer.__default.Object($LS($ly), obj#0) == JSON_mSerializer.__default.Object($ly, obj#0));

axiom (forall $ly: LayerType, obj#0: Seq :: { JSON_mSerializer.__default.Object(AsFuelBottom($ly), obj#0) } JSON_mSerializer.__default.Object($ly, obj#0) == JSON_mSerializer.__default.Object($LZ, obj#0));

function JSON_mSerializer.__default.Object#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSerializer.__default.Object#requires($ly, obj#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> (JSON_mSerializer.__default.Object#requires($ly, obj#0) <==> true));

procedure {:verboseName "JSON.Serializer.Object (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Object(obj#0: Seq where $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Object (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Object(obj#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var v#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##kv#0: DatatypeType;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var items#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##v#0: DatatypeType;
  var ##ds#0: Seq;
  var ##suffix#0: DatatypeType;
  var ##start#0: int;
  var ##v#1: DatatypeType;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Object", " | ", obj#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(124,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(JSON_mSerializer.__default.Object($LS($LZ), obj#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon12_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc v#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Is(v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && $IsAlloc(v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Contains(obj#0, $Box(v#0));
    ##kv#0 := v#0;
    assume $IsAlloc(##kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), $lambdaHeap#0);
    assume DtRank(##kv#0) < Seq#Rank(obj#0);
    assume JSON_mSerializer.__default.KeyValue#canCall(v#0);
    assume lambdaResult#0 == JSON_mSerializer.__default.KeyValue($LS($LZ), v#0);
    assume JSON_mSerializer.__default.KeyValue#canCall(v#0);
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()));
    goto anon7;

  anon15_Else:
    assume {:partition} !Seq#Contains(obj#0, $Box(v#0));
    goto anon7;

  anon14_Else:
    assume {:partition} !($Is(v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && $IsAlloc(v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), $lambdaHeap#0));
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon13_Else:
    goto anon8;

  anon8:
    ##f#0 := Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#9#ly#0, $Unbox($l#9#v#0): DatatypeType))), (lambda $l#9#heap#0: Heap, $l#9#v#0: Box :: $IsBox($l#9#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#9#v#0)), (lambda $l#9#heap#0: Heap, $l#9#v#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError())), $Heap);
    ##xs#0 := obj#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.MapWithResult#canCall(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#10#ly#0, $Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#10#v#0)), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), obj#0);
    assume let#0#0#0 == Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#12#ly#0, $Unbox($l#12#v#0): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: $IsBox($l#12#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#12#v#0)), (lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), obj#0);
    assume (forall $l#13#v#0: DatatypeType :: $Is($l#13#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> Seq#Contains(obj#0, $Box($l#13#v#0)) ==> JSON_mSerializer.__default.KeyValue#canCall($l#13#v#0)) && Seq.__default.MapWithResult#canCall(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#14#ly#0, $Unbox($l#14#v#0): DatatypeType))), (lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: $IsBox($l#14#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#14#v#0)), (lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))), obj#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()));
    assume JSON_mSerializer.__default.Object($LS($LZ), obj#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.Object($LS($LZ), obj#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()));
    goto anon11;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc items#Z#0;
    assume $Is(items#Z#0, TSeq(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(items#Z#0, TSeq(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.JSON_mGrammar.jKeyValue()));
    assume items#Z#0 == let#1#0#0;
    ##v#0 := JSON_mGrammar.__default.LBRACE();
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE()));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())));
    ##ds#0 := items#Z#0;
    assume $IsAlloc(##ds#0, TSeq(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    ##suffix#0 := JSON_mSerializer.__default.COMMA();
    assume $IsAlloc(##suffix#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##start#0 := LitInt(0);
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0));
    ##v#1 := JSON_mGrammar.__default.RBRACE();
    assume $IsAlloc(##v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE())));
    assume $Is(#Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()))))), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()));
    assume JSON_mSerializer.__default.Object($LS($LZ), obj#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE())))));
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()));
    assume $Is(JSON_mSerializer.__default.Object($LS($LZ), obj#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()));
    goto anon11;

  anon11:
    assume b$reqreads#0;
    return;
}



function JSON_mSerializer.__default.Array($ly: LayerType, arr#0: Seq) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: Seq :: { JSON_mSerializer.__default.Array($ly, arr#0) } JSON_mSerializer.__default.Array#canCall(arr#0) || (4 < $FunctionContextHeight && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> $Is(JSON_mSerializer.__default.Array($ly, arr#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSerializer.__default.Array($LS($ly), arr#0), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Array#canCall(arr#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> (forall $l#1#v#0: DatatypeType :: $Is($l#1#v#0, Tclass.JSON_mValues.JSON()) ==> Seq#Contains(arr#0, $Box($l#1#v#0)) ==> JSON_mSerializer.__default.Value#canCall($l#1#v#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#2#ly#0, $Unbox($l#2#v#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: $IsBox($l#2#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#2#v#0)), (lambda $l#2#heap#0: Heap, $l#2#v#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly)), arr#0) && (var valueOrError0#0 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#3#ly#0, $Unbox($l#3#v#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: $IsBox($l#3#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#3#v#0)), (lambda $l#3#heap#0: Heap, $l#3#v#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $ly)), arr#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (var items#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), items#0, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()))))) && JSON_mSerializer.__default.Array($LS($ly), arr#0) == (var valueOrError0#0 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#0#ly#0, $Unbox($l#0#v#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $IsBox($l#0#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#0#v#0)), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)), arr#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var items#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#0, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET())))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: {:weight 3} { JSON_mSerializer.__default.Array($LS($ly), Lit(arr#0)), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Array#canCall(Lit(arr#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> (forall $l#5#v#0: DatatypeType :: $Is($l#5#v#0, Tclass.JSON_mValues.JSON()) ==> Seq#Contains(arr#0, $Box($l#5#v#0)) ==> JSON_mSerializer.__default.Value#canCall($l#5#v#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#6#ly#0, $Unbox($l#6#v#0): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: $IsBox($l#6#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#6#v#0)), (lambda $l#6#heap#0: Heap, $l#6#v#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($ly))), Lit(arr#0)) && (var valueOrError0#1 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#7#ly#0, $Unbox($l#7#v#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: $IsBox($l#7#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#7#v#0)), (lambda $l#7#heap#0: Heap, $l#7#v#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($ly))), Lit(arr#0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (var items#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), items#1, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()))))) && JSON_mSerializer.__default.Array($LS($ly), Lit(arr#0)) == (var valueOrError0#1 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#4#ly#0, $Unbox($l#4#v#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: $IsBox($l#4#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#4#v#0)), (lambda $l#4#heap#0: Heap, $l#4#v#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($ly))), Lit(arr#0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var items#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#1, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET())))))))));
}

function JSON_mSerializer.__default.Array#canCall(arr#0: Seq) : bool;

axiom (forall $ly: LayerType, arr#0: Seq :: { JSON_mSerializer.__default.Array($LS($ly), arr#0) } JSON_mSerializer.__default.Array($LS($ly), arr#0) == JSON_mSerializer.__default.Array($ly, arr#0));

axiom (forall $ly: LayerType, arr#0: Seq :: { JSON_mSerializer.__default.Array(AsFuelBottom($ly), arr#0) } JSON_mSerializer.__default.Array($ly, arr#0) == JSON_mSerializer.__default.Array($LZ, arr#0));

function JSON_mSerializer.__default.Array#requires(LayerType, Seq) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSerializer.__default.Array#requires($ly, arr#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON())) ==> (JSON_mSerializer.__default.Array#requires($ly, arr#0) <==> true));

procedure {:verboseName "JSON.Serializer.Array (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Array(arr#0: Seq where $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Array (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Array(arr#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var v#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##js#0: DatatypeType;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var items#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##v#0: DatatypeType;
  var ##ds#0: Seq;
  var ##suffix#0: DatatypeType;
  var ##start#0: int;
  var ##v#1: DatatypeType;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Array", " | ", arr#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(132,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(JSON_mSerializer.__default.Array($LS($LZ), arr#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon12_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc v#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} $Is(v#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(v#0, Tclass.JSON_mValues.JSON(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Seq#Contains(arr#0, $Box(v#0));
    ##js#0 := v#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $lambdaHeap#0);
    assume DtRank(##js#0) < Seq#Rank(arr#0);
    assume JSON_mSerializer.__default.Value#canCall(v#0);
    assume lambdaResult#0 == JSON_mSerializer.__default.Value($LS($LZ), v#0);
    assume JSON_mSerializer.__default.Value#canCall(v#0);
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    goto anon7;

  anon15_Else:
    assume {:partition} !Seq#Contains(arr#0, $Box(v#0));
    goto anon7;

  anon14_Else:
    assume {:partition} !($Is(v#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(v#0, Tclass.JSON_mValues.JSON(), $lambdaHeap#0));
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon13_Else:
    goto anon8;

  anon8:
    ##f#0 := Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#9#ly#0, $Unbox($l#9#v#0): DatatypeType))), (lambda $l#9#heap#0: Heap, $l#9#v#0: Box :: $IsBox($l#9#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#9#v#0)), (lambda $l#9#heap#0: Heap, $l#9#v#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.JSON_mValues.JSON(), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError())), $Heap);
    ##xs#0 := arr#0;
    assume $IsAlloc(##xs#0, TSeq(Tclass.JSON_mValues.JSON()), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.JSON_mValues.JSON(), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.JSON_mValues.JSON(), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.JSON_mValues.JSON(), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.JSON_mValues.JSON(), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.MapWithResult#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#10#ly#0, $Unbox($l#10#v#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: $IsBox($l#10#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#10#v#0)), (lambda $l#10#heap#0: Heap, $l#10#v#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), arr#0);
    assume let#0#0#0 == Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#12#ly#0, $Unbox($l#12#v#0): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: $IsBox($l#12#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#12#v#0)), (lambda $l#12#heap#0: Heap, $l#12#v#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), arr#0);
    assume (forall $l#13#v#0: DatatypeType :: $Is($l#13#v#0, Tclass.JSON_mValues.JSON()) ==> Seq#Contains(arr#0, $Box($l#13#v#0)) ==> JSON_mSerializer.__default.Value#canCall($l#13#v#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#14#ly#0, $Unbox($l#14#v#0): DatatypeType))), (lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: $IsBox($l#14#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#14#v#0)), (lambda $l#14#heap#0: Heap, $l#14#v#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))), arr#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()));
    assume JSON_mSerializer.__default.Array($LS($LZ), arr#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.Array($LS($LZ), arr#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()));
    goto anon11;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc items#Z#0;
    assume $Is(items#Z#0, TSeq(Tclass.JSON_mGrammar.Value())) && $IsAlloc(items#Z#0, TSeq(Tclass.JSON_mGrammar.Value()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(Tclass.JSON_mGrammar.Value()));
    assume items#Z#0 == let#1#0#0;
    ##v#0 := JSON_mGrammar.__default.LBRACKET();
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET()));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())));
    ##ds#0 := items#Z#0;
    assume $IsAlloc(##ds#0, TSeq(Tclass.JSON_mGrammar.Value()), $Heap);
    ##suffix#0 := JSON_mSerializer.__default.COMMA();
    assume $IsAlloc(##suffix#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##start#0 := LitInt(0);
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    assume JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0));
    ##v#1 := JSON_mGrammar.__default.RBRACKET();
    assume $IsAlloc(##v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET())));
    assume $Is(#Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()))))), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()));
    assume JSON_mSerializer.__default.Array($LS($LZ), arr#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET())))));
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), items#Z#0, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()));
    assume $Is(JSON_mSerializer.__default.Array($LS($LZ), arr#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()));
    goto anon11;

  anon11:
    assume b$reqreads#0;
    return;
}



function JSON_mSerializer.__default.Value($ly: LayerType, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value($ly, js#0) } JSON_mSerializer.__default.Value#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSerializer.__default.Value($ly, js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value($LS($ly), js#0) } JSON_mSerializer.__default.Value#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> (JSON_mValues.JSON.Null_q(js#0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL())) && (!JSON_mValues.JSON.Null_q(js#0) ==> (JSON_mValues.JSON.Bool_q(js#0) ==> (var b#1 := JSON_mValues.JSON.b(js#0); JSON_mSerializer.__default.Bool#canCall(b#1))) && (!JSON_mValues.JSON.Bool_q(js#0) ==> (JSON_mValues.JSON.String_q(js#0) ==> (var str#1 := JSON_mValues.JSON.str(js#0); JSON_mSerializer.__default.String#canCall(str#1) && (var valueOrError0#1 := JSON_mSerializer.__default.String(str#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1))))) && (!JSON_mValues.JSON.String_q(js#0) ==> (JSON_mValues.JSON.Number_q(js#0) ==> (var dec#1 := JSON_mValues.JSON.num(js#0); JSON_mSerializer.__default.Number#canCall(dec#1) && (var valueOrError1#1 := JSON_mSerializer.__default.Number(dec#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#1))))) && (!JSON_mValues.JSON.Number_q(js#0) ==> (JSON_mValues.JSON.Object_q(js#0) ==> (var obj#1 := JSON_mValues.JSON.obj(js#0); JSON_mSerializer.__default.Object#canCall(obj#1) && (var valueOrError2#1 := JSON_mSerializer.__default.Object($ly, obj#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#1))))) && (!JSON_mValues.JSON.Object_q(js#0) ==> (var arr#1 := JSON_mValues.JSON.arr(js#0); JSON_mSerializer.__default.Array#canCall(arr#1) && (var valueOrError3#1 := JSON_mSerializer.__default.Array($ly, arr#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#1))))))))) && JSON_mSerializer.__default.Value($LS($ly), js#0) == (if JSON_mValues.JSON.Null_q(js#0) then #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Null(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())))) else (if JSON_mValues.JSON.Bool_q(js#0) then (var b#0 := JSON_mValues.JSON.b(js#0); #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Bool(JSON_mSerializer.__default.Bool(b#0))))) else (if JSON_mValues.JSON.String_q(js#0) then (var str#0 := JSON_mValues.JSON.str(js#0); (var valueOrError0#0 := JSON_mSerializer.__default.String(str#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#0) else (var s#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.String(s#0))))))) else (if JSON_mValues.JSON.Number_q(js#0) then (var dec#0 := JSON_mValues.JSON.num(js#0); (var valueOrError1#0 := JSON_mSerializer.__default.Number(dec#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#0) else (var n#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Number(n#0))))))) else (if JSON_mValues.JSON.Object_q(js#0) then (var obj#0 := JSON_mValues.JSON.obj(js#0); (var valueOrError2#0 := JSON_mSerializer.__default.Object($ly, obj#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#0) else (var o#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Object(o#0))))))) else (var arr#0 := JSON_mValues.JSON.arr(js#0); (var valueOrError3#0 := JSON_mSerializer.__default.Array($ly, arr#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#0) else (var a#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Array(a#0)))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.Value($LS($ly), Lit(js#0)) } JSON_mSerializer.__default.Value#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> (Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL())) && (!Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (var b#3 := Lit(JSON_mValues.JSON.b(Lit(js#0))); JSON_mSerializer.__default.Bool#canCall(b#3))) && (!Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (var str#3 := Lit(JSON_mValues.JSON.str(Lit(js#0))); JSON_mSerializer.__default.String#canCall(str#3) && (var valueOrError0#3 := JSON_mSerializer.__default.String(str#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3))))) && (!Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (var dec#3 := Lit(JSON_mValues.JSON.num(Lit(js#0))); JSON_mSerializer.__default.Number#canCall(dec#3) && (var valueOrError1#3 := JSON_mSerializer.__default.Number(dec#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3))))) && (!Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var obj#3 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); JSON_mSerializer.__default.Object#canCall(obj#3) && (var valueOrError2#3 := JSON_mSerializer.__default.Object($LS($ly), obj#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3))))) && (!Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var arr#3 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); JSON_mSerializer.__default.Array#canCall(arr#3) && (var valueOrError3#3 := JSON_mSerializer.__default.Array($LS($ly), arr#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#3))))))))) && JSON_mSerializer.__default.Value($LS($ly), Lit(js#0)) == (if JSON_mValues.JSON.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Null(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())))) else (if JSON_mValues.JSON.Bool_q(Lit(js#0)) then (var b#2 := Lit(JSON_mValues.JSON.b(Lit(js#0))); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Bool(Lit(JSON_mSerializer.__default.Bool(b#2)))))))) else (if JSON_mValues.JSON.String_q(Lit(js#0)) then (var str#2 := Lit(JSON_mValues.JSON.str(Lit(js#0))); (var valueOrError0#2 := Lit(JSON_mSerializer.__default.String(str#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#2) else (var s#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.String(s#2))))))))) else (if JSON_mValues.JSON.Number_q(Lit(js#0)) then (var dec#2 := Lit(JSON_mValues.JSON.num(Lit(js#0))); (var valueOrError1#2 := Lit(JSON_mSerializer.__default.Number(dec#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#2) else (var n#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Number(n#2))))))))) else (if JSON_mValues.JSON.Object_q(Lit(js#0)) then (var obj#2 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); (var valueOrError2#2 := Lit(JSON_mSerializer.__default.Object($LS($ly), obj#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#2) else (var o#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Object(o#2))))))))) else (var arr#2 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); (var valueOrError3#2 := Lit(JSON_mSerializer.__default.Array($LS($ly), arr#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#2) else (var a#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#2)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Array(a#2)))))))))))))));
}

function JSON_mSerializer.__default.Value#canCall(js#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value($LS($ly), js#0) } JSON_mSerializer.__default.Value($LS($ly), js#0) == JSON_mSerializer.__default.Value($ly, js#0));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value(AsFuelBottom($ly), js#0) } JSON_mSerializer.__default.Value($ly, js#0) == JSON_mSerializer.__default.Value($LZ, js#0));

function JSON_mSerializer.__default.Value#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value#requires($ly, js#0) } $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mSerializer.__default.Value#requires($ly, js#0) <==> true));

procedure {:verboseName "JSON.Serializer.Value (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Value(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.Value (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.Value(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#4#0: Seq;
  var arr#Z#0: Seq;
  var let#0#0#0: Seq;
  var valueOrError3#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##arr#0: Seq;
  var a#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var _mcc#3#0: Seq;
  var obj#Z#0: Seq;
  var let#3#0#0: Seq;
  var valueOrError2#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##obj#0: Seq;
  var o#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var dec#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##dec#0: DatatypeType;
  var n#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var _mcc#1#0: Seq;
  var str#Z#0: Seq;
  var let#9#0#0: Seq;
  var valueOrError0#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;
  var ##str#0: Seq;
  var s#Z#0: DatatypeType;
  var let#11#0#0: DatatypeType;
  var _mcc#0#0: bool;
  var b#Z#0: bool;
  var let#12#0#0: bool;
  var ##b#0: bool;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.Value", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(139,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Null();
    ##bs#0 := JSON_mGrammar.__default.NULL();
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL());
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL()));
    assume $Is(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL()), Tclass.JSON_mGrammar.jnull());
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Null(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL()))));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL());
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon20_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Null();
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Bool(_mcc#0#0);
    havoc b#Z#0;
    assume true;
    assume let#12#0#0 <==> _mcc#0#0;
    assume true;
    assume $Is(let#12#0#0, TBool);
    assume b#Z#0 <==> let#12#0#0;
    ##b#0 := b#Z#0;
    assume $IsAlloc(##b#0, TBool, $Heap);
    assume JSON_mSerializer.__default.Bool#canCall(b#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mSerializer.__default.Bool(b#Z#0));
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Bool(JSON_mSerializer.__default.Bool(b#Z#0))));
    assume JSON_mSerializer.__default.Bool#canCall(b#Z#0);
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon21_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Bool(_mcc#0#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.String(_mcc#1#0);
    assume $Is(_mcc#1#0, TSeq(TChar));
    havoc str#Z#0;
    assume $Is(str#Z#0, TSeq(TChar)) && $IsAlloc(str#Z#0, TSeq(TChar), $Heap);
    assume let#9#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#9#0#0, TSeq(TChar));
    assume str#Z#0 == let#9#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##str#0 := str#Z#0;
    assume $IsAlloc(##str#0, TSeq(TChar), $Heap);
    assume JSON_mSerializer.__default.String#canCall(str#Z#0);
    assume let#10#0#0 == JSON_mSerializer.__default.String(str#Z#0);
    assume JSON_mSerializer.__default.String#canCall(str#Z#0);
    assume $Is(let#10#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#10#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#Z#0);
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon23_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc s#Z#0;
    assume $Is(s#Z#0, Tclass.JSON_mGrammar.jstring()) && $IsAlloc(s#Z#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume JSON_mGrammar.jstring.JString_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType);
    assume let#11#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#11#0#0, Tclass.JSON_mGrammar.jstring());
    assume s#Z#0 == let#11#0#0;
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Value.String(s#Z#0)));
    assume true;
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon22_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.String(_mcc#1#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Number(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mValues.Decimal());
    havoc dec#Z#0;
    assume $Is(dec#Z#0, Tclass.JSON_mValues.Decimal()) && $IsAlloc(dec#Z#0, Tclass.JSON_mValues.Decimal(), $Heap);
    assume let#6#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.JSON_mValues.Decimal());
    assume dec#Z#0 == let#6#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##dec#0 := dec#Z#0;
    assume $IsAlloc(##dec#0, Tclass.JSON_mValues.Decimal(), $Heap);
    assume JSON_mSerializer.__default.Number#canCall(dec#Z#0);
    assume let#7#0#0 == JSON_mSerializer.__default.Number(dec#Z#0);
    assume JSON_mSerializer.__default.Number#canCall(dec#Z#0);
    assume $Is(let#7#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError1#Z#0 == let#7#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#Z#0);
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#Z#0);
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    havoc n#Z#0;
    assume $Is(n#Z#0, Tclass.JSON_mGrammar.jnumber()) && $IsAlloc(n#Z#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume JSON_mGrammar.jnumber.JNumber_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): DatatypeType);
    assume let#8#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#Z#0);
    assume $Is(let#8#0#0, Tclass.JSON_mGrammar.jnumber());
    assume n#Z#0 == let#8#0#0;
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Number(n#Z#0)));
    assume true;
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon24_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Number(_mcc#2#0);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Object(_mcc#3#0);
    assume $Is(_mcc#3#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
    havoc obj#Z#0;
    assume $Is(obj#Z#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) && $IsAlloc(obj#Z#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $Heap);
    assume let#3#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#3#0#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
    assume obj#Z#0 == let#3#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##obj#0 := obj#Z#0;
    assume $IsAlloc(##obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $Heap);
    assume Seq#Rank(##obj#0) < DtRank(js#0);
    assume JSON_mSerializer.__default.Object#canCall(obj#Z#0);
    assume let#4#0#0 == JSON_mSerializer.__default.Object($LS($LZ), obj#Z#0);
    assume JSON_mSerializer.__default.Object#canCall(obj#Z#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError2#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#Z#0);
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#Z#0);
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon27_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    havoc o#Z#0;
    assume $Is(o#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(o#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0)): DatatypeType);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#Z#0);
    assume $Is(let#5#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    assume o#Z#0 == let#5#0#0;
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Object(o#Z#0)));
    assume true;
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon26_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Object(_mcc#3#0);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} js#0 == #JSON.Values.JSON.Array(_mcc#4#0);
    assume $Is(_mcc#4#0, TSeq(Tclass.JSON_mValues.JSON()));
    havoc arr#Z#0;
    assume $Is(arr#Z#0, TSeq(Tclass.JSON_mValues.JSON())) && $IsAlloc(arr#Z#0, TSeq(Tclass.JSON_mValues.JSON()), $Heap);
    assume let#0#0#0 == _mcc#4#0;
    assume true;
    assume $Is(let#0#0#0, TSeq(Tclass.JSON_mValues.JSON()));
    assume arr#Z#0 == let#0#0#0;
    havoc valueOrError3#Z#0;
    assume $Is(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##arr#0 := arr#Z#0;
    assume $IsAlloc(##arr#0, TSeq(Tclass.JSON_mValues.JSON()), $Heap);
    assume Seq#Rank(##arr#0) < DtRank(js#0);
    assume JSON_mSerializer.__default.Array#canCall(arr#Z#0);
    assume let#1#0#0 == JSON_mSerializer.__default.Array($LS($LZ), arr#Z#0);
    assume JSON_mSerializer.__default.Array#canCall(arr#Z#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError3#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#Z#0);
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#Z#0);
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon29_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0);
    havoc a#Z#0;
    assume $Is(a#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(a#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0)): DatatypeType);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    assume a#Z#0 == let#2#0#0;
    assume JSON_mSerializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Array(a#Z#0)));
    assume true;
    assume $Is(JSON_mSerializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon28_Else:
    assume {:partition} js#0 != #JSON.Values.JSON.Array(_mcc#4#0);
    assume false;
    return;
}



function JSON_mSerializer.__default.JSON(js#0: DatatypeType) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mSerializer.__default.JSON(js#0) } JSON_mSerializer.__default.JSON#canCall(js#0) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSerializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())));
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mSerializer.__default.JSON(js#0) } JSON_mSerializer.__default.JSON#canCall(js#0) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> JSON_mSerializer.__default.Value#canCall(js#0) && (var valueOrError0#0 := JSON_mSerializer.__default.Value($LS($LZ), js#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (var val#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mGrammar.Value(), $Box(val#0))))) && JSON_mSerializer.__default.JSON(js#0) == (var valueOrError0#0 := JSON_mSerializer.__default.Value($LS($LZ), js#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#0) else (var val#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mGrammar.Value(), $Box(val#0))))))));
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.JSON(Lit(js#0)) } JSON_mSerializer.__default.JSON#canCall(Lit(js#0)) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> JSON_mSerializer.__default.Value#canCall(Lit(js#0)) && (var valueOrError0#1 := Lit(JSON_mSerializer.__default.Value($LS($LZ), Lit(js#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (var val#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): DatatypeType; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mGrammar.Value(), $Box(val#1))))) && JSON_mSerializer.__default.JSON(Lit(js#0)) == (var valueOrError0#1 := Lit(JSON_mSerializer.__default.Value($LS($LZ), Lit(js#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#1) else (var val#1 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mGrammar.Value(), $Box(val#1))))))))));
}

function JSON_mSerializer.__default.JSON#canCall(js#0: DatatypeType) : bool;

function JSON_mSerializer.__default.JSON#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mSerializer.__default.JSON#requires(js#0) } $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mSerializer.__default.JSON#requires(js#0) <==> true));

procedure {:verboseName "JSON.Serializer.JSON (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.JSON(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.JSON (well-formedness)"} CheckWellformed$$JSON_mSerializer.__default.JSON(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##js#0: DatatypeType;
  var val#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##v#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.JSON", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(149,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(JSON_mSerializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon6_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume JSON_mSerializer.__default.Value#canCall(js#0);
    assume let#0#0#0 == JSON_mSerializer.__default.Value($LS($LZ), js#0);
    assume JSON_mSerializer.__default.Value#canCall(js#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume JSON_mSerializer.__default.JSON(js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume $Is(JSON_mSerializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()));
    return;

  anon7_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc val#Z#0;
    assume $Is(val#Z#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(val#Z#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mGrammar.Value());
    assume val#Z#0 == let#1#0#0;
    ##v#0 := val#Z#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mGrammar.Value(), $Box(val#Z#0));
    assume JSON_mGrammar.Structural.Structural_q(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mGrammar.Value(), $Box(val#Z#0)));
    assume JSON_mSerializer.__default.JSON(js#0) == #Wrappers.Result.Success($Box(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mGrammar.Value(), $Box(val#Z#0))));
    assume JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mGrammar.Value(), $Box(val#Z#0));
    assume $Is(JSON_mSerializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()));
    return;
}



procedure {:verboseName "JSON.Serializer.bytes32 (well-formedness)"} CheckWellFormed$$JSON_mSerializer.bytes32(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.bytes32 (well-formedness)"} CheckWellFormed$$JSON_mSerializer.bytes32(bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.bytes32", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(38,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    return;

  anon4_Else:
    assume true;
    assume Seq#Length(Lit(Seq#Empty(): Seq)) < BoundedInts.__default.TWO__TO__THE__32();
    return;
}



function Tclass.JSON_mSerializer.bytes32() : Ty
uses {
axiom Tag(Tclass.JSON_mSerializer.bytes32()) == Tagclass.JSON_mSerializer.bytes32 && TagFamily(Tclass.JSON_mSerializer.bytes32()) == tytagFamily$bytes32;
}

const unique Tagclass.JSON_mSerializer.bytes32: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mSerializer.bytes32()) } $IsBox(bx, Tclass.JSON_mSerializer.bytes32()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.JSON_mSerializer.bytes32()));

axiom (forall bs#0: Seq :: { $Is(bs#0, Tclass.JSON_mSerializer.bytes32()) } $Is(bs#0, Tclass.JSON_mSerializer.bytes32()) <==> $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall bs#0: Seq, $h: Heap :: { $IsAlloc(bs#0, Tclass.JSON_mSerializer.bytes32(), $h) } $IsAlloc(bs#0, Tclass.JSON_mSerializer.bytes32(), $h) <==> $IsAlloc(bs#0, TSeq(Tclass.BoundedInts.uint8()), $h));

procedure {:verboseName "JSON.Serializer.string32 (well-formedness)"} CheckWellFormed$$JSON_mSerializer.string32(s#0: Seq where $Is(s#0, TSeq(TChar)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Serializer.string32 (well-formedness)"} CheckWellFormed$$JSON_mSerializer.string32(s#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Serializer.string32", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Serializer.dfy(39,7): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume Seq#Length(s#0) < BoundedInts.__default.TWO__TO__THE__32();
    return;

  anon4_Else:
    assume true;
    assume Seq#Length(Lit(Seq#Empty(): Seq)) < BoundedInts.__default.TWO__TO__THE__32();
    return;
}



function Tclass.JSON_mSerializer.string32() : Ty
uses {
axiom Tag(Tclass.JSON_mSerializer.string32()) == Tagclass.JSON_mSerializer.string32 && TagFamily(Tclass.JSON_mSerializer.string32()) == tytagFamily$string32;
}

const unique Tagclass.JSON_mSerializer.string32: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mSerializer.string32()) } $IsBox(bx, Tclass.JSON_mSerializer.string32()) ==> $Box($Unbox(bx): Seq) == bx && $Is($Unbox(bx): Seq, Tclass.JSON_mSerializer.string32()));

axiom (forall s#0: Seq :: { $Is(s#0, Tclass.JSON_mSerializer.string32()) } $Is(s#0, Tclass.JSON_mSerializer.string32()) <==> $Is(s#0, TSeq(TChar)) && Seq#Length(s#0) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall s#0: Seq, $h: Heap :: { $IsAlloc(s#0, Tclass.JSON_mSerializer.string32(), $h) } $IsAlloc(s#0, Tclass.JSON_mSerializer.string32(), $h) <==> $IsAlloc(s#0, TSeq(TChar), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#192 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#192))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#194 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#194)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#288 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#288))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#290 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#290)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#292 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#292)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#288 := Wrappers.Option.value(this); v#288)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#290 := Lit(Wrappers.Option.value(Lit(this))); v#290)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#292 := Lit(Wrappers.Option.value(Lit(this))); v#292)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#192 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#192)) else (var e#192 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#194 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#194))) else (var e#194 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#288 := Wrappers.Result.value(this); s#288) else (var e#288 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#290 := Lit(Wrappers.Result.value(Lit(this))); s#290) else (var e#290 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#292 := Lit(Wrappers.Result.value(Lit(this))); s#292) else (var e#292 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#288 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#288)) else (var e#288 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#288)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#290 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#290))) else (var e#290 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#290)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#292 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#292))) else (var e#292 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#292)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#26: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#26, x#26)): bool } $IsBox(x#26, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#26, x#26)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#27: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#27, x#27)): bool } $IsBox(x#27, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#27, x#27)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#26: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#26, x#26)): bool } $IsBox(x#26, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#26, x#26)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#27: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#27, x#27)): bool } $IsBox(x#27, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#27, x#27)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#26: Box, y#26: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#26, x#26)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#26, y#26)): bool } $IsBox(x#26, Relations._default.AntiSymmetric$T) && $IsBox(y#26, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#26, y#26)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#26, x#26)): bool ==> x#26 == y#26)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#27: Box, y#27: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#27, x#27)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#27, y#27)): bool } $IsBox(x#27, Relations._default.AntiSymmetric$T) && $IsBox(y#27, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#27, y#27)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#27, x#27)): bool ==> x#27 == y#27)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#26: Box, y#26: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#26, x#26)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#26, y#26)): bool } $IsBox(x#26, Relations._default.Symmetric$T) && $IsBox(y#26, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#26, y#26)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#26, x#26)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#27: Box, y#27: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#27, x#27)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#27, y#27)): bool } $IsBox(x#27, Relations._default.Symmetric$T) && $IsBox(y#27, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#27, y#27)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#27, x#27)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#26: Box, y#26: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#26, x#26)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#26, y#26)): bool } $IsBox(x#26, Relations._default.Connected$T) && $IsBox(y#26, Relations._default.Connected$T) ==> x#26 != y#26 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#26, y#26)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#26, x#26)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#27: Box, y#27: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#27, x#27)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#27, y#27)): bool } $IsBox(x#27, Relations._default.Connected$T) && $IsBox(y#27, Relations._default.Connected$T) ==> x#27 != y#27 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#27, y#27)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#27, x#27)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#26: Box, y#26: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#26, x#26)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#26, y#26)): bool } $IsBox(x#26, Relations._default.StronglyConnected$T) && $IsBox(y#26, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#26, y#26)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#26, x#26)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#27: Box, y#27: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#27, x#27)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#27, y#27)): bool } $IsBox(x#27, Relations._default.StronglyConnected$T) && $IsBox(y#27, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#27, y#27)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#27, x#27)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#26: Box, y#26: Box, z#26: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#26, z#26)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#26, z#26)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#26, z#26)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#26, y#26)): bool } $IsBox(x#26, Relations._default.Transitive$T) && $IsBox(y#26, Relations._default.Transitive$T) && $IsBox(z#26, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#26, y#26)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#26, z#26)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#26, z#26)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#27: Box, y#27: Box, z#27: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#27, z#27)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#27, z#27)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#27, z#27)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#27, y#27)): bool } $IsBox(x#27, Relations._default.Transitive$T) && $IsBox(y#27, Relations._default.Transitive$T) && $IsBox(z#27, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#27, y#27)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#27, z#27)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#27, z#27)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#38: int, j#38: int :: { Seq#Index(a#0, j#38), Seq#Index(a#0, i#38) } LitInt(0) <= i#38 && i#38 < j#38 && j#38 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#38), Seq#Index(a#0, j#38))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#39: int, j#39: int :: { Seq#Index(a#0, j#39), Seq#Index(a#0, i#39) } LitInt(0) <= i#39 && i#39 < j#39 && j#39 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#39), Seq#Index(Lit(a#0), j#39))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#40: int, j#40: int :: { Seq#Index(a#0, j#40), Seq#Index(a#0, i#40) } LitInt(0) <= i#40 && i#40 < j#40 && j#40 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#40), Seq#Index(Lit(a#0), j#40))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#38: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#38)): bool } { s#0[x#38] } $IsBox(x#38, Relations._default.IsLeast$T) && s#0[x#38] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#38)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#39: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#39)): bool } { s#0[x#39] } $IsBox(x#39, Relations._default.IsLeast$T) && Lit(s#0)[x#39] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#39)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#40: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#40)): bool } { s#0[x#40] } $IsBox(x#40, Relations._default.IsLeast$T) && Lit(s#0)[x#40] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#40)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#38: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#38)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#38, min#0)): bool } { s#0[x#38] } $IsBox(x#38, Relations._default.IsMinimal$T) && s#0[x#38] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#38, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#38)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#39: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#39)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#39, min#0)): bool } { s#0[x#39] } $IsBox(x#39, Relations._default.IsMinimal$T) && Lit(s#0)[x#39] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#39, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#39)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#40: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#40)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#40, min#0)): bool } { s#0[x#40] } $IsBox(x#40, Relations._default.IsMinimal$T) && Lit(s#0)[x#40] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#40, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#40)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#38: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#38, max#0)): bool } { s#0[x#38] } $IsBox(x#38, Relations._default.IsGreatest$T) && s#0[x#38] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#38, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#39: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#39, max#0)): bool } { s#0[x#39] } $IsBox(x#39, Relations._default.IsGreatest$T) && Lit(s#0)[x#39] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#39, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#40: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#40, max#0)): bool } { s#0[x#40] } $IsBox(x#40, Relations._default.IsGreatest$T) && Lit(s#0)[x#40] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#40, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#38: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#38, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#38)): bool } { s#0[x#38] } $IsBox(x#38, Relations._default.IsMaximal$T) && s#0[x#38] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#38)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#38, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#39: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#39, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#39)): bool } { s#0[x#39] } $IsBox(x#39, Relations._default.IsMaximal$T) && Lit(s#0)[x#39] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#39)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#39, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#40: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#40, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#40)): bool } { s#0[x#40] } $IsBox(x#40, Relations._default.IsMaximal$T) && Lit(s#0)[x#40] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#40)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#40, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#33 := Div(Seq#Length(a#0), LitInt(2)); (var left#33, right#33 := Seq#Take(a#0, splitIndex#33), Seq#Drop(a#0, splitIndex#33); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#33, lessThanOrEq#0) && (var leftSorted#33 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#33, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#33, lessThanOrEq#0) && (var rightSorted#33 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#33, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#33, rightSorted#33, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#33 := Div(Seq#Length(a#0), LitInt(2)); (var left#33, right#33 := Seq#Take(a#0, splitIndex#33), Seq#Drop(a#0, splitIndex#33); (var leftSorted#33 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#33, lessThanOrEq#0); (var rightSorted#33 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#33, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#33, rightSorted#33, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#34 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#34, right#34 := Seq#Take(Lit(a#0), splitIndex#34), Seq#Drop(Lit(a#0), splitIndex#34); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#34, lessThanOrEq#0) && (var leftSorted#34 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#34, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#34, lessThanOrEq#0) && (var rightSorted#34 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#34, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#34, rightSorted#34, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#34 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#34, right#34 := Seq#Take(Lit(a#0), splitIndex#34), Seq#Drop(Lit(a#0), splitIndex#34); (var leftSorted#34 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#34, lessThanOrEq#0); (var rightSorted#34 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#34, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#34, rightSorted#34, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#35 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#35, right#35 := Seq#Take(Lit(a#0), splitIndex#35), Seq#Drop(Lit(a#0), splitIndex#35); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#35, Lit(lessThanOrEq#0)) && (var leftSorted#35 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#35, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#35, Lit(lessThanOrEq#0)) && (var rightSorted#35 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#35, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#35, rightSorted#35, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#35 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#35, right#35 := Seq#Take(Lit(a#0), splitIndex#35), Seq#Drop(Lit(a#0), splitIndex#35); (var leftSorted#35 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#35, Lit(lessThanOrEq#0)); (var rightSorted#35 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#35, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#35, rightSorted#35, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#22: Box :: $IsBox($y#22, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#22)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#23: Box :: $IsBox($y#23, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#23)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#22: int, j#22: int :: { Seq#Index(xs#0, j#22), Seq#Index(xs#0, i#22) } LitInt(0) <= i#22 && i#22 < Seq#Length(xs#0) && LitInt(0) <= j#22 && j#22 < Seq#Length(xs#0) && i#22 != j#22 ==> Seq#Index(xs#0, i#22) != Seq#Index(xs#0, j#22))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#23: int, j#23: int :: { Seq#Index(xs#0, j#23), Seq#Index(xs#0, i#23) } LitInt(0) <= i#23 && i#23 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#23 && j#23 < Seq#Length(Lit(xs#0)) && i#23 != j#23 ==> Seq#Index(Lit(xs#0), i#23) != Seq#Index(Lit(xs#0), j#23))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#12: int :: { Seq#Index(xs#0, j#12) } LitInt(0) <= j#12 && j#12 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#12) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#12: int :: { Seq#Index(xs#0, j#12) } LitInt(0) <= j#12 && j#12 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#12) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#30 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#30) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#30)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#31 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#31) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#31)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#32 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#32) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#32)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#12: int :: { Seq#Index(xs#0, j#12) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#12 && j#12 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#12) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#12: int :: { Seq#Index(xs#0, j#12) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#12 && j#12 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#12) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#24: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#24), Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#24) == Seq#Index(xs#0, i#24)) && (forall i#25: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#25) } pos#0 <= i#25 && i#25 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#25) == Seq#Index(xs#0, i#25 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#30 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#30), Seq#Drop(xs#0, i#30 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#31 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#31), Seq#Drop(Lit(xs#0), i#31 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#32 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#32), Seq#Drop(Lit(xs#0), i#32 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#24: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#24), Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#24) == Seq#Index(xs#0, i#24)) && (forall i#25: int :: { Seq#Index(xs#0, i#25) } pos#0 <= i#25 && i#25 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#25 + 1) == Seq#Index(xs#0, i#25)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#12: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#12) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#12 - 1) } LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#12) == Seq#Index(xs#0, Seq#Length(xs#0) - i#12 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#12: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#12) } LitInt(0) <= i#12 && i#12 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#12) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#12: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#12) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#12) } LitInt(0) <= i#12 && i#12 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#12), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#12)), $Unbox(Seq#Index(xs#0, i#12)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#20, b#20 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#20, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#20, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#21, b#21 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#21, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#21, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#12: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#12)): DatatypeType } LitInt(0) <= i#12 && i#12 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#12)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#12), Seq#Index(ys#0, i#12)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#12: int :: { Seq#Contains(xs#0, $Box(k#12)) } Seq#Contains(xs#0, $Box(k#12)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#12) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#12: int :: { Seq#Contains(xs#0, $Box(k#12)) } Seq#Contains(xs#0, $Box(k#12)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#12) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#43: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#43) } LitInt(0) <= i#43 && i#43 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#43) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#43))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#44: int :: { Seq#Index(xs#0, i#44) } LitInt(0) <= i#44 && i#44 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#44)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#44: int :: { Seq#Index(xs#0, i#44) } LitInt(0) <= i#44 && i#44 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#44)))) ==> (forall $l#25#i#0: int :: LitInt(0) <= $l#25#i#0 ==> $l#25#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#25#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#24#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#24#i#0): int))), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $IsBox($l#24#i#0, TInt) && LitInt(0) <= $Unbox($l#24#i#0): int && $Unbox($l#24#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#24#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#24#i#0): int))), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: (exists i#45: int, o#18: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#24#heap#0, f#0, Seq#Index(xs#0, i#45))[$Box(o#18)] } $Is(o#18, Tclass._System.object?()) && LitInt(0) <= i#45 && i#45 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#24#heap#0, f#0, Seq#Index(xs#0, i#45))[$Box(o#18)] && $Box($l#24#o#0) == $Box(o#18))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#31: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#31) } { Seq#Index(xs#0, i#31) } (LitInt(0) <= i#31 && i#31 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#31))): DatatypeType)) && (LitInt(0) <= i#31 && i#31 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#31) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#31))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#32: int :: { Seq#Index(xs#0, i#32) } LitInt(0) <= i#32 && i#32 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#32)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#32: int :: { Seq#Index(xs#0, i#32) } LitInt(0) <= i#32 && i#32 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#32)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#10 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#10) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#10) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#10 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#10) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#10)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#10) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#10)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#10 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#10) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#10) else (var head#10 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#10); (var valueOrError1#10 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#10) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#10) else (var tail#10 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#10)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#10), tail#10)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#31: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#31) } LitInt(0) <= i#31 ==> i#31 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#31)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#31))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#32: int :: { Seq#Index(xs#0, i#32) } LitInt(0) <= i#32 && i#32 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#32)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#32: int :: { Seq#Index(xs#0, i#32) } LitInt(0) <= i#32 && i#32 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#32)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#22: Box, xs#22: Seq, b#22: Box, b'#22: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#22, x#22, b'#22)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#22), xs#22) } $IsBox(x#22, Seq._default.InvFoldLeft$A) && $Is(xs#22, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#22, Seq._default.InvFoldLeft$B) && $IsBox(b'#22, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#22, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#22), xs#22)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#22, x#22, b'#22)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#22, $Box(xs#22))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#23: Box, xs#23: Seq, b#23: Box, b'#23: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#23, x#23, b'#23)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#23), xs#23) } $IsBox(x#23, Seq._default.InvFoldLeft$A) && $Is(xs#23, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#23, Seq._default.InvFoldLeft$B) && $IsBox(b'#23, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#23, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#23), xs#23)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#23, x#23, b'#23)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#23, $Box(xs#23))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#22: Box, xs#22: Seq, b#22: Box, b'#22: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#22), xs#22), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#22, b#22, b'#22)): bool } $IsBox(x#22, Seq._default.InvFoldRight$A) && $Is(xs#22, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#22, Seq._default.InvFoldRight$B) && $IsBox(b'#22, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#22), b#22)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#22, b#22, b'#22)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#22), xs#22)), b'#22)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#23: Box, xs#23: Seq, b#23: Box, b'#23: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#23), xs#23), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#23, b#23, b'#23)): bool } $IsBox(x#23, Seq._default.InvFoldRight$A) && $Is(xs#23, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#23, Seq._default.InvFoldRight$B) && $IsBox(b'#23, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#23), b#23)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#23, b#23, b'#23)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#23), xs#23)), b'#23)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#19: int :: { Seq#Index(xs#0, i#19) } LitInt(0) <= i#19 && i#19 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#19)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#19: int :: { Seq#Index(xs#0, i#19) } LitInt(0) <= i#19 && i#19 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#19)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#12 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#12)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#13 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#13)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#8: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#8) } $IsBox(x#8, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#8))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#8: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#8) } $IsBox(x#8, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#8))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#8: Box, x2#8: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#8), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#8) } $IsBox(x1#8, Functions._default.Injective$X) && $IsBox(x2#8, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#8) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#8) ==> x1#8 == x2#8)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#13: int :: { Seq#Take(s#0, i#13) } 0 < i#13 && i#13 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#13))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> (Seq#Length(s#0) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(2) ==> (Seq#Length(s#0) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(3) ==> Seq#Length(s#0) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0)))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then (var b#25 := Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0); b#25) else (if Seq#Length(s#0) == LitInt(2) then (var b#26 := Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#26) else (if Seq#Length(s#0) == LitInt(3) then (var b#27 := Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0); b#27) else (if Seq#Length(s#0) == LitInt(4) then (var b#28 := Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0); b#28) else false))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> (Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(2) ==> (Seq#Length(Lit(s#0)) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(3) ==> Seq#Length(Lit(s#0)) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0))))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then (var b#29 := Lit(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0))); b#29) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#30 := Lit(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#30) else (if Seq#Length(Lit(s#0)) == LitInt(3) then (var b#31 := Lit(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0))); b#31) else (if Seq#Length(Lit(s#0)) == LitInt(4) then (var b#32 := Lit(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0))); b#32) else false))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstByte#6 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#6) && le_bv8(firstByte#6, 127bv8))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#7) && le_bv8(firstByte#7, 127bv8))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstByte#6 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#6 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#6) && le_bv8(firstByte#6, 223bv8) && le_bv8(128bv8, secondByte#6) && le_bv8(secondByte#6, 191bv8)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; le_bv8(194bv8, firstByte#7) && le_bv8(firstByte#7, 223bv8) && le_bv8(128bv8, secondByte#7) && le_bv8(secondByte#7, 191bv8)))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> (var firstByte#6 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#6 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#6 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; ((firstByte#6 == Lit(224bv8) && le_bv8(160bv8, secondByte#6) && le_bv8(secondByte#6, 191bv8)) || (le_bv8(225bv8, firstByte#6) && le_bv8(firstByte#6, 236bv8) && le_bv8(128bv8, secondByte#6) && le_bv8(secondByte#6, 191bv8)) || (firstByte#6 == Lit(237bv8) && le_bv8(128bv8, secondByte#6) && le_bv8(secondByte#6, 159bv8)) || (le_bv8(238bv8, firstByte#6) && le_bv8(firstByte#6, 239bv8) && le_bv8(128bv8, secondByte#6) && le_bv8(secondByte#6, 191bv8))) && le_bv8(128bv8, thirdByte#6) && le_bv8(thirdByte#6, 191bv8))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; ((firstByte#7 == Lit(224bv8) && le_bv8(160bv8, secondByte#7) && le_bv8(secondByte#7, 191bv8)) || (le_bv8(225bv8, firstByte#7) && le_bv8(firstByte#7, 236bv8) && le_bv8(128bv8, secondByte#7) && le_bv8(secondByte#7, 191bv8)) || (firstByte#7 == Lit(237bv8) && le_bv8(128bv8, secondByte#7) && le_bv8(secondByte#7, 159bv8)) || (le_bv8(238bv8, firstByte#7) && le_bv8(firstByte#7, 239bv8) && le_bv8(128bv8, secondByte#7) && le_bv8(secondByte#7, 191bv8))) && le_bv8(128bv8, thirdByte#7) && le_bv8(thirdByte#7, 191bv8))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> (var firstByte#6 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#6 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#6 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#6 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; ((firstByte#6 == Lit(240bv8) && le_bv8(144bv8, secondByte#6) && le_bv8(secondByte#6, 191bv8)) || (le_bv8(241bv8, firstByte#6) && le_bv8(firstByte#6, 243bv8) && le_bv8(128bv8, secondByte#6) && le_bv8(secondByte#6, 191bv8)) || (firstByte#6 == Lit(244bv8) && le_bv8(128bv8, secondByte#6) && le_bv8(secondByte#6, 143bv8))) && le_bv8(128bv8, thirdByte#6) && le_bv8(thirdByte#6, 191bv8) && le_bv8(128bv8, fourthByte#6) && le_bv8(fourthByte#6, 191bv8)))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; (var fourthByte#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(3))): bv8; ((firstByte#7 == Lit(240bv8) && le_bv8(144bv8, secondByte#7) && le_bv8(secondByte#7, 191bv8)) || (le_bv8(241bv8, firstByte#7) && le_bv8(firstByte#7, 243bv8) && le_bv8(128bv8, secondByte#7) && le_bv8(secondByte#7, 191bv8)) || (firstByte#7 == Lit(244bv8) && le_bv8(128bv8, secondByte#7) && le_bv8(secondByte#7, 143bv8))) && le_bv8(128bv8, thirdByte#7) && le_bv8(thirdByte#7, 191bv8) && le_bv8(128bv8, fourthByte#7) && le_bv8(fourthByte#7, 191bv8)))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#10: int :: { Seq#Take(s#0, i#10) } 0 < i#10 && i#10 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#10))) <==> true && Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#4 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#4) && Seq#Length(prefix#4) <= Seq#Length(s#0) && Seq#Equal(prefix#4, Seq#Take(s#0, Seq#Length(prefix#4))) && (forall i#11: int :: { Seq#Take(s#0, i#11) } 0 < i#11 && i#11 < Seq#Length(prefix#4) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#11))))) && $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == (var x#6 := and_bv24(v#0, 127bv24)[7:0]; (var firstByte#7 := (0bv1 ++ x#6): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#7)))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) == (var x#7 := Lit(and_bv24(v#0, 127bv24))[7:0]; (var firstByte#8 := (0bv1 ++ x#7): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#8)))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == (var x#6 := and_bv24(v#0, 63bv24)[6:0]; (var y#6 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#7 := or_bv8(192bv8, (0bv3 ++ y#6): bv8); (var secondByte#7 := or_bv8(128bv8, (0bv2 ++ x#6): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#7)), $Box(secondByte#7)))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) == (var x#7 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#7 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#8 := or_bv8(192bv8, (0bv3 ++ y#7): bv8); (var secondByte#8 := or_bv8(128bv8, (0bv2 ++ x#7): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#8)), $Box(secondByte#8)))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == (var x#6 := and_bv24(v#0, 63bv24)[6:0]; (var y#6 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#6 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#7 := or_bv8(224bv8, (0bv4 ++ z#6): bv8); (var secondByte#7 := or_bv8(128bv8, (0bv2 ++ y#6): bv8); (var thirdByte#7 := or_bv8(128bv8, (0bv2 ++ x#6): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#7)), $Box(secondByte#7)), $Box(thirdByte#7)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) == (var x#7 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#7 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#7 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#8 := or_bv8(224bv8, (0bv4 ++ z#7): bv8); (var secondByte#8 := or_bv8(128bv8, (0bv2 ++ y#7): bv8); (var thirdByte#8 := or_bv8(128bv8, (0bv2 ++ x#7): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#8)), $Box(secondByte#8)), $Box(thirdByte#8)))))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == (var x#6 := and_bv24(v#0, 63bv24)[6:0]; (var y#6 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#6 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#6 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#6 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#7 := or_bv8(240bv8, (0bv5 ++ u1#6): bv8); (var secondByte#7 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#6): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#6): bv8); (var thirdByte#7 := or_bv8(128bv8, (0bv2 ++ y#6): bv8); (var fourthByte#7 := or_bv8(128bv8, (0bv2 ++ x#6): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#7)), $Box(secondByte#7)), $Box(thirdByte#7)), $Box(fourthByte#7))))))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) == (var x#7 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#7 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#7 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#7 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#7 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#8 := or_bv8(240bv8, (0bv5 ++ u1#7): bv8); (var secondByte#8 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#7): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#7): bv8); (var thirdByte#8 := or_bv8(128bv8, (0bv2 ++ y#7): bv8); (var fourthByte#8 := or_bv8(128bv8, (0bv2 ++ x#7): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#8)), $Box(secondByte#8)), $Box(thirdByte#8)), $Box(fourthByte#8))))))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (var firstByte#6 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var x#6 := firstByte#6[7:0]; (0bv17 ++ x#6): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) == (var firstByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var x#7 := firstByte#7[7:0]; (0bv17 ++ x#7): bv24)));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == (var firstByte#6 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#6 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var y#6 := (0bv16 ++ and_bv8(firstByte#6, 31bv8)): bv24; (var x#6 := (0bv16 ++ and_bv8(secondByte#6, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#6, (0bv19 ++ 6bv5): bv24), x#6))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) == (var firstByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var y#7 := (0bv16 ++ and_bv8(firstByte#7, 31bv8)): bv24; (var x#7 := (0bv16 ++ and_bv8(secondByte#7, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#7, (0bv19 ++ 6bv5): bv24), x#7))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == (var firstByte#6 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#6 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#6 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var z#6 := (0bv16 ++ and_bv8(firstByte#6, 15bv8)): bv24; (var y#6 := (0bv16 ++ and_bv8(secondByte#6, 63bv8)): bv24; (var x#6 := (0bv16 ++ and_bv8(thirdByte#6, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#6, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#6, (0bv19 ++ 6bv5): bv24)), x#6))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) == (var firstByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var z#7 := (0bv16 ++ and_bv8(firstByte#7, 15bv8)): bv24; (var y#7 := (0bv16 ++ and_bv8(secondByte#7, 63bv8)): bv24; (var x#7 := (0bv16 ++ and_bv8(thirdByte#7, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#7, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#7, (0bv19 ++ 6bv5): bv24)), x#7))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == (var firstByte#6 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#6 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#6 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var fourthByte#6 := $Unbox(Seq#Index(m#0, LitInt(3))): bv8; (var u1#6 := (0bv16 ++ and_bv8(firstByte#6, 7bv8)): bv24; (var u2#6 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#6, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#6 := (0bv16 ++ and_bv8(secondByte#6, 15bv8)): bv24; (var y#6 := (0bv16 ++ and_bv8(thirdByte#6, 63bv8)): bv24; (var x#6 := (0bv16 ++ and_bv8(fourthByte#6, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#6, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#6, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#6, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#6, (0bv19 ++ 6bv5): bv24)), x#6)))))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) == (var firstByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var fourthByte#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(3))): bv8; (var u1#7 := (0bv16 ++ and_bv8(firstByte#7, 7bv8)): bv24; (var u2#7 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#7, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#7 := (0bv16 ++ and_bv8(secondByte#7, 15bv8)): bv24; (var y#7 := (0bv16 ++ and_bv8(thirdByte#7, 63bv8)): bv24; (var x#7 := (0bv16 ++ and_bv8(fourthByte#7, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#7, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#7, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#7, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#7, (0bv19 ++ 6bv5): bv24)), x#7)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#7 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#7)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) && (var prefix#7 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#7))) && (var valueOrError1#6 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#7))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#7 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#7) else (var prefix#7 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7)): Seq; (var valueOrError1#6 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#7))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) else (var restParts#6 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#7)), restParts#6)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#8 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#8)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) && (var prefix#8 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#8))) && (var valueOrError1#7 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#8))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#8 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#8) else (var prefix#8 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8)): Seq); (var valueOrError1#7 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#8))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) else (var restParts#7 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#8)), restParts#7)))))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) == $Box(Utf8EncodingForm.__default.EncodeScalarValue($Unbox($fh$3x#0): bv24)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) <==> Utf8EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$3x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue($fh$3x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.EncodeScalarValue($fh$3x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(8), ms#6)) && Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#6)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#7 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(8), ms#7)) && Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#7 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#7)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) } Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) == $Box(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$3x#0): Seq)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) } Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) <==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$3x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$3x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$3x#0) == $Unbox(Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$3x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#6 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#6)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#6 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#7 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#6); vs#7)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#7 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#7)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#7 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#8 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#7); vs#8)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#7: int :: { Seq#Take(s#0, i#7) } 0 < i#7 && i#7 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#7))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> Seq#Length(s#0) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#7 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#7) else false))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#8 := Lit(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#8) else false))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstWord#6 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#6) && le_bv16(firstWord#6, 55295bv16)) || (le_bv16(57344bv16, firstWord#6) && le_bv16(firstWord#6, 65535bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (le_bv16(0bv16, firstWord#7) && le_bv16(firstWord#7, 55295bv16)) || (le_bv16(57344bv16, firstWord#7) && le_bv16(firstWord#7, 65535bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstWord#6 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (var secondWord#6 := $Unbox(Seq#Index(s#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#6) && le_bv16(firstWord#6, 56319bv16) && le_bv16(56320bv16, secondWord#6) && le_bv16(secondWord#6, 57343bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (var secondWord#7 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv16; le_bv16(55296bv16, firstWord#7) && le_bv16(firstWord#7, 56319bv16) && le_bv16(56320bv16, secondWord#7) && le_bv16(secondWord#7, 57343bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#16: int :: { Seq#Take(s#0, i#16) } 0 < i#16 && i#16 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#16))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#8 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#8) && Seq#Length(prefix#8) <= Seq#Length(s#0) && Seq#Equal(prefix#8, Seq#Take(s#0, Seq#Length(prefix#8))) && (forall i#17: int :: { Seq#Take(s#0, i#17) } 0 < i#17 && i#17 < Seq#Length(prefix#8) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#17))))) && (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#18: int :: { Seq#Take(s#0, i#18) } 0 < i#18 && i#18 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#18))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#9 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#9) && Seq#Length(prefix#9) <= Seq#Length(s#0) && Seq#Equal(prefix#9, Seq#Take(s#0, Seq#Length(prefix#9))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#9))) && $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == (var firstWord#7 := v#0[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#7))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) == (var firstWord#8 := Lit(v#0)[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#8))));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == (var x2#6 := and_bv24(v#0, 1023bv24)[10:0]; (var x1#6 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#6 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#6 := sub_bv5(u#6, 1bv5)[4:0]; (var firstWord#7 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#6): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#6): bv16); (var secondWord#7 := or_bv16(56320bv16, (0bv6 ++ x2#6): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#7)), $Box(secondWord#7)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) == (var x2#7 := Lit(and_bv24(v#0, 1023bv24))[10:0]; (var x1#7 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#7 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#7 := sub_bv5(u#7, 1bv5)[4:0]; (var firstWord#8 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#7): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#7): bv16); (var secondWord#8 := or_bv16(56320bv16, (0bv6 ++ x2#7): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#8)), $Box(secondWord#8)))))))));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (var firstWord#6 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var x#6 := firstWord#6; (0bv8 ++ x#6): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) == (var firstWord#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var x#7 := firstWord#7; (0bv8 ++ x#7): bv24)));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == (var firstWord#6 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#6 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; (var x2#6 := (0bv8 ++ and_bv16(secondWord#6, 1023bv16)): bv24; (var x1#6 := (0bv8 ++ and_bv16(firstWord#6, 63bv16)): bv24; (var w#6 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#6, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#6 := add_bv24(w#6, 1bv24); (var v#7 := or_bv24(or_bv24(LeftShift_bv24(u#6, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#6, (0bv19 ++ 10bv5): bv24)), x2#6); v#7))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) == (var firstWord#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var secondWord#7 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv16; (var x2#7 := (0bv8 ++ and_bv16(secondWord#7, 1023bv16)): bv24; (var x1#7 := (0bv8 ++ and_bv16(firstWord#7, 63bv16)): bv24; (var w#7 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#7, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#7 := add_bv24(w#7, 1bv24); (var v#8 := or_bv24(or_bv24(LeftShift_bv24(u#7, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#7, (0bv19 ++ 10bv5): bv24)), x2#7); v#8))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#7 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#7)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) && (var prefix#7 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#7))) && (var valueOrError1#6 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#7))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#7 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#7) else (var prefix#7 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#7)): Seq; (var valueOrError1#6 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#7))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6) else (var restParts#6 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#6)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#7)), restParts#6)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#8 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#8)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) && (var prefix#8 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#8))) && (var valueOrError1#7 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#8))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#8 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#8) else (var prefix#8 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#8)): Seq); (var valueOrError1#7 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#8))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7) else (var restParts#7 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#7)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#8)), restParts#7)))))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) == $Box(Utf16EncodingForm.__default.EncodeScalarValue($Unbox($fh$3x#0): bv24)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0) <==> Utf16EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$3x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue($fh$3x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.EncodeScalarValue($fh$3x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(16), ms#6)) && Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#6 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#6)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#7 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(16), ms#7)) && Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#7 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#7)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) } Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) == $Box(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$3x#0): Seq)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) } Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0) <==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$3x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$3x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$3x#0) == $Unbox(Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$3x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#6 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#6)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#6 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#7 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#6); vs#7)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#7 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#7)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#7 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#8 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#7); vs#8)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#29#c#0): char)))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#30#c#0): char)))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar)), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), s#0)) && (UnicodeStrings.__default.IsWellFormedString(s#0) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#27#c#0): char)))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar)), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))), s#0))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.IsWellFormedString(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#33#c#0): char)))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, TChar)), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#34#c#0): char)))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, TChar)), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (UnicodeStrings.__default.IsWellFormedString(Lit(s#0)) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#31#c#0): char)))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, TChar)), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#46#c#0): char)))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, TChar)), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))), s#0) && (var asCodeUnits#4 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#49#c#0): char)))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, TChar)), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))), s#0); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#4) && (var valueOrError0#4 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#4); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) && (var utf32#4 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#4) && (var asUtf8CodeUnits#4 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#4); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(nat_from_bv8($Unbox($l#48#c#0): bv8))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, TBitvector(8))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#4)))))) && UnicodeStrings.__default.ToUTF8Checked(s#0) == (var asCodeUnits#4 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#43#c#0): char)))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, TChar)), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), s#0); (var valueOrError0#4 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#4); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var utf32#4 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4)): Seq; (var asUtf8CodeUnits#4 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#4); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(nat_from_bv8($Unbox($l#44#c#0): bv8))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, TBitvector(8))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#4)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#53#c#0): char)))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, TChar)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && (var asCodeUnits#5 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#56#c#0): char)))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, TChar)), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#5) && (var valueOrError0#5 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#5); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) && (var utf32#5 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#5) && (var asUtf8CodeUnits#5 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#5); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(nat_from_bv8($Unbox($l#55#c#0): bv8))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, TBitvector(8))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#5)))))) && UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)) == (var asCodeUnits#5 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#50#c#0): char)))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, TChar)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); (var valueOrError0#5 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#5); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var utf32#5 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5)): Seq; (var asUtf8CodeUnits#5 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#5); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(nat_from_bv8($Unbox($l#51#c#0): bv8))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, TBitvector(8))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#5)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(nat_to_bv8($Unbox($l#46#c#0): int))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint8())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))), bs#0) && (var asCodeUnits#4 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(nat_to_bv8($Unbox($l#49#c#0): int))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.BoundedInts.uint8())), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))), bs#0); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#4) && (var valueOrError0#4 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#4); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#4)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) && (var utf32#4 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#4) && (var asUtf16CodeUnits#4 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#4); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#48#cu#0): bv16)))), (lambda $l#48#heap#0: Heap, $l#48#cu#0: Box :: $IsBox($l#48#cu#0, TBitvector(16))), (lambda $l#48#heap#0: Heap, $l#48#cu#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#4)))))) && UnicodeStrings.__default.FromUTF8Checked(bs#0) == (var asCodeUnits#4 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(nat_to_bv8($Unbox($l#43#c#0): int))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint8())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), bs#0); (var valueOrError0#4 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#4); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#4) else (var utf32#4 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#4)): Seq; (var asUtf16CodeUnits#4 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#4); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#44#cu#0): bv16)))), (lambda $l#44#heap#0: Heap, $l#44#cu#0: Box :: $IsBox($l#44#cu#0, TBitvector(16))), (lambda $l#44#heap#0: Heap, $l#44#cu#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#4)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(nat_to_bv8($Unbox($l#53#c#0): int))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.BoundedInts.uint8())), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && (var asCodeUnits#5 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(nat_to_bv8($Unbox($l#56#c#0): int))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint8())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#5) && (var valueOrError0#5 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#5); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#5)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) && (var utf32#5 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#5) && (var asUtf16CodeUnits#5 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#5); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#55#cu#0): bv16)))), (lambda $l#55#heap#0: Heap, $l#55#cu#0: Box :: $IsBox($l#55#cu#0, TBitvector(16))), (lambda $l#55#heap#0: Heap, $l#55#cu#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#5)))))) && UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)) == (var asCodeUnits#5 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(nat_to_bv8($Unbox($l#50#c#0): int))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.BoundedInts.uint8())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); (var valueOrError0#5 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#5); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#5) else (var utf32#5 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#5)): Seq; (var asUtf16CodeUnits#5 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#5); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#51#cu#0): bv16)))), (lambda $l#51#heap#0: Heap, $l#51#cu#0: Box :: $IsBox($l#51#cu#0, TBitvector(16))), (lambda $l#51#heap#0: Heap, $l#51#cu#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#5)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#50#c#0): char)))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, TChar)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#51#c#0): char)))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, TChar)), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))), s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#52#c#0): char)))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, TChar)), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))), s#0)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(char#ToInt($Unbox($l#54#c#0): char))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, TChar)), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))), s#0)) && UnicodeStrings.__default.ToUTF16Checked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#47#c#0): char)))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, TChar)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))), s#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(char#ToInt($Unbox($l#48#c#0): char))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, TChar)), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), s#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#58#c#0): char)))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, TChar)), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#59#c#0): char)))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, TChar)), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#60#c#0): char)))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, TChar)), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(char#ToInt($Unbox($l#62#c#0): char))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, TChar)), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#55#c#0): char)))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, TChar)), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(char#ToInt($Unbox($l#56#c#0): char))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, TChar)), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(nat_to_bv16($Unbox($l#50#c#0): int))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.BoundedInts.uint16())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))), bs#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(nat_to_bv16($Unbox($l#51#c#0): int))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.BoundedInts.uint16())), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))), bs#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box(nat_to_bv16($Unbox($l#52#c#0): int))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint16())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))), bs#0)) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(char#FromInt($Unbox($l#54#c#0): int))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint16())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))), bs#0)) && UnicodeStrings.__default.FromUTF16Checked(bs#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(nat_to_bv16($Unbox($l#47#c#0): int))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.BoundedInts.uint16())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))), bs#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(char#FromInt($Unbox($l#48#c#0): int))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint16())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), bs#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(nat_to_bv16($Unbox($l#58#c#0): int))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint16())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(nat_to_bv16($Unbox($l#59#c#0): int))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.BoundedInts.uint16())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(nat_to_bv16($Unbox($l#60#c#0): int))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, Tclass.BoundedInts.uint16())), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(char#FromInt($Unbox($l#62#c#0): int))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.BoundedInts.uint16())), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(nat_to_bv16($Unbox($l#55#c#0): int))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, Tclass.BoundedInts.uint16())), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(char#FromInt($Unbox($l#56#c#0): int))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint16())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF8#requires(s#0) <==> (forall i#8: int :: { $Unbox(Seq#Index(s#0, i#8)): char } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#8: int :: { $Unbox(Seq#Index(s#0, i#8)): char } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(char#ToInt($Unbox($l#21#c#0): char))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#21#c#0): char) && char#ToInt($Unbox($l#21#c#0): char) < 128), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(char#ToInt($Unbox($l#19#c#0): char))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#19#c#0): char) && char#ToInt($Unbox($l#19#c#0): char) < 128), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#9: int :: { $Unbox(Seq#Index(s#0, i#9)): char } LitInt(0) <= i#9 && i#9 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#9)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#9)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(char#ToInt($Unbox($l#24#c#0): char))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#24#c#0): char) && char#ToInt($Unbox($l#24#c#0): char) < 128), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(char#ToInt($Unbox($l#22#c#0): char))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#22#c#0): char) && char#ToInt($Unbox($l#22#c#0): char) < 128), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF16#requires(s#0) <==> (forall i#8: int :: { $Unbox(Seq#Index(s#0, i#8)): char } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#8: int :: { $Unbox(Seq#Index(s#0, i#8)): char } LitInt(0) <= i#8 && i#8 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#8)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(char#ToInt($Unbox($l#21#c#0): char))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#21#c#0): char) && char#ToInt($Unbox($l#21#c#0): char) < 128), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(char#ToInt($Unbox($l#19#c#0): char))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#19#c#0): char) && char#ToInt($Unbox($l#19#c#0): char) < 128), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#9: int :: { $Unbox(Seq#Index(s#0, i#9)): char } LitInt(0) <= i#9 && i#9 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#9)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#9)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(char#ToInt($Unbox($l#24#c#0): char))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#24#c#0): char) && char#ToInt($Unbox($l#24#c#0): char) < 128), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(char#ToInt($Unbox($l#22#c#0): char))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#22#c#0): char) && char#ToInt($Unbox($l#22#c#0): char) < 128), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom MulInternals.__default.MulAuto() <==> (forall x#84: int, y#84: int :: { Mul(x#84, y#84) } Mul(x#84, y#84) == Mul(y#84, x#84)) && (forall x#85: int, y#85: int, z#56: int :: { Mul(x#85 + y#85, z#56) } Mul(x#85 + y#85, z#56) == Mul(x#85, z#56) + Mul(y#85, z#56)) && (forall x#86: int, y#86: int, z#57: int :: { Mul(x#86 - y#86, z#57) } Mul(x#86 - y#86, z#57) == Mul(x#86, z#57) - Mul(y#86, z#57));

axiom MulInternals.__default.MulAuto() <==> (forall x#87: int, y#87: int :: { Mul(x#87, y#87) } Mul(x#87, y#87) == Mul(y#87, x#87)) && (forall x#88: int, y#88: int, z#58: int :: { Mul(x#88 + y#88, z#58) } Mul(x#88 + y#88, z#58) == Mul(x#88, z#58) + Mul(y#88, z#58)) && (forall x#89: int, y#89: int, z#59: int :: { Mul(x#89 - y#89, z#59) } Mul(x#89 - y#89, z#59) == Mul(x#89, z#59) - Mul(y#89, z#59));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#96: int :: { Mod(Mod(x#96, n#0), n#0) } Mod(Mod(x#96, n#0), n#0) == Mod(x#96, n#0)) && (forall x#97: int :: { Mod(x#97, n#0) } LitInt(0) <= x#97 && x#97 < n#0 <==> Mod(x#97, n#0) == x#97) && (forall x#98: int, y#48: int :: { Mod(x#98 + y#48, n#0) } (var z#46 := Mod(x#98, n#0) + Mod(y#48, n#0); (LitInt(0) <= z#46 && z#46 < n#0 && Mod(x#98 + y#48, n#0) == z#46) || (n#0 <= z#46 && z#46 < n#0 + n#0 && Mod(x#98 + y#48, n#0) == z#46 - n#0))) && (forall x#99: int, y#49: int :: { Mod(x#99 - y#49, n#0) } (var z#47 := Mod(x#99, n#0) - Mod(y#49, n#0); (LitInt(0) <= z#47 && z#47 < n#0 && Mod(x#99 - y#49, n#0) == z#47) || (0 - n#0 <= z#47 && z#47 < 0 && Mod(x#99 - y#49, n#0) == z#47 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#100: int :: { Mod(Mod(x#100, n#0), n#0) } Mod(Mod(x#100, LitInt(n#0)), LitInt(n#0)) == Mod(x#100, LitInt(n#0))) && (forall x#101: int :: { Mod(x#101, n#0) } LitInt(0) <= x#101 && x#101 < n#0 <==> Mod(x#101, LitInt(n#0)) == x#101) && (forall x#102: int, y#50: int :: { Mod(x#102 + y#50, n#0) } (var z#48 := Mod(x#102, LitInt(n#0)) + Mod(y#50, LitInt(n#0)); (LitInt(0) <= z#48 && z#48 < n#0 && Mod(x#102 + y#50, LitInt(n#0)) == z#48) || (LitInt(n#0) <= z#48 && z#48 < n#0 + n#0 && Mod(x#102 + y#50, LitInt(n#0)) == z#48 - n#0))) && (forall x#103: int, y#51: int :: { Mod(x#103 - y#51, n#0) } (var z#49 := Mod(x#103, LitInt(n#0)) - Mod(y#51, LitInt(n#0)); (LitInt(0) <= z#49 && z#49 < n#0 && Mod(x#103 - y#51, LitInt(n#0)) == z#49) || (LitInt(0 - n#0) <= z#49 && z#49 < 0 && Mod(x#103 - y#51, LitInt(n#0)) == z#49 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#66: int :: { Div(x#66, n#0) } LitInt(0) <= x#66 && x#66 < n#0 <==> Div(x#66, n#0) == LitInt(0)) && (forall x#67: int, y#44: int :: { Div(x#67 + y#44, n#0) } (var z#42 := Mod(x#67, n#0) + Mod(y#44, n#0); (LitInt(0) <= z#42 && z#42 < n#0 && Div(x#67 + y#44, n#0) == Div(x#67, n#0) + Div(y#44, n#0)) || (n#0 <= z#42 && z#42 < n#0 + n#0 && Div(x#67 + y#44, n#0) == Div(x#67, n#0) + Div(y#44, n#0) + 1))) && (forall x#68: int, y#45: int :: { Div(x#68 - y#45, n#0) } (var z#43 := Mod(x#68, n#0) - Mod(y#45, n#0); (LitInt(0) <= z#43 && z#43 < n#0 && Div(x#68 - y#45, n#0) == Div(x#68, n#0) - Div(y#45, n#0)) || (0 - n#0 <= z#43 && z#43 < 0 && Div(x#68 - y#45, n#0) == Div(x#68, n#0) - Div(y#45, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#69: int :: { Div(x#69, n#0) } LitInt(0) <= x#69 && x#69 < n#0 <==> Div(x#69, LitInt(n#0)) == LitInt(0)) && (forall x#70: int, y#46: int :: { Div(x#70 + y#46, n#0) } (var z#44 := Mod(x#70, LitInt(n#0)) + Mod(y#46, LitInt(n#0)); (LitInt(0) <= z#44 && z#44 < n#0 && Div(x#70 + y#46, LitInt(n#0)) == Div(x#70, LitInt(n#0)) + Div(y#46, LitInt(n#0))) || (LitInt(n#0) <= z#44 && z#44 < n#0 + n#0 && Div(x#70 + y#46, LitInt(n#0)) == Div(x#70, LitInt(n#0)) + Div(y#46, LitInt(n#0)) + 1))) && (forall x#71: int, y#47: int :: { Div(x#71 - y#47, n#0) } (var z#45 := Mod(x#71, LitInt(n#0)) - Mod(y#47, LitInt(n#0)); (LitInt(0) <= z#45 && z#45 < n#0 && Div(x#71 - y#47, LitInt(n#0)) == Div(x#71, LitInt(n#0)) - Div(y#47, LitInt(n#0))) || (LitInt(0 - n#0) <= z#45 && z#45 < 0 && Div(x#71 - y#47, LitInt(n#0)) == Div(x#71, LitInt(n#0)) - Div(y#47, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#10 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#10) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#10)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#10 := lv#0; (var dt_update#end#0#10 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#10), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#10), dt_update#end#0#10))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#11 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#11) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#11)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#11 := Lit(lv#0); (var dt_update#end#0#11 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#11)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#11)), dt_update#end#0#11)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#12: char :: { Seq#Contains(s#0, $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(s#0, $Box(c#12)) ==> char#ToInt(c#12) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#12: char :: { Seq#Contains(s#0, $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(s#0, $Box(c#12)) ==> char#ToInt(c#12) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#24#i#0): int)): char))), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $IsBox($l#24#i#0, TInt) && LitInt(0) <= $Unbox($l#24#i#0): int && $Unbox($l#24#i#0): int < Seq#Length(s#0)), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#13: char :: { Seq#Contains(s#0, $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(s#0, $Box(c#13)) ==> char#ToInt(c#13) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#26#i#0): int)): char))), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $IsBox($l#26#i#0, TInt) && LitInt(0) <= $Unbox($l#26#i#0): int && $Unbox($l#26#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#6: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#6)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#6)) ==> LitInt(0) <= d#6 && d#6 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#12 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#13 := Seq#Append(digits'#12, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#13))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#13 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#14 := Seq#Append(digits'#13, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#14))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#14 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#15 := Seq#Append(digits'#14, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#15))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#6: Box :: { Seq#Contains(chars#0, c#6) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#6) } $IsBox(c#6, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#6) ==> Seq#Contains(chars#0, c#6)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#13: int :: { Seq#Contains(digits#0, $Box(d#13)) } Seq#Contains(digits#0, $Box(d#13)) ==> LitInt(0) <= d#13 && d#13 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#13: int :: { Seq#Contains(digits#0, $Box(d#13)) } Seq#Contains(digits#0, $Box(d#13)) ==> LitInt(0) <= d#13 && d#13 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#14: int :: { Seq#Contains(digits#0, $Box(d#14)) } Seq#Contains(digits#0, $Box(d#14)) ==> LitInt(0) <= d#14 && d#14 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#6: Box :: { Seq#Contains(chars#0, c#6) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#6) } $IsBox(c#6, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#6) ==> Seq#Contains(chars#0, c#6)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#8 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#8) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#8), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#8 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#8), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#9 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#9) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#9), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#9 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#9), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#14: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#14)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#14) } $IsBox(c#14, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#14) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#14)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#15: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#15)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#15) } $IsBox(c#15, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#15) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#15)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#16: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#16)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#16) } $IsBox(c#16, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#16) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#16)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Seq#Contains(chars#0, $l#10#c#0))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#11: Box :: { Map#Domain(digits#0)[c#11] } { Seq#Contains(str#0, c#11) } $IsBox(c#11, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#11) ==> Map#Domain(digits#0)[c#11])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#11: Box :: { Map#Domain(digits#0)[c#11] } { Seq#Contains(str#0, c#11) } $IsBox(c#11, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#11) ==> Map#Domain(digits#0)[c#11])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#12: Box :: { Map#Domain(digits#0)[c#12] } { Seq#Contains(str#0, c#12) } $IsBox(c#12, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#12) ==> Map#Domain(digits#0)[c#12])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Map#Domain(digits#0)[$l#21#c#0])), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Map#Domain(digits#0)[$l#21#c#0])), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(Map#Domain(digits#0)[$l#22#c#0])), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Map#Domain(digits#0)[$l#23#c#0])), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#12 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#12) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#12)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#12)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#12 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#12) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#12) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#12)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#12) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#12))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#12 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#12) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#12) else (var tl#24 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#12)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#24)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#12 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#12) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#12) else (var tl#25 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#12)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#25)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#13 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#13) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#13)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#13)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#13 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#13) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#13) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#13)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#13) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#13))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#13 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#13) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#13) else (var tl#26 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#13)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#26)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#13 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#13) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#13) else (var tl#27 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#13)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#27)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#14 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#14) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#14)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#14)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#14 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#14) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#14) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#14)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#14) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#14))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#14 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#14) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#14) else (var tl#28 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#14)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#28)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#14 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#14) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#14) else (var tl#29 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#14)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#29)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#6: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#6)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#6)) ==> LitInt(0) <= d#6 && d#6 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#12 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#13 := Seq#Append(digits'#12, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#13))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#13 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#14 := Seq#Append(digits'#13, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#14))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#14 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#15 := Seq#Append(digits'#14, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#15))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#6: char :: { Seq#Contains(chars#0, $Box(c#6)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#6)) ==> Seq#Contains(chars#0, $Box(c#6))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#13: int :: { Seq#Contains(digits#0, $Box(d#13)) } Seq#Contains(digits#0, $Box(d#13)) ==> LitInt(0) <= d#13 && d#13 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#13: int :: { Seq#Contains(digits#0, $Box(d#13)) } Seq#Contains(digits#0, $Box(d#13)) ==> LitInt(0) <= d#13 && d#13 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#14: int :: { Seq#Contains(digits#0, $Box(d#14)) } Seq#Contains(digits#0, $Box(d#14)) ==> LitInt(0) <= d#14 && d#14 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#6: char :: { Seq#Contains(chars#0, $Box(c#6)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#6)) ==> Seq#Contains(chars#0, $Box(c#6))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#8 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#8) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#8), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#8 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#8), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#9 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#9) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#9), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#9 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#9), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#14: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#14))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#14)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#14))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#15: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#15))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#15)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#15))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#16: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#16))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#16)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#16))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Seq#Contains(chars#0, $l#10#c#0))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar)), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#11: char :: { Map#Domain(digits#0)[$Box(c#11)] } { Seq#Contains(str#0, $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(str#0, $Box(c#11)) ==> Map#Domain(digits#0)[$Box(c#11)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#11: char :: { Map#Domain(digits#0)[$Box(c#11)] } { Seq#Contains(str#0, $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(str#0, $Box(c#11)) ==> Map#Domain(digits#0)[$Box(c#11)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#12: char :: { Map#Domain(digits#0)[$Box(c#12)] } { Seq#Contains(str#0, $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(str#0, $Box(c#12)) ==> Map#Domain(digits#0)[$Box(c#12)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Map#Domain(digits#0)[$l#21#c#0])), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Map#Domain(digits#0)[$l#21#c#0])), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(Map#Domain(digits#0)[$l#22#c#0])), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TChar)), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Map#Domain(digits#0)[$l#23#c#0])), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#12 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#12) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#12)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#12)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#12 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#12) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#12) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#12)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#12) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#12))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#12 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#12) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#12) else (var tl#24 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#12)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#24)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#12 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#12) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#12) else (var tl#25 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#12)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#25)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#13 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#13) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#13)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#13)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#13 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#13) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#13) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#13)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#13) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#13))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#13 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#13) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#13) else (var tl#26 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#13)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#26)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#13 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#13) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#13) else (var tl#27 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#13)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#27)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#14 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#14) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#14)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#14)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#14 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#14) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#14) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#14)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#14) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#14))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#14 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#14) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#14) else (var tl#28 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#14)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#28)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#14 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#14) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#14) else (var tl#29 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#14)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#29)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#5: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#5)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#5)) } $Is(c#5, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#5)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#5))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#8#c#0))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, TChar)), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#9: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)] } { Seq#Contains(str#0, $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(str#0, $Box(c#9)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#9: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)] } { Seq#Contains(str#0, $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(str#0, $Box(c#9)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#9)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#10: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#10)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#10)] } { Seq#Contains(str#0, $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(str#0, $Box(c#10)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#10)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#10)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#17#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#17#c#0]): int < base#0)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#17#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#17#c#0]): int < base#0)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#18#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#18#c#0]): int < base#0)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom $Is(JSON_mUtils_mVectors.__default.OOM__FAILURE(), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mVectors.__default.OOM__FAILURE(), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mVectors.__default.OOM__FAILURE(), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mVectors.VectorError()), $h));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o) } $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $IsBox(JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o), JSON.Utils.Vectors.Vector$A));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAllocBox(JSON_mUtils_mVectors.Vector.a(JSON.Utils.Vectors.Vector$A, $o), JSON.Utils.Vectors.Vector$A, $h));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o) } $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is(JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32()));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32(), $h));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o) } $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) ==> $Is(JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32()));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $h: Heap, $o: ref :: { JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o), $Unbox(read($h, $o, alloc)): bool } $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.JSON_mUtils_mVectors.Vector?(JSON.Utils.Vectors.Vector$A) && $Unbox(read($h, $o, alloc)): bool ==> $IsAlloc(JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, $o), Tclass.BoundedInts.uint32(), $h));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) } JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) ==> JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) ==> ($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set)[$Box(this)]);

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this), $IsGoodHeap($Heap) } JSON_mUtils_mVectors.Vector.Valid_q#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap)) ==> (JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this) <==> Set#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.Repr)): Set, Set#UnionOne(Set#UnionOne(Set#Empty(): Set, $Box(this)), read($Heap, this, JSON_mUtils_mVectors.Vector.data))) && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int != 0 && _System.array.Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref) == $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int <= $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.capacity)): int && $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int == Seq#Length($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq) && Seq#Equal($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, Seq#Take(Seq#FromArray($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref), $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int))));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) } JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) && read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, idx#0) && $IsBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { $IsAllocBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A, $Heap) } JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) || ($IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> $IsAllocBox(JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), JSON.Utils.Vectors.Vector$A, $Heap));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref, idx#0: int :: { JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0), $IsGoodHeap($Heap) } JSON_mUtils_mVectors.Vector.At#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && LitInt(0) <= idx#0 && idx#0 < BoundedInts.__default.TWO__TO__THE__32() && idx#0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.At(JSON.Utils.Vectors.Vector$A, $Heap, this, idx#0) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField(idx#0)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) } JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) && read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)) == Seq#Index($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.items)): Seq, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1) && $IsBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { $IsAllocBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A, $Heap) } JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || ($IsGoodHeap($Heap) && this != null && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> $IsAllocBox(JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), JSON.Utils.Vectors.Vector$A, $Heap));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, $Heap: Heap, this: ref :: { JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this), $IsGoodHeap($Heap) } JSON_mUtils_mVectors.Vector.Top#canCall(JSON.Utils.Vectors.Vector$A, $Heap, this) || ($IsGoodHeap($Heap) && this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && $IsAlloc(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A), $Heap) && 0 < $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int && JSON_mUtils_mVectors.Vector.Valid_q(JSON.Utils.Vectors.Vector$A, $Heap, this)) ==> JSON_mUtils_mVectors.Vector.Top(JSON.Utils.Vectors.Vector$A, $Heap, this) == read($Heap, $Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.data)): ref, IndexField($Unbox(read($Heap, this, JSON_mUtils_mVectors.Vector.size)): int - 1)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, capacity#0) || (this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> LitInt(0) <= JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) && JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, capacity#0) || (this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, capacity#0) == (if capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), capacity#0) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: {:weight 3} { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, LitInt(capacity#0)) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, this, LitInt(capacity#0)) || (this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, this, LitInt(capacity#0)) == (if capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, this) then Mul(LitInt(2), LitInt(capacity#0)) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, this)));

axiom (forall JSON.Utils.Vectors.Vector$A: Ty, this: ref, capacity#0: int :: {:weight 3} { JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, Lit(this), LitInt(capacity#0)) } JSON_mUtils_mVectors.Vector.DefaultNewCapacity#canCall(JSON.Utils.Vectors.Vector$A, Lit(this), LitInt(capacity#0)) || (this != null && $Is(this, Tclass.JSON_mUtils_mVectors.Vector(JSON.Utils.Vectors.Vector$A)) && LitInt(0) <= capacity#0 && capacity#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mVectors.Vector.DefaultNewCapacity(JSON.Utils.Vectors.Vector$A, Lit(this), LitInt(capacity#0)) == (if capacity#0 < JSON_mUtils_mVectors.Vector.MAX__CAPACITY__BEFORE__DOUBLING(JSON.Utils.Vectors.Vector$A, Lit(this)) then Mul(LitInt(2), LitInt(capacity#0)) else JSON_mUtils_mVectors.Vector.MAX__CAPACITY(JSON.Utils.Vectors.Vector$A, Lit(this))));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#8 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#8)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#16 := JSON_mErrors.DeserializationError.b(this); (var b0#8 := JSON_mErrors.DeserializationError.expected(this); (var c#16 := (if b#16 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#16)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#8)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#16)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#17 := JSON_mErrors.DeserializationError.b(this); (var bs0#8 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#17 := (if b#17 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#17)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#8 := Seq#Create(TChar, $Heap, Seq#Length(bs0#8), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#8, $Unbox($l#16#idx#0): int)): int))), (lambda $l#16#heap#0: Heap, $l#16#idx#0: Box :: $IsBox($l#16#idx#0, TInt) && LitInt(0) <= $Unbox($l#16#idx#0): int && $Unbox($l#16#idx#0): int < Seq#Length(bs0#8)), (lambda $l#16#heap#0: Heap, $l#16#idx#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#8), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#17))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#10 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#10)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#20 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#10 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#20 := (if b#20 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#20)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#10)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#20)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#21 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#10 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#21 := (if b#21 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#21)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#10 := Seq#Create(TChar, $Heap, Seq#Length(bs0#10), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#10, $Unbox($l#19#idx#0): int)): int))), (lambda $l#19#heap#0: Heap, $l#19#idx#0: Box :: $IsBox($l#19#idx#0, TInt) && LitInt(0) <= $Unbox($l#19#idx#0): int && $Unbox($l#19#idx#0): int < Seq#Length(bs0#10)), (lambda $l#19#heap#0: Heap, $l#19#idx#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#10), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#21))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#9 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#9, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#8 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#8, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#8 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#8)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#11 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#11, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#10 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#10, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#10 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#10)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall c#0: int :: { JSON_mSpec.__default.EscapeUnicode(c#0) } JSON_mSpec.__default.EscapeUnicode#canCall(c#0) || (LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> $Is(JSON_mSpec.__default.EscapeUnicode(c#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall $Heap: Heap, c#0: int :: { JSON_mSpec.__default.EscapeUnicode(c#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(c#0) || ($IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(c#0, LitInt(16)) && (var sStr#2 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#2)) && JSON_mSpec.__default.EscapeUnicode(c#0) == (var sStr#2 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); (var s#2 := UnicodeStrings.__default.ASCIIToUTF16(sStr#2); Seq#Append(s#2, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#2), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#10#heap#0: Heap, $l#10#_v0#0: Box :: $IsBox($l#10#_v0#0, TInt)), (lambda $l#10#heap#0: Heap, $l#10#_v0#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $Heap: Heap, c#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(LitInt(c#0)) || ($IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(LitInt(c#0), LitInt(16)) && (var sStr#3 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#3)) && JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)) == (var sStr#3 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); (var s#3 := Lit(UnicodeStrings.__default.ASCIIToUTF16(sStr#3)); Seq#Append(s#3, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#3), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: $IsBox($l#12#_v0#0, TInt)), (lambda $l#12#heap#0: Heap, $l#12#_v0#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($ly, str#0, start#0) } JSON_mSpec.__default.Escape#canCall(str#0, start#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> $Is(JSON_mSpec.__default.Escape($ly, str#0, start#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) } JSON_mSpec.__default.Escape#canCall(str#0, start#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(str#0) > start#0 ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(34) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(92) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(8) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(12) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(10) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(13) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(9) ==> (var c#3 := $Unbox(Seq#Index(str#0, start#0)): int; c#3 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#3))))))))) && JSON_mSpec.__default.Escape#canCall(str#0, start#0 + 1)) && JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) == (if start#0 >= Seq#Length(str#0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#3 := $Unbox(Seq#Index(str#0, start#0)): int; (if c#3 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#3)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))))))))))), JSON_mSpec.__default.Escape($ly, str#0, start#0 + 1))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(34) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(92) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(8) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(12) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(10) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(13) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(9) ==> (var c#4 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; c#4 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#4))))))))) && JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0 + 1))) && JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#4 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; (if c#4 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#4)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0)))))))))))), JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0 + 1)))));

axiom (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) } JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, start#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> $Is(JSON_mSpec.__default.EscapeToUTF8(str#0, start#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) } JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, start#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(str#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#2 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (var utf16#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#2, LitInt(0)) && (var escaped#2 := JSON_mSpec.__default.Escape($LS($LZ), utf16#2, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#2) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#2), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#2 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#2), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (var utf32#2 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#2) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#2), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == (var valueOrError0#2 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var utf16#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; (var escaped#2 := JSON_mSpec.__default.Escape($LS($LZ), utf16#2, LitInt(0)); (var valueOrError1#2 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#2), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#2) else (var utf32#2 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): Seq; Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#2), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))));

axiom (forall str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(start#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(str#0)) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#3 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (var utf16#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#3, LitInt(0)) && (var escaped#3 := JSON_mSpec.__default.Escape($LS($LZ), utf16#3, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#3) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#3), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#3 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#3), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (var utf32#3 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#3) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#3), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) == (var valueOrError0#3 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var utf16#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq); (var escaped#3 := Lit(JSON_mSpec.__default.Escape($LS($LZ), utf16#3, LitInt(0))); (var valueOrError1#3 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.FromUTF16Checked(escaped#3)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#3) else (var utf32#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3)): Seq); Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF8Checked(utf32#3)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))))))))))));

axiom (forall str#0: Seq :: { JSON_mSpec.__default.String(str#0) } JSON_mSpec.__default.String#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> $Is(JSON_mSpec.__default.String(str#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall str#0: Seq :: { JSON_mSpec.__default.String(str#0) } JSON_mSpec.__default.String#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0)) && (var valueOrError0#2 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(str#0) == (var valueOrError0#2 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var inBytes#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#2), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mSpec.__default.String(Lit(str#0)) } JSON_mSpec.__default.String#canCall(Lit(str#0)) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(0)) && (var valueOrError0#3 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(Lit(str#0)) == (var valueOrError0#3 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var inBytes#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#3), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));

axiom (forall n#0: int :: { JSON_mSpec.__default.IntToBytes(n#0) } $Is(JSON_mSpec.__default.IntToBytes(n#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int :: { JSON_mSpec.__default.IntToBytes(n#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10)) && (var s#2 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#2)) && JSON_mSpec.__default.IntToBytes(n#0) == (var s#2 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8(s#2)));

axiom (forall n#0: int :: {:weight 3} { JSON_mSpec.__default.IntToBytes(LitInt(n#0)) } JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(n#0), LitInt(10)) && (var s#3 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#3)) && JSON_mSpec.__default.IntToBytes(LitInt(n#0)) == (var s#3 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); Lit(UnicodeStrings.__default.ASCIIToUTF8(s#3))));

axiom (forall dec#0: DatatypeType :: { JSON_mSpec.__default.Number(dec#0) } JSON_mSpec.__default.Number#canCall(dec#0) || $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> $Is(JSON_mSpec.__default.Number(dec#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall dec#0: DatatypeType :: { JSON_mSpec.__default.Number(dec#0) } JSON_mSpec.__default.Number#canCall(dec#0) || $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && (JSON_mValues.Decimal.e10(dec#0) != LitInt(0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))) && JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSpec.__default.IntToBytes#canCall(JSON_mValues.Decimal.e10(dec#0))) && JSON_mSpec.__default.Number(dec#0) == #Wrappers.Result.Success($Box(Seq#Append(JSON_mSpec.__default.IntToBytes(JSON_mValues.Decimal.n(dec#0)), (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))), JSON_mSpec.__default.IntToBytes(JSON_mValues.Decimal.e10(dec#0))))))));

axiom (forall dec#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.Number(Lit(dec#0)) } JSON_mSpec.__default.Number#canCall(Lit(dec#0)) || $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSpec.__default.IntToBytes#canCall(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && (LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) != LitInt(0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSpec.__default.IntToBytes#canCall(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))) && JSON_mSpec.__default.Number(Lit(dec#0)) == #Wrappers.Result.Success($Box(Seq#Append(JSON_mSpec.__default.IntToBytes(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))), (if LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) == LitInt(0) then Seq#Empty(): Seq else Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(101))))), JSON_mSpec.__default.IntToBytes(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($ly, kv#0) } JSON_mSpec.__default.KeyValue#canCall(kv#0) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSpec.__default.KeyValue($ly, kv#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($LS($ly), kv#0) } JSON_mSpec.__default.KeyValue#canCall(kv#0) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq) && (var valueOrError0#2 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.JSON#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType) && (var valueOrError1#2 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), kv#0) == (var valueOrError0#2 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var key#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; (var valueOrError1#2 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#2) else (var value#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#2, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#2))))))))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) } JSON_mSpec.__default.KeyValue#canCall(Lit(kv#0)) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.String#canCall(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq)) && (var valueOrError0#3 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.JSON#canCall(Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType)) && (var valueOrError1#3 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) == (var valueOrError0#3 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var key#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq); (var valueOrError1#3 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#3) else (var value#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#3, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#3))))))))));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($ly, sep#0, items#0) } JSON_mSpec.__default.Join#canCall(sep#0, items#0) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> $Is(JSON_mSpec.__default.Join($ly, sep#0, items#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) } JSON_mSpec.__default.Join#canCall(sep#0, items#0) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(items#0) != LitInt(0) ==> (var valueOrError0#2 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Seq#Length(items#0) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(sep#0, Seq#Drop(items#0, LitInt(1))) && (var valueOrError1#2 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2))))))) && JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) == (if Seq#Length(items#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#2 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var first#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; (if Seq#Length(items#0) == LitInt(1) then #Wrappers.Result.Success($Box(first#2)) else (var valueOrError1#2 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#2) else (var rest#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#2, sep#0), rest#2))))))))))));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: {:weight 3} { JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) } JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(items#0)) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(Lit(items#0)) != LitInt(0) ==> (var valueOrError0#3 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Seq#Length(Lit(items#0)) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1)))) && (var valueOrError1#3 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3))))))) && JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) == (if Seq#Length(Lit(items#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#3 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var first#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; (if Seq#Length(Lit(items#0)) == LitInt(1) then #Wrappers.Result.Success($Box(first#3)) else (var valueOrError1#3 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#3) else (var rest#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#3, sep#0), rest#3))))))))))));

axiom (forall $ly: LayerType, obj#0: Seq :: { JSON_mSpec.__default.Object($ly, obj#0) } JSON_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> $Is(JSON_mSpec.__default.Object($ly, obj#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSpec.__default.Object($LS($ly), obj#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(obj#0) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#17#i#0: int :: LitInt(0) <= $l#17#i#0 && $l#17#i#0 < Seq#Length(obj#0) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, $l#17#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#18#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#18#i#0): int)): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $IsBox($l#18#i#0, TInt) && LitInt(0) <= $Unbox($l#18#i#0): int && $Unbox($l#18#i#0): int < Seq#Length(obj#0)), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $ly)))) && (var valueOrError0#2 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#19#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#19#i#0): int)): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#i#0: Box :: $IsBox($l#19#i#0, TInt) && LitInt(0) <= $Unbox($l#19#i#0): int && $Unbox($l#19#i#0): int < Seq#Length(obj#0)), (lambda $l#19#heap#0: Heap, $l#19#i#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), obj#0) == (var valueOrError0#2 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#16#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#16#i#0): int)): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $IsBox($l#16#i#0, TInt) && LitInt(0) <= $Unbox($l#16#i#0): int && $Unbox($l#16#i#0): int < Seq#Length(obj#0)), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var middle#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#2), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: {:weight 3} { JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(Lit(obj#0)) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#21#i#0: int :: LitInt(0) <= $l#21#i#0 && $l#21#i#0 < Seq#Length(Lit(obj#0)) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(Lit(obj#0), $l#21#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#22#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#22#i#0): int)): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $IsBox($l#22#i#0, TInt) && LitInt(0) <= $Unbox($l#22#i#0): int && $Unbox($l#22#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#3 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#23#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#23#i#0): int)): DatatypeType))), (lambda $l#23#heap#0: Heap, $l#23#i#0: Box :: $IsBox($l#23#i#0, TInt) && LitInt(0) <= $Unbox($l#23#i#0): int && $Unbox($l#23#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#23#heap#0: Heap, $l#23#i#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)) == (var valueOrError0#3 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#20#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#20#i#0): int)): DatatypeType))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $IsBox($l#20#i#0, TInt) && LitInt(0) <= $Unbox($l#20#i#0): int && $Unbox($l#20#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var middle#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#3), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));

axiom (forall $ly: LayerType, arr#0: Seq :: { JSON_mSpec.__default.Array($ly, arr#0) } JSON_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSpec.__default.Array($ly, arr#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSpec.__default.Array($LS($ly), arr#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(arr#0) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#17#i#0: int :: LitInt(0) <= $l#17#i#0 && $l#17#i#0 < Seq#Length(arr#0) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, $l#17#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#18#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#18#i#0): int)): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: $IsBox($l#18#i#0, TInt) && LitInt(0) <= $Unbox($l#18#i#0): int && $Unbox($l#18#i#0): int < Seq#Length(arr#0)), (lambda $l#18#heap#0: Heap, $l#18#i#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $ly)))) && (var valueOrError0#2 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#19#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#19#i#0): int)): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#i#0: Box :: $IsBox($l#19#i#0, TInt) && LitInt(0) <= $Unbox($l#19#i#0): int && $Unbox($l#19#i#0): int < Seq#Length(arr#0)), (lambda $l#19#heap#0: Heap, $l#19#i#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), arr#0) == (var valueOrError0#2 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#16#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#16#i#0): int)): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: $IsBox($l#16#i#0, TInt) && LitInt(0) <= $Unbox($l#16#i#0): int && $Unbox($l#16#i#0): int < Seq#Length(arr#0)), (lambda $l#16#heap#0: Heap, $l#16#i#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#2) else (var middle#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#2), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: {:weight 3} { JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(Lit(arr#0)) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#21#i#0: int :: LitInt(0) <= $l#21#i#0 && $l#21#i#0 < Seq#Length(Lit(arr#0)) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(Lit(arr#0), $l#21#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#22#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#22#i#0): int)): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: $IsBox($l#22#i#0, TInt) && LitInt(0) <= $Unbox($l#22#i#0): int && $Unbox($l#22#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#22#heap#0: Heap, $l#22#i#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#3 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#23#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#23#i#0): int)): DatatypeType))), (lambda $l#23#heap#0: Heap, $l#23#i#0: Box :: $IsBox($l#23#i#0, TInt) && LitInt(0) <= $Unbox($l#23#i#0): int && $Unbox($l#23#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#23#heap#0: Heap, $l#23#i#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)) == (var valueOrError0#3 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#20#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#20#i#0): int)): DatatypeType))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: $IsBox($l#20#i#0, TInt) && LitInt(0) <= $Unbox($l#20#i#0): int && $Unbox($l#20#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#20#heap#0: Heap, $l#20#i#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#3) else (var middle#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#3), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($ly, js#0) } JSON_mSpec.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> $Is(JSON_mSpec.__default.JSON($ly, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($LS($ly), js#0) } JSON_mSpec.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mValues.JSON.Null_q(js#0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!JSON_mValues.JSON.Null_q(js#0) ==> (JSON_mValues.JSON.Bool_q(js#0) ==> (var b#5 := JSON_mValues.JSON.b(js#0); (b#5 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#5 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!JSON_mValues.JSON.Bool_q(js#0) ==> (JSON_mValues.JSON.String_q(js#0) ==> (var str#5 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String#canCall(str#5))) && (!JSON_mValues.JSON.String_q(js#0) ==> (JSON_mValues.JSON.Number_q(js#0) ==> (var dec#5 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number#canCall(dec#5))) && (!JSON_mValues.JSON.Number_q(js#0) ==> (JSON_mValues.JSON.Object_q(js#0) ==> (var obj#5 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object#canCall(obj#5))) && (!JSON_mValues.JSON.Object_q(js#0) ==> (var arr#5 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array#canCall(arr#5))))))) && JSON_mSpec.__default.JSON($LS($ly), js#0) == (if JSON_mValues.JSON.Null_q(js#0) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(js#0) then (var b#4 := JSON_mValues.JSON.b(js#0); #Wrappers.Result.Success($Box((if b#4 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(js#0) then (var str#4 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String(str#4)) else (if JSON_mValues.JSON.Number_q(js#0) then (var dec#4 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number(dec#4)) else (if JSON_mValues.JSON.Object_q(js#0) then (var obj#4 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object($ly, obj#4)) else (var arr#4 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array($ly, arr#4))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) } JSON_mSpec.__default.JSON#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (var b#7 := Lit(JSON_mValues.JSON.b(Lit(js#0))); (b#7 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#7 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (var str#7 := Lit(JSON_mValues.JSON.str(Lit(js#0))); JSON_mSpec.__default.String#canCall(str#7))) && (!Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (var dec#7 := Lit(JSON_mValues.JSON.num(Lit(js#0))); JSON_mSpec.__default.Number#canCall(dec#7))) && (!Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var obj#7 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); JSON_mSpec.__default.Object#canCall(obj#7))) && (!Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var arr#7 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); JSON_mSpec.__default.Array#canCall(arr#7))))))) && JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) == (if JSON_mValues.JSON.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(Lit(js#0)) then (var b#6 := Lit(JSON_mValues.JSON.b(Lit(js#0))); #Wrappers.Result.Success($Box((if b#6 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(Lit(js#0)) then (var str#6 := Lit(JSON_mValues.JSON.str(Lit(js#0))); Lit(JSON_mSpec.__default.String(str#6))) else (if JSON_mValues.JSON.Number_q(Lit(js#0)) then (var dec#6 := Lit(JSON_mValues.JSON.num(Lit(js#0))); Lit(JSON_mSpec.__default.Number(dec#6))) else (if JSON_mValues.JSON.Object_q(Lit(js#0)) then (var obj#6 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); Lit(JSON_mSpec.__default.Object($LS($ly), obj#6))) else (var arr#6 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); Lit(JSON_mSpec.__default.Array($LS($ly), arr#6)))))))));

axiom $Is(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.EMPTY(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.DOUBLEQUOTE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.PERIOD(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.PERIOD(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.PERIOD(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.E(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.E(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.E(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.COLON(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.COLON(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.COLON(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.COMMA(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.COMMA(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.COMMA(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.LBRACE(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.LBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.LBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.RBRACE(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.RBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.RBRACE(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.LBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.LBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.LBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.RBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.RBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.RBRACKET(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom $Is(JSON_mGrammar.__default.MINUS(), Tclass.JSON_mUtils_mViews_mCore.View());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.MINUS(), Tclass.JSON_mUtils_mViews_mCore.View(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.MINUS(), Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom (forall b#0: int :: { JSON_mGrammar.__default.Blank_q(b#0) } JSON_mGrammar.__default.Blank_q#canCall(b#0) || (LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Blank_q(b#0) <==> b#0 == LitInt(32) || b#0 == LitInt(9) || b#0 == LitInt(10) || b#0 == LitInt(13)));

axiom (forall b#0: int :: {:weight 3} { JSON_mGrammar.__default.Blank_q(LitInt(b#0)) } JSON_mGrammar.__default.Blank_q#canCall(LitInt(b#0)) || (LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Blank_q(LitInt(b#0)) <==> LitInt(b#0) == LitInt(32) || LitInt(b#0) == LitInt(9) || LitInt(b#0) == LitInt(10) || LitInt(b#0) == LitInt(13)));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#4: int :: { JSON_mGrammar.__default.Blank_q(b#4) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) } LitInt(0) <= b#4 && b#4 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#4))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#4: int :: { JSON_mGrammar.__default.Blank_q(b#4) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) } LitInt(0) <= b#4 && b#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) ==> JSON_mGrammar.__default.Blank_q(b#4))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#5: int :: { JSON_mGrammar.__default.Blank_q(b#5) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#5)) } LitInt(0) <= b#5 && b#5 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#5)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#5))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#5: int :: { JSON_mGrammar.__default.Blank_q(b#5) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#5)) } LitInt(0) <= b#5 && b#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#5)) ==> JSON_mGrammar.__default.Blank_q(b#5))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#4: int :: { $Unbox(Seq#Index(s#0, idx#4)): DatatypeType } LitInt(0) <= idx#4 && idx#4 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#4)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#4: int :: { $Unbox(Seq#Index(s#0, idx#4)): DatatypeType } LitInt(0) <= idx#4 && idx#4 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#4)): DatatypeType)) <==> idx#4 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#5: int :: { $Unbox(Seq#Index(s#0, idx#5)): DatatypeType } LitInt(0) <= idx#5 && idx#5 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#5)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#5: int :: { $Unbox(Seq#Index(s#0, idx#5)): DatatypeType } LitInt(0) <= idx#5 && idx#5 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#5)): DatatypeType)) <==> idx#5 == Seq#Length(Lit(s#0)) - 1))));

axiom $Is(JSON_mGrammar.__default.NULL(), TSeq(Tclass.BoundedInts.uint8()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.NULL(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.NULL(), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom $Is(JSON_mGrammar.__default.TRUE(), TSeq(Tclass.BoundedInts.uint8()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.TRUE(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.TRUE(), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom $Is(JSON_mGrammar.__default.FALSE(), TSeq(Tclass.BoundedInts.uint8()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mGrammar.__default.FALSE(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mGrammar.__default.FALSE(), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Null_q(v#0) } JSON_mGrammar.__default.Null_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (JSON_mGrammar.__default.Null_q(v#0) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mGrammar.__default.NULL())));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Null_q(Lit(v#0)) } JSON_mGrammar.__default.Null_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (JSON_mGrammar.__default.Null_q(Lit(v#0)) <==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), JSON_mGrammar.__default.NULL())));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Bool_q(v#0) } JSON_mGrammar.__default.Bool_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (JSON_mGrammar.__default.Bool_q(v#0) <==> JSON_mUtils_mViews_mCore.View__.Bytes(v#0) == JSON_mGrammar.__default.TRUE() || JSON_mUtils_mViews_mCore.View__.Bytes(v#0) == JSON_mGrammar.__default.FALSE()));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Bool_q(Lit(v#0)) } JSON_mGrammar.__default.Bool_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (JSON_mGrammar.__default.Bool_q(Lit(v#0)) <==> Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0))) == JSON_mGrammar.__default.TRUE() || Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0))) == JSON_mGrammar.__default.FALSE()));

axiom (forall b#0: int :: { JSON_mGrammar.__default.Digit_q(b#0) } JSON_mGrammar.__default.Digit_q#canCall(b#0) || (LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Digit_q(b#0) <==> char#ToInt(Lit(char#FromInt(48))) <= b#0 && b#0 <= char#ToInt(Lit(char#FromInt(57)))));

axiom (forall b#0: int :: {:weight 3} { JSON_mGrammar.__default.Digit_q(LitInt(b#0)) } JSON_mGrammar.__default.Digit_q#canCall(LitInt(b#0)) || (LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> (JSON_mGrammar.__default.Digit_q(LitInt(b#0)) <==> char#ToInt(Lit(char#FromInt(48))) <= LitInt(b#0) && LitInt(b#0) <= char#ToInt(Lit(char#FromInt(57)))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#4: int :: { JSON_mGrammar.__default.Digit_q(b#4) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) } LitInt(0) <= b#4 && b#4 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#4))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#4: int :: { JSON_mGrammar.__default.Digit_q(b#4) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) } LitInt(0) <= b#4 && b#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#4)) ==> JSON_mGrammar.__default.Digit_q(b#4))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#5: int :: { JSON_mGrammar.__default.Digit_q(b#5) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#5)) } LitInt(0) <= b#5 && b#5 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#5)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#5))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#5: int :: { JSON_mGrammar.__default.Digit_q(b#5) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#5)) } LitInt(0) <= b#5 && b#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#5)) ==> JSON_mGrammar.__default.Digit_q(b#5))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Num_q(v#0) } JSON_mGrammar.__default.Num_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mGrammar.__default.Digits_q#canCall(v#0) && (JSON_mGrammar.__default.Num_q(v#0) <==> JSON_mGrammar.__default.Digits_q(v#0) && !JSON_mUtils_mViews_mCore.View__.Empty_q(v#0)));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Num_q(Lit(v#0)) } JSON_mGrammar.__default.Num_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) && (JSON_mGrammar.__default.Num_q(Lit(v#0)) <==> JSON_mGrammar.__default.Digits_q(Lit(v#0)) && !JSON_mUtils_mViews_mCore.View__.Empty_q(Lit(v#0))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Int_q(v#0) } JSON_mGrammar.__default.Int_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(v#0, Lit(char#FromInt(48))) && (!JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48))) ==> JSON_mGrammar.__default.Num_q#canCall(v#0) && (JSON_mGrammar.__default.Num_q(v#0) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(v#0, LitInt(0)))) && (JSON_mGrammar.__default.Int_q(v#0) <==> JSON_mUtils_mViews_mCore.View__.Char_q(v#0, Lit(char#FromInt(48))) || (JSON_mGrammar.__default.Num_q(v#0) && JSON_mUtils_mViews_mCore.View__.At(v#0, LitInt(0)) != char#ToInt(Lit(char#FromInt(48))))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Int_q(Lit(v#0)) } JSON_mGrammar.__default.Int_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(Lit(v#0), Lit(char#FromInt(48))) && (!Lit(JSON_mUtils_mViews_mCore.View__.Char_q(Lit(v#0), Lit(char#FromInt(48)))) ==> JSON_mGrammar.__default.Num_q#canCall(Lit(v#0)) && (Lit(JSON_mGrammar.__default.Num_q(Lit(v#0))) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(v#0), LitInt(0)))) && (JSON_mGrammar.__default.Int_q(Lit(v#0)) <==> JSON_mUtils_mViews_mCore.View__.Char_q(Lit(v#0), Lit(char#FromInt(48))) || (JSON_mGrammar.__default.Num_q(Lit(v#0)) && JSON_mUtils_mViews_mCore.View__.At(Lit(v#0), LitInt(0)) != char#ToInt(Lit(char#FromInt(48))))));

axiom (forall a#28#0#0: DatatypeType, a#28#1#0: Seq, a#28#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#28#0#0, a#28#1#0, a#28#2#0) } DatatypeCtorId(#JSON.Grammar.Bracketed.Bracketed(a#28#0#0, a#28#1#0, a#28#2#0)) == ##JSON.Grammar.Bracketed.Bracketed);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Bracketed.Bracketed_q(d) } JSON_mGrammar.Bracketed.Bracketed_q(d) ==> (exists a#29#0#0: DatatypeType, a#29#1#0: Seq, a#29#2#0: DatatypeType :: d == #JSON.Grammar.Bracketed.Bracketed(a#29#0#0, a#29#1#0, a#29#2#0)));

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty, a#30#0#0: DatatypeType, a#30#1#0: Seq, a#30#2#0: DatatypeType :: { $Is(#JSON.Grammar.Bracketed.Bracketed(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) } $Is(#JSON.Grammar.Bracketed.Bracketed(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R)) <==> $Is(a#30#0#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$L)) && $Is(a#30#1#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S)) && $Is(a#30#2#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$R)));

axiom (forall JSON.Grammar.Bracketed$L: Ty, JSON.Grammar.Bracketed$D: Ty, JSON.Grammar.Bracketed$S: Ty, JSON.Grammar.Bracketed$R: Ty, a#30#0#0: DatatypeType, a#30#1#0: Seq, a#30#2#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Grammar.Bracketed.Bracketed(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Grammar.Bracketed.Bracketed(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.JSON_mGrammar.Bracketed(JSON.Grammar.Bracketed$L, JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S, JSON.Grammar.Bracketed$R), $h) <==> $IsAlloc(a#30#0#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$L), $h) && $IsAlloc(a#30#1#0, Tclass.JSON_mGrammar.SuffixedSequence(JSON.Grammar.Bracketed$D, JSON.Grammar.Bracketed$S), $h) && $IsAlloc(a#30#2#0, Tclass.JSON_mGrammar.Structural(JSON.Grammar.Bracketed$R), $h)));

axiom (forall a#31#0#0: DatatypeType, a#31#1#0: Seq, a#31#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(Lit(a#31#0#0), Lit(a#31#1#0), Lit(a#31#2#0)) } #JSON.Grammar.Bracketed.Bracketed(Lit(a#31#0#0), Lit(a#31#1#0), Lit(a#31#2#0)) == Lit(#JSON.Grammar.Bracketed.Bracketed(a#31#0#0, a#31#1#0, a#31#2#0)));

axiom (forall a#32#0#0: DatatypeType, a#32#1#0: Seq, a#32#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#32#0#0, a#32#1#0, a#32#2#0) } JSON_mGrammar.Bracketed.l(#JSON.Grammar.Bracketed.Bracketed(a#32#0#0, a#32#1#0, a#32#2#0)) == a#32#0#0);

axiom (forall a#33#0#0: DatatypeType, a#33#1#0: Seq, a#33#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#33#0#0, a#33#1#0, a#33#2#0) } DtRank(a#33#0#0) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#33#0#0, a#33#1#0, a#33#2#0)));

axiom (forall a#34#0#0: DatatypeType, a#34#1#0: Seq, a#34#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#34#0#0, a#34#1#0, a#34#2#0) } JSON_mGrammar.Bracketed.data(#JSON.Grammar.Bracketed.Bracketed(a#34#0#0, a#34#1#0, a#34#2#0)) == a#34#1#0);

axiom (forall a#35#0#0: DatatypeType, a#35#1#0: Seq, a#35#2#0: DatatypeType, i: int :: { Seq#Index(a#35#1#0, i), #JSON.Grammar.Bracketed.Bracketed(a#35#0#0, a#35#1#0, a#35#2#0) } 0 <= i && i < Seq#Length(a#35#1#0) ==> DtRank($Unbox(Seq#Index(a#35#1#0, i)): DatatypeType) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#35#0#0, a#35#1#0, a#35#2#0)));

axiom (forall a#36#0#0: DatatypeType, a#36#1#0: Seq, a#36#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#36#0#0, a#36#1#0, a#36#2#0) } Seq#Rank(a#36#1#0) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#36#0#0, a#36#1#0, a#36#2#0)));

axiom (forall a#37#0#0: DatatypeType, a#37#1#0: Seq, a#37#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#37#0#0, a#37#1#0, a#37#2#0) } JSON_mGrammar.Bracketed.r(#JSON.Grammar.Bracketed.Bracketed(a#37#0#0, a#37#1#0, a#37#2#0)) == a#37#2#0);

axiom (forall a#38#0#0: DatatypeType, a#38#1#0: Seq, a#38#2#0: DatatypeType :: { #JSON.Grammar.Bracketed.Bracketed(a#38#0#0, a#38#1#0, a#38#2#0) } DtRank(a#38#2#0) < DtRank(#JSON.Grammar.Bracketed.Bracketed(a#38#0#0, a#38#1#0, a#38#2#0)));

axiom (forall a#39#0#0: DatatypeType, a#39#1#0: DatatypeType, a#39#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#39#0#0, a#39#1#0, a#39#2#0) } DatatypeCtorId(#JSON.Grammar.jstring.JString(a#39#0#0, a#39#1#0, a#39#2#0)) == ##JSON.Grammar.jstring.JString);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jstring.JString_q(d) } JSON_mGrammar.jstring.JString_q(d) ==> (exists a#40#0#0: DatatypeType, a#40#1#0: DatatypeType, a#40#2#0: DatatypeType :: d == #JSON.Grammar.jstring.JString(a#40#0#0, a#40#1#0, a#40#2#0)));

axiom (forall a#41#0#0: DatatypeType, a#41#1#0: DatatypeType, a#41#2#0: DatatypeType :: { $Is(#JSON.Grammar.jstring.JString(a#41#0#0, a#41#1#0, a#41#2#0), Tclass.JSON_mGrammar.jstring()) } $Is(#JSON.Grammar.jstring.JString(a#41#0#0, a#41#1#0, a#41#2#0), Tclass.JSON_mGrammar.jstring()) <==> $Is(a#41#0#0, Tclass.JSON_mGrammar.jquote()) && $Is(a#41#1#0, Tclass.JSON_mGrammar.jstr()) && $Is(a#41#2#0, Tclass.JSON_mGrammar.jquote()));

axiom (forall a#42#0#0: DatatypeType, a#42#1#0: DatatypeType, a#42#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(Lit(a#42#0#0), Lit(a#42#1#0), Lit(a#42#2#0)) } #JSON.Grammar.jstring.JString(Lit(a#42#0#0), Lit(a#42#1#0), Lit(a#42#2#0)) == Lit(#JSON.Grammar.jstring.JString(a#42#0#0, a#42#1#0, a#42#2#0)));

axiom (forall a#43#0#0: DatatypeType, a#43#1#0: DatatypeType, a#43#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#43#0#0, a#43#1#0, a#43#2#0) } JSON_mGrammar.jstring.lq(#JSON.Grammar.jstring.JString(a#43#0#0, a#43#1#0, a#43#2#0)) == a#43#0#0);

axiom (forall a#44#0#0: DatatypeType, a#44#1#0: DatatypeType, a#44#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#44#0#0, a#44#1#0, a#44#2#0) } DtRank(a#44#0#0) < DtRank(#JSON.Grammar.jstring.JString(a#44#0#0, a#44#1#0, a#44#2#0)));

axiom (forall a#45#0#0: DatatypeType, a#45#1#0: DatatypeType, a#45#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#45#0#0, a#45#1#0, a#45#2#0) } JSON_mGrammar.jstring.contents(#JSON.Grammar.jstring.JString(a#45#0#0, a#45#1#0, a#45#2#0)) == a#45#1#0);

axiom (forall a#46#0#0: DatatypeType, a#46#1#0: DatatypeType, a#46#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#46#0#0, a#46#1#0, a#46#2#0) } DtRank(a#46#1#0) < DtRank(#JSON.Grammar.jstring.JString(a#46#0#0, a#46#1#0, a#46#2#0)));

axiom (forall a#47#0#0: DatatypeType, a#47#1#0: DatatypeType, a#47#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#47#0#0, a#47#1#0, a#47#2#0) } JSON_mGrammar.jstring.rq(#JSON.Grammar.jstring.JString(a#47#0#0, a#47#1#0, a#47#2#0)) == a#47#2#0);

axiom (forall a#48#0#0: DatatypeType, a#48#1#0: DatatypeType, a#48#2#0: DatatypeType :: { #JSON.Grammar.jstring.JString(a#48#0#0, a#48#1#0, a#48#2#0) } DtRank(a#48#2#0) < DtRank(#JSON.Grammar.jstring.JString(a#48#0#0, a#48#1#0, a#48#2#0)));

axiom (forall a#49#0#0: DatatypeType, a#49#1#0: DatatypeType, a#49#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#49#0#0, a#49#1#0, a#49#2#0) } DatatypeCtorId(#JSON.Grammar.jKeyValue.KeyValue(a#49#0#0, a#49#1#0, a#49#2#0)) == ##JSON.Grammar.jKeyValue.KeyValue);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jKeyValue.KeyValue_q(d) } JSON_mGrammar.jKeyValue.KeyValue_q(d) ==> (exists a#50#0#0: DatatypeType, a#50#1#0: DatatypeType, a#50#2#0: DatatypeType :: d == #JSON.Grammar.jKeyValue.KeyValue(a#50#0#0, a#50#1#0, a#50#2#0)));

axiom (forall a#51#0#0: DatatypeType, a#51#1#0: DatatypeType, a#51#2#0: DatatypeType :: { $Is(#JSON.Grammar.jKeyValue.KeyValue(a#51#0#0, a#51#1#0, a#51#2#0), Tclass.JSON_mGrammar.jKeyValue()) } $Is(#JSON.Grammar.jKeyValue.KeyValue(a#51#0#0, a#51#1#0, a#51#2#0), Tclass.JSON_mGrammar.jKeyValue()) <==> $Is(a#51#0#0, Tclass.JSON_mGrammar.jstring()) && $Is(a#51#1#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) && $Is(a#51#2#0, Tclass.JSON_mGrammar.Value()));

axiom (forall a#52#0#0: DatatypeType, a#52#1#0: DatatypeType, a#52#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(Lit(a#52#0#0), Lit(a#52#1#0), Lit(a#52#2#0)) } #JSON.Grammar.jKeyValue.KeyValue(Lit(a#52#0#0), Lit(a#52#1#0), Lit(a#52#2#0)) == Lit(#JSON.Grammar.jKeyValue.KeyValue(a#52#0#0, a#52#1#0, a#52#2#0)));

axiom (forall a#53#0#0: DatatypeType, a#53#1#0: DatatypeType, a#53#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#53#0#0, a#53#1#0, a#53#2#0) } JSON_mGrammar.jKeyValue.k(#JSON.Grammar.jKeyValue.KeyValue(a#53#0#0, a#53#1#0, a#53#2#0)) == a#53#0#0);

axiom (forall a#54#0#0: DatatypeType, a#54#1#0: DatatypeType, a#54#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#54#0#0, a#54#1#0, a#54#2#0) } DtRank(a#54#0#0) < DtRank(#JSON.Grammar.jKeyValue.KeyValue(a#54#0#0, a#54#1#0, a#54#2#0)));

axiom (forall a#55#0#0: DatatypeType, a#55#1#0: DatatypeType, a#55#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#55#0#0, a#55#1#0, a#55#2#0) } JSON_mGrammar.jKeyValue.colon(#JSON.Grammar.jKeyValue.KeyValue(a#55#0#0, a#55#1#0, a#55#2#0)) == a#55#1#0);

axiom (forall a#56#0#0: DatatypeType, a#56#1#0: DatatypeType, a#56#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#56#0#0, a#56#1#0, a#56#2#0) } DtRank(a#56#1#0) < DtRank(#JSON.Grammar.jKeyValue.KeyValue(a#56#0#0, a#56#1#0, a#56#2#0)));

axiom (forall a#57#0#0: DatatypeType, a#57#1#0: DatatypeType, a#57#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#57#0#0, a#57#1#0, a#57#2#0) } JSON_mGrammar.jKeyValue.v(#JSON.Grammar.jKeyValue.KeyValue(a#57#0#0, a#57#1#0, a#57#2#0)) == a#57#2#0);

axiom (forall a#58#0#0: DatatypeType, a#58#1#0: DatatypeType, a#58#2#0: DatatypeType :: { #JSON.Grammar.jKeyValue.KeyValue(a#58#0#0, a#58#1#0, a#58#2#0) } DtRank(a#58#2#0) < DtRank(#JSON.Grammar.jKeyValue.KeyValue(a#58#0#0, a#58#1#0, a#58#2#0)));

axiom (forall a#59#0#0: DatatypeType, a#59#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#59#0#0, a#59#1#0) } DatatypeCtorId(#JSON.Grammar.jfrac.JFrac(a#59#0#0, a#59#1#0)) == ##JSON.Grammar.jfrac.JFrac);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jfrac.JFrac_q(d) } JSON_mGrammar.jfrac.JFrac_q(d) ==> (exists a#60#0#0: DatatypeType, a#60#1#0: DatatypeType :: d == #JSON.Grammar.jfrac.JFrac(a#60#0#0, a#60#1#0)));

axiom (forall a#61#0#0: DatatypeType, a#61#1#0: DatatypeType :: { $Is(#JSON.Grammar.jfrac.JFrac(a#61#0#0, a#61#1#0), Tclass.JSON_mGrammar.jfrac()) } $Is(#JSON.Grammar.jfrac.JFrac(a#61#0#0, a#61#1#0), Tclass.JSON_mGrammar.jfrac()) <==> $Is(a#61#0#0, Tclass.JSON_mGrammar.jperiod()) && $Is(a#61#1#0, Tclass.JSON_mGrammar.jnum()));

axiom (forall a#62#0#0: DatatypeType, a#62#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(Lit(a#62#0#0), Lit(a#62#1#0)) } #JSON.Grammar.jfrac.JFrac(Lit(a#62#0#0), Lit(a#62#1#0)) == Lit(#JSON.Grammar.jfrac.JFrac(a#62#0#0, a#62#1#0)));

axiom (forall a#63#0#0: DatatypeType, a#63#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#63#0#0, a#63#1#0) } JSON_mGrammar.jfrac.period(#JSON.Grammar.jfrac.JFrac(a#63#0#0, a#63#1#0)) == a#63#0#0);

axiom (forall a#64#0#0: DatatypeType, a#64#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#64#0#0, a#64#1#0) } DtRank(a#64#0#0) < DtRank(#JSON.Grammar.jfrac.JFrac(a#64#0#0, a#64#1#0)));

axiom (forall a#65#0#0: DatatypeType, a#65#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#65#0#0, a#65#1#0) } JSON_mGrammar.jfrac.num(#JSON.Grammar.jfrac.JFrac(a#65#0#0, a#65#1#0)) == a#65#1#0);

axiom (forall a#66#0#0: DatatypeType, a#66#1#0: DatatypeType :: { #JSON.Grammar.jfrac.JFrac(a#66#0#0, a#66#1#0) } DtRank(a#66#1#0) < DtRank(#JSON.Grammar.jfrac.JFrac(a#66#0#0, a#66#1#0)));

axiom (forall a#67#0#0: DatatypeType, a#67#1#0: DatatypeType, a#67#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#67#0#0, a#67#1#0, a#67#2#0) } DatatypeCtorId(#JSON.Grammar.jexp.JExp(a#67#0#0, a#67#1#0, a#67#2#0)) == ##JSON.Grammar.jexp.JExp);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jexp.JExp_q(d) } JSON_mGrammar.jexp.JExp_q(d) ==> (exists a#68#0#0: DatatypeType, a#68#1#0: DatatypeType, a#68#2#0: DatatypeType :: d == #JSON.Grammar.jexp.JExp(a#68#0#0, a#68#1#0, a#68#2#0)));

axiom (forall a#69#0#0: DatatypeType, a#69#1#0: DatatypeType, a#69#2#0: DatatypeType :: { $Is(#JSON.Grammar.jexp.JExp(a#69#0#0, a#69#1#0, a#69#2#0), Tclass.JSON_mGrammar.jexp()) } $Is(#JSON.Grammar.jexp.JExp(a#69#0#0, a#69#1#0, a#69#2#0), Tclass.JSON_mGrammar.jexp()) <==> $Is(a#69#0#0, Tclass.JSON_mGrammar.je()) && $Is(a#69#1#0, Tclass.JSON_mGrammar.jsign()) && $Is(a#69#2#0, Tclass.JSON_mGrammar.jnum()));

axiom (forall a#70#0#0: DatatypeType, a#70#1#0: DatatypeType, a#70#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(Lit(a#70#0#0), Lit(a#70#1#0), Lit(a#70#2#0)) } #JSON.Grammar.jexp.JExp(Lit(a#70#0#0), Lit(a#70#1#0), Lit(a#70#2#0)) == Lit(#JSON.Grammar.jexp.JExp(a#70#0#0, a#70#1#0, a#70#2#0)));

axiom (forall a#71#0#0: DatatypeType, a#71#1#0: DatatypeType, a#71#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#71#0#0, a#71#1#0, a#71#2#0) } JSON_mGrammar.jexp.e(#JSON.Grammar.jexp.JExp(a#71#0#0, a#71#1#0, a#71#2#0)) == a#71#0#0);

axiom (forall a#72#0#0: DatatypeType, a#72#1#0: DatatypeType, a#72#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#72#0#0, a#72#1#0, a#72#2#0) } DtRank(a#72#0#0) < DtRank(#JSON.Grammar.jexp.JExp(a#72#0#0, a#72#1#0, a#72#2#0)));

axiom (forall a#73#0#0: DatatypeType, a#73#1#0: DatatypeType, a#73#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#73#0#0, a#73#1#0, a#73#2#0) } JSON_mGrammar.jexp.sign(#JSON.Grammar.jexp.JExp(a#73#0#0, a#73#1#0, a#73#2#0)) == a#73#1#0);

axiom (forall a#74#0#0: DatatypeType, a#74#1#0: DatatypeType, a#74#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#74#0#0, a#74#1#0, a#74#2#0) } DtRank(a#74#1#0) < DtRank(#JSON.Grammar.jexp.JExp(a#74#0#0, a#74#1#0, a#74#2#0)));

axiom (forall a#75#0#0: DatatypeType, a#75#1#0: DatatypeType, a#75#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#75#0#0, a#75#1#0, a#75#2#0) } JSON_mGrammar.jexp.num(#JSON.Grammar.jexp.JExp(a#75#0#0, a#75#1#0, a#75#2#0)) == a#75#2#0);

axiom (forall a#76#0#0: DatatypeType, a#76#1#0: DatatypeType, a#76#2#0: DatatypeType :: { #JSON.Grammar.jexp.JExp(a#76#0#0, a#76#1#0, a#76#2#0) } DtRank(a#76#2#0) < DtRank(#JSON.Grammar.jexp.JExp(a#76#0#0, a#76#1#0, a#76#2#0)));

axiom (forall a#77#0#0: DatatypeType, a#77#1#0: DatatypeType, a#77#2#0: DatatypeType, a#77#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#77#0#0, a#77#1#0, a#77#2#0, a#77#3#0) } DatatypeCtorId(#JSON.Grammar.jnumber.JNumber(a#77#0#0, a#77#1#0, a#77#2#0, a#77#3#0)) == ##JSON.Grammar.jnumber.JNumber);

axiom (forall d: DatatypeType :: { JSON_mGrammar.jnumber.JNumber_q(d) } JSON_mGrammar.jnumber.JNumber_q(d) ==> (exists a#78#0#0: DatatypeType, a#78#1#0: DatatypeType, a#78#2#0: DatatypeType, a#78#3#0: DatatypeType :: d == #JSON.Grammar.jnumber.JNumber(a#78#0#0, a#78#1#0, a#78#2#0, a#78#3#0)));

axiom (forall a#79#0#0: DatatypeType, a#79#1#0: DatatypeType, a#79#2#0: DatatypeType, a#79#3#0: DatatypeType :: { $Is(#JSON.Grammar.jnumber.JNumber(a#79#0#0, a#79#1#0, a#79#2#0, a#79#3#0), Tclass.JSON_mGrammar.jnumber()) } $Is(#JSON.Grammar.jnumber.JNumber(a#79#0#0, a#79#1#0, a#79#2#0, a#79#3#0), Tclass.JSON_mGrammar.jnumber()) <==> $Is(a#79#0#0, Tclass.JSON_mGrammar.jminus()) && $Is(a#79#1#0, Tclass.JSON_mGrammar.jnum()) && $Is(a#79#2#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $Is(a#79#3#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())));

axiom (forall a#80#0#0: DatatypeType, a#80#1#0: DatatypeType, a#80#2#0: DatatypeType, a#80#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(Lit(a#80#0#0), Lit(a#80#1#0), Lit(a#80#2#0), Lit(a#80#3#0)) } #JSON.Grammar.jnumber.JNumber(Lit(a#80#0#0), Lit(a#80#1#0), Lit(a#80#2#0), Lit(a#80#3#0)) == Lit(#JSON.Grammar.jnumber.JNumber(a#80#0#0, a#80#1#0, a#80#2#0, a#80#3#0)));

axiom (forall a#81#0#0: DatatypeType, a#81#1#0: DatatypeType, a#81#2#0: DatatypeType, a#81#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#81#0#0, a#81#1#0, a#81#2#0, a#81#3#0) } JSON_mGrammar.jnumber.minus(#JSON.Grammar.jnumber.JNumber(a#81#0#0, a#81#1#0, a#81#2#0, a#81#3#0)) == a#81#0#0);

axiom (forall a#82#0#0: DatatypeType, a#82#1#0: DatatypeType, a#82#2#0: DatatypeType, a#82#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#82#0#0, a#82#1#0, a#82#2#0, a#82#3#0) } DtRank(a#82#0#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#82#0#0, a#82#1#0, a#82#2#0, a#82#3#0)));

axiom (forall a#83#0#0: DatatypeType, a#83#1#0: DatatypeType, a#83#2#0: DatatypeType, a#83#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#83#0#0, a#83#1#0, a#83#2#0, a#83#3#0) } JSON_mGrammar.jnumber.num(#JSON.Grammar.jnumber.JNumber(a#83#0#0, a#83#1#0, a#83#2#0, a#83#3#0)) == a#83#1#0);

axiom (forall a#84#0#0: DatatypeType, a#84#1#0: DatatypeType, a#84#2#0: DatatypeType, a#84#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#84#0#0, a#84#1#0, a#84#2#0, a#84#3#0) } DtRank(a#84#1#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#84#0#0, a#84#1#0, a#84#2#0, a#84#3#0)));

axiom (forall a#85#0#0: DatatypeType, a#85#1#0: DatatypeType, a#85#2#0: DatatypeType, a#85#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0) } JSON_mGrammar.jnumber.frac(#JSON.Grammar.jnumber.JNumber(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0)) == a#85#2#0);

axiom (forall a#86#0#0: DatatypeType, a#86#1#0: DatatypeType, a#86#2#0: DatatypeType, a#86#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#86#0#0, a#86#1#0, a#86#2#0, a#86#3#0) } DtRank(a#86#2#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#86#0#0, a#86#1#0, a#86#2#0, a#86#3#0)));

axiom (forall a#87#0#0: DatatypeType, a#87#1#0: DatatypeType, a#87#2#0: DatatypeType, a#87#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0) } JSON_mGrammar.jnumber.exp(#JSON.Grammar.jnumber.JNumber(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0)) == a#87#3#0);

axiom (forall a#88#0#0: DatatypeType, a#88#1#0: DatatypeType, a#88#2#0: DatatypeType, a#88#3#0: DatatypeType :: { #JSON.Grammar.jnumber.JNumber(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0) } DtRank(a#88#3#0) < DtRank(#JSON.Grammar.jnumber.JNumber(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0)));

axiom (forall a#89#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(a#89#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Null(a#89#0#0)) == ##JSON.Grammar.Value.Null);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Null_q(d) } JSON_mGrammar.Value.Null_q(d) ==> (exists a#90#0#0: DatatypeType :: d == #JSON.Grammar.Value.Null(a#90#0#0)));

axiom (forall a#91#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Null(a#91#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Null(a#91#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#91#0#0, Tclass.JSON_mGrammar.jnull()));

axiom (forall a#92#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(Lit(a#92#0#0)) } #JSON.Grammar.Value.Null(Lit(a#92#0#0)) == Lit(#JSON.Grammar.Value.Null(a#92#0#0)));

axiom (forall a#93#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(a#93#0#0) } JSON_mGrammar.Value.n(#JSON.Grammar.Value.Null(a#93#0#0)) == a#93#0#0);

axiom (forall a#94#0#0: DatatypeType :: { #JSON.Grammar.Value.Null(a#94#0#0) } DtRank(a#94#0#0) < DtRank(#JSON.Grammar.Value.Null(a#94#0#0)));

axiom (forall a#95#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(a#95#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Bool(a#95#0#0)) == ##JSON.Grammar.Value.Bool);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Bool_q(d) } JSON_mGrammar.Value.Bool_q(d) ==> (exists a#96#0#0: DatatypeType :: d == #JSON.Grammar.Value.Bool(a#96#0#0)));

axiom (forall a#97#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Bool(a#97#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Bool(a#97#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#97#0#0, Tclass.JSON_mGrammar.jbool()));

axiom (forall a#98#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(Lit(a#98#0#0)) } #JSON.Grammar.Value.Bool(Lit(a#98#0#0)) == Lit(#JSON.Grammar.Value.Bool(a#98#0#0)));

axiom (forall a#99#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(a#99#0#0) } JSON_mGrammar.Value.b(#JSON.Grammar.Value.Bool(a#99#0#0)) == a#99#0#0);

axiom (forall a#100#0#0: DatatypeType :: { #JSON.Grammar.Value.Bool(a#100#0#0) } DtRank(a#100#0#0) < DtRank(#JSON.Grammar.Value.Bool(a#100#0#0)));

axiom (forall a#101#0#0: DatatypeType :: { #JSON.Grammar.Value.String(a#101#0#0) } DatatypeCtorId(#JSON.Grammar.Value.String(a#101#0#0)) == ##JSON.Grammar.Value.String);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.String_q(d) } JSON_mGrammar.Value.String_q(d) ==> (exists a#102#0#0: DatatypeType :: d == #JSON.Grammar.Value.String(a#102#0#0)));

axiom (forall a#103#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.String(a#103#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.String(a#103#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#103#0#0, Tclass.JSON_mGrammar.jstring()));

axiom (forall a#104#0#0: DatatypeType :: { #JSON.Grammar.Value.String(Lit(a#104#0#0)) } #JSON.Grammar.Value.String(Lit(a#104#0#0)) == Lit(#JSON.Grammar.Value.String(a#104#0#0)));

axiom (forall a#105#0#0: DatatypeType :: { #JSON.Grammar.Value.String(a#105#0#0) } JSON_mGrammar.Value.str(#JSON.Grammar.Value.String(a#105#0#0)) == a#105#0#0);

axiom (forall a#106#0#0: DatatypeType :: { #JSON.Grammar.Value.String(a#106#0#0) } DtRank(a#106#0#0) < DtRank(#JSON.Grammar.Value.String(a#106#0#0)));

axiom (forall a#107#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(a#107#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Number(a#107#0#0)) == ##JSON.Grammar.Value.Number);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Number_q(d) } JSON_mGrammar.Value.Number_q(d) ==> (exists a#108#0#0: DatatypeType :: d == #JSON.Grammar.Value.Number(a#108#0#0)));

axiom (forall a#109#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Number(a#109#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Number(a#109#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#109#0#0, Tclass.JSON_mGrammar.jnumber()));

axiom (forall a#110#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(Lit(a#110#0#0)) } #JSON.Grammar.Value.Number(Lit(a#110#0#0)) == Lit(#JSON.Grammar.Value.Number(a#110#0#0)));

axiom (forall a#111#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(a#111#0#0) } JSON_mGrammar.Value.num(#JSON.Grammar.Value.Number(a#111#0#0)) == a#111#0#0);

axiom (forall a#112#0#0: DatatypeType :: { #JSON.Grammar.Value.Number(a#112#0#0) } DtRank(a#112#0#0) < DtRank(#JSON.Grammar.Value.Number(a#112#0#0)));

axiom (forall a#113#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(a#113#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Object(a#113#0#0)) == ##JSON.Grammar.Value.Object);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Object_q(d) } JSON_mGrammar.Value.Object_q(d) ==> (exists a#114#0#0: DatatypeType :: d == #JSON.Grammar.Value.Object(a#114#0#0)));

axiom (forall a#115#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Object(a#115#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Object(a#115#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#115#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())));

axiom (forall a#116#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(Lit(a#116#0#0)) } #JSON.Grammar.Value.Object(Lit(a#116#0#0)) == Lit(#JSON.Grammar.Value.Object(a#116#0#0)));

axiom (forall a#117#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(a#117#0#0) } JSON_mGrammar.Value.obj(#JSON.Grammar.Value.Object(a#117#0#0)) == a#117#0#0);

axiom (forall a#118#0#0: DatatypeType :: { #JSON.Grammar.Value.Object(a#118#0#0) } DtRank(a#118#0#0) < DtRank(#JSON.Grammar.Value.Object(a#118#0#0)));

axiom (forall a#119#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(a#119#0#0) } DatatypeCtorId(#JSON.Grammar.Value.Array(a#119#0#0)) == ##JSON.Grammar.Value.Array);

axiom (forall d: DatatypeType :: { JSON_mGrammar.Value.Array_q(d) } JSON_mGrammar.Value.Array_q(d) ==> (exists a#120#0#0: DatatypeType :: d == #JSON.Grammar.Value.Array(a#120#0#0)));

axiom (forall a#121#0#0: DatatypeType :: { $Is(#JSON.Grammar.Value.Array(a#121#0#0), Tclass.JSON_mGrammar.Value()) } $Is(#JSON.Grammar.Value.Array(a#121#0#0), Tclass.JSON_mGrammar.Value()) <==> $Is(a#121#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())));

axiom (forall a#122#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(Lit(a#122#0#0)) } #JSON.Grammar.Value.Array(Lit(a#122#0#0)) == Lit(#JSON.Grammar.Value.Array(a#122#0#0)));

axiom (forall a#123#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(a#123#0#0) } JSON_mGrammar.Value.arr(#JSON.Grammar.Value.Array(a#123#0#0)) == a#123#0#0);

axiom (forall a#124#0#0: DatatypeType :: { #JSON.Grammar.Value.Array(a#124#0#0) } DtRank(a#124#0#0) < DtRank(#JSON.Grammar.Value.Array(a#124#0#0)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#3: int :: { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) } Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < base#0) && $Is(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#3 := JSON_mSerializer_mByteStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#4 := Seq#Append(digits'#3, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#4))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#4 := JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#5 := Seq#Append(digits'#4, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#5))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#5 := Lit(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#6 := Seq#Append(digits'#5, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#6))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#3: int :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && Seq#Length(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#8: int :: { Seq#Contains(digits#0, $Box(d#8)) } Seq#Contains(digits#0, $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#3: int :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> (var base#2 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#2) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#2 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#3 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#3) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#3 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#5: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#5))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#5)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#5))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#6: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#6))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#6)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#6))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#7: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#7))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#7)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box(c#7))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> JSON_mSerializer_mByteStrConversion.__default.NumberStr(JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Seq#Contains(chars#0, $l#7#c#0))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint8())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mSerializer_mByteStrConversion.__default.OfNat__any(0 - n#0, chars#0))));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#5: int :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#5: int :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#6: int :: { Map#Domain(digits#0)[$Box(c#6)] } { Seq#Contains(str#0, $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#6)) ==> Map#Domain(digits#0)[$Box(c#6)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Map#Domain(digits#0)[$l#10#c#0])), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(digits#0)[$l#11#c#0])), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint8())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

const unique tytagFamily$bytes32: TyTagFamily;

const unique tytagFamily$string32: TyTagFamily;

const unique class.JSON_mDeserializer_mUint16StrConversion.__default: ClassName;

function JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly: LayerType, n#0: int, base#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#0: int :: { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) } Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < base#0) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#0 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#0 := Seq#Append(digits'#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#1 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#1 := Seq#Append(digits'#1, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#2 := Lit(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#2 := Seq#Append(digits'#2, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#2))));
}

function JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0: int, base#0: int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) == JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits(AsFuelBottom($ly), n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0) == JSON_mDeserializer_mUint16StrConversion.__default.Digits($LZ, n#0, base#0));

function JSON_mDeserializer_mUint16StrConversion.__default.Digits#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits#requires($ly, n#0, base#0) } LitInt(0) <= n#0 ==> (JSON_mDeserializer_mUint16StrConversion.__default.Digits#requires($ly, n#0, base#0) <==> base#0 > 1));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.Digits(n#0: int where LitInt(0) <= n#0, base#0: int) returns (digits#3: Seq where $Is(digits#3, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Uint16StrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.Digits(n#0: int, base#0: int) returns (digits#3: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var d#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var digits'#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#1: int;
  var digits#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##base#2: int;
  var ##pow#1: int;
  var base##1_0_0: int;
  var pow##1_0_0: int;
  var d##1_0_0_0: int;
  var base##1_1_0: int;
  var pow##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Uint16StrConversion.Digits", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume n#0 == LitInt(0);
    assume Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon30_Else:
    assume n#0 == LitInt(0) ==> Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume n#0 > 0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon31_Else:
    assume n#0 > 0 ==> Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon8:
    havoc d#2;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume Seq#Contains(digits#3, $Box(d#2));
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= d#2;
    goto anon11;

  anon33_Else:
    assume {:partition} d#2 < LitInt(0);
    goto anon11;

  anon11:
    assume LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon32_Else:
    assume Seq#Contains(digits#3, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon13:
    assume (forall d#1: int :: { Seq#Contains(digits#3, $Box(d#1)) } Seq#Contains(digits#3, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);
    assume false;
    return;

  anon29_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} n#0 == LitInt(0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](35,49)"} true;
    assume true;
    assume false;
    goto anon17;

  anon35_Else:
    goto anon17;

  anon17:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, LitInt(0)) == LitInt(1);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](35,52)"} true;
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon34_Else:
    assume {:partition} n#0 != LitInt(0);
    free call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](38,29)"} true;
    free call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](38,54)"} true;
    havoc digits'#Z#0;
    assume $Is(digits'#Z#0, TSeq(TInt)) && $IsAlloc(digits'#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume $Is(Div(n#0, base#0), Tclass._System.nat());
    ##n#0 := Div(n#0, base#0);
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume 0 <= n#0 || ##n#0 == n#0;
    assume ##n#0 < n#0;
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume let#0#0#0 == JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), Div(n#0, base#0), base#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume $Is(let#0#0#0, TSeq(TInt));
    assume digits'#Z#0 == let#0#0#0;
    havoc digits#Z#0;
    assume $Is(digits#Z#0, TSeq(TInt)) && $IsAlloc(digits#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume let#1#0#0 == Seq#Append(digits'#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))));
    assume true;
    assume $Is(let#1#0#0, TSeq(TInt));
    assume digits#Z#0 == let#1#0#0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#2 := base#0;
    assume $IsAlloc(##base#2, Tclass._System.nat(), $Heap);
    ##pow#1 := n#0;
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#2 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume true;
    assume Seq#Length(digits#Z#0) == Seq#Length(digits'#Z#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](42,42)"} true;
    assume true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} n#0 < base#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_0_0 := base#0;
    assume true;
    pow##1_0_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    call CallPost$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](44,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume true;
    d##1_0_0_0 := base#0;
    call CallPre$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    call CallPost$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](45,57)"} true;
    assume Div(n#0, base#0) == LitInt(0);
    assume false;
    goto anon22;

  anon38_Else:
    goto anon22;

  anon22:
    assume Div(n#0, base#0) == LitInt(0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](45,59)"} true;
    goto anon26;

  anon37_Else:
    assume {:partition} base#0 <= n#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_1_0 := base#0;
    assume true;
    pow##1_1_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](47,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    call CallPre$$DivMod.__default.LemmaDivNonZeroAuto();
    call CallPost$$DivMod.__default.LemmaDivNonZeroAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](48,58)"} true;
    assume Div(n#0, base#0) > 0;
    assume false;
    goto anon25;

  anon39_Else:
    goto anon25;

  anon25:
    assume Div(n#0, base#0) > 0;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](48,60)"} true;
    goto anon26;

  anon26:
    assume true;
    assume false;
    goto anon27;

  anon36_Else:
    goto anon27;

  anon27:
    assume Seq#Length(digits#Z#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](50,8)"} true;
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#Z#0;
    assume true;
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon28:
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#3;
    return;
}



function JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly: LayerType, digits#0: Seq, chars#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#0: int :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#2: int :: { Seq#Contains(digits#0, $Box(d#2)) } Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));
}

function JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0: Seq, chars#0: Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits(AsFuelBottom($ly), digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0) == JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LZ, digits#0, chars#0));

function JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.OfDigits (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.OfDigits(digits#0: Seq where $Is(digits#0, TSeq(TInt)), chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint16()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#0: int :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(chars#0) > 1) ==> (var base#0 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) == (var base#0 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0))));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#1 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), base#1) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#1 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0)))));
}

function JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0: int, chars#0: Seq) : bool;

function JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#requires(int, Seq) : bool;

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#requires(n#0, chars#0) } LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#requires(n#0, chars#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0: int where LitInt(0) <= n#0, chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint16()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Uint16StrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var c#2: int;
  var base#Z#0: int;
  var let#0#0#0: int;
  var ##n#0: int;
  var ##base#1: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Uint16StrConversion.OfNat_any", " | ", n#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](66,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint16()));
    assume $Is(Seq#Length(chars#0), Tclass._System.nat());
    ##base#0 := Seq#Length(chars#0);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(Seq#Length(chars#0), n#0);
    assume Seq#Length(str#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1;
    havoc c#2;
    assume LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(str#0, $Box(c#2));
    assume Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon11_Else:
    assume Seq#Contains(str#0, $Box(c#2)) ==> Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon5:
    assume (forall c#1: int :: { Seq#Contains(chars#0, $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(chars#0, $Box(c#1)));
    assume false;
    return;

  anon10_Else:
    havoc base#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(chars#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume base#Z#0 == let#0#0#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} n#0 == LitInt(0);
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](72,32)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(chars#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) == Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0)));
    assume true;
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint16()));
    goto anon9;

  anon12_Else:
    assume {:partition} n#0 != LitInt(0);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#Z#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#Z#0);
    ##digits#0 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#Z#0);
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume true;
    assume (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) == JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#Z#0) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint16()));
    goto anon9;

  anon9:
    assume JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) == str#0;
    return;
}



function JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0: Seq, minus#0: int, is_digit#0: HandleType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#0: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#0))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#0))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#1: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#1))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#1)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#1))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#2: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#2))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#2)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, Lit(is_digit#0), $Box(c#2))): bool)));
}

function JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(str#0: Seq, minus#0: int, is_digit#0: HandleType) : bool;

function JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#requires(Seq, int, HandleType) : bool;

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool)) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.NumberStr (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16(), is_digit#0: HandleType where $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0: int, chars#0: Seq, minus#0: int) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(chars#0) > 1) ==> JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(Seq#Contains(chars#0, $l#0#c#0))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint16())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint16())));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(0 - n#0, chars#0))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
}

function JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(n#0: int, chars#0: Seq, minus#0: int) : bool;

function JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#requires(int, Seq, int) : bool;

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) } $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() ==> (JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.OfInt_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0: int, chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16()) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly: LayerType, str#0: Seq, base#0: int, digits#0: Map) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#2: int :: { Map#Domain(digits#0)[$Box(c#2)] } { Seq#Contains(str#0, $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#2)) ==> Map#Domain(digits#0)[$Box(c#2)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));
}

function JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0: Seq, base#0: int, digits#0: Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any(AsFuelBottom($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) == JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LZ, str#0, base#0, digits#0));

function JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires(LayerType, Seq, int, Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()))) returns (n#0: int where LitInt(0) <= n#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any(str#0: Seq, base#0: int, digits#0: Map) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: int;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Uint16StrConversion.ToNat_any", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](90,42): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 0;
    havoc c#3;
    assume LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, $Box(c#3));
    assume Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon10_Else:
    assume Seq#Contains(str#0, $Box(c#3)) ==> Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon4:
    assume (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)]);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume LitInt(0) <= JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == LitInt(0);
    assume true;
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon12_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](96,32)"} true;
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume true;
    assume ##base#0 > 0;
    assume true;
    assume (forall c#4: int :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume 0 <= base#0 || Seq#Rank(##str#0) < Seq#Rank(str#0) || ##base#0 == base#0;
    assume Seq#Rank(##str#0) < Seq#Rank(str#0) || (Seq#Rank(##str#0) == Seq#Rank(str#0) && (##base#0 < base#0 || (##base#0 == base#0 && Set#Subset(Map#Domain(##digits#0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(##digits#0)))));
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume $Is(Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int, Tclass._System.nat());
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int;
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume $Is(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon9:
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == n#0;
    return;
}



procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_bound (well-formedness)"} CheckWellFormed$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_bound (call precondtion)"} CallPre$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap));
  requires {:id "id23118"} base#0 > 0;
  requires {:id "id23119"} (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id23120"} (forall c#3: int :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);



procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap));
  modifies $Heap;
  free ensures JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id23121"} JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_bound (correctness)"} Impl$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id23122"} base#0 > 0;
  requires {:id "id23123"} (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id23124"} (forall c#3: int :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);
  modifies $Heap;
  free ensures JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id23125"} $_reverifyPost ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_bound (correctness)"} Impl$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##b#1_0_0_1: int;
  var ##e#1_0_0_1: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var ##str#1_0_2_0: Seq;
  var ##base#1_0_2_0: int;
  var ##digits#1_0_2_0: Map;
  var str##1_0_2_0: Seq;
  var base##1_0_2_0: int;
  var digits##1_0_2_0: Map;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##str#1_0_3_0: Seq;
  var ##base#1_0_3_0: int;
  var ##digits#1_0_3_0: Map;
  var ##str#1_0_3_1: Seq;
  var ##base#1_0_3_1: int;
  var ##digits#1_0_3_1: Map;
  var ##str#1_0_4_0: Seq;
  var ##base#1_0_4_0: int;
  var ##digits#1_0_4_0: Map;
  var ##str#1_0_4_1: Seq;
  var ##base#1_0_4_1: int;
  var ##digits#1_0_4_1: Map;
  var ##str#1_0_0: Seq;
  var ##base#1_0_0: int;
  var ##digits#1_0_0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Uint16StrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](105,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](107,19)"} true;
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##str#1_0_0 := str#0;
    assume $IsAlloc(##str#1_0_0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_0 := digits#0;
    assume $IsAlloc(##digits#1_0_0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 0;
    assume {:subsumption 0} (forall c#1_0_0: int :: { Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)] } { Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) } LitInt(0) <= c#1_0_0 && c#1_0_0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) ==> Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume false;
    goto anon9;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##str#1_0_4_0 := str#0;
    assume $IsAlloc(##str#1_0_4_0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#1_0_4_0 := base#0;
    assume $IsAlloc(##base#1_0_4_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_0 := digits#0;
    assume $IsAlloc(##digits#1_0_4_0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_0 > 0;
    assume {:subsumption 0} (forall c#1_0_4_0: int :: { Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)] } { Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) } LitInt(0) <= c#1_0_4_0 && c#1_0_4_0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) ==> Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_4_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_4_1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#1_0_4_1 := base#0;
    assume $IsAlloc(##base#1_0_4_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_1 := digits#0;
    assume $IsAlloc(##digits#1_0_4_1, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_1 > 0;
    assume {:subsumption 0} (forall c#1_0_4_1: int :: { Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)] } { Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) } LitInt(0) <= c#1_0_4_1 && c#1_0_4_1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) ==> Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#1_0_3_0 := base#0;
    assume $IsAlloc(##base#1_0_3_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_0 := digits#0;
    assume $IsAlloc(##digits#1_0_3_0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_0 > 0;
    assume {:subsumption 0} (forall c#1_0_3_0: int :: { Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)] } { Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) } LitInt(0) <= c#1_0_3_0 && c#1_0_3_0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) ==> Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#1_0_3_1 := base#0;
    assume $IsAlloc(##base#1_0_3_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_1 := digits#0;
    assume $IsAlloc(##digits#1_0_3_1, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_1 > 0;
    assume {:subsumption 0} (forall c#1_0_3_1: int :: { Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)] } { Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) } LitInt(0) <= c#1_0_3_1 && c#1_0_3_1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) ==> Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_2_0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    ##base#1_0_2_0 := base#0;
    assume $IsAlloc(##base#1_0_2_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_2_0 := digits#0;
    assume $IsAlloc(##digits#1_0_2_0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_2_0 > 0;
    assume {:subsumption 0} (forall c#1_0_2_0: int :: { Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)] } { Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) } LitInt(0) <= c#1_0_2_0 && c#1_0_2_0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) ==> Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    assume true;
    str##1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume true;
    base##1_0_2_0 := base#0;
    assume true;
    digits##1_0_2_0 := digits#0;
    assume 0 <= base#0 || Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || base##1_0_2_0 == base#0;
    assume Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0_2_0) == Seq#Rank(str#0) && (base##1_0_2_0 < base#0 || (base##1_0_2_0 == base#0 && Set#Subset(Map#Domain(digits##1_0_2_0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(digits##1_0_2_0)))));
    call CallPre$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    call CallPost$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](113,55)"} true;
    free call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](114,36)"} true;
    ##b#1_0_2_0 := base#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_2_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##b#1_0_1_0 := base#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](116,40)"} true;
    ##b#1_0_1_1 := base#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_1 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    ##b#1_0_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_0_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](118,23)"} true;
    free call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[Uint16StrConversion](118,53)"} true;
    ##b#1_0_0_1 := base#0;
    assume $IsAlloc(##b#1_0_0_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#1_0_0_1 := Seq#Length(str#0);
    assume $IsAlloc(##e#1_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume true;
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) - 1;
    return;
}



function JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0: Seq, minus#0: int, base#0: int, digits#0: Map) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint16())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Map#Domain(digits#0)[$l#2#c#0])), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.BoundedInts.uint16())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(Map#Domain(digits#0)[$l#3#c#0])), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint16())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
}

function JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(str#0: Seq, minus#0: int, base#0: int, digits#0: Map) : bool;

function JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(Seq, int, int, Map) : bool;

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint16())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.Deserializer.Uint16StrConversion.ToInt_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16(), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()))) returns (s#0: int);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#196 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#196))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#198 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#198)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#294 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#294))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#296 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#296)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#298 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#298)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#294 := Wrappers.Option.value(this); v#294)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#296 := Lit(Wrappers.Option.value(Lit(this))); v#296)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#298 := Lit(Wrappers.Option.value(Lit(this))); v#298)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#196 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#196)) else (var e#196 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#198 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#198))) else (var e#198 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#294 := Wrappers.Result.value(this); s#294) else (var e#294 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#296 := Lit(Wrappers.Result.value(Lit(this))); s#296) else (var e#296 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#298 := Lit(Wrappers.Result.value(Lit(this))); s#298) else (var e#298 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#294 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#294)) else (var e#294 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#294)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#296 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#296))) else (var e#296 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#296)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#298 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#298))) else (var e#298 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#298)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#90: int, y#90: int :: { Mul(x#90, y#90) } Mul(x#90, y#90) == Mul(y#90, x#90)) && (forall x#91: int, y#91: int, z#60: int :: { Mul(x#91 + y#91, z#60) } Mul(x#91 + y#91, z#60) == Mul(x#91, z#60) + Mul(y#91, z#60)) && (forall x#92: int, y#92: int, z#61: int :: { Mul(x#92 - y#92, z#61) } Mul(x#92 - y#92, z#61) == Mul(x#92, z#61) - Mul(y#92, z#61));

axiom MulInternals.__default.MulAuto() <==> (forall x#93: int, y#93: int :: { Mul(x#93, y#93) } Mul(x#93, y#93) == Mul(y#93, x#93)) && (forall x#94: int, y#94: int, z#62: int :: { Mul(x#94 + y#94, z#62) } Mul(x#94 + y#94, z#62) == Mul(x#94, z#62) + Mul(y#94, z#62)) && (forall x#95: int, y#95: int, z#63: int :: { Mul(x#95 - y#95, z#63) } Mul(x#95 - y#95, z#63) == Mul(x#95, z#63) - Mul(y#95, z#63));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#104: int :: { Mod(Mod(x#104, n#0), n#0) } Mod(Mod(x#104, n#0), n#0) == Mod(x#104, n#0)) && (forall x#105: int :: { Mod(x#105, n#0) } LitInt(0) <= x#105 && x#105 < n#0 <==> Mod(x#105, n#0) == x#105) && (forall x#106: int, y#52: int :: { Mod(x#106 + y#52, n#0) } (var z#50 := Mod(x#106, n#0) + Mod(y#52, n#0); (LitInt(0) <= z#50 && z#50 < n#0 && Mod(x#106 + y#52, n#0) == z#50) || (n#0 <= z#50 && z#50 < n#0 + n#0 && Mod(x#106 + y#52, n#0) == z#50 - n#0))) && (forall x#107: int, y#53: int :: { Mod(x#107 - y#53, n#0) } (var z#51 := Mod(x#107, n#0) - Mod(y#53, n#0); (LitInt(0) <= z#51 && z#51 < n#0 && Mod(x#107 - y#53, n#0) == z#51) || (0 - n#0 <= z#51 && z#51 < 0 && Mod(x#107 - y#53, n#0) == z#51 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#108: int :: { Mod(Mod(x#108, n#0), n#0) } Mod(Mod(x#108, LitInt(n#0)), LitInt(n#0)) == Mod(x#108, LitInt(n#0))) && (forall x#109: int :: { Mod(x#109, n#0) } LitInt(0) <= x#109 && x#109 < n#0 <==> Mod(x#109, LitInt(n#0)) == x#109) && (forall x#110: int, y#54: int :: { Mod(x#110 + y#54, n#0) } (var z#52 := Mod(x#110, LitInt(n#0)) + Mod(y#54, LitInt(n#0)); (LitInt(0) <= z#52 && z#52 < n#0 && Mod(x#110 + y#54, LitInt(n#0)) == z#52) || (LitInt(n#0) <= z#52 && z#52 < n#0 + n#0 && Mod(x#110 + y#54, LitInt(n#0)) == z#52 - n#0))) && (forall x#111: int, y#55: int :: { Mod(x#111 - y#55, n#0) } (var z#53 := Mod(x#111, LitInt(n#0)) - Mod(y#55, LitInt(n#0)); (LitInt(0) <= z#53 && z#53 < n#0 && Mod(x#111 - y#55, LitInt(n#0)) == z#53) || (LitInt(0 - n#0) <= z#53 && z#53 < 0 && Mod(x#111 - y#55, LitInt(n#0)) == z#53 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#72: int :: { Div(x#72, n#0) } LitInt(0) <= x#72 && x#72 < n#0 <==> Div(x#72, n#0) == LitInt(0)) && (forall x#73: int, y#48: int :: { Div(x#73 + y#48, n#0) } (var z#46 := Mod(x#73, n#0) + Mod(y#48, n#0); (LitInt(0) <= z#46 && z#46 < n#0 && Div(x#73 + y#48, n#0) == Div(x#73, n#0) + Div(y#48, n#0)) || (n#0 <= z#46 && z#46 < n#0 + n#0 && Div(x#73 + y#48, n#0) == Div(x#73, n#0) + Div(y#48, n#0) + 1))) && (forall x#74: int, y#49: int :: { Div(x#74 - y#49, n#0) } (var z#47 := Mod(x#74, n#0) - Mod(y#49, n#0); (LitInt(0) <= z#47 && z#47 < n#0 && Div(x#74 - y#49, n#0) == Div(x#74, n#0) - Div(y#49, n#0)) || (0 - n#0 <= z#47 && z#47 < 0 && Div(x#74 - y#49, n#0) == Div(x#74, n#0) - Div(y#49, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#75: int :: { Div(x#75, n#0) } LitInt(0) <= x#75 && x#75 < n#0 <==> Div(x#75, LitInt(n#0)) == LitInt(0)) && (forall x#76: int, y#50: int :: { Div(x#76 + y#50, n#0) } (var z#48 := Mod(x#76, LitInt(n#0)) + Mod(y#50, LitInt(n#0)); (LitInt(0) <= z#48 && z#48 < n#0 && Div(x#76 + y#50, LitInt(n#0)) == Div(x#76, LitInt(n#0)) + Div(y#50, LitInt(n#0))) || (LitInt(n#0) <= z#48 && z#48 < n#0 + n#0 && Div(x#76 + y#50, LitInt(n#0)) == Div(x#76, LitInt(n#0)) + Div(y#50, LitInt(n#0)) + 1))) && (forall x#77: int, y#51: int :: { Div(x#77 - y#51, n#0) } (var z#49 := Mod(x#77, LitInt(n#0)) - Mod(y#51, LitInt(n#0)); (LitInt(0) <= z#49 && z#49 < n#0 && Div(x#77 - y#51, LitInt(n#0)) == Div(x#77, LitInt(n#0)) - Div(y#51, LitInt(n#0))) || (LitInt(0 - n#0) <= z#49 && z#49 < 0 && Div(x#77 - y#51, LitInt(n#0)) == Div(x#77, LitInt(n#0)) - Div(y#51, LitInt(n#0)) - 1)))));

const unique class.JSON_mDeserializer_mByteStrConversion.__default: ClassName;

function JSON_mDeserializer_mByteStrConversion.__default.Digits($ly: LayerType, n#0: int, base#0: int) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#0: int :: { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) } Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < base#0) && $Is(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#0 := JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#0 := Seq#Append(digits'#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#0))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#1 := JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#1 := Seq#Append(digits'#1, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#1))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (0 < $FunctionContextHeight && LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#2 := Lit(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#2 := Seq#Append(digits'#2, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#2))));
}

function JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0: int, base#0: int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits(AsFuelBottom($ly), n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) == JSON_mDeserializer_mByteStrConversion.__default.Digits($LZ, n#0, base#0));

function JSON_mDeserializer_mByteStrConversion.__default.Digits#requires(LayerType, int, int) : bool;

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits#requires($ly, n#0, base#0) } LitInt(0) <= n#0 ==> (JSON_mDeserializer_mByteStrConversion.__default.Digits#requires($ly, n#0, base#0) <==> base#0 > 1));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.Digits(n#0: int where LitInt(0) <= n#0, base#0: int) returns (digits#3: Seq where $Is(digits#3, TSeq(TInt)));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.ByteStrConversion.Digits (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.Digits(n#0: int, base#0: int) returns (digits#3: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var d#2: int;
  var ##b#0: int;
  var ##e#0: int;
  var digits'#Z#0: Seq;
  var let#0#0#0: Seq;
  var ##n#0: int;
  var ##base#1: int;
  var digits#Z#0: Seq;
  var let#1#0#0: Seq;
  var ##base#2: int;
  var ##pow#1: int;
  var base##1_0_0: int;
  var pow##1_0_0: int;
  var d##1_0_0_0: int;
  var base##1_1_0: int;
  var pow##1_1_0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ByteStrConversion.Digits", " | ", n#0, " | ", base#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](27,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 1;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume n#0 == LitInt(0);
    assume Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon30_Else:
    assume n#0 == LitInt(0) ==> Seq#Length(digits#3) == LitInt(0);
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume n#0 > 0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon31_Else:
    assume n#0 > 0 ==> Seq#Length(digits#3) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    goto anon8;

  anon8:
    havoc d#2;
    assume true;
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume Seq#Contains(digits#3, $Box(d#2));
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} LitInt(0) <= d#2;
    goto anon11;

  anon33_Else:
    assume {:partition} d#2 < LitInt(0);
    goto anon11;

  anon11:
    assume LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon32_Else:
    assume Seq#Contains(digits#3, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < base#0;
    goto anon13;

  anon13:
    assume (forall d#1: int :: { Seq#Contains(digits#3, $Box(d#1)) } Seq#Contains(digits#3, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < base#0);
    assume false;
    return;

  anon29_Else:
    goto anon34_Then, anon34_Else;

  anon34_Then:
    assume {:partition} n#0 == LitInt(0);
    ##b#0 := base#0;
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##e#0 := LitInt(0);
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    assume Power.__default.Pow#canCall(base#0, LitInt(0));
    goto anon35_Then, anon35_Else;

  anon35_Then:
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](35,49)"} true;
    assume true;
    assume false;
    goto anon17;

  anon35_Else:
    goto anon17;

  anon17:
    assume Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, LitInt(0)) == LitInt(1);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](35,52)"} true;
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon34_Else:
    assume {:partition} n#0 != LitInt(0);
    free call CallPre$$DivMod.__default.LemmaDivPosIsPosAuto();
    call CallPost$$DivMod.__default.LemmaDivPosIsPosAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](38,29)"} true;
    free call CallPre$$DivMod.__default.LemmaDivDecreasesAuto();
    call CallPost$$DivMod.__default.LemmaDivDecreasesAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](38,54)"} true;
    havoc digits'#Z#0;
    assume $Is(digits'#Z#0, TSeq(TInt)) && $IsAlloc(digits'#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume $Is(Div(n#0, base#0), Tclass._System.nat());
    ##n#0 := Div(n#0, base#0);
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume 0 <= n#0 || ##n#0 == n#0;
    assume ##n#0 < n#0;
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume let#0#0#0 == JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), Div(n#0, base#0), base#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0);
    assume $Is(let#0#0#0, TSeq(TInt));
    assume digits'#Z#0 == let#0#0#0;
    havoc digits#Z#0;
    assume $Is(digits#Z#0, TSeq(TInt)) && $IsAlloc(digits#Z#0, TSeq(TInt), $Heap);
    assume base#0 != 0;
    assume let#1#0#0 == Seq#Append(digits'#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0))));
    assume true;
    assume $Is(let#1#0#0, TSeq(TInt));
    assume digits#Z#0 == let#1#0#0;
    assume $Is(base#0, Tclass._System.nat());
    ##base#2 := base#0;
    assume $IsAlloc(##base#2, Tclass._System.nat(), $Heap);
    ##pow#1 := n#0;
    assume $IsAlloc(##pow#1, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#2 > 1;
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    assume Logarithm.__default.Log#canCall(base#0, n#0);
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume true;
    assume Seq#Length(digits#Z#0) == Seq#Length(digits'#Z#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](42,42)"} true;
    assume true;
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} n#0 < base#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_0_0 := base#0;
    assume true;
    pow##1_0_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    call CallPost$$Logarithm.__default.LemmaLog0(base##1_0_0, pow##1_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](44,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume true;
    d##1_0_0_0 := base#0;
    call CallPre$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    call CallPost$$DivMod.__default.LemmaBasicDiv(d##1_0_0_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](45,57)"} true;
    assume Div(n#0, base#0) == LitInt(0);
    assume false;
    goto anon22;

  anon38_Else:
    goto anon22;

  anon22:
    assume Div(n#0, base#0) == LitInt(0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](45,59)"} true;
    goto anon26;

  anon37_Else:
    assume {:partition} base#0 <= n#0;
    assume true;
    assume $Is(base#0, Tclass._System.nat());
    base##1_1_0 := base#0;
    assume true;
    pow##1_1_0 := n#0;
    call CallPre$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    call CallPost$$Logarithm.__default.LemmaLogS(base##1_1_0, pow##1_1_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](47,30)"} true;
    assume {:subsumption 0} base#0 != 0;
    assume true;
    goto anon39_Then, anon39_Else;

  anon39_Then:
    call CallPre$$DivMod.__default.LemmaDivNonZeroAuto();
    call CallPost$$DivMod.__default.LemmaDivNonZeroAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](48,58)"} true;
    assume Div(n#0, base#0) > 0;
    assume false;
    goto anon25;

  anon39_Else:
    goto anon25;

  anon25:
    assume Div(n#0, base#0) > 0;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](48,60)"} true;
    goto anon26;

  anon26:
    assume true;
    assume false;
    goto anon27;

  anon36_Else:
    goto anon27;

  anon27:
    assume Seq#Length(digits#Z#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](50,8)"} true;
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#Z#0;
    assume true;
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), TSeq(TInt));
    goto anon28;

  anon28:
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0) == digits#3;
    return;
}



function JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly: LayerType, digits#0: Seq, chars#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#0: int :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || (2 < $FunctionContextHeight && $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#2: int :: { Seq#Contains(digits#0, $Box(d#2)) } Seq#Contains(digits#0, $Box(d#2)) ==> LitInt(0) <= d#2 && d#2 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));
}

function JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0: Seq, chars#0: Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits(AsFuelBottom($ly), digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) == JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LZ, digits#0, chars#0));

function JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires(LayerType, Seq, Seq) : bool;

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#1: int :: { Seq#Contains(digits#0, $Box(d#1)) } Seq#Contains(digits#0, $Box(d#1)) ==> LitInt(0) <= d#1 && d#1 < Seq#Length(chars#0))));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.OfDigits (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.OfDigits(digits#0: Seq where $Is(digits#0, TSeq(TInt)), chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint8()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#0: int :: { Seq#Contains(chars#0, $Box(c#0)) } { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#0)) ==> Seq#Contains(chars#0, $Box(c#0))) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> (var base#0 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#0 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#0), chars#0))));
axiom 3 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (3 < $FunctionContextHeight && LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#1 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#1) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#1 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#1), Lit(chars#0)))));
}

function JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0: int, chars#0: Seq) : bool;

function JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#requires(int, Seq) : bool;

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#requires(n#0, chars#0) } LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#requires(n#0, chars#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0: int where LitInt(0) <= n#0, chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint8()))) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.ByteStrConversion.OfNat_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0: int, chars#0: Seq) returns (str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##base#0: int;
  var ##pow#0: int;
  var c#2: int;
  var base#Z#0: int;
  var let#0#0#0: int;
  var ##n#0: int;
  var ##base#1: int;
  var ##digits#0: Seq;
  var ##chars#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ByteStrConversion.OfNat_any", " | ", n#0, " | ", chars#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](66,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(chars#0) > 1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8()));
    assume $Is(Seq#Length(chars#0), Tclass._System.nat());
    ##base#0 := Seq#Length(chars#0);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##pow#0 := n#0;
    assume $IsAlloc(##pow#0, Tclass._System.nat(), $Heap);
    assume {:subsumption 0} ##base#0 > 1;
    assume ##base#0 > 1;
    assume Logarithm.__default.Log#canCall(Seq#Length(chars#0), n#0);
    assume Seq#Length(str#0) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1;
    havoc c#2;
    assume LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(str#0, $Box(c#2));
    assume Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon11_Else:
    assume Seq#Contains(str#0, $Box(c#2)) ==> Seq#Contains(chars#0, $Box(c#2));
    goto anon5;

  anon5:
    assume (forall c#1: int :: { Seq#Contains(chars#0, $Box(c#1)) } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Seq#Contains(chars#0, $Box(c#1)));
    assume false;
    return;

  anon10_Else:
    havoc base#Z#0;
    assume true;
    assume let#0#0#0 == Seq#Length(chars#0);
    assume true;
    assume $Is(let#0#0#0, TInt);
    assume base#Z#0 == let#0#0#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} n#0 == LitInt(0);
    call CallPre$$Logarithm.__default.reveal__Log();
    call CallPost$$Logarithm.__default.reveal__Log();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](72,32)"} true;
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(chars#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0)));
    assume true;
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon9;

  anon12_Else:
    assume {:partition} n#0 != LitInt(0);
    ##n#0 := n#0;
    assume $IsAlloc(##n#0, Tclass._System.nat(), $Heap);
    ##base#1 := base#Z#0;
    assume $IsAlloc(##base#1, TInt, $Heap);
    assume true;
    assume ##base#1 > 1;
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#Z#0);
    ##digits#0 := JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0);
    assume $IsAlloc(##digits#0, TSeq(TInt), $Heap);
    ##chars#0 := chars#0;
    assume $IsAlloc(##chars#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume true;
    assume (forall d#0: int :: { Seq#Contains(##digits#0, $Box(d#0)) } Seq#Contains(##digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(##chars#0));
    assume JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#Z#0) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#Z#0), chars#0);
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon9;

  anon9:
    assume JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == str#0;
    return;
}



function JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0: Seq, minus#0: int, is_digit#0: HandleType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#0: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#0))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#0))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#1: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#1))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#1)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#1))): bool)));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#2: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#2))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#2)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box(c#2))): bool)));
}

function JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(str#0: Seq, minus#0: int, is_digit#0: HandleType) : bool;

function JSON_mDeserializer_mByteStrConversion.__default.NumberStr#requires(Seq, int, HandleType) : bool;

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mByteStrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr#requires(str#0, minus#0, is_digit#0) <==> true));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.NumberStr (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8(), is_digit#0: HandleType where $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0: int, chars#0: Seq, minus#0: int) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> JSON_mDeserializer_mByteStrConversion.__default.NumberStr(JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(Seq#Contains(chars#0, $l#0#c#0))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint8())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(0 - n#0, chars#0))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
axiom 4 <= $FunctionContextHeight ==> (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) || (4 < $FunctionContextHeight && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));
}

function JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(n#0: int, chars#0: Seq, minus#0: int) : bool;

function JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#requires(int, Seq, int) : bool;

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) } $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() ==> (JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#requires(n#0, chars#0, minus#0) <==> Seq#Length(chars#0) > 1));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.OfInt_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0: int, chars#0: Seq where $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8()) returns (str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly: LayerType, str#0: Seq, base#0: int, digits#0: Map) : int
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#2: int :: { Map#Domain(digits#0)[$Box(c#2)] } { Seq#Contains(str#0, $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#2)) ==> Map#Domain(digits#0)[$Box(c#2)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));
}

function JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0: Seq, base#0: int, digits#0: Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any(AsFuelBottom($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) == JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LZ, str#0, base#0, digits#0));

function JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires(LayerType, Seq, int, Map) : bool;

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)])));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__any(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()))) returns (n#0: int where LitInt(0) <= n#0);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_any (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__any(str#0: Seq, base#0: int, digits#0: Map) returns (n#0: int)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: int;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ByteStrConversion.ToNat_any", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](90,42): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume base#0 > 0;
    havoc c#3;
    assume LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume Seq#Contains(str#0, $Box(c#3));
    assume Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon10_Else:
    assume Seq#Contains(str#0, $Box(c#3)) ==> Map#Domain(digits#0)[$Box(c#3)];
    goto anon4;

  anon4:
    assume (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)]);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume LitInt(0) <= JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0);
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    assume $Is(LitInt(0), Tclass._System.nat());
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == LitInt(0);
    assume true;
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon12_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Mul.__default.LemmaMulNonnegativeAuto();
    call CallPost$$Mul.__default.LemmaMulNonnegativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](96,32)"} true;
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#0 := base#0;
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := digits#0;
    assume $IsAlloc(##digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume true;
    assume ##base#0 > 0;
    assume true;
    assume (forall c#4: int :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume 0 <= base#0 || Seq#Rank(##str#0) < Seq#Rank(str#0) || ##base#0 == base#0;
    assume Seq#Rank(##str#0) < Seq#Rank(str#0) || (Seq#Rank(##str#0) == Seq#Rank(str#0) && (##base#0 < base#0 || (##base#0 == base#0 && Set#Subset(Map#Domain(##digits#0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(##digits#0)))));
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume $Is(Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int, Tclass._System.nat());
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int;
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume $Is(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0), Tclass._System.nat());
    goto anon9;

  anon9:
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) == n#0;
    return;
}



procedure {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_bound (well-formedness)"} CheckWellFormed$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_bound (call precondtion)"} CallPre$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap));
  requires {:id "id23327"} base#0 > 0;
  requires {:id "id23328"} (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id23329"} (forall c#3: int :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);



procedure {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap));
  modifies $Heap;
  free ensures JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id23330"} JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_bound (correctness)"} Impl$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && $IsAlloc(str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && $IsAlloc(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap)) returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  requires {:id "id23331"} base#0 > 0;
  requires {:id "id23332"} (forall c#1: int :: { Map#Domain(digits#0)[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(digits#0)[$Box(c#1)]);
  requires {:id "id23333"} (forall c#3: int :: { $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int } { Seq#Contains(str#0, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#3)) ==> $Unbox(Map#Elements(digits#0)[$Box(c#3)]): int < base#0);
  modifies $Heap;
  free ensures JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) && Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
  free ensures {:id "id23334"} $_reverifyPost ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LS($LZ)), str#0, base#0, digits#0) < Power.__default.Pow($LS($LS($LZ)), reveal_Power._default.Pow, base#0, Seq#Length(str#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_bound (correctness)"} Impl$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##b#1_0_0_0: int;
  var ##e#1_0_0_0: int;
  var ##b#1_0_0_1: int;
  var ##e#1_0_0_1: int;
  var ##b#1_0_1_0: int;
  var ##e#1_0_1_0: int;
  var ##b#1_0_1_1: int;
  var ##e#1_0_1_1: int;
  var ##str#1_0_2_0: Seq;
  var ##base#1_0_2_0: int;
  var ##digits#1_0_2_0: Map;
  var str##1_0_2_0: Seq;
  var base##1_0_2_0: int;
  var digits##1_0_2_0: Map;
  var ##b#1_0_2_0: int;
  var ##e#1_0_2_0: int;
  var ##str#1_0_3_0: Seq;
  var ##base#1_0_3_0: int;
  var ##digits#1_0_3_0: Map;
  var ##str#1_0_3_1: Seq;
  var ##base#1_0_3_1: int;
  var ##digits#1_0_3_1: Map;
  var ##str#1_0_4_0: Seq;
  var ##base#1_0_4_0: int;
  var ##digits#1_0_4_0: Map;
  var ##str#1_0_4_1: Seq;
  var ##base#1_0_4_1: int;
  var ##digits#1_0_4_1: Map;
  var ##str#1_0_0: Seq;
  var ##base#1_0_0: int;
  var ##digits#1_0_0: Map;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ByteStrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](105,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Seq#Equal(str#0, Seq#Empty(): Seq);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](107,19)"} true;
    return;

  anon10_Else:
    assume {:partition} !Seq#Equal(str#0, Seq#Empty(): Seq);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    ##str#1_0_0 := str#0;
    assume $IsAlloc(##str#1_0_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_0 := base#0;
    assume $IsAlloc(##base#1_0_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_0 := digits#0;
    assume $IsAlloc(##digits#1_0_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_0 > 0;
    assume {:subsumption 0} (forall c#1_0_0: int :: { Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)] } { Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) } LitInt(0) <= c#1_0_0 && c#1_0_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_0, $Box(c#1_0_0)) ==> Map#Domain(##digits#1_0_0)[$Box(c#1_0_0)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume false;
    goto anon9;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    ##str#1_0_4_0 := str#0;
    assume $IsAlloc(##str#1_0_4_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_4_0 := base#0;
    assume $IsAlloc(##base#1_0_4_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_0 := digits#0;
    assume $IsAlloc(##digits#1_0_4_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_0 > 0;
    assume {:subsumption 0} (forall c#1_0_4_0: int :: { Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)] } { Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) } LitInt(0) <= c#1_0_4_0 && c#1_0_4_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_4_0, $Box(c#1_0_4_0)) ==> Map#Domain(##digits#1_0_4_0)[$Box(c#1_0_4_0)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_4_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_4_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_4_1 := base#0;
    assume $IsAlloc(##base#1_0_4_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_4_1 := digits#0;
    assume $IsAlloc(##digits#1_0_4_1, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_4_1 > 0;
    assume {:subsumption 0} (forall c#1_0_4_1: int :: { Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)] } { Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) } LitInt(0) <= c#1_0_4_1 && c#1_0_4_1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_4_1, $Box(c#1_0_4_1)) ==> Map#Domain(##digits#1_0_4_1)[$Box(c#1_0_4_1)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon12_Else:
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_3_0 := base#0;
    assume $IsAlloc(##base#1_0_3_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_0 := digits#0;
    assume $IsAlloc(##digits#1_0_3_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_0 > 0;
    assume {:subsumption 0} (forall c#1_0_3_0: int :: { Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)] } { Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) } LitInt(0) <= c#1_0_3_0 && c#1_0_3_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_3_0, $Box(c#1_0_3_0)) ==> Map#Domain(##digits#1_0_3_0)[$Box(c#1_0_3_0)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 < Seq#Length(str#0);
    assume {:subsumption 0} Map#Domain(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)];
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_3_1 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_3_1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_3_1 := base#0;
    assume $IsAlloc(##base#1_0_3_1, Tclass._System.nat(), $Heap);
    ##digits#1_0_3_1 := digits#0;
    assume $IsAlloc(##digits#1_0_3_1, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_3_1 > 0;
    assume {:subsumption 0} (forall c#1_0_3_1: int :: { Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)] } { Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) } LitInt(0) <= c#1_0_3_1 && c#1_0_3_1 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_3_1, $Box(c#1_0_3_1)) ==> Map#Domain(##digits#1_0_3_1)[$Box(c#1_0_3_1)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume true;
    assume false;
    goto anon9;

  anon13_Else:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:subsumption 0} 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    ##str#1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume $IsAlloc(##str#1_0_2_0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##base#1_0_2_0 := base#0;
    assume $IsAlloc(##base#1_0_2_0, Tclass._System.nat(), $Heap);
    ##digits#1_0_2_0 := digits#0;
    assume $IsAlloc(##digits#1_0_2_0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#1_0_2_0 > 0;
    assume {:subsumption 0} (forall c#1_0_2_0: int :: { Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)] } { Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) } LitInt(0) <= c#1_0_2_0 && c#1_0_2_0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#1_0_2_0, $Box(c#1_0_2_0)) ==> Map#Domain(##digits#1_0_2_0)[$Box(c#1_0_2_0)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0);
    assume 0 <= Seq#Length(str#0) - 1 && Seq#Length(str#0) - 1 <= Seq#Length(str#0);
    assume true;
    str##1_0_2_0 := Seq#Take(str#0, Seq#Length(str#0) - 1);
    assume true;
    base##1_0_2_0 := base#0;
    assume true;
    digits##1_0_2_0 := digits#0;
    assume 0 <= base#0 || Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || base##1_0_2_0 == base#0;
    assume Seq#Rank(str##1_0_2_0) < Seq#Rank(str#0) || (Seq#Rank(str##1_0_2_0) == Seq#Rank(str#0) && (base##1_0_2_0 < base#0 || (base##1_0_2_0 == base#0 && Set#Subset(Map#Domain(digits##1_0_2_0), Map#Domain(digits#0)) && !Set#Subset(Map#Domain(digits#0), Map#Domain(digits##1_0_2_0)))));
    call CallPre$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    call CallPost$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str##1_0_2_0, base##1_0_2_0, digits##1_0_2_0);
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](113,55)"} true;
    free call CallPre$$Mul.__default.LemmaMulInequalityAuto();
    call CallPost$$Mul.__default.LemmaMulInequalityAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](114,36)"} true;
    ##b#1_0_2_0 := base#0;
    assume $IsAlloc(##b#1_0_2_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_2_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_2_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon14_Else:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    ##b#1_0_1_0 := base#0;
    assume $IsAlloc(##b#1_0_1_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Mul.__default.LemmaMulIsDistributiveAuto();
    call CallPost$$Mul.__default.LemmaMulIsDistributiveAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](116,40)"} true;
    ##b#1_0_1_1 := base#0;
    assume $IsAlloc(##b#1_0_1_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_1_1 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_1_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume true;
    assume false;
    goto anon9;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    ##b#1_0_0_0 := base#0;
    assume $IsAlloc(##b#1_0_0_0, TInt, $Heap);
    assume $Is(Seq#Length(str#0) - 1, Tclass._System.nat());
    ##e#1_0_0_0 := Seq#Length(str#0) - 1;
    assume $IsAlloc(##e#1_0_0_0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0) - 1);
    free call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](118,23)"} true;
    free call CallPre$$Mul.__default.LemmaMulIsCommutativeAuto();
    call CallPost$$Mul.__default.LemmaMulIsCommutativeAuto();
    assume {:captureState "libraries/src/JSON/Utils/Str.dfy[ByteStrConversion](118,53)"} true;
    ##b#1_0_0_1 := base#0;
    assume $IsAlloc(##b#1_0_0_1, TInt, $Heap);
    assume $Is(Seq#Length(str#0), Tclass._System.nat());
    ##e#1_0_0_1 := Seq#Length(str#0);
    assume $IsAlloc(##e#1_0_0_1, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume Power.__default.Pow#canCall(base#0, Seq#Length(str#0));
    assume true;
    assume false;
    goto anon9;

  anon16_Else:
    goto anon9;

  anon9:
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0) <= Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, base#0, Seq#Length(str#0)) - 1;
    return;
}



function JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0: Seq, minus#0: int, base#0: int, digits#0: Map) : int
uses {
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(Map#Domain(digits#0)[$l#2#c#0])), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.BoundedInts.uint8())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
axiom 3 <= $FunctionContextHeight ==> (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || (3 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(Map#Domain(digits#0)[$l#3#c#0])), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));
}

function JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(str#0: Seq, minus#0: int, base#0: int, digits#0: Map) : bool;

function JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(Seq, int, int, Map) : bool;

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(Map#Domain(digits#0)[$l#1#c#0])), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.Deserializer.ByteStrConversion.ToInt_any (well-formedness)"} CheckWellformed$$JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint8())), minus#0: int where LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8(), base#0: int where LitInt(0) <= base#0, digits#0: Map where $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()))) returns (s#0: int);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#200 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#200))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#202 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#202)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#300 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#300))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#302 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#302)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#304 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#304)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#300 := Wrappers.Option.value(this); v#300)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#302 := Lit(Wrappers.Option.value(Lit(this))); v#302)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#304 := Lit(Wrappers.Option.value(Lit(this))); v#304)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#200 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#200)) else (var e#200 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#202 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#202))) else (var e#202 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#300 := Wrappers.Result.value(this); s#300) else (var e#300 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#302 := Lit(Wrappers.Result.value(Lit(this))); s#302) else (var e#302 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#304 := Lit(Wrappers.Result.value(Lit(this))); s#304) else (var e#304 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#300 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#300)) else (var e#300 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#300)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#302 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#302))) else (var e#302 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#302)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#304 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#304))) else (var e#304 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#304)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#96: int, y#96: int :: { Mul(x#96, y#96) } Mul(x#96, y#96) == Mul(y#96, x#96)) && (forall x#97: int, y#97: int, z#64: int :: { Mul(x#97 + y#97, z#64) } Mul(x#97 + y#97, z#64) == Mul(x#97, z#64) + Mul(y#97, z#64)) && (forall x#98: int, y#98: int, z#65: int :: { Mul(x#98 - y#98, z#65) } Mul(x#98 - y#98, z#65) == Mul(x#98, z#65) - Mul(y#98, z#65));

axiom MulInternals.__default.MulAuto() <==> (forall x#99: int, y#99: int :: { Mul(x#99, y#99) } Mul(x#99, y#99) == Mul(y#99, x#99)) && (forall x#100: int, y#100: int, z#66: int :: { Mul(x#100 + y#100, z#66) } Mul(x#100 + y#100, z#66) == Mul(x#100, z#66) + Mul(y#100, z#66)) && (forall x#101: int, y#101: int, z#67: int :: { Mul(x#101 - y#101, z#67) } Mul(x#101 - y#101, z#67) == Mul(x#101, z#67) - Mul(y#101, z#67));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#112: int :: { Mod(Mod(x#112, n#0), n#0) } Mod(Mod(x#112, n#0), n#0) == Mod(x#112, n#0)) && (forall x#113: int :: { Mod(x#113, n#0) } LitInt(0) <= x#113 && x#113 < n#0 <==> Mod(x#113, n#0) == x#113) && (forall x#114: int, y#56: int :: { Mod(x#114 + y#56, n#0) } (var z#54 := Mod(x#114, n#0) + Mod(y#56, n#0); (LitInt(0) <= z#54 && z#54 < n#0 && Mod(x#114 + y#56, n#0) == z#54) || (n#0 <= z#54 && z#54 < n#0 + n#0 && Mod(x#114 + y#56, n#0) == z#54 - n#0))) && (forall x#115: int, y#57: int :: { Mod(x#115 - y#57, n#0) } (var z#55 := Mod(x#115, n#0) - Mod(y#57, n#0); (LitInt(0) <= z#55 && z#55 < n#0 && Mod(x#115 - y#57, n#0) == z#55) || (0 - n#0 <= z#55 && z#55 < 0 && Mod(x#115 - y#57, n#0) == z#55 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#116: int :: { Mod(Mod(x#116, n#0), n#0) } Mod(Mod(x#116, LitInt(n#0)), LitInt(n#0)) == Mod(x#116, LitInt(n#0))) && (forall x#117: int :: { Mod(x#117, n#0) } LitInt(0) <= x#117 && x#117 < n#0 <==> Mod(x#117, LitInt(n#0)) == x#117) && (forall x#118: int, y#58: int :: { Mod(x#118 + y#58, n#0) } (var z#56 := Mod(x#118, LitInt(n#0)) + Mod(y#58, LitInt(n#0)); (LitInt(0) <= z#56 && z#56 < n#0 && Mod(x#118 + y#58, LitInt(n#0)) == z#56) || (LitInt(n#0) <= z#56 && z#56 < n#0 + n#0 && Mod(x#118 + y#58, LitInt(n#0)) == z#56 - n#0))) && (forall x#119: int, y#59: int :: { Mod(x#119 - y#59, n#0) } (var z#57 := Mod(x#119, LitInt(n#0)) - Mod(y#59, LitInt(n#0)); (LitInt(0) <= z#57 && z#57 < n#0 && Mod(x#119 - y#59, LitInt(n#0)) == z#57) || (LitInt(0 - n#0) <= z#57 && z#57 < 0 && Mod(x#119 - y#59, LitInt(n#0)) == z#57 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#78: int :: { Div(x#78, n#0) } LitInt(0) <= x#78 && x#78 < n#0 <==> Div(x#78, n#0) == LitInt(0)) && (forall x#79: int, y#52: int :: { Div(x#79 + y#52, n#0) } (var z#50 := Mod(x#79, n#0) + Mod(y#52, n#0); (LitInt(0) <= z#50 && z#50 < n#0 && Div(x#79 + y#52, n#0) == Div(x#79, n#0) + Div(y#52, n#0)) || (n#0 <= z#50 && z#50 < n#0 + n#0 && Div(x#79 + y#52, n#0) == Div(x#79, n#0) + Div(y#52, n#0) + 1))) && (forall x#80: int, y#53: int :: { Div(x#80 - y#53, n#0) } (var z#51 := Mod(x#80, n#0) - Mod(y#53, n#0); (LitInt(0) <= z#51 && z#51 < n#0 && Div(x#80 - y#53, n#0) == Div(x#80, n#0) - Div(y#53, n#0)) || (0 - n#0 <= z#51 && z#51 < 0 && Div(x#80 - y#53, n#0) == Div(x#80, n#0) - Div(y#53, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#81: int :: { Div(x#81, n#0) } LitInt(0) <= x#81 && x#81 < n#0 <==> Div(x#81, LitInt(n#0)) == LitInt(0)) && (forall x#82: int, y#54: int :: { Div(x#82 + y#54, n#0) } (var z#52 := Mod(x#82, LitInt(n#0)) + Mod(y#54, LitInt(n#0)); (LitInt(0) <= z#52 && z#52 < n#0 && Div(x#82 + y#54, LitInt(n#0)) == Div(x#82, LitInt(n#0)) + Div(y#54, LitInt(n#0))) || (LitInt(n#0) <= z#52 && z#52 < n#0 + n#0 && Div(x#82 + y#54, LitInt(n#0)) == Div(x#82, LitInt(n#0)) + Div(y#54, LitInt(n#0)) + 1))) && (forall x#83: int, y#55: int :: { Div(x#83 - y#55, n#0) } (var z#53 := Mod(x#83, LitInt(n#0)) - Mod(y#55, LitInt(n#0)); (LitInt(0) <= z#53 && z#53 < n#0 && Div(x#83 - y#55, LitInt(n#0)) == Div(x#83, LitInt(n#0)) - Div(y#55, LitInt(n#0))) || (LitInt(0 - n#0) <= z#53 && z#53 < 0 && Div(x#83 - y#55, LitInt(n#0)) == Div(x#83, LitInt(n#0)) - Div(y#55, LitInt(n#0)) - 1)))));

const unique class.JSON_mDeserializer.__default: ClassName;

function JSON_mDeserializer.__default.Bool(js#0: DatatypeType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Bool(js#0) } JSON_mDeserializer.__default.Bool#canCall(js#0) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jbool())) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(js#0, LitInt(0)) && (JSON_mDeserializer.__default.Bool(js#0) <==> JSON_mUtils_mViews_mCore.View__.At(js#0, LitInt(0)) == char#ToInt(Lit(char#FromInt(116)))));
axiom 0 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Bool(Lit(js#0)) } JSON_mDeserializer.__default.Bool#canCall(Lit(js#0)) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jbool())) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(js#0), LitInt(0)) && (JSON_mDeserializer.__default.Bool(Lit(js#0)) <==> LitInt(JSON_mUtils_mViews_mCore.View__.At(Lit(js#0), LitInt(0))) == char#ToInt(Lit(char#FromInt(116)))));
}

function JSON_mDeserializer.__default.Bool#canCall(js#0: DatatypeType) : bool;

function JSON_mDeserializer.__default.Bool#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Bool#requires(js#0) } $Is(js#0, Tclass.JSON_mGrammar.jbool()) ==> (JSON_mDeserializer.__default.Bool#requires(js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Bool (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Bool(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.jbool()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Bool (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Bool(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##idx#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Bool", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(37,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(js#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(js#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(js#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(js#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes(js#0) == JSON_mGrammar.__default.TRUE() || JSON_mUtils_mViews_mCore.View__.Bytes(js#0) == JSON_mGrammar.__default.FALSE();
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(38,54)"} true;
    assume $IsAllocBox($Box(js#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0 := LitInt(0);
    assume $IsAlloc(##idx#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(js#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(js#0);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall(js#0, ##idx#0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q(js#0, ##idx#0) || JSON_mUtils_mViews_mCore.View__.beg(js#0) + ##idx#0 < JSON_mUtils_mViews_mCore.View__.end(js#0);
    assume JSON_mUtils_mViews_mCore.View__.ValidIndex_q(js#0, ##idx#0);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall(js#0, LitInt(0));
    newtype$check#1 := char#ToInt(Lit(char#FromInt(116)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(116)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mDeserializer.__default.Bool(js#0) <==> JSON_mUtils_mViews_mCore.View__.At(js#0, LitInt(0)) == char#ToInt(Lit(char#FromInt(116)));
    assume JSON_mUtils_mViews_mCore.View__.At#canCall(js#0, LitInt(0));
    assume $Is(JSON_mDeserializer.__default.Bool(js#0), TBool);
    return;
}



function JSON_mDeserializer.__default.UnsupportedEscape16(code#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall code#0: Seq :: { JSON_mDeserializer.__default.UnsupportedEscape16(code#0) } JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#0) || (0 < $FunctionContextHeight && $Is(code#0, TSeq(Tclass.BoundedInts.uint16()))) ==> $Is(JSON_mDeserializer.__default.UnsupportedEscape16(code#0), Tclass.JSON_mErrors.DeserializationError()));
axiom 0 <= $FunctionContextHeight ==> (forall code#0: Seq :: { JSON_mDeserializer.__default.UnsupportedEscape16(code#0) } JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#0) || (0 < $FunctionContextHeight && $Is(code#0, TSeq(Tclass.BoundedInts.uint16()))) ==> UnicodeStrings.__default.FromUTF16Checked#canCall(code#0) && Wrappers.Option.UnwrapOr#canCall(TSeq(TChar), UnicodeStrings.__default.FromUTF16Checked(code#0), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54)))))) && JSON_mDeserializer.__default.UnsupportedEscape16(code#0) == #JSON.Errors.DeserializationError.UnsupportedEscape($Unbox(Wrappers.Option.UnwrapOr(TSeq(TChar), UnicodeStrings.__default.FromUTF16Checked(code#0), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54))))))): Seq));
axiom 0 <= $FunctionContextHeight ==> (forall code#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.UnsupportedEscape16(Lit(code#0)) } JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Lit(code#0)) || (0 < $FunctionContextHeight && $Is(code#0, TSeq(Tclass.BoundedInts.uint16()))) ==> UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(code#0)) && Wrappers.Option.UnwrapOr#canCall(TSeq(TChar), Lit(UnicodeStrings.__default.FromUTF16Checked(Lit(code#0))), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54)))))) && JSON_mDeserializer.__default.UnsupportedEscape16(Lit(code#0)) == Lit(#JSON.Errors.DeserializationError.UnsupportedEscape(Lit($Unbox(Wrappers.Option.UnwrapOr(TSeq(TChar), Lit(UnicodeStrings.__default.FromUTF16Checked(Lit(code#0))), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54))))))): Seq))));
}

function JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#0: Seq) : bool;

function JSON_mDeserializer.__default.UnsupportedEscape16#requires(Seq) : bool;

axiom (forall code#0: Seq :: { JSON_mDeserializer.__default.UnsupportedEscape16#requires(code#0) } $Is(code#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer.__default.UnsupportedEscape16#requires(code#0) <==> true));

procedure {:verboseName "JSON.Deserializer.UnsupportedEscape16 (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.UnsupportedEscape16(code#0: Seq where $Is(code#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mDeserializer.__default.HEX__TABLE__16() : Map
uses {
axiom JSON_mDeserializer.__default.HEX__TABLE__16(): Map == Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Empty(): Map, $Box(char#ToInt(Lit(char#FromInt(48)))), $Box(LitInt(0))), $Box(char#ToInt(Lit(char#FromInt(49)))), $Box(LitInt(1))), $Box(char#ToInt(Lit(char#FromInt(50)))), $Box(LitInt(2))), $Box(char#ToInt(Lit(char#FromInt(51)))), $Box(LitInt(3))), $Box(char#ToInt(Lit(char#FromInt(52)))), $Box(LitInt(4))), $Box(char#ToInt(Lit(char#FromInt(53)))), $Box(LitInt(5))), $Box(char#ToInt(Lit(char#FromInt(54)))), $Box(LitInt(6))), $Box(char#ToInt(Lit(char#FromInt(55)))), $Box(LitInt(7))), $Box(char#ToInt(Lit(char#FromInt(56)))), $Box(LitInt(8))), $Box(char#ToInt(Lit(char#FromInt(57)))), $Box(LitInt(9))), $Box(char#ToInt(Lit(char#FromInt(97)))), $Box(LitInt(10))), $Box(char#ToInt(Lit(char#FromInt(98)))), $Box(LitInt(11))), $Box(char#ToInt(Lit(char#FromInt(99)))), $Box(LitInt(12))), $Box(char#ToInt(Lit(char#FromInt(100)))), $Box(LitInt(13))), $Box(char#ToInt(Lit(char#FromInt(101)))), $Box(LitInt(14))), $Box(char#ToInt(Lit(char#FromInt(102)))), $Box(LitInt(15))), $Box(char#ToInt(Lit(char#FromInt(65)))), $Box(LitInt(10))), $Box(char#ToInt(Lit(char#FromInt(66)))), $Box(LitInt(11))), $Box(char#ToInt(Lit(char#FromInt(67)))), $Box(LitInt(12))), $Box(char#ToInt(Lit(char#FromInt(68)))), $Box(LitInt(13))), $Box(char#ToInt(Lit(char#FromInt(69)))), $Box(LitInt(14))), $Box(char#ToInt(Lit(char#FromInt(70)))), $Box(LitInt(15)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mDeserializer.__default.HEX__TABLE__16(), TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()));
}

procedure {:verboseName "JSON.Deserializer.HEX_TABLE_16 (well-formedness)"} CheckWellFormed$$JSON_mDeserializer.__default.HEX__TABLE__16();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.HEX_TABLE_16 (well-formedness)"} CheckWellFormed$$JSON_mDeserializer.__default.HEX__TABLE__16()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var newtype$check#26: int;
  var newtype$check#27: int;
  var newtype$check#28: int;
  var newtype$check#29: int;
  var newtype$check#30: int;
  var newtype$check#31: int;
  var newtype$check#32: int;
  var newtype$check#33: int;
  var newtype$check#34: int;
  var newtype$check#35: int;
  var newtype$check#36: int;
  var newtype$check#37: int;
  var newtype$check#38: int;
  var newtype$check#39: int;
  var newtype$check#40: int;
  var newtype$check#41: int;
  var newtype$check#42: int;
  var newtype$check#43: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.HEX_TABLE_16"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(52,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(0), Tclass._System.nat());
    newtype$check#2 := char#ToInt(Lit(char#FromInt(49)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(49)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(1), Tclass._System.nat());
    newtype$check#4 := char#ToInt(Lit(char#FromInt(50)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(50)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(2), Tclass._System.nat());
    newtype$check#6 := char#ToInt(Lit(char#FromInt(51)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(51)));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(3), Tclass._System.nat());
    newtype$check#8 := char#ToInt(Lit(char#FromInt(52)));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#9 := char#ToInt(Lit(char#FromInt(52)));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(4), Tclass._System.nat());
    newtype$check#10 := char#ToInt(Lit(char#FromInt(53)));
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#11 := char#ToInt(Lit(char#FromInt(53)));
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(5), Tclass._System.nat());
    newtype$check#12 := char#ToInt(Lit(char#FromInt(54)));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#13 := char#ToInt(Lit(char#FromInt(54)));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(6), Tclass._System.nat());
    newtype$check#14 := char#ToInt(Lit(char#FromInt(55)));
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#15 := char#ToInt(Lit(char#FromInt(55)));
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(7), Tclass._System.nat());
    newtype$check#16 := char#ToInt(Lit(char#FromInt(56)));
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#17 := char#ToInt(Lit(char#FromInt(56)));
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(8), Tclass._System.nat());
    newtype$check#18 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#19 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(9), Tclass._System.nat());
    newtype$check#20 := char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#21 := char#ToInt(Lit(char#FromInt(97)));
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(10), Tclass._System.nat());
    newtype$check#22 := char#ToInt(Lit(char#FromInt(98)));
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#23 := char#ToInt(Lit(char#FromInt(98)));
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(11), Tclass._System.nat());
    newtype$check#24 := char#ToInt(Lit(char#FromInt(99)));
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#25 := char#ToInt(Lit(char#FromInt(99)));
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(12), Tclass._System.nat());
    newtype$check#26 := char#ToInt(Lit(char#FromInt(100)));
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#27 := char#ToInt(Lit(char#FromInt(100)));
    assume LitInt(0) <= newtype$check#27 && newtype$check#27 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(13), Tclass._System.nat());
    newtype$check#28 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#28 && newtype$check#28 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#29 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#29 && newtype$check#29 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(14), Tclass._System.nat());
    newtype$check#30 := char#ToInt(Lit(char#FromInt(102)));
    assume LitInt(0) <= newtype$check#30 && newtype$check#30 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#31 := char#ToInt(Lit(char#FromInt(102)));
    assume LitInt(0) <= newtype$check#31 && newtype$check#31 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(15), Tclass._System.nat());
    newtype$check#32 := char#ToInt(Lit(char#FromInt(65)));
    assume LitInt(0) <= newtype$check#32 && newtype$check#32 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#33 := char#ToInt(Lit(char#FromInt(65)));
    assume LitInt(0) <= newtype$check#33 && newtype$check#33 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(10), Tclass._System.nat());
    newtype$check#34 := char#ToInt(Lit(char#FromInt(66)));
    assume LitInt(0) <= newtype$check#34 && newtype$check#34 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#35 := char#ToInt(Lit(char#FromInt(66)));
    assume LitInt(0) <= newtype$check#35 && newtype$check#35 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(11), Tclass._System.nat());
    newtype$check#36 := char#ToInt(Lit(char#FromInt(67)));
    assume LitInt(0) <= newtype$check#36 && newtype$check#36 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#37 := char#ToInt(Lit(char#FromInt(67)));
    assume LitInt(0) <= newtype$check#37 && newtype$check#37 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(12), Tclass._System.nat());
    newtype$check#38 := char#ToInt(Lit(char#FromInt(68)));
    assume LitInt(0) <= newtype$check#38 && newtype$check#38 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#39 := char#ToInt(Lit(char#FromInt(68)));
    assume LitInt(0) <= newtype$check#39 && newtype$check#39 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(13), Tclass._System.nat());
    newtype$check#40 := char#ToInt(Lit(char#FromInt(69)));
    assume LitInt(0) <= newtype$check#40 && newtype$check#40 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#41 := char#ToInt(Lit(char#FromInt(69)));
    assume LitInt(0) <= newtype$check#41 && newtype$check#41 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(14), Tclass._System.nat());
    newtype$check#42 := char#ToInt(Lit(char#FromInt(70)));
    assume LitInt(0) <= newtype$check#42 && newtype$check#42 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#43 := char#ToInt(Lit(char#FromInt(70)));
    assume LitInt(0) <= newtype$check#43 && newtype$check#43 < BoundedInts.__default.TWO__TO__THE__16();
    assume $Is(LitInt(15), Tclass._System.nat());
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mDeserializer.__default.HEX__TABLE__16(), TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mDeserializer.__default.HEX__TABLE__16(), TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $h));

function JSON_mDeserializer.__default.ToNat16(str#0: Seq) : int
uses {
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mDeserializer.__default.ToNat16(str#0) } JSON_mDeserializer.__default.ToNat16#canCall(str#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(str#0) <= LitInt(4) && (forall c#0: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#0)])) ==> LitInt(0) <= JSON_mDeserializer.__default.ToNat16(str#0) && JSON_mDeserializer.__default.ToNat16(str#0) < BoundedInts.__default.TWO__TO__THE__16());
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq :: { JSON_mDeserializer.__default.ToNat16(str#0) } JSON_mDeserializer.__default.ToNat16#canCall(str#0) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(str#0) <= LitInt(4) && (forall c#1: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)])) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()) && JSON_mDeserializer.__default.ToNat16(str#0) == (var hd#0 := JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()); hd#0));
axiom 1 <= $FunctionContextHeight ==> (forall str#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.ToNat16(Lit(str#0)) } JSON_mDeserializer.__default.ToNat16#canCall(Lit(str#0)) || (1 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(Lit(str#0)) <= LitInt(4) && (forall c#2: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#2)] } { Seq#Contains(str#0, $Box(c#2)) } LitInt(0) <= c#2 && c#2 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#2)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#2)])) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()) && JSON_mDeserializer.__default.ToNat16(Lit(str#0)) == (var hd#1 := JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()); hd#1));
}

function JSON_mDeserializer.__default.ToNat16#canCall(str#0: Seq) : bool;

function JSON_mDeserializer.__default.ToNat16#requires(Seq) : bool;

axiom (forall str#0: Seq :: { JSON_mDeserializer.__default.ToNat16#requires(str#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer.__default.ToNat16#requires(str#0) <==> Seq#Length(str#0) <= LitInt(4) && (forall c#1: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)] } { Seq#Contains(str#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#1)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)])));

procedure {:verboseName "JSON.Deserializer.ToNat16 (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.ToNat16(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.ToNat16 (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.ToNat16(str#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var c#3: int;
  var str##0: Seq;
  var base##0: int;
  var digits##0: Map;
  var hd#Z#0: int;
  var let#0#0#0: int;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ToNat16", " | ", str#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(60,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(str#0) <= LitInt(4);
    havoc c#3;
    assume LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume Seq#Contains(str#0, $Box(c#3));
    assume Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)];
    goto anon4;

  anon9_Else:
    assume Seq#Contains(str#0, $Box(c#3)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)];
    goto anon4;

  anon4:
    assume (forall c#0: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#0)]);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume LitInt(0) <= JSON_mDeserializer.__default.ToNat16(str#0) && JSON_mDeserializer.__default.ToNat16(str#0) < BoundedInts.__default.TWO__TO__THE__16();
    assume false;
    return;

  anon10_Else:
    assume true;
    str##0 := str#0;
    assume true;
    assume $Is(LitInt(16), Tclass._System.nat());
    base##0 := LitInt(16);
    assume true;
    digits##0 := JSON_mDeserializer.__default.HEX__TABLE__16();
    call CallPre$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str##0, base##0, digits##0);
    call CallPost$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str##0, base##0, digits##0);
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(64,57)"} true;
    havoc hd#Z#0;
    assume LitInt(0) <= hd#Z#0;
    ##str#0 := str#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(LitInt(16), Tclass._System.nat());
    ##base#0 := LitInt(16);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    ##digits#0 := JSON_mDeserializer.__default.HEX__TABLE__16();
    assume $IsAlloc(##digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} (forall c#4: int :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume (forall c#4: int :: { Map#Domain(##digits#0)[$Box(c#4)] } { Seq#Contains(##str#0, $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#0, $Box(c#4)) ==> Map#Domain(##digits#0)[$Box(c#4)]);
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16());
    assume let#0#0#0 == JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16());
    assume JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16());
    assume $Is(let#0#0#0, Tclass._System.nat());
    assume hd#Z#0 == let#0#0#0;
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    call CallPre$$Power.__default.reveal__Pow();
    call CallPost$$Power.__default.reveal__Pow();
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(66,41)"} true;
    assume hd#Z#0 < 65536;
    assume false;
    goto anon8;

  anon11_Else:
    goto anon8;

  anon8:
    assume hd#Z#0 < 65536;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(66,44)"} true;
    newtype$check#0 := hd#Z#0;
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#1 := hd#Z#0;
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    assume JSON_mDeserializer.__default.ToNat16(str#0) == hd#Z#0;
    assume true;
    assume $Is(JSON_mDeserializer.__default.ToNat16(str#0), Tclass.BoundedInts.uint16());
    return;
}



function JSON_mDeserializer.__default.Unescape($ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape($ly, str#0, start#0, prefix#0) } JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0, prefix#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> $Is(JSON_mDeserializer.__default.Unescape($ly, str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError())));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape($LS($ly), str#0, start#0, prefix#0) } JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0, prefix#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> (Seq#Length(str#0) > start#0 ==> ($Unbox(Seq#Index(str#0, start#0)): int == char#ToInt(Lit(char#FromInt(92))) ==> Seq#Length(str#0) != start#0 + 1 ==> (var c#0 := $Unbox(Seq#Index(str#0, start#0 + 1)): int; (c#0 == char#ToInt(Lit(char#FromInt(117))) ==> start#0 + 6 < Seq#Length(str#0) ==> (var code#0 := Seq#Drop(Seq#Take(str#0, start#0 + 6), start#0 + 2); ((exists c#1: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)] } { Seq#Contains(code#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#0, $Box(c#1)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)]) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#0)) && (!(exists c#1: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)] } { Seq#Contains(code#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#0, $Box(c#1)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)]) ==> JSON_mDeserializer.__default.ToNat16#canCall(code#0) && (var hd#0 := JSON_mDeserializer.__default.ToNat16(code#0); JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#0)))))))) && (c#0 != char#ToInt(Lit(char#FromInt(117))) ==> (var unescaped#0 := (if c#0 == LitInt(34) then 34 else (if c#0 == LitInt(92) then 92 else (if c#0 == LitInt(98) then 8 else (if c#0 == LitInt(102) then 12 else (if c#0 == LitInt(110) then 10 else (if c#0 == LitInt(114) then 13 else (if c#0 == LitInt(116) then 9 else 0))))))); (unescaped#0 == LitInt(0) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0))) && (unescaped#0 != LitInt(0) ==> JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#0))))))))) && ($Unbox(Seq#Index(str#0, start#0)): int != char#ToInt(Lit(char#FromInt(92))) ==> JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0)))))) && JSON_mDeserializer.__default.Unescape($LS($ly), str#0, start#0, prefix#0) == (if start#0 >= Seq#Length(str#0) then #Wrappers.Result.Success($Box(prefix#0)) else (if $Unbox(Seq#Index(str#0, start#0)): int == char#ToInt(Lit(char#FromInt(92))) then (if Seq#Length(str#0) == start#0 + 1 then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var c#0 := $Unbox(Seq#Index(str#0, start#0 + 1)): int; (if c#0 == char#ToInt(Lit(char#FromInt(117))) then (if Seq#Length(str#0) <= start#0 + 6 then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var code#0 := Seq#Drop(Seq#Take(str#0, start#0 + 6), start#0 + 2); (if (exists c#1: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)] } { Seq#Contains(code#0, $Box(c#1)) } LitInt(0) <= c#1 && c#1 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#0, $Box(c#1)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#1)]) then #Wrappers.Result.Failure($Box(JSON_mDeserializer.__default.UnsupportedEscape16(code#0))) else (var hd#0 := JSON_mDeserializer.__default.ToNat16(code#0); JSON_mDeserializer.__default.Unescape($ly, str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#0)))))))) else (var unescaped#0 := (if c#0 == LitInt(34) then 34 else (if c#0 == LitInt(92) then 92 else (if c#0 == LitInt(98) then 8 else (if c#0 == LitInt(102) then 12 else (if c#0 == LitInt(110) then 10 else (if c#0 == LitInt(114) then 13 else (if c#0 == LitInt(116) then 9 else 0))))))); (if unescaped#0 == LitInt(0) then #Wrappers.Result.Failure($Box(JSON_mDeserializer.__default.UnsupportedEscape16(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0)))) else JSON_mDeserializer.__default.Unescape($ly, str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#0))))))))) else JSON_mDeserializer.__default.Unescape($ly, str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0)))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), prefix#0) } JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0), prefix#0) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) ==> Seq#Length(Lit(str#0)) != LitInt(start#0 + 1) ==> (var c#2 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (c#2 == char#ToInt(Lit(char#FromInt(117))) ==> LitInt(start#0 + 6) < Seq#Length(Lit(str#0)) ==> (var code#1 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); ((exists c#3: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)] } { Seq#Contains(code#1, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#1, $Box(c#3)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)]) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#1)) && (!(exists c#3: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)] } { Seq#Contains(code#1, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#1, $Box(c#3)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)]) ==> JSON_mDeserializer.__default.ToNat16#canCall(code#1) && (var hd#1 := JSON_mDeserializer.__default.ToNat16(code#1); JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#1)))))))) && (c#2 != char#ToInt(Lit(char#FromInt(117))) ==> (var unescaped#1 := (if c#2 == LitInt(34) then 34 else (if c#2 == LitInt(92) then 92 else (if c#2 == LitInt(98) then 8 else (if c#2 == LitInt(102) then 12 else (if c#2 == LitInt(110) then 10 else (if c#2 == LitInt(114) then 13 else (if c#2 == LitInt(116) then 9 else 0))))))); (unescaped#1 == LitInt(0) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))) && (unescaped#1 != LitInt(0) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#1))))))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != char#ToInt(Lit(char#FromInt(92))) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))) && JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), prefix#0) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then #Wrappers.Result.Success($Box(prefix#0)) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) then (if Seq#Length(Lit(str#0)) == LitInt(start#0 + 1) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var c#2 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (if c#2 == char#ToInt(Lit(char#FromInt(117))) then (if Seq#Length(Lit(str#0)) <= LitInt(start#0 + 6) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var code#1 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); (if (exists c#3: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)] } { Seq#Contains(code#1, $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#1, $Box(c#3)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#3)]) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(code#1)))) else (var hd#1 := LitInt(JSON_mDeserializer.__default.ToNat16(code#1)); JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#1)))))))) else (var unescaped#1 := (if c#2 == LitInt(34) then 34 else (if c#2 == LitInt(92) then 92 else (if c#2 == LitInt(98) then 8 else (if c#2 == LitInt(102) then 12 else (if c#2 == LitInt(110) then 10 else (if c#2 == LitInt(114) then 13 else (if c#2 == LitInt(116) then 9 else 0))))))); (if unescaped#1 == LitInt(0) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#1))))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), Lit(prefix#0)) } JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0), Lit(prefix#0)) || (2 < $FunctionContextHeight && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) ==> Seq#Length(Lit(str#0)) != LitInt(start#0 + 1) ==> (var c#4 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (c#4 == char#ToInt(Lit(char#FromInt(117))) ==> LitInt(start#0 + 6) < Seq#Length(Lit(str#0)) ==> (var code#2 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); ((exists c#5: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)] } { Seq#Contains(code#2, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#2, $Box(c#5)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)]) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#2)) && (!(exists c#5: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)] } { Seq#Contains(code#2, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#2, $Box(c#5)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)]) ==> JSON_mDeserializer.__default.ToNat16#canCall(code#2) && (var hd#2 := JSON_mDeserializer.__default.ToNat16(code#2); JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#2)))))))) && (c#4 != char#ToInt(Lit(char#FromInt(117))) ==> (var unescaped#2 := (if c#4 == LitInt(34) then 34 else (if c#4 == LitInt(92) then 92 else (if c#4 == LitInt(98) then 8 else (if c#4 == LitInt(102) then 12 else (if c#4 == LitInt(110) then 10 else (if c#4 == LitInt(114) then 13 else (if c#4 == LitInt(116) then 9 else 0))))))); (unescaped#2 == LitInt(0) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))) && (unescaped#2 != LitInt(0) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#2))))))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != char#ToInt(Lit(char#FromInt(92))) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))) && JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), Lit(prefix#0)) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then #Wrappers.Result.Success($Box(Lit(prefix#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) then (if Seq#Length(Lit(str#0)) == LitInt(start#0 + 1) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var c#4 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (if c#4 == char#ToInt(Lit(char#FromInt(117))) then (if Seq#Length(Lit(str#0)) <= LitInt(start#0 + 6) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var code#2 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); (if (exists c#5: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)] } { Seq#Contains(code#2, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#2, $Box(c#5)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)]) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(code#2)))) else (var hd#2 := LitInt(JSON_mDeserializer.__default.ToNat16(code#2)); JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#2)))))))) else (var unescaped#2 := (if c#4 == LitInt(34) then 34 else (if c#4 == LitInt(92) then 92 else (if c#4 == LitInt(98) then 8 else (if c#4 == LitInt(102) then 12 else (if c#4 == LitInt(110) then 10 else (if c#4 == LitInt(114) then 13 else (if c#4 == LitInt(116) then 9 else 0))))))); (if unescaped#2 == LitInt(0) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#2))))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))));
}

function JSON_mDeserializer.__default.Unescape#canCall(str#0: Seq, start#0: int, prefix#0: Seq) : bool;

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape($LS($ly), str#0, start#0, prefix#0) } JSON_mDeserializer.__default.Unescape($LS($ly), str#0, start#0, prefix#0) == JSON_mDeserializer.__default.Unescape($ly, str#0, start#0, prefix#0));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape(AsFuelBottom($ly), str#0, start#0, prefix#0) } JSON_mDeserializer.__default.Unescape($ly, str#0, start#0, prefix#0) == JSON_mDeserializer.__default.Unescape($LZ, str#0, start#0, prefix#0));

function JSON_mDeserializer.__default.Unescape#requires(LayerType, Seq, int, Seq) : bool;

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape#requires($ly, str#0, start#0, prefix#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer.__default.Unescape#requires($ly, str#0, start#0, prefix#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Unescape (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mDeserializer.__default.Unescape(str#0: Seq where $Is(str#0, TSeq(Tclass.BoundedInts.uint16())), start#0: int where LitInt(0) <= start#0, prefix#0: Seq where $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Unescape (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mDeserializer.__default.Unescape(str#0: Seq, start#0: int, prefix#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var c#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var code#Z#0: Seq;
  var let#1#0#0: Seq;
  var c#6: int;
  var ##code#0: Seq;
  var hd#Z#0: int;
  var let#2#0#0: int;
  var ##str#0: Seq;
  var ##str#1: Seq;
  var ##start#0: int;
  var ##prefix#0: Seq;
  var unescaped#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;
  var newtype$check#20: int;
  var newtype$check#21: int;
  var newtype$check#22: int;
  var newtype$check#23: int;
  var newtype$check#24: int;
  var newtype$check#25: int;
  var newtype$check#26: int;
  var ##code#1: Seq;
  var ##str#2: Seq;
  var ##start#1: int;
  var ##prefix#1: Seq;
  var ##str#3: Seq;
  var ##start#2: int;
  var ##prefix#2: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Unescape", " | ", str#0, " | ", start#0, " | ", prefix#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(70,57): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    assume $Is(LitInt(0), Tclass._System.nat());
    assume true;
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon36_Else:
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} start#0 >= Seq#Length(str#0);
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == #Wrappers.Result.Success($Box(prefix#0));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon37_Else:
    assume {:partition} Seq#Length(str#0) > start#0;
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int == char#ToInt(Lit(char#FromInt(92)));
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} Seq#Length(str#0) == start#0 + 1;
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon39_Else:
    assume {:partition} Seq#Length(str#0) != start#0 + 1;
    havoc c#Z#0;
    assume LitInt(0) <= c#Z#0 && c#Z#0 < BoundedInts.__default.TWO__TO__THE__16();
    assume 0 <= start#0 + 1 && start#0 + 1 < Seq#Length(str#0);
    assume let#0#0#0 == $Unbox(Seq#Index(str#0, start#0 + 1)): int;
    assume true;
    assume $Is(let#0#0#0, Tclass.BoundedInts.uint16());
    assume c#Z#0 == let#0#0#0;
    newtype$check#2 := char#ToInt(Lit(char#FromInt(117)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(117)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(117)));
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} Seq#Length(str#0) <= start#0 + 6;
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon41_Else:
    assume {:partition} start#0 + 6 < Seq#Length(str#0);
    havoc code#Z#0;
    assume $Is(code#Z#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(code#Z#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume 0 <= start#0 + 2 && start#0 + 2 <= Seq#Length(str#0);
    assume start#0 + 2 <= start#0 + 6 && start#0 + 6 <= Seq#Length(str#0);
    assume let#1#0#0 == Seq#Drop(Seq#Take(str#0, start#0 + 6), start#0 + 2);
    assume true;
    assume $Is(let#1#0#0, TSeq(Tclass.BoundedInts.uint16()));
    assume code#Z#0 == let#1#0#0;
    havoc c#6;
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume {:partition} LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} Seq#Contains(code#Z#0, $Box(c#6));
    goto anon14;

  anon43_Else:
    assume {:partition} !Seq#Contains(code#Z#0, $Box(c#6));
    goto anon14;

  anon42_Else:
    assume {:partition} !(LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__16());
    goto anon14;

  anon14:
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume {:partition} (exists c#8: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#8)] } { Seq#Contains(code#Z#0, $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#Z#0, $Box(c#8)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#8)]);
    ##code#0 := code#Z#0;
    assume $IsAlloc(##code#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#Z#0);
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == #Wrappers.Result.Failure($Box(JSON_mDeserializer.__default.UnsupportedEscape16(code#Z#0)));
    assume JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#Z#0);
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon44_Else:
    assume {:partition} !(exists c#8: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#8)] } { Seq#Contains(code#Z#0, $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#Z#0, $Box(c#8)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#8)]);
    havoc hd#Z#0;
    assume LitInt(0) <= hd#Z#0 && hd#Z#0 < BoundedInts.__default.TWO__TO__THE__16();
    ##str#0 := code#Z#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume {:subsumption 0} Seq#Length(##str#0) <= LitInt(4);
    assume Seq#Length(##str#0) <= LitInt(4);
    assume {:subsumption 0} (forall c#7: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#7)] } { Seq#Contains(##str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#0, $Box(c#7)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#7)]);
    assume (forall c#7: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#7)] } { Seq#Contains(##str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(##str#0, $Box(c#7)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#7)]);
    assume JSON_mDeserializer.__default.ToNat16#canCall(code#Z#0);
    assume let#2#0#0 == JSON_mDeserializer.__default.ToNat16(code#Z#0);
    assume JSON_mDeserializer.__default.ToNat16#canCall(code#Z#0);
    assume $Is(let#2#0#0, Tclass.BoundedInts.uint16());
    assume hd#Z#0 == let#2#0#0;
    ##str#1 := str#0;
    assume $IsAlloc(##str#1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(start#0 + 6, Tclass._System.nat());
    ##start#0 := start#0 + 6;
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    ##prefix#0 := Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#Z#0)));
    assume $IsAlloc(##prefix#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume 0 <= Seq#Length(str#0) - start#0 || Seq#Length(##str#1) - ##start#0 == Seq#Length(str#0) - start#0;
    assume Seq#Length(##str#1) - ##start#0 < Seq#Length(str#0) - start#0;
    assume JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#Z#0))));
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#Z#0))));
    assume JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#Z#0))));
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon40_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(117)));
    havoc unescaped#Z#0;
    assume LitInt(0) <= unescaped#Z#0 && unescaped#Z#0 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#4 := LitInt(34);
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume {:partition} c#Z#0 == LitInt(34);
    newtype$check#5 := LitInt(34);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#6 := LitInt(34);
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(34);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon45_Else:
    assume {:partition} c#Z#0 != LitInt(34);
    newtype$check#7 := LitInt(92);
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} c#Z#0 == LitInt(92);
    newtype$check#8 := LitInt(92);
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#9 := LitInt(92);
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(92);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon46_Else:
    assume {:partition} c#Z#0 != LitInt(92);
    newtype$check#10 := LitInt(98);
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} c#Z#0 == LitInt(98);
    newtype$check#11 := LitInt(8);
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#12 := LitInt(8);
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(8);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon47_Else:
    assume {:partition} c#Z#0 != LitInt(98);
    newtype$check#13 := LitInt(102);
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} c#Z#0 == LitInt(102);
    newtype$check#14 := LitInt(12);
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#15 := LitInt(12);
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(12);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon48_Else:
    assume {:partition} c#Z#0 != LitInt(102);
    newtype$check#16 := LitInt(110);
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume {:partition} c#Z#0 == LitInt(110);
    newtype$check#17 := LitInt(10);
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#18 := LitInt(10);
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(10);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon49_Else:
    assume {:partition} c#Z#0 != LitInt(110);
    newtype$check#19 := LitInt(114);
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume {:partition} c#Z#0 == LitInt(114);
    newtype$check#20 := LitInt(13);
    assume LitInt(0) <= newtype$check#20 && newtype$check#20 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#21 := LitInt(13);
    assume LitInt(0) <= newtype$check#21 && newtype$check#21 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(13);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon50_Else:
    assume {:partition} c#Z#0 != LitInt(114);
    newtype$check#22 := LitInt(116);
    assume LitInt(0) <= newtype$check#22 && newtype$check#22 < BoundedInts.__default.TWO__TO__THE__16();
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume {:partition} c#Z#0 == LitInt(116);
    newtype$check#23 := LitInt(9);
    assume LitInt(0) <= newtype$check#23 && newtype$check#23 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#24 := LitInt(9);
    assume LitInt(0) <= newtype$check#24 && newtype$check#24 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(9);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon51_Else:
    assume {:partition} c#Z#0 != LitInt(116);
    newtype$check#25 := LitInt(0);
    assume LitInt(0) <= newtype$check#25 && newtype$check#25 < BoundedInts.__default.TWO__TO__THE__16();
    newtype$check#26 := LitInt(0);
    assume LitInt(0) <= newtype$check#26 && newtype$check#26 < BoundedInts.__default.TWO__TO__THE__16();
    assume let#3#0#0 == LitInt(0);
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint16());
    goto anon32;

  anon32:
    assume unescaped#Z#0 == let#3#0#0;
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume {:partition} unescaped#Z#0 == LitInt(0);
    assume 0 <= start#0 && start#0 <= Seq#Length(str#0);
    assume start#0 <= start#0 + 2 && start#0 + 2 <= Seq#Length(str#0);
    ##code#1 := Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0);
    assume $IsAlloc(##code#1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0));
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == #Wrappers.Result.Failure($Box(JSON_mDeserializer.__default.UnsupportedEscape16(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0))));
    assume JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0));
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon52_Else:
    assume {:partition} unescaped#Z#0 != LitInt(0);
    ##str#2 := str#0;
    assume $IsAlloc(##str#2, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(start#0 + 2, Tclass._System.nat());
    ##start#1 := start#0 + 2;
    assume $IsAlloc(##start#1, Tclass._System.nat(), $Heap);
    ##prefix#1 := Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#Z#0)));
    assume $IsAlloc(##prefix#1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume 0 <= Seq#Length(str#0) - start#0 || Seq#Length(##str#2) - ##start#1 == Seq#Length(str#0) - start#0;
    assume Seq#Length(##str#2) - ##start#1 < Seq#Length(str#0) - start#0;
    assume JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#Z#0))));
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#Z#0))));
    assume JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#Z#0))));
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon38_Else:
    assume {:partition} $Unbox(Seq#Index(str#0, start#0)): int != char#ToInt(Lit(char#FromInt(92)));
    assume 0 <= start#0 && start#0 < Seq#Length(str#0);
    ##str#3 := str#0;
    assume $IsAlloc(##str#3, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(start#0 + 1, Tclass._System.nat());
    ##start#2 := start#0 + 1;
    assume $IsAlloc(##start#2, Tclass._System.nat(), $Heap);
    ##prefix#2 := Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0)));
    assume $IsAlloc(##prefix#2, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume 0 <= Seq#Length(str#0) - start#0 || Seq#Length(##str#3) - ##start#2 == Seq#Length(str#0) - start#0;
    assume Seq#Length(##str#3) - ##start#2 < Seq#Length(str#0) - start#0;
    assume JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))));
    assume JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0) == JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))));
    assume JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))));
    assume $Is(JSON_mDeserializer.__default.Unescape($LS($LZ), str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    return;
}



function JSON_mDeserializer.__default.String(js#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.String(js#0) } JSON_mDeserializer.__default.String#canCall(js#0) || (3 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jstring())) ==> $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError())));
axiom 3 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.String(js#0) } JSON_mDeserializer.__default.String#canCall(js#0) || (3 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jstring())) ==> JSON_mGrammar.jstring.JString_q(js#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.jstring.contents(js#0)) && UnicodeStrings.__default.FromUTF8Checked#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError0#0 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (var asUtf32#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): Seq; UnicodeStrings.__default.ToUTF16Checked#canCall(asUtf32#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError1#0 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) && (var asUint16#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0)): Seq; JSON_mDeserializer.__default.Unescape#canCall(asUint16#0, LitInt(0), Lit(Seq#Empty(): Seq)) && (var valueOrError2#0 := JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#0, LitInt(0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#0)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) && (var unescaped#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0)): Seq; UnicodeStrings.__default.FromUTF16Checked#canCall(unescaped#0) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))))))))))) && JSON_mDeserializer.__default.String(js#0) == (var valueOrError0#0 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#0) else (var asUtf32#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): Seq; (var valueOrError1#0 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#0) else (var asUint16#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0)): Seq; (var valueOrError2#0 := JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#0, LitInt(0), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#0) else (var unescaped#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0)): Seq; Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.String(Lit(js#0)) } JSON_mDeserializer.__default.String#canCall(Lit(js#0)) || (3 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jstring())) ==> JSON_mGrammar.jstring.JString_q(Lit(js#0)) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(JSON_mGrammar.jstring.contents(Lit(js#0)))) && UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0)))))) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF8Checked(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0))))))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError0#1 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF8Checked(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0))))))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (var asUtf32#1 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): Seq; UnicodeStrings.__default.ToUTF16Checked#canCall(asUtf32#1) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#1), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError1#1 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#1), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (var asUint16#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1)): Seq; JSON_mDeserializer.__default.Unescape#canCall(asUint16#1, LitInt(0), Lit(Seq#Empty(): Seq)) && (var valueOrError2#1 := JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#1, LitInt(0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) && (var unescaped#1 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1)): Seq; UnicodeStrings.__default.FromUTF16Checked#canCall(unescaped#1) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#1), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))))))))))) && JSON_mDeserializer.__default.String(Lit(js#0)) == (var valueOrError0#1 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF8Checked(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0))))))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#1) else (var asUtf32#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): Seq); (var valueOrError1#1 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(asUtf32#1)), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#1) else (var asUint16#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1)): Seq); (var valueOrError2#1 := Lit(JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#1, LitInt(0), Lit(Seq#Empty(): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#1) else (var unescaped#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1)): Seq); Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF16Checked(unescaped#1)), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))))))))))))));
}

function JSON_mDeserializer.__default.String#canCall(js#0: DatatypeType) : bool;

function JSON_mDeserializer.__default.String#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.String#requires(js#0) } $Is(js#0, Tclass.JSON_mGrammar.jstring()) ==> (JSON_mDeserializer.__default.String#requires(js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.String (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.String(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.jstring()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.String (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.String(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##bs#0: Seq;
  var ##error#0: DatatypeType;
  var asUtf32#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##s#0: Seq;
  var ##error#1: DatatypeType;
  var asUint16#Z#0: Seq;
  var let#3#0#0: Seq;
  var valueOrError2#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##str#0: Seq;
  var ##start#0: int;
  var ##prefix#0: Seq;
  var unescaped#Z#0: Seq;
  var let#5#0#0: Seq;
  var ##bs#1: Seq;
  var ##error#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.String", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(107,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mGrammar.jstring.JString_q(js#0);
    assume $IsAllocBox($Box(JSON_mGrammar.jstring.contents(js#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mGrammar.jstring.contents(js#0));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mGrammar.jstring.contents(js#0));
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.jstring.contents(js#0));
    ##bs#0 := JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume UnicodeStrings.__default.FromUTF8Checked#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0)));
    assume $IsAllocBox($Box(UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0)))), Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    ##error#0 := Lit(#JSON.Errors.DeserializationError.InvalidUnicode());
    assume $IsAlloc(##error#0, Tclass.JSON_mErrors.DeserializationError(), $Heap);
    assume Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume let#0#0#0 == Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume JSON_mGrammar.jstring.JString_q(js#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.jstring.contents(js#0)) && UnicodeStrings.__default.FromUTF8Checked#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#Z#0);
    assume JSON_mDeserializer.__default.String(js#0) == Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#Z#0);
    assume $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    havoc asUtf32#Z#0;
    assume $Is(asUtf32#Z#0, TSeq(TChar)) && $IsAlloc(asUtf32#Z#0, TSeq(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(TChar));
    assume asUtf32#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##s#0 := asUtf32#Z#0;
    assume $IsAlloc(##s#0, TSeq(TChar), $Heap);
    assume UnicodeStrings.__default.ToUTF16Checked#canCall(asUtf32#Z#0);
    assume $IsAllocBox($Box(UnicodeStrings.__default.ToUTF16Checked(asUtf32#Z#0)), Tclass.Wrappers.Option(TSeq(Tclass.BoundedInts.uint16())), $Heap);
    ##error#1 := Lit(#JSON.Errors.DeserializationError.InvalidUnicode());
    assume $IsAlloc(##error#1, Tclass.JSON_mErrors.DeserializationError(), $Heap);
    assume Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume let#2#0#0 == Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume UnicodeStrings.__default.ToUTF16Checked#canCall(asUtf32#Z#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#Z#0);
    assume JSON_mDeserializer.__default.String(js#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#Z#0);
    assume $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    havoc asUint16#Z#0;
    assume $Is(asUint16#Z#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(asUint16#Z#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, TSeq(Tclass.BoundedInts.uint16()));
    assume asUint16#Z#0 == let#3#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##str#0 := asUint16#Z#0;
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $Is(LitInt(0), Tclass._System.nat());
    ##start#0 := LitInt(0);
    assume $IsAlloc(##start#0, Tclass._System.nat(), $Heap);
    ##prefix#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##prefix#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume JSON_mDeserializer.__default.Unescape#canCall(asUint16#Z#0, LitInt(0), Lit(Seq#Empty(): Seq));
    assume let#4#0#0 == JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#Z#0, LitInt(0), Lit(Seq#Empty(): Seq));
    assume JSON_mDeserializer.__default.Unescape#canCall(asUint16#Z#0, LitInt(0), Lit(Seq#Empty(): Seq));
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError2#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#Z#0);
    assume JSON_mDeserializer.__default.String(js#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#Z#0);
    assume $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon13_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    havoc unescaped#Z#0;
    assume $Is(unescaped#Z#0, TSeq(Tclass.BoundedInts.uint16())) && $IsAlloc(unescaped#Z#0, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume $Is(let#5#0#0, TSeq(Tclass.BoundedInts.uint16()));
    assume unescaped#Z#0 == let#5#0#0;
    ##bs#1 := unescaped#Z#0;
    assume $IsAlloc(##bs#1, TSeq(Tclass.BoundedInts.uint16()), $Heap);
    assume UnicodeStrings.__default.FromUTF16Checked#canCall(unescaped#Z#0);
    assume $IsAllocBox($Box(UnicodeStrings.__default.FromUTF16Checked(unescaped#Z#0)), Tclass.Wrappers.Option(TSeq(TChar)), $Heap);
    ##error#2 := Lit(#JSON.Errors.DeserializationError.InvalidUnicode());
    assume $IsAlloc(##error#2, Tclass.JSON_mErrors.DeserializationError(), $Heap);
    assume Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume JSON_mDeserializer.__default.String(js#0) == Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume UnicodeStrings.__default.FromUTF16Checked#canCall(unescaped#Z#0) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())));
    assume $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    return;
}



function JSON_mDeserializer.__default.DIGITS() : Map
uses {
axiom JSON_mDeserializer.__default.DIGITS(): Map == Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Build(Map#Empty(): Map, $Box(char#ToInt(Lit(char#FromInt(48)))), $Box(LitInt(0))), $Box(char#ToInt(Lit(char#FromInt(49)))), $Box(LitInt(1))), $Box(char#ToInt(Lit(char#FromInt(50)))), $Box(LitInt(2))), $Box(char#ToInt(Lit(char#FromInt(51)))), $Box(LitInt(3))), $Box(char#ToInt(Lit(char#FromInt(52)))), $Box(LitInt(4))), $Box(char#ToInt(Lit(char#FromInt(53)))), $Box(LitInt(5))), $Box(char#ToInt(Lit(char#FromInt(54)))), $Box(LitInt(6))), $Box(char#ToInt(Lit(char#FromInt(55)))), $Box(LitInt(7))), $Box(char#ToInt(Lit(char#FromInt(56)))), $Box(LitInt(8))), $Box(char#ToInt(Lit(char#FromInt(57)))), $Box(LitInt(9)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), TInt));
}

procedure {:verboseName "JSON.Deserializer.DIGITS (well-formedness)"} CheckWellFormed$$JSON_mDeserializer.__default.DIGITS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.DIGITS (well-formedness)"} CheckWellFormed$$JSON_mDeserializer.__default.DIGITS()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var newtype$check#12: int;
  var newtype$check#13: int;
  var newtype$check#14: int;
  var newtype$check#15: int;
  var newtype$check#16: int;
  var newtype$check#17: int;
  var newtype$check#18: int;
  var newtype$check#19: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.DIGITS"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(119,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2 := char#ToInt(Lit(char#FromInt(49)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(49)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := char#ToInt(Lit(char#FromInt(50)));
    assume LitInt(0) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(50)));
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#6 := char#ToInt(Lit(char#FromInt(51)));
    assume LitInt(0) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(51)));
    assume LitInt(0) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#8 := char#ToInt(Lit(char#FromInt(52)));
    assume LitInt(0) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#9 := char#ToInt(Lit(char#FromInt(52)));
    assume LitInt(0) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#10 := char#ToInt(Lit(char#FromInt(53)));
    assume LitInt(0) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#11 := char#ToInt(Lit(char#FromInt(53)));
    assume LitInt(0) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#12 := char#ToInt(Lit(char#FromInt(54)));
    assume LitInt(0) <= newtype$check#12 && newtype$check#12 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#13 := char#ToInt(Lit(char#FromInt(54)));
    assume LitInt(0) <= newtype$check#13 && newtype$check#13 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#14 := char#ToInt(Lit(char#FromInt(55)));
    assume LitInt(0) <= newtype$check#14 && newtype$check#14 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#15 := char#ToInt(Lit(char#FromInt(55)));
    assume LitInt(0) <= newtype$check#15 && newtype$check#15 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#16 := char#ToInt(Lit(char#FromInt(56)));
    assume LitInt(0) <= newtype$check#16 && newtype$check#16 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#17 := char#ToInt(Lit(char#FromInt(56)));
    assume LitInt(0) <= newtype$check#17 && newtype$check#17 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#18 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#18 && newtype$check#18 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#19 := char#ToInt(Lit(char#FromInt(57)));
    assume LitInt(0) <= newtype$check#19 && newtype$check#19 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), TInt), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), TInt), $h));

function JSON_mDeserializer.__default.MINUS() : int
uses {
axiom JSON_mDeserializer.__default.MINUS(): int == char#ToInt(Lit(char#FromInt(45)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mDeserializer.__default.MINUS(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.Deserializer.MINUS (well-formedness)"} CheckWellFormed$$JSON_mDeserializer.__default.MINUS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.MINUS (well-formedness)"} CheckWellFormed$$JSON_mDeserializer.__default.MINUS()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.MINUS"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(126,8): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mDeserializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mDeserializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h));

function JSON_mDeserializer.__default.ToInt(sign#0: DatatypeType, n#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall sign#0: DatatypeType, n#0: DatatypeType :: { JSON_mDeserializer.__default.ToInt(sign#0, n#0) } JSON_mDeserializer.__default.ToInt#canCall(sign#0, n#0) || (1 < $FunctionContextHeight && $Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum())) ==> $Is(JSON_mDeserializer.__default.ToInt(sign#0, n#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError())));
axiom 1 <= $FunctionContextHeight ==> (forall sign#0: DatatypeType, n#0: DatatypeType :: { JSON_mDeserializer.__default.ToInt(sign#0, n#0) } JSON_mDeserializer.__default.ToInt#canCall(sign#0, n#0) || (1 < $FunctionContextHeight && $Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(n#0) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS()) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall(sign#0, Lit(char#FromInt(45))) && JSON_mDeserializer.__default.ToInt(sign#0, n#0) == (var n#1 := JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS()); #Wrappers.Result.Success($Box((if JSON_mUtils_mViews_mCore.View__.Char_q(sign#0, Lit(char#FromInt(45))) then 0 - n#1 else n#1)))));
axiom 1 <= $FunctionContextHeight ==> (forall sign#0: DatatypeType, n#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.ToInt(Lit(sign#0), Lit(n#0)) } JSON_mDeserializer.__default.ToInt#canCall(Lit(sign#0), Lit(n#0)) || (1 < $FunctionContextHeight && $Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(n#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(n#0))), LitInt(10), JSON_mDeserializer.__default.DIGITS()) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall(Lit(sign#0), Lit(char#FromInt(45))) && JSON_mDeserializer.__default.ToInt(Lit(sign#0), Lit(n#0)) == (var n#2 := JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(n#0))), LitInt(10), JSON_mDeserializer.__default.DIGITS()); #Wrappers.Result.Success($Box((if JSON_mUtils_mViews_mCore.View__.Char_q(Lit(sign#0), Lit(char#FromInt(45))) then 0 - n#2 else n#2)))));
}

function JSON_mDeserializer.__default.ToInt#canCall(sign#0: DatatypeType, n#0: DatatypeType) : bool;

function JSON_mDeserializer.__default.ToInt#requires(DatatypeType, DatatypeType) : bool;

axiom (forall sign#0: DatatypeType, n#0: DatatypeType :: { JSON_mDeserializer.__default.ToInt#requires(sign#0, n#0) } $Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum()) ==> (JSON_mDeserializer.__default.ToInt#requires(sign#0, n#0) <==> true));

procedure {:verboseName "JSON.Deserializer.ToInt (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.ToInt(sign#0: DatatypeType where $Is(sign#0, Tclass.JSON_mGrammar.jsign()), n#0: DatatypeType where $Is(n#0, Tclass.JSON_mGrammar.jnum()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.ToInt (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.ToInt(sign#0: DatatypeType, n#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var n#Z#0: int;
  var let#0#0#0: int;
  var ##str#0: Seq;
  var ##base#0: int;
  var ##digits#0: Map;
  var ##c#0: char;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ToInt", " | ", sign#0, " | ", n#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(128,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mDeserializer.__default.ToInt(sign#0, n#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon7_Else:
    havoc n#Z#0;
    assume true;
    assume $IsAllocBox($Box(n#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(n#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(n#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(n#0);
    ##str#0 := JSON_mUtils_mViews_mCore.View__.Bytes(n#0);
    assume $IsAlloc(##str#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume $Is(LitInt(10), Tclass._System.nat());
    ##base#0 := LitInt(10);
    assume $IsAlloc(##base#0, Tclass._System.nat(), $Heap);
    assume $Is(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()));
    ##digits#0 := JSON_mDeserializer.__default.DIGITS();
    assume $IsAlloc(##digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat()), $Heap);
    assume {:subsumption 0} ##base#0 > 0;
    assume ##base#0 > 0;
    assume {:subsumption 0} (forall c#0: int :: { Map#Domain(##digits#0)[$Box(c#0)] } { Seq#Contains(##str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#0, $Box(c#0)) ==> Map#Domain(##digits#0)[$Box(c#0)]);
    assume (forall c#0: int :: { Map#Domain(##digits#0)[$Box(c#0)] } { Seq#Contains(##str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##str#0, $Box(c#0)) ==> Map#Domain(##digits#0)[$Box(c#0)]);
    assume JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS());
    assume let#0#0#0 == JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS());
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(n#0) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS());
    assume $Is(let#0#0#0, TInt);
    assume n#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(sign#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(45));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(sign#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(sign#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(sign#0, Lit(char#FromInt(45)));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Char_q(sign#0, Lit(char#FromInt(45)));
    goto anon6;

  anon8_Else:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Char_q(sign#0, Lit(char#FromInt(45)));
    goto anon6;

  anon6:
    assume JSON_mDeserializer.__default.ToInt(sign#0, n#0) == #Wrappers.Result.Success($Box((if JSON_mUtils_mViews_mCore.View__.Char_q(sign#0, Lit(char#FromInt(45))) then 0 - n#Z#0 else n#Z#0)));
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(sign#0, Lit(char#FromInt(45)));
    assume $Is(JSON_mDeserializer.__default.ToInt(sign#0, n#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()));
    return;
}



function JSON_mDeserializer.__default.Number(js#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Number(js#0) } JSON_mDeserializer.__default.Number#canCall(js#0) || (2 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jnumber())) ==> $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError())));
axiom 2 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Number(js#0) } JSON_mDeserializer.__default.Number#canCall(js#0) || (2 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jnumber())) ==> (var minus#0, num#0, frac#0, exp#0 := JSON_mGrammar.jnumber.minus(js#0), JSON_mGrammar.jnumber.num(js#0), JSON_mGrammar.jnumber.frac(js#0), JSON_mGrammar.jnumber.exp(js#0); JSON_mDeserializer.__default.ToInt#canCall(minus#0, num#0) && (var valueOrError0#0 := JSON_mDeserializer.__default.ToInt(minus#0, num#0); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (!JSON_mGrammar.Maybe.Empty_q(exp#0) ==> JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType) && (var num#3 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType); JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType) && (var sign#1 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType); JSON_mDeserializer.__default.ToInt#canCall(sign#1, num#3)))) && (var valueOrError1#0 := (if JSON_mGrammar.Maybe.Empty_q(exp#0) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#5 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType); (var sign#2 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#2, num#5)))); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#0)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) && (!JSON_mGrammar.Maybe.Empty_q(frac#0) ==> JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(frac#0)): DatatypeType) && (var num#4 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#0)): DatatypeType); JSON_mUtils_mViews_mCore.View__.Length#canCall(num#4) && (var pow10#1 := JSON_mUtils_mViews_mCore.View__.Length(num#4); JSON_mDeserializer.__default.ToInt#canCall(minus#0, num#4) && (var valueOrError2#1 := JSON_mDeserializer.__default.ToInt(minus#0, num#4); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#1)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) && Power.__default.Pow#canCall(LitInt(10), pow10#1))))))))))) && JSON_mDeserializer.__default.Number(js#0) == (var minus#0, num#0, frac#0, exp#0 := JSON_mGrammar.jnumber.minus(js#0), JSON_mGrammar.jnumber.num(js#0), JSON_mGrammar.jnumber.frac(js#0), JSON_mGrammar.jnumber.exp(js#0); (var valueOrError0#0 := JSON_mDeserializer.__default.ToInt(minus#0, num#0); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#0) else (var n#0 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): int; (var valueOrError1#0 := (if JSON_mGrammar.Maybe.Empty_q(exp#0) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#1 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType); (var sign#0 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#0)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#0, num#1)))); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#0) else (var e10#0 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0)): int; (if JSON_mGrammar.Maybe.Empty_q(frac#0) then #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(n#0, e10#0))) else (var num#2 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#0)): DatatypeType); (var pow10#0 := JSON_mUtils_mViews_mCore.View__.Length(num#2); (var valueOrError2#0 := JSON_mDeserializer.__default.ToInt(minus#0, num#2); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#0) else (var frac#1 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0)): int; #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(Mul(n#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(10), pow10#0)) + frac#1, e10#0 - pow10#0)))))))))))))))));
axiom 2 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Number(Lit(js#0)) } JSON_mDeserializer.__default.Number#canCall(Lit(js#0)) || (2 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jnumber())) ==> (var minus#1, num#6, frac#3, exp#1 := JSON_mGrammar.jnumber.minus(Lit(js#0)), JSON_mGrammar.jnumber.num(Lit(js#0)), JSON_mGrammar.jnumber.frac(Lit(js#0)), JSON_mGrammar.jnumber.exp(Lit(js#0)); JSON_mDeserializer.__default.ToInt#canCall(minus#1, num#6) && (var valueOrError0#1 := JSON_mDeserializer.__default.ToInt(minus#1, num#6); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (!JSON_mGrammar.Maybe.Empty_q(exp#1) ==> JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType) && (var num#9 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType); JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType) && (var sign#4 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType); JSON_mDeserializer.__default.ToInt#canCall(sign#4, num#9)))) && (var valueOrError1#1 := (if JSON_mGrammar.Maybe.Empty_q(exp#1) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#11 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType); (var sign#5 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#5, num#11)))); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (!JSON_mGrammar.Maybe.Empty_q(frac#3) ==> JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(frac#3)): DatatypeType) && (var num#10 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#3)): DatatypeType); JSON_mUtils_mViews_mCore.View__.Length#canCall(num#10) && (var pow10#3 := JSON_mUtils_mViews_mCore.View__.Length(num#10); JSON_mDeserializer.__default.ToInt#canCall(minus#1, num#10) && (var valueOrError2#3 := JSON_mDeserializer.__default.ToInt(minus#1, num#10); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#3)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) && Power.__default.Pow#canCall(LitInt(10), pow10#3))))))))))) && JSON_mDeserializer.__default.Number(Lit(js#0)) == (var minus#1, num#6, frac#3, exp#1 := JSON_mGrammar.jnumber.minus(Lit(js#0)), JSON_mGrammar.jnumber.num(Lit(js#0)), JSON_mGrammar.jnumber.frac(Lit(js#0)), JSON_mGrammar.jnumber.exp(Lit(js#0)); (var valueOrError0#1 := JSON_mDeserializer.__default.ToInt(minus#1, num#6); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#1) else (var n#1 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): int; (var valueOrError1#1 := (if JSON_mGrammar.Maybe.Empty_q(exp#1) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#7 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType); (var sign#3 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#1)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#3, num#7)))); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#1) else (var e10#1 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1)): int; (if JSON_mGrammar.Maybe.Empty_q(frac#3) then #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(n#1, e10#1))) else (var num#8 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#3)): DatatypeType); (var pow10#2 := JSON_mUtils_mViews_mCore.View__.Length(num#8); (var valueOrError2#2 := JSON_mDeserializer.__default.ToInt(minus#1, num#8); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#2) else (var frac#4 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2)): int; #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(Mul(n#1, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(10), pow10#2)) + frac#4, e10#1 - pow10#2)))))))))))))))));
}

function JSON_mDeserializer.__default.Number#canCall(js#0: DatatypeType) : bool;

function JSON_mDeserializer.__default.Number#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Number#requires(js#0) } $Is(js#0, Tclass.JSON_mGrammar.jnumber()) ==> (JSON_mDeserializer.__default.Number#requires(js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Number (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Number(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.jnumber()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Number (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Number(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var minus#Z#0: DatatypeType;
  var num#Z#0: DatatypeType;
  var frac#Z#0: DatatypeType;
  var exp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##sign#0: DatatypeType;
  var ##n#0: DatatypeType;
  var n#Z#0: int;
  var let#2#0#0: int;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var _mcc#0#0: DatatypeType;
  var _mcc#1#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var _mcc#3#0: DatatypeType;
  var num#Z#1: DatatypeType;
  var let#4#0#0: DatatypeType;
  var sign#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##sign#1: DatatypeType;
  var ##n#1: DatatypeType;
  var e10#Z#0: int;
  var let#6#0#0: int;
  var _mcc#4#0: DatatypeType;
  var _mcc#5#0: DatatypeType;
  var _mcc#6#0: DatatypeType;
  var num#Z#2: DatatypeType;
  var let#7#0#0: DatatypeType;
  var pow10#Z#0: int;
  var let#8#0#0: int;
  var valueOrError2#Z#0: DatatypeType;
  var let#9#0#0: DatatypeType;
  var ##sign#2: DatatypeType;
  var ##n#2: DatatypeType;
  var frac#Z#1: int;
  var let#10#0#0: int;
  var ##b#0: int;
  var ##e#0: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Number", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(133,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon21_Else:
    havoc minus#Z#0;
    havoc num#Z#0;
    havoc frac#Z#0;
    havoc exp#Z#0;
    assume $Is(minus#Z#0, Tclass.JSON_mGrammar.jminus()) && $IsAlloc(minus#Z#0, Tclass.JSON_mGrammar.jminus(), $Heap) && $Is(num#Z#0, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnum(), $Heap) && $Is(frac#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $IsAlloc(frac#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap) && $Is(exp#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())) && $IsAlloc(exp#Z#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    assume let#0#0#0 == js#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.jnumber());
    assume JSON_mGrammar.jnumber.JNumber_q(let#0#0#0);
    assume #JSON.Grammar.jnumber.JNumber(minus#Z#0, num#Z#0, frac#Z#0, exp#Z#0) == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume $Is(minus#Z#0, Tclass.JSON_mGrammar.jsign());
    ##sign#0 := minus#Z#0;
    assume $IsAlloc(##sign#0, Tclass.JSON_mGrammar.jsign(), $Heap);
    ##n#0 := num#Z#0;
    assume $IsAlloc(##n#0, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume JSON_mDeserializer.__default.ToInt#canCall(minus#Z#0, num#Z#0);
    assume let#1#0#0 == JSON_mDeserializer.__default.ToInt(minus#Z#0, num#Z#0);
    assume JSON_mDeserializer.__default.ToInt#canCall(minus#Z#0, num#Z#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#Z#0);
    assume JSON_mDeserializer.__default.Number(js#0) == Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#Z#0);
    assume $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon22_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    havoc n#Z#0;
    assume true;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): int;
    assume Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $Is(let#2#0#0, TInt);
    assume n#Z#0 == let#2#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} exp#Z#0 == #JSON.Grammar.Maybe.Empty();
    assume let#3#0#0 == Lit(#Wrappers.Result.Success($Box(LitInt(0))));
    assume true;
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()));
    goto anon11;

  anon23_Else:
    assume {:partition} exp#Z#0 != #JSON.Grammar.Maybe.Empty();
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} exp#Z#0 == #JSON.Grammar.Maybe.NonEmpty($Box(_mcc#0#0));
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jexp());
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} _mcc#0#0 == #JSON.Grammar.jexp.JExp(_mcc#1#0, _mcc#2#0, _mcc#3#0);
    assume $Is(_mcc#1#0, Tclass.JSON_mGrammar.je());
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jsign());
    assume $Is(_mcc#3#0, Tclass.JSON_mGrammar.jnum());
    havoc num#Z#1;
    assume $Is(num#Z#1, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#1, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume let#4#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mGrammar.jnum());
    assume num#Z#1 == let#4#0#0;
    havoc sign#Z#0;
    assume $Is(sign#Z#0, Tclass.JSON_mGrammar.jsign()) && $IsAlloc(sign#Z#0, Tclass.JSON_mGrammar.jsign(), $Heap);
    assume let#5#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.JSON_mGrammar.jsign());
    assume sign#Z#0 == let#5#0#0;
    ##sign#1 := sign#Z#0;
    assume $IsAlloc(##sign#1, Tclass.JSON_mGrammar.jsign(), $Heap);
    ##n#1 := num#Z#1;
    assume $IsAlloc(##n#1, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume JSON_mDeserializer.__default.ToInt#canCall(sign#Z#0, num#Z#1);
    assume let#3#0#0 == JSON_mDeserializer.__default.ToInt(sign#Z#0, num#Z#1);
    assume JSON_mDeserializer.__default.ToInt#canCall(sign#Z#0, num#Z#1);
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()));
    goto anon11;

  anon25_Else:
    assume {:partition} _mcc#0#0 != #JSON.Grammar.jexp.JExp(_mcc#1#0, _mcc#2#0, _mcc#3#0);
    assume false;
    goto anon11;

  anon24_Else:
    assume {:partition} exp#Z#0 != #JSON.Grammar.Maybe.NonEmpty($Box(_mcc#0#0));
    assume false;
    goto anon11;

  anon11:
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#Z#0);
    assume JSON_mDeserializer.__default.Number(js#0) == Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#Z#0);
    assume $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon26_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    havoc e10#Z#0;
    assume true;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0)): int;
    assume Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $Is(let#6#0#0, TInt);
    assume e10#Z#0 == let#6#0#0;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} frac#Z#0 == #JSON.Grammar.Maybe.Empty();
    assume JSON_mDeserializer.__default.Number(js#0) == #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(n#Z#0, e10#Z#0)));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon27_Else:
    assume {:partition} frac#Z#0 != #JSON.Grammar.Maybe.Empty();
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} frac#Z#0 == #JSON.Grammar.Maybe.NonEmpty($Box(_mcc#4#0));
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.jfrac());
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} _mcc#4#0 == #JSON.Grammar.jfrac.JFrac(_mcc#5#0, _mcc#6#0);
    assume $Is(_mcc#5#0, Tclass.JSON_mGrammar.jperiod());
    assume $Is(_mcc#6#0, Tclass.JSON_mGrammar.jnum());
    havoc num#Z#2;
    assume $Is(num#Z#2, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#2, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume let#7#0#0 == _mcc#6#0;
    assume true;
    assume $Is(let#7#0#0, Tclass.JSON_mGrammar.jnum());
    assume num#Z#2 == let#7#0#0;
    havoc pow10#Z#0;
    assume true;
    assume $IsAllocBox($Box(num#Z#2), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(num#Z#2);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(num#Z#2);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(num#Z#2);
    assume let#8#0#0 == JSON_mUtils_mViews_mCore.View__.Length(num#Z#2);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(num#Z#2);
    assume $Is(let#8#0#0, TInt);
    assume pow10#Z#0 == let#8#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume $Is(minus#Z#0, Tclass.JSON_mGrammar.jsign());
    ##sign#2 := minus#Z#0;
    assume $IsAlloc(##sign#2, Tclass.JSON_mGrammar.jsign(), $Heap);
    ##n#2 := num#Z#2;
    assume $IsAlloc(##n#2, Tclass.JSON_mGrammar.jnum(), $Heap);
    assume JSON_mDeserializer.__default.ToInt#canCall(minus#Z#0, num#Z#2);
    assume let#9#0#0 == JSON_mDeserializer.__default.ToInt(minus#Z#0, num#Z#2);
    assume JSON_mDeserializer.__default.ToInt#canCall(minus#Z#0, num#Z#2);
    assume $Is(let#9#0#0, Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError2#Z#0 == let#9#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#Z#0);
    assume JSON_mDeserializer.__default.Number(js#0) == Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#Z#0);
    assume $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon30_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    havoc frac#Z#1;
    assume true;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume let#10#0#0 == $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0)): int;
    assume Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume $Is(let#10#0#0, TInt);
    assume frac#Z#1 == let#10#0#0;
    ##b#0 := LitInt(10);
    assume $IsAlloc(##b#0, TInt, $Heap);
    assume $Is(pow10#Z#0, Tclass._System.nat());
    ##e#0 := pow10#Z#0;
    assume $IsAlloc(##e#0, Tclass._System.nat(), $Heap);
    assume Power.__default.Pow#canCall(LitInt(10), pow10#Z#0);
    assume JSON_mDeserializer.__default.Number(js#0) == #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(Mul(n#Z#0, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(10), pow10#Z#0)) + frac#Z#1, e10#Z#0 - pow10#Z#0)));
    assume Power.__default.Pow#canCall(LitInt(10), pow10#Z#0);
    assume $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon29_Else:
    assume {:partition} _mcc#4#0 != #JSON.Grammar.jfrac.JFrac(_mcc#5#0, _mcc#6#0);
    assume false;
    return;

  anon28_Else:
    assume {:partition} frac#Z#0 != #JSON.Grammar.Maybe.NonEmpty($Box(_mcc#4#0));
    assume false;
    return;
}



function JSON_mDeserializer.__default.KeyValue($ly: LayerType, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue($ly, js#0) } JSON_mDeserializer.__default.KeyValue#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jKeyValue())) ==> $Is(JSON_mDeserializer.__default.KeyValue($ly, js#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue($LS($ly), js#0) } JSON_mDeserializer.__default.KeyValue#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jKeyValue())) ==> JSON_mGrammar.jKeyValue.KeyValue_q(js#0) && JSON_mDeserializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k(js#0)) && (var valueOrError0#0 := JSON_mDeserializer.__default.String(JSON_mGrammar.jKeyValue.k(js#0)); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && JSON_mGrammar.jKeyValue.KeyValue_q(js#0) && JSON_mDeserializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(js#0)) && (var valueOrError1#0 := JSON_mDeserializer.__default.Value($ly, JSON_mGrammar.jKeyValue.v(js#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0))))) && JSON_mDeserializer.__default.KeyValue($LS($ly), js#0) == (var valueOrError0#0 := JSON_mDeserializer.__default.String(JSON_mGrammar.jKeyValue.k(js#0)); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#0) else (var k#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): Seq; (var valueOrError1#0 := JSON_mDeserializer.__default.Value($ly, JSON_mGrammar.jKeyValue.v(js#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#0) else (var v#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(k#0), $Box(v#0)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.KeyValue($LS($ly), Lit(js#0)) } JSON_mDeserializer.__default.KeyValue#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.jKeyValue())) ==> JSON_mGrammar.jKeyValue.KeyValue_q(Lit(js#0)) && JSON_mDeserializer.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit(js#0)))) && (var valueOrError0#1 := Lit(JSON_mDeserializer.__default.String(Lit(JSON_mGrammar.jKeyValue.k(Lit(js#0))))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit(js#0)) && JSON_mDeserializer.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit(js#0)))) && (var valueOrError1#1 := Lit(JSON_mDeserializer.__default.Value($LS($ly), Lit(JSON_mGrammar.jKeyValue.v(Lit(js#0))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1))))) && JSON_mDeserializer.__default.KeyValue($LS($ly), Lit(js#0)) == (var valueOrError0#1 := Lit(JSON_mDeserializer.__default.String(Lit(JSON_mGrammar.jKeyValue.k(Lit(js#0))))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#1) else (var k#1 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): Seq); (var valueOrError1#1 := Lit(JSON_mDeserializer.__default.Value($LS($ly), Lit(JSON_mGrammar.jKeyValue.v(Lit(js#0))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#1) else (var v#1 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#_System._tuple#2._#Make2($Box(k#1), $Box(v#1)))))))))))));
}

function JSON_mDeserializer.__default.KeyValue#canCall(js#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue($LS($ly), js#0) } JSON_mDeserializer.__default.KeyValue($LS($ly), js#0) == JSON_mDeserializer.__default.KeyValue($ly, js#0));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue(AsFuelBottom($ly), js#0) } JSON_mDeserializer.__default.KeyValue($ly, js#0) == JSON_mDeserializer.__default.KeyValue($LZ, js#0));

function JSON_mDeserializer.__default.KeyValue#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue#requires($ly, js#0) } $Is(js#0, Tclass.JSON_mGrammar.jKeyValue()) ==> (JSON_mDeserializer.__default.KeyValue#requires($ly, js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.KeyValue (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.KeyValue(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.jKeyValue()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.KeyValue (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.KeyValue(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##js#0: DatatypeType;
  var k#Z#0: Seq;
  var let#1#0#0: Seq;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##js#1: DatatypeType;
  var v#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.KeyValue", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(148,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon8_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mGrammar.jKeyValue.KeyValue_q(js#0);
    ##js#0 := JSON_mGrammar.jKeyValue.k(js#0);
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mDeserializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k(js#0));
    assume let#0#0#0 == JSON_mDeserializer.__default.String(JSON_mGrammar.jKeyValue.k(js#0));
    assume JSON_mGrammar.jKeyValue.KeyValue_q(js#0) && JSON_mDeserializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k(js#0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#Z#0);
    assume JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#Z#0);
    assume $Is(JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon9_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    havoc k#Z#0;
    assume $Is(k#Z#0, TSeq(TChar)) && $IsAlloc(k#Z#0, TSeq(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, TSeq(TChar));
    assume k#Z#0 == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mGrammar.jKeyValue.KeyValue_q(js#0);
    ##js#1 := JSON_mGrammar.jKeyValue.v(js#0);
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume DtRank(##js#1) < DtRank(js#0);
    assume JSON_mDeserializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(js#0));
    assume let#2#0#0 == JSON_mDeserializer.__default.Value($LS($LZ), JSON_mGrammar.jKeyValue.v(js#0));
    assume JSON_mGrammar.jKeyValue.KeyValue_q(js#0) && JSON_mDeserializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(js#0));
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#Z#0);
    assume JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#Z#0);
    assume $Is(JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    havoc v#Z#0;
    assume $Is(v#Z#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(v#Z#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $Is(let#3#0#0, Tclass.JSON_mValues.JSON());
    assume v#Z#0 == let#3#0#0;
    assume JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(k#Z#0), $Box(v#Z#0))));
    assume true;
    assume $Is(JSON_mDeserializer.__default.KeyValue($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    return;
}



function JSON_mDeserializer.__default.Object($ly: LayerType, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object($ly, js#0) } JSON_mDeserializer.__default.Object#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> $Is(JSON_mDeserializer.__default.Object($ly, js#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object($LS($ly), js#0), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Object#canCall(js#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> (forall $l#1#d#0: DatatypeType :: $Is($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(js#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box($l#1#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#1#d#0) && JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#1#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(js#0) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#2#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#2#d#0): DatatypeType)): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $IsBox($l#2#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#2#d#0)), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)) && JSON_mDeserializer.__default.Object($LS($ly), js#0) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#0#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#0#d#0): DatatypeType)): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $IsBox($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#0#d#0)), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Object($LS($ly), Lit(js#0)), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Object#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> (forall $l#4#d#0: DatatypeType :: $Is($l#4#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && (Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $Box($l#4#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#4#d#0) && JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#4#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#5#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#5#d#0): DatatypeType)): DatatypeType))), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $IsBox($l#5#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#5#d#0)), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))) && JSON_mDeserializer.__default.Object($LS($ly), Lit(js#0)) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#3#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#3#d#0): DatatypeType)): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $IsBox($l#3#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#3#d#0)), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))));
}

function JSON_mDeserializer.__default.Object#canCall(js#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object($LS($ly), js#0) } JSON_mDeserializer.__default.Object($LS($ly), js#0) == JSON_mDeserializer.__default.Object($ly, js#0));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object(AsFuelBottom($ly), js#0) } JSON_mDeserializer.__default.Object($ly, js#0) == JSON_mDeserializer.__default.Object($LZ, js#0));

function JSON_mDeserializer.__default.Object#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object#requires($ly, js#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (JSON_mDeserializer.__default.Object#requires($ly, js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Object (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Object(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Object (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Object(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var d#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##js#0: DatatypeType;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Object", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(154,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mDeserializer.__default.Object($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume JSON_mGrammar.Bracketed.Bracketed_q(js#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box(d#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(d#0);
    ##js#0 := $Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.jKeyValue(), $lambdaHeap#0);
    assume DtRank(##js#0) < DtRank(js#0);
    assume JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType);
    assume lambdaResult#0 == JSON_mDeserializer.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(d#0) && JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType);
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon7;

  anon12_Else:
    assume {:partition} !Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box(d#0));
    goto anon7;

  anon11_Else:
    assume {:partition} !($Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon10_Else:
    goto anon8;

  anon8:
    assume JSON_mGrammar.Bracketed.Bracketed_q(js#0);
    ##f#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#7#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#7#d#0): DatatypeType)): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $IsBox($l#7#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#7#d#0)), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##xs#0 := JSON_mGrammar.Bracketed.data(js#0);
    assume $IsAlloc(##xs#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#8#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#8#d#0): DatatypeType)): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $IsBox($l#8#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#8#d#0)), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), JSON_mGrammar.Bracketed.data(js#0));
    assume JSON_mDeserializer.__default.Object($LS($LZ), js#0) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#10#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#10#d#0): DatatypeType)): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $IsBox($l#10#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#10#d#0)), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), JSON_mGrammar.Bracketed.data(js#0));
    assume (forall $l#11#d#0: DatatypeType :: $Is($l#11#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(js#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box($l#11#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#11#d#0) && JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#11#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(js#0) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#12#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#12#d#0): DatatypeType)): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $IsBox($l#12#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#12#d#0)), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), JSON_mGrammar.Bracketed.data(js#0));
    assume $Is(JSON_mDeserializer.__default.Object($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()));
    assume b$reqreads#0;
    return;
}



function JSON_mDeserializer.__default.Array($ly: LayerType, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array($ly, js#0) } JSON_mDeserializer.__default.Array#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> $Is(JSON_mDeserializer.__default.Array($ly, js#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array($LS($ly), js#0), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Array#canCall(js#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> (forall $l#1#d#0: DatatypeType :: $Is($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(js#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box($l#1#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#1#d#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#1#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(js#0) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#2#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#2#d#0): DatatypeType)): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $IsBox($l#2#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#2#d#0)), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)) && JSON_mDeserializer.__default.Array($LS($ly), js#0) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#0#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#0#d#0): DatatypeType)): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $IsBox($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#0#d#0)), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Array($LS($ly), Lit(js#0)), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Array#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> (forall $l#4#d#0: DatatypeType :: $Is($l#4#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && (Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $Box($l#4#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#4#d#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#4#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#5#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#5#d#0): DatatypeType)): DatatypeType))), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $IsBox($l#5#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#5#d#0)), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))) && JSON_mDeserializer.__default.Array($LS($ly), Lit(js#0)) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#3#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#3#d#0): DatatypeType)): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $IsBox($l#3#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#3#d#0)), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))));
}

function JSON_mDeserializer.__default.Array#canCall(js#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array($LS($ly), js#0) } JSON_mDeserializer.__default.Array($LS($ly), js#0) == JSON_mDeserializer.__default.Array($ly, js#0));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array(AsFuelBottom($ly), js#0) } JSON_mDeserializer.__default.Array($ly, js#0) == JSON_mDeserializer.__default.Array($LZ, js#0));

function JSON_mDeserializer.__default.Array#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array#requires($ly, js#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (JSON_mDeserializer.__default.Array#requires($ly, js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Array (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Array(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Array (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Array(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var d#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##js#0: DatatypeType;
  var ##f#0: HandleType;
  var ##xs#0: Seq;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Array", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(158,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mDeserializer.__default.Array($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume JSON_mGrammar.Bracketed.Bracketed_q(js#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box(d#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(d#0);
    ##js#0 := $Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#0);
    assume DtRank(##js#0) < DtRank(js#0);
    assume JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType);
    assume lambdaResult#0 == JSON_mDeserializer.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(d#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(d#0)): DatatypeType);
    assume $Is(lambdaResult#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    goto anon7;

  anon12_Else:
    assume {:partition} !Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box(d#0));
    goto anon7;

  anon11_Else:
    assume {:partition} !($Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon10_Else:
    goto anon8;

  anon8:
    assume JSON_mGrammar.Bracketed.Bracketed_q(js#0);
    ##f#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#7#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#7#d#0): DatatypeType)): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $IsBox($l#7#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#7#d#0)), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##f#0, Tclass._System.___hFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##xs#0 := JSON_mGrammar.Bracketed.data(js#0);
    assume $IsAlloc(##xs#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    assume (forall i#0: int :: { $Unbox(Seq#Index(##xs#0, i#0)): DatatypeType } LitInt(0) <= i#0 && i#0 < Seq#Length(##xs#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#0)));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && (exists i#1: int, o#0: ref :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] } $Is(o#0, Tclass._System.object?()) && LitInt(0) <= i#1 && i#1 < Seq#Length(##xs#0) && Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()), $Heap, ##f#0, Seq#Index(##xs#0, i#1))[$Box(o#0)] && $Box($o) == $Box(o#0)) ==> $_ReadsFrame[$o, $f]);
    assume Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#8#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#8#d#0): DatatypeType)): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $IsBox($l#8#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#8#d#0)), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))), JSON_mGrammar.Bracketed.data(js#0));
    assume JSON_mDeserializer.__default.Array($LS($LZ), js#0) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#10#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#10#d#0): DatatypeType)): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $IsBox($l#10#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#10#d#0)), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))), JSON_mGrammar.Bracketed.data(js#0));
    assume (forall $l#11#d#0: DatatypeType :: $Is($l#11#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(js#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box($l#11#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#11#d#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#11#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(js#0) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#12#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#12#d#0): DatatypeType)): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $IsBox($l#12#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#12#d#0)), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), JSON_mGrammar.Bracketed.data(js#0));
    assume $Is(JSON_mDeserializer.__default.Array($LS($LZ), js#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    assume b$reqreads#0;
    return;
}



function JSON_mDeserializer.__default.Value($ly: LayerType, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value($ly, js#0) } JSON_mDeserializer.__default.Value#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Value())) ==> $Is(JSON_mDeserializer.__default.Value($ly, js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value($LS($ly), js#0) } JSON_mDeserializer.__default.Value#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Value())) ==> (!JSON_mGrammar.Value.Null_q(js#0) ==> (JSON_mGrammar.Value.Bool_q(js#0) ==> (var b#1 := JSON_mGrammar.Value.b(js#0); JSON_mDeserializer.__default.Bool#canCall(b#1))) && (!JSON_mGrammar.Value.Bool_q(js#0) ==> (JSON_mGrammar.Value.String_q(js#0) ==> (var str#1 := JSON_mGrammar.Value.str(js#0); JSON_mDeserializer.__default.String#canCall(str#1) && (var valueOrError0#1 := JSON_mDeserializer.__default.String(str#1); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1))))) && (!JSON_mGrammar.Value.String_q(js#0) ==> (JSON_mGrammar.Value.Number_q(js#0) ==> (var dec#1 := JSON_mGrammar.Value.num(js#0); JSON_mDeserializer.__default.Number#canCall(dec#1) && (var valueOrError1#1 := JSON_mDeserializer.__default.Number(dec#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1))))) && (!JSON_mGrammar.Value.Number_q(js#0) ==> (JSON_mGrammar.Value.Object_q(js#0) ==> (var obj#1 := JSON_mGrammar.Value.obj(js#0); JSON_mDeserializer.__default.Object#canCall(obj#1) && (var valueOrError2#1 := JSON_mDeserializer.__default.Object($ly, obj#1); Wrappers.Result.IsFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) && (Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#1))))) && (!JSON_mGrammar.Value.Object_q(js#0) ==> (var arr#1 := JSON_mGrammar.Value.arr(js#0); JSON_mDeserializer.__default.Array#canCall(arr#1) && (var valueOrError3#1 := JSON_mDeserializer.__default.Array($ly, arr#1); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#1) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#1) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#1)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#1) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#1))))))))) && JSON_mDeserializer.__default.Value($LS($ly), js#0) == (if JSON_mGrammar.Value.Null_q(js#0) then #Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Null()))) else (if JSON_mGrammar.Value.Bool_q(js#0) then (var b#0 := JSON_mGrammar.Value.b(js#0); #Wrappers.Result.Success($Box(#JSON.Values.JSON.Bool(JSON_mDeserializer.__default.Bool(b#0))))) else (if JSON_mGrammar.Value.String_q(js#0) then (var str#0 := JSON_mGrammar.Value.str(js#0); (var valueOrError0#0 := JSON_mDeserializer.__default.String(str#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#0) else (var s#0 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): Seq; #Wrappers.Result.Success($Box(#JSON.Values.JSON.String(s#0))))))) else (if JSON_mGrammar.Value.Number_q(js#0) then (var dec#0 := JSON_mGrammar.Value.num(js#0); (var valueOrError1#0 := JSON_mDeserializer.__default.Number(dec#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#0) else (var n#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Values.JSON.Number(n#0))))))) else (if JSON_mGrammar.Value.Object_q(js#0) then (var obj#0 := JSON_mGrammar.Value.obj(js#0); (var valueOrError2#0 := JSON_mDeserializer.__default.Object($ly, obj#0); (if Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#0) else (var o#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#0)): Seq; #Wrappers.Result.Success($Box(#JSON.Values.JSON.Object(o#0))))))) else (var arr#0 := JSON_mGrammar.Value.arr(js#0); (var valueOrError3#0 := JSON_mDeserializer.__default.Array($ly, arr#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#0) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#0) else (var a#0 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#0)): Seq; #Wrappers.Result.Success($Box(#JSON.Values.JSON.Array(a#0)))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Value($LS($ly), Lit(js#0)) } JSON_mDeserializer.__default.Value#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Value())) ==> (!Lit(JSON_mGrammar.Value.Null_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(js#0))) ==> (var b#3 := Lit(JSON_mGrammar.Value.b(Lit(js#0))); JSON_mDeserializer.__default.Bool#canCall(b#3))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(js#0))) ==> (var str#3 := Lit(JSON_mGrammar.Value.str(Lit(js#0))); JSON_mDeserializer.__default.String#canCall(str#3) && (var valueOrError0#3 := JSON_mDeserializer.__default.String(str#3); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3))))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(js#0))) ==> (var dec#3 := Lit(JSON_mGrammar.Value.num(Lit(js#0))); JSON_mDeserializer.__default.Number#canCall(dec#3) && (var valueOrError1#3 := JSON_mDeserializer.__default.Number(dec#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3))))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(js#0))) ==> (var obj#3 := Lit(JSON_mGrammar.Value.obj(Lit(js#0))); JSON_mDeserializer.__default.Object#canCall(obj#3) && (var valueOrError2#3 := JSON_mDeserializer.__default.Object($LS($ly), obj#3); Wrappers.Result.IsFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) && (Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3))))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(js#0))) ==> (var arr#3 := Lit(JSON_mGrammar.Value.arr(Lit(js#0))); JSON_mDeserializer.__default.Array#canCall(arr#3) && (var valueOrError3#3 := JSON_mDeserializer.__default.Array($LS($ly), arr#3); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#3))))))))) && JSON_mDeserializer.__default.Value($LS($ly), Lit(js#0)) == (if JSON_mGrammar.Value.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Null()))) else (if JSON_mGrammar.Value.Bool_q(Lit(js#0)) then (var b#2 := Lit(JSON_mGrammar.Value.b(Lit(js#0))); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Bool(Lit(JSON_mDeserializer.__default.Bool(b#2)))))))) else (if JSON_mGrammar.Value.String_q(Lit(js#0)) then (var str#2 := Lit(JSON_mGrammar.Value.str(Lit(js#0))); (var valueOrError0#2 := Lit(JSON_mDeserializer.__default.String(str#2)); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#2) else (var s#2 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): Seq); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.String(s#2))))))))) else (if JSON_mGrammar.Value.Number_q(Lit(js#0)) then (var dec#2 := Lit(JSON_mGrammar.Value.num(Lit(js#0))); (var valueOrError1#2 := Lit(JSON_mDeserializer.__default.Number(dec#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#2) else (var n#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Number(n#2))))))))) else (if JSON_mGrammar.Value.Object_q(Lit(js#0)) then (var obj#2 := Lit(JSON_mGrammar.Value.obj(Lit(js#0))); (var valueOrError2#2 := Lit(JSON_mDeserializer.__default.Object($LS($ly), obj#2)); (if Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#2) else (var o#2 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2)): Seq); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Object(o#2))))))))) else (var arr#2 := Lit(JSON_mGrammar.Value.arr(Lit(js#0))); (var valueOrError3#2 := Lit(JSON_mDeserializer.__default.Array($LS($ly), arr#2)); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#2) else (var a#2 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#2)): Seq); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Array(a#2)))))))))))))));
}

function JSON_mDeserializer.__default.Value#canCall(js#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value($LS($ly), js#0) } JSON_mDeserializer.__default.Value($LS($ly), js#0) == JSON_mDeserializer.__default.Value($ly, js#0));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value(AsFuelBottom($ly), js#0) } JSON_mDeserializer.__default.Value($ly, js#0) == JSON_mDeserializer.__default.Value($LZ, js#0));

function JSON_mDeserializer.__default.Value#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value#requires($ly, js#0) } $Is(js#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mDeserializer.__default.Value#requires($ly, js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.Value (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Value(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Value()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.Deserializer.Value (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.Value(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#5#0: DatatypeType;
  var arr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var valueOrError3#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##js#0: DatatypeType;
  var a#Z#0: Seq;
  var let#2#0#0: Seq;
  var _mcc#4#0: DatatypeType;
  var obj#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var valueOrError2#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##js#1: DatatypeType;
  var o#Z#0: Seq;
  var let#5#0#0: Seq;
  var _mcc#3#0: DatatypeType;
  var dec#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##js#2: DatatypeType;
  var n#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var str#Z#0: DatatypeType;
  var let#9#0#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;
  var ##js#3: DatatypeType;
  var s#Z#0: Seq;
  var let#11#0#0: Seq;
  var _mcc#1#0: DatatypeType;
  var b#Z#0: DatatypeType;
  var let#12#0#0: DatatypeType;
  var ##js#4: DatatypeType;
  var _mcc#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Value", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/Deserializer.dfy(162,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} js#0 == #JSON.Grammar.Value.Null(_mcc#0#0);
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jnull());
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Null()))));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon20_Else:
    assume {:partition} js#0 != #JSON.Grammar.Value.Null(_mcc#0#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} js#0 == #JSON.Grammar.Value.Bool(_mcc#1#0);
    assume $Is(_mcc#1#0, Tclass.JSON_mGrammar.jbool());
    havoc b#Z#0;
    assume $Is(b#Z#0, Tclass.JSON_mGrammar.jbool()) && $IsAlloc(b#Z#0, Tclass.JSON_mGrammar.jbool(), $Heap);
    assume let#12#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#12#0#0, Tclass.JSON_mGrammar.jbool());
    assume b#Z#0 == let#12#0#0;
    ##js#4 := b#Z#0;
    assume $IsAlloc(##js#4, Tclass.JSON_mGrammar.jbool(), $Heap);
    assume JSON_mDeserializer.__default.Bool#canCall(b#Z#0);
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Values.JSON.Bool(JSON_mDeserializer.__default.Bool(b#Z#0))));
    assume JSON_mDeserializer.__default.Bool#canCall(b#Z#0);
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon21_Else:
    assume {:partition} js#0 != #JSON.Grammar.Value.Bool(_mcc#1#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} js#0 == #JSON.Grammar.Value.String(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jstring());
    havoc str#Z#0;
    assume $Is(str#Z#0, Tclass.JSON_mGrammar.jstring()) && $IsAlloc(str#Z#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume let#9#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#9#0#0, Tclass.JSON_mGrammar.jstring());
    assume str#Z#0 == let#9#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##js#3 := str#Z#0;
    assume $IsAlloc(##js#3, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mDeserializer.__default.String#canCall(str#Z#0);
    assume let#10#0#0 == JSON_mDeserializer.__default.String(str#Z#0);
    assume JSON_mDeserializer.__default.String#canCall(str#Z#0);
    assume $Is(let#10#0#0, Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#10#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#Z#0);
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#Z#0);
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon23_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    havoc s#Z#0;
    assume $Is(s#Z#0, TSeq(TChar)) && $IsAlloc(s#Z#0, TSeq(TChar), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume let#11#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $Is(let#11#0#0, TSeq(TChar));
    assume s#Z#0 == let#11#0#0;
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Values.JSON.String(s#Z#0)));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon22_Else:
    assume {:partition} js#0 != #JSON.Grammar.Value.String(_mcc#2#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} js#0 == #JSON.Grammar.Value.Number(_mcc#3#0);
    assume $Is(_mcc#3#0, Tclass.JSON_mGrammar.jnumber());
    havoc dec#Z#0;
    assume $Is(dec#Z#0, Tclass.JSON_mGrammar.jnumber()) && $IsAlloc(dec#Z#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume let#6#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.JSON_mGrammar.jnumber());
    assume dec#Z#0 == let#6#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##js#2 := dec#Z#0;
    assume $IsAlloc(##js#2, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume JSON_mDeserializer.__default.Number#canCall(dec#Z#0);
    assume let#7#0#0 == JSON_mDeserializer.__default.Number(dec#Z#0);
    assume JSON_mDeserializer.__default.Number#canCall(dec#Z#0);
    assume $Is(let#7#0#0, Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError1#Z#0 == let#7#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#Z#0);
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#Z#0);
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon25_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    havoc n#Z#0;
    assume $Is(n#Z#0, Tclass.JSON_mValues.Decimal()) && $IsAlloc(n#Z#0, Tclass.JSON_mValues.Decimal(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume JSON_mValues.Decimal.Decimal_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0)): DatatypeType);
    assume let#8#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $Is(let#8#0#0, Tclass.JSON_mValues.Decimal());
    assume n#Z#0 == let#8#0#0;
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Values.JSON.Number(n#Z#0)));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon24_Else:
    assume {:partition} js#0 != #JSON.Grammar.Value.Number(_mcc#3#0);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} js#0 == #JSON.Grammar.Value.Object(_mcc#4#0);
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    havoc obj#Z#0;
    assume $Is(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume let#3#0#0 == _mcc#4#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    assume obj#Z#0 == let#3#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##js#1 := obj#Z#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume DtRank(##js#1) < DtRank(js#0);
    assume JSON_mDeserializer.__default.Object#canCall(obj#Z#0);
    assume let#4#0#0 == JSON_mDeserializer.__default.Object($LS($LZ), obj#Z#0);
    assume JSON_mDeserializer.__default.Object#canCall(obj#Z#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError2#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#Z#0);
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#Z#0);
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon27_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    havoc o#Z#0;
    assume $Is(o#Z#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) && $IsAlloc(o#Z#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#Z#0);
    assume $Is(let#5#0#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())));
    assume o#Z#0 == let#5#0#0;
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Values.JSON.Object(o#Z#0)));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon26_Else:
    assume {:partition} js#0 != #JSON.Grammar.Value.Object(_mcc#4#0);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} js#0 == #JSON.Grammar.Value.Array(_mcc#5#0);
    assume $Is(_mcc#5#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    havoc arr#Z#0;
    assume $Is(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume let#0#0#0 == _mcc#5#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    assume arr#Z#0 == let#0#0#0;
    havoc valueOrError3#Z#0;
    assume $Is(valueOrError3#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError3#Z#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##js#0 := arr#Z#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume DtRank(##js#0) < DtRank(js#0);
    assume JSON_mDeserializer.__default.Array#canCall(arr#Z#0);
    assume let#1#0#0 == JSON_mDeserializer.__default.Array($LS($LZ), arr#Z#0);
    assume JSON_mDeserializer.__default.Array#canCall(arr#Z#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError3#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#Z#0);
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#Z#0);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#Z#0);
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#Z#0);
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon29_Else:
    assume {:partition} !Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#Z#0);
    havoc a#Z#0;
    assume $Is(a#Z#0, TSeq(Tclass.JSON_mValues.JSON())) && $IsAlloc(a#Z#0, TSeq(Tclass.JSON_mValues.JSON()), $Heap);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#Z#0);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#Z#0)): Seq;
    assume Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#Z#0);
    assume $Is(let#2#0#0, TSeq(Tclass.JSON_mValues.JSON()));
    assume a#Z#0 == let#2#0#0;
    assume JSON_mDeserializer.__default.Value($LS($LZ), js#0) == #Wrappers.Result.Success($Box(#JSON.Values.JSON.Array(a#Z#0)));
    assume true;
    assume $Is(JSON_mDeserializer.__default.Value($LS($LZ), js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    return;

  anon28_Else:
    assume {:partition} js#0 != #JSON.Grammar.Value.Array(_mcc#5#0);
    assume false;
    return;
}



function JSON_mDeserializer.__default.JSON(js#0: DatatypeType) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.JSON(js#0) } JSON_mDeserializer.__default.JSON#canCall(js#0) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> $Is(JSON_mDeserializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())));
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.JSON(js#0) } JSON_mDeserializer.__default.JSON#canCall(js#0) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType) && JSON_mDeserializer.__default.JSON(js#0) == JSON_mDeserializer.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType));
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.JSON(Lit(js#0)) } JSON_mDeserializer.__default.JSON#canCall(Lit(js#0)) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mDeserializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType)) && JSON_mDeserializer.__default.JSON(Lit(js#0)) == Lit(JSON_mDeserializer.__default.Value($LS($LZ), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType))));
}

function JSON_mDeserializer.__default.JSON#canCall(js#0: DatatypeType) : bool;

function JSON_mDeserializer.__default.JSON#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.JSON#requires(js#0) } $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> (JSON_mDeserializer.__default.JSON#requires(js#0) <==> true));

procedure {:verboseName "JSON.Deserializer.JSON (well-formedness)"} CheckWellformed$$JSON_mDeserializer.__default.JSON(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#204 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#204))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#206 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#206)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#306 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#306))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#308 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#308)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#310 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#310)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#306 := Wrappers.Option.value(this); v#306)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#308 := Lit(Wrappers.Option.value(Lit(this))); v#308)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#310 := Lit(Wrappers.Option.value(Lit(this))); v#310)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#204 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#204)) else (var e#204 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#206 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#206))) else (var e#206 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#306 := Wrappers.Result.value(this); s#306) else (var e#306 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#308 := Lit(Wrappers.Result.value(Lit(this))); s#308) else (var e#308 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#310 := Lit(Wrappers.Result.value(Lit(this))); s#310) else (var e#310 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#306 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#306)) else (var e#306 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#306)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#308 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#308))) else (var e#308 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#308)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#310 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#310))) else (var e#310 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#310)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#28: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#28, x#28)): bool } $IsBox(x#28, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#28, x#28)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#29: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#29, x#29)): bool } $IsBox(x#29, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#29, x#29)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#28: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#28, x#28)): bool } $IsBox(x#28, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#28, x#28)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#29: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#29, x#29)): bool } $IsBox(x#29, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#29, x#29)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#28: Box, y#28: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#28, x#28)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#28, y#28)): bool } $IsBox(x#28, Relations._default.AntiSymmetric$T) && $IsBox(y#28, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#28, y#28)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#28, x#28)): bool ==> x#28 == y#28)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#29: Box, y#29: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#29, x#29)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#29, y#29)): bool } $IsBox(x#29, Relations._default.AntiSymmetric$T) && $IsBox(y#29, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#29, y#29)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#29, x#29)): bool ==> x#29 == y#29)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#28: Box, y#28: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#28, x#28)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#28, y#28)): bool } $IsBox(x#28, Relations._default.Symmetric$T) && $IsBox(y#28, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#28, y#28)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#28, x#28)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#29: Box, y#29: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#29, x#29)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#29, y#29)): bool } $IsBox(x#29, Relations._default.Symmetric$T) && $IsBox(y#29, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#29, y#29)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#29, x#29)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#28: Box, y#28: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#28, x#28)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#28, y#28)): bool } $IsBox(x#28, Relations._default.Connected$T) && $IsBox(y#28, Relations._default.Connected$T) ==> x#28 != y#28 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#28, y#28)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#28, x#28)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#29: Box, y#29: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#29, x#29)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#29, y#29)): bool } $IsBox(x#29, Relations._default.Connected$T) && $IsBox(y#29, Relations._default.Connected$T) ==> x#29 != y#29 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#29, y#29)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#29, x#29)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#28: Box, y#28: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#28, x#28)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#28, y#28)): bool } $IsBox(x#28, Relations._default.StronglyConnected$T) && $IsBox(y#28, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#28, y#28)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#28, x#28)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#29: Box, y#29: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#29, x#29)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#29, y#29)): bool } $IsBox(x#29, Relations._default.StronglyConnected$T) && $IsBox(y#29, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#29, y#29)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#29, x#29)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#28: Box, y#28: Box, z#28: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#28, z#28)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#28, z#28)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#28, z#28)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#28, y#28)): bool } $IsBox(x#28, Relations._default.Transitive$T) && $IsBox(y#28, Relations._default.Transitive$T) && $IsBox(z#28, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#28, y#28)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#28, z#28)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#28, z#28)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#29: Box, y#29: Box, z#29: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#29, z#29)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#29, z#29)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#29, z#29)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#29, y#29)): bool } $IsBox(x#29, Relations._default.Transitive$T) && $IsBox(y#29, Relations._default.Transitive$T) && $IsBox(z#29, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#29, y#29)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#29, z#29)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#29, z#29)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#41: int, j#41: int :: { Seq#Index(a#0, j#41), Seq#Index(a#0, i#41) } LitInt(0) <= i#41 && i#41 < j#41 && j#41 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#41), Seq#Index(a#0, j#41))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#42: int, j#42: int :: { Seq#Index(a#0, j#42), Seq#Index(a#0, i#42) } LitInt(0) <= i#42 && i#42 < j#42 && j#42 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#42), Seq#Index(Lit(a#0), j#42))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#43: int, j#43: int :: { Seq#Index(a#0, j#43), Seq#Index(a#0, i#43) } LitInt(0) <= i#43 && i#43 < j#43 && j#43 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#43), Seq#Index(Lit(a#0), j#43))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#41: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#41)): bool } { s#0[x#41] } $IsBox(x#41, Relations._default.IsLeast$T) && s#0[x#41] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#41)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#42: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#42)): bool } { s#0[x#42] } $IsBox(x#42, Relations._default.IsLeast$T) && Lit(s#0)[x#42] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#42)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#43: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#43)): bool } { s#0[x#43] } $IsBox(x#43, Relations._default.IsLeast$T) && Lit(s#0)[x#43] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#43)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#41: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#41)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#41, min#0)): bool } { s#0[x#41] } $IsBox(x#41, Relations._default.IsMinimal$T) && s#0[x#41] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#41, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#41)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#42: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#42)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#42, min#0)): bool } { s#0[x#42] } $IsBox(x#42, Relations._default.IsMinimal$T) && Lit(s#0)[x#42] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#42, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#42)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#43: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#43)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#43, min#0)): bool } { s#0[x#43] } $IsBox(x#43, Relations._default.IsMinimal$T) && Lit(s#0)[x#43] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#43, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#43)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#41: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#41, max#0)): bool } { s#0[x#41] } $IsBox(x#41, Relations._default.IsGreatest$T) && s#0[x#41] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#41, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#42: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#42, max#0)): bool } { s#0[x#42] } $IsBox(x#42, Relations._default.IsGreatest$T) && Lit(s#0)[x#42] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#42, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#43: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#43, max#0)): bool } { s#0[x#43] } $IsBox(x#43, Relations._default.IsGreatest$T) && Lit(s#0)[x#43] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#43, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#41: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#41, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#41)): bool } { s#0[x#41] } $IsBox(x#41, Relations._default.IsMaximal$T) && s#0[x#41] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#41)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#41, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#42: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#42, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#42)): bool } { s#0[x#42] } $IsBox(x#42, Relations._default.IsMaximal$T) && Lit(s#0)[x#42] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#42)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#42, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#43: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#43, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#43)): bool } { s#0[x#43] } $IsBox(x#43, Relations._default.IsMaximal$T) && Lit(s#0)[x#43] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#43)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#43, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#36 := Div(Seq#Length(a#0), LitInt(2)); (var left#36, right#36 := Seq#Take(a#0, splitIndex#36), Seq#Drop(a#0, splitIndex#36); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#36, lessThanOrEq#0) && (var leftSorted#36 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#36, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#36, lessThanOrEq#0) && (var rightSorted#36 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#36, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#36, rightSorted#36, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#36 := Div(Seq#Length(a#0), LitInt(2)); (var left#36, right#36 := Seq#Take(a#0, splitIndex#36), Seq#Drop(a#0, splitIndex#36); (var leftSorted#36 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#36, lessThanOrEq#0); (var rightSorted#36 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#36, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#36, rightSorted#36, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#37 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#37, right#37 := Seq#Take(Lit(a#0), splitIndex#37), Seq#Drop(Lit(a#0), splitIndex#37); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#37, lessThanOrEq#0) && (var leftSorted#37 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#37, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#37, lessThanOrEq#0) && (var rightSorted#37 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#37, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#37, rightSorted#37, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#37 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#37, right#37 := Seq#Take(Lit(a#0), splitIndex#37), Seq#Drop(Lit(a#0), splitIndex#37); (var leftSorted#37 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#37, lessThanOrEq#0); (var rightSorted#37 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#37, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#37, rightSorted#37, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#38 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#38, right#38 := Seq#Take(Lit(a#0), splitIndex#38), Seq#Drop(Lit(a#0), splitIndex#38); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#38, Lit(lessThanOrEq#0)) && (var leftSorted#38 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#38, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#38, Lit(lessThanOrEq#0)) && (var rightSorted#38 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#38, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#38, rightSorted#38, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#38 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#38, right#38 := Seq#Take(Lit(a#0), splitIndex#38), Seq#Drop(Lit(a#0), splitIndex#38); (var leftSorted#38 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#38, Lit(lessThanOrEq#0)); (var rightSorted#38 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#38, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#38, rightSorted#38, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#24: Box :: $IsBox($y#24, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#24)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#25: Box :: $IsBox($y#25, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#25)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#24: int, j#24: int :: { Seq#Index(xs#0, j#24), Seq#Index(xs#0, i#24) } LitInt(0) <= i#24 && i#24 < Seq#Length(xs#0) && LitInt(0) <= j#24 && j#24 < Seq#Length(xs#0) && i#24 != j#24 ==> Seq#Index(xs#0, i#24) != Seq#Index(xs#0, j#24))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#25: int, j#25: int :: { Seq#Index(xs#0, j#25), Seq#Index(xs#0, i#25) } LitInt(0) <= i#25 && i#25 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#25 && j#25 < Seq#Length(Lit(xs#0)) && i#25 != j#25 ==> Seq#Index(Lit(xs#0), i#25) != Seq#Index(Lit(xs#0), j#25))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#13: int :: { Seq#Index(xs#0, j#13) } LitInt(0) <= j#13 && j#13 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#13) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#13: int :: { Seq#Index(xs#0, j#13) } LitInt(0) <= j#13 && j#13 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#13) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#33 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#33) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#33)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#34 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#34) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#34)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#35 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#35) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#35)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#13: int :: { Seq#Index(xs#0, j#13) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#13 && j#13 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#13) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#13: int :: { Seq#Index(xs#0, j#13) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#13 && j#13 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#13) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#26: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#26), Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#26) == Seq#Index(xs#0, i#26)) && (forall i#27: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#27) } pos#0 <= i#27 && i#27 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#27) == Seq#Index(xs#0, i#27 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#33 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#33), Seq#Drop(xs#0, i#33 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#34 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#34), Seq#Drop(Lit(xs#0), i#34 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#35 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#35), Seq#Drop(Lit(xs#0), i#35 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#26: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#26), Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#26) == Seq#Index(xs#0, i#26)) && (forall i#27: int :: { Seq#Index(xs#0, i#27) } pos#0 <= i#27 && i#27 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#27 + 1) == Seq#Index(xs#0, i#27)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#13: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#13) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#13 - 1) } LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#13) == Seq#Index(xs#0, Seq#Length(xs#0) - i#13 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#13: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#13) } LitInt(0) <= i#13 && i#13 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#13) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#13: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#13) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#13) } LitInt(0) <= i#13 && i#13 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#13), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#13)), $Unbox(Seq#Index(xs#0, i#13)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#22, b#22 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#22, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#22, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#23, b#23 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#23, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#23, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#13: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#13)): DatatypeType } LitInt(0) <= i#13 && i#13 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#13)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#13), Seq#Index(ys#0, i#13)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#13: int :: { Seq#Contains(xs#0, $Box(k#13)) } Seq#Contains(xs#0, $Box(k#13)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#13) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#13: int :: { Seq#Contains(xs#0, $Box(k#13)) } Seq#Contains(xs#0, $Box(k#13)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#13) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#46: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#46) } LitInt(0) <= i#46 && i#46 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#46) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#46))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#47: int :: { Seq#Index(xs#0, i#47) } LitInt(0) <= i#47 && i#47 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#47)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#47: int :: { Seq#Index(xs#0, i#47) } LitInt(0) <= i#47 && i#47 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#47)))) ==> (forall $l#27#i#0: int :: LitInt(0) <= $l#27#i#0 ==> $l#27#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#27#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#26#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#26#i#0): int))), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $IsBox($l#26#i#0, TInt) && LitInt(0) <= $Unbox($l#26#i#0): int && $Unbox($l#26#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#26#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#26#i#0): int))), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: (exists i#48: int, o#19: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#26#heap#0, f#0, Seq#Index(xs#0, i#48))[$Box(o#19)] } $Is(o#19, Tclass._System.object?()) && LitInt(0) <= i#48 && i#48 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#26#heap#0, f#0, Seq#Index(xs#0, i#48))[$Box(o#19)] && $Box($l#26#o#0) == $Box(o#19))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#33: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#33) } { Seq#Index(xs#0, i#33) } (LitInt(0) <= i#33 && i#33 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#33))): DatatypeType)) && (LitInt(0) <= i#33 && i#33 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#33) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#33))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#34: int :: { Seq#Index(xs#0, i#34) } LitInt(0) <= i#34 && i#34 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#34)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#34: int :: { Seq#Index(xs#0, i#34) } LitInt(0) <= i#34 && i#34 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#34)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#11 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#11) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#11) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#11 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#11) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#11)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#11) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#11)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#11 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#11) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#11) else (var head#11 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#11); (var valueOrError1#11 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#11) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#11) else (var tail#11 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#11)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#11), tail#11)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#33: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#33) } LitInt(0) <= i#33 ==> i#33 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#33)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#33))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#34: int :: { Seq#Index(xs#0, i#34) } LitInt(0) <= i#34 && i#34 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#34)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#34: int :: { Seq#Index(xs#0, i#34) } LitInt(0) <= i#34 && i#34 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#34)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#24: Box, xs#24: Seq, b#24: Box, b'#24: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#24, x#24, b'#24)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#24), xs#24) } $IsBox(x#24, Seq._default.InvFoldLeft$A) && $Is(xs#24, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#24, Seq._default.InvFoldLeft$B) && $IsBox(b'#24, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#24, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#24), xs#24)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#24, x#24, b'#24)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#24, $Box(xs#24))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#25: Box, xs#25: Seq, b#25: Box, b'#25: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#25, x#25, b'#25)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#25), xs#25) } $IsBox(x#25, Seq._default.InvFoldLeft$A) && $Is(xs#25, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#25, Seq._default.InvFoldLeft$B) && $IsBox(b'#25, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#25, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#25), xs#25)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#25, x#25, b'#25)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#25, $Box(xs#25))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#24: Box, xs#24: Seq, b#24: Box, b'#24: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#24), xs#24), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#24, b#24, b'#24)): bool } $IsBox(x#24, Seq._default.InvFoldRight$A) && $Is(xs#24, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#24, Seq._default.InvFoldRight$B) && $IsBox(b'#24, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#24), b#24)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#24, b#24, b'#24)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#24), xs#24)), b'#24)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#25: Box, xs#25: Seq, b#25: Box, b'#25: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#25), xs#25), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#25, b#25, b'#25)): bool } $IsBox(x#25, Seq._default.InvFoldRight$A) && $Is(xs#25, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#25, Seq._default.InvFoldRight$B) && $IsBox(b'#25, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#25), b#25)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#25, b#25, b'#25)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#25), xs#25)), b'#25)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#20)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#20: int :: { Seq#Index(xs#0, i#20) } LitInt(0) <= i#20 && i#20 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#20)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#14 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#14)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#15 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#15)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#9: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#9) } $IsBox(x#9, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#9))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#9: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#9) } $IsBox(x#9, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#9))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#9: Box, x2#9: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#9), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#9) } $IsBox(x1#9, Functions._default.Injective$X) && $IsBox(x2#9, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#9) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#9) ==> x1#9 == x2#9)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#14: int :: { Seq#Take(s#0, i#14) } 0 < i#14 && i#14 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#14))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> (Seq#Length(s#0) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(2) ==> (Seq#Length(s#0) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(3) ==> Seq#Length(s#0) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0)))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then (var b#33 := Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0); b#33) else (if Seq#Length(s#0) == LitInt(2) then (var b#34 := Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#34) else (if Seq#Length(s#0) == LitInt(3) then (var b#35 := Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0); b#35) else (if Seq#Length(s#0) == LitInt(4) then (var b#36 := Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0); b#36) else false))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> (Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(2) ==> (Seq#Length(Lit(s#0)) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(3) ==> Seq#Length(Lit(s#0)) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0))))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then (var b#37 := Lit(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0))); b#37) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#38 := Lit(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#38) else (if Seq#Length(Lit(s#0)) == LitInt(3) then (var b#39 := Lit(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0))); b#39) else (if Seq#Length(Lit(s#0)) == LitInt(4) then (var b#40 := Lit(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0))); b#40) else false))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstByte#8 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#8) && le_bv8(firstByte#8, 127bv8))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#9) && le_bv8(firstByte#9, 127bv8))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstByte#8 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#8 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#8) && le_bv8(firstByte#8, 223bv8) && le_bv8(128bv8, secondByte#8) && le_bv8(secondByte#8, 191bv8)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; le_bv8(194bv8, firstByte#9) && le_bv8(firstByte#9, 223bv8) && le_bv8(128bv8, secondByte#9) && le_bv8(secondByte#9, 191bv8)))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> (var firstByte#8 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#8 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#8 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; ((firstByte#8 == Lit(224bv8) && le_bv8(160bv8, secondByte#8) && le_bv8(secondByte#8, 191bv8)) || (le_bv8(225bv8, firstByte#8) && le_bv8(firstByte#8, 236bv8) && le_bv8(128bv8, secondByte#8) && le_bv8(secondByte#8, 191bv8)) || (firstByte#8 == Lit(237bv8) && le_bv8(128bv8, secondByte#8) && le_bv8(secondByte#8, 159bv8)) || (le_bv8(238bv8, firstByte#8) && le_bv8(firstByte#8, 239bv8) && le_bv8(128bv8, secondByte#8) && le_bv8(secondByte#8, 191bv8))) && le_bv8(128bv8, thirdByte#8) && le_bv8(thirdByte#8, 191bv8))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; ((firstByte#9 == Lit(224bv8) && le_bv8(160bv8, secondByte#9) && le_bv8(secondByte#9, 191bv8)) || (le_bv8(225bv8, firstByte#9) && le_bv8(firstByte#9, 236bv8) && le_bv8(128bv8, secondByte#9) && le_bv8(secondByte#9, 191bv8)) || (firstByte#9 == Lit(237bv8) && le_bv8(128bv8, secondByte#9) && le_bv8(secondByte#9, 159bv8)) || (le_bv8(238bv8, firstByte#9) && le_bv8(firstByte#9, 239bv8) && le_bv8(128bv8, secondByte#9) && le_bv8(secondByte#9, 191bv8))) && le_bv8(128bv8, thirdByte#9) && le_bv8(thirdByte#9, 191bv8))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> (var firstByte#8 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#8 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#8 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#8 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; ((firstByte#8 == Lit(240bv8) && le_bv8(144bv8, secondByte#8) && le_bv8(secondByte#8, 191bv8)) || (le_bv8(241bv8, firstByte#8) && le_bv8(firstByte#8, 243bv8) && le_bv8(128bv8, secondByte#8) && le_bv8(secondByte#8, 191bv8)) || (firstByte#8 == Lit(244bv8) && le_bv8(128bv8, secondByte#8) && le_bv8(secondByte#8, 143bv8))) && le_bv8(128bv8, thirdByte#8) && le_bv8(thirdByte#8, 191bv8) && le_bv8(128bv8, fourthByte#8) && le_bv8(fourthByte#8, 191bv8)))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; (var fourthByte#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(3))): bv8; ((firstByte#9 == Lit(240bv8) && le_bv8(144bv8, secondByte#9) && le_bv8(secondByte#9, 191bv8)) || (le_bv8(241bv8, firstByte#9) && le_bv8(firstByte#9, 243bv8) && le_bv8(128bv8, secondByte#9) && le_bv8(secondByte#9, 191bv8)) || (firstByte#9 == Lit(244bv8) && le_bv8(128bv8, secondByte#9) && le_bv8(secondByte#9, 143bv8))) && le_bv8(128bv8, thirdByte#9) && le_bv8(thirdByte#9, 191bv8) && le_bv8(128bv8, fourthByte#9) && le_bv8(fourthByte#9, 191bv8)))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#12: int :: { Seq#Take(s#0, i#12) } 0 < i#12 && i#12 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#12))) <==> true && Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#5 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#5) && Seq#Length(prefix#5) <= Seq#Length(s#0) && Seq#Equal(prefix#5, Seq#Take(s#0, Seq#Length(prefix#5))) && (forall i#13: int :: { Seq#Take(s#0, i#13) } 0 < i#13 && i#13 < Seq#Length(prefix#5) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#13))))) && $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == (var x#8 := and_bv24(v#0, 127bv24)[7:0]; (var firstByte#9 := (0bv1 ++ x#8): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#9)))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) == (var x#9 := Lit(and_bv24(v#0, 127bv24))[7:0]; (var firstByte#10 := (0bv1 ++ x#9): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#10)))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == (var x#8 := and_bv24(v#0, 63bv24)[6:0]; (var y#8 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#9 := or_bv8(192bv8, (0bv3 ++ y#8): bv8); (var secondByte#9 := or_bv8(128bv8, (0bv2 ++ x#8): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#9)), $Box(secondByte#9)))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) == (var x#9 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#9 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#10 := or_bv8(192bv8, (0bv3 ++ y#9): bv8); (var secondByte#10 := or_bv8(128bv8, (0bv2 ++ x#9): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#10)), $Box(secondByte#10)))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == (var x#8 := and_bv24(v#0, 63bv24)[6:0]; (var y#8 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#8 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#9 := or_bv8(224bv8, (0bv4 ++ z#8): bv8); (var secondByte#9 := or_bv8(128bv8, (0bv2 ++ y#8): bv8); (var thirdByte#9 := or_bv8(128bv8, (0bv2 ++ x#8): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#9)), $Box(secondByte#9)), $Box(thirdByte#9)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) == (var x#9 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#9 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#9 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#10 := or_bv8(224bv8, (0bv4 ++ z#9): bv8); (var secondByte#10 := or_bv8(128bv8, (0bv2 ++ y#9): bv8); (var thirdByte#10 := or_bv8(128bv8, (0bv2 ++ x#9): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#10)), $Box(secondByte#10)), $Box(thirdByte#10)))))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == (var x#8 := and_bv24(v#0, 63bv24)[6:0]; (var y#8 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#8 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#8 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#8 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#9 := or_bv8(240bv8, (0bv5 ++ u1#8): bv8); (var secondByte#9 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#8): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#8): bv8); (var thirdByte#9 := or_bv8(128bv8, (0bv2 ++ y#8): bv8); (var fourthByte#9 := or_bv8(128bv8, (0bv2 ++ x#8): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#9)), $Box(secondByte#9)), $Box(thirdByte#9)), $Box(fourthByte#9))))))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) == (var x#9 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#9 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#9 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#9 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#9 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#10 := or_bv8(240bv8, (0bv5 ++ u1#9): bv8); (var secondByte#10 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#9): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#9): bv8); (var thirdByte#10 := or_bv8(128bv8, (0bv2 ++ y#9): bv8); (var fourthByte#10 := or_bv8(128bv8, (0bv2 ++ x#9): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#10)), $Box(secondByte#10)), $Box(thirdByte#10)), $Box(fourthByte#10))))))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (var firstByte#8 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var x#8 := firstByte#8[7:0]; (0bv17 ++ x#8): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) == (var firstByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var x#9 := firstByte#9[7:0]; (0bv17 ++ x#9): bv24)));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == (var firstByte#8 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#8 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var y#8 := (0bv16 ++ and_bv8(firstByte#8, 31bv8)): bv24; (var x#8 := (0bv16 ++ and_bv8(secondByte#8, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#8, (0bv19 ++ 6bv5): bv24), x#8))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) == (var firstByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var y#9 := (0bv16 ++ and_bv8(firstByte#9, 31bv8)): bv24; (var x#9 := (0bv16 ++ and_bv8(secondByte#9, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#9, (0bv19 ++ 6bv5): bv24), x#9))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == (var firstByte#8 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#8 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#8 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var z#8 := (0bv16 ++ and_bv8(firstByte#8, 15bv8)): bv24; (var y#8 := (0bv16 ++ and_bv8(secondByte#8, 63bv8)): bv24; (var x#8 := (0bv16 ++ and_bv8(thirdByte#8, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#8, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#8, (0bv19 ++ 6bv5): bv24)), x#8))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) == (var firstByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var z#9 := (0bv16 ++ and_bv8(firstByte#9, 15bv8)): bv24; (var y#9 := (0bv16 ++ and_bv8(secondByte#9, 63bv8)): bv24; (var x#9 := (0bv16 ++ and_bv8(thirdByte#9, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#9, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#9, (0bv19 ++ 6bv5): bv24)), x#9))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == (var firstByte#8 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#8 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#8 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var fourthByte#8 := $Unbox(Seq#Index(m#0, LitInt(3))): bv8; (var u1#8 := (0bv16 ++ and_bv8(firstByte#8, 7bv8)): bv24; (var u2#8 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#8, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#8 := (0bv16 ++ and_bv8(secondByte#8, 15bv8)): bv24; (var y#8 := (0bv16 ++ and_bv8(thirdByte#8, 63bv8)): bv24; (var x#8 := (0bv16 ++ and_bv8(fourthByte#8, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#8, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#8, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#8, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#8, (0bv19 ++ 6bv5): bv24)), x#8)))))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) == (var firstByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var fourthByte#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(3))): bv8; (var u1#9 := (0bv16 ++ and_bv8(firstByte#9, 7bv8)): bv24; (var u2#9 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#9, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#9 := (0bv16 ++ and_bv8(secondByte#9, 15bv8)): bv24; (var y#9 := (0bv16 ++ and_bv8(thirdByte#9, 63bv8)): bv24; (var x#9 := (0bv16 ++ and_bv8(fourthByte#9, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#9, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#9, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#9, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#9, (0bv19 ++ 6bv5): bv24)), x#9)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#9 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#9)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) && (var prefix#9 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#9))) && (var valueOrError1#8 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#9))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#9 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#9) else (var prefix#9 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9)): Seq; (var valueOrError1#8 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#9))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) else (var restParts#8 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#9)), restParts#8)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#10 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#10)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) && (var prefix#10 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#10))) && (var valueOrError1#9 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#10))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#10 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#10) else (var prefix#10 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10)): Seq); (var valueOrError1#9 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#10))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) else (var restParts#9 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#10)), restParts#9)))))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) == $Box(Utf8EncodingForm.__default.EncodeScalarValue($Unbox($fh$4x#0): bv24)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) <==> Utf8EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$4x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue($fh$4x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.EncodeScalarValue($fh$4x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#8 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(8), ms#8)) && Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#8 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#8)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#9 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(8), ms#9)) && Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#9 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#9)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) } Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) == $Box(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$4x#0): Seq)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) } Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) <==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$4x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$4x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$4x#0) == $Unbox(Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$4x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#8 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#8)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#8 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#9 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#8); vs#9)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#9 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#9)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#9 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#10 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#9); vs#10)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#8: int :: { Seq#Take(s#0, i#8) } 0 < i#8 && i#8 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#8))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> Seq#Length(s#0) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#9 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#9) else false))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#10 := Lit(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#10) else false))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstWord#8 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#8) && le_bv16(firstWord#8, 55295bv16)) || (le_bv16(57344bv16, firstWord#8) && le_bv16(firstWord#8, 65535bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (le_bv16(0bv16, firstWord#9) && le_bv16(firstWord#9, 55295bv16)) || (le_bv16(57344bv16, firstWord#9) && le_bv16(firstWord#9, 65535bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstWord#8 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (var secondWord#8 := $Unbox(Seq#Index(s#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#8) && le_bv16(firstWord#8, 56319bv16) && le_bv16(56320bv16, secondWord#8) && le_bv16(secondWord#8, 57343bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (var secondWord#9 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv16; le_bv16(55296bv16, firstWord#9) && le_bv16(firstWord#9, 56319bv16) && le_bv16(56320bv16, secondWord#9) && le_bv16(secondWord#9, 57343bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#19: int :: { Seq#Take(s#0, i#19) } 0 < i#19 && i#19 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#19))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#10 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#10) && Seq#Length(prefix#10) <= Seq#Length(s#0) && Seq#Equal(prefix#10, Seq#Take(s#0, Seq#Length(prefix#10))) && (forall i#20: int :: { Seq#Take(s#0, i#20) } 0 < i#20 && i#20 < Seq#Length(prefix#10) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#20))))) && (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#21: int :: { Seq#Take(s#0, i#21) } 0 < i#21 && i#21 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#21))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#11 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#11) && Seq#Length(prefix#11) <= Seq#Length(s#0) && Seq#Equal(prefix#11, Seq#Take(s#0, Seq#Length(prefix#11))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#11))) && $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == (var firstWord#9 := v#0[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#9))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) == (var firstWord#10 := Lit(v#0)[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#10))));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == (var x2#8 := and_bv24(v#0, 1023bv24)[10:0]; (var x1#8 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#8 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#8 := sub_bv5(u#8, 1bv5)[4:0]; (var firstWord#9 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#8): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#8): bv16); (var secondWord#9 := or_bv16(56320bv16, (0bv6 ++ x2#8): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#9)), $Box(secondWord#9)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) == (var x2#9 := Lit(and_bv24(v#0, 1023bv24))[10:0]; (var x1#9 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#9 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#9 := sub_bv5(u#9, 1bv5)[4:0]; (var firstWord#10 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#9): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#9): bv16); (var secondWord#10 := or_bv16(56320bv16, (0bv6 ++ x2#9): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#10)), $Box(secondWord#10)))))))));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (var firstWord#8 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var x#8 := firstWord#8; (0bv8 ++ x#8): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) == (var firstWord#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var x#9 := firstWord#9; (0bv8 ++ x#9): bv24)));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == (var firstWord#8 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#8 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; (var x2#8 := (0bv8 ++ and_bv16(secondWord#8, 1023bv16)): bv24; (var x1#8 := (0bv8 ++ and_bv16(firstWord#8, 63bv16)): bv24; (var w#8 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#8, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#8 := add_bv24(w#8, 1bv24); (var v#9 := or_bv24(or_bv24(LeftShift_bv24(u#8, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#8, (0bv19 ++ 10bv5): bv24)), x2#8); v#9))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) == (var firstWord#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var secondWord#9 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv16; (var x2#9 := (0bv8 ++ and_bv16(secondWord#9, 1023bv16)): bv24; (var x1#9 := (0bv8 ++ and_bv16(firstWord#9, 63bv16)): bv24; (var w#9 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#9, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#9 := add_bv24(w#9, 1bv24); (var v#10 := or_bv24(or_bv24(LeftShift_bv24(u#9, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#9, (0bv19 ++ 10bv5): bv24)), x2#9); v#10))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#9 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#9)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) && (var prefix#9 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#9))) && (var valueOrError1#8 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#9))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#9 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#9) else (var prefix#9 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#9)): Seq; (var valueOrError1#8 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#9))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8) else (var restParts#8 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#8)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#9)), restParts#8)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#10 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#10)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) && (var prefix#10 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#10))) && (var valueOrError1#9 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#10))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#10 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#10) else (var prefix#10 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#10)): Seq); (var valueOrError1#9 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#10))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9) else (var restParts#9 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#9)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#10)), restParts#9)))))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) == $Box(Utf16EncodingForm.__default.EncodeScalarValue($Unbox($fh$4x#0): bv24)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0) <==> Utf16EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$4x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue($fh$4x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.EncodeScalarValue($fh$4x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#8 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(16), ms#8)) && Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#8 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#8)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#9 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(16), ms#9)) && Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#9 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#9)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) } Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) == $Box(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$4x#0): Seq)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) } Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0) <==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$4x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$4x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$4x#0) == $Unbox(Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$4x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#8 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#8)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#8 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#9 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#8); vs#9)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#9 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#9)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#9 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#10 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#9); vs#10)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#37#c#0): char)))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, TChar)), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#38#c#0): char)))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, TChar)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))), s#0)) && (UnicodeStrings.__default.IsWellFormedString(s#0) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#35#c#0): char)))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, TChar)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))), s#0))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.IsWellFormedString(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#41#c#0): char)))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, TChar)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#42#c#0): char)))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, TChar)), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (UnicodeStrings.__default.IsWellFormedString(Lit(s#0)) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#39#c#0): char)))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, TChar)), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#60#c#0): char)))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, TChar)), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), s#0) && (var asCodeUnits#6 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#63#c#0): char)))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, TChar)), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))), s#0); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#6) && (var valueOrError0#6 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#6); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) && (var utf32#6 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#6) && (var asUtf8CodeUnits#6 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#6); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(nat_from_bv8($Unbox($l#62#c#0): bv8))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, TBitvector(8))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#6)))))) && UnicodeStrings.__default.ToUTF8Checked(s#0) == (var asCodeUnits#6 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#57#c#0): char)))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, TChar)), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))), s#0); (var valueOrError0#6 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#6); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var utf32#6 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6)): Seq; (var asUtf8CodeUnits#6 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#6); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(nat_from_bv8($Unbox($l#58#c#0): bv8))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, TBitvector(8))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#6)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#67#c#0): char)))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, TChar)), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && (var asCodeUnits#7 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#70#c#0): char)))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, TChar)), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#7) && (var valueOrError0#7 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#7); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) && (var utf32#7 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#7) && (var asUtf8CodeUnits#7 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#7); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box(nat_from_bv8($Unbox($l#69#c#0): bv8))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, TBitvector(8))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#7)))))) && UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)) == (var asCodeUnits#7 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#64#c#0): char)))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, TChar)), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); (var valueOrError0#7 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#7); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var utf32#7 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7)): Seq; (var asUtf8CodeUnits#7 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#7); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(nat_from_bv8($Unbox($l#65#c#0): bv8))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, TBitvector(8))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#7)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(nat_to_bv8($Unbox($l#60#c#0): int))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, Tclass.BoundedInts.uint8())), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), bs#0) && (var asCodeUnits#6 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(nat_to_bv8($Unbox($l#63#c#0): int))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint8())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))), bs#0); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#6) && (var valueOrError0#6 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#6); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#6)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) && (var utf32#6 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#6) && (var asUtf16CodeUnits#6 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#6); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#62#cu#0): bv16)))), (lambda $l#62#heap#0: Heap, $l#62#cu#0: Box :: $IsBox($l#62#cu#0, TBitvector(16))), (lambda $l#62#heap#0: Heap, $l#62#cu#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#6)))))) && UnicodeStrings.__default.FromUTF8Checked(bs#0) == (var asCodeUnits#6 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(nat_to_bv8($Unbox($l#57#c#0): int))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.BoundedInts.uint8())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))), bs#0); (var valueOrError0#6 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#6); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#6) else (var utf32#6 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#6)): Seq; (var asUtf16CodeUnits#6 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#6); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#58#cu#0): bv16)))), (lambda $l#58#heap#0: Heap, $l#58#cu#0: Box :: $IsBox($l#58#cu#0, TBitvector(16))), (lambda $l#58#heap#0: Heap, $l#58#cu#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#6)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(nat_to_bv8($Unbox($l#67#c#0): int))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.BoundedInts.uint8())), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && (var asCodeUnits#7 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box(nat_to_bv8($Unbox($l#70#c#0): int))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.BoundedInts.uint8())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#7) && (var valueOrError0#7 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#7); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#7)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) && (var utf32#7 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#7) && (var asUtf16CodeUnits#7 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#7); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#69#cu#0): bv16)))), (lambda $l#69#heap#0: Heap, $l#69#cu#0: Box :: $IsBox($l#69#cu#0, TBitvector(16))), (lambda $l#69#heap#0: Heap, $l#69#cu#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#7)))))) && UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)) == (var asCodeUnits#7 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box(nat_to_bv8($Unbox($l#64#c#0): int))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, Tclass.BoundedInts.uint8())), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); (var valueOrError0#7 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#7); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#7) else (var utf32#7 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#7)): Seq; (var asUtf16CodeUnits#7 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#7); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#65#cu#0): bv16)))), (lambda $l#65#heap#0: Heap, $l#65#cu#0: Box :: $IsBox($l#65#cu#0, TBitvector(16))), (lambda $l#65#heap#0: Heap, $l#65#cu#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#7)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#66#c#0): char)))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, TChar)), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#67#c#0): char)))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, TChar)), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))), s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#68#c#0): char)))), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, TChar)), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))), s#0)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box(char#ToInt($Unbox($l#70#c#0): char))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, TChar)), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))), s#0)) && UnicodeStrings.__default.ToUTF16Checked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#63#c#0): char)))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, TChar)), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))), s#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box(char#ToInt($Unbox($l#64#c#0): char))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, TChar)), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))), s#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#74#c#0): char)))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, TChar)), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#75#c#0): char)))), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $IsBox($l#75#c#0, TChar)), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#76#c#0): char)))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, TChar)), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box(char#ToInt($Unbox($l#78#c#0): char))), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, TChar)), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#71#c#0): char)))), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, TChar)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box(char#ToInt($Unbox($l#72#c#0): char))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, TChar)), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(nat_to_bv16($Unbox($l#66#c#0): int))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, Tclass.BoundedInts.uint16())), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ))), bs#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(nat_to_bv16($Unbox($l#67#c#0): int))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.BoundedInts.uint16())), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))), bs#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box(nat_to_bv16($Unbox($l#68#c#0): int))), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, Tclass.BoundedInts.uint16())), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))), bs#0)) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box(char#FromInt($Unbox($l#70#c#0): int))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.BoundedInts.uint16())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))), bs#0)) && UnicodeStrings.__default.FromUTF16Checked(bs#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(nat_to_bv16($Unbox($l#63#c#0): int))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint16())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))), bs#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box(char#FromInt($Unbox($l#64#c#0): int))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, Tclass.BoundedInts.uint16())), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))), bs#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box(nat_to_bv16($Unbox($l#74#c#0): int))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.BoundedInts.uint16())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $Box(nat_to_bv16($Unbox($l#75#c#0): int))), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $IsBox($l#75#c#0, Tclass.BoundedInts.uint16())), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box(nat_to_bv16($Unbox($l#76#c#0): int))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, Tclass.BoundedInts.uint16())), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box(char#FromInt($Unbox($l#78#c#0): int))), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, Tclass.BoundedInts.uint16())), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(nat_to_bv16($Unbox($l#71#c#0): int))), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, Tclass.BoundedInts.uint16())), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box(char#FromInt($Unbox($l#72#c#0): int))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, Tclass.BoundedInts.uint16())), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF8#requires(s#0) <==> (forall i#10: int :: { $Unbox(Seq#Index(s#0, i#10)): char } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#10: int :: { $Unbox(Seq#Index(s#0, i#10)): char } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(char#ToInt($Unbox($l#27#c#0): char))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#27#c#0): char) && char#ToInt($Unbox($l#27#c#0): char) < 128), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(char#ToInt($Unbox($l#25#c#0): char))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#25#c#0): char) && char#ToInt($Unbox($l#25#c#0): char) < 128), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#11: int :: { $Unbox(Seq#Index(s#0, i#11)): char } LitInt(0) <= i#11 && i#11 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#11)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#11)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(char#ToInt($Unbox($l#30#c#0): char))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#30#c#0): char) && char#ToInt($Unbox($l#30#c#0): char) < 128), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(char#ToInt($Unbox($l#28#c#0): char))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#28#c#0): char) && char#ToInt($Unbox($l#28#c#0): char) < 128), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF16#requires(s#0) <==> (forall i#10: int :: { $Unbox(Seq#Index(s#0, i#10)): char } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#10: int :: { $Unbox(Seq#Index(s#0, i#10)): char } LitInt(0) <= i#10 && i#10 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#10)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(char#ToInt($Unbox($l#27#c#0): char))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#27#c#0): char) && char#ToInt($Unbox($l#27#c#0): char) < 128), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(char#ToInt($Unbox($l#25#c#0): char))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#25#c#0): char) && char#ToInt($Unbox($l#25#c#0): char) < 128), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#11: int :: { $Unbox(Seq#Index(s#0, i#11)): char } LitInt(0) <= i#11 && i#11 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#11)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#11)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(char#ToInt($Unbox($l#30#c#0): char))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#30#c#0): char) && char#ToInt($Unbox($l#30#c#0): char) < 128), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(char#ToInt($Unbox($l#28#c#0): char))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#28#c#0): char) && char#ToInt($Unbox($l#28#c#0): char) < 128), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom MulInternals.__default.MulAuto() <==> (forall x#102: int, y#102: int :: { Mul(x#102, y#102) } Mul(x#102, y#102) == Mul(y#102, x#102)) && (forall x#103: int, y#103: int, z#68: int :: { Mul(x#103 + y#103, z#68) } Mul(x#103 + y#103, z#68) == Mul(x#103, z#68) + Mul(y#103, z#68)) && (forall x#104: int, y#104: int, z#69: int :: { Mul(x#104 - y#104, z#69) } Mul(x#104 - y#104, z#69) == Mul(x#104, z#69) - Mul(y#104, z#69));

axiom MulInternals.__default.MulAuto() <==> (forall x#105: int, y#105: int :: { Mul(x#105, y#105) } Mul(x#105, y#105) == Mul(y#105, x#105)) && (forall x#106: int, y#106: int, z#70: int :: { Mul(x#106 + y#106, z#70) } Mul(x#106 + y#106, z#70) == Mul(x#106, z#70) + Mul(y#106, z#70)) && (forall x#107: int, y#107: int, z#71: int :: { Mul(x#107 - y#107, z#71) } Mul(x#107 - y#107, z#71) == Mul(x#107, z#71) - Mul(y#107, z#71));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#120: int :: { Mod(Mod(x#120, n#0), n#0) } Mod(Mod(x#120, n#0), n#0) == Mod(x#120, n#0)) && (forall x#121: int :: { Mod(x#121, n#0) } LitInt(0) <= x#121 && x#121 < n#0 <==> Mod(x#121, n#0) == x#121) && (forall x#122: int, y#60: int :: { Mod(x#122 + y#60, n#0) } (var z#58 := Mod(x#122, n#0) + Mod(y#60, n#0); (LitInt(0) <= z#58 && z#58 < n#0 && Mod(x#122 + y#60, n#0) == z#58) || (n#0 <= z#58 && z#58 < n#0 + n#0 && Mod(x#122 + y#60, n#0) == z#58 - n#0))) && (forall x#123: int, y#61: int :: { Mod(x#123 - y#61, n#0) } (var z#59 := Mod(x#123, n#0) - Mod(y#61, n#0); (LitInt(0) <= z#59 && z#59 < n#0 && Mod(x#123 - y#61, n#0) == z#59) || (0 - n#0 <= z#59 && z#59 < 0 && Mod(x#123 - y#61, n#0) == z#59 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#124: int :: { Mod(Mod(x#124, n#0), n#0) } Mod(Mod(x#124, LitInt(n#0)), LitInt(n#0)) == Mod(x#124, LitInt(n#0))) && (forall x#125: int :: { Mod(x#125, n#0) } LitInt(0) <= x#125 && x#125 < n#0 <==> Mod(x#125, LitInt(n#0)) == x#125) && (forall x#126: int, y#62: int :: { Mod(x#126 + y#62, n#0) } (var z#60 := Mod(x#126, LitInt(n#0)) + Mod(y#62, LitInt(n#0)); (LitInt(0) <= z#60 && z#60 < n#0 && Mod(x#126 + y#62, LitInt(n#0)) == z#60) || (LitInt(n#0) <= z#60 && z#60 < n#0 + n#0 && Mod(x#126 + y#62, LitInt(n#0)) == z#60 - n#0))) && (forall x#127: int, y#63: int :: { Mod(x#127 - y#63, n#0) } (var z#61 := Mod(x#127, LitInt(n#0)) - Mod(y#63, LitInt(n#0)); (LitInt(0) <= z#61 && z#61 < n#0 && Mod(x#127 - y#63, LitInt(n#0)) == z#61) || (LitInt(0 - n#0) <= z#61 && z#61 < 0 && Mod(x#127 - y#63, LitInt(n#0)) == z#61 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#84: int :: { Div(x#84, n#0) } LitInt(0) <= x#84 && x#84 < n#0 <==> Div(x#84, n#0) == LitInt(0)) && (forall x#85: int, y#56: int :: { Div(x#85 + y#56, n#0) } (var z#54 := Mod(x#85, n#0) + Mod(y#56, n#0); (LitInt(0) <= z#54 && z#54 < n#0 && Div(x#85 + y#56, n#0) == Div(x#85, n#0) + Div(y#56, n#0)) || (n#0 <= z#54 && z#54 < n#0 + n#0 && Div(x#85 + y#56, n#0) == Div(x#85, n#0) + Div(y#56, n#0) + 1))) && (forall x#86: int, y#57: int :: { Div(x#86 - y#57, n#0) } (var z#55 := Mod(x#86, n#0) - Mod(y#57, n#0); (LitInt(0) <= z#55 && z#55 < n#0 && Div(x#86 - y#57, n#0) == Div(x#86, n#0) - Div(y#57, n#0)) || (0 - n#0 <= z#55 && z#55 < 0 && Div(x#86 - y#57, n#0) == Div(x#86, n#0) - Div(y#57, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#87: int :: { Div(x#87, n#0) } LitInt(0) <= x#87 && x#87 < n#0 <==> Div(x#87, LitInt(n#0)) == LitInt(0)) && (forall x#88: int, y#58: int :: { Div(x#88 + y#58, n#0) } (var z#56 := Mod(x#88, LitInt(n#0)) + Mod(y#58, LitInt(n#0)); (LitInt(0) <= z#56 && z#56 < n#0 && Div(x#88 + y#58, LitInt(n#0)) == Div(x#88, LitInt(n#0)) + Div(y#58, LitInt(n#0))) || (LitInt(n#0) <= z#56 && z#56 < n#0 + n#0 && Div(x#88 + y#58, LitInt(n#0)) == Div(x#88, LitInt(n#0)) + Div(y#58, LitInt(n#0)) + 1))) && (forall x#89: int, y#59: int :: { Div(x#89 - y#59, n#0) } (var z#57 := Mod(x#89, LitInt(n#0)) - Mod(y#59, LitInt(n#0)); (LitInt(0) <= z#57 && z#57 < n#0 && Div(x#89 - y#59, LitInt(n#0)) == Div(x#89, LitInt(n#0)) - Div(y#59, LitInt(n#0))) || (LitInt(0 - n#0) <= z#57 && z#57 < 0 && Div(x#89 - y#59, LitInt(n#0)) == Div(x#89, LitInt(n#0)) - Div(y#59, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#12 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#12) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#12)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#12 := lv#0; (var dt_update#end#0#12 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#12), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#12), dt_update#end#0#12))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#13 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#13) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#13)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#13 := Lit(lv#0); (var dt_update#end#0#13 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#13)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#13)), dt_update#end#0#13)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#14: char :: { Seq#Contains(s#0, $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(s#0, $Box(c#14)) ==> char#ToInt(c#14) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#14: char :: { Seq#Contains(s#0, $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(s#0, $Box(c#14)) ==> char#ToInt(c#14) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#28#i#0): int)): char))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $IsBox($l#28#i#0, TInt) && LitInt(0) <= $Unbox($l#28#i#0): int && $Unbox($l#28#i#0): int < Seq#Length(s#0)), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#15: char :: { Seq#Contains(s#0, $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(s#0, $Box(c#15)) ==> char#ToInt(c#15) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#30#i#0): int)): char))), (lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: $IsBox($l#30#i#0, TInt) && LitInt(0) <= $Unbox($l#30#i#0): int && $Unbox($l#30#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#7: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#7)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#15 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#16 := Seq#Append(digits'#15, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#16))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#16 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#17 := Seq#Append(digits'#16, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#17))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#17 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#18 := Seq#Append(digits'#17, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#18))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#7: Box :: { Seq#Contains(chars#0, c#7) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#7) } $IsBox(c#7, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#7) ==> Seq#Contains(chars#0, c#7)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#15: int :: { Seq#Contains(digits#0, $Box(d#15)) } Seq#Contains(digits#0, $Box(d#15)) ==> LitInt(0) <= d#15 && d#15 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#15: int :: { Seq#Contains(digits#0, $Box(d#15)) } Seq#Contains(digits#0, $Box(d#15)) ==> LitInt(0) <= d#15 && d#15 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#16: int :: { Seq#Contains(digits#0, $Box(d#16)) } Seq#Contains(digits#0, $Box(d#16)) ==> LitInt(0) <= d#16 && d#16 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#7: Box :: { Seq#Contains(chars#0, c#7) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#7) } $IsBox(c#7, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#7) ==> Seq#Contains(chars#0, c#7)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#10 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#10) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#10), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#10 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#10), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#11 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#11) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#11), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#11 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#11), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#17: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#17)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#17) } $IsBox(c#17, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#17) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#17)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#18: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#18)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#18) } $IsBox(c#18, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#18) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#18)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#19: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#19)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#19) } $IsBox(c#19, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#19) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#19)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Seq#Contains(chars#0, $l#11#c#0))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#13: Box :: { Map#Domain(digits#0)[c#13] } { Seq#Contains(str#0, c#13) } $IsBox(c#13, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#13) ==> Map#Domain(digits#0)[c#13])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#13: Box :: { Map#Domain(digits#0)[c#13] } { Seq#Contains(str#0, c#13) } $IsBox(c#13, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#13) ==> Map#Domain(digits#0)[c#13])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#14: Box :: { Map#Domain(digits#0)[c#14] } { Seq#Contains(str#0, c#14) } $IsBox(c#14, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#14) ==> Map#Domain(digits#0)[c#14])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Map#Domain(digits#0)[$l#25#c#0])), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Map#Domain(digits#0)[$l#25#c#0])), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Map#Domain(digits#0)[$l#26#c#0])), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(Map#Domain(digits#0)[$l#27#c#0])), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#15 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#15) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#15)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#15)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#15 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#15) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#15) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#15)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#15) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#15))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#15 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#15) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#15) else (var tl#30 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#15)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#30)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#15 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#15) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#15) else (var tl#31 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#15)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#31)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#16 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#16) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#16)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#16)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#16 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#16) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#16) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#16)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#16) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#16))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#16 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#16) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#16) else (var tl#32 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#16)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#32)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#16 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#16) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#16) else (var tl#33 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#16)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#33)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#17 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#17) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#17)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#17)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#17 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#17) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#17) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#17)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#17) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#17))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#17 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#17) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#17) else (var tl#34 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#17)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#34)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#17 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#17) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#17) else (var tl#35 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#17)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#35)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#7: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#7)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#15 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#16 := Seq#Append(digits'#15, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#16))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#16 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#17 := Seq#Append(digits'#16, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#17))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#17 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#18 := Seq#Append(digits'#17, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#18))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#7: char :: { Seq#Contains(chars#0, $Box(c#7)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#7)) ==> Seq#Contains(chars#0, $Box(c#7))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#15: int :: { Seq#Contains(digits#0, $Box(d#15)) } Seq#Contains(digits#0, $Box(d#15)) ==> LitInt(0) <= d#15 && d#15 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#15: int :: { Seq#Contains(digits#0, $Box(d#15)) } Seq#Contains(digits#0, $Box(d#15)) ==> LitInt(0) <= d#15 && d#15 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#16: int :: { Seq#Contains(digits#0, $Box(d#16)) } Seq#Contains(digits#0, $Box(d#16)) ==> LitInt(0) <= d#16 && d#16 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#7: char :: { Seq#Contains(chars#0, $Box(c#7)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#7)) ==> Seq#Contains(chars#0, $Box(c#7))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#10 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#10) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#10), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#10 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#10), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#11 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#11) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#11), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#11 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#11), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#17: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#17))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#17)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#17))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#18: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#18))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#18)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#18))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#19: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#19))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#19)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#19))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Seq#Contains(chars#0, $l#11#c#0))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, TChar)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#13: char :: { Map#Domain(digits#0)[$Box(c#13)] } { Seq#Contains(str#0, $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(str#0, $Box(c#13)) ==> Map#Domain(digits#0)[$Box(c#13)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#13: char :: { Map#Domain(digits#0)[$Box(c#13)] } { Seq#Contains(str#0, $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(str#0, $Box(c#13)) ==> Map#Domain(digits#0)[$Box(c#13)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#14: char :: { Map#Domain(digits#0)[$Box(c#14)] } { Seq#Contains(str#0, $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(str#0, $Box(c#14)) ==> Map#Domain(digits#0)[$Box(c#14)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Map#Domain(digits#0)[$l#25#c#0])), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar)), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Map#Domain(digits#0)[$l#25#c#0])), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar)), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Map#Domain(digits#0)[$l#26#c#0])), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TChar)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(Map#Domain(digits#0)[$l#27#c#0])), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar)), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#15 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#15) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#15)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#15)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#15 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#15) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#15) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#15)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#15) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#15))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#15 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#15) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#15) else (var tl#30 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#15)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#30)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#15 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#15) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#15) else (var tl#31 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#15)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#31)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#16 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#16) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#16)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#16)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#16 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#16) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#16) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#16)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#16) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#16))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#16 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#16) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#16) else (var tl#32 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#16)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#32)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#16 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#16) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#16) else (var tl#33 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#16)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#33)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#17 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#17) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#17)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#17)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#17 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#17) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#17) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#17)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#17) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#17))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#17 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#17) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#17) else (var tl#34 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#17)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#34)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#17 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#17) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#17) else (var tl#35 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#17)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#35)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#6: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#6)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#6)) } $Is(c#6, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#6)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#6))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#9#c#0))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, TChar)), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#11: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)] } { Seq#Contains(str#0, $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(str#0, $Box(c#11)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#11: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)] } { Seq#Contains(str#0, $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(str#0, $Box(c#11)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#11)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#12: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#12)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#12)] } { Seq#Contains(str#0, $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(str#0, $Box(c#12)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#12)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#12)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#20#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#20#c#0]): int < base#0)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, TChar)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#20#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#20#c#0]): int < base#0)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, TChar)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#21#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#21#c#0]): int < base#0)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#12 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#12)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#24 := JSON_mErrors.DeserializationError.b(this); (var b0#12 := JSON_mErrors.DeserializationError.expected(this); (var c#24 := (if b#24 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#24)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#12)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#24)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#25 := JSON_mErrors.DeserializationError.b(this); (var bs0#12 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#25 := (if b#25 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#25)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#12 := Seq#Create(TChar, $Heap, Seq#Length(bs0#12), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#12, $Unbox($l#22#idx#0): int)): int))), (lambda $l#22#heap#0: Heap, $l#22#idx#0: Box :: $IsBox($l#22#idx#0, TInt) && LitInt(0) <= $Unbox($l#22#idx#0): int && $Unbox($l#22#idx#0): int < Seq#Length(bs0#12)), (lambda $l#22#heap#0: Heap, $l#22#idx#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#12), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#25))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#14 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#14)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#28 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#14 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#28 := (if b#28 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#28)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#14)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#28)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#29 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#14 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#29 := (if b#29 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#29)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#14 := Seq#Create(TChar, $Heap, Seq#Length(bs0#14), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#14, $Unbox($l#25#idx#0): int)): int))), (lambda $l#25#heap#0: Heap, $l#25#idx#0: Box :: $IsBox($l#25#idx#0, TInt) && LitInt(0) <= $Unbox($l#25#idx#0): int && $Unbox($l#25#idx#0): int < Seq#Length(bs0#14)), (lambda $l#25#heap#0: Heap, $l#25#idx#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#14), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#29))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#13 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#13, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#12 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#12, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#12 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#12)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#15 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#15, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#14 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#14, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#14 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#14)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall $Heap: Heap, c#0: int :: { JSON_mSpec.__default.EscapeUnicode(c#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(c#0) || ($IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(c#0, LitInt(16)) && (var sStr#4 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#4)) && JSON_mSpec.__default.EscapeUnicode(c#0) == (var sStr#4 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); (var s#4 := UnicodeStrings.__default.ASCIIToUTF16(sStr#4); Seq#Append(s#4, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#4), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#14#heap#0: Heap, $l#14#_v0#0: Box :: $IsBox($l#14#_v0#0, TInt)), (lambda $l#14#heap#0: Heap, $l#14#_v0#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $Heap: Heap, c#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(LitInt(c#0)) || ($IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(LitInt(c#0), LitInt(16)) && (var sStr#5 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#5)) && JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)) == (var sStr#5 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); (var s#5 := Lit(UnicodeStrings.__default.ASCIIToUTF16(sStr#5)); Seq#Append(s#5, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#5), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: $IsBox($l#16#_v0#0, TInt)), (lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) } JSON_mSpec.__default.Escape#canCall(str#0, start#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(str#0) > start#0 ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(34) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(92) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(8) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(12) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(10) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(13) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(9) ==> (var c#5 := $Unbox(Seq#Index(str#0, start#0)): int; c#5 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#5))))))))) && JSON_mSpec.__default.Escape#canCall(str#0, start#0 + 1)) && JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) == (if start#0 >= Seq#Length(str#0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#5 := $Unbox(Seq#Index(str#0, start#0)): int; (if c#5 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#5)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))))))))))), JSON_mSpec.__default.Escape($ly, str#0, start#0 + 1))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(34) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(92) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(8) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(12) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(10) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(13) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(9) ==> (var c#6 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; c#6 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#6))))))))) && JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0 + 1))) && JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#6 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; (if c#6 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#6)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0)))))))))))), JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0 + 1)))));

axiom (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) } JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, start#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(str#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#4 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (var utf16#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#4, LitInt(0)) && (var escaped#4 := JSON_mSpec.__default.Escape($LS($LZ), utf16#4, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#4) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#4), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#4 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#4), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) && (var utf32#4 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#4) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#4), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == (var valueOrError0#4 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var utf16#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; (var escaped#4 := JSON_mSpec.__default.Escape($LS($LZ), utf16#4, LitInt(0)); (var valueOrError1#4 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#4), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#4) else (var utf32#4 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4)): Seq; Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#4), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))));

axiom (forall str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(start#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(str#0)) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#5 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (var utf16#5 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#5, LitInt(0)) && (var escaped#5 := JSON_mSpec.__default.Escape($LS($LZ), utf16#5, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#5) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#5), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#5 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#5), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) && (var utf32#5 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#5) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#5), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) == (var valueOrError0#5 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var utf16#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq); (var escaped#5 := Lit(JSON_mSpec.__default.Escape($LS($LZ), utf16#5, LitInt(0))); (var valueOrError1#5 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.FromUTF16Checked(escaped#5)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#5) else (var utf32#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5)): Seq); Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF8Checked(utf32#5)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))))))))))));

axiom (forall str#0: Seq :: { JSON_mSpec.__default.String(str#0) } JSON_mSpec.__default.String#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0)) && (var valueOrError0#4 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(str#0) == (var valueOrError0#4 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var inBytes#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#4), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mSpec.__default.String(Lit(str#0)) } JSON_mSpec.__default.String#canCall(Lit(str#0)) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(0)) && (var valueOrError0#5 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(Lit(str#0)) == (var valueOrError0#5 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var inBytes#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#5), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));

axiom (forall n#0: int :: { JSON_mSpec.__default.IntToBytes(n#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10)) && (var s#4 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#4)) && JSON_mSpec.__default.IntToBytes(n#0) == (var s#4 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8(s#4)));

axiom (forall n#0: int :: {:weight 3} { JSON_mSpec.__default.IntToBytes(LitInt(n#0)) } JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(n#0), LitInt(10)) && (var s#5 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#5)) && JSON_mSpec.__default.IntToBytes(LitInt(n#0)) == (var s#5 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); Lit(UnicodeStrings.__default.ASCIIToUTF8(s#5))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($LS($ly), kv#0) } JSON_mSpec.__default.KeyValue#canCall(kv#0) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq) && (var valueOrError0#4 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.JSON#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType) && (var valueOrError1#4 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), kv#0) == (var valueOrError0#4 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var key#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; (var valueOrError1#4 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#4) else (var value#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#4, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#4))))))))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) } JSON_mSpec.__default.KeyValue#canCall(Lit(kv#0)) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.String#canCall(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq)) && (var valueOrError0#5 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.JSON#canCall(Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType)) && (var valueOrError1#5 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) == (var valueOrError0#5 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var key#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq); (var valueOrError1#5 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#5) else (var value#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#5, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#5))))))))));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) } JSON_mSpec.__default.Join#canCall(sep#0, items#0) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(items#0) != LitInt(0) ==> (var valueOrError0#4 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Seq#Length(items#0) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(sep#0, Seq#Drop(items#0, LitInt(1))) && (var valueOrError1#4 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4))))))) && JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) == (if Seq#Length(items#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#4 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var first#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; (if Seq#Length(items#0) == LitInt(1) then #Wrappers.Result.Success($Box(first#4)) else (var valueOrError1#4 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#4) else (var rest#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#4, sep#0), rest#4))))))))))));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: {:weight 3} { JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) } JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(items#0)) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(Lit(items#0)) != LitInt(0) ==> (var valueOrError0#5 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Seq#Length(Lit(items#0)) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1)))) && (var valueOrError1#5 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5))))))) && JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) == (if Seq#Length(Lit(items#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#5 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var first#5 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq; (if Seq#Length(Lit(items#0)) == LitInt(1) then #Wrappers.Result.Success($Box(first#5)) else (var valueOrError1#5 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#5) else (var rest#5 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#5, sep#0), rest#5))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSpec.__default.Object($LS($ly), obj#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(obj#0) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#25#i#0: int :: LitInt(0) <= $l#25#i#0 && $l#25#i#0 < Seq#Length(obj#0) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, $l#25#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#26#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#26#i#0): int)): DatatypeType))), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $IsBox($l#26#i#0, TInt) && LitInt(0) <= $Unbox($l#26#i#0): int && $Unbox($l#26#i#0): int < Seq#Length(obj#0)), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $ly)))) && (var valueOrError0#4 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#27#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#27#i#0): int)): DatatypeType))), (lambda $l#27#heap#0: Heap, $l#27#i#0: Box :: $IsBox($l#27#i#0, TInt) && LitInt(0) <= $Unbox($l#27#i#0): int && $Unbox($l#27#i#0): int < Seq#Length(obj#0)), (lambda $l#27#heap#0: Heap, $l#27#i#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), obj#0) == (var valueOrError0#4 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#24#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#24#i#0): int)): DatatypeType))), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $IsBox($l#24#i#0, TInt) && LitInt(0) <= $Unbox($l#24#i#0): int && $Unbox($l#24#i#0): int < Seq#Length(obj#0)), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var middle#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#4), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: {:weight 3} { JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(Lit(obj#0)) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#29#i#0: int :: LitInt(0) <= $l#29#i#0 && $l#29#i#0 < Seq#Length(Lit(obj#0)) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(Lit(obj#0), $l#29#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#30#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#30#i#0): int)): DatatypeType))), (lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: $IsBox($l#30#i#0, TInt) && LitInt(0) <= $Unbox($l#30#i#0): int && $Unbox($l#30#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#5 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#31#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#31#i#0): int)): DatatypeType))), (lambda $l#31#heap#0: Heap, $l#31#i#0: Box :: $IsBox($l#31#i#0, TInt) && LitInt(0) <= $Unbox($l#31#i#0): int && $Unbox($l#31#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#31#heap#0: Heap, $l#31#i#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)) == (var valueOrError0#5 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#28#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#28#i#0): int)): DatatypeType))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $IsBox($l#28#i#0, TInt) && LitInt(0) <= $Unbox($l#28#i#0): int && $Unbox($l#28#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var middle#5 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#5), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSpec.__default.Array($LS($ly), arr#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(arr#0) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#25#i#0: int :: LitInt(0) <= $l#25#i#0 && $l#25#i#0 < Seq#Length(arr#0) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, $l#25#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#26#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#26#i#0): int)): DatatypeType))), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: $IsBox($l#26#i#0, TInt) && LitInt(0) <= $Unbox($l#26#i#0): int && $Unbox($l#26#i#0): int < Seq#Length(arr#0)), (lambda $l#26#heap#0: Heap, $l#26#i#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $ly)))) && (var valueOrError0#4 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#27#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#27#i#0): int)): DatatypeType))), (lambda $l#27#heap#0: Heap, $l#27#i#0: Box :: $IsBox($l#27#i#0, TInt) && LitInt(0) <= $Unbox($l#27#i#0): int && $Unbox($l#27#i#0): int < Seq#Length(arr#0)), (lambda $l#27#heap#0: Heap, $l#27#i#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), arr#0) == (var valueOrError0#4 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#24#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#24#i#0): int)): DatatypeType))), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: $IsBox($l#24#i#0, TInt) && LitInt(0) <= $Unbox($l#24#i#0): int && $Unbox($l#24#i#0): int < Seq#Length(arr#0)), (lambda $l#24#heap#0: Heap, $l#24#i#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#4) else (var middle#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#4), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: {:weight 3} { JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(Lit(arr#0)) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#29#i#0: int :: LitInt(0) <= $l#29#i#0 && $l#29#i#0 < Seq#Length(Lit(arr#0)) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(Lit(arr#0), $l#29#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#30#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#30#i#0): int)): DatatypeType))), (lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: $IsBox($l#30#i#0, TInt) && LitInt(0) <= $Unbox($l#30#i#0): int && $Unbox($l#30#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#30#heap#0: Heap, $l#30#i#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#5 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#31#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#31#i#0): int)): DatatypeType))), (lambda $l#31#heap#0: Heap, $l#31#i#0: Box :: $IsBox($l#31#i#0, TInt) && LitInt(0) <= $Unbox($l#31#i#0): int && $Unbox($l#31#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#31#heap#0: Heap, $l#31#i#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)) == (var valueOrError0#5 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#28#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#28#i#0): int)): DatatypeType))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $IsBox($l#28#i#0, TInt) && LitInt(0) <= $Unbox($l#28#i#0): int && $Unbox($l#28#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#5) else (var middle#5 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#5), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($LS($ly), js#0) } JSON_mSpec.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mValues.JSON.Null_q(js#0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!JSON_mValues.JSON.Null_q(js#0) ==> (JSON_mValues.JSON.Bool_q(js#0) ==> (var b#9 := JSON_mValues.JSON.b(js#0); (b#9 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#9 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!JSON_mValues.JSON.Bool_q(js#0) ==> (JSON_mValues.JSON.String_q(js#0) ==> (var str#9 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String#canCall(str#9))) && (!JSON_mValues.JSON.String_q(js#0) ==> (JSON_mValues.JSON.Number_q(js#0) ==> (var dec#9 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number#canCall(dec#9))) && (!JSON_mValues.JSON.Number_q(js#0) ==> (JSON_mValues.JSON.Object_q(js#0) ==> (var obj#9 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object#canCall(obj#9))) && (!JSON_mValues.JSON.Object_q(js#0) ==> (var arr#9 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array#canCall(arr#9))))))) && JSON_mSpec.__default.JSON($LS($ly), js#0) == (if JSON_mValues.JSON.Null_q(js#0) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(js#0) then (var b#8 := JSON_mValues.JSON.b(js#0); #Wrappers.Result.Success($Box((if b#8 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(js#0) then (var str#8 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String(str#8)) else (if JSON_mValues.JSON.Number_q(js#0) then (var dec#8 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number(dec#8)) else (if JSON_mValues.JSON.Object_q(js#0) then (var obj#8 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object($ly, obj#8)) else (var arr#8 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array($ly, arr#8))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) } JSON_mSpec.__default.JSON#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (var b#11 := Lit(JSON_mValues.JSON.b(Lit(js#0))); (b#11 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#11 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (var str#11 := Lit(JSON_mValues.JSON.str(Lit(js#0))); JSON_mSpec.__default.String#canCall(str#11))) && (!Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (var dec#11 := Lit(JSON_mValues.JSON.num(Lit(js#0))); JSON_mSpec.__default.Number#canCall(dec#11))) && (!Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var obj#11 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); JSON_mSpec.__default.Object#canCall(obj#11))) && (!Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var arr#11 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); JSON_mSpec.__default.Array#canCall(arr#11))))))) && JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) == (if JSON_mValues.JSON.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(Lit(js#0)) then (var b#10 := Lit(JSON_mValues.JSON.b(Lit(js#0))); #Wrappers.Result.Success($Box((if b#10 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(Lit(js#0)) then (var str#10 := Lit(JSON_mValues.JSON.str(Lit(js#0))); Lit(JSON_mSpec.__default.String(str#10))) else (if JSON_mValues.JSON.Number_q(Lit(js#0)) then (var dec#10 := Lit(JSON_mValues.JSON.num(Lit(js#0))); Lit(JSON_mSpec.__default.Number(dec#10))) else (if JSON_mValues.JSON.Object_q(Lit(js#0)) then (var obj#10 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); Lit(JSON_mSpec.__default.Object($LS($ly), obj#10))) else (var arr#10 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); Lit(JSON_mSpec.__default.Array($LS($ly), arr#10)))))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#6: int :: { JSON_mGrammar.__default.Blank_q(b#6) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) } LitInt(0) <= b#6 && b#6 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#6))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#6: int :: { JSON_mGrammar.__default.Blank_q(b#6) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) } LitInt(0) <= b#6 && b#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) ==> JSON_mGrammar.__default.Blank_q(b#6))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#7: int :: { JSON_mGrammar.__default.Blank_q(b#7) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#7)) } LitInt(0) <= b#7 && b#7 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#7)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#7))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#7: int :: { JSON_mGrammar.__default.Blank_q(b#7) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#7)) } LitInt(0) <= b#7 && b#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#7)) ==> JSON_mGrammar.__default.Blank_q(b#7))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#6: int :: { $Unbox(Seq#Index(s#0, idx#6)): DatatypeType } LitInt(0) <= idx#6 && idx#6 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#6)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#6: int :: { $Unbox(Seq#Index(s#0, idx#6)): DatatypeType } LitInt(0) <= idx#6 && idx#6 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#6)): DatatypeType)) <==> idx#6 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#7: int :: { $Unbox(Seq#Index(s#0, idx#7)): DatatypeType } LitInt(0) <= idx#7 && idx#7 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#7)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#7: int :: { $Unbox(Seq#Index(s#0, idx#7)): DatatypeType } LitInt(0) <= idx#7 && idx#7 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#7)): DatatypeType)) <==> idx#7 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#6: int :: { JSON_mGrammar.__default.Digit_q(b#6) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) } LitInt(0) <= b#6 && b#6 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#6))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#6: int :: { JSON_mGrammar.__default.Digit_q(b#6) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) } LitInt(0) <= b#6 && b#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#6)) ==> JSON_mGrammar.__default.Digit_q(b#6))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#7: int :: { JSON_mGrammar.__default.Digit_q(b#7) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#7)) } LitInt(0) <= b#7 && b#7 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#7)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#7))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#7: int :: { JSON_mGrammar.__default.Digit_q(b#7) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#7)) } LitInt(0) <= b#7 && b#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#7)) ==> JSON_mGrammar.__default.Digit_q(b#7))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#3: int :: { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) } Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < base#0) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#3 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#4 := Seq#Append(digits'#3, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#4))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#4 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#5 := Seq#Append(digits'#4, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#5))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#5 := Lit(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#6 := Seq#Append(digits'#5, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#6))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#3: int :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#8: int :: { Seq#Contains(digits#0, $Box(d#8)) } Seq#Contains(digits#0, $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#3: int :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(chars#0) > 1) ==> (var base#2 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#2) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) == (var base#2 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#3 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), base#3) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#3 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#5: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#5))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#5)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#5))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#6: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#6))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#6)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#6))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#7: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#7))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#7)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, Lit(is_digit#0), $Box(c#7))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(chars#0) > 1) ==> JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Seq#Contains(chars#0, $l#7#c#0))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint16())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(0 - n#0, chars#0))));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#5: int :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && (forall c#5: int :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#6: int :: { Map#Domain(digits#0)[$Box(c#6)] } { Seq#Contains(str#0, $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#6)) ==> Map#Domain(digits#0)[$Box(c#6)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint16())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint16())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Map#Domain(digits#0)[$l#10#c#0])), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint16())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(digits#0)[$l#11#c#0])), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint16())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#3: int :: { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) } Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#3)) ==> LitInt(0) <= d#3 && d#3 < base#0) && $Is(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#3 := JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#4 := Seq#Append(digits'#3, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#4))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#4 := JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#5 := Seq#Append(digits'#4, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#5))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#5 := Lit(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#6 := Seq#Append(digits'#5, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#6))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#3: int :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#7: int :: { Seq#Contains(digits#0, $Box(d#7)) } Seq#Contains(digits#0, $Box(d#7)) ==> LitInt(0) <= d#7 && d#7 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#8: int :: { Seq#Contains(digits#0, $Box(d#8)) } Seq#Contains(digits#0, $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#3: int :: { Seq#Contains(chars#0, $Box(c#3)) } { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#3)) ==> Seq#Contains(chars#0, $Box(c#3))) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> (var base#2 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#2) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#2 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#2), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#3 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#3) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#3 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#3), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#5: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#5))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#5)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#5))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#6: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#6))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#6)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#6))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#7: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#7))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#7)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box(c#7))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> JSON_mDeserializer_mByteStrConversion.__default.NumberStr(JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(Seq#Contains(chars#0, $l#7#c#0))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint8())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> (n#0 >= LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0)) && (LitInt(0) > n#0 ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(0 - n#0, chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) == (if n#0 >= LitInt(0) then JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(0 - n#0, chars#0))));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), minus#0) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(Lit(chars#0)) > 1) ==> (LitInt(n#0) >= LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0))) && (LitInt(0) > LitInt(n#0) ==> JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(0 - n#0), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), Lit(chars#0), LitInt(minus#0)) == (if LitInt(n#0) >= LitInt(0) then JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(0 - n#0), Lit(chars#0)))));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#0: int :: { Map#Domain(digits#0)[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(digits#0)[$Box(c#0)])) ==> LitInt(0) <= JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, str#0, base#0, digits#0));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#5: int :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#5: int :: { Map#Domain(digits#0)[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(digits#0)[$Box(c#5)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#6: int :: { Map#Domain(digits#0)[$Box(c#6)] } { Seq#Contains(str#0, $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#6)) ==> Map#Domain(digits#0)[$Box(c#6)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(Map#Domain(digits#0)[$l#9#c#0])), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Map#Domain(digits#0)[$l#10#c#0])), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Map#Domain(digits#0)[$l#11#c#0])), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint8())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

const unique class.JSON_mConcreteSyntax_mSpec.__default: ClassName;

function JSON_mConcreteSyntax_mSpec.__default.View(v#0: DatatypeType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View(v#0) } JSON_mConcreteSyntax_mSpec.__default.View#canCall(v#0) || (0 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.View(v#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 0 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View(v#0) } JSON_mConcreteSyntax_mSpec.__default.View#canCall(v#0) || (0 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.View(v#0) == JSON_mUtils_mViews_mCore.View__.Bytes(v#0));
axiom 0 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.View(Lit(v#0)) } JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(v#0)) || (0 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && JSON_mConcreteSyntax_mSpec.__default.View(Lit(v#0)) == Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0))));
}

function JSON_mConcreteSyntax_mSpec.__default.View#canCall(v#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.View#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mConcreteSyntax_mSpec.__default.View#requires(v#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.View (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.View(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.View (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.View(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.View", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(11,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.View(v#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume JSON_mConcreteSyntax_mSpec.__default.View(v#0) == JSON_mUtils_mViews_mCore.View__.Bytes(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.View(v#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, self#0: DatatypeType, fT#0: HandleType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mGrammar.Structural.Structural_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.Structural.before(self#0)) && JSON_mGrammar.Structural.Structural_q(self#0) && JSON_mGrammar.Structural.Structural_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.Structural.after(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.Structural.before(self#0)), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Structural.t(self#0))): Seq), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.Structural.after(self#0))));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), fT#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.after(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), fT#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Lit(JSON_mGrammar.Structural.t(Lit(self#0))))): Seq), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.after(Lit(self#0))))));
axiom 1 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), Lit(fT#0)) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.after(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), Lit(fT#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Lit(JSON_mGrammar.Structural.t(Lit(self#0))))): Seq), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.after(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, self#0: DatatypeType, fT#0: HandleType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Structural#requires(Ty, DatatypeType, HandleType) : bool;

axiom (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Structural#requires(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Structural#requires(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Structural (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)), fT#0: HandleType where $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0) } JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(self#0) || (2 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(self#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle()) && JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(self#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(self#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Lit(self#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle()) && JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(self#0)) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), Lit(self#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle()));
}

function JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(self#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires(self#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) ==> (JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires(self#0) <==> true));

function JSON_mConcreteSyntax_mSpec.__default.View#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "JSON.ConcreteSyntax.Spec.StructuralView (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.StructuralView (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.StructuralView", " | ", self#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(19,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 0 != $FunctionContextHeight;
    ##self#0 := self#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, self#0: DatatypeType, fT#0: HandleType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $IsAlloc(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T), $Heap) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())), $Heap)) ==> (JSON_mGrammar.Maybe.Empty_q(self#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), Seq#Empty(): Seq)) && (JSON_mGrammar.Maybe.NonEmpty_q(self#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq)) && $Is(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) == (if JSON_mGrammar.Maybe.Empty_q(self#0) then Seq#Empty(): Seq else $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), fT#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), fT#0) == (if JSON_mGrammar.Maybe.Empty_q(Lit(self#0)) then Seq#Empty(): Seq else $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Lit(JSON_mGrammar.Maybe.t(Lit(self#0))))): Seq));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), Lit(fT#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), Lit(fT#0)) == (if JSON_mGrammar.Maybe.Empty_q(Lit(self#0)) then Seq#Empty(): Seq else $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Lit(JSON_mGrammar.Maybe.t(Lit(self#0))))): Seq));
}

function JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, self#0: DatatypeType, fT#0: HandleType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Maybe#requires(Ty, DatatypeType, HandleType) : bool;

axiom (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Maybe#requires(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Maybe#requires(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Maybe (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)), fT#0: HandleType where $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) returns (bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id23753"} JSON_mGrammar.Maybe.Empty_q(self#0) ==> Seq#Equal(bs#0, Seq#Empty(): Seq);
  free ensures {:id "id23754"} JSON_mGrammar.Maybe.NonEmpty_q(self#0) ==> Seq#Equal(bs#0, $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Maybe (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, self#0: DatatypeType, fT#0: HandleType) returns (bs#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Maybe", " | ", JSON.ConcreteSyntax.Spec._default.Maybe$T, " | ", self#0, " | ", fT#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(23,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume JSON_mGrammar.Maybe.Empty_q(self#0);
    assume Seq#Equal(bs#0, Seq#Empty(): Seq);
    goto anon5;

  anon14_Else:
    assume JSON_mGrammar.Maybe.Empty_q(self#0) ==> Seq#Equal(bs#0, Seq#Empty(): Seq);
    goto anon5;

  anon5:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume JSON_mGrammar.Maybe.NonEmpty_q(self#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(self#0);
    assume Seq#Equal(bs#0, $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq);
    goto anon8;

  anon15_Else:
    assume JSON_mGrammar.Maybe.NonEmpty_q(self#0) ==> Seq#Equal(bs#0, $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq);
    goto anon8;

  anon8:
    assume false;
    return;

  anon13_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} JSON_mGrammar.Maybe.Empty_q(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon16_Else:
    assume {:partition} !JSON_mGrammar.Maybe.Empty_q(self#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) == $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq;
    assume true;
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon12:
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) == bs#0;
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, ts#0: Seq, fT#0: HandleType) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $IsAlloc(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T), $Heap) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8())), $Heap) && (forall d#0: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#0) } { Seq#Contains(ts#0, d#0) } $IsBox(d#0, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#0) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#0))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#1) } { Seq#Contains(ts#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#1) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#1))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#2: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#2) } { Seq#Contains(ts#0, d#2) } $IsBox(d#2, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#2) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#2))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#3) } { Seq#Contains(ts#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#3) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#3))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));
}

function JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, ts#0: Seq, fT#0: HandleType) : bool;

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, AsFuelBottom($ly), ts#0, fT#0) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LZ, ts#0, fT#0));

function JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(Ty, LayerType, Seq, HandleType) : bool;

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#1) } { Seq#Contains(ts#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#1) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#1))));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.ConcatBytes (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, ts#0: Seq where $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)), fT#0: HandleType where $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.ConcatBytes (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, ts#0: Seq, fT#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var d#4: Box;
  var ##x0#0: Box;
  var b$reqreads#0: bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.ConcatBytes", " | ", JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, " | ", ts#0, " | ", fT#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(30,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc d#4;
    assume $IsBox(d#4, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && $IsAllocBox(d#4, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume Seq#Contains(ts#0, d#4);
    assume $IsAllocBox($Box(fT#0), Tclass._System.___hFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#0 := d#4;
    assume $IsAllocBox(##x0#0, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, ##x0#0)[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#4);
    assume Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#4);
    goto anon4;

  anon9_Else:
    assume Seq#Contains(ts#0, d#4) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#4);
    goto anon4;

  anon4:
    assume (forall d#0: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#0) } { Seq#Contains(ts#0, d#0) } $IsBox(d#0, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#0) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#0));
    assume b$reqreads#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($LZ), ts#0, fT#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon10_Else:
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Seq#Length(ts#0) == LitInt(0);
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($LZ), ts#0, fT#0) == Lit(Seq#Empty(): Seq);
    assume true;
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($LZ), ts#0, fT#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon11_Else:
    assume {:partition} Seq#Length(ts#0) != LitInt(0);
    assume 0 <= LitInt(0) && LitInt(0) < Seq#Length(ts#0);
    assume Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)));
    assume 0 <= LitInt(1) && LitInt(1) <= Seq#Length(ts#0);
    ##ts#0 := Seq#Drop(ts#0, LitInt(1));
    assume $IsAlloc(##ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T), $Heap);
    ##fT#0 := fT#0;
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#5: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#5) } { Seq#Contains(##ts#0, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(##ts#0, d#5) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#5));
    assume (forall d#5: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#5) } { Seq#Contains(##ts#0, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(##ts#0, d#5) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#5));
    assume Seq#Rank(##ts#0) < Seq#Rank(ts#0);
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0);
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($LZ), ts#0, fT#0) == Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($LZ), Seq#Drop(ts#0, LitInt(1)), fT#0));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($LZ), ts#0, fT#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, self#0: DatatypeType, fDatum#0: HandleType) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8())), $Heap) && (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#0) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#0)))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#1) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#1)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#2) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#2)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#3) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#3)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, self#0: DatatypeType, fDatum#0: HandleType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(Ty, Ty, DatatypeType, HandleType) : bool;

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#1) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#1)))));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Bracketed (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())), fDatum#0: HandleType where $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Bracketed (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, self#0: DatatypeType, fDatum#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var d#4: DatatypeType;
  var ##x0#0: DatatypeType;
  var b$reqreads#0: bool;
  var ##self#0: DatatypeType;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var ##self#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Bracketed", " | ", JSON.ConcreteSyntax.Spec._default.Bracketed$D, " | ", JSON.ConcreteSyntax.Spec._default.Bracketed$S, " | ", self#0, " | ", fDatum#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(37,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc d#4;
    assume $Is(d#4, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && $IsAlloc(d#4, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $Heap);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume DtRank(d#4) < DtRank(self#0);
    assume $IsAllocBox($Box(fDatum#0), Tclass._System.___hFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#0 := d#4;
    assume $IsAlloc(##x0#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(##x0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#4));
    assume Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#4));
    goto anon4;

  anon7_Else:
    assume DtRank(d#4) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#4));
    goto anon4;

  anon4:
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#0) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#0)));
    assume b$reqreads#0;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon8_Else:
    assume JSON_mGrammar.Bracketed.Bracketed_q(self#0);
    ##self#0 := JSON_mGrammar.Bracketed.l(self#0);
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(self#0);
    ##ts#0 := JSON_mGrammar.Bracketed.data(self#0);
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)), $Heap);
    ##fT#0 := fDatum#0;
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#5: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#5)) } { Seq#Contains(##ts#0, $Box(d#5)) } $Is(d#5, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && Seq#Contains(##ts#0, $Box(d#5)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#5)));
    assume (forall d#5: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#5)) } { Seq#Contains(##ts#0, $Box(d#5)) } $Is(d#5, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && Seq#Contains(##ts#0, $Box(d#5)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#5)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(self#0);
    ##self#1 := JSON_mGrammar.Bracketed.r(self#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0)));
    assume JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly: LayerType, self#0: DatatypeType) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jKeyValue())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jKeyValue())) ==> JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k(self#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon(self#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(self#0)) && JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(JSON_mGrammar.jKeyValue.k(self#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.jKeyValue.colon(self#0))), JSON_mConcreteSyntax_mSpec.__default.Value($ly, JSON_mGrammar.jKeyValue.v(self#0))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(Lit(self#0)) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jKeyValue())) ==> JSON_mGrammar.jKeyValue.KeyValue_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit(self#0)))) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.jKeyValue.colon(Lit(self#0)))) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), Lit(self#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(Lit(JSON_mGrammar.jKeyValue.k(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(JSON_mGrammar.jKeyValue.v(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(self#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), self#0) == JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, self#0));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue(AsFuelBottom($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, self#0) == JSON_mConcreteSyntax_mSpec.__default.KeyValue($LZ, self#0));

function JSON_mConcreteSyntax_mSpec.__default.KeyValue#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue#requires($ly, self#0) } $Is(self#0, Tclass.JSON_mGrammar.jKeyValue()) ==> (JSON_mConcreteSyntax_mSpec.__default.KeyValue#requires($ly, self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.KeyValue (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.KeyValue(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.jKeyValue()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.KeyValue (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.KeyValue(self#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.KeyValue", " | ", self#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(45,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume JSON_mGrammar.jKeyValue.KeyValue_q(self#0);
    ##self#0 := JSON_mGrammar.jKeyValue.k(self#0);
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k(self#0));
    assume JSON_mGrammar.jKeyValue.KeyValue_q(self#0);
    ##self#1 := JSON_mGrammar.jKeyValue.colon(self#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon(self#0));
    assume JSON_mGrammar.jKeyValue.KeyValue_q(self#0);
    ##self#2 := JSON_mGrammar.jKeyValue.v(self#0);
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume DtRank(##self#2) < DtRank(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(self#0));
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(JSON_mGrammar.jKeyValue.k(self#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.jKeyValue.colon(self#0))), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), JSON_mGrammar.jKeyValue.v(self#0)));
    assume JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k(self#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon(self#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(self#0));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Frac(self#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac(self#0) } JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(self#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jfrac())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Frac(self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac(self#0) } JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(self#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jfrac())) ==> JSON_mGrammar.jfrac.JFrac_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jfrac.period(self#0)) && JSON_mGrammar.jfrac.JFrac_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jfrac.num(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Frac(self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jfrac.period(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jfrac.num(self#0))));
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Frac(Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(Lit(self#0)) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jfrac())) ==> JSON_mGrammar.jfrac.JFrac_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jfrac.period(Lit(self#0)))) && JSON_mGrammar.jfrac.JFrac_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jfrac.num(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Frac(Lit(self#0)) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jfrac.period(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jfrac.num(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(self#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Frac#requires(DatatypeType) : bool;

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac#requires(self#0) } $Is(self#0, Tclass.JSON_mGrammar.jfrac()) ==> (JSON_mConcreteSyntax_mSpec.__default.Frac#requires(self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Frac (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Frac(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.jfrac()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mConcreteSyntax_mSpec.__default.Exp(self#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp(self#0) } JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(self#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jexp())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Exp(self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp(self#0) } JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(self#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jexp())) ==> JSON_mGrammar.jexp.JExp_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jexp.e(self#0)) && JSON_mGrammar.jexp.JExp_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jexp.sign(self#0)) && JSON_mGrammar.jexp.JExp_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jexp.num(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Exp(self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jexp.e(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jexp.sign(self#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jexp.num(self#0))));
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Exp(Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(Lit(self#0)) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jexp())) ==> JSON_mGrammar.jexp.JExp_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jexp.e(Lit(self#0)))) && JSON_mGrammar.jexp.JExp_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jexp.sign(Lit(self#0)))) && JSON_mGrammar.jexp.JExp_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jexp.num(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Exp(Lit(self#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jexp.e(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jexp.sign(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jexp.num(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(self#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Exp#requires(DatatypeType) : bool;

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp#requires(self#0) } $Is(self#0, Tclass.JSON_mGrammar.jexp()) ==> (JSON_mConcreteSyntax_mSpec.__default.Exp#requires(self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Exp (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Exp(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.jexp()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mConcreteSyntax_mSpec.__default.Number(self#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number(self#0) } JSON_mConcreteSyntax_mSpec.__default.Number#canCall(self#0) || (2 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jnumber())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Number(self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number(self#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Number#canCall(self#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.jnumber())) ==> JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(self#0)) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(self#0)) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Number(self#0) == Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(self#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Number(Lit(self#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Number#canCall(Lit(self#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.jnumber())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jnumber.minus(Lit(self#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jnumber.num(Lit(self#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), Lit(JSON_mGrammar.jnumber.frac(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), Lit(JSON_mGrammar.jnumber.exp(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Number(Lit(self#0)) == Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jnumber.minus(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jnumber.num(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), Lit(JSON_mGrammar.jnumber.frac(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), Lit(JSON_mGrammar.jnumber.exp(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())));
}

function JSON_mConcreteSyntax_mSpec.__default.Number#canCall(self#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Number#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number#requires(self#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.jnumber()) ==> (JSON_mConcreteSyntax_mSpec.__default.Number#requires(self#0) <==> true));

function JSON_mConcreteSyntax_mSpec.__default.Frac#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mConcreteSyntax_mSpec.__default.Exp#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Number (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Number(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.jnumber()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Number (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Number(self#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##v#0: DatatypeType;
  var ##v#1: DatatypeType;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Number", " | ", self#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(57,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Number(self#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume JSON_mGrammar.jnumber.JNumber_q(self#0);
    ##v#0 := JSON_mGrammar.jnumber.minus(self#0);
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(self#0));
    assume JSON_mGrammar.jnumber.JNumber_q(self#0);
    ##v#1 := JSON_mGrammar.jnumber.num(self#0);
    assume $IsAlloc(##v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(self#0));
    assume JSON_mGrammar.jnumber.JNumber_q(self#0);
    assume 1 != $FunctionContextHeight;
    ##self#0 := JSON_mGrammar.jnumber.frac(self#0);
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mGrammar.jnumber.JNumber_q(self#0);
    assume 1 != $FunctionContextHeight;
    ##self#1 := JSON_mGrammar.jnumber.exp(self#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Number(self#0) == Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(self#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()));
    assume JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(self#0)) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(self#0)) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Number(self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.String(self#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String(self#0) } JSON_mConcreteSyntax_mSpec.__default.String#canCall(self#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jstring())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.String(self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String(self#0) } JSON_mConcreteSyntax_mSpec.__default.String#canCall(self#0) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jstring())) ==> JSON_mGrammar.jstring.JString_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jstring.lq(self#0)) && JSON_mGrammar.jstring.JString_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jstring.contents(self#0)) && JSON_mGrammar.jstring.JString_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jstring.rq(self#0)) && JSON_mConcreteSyntax_mSpec.__default.String(self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jstring.lq(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jstring.contents(self#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jstring.rq(self#0))));
axiom 1 <= $FunctionContextHeight ==> (forall self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.String(Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.String#canCall(Lit(self#0)) || (1 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.jstring())) ==> JSON_mGrammar.jstring.JString_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jstring.lq(Lit(self#0)))) && JSON_mGrammar.jstring.JString_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jstring.contents(Lit(self#0)))) && JSON_mGrammar.jstring.JString_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jstring.rq(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.String(Lit(self#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jstring.lq(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jstring.contents(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jstring.rq(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.String#canCall(self#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.String#requires(DatatypeType) : bool;

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String#requires(self#0) } $Is(self#0, Tclass.JSON_mGrammar.jstring()) ==> (JSON_mConcreteSyntax_mSpec.__default.String#requires(self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.String (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.String(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.jstring()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0: DatatypeType) : Seq
uses {
axiom 3 <= $FunctionContextHeight ==> (forall c#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0) } JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(c#0) || (3 < $FunctionContextHeight && $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, c#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(c#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0) == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, c#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(c#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(c#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), Lit(c#0), JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(c#0)) == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), Lit(c#0), JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()));
}

function JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(c#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, c#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#requires(c#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#requires(c#0) <==> true));

function JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "JSON.ConcreteSyntax.Spec.CommaSuffix (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0: DatatypeType where $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.CommaSuffix (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.CommaSuffix", " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(65,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 2 != $FunctionContextHeight;
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0) == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle());
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Member($ly: LayerType, self#0: DatatypeType) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.Member#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Member($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Member#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(self#0))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Member#canCall(Lit(self#0)) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), Lit(self#0)) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Member#canCall(self#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), self#0) == JSON_mConcreteSyntax_mSpec.__default.Member($ly, self#0));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member(AsFuelBottom($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Member($ly, self#0) == JSON_mConcreteSyntax_mSpec.__default.Member($LZ, self#0));

function JSON_mConcreteSyntax_mSpec.__default.Member#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member#requires($ly, self#0) } $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> (JSON_mConcreteSyntax_mSpec.__default.Member#requires($ly, self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Member (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Member(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Member (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Member(self#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##c#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Member", " | ", self#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(70,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume JSON_mGrammar.Suffixed.Suffixed_q(self#0);
    ##self#0 := $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume DtRank(##self#0) < DtRank(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(self#0);
    ##c#0 := JSON_mGrammar.Suffixed.suffix(self#0);
    assume $IsAlloc(##c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0));
    assume JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(self#0)));
    assume JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Item($ly: LayerType, self#0: DatatypeType) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.Item#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Item($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Item#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(self#0))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Item#canCall(Lit(self#0)) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), Lit(self#0)) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Item#canCall(self#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), self#0) == JSON_mConcreteSyntax_mSpec.__default.Item($ly, self#0));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item(AsFuelBottom($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Item($ly, self#0) == JSON_mConcreteSyntax_mSpec.__default.Item($LZ, self#0));

function JSON_mConcreteSyntax_mSpec.__default.Item#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item#requires($ly, self#0) } $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> (JSON_mConcreteSyntax_mSpec.__default.Item#requires($ly, self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Item (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Item(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Item (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Item(self#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##c#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Item", " | ", self#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(74,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume JSON_mGrammar.Suffixed.Suffixed_q(self#0);
    ##self#0 := $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume DtRank(##self#0) < DtRank(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(self#0);
    ##c#0 := JSON_mGrammar.Suffixed.suffix(self#0);
    assume $IsAlloc(##c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0));
    assume JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(self#0)));
    assume JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Object($ly: LayerType, obj#0: DatatypeType) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || (4 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || (4 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> (forall $l#1#d#0: DatatypeType :: $Is($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#1#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#1#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#2#ly#0, $Unbox($l#2#d#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $IsBox($l#2#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#2#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#0#ly#0, $Unbox($l#0#d#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $IsBox($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#0#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || (4 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> (forall $l#4#d#0: DatatypeType :: $Is($l#4#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#4#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#4#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#5#ly#0, $Unbox($l#5#d#0): DatatypeType))), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $IsBox($l#5#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#5#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#3#ly#0, $Unbox($l#3#d#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $IsBox($l#3#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#3#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($ly))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object(AsFuelBottom($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0) == JSON_mConcreteSyntax_mSpec.__default.Object($LZ, obj#0));

function JSON_mConcreteSyntax_mSpec.__default.Object#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, obj#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, obj#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Object (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Object(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Object (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Object(obj#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var d#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##fDatum#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Object", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(78,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} DtRank(d#0) < DtRank(obj#0);
    ##self#0 := d#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    assume DtRank(##self#0) < DtRank(obj#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(d#0);
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), d#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(d#0);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon7;

  anon12_Else:
    assume {:partition} DtRank(obj#0) <= DtRank(d#0);
    goto anon7;

  anon11_Else:
    assume {:partition} !($Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon10_Else:
    goto anon8;

  anon8:
    ##self#1 := obj#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#7#ly#0, $Unbox($l#7#d#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $IsBox($l#7#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#7#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1) < DtRank(##self#1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)));
    assume (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1) < DtRank(##self#1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#8#ly#0, $Unbox($l#8#d#0): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $IsBox($l#8#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#8#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#10#ly#0, $Unbox($l#10#d#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $IsBox($l#10#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#10#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume (forall $l#11#d#0: DatatypeType :: $Is($l#11#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#11#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#11#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#12#ly#0, $Unbox($l#12#d#0): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $IsBox($l#12#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#12#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Array($ly: LayerType, arr#0: DatatypeType) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || (4 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || (4 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> (forall $l#1#d#0: DatatypeType :: $Is($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#1#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#1#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#2#ly#0, $Unbox($l#2#d#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: $IsBox($l#2#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#2#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#2#heap#0: Heap, $l#2#d#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#0#ly#0, $Unbox($l#0#d#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: $IsBox($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#0#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#0#heap#0: Heap, $l#0#d#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || (4 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> (forall $l#4#d#0: DatatypeType :: $Is($l#4#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#4#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#4#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#5#ly#0, $Unbox($l#5#d#0): DatatypeType))), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: $IsBox($l#5#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#5#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#5#heap#0: Heap, $l#5#d#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#3#ly#0, $Unbox($l#3#d#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: $IsBox($l#3#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#3#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#3#heap#0: Heap, $l#3#d#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($ly))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array(AsFuelBottom($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0) == JSON_mConcreteSyntax_mSpec.__default.Array($LZ, arr#0));

function JSON_mConcreteSyntax_mSpec.__default.Array#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, arr#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, arr#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Array (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Array(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Array (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Array(arr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var d#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##fDatum#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Array", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(82,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon9_Else:
    goto anon10_Then, anon10_Else;

  anon10_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#0;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} DtRank(d#0) < DtRank(arr#0);
    ##self#0 := d#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    assume DtRank(##self#0) < DtRank(arr#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(d#0);
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), d#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(d#0);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon7;

  anon12_Else:
    assume {:partition} DtRank(arr#0) <= DtRank(d#0);
    goto anon7;

  anon11_Else:
    assume {:partition} !($Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon7;

  anon7:
    assume false;
    goto anon8;

  anon10_Else:
    goto anon8;

  anon8:
    ##self#1 := arr#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#7#ly#0, $Unbox($l#7#d#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: $IsBox($l#7#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#7#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#7#heap#0: Heap, $l#7#d#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1) < DtRank(##self#1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)));
    assume (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1) < DtRank(##self#1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#8#ly#0, $Unbox($l#8#d#0): DatatypeType))), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: $IsBox($l#8#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#8#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#8#heap#0: Heap, $l#8#d#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#10#ly#0, $Unbox($l#10#d#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: $IsBox($l#10#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#10#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#10#heap#0: Heap, $l#10#d#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume (forall $l#11#d#0: DatatypeType :: $Is($l#11#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#11#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#11#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#12#ly#0, $Unbox($l#12#d#0): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: $IsBox($l#12#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#12#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#12#heap#0: Heap, $l#12#d#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.Value($ly: LayerType, self#0: DatatypeType) : Seq
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Value())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Value($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Value())) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#1 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#1))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#1 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#1))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#1 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#1))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#1 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#1))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#1 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#1))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#1 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#1))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#0 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#0)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#0 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#0)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#0 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#0)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#0 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#0)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#0 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0)) else (var arr#0 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || (4 < $FunctionContextHeight && $Is(self#0, Tclass.JSON_mGrammar.Value())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#3 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#3))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#3 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#3))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#3 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#3))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#3 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#3))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#3 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#3))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#3 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#3))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#2 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#2))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#2 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#2))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#2 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#2))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#2 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#2))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#2 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#2))) else (var arr#2 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#2)))))))));
}

function JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == JSON_mConcreteSyntax_mSpec.__default.Value($ly, self#0));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value(AsFuelBottom($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, self#0) == JSON_mConcreteSyntax_mSpec.__default.Value($LZ, self#0));

function JSON_mConcreteSyntax_mSpec.__default.Value#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, self#0) } $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, self#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.Spec.Value (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Value(self#0: DatatypeType where $Is(self#0, Tclass.JSON_mGrammar.Value()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.Value (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.Value(self#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var _mcc#5#0: DatatypeType;
  var arr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##arr#0: DatatypeType;
  var _mcc#4#0: DatatypeType;
  var obj#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##obj#0: DatatypeType;
  var _mcc#3#0: DatatypeType;
  var num#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##self#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var str#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##self#1: DatatypeType;
  var _mcc#1#0: DatatypeType;
  var b#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##v#0: DatatypeType;
  var _mcc#0#0: DatatypeType;
  var n#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##v#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.Value", " | ", self#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(86,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon11_Else:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} self#0 == #JSON.Grammar.Value.Null(_mcc#0#0);
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jnull());
    havoc n#Z#0;
    assume $Is(n#Z#0, Tclass.JSON_mGrammar.jnull()) && $IsAlloc(n#Z#0, Tclass.JSON_mGrammar.jnull(), $Heap);
    assume let#5#0#0 == _mcc#0#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.JSON_mGrammar.jnull());
    assume n#Z#0 == let#5#0#0;
    ##v#1 := n#Z#0;
    assume $IsAlloc(##v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0) == JSON_mConcreteSyntax_mSpec.__default.View(n#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#Z#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon12_Else:
    assume {:partition} self#0 != #JSON.Grammar.Value.Null(_mcc#0#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} self#0 == #JSON.Grammar.Value.Bool(_mcc#1#0);
    assume $Is(_mcc#1#0, Tclass.JSON_mGrammar.jbool());
    havoc b#Z#0;
    assume $Is(b#Z#0, Tclass.JSON_mGrammar.jbool()) && $IsAlloc(b#Z#0, Tclass.JSON_mGrammar.jbool(), $Heap);
    assume let#4#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mGrammar.jbool());
    assume b#Z#0 == let#4#0#0;
    ##v#0 := b#Z#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0) == JSON_mConcreteSyntax_mSpec.__default.View(b#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#Z#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon13_Else:
    assume {:partition} self#0 != #JSON.Grammar.Value.Bool(_mcc#1#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} self#0 == #JSON.Grammar.Value.String(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jstring());
    havoc str#Z#0;
    assume $Is(str#Z#0, Tclass.JSON_mGrammar.jstring()) && $IsAlloc(str#Z#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume let#3#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mGrammar.jstring());
    assume str#Z#0 == let#3#0#0;
    ##self#1 := str#Z#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0) == JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#Z#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon14_Else:
    assume {:partition} self#0 != #JSON.Grammar.Value.String(_mcc#2#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} self#0 == #JSON.Grammar.Value.Number(_mcc#3#0);
    assume $Is(_mcc#3#0, Tclass.JSON_mGrammar.jnumber());
    havoc num#Z#0;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnumber()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume let#2#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mGrammar.jnumber());
    assume num#Z#0 == let#2#0#0;
    ##self#0 := num#Z#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0) == JSON_mConcreteSyntax_mSpec.__default.Number(num#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#Z#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon15_Else:
    assume {:partition} self#0 != #JSON.Grammar.Value.Number(_mcc#3#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} self#0 == #JSON.Grammar.Value.Object(_mcc#4#0);
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    havoc obj#Z#0;
    assume $Is(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume let#1#0#0 == _mcc#4#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    assume obj#Z#0 == let#1#0#0;
    ##obj#0 := obj#Z#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume DtRank(##obj#0) < DtRank(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0) == JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#Z#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon16_Else:
    assume {:partition} self#0 != #JSON.Grammar.Value.Object(_mcc#4#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} self#0 == #JSON.Grammar.Value.Array(_mcc#5#0);
    assume $Is(_mcc#5#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    havoc arr#Z#0;
    assume $Is(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume let#0#0#0 == _mcc#5#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    assume arr#Z#0 == let#0#0#0;
    ##arr#0 := arr#Z#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume DtRank(##arr#0) < DtRank(self#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0) == JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#Z#0);
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), self#0), TSeq(Tclass.BoundedInts.uint8()));
    return;

  anon17_Else:
    assume {:partition} self#0 != #JSON.Grammar.Value.Array(_mcc#5#0);
    assume false;
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueNumber", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(97,8): initial state"} true;
    assume JSON_mGrammar.Value.Number_q(v#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(99,21): post-state"} true;
    ##self#0 := v#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    assume JSON_mGrammar.Value.Number_q(v#0);
    ##self#1 := JSON_mGrammar.Value.num(v#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Number#canCall(JSON_mGrammar.Value.num(v#0));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Number(JSON_mGrammar.Value.num(v#0)));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (call precondtion)"} CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  requires {:id "id23830"} JSON_mGrammar.Value.Number_q(v#0);



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Number#canCall(JSON_mGrammar.Value.num(v#0));
  free ensures {:id "id23831"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Number(JSON_mGrammar.Value.num(v#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (correctness)"} Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id23832"} JSON_mGrammar.Value.Number_q(v#0);
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Number#canCall(JSON_mGrammar.Value.num(v#0));
  free ensures {:id "id23833"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Number(JSON_mGrammar.Value.num(v#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (correctness)"} Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##self#2: DatatypeType;
  var _mcc#10#0: DatatypeType;
  var _mcc#8#0: DatatypeType;
  var _mcc#6#0: DatatypeType;
  var num#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#3: DatatypeType;
  var _mcc#4#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var _mcc#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueNumber", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(100,2): initial state"} true;
    assume $IsA#JSON_mGrammar.Value(v#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#v0#0: DatatypeType :: $Is($ih#v0#0, Tclass.JSON_mGrammar.Value()) && JSON_mGrammar.Value.Number_q($ih#v0#0) && DtRank($ih#v0#0) < DtRank(v#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $ih#v0#0), JSON_mConcreteSyntax_mSpec.__default.Number(JSON_mGrammar.Value.num($ih#v0#0))));
    $_reverifyPost := false;
    ##self#2 := v#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Null(_mcc#0#0);
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jnull());
    goto anon8;

  anon9_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Null(_mcc#0#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Bool(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jbool());
    goto anon8;

  anon10_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Bool(_mcc#2#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.String(_mcc#4#0);
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.jstring());
    goto anon8;

  anon11_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.String(_mcc#4#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Number(_mcc#6#0);
    assume $Is(_mcc#6#0, Tclass.JSON_mGrammar.jnumber());
    havoc num#Z#0;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnumber()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume let#0#0#0 == _mcc#6#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.jnumber());
    assume num#Z#0 == let#0#0#0;
    ##self#3 := num#Z#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#Z#0);
    goto anon8;

  anon12_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Number(_mcc#6#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Object(_mcc#8#0);
    assume $Is(_mcc#8#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    goto anon8;

  anon13_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Object(_mcc#8#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Array(_mcc#10#0);
    assume $Is(_mcc#10#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    goto anon8;

  anon14_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Array(_mcc#10#0);
    assume false;
    goto anon8;

  anon8:
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && (!JSON_mGrammar.Value.Null_q(v#0) ==> !JSON_mGrammar.Value.Bool_q(v#0) ==> !JSON_mGrammar.Value.String_q(v#0) ==> JSON_mGrammar.Value.Number_q(v#0) ==> (var num#0 := JSON_mGrammar.Value.num(v#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#0)));
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), (if JSON_mGrammar.Value.Null_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Bool_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.String_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Number_q(v#0) then (var num#1 := JSON_mGrammar.Value.num(v#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#1)) else (if JSON_mGrammar.Value.Object_q(v#0) then Seq#Empty(): Seq else Seq#Empty(): Seq))))));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), (if JSON_mGrammar.Value.Null_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Bool_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.String_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Number_q(v#0) then (var num#2 := JSON_mGrammar.Value.num(v#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#2)) else (if JSON_mGrammar.Value.Object_q(v#0) then Seq#Empty(): Seq else Seq#Empty(): Seq))))));
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(101,78)"} true;
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##obj#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueObject", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(104,8): initial state"} true;
    assume JSON_mGrammar.Value.Object_q(v#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(106,21): post-state"} true;
    ##self#0 := v#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    assume JSON_mGrammar.Value.Object_q(v#0);
    ##obj#0 := JSON_mGrammar.Value.obj(v#0);
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(JSON_mGrammar.Value.obj(v#0));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), JSON_mGrammar.Value.obj(v#0)));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (call precondtion)"} CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  requires {:id "id23841"} JSON_mGrammar.Value.Object_q(v#0);



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(JSON_mGrammar.Value.obj(v#0));
  free ensures {:id "id23842"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), JSON_mGrammar.Value.obj(v#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (correctness)"} Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id23843"} JSON_mGrammar.Value.Object_q(v#0);
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(JSON_mGrammar.Value.obj(v#0));
  free ensures {:id "id23844"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), JSON_mGrammar.Value.obj(v#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (correctness)"} Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##self#1: DatatypeType;
  var _mcc#10#0: DatatypeType;
  var _mcc#8#0: DatatypeType;
  var obj#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##obj#1: DatatypeType;
  var _mcc#6#0: DatatypeType;
  var _mcc#4#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var _mcc#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueObject", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(107,2): initial state"} true;
    assume $IsA#JSON_mGrammar.Value(v#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#v0#0: DatatypeType :: $Is($ih#v0#0, Tclass.JSON_mGrammar.Value()) && JSON_mGrammar.Value.Object_q($ih#v0#0) && DtRank($ih#v0#0) < DtRank(v#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $ih#v0#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), JSON_mGrammar.Value.obj($ih#v0#0))));
    $_reverifyPost := false;
    ##self#1 := v#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Null(_mcc#0#0);
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jnull());
    goto anon8;

  anon9_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Null(_mcc#0#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Bool(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jbool());
    goto anon8;

  anon10_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Bool(_mcc#2#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.String(_mcc#4#0);
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.jstring());
    goto anon8;

  anon11_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.String(_mcc#4#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Number(_mcc#6#0);
    assume $Is(_mcc#6#0, Tclass.JSON_mGrammar.jnumber());
    goto anon8;

  anon12_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Number(_mcc#6#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Object(_mcc#8#0);
    assume $Is(_mcc#8#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    havoc obj#Z#0;
    assume $Is(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume let#0#0#0 == _mcc#8#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    assume obj#Z#0 == let#0#0#0;
    ##obj#1 := obj#Z#0;
    assume $IsAlloc(##obj#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#Z#0);
    goto anon8;

  anon13_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Object(_mcc#8#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Array(_mcc#10#0);
    assume $Is(_mcc#10#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    goto anon8;

  anon14_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Array(_mcc#10#0);
    assume false;
    goto anon8;

  anon8:
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && (!JSON_mGrammar.Value.Null_q(v#0) ==> !JSON_mGrammar.Value.Bool_q(v#0) ==> !JSON_mGrammar.Value.String_q(v#0) ==> !JSON_mGrammar.Value.Number_q(v#0) ==> JSON_mGrammar.Value.Object_q(v#0) ==> (var obj#0 := JSON_mGrammar.Value.obj(v#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0)));
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), (if JSON_mGrammar.Value.Null_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Bool_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.String_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Number_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Object_q(v#0) then (var obj#1 := JSON_mGrammar.Value.obj(v#0); JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#1)) else Seq#Empty(): Seq))))));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), (if JSON_mGrammar.Value.Null_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Bool_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.String_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Number_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Object_q(v#0) then (var obj#2 := JSON_mGrammar.Value.obj(v#0); JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#2)) else Seq#Empty(): Seq))))));
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(108,78)"} true;
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##arr#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueArray", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(111,8): initial state"} true;
    assume JSON_mGrammar.Value.Array_q(v#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(113,21): post-state"} true;
    ##self#0 := v#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    assume JSON_mGrammar.Value.Array_q(v#0);
    ##arr#0 := JSON_mGrammar.Value.arr(v#0);
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(JSON_mGrammar.Value.arr(v#0));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), JSON_mGrammar.Value.arr(v#0)));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (call precondtion)"} CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  requires {:id "id23852"} JSON_mGrammar.Value.Array_q(v#0);



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(JSON_mGrammar.Value.arr(v#0));
  free ensures {:id "id23853"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), JSON_mGrammar.Value.arr(v#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (correctness)"} Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $IsA#JSON_mGrammar.Value(v#0)) returns ($_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  requires {:id "id23854"} JSON_mGrammar.Value.Array_q(v#0);
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(JSON_mGrammar.Value.arr(v#0));
  free ensures {:id "id23855"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), JSON_mGrammar.Value.arr(v#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (correctness)"} Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var ##self#1: DatatypeType;
  var _mcc#10#0: DatatypeType;
  var arr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##arr#1: DatatypeType;
  var _mcc#8#0: DatatypeType;
  var _mcc#6#0: DatatypeType;
  var _mcc#4#0: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var _mcc#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueArray", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(114,2): initial state"} true;
    assume $IsA#JSON_mGrammar.Value(v#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#v0#0: DatatypeType :: $Is($ih#v0#0, Tclass.JSON_mGrammar.Value()) && JSON_mGrammar.Value.Array_q($ih#v0#0) && DtRank($ih#v0#0) < DtRank(v#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $ih#v0#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), JSON_mGrammar.Value.arr($ih#v0#0))));
    $_reverifyPost := false;
    ##self#1 := v#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Null(_mcc#0#0);
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jnull());
    goto anon8;

  anon9_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Null(_mcc#0#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Bool(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jbool());
    goto anon8;

  anon10_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Bool(_mcc#2#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.String(_mcc#4#0);
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.jstring());
    goto anon8;

  anon11_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.String(_mcc#4#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Number(_mcc#6#0);
    assume $Is(_mcc#6#0, Tclass.JSON_mGrammar.jnumber());
    goto anon8;

  anon12_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Number(_mcc#6#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Object(_mcc#8#0);
    assume $Is(_mcc#8#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    goto anon8;

  anon13_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Object(_mcc#8#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Array(_mcc#10#0);
    assume $Is(_mcc#10#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    havoc arr#Z#0;
    assume $Is(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume let#0#0#0 == _mcc#10#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    assume arr#Z#0 == let#0#0#0;
    ##arr#1 := arr#Z#0;
    assume $IsAlloc(##arr#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#Z#0);
    goto anon8;

  anon14_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Array(_mcc#10#0);
    assume false;
    goto anon8;

  anon8:
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && (!JSON_mGrammar.Value.Null_q(v#0) ==> !JSON_mGrammar.Value.Bool_q(v#0) ==> !JSON_mGrammar.Value.String_q(v#0) ==> !JSON_mGrammar.Value.Number_q(v#0) ==> !JSON_mGrammar.Value.Object_q(v#0) ==> (var arr#0 := JSON_mGrammar.Value.arr(v#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0)));
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), (if JSON_mGrammar.Value.Null_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Bool_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.String_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Number_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Object_q(v#0) then Seq#Empty(): Seq else (var arr#1 := JSON_mGrammar.Value.arr(v#0); JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#1))))))));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), (if JSON_mGrammar.Value.Null_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Bool_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.String_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Number_q(v#0) then Seq#Empty(): Seq else (if JSON_mGrammar.Value.Object_q(v#0) then Seq#Empty(): Seq else (var arr#2 := JSON_mGrammar.Value.arr(v#0); JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#2))))))));
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(115,76)"} true;
    return;
}



function JSON_mConcreteSyntax_mSpec.__default.JSON(js#0: DatatypeType) : Seq
uses {
axiom 5 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON(js#0) } JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0) || (5 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, js#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON(js#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.JSON(js#0) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, js#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.JSON(Lit(js#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(Lit(js#0)) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), Lit(js#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.JSON(Lit(js#0)) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.Value(), Lit(js#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
}

function JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.JSON#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, js#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON#requires(js#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> (JSON_mConcreteSyntax_mSpec.__default.JSON#requires(js#0) <==> true));

axiom (forall $ly: LayerType :: { JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($ly)) } JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($ly)) == JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly));

function JSON_mConcreteSyntax_mSpec.__default.Value#Handle($fuel: LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$0x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$0x#0))): Seq);

procedure {:verboseName "JSON.ConcreteSyntax.Spec.JSON (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.JSON(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.Spec.JSON (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpec.__default.JSON(js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.JSON", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.Spec.dfy(118,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 4 != $FunctionContextHeight;
    ##self#0 := js#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.JSON(js#0) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume $Is(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#14 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#14) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#14)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#14 := lv#0; (var dt_update#end#0#14 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#14), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#14), dt_update#end#0#14))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#15 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#15) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#15)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#15 := Lit(lv#0); (var dt_update#end#0#15 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#15)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#15)), dt_update#end#0#15)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#16: char :: { Seq#Contains(s#0, $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(s#0, $Box(c#16)) ==> char#ToInt(c#16) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#16: char :: { Seq#Contains(s#0, $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(s#0, $Box(c#16)) ==> char#ToInt(c#16) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#32#i#0): int)): char))), (lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: $IsBox($l#32#i#0, TInt) && LitInt(0) <= $Unbox($l#32#i#0): int && $Unbox($l#32#i#0): int < Seq#Length(s#0)), (lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#17: char :: { Seq#Contains(s#0, $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(s#0, $Box(c#17)) ==> char#ToInt(c#17) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#34#i#0): int)): char))), (lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: $IsBox($l#34#i#0, TInt) && LitInt(0) <= $Unbox($l#34#i#0): int && $Unbox($l#34#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#8: int :: { JSON_mGrammar.__default.Blank_q(b#8) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) } LitInt(0) <= b#8 && b#8 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#8))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#8: int :: { JSON_mGrammar.__default.Blank_q(b#8) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) } LitInt(0) <= b#8 && b#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) ==> JSON_mGrammar.__default.Blank_q(b#8))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#9: int :: { JSON_mGrammar.__default.Blank_q(b#9) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#9)) } LitInt(0) <= b#9 && b#9 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#9)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#9))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#9: int :: { JSON_mGrammar.__default.Blank_q(b#9) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#9)) } LitInt(0) <= b#9 && b#9 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#9)) ==> JSON_mGrammar.__default.Blank_q(b#9))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#8: int :: { $Unbox(Seq#Index(s#0, idx#8)): DatatypeType } LitInt(0) <= idx#8 && idx#8 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#8)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#8: int :: { $Unbox(Seq#Index(s#0, idx#8)): DatatypeType } LitInt(0) <= idx#8 && idx#8 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#8)): DatatypeType)) <==> idx#8 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#9: int :: { $Unbox(Seq#Index(s#0, idx#9)): DatatypeType } LitInt(0) <= idx#9 && idx#9 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#9)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#9: int :: { $Unbox(Seq#Index(s#0, idx#9)): DatatypeType } LitInt(0) <= idx#9 && idx#9 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#9)): DatatypeType)) <==> idx#9 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#8: int :: { JSON_mGrammar.__default.Digit_q(b#8) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) } LitInt(0) <= b#8 && b#8 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#8))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#8: int :: { JSON_mGrammar.__default.Digit_q(b#8) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) } LitInt(0) <= b#8 && b#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#8)) ==> JSON_mGrammar.__default.Digit_q(b#8))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#9: int :: { JSON_mGrammar.__default.Digit_q(b#9) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#9)) } LitInt(0) <= b#9 && b#9 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#9)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#9))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#9: int :: { JSON_mGrammar.__default.Digit_q(b#9) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#9)) } LitInt(0) <= b#9 && b#9 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#9)) ==> JSON_mGrammar.__default.Digit_q(b#9))));

const unique class.JSON_mConcreteSyntax_mSpecProperties.__default: ClassName;

function JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType) : bool
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#0) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#0))) && ((forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#0) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#0))) ==> (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#1) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#1)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#0) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#0))) && (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#1) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#1))) && (forall d#2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#2))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#2))): Seq } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#2) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#2))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#2))): Seq))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#3) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#3))) && ((forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#3) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#3))) ==> (forall d#4: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#4)) } $Is(d#4, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#4) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#4)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#3) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#3))) && (forall d#4: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#4)) } $Is(d#4, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#4) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#4))) && (forall d#5: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#5))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#5))): Seq } $Is(d#5, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#5) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#5))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#5))): Seq))));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#6: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#6)) } $Is(d#6, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#6) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#6))) && ((forall d#6: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#6)) } $Is(d#6, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#6) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#6))) ==> (forall d#7: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#7)) } $Is(d#7, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#7) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#7)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#6: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#6)) } $Is(d#6, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#6) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#6))) && (forall d#7: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#7)) } $Is(d#7, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#7) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#7))) && (forall d#8: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#8))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#8))): Seq } $Is(d#8, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#8) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#8))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#8))): Seq))));
}

function JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType) : bool;

function JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#requires(Ty, Ty, DatatypeType, HandleType, HandleType) : bool;

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> true));

procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism_Requires (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, bracketed#0: DatatypeType where $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())), pd0#0: HandleType where $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))), pd1#0: HandleType where $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism_Requires (well-formedness)"} CheckWellformed$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var d#9: DatatypeType;
  var ##x0#0: DatatypeType;
  var d#10: DatatypeType;
  var ##x0#1: DatatypeType;
  var d#12: DatatypeType;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism_Requires", " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, " | ", bracketed#0, " | ", pd0#0, " | ", pd1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "HandleType"} true;
    b$reqreads#0 := true;
    b$reqreads#1 := true;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(15,18): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume false;
    return;

  anon17_Else:
    havoc d#9;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} $Is(d#9, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && $IsAlloc(d#9, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} DtRank(d#9) < DtRank(bracketed#0);
    assume $IsAllocBox($Box(pd0#0), Tclass._System.___hFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#0 := d#9;
    assume $IsAlloc(##x0#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(##x0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#9));
    goto anon6;

  anon19_Else:
    assume {:partition} DtRank(bracketed#0) <= DtRank(d#9);
    goto anon6;

  anon18_Else:
    assume {:partition} !($Is(d#9, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && $IsAlloc(d#9, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap));
    goto anon6;

  anon6:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} (forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#11) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)));
    havoc d#10;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $Is(d#10, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && $IsAlloc(d#10, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} DtRank(d#10) < DtRank(bracketed#0);
    assume $IsAllocBox($Box(pd1#0), Tclass._System.___hFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#1 := d#10;
    assume $IsAlloc(##x0#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap);
    b$reqreads#1 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(##x0#1))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#10));
    goto anon10;

  anon22_Else:
    assume {:partition} DtRank(bracketed#0) <= DtRank(d#10);
    goto anon10;

  anon21_Else:
    assume {:partition} !($Is(d#10, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && $IsAlloc(d#10, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap));
    goto anon10;

  anon10:
    goto anon11;

  anon20_Else:
    assume {:partition} !(forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#11) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)));
    goto anon11;

  anon11:
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} (forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#11) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11))) && (forall d#13: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13)) } $Is(d#13, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#13) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13)));
    havoc d#12;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} $Is(d#12, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && $IsAlloc(d#12, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} DtRank(d#12) < DtRank(bracketed#0);
    assume Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#12));
    assume Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#12));
    goto anon15;

  anon25_Else:
    assume {:partition} DtRank(bracketed#0) <= DtRank(d#12);
    goto anon15;

  anon24_Else:
    assume {:partition} !($Is(d#12, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && $IsAlloc(d#12, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), $Heap));
    goto anon15;

  anon15:
    goto anon16;

  anon23_Else:
    assume {:partition} !((forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#11) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11))) && (forall d#13: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13)) } $Is(d#13, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#13) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13))));
    goto anon16;

  anon16:
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#11) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11))) && (forall d#13: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13)) } $Is(d#13, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#13) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13))) && (forall d#14: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#14))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#14))): Seq } $Is(d#14, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#14) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#14))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#14))): Seq));
    assume (forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#11) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11))) && ((forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#11) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#11))) ==> (forall d#13: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13)) } $Is(d#13, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#13) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#13))));
    assume $Is(JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), TBool);
    assume b$reqreads#0;
    assume b$reqreads#1;
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType where $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Bracketed(bracketed#0), pd0#0: HandleType where $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap), pd1#0: HandleType where $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##bracketed#0: DatatypeType;
  var ##pd0#0: HandleType;
  var ##pd1#0: HandleType;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##self#1: DatatypeType;
  var ##fDatum#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism", " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, " | ", bracketed#0, " | ", pd0#0, " | ", pd1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(21,8): initial state"} true;
    ##bracketed#0 := bracketed#0;
    assume $IsAlloc(##bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##pd0#0 := pd0#0;
    assume $IsAlloc(##pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##pd1#0 := pd1#0;
    assume $IsAlloc(##pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(23,43): post-state"} true;
    ##self#0 := bracketed#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := pd0#0;
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0);
    ##self#1 := bracketed#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := pd1#0;
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#1) < DtRank(##self#1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#1)));
    assume (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#1) < DtRank(##self#1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (call precondtion)"} CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType where $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Bracketed(bracketed#0), pd0#0: HandleType where $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap), pd1#0: HandleType where $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap));
  requires {:id "id23878"} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) || (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#2) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#2)));
  requires {:id "id23879"} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) || (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#3) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#3)));
  requires {:id "id23880"} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) || (forall d#4: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#4))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#4))): Seq } $Is(d#4, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#4) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#4))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#4))): Seq));



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType where $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Bracketed(bracketed#0), pd0#0: HandleType where $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap), pd1#0: HandleType where $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0);
  free ensures {:id "id23881"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (correctness)"} Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType where $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Bracketed(bracketed#0), pd0#0: HandleType where $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap), pd1#0: HandleType where $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  free requires {:id "id23882"} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) && JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0) && (forall d#5: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#5)) } $Is(d#5, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#5) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#5))) && (forall d#6: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#6)) } $Is(d#6, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#6) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#6))) && (forall d#7: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#7))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#7))): Seq } $Is(d#7, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#7) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#7))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#7))): Seq));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0);
  free ensures {:id "id23883"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (correctness)"} Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0_0_0: DatatypeType;
  var ##fDatum#0_0_0: HandleType;
  var ts##0_0_0: Seq;
  var pt0##0_0_0: HandleType;
  var pt1##0_0_0: HandleType;
  var ##self#0_0_1: DatatypeType;
  var ##fDatum#0_0_1: HandleType;
  var ##self#0_0: DatatypeType;
  var ##fDatum#0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism", " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, " | ", bracketed#0, " | ", pd0#0, " | ", pd1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(24,2): initial state"} true;
    $_reverifyPost := false;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    ##self#0_0 := bracketed#0;
    assume $IsAlloc(##self#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0 := pd0#0;
    assume $IsAlloc(##fDatum#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0, $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#0_0) < DtRank(##self#0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0, $Box(d#0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0);
    assume false;
    goto anon3;

  anon4_Else:
    goto anon5_Then, anon5_Else;

  anon5_Then:
    ##self#0_0_0 := bracketed#0;
    assume $IsAlloc(##self#0_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0_0 := pd0#0;
    assume $IsAlloc(##fDatum#0_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)) } $Is(d#0_0_0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#0_0_0) < DtRank(##self#0_0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(bracketed#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(bracketed#0);
    ts##0_0_0 := JSON_mGrammar.Bracketed.data(bracketed#0);
    assume true;
    pt0##0_0_0 := pd0#0;
    assume true;
    pt1##0_0_0 := pd1#0;
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), ts##0_0_0, pt0##0_0_0, pt1##0_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), ts##0_0_0, pt0##0_0_0, pt1##0_0_0);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(27,54)"} true;
    ##self#0_0_1 := bracketed#0;
    assume $IsAlloc(##self#0_0_1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0_1 := pd1#0;
    assume $IsAlloc(##fDatum#0_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_1, $Box(d#0_0_1)) } $Is(d#0_0_1, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S)) && DtRank(d#0_0_1) < DtRank(##self#0_0_1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_1, $Box(d#0_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0));
    assume false;
    goto anon3;

  anon5_Else:
    goto anon3;

  anon3:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd1#0));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq where $Is(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T)) && $IsAlloc(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T), $Heap), pt0#0: HandleType where $Is(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap), pt1#0: HandleType where $Is(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq, pt0#0: HandleType, pt1#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0: Box;
  var ##x0#0: Box;
  var d#2: Box;
  var ##x0#1: Box;
  var d#4: Box;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var ##ts#1: Seq;
  var ##fT#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism", " | ", JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, " | ", ts#0, " | ", pt0#0, " | ", pt1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(32,24): initial state"} true;
    havoc d#0;
    assume $IsBox(d#0, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && $IsAllocBox(d#0, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $Heap);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Seq#Contains(ts#0, d#0);
    assume $IsAllocBox($Box(pt0#0), Tclass._System.___hFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#0 := d#0;
    assume $IsAllocBox(##x0#0, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $Heap);
    assume Requires1#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#0);
    assume Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#0);
    goto anon4;

  anon11_Else:
    assume Seq#Contains(ts#0, d#0) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#0);
    goto anon4;

  anon4:
    assume (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#1) } { Seq#Contains(ts#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#1) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#1));
    havoc d#2;
    assume $IsBox(d#2, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && $IsAllocBox(d#2, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $Heap);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume Seq#Contains(ts#0, d#2);
    assume $IsAllocBox($Box(pt1#0), Tclass._System.___hFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#1 := d#2;
    assume $IsAllocBox(##x0#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $Heap);
    assume Requires1#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#2);
    assume Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#2);
    goto anon7;

  anon12_Else:
    assume Seq#Contains(ts#0, d#2) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#2);
    goto anon7;

  anon7:
    assume (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#3) } { Seq#Contains(ts#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#3) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#3));
    havoc d#4;
    assume $IsBox(d#4, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && $IsAllocBox(d#4, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $Heap);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Seq#Contains(ts#0, d#4);
    assume Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#4);
    assume Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#4);
    assume Seq#Equal($Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#4)): Seq, $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#4)): Seq);
    goto anon10;

  anon13_Else:
    assume Seq#Contains(ts#0, d#4) ==> Seq#Equal($Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#4)): Seq, $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#4)): Seq);
    goto anon10;

  anon10:
    assume (forall d#5: Box :: { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#5)): Seq } { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#5)): Seq } { Seq#Contains(ts#0, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#5) ==> Seq#Equal($Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#5)): Seq, $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#5)): Seq));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(36,38): post-state"} true;
    ##ts#0 := ts#0;
    assume $IsAlloc(##ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T), $Heap);
    ##fT#0 := pt0#0;
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#6: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#6) } { Seq#Contains(##ts#0, d#6) } $IsBox(d#6, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(##ts#0, d#6) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#6));
    assume (forall d#6: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#6) } { Seq#Contains(##ts#0, d#6) } $IsBox(d#6, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(##ts#0, d#6) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#6));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt0#0);
    ##ts#1 := ts#0;
    assume $IsAlloc(##ts#1, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T), $Heap);
    ##fT#1 := pt1#0;
    assume $IsAlloc(##fT#1, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#7: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#7) } { Seq#Contains(##ts#1, d#7) } $IsBox(d#7, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(##ts#1, d#7) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#7));
    assume (forall d#7: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#7) } { Seq#Contains(##ts#1, d#7) } $IsBox(d#7, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(##ts#1, d#7) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#7));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt1#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LZ), ts#0, pt0#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LZ), ts#0, pt1#0));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (call precondtion)"} CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq where $Is(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T)) && $IsAlloc(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T), $Heap), pt0#0: HandleType where $Is(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap), pt1#0: HandleType where $Is(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap));
  requires {:id "id23908"} (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#1) } { Seq#Contains(ts#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#1) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#1));
  requires {:id "id23909"} (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#3) } { Seq#Contains(ts#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#3) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#3));
  requires {:id "id23910"} (forall d#5: Box :: { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#5)): Seq } { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#5)): Seq } { Seq#Contains(ts#0, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#5) ==> Seq#Equal($Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#5)): Seq, $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#5)): Seq));



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq where $Is(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T)) && $IsAlloc(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T), $Heap), pt0#0: HandleType where $Is(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap), pt1#0: HandleType where $Is(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt0#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt1#0);
  free ensures {:id "id23911"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LS($LZ)), ts#0, pt0#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LS($LZ)), ts#0, pt1#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (correctness)"} Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq where $Is(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T)) && $IsAlloc(ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T), $Heap), pt0#0: HandleType where $Is(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt0#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap), pt1#0: HandleType where $Is(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt1#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8())), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id23912"} (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#1) } { Seq#Contains(ts#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#1) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#1));
  requires {:id "id23913"} (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#3) } { Seq#Contains(ts#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#3) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#3));
  requires {:id "id23914"} (forall d#5: Box :: { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#5)): Seq } { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#5)): Seq } { Seq#Contains(ts#0, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains(ts#0, d#5) ==> Seq#Equal($Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt0#0, d#5)): Seq, $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt1#0, d#5)): Seq));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt0#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt1#0);
  free ensures {:id "id23915"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LS($LZ)), ts#0, pt0#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LS($LZ)), ts#0, pt1#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (correctness)"} Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq, pt0#0: HandleType, pt1#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism", " | ", JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, " | ", ts#0, " | ", pt0#0, " | ", pt1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(37,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#ts0#0: Seq :: $Is($ih#ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T)) && (forall d#8: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt0#0, d#8) } { Seq#Contains($ih#ts0#0, d#8) } $IsBox(d#8, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains($ih#ts0#0, d#8) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt0#0, d#8)) && (forall d#9: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt1#0, d#9) } { Seq#Contains($ih#ts0#0, d#9) } $IsBox(d#9, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains($ih#ts0#0, d#9) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt1#0, d#9)) && (forall d#10: Box :: { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt1#0, d#10)): Seq } { $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt0#0, d#10)): Seq } { Seq#Contains($ih#ts0#0, d#10) } $IsBox(d#10, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T) && Seq#Contains($ih#ts0#0, d#10) ==> Seq#Equal($Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt0#0, d#10)): Seq, $Unbox(Apply1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt1#0, d#10)): Seq)) && Seq#Rank($ih#ts0#0) < Seq#Rank(ts#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LZ), $ih#ts0#0, pt0#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, $LS($LZ), $ih#ts0#0, pt1#0)));
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq where $Is(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), ts1#0: Seq where $Is(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), pt#0: HandleType where $Is(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (well-formedness)"} CheckWellFormed$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq, ts1#0: Seq, pt#0: HandleType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var d#0: Box;
  var ##x0#0: Box;
  var d#2: Box;
  var ##x0#1: Box;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var ##ts#1: Seq;
  var ##fT#1: HandleType;
  var ##ts#2: Seq;
  var ##fT#2: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear", " | ", JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, " | ", ts0#0, " | ", ts1#0, " | ", pt#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(39,25): initial state"} true;
    havoc d#0;
    assume $IsBox(d#0, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && $IsAllocBox(d#0, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $Heap);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Seq#Contains(ts0#0, d#0);
    assume $IsAllocBox($Box(pt#0), Tclass._System.___hFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#0 := d#0;
    assume $IsAllocBox(##x0#0, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $Heap);
    assume Requires1#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#0);
    assume Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#0);
    goto anon4;

  anon8_Else:
    assume Seq#Contains(ts0#0, d#0) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#0);
    goto anon4;

  anon4:
    assume (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#1) } { Seq#Contains(ts0#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts0#0, d#1) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#1));
    havoc d#2;
    assume $IsBox(d#2, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && $IsAllocBox(d#2, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume Seq#Contains(ts1#0, d#2);
    assume $IsAllocBox($Box(pt#0), Tclass._System.___hFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##x0#1 := d#2;
    assume $IsAllocBox(##x0#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $Heap);
    assume Requires1#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#2);
    assume Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#2);
    goto anon7;

  anon9_Else:
    assume Seq#Contains(ts1#0, d#2) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#2);
    goto anon7;

  anon7:
    assume (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#3) } { Seq#Contains(ts1#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts1#0, d#3) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#3));
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(42,44): post-state"} true;
    ##ts#0 := Seq#Append(ts0#0, ts1#0);
    assume $IsAlloc(##ts#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap);
    ##fT#0 := pt#0;
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#4: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#4) } { Seq#Contains(##ts#0, d#4) } $IsBox(d#4, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(##ts#0, d#4) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#4));
    assume (forall d#4: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#4) } { Seq#Contains(##ts#0, d#4) } $IsBox(d#4, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(##ts#0, d#4) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#4));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, Seq#Append(ts0#0, ts1#0), pt#0);
    ##ts#1 := ts0#0;
    assume $IsAlloc(##ts#1, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap);
    ##fT#1 := pt#0;
    assume $IsAlloc(##fT#1, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#5: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#5) } { Seq#Contains(##ts#1, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(##ts#1, d#5) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#5));
    assume (forall d#5: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#5) } { Seq#Contains(##ts#1, d#5) } $IsBox(d#5, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(##ts#1, d#5) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, d#5));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts0#0, pt#0);
    ##ts#2 := ts1#0;
    assume $IsAlloc(##ts#2, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap);
    ##fT#2 := pt#0;
    assume $IsAlloc(##fT#2, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#6: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, d#6) } { Seq#Contains(##ts#2, d#6) } $IsBox(d#6, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(##ts#2, d#6) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, d#6));
    assume (forall d#6: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, d#6) } { Seq#Contains(##ts#2, d#6) } $IsBox(d#6, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(##ts#2, d#6) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, d#6));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts1#0, pt#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LZ), Seq#Append(ts0#0, ts1#0), pt#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LZ), ts0#0, pt#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LZ), ts1#0, pt#0)));
    return;
}



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (call precondtion)"} CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq where $Is(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), ts1#0: Seq where $Is(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), pt#0: HandleType where $Is(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap));
  requires {:id "id23928"} (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#1) } { Seq#Contains(ts0#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts0#0, d#1) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#1));
  requires {:id "id23929"} (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#3) } { Seq#Contains(ts1#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts1#0, d#3) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#3));



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq where $Is(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), ts1#0: Seq where $Is(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), pt#0: HandleType where $Is(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, Seq#Append(ts0#0, ts1#0), pt#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts0#0, pt#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts1#0, pt#0);
  free ensures {:id "id23930"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LS($LZ)), Seq#Append(ts0#0, ts1#0), pt#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LS($LZ)), ts0#0, pt#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LS($LZ)), ts1#0, pt#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (correctness)"} Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq where $Is(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts0#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), ts1#0: Seq where $Is(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && $IsAlloc(ts1#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T), $Heap), pt#0: HandleType where $Is(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(pt#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8())), $Heap)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id23931"} (forall d#1: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#1) } { Seq#Contains(ts0#0, d#1) } $IsBox(d#1, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts0#0, d#1) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#1));
  requires {:id "id23932"} (forall d#3: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#3) } { Seq#Contains(ts1#0, d#3) } $IsBox(d#3, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts1#0, d#3) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, pt#0, d#3));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, Seq#Append(ts0#0, ts1#0), pt#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts0#0, pt#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts1#0, pt#0);
  free ensures {:id "id23933"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LS($LZ)), Seq#Append(ts0#0, ts1#0), pt#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LS($LZ)), ts0#0, pt#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LS($LZ)), ts1#0, pt#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (correctness)"} Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq, ts1#0: Seq, pt#0: HandleType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;

  anon0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear", " | ", JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, " | ", ts0#0, " | ", ts1#0, " | ", pt#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(43,2): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#ts00#0: Seq :: $Is($ih#ts00#0, TSeq(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T)) && (forall d#7: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt#0, d#7) } { Seq#Contains($ih#ts00#0, d#7) } $IsBox(d#7, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains($ih#ts00#0, d#7) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt#0, d#7)) && (forall d#8: Box :: { Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt#0, d#8) } { Seq#Contains(ts1#0, d#8) } $IsBox(d#8, JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T) && Seq#Contains(ts1#0, d#8) ==> Requires1(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, TSeq(Tclass.BoundedInts.uint8()), $initHeapForallStmt#0, pt#0, d#8)) && (Seq#Rank($ih#ts00#0) < Seq#Rank(ts0#0) || (Seq#Rank($ih#ts00#0) == Seq#Rank(ts0#0) && Seq#Rank(ts1#0) < Seq#Rank(ts1#0))) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LZ), Seq#Append($ih#ts00#0, ts1#0), pt#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LZ), $ih#ts00#0, pt#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, $LS($LZ), ts1#0, pt#0))));
    $_reverifyPost := false;
    assume true;
    goto anon3_Then, anon3_Else;

  anon3_Then:
    assume {:partition} Seq#Length(ts0#0) == LitInt(0);
    assume true;
    assume Seq#Equal(Seq#Append(Seq#Empty(): Seq, ts1#0), ts1#0);
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(45,28)"} true;
    return;

  anon3_Else:
    assume {:partition} Seq#Length(ts0#0) != LitInt(0);
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) < Seq#Length(ts0#0);
    assume {:subsumption 0} 0 <= LitInt(1) && LitInt(1) <= Seq#Length(ts0#0);
    assume true;
    assume Seq#Equal(Seq#Append(ts0#0, ts1#0), Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(ts0#0, LitInt(0))), Seq#Append(Seq#Drop(ts0#0, LitInt(1)), ts1#0)));
    assume {:captureState "libraries/src/JSON/ConcreteSyntax.SpecProperties.dfy(47,53)"} true;
    return;
}



axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#16 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#16) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#16)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#16 := lv#0; (var dt_update#end#0#16 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#16), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#16), dt_update#end#0#16))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#17 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#17) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#17)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#17 := Lit(lv#0); (var dt_update#end#0#17 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#17)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#17)), dt_update#end#0#17)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#18: char :: { Seq#Contains(s#0, $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(s#0, $Box(c#18)) ==> char#ToInt(c#18) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#18: char :: { Seq#Contains(s#0, $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(s#0, $Box(c#18)) ==> char#ToInt(c#18) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#36#i#0): int)): char))), (lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: $IsBox($l#36#i#0, TInt) && LitInt(0) <= $Unbox($l#36#i#0): int && $Unbox($l#36#i#0): int < Seq#Length(s#0)), (lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#19: char :: { Seq#Contains(s#0, $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(s#0, $Box(c#19)) ==> char#ToInt(c#19) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#38#i#0): int)): char))), (lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: $IsBox($l#38#i#0, TInt) && LitInt(0) <= $Unbox($l#38#i#0): int && $Unbox($l#38#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#10: int :: { JSON_mGrammar.__default.Blank_q(b#10) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) } LitInt(0) <= b#10 && b#10 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#10))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#10: int :: { JSON_mGrammar.__default.Blank_q(b#10) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) } LitInt(0) <= b#10 && b#10 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) ==> JSON_mGrammar.__default.Blank_q(b#10))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#11: int :: { JSON_mGrammar.__default.Blank_q(b#11) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#11)) } LitInt(0) <= b#11 && b#11 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#11)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#11))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#11: int :: { JSON_mGrammar.__default.Blank_q(b#11) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#11)) } LitInt(0) <= b#11 && b#11 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#11)) ==> JSON_mGrammar.__default.Blank_q(b#11))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#10: int :: { $Unbox(Seq#Index(s#0, idx#10)): DatatypeType } LitInt(0) <= idx#10 && idx#10 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#10)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#10: int :: { $Unbox(Seq#Index(s#0, idx#10)): DatatypeType } LitInt(0) <= idx#10 && idx#10 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#10)): DatatypeType)) <==> idx#10 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#11: int :: { $Unbox(Seq#Index(s#0, idx#11)): DatatypeType } LitInt(0) <= idx#11 && idx#11 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#11)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#11: int :: { $Unbox(Seq#Index(s#0, idx#11)): DatatypeType } LitInt(0) <= idx#11 && idx#11 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#11)): DatatypeType)) <==> idx#11 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#10: int :: { JSON_mGrammar.__default.Digit_q(b#10) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) } LitInt(0) <= b#10 && b#10 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#10))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#10: int :: { JSON_mGrammar.__default.Digit_q(b#10) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) } LitInt(0) <= b#10 && b#10 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#10)) ==> JSON_mGrammar.__default.Digit_q(b#10))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#11: int :: { JSON_mGrammar.__default.Digit_q(b#11) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#11)) } LitInt(0) <= b#11 && b#11 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#11)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#11))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#11: int :: { JSON_mGrammar.__default.Digit_q(b#11) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#11)) } LitInt(0) <= b#11 && b#11 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#11)) ==> JSON_mGrammar.__default.Digit_q(b#11))));

axiom (forall v#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View(v#0) } JSON_mConcreteSyntax_mSpec.__default.View#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.View(v#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall v#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View(v#0) } JSON_mConcreteSyntax_mSpec.__default.View#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.View(v#0) == JSON_mUtils_mViews_mCore.View__.Bytes(v#0));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.View(Lit(v#0)) } JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && JSON_mConcreteSyntax_mSpec.__default.View(Lit(v#0)) == Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) || ($Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mGrammar.Structural.Structural_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.Structural.before(self#0)) && JSON_mGrammar.Structural.Structural_q(self#0) && JSON_mGrammar.Structural.Structural_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.Structural.after(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, self#0, fT#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.Structural.before(self#0)), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Structural.t(self#0))): Seq), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.Structural.after(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), fT#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.after(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), fT#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Lit(JSON_mGrammar.Structural.t(Lit(self#0))))): Seq), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.after(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Structural$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mGrammar.Structural.Structural_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.Structural.after(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ConcreteSyntax.Spec._default.Structural$T, Lit(self#0), Lit(fT#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.before(Lit(self#0)))), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Structural$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Lit(JSON_mGrammar.Structural.t(Lit(self#0))))): Seq), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.Structural.after(Lit(self#0))))));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0) } JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(self#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle()) && JSON_mConcreteSyntax_mSpec.__default.StructuralView(self#0) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), self#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle()));

axiom (forall $Heap: Heap, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(self#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(self#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Lit(self#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle()) && JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(self#0)) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), Lit(self#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle()));

axiom (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $IsAlloc(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T), $Heap) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())), $Heap)) ==> (JSON_mGrammar.Maybe.Empty_q(self#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), Seq#Empty(): Seq)) && (JSON_mGrammar.Maybe.NonEmpty_q(self#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq)) && $Is(JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, self#0, fT#0) == (if JSON_mGrammar.Maybe.Empty_q(self#0) then Seq#Empty(): Seq else $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, JSON_mGrammar.Maybe.t(self#0))): Seq));

axiom (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), fT#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), fT#0) == (if JSON_mGrammar.Maybe.Empty_q(Lit(self#0)) then Seq#Empty(): Seq else $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Lit(JSON_mGrammar.Maybe.t(Lit(self#0))))): Seq));

axiom (forall JSON.ConcreteSyntax.Spec._default.Maybe$T: Ty, $Heap: Heap, self#0: DatatypeType, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T)) && $Is(fT#0, Tclass._System.___hTotalFunc1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe(JSON.ConcreteSyntax.Spec._default.Maybe$T, Lit(self#0), Lit(fT#0)) == (if JSON_mGrammar.Maybe.Empty_q(Lit(self#0)) then Seq#Empty(): Seq else $Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.Maybe$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Lit(JSON_mGrammar.Maybe.t(Lit(self#0))))): Seq));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $IsAlloc(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T), $Heap) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8())), $Heap) && (forall d#0: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#0) } { Seq#Contains(ts#0, d#0) } $IsBox(d#0, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#0) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#0))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#6: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#6) } { Seq#Contains(ts#0, d#6) } $IsBox(d#6, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#6) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#6))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#6: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#6) } { Seq#Contains(ts#0, d#6) } $IsBox(d#6, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#6) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#6))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#7: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#7) } { Seq#Contains(ts#0, d#7) } $IsBox(d#7, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#7) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#7))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#8: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#8) } { Seq#Contains(ts#0, d#8) } $IsBox(d#8, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#8) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#8))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8())), $Heap) && (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#0) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#0)))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#6: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#6)) } $Is(d#6, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#6) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#6)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#6: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#6)) } $Is(d#6, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#6) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#6)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#7: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#7)) } $Is(d#7, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#7) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#7)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#8: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#8)) } $Is(d#8, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#8) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#8)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jKeyValue()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k(self#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon(self#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(self#0)) && JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(JSON_mGrammar.jKeyValue.k(self#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.jKeyValue.colon(self#0))), JSON_mConcreteSyntax_mSpec.__default.Value($ly, JSON_mGrammar.jKeyValue.v(self#0))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mGrammar.jKeyValue.KeyValue_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit(self#0)))) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.jKeyValue.colon(Lit(self#0)))) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), Lit(self#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(Lit(JSON_mGrammar.jKeyValue.k(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(JSON_mGrammar.jKeyValue.v(Lit(self#0))))));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac(self#0) } JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jfrac()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Frac(self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac(self#0) } JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jfrac()) ==> JSON_mGrammar.jfrac.JFrac_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jfrac.period(self#0)) && JSON_mGrammar.jfrac.JFrac_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jfrac.num(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Frac(self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jfrac.period(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jfrac.num(self#0))));

axiom (forall self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Frac(Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Frac#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.jfrac()) ==> JSON_mGrammar.jfrac.JFrac_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jfrac.period(Lit(self#0)))) && JSON_mGrammar.jfrac.JFrac_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jfrac.num(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Frac(Lit(self#0)) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jfrac.period(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jfrac.num(Lit(self#0))))));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp(self#0) } JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jexp()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Exp(self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp(self#0) } JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jexp()) ==> JSON_mGrammar.jexp.JExp_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jexp.e(self#0)) && JSON_mGrammar.jexp.JExp_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jexp.sign(self#0)) && JSON_mGrammar.jexp.JExp_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jexp.num(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Exp(self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jexp.e(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jexp.sign(self#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jexp.num(self#0))));

axiom (forall self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Exp(Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Exp#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.jexp()) ==> JSON_mGrammar.jexp.JExp_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jexp.e(Lit(self#0)))) && JSON_mGrammar.jexp.JExp_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jexp.sign(Lit(self#0)))) && JSON_mGrammar.jexp.JExp_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jexp.num(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Exp(Lit(self#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jexp.e(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jexp.sign(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jexp.num(Lit(self#0))))));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number(self#0) } JSON_mConcreteSyntax_mSpec.__default.Number#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jnumber()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Number(self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number(self#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Number#canCall(self#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.jnumber())) ==> JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(self#0)) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(self#0)) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mGrammar.jnumber.JNumber_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Number(self#0) == Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(self#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(self#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(self#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())));

axiom (forall $Heap: Heap, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Number(Lit(self#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Number#canCall(Lit(self#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.jnumber())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jnumber.minus(Lit(self#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jnumber.num(Lit(self#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), Lit(JSON_mGrammar.jnumber.frac(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mGrammar.jnumber.JNumber_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), Lit(JSON_mGrammar.jnumber.exp(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Number(Lit(self#0)) == Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jnumber.minus(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jnumber.num(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), Lit(JSON_mGrammar.jnumber.frac(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), Lit(JSON_mGrammar.jnumber.exp(Lit(self#0))), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String(self#0) } JSON_mConcreteSyntax_mSpec.__default.String#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jstring()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.String(self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String(self#0) } JSON_mConcreteSyntax_mSpec.__default.String#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.jstring()) ==> JSON_mGrammar.jstring.JString_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jstring.lq(self#0)) && JSON_mGrammar.jstring.JString_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jstring.contents(self#0)) && JSON_mGrammar.jstring.JString_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jstring.rq(self#0)) && JSON_mConcreteSyntax_mSpec.__default.String(self#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jstring.lq(self#0)), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jstring.contents(self#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jstring.rq(self#0))));

axiom (forall self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.String(Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.String#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.jstring()) ==> JSON_mGrammar.jstring.JString_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jstring.lq(Lit(self#0)))) && JSON_mGrammar.jstring.JString_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jstring.contents(Lit(self#0)))) && JSON_mGrammar.jstring.JString_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(Lit(JSON_mGrammar.jstring.rq(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.String(Lit(self#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jstring.lq(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jstring.contents(Lit(self#0))))), JSON_mConcreteSyntax_mSpec.__default.View(Lit(JSON_mGrammar.jstring.rq(Lit(self#0))))));

axiom (forall c#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0) } JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(c#0) || $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, c#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(c#0) || ($IsGoodHeap($Heap) && $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(c#0) == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), c#0, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()));

axiom (forall $Heap: Heap, c#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(c#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(c#0)) || ($IsGoodHeap($Heap) && $Is(c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), Lit(c#0), JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(c#0)) == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), Lit(c#0), JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle()));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.Member#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Member($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Member#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($ly, $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(self#0))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Member#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Member($LS($ly), Lit(self#0)) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($ly), Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.Item#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Item($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Item#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), self#0) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox(JSON_mGrammar.Suffixed.t(self#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(self#0))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Item#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Item($LS($ly), Lit(self#0)) == Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(self#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(self#0))))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#14#d#0: DatatypeType :: $Is($l#14#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#14#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#14#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#15#ly#0, $Unbox($l#15#d#0): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $IsBox($l#15#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#15#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#13#ly#0, $Unbox($l#13#d#0): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $IsBox($l#13#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#13#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#17#d#0: DatatypeType :: $Is($l#17#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#17#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#17#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#18#ly#0, $Unbox($l#18#d#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $IsBox($l#18#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#18#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#16#ly#0, $Unbox($l#16#d#0): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $IsBox($l#16#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#16#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#14#d#0: DatatypeType :: $Is($l#14#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#14#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#14#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#15#ly#0, $Unbox($l#15#d#0): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $IsBox($l#15#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#15#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#13#ly#0, $Unbox($l#13#d#0): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $IsBox($l#13#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#13#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#17#d#0: DatatypeType :: $Is($l#17#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#17#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#17#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#18#ly#0, $Unbox($l#18#d#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $IsBox($l#18#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#18#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#16#ly#0, $Unbox($l#16#d#0): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $IsBox($l#16#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#16#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.Value($ly, self#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#5 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#5))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#5 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#5))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#5 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#5))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#5 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#5))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#5 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#5))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#5 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#5))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#4 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#4)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#4 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#4)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#4 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#4)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#4 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#4)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#4 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#4)) else (var arr#4 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#4))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#7 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#7))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#7 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#7))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#7 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#7))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#7 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#7))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#7 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#7))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#7 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#7))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#6 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#6))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#6 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#6))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#6 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#6))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#6 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#6))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#6 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#6))) else (var arr#6 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#6)))))))));

axiom (forall js#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON(js#0) } JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> $Is(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$1x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, js#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON(js#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.JSON(js#0) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.Value(), js#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));

axiom (forall $Heap: Heap, js#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.JSON(Lit(js#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(Lit(js#0)) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), Lit(js#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.JSON(Lit(js#0)) == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.Value(), Lit(js#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));

const reveal_JSON.ZeroCopy.Serializer._default.Text: bool;

const reveal_JSON.ZeroCopy.Serializer._default.JSON: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Value: bool;

const reveal_JSON.ZeroCopy.Serializer._default.String: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Number: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Object: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Array: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Members: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Items: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Member: bool;

const reveal_JSON.ZeroCopy.Serializer._default.Item: bool;

const unique class.JSON_mZeroCopy_mSerializer.__default: ClassName;

procedure {:verboseName "JSON.ZeroCopy.Serializer.Serialize (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0)) returns (rbs#0: DatatypeType where $Is(rbs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(rbs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Serialize (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType) returns (rbs#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Serialize", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(21,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc rbs#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(22,25): post-state"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume Wrappers.Result.Success_q(rbs#0);
    assume Wrappers.Result.Success_q(rbs#0);
    assume $Unbox(Wrappers.Result.value(rbs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(rbs#0)): ref, alloc)): bool;
    goto anon4;

  anon7_Else:
    assume Wrappers.Result.Success_q(rbs#0) ==> $Unbox(Wrappers.Result.value(rbs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(rbs#0)): ref, alloc)): bool;
    goto anon4;

  anon4:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(rbs#0);
    assume Wrappers.Result.Success_q(rbs#0);
    assume $Unbox(Wrappers.Result.value(rbs#0)): ref != null;
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(rbs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    return;

  anon8_Else:
    assume Wrappers.Result.Success_q(rbs#0) ==> Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(rbs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.Serialize (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.Serialize (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0)) returns (rbs#0: DatatypeType where $Is(rbs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(rbs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id23954"} Wrappers.Result.Success_q(rbs#0) ==> $Unbox(Wrappers.Result.value(rbs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(rbs#0)): ref, alloc)): bool;
  free ensures Wrappers.Result.Success_q(rbs#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id23955"} Wrappers.Result.Success_q(rbs#0) ==> Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(rbs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.Serializer.Serialize (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0)) returns (defass#rbs#0: bool, rbs#0: DatatypeType where defass#rbs#0 ==> $Is(rbs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(rbs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap), $_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id23956"} Wrappers.Result.Success_q(rbs#0) ==> $Unbox(Wrappers.Result.value(rbs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(rbs#0)): ref, alloc)): bool;
  free ensures Wrappers.Result.Success_q(rbs#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id23957"} Wrappers.Result.Success_q(rbs#0) ==> Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(rbs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Serialize (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType) returns (defass#rbs#0: bool, rbs#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
  var ##js#1: DatatypeType;
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
  var ##condition#0: bool;
  var ##error#0: DatatypeType;
  var bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap);
  var $rhs##0: ref;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Serialize", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(24,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##js#1 := js#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0));
    assume JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0);
    writer#0 := JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(25,26)"} true;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap) */;
    assume true;
    ##condition#0 := JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0);
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Lit(#JSON.Errors.SerializationError.OutOfMemory());
    assume $IsAlloc(##error#0, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    valueOrError0#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    defass#valueOrError0#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(26,45)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass._System.array(Tclass.BoundedInts.uint8()), valueOrError0#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass._System.array(Tclass.BoundedInts.uint8()), valueOrError0#0);
    rbs#0 := Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass._System.array(Tclass.BoundedInts.uint8()), valueOrError0#0);
    defass#rbs#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(26,45)"} true;
    assume defass#rbs#0;
    pop;
    return;

  anon6_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume true;
    assume true;
    call CallPre$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(writer#0);
    call $rhs##0 := CallPost$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(writer#0);
    bs#0 := $rhs##0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(27,30)"} true;
    assume true;
    assume true;
    rbs#0 := #Wrappers.Result.Success($Box(bs#0));
    defass#rbs#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(28,22)"} true;
    assume defass#rbs#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (len#0: DatatypeType where $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType, dest#0: ref) returns (len#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.SerializeTo", " | ", js#0, " | ", dest#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(31,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
    assume $HeapSucc(old($Heap), $Heap);
    havoc len#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(33,25): post-state"} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Wrappers.Result.Success_q(len#0);
    assume Wrappers.Result.Success_q(len#0);
    assume dest#0 != null;
    assume $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
    goto anon4;

  anon13_Else:
    assume Wrappers.Result.Success_q(len#0) ==> $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
    goto anon4;

  anon4:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Wrappers.Result.Success_q(len#0);
    assume dest#0 != null;
    assume Wrappers.Result.Success_q(len#0);
    assume 0 <= $Unbox(Wrappers.Result.value(len#0)): int && $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    goto anon7;

  anon14_Else:
    assume Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    goto anon7;

  anon7:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(len#0);
    assume dest#0 != null;
    assume Wrappers.Result.Success_q(len#0);
    assume 0 <= $Unbox(Wrappers.Result.value(len#0)): int && $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
    assume dest#0 != null;
    assume $IsAlloc(dest#0, Tclass._System.array?(Tclass.BoundedInts.uint8()), old($Heap));
    assume Wrappers.Result.Success_q(len#0);
    assume $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), old($Heap));
    assume 0 <= $Unbox(Wrappers.Result.value(len#0)): int && $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), dest#0), $Unbox(Wrappers.Result.value(len#0)): int));
    goto anon10;

  anon15_Else:
    assume Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), dest#0), $Unbox(Wrappers.Result.value(len#0)): int));
    goto anon10;

  anon10:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume Wrappers.Result.Failure_q(len#0);
    assume $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == dest#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    return;

  anon16_Else:
    assume Wrappers.Result.Failure_q(len#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == dest#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (len#0: DatatypeType where $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id23997"} Wrappers.Result.Success_q(len#0) ==> $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
  free ensures Wrappers.Result.Success_q(len#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id23998"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures true;
  free ensures {:id "id23999"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), dest#0), $Unbox(Wrappers.Result.value(len#0)): int));
  free ensures true;
  free ensures {:id "id24000"} Wrappers.Result.Failure_q(len#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == dest#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), dest#0: ref where $Is(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(dest#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (defass#len#0: bool, len#0: DatatypeType where defass#len#0 ==> $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap), $_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id24001"} Wrappers.Result.Success_q(len#0) ==> $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(dest#0);
  free ensures Wrappers.Result.Success_q(len#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id24002"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures true;
  free ensures {:id "id24003"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, dest#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), dest#0), $Unbox(Wrappers.Result.value(len#0)): int));
  free ensures true;
  free ensures {:id "id24004"} Wrappers.Result.Failure_q(len#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == dest#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == dest#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType, dest#0: ref) returns (defass#len#0: bool, len#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
  var ##js#1: DatatypeType;
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
  var ##condition#0: bool;
  var ##error#0: DatatypeType;
  var defass#valueOrError1#0: bool;
  var valueOrError1#0: DatatypeType where defass#valueOrError1#0 ==> $Is(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
  var ##condition#1: bool;
  var ##error#1: DatatypeType;
  var dest##0: ref;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.SerializeTo", " | ", js#0, " | ", dest#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == dest#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(37,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    ##js#1 := js#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0));
    assume JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0);
    writer#0 := JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(38,26)"} true;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap) */;
    assume true;
    ##condition#0 := JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0);
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Lit(#JSON.Errors.SerializationError.OutOfMemory());
    assume $IsAlloc(##error#0, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    valueOrError0#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(writer#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    defass#valueOrError0#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(39,45)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError0#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError0#0);
    len#0 := Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError0#0);
    defass#len#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(39,45)"} true;
    assume defass#len#0;
    pop;
    return;

  anon10_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    havoc valueOrError1#0 /* where defass#valueOrError1#0 ==> $Is(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError1#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap) */;
    assume true;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(writer#0);
    assume dest#0 != null;
    ##condition#1 := JSON_mUtils_mViews_mWriters.Writer__.length(writer#0) <= _System.array.Length(dest#0);
    assume $IsAlloc(##condition#1, TBool, $Heap);
    ##error#1 := Lit(#JSON.Errors.SerializationError.OutOfMemory());
    assume $IsAlloc(##error#1, Tclass.JSON_mErrors.SerializationError(), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.length(writer#0) <= _System.array.Length(dest#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(writer#0) && Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.length(writer#0) <= _System.array.Length(dest#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    valueOrError1#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), JSON_mUtils_mViews_mWriters.Writer__.length(writer#0) <= _System.array.Length(dest#0), $Box(Lit(#JSON.Errors.SerializationError.OutOfMemory())));
    defass#valueOrError1#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(40,61)"} true;
    assume defass#valueOrError1#0;
    assume $IsAllocBox($Box(valueOrError1#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0);
    push;
    assume true;
    assume defass#valueOrError1#0;
    assume $IsAllocBox($Box(valueOrError1#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError1#0);
    assume Wrappers.Outcome.Fail_q(valueOrError1#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError1#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError1#0);
    len#0 := Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError1#0);
    defass#len#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(40,61)"} true;
    assume defass#len#0;
    pop;
    return;

  anon11_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#0);
    assume true;
    assume true;
    dest##0 := dest#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == dest##0 ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(writer#0, dest##0);
    call CallPost$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(writer#0, dest##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(41,23)"} true;
    assume true;
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(writer#0);
    len#0 := #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mWriters.Writer__.length(writer#0)));
    defass#len#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(42,33)"} true;
    assume defass#len#0;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Text($reveal: bool, js#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $reveal: bool, js#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Text($reveal, js#0) } JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text($reveal, js#0)), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0)) && $Is(JSON_mZeroCopy_mSerializer.__default.Text($reveal, js#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 4 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Text(true, js#0) } JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty()) && JSON_mZeroCopy_mSerializer.__default.Text(true, js#0) == JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty()));
axiom 4 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Text(true, Lit(js#0)) } JSON_mZeroCopy_mSerializer.__default.Text#canCall(Lit(js#0)) || (4 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mZeroCopy_mSerializer.__default.JSON#canCall(Lit(js#0), JSON_mUtils_mViews_mWriters.Writer__.Empty()) && JSON_mZeroCopy_mSerializer.__default.Text(true, Lit(js#0)) == JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, Lit(js#0), JSON_mUtils_mViews_mWriters.Writer__.Empty()));
}

function JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0: DatatypeType) : bool;

function JSON_mZeroCopy_mSerializer.__default.Text#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Text#requires(js#0) } $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mSerializer.__default.Text#requires(js#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Text (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Text(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24025"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Text (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Text(js#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;
  var ##js#1: DatatypeType;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Text", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(45,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#0);
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    assume false;
    return;

  anon4_Else:
    ##js#1 := js#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    ##writer#0 := JSON_mUtils_mViews_mWriters.Writer__.Empty();
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty());
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty()));
    assume JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0) == JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty());
    assume JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty());
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0) == wr#0;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.JSON($reveal: bool, js#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, js#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.JSON($reveal, js#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, writer#0) || (3 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.JSON($reveal, js#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.JSON($reveal, js#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.JSON(true, js#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, writer#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(js#0)) && (forall $l#1#wr#0: DatatypeType :: $Is($l#1#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $l#1#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#2#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#2#wr#0): DatatypeType))), (lambda $l#2#heap#0: Heap, $l#2#wr#0: Box :: $IsBox($l#2#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#2#heap#0: Heap, $l#2#wr#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#3#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#3#wr#0): DatatypeType))), (lambda $l#3#heap#0: Heap, $l#3#wr#0: Box :: $IsBox($l#3#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#3#heap#0: Heap, $l#3#wr#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)) && JSON_mZeroCopy_mSerializer.__default.JSON(true, js#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#0#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#0#wr#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#wr#0: Box :: $IsBox($l#0#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#0#heap#0: Heap, $l#0#wr#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.JSON(true, Lit(js#0), Lit(writer#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(Lit(js#0), Lit(writer#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))) && (forall $l#5#wr#0: DatatypeType :: $Is($l#5#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $l#5#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#6#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#6#wr#0): DatatypeType))), (lambda $l#6#heap#0: Heap, $l#6#wr#0: Box :: $IsBox($l#6#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#6#heap#0: Heap, $l#6#wr#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#7#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#7#wr#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#wr#0: Box :: $IsBox($l#7#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#7#heap#0: Heap, $l#7#wr#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))), Lit(JSON_mGrammar.Structural.after(Lit(js#0)))) && JSON_mZeroCopy_mSerializer.__default.JSON(true, Lit(js#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#4#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#4#wr#0): DatatypeType))), (lambda $l#4#heap#0: Heap, $l#4#wr#0: Box :: $IsBox($l#4#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#4#heap#0: Heap, $l#4#wr#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)))), Lit(JSON_mGrammar.Structural.after(Lit(js#0)))));
}

function JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0: DatatypeType, writer#0: DatatypeType) : bool;

function JSON_mZeroCopy_mSerializer.__default.JSON#requires(DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.JSON#requires(js#0, writer#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.JSON#requires(js#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.JSON (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.JSON(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24029"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.JSON (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.JSON(js#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;
  var a##0: Seq;
  var b##0: Seq;
  var c##0: Seq;
  var ##self#0: DatatypeType;
  var d##0: Seq;
  var ##v'#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var wr#1: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: DatatypeType;
  var ##v#0: DatatypeType;
  var ##writer#0: DatatypeType;
  var ##fn#0: HandleType;
  var ##v'#1: DatatypeType;
  var b$reqreads#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.JSON", " | ", js#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(51,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#0);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0)));
    assume false;
    return;

  anon8_Else:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Structural.Structural_q(js#0);
    assume $IsAllocBox($Box(JSON_mGrammar.Structural.before(js#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mGrammar.Structural.before(js#0));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mGrammar.Structural.before(js#0));
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.Structural.before(js#0));
    assume JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.Structural.before(js#0));
    b##0 := JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.Structural.before(js#0));
    assume JSON_mGrammar.Structural.Structural_q(js#0);
    ##self#0 := $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType);
    assume JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType);
    c##0 := JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType);
    assume JSON_mGrammar.Structural.Structural_q(js#0);
    assume $IsAllocBox($Box(JSON_mGrammar.Structural.after(js#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mGrammar.Structural.after(js#0));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(JSON_mGrammar.Structural.after(js#0));
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.Structural.after(js#0));
    assume JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.Structural.after(js#0));
    d##0 := JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.Structural.after(js#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0, b##0, c##0, d##0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0, b##0, c##0, d##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(54,83)"} true;
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Structural.Structural_q(js#0);
    ##v'#0 := JSON_mGrammar.Structural.before(js#0);
    assume $IsAlloc(##v'#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(js#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc wr#1;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} $Is(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume JSON_mGrammar.Structural.Structural_q(js#0);
    ##v#0 := $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType;
    assume $IsAlloc(##v#0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#0);
    ##writer#0 := wr#1;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $lambdaHeap#0);
    assume JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, wr#1);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, wr#1));
    assume lambdaResult#0 == JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, wr#1);
    assume JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, wr#1);
    assume $Is(lambdaResult#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon6;

  anon10_Else:
    assume {:partition} !($Is(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon9_Else:
    goto anon7;

  anon7:
    ##fn#0 := Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#9#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#9#wr#0): DatatypeType))), (lambda $l#9#heap#0: Heap, $l#9#wr#0: Box :: $IsBox($l#9#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#9#heap#0: Heap, $l#9#wr#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)));
    assume {:subsumption 0} Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##fn#0, $Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0))));
    assume Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##fn#0, $Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0))));
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##fn#0, $Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0))))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#10#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#10#wr#0): DatatypeType))), (lambda $l#10#heap#0: Heap, $l#10#wr#0: Box :: $IsBox($l#10#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#10#heap#0: Heap, $l#10#wr#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#11#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#11#wr#0): DatatypeType))), (lambda $l#11#heap#0: Heap, $l#11#wr#0: Box :: $IsBox($l#11#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#11#heap#0: Heap, $l#11#wr#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#12#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#12#wr#0): DatatypeType))), (lambda $l#12#heap#0: Heap, $l#12#wr#0: Box :: $IsBox($l#12#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#12#heap#0: Heap, $l#12#wr#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Structural.Structural_q(js#0);
    ##v'#1 := JSON_mGrammar.Structural.after(js#0);
    assume $IsAlloc(##v'#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#13#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#13#wr#0): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#wr#0: Box :: $IsBox($l#13#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#13#heap#0: Heap, $l#13#wr#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#14#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#14#wr#0): DatatypeType))), (lambda $l#14#heap#0: Heap, $l#14#wr#0: Box :: $IsBox($l#14#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#14#heap#0: Heap, $l#14#wr#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#15#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#15#wr#0): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#wr#0: Box :: $IsBox($l#15#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#15#heap#0: Heap, $l#15#wr#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#16#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#16#wr#0): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#wr#0: Box :: $IsBox($l#16#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#16#heap#0: Heap, $l#16#wr#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)));
    assume JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#18#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#18#wr#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#wr#0: Box :: $IsBox($l#18#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#18#heap#0: Heap, $l#18#wr#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0));
    assume JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(js#0)) && (forall $l#19#wr#0: DatatypeType :: $Is($l#19#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $l#19#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#20#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#20#wr#0): DatatypeType))), (lambda $l#20#heap#0: Heap, $l#20#wr#0: Box :: $IsBox($l#20#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#20#heap#0: Heap, $l#20#wr#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#21#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#21#wr#0): DatatypeType))), (lambda $l#21#heap#0: Heap, $l#21#wr#0: Box :: $IsBox($l#21#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#21#heap#0: Heap, $l#21#wr#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0));
    assume $Is(JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, writer#0) == wr#0;
    assume b$reqreads#0;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Value($ly: LayerType, $reveal: bool, v#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(v#0, writer#0) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(v#0, writer#0) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (JSON_mGrammar.Value.Null_q(v#0) ==> (var n#1 := JSON_mGrammar.Value.n(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#1))) && (!JSON_mGrammar.Value.Null_q(v#0) ==> (JSON_mGrammar.Value.Bool_q(v#0) ==> (var b#1 := JSON_mGrammar.Value.b(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#1))) && (!JSON_mGrammar.Value.Bool_q(v#0) ==> (JSON_mGrammar.Value.String_q(v#0) ==> (var str#1 := JSON_mGrammar.Value.str(v#0); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#1, writer#0))) && (!JSON_mGrammar.Value.String_q(v#0) ==> (JSON_mGrammar.Value.Number_q(v#0) ==> (var num#1 := JSON_mGrammar.Value.num(v#0); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#1, writer#0))) && (!JSON_mGrammar.Value.Number_q(v#0) ==> (JSON_mGrammar.Value.Object_q(v#0) ==> (var obj#1 := JSON_mGrammar.Value.obj(v#0); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#1, writer#0))) && (!JSON_mGrammar.Value.Object_q(v#0) ==> (var arr#1 := JSON_mGrammar.Value.arr(v#0); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#1, writer#0))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, v#0, writer#0) == (if JSON_mGrammar.Value.Null_q(v#0) then (var n#0 := JSON_mGrammar.Value.n(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#0)) else (if JSON_mGrammar.Value.Bool_q(v#0) then (var b#0 := JSON_mGrammar.Value.b(v#0); (var wr#0 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#0); wr#0)) else (if JSON_mGrammar.Value.String_q(v#0) then (var str#0 := JSON_mGrammar.Value.str(v#0); (var wr#1 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#0, writer#0); wr#1)) else (if JSON_mGrammar.Value.Number_q(v#0) then (var num#0 := JSON_mGrammar.Value.num(v#0); (var wr#2 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#0, writer#0); wr#2)) else (if JSON_mGrammar.Value.Object_q(v#0) then (var obj#0 := JSON_mGrammar.Value.obj(v#0); (var wr#3 := JSON_mZeroCopy_mSerializer.__default.Object($ly, reveal_JSON.ZeroCopy.Serializer._default.Object, obj#0, writer#0); wr#3)) else (var arr#0 := JSON_mGrammar.Value.arr(v#0); (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Array($ly, reveal_JSON.ZeroCopy.Serializer._default.Array, arr#0, writer#0); wr#4))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(v#0), writer#0) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (var n#3 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#3))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (var b#3 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#3))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (var str#3 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#3, writer#0))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (var num#3 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#3, writer#0))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var obj#3 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#3, writer#0))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var arr#3 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#3, writer#0))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), writer#0) == (if JSON_mGrammar.Value.Null_q(Lit(v#0)) then (var n#2 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#2)) else (if JSON_mGrammar.Value.Bool_q(Lit(v#0)) then (var b#2 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); (var wr#10 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#2); wr#10)) else (if JSON_mGrammar.Value.String_q(Lit(v#0)) then (var str#2 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); (var wr#11 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#2, writer#0); wr#11)) else (if JSON_mGrammar.Value.Number_q(Lit(v#0)) then (var num#2 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); (var wr#12 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#2, writer#0); wr#12)) else (if JSON_mGrammar.Value.Object_q(Lit(v#0)) then (var obj#2 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); (var wr#13 := JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#2, writer#0); wr#13)) else (var arr#2 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#2, writer#0); wr#14))))))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(v#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (var n#5 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), n#5))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (var b#5 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), b#5))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (var str#5 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#5, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (var num#5 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#5, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var obj#5 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#5, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var arr#5 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#5, Lit(writer#0)))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), Lit(writer#0)) == (if JSON_mGrammar.Value.Null_q(Lit(v#0)) then (var n#4 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), n#4)) else (if JSON_mGrammar.Value.Bool_q(Lit(v#0)) then (var b#4 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); (var wr#20 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), b#4); wr#20)) else (if JSON_mGrammar.Value.String_q(Lit(v#0)) then (var str#4 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); (var wr#21 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#4, Lit(writer#0)); wr#21)) else (if JSON_mGrammar.Value.Number_q(Lit(v#0)) then (var num#4 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); (var wr#22 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#4, Lit(writer#0)); wr#22)) else (if JSON_mGrammar.Value.Object_q(Lit(v#0)) then (var obj#4 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#4, Lit(writer#0)); wr#23)) else (var arr#4 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); (var wr#24 := JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#4, Lit(writer#0)); wr#24))))))));
}

function JSON_mZeroCopy_mSerializer.__default.Value#canCall(v#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), $reveal, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), $reveal, v#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value(AsFuelBottom($ly), $reveal, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Value($LZ, $reveal, v#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Value#requires(LayerType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value#requires($ly, v#0, writer#0) } $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Value#requires($ly, v#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Value (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Value(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#30: DatatypeType where $Is(wr#30, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24043"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#30), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Value (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Value(v#0: DatatypeType, writer#0: DatatypeType) returns (wr#30: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var _mcc#5#0: DatatypeType;
  var arr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##arr#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##arr#1: DatatypeType;
  var ##writer#0: DatatypeType;
  var ##self#2: DatatypeType;
  var _mcc#4#0: DatatypeType;
  var obj#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##self#3: DatatypeType;
  var ##self#4: DatatypeType;
  var ##self#5: DatatypeType;
  var ##obj#0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##obj#1: DatatypeType;
  var ##writer#1: DatatypeType;
  var _mcc#3#0: DatatypeType;
  var num#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var v##0_0: DatatypeType;
  var wr#Z#2: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##num#0: DatatypeType;
  var ##writer#2: DatatypeType;
  var _mcc#2#0: DatatypeType;
  var str#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var wr#Z#3: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##str#0: DatatypeType;
  var ##writer#3: DatatypeType;
  var _mcc#1#0: DatatypeType;
  var b#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var wr#Z#4: DatatypeType;
  var let#9#0#0: DatatypeType;
  var ##v'#0: DatatypeType;
  var _mcc#0#0: DatatypeType;
  var n#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;
  var ##v'#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Value", " | ", v#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(61,50): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#30), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#30);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##self#0 := v#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#30), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0)));
    assume false;
    return;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Null(_mcc#0#0);
    assume $Is(_mcc#0#0, Tclass.JSON_mGrammar.jnull());
    havoc n#Z#0;
    assume $Is(n#Z#0, Tclass.JSON_mGrammar.jnull()) && $IsAlloc(n#Z#0, Tclass.JSON_mGrammar.jnull(), $Heap);
    assume let#10#0#0 == _mcc#0#0;
    assume true;
    assume $Is(let#10#0#0, Tclass.JSON_mGrammar.jnull());
    assume n#Z#0 == let#10#0#0;
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    ##v'#1 := n#Z#0;
    assume $IsAlloc(##v'#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#Z#0));
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#Z#0);
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon15;

  anon17_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Null(_mcc#0#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Bool(_mcc#1#0);
    assume $Is(_mcc#1#0, Tclass.JSON_mGrammar.jbool());
    havoc b#Z#0;
    assume $Is(b#Z#0, Tclass.JSON_mGrammar.jbool()) && $IsAlloc(b#Z#0, Tclass.JSON_mGrammar.jbool(), $Heap);
    assume let#8#0#0 == _mcc#1#0;
    assume true;
    assume $Is(let#8#0#0, Tclass.JSON_mGrammar.jbool());
    assume b#Z#0 == let#8#0#0;
    havoc wr#Z#4;
    assume $Is(wr#Z#4, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#4, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    ##v'#0 := b#Z#0;
    assume $IsAlloc(##v'#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#Z#0));
    assume let#9#0#0 == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#Z#0);
    assume $Is(let#9#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#4 == let#9#0#0;
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == wr#Z#4;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon15;

  anon18_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Bool(_mcc#1#0);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.String(_mcc#2#0);
    assume $Is(_mcc#2#0, Tclass.JSON_mGrammar.jstring());
    havoc str#Z#0;
    assume $Is(str#Z#0, Tclass.JSON_mGrammar.jstring()) && $IsAlloc(str#Z#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume let#6#0#0 == _mcc#2#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.JSON_mGrammar.jstring());
    assume str#Z#0 == let#6#0#0;
    havoc wr#Z#3;
    assume $Is(wr#Z#3, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#3, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##str#0 := str#Z#0;
    assume $IsAlloc(##str#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    ##writer#3 := writer#0;
    assume $IsAlloc(##writer#3, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.String#canCall(str#Z#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#Z#0, writer#0));
    assume let#7#0#0 == JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#Z#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.String#canCall(str#Z#0, writer#0);
    assume $Is(let#7#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#3 == let#7#0#0;
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == wr#Z#3;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon15;

  anon19_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.String(_mcc#2#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Number(_mcc#3#0);
    assume $Is(_mcc#3#0, Tclass.JSON_mGrammar.jnumber());
    havoc num#Z#0;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnumber()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume let#4#0#0 == _mcc#3#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mGrammar.jnumber());
    assume num#Z#0 == let#4#0#0;
    assume $IsA#JSON_mGrammar.Value(v#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume true;
    v##0_0 := v#0;
    call CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v##0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(69,86)"} true;
    assume JSON_mGrammar.Value#Equal(#JSON.Grammar.Value.Number(num#Z#0), v#0);
    assume false;
    goto anon9;

  anon21_Else:
    goto anon9;

  anon9:
    assume JSON_mGrammar.Value#Equal(#JSON.Grammar.Value.Number(num#Z#0), v#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(69,88)"} true;
    havoc wr#Z#2;
    assume $Is(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##num#0 := num#Z#0;
    assume $IsAlloc(##num#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    ##writer#2 := writer#0;
    assume $IsAlloc(##writer#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#Z#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#Z#0, writer#0));
    assume let#5#0#0 == JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#Z#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#Z#0, writer#0);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#2 == let#5#0#0;
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == wr#Z#2;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon15;

  anon20_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Number(_mcc#3#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Object(_mcc#4#0);
    assume $Is(_mcc#4#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    havoc obj#Z#0;
    assume $Is(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume let#2#0#0 == _mcc#4#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    assume obj#Z#0 == let#2#0#0;
    assume $IsA#JSON_mGrammar.Value(v#0);
    assume JSON_mGrammar.Value#Equal(#JSON.Grammar.Value.Object(obj#Z#0), v#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(70,55)"} true;
    ##self#3 := v#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    ##self#4 := #JSON.Grammar.Value.Object(obj#Z#0);
    assume $IsAlloc(##self#4, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Object(obj#Z#0));
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Object(obj#Z#0)));
    ##self#5 := #JSON.Grammar.Value.Object(obj#Z#0);
    assume $IsAlloc(##self#5, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Object(obj#Z#0));
    ##obj#0 := obj#Z#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#Z#0);
    goto anon12;

  anon23_Else:
    assume {:partition} !Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Object(obj#Z#0)));
    goto anon12;

  anon12:
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Object(obj#Z#0)) && (Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Object(obj#Z#0))) ==> JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Object(obj#Z#0)) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#Z#0));
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), #JSON.Grammar.Value.Object(obj#Z#0)));
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), #JSON.Grammar.Value.Object(obj#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#Z#0));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Object(obj#Z#0))) && Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Object(obj#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(70,132)"} true;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##obj#1 := obj#Z#0;
    assume $IsAlloc(##obj#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##writer#1 := writer#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(4) || DtRank(##obj#1) < DtRank(v#0) || LitInt(3) == LitInt(4);
    assume DtRank(##obj#1) < DtRank(v#0) || (DtRank(##obj#1) == DtRank(v#0) && LitInt(3) < LitInt(4));
    assume JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#Z#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Object($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#Z#0, writer#0));
    assume let#3#0#0 == JSON_mZeroCopy_mSerializer.__default.Object($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#Z#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#Z#0, writer#0);
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#1 == let#3#0#0;
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == wr#Z#1;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon15;

  anon22_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Object(_mcc#4#0);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} v#0 == #JSON.Grammar.Value.Array(_mcc#5#0);
    assume $Is(_mcc#5#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    havoc arr#Z#0;
    assume $Is(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume let#0#0#0 == _mcc#5#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    assume arr#Z#0 == let#0#0#0;
    assume $IsA#JSON_mGrammar.Value(v#0);
    assume JSON_mGrammar.Value#Equal(#JSON.Grammar.Value.Array(arr#Z#0), v#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(71,53)"} true;
    ##self#1 := v#0;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    ##arr#0 := arr#Z#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#Z#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#Z#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#Z#0));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(71,94)"} true;
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##arr#1 := arr#Z#0;
    assume $IsAlloc(##arr#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(4) || DtRank(##arr#1) < DtRank(v#0) || LitInt(3) == LitInt(4);
    assume DtRank(##arr#1) < DtRank(v#0) || (DtRank(##arr#1) == DtRank(v#0) && LitInt(3) < LitInt(4));
    assume JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#Z#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Array($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#Z#0, writer#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.Array($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#Z#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#Z#0, writer#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(wr#Z#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#0);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##self#2 := v#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#0) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(v#0);
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), v#0)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(71,177)"} true;
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == wr#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon15;

  anon24_Else:
    assume {:partition} v#0 != #JSON.Grammar.Value.Array(_mcc#5#0);
    assume false;
    goto anon15;

  anon15:
    assume JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, v#0, writer#0) == wr#30;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.String($reveal: bool, str#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, str#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.String($reveal, str#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.String#canCall(str#0, writer#0) || (0 < $FunctionContextHeight && $Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.String($reveal, str#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.String(str#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.String($reveal, str#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.String(true, str#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.String#canCall(str#0, writer#0) || (0 < $FunctionContextHeight && $Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jstring.lq(str#0)) && JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)) && JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0)) && JSON_mZeroCopy_mSerializer.__default.String(true, str#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0)));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(str#0), writer#0) || (0 < $FunctionContextHeight && $Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))) && JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))));
axiom 0 <= $FunctionContextHeight ==> (forall str#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(str#0), Lit(writer#0)) || (0 < $FunctionContextHeight && $Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))) && JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))));
}

function JSON_mZeroCopy_mSerializer.__default.String#canCall(str#0: DatatypeType, writer#0: DatatypeType) : bool;

function JSON_mZeroCopy_mSerializer.__default.String#requires(DatatypeType, DatatypeType) : bool;

axiom (forall str#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.String#requires(str#0, writer#0) } $Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.String#requires(str#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.String (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.String(str#0: DatatypeType where $Is(str#0, Tclass.JSON_mGrammar.jstring()), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24093"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.String(str#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.String (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.String(str#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##v'#0: DatatypeType;
  var ##v'#1: DatatypeType;
  var ##v'#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.String", " | ", str#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(74,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#0);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##self#0 := str#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.String(str#0)));
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jstring.JString_q(str#0);
    ##v'#0 := JSON_mGrammar.jstring.lq(str#0);
    assume $IsAlloc(##v'#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jstring.lq(str#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jstring.JString_q(str#0);
    ##v'#1 := JSON_mGrammar.jstring.contents(str#0);
    assume $IsAlloc(##v'#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jstring.JString_q(str#0);
    ##v'#2 := JSON_mGrammar.jstring.rq(str#0);
    assume $IsAlloc(##v'#2, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0)));
    assume JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0));
    assume JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jstring.lq(str#0)) && JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)) && JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0));
    assume $Is(JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#0, writer#0) == wr#0;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Number($reveal: bool, num#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, num#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Number($reveal, num#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#0, writer#0) || (0 < $FunctionContextHeight && $Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Number($reveal, num#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Number(num#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Number($reveal, num#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 0 <= $FunctionContextHeight ==> (forall num#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Number(true, num#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#0, writer#0) || (0 < $FunctionContextHeight && $Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)) && (var wr#0 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)); JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType))) && (var wr#1 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) else wr#0); JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0)) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, num#0, writer#0) == (var wr#0 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)); (var wr#1 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) else wr#0); (var wr#2 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) else wr#1); wr#2))));
axiom 0 <= $FunctionContextHeight ==> (forall num#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(Lit(num#0), writer#0) || (0 < $FunctionContextHeight && $Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))) && (var wr#3 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#3, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#3, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType))))) && (var wr#4 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#3, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#3); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#4, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#4, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#4, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType))))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), writer#0) == (var wr#3 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); (var wr#4 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#3, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#3); (var wr#5 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#4, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) else wr#4); wr#5))));
axiom 0 <= $FunctionContextHeight ==> (forall num#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(Lit(num#0), Lit(writer#0)) || (0 < $FunctionContextHeight && $Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))) && (var wr#6 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#6, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#6, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType))))) && (var wr#7 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#6, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#6); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#7, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#7, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#7, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType))))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), Lit(writer#0)) == (var wr#6 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); (var wr#7 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#6, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#6); (var wr#8 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#7, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) else wr#7); wr#8))));
}

function JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#0: DatatypeType, writer#0: DatatypeType) : bool;

function JSON_mZeroCopy_mSerializer.__default.Number#requires(DatatypeType, DatatypeType) : bool;

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Number#requires(num#0, writer#0) } $Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Number#requires(num#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Number (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Number(num#0: DatatypeType where $Is(num#0, Tclass.JSON_mGrammar.jnumber()), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#9: DatatypeType where $Is(wr#9, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24100"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#9), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Number(num#0)));



axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$2x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Number (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Number(num#0: DatatypeType, writer#0: DatatypeType) returns (wr#9: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##v'#0: DatatypeType;
  var ##v'#1: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##v'#2: DatatypeType;
  var ##v'#3: DatatypeType;
  var ##v#0: DatatypeType;
  var ##v#1: DatatypeType;
  var ##self#1: DatatypeType;
  var ##fT#0: HandleType;
  var ##v#0_0: DatatypeType;
  var ##v#0_1: DatatypeType;
  var wr#Z#2: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##v'#4: DatatypeType;
  var ##v'#5: DatatypeType;
  var ##v'#6: DatatypeType;
  var ##v#2: DatatypeType;
  var ##v#3: DatatypeType;
  var ##self#2: DatatypeType;
  var ##fT#1: HandleType;
  var ##self#3: DatatypeType;
  var ##fT#2: HandleType;
  var ##v#1_1_0: DatatypeType;
  var ##v#1_1_1: DatatypeType;
  var ##self#1_1_0: DatatypeType;
  var ##fT#1_1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Number", " | ", num#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(84,50): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#9), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#9);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##self#0 := num#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#9), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Number(num#0)));
    assume false;
    return;

  anon19_Else:
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v'#0 := JSON_mGrammar.jnumber.minus(num#0);
    assume $IsAlloc(##v'#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jnumber.minus(num#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v'#1 := JSON_mGrammar.jnumber.num(num#0);
    assume $IsAlloc(##v'#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)));
    assume let#0#0#0 == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0));
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#0#0#0;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0));
    assume $IsAllocBox($Box(wr#Z#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0));
    assume JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType);
    ##v'#2 := JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType);
    assume $IsAlloc(##v'#2, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0));
    assume JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType);
    ##v'#3 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType);
    assume $IsAlloc(##v'#3, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)));
    assume let#1#0#0 == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#0, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType));
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon6;

  anon20_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0));
    assume let#1#0#0 == wr#Z#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon6;

  anon6:
    assume wr#Z#1 == let#1#0#0;
    assume $IsAllocBox($Box(wr#Z#1), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#0 := JSON_mGrammar.jnumber.minus(num#0);
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#1 := JSON_mGrammar.jnumber.num(num#0);
    assume $IsAlloc(##v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume true;
    ##self#1 := JSON_mGrammar.jnumber.frac(num#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.jnumber.frac(num#0));
    assume $IsAllocBox($Box(wr#Z#1), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#0_0 := JSON_mGrammar.jnumber.minus(num#0);
    assume $IsAlloc(##v#0_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#0_1 := JSON_mGrammar.jnumber.num(num#0);
    assume $IsAlloc(##v#0_1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0));
    goto anon9;

  anon22_Else:
    assume {:partition} !JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.jnumber.frac(num#0));
    goto anon9;

  anon9:
    assume JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.jnumber.frac(num#0)) ==> JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0)));
    assume {:subsumption 0} JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.jnumber.frac(num#0)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), Seq#Empty(): Seq));
    assume JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.jnumber.frac(num#0)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), Seq#Empty(): Seq));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(94,110)"} true;
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())));
    assume false;
    goto anon10;

  anon21_Else:
    goto anon10;

  anon10:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(95,4)"} true;
    havoc wr#Z#2;
    assume $Is(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    assume $IsAllocBox($Box(wr#Z#1), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    assume JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType);
    ##v'#4 := JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType);
    assume $IsAlloc(##v'#4, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(wr#Z#1);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(wr#Z#1);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    assume JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType);
    ##v'#5 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType);
    assume $IsAlloc(##v'#5, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    assume JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType);
    ##v'#6 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType);
    assume $IsAlloc(##v'#6, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)));
    assume let#2#0#0 == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#Z#1, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType));
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon13;

  anon23_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    assume let#2#0#0 == wr#Z#1;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon13;

  anon13:
    assume wr#Z#2 == let#2#0#0;
    assume $IsAllocBox($Box(wr#Z#2), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#2 := JSON_mGrammar.jnumber.minus(num#0);
    assume $IsAlloc(##v#2, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#3 := JSON_mGrammar.jnumber.num(num#0);
    assume $IsAlloc(##v#3, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume true;
    ##self#2 := JSON_mGrammar.jnumber.frac(num#0);
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume true;
    ##self#3 := JSON_mGrammar.jnumber.exp(num#0);
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    ##fT#2 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(num#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(num#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    goto anon17;

  anon25_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0));
    assume $IsAllocBox($Box(wr#Z#2), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#1_1_0 := JSON_mGrammar.jnumber.minus(num#0);
    assume $IsAlloc(##v#1_1_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    ##v#1_1_1 := JSON_mGrammar.jnumber.num(num#0);
    assume $IsAlloc(##v#1_1_1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0));
    assume JSON_mGrammar.jnumber.JNumber_q(num#0);
    assume true;
    ##self#1_1_0 := JSON_mGrammar.jnumber.frac(num#0);
    assume $IsAlloc(##self#1_1_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#1_1_0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#1_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(JSON_mGrammar.jnumber.num(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), Seq#Empty(): Seq));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(102,126)"} true;
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(num#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())));
    assume false;
    goto anon18;

  anon24_Else:
    goto anon18;

  anon18:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(Seq#Append(Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.minus(num#0))), JSON_mConcreteSyntax_mSpec.__default.View(JSON_mGrammar.jnumber.num(num#0))), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), JSON_mGrammar.jnumber.frac(num#0), JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), JSON_mGrammar.jnumber.exp(num#0), JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(104,4)"} true;
    assume $Is(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#0, writer#0) == wr#Z#2;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#0, writer#0) == wr#9;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, st#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle()))) && $Is(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 0 <= $FunctionContextHeight ==> (forall st#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0) || (0 < $FunctionContextHeight && $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(st#0)) && JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType) && JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0)));
axiom 0 <= $FunctionContextHeight ==> (forall st#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(st#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(st#0), Lit(writer#0)) || (0 < $FunctionContextHeight && $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(Lit(st#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))) && JSON_mGrammar.Structural.Structural_q(Lit(st#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(st#0))): DatatypeType)) && JSON_mGrammar.Structural.Structural_q(Lit(st#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(st#0))): DatatypeType)), Lit(JSON_mGrammar.Structural.after(Lit(st#0)))) && JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(st#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(st#0))): DatatypeType)), Lit(JSON_mGrammar.Structural.after(Lit(st#0)))));
}

function JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$2x#0))): Seq);

function JSON_mZeroCopy_mSerializer.__default.StructuralView#requires(DatatypeType, DatatypeType) : bool;

axiom (forall st#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.StructuralView#requires(st#0, writer#0) } $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.StructuralView#requires(st#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.StructuralView (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0: DatatypeType where $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24136"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle())));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.StructuralView (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##v'#0: DatatypeType;
  var ##v'#1: DatatypeType;
  var ##v'#2: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.StructuralView", " | ", st#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(109,11): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#0);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle())));
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Structural.Structural_q(st#0);
    ##v'#0 := JSON_mGrammar.Structural.before(st#0);
    assume $IsAlloc(##v'#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(st#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0))), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Structural.Structural_q(st#0);
    ##v'#1 := $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType;
    assume $IsAlloc(##v'#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType));
    assume $IsAllocBox($Box(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType)), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Structural.Structural_q(st#0);
    ##v'#2 := JSON_mGrammar.Structural.after(st#0);
    assume $IsAlloc(##v'#2, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Valid_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0)));
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0));
    assume JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(st#0)) && JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType) && JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0));
    assume $Is(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0) == wr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType where $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Structural(st#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType, writer#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##st#0: DatatypeType;
  var ##writer#0: DatatypeType;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.StructuralViewEns", " | ", st#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(115,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(116,47): post-state"} true;
    ##st#0 := st#0;
    assume $IsAlloc(##st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0));
    assume $IsAllocBox($Box(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0));
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle())));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType where $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Structural(st#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType where $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Structural(st#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));
  modifies $Heap;
  free ensures JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
  free ensures {:id "id24146"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle())));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType where $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $IsA#JSON_mGrammar.Structural(st#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle());
  free ensures {:id "id24147"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle())));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType, writer#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.StructuralViewEns", " | ", st#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(117,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.Assume (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Assume(b#0: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.Assume (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.Assume(b#0: bool);



procedure {:verboseName "JSON.ZeroCopy.Serializer.Assume (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Assume(b#0: bool);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id24149"} b#0;
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall $ly: LayerType :: { JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($ly)) } JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($ly)) == JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly));

function JSON_mConcreteSyntax_mSpec.__default.Member#Handle($fuel: LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Member($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Member#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$0x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($ly, $fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Member($ly, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $Box($fh$0x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##obj#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.BracketedToObject", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(123,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(124,45): post-state"} true;
    assume true;
    ##self#0 := obj#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
  free ensures {:id "id24153"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
  free ensures {:id "id24154"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var rMember#0: HandleType where $Is(rMember#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(rMember#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#0: Heap;
  var d#1: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;
  var ##fDatum#1: HandleType;
  var ##self#3: DatatypeType;
  var ##fDatum#2: HandleType;
  var ##bracketed#0_0: DatatypeType;
  var ##pd0#0_0: HandleType;
  var ##pd1#0_0: HandleType;
  var bracketed##0_0: DatatypeType;
  var pd0##0_0: HandleType;
  var pd1##0_0: HandleType;
  var ##self#1_0_0: DatatypeType;
  var ##fDatum#1_0_0: HandleType;
  var ##obj#1_0_0: DatatypeType;
  var ##self#1_1_0: DatatypeType;
  var ##fDatum#1_1_0: HandleType;
  var ##self#1_1_1: DatatypeType;
  var ##fDatum#1_1_1: HandleType;
  var ##self#1_0: DatatypeType;
  var ##fDatum#1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.BracketedToObject", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(125,2): initial state"} true;
    assume $IsA#JSON_mGrammar.Bracketed(obj#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#obj0#0: DatatypeType :: $Is($ih#obj0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && Lit(true) && DtRank($ih#obj0#0) < DtRank(obj#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $ih#obj0#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), $ih#obj0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#1;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} DtRank(d#1) < DtRank(obj#0);
    ##self#1 := d#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(d#1);
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), d#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(d#1);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon14_Else:
    assume {:partition} DtRank(obj#0) <= DtRank(d#1);
    goto anon4;

  anon13_Else:
    assume {:partition} !($Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    assume (forall $l#0#d#0: DatatypeType :: $Is($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#0#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#0#d#0));
    rMember#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#1#ly#0, $Unbox($l#1#d#0): DatatypeType))), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $IsBox($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#1#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(126,66)"} true;
    assume true;
    ##self#2 := obj#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#2) < DtRank(##self#2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    ##self#3 := obj#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#2 := rMember#0;
    assume $IsAlloc(##fDatum#2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#3) < DtRank(##self#3) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    push;
    assume true;
    ##bracketed#0_0 := obj#0;
    assume $IsAlloc(##bracketed#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##pd0#0_0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##pd0#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##pd1#0_0 := rMember#0;
    assume $IsAlloc(##pd1#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0);
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0) || (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ))), $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0) < DtRank(obj#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ))), $Box(d#0_0)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0) || (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_1) < DtRank(obj#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_1)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0) || (forall d#0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_2))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ))), $Box(d#0_2))): Seq } $Is(d#0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_2) < DtRank(obj#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ))), $Box(d#0_2))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_2))): Seq));
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)), rMember#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(131,82)"} true;
    assume true;
    bracketed##0_0 := obj#0;
    assume true;
    assume true;
    pd0##0_0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume true;
    pd1##0_0 := rMember#0;
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0, pd0##0_0, pd1##0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0, pd0##0_0, pd1##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(132,66)"} true;
    pop;
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume false;
    goto anon7;

  anon15_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(133,4)"} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    ##self#1_0 := obj#0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)) } $Is(d#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0) < DtRank(##self#1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume false;
    goto anon11;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume true;
    ##self#1_1_0 := obj#0;
    assume $IsAlloc(##self#1_1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1_1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)) } $Is(d#1_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_0) < DtRank(##self#1_1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    ##self#1_1_1 := obj#0;
    assume $IsAlloc(##self#1_1_1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_1 := rMember#0;
    assume $IsAlloc(##fDatum#1_1_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)) } $Is(d#1_1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_1) < DtRank(##self#1_1_1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume false;
    goto anon11;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    ##self#1_0_0 := obj#0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0_0 := rMember#0;
    assume $IsAlloc(##fDatum#1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)) } $Is(d#1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0_0) < DtRank(##self#1_0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    ##obj#1_0_0 := obj#0;
    assume $IsAlloc(##obj#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
    assume false;
    goto anon11;

  anon18_Else:
    goto anon11;

  anon11:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0));
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Object($ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(obj#0), writer#0) && (var wr#0 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0); JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, wr#0) && (var wr#1 := JSON_mZeroCopy_mSerializer.__default.Members($ly, reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#0); JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(obj#0), wr#1))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, obj#0, writer#0) == (var wr#0 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0); (var wr#1 := JSON_mZeroCopy_mSerializer.__default.Members($ly, reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#0); (var wr#2 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(obj#0), wr#1); wr#2))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(Lit(obj#0), writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0) && (var wr#3 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0); JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), wr#3) && (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#3); JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#4))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), writer#0) == (var wr#3 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0); (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#3); (var wr#5 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#4); wr#5))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(Lit(obj#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0)) && (var wr#6 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0))); JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), wr#6) && (var wr#7 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#6); JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#7))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), Lit(writer#0)) == (var wr#6 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0))); (var wr#7 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#6); (var wr#8 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#7); wr#8))));
}

function JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), $reveal, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), $reveal, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object(AsFuelBottom($ly), $reveal, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Object($LZ, $reveal, obj#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Object#requires(LayerType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object#requires($ly, obj#0, writer#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Object#requires($ly, obj#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Object (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Object(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#9: DatatypeType where $Is(wr#9, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24179"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#9), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Object (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Object(obj#0: DatatypeType, writer#0: DatatypeType) returns (wr#9: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##obj#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##st#0: DatatypeType;
  var ##writer#0: DatatypeType;
  var st##0: DatatypeType;
  var writer##0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##obj#1: DatatypeType;
  var ##writer#1: DatatypeType;
  var wr#Z#2: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##st#1: DatatypeType;
  var ##writer#2: DatatypeType;
  var a##0: Seq;
  var b##0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var c##0: Seq;
  var ##ts#0: Seq;
  var ##fT#1: HandleType;
  var d##0: Seq;
  var ##self#1: DatatypeType;
  var ##fT#2: HandleType;
  var ##self#2: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##self#3: DatatypeType;
  var ##fDatum#1: HandleType;
  var ##obj#2: DatatypeType;
  var obj##0_0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Object", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(141,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Object($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#9), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#9);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#9), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0)));
    assume false;
    return;

  anon6_Else:
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    ##st#0 := JSON_mGrammar.Bracketed.l(obj#0);
    assume $IsAlloc(##st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(obj#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0));
    assume let#0#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(obj#0), writer#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#0#0#0;
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    st##0 := JSON_mGrammar.Bracketed.l(obj#0);
    assume true;
    writer##0 := writer#0;
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st##0, writer##0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st##0, writer##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(146,35)"} true;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##obj#1 := obj#0;
    assume $IsAlloc(##obj#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##writer#1 := wr#Z#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(3) || DtRank(##obj#1) < DtRank(obj#0) || LitInt(2) == LitInt(3);
    assume DtRank(##obj#1) < DtRank(obj#0) || (DtRank(##obj#1) == DtRank(obj#0) && LitInt(2) < LitInt(3));
    assume JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#Z#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#Z#0);
    assume JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, wr#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#1 == let#1#0#0;
    havoc wr#Z#2;
    assume $Is(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    ##st#1 := JSON_mGrammar.Bracketed.r(obj#0);
    assume $IsAlloc(##st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#2 := wr#Z#1;
    assume $IsAlloc(##writer#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(obj#0), wr#Z#1);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(obj#0), wr#Z#1));
    assume let#2#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(obj#0), wr#Z#1);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(obj#0), wr#Z#1);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#2 == let#2#0#0;
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    assume true;
    ##self#0 := JSON_mGrammar.Bracketed.l(obj#0);
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.l(obj#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.l(obj#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    b##0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.l(obj#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    assume true;
    ##ts#0 := JSON_mGrammar.Bracketed.data(obj#0);
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    c##0 := JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    assume true;
    ##self#1 := JSON_mGrammar.Bracketed.r(obj#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#2 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.r(obj#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.r(obj#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    d##0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.r(obj#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0, b##0, c##0, d##0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0, b##0, c##0, d##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(149,152)"} true;
    assume $IsAllocBox($Box(wr#Z#2), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##self#2 := obj#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1) < DtRank(##self#2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(150,74)"} true;
    assume true;
    ##self#3 := obj#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#2) < DtRank(##self#3) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    ##obj#2 := obj#0;
    assume $IsAlloc(##obj#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    obj##0_0 := obj#0;
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj##0_0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(151,91)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
    assume false;
    goto anon5;

  anon7_Else:
    goto anon5;

  anon5:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(151,93)"} true;
    assume JSON_mZeroCopy_mSerializer.__default.Object($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#0, writer#0) == wr#Z#2;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Object($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Object($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#0, writer#0) == wr#9;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom (forall $ly: LayerType :: { JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($ly)) } JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($ly)) == JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly));

function JSON_mConcreteSyntax_mSpec.__default.Item#Handle($fuel: LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Item($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Item#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$0x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($ly, $fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Item($ly, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $Box($fh$0x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##arr#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.BracketedToArray", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(155,8): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(156,43): post-state"} true;
    assume true;
    ##self#0 := arr#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
  free ensures {:id "id24211"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0)) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
  free ensures {:id "id24212"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var rItem#0: HandleType where $Is(rItem#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(rItem#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#0: Heap;
  var d#1: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;
  var ##fDatum#1: HandleType;
  var ##self#3: DatatypeType;
  var ##fDatum#2: HandleType;
  var ##bracketed#0_0: DatatypeType;
  var ##pd0#0_0: HandleType;
  var ##pd1#0_0: HandleType;
  var bracketed##0_0: DatatypeType;
  var pd0##0_0: HandleType;
  var pd1##0_0: HandleType;
  var ##self#1_0_0: DatatypeType;
  var ##fDatum#1_0_0: HandleType;
  var ##arr#1_0_0: DatatypeType;
  var ##self#1_1_0: DatatypeType;
  var ##fDatum#1_1_0: HandleType;
  var ##self#1_1_1: DatatypeType;
  var ##fDatum#1_1_1: HandleType;
  var ##self#1_0: DatatypeType;
  var ##fDatum#1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.BracketedToArray", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(157,2): initial state"} true;
    assume $IsA#JSON_mGrammar.Bracketed(arr#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#arr0#0: DatatypeType :: $Is($ih#arr0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && Lit(true) && DtRank($ih#arr0#0) < DtRank(arr#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $ih#arr0#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), $ih#arr0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#1;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} DtRank(d#1) < DtRank(arr#0);
    ##self#1 := d#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(d#1);
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), d#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(d#1);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon14_Else:
    assume {:partition} DtRank(arr#0) <= DtRank(d#1);
    goto anon4;

  anon13_Else:
    assume {:partition} !($Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    assume (forall $l#0#d#0: DatatypeType :: $Is($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#0#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#0#d#0));
    rItem#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#1#ly#0, $Unbox($l#1#d#0): DatatypeType))), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $IsBox($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#1#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(158,60)"} true;
    assume true;
    ##self#2 := arr#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#2) < DtRank(##self#2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    ##self#3 := arr#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#2 := rItem#0;
    assume $IsAlloc(##fDatum#2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#3) < DtRank(##self#3) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    push;
    assume true;
    ##bracketed#0_0 := arr#0;
    assume $IsAlloc(##bracketed#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##pd0#0_0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##pd0#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##pd1#0_0 := rItem#0;
    assume $IsAlloc(##pd1#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0);
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0) || (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ))), $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0) < DtRank(arr#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ))), $Box(d#0_0)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0) || (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_1) < DtRank(arr#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_1)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0) || (forall d#0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_2))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ))), $Box(d#0_2))): Seq } $Is(d#0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_2) < DtRank(arr#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ))), $Box(d#0_2))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_2))): Seq));
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)), rItem#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(160,78)"} true;
    assume true;
    bracketed##0_0 := arr#0;
    assume true;
    assume true;
    pd0##0_0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume true;
    pd1##0_0 := rItem#0;
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0, pd0##0_0, pd1##0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0, pd0##0_0, pd1##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(161,62)"} true;
    pop;
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0));
    assume false;
    goto anon7;

  anon15_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(162,4)"} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume true;
    ##self#1_0 := arr#0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)) } $Is(d#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0) < DtRank(##self#1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume false;
    goto anon11;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume true;
    ##self#1_1_0 := arr#0;
    assume $IsAlloc(##self#1_1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1_1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)) } $Is(d#1_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_0) < DtRank(##self#1_1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    ##self#1_1_1 := arr#0;
    assume $IsAlloc(##self#1_1_1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_1 := rItem#0;
    assume $IsAlloc(##fDatum#1_1_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)) } $Is(d#1_1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_1) < DtRank(##self#1_1_1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0));
    assume false;
    goto anon11;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    ##self#1_0_0 := arr#0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0_0 := rItem#0;
    assume $IsAlloc(##fDatum#1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)) } $Is(d#1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0_0) < DtRank(##self#1_0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    ##arr#1_0_0 := arr#0;
    assume $IsAlloc(##arr#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
    assume false;
    goto anon11;

  anon18_Else:
    goto anon11;

  anon11:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0));
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Array($ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(arr#0), writer#0) && (var wr#0 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0); JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, wr#0) && (var wr#1 := JSON_mZeroCopy_mSerializer.__default.Items($ly, reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#0); JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(arr#0), wr#1))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, arr#0, writer#0) == (var wr#0 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0); (var wr#1 := JSON_mZeroCopy_mSerializer.__default.Items($ly, reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#0); (var wr#2 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(arr#0), wr#1); wr#2))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(Lit(arr#0), writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0) && (var wr#3 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0); JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), wr#3) && (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#3); JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#4))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), writer#0) == (var wr#3 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0); (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#3); (var wr#5 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#4); wr#5))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(Lit(arr#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0)) && (var wr#6 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0))); JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), wr#6) && (var wr#7 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#6); JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#7))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), Lit(writer#0)) == (var wr#6 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0))); (var wr#7 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#6); (var wr#8 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#7); wr#8))));
}

function JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), $reveal, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), $reveal, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array(AsFuelBottom($ly), $reveal, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Array($LZ, $reveal, arr#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Array#requires(LayerType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array#requires($ly, arr#0, writer#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Array#requires($ly, arr#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Array (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Array(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#9: DatatypeType where $Is(wr#9, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24237"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#9), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Array (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Array(arr#0: DatatypeType, writer#0: DatatypeType) returns (wr#9: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##arr#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##st#0: DatatypeType;
  var ##writer#0: DatatypeType;
  var st##0: DatatypeType;
  var writer##0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##arr#1: DatatypeType;
  var ##writer#1: DatatypeType;
  var wr#Z#2: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##st#1: DatatypeType;
  var ##writer#2: DatatypeType;
  var a##0: Seq;
  var b##0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var c##0: Seq;
  var ##ts#0: Seq;
  var ##fT#1: HandleType;
  var d##0: Seq;
  var ##self#1: DatatypeType;
  var ##fT#2: HandleType;
  var ##self#2: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##self#3: DatatypeType;
  var ##fDatum#1: HandleType;
  var ##arr#2: DatatypeType;
  var arr##0_0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Array", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(170,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon6_Then, anon6_Else;

  anon6_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Array($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#9), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#9);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#9), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0)));
    assume false;
    return;

  anon6_Else:
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    ##st#0 := JSON_mGrammar.Bracketed.l(arr#0);
    assume $IsAlloc(##st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(arr#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0));
    assume let#0#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(arr#0), writer#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#0#0#0;
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    st##0 := JSON_mGrammar.Bracketed.l(arr#0);
    assume true;
    writer##0 := writer#0;
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st##0, writer##0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st##0, writer##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(175,35)"} true;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##arr#1 := arr#0;
    assume $IsAlloc(##arr#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##writer#1 := wr#Z#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(3) || DtRank(##arr#1) < DtRank(arr#0) || LitInt(2) == LitInt(3);
    assume DtRank(##arr#1) < DtRank(arr#0) || (DtRank(##arr#1) == DtRank(arr#0) && LitInt(2) < LitInt(3));
    assume JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#Z#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#Z#0);
    assume JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, wr#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#1 == let#1#0#0;
    havoc wr#Z#2;
    assume $Is(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    ##st#1 := JSON_mGrammar.Bracketed.r(arr#0);
    assume $IsAlloc(##st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#2 := wr#Z#1;
    assume $IsAlloc(##writer#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(arr#0), wr#Z#1);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(arr#0), wr#Z#1));
    assume let#2#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(arr#0), wr#Z#1);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(arr#0), wr#Z#1);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#2 == let#2#0#0;
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    assume true;
    ##self#0 := JSON_mGrammar.Bracketed.l(arr#0);
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.l(arr#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.l(arr#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    b##0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.l(arr#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    assume true;
    ##ts#0 := JSON_mGrammar.Bracketed.data(arr#0);
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    c##0 := JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    assume true;
    ##self#1 := JSON_mGrammar.Bracketed.r(arr#0);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#2 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.r(arr#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.r(arr#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    d##0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.Bracketed.r(arr#0), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0, b##0, c##0, d##0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0, b##0, c##0, d##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(178,150)"} true;
    assume $IsAllocBox($Box(wr#Z#2), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##self#2 := arr#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1) < DtRank(##self#2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(179,72)"} true;
    assume true;
    ##self#3 := arr#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#2) < DtRank(##self#3) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    ##arr#2 := arr#0;
    assume $IsAlloc(##arr#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume true;
    arr##0_0 := arr#0;
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr##0_0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(180,87)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
    assume false;
    goto anon5;

  anon7_Else:
    goto anon5;

  anon5:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(180,89)"} true;
    assume JSON_mZeroCopy_mSerializer.__default.Array($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#0, writer#0) == wr#Z#2;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Array($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Array($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#0, writer#0) == wr#9;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Members($ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0) && JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), writer#0) && JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), writer#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), Lit(writer#0)) && JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), Lit(writer#0)) == Lit(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), Lit(writer#0))));
}

function JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), $reveal, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), $reveal, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members(AsFuelBottom($ly), $reveal, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Members($LZ, $reveal, obj#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Members#requires(LayerType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members#requires($ly, obj#0, writer#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Members#requires($ly, obj#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Members (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24266"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ))))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Members (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var ##obj#0: DatatypeType;
  var ##members#0: Seq;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Members", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(184,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#0);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    assume true;
    ##ts#0 := JSON_mGrammar.Bracketed.data(obj#0);
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)))));
    assume false;
    return;

  anon4_Else:
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##members#0 := JSON_mGrammar.Bracketed.data(obj#0);
    assume $IsAlloc(##members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#0: int :: { $Unbox(Seq#Index(##members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##members#0) ==> DtRank($Unbox(Seq#Index(##members#0, j#0)): DatatypeType) < DtRank(##obj#0));
    assume (forall j#0: int :: { $Unbox(Seq#Index(##members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##members#0) ==> DtRank($Unbox(Seq#Index(##members#0, j#0)): DatatypeType) < DtRank(##obj#0));
    assume 0 <= LitInt(2) || DtRank(##obj#0) <= DtRank(obj#0) || LitInt(1) == LitInt(2);
    assume DtRank(##obj#0) <= DtRank(obj#0) && (DtRank(##obj#0) == DtRank(obj#0) ==> LitInt(1) <= LitInt(2));
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));
    assume JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0);
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0) == wr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.Members (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (defass#wr#0: bool, wr#0: DatatypeType where defass#wr#0 ==> $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0);
  free ensures {:id "id24275"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.Members($LS($LS($LZ)), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Members (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType, writer#0: DatatypeType) returns (defass#wr#0: bool, wr#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var obj##0: DatatypeType;
  var writer##0: DatatypeType;
  var b##0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Members", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(189,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    obj##0 := obj#0;
    assume true;
    writer##0 := writer#0;
    assume 0 <= LitInt(2) || DtRank(obj##0) < DtRank(obj#0) || LitInt(1) == LitInt(2);
    assume DtRank(obj##0) < DtRank(obj#0) || (DtRank(obj##0) == DtRank(obj#0) && LitInt(1) < LitInt(2));
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj##0, writer##0);
    call $rhs##0 := CallPost$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj##0, writer##0);
    wr#0 := $rhs##0;
    defass#wr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(190,34)"} true;
    assume true;
    b##0 := Lit(false);
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.Assume(b##0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.Assume(b##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(191,17)"} true;
    assume defass#wr#0;
    assume JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0);
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Items($ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0) && JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), writer#0) && JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), writer#0));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), Lit(writer#0)) && JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), Lit(writer#0)) == Lit(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), Lit(writer#0))));
}

function JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), $reveal, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), $reveal, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items(AsFuelBottom($ly), $reveal, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Items($LZ, $reveal, arr#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Items#requires(LayerType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items#requires($ly, arr#0, writer#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Items#requires($ly, arr#0, writer#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Items (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24284"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ))))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Items (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var ##arr#0: DatatypeType;
  var ##items#0: Seq;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Items", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(194,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#0);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    assume true;
    ##ts#0 := JSON_mGrammar.Bracketed.data(arr#0);
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#0), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)))));
    assume false;
    return;

  anon4_Else:
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##items#0 := JSON_mGrammar.Bracketed.data(arr#0);
    assume $IsAlloc(##items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#0: int :: { $Unbox(Seq#Index(##items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##items#0) ==> DtRank($Unbox(Seq#Index(##items#0, j#0)): DatatypeType) < DtRank(##arr#0));
    assume (forall j#0: int :: { $Unbox(Seq#Index(##items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##items#0) ==> DtRank($Unbox(Seq#Index(##items#0, j#0)): DatatypeType) < DtRank(##arr#0));
    assume 0 <= LitInt(2) || DtRank(##arr#0) <= DtRank(arr#0) || LitInt(1) == LitInt(2);
    assume DtRank(##arr#0) <= DtRank(arr#0) && (DtRank(##arr#0) == DtRank(arr#0) ==> LitInt(1) <= LitInt(2));
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));
    assume JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0);
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0) == wr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.Items (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (defass#wr#0: bool, wr#0: DatatypeType where defass#wr#0 ==> $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0);
  free ensures {:id "id24293"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.Items($LS($LS($LZ)), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Items (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType, writer#0: DatatypeType) returns (defass#wr#0: bool, wr#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var arr##0: DatatypeType;
  var writer##0: DatatypeType;
  var b##0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Items", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(199,14): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    arr##0 := arr#0;
    assume true;
    writer##0 := writer#0;
    assume 0 <= LitInt(2) || DtRank(arr##0) < DtRank(arr#0) || LitInt(1) == LitInt(2);
    assume DtRank(arr##0) < DtRank(arr#0) || (DtRank(arr##0) == DtRank(arr#0) && LitInt(1) < LitInt(2));
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr##0, writer##0);
    call $rhs##0 := CallPost$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr##0, writer##0);
    wr#0 := $rhs##0;
    defass#wr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(200,32)"} true;
    assume true;
    b##0 := Lit(false);
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.Assume(b##0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.Assume(b##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(201,17)"} true;
    assume defass#wr#0;
    assume JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0);
    return;
}



function JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && (forall j#0: int :: { $Unbox(Seq#Index(members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#0)): DatatypeType) < DtRank(obj#0))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), members#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#1: int :: { $Unbox(Seq#Index(members#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#1)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#0, last#0 := Seq#Take(members#0, Seq#Length(members#0) - 1), $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, butLast#0, writer#0) && (var wr#0 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, butLast#0, writer#0); JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, last#0, wr#0)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#0, last#0 := Seq#Take(members#0, Seq#Length(members#0) - 1), $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType; (var wr#0 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, butLast#0, writer#0); (var wr#1 := JSON_mZeroCopy_mSerializer.__default.Member($ly, reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, last#0, wr#0); wr#1)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(members#0), writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#2: int :: { $Unbox(Seq#Index(members#0, j#2)): DatatypeType } LitInt(0) <= j#2 && j#2 < Seq#Length(Lit(members#0)) ==> DtRank($Unbox(Seq#Index(Lit(members#0), j#2)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#1, last#1 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), butLast#1, writer#0) && (var wr#2 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#1, writer#0); JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), last#1, wr#2)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), writer#0) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#1, last#1 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; (var wr#2 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#1, writer#0); (var wr#3 := JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Member, Lit(obj#0), last#1, wr#2); wr#3)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(members#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#3: int :: { $Unbox(Seq#Index(members#0, j#3)): DatatypeType } LitInt(0) <= j#3 && j#3 < Seq#Length(Lit(members#0)) ==> DtRank($Unbox(Seq#Index(Lit(members#0), j#3)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#2, last#2 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), butLast#2, Lit(writer#0)) && (var wr#4 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#2, Lit(writer#0)); JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), last#2, wr#4)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), Lit(writer#0)) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#2, last#2 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; (var wr#4 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#2, Lit(writer#0)); (var wr#5 := JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Member, Lit(obj#0), last#2, wr#4); wr#5)))));
}

function JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec(AsFuelBottom($ly), obj#0, members#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($LZ, obj#0, members#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires(LayerType, DatatypeType, Seq, DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires($ly, obj#0, members#0, writer#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires($ly, obj#0, members#0, writer#0) <==> (forall j#1: int :: { $Unbox(Seq#Index(members#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#1)): DatatypeType) < DtRank(obj#0))));

procedure {:verboseName "JSON.ZeroCopy.Serializer.MembersSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.MembersSpec(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), members#0: Seq where $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#6: DatatypeType where $Is(wr#6, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24302"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#6), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), members#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ))))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.MembersSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.MembersSpec(obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType) returns (wr#6: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#4: int;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var butLast#Z#0: Seq;
  var last#Z#0: DatatypeType;
  var let#0#0#0: Seq;
  var let#0#1#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##obj#0: DatatypeType;
  var ##members#0: Seq;
  var ##writer#0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##obj#1: DatatypeType;
  var ##m#0: DatatypeType;
  var ##writer#1: DatatypeType;
  var ##ts#1: Seq;
  var ##fT#1: HandleType;
  var ##ts#2: Seq;
  var ##fT#2: HandleType;
  var a##0_0: Seq;
  var b##0_0: Seq;
  var ##ts#0_0: Seq;
  var ##fT#0_0: HandleType;
  var c##0_0: Seq;
  var ##ts#0_1: Seq;
  var ##fT#0_1: HandleType;
  var ts0##0: Seq;
  var ts1##0: Seq;
  var pt##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.MembersSpec", " | ", obj#0, " | ", members#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "Seq", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(204,17): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc j#4;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= j#4;
    goto anon4;

  anon15_Else:
    assume {:partition} j#4 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= j#4 && j#4 < Seq#Length(members#0);
    assume 0 <= j#4 && j#4 < Seq#Length(members#0);
    assume DtRank($Unbox(Seq#Index(members#0, j#4)): DatatypeType) < DtRank(obj#0);
    goto anon6;

  anon14_Else:
    assume LitInt(0) <= j#4 && j#4 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#4)): DatatypeType) < DtRank(obj#0);
    goto anon6;

  anon6:
    assume (forall j#0: int :: { $Unbox(Seq#Index(members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#0)): DatatypeType) < DtRank(obj#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#6), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#6);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##ts#0 := members#0;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), members#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#6), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), members#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)))));
    assume false;
    return;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Equal(members#0, Seq#Empty(): Seq);
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0) == writer#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon13;

  anon17_Else:
    assume {:partition} !Seq#Equal(members#0, Seq#Empty(): Seq);
    havoc butLast#Z#0;
    havoc last#Z#0;
    assume $Is(butLast#Z#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(butLast#Z#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap) && $Is(last#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(last#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume 0 <= Seq#Length(members#0) - 1 && Seq#Length(members#0) - 1 <= Seq#Length(members#0);
    assume let#0#0#0 == Seq#Take(members#0, Seq#Length(members#0) - 1);
    assume true;
    assume $Is(let#0#0#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())));
    assume butLast#Z#0 == let#0#0#0;
    assume 0 <= Seq#Length(members#0) - 1 && Seq#Length(members#0) - 1 < Seq#Length(members#0);
    assume let#0#1#0 == $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType;
    assume true;
    assume $Is(let#0#1#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()));
    assume last#Z#0 == let#0#1#0;
    assume true;
    assume Seq#Equal(members#0, Seq#Append(butLast#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(213,40)"} true;
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##members#0 := butLast#Z#0;
    assume $IsAlloc(##members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#5: int :: { $Unbox(Seq#Index(##members#0, j#5)): DatatypeType } LitInt(0) <= j#5 && j#5 < Seq#Length(##members#0) ==> DtRank($Unbox(Seq#Index(##members#0, j#5)): DatatypeType) < DtRank(##obj#0));
    assume (forall j#5: int :: { $Unbox(Seq#Index(##members#0, j#5)): DatatypeType } LitInt(0) <= j#5 && j#5 < Seq#Length(##members#0) ==> DtRank($Unbox(Seq#Index(##members#0, j#5)): DatatypeType) < DtRank(##obj#0));
    assume 0 <= LitInt(1) || DtRank(##obj#0) < DtRank(obj#0) || LitInt(1) == LitInt(1);
    assume DtRank(##obj#0) < DtRank(obj#0) || (DtRank(##obj#0) == DtRank(obj#0) && (LitInt(1) < LitInt(1) || (LitInt(1) == LitInt(1) && Seq#Rank(##members#0) < Seq#Rank(members#0))));
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, butLast#Z#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, butLast#Z#0, writer#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, butLast#Z#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, butLast#Z#0, writer#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#1#0#0;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##obj#1 := obj#0;
    assume $IsAlloc(##obj#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##m#0 := last#Z#0;
    assume $IsAlloc(##m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    ##writer#1 := wr#Z#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} DtRank(##m#0) < DtRank(##obj#1);
    assume DtRank(##m#0) < DtRank(##obj#1);
    assume 0 <= LitInt(1) || DtRank(##obj#1) < DtRank(obj#0) || LitInt(0) == LitInt(1);
    assume DtRank(##obj#1) < DtRank(obj#0) || (DtRank(##obj#1) == DtRank(obj#0) && LitInt(0) < LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, last#Z#0, wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, last#Z#0, wr#Z#0));
    assume let#2#0#0 == JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, last#Z#0, wr#Z#0);
    assume JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, last#Z#0, wr#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#1 == let#2#0#0;
    assume $IsAllocBox($Box(wr#Z#1), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##ts#1 := butLast#Z#0;
    assume $IsAlloc(##ts#1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#1)) } { Seq#Contains(##ts#1, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#1, $Box(d#1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume true;
    ##ts#2 := Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0));
    assume $IsAlloc(##ts#2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#2 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, $Box(d#2)) } { Seq#Contains(##ts#2, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#2, $Box(d#2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0_0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume true;
    ##ts#0_0 := butLast#Z#0;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)) } { Seq#Contains(##ts#0_0, $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_0, $Box(d#0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)));
    assume (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)) } { Seq#Contains(##ts#0_0, $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_0, $Box(d#0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    b##0_0 := JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume true;
    ##ts#0_1 := Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0));
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    assume $IsAlloc(##fT#0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)) } { Seq#Contains(##ts#0_1, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1, $Box(d#0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)));
    assume (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)) } { Seq#Contains(##ts#0_1, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1, $Box(d#0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    c##0_0 := JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ)));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(217,112)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LS($LZ)))))));
    assume false;
    goto anon12;

  anon18_Else:
    goto anon12;

  anon12:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(218,6)"} true;
    assume true;
    ts0##0 := butLast#Z#0;
    assume true;
    ts1##0 := Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0));
    assume true;
    assume true;
    pt##0 := JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ));
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts0##0, ts1##0, pt##0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts0##0, ts1##0, pt##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(219,68)"} true;
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0) == wr#Z#1;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon13;

  anon13:
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0) == wr#6;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, items#0, spec#0, impl#0, writer#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $IsAlloc(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T), $Heap) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8())), $Heap) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $IsAlloc(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && (forall item#0: Box, wr#0: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#0, $Box(wr#0)) } $IsBox(item#0, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#0) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#0, $Box(wr#0))) && (forall item#1: Box, wr#1: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#1), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#1)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#1, $Box(wr#1))): DatatypeType } $IsBox(item#1, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#1) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#1, $Box(wr#1))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#1), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#1)): Seq)))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), items#0, spec#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, items#0, spec#0, impl#0, writer#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#2: Box, wr#2: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#2, $Box(wr#2)) } $IsBox(item#2, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#2, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#2) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#2, $Box(wr#2))) && (forall item#3: Box, wr#3: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#3), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#3)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#3, $Box(wr#3))): DatatypeType } $IsBox(item#3, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#3, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#3) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#3, $Box(wr#3))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#3), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#3)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#1 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), Seq#Index(items#0, Seq#Length(items#0) - 1), $Box(writer#1))): DatatypeType)));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#4: Box, wr#4: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#4, $Box(wr#4)) } $IsBox(item#4, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#4, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#4) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), item#4, $Box(wr#4))) && (forall item#5: Box, wr#5: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#5), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#5)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#5, $Box(wr#5))): DatatypeType } $IsBox(item#5, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#5, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#5) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), item#5, $Box(wr#5))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#5), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#5)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), spec#0, impl#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#2 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), spec#0, impl#0, writer#0); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Box(writer#2))): DatatypeType)));
axiom 0 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#6: Box, wr#6: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#6, $Box(wr#6)) } $IsBox(item#6, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#6, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#6) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), item#6, $Box(wr#6))) && (forall item#7: Box, wr#7: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#7), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#7)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#7, $Box(wr#7))): DatatypeType } $IsBox(item#7, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#7, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#7) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), item#7, $Box(wr#7))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#7), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(spec#0), item#7)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), Lit(spec#0), Lit(impl#0), Lit(writer#0))) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#3 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), Lit(spec#0), Lit(impl#0), Lit(writer#0)); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Box(writer#3))): DatatypeType)));
}

function JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType) : bool;

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, AsFuelBottom($ly), v#0, items#0, spec#0, impl#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LZ, v#0, items#0, spec#0, impl#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(Ty, LayerType, DatatypeType, Seq, HandleType, HandleType, DatatypeType) : bool;

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0) <==> (forall item#2: Box, wr#2: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#2, $Box(wr#2)) } $IsBox(item#2, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#2, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#2) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#2, $Box(wr#2))) && (forall item#3: Box, wr#3: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#3), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#3)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#3, $Box(wr#3))): DatatypeType } $IsBox(item#3, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#3, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#3) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#3, $Box(wr#3))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#3), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#3)): Seq)))));

procedure {:verboseName "JSON.ZeroCopy.Serializer.SequenceSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, v#0: DatatypeType where $Is(v#0, Tclass.JSON_mGrammar.Value()), items#0: Seq where $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)), spec#0: HandleType where $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))), impl#0: HandleType where $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#8: DatatypeType where $Is(wr#8, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24346"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#8), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LS($LZ)), items#0, spec#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.SequenceSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType) returns (wr#8: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var item#8: Box;
  var wr#9: DatatypeType;
  var ##x0#0: DatatypeType;
  var ##x1#0: Box;
  var ##x2#0: DatatypeType;
  var item#9: Box;
  var wr#10: DatatypeType;
  var b$reqreads#0: bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var writer#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##v#0: DatatypeType;
  var ##items#0: Seq;
  var ##spec#0: HandleType;
  var ##impl#0: HandleType;
  var ##writer#0: DatatypeType;
  var ts0##0: Seq;
  var ts1##0: Seq;
  var pt##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.SequenceSpec", " | ", JSON.ZeroCopy.Serializer._default.SequenceSpec$T, " | ", v#0, " | ", items#0, " | ", spec#0, " | ", impl#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "Seq", " | ", "HandleType", " | ", "HandleType", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(228,17): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc item#8;
    havoc wr#9;
    assume $IsBox(item#8, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $IsAllocBox(item#8, JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $Heap) && $Is(wr#9, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#9, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Seq#Contains(items#0, item#8);
    assume $IsAllocBox($Box(impl#0), Tclass._System.___hFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap);
    ##x0#0 := v#0;
    assume $IsAlloc(##x0#0, Tclass.JSON_mGrammar.Value(), $Heap);
    ##x1#0 := item#8;
    assume $IsAllocBox(##x1#0, JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $Heap);
    ##x2#0 := wr#9;
    assume $IsAlloc(##x2#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(##x0#0), ##x1#0, $Box(##x2#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires3#canCall(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#8, $Box(wr#9));
    assume Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#8, $Box(wr#9));
    goto anon4;

  anon13_Else:
    assume Seq#Contains(items#0, item#8) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#8, $Box(wr#9));
    goto anon4;

  anon4:
    assume (forall item#0: Box, wr#0: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#0, $Box(wr#0)) } $IsBox(item#0, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#0) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#0, $Box(wr#0)));
    havoc item#9;
    havoc wr#10;
    assume $IsBox(item#9, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $IsAllocBox(item#9, JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $Heap) && $Is(wr#10, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#10, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Seq#Contains(items#0, item#9);
    assume Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#9, $Box(wr#10));
    assume $IsAllocBox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#9, $Box(wr#10)), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#9, $Box(wr#10))): DatatypeType);
    assume $IsAllocBox($Box(wr#10), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#10);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#9, $Box(wr#10))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#10), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#9)): Seq));
    goto anon7;

  anon14_Else:
    assume Seq#Contains(items#0, item#9) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#9, $Box(wr#10))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#10), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#9)): Seq));
    goto anon7;

  anon7:
    assume (forall item#1: Box, wr#1: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#1), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#1)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#1, $Box(wr#1))): DatatypeType } $IsBox(item#1, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#1) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#1, $Box(wr#1))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#1), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#1)): Seq)));
    assume b$reqreads#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, items#0, spec#0, impl#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#8), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#8);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##ts#0 := items#0;
    assume $IsAlloc(##ts#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T), $Heap);
    ##fT#0 := spec#0;
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: Box :: { Requires1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#0) } { Seq#Contains(##ts#0, d#0) } $IsBox(d#0, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && Seq#Contains(##ts#0, d#0) ==> Requires1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#0));
    assume (forall d#0: Box :: { Requires1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#0) } { Seq#Contains(##ts#0, d#0) } $IsBox(d#0, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && Seq#Contains(##ts#0, d#0) ==> Requires1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, d#0));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, items#0, spec#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#8), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), items#0, spec#0)));
    assume false;
    return;

  anon15_Else:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Seq#Equal(items#0, Seq#Empty(): Seq);
    assume JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, items#0, spec#0, impl#0, writer#0) == writer#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, items#0, spec#0, impl#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon12;

  anon16_Else:
    assume {:partition} !Seq#Equal(items#0, Seq#Empty(): Seq);
    havoc writer#Z#0;
    assume $Is(writer#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 <= Seq#Length(items#0);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mGrammar.Value(), $Heap);
    ##items#0 := Seq#Take(items#0, Seq#Length(items#0) - 1);
    assume $IsAlloc(##items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T), $Heap);
    ##spec#0 := spec#0;
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##impl#0 := impl#0;
    assume $IsAlloc(##impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall item#10: Box, wr#11: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#10, $Box(wr#11)) } $IsBox(item#10, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#11, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(##items#0, item#10) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#10, $Box(wr#11)));
    assume (forall item#10: Box, wr#11: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#10, $Box(wr#11)) } $IsBox(item#10, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#11, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(##items#0, item#10) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#10, $Box(wr#11)));
    assume {:subsumption 0} (forall item#11: Box, wr#12: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#12), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##spec#0, item#11)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#11, $Box(wr#12))): DatatypeType } $IsBox(item#11, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#12, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(##items#0, item#11) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#11, $Box(wr#12))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#12), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##spec#0, item#11)): Seq)));
    assume (forall item#11: Box, wr#12: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#12), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##spec#0, item#11)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#11, $Box(wr#12))): DatatypeType } $IsBox(item#11, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#12, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(##items#0, item#11) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, ##impl#0, $Box(##v#0), item#11, $Box(wr#12))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#12), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, ##spec#0, item#11)): Seq)));
    assume 0 <= LitInt(1) || DtRank(##v#0) < DtRank(v#0) || LitInt(1) == LitInt(1);
    assume DtRank(##v#0) < DtRank(v#0) || (DtRank(##v#0) == DtRank(v#0) && (LitInt(1) < LitInt(1) || (LitInt(1) == LitInt(1) && Seq#Rank(##items#0) < Seq#Rank(items#0))));
    assume JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0));
    assume let#0#0#0 == JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume writer#Z#0 == let#0#0#0;
    assume {:subsumption 0} 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 <= Seq#Length(items#0);
    assume {:subsumption 0} 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 < Seq#Length(items#0);
    assume true;
    assume Seq#Equal(items#0, Seq#Append(Seq#Take(items#0, Seq#Length(items#0) - 1), Seq#Build(Seq#Empty(): Seq, Seq#Index(items#0, Seq#Length(items#0) - 1))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(241,61)"} true;
    assume 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 <= Seq#Length(items#0);
    assume true;
    ts0##0 := Seq#Take(items#0, Seq#Length(items#0) - 1);
    assume 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 < Seq#Length(items#0);
    assume true;
    ts1##0 := Seq#Build(Seq#Empty(): Seq, Seq#Index(items#0, Seq#Length(items#0) - 1));
    assume true;
    pt##0 := spec#0;
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, ts0##0, ts1##0, pt##0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, ts0##0, ts1##0, pt##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(242,84)"} true;
    assume 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 < Seq#Length(items#0);
    assume Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), Seq#Index(items#0, Seq#Length(items#0) - 1), $Box(writer#Z#0));
    assume JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, items#0, spec#0, impl#0, writer#0) == $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), Seq#Index(items#0, Seq#Length(items#0) - 1), $Box(writer#Z#0))): DatatypeType;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, items#0, spec#0, impl#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon12;

  anon12:
    assume JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), v#0, items#0, spec#0, impl#0, writer#0) == wr#8;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, items#0, writer#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && (forall j#0: int :: { $Unbox(Seq#Index(items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#0)): DatatypeType) < DtRank(arr#0))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), items#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, items#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#1: int :: { $Unbox(Seq#Index(items#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#1)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#0, last#0 := Seq#Take(items#0, Seq#Length(items#0) - 1), $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, butLast#0, writer#0) && (var wr#0 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, butLast#0, writer#0); JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, last#0, wr#0)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#0, last#0 := Seq#Take(items#0, Seq#Length(items#0) - 1), $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType; (var wr#0 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, butLast#0, writer#0); (var wr#1 := JSON_mZeroCopy_mSerializer.__default.Item($ly, reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, last#0, wr#0); wr#1)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(items#0), writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#2: int :: { $Unbox(Seq#Index(items#0, j#2)): DatatypeType } LitInt(0) <= j#2 && j#2 < Seq#Length(Lit(items#0)) ==> DtRank($Unbox(Seq#Index(Lit(items#0), j#2)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#1, last#1 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), butLast#1, writer#0) && (var wr#2 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#1, writer#0); JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), last#1, wr#2)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#1, last#1 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; (var wr#2 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#1, writer#0); (var wr#3 := JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Item, Lit(arr#0), last#1, wr#2); wr#3)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(items#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#3: int :: { $Unbox(Seq#Index(items#0, j#3)): DatatypeType } LitInt(0) <= j#3 && j#3 < Seq#Length(Lit(items#0)) ==> DtRank($Unbox(Seq#Index(Lit(items#0), j#3)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#2, last#2 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), butLast#2, Lit(writer#0)) && (var wr#4 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#2, Lit(writer#0)); JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), last#2, wr#4)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), Lit(writer#0)) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#2, last#2 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; (var wr#4 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#2, Lit(writer#0)); (var wr#5 := JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Item, Lit(arr#0), last#2, wr#4); wr#5)))));
}

function JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec(AsFuelBottom($ly), arr#0, items#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LZ, arr#0, items#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires(LayerType, DatatypeType, Seq, DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires($ly, arr#0, items#0, writer#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires($ly, arr#0, items#0, writer#0) <==> (forall j#1: int :: { $Unbox(Seq#Index(items#0, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#1)): DatatypeType) < DtRank(arr#0))));

procedure {:verboseName "JSON.ZeroCopy.Serializer.ItemsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.ItemsSpec(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), items#0: Seq where $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#6: DatatypeType where $Is(wr#6, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24378"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#6), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), items#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ))))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.ItemsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.ItemsSpec(arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType) returns (wr#6: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var j#4: int;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;
  var butLast#Z#0: Seq;
  var last#Z#0: DatatypeType;
  var let#0#0#0: Seq;
  var let#0#1#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##arr#0: DatatypeType;
  var ##items#0: Seq;
  var ##writer#0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##arr#1: DatatypeType;
  var ##m#0: DatatypeType;
  var ##writer#1: DatatypeType;
  var ##ts#1: Seq;
  var ##fT#1: HandleType;
  var ##ts#2: Seq;
  var ##fT#2: HandleType;
  var a##0_0: Seq;
  var b##0_0: Seq;
  var ##ts#0_0: Seq;
  var ##fT#0_0: HandleType;
  var c##0_0: Seq;
  var ##ts#0_1: Seq;
  var ##fT#0_1: HandleType;
  var ts0##0: Seq;
  var ts1##0: Seq;
  var pt##0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.ItemsSpec", " | ", arr#0, " | ", items#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "Seq", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(249,17): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc j#4;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} LitInt(0) <= j#4;
    goto anon4;

  anon15_Else:
    assume {:partition} j#4 < LitInt(0);
    goto anon4;

  anon4:
    assume LitInt(0) <= j#4 && j#4 < Seq#Length(items#0);
    assume 0 <= j#4 && j#4 < Seq#Length(items#0);
    assume DtRank($Unbox(Seq#Index(items#0, j#4)): DatatypeType) < DtRank(arr#0);
    goto anon6;

  anon14_Else:
    assume LitInt(0) <= j#4 && j#4 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#4)): DatatypeType) < DtRank(arr#0);
    goto anon6;

  anon6:
    assume (forall j#0: int :: { $Unbox(Seq#Index(items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#0)): DatatypeType) < DtRank(arr#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, items#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#6), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#6);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##ts#0 := items#0;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), items#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#6), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), items#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)))));
    assume false;
    return;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Seq#Equal(items#0, Seq#Empty(): Seq);
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, items#0, writer#0) == writer#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, items#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon13;

  anon17_Else:
    assume {:partition} !Seq#Equal(items#0, Seq#Empty(): Seq);
    havoc butLast#Z#0;
    havoc last#Z#0;
    assume $Is(butLast#Z#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(butLast#Z#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap) && $Is(last#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(last#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 <= Seq#Length(items#0);
    assume let#0#0#0 == Seq#Take(items#0, Seq#Length(items#0) - 1);
    assume true;
    assume $Is(let#0#0#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())));
    assume butLast#Z#0 == let#0#0#0;
    assume 0 <= Seq#Length(items#0) - 1 && Seq#Length(items#0) - 1 < Seq#Length(items#0);
    assume let#0#1#0 == $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType;
    assume true;
    assume $Is(let#0#1#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()));
    assume last#Z#0 == let#0#1#0;
    assume true;
    assume Seq#Equal(items#0, Seq#Append(butLast#Z#0, Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(258,38)"} true;
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##items#0 := butLast#Z#0;
    assume $IsAlloc(##items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#5: int :: { $Unbox(Seq#Index(##items#0, j#5)): DatatypeType } LitInt(0) <= j#5 && j#5 < Seq#Length(##items#0) ==> DtRank($Unbox(Seq#Index(##items#0, j#5)): DatatypeType) < DtRank(##arr#0));
    assume (forall j#5: int :: { $Unbox(Seq#Index(##items#0, j#5)): DatatypeType } LitInt(0) <= j#5 && j#5 < Seq#Length(##items#0) ==> DtRank($Unbox(Seq#Index(##items#0, j#5)): DatatypeType) < DtRank(##arr#0));
    assume 0 <= LitInt(1) || DtRank(##arr#0) < DtRank(arr#0) || LitInt(1) == LitInt(1);
    assume DtRank(##arr#0) < DtRank(arr#0) || (DtRank(##arr#0) == DtRank(arr#0) && (LitInt(1) < LitInt(1) || (LitInt(1) == LitInt(1) && Seq#Rank(##items#0) < Seq#Rank(items#0))));
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, butLast#Z#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, butLast#Z#0, writer#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, butLast#Z#0, writer#0);
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, butLast#Z#0, writer#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#1#0#0;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    ##arr#1 := arr#0;
    assume $IsAlloc(##arr#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##m#0 := last#Z#0;
    assume $IsAlloc(##m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    ##writer#1 := wr#Z#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} DtRank(##m#0) < DtRank(##arr#1);
    assume DtRank(##m#0) < DtRank(##arr#1);
    assume 0 <= LitInt(1) || DtRank(##arr#1) < DtRank(arr#0) || LitInt(0) == LitInt(1);
    assume DtRank(##arr#1) < DtRank(arr#0) || (DtRank(##arr#1) == DtRank(arr#0) && LitInt(0) < LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, last#Z#0, wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, last#Z#0, wr#Z#0));
    assume let#2#0#0 == JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, last#Z#0, wr#Z#0);
    assume JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, last#Z#0, wr#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#1 == let#2#0#0;
    assume $IsAllocBox($Box(wr#Z#1), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume true;
    ##ts#1 := butLast#Z#0;
    assume $IsAlloc(##ts#1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#1)) } { Seq#Contains(##ts#1, $Box(d#1)) } $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#1, $Box(d#1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#1, $Box(d#1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume true;
    ##ts#2 := Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0));
    assume $IsAlloc(##ts#2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#2 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, $Box(d#2)) } { Seq#Contains(##ts#2, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#2, $Box(d#2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#2, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0_0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume true;
    ##ts#0_0 := butLast#Z#0;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)) } { Seq#Contains(##ts#0_0, $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_0, $Box(d#0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)));
    assume (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)) } { Seq#Contains(##ts#0_0, $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_0, $Box(d#0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_0, $Box(d#0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    b##0_0 := JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume true;
    ##ts#0_1 := Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0));
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    assume $IsAlloc(##fT#0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)) } { Seq#Contains(##ts#0_1, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1, $Box(d#0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)));
    assume (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)) } { Seq#Contains(##ts#0_1, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1, $Box(d#0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1, $Box(d#0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    c##0_0 := JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ)));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(262,108)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LS($LZ)))))));
    assume false;
    goto anon12;

  anon18_Else:
    goto anon12;

  anon12:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), butLast#Z#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0)), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(263,6)"} true;
    assume true;
    ts0##0 := butLast#Z#0;
    assume true;
    ts1##0 := Seq#Build(Seq#Empty(): Seq, $Box(last#Z#0));
    assume true;
    assume true;
    pt##0 := JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ));
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts0##0, ts1##0, pt##0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts0##0, ts1##0, pt##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(264,66)"} true;
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, items#0, writer#0) == wr#Z#1;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, items#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    goto anon13;

  anon13:
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, items#0, writer#0) == wr#6;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##obj#0: DatatypeType;
  var ##members#0: Seq;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.MembersImpl", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(270,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc wr#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(272,15): post-state"} true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##members#0 := JSON_mGrammar.Bracketed.data(obj#0);
    assume $IsAlloc(##members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#0: int :: { $Unbox(Seq#Index(##members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##members#0) ==> DtRank($Unbox(Seq#Index(##members#0, j#0)): DatatypeType) < DtRank(##obj#0));
    assume (forall j#0: int :: { $Unbox(Seq#Index(##members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##members#0) ==> DtRank($Unbox(Seq#Index(##members#0, j#0)): DatatypeType) < DtRank(##obj#0));
    assume 0 <= LitInt(1) || DtRank(##obj#0) <= DtRank(obj#0) || LitInt(1) == LitInt(1);
    assume DtRank(##obj#0) <= DtRank(obj#0) && (DtRank(##obj#0) == DtRank(obj#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0)) && JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0);
  free ensures {:id "id24426"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (defass#wr#0: bool, wr#0: DatatypeType where defass#wr#0 ==> $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0)) && JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0);
  free ensures {:id "id24427"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType, writer#0: DatatypeType) returns (defass#wr#0: bool, wr#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var members#0: Seq where $Is(members#0, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(members#0, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
  var ##obj#1: DatatypeType;
  var ##members#1: Seq;
  var ##writer#1: DatatypeType;
  var i#0: int;
  var i#0#lo: int;
  var i#0#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#wr#0: bool;
  var $w$loop#0: bool;
  var ##obj#2: DatatypeType;
  var ##members#2: Seq;
  var ##writer#2: DatatypeType;
  var ##obj#0_0: DatatypeType;
  var ##m#0_0: DatatypeType;
  var ##writer#0_0: DatatypeType;
  var ##obj#3: DatatypeType;
  var ##members#3: Seq;
  var ##writer#3: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.MembersImpl", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(273,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    wr#0 := writer#0;
    defass#wr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(274,16)"} true;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(obj#0);
    members#0 := JSON_mGrammar.Bracketed.data(obj#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(275,27)"} true;
    assume defass#wr#0;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(members#0);
    ##obj#1 := obj#0;
    assume $IsAlloc(##obj#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##members#1 := Seq#Take(members#0, LitInt(0));
    assume $IsAlloc(##members#1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#1 := writer#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#1: int :: { $Unbox(Seq#Index(##members#1, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(##members#1) ==> DtRank($Unbox(Seq#Index(##members#1, j#1)): DatatypeType) < DtRank(##obj#1));
    assume 0 <= LitInt(1) || DtRank(##obj#1) <= DtRank(obj#0) || LitInt(1) == LitInt(1);
    assume DtRank(##obj#1) <= DtRank(obj#0) && (DtRank(##obj#1) == DtRank(obj#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, Seq#Take(members#0, LitInt(0)), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, LitInt(0)), writer#0));
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, LitInt(0)), writer#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, Seq#Take(members#0, LitInt(0)), writer#0);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, Seq#Take(members#0, LitInt(0)), writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, Seq#Take(members#0, LitInt(0)), writer#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(276,55)"} true;
    i#0#lo := LitInt(0);
    i#0#hi := Seq#Length(members#0);
    assume i#0#lo <= i#0#hi;
    i#0 := i#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#wr#0 := defass#wr#0;
    havoc $w$loop#0;
    goto anon7_LoopHead;

  anon7_LoopHead:
    assume i#0#lo <= i#0 && i#0 <= i#0#hi;
    assume $w$loop#0 ==> $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, i#0), writer#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, Seq#Take(members#0, i#0), writer#0);
    assume $w$loop#0 ==> JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, Seq#Take(members#0, i#0), writer#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#wr#0 ==> defass#wr#0;
    assume true;
    goto anon7_LoopDone, anon7_LoopBody;

  anon7_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(277,4): after some loop iterations"} true;
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} !$w$loop#0;
    assume defass#wr#0;
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(members#0);
    ##obj#2 := obj#0;
    assume $IsAlloc(##obj#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##members#2 := Seq#Take(members#0, i#0);
    assume $IsAlloc(##members#2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#2 := writer#0;
    assume $IsAlloc(##writer#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#2: int :: { $Unbox(Seq#Index(##members#2, j#2)): DatatypeType } LitInt(0) <= j#2 && j#2 < Seq#Length(##members#2) ==> DtRank($Unbox(Seq#Index(##members#2, j#2)): DatatypeType) < DtRank(##obj#2));
    assume 0 <= LitInt(1) || DtRank(##obj#2) <= DtRank(obj#0) || LitInt(1) == LitInt(1);
    assume DtRank(##obj#2) <= DtRank(obj#0) && (DtRank(##obj#2) == DtRank(obj#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, Seq#Take(members#0, i#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, i#0), writer#0));
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, i#0), writer#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, Seq#Take(members#0, i#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, i#0), writer#0));
    assume false;
    goto anon3;

  anon8_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume {:partition} i#0 == i#0#hi;
    goto anon6;

  anon9_Else:
    assume {:partition} i#0 != i#0#hi;
    push;
    assume {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(members#0);
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(Seq#Take(members#0, i#0 + 1));
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(members#0);
    assume true;
    assume Seq#Equal(Seq#Take(Seq#Take(members#0, i#0 + 1), i#0), Seq#Take(members#0, i#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(280,48)"} true;
    assume true;
    assume 0 <= i#0 && i#0 < Seq#Length(members#0);
    assume defass#wr#0;
    ##obj#0_0 := obj#0;
    assume $IsAlloc(##obj#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##m#0_0 := $Unbox(Seq#Index(members#0, i#0)): DatatypeType;
    assume $IsAlloc(##m#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    ##writer#0_0 := wr#0;
    assume $IsAlloc(##writer#0_0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} DtRank(##m#0_0) < DtRank(##obj#0_0);
    assume DtRank(##m#0_0) < DtRank(##obj#0_0);
    assume 0 <= LitInt(1) || DtRank(##obj#0_0) < DtRank(obj#0) || LitInt(0) == LitInt(1);
    assume DtRank(##obj#0_0) < DtRank(obj#0) || (DtRank(##obj#0_0) == DtRank(obj#0) && LitInt(0) < LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, $Unbox(Seq#Index(members#0, i#0)): DatatypeType, wr#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, $Unbox(Seq#Index(members#0, i#0)): DatatypeType, wr#0));
    assume JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, $Unbox(Seq#Index(members#0, i#0)): DatatypeType, wr#0);
    wr#0 := JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, $Unbox(Seq#Index(members#0, i#0)): DatatypeType, wr#0);
    defass#wr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(281,39)"} true;
    pop;
    i#0 := i#0 + 1;
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, Seq#Take(members#0, i#0), writer#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, Seq#Take(members#0, i#0), writer#0);
    goto anon7_LoopHead;

  anon7_LoopDone:
    assume {:partition} false;
    goto anon6;

  anon6:
    assume {:subsumption 0} 0 <= Seq#Length(members#0) && Seq#Length(members#0) <= Seq#Length(members#0);
    assume true;
    assume Seq#Equal(Seq#Take(members#0, Seq#Length(members#0)), members#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(283,42)"} true;
    assume defass#wr#0;
    ##obj#3 := obj#0;
    assume $IsAlloc(##obj#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##members#3 := members#0;
    assume $IsAlloc(##members#3, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#3 := writer#0;
    assume $IsAlloc(##writer#3, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#3: int :: { $Unbox(Seq#Index(##members#3, j#3)): DatatypeType } LitInt(0) <= j#3 && j#3 < Seq#Length(##members#3) ==> DtRank($Unbox(Seq#Index(##members#3, j#3)): DatatypeType) < DtRank(##obj#3));
    assume 0 <= LitInt(1) || DtRank(##obj#3) <= DtRank(obj#0) || LitInt(1) == LitInt(1);
    assume DtRank(##obj#3) <= DtRank(obj#0) && (DtRank(##obj#3) == DtRank(obj#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0));
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LZ), obj#0, members#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, members#0, writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($LS($LZ)), obj#0, members#0, writer#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(284,50)"} true;
    assume defass#wr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##arr#0: DatatypeType;
  var ##items#0: Seq;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.ItemsImpl", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(287,38): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc wr#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(289,15): post-state"} true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##items#0 := JSON_mGrammar.Bracketed.data(arr#0);
    assume $IsAlloc(##items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#0: int :: { $Unbox(Seq#Index(##items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##items#0) ==> DtRank($Unbox(Seq#Index(##items#0, j#0)): DatatypeType) < DtRank(##arr#0));
    assume (forall j#0: int :: { $Unbox(Seq#Index(##items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(##items#0) ==> DtRank($Unbox(Seq#Index(##items#0, j#0)): DatatypeType) < DtRank(##arr#0));
    assume 0 <= LitInt(1) || DtRank(##arr#0) <= DtRank(arr#0) || LitInt(1) == LitInt(1);
    assume DtRank(##arr#0) <= DtRank(arr#0) && (DtRank(##arr#0) == DtRank(arr#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0)) && JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0);
  free ensures {:id "id24468"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LS($LZ)), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (defass#wr#0: bool, wr#0: DatatypeType where defass#wr#0 ==> $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0)) && JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0);
  free ensures {:id "id24469"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LS($LZ)), arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType, writer#0: DatatypeType) returns (defass#wr#0: bool, wr#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var items#0: Seq where $Is(items#0, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(items#0, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
  var ##arr#1: DatatypeType;
  var ##items#1: Seq;
  var ##writer#1: DatatypeType;
  var i#0: int;
  var i#0#lo: int;
  var i#0#hi: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#wr#0: bool;
  var $w$loop#0: bool;
  var ##arr#2: DatatypeType;
  var ##items#2: Seq;
  var ##writer#2: DatatypeType;
  var xs##0_0_0: Seq;
  var i##0_0_0: int;
  var j##0_0_0: int;
  var ##arr#0_0: DatatypeType;
  var ##m#0_0: DatatypeType;
  var ##writer#0_0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.ItemsImpl", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(290,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    wr#0 := writer#0;
    defass#wr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(291,16)"} true;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(arr#0);
    items#0 := JSON_mGrammar.Bracketed.data(arr#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(292,25)"} true;
    assume defass#wr#0;
    assume {:subsumption 0} 0 <= LitInt(0) && LitInt(0) <= Seq#Length(items#0);
    ##arr#1 := arr#0;
    assume $IsAlloc(##arr#1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##items#1 := Seq#Take(items#0, LitInt(0));
    assume $IsAlloc(##items#1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#1 := writer#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#1: int :: { $Unbox(Seq#Index(##items#1, j#1)): DatatypeType } LitInt(0) <= j#1 && j#1 < Seq#Length(##items#1) ==> DtRank($Unbox(Seq#Index(##items#1, j#1)): DatatypeType) < DtRank(##arr#1));
    assume 0 <= LitInt(1) || DtRank(##arr#1) <= DtRank(arr#0) || LitInt(1) == LitInt(1);
    assume DtRank(##arr#1) <= DtRank(arr#0) && (DtRank(##arr#1) == DtRank(arr#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, Seq#Take(items#0, LitInt(0)), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, LitInt(0)), writer#0));
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, LitInt(0)), writer#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, Seq#Take(items#0, LitInt(0)), writer#0);
    assume {:subsumption 0} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LS($LZ)), arr#0, Seq#Take(items#0, LitInt(0)), writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LS($LZ)), arr#0, Seq#Take(items#0, LitInt(0)), writer#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(293,51)"} true;
    i#0#lo := LitInt(0);
    i#0#hi := Seq#Length(items#0);
    assume i#0#lo <= i#0#hi;
    i#0 := i#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#wr#0 := defass#wr#0;
    havoc $w$loop#0;
    goto anon9_LoopHead;

  anon9_LoopHead:
    assume i#0#lo <= i#0 && i#0 <= i#0#hi;
    assume $w$loop#0 ==> $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, i#0), writer#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, Seq#Take(items#0, i#0), writer#0);
    assume $w$loop#0 ==> JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LS($LZ)), arr#0, Seq#Take(items#0, i#0), writer#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#wr#0 ==> defass#wr#0;
    assume true;
    goto anon9_LoopDone, anon9_LoopBody;

  anon9_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(294,4): after some loop iterations"} true;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} !$w$loop#0;
    assume defass#wr#0;
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(items#0);
    ##arr#2 := arr#0;
    assume $IsAlloc(##arr#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##items#2 := Seq#Take(items#0, i#0);
    assume $IsAlloc(##items#2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##writer#2 := writer#0;
    assume $IsAlloc(##writer#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} (forall j#2: int :: { $Unbox(Seq#Index(##items#2, j#2)): DatatypeType } LitInt(0) <= j#2 && j#2 < Seq#Length(##items#2) ==> DtRank($Unbox(Seq#Index(##items#2, j#2)): DatatypeType) < DtRank(##arr#2));
    assume 0 <= LitInt(1) || DtRank(##arr#2) <= DtRank(arr#0) || LitInt(1) == LitInt(1);
    assume DtRank(##arr#2) <= DtRank(arr#0) && (DtRank(##arr#2) == DtRank(arr#0) ==> LitInt(1) <= LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, Seq#Take(items#0, i#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, i#0), writer#0));
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, i#0), writer#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, Seq#Take(items#0, i#0), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, i#0), writer#0));
    assume false;
    goto anon3;

  anon10_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} i#0 == i#0#hi;
    goto anon8;

  anon11_Else:
    assume {:partition} i#0 != i#0#hi;
    push;
    assume {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(items#0);
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(Seq#Take(items#0, i#0 + 1));
    assume {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(items#0);
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    push;
    assume true;
    xs##0_0_0 := items#0;
    assume true;
    assume $Is(i#0, Tclass._System.nat());
    i##0_0_0 := i#0;
    assume true;
    assume $Is(i#0 + 1, Tclass._System.nat());
    j##0_0_0 := i#0 + 1;
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.AboutList(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), xs##0_0_0, i##0_0_0, j##0_0_0);
    call CallPost$$JSON_mZeroCopy_mSerializer.__default.AboutList(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), xs##0_0_0, i##0_0_0, j##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(298,32)"} true;
    pop;
    assume Seq#Equal(Seq#Take(Seq#Take(items#0, i#0 + 1), i#0), Seq#Take(items#0, i#0));
    assume false;
    goto anon7;

  anon12_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(Seq#Take(Seq#Take(items#0, i#0 + 1), i#0), Seq#Take(items#0, i#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(299,6)"} true;
    assume true;
    assume 0 <= i#0 && i#0 < Seq#Length(items#0);
    assume defass#wr#0;
    ##arr#0_0 := arr#0;
    assume $IsAlloc(##arr#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##m#0_0 := $Unbox(Seq#Index(items#0, i#0)): DatatypeType;
    assume $IsAlloc(##m#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    ##writer#0_0 := wr#0;
    assume $IsAlloc(##writer#0_0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume {:subsumption 0} DtRank(##m#0_0) < DtRank(##arr#0_0);
    assume DtRank(##m#0_0) < DtRank(##arr#0_0);
    assume 0 <= LitInt(1) || DtRank(##arr#0_0) < DtRank(arr#0) || LitInt(0) == LitInt(1);
    assume DtRank(##arr#0_0) < DtRank(arr#0) || (DtRank(##arr#0_0) == DtRank(arr#0) && LitInt(0) < LitInt(1));
    assume JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, $Unbox(Seq#Index(items#0, i#0)): DatatypeType, wr#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, $Unbox(Seq#Index(items#0, i#0)): DatatypeType, wr#0));
    assume JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, $Unbox(Seq#Index(items#0, i#0)): DatatypeType, wr#0);
    wr#0 := JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, $Unbox(Seq#Index(items#0, i#0)): DatatypeType, wr#0);
    defass#wr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(300,35)"} true;
    pop;
    i#0 := i#0 + 1;
    assume $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($LZ), arr#0, Seq#Take(items#0, i#0), writer#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, Seq#Take(items#0, i#0), writer#0);
    goto anon9_LoopHead;

  anon9_LoopDone:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume {:subsumption 0} 0 <= Seq#Length(items#0) && Seq#Length(items#0) <= Seq#Length(items#0);
    assume true;
    assume Seq#Equal(Seq#Take(items#0, Seq#Length(items#0)), items#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(302,36)"} true;
    assume defass#wr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.AboutList (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T), $Heap), i#0: int where LitInt(0) <= i#0, j#0: int where LitInt(0) <= j#0);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.AboutList (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq, i#0: int, j#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.AboutList", " | ", JSON.ZeroCopy.Serializer._default.AboutList$T, " | ", xs#0, " | ", i#0, " | ", j#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(305,8): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} i#0 < j#0;
    goto anon3;

  anon4_Else:
    assume {:partition} j#0 <= i#0;
    goto anon3;

  anon3:
    assume i#0 < j#0 && j#0 <= Seq#Length(xs#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(307,25): post-state"} true;
    assume 0 <= j#0 && j#0 <= Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 <= Seq#Length(Seq#Take(xs#0, j#0));
    assume 0 <= i#0 && i#0 <= Seq#Length(xs#0);
    assume Seq#Equal(Seq#Take(Seq#Take(xs#0, j#0), i#0), Seq#Take(xs#0, i#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.AboutList (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T), $Heap), i#0: int where LitInt(0) <= i#0, j#0: int where LitInt(0) <= j#0);
  requires {:id "id24510"} i#0 < j#0;
  requires {:id "id24511"} j#0 <= Seq#Length(xs#0);



procedure {:verboseName "JSON.ZeroCopy.Serializer.AboutList (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T), $Heap), i#0: int where LitInt(0) <= i#0, j#0: int where LitInt(0) <= j#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id24512"} Seq#Equal(Seq#Take(Seq#Take(xs#0, j#0), i#0), Seq#Take(xs#0, i#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.AboutList (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Serializer._default.AboutList$T), $Heap), i#0: int where LitInt(0) <= i#0, j#0: int where LitInt(0) <= j#0) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id24513"} i#0 < j#0;
  requires {:id "id24514"} j#0 <= Seq#Length(xs#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id24515"} Seq#Equal(Seq#Take(Seq#Take(xs#0, j#0), i#0), Seq#Take(xs#0, i#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.AboutList (correctness)"} Impl$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq, i#0: int, j#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.AboutList", " | ", JSON.ZeroCopy.Serializer._default.AboutList$T, " | ", xs#0, " | ", i#0, " | ", j#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(308,2): initial state"} true;
    $_reverifyPost := false;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Member($ly: LayerType, $reveal: bool, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, m#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), m#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, m#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0) && (var wr#0 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#0) && (var wr#1 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#1) && (var wr#2 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#1); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#2))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, obj#0, m#0, writer#0) == (var wr#0 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); (var wr#1 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#0); (var wr#2 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#1); (var wr#3 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#2 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#2)); wr#3)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), m#0, writer#0) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0) && (var wr#4 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#4) && (var wr#5 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#4); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#5) && (var wr#6 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#5); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#6))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), m#0, writer#0) == (var wr#4 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); (var wr#5 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#4); (var wr#6 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#5); (var wr#7 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#6 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#6)); wr#7)))));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), Lit(m#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), Lit(m#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)) && (var wr#8 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#8) && (var wr#9 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#8); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#9) && (var wr#10 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#9); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && (!Lit(JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#10))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), Lit(m#0), Lit(writer#0)) == (var wr#8 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)); (var wr#9 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#8); (var wr#10 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#9); (var wr#11 := (if JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0)))) then wr#10 else JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#10)); wr#11)))));
}

function JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), $reveal, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), $reveal, obj#0, m#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member(AsFuelBottom($ly), $reveal, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Member($LZ, $reveal, obj#0, m#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Member#requires(LayerType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member#requires($ly, obj#0, m#0, writer#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Member#requires($ly, obj#0, m#0, writer#0) <==> DtRank(m#0) < DtRank(obj#0)));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Member (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Member(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), m#0: DatatypeType where $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#12: DatatypeType where $Is(wr#12, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24516"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#12), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Member($LS($LS($LZ)), m#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Member (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Member(obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType) returns (wr#12: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##str#0: DatatypeType;
  var ##writer#0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##st#0: DatatypeType;
  var ##writer#1: DatatypeType;
  var wr#Z#2: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##v#0: DatatypeType;
  var ##writer#2: DatatypeType;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;
  var ##fT#0: HandleType;
  var ##self#3: DatatypeType;
  var a##0_0: Seq;
  var b##0_0: Seq;
  var ##self#0_0: DatatypeType;
  var c##0_0: Seq;
  var ##self#0_1: DatatypeType;
  var ##fT#0_0: HandleType;
  var d##0_0: Seq;
  var ##self#0_2: DatatypeType;
  var wr#Z#3: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##st#1: DatatypeType;
  var ##writer#3: DatatypeType;
  var ##self#4: DatatypeType;
  var ##c#0: DatatypeType;
  var l##1_0_0: Seq;
  var ##self#1_0_0: DatatypeType;
  var a##1_0_0: Seq;
  var b##1_0_0: Seq;
  var ##self#1_0_1: DatatypeType;
  var c##1_0_0: Seq;
  var ##self#1_1_0: DatatypeType;
  var ##c#1_1_0: DatatypeType;
  var ##self#5: DatatypeType;
  var ##c#1: DatatypeType;
  var a##2_0: Seq;
  var b##2_0: Seq;
  var ##self#2_0: DatatypeType;
  var c##2_0: Seq;
  var ##c#2_0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Member", " | ", obj#0, " | ", m#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(310,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume DtRank(m#0) < DtRank(obj#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#12), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#12);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##self#0 := m#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(m#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#12), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), m#0)));
    assume false;
    return;

  anon16_Else:
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##str#0 := JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##str#0, Tclass.JSON_mGrammar.jstring(), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0));
    assume let#0#0#0 == JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#0#0#0;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##st#0 := JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#1 := wr#Z#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#1 == let#1#0#0;
    havoc wr#Z#2;
    assume $Is(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##v#0 := JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##v#0, Tclass.JSON_mGrammar.Value(), $Heap);
    ##writer#2 := wr#Z#1;
    assume $IsAlloc(##writer#2, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(0) || DtRank(##v#0) < DtRank(obj#0) || LitInt(4) == LitInt(0);
    assume DtRank(##v#0) < DtRank(obj#0) || (DtRank(##v#0) == DtRank(obj#0) && LitInt(4) < LitInt(0));
    assume JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#1);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#1));
    assume let#2#0#0 == JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#1);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#Z#1);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#2 == let#2#0#0;
    assume $IsAllocBox($Box(wr#Z#2), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##self#1 := JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume true;
    ##self#2 := JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##self#3 := JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#2) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle()) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0_0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##self#0_0 := JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##self#0_0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    b##0_0 := JSON_mConcreteSyntax_mSpec.__default.String(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume true;
    ##self#0_1 := JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##self#0_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fT#0_0 := JSON_mConcreteSyntax_mSpec.__default.View#Handle();
    assume $IsAlloc(##fT#0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    c##0_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle());
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    ##self#0_2 := JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume $IsAlloc(##self#0_2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    d##0_0 := JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0, d##0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc2(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0, d##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(319,117)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle())), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)))));
    assume false;
    goto anon5;

  anon17_Else:
    goto anon5;

  anon5:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#2), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View#Handle())), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(320,4)"} true;
    havoc wr#Z#3;
    assume $Is(wr#Z#3, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(wr#Z#3, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    assume let#3#0#0 == wr#Z#2;
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon8;

  anon18_Else:
    assume {:partition} !JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    ##st#1 := $Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType;
    assume $IsAlloc(##st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#3 := wr#Z#2;
    assume $IsAlloc(##writer#3, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#2);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#2));
    assume let#3#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#2);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#2);
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon8;

  anon8:
    assume wr#Z#3 == let#3#0#0;
    assume $IsAllocBox($Box(wr#Z#3), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#3);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#4 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#4, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##c#0 := JSON_mGrammar.Suffixed.suffix(m#0);
    assume $IsAlloc(##c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#3) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#1_0_0 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    l##1_0_0 := JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    call CallPre$$JSON_mUtils_mSeq.__default.Neutral(Tclass.BoundedInts.uint8(), l##1_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Neutral(Tclass.BoundedInts.uint8(), l##1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(324,35)"} true;
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##1_0_0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#1_0_1 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#1_0_1, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    b##1_0_0 := JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume true;
    c##1_0_0 := Lit(Seq#Empty(): Seq);
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##1_0_0, b##1_0_0, c##1_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##1_0_0, b##1_0_0, c##1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(325,58)"} true;
    goto anon12;

  anon20_Else:
    assume {:partition} !JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    ##self#1_1_0 := $Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType;
    assume $IsAlloc(##self#1_1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##c#1_1_0 := JSON_mGrammar.Suffixed.suffix(m#0);
    assume $IsAlloc(##c#1_1_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(328,76)"} true;
    goto anon12;

  anon12:
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#3), Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LS($LZ)), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0))));
    assume false;
    goto anon13;

  anon19_Else:
    goto anon13;

  anon13:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#3), Seq#Append(Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(330,4)"} true;
    assume $IsAllocBox($Box(wr#Z#3), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#3);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#5 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#5, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##c#1 := JSON_mGrammar.Suffixed.suffix(m#0);
    assume $IsAlloc(##c#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#3) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##2_0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#2_0 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#2_0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    b##2_0 := JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##c#2_0 := JSON_mGrammar.Suffixed.suffix(m#0);
    assume $IsAlloc(##c#2_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    c##2_0 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##2_0, b##2_0, c##2_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##2_0, b##2_0, c##2_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(332,79)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#3), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LS($LZ)), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0)))));
    assume false;
    goto anon15;

  anon21_Else:
    goto anon15;

  anon15:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#3), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(333,4)"} true;
    assume $Is(wr#Z#3, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, m#0, writer#0) == wr#Z#3;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Member($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, m#0, writer#0) == wr#12;
    return;
}



function JSON_mZeroCopy_mSerializer.__default.Item($ly: LayerType, $reveal: bool, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, m#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), m#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, m#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0) && (var wr#0 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#0))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, arr#0, m#0, writer#0) == (var wr#0 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); (var wr#1 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#0 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#0)); wr#1)));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), m#0, writer#0) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0) && (var wr#2 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#2))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), m#0, writer#0) == (var wr#2 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); (var wr#3 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#2 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#2)); wr#3)));
axiom 2 <= $FunctionContextHeight ==> (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), Lit(m#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), Lit(m#0), Lit(writer#0)) || (2 < $FunctionContextHeight && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)) && (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && (!Lit(JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#4))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), Lit(m#0), Lit(writer#0)) == (var wr#4 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)); (var wr#5 := (if JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0)))) then wr#4 else JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#4)); wr#5)));
}

function JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), $reveal, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), $reveal, arr#0, m#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0));

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item(AsFuelBottom($ly), $reveal, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.Item($LZ, $reveal, arr#0, m#0, writer#0));

function JSON_mZeroCopy_mSerializer.__default.Item#requires(LayerType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item#requires($ly, arr#0, m#0, writer#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.Item#requires($ly, arr#0, m#0, writer#0) <==> DtRank(m#0) < DtRank(arr#0)));

procedure {:verboseName "JSON.ZeroCopy.Serializer.Item (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Item(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), m#0: DatatypeType where $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) returns (wr#6: DatatypeType where $Is(wr#6, Tclass.JSON_mUtils_mViews_mWriters.Writer()));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24552"} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#6), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Item($LS($LS($LZ)), m#0)));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Item (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mSerializer.__default.Item(arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType) returns (wr#6: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var wr#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##v#0: DatatypeType;
  var ##writer#0: DatatypeType;
  var wr#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##st#0: DatatypeType;
  var ##writer#1: DatatypeType;
  var ##self#1: DatatypeType;
  var ##c#0: DatatypeType;
  var a##0_0: Seq;
  var b##0_0: Seq;
  var ##self#0_0: DatatypeType;
  var c##0_0: Seq;
  var ##c#0_0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Item", " | ", arr#0, " | ", m#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(337,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume DtRank(m#0) < DtRank(arr#0);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume $IsAllocBox($Box(wr#6), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#6);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    ##self#0 := m#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(m#0);
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#6), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), m#0)));
    assume false;
    return;

  anon9_Else:
    havoc wr#Z#0;
    assume $Is(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#Z#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##v#0 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##v#0, Tclass.JSON_mGrammar.Value(), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(0) || DtRank(##v#0) < DtRank(arr#0) || LitInt(4) == LitInt(0);
    assume DtRank(##v#0) < DtRank(arr#0) || (DtRank(##v#0) == DtRank(arr#0) && LitInt(4) < LitInt(0));
    assume JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0));
    assume let#0#0#0 == JSON_mZeroCopy_mSerializer.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume wr#Z#0 == let#0#0#0;
    havoc wr#Z#1;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    assume let#1#0#0 == wr#Z#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon6;

  anon10_Else:
    assume {:partition} !JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(m#0));
    ##st#0 := $Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType;
    assume $IsAlloc(##st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##writer#1 := wr#Z#0;
    assume $IsAlloc(##writer#1, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#0));
    assume let#1#0#0 == JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mViews_mWriters.Writer__());
    goto anon6;

  anon6:
    assume wr#Z#1 == let#1#0#0;
    assume $IsAllocBox($Box(wr#Z#1), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1);
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#1 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##c#0 := JSON_mGrammar.Suffixed.suffix(m#0);
    assume $IsAlloc(##c#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(wr#Z#1) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume $IsAllocBox($Box(writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(writer#0);
    a##0_0 := JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##self#0_0 := $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType;
    assume $IsAlloc(##self#0_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    b##0_0 := JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0);
    ##c#0_0 := JSON_mGrammar.Suffixed.suffix(m#0);
    assume $IsAlloc(##c#0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(m#0));
    c##0_0 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0, b##0_0, c##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(345,76)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0)))));
    assume false;
    goto anon8;

  anon11_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#Z#1), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(m#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(346,4)"} true;
    assume $Is(wr#Z#1, Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, m#0, writer#0) == wr#Z#1;
    assume true;
    assume $Is(JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer());
    assume JSON_mZeroCopy_mSerializer.__default.Item($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, m#0, writer#0) == wr#6;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Text (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Text();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Text (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Text();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Text (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Text();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Text;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_JSON (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__JSON();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_JSON (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__JSON();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_JSON (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__JSON();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.JSON;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Value (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Value();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Value (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Value();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Value (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Value();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Value;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_String (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__String();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_String (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__String();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_String (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__String();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.String;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Number (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Number();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Number (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Number();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Number (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Number();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Number;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Object (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Object();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Object (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Object();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Object (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Object();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Object;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Array (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Array();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Array (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Array();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Array (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Array();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Array;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Members (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Members();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Members (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Members();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Members (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Members();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Members;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Items (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Items();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Items (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Items();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Items (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Items();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Items;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Member (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Member();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Member (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Member();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Member (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Member();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Member;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Item (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.reveal__Item();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Item (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mSerializer.__default.reveal__Item();



procedure {:verboseName "JSON.ZeroCopy.Serializer.reveal_Item (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mSerializer.__default.reveal__Item();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Serializer._default.Item;



procedure {:verboseName "JSON.ZeroCopy.Serializer.Members (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Members (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##obj#0: DatatypeType;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Members", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(184,21): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc wr#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(189,4): post-state"} true;
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(2) || DtRank(##obj#0) < DtRank(obj#0) || LitInt(2) == LitInt(2);
    assume DtRank(##obj#0) < DtRank(obj#0) || (DtRank(##obj#0) == DtRank(obj#0) && LitInt(2) < LitInt(2));
    assume JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.Members (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.Members (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.Members($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0);
  free ensures {:id "id24573"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.Members($LS($LS($LZ)), reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.Serializer.Items (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Serializer.Items (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##arr#0: DatatypeType;
  var ##writer#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Items", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(194,21): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc wr#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Serializer.dfy(199,4): post-state"} true;
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    ##writer#0 := writer#0;
    assume $IsAlloc(##writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap);
    assume 0 <= LitInt(2) || DtRank(##arr#0) < DtRank(arr#0) || LitInt(2) == LitInt(2);
    assume DtRank(##arr#0) < DtRank(arr#0) || (DtRank(##arr#0) == DtRank(arr#0) && LitInt(2) < LitInt(2));
    assume JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0));
    assume JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Serializer.Items (call precondtion)"} CallPre$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0));



procedure {:verboseName "JSON.ZeroCopy.Serializer.Items (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0), writer#0: DatatypeType where $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(writer#0)) returns (wr#0: DatatypeType where $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap));
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mViews_mWriters.Writer__(wr#0) && $IsA#JSON_mUtils_mViews_mWriters.Writer__(JSON_mZeroCopy_mSerializer.__default.Items($LS($LZ), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0);
  free ensures {:id "id24586"} JSON_mUtils_mViews_mWriters.Writer__#Equal(wr#0, JSON_mZeroCopy_mSerializer.__default.Items($LS($LS($LZ)), reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, writer#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#208 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#208))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#210 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#210)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#312 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#312))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#314 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#314)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#316 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#316)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#312 := Wrappers.Option.value(this); v#312)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#314 := Lit(Wrappers.Option.value(Lit(this))); v#314)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#316 := Lit(Wrappers.Option.value(Lit(this))); v#316)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#208 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#208)) else (var e#208 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#210 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#210))) else (var e#210 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#312 := Wrappers.Result.value(this); s#312) else (var e#312 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#314 := Lit(Wrappers.Result.value(Lit(this))); s#314) else (var e#314 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#316 := Lit(Wrappers.Result.value(Lit(this))); s#316) else (var e#316 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#312 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#312)) else (var e#312 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#312)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#314 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#314))) else (var e#314 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#314)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#316 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#316))) else (var e#316 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#316)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#108: int, y#108: int :: { Mul(x#108, y#108) } Mul(x#108, y#108) == Mul(y#108, x#108)) && (forall x#109: int, y#109: int, z#72: int :: { Mul(x#109 + y#109, z#72) } Mul(x#109 + y#109, z#72) == Mul(x#109, z#72) + Mul(y#109, z#72)) && (forall x#110: int, y#110: int, z#73: int :: { Mul(x#110 - y#110, z#73) } Mul(x#110 - y#110, z#73) == Mul(x#110, z#73) - Mul(y#110, z#73));

axiom MulInternals.__default.MulAuto() <==> (forall x#111: int, y#111: int :: { Mul(x#111, y#111) } Mul(x#111, y#111) == Mul(y#111, x#111)) && (forall x#112: int, y#112: int, z#74: int :: { Mul(x#112 + y#112, z#74) } Mul(x#112 + y#112, z#74) == Mul(x#112, z#74) + Mul(y#112, z#74)) && (forall x#113: int, y#113: int, z#75: int :: { Mul(x#113 - y#113, z#75) } Mul(x#113 - y#113, z#75) == Mul(x#113, z#75) - Mul(y#113, z#75));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#128: int :: { Mod(Mod(x#128, n#0), n#0) } Mod(Mod(x#128, n#0), n#0) == Mod(x#128, n#0)) && (forall x#129: int :: { Mod(x#129, n#0) } LitInt(0) <= x#129 && x#129 < n#0 <==> Mod(x#129, n#0) == x#129) && (forall x#130: int, y#64: int :: { Mod(x#130 + y#64, n#0) } (var z#62 := Mod(x#130, n#0) + Mod(y#64, n#0); (LitInt(0) <= z#62 && z#62 < n#0 && Mod(x#130 + y#64, n#0) == z#62) || (n#0 <= z#62 && z#62 < n#0 + n#0 && Mod(x#130 + y#64, n#0) == z#62 - n#0))) && (forall x#131: int, y#65: int :: { Mod(x#131 - y#65, n#0) } (var z#63 := Mod(x#131, n#0) - Mod(y#65, n#0); (LitInt(0) <= z#63 && z#63 < n#0 && Mod(x#131 - y#65, n#0) == z#63) || (0 - n#0 <= z#63 && z#63 < 0 && Mod(x#131 - y#65, n#0) == z#63 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#132: int :: { Mod(Mod(x#132, n#0), n#0) } Mod(Mod(x#132, LitInt(n#0)), LitInt(n#0)) == Mod(x#132, LitInt(n#0))) && (forall x#133: int :: { Mod(x#133, n#0) } LitInt(0) <= x#133 && x#133 < n#0 <==> Mod(x#133, LitInt(n#0)) == x#133) && (forall x#134: int, y#66: int :: { Mod(x#134 + y#66, n#0) } (var z#64 := Mod(x#134, LitInt(n#0)) + Mod(y#66, LitInt(n#0)); (LitInt(0) <= z#64 && z#64 < n#0 && Mod(x#134 + y#66, LitInt(n#0)) == z#64) || (LitInt(n#0) <= z#64 && z#64 < n#0 + n#0 && Mod(x#134 + y#66, LitInt(n#0)) == z#64 - n#0))) && (forall x#135: int, y#67: int :: { Mod(x#135 - y#67, n#0) } (var z#65 := Mod(x#135, LitInt(n#0)) - Mod(y#67, LitInt(n#0)); (LitInt(0) <= z#65 && z#65 < n#0 && Mod(x#135 - y#67, LitInt(n#0)) == z#65) || (LitInt(0 - n#0) <= z#65 && z#65 < 0 && Mod(x#135 - y#67, LitInt(n#0)) == z#65 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#90: int :: { Div(x#90, n#0) } LitInt(0) <= x#90 && x#90 < n#0 <==> Div(x#90, n#0) == LitInt(0)) && (forall x#91: int, y#60: int :: { Div(x#91 + y#60, n#0) } (var z#58 := Mod(x#91, n#0) + Mod(y#60, n#0); (LitInt(0) <= z#58 && z#58 < n#0 && Div(x#91 + y#60, n#0) == Div(x#91, n#0) + Div(y#60, n#0)) || (n#0 <= z#58 && z#58 < n#0 + n#0 && Div(x#91 + y#60, n#0) == Div(x#91, n#0) + Div(y#60, n#0) + 1))) && (forall x#92: int, y#61: int :: { Div(x#92 - y#61, n#0) } (var z#59 := Mod(x#92, n#0) - Mod(y#61, n#0); (LitInt(0) <= z#59 && z#59 < n#0 && Div(x#92 - y#61, n#0) == Div(x#92, n#0) - Div(y#61, n#0)) || (0 - n#0 <= z#59 && z#59 < 0 && Div(x#92 - y#61, n#0) == Div(x#92, n#0) - Div(y#61, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#93: int :: { Div(x#93, n#0) } LitInt(0) <= x#93 && x#93 < n#0 <==> Div(x#93, LitInt(n#0)) == LitInt(0)) && (forall x#94: int, y#62: int :: { Div(x#94 + y#62, n#0) } (var z#60 := Mod(x#94, LitInt(n#0)) + Mod(y#62, LitInt(n#0)); (LitInt(0) <= z#60 && z#60 < n#0 && Div(x#94 + y#62, LitInt(n#0)) == Div(x#94, LitInt(n#0)) + Div(y#62, LitInt(n#0))) || (LitInt(n#0) <= z#60 && z#60 < n#0 + n#0 && Div(x#94 + y#62, LitInt(n#0)) == Div(x#94, LitInt(n#0)) + Div(y#62, LitInt(n#0)) + 1))) && (forall x#95: int, y#63: int :: { Div(x#95 - y#63, n#0) } (var z#61 := Mod(x#95, LitInt(n#0)) - Mod(y#63, LitInt(n#0)); (LitInt(0) <= z#61 && z#61 < n#0 && Div(x#95 - y#63, LitInt(n#0)) == Div(x#95, LitInt(n#0)) - Div(y#63, LitInt(n#0))) || (LitInt(0 - n#0) <= z#61 && z#61 < 0 && Div(x#95 - y#63, LitInt(n#0)) == Div(x#95, LitInt(n#0)) - Div(y#63, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#18 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#18) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#18)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#18 := lv#0; (var dt_update#end#0#18 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#18), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#18), dt_update#end#0#18))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#19 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#19) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#19)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#19 := Lit(lv#0); (var dt_update#end#0#19 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#19)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#19)), dt_update#end#0#19)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#20: char :: { Seq#Contains(s#0, $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(s#0, $Box(c#20)) ==> char#ToInt(c#20) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#20: char :: { Seq#Contains(s#0, $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(s#0, $Box(c#20)) ==> char#ToInt(c#20) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#40#i#0): int)): char))), (lambda $l#40#heap#0: Heap, $l#40#i#0: Box :: $IsBox($l#40#i#0, TInt) && LitInt(0) <= $Unbox($l#40#i#0): int && $Unbox($l#40#i#0): int < Seq#Length(s#0)), (lambda $l#40#heap#0: Heap, $l#40#i#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#21: char :: { Seq#Contains(s#0, $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(s#0, $Box(c#21)) ==> char#ToInt(c#21) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#42#i#0): int)): char))), (lambda $l#42#heap#0: Heap, $l#42#i#0: Box :: $IsBox($l#42#i#0, TInt) && LitInt(0) <= $Unbox($l#42#i#0): int && $Unbox($l#42#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#42#heap#0: Heap, $l#42#i#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#4#0#0, a#4#1#0) } DatatypeCtorId(#JSON.Utils.Views.Writers.Chain.Chain(a#4#0#0, a#4#1#0)) == ##JSON.Utils.Views.Writers.Chain.Chain);

axiom (forall d: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) } JSON_mUtils_mViews_mWriters.Chain.Chain_q(d) ==> (exists a#5#0#0: DatatypeType, a#5#1#0: DatatypeType :: d == #JSON.Utils.Views.Writers.Chain.Chain(a#5#0#0, a#5#1#0)));

axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType :: { $Is(#JSON.Utils.Views.Writers.Chain.Chain(a#6#0#0, a#6#1#0), Tclass.JSON_mUtils_mViews_mWriters.Chain()) } $Is(#JSON.Utils.Views.Writers.Chain.Chain(a#6#0#0, a#6#1#0), Tclass.JSON_mUtils_mViews_mWriters.Chain()) <==> $Is(a#6#0#0, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(a#6#1#0, Tclass.JSON_mUtils_mViews_mCore.View()));

axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(Lit(a#7#0#0), Lit(a#7#1#0)) } #JSON.Utils.Views.Writers.Chain.Chain(Lit(a#7#0#0), Lit(a#7#1#0)) == Lit(#JSON.Utils.Views.Writers.Chain.Chain(a#7#0#0, a#7#1#0)));

axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#8#0#0, a#8#1#0) } JSON_mUtils_mViews_mWriters.Chain.previous(#JSON.Utils.Views.Writers.Chain.Chain(a#8#0#0, a#8#1#0)) == a#8#0#0);

axiom (forall a#9#0#0: DatatypeType, a#9#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#9#0#0, a#9#1#0) } DtRank(a#9#0#0) < DtRank(#JSON.Utils.Views.Writers.Chain.Chain(a#9#0#0, a#9#1#0)));

axiom (forall a#10#0#0: DatatypeType, a#10#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#10#0#0, a#10#1#0) } JSON_mUtils_mViews_mWriters.Chain.v(#JSON.Utils.Views.Writers.Chain.Chain(a#10#0#0, a#10#1#0)) == a#10#1#0);

axiom (forall a#11#0#0: DatatypeType, a#11#1#0: DatatypeType :: { #JSON.Utils.Views.Writers.Chain.Chain(a#11#0#0, a#11#1#0) } DtRank(a#11#1#0) < DtRank(#JSON.Utils.Views.Writers.Chain.Chain(a#11#0#0, a#11#1#0)));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length($ly, this) } JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Chain.Length($ly, this));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Length#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (!JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) ==> JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this)) && JSON_mUtils_mViews_mCore.View__.Length#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this))) && JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), this) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) then 0 else JSON_mUtils_mViews_mWriters.Chain.Length($ly, JSON_mUtils_mViews_mWriters.Chain.previous(this)) + JSON_mUtils_mViews_mCore.View__.Length(JSON_mUtils_mViews_mWriters.Chain.v(this))));

axiom (forall $ly: LayerType, this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), Lit(this)) } JSON_mUtils_mViews_mWriters.Chain.Length#canCall(Lit(this)) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (!Lit(JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Chain.Length#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) && JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))))) && JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), Lit(this)) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this)) then 0 else JSON_mUtils_mViews_mWriters.Chain.Length($LS($ly), Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) + JSON_mUtils_mViews_mCore.View__.Length(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))))));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count($ly, this) } JSON_mUtils_mViews_mWriters.Chain.Count#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Chain.Count($ly, this));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Count#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (!JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) ==> JSON_mUtils_mViews_mWriters.Chain.Count#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this))) && JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), this) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) then 0 else JSON_mUtils_mViews_mWriters.Chain.Count($ly, JSON_mUtils_mViews_mWriters.Chain.previous(this)) + 1));

axiom (forall $ly: LayerType, this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), Lit(this)) } JSON_mUtils_mViews_mWriters.Chain.Count#canCall(Lit(this)) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (!Lit(JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Chain.Count#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this))))) && JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), Lit(this)) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this)) then 0 else JSON_mUtils_mViews_mWriters.Chain.Count($LS($ly), Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) + 1));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this) } JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> Seq#Length(JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this)) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), this) && $Is(JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, this), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), this) } JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (!JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) ==> JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.previous(this)) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this))) && JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), this) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(this) then Seq#Empty(): Seq else Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($ly, JSON_mUtils_mViews_mWriters.Chain.previous(this)), JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mWriters.Chain.v(this)))));

axiom (forall $ly: LayerType, this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), Lit(this)) } JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(Lit(this)) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) ==> (!Lit(JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))))) && JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), Lit(this)) == (if JSON_mUtils_mViews_mWriters.Chain.Empty_q(Lit(this)) then Seq#Empty(): Seq else Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($ly), Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this)))), JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this)))))));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) } JSON_mUtils_mViews_mWriters.Chain.Append#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0))) && $Is(JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Chain()));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) } JSON_mUtils_mViews_mWriters.Chain.Append#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) ==> JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0)) && (JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) && JSON_mUtils_mViews_mCore.__default.Adjacent(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0) ==> JSON_mUtils_mViews_mCore.__default.Merge#canCall(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0)) && JSON_mUtils_mViews_mWriters.Chain.Append(this, v'#0) == (if JSON_mUtils_mViews_mWriters.Chain.Chain_q(this) && JSON_mUtils_mViews_mCore.__default.Adjacent(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0) then #JSON.Utils.Views.Writers.Chain.Chain(JSON_mUtils_mViews_mWriters.Chain.previous(this), JSON_mUtils_mViews_mCore.__default.Merge(JSON_mUtils_mViews_mWriters.Chain.v(this), v'#0)) else #JSON.Utils.Views.Writers.Chain.Chain(this, v'#0)));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Chain.Append(Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mWriters.Chain.Append#canCall(Lit(this), Lit(v'#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mWriters.Chain()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (Lit(JSON_mUtils_mViews_mWriters.Chain.Chain_q(Lit(this))) ==> JSON_mUtils_mViews_mCore.__default.Adjacent#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0))) && (Lit(JSON_mUtils_mViews_mWriters.Chain.Chain_q(Lit(this)) && JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0))) ==> JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0))) && JSON_mUtils_mViews_mWriters.Chain.Append(Lit(this), Lit(v'#0)) == (if JSON_mUtils_mViews_mWriters.Chain.Chain_q(Lit(this)) && JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0)) then #JSON.Utils.Views.Writers.Chain.Chain(Lit(JSON_mUtils_mViews_mWriters.Chain.previous(Lit(this))), Lit(JSON_mUtils_mViews_mCore.__default.Merge(Lit(JSON_mUtils_mViews_mWriters.Chain.v(Lit(this))), Lit(v'#0)))) else #JSON.Utils.Views.Writers.Chain.Chain(Lit(this), Lit(v'#0))));

axiom $Is(JSON_mUtils_mViews_mWriters.Writer__.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Writer());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Empty(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $h));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Empty_q($o), TBool, $h));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q($o), TBool, $h));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Length(this) } JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Writer__.Length(this));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Length(this) } JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Length#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this)) && JSON_mUtils_mViews_mWriters.Writer__.Length(this) == JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.Length(Lit(this)) } JSON_mUtils_mViews_mWriters.Writer__.Length#canCall(Lit(this)) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mWriters.Chain.Length#canCall(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this)))) && JSON_mUtils_mViews_mWriters.Writer__.Length(Lit(this)) == LitInt(JSON_mUtils_mViews_mWriters.Chain.Length($LS($LZ), Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))))));

axiom (forall $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o) } $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o), TBool));

axiom (forall $h: Heap, $o: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o), $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) } $IsGoodHeap($h) && $Is($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc($o, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $h) ==> $IsAlloc(JSON_mUtils_mViews_mWriters.Writer__.Valid_q($o), TBool, $h));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) } JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> Seq#Length(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this)) == JSON_mUtils_mViews_mWriters.Writer__.Length(this) && $Is(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall this: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) } JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(this) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this)) && JSON_mUtils_mViews_mWriters.Writer__.Bytes(this) == JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), JSON_mUtils_mViews_mWriters.Writer__.chain(this)));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.Bytes(Lit(this)) } JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(Lit(this)) || $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mWriters.Chain.Bytes#canCall(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this)))) && JSON_mUtils_mViews_mWriters.Writer__.Bytes(Lit(this)) == Lit(JSON_mUtils_mViews_mWriters.Chain.Bytes($LS($LZ), Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))))));

axiom (forall a#0: int, b#0: int :: { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) } JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(a#0, b#0) || (LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> LitInt(0) <= JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) < BoundedInts.__default.TWO__TO__THE__32());

axiom (forall a#0: int, b#0: int :: { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) } JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(a#0, b#0) || (LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(a#0, b#0) == (if a#0 <= BoundedInts.__default.UINT32__MAX() - b#0 then a#0 + b#0 else BoundedInts.__default.UINT32__MAX()));

axiom (forall a#0: int, b#0: int :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(LitInt(a#0), LitInt(b#0)) } JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(LitInt(a#0), LitInt(b#0)) || (LitInt(0) <= a#0 && a#0 < BoundedInts.__default.TWO__TO__THE__32() && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(LitInt(a#0), LitInt(b#0)) == (if LitInt(a#0) <= BoundedInts.__default.UINT32__MAX() - b#0 then a#0 + b#0 else BoundedInts.__default.UINT32__MAX()));

axiom (forall $reveal: bool, this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0) } JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this)) ==> (JSON_mUtils_mViews_mWriters.Writer__.Unsaturated_q(JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0)) <==> JSON_mUtils_mViews_mCore.View__.Length(v'#0) < BoundedInts.__default.UINT32__MAX() - JSON_mUtils_mViews_mWriters.Writer__.length(this)) && Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(this), JSON_mUtils_mViews_mCore.View__.Bytes(v'#0))) && $Is(JSON_mUtils_mViews_mWriters.Writer__.Append($reveal, this, v'#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: { JSON_mUtils_mViews_mWriters.Writer__.Append(true, this, v'#0) } JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(this, v'#0) || ($Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this)) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mCore.View__.Length#canCall(v'#0) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(this) && JSON_mUtils_mViews_mWriters.Chain.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0) && JSON_mUtils_mViews_mWriters.Writer__.Append(true, this, v'#0) == #JSON.Utils.Views.Writers.Writer_.Writer(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(JSON_mUtils_mViews_mWriters.Writer__.length(this), JSON_mUtils_mViews_mCore.View__.Length(v'#0)), JSON_mUtils_mViews_mWriters.Chain.Append(JSON_mUtils_mViews_mWriters.Writer__.chain(this), v'#0)));

axiom (forall this: DatatypeType, v'#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mWriters.Writer__.Append(true, Lit(this), Lit(v'#0)) } JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(this), Lit(v'#0)) || ($Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $Is(v'#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(Lit(this))) ==> JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32#canCall(LitInt(JSON_mUtils_mViews_mWriters.Writer__.length(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.Length(Lit(v'#0)))) && JSON_mUtils_mViews_mWriters.Writer__.Writer_q(Lit(this)) && JSON_mUtils_mViews_mWriters.Chain.Append#canCall(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))), Lit(v'#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append(true, Lit(this), Lit(v'#0)) == Lit(#JSON.Utils.Views.Writers.Writer_.Writer(LitInt(JSON_mUtils_mViews_mWriters.Writer__.SaturatedAddU32(LitInt(JSON_mUtils_mViews_mWriters.Writer__.length(Lit(this))), LitInt(JSON_mUtils_mViews_mCore.View__.Length(Lit(v'#0))))), Lit(JSON_mUtils_mViews_mWriters.Chain.Append(Lit(JSON_mUtils_mViews_mWriters.Writer__.chain(Lit(this))), Lit(v'#0))))));

axiom (forall $Heap: Heap, this: DatatypeType, fn#0: HandleType :: { JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0) } JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, this, fn#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap) && $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $IsAlloc(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this) && Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))) ==> $Is(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $Heap: Heap, this: DatatypeType, fn#0: HandleType :: { JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, this, fn#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__()) && $IsAlloc(this, Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap) && $Is(fn#0, Tclass._System.___hFunc1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && JSON_mUtils_mViews_mWriters.Writer__.Valid_q(this) && Requires1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))) ==> JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, this, fn#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, fn#0, $Box(this))): DatatypeType);

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#8: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#8)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#18 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#19 := Seq#Append(digits'#18, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#19))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#19 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#20 := Seq#Append(digits'#19, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#20))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#20 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#21 := Seq#Append(digits'#20, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#21))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#8: Box :: { Seq#Contains(chars#0, c#8) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#8) } $IsBox(c#8, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#8) ==> Seq#Contains(chars#0, c#8)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#17: int :: { Seq#Contains(digits#0, $Box(d#17)) } Seq#Contains(digits#0, $Box(d#17)) ==> LitInt(0) <= d#17 && d#17 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#17: int :: { Seq#Contains(digits#0, $Box(d#17)) } Seq#Contains(digits#0, $Box(d#17)) ==> LitInt(0) <= d#17 && d#17 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#18: int :: { Seq#Contains(digits#0, $Box(d#18)) } Seq#Contains(digits#0, $Box(d#18)) ==> LitInt(0) <= d#18 && d#18 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#8: Box :: { Seq#Contains(chars#0, c#8) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#8) } $IsBox(c#8, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#8) ==> Seq#Contains(chars#0, c#8)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#12 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#12) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#12), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#12 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#12), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#13 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#13) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#13), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#13 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#13), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#20: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#20)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#20) } $IsBox(c#20, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#20) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#20)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#21: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#21)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#21) } $IsBox(c#21, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#21) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#21)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#22: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#22)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#22) } $IsBox(c#22, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#22) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#22)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(Seq#Contains(chars#0, $l#12#c#0))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#15: Box :: { Map#Domain(digits#0)[c#15] } { Seq#Contains(str#0, c#15) } $IsBox(c#15, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#15) ==> Map#Domain(digits#0)[c#15])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#15: Box :: { Map#Domain(digits#0)[c#15] } { Seq#Contains(str#0, c#15) } $IsBox(c#15, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#15) ==> Map#Domain(digits#0)[c#15])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#16: Box :: { Map#Domain(digits#0)[c#16] } { Seq#Contains(str#0, c#16) } $IsBox(c#16, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#16) ==> Map#Domain(digits#0)[c#16])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(Map#Domain(digits#0)[$l#29#c#0])), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(Map#Domain(digits#0)[$l#29#c#0])), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(Map#Domain(digits#0)[$l#30#c#0])), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(Map#Domain(digits#0)[$l#31#c#0])), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#18 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#18) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#18)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#18)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#18 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#18) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#18) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#18)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#18) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#18))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#18 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#18) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#18) else (var tl#36 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#18)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#36)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#18 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#18) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#18) else (var tl#37 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#18)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#37)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#19 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#19) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#19)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#19)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#19 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#19) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#19) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#19)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#19) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#19))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#19 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#19) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#19) else (var tl#38 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#19)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#38)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#19 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#19) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#19) else (var tl#39 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#19)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#39)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#20 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#20) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#20) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#20)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#20) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#20)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#20 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#20) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#20) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#20)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#20) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#20))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#20 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#20) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#20) else (var tl#40 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#20)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#40)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#20 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#20) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#20) else (var tl#41 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#20)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#41)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#8: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#8)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#8)) ==> LitInt(0) <= d#8 && d#8 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#18 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#19 := Seq#Append(digits'#18, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#19))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#19 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#20 := Seq#Append(digits'#19, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#20))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#20 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#21 := Seq#Append(digits'#20, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#21))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#8: char :: { Seq#Contains(chars#0, $Box(c#8)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#8)) ==> Seq#Contains(chars#0, $Box(c#8))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#17: int :: { Seq#Contains(digits#0, $Box(d#17)) } Seq#Contains(digits#0, $Box(d#17)) ==> LitInt(0) <= d#17 && d#17 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#17: int :: { Seq#Contains(digits#0, $Box(d#17)) } Seq#Contains(digits#0, $Box(d#17)) ==> LitInt(0) <= d#17 && d#17 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#18: int :: { Seq#Contains(digits#0, $Box(d#18)) } Seq#Contains(digits#0, $Box(d#18)) ==> LitInt(0) <= d#18 && d#18 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#8: char :: { Seq#Contains(chars#0, $Box(c#8)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#8)) ==> Seq#Contains(chars#0, $Box(c#8))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#12 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#12) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#12), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#12 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#12), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#13 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#13) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#13), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#13 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#13), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#20: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#20))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#20)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#20))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#21: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#21))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#21)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#21))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#22: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#22))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#22)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#22))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(Seq#Contains(chars#0, $l#12#c#0))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar)), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#15: char :: { Map#Domain(digits#0)[$Box(c#15)] } { Seq#Contains(str#0, $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(str#0, $Box(c#15)) ==> Map#Domain(digits#0)[$Box(c#15)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#15: char :: { Map#Domain(digits#0)[$Box(c#15)] } { Seq#Contains(str#0, $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(str#0, $Box(c#15)) ==> Map#Domain(digits#0)[$Box(c#15)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#16: char :: { Map#Domain(digits#0)[$Box(c#16)] } { Seq#Contains(str#0, $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(str#0, $Box(c#16)) ==> Map#Domain(digits#0)[$Box(c#16)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(Map#Domain(digits#0)[$l#29#c#0])), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(Map#Domain(digits#0)[$l#29#c#0])), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(Map#Domain(digits#0)[$l#30#c#0])), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar)), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(Map#Domain(digits#0)[$l#31#c#0])), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, TChar)), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#18 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#18) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#18)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#18)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#18 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#18) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#18) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#18)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#18) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#18))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#18 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#18) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#18) else (var tl#36 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#18)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#36)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#18 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#18) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#18) else (var tl#37 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#18)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#37)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#19 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#19) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#19)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#19)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#19 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#19) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#19) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#19)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#19) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#19))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#19 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#19) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#19) else (var tl#38 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#19)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#38)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#19 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#19) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#19) else (var tl#39 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#19)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#39)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#20 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#20) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#20) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#20)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#20) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#20)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#20 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#20) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#20) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#20)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#20) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#20))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#20 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#20) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#20) else (var tl#40 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#20)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#40)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#20 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#20) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#20) else (var tl#41 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#20)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#41)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#7: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#7)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#7)) } $Is(c#7, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#7)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#7))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#10#c#0))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, TChar)), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#13: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)] } { Seq#Contains(str#0, $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(str#0, $Box(c#13)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#13: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)] } { Seq#Contains(str#0, $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(str#0, $Box(c#13)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#13)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#14: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#14)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#14)] } { Seq#Contains(str#0, $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(str#0, $Box(c#14)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#14)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#14)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#23#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#23#c#0]): int < base#0)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#23#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#23#c#0]): int < base#0)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#24#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#24#c#0]): int < base#0)), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, TChar)), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#16 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#16)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#32 := JSON_mErrors.DeserializationError.b(this); (var b0#16 := JSON_mErrors.DeserializationError.expected(this); (var c#32 := (if b#32 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#32)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#16)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#32)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#33 := JSON_mErrors.DeserializationError.b(this); (var bs0#16 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#33 := (if b#33 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#33)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#16 := Seq#Create(TChar, $Heap, Seq#Length(bs0#16), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#16, $Unbox($l#28#idx#0): int)): int))), (lambda $l#28#heap#0: Heap, $l#28#idx#0: Box :: $IsBox($l#28#idx#0, TInt) && LitInt(0) <= $Unbox($l#28#idx#0): int && $Unbox($l#28#idx#0): int < Seq#Length(bs0#16)), (lambda $l#28#heap#0: Heap, $l#28#idx#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#16), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#33))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#18 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#18)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#36 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#18 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#36 := (if b#36 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#36)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#18)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#36)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#37 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#18 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#37 := (if b#37 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#37)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#18 := Seq#Create(TChar, $Heap, Seq#Length(bs0#18), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#18, $Unbox($l#31#idx#0): int)): int))), (lambda $l#31#heap#0: Heap, $l#31#idx#0: Box :: $IsBox($l#31#idx#0, TInt) && LitInt(0) <= $Unbox($l#31#idx#0): int && $Unbox($l#31#idx#0): int < Seq#Length(bs0#18)), (lambda $l#31#heap#0: Heap, $l#31#idx#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#18), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#37))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#17 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#17, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#16 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#16, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#16 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#16)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#19 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#19, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#18 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#18, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#18 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#18)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#12: int :: { JSON_mGrammar.__default.Blank_q(b#12) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) } LitInt(0) <= b#12 && b#12 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#12))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#12: int :: { JSON_mGrammar.__default.Blank_q(b#12) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) } LitInt(0) <= b#12 && b#12 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) ==> JSON_mGrammar.__default.Blank_q(b#12))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#13: int :: { JSON_mGrammar.__default.Blank_q(b#13) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#13)) } LitInt(0) <= b#13 && b#13 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#13)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#13))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#13: int :: { JSON_mGrammar.__default.Blank_q(b#13) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#13)) } LitInt(0) <= b#13 && b#13 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#13)) ==> JSON_mGrammar.__default.Blank_q(b#13))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#12: int :: { $Unbox(Seq#Index(s#0, idx#12)): DatatypeType } LitInt(0) <= idx#12 && idx#12 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#12)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#12: int :: { $Unbox(Seq#Index(s#0, idx#12)): DatatypeType } LitInt(0) <= idx#12 && idx#12 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#12)): DatatypeType)) <==> idx#12 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#13: int :: { $Unbox(Seq#Index(s#0, idx#13)): DatatypeType } LitInt(0) <= idx#13 && idx#13 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#13)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#13: int :: { $Unbox(Seq#Index(s#0, idx#13)): DatatypeType } LitInt(0) <= idx#13 && idx#13 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#13)): DatatypeType)) <==> idx#13 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#12: int :: { JSON_mGrammar.__default.Digit_q(b#12) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) } LitInt(0) <= b#12 && b#12 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#12))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#12: int :: { JSON_mGrammar.__default.Digit_q(b#12) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) } LitInt(0) <= b#12 && b#12 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#12)) ==> JSON_mGrammar.__default.Digit_q(b#12))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#13: int :: { JSON_mGrammar.__default.Digit_q(b#13) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#13)) } LitInt(0) <= b#13 && b#13 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#13)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#13))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#13: int :: { JSON_mGrammar.__default.Digit_q(b#13) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#13)) } LitInt(0) <= b#13 && b#13 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#13)) ==> JSON_mGrammar.__default.Digit_q(b#13))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#9: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#9) } { Seq#Contains(ts#0, d#9) } $IsBox(d#9, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#9) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#9))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#9: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#9) } { Seq#Contains(ts#0, d#9) } $IsBox(d#9, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#9) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#9))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#10: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#10) } { Seq#Contains(ts#0, d#10) } $IsBox(d#10, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#10) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#10))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#11: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#11) } { Seq#Contains(ts#0, d#11) } $IsBox(d#11, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#11) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#11))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#9: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#9)) } $Is(d#9, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#9) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#9)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#9: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#9)) } $Is(d#9, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#9) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#9)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#10: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#10)) } $Is(d#10, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#10) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#10)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#11: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#11)) } $Is(d#11, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#11) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#11)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#20#d#0: DatatypeType :: $Is($l#20#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#20#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#20#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#21#ly#0, $Unbox($l#21#d#0): DatatypeType))), (lambda $l#21#heap#0: Heap, $l#21#d#0: Box :: $IsBox($l#21#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#21#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#21#heap#0: Heap, $l#21#d#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#19#ly#0, $Unbox($l#19#d#0): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#d#0: Box :: $IsBox($l#19#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#19#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#19#heap#0: Heap, $l#19#d#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#23#d#0: DatatypeType :: $Is($l#23#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#23#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#23#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#24#ly#0, $Unbox($l#24#d#0): DatatypeType))), (lambda $l#24#heap#0: Heap, $l#24#d#0: Box :: $IsBox($l#24#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#24#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#24#heap#0: Heap, $l#24#d#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#22#ly#0, $Unbox($l#22#d#0): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#d#0: Box :: $IsBox($l#22#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#22#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#22#heap#0: Heap, $l#22#d#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#20#d#0: DatatypeType :: $Is($l#20#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#20#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#20#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#21#ly#0, $Unbox($l#21#d#0): DatatypeType))), (lambda $l#21#heap#0: Heap, $l#21#d#0: Box :: $IsBox($l#21#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#21#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#21#heap#0: Heap, $l#21#d#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#19#ly#0, $Unbox($l#19#d#0): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#d#0: Box :: $IsBox($l#19#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#19#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#19#heap#0: Heap, $l#19#d#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#23#d#0: DatatypeType :: $Is($l#23#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#23#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#23#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#24#ly#0, $Unbox($l#24#d#0): DatatypeType))), (lambda $l#24#heap#0: Heap, $l#24#d#0: Box :: $IsBox($l#24#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#24#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#24#heap#0: Heap, $l#24#d#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#22#ly#0, $Unbox($l#22#d#0): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#d#0: Box :: $IsBox($l#22#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#22#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#22#heap#0: Heap, $l#22#d#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#9 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#9))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#9 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#9))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#9 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#9))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#9 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#9))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#9 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#9))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#9 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#9))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#8 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#8)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#8 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#8)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#8 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#8)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#8 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#8)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#8 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#8)) else (var arr#8 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#8))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#11 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#11))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#11 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#11))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#11 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#11))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#11 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#11))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#11 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#11))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#11 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#11))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#10 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#10))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#10 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#10))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#10 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#10))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#10 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#10))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#10 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#10))) else (var arr#10 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#10)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$2x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$2x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#15: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#15)) } $Is(d#15, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#15) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#15))) && ((forall d#15: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#15)) } $Is(d#15, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#15) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#15))) ==> (forall d#16: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#16)) } $Is(d#16, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#16) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#16)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#15: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#15)) } $Is(d#15, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#15) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#15))) && (forall d#16: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#16)) } $Is(d#16, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#16) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#16))) && (forall d#17: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#17))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#17))): Seq } $Is(d#17, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#17) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#17))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#17))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#18: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#18)) } $Is(d#18, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#18) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#18))) && ((forall d#18: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#18)) } $Is(d#18, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#18) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#18))) ==> (forall d#19: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#19)) } $Is(d#19, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#19) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#19)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#18: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#18)) } $Is(d#18, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#18) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#18))) && (forall d#19: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#19)) } $Is(d#19, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#19) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#19))) && (forall d#20: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#20))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#20))): Seq } $Is(d#20, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#20) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#20))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#20))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#21: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#21)) } $Is(d#21, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#21) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#21))) && ((forall d#21: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#21)) } $Is(d#21, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#21) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#21))) ==> (forall d#22: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#22)) } $Is(d#22, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#22) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#22)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#21: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#21)) } $Is(d#21, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#21) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#21))) && (forall d#22: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#22)) } $Is(d#22, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#22) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#22))) && (forall d#23: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#23))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#23))): Seq } $Is(d#23, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#23) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#23))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#23))): Seq))));

const reveal_JSON.ZeroCopy.Deserializer.Core._default.Get: bool;

const reveal_JSON.ZeroCopy.Deserializer.Core._default.WS: bool;

const reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mCore.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(): HandleType == Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($l#0#v#0): DatatypeType))), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: $IsBox($l#0#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#0#heap#0: Heap, $l#0#v#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.SpecView (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal: bool, cs#0: DatatypeType, err#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jchar(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))))));
}

function JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0: DatatypeType, err#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mCore.__default.Get#requires(DatatypeType, DatatypeType) : bool;

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get#requires(cs#0, err#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError()) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Get#requires(cs#0, err#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.Get (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.Get(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), err#0: DatatypeType where $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24630"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jchar(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Core.Get (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.Get(cs#0: DatatypeType, err#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##err#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.Get", " | ", cs#0, " | ", err#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(33,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Get(reveal_JSON.ZeroCopy.Deserializer.Core._default.Get, cs#0, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jchar(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jchar(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jchar(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jchar(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##err#0 := err#0;
    assume $IsAlloc(##err#0, Tclass.JSON_mErrors.DeserializationError(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0));
    assume JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Get(reveal_JSON.ZeroCopy.Deserializer.Core._default.Get, cs#0, err#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Get(reveal_JSON.ZeroCopy.Deserializer.Core._default.Get, cs#0, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Get(reveal_JSON.ZeroCopy.Deserializer.Core._default.Get, cs#0, err#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Get(reveal_JSON.ZeroCopy.Deserializer.Core._default.Get, cs#0, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Get(reveal_JSON.ZeroCopy.Deserializer.Core._default.Get, cs#0, err#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) || (1 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jblanks(), JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0)), cs#0) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0)), cs#0)) && (JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0)), JSON_mUtils_mCursors.Cursor__.Suffix(cs#0))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())) && JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(cs#0), JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Blank_q#Handle())) && JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, Lit(cs#0)) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Blank_q#Handle())));
}

function JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mCore.__default.WS#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.WS#requires(cs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.WS#requires(cs#0) <==> true));

function JSON_mGrammar.__default.Blank_q#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$0x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$0x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$0x#0): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$0x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$0x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$0x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$0x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$0x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$0x#0))): bool);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24648"} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jblanks(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
  free ensures {:id "id24649"} JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
  free ensures {:id "id24650"} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
  free ensures {:id "id24651"} JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), JSON_mUtils_mCursors.Cursor__.Suffix(cs#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType) returns (sp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##other#0: DatatypeType;
  var ##other#1: DatatypeType;
  var ##other#2: DatatypeType;
  var ##p#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.WS", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(40,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jblanks(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jblanks(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jblanks(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(sp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#1 := cs#0;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
    goto anon5;

  anon11_Else:
    assume !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0);
    goto anon5;

  anon5:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Suffix#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.Suffix(cs#0));
    ##other#2 := JSON_mUtils_mCursors.Cursor__.Suffix(cs#0);
    assume $IsAlloc(##other#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#0));
    assume JSON_mUtils_mCursors.Cursor__.SuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#0), JSON_mUtils_mCursors.Cursor__.Suffix(cs#0));
    assume JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), JSON_mUtils_mCursors.Cursor__.Suffix(cs#0));
    goto anon8;

  anon12_Else:
    assume JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), JSON_mUtils_mCursors.Cursor__.Suffix(cs#0));
    goto anon8;

  anon8:
    assume false;
    return;

  anon10_Else:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume true;
    ##p#0 := JSON_mGrammar.__default.Blank_q#Handle();
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle());
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0) == sp#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns (defass#sp#0: bool, sp#0: DatatypeType where defass#sp#0 ==> $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks())) && $IsAlloc(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()), $Heap), $_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mCursors.Split(sp#0) && $IsA#JSON_mUtils_mCursors.Split(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)) && JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
  free ensures {:id "id24670"} JSON_mUtils_mCursors.Split#Equal(sp#0, JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType) returns (defass#sp#0: bool, sp#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var point'#0: int where LitInt(0) <= point'#0 && point'#0 < BoundedInts.__default.TWO__TO__THE__32();
  var end#0: int where LitInt(0) <= end#0 && end#0 < BoundedInts.__default.TWO__TO__THE__32();
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#sp#0: bool;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#point#0#Z#0: int;
  var let#1#0#0: int;
  var dt_update_tmp#1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var dt_update#point#1#Z#0: int;
  var let#3#0#0: int;
  var ##p#1: HandleType;
  var ##p#2: HandleType;
  var ##b#0: int;
  var $decr$loop#00: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.WS", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(47,16): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__WS();
    call CallPost$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__WS();
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(48,16)"} true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    point'#0 := JSON_mUtils_mCursors.Cursor__.point(cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(49,28)"} true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    end#0 := JSON_mUtils_mCursors.Cursor__.end(cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(50,23)"} true;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#sp#0 := defass#sp#0;
    $decr_init$loop#00 := end#0 - point'#0;
    havoc $w$loop#0;
    goto anon10_LoopHead;

  anon10_LoopHead:
    assume $w$loop#0 ==> (var dt_update_tmp#0#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume $w$loop#0 ==> JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := cs#0; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    assume $w$loop#0 ==> $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle())) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())) && (var dt_update_tmp#1#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle());
    assume $w$loop#0 ==> JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle()), JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#sp#0 ==> defass#sp#0;
    assume end#0 - point'#0 <= $decr_init$loop#00;
    goto anon10_LoopDone, anon10_LoopBody;

  anon10_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(51,6): after some loop iterations"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume {:partition} !$w$loop#0;
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume let#0#0#0 == cs#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#point#0#Z#0;
    assume LitInt(0) <= dt_update#point#0#Z#0 && dt_update#point#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == point'#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume (var dt_update_tmp#0#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := cs#0; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    havoc dt_update_tmp#1#Z#0;
    assume $Is(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume let#2#0#0 == cs#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume dt_update_tmp#1#Z#0 == let#2#0#0;
    havoc dt_update#point#1#Z#0;
    assume LitInt(0) <= dt_update#point#1#Z#0 && dt_update#point#1#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#3#0#0 == point'#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#1#Z#0 == let#3#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume $IsAllocBox($Box((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume true;
    ##p#1 := JSON_mGrammar.__default.Blank_q#Handle();
    assume $IsAlloc(##p#1, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle());
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle()));
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume true;
    ##p#2 := JSON_mGrammar.__default.Blank_q#Handle();
    assume $IsAlloc(##p#2, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle());
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle())) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())) && (var dt_update_tmp#1#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle());
    assume JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle()), JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    assume true;
    assume false;
    goto anon3;

  anon11_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} point'#0 < end#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume 0 <= point'#0 && point'#0 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(cs#0));
    ##b#0 := $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(cs#0), point'#0)): int;
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume JSON_mGrammar.__default.Blank_q#canCall($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(cs#0), point'#0)): int);
    goto anon5;

  anon12_Else:
    assume {:partition} end#0 <= point'#0;
    goto anon5;

  anon5:
    assume point'#0 < end#0 ==> JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0) && JSON_mGrammar.__default.Blank_q#canCall($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(cs#0), point'#0)): int);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} !(point'#0 < end#0 && JSON_mGrammar.__default.Blank_q($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(cs#0), point'#0)): int));
    goto anon8;

  anon13_Else:
    assume {:partition} point'#0 < end#0 && JSON_mGrammar.__default.Blank_q($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(cs#0), point'#0)): int);
    $decr$loop#00 := end#0 - point'#0;
    push;
    assume true;
    newtype$check#0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__32();
    newtype$check#0_1 := point'#0 + 1;
    assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__32();
    assume true;
    point'#0 := point'#0 + 1;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(55,28)"} true;
    pop;
    assume 0 <= $decr$loop#00 || end#0 - point'#0 == $decr$loop#00;
    assume end#0 - point'#0 < $decr$loop#00;
    assume (var dt_update_tmp#0#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && (JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := cs#0; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0))))) ==> $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle())) && $IsA#JSON_mUtils_mCursors.Cursor__(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())) && (var dt_update_tmp#1#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle()));
    goto anon10_LoopHead;

  anon10_LoopDone:
    assume {:partition} false;
    goto anon8;

  anon8:
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0))));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0) && JSON_mUtils_mCursors.Cursor__.Split#canCall(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    sp#0 := JSON_mUtils_mCursors.Cursor__.Split(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    defass#sp#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(57,57)"} true;
    assume defass#sp#0;
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
    return;
}



function JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, cs#0: DatatypeType, parser#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#0#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#0#heap#0: Heap, $l#0#st#0: Box :: $IsBox($l#0#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#0#heap#0: Heap, $l#0#st#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#2)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#3 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#0 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#3))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#4 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#4))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#0, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#0 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#3))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#0) else (var val#0, cs#4 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); (var after#0, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#4))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#4)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#0, val#0, after#0)), cs#5)))))))));
axiom 3 <= $FunctionContextHeight ==> (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#6: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#6)) } $Is(cs#6, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#6)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#7 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#1 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#7))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#8 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#8))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#1, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#1 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#7))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#1) else (var val#1, cs#8 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); (var after#1, cs#9 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#8))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#8)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#1, val#1, after#1)), cs#9)))))))));
}

function JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, cs#0: DatatypeType, parser#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(Ty, DatatypeType, DatatypeType) : bool;

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#2)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.Structural (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), parser#0: DatatypeType where $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()))) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24702"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#1#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $IsBox($l#1#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Core.Structural (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, cs#0: DatatypeType, parser#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var cs#10: DatatypeType;
  var ##x0#0: DatatypeType;
  var b$reqreads#0: bool;
  var $lambdaHeap#0: Heap;
  var st#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var before#Z#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var val#Z#0: Box;
  var cs#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;
  var after#Z#0: DatatypeType;
  var cs#Z#2: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##cs#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.Structural", " | ", JSON.ZeroCopy.Deserializer.Core._default.Structural$T, " | ", cs#0, " | ", parser#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    b$reqreads#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(60,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    havoc cs#10;
    assume $Is(cs#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#10, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(parser#0);
    assume $IsAllocBox($Box(JSON_mUtils_mParsers.Parser__.fn(parser#0)), Tclass._System.___hFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))), $Heap);
    ##x0#0 := cs#10;
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    b$reqreads#0 := (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(##x0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#10));
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#10));
    assume (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)));
    assume b$reqreads#0;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), $Heap);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc st#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Is(st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(parser#0);
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $lambdaHeap#0);
    ##fT#0 := JSON_mUtils_mParsers.Parser__.spec(parser#0);
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, st#0, JSON_mUtils_mParsers.Parser__.spec(parser#0));
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, st#0, JSON_mUtils_mParsers.Parser__.spec(parser#0));
    assume JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, st#0, JSON_mUtils_mParsers.Parser__.spec(parser#0));
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon6;

  anon17_Else:
    assume {:partition} !($Is(st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon16_Else:
    goto anon7;

  anon7:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#3#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#4#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: $IsBox($l#4#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#5#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    goto anon9;

  anon15_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#6#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    goto anon9;

  anon9:
    assume false;
    return;

  anon14_Else:
    havoc before#Z#0;
    havoc cs#Z#0;
    assume $Is(before#Z#0, Tclass.JSON_mGrammar.jblanks()) && $IsAlloc(before#Z#0, Tclass.JSON_mGrammar.jblanks(), $Heap) && $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#0#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(before#Z#0), cs#Z#0) == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Parser_q(parser#0);
    assume let#1#0#0 == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#Z#0))): DatatypeType;
    assume JSON_mUtils_mParsers.Parser__.Parser_q(parser#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, parser#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc val#Z#0;
    havoc cs#Z#1;
    assume $IsBox(val#Z#0, JSON.ZeroCopy.Deserializer.Core._default.Structural$T) && $IsAllocBox(val#Z#0, JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Heap) && $Is(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T));
    assume JSON_mUtils_mCursors.Split.SP_q(let#2#0#0);
    assume #JSON.Utils.Cursors.Split.SP(val#Z#0, cs#Z#1) == let#2#0#0;
    havoc after#Z#0;
    havoc cs#Z#2;
    assume $Is(after#Z#0, Tclass.JSON_mGrammar.jblanks()) && $IsAlloc(after#Z#0, Tclass.JSON_mGrammar.jblanks(), $Heap) && $Is(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##cs#1 := cs#Z#1;
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#Z#1));
    assume let#3#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#Z#1);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#Z#1);
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#3#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(after#Z#0), cs#Z#2) == let#3#0#0;
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, parser#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#Z#0, val#Z#0, after#Z#0)), cs#Z#2)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon13:
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, parser#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#0#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#st#0: Box :: $IsBox($l#0#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#0#heap#0: Heap, $l#0#st#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));
axiom 3 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#1 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#1) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#1)) && (var cs#2 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#1))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#2))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#0, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#0, cs#2 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#1)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#1))); (var after#0, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#2))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#2)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#0, $Box(val#0), after#0)), cs#3)))));
axiom 3 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#4 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#4) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#4)) && (var cs#5 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#4))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#5))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#1, cs#4 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#1, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#4)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#4))); (var after#1, cs#6 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#5))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#5)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#1, $Box(val#1), after#1)), cs#6)))));
}

function JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0: DatatypeType) : bool;

function Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()) == Tagclass.JSON_mZeroCopy_mDeserializer_mCore.jopt && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()) == tytagFamily$jopt;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mCore.jopt: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()));

function JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.TryStructural (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24724"} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), sp#0, cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#1#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $IsBox($l#1#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Core.TryStructural (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0: DatatypeType) returns (sp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var st#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var before#Z#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var val#Z#0: DatatypeType;
  var cs#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var after#Z#0: DatatypeType;
  var cs#Z#2: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##cs#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.TryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(73,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc st#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon5;

  anon10_Else:
    assume {:partition} !($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), $lambdaHeap#0));
    goto anon5;

  anon5:
    assume false;
    goto anon6;

  anon9_Else:
    goto anon6;

  anon6:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), sp#0, cs#0, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#4#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: $IsBox($l#4#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), sp#0, cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume false;
    return;

  anon8_Else:
    havoc before#Z#0;
    havoc cs#Z#0;
    assume $Is(before#Z#0, Tclass.JSON_mGrammar.jblanks()) && $IsAlloc(before#Z#0, Tclass.JSON_mGrammar.jblanks(), $Heap) && $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#0#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(before#Z#0), cs#Z#0) == let#0#0#0;
    havoc val#Z#0;
    havoc cs#Z#1;
    assume $Is(val#Z#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(val#Z#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0)));
    assume let#1#0#0 == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#Z#0) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#Z#0));
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#1#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(val#Z#0), cs#Z#1) == let#1#0#0;
    havoc after#Z#0;
    havoc cs#Z#2;
    assume $Is(after#Z#0, Tclass.JSON_mGrammar.jblanks()) && $IsAlloc(after#Z#0, Tclass.JSON_mGrammar.jblanks(), $Heap) && $Is(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##cs#1 := cs#Z#1;
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#Z#1));
    assume let#2#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#Z#1);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#Z#1);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#2#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(after#Z#0), cs#Z#2) == let#2#0#0;
    assume $Is(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#Z#0, $Box(val#Z#0), after#Z#0)), cs#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#Z#0, $Box(val#Z#0), after#Z#0)), cs#Z#2);
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == sp#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0: DatatypeType) : bool
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#0) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#0))): Seq } $Is(t#0, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#0)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#0) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#0))): Seq } $Is(t#0, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#0))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#0)))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#1: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#1) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#1))): Seq } $Is(t#1, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#1)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#1: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#1) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#1))): Seq } $Is(t#1, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#1))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#1)))));
}

function JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#requires(sp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#requires(sp#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.ValueParserValid (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_Get (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__Get();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_Get (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__Get();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_Get (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__Get();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Core._default.Get;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_WS (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__WS();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_WS (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__WS();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_WS (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__WS();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Core._default.WS;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_Structural (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__Structural();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_Structural (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__Structural();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.reveal_Structural (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mCore.__default.reveal__Structural();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks())) && $IsAlloc(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks())) && $IsAlloc(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks()), $Heap));
  modifies $Heap;
  free ensures $IsA#JSON_mUtils_mCursors.Split(sp#0) && $IsA#JSON_mUtils_mCursors.Split(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)) && JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0);
  free ensures {:id "id24740"} JSON_mUtils_mCursors.Split#Equal(sp#0, JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.jopt (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.jopt(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Core.jopt (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.jopt(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var ##bs#0: Seq;
  var newtype$check#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.jopt", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(71,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall(v#0);
    newtype$check#0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.Length(v#0) <= LitInt(1);
    return;

  anon4_Else:
    ##bs#0 := Lit(Seq#Empty(): Seq);
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq));
    assume JSON_mUtils_mViews_mCore.View__.View_q(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    newtype$check#1 := Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq)));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#1);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(Seq#Empty(): Seq)) && JSON_mUtils_mViews_mCore.View__.Length#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))));
    assume LitInt(JSON_mUtils_mViews_mCore.View__.Length(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(Seq#Empty(): Seq))))) <= LitInt(1);
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Length(v#0) <= LitInt(1));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Core.ValueParser (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mCore.ValueParser(sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) == Tagclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) == tytagFamily$ValueParser;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()));

axiom (forall sp#0: DatatypeType :: { $Is(sp#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) } $Is(sp#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) <==> $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError())) && JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0));

axiom (forall sp#0: DatatypeType, $h: Heap :: { $IsAlloc(sp#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $h) } $IsAlloc(sp#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $h) <==> $IsAlloc(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#212 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#212))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#214 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#214)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#318 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#318))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#320 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#320)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#322 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#322)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#318 := Wrappers.Option.value(this); v#318)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#320 := Lit(Wrappers.Option.value(Lit(this))); v#320)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#322 := Lit(Wrappers.Option.value(Lit(this))); v#322)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#212 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#212)) else (var e#212 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#214 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#214))) else (var e#214 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#318 := Wrappers.Result.value(this); s#318) else (var e#318 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#320 := Lit(Wrappers.Result.value(Lit(this))); s#320) else (var e#320 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#322 := Lit(Wrappers.Result.value(Lit(this))); s#322) else (var e#322 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#318 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#318)) else (var e#318 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#318)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#320 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#320))) else (var e#320 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#320)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#322 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#322))) else (var e#322 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#322)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#114: int, y#114: int :: { Mul(x#114, y#114) } Mul(x#114, y#114) == Mul(y#114, x#114)) && (forall x#115: int, y#115: int, z#76: int :: { Mul(x#115 + y#115, z#76) } Mul(x#115 + y#115, z#76) == Mul(x#115, z#76) + Mul(y#115, z#76)) && (forall x#116: int, y#116: int, z#77: int :: { Mul(x#116 - y#116, z#77) } Mul(x#116 - y#116, z#77) == Mul(x#116, z#77) - Mul(y#116, z#77));

axiom MulInternals.__default.MulAuto() <==> (forall x#117: int, y#117: int :: { Mul(x#117, y#117) } Mul(x#117, y#117) == Mul(y#117, x#117)) && (forall x#118: int, y#118: int, z#78: int :: { Mul(x#118 + y#118, z#78) } Mul(x#118 + y#118, z#78) == Mul(x#118, z#78) + Mul(y#118, z#78)) && (forall x#119: int, y#119: int, z#79: int :: { Mul(x#119 - y#119, z#79) } Mul(x#119 - y#119, z#79) == Mul(x#119, z#79) - Mul(y#119, z#79));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#136: int :: { Mod(Mod(x#136, n#0), n#0) } Mod(Mod(x#136, n#0), n#0) == Mod(x#136, n#0)) && (forall x#137: int :: { Mod(x#137, n#0) } LitInt(0) <= x#137 && x#137 < n#0 <==> Mod(x#137, n#0) == x#137) && (forall x#138: int, y#68: int :: { Mod(x#138 + y#68, n#0) } (var z#66 := Mod(x#138, n#0) + Mod(y#68, n#0); (LitInt(0) <= z#66 && z#66 < n#0 && Mod(x#138 + y#68, n#0) == z#66) || (n#0 <= z#66 && z#66 < n#0 + n#0 && Mod(x#138 + y#68, n#0) == z#66 - n#0))) && (forall x#139: int, y#69: int :: { Mod(x#139 - y#69, n#0) } (var z#67 := Mod(x#139, n#0) - Mod(y#69, n#0); (LitInt(0) <= z#67 && z#67 < n#0 && Mod(x#139 - y#69, n#0) == z#67) || (0 - n#0 <= z#67 && z#67 < 0 && Mod(x#139 - y#69, n#0) == z#67 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#140: int :: { Mod(Mod(x#140, n#0), n#0) } Mod(Mod(x#140, LitInt(n#0)), LitInt(n#0)) == Mod(x#140, LitInt(n#0))) && (forall x#141: int :: { Mod(x#141, n#0) } LitInt(0) <= x#141 && x#141 < n#0 <==> Mod(x#141, LitInt(n#0)) == x#141) && (forall x#142: int, y#70: int :: { Mod(x#142 + y#70, n#0) } (var z#68 := Mod(x#142, LitInt(n#0)) + Mod(y#70, LitInt(n#0)); (LitInt(0) <= z#68 && z#68 < n#0 && Mod(x#142 + y#70, LitInt(n#0)) == z#68) || (LitInt(n#0) <= z#68 && z#68 < n#0 + n#0 && Mod(x#142 + y#70, LitInt(n#0)) == z#68 - n#0))) && (forall x#143: int, y#71: int :: { Mod(x#143 - y#71, n#0) } (var z#69 := Mod(x#143, LitInt(n#0)) - Mod(y#71, LitInt(n#0)); (LitInt(0) <= z#69 && z#69 < n#0 && Mod(x#143 - y#71, LitInt(n#0)) == z#69) || (LitInt(0 - n#0) <= z#69 && z#69 < 0 && Mod(x#143 - y#71, LitInt(n#0)) == z#69 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#96: int :: { Div(x#96, n#0) } LitInt(0) <= x#96 && x#96 < n#0 <==> Div(x#96, n#0) == LitInt(0)) && (forall x#97: int, y#64: int :: { Div(x#97 + y#64, n#0) } (var z#62 := Mod(x#97, n#0) + Mod(y#64, n#0); (LitInt(0) <= z#62 && z#62 < n#0 && Div(x#97 + y#64, n#0) == Div(x#97, n#0) + Div(y#64, n#0)) || (n#0 <= z#62 && z#62 < n#0 + n#0 && Div(x#97 + y#64, n#0) == Div(x#97, n#0) + Div(y#64, n#0) + 1))) && (forall x#98: int, y#65: int :: { Div(x#98 - y#65, n#0) } (var z#63 := Mod(x#98, n#0) - Mod(y#65, n#0); (LitInt(0) <= z#63 && z#63 < n#0 && Div(x#98 - y#65, n#0) == Div(x#98, n#0) - Div(y#65, n#0)) || (0 - n#0 <= z#63 && z#63 < 0 && Div(x#98 - y#65, n#0) == Div(x#98, n#0) - Div(y#65, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#99: int :: { Div(x#99, n#0) } LitInt(0) <= x#99 && x#99 < n#0 <==> Div(x#99, LitInt(n#0)) == LitInt(0)) && (forall x#100: int, y#66: int :: { Div(x#100 + y#66, n#0) } (var z#64 := Mod(x#100, LitInt(n#0)) + Mod(y#66, LitInt(n#0)); (LitInt(0) <= z#64 && z#64 < n#0 && Div(x#100 + y#66, LitInt(n#0)) == Div(x#100, LitInt(n#0)) + Div(y#66, LitInt(n#0))) || (LitInt(n#0) <= z#64 && z#64 < n#0 + n#0 && Div(x#100 + y#66, LitInt(n#0)) == Div(x#100, LitInt(n#0)) + Div(y#66, LitInt(n#0)) + 1))) && (forall x#101: int, y#67: int :: { Div(x#101 - y#67, n#0) } (var z#65 := Mod(x#101, LitInt(n#0)) - Mod(y#67, LitInt(n#0)); (LitInt(0) <= z#65 && z#65 < n#0 && Div(x#101 - y#67, LitInt(n#0)) == Div(x#101, LitInt(n#0)) - Div(y#67, LitInt(n#0))) || (LitInt(0 - n#0) <= z#65 && z#65 < 0 && Div(x#101 - y#67, LitInt(n#0)) == Div(x#101, LitInt(n#0)) - Div(y#67, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#20 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#20) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#20)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#20 := lv#0; (var dt_update#end#0#20 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#20), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#20), dt_update#end#0#20))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#21 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#21) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#21)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#21 := Lit(lv#0); (var dt_update#end#0#21 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#21)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#21)), dt_update#end#0#21)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#22: char :: { Seq#Contains(s#0, $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(s#0, $Box(c#22)) ==> char#ToInt(c#22) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#22: char :: { Seq#Contains(s#0, $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(s#0, $Box(c#22)) ==> char#ToInt(c#22) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#44#i#0): int)): char))), (lambda $l#44#heap#0: Heap, $l#44#i#0: Box :: $IsBox($l#44#i#0, TInt) && LitInt(0) <= $Unbox($l#44#i#0): int && $Unbox($l#44#i#0): int < Seq#Length(s#0)), (lambda $l#44#heap#0: Heap, $l#44#i#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#23: char :: { Seq#Contains(s#0, $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(s#0, $Box(c#23)) ==> char#ToInt(c#23) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#46#i#0): int)): char))), (lambda $l#46#heap#0: Heap, $l#46#i#0: Box :: $IsBox($l#46#i#0, TInt) && LitInt(0) <= $Unbox($l#46#i#0): int && $Unbox($l#46#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#46#heap#0: Heap, $l#46#i#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#24 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#12 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#24 := (if b#24 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#24)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#12)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#24)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#25 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#12 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#25 := (if b#25 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#25)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#12 := Seq#Create(TChar, $Heap, Seq#Length(bs0#12), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#12, $Unbox($l#22#idx#0): int)): int))), (lambda $l#22#heap#0: Heap, $l#22#idx#0: Box :: $IsBox($l#22#idx#0, TInt) && LitInt(0) <= $Unbox($l#22#idx#0): int && $Unbox($l#22#idx#0): int < Seq#Length(bs0#12)), (lambda $l#22#heap#0: Heap, $l#22#idx#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#12), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#25))))) else (var err#12 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#12)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#28 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#14 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#28 := (if b#28 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#28)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#14)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#28)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#29 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#14 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#29 := (if b#29 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#29)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#14 := Seq#Create(TChar, $Heap, Seq#Length(bs0#14), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#14, $Unbox($l#25#idx#0): int)): int))), (lambda $l#25#heap#0: Heap, $l#25#idx#0: Box :: $IsBox($l#25#idx#0, TInt) && LitInt(0) <= $Unbox($l#25#idx#0): int && $Unbox($l#25#idx#0): int < Seq#Length(bs0#14)), (lambda $l#25#heap#0: Heap, $l#25#idx#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#14), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#29))))) else (var err#14 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#14)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#32 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#16 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#32 := (if b#32 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#32)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#16)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#32)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#33 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#16 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#33 := (if b#33 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#33)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#16 := Seq#Create(TChar, $Heap, Seq#Length(bs0#16), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#16, $Unbox($l#28#idx#0): int)): int))), (lambda $l#28#heap#0: Heap, $l#28#idx#0: Box :: $IsBox($l#28#idx#0, TInt) && LitInt(0) <= $Unbox($l#28#idx#0): int && $Unbox($l#28#idx#0): int < Seq#Length(bs0#16)), (lambda $l#28#heap#0: Heap, $l#28#idx#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#16), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#33))))) else (var err#16 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#16)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#4: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#4)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#4)): int } LitInt(0) <= idx#4 && idx#4 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#4 && idx#4 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#4)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#4)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#4 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#4 := this; (var dt_update#beg#0#4 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#4), dt_update#beg#0#4, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#4), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#4)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#5 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#5 := Lit(this); (var dt_update#beg#0#5 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#5)), dt_update#beg#0#5, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#5)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#5)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#42#v#0): DatatypeType))), (lambda $l#42#heap#0: Heap, $l#42#v#0: Box :: $IsBox($l#42#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#42#heap#0: Heap, $l#42#v#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#43#v#0): DatatypeType))), (lambda $l#43#heap#0: Heap, $l#43#v#0: Box :: $IsBox($l#43#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#43#heap#0: Heap, $l#43#v#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#44#v#0): DatatypeType))), (lambda $l#44#heap#0: Heap, $l#44#v#0: Box :: $IsBox($l#44#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#44#heap#0: Heap, $l#44#v#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#4 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#4 := this; (var dt_update#point#0#4 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#4), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#4), dt_update#point#0#4, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#4)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#5 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#5 := Lit(this); (var dt_update#point#0#5 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#5)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#5)), dt_update#point#0#5, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#5)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#4 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#4)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#4 := this; (var dt_update#point#0#4 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#4), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#4), dt_update#point#0#4, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#4)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#5 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#5)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#5 := Lit(this); (var dt_update#point#0#5 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#5)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#5)), dt_update#point#0#5, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#5)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#4 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#4 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#4 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#4 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#4))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#5 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#5 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#5 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#5 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#5)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#9: int :: { Seq#Contains(bs#0, $Box(b#9)) } LitInt(0) <= b#9 && b#9 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#9)) ==> b#9 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#9: int :: { Seq#Contains(bs#0, $Box(b#9)) } LitInt(0) <= b#9 && b#9 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#9)) ==> b#9 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6) && (var ps#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#6, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#6) else (var ps#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#6, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#10: int :: { Seq#Contains(bs#0, $Box(b#10)) } LitInt(0) <= b#10 && b#10 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#10)) ==> b#10 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7) && (var ps#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#7, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#7) else (var ps#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#7, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#11: int :: { Seq#Contains(bs#0, $Box(b#11)) } LitInt(0) <= b#11 && b#11 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#11)) ==> b#11 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8) && (var ps#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#8, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#8) else (var ps#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#8, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#4: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#4)): int } LitInt(0) <= idx#4 && idx#4 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#4 && idx#4 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#4)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#14 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#14)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#13 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#13)))) else (var st#13 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#13))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#16 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#16)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#15 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#15)))) else (var st#15 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#15))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#18 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#18)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#17 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#17)))) else (var st#17 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#17))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty, $reveal: bool :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal) } JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal)) && $Is(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R)));

axiom (forall $Heap: Heap, JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty, $reveal: bool :: { $IsAlloc(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R), $Heap) } $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R), $Heap));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: $IsBox($l#16#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#16#heap#0: Heap, $l#16#_v0#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#17#heap#0: Heap, $l#17#_v1#0: Box :: $IsBox($l#17#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#17#heap#0: Heap, $l#17#_v1#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: $IsBox($l#20#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#21#heap#0: Heap, $l#21#_v1#0: Box :: $IsBox($l#21#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#21#heap#0: Heap, $l#21#_v1#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty, $reveal: bool :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal) } JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal)) && $Is(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R)));

axiom (forall $Heap: Heap, JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty, $reveal: bool :: { $IsAlloc(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R), $Heap) } $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, $reveal), Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R), $Heap));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#cs#0: Box :: $Box(Lit(false))), (lambda $l#24#heap#0: Heap, $l#24#cs#0: Box :: $IsBox($l#24#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#24#heap#0: Heap, $l#24#cs#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#25#heap#0: Heap, $l#25#cs#0: Box :: $IsBox($l#25#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#25#heap#0: Heap, $l#25#cs#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#26#heap#0: Heap, $l#26#_v2#0: Box :: $IsBox($l#26#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#26#heap#0: Heap, $l#26#_v2#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#cs#0: Box :: $Box(Lit(false))), (lambda $l#30#heap#0: Heap, $l#30#cs#0: Box :: $IsBox($l#30#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#30#heap#0: Heap, $l#30#cs#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#31#heap#0: Heap, $l#31#cs#0: Box :: $IsBox($l#31#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#31#heap#0: Heap, $l#31#cs#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#32#heap#0: Heap, $l#32#_v2#0: Box :: $IsBox($l#32#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#32#heap#0: Heap, $l#32#_v2#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#4: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#4))): DatatypeType } $Is(cs'#4, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#4))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#4))): DatatypeType)): DatatypeType, cs'#4, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#4: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#4))): DatatypeType } $Is(cs'#4, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#4))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#4))): DatatypeType)): DatatypeType, cs'#4, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#5: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#5))): DatatypeType } $Is(cs'#5, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType)): DatatypeType, cs'#5, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#5: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#5))): DatatypeType } $Is(cs'#5, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#5))): DatatypeType)): DatatypeType, cs'#5, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#12: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#12)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#12))): bool } $Is(cs'#12, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#12))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#12)))) && ((forall cs'#12: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#12)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#12))): bool } $Is(cs'#12, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#12))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#12))) ==> (forall cs'#13: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#13))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#13, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#13: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#13))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#13, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#13))): bool) ==> (forall cs'#14: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#14))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#14))): bool } $Is(cs'#14, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#14))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#14))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#14))): DatatypeType)): DatatypeType, cs'#14, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#12: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#12)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#12))): bool } $Is(cs'#12, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#12))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#12))) && (forall cs'#13: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#13))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#13, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#13, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#13))): bool) && (forall cs'#14: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#14))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#14))): bool } $Is(cs'#14, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#14))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#14))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#14))): DatatypeType)): DatatypeType, cs'#14, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#15: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#15)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#15))): bool } $Is(cs'#15, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#15))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#15)))) && ((forall cs'#15: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#15)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#15))): bool } $Is(cs'#15, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#15))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#15))) ==> (forall cs'#16: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#16))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#16, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#16, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#16, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#16, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#16: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#16))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#16, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#16, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#16, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#16))): bool) ==> (forall cs'#17: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#17))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#17))): bool } $Is(cs'#17, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#17))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType)): DatatypeType, cs'#17, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#15: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#15)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#15))): bool } $Is(cs'#15, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#15))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#15))) && (forall cs'#16: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#16))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#16, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#16, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#16, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#16))): bool) && (forall cs'#17: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#17))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#17))): bool } $Is(cs'#17, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#17))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType)): DatatypeType, cs'#17, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#9: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#9)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#21 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#22 := Seq#Append(digits'#21, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#22))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#22 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#23 := Seq#Append(digits'#22, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#23))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#23 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#24 := Seq#Append(digits'#23, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#24))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#9: Box :: { Seq#Contains(chars#0, c#9) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#9) } $IsBox(c#9, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#9) ==> Seq#Contains(chars#0, c#9)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#19: int :: { Seq#Contains(digits#0, $Box(d#19)) } Seq#Contains(digits#0, $Box(d#19)) ==> LitInt(0) <= d#19 && d#19 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#19: int :: { Seq#Contains(digits#0, $Box(d#19)) } Seq#Contains(digits#0, $Box(d#19)) ==> LitInt(0) <= d#19 && d#19 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#20: int :: { Seq#Contains(digits#0, $Box(d#20)) } Seq#Contains(digits#0, $Box(d#20)) ==> LitInt(0) <= d#20 && d#20 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#9: Box :: { Seq#Contains(chars#0, c#9) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#9) } $IsBox(c#9, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#9) ==> Seq#Contains(chars#0, c#9)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#14 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#14) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#14), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#14 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#14), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#15 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#15) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#15), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#15 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#15), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#23: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#23)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#23) } $IsBox(c#23, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#23) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#23)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#24: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#24)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#24) } $IsBox(c#24, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#24) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#24)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#25: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#25)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#25) } $IsBox(c#25, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#25) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#25)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Seq#Contains(chars#0, $l#13#c#0))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#17: Box :: { Map#Domain(digits#0)[c#17] } { Seq#Contains(str#0, c#17) } $IsBox(c#17, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#17) ==> Map#Domain(digits#0)[c#17])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#17: Box :: { Map#Domain(digits#0)[c#17] } { Seq#Contains(str#0, c#17) } $IsBox(c#17, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#17) ==> Map#Domain(digits#0)[c#17])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#18: Box :: { Map#Domain(digits#0)[c#18] } { Seq#Contains(str#0, c#18) } $IsBox(c#18, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#18) ==> Map#Domain(digits#0)[c#18])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(Map#Domain(digits#0)[$l#33#c#0])), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(Map#Domain(digits#0)[$l#33#c#0])), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(Map#Domain(digits#0)[$l#34#c#0])), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(Map#Domain(digits#0)[$l#35#c#0])), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#21 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#21) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#21) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#21)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#21) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#21)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#21 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#21) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#21) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#21)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#21) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#21))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#21 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#21) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#21) else (var tl#42 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#21)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#42)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#21 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#21) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#21) else (var tl#43 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#21)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#43)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#22 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#22) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#22) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#22)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#22) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#22)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#22 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#22) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#22) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#22)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#22) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#22))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#22 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#22) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#22) else (var tl#44 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#22)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#44)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#22 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#22) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#22) else (var tl#45 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#22)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#45)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#23 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#23) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#23) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#23)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#23) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#23)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#23 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#23) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#23) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#23)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#23) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#23))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#23 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#23) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#23) else (var tl#46 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#23)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#46)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#23 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#23) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#23) else (var tl#47 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#23)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#47)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#9: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#9)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#21 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#22 := Seq#Append(digits'#21, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#22))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#22 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#23 := Seq#Append(digits'#22, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#23))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#23 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#24 := Seq#Append(digits'#23, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#24))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#9: char :: { Seq#Contains(chars#0, $Box(c#9)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#9)) ==> Seq#Contains(chars#0, $Box(c#9))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#19: int :: { Seq#Contains(digits#0, $Box(d#19)) } Seq#Contains(digits#0, $Box(d#19)) ==> LitInt(0) <= d#19 && d#19 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#19: int :: { Seq#Contains(digits#0, $Box(d#19)) } Seq#Contains(digits#0, $Box(d#19)) ==> LitInt(0) <= d#19 && d#19 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#20: int :: { Seq#Contains(digits#0, $Box(d#20)) } Seq#Contains(digits#0, $Box(d#20)) ==> LitInt(0) <= d#20 && d#20 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#9: char :: { Seq#Contains(chars#0, $Box(c#9)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#9)) ==> Seq#Contains(chars#0, $Box(c#9))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#14 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#14) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#14), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#14 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#14), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#15 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#15) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#15), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#15 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#15), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#23: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#23))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#23)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#23))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#24: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#24))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#24)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#24))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#25: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#25))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#25)) } $Is(c#25, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#25)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#25))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Seq#Contains(chars#0, $l#13#c#0))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#17: char :: { Map#Domain(digits#0)[$Box(c#17)] } { Seq#Contains(str#0, $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(str#0, $Box(c#17)) ==> Map#Domain(digits#0)[$Box(c#17)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#17: char :: { Map#Domain(digits#0)[$Box(c#17)] } { Seq#Contains(str#0, $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(str#0, $Box(c#17)) ==> Map#Domain(digits#0)[$Box(c#17)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#18: char :: { Map#Domain(digits#0)[$Box(c#18)] } { Seq#Contains(str#0, $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(str#0, $Box(c#18)) ==> Map#Domain(digits#0)[$Box(c#18)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(Map#Domain(digits#0)[$l#33#c#0])), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, TChar)), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(Map#Domain(digits#0)[$l#33#c#0])), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, TChar)), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(Map#Domain(digits#0)[$l#34#c#0])), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, TChar)), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(Map#Domain(digits#0)[$l#35#c#0])), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, TChar)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#21 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#21) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#21) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#21)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#21) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#21)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#21 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#21) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#21) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#21)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#21) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#21))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#21 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#21) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#21) else (var tl#42 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#21)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#42)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#21 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#21) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#21) else (var tl#43 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#21)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#43)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#22 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#22) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#22) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#22)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#22) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#22)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#22 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#22) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#22) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#22)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#22) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#22))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#22 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#22) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#22) else (var tl#44 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#22)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#44)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#22 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#22) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#22) else (var tl#45 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#22)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#45)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#23 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#23) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#23) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#23)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#23) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#23)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#23 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#23) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#23) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#23)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#23) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#23))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#23 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#23) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#23) else (var tl#46 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#23)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#46)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#23 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#23) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#23) else (var tl#47 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#23)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#47)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#8: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#8)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#8)) } $Is(c#8, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#8)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#8))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#11#c#0))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, TChar)), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#15: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)] } { Seq#Contains(str#0, $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(str#0, $Box(c#15)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#15: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)] } { Seq#Contains(str#0, $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(str#0, $Box(c#15)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#15)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#16: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#16)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#16)] } { Seq#Contains(str#0, $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(str#0, $Box(c#16)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#16)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#16)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#26#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#26#c#0]): int < base#0)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TChar)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#26#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#26#c#0]): int < base#0)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TChar)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#27#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#27#c#0]): int < base#0)), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar)), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#20 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#20)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#40 := JSON_mErrors.DeserializationError.b(this); (var b0#20 := JSON_mErrors.DeserializationError.expected(this); (var c#40 := (if b#40 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#40)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#20)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#40)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#41 := JSON_mErrors.DeserializationError.b(this); (var bs0#20 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#41 := (if b#41 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#41)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#20 := Seq#Create(TChar, $Heap, Seq#Length(bs0#20), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#20, $Unbox($l#34#idx#0): int)): int))), (lambda $l#34#heap#0: Heap, $l#34#idx#0: Box :: $IsBox($l#34#idx#0, TInt) && LitInt(0) <= $Unbox($l#34#idx#0): int && $Unbox($l#34#idx#0): int < Seq#Length(bs0#20)), (lambda $l#34#heap#0: Heap, $l#34#idx#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#20), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#41))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#22 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#22)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#44 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#22 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#44 := (if b#44 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#44)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#22)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#44)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#45 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#22 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#45 := (if b#45 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#45)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#22 := Seq#Create(TChar, $Heap, Seq#Length(bs0#22), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#22, $Unbox($l#37#idx#0): int)): int))), (lambda $l#37#heap#0: Heap, $l#37#idx#0: Box :: $IsBox($l#37#idx#0, TInt) && LitInt(0) <= $Unbox($l#37#idx#0): int && $Unbox($l#37#idx#0): int < Seq#Length(bs0#22)), (lambda $l#37#heap#0: Heap, $l#37#idx#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#22), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#45))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#21 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#21, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#20 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#20, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#20 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#20)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#23 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#23, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#22 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#22, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#22 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#22)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#14: int :: { JSON_mGrammar.__default.Blank_q(b#14) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) } LitInt(0) <= b#14 && b#14 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#14))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#14: int :: { JSON_mGrammar.__default.Blank_q(b#14) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) } LitInt(0) <= b#14 && b#14 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) ==> JSON_mGrammar.__default.Blank_q(b#14))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#15: int :: { JSON_mGrammar.__default.Blank_q(b#15) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#15)) } LitInt(0) <= b#15 && b#15 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#15)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#15))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#15: int :: { JSON_mGrammar.__default.Blank_q(b#15) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#15)) } LitInt(0) <= b#15 && b#15 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#15)) ==> JSON_mGrammar.__default.Blank_q(b#15))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#14: int :: { $Unbox(Seq#Index(s#0, idx#14)): DatatypeType } LitInt(0) <= idx#14 && idx#14 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#14)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#14: int :: { $Unbox(Seq#Index(s#0, idx#14)): DatatypeType } LitInt(0) <= idx#14 && idx#14 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#14)): DatatypeType)) <==> idx#14 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#15: int :: { $Unbox(Seq#Index(s#0, idx#15)): DatatypeType } LitInt(0) <= idx#15 && idx#15 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#15)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#15: int :: { $Unbox(Seq#Index(s#0, idx#15)): DatatypeType } LitInt(0) <= idx#15 && idx#15 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#15)): DatatypeType)) <==> idx#15 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#14: int :: { JSON_mGrammar.__default.Digit_q(b#14) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) } LitInt(0) <= b#14 && b#14 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#14))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#14: int :: { JSON_mGrammar.__default.Digit_q(b#14) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) } LitInt(0) <= b#14 && b#14 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#14)) ==> JSON_mGrammar.__default.Digit_q(b#14))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#15: int :: { JSON_mGrammar.__default.Digit_q(b#15) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#15)) } LitInt(0) <= b#15 && b#15 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#15)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#15))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#15: int :: { JSON_mGrammar.__default.Digit_q(b#15) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#15)) } LitInt(0) <= b#15 && b#15 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#15)) ==> JSON_mGrammar.__default.Digit_q(b#15))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#12: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#12) } { Seq#Contains(ts#0, d#12) } $IsBox(d#12, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#12) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#12))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#12: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#12) } { Seq#Contains(ts#0, d#12) } $IsBox(d#12, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#12) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#12))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#13: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#13) } { Seq#Contains(ts#0, d#13) } $IsBox(d#13, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#13) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#13))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#14: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#14) } { Seq#Contains(ts#0, d#14) } $IsBox(d#14, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#14) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#14))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#12: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#12)) } $Is(d#12, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#12) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#12)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#12: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#12)) } $Is(d#12, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#12) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#12)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#13: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#13)) } $Is(d#13, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#13) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#13)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#14: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#14)) } $Is(d#14, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#14) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#14)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#26#d#0: DatatypeType :: $Is($l#26#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#26#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#26#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#27#ly#0, $Unbox($l#27#d#0): DatatypeType))), (lambda $l#27#heap#0: Heap, $l#27#d#0: Box :: $IsBox($l#27#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#27#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#27#heap#0: Heap, $l#27#d#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#25#ly#0, $Unbox($l#25#d#0): DatatypeType))), (lambda $l#25#heap#0: Heap, $l#25#d#0: Box :: $IsBox($l#25#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#25#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#25#heap#0: Heap, $l#25#d#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#29#d#0: DatatypeType :: $Is($l#29#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#29#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#29#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#30#ly#0, $Unbox($l#30#d#0): DatatypeType))), (lambda $l#30#heap#0: Heap, $l#30#d#0: Box :: $IsBox($l#30#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#30#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#30#heap#0: Heap, $l#30#d#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#28#ly#0, $Unbox($l#28#d#0): DatatypeType))), (lambda $l#28#heap#0: Heap, $l#28#d#0: Box :: $IsBox($l#28#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#28#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#28#heap#0: Heap, $l#28#d#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#26#d#0: DatatypeType :: $Is($l#26#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#26#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#26#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#27#ly#0, $Unbox($l#27#d#0): DatatypeType))), (lambda $l#27#heap#0: Heap, $l#27#d#0: Box :: $IsBox($l#27#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#27#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#27#heap#0: Heap, $l#27#d#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#25#ly#0, $Unbox($l#25#d#0): DatatypeType))), (lambda $l#25#heap#0: Heap, $l#25#d#0: Box :: $IsBox($l#25#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#25#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#25#heap#0: Heap, $l#25#d#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#29#d#0: DatatypeType :: $Is($l#29#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#29#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#29#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#30#ly#0, $Unbox($l#30#d#0): DatatypeType))), (lambda $l#30#heap#0: Heap, $l#30#d#0: Box :: $IsBox($l#30#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#30#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#30#heap#0: Heap, $l#30#d#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#28#ly#0, $Unbox($l#28#d#0): DatatypeType))), (lambda $l#28#heap#0: Heap, $l#28#d#0: Box :: $IsBox($l#28#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#28#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#28#heap#0: Heap, $l#28#d#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#13 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#13))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#13 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#13))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#13 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#13))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#13 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#13))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#13 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#13))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#13 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#13))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#12 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#12)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#12 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#12)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#12 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#12)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#12 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#12)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#12 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#12)) else (var arr#12 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#12))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#15 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#15))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#15 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#15))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#15 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#15))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#15 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#15))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#15 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#15))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#15 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#15))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#14 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#14))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#14 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#14))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#14 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#14))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#14 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#14))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#14 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#14))) else (var arr#14 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#14)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$3x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$3x#0))): Seq);

const unique tytagFamily$jopt: TyTagFamily;

const unique tytagFamily$ValueParser: TyTagFamily;

const unique class.JSON_mZeroCopy_mDeserializer_mSequenceParams.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN() : int
uses {
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN(), Tclass.BoundedInts.uint8());
}

axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE() : int
uses {
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE(), Tclass.BoundedInts.uint8());
}

axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec(t#0: Box) : Seq
uses {
axiom 0 <= $FunctionContextHeight ==> (forall t#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#canCall(t#0) || (0 < $FunctionContextHeight && $IsBox(t#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement())) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));
}

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#canCall(t#0: Box) : bool;

function Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement() : Ty;

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires(Box) : bool;

axiom (forall t#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires(t#0) } $IsBox(t#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()) ==> (JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires(t#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.SequenceParams.ElementSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec(t#0: Box where $IsBox(t#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#canCall(cs#0, json#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#canCall(cs#0, json#0) || (1 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));
}

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$0x#0)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires($fh$0x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$0x#0)): Seq);

function JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#requires(DatatypeType, DatatypeType) : bool;

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#requires(cs#0, json#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.SequenceParams.Element (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24793"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.SequenceParams.Element (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.SequenceParams.Element", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(105,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), $Heap);
    assume 0 != $FunctionContextHeight;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle());
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume false;
    return;
}



const unique class.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#216 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#216))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#218 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#218)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#324 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#324))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#326 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#326)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#328 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#328)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#324 := Wrappers.Option.value(this); v#324)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#326 := Lit(Wrappers.Option.value(Lit(this))); v#326)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#328 := Lit(Wrappers.Option.value(Lit(this))); v#328)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#216 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#216)) else (var e#216 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#218 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#218))) else (var e#218 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#324 := Wrappers.Result.value(this); s#324) else (var e#324 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#326 := Lit(Wrappers.Result.value(Lit(this))); s#326) else (var e#326 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#328 := Lit(Wrappers.Result.value(Lit(this))); s#328) else (var e#328 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#324 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#324)) else (var e#324 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#324)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#326 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#326))) else (var e#326 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#326)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#328 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#328))) else (var e#328 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#328)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#120: int, y#120: int :: { Mul(x#120, y#120) } Mul(x#120, y#120) == Mul(y#120, x#120)) && (forall x#121: int, y#121: int, z#80: int :: { Mul(x#121 + y#121, z#80) } Mul(x#121 + y#121, z#80) == Mul(x#121, z#80) + Mul(y#121, z#80)) && (forall x#122: int, y#122: int, z#81: int :: { Mul(x#122 - y#122, z#81) } Mul(x#122 - y#122, z#81) == Mul(x#122, z#81) - Mul(y#122, z#81));

axiom MulInternals.__default.MulAuto() <==> (forall x#123: int, y#123: int :: { Mul(x#123, y#123) } Mul(x#123, y#123) == Mul(y#123, x#123)) && (forall x#124: int, y#124: int, z#82: int :: { Mul(x#124 + y#124, z#82) } Mul(x#124 + y#124, z#82) == Mul(x#124, z#82) + Mul(y#124, z#82)) && (forall x#125: int, y#125: int, z#83: int :: { Mul(x#125 - y#125, z#83) } Mul(x#125 - y#125, z#83) == Mul(x#125, z#83) - Mul(y#125, z#83));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#144: int :: { Mod(Mod(x#144, n#0), n#0) } Mod(Mod(x#144, n#0), n#0) == Mod(x#144, n#0)) && (forall x#145: int :: { Mod(x#145, n#0) } LitInt(0) <= x#145 && x#145 < n#0 <==> Mod(x#145, n#0) == x#145) && (forall x#146: int, y#72: int :: { Mod(x#146 + y#72, n#0) } (var z#70 := Mod(x#146, n#0) + Mod(y#72, n#0); (LitInt(0) <= z#70 && z#70 < n#0 && Mod(x#146 + y#72, n#0) == z#70) || (n#0 <= z#70 && z#70 < n#0 + n#0 && Mod(x#146 + y#72, n#0) == z#70 - n#0))) && (forall x#147: int, y#73: int :: { Mod(x#147 - y#73, n#0) } (var z#71 := Mod(x#147, n#0) - Mod(y#73, n#0); (LitInt(0) <= z#71 && z#71 < n#0 && Mod(x#147 - y#73, n#0) == z#71) || (0 - n#0 <= z#71 && z#71 < 0 && Mod(x#147 - y#73, n#0) == z#71 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#148: int :: { Mod(Mod(x#148, n#0), n#0) } Mod(Mod(x#148, LitInt(n#0)), LitInt(n#0)) == Mod(x#148, LitInt(n#0))) && (forall x#149: int :: { Mod(x#149, n#0) } LitInt(0) <= x#149 && x#149 < n#0 <==> Mod(x#149, LitInt(n#0)) == x#149) && (forall x#150: int, y#74: int :: { Mod(x#150 + y#74, n#0) } (var z#72 := Mod(x#150, LitInt(n#0)) + Mod(y#74, LitInt(n#0)); (LitInt(0) <= z#72 && z#72 < n#0 && Mod(x#150 + y#74, LitInt(n#0)) == z#72) || (LitInt(n#0) <= z#72 && z#72 < n#0 + n#0 && Mod(x#150 + y#74, LitInt(n#0)) == z#72 - n#0))) && (forall x#151: int, y#75: int :: { Mod(x#151 - y#75, n#0) } (var z#73 := Mod(x#151, LitInt(n#0)) - Mod(y#75, LitInt(n#0)); (LitInt(0) <= z#73 && z#73 < n#0 && Mod(x#151 - y#75, LitInt(n#0)) == z#73) || (LitInt(0 - n#0) <= z#73 && z#73 < 0 && Mod(x#151 - y#75, LitInt(n#0)) == z#73 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#102: int :: { Div(x#102, n#0) } LitInt(0) <= x#102 && x#102 < n#0 <==> Div(x#102, n#0) == LitInt(0)) && (forall x#103: int, y#68: int :: { Div(x#103 + y#68, n#0) } (var z#66 := Mod(x#103, n#0) + Mod(y#68, n#0); (LitInt(0) <= z#66 && z#66 < n#0 && Div(x#103 + y#68, n#0) == Div(x#103, n#0) + Div(y#68, n#0)) || (n#0 <= z#66 && z#66 < n#0 + n#0 && Div(x#103 + y#68, n#0) == Div(x#103, n#0) + Div(y#68, n#0) + 1))) && (forall x#104: int, y#69: int :: { Div(x#104 - y#69, n#0) } (var z#67 := Mod(x#104, n#0) - Mod(y#69, n#0); (LitInt(0) <= z#67 && z#67 < n#0 && Div(x#104 - y#69, n#0) == Div(x#104, n#0) - Div(y#69, n#0)) || (0 - n#0 <= z#67 && z#67 < 0 && Div(x#104 - y#69, n#0) == Div(x#104, n#0) - Div(y#69, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#105: int :: { Div(x#105, n#0) } LitInt(0) <= x#105 && x#105 < n#0 <==> Div(x#105, LitInt(n#0)) == LitInt(0)) && (forall x#106: int, y#70: int :: { Div(x#106 + y#70, n#0) } (var z#68 := Mod(x#106, LitInt(n#0)) + Mod(y#70, LitInt(n#0)); (LitInt(0) <= z#68 && z#68 < n#0 && Div(x#106 + y#70, LitInt(n#0)) == Div(x#106, LitInt(n#0)) + Div(y#70, LitInt(n#0))) || (LitInt(n#0) <= z#68 && z#68 < n#0 + n#0 && Div(x#106 + y#70, LitInt(n#0)) == Div(x#106, LitInt(n#0)) + Div(y#70, LitInt(n#0)) + 1))) && (forall x#107: int, y#71: int :: { Div(x#107 - y#71, n#0) } (var z#69 := Mod(x#107, LitInt(n#0)) - Mod(y#71, LitInt(n#0)); (LitInt(0) <= z#69 && z#69 < n#0 && Div(x#107 - y#71, LitInt(n#0)) == Div(x#107, LitInt(n#0)) - Div(y#71, LitInt(n#0))) || (LitInt(0 - n#0) <= z#69 && z#69 < 0 && Div(x#107 - y#71, LitInt(n#0)) == Div(x#107, LitInt(n#0)) - Div(y#71, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#22 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#22) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#22)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#22 := lv#0; (var dt_update#end#0#22 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#22), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#22), dt_update#end#0#22))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#23 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#23) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#23)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#23 := Lit(lv#0); (var dt_update#end#0#23 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#23)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#23)), dt_update#end#0#23)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#24: char :: { Seq#Contains(s#0, $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(s#0, $Box(c#24)) ==> char#ToInt(c#24) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#24: char :: { Seq#Contains(s#0, $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(s#0, $Box(c#24)) ==> char#ToInt(c#24) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#48#i#0): int)): char))), (lambda $l#48#heap#0: Heap, $l#48#i#0: Box :: $IsBox($l#48#i#0, TInt) && LitInt(0) <= $Unbox($l#48#i#0): int && $Unbox($l#48#i#0): int < Seq#Length(s#0)), (lambda $l#48#heap#0: Heap, $l#48#i#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#25: char :: { Seq#Contains(s#0, $Box(c#25)) } $Is(c#25, TChar) && Seq#Contains(s#0, $Box(c#25)) ==> char#ToInt(c#25) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#50#i#0): int)): char))), (lambda $l#50#heap#0: Heap, $l#50#i#0: Box :: $IsBox($l#50#i#0, TInt) && LitInt(0) <= $Unbox($l#50#i#0): int && $Unbox($l#50#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#50#heap#0: Heap, $l#50#i#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#36 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#18 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#36 := (if b#36 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#36)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#18)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#36)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#37 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#18 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#37 := (if b#37 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#37)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#18 := Seq#Create(TChar, $Heap, Seq#Length(bs0#18), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#18, $Unbox($l#31#idx#0): int)): int))), (lambda $l#31#heap#0: Heap, $l#31#idx#0: Box :: $IsBox($l#31#idx#0, TInt) && LitInt(0) <= $Unbox($l#31#idx#0): int && $Unbox($l#31#idx#0): int < Seq#Length(bs0#18)), (lambda $l#31#heap#0: Heap, $l#31#idx#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#18), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#37))))) else (var err#18 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#18)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#40 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#20 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#40 := (if b#40 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#40)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#20)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#40)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#41 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#20 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#41 := (if b#41 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#41)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#20 := Seq#Create(TChar, $Heap, Seq#Length(bs0#20), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#20, $Unbox($l#34#idx#0): int)): int))), (lambda $l#34#heap#0: Heap, $l#34#idx#0: Box :: $IsBox($l#34#idx#0, TInt) && LitInt(0) <= $Unbox($l#34#idx#0): int && $Unbox($l#34#idx#0): int < Seq#Length(bs0#20)), (lambda $l#34#heap#0: Heap, $l#34#idx#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#20), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#41))))) else (var err#20 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#20)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#44 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#22 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#44 := (if b#44 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#44)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#22)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#44)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#45 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#22 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#45 := (if b#45 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#45)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#22 := Seq#Create(TChar, $Heap, Seq#Length(bs0#22), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#22, $Unbox($l#37#idx#0): int)): int))), (lambda $l#37#heap#0: Heap, $l#37#idx#0: Box :: $IsBox($l#37#idx#0, TInt) && LitInt(0) <= $Unbox($l#37#idx#0): int && $Unbox($l#37#idx#0): int < Seq#Length(bs0#22)), (lambda $l#37#heap#0: Heap, $l#37#idx#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#22), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#45))))) else (var err#22 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#22)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#5: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#5)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#5)): int } LitInt(0) <= idx#5 && idx#5 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#5 && idx#5 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#5)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#5)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#6 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#6 := this; (var dt_update#beg#0#6 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#6), dt_update#beg#0#6, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#6), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#6)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#7 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#7 := Lit(this); (var dt_update#beg#0#7 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#7)), dt_update#beg#0#7, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#7)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#7)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#45#v#0): DatatypeType))), (lambda $l#45#heap#0: Heap, $l#45#v#0: Box :: $IsBox($l#45#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#45#heap#0: Heap, $l#45#v#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#46#v#0): DatatypeType))), (lambda $l#46#heap#0: Heap, $l#46#v#0: Box :: $IsBox($l#46#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#46#heap#0: Heap, $l#46#v#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#47#v#0): DatatypeType))), (lambda $l#47#heap#0: Heap, $l#47#v#0: Box :: $IsBox($l#47#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#47#heap#0: Heap, $l#47#v#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#6 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#6 := this; (var dt_update#point#0#6 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#6), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#6), dt_update#point#0#6, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#6)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#7 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#7 := Lit(this); (var dt_update#point#0#7 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#7)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#7)), dt_update#point#0#7, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#7)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#6 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#6)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#6 := this; (var dt_update#point#0#6 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#6), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#6), dt_update#point#0#6, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#6)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#7 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#7)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#7 := Lit(this); (var dt_update#point#0#7 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#7)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#7)), dt_update#point#0#7, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#7)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#6 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#6 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#6 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#6 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#6))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#7 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#7 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#7 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#7 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#7)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#12: int :: { Seq#Contains(bs#0, $Box(b#12)) } LitInt(0) <= b#12 && b#12 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#12)) ==> b#12 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#12: int :: { Seq#Contains(bs#0, $Box(b#12)) } LitInt(0) <= b#12 && b#12 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#12)) ==> b#12 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9) && (var ps#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#9, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#9) else (var ps#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#9, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#13: int :: { Seq#Contains(bs#0, $Box(b#13)) } LitInt(0) <= b#13 && b#13 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#13)) ==> b#13 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10) && (var ps#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#10, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#10) else (var ps#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#10, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#14: int :: { Seq#Contains(bs#0, $Box(b#14)) } LitInt(0) <= b#14 && b#14 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#14)) ==> b#14 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11) && (var ps#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#11, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#11) else (var ps#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#11, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#5: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#5)): int } LitInt(0) <= idx#5 && idx#5 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#5 && idx#5 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#5)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#20 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#20)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#19 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#19)))) else (var st#19 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#19))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#22 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#22)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#21 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#21)))) else (var st#21 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#21))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#24 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#24)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#23 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#23)))) else (var st#23 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#23))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#24#heap#0: Heap, $l#24#_v0#0: Box :: $IsBox($l#24#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#24#heap#0: Heap, $l#24#_v0#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#25#heap#0: Heap, $l#25#_v1#0: Box :: $IsBox($l#25#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#25#heap#0: Heap, $l#25#_v1#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#28#heap#0: Heap, $l#28#_v0#0: Box :: $IsBox($l#28#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#28#heap#0: Heap, $l#28#_v0#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#29#heap#0: Heap, $l#29#_v1#0: Box :: $IsBox($l#29#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#29#heap#0: Heap, $l#29#_v1#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#cs#0: Box :: $Box(Lit(false))), (lambda $l#36#heap#0: Heap, $l#36#cs#0: Box :: $IsBox($l#36#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#36#heap#0: Heap, $l#36#cs#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#37#heap#0: Heap, $l#37#cs#0: Box :: $IsBox($l#37#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#37#heap#0: Heap, $l#37#cs#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#38#heap#0: Heap, $l#38#_v2#0: Box :: $IsBox($l#38#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#38#heap#0: Heap, $l#38#_v2#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#cs#0: Box :: $Box(Lit(false))), (lambda $l#42#heap#0: Heap, $l#42#cs#0: Box :: $IsBox($l#42#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#42#heap#0: Heap, $l#42#cs#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#43#heap#0: Heap, $l#43#cs#0: Box :: $IsBox($l#43#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#43#heap#0: Heap, $l#43#cs#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#44#heap#0: Heap, $l#44#_v2#0: Box :: $IsBox($l#44#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#44#heap#0: Heap, $l#44#_v2#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#6: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#6))): DatatypeType } $Is(cs'#6, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#6))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#6))): DatatypeType)): DatatypeType, cs'#6, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#6: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#6))): DatatypeType } $Is(cs'#6, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#6))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#6))): DatatypeType)): DatatypeType, cs'#6, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#7: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#7))): DatatypeType } $Is(cs'#7, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#7))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#7))): DatatypeType)): DatatypeType, cs'#7, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#7: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#7))): DatatypeType } $Is(cs'#7, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#7))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#7))): DatatypeType)): DatatypeType, cs'#7, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#18: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#18)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#18))): bool } $Is(cs'#18, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#18))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#18)))) && ((forall cs'#18: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#18)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#18))): bool } $Is(cs'#18, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#18))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#18))) ==> (forall cs'#19: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#19))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#19: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#19))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#19))): bool) ==> (forall cs'#20: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#20))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#20))): bool } $Is(cs'#20, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#20))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#20))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#20))): DatatypeType)): DatatypeType, cs'#20, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#18: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#18)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#18))): bool } $Is(cs'#18, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#18))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#18))) && (forall cs'#19: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#19))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#19, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#19))): bool) && (forall cs'#20: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#20))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#20))): bool } $Is(cs'#20, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#20))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#20))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#20))): DatatypeType)): DatatypeType, cs'#20, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#21: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#21)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#21))): bool } $Is(cs'#21, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#21))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#21)))) && ((forall cs'#21: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#21)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#21))): bool } $Is(cs'#21, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#21))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#21))) ==> (forall cs'#22: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#22))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#22, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#22, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#22, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#22, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#22: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#22))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#22, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#22, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#22, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#22))): bool) ==> (forall cs'#23: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#23))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#23))): bool } $Is(cs'#23, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#23))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType)): DatatypeType, cs'#23, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#21: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#21)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#21))): bool } $Is(cs'#21, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#21))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#21))) && (forall cs'#22: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#22))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#22, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#22, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#22, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#22))): bool) && (forall cs'#23: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#23))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#23))): bool } $Is(cs'#23, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#23))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType)): DatatypeType, cs'#23, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#10: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#10)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#24 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#25 := Seq#Append(digits'#24, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#25))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#25 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#26 := Seq#Append(digits'#25, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#26))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#26 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#27 := Seq#Append(digits'#26, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#27))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#10: Box :: { Seq#Contains(chars#0, c#10) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#10) } $IsBox(c#10, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#10) ==> Seq#Contains(chars#0, c#10)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#21: int :: { Seq#Contains(digits#0, $Box(d#21)) } Seq#Contains(digits#0, $Box(d#21)) ==> LitInt(0) <= d#21 && d#21 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#21: int :: { Seq#Contains(digits#0, $Box(d#21)) } Seq#Contains(digits#0, $Box(d#21)) ==> LitInt(0) <= d#21 && d#21 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#22: int :: { Seq#Contains(digits#0, $Box(d#22)) } Seq#Contains(digits#0, $Box(d#22)) ==> LitInt(0) <= d#22 && d#22 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#10: Box :: { Seq#Contains(chars#0, c#10) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#10) } $IsBox(c#10, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#10) ==> Seq#Contains(chars#0, c#10)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#16 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#16) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#16), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#16 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#16), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#17 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#17) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#17), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#17 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#17), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#26: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#26)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#26) } $IsBox(c#26, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#26) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#26)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#27: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#27)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#27) } $IsBox(c#27, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#27) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#27)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#28: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#28)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#28) } $IsBox(c#28, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#28) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#28)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Seq#Contains(chars#0, $l#14#c#0))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#19: Box :: { Map#Domain(digits#0)[c#19] } { Seq#Contains(str#0, c#19) } $IsBox(c#19, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#19) ==> Map#Domain(digits#0)[c#19])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#19: Box :: { Map#Domain(digits#0)[c#19] } { Seq#Contains(str#0, c#19) } $IsBox(c#19, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#19) ==> Map#Domain(digits#0)[c#19])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#20: Box :: { Map#Domain(digits#0)[c#20] } { Seq#Contains(str#0, c#20) } $IsBox(c#20, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#20) ==> Map#Domain(digits#0)[c#20])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(Map#Domain(digits#0)[$l#37#c#0])), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(Map#Domain(digits#0)[$l#37#c#0])), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(Map#Domain(digits#0)[$l#38#c#0])), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(Map#Domain(digits#0)[$l#39#c#0])), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#24 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#24) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#24) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#24)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#24) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#24)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#24 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#24) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#24) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#24)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#24) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#24))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#24 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#24) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#24) else (var tl#48 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#24)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#48)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#24 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#24) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#24) else (var tl#49 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#24)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#49)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#25 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#25) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#25) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#25)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#25) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#25)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#25 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#25) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#25) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#25)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#25) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#25))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#25 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#25) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#25) else (var tl#50 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#25)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#50)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#25 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#25) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#25) else (var tl#51 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#25)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#51)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#26 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#26) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#26) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#26)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#26) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#26)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#26 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#26) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#26) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#26)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#26) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#26))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#26 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#26) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#26) else (var tl#52 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#26)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#52)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#26 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#26) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#26) else (var tl#53 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#26)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#53)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#10: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#10)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#24 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#25 := Seq#Append(digits'#24, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#25))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#25 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#26 := Seq#Append(digits'#25, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#26))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#26 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#27 := Seq#Append(digits'#26, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#27))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#10: char :: { Seq#Contains(chars#0, $Box(c#10)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#10)) ==> Seq#Contains(chars#0, $Box(c#10))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#21: int :: { Seq#Contains(digits#0, $Box(d#21)) } Seq#Contains(digits#0, $Box(d#21)) ==> LitInt(0) <= d#21 && d#21 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#21: int :: { Seq#Contains(digits#0, $Box(d#21)) } Seq#Contains(digits#0, $Box(d#21)) ==> LitInt(0) <= d#21 && d#21 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#22: int :: { Seq#Contains(digits#0, $Box(d#22)) } Seq#Contains(digits#0, $Box(d#22)) ==> LitInt(0) <= d#22 && d#22 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#10: char :: { Seq#Contains(chars#0, $Box(c#10)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#10)) ==> Seq#Contains(chars#0, $Box(c#10))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#16 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#16) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#16), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#16 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#16), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#17 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#17) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#17), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#17 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#17), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#26: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#26))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#26)) } $Is(c#26, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#26)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#26))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#27: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#27))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#27)) } $Is(c#27, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#27)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#27))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#28: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#28))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#28)) } $Is(c#28, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#28)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#28))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Seq#Contains(chars#0, $l#14#c#0))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, TChar)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#19: char :: { Map#Domain(digits#0)[$Box(c#19)] } { Seq#Contains(str#0, $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(str#0, $Box(c#19)) ==> Map#Domain(digits#0)[$Box(c#19)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#19: char :: { Map#Domain(digits#0)[$Box(c#19)] } { Seq#Contains(str#0, $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(str#0, $Box(c#19)) ==> Map#Domain(digits#0)[$Box(c#19)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#20: char :: { Map#Domain(digits#0)[$Box(c#20)] } { Seq#Contains(str#0, $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(str#0, $Box(c#20)) ==> Map#Domain(digits#0)[$Box(c#20)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(Map#Domain(digits#0)[$l#37#c#0])), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, TChar)), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(Map#Domain(digits#0)[$l#37#c#0])), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, TChar)), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(Map#Domain(digits#0)[$l#38#c#0])), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, TChar)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(Map#Domain(digits#0)[$l#39#c#0])), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, TChar)), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#24 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#24) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#24) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#24)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#24) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#24)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#24 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#24) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#24) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#24)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#24) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#24))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#24 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#24) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#24) else (var tl#48 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#24)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#48)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#24 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#24) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#24) else (var tl#49 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#24)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#49)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#25 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#25) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#25) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#25)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#25) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#25)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#25 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#25) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#25) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#25)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#25) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#25))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#25 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#25) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#25) else (var tl#50 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#25)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#50)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#25 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#25) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#25) else (var tl#51 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#25)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#51)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#26 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#26) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#26) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#26)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#26) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#26)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#26 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#26) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#26) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#26)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#26) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#26))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#26 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#26) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#26) else (var tl#52 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#26)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#52)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#26 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#26) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#26) else (var tl#53 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#26)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#53)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#9: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#9)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#9)) } $Is(c#9, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#9)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#9))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#12#c#0))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, TChar)), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#17: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)] } { Seq#Contains(str#0, $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(str#0, $Box(c#17)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#17: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)] } { Seq#Contains(str#0, $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(str#0, $Box(c#17)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#17)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#18: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#18)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#18)] } { Seq#Contains(str#0, $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(str#0, $Box(c#18)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#18)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#18)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#29#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#29#c#0]): int < base#0)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#29#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#29#c#0]): int < base#0)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, TChar)), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#30#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#30#c#0]): int < base#0)), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, TChar)), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#24 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#24)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#48 := JSON_mErrors.DeserializationError.b(this); (var b0#24 := JSON_mErrors.DeserializationError.expected(this); (var c#48 := (if b#48 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#48)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#24)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#48)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#49 := JSON_mErrors.DeserializationError.b(this); (var bs0#24 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#49 := (if b#49 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#49)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#24 := Seq#Create(TChar, $Heap, Seq#Length(bs0#24), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#24, $Unbox($l#40#idx#0): int)): int))), (lambda $l#40#heap#0: Heap, $l#40#idx#0: Box :: $IsBox($l#40#idx#0, TInt) && LitInt(0) <= $Unbox($l#40#idx#0): int && $Unbox($l#40#idx#0): int < Seq#Length(bs0#24)), (lambda $l#40#heap#0: Heap, $l#40#idx#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#24), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#49))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#26 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#26)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#52 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#26 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#52 := (if b#52 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#52)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#26)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#52)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#53 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#26 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#53 := (if b#53 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#53)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#26 := Seq#Create(TChar, $Heap, Seq#Length(bs0#26), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#26, $Unbox($l#43#idx#0): int)): int))), (lambda $l#43#heap#0: Heap, $l#43#idx#0: Box :: $IsBox($l#43#idx#0, TInt) && LitInt(0) <= $Unbox($l#43#idx#0): int && $Unbox($l#43#idx#0): int < Seq#Length(bs0#26)), (lambda $l#43#heap#0: Heap, $l#43#idx#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#26), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#53))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#25 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#25, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#24 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#24, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#24 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#24)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#27 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#27, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#26 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#26, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#26 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#26)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#16: int :: { JSON_mGrammar.__default.Blank_q(b#16) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) } LitInt(0) <= b#16 && b#16 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#16))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#16: int :: { JSON_mGrammar.__default.Blank_q(b#16) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) } LitInt(0) <= b#16 && b#16 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) ==> JSON_mGrammar.__default.Blank_q(b#16))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#17: int :: { JSON_mGrammar.__default.Blank_q(b#17) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#17)) } LitInt(0) <= b#17 && b#17 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#17)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#17))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#17: int :: { JSON_mGrammar.__default.Blank_q(b#17) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#17)) } LitInt(0) <= b#17 && b#17 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#17)) ==> JSON_mGrammar.__default.Blank_q(b#17))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#16: int :: { $Unbox(Seq#Index(s#0, idx#16)): DatatypeType } LitInt(0) <= idx#16 && idx#16 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#16)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#16: int :: { $Unbox(Seq#Index(s#0, idx#16)): DatatypeType } LitInt(0) <= idx#16 && idx#16 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#16)): DatatypeType)) <==> idx#16 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#17: int :: { $Unbox(Seq#Index(s#0, idx#17)): DatatypeType } LitInt(0) <= idx#17 && idx#17 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#17)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#17: int :: { $Unbox(Seq#Index(s#0, idx#17)): DatatypeType } LitInt(0) <= idx#17 && idx#17 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#17)): DatatypeType)) <==> idx#17 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#16: int :: { JSON_mGrammar.__default.Digit_q(b#16) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) } LitInt(0) <= b#16 && b#16 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#16))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#16: int :: { JSON_mGrammar.__default.Digit_q(b#16) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) } LitInt(0) <= b#16 && b#16 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#16)) ==> JSON_mGrammar.__default.Digit_q(b#16))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#17: int :: { JSON_mGrammar.__default.Digit_q(b#17) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#17)) } LitInt(0) <= b#17 && b#17 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#17)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#17))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#17: int :: { JSON_mGrammar.__default.Digit_q(b#17) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#17)) } LitInt(0) <= b#17 && b#17 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#17)) ==> JSON_mGrammar.__default.Digit_q(b#17))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#15: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#15) } { Seq#Contains(ts#0, d#15) } $IsBox(d#15, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#15) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#15))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#15: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#15) } { Seq#Contains(ts#0, d#15) } $IsBox(d#15, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#15) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#15))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#16: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#16) } { Seq#Contains(ts#0, d#16) } $IsBox(d#16, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#16) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#16))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#17: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#17) } { Seq#Contains(ts#0, d#17) } $IsBox(d#17, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#17) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#17))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#15: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#15)) } $Is(d#15, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#15) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#15)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#15: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#15)) } $Is(d#15, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#15) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#15)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#16: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#16)) } $Is(d#16, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#16) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#16)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#17: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#17)) } $Is(d#17, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#17) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#17)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#32#d#0: DatatypeType :: $Is($l#32#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#32#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#32#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#33#ly#0, $Unbox($l#33#d#0): DatatypeType))), (lambda $l#33#heap#0: Heap, $l#33#d#0: Box :: $IsBox($l#33#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#33#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#33#heap#0: Heap, $l#33#d#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#31#ly#0, $Unbox($l#31#d#0): DatatypeType))), (lambda $l#31#heap#0: Heap, $l#31#d#0: Box :: $IsBox($l#31#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#31#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#31#heap#0: Heap, $l#31#d#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#35#d#0: DatatypeType :: $Is($l#35#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#35#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#35#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#36#ly#0, $Unbox($l#36#d#0): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#d#0: Box :: $IsBox($l#36#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#36#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#36#heap#0: Heap, $l#36#d#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#34#ly#0, $Unbox($l#34#d#0): DatatypeType))), (lambda $l#34#heap#0: Heap, $l#34#d#0: Box :: $IsBox($l#34#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#34#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#34#heap#0: Heap, $l#34#d#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#32#d#0: DatatypeType :: $Is($l#32#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#32#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#32#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#33#ly#0, $Unbox($l#33#d#0): DatatypeType))), (lambda $l#33#heap#0: Heap, $l#33#d#0: Box :: $IsBox($l#33#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#33#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#33#heap#0: Heap, $l#33#d#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#31#ly#0, $Unbox($l#31#d#0): DatatypeType))), (lambda $l#31#heap#0: Heap, $l#31#d#0: Box :: $IsBox($l#31#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#31#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#31#heap#0: Heap, $l#31#d#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#35#d#0: DatatypeType :: $Is($l#35#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#35#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#35#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#36#ly#0, $Unbox($l#36#d#0): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#d#0: Box :: $IsBox($l#36#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#36#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#36#heap#0: Heap, $l#36#d#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#34#ly#0, $Unbox($l#34#d#0): DatatypeType))), (lambda $l#34#heap#0: Heap, $l#34#d#0: Box :: $IsBox($l#34#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#34#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#34#heap#0: Heap, $l#34#d#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#17 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#17))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#17 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#17))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#17 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#17))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#17 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#17))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#17 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#17))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#17 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#17))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#16 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#16)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#16 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#16)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#16 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#16)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#16 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#16)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#16 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#16)) else (var arr#16 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#16))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#19 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#19))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#19 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#19))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#19 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#19))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#19 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#19))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#19 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#19))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#19 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#19))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#18 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#18))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#18 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#18))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#18 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#18))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#18 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#18))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#18 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#18))) else (var arr#18 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#18)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$4x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$4x#0))): Seq);

axiom $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall $reveal: bool, cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jchar(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Get($reveal, cs#0, err#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jchar()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jblanks(), JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0)), cs#0) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0)), cs#0)) && (JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0)), JSON_mUtils_mCursors.Cursor__.Suffix(cs#0))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.WS($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jblanks())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$1x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$1x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$1x#0): int)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$1x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$1x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$1x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$1x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$1x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$1x#0))): bool);

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())) && JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Blank_q#Handle())));

axiom (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(cs#0), JSON_mGrammar.__default.Blank_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Blank_q#Handle())) && JSON_mZeroCopy_mDeserializer_mCore.__default.WS(true, Lit(cs#0)) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Blank_q#Handle())));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#7#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#11: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#11)) } $Is(cs#11, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#11)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#11: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#11)) } $Is(cs#11, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#11)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#12 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#2 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#12))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#13 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#13))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#2, cs#12 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#2 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#12))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#2) else (var val#2, cs#13 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); (var after#2, cs#14 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#13))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#13)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#2, val#2, after#2)), cs#14)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#15: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#15)) } $Is(cs#15, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#15)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#16 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#3 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#16))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#17 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#17))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#3, cs#16 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#3 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#16))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#3) else (var val#3, cs#17 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); (var after#3, cs#18 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#17))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#17)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#3, val#3, after#3)), cs#18)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#7 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#7) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#7)) && (var cs#8 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#7))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#8))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#2, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#2, cs#8 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#7)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#7))); (var after#2, cs#9 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#8))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#8)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#2, $Box(val#2), after#2)), cs#9)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#10 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#10) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#10)) && (var cs#11 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#10))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#11))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#3, cs#10 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#3, cs#11 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#10)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#10))); (var after#3, cs#12 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#11))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#11)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#3, $Box(val#3), after#3)), cs#12)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#4: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#4) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#4))): Seq } $Is(t#4, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#4)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#4: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#4) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#4))): Seq } $Is(t#4, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#4))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#4)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#5: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#5) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#5))): Seq } $Is(t#5, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#5)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#5: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#5) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#5))): Seq } $Is(t#5, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#5))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#5)))));

const class.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default: ClassName;

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN() : int
uses {
axiom $Is(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN(), Tclass.BoundedInts.uint8());
}

axiom (forall $h: Heap :: { $IsAlloc(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() : int
uses {
axiom $Is(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE(), Tclass.BoundedInts.uint8());
}

axiom (forall $h: Heap :: { $IsAlloc(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(t#0: Box) : Seq;

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(t#0: Box) : bool;

function Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement() : Ty;

axiom (forall t#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(t#0) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(t#0) || $IsBox(t#0, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()) ==> $Is(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires(Box) : bool;

axiom (forall t#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires(t#0) } $IsBox(t#0, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()) ==> (JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires(t#0) <==> true));

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType;

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0) == $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$0x#0)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0) <==> JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires($fh$0x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$0x#0)): Seq);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0, json#0), $IsGoodHeap($Heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(Wrappers.Result.value(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0, json#0))): DatatypeType, cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle())) && $Is(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { $IsAlloc(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> $IsAlloc(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

function JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#requires(DatatypeType, DatatypeType) : bool;

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#requires(cs#0, json#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

const class.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#220 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#220))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#222 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#222)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#330 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#330))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#332 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#332)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#334 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#334)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#330 := Wrappers.Option.value(this); v#330)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#332 := Lit(Wrappers.Option.value(Lit(this))); v#332)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#334 := Lit(Wrappers.Option.value(Lit(this))); v#334)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#220 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#220)) else (var e#220 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#222 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#222))) else (var e#222 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#330 := Wrappers.Result.value(this); s#330) else (var e#330 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#332 := Lit(Wrappers.Result.value(Lit(this))); s#332) else (var e#332 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#334 := Lit(Wrappers.Result.value(Lit(this))); s#334) else (var e#334 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#330 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#330)) else (var e#330 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#330)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#332 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#332))) else (var e#332 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#332)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#334 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#334))) else (var e#334 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#334)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#126: int, y#126: int :: { Mul(x#126, y#126) } Mul(x#126, y#126) == Mul(y#126, x#126)) && (forall x#127: int, y#127: int, z#84: int :: { Mul(x#127 + y#127, z#84) } Mul(x#127 + y#127, z#84) == Mul(x#127, z#84) + Mul(y#127, z#84)) && (forall x#128: int, y#128: int, z#85: int :: { Mul(x#128 - y#128, z#85) } Mul(x#128 - y#128, z#85) == Mul(x#128, z#85) - Mul(y#128, z#85));

axiom MulInternals.__default.MulAuto() <==> (forall x#129: int, y#129: int :: { Mul(x#129, y#129) } Mul(x#129, y#129) == Mul(y#129, x#129)) && (forall x#130: int, y#130: int, z#86: int :: { Mul(x#130 + y#130, z#86) } Mul(x#130 + y#130, z#86) == Mul(x#130, z#86) + Mul(y#130, z#86)) && (forall x#131: int, y#131: int, z#87: int :: { Mul(x#131 - y#131, z#87) } Mul(x#131 - y#131, z#87) == Mul(x#131, z#87) - Mul(y#131, z#87));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#152: int :: { Mod(Mod(x#152, n#0), n#0) } Mod(Mod(x#152, n#0), n#0) == Mod(x#152, n#0)) && (forall x#153: int :: { Mod(x#153, n#0) } LitInt(0) <= x#153 && x#153 < n#0 <==> Mod(x#153, n#0) == x#153) && (forall x#154: int, y#76: int :: { Mod(x#154 + y#76, n#0) } (var z#74 := Mod(x#154, n#0) + Mod(y#76, n#0); (LitInt(0) <= z#74 && z#74 < n#0 && Mod(x#154 + y#76, n#0) == z#74) || (n#0 <= z#74 && z#74 < n#0 + n#0 && Mod(x#154 + y#76, n#0) == z#74 - n#0))) && (forall x#155: int, y#77: int :: { Mod(x#155 - y#77, n#0) } (var z#75 := Mod(x#155, n#0) - Mod(y#77, n#0); (LitInt(0) <= z#75 && z#75 < n#0 && Mod(x#155 - y#77, n#0) == z#75) || (0 - n#0 <= z#75 && z#75 < 0 && Mod(x#155 - y#77, n#0) == z#75 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#156: int :: { Mod(Mod(x#156, n#0), n#0) } Mod(Mod(x#156, LitInt(n#0)), LitInt(n#0)) == Mod(x#156, LitInt(n#0))) && (forall x#157: int :: { Mod(x#157, n#0) } LitInt(0) <= x#157 && x#157 < n#0 <==> Mod(x#157, LitInt(n#0)) == x#157) && (forall x#158: int, y#78: int :: { Mod(x#158 + y#78, n#0) } (var z#76 := Mod(x#158, LitInt(n#0)) + Mod(y#78, LitInt(n#0)); (LitInt(0) <= z#76 && z#76 < n#0 && Mod(x#158 + y#78, LitInt(n#0)) == z#76) || (LitInt(n#0) <= z#76 && z#76 < n#0 + n#0 && Mod(x#158 + y#78, LitInt(n#0)) == z#76 - n#0))) && (forall x#159: int, y#79: int :: { Mod(x#159 - y#79, n#0) } (var z#77 := Mod(x#159, LitInt(n#0)) - Mod(y#79, LitInt(n#0)); (LitInt(0) <= z#77 && z#77 < n#0 && Mod(x#159 - y#79, LitInt(n#0)) == z#77) || (LitInt(0 - n#0) <= z#77 && z#77 < 0 && Mod(x#159 - y#79, LitInt(n#0)) == z#77 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#108: int :: { Div(x#108, n#0) } LitInt(0) <= x#108 && x#108 < n#0 <==> Div(x#108, n#0) == LitInt(0)) && (forall x#109: int, y#72: int :: { Div(x#109 + y#72, n#0) } (var z#70 := Mod(x#109, n#0) + Mod(y#72, n#0); (LitInt(0) <= z#70 && z#70 < n#0 && Div(x#109 + y#72, n#0) == Div(x#109, n#0) + Div(y#72, n#0)) || (n#0 <= z#70 && z#70 < n#0 + n#0 && Div(x#109 + y#72, n#0) == Div(x#109, n#0) + Div(y#72, n#0) + 1))) && (forall x#110: int, y#73: int :: { Div(x#110 - y#73, n#0) } (var z#71 := Mod(x#110, n#0) - Mod(y#73, n#0); (LitInt(0) <= z#71 && z#71 < n#0 && Div(x#110 - y#73, n#0) == Div(x#110, n#0) - Div(y#73, n#0)) || (0 - n#0 <= z#71 && z#71 < 0 && Div(x#110 - y#73, n#0) == Div(x#110, n#0) - Div(y#73, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#111: int :: { Div(x#111, n#0) } LitInt(0) <= x#111 && x#111 < n#0 <==> Div(x#111, LitInt(n#0)) == LitInt(0)) && (forall x#112: int, y#74: int :: { Div(x#112 + y#74, n#0) } (var z#72 := Mod(x#112, LitInt(n#0)) + Mod(y#74, LitInt(n#0)); (LitInt(0) <= z#72 && z#72 < n#0 && Div(x#112 + y#74, LitInt(n#0)) == Div(x#112, LitInt(n#0)) + Div(y#74, LitInt(n#0))) || (LitInt(n#0) <= z#72 && z#72 < n#0 + n#0 && Div(x#112 + y#74, LitInt(n#0)) == Div(x#112, LitInt(n#0)) + Div(y#74, LitInt(n#0)) + 1))) && (forall x#113: int, y#75: int :: { Div(x#113 - y#75, n#0) } (var z#73 := Mod(x#113, LitInt(n#0)) - Mod(y#75, LitInt(n#0)); (LitInt(0) <= z#73 && z#73 < n#0 && Div(x#113 - y#75, LitInt(n#0)) == Div(x#113, LitInt(n#0)) - Div(y#75, LitInt(n#0))) || (LitInt(0 - n#0) <= z#73 && z#73 < 0 && Div(x#113 - y#75, LitInt(n#0)) == Div(x#113, LitInt(n#0)) - Div(y#75, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#24 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#24) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#24)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#24 := lv#0; (var dt_update#end#0#24 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#24), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#24), dt_update#end#0#24))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#25 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#25) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#25)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#25 := Lit(lv#0); (var dt_update#end#0#25 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#25)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#25)), dt_update#end#0#25)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#26: char :: { Seq#Contains(s#0, $Box(c#26)) } $Is(c#26, TChar) && Seq#Contains(s#0, $Box(c#26)) ==> char#ToInt(c#26) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#26: char :: { Seq#Contains(s#0, $Box(c#26)) } $Is(c#26, TChar) && Seq#Contains(s#0, $Box(c#26)) ==> char#ToInt(c#26) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#52#i#0): int)): char))), (lambda $l#52#heap#0: Heap, $l#52#i#0: Box :: $IsBox($l#52#i#0, TInt) && LitInt(0) <= $Unbox($l#52#i#0): int && $Unbox($l#52#i#0): int < Seq#Length(s#0)), (lambda $l#52#heap#0: Heap, $l#52#i#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#27: char :: { Seq#Contains(s#0, $Box(c#27)) } $Is(c#27, TChar) && Seq#Contains(s#0, $Box(c#27)) ==> char#ToInt(c#27) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#54#i#0): int)): char))), (lambda $l#54#heap#0: Heap, $l#54#i#0: Box :: $IsBox($l#54#i#0, TInt) && LitInt(0) <= $Unbox($l#54#i#0): int && $Unbox($l#54#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#54#heap#0: Heap, $l#54#i#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#48 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#24 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#48 := (if b#48 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#48)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#24)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#48)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#49 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#24 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#49 := (if b#49 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#49)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#24 := Seq#Create(TChar, $Heap, Seq#Length(bs0#24), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#24, $Unbox($l#40#idx#0): int)): int))), (lambda $l#40#heap#0: Heap, $l#40#idx#0: Box :: $IsBox($l#40#idx#0, TInt) && LitInt(0) <= $Unbox($l#40#idx#0): int && $Unbox($l#40#idx#0): int < Seq#Length(bs0#24)), (lambda $l#40#heap#0: Heap, $l#40#idx#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#24), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#49))))) else (var err#24 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#24)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#52 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#26 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#52 := (if b#52 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#52)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#26)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#52)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#53 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#26 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#53 := (if b#53 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#53)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#26 := Seq#Create(TChar, $Heap, Seq#Length(bs0#26), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#26, $Unbox($l#43#idx#0): int)): int))), (lambda $l#43#heap#0: Heap, $l#43#idx#0: Box :: $IsBox($l#43#idx#0, TInt) && LitInt(0) <= $Unbox($l#43#idx#0): int && $Unbox($l#43#idx#0): int < Seq#Length(bs0#26)), (lambda $l#43#heap#0: Heap, $l#43#idx#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#26), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#53))))) else (var err#26 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#26)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#56 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#28 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#56 := (if b#56 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#56)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#28)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#56)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#57 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#28 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#57 := (if b#57 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#57)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#28 := Seq#Create(TChar, $Heap, Seq#Length(bs0#28), Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#28, $Unbox($l#46#idx#0): int)): int))), (lambda $l#46#heap#0: Heap, $l#46#idx#0: Box :: $IsBox($l#46#idx#0, TInt) && LitInt(0) <= $Unbox($l#46#idx#0): int && $Unbox($l#46#idx#0): int < Seq#Length(bs0#28)), (lambda $l#46#heap#0: Heap, $l#46#idx#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#28), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#57))))) else (var err#28 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#28)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#6: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#6)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#6)): int } LitInt(0) <= idx#6 && idx#6 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#6 && idx#6 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#6)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#6)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#8 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#8 := this; (var dt_update#beg#0#8 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#8), dt_update#beg#0#8, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#8), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#8)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#9 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#9 := Lit(this); (var dt_update#beg#0#9 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#9)), dt_update#beg#0#9, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#9)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#9)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#48#v#0): DatatypeType))), (lambda $l#48#heap#0: Heap, $l#48#v#0: Box :: $IsBox($l#48#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#48#heap#0: Heap, $l#48#v#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#49#v#0): DatatypeType))), (lambda $l#49#heap#0: Heap, $l#49#v#0: Box :: $IsBox($l#49#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#49#heap#0: Heap, $l#49#v#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#50#v#0): DatatypeType))), (lambda $l#50#heap#0: Heap, $l#50#v#0: Box :: $IsBox($l#50#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#50#heap#0: Heap, $l#50#v#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#8 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#8 := this; (var dt_update#point#0#8 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#8), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#8), dt_update#point#0#8, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#8)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#9 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#9 := Lit(this); (var dt_update#point#0#9 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#9)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#9)), dt_update#point#0#9, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#9)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#8 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#8)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#8 := this; (var dt_update#point#0#8 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#8), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#8), dt_update#point#0#8, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#8)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#9 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#9)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#9 := Lit(this); (var dt_update#point#0#9 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#9)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#9)), dt_update#point#0#9, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#9)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#8 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#8 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#8 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#8 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#8))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#9 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#9 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#9 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#9 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#9)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#15: int :: { Seq#Contains(bs#0, $Box(b#15)) } LitInt(0) <= b#15 && b#15 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#15)) ==> b#15 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#15: int :: { Seq#Contains(bs#0, $Box(b#15)) } LitInt(0) <= b#15 && b#15 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#15)) ==> b#15 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12) && (var ps#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#12, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#12) else (var ps#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#12, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#16: int :: { Seq#Contains(bs#0, $Box(b#16)) } LitInt(0) <= b#16 && b#16 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#16)) ==> b#16 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#13 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13) && (var ps#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#13, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#13 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#13) else (var ps#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#13, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#17: int :: { Seq#Contains(bs#0, $Box(b#17)) } LitInt(0) <= b#17 && b#17 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#17)) ==> b#17 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#14 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14) && (var ps#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#14, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#14 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#14) else (var ps#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#14)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#14, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#6: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#6)): int } LitInt(0) <= idx#6 && idx#6 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#6 && idx#6 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#6)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#26 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#26)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#25 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#25)))) else (var st#25 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#25))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#28 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#28)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#27 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#27)))) else (var st#27 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#27))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#30 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#30)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#29 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#29)))) else (var st#29 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#29))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#32#heap#0: Heap, $l#32#_v0#0: Box :: $IsBox($l#32#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#32#heap#0: Heap, $l#32#_v0#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#33#heap#0: Heap, $l#33#_v1#0: Box :: $IsBox($l#33#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#33#heap#0: Heap, $l#33#_v1#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#36#heap#0: Heap, $l#36#_v0#0: Box :: $IsBox($l#36#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#36#heap#0: Heap, $l#36#_v0#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#37#heap#0: Heap, $l#37#_v1#0: Box :: $IsBox($l#37#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#37#heap#0: Heap, $l#37#_v1#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#cs#0: Box :: $Box(Lit(false))), (lambda $l#48#heap#0: Heap, $l#48#cs#0: Box :: $IsBox($l#48#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#48#heap#0: Heap, $l#48#cs#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#49#heap#0: Heap, $l#49#cs#0: Box :: $IsBox($l#49#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#49#heap#0: Heap, $l#49#cs#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#50#heap#0: Heap, $l#50#_v2#0: Box :: $IsBox($l#50#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#50#heap#0: Heap, $l#50#_v2#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#cs#0: Box :: $Box(Lit(false))), (lambda $l#54#heap#0: Heap, $l#54#cs#0: Box :: $IsBox($l#54#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#54#heap#0: Heap, $l#54#cs#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#55#heap#0: Heap, $l#55#cs#0: Box :: $IsBox($l#55#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#55#heap#0: Heap, $l#55#cs#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#56#heap#0: Heap, $l#56#_v2#0: Box :: $IsBox($l#56#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#56#heap#0: Heap, $l#56#_v2#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#8: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#8))): DatatypeType } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#8))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#8))): DatatypeType)): DatatypeType, cs'#8, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#8: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#8))): DatatypeType } $Is(cs'#8, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#8))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#8))): DatatypeType)): DatatypeType, cs'#8, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#9: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#9))): DatatypeType } $Is(cs'#9, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#9))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#9))): DatatypeType)): DatatypeType, cs'#9, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#9: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#9))): DatatypeType } $Is(cs'#9, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#9))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#9))): DatatypeType)): DatatypeType, cs'#9, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#24: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#24)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#24))): bool } $Is(cs'#24, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#24))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#24)))) && ((forall cs'#24: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#24)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#24))): bool } $Is(cs'#24, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#24))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#24))) ==> (forall cs'#25: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#25))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#25, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#25: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#25))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#25, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#25))): bool) ==> (forall cs'#26: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#26))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#26))): bool } $Is(cs'#26, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#26))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#26))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#26))): DatatypeType)): DatatypeType, cs'#26, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#24: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#24)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#24))): bool } $Is(cs'#24, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#24))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#24))) && (forall cs'#25: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#25))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#25, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#25, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#25))): bool) && (forall cs'#26: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#26))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#26))): bool } $Is(cs'#26, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#26))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#26))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#26))): DatatypeType)): DatatypeType, cs'#26, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#27: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#27)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#27))): bool } $Is(cs'#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#27))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#27)))) && ((forall cs'#27: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#27)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#27))): bool } $Is(cs'#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#27))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#27))) ==> (forall cs'#28: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#28))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#28, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#28, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#28, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#28, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#28: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#28))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#28, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#28, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#28, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#28))): bool) ==> (forall cs'#29: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#29))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#29))): bool } $Is(cs'#29, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#29))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType)): DatatypeType, cs'#29, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#27: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#27)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#27))): bool } $Is(cs'#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#27))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#27))) && (forall cs'#28: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#28))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#28, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#28, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#28, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#28))): bool) && (forall cs'#29: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#29))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#29))): bool } $Is(cs'#29, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#29))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType)): DatatypeType, cs'#29, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#11: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#11)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#11)) ==> LitInt(0) <= d#11 && d#11 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#27 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#28 := Seq#Append(digits'#27, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#28))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#28 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#29 := Seq#Append(digits'#28, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#29))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#29 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#30 := Seq#Append(digits'#29, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#30))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#11: Box :: { Seq#Contains(chars#0, c#11) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#11) } $IsBox(c#11, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#11) ==> Seq#Contains(chars#0, c#11)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#23: int :: { Seq#Contains(digits#0, $Box(d#23)) } Seq#Contains(digits#0, $Box(d#23)) ==> LitInt(0) <= d#23 && d#23 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#23: int :: { Seq#Contains(digits#0, $Box(d#23)) } Seq#Contains(digits#0, $Box(d#23)) ==> LitInt(0) <= d#23 && d#23 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#24: int :: { Seq#Contains(digits#0, $Box(d#24)) } Seq#Contains(digits#0, $Box(d#24)) ==> LitInt(0) <= d#24 && d#24 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#11: Box :: { Seq#Contains(chars#0, c#11) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#11) } $IsBox(c#11, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#11) ==> Seq#Contains(chars#0, c#11)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#18 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#18) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#18), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#18 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#18), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#19 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#19) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#19), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#19 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#19), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#29: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#29)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#29) } $IsBox(c#29, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#29) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#29)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#30: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#30)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#30) } $IsBox(c#30, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#30) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#30)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#31: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#31)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#31) } $IsBox(c#31, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#31) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#31)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Seq#Contains(chars#0, $l#15#c#0))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#21: Box :: { Map#Domain(digits#0)[c#21] } { Seq#Contains(str#0, c#21) } $IsBox(c#21, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#21) ==> Map#Domain(digits#0)[c#21])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#21: Box :: { Map#Domain(digits#0)[c#21] } { Seq#Contains(str#0, c#21) } $IsBox(c#21, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#21) ==> Map#Domain(digits#0)[c#21])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#22: Box :: { Map#Domain(digits#0)[c#22] } { Seq#Contains(str#0, c#22) } $IsBox(c#22, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#22) ==> Map#Domain(digits#0)[c#22])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(Map#Domain(digits#0)[$l#41#c#0])), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(Map#Domain(digits#0)[$l#41#c#0])), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(Map#Domain(digits#0)[$l#42#c#0])), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(Map#Domain(digits#0)[$l#43#c#0])), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#27 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#27) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#27) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#27)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#27) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#27)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#27 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#27) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#27) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#27)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#27) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#27))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#27 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#27) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#27) else (var tl#54 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#27)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#54)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#27 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#27) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#27) else (var tl#55 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#27)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#55)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#28 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#28) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#28) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#28)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#28) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#28)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#28 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#28) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#28) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#28)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#28) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#28))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#28 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#28) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#28) else (var tl#56 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#28)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#56)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#28 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#28) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#28) else (var tl#57 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#28)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#57)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#29 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#29) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#29) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#29)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#29) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#29)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#29 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#29) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#29) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#29)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#29) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#29))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#29 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#29) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#29) else (var tl#58 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#29)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#58)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#29 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#29) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#29) else (var tl#59 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#29)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#59)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#11: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#11)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#11)) ==> LitInt(0) <= d#11 && d#11 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#27 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#28 := Seq#Append(digits'#27, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#28))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#28 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#29 := Seq#Append(digits'#28, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#29))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#29 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#30 := Seq#Append(digits'#29, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#30))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#11: char :: { Seq#Contains(chars#0, $Box(c#11)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#11)) ==> Seq#Contains(chars#0, $Box(c#11))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#23: int :: { Seq#Contains(digits#0, $Box(d#23)) } Seq#Contains(digits#0, $Box(d#23)) ==> LitInt(0) <= d#23 && d#23 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#23: int :: { Seq#Contains(digits#0, $Box(d#23)) } Seq#Contains(digits#0, $Box(d#23)) ==> LitInt(0) <= d#23 && d#23 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#24: int :: { Seq#Contains(digits#0, $Box(d#24)) } Seq#Contains(digits#0, $Box(d#24)) ==> LitInt(0) <= d#24 && d#24 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#11: char :: { Seq#Contains(chars#0, $Box(c#11)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#11)) ==> Seq#Contains(chars#0, $Box(c#11))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#18 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#18) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#18), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#18 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#18), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#19 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#19) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#19), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#19 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#19), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#29: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#29))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#29)) } $Is(c#29, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#29)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#29))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#30: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#30))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#30)) } $Is(c#30, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#30)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#30))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#31: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#31))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#31)) } $Is(c#31, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#31)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#31))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Seq#Contains(chars#0, $l#15#c#0))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#21: char :: { Map#Domain(digits#0)[$Box(c#21)] } { Seq#Contains(str#0, $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(str#0, $Box(c#21)) ==> Map#Domain(digits#0)[$Box(c#21)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#21: char :: { Map#Domain(digits#0)[$Box(c#21)] } { Seq#Contains(str#0, $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(str#0, $Box(c#21)) ==> Map#Domain(digits#0)[$Box(c#21)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#22: char :: { Map#Domain(digits#0)[$Box(c#22)] } { Seq#Contains(str#0, $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(str#0, $Box(c#22)) ==> Map#Domain(digits#0)[$Box(c#22)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(Map#Domain(digits#0)[$l#41#c#0])), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, TChar)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(Map#Domain(digits#0)[$l#41#c#0])), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, TChar)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(Map#Domain(digits#0)[$l#42#c#0])), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, TChar)), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(Map#Domain(digits#0)[$l#43#c#0])), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, TChar)), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#27 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#27) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#27) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#27)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#27) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#27)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#27 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#27) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#27) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#27)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#27) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#27))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#27 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#27) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#27) else (var tl#54 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#27)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#54)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#27 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#27) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#27) else (var tl#55 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#27)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#55)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#28 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#28) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#28) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#28)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#28) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#28)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#28 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#28) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#28) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#28)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#28) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#28))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#28 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#28) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#28) else (var tl#56 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#28)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#56)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#28 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#28) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#28) else (var tl#57 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#28)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#57)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#29 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#29) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#29) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#29)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#29) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#29)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#29 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#29) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#29) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#29)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#29) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#29))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#29 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#29) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#29) else (var tl#58 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#29)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#58)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#29 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#29) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#29) else (var tl#59 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#29)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#59)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#10: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#10)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#10)) } $Is(c#10, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#10)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#10))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#13#c#0))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, TChar)), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#19: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)] } { Seq#Contains(str#0, $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(str#0, $Box(c#19)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#19: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)] } { Seq#Contains(str#0, $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(str#0, $Box(c#19)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#19)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#20: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#20)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#20)] } { Seq#Contains(str#0, $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(str#0, $Box(c#20)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#20)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#20)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#32#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#32#c#0]): int < base#0)), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, TChar)), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#32#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#32#c#0]): int < base#0)), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, TChar)), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#33#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#33#c#0]): int < base#0)), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, TChar)), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#28 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#28)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#56 := JSON_mErrors.DeserializationError.b(this); (var b0#28 := JSON_mErrors.DeserializationError.expected(this); (var c#56 := (if b#56 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#56)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#28)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#56)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#57 := JSON_mErrors.DeserializationError.b(this); (var bs0#28 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#57 := (if b#57 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#57)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#28 := Seq#Create(TChar, $Heap, Seq#Length(bs0#28), Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#28, $Unbox($l#46#idx#0): int)): int))), (lambda $l#46#heap#0: Heap, $l#46#idx#0: Box :: $IsBox($l#46#idx#0, TInt) && LitInt(0) <= $Unbox($l#46#idx#0): int && $Unbox($l#46#idx#0): int < Seq#Length(bs0#28)), (lambda $l#46#heap#0: Heap, $l#46#idx#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#28), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#57))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#30 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#30)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#60 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#30 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#60 := (if b#60 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#60)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#30)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#60)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#61 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#30 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#61 := (if b#61 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#61)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#30 := Seq#Create(TChar, $Heap, Seq#Length(bs0#30), Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#30, $Unbox($l#49#idx#0): int)): int))), (lambda $l#49#heap#0: Heap, $l#49#idx#0: Box :: $IsBox($l#49#idx#0, TInt) && LitInt(0) <= $Unbox($l#49#idx#0): int && $Unbox($l#49#idx#0): int < Seq#Length(bs0#30)), (lambda $l#49#heap#0: Heap, $l#49#idx#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#30), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#61))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#29 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#29, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#28 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#28, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#28 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#28)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#31 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#31, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#30 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#30, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#30 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#30)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#18: int :: { JSON_mGrammar.__default.Blank_q(b#18) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) } LitInt(0) <= b#18 && b#18 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#18))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#18: int :: { JSON_mGrammar.__default.Blank_q(b#18) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) } LitInt(0) <= b#18 && b#18 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) ==> JSON_mGrammar.__default.Blank_q(b#18))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#19: int :: { JSON_mGrammar.__default.Blank_q(b#19) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#19)) } LitInt(0) <= b#19 && b#19 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#19)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#19))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#19: int :: { JSON_mGrammar.__default.Blank_q(b#19) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#19)) } LitInt(0) <= b#19 && b#19 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#19)) ==> JSON_mGrammar.__default.Blank_q(b#19))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#18: int :: { $Unbox(Seq#Index(s#0, idx#18)): DatatypeType } LitInt(0) <= idx#18 && idx#18 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#18)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#18: int :: { $Unbox(Seq#Index(s#0, idx#18)): DatatypeType } LitInt(0) <= idx#18 && idx#18 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#18)): DatatypeType)) <==> idx#18 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#19: int :: { $Unbox(Seq#Index(s#0, idx#19)): DatatypeType } LitInt(0) <= idx#19 && idx#19 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#19)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#19: int :: { $Unbox(Seq#Index(s#0, idx#19)): DatatypeType } LitInt(0) <= idx#19 && idx#19 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#19)): DatatypeType)) <==> idx#19 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#18: int :: { JSON_mGrammar.__default.Digit_q(b#18) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) } LitInt(0) <= b#18 && b#18 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#18))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#18: int :: { JSON_mGrammar.__default.Digit_q(b#18) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) } LitInt(0) <= b#18 && b#18 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#18)) ==> JSON_mGrammar.__default.Digit_q(b#18))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#19: int :: { JSON_mGrammar.__default.Digit_q(b#19) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#19)) } LitInt(0) <= b#19 && b#19 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#19)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#19))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#19: int :: { JSON_mGrammar.__default.Digit_q(b#19) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#19)) } LitInt(0) <= b#19 && b#19 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#19)) ==> JSON_mGrammar.__default.Digit_q(b#19))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#18: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#18) } { Seq#Contains(ts#0, d#18) } $IsBox(d#18, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#18) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#18))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#18: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#18) } { Seq#Contains(ts#0, d#18) } $IsBox(d#18, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#18) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#18))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#19: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#19) } { Seq#Contains(ts#0, d#19) } $IsBox(d#19, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#19) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#19))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#20: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#20) } { Seq#Contains(ts#0, d#20) } $IsBox(d#20, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#20) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#20))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#18: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#18)) } $Is(d#18, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#18) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#18)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#18: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#18)) } $Is(d#18, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#18) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#18)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#19: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#19)) } $Is(d#19, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#19) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#19)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#20: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#20)) } $Is(d#20, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#20) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#20)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#38#d#0: DatatypeType :: $Is($l#38#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#38#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#38#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#39#ly#0, $Unbox($l#39#d#0): DatatypeType))), (lambda $l#39#heap#0: Heap, $l#39#d#0: Box :: $IsBox($l#39#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#39#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#39#heap#0: Heap, $l#39#d#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#37#ly#0, $Unbox($l#37#d#0): DatatypeType))), (lambda $l#37#heap#0: Heap, $l#37#d#0: Box :: $IsBox($l#37#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#37#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#37#heap#0: Heap, $l#37#d#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#41#d#0: DatatypeType :: $Is($l#41#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#41#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#41#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#42#ly#0, $Unbox($l#42#d#0): DatatypeType))), (lambda $l#42#heap#0: Heap, $l#42#d#0: Box :: $IsBox($l#42#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#42#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#42#heap#0: Heap, $l#42#d#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#40#ly#0, $Unbox($l#40#d#0): DatatypeType))), (lambda $l#40#heap#0: Heap, $l#40#d#0: Box :: $IsBox($l#40#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#40#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#40#heap#0: Heap, $l#40#d#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#38#d#0: DatatypeType :: $Is($l#38#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#38#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#38#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#39#ly#0, $Unbox($l#39#d#0): DatatypeType))), (lambda $l#39#heap#0: Heap, $l#39#d#0: Box :: $IsBox($l#39#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#39#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#39#heap#0: Heap, $l#39#d#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#37#ly#0, $Unbox($l#37#d#0): DatatypeType))), (lambda $l#37#heap#0: Heap, $l#37#d#0: Box :: $IsBox($l#37#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#37#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#37#heap#0: Heap, $l#37#d#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#41#d#0: DatatypeType :: $Is($l#41#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#41#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#41#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#42#ly#0, $Unbox($l#42#d#0): DatatypeType))), (lambda $l#42#heap#0: Heap, $l#42#d#0: Box :: $IsBox($l#42#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#42#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#42#heap#0: Heap, $l#42#d#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#40#ly#0, $Unbox($l#40#d#0): DatatypeType))), (lambda $l#40#heap#0: Heap, $l#40#d#0: Box :: $IsBox($l#40#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#40#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#40#heap#0: Heap, $l#40#d#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#21 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#21))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#21 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#21))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#21 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#21))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#21 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#21))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#21 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#21))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#21 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#21))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#20 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#20)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#20 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#20)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#20 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#20)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#20 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#20)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#20 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#20)) else (var arr#20 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#20))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#23 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#23))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#23 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#23))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#23 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#23))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#23 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#23))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#23 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#23))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#23 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#23))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#22 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#22))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#22 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#22))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#22 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#22))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#22 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#22))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#22 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#22))) else (var arr#22 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#22)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$5x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$5x#0))): Seq);

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$2x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$2x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$2x#0): int)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$2x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$2x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$2x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$2x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$2x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$2x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#8#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $IsBox($l#8#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#19: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#19)) } $Is(cs#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#19)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#19: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#19)) } $Is(cs#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#19)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#20 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#4 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#20))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#21 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#21))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#4, cs#20 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#4 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#20))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#4) else (var val#4, cs#21 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); (var after#4, cs#22 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#21))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#21)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#4, val#4, after#4)), cs#22)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#23: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#23)) } $Is(cs#23, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#23)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#24 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#5 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#24))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#25 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#25))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#5, cs#24 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#5 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#24))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#5) else (var val#5, cs#25 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); (var after#5, cs#26 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#25))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#25)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#5, val#5, after#5)), cs#26)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#13 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#13) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#13)) && (var cs#14 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#13))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#14))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#4, cs#13 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#4, cs#14 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#13)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#13))); (var after#4, cs#15 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#14))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#14)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#4, $Box(val#4), after#4)), cs#15)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#16 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#16) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#16)) && (var cs#17 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#16))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#17))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#5, cs#16 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#5, cs#17 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#16)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#16))); (var after#5, cs#18 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#17))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#17)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#5, $Box(val#5), after#5)), cs#18)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#6: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#6) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#6))): Seq } $Is(t#6, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#6)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#6: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#6) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#6))): Seq } $Is(t#6, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#6))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#6)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#7: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#7) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#7))): Seq } $Is(t#7, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#7)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#7: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#7) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#7))): Seq } $Is(t#7, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#7))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#7)))));

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open: bool;

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close: bool;

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts: bool;

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix: bool;

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast: bool;

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements: bool;

const reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mSequences.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(): int == char#ToInt(Lit(char#FromInt(44)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SEPARATOR (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SEPARATOR (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.SEPARATOR"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(124,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(): HandleType == JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SpecViewClose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) == Tagclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) == tytagFamily$jclose;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(): HandleType == JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SpecViewOpen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) == Tagclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) == tytagFamily$jopen;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()));

axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(e#0) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(e#0) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(e#0)) && JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(e#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0) == Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(e#0)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(e#0))));
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(Lit(e#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(Lit(e#0)) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(Lit(JSON_mGrammar.Suffixed.t(Lit(e#0)))) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(Lit(e#0)) == Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(Lit(JSON_mGrammar.Suffixed.t(Lit(e#0)))), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0))))));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(e#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires(DatatypeType) : bool;

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires(e#0) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires(e#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SuffixedElementSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0: DatatypeType where $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(Lit(ts#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(ts#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires(ts#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires(ts#0) <==> true));

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $Box($fh$0x#0))): Seq);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.BracketedSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0: DatatypeType where $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.BracketedSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.BracketedSpec", " | ", ts#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(138,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 1 != $FunctionContextHeight;
    ##self#0 := ts#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(Lit(ts#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(ts#0: Seq) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires(Seq) : bool;

axiom (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires(ts#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires(ts#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SuffixedElementsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0: Seq where $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.SuffixedElementsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.SuffixedElementsSpec", " | ", ts#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(142,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 1 != $FunctionContextHeight;
    ##ts#0 := ts#0;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) == (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Open (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24837"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Open (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##b#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Open", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(146,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##b#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN();
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open, cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) == (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Close (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24855"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Close (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##b#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Close", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(154,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##b#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal: bool, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))));
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#0 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#0));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#1 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#1));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox($fh$0x#0): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires($Unbox($fh$0x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$0x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$0x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.BracketedFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()), open#0: DatatypeType where $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))), close#0: DatatypeType where $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())))) returns (sp#2: DatatypeType where $Is(sp#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24873"} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.BracketedFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) returns (sp#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#1: Heap;
  var c#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#0_0_0: DatatypeType;
  var ##fT#0_0_0: HandleType;
  var ##ts#0_0_0: Seq;
  var ##self#0_0_1: DatatypeType;
  var ##fT#0_0_1: HandleType;
  var ##self#0_0_2: DatatypeType;
  var ##fDatum#0_0_0: HandleType;
  var ##self#0_1_0: DatatypeType;
  var ##fT#0_1_0: HandleType;
  var ##ts#0_1_0: Seq;
  var ##self#0_1_1: DatatypeType;
  var ##fT#0_1_1: HandleType;
  var a##0_1_0: Seq;
  var ##self#0_1_2: DatatypeType;
  var ##fT#0_1_2: HandleType;
  var ##ts#0_1_1: Seq;
  var b##0_1_0: Seq;
  var ##self#0_1_3: DatatypeType;
  var ##fT#0_1_3: HandleType;
  var c##0_1_0: Seq;
  var ##self#0_1_4: DatatypeType;
  var ##fT#0_1_4: HandleType;
  var ##ts#0_1_2: Seq;
  var ##self#0_1_5: DatatypeType;
  var ##fT#0_1_5: HandleType;
  var ##self#0_2_0: DatatypeType;
  var ##fT#0_2_0: HandleType;
  var ##ts#0_2_0: Seq;
  var ##self#0_2_1: DatatypeType;
  var ##fT#0_2_1: HandleType;
  var ##self#0_2_2: DatatypeType;
  var ##fT#0_2_2: HandleType;
  var ##ts#0_2_1: Seq;
  var ##self#0_2_3: DatatypeType;
  var ##fT#0_2_3: HandleType;
  var ##self#0_3_0: DatatypeType;
  var ##fT#0_3_0: HandleType;
  var ##ts#0_3_0: Seq;
  var a##0_3_0: Seq;
  var ##self#0_3_1: DatatypeType;
  var ##fT#0_3_1: HandleType;
  var b##0_3_0: Seq;
  var ##ts#0_3_1: Seq;
  var c##0_3_0: Seq;
  var ##self#0_3_2: DatatypeType;
  var ##fT#0_3_2: HandleType;
  var ##ts#0_3_2: Seq;
  var ##self#0_4_0: DatatypeType;
  var ##fT#0_4_0: HandleType;
  var ##ts#0_4_0: Seq;
  var ##self#0_4_1: DatatypeType;
  var ##fT#0_4_1: HandleType;
  var ##ts#0_4_1: Seq;
  var ##self#0_5_0: DatatypeType;
  var ##fT#0_5_0: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.BracketedFromParts", " | ", cs#0, " | ", open#0, " | ", elems#0, " | ", close#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(162,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##s#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume $IsAllocBox($Box(open#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon21_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon20_Else:
    goto anon5;

  anon5:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := c#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon23_Else:
    assume {:partition} !($Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1));
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon22_Else:
    goto anon9;

  anon9:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))));
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume $IsAllocBox($Box(sp#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume false;
    return;

  anon24_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $Is($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume let#0#0#0 == #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume sp#Z#0 == let#0#0#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume false;
    goto anon19;

  anon25_Else:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_5_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_5_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_5_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_5_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0))));
    assume false;
    goto anon19;

  anon26_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_4_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_4_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_4_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_4_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_4_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_4_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0)) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(177,84)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_4_1 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_4_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_4_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_4_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_4_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_4_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:subsumption 0} Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0))), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)))));
    assume false;
    goto anon19;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_3_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_1 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_3_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    a##0_3_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    b##0_3_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    c##0_3_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_3_0, b##0_3_0, c##0_3_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_3_0, b##0_3_0, c##0_3_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(179,104)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_3_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:subsumption 0} Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)))), Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume false;
    goto anon19;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_2_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_2_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_2_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_2_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_2_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##fT#0_2_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(181,90)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_2_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_2_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_2_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_2_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_2_3 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_3, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##fT#0_2_3 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))), Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0)))));
    assume false;
    goto anon19;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_1_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##fT#0_1_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_1_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_1_0 := Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_3 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_3, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##fT#0_1_3 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    b##0_1_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    c##0_1_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_1_0, b##0_1_0, c##0_1_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_1_0, b##0_1_0, c##0_1_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(183,141)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_4 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_4, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_1_4 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_4, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_5 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_5, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##fT#0_1_5 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_5, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0)))), Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq)), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume false;
    goto anon19;

  anon30_Else:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $Heap);
    ##fT#0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##fT#0_0_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume 1 != $FunctionContextHeight;
    ##self#0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)) } $Is(d#0_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0_0) < DtRank(##self#0_0_2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume {:subsumption 0} Seq#Equal(Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq)), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume false;
    goto anon19;

  anon31_Else:
    goto anon19;

  anon19:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#4 := cs#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(187,53)"} true;
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#0, elems#0, close#0) == sp#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#0, elems#0, close#0) == sp#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#0 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#0 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#0)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) && (forall e#3: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) } $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#1 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#1 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#1)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#1)));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0) == $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$1x#0)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0) <==> JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires($fh$1x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$1x#0)): Seq);

function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AppendWithSuffix (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))), elem#0: DatatypeType where $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())), sep#0: DatatypeType where $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) returns (elems'#2: DatatypeType where $Is(elems'#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id24929"} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
  free ensures {:id "id24930"} (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)));
  free ensures {:id "id24931"} JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
  free ensures {:id "id24932"} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
  free ensures {:id "id24933"} JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AppendWithSuffix (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) returns (elems'#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var e#5: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var e#6: DatatypeType;
  var ##other#1: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var suffixed#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##ts#0: Seq;
  var ##ts#0_0: Seq;
  var ##t#0_0: Box;
  var ##c#0_0: DatatypeType;
  var ##ts#0_0_0: Seq;
  var ##t#0_0_0: Box;
  var ##c#0_0_0: DatatypeType;
  var ##ts#0_0_0_0: Seq;
  var ##t#0_0_0_0: Box;
  var ##c#0_0_0_0: DatatypeType;
  var a##0_0_0_0: Seq;
  var ##ts#0_0_0_1: Seq;
  var b##0_0_0_0: Seq;
  var ##t#0_0_0_1: Box;
  var c##0_0_0_0: Seq;
  var a##0_0_0_1: Seq;
  var ##ts#0_0_0_2: Seq;
  var ##t#0_0_0_2: Box;
  var b##0_0_0_1: Seq;
  var ##c#0_0_0_1: DatatypeType;
  var c##0_0_0_1: Seq;
  var a##0_0_0: Seq;
  var ##ts#0_0_1: Seq;
  var b##0_0_0: Seq;
  var ##t#0_0_1: Box;
  var c##0_0_0: Seq;
  var ##c#0_0_1: DatatypeType;
  var ##ts#0_1: Seq;
  var ##t#0_1: Box;
  var ##c#0_1: DatatypeType;
  var ##ts#0_2: Seq;
  var ##ts#0_1_0: Seq;
  var ##e#0_1_0: DatatypeType;
  var ##ts#0_1_1: Seq;
  var ts0##0_1_0_0: Seq;
  var ts1##0_1_0_0: Seq;
  var pt##0_1_0_0: HandleType;
  var ##ts#0_1_0_0: Seq;
  var ##fT#0_1_0_0: HandleType;
  var ##ts#0_1_0_1: Seq;
  var ##fT#0_1_0_1: HandleType;
  var ##ts#0_1_0_2: Seq;
  var ##fT#0_1_0_2: HandleType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;
  var e#7: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#6: HandleType;
  var ##cs0#2_0: DatatypeType;
  var ##spec#2_0: HandleType;
  var ##cs0#2_0_0: DatatypeType;
  var ##spec#2_0_0: HandleType;
  var ##other#2_0: DatatypeType;
  var ##other#2_1_0: DatatypeType;
  var ##cs0#2_1_0_0: DatatypeType;
  var ##spec#2_1_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AppendWithSuffix", " | ", cs0#0, " | ", json#0, " | ", elems#0, " | ", elem#0, " | ", sep#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(191,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(elem#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon38_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon37_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elem#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    havoc e#5;
    assume $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#5);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5));
    goto anon8;

  anon39_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs0#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    havoc e#6;
    assume $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#6));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#6);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6));
    goto anon12;

  anon41_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6));
    goto anon12;

  anon12:
    assume (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#4 := cs0#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume false;
    return;

  anon40_Else:
    havoc suffixed#Z#0;
    assume $Is(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume let#0#0#0 == #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()));
    assume suffixed#Z#0 == let#0#0#0;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume let#1#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))), JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon43_Then, anon43_Else;

  anon43_Then:
    push;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0_0, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon44_Then, anon44_Else;

  anon44_Then:
    push;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(214,82)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_0 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0_0_0, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(215,80)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(216,88)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_1 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0_0_1, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    b##0_0_0_0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    c##0_0_0_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_0, b##0_0_0_0, c##0_0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_0, b##0_0_0_0, c##0_0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(217,95)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_2 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0_0_2, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    a##0_0_0_1 := Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0)));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    b##0_0_0_1 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    c##0_0_0_1 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_1, b##0_0_0_1, c##0_0_0_1);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_1, b##0_0_0_1, c##0_0_0_1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(218,130)"} true;
    pop;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0))), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon17;

  anon44_Else:
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0))), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(219,10)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_1 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0_1, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    b##0_0_0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    c##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(220,110)"} true;
    pop;
    assume {:focus} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon18;

  anon43_Else:
    goto anon18;

  anon18:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(221,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_1 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_1, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    ##e#0_1_0 := suffixed#Z#0;
    assume $IsAlloc(##e#0_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(suffixed#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ts0##0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume true;
    ts1##0_1_0_0 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume 1 != $FunctionContextHeight;
    assume true;
    pt##0_1_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(224,87)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)) } { Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) } $Is(d#0_1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_1 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume $IsAlloc(##ts#0_1_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)) } { Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) } $Is(d#0_1_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_2 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)) } { Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) } $Is(d#0_1_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume {:subsumption 0} Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
    assume Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(225,181)"} true;
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume false;
    goto anon21;

  anon46_Else:
    goto anon21;

  anon21:
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(226,10)"} true;
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon22;

  anon45_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(227,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon23;

  anon42_Else:
    goto anon23;

  anon23:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(228,6)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#5 := cs0#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs0#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(229,65)"} true;
    havoc e#7;
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#7));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#7);
    goto anon26;

  anon48_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#7));
    goto anon26;

  anon47_Else:
    assume {:partition} !($Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon26;

  anon26:
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#8)));
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Equal($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(230,104)"} true;
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)));
    assume false;
    goto anon28;

  anon49_Else:
    goto anon28;

  anon28:
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(230,106)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:split_here} JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(231,65)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#6 := cs0#0;
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#6, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_0 := cs0#0;
    assume $IsAlloc(##cs0#2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    goto anon51_Then, anon51_Else;

  anon51_Then:
    push;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_0_0 := cs0#0;
    assume $IsAlloc(##cs0#2_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_0_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs0#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(234,69)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0))));
    assume false;
    goto anon31;

  anon51_Else:
    goto anon31;

  anon31:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(235,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0 := cs0#0;
    assume $IsAlloc(##other#2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_1_0 := cs0#0;
    assume $IsAlloc(##other#2_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_1_0_0 := cs0#0;
    assume $IsAlloc(##cs0#2_1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_1_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_1_0_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs0#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(238,71)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs0#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs0#0));
    assume false;
    goto anon34;

  anon53_Else:
    goto anon34;

  anon34:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(239,10)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume false;
    goto anon35;

  anon52_Else:
    goto anon35;

  anon35:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(240,8)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume false;
    goto anon36;

  anon50_Else:
    goto anon36;

  anon36:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(241,6)"} true;
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#0 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#0 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#0)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#1 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#1 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#1)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#1)));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AppendLast (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))), elem#0: DatatypeType where $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())), sep#0: DatatypeType where $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())))) returns (elems'#2: DatatypeType where $Is(elems'#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25054"} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
  free ensures {:id "id25055"} JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
  free ensures {:id "id25056"} JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
  free ensures {:id "id25057"} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
  free ensures {:id "id25058"} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AppendLast (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) returns (elems'#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var e#3: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var ##s#0: Seq;
  var ##other#1: DatatypeType;
  var $lambdaHeap#1: Heap;
  var c#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var suffixed#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##ts#0: Seq;
  var ##ts#0_0: Seq;
  var ##t#0_0: Box;
  var ##ts#0_1: Seq;
  var ##t#0_1: Box;
  var ##ts#0_2: Seq;
  var ##ts#0_1_0: Seq;
  var ##e#0_1_0: DatatypeType;
  var ##ts#0_1_1: Seq;
  var ts0##0_1_0_0: Seq;
  var ts1##0_1_0_0: Seq;
  var pt##0_1_0_0: HandleType;
  var ##ts#0_1_0_0: Seq;
  var ##fT#0_1_0_0: HandleType;
  var ##ts#0_1_0_1: Seq;
  var ##fT#0_1_0_1: HandleType;
  var ##ts#0_1_0_2: Seq;
  var ##fT#0_1_0_2: HandleType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AppendLast", " | ", cs0#0, " | ", json#0, " | ", elems#0, " | ", elem#0, " | ", sep#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(245,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(elem#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon24_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon23_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elem#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    havoc e#3;
    assume $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#3);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3));
    goto anon8;

  anon25_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs0#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    ##s#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} $Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := c#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon28_Else:
    assume {:partition} !($Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon27_Else:
    goto anon13;

  anon13:
    ##cs0#4 := JSON_mUtils_mCursors.Split.cs(elems'#2);
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume false;
    return;

  anon26_Else:
    havoc suffixed#Z#0;
    assume $Is(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume let#0#0#0 == #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty()));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()));
    assume suffixed#Z#0 == let#0#0#0;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume let#1#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))), JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_0, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.t(elem#0) == JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(267,37)"} true;
    pop;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon17;

  anon30_Else:
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(268,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_1 := JSON_mGrammar.Suffixed.t(suffixed#Z#0);
    assume $IsAllocBox(##t#0_1, Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Heap);
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    ##e#0_1_0 := suffixed#Z#0;
    assume $IsAlloc(##e#0_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(suffixed#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ts0##0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume true;
    ts1##0_1_0_0 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume 1 != $FunctionContextHeight;
    assume true;
    pt##0_1_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(271,87)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)) } { Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) } $Is(d#0_1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_1 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume $IsAlloc(##ts#0_1_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)) } { Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) } $Is(d#0_1_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_2 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)) } { Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) } $Is(d#0_1_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle());
    assume {:subsumption 0} Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
    assume Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(272,181)"} true;
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume false;
    goto anon20;

  anon32_Else:
    goto anon20;

  anon20:
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(273,10)"} true;
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon21;

  anon31_Else:
    goto anon21;

  anon21:
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(274,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon22;

  anon29_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(275,6)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#5 := cs0#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs0#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(277,65)"} true;
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#2;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var s0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var sp#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##other#0: DatatypeType;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var sp#Z#2: DatatypeType;
  var let#3#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var st#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var sp#Z#3: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var sp#Z#4: DatatypeType;
  var let#5#0#0: DatatypeType;
  var $lambdaHeap#1: Heap;
  var st#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(281,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(283,8): post-state"} true;
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume sp#Z#0 == let#0#0#0;
    havoc s0#Z#0;
    assume LitInt(-1) <= s0#Z#0 && s0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume let#1#0#0 == JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume $Is(let#1#0#0, Tclass.BoundedInts.opt__byte());
    assume s0#Z#0 == let#1#0#0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon3;

  anon29_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon3;

  anon3:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon30_Else:
    assume {:partition} !(!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0));
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    havoc sp#Z#1;
    assume $Is(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#2#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sp#Z#1 == let#2#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0);
    goto anon7;

  anon31_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    goto anon7;

  anon7:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0));
    newtype$check#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    havoc sp#Z#2;
    assume $Is(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#3#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sp#Z#2 == let#3#0#0;
    assume $IsAllocBox($Box(sp#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    goto anon34_Then, anon34_Else;

  anon34_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc st#0;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon35_Else:
    assume {:partition} !($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon34_Else:
    goto anon13;

  anon13:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $IsBox($l#1#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#Z#2, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#2#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $IsBox($l#2#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))));
    goto anon14;

  anon33_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    goto anon14;

  anon32_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0)));
    goto anon14;

  anon14:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon17;

  anon37_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon17;

  anon17:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    newtype$check#4 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon19;

  anon38_Else:
    assume {:partition} !(!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0));
    goto anon19;

  anon19:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    havoc sp#Z#3;
    assume $Is(sp#Z#3, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sp#Z#3, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume let#4#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume sp#Z#3 == let#4#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#3);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#Z#3)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#1 := cs#0;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#3), cs#0);
    goto anon21;

  anon39_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    goto anon21;

  anon36_Else:
    assume {:partition} !(((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))));
    goto anon21;

  anon21:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#2 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#2), cs#0)));
    newtype$check#6 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    havoc sp#Z#4;
    assume $Is(sp#Z#4, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sp#Z#4, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume let#5#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume sp#Z#4 == let#5#0#0;
    assume $IsAllocBox($Box(sp#Z#4), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc st#1;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} $Is(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := st#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon26;

  anon43_Else:
    assume {:partition} !($Is(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#1));
    goto anon26;

  anon26:
    assume false;
    goto anon27;

  anon42_Else:
    goto anon27;

  anon27:
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#Z#4, cs#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    goto anon28;

  anon41_Else:
    assume {:partition} s0#Z#0 != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    goto anon28;

  anon40_Else:
    assume {:partition} !(((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#2 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#2), cs#0))));
    goto anon28;

  anon28:
    assume (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $IsBox($l#8#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#9#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $IsBox($l#9#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))))));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));
  modifies $Heap;
  free ensures JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; (forall $l#10#st#0: DatatypeType :: $Is($l#10#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#10#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $IsBox($l#11#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) && ((s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $IsBox($l#14#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))))) ==> (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) ==> s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#7 := sp#3; (forall $l#12#st#0: DatatypeType :: $Is($l#12#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $l#12#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#13#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $IsBox($l#13#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))))))));
  free ensures {:id "id25150"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#4)), JSON_mUtils_mCursors.Cursor__.s(cs#0)) && JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#4)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0) && JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#4)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id25151"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $IsBox($l#15#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#16#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $IsBox($l#16#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#21#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $IsBox($l#21#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))))));
  free ensures {:id "id25152"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#6)), JSON_mUtils_mCursors.Cursor__.s(cs#0)) && JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#6)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0) && JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#6)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id25153"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#22#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: $IsBox($l#22#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#23#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: $IsBox($l#23#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#28#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: $IsBox($l#28#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; (forall $l#29#st#0: DatatypeType :: $Is($l#29#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#29#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#30#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: $IsBox($l#30#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))))) && ((s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#33#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: $IsBox($l#33#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))))) ==> (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) ==> s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#7 := sp#3; (forall $l#31#st#0: DatatypeType :: $Is($l#31#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $l#31#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#32#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: $IsBox($l#32#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))))))));
  free ensures {:id "id25154"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#4)), JSON_mUtils_mCursors.Cursor__.s(cs#0)))));
  free ensures {:id "id25155"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#4)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0))));
  free ensures {:id "id25156"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#4)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id25157"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#34#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $IsBox($l#34#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#35#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $IsBox($l#35#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0)))));
  free ensures {:id "id25158"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#34#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $IsBox($l#34#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#35#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $IsBox($l#35#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#36#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: $IsBox($l#36#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#37#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: $IsBox($l#37#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#38#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: $IsBox($l#38#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#5))))))));
  free ensures {:id "id25159"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#6)), JSON_mUtils_mCursors.Cursor__.s(cs#0)))));
  free ensures {:id "id25160"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#6)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0))));
  free ensures {:id "id25161"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#6)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id25162"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $IsBox($l#41#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#42#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $IsBox($l#42#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0)))));
  free ensures {:id "id25163"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $IsBox($l#41#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#42#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $IsBox($l#42#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#43#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: $IsBox($l#43#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#44#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: $IsBox($l#44#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#45#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: $IsBox($l#45#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#7))))))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(289,4): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq, i#0: int)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(291,39): initial state"} true;
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume {:partition} LitInt(0) <= i#0;
    goto anon3;

  anon4_Else:
    assume {:partition} i#0 < LitInt(0);
    goto anon3;

  anon3:
    assume LitInt(0) <= i#0 && i#0 < Seq#Length(xs#0);
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(293,43): post-state"} true;
    assume 0 <= i#0 && i#0 <= Seq#Length(xs#0);
    assume i#0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(xs#0);
    assume 0 <= i#0 && i#0 < Seq#Length(xs#0);
    assume Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id25169"} LitInt(0) <= i#0;
  requires {:id "id25170"} i#0 < Seq#Length(xs#0);



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures true;
  free ensures {:id "id25171"} Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id25172"} LitInt(0) <= i#0;
  requires {:id "id25173"} i#0 < Seq#Length(xs#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id25174"} Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq, i#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(294,4): initial state"} true;
    $_reverifyPost := false;
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var elem#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#0) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#0)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && (var sep#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#0)); JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType); (s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType)) && (s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#1 := sep#0; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1) && (var elems#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#1)))) && (!(s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType)) && (s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#2 := sep#0; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2) && (var elems'#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#0, sep#2))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#0) else (var elem#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#0)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#0)); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType); (if s0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#1 := sep#0; (var elems#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#1))) else (if s0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#2 := sep#0; (var elems'#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2); (var bracketed#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#0, sep#2); #Wrappers.Result.Success($Box(bracketed#0))))) else (var separator#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#0 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#0)), s0#0))); pr#0)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var elem#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#1) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#1)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#1)) && (var sep#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#1)); JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) && (var s0#1 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType); (s0#1 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType)) && (s0#1 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#4 := sep#3; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4) && (var elems#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#2)))) && (!(s0#1 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#1 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType)) && (s0#1 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#5 := sep#3; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5) && (var elems'#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#1, sep#5))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#1) else (var elem#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#1)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#1)); (var s0#1 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType); (if s0#1 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#4 := sep#3; (var elems#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#2))) else (if s0#1 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#5 := sep#3; (var elems'#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5); (var bracketed#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#1, sep#5); #Wrappers.Result.Success($Box(bracketed#1))))) else (var separator#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#1 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#1)), s0#1))); pr#1)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#3: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) } $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#2 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var elem#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#2) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#2)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#2)) && (var sep#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#2)); JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) && (var s0#2 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType); (s0#2 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType)) && (s0#2 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#7 := sep#6; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7) && (var elems#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#3)))) && (!(s0#2 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#2 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType)) && (s0#2 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#8 := sep#6; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8) && (var elems'#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#2, sep#8))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#2 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#2) else (var elem#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#2)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#2)); (var s0#2 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType); (if s0#2 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#7 := sep#6; (var elems#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#3))) else (if s0#2 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#8 := sep#6; (var elems'#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8); (var bracketed#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#2, sep#8); #Wrappers.Result.Success($Box(bracketed#2))))) else (var separator#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#2 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#2)), s0#2))); pr#2)))))))))));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), $reveal, cs0#0, json#0, open#0, elems#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), $reveal, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0));

axiom (forall $ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements(AsFuelBottom($ly), $reveal, cs0#0, json#0, open#0, elems#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LZ, $reveal, cs0#0, json#0, open#0, elems#0));

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires(LayerType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Elements (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), open#0: DatatypeType where $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))))) returns (pr#3: DatatypeType where $Is(pr#3, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25175"} Wrappers.Result.Success_q(pr#3) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());



function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, $Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] } Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: DatatypeType, $fh$0x#2: DatatypeType, $fh$0x#3: DatatypeType, $fh$0x#4: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Unbox(Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle($reveal), $Box($fh$0x#0), $Box($fh$0x#1), $Box($fh$0x#2), $Box($fh$0x#3), $Box($fh$0x#4))): DatatypeType);

function JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, $Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] } Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: DatatypeType, $fh$0x#2: DatatypeType, $fh$0x#3: DatatypeType, $fh$0x#4: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Unbox(Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle($reveal), $Box($fh$0x#0), $Box($fh$0x#1), $Box($fh$0x#2), $Box($fh$0x#3), $Box($fh$0x#4))): DatatypeType);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Elements (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements(cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) returns (pr#3: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##other#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var e#4: DatatypeType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##json#0: DatatypeType;
  var elem#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var cs##0: DatatypeType;
  var sep#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var s0#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##c#0: char;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var newtype$check#0_0_1_2: int;
  var ##idx#0_0_1_0: int;
  var newtype$check#0_0_1_3: int;
  var newtype$check#0_0_1_4: int;
  var newtype$check#0_0_1_5: int;
  var newtype$check#0_0_1_6: int;
  var newtype$check#0_0_2_0: int;
  var ##idx#0_0_2_0: int;
  var newtype$check#0_0_2_1: int;
  var newtype$check#0_0_2_2: int;
  var newtype$check#0_0_2_3: int;
  var newtype$check#0_0_2_4: int;
  var newtype$check#0_0_2_5: int;
  var newtype$check#0_0_2_6: int;
  var newtype$check#0_0_2_7: int;
  var newtype$check#0_0_2_8: int;
  var newtype$check#0_0_3_0: int;
  var newtype$check#0_0_3_1: int;
  var newtype$check#0_0_3_2: int;
  var newtype$check#0_0_3_3: int;
  var xs##0_0_4_0_0: Seq;
  var i##0_0_4_0_0: int;
  var newtype$check#0_0_5_0_0: int;
  var ##c#0_0_7_0: int;
  var ##c#0_0_8_0: int;
  var newtype$check#0_0_8_0: int;
  var newtype$check#0_0_8_1: int;
  var ##c#0_0_8_1: int;
  var newtype$check#0_0_9_0: int;
  var newtype$check#0_0_9_1: int;
  var ##c#0_0_9_0: int;
  var ##c#0_0_9_1: char;
  var sep#Z#1: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##x0#0: DatatypeType;
  var ##x1#0: DatatypeType;
  var ##x2#0: DatatypeType;
  var ##x3#0: DatatypeType;
  var ##x4#0: DatatypeType;
  var ##other#1_0: DatatypeType;
  var ##cs0#1_0: DatatypeType;
  var ##spec#1_0: HandleType;
  var ##cs0#1_1: DatatypeType;
  var ##spec#1_1: HandleType;
  var $lambdaHeap#1_0: Heap;
  var c#1_0: DatatypeType;
  var $_Frame#l1_0: [ref,Field]bool;
  var lambdaResult#1_0: Seq;
  var ##self#1_0: DatatypeType;
  var ##fT#1_0: HandleType;
  var ##cs0#1_2: DatatypeType;
  var ##spec#1_2: HandleType;
  var $lambdaHeap#1_0_0: Heap;
  var c#1_0_0: DatatypeType;
  var $_Frame#l1_0_0: [ref,Field]bool;
  var lambdaResult#1_0_0: Seq;
  var ##self#1_0_0: DatatypeType;
  var ##fT#1_0_0: HandleType;
  var ##cs0#1_0_0: DatatypeType;
  var ##spec#1_0_0: HandleType;
  var $lambdaHeap#1_0_0_0: Heap;
  var c#1_0_0_0: DatatypeType;
  var $_Frame#l1_0_0_0: [ref,Field]bool;
  var lambdaResult#1_0_0_0: Seq;
  var ##self#1_0_0_0: DatatypeType;
  var ##fT#1_0_0_0: HandleType;
  var ##cs0#1_0_0_0: DatatypeType;
  var ##spec#1_0_0_0: HandleType;
  var ##other#1_0_0: DatatypeType;
  var ##other#1_0_1_0: DatatypeType;
  var e#1_0: DatatypeType;
  var elems#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##json#1: DatatypeType;
  var ##elems#0: DatatypeType;
  var ##elem#0: DatatypeType;
  var ##sep#0: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##json#2: DatatypeType;
  var ##open#0: DatatypeType;
  var ##elems#1: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##c#1: int;
  var newtype$check#2_0_0_0: int;
  var newtype$check#2_0_0_1: int;
  var newtype$check#2_0_1_0: int;
  var newtype$check#2_0_1_1: int;
  var newtype$check#2_0_1_2: int;
  var ##idx#2_0_1_0: int;
  var newtype$check#2_0_1_3: int;
  var newtype$check#2_0_1_4: int;
  var newtype$check#2_0_1_5: int;
  var newtype$check#2_0_1_6: int;
  var newtype$check#2_0_2_0: int;
  var ##idx#2_0_2_0: int;
  var newtype$check#2_0_2_1: int;
  var newtype$check#2_0_2_2: int;
  var newtype$check#2_0_2_3: int;
  var newtype$check#2_0_2_4: int;
  var newtype$check#2_0_2_5: int;
  var newtype$check#2_0_2_6: int;
  var newtype$check#2_0_2_7: int;
  var newtype$check#2_0_2_8: int;
  var newtype$check#2_0_3_0: int;
  var newtype$check#2_0_3_1: int;
  var newtype$check#2_0_3_2: int;
  var newtype$check#2_0_3_3: int;
  var xs##2_0_4_0_0: Seq;
  var i##2_0_4_0_0: int;
  var newtype$check#2_0_5_0_0: int;
  var ##c#2_0_7_0: int;
  var sep#Z#2: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##x0#1: DatatypeType;
  var ##x1#1: DatatypeType;
  var ##x2#1: DatatypeType;
  var ##x3#1: DatatypeType;
  var ##x4#1: DatatypeType;
  var ##other#3_0: DatatypeType;
  var ##cs0#3_0: DatatypeType;
  var ##spec#3_0: HandleType;
  var ##cs0#3_1: DatatypeType;
  var ##spec#3_1: HandleType;
  var $lambdaHeap#3_0: Heap;
  var c#3_0: DatatypeType;
  var $_Frame#l3_0: [ref,Field]bool;
  var lambdaResult#3_0: Seq;
  var ##self#3_0: DatatypeType;
  var ##fT#3_0: HandleType;
  var ##cs0#3_2: DatatypeType;
  var ##spec#3_2: HandleType;
  var $lambdaHeap#3_0_0: Heap;
  var c#3_0_0: DatatypeType;
  var $_Frame#l3_0_0: [ref,Field]bool;
  var lambdaResult#3_0_0: Seq;
  var ##self#3_0_0: DatatypeType;
  var ##fT#3_0_0: HandleType;
  var ##cs0#3_0_0: DatatypeType;
  var ##spec#3_0_0: HandleType;
  var $lambdaHeap#3_0_0_0: Heap;
  var c#3_0_0_0: DatatypeType;
  var $_Frame#l3_0_0_0: [ref,Field]bool;
  var lambdaResult#3_0_0_0: Seq;
  var ##self#3_0_0_0: DatatypeType;
  var ##fT#3_0_0_0: HandleType;
  var ##cs0#3_0_0_0: DatatypeType;
  var ##spec#3_0_0_0: HandleType;
  var ##other#3_0_0: DatatypeType;
  var ##other#3_0_1_0: DatatypeType;
  var e#3_0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##cs0#5: DatatypeType;
  var ##json#3: DatatypeType;
  var ##elems#2: DatatypeType;
  var ##elem#1: DatatypeType;
  var ##sep#1: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#3: HandleType;
  var ##cs0#4_0: DatatypeType;
  var ##spec#4_0: HandleType;
  var bracketed#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##open#1: DatatypeType;
  var ##elems#3: DatatypeType;
  var ##close#0: DatatypeType;
  var ##cs0#7: DatatypeType;
  var ##spec#4: HandleType;
  var separator#Z#0: int;
  var let#9#0#0: int;
  var pr#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Elements", " | ", cs0#0, " | ", json#0, " | ", open#0, " | ", elems#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(298,69): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(open#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    goto anon113_Then, anon113_Else;

  anon113_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon114_Then, anon114_Else;

  anon114_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon114_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon113_Else:
    goto anon5;

  anon5:
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    havoc e#4;
    assume $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon115_Then, anon115_Else;

  anon115_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#4);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4));
    goto anon8;

  anon115_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    goto anon116_Then, anon116_Else;

  anon116_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon117_Then, anon117_Else;

  anon117_Then:
    assume Wrappers.Result.Success_q(pr#3);
    assume Wrappers.Result.Success_q(pr#3);
    assume $IsAllocBox(Wrappers.Result.value(pr#3), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2 := cs0#0;
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    goto anon12;

  anon117_Else:
    assume Wrappers.Result.Success_q(pr#3) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    goto anon12;

  anon12:
    assume false;
    return;

  anon116_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##cs#0 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(##cs#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(##cs#0), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.beg(##cs#0) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.end(##cs#0) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume let#0#0#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon118_Then, anon118_Else;

  anon118_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon118_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc elem#Z#0;
    assume $Is(elem#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()));
    assume elem#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon119_Then, anon119_Else;

  anon119_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon119_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    cs##0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs##0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(316,34)"} true;
    havoc sep#Z#0;
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))) && $IsAlloc(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume let#2#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume sep#Z#0 == let#2#0#0;
    havoc s0#Z#0;
    assume LitInt(-1) <= s0#Z#0 && s0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume let#3#0#0 == JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Is(let#3#0#0, Tclass.BoundedInts.opt__byte());
    assume s0#Z#0 == let#3#0#0;
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon120_Then, anon120_Else;

  anon120_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon19;

  anon120_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    goto anon19;

  anon19:
    goto anon121_Then, anon121_Else;

  anon121_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    goto anon122_Then, anon122_Else;

  anon122_Then:
    goto anon123_Then, anon123_Else;

  anon123_Then:
    assume true;
    assume false;
    goto anon37;

  anon123_Else:
    goto anon124_Then, anon124_Else;

  anon124_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_9_0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_9_0 && newtype$check#0_0_9_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_9_1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_9_1 && newtype$check#0_0_9_1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0_0_9_0 := char#ToInt(Lit(char#FromInt(44)));
    assume $IsAlloc(##c#0_0_9_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_9_1 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0_0_9_1, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} char#ToInt(##c#0_0_9_1) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44))) ==> JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44)))))));
    assume false;
    goto anon37;

  anon124_Else:
    goto anon125_Then, anon125_Else;

  anon125_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_8_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0_8_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_8_0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_8_0 && newtype$check#0_0_8_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_8_1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_8_1 && newtype$check#0_0_8_1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0_0_8_1 := char#ToInt(Lit(char#FromInt(44)));
    assume $IsAlloc(##c#0_0_8_1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44))))));
    assume false;
    goto anon37;

  anon125_Else:
    goto anon126_Then, anon126_Else;

  anon126_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_7_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0_7_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume false;
    goto anon37;

  anon126_Else:
    goto anon127_Then, anon127_Else;

  anon127_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()))) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume false;
    goto anon37;

  anon127_Else:
    goto anon128_Then, anon128_Else;

  anon128_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon129_Then, anon129_Else;

  anon129_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#0_0_5_0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0_5_0_0 && newtype$check#0_0_5_0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(327,105)"} true;
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume false;
    goto anon29;

  anon129_Else:
    goto anon29;

  anon29:
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(327,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()))) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume false;
    goto anon37;

  anon128_Else:
    goto anon130_Then, anon130_Else;

  anon130_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon131_Then, anon131_Else;

  anon131_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    xs##0_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    i##0_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##0_0_4_0_0, i##0_0_4_0_0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##0_0_4_0_0, i##0_0_4_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(329,155)"} true;
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume false;
    goto anon32;

  anon131_Else:
    goto anon32;

  anon32:
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(329,157)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()))) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume false;
    goto anon37;

  anon130_Else:
    goto anon132_Then, anon132_Else;

  anon132_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#0_0_3_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_3_0 && newtype$check#0_0_3_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_1 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_3_1 && newtype$check#0_0_3_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_3_2 && newtype$check#0_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_3_3 && newtype$check#0_0_3_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume false;
    goto anon37;

  anon132_Else:
    goto anon133_Then, anon133_Else;

  anon133_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0_0_2_0 && newtype$check#0_0_2_0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0_0_2_0 := LitInt(0);
    assume $IsAlloc(##idx#0_0_2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_2_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_2_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#0_0_2_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#0_0_2_1 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_2_1 && newtype$check#0_0_2_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_2 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_2_2 && newtype$check#0_0_2_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_3 && newtype$check#0_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_4 && newtype$check#0_0_2_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#0_0_2_5 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_2_5 && newtype$check#0_0_2_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_6 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_2_6 && newtype$check#0_0_2_6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_7 && newtype$check#0_0_2_7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_8 && newtype$check#0_0_2_8 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume false;
    goto anon37;

  anon133_Else:
    goto anon134_Then, anon134_Else;

  anon134_Then:
    newtype$check#0_0_1_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_0 && newtype$check#0_0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_1 && newtype$check#0_0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_1_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#0_0_1_2 && newtype$check#0_0_1_2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0_0_1_0 := LitInt(0);
    assume $IsAlloc(##idx#0_0_1_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_1_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_1_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#0_0_1_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#0_0_1_3 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_1_3 && newtype$check#0_0_1_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_4 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_1_4 && newtype$check#0_0_1_4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_5 && newtype$check#0_0_1_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_6 && newtype$check#0_0_1_6 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume {:subsumption 0} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume false;
    goto anon37;

  anon134_Else:
    goto anon135_Then, anon135_Else;

  anon135_Then:
    assume true;
    assume true;
    newtype$check#0_0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_0_0 && newtype$check#0_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_0_1 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_0_1 && newtype$check#0_0_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume {:subsumption 0} Lit(true) ==> s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume false;
    goto anon37;

  anon135_Else:
    goto anon37;

  anon37:
    assume true ==> JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44))) ==> JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44))) || (JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44)))) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(44)))))));
    assume false;
    goto anon38;

  anon122_Else:
    goto anon38;

  anon38:
    assume JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(336,10)"} true;
    havoc sep#Z#1;
    assume $Is(sep#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#4#0#0 == sep#Z#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sep#Z#1 == let#4#0#0;
    assume 3 != $FunctionContextHeight;
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix)), Tclass._System.___hFunc5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##x0#0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##x1#0 := json#0;
    assume $IsAlloc(##x1#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##x2#0 := elems#0;
    assume $IsAlloc(##x2#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##x3#0 := elem#Z#0;
    assume $IsAlloc(##x3#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    ##x4#0 := sep#Z#1;
    assume $IsAlloc(##x4#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix), $Box(##x0#0), $Box(##x1#0), $Box(##x2#0), $Box(##x3#0), $Box(##x4#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    goto anon136_Then, anon136_Else;

  anon136_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:subsumption 0} {:focus} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:subsumption 0} {:focus} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(json#0))));
    assume {:subsumption 0} {:focus} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume {:subsumption 0} {:focus} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(339,64)"} true;
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(340,66)"} true;
    assume $IsAllocBox($Box(elem#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1_1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1_1, Tclass._System.___hTotalFunc1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), JSON_mUtils_mCursors.Split.t(elem#Z#0))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(341,65)"} true;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon137_Then, anon137_Else;

  anon137_Then:
    havoc $lambdaHeap#1_0;
    assume $IsGoodHeap($lambdaHeap#1_0);
    assume $Heap == $lambdaHeap#1_0 || $HeapSucc($Heap, $lambdaHeap#1_0);
    havoc c#1_0;
    goto anon138_Then, anon138_Else;

  anon138_Then:
    assume {:partition} $Is(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0);
    $_Frame#l1_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0, $o, alloc)): bool ==> false);
    ##self#1_0 := c#1_0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0);
    ##fT#1_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon42;

  anon138_Else:
    assume {:partition} !($Is(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0));
    goto anon42;

  anon42:
    assume false;
    goto anon43;

  anon137_Else:
    goto anon43;

  anon43:
    ##cs0#1_2 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_2 := Lit(AtLayer((lambda $l#1_1#ly#0: LayerType :: Handle1((lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: $IsBox($l#1_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_2#ly#0: LayerType :: Handle1((lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: $IsBox($l#1_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_3#c#0: DatatypeType :: $Is($l#1_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_4#ly#0: LayerType :: Handle1((lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: $IsBox($l#1_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon139_Then, anon139_Else;

  anon139_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon140_Then, anon140_Else;

  anon140_Then:
    havoc $lambdaHeap#1_0_0;
    assume $IsGoodHeap($lambdaHeap#1_0_0);
    assume $Heap == $lambdaHeap#1_0_0 || $HeapSucc($Heap, $lambdaHeap#1_0_0);
    havoc c#1_0_0;
    goto anon141_Then, anon141_Else;

  anon141_Then:
    assume {:partition} $Is(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0);
    $_Frame#l1_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0_0, $o, alloc)): bool ==> false);
    ##self#1_0_0 := c#1_0_0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0);
    ##fT#1_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon47;

  anon141_Else:
    assume {:partition} !($Is(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0));
    goto anon47;

  anon47:
    assume false;
    goto anon48;

  anon140_Else:
    goto anon48;

  anon48:
    ##cs0#1_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0 := Lit(AtLayer((lambda $l#1_0_1#ly#0: LayerType :: Handle1((lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: $IsBox($l#1_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_2#ly#0: LayerType :: Handle1((lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: $IsBox($l#1_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_0_3#c#0: DatatypeType :: $Is($l#1_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_4#ly#0: LayerType :: Handle1((lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: $IsBox($l#1_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon142_Then, anon142_Else;

  anon142_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon143_Then, anon143_Else;

  anon143_Then:
    havoc $lambdaHeap#1_0_0_0;
    assume $IsGoodHeap($lambdaHeap#1_0_0_0);
    assume $Heap == $lambdaHeap#1_0_0_0 || $HeapSucc($Heap, $lambdaHeap#1_0_0_0);
    havoc c#1_0_0_0;
    goto anon144_Then, anon144_Else;

  anon144_Then:
    assume {:partition} $Is(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0);
    $_Frame#l1_0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0_0_0, $o, alloc)): bool ==> false);
    ##self#1_0_0_0 := c#1_0_0_0;
    assume $IsAlloc(##self#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0);
    ##fT#1_0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon52;

  anon144_Else:
    assume {:partition} !($Is(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0));
    goto anon52;

  anon52:
    assume false;
    goto anon53;

  anon143_Else:
    goto anon53;

  anon53:
    ##cs0#1_0_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0_0 := Lit(AtLayer((lambda $l#1_0_0_1#ly#0: LayerType :: Handle1((lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: $IsBox($l#1_0_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_2#ly#0: LayerType :: Handle1((lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: $IsBox($l#1_0_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_0_0_3#c#0: DatatypeType :: $Is($l#1_0_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_0_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_4#ly#0: LayerType :: Handle1((lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: $IsBox($l#1_0_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_4#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_5#ly#0: LayerType :: Handle1((lambda $l#1_0_0_5#heap#0: Heap, $l#1_0_0_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_5#heap#0: Heap, $l#1_0_0_5#c#0: Box :: $IsBox($l#1_0_0_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_5#heap#0: Heap, $l#1_0_0_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_6#ly#0: LayerType :: Handle1((lambda $l#1_0_0_6#heap#0: Heap, $l#1_0_0_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_6#heap#0: Heap, $l#1_0_0_6#c#0: Box :: $IsBox($l#1_0_0_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_6#heap#0: Heap, $l#1_0_0_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_5#ly#0: LayerType :: Handle1((lambda $l#1_0_0_5#heap#0: Heap, $l#1_0_0_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_5#heap#0: Heap, $l#1_0_0_5#c#0: Box :: $IsBox($l#1_0_0_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_5#heap#0: Heap, $l#1_0_0_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_6#ly#0: LayerType :: Handle1((lambda $l#1_0_0_6#heap#0: Heap, $l#1_0_0_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_6#heap#0: Heap, $l#1_0_0_6#c#0: Box :: $IsBox($l#1_0_0_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_6#heap#0: Heap, $l#1_0_0_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_7#ly#0: LayerType :: Handle1((lambda $l#1_0_0_7#heap#0: Heap, $l#1_0_0_7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_7#heap#0: Heap, $l#1_0_0_7#c#0: Box :: $IsBox($l#1_0_0_7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_7#heap#0: Heap, $l#1_0_0_7#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_7#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_8#ly#0: LayerType :: Handle1((lambda $l#1_0_0_8#heap#0: Heap, $l#1_0_0_8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_8#heap#0: Heap, $l#1_0_0_8#c#0: Box :: $IsBox($l#1_0_0_8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_8#heap#0: Heap, $l#1_0_0_8#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_8#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#1_0_0_9#ly#0: LayerType :: Handle1((lambda $l#1_0_0_9#heap#0: Heap, $l#1_0_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_9#heap#0: Heap, $l#1_0_0_9#c#0: Box :: $IsBox($l#1_0_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_9#heap#0: Heap, $l#1_0_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_9#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#Z#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_12#ly#0: LayerType :: Handle1((lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: $IsBox($l#1_0_0_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(344,81)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_5#ly#0: LayerType :: Handle1((lambda $l#1_0_5#heap#0: Heap, $l#1_0_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_5#heap#0: Heap, $l#1_0_5#c#0: Box :: $IsBox($l#1_0_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_5#heap#0: Heap, $l#1_0_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_6#ly#0: LayerType :: Handle1((lambda $l#1_0_6#heap#0: Heap, $l#1_0_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_6#heap#0: Heap, $l#1_0_6#c#0: Box :: $IsBox($l#1_0_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_6#heap#0: Heap, $l#1_0_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_6#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#1_0_7#ly#0: LayerType :: Handle1((lambda $l#1_0_7#heap#0: Heap, $l#1_0_7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_7#heap#0: Heap, $l#1_0_7#c#0: Box :: $IsBox($l#1_0_7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_7#heap#0: Heap, $l#1_0_7#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_7#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#Z#1))));
    assume false;
    goto anon54;

  anon142_Else:
    goto anon54;

  anon54:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_9#ly#0: LayerType :: Handle1((lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: $IsBox($l#1_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_9#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(345,14)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#1_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon145_Then, anon145_Else;

  anon145_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(347,34)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#1_0_1_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#1_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon146_Then, anon146_Else;

  anon146_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(349,38)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sep#Z#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sep#Z#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume false;
    goto anon57;

  anon146_Else:
    goto anon57;

  anon57:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(350,16)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sep#Z#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sep#Z#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume false;
    goto anon58;

  anon145_Else:
    goto anon58;

  anon58:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(351,14)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_5#ly#0: LayerType :: Handle1((lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $IsBox($l#1_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_6#ly#0: LayerType :: Handle1((lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $IsBox($l#1_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_5#ly#0: LayerType :: Handle1((lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $IsBox($l#1_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_6#ly#0: LayerType :: Handle1((lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $IsBox($l#1_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_5#ly#0: LayerType :: Handle1((lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $IsBox($l#1_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_6#ly#0: LayerType :: Handle1((lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $IsBox($l#1_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sep#Z#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_5#ly#0: LayerType :: Handle1((lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $IsBox($l#1_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_6#ly#0: LayerType :: Handle1((lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $IsBox($l#1_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sep#Z#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_5#ly#0: LayerType :: Handle1((lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: $IsBox($l#1_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_5#heap#0: Heap, $l#1_5#c#0: Box :: SetRef_to_SetBox((lambda $l#1_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_6#ly#0: LayerType :: Handle1((lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: $IsBox($l#1_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_6#heap#0: Heap, $l#1_6#c#0: Box :: SetRef_to_SetBox((lambda $l#1_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_7#ly#0: LayerType :: Handle1((lambda $l#1_7#heap#0: Heap, $l#1_7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_7#heap#0: Heap, $l#1_7#c#0: Box :: $IsBox($l#1_7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_7#heap#0: Heap, $l#1_7#c#0: Box :: SetRef_to_SetBox((lambda $l#1_7#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_8#ly#0: LayerType :: Handle1((lambda $l#1_8#heap#0: Heap, $l#1_8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_8#heap#0: Heap, $l#1_8#c#0: Box :: $IsBox($l#1_8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_8#heap#0: Heap, $l#1_8#c#0: Box :: SetRef_to_SetBox((lambda $l#1_8#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#1_9#ly#0: LayerType :: Handle1((lambda $l#1_9#heap#0: Heap, $l#1_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_9#heap#0: Heap, $l#1_9#c#0: Box :: $IsBox($l#1_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_9#heap#0: Heap, $l#1_9#c#0: Box :: SetRef_to_SetBox((lambda $l#1_9#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#Z#1)))));
    assume false;
    goto anon59;

  anon139_Else:
    goto anon59;

  anon59:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_12#ly#0: LayerType :: Handle1((lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: $IsBox($l#1_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: SetRef_to_SetBox((lambda $l#1_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(352,12)"} true;
    havoc e#1_0;
    goto anon147_Then, anon147_Else;

  anon147_Then:
    assume {:partition} $Is(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon148_Then, anon148_Else;

  anon148_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#1_0);
    goto anon62;

  anon148_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_0));
    goto anon62;

  anon147_Else:
    assume {:partition} !($Is(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon62;

  anon62:
    assume (forall e#1_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) } $Is(e#1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#1_1)));
    assume (forall e#1_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) } $Is(e#1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1_1)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(353,64)"} true;
    assume true;
    assume {:split_here} Lit(true);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(354,37)"} true;
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume false;
    goto anon63;

  anon136_Else:
    goto anon63;

  anon63:
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(355,10)"} true;
    havoc elems#Z#0;
    assume $Is(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##cs0#3 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#1 := json#0;
    assume $IsAlloc(##json#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##elems#0 := elems#0;
    assume $IsAlloc(##elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##elem#0 := elem#Z#0;
    assume $IsAlloc(##elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    ##sep#0 := sep#Z#1;
    assume $IsAlloc(##sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#1)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#3), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elem#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), JSON_mUtils_mCursors.Split.t(##elem#0))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##sep#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##sep#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##sep#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##sep#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##sep#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##sep#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)));
    assume (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1));
    assume let#5#0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems#Z#0 == let#5#0#0;
    ##cs0#4 := cs0#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#2 := json#0;
    assume $IsAlloc(##json#2, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##open#0 := open#0;
    assume $IsAlloc(##open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    ##elems#1 := elems#Z#0;
    assume $IsAlloc(##elems#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#0)), JSON_mUtils_mCursors.Cursor__.s(##cs0#4))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs0#4)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs0#4)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#4), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#2)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)));
    assume (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)));
    assume 0 <= JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(##elems#1)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon121_Else:
    assume {:partition} !(s0#Z#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1));
    newtype$check#3 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon149_Then, anon149_Else;

  anon149_Then:
    assume {:partition} s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#5 := LitInt(1);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon66;

  anon149_Else:
    assume {:partition} s0#Z#0 != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    goto anon66;

  anon66:
    goto anon150_Then, anon150_Else;

  anon150_Then:
    assume {:partition} s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume $IsAlloc(##c#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    goto anon151_Then, anon151_Else;

  anon151_Then:
    goto anon152_Then, anon152_Else;

  anon152_Then:
    assume true;
    assume false;
    goto anon82;

  anon152_Else:
    goto anon153_Then, anon153_Else;

  anon153_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#2_0_7_0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume $IsAlloc(##c#2_0_7_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume false;
    goto anon82;

  anon153_Else:
    goto anon154_Then, anon154_Else;

  anon154_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume false;
    goto anon82;

  anon154_Else:
    goto anon155_Then, anon155_Else;

  anon155_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon156_Then, anon156_Else;

  anon156_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#2_0_5_0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#2_0_5_0_0 && newtype$check#2_0_5_0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(364,105)"} true;
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume false;
    goto anon74;

  anon156_Else:
    goto anon74;

  anon74:
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(364,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume false;
    goto anon82;

  anon155_Else:
    goto anon157_Then, anon157_Else;

  anon157_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon158_Then, anon158_Else;

  anon158_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    xs##2_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    i##2_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##2_0_4_0_0, i##2_0_4_0_0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##2_0_4_0_0, i##2_0_4_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(366,155)"} true;
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume false;
    goto anon77;

  anon158_Else:
    goto anon77;

  anon77:
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(366,157)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))) ==> Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume false;
    goto anon82;

  anon157_Else:
    goto anon159_Then, anon159_Else;

  anon159_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#2_0_3_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_3_0 && newtype$check#2_0_3_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_1 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_3_1 && newtype$check#2_0_3_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_2 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_3_2 && newtype$check#2_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_3 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_3_3 && newtype$check#2_0_3_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume false;
    goto anon82;

  anon159_Else:
    goto anon160_Then, anon160_Else;

  anon160_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#2_0_2_0 && newtype$check#2_0_2_0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#2_0_2_0 := LitInt(0);
    assume $IsAlloc(##idx#2_0_2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_2_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_2_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#2_0_2_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#2_0_2_1 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_2_1 && newtype$check#2_0_2_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_2 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_2_2 && newtype$check#2_0_2_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_3 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_3 && newtype$check#2_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_4 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_4 && newtype$check#2_0_2_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#2_0_2_5 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_2_5 && newtype$check#2_0_2_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_6 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_2_6 && newtype$check#2_0_2_6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_7 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_7 && newtype$check#2_0_2_7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_8 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_8 && newtype$check#2_0_2_8 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume false;
    goto anon82;

  anon160_Else:
    goto anon161_Then, anon161_Else;

  anon161_Then:
    newtype$check#2_0_1_0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_0 && newtype$check#2_0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_1 && newtype$check#2_0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2_0_1_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2_0_1_2 && newtype$check#2_0_1_2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#2_0_1_0 := LitInt(0);
    assume $IsAlloc(##idx#2_0_1_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_1_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_1_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#2_0_1_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#2_0_1_3 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_1_3 && newtype$check#2_0_1_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_4 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_1_4 && newtype$check#2_0_1_4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_5 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_5 && newtype$check#2_0_1_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_6 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_6 && newtype$check#2_0_1_6 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume {:subsumption 0} s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume false;
    goto anon82;

  anon161_Else:
    goto anon162_Then, anon162_Else;

  anon162_Then:
    assume true;
    assume true;
    newtype$check#2_0_0_0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_0_0 && newtype$check#2_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_0_1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_0_1 && newtype$check#2_0_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume {:subsumption 0} Lit(true) ==> s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume false;
    goto anon82;

  anon162_Else:
    goto anon82;

  anon82:
    assume true ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume false;
    goto anon83;

  anon151_Else:
    goto anon83;

  anon83:
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(373,10)"} true;
    havoc sep#Z#2;
    assume $Is(sep#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume let#6#0#0 == sep#Z#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume sep#Z#2 == let#6#0#0;
    assume 3 != $FunctionContextHeight;
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast)), Tclass._System.___hFunc5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##x0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##x0#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##x1#1 := json#0;
    assume $IsAlloc(##x1#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##x2#1 := elems#0;
    assume $IsAlloc(##x2#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##x3#1 := elem#Z#0;
    assume $IsAlloc(##x3#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    ##x4#1 := sep#Z#2;
    assume $IsAlloc(##x4#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast), $Box(##x0#1), $Box(##x1#1), $Box(##x2#1), $Box(##x3#1), $Box(##x4#1))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    goto anon163_Then, anon163_Else;

  anon163_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#3_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(376,55)"} true;
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#3_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mCursors.Split.cs(open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(377,66)"} true;
    assume $IsAllocBox($Box(elem#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#3_1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#3_1, Tclass._System.___hTotalFunc1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0), JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), JSON_mUtils_mCursors.Split.t(elem#Z#0))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(378,65)"} true;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon164_Then, anon164_Else;

  anon164_Then:
    havoc $lambdaHeap#3_0;
    assume $IsGoodHeap($lambdaHeap#3_0);
    assume $Heap == $lambdaHeap#3_0 || $HeapSucc($Heap, $lambdaHeap#3_0);
    havoc c#3_0;
    goto anon165_Then, anon165_Else;

  anon165_Then:
    assume {:partition} $Is(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0);
    $_Frame#l3_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0, $o, alloc)): bool ==> false);
    ##self#3_0 := c#3_0;
    assume $IsAlloc(##self#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0);
    ##fT#3_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon87;

  anon165_Else:
    assume {:partition} !($Is(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0));
    goto anon87;

  anon87:
    assume false;
    goto anon88;

  anon164_Else:
    goto anon88;

  anon88:
    ##cs0#3_2 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_2 := Lit(AtLayer((lambda $l#3_1#ly#0: LayerType :: Handle1((lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: $IsBox($l#3_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_2#ly#0: LayerType :: Handle1((lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: $IsBox($l#3_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_3#c#0: DatatypeType :: $Is($l#3_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $l#3_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_4#ly#0: LayerType :: Handle1((lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: $IsBox($l#3_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon166_Then, anon166_Else;

  anon166_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon167_Then, anon167_Else;

  anon167_Then:
    havoc $lambdaHeap#3_0_0;
    assume $IsGoodHeap($lambdaHeap#3_0_0);
    assume $Heap == $lambdaHeap#3_0_0 || $HeapSucc($Heap, $lambdaHeap#3_0_0);
    havoc c#3_0_0;
    goto anon168_Then, anon168_Else;

  anon168_Then:
    assume {:partition} $Is(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0_0);
    $_Frame#l3_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0_0, $o, alloc)): bool ==> false);
    ##self#3_0_0 := c#3_0_0;
    assume $IsAlloc(##self#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0_0);
    ##fT#3_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon92;

  anon168_Else:
    assume {:partition} !($Is(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0_0));
    goto anon92;

  anon92:
    assume false;
    goto anon93;

  anon167_Else:
    goto anon93;

  anon93:
    ##cs0#3_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0 := Lit(AtLayer((lambda $l#3_0_1#ly#0: LayerType :: Handle1((lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: $IsBox($l#3_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_2#ly#0: LayerType :: Handle1((lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: $IsBox($l#3_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_0_3#c#0: DatatypeType :: $Is($l#3_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $l#3_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_4#ly#0: LayerType :: Handle1((lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: $IsBox($l#3_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon169_Then, anon169_Else;

  anon169_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon170_Then, anon170_Else;

  anon170_Then:
    havoc $lambdaHeap#3_0_0_0;
    assume $IsGoodHeap($lambdaHeap#3_0_0_0);
    assume $Heap == $lambdaHeap#3_0_0_0 || $HeapSucc($Heap, $lambdaHeap#3_0_0_0);
    havoc c#3_0_0_0;
    goto anon171_Then, anon171_Else;

  anon171_Then:
    assume {:partition} $Is(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0_0_0);
    $_Frame#l3_0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0_0_0, $o, alloc)): bool ==> false);
    ##self#3_0_0_0 := c#3_0_0_0;
    assume $IsAlloc(##self#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0_0_0);
    ##fT#3_0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon97;

  anon171_Else:
    assume {:partition} !($Is(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $lambdaHeap#3_0_0_0));
    goto anon97;

  anon97:
    assume false;
    goto anon98;

  anon170_Else:
    goto anon98;

  anon98:
    ##cs0#3_0_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0_0 := Lit(AtLayer((lambda $l#3_0_0_1#ly#0: LayerType :: Handle1((lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: $IsBox($l#3_0_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_2#ly#0: LayerType :: Handle1((lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: $IsBox($l#3_0_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_0_0_3#c#0: DatatypeType :: $Is($l#3_0_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $l#3_0_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_4#ly#0: LayerType :: Handle1((lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: $IsBox($l#3_0_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_4#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_5#ly#0: LayerType :: Handle1((lambda $l#3_0_0_5#heap#0: Heap, $l#3_0_0_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_5#heap#0: Heap, $l#3_0_0_5#c#0: Box :: $IsBox($l#3_0_0_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_5#heap#0: Heap, $l#3_0_0_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_6#ly#0: LayerType :: Handle1((lambda $l#3_0_0_6#heap#0: Heap, $l#3_0_0_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_6#heap#0: Heap, $l#3_0_0_6#c#0: Box :: $IsBox($l#3_0_0_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_6#heap#0: Heap, $l#3_0_0_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_5#ly#0: LayerType :: Handle1((lambda $l#3_0_0_5#heap#0: Heap, $l#3_0_0_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_5#heap#0: Heap, $l#3_0_0_5#c#0: Box :: $IsBox($l#3_0_0_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_5#heap#0: Heap, $l#3_0_0_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_6#ly#0: LayerType :: Handle1((lambda $l#3_0_0_6#heap#0: Heap, $l#3_0_0_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_6#heap#0: Heap, $l#3_0_0_6#c#0: Box :: $IsBox($l#3_0_0_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_6#heap#0: Heap, $l#3_0_0_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_7#ly#0: LayerType :: Handle1((lambda $l#3_0_0_7#heap#0: Heap, $l#3_0_0_7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_7#heap#0: Heap, $l#3_0_0_7#c#0: Box :: $IsBox($l#3_0_0_7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_7#heap#0: Heap, $l#3_0_0_7#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_7#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_8#ly#0: LayerType :: Handle1((lambda $l#3_0_0_8#heap#0: Heap, $l#3_0_0_8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_8#heap#0: Heap, $l#3_0_0_8#c#0: Box :: $IsBox($l#3_0_0_8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_8#heap#0: Heap, $l#3_0_0_8#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_8#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#3_0_0_9#ly#0: LayerType :: Handle1((lambda $l#3_0_0_9#heap#0: Heap, $l#3_0_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_9#heap#0: Heap, $l#3_0_0_9#c#0: Box :: $IsBox($l#3_0_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_9#heap#0: Heap, $l#3_0_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_9#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#2)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#Z#2)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_12#ly#0: LayerType :: Handle1((lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_0_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: $IsBox($l#3_0_0_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(381,81)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_5#ly#0: LayerType :: Handle1((lambda $l#3_0_5#heap#0: Heap, $l#3_0_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_5#heap#0: Heap, $l#3_0_5#c#0: Box :: $IsBox($l#3_0_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_5#heap#0: Heap, $l#3_0_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_6#ly#0: LayerType :: Handle1((lambda $l#3_0_6#heap#0: Heap, $l#3_0_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_6#heap#0: Heap, $l#3_0_6#c#0: Box :: $IsBox($l#3_0_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_6#heap#0: Heap, $l#3_0_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_6#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#3_0_7#ly#0: LayerType :: Handle1((lambda $l#3_0_7#heap#0: Heap, $l#3_0_7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_7#heap#0: Heap, $l#3_0_7#c#0: Box :: $IsBox($l#3_0_7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_7#heap#0: Heap, $l#3_0_7#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_7#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#2)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#Z#2))));
    assume false;
    goto anon99;

  anon169_Else:
    goto anon99;

  anon99:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_9#ly#0: LayerType :: Handle1((lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: $IsBox($l#3_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_9#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(382,14)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#3_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#3_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon172_Then, anon172_Else;

  anon172_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(384,34)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#3_0_1_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#3_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon173_Then, anon173_Else;

  anon173_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(386,38)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sep#Z#2)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sep#Z#2)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume false;
    goto anon102;

  anon173_Else:
    goto anon102;

  anon102:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(387,16)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sep#Z#2)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sep#Z#2)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume false;
    goto anon103;

  anon172_Else:
    goto anon103;

  anon103:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(388,14)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_5#ly#0: LayerType :: Handle1((lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $IsBox($l#3_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_6#ly#0: LayerType :: Handle1((lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $IsBox($l#3_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_5#ly#0: LayerType :: Handle1((lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $IsBox($l#3_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_6#ly#0: LayerType :: Handle1((lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $IsBox($l#3_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elem#Z#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_5#ly#0: LayerType :: Handle1((lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $IsBox($l#3_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_6#ly#0: LayerType :: Handle1((lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $IsBox($l#3_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sep#Z#2)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elem#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_5#ly#0: LayerType :: Handle1((lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $IsBox($l#3_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_6#ly#0: LayerType :: Handle1((lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $IsBox($l#3_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sep#Z#2)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elem#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_5#ly#0: LayerType :: Handle1((lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: $IsBox($l#3_5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_5#heap#0: Heap, $l#3_5#c#0: Box :: SetRef_to_SetBox((lambda $l#3_5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_6#ly#0: LayerType :: Handle1((lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: $IsBox($l#3_6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_6#heap#0: Heap, $l#3_6#c#0: Box :: SetRef_to_SetBox((lambda $l#3_6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_7#ly#0: LayerType :: Handle1((lambda $l#3_7#heap#0: Heap, $l#3_7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_7#heap#0: Heap, $l#3_7#c#0: Box :: $IsBox($l#3_7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_7#heap#0: Heap, $l#3_7#c#0: Box :: SetRef_to_SetBox((lambda $l#3_7#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_8#ly#0: LayerType :: Handle1((lambda $l#3_8#heap#0: Heap, $l#3_8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_8#heap#0: Heap, $l#3_8#c#0: Box :: $IsBox($l#3_8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_8#heap#0: Heap, $l#3_8#c#0: Box :: SetRef_to_SetBox((lambda $l#3_8#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#3_9#ly#0: LayerType :: Handle1((lambda $l#3_9#heap#0: Heap, $l#3_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_9#heap#0: Heap, $l#3_9#c#0: Box :: $IsBox($l#3_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_9#heap#0: Heap, $l#3_9#c#0: Box :: SetRef_to_SetBox((lambda $l#3_9#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#2)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#Z#2)))));
    assume false;
    goto anon104;

  anon166_Else:
    goto anon104;

  anon104:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_12#ly#0: LayerType :: Handle1((lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#3_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: $IsBox($l#3_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: SetRef_to_SetBox((lambda $l#3_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(389,12)"} true;
    havoc e#3_0;
    goto anon174_Then, anon174_Else;

  anon174_Then:
    assume {:partition} $Is(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon175_Then, anon175_Else;

  anon175_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#3_0);
    goto anon107;

  anon175_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_0));
    goto anon107;

  anon174_Else:
    assume {:partition} !($Is(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon107;

  anon107:
    assume (forall e#3_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) } $Is(e#3_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#3_1)));
    assume (forall e#3_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) } $Is(e#3_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3_1)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(390,64)"} true;
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume false;
    goto anon108;

  anon163_Else:
    goto anon108;

  anon108:
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(391,10)"} true;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##cs0#5 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#3 := json#0;
    assume $IsAlloc(##json#3, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##elems#2 := elems#0;
    assume $IsAlloc(##elems#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##elem#1 := elem#Z#0;
    assume $IsAlloc(##elem#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap);
    ##sep#1 := sep#Z#2;
    assume $IsAlloc(##sep#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#2)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#2)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#3)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#2)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#3)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#5), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#2)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elem#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#2)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#2)), Seq#Append($Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), JSON_mUtils_mCursors.Split.t(##elem#1))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##sep#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##sep#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#1)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##sep#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##sep#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#1)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##sep#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##sep#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)));
    assume (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2));
    assume let#7#0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume $Is(let#7#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#7#0#0;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#6 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    goto anon176_Then, anon176_Else;

  anon176_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#4_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#4_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(open#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(open#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(open#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(394,75)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), JSON_mUtils_mCursors.Split.cs(open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)))));
    assume false;
    goto anon110;

  anon176_Else:
    goto anon110;

  anon110:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(395,10)"} true;
    havoc bracketed#Z#0;
    assume $Is(bracketed#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(bracketed#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    ##cs#2 := cs0#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##open#1 := open#0;
    assume $IsAlloc(##open#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    ##elems#3 := elems'#Z#0;
    assume $IsAlloc(##elems#3, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##close#0 := sep#Z#2;
    assume $IsAlloc(##close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) || (forall idx#0: int :: { $Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) - 1));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#1)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#1)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#1)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#36#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#39#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#3)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##close#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##close#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#3)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##close#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##close#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#42#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#43#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#3)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#44#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##close#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##close#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#47#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#Z#0, sep#Z#2));
    assume let#8#0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume $Is(let#8#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume bracketed#Z#0 == let#8#0#0;
    assume $IsAllocBox($Box(bracketed#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#7 := cs0#0;
    assume $IsAlloc(##cs0#7, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs0#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0), cs0#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs0#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(bracketed#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(bracketed#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(397,65)"} true;
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0) == #Wrappers.Result.Success($Box(bracketed#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon150_Else:
    assume {:partition} !(s0#Z#0 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1));
    havoc separator#Z#0;
    assume LitInt(0) <= separator#Z#0 && separator#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#9#0#0 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume true;
    assume $Is(let#9#0#0, Tclass.BoundedInts.uint8());
    assume separator#Z#0 == let#9#0#0;
    havoc pr#Z#0;
    assume $Is(pr#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(pr#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume let#10#0#0 == #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#Z#0)), s0#Z#0)));
    assume true;
    assume $Is(let#10#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume pr#Z#0 == let#10#0#0;
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0) == pr#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon112:
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#0) == pr#3;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $Box($fh$0x#0))): DatatypeType);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser()
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(405,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(406,57): post-state"} true;
    assume 2 != $FunctionContextHeight;
    assume $IsAllocBox($Box(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser();
  modifies $Heap;
  free ensures JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
  free ensures {:id "id25579"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) && JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) && (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
  free ensures {:id "id25580"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) ==> JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) || (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType)): DatatypeType, cs'#1, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var cs'#0_0_0: DatatypeType;
  var ##cs#0_0_0: DatatypeType;
  var ##cs#0_0_1: DatatypeType;
  var ##cs0#0_0_0: DatatypeType;
  var ##spec#0_0_0: HandleType;
  var ##cs#0_0_2: DatatypeType;
  var ##cs#0_0_0_0: DatatypeType;
  var ##cs0#0_0_0_0: DatatypeType;
  var ##spec#0_0_0_0: HandleType;
  var ##cs#0_0_0_0_0: DatatypeType;
  var ##cs#0_0_0_0_1: DatatypeType;
  var ##cs0#0_0_0_0_0: DatatypeType;
  var ##spec#0_0_0_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(407,4): initial state"} true;
    $_reverifyPost := false;
    assume 2 != $FunctionContextHeight;
    assume $IsAllocBox($Box(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    havoc cs'#0_0_0;
    assume $Is(cs'#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume true;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    ##cs#0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    ##cs#0_0_1 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##cs0#0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    goto anon5;

  anon20_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    goto anon5;

  anon5:
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    assume false;
    goto anon6;

  anon19_Else:
    goto anon6;

  anon6:
    ##cs#0_0_2 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    ##cs#0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##cs0#0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    goto anon22_Then, anon22_Else;

  anon22_Then:
    ##cs#0_0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    ##cs#0_0_0_0_1 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap);
    ##cs0#0_0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0_0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    goto anon10;

  anon23_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    goto anon10;

  anon10:
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    assume {:subsumption 0} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)));
    assume {:subsumption 0} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs'#0_0_0))));
    assume {:subsumption 0} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs'#0_0_0)));
    assume {:subsumption 0} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs'#0_0_0)));
    assume {:subsumption 0} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs'#0_0_0), Seq#Append($Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)))));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(412,100)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs'#0_0_0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs'#0_0_0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs'#0_0_0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs'#0_0_0), Seq#Append($Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)))));
    assume false;
    goto anon11;

  anon22_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(413,12)"} true;
    goto anon13;

  anon21_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0));
    goto anon13;

  anon13:
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs'#0_0_0))));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs'#0_0_0)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs'#0_0_0)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs'#0_0_0), Seq#Append($Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_0))): DatatypeType)))));
    assume false;
    goto anon15;

  anon18_Else:
    assume (forall cs'#0_0_1: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_1) } $Is(cs'#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && Lit(true) ==> Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_1)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close, cs'#0_0_1))): DatatypeType, cs'#0_0_1, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    goto anon15;

  anon15:
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(415,8)"} true;
    assume {:subsumption 0} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) ==> JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) || (forall cs'#2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#2))): DatatypeType } $Is(cs'#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())), $Box(cs'#2))): DatatypeType)): DatatypeType, cs'#2, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()))));
    assume false;
    goto anon16;

  anon17_Else:
    goto anon16;

  anon16:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(416,6)"} true;
    return;
}



function JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 5 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var open#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#0) && (var elems#0 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#0)); JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#0)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#0), p#0) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#0), p#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (var close#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs#0, json#0, open#0, elems#0)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#0) else (var open#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (var elems#0 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#0)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#0), p#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#0) else (var close#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#0, elems#0, close#0))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs#0, json#0, open#0, elems#0)))))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var open#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#1) && (var elems#1 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#1)); JSON_mUtils_mCursors.Split.SP_q(open#1) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#1)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#1), p#1) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#1), p#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (var close#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), open#1, elems#1, close#1)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#1, elems#1)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#1) else (var open#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (var elems#1 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#1)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#1), p#1); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#1) else (var close#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs#0), open#1, elems#1, close#1))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs#0), Lit(json#0), open#1, elems#1)))))));
}

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#requires(DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#requires(cs#0, json#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

function JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Bracketed (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25606"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)));
  free ensures {:id "id25607"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
  free ensures {:id "id25608"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
  free ensures {:id "id25609"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
  free ensures {:id "id25610"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Bracketed (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##parser#0: DatatypeType;
  var open#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var elems#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var p#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var ##parser#1: DatatypeType;
  var close#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##open#0: DatatypeType;
  var ##elems#0: DatatypeType;
  var ##close#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##json#0: DatatypeType;
  var ##open#1: DatatypeType;
  var ##elems#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Bracketed", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(419,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    goto anon5;

  anon17_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon16_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen()), Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen());
    assume $IsAlloc(##parser#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen()));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen()));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen()));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc open#Z#0;
    assume $Is(open#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())));
    assume open#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(open#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(open#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(open#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(425,48)"} true;
    havoc elems#Z#0;
    assume $Is(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume let#2#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems#Z#0 == let#2#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    newtype$check#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#Z#0)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    havoc p#Z#0;
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume 2 != $FunctionContextHeight;
    assume let#3#0#0 == #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose());
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()));
    assume p#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(p#Z#0), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    call CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser();
    call CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser();
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(430,28)"} true;
    assume {:subsumption 0} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0) ==> JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0) || (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#Z#0), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#Z#0), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#Z#0), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(p#Z#0)));
    assume false;
    goto anon11;

  anon20_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(431,8)"} true;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(open#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#1 := p#Z#0;
    assume $IsAlloc(##parser#1, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)));
    assume (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume let#4#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon21_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc close#Z#0;
    assume $Is(close#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())));
    assume close#Z#0 == let#5#0#0;
    ##cs#2 := cs#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##open#0 := open#Z#0;
    assume $IsAlloc(##open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    ##elems#0 := elems#Z#0;
    assume $IsAlloc(##elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##close#0 := close#Z#0;
    assume $IsAlloc(##close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap);
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) || (forall idx#0: int :: { $Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) - 1));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#0)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##close#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##close#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##close#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##close#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##close#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##close#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#Z#0, elems#Z#0, close#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#Z#0, elems#Z#0, close#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0) == #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#Z#0, elems#Z#0, close#Z#0)));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#Z#0, elems#Z#0, close#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon19_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#Z#0)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##open#1 := open#Z#0;
    assume $IsAlloc(##open#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap);
    ##elems#1 := elems#Z#0;
    assume $IsAlloc(##elems#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#1)), JSON_mUtils_mCursors.Cursor__.s(##cs0#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#1)) > JSON_mUtils_mCursors.Cursor__.beg(##cs0#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#1)) == JSON_mUtils_mCursors.Cursor__.end(##cs0#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#1), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs#0, json#0, open#Z#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0) == JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs#0, json#0, open#Z#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs#0, json#0, open#Z#0, elems#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon15:
    assume JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed, cs#0, json#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##c#1: int;
  var ##s#0: Seq;
  var pf#0: DatatypeType;
  var ##c#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(438,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(439,25): post-state"} true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    assume $IsAllocBox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    assume $IsAllocBox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume $IsAlloc(##c#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    ##s#0 := JSON_mGrammar.Bracketed.data(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0));
    havoc pf#0;
    assume $Is(pf#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(pf#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#2 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume $IsAlloc(##c#2, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    goto anon6;

  anon8_Else:
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    goto anon6;

  anon7_Else:
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    goto anon6;

  anon6:
    assume (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));
  modifies $Heap;
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
  free ensures {:id "id25696"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
  free ensures {:id "id25697"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0));
  free ensures {:id "id25698"} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0)) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0)) && (forall idx#0: int :: { $Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#0)): DatatypeType)) <==> idx#0 == Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) - 1));
  free ensures (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(x#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()))));
  free ensures {:id "id25699"} (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
  free ensures {:id "id25700"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
  free ensures {:id "id25701"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0));
  free ensures {:id "id25702"} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0)) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), JSON_mGrammar.Bracketed.data(x#0)) || (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#1)): DatatypeType } LitInt(0) <= idx#1 && idx#1 < Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#1)): DatatypeType)) <==> idx#1 == Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) - 1));
  free ensures (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(x#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()))));
  free ensures {:id "id25703"} (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var xlt#0: DatatypeType where $Is(xlt#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) && $IsAlloc(xlt#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Heap);
  var xrt#0: DatatypeType where $Is(xrt#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) && $IsAlloc(xrt#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Heap);
  var pf#0_0: DatatypeType;
  var ##c#0_0: int;
  var xtt#0_0_0: DatatypeType where $Is(xtt#0_0_0, Tclass.JSON_mGrammar.jcomma()) && $IsAlloc(xtt#0_0_0, Tclass.JSON_mGrammar.jcomma(), $Heap);

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(444,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    xlt#0 := $Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(445,29)"} true;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    xrt#0 := $Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(446,30)"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc pf#0_0;
    assume $Is(pf#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    goto anon4;

  anon13_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    goto anon4;

  anon4:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()));
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR());
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume true;
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    xtt#0_0_0 := $Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(451,34)"} true;
    goto anon8;

  anon14_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    goto anon8;

  anon8:
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR())));
    assume false;
    goto anon10;

  anon11_Else:
    assume (forall pf#0_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#0_1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_1)) } $Is(pf#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR()));
    goto anon10;

  anon10:
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(453,6)"} true;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Open (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Open();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Open (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Open();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Open (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Open();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Close (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Close();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Close (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Close();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Close (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Close();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_BracketedFromParts (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__BracketedFromParts();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_BracketedFromParts (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__BracketedFromParts();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_BracketedFromParts (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__BracketedFromParts();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_AppendWithSuffix (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__AppendWithSuffix();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_AppendWithSuffix (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__AppendWithSuffix();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_AppendWithSuffix (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__AppendWithSuffix();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_AppendLast (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__AppendLast();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_AppendLast (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__AppendLast();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_AppendLast (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__AppendLast();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Elements (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Elements();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Elements (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Elements();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Elements (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Elements();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Bracketed (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Bracketed();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Bracketed (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Bracketed();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.reveal_Bracketed (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.reveal__Bracketed();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Bracketed;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.jopen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.jopen(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.jopen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.jopen(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.jopen", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(126,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(v#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    return;

  anon4_Else:
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN())));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()))));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN())));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()))) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN())))), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN())));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.jclose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.jclose(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.jclose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mSequences.jclose(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.jclose", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(127,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(v#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    return;

  anon4_Else:
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())))), Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#224 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#224))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#226 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#226)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#336 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#336))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#338 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#338)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#340 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#340)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#336 := Wrappers.Option.value(this); v#336)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#338 := Lit(Wrappers.Option.value(Lit(this))); v#338)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#340 := Lit(Wrappers.Option.value(Lit(this))); v#340)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#224 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#224)) else (var e#224 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#226 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#226))) else (var e#226 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#336 := Wrappers.Result.value(this); s#336) else (var e#336 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#338 := Lit(Wrappers.Result.value(Lit(this))); s#338) else (var e#338 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#340 := Lit(Wrappers.Result.value(Lit(this))); s#340) else (var e#340 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#336 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#336)) else (var e#336 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#336)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#338 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#338))) else (var e#338 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#338)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#340 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#340))) else (var e#340 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#340)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#132: int, y#132: int :: { Mul(x#132, y#132) } Mul(x#132, y#132) == Mul(y#132, x#132)) && (forall x#133: int, y#133: int, z#88: int :: { Mul(x#133 + y#133, z#88) } Mul(x#133 + y#133, z#88) == Mul(x#133, z#88) + Mul(y#133, z#88)) && (forall x#134: int, y#134: int, z#89: int :: { Mul(x#134 - y#134, z#89) } Mul(x#134 - y#134, z#89) == Mul(x#134, z#89) - Mul(y#134, z#89));

axiom MulInternals.__default.MulAuto() <==> (forall x#135: int, y#135: int :: { Mul(x#135, y#135) } Mul(x#135, y#135) == Mul(y#135, x#135)) && (forall x#136: int, y#136: int, z#90: int :: { Mul(x#136 + y#136, z#90) } Mul(x#136 + y#136, z#90) == Mul(x#136, z#90) + Mul(y#136, z#90)) && (forall x#137: int, y#137: int, z#91: int :: { Mul(x#137 - y#137, z#91) } Mul(x#137 - y#137, z#91) == Mul(x#137, z#91) - Mul(y#137, z#91));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#160: int :: { Mod(Mod(x#160, n#0), n#0) } Mod(Mod(x#160, n#0), n#0) == Mod(x#160, n#0)) && (forall x#161: int :: { Mod(x#161, n#0) } LitInt(0) <= x#161 && x#161 < n#0 <==> Mod(x#161, n#0) == x#161) && (forall x#162: int, y#80: int :: { Mod(x#162 + y#80, n#0) } (var z#78 := Mod(x#162, n#0) + Mod(y#80, n#0); (LitInt(0) <= z#78 && z#78 < n#0 && Mod(x#162 + y#80, n#0) == z#78) || (n#0 <= z#78 && z#78 < n#0 + n#0 && Mod(x#162 + y#80, n#0) == z#78 - n#0))) && (forall x#163: int, y#81: int :: { Mod(x#163 - y#81, n#0) } (var z#79 := Mod(x#163, n#0) - Mod(y#81, n#0); (LitInt(0) <= z#79 && z#79 < n#0 && Mod(x#163 - y#81, n#0) == z#79) || (0 - n#0 <= z#79 && z#79 < 0 && Mod(x#163 - y#81, n#0) == z#79 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#164: int :: { Mod(Mod(x#164, n#0), n#0) } Mod(Mod(x#164, LitInt(n#0)), LitInt(n#0)) == Mod(x#164, LitInt(n#0))) && (forall x#165: int :: { Mod(x#165, n#0) } LitInt(0) <= x#165 && x#165 < n#0 <==> Mod(x#165, LitInt(n#0)) == x#165) && (forall x#166: int, y#82: int :: { Mod(x#166 + y#82, n#0) } (var z#80 := Mod(x#166, LitInt(n#0)) + Mod(y#82, LitInt(n#0)); (LitInt(0) <= z#80 && z#80 < n#0 && Mod(x#166 + y#82, LitInt(n#0)) == z#80) || (LitInt(n#0) <= z#80 && z#80 < n#0 + n#0 && Mod(x#166 + y#82, LitInt(n#0)) == z#80 - n#0))) && (forall x#167: int, y#83: int :: { Mod(x#167 - y#83, n#0) } (var z#81 := Mod(x#167, LitInt(n#0)) - Mod(y#83, LitInt(n#0)); (LitInt(0) <= z#81 && z#81 < n#0 && Mod(x#167 - y#83, LitInt(n#0)) == z#81) || (LitInt(0 - n#0) <= z#81 && z#81 < 0 && Mod(x#167 - y#83, LitInt(n#0)) == z#81 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#114: int :: { Div(x#114, n#0) } LitInt(0) <= x#114 && x#114 < n#0 <==> Div(x#114, n#0) == LitInt(0)) && (forall x#115: int, y#76: int :: { Div(x#115 + y#76, n#0) } (var z#74 := Mod(x#115, n#0) + Mod(y#76, n#0); (LitInt(0) <= z#74 && z#74 < n#0 && Div(x#115 + y#76, n#0) == Div(x#115, n#0) + Div(y#76, n#0)) || (n#0 <= z#74 && z#74 < n#0 + n#0 && Div(x#115 + y#76, n#0) == Div(x#115, n#0) + Div(y#76, n#0) + 1))) && (forall x#116: int, y#77: int :: { Div(x#116 - y#77, n#0) } (var z#75 := Mod(x#116, n#0) - Mod(y#77, n#0); (LitInt(0) <= z#75 && z#75 < n#0 && Div(x#116 - y#77, n#0) == Div(x#116, n#0) - Div(y#77, n#0)) || (0 - n#0 <= z#75 && z#75 < 0 && Div(x#116 - y#77, n#0) == Div(x#116, n#0) - Div(y#77, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#117: int :: { Div(x#117, n#0) } LitInt(0) <= x#117 && x#117 < n#0 <==> Div(x#117, LitInt(n#0)) == LitInt(0)) && (forall x#118: int, y#78: int :: { Div(x#118 + y#78, n#0) } (var z#76 := Mod(x#118, LitInt(n#0)) + Mod(y#78, LitInt(n#0)); (LitInt(0) <= z#76 && z#76 < n#0 && Div(x#118 + y#78, LitInt(n#0)) == Div(x#118, LitInt(n#0)) + Div(y#78, LitInt(n#0))) || (LitInt(n#0) <= z#76 && z#76 < n#0 + n#0 && Div(x#118 + y#78, LitInt(n#0)) == Div(x#118, LitInt(n#0)) + Div(y#78, LitInt(n#0)) + 1))) && (forall x#119: int, y#79: int :: { Div(x#119 - y#79, n#0) } (var z#77 := Mod(x#119, LitInt(n#0)) - Mod(y#79, LitInt(n#0)); (LitInt(0) <= z#77 && z#77 < n#0 && Div(x#119 - y#79, LitInt(n#0)) == Div(x#119, LitInt(n#0)) - Div(y#79, LitInt(n#0))) || (LitInt(0 - n#0) <= z#77 && z#77 < 0 && Div(x#119 - y#79, LitInt(n#0)) == Div(x#119, LitInt(n#0)) - Div(y#79, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#26 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#26) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#26)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#26 := lv#0; (var dt_update#end#0#26 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#26), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#26), dt_update#end#0#26))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#27 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#27) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#27)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#27 := Lit(lv#0); (var dt_update#end#0#27 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#27)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#27)), dt_update#end#0#27)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#28: char :: { Seq#Contains(s#0, $Box(c#28)) } $Is(c#28, TChar) && Seq#Contains(s#0, $Box(c#28)) ==> char#ToInt(c#28) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#28: char :: { Seq#Contains(s#0, $Box(c#28)) } $Is(c#28, TChar) && Seq#Contains(s#0, $Box(c#28)) ==> char#ToInt(c#28) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#56#i#0): int)): char))), (lambda $l#56#heap#0: Heap, $l#56#i#0: Box :: $IsBox($l#56#i#0, TInt) && LitInt(0) <= $Unbox($l#56#i#0): int && $Unbox($l#56#i#0): int < Seq#Length(s#0)), (lambda $l#56#heap#0: Heap, $l#56#i#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#29: char :: { Seq#Contains(s#0, $Box(c#29)) } $Is(c#29, TChar) && Seq#Contains(s#0, $Box(c#29)) ==> char#ToInt(c#29) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#58#i#0): int)): char))), (lambda $l#58#heap#0: Heap, $l#58#i#0: Box :: $IsBox($l#58#i#0, TInt) && LitInt(0) <= $Unbox($l#58#i#0): int && $Unbox($l#58#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#58#heap#0: Heap, $l#58#i#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#60 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#30 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#60 := (if b#60 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#60)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#30)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#60)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#61 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#30 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#61 := (if b#61 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#61)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#30 := Seq#Create(TChar, $Heap, Seq#Length(bs0#30), Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#30, $Unbox($l#49#idx#0): int)): int))), (lambda $l#49#heap#0: Heap, $l#49#idx#0: Box :: $IsBox($l#49#idx#0, TInt) && LitInt(0) <= $Unbox($l#49#idx#0): int && $Unbox($l#49#idx#0): int < Seq#Length(bs0#30)), (lambda $l#49#heap#0: Heap, $l#49#idx#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#30), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#61))))) else (var err#30 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#30)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#64 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#32 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#64 := (if b#64 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#64)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#32)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#64)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#65 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#32 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#65 := (if b#65 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#65)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#32 := Seq#Create(TChar, $Heap, Seq#Length(bs0#32), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#32, $Unbox($l#52#idx#0): int)): int))), (lambda $l#52#heap#0: Heap, $l#52#idx#0: Box :: $IsBox($l#52#idx#0, TInt) && LitInt(0) <= $Unbox($l#52#idx#0): int && $Unbox($l#52#idx#0): int < Seq#Length(bs0#32)), (lambda $l#52#heap#0: Heap, $l#52#idx#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#32), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#65))))) else (var err#32 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#32)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#68 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#34 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#68 := (if b#68 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#68)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#34)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#68)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#69 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#34 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#69 := (if b#69 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#69)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#34 := Seq#Create(TChar, $Heap, Seq#Length(bs0#34), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#34, $Unbox($l#55#idx#0): int)): int))), (lambda $l#55#heap#0: Heap, $l#55#idx#0: Box :: $IsBox($l#55#idx#0, TInt) && LitInt(0) <= $Unbox($l#55#idx#0): int && $Unbox($l#55#idx#0): int < Seq#Length(bs0#34)), (lambda $l#55#heap#0: Heap, $l#55#idx#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#34), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#69))))) else (var err#34 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#34)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#7: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#7)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#7)): int } LitInt(0) <= idx#7 && idx#7 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#7 && idx#7 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#7)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#7)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#10 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#10 := this; (var dt_update#beg#0#10 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#10), dt_update#beg#0#10, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#10), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#10)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#11 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#11 := Lit(this); (var dt_update#beg#0#11 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#11)), dt_update#beg#0#11, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#11)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#11)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#51#v#0): DatatypeType))), (lambda $l#51#heap#0: Heap, $l#51#v#0: Box :: $IsBox($l#51#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#51#heap#0: Heap, $l#51#v#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#52#v#0): DatatypeType))), (lambda $l#52#heap#0: Heap, $l#52#v#0: Box :: $IsBox($l#52#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#52#heap#0: Heap, $l#52#v#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#53#v#0): DatatypeType))), (lambda $l#53#heap#0: Heap, $l#53#v#0: Box :: $IsBox($l#53#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#53#heap#0: Heap, $l#53#v#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#10 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#10 := this; (var dt_update#point#0#10 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#10), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#10), dt_update#point#0#10, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#10)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#11 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#11 := Lit(this); (var dt_update#point#0#11 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#11)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#11)), dt_update#point#0#11, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#11)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#10 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#10)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#10 := this; (var dt_update#point#0#10 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#10), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#10), dt_update#point#0#10, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#10)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#11 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#11)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#11 := Lit(this); (var dt_update#point#0#11 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#11)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#11)), dt_update#point#0#11, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#11)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#10 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#10 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#10 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#10 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#10))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#11 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#11 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#11 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#11 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#11)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#18: int :: { Seq#Contains(bs#0, $Box(b#18)) } LitInt(0) <= b#18 && b#18 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#18)) ==> b#18 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#18: int :: { Seq#Contains(bs#0, $Box(b#18)) } LitInt(0) <= b#18 && b#18 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#18)) ==> b#18 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#15 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15) && (var ps#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#15, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#15 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#15) else (var ps#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#15)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#15, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#19: int :: { Seq#Contains(bs#0, $Box(b#19)) } LitInt(0) <= b#19 && b#19 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#19)) ==> b#19 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#16 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16) && (var ps#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#16, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#16 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#16) else (var ps#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#16)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#16, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#20: int :: { Seq#Contains(bs#0, $Box(b#20)) } LitInt(0) <= b#20 && b#20 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#20)) ==> b#20 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#17 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17) && (var ps#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#17, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#17 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#17) else (var ps#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#17)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#17, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#7: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#7)): int } LitInt(0) <= idx#7 && idx#7 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#7 && idx#7 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#7)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#32 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#32)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#31 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#31)))) else (var st#31 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#31))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#34 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#34)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#33 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#33)))) else (var st#33 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#33))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#36 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#36)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#35 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#35)))) else (var st#35 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#35))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#40#heap#0: Heap, $l#40#_v0#0: Box :: $IsBox($l#40#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#40#heap#0: Heap, $l#40#_v0#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#41#heap#0: Heap, $l#41#_v1#0: Box :: $IsBox($l#41#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#41#heap#0: Heap, $l#41#_v1#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#44#heap#0: Heap, $l#44#_v0#0: Box :: $IsBox($l#44#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#44#heap#0: Heap, $l#44#_v0#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#45#heap#0: Heap, $l#45#_v1#0: Box :: $IsBox($l#45#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#45#heap#0: Heap, $l#45#_v1#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#cs#0: Box :: $Box(Lit(false))), (lambda $l#60#heap#0: Heap, $l#60#cs#0: Box :: $IsBox($l#60#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#60#heap#0: Heap, $l#60#cs#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#61#heap#0: Heap, $l#61#cs#0: Box :: $IsBox($l#61#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#61#heap#0: Heap, $l#61#cs#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#62#heap#0: Heap, $l#62#_v2#0: Box :: $IsBox($l#62#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#62#heap#0: Heap, $l#62#_v2#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#cs#0: Box :: $Box(Lit(false))), (lambda $l#66#heap#0: Heap, $l#66#cs#0: Box :: $IsBox($l#66#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#66#heap#0: Heap, $l#66#cs#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#67#heap#0: Heap, $l#67#cs#0: Box :: $IsBox($l#67#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#67#heap#0: Heap, $l#67#cs#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#68#heap#0: Heap, $l#68#_v2#0: Box :: $IsBox($l#68#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#68#heap#0: Heap, $l#68#_v2#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#10))): DatatypeType } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#10))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#10))): DatatypeType)): DatatypeType, cs'#10, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#10: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#10))): DatatypeType } $Is(cs'#10, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#10))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#10))): DatatypeType)): DatatypeType, cs'#10, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#11: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#11))): DatatypeType } $Is(cs'#11, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#11))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#11))): DatatypeType)): DatatypeType, cs'#11, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#11: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#11))): DatatypeType } $Is(cs'#11, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#11))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#11))): DatatypeType)): DatatypeType, cs'#11, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#30: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#30)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#30))): bool } $Is(cs'#30, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#30))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#30)))) && ((forall cs'#30: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#30)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#30))): bool } $Is(cs'#30, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#30))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#30))) ==> (forall cs'#31: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#31))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#31, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#31: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#31))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#31, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#31))): bool) ==> (forall cs'#32: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#32))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#32))): bool } $Is(cs'#32, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#32))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#32))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#32))): DatatypeType)): DatatypeType, cs'#32, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#30: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#30)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#30))): bool } $Is(cs'#30, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#30))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#30))) && (forall cs'#31: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#31))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#31, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#31, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#31))): bool) && (forall cs'#32: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#32))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#32))): bool } $Is(cs'#32, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#32))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#32))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#32))): DatatypeType)): DatatypeType, cs'#32, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#33: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#33)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#33))): bool } $Is(cs'#33, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#33))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#33)))) && ((forall cs'#33: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#33)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#33))): bool } $Is(cs'#33, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#33))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#33))) ==> (forall cs'#34: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#34))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#34, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#34, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#34, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#34, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#34: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#34))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#34, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#34, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#34, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#34))): bool) ==> (forall cs'#35: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#35))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#35))): bool } $Is(cs'#35, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#35))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType)): DatatypeType, cs'#35, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#33: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#33)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#33))): bool } $Is(cs'#33, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#33))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#33))) && (forall cs'#34: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#34))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#34, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#34, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#34, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#34))): bool) && (forall cs'#35: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#35))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#35))): bool } $Is(cs'#35, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#35))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType)): DatatypeType, cs'#35, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#12: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#12)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#12)) ==> LitInt(0) <= d#12 && d#12 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#30 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#31 := Seq#Append(digits'#30, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#31))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#31 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#32 := Seq#Append(digits'#31, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#32))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#32 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#33 := Seq#Append(digits'#32, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#33))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#12: Box :: { Seq#Contains(chars#0, c#12) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#12) } $IsBox(c#12, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#12) ==> Seq#Contains(chars#0, c#12)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#25: int :: { Seq#Contains(digits#0, $Box(d#25)) } Seq#Contains(digits#0, $Box(d#25)) ==> LitInt(0) <= d#25 && d#25 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#25: int :: { Seq#Contains(digits#0, $Box(d#25)) } Seq#Contains(digits#0, $Box(d#25)) ==> LitInt(0) <= d#25 && d#25 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#26: int :: { Seq#Contains(digits#0, $Box(d#26)) } Seq#Contains(digits#0, $Box(d#26)) ==> LitInt(0) <= d#26 && d#26 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#12: Box :: { Seq#Contains(chars#0, c#12) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#12) } $IsBox(c#12, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#12) ==> Seq#Contains(chars#0, c#12)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#20 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#20) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#20), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#20 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#20), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#21 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#21) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#21), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#21 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#21), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#32: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#32)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#32) } $IsBox(c#32, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#32) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#32)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#33: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#33)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#33) } $IsBox(c#33, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#33) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#33)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#34: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#34)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#34) } $IsBox(c#34, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#34) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#34)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(Seq#Contains(chars#0, $l#16#c#0))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#23: Box :: { Map#Domain(digits#0)[c#23] } { Seq#Contains(str#0, c#23) } $IsBox(c#23, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#23) ==> Map#Domain(digits#0)[c#23])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#23: Box :: { Map#Domain(digits#0)[c#23] } { Seq#Contains(str#0, c#23) } $IsBox(c#23, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#23) ==> Map#Domain(digits#0)[c#23])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#24: Box :: { Map#Domain(digits#0)[c#24] } { Seq#Contains(str#0, c#24) } $IsBox(c#24, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#24) ==> Map#Domain(digits#0)[c#24])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box(Map#Domain(digits#0)[$l#45#c#0])), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box(Map#Domain(digits#0)[$l#45#c#0])), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(Map#Domain(digits#0)[$l#46#c#0])), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(Map#Domain(digits#0)[$l#47#c#0])), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#30 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#30) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#30) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#30)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#30) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#30)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#30 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#30) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#30) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#30)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#30) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#30))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#30 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#30) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#30) else (var tl#60 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#30)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#60)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#30 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#30) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#30) else (var tl#61 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#30)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#61)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#31 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#31) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#31) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#31)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#31) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#31)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#31 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#31) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#31) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#31)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#31) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#31))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#31 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#31) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#31) else (var tl#62 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#31)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#62)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#31 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#31) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#31) else (var tl#63 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#31)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#63)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#32 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#32) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#32) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#32)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#32) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#32)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#32 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#32) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#32) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#32)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#32) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#32))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#32 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#32) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#32) else (var tl#64 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#32)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#64)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#32 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#32) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#32) else (var tl#65 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#32)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#65)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#12: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#12)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#12)) ==> LitInt(0) <= d#12 && d#12 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#30 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#31 := Seq#Append(digits'#30, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#31))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#31 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#32 := Seq#Append(digits'#31, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#32))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#32 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#33 := Seq#Append(digits'#32, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#33))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#12: char :: { Seq#Contains(chars#0, $Box(c#12)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#12)) ==> Seq#Contains(chars#0, $Box(c#12))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#25: int :: { Seq#Contains(digits#0, $Box(d#25)) } Seq#Contains(digits#0, $Box(d#25)) ==> LitInt(0) <= d#25 && d#25 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#25: int :: { Seq#Contains(digits#0, $Box(d#25)) } Seq#Contains(digits#0, $Box(d#25)) ==> LitInt(0) <= d#25 && d#25 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#26: int :: { Seq#Contains(digits#0, $Box(d#26)) } Seq#Contains(digits#0, $Box(d#26)) ==> LitInt(0) <= d#26 && d#26 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#12: char :: { Seq#Contains(chars#0, $Box(c#12)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#12)) ==> Seq#Contains(chars#0, $Box(c#12))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#20 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#20) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#20), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#20 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#20), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#21 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#21) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#21), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#21 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#21), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#32: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#32))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#32)) } $Is(c#32, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#32)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#32))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#33: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#33))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#33)) } $Is(c#33, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#33)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#33))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#34: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#34))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#34)) } $Is(c#34, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#34)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#34))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(Seq#Contains(chars#0, $l#16#c#0))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, TChar)), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#23: char :: { Map#Domain(digits#0)[$Box(c#23)] } { Seq#Contains(str#0, $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(str#0, $Box(c#23)) ==> Map#Domain(digits#0)[$Box(c#23)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#23: char :: { Map#Domain(digits#0)[$Box(c#23)] } { Seq#Contains(str#0, $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(str#0, $Box(c#23)) ==> Map#Domain(digits#0)[$Box(c#23)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#24: char :: { Map#Domain(digits#0)[$Box(c#24)] } { Seq#Contains(str#0, $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(str#0, $Box(c#24)) ==> Map#Domain(digits#0)[$Box(c#24)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box(Map#Domain(digits#0)[$l#45#c#0])), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, TChar)), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box(Map#Domain(digits#0)[$l#45#c#0])), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, TChar)), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(Map#Domain(digits#0)[$l#46#c#0])), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, TChar)), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(Map#Domain(digits#0)[$l#47#c#0])), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, TChar)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#30 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#30) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#30) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#30)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#30) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#30)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#30 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#30) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#30) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#30)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#30) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#30))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#30 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#30) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#30) else (var tl#60 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#30)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#60)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#30 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#30) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#30) else (var tl#61 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#30)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#61)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#31 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#31) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#31) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#31)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#31) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#31)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#31 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#31) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#31) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#31)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#31) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#31))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#31 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#31) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#31) else (var tl#62 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#31)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#62)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#31 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#31) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#31) else (var tl#63 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#31)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#63)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#32 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#32) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#32) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#32)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#32) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#32)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#32 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#32) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#32) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#32)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#32) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#32))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#32 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#32) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#32) else (var tl#64 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#32)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#64)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#32 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#32) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#32) else (var tl#65 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#32)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#65)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#11: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#11)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#11)) } $Is(c#11, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#11)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#11))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#14#c#0))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, TChar)), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#21: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)] } { Seq#Contains(str#0, $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(str#0, $Box(c#21)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#21: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)] } { Seq#Contains(str#0, $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(str#0, $Box(c#21)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#21)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#22: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#22)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#22)] } { Seq#Contains(str#0, $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(str#0, $Box(c#22)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#22)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#22)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#35#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#35#c#0]): int < base#0)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, TChar)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#35#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#35#c#0]): int < base#0)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, TChar)), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#36#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#36#c#0]): int < base#0)), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, TChar)), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#32 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#32)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#64 := JSON_mErrors.DeserializationError.b(this); (var b0#32 := JSON_mErrors.DeserializationError.expected(this); (var c#64 := (if b#64 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#64)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#32)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#64)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#65 := JSON_mErrors.DeserializationError.b(this); (var bs0#32 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#65 := (if b#65 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#65)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#32 := Seq#Create(TChar, $Heap, Seq#Length(bs0#32), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#32, $Unbox($l#52#idx#0): int)): int))), (lambda $l#52#heap#0: Heap, $l#52#idx#0: Box :: $IsBox($l#52#idx#0, TInt) && LitInt(0) <= $Unbox($l#52#idx#0): int && $Unbox($l#52#idx#0): int < Seq#Length(bs0#32)), (lambda $l#52#heap#0: Heap, $l#52#idx#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#32), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#65))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#34 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#34)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#68 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#34 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#68 := (if b#68 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#68)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#34)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#68)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#69 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#34 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#69 := (if b#69 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#69)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#34 := Seq#Create(TChar, $Heap, Seq#Length(bs0#34), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#34, $Unbox($l#55#idx#0): int)): int))), (lambda $l#55#heap#0: Heap, $l#55#idx#0: Box :: $IsBox($l#55#idx#0, TInt) && LitInt(0) <= $Unbox($l#55#idx#0): int && $Unbox($l#55#idx#0): int < Seq#Length(bs0#34)), (lambda $l#55#heap#0: Heap, $l#55#idx#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#34), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#69))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#33 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#33, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#32 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#32, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#32 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#32)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#35 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#35, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#34 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#34, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#34 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#34)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#20: int :: { JSON_mGrammar.__default.Blank_q(b#20) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) } LitInt(0) <= b#20 && b#20 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#20))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#20: int :: { JSON_mGrammar.__default.Blank_q(b#20) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) } LitInt(0) <= b#20 && b#20 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) ==> JSON_mGrammar.__default.Blank_q(b#20))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#21: int :: { JSON_mGrammar.__default.Blank_q(b#21) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#21)) } LitInt(0) <= b#21 && b#21 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#21)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#21))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#21: int :: { JSON_mGrammar.__default.Blank_q(b#21) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#21)) } LitInt(0) <= b#21 && b#21 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#21)) ==> JSON_mGrammar.__default.Blank_q(b#21))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#20: int :: { $Unbox(Seq#Index(s#0, idx#20)): DatatypeType } LitInt(0) <= idx#20 && idx#20 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#20)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#20: int :: { $Unbox(Seq#Index(s#0, idx#20)): DatatypeType } LitInt(0) <= idx#20 && idx#20 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#20)): DatatypeType)) <==> idx#20 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#21: int :: { $Unbox(Seq#Index(s#0, idx#21)): DatatypeType } LitInt(0) <= idx#21 && idx#21 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#21)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#21: int :: { $Unbox(Seq#Index(s#0, idx#21)): DatatypeType } LitInt(0) <= idx#21 && idx#21 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#21)): DatatypeType)) <==> idx#21 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#20: int :: { JSON_mGrammar.__default.Digit_q(b#20) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) } LitInt(0) <= b#20 && b#20 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#20))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#20: int :: { JSON_mGrammar.__default.Digit_q(b#20) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) } LitInt(0) <= b#20 && b#20 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#20)) ==> JSON_mGrammar.__default.Digit_q(b#20))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#21: int :: { JSON_mGrammar.__default.Digit_q(b#21) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#21)) } LitInt(0) <= b#21 && b#21 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#21)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#21))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#21: int :: { JSON_mGrammar.__default.Digit_q(b#21) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#21)) } LitInt(0) <= b#21 && b#21 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#21)) ==> JSON_mGrammar.__default.Digit_q(b#21))));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$6x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$6x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$6x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#21: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#21) } { Seq#Contains(ts#0, d#21) } $IsBox(d#21, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#21) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#21))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#21: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#21) } { Seq#Contains(ts#0, d#21) } $IsBox(d#21, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#21) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#21))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#22: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#22) } { Seq#Contains(ts#0, d#22) } $IsBox(d#22, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#22) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#22))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#23: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#23) } { Seq#Contains(ts#0, d#23) } $IsBox(d#23, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#23) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#23))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#21: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#21)) } $Is(d#21, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#21) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#21)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#21: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#21)) } $Is(d#21, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#21) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#21)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#22: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#22)) } $Is(d#22, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#22) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#22)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#23: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#23)) } $Is(d#23, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#23) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#23)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$6x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$6x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$6x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$6x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$6x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$6x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$6x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$6x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$6x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#44#d#0: DatatypeType :: $Is($l#44#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#44#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#44#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#45#ly#0, $Unbox($l#45#d#0): DatatypeType))), (lambda $l#45#heap#0: Heap, $l#45#d#0: Box :: $IsBox($l#45#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#45#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#45#heap#0: Heap, $l#45#d#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#43#ly#0, $Unbox($l#43#d#0): DatatypeType))), (lambda $l#43#heap#0: Heap, $l#43#d#0: Box :: $IsBox($l#43#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#43#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#43#heap#0: Heap, $l#43#d#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#47#d#0: DatatypeType :: $Is($l#47#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#47#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#47#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#48#ly#0, $Unbox($l#48#d#0): DatatypeType))), (lambda $l#48#heap#0: Heap, $l#48#d#0: Box :: $IsBox($l#48#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#48#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#48#heap#0: Heap, $l#48#d#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#46#ly#0, $Unbox($l#46#d#0): DatatypeType))), (lambda $l#46#heap#0: Heap, $l#46#d#0: Box :: $IsBox($l#46#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#46#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#46#heap#0: Heap, $l#46#d#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#44#d#0: DatatypeType :: $Is($l#44#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#44#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#44#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#45#ly#0, $Unbox($l#45#d#0): DatatypeType))), (lambda $l#45#heap#0: Heap, $l#45#d#0: Box :: $IsBox($l#45#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#45#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#45#heap#0: Heap, $l#45#d#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#43#ly#0, $Unbox($l#43#d#0): DatatypeType))), (lambda $l#43#heap#0: Heap, $l#43#d#0: Box :: $IsBox($l#43#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#43#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#43#heap#0: Heap, $l#43#d#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#47#d#0: DatatypeType :: $Is($l#47#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#47#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#47#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#48#ly#0, $Unbox($l#48#d#0): DatatypeType))), (lambda $l#48#heap#0: Heap, $l#48#d#0: Box :: $IsBox($l#48#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#48#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#48#heap#0: Heap, $l#48#d#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#46#ly#0, $Unbox($l#46#d#0): DatatypeType))), (lambda $l#46#heap#0: Heap, $l#46#d#0: Box :: $IsBox($l#46#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#46#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#46#heap#0: Heap, $l#46#d#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#25 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#25))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#25 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#25))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#25 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#25))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#25 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#25))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#25 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#25))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#25 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#25))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#24 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#24)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#24 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#24)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#24 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#24)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#24 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#24)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#24 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#24)) else (var arr#24 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#24))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#27 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#27))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#27 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#27))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#27 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#27))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#27 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#27))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#27 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#27))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#27 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#27))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#26 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#26))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#26 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#26))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#26 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#26))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#26 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#26))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#26 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#26))) else (var arr#26 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#26)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$6x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$6x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$6x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$6x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$6x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$6x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#24: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#24)) } $Is(d#24, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#24) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#24))) && ((forall d#24: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#24)) } $Is(d#24, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#24) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#24))) ==> (forall d#25: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#25)) } $Is(d#25, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#25) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#25)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#24: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#24)) } $Is(d#24, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#24) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#24))) && (forall d#25: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#25)) } $Is(d#25, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#25) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#25))) && (forall d#26: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#26))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#26))): Seq } $Is(d#26, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#26) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#26))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#26))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#27: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#27)) } $Is(d#27, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#27) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#27))) && ((forall d#27: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#27)) } $Is(d#27, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#27) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#27))) ==> (forall d#28: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#28)) } $Is(d#28, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#28) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#28)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#27: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#27)) } $Is(d#27, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#27) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#27))) && (forall d#28: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#28)) } $Is(d#28, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#28) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#28))) && (forall d#29: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#29))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#29))): Seq } $Is(d#29, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#29) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#29))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#29))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#30: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#30)) } $Is(d#30, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#30) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#30))) && ((forall d#30: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#30)) } $Is(d#30, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#30) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#30))) ==> (forall d#31: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#31)) } $Is(d#31, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#31) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#31)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#30: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#30)) } $Is(d#30, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#30) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#30))) && (forall d#31: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#31)) } $Is(d#31, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#31) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#31))) && (forall d#32: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#32))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#32))): Seq } $Is(d#32, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#32) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#32))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#32))): Seq))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$3x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$3x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$3x#0): int)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$3x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$3x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$3x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$3x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$3x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$3x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#9#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $IsBox($l#9#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#27: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#27)) } $Is(cs#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#27)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#27: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#27)) } $Is(cs#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#27)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#28 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#6 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#28))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#29 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#29))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#6, cs#28 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#6 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#28))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#6) else (var val#6, cs#29 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); (var after#6, cs#30 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#29))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#29)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#6, val#6, after#6)), cs#30)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#31: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#31)) } $Is(cs#31, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#31)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#32 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#7 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#32))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#33 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#33))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#7, cs#32 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#7 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#32))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#7) else (var val#7, cs#33 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); (var after#7, cs#34 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#33))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#33)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#7, val#7, after#7)), cs#34)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#8#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $IsBox($l#8#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#19 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#19) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#19)) && (var cs#20 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#19))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#20))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#6, cs#19 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#6, cs#20 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#19)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#19))); (var after#6, cs#21 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#20))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#20)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#6, $Box(val#6), after#6)), cs#21)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#22 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#22) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#22)) && (var cs#23 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#22))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#23))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#7, cs#22 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#7, cs#23 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#22)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#22))); (var after#7, cs#24 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#23))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#23)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#7, $Box(val#7), after#7)), cs#24)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#8: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#8) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#8))): Seq } $Is(t#8, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#8)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#8: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#8) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#8))): Seq } $Is(t#8, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#8))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#8)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#9: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#9) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#9))): Seq } $Is(t#9, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#9)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#9: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#9) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#9))): Seq } $Is(t#9, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#9))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#9)))));

const unique tytagFamily$jclose: TyTagFamily;

const unique tytagFamily$jopen: TyTagFamily;

const reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody: bool;

const reveal_JSON.ZeroCopy.Deserializer.Strings._default.String: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mStrings.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0))): DatatypeType, cs#0)) && $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, cs#0) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, Lit(cs#0)) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())));
}

function JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#requires(cs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#requires(cs#0) <==> true));

function JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R: Ty) : HandleType;

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$0x#0, $fh$0x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$0x#0, $fh$0x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$0x#0): bool, $Unbox($fh$0x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$0x#0, $fh$0x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$0x#0, $fh$0x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$0x#0): bool, $Unbox($fh$0x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$0x#0, $fh$0x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$0x#0, $fh$0x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$0x#0: bool, $fh$0x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$0x#0, $fh$0x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$0x#0), $Box($fh$0x#1))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25741"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##step#0: HandleType;
  var ##st#0: bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Strings.StringBody", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(668,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q#canCall($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0);
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0);
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume true;
    ##step#0 := JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError());
    assume $IsAlloc(##step#0, Tclass._System.___hTotalFunc2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##st#0 := JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart();
    assume $IsAlloc(##st#0, TBool, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart()));
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart()));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart()));
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns (defass#pr#0: bool, pr#0: DatatypeType where defass#pr#0 ==> $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap), $_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(pr#0) && $IsA#Wrappers.Result(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0)) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
  free ensures {:id "id25751"} Wrappers.Result#Equal(pr#0, JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType) returns (defass#pr#0: bool, pr#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var escaped#0: bool;
  var point'#0: int;
  var point'#0#lo: int;
  var point'#0#hi: int;
  var point'#0#x: int;
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#pr#0: bool;
  var $w$loop#0: bool;
  var dt_update_tmp#0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#point#0#Z#0: int;
  var let#1#0#0: int;
  var dt_update_tmp#1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var dt_update#point#1#Z#0: int;
  var let#3#0#0: int;
  var ##step#1: HandleType;
  var ##st#1: bool;
  var ##cs#0: DatatypeType;
  var byte#0: int where LitInt(0) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8();
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var newtype$check#0_1_0: int;
  var newtype$check#0_1_1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Strings.StringBody", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(672,16): initial state"} true;
    $_reverifyPost := false;
    call CallPre$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__StringBody();
    call CallPost$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__StringBody();
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(673,24)"} true;
    assume true;
    assume true;
    escaped#0 := Lit(false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(674,26)"} true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    point'#0#lo := JSON_mUtils_mCursors.Cursor__.point(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    point'#0#hi := JSON_mUtils_mCursors.Cursor__.end(cs#0);
    assume point'#0#lo <= point'#0#hi;
    havoc point'#0#x;
    assume point'#0#lo <= point'#0#x && point'#0#x <= point'#0#hi;
    assume $Is(point'#0#x, Tclass.BoundedInts.uint32());
    point'#0 := point'#0#lo;
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#pr#0 := defass#pr#0;
    havoc $w$loop#0;
    goto anon17_LoopHead;

  anon17_LoopHead:
    assume point'#0#lo <= point'#0 && point'#0 <= point'#0#hi;
    assume $w$loop#0 ==> (var dt_update_tmp#0#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume $w$loop#0 ==> JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := cs#0; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    assume $w$loop#0 ==> $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0))) && $IsA#Wrappers.Result(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0)) && (var dt_update_tmp#1#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0)) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
    assume $w$loop#0 ==> Wrappers.Result#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LS($LZ)), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0)), JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0));
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
    assume $HeapSucc($PreLoopHeap$loop#0, $Heap);
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null && $Unbox(read($PreLoopHeap$loop#0, $o, alloc)): bool ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_ModifiesFrame[$o, $f]);
    assume preLoop$loop#0$defass#pr#0 ==> defass#pr#0;
    assume true;
    goto anon17_LoopDone, anon17_LoopBody;

  anon17_LoopBody:
    assume {:partition} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(675,6): after some loop iterations"} true;
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} !$w$loop#0;
    havoc dt_update_tmp#0#Z#0;
    assume $Is(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(dt_update_tmp#0#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume let#0#0#0 == cs#0;
    assume true;
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume dt_update_tmp#0#Z#0 == let#0#0#0;
    havoc dt_update#point#0#Z#0;
    assume LitInt(0) <= dt_update#point#0#Z#0 && dt_update#point#0#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#1#0#0 == point'#0;
    assume true;
    assume $Is(let#1#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#0#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#Z#0);
    assume (var dt_update_tmp#0#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := cs#0; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0)))));
    havoc dt_update_tmp#1#Z#0;
    assume $Is(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(dt_update_tmp#1#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume let#2#0#0 == cs#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume dt_update_tmp#1#Z#0 == let#2#0#0;
    havoc dt_update#point#1#Z#0;
    assume LitInt(0) <= dt_update#point#1#Z#0 && dt_update#point#1#Z#0 < BoundedInts.__default.TWO__TO__THE__32();
    assume let#3#0#0 == point'#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.BoundedInts.uint32());
    assume dt_update#point#1#Z#0 == let#3#0#0;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#Z#0);
    assume $IsAllocBox($Box((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume true;
    ##step#1 := JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError());
    assume $IsAlloc(##step#1, Tclass._System.___hTotalFunc2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##st#1 := escaped#0;
    assume $IsAlloc(##st#1, TBool, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0));
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
    assume $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0))) && $IsA#Wrappers.Result(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0)) && (var dt_update_tmp#1#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0)) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
    assume Wrappers.Result#Equal(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0)), JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0));
    assume false;
    goto anon3;

  anon18_Else:
    assume {:partition} $w$loop#0;
    goto anon3;

  anon3:
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} point'#0 == point'#0#hi;
    goto anon15;

  anon19_Else:
    assume {:partition} point'#0 != point'#0#hi;
    push;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume 0 <= point'#0 && point'#0 < Seq#Length(JSON_mUtils_mCursors.Cursor__.s(cs#0));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    byte#0 := $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(cs#0), point'#0)): int;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(679,32)"} true;
    newtype$check#0_0 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34)));
    goto anon7;

  anon20_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(34)));
    goto anon7;

  anon7:
    assume true;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0;
    push;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(cs#0);
    assume $Is(#Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0)))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    pr#0 := #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(cs#0), JSON_mUtils_mCursors.Cursor__.beg(cs#0), point'#0, JSON_mUtils_mCursors.Cursor__.end(cs#0))));
    defass#pr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(681,62)"} true;
    assume defass#pr#0;
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
    pop;
    pop;
    return;

  anon21_Else:
    assume {:partition} !(byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0);
    push;
    newtype$check#0_1_0 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(0) <= newtype$check#0_1_0 && newtype$check#0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_1_1 := char#ToInt(Lit(char#FromInt(92)));
    assume LitInt(0) <= newtype$check#0_1_1 && newtype$check#0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} byte#0 == char#ToInt(Lit(char#FromInt(92)));
    push;
    assume true;
    assume true;
    escaped#0 := !escaped#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(683,29)"} true;
    pop;
    goto anon13;

  anon22_Else:
    assume {:partition} byte#0 != char#ToInt(Lit(char#FromInt(92)));
    push;
    assume true;
    assume true;
    escaped#0 := Lit(false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(685,26)"} true;
    pop;
    goto anon13;

  anon13:
    pop;
    pop;
    point'#0 := point'#0 + 1;
    assume (var dt_update_tmp#0#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#0)) && (JSON_mUtils_mCursors.Cursor__.Valid_q((var dt_update_tmp#0#0 := cs#0; (var dt_update#point#0#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#0), dt_update#point#0#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#0))))) ==> $IsA#Wrappers.Result(JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0))) && $IsA#Wrappers.Result(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0)) && (var dt_update_tmp#1#0 := cs#0; JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#1#0)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), (var dt_update_tmp#1#0 := cs#0; (var dt_update#point#1#0 := point'#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#1#0), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#1#0), dt_update#point#1#0, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#1#0)))), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(escaped#0)) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0));
    goto anon17_LoopHead;

  anon17_LoopDone:
    assume {:partition} false;
    goto anon15;

  anon15:
    assume true;
    assume true;
    pr#0 := Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    defass#pr#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(688,25)"} true;
    assume defass#pr#0;
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
    return;
}



function JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jquote(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))))));
}

function JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.Quote (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25785"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jquote(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Strings.Quote (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##c0#0: char;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Strings.Quote", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(691,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jquote(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jquote(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jquote(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jquote(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##c0#0 := Lit(char#FromInt(34));
    assume $IsAlloc(##c0#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume {:subsumption 0} char#ToInt(##c0#0) < 256;
    assume char#ToInt(##c0#0) < 256;
    assume JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34)));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34)));
    assume JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34)));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#1) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (var contents#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#0) && (var cs#2 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#0)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#2) && (var valueOrError2#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#2); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#0) else (var lq#0, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#1); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#0) else (var contents#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; (var contents#1, cs#2 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#0)); (var valueOrError2#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#2); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#0) else (var rq#0, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#0, contents#1, rq#0)), cs#3))))))))))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#1 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#4 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#4) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#4); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (var contents#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#2) && (var cs#5 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#2)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#5) && (var valueOrError2#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#1 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#1) else (var lq#1, cs#4 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType)); (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#1) else (var contents#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; (var contents#3, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#2))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#2)); (var valueOrError2#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#1) else (var rq#1, cs#6 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#1, contents#3, rq#1)), cs#6))))))))))))));
}

function JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.String#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mStrings.__default.String#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mStrings.__default.String#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.String (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.String(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25804"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Strings.String (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.String(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var lq#Z#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var contents#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var contents#Z#1: DatatypeType;
  var cs#Z#1: DatatypeType;
  var let#4#0#0: DatatypeType;
  var valueOrError2#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var rq#Z#0: DatatypeType;
  var cs#Z#2: DatatypeType;
  var let#6#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Strings.String", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(698,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    goto anon5;

  anon15_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0);
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc lq#Z#0;
    havoc cs#Z#0;
    assume $Is(lq#Z#0, Tclass.JSON_mGrammar.jquote()) && $IsAlloc(lq#Z#0, Tclass.JSON_mGrammar.jquote(), $Heap) && $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#1#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(lq#Z#0), cs#Z#0) == let#1#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#1 := cs#Z#0;
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#Z#0);
    assume let#2#0#0 == JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#Z#0);
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon17_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc contents#Z#0;
    assume $Is(contents#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(contents#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume contents#Z#0 == let#3#0#0;
    havoc contents#Z#1;
    havoc cs#Z#1;
    assume $Is(contents#Z#1, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(contents#Z#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(contents#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(contents#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(contents#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(contents#Z#0));
    assume let#4#0#0 == JSON_mUtils_mCursors.Cursor__.Split(contents#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#Z#0);
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#4#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(contents#Z#1), cs#Z#1) == let#4#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#2 := cs#Z#1;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#Z#1);
    assume let#5#0#0 == JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#Z#1);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#Z#1);
    assume $Is(let#5#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError2#Z#0 == let#5#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    havoc rq#Z#0;
    havoc cs#Z#2;
    assume $Is(rq#Z#0, Tclass.JSON_mGrammar.jquote()) && $IsAlloc(rq#Z#0, Tclass.JSON_mGrammar.jquote(), $Heap) && $Is(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#6#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(rq#Z#0), cs#Z#2) == let#6#0#0;
    assume $Is(contents#Z#1, Tclass.JSON_mGrammar.jstr());
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#Z#0, contents#Z#1, rq#Z#0)), cs#Z#2)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon13:
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.reveal_StringBody (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__StringBody();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.reveal_StringBody (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__StringBody();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.reveal_StringBody (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__StringBody();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.reveal_String (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__String();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.reveal_String (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__String();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.reveal_String (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mStrings.__default.reveal__String();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Strings._default.String;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));
  modifies $Heap;
  free ensures $IsA#Wrappers.Result(pr#0) && $IsA#Wrappers.Result(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0)) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0);
  free ensures {:id "id25838"} Wrappers.Result#Equal(pr#0, JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#228 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#228))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#230 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#230)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#342 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#342))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#344 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#344)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#346 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#346)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#342 := Wrappers.Option.value(this); v#342)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#344 := Lit(Wrappers.Option.value(Lit(this))); v#344)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#346 := Lit(Wrappers.Option.value(Lit(this))); v#346)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#228 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#228)) else (var e#228 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#230 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#230))) else (var e#230 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#342 := Wrappers.Result.value(this); s#342) else (var e#342 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#344 := Lit(Wrappers.Result.value(Lit(this))); s#344) else (var e#344 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#346 := Lit(Wrappers.Result.value(Lit(this))); s#346) else (var e#346 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#342 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#342)) else (var e#342 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#342)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#344 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#344))) else (var e#344 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#344)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#346 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#346))) else (var e#346 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#346)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#138: int, y#138: int :: { Mul(x#138, y#138) } Mul(x#138, y#138) == Mul(y#138, x#138)) && (forall x#139: int, y#139: int, z#92: int :: { Mul(x#139 + y#139, z#92) } Mul(x#139 + y#139, z#92) == Mul(x#139, z#92) + Mul(y#139, z#92)) && (forall x#140: int, y#140: int, z#93: int :: { Mul(x#140 - y#140, z#93) } Mul(x#140 - y#140, z#93) == Mul(x#140, z#93) - Mul(y#140, z#93));

axiom MulInternals.__default.MulAuto() <==> (forall x#141: int, y#141: int :: { Mul(x#141, y#141) } Mul(x#141, y#141) == Mul(y#141, x#141)) && (forall x#142: int, y#142: int, z#94: int :: { Mul(x#142 + y#142, z#94) } Mul(x#142 + y#142, z#94) == Mul(x#142, z#94) + Mul(y#142, z#94)) && (forall x#143: int, y#143: int, z#95: int :: { Mul(x#143 - y#143, z#95) } Mul(x#143 - y#143, z#95) == Mul(x#143, z#95) - Mul(y#143, z#95));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#168: int :: { Mod(Mod(x#168, n#0), n#0) } Mod(Mod(x#168, n#0), n#0) == Mod(x#168, n#0)) && (forall x#169: int :: { Mod(x#169, n#0) } LitInt(0) <= x#169 && x#169 < n#0 <==> Mod(x#169, n#0) == x#169) && (forall x#170: int, y#84: int :: { Mod(x#170 + y#84, n#0) } (var z#82 := Mod(x#170, n#0) + Mod(y#84, n#0); (LitInt(0) <= z#82 && z#82 < n#0 && Mod(x#170 + y#84, n#0) == z#82) || (n#0 <= z#82 && z#82 < n#0 + n#0 && Mod(x#170 + y#84, n#0) == z#82 - n#0))) && (forall x#171: int, y#85: int :: { Mod(x#171 - y#85, n#0) } (var z#83 := Mod(x#171, n#0) - Mod(y#85, n#0); (LitInt(0) <= z#83 && z#83 < n#0 && Mod(x#171 - y#85, n#0) == z#83) || (0 - n#0 <= z#83 && z#83 < 0 && Mod(x#171 - y#85, n#0) == z#83 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#172: int :: { Mod(Mod(x#172, n#0), n#0) } Mod(Mod(x#172, LitInt(n#0)), LitInt(n#0)) == Mod(x#172, LitInt(n#0))) && (forall x#173: int :: { Mod(x#173, n#0) } LitInt(0) <= x#173 && x#173 < n#0 <==> Mod(x#173, LitInt(n#0)) == x#173) && (forall x#174: int, y#86: int :: { Mod(x#174 + y#86, n#0) } (var z#84 := Mod(x#174, LitInt(n#0)) + Mod(y#86, LitInt(n#0)); (LitInt(0) <= z#84 && z#84 < n#0 && Mod(x#174 + y#86, LitInt(n#0)) == z#84) || (LitInt(n#0) <= z#84 && z#84 < n#0 + n#0 && Mod(x#174 + y#86, LitInt(n#0)) == z#84 - n#0))) && (forall x#175: int, y#87: int :: { Mod(x#175 - y#87, n#0) } (var z#85 := Mod(x#175, LitInt(n#0)) - Mod(y#87, LitInt(n#0)); (LitInt(0) <= z#85 && z#85 < n#0 && Mod(x#175 - y#87, LitInt(n#0)) == z#85) || (LitInt(0 - n#0) <= z#85 && z#85 < 0 && Mod(x#175 - y#87, LitInt(n#0)) == z#85 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#120: int :: { Div(x#120, n#0) } LitInt(0) <= x#120 && x#120 < n#0 <==> Div(x#120, n#0) == LitInt(0)) && (forall x#121: int, y#80: int :: { Div(x#121 + y#80, n#0) } (var z#78 := Mod(x#121, n#0) + Mod(y#80, n#0); (LitInt(0) <= z#78 && z#78 < n#0 && Div(x#121 + y#80, n#0) == Div(x#121, n#0) + Div(y#80, n#0)) || (n#0 <= z#78 && z#78 < n#0 + n#0 && Div(x#121 + y#80, n#0) == Div(x#121, n#0) + Div(y#80, n#0) + 1))) && (forall x#122: int, y#81: int :: { Div(x#122 - y#81, n#0) } (var z#79 := Mod(x#122, n#0) - Mod(y#81, n#0); (LitInt(0) <= z#79 && z#79 < n#0 && Div(x#122 - y#81, n#0) == Div(x#122, n#0) - Div(y#81, n#0)) || (0 - n#0 <= z#79 && z#79 < 0 && Div(x#122 - y#81, n#0) == Div(x#122, n#0) - Div(y#81, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#123: int :: { Div(x#123, n#0) } LitInt(0) <= x#123 && x#123 < n#0 <==> Div(x#123, LitInt(n#0)) == LitInt(0)) && (forall x#124: int, y#82: int :: { Div(x#124 + y#82, n#0) } (var z#80 := Mod(x#124, LitInt(n#0)) + Mod(y#82, LitInt(n#0)); (LitInt(0) <= z#80 && z#80 < n#0 && Div(x#124 + y#82, LitInt(n#0)) == Div(x#124, LitInt(n#0)) + Div(y#82, LitInt(n#0))) || (LitInt(n#0) <= z#80 && z#80 < n#0 + n#0 && Div(x#124 + y#82, LitInt(n#0)) == Div(x#124, LitInt(n#0)) + Div(y#82, LitInt(n#0)) + 1))) && (forall x#125: int, y#83: int :: { Div(x#125 - y#83, n#0) } (var z#81 := Mod(x#125, LitInt(n#0)) - Mod(y#83, LitInt(n#0)); (LitInt(0) <= z#81 && z#81 < n#0 && Div(x#125 - y#83, LitInt(n#0)) == Div(x#125, LitInt(n#0)) - Div(y#83, LitInt(n#0))) || (LitInt(0 - n#0) <= z#81 && z#81 < 0 && Div(x#125 - y#83, LitInt(n#0)) == Div(x#125, LitInt(n#0)) - Div(y#83, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#28 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#28) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#28)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#28 := lv#0; (var dt_update#end#0#28 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#28), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#28), dt_update#end#0#28))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#29 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#29) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#29)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#29 := Lit(lv#0); (var dt_update#end#0#29 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#29)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#29)), dt_update#end#0#29)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#30: char :: { Seq#Contains(s#0, $Box(c#30)) } $Is(c#30, TChar) && Seq#Contains(s#0, $Box(c#30)) ==> char#ToInt(c#30) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#30: char :: { Seq#Contains(s#0, $Box(c#30)) } $Is(c#30, TChar) && Seq#Contains(s#0, $Box(c#30)) ==> char#ToInt(c#30) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#60#i#0): int)): char))), (lambda $l#60#heap#0: Heap, $l#60#i#0: Box :: $IsBox($l#60#i#0, TInt) && LitInt(0) <= $Unbox($l#60#i#0): int && $Unbox($l#60#i#0): int < Seq#Length(s#0)), (lambda $l#60#heap#0: Heap, $l#60#i#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#31: char :: { Seq#Contains(s#0, $Box(c#31)) } $Is(c#31, TChar) && Seq#Contains(s#0, $Box(c#31)) ==> char#ToInt(c#31) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#62#i#0): int)): char))), (lambda $l#62#heap#0: Heap, $l#62#i#0: Box :: $IsBox($l#62#i#0, TInt) && LitInt(0) <= $Unbox($l#62#i#0): int && $Unbox($l#62#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#62#heap#0: Heap, $l#62#i#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))));

axiom $Is(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(), TBool);

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(), TBool, $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart(), TBool, $h));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) || (LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> $Is(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R)));

axiom (forall $Heap: Heap, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $Heap) } (JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) || (LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8())) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $Heap));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) || (LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, escaped#0, byte#0) == (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(!escaped#0)) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#0 then #JSON.Utils.Lexers.Core.LexerResult.Accept() else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(false))))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, escaped#0: bool, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, Lit(escaped#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.StringBody#canCall(JSON.Utils.Lexers.Strings._default.StringBody$R, Lit(escaped#0), LitInt(byte#0)) || (LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, Lit(escaped#0), LitInt(byte#0)) == (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(!Lit(escaped#0))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !Lit(escaped#0) then #JSON.Utils.Lexers.Core.LexerResult.Accept() else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(false))))));

axiom $Is(JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mUtils_mLexers_mStrings.__default.StringLexerStart(), Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), $h));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> $Is(JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState(), TSeq(TChar))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#4 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#4))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#4 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#6 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#6))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#6 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall a#13#0#0: Box, a#13#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#13#0#0, a#13#1#0) } DatatypeCtorId(#JSON.Utils.Cursors.Split.SP(a#13#0#0, a#13#1#0)) == ##JSON.Utils.Cursors.Split.SP);

axiom (forall d: DatatypeType :: { JSON_mUtils_mCursors.Split.SP_q(d) } JSON_mUtils_mCursors.Split.SP_q(d) ==> (exists a#14#0#0: Box, a#14#1#0: DatatypeType :: d == #JSON.Utils.Cursors.Split.SP(a#14#0#0, a#14#1#0)));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, a#15#0#0: Box, a#15#1#0: DatatypeType :: { $Is(#JSON.Utils.Cursors.Split.SP(a#15#0#0, a#15#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) } $Is(#JSON.Utils.Cursors.Split.SP(a#15#0#0, a#15#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T)) <==> $IsBox(a#15#0#0, JSON.Utils.Cursors.Split$T) && $Is(a#15#1#0, Tclass.JSON_mUtils_mCursors.FreshCursor()));

axiom (forall JSON.Utils.Cursors.Split$T: Ty, a#15#0#0: Box, a#15#1#0: DatatypeType, $h: Heap :: { $IsAlloc(#JSON.Utils.Cursors.Split.SP(a#15#0#0, a#15#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) } $IsGoodHeap($h) ==> ($IsAlloc(#JSON.Utils.Cursors.Split.SP(a#15#0#0, a#15#1#0), Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Cursors.Split$T), $h) <==> $IsAllocBox(a#15#0#0, JSON.Utils.Cursors.Split$T, $h) && $IsAlloc(a#15#1#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $h)));

axiom (forall a#16#0#0: Box, a#16#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(Lit(a#16#0#0), Lit(a#16#1#0)) } #JSON.Utils.Cursors.Split.SP(Lit(a#16#0#0), Lit(a#16#1#0)) == Lit(#JSON.Utils.Cursors.Split.SP(a#16#0#0, a#16#1#0)));

axiom (forall a#17#0#0: Box, a#17#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#17#0#0, a#17#1#0) } JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP(a#17#0#0, a#17#1#0)) == a#17#0#0);

axiom (forall a#18#0#0: Box, a#18#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#18#0#0, a#18#1#0) } BoxRank(a#18#0#0) < DtRank(#JSON.Utils.Cursors.Split.SP(a#18#0#0, a#18#1#0)));

axiom (forall a#19#0#0: Box, a#19#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#19#0#0, a#19#1#0) } JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP(a#19#0#0, a#19#1#0)) == a#19#1#0);

axiom (forall a#20#0#0: Box, a#20#1#0: DatatypeType :: { #JSON.Utils.Cursors.Split.SP(a#20#0#0, a#20#1#0) } DtRank(a#20#1#0) < DtRank(#JSON.Utils.Cursors.Split.SP(a#20#0#0, a#20#1#0)));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#72 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#36 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#72 := (if b#72 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#72)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#36)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#72)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#73 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#36 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#73 := (if b#73 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#73)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#36 := Seq#Create(TChar, $Heap, Seq#Length(bs0#36), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#36, $Unbox($l#58#idx#0): int)): int))), (lambda $l#58#heap#0: Heap, $l#58#idx#0: Box :: $IsBox($l#58#idx#0, TInt) && LitInt(0) <= $Unbox($l#58#idx#0): int && $Unbox($l#58#idx#0): int < Seq#Length(bs0#36)), (lambda $l#58#heap#0: Heap, $l#58#idx#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#36), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#73))))) else (var err#36 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#36)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#76 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#38 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#76 := (if b#76 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#76)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#38)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#76)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#77 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#38 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#77 := (if b#77 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#77)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#38 := Seq#Create(TChar, $Heap, Seq#Length(bs0#38), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#38, $Unbox($l#61#idx#0): int)): int))), (lambda $l#61#heap#0: Heap, $l#61#idx#0: Box :: $IsBox($l#61#idx#0, TInt) && LitInt(0) <= $Unbox($l#61#idx#0): int && $Unbox($l#61#idx#0): int < Seq#Length(bs0#38)), (lambda $l#61#heap#0: Heap, $l#61#idx#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#38), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#77))))) else (var err#38 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#38)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#80 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#40 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#80 := (if b#80 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#80)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#40)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#80)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#81 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#40 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#81 := (if b#81 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#81)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#40 := Seq#Create(TChar, $Heap, Seq#Length(bs0#40), Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#40, $Unbox($l#64#idx#0): int)): int))), (lambda $l#64#heap#0: Heap, $l#64#idx#0: Box :: $IsBox($l#64#idx#0, TInt) && LitInt(0) <= $Unbox($l#64#idx#0): int && $Unbox($l#64#idx#0): int < Seq#Length(bs0#40)), (lambda $l#64#heap#0: Heap, $l#64#idx#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#40), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#81))))) else (var err#40 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#40)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#8: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#8)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#8)): int } LitInt(0) <= idx#8 && idx#8 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#8 && idx#8 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#8)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#8)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#12 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#12 := this; (var dt_update#beg#0#12 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#12), dt_update#beg#0#12, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#12), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#12)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#13 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#13 := Lit(this); (var dt_update#beg#0#13 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#13)), dt_update#beg#0#13, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#13)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#13)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#54#v#0): DatatypeType))), (lambda $l#54#heap#0: Heap, $l#54#v#0: Box :: $IsBox($l#54#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#54#heap#0: Heap, $l#54#v#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#55#v#0): DatatypeType))), (lambda $l#55#heap#0: Heap, $l#55#v#0: Box :: $IsBox($l#55#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#55#heap#0: Heap, $l#55#v#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#56#v#0): DatatypeType))), (lambda $l#56#heap#0: Heap, $l#56#v#0: Box :: $IsBox($l#56#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#56#heap#0: Heap, $l#56#v#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#12 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#12 := this; (var dt_update#point#0#12 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#12), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#12), dt_update#point#0#12, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#12)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#13 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#13 := Lit(this); (var dt_update#point#0#13 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#13)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#13)), dt_update#point#0#13, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#13)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#12 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#12)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#12 := this; (var dt_update#point#0#12 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#12), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#12), dt_update#point#0#12, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#12)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#13 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#13)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#13 := Lit(this); (var dt_update#point#0#13 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#13)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#13)), dt_update#point#0#13, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#13)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#12 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#12 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#12 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#12 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#12))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#13 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#13 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#13 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#13 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#13)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#21: int :: { Seq#Contains(bs#0, $Box(b#21)) } LitInt(0) <= b#21 && b#21 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#21)) ==> b#21 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#21: int :: { Seq#Contains(bs#0, $Box(b#21)) } LitInt(0) <= b#21 && b#21 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#21)) ==> b#21 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#18 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18) && (var ps#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#18, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#18 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#18) else (var ps#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#18)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#18, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#22: int :: { Seq#Contains(bs#0, $Box(b#22)) } LitInt(0) <= b#22 && b#22 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#22)) ==> b#22 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#19 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19) && (var ps#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#19, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#19 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#19) else (var ps#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#19)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#19, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#23: int :: { Seq#Contains(bs#0, $Box(b#23)) } LitInt(0) <= b#23 && b#23 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#23)) ==> b#23 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#20 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#20)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20) && (var ps#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#20, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#20 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#20) else (var ps#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#20)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#20, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#8: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#8)): int } LitInt(0) <= idx#8 && idx#8 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#8 && idx#8 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#8)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#38 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#38)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#37 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#37)))) else (var st#37 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#37))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#40 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#40)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#39 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#39)))) else (var st#39 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#39))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#42 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#42)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#41 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#41)))) else (var st#41 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#41))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#48#heap#0: Heap, $l#48#_v0#0: Box :: $IsBox($l#48#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#48#heap#0: Heap, $l#48#_v0#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#49#heap#0: Heap, $l#49#_v1#0: Box :: $IsBox($l#49#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#49#heap#0: Heap, $l#49#_v1#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#52#heap#0: Heap, $l#52#_v0#0: Box :: $IsBox($l#52#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#52#heap#0: Heap, $l#52#_v0#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#53#heap#0: Heap, $l#53#_v1#0: Box :: $IsBox($l#53#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#53#heap#0: Heap, $l#53#_v1#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#cs#0: Box :: $Box(Lit(false))), (lambda $l#72#heap#0: Heap, $l#72#cs#0: Box :: $IsBox($l#72#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#72#heap#0: Heap, $l#72#cs#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#73#heap#0: Heap, $l#73#cs#0: Box :: $IsBox($l#73#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#73#heap#0: Heap, $l#73#cs#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#74#heap#0: Heap, $l#74#_v2#0: Box :: $IsBox($l#74#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#74#heap#0: Heap, $l#74#_v2#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#cs#0: Box :: $Box(Lit(false))), (lambda $l#78#heap#0: Heap, $l#78#cs#0: Box :: $IsBox($l#78#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#78#heap#0: Heap, $l#78#cs#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#79#heap#0: Heap, $l#79#cs#0: Box :: $IsBox($l#79#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#79#heap#0: Heap, $l#79#cs#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#80#heap#0: Heap, $l#80#_v2#0: Box :: $IsBox($l#80#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#80#heap#0: Heap, $l#80#_v2#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#12: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#12))): DatatypeType } $Is(cs'#12, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#12))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#12))): DatatypeType)): DatatypeType, cs'#12, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#12: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#12))): DatatypeType } $Is(cs'#12, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#12))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#12))): DatatypeType)): DatatypeType, cs'#12, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#13: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#13))): DatatypeType } $Is(cs'#13, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#13))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#13))): DatatypeType)): DatatypeType, cs'#13, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#13: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#13))): DatatypeType } $Is(cs'#13, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#13))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#13))): DatatypeType)): DatatypeType, cs'#13, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#36: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#36)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#36))): bool } $Is(cs'#36, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#36))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#36)))) && ((forall cs'#36: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#36)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#36))): bool } $Is(cs'#36, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#36))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#36))) ==> (forall cs'#37: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#37))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#37, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#37: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#37))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#37, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#37))): bool) ==> (forall cs'#38: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#38))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#38))): bool } $Is(cs'#38, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#38))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#38))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#38))): DatatypeType)): DatatypeType, cs'#38, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#36: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#36)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#36))): bool } $Is(cs'#36, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#36))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#36))) && (forall cs'#37: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#37))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#37, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#37, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#37))): bool) && (forall cs'#38: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#38))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#38))): bool } $Is(cs'#38, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#38))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#38))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#38))): DatatypeType)): DatatypeType, cs'#38, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#39: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#39)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#39))): bool } $Is(cs'#39, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#39))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#39)))) && ((forall cs'#39: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#39)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#39))): bool } $Is(cs'#39, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#39))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#39))) ==> (forall cs'#40: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#40))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#40, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#40, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#40, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#40, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#40: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#40))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#40, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#40, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#40, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#40))): bool) ==> (forall cs'#41: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#41))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#41))): bool } $Is(cs'#41, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#41))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#41))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#41))): DatatypeType)): DatatypeType, cs'#41, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#39: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#39)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#39))): bool } $Is(cs'#39, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#39))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#39))) && (forall cs'#40: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#40))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#40, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#40, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#40, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#40))): bool) && (forall cs'#41: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#41))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#41))): bool } $Is(cs'#41, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#41))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#41))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#41))): DatatypeType)): DatatypeType, cs'#41, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#13: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#13)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#13)) ==> LitInt(0) <= d#13 && d#13 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#33 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#34 := Seq#Append(digits'#33, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#34))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#34 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#35 := Seq#Append(digits'#34, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#35))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#35 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#36 := Seq#Append(digits'#35, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#36))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#13: Box :: { Seq#Contains(chars#0, c#13) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#13) } $IsBox(c#13, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#13) ==> Seq#Contains(chars#0, c#13)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#27: int :: { Seq#Contains(digits#0, $Box(d#27)) } Seq#Contains(digits#0, $Box(d#27)) ==> LitInt(0) <= d#27 && d#27 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#27: int :: { Seq#Contains(digits#0, $Box(d#27)) } Seq#Contains(digits#0, $Box(d#27)) ==> LitInt(0) <= d#27 && d#27 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#28: int :: { Seq#Contains(digits#0, $Box(d#28)) } Seq#Contains(digits#0, $Box(d#28)) ==> LitInt(0) <= d#28 && d#28 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#13: Box :: { Seq#Contains(chars#0, c#13) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#13) } $IsBox(c#13, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#13) ==> Seq#Contains(chars#0, c#13)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#22 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#22) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#22), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#22 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#22), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#23 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#23) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#23), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#23 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#23), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#35: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#35)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#35) } $IsBox(c#35, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#35) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#35)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#36: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#36)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#36) } $IsBox(c#36, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#36) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#36)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#37: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#37)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#37) } $IsBox(c#37, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#37) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#37)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Seq#Contains(chars#0, $l#17#c#0))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#25: Box :: { Map#Domain(digits#0)[c#25] } { Seq#Contains(str#0, c#25) } $IsBox(c#25, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#25) ==> Map#Domain(digits#0)[c#25])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#25: Box :: { Map#Domain(digits#0)[c#25] } { Seq#Contains(str#0, c#25) } $IsBox(c#25, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#25) ==> Map#Domain(digits#0)[c#25])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#26: Box :: { Map#Domain(digits#0)[c#26] } { Seq#Contains(str#0, c#26) } $IsBox(c#26, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#26) ==> Map#Domain(digits#0)[c#26])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(Map#Domain(digits#0)[$l#49#c#0])), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(Map#Domain(digits#0)[$l#49#c#0])), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(Map#Domain(digits#0)[$l#50#c#0])), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(Map#Domain(digits#0)[$l#51#c#0])), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#33 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#33) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#33) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#33)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#33) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#33)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#33 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#33) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#33) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#33)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#33) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#33))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#33 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#33) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#33) else (var tl#66 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#33)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#66)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#33 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#33) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#33) else (var tl#67 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#33)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#67)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#34 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#34) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#34) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#34)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#34) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#34)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#34 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#34) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#34) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#34)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#34) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#34))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#34 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#34) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#34) else (var tl#68 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#34)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#68)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#34 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#34) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#34) else (var tl#69 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#34)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#69)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#35 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#35) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#35) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#35)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#35) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#35)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#35 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#35) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#35) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#35)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#35) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#35))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#35 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#35) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#35) else (var tl#70 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#35)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#70)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#35 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#35) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#35) else (var tl#71 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#35)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#71)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#13: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#13)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#13)) ==> LitInt(0) <= d#13 && d#13 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#33 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#34 := Seq#Append(digits'#33, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#34))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#34 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#35 := Seq#Append(digits'#34, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#35))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#35 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#36 := Seq#Append(digits'#35, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#36))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#13: char :: { Seq#Contains(chars#0, $Box(c#13)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#13)) ==> Seq#Contains(chars#0, $Box(c#13))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#27: int :: { Seq#Contains(digits#0, $Box(d#27)) } Seq#Contains(digits#0, $Box(d#27)) ==> LitInt(0) <= d#27 && d#27 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#27: int :: { Seq#Contains(digits#0, $Box(d#27)) } Seq#Contains(digits#0, $Box(d#27)) ==> LitInt(0) <= d#27 && d#27 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#28: int :: { Seq#Contains(digits#0, $Box(d#28)) } Seq#Contains(digits#0, $Box(d#28)) ==> LitInt(0) <= d#28 && d#28 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#13: char :: { Seq#Contains(chars#0, $Box(c#13)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#13)) ==> Seq#Contains(chars#0, $Box(c#13))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#22 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#22) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#22), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#22 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#22), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#23 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#23) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#23), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#23 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#23), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#35: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#35))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#35)) } $Is(c#35, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#35)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#35))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#36: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#36))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#36)) } $Is(c#36, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#36)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#36))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#37: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#37))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#37)) } $Is(c#37, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#37)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#37))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Seq#Contains(chars#0, $l#17#c#0))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#25: char :: { Map#Domain(digits#0)[$Box(c#25)] } { Seq#Contains(str#0, $Box(c#25)) } $Is(c#25, TChar) && Seq#Contains(str#0, $Box(c#25)) ==> Map#Domain(digits#0)[$Box(c#25)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#25: char :: { Map#Domain(digits#0)[$Box(c#25)] } { Seq#Contains(str#0, $Box(c#25)) } $Is(c#25, TChar) && Seq#Contains(str#0, $Box(c#25)) ==> Map#Domain(digits#0)[$Box(c#25)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#26: char :: { Map#Domain(digits#0)[$Box(c#26)] } { Seq#Contains(str#0, $Box(c#26)) } $Is(c#26, TChar) && Seq#Contains(str#0, $Box(c#26)) ==> Map#Domain(digits#0)[$Box(c#26)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(Map#Domain(digits#0)[$l#49#c#0])), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, TChar)), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(Map#Domain(digits#0)[$l#49#c#0])), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, TChar)), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(Map#Domain(digits#0)[$l#50#c#0])), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, TChar)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(Map#Domain(digits#0)[$l#51#c#0])), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, TChar)), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#33 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#33) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#33) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#33)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#33) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#33)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#33 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#33) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#33) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#33)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#33) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#33))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#33 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#33) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#33) else (var tl#66 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#33)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#66)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#33 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#33) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#33) else (var tl#67 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#33)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#67)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#34 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#34) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#34) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#34)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#34) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#34)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#34 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#34) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#34) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#34)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#34) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#34))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#34 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#34) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#34) else (var tl#68 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#34)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#68)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#34 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#34) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#34) else (var tl#69 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#34)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#69)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#35 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#35) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#35) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#35)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#35) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#35)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#35 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#35) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#35) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#35)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#35) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#35))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#35 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#35) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#35) else (var tl#70 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#35)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#70)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#35 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#35) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#35) else (var tl#71 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#35)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#71)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#12: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#12)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#12)) } $Is(c#12, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#12)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#12))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#15#c#0))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, TChar)), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#23: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)] } { Seq#Contains(str#0, $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(str#0, $Box(c#23)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#23: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)] } { Seq#Contains(str#0, $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(str#0, $Box(c#23)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#23)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#24: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#24)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#24)] } { Seq#Contains(str#0, $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(str#0, $Box(c#24)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#24)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#24)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#38#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#38#c#0]): int < base#0)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, TChar)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#38#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#38#c#0]): int < base#0)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, TChar)), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#39#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#39#c#0]): int < base#0)), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, TChar)), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#36 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#36)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#72 := JSON_mErrors.DeserializationError.b(this); (var b0#36 := JSON_mErrors.DeserializationError.expected(this); (var c#72 := (if b#72 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#72)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#36)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#72)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#73 := JSON_mErrors.DeserializationError.b(this); (var bs0#36 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#73 := (if b#73 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#73)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#36 := Seq#Create(TChar, $Heap, Seq#Length(bs0#36), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#36, $Unbox($l#58#idx#0): int)): int))), (lambda $l#58#heap#0: Heap, $l#58#idx#0: Box :: $IsBox($l#58#idx#0, TInt) && LitInt(0) <= $Unbox($l#58#idx#0): int && $Unbox($l#58#idx#0): int < Seq#Length(bs0#36)), (lambda $l#58#heap#0: Heap, $l#58#idx#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#36), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#73))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#38 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#38)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#76 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#38 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#76 := (if b#76 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#76)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#38)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#76)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#77 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#38 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#77 := (if b#77 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#77)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#38 := Seq#Create(TChar, $Heap, Seq#Length(bs0#38), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#38, $Unbox($l#61#idx#0): int)): int))), (lambda $l#61#heap#0: Heap, $l#61#idx#0: Box :: $IsBox($l#61#idx#0, TInt) && LitInt(0) <= $Unbox($l#61#idx#0): int && $Unbox($l#61#idx#0): int < Seq#Length(bs0#38)), (lambda $l#61#heap#0: Heap, $l#61#idx#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#38), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#77))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#37 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#37, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#36 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#36, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#36 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#36)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#39 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#39, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#38 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#38, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#38 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#38)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#22: int :: { JSON_mGrammar.__default.Blank_q(b#22) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) } LitInt(0) <= b#22 && b#22 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#22))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#22: int :: { JSON_mGrammar.__default.Blank_q(b#22) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) } LitInt(0) <= b#22 && b#22 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) ==> JSON_mGrammar.__default.Blank_q(b#22))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#23: int :: { JSON_mGrammar.__default.Blank_q(b#23) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#23)) } LitInt(0) <= b#23 && b#23 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#23)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#23))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#23: int :: { JSON_mGrammar.__default.Blank_q(b#23) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#23)) } LitInt(0) <= b#23 && b#23 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#23)) ==> JSON_mGrammar.__default.Blank_q(b#23))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#22: int :: { $Unbox(Seq#Index(s#0, idx#22)): DatatypeType } LitInt(0) <= idx#22 && idx#22 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#22)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#22: int :: { $Unbox(Seq#Index(s#0, idx#22)): DatatypeType } LitInt(0) <= idx#22 && idx#22 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#22)): DatatypeType)) <==> idx#22 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#23: int :: { $Unbox(Seq#Index(s#0, idx#23)): DatatypeType } LitInt(0) <= idx#23 && idx#23 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#23)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#23: int :: { $Unbox(Seq#Index(s#0, idx#23)): DatatypeType } LitInt(0) <= idx#23 && idx#23 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#23)): DatatypeType)) <==> idx#23 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#22: int :: { JSON_mGrammar.__default.Digit_q(b#22) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) } LitInt(0) <= b#22 && b#22 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#22))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#22: int :: { JSON_mGrammar.__default.Digit_q(b#22) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) } LitInt(0) <= b#22 && b#22 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#22)) ==> JSON_mGrammar.__default.Digit_q(b#22))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#23: int :: { JSON_mGrammar.__default.Digit_q(b#23) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#23)) } LitInt(0) <= b#23 && b#23 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#23)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#23))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#23: int :: { JSON_mGrammar.__default.Digit_q(b#23) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#23)) } LitInt(0) <= b#23 && b#23 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#23)) ==> JSON_mGrammar.__default.Digit_q(b#23))));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$7x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$7x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$7x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$7x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$7x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$7x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$7x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$7x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$7x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$7x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$7x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$7x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#24: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#24) } { Seq#Contains(ts#0, d#24) } $IsBox(d#24, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#24) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#24))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#24: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#24) } { Seq#Contains(ts#0, d#24) } $IsBox(d#24, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#24) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#24))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#25: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#25) } { Seq#Contains(ts#0, d#25) } $IsBox(d#25, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#25) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#25))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#26: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#26) } { Seq#Contains(ts#0, d#26) } $IsBox(d#26, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#26) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#26))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#24: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#24)) } $Is(d#24, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#24) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#24)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#24: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#24)) } $Is(d#24, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#24) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#24)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#25: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#25)) } $Is(d#25, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#25) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#25)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#26: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#26)) } $Is(d#26, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#26) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#26)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$7x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$7x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$7x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$7x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$7x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$7x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$7x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$7x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$7x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$7x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$7x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$7x#0))): Seq);

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$7x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$7x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$7x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$7x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$7x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$7x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$7x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$7x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$7x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$7x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$7x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$7x#0))): Seq);

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$7x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$7x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$7x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$7x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$7x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$7x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$7x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$7x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$7x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$7x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$7x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$7x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#50#d#0: DatatypeType :: $Is($l#50#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#50#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#50#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#51#ly#0, $Unbox($l#51#d#0): DatatypeType))), (lambda $l#51#heap#0: Heap, $l#51#d#0: Box :: $IsBox($l#51#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#51#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#51#heap#0: Heap, $l#51#d#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#49#ly#0, $Unbox($l#49#d#0): DatatypeType))), (lambda $l#49#heap#0: Heap, $l#49#d#0: Box :: $IsBox($l#49#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#49#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#49#heap#0: Heap, $l#49#d#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#53#d#0: DatatypeType :: $Is($l#53#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#53#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#53#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#54#ly#0, $Unbox($l#54#d#0): DatatypeType))), (lambda $l#54#heap#0: Heap, $l#54#d#0: Box :: $IsBox($l#54#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#54#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#54#heap#0: Heap, $l#54#d#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#52#ly#0, $Unbox($l#52#d#0): DatatypeType))), (lambda $l#52#heap#0: Heap, $l#52#d#0: Box :: $IsBox($l#52#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#52#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#52#heap#0: Heap, $l#52#d#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#50#d#0: DatatypeType :: $Is($l#50#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#50#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#50#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#51#ly#0, $Unbox($l#51#d#0): DatatypeType))), (lambda $l#51#heap#0: Heap, $l#51#d#0: Box :: $IsBox($l#51#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#51#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#51#heap#0: Heap, $l#51#d#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#49#ly#0, $Unbox($l#49#d#0): DatatypeType))), (lambda $l#49#heap#0: Heap, $l#49#d#0: Box :: $IsBox($l#49#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#49#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#49#heap#0: Heap, $l#49#d#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#53#d#0: DatatypeType :: $Is($l#53#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#53#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#53#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#54#ly#0, $Unbox($l#54#d#0): DatatypeType))), (lambda $l#54#heap#0: Heap, $l#54#d#0: Box :: $IsBox($l#54#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#54#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#54#heap#0: Heap, $l#54#d#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#52#ly#0, $Unbox($l#52#d#0): DatatypeType))), (lambda $l#52#heap#0: Heap, $l#52#d#0: Box :: $IsBox($l#52#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#52#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#52#heap#0: Heap, $l#52#d#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#29 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#29))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#29 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#29))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#29 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#29))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#29 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#29))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#29 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#29))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#29 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#29))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#28 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#28)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#28 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#28)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#28 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#28)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#28 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#28)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#28 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#28)) else (var arr#28 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#28))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#31 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#31))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#31 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#31))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#31 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#31))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#31 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#31))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#31 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#31))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#31 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#31))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#30 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#30))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#30 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#30))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#30 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#30))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#30 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#30))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#30 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#30))) else (var arr#30 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#30)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$7x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$7x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$7x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$7x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$7x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$7x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$7x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$7x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$7x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$7x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$7x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$7x#0))): Seq);

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$4x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$4x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$4x#0): int)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$4x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$4x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$4x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$4x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$4x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$4x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#10#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#10#heap#0: Heap, $l#10#st#0: Box :: $IsBox($l#10#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#10#heap#0: Heap, $l#10#st#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#35: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#35)) } $Is(cs#35, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#35)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#35: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#35)) } $Is(cs#35, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#35)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#36 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#8 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#36))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#37 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#37))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#8, cs#36 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#8 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#36))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#8) else (var val#8, cs#37 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); (var after#8, cs#38 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#37))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#37)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#8, val#8, after#8)), cs#38)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#39: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#39)) } $Is(cs#39, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#39)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#40 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#9 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#40))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#41 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#41))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#9, cs#40 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#9 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#40))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#9) else (var val#9, cs#41 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); (var after#9, cs#42 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#41))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#41)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#9, val#9, after#9)), cs#42)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#9#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $IsBox($l#9#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#25 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#25) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#25)) && (var cs#26 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#25))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#26))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#8, cs#25 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#8, cs#26 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#25)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#25))); (var after#8, cs#27 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#26))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#26)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#8, $Box(val#8), after#8)), cs#27)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#28 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#28) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#28)) && (var cs#29 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#28))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#29))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#9, cs#28 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#9, cs#29 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#28)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#28))); (var after#9, cs#30 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#29))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#29)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#9, $Box(val#9), after#9)), cs#30)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#10: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#10) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#10))): Seq } $Is(t#10, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#10)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#10: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#10) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#10))): Seq } $Is(t#10, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#10))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#10)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#11: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#11) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#11))): Seq } $Is(t#11, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#11)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#11: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#11) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#11))): Seq } $Is(t#11, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#11))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#11)))));

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts: bool;

const reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mNumbers.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jdigits(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Digit_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(cs#0), JSON_mGrammar.__default.Digit_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Digit_q#Handle())) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, Lit(cs#0)) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Digit_q#Handle())));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#requires(cs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#requires(cs#0) <==> true));

function JSON_mGrammar.__default.Digit_q#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$0x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$0x#0) == $Box(JSON_mGrammar.__default.Digit_q($Unbox($fh$0x#0): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$0x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$0x#0) <==> JSON_mGrammar.__default.Digit_q#requires($Unbox($fh$0x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: int :: { JSON_mGrammar.__default.Digit_q($fh$0x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Digit_q($fh$0x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $Box($fh$0x#0))): bool);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Digits (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25886"} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jdigits(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Digits (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(cs#0: DatatypeType) returns (sp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##p#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.Digits", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(717,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()));
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jdigits(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jdigits(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jdigits(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume false;
    return;

  anon4_Else:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume true;
    ##p#0 := JSON_mGrammar.__default.Digit_q#Handle();
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Digit_q#Handle());
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle()));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LS($LZ)), cs#0, JSON_mGrammar.__default.Digit_q#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle()));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Digit_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle()));
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0) == sp#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || (1 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnum(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 1 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || (1 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) && (var sp#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#0) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#0 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#0)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) == (var sp#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); (var valueOrError0#0 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#0) else #Wrappers.Result.Success($Box(sp#0))))));
axiom 1 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) || (1 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) && (var sp#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(sp#1) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#1)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#1 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#1)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#1)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) == (var sp#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); (var valueOrError0#1 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#1)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#1) else #Wrappers.Result.Success($Box(sp#1))))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.NonEmptyDigits (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25894"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnum(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.NonEmptyDigits (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##condition#0: bool;
  var ##error#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.NonEmptyDigits", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(723,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jnum(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnum(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnum(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnum(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits())) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()));
    assume sp#Z#0 == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    ##condition#0 := !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber()))));
    assume $IsAlloc(##error#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber()))))));
    assume let#1#0#0 == Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber()))))));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber()))))));
    assume $Is(let#1#0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#Z#0);
    assume $Is(Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0) == Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(#Wrappers.Result.Success($Box(sp#Z#0)), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0) == #Wrappers.Result.Success($Box(sp#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.Peek(cs#0) != char#ToInt(Lit(char#FromInt(48)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.Peek(cs#0) != char#ToInt(Lit(char#FromInt(48)))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, cs#0) == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0)) != char#ToInt(Lit(char#FromInt(48)))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, Lit(cs#0)) == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, Lit(cs#0)));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#requires(cs#0) <==> JSON_mUtils_mCursors.Cursor__.Peek(cs#0) != char#ToInt(Lit(char#FromInt(48)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.NonZeroInt (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25909"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.NonZeroInt (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.NonZeroInt", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(731,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Cursor__.Peek(cs#0) != char#ToInt(Lit(char#FromInt(48)));
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jint(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, cs#0) == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box($Unbox($l#2#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.BoundedInts.uint8())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box($Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box($Unbox($l#0#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint8())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box($Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box($Unbox($l#7#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint8())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box($Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.BoundedInts.uint8())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.OptionalMinus (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25921"} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.OptionalMinus (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(cs#0: DatatypeType) returns (sp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##p#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.OptionalMinus", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(738,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()));
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jminus(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jminus(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume false;
    return;

  anon8_Else:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    goto anon9_Then, anon9_Else;

  anon9_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#0 <==> c#0 == char#ToInt(Lit(char#FromInt(45)));
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon6;

  anon10_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon9_Else:
    goto anon7;

  anon7:
    ##p#0 := Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box($Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box($Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box($Unbox($l#11#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint8())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box($Unbox($l#12#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.BoundedInts.uint8())), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box($Unbox($l#13#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box($Unbox($l#14#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.BoundedInts.uint8())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box($Unbox($l#15#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint8())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box($Unbox($l#16#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.BoundedInts.uint8())), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box($Unbox($l#17#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.BoundedInts.uint8())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box($Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint8())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box($Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint8())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box($Unbox($l#21#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.BoundedInts.uint8())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0) == sp#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jsign(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign())));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box($Unbox($l#2#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#2#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.BoundedInts.uint8())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box($Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box($Unbox($l#0#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#0#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint8())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box($Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box($Unbox($l#7#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#7#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint8())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box($Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.BoundedInts.uint8())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.OptionalSign (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (sp#0: DatatypeType where $Is(sp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25931"} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jsign(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.OptionalSign (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(cs#0: DatatypeType) returns (sp#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var ##p#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.OptionalSign", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(744,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign()));
    assume $IsAllocBox($Box(sp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jsign(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jsign(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jsign(), sp#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume false;
    return;

  anon10_Else:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(45)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} c#0 != char#ToInt(Lit(char#FromInt(45)));
    newtype$check#2 := char#ToInt(Lit(char#FromInt(43)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(43)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon7;

  anon13_Else:
    assume {:partition} c#0 == char#ToInt(Lit(char#FromInt(45)));
    goto anon7;

  anon7:
    assume lambdaResult#0 <==> c#0 == char#ToInt(Lit(char#FromInt(45))) || c#0 == char#ToInt(Lit(char#FromInt(43)));
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon8;

  anon12_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon11_Else:
    goto anon9;

  anon9:
    ##p#0 := Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box($Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box($Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box($Unbox($l#11#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#11#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint8())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box($Unbox($l#12#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#12#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.BoundedInts.uint8())), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box($Unbox($l#13#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#13#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box($Unbox($l#14#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#14#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.BoundedInts.uint8())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box($Unbox($l#15#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#15#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint8())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box($Unbox($l#16#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#16#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.BoundedInts.uint8())), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))));
    assume $Is(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box($Unbox($l#17#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#17#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.BoundedInts.uint8())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box($Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint8())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box($Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint8())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box($Unbox($l#21#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#21#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.BoundedInts.uint8())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#0) == sp#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 3 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box($Unbox($l#2#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.BoundedInts.uint8())), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box($Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && (var sp#0 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box($Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.BoundedInts.uint8())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))); JSON_mUtils_mCursors.Split.SP_q(sp#0) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#0)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) == (var sp#0 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box($Unbox($l#0#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.BoundedInts.uint8())), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#0)): DatatypeType) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#0)) else #Wrappers.Result.Success($Box(sp#0)))));
axiom 3 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(Lit(cs#0)) || (3 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box($Unbox($l#7#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.BoundedInts.uint8())), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box($Unbox($l#8#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint8())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))))) && (var sp#1 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box($Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))))); JSON_mUtils_mCursors.Split.SP_q(sp#1) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#1)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#1) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#1)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) == (var sp#1 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box($Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.BoundedInts.uint8())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit($Unbox(JSON_mUtils_mCursors.Split.t(sp#1)): DatatypeType)) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, Lit(JSON_mUtils_mCursors.Split.cs(sp#1))) else #Wrappers.Result.Success($Box(sp#1)))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.TrimmedInt (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25943"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.TrimmedInt (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var c#0: int;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##p#0: HandleType;
  var ##cs#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.TrimmedInt", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(750,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jint(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon15_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(48)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#0 <==> c#0 == char#ToInt(Lit(char#FromInt(48)));
    assume true;
    assume $Is(lambdaResult#0, TBool);
    goto anon9;

  anon17_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon9;

  anon9:
    assume false;
    goto anon10;

  anon16_Else:
    goto anon10;

  anon10:
    ##p#0 := Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box($Unbox($l#11#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.BoundedInts.uint8())), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box($Unbox($l#12#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.BoundedInts.uint8())), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box($Unbox($l#13#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box($Unbox($l#14#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.BoundedInts.uint8())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box($Unbox($l#15#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint8())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box($Unbox($l#16#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.BoundedInts.uint8())), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box($Unbox($l#17#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.BoundedInts.uint8())), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box($Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint8())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box($Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint8())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box($Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.BoundedInts.uint8())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box($Unbox($l#23#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.BoundedInts.uint8())), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume sp#Z#0 == let#0#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    ##cs#0 := JSON_mUtils_mCursors.Split.cs(sp#Z#0);
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Peek(##cs#0) != char#ToInt(Lit(char#FromInt(48)));
    assume JSON_mUtils_mCursors.Cursor__.Peek(##cs#0) != char#ToInt(Lit(char#FromInt(48)));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, cs#0) == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0));
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon18_Else:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume $Is(#Wrappers.Result.Success($Box(sp#Z#0)), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, cs#0) == #Wrappers.Result.Success($Box(sp#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon13:
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#0#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#0#heap#0: Heap, $l#0#exp#0: Box :: $IsBox($l#0#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#0#heap#0: Heap, $l#0#exp#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box($Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box($Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.BoundedInts.uint8())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))) && (var e#0, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box($Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.BoundedInts.uint8())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box($Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.BoundedInts.uint8())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#0) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#1) && (var cs#2 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#1)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#2) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#2); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) == (var e#0, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box($Unbox($l#1#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#1#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box($Unbox($l#1#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#1#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#0) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#1))) else (var sign#0, cs#2 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#1))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#1)); (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#2); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#0) else (var num#0, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#0, sign#0, num#0)))), cs#3))))))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box($Unbox($l#8#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#8#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint8())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box($Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))))) && (var e#1, cs#4 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box($Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box($Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#1) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#4) && (var cs#5 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#4)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#5) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) == (var e#1, cs#4 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box($Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box($Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#1) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#4))) else (var sign#1, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#4))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#4)); (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#1) else (var num#1, cs#6 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#1, sign#1, num#1)))), cs#6))))))))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$8x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$8x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$8x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$8x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$8x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$8x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$8x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$8x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$8x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$8x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$8x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$8x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Exp (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25960"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#11#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: $IsBox($l#11#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Exp (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var exp#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var e#Z#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var $lambdaHeap#1: Heap;
  var c#0: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var ##p#0: HandleType;
  var ##c#0: char;
  var ##c#1: char;
  var sign#Z#0: DatatypeType;
  var cs#Z#1: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var num#Z#0: DatatypeType;
  var cs#Z#2: DatatypeType;
  var let#3#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.Exp", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(758,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap);
    goto anon26_Then, anon26_Else;

  anon26_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc exp#0;
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} $Is(exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())) && $IsAlloc(exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume true;
    ##self#0 := exp#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $lambdaHeap#0);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), exp#0, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), exp#0, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), exp#0, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon6;

  anon27_Else:
    assume {:partition} !($Is(exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())) && $IsAlloc(exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon26_Else:
    goto anon7;

  anon7:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#13#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#13#heap#0: Heap, $l#13#exp#0: Box :: $IsBox($l#13#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#13#heap#0: Heap, $l#13#exp#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#14#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#14#heap#0: Heap, $l#14#exp#0: Box :: $IsBox($l#14#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#14#heap#0: Heap, $l#14#exp#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#15#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: $IsBox($l#15#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    goto anon9;

  anon25_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#16#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#16#heap#0: Heap, $l#16#exp#0: Box :: $IsBox($l#16#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#16#heap#0: Heap, $l#16#exp#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))));
    goto anon9;

  anon9:
    assume false;
    return;

  anon24_Else:
    havoc e#Z#0;
    havoc cs#Z#0;
    assume $Is(e#Z#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(e#Z#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    goto anon28_Then, anon28_Else;

  anon28_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(101)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} c#0 != char#ToInt(Lit(char#FromInt(101)));
    newtype$check#2 := char#ToInt(Lit(char#FromInt(69)));
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(69)));
    assume LitInt(0) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon14;

  anon30_Else:
    assume {:partition} c#0 == char#ToInt(Lit(char#FromInt(101)));
    goto anon14;

  anon14:
    assume lambdaResult#1 <==> c#0 == char#ToInt(Lit(char#FromInt(101))) || c#0 == char#ToInt(Lit(char#FromInt(69)));
    assume true;
    assume $Is(lambdaResult#1, TBool);
    goto anon15;

  anon29_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon15;

  anon15:
    assume false;
    goto anon16;

  anon28_Else:
    goto anon16;

  anon16:
    ##p#0 := Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box($Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint8())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box($Unbox($l#19#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#19#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.BoundedInts.uint8())), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box($Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint8())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box($Unbox($l#21#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#21#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.BoundedInts.uint8())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box($Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.BoundedInts.uint8())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box($Unbox($l#23#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#23#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.BoundedInts.uint8())), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box($Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.BoundedInts.uint8())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box($Unbox($l#25#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#25#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.BoundedInts.uint8())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box($Unbox($l#27#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#27#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.BoundedInts.uint8())), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box($Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint8())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box($Unbox($l#30#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#30#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.BoundedInts.uint8())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#0#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(e#Z#0), cs#Z#0) == let#0#0#0;
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Empty_q(e#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#Z#0)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon23;

  anon31_Else:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Empty_q(e#Z#0);
    assume $IsAllocBox($Box(e#Z#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(101));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(e#Z#0);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(e#Z#0, Lit(char#FromInt(101)));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Char_q(e#Z#0, Lit(char#FromInt(101)));
    assume $IsAllocBox($Box(e#Z#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := Lit(char#FromInt(69));
    assume $IsAlloc(##c#1, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(e#Z#0);
    assume {:subsumption 0} char#ToInt(##c#1) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(e#Z#0, Lit(char#FromInt(69)));
    goto anon20;

  anon32_Else:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Char_q(e#Z#0, Lit(char#FromInt(101)));
    goto anon20;

  anon20:
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall(e#Z#0, Lit(char#FromInt(101))) && (!JSON_mUtils_mViews_mCore.View__.Char_q(e#Z#0, Lit(char#FromInt(101))) ==> JSON_mUtils_mViews_mCore.View__.Char_q#canCall(e#Z#0, Lit(char#FromInt(69))));
    assume JSON_mUtils_mViews_mCore.View__.Char_q(e#Z#0, Lit(char#FromInt(101))) || JSON_mUtils_mViews_mCore.View__.Char_q(e#Z#0, Lit(char#FromInt(69)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(766,43)"} true;
    havoc sign#Z#0;
    havoc cs#Z#1;
    assume $Is(sign#Z#0, Tclass.JSON_mGrammar.jsign()) && $IsAlloc(sign#Z#0, Tclass.JSON_mGrammar.jsign(), $Heap) && $Is(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##cs#0 := cs#Z#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#Z#0));
    assume let#1#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#1#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(sign#Z#0), cs#Z#1) == let#1#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#1 := cs#Z#1;
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#Z#1);
    assume let#2#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#Z#1);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#Z#1);
    assume $Is(let#2#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon23;

  anon33_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc num#Z#0;
    havoc cs#Z#2;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnum(), $Heap) && $Is(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#3#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#3#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs#Z#2) == let#3#0#0;
    assume $Is(e#Z#0, Tclass.JSON_mGrammar.je());
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#Z#0, sign#Z#0, num#Z#0)))), cs#Z#2)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon23;

  anon23:
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#0#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $IsBox($l#0#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box($Unbox($l#3#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.BoundedInts.uint8())), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box($Unbox($l#4#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.BoundedInts.uint8())), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))) && (var period#0, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box($Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.BoundedInts.uint8())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box($Unbox($l#5#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.BoundedInts.uint8())), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#0) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#1) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) == (var period#0, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box($Unbox($l#1#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box($Unbox($l#1#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.BoundedInts.uint8())), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#0) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#1))) else (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#1); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#0) else (var num#0, cs#2 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#0, num#0)))), cs#2)))))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box($Unbox($l#8#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint8())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box($Unbox($l#9#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.BoundedInts.uint8())), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))))) && (var period#1, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box($Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box($Unbox($l#10#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.BoundedInts.uint8())), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#1) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#3) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) == (var period#1, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box($Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box($Unbox($l#6#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.BoundedInts.uint8())), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#1) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#3))) else (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#3); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#1) else (var num#1, cs#4 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#1, num#1)))), cs#4)))))))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$8x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$8x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$8x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$8x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$8x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$8x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$8x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$8x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$8x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$8x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$8x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$8x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Frac (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id25994"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#11#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#11#heap#0: Heap, $l#11#frac#0: Box :: $IsBox($l#11#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#11#heap#0: Heap, $l#11#frac#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Frac (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var frac#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var period#Z#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var $lambdaHeap#1: Heap;
  var c#0: int;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##p#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var num#Z#0: DatatypeType;
  var cs#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.Frac", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(772,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc frac#0;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $IsAlloc(frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume true;
    ##self#0 := frac#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $lambdaHeap#0);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), frac#0, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), frac#0, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), frac#0, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon6;

  anon23_Else:
    assume {:partition} !($Is(frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $IsAlloc(frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon22_Else:
    goto anon7;

  anon7:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#13#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#13#heap#0: Heap, $l#13#frac#0: Box :: $IsBox($l#13#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#13#heap#0: Heap, $l#13#frac#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#14#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#14#heap#0: Heap, $l#14#frac#0: Box :: $IsBox($l#14#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#14#heap#0: Heap, $l#14#frac#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#15#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#15#heap#0: Heap, $l#15#frac#0: Box :: $IsBox($l#15#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#15#heap#0: Heap, $l#15#frac#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    goto anon9;

  anon21_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#16#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: $IsBox($l#16#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))));
    goto anon9;

  anon9:
    assume false;
    return;

  anon20_Else:
    havoc period#Z#0;
    havoc cs#Z#0;
    assume $Is(period#Z#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(period#Z#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    goto anon24_Then, anon24_Else;

  anon24_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume {:partition} LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8();
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(46)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(46)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume lambdaResult#1 <==> c#0 == char#ToInt(Lit(char#FromInt(46)));
    assume true;
    assume $Is(lambdaResult#1, TBool);
    goto anon13;

  anon25_Else:
    assume {:partition} !(LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__8());
    goto anon13;

  anon13:
    assume false;
    goto anon14;

  anon24_Else:
    goto anon14;

  anon14:
    ##p#0 := Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box($Unbox($l#18#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.BoundedInts.uint8())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box($Unbox($l#19#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.BoundedInts.uint8())), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box($Unbox($l#20#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.BoundedInts.uint8())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))));
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box($Unbox($l#21#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.BoundedInts.uint8())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box($Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.BoundedInts.uint8())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box($Unbox($l#23#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.BoundedInts.uint8())), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box($Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.BoundedInts.uint8())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box($Unbox($l#25#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.BoundedInts.uint8())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box($Unbox($l#27#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.BoundedInts.uint8())), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))));
    assume JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box($Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint8())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box($Unbox($l#30#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.BoundedInts.uint8())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))));
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#0#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(period#Z#0), cs#Z#0) == let#0#0#0;
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume {:partition} JSON_mUtils_mViews_mCore.View__.Empty_q(period#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#Z#0)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon19;

  anon26_Else:
    assume {:partition} !JSON_mUtils_mViews_mCore.View__.Empty_q(period#Z#0);
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#0 := cs#Z#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#Z#0);
    assume let#1#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#Z#0);
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon19;

  anon27_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc num#Z#0;
    havoc cs#Z#1;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnum()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnum(), $Heap) && $Is(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#2#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs#Z#1) == let#2#0#0;
    assume $Is(period#Z#0, Tclass.JSON_mGrammar.jperiod());
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#Z#0, num#Z#0)))), cs#Z#1)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon19;

  anon19:
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal: bool, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#0#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $IsBox($l#0#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#1#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#1#heap#0: Heap, $l#1#exp#0: Box :: $IsBox($l#1#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#1#heap#0: Heap, $l#1#exp#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#2#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: $IsBox($l#2#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#3#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#3#heap#0: Heap, $l#3#exp#0: Box :: $IsBox($l#3#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#3#heap#0: Heap, $l#3#exp#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0) == (var sp#0 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0)); sp#0));
axiom 0 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), Lit(minus#0), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), Lit(num#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(minus#0))), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), Lit(frac#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(num#0))), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#4#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#4#heap#0: Heap, $l#4#frac#0: Box :: $IsBox($l#4#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#4#heap#0: Heap, $l#4#frac#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Lit(exp#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(frac#0))), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#5#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#5#heap#0: Heap, $l#5#exp#0: Box :: $IsBox($l#5#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#5#heap#0: Heap, $l#5#exp#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(num#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) == (var sp#1 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jnumber.JNumber(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(minus#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(num#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(frac#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(exp#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(exp#0))))); sp#1));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.Number#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Number#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Number($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0) <==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#2#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: $IsBox($l#2#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#3#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#3#heap#0: Heap, $l#3#exp#0: Box :: $IsBox($l#3#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#3#heap#0: Heap, $l#3#exp#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.NumberFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()), minus#0: DatatypeType where $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())), num#0: DatatypeType where $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())), frac#0: DatatypeType where $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), exp#0: DatatypeType where $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())))) returns (sp#2: DatatypeType where $Is(sp#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id26019"} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.NumberFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType) returns (sp#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var frac#1: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var $lambdaHeap#1: Heap;
  var exp#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#2: DatatypeType;
  var ##v#0_0: DatatypeType;
  var ##v#0_1: DatatypeType;
  var ##self#0_0: DatatypeType;
  var ##fT#0_0: HandleType;
  var ##self#0_1: DatatypeType;
  var ##fT#0_1: HandleType;
  var ##v#0_0_0: DatatypeType;
  var ##v#0_0_1: DatatypeType;
  var ##self#0_0_0: DatatypeType;
  var ##fT#0_0_0: HandleType;
  var ##self#0_0_1: DatatypeType;
  var ##fT#0_0_1: HandleType;
  var a##0_0_0: Seq;
  var ##v#0_0_2: DatatypeType;
  var b##0_0_0: Seq;
  var ##v#0_0_3: DatatypeType;
  var c##0_0_0: Seq;
  var a##0_0_1: Seq;
  var ##v#0_0_4: DatatypeType;
  var ##v#0_0_5: DatatypeType;
  var b##0_0_1: Seq;
  var ##self#0_0_2: DatatypeType;
  var ##fT#0_0_2: HandleType;
  var c##0_0_1: Seq;
  var a##0_0_2: Seq;
  var ##v#0_0_6: DatatypeType;
  var ##v#0_0_7: DatatypeType;
  var ##self#0_0_3: DatatypeType;
  var ##fT#0_0_3: HandleType;
  var b##0_0_2: Seq;
  var ##self#0_0_4: DatatypeType;
  var ##fT#0_0_4: HandleType;
  var c##0_0_2: Seq;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.NumberFromParts", " | ", cs#0, " | ", minus#0, " | ", num#0, " | ", frac#0, " | ", exp#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(784,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(minus#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jminus(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $IsAllocBox($Box(num#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(minus#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jint(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $IsAllocBox($Box(frac#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc frac#1;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Is(frac#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $IsAlloc(frac#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume true;
    ##self#0 := frac#1;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $lambdaHeap#0);
    ##fT#0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), frac#1, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), frac#1, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), frac#1, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon17_Else:
    assume {:partition} !($Is(frac#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())) && $IsAlloc(frac#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon16_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(num#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#7#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#7#heap#0: Heap, $l#7#frac#0: Box :: $IsBox($l#7#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#7#heap#0: Heap, $l#7#frac#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#8#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#8#heap#0: Heap, $l#8#frac#0: Box :: $IsBox($l#8#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#8#heap#0: Heap, $l#8#frac#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#9#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#9#heap#0: Heap, $l#9#frac#0: Box :: $IsBox($l#9#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#9#heap#0: Heap, $l#9#frac#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAllocBox($Box(exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc exp#1;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} $Is(exp#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())) && $IsAlloc(exp#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    assume true;
    ##self#1 := exp#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $lambdaHeap#1);
    ##fT#1 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), exp#1, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), exp#1, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), exp#1, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon19_Else:
    assume {:partition} !($Is(exp#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())) && $IsAlloc(exp#1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $lambdaHeap#1));
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon18_Else:
    goto anon9;

  anon9:
    ##cs0#3 := JSON_mUtils_mCursors.Split.cs(frac#0);
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#11#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: $IsBox($l#11#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#12#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#12#heap#0: Heap, $l#12#exp#0: Box :: $IsBox($l#12#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#12#heap#0: Heap, $l#12#exp#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#13#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#13#heap#0: Heap, $l#13#exp#0: Box :: $IsBox($l#13#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#13#heap#0: Heap, $l#13#exp#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))));
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()));
    assume $IsAllocBox($Box(sp#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), $Heap);
    assume true;
    ##cs0#4 := cs#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mConcreteSyntax_mSpec.__default.Number#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume false;
    return;

  anon20_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    assume $Is($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, Tclass.JSON_mGrammar.jnum());
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume let#0#0#0 == #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()));
    assume sp#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    ##self#2 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.jnumber(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Number#canCall($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(exp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mConcreteSyntax_mSpec.__default.Number#canCall($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    ##v#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType;
    assume $IsAlloc(##v#0_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    ##v#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType;
    assume $IsAlloc(##v#0_1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume true;
    ##self#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType;
    assume $IsAlloc(##self#0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#0_0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume true;
    ##self#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType;
    assume $IsAlloc(##self#0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    ##fT#0_1 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#0_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(exp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    ##v#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(minus#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(minus#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(minus#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(minus#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(minus#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(799,68)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(minus#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(minus#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(minus#0));
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    ##v#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(num#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(num#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(minus#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(num#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(800,70)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(num#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume true;
    ##self#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#0_0_0 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(frac#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(num#0)) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(num#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(frac#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(801,82)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(frac#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume true;
    ##self#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    ##fT#0_0_1 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#0_0_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(exp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(frac#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(exp#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(802,80)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    ##v#0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_2, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    a##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    ##v#0_0_3 := $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_3, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    b##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(num#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(num#0));
    assume JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(num#0));
    c##0_0_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(num#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(803,74)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    ##v#0_0_4 := $Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_4, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    ##v#0_0_5 := $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_5, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    a##0_0_1 := Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume true;
    ##self#0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_2, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#0_0_2 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0_0_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    b##0_0_1 := JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(frac#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(frac#0));
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(frac#0));
    c##0_0_1 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(frac#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_1, b##0_0_1, c##0_0_1);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_1, b##0_0_1, c##0_0_1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(804,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0);
    ##v#0_0_6 := $Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_6, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(num#0);
    ##v#0_0_7 := $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType;
    assume $IsAlloc(##v#0_0_7, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(frac#0);
    assume true;
    ##self#0_0_3 := $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_3, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Heap);
    ##fT#0_0_3 := JSON_mConcreteSyntax_mSpec.__default.Frac#Handle();
    assume $IsAlloc(##fT#0_0_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle());
    a##0_0_2 := Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()));
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume true;
    ##self#0_0_4 := $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_4, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Heap);
    ##fT#0_0_4 := JSON_mConcreteSyntax_mSpec.__default.Exp#Handle();
    assume $IsAlloc(##fT#0_0_4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mConcreteSyntax_mSpec.__default.Maybe#canCall(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    b##0_0_2 := JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(exp#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    assume JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(exp#0));
    c##0_0_2 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(exp#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_2, b##0_0_2, c##0_0_2);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_2, b##0_0_2, c##0_0_2);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(805,136)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(exp#0))));
    assume false;
    goto anon14;

  anon22_Else:
    goto anon14;

  anon14:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.View($Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle())), JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle())), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(exp#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(806,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(exp#0))));
    assume false;
    goto anon15;

  anon21_Else:
    goto anon15;

  anon15:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(exp#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(807,6)"} true;
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), $Heap);
    assume true;
    ##cs0#5 := cs#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mConcreteSyntax_mSpec.__default.Number#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(808,51)"} true;
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#0, num#0, frac#0, exp#0) == sp#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#0, num#0, frac#0, exp#0) == sp#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 4 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || (4 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) && (var minus#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#0)) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var num#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#0)) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (var frac#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#0)) && (var valueOrError2#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) && (var exp#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) == (var minus#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#0) else (var num#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#0) else (var frac#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; (var valueOrError2#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#0) else (var exp#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#0, num#0, frac#0, exp#0))))))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) || (4 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) && (var minus#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(minus#1) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#1)) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#1)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var num#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#1) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#1)) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#1)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (var frac#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#1) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#1)) && (var valueOrError2#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#1)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) && (var exp#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), minus#1, num#1, frac#1, exp#1))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) == (var minus#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#1)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#1) else (var num#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#1)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#1) else (var frac#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; (var valueOrError2#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#1)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#1) else (var exp#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, Lit(cs#0), minus#1, num#1, frac#1, exp#1))))))))))))));
}

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Number (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id26078"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.Number (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var minus#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var num#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var frac#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var valueOrError2#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs#3: DatatypeType;
  var exp#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##cs#4: DatatypeType;
  var ##minus#0: DatatypeType;
  var ##num#0: DatatypeType;
  var ##frac#0: DatatypeType;
  var ##exp#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Numbers.Number", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(815,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.Number#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    goto anon5;

  anon15_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon14_Else:
    havoc minus#Z#0;
    assume $Is(minus#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()));
    assume minus#Z#0 == let#0#0#0;
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(minus#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(minus#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#Z#0));
    assume let#1#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(minus#Z#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#Z#0));
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon16_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc num#Z#0;
    assume $Is(num#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()));
    assume num#Z#0 == let#2#0#0;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(num#Z#0);
    ##cs#2 := JSON_mUtils_mCursors.Split.cs(num#Z#0);
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#Z#0));
    assume let#3#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(num#Z#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#Z#0));
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon17_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc frac#Z#0;
    assume $Is(frac#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#4#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())));
    assume frac#Z#0 == let#4#0#0;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(frac#Z#0);
    ##cs#3 := JSON_mUtils_mCursors.Split.cs(frac#Z#0);
    assume $IsAlloc(##cs#3, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#Z#0));
    assume let#5#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(frac#Z#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#Z#0));
    assume $Is(let#5#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError2#Z#0 == let#5#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    havoc exp#Z#0;
    assume $Is(exp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())));
    assume exp#Z#0 == let#6#0#0;
    ##cs#4 := cs#0;
    assume $IsAlloc(##cs#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##minus#0 := minus#Z#0;
    assume $IsAlloc(##minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap);
    ##num#0 := num#Z#0;
    assume $IsAlloc(##num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap);
    ##frac#0 := frac#Z#0;
    assume $IsAlloc(##frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap);
    ##exp#0 := exp#Z#0;
    assume $IsAlloc(##exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##minus#0), ##cs#4) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##minus#0), ##cs#4) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##minus#0), ##cs#4) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##minus#0), ##cs#4));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#4), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jminus(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##minus#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##minus#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), ##minus#0, ##cs#4, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##num#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##num#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##minus#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##num#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##minus#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##num#0), JSON_mUtils_mCursors.Split.cs(##minus#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##num#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##minus#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##minus#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jint(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##num#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##num#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), ##num#0, JSON_mUtils_mCursors.Split.cs(##minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#0#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $IsBox($l#0#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#1#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#1#heap#0: Heap, $l#1#frac#0: Box :: $IsBox($l#1#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#1#heap#0: Heap, $l#1#frac#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##frac#0), JSON_mUtils_mCursors.Split.cs(##num#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##frac#0), JSON_mUtils_mCursors.Split.cs(##num#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##frac#0), JSON_mUtils_mCursors.Split.cs(##num#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##frac#0), JSON_mUtils_mCursors.Split.cs(##num#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#0#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: $IsBox($l#0#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#0#heap#0: Heap, $l#0#frac#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#1#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#1#heap#0: Heap, $l#1#frac#0: Box :: $IsBox($l#1#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#1#heap#0: Heap, $l#1#frac#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#2#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: $IsBox($l#2#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#2#heap#0: Heap, $l#2#frac#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#3#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#3#heap#0: Heap, $l#3#frac#0: Box :: $IsBox($l#3#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#3#heap#0: Heap, $l#3#frac#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##num#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#4#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#4#heap#0: Heap, $l#4#frac#0: Box :: $IsBox($l#4#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#4#heap#0: Heap, $l#4#frac#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##frac#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##frac#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), ##frac#0, JSON_mUtils_mCursors.Split.cs(##num#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#7#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#7#heap#0: Heap, $l#7#frac#0: Box :: $IsBox($l#7#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#7#heap#0: Heap, $l#7#frac#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#8#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#8#heap#0: Heap, $l#8#exp#0: Box :: $IsBox($l#8#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#8#heap#0: Heap, $l#8#exp#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#9#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#9#heap#0: Heap, $l#9#exp#0: Box :: $IsBox($l#9#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#9#heap#0: Heap, $l#9#exp#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##exp#0), JSON_mUtils_mCursors.Split.cs(##frac#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##exp#0), JSON_mUtils_mCursors.Split.cs(##frac#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##exp#0), JSON_mUtils_mCursors.Split.cs(##frac#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##exp#0), JSON_mUtils_mCursors.Split.cs(##frac#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#8#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#8#heap#0: Heap, $l#8#exp#0: Box :: $IsBox($l#8#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#8#heap#0: Heap, $l#8#exp#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#9#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#9#heap#0: Heap, $l#9#exp#0: Box :: $IsBox($l#9#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#9#heap#0: Heap, $l#9#exp#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#10#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#10#heap#0: Heap, $l#10#exp#0: Box :: $IsBox($l#10#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#10#heap#0: Heap, $l#10#exp#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#11#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: $IsBox($l#11#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#11#heap#0: Heap, $l#11#exp#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##frac#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#12#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#12#heap#0: Heap, $l#12#exp#0: Box :: $IsBox($l#12#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#12#heap#0: Heap, $l#12#exp#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##exp#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##exp#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), ##exp#0, JSON_mUtils_mCursors.Split.cs(##frac#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#15#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: $IsBox($l#15#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#Z#0, num#Z#0, frac#Z#0, exp#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#Z#0, num#Z#0, frac#Z#0, exp#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0) == #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#Z#0, num#Z#0, frac#Z#0, exp#Z#0)));
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#Z#0, num#Z#0, frac#Z#0, exp#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon13;

  anon13:
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Digits (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Digits();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Digits (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Digits();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Digits (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Digits();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NonEmptyDigits (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NonEmptyDigits();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NonEmptyDigits (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NonEmptyDigits();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NonEmptyDigits (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NonEmptyDigits();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NonZeroInt (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NonZeroInt();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NonZeroInt (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NonZeroInt();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NonZeroInt (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NonZeroInt();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_OptionalMinus (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__OptionalMinus();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_OptionalMinus (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__OptionalMinus();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_OptionalMinus (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__OptionalMinus();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_OptionalSign (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__OptionalSign();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_OptionalSign (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__OptionalSign();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_OptionalSign (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__OptionalSign();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_TrimmedInt (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__TrimmedInt();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_TrimmedInt (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__TrimmedInt();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_TrimmedInt (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__TrimmedInt();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Exp (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Exp();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Exp (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Exp();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Exp (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Exp();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Frac (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Frac();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Frac (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Frac();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Frac (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Frac();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NumberFromParts (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NumberFromParts();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NumberFromParts (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NumberFromParts();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_NumberFromParts (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__NumberFromParts();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Number (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Number();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Number (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Number();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Numbers.reveal_Number (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mNumbers.__default.reveal__Number();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#232 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#232))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#234 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#234)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#348 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#348))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#350 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#350)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#352 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#352)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#348 := Wrappers.Option.value(this); v#348)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#350 := Lit(Wrappers.Option.value(Lit(this))); v#350)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#352 := Lit(Wrappers.Option.value(Lit(this))); v#352)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#232 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#232)) else (var e#232 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#234 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#234))) else (var e#234 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#348 := Wrappers.Result.value(this); s#348) else (var e#348 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#350 := Lit(Wrappers.Result.value(Lit(this))); s#350) else (var e#350 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#352 := Lit(Wrappers.Result.value(Lit(this))); s#352) else (var e#352 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#348 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#348)) else (var e#348 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#348)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#350 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#350))) else (var e#350 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#350)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#352 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#352))) else (var e#352 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#352)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#144: int, y#144: int :: { Mul(x#144, y#144) } Mul(x#144, y#144) == Mul(y#144, x#144)) && (forall x#145: int, y#145: int, z#96: int :: { Mul(x#145 + y#145, z#96) } Mul(x#145 + y#145, z#96) == Mul(x#145, z#96) + Mul(y#145, z#96)) && (forall x#146: int, y#146: int, z#97: int :: { Mul(x#146 - y#146, z#97) } Mul(x#146 - y#146, z#97) == Mul(x#146, z#97) - Mul(y#146, z#97));

axiom MulInternals.__default.MulAuto() <==> (forall x#147: int, y#147: int :: { Mul(x#147, y#147) } Mul(x#147, y#147) == Mul(y#147, x#147)) && (forall x#148: int, y#148: int, z#98: int :: { Mul(x#148 + y#148, z#98) } Mul(x#148 + y#148, z#98) == Mul(x#148, z#98) + Mul(y#148, z#98)) && (forall x#149: int, y#149: int, z#99: int :: { Mul(x#149 - y#149, z#99) } Mul(x#149 - y#149, z#99) == Mul(x#149, z#99) - Mul(y#149, z#99));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#176: int :: { Mod(Mod(x#176, n#0), n#0) } Mod(Mod(x#176, n#0), n#0) == Mod(x#176, n#0)) && (forall x#177: int :: { Mod(x#177, n#0) } LitInt(0) <= x#177 && x#177 < n#0 <==> Mod(x#177, n#0) == x#177) && (forall x#178: int, y#88: int :: { Mod(x#178 + y#88, n#0) } (var z#86 := Mod(x#178, n#0) + Mod(y#88, n#0); (LitInt(0) <= z#86 && z#86 < n#0 && Mod(x#178 + y#88, n#0) == z#86) || (n#0 <= z#86 && z#86 < n#0 + n#0 && Mod(x#178 + y#88, n#0) == z#86 - n#0))) && (forall x#179: int, y#89: int :: { Mod(x#179 - y#89, n#0) } (var z#87 := Mod(x#179, n#0) - Mod(y#89, n#0); (LitInt(0) <= z#87 && z#87 < n#0 && Mod(x#179 - y#89, n#0) == z#87) || (0 - n#0 <= z#87 && z#87 < 0 && Mod(x#179 - y#89, n#0) == z#87 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#180: int :: { Mod(Mod(x#180, n#0), n#0) } Mod(Mod(x#180, LitInt(n#0)), LitInt(n#0)) == Mod(x#180, LitInt(n#0))) && (forall x#181: int :: { Mod(x#181, n#0) } LitInt(0) <= x#181 && x#181 < n#0 <==> Mod(x#181, LitInt(n#0)) == x#181) && (forall x#182: int, y#90: int :: { Mod(x#182 + y#90, n#0) } (var z#88 := Mod(x#182, LitInt(n#0)) + Mod(y#90, LitInt(n#0)); (LitInt(0) <= z#88 && z#88 < n#0 && Mod(x#182 + y#90, LitInt(n#0)) == z#88) || (LitInt(n#0) <= z#88 && z#88 < n#0 + n#0 && Mod(x#182 + y#90, LitInt(n#0)) == z#88 - n#0))) && (forall x#183: int, y#91: int :: { Mod(x#183 - y#91, n#0) } (var z#89 := Mod(x#183, LitInt(n#0)) - Mod(y#91, LitInt(n#0)); (LitInt(0) <= z#89 && z#89 < n#0 && Mod(x#183 - y#91, LitInt(n#0)) == z#89) || (LitInt(0 - n#0) <= z#89 && z#89 < 0 && Mod(x#183 - y#91, LitInt(n#0)) == z#89 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#126: int :: { Div(x#126, n#0) } LitInt(0) <= x#126 && x#126 < n#0 <==> Div(x#126, n#0) == LitInt(0)) && (forall x#127: int, y#84: int :: { Div(x#127 + y#84, n#0) } (var z#82 := Mod(x#127, n#0) + Mod(y#84, n#0); (LitInt(0) <= z#82 && z#82 < n#0 && Div(x#127 + y#84, n#0) == Div(x#127, n#0) + Div(y#84, n#0)) || (n#0 <= z#82 && z#82 < n#0 + n#0 && Div(x#127 + y#84, n#0) == Div(x#127, n#0) + Div(y#84, n#0) + 1))) && (forall x#128: int, y#85: int :: { Div(x#128 - y#85, n#0) } (var z#83 := Mod(x#128, n#0) - Mod(y#85, n#0); (LitInt(0) <= z#83 && z#83 < n#0 && Div(x#128 - y#85, n#0) == Div(x#128, n#0) - Div(y#85, n#0)) || (0 - n#0 <= z#83 && z#83 < 0 && Div(x#128 - y#85, n#0) == Div(x#128, n#0) - Div(y#85, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#129: int :: { Div(x#129, n#0) } LitInt(0) <= x#129 && x#129 < n#0 <==> Div(x#129, LitInt(n#0)) == LitInt(0)) && (forall x#130: int, y#86: int :: { Div(x#130 + y#86, n#0) } (var z#84 := Mod(x#130, LitInt(n#0)) + Mod(y#86, LitInt(n#0)); (LitInt(0) <= z#84 && z#84 < n#0 && Div(x#130 + y#86, LitInt(n#0)) == Div(x#130, LitInt(n#0)) + Div(y#86, LitInt(n#0))) || (LitInt(n#0) <= z#84 && z#84 < n#0 + n#0 && Div(x#130 + y#86, LitInt(n#0)) == Div(x#130, LitInt(n#0)) + Div(y#86, LitInt(n#0)) + 1))) && (forall x#131: int, y#87: int :: { Div(x#131 - y#87, n#0) } (var z#85 := Mod(x#131, LitInt(n#0)) - Mod(y#87, LitInt(n#0)); (LitInt(0) <= z#85 && z#85 < n#0 && Div(x#131 - y#87, LitInt(n#0)) == Div(x#131, LitInt(n#0)) - Div(y#87, LitInt(n#0))) || (LitInt(0 - n#0) <= z#85 && z#85 < 0 && Div(x#131 - y#87, LitInt(n#0)) == Div(x#131, LitInt(n#0)) - Div(y#87, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#30 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#30) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#30)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#30 := lv#0; (var dt_update#end#0#30 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#30), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#30), dt_update#end#0#30))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#31 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#31) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#31)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#31 := Lit(lv#0); (var dt_update#end#0#31 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#31)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#31)), dt_update#end#0#31)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#32: char :: { Seq#Contains(s#0, $Box(c#32)) } $Is(c#32, TChar) && Seq#Contains(s#0, $Box(c#32)) ==> char#ToInt(c#32) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#32: char :: { Seq#Contains(s#0, $Box(c#32)) } $Is(c#32, TChar) && Seq#Contains(s#0, $Box(c#32)) ==> char#ToInt(c#32) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#64#i#0): int)): char))), (lambda $l#64#heap#0: Heap, $l#64#i#0: Box :: $IsBox($l#64#i#0, TInt) && LitInt(0) <= $Unbox($l#64#i#0): int && $Unbox($l#64#i#0): int < Seq#Length(s#0)), (lambda $l#64#heap#0: Heap, $l#64#i#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#33: char :: { Seq#Contains(s#0, $Box(c#33)) } $Is(c#33, TChar) && Seq#Contains(s#0, $Box(c#33)) ==> char#ToInt(c#33) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#66#i#0): int)): char))), (lambda $l#66#heap#0: Heap, $l#66#i#0: Box :: $IsBox($l#66#i#0, TInt) && LitInt(0) <= $Unbox($l#66#i#0): int && $Unbox($l#66#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#66#heap#0: Heap, $l#66#i#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#84 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#42 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#84 := (if b#84 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#84)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#42)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#84)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#85 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#42 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#85 := (if b#85 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#85)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#42 := Seq#Create(TChar, $Heap, Seq#Length(bs0#42), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#42, $Unbox($l#67#idx#0): int)): int))), (lambda $l#67#heap#0: Heap, $l#67#idx#0: Box :: $IsBox($l#67#idx#0, TInt) && LitInt(0) <= $Unbox($l#67#idx#0): int && $Unbox($l#67#idx#0): int < Seq#Length(bs0#42)), (lambda $l#67#heap#0: Heap, $l#67#idx#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#42), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#85))))) else (var err#42 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#42)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#88 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#44 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#88 := (if b#88 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#88)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#44)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#88)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#89 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#44 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#89 := (if b#89 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#89)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#44 := Seq#Create(TChar, $Heap, Seq#Length(bs0#44), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#44, $Unbox($l#70#idx#0): int)): int))), (lambda $l#70#heap#0: Heap, $l#70#idx#0: Box :: $IsBox($l#70#idx#0, TInt) && LitInt(0) <= $Unbox($l#70#idx#0): int && $Unbox($l#70#idx#0): int < Seq#Length(bs0#44)), (lambda $l#70#heap#0: Heap, $l#70#idx#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#44), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#89))))) else (var err#44 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#44)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#92 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#46 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#92 := (if b#92 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#92)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#46)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#92)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#93 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#46 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#93 := (if b#93 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#93)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#46 := Seq#Create(TChar, $Heap, Seq#Length(bs0#46), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#46, $Unbox($l#73#idx#0): int)): int))), (lambda $l#73#heap#0: Heap, $l#73#idx#0: Box :: $IsBox($l#73#idx#0, TInt) && LitInt(0) <= $Unbox($l#73#idx#0): int && $Unbox($l#73#idx#0): int < Seq#Length(bs0#46)), (lambda $l#73#heap#0: Heap, $l#73#idx#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#46), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#93))))) else (var err#46 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#46)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#9: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#9)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#9)): int } LitInt(0) <= idx#9 && idx#9 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#9 && idx#9 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#9)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#9)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#14 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#14 := this; (var dt_update#beg#0#14 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#14), dt_update#beg#0#14, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#14), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#14)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#15 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#15 := Lit(this); (var dt_update#beg#0#15 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#15)), dt_update#beg#0#15, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#15)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#15)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#57#v#0): DatatypeType))), (lambda $l#57#heap#0: Heap, $l#57#v#0: Box :: $IsBox($l#57#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#57#heap#0: Heap, $l#57#v#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#58#v#0): DatatypeType))), (lambda $l#58#heap#0: Heap, $l#58#v#0: Box :: $IsBox($l#58#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#58#heap#0: Heap, $l#58#v#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#59#v#0): DatatypeType))), (lambda $l#59#heap#0: Heap, $l#59#v#0: Box :: $IsBox($l#59#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#59#heap#0: Heap, $l#59#v#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#14 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#14 := this; (var dt_update#point#0#14 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#14), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#14), dt_update#point#0#14, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#14)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#15 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#15 := Lit(this); (var dt_update#point#0#15 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#15)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#15)), dt_update#point#0#15, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#15)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#14 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#14)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#14 := this; (var dt_update#point#0#14 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#14), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#14), dt_update#point#0#14, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#14)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#15 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#15)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#15 := Lit(this); (var dt_update#point#0#15 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#15)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#15)), dt_update#point#0#15, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#15)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#14 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#14 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#14 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#14 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#14))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#15 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#15 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#15 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#15 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#15)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#24: int :: { Seq#Contains(bs#0, $Box(b#24)) } LitInt(0) <= b#24 && b#24 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#24)) ==> b#24 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#24: int :: { Seq#Contains(bs#0, $Box(b#24)) } LitInt(0) <= b#24 && b#24 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#24)) ==> b#24 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#21 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#21)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21) && (var ps#21 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#21, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#21 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#21) else (var ps#21 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#21)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#21, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#25: int :: { Seq#Contains(bs#0, $Box(b#25)) } LitInt(0) <= b#25 && b#25 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#25)) ==> b#25 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#22 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#22)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22) && (var ps#22 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#22, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#22 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#22) else (var ps#22 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#22)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#22, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#26: int :: { Seq#Contains(bs#0, $Box(b#26)) } LitInt(0) <= b#26 && b#26 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#26)) ==> b#26 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#23 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#23)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23) && (var ps#23 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#23, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#23 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#23) else (var ps#23 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#23)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#23, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#9: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#9)): int } LitInt(0) <= idx#9 && idx#9 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#9 && idx#9 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#9)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#44 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#44)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#43 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#43)))) else (var st#43 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#43))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#46 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#46)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#45 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#45)))) else (var st#45 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#45))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#48 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#48)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#47 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#47)))) else (var st#47 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#47))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#56#heap#0: Heap, $l#56#_v0#0: Box :: $IsBox($l#56#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#56#heap#0: Heap, $l#56#_v0#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#57#heap#0: Heap, $l#57#_v1#0: Box :: $IsBox($l#57#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#57#heap#0: Heap, $l#57#_v1#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#60#heap#0: Heap, $l#60#_v0#0: Box :: $IsBox($l#60#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#60#heap#0: Heap, $l#60#_v0#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#61#heap#0: Heap, $l#61#_v1#0: Box :: $IsBox($l#61#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#61#heap#0: Heap, $l#61#_v1#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#cs#0: Box :: $Box(Lit(false))), (lambda $l#84#heap#0: Heap, $l#84#cs#0: Box :: $IsBox($l#84#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#84#heap#0: Heap, $l#84#cs#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#85#heap#0: Heap, $l#85#cs#0: Box :: $IsBox($l#85#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#85#heap#0: Heap, $l#85#cs#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#86#heap#0: Heap, $l#86#_v2#0: Box :: $IsBox($l#86#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#86#heap#0: Heap, $l#86#_v2#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#cs#0: Box :: $Box(Lit(false))), (lambda $l#90#heap#0: Heap, $l#90#cs#0: Box :: $IsBox($l#90#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#90#heap#0: Heap, $l#90#cs#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#91#heap#0: Heap, $l#91#cs#0: Box :: $IsBox($l#91#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#91#heap#0: Heap, $l#91#cs#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#92#ly#0: LayerType :: Handle1((lambda $l#92#heap#0: Heap, $l#92#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#92#heap#0: Heap, $l#92#_v2#0: Box :: $IsBox($l#92#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#92#heap#0: Heap, $l#92#_v2#0: Box :: SetRef_to_SetBox((lambda $l#92#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#14: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#14))): DatatypeType } $Is(cs'#14, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#14))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#14))): DatatypeType)): DatatypeType, cs'#14, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#14: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#14))): DatatypeType } $Is(cs'#14, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#14))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#14))): DatatypeType)): DatatypeType, cs'#14, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#15: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#15))): DatatypeType } $Is(cs'#15, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#15))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#15))): DatatypeType)): DatatypeType, cs'#15, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#15: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#15))): DatatypeType } $Is(cs'#15, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#15))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#15))): DatatypeType)): DatatypeType, cs'#15, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#42: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#42)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#42))): bool } $Is(cs'#42, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#42))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#42)))) && ((forall cs'#42: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#42)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#42))): bool } $Is(cs'#42, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#42))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#42))) ==> (forall cs'#43: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#43))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#43, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#43: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#43))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#43, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#43))): bool) ==> (forall cs'#44: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#44))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#44))): bool } $Is(cs'#44, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#44))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#44))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#44))): DatatypeType)): DatatypeType, cs'#44, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#42: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#42)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#42))): bool } $Is(cs'#42, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#42))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#42))) && (forall cs'#43: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#43))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#43, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#43, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#43))): bool) && (forall cs'#44: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#44))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#44))): bool } $Is(cs'#44, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#44))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#44))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#44))): DatatypeType)): DatatypeType, cs'#44, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#45: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#45)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#45))): bool } $Is(cs'#45, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#45))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#45)))) && ((forall cs'#45: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#45)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#45))): bool } $Is(cs'#45, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#45))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#45))) ==> (forall cs'#46: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#46))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#46, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#46, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#46, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#46, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#46: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#46))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#46, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#46, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#46, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#46))): bool) ==> (forall cs'#47: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#47))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#47))): bool } $Is(cs'#47, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#47))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#47))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#47))): DatatypeType)): DatatypeType, cs'#47, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#45: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#45)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#45))): bool } $Is(cs'#45, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#45))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#45))) && (forall cs'#46: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#46))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#46, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#46, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#46, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#46))): bool) && (forall cs'#47: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#47))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#47))): bool } $Is(cs'#47, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#47))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#47))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#47))): DatatypeType)): DatatypeType, cs'#47, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#14: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#14)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#14)) ==> LitInt(0) <= d#14 && d#14 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#36 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#37 := Seq#Append(digits'#36, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#37))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#37 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#38 := Seq#Append(digits'#37, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#38))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#38 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#39 := Seq#Append(digits'#38, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#39))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#14: Box :: { Seq#Contains(chars#0, c#14) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#14) } $IsBox(c#14, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#14) ==> Seq#Contains(chars#0, c#14)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#29: int :: { Seq#Contains(digits#0, $Box(d#29)) } Seq#Contains(digits#0, $Box(d#29)) ==> LitInt(0) <= d#29 && d#29 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#29: int :: { Seq#Contains(digits#0, $Box(d#29)) } Seq#Contains(digits#0, $Box(d#29)) ==> LitInt(0) <= d#29 && d#29 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#30: int :: { Seq#Contains(digits#0, $Box(d#30)) } Seq#Contains(digits#0, $Box(d#30)) ==> LitInt(0) <= d#30 && d#30 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#14: Box :: { Seq#Contains(chars#0, c#14) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#14) } $IsBox(c#14, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#14) ==> Seq#Contains(chars#0, c#14)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#24 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#24) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#24), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#24 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#24), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#25 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#25) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#25), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#25 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#25), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#38: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#38)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#38) } $IsBox(c#38, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#38) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#38)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#39: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#39)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#39) } $IsBox(c#39, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#39) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#39)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#40: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#40)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#40) } $IsBox(c#40, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#40) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#40)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(Seq#Contains(chars#0, $l#18#c#0))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#27: Box :: { Map#Domain(digits#0)[c#27] } { Seq#Contains(str#0, c#27) } $IsBox(c#27, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#27) ==> Map#Domain(digits#0)[c#27])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#27: Box :: { Map#Domain(digits#0)[c#27] } { Seq#Contains(str#0, c#27) } $IsBox(c#27, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#27) ==> Map#Domain(digits#0)[c#27])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#28: Box :: { Map#Domain(digits#0)[c#28] } { Seq#Contains(str#0, c#28) } $IsBox(c#28, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#28) ==> Map#Domain(digits#0)[c#28])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(Map#Domain(digits#0)[$l#53#c#0])), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(Map#Domain(digits#0)[$l#53#c#0])), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(Map#Domain(digits#0)[$l#54#c#0])), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(Map#Domain(digits#0)[$l#55#c#0])), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#36 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#36) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#36) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#36)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#36) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#36)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#36 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#36) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#36) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#36)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#36) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#36))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#36 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#36) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#36) else (var tl#72 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#36)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#72)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#36 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#36) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#36) else (var tl#73 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#36)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#73)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#37 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#37) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#37) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#37)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#37) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#37)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#37 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#37) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#37) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#37)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#37) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#37))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#37 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#37) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#37) else (var tl#74 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#37)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#74)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#37 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#37) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#37) else (var tl#75 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#37)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#75)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#38 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#38) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#38) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#38)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#38) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#38)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#38 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#38) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#38) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#38)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#38) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#38))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#38 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#38) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#38) else (var tl#76 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#38)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#76)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#38 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#38) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#38) else (var tl#77 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#38)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#77)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#14: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#14)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#14)) ==> LitInt(0) <= d#14 && d#14 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#36 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#37 := Seq#Append(digits'#36, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#37))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#37 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#38 := Seq#Append(digits'#37, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#38))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#38 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#39 := Seq#Append(digits'#38, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#39))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#14: char :: { Seq#Contains(chars#0, $Box(c#14)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#14)) ==> Seq#Contains(chars#0, $Box(c#14))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#29: int :: { Seq#Contains(digits#0, $Box(d#29)) } Seq#Contains(digits#0, $Box(d#29)) ==> LitInt(0) <= d#29 && d#29 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#29: int :: { Seq#Contains(digits#0, $Box(d#29)) } Seq#Contains(digits#0, $Box(d#29)) ==> LitInt(0) <= d#29 && d#29 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#30: int :: { Seq#Contains(digits#0, $Box(d#30)) } Seq#Contains(digits#0, $Box(d#30)) ==> LitInt(0) <= d#30 && d#30 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#14: char :: { Seq#Contains(chars#0, $Box(c#14)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#14)) ==> Seq#Contains(chars#0, $Box(c#14))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#24 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#24) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#24), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#24 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#24), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#25 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#25) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#25), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#25 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#25), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#38: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#38))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#38)) } $Is(c#38, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#38)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#38))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#39: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#39))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#39)) } $Is(c#39, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#39)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#39))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#40: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#40))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#40)) } $Is(c#40, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#40)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#40))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(Seq#Contains(chars#0, $l#18#c#0))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#27: char :: { Map#Domain(digits#0)[$Box(c#27)] } { Seq#Contains(str#0, $Box(c#27)) } $Is(c#27, TChar) && Seq#Contains(str#0, $Box(c#27)) ==> Map#Domain(digits#0)[$Box(c#27)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#27: char :: { Map#Domain(digits#0)[$Box(c#27)] } { Seq#Contains(str#0, $Box(c#27)) } $Is(c#27, TChar) && Seq#Contains(str#0, $Box(c#27)) ==> Map#Domain(digits#0)[$Box(c#27)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#28: char :: { Map#Domain(digits#0)[$Box(c#28)] } { Seq#Contains(str#0, $Box(c#28)) } $Is(c#28, TChar) && Seq#Contains(str#0, $Box(c#28)) ==> Map#Domain(digits#0)[$Box(c#28)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(Map#Domain(digits#0)[$l#53#c#0])), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, TChar)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(Map#Domain(digits#0)[$l#53#c#0])), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, TChar)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(Map#Domain(digits#0)[$l#54#c#0])), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, TChar)), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(Map#Domain(digits#0)[$l#55#c#0])), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, TChar)), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#36 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#36) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#36) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#36)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#36) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#36)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#36 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#36) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#36) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#36)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#36) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#36))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#36 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#36) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#36) else (var tl#72 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#36)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#72)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#36 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#36) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#36) else (var tl#73 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#36)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#73)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#37 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#37) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#37) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#37)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#37) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#37)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#37 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#37) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#37) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#37)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#37) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#37))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#37 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#37) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#37) else (var tl#74 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#37)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#74)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#37 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#37) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#37) else (var tl#75 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#37)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#75)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#38 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#38) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#38) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#38)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#38) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#38)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#38 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#38) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#38) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#38)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#38) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#38))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#38 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#38) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#38) else (var tl#76 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#38)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#76)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#38 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#38) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#38) else (var tl#77 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#38)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#77)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#13: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#13)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#13)) } $Is(c#13, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#13)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#13))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#16#c#0))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, TChar)), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#25: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)] } { Seq#Contains(str#0, $Box(c#25)) } $Is(c#25, TChar) && Seq#Contains(str#0, $Box(c#25)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#25: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)] } { Seq#Contains(str#0, $Box(c#25)) } $Is(c#25, TChar) && Seq#Contains(str#0, $Box(c#25)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#25)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#26: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#26)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#26)] } { Seq#Contains(str#0, $Box(c#26)) } $Is(c#26, TChar) && Seq#Contains(str#0, $Box(c#26)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#26)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#26)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#41#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#41#c#0]): int < base#0)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, TChar)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#41#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#41#c#0]): int < base#0)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, TChar)), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#42#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#42#c#0]): int < base#0)), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, TChar)), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#40 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#40)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#80 := JSON_mErrors.DeserializationError.b(this); (var b0#40 := JSON_mErrors.DeserializationError.expected(this); (var c#80 := (if b#80 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#80)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#40)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#80)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#81 := JSON_mErrors.DeserializationError.b(this); (var bs0#40 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#81 := (if b#81 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#81)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#40 := Seq#Create(TChar, $Heap, Seq#Length(bs0#40), Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#40, $Unbox($l#64#idx#0): int)): int))), (lambda $l#64#heap#0: Heap, $l#64#idx#0: Box :: $IsBox($l#64#idx#0, TInt) && LitInt(0) <= $Unbox($l#64#idx#0): int && $Unbox($l#64#idx#0): int < Seq#Length(bs0#40)), (lambda $l#64#heap#0: Heap, $l#64#idx#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#40), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#81))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#42 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#42)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#84 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#42 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#84 := (if b#84 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#84)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#42)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#84)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#85 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#42 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#85 := (if b#85 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#85)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#42 := Seq#Create(TChar, $Heap, Seq#Length(bs0#42), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#42, $Unbox($l#67#idx#0): int)): int))), (lambda $l#67#heap#0: Heap, $l#67#idx#0: Box :: $IsBox($l#67#idx#0, TInt) && LitInt(0) <= $Unbox($l#67#idx#0): int && $Unbox($l#67#idx#0): int < Seq#Length(bs0#42)), (lambda $l#67#heap#0: Heap, $l#67#idx#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#42), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#85))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#41 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#41, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#40 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#40, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#40 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#40)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#43 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#43, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#42 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#42, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#42 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#42)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#24: int :: { JSON_mGrammar.__default.Blank_q(b#24) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) } LitInt(0) <= b#24 && b#24 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#24))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#24: int :: { JSON_mGrammar.__default.Blank_q(b#24) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) } LitInt(0) <= b#24 && b#24 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) ==> JSON_mGrammar.__default.Blank_q(b#24))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#25: int :: { JSON_mGrammar.__default.Blank_q(b#25) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#25)) } LitInt(0) <= b#25 && b#25 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#25)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#25))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#25: int :: { JSON_mGrammar.__default.Blank_q(b#25) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#25)) } LitInt(0) <= b#25 && b#25 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#25)) ==> JSON_mGrammar.__default.Blank_q(b#25))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#24: int :: { $Unbox(Seq#Index(s#0, idx#24)): DatatypeType } LitInt(0) <= idx#24 && idx#24 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#24)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#24: int :: { $Unbox(Seq#Index(s#0, idx#24)): DatatypeType } LitInt(0) <= idx#24 && idx#24 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#24)): DatatypeType)) <==> idx#24 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#25: int :: { $Unbox(Seq#Index(s#0, idx#25)): DatatypeType } LitInt(0) <= idx#25 && idx#25 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#25)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#25: int :: { $Unbox(Seq#Index(s#0, idx#25)): DatatypeType } LitInt(0) <= idx#25 && idx#25 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#25)): DatatypeType)) <==> idx#25 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#24: int :: { JSON_mGrammar.__default.Digit_q(b#24) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) } LitInt(0) <= b#24 && b#24 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#24))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#24: int :: { JSON_mGrammar.__default.Digit_q(b#24) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) } LitInt(0) <= b#24 && b#24 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#24)) ==> JSON_mGrammar.__default.Digit_q(b#24))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#25: int :: { JSON_mGrammar.__default.Digit_q(b#25) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#25)) } LitInt(0) <= b#25 && b#25 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#25)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#25))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#25: int :: { JSON_mGrammar.__default.Digit_q(b#25) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#25)) } LitInt(0) <= b#25 && b#25 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#25)) ==> JSON_mGrammar.__default.Digit_q(b#25))));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$8x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$8x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$8x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$8x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$8x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$8x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$8x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$8x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$8x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$8x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$8x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$8x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#27: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#27) } { Seq#Contains(ts#0, d#27) } $IsBox(d#27, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#27) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#27))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#27: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#27) } { Seq#Contains(ts#0, d#27) } $IsBox(d#27, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#27) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#27))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#28: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#28) } { Seq#Contains(ts#0, d#28) } $IsBox(d#28, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#28) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#28))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#29: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#29) } { Seq#Contains(ts#0, d#29) } $IsBox(d#29, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#29) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#29))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#27: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#27)) } $Is(d#27, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#27) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#27)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#27: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#27)) } $Is(d#27, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#27) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#27)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#28: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#28)) } $Is(d#28, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#28) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#28)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#29: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#29)) } $Is(d#29, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#29) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#29)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$8x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$8x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$8x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$8x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$8x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$8x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$8x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$8x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$8x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$8x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$8x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$8x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#56#d#0: DatatypeType :: $Is($l#56#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#56#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#56#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#57#ly#0, $Unbox($l#57#d#0): DatatypeType))), (lambda $l#57#heap#0: Heap, $l#57#d#0: Box :: $IsBox($l#57#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#57#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#57#heap#0: Heap, $l#57#d#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#55#ly#0, $Unbox($l#55#d#0): DatatypeType))), (lambda $l#55#heap#0: Heap, $l#55#d#0: Box :: $IsBox($l#55#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#55#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#55#heap#0: Heap, $l#55#d#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#59#d#0: DatatypeType :: $Is($l#59#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#59#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#59#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#60#ly#0, $Unbox($l#60#d#0): DatatypeType))), (lambda $l#60#heap#0: Heap, $l#60#d#0: Box :: $IsBox($l#60#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#60#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#60#heap#0: Heap, $l#60#d#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#58#ly#0, $Unbox($l#58#d#0): DatatypeType))), (lambda $l#58#heap#0: Heap, $l#58#d#0: Box :: $IsBox($l#58#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#58#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#58#heap#0: Heap, $l#58#d#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#56#d#0: DatatypeType :: $Is($l#56#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#56#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#56#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#57#ly#0, $Unbox($l#57#d#0): DatatypeType))), (lambda $l#57#heap#0: Heap, $l#57#d#0: Box :: $IsBox($l#57#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#57#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#57#heap#0: Heap, $l#57#d#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#55#ly#0, $Unbox($l#55#d#0): DatatypeType))), (lambda $l#55#heap#0: Heap, $l#55#d#0: Box :: $IsBox($l#55#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#55#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#55#heap#0: Heap, $l#55#d#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#59#d#0: DatatypeType :: $Is($l#59#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#59#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#59#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#60#ly#0, $Unbox($l#60#d#0): DatatypeType))), (lambda $l#60#heap#0: Heap, $l#60#d#0: Box :: $IsBox($l#60#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#60#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#60#heap#0: Heap, $l#60#d#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#58#ly#0, $Unbox($l#58#d#0): DatatypeType))), (lambda $l#58#heap#0: Heap, $l#58#d#0: Box :: $IsBox($l#58#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#58#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#58#heap#0: Heap, $l#58#d#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#33 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#33))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#33 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#33))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#33 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#33))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#33 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#33))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#33 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#33))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#33 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#33))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#32 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#32)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#32 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#32)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#32 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#32)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#32 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#32)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#32 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#32)) else (var arr#32 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#32))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#35 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#35))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#35 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#35))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#35 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#35))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#35 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#35))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#35 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#35))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#35 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#35))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#34 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#34))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#34 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#34))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#34 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#34))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#34 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#34))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#34 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#34))) else (var arr#34 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#34)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$8x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$8x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$8x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$8x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$8x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$8x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$8x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$8x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$8x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$8x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$8x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$8x#0))): Seq);

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$5x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$5x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$5x#0): int)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$5x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$5x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$5x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$5x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$5x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$5x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#11#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $IsBox($l#11#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#43: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#43)) } $Is(cs#43, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#43)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#43: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#43)) } $Is(cs#43, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#43)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#44 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#10 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#44))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#45 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#45))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#10, cs#44 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#10 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#44))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#10) else (var val#10, cs#45 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType); (var after#10, cs#46 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#45))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#45)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#10, val#10, after#10)), cs#46)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#47: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#47)) } $Is(cs#47, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#47)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#48 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#11 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#48))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#49 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#49))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#11, cs#48 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#11 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#48))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#11) else (var val#11, cs#49 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); (var after#11, cs#50 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#49))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#49)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#11, val#11, after#11)), cs#50)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#10#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#st#0: Box :: $IsBox($l#10#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#10#heap#0: Heap, $l#10#st#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#31 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#31) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#31)) && (var cs#32 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#31))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#32))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#10, cs#31 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#10, cs#32 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#31)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#31))); (var after#10, cs#33 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#32))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#32)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#10, $Box(val#10), after#10)), cs#33)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#34 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#34) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#34)) && (var cs#35 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#34))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#35))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#11, cs#34 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#11, cs#35 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#34)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#34))); (var after#11, cs#36 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#35))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#35)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#11, $Box(val#11), after#11)), cs#36)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#12: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#12) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#12))): Seq } $Is(t#12, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#12)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#12: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#12) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#12))): Seq } $Is(t#12, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#12))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#12)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#13: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#13) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#13))): Seq } $Is(t#13, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#13)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#13: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#13) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#13))): Seq } $Is(t#13, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#13))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#13)))));

const reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts: bool;

const reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mObjectParams.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(): int == char#ToInt(Lit(char#FromInt(123)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.OPEN (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.OPEN (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ObjectParams.OPEN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(881,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(123)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(123)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(): int == char#ToInt(Lit(char#FromInt(125)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.CLOSE (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.CLOSE (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ObjectParams.CLOSE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(882,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(125)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(125)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))))));
}

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.Colon (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id26138"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.Colon (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##c0#0: char;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ObjectParams.Colon", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(884,13): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##c0#0 := Lit(char#FromInt(58));
    assume $IsAlloc(##c0#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume {:subsumption 0} char#ToInt(##c0#0) < 256;
    assume char#ToInt(##c0#0) < 256;
    assume JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58)));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58)));
    assume JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58)));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal: bool, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#0 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#0));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#1 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#1));
}

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$9x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$9x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$9x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$9x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$9x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$9x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$9x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$9x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$9x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$9x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$9x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$9x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle() : HandleType;

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(t#0) || (1 < $FunctionContextHeight && $Is(t#0, Tclass.JSON_mGrammar.jKeyValue())) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(t#0) || (1 < $FunctionContextHeight && $Is(t#0, Tclass.JSON_mGrammar.jKeyValue())) ==> JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(t#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0) == JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), t#0));
axiom 1 <= $FunctionContextHeight ==> (forall t#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(Lit(t#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(Lit(t#0)) || (1 < $FunctionContextHeight && $Is(t#0, Tclass.JSON_mGrammar.jKeyValue())) ==> JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(Lit(t#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(Lit(t#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), Lit(t#0))));
}

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(t#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.KeyValueFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()), k#0: DatatypeType where $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())), colon#0: DatatypeType where $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()))) returns (sp#2: DatatypeType where $Is(sp#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id26157"} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.KeyValueFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType) returns (sp#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##self#0_0: DatatypeType;
  var ##self#0_1: DatatypeType;
  var ##fT#0_0: HandleType;
  var ##self#0_2: DatatypeType;
  var ##self#0_0_0: DatatypeType;
  var ##self#0_0_1: DatatypeType;
  var ##fT#0_0_0: HandleType;
  var ##self#0_0_2: DatatypeType;
  var a##0_0_0: Seq;
  var ##self#0_0_3: DatatypeType;
  var b##0_0_0: Seq;
  var ##self#0_0_4: DatatypeType;
  var ##fT#0_0_1: HandleType;
  var c##0_0_0: Seq;
  var a##0_0_1: Seq;
  var ##self#0_0_5: DatatypeType;
  var ##self#0_0_6: DatatypeType;
  var ##fT#0_0_2: HandleType;
  var b##0_0_1: Seq;
  var ##self#0_0_7: DatatypeType;
  var c##0_0_1: Seq;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ObjectParams.KeyValueFromParts", " | ", cs#0, " | ", k#0, " | ", colon#0, " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(891,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(k#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume $IsAllocBox($Box(colon#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon13_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(k#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    assume true;
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(colon#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()));
    assume $IsAllocBox($Box(sp#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume 1 != $FunctionContextHeight;
    ##cs0#3 := cs#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume false;
    return;

  anon14_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume let#0#0#0 == #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()));
    assume sp#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    ##self#1 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    ##self#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType;
    assume $IsAlloc(##self#0_0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    ##self#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType;
    assume $IsAlloc(##self#0_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $Heap);
    ##fT#0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    ##self#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType;
    assume $IsAlloc(##self#0_2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    ##self#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(k#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(k#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(k#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(k#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(k#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(902,62)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(k#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(k#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(k#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    ##self#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $Heap);
    ##fT#0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(k#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(k#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(903,86)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    ##self#0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0))));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(904,67)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    ##self#0_0_3 := $Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_3, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType);
    a##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.String($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    ##self#0_0_4 := $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_4, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $Heap);
    ##fT#0_0_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    b##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#0));
    c##0_0_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(905,92)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(k#0);
    ##self#0_0_5 := $Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_5, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#0);
    ##self#0_0_6 := $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_6, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $Heap);
    ##fT#0_0_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    a##0_0_1 := Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()));
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    ##self#0_0_7 := $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_7, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType);
    b##0_0_1 := JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(v#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    assume JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#0));
    c##0_0_1 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_1, b##0_0_1, c##0_0_1);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_1, b##0_0_1, c##0_0_1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(906,106)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0))));
    assume false;
    goto anon10;

  anon16_Else:
    goto anon10;

  anon10:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(907,8)"} true;
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0))));
    assume false;
    goto anon11;

  anon15_Else:
    goto anon11;

  anon11:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(908,6)"} true;
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume 1 != $FunctionContextHeight;
    ##cs0#4 := cs#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(909,51)"} true;
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#0, colon#0, v#0) == sp#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()));
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#0, colon#0, v#0) == sp#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires(DatatypeType) : bool;

axiom (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires(t#0) } $Is(t#0, Tclass.JSON_mGrammar.jKeyValue()) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires(t#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.ElementSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0: DatatypeType where $Is(t#0, Tclass.JSON_mGrammar.jKeyValue()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var k#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#0), p#0) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#0), p#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (var colon#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && (var valueOrError2#0 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) && (var v#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#0) else (var k#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#0), p#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#0) else (var colon#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; (var valueOrError2#0 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#0)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#0) else (var v#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType; (var kv#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#0, colon#0, v#0); #Wrappers.Result.Success($Box(kv#0))))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var k#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#1), p#1) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#1), p#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (var colon#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#1) && (var valueOrError2#1 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#1)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) && (var v#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#1, colon#1, v#1))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#1) else (var k#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#1), p#1); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#1) else (var colon#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; (var valueOrError2#1 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#1)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#1) else (var v#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType; (var kv#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#1, colon#1, v#1); #Wrappers.Result.Success($Box(kv#1))))))))))))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var k#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#2), p#2) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#2), p#2); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (var colon#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#2) && (var valueOrError2#2 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#2)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) && (var v#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#2, colon#2, v#2))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#2) else (var k#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#2), p#2); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#2) else (var colon#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; (var valueOrError2#2 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#2)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#2) else (var v#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType; (var kv#2 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#2, colon#2, v#2); #Wrappers.Result.Success($Box(kv#2))))))))))))));
}

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#requires(DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#requires(cs#0, json#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

function JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.Element (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id26202"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.Element (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var k#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var p#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var ##parser#0: DatatypeType;
  var colon#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var st#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var ##other#2: DatatypeType;
  var ##x0#0: DatatypeType;
  var ##other#0_0_0: DatatypeType;
  var valueOrError2#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var v#Z#0: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var ##other#1_0: DatatypeType;
  var ##cs0#1_0_0: DatatypeType;
  var ##spec#1_0_0: HandleType;
  var ##cs0#1_0: DatatypeType;
  var ##spec#1_0: HandleType;
  var ##self#1_1_0_0_0: DatatypeType;
  var ##sp#1_1_0_0_0_0: DatatypeType;
  var ##self#1_1_0_0_1: DatatypeType;
  var ##cs0#1_1_0_1_0: DatatypeType;
  var ##spec#1_1_0_1_0: HandleType;
  var kv#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##k#0: DatatypeType;
  var ##colon#0: DatatypeType;
  var ##v#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ObjectParams.Element", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(917,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume 1 != $FunctionContextHeight;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    goto anon5;

  anon39_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon38_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0);
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon37;

  anon40_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc k#Z#0;
    assume $Is(k#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()));
    assume k#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(k#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(k#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(k#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(k#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(k#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(k#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(k#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(k#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(921,45)"} true;
    assume $IsAllocBox($Box(k#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(k#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(k#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(k#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(k#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(k#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(k#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(k#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(922,50)"} true;
    havoc p#Z#0;
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume 0 != $FunctionContextHeight;
    assume let#2#0#0 == #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError()));
    assume p#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(p#Z#0), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume {:subsumption 0} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0) ==> JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0) || (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#Z#0), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#Z#0), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(p#Z#0), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(p#Z#0)));
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(924,23)"} true;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(k#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(k#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#0 := p#Z#0;
    assume $IsAlloc(##parser#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mGrammar.jcolon(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#Z#0), p#Z#0);
    assume let#3#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#Z#0), p#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(k#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#Z#0), p#Z#0);
    assume $Is(let#3#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon37;

  anon41_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc colon#Z#0;
    assume $Is(colon#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#4#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())));
    assume colon#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(colon#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(k#Z#0);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc st#0;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcolon(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon13;

  anon43_Else:
    assume {:partition} !($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $lambdaHeap#0));
    goto anon13;

  anon13:
    assume false;
    goto anon14;

  anon42_Else:
    goto anon14;

  anon14:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(k#Z#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#1#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $IsBox($l#1#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#2#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $IsBox($l#2#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(k#Z#0) && (forall $l#3#st#0: DatatypeType :: $Is($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), $l#3#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#4#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: $IsBox($l#4#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#4#heap#0: Heap, $l#4#st#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(k#Z#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(colon#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(k#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mCursors.Split.cs(k#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(colon#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(k#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#8#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $IsBox($l#8#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(k#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#9#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $IsBox($l#9#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(colon#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#Z#0, JSON_mUtils_mCursors.Split.cs(k#Z#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#12#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: $IsBox($l#12#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(926,80)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#2 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(colon#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(colon#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(927,49)"} true;
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume $IsAllocBox($Box(JSON_mUtils_mParsers.SubParser__.fn(json#0)), Tclass._System.___hFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    ##x0#0 := JSON_mUtils_mCursors.Split.cs(colon#Z#0);
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(##x0#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    goto anon44_Then, anon44_Else;

  anon44_Then:
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    goto anon45_Then, anon45_Else;

  anon45_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0_0_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(colon#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(colon#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(931,53)"} true;
    assume $IsAllocBox($Box(json#0), Tclass.JSON_mUtils_mParsers.SubParser__(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0_0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0_0))): bool } $Is(cs'#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0_0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0_0)));
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#0_0_1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0_1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#0_0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) } $Is(cs'#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#0_0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0_1))): bool);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#0_0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0_2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0_2))): bool } $Is(cs'#0_0_2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0_2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0_2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0_2))): DatatypeType)): DatatypeType, cs'#0_0_2, JSON_mUtils_mParsers.SubParser__.spec(json#0)));
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(932,30)"} true;
    pop;
    assume $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)))): bool;
    assume false;
    goto anon17;

  anon45_Else:
    goto anon17;

  anon17:
    assume $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)))): bool;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(933,8)"} true;
    assume $IsAllocBox($Box(json#0), Tclass.JSON_mUtils_mParsers.SubParser__(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#0_0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0))): bool } $Is(cs'#0_0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_0)));
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#0_1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) } $Is(cs'#0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_1))): bool);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_2))): bool } $Is(cs'#0_2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#0_2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#0_2))): DatatypeType)): DatatypeType, cs'#0_2, JSON_mUtils_mParsers.SubParser__.spec(json#0)));
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(934,28)"} true;
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume false;
    goto anon18;

  anon44_Else:
    goto anon18;

  anon18:
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(935,6)"} true;
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume let#5#0#0 == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)))): DatatypeType;
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume $Is(let#5#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError2#Z#0 == let#5#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon37;

  anon46_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    havoc v#Z#0;
    assume $Is(v#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()));
    assume v#Z#0 == let#6#0#0;
    assume $IsAllocBox($Box(v#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume true;
    ##cs0#3 := JSON_mUtils_mCursors.Split.cs(colon#Z#0);
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    ##other#1_0 := JSON_mUtils_mCursors.Split.cs(colon#Z#0);
    assume $IsAlloc(##other#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    goto anon48_Then, anon48_Else;

  anon48_Then:
    push;
    assume $IsAllocBox($Box(v#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##cs0#1_0_0 := JSON_mUtils_mCursors.Split.cs(colon#Z#0);
    assume $IsAlloc(##cs0#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0 := JSON_mUtils_mParsers.SubParser__.spec(json#0);
    assume $IsAlloc(##spec#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0));
    goto anon49_Then, anon49_Else;

  anon49_Then:
    push;
    assume $IsAllocBox($Box(json#0), Tclass.JSON_mUtils_mParsers.SubParser__(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#1_0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_0_0_0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_0_0_0))): bool } $Is(cs'#1_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_0_0_0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_0_0_0)));
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#1_0_0_1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_0_0_1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1_0_0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) } $Is(cs'#1_0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1_0_0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_0_0_1))): bool);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#1_0_0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_0_0_2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_0_0_2))): bool } $Is(cs'#1_0_0_2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_0_0_2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_0_0_2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_0_0_2))): DatatypeType)): DatatypeType, cs'#1_0_0_2, JSON_mUtils_mParsers.SubParser__.spec(json#0)));
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(942,32)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(v#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(v#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(colon#Z#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(v#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(colon#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(v#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(colon#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0)))));
    assume false;
    goto anon24;

  anon49_Else:
    goto anon24;

  anon24:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(943,10)"} true;
    pop;
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(v#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(colon#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(v#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(v#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(colon#Z#0)));
    assume false;
    goto anon25;

  anon48_Else:
    goto anon25;

  anon25:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(944,8)"} true;
    assume $IsAllocBox($Box(v#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume true;
    ##cs0#1_0 := JSON_mUtils_mCursors.Split.cs(colon#Z#0);
    assume $IsAlloc(##cs0#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon50_Then, anon50_Else;

  anon50_Then:
    goto anon51_Then, anon51_Else;

  anon51_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume false;
    goto anon34;

  anon51_Else:
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(colon#Z#0));
    assume $IsAllocBox($Box(v#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##cs0#1_1_0_1_0 := JSON_mUtils_mCursors.Split.cs(colon#Z#0);
    assume $IsAlloc(##cs0#1_1_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_1_0_1_0 := JSON_mUtils_mParsers.SubParser__.spec(json#0);
    assume $IsAlloc(##spec#1_1_0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(colon#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0));
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume $IsAllocBox($Box(json#0), Tclass.JSON_mUtils_mParsers.SubParser__(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#1_1_0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_1_0_1_0_0)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_1_0_1_0_0))): bool } $Is(cs'#1_1_0_1_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_1_0_1_0_0))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_1_0_1_0_0)));
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#1_1_0_1_0_1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_1_0_1_0_1))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1_1_0_1_0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) } $Is(cs'#1_1_0_1_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#1_1_0_1_0_1, JSON_mUtils_mParsers.SubParser__.cs(json#0)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_1_0_1_0_1))): bool);
    assume {:subsumption 0} JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) ==> JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0) || (forall cs'#1_1_0_1_0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_1_0_1_0_2))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_1_0_1_0_2))): bool } $Is(cs'#1_1_0_1_0_2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(json#0), $Box(cs'#1_1_0_1_0_2))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_1_0_1_0_2))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs'#1_1_0_1_0_2))): DatatypeType)): DatatypeType, cs'#1_1_0_1_0_2, JSON_mUtils_mParsers.SubParser__.spec(json#0)));
    assume JSON_mUtils_mParsers.SubParser__.Valid_q(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError(), json#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(948,85)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0))));
    assume false;
    goto anon30;

  anon53_Else:
    goto anon30;

  anon30:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mUtils_mParsers.SubParser__.spec(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(948,87)"} true;
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume {:subsumption 0} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0))));
    assume false;
    goto anon34;

  anon52_Else:
    goto anon54_Then, anon54_Else;

  anon54_Then:
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    ##self#1_1_0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType;
    assume $IsAlloc(##self#1_1_0_0_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType);
    goto anon55_Then, anon55_Else;

  anon55_Then:
    ##sp#1_1_0_0_0_0 := json#0;
    assume $IsAlloc(##sp#1_1_0_0_0_0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(json#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(json#0);
    assume {:subsumption 0} JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(json#0) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(json#0) || (forall t#1_1_0_0_0_0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), t#1_1_0_0_0_0) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box(t#1_1_0_0_0_0))): Seq } $Is(t#1_1_0_0_0_0, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box(t#1_1_0_0_0_0))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), t#1_1_0_0_0_0)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(json#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(950,89)"} true;
    assume {:subsumption 0} Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType));
    assume false;
    goto anon33;

  anon55_Else:
    goto anon33;

  anon33:
    assume Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(950,91)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    ##self#1_1_0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType;
    assume $IsAlloc(##self#1_1_0_0_1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(v#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(v#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0));
    assume {:subsumption 0} Seq#Equal(Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(json#0), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0))), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0))));
    assume false;
    goto anon34;

  anon54_Else:
    goto anon34;

  anon34:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), $Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0))));
    assume false;
    goto anon35;

  anon50_Else:
    goto anon35;

  anon35:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(953,8)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(v#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(v#Z#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(colon#Z#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(v#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(colon#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(v#Z#0), JSON_mUtils_mCursors.Split.cs(colon#Z#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(v#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(colon#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(colon#Z#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(v#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(v#Z#0)))));
    assume false;
    goto anon36;

  anon47_Else:
    goto anon36;

  anon36:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#Z#0, JSON_mUtils_mCursors.Split.cs(colon#Z#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(954,6)"} true;
    havoc kv#Z#0;
    assume $Is(kv#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(kv#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    ##cs#2 := cs#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##k#0 := k#Z#0;
    assume $IsAlloc(##k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    ##colon#0 := colon#Z#0;
    assume $IsAlloc(##colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap);
    ##v#0 := v#Z#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##k#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##k#0)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##k#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##k#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##k#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##k#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##k#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), ##k#0, ##cs#2, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##colon#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##colon#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##k#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##colon#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##k#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mUtils_mCursors.Split.cs(##k#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##colon#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##k#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##k#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##colon#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##colon#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), ##colon#0, JSON_mUtils_mCursors.Split.cs(##k#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##v#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##v#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##colon#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##v#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##colon#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##v#0), JSON_mUtils_mCursors.Split.cs(##colon#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##v#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##colon#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##colon#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##v#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##v#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##v#0, JSON_mUtils_mCursors.Split.cs(##colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#Z#0, colon#Z#0, v#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#Z#0, colon#Z#0, v#Z#0));
    assume let#7#0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#Z#0, colon#Z#0, v#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#Z#0, colon#Z#0, v#Z#0);
    assume $Is(let#7#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()));
    assume kv#Z#0 == let#7#0#0;
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0) == #Wrappers.Result.Success($Box(kv#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon37;

  anon37:
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, cs#0, json#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.reveal_KeyValueFromParts (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.reveal__KeyValueFromParts();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.reveal_KeyValueFromParts (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.reveal__KeyValueFromParts();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.reveal_KeyValueFromParts (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.reveal__KeyValueFromParts();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.reveal_Element (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.reveal__Element();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.reveal_Element (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.reveal__Element();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ObjectParams.reveal_Element (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjectParams.__default.reveal__Element();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#236 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#236))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#238 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#238)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#354 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#354))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#356 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#356)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#358 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#358)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#354 := Wrappers.Option.value(this); v#354)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#356 := Lit(Wrappers.Option.value(Lit(this))); v#356)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#358 := Lit(Wrappers.Option.value(Lit(this))); v#358)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#236 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#236)) else (var e#236 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#238 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#238))) else (var e#238 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#354 := Wrappers.Result.value(this); s#354) else (var e#354 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#356 := Lit(Wrappers.Result.value(Lit(this))); s#356) else (var e#356 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#358 := Lit(Wrappers.Result.value(Lit(this))); s#358) else (var e#358 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#354 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#354)) else (var e#354 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#354)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#356 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#356))) else (var e#356 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#356)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#358 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#358))) else (var e#358 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#358)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#150: int, y#150: int :: { Mul(x#150, y#150) } Mul(x#150, y#150) == Mul(y#150, x#150)) && (forall x#151: int, y#151: int, z#100: int :: { Mul(x#151 + y#151, z#100) } Mul(x#151 + y#151, z#100) == Mul(x#151, z#100) + Mul(y#151, z#100)) && (forall x#152: int, y#152: int, z#101: int :: { Mul(x#152 - y#152, z#101) } Mul(x#152 - y#152, z#101) == Mul(x#152, z#101) - Mul(y#152, z#101));

axiom MulInternals.__default.MulAuto() <==> (forall x#153: int, y#153: int :: { Mul(x#153, y#153) } Mul(x#153, y#153) == Mul(y#153, x#153)) && (forall x#154: int, y#154: int, z#102: int :: { Mul(x#154 + y#154, z#102) } Mul(x#154 + y#154, z#102) == Mul(x#154, z#102) + Mul(y#154, z#102)) && (forall x#155: int, y#155: int, z#103: int :: { Mul(x#155 - y#155, z#103) } Mul(x#155 - y#155, z#103) == Mul(x#155, z#103) - Mul(y#155, z#103));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#184: int :: { Mod(Mod(x#184, n#0), n#0) } Mod(Mod(x#184, n#0), n#0) == Mod(x#184, n#0)) && (forall x#185: int :: { Mod(x#185, n#0) } LitInt(0) <= x#185 && x#185 < n#0 <==> Mod(x#185, n#0) == x#185) && (forall x#186: int, y#92: int :: { Mod(x#186 + y#92, n#0) } (var z#90 := Mod(x#186, n#0) + Mod(y#92, n#0); (LitInt(0) <= z#90 && z#90 < n#0 && Mod(x#186 + y#92, n#0) == z#90) || (n#0 <= z#90 && z#90 < n#0 + n#0 && Mod(x#186 + y#92, n#0) == z#90 - n#0))) && (forall x#187: int, y#93: int :: { Mod(x#187 - y#93, n#0) } (var z#91 := Mod(x#187, n#0) - Mod(y#93, n#0); (LitInt(0) <= z#91 && z#91 < n#0 && Mod(x#187 - y#93, n#0) == z#91) || (0 - n#0 <= z#91 && z#91 < 0 && Mod(x#187 - y#93, n#0) == z#91 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#188: int :: { Mod(Mod(x#188, n#0), n#0) } Mod(Mod(x#188, LitInt(n#0)), LitInt(n#0)) == Mod(x#188, LitInt(n#0))) && (forall x#189: int :: { Mod(x#189, n#0) } LitInt(0) <= x#189 && x#189 < n#0 <==> Mod(x#189, LitInt(n#0)) == x#189) && (forall x#190: int, y#94: int :: { Mod(x#190 + y#94, n#0) } (var z#92 := Mod(x#190, LitInt(n#0)) + Mod(y#94, LitInt(n#0)); (LitInt(0) <= z#92 && z#92 < n#0 && Mod(x#190 + y#94, LitInt(n#0)) == z#92) || (LitInt(n#0) <= z#92 && z#92 < n#0 + n#0 && Mod(x#190 + y#94, LitInt(n#0)) == z#92 - n#0))) && (forall x#191: int, y#95: int :: { Mod(x#191 - y#95, n#0) } (var z#93 := Mod(x#191, LitInt(n#0)) - Mod(y#95, LitInt(n#0)); (LitInt(0) <= z#93 && z#93 < n#0 && Mod(x#191 - y#95, LitInt(n#0)) == z#93) || (LitInt(0 - n#0) <= z#93 && z#93 < 0 && Mod(x#191 - y#95, LitInt(n#0)) == z#93 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#132: int :: { Div(x#132, n#0) } LitInt(0) <= x#132 && x#132 < n#0 <==> Div(x#132, n#0) == LitInt(0)) && (forall x#133: int, y#88: int :: { Div(x#133 + y#88, n#0) } (var z#86 := Mod(x#133, n#0) + Mod(y#88, n#0); (LitInt(0) <= z#86 && z#86 < n#0 && Div(x#133 + y#88, n#0) == Div(x#133, n#0) + Div(y#88, n#0)) || (n#0 <= z#86 && z#86 < n#0 + n#0 && Div(x#133 + y#88, n#0) == Div(x#133, n#0) + Div(y#88, n#0) + 1))) && (forall x#134: int, y#89: int :: { Div(x#134 - y#89, n#0) } (var z#87 := Mod(x#134, n#0) - Mod(y#89, n#0); (LitInt(0) <= z#87 && z#87 < n#0 && Div(x#134 - y#89, n#0) == Div(x#134, n#0) - Div(y#89, n#0)) || (0 - n#0 <= z#87 && z#87 < 0 && Div(x#134 - y#89, n#0) == Div(x#134, n#0) - Div(y#89, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#135: int :: { Div(x#135, n#0) } LitInt(0) <= x#135 && x#135 < n#0 <==> Div(x#135, LitInt(n#0)) == LitInt(0)) && (forall x#136: int, y#90: int :: { Div(x#136 + y#90, n#0) } (var z#88 := Mod(x#136, LitInt(n#0)) + Mod(y#90, LitInt(n#0)); (LitInt(0) <= z#88 && z#88 < n#0 && Div(x#136 + y#90, LitInt(n#0)) == Div(x#136, LitInt(n#0)) + Div(y#90, LitInt(n#0))) || (LitInt(n#0) <= z#88 && z#88 < n#0 + n#0 && Div(x#136 + y#90, LitInt(n#0)) == Div(x#136, LitInt(n#0)) + Div(y#90, LitInt(n#0)) + 1))) && (forall x#137: int, y#91: int :: { Div(x#137 - y#91, n#0) } (var z#89 := Mod(x#137, LitInt(n#0)) - Mod(y#91, LitInt(n#0)); (LitInt(0) <= z#89 && z#89 < n#0 && Div(x#137 - y#91, LitInt(n#0)) == Div(x#137, LitInt(n#0)) - Div(y#91, LitInt(n#0))) || (LitInt(0 - n#0) <= z#89 && z#89 < 0 && Div(x#137 - y#91, LitInt(n#0)) == Div(x#137, LitInt(n#0)) - Div(y#91, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#32 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#32) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#32)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#32 := lv#0; (var dt_update#end#0#32 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#32), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#32), dt_update#end#0#32))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#33 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#33) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#33)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#33 := Lit(lv#0); (var dt_update#end#0#33 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#33)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#33)), dt_update#end#0#33)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#34: char :: { Seq#Contains(s#0, $Box(c#34)) } $Is(c#34, TChar) && Seq#Contains(s#0, $Box(c#34)) ==> char#ToInt(c#34) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#34: char :: { Seq#Contains(s#0, $Box(c#34)) } $Is(c#34, TChar) && Seq#Contains(s#0, $Box(c#34)) ==> char#ToInt(c#34) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#68#i#0): int)): char))), (lambda $l#68#heap#0: Heap, $l#68#i#0: Box :: $IsBox($l#68#i#0, TInt) && LitInt(0) <= $Unbox($l#68#i#0): int && $Unbox($l#68#i#0): int < Seq#Length(s#0)), (lambda $l#68#heap#0: Heap, $l#68#i#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#35: char :: { Seq#Contains(s#0, $Box(c#35)) } $Is(c#35, TChar) && Seq#Contains(s#0, $Box(c#35)) ==> char#ToInt(c#35) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#70#i#0): int)): char))), (lambda $l#70#heap#0: Heap, $l#70#i#0: Box :: $IsBox($l#70#i#0, TInt) && LitInt(0) <= $Unbox($l#70#i#0): int && $Unbox($l#70#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#70#heap#0: Heap, $l#70#i#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#8 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#8))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#8 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#10 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#10))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#10 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#96 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#48 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#96 := (if b#96 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#96)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#48)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#96)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#97 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#48 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#97 := (if b#97 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#97)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#48 := Seq#Create(TChar, $Heap, Seq#Length(bs0#48), Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#48, $Unbox($l#76#idx#0): int)): int))), (lambda $l#76#heap#0: Heap, $l#76#idx#0: Box :: $IsBox($l#76#idx#0, TInt) && LitInt(0) <= $Unbox($l#76#idx#0): int && $Unbox($l#76#idx#0): int < Seq#Length(bs0#48)), (lambda $l#76#heap#0: Heap, $l#76#idx#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#48), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#97))))) else (var err#48 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#48)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#100 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#50 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#100 := (if b#100 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#100)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#50)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#100)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#101 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#50 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#101 := (if b#101 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#101)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#50 := Seq#Create(TChar, $Heap, Seq#Length(bs0#50), Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#50, $Unbox($l#79#idx#0): int)): int))), (lambda $l#79#heap#0: Heap, $l#79#idx#0: Box :: $IsBox($l#79#idx#0, TInt) && LitInt(0) <= $Unbox($l#79#idx#0): int && $Unbox($l#79#idx#0): int < Seq#Length(bs0#50)), (lambda $l#79#heap#0: Heap, $l#79#idx#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#50), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#101))))) else (var err#50 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#50)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#104 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#52 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#104 := (if b#104 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#104)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#52)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#104)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#105 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#52 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#105 := (if b#105 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#105)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#52 := Seq#Create(TChar, $Heap, Seq#Length(bs0#52), Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#52, $Unbox($l#82#idx#0): int)): int))), (lambda $l#82#heap#0: Heap, $l#82#idx#0: Box :: $IsBox($l#82#idx#0, TInt) && LitInt(0) <= $Unbox($l#82#idx#0): int && $Unbox($l#82#idx#0): int < Seq#Length(bs0#52)), (lambda $l#82#heap#0: Heap, $l#82#idx#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#52), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#105))))) else (var err#52 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#52)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#10: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#10)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#10)): int } LitInt(0) <= idx#10 && idx#10 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#10 && idx#10 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#10)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#10)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#16 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#16 := this; (var dt_update#beg#0#16 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#16), dt_update#beg#0#16, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#16), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#16)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#17 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#17 := Lit(this); (var dt_update#beg#0#17 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#17)), dt_update#beg#0#17, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#17)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#17)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#60#v#0): DatatypeType))), (lambda $l#60#heap#0: Heap, $l#60#v#0: Box :: $IsBox($l#60#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#60#heap#0: Heap, $l#60#v#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#61#v#0): DatatypeType))), (lambda $l#61#heap#0: Heap, $l#61#v#0: Box :: $IsBox($l#61#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#61#heap#0: Heap, $l#61#v#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#62#v#0): DatatypeType))), (lambda $l#62#heap#0: Heap, $l#62#v#0: Box :: $IsBox($l#62#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#62#heap#0: Heap, $l#62#v#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#16 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#16 := this; (var dt_update#point#0#16 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#16), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#16), dt_update#point#0#16, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#16)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#17 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#17 := Lit(this); (var dt_update#point#0#17 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#17)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#17)), dt_update#point#0#17, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#17)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#16 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#16)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#16 := this; (var dt_update#point#0#16 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#16), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#16), dt_update#point#0#16, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#16)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#17 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#17)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#17 := Lit(this); (var dt_update#point#0#17 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#17)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#17)), dt_update#point#0#17, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#17)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#16 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#16 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#16 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#16 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#16))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#17 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#17 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#17 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#17 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#17)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#27: int :: { Seq#Contains(bs#0, $Box(b#27)) } LitInt(0) <= b#27 && b#27 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#27)) ==> b#27 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#27: int :: { Seq#Contains(bs#0, $Box(b#27)) } LitInt(0) <= b#27 && b#27 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#27)) ==> b#27 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#24 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#24)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24) && (var ps#24 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#24, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#24 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#24) else (var ps#24 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#24)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#24, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#28: int :: { Seq#Contains(bs#0, $Box(b#28)) } LitInt(0) <= b#28 && b#28 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#28)) ==> b#28 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#25 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#25)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25) && (var ps#25 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#25, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#25 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#25) else (var ps#25 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#25)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#25, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#29: int :: { Seq#Contains(bs#0, $Box(b#29)) } LitInt(0) <= b#29 && b#29 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#29)) ==> b#29 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#26 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#26)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26) && (var ps#26 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#26, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#26 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#26) else (var ps#26 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#26)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#26, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#10: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#10)): int } LitInt(0) <= idx#10 && idx#10 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#10 && idx#10 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#10)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#50 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#50)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#49 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#49)))) else (var st#49 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#49))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#52 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#52)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#51 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#51)))) else (var st#51 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#51))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#54 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#54)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#53 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#53)))) else (var st#53 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#53))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#64#heap#0: Heap, $l#64#_v0#0: Box :: $IsBox($l#64#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#64#heap#0: Heap, $l#64#_v0#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#65#heap#0: Heap, $l#65#_v1#0: Box :: $IsBox($l#65#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#65#heap#0: Heap, $l#65#_v1#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#68#heap#0: Heap, $l#68#_v0#0: Box :: $IsBox($l#68#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#68#heap#0: Heap, $l#68#_v0#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#69#heap#0: Heap, $l#69#_v1#0: Box :: $IsBox($l#69#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#69#heap#0: Heap, $l#69#_v1#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#96#ly#0: LayerType :: Handle1((lambda $l#96#heap#0: Heap, $l#96#cs#0: Box :: $Box(Lit(false))), (lambda $l#96#heap#0: Heap, $l#96#cs#0: Box :: $IsBox($l#96#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#96#heap#0: Heap, $l#96#cs#0: Box :: SetRef_to_SetBox((lambda $l#96#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#97#ly#0: LayerType :: Handle1((lambda $l#97#heap#0: Heap, $l#97#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#97#heap#0: Heap, $l#97#cs#0: Box :: $IsBox($l#97#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#97#heap#0: Heap, $l#97#cs#0: Box :: SetRef_to_SetBox((lambda $l#97#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#98#ly#0: LayerType :: Handle1((lambda $l#98#heap#0: Heap, $l#98#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#98#heap#0: Heap, $l#98#_v2#0: Box :: $IsBox($l#98#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#98#heap#0: Heap, $l#98#_v2#0: Box :: SetRef_to_SetBox((lambda $l#98#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#102#ly#0: LayerType :: Handle1((lambda $l#102#heap#0: Heap, $l#102#cs#0: Box :: $Box(Lit(false))), (lambda $l#102#heap#0: Heap, $l#102#cs#0: Box :: $IsBox($l#102#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#102#heap#0: Heap, $l#102#cs#0: Box :: SetRef_to_SetBox((lambda $l#102#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#103#ly#0: LayerType :: Handle1((lambda $l#103#heap#0: Heap, $l#103#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#103#heap#0: Heap, $l#103#cs#0: Box :: $IsBox($l#103#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#103#heap#0: Heap, $l#103#cs#0: Box :: SetRef_to_SetBox((lambda $l#103#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#104#ly#0: LayerType :: Handle1((lambda $l#104#heap#0: Heap, $l#104#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#104#heap#0: Heap, $l#104#_v2#0: Box :: $IsBox($l#104#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#104#heap#0: Heap, $l#104#_v2#0: Box :: SetRef_to_SetBox((lambda $l#104#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#16: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#16))): DatatypeType } $Is(cs'#16, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#16))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#16))): DatatypeType)): DatatypeType, cs'#16, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#16: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#16))): DatatypeType } $Is(cs'#16, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#16))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#16))): DatatypeType)): DatatypeType, cs'#16, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#17: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#17))): DatatypeType } $Is(cs'#17, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType)): DatatypeType, cs'#17, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#17: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#17))): DatatypeType } $Is(cs'#17, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#17))): DatatypeType)): DatatypeType, cs'#17, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#48: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#48)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#48))): bool } $Is(cs'#48, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#48))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#48)))) && ((forall cs'#48: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#48)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#48))): bool } $Is(cs'#48, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#48))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#48))) ==> (forall cs'#49: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#49))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#49, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#49: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#49))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#49, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#49))): bool) ==> (forall cs'#50: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#50))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#50))): bool } $Is(cs'#50, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#50))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#50))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#50))): DatatypeType)): DatatypeType, cs'#50, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#48: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#48)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#48))): bool } $Is(cs'#48, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#48))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#48))) && (forall cs'#49: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#49))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#49, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#49, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#49))): bool) && (forall cs'#50: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#50))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#50))): bool } $Is(cs'#50, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#50))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#50))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#50))): DatatypeType)): DatatypeType, cs'#50, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#51: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#51)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#51))): bool } $Is(cs'#51, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#51))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#51)))) && ((forall cs'#51: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#51)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#51))): bool } $Is(cs'#51, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#51))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#51))) ==> (forall cs'#52: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#52))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#52, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#52, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#52, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#52, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#52: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#52))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#52, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#52, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#52, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#52))): bool) ==> (forall cs'#53: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#53))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#53))): bool } $Is(cs'#53, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#53))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#53))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#53))): DatatypeType)): DatatypeType, cs'#53, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#51: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#51)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#51))): bool } $Is(cs'#51, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#51))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#51))) && (forall cs'#52: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#52))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#52, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#52, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#52, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#52))): bool) && (forall cs'#53: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#53))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#53))): bool } $Is(cs'#53, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#53))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#53))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#53))): DatatypeType)): DatatypeType, cs'#53, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#15: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#15)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#15)) ==> LitInt(0) <= d#15 && d#15 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#39 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#40 := Seq#Append(digits'#39, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#40))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#40 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#41 := Seq#Append(digits'#40, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#41))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#41 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#42 := Seq#Append(digits'#41, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#42))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#15: Box :: { Seq#Contains(chars#0, c#15) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#15) } $IsBox(c#15, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#15) ==> Seq#Contains(chars#0, c#15)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#31: int :: { Seq#Contains(digits#0, $Box(d#31)) } Seq#Contains(digits#0, $Box(d#31)) ==> LitInt(0) <= d#31 && d#31 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#31: int :: { Seq#Contains(digits#0, $Box(d#31)) } Seq#Contains(digits#0, $Box(d#31)) ==> LitInt(0) <= d#31 && d#31 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#32: int :: { Seq#Contains(digits#0, $Box(d#32)) } Seq#Contains(digits#0, $Box(d#32)) ==> LitInt(0) <= d#32 && d#32 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#15: Box :: { Seq#Contains(chars#0, c#15) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#15) } $IsBox(c#15, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#15) ==> Seq#Contains(chars#0, c#15)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#26 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#26) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#26), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#26 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#26), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#27 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#27) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#27), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#27 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#27), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#41: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#41)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#41) } $IsBox(c#41, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#41) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#41)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#42: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#42)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#42) } $IsBox(c#42, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#42) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#42)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#43: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#43)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#43) } $IsBox(c#43, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#43) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#43)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(Seq#Contains(chars#0, $l#19#c#0))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#29: Box :: { Map#Domain(digits#0)[c#29] } { Seq#Contains(str#0, c#29) } $IsBox(c#29, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#29) ==> Map#Domain(digits#0)[c#29])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#29: Box :: { Map#Domain(digits#0)[c#29] } { Seq#Contains(str#0, c#29) } $IsBox(c#29, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#29) ==> Map#Domain(digits#0)[c#29])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#30: Box :: { Map#Domain(digits#0)[c#30] } { Seq#Contains(str#0, c#30) } $IsBox(c#30, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#30) ==> Map#Domain(digits#0)[c#30])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(Map#Domain(digits#0)[$l#57#c#0])), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(Map#Domain(digits#0)[$l#57#c#0])), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(Map#Domain(digits#0)[$l#58#c#0])), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(Map#Domain(digits#0)[$l#59#c#0])), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#39 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#39) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#39) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#39)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#39) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#39)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#39 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#39) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#39) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#39)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#39) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#39))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#39 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#39) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#39) else (var tl#78 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#39)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#78)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#39 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#39) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#39) else (var tl#79 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#39)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#79)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#40 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#40) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#40) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#40)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#40) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#40)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#40 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#40) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#40) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#40)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#40) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#40))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#40 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#40) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#40) else (var tl#80 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#40)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#80)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#40 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#40) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#40) else (var tl#81 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#40)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#81)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#41 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#41) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#41) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#41)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#41) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#41)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#41 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#41) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#41) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#41)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#41) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#41))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#41 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#41) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#41) else (var tl#82 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#41)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#82)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#41 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#41) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#41) else (var tl#83 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#41)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#83)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#15: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#15)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#15)) ==> LitInt(0) <= d#15 && d#15 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#39 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#40 := Seq#Append(digits'#39, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#40))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#40 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#41 := Seq#Append(digits'#40, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#41))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#41 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#42 := Seq#Append(digits'#41, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#42))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#15: char :: { Seq#Contains(chars#0, $Box(c#15)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#15)) ==> Seq#Contains(chars#0, $Box(c#15))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#31: int :: { Seq#Contains(digits#0, $Box(d#31)) } Seq#Contains(digits#0, $Box(d#31)) ==> LitInt(0) <= d#31 && d#31 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#31: int :: { Seq#Contains(digits#0, $Box(d#31)) } Seq#Contains(digits#0, $Box(d#31)) ==> LitInt(0) <= d#31 && d#31 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#32: int :: { Seq#Contains(digits#0, $Box(d#32)) } Seq#Contains(digits#0, $Box(d#32)) ==> LitInt(0) <= d#32 && d#32 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#15: char :: { Seq#Contains(chars#0, $Box(c#15)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#15)) ==> Seq#Contains(chars#0, $Box(c#15))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#26 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#26) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#26), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#26 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#26), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#27 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#27) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#27), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#27 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#27), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#41: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#41))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#41)) } $Is(c#41, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#41)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#41))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#42: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#42))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#42)) } $Is(c#42, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#42)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#42))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#43: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#43))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#43)) } $Is(c#43, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#43)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#43))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(Seq#Contains(chars#0, $l#19#c#0))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, TChar)), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#29: char :: { Map#Domain(digits#0)[$Box(c#29)] } { Seq#Contains(str#0, $Box(c#29)) } $Is(c#29, TChar) && Seq#Contains(str#0, $Box(c#29)) ==> Map#Domain(digits#0)[$Box(c#29)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#29: char :: { Map#Domain(digits#0)[$Box(c#29)] } { Seq#Contains(str#0, $Box(c#29)) } $Is(c#29, TChar) && Seq#Contains(str#0, $Box(c#29)) ==> Map#Domain(digits#0)[$Box(c#29)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#30: char :: { Map#Domain(digits#0)[$Box(c#30)] } { Seq#Contains(str#0, $Box(c#30)) } $Is(c#30, TChar) && Seq#Contains(str#0, $Box(c#30)) ==> Map#Domain(digits#0)[$Box(c#30)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(Map#Domain(digits#0)[$l#57#c#0])), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, TChar)), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(Map#Domain(digits#0)[$l#57#c#0])), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, TChar)), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(Map#Domain(digits#0)[$l#58#c#0])), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, TChar)), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(Map#Domain(digits#0)[$l#59#c#0])), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, TChar)), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#39 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#39) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#39) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#39)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#39) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#39)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#39 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#39) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#39) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#39)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#39) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#39))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#39 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#39) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#39) else (var tl#78 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#39)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#78)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#39 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#39) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#39) else (var tl#79 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#39)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#79)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#40 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#40) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#40) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#40)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#40) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#40)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#40 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#40) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#40) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#40)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#40) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#40))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#40 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#40) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#40) else (var tl#80 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#40)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#80)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#40 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#40) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#40) else (var tl#81 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#40)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#81)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#41 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#41) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#41) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#41)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#41) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#41)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#41 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#41) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#41) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#41)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#41) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#41))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#41 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#41) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#41) else (var tl#82 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#41)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#82)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#41 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#41) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#41) else (var tl#83 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#41)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#83)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#14: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#14)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#14)) } $Is(c#14, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#14)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#14))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#17#c#0))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, TChar)), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#27: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)] } { Seq#Contains(str#0, $Box(c#27)) } $Is(c#27, TChar) && Seq#Contains(str#0, $Box(c#27)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#27: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)] } { Seq#Contains(str#0, $Box(c#27)) } $Is(c#27, TChar) && Seq#Contains(str#0, $Box(c#27)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#27)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#28: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#28)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#28)] } { Seq#Contains(str#0, $Box(c#28)) } $Is(c#28, TChar) && Seq#Contains(str#0, $Box(c#28)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#28)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#28)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#44#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#44#c#0]): int < base#0)), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, TChar)), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#44#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#44#c#0]): int < base#0)), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, TChar)), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#45#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#45#c#0]): int < base#0)), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, TChar)), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#44 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#44)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#88 := JSON_mErrors.DeserializationError.b(this); (var b0#44 := JSON_mErrors.DeserializationError.expected(this); (var c#88 := (if b#88 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#88)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#44)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#88)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#89 := JSON_mErrors.DeserializationError.b(this); (var bs0#44 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#89 := (if b#89 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#89)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#44 := Seq#Create(TChar, $Heap, Seq#Length(bs0#44), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#44, $Unbox($l#70#idx#0): int)): int))), (lambda $l#70#heap#0: Heap, $l#70#idx#0: Box :: $IsBox($l#70#idx#0, TInt) && LitInt(0) <= $Unbox($l#70#idx#0): int && $Unbox($l#70#idx#0): int < Seq#Length(bs0#44)), (lambda $l#70#heap#0: Heap, $l#70#idx#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#44), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#89))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#46 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#46)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#92 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#46 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#92 := (if b#92 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#92)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#46)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#92)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#93 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#46 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#93 := (if b#93 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#93)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#46 := Seq#Create(TChar, $Heap, Seq#Length(bs0#46), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#46, $Unbox($l#73#idx#0): int)): int))), (lambda $l#73#heap#0: Heap, $l#73#idx#0: Box :: $IsBox($l#73#idx#0, TInt) && LitInt(0) <= $Unbox($l#73#idx#0): int && $Unbox($l#73#idx#0): int < Seq#Length(bs0#46)), (lambda $l#73#heap#0: Heap, $l#73#idx#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#46), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#93))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#45 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#45, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#44 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#44, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#44 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#44)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#47 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#47, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#46 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#46, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#46 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#46)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#26: int :: { JSON_mGrammar.__default.Blank_q(b#26) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) } LitInt(0) <= b#26 && b#26 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#26))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#26: int :: { JSON_mGrammar.__default.Blank_q(b#26) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) } LitInt(0) <= b#26 && b#26 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) ==> JSON_mGrammar.__default.Blank_q(b#26))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#27: int :: { JSON_mGrammar.__default.Blank_q(b#27) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#27)) } LitInt(0) <= b#27 && b#27 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#27)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#27))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#27: int :: { JSON_mGrammar.__default.Blank_q(b#27) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#27)) } LitInt(0) <= b#27 && b#27 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#27)) ==> JSON_mGrammar.__default.Blank_q(b#27))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#26: int :: { $Unbox(Seq#Index(s#0, idx#26)): DatatypeType } LitInt(0) <= idx#26 && idx#26 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#26)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#26: int :: { $Unbox(Seq#Index(s#0, idx#26)): DatatypeType } LitInt(0) <= idx#26 && idx#26 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#26)): DatatypeType)) <==> idx#26 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#27: int :: { $Unbox(Seq#Index(s#0, idx#27)): DatatypeType } LitInt(0) <= idx#27 && idx#27 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#27)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#27: int :: { $Unbox(Seq#Index(s#0, idx#27)): DatatypeType } LitInt(0) <= idx#27 && idx#27 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#27)): DatatypeType)) <==> idx#27 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#26: int :: { JSON_mGrammar.__default.Digit_q(b#26) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) } LitInt(0) <= b#26 && b#26 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#26))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#26: int :: { JSON_mGrammar.__default.Digit_q(b#26) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) } LitInt(0) <= b#26 && b#26 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#26)) ==> JSON_mGrammar.__default.Digit_q(b#26))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#27: int :: { JSON_mGrammar.__default.Digit_q(b#27) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#27)) } LitInt(0) <= b#27 && b#27 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#27)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#27))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#27: int :: { JSON_mGrammar.__default.Digit_q(b#27) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#27)) } LitInt(0) <= b#27 && b#27 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#27)) ==> JSON_mGrammar.__default.Digit_q(b#27))));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$9x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$9x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$9x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$9x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$9x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$9x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$9x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$9x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$9x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$9x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$9x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$9x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#30: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#30) } { Seq#Contains(ts#0, d#30) } $IsBox(d#30, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#30) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#30))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#30: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#30) } { Seq#Contains(ts#0, d#30) } $IsBox(d#30, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#30) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#30))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#31: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#31) } { Seq#Contains(ts#0, d#31) } $IsBox(d#31, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#31) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#31))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#32: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#32) } { Seq#Contains(ts#0, d#32) } $IsBox(d#32, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#32) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#32))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#30: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#30)) } $Is(d#30, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#30) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#30)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#30: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#30)) } $Is(d#30, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#30) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#30)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#31: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#31)) } $Is(d#31, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#31) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#31)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#32: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#32)) } $Is(d#32, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#32) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#32)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$9x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$9x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$9x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$9x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$9x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$9x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$9x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$9x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$9x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$9x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$9x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$9x#0))): Seq);

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$9x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$9x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$9x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$9x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$9x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$9x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$9x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$9x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$9x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$9x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$9x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$9x#0))): Seq);

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$9x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$9x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$9x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$9x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$9x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$9x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$9x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$9x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$9x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$9x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$9x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$9x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#62#d#0: DatatypeType :: $Is($l#62#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#62#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#62#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#63#ly#0, $Unbox($l#63#d#0): DatatypeType))), (lambda $l#63#heap#0: Heap, $l#63#d#0: Box :: $IsBox($l#63#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#63#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#63#heap#0: Heap, $l#63#d#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#61#ly#0, $Unbox($l#61#d#0): DatatypeType))), (lambda $l#61#heap#0: Heap, $l#61#d#0: Box :: $IsBox($l#61#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#61#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#61#heap#0: Heap, $l#61#d#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#65#d#0: DatatypeType :: $Is($l#65#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#65#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#65#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#66#ly#0, $Unbox($l#66#d#0): DatatypeType))), (lambda $l#66#heap#0: Heap, $l#66#d#0: Box :: $IsBox($l#66#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#66#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#66#heap#0: Heap, $l#66#d#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#64#ly#0, $Unbox($l#64#d#0): DatatypeType))), (lambda $l#64#heap#0: Heap, $l#64#d#0: Box :: $IsBox($l#64#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#64#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#64#heap#0: Heap, $l#64#d#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#62#d#0: DatatypeType :: $Is($l#62#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#62#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#62#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#63#ly#0, $Unbox($l#63#d#0): DatatypeType))), (lambda $l#63#heap#0: Heap, $l#63#d#0: Box :: $IsBox($l#63#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#63#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#63#heap#0: Heap, $l#63#d#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#61#ly#0, $Unbox($l#61#d#0): DatatypeType))), (lambda $l#61#heap#0: Heap, $l#61#d#0: Box :: $IsBox($l#61#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#61#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#61#heap#0: Heap, $l#61#d#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#65#d#0: DatatypeType :: $Is($l#65#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#65#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#65#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#66#ly#0, $Unbox($l#66#d#0): DatatypeType))), (lambda $l#66#heap#0: Heap, $l#66#d#0: Box :: $IsBox($l#66#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#66#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#66#heap#0: Heap, $l#66#d#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#64#ly#0, $Unbox($l#64#d#0): DatatypeType))), (lambda $l#64#heap#0: Heap, $l#64#d#0: Box :: $IsBox($l#64#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#64#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#64#heap#0: Heap, $l#64#d#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#37 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#37))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#37 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#37))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#37 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#37))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#37 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#37))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#37 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#37))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#37 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#37))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#36 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#36)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#36 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#36)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#36 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#36)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#36 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#36)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#36 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#36)) else (var arr#36 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#36))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#39 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#39))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#39 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#39))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#39 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#39))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#39 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#39))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#39 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#39))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#39 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#39))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#38 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#38))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#38 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#38))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#38 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#38))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#38 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#38))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#38 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#38))) else (var arr#38 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#38)))))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var cs#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#13)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#12) else (var cs#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#13)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#13 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var cs#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#14)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#13 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#13) else (var cs#14 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#14)))))))));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$6x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$6x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$6x#0): int)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$6x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$6x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$6x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$6x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$6x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$6x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#12#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: $IsBox($l#12#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#51: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#51)) } $Is(cs#51, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#51)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#51: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#51)) } $Is(cs#51, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#51)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#52 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#12 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#52))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var cs#53 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#53))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#12, cs#52 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#12 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#52))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#12) else (var val#12, cs#53 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType); (var after#12, cs#54 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#53))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#53)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#12, val#12, after#12)), cs#54)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#55: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#55)) } $Is(cs#55, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#55)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#56 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#13 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#56))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var cs#57 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#57))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#13, cs#56 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#13 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#56))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#13) else (var val#13, cs#57 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType); (var after#13, cs#58 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#57))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#57)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#13, val#13, after#13)), cs#58)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#11#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $IsBox($l#11#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#37 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#37) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#37)) && (var cs#38 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#37))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#38))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#12, cs#37 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#12, cs#38 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#37)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#37))); (var after#12, cs#39 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#38))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#38)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#12, $Box(val#12), after#12)), cs#39)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#40 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#40) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#40)) && (var cs#41 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#40))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#41))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#13, cs#40 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#13, cs#41 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#40)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#40))); (var after#13, cs#42 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#41))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#41)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#13, $Box(val#13), after#13)), cs#42)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#14: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#14) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#14))): Seq } $Is(t#14, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#14)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#14: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#14) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#14))): Seq } $Is(t#14, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#14))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#14)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#15: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#15) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#15))): Seq } $Is(t#15, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#15)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#15: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#15) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#15))): Seq } $Is(t#15, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#15))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#15)))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0))): DatatypeType, cs#0)) && $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$1x#0: Box, $fh$1x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$1x#0, $fh$1x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$1x#0, $fh$1x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$1x#0): bool, $Unbox($fh$1x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$1x#0: Box, $fh$1x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$1x#0, $fh$1x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$1x#0, $fh$1x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$1x#0): bool, $Unbox($fh$1x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$1x#0: Box, $fh$1x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$1x#0, $fh$1x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$1x#0, $fh$1x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$1x#0: bool, $fh$1x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$1x#0, $fh$1x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$1x#0, $fh$1x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$1x#0), $Box($fh$1x#1))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, cs#0) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())));

axiom (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(TBool, Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())) && JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(true, Lit(cs#0)) == JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(TBool, Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(Tclass.JSON_mErrors.DeserializationError()), $Box(JSON_mUtils_mLexers_mStrings.__default.StringBodyLexerStart())));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jquote(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mStrings.__default.String($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#7 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#7) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (var contents#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#4) && (var cs#8 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#4)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#8) && (var valueOrError2#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#8); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#2) else (var lq#2, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#7); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#2) else (var contents#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; (var contents#5, cs#8 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#4))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#4)); (var valueOrError2#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#8); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#2) else (var rq#2, cs#9 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#2, contents#5, rq#2)), cs#9))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#3 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#10 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#10) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#10); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (var contents#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#6) && (var cs#11 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#6)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#11) && (var valueOrError2#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#11); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#3 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#3) else (var lq#3, cs#10 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType)); (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#10); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#3) else (var contents#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; (var contents#7, cs#11 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#6))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#6)); (var valueOrError2#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#11); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#3) else (var rq#3, cs#12 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#3, contents#7, rq#3)), cs#12))))))))))))));

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements: bool;

const reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mObjects.__default: ClassName;

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle() : HandleType;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(e#0) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(e#0) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(e#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0) == Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(e#0))));
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(Lit(e#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(Lit(e#0)) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(Lit(e#0)) == Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0))))));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(e#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box($fh$0x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##obj#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(963,39): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(964,55): post-state"} true;
    assume 1 != $FunctionContextHeight;
    ##self#0 := obj#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    ##obj#0 := obj#0;
    assume $IsAlloc(##obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
  free ensures {:id "id26365"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType where $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $IsA#JSON_mGrammar.Bracketed(obj#0)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
  free ensures {:id "id26366"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var rMember#0: HandleType where $Is(rMember#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(rMember#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#0: Heap;
  var d#1: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;
  var ##fDatum#1: HandleType;
  var ##self#3: DatatypeType;
  var ##fDatum#2: HandleType;
  var ##self#0_0: DatatypeType;
  var ##fDatum#0_0: HandleType;
  var ##self#0_1: DatatypeType;
  var ##fDatum#0_1: HandleType;
  var ##bracketed#0_0_0: DatatypeType;
  var ##pd0#0_0_0: HandleType;
  var ##pd1#0_0_0: HandleType;
  var bracketed##0_0_0: DatatypeType;
  var pd0##0_0_0: HandleType;
  var pd1##0_0_0: HandleType;
  var ##self#1_0_0: DatatypeType;
  var ##fDatum#1_0_0: HandleType;
  var ##obj#1_0_0: DatatypeType;
  var ##self#1_1_0: DatatypeType;
  var ##fDatum#1_1_0: HandleType;
  var ##self#1_1_1: DatatypeType;
  var ##fDatum#1_1_1: HandleType;
  var ##self#1_0: DatatypeType;
  var ##fDatum#1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(965,4): initial state"} true;
    assume $IsA#JSON_mGrammar.Bracketed(obj#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#obj0#0: DatatypeType :: $Is($ih#obj0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && Lit(true) && DtRank($ih#obj0#0) < DtRank(obj#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $ih#obj0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), $ih#obj0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon14_Then, anon14_Else;

  anon14_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#1;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume {:partition} DtRank(d#1) < DtRank(obj#0);
    ##self#1 := d#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(d#1);
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), d#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Member#canCall(d#1);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon16_Else:
    assume {:partition} DtRank(obj#0) <= DtRank(d#1);
    goto anon4;

  anon15_Else:
    assume {:partition} !($Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon14_Else:
    goto anon5;

  anon5:
    assume (forall $l#0#d#0: DatatypeType :: $Is($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#0#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#0#d#0));
    rMember#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#1#ly#0, $Unbox($l#1#d#0): DatatypeType))), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $IsBox($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#1#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(966,68)"} true;
    assume 1 != $FunctionContextHeight;
    ##self#2 := obj#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#2) < DtRank(##self#2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    ##self#3 := obj#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#2 := rMember#0;
    assume $IsAlloc(##fDatum#2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#3) < DtRank(##self#3) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    goto anon17_Then, anon17_Else;

  anon17_Then:
    push;
    assume 1 != $FunctionContextHeight;
    ##self#0_0 := obj#0;
    assume $IsAlloc(##self#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0, $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0) < DtRank(##self#0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0, $Box(d#0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    ##self#0_1 := obj#0;
    assume $IsAlloc(##self#0_1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_1 := rMember#0;
    assume $IsAlloc(##fDatum#0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_1, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_1) < DtRank(##self#0_1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_1, $Box(d#0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    push;
    assume 1 != $FunctionContextHeight;
    ##bracketed#0_0_0 := obj#0;
    assume $IsAlloc(##bracketed#0_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##pd0#0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##pd0#0_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##pd1#0_0_0 := rMember#0;
    assume $IsAlloc(##pd1#0_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0);
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0) || (forall d#0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box(d#0_0_0)) } $Is(d#0_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0_0) < DtRank(obj#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box(d#0_0_0)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0) || (forall d#0_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_0_1)) } $Is(d#0_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0_1) < DtRank(obj#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_0_1)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0) || (forall d#0_0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_0_2))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box(d#0_0_2))): Seq } $Is(d#0_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0_2) < DtRank(obj#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box(d#0_0_2))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rMember#0, $Box(d#0_0_2))): Seq));
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), rMember#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(969,94)"} true;
    assume true;
    bracketed##0_0_0 := obj#0;
    assume 1 != $FunctionContextHeight;
    assume true;
    pd0##0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume true;
    pd1##0_0_0 := rMember#0;
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0_0, pd0##0_0_0, pd1##0_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0_0, pd0##0_0_0, pd1##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(970,78)"} true;
    pop;
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume false;
    goto anon8;

  anon18_Else:
    goto anon8;

  anon8:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(971,8)"} true;
    pop;
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume false;
    goto anon9;

  anon17_Else:
    goto anon9;

  anon9:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(972,6)"} true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume 1 != $FunctionContextHeight;
    ##self#1_0 := obj#0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)) } $Is(d#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0) < DtRank(##self#1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume false;
    goto anon13;

  anon19_Else:
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume 1 != $FunctionContextHeight;
    ##self#1_1_0 := obj#0;
    assume $IsAlloc(##self#1_1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#1_1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)) } $Is(d#1_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_0) < DtRank(##self#1_1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    ##self#1_1_1 := obj#0;
    assume $IsAlloc(##self#1_1_1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_1 := rMember#0;
    assume $IsAlloc(##fDatum#1_1_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)) } $Is(d#1_1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_1) < DtRank(##self#1_1_1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0));
    assume false;
    goto anon13;

  anon20_Else:
    goto anon21_Then, anon21_Else;

  anon21_Then:
    ##self#1_0_0 := obj#0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0_0 := rMember#0;
    assume $IsAlloc(##fDatum#1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)) } $Is(d#1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0_0) < DtRank(##self#1_0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0);
    ##obj#1_0_0 := obj#0;
    assume $IsAlloc(##obj#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, rMember#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LS($LZ)), obj#0));
    assume false;
    goto anon13;

  anon21_Else:
    goto anon13;

  anon13:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0));
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 6 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || (6 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 6 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || (6 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#0) else (var sp#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(sp#0))))));
axiom 6 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), Lit(json#0)) || (6 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#1) else (var sp#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(sp#1))))));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

axiom (forall $ly: LayerType :: { JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($ly)) } JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($ly)) == JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly));

function JSON_mConcreteSyntax_mSpec.__default.Object#Handle($fuel: LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Object($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$0x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#requires(DatatypeType, DatatypeType) : bool;

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#requires(cs#0, json#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

function Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) == Tagclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) == tytagFamily$jopen;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()));

function Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) == Tagclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) == tytagFamily$jclose;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Object (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id26396"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)));
  free ensures {:id "id26397"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
  free ensures {:id "id26398"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
  free ensures {:id "id26399"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
  free ensures {:id "id26400"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)))));



function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle() : HandleType;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(Lit(ts#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(ts#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($fh$0x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Object (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##json#0: DatatypeType;
  var sp#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var obj##0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Object", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(980,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)));
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__#Equal(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0);
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume sp#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(986,53)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume $Is($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()));
    obj##0 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    call CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj##0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(987,28)"} true;
    assume $Is(#Wrappers.Result.Success($Box(sp#Z#0)), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, json#0) == #Wrappers.Result.Success($Box(sp#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, json#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(): int == char#ToInt(Lit(char#FromInt(44)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.SEPARATOR (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(): HandleType == JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.SpecViewClose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(): HandleType == JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.SpecViewOpen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires(DatatypeType) : bool;

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires(e#0) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires(e#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.SuffixedElementSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0: DatatypeType where $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires(ts#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires(ts#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0: DatatypeType where $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.BracketedSpec", " | ", ts#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](138,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 1 != $FunctionContextHeight;
    ##self#0 := ts#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(Lit(ts#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(ts#0: Seq) : bool;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires(Seq) : bool;

axiom (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires(ts#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires(ts#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.SuffixedElementsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0: Seq where $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.SuffixedElementsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.SuffixedElementsSpec", " | ", ts#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](142,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 1 != $FunctionContextHeight;
    ##ts#0 := ts#0;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) == (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Open (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Open (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##b#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Open", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](146,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##b#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN();
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open, cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) == (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Close (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Close (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##b#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Close", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](154,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##b#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal: bool, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#0 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#0));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#1 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#1));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox($fh$0x#0): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires($Unbox($fh$0x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$0x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$0x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()), open#0: DatatypeType where $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))), close#0: DatatypeType where $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())))) returns (sp#2: DatatypeType where $Is(sp#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) returns (sp#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#1: Heap;
  var c#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#0_0_0: DatatypeType;
  var ##fT#0_0_0: HandleType;
  var ##ts#0_0_0: Seq;
  var ##self#0_0_1: DatatypeType;
  var ##fT#0_0_1: HandleType;
  var ##self#0_0_2: DatatypeType;
  var ##fDatum#0_0_0: HandleType;
  var ##self#0_1_0: DatatypeType;
  var ##fT#0_1_0: HandleType;
  var ##ts#0_1_0: Seq;
  var ##self#0_1_1: DatatypeType;
  var ##fT#0_1_1: HandleType;
  var a##0_1_0: Seq;
  var ##self#0_1_2: DatatypeType;
  var ##fT#0_1_2: HandleType;
  var ##ts#0_1_1: Seq;
  var b##0_1_0: Seq;
  var ##self#0_1_3: DatatypeType;
  var ##fT#0_1_3: HandleType;
  var c##0_1_0: Seq;
  var ##self#0_1_4: DatatypeType;
  var ##fT#0_1_4: HandleType;
  var ##ts#0_1_2: Seq;
  var ##self#0_1_5: DatatypeType;
  var ##fT#0_1_5: HandleType;
  var ##self#0_2_0: DatatypeType;
  var ##fT#0_2_0: HandleType;
  var ##ts#0_2_0: Seq;
  var ##self#0_2_1: DatatypeType;
  var ##fT#0_2_1: HandleType;
  var ##self#0_2_2: DatatypeType;
  var ##fT#0_2_2: HandleType;
  var ##ts#0_2_1: Seq;
  var ##self#0_2_3: DatatypeType;
  var ##fT#0_2_3: HandleType;
  var ##self#0_3_0: DatatypeType;
  var ##fT#0_3_0: HandleType;
  var ##ts#0_3_0: Seq;
  var a##0_3_0: Seq;
  var ##self#0_3_1: DatatypeType;
  var ##fT#0_3_1: HandleType;
  var b##0_3_0: Seq;
  var ##ts#0_3_1: Seq;
  var c##0_3_0: Seq;
  var ##self#0_3_2: DatatypeType;
  var ##fT#0_3_2: HandleType;
  var ##ts#0_3_2: Seq;
  var ##self#0_4_0: DatatypeType;
  var ##fT#0_4_0: HandleType;
  var ##ts#0_4_0: Seq;
  var ##self#0_4_1: DatatypeType;
  var ##fT#0_4_1: HandleType;
  var ##ts#0_4_1: Seq;
  var ##self#0_5_0: DatatypeType;
  var ##fT#0_5_0: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.BracketedFromParts", " | ", cs#0, " | ", open#0, " | ", elems#0, " | ", close#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](162,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##s#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume $IsAllocBox($Box(open#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon21_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon20_Else:
    goto anon5;

  anon5:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := c#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon23_Else:
    assume {:partition} !($Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1));
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon22_Else:
    goto anon9;

  anon9:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))));
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume $IsAllocBox($Box(sp#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume false;
    return;

  anon24_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $Is($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume let#0#0#0 == #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume sp#Z#0 == let#0#0#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume false;
    goto anon19;

  anon25_Else:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_5_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_5_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_5_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_5_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume true;
    assume false;
    goto anon19;

  anon26_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_4_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_4_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_4_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_4_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_4_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_4_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0)) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](177,84)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_4_1 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_4_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_4_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_4_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_4_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_4_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume true;
    assume false;
    goto anon19;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_3_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_1 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_3_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    a##0_3_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    b##0_3_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    c##0_3_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_3_0, b##0_3_0, c##0_3_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_3_0, b##0_3_0, c##0_3_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](179,104)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_3_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume true;
    assume false;
    goto anon19;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_2_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_2_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_2_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_2_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_2_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##fT#0_2_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](181,90)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_2_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_2_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_2_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_2_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_2_3 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_3, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##fT#0_2_3 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume true;
    assume false;
    goto anon19;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_1_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##fT#0_1_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_1_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_1_0 := Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_3 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_3, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##fT#0_1_3 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    b##0_1_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    c##0_1_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_1_0, b##0_1_0, c##0_1_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_1_0, b##0_1_0, c##0_1_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](183,141)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_4 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_4, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_1_4 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_4, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_5 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_5, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##fT#0_1_5 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_5, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume true;
    assume false;
    goto anon19;

  anon30_Else:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $Heap);
    ##fT#0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##fT#0_0_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume 1 != $FunctionContextHeight;
    ##self#0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)) } $Is(d#0_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0_0) < DtRank(##self#0_0_2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume true;
    assume false;
    goto anon19;

  anon31_Else:
    goto anon19;

  anon19:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#4 := cs#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](187,53)"} true;
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#0, elems#0, close#0) == sp#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#0, elems#0, close#0) == sp#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#0 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#0 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#0)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) && (forall e#3: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) } $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#1 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#1 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#1)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#1)));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$1x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AppendWithSuffix (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))), elem#0: DatatypeType where $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())), sep#0: DatatypeType where $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) returns (elems'#2: DatatypeType where $Is(elems'#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AppendWithSuffix (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) returns (elems'#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var e#5: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var e#6: DatatypeType;
  var ##other#1: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var suffixed#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##ts#0: Seq;
  var ##ts#0_0: Seq;
  var ##t#0_0: DatatypeType;
  var ##c#0_0: DatatypeType;
  var ##ts#0_0_0: Seq;
  var ##t#0_0_0: DatatypeType;
  var ##c#0_0_0: DatatypeType;
  var ##ts#0_0_0_0: Seq;
  var ##t#0_0_0_0: DatatypeType;
  var ##c#0_0_0_0: DatatypeType;
  var a##0_0_0_0: Seq;
  var ##ts#0_0_0_1: Seq;
  var b##0_0_0_0: Seq;
  var ##t#0_0_0_1: DatatypeType;
  var c##0_0_0_0: Seq;
  var a##0_0_0_1: Seq;
  var ##ts#0_0_0_2: Seq;
  var ##t#0_0_0_2: DatatypeType;
  var b##0_0_0_1: Seq;
  var ##c#0_0_0_1: DatatypeType;
  var c##0_0_0_1: Seq;
  var a##0_0_0: Seq;
  var ##ts#0_0_1: Seq;
  var b##0_0_0: Seq;
  var ##t#0_0_1: DatatypeType;
  var c##0_0_0: Seq;
  var ##c#0_0_1: DatatypeType;
  var ##ts#0_1: Seq;
  var ##t#0_1: DatatypeType;
  var ##c#0_1: DatatypeType;
  var ##ts#0_2: Seq;
  var ##ts#0_1_0: Seq;
  var ##e#0_1_0: DatatypeType;
  var ##ts#0_1_1: Seq;
  var ts0##0_1_0_0: Seq;
  var ts1##0_1_0_0: Seq;
  var pt##0_1_0_0: HandleType;
  var ##ts#0_1_0_0: Seq;
  var ##fT#0_1_0_0: HandleType;
  var ##ts#0_1_0_1: Seq;
  var ##fT#0_1_0_1: HandleType;
  var ##ts#0_1_0_2: Seq;
  var ##fT#0_1_0_2: HandleType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;
  var e#7: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#6: HandleType;
  var ##cs0#2_0: DatatypeType;
  var ##spec#2_0: HandleType;
  var ##cs0#2_0_0: DatatypeType;
  var ##spec#2_0_0: HandleType;
  var ##other#2_0: DatatypeType;
  var ##other#2_1_0: DatatypeType;
  var ##cs0#2_1_0_0: DatatypeType;
  var ##spec#2_1_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AppendWithSuffix", " | ", cs0#0, " | ", json#0, " | ", elems#0, " | ", elem#0, " | ", sep#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](191,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(elem#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon38_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon37_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elem#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    havoc e#5;
    assume $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#5);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5));
    goto anon8;

  anon39_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs0#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    havoc e#6;
    assume $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#6));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#6);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6));
    goto anon12;

  anon41_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6));
    goto anon12;

  anon12:
    assume (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#4 := cs0#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume false;
    return;

  anon40_Else:
    havoc suffixed#Z#0;
    assume $Is(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume let#0#0#0 == #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()));
    assume suffixed#Z#0 == let#0#0#0;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume let#1#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))), JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon43_Then, anon43_Else;

  anon43_Then:
    push;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon44_Then, anon44_Else;

  anon44_Then:
    push;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](214,82)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0_0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](215,80)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](216,88)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0_1, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    b##0_0_0_0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    c##0_0_0_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_0, b##0_0_0_0, c##0_0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_0, b##0_0_0_0, c##0_0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](217,95)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_2 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0_2, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    a##0_0_0_1 := Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    b##0_0_0_1 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    c##0_0_0_1 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_1, b##0_0_0_1, c##0_0_0_1);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_1, b##0_0_0_1, c##0_0_0_1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](218,130)"} true;
    pop;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon17;

  anon44_Else:
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](219,10)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_1, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    b##0_0_0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    c##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](220,110)"} true;
    pop;
    assume {:focus} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon18;

  anon43_Else:
    goto anon18;

  anon18:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](221,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_1, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    ##e#0_1_0 := suffixed#Z#0;
    assume $IsAlloc(##e#0_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(suffixed#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ts0##0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume true;
    ts1##0_1_0_0 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume 1 != $FunctionContextHeight;
    assume true;
    pt##0_1_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](224,87)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)) } { Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) } $Is(d#0_1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_1 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume $IsAlloc(##ts#0_1_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)) } { Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) } $Is(d#0_1_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_2 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)) } { Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) } $Is(d#0_1_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume true;
    assume Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](225,181)"} true;
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume false;
    goto anon21;

  anon46_Else:
    goto anon21;

  anon21:
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](226,10)"} true;
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon22;

  anon45_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](227,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon23;

  anon42_Else:
    goto anon23;

  anon23:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](228,6)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#5 := cs0#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](229,65)"} true;
    havoc e#7;
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#7));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#7);
    goto anon26;

  anon48_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#7));
    goto anon26;

  anon47_Else:
    assume {:partition} !($Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon26;

  anon26:
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#8)));
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Equal($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](230,104)"} true;
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)));
    assume false;
    goto anon28;

  anon49_Else:
    goto anon28;

  anon28:
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](230,106)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:split_here} JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](231,65)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#6 := cs0#0;
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#6, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_0 := cs0#0;
    assume $IsAlloc(##cs0#2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    goto anon51_Then, anon51_Else;

  anon51_Then:
    push;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_0_0 := cs0#0;
    assume $IsAlloc(##cs0#2_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_0_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](234,69)"} true;
    pop;
    assume true;
    assume false;
    goto anon31;

  anon51_Else:
    goto anon31;

  anon31:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](235,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0 := cs0#0;
    assume $IsAlloc(##other#2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_1_0 := cs0#0;
    assume $IsAlloc(##other#2_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_1_0_0 := cs0#0;
    assume $IsAlloc(##cs0#2_1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_1_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_1_0_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](238,71)"} true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon34;

  anon53_Else:
    goto anon34;

  anon34:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](239,10)"} true;
    assume true;
    assume false;
    goto anon35;

  anon52_Else:
    goto anon35;

  anon35:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](240,8)"} true;
    assume true;
    assume true;
    assume false;
    goto anon36;

  anon50_Else:
    goto anon36;

  anon36:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](241,6)"} true;
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#0 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#0 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#0)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#1 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#1 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#1)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#1)));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AppendLast (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))), elem#0: DatatypeType where $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())), sep#0: DatatypeType where $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())))) returns (elems'#2: DatatypeType where $Is(elems'#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AppendLast (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) returns (elems'#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var e#3: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var ##s#0: Seq;
  var ##other#1: DatatypeType;
  var $lambdaHeap#1: Heap;
  var c#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var suffixed#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##ts#0: Seq;
  var ##ts#0_0: Seq;
  var ##t#0_0: DatatypeType;
  var ##ts#0_1: Seq;
  var ##t#0_1: DatatypeType;
  var ##ts#0_2: Seq;
  var ##ts#0_1_0: Seq;
  var ##e#0_1_0: DatatypeType;
  var ##ts#0_1_1: Seq;
  var ts0##0_1_0_0: Seq;
  var ts1##0_1_0_0: Seq;
  var pt##0_1_0_0: HandleType;
  var ##ts#0_1_0_0: Seq;
  var ##fT#0_1_0_0: HandleType;
  var ##ts#0_1_0_1: Seq;
  var ##fT#0_1_0_1: HandleType;
  var ##ts#0_1_0_2: Seq;
  var ##fT#0_1_0_2: HandleType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AppendLast", " | ", cs0#0, " | ", json#0, " | ", elems#0, " | ", elem#0, " | ", sep#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](245,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(elem#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon24_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon23_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elem#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    havoc e#3;
    assume $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#3);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3));
    goto anon8;

  anon25_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs0#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    ##s#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} $Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := c#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon28_Else:
    assume {:partition} !($Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon27_Else:
    goto anon13;

  anon13:
    ##cs0#4 := JSON_mUtils_mCursors.Split.cs(elems'#2);
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume false;
    return;

  anon26_Else:
    havoc suffixed#Z#0;
    assume $Is(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume let#0#0#0 == #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty()));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()));
    assume suffixed#Z#0 == let#0#0#0;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume let#1#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))), JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    assume $IsA#JSON_mGrammar.jKeyValue($Unbox(JSON_mUtils_mCursors.Split.t(elem#0)): DatatypeType) && $IsA#JSON_mGrammar.jKeyValue($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    assume JSON_mGrammar.jKeyValue#Equal($Unbox(JSON_mUtils_mCursors.Split.t(elem#0)): DatatypeType, $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](267,37)"} true;
    pop;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon17;

  anon30_Else:
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](268,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_1, Tclass.JSON_mGrammar.jKeyValue(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    ##e#0_1_0 := suffixed#Z#0;
    assume $IsAlloc(##e#0_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(suffixed#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ts0##0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume true;
    ts1##0_1_0_0 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume 1 != $FunctionContextHeight;
    assume true;
    pt##0_1_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](271,87)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)) } { Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) } $Is(d#0_1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_1 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume $IsAlloc(##ts#0_1_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)) } { Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) } $Is(d#0_1_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_2 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)) } { Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) } $Is(d#0_1_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle());
    assume true;
    assume Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](272,181)"} true;
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume false;
    goto anon20;

  anon32_Else:
    goto anon20;

  anon20:
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](273,10)"} true;
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon21;

  anon31_Else:
    goto anon21;

  anon21:
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](274,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon22;

  anon29_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](275,6)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#5 := cs0#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](277,65)"} true;
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#2;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var s0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var sp#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##other#0: DatatypeType;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var sp#Z#2: DatatypeType;
  var let#3#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var st#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var sp#Z#3: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var sp#Z#4: DatatypeType;
  var let#5#0#0: DatatypeType;
  var $lambdaHeap#1: Heap;
  var st#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](281,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](283,8): post-state"} true;
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume sp#Z#0 == let#0#0#0;
    havoc s0#Z#0;
    assume LitInt(-1) <= s0#Z#0 && s0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume let#1#0#0 == JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume $Is(let#1#0#0, Tclass.BoundedInts.opt__byte());
    assume s0#Z#0 == let#1#0#0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon3;

  anon29_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon3;

  anon3:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon30_Else:
    assume {:partition} !(!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0));
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    havoc sp#Z#1;
    assume $Is(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#2#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sp#Z#1 == let#2#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0);
    goto anon7;

  anon31_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    goto anon7;

  anon7:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0));
    newtype$check#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    havoc sp#Z#2;
    assume $Is(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#3#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sp#Z#2 == let#3#0#0;
    assume $IsAllocBox($Box(sp#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    goto anon34_Then, anon34_Else;

  anon34_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc st#0;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon35_Else:
    assume {:partition} !($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon34_Else:
    goto anon13;

  anon13:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $IsBox($l#1#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#Z#2, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#2#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $IsBox($l#2#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))));
    goto anon14;

  anon33_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    goto anon14;

  anon32_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0)));
    goto anon14;

  anon14:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon17;

  anon37_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon17;

  anon17:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    newtype$check#4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon19;

  anon38_Else:
    assume {:partition} !(!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0));
    goto anon19;

  anon19:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    havoc sp#Z#3;
    assume $Is(sp#Z#3, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sp#Z#3, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume let#4#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume sp#Z#3 == let#4#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#3);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#Z#3)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#1 := cs#0;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#3), cs#0);
    goto anon21;

  anon39_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    goto anon21;

  anon36_Else:
    assume {:partition} !(((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))));
    goto anon21;

  anon21:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#2 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#2), cs#0)));
    newtype$check#6 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    havoc sp#Z#4;
    assume $Is(sp#Z#4, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sp#Z#4, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume let#5#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume sp#Z#4 == let#5#0#0;
    assume $IsAllocBox($Box(sp#Z#4), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc st#1;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} $Is(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := st#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon26;

  anon43_Else:
    assume {:partition} !($Is(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#1));
    goto anon26;

  anon26:
    assume false;
    goto anon27;

  anon42_Else:
    goto anon27;

  anon27:
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#Z#4, cs#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    goto anon28;

  anon41_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    goto anon28;

  anon40_Else:
    assume {:partition} !(((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#2 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#2), cs#0))));
    goto anon28;

  anon28:
    assume (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $IsBox($l#8#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#9#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $IsBox($l#9#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))))));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));
  modifies $Heap;
  free ensures JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; (forall $l#10#st#0: DatatypeType :: $Is($l#10#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#10#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $IsBox($l#11#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) && ((s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $IsBox($l#14#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))))) ==> (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#7 := sp#3; (forall $l#12#st#0: DatatypeType :: $Is($l#12#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $l#12#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#13#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $IsBox($l#13#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))))))));
  free ensures {:id "id26698"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#4)), JSON_mUtils_mCursors.Cursor__.s(cs#0)) && JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#4)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0) && JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#4)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id26699"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $IsBox($l#15#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#16#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $IsBox($l#16#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#21#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $IsBox($l#21#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))))));
  free ensures {:id "id26700"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#6)), JSON_mUtils_mCursors.Cursor__.s(cs#0)) && JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#6)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0) && JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#6)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id26701"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#22#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: $IsBox($l#22#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#23#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: $IsBox($l#23#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#28#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: $IsBox($l#28#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; (forall $l#29#st#0: DatatypeType :: $Is($l#29#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#29#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#30#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: $IsBox($l#30#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))))) && ((s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#33#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: $IsBox($l#33#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))))) ==> (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#7 := sp#3; (forall $l#31#st#0: DatatypeType :: $Is($l#31#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $l#31#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#32#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: $IsBox($l#32#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))))))));
  free ensures {:id "id26702"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#4)), JSON_mUtils_mCursors.Cursor__.s(cs#0)))));
  free ensures {:id "id26703"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#4)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0))));
  free ensures {:id "id26704"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#4)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id26705"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#34#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $IsBox($l#34#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#35#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $IsBox($l#35#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0)))));
  free ensures {:id "id26706"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#34#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $IsBox($l#34#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#35#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $IsBox($l#35#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#36#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: $IsBox($l#36#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#37#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: $IsBox($l#37#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#38#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: $IsBox($l#38#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#5))))))));
  free ensures {:id "id26707"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#6)), JSON_mUtils_mCursors.Cursor__.s(cs#0)))));
  free ensures {:id "id26708"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#6)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0))));
  free ensures {:id "id26709"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#6)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id26710"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $IsBox($l#41#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#42#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $IsBox($l#42#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0)))));
  free ensures {:id "id26711"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $IsBox($l#41#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#42#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $IsBox($l#42#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#43#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: $IsBox($l#43#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#44#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: $IsBox($l#44#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#45#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: $IsBox($l#45#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#7))))))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](289,4): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutLists (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutLists (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id26717"} LitInt(0) <= i#0;
  requires {:id "id26718"} i#0 < Seq#Length(xs#0);



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutLists (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures true;
  free ensures {:id "id26719"} Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutLists (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id26720"} LitInt(0) <= i#0;
  requires {:id "id26721"} i#0 < Seq#Length(xs#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id26722"} $_reverifyPost ==> Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutLists (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T: Ty, xs#0: Seq, i#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](294,4): initial state"} true;
    $_reverifyPost := false;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var elem#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#0) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#0)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && (var sep#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#0)); JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType); (s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType)) && (s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#1 := sep#0; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1) && (var elems#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#1)))) && (!(s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType)) && (s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#2 := sep#0; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2) && (var elems'#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#0, sep#2))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#0) else (var elem#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#0)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#0)); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType); (if s0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#1 := sep#0; (var elems#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#1))) else (if s0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#2 := sep#0; (var elems'#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2); (var bracketed#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#0, sep#2); #Wrappers.Result.Success($Box(bracketed#0))))) else (var separator#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#0 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#0)), s0#0))); pr#0)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var elem#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#1) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#1)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#1)) && (var sep#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#1)); JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) && (var s0#1 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType); (s0#1 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType)) && (s0#1 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#4 := sep#3; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4) && (var elems#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#2)))) && (!(s0#1 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#1 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType)) && (s0#1 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#5 := sep#3; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5) && (var elems'#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#1, sep#5))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#1) else (var elem#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#1)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#1)); (var s0#1 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType); (if s0#1 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#4 := sep#3; (var elems#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#2))) else (if s0#1 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#5 := sep#3; (var elems'#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5); (var bracketed#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#1, sep#5); #Wrappers.Result.Success($Box(bracketed#1))))) else (var separator#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#1 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#1)), s0#1))); pr#1)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#3: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) } $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var elem#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#2) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#2)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#2)) && (var sep#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#2)); JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) && (var s0#2 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType); (s0#2 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType)) && (s0#2 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#7 := sep#6; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7) && (var elems#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#3)))) && (!(s0#2 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#2 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType)) && (s0#2 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#8 := sep#6; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8) && (var elems'#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#2, sep#8))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#2) else (var elem#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#2)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#2)); (var s0#2 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType); (if s0#2 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#7 := sep#6; (var elems#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#3))) else (if s0#2 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#8 := sep#6; (var elems'#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8); (var bracketed#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#2, sep#8); #Wrappers.Result.Success($Box(bracketed#2))))) else (var separator#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#2 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#2)), s0#2))); pr#2)))))))))));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), $reveal, cs0#0, json#0, open#0, elems#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), $reveal, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0));

axiom (forall $ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements(AsFuelBottom($ly), $reveal, cs0#0, json#0, open#0, elems#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LZ, $reveal, cs0#0, json#0, open#0, elems#0));

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires(LayerType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Elements (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), open#0: DatatypeType where $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))))) returns (pr#3: DatatypeType where $Is(pr#3, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, $Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] } Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: DatatypeType, $fh$0x#2: DatatypeType, $fh$0x#3: DatatypeType, $fh$0x#4: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Unbox(Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle($reveal), $Box($fh$0x#0), $Box($fh$0x#1), $Box($fh$0x#2), $Box($fh$0x#3), $Box($fh$0x#4))): DatatypeType);

function JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, $Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] } Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: DatatypeType, $fh$0x#2: DatatypeType, $fh$0x#3: DatatypeType, $fh$0x#4: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Unbox(Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle($reveal), $Box($fh$0x#0), $Box($fh$0x#1), $Box($fh$0x#2), $Box($fh$0x#3), $Box($fh$0x#4))): DatatypeType);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Elements (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements(cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) returns (pr#3: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##other#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var e#4: DatatypeType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##json#0: DatatypeType;
  var elem#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var cs##0: DatatypeType;
  var sep#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var s0#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##c#0: char;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var newtype$check#0_0_1_2: int;
  var ##idx#0_0_1_0: int;
  var newtype$check#0_0_1_3: int;
  var newtype$check#0_0_1_4: int;
  var newtype$check#0_0_1_5: int;
  var newtype$check#0_0_1_6: int;
  var newtype$check#0_0_2_0: int;
  var ##idx#0_0_2_0: int;
  var newtype$check#0_0_2_1: int;
  var newtype$check#0_0_2_2: int;
  var newtype$check#0_0_2_3: int;
  var newtype$check#0_0_2_4: int;
  var newtype$check#0_0_2_5: int;
  var newtype$check#0_0_2_6: int;
  var newtype$check#0_0_2_7: int;
  var newtype$check#0_0_2_8: int;
  var newtype$check#0_0_3_0: int;
  var newtype$check#0_0_3_1: int;
  var newtype$check#0_0_3_2: int;
  var newtype$check#0_0_3_3: int;
  var xs##0_0_4_0_0: Seq;
  var i##0_0_4_0_0: int;
  var newtype$check#0_0_5_0_0: int;
  var ##c#0_0_7_0: int;
  var ##c#0_0_8_0: int;
  var newtype$check#0_0_8_0: int;
  var newtype$check#0_0_8_1: int;
  var ##c#0_0_8_1: int;
  var newtype$check#0_0_9_0: int;
  var newtype$check#0_0_9_1: int;
  var ##c#0_0_9_0: int;
  var ##c#0_0_9_1: char;
  var sep#Z#1: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##x0#0: DatatypeType;
  var ##x1#0: DatatypeType;
  var ##x2#0: DatatypeType;
  var ##x3#0: DatatypeType;
  var ##x4#0: DatatypeType;
  var ##other#1_0: DatatypeType;
  var ##cs0#1_0: DatatypeType;
  var ##spec#1_0: HandleType;
  var ##cs0#1_1: DatatypeType;
  var ##spec#1_1: HandleType;
  var $lambdaHeap#1_0: Heap;
  var c#1_0: DatatypeType;
  var $_Frame#l1_0: [ref,Field]bool;
  var lambdaResult#1_0: Seq;
  var ##self#1_0: DatatypeType;
  var ##fT#1_0: HandleType;
  var ##cs0#1_2: DatatypeType;
  var ##spec#1_2: HandleType;
  var $lambdaHeap#1_0_0: Heap;
  var c#1_0_0: DatatypeType;
  var $_Frame#l1_0_0: [ref,Field]bool;
  var lambdaResult#1_0_0: Seq;
  var ##self#1_0_0: DatatypeType;
  var ##fT#1_0_0: HandleType;
  var ##cs0#1_0_0: DatatypeType;
  var ##spec#1_0_0: HandleType;
  var $lambdaHeap#1_0_0_0: Heap;
  var c#1_0_0_0: DatatypeType;
  var $_Frame#l1_0_0_0: [ref,Field]bool;
  var lambdaResult#1_0_0_0: Seq;
  var ##self#1_0_0_0: DatatypeType;
  var ##fT#1_0_0_0: HandleType;
  var ##cs0#1_0_0_0: DatatypeType;
  var ##spec#1_0_0_0: HandleType;
  var ##other#1_0_0: DatatypeType;
  var ##other#1_0_1_0: DatatypeType;
  var e#1_0: DatatypeType;
  var elems#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##json#1: DatatypeType;
  var ##elems#0: DatatypeType;
  var ##elem#0: DatatypeType;
  var ##sep#0: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##json#2: DatatypeType;
  var ##open#0: DatatypeType;
  var ##elems#1: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##c#1: int;
  var newtype$check#2_0_0_0: int;
  var newtype$check#2_0_0_1: int;
  var newtype$check#2_0_1_0: int;
  var newtype$check#2_0_1_1: int;
  var newtype$check#2_0_1_2: int;
  var ##idx#2_0_1_0: int;
  var newtype$check#2_0_1_3: int;
  var newtype$check#2_0_1_4: int;
  var newtype$check#2_0_1_5: int;
  var newtype$check#2_0_1_6: int;
  var newtype$check#2_0_2_0: int;
  var ##idx#2_0_2_0: int;
  var newtype$check#2_0_2_1: int;
  var newtype$check#2_0_2_2: int;
  var newtype$check#2_0_2_3: int;
  var newtype$check#2_0_2_4: int;
  var newtype$check#2_0_2_5: int;
  var newtype$check#2_0_2_6: int;
  var newtype$check#2_0_2_7: int;
  var newtype$check#2_0_2_8: int;
  var newtype$check#2_0_3_0: int;
  var newtype$check#2_0_3_1: int;
  var newtype$check#2_0_3_2: int;
  var newtype$check#2_0_3_3: int;
  var xs##2_0_4_0_0: Seq;
  var i##2_0_4_0_0: int;
  var newtype$check#2_0_5_0_0: int;
  var ##c#2_0_7_0: int;
  var sep#Z#2: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##x0#1: DatatypeType;
  var ##x1#1: DatatypeType;
  var ##x2#1: DatatypeType;
  var ##x3#1: DatatypeType;
  var ##x4#1: DatatypeType;
  var ##other#3_0: DatatypeType;
  var ##cs0#3_0: DatatypeType;
  var ##spec#3_0: HandleType;
  var ##cs0#3_1: DatatypeType;
  var ##spec#3_1: HandleType;
  var $lambdaHeap#3_0: Heap;
  var c#3_0: DatatypeType;
  var $_Frame#l3_0: [ref,Field]bool;
  var lambdaResult#3_0: Seq;
  var ##self#3_0: DatatypeType;
  var ##fT#3_0: HandleType;
  var ##cs0#3_2: DatatypeType;
  var ##spec#3_2: HandleType;
  var $lambdaHeap#3_0_0: Heap;
  var c#3_0_0: DatatypeType;
  var $_Frame#l3_0_0: [ref,Field]bool;
  var lambdaResult#3_0_0: Seq;
  var ##self#3_0_0: DatatypeType;
  var ##fT#3_0_0: HandleType;
  var ##cs0#3_0_0: DatatypeType;
  var ##spec#3_0_0: HandleType;
  var $lambdaHeap#3_0_0_0: Heap;
  var c#3_0_0_0: DatatypeType;
  var $_Frame#l3_0_0_0: [ref,Field]bool;
  var lambdaResult#3_0_0_0: Seq;
  var ##self#3_0_0_0: DatatypeType;
  var ##fT#3_0_0_0: HandleType;
  var ##cs0#3_0_0_0: DatatypeType;
  var ##spec#3_0_0_0: HandleType;
  var ##other#3_0_0: DatatypeType;
  var ##other#3_0_1_0: DatatypeType;
  var e#3_0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##cs0#5: DatatypeType;
  var ##json#3: DatatypeType;
  var ##elems#2: DatatypeType;
  var ##elem#1: DatatypeType;
  var ##sep#1: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#3: HandleType;
  var ##cs0#4_0: DatatypeType;
  var ##spec#4_0: HandleType;
  var bracketed#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##open#1: DatatypeType;
  var ##elems#3: DatatypeType;
  var ##close#0: DatatypeType;
  var ##cs0#7: DatatypeType;
  var ##spec#4: HandleType;
  var separator#Z#0: int;
  var let#9#0#0: int;
  var pr#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Elements", " | ", cs0#0, " | ", json#0, " | ", open#0, " | ", elems#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](298,69): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(open#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    goto anon113_Then, anon113_Else;

  anon113_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon114_Then, anon114_Else;

  anon114_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon114_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon113_Else:
    goto anon5;

  anon5:
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    havoc e#4;
    assume $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon115_Then, anon115_Else;

  anon115_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#4);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4));
    goto anon8;

  anon115_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    goto anon116_Then, anon116_Else;

  anon116_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon117_Then, anon117_Else;

  anon117_Then:
    assume Wrappers.Result.Success_q(pr#3);
    assume Wrappers.Result.Success_q(pr#3);
    assume $IsAllocBox(Wrappers.Result.value(pr#3), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2 := cs0#0;
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    goto anon12;

  anon117_Else:
    assume Wrappers.Result.Success_q(pr#3) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    goto anon12;

  anon12:
    assume false;
    return;

  anon116_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##cs#0 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(##cs#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(##cs#0), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.beg(##cs#0) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.end(##cs#0) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon118_Then, anon118_Else;

  anon118_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon118_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc elem#Z#0;
    assume $Is(elem#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()));
    assume elem#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon119_Then, anon119_Else;

  anon119_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon119_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    cs##0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs##0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](316,34)"} true;
    havoc sep#Z#0;
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))) && $IsAlloc(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume let#2#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume sep#Z#0 == let#2#0#0;
    havoc s0#Z#0;
    assume LitInt(-1) <= s0#Z#0 && s0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume let#3#0#0 == JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Is(let#3#0#0, Tclass.BoundedInts.opt__byte());
    assume s0#Z#0 == let#3#0#0;
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon120_Then, anon120_Else;

  anon120_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon19;

  anon120_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    goto anon19;

  anon19:
    goto anon121_Then, anon121_Else;

  anon121_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    goto anon122_Then, anon122_Else;

  anon122_Then:
    goto anon123_Then, anon123_Else;

  anon123_Then:
    assume true;
    assume false;
    goto anon37;

  anon123_Else:
    goto anon124_Then, anon124_Else;

  anon124_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_9_0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_9_0 && newtype$check#0_0_9_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_9_1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_9_1 && newtype$check#0_0_9_1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0_0_9_0 := char#ToInt(Lit(char#FromInt(44)));
    assume $IsAlloc(##c#0_0_9_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_9_1 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0_0_9_1, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} char#ToInt(##c#0_0_9_1) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume true;
    assume false;
    goto anon37;

  anon124_Else:
    goto anon125_Then, anon125_Else;

  anon125_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_8_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0_8_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_8_0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_8_0 && newtype$check#0_0_8_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_8_1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_8_1 && newtype$check#0_0_8_1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0_0_8_1 := char#ToInt(Lit(char#FromInt(44)));
    assume $IsAlloc(##c#0_0_8_1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume true;
    assume false;
    goto anon37;

  anon125_Else:
    goto anon126_Then, anon126_Else;

  anon126_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_7_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0_7_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume true;
    assume false;
    goto anon37;

  anon126_Else:
    goto anon127_Then, anon127_Else;

  anon127_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon127_Else:
    goto anon128_Then, anon128_Else;

  anon128_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon129_Then, anon129_Else;

  anon129_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#0_0_5_0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0_5_0_0 && newtype$check#0_0_5_0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](327,105)"} true;
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume false;
    goto anon29;

  anon129_Else:
    goto anon29;

  anon29:
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](327,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon128_Else:
    goto anon130_Then, anon130_Else;

  anon130_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon131_Then, anon131_Else;

  anon131_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    xs##0_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    i##0_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##0_0_4_0_0, i##0_0_4_0_0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##0_0_4_0_0, i##0_0_4_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](329,155)"} true;
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume false;
    goto anon32;

  anon131_Else:
    goto anon32;

  anon32:
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](329,157)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon130_Else:
    goto anon132_Then, anon132_Else;

  anon132_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#0_0_3_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_3_0 && newtype$check#0_0_3_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_1 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_3_1 && newtype$check#0_0_3_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_3_2 && newtype$check#0_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_3_3 && newtype$check#0_0_3_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon132_Else:
    goto anon133_Then, anon133_Else;

  anon133_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0_0_2_0 && newtype$check#0_0_2_0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0_0_2_0 := LitInt(0);
    assume $IsAlloc(##idx#0_0_2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_2_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_2_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#0_0_2_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#0_0_2_1 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_2_1 && newtype$check#0_0_2_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_2 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_2_2 && newtype$check#0_0_2_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_3 && newtype$check#0_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_4 && newtype$check#0_0_2_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#0_0_2_5 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_2_5 && newtype$check#0_0_2_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_6 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_2_6 && newtype$check#0_0_2_6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_7 && newtype$check#0_0_2_7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_8 && newtype$check#0_0_2_8 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon133_Else:
    goto anon134_Then, anon134_Else;

  anon134_Then:
    newtype$check#0_0_1_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_0 && newtype$check#0_0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_1 && newtype$check#0_0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_1_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#0_0_1_2 && newtype$check#0_0_1_2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0_0_1_0 := LitInt(0);
    assume $IsAlloc(##idx#0_0_1_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_1_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_1_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#0_0_1_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#0_0_1_3 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_1_3 && newtype$check#0_0_1_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_4 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_1_4 && newtype$check#0_0_1_4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_5 && newtype$check#0_0_1_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_6 && newtype$check#0_0_1_6 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume true;
    assume false;
    goto anon37;

  anon134_Else:
    goto anon135_Then, anon135_Else;

  anon135_Then:
    assume true;
    assume true;
    newtype$check#0_0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_0_0 && newtype$check#0_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_0_1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_0_1 && newtype$check#0_0_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume true;
    assume false;
    goto anon37;

  anon135_Else:
    goto anon37;

  anon37:
    assume true ==> JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume true;
    assume false;
    goto anon38;

  anon122_Else:
    goto anon38;

  anon38:
    assume JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](336,10)"} true;
    havoc sep#Z#1;
    assume $Is(sep#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#4#0#0 == sep#Z#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sep#Z#1 == let#4#0#0;
    assume 3 != $FunctionContextHeight;
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix)), Tclass._System.___hFunc5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##x0#0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##x1#0 := json#0;
    assume $IsAlloc(##x1#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##x2#0 := elems#0;
    assume $IsAlloc(##x2#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##x3#0 := elem#Z#0;
    assume $IsAlloc(##x3#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    ##x4#0 := sep#Z#1;
    assume $IsAlloc(##x4#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix), $Box(##x0#0), $Box(##x1#0), $Box(##x2#0), $Box(##x3#0), $Box(##x4#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    goto anon136_Then, anon136_Else;

  anon136_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:focus} true;
    assume {:focus} true;
    assume {:focus} true;
    assume {:focus} true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](339,64)"} true;
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](340,66)"} true;
    assume $IsAllocBox($Box(elem#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1_1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](341,65)"} true;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon137_Then, anon137_Else;

  anon137_Then:
    havoc $lambdaHeap#1_0;
    assume $IsGoodHeap($lambdaHeap#1_0);
    assume $Heap == $lambdaHeap#1_0 || $HeapSucc($Heap, $lambdaHeap#1_0);
    havoc c#1_0;
    goto anon138_Then, anon138_Else;

  anon138_Then:
    assume {:partition} $Is(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0);
    $_Frame#l1_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0, $o, alloc)): bool ==> false);
    ##self#1_0 := c#1_0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0);
    ##fT#1_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon42;

  anon138_Else:
    assume {:partition} !($Is(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0));
    goto anon42;

  anon42:
    assume false;
    goto anon43;

  anon137_Else:
    goto anon43;

  anon43:
    ##cs0#1_2 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_2 := Lit(AtLayer((lambda $l#1_1#ly#0: LayerType :: Handle1((lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: $IsBox($l#1_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_2#ly#0: LayerType :: Handle1((lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: $IsBox($l#1_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_3#c#0: DatatypeType :: $Is($l#1_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_4#ly#0: LayerType :: Handle1((lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: $IsBox($l#1_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon139_Then, anon139_Else;

  anon139_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon140_Then, anon140_Else;

  anon140_Then:
    havoc $lambdaHeap#1_0_0;
    assume $IsGoodHeap($lambdaHeap#1_0_0);
    assume $Heap == $lambdaHeap#1_0_0 || $HeapSucc($Heap, $lambdaHeap#1_0_0);
    havoc c#1_0_0;
    goto anon141_Then, anon141_Else;

  anon141_Then:
    assume {:partition} $Is(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0);
    $_Frame#l1_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0_0, $o, alloc)): bool ==> false);
    ##self#1_0_0 := c#1_0_0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0);
    ##fT#1_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon47;

  anon141_Else:
    assume {:partition} !($Is(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0));
    goto anon47;

  anon47:
    assume false;
    goto anon48;

  anon140_Else:
    goto anon48;

  anon48:
    ##cs0#1_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0 := Lit(AtLayer((lambda $l#1_0_1#ly#0: LayerType :: Handle1((lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: $IsBox($l#1_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_2#ly#0: LayerType :: Handle1((lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: $IsBox($l#1_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_0_3#c#0: DatatypeType :: $Is($l#1_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_4#ly#0: LayerType :: Handle1((lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: $IsBox($l#1_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon142_Then, anon142_Else;

  anon142_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon143_Then, anon143_Else;

  anon143_Then:
    havoc $lambdaHeap#1_0_0_0;
    assume $IsGoodHeap($lambdaHeap#1_0_0_0);
    assume $Heap == $lambdaHeap#1_0_0_0 || $HeapSucc($Heap, $lambdaHeap#1_0_0_0);
    havoc c#1_0_0_0;
    goto anon144_Then, anon144_Else;

  anon144_Then:
    assume {:partition} $Is(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0);
    $_Frame#l1_0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0_0_0, $o, alloc)): bool ==> false);
    ##self#1_0_0_0 := c#1_0_0_0;
    assume $IsAlloc(##self#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0);
    ##fT#1_0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon52;

  anon144_Else:
    assume {:partition} !($Is(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0));
    goto anon52;

  anon52:
    assume false;
    goto anon53;

  anon143_Else:
    goto anon53;

  anon53:
    ##cs0#1_0_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0_0 := Lit(AtLayer((lambda $l#1_0_0_1#ly#0: LayerType :: Handle1((lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: $IsBox($l#1_0_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_2#ly#0: LayerType :: Handle1((lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: $IsBox($l#1_0_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_0_0_3#c#0: DatatypeType :: $Is($l#1_0_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_0_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_4#ly#0: LayerType :: Handle1((lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: $IsBox($l#1_0_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_4#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_12#ly#0: LayerType :: Handle1((lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: $IsBox($l#1_0_0_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](344,81)"} true;
    pop;
    assume true;
    assume false;
    goto anon54;

  anon142_Else:
    goto anon54;

  anon54:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_9#ly#0: LayerType :: Handle1((lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: $IsBox($l#1_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_9#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](345,14)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#1_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon145_Then, anon145_Else;

  anon145_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](347,34)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#1_0_1_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#1_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon146_Then, anon146_Else;

  anon146_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](349,38)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon57;

  anon146_Else:
    goto anon57;

  anon57:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](350,16)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon58;

  anon145_Else:
    goto anon58;

  anon58:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](351,14)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon59;

  anon139_Else:
    goto anon59;

  anon59:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_12#ly#0: LayerType :: Handle1((lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: $IsBox($l#1_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: SetRef_to_SetBox((lambda $l#1_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](352,12)"} true;
    havoc e#1_0;
    goto anon147_Then, anon147_Else;

  anon147_Then:
    assume {:partition} $Is(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon148_Then, anon148_Else;

  anon148_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#1_0);
    goto anon62;

  anon148_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_0));
    goto anon62;

  anon147_Else:
    assume {:partition} !($Is(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon62;

  anon62:
    assume (forall e#1_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) } $Is(e#1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#1_1)));
    assume (forall e#1_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) } $Is(e#1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1_1)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](353,64)"} true;
    assume true;
    assume {:split_here} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](354,37)"} true;
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume false;
    goto anon63;

  anon136_Else:
    goto anon63;

  anon63:
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](355,10)"} true;
    havoc elems#Z#0;
    assume $Is(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##cs0#3 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#1 := json#0;
    assume $IsAlloc(##json#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##elems#0 := elems#0;
    assume $IsAlloc(##elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##elem#0 := elem#Z#0;
    assume $IsAlloc(##elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    ##sep#0 := sep#Z#1;
    assume $IsAlloc(##sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#1)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#3), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elem#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elem#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##sep#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##sep#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##sep#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##sep#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##sep#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##sep#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1));
    assume let#5#0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems#Z#0 == let#5#0#0;
    ##cs0#4 := cs0#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#2 := json#0;
    assume $IsAlloc(##json#2, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##open#0 := open#0;
    assume $IsAlloc(##open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    ##elems#1 := elems#Z#0;
    assume $IsAlloc(##elems#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#0)), JSON_mUtils_mCursors.Cursor__.s(##cs0#4))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs0#4)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs0#4)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#4), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#2)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)));
    assume 0 <= JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(##elems#1)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon121_Else:
    assume {:partition} !(s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1));
    newtype$check#3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon149_Then, anon149_Else;

  anon149_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#5 := LitInt(1);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon66;

  anon149_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    goto anon66;

  anon66:
    goto anon150_Then, anon150_Else;

  anon150_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume $IsAlloc(##c#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    goto anon151_Then, anon151_Else;

  anon151_Then:
    goto anon152_Then, anon152_Else;

  anon152_Then:
    assume true;
    assume false;
    goto anon82;

  anon152_Else:
    goto anon153_Then, anon153_Else;

  anon153_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#2_0_7_0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume $IsAlloc(##c#2_0_7_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume true;
    assume false;
    goto anon82;

  anon153_Else:
    goto anon154_Then, anon154_Else;

  anon154_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon154_Else:
    goto anon155_Then, anon155_Else;

  anon155_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon156_Then, anon156_Else;

  anon156_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#2_0_5_0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#2_0_5_0_0 && newtype$check#2_0_5_0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](364,105)"} true;
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume false;
    goto anon74;

  anon156_Else:
    goto anon74;

  anon74:
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](364,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon155_Else:
    goto anon157_Then, anon157_Else;

  anon157_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon158_Then, anon158_Else;

  anon158_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    xs##2_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    i##2_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##2_0_4_0_0, i##2_0_4_0_0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##2_0_4_0_0, i##2_0_4_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](366,155)"} true;
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume false;
    goto anon77;

  anon158_Else:
    goto anon77;

  anon77:
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](366,157)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon157_Else:
    goto anon159_Then, anon159_Else;

  anon159_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#2_0_3_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_3_0 && newtype$check#2_0_3_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_1 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_3_1 && newtype$check#2_0_3_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_2 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_3_2 && newtype$check#2_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_3_3 && newtype$check#2_0_3_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon159_Else:
    goto anon160_Then, anon160_Else;

  anon160_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#2_0_2_0 && newtype$check#2_0_2_0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#2_0_2_0 := LitInt(0);
    assume $IsAlloc(##idx#2_0_2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_2_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_2_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#2_0_2_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#2_0_2_1 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_2_1 && newtype$check#2_0_2_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_2 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_2_2 && newtype$check#2_0_2_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_3 && newtype$check#2_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_4 && newtype$check#2_0_2_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#2_0_2_5 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_2_5 && newtype$check#2_0_2_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_6 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_2_6 && newtype$check#2_0_2_6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_7 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_7 && newtype$check#2_0_2_7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_8 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_8 && newtype$check#2_0_2_8 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon160_Else:
    goto anon161_Then, anon161_Else;

  anon161_Then:
    newtype$check#2_0_1_0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_0 && newtype$check#2_0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_1 && newtype$check#2_0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2_0_1_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2_0_1_2 && newtype$check#2_0_1_2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#2_0_1_0 := LitInt(0);
    assume $IsAlloc(##idx#2_0_1_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_1_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_1_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#2_0_1_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#2_0_1_3 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_1_3 && newtype$check#2_0_1_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_4 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_1_4 && newtype$check#2_0_1_4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_5 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_5 && newtype$check#2_0_1_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_6 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_6 && newtype$check#2_0_1_6 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume true;
    assume false;
    goto anon82;

  anon161_Else:
    goto anon162_Then, anon162_Else;

  anon162_Then:
    assume true;
    assume true;
    newtype$check#2_0_0_0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_0_0 && newtype$check#2_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_0_1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_0_1 && newtype$check#2_0_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume true;
    assume false;
    goto anon82;

  anon162_Else:
    goto anon82;

  anon82:
    assume true ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume true;
    assume false;
    goto anon83;

  anon151_Else:
    goto anon83;

  anon83:
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](373,10)"} true;
    havoc sep#Z#2;
    assume $Is(sep#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume let#6#0#0 == sep#Z#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume sep#Z#2 == let#6#0#0;
    assume 3 != $FunctionContextHeight;
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast)), Tclass._System.___hFunc5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##x0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##x0#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##x1#1 := json#0;
    assume $IsAlloc(##x1#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##x2#1 := elems#0;
    assume $IsAlloc(##x2#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##x3#1 := elem#Z#0;
    assume $IsAlloc(##x3#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    ##x4#1 := sep#Z#2;
    assume $IsAlloc(##x4#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast), $Box(##x0#1), $Box(##x1#1), $Box(##x2#1), $Box(##x3#1), $Box(##x4#1))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    goto anon163_Then, anon163_Else;

  anon163_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#3_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](376,55)"} true;
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#3_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](377,66)"} true;
    assume $IsAllocBox($Box(elem#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#3_1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#3_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](378,65)"} true;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon164_Then, anon164_Else;

  anon164_Then:
    havoc $lambdaHeap#3_0;
    assume $IsGoodHeap($lambdaHeap#3_0);
    assume $Heap == $lambdaHeap#3_0 || $HeapSucc($Heap, $lambdaHeap#3_0);
    havoc c#3_0;
    goto anon165_Then, anon165_Else;

  anon165_Then:
    assume {:partition} $Is(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0);
    $_Frame#l3_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0, $o, alloc)): bool ==> false);
    ##self#3_0 := c#3_0;
    assume $IsAlloc(##self#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0);
    ##fT#3_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon87;

  anon165_Else:
    assume {:partition} !($Is(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0));
    goto anon87;

  anon87:
    assume false;
    goto anon88;

  anon164_Else:
    goto anon88;

  anon88:
    ##cs0#3_2 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_2 := Lit(AtLayer((lambda $l#3_1#ly#0: LayerType :: Handle1((lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: $IsBox($l#3_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_2#ly#0: LayerType :: Handle1((lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: $IsBox($l#3_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_3#c#0: DatatypeType :: $Is($l#3_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $l#3_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_4#ly#0: LayerType :: Handle1((lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: $IsBox($l#3_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon166_Then, anon166_Else;

  anon166_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon167_Then, anon167_Else;

  anon167_Then:
    havoc $lambdaHeap#3_0_0;
    assume $IsGoodHeap($lambdaHeap#3_0_0);
    assume $Heap == $lambdaHeap#3_0_0 || $HeapSucc($Heap, $lambdaHeap#3_0_0);
    havoc c#3_0_0;
    goto anon168_Then, anon168_Else;

  anon168_Then:
    assume {:partition} $Is(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0_0);
    $_Frame#l3_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0_0, $o, alloc)): bool ==> false);
    ##self#3_0_0 := c#3_0_0;
    assume $IsAlloc(##self#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0_0);
    ##fT#3_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon92;

  anon168_Else:
    assume {:partition} !($Is(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0_0));
    goto anon92;

  anon92:
    assume false;
    goto anon93;

  anon167_Else:
    goto anon93;

  anon93:
    ##cs0#3_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0 := Lit(AtLayer((lambda $l#3_0_1#ly#0: LayerType :: Handle1((lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: $IsBox($l#3_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_2#ly#0: LayerType :: Handle1((lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: $IsBox($l#3_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_0_3#c#0: DatatypeType :: $Is($l#3_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $l#3_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_4#ly#0: LayerType :: Handle1((lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: $IsBox($l#3_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon169_Then, anon169_Else;

  anon169_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon170_Then, anon170_Else;

  anon170_Then:
    havoc $lambdaHeap#3_0_0_0;
    assume $IsGoodHeap($lambdaHeap#3_0_0_0);
    assume $Heap == $lambdaHeap#3_0_0_0 || $HeapSucc($Heap, $lambdaHeap#3_0_0_0);
    havoc c#3_0_0_0;
    goto anon171_Then, anon171_Else;

  anon171_Then:
    assume {:partition} $Is(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0_0_0);
    $_Frame#l3_0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0_0_0, $o, alloc)): bool ==> false);
    ##self#3_0_0_0 := c#3_0_0_0;
    assume $IsAlloc(##self#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0_0_0);
    ##fT#3_0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon97;

  anon171_Else:
    assume {:partition} !($Is(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $lambdaHeap#3_0_0_0));
    goto anon97;

  anon97:
    assume false;
    goto anon98;

  anon170_Else:
    goto anon98;

  anon98:
    ##cs0#3_0_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0_0 := Lit(AtLayer((lambda $l#3_0_0_1#ly#0: LayerType :: Handle1((lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: $IsBox($l#3_0_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_2#ly#0: LayerType :: Handle1((lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: $IsBox($l#3_0_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_0_0_3#c#0: DatatypeType :: $Is($l#3_0_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $l#3_0_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_4#ly#0: LayerType :: Handle1((lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: $IsBox($l#3_0_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_4#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_12#ly#0: LayerType :: Handle1((lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_0_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: $IsBox($l#3_0_0_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](381,81)"} true;
    pop;
    assume true;
    assume false;
    goto anon99;

  anon169_Else:
    goto anon99;

  anon99:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_9#ly#0: LayerType :: Handle1((lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: $IsBox($l#3_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_9#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](382,14)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#3_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#3_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon172_Then, anon172_Else;

  anon172_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](384,34)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#3_0_1_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#3_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon173_Then, anon173_Else;

  anon173_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](386,38)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon102;

  anon173_Else:
    goto anon102;

  anon102:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](387,16)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon103;

  anon172_Else:
    goto anon103;

  anon103:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](388,14)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon104;

  anon166_Else:
    goto anon104;

  anon104:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_12#ly#0: LayerType :: Handle1((lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#3_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: $IsBox($l#3_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: SetRef_to_SetBox((lambda $l#3_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](389,12)"} true;
    havoc e#3_0;
    goto anon174_Then, anon174_Else;

  anon174_Then:
    assume {:partition} $Is(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon175_Then, anon175_Else;

  anon175_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#3_0);
    goto anon107;

  anon175_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_0));
    goto anon107;

  anon174_Else:
    assume {:partition} !($Is(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon107;

  anon107:
    assume (forall e#3_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) } $Is(e#3_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#3_1)));
    assume (forall e#3_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) } $Is(e#3_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3_1)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](390,64)"} true;
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume false;
    goto anon108;

  anon163_Else:
    goto anon108;

  anon108:
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](391,10)"} true;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##cs0#5 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#3 := json#0;
    assume $IsAlloc(##json#3, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##elems#2 := elems#0;
    assume $IsAlloc(##elems#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##elem#1 := elem#Z#0;
    assume $IsAlloc(##elem#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap);
    ##sep#1 := sep#Z#2;
    assume $IsAlloc(##sep#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#2)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#2)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#3)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#2)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#3)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#5), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#2)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elem#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#2)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#2)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elem#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##sep#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##sep#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#1)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##sep#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##sep#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#1)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##sep#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##sep#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2));
    assume let#7#0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume $Is(let#7#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#7#0#0;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#6 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    goto anon176_Then, anon176_Else;

  anon176_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#4_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#4_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](394,75)"} true;
    assume true;
    assume true;
    assume false;
    goto anon110;

  anon176_Else:
    goto anon110;

  anon110:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](395,10)"} true;
    havoc bracketed#Z#0;
    assume $Is(bracketed#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(bracketed#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    ##cs#2 := cs0#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##open#1 := open#0;
    assume $IsAlloc(##open#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    ##elems#3 := elems'#Z#0;
    assume $IsAlloc(##elems#3, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##close#0 := sep#Z#2;
    assume $IsAlloc(##close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) || (forall idx#0: int :: { $Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) - 1));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#1)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#1)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#1)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#36#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#39#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#3)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##close#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##close#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#3)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##close#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##close#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#42#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#43#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#3)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#44#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##close#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##close#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#47#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#Z#0, sep#Z#2));
    assume let#8#0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume $Is(let#8#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume bracketed#Z#0 == let#8#0#0;
    assume $IsAllocBox($Box(bracketed#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#7 := cs0#0;
    assume $IsAlloc(##cs0#7, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](397,65)"} true;
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0) == #Wrappers.Result.Success($Box(bracketed#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon150_Else:
    assume {:partition} !(s0#Z#0 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1));
    havoc separator#Z#0;
    assume LitInt(0) <= separator#Z#0 && separator#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#9#0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume true;
    assume $Is(let#9#0#0, Tclass.BoundedInts.uint8());
    assume separator#Z#0 == let#9#0#0;
    havoc pr#Z#0;
    assume $Is(pr#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(pr#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume let#10#0#0 == #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#Z#0)), s0#Z#0)));
    assume true;
    assume $Is(let#10#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume pr#Z#0 == let#10#0#0;
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0) == pr#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon112:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#0) == pr#3;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser();
  modifies $Heap;
  free ensures JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
  free ensures {:id "id27039"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())) && JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())) && (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
  free ensures {:id "id27040"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())) ==> JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())) || (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType)): DatatypeType, cs'#1, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var cs'#0_0_0: DatatypeType;
  var ##cs#0_0_0: DatatypeType;
  var ##cs#0_0_1: DatatypeType;
  var ##cs0#0_0_0: DatatypeType;
  var ##spec#0_0_0: HandleType;
  var ##cs#0_0_2: DatatypeType;
  var ##cs#0_0_0_0: DatatypeType;
  var ##cs0#0_0_0_0: DatatypeType;
  var ##spec#0_0_0_0: HandleType;
  var ##cs#0_0_0_0_0: DatatypeType;
  var ##cs#0_0_0_0_1: DatatypeType;
  var ##cs0#0_0_0_0_0: DatatypeType;
  var ##spec#0_0_0_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](407,4): initial state"} true;
    $_reverifyPost := false;
    assume 2 != $FunctionContextHeight;
    assume $IsAllocBox($Box(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    havoc cs'#0_0_0;
    assume $Is(cs'#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume true;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    ##cs#0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    ##cs#0_0_1 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##cs0#0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    goto anon5;

  anon20_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    goto anon5;

  anon5:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    assume false;
    goto anon6;

  anon19_Else:
    goto anon6;

  anon6:
    ##cs#0_0_2 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    ##cs#0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##cs0#0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    goto anon22_Then, anon22_Else;

  anon22_Then:
    ##cs#0_0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    ##cs#0_0_0_0_1 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap);
    ##cs0#0_0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0_0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    goto anon10;

  anon23_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    goto anon10;

  anon10:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](412,100)"} true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon11;

  anon22_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](413,12)"} true;
    goto anon13;

  anon21_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0));
    goto anon13;

  anon13:
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs'#0_0_0))));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs'#0_0_0)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs'#0_0_0)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs'#0_0_0), Seq#Append($Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_0))): DatatypeType)))));
    assume false;
    goto anon15;

  anon18_Else:
    assume (forall cs'#0_0_1: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_1) } $Is(cs'#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && Lit(true) ==> Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_1)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close, cs'#0_0_1))): DatatypeType, cs'#0_0_1, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
    goto anon15;

  anon15:
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](415,8)"} true;
    assume true;
    assume false;
    goto anon16;

  anon17_Else:
    goto anon16;

  anon16:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](416,6)"} true;
    return;
}



function JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var open#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#0) && (var elems#0 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#0)); JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#0)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#0), p#0) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#0), p#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (var close#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#0, elems#0)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#0) else (var open#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (var elems#0 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#0)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#0), p#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#0) else (var close#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#0, elems#0, close#0))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#0, elems#0)))))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var open#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#1) && (var elems#1 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#1)); JSON_mUtils_mCursors.Split.SP_q(open#1) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#1)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#1), p#1) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#1), p#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (var close#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), open#1, elems#1, close#1)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#1, elems#1)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#1) else (var open#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (var elems#1 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#1)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#1), p#1); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#1) else (var close#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs#0), open#1, elems#1, close#1))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs#0), Lit(json#0), open#1, elems#1)))))));
}

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#requires(DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#requires(cs#0, json#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

function JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Bracketed (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id27055"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)));
  free ensures {:id "id27056"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
  free ensures {:id "id27057"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
  free ensures {:id "id27058"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
  free ensures {:id "id27059"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Bracketed (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##parser#0: DatatypeType;
  var open#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var elems#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var p#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var ##parser#1: DatatypeType;
  var close#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##open#0: DatatypeType;
  var ##elems#0: DatatypeType;
  var ##close#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##json#0: DatatypeType;
  var ##open#1: DatatypeType;
  var ##elems#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Bracketed", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](419,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    goto anon5;

  anon17_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon16_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen()), Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen());
    assume $IsAlloc(##parser#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen()));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen()));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen()));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc open#Z#0;
    assume $Is(open#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())));
    assume open#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](425,48)"} true;
    havoc elems#Z#0;
    assume $Is(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume let#2#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems#Z#0 == let#2#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#Z#0)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    havoc p#Z#0;
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume 2 != $FunctionContextHeight;
    assume let#3#0#0 == #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose());
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError()));
    assume p#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(p#Z#0), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    call CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser();
    call CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser();
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](430,28)"} true;
    assume true;
    assume false;
    goto anon11;

  anon20_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](431,8)"} true;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(open#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#1 := p#Z#0;
    assume $IsAlloc(##parser#1, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)));
    assume (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume let#4#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon21_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc close#Z#0;
    assume $Is(close#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())));
    assume close#Z#0 == let#5#0#0;
    ##cs#2 := cs#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##open#0 := open#Z#0;
    assume $IsAlloc(##open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    ##elems#0 := elems#Z#0;
    assume $IsAlloc(##elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##close#0 := close#Z#0;
    assume $IsAlloc(##close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap);
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) || (forall idx#0: int :: { $Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) - 1));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#0)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##close#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##close#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##close#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##close#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##close#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##close#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#Z#0, elems#Z#0, close#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#Z#0, elems#Z#0, close#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0) == #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#Z#0, elems#Z#0, close#Z#0)));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#Z#0, elems#Z#0, close#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon19_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#Z#0)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##open#1 := open#Z#0;
    assume $IsAlloc(##open#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap);
    ##elems#1 := elems#Z#0;
    assume $IsAlloc(##elems#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#1)), JSON_mUtils_mCursors.Cursor__.s(##cs0#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#1)) > JSON_mUtils_mCursors.Cursor__.beg(##cs0#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#1)) == JSON_mUtils_mCursors.Cursor__.end(##cs0#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#1), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#Z#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0) == JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#Z#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#Z#0, elems#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon15:
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##c#1: int;
  var ##s#0: Seq;
  var pf#0: DatatypeType;
  var ##c#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](438,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](439,25): post-state"} true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    assume $IsAllocBox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    assume $IsAllocBox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume $IsAlloc(##c#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    ##s#0 := JSON_mGrammar.Bracketed.data(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0));
    havoc pf#0;
    assume $Is(pf#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(pf#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume $IsAlloc(##c#2, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    goto anon6;

  anon8_Else:
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    goto anon6;

  anon7_Else:
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    goto anon6;

  anon6:
    assume (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));
  modifies $Heap;
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
  free ensures {:id "id27139"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
  free ensures {:id "id27140"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0));
  free ensures {:id "id27141"} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0)) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0)) && (forall idx#0: int :: { $Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#0)): DatatypeType)) <==> idx#0 == Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) - 1));
  free ensures (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(x#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()))));
  free ensures {:id "id27142"} (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
  free ensures {:id "id27143"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
  free ensures {:id "id27144"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0));
  free ensures {:id "id27145"} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0)) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), JSON_mGrammar.Bracketed.data(x#0)) || (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#1)): DatatypeType } LitInt(0) <= idx#1 && idx#1 < Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#1)): DatatypeType)) <==> idx#1 == Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) - 1));
  free ensures (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(x#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()))));
  free ensures {:id "id27146"} $_reverifyPost ==> (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var xlt#0: DatatypeType where $Is(xlt#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) && $IsAlloc(xlt#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Heap);
  var xrt#0: DatatypeType where $Is(xrt#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) && $IsAlloc(xrt#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Heap);
  var pf#0_0: DatatypeType;
  var ##c#0_0: int;
  var xtt#0_0_0: DatatypeType where $Is(xtt#0_0_0, Tclass.JSON_mGrammar.jcomma()) && $IsAlloc(xtt#0_0_0, Tclass.JSON_mGrammar.jcomma(), $Heap);

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](444,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    xlt#0 := $Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](445,29)"} true;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    xrt#0 := $Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](446,30)"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc pf#0_0;
    assume $Is(pf#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    goto anon4;

  anon13_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    goto anon4;

  anon4:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()));
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR());
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume true;
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    xtt#0_0_0 := $Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](451,34)"} true;
    goto anon8;

  anon14_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    goto anon8;

  anon8:
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR())));
    assume false;
    goto anon10;

  anon11_Else:
    assume (forall pf#0_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#0_1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_1)) } $Is(pf#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR()));
    goto anon10;

  anon10:
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](453,6)"} true;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Open (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Open();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Open (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Open();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Open (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Open();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Close (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Close();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Close (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Close();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Close (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Close();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_BracketedFromParts (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__BracketedFromParts();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_BracketedFromParts (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__BracketedFromParts();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_BracketedFromParts (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__BracketedFromParts();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_AppendWithSuffix (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__AppendWithSuffix();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_AppendWithSuffix (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__AppendWithSuffix();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_AppendWithSuffix (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__AppendWithSuffix();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_AppendLast (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__AppendLast();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_AppendLast (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__AppendLast();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_AppendLast (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__AppendLast();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Elements (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Elements();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Elements (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Elements();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Elements (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Elements();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Bracketed (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Bracketed();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Bracketed (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Bracketed();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Bracketed (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Bracketed();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Object (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Object();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Object (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Object();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.reveal_Object (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.reveal__Object();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.jopen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.jopen(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.jopen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.jopen(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.jopen", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](126,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(v#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    return;

  anon4_Else:
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN())));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()))));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN())));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()))) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN())))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN())));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Objects.jclose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.jclose(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Objects.jclose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mObjects.jclose(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.jclose", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Objects](127,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(v#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    return;

  anon4_Else:
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()))));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()))) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#240 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#240))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#242 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#242)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#360 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#360))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#362 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#362)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#364 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#364)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#360 := Wrappers.Option.value(this); v#360)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#362 := Lit(Wrappers.Option.value(Lit(this))); v#362)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#364 := Lit(Wrappers.Option.value(Lit(this))); v#364)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#240 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#240)) else (var e#240 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#242 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#242))) else (var e#242 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#360 := Wrappers.Result.value(this); s#360) else (var e#360 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#362 := Lit(Wrappers.Result.value(Lit(this))); s#362) else (var e#362 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#364 := Lit(Wrappers.Result.value(Lit(this))); s#364) else (var e#364 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#360 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#360)) else (var e#360 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#360)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#362 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#362))) else (var e#362 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#362)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#364 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#364))) else (var e#364 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#364)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#156: int, y#156: int :: { Mul(x#156, y#156) } Mul(x#156, y#156) == Mul(y#156, x#156)) && (forall x#157: int, y#157: int, z#104: int :: { Mul(x#157 + y#157, z#104) } Mul(x#157 + y#157, z#104) == Mul(x#157, z#104) + Mul(y#157, z#104)) && (forall x#158: int, y#158: int, z#105: int :: { Mul(x#158 - y#158, z#105) } Mul(x#158 - y#158, z#105) == Mul(x#158, z#105) - Mul(y#158, z#105));

axiom MulInternals.__default.MulAuto() <==> (forall x#159: int, y#159: int :: { Mul(x#159, y#159) } Mul(x#159, y#159) == Mul(y#159, x#159)) && (forall x#160: int, y#160: int, z#106: int :: { Mul(x#160 + y#160, z#106) } Mul(x#160 + y#160, z#106) == Mul(x#160, z#106) + Mul(y#160, z#106)) && (forall x#161: int, y#161: int, z#107: int :: { Mul(x#161 - y#161, z#107) } Mul(x#161 - y#161, z#107) == Mul(x#161, z#107) - Mul(y#161, z#107));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#192: int :: { Mod(Mod(x#192, n#0), n#0) } Mod(Mod(x#192, n#0), n#0) == Mod(x#192, n#0)) && (forall x#193: int :: { Mod(x#193, n#0) } LitInt(0) <= x#193 && x#193 < n#0 <==> Mod(x#193, n#0) == x#193) && (forall x#194: int, y#96: int :: { Mod(x#194 + y#96, n#0) } (var z#94 := Mod(x#194, n#0) + Mod(y#96, n#0); (LitInt(0) <= z#94 && z#94 < n#0 && Mod(x#194 + y#96, n#0) == z#94) || (n#0 <= z#94 && z#94 < n#0 + n#0 && Mod(x#194 + y#96, n#0) == z#94 - n#0))) && (forall x#195: int, y#97: int :: { Mod(x#195 - y#97, n#0) } (var z#95 := Mod(x#195, n#0) - Mod(y#97, n#0); (LitInt(0) <= z#95 && z#95 < n#0 && Mod(x#195 - y#97, n#0) == z#95) || (0 - n#0 <= z#95 && z#95 < 0 && Mod(x#195 - y#97, n#0) == z#95 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#196: int :: { Mod(Mod(x#196, n#0), n#0) } Mod(Mod(x#196, LitInt(n#0)), LitInt(n#0)) == Mod(x#196, LitInt(n#0))) && (forall x#197: int :: { Mod(x#197, n#0) } LitInt(0) <= x#197 && x#197 < n#0 <==> Mod(x#197, LitInt(n#0)) == x#197) && (forall x#198: int, y#98: int :: { Mod(x#198 + y#98, n#0) } (var z#96 := Mod(x#198, LitInt(n#0)) + Mod(y#98, LitInt(n#0)); (LitInt(0) <= z#96 && z#96 < n#0 && Mod(x#198 + y#98, LitInt(n#0)) == z#96) || (LitInt(n#0) <= z#96 && z#96 < n#0 + n#0 && Mod(x#198 + y#98, LitInt(n#0)) == z#96 - n#0))) && (forall x#199: int, y#99: int :: { Mod(x#199 - y#99, n#0) } (var z#97 := Mod(x#199, LitInt(n#0)) - Mod(y#99, LitInt(n#0)); (LitInt(0) <= z#97 && z#97 < n#0 && Mod(x#199 - y#99, LitInt(n#0)) == z#97) || (LitInt(0 - n#0) <= z#97 && z#97 < 0 && Mod(x#199 - y#99, LitInt(n#0)) == z#97 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#138: int :: { Div(x#138, n#0) } LitInt(0) <= x#138 && x#138 < n#0 <==> Div(x#138, n#0) == LitInt(0)) && (forall x#139: int, y#92: int :: { Div(x#139 + y#92, n#0) } (var z#90 := Mod(x#139, n#0) + Mod(y#92, n#0); (LitInt(0) <= z#90 && z#90 < n#0 && Div(x#139 + y#92, n#0) == Div(x#139, n#0) + Div(y#92, n#0)) || (n#0 <= z#90 && z#90 < n#0 + n#0 && Div(x#139 + y#92, n#0) == Div(x#139, n#0) + Div(y#92, n#0) + 1))) && (forall x#140: int, y#93: int :: { Div(x#140 - y#93, n#0) } (var z#91 := Mod(x#140, n#0) - Mod(y#93, n#0); (LitInt(0) <= z#91 && z#91 < n#0 && Div(x#140 - y#93, n#0) == Div(x#140, n#0) - Div(y#93, n#0)) || (0 - n#0 <= z#91 && z#91 < 0 && Div(x#140 - y#93, n#0) == Div(x#140, n#0) - Div(y#93, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#141: int :: { Div(x#141, n#0) } LitInt(0) <= x#141 && x#141 < n#0 <==> Div(x#141, LitInt(n#0)) == LitInt(0)) && (forall x#142: int, y#94: int :: { Div(x#142 + y#94, n#0) } (var z#92 := Mod(x#142, LitInt(n#0)) + Mod(y#94, LitInt(n#0)); (LitInt(0) <= z#92 && z#92 < n#0 && Div(x#142 + y#94, LitInt(n#0)) == Div(x#142, LitInt(n#0)) + Div(y#94, LitInt(n#0))) || (LitInt(n#0) <= z#92 && z#92 < n#0 + n#0 && Div(x#142 + y#94, LitInt(n#0)) == Div(x#142, LitInt(n#0)) + Div(y#94, LitInt(n#0)) + 1))) && (forall x#143: int, y#95: int :: { Div(x#143 - y#95, n#0) } (var z#93 := Mod(x#143, LitInt(n#0)) - Mod(y#95, LitInt(n#0)); (LitInt(0) <= z#93 && z#93 < n#0 && Div(x#143 - y#95, LitInt(n#0)) == Div(x#143, LitInt(n#0)) - Div(y#95, LitInt(n#0))) || (LitInt(0 - n#0) <= z#93 && z#93 < 0 && Div(x#143 - y#95, LitInt(n#0)) == Div(x#143, LitInt(n#0)) - Div(y#95, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#34 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#34) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#34)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#34 := lv#0; (var dt_update#end#0#34 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#34), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#34), dt_update#end#0#34))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#35 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#35) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#35)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#35 := Lit(lv#0); (var dt_update#end#0#35 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#35)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#35)), dt_update#end#0#35)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#36: char :: { Seq#Contains(s#0, $Box(c#36)) } $Is(c#36, TChar) && Seq#Contains(s#0, $Box(c#36)) ==> char#ToInt(c#36) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#36: char :: { Seq#Contains(s#0, $Box(c#36)) } $Is(c#36, TChar) && Seq#Contains(s#0, $Box(c#36)) ==> char#ToInt(c#36) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#72#i#0): int)): char))), (lambda $l#72#heap#0: Heap, $l#72#i#0: Box :: $IsBox($l#72#i#0, TInt) && LitInt(0) <= $Unbox($l#72#i#0): int && $Unbox($l#72#i#0): int < Seq#Length(s#0)), (lambda $l#72#heap#0: Heap, $l#72#i#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#37: char :: { Seq#Contains(s#0, $Box(c#37)) } $Is(c#37, TChar) && Seq#Contains(s#0, $Box(c#37)) ==> char#ToInt(c#37) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#74#i#0): int)): char))), (lambda $l#74#heap#0: Heap, $l#74#i#0: Box :: $IsBox($l#74#i#0, TInt) && LitInt(0) <= $Unbox($l#74#i#0): int && $Unbox($l#74#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#74#heap#0: Heap, $l#74#i#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#12 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#12))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#12 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#14 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#14))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#14 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#108 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#54 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#108 := (if b#108 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#108)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#54)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#108)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#109 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#54 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#109 := (if b#109 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#109)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#54 := Seq#Create(TChar, $Heap, Seq#Length(bs0#54), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#54, $Unbox($l#85#idx#0): int)): int))), (lambda $l#85#heap#0: Heap, $l#85#idx#0: Box :: $IsBox($l#85#idx#0, TInt) && LitInt(0) <= $Unbox($l#85#idx#0): int && $Unbox($l#85#idx#0): int < Seq#Length(bs0#54)), (lambda $l#85#heap#0: Heap, $l#85#idx#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#54), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#109))))) else (var err#54 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#54)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#112 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#56 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#112 := (if b#112 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#112)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#56)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#112)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#113 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#56 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#113 := (if b#113 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#113)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#56 := Seq#Create(TChar, $Heap, Seq#Length(bs0#56), Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#56, $Unbox($l#88#idx#0): int)): int))), (lambda $l#88#heap#0: Heap, $l#88#idx#0: Box :: $IsBox($l#88#idx#0, TInt) && LitInt(0) <= $Unbox($l#88#idx#0): int && $Unbox($l#88#idx#0): int < Seq#Length(bs0#56)), (lambda $l#88#heap#0: Heap, $l#88#idx#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#56), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#113))))) else (var err#56 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#56)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#116 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#58 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#116 := (if b#116 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#116)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#58)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#116)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#117 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#58 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#117 := (if b#117 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#117)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#58 := Seq#Create(TChar, $Heap, Seq#Length(bs0#58), Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#58, $Unbox($l#91#idx#0): int)): int))), (lambda $l#91#heap#0: Heap, $l#91#idx#0: Box :: $IsBox($l#91#idx#0, TInt) && LitInt(0) <= $Unbox($l#91#idx#0): int && $Unbox($l#91#idx#0): int < Seq#Length(bs0#58)), (lambda $l#91#heap#0: Heap, $l#91#idx#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#58), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#117))))) else (var err#58 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#58)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#11: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#11)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#11)): int } LitInt(0) <= idx#11 && idx#11 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#11 && idx#11 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#11)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#11)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#18 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#18 := this; (var dt_update#beg#0#18 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#18), dt_update#beg#0#18, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#18), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#18)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#19 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#19 := Lit(this); (var dt_update#beg#0#19 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#19)), dt_update#beg#0#19, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#19)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#19)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#63#v#0): DatatypeType))), (lambda $l#63#heap#0: Heap, $l#63#v#0: Box :: $IsBox($l#63#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#63#heap#0: Heap, $l#63#v#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#64#v#0): DatatypeType))), (lambda $l#64#heap#0: Heap, $l#64#v#0: Box :: $IsBox($l#64#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#64#heap#0: Heap, $l#64#v#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#65#v#0): DatatypeType))), (lambda $l#65#heap#0: Heap, $l#65#v#0: Box :: $IsBox($l#65#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#65#heap#0: Heap, $l#65#v#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#18 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#18 := this; (var dt_update#point#0#18 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#18), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#18), dt_update#point#0#18, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#18)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#19 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#19 := Lit(this); (var dt_update#point#0#19 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#19)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#19)), dt_update#point#0#19, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#19)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#18 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#18)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#18 := this; (var dt_update#point#0#18 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#18), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#18), dt_update#point#0#18, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#18)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#19 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#19)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#19 := Lit(this); (var dt_update#point#0#19 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#19)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#19)), dt_update#point#0#19, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#19)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#18 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#18 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#18 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#18 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#18))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#19 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#19 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#19 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#19 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#19)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#30: int :: { Seq#Contains(bs#0, $Box(b#30)) } LitInt(0) <= b#30 && b#30 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#30)) ==> b#30 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#30: int :: { Seq#Contains(bs#0, $Box(b#30)) } LitInt(0) <= b#30 && b#30 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#30)) ==> b#30 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#27 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#27)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27) && (var ps#27 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#27, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#27 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#27) else (var ps#27 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#27)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#27, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#31: int :: { Seq#Contains(bs#0, $Box(b#31)) } LitInt(0) <= b#31 && b#31 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#31)) ==> b#31 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#28 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#28)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28) && (var ps#28 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#28, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#28 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#28) else (var ps#28 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#28)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#28, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#32: int :: { Seq#Contains(bs#0, $Box(b#32)) } LitInt(0) <= b#32 && b#32 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#32)) ==> b#32 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#29 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#29)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29) && (var ps#29 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#29, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#29 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#29) else (var ps#29 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#29)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#29, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#11: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#11)): int } LitInt(0) <= idx#11 && idx#11 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#11 && idx#11 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#11)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#56 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#56)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#55 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#55)))) else (var st#55 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#55))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#58 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#58)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#57 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#57)))) else (var st#57 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#57))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#60 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#60)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#59 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#59)))) else (var st#59 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#59))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#72#heap#0: Heap, $l#72#_v0#0: Box :: $IsBox($l#72#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#72#heap#0: Heap, $l#72#_v0#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#73#heap#0: Heap, $l#73#_v1#0: Box :: $IsBox($l#73#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#73#heap#0: Heap, $l#73#_v1#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#76#heap#0: Heap, $l#76#_v0#0: Box :: $IsBox($l#76#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#76#heap#0: Heap, $l#76#_v0#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#77#heap#0: Heap, $l#77#_v1#0: Box :: $IsBox($l#77#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#77#heap#0: Heap, $l#77#_v1#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#108#ly#0: LayerType :: Handle1((lambda $l#108#heap#0: Heap, $l#108#cs#0: Box :: $Box(Lit(false))), (lambda $l#108#heap#0: Heap, $l#108#cs#0: Box :: $IsBox($l#108#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#108#heap#0: Heap, $l#108#cs#0: Box :: SetRef_to_SetBox((lambda $l#108#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#109#ly#0: LayerType :: Handle1((lambda $l#109#heap#0: Heap, $l#109#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#109#heap#0: Heap, $l#109#cs#0: Box :: $IsBox($l#109#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#109#heap#0: Heap, $l#109#cs#0: Box :: SetRef_to_SetBox((lambda $l#109#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#110#ly#0: LayerType :: Handle1((lambda $l#110#heap#0: Heap, $l#110#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#110#heap#0: Heap, $l#110#_v2#0: Box :: $IsBox($l#110#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#110#heap#0: Heap, $l#110#_v2#0: Box :: SetRef_to_SetBox((lambda $l#110#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#114#ly#0: LayerType :: Handle1((lambda $l#114#heap#0: Heap, $l#114#cs#0: Box :: $Box(Lit(false))), (lambda $l#114#heap#0: Heap, $l#114#cs#0: Box :: $IsBox($l#114#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#114#heap#0: Heap, $l#114#cs#0: Box :: SetRef_to_SetBox((lambda $l#114#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#115#ly#0: LayerType :: Handle1((lambda $l#115#heap#0: Heap, $l#115#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#115#heap#0: Heap, $l#115#cs#0: Box :: $IsBox($l#115#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#115#heap#0: Heap, $l#115#cs#0: Box :: SetRef_to_SetBox((lambda $l#115#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#116#ly#0: LayerType :: Handle1((lambda $l#116#heap#0: Heap, $l#116#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#116#heap#0: Heap, $l#116#_v2#0: Box :: $IsBox($l#116#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#116#heap#0: Heap, $l#116#_v2#0: Box :: SetRef_to_SetBox((lambda $l#116#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#18: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#18))): DatatypeType } $Is(cs'#18, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#18))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#18))): DatatypeType)): DatatypeType, cs'#18, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#18: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#18))): DatatypeType } $Is(cs'#18, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#18))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#18))): DatatypeType)): DatatypeType, cs'#18, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#19: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#19))): DatatypeType } $Is(cs'#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#19))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#19))): DatatypeType)): DatatypeType, cs'#19, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#19: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#19))): DatatypeType } $Is(cs'#19, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#19))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#19))): DatatypeType)): DatatypeType, cs'#19, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#54: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#54)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#54))): bool } $Is(cs'#54, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#54))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#54)))) && ((forall cs'#54: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#54)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#54))): bool } $Is(cs'#54, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#54))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#54))) ==> (forall cs'#55: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#55))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#55, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#55: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#55))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#55, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#55))): bool) ==> (forall cs'#56: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#56))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#56))): bool } $Is(cs'#56, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#56))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#56))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#56))): DatatypeType)): DatatypeType, cs'#56, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#54: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#54)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#54))): bool } $Is(cs'#54, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#54))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#54))) && (forall cs'#55: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#55))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#55, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#55, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#55))): bool) && (forall cs'#56: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#56))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#56))): bool } $Is(cs'#56, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#56))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#56))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#56))): DatatypeType)): DatatypeType, cs'#56, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#57: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#57)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#57))): bool } $Is(cs'#57, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#57))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#57)))) && ((forall cs'#57: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#57)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#57))): bool } $Is(cs'#57, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#57))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#57))) ==> (forall cs'#58: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#58))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#58, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#58, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#58, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#58, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#58: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#58))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#58, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#58, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#58, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#58))): bool) ==> (forall cs'#59: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#59))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#59))): bool } $Is(cs'#59, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#59))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#59))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#59))): DatatypeType)): DatatypeType, cs'#59, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#57: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#57)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#57))): bool } $Is(cs'#57, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#57))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#57))) && (forall cs'#58: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#58))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#58, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#58, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#58, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#58))): bool) && (forall cs'#59: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#59))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#59))): bool } $Is(cs'#59, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#59))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#59))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#59))): DatatypeType)): DatatypeType, cs'#59, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#16: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#16)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#16)) ==> LitInt(0) <= d#16 && d#16 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#42 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#43 := Seq#Append(digits'#42, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#43))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#43 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#44 := Seq#Append(digits'#43, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#44))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#44 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#45 := Seq#Append(digits'#44, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#45))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#16: Box :: { Seq#Contains(chars#0, c#16) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#16) } $IsBox(c#16, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#16) ==> Seq#Contains(chars#0, c#16)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#33: int :: { Seq#Contains(digits#0, $Box(d#33)) } Seq#Contains(digits#0, $Box(d#33)) ==> LitInt(0) <= d#33 && d#33 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#33: int :: { Seq#Contains(digits#0, $Box(d#33)) } Seq#Contains(digits#0, $Box(d#33)) ==> LitInt(0) <= d#33 && d#33 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#34: int :: { Seq#Contains(digits#0, $Box(d#34)) } Seq#Contains(digits#0, $Box(d#34)) ==> LitInt(0) <= d#34 && d#34 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#16: Box :: { Seq#Contains(chars#0, c#16) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#16) } $IsBox(c#16, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#16) ==> Seq#Contains(chars#0, c#16)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#28 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#28) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#28), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#28 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#28), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#29 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#29) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#29), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#29 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#29), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#44: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#44)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#44) } $IsBox(c#44, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#44) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#44)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#45: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#45)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#45) } $IsBox(c#45, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#45) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#45)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#46: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#46)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#46) } $IsBox(c#46, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#46) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#46)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(Seq#Contains(chars#0, $l#20#c#0))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#31: Box :: { Map#Domain(digits#0)[c#31] } { Seq#Contains(str#0, c#31) } $IsBox(c#31, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#31) ==> Map#Domain(digits#0)[c#31])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#31: Box :: { Map#Domain(digits#0)[c#31] } { Seq#Contains(str#0, c#31) } $IsBox(c#31, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#31) ==> Map#Domain(digits#0)[c#31])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#32: Box :: { Map#Domain(digits#0)[c#32] } { Seq#Contains(str#0, c#32) } $IsBox(c#32, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#32) ==> Map#Domain(digits#0)[c#32])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(Map#Domain(digits#0)[$l#61#c#0])), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(Map#Domain(digits#0)[$l#61#c#0])), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(Map#Domain(digits#0)[$l#62#c#0])), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(Map#Domain(digits#0)[$l#63#c#0])), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#42 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#42) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#42) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#42)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#42) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#42)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#42 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#42) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#42) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#42)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#42) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#42))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#42 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#42) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#42) else (var tl#84 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#42)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#84)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#42 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#42) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#42) else (var tl#85 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#42)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#85)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#43 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#43) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#43) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#43)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#43) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#43)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#43 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#43) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#43) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#43)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#43) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#43))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#43 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#43) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#43) else (var tl#86 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#43)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#86)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#43 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#43) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#43) else (var tl#87 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#43)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#87)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#44 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#44) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#44) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#44)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#44) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#44)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#44 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#44) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#44) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#44)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#44) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#44))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#44 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#44) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#44) else (var tl#88 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#44)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#88)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#44 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#44) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#44) else (var tl#89 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#44)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#89)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#16: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#16)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#16)) ==> LitInt(0) <= d#16 && d#16 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#42 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#43 := Seq#Append(digits'#42, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#43))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#43 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#44 := Seq#Append(digits'#43, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#44))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#44 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#45 := Seq#Append(digits'#44, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#45))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#16: char :: { Seq#Contains(chars#0, $Box(c#16)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#16)) ==> Seq#Contains(chars#0, $Box(c#16))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#33: int :: { Seq#Contains(digits#0, $Box(d#33)) } Seq#Contains(digits#0, $Box(d#33)) ==> LitInt(0) <= d#33 && d#33 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#33: int :: { Seq#Contains(digits#0, $Box(d#33)) } Seq#Contains(digits#0, $Box(d#33)) ==> LitInt(0) <= d#33 && d#33 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#34: int :: { Seq#Contains(digits#0, $Box(d#34)) } Seq#Contains(digits#0, $Box(d#34)) ==> LitInt(0) <= d#34 && d#34 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#16: char :: { Seq#Contains(chars#0, $Box(c#16)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#16)) ==> Seq#Contains(chars#0, $Box(c#16))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#28 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#28) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#28), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#28 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#28), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#29 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#29) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#29), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#29 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#29), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#44: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#44))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#44)) } $Is(c#44, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#44)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#44))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#45: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#45))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#45)) } $Is(c#45, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#45)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#45))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#46: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#46))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#46)) } $Is(c#46, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#46)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#46))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(Seq#Contains(chars#0, $l#20#c#0))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, TChar)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#31: char :: { Map#Domain(digits#0)[$Box(c#31)] } { Seq#Contains(str#0, $Box(c#31)) } $Is(c#31, TChar) && Seq#Contains(str#0, $Box(c#31)) ==> Map#Domain(digits#0)[$Box(c#31)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#31: char :: { Map#Domain(digits#0)[$Box(c#31)] } { Seq#Contains(str#0, $Box(c#31)) } $Is(c#31, TChar) && Seq#Contains(str#0, $Box(c#31)) ==> Map#Domain(digits#0)[$Box(c#31)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#32: char :: { Map#Domain(digits#0)[$Box(c#32)] } { Seq#Contains(str#0, $Box(c#32)) } $Is(c#32, TChar) && Seq#Contains(str#0, $Box(c#32)) ==> Map#Domain(digits#0)[$Box(c#32)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(Map#Domain(digits#0)[$l#61#c#0])), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, TChar)), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(Map#Domain(digits#0)[$l#61#c#0])), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, TChar)), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(Map#Domain(digits#0)[$l#62#c#0])), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, TChar)), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(Map#Domain(digits#0)[$l#63#c#0])), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, TChar)), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#42 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#42) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#42) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#42)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#42) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#42)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#42 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#42) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#42) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#42)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#42) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#42))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#42 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#42) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#42) else (var tl#84 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#42)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#84)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#42 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#42) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#42) else (var tl#85 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#42)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#85)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#43 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#43) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#43) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#43)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#43) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#43)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#43 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#43) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#43) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#43)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#43) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#43))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#43 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#43) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#43) else (var tl#86 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#43)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#86)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#43 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#43) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#43) else (var tl#87 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#43)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#87)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#44 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#44) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#44) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#44)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#44) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#44)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#44 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#44) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#44) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#44)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#44) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#44))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#44 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#44) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#44) else (var tl#88 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#44)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#88)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#44 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#44) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#44) else (var tl#89 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#44)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#89)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#15: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#15)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#15)) } $Is(c#15, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#15)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#15))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#18#c#0))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, TChar)), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#29: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)] } { Seq#Contains(str#0, $Box(c#29)) } $Is(c#29, TChar) && Seq#Contains(str#0, $Box(c#29)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#29: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)] } { Seq#Contains(str#0, $Box(c#29)) } $Is(c#29, TChar) && Seq#Contains(str#0, $Box(c#29)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#29)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#30: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#30)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#30)] } { Seq#Contains(str#0, $Box(c#30)) } $Is(c#30, TChar) && Seq#Contains(str#0, $Box(c#30)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#30)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#30)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#47#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#47#c#0]): int < base#0)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, TChar)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#47#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#47#c#0]): int < base#0)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, TChar)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#48#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#48#c#0]): int < base#0)), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, TChar)), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#48 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#48)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#96 := JSON_mErrors.DeserializationError.b(this); (var b0#48 := JSON_mErrors.DeserializationError.expected(this); (var c#96 := (if b#96 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#96)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#48)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#96)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#97 := JSON_mErrors.DeserializationError.b(this); (var bs0#48 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#97 := (if b#97 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#97)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#48 := Seq#Create(TChar, $Heap, Seq#Length(bs0#48), Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#48, $Unbox($l#76#idx#0): int)): int))), (lambda $l#76#heap#0: Heap, $l#76#idx#0: Box :: $IsBox($l#76#idx#0, TInt) && LitInt(0) <= $Unbox($l#76#idx#0): int && $Unbox($l#76#idx#0): int < Seq#Length(bs0#48)), (lambda $l#76#heap#0: Heap, $l#76#idx#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#48), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#97))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#50 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#50)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#100 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#50 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#100 := (if b#100 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#100)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#50)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#100)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#101 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#50 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#101 := (if b#101 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#101)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#50 := Seq#Create(TChar, $Heap, Seq#Length(bs0#50), Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#50, $Unbox($l#79#idx#0): int)): int))), (lambda $l#79#heap#0: Heap, $l#79#idx#0: Box :: $IsBox($l#79#idx#0, TInt) && LitInt(0) <= $Unbox($l#79#idx#0): int && $Unbox($l#79#idx#0): int < Seq#Length(bs0#50)), (lambda $l#79#heap#0: Heap, $l#79#idx#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#50), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#101))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#49 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#49, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#48 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#48, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#48 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#48)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#51 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#51, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#50 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#50, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#50 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#50)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#28: int :: { JSON_mGrammar.__default.Blank_q(b#28) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) } LitInt(0) <= b#28 && b#28 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#28))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#28: int :: { JSON_mGrammar.__default.Blank_q(b#28) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) } LitInt(0) <= b#28 && b#28 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) ==> JSON_mGrammar.__default.Blank_q(b#28))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#29: int :: { JSON_mGrammar.__default.Blank_q(b#29) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#29)) } LitInt(0) <= b#29 && b#29 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#29)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#29))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#29: int :: { JSON_mGrammar.__default.Blank_q(b#29) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#29)) } LitInt(0) <= b#29 && b#29 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#29)) ==> JSON_mGrammar.__default.Blank_q(b#29))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#28: int :: { $Unbox(Seq#Index(s#0, idx#28)): DatatypeType } LitInt(0) <= idx#28 && idx#28 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#28)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#28: int :: { $Unbox(Seq#Index(s#0, idx#28)): DatatypeType } LitInt(0) <= idx#28 && idx#28 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#28)): DatatypeType)) <==> idx#28 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#29: int :: { $Unbox(Seq#Index(s#0, idx#29)): DatatypeType } LitInt(0) <= idx#29 && idx#29 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#29)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#29: int :: { $Unbox(Seq#Index(s#0, idx#29)): DatatypeType } LitInt(0) <= idx#29 && idx#29 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#29)): DatatypeType)) <==> idx#29 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#28: int :: { JSON_mGrammar.__default.Digit_q(b#28) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) } LitInt(0) <= b#28 && b#28 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#28))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#28: int :: { JSON_mGrammar.__default.Digit_q(b#28) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) } LitInt(0) <= b#28 && b#28 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#28)) ==> JSON_mGrammar.__default.Digit_q(b#28))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#29: int :: { JSON_mGrammar.__default.Digit_q(b#29) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#29)) } LitInt(0) <= b#29 && b#29 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#29)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#29))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#29: int :: { JSON_mGrammar.__default.Digit_q(b#29) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#29)) } LitInt(0) <= b#29 && b#29 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#29)) ==> JSON_mGrammar.__default.Digit_q(b#29))));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$10x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$10x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$10x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$10x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$10x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$10x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$10x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$10x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$10x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$10x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$10x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$10x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$10x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#33: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#33) } { Seq#Contains(ts#0, d#33) } $IsBox(d#33, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#33) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#33))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#33: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#33) } { Seq#Contains(ts#0, d#33) } $IsBox(d#33, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#33) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#33))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#34: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#34) } { Seq#Contains(ts#0, d#34) } $IsBox(d#34, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#34) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#34))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#35: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#35) } { Seq#Contains(ts#0, d#35) } $IsBox(d#35, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#35) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#35))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#33: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#33)) } $Is(d#33, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#33) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#33)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#33: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#33)) } $Is(d#33, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#33) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#33)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#34: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#34)) } $Is(d#34, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#34) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#34)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#35: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#35)) } $Is(d#35, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#35) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#35)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$10x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$10x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$10x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$10x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$10x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$10x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$10x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$10x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$10x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$10x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$10x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$10x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$10x#0))): Seq);

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$10x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$10x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$10x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$10x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$10x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$10x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$10x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$10x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$10x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$10x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$10x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$10x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$10x#0))): Seq);

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$10x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$10x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$10x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$10x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$10x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$10x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$10x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$10x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$10x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$10x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$10x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$10x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$10x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#68#d#0: DatatypeType :: $Is($l#68#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#68#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#68#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#69#ly#0, $Unbox($l#69#d#0): DatatypeType))), (lambda $l#69#heap#0: Heap, $l#69#d#0: Box :: $IsBox($l#69#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#69#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#69#heap#0: Heap, $l#69#d#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#67#ly#0, $Unbox($l#67#d#0): DatatypeType))), (lambda $l#67#heap#0: Heap, $l#67#d#0: Box :: $IsBox($l#67#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#67#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#67#heap#0: Heap, $l#67#d#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#71#d#0: DatatypeType :: $Is($l#71#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#71#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#71#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#72#ly#0, $Unbox($l#72#d#0): DatatypeType))), (lambda $l#72#heap#0: Heap, $l#72#d#0: Box :: $IsBox($l#72#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#72#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#72#heap#0: Heap, $l#72#d#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#70#ly#0, $Unbox($l#70#d#0): DatatypeType))), (lambda $l#70#heap#0: Heap, $l#70#d#0: Box :: $IsBox($l#70#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#70#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#70#heap#0: Heap, $l#70#d#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#68#d#0: DatatypeType :: $Is($l#68#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#68#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#68#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#69#ly#0, $Unbox($l#69#d#0): DatatypeType))), (lambda $l#69#heap#0: Heap, $l#69#d#0: Box :: $IsBox($l#69#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#69#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#69#heap#0: Heap, $l#69#d#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#67#ly#0, $Unbox($l#67#d#0): DatatypeType))), (lambda $l#67#heap#0: Heap, $l#67#d#0: Box :: $IsBox($l#67#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#67#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#67#heap#0: Heap, $l#67#d#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#71#d#0: DatatypeType :: $Is($l#71#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#71#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#71#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#72#ly#0, $Unbox($l#72#d#0): DatatypeType))), (lambda $l#72#heap#0: Heap, $l#72#d#0: Box :: $IsBox($l#72#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#72#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#72#heap#0: Heap, $l#72#d#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#70#ly#0, $Unbox($l#70#d#0): DatatypeType))), (lambda $l#70#heap#0: Heap, $l#70#d#0: Box :: $IsBox($l#70#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#70#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#70#heap#0: Heap, $l#70#d#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#41 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#41))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#41 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#41))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#41 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#41))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#41 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#41))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#41 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#41))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#41 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#41))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#40 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#40)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#40 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#40)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#40 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#40)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#40 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#40)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#40 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#40)) else (var arr#40 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#40))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#43 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#43))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#43 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#43))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#43 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#43))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#43 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#43))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#43 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#43))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#43 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#43))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#42 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#42))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#42 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#42))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#42 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#42))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#42 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#42))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#42 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#42))) else (var arr#42 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#42)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$10x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$10x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$10x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$10x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$10x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$10x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$10x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$10x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$10x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$10x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$10x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$10x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$10x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$10x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$10x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#33: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#33)) } $Is(d#33, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#33) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#33))) && ((forall d#33: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#33)) } $Is(d#33, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#33) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#33))) ==> (forall d#34: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#34)) } $Is(d#34, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#34) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#34)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#33: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#33)) } $Is(d#33, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#33) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#33))) && (forall d#34: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#34)) } $Is(d#34, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#34) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#34))) && (forall d#35: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#35))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#35))): Seq } $Is(d#35, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#35) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#35))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#35))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#36: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#36)) } $Is(d#36, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#36) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#36))) && ((forall d#36: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#36)) } $Is(d#36, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#36) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#36))) ==> (forall d#37: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#37)) } $Is(d#37, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#37) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#37)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#36: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#36)) } $Is(d#36, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#36) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#36))) && (forall d#37: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#37)) } $Is(d#37, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#37) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#37))) && (forall d#38: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#38))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#38))): Seq } $Is(d#38, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#38) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#38))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#38))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#39: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#39)) } $Is(d#39, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#39) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#39))) && ((forall d#39: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#39)) } $Is(d#39, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#39) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#39))) ==> (forall d#40: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#40)) } $Is(d#40, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#40) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#40)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#39: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#39)) } $Is(d#39, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#39) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#39))) && (forall d#40: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#40)) } $Is(d#40, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#40) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#40))) && (forall d#41: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#41))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#41))): Seq } $Is(d#41, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#41) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#41))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#41))): Seq))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#14 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var cs#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#15)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#14 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#14) else (var cs#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#15)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#15 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var cs#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#16)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#15 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#15) else (var cs#16 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#16)))))))));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$7x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$7x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$7x#0): int)));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$7x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$7x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$7x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$7x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$7x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$7x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$7x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$7x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$7x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#13#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $IsBox($l#13#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#59: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#59)) } $Is(cs#59, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#59)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#59: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#59)) } $Is(cs#59, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#59)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#60 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#14 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#60))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var cs#61 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#61))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#14, cs#60 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#14 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#60))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#14) else (var val#14, cs#61 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType); (var after#14, cs#62 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#61))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#61)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#14, val#14, after#14)), cs#62)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#63: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#63)) } $Is(cs#63, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#63)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#64 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#15 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#64))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var cs#65 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#65))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#15, cs#64 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#15 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#64))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#15) else (var val#15, cs#65 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType); (var after#15, cs#66 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#65))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#65)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#15, val#15, after#15)), cs#66)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#12#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: $IsBox($l#12#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#12#heap#0: Heap, $l#12#st#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#43 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#43) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#43)) && (var cs#44 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#43))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#44))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#14, cs#43 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#14, cs#44 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#43)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#43))); (var after#14, cs#45 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#44))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#44)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#14, $Box(val#14), after#14)), cs#45)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#46 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#46) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#46)) && (var cs#47 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#46))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#47))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#15, cs#46 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#15, cs#47 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#46)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#46))); (var after#15, cs#48 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#47))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#47)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#15, $Box(val#15), after#15)), cs#48)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#16: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#16) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#16))): Seq } $Is(t#16, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#16)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#16: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#16) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#16))): Seq } $Is(t#16, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#16))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#16)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#17: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#17) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#17))): Seq } $Is(t#17, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#17)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#17: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#17) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#17))): Seq } $Is(t#17, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#17))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#17)))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$2x#0: Box, $fh$2x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$2x#0, $fh$2x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$2x#0, $fh$2x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$2x#0): bool, $Unbox($fh$2x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$2x#0: Box, $fh$2x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$2x#0, $fh$2x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$2x#0, $fh$2x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$2x#0): bool, $Unbox($fh$2x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$2x#0: Box, $fh$2x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$2x#0, $fh$2x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$2x#0, $fh$2x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$2x#0: bool, $fh$2x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$2x#0, $fh$2x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$2x#0, $fh$2x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$2x#0), $Box($fh$2x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#13 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#13) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#13); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (var contents#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#8) && (var cs#14 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#8)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#14) && (var valueOrError2#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#14); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#4) else (var lq#4, cs#13 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#13); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#4) else (var contents#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; (var contents#9, cs#14 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#8))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#8)); (var valueOrError2#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#14); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#4) else (var rq#4, cs#15 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#4, contents#9, rq#4)), cs#15))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#5 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#16 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#16) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#16); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (var contents#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#10) && (var cs#17 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#10)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#17) && (var valueOrError2#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#17); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#5 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#5) else (var lq#5, cs#16 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType)); (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#16); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#5) else (var contents#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; (var contents#11, cs#17 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#10))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#10)); (var valueOrError2#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#17); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#5) else (var rq#5, cs#18 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#5, contents#11, rq#5)), cs#18))))))))))))));

axiom $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jcolon(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#3 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#3));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#4 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#4));

axiom (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(t#0) || $Is(t#0, Tclass.JSON_mGrammar.jKeyValue()) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(t#0) || $Is(t#0, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(t#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(t#0) == JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), t#0));

axiom (forall t#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(Lit(t#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(Lit(t#0)) || $Is(t#0, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mConcreteSyntax_mSpec.__default.KeyValue#canCall(Lit(t#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(Lit(t#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.KeyValue($LS($LZ), Lit(t#0))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$1x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var k#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#3), p#3) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#3), p#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (var colon#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#3) && (var valueOrError2#3 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#3)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) && (var v#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#3, colon#3, v#3))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#3) else (var k#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#3), p#3); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#3) else (var colon#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; (var valueOrError2#3 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#3)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#3) else (var v#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType; (var kv#3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#3, colon#3, v#3); #Wrappers.Result.Success($Box(kv#3))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var k#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#4), p#4) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#4), p#4); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (var colon#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#4) && (var valueOrError2#4 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#4)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) && (var v#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#4, colon#4, v#4))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#4) else (var k#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#4), p#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#4) else (var colon#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; (var valueOrError2#4 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#4)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#4) else (var v#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType; (var kv#4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#4, colon#4, v#4); #Wrappers.Result.Success($Box(kv#4))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var k#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#5), p#5) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#5), p#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (var colon#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#5) && (var valueOrError2#5 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#5)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) && (var v#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#5, colon#5, v#5))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#5) else (var k#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#5), p#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#5) else (var colon#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; (var valueOrError2#5 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#5)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#5) else (var v#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType; (var kv#5 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#5, colon#5, v#5); #Wrappers.Result.Success($Box(kv#5))))))))))))));

const reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mArrayParams.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(): int == char#ToInt(Lit(char#FromInt(91)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.OPEN (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.OPEN (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ArrayParams.OPEN"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(832,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(91)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(91)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(): int == char#ToInt(Lit(char#FromInt(93)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.CLOSE (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.CLOSE (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()
{
  var $_ReadsFrame: [ref,Field]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ArrayParams.CLOSE"} true;
    assume {:print "Types"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(833,10): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    newtype$check#0 := char#ToInt(Lit(char#FromInt(93)));
    assume LitInt(0) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(93)));
    assume LitInt(0) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    return;
}



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(t#0) || (1 < $FunctionContextHeight && $Is(t#0, Tclass.JSON_mGrammar.Value())) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(t#0) || (1 < $FunctionContextHeight && $Is(t#0, Tclass.JSON_mGrammar.Value())) ==> JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0) == JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#0));
axiom 1 <= $FunctionContextHeight ==> (forall t#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(Lit(t#0)) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(Lit(t#0)) || (1 < $FunctionContextHeight && $Is(t#0, Tclass.JSON_mGrammar.Value())) ==> JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(t#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(Lit(t#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), Lit(t#0))));
}

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(t#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires(DatatypeType) : bool;

axiom (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires(t#0) } $Is(t#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires(t#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.ElementSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0: DatatypeType where $Is(t#0, Tclass.JSON_mGrammar.Value()));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(cs#0, json#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(cs#0, json#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, cs#0, json#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs#0))): DatatypeType);
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(cs#0), json#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), json#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(Lit(cs#0)))): DatatypeType);
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(Lit(cs#0)))): DatatypeType);
}

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#requires(DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#requires(cs#0, json#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.Element (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id27193"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.Element (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.ArrayParams.Element", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(839,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume 1 != $FunctionContextHeight;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs#0));
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, cs#0, json#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs#0))): DatatypeType;
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, cs#0, json#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.reveal_Element (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.reveal__Element();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.reveal_Element (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.reveal__Element();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.ArrayParams.reveal_Element (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrayParams.__default.reveal__Element();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#244 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#244))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#246 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#246)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#366 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#366))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#368 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#368)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#370 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#370)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#366 := Wrappers.Option.value(this); v#366)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#368 := Lit(Wrappers.Option.value(Lit(this))); v#368)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#370 := Lit(Wrappers.Option.value(Lit(this))); v#370)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#244 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#244)) else (var e#244 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#246 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#246))) else (var e#246 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#366 := Wrappers.Result.value(this); s#366) else (var e#366 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#368 := Lit(Wrappers.Result.value(Lit(this))); s#368) else (var e#368 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#370 := Lit(Wrappers.Result.value(Lit(this))); s#370) else (var e#370 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#366 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#366)) else (var e#366 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#366)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#368 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#368))) else (var e#368 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#368)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#370 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#370))) else (var e#370 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#370)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#162: int, y#162: int :: { Mul(x#162, y#162) } Mul(x#162, y#162) == Mul(y#162, x#162)) && (forall x#163: int, y#163: int, z#108: int :: { Mul(x#163 + y#163, z#108) } Mul(x#163 + y#163, z#108) == Mul(x#163, z#108) + Mul(y#163, z#108)) && (forall x#164: int, y#164: int, z#109: int :: { Mul(x#164 - y#164, z#109) } Mul(x#164 - y#164, z#109) == Mul(x#164, z#109) - Mul(y#164, z#109));

axiom MulInternals.__default.MulAuto() <==> (forall x#165: int, y#165: int :: { Mul(x#165, y#165) } Mul(x#165, y#165) == Mul(y#165, x#165)) && (forall x#166: int, y#166: int, z#110: int :: { Mul(x#166 + y#166, z#110) } Mul(x#166 + y#166, z#110) == Mul(x#166, z#110) + Mul(y#166, z#110)) && (forall x#167: int, y#167: int, z#111: int :: { Mul(x#167 - y#167, z#111) } Mul(x#167 - y#167, z#111) == Mul(x#167, z#111) - Mul(y#167, z#111));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#200: int :: { Mod(Mod(x#200, n#0), n#0) } Mod(Mod(x#200, n#0), n#0) == Mod(x#200, n#0)) && (forall x#201: int :: { Mod(x#201, n#0) } LitInt(0) <= x#201 && x#201 < n#0 <==> Mod(x#201, n#0) == x#201) && (forall x#202: int, y#100: int :: { Mod(x#202 + y#100, n#0) } (var z#98 := Mod(x#202, n#0) + Mod(y#100, n#0); (LitInt(0) <= z#98 && z#98 < n#0 && Mod(x#202 + y#100, n#0) == z#98) || (n#0 <= z#98 && z#98 < n#0 + n#0 && Mod(x#202 + y#100, n#0) == z#98 - n#0))) && (forall x#203: int, y#101: int :: { Mod(x#203 - y#101, n#0) } (var z#99 := Mod(x#203, n#0) - Mod(y#101, n#0); (LitInt(0) <= z#99 && z#99 < n#0 && Mod(x#203 - y#101, n#0) == z#99) || (0 - n#0 <= z#99 && z#99 < 0 && Mod(x#203 - y#101, n#0) == z#99 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#204: int :: { Mod(Mod(x#204, n#0), n#0) } Mod(Mod(x#204, LitInt(n#0)), LitInt(n#0)) == Mod(x#204, LitInt(n#0))) && (forall x#205: int :: { Mod(x#205, n#0) } LitInt(0) <= x#205 && x#205 < n#0 <==> Mod(x#205, LitInt(n#0)) == x#205) && (forall x#206: int, y#102: int :: { Mod(x#206 + y#102, n#0) } (var z#100 := Mod(x#206, LitInt(n#0)) + Mod(y#102, LitInt(n#0)); (LitInt(0) <= z#100 && z#100 < n#0 && Mod(x#206 + y#102, LitInt(n#0)) == z#100) || (LitInt(n#0) <= z#100 && z#100 < n#0 + n#0 && Mod(x#206 + y#102, LitInt(n#0)) == z#100 - n#0))) && (forall x#207: int, y#103: int :: { Mod(x#207 - y#103, n#0) } (var z#101 := Mod(x#207, LitInt(n#0)) - Mod(y#103, LitInt(n#0)); (LitInt(0) <= z#101 && z#101 < n#0 && Mod(x#207 - y#103, LitInt(n#0)) == z#101) || (LitInt(0 - n#0) <= z#101 && z#101 < 0 && Mod(x#207 - y#103, LitInt(n#0)) == z#101 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#144: int :: { Div(x#144, n#0) } LitInt(0) <= x#144 && x#144 < n#0 <==> Div(x#144, n#0) == LitInt(0)) && (forall x#145: int, y#96: int :: { Div(x#145 + y#96, n#0) } (var z#94 := Mod(x#145, n#0) + Mod(y#96, n#0); (LitInt(0) <= z#94 && z#94 < n#0 && Div(x#145 + y#96, n#0) == Div(x#145, n#0) + Div(y#96, n#0)) || (n#0 <= z#94 && z#94 < n#0 + n#0 && Div(x#145 + y#96, n#0) == Div(x#145, n#0) + Div(y#96, n#0) + 1))) && (forall x#146: int, y#97: int :: { Div(x#146 - y#97, n#0) } (var z#95 := Mod(x#146, n#0) - Mod(y#97, n#0); (LitInt(0) <= z#95 && z#95 < n#0 && Div(x#146 - y#97, n#0) == Div(x#146, n#0) - Div(y#97, n#0)) || (0 - n#0 <= z#95 && z#95 < 0 && Div(x#146 - y#97, n#0) == Div(x#146, n#0) - Div(y#97, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#147: int :: { Div(x#147, n#0) } LitInt(0) <= x#147 && x#147 < n#0 <==> Div(x#147, LitInt(n#0)) == LitInt(0)) && (forall x#148: int, y#98: int :: { Div(x#148 + y#98, n#0) } (var z#96 := Mod(x#148, LitInt(n#0)) + Mod(y#98, LitInt(n#0)); (LitInt(0) <= z#96 && z#96 < n#0 && Div(x#148 + y#98, LitInt(n#0)) == Div(x#148, LitInt(n#0)) + Div(y#98, LitInt(n#0))) || (LitInt(n#0) <= z#96 && z#96 < n#0 + n#0 && Div(x#148 + y#98, LitInt(n#0)) == Div(x#148, LitInt(n#0)) + Div(y#98, LitInt(n#0)) + 1))) && (forall x#149: int, y#99: int :: { Div(x#149 - y#99, n#0) } (var z#97 := Mod(x#149, LitInt(n#0)) - Mod(y#99, LitInt(n#0)); (LitInt(0) <= z#97 && z#97 < n#0 && Div(x#149 - y#99, LitInt(n#0)) == Div(x#149, LitInt(n#0)) - Div(y#99, LitInt(n#0))) || (LitInt(0 - n#0) <= z#97 && z#97 < 0 && Div(x#149 - y#99, LitInt(n#0)) == Div(x#149, LitInt(n#0)) - Div(y#99, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#36 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#36) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#36)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#36 := lv#0; (var dt_update#end#0#36 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#36), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#36), dt_update#end#0#36))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#37 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#37) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#37)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#37 := Lit(lv#0); (var dt_update#end#0#37 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#37)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#37)), dt_update#end#0#37)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#38: char :: { Seq#Contains(s#0, $Box(c#38)) } $Is(c#38, TChar) && Seq#Contains(s#0, $Box(c#38)) ==> char#ToInt(c#38) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#38: char :: { Seq#Contains(s#0, $Box(c#38)) } $Is(c#38, TChar) && Seq#Contains(s#0, $Box(c#38)) ==> char#ToInt(c#38) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#76#i#0): int)): char))), (lambda $l#76#heap#0: Heap, $l#76#i#0: Box :: $IsBox($l#76#i#0, TInt) && LitInt(0) <= $Unbox($l#76#i#0): int && $Unbox($l#76#i#0): int < Seq#Length(s#0)), (lambda $l#76#heap#0: Heap, $l#76#i#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#39: char :: { Seq#Contains(s#0, $Box(c#39)) } $Is(c#39, TChar) && Seq#Contains(s#0, $Box(c#39)) ==> char#ToInt(c#39) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#78#i#0): int)): char))), (lambda $l#78#heap#0: Heap, $l#78#i#0: Box :: $IsBox($l#78#i#0, TInt) && LitInt(0) <= $Unbox($l#78#i#0): int && $Unbox($l#78#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#78#heap#0: Heap, $l#78#i#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#16 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#16))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#16 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#18 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#18))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#18 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#120 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#60 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#120 := (if b#120 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#120)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#60)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#120)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#121 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#60 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#121 := (if b#121 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#121)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#60 := Seq#Create(TChar, $Heap, Seq#Length(bs0#60), Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#60, $Unbox($l#94#idx#0): int)): int))), (lambda $l#94#heap#0: Heap, $l#94#idx#0: Box :: $IsBox($l#94#idx#0, TInt) && LitInt(0) <= $Unbox($l#94#idx#0): int && $Unbox($l#94#idx#0): int < Seq#Length(bs0#60)), (lambda $l#94#heap#0: Heap, $l#94#idx#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#60), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#121))))) else (var err#60 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#60)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#124 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#62 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#124 := (if b#124 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#124)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#62)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#124)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#125 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#62 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#125 := (if b#125 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#125)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#62 := Seq#Create(TChar, $Heap, Seq#Length(bs0#62), Lit(AtLayer((lambda $l#97#ly#0: LayerType :: Handle1((lambda $l#97#heap#0: Heap, $l#97#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#62, $Unbox($l#97#idx#0): int)): int))), (lambda $l#97#heap#0: Heap, $l#97#idx#0: Box :: $IsBox($l#97#idx#0, TInt) && LitInt(0) <= $Unbox($l#97#idx#0): int && $Unbox($l#97#idx#0): int < Seq#Length(bs0#62)), (lambda $l#97#heap#0: Heap, $l#97#idx#0: Box :: SetRef_to_SetBox((lambda $l#97#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#62), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#125))))) else (var err#62 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#62)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#128 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#64 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#128 := (if b#128 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#128)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#64)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#128)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#129 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#64 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#129 := (if b#129 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#129)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#64 := Seq#Create(TChar, $Heap, Seq#Length(bs0#64), Lit(AtLayer((lambda $l#100#ly#0: LayerType :: Handle1((lambda $l#100#heap#0: Heap, $l#100#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#64, $Unbox($l#100#idx#0): int)): int))), (lambda $l#100#heap#0: Heap, $l#100#idx#0: Box :: $IsBox($l#100#idx#0, TInt) && LitInt(0) <= $Unbox($l#100#idx#0): int && $Unbox($l#100#idx#0): int < Seq#Length(bs0#64)), (lambda $l#100#heap#0: Heap, $l#100#idx#0: Box :: SetRef_to_SetBox((lambda $l#100#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#64), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#129))))) else (var err#64 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#64)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#12: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#12)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#12)): int } LitInt(0) <= idx#12 && idx#12 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#12 && idx#12 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#12)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#12)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#20 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#20 := this; (var dt_update#beg#0#20 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#20), dt_update#beg#0#20, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#20), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#20)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#21 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#21 := Lit(this); (var dt_update#beg#0#21 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#21)), dt_update#beg#0#21, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#21)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#21)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#66#v#0): DatatypeType))), (lambda $l#66#heap#0: Heap, $l#66#v#0: Box :: $IsBox($l#66#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#66#heap#0: Heap, $l#66#v#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#67#v#0): DatatypeType))), (lambda $l#67#heap#0: Heap, $l#67#v#0: Box :: $IsBox($l#67#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#67#heap#0: Heap, $l#67#v#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#68#v#0): DatatypeType))), (lambda $l#68#heap#0: Heap, $l#68#v#0: Box :: $IsBox($l#68#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#68#heap#0: Heap, $l#68#v#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#20 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#20 := this; (var dt_update#point#0#20 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#20), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#20), dt_update#point#0#20, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#20)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#21 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#21 := Lit(this); (var dt_update#point#0#21 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#21)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#21)), dt_update#point#0#21, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#21)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#20 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#20)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#20 := this; (var dt_update#point#0#20 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#20), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#20), dt_update#point#0#20, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#20)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#21 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#21)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#21 := Lit(this); (var dt_update#point#0#21 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#21)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#21)), dt_update#point#0#21, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#21)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#20 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#20 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#20 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#20 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#20))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#21 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#21 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#21 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#21 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#21)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#33: int :: { Seq#Contains(bs#0, $Box(b#33)) } LitInt(0) <= b#33 && b#33 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#33)) ==> b#33 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#33: int :: { Seq#Contains(bs#0, $Box(b#33)) } LitInt(0) <= b#33 && b#33 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#33)) ==> b#33 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#30 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#30)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30) && (var ps#30 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#30, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#30 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#30) else (var ps#30 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#30)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#30, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#34: int :: { Seq#Contains(bs#0, $Box(b#34)) } LitInt(0) <= b#34 && b#34 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#34)) ==> b#34 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#31 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#31)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31) && (var ps#31 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#31, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#31 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#31) else (var ps#31 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#31)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#31, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#35: int :: { Seq#Contains(bs#0, $Box(b#35)) } LitInt(0) <= b#35 && b#35 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#35)) ==> b#35 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#32 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#32)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32) && (var ps#32 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#32, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#32 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#32) else (var ps#32 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#32)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#32, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#12: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#12)): int } LitInt(0) <= idx#12 && idx#12 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#12 && idx#12 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#12)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#62 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#62)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#61 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#61)))) else (var st#61 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#61))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#64 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#64)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#63 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#63)))) else (var st#63 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#63))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#66 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#66)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#65 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#65)))) else (var st#65 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#65))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#80#heap#0: Heap, $l#80#_v0#0: Box :: $IsBox($l#80#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#80#heap#0: Heap, $l#80#_v0#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#81#heap#0: Heap, $l#81#_v1#0: Box :: $IsBox($l#81#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#81#heap#0: Heap, $l#81#_v1#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#84#heap#0: Heap, $l#84#_v0#0: Box :: $IsBox($l#84#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#84#heap#0: Heap, $l#84#_v0#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#85#heap#0: Heap, $l#85#_v1#0: Box :: $IsBox($l#85#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#85#heap#0: Heap, $l#85#_v1#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#120#ly#0: LayerType :: Handle1((lambda $l#120#heap#0: Heap, $l#120#cs#0: Box :: $Box(Lit(false))), (lambda $l#120#heap#0: Heap, $l#120#cs#0: Box :: $IsBox($l#120#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#120#heap#0: Heap, $l#120#cs#0: Box :: SetRef_to_SetBox((lambda $l#120#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#121#ly#0: LayerType :: Handle1((lambda $l#121#heap#0: Heap, $l#121#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#121#heap#0: Heap, $l#121#cs#0: Box :: $IsBox($l#121#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#121#heap#0: Heap, $l#121#cs#0: Box :: SetRef_to_SetBox((lambda $l#121#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#122#ly#0: LayerType :: Handle1((lambda $l#122#heap#0: Heap, $l#122#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#122#heap#0: Heap, $l#122#_v2#0: Box :: $IsBox($l#122#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#122#heap#0: Heap, $l#122#_v2#0: Box :: SetRef_to_SetBox((lambda $l#122#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#126#ly#0: LayerType :: Handle1((lambda $l#126#heap#0: Heap, $l#126#cs#0: Box :: $Box(Lit(false))), (lambda $l#126#heap#0: Heap, $l#126#cs#0: Box :: $IsBox($l#126#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#126#heap#0: Heap, $l#126#cs#0: Box :: SetRef_to_SetBox((lambda $l#126#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#127#ly#0: LayerType :: Handle1((lambda $l#127#heap#0: Heap, $l#127#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#127#heap#0: Heap, $l#127#cs#0: Box :: $IsBox($l#127#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#127#heap#0: Heap, $l#127#cs#0: Box :: SetRef_to_SetBox((lambda $l#127#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#128#ly#0: LayerType :: Handle1((lambda $l#128#heap#0: Heap, $l#128#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#128#heap#0: Heap, $l#128#_v2#0: Box :: $IsBox($l#128#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#128#heap#0: Heap, $l#128#_v2#0: Box :: SetRef_to_SetBox((lambda $l#128#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#20: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#20))): DatatypeType } $Is(cs'#20, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#20))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#20))): DatatypeType)): DatatypeType, cs'#20, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#20: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#20))): DatatypeType } $Is(cs'#20, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#20))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#20))): DatatypeType)): DatatypeType, cs'#20, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#21: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#21))): DatatypeType } $Is(cs'#21, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#21))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#21))): DatatypeType)): DatatypeType, cs'#21, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#21: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#21))): DatatypeType } $Is(cs'#21, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#21))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#21))): DatatypeType)): DatatypeType, cs'#21, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#60: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#60)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#60))): bool } $Is(cs'#60, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#60))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#60)))) && ((forall cs'#60: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#60)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#60))): bool } $Is(cs'#60, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#60))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#60))) ==> (forall cs'#61: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#61))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#61, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#61: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#61))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#61, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#61))): bool) ==> (forall cs'#62: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#62))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#62))): bool } $Is(cs'#62, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#62))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#62))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#62))): DatatypeType)): DatatypeType, cs'#62, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#60: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#60)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#60))): bool } $Is(cs'#60, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#60))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#60))) && (forall cs'#61: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#61))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#61, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#61, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#61))): bool) && (forall cs'#62: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#62))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#62))): bool } $Is(cs'#62, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#62))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#62))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#62))): DatatypeType)): DatatypeType, cs'#62, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#63: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#63)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#63))): bool } $Is(cs'#63, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#63))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#63)))) && ((forall cs'#63: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#63)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#63))): bool } $Is(cs'#63, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#63))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#63))) ==> (forall cs'#64: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#64))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#64, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#64, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#64, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#64, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#64: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#64))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#64, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#64, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#64, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#64))): bool) ==> (forall cs'#65: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#65))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#65))): bool } $Is(cs'#65, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#65))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#65))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#65))): DatatypeType)): DatatypeType, cs'#65, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#63: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#63)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#63))): bool } $Is(cs'#63, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#63))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#63))) && (forall cs'#64: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#64))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#64, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#64, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#64, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#64))): bool) && (forall cs'#65: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#65))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#65))): bool } $Is(cs'#65, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#65))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#65))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#65))): DatatypeType)): DatatypeType, cs'#65, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#17: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#17)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#17)) ==> LitInt(0) <= d#17 && d#17 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#45 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#46 := Seq#Append(digits'#45, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#46))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#46 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#47 := Seq#Append(digits'#46, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#47))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#47 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#48 := Seq#Append(digits'#47, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#48))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#17: Box :: { Seq#Contains(chars#0, c#17) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#17) } $IsBox(c#17, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#17) ==> Seq#Contains(chars#0, c#17)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#35: int :: { Seq#Contains(digits#0, $Box(d#35)) } Seq#Contains(digits#0, $Box(d#35)) ==> LitInt(0) <= d#35 && d#35 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#35: int :: { Seq#Contains(digits#0, $Box(d#35)) } Seq#Contains(digits#0, $Box(d#35)) ==> LitInt(0) <= d#35 && d#35 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#36: int :: { Seq#Contains(digits#0, $Box(d#36)) } Seq#Contains(digits#0, $Box(d#36)) ==> LitInt(0) <= d#36 && d#36 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#17: Box :: { Seq#Contains(chars#0, c#17) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#17) } $IsBox(c#17, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#17) ==> Seq#Contains(chars#0, c#17)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#30 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#30) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#30), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#30 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#30), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#31 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#31) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#31), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#31 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#31), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#47: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#47)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#47) } $IsBox(c#47, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#47) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#47)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#48: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#48)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#48) } $IsBox(c#48, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#48) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#48)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#49: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#49)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#49) } $IsBox(c#49, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#49) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#49)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Seq#Contains(chars#0, $l#21#c#0))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#33: Box :: { Map#Domain(digits#0)[c#33] } { Seq#Contains(str#0, c#33) } $IsBox(c#33, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#33) ==> Map#Domain(digits#0)[c#33])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#33: Box :: { Map#Domain(digits#0)[c#33] } { Seq#Contains(str#0, c#33) } $IsBox(c#33, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#33) ==> Map#Domain(digits#0)[c#33])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#34: Box :: { Map#Domain(digits#0)[c#34] } { Seq#Contains(str#0, c#34) } $IsBox(c#34, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#34) ==> Map#Domain(digits#0)[c#34])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(Map#Domain(digits#0)[$l#65#c#0])), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(Map#Domain(digits#0)[$l#65#c#0])), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(Map#Domain(digits#0)[$l#66#c#0])), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(Map#Domain(digits#0)[$l#67#c#0])), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#45 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#45) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#45) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#45)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#45) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#45)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#45 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#45) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#45) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#45)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#45) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#45))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#45 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#45) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#45) else (var tl#90 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#45)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#90)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#45 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#45) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#45) else (var tl#91 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#45)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#91)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#46 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#46) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#46) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#46)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#46) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#46)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#46 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#46) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#46) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#46)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#46) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#46))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#46 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#46) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#46) else (var tl#92 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#46)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#92)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#46 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#46) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#46) else (var tl#93 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#46)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#93)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#47 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#47) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#47) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#47)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#47) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#47)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#47 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#47) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#47) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#47)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#47) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#47))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#47 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#47) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#47) else (var tl#94 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#47)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#94)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#47 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#47) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#47) else (var tl#95 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#47)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#95)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#17: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#17)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#17)) ==> LitInt(0) <= d#17 && d#17 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#45 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#46 := Seq#Append(digits'#45, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#46))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#46 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#47 := Seq#Append(digits'#46, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#47))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#47 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#48 := Seq#Append(digits'#47, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#48))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#17: char :: { Seq#Contains(chars#0, $Box(c#17)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#17)) ==> Seq#Contains(chars#0, $Box(c#17))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#35: int :: { Seq#Contains(digits#0, $Box(d#35)) } Seq#Contains(digits#0, $Box(d#35)) ==> LitInt(0) <= d#35 && d#35 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#35: int :: { Seq#Contains(digits#0, $Box(d#35)) } Seq#Contains(digits#0, $Box(d#35)) ==> LitInt(0) <= d#35 && d#35 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#36: int :: { Seq#Contains(digits#0, $Box(d#36)) } Seq#Contains(digits#0, $Box(d#36)) ==> LitInt(0) <= d#36 && d#36 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#17: char :: { Seq#Contains(chars#0, $Box(c#17)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#17)) ==> Seq#Contains(chars#0, $Box(c#17))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#30 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#30) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#30), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#30 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#30), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#31 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#31) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#31), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#31 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#31), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#47: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#47))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#47)) } $Is(c#47, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#47)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#47))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#48: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#48))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#48)) } $Is(c#48, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#48)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#48))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#49: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#49))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#49)) } $Is(c#49, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#49)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#49))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Seq#Contains(chars#0, $l#21#c#0))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#33: char :: { Map#Domain(digits#0)[$Box(c#33)] } { Seq#Contains(str#0, $Box(c#33)) } $Is(c#33, TChar) && Seq#Contains(str#0, $Box(c#33)) ==> Map#Domain(digits#0)[$Box(c#33)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#33: char :: { Map#Domain(digits#0)[$Box(c#33)] } { Seq#Contains(str#0, $Box(c#33)) } $Is(c#33, TChar) && Seq#Contains(str#0, $Box(c#33)) ==> Map#Domain(digits#0)[$Box(c#33)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#34: char :: { Map#Domain(digits#0)[$Box(c#34)] } { Seq#Contains(str#0, $Box(c#34)) } $Is(c#34, TChar) && Seq#Contains(str#0, $Box(c#34)) ==> Map#Domain(digits#0)[$Box(c#34)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(Map#Domain(digits#0)[$l#65#c#0])), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, TChar)), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(Map#Domain(digits#0)[$l#65#c#0])), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, TChar)), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(Map#Domain(digits#0)[$l#66#c#0])), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, TChar)), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(Map#Domain(digits#0)[$l#67#c#0])), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, TChar)), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#45 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#45) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#45) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#45)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#45) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#45)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#45 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#45) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#45) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#45)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#45) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#45))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#45 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#45) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#45) else (var tl#90 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#45)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#90)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#45 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#45) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#45) else (var tl#91 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#45)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#91)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#46 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#46) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#46) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#46)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#46) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#46)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#46 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#46) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#46) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#46)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#46) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#46))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#46 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#46) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#46) else (var tl#92 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#46)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#92)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#46 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#46) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#46) else (var tl#93 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#46)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#93)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#47 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#47) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#47) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#47)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#47) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#47)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#47 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#47) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#47) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#47)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#47) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#47))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#47 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#47) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#47) else (var tl#94 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#47)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#94)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#47 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#47) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#47) else (var tl#95 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#47)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#95)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#16: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#16)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#16)) } $Is(c#16, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#16)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#16))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#19#c#0))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, TChar)), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#31: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)] } { Seq#Contains(str#0, $Box(c#31)) } $Is(c#31, TChar) && Seq#Contains(str#0, $Box(c#31)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#31: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)] } { Seq#Contains(str#0, $Box(c#31)) } $Is(c#31, TChar) && Seq#Contains(str#0, $Box(c#31)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#31)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#32: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#32)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#32)] } { Seq#Contains(str#0, $Box(c#32)) } $Is(c#32, TChar) && Seq#Contains(str#0, $Box(c#32)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#32)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#32)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#50#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#50#c#0]): int < base#0)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, TChar)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#50#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#50#c#0]): int < base#0)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, TChar)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#51#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#51#c#0]): int < base#0)), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, TChar)), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#52 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#52)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#104 := JSON_mErrors.DeserializationError.b(this); (var b0#52 := JSON_mErrors.DeserializationError.expected(this); (var c#104 := (if b#104 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#104)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#52)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#104)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#105 := JSON_mErrors.DeserializationError.b(this); (var bs0#52 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#105 := (if b#105 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#105)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#52 := Seq#Create(TChar, $Heap, Seq#Length(bs0#52), Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#52, $Unbox($l#82#idx#0): int)): int))), (lambda $l#82#heap#0: Heap, $l#82#idx#0: Box :: $IsBox($l#82#idx#0, TInt) && LitInt(0) <= $Unbox($l#82#idx#0): int && $Unbox($l#82#idx#0): int < Seq#Length(bs0#52)), (lambda $l#82#heap#0: Heap, $l#82#idx#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#52), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#105))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#54 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#54)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#108 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#54 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#108 := (if b#108 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#108)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#54)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#108)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#109 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#54 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#109 := (if b#109 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#109)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#54 := Seq#Create(TChar, $Heap, Seq#Length(bs0#54), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#54, $Unbox($l#85#idx#0): int)): int))), (lambda $l#85#heap#0: Heap, $l#85#idx#0: Box :: $IsBox($l#85#idx#0, TInt) && LitInt(0) <= $Unbox($l#85#idx#0): int && $Unbox($l#85#idx#0): int < Seq#Length(bs0#54)), (lambda $l#85#heap#0: Heap, $l#85#idx#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#54), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#109))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#53 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#53, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#52 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#52, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#52 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#52)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#55 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#55, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#54 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#54, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#54 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#54)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#30: int :: { JSON_mGrammar.__default.Blank_q(b#30) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) } LitInt(0) <= b#30 && b#30 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#30))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#30: int :: { JSON_mGrammar.__default.Blank_q(b#30) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) } LitInt(0) <= b#30 && b#30 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) ==> JSON_mGrammar.__default.Blank_q(b#30))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#31: int :: { JSON_mGrammar.__default.Blank_q(b#31) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#31)) } LitInt(0) <= b#31 && b#31 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#31)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#31))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#31: int :: { JSON_mGrammar.__default.Blank_q(b#31) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#31)) } LitInt(0) <= b#31 && b#31 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#31)) ==> JSON_mGrammar.__default.Blank_q(b#31))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#30: int :: { $Unbox(Seq#Index(s#0, idx#30)): DatatypeType } LitInt(0) <= idx#30 && idx#30 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#30)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#30: int :: { $Unbox(Seq#Index(s#0, idx#30)): DatatypeType } LitInt(0) <= idx#30 && idx#30 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#30)): DatatypeType)) <==> idx#30 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#31: int :: { $Unbox(Seq#Index(s#0, idx#31)): DatatypeType } LitInt(0) <= idx#31 && idx#31 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#31)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#31: int :: { $Unbox(Seq#Index(s#0, idx#31)): DatatypeType } LitInt(0) <= idx#31 && idx#31 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#31)): DatatypeType)) <==> idx#31 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#30: int :: { JSON_mGrammar.__default.Digit_q(b#30) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) } LitInt(0) <= b#30 && b#30 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#30))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#30: int :: { JSON_mGrammar.__default.Digit_q(b#30) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) } LitInt(0) <= b#30 && b#30 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#30)) ==> JSON_mGrammar.__default.Digit_q(b#30))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#31: int :: { JSON_mGrammar.__default.Digit_q(b#31) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#31)) } LitInt(0) <= b#31 && b#31 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#31)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#31))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#31: int :: { JSON_mGrammar.__default.Digit_q(b#31) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#31)) } LitInt(0) <= b#31 && b#31 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#31)) ==> JSON_mGrammar.__default.Digit_q(b#31))));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$11x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$11x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$11x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$11x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$11x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$11x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$11x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$11x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$11x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$11x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$11x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$11x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$11x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#36: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#36) } { Seq#Contains(ts#0, d#36) } $IsBox(d#36, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#36) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#36))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#36: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#36) } { Seq#Contains(ts#0, d#36) } $IsBox(d#36, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#36) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#36))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#37: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#37) } { Seq#Contains(ts#0, d#37) } $IsBox(d#37, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#37) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#37))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#38: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#38) } { Seq#Contains(ts#0, d#38) } $IsBox(d#38, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#38) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#38))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#36: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#36)) } $Is(d#36, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#36) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#36)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#36: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#36)) } $Is(d#36, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#36) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#36)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#37: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#37)) } $Is(d#37, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#37) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#37)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#38: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#38)) } $Is(d#38, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#38) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#38)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$11x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$11x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$11x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$11x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$11x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$11x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$11x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$11x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$11x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$11x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$11x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$11x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$11x#0))): Seq);

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$11x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$11x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$11x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$11x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$11x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$11x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$11x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$11x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$11x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$11x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$11x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$11x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$11x#0))): Seq);

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$11x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$11x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$11x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$11x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$11x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$11x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$11x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$11x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$11x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$11x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$11x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$11x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$11x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#74#d#0: DatatypeType :: $Is($l#74#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#74#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#74#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#75#ly#0, $Unbox($l#75#d#0): DatatypeType))), (lambda $l#75#heap#0: Heap, $l#75#d#0: Box :: $IsBox($l#75#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#75#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#75#heap#0: Heap, $l#75#d#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#73#ly#0, $Unbox($l#73#d#0): DatatypeType))), (lambda $l#73#heap#0: Heap, $l#73#d#0: Box :: $IsBox($l#73#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#73#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#73#heap#0: Heap, $l#73#d#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#77#d#0: DatatypeType :: $Is($l#77#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#77#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#77#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#78#ly#0, $Unbox($l#78#d#0): DatatypeType))), (lambda $l#78#heap#0: Heap, $l#78#d#0: Box :: $IsBox($l#78#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#78#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#78#heap#0: Heap, $l#78#d#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#76#ly#0, $Unbox($l#76#d#0): DatatypeType))), (lambda $l#76#heap#0: Heap, $l#76#d#0: Box :: $IsBox($l#76#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#76#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#76#heap#0: Heap, $l#76#d#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#74#d#0: DatatypeType :: $Is($l#74#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#74#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#74#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#75#ly#0, $Unbox($l#75#d#0): DatatypeType))), (lambda $l#75#heap#0: Heap, $l#75#d#0: Box :: $IsBox($l#75#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#75#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#75#heap#0: Heap, $l#75#d#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#73#ly#0, $Unbox($l#73#d#0): DatatypeType))), (lambda $l#73#heap#0: Heap, $l#73#d#0: Box :: $IsBox($l#73#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#73#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#73#heap#0: Heap, $l#73#d#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#77#d#0: DatatypeType :: $Is($l#77#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#77#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#77#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#78#ly#0, $Unbox($l#78#d#0): DatatypeType))), (lambda $l#78#heap#0: Heap, $l#78#d#0: Box :: $IsBox($l#78#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#78#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#78#heap#0: Heap, $l#78#d#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#76#ly#0, $Unbox($l#76#d#0): DatatypeType))), (lambda $l#76#heap#0: Heap, $l#76#d#0: Box :: $IsBox($l#76#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#76#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#76#heap#0: Heap, $l#76#d#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#45 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#45))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#45 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#45))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#45 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#45))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#45 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#45))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#45 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#45))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#45 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#45))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#44 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#44)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#44 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#44)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#44 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#44)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#44 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#44)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#44 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#44)) else (var arr#44 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#44))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#47 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#47))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#47 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#47))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#47 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#47))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#47 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#47))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#47 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#47))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#47 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#47))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#46 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#46))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#46 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#46))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#46 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#46))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#46 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#46))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#46 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#46))) else (var arr#46 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#46)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$11x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$11x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$11x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$11x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$11x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$11x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$11x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$11x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$11x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$11x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$11x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$11x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$11x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$11x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$11x#0))): Seq);

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#16 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var cs#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#17)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#16 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#16) else (var cs#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#17)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#17 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var cs#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#18)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#17 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#17) else (var cs#18 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#18)))))))));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$8x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$8x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$8x#0): int)));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$8x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$8x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$8x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$8x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$8x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$8x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$8x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$8x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$8x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#14#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $IsBox($l#14#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#67: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#67)) } $Is(cs#67, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#67)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#67: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#67)) } $Is(cs#67, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#67)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#68 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#16 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#68))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var cs#69 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#69))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#16, cs#68 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#16 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#68))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#16) else (var val#16, cs#69 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType); (var after#16, cs#70 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#69))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#69)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#16, val#16, after#16)), cs#70)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#71: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#71)) } $Is(cs#71, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#71)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#72 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#17 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#72))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var cs#73 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#73))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#17, cs#72 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#17 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#72))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#17) else (var val#17, cs#73 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType); (var after#17, cs#74 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#73))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#73)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#17, val#17, after#17)), cs#74)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#13#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $IsBox($l#13#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#49 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#49) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#49)) && (var cs#50 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#49))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#50))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#16, cs#49 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#16, cs#50 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#49)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#49))); (var after#16, cs#51 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#50))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#50)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#16, $Box(val#16), after#16)), cs#51)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#52 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#52) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#52)) && (var cs#53 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#52))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#53))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#17, cs#52 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#17, cs#53 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#52)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#52))); (var after#17, cs#54 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#53))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#53)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#17, $Box(val#17), after#17)), cs#54)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#18: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#18) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#18))): Seq } $Is(t#18, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#18)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#18: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#18) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#18))): Seq } $Is(t#18, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#18))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#18)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#19: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#19) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#19))): Seq } $Is(t#19, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#19)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#19: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#19) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#19))): Seq } $Is(t#19, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#19))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#19)))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$3x#0: Box, $fh$3x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$3x#0, $fh$3x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$3x#0, $fh$3x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$3x#0): bool, $Unbox($fh$3x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$3x#0: Box, $fh$3x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$3x#0, $fh$3x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$3x#0, $fh$3x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$3x#0): bool, $Unbox($fh$3x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$3x#0: Box, $fh$3x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$3x#0, $fh$3x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$3x#0, $fh$3x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$3x#0: bool, $fh$3x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$3x#0, $fh$3x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$3x#0, $fh$3x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$3x#0), $Box($fh$3x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#19 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#19) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#19); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (var contents#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#12) && (var cs#20 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#12)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#20) && (var valueOrError2#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#20); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#6) else (var lq#6, cs#19 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#19); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#6) else (var contents#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; (var contents#13, cs#20 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#12))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#12)); (var valueOrError2#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#20); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#6) else (var rq#6, cs#21 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#6, contents#13, rq#6)), cs#21))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#7 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#22 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#22) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#22); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (var contents#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#14) && (var cs#23 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#14)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#23) && (var valueOrError2#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#23); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#7 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#7) else (var lq#7, cs#22 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType)); (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#22); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#7) else (var contents#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; (var contents#15, cs#23 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#14))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#14)); (var valueOrError2#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#23); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#7) else (var rq#7, cs#24 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#7, contents#15, rq#7)), cs#24))))))))))))));

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements: bool;

const reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mArrays.__default: ClassName;

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle() : HandleType;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0: DatatypeType) : Seq
uses {
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(e#0) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(e#0) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(e#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0) == Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(e#0))));
axiom 1 <= $FunctionContextHeight ==> (forall e#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(Lit(e#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(Lit(e#0)) || (1 < $FunctionContextHeight && $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(Lit(e#0)) == Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0))))));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(e#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box($fh$0x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;
  var ##arr#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(848,39): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(849,55): post-state"} true;
    assume 1 != $FunctionContextHeight;
    ##self#0 := arr#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    ##arr#0 := arr#0;
    assume $IsAlloc(##arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0));
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
  free ensures {:id "id27221"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType where $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $IsA#JSON_mGrammar.Bracketed(arr#0)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
  free ensures {:id "id27222"} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $initHeapForallStmt#0: Heap;
  var rItem#0: HandleType where $Is(rItem#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(rItem#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#0: Heap;
  var d#1: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;
  var ##fDatum#1: HandleType;
  var ##self#3: DatatypeType;
  var ##fDatum#2: HandleType;
  var ##bracketed#0_0: DatatypeType;
  var ##pd0#0_0: HandleType;
  var ##pd1#0_0: HandleType;
  var bracketed##0_0: DatatypeType;
  var pd0##0_0: HandleType;
  var pd1##0_0: HandleType;
  var ##self#1_0_0: DatatypeType;
  var ##fDatum#1_0_0: HandleType;
  var ##arr#1_0_0: DatatypeType;
  var ##self#1_1_0: DatatypeType;
  var ##fDatum#1_1_0: HandleType;
  var ##self#1_1_1: DatatypeType;
  var ##fDatum#1_1_1: HandleType;
  var ##self#1_0: DatatypeType;
  var ##fDatum#1_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(850,4): initial state"} true;
    assume $IsA#JSON_mGrammar.Bracketed(arr#0);
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#arr0#0: DatatypeType :: $Is($ih#arr0#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && Lit(true) && DtRank($ih#arr0#0) < DtRank(arr#0) ==> Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $ih#arr0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), $ih#arr0#0)));
    $_reverifyPost := false;
    assume true;
    goto anon12_Then, anon12_Else;

  anon12_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc d#1;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} $Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} DtRank(d#1) < DtRank(arr#0);
    ##self#1 := d#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(d#1);
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), d#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Item#canCall(d#1);
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon14_Else:
    assume {:partition} DtRank(arr#0) <= DtRank(d#1);
    goto anon4;

  anon13_Else:
    assume {:partition} !($Is(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(d#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    assume (forall $l#0#d#0: DatatypeType :: $Is($l#0#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#0#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#0#d#0));
    rItem#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#1#ly#0, $Unbox($l#1#d#0): DatatypeType))), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: $IsBox($l#1#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#1#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#1#heap#0: Heap, $l#1#d#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(851,62)"} true;
    assume 1 != $FunctionContextHeight;
    ##self#2 := arr#0;
    assume $IsAlloc(##self#2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)) } $Is(d#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#2) < DtRank(##self#2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1, $Box(d#2)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    ##self#3 := arr#0;
    assume $IsAlloc(##self#3, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#2 := rItem#0;
    assume $IsAlloc(##fDatum#2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#3: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)) } $Is(d#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#3) < DtRank(##self#3) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#2, $Box(d#3)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    push;
    assume 1 != $FunctionContextHeight;
    ##bracketed#0_0 := arr#0;
    assume $IsAlloc(##bracketed#0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##pd0#0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##pd0#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    ##pd1#0_0 := rItem#0;
    assume $IsAlloc(##pd1#0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0);
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0);
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0) || (forall d#0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box(d#0_0)) } $Is(d#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0) < DtRank(arr#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box(d#0_0)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0) || (forall d#0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_1)) } $Is(d#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_1) < DtRank(arr#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_1)));
    assume {:subsumption 0} JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0) ==> JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0) || (forall d#0_2: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_2))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box(d#0_2))): Seq } $Is(d#0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_2) < DtRank(arr#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box(d#0_2))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, rItem#0, $Box(d#0_2))): Seq));
    assume JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), rItem#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(853,90)"} true;
    assume true;
    bracketed##0_0 := arr#0;
    assume 1 != $FunctionContextHeight;
    assume true;
    pd0##0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume true;
    pd1##0_0 := rItem#0;
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0, pd0##0_0, pd1##0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), bracketed##0_0, pd0##0_0, pd1##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(854,74)"} true;
    pop;
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0));
    assume false;
    goto anon7;

  anon15_Else:
    goto anon7;

  anon7:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(855,6)"} true;
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume 1 != $FunctionContextHeight;
    ##self#1_0 := arr#0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)) } $Is(d#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0) < DtRank(##self#1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0, $Box(d#1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume false;
    goto anon11;

  anon16_Else:
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume 1 != $FunctionContextHeight;
    ##self#1_1_0 := arr#0;
    assume $IsAlloc(##self#1_1_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#1_1_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)) } $Is(d#1_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_0) < DtRank(##self#1_1_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_0, $Box(d#1_1_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    ##self#1_1_1 := arr#0;
    assume $IsAlloc(##self#1_1_1, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_1_1 := rItem#0;
    assume $IsAlloc(##fDatum#1_1_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_1_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)) } $Is(d#1_1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_1_1) < DtRank(##self#1_1_1) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_1_1, $Box(d#1_1_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0));
    assume false;
    goto anon11;

  anon17_Else:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    ##self#1_0_0 := arr#0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#1_0_0 := rItem#0;
    assume $IsAlloc(##fDatum#1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)) } $Is(d#1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#1_0_0) < DtRank(##self#1_0_0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#1_0_0, $Box(d#1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0);
    ##arr#1_0_0 := arr#0;
    assume $IsAlloc(##arr#1_0_0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0);
    assume {:subsumption 0} Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, rItem#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LS($LZ)), arr#0));
    assume false;
    goto anon11;

  anon18_Else:
    goto anon11;

  anon11:
    assume Seq#Equal(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0));
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 6 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || (6 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 6 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || (6 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#0) else (var sp#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(sp#0))))));
axiom 6 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), Lit(json#0)) || (6 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#1) else (var sp#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(sp#1))))));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

axiom (forall $ly: LayerType :: { JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($ly)) } JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($ly)) == JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly));

function JSON_mConcreteSyntax_mSpec.__default.Array#Handle($fuel: LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Array($ly, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$0x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#requires(DatatypeType, DatatypeType) : bool;

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#requires(cs#0, json#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

function Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) == Tagclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) == tytagFamily$jopen;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()));

function Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose() : Ty
uses {
axiom Tag(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) == Tagclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose && TagFamily(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) == tytagFamily$jclose;
}

const unique Tagclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose: TyTag;

axiom (forall bx: Box :: { $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) } $IsBox(bx, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) ==> $Box($Unbox(bx): DatatypeType) == bx && $Is($Unbox(bx): DatatypeType, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Array (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 6 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id27247"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)));
  free ensures {:id "id27248"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
  free ensures {:id "id27249"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
  free ensures {:id "id27250"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
  free ensures {:id "id27251"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)))));



function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle() : HandleType;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0: DatatypeType) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(Lit(ts#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(ts#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($fh$0x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Array (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##json#0: DatatypeType;
  var sp#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var arr##0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Array", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(863,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)));
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__#Equal(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0);
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume sp#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(869,53)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume $Is($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()));
    arr##0 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    call CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr##0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(870,27)"} true;
    assume $Is(#Wrappers.Result.Success($Box(sp#Z#0)), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, json#0) == #Wrappers.Result.Success($Box(sp#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, json#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() : int
uses {
axiom JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(): int == char#ToInt(Lit(char#FromInt(44)));
axiom 0 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(), Tclass.BoundedInts.uint8());
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.SEPARATOR (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



axiom 0 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h));

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(): HandleType == JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.SpecViewClose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen() : HandleType
uses {
axiom JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(): HandleType == JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
axiom 1 < $FunctionContextHeight ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())));
}

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.SpecViewOpen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen();
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



axiom 1 < $FunctionContextHeight ==> (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h));

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires(DatatypeType) : bool;

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires(e#0) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires(e#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.SuffixedElementSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0: DatatypeType where $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires(ts#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires(ts#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0: DatatypeType where $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##self#0: DatatypeType;
  var ##fDatum#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.BracketedSpec", " | ", ts#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](138,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 1 != $FunctionContextHeight;
    ##self#0 := ts#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0) < DtRank(##self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0: Seq) : Seq
uses {
axiom 2 <= $FunctionContextHeight ==> (forall ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(ts#0) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));
axiom 2 <= $FunctionContextHeight ==> (forall $Heap: Heap, ts#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(Lit(ts#0)) || (2 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(ts#0: Seq) : bool;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires(Seq) : bool;

axiom (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires(ts#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires(ts#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.SuffixedElementsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0: Seq where $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.SuffixedElementsSpec (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0: Seq)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##ts#0: Seq;
  var ##fT#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.SuffixedElementsSpec", " | ", ts#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](142,19): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    assume false;
    return;

  anon4_Else:
    assume 1 != $FunctionContextHeight;
    ##ts#0 := ts#0;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume (forall d#0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)) } { Seq#Contains(##ts#0, $Box(d#0)) } $Is(d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0, $Box(d#0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0, $Box(d#0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8()));
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) == (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Open (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Open (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##b#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Open", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](146,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##b#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN();
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open, cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 2 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(Lit(cs#0)) || (2 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) == (var valueOrError0#1 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires(DatatypeType) : bool;

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires(cs#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires(cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Close (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Close (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##b#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Close", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](154,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##b#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume $IsAlloc(##b#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume $Is(#Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal: bool, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#0 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#0));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#1 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#1));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox($fh$0x#0): Seq)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires($Unbox($fh$0x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$0x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$0x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()), open#0: DatatypeType where $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))), close#0: DatatypeType where $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())))) returns (sp#2: DatatypeType where $Is(sp#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedFromParts (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType) returns (sp#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##s#0: Seq;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#1: Heap;
  var c#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##self#0_0_0: DatatypeType;
  var ##fT#0_0_0: HandleType;
  var ##ts#0_0_0: Seq;
  var ##self#0_0_1: DatatypeType;
  var ##fT#0_0_1: HandleType;
  var ##self#0_0_2: DatatypeType;
  var ##fDatum#0_0_0: HandleType;
  var ##self#0_1_0: DatatypeType;
  var ##fT#0_1_0: HandleType;
  var ##ts#0_1_0: Seq;
  var ##self#0_1_1: DatatypeType;
  var ##fT#0_1_1: HandleType;
  var a##0_1_0: Seq;
  var ##self#0_1_2: DatatypeType;
  var ##fT#0_1_2: HandleType;
  var ##ts#0_1_1: Seq;
  var b##0_1_0: Seq;
  var ##self#0_1_3: DatatypeType;
  var ##fT#0_1_3: HandleType;
  var c##0_1_0: Seq;
  var ##self#0_1_4: DatatypeType;
  var ##fT#0_1_4: HandleType;
  var ##ts#0_1_2: Seq;
  var ##self#0_1_5: DatatypeType;
  var ##fT#0_1_5: HandleType;
  var ##self#0_2_0: DatatypeType;
  var ##fT#0_2_0: HandleType;
  var ##ts#0_2_0: Seq;
  var ##self#0_2_1: DatatypeType;
  var ##fT#0_2_1: HandleType;
  var ##self#0_2_2: DatatypeType;
  var ##fT#0_2_2: HandleType;
  var ##ts#0_2_1: Seq;
  var ##self#0_2_3: DatatypeType;
  var ##fT#0_2_3: HandleType;
  var ##self#0_3_0: DatatypeType;
  var ##fT#0_3_0: HandleType;
  var ##ts#0_3_0: Seq;
  var a##0_3_0: Seq;
  var ##self#0_3_1: DatatypeType;
  var ##fT#0_3_1: HandleType;
  var b##0_3_0: Seq;
  var ##ts#0_3_1: Seq;
  var c##0_3_0: Seq;
  var ##self#0_3_2: DatatypeType;
  var ##fT#0_3_2: HandleType;
  var ##ts#0_3_2: Seq;
  var ##self#0_4_0: DatatypeType;
  var ##fT#0_4_0: HandleType;
  var ##ts#0_4_0: Seq;
  var ##self#0_4_1: DatatypeType;
  var ##fT#0_4_1: HandleType;
  var ##ts#0_4_1: Seq;
  var ##self#0_5_0: DatatypeType;
  var ##fT#0_5_0: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.BracketedFromParts", " | ", cs#0, " | ", open#0, " | ", elems#0, " | ", close#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](162,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##s#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume $IsAllocBox($Box(open#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon21_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon20_Else:
    goto anon5;

  anon5:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} $Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := c#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon8;

  anon23_Else:
    assume {:partition} !($Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1));
    goto anon8;

  anon8:
    assume false;
    goto anon9;

  anon22_Else:
    goto anon9;

  anon9:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))));
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume $IsAllocBox($Box(sp#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#2, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume false;
    return;

  anon24_Else:
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $Is($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Tclass.JSON_mGrammar.SuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume let#0#0#0 == #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume sp#Z#0 == let#0#0#0;
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume false;
    goto anon19;

  anon25_Else:
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_5_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_5_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_5_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_5_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume true;
    assume false;
    goto anon19;

  anon26_Else:
    goto anon27_Then, anon27_Else;

  anon27_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_4_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_4_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_4_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_4_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_4_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_4_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(open#0)) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(open#0)), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](177,84)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_4_1 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_4_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_4_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_4_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_4_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_4_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume true;
    assume false;
    goto anon19;

  anon27_Else:
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_3_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_1 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_3_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    a##0_3_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    b##0_3_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    c##0_3_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_3_0, b##0_3_0, c##0_3_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_3_0, b##0_3_0, c##0_3_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](179,104)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_3_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_3_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_3_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_3_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_3_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_3_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume true;
    assume false;
    goto anon19;

  anon28_Else:
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_2_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_2_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_2_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_2_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_2_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##fT#0_2_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](181,90)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_2_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_2_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_2_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_2_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_2_3 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_2_3, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##fT#0_2_3 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_2_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume true;
    assume false;
    goto anon19;

  anon29_Else:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_1_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##fT#0_1_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_2 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_2, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_1_2 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_1_0 := Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_3 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_3, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##fT#0_1_3 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_3, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    b##0_1_0 := JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    c##0_1_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_1_0, b##0_1_0, c##0_1_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_1_0, b##0_1_0, c##0_1_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](183,141)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_1_4 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_4, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_1_4 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_4, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_1_5 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_1_5, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##fT#0_1_5 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_1_5, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume true;
    assume false;
    goto anon19;

  anon30_Else:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##self#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $Heap);
    ##fT#0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    ##self#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##fT#0_0_1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0_0_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume 1 != $FunctionContextHeight;
    ##self#0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType;
    assume $IsAlloc(##self#0_0_2, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    ##fDatum#0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fDatum#0_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)) } $Is(d#0_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank(d#0_0_0) < DtRank(##self#0_0_2) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fDatum#0_0_0, $Box(d#0_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(close#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(close#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(close#0));
    assume true;
    assume false;
    goto anon19;

  anon31_Else:
    goto anon19;

  anon19:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(close#0))));
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#4 := cs#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#0, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](187,53)"} true;
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#0, elems#0, close#0) == sp#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#0, elems#0, close#0) == sp#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#0 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#0 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#0)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))))) && (forall e#3: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) } $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#1 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#1 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#1)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#1)));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : bool;

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$1x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AppendWithSuffix (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))), elem#0: DatatypeType where $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())), sep#0: DatatypeType where $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())))) returns (elems'#2: DatatypeType where $Is(elems'#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AppendWithSuffix (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) returns (elems'#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var e#5: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var e#6: DatatypeType;
  var ##other#1: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var suffixed#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##ts#0: Seq;
  var ##ts#0_0: Seq;
  var ##t#0_0: DatatypeType;
  var ##c#0_0: DatatypeType;
  var ##ts#0_0_0: Seq;
  var ##t#0_0_0: DatatypeType;
  var ##c#0_0_0: DatatypeType;
  var ##ts#0_0_0_0: Seq;
  var ##t#0_0_0_0: DatatypeType;
  var ##c#0_0_0_0: DatatypeType;
  var a##0_0_0_0: Seq;
  var ##ts#0_0_0_1: Seq;
  var b##0_0_0_0: Seq;
  var ##t#0_0_0_1: DatatypeType;
  var c##0_0_0_0: Seq;
  var a##0_0_0_1: Seq;
  var ##ts#0_0_0_2: Seq;
  var ##t#0_0_0_2: DatatypeType;
  var b##0_0_0_1: Seq;
  var ##c#0_0_0_1: DatatypeType;
  var c##0_0_0_1: Seq;
  var a##0_0_0: Seq;
  var ##ts#0_0_1: Seq;
  var b##0_0_0: Seq;
  var ##t#0_0_1: DatatypeType;
  var c##0_0_0: Seq;
  var ##c#0_0_1: DatatypeType;
  var ##ts#0_1: Seq;
  var ##t#0_1: DatatypeType;
  var ##c#0_1: DatatypeType;
  var ##ts#0_2: Seq;
  var ##ts#0_1_0: Seq;
  var ##e#0_1_0: DatatypeType;
  var ##ts#0_1_1: Seq;
  var ts0##0_1_0_0: Seq;
  var ts1##0_1_0_0: Seq;
  var pt##0_1_0_0: HandleType;
  var ##ts#0_1_0_0: Seq;
  var ##fT#0_1_0_0: HandleType;
  var ##ts#0_1_0_1: Seq;
  var ##fT#0_1_0_1: HandleType;
  var ##ts#0_1_0_2: Seq;
  var ##fT#0_1_0_2: HandleType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;
  var e#7: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#6: HandleType;
  var ##cs0#2_0: DatatypeType;
  var ##spec#2_0: HandleType;
  var ##cs0#2_0_0: DatatypeType;
  var ##spec#2_0_0: HandleType;
  var ##other#2_0: DatatypeType;
  var ##other#2_1_0: DatatypeType;
  var ##cs0#2_1_0_0: DatatypeType;
  var ##spec#2_1_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AppendWithSuffix", " | ", cs0#0, " | ", json#0, " | ", elems#0, " | ", elem#0, " | ", sep#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](191,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(elem#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    goto anon37_Then, anon37_Else;

  anon37_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon38_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon37_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elem#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    havoc e#5;
    assume $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#5);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5));
    goto anon8;

  anon39_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs0#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    havoc e#6;
    assume $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#6));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#6);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6));
    goto anon12;

  anon41_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6));
    goto anon12;

  anon12:
    assume (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#4 := cs0#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume false;
    return;

  anon40_Else:
    havoc suffixed#Z#0;
    assume $Is(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume let#0#0#0 == #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()));
    assume suffixed#Z#0 == let#0#0#0;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume let#1#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))), JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon42_Then, anon42_Else;

  anon42_Then:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon43_Then, anon43_Else;

  anon43_Then:
    push;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon44_Then, anon44_Else;

  anon44_Then:
    push;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](214,82)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elems#0)), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](215,80)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0_0 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0_0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0)), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](216,88)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0_1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    b##0_0_0_0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    c##0_0_0_0 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_0, b##0_0_0_0, c##0_0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_0, b##0_0_0_0, c##0_0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](217,95)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_0_2 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_0_2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    a##0_0_0_1 := Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    b##0_0_0_1 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    c##0_0_0_1 := JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_1, b##0_0_0_1, c##0_0_0_1);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(Tclass.BoundedInts.uint8(), a##0_0_0_1, b##0_0_0_1, c##0_0_0_1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](218,130)"} true;
    pop;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon17;

  anon44_Else:
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](219,10)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    a##0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0_1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    b##0_0_0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    c##0_0_0 := JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    call CallPre$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    call CallPost$$JSON_mUtils_mSeq.__default.Assoc(Tclass.BoundedInts.uint8(), a##0_0_0, b##0_0_0, c##0_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](220,110)"} true;
    pop;
    assume {:focus} Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon18;

  anon43_Else:
    goto anon18;

  anon18:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](221,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##c#0_1 := JSON_mGrammar.Suffixed.suffix(suffixed#Z#0);
    assume $IsAlloc(##c#0_1, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(sep#0));
    goto anon45_Then, anon45_Else;

  anon45_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    ##e#0_1_0 := suffixed#Z#0;
    assume $IsAlloc(##e#0_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(suffixed#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    goto anon46_Then, anon46_Else;

  anon46_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ts0##0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume true;
    ts1##0_1_0_0 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume 1 != $FunctionContextHeight;
    assume true;
    pt##0_1_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](224,87)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)) } { Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) } $Is(d#0_1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_1 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume $IsAlloc(##ts#0_1_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)) } { Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) } $Is(d#0_1_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_2 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)) } { Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) } $Is(d#0_1_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume true;
    assume Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](225,181)"} true;
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume false;
    goto anon21;

  anon46_Else:
    goto anon21;

  anon21:
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](226,10)"} true;
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon22;

  anon45_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(suffixed#Z#0)))), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](227,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume false;
    goto anon23;

  anon42_Else:
    goto anon23;

  anon23:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sep#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](228,6)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#5 := cs0#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](229,65)"} true;
    havoc e#7;
    goto anon47_Then, anon47_Else;

  anon47_Then:
    assume {:partition} $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    goto anon48_Then, anon48_Else;

  anon48_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#7));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#7);
    goto anon26;

  anon48_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#7));
    goto anon26;

  anon47_Else:
    assume {:partition} !($Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon26;

  anon26:
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#8)));
    goto anon49_Then, anon49_Else;

  anon49_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Equal($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](230,104)"} true;
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)));
    assume false;
    goto anon28;

  anon49_Else:
    goto anon28;

  anon28:
    assume (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](230,106)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:split_here} JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](231,65)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#6 := cs0#0;
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#6, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    goto anon50_Then, anon50_Else;

  anon50_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_0 := cs0#0;
    assume $IsAlloc(##cs0#2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    goto anon51_Then, anon51_Else;

  anon51_Then:
    push;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_0_0 := cs0#0;
    assume $IsAlloc(##cs0#2_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_0_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](234,69)"} true;
    pop;
    assume true;
    assume false;
    goto anon31;

  anon51_Else:
    goto anon31;

  anon31:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](235,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0 := cs0#0;
    assume $IsAlloc(##other#2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    goto anon52_Then, anon52_Else;

  anon52_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_1_0 := cs0#0;
    assume $IsAlloc(##other#2_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    goto anon53_Then, anon53_Else;

  anon53_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2_1_0_0 := cs0#0;
    assume $IsAlloc(##cs0#2_1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_1_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#2_1_0_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](238,71)"} true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon34;

  anon53_Else:
    goto anon34;

  anon34:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](239,10)"} true;
    assume true;
    assume false;
    goto anon35;

  anon52_Else:
    goto anon35;

  anon35:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#Z#0), cs0#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](240,8)"} true;
    assume true;
    assume true;
    assume false;
    goto anon36;

  anon50_Else:
    goto anon36;

  anon36:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](241,6)"} true;
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#2;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#0 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#0 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#0)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#0)));
axiom 3 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || (3 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#1 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#1 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#1)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#1)));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AppendLast (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))), elem#0: DatatypeType where $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())), sep#0: DatatypeType where $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())))) returns (elems'#2: DatatypeType where $Is(elems'#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AppendLast (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType) returns (elems'#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var e#3: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var ##s#0: Seq;
  var ##other#1: DatatypeType;
  var $lambdaHeap#1: Heap;
  var c#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var suffixed#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##ts#0: Seq;
  var ##ts#0_0: Seq;
  var ##t#0_0: DatatypeType;
  var ##ts#0_1: Seq;
  var ##t#0_1: DatatypeType;
  var ##ts#0_2: Seq;
  var ##ts#0_1_0: Seq;
  var ##e#0_1_0: DatatypeType;
  var ##ts#0_1_1: Seq;
  var ts0##0_1_0_0: Seq;
  var ts1##0_1_0_0: Seq;
  var pt##0_1_0_0: HandleType;
  var ##ts#0_1_0_0: Seq;
  var ##fT#0_1_0_0: HandleType;
  var ##ts#0_1_0_1: Seq;
  var ##fT#0_1_0_1: HandleType;
  var ##ts#0_1_0_2: Seq;
  var ##fT#0_1_0_2: HandleType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AppendLast", " | ", cs0#0, " | ", json#0, " | ", elems#0, " | ", elem#0, " | ", sep#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](245,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume $IsAllocBox($Box(elem#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon24_Then, anon24_Else;

  anon24_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon24_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon23_Else:
    goto anon5;

  anon5:
    ##cs0#2 := JSON_mUtils_mCursors.Split.cs(elem#0);
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))));
    havoc e#3;
    assume $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon25_Then, anon25_Else;

  anon25_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#3);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3));
    goto anon8;

  anon25_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    goto anon26_Then, anon26_Else;

  anon26_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume $IsAllocBox($Box(elems'#2), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#3 := cs0#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#2, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    ##s#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq;
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems'#2)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems'#2)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems'#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems'#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems'#2), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(sep#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#2);
    goto anon27_Then, anon27_Else;

  anon27_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc c#1;
    goto anon28_Then, anon28_Else;

  anon28_Then:
    assume {:partition} $Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := c#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon28_Else:
    assume {:partition} !($Is(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon27_Else:
    goto anon13;

  anon13:
    ##cs0#4 := JSON_mUtils_mCursors.Split.cs(elems'#2);
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elems'#2), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))));
    assume false;
    return;

  anon26_Else:
    havoc suffixed#Z#0;
    assume $Is(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(suffixed#Z#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume let#0#0#0 == #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty()));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $Is(let#0#0#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()));
    assume suffixed#Z#0 == let#0#0#0;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume let#1#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))), JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume $IsAllocBox($Box(cs0#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs0#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_0 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs0#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon30_Then, anon30_Else;

  anon30_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    assume $IsA#JSON_mGrammar.Value($Unbox(JSON_mUtils_mCursors.Split.t(elem#0)): DatatypeType) && $IsA#JSON_mGrammar.Value($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    assume JSON_mGrammar.Value#Equal($Unbox(JSON_mUtils_mCursors.Split.t(elem#0)): DatatypeType, $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](267,37)"} true;
    pop;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon17;

  anon30_Else:
    goto anon17;

  anon17:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](268,8)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    assume JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0);
    ##t#0_1 := $Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType;
    assume $IsAlloc(##t#0_1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0);
    ##ts#0_2 := $Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq;
    assume $IsAlloc(##ts#0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elem#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mGrammar.Suffixed.Suffixed_q(suffixed#Z#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(elems'#Z#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(JSON_mUtils_mCursors.Split.cs(elem#0));
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq);
    ##e#0_1_0 := suffixed#Z#0;
    assume $IsAlloc(##e#0_1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(suffixed#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##ts#0_1_1 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(suffixed#Z#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))));
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ts0##0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume true;
    ts1##0_1_0_0 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume 1 != $FunctionContextHeight;
    assume true;
    pt##0_1_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    call CallPre$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts0##0_1_0_0, ts1##0_1_0_0, pt##0_1_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](271,87)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_0 := $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq;
    assume $IsAlloc(##ts#0_1_0_0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_0: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)) } { Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) } $Is(d#0_1_0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_0, $Box(d#0_1_0_0)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_0, $Box(d#0_1_0_0)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_1 := Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0));
    assume $IsAlloc(##ts#0_1_0_1, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_1, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_1: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)) } { Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) } $Is(d#0_1_0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_1, $Box(d#0_1_0_1)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_1, $Box(d#0_1_0_1)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume 1 != $FunctionContextHeight;
    ##ts#0_1_0_2 := Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)));
    assume $IsAlloc(##ts#0_1_0_2, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    ##fT#0_1_0_2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle();
    assume $IsAlloc(##fT#0_1_0_2, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume {:subsumption 0} (forall d#0_1_0_2: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)) } { Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) } $Is(d#0_1_0_2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(##ts#0_1_0_2, $Box(d#0_1_0_2)) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, ##fT#0_1_0_2, $Box(d#0_1_0_2)));
    assume JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle());
    assume true;
    assume Seq#Equal(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LS($LZ)), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle())), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](272,181)"} true;
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume false;
    goto anon20;

  anon32_Else:
    goto anon20;

  anon20:
    assume Seq#Equal(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(suffixed#Z#0)), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#Z#0)))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](273,10)"} true;
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon21;

  anon31_Else:
    goto anon21;

  anon21:
    assume Seq#Equal(Seq#Append(Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(suffixed#Z#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](274,8)"} true;
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume false;
    goto anon22;

  anon29_Else:
    goto anon22;

  anon22:
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs0#0), Seq#Append(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox(JSON_mUtils_mCursors.Split.t(elems'#Z#0)): Seq), JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(elem#0))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](275,6)"} true;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#5 := cs0#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](277,65)"} true;
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, cs0#0, json#0, elems#0, elem#0, sep#0) == elems'#2;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var sp#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var s0#Z#0: int;
  var let#1#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var sp#Z#1: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##other#0: DatatypeType;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var sp#Z#2: DatatypeType;
  var let#3#0#0: DatatypeType;
  var $lambdaHeap#0: Heap;
  var st#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var sp#Z#3: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var sp#Z#4: DatatypeType;
  var let#5#0#0: DatatypeType;
  var $lambdaHeap#1: Heap;
  var st#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: Seq;
  var ##self#1: DatatypeType;
  var ##fT#1: HandleType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](281,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](283,8): post-state"} true;
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume sp#Z#0 == let#0#0#0;
    havoc s0#Z#0;
    assume LitInt(-1) <= s0#Z#0 && s0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume let#1#0#0 == JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType)): DatatypeType);
    assume $Is(let#1#0#0, Tclass.BoundedInts.opt__byte());
    assume s0#Z#0 == let#1#0#0;
    goto anon29_Then, anon29_Else;

  anon29_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon3;

  anon29_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon3;

  anon3:
    goto anon30_Then, anon30_Else;

  anon30_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon5;

  anon30_Else:
    assume {:partition} !(!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0));
    goto anon5;

  anon5:
    goto anon31_Then, anon31_Else;

  anon31_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    havoc sp#Z#1;
    assume $Is(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#2#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sp#Z#1 == let#2#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#0 := cs#0;
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0);
    goto anon7;

  anon31_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    goto anon7;

  anon7:
    goto anon32_Then, anon32_Else;

  anon32_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0));
    newtype$check#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon33_Then, anon33_Else;

  anon33_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    havoc sp#Z#2;
    assume $Is(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#3#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sp#Z#2 == let#3#0#0;
    assume $IsAllocBox($Box(sp#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    goto anon34_Then, anon34_Else;

  anon34_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc st#0;
    goto anon35_Then, anon35_Else;

  anon35_Then:
    assume {:partition} $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := st#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon12;

  anon35_Else:
    assume {:partition} !($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#0));
    goto anon12;

  anon12:
    assume false;
    goto anon13;

  anon34_Else:
    goto anon13;

  anon13:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: $IsBox($l#1#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1#heap#0: Heap, $l#1#st#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#Z#2, cs#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#2#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: $IsBox($l#2#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#2#heap#0: Heap, $l#2#st#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ))));
    goto anon14;

  anon33_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    goto anon14;

  anon32_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0)));
    goto anon14;

  anon14:
    goto anon36_Then, anon36_Else;

  anon36_Then:
    assume {:partition} ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))));
    goto anon37_Then, anon37_Else;

  anon37_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon17;

  anon37_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0);
    goto anon17;

  anon17:
    goto anon38_Then, anon38_Else;

  anon38_Then:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0);
    newtype$check#4 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon19;

  anon38_Else:
    assume {:partition} !(!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0));
    goto anon19;

  anon19:
    goto anon39_Then, anon39_Else;

  anon39_Then:
    assume {:partition} (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    havoc sp#Z#3;
    assume $Is(sp#Z#3, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sp#Z#3, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume let#4#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume sp#Z#3 == let#4#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(sp#Z#3);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sp#Z#3)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#1 := cs#0;
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sp#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#3), cs#0);
    goto anon21;

  anon39_Else:
    assume {:partition} !((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    goto anon21;

  anon36_Else:
    assume {:partition} !(((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#3#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: $IsBox($l#3#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#3#heap#0: Heap, $l#3#st#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))))));
    goto anon21;

  anon21:
    goto anon40_Then, anon40_Else;

  anon40_Then:
    assume {:partition} ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#2 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#2), cs#0)));
    newtype$check#6 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon41_Then, anon41_Else;

  anon41_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    havoc sp#Z#4;
    assume $Is(sp#Z#4, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sp#Z#4, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume let#5#0#0 == sp#Z#0;
    assume true;
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume sp#Z#4 == let#5#0#0;
    assume $IsAllocBox($Box(sp#Z#4), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    goto anon42_Then, anon42_Else;

  anon42_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc st#1;
    goto anon43_Then, anon43_Else;

  anon43_Then:
    assume {:partition} $Is(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    ##self#1 := st#1;
    assume $IsAlloc(##self#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1);
    ##fT#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), st#1, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1, TSeq(Tclass.BoundedInts.uint8()));
    goto anon26;

  anon43_Else:
    assume {:partition} !($Is(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(st#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#1));
    goto anon26;

  anon26:
    assume false;
    goto anon27;

  anon42_Else:
    goto anon27;

  anon27:
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#5#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: $IsBox($l#5#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#5#heap#0: Heap, $l#5#st#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#Z#4, cs#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#6#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: $IsBox($l#6#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#6#heap#0: Heap, $l#6#st#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    goto anon28;

  anon41_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    goto anon28;

  anon40_Else:
    assume {:partition} !(((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#0 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#0), cs#0))) && (s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#1 := sp#Z#0; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#1, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: $IsBox($l#7#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#st#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#2 := sp#Z#0; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#2), cs#0))));
    goto anon28;

  anon28:
    assume (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: $IsBox($l#8#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#st#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))))) && ((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#9#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: $IsBox($l#9#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#st#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))))));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0));
  modifies $Heap;
  free ensures JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; (forall $l#10#st#0: DatatypeType :: $Is($l#10#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#10#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: $IsBox($l#11#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#st#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))))) && ((s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $IsBox($l#14#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))))) ==> (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#7 := sp#3; (forall $l#12#st#0: DatatypeType :: $Is($l#12#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $l#12#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#13#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: $IsBox($l#13#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#st#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))))))));
  free ensures {:id "id27549"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#4)), JSON_mUtils_mCursors.Cursor__.s(cs#0)) && JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#4)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0) && JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#4)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id27550"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $IsBox($l#15#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#16#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $IsBox($l#16#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#21#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $IsBox($l#21#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))))));
  free ensures {:id "id27551"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#6)), JSON_mUtils_mCursors.Cursor__.s(cs#0)) && JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#6)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0) && JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#6)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id27552"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#22#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: $IsBox($l#22#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#22#heap#0: Heap, $l#22#st#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#23#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: $IsBox($l#23#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#st#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#28#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: $IsBox($l#28#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#st#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0)) returns ($_reverifyPost: bool);
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0))) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; (forall $l#29#st#0: DatatypeType :: $Is($l#29#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#29#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#30#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: $IsBox($l#30#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#30#heap#0: Heap, $l#30#st#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))))) && ((s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#33#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: $IsBox($l#33#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#33#heap#0: Heap, $l#33#st#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))))) ==> (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) && (((!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0))) ==> s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#7 := sp#3; (forall $l#31#st#0: DatatypeType :: $Is($l#31#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $l#31#st#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#32#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: $IsBox($l#32#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#32#heap#0: Heap, $l#32#st#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))))))));
  free ensures {:id "id27553"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#4)), JSON_mUtils_mCursors.Cursor__.s(cs#0)))));
  free ensures {:id "id27554"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#4)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0))));
  free ensures {:id "id27555"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#4 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#4), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#4)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id27556"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#34#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $IsBox($l#34#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#35#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $IsBox($l#35#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#5), cs#0)))));
  free ensures {:id "id27557"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> (var sp#5 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#34#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: $IsBox($l#34#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#34#heap#0: Heap, $l#34#st#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#35#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: $IsBox($l#35#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#35#heap#0: Heap, $l#35#st#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#36#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: $IsBox($l#36#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#36#heap#0: Heap, $l#36#st#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sp#5, cs#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#37#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: $IsBox($l#37#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#37#heap#0: Heap, $l#37#st#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#38#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: $IsBox($l#38#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#38#heap#0: Heap, $l#38#st#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#5))))))));
  free ensures {:id "id27558"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#6)), JSON_mUtils_mCursors.Cursor__.s(cs#0)))));
  free ensures {:id "id27559"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#6)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0))));
  free ensures {:id "id27560"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); (!JSON_mUtils_mCursors.Cursor__.BOF_q(cs#0) || !JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0)) && s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#6 := sp#3; JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#6), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#6)) == JSON_mUtils_mCursors.Cursor__.end(cs#0))));
  free ensures {:id "id27561"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $IsBox($l#41#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#42#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $IsBox($l#42#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#7), cs#0)))));
  free ensures {:id "id27562"} (var sp#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)): DatatypeType); s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var sp#7 := sp#3; JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: $IsBox($l#41#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#st#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#42#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: $IsBox($l#42#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#st#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#43#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: $IsBox($l#43#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#st#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sp#7, cs#0, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#44#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: $IsBox($l#44#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#44#heap#0: Heap, $l#44#st#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#45#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: $IsBox($l#45#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#45#heap#0: Heap, $l#45#st#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#7))))))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](289,4): initial state"} true;
    $_reverifyPost := false;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutLists (well-formedness)"} {:vcs_split_on_every_assert} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutLists (call precondtion)"} {:vcs_split_on_every_assert} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  requires {:id "id27568"} LitInt(0) <= i#0;
  requires {:id "id27569"} i#0 < Seq#Length(xs#0);



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutLists (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32());
  modifies $Heap;
  free ensures true;
  free ensures {:id "id27570"} Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutLists (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T: Ty, xs#0: Seq where $Is(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T)) && $IsAlloc(xs#0, TSeq(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T), $Heap), i#0: int where LitInt(0) <= i#0 && i#0 < BoundedInts.__default.TWO__TO__THE__32()) returns ($_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  requires {:id "id27571"} LitInt(0) <= i#0;
  requires {:id "id27572"} i#0 < Seq#Length(xs#0);
  modifies $Heap;
  free ensures true;
  free ensures {:id "id27573"} $_reverifyPost ==> Seq#Equal(Seq#Drop(Seq#Take(xs#0, i#0 + 1), i#0), Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, i#0)));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutLists (correctness)"} {:vcs_split_on_every_assert} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T: Ty, xs#0: Seq, i#0: int) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](294,4): initial state"} true;
    $_reverifyPost := false;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) : DatatypeType
uses {
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var elem#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#0) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#0)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#0)) && (var sep#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#0)); JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) && (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType); (s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType)) && (s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#1 := sep#0; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1) && (var elems#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#1)))) && (!(s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType)) && (s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#2 := sep#0; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2) && (var elems'#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#0, sep#2))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#0) else (var elem#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#0)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#0)); (var s0#0 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType); (if s0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#1 := sep#0; (var elems#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#1); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#1))) else (if s0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#0)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#2 := sep#0; (var elems'#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#0, sep#2); (var bracketed#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#0, sep#2); #Wrappers.Result.Success($Box(bracketed#0))))) else (var separator#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#0 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#0)), s0#0))); pr#0)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#2: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#2) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#2)) } $Is(e#2, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#2)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#2)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var elem#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#1) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#1)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#1)) && (var sep#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#1)); JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) && (var s0#1 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType); (s0#1 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType)) && (s0#1 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#4 := sep#3; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4) && (var elems#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#2)))) && (!(s0#1 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#1 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#3) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType)) && (s0#1 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#5 := sep#3; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5) && (var elems'#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#1, sep#5))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#1) else (var elem#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#1)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#1)); (var s0#1 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType); (if s0#1 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#4 := sep#3; (var elems#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#4); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#2))) else (if s0#1 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#3)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#5 := sep#3; (var elems'#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#1, sep#5); (var bracketed#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#1, sep#5); #Wrappers.Result.Success($Box(bracketed#1))))) else (var separator#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#1 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#1)), s0#1))); pr#1)))))))))));
axiom 4 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || (4 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#3: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3)) } $Is(e#3, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#3)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var elem#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#2) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#2)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#2)) && (var sep#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#2)); JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) && (var s0#2 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType); (s0#2 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType)) && (s0#2 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#7 := sep#6; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7) && (var elems#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#3)))) && (!(s0#2 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#2 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#6) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType)) && (s0#2 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#8 := sep#6; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8) && (var elems'#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#2, sep#8))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#2) else (var elem#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#2)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#2)); (var s0#2 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType); (if s0#2 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#7 := sep#6; (var elems#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#7); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#3))) else (if s0#2 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#6)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#8 := sep#6; (var elems'#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#2, sep#8); (var bracketed#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#2, sep#8); #Wrappers.Result.Success($Box(bracketed#2))))) else (var separator#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#2 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#2)), s0#2))); pr#2)))))))))));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), $reveal, cs0#0, json#0, open#0, elems#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), $reveal, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0));

axiom (forall $ly: LayerType, $reveal: bool, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements(AsFuelBottom($ly), $reveal, cs0#0, json#0, open#0, elems#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LZ, $reveal, cs0#0, json#0, open#0, elems#0));

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires(LayerType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) } $Is(e#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1)))));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Elements (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements(cs0#0: DatatypeType where $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()), open#0: DatatypeType where $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), elems#0: DatatypeType where $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))))) returns (pr#3: DatatypeType where $Is(pr#3, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 4 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, $Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] } Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: DatatypeType, $fh$0x#2: DatatypeType, $fh$0x#3: DatatypeType, $fh$0x#4: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Unbox(Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle($reveal), $Box($fh$0x#0), $Box($fh$0x#1), $Box($fh$0x#2), $Box($fh$0x#3), $Box($fh$0x#4))): DatatypeType);

function JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, $Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) } Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires($Unbox($fh$0x#0): DatatypeType, $Unbox($fh$0x#1): DatatypeType, $Unbox($fh$0x#2): DatatypeType, $Unbox($fh$0x#3): DatatypeType, $Unbox($fh$0x#4): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box, $fh$0x#2: Box, $fh$0x#3: Box, $fh$0x#4: Box :: { Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] } Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType, $fh$0x#1: DatatypeType, $fh$0x#2: DatatypeType, $fh$0x#3: DatatypeType, $fh$0x#4: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, $fh$0x#0, $fh$0x#1, $fh$0x#2, $fh$0x#3, $fh$0x#4) == $Unbox(Apply5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle($reveal), $Box($fh$0x#0), $Box($fh$0x#1), $Box($fh$0x#2), $Box($fh$0x#3), $Box($fh$0x#4))): DatatypeType);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Elements (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements(cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType) returns (pr#3: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var c#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##self#0: DatatypeType;
  var ##fT#0: HandleType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##other#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var e#4: DatatypeType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##json#0: DatatypeType;
  var elem#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var cs##0: DatatypeType;
  var sep#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var s0#Z#0: int;
  var let#3#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var ##c#0: char;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var newtype$check#0_0_1_2: int;
  var ##idx#0_0_1_0: int;
  var newtype$check#0_0_1_3: int;
  var newtype$check#0_0_1_4: int;
  var newtype$check#0_0_1_5: int;
  var newtype$check#0_0_1_6: int;
  var newtype$check#0_0_2_0: int;
  var ##idx#0_0_2_0: int;
  var newtype$check#0_0_2_1: int;
  var newtype$check#0_0_2_2: int;
  var newtype$check#0_0_2_3: int;
  var newtype$check#0_0_2_4: int;
  var newtype$check#0_0_2_5: int;
  var newtype$check#0_0_2_6: int;
  var newtype$check#0_0_2_7: int;
  var newtype$check#0_0_2_8: int;
  var newtype$check#0_0_3_0: int;
  var newtype$check#0_0_3_1: int;
  var newtype$check#0_0_3_2: int;
  var newtype$check#0_0_3_3: int;
  var xs##0_0_4_0_0: Seq;
  var i##0_0_4_0_0: int;
  var newtype$check#0_0_5_0_0: int;
  var ##c#0_0_7_0: int;
  var ##c#0_0_8_0: int;
  var newtype$check#0_0_8_0: int;
  var newtype$check#0_0_8_1: int;
  var ##c#0_0_8_1: int;
  var newtype$check#0_0_9_0: int;
  var newtype$check#0_0_9_1: int;
  var ##c#0_0_9_0: int;
  var ##c#0_0_9_1: char;
  var sep#Z#1: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##x0#0: DatatypeType;
  var ##x1#0: DatatypeType;
  var ##x2#0: DatatypeType;
  var ##x3#0: DatatypeType;
  var ##x4#0: DatatypeType;
  var ##other#1_0: DatatypeType;
  var ##cs0#1_0: DatatypeType;
  var ##spec#1_0: HandleType;
  var ##cs0#1_1: DatatypeType;
  var ##spec#1_1: HandleType;
  var $lambdaHeap#1_0: Heap;
  var c#1_0: DatatypeType;
  var $_Frame#l1_0: [ref,Field]bool;
  var lambdaResult#1_0: Seq;
  var ##self#1_0: DatatypeType;
  var ##fT#1_0: HandleType;
  var ##cs0#1_2: DatatypeType;
  var ##spec#1_2: HandleType;
  var $lambdaHeap#1_0_0: Heap;
  var c#1_0_0: DatatypeType;
  var $_Frame#l1_0_0: [ref,Field]bool;
  var lambdaResult#1_0_0: Seq;
  var ##self#1_0_0: DatatypeType;
  var ##fT#1_0_0: HandleType;
  var ##cs0#1_0_0: DatatypeType;
  var ##spec#1_0_0: HandleType;
  var $lambdaHeap#1_0_0_0: Heap;
  var c#1_0_0_0: DatatypeType;
  var $_Frame#l1_0_0_0: [ref,Field]bool;
  var lambdaResult#1_0_0_0: Seq;
  var ##self#1_0_0_0: DatatypeType;
  var ##fT#1_0_0_0: HandleType;
  var ##cs0#1_0_0_0: DatatypeType;
  var ##spec#1_0_0_0: HandleType;
  var ##other#1_0_0: DatatypeType;
  var ##other#1_0_1_0: DatatypeType;
  var e#1_0: DatatypeType;
  var elems#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##json#1: DatatypeType;
  var ##elems#0: DatatypeType;
  var ##elem#0: DatatypeType;
  var ##sep#0: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##json#2: DatatypeType;
  var ##open#0: DatatypeType;
  var ##elems#1: DatatypeType;
  var newtype$check#3: int;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var ##c#1: int;
  var newtype$check#2_0_0_0: int;
  var newtype$check#2_0_0_1: int;
  var newtype$check#2_0_1_0: int;
  var newtype$check#2_0_1_1: int;
  var newtype$check#2_0_1_2: int;
  var ##idx#2_0_1_0: int;
  var newtype$check#2_0_1_3: int;
  var newtype$check#2_0_1_4: int;
  var newtype$check#2_0_1_5: int;
  var newtype$check#2_0_1_6: int;
  var newtype$check#2_0_2_0: int;
  var ##idx#2_0_2_0: int;
  var newtype$check#2_0_2_1: int;
  var newtype$check#2_0_2_2: int;
  var newtype$check#2_0_2_3: int;
  var newtype$check#2_0_2_4: int;
  var newtype$check#2_0_2_5: int;
  var newtype$check#2_0_2_6: int;
  var newtype$check#2_0_2_7: int;
  var newtype$check#2_0_2_8: int;
  var newtype$check#2_0_3_0: int;
  var newtype$check#2_0_3_1: int;
  var newtype$check#2_0_3_2: int;
  var newtype$check#2_0_3_3: int;
  var xs##2_0_4_0_0: Seq;
  var i##2_0_4_0_0: int;
  var newtype$check#2_0_5_0_0: int;
  var ##c#2_0_7_0: int;
  var sep#Z#2: DatatypeType;
  var let#6#0#0: DatatypeType;
  var ##x0#1: DatatypeType;
  var ##x1#1: DatatypeType;
  var ##x2#1: DatatypeType;
  var ##x3#1: DatatypeType;
  var ##x4#1: DatatypeType;
  var ##other#3_0: DatatypeType;
  var ##cs0#3_0: DatatypeType;
  var ##spec#3_0: HandleType;
  var ##cs0#3_1: DatatypeType;
  var ##spec#3_1: HandleType;
  var $lambdaHeap#3_0: Heap;
  var c#3_0: DatatypeType;
  var $_Frame#l3_0: [ref,Field]bool;
  var lambdaResult#3_0: Seq;
  var ##self#3_0: DatatypeType;
  var ##fT#3_0: HandleType;
  var ##cs0#3_2: DatatypeType;
  var ##spec#3_2: HandleType;
  var $lambdaHeap#3_0_0: Heap;
  var c#3_0_0: DatatypeType;
  var $_Frame#l3_0_0: [ref,Field]bool;
  var lambdaResult#3_0_0: Seq;
  var ##self#3_0_0: DatatypeType;
  var ##fT#3_0_0: HandleType;
  var ##cs0#3_0_0: DatatypeType;
  var ##spec#3_0_0: HandleType;
  var $lambdaHeap#3_0_0_0: Heap;
  var c#3_0_0_0: DatatypeType;
  var $_Frame#l3_0_0_0: [ref,Field]bool;
  var lambdaResult#3_0_0_0: Seq;
  var ##self#3_0_0_0: DatatypeType;
  var ##fT#3_0_0_0: HandleType;
  var ##cs0#3_0_0_0: DatatypeType;
  var ##spec#3_0_0_0: HandleType;
  var ##other#3_0_0: DatatypeType;
  var ##other#3_0_1_0: DatatypeType;
  var e#3_0: DatatypeType;
  var elems'#Z#0: DatatypeType;
  var let#7#0#0: DatatypeType;
  var ##cs0#5: DatatypeType;
  var ##json#3: DatatypeType;
  var ##elems#2: DatatypeType;
  var ##elem#1: DatatypeType;
  var ##sep#1: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#3: HandleType;
  var ##cs0#4_0: DatatypeType;
  var ##spec#4_0: HandleType;
  var bracketed#Z#0: DatatypeType;
  var let#8#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##open#1: DatatypeType;
  var ##elems#3: DatatypeType;
  var ##close#0: DatatypeType;
  var ##cs0#7: DatatypeType;
  var ##spec#4: HandleType;
  var separator#Z#0: int;
  var let#9#0#0: int;
  var pr#Z#0: DatatypeType;
  var let#10#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Elements", " | ", cs0#0, " | ", json#0, " | ", open#0, " | ", elems#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](298,69): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(open#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    goto anon113_Then, anon113_Else;

  anon113_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc c#0;
    goto anon114_Then, anon114_Else;

  anon114_Then:
    assume {:partition} $Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    ##self#0 := c#0;
    assume $IsAlloc(##self#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $lambdaHeap#0);
    ##fT#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon4;

  anon114_Else:
    assume {:partition} !($Is(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())) && $IsAlloc(c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), $lambdaHeap#0));
    goto anon4;

  anon4:
    assume false;
    goto anon5;

  anon113_Else:
    goto anon5;

  anon5:
    ##cs0#0 := cs0#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#5#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: $IsBox($l#5#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#5#heap#0: Heap, $l#5#c#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#6#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: $IsBox($l#6#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#6#heap#0: Heap, $l#6#c#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    havoc e#4;
    assume $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon115_Then, anon115_Else;

  anon115_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#4);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4));
    goto anon8;

  anon115_Else:
    assume Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4));
    goto anon8;

  anon8:
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(JSON_mUtils_mCursors.Split.cs(elems#0));
    goto anon116_Then, anon116_Else;

  anon116_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon117_Then, anon117_Else;

  anon117_Then:
    assume Wrappers.Result.Success_q(pr#3);
    assume Wrappers.Result.Success_q(pr#3);
    assume $IsAllocBox(Wrappers.Result.value(pr#3), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#2 := cs0#0;
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    goto anon12;

  anon117_Else:
    assume Wrappers.Result.Success_q(pr#3) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#3)): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    goto anon12;

  anon12:
    assume false;
    return;

  anon116_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    ##cs#0 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(##cs#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(##cs#0), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.beg(##cs#0) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.end(##cs#0) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#0, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon118_Then, anon118_Else;

  anon118_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon118_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc elem#Z#0;
    assume $Is(elem#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()));
    assume elem#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon119_Then, anon119_Else;

  anon119_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0) == Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon119_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    cs##0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs##0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](316,34)"} true;
    havoc sep#Z#0;
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))) && $IsAlloc(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#Z#0)));
    assume let#2#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt())));
    assume sep#Z#0 == let#2#0#0;
    havoc s0#Z#0;
    assume LitInt(-1) <= s0#Z#0 && s0#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume let#3#0#0 == JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Is(let#3#0#0, Tclass.BoundedInts.opt__byte());
    assume s0#Z#0 == let#3#0#0;
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon120_Then, anon120_Else;

  anon120_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#2 := LitInt(1);
    assume LitInt(0) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon19;

  anon120_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    goto anon19;

  anon19:
    goto anon121_Then, anon121_Else;

  anon121_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} char#ToInt(##c#0) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    goto anon122_Then, anon122_Else;

  anon122_Then:
    goto anon123_Then, anon123_Else;

  anon123_Then:
    assume true;
    assume false;
    goto anon37;

  anon123_Else:
    goto anon124_Then, anon124_Else;

  anon124_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_9_0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_9_0 && newtype$check#0_0_9_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_9_1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_9_1 && newtype$check#0_0_9_1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0_0_9_0 := char#ToInt(Lit(char#FromInt(44)));
    assume $IsAlloc(##c#0_0_9_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_9_1 := Lit(char#FromInt(44));
    assume $IsAlloc(##c#0_0_9_1, TChar, $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} char#ToInt(##c#0_0_9_1) < 256;
    assume JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume true;
    assume false;
    goto anon37;

  anon124_Else:
    goto anon125_Then, anon125_Else;

  anon125_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_8_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0_8_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_8_0 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_8_0 && newtype$check#0_0_8_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_8_1 := char#ToInt(Lit(char#FromInt(44)));
    assume LitInt(0) <= newtype$check#0_0_8_1 && newtype$check#0_0_8_1 < BoundedInts.__default.TWO__TO__THE__8();
    ##c#0_0_8_1 := char#ToInt(Lit(char#FromInt(44)));
    assume $IsAlloc(##c#0_0_8_1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, char#ToInt(Lit(char#FromInt(44))));
    assume true;
    assume false;
    goto anon37;

  anon125_Else:
    goto anon126_Then, anon126_Else;

  anon126_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0_7_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0_7_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume true;
    assume false;
    goto anon37;

  anon126_Else:
    goto anon127_Then, anon127_Else;

  anon127_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon127_Else:
    goto anon128_Then, anon128_Else;

  anon128_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon129_Then, anon129_Else;

  anon129_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#0_0_5_0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#0_0_5_0_0 && newtype$check#0_0_5_0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](327,105)"} true;
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume false;
    goto anon29;

  anon129_Else:
    goto anon29;

  anon29:
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](327,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon128_Else:
    goto anon130_Then, anon130_Else;

  anon130_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon131_Then, anon131_Else;

  anon131_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    xs##0_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    i##0_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##0_0_4_0_0, i##0_0_4_0_0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##0_0_4_0_0, i##0_0_4_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](329,155)"} true;
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume false;
    goto anon32;

  anon131_Else:
    goto anon32;

  anon32:
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](329,157)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon130_Else:
    goto anon132_Then, anon132_Else;

  anon132_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#0_0_3_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_3_0 && newtype$check#0_0_3_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_1 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_3_1 && newtype$check#0_0_3_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_3_2 && newtype$check#0_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_3_3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_3_3 && newtype$check#0_0_3_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon132_Else:
    goto anon133_Then, anon133_Else;

  anon133_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#0_0_2_0 && newtype$check#0_0_2_0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0_0_2_0 := LitInt(0);
    assume $IsAlloc(##idx#0_0_2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_2_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_2_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#0_0_2_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#0_0_2_1 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_2_1 && newtype$check#0_0_2_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_2 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_2_2 && newtype$check#0_0_2_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_3 && newtype$check#0_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_4 && newtype$check#0_0_2_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#0_0_2_5 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_2_5 && newtype$check#0_0_2_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_6 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#0_0_2_6 && newtype$check#0_0_2_6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_7 && newtype$check#0_0_2_7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_2_8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_2_8 && newtype$check#0_0_2_8 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon37;

  anon133_Else:
    goto anon134_Then, anon134_Else;

  anon134_Then:
    newtype$check#0_0_1_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_0 && newtype$check#0_0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_1 && newtype$check#0_0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#0_0_1_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#0_0_1_2 && newtype$check#0_0_1_2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#0_0_1_0 := LitInt(0);
    assume $IsAlloc(##idx#0_0_1_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_1_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#0_0_1_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#0_0_1_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#0_0_1_3 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_1_3 && newtype$check#0_0_1_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_4 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#0_0_1_4 && newtype$check#0_0_1_4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_5 && newtype$check#0_0_1_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_1_6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_1_6 && newtype$check#0_0_1_6 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume true;
    assume false;
    goto anon37;

  anon134_Else:
    goto anon135_Then, anon135_Else;

  anon135_Then:
    assume true;
    assume true;
    newtype$check#0_0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_0_0 && newtype$check#0_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#0_0_0_1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume LitInt(-1) <= newtype$check#0_0_0_1 && newtype$check#0_0_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume true;
    assume false;
    goto anon37;

  anon135_Else:
    goto anon37;

  anon37:
    assume true ==> JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume true;
    assume false;
    goto anon38;

  anon122_Else:
    goto anon38;

  anon38:
    assume JSON_mUtils_mViews_mCore.View__.Char_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, Lit(char#FromInt(44)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](336,10)"} true;
    havoc sep#Z#1;
    assume $Is(sep#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume let#4#0#0 == sep#Z#0;
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())));
    assume sep#Z#1 == let#4#0#0;
    assume 3 != $FunctionContextHeight;
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix)), Tclass._System.___hFunc5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##x0#0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##x0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##x1#0 := json#0;
    assume $IsAlloc(##x1#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##x2#0 := elems#0;
    assume $IsAlloc(##x2#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##x3#0 := elem#Z#0;
    assume $IsAlloc(##x3#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##x4#0 := sep#Z#1;
    assume $IsAlloc(##x4#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix), $Box(##x0#0), $Box(##x1#0), $Box(##x2#0), $Box(##x3#0), $Box(##x4#0))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    goto anon136_Then, anon136_Else;

  anon136_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:focus} true;
    assume {:focus} true;
    assume {:focus} true;
    assume {:focus} true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](339,64)"} true;
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#1_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#1_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](340,66)"} true;
    assume $IsAllocBox($Box(elem#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#1_1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](341,65)"} true;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon137_Then, anon137_Else;

  anon137_Then:
    havoc $lambdaHeap#1_0;
    assume $IsGoodHeap($lambdaHeap#1_0);
    assume $Heap == $lambdaHeap#1_0 || $HeapSucc($Heap, $lambdaHeap#1_0);
    havoc c#1_0;
    goto anon138_Then, anon138_Else;

  anon138_Then:
    assume {:partition} $Is(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0);
    $_Frame#l1_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0, $o, alloc)): bool ==> false);
    ##self#1_0 := c#1_0;
    assume $IsAlloc(##self#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0);
    ##fT#1_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon42;

  anon138_Else:
    assume {:partition} !($Is(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0));
    goto anon42;

  anon42:
    assume false;
    goto anon43;

  anon137_Else:
    goto anon43;

  anon43:
    ##cs0#1_2 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_2 := Lit(AtLayer((lambda $l#1_1#ly#0: LayerType :: Handle1((lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: $IsBox($l#1_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_1#heap#0: Heap, $l#1_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_2#ly#0: LayerType :: Handle1((lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: $IsBox($l#1_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_2#heap#0: Heap, $l#1_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_3#c#0: DatatypeType :: $Is($l#1_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_4#ly#0: LayerType :: Handle1((lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: $IsBox($l#1_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_4#heap#0: Heap, $l#1_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon139_Then, anon139_Else;

  anon139_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon140_Then, anon140_Else;

  anon140_Then:
    havoc $lambdaHeap#1_0_0;
    assume $IsGoodHeap($lambdaHeap#1_0_0);
    assume $Heap == $lambdaHeap#1_0_0 || $HeapSucc($Heap, $lambdaHeap#1_0_0);
    havoc c#1_0_0;
    goto anon141_Then, anon141_Else;

  anon141_Then:
    assume {:partition} $Is(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0);
    $_Frame#l1_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0_0, $o, alloc)): bool ==> false);
    ##self#1_0_0 := c#1_0_0;
    assume $IsAlloc(##self#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0);
    ##fT#1_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon47;

  anon141_Else:
    assume {:partition} !($Is(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0));
    goto anon47;

  anon47:
    assume false;
    goto anon48;

  anon140_Else:
    goto anon48;

  anon48:
    ##cs0#1_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0 := Lit(AtLayer((lambda $l#1_0_1#ly#0: LayerType :: Handle1((lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: $IsBox($l#1_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_1#heap#0: Heap, $l#1_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_2#ly#0: LayerType :: Handle1((lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: $IsBox($l#1_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_2#heap#0: Heap, $l#1_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_0_3#c#0: DatatypeType :: $Is($l#1_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_4#ly#0: LayerType :: Handle1((lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: $IsBox($l#1_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_4#heap#0: Heap, $l#1_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon142_Then, anon142_Else;

  anon142_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon143_Then, anon143_Else;

  anon143_Then:
    havoc $lambdaHeap#1_0_0_0;
    assume $IsGoodHeap($lambdaHeap#1_0_0_0);
    assume $Heap == $lambdaHeap#1_0_0_0 || $HeapSucc($Heap, $lambdaHeap#1_0_0_0);
    havoc c#1_0_0_0;
    goto anon144_Then, anon144_Else;

  anon144_Then:
    assume {:partition} $Is(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0);
    $_Frame#l1_0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1_0_0_0, $o, alloc)): bool ==> false);
    ##self#1_0_0_0 := c#1_0_0_0;
    assume $IsAlloc(##self#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0);
    ##fT#1_0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#1_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jcomma(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#1_0_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#1_0_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), c#1_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#1_0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon52;

  anon144_Else:
    assume {:partition} !($Is(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(c#1_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $lambdaHeap#1_0_0_0));
    goto anon52;

  anon52:
    assume false;
    goto anon53;

  anon143_Else:
    goto anon53;

  anon53:
    ##cs0#1_0_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#1_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0_0_0 := Lit(AtLayer((lambda $l#1_0_0_1#ly#0: LayerType :: Handle1((lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: $IsBox($l#1_0_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_1#heap#0: Heap, $l#1_0_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#1_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_2#ly#0: LayerType :: Handle1((lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: $IsBox($l#1_0_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_2#heap#0: Heap, $l#1_0_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#1_0_0_3#c#0: DatatypeType :: $Is($l#1_0_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mGrammar.jcomma(), $l#1_0_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_4#ly#0: LayerType :: Handle1((lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: $IsBox($l#1_0_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_4#heap#0: Heap, $l#1_0_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_4#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_0_12#ly#0: LayerType :: Handle1((lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_0_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: $IsBox($l#1_0_0_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_0_12#heap#0: Heap, $l#1_0_0_12#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_0_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](344,81)"} true;
    pop;
    assume true;
    assume false;
    goto anon54;

  anon142_Else:
    goto anon54;

  anon54:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_0_9#ly#0: LayerType :: Handle1((lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: $IsBox($l#1_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_0_9#heap#0: Heap, $l#1_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#1_0_9#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](345,14)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#1_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#1_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon145_Then, anon145_Else;

  anon145_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](347,34)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#1)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#1_0_1_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#1_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#1) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon146_Then, anon146_Else;

  anon146_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](349,38)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon57;

  anon146_Else:
    goto anon57;

  anon57:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](350,16)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon58;

  anon145_Else:
    goto anon58;

  anon58:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#1), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](351,14)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon59;

  anon139_Else:
    goto anon59;

  anon59:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#Z#1, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#1_12#ly#0: LayerType :: Handle1((lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#1_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: $IsBox($l#1_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#1_12#heap#0: Heap, $l#1_12#c#0: Box :: SetRef_to_SetBox((lambda $l#1_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](352,12)"} true;
    havoc e#1_0;
    goto anon147_Then, anon147_Else;

  anon147_Then:
    assume {:partition} $Is(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon148_Then, anon148_Else;

  anon148_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#1_0);
    goto anon62;

  anon148_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_0));
    goto anon62;

  anon147_Else:
    assume {:partition} !($Is(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#1_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon62;

  anon62:
    assume (forall e#1_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) } $Is(e#1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#1_1)));
    assume (forall e#1_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#1_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) } $Is(e#1_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#1_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#1_1)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](353,64)"} true;
    assume true;
    assume {:split_here} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](354,37)"} true;
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume false;
    goto anon63;

  anon136_Else:
    goto anon63;

  anon63:
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#1));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](355,10)"} true;
    havoc elems#Z#0;
    assume $Is(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##cs0#3 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#1 := json#0;
    assume $IsAlloc(##json#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##elems#0 := elems#0;
    assume $IsAlloc(##elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##elem#0 := elem#Z#0;
    assume $IsAlloc(##elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##sep#0 := sep#Z#1;
    assume $IsAlloc(##sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#1)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mParsers.SubParser__.cs(##json#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), ##cs0#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#3), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, ##cs0#3, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elem#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elem#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#0, JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##sep#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##sep#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##sep#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#0), JSON_mUtils_mCursors.Split.cs(##elem#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##sep#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##sep#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##sep#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), ##sep#0, JSON_mUtils_mCursors.Split.cs(##elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1));
    assume let#5#0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#1);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems#Z#0 == let#5#0#0;
    ##cs0#4 := cs0#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#2 := json#0;
    assume $IsAlloc(##json#2, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##open#0 := open#0;
    assume $IsAlloc(##open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    ##elems#1 := elems#Z#0;
    assume $IsAlloc(##elems#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#0)), JSON_mUtils_mCursors.Cursor__.s(##cs0#4))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs0#4)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs0#4) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs0#4)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#4), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs0#4, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#2)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)));
    assume 0 <= JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) || JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(##elems#1)) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0) == JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon121_Else:
    assume {:partition} !(s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1));
    newtype$check#3 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#4 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon149_Then, anon149_Else;

  anon149_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#5 := LitInt(1);
    assume LitInt(0) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__32();
    goto anon66;

  anon149_Else:
    assume {:partition} s0#Z#0 != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    goto anon66;

  anon66:
    goto anon150_Then, anon150_Else;

  anon150_Then:
    assume {:partition} s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume $IsAlloc(##c#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    goto anon151_Then, anon151_Else;

  anon151_Then:
    goto anon152_Then, anon152_Else;

  anon152_Then:
    assume true;
    assume false;
    goto anon82;

  anon152_Else:
    goto anon153_Then, anon153_Else;

  anon153_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#2_0_7_0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume $IsAlloc(##c#2_0_7_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume true;
    assume false;
    goto anon82;

  anon153_Else:
    goto anon154_Then, anon154_Else;

  anon154_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon154_Else:
    goto anon155_Then, anon155_Else;

  anon155_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon156_Then, anon156_Else;

  anon156_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    newtype$check#2_0_5_0_0 := LitInt(1);
    assume LitInt(0) <= newtype$check#2_0_5_0_0 && newtype$check#2_0_5_0_0 < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](364,105)"} true;
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume false;
    goto anon74;

  anon156_Else:
    goto anon74;

  anon74:
    assume JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 == JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](364,107)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon155_Else:
    goto anon157_Then, anon157_Else;

  anon157_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    goto anon158_Then, anon158_Else;

  anon158_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    xs##2_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    i##2_0_4_0_0 := JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    call CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##2_0_4_0_0, i##2_0_4_0_0);
    call CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(Tclass.BoundedInts.uint8(), xs##2_0_4_0_0, i##2_0_4_0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](366,155)"} true;
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume false;
    goto anon77;

  anon158_Else:
    goto anon77;

  anon77:
    assume Seq#Equal(Seq#Drop(Seq#Take(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType)), Seq#Build(Seq#Empty(): Seq, Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](366,157)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + 1 <= Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon157_Else:
    goto anon159_Then, anon159_Else;

  anon159_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#2_0_3_0 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_3_0 && newtype$check#2_0_3_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_1 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_3_1 && newtype$check#2_0_3_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_2 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_3_2 && newtype$check#2_0_3_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_3_3 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_3_3 && newtype$check#2_0_3_3 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon159_Else:
    goto anon160_Then, anon160_Else;

  anon160_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2_0_2_0 := LitInt(0);
    assume LitInt(0) <= newtype$check#2_0_2_0 && newtype$check#2_0_2_0 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#2_0_2_0 := LitInt(0);
    assume $IsAlloc(##idx#2_0_2_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_2_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_2_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#2_0_2_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#2_0_2_1 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_2_1 && newtype$check#2_0_2_1 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_2 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_2_2 && newtype$check#2_0_2_2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_3 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_3 && newtype$check#2_0_2_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_4 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_4 && newtype$check#2_0_2_4 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} 0 <= JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) < Seq#Length(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType));
    newtype$check#2_0_2_5 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_2_5 && newtype$check#2_0_2_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_6 := $Unbox(Seq#Index(JSON_mUtils_mViews_mCore.View__.s($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType), JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType))): int;
    assume LitInt(-1) <= newtype$check#2_0_2_6 && newtype$check#2_0_2_6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_7 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_7 && newtype$check#2_0_2_7 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_2_8 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_2_8 && newtype$check#2_0_2_8 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) && JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.View_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume true;
    assume false;
    goto anon82;

  anon160_Else:
    goto anon161_Then, anon161_Else;

  anon161_Then:
    newtype$check#2_0_1_0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_0 && newtype$check#2_0_1_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_1 && newtype$check#2_0_1_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    newtype$check#2_0_1_2 := LitInt(0);
    assume LitInt(0) <= newtype$check#2_0_1_2 && newtype$check#2_0_1_2 < BoundedInts.__default.TWO__TO__THE__32();
    ##idx#2_0_1_0 := LitInt(0);
    assume $IsAlloc(##idx#2_0_1_0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.ValidIndex_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_1_0) ==> JSON_mUtils_mViews_mCore.View__.ValidIndex_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, ##idx#2_0_1_0) || JSON_mUtils_mViews_mCore.View__.beg($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) + ##idx#2_0_1_0 < JSON_mUtils_mViews_mCore.View__.end($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    newtype$check#2_0_1_3 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_1_3 && newtype$check#2_0_1_3 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_4 := JSON_mUtils_mViews_mCore.View__.At($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume LitInt(-1) <= newtype$check#2_0_1_4 && newtype$check#2_0_1_4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_5 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_5 && newtype$check#2_0_1_5 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_1_6 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_1_6 && newtype$check#2_0_1_6 < BoundedInts.__default.TWO__TO__THE__8();
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.At#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, LitInt(0));
    assume true;
    assume false;
    goto anon82;

  anon161_Else:
    goto anon162_Then, anon162_Else;

  anon162_Then:
    assume true;
    assume true;
    newtype$check#2_0_0_0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_0_0 && newtype$check#2_0_0_0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#2_0_0_1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#2_0_0_1 && newtype$check#2_0_0_1 < BoundedInts.__default.TWO__TO__THE__8();
    assume true;
    assume true;
    assume false;
    goto anon82;

  anon162_Else:
    goto anon82;

  anon82:
    assume true ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume true;
    assume false;
    goto anon83;

  anon151_Else:
    goto anon83;

  anon83:
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](373,10)"} true;
    havoc sep#Z#2;
    assume $Is(sep#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume $Is(sep#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume let#6#0#0 == sep#Z#0;
    assume true;
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume sep#Z#2 == let#6#0#0;
    assume 3 != $FunctionContextHeight;
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast)), Tclass._System.___hFunc5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##x0#1 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##x0#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##x1#1 := json#0;
    assume $IsAlloc(##x1#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##x2#1 := elems#0;
    assume $IsAlloc(##x2#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##x3#1 := elem#Z#0;
    assume $IsAlloc(##x3#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##x4#1 := sep#Z#2;
    assume $IsAlloc(##x4#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume {:subsumption 0} (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && Reads5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast), $Box(##x0#1), $Box(##x1#1), $Box(##x2#1), $Box(##x3#1), $Box(##x4#1))[$Box($o)] ==> $_ReadsFrame[$o, $f]);
    assume Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && Requires5#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    goto anon163_Then, anon163_Else;

  anon163_Then:
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(elems#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#3_0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(elems#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](376,55)"} true;
    assume $IsAllocBox($Box(elems#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#3_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](377,66)"} true;
    assume $IsAllocBox($Box(elem#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    assume true;
    ##cs0#3_1 := JSON_mUtils_mCursors.Split.cs(elems#0);
    assume $IsAlloc(##cs0#3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle();
    assume $IsAlloc(##spec#3_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#Z#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](378,65)"} true;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon164_Then, anon164_Else;

  anon164_Then:
    havoc $lambdaHeap#3_0;
    assume $IsGoodHeap($lambdaHeap#3_0);
    assume $Heap == $lambdaHeap#3_0 || $HeapSucc($Heap, $lambdaHeap#3_0);
    havoc c#3_0;
    goto anon165_Then, anon165_Else;

  anon165_Then:
    assume {:partition} $Is(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0);
    $_Frame#l3_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0, $o, alloc)): bool ==> false);
    ##self#3_0 := c#3_0;
    assume $IsAlloc(##self#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0);
    ##fT#3_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon87;

  anon165_Else:
    assume {:partition} !($Is(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#3_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0));
    goto anon87;

  anon87:
    assume false;
    goto anon88;

  anon164_Else:
    goto anon88;

  anon88:
    ##cs0#3_2 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_2 := Lit(AtLayer((lambda $l#3_1#ly#0: LayerType :: Handle1((lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: $IsBox($l#3_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_1#heap#0: Heap, $l#3_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_2#ly#0: LayerType :: Handle1((lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: $IsBox($l#3_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_2#heap#0: Heap, $l#3_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_3#c#0: DatatypeType :: $Is($l#3_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $l#3_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_4#ly#0: LayerType :: Handle1((lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: $IsBox($l#3_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_4#heap#0: Heap, $l#3_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon166_Then, anon166_Else;

  anon166_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon167_Then, anon167_Else;

  anon167_Then:
    havoc $lambdaHeap#3_0_0;
    assume $IsGoodHeap($lambdaHeap#3_0_0);
    assume $Heap == $lambdaHeap#3_0_0 || $HeapSucc($Heap, $lambdaHeap#3_0_0);
    havoc c#3_0_0;
    goto anon168_Then, anon168_Else;

  anon168_Then:
    assume {:partition} $Is(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0_0);
    $_Frame#l3_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0_0, $o, alloc)): bool ==> false);
    ##self#3_0_0 := c#3_0_0;
    assume $IsAlloc(##self#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0_0);
    ##fT#3_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon92;

  anon168_Else:
    assume {:partition} !($Is(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#3_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0_0));
    goto anon92;

  anon92:
    assume false;
    goto anon93;

  anon167_Else:
    goto anon93;

  anon93:
    ##cs0#3_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0 := Lit(AtLayer((lambda $l#3_0_1#ly#0: LayerType :: Handle1((lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: $IsBox($l#3_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_1#heap#0: Heap, $l#3_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_2#ly#0: LayerType :: Handle1((lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: $IsBox($l#3_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_2#heap#0: Heap, $l#3_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_0_3#c#0: DatatypeType :: $Is($l#3_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $l#3_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_4#ly#0: LayerType :: Handle1((lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: $IsBox($l#3_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_4#heap#0: Heap, $l#3_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_4#o#0: ref :: false))))), $LS($LZ))));
    goto anon169_Then, anon169_Else;

  anon169_Then:
    push;
    assume $IsAllocBox($Box(sep#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    goto anon170_Then, anon170_Else;

  anon170_Then:
    havoc $lambdaHeap#3_0_0_0;
    assume $IsGoodHeap($lambdaHeap#3_0_0_0);
    assume $Heap == $lambdaHeap#3_0_0_0 || $HeapSucc($Heap, $lambdaHeap#3_0_0_0);
    havoc c#3_0_0_0;
    goto anon171_Then, anon171_Else;

  anon171_Then:
    assume {:partition} $Is(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0_0_0);
    $_Frame#l3_0_0_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0_0_0, $o, alloc)): bool ==> false);
    ##self#3_0_0_0 := c#3_0_0_0;
    assume $IsAlloc(##self#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0_0_0);
    ##fT#3_0_0_0 := JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView();
    assume $IsAlloc(##fT#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $lambdaHeap#3_0_0_0);
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume lambdaResult#3_0_0_0 == JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), c#3_0_0_0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView());
    assume $Is(lambdaResult#3_0_0_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon97;

  anon171_Else:
    assume {:partition} !($Is(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(c#3_0_0_0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $lambdaHeap#3_0_0_0));
    goto anon97;

  anon97:
    assume false;
    goto anon98;

  anon170_Else:
    goto anon98;

  anon98:
    ##cs0#3_0_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##cs0#3_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0_0 := Lit(AtLayer((lambda $l#3_0_0_1#ly#0: LayerType :: Handle1((lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_0_1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: $IsBox($l#3_0_0_1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_0_1#heap#0: Heap, $l#3_0_0_1#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_1#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_2#ly#0: LayerType :: Handle1((lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_0_2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: $IsBox($l#3_0_0_2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_0_2#heap#0: Heap, $l#3_0_0_2#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_2#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && (forall $l#3_0_0_3#c#0: DatatypeType :: $Is($l#3_0_0_3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> JSON_mConcreteSyntax_mSpec.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $l#3_0_0_3#c#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_4#ly#0: LayerType :: Handle1((lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_0_4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: $IsBox($l#3_0_0_4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_0_4#heap#0: Heap, $l#3_0_0_4#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_4#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_0_12#ly#0: LayerType :: Handle1((lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_0_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: $IsBox($l#3_0_0_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_0_12#heap#0: Heap, $l#3_0_0_12#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_0_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](381,81)"} true;
    pop;
    assume true;
    assume false;
    goto anon99;

  anon169_Else:
    goto anon99;

  anon99:
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_0_9#ly#0: LayerType :: Handle1((lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_0_9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: $IsBox($l#3_0_9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_0_9#heap#0: Heap, $l#3_0_9#c#0: Box :: SetRef_to_SetBox((lambda $l#3_0_9#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](382,14)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#3_0_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#3_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon172_Then, anon172_Else;

  anon172_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](384,34)"} true;
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(sep#Z#2)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    ##other#3_0_1_0 := JSON_mUtils_mCursors.Split.cs(elem#Z#0);
    assume $IsAlloc(##other#3_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(sep#Z#2) && JSON_mUtils_mCursors.Split.SP_q(elem#Z#0) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    goto anon173_Then, anon173_Else;

  anon173_Then:
    push;
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(elem#Z#0);
    assume !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](386,38)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon102;

  anon173_Else:
    goto anon102;

  anon102:
    assume JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](387,16)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon103;

  anon172_Else:
    goto anon103;

  anon103:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sep#Z#2), JSON_mUtils_mCursors.Split.cs(elem#Z#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](388,14)"} true;
    pop;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon104;

  anon166_Else:
    goto anon104;

  anon104:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#Z#2, JSON_mUtils_mCursors.Split.cs(elem#Z#0), Lit(AtLayer((lambda $l#3_12#ly#0: LayerType :: Handle1((lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#3_12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: $IsBox($l#3_12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#3_12#heap#0: Heap, $l#3_12#c#0: Box :: SetRef_to_SetBox((lambda $l#3_12#o#0: ref :: false))))), $LS($LZ))));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](389,12)"} true;
    havoc e#3_0;
    goto anon174_Then, anon174_Else;

  anon174_Then:
    assume {:partition} $Is(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(elems#0);
    goto anon175_Then, anon175_Else;

  anon175_Then:
    assume {:partition} Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(e#3_0);
    goto anon107;

  anon175_Else:
    assume {:partition} !Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_0));
    goto anon107;

  anon174_Else:
    assume {:partition} !($Is(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(e#3_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap));
    goto anon107;

  anon107:
    assume (forall e#3_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) } $Is(e#3_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && (Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#3_1)));
    assume (forall e#3_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#3_1) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) } $Is(e#3_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#3_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#3_1)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](390,64)"} true;
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume false;
    goto anon108;

  anon163_Else:
    goto anon108;

  anon108:
    assume Requires5(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast), $Box(JSON_mUtils_mCursors.Split.cs(open#0)), $Box(json#0), $Box(elems#0), $Box(elem#Z#0), $Box(sep#Z#2));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](391,10)"} true;
    havoc elems'#Z#0;
    assume $Is(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems'#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    ##cs0#5 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#3 := json#0;
    assume $IsAlloc(##json#3, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##elems#2 := elems#0;
    assume $IsAlloc(##elems#2, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##elem#1 := elem#Z#0;
    assume $IsAlloc(##elem#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##sep#1 := sep#Z#2;
    assume $IsAlloc(##sep#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#2)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#2)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#3)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#2)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#3)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mUtils_mParsers.SubParser__.cs(##json#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#2), ##cs0#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#5), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#2)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#2, ##cs0#5, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elem#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#2)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elem#1), JSON_mUtils_mCursors.Split.cs(##elems#2)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#2)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elem#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), ##elem#1, JSON_mUtils_mCursors.Split.cs(##elems#2), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##sep#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##sep#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elem#1)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##sep#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elem#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##sep#1), JSON_mUtils_mCursors.Split.cs(##elem#1)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##sep#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elem#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elem#1)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##sep#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##sep#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##sep#1, JSON_mUtils_mCursors.Split.cs(##elem#1), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))));
    assume true;
    assume (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#2)): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2));
    assume let#7#0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#Z#0, sep#Z#2);
    assume $Is(let#7#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems'#Z#0 == let#7#0#0;
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#6 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    goto anon176_Then, anon176_Else;

  anon176_Then:
    assume $IsAllocBox($Box(elems'#Z#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#0);
    assume 2 != $FunctionContextHeight;
    ##cs0#4_0 := JSON_mUtils_mCursors.Split.cs(open#0);
    assume $IsAlloc(##cs0#4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle();
    assume $IsAlloc(##spec#4_0, Tclass._System.___hTotalFunc1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](394,75)"} true;
    assume true;
    assume true;
    assume false;
    goto anon110;

  anon176_Else:
    goto anon110;

  anon110:
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems'#Z#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](395,10)"} true;
    havoc bracketed#Z#0;
    assume $Is(bracketed#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(bracketed#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    ##cs#2 := cs0#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##open#1 := open#0;
    assume $IsAlloc(##open#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    ##elems#3 := elems'#Z#0;
    assume $IsAlloc(##elems#3, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##close#0 := sep#Z#2;
    assume $IsAlloc(##close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) || (forall idx#0: int :: { $Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq) - 1));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#1)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#1)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#1)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#36#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs#2, Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#39#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#3), JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#3)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#3)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#3, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##close#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##close#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#3)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##close#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#3)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##close#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#42#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#43#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#3)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#44#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##close#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##close#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#3), Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#47#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#Z#0, sep#Z#2));
    assume let#8#0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#Z#0, sep#Z#2);
    assume $Is(let#8#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume bracketed#Z#0 == let#8#0#0;
    assume $IsAllocBox($Box(bracketed#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#7 := cs0#0;
    assume $IsAlloc(##cs0#7, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), bracketed#Z#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](397,65)"} true;
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0) == #Wrappers.Result.Success($Box(bracketed#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon150_Else:
    assume {:partition} !(s0#Z#0 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#Z#0)): DatatypeType)): DatatypeType) == LitInt(1));
    havoc separator#Z#0;
    assume LitInt(0) <= separator#Z#0 && separator#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume let#9#0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume true;
    assume $Is(let#9#0#0, Tclass.BoundedInts.uint8());
    assume separator#Z#0 == let#9#0#0;
    havoc pr#Z#0;
    assume $Is(pr#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(pr#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume let#10#0#0 == #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#Z#0)), s0#Z#0)));
    assume true;
    assume $Is(let#10#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume pr#Z#0 == let#10#0#0;
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0) == pr#Z#0;
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon112;

  anon112:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#0) == pr#3;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser();
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser();
  modifies $Heap;
  free ensures JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
  free ensures {:id "id27890"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())) && JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())) && (forall cs'#0: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType } $Is(cs'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), $Box(cs'#0))): DatatypeType)): DatatypeType, cs'#0, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()))));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser() returns ($_reverifyPost: bool);
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
  free ensures {:id "id27891"} JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())) ==> JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())) || (forall cs'#1: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType } $Is(cs'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), $Box(cs'#1))): DatatypeType)): DatatypeType, cs'#1, JSON_mUtils_mParsers.Parser__.spec(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()))));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser() returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var cs'#0_0_0: DatatypeType;
  var ##cs#0_0_0: DatatypeType;
  var ##cs#0_0_1: DatatypeType;
  var ##cs0#0_0_0: DatatypeType;
  var ##spec#0_0_0: HandleType;
  var ##cs#0_0_2: DatatypeType;
  var ##cs#0_0_0_0: DatatypeType;
  var ##cs0#0_0_0_0: DatatypeType;
  var ##spec#0_0_0_0: HandleType;
  var ##cs#0_0_0_0_0: DatatypeType;
  var ##cs#0_0_0_0_1: DatatypeType;
  var ##cs0#0_0_0_0_0: DatatypeType;
  var ##spec#0_0_0_0_0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser"} true;
    assume {:print "Types"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](407,4): initial state"} true;
    $_reverifyPost := false;
    assume 2 != $FunctionContextHeight;
    assume $IsAllocBox($Box(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    goto anon18_Then, anon18_Else;

  anon18_Then:
    havoc cs'#0_0_0;
    assume $Is(cs'#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor());
    assume true;
    assume true;
    goto anon19_Then, anon19_Else;

  anon19_Then:
    ##cs#0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    ##cs#0_0_1 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##cs0#0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    goto anon5;

  anon20_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    goto anon5;

  anon5:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    assume false;
    goto anon6;

  anon19_Else:
    goto anon6;

  anon6:
    ##cs#0_0_2 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    ##cs#0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##cs0#0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    goto anon22_Then, anon22_Else;

  anon22_Then:
    ##cs#0_0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0_0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    goto anon23_Then, anon23_Else;

  anon23_Then:
    assume {:partition} Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    ##cs#0_0_0_0_1 := cs'#0_0_0;
    assume $IsAlloc(##cs#0_0_0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0);
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    assume $IsAllocBox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap);
    ##cs0#0_0_0_0_0 := cs'#0_0_0;
    assume $IsAlloc(##cs0#0_0_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0_0_0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose();
    assume $IsAlloc(##spec#0_0_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    goto anon10;

  anon23_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    goto anon10;

  anon10:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs'#0_0_0) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](412,100)"} true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume true;
    assume false;
    goto anon11;

  anon22_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](413,12)"} true;
    goto anon13;

  anon21_Else:
    assume {:partition} !Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0));
    goto anon13;

  anon13:
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs'#0_0_0))));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs'#0_0_0)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType), cs'#0_0_0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs'#0_0_0)));
    assume Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType, cs'#0_0_0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs'#0_0_0), Seq#Append($Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_0))): DatatypeType)))));
    assume false;
    goto anon15;

  anon18_Else:
    assume (forall cs'#0_0_1: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_1) } $Is(cs'#0_0_1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && Lit(true) ==> Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_1)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close, cs'#0_0_1))): DatatypeType, cs'#0_0_1, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
    goto anon15;

  anon15:
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](415,8)"} true;
    assume true;
    assume false;
    goto anon16;

  anon17_Else:
    goto anon16;

  anon16:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](416,6)"} true;
    return;
}



function JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal: bool, cs#0: DatatypeType, json#0: DatatypeType) : DatatypeType
uses {
axiom 5 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var open#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#0) && (var elems#0 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#0)); JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#0)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#0), p#0) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#0), p#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (var close#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#0, elems#0)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#0) else (var open#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; (var elems#0 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#0)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#0)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#0), p#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#0) else (var close#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#0, elems#0, close#0))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#0, elems#0)))))));
axiom 5 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || (5 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var open#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#1) && (var elems#1 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#1)); JSON_mUtils_mCursors.Split.SP_q(open#1) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#1)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#1) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#1), p#1) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#1), p#1); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (var close#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), open#1, elems#1, close#1)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#1, elems#1)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#1) else (var open#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; (var elems#1 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#1)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#1)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#1 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#1), p#1); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#1) else (var close#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs#0), open#1, elems#1, close#1))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs#0), Lit(json#0), open#1, elems#1)))))));
}

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0: DatatypeType, json#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#requires(DatatypeType, DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#requires(cs#0, json#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#requires(cs#0, json#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))));

function JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal: bool) : HandleType;

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Bracketed (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), json#0: DatatypeType where $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id27906"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)));
  free ensures {:id "id27907"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
  free ensures {:id "id27908"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
  free ensures {:id "id27909"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
  free ensures {:id "id27910"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Bracketed (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(cs#0: DatatypeType, json#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##parser#0: DatatypeType;
  var open#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##other#1: DatatypeType;
  var elems#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var p#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var ##parser#1: DatatypeType;
  var close#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##open#0: DatatypeType;
  var ##elems#0: DatatypeType;
  var ##close#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##json#0: DatatypeType;
  var ##open#1: DatatypeType;
  var ##elems#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Bracketed", " | ", cs#0, " | ", json#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](419,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0));
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    goto anon5;

  anon17_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon16_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume 2 != $FunctionContextHeight;
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen()), Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen());
    assume $IsAlloc(##parser#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen()));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen()));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen()));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon18_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc open#Z#0;
    assume $Is(open#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())));
    assume open#Z#0 == let#1#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0);
    ##other#1 := JSON_mUtils_mParsers.SubParser__.cs(json#0);
    assume $IsAlloc(##other#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0) && JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume true;
    assume true;
    assume true;
    assume true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(open#Z#0), JSON_mUtils_mParsers.SubParser__.cs(json#0));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](425,48)"} true;
    havoc elems#Z#0;
    assume $Is(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#Z#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume let#2#0#0 == #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))));
    assume elems#Z#0 == let#2#0#0;
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    assume $IsAllocBox($Box(JSON_mUtils_mCursors.Split.cs(open#Z#0)), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#Z#0));
    newtype$check#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#Z#0)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    havoc p#Z#0;
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume 2 != $FunctionContextHeight;
    assume let#3#0#0 == #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose());
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError()));
    assume p#Z#0 == let#3#0#0;
    assume $IsAllocBox($Box(p#Z#0), Tclass.JSON_mUtils_mParsers.Parser__(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume JSON_mUtils_mParsers.Parser__.Valid_q#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    call CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser();
    call CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser();
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](430,28)"} true;
    assume true;
    assume false;
    goto anon11;

  anon20_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mParsers.Parser__.Valid_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError(), p#Z#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](431,8)"} true;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0);
    ##cs#1 := JSON_mUtils_mCursors.Split.cs(open#Z#0);
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(p#Z#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#1 := p#Z#0;
    assume $IsAlloc(##parser#1, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)));
    assume (forall cs#2: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)) } $Is(cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#1), $Box(cs#2)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume let#4#0#0 == JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(open#Z#0) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#Z#0), p#Z#0);
    assume $Is(let#4#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon21_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc close#Z#0;
    assume $Is(close#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#5#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#5#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())));
    assume close#Z#0 == let#5#0#0;
    ##cs#2 := cs#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##open#0 := open#Z#0;
    assume $IsAlloc(##open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    ##elems#0 := elems#Z#0;
    assume $IsAlloc(##elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    ##close#0 := close#Z#0;
    assume $IsAlloc(##close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap);
    assume {:subsumption 0} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) || (forall idx#0: int :: { $Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq, idx#0)): DatatypeType)) <==> idx#0 == Seq#Length($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq) - 1));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#0)), JSON_mUtils_mCursors.Cursor__.s(##cs#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#0)) > JSON_mUtils_mCursors.Cursor__.beg(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#0), ##cs#2) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#0)) == JSON_mUtils_mCursors.Cursor__.end(##cs#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#0#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: $IsBox($l#0#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#0#heap#0: Heap, $l#0#c#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#1#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: $IsBox($l#1#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#1#heap#0: Heap, $l#1#c#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#2#ly#0: LayerType :: Handle1((lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#2#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: $IsBox($l#2#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#2#heap#0: Heap, $l#2#c#0: Box :: SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#3#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: $IsBox($l#3#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#3#heap#0: Heap, $l#3#c#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs#2), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#4#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: $IsBox($l#4#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#4#heap#0: Heap, $l#4#c#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#0, ##cs#2, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#0), JSON_mUtils_mCursors.Split.cs(##open#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#0)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#0)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#0, JSON_mUtils_mCursors.Split.cs(##open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##close#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##close#0)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#0)))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##close#0)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##close#0), JSON_mUtils_mCursors.Split.cs(##elems#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##close#0)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##close#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##close#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), ##close#0, JSON_mUtils_mCursors.Split.cs(##elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#Z#0, elems#Z#0, close#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#Z#0, elems#Z#0, close#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0) == #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#Z#0, elems#Z#0, close#Z#0)));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#Z#0, elems#Z#0, close#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon19_Else:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#Z#0)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := json#0;
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    ##open#1 := open#Z#0;
    assume $IsAlloc(##open#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap);
    ##elems#1 := elems#Z#0;
    assume $IsAlloc(##elems#1, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##open#1)), JSON_mUtils_mCursors.Cursor__.s(##cs0#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##open#1)) > JSON_mUtils_mCursors.Cursor__.beg(##cs0#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##open#1), ##cs0#1) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##open#1)) == JSON_mUtils_mCursors.Cursor__.end(##cs0#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(##cs0#1), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##open#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), ##open#1, ##cs0#1, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(##elems#1));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(##elems#1)), JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mParsers.SubParser__.cs(##json#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(##elems#1)) > JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(##elems#1)) == JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mParsers.SubParser__.cs(##json#0)));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(##elems#1), JSON_mUtils_mCursors.Split.cs(##open#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##open#1)), Seq#Append($Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(##elems#1)))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), ##elems#1, JSON_mUtils_mCursors.Split.cs(##open#1), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle());
    assume true;
    assume (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(##elems#1)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#Z#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0) == JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#Z#0, elems#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#Z#0, elems#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon15;

  anon15:
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##c#1: int;
  var ##s#0: Seq;
  var pf#0: DatatypeType;
  var ##c#2: int;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](438,10): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume old($Heap) == $Heap;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](439,25): post-state"} true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    assume $IsAllocBox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    assume $IsAllocBox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0)), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#1 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume $IsAlloc(##c#1, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    ##s#0 := JSON_mGrammar.Bracketed.data(x#0);
    assume $IsAlloc(##s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap);
    assume JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0));
    assume JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0));
    havoc pf#0;
    assume $Is(pf#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $IsAlloc(pf#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $Heap);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume $IsAlloc(##c#2, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    goto anon6;

  anon8_Else:
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    goto anon6;

  anon7_Else:
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    goto anon6;

  anon6:
    assume (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (call precondtion)"} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0));
  modifies $Heap;
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
  free ensures {:id "id27990"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
  free ensures {:id "id27991"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0));
  free ensures {:id "id27992"} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0)) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0)) && (forall idx#0: int :: { $Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#0)): DatatypeType } LitInt(0) <= idx#0 && idx#0 < Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#0)): DatatypeType)) <==> idx#0 == Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) - 1));
  free ensures (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(x#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()))));
  free ensures {:id "id27993"} (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()));
  free ensures old($Heap) == $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType where $Is(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) && $IsAlloc(x#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Heap) && $IsA#JSON_mGrammar.Bracketed(x#0)) returns ($_reverifyPost: bool);
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
  free ensures {:id "id27994"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0)) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
  free ensures {:id "id27995"} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
  free ensures JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0));
  free ensures {:id "id27996"} JSON_mGrammar.__default.NoTrailingSuffix#canCall(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0)) ==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), JSON_mGrammar.Bracketed.data(x#0)) || (forall idx#1: int :: { $Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#1)): DatatypeType } LitInt(0) <= idx#1 && idx#1 < Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(JSON_mGrammar.Bracketed.data(x#0), idx#1)): DatatypeType)) <==> idx#1 == Seq#Length(JSON_mGrammar.Bracketed.data(x#0)) - 1));
  free ensures (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(x#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#1) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()))));
  free ensures {:id "id27997"} $_reverifyPost ==> (forall pf#1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) } $Is(pf#1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()));
  free ensures old($Heap) == $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (correctness)"} Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType) returns ($_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var xlt#0: DatatypeType where $Is(xlt#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) && $IsAlloc(xlt#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Heap);
  var xrt#0: DatatypeType where $Is(xrt#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) && $IsAlloc(xrt#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Heap);
  var pf#0_0: DatatypeType;
  var ##c#0_0: int;
  var xtt#0_0_0: DatatypeType where $Is(xtt#0_0_0, Tclass.JSON_mGrammar.jcomma()) && $IsAlloc(xtt#0_0_0, Tclass.JSON_mGrammar.jcomma(), $Heap);

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](444,4): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.l(x#0));
    xlt#0 := $Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.l(x#0))): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](445,29)"} true;
    assume true;
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0) && JSON_mGrammar.Structural.Structural_q(JSON_mGrammar.Bracketed.r(x#0));
    xrt#0 := $Unbox(JSON_mGrammar.Structural.t(JSON_mGrammar.Bracketed.r(x#0))): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](446,30)"} true;
    goto anon11_Then, anon11_Else;

  anon11_Then:
    havoc pf#0_0;
    assume $Is(pf#0_0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()));
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume JSON_mGrammar.Bracketed.Bracketed_q(x#0);
    assume Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_0));
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    assume $IsAllocBox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0_0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR();
    assume $IsAlloc(##c#0_0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    goto anon4;

  anon13_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    goto anon4;

  anon4:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()));
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR());
    assume false;
    goto anon5;

  anon12_Else:
    goto anon5;

  anon5:
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume true;
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0);
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    assume JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    assume JSON_mGrammar.Suffixed.Suffixed_q(pf#0_0) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType);
    xtt#0_0_0 := $Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](451,34)"} true;
    goto anon8;

  anon14_Else:
    assume {:partition} !JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0));
    goto anon8;

  anon8:
    assume JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_0)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_0))): DatatypeType)): DatatypeType), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR())));
    assume false;
    goto anon10;

  anon11_Else:
    assume (forall pf#0_1: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(pf#0_1) } { Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_1)) } $Is(pf#0_1, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(x#0), $Box(pf#0_1)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(pf#0_1)) ==> JSON_mUtils_mViews_mCore.View__.Byte_q($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(pf#0_1))): DatatypeType)): DatatypeType, JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR()));
    goto anon10;

  anon10:
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](453,6)"} true;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Open (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Open();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Open (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Open();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Open (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Open();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Close (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Close();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Close (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Close();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Close (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Close();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_BracketedFromParts (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__BracketedFromParts();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_BracketedFromParts (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__BracketedFromParts();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_BracketedFromParts (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__BracketedFromParts();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_AppendWithSuffix (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__AppendWithSuffix();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_AppendWithSuffix (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__AppendWithSuffix();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_AppendWithSuffix (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__AppendWithSuffix();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_AppendLast (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__AppendLast();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_AppendLast (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__AppendLast();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_AppendLast (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__AppendLast();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Elements (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Elements();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Elements (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Elements();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Elements (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Elements();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Bracketed (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Bracketed();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Bracketed (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Bracketed();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Bracketed (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Bracketed();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Array (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Array();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Array (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Array();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.reveal_Array (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.reveal__Array();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.jopen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.jopen(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.jopen (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.jopen(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.jopen", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](126,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(v#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    return;

  anon4_Else:
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN())));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()))));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN())));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()))) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN())))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN())));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.jclose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.jclose(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.jclose (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mArrays.jclose(v#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##c#0: int;
  var ##bs#0: Seq;
  var newtype$check#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.jclose", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy[Arrays](127,9): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    ##c#0 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE();
    assume $IsAlloc(##c#0, Tclass.BoundedInts.uint8(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(v#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    return;

  anon4_Else:
    ##bs#0 := Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()));
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()))));
    newtype$check#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(newtype$check#0);
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()))) && JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE());
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Byte_q#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) ==> JSON_mUtils_mViews_mCore.View__.Byte_q(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) || Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())))), Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())));
    return;
}



axiom (forall v#0: DatatypeType :: { $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) } $Is(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()) <==> $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.View__.Byte_q(v#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()));

axiom (forall v#0: DatatypeType, $h: Heap :: { $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $h) } $IsAlloc(v#0, Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $h) <==> $IsAlloc(v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $h));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#248 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#248))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#250 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#250)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#372 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#372))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#374 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#374)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#376 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#376)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#372 := Wrappers.Option.value(this); v#372)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#374 := Lit(Wrappers.Option.value(Lit(this))); v#374)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#376 := Lit(Wrappers.Option.value(Lit(this))); v#376)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#248 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#248)) else (var e#248 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#250 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#250))) else (var e#250 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#372 := Wrappers.Result.value(this); s#372) else (var e#372 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#374 := Lit(Wrappers.Result.value(Lit(this))); s#374) else (var e#374 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#376 := Lit(Wrappers.Result.value(Lit(this))); s#376) else (var e#376 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#372 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#372)) else (var e#372 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#372)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#374 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#374))) else (var e#374 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#374)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#376 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#376))) else (var e#376 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#376)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#168: int, y#168: int :: { Mul(x#168, y#168) } Mul(x#168, y#168) == Mul(y#168, x#168)) && (forall x#169: int, y#169: int, z#112: int :: { Mul(x#169 + y#169, z#112) } Mul(x#169 + y#169, z#112) == Mul(x#169, z#112) + Mul(y#169, z#112)) && (forall x#170: int, y#170: int, z#113: int :: { Mul(x#170 - y#170, z#113) } Mul(x#170 - y#170, z#113) == Mul(x#170, z#113) - Mul(y#170, z#113));

axiom MulInternals.__default.MulAuto() <==> (forall x#171: int, y#171: int :: { Mul(x#171, y#171) } Mul(x#171, y#171) == Mul(y#171, x#171)) && (forall x#172: int, y#172: int, z#114: int :: { Mul(x#172 + y#172, z#114) } Mul(x#172 + y#172, z#114) == Mul(x#172, z#114) + Mul(y#172, z#114)) && (forall x#173: int, y#173: int, z#115: int :: { Mul(x#173 - y#173, z#115) } Mul(x#173 - y#173, z#115) == Mul(x#173, z#115) - Mul(y#173, z#115));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#208: int :: { Mod(Mod(x#208, n#0), n#0) } Mod(Mod(x#208, n#0), n#0) == Mod(x#208, n#0)) && (forall x#209: int :: { Mod(x#209, n#0) } LitInt(0) <= x#209 && x#209 < n#0 <==> Mod(x#209, n#0) == x#209) && (forall x#210: int, y#104: int :: { Mod(x#210 + y#104, n#0) } (var z#102 := Mod(x#210, n#0) + Mod(y#104, n#0); (LitInt(0) <= z#102 && z#102 < n#0 && Mod(x#210 + y#104, n#0) == z#102) || (n#0 <= z#102 && z#102 < n#0 + n#0 && Mod(x#210 + y#104, n#0) == z#102 - n#0))) && (forall x#211: int, y#105: int :: { Mod(x#211 - y#105, n#0) } (var z#103 := Mod(x#211, n#0) - Mod(y#105, n#0); (LitInt(0) <= z#103 && z#103 < n#0 && Mod(x#211 - y#105, n#0) == z#103) || (0 - n#0 <= z#103 && z#103 < 0 && Mod(x#211 - y#105, n#0) == z#103 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#212: int :: { Mod(Mod(x#212, n#0), n#0) } Mod(Mod(x#212, LitInt(n#0)), LitInt(n#0)) == Mod(x#212, LitInt(n#0))) && (forall x#213: int :: { Mod(x#213, n#0) } LitInt(0) <= x#213 && x#213 < n#0 <==> Mod(x#213, LitInt(n#0)) == x#213) && (forall x#214: int, y#106: int :: { Mod(x#214 + y#106, n#0) } (var z#104 := Mod(x#214, LitInt(n#0)) + Mod(y#106, LitInt(n#0)); (LitInt(0) <= z#104 && z#104 < n#0 && Mod(x#214 + y#106, LitInt(n#0)) == z#104) || (LitInt(n#0) <= z#104 && z#104 < n#0 + n#0 && Mod(x#214 + y#106, LitInt(n#0)) == z#104 - n#0))) && (forall x#215: int, y#107: int :: { Mod(x#215 - y#107, n#0) } (var z#105 := Mod(x#215, LitInt(n#0)) - Mod(y#107, LitInt(n#0)); (LitInt(0) <= z#105 && z#105 < n#0 && Mod(x#215 - y#107, LitInt(n#0)) == z#105) || (LitInt(0 - n#0) <= z#105 && z#105 < 0 && Mod(x#215 - y#107, LitInt(n#0)) == z#105 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#150: int :: { Div(x#150, n#0) } LitInt(0) <= x#150 && x#150 < n#0 <==> Div(x#150, n#0) == LitInt(0)) && (forall x#151: int, y#100: int :: { Div(x#151 + y#100, n#0) } (var z#98 := Mod(x#151, n#0) + Mod(y#100, n#0); (LitInt(0) <= z#98 && z#98 < n#0 && Div(x#151 + y#100, n#0) == Div(x#151, n#0) + Div(y#100, n#0)) || (n#0 <= z#98 && z#98 < n#0 + n#0 && Div(x#151 + y#100, n#0) == Div(x#151, n#0) + Div(y#100, n#0) + 1))) && (forall x#152: int, y#101: int :: { Div(x#152 - y#101, n#0) } (var z#99 := Mod(x#152, n#0) - Mod(y#101, n#0); (LitInt(0) <= z#99 && z#99 < n#0 && Div(x#152 - y#101, n#0) == Div(x#152, n#0) - Div(y#101, n#0)) || (0 - n#0 <= z#99 && z#99 < 0 && Div(x#152 - y#101, n#0) == Div(x#152, n#0) - Div(y#101, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#153: int :: { Div(x#153, n#0) } LitInt(0) <= x#153 && x#153 < n#0 <==> Div(x#153, LitInt(n#0)) == LitInt(0)) && (forall x#154: int, y#102: int :: { Div(x#154 + y#102, n#0) } (var z#100 := Mod(x#154, LitInt(n#0)) + Mod(y#102, LitInt(n#0)); (LitInt(0) <= z#100 && z#100 < n#0 && Div(x#154 + y#102, LitInt(n#0)) == Div(x#154, LitInt(n#0)) + Div(y#102, LitInt(n#0))) || (LitInt(n#0) <= z#100 && z#100 < n#0 + n#0 && Div(x#154 + y#102, LitInt(n#0)) == Div(x#154, LitInt(n#0)) + Div(y#102, LitInt(n#0)) + 1))) && (forall x#155: int, y#103: int :: { Div(x#155 - y#103, n#0) } (var z#101 := Mod(x#155, LitInt(n#0)) - Mod(y#103, LitInt(n#0)); (LitInt(0) <= z#101 && z#101 < n#0 && Div(x#155 - y#103, LitInt(n#0)) == Div(x#155, LitInt(n#0)) - Div(y#103, LitInt(n#0))) || (LitInt(0 - n#0) <= z#101 && z#101 < 0 && Div(x#155 - y#103, LitInt(n#0)) == Div(x#155, LitInt(n#0)) - Div(y#103, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#38 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#38) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#38)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#38 := lv#0; (var dt_update#end#0#38 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#38), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#38), dt_update#end#0#38))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#39 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#39) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#39)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#39 := Lit(lv#0); (var dt_update#end#0#39 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#39)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#39)), dt_update#end#0#39)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#40: char :: { Seq#Contains(s#0, $Box(c#40)) } $Is(c#40, TChar) && Seq#Contains(s#0, $Box(c#40)) ==> char#ToInt(c#40) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#40: char :: { Seq#Contains(s#0, $Box(c#40)) } $Is(c#40, TChar) && Seq#Contains(s#0, $Box(c#40)) ==> char#ToInt(c#40) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#80#i#0): int)): char))), (lambda $l#80#heap#0: Heap, $l#80#i#0: Box :: $IsBox($l#80#i#0, TInt) && LitInt(0) <= $Unbox($l#80#i#0): int && $Unbox($l#80#i#0): int < Seq#Length(s#0)), (lambda $l#80#heap#0: Heap, $l#80#i#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#41: char :: { Seq#Contains(s#0, $Box(c#41)) } $Is(c#41, TChar) && Seq#Contains(s#0, $Box(c#41)) ==> char#ToInt(c#41) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#82#i#0): int)): char))), (lambda $l#82#heap#0: Heap, $l#82#i#0: Box :: $IsBox($l#82#i#0, TInt) && LitInt(0) <= $Unbox($l#82#i#0): int && $Unbox($l#82#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#82#heap#0: Heap, $l#82#i#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#20 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#20))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#20 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#22 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#22))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#22 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#132 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#66 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#132 := (if b#132 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#132)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#66)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#132)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#133 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#66 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#133 := (if b#133 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#133)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#66 := Seq#Create(TChar, $Heap, Seq#Length(bs0#66), Lit(AtLayer((lambda $l#103#ly#0: LayerType :: Handle1((lambda $l#103#heap#0: Heap, $l#103#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#66, $Unbox($l#103#idx#0): int)): int))), (lambda $l#103#heap#0: Heap, $l#103#idx#0: Box :: $IsBox($l#103#idx#0, TInt) && LitInt(0) <= $Unbox($l#103#idx#0): int && $Unbox($l#103#idx#0): int < Seq#Length(bs0#66)), (lambda $l#103#heap#0: Heap, $l#103#idx#0: Box :: SetRef_to_SetBox((lambda $l#103#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#66), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#133))))) else (var err#66 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#66)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#136 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#68 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#136 := (if b#136 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#136)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#68)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#136)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#137 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#68 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#137 := (if b#137 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#137)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#68 := Seq#Create(TChar, $Heap, Seq#Length(bs0#68), Lit(AtLayer((lambda $l#106#ly#0: LayerType :: Handle1((lambda $l#106#heap#0: Heap, $l#106#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#68, $Unbox($l#106#idx#0): int)): int))), (lambda $l#106#heap#0: Heap, $l#106#idx#0: Box :: $IsBox($l#106#idx#0, TInt) && LitInt(0) <= $Unbox($l#106#idx#0): int && $Unbox($l#106#idx#0): int < Seq#Length(bs0#68)), (lambda $l#106#heap#0: Heap, $l#106#idx#0: Box :: SetRef_to_SetBox((lambda $l#106#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#68), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#137))))) else (var err#68 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#68)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#140 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#70 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#140 := (if b#140 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#140)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#70)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#140)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#141 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#70 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#141 := (if b#141 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#141)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#70 := Seq#Create(TChar, $Heap, Seq#Length(bs0#70), Lit(AtLayer((lambda $l#109#ly#0: LayerType :: Handle1((lambda $l#109#heap#0: Heap, $l#109#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#70, $Unbox($l#109#idx#0): int)): int))), (lambda $l#109#heap#0: Heap, $l#109#idx#0: Box :: $IsBox($l#109#idx#0, TInt) && LitInt(0) <= $Unbox($l#109#idx#0): int && $Unbox($l#109#idx#0): int < Seq#Length(bs0#70)), (lambda $l#109#heap#0: Heap, $l#109#idx#0: Box :: SetRef_to_SetBox((lambda $l#109#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#70), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#141))))) else (var err#70 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#70)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#13: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#13)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#13)): int } LitInt(0) <= idx#13 && idx#13 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#13 && idx#13 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#13)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#13)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#22 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#22 := this; (var dt_update#beg#0#22 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#22), dt_update#beg#0#22, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#22), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#22)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#23 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#23 := Lit(this); (var dt_update#beg#0#23 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#23)), dt_update#beg#0#23, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#23)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#23)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#69#v#0): DatatypeType))), (lambda $l#69#heap#0: Heap, $l#69#v#0: Box :: $IsBox($l#69#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#69#heap#0: Heap, $l#69#v#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#70#v#0): DatatypeType))), (lambda $l#70#heap#0: Heap, $l#70#v#0: Box :: $IsBox($l#70#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#70#heap#0: Heap, $l#70#v#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#71#v#0): DatatypeType))), (lambda $l#71#heap#0: Heap, $l#71#v#0: Box :: $IsBox($l#71#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#71#heap#0: Heap, $l#71#v#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#22 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#22 := this; (var dt_update#point#0#22 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#22), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#22), dt_update#point#0#22, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#22)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#23 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#23 := Lit(this); (var dt_update#point#0#23 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#23)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#23)), dt_update#point#0#23, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#23)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#22 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#22)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#22 := this; (var dt_update#point#0#22 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#22), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#22), dt_update#point#0#22, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#22)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#23 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#23)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#23 := Lit(this); (var dt_update#point#0#23 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#23)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#23)), dt_update#point#0#23, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#23)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#22 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#22 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#22 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#22 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#22))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#23 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#23 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#23 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#23 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#23)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#36: int :: { Seq#Contains(bs#0, $Box(b#36)) } LitInt(0) <= b#36 && b#36 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#36)) ==> b#36 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#36: int :: { Seq#Contains(bs#0, $Box(b#36)) } LitInt(0) <= b#36 && b#36 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#36)) ==> b#36 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#33 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#33)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33) && (var ps#33 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#33, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#33 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#33) else (var ps#33 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#33)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#33, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#37: int :: { Seq#Contains(bs#0, $Box(b#37)) } LitInt(0) <= b#37 && b#37 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#37)) ==> b#37 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#34 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#34)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34) && (var ps#34 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#34, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#34 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#34) else (var ps#34 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#34)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#34, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#38: int :: { Seq#Contains(bs#0, $Box(b#38)) } LitInt(0) <= b#38 && b#38 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#38)) ==> b#38 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#35 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#35)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35) && (var ps#35 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#35, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#35 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#35) else (var ps#35 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#35)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#35, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#13: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#13)): int } LitInt(0) <= idx#13 && idx#13 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#13 && idx#13 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#13)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#68 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#68)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#67 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#67)))) else (var st#67 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#67))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#70 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#70)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#69 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#69)))) else (var st#69 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#69))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#72 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#72)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#71 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#71)))) else (var st#71 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#71))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#88#heap#0: Heap, $l#88#_v0#0: Box :: $IsBox($l#88#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#88#heap#0: Heap, $l#88#_v0#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#89#ly#0: LayerType :: Handle1((lambda $l#89#heap#0: Heap, $l#89#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#89#heap#0: Heap, $l#89#_v1#0: Box :: $IsBox($l#89#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#89#heap#0: Heap, $l#89#_v1#0: Box :: SetRef_to_SetBox((lambda $l#89#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#92#ly#0: LayerType :: Handle1((lambda $l#92#heap#0: Heap, $l#92#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#92#heap#0: Heap, $l#92#_v0#0: Box :: $IsBox($l#92#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#92#heap#0: Heap, $l#92#_v0#0: Box :: SetRef_to_SetBox((lambda $l#92#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#93#heap#0: Heap, $l#93#_v1#0: Box :: $IsBox($l#93#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#93#heap#0: Heap, $l#93#_v1#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#132#ly#0: LayerType :: Handle1((lambda $l#132#heap#0: Heap, $l#132#cs#0: Box :: $Box(Lit(false))), (lambda $l#132#heap#0: Heap, $l#132#cs#0: Box :: $IsBox($l#132#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#132#heap#0: Heap, $l#132#cs#0: Box :: SetRef_to_SetBox((lambda $l#132#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#133#ly#0: LayerType :: Handle1((lambda $l#133#heap#0: Heap, $l#133#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#133#heap#0: Heap, $l#133#cs#0: Box :: $IsBox($l#133#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#133#heap#0: Heap, $l#133#cs#0: Box :: SetRef_to_SetBox((lambda $l#133#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#134#ly#0: LayerType :: Handle1((lambda $l#134#heap#0: Heap, $l#134#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#134#heap#0: Heap, $l#134#_v2#0: Box :: $IsBox($l#134#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#134#heap#0: Heap, $l#134#_v2#0: Box :: SetRef_to_SetBox((lambda $l#134#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#138#ly#0: LayerType :: Handle1((lambda $l#138#heap#0: Heap, $l#138#cs#0: Box :: $Box(Lit(false))), (lambda $l#138#heap#0: Heap, $l#138#cs#0: Box :: $IsBox($l#138#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#138#heap#0: Heap, $l#138#cs#0: Box :: SetRef_to_SetBox((lambda $l#138#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#139#ly#0: LayerType :: Handle1((lambda $l#139#heap#0: Heap, $l#139#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#139#heap#0: Heap, $l#139#cs#0: Box :: $IsBox($l#139#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#139#heap#0: Heap, $l#139#cs#0: Box :: SetRef_to_SetBox((lambda $l#139#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#140#ly#0: LayerType :: Handle1((lambda $l#140#heap#0: Heap, $l#140#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#140#heap#0: Heap, $l#140#_v2#0: Box :: $IsBox($l#140#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#140#heap#0: Heap, $l#140#_v2#0: Box :: SetRef_to_SetBox((lambda $l#140#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#22: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#22))): DatatypeType } $Is(cs'#22, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#22))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#22))): DatatypeType)): DatatypeType, cs'#22, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#22: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#22))): DatatypeType } $Is(cs'#22, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#22))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#22))): DatatypeType)): DatatypeType, cs'#22, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#23: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#23))): DatatypeType } $Is(cs'#23, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType)): DatatypeType, cs'#23, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#23: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#23))): DatatypeType } $Is(cs'#23, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#23))): DatatypeType)): DatatypeType, cs'#23, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#66: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#66)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#66))): bool } $Is(cs'#66, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#66))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#66)))) && ((forall cs'#66: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#66)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#66))): bool } $Is(cs'#66, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#66))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#66))) ==> (forall cs'#67: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#67))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#67, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#67: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#67))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#67, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#67))): bool) ==> (forall cs'#68: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#68))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#68))): bool } $Is(cs'#68, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#68))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#68))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#68))): DatatypeType)): DatatypeType, cs'#68, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#66: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#66)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#66))): bool } $Is(cs'#66, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#66))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#66))) && (forall cs'#67: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#67))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#67, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#67, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#67))): bool) && (forall cs'#68: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#68))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#68))): bool } $Is(cs'#68, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#68))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#68))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#68))): DatatypeType)): DatatypeType, cs'#68, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#69: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#69)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#69))): bool } $Is(cs'#69, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#69))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#69)))) && ((forall cs'#69: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#69)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#69))): bool } $Is(cs'#69, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#69))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#69))) ==> (forall cs'#70: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#70))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#70, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#70, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#70, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#70, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#70: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#70))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#70, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#70, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#70, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#70))): bool) ==> (forall cs'#71: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#71))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#71))): bool } $Is(cs'#71, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#71))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#71))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#71))): DatatypeType)): DatatypeType, cs'#71, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#69: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#69)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#69))): bool } $Is(cs'#69, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#69))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#69))) && (forall cs'#70: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#70))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#70, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#70, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#70, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#70))): bool) && (forall cs'#71: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#71))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#71))): bool } $Is(cs'#71, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#71))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#71))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#71))): DatatypeType)): DatatypeType, cs'#71, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#18: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#18)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#18)) ==> LitInt(0) <= d#18 && d#18 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#48 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#49 := Seq#Append(digits'#48, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#49))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#49 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#50 := Seq#Append(digits'#49, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#50))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#50 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#51 := Seq#Append(digits'#50, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#51))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#18: Box :: { Seq#Contains(chars#0, c#18) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#18) } $IsBox(c#18, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#18) ==> Seq#Contains(chars#0, c#18)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#37: int :: { Seq#Contains(digits#0, $Box(d#37)) } Seq#Contains(digits#0, $Box(d#37)) ==> LitInt(0) <= d#37 && d#37 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#37: int :: { Seq#Contains(digits#0, $Box(d#37)) } Seq#Contains(digits#0, $Box(d#37)) ==> LitInt(0) <= d#37 && d#37 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#38: int :: { Seq#Contains(digits#0, $Box(d#38)) } Seq#Contains(digits#0, $Box(d#38)) ==> LitInt(0) <= d#38 && d#38 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#18: Box :: { Seq#Contains(chars#0, c#18) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#18) } $IsBox(c#18, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#18) ==> Seq#Contains(chars#0, c#18)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#32 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#32) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#32), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#32 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#32), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#33 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#33) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#33), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#33 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#33), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#50: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#50)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#50) } $IsBox(c#50, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#50) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#50)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#51: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#51)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#51) } $IsBox(c#51, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#51) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#51)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#52: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#52)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#52) } $IsBox(c#52, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#52) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#52)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(Seq#Contains(chars#0, $l#22#c#0))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#35: Box :: { Map#Domain(digits#0)[c#35] } { Seq#Contains(str#0, c#35) } $IsBox(c#35, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#35) ==> Map#Domain(digits#0)[c#35])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#35: Box :: { Map#Domain(digits#0)[c#35] } { Seq#Contains(str#0, c#35) } $IsBox(c#35, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#35) ==> Map#Domain(digits#0)[c#35])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#36: Box :: { Map#Domain(digits#0)[c#36] } { Seq#Contains(str#0, c#36) } $IsBox(c#36, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#36) ==> Map#Domain(digits#0)[c#36])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box(Map#Domain(digits#0)[$l#69#c#0])), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box(Map#Domain(digits#0)[$l#69#c#0])), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box(Map#Domain(digits#0)[$l#70#c#0])), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(Map#Domain(digits#0)[$l#71#c#0])), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#48 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#48) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#48) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#48)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#48) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#48)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#48 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#48) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#48) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#48)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#48) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#48))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#48 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#48) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#48) else (var tl#96 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#48)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#96)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#48 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#48) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#48) else (var tl#97 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#48)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#97)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#49 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#49) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#49) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#49)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#49) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#49)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#49 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#49) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#49) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#49)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#49) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#49))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#49 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#49) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#49) else (var tl#98 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#49)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#98)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#49 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#49) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#49) else (var tl#99 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#49)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#99)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#50 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#50) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#50) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#50)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#50) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#50)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#50 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#50) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#50) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#50)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#50) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#50))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#50 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#50) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#50) else (var tl#100 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#50)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#100)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#50 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#50) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#50) else (var tl#101 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#50)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#101)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#18: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#18)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#18)) ==> LitInt(0) <= d#18 && d#18 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#48 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#49 := Seq#Append(digits'#48, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#49))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#49 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#50 := Seq#Append(digits'#49, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#50))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#50 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#51 := Seq#Append(digits'#50, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#51))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#18: char :: { Seq#Contains(chars#0, $Box(c#18)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#18)) ==> Seq#Contains(chars#0, $Box(c#18))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#37: int :: { Seq#Contains(digits#0, $Box(d#37)) } Seq#Contains(digits#0, $Box(d#37)) ==> LitInt(0) <= d#37 && d#37 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#37: int :: { Seq#Contains(digits#0, $Box(d#37)) } Seq#Contains(digits#0, $Box(d#37)) ==> LitInt(0) <= d#37 && d#37 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#38: int :: { Seq#Contains(digits#0, $Box(d#38)) } Seq#Contains(digits#0, $Box(d#38)) ==> LitInt(0) <= d#38 && d#38 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#18: char :: { Seq#Contains(chars#0, $Box(c#18)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#18)) ==> Seq#Contains(chars#0, $Box(c#18))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#32 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#32) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#32), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#32 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#32), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#33 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#33) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#33), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#33 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#33), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#50: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#50))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#50)) } $Is(c#50, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#50)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#50))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#51: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#51))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#51)) } $Is(c#51, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#51)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#51))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#52: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#52))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#52)) } $Is(c#52, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#52)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#52))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(Seq#Contains(chars#0, $l#22#c#0))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TChar)), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#35: char :: { Map#Domain(digits#0)[$Box(c#35)] } { Seq#Contains(str#0, $Box(c#35)) } $Is(c#35, TChar) && Seq#Contains(str#0, $Box(c#35)) ==> Map#Domain(digits#0)[$Box(c#35)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#35: char :: { Map#Domain(digits#0)[$Box(c#35)] } { Seq#Contains(str#0, $Box(c#35)) } $Is(c#35, TChar) && Seq#Contains(str#0, $Box(c#35)) ==> Map#Domain(digits#0)[$Box(c#35)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#36: char :: { Map#Domain(digits#0)[$Box(c#36)] } { Seq#Contains(str#0, $Box(c#36)) } $Is(c#36, TChar) && Seq#Contains(str#0, $Box(c#36)) ==> Map#Domain(digits#0)[$Box(c#36)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box(Map#Domain(digits#0)[$l#69#c#0])), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, TChar)), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box(Map#Domain(digits#0)[$l#69#c#0])), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, TChar)), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box(Map#Domain(digits#0)[$l#70#c#0])), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, TChar)), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(Map#Domain(digits#0)[$l#71#c#0])), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, TChar)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#48 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#48) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#48) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#48)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#48) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#48)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#48 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#48) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#48) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#48)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#48) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#48))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#48 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#48) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#48) else (var tl#96 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#48)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#96)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#48 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#48) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#48) else (var tl#97 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#48)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#97)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#49 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#49) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#49) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#49)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#49) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#49)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#49 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#49) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#49) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#49)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#49) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#49))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#49 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#49) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#49) else (var tl#98 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#49)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#98)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#49 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#49) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#49) else (var tl#99 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#49)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#99)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#50 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#50) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#50) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#50)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#50) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#50)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#50 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#50) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#50) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#50)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#50) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#50))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#50 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#50) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#50) else (var tl#100 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#50)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#100)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#50 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#50) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#50) else (var tl#101 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#50)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#101)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#17: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#17)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#17)) } $Is(c#17, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#17)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#17))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#20#c#0))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, TChar)), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#33: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)] } { Seq#Contains(str#0, $Box(c#33)) } $Is(c#33, TChar) && Seq#Contains(str#0, $Box(c#33)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#33: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)] } { Seq#Contains(str#0, $Box(c#33)) } $Is(c#33, TChar) && Seq#Contains(str#0, $Box(c#33)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#33)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#34: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#34)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#34)] } { Seq#Contains(str#0, $Box(c#34)) } $Is(c#34, TChar) && Seq#Contains(str#0, $Box(c#34)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#34)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#34)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#53#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#53#c#0]): int < base#0)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, TChar)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#53#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#53#c#0]): int < base#0)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, TChar)), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#54#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#54#c#0]): int < base#0)), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, TChar)), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#56 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#56)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#112 := JSON_mErrors.DeserializationError.b(this); (var b0#56 := JSON_mErrors.DeserializationError.expected(this); (var c#112 := (if b#112 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#112)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#56)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#112)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#113 := JSON_mErrors.DeserializationError.b(this); (var bs0#56 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#113 := (if b#113 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#113)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#56 := Seq#Create(TChar, $Heap, Seq#Length(bs0#56), Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#56, $Unbox($l#88#idx#0): int)): int))), (lambda $l#88#heap#0: Heap, $l#88#idx#0: Box :: $IsBox($l#88#idx#0, TInt) && LitInt(0) <= $Unbox($l#88#idx#0): int && $Unbox($l#88#idx#0): int < Seq#Length(bs0#56)), (lambda $l#88#heap#0: Heap, $l#88#idx#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#56), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#113))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#58 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#58)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#116 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#58 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#116 := (if b#116 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#116)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#58)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#116)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#117 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#58 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#117 := (if b#117 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#117)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#58 := Seq#Create(TChar, $Heap, Seq#Length(bs0#58), Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#58, $Unbox($l#91#idx#0): int)): int))), (lambda $l#91#heap#0: Heap, $l#91#idx#0: Box :: $IsBox($l#91#idx#0, TInt) && LitInt(0) <= $Unbox($l#91#idx#0): int && $Unbox($l#91#idx#0): int < Seq#Length(bs0#58)), (lambda $l#91#heap#0: Heap, $l#91#idx#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#58), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#117))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#57 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#57, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#56 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#56, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#56 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#56)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#59 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#59, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#58 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#58, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#58 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#58)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#32: int :: { JSON_mGrammar.__default.Blank_q(b#32) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) } LitInt(0) <= b#32 && b#32 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#32))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#32: int :: { JSON_mGrammar.__default.Blank_q(b#32) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) } LitInt(0) <= b#32 && b#32 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) ==> JSON_mGrammar.__default.Blank_q(b#32))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#33: int :: { JSON_mGrammar.__default.Blank_q(b#33) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#33)) } LitInt(0) <= b#33 && b#33 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#33)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#33))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#33: int :: { JSON_mGrammar.__default.Blank_q(b#33) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#33)) } LitInt(0) <= b#33 && b#33 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#33)) ==> JSON_mGrammar.__default.Blank_q(b#33))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#32: int :: { $Unbox(Seq#Index(s#0, idx#32)): DatatypeType } LitInt(0) <= idx#32 && idx#32 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#32)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#32: int :: { $Unbox(Seq#Index(s#0, idx#32)): DatatypeType } LitInt(0) <= idx#32 && idx#32 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#32)): DatatypeType)) <==> idx#32 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#33: int :: { $Unbox(Seq#Index(s#0, idx#33)): DatatypeType } LitInt(0) <= idx#33 && idx#33 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#33)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#33: int :: { $Unbox(Seq#Index(s#0, idx#33)): DatatypeType } LitInt(0) <= idx#33 && idx#33 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#33)): DatatypeType)) <==> idx#33 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#32: int :: { JSON_mGrammar.__default.Digit_q(b#32) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) } LitInt(0) <= b#32 && b#32 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#32))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#32: int :: { JSON_mGrammar.__default.Digit_q(b#32) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) } LitInt(0) <= b#32 && b#32 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#32)) ==> JSON_mGrammar.__default.Digit_q(b#32))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#33: int :: { JSON_mGrammar.__default.Digit_q(b#33) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#33)) } LitInt(0) <= b#33 && b#33 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#33)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#33))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#33: int :: { JSON_mGrammar.__default.Digit_q(b#33) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#33)) } LitInt(0) <= b#33 && b#33 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#33)) ==> JSON_mGrammar.__default.Digit_q(b#33))));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$12x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$12x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$12x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$12x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$12x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$12x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$12x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$12x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$12x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$12x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$12x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$12x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$12x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#39: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#39) } { Seq#Contains(ts#0, d#39) } $IsBox(d#39, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#39) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#39))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#39: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#39) } { Seq#Contains(ts#0, d#39) } $IsBox(d#39, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#39) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#39))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#40: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#40) } { Seq#Contains(ts#0, d#40) } $IsBox(d#40, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#40) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#40))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#41: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#41) } { Seq#Contains(ts#0, d#41) } $IsBox(d#41, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#41) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#41))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#39: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#39)) } $Is(d#39, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#39) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#39)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#39: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#39)) } $Is(d#39, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#39) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#39)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#40: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#40)) } $Is(d#40, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#40) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#40)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#41: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#41)) } $Is(d#41, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#41) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#41)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$12x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$12x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$12x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$12x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$12x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$12x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$12x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$12x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$12x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$12x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$12x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$12x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$12x#0))): Seq);

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$12x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$12x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$12x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$12x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$12x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$12x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$12x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$12x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$12x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$12x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$12x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$12x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$12x#0))): Seq);

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$12x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$12x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$12x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$12x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$12x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$12x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$12x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$12x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$12x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$12x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$12x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$12x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$12x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#80#d#0: DatatypeType :: $Is($l#80#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#80#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#80#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#81#ly#0, $Unbox($l#81#d#0): DatatypeType))), (lambda $l#81#heap#0: Heap, $l#81#d#0: Box :: $IsBox($l#81#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#81#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#81#heap#0: Heap, $l#81#d#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#79#ly#0, $Unbox($l#79#d#0): DatatypeType))), (lambda $l#79#heap#0: Heap, $l#79#d#0: Box :: $IsBox($l#79#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#79#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#79#heap#0: Heap, $l#79#d#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#83#d#0: DatatypeType :: $Is($l#83#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#83#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#83#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#84#ly#0, $Unbox($l#84#d#0): DatatypeType))), (lambda $l#84#heap#0: Heap, $l#84#d#0: Box :: $IsBox($l#84#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#84#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#84#heap#0: Heap, $l#84#d#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#82#ly#0, $Unbox($l#82#d#0): DatatypeType))), (lambda $l#82#heap#0: Heap, $l#82#d#0: Box :: $IsBox($l#82#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#82#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#82#heap#0: Heap, $l#82#d#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#80#d#0: DatatypeType :: $Is($l#80#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#80#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#80#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#81#ly#0, $Unbox($l#81#d#0): DatatypeType))), (lambda $l#81#heap#0: Heap, $l#81#d#0: Box :: $IsBox($l#81#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#81#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#81#heap#0: Heap, $l#81#d#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#79#ly#0, $Unbox($l#79#d#0): DatatypeType))), (lambda $l#79#heap#0: Heap, $l#79#d#0: Box :: $IsBox($l#79#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#79#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#79#heap#0: Heap, $l#79#d#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#83#d#0: DatatypeType :: $Is($l#83#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#83#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#83#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#84#ly#0, $Unbox($l#84#d#0): DatatypeType))), (lambda $l#84#heap#0: Heap, $l#84#d#0: Box :: $IsBox($l#84#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#84#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#84#heap#0: Heap, $l#84#d#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#82#ly#0, $Unbox($l#82#d#0): DatatypeType))), (lambda $l#82#heap#0: Heap, $l#82#d#0: Box :: $IsBox($l#82#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#82#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#82#heap#0: Heap, $l#82#d#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#49 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#49))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#49 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#49))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#49 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#49))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#49 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#49))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#49 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#49))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#49 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#49))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#48 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#48)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#48 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#48)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#48 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#48)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#48 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#48)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#48 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#48)) else (var arr#48 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#48))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#51 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#51))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#51 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#51))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#51 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#51))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#51 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#51))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#51 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#51))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#51 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#51))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#50 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#50))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#50 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#50))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#50 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#50))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#50 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#50))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#50 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#50))) else (var arr#50 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#50)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$12x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$12x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$12x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$12x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$12x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$12x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$12x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$12x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$12x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$12x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$12x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$12x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$12x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$12x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$12x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#42: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#42)) } $Is(d#42, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#42) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#42))) && ((forall d#42: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#42)) } $Is(d#42, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#42) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#42))) ==> (forall d#43: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#43)) } $Is(d#43, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#43) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#43)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#42: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#42)) } $Is(d#42, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#42) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#42))) && (forall d#43: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#43)) } $Is(d#43, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#43) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#43))) && (forall d#44: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#44))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#44))): Seq } $Is(d#44, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#44) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#44))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#44))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#45: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#45)) } $Is(d#45, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#45) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#45))) && ((forall d#45: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#45)) } $Is(d#45, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#45) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#45))) ==> (forall d#46: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#46)) } $Is(d#46, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#46) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#46)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#45: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#45)) } $Is(d#45, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#45) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#45))) && (forall d#46: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#46)) } $Is(d#46, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#46) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#46))) && (forall d#47: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#47))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#47))): Seq } $Is(d#47, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#47) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#47))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#47))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#48: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#48)) } $Is(d#48, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#48) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#48))) && ((forall d#48: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#48)) } $Is(d#48, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#48) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#48))) ==> (forall d#49: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#49)) } $Is(d#49, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#49) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#49)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#48: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#48)) } $Is(d#48, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#48) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#48))) && (forall d#49: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#49)) } $Is(d#49, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#49) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#49))) && (forall d#50: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#50))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#50))): Seq } $Is(d#50, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#50) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#50))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#50))): Seq))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#18 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (var cs#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#19)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#18 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#18) else (var cs#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#19)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#19 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (var cs#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#20)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#19 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#19) else (var cs#20 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#20)))))))));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$9x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$9x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$9x#0): int)));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$9x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$9x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$9x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$9x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$9x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$9x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$9x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$9x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$9x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#15#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $IsBox($l#15#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#75: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#75)) } $Is(cs#75, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#75)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#75: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#75)) } $Is(cs#75, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#75)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#76 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#18 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#76))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (var cs#77 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#77))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#18, cs#76 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#18 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#76))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#18) else (var val#18, cs#77 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType); (var after#18, cs#78 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#77))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#77)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#18, val#18, after#18)), cs#78)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#79: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#79)) } $Is(cs#79, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#79)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#80 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#19 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#80))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (var cs#81 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#81))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#19, cs#80 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#19 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#80))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#19) else (var val#19, cs#81 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType); (var after#19, cs#82 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#81))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#81)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#19, val#19, after#19)), cs#82)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#14#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: $IsBox($l#14#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#14#heap#0: Heap, $l#14#st#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#55 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#55) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#55)) && (var cs#56 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#55))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#56))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#18, cs#55 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#18, cs#56 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#55)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#55))); (var after#18, cs#57 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#56))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#56)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#18, $Box(val#18), after#18)), cs#57)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#58 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#58) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#58)) && (var cs#59 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#58))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#59))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#19, cs#58 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#19, cs#59 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#58)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#58))); (var after#19, cs#60 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#59))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#59)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#19, $Box(val#19), after#19)), cs#60)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#20: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#20) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#20))): Seq } $Is(t#20, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#20)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#20: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#20) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#20))): Seq } $Is(t#20, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#20))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#20)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#21: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#21) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#21))): Seq } $Is(t#21, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#21)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#21: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#21) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#21))): Seq } $Is(t#21, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#21))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#21)))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$4x#0: Box, $fh$4x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$4x#0, $fh$4x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$4x#0, $fh$4x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$4x#0): bool, $Unbox($fh$4x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$4x#0: Box, $fh$4x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$4x#0, $fh$4x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$4x#0, $fh$4x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$4x#0): bool, $Unbox($fh$4x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$4x#0: Box, $fh$4x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$4x#0, $fh$4x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$4x#0, $fh$4x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$4x#0: bool, $fh$4x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$4x#0, $fh$4x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$4x#0, $fh$4x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$4x#0), $Box($fh$4x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#25 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#25) && (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#25); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (var contents#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#16) && (var cs#26 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#16)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#26) && (var valueOrError2#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#26); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#8) else (var lq#8, cs#25 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#25); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#8) else (var contents#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; (var contents#17, cs#26 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#16))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#16)); (var valueOrError2#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#26); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#8) else (var rq#8, cs#27 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#8, contents#17, rq#8)), cs#27))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#9 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#28 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#28) && (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#28); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (var contents#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#18) && (var cs#29 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#18)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#29) && (var valueOrError2#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#29); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#9 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#9) else (var lq#9, cs#28 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType)); (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#28); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#9) else (var contents#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; (var contents#19, cs#29 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#18))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#18)); (var valueOrError2#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#29); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#9) else (var rq#9, cs#30 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#9, contents#19, rq#9)), cs#30))))))))))))));

axiom $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

axiom (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(t#0) || $Is(t#0, Tclass.JSON_mGrammar.Value()) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall t#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(t#0) || $Is(t#0, Tclass.JSON_mGrammar.Value()) ==> JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(t#0) == JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#0));

axiom (forall t#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(Lit(t#0)) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(Lit(t#0)) || $Is(t#0, Tclass.JSON_mGrammar.Value()) ==> JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(t#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(Lit(t#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), Lit(t#0))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, cs#0, json#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(cs#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), json#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(Lit(cs#0)))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(Lit(cs#0)))): DatatypeType);

const reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mConstants.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal: bool, cs#0: DatatypeType, expected#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType)): DatatypeType), expected#0)) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#_v3#0: Box :: $Box(expected#0)), (lambda $l#0#heap#0: Heap, $l#0#_v3#0: Box :: $IsBox($l#0#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#0#heap#0: Heap, $l#0#_v3#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0)) && (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#1)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) == (var valueOrError0#0 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#0) else (var cs#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#1)))))));
axiom 0 <= $FunctionContextHeight ==> (forall cs#0: DatatypeType, expected#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), Lit(expected#0)) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(expected#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(expected#0), LitInt(0)) && (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (var cs#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#2)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) == (var valueOrError0#1 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#1) else (var cs#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#2)))))))));
}

function JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0: DatatypeType, expected#0: Seq) : bool;

function JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#requires(DatatypeType, Seq) : bool;

axiom (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#requires(cs#0, expected#0) } $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#requires(cs#0, expected#0) <==> Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Constants.Constant (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()), expected#0: Seq where $Is(expected#0, TSeq(Tclass.BoundedInts.uint8()))) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28039"} Wrappers.Result.Success_q(pr#0) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType), expected#0);
  free ensures {:id "id28040"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#_v3#0: Box :: $Box(expected#0)), (lambda $l#1#heap#0: Heap, $l#1#_v3#0: Box :: $IsBox($l#1#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#1#heap#0: Heap, $l#1#_v3#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $LS($LZ))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Constants.Constant (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(cs#0: DatatypeType, expected#0: Seq) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var $lambdaHeap#0: Heap;
  var _v3#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: Seq;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##bs#0: Seq;
  var ##offset#0: int;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Constants.Constant", " | ", cs#0, " | ", expected#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(647,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32();
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.value(pr#0)): DatatypeType);
    assume $IsAllocBox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType), expected#0);
    goto anon5;

  anon18_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(pr#0)): DatatypeType)): DatatypeType), expected#0);
    goto anon5;

  anon5:
    goto anon19_Then, anon19_Else;

  anon19_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap);
    goto anon20_Then, anon20_Else;

  anon20_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc _v3#0;
    goto anon21_Then, anon21_Else;

  anon21_Then:
    assume {:partition} $Is(_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume lambdaResult#0 == expected#0;
    assume true;
    assume $Is(lambdaResult#0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon9;

  anon21_Else:
    assume {:partition} !($Is(_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__()) && $IsAlloc(_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__(), $lambdaHeap#0));
    goto anon9;

  anon9:
    assume false;
    goto anon10;

  anon20_Else:
    goto anon10;

  anon10:
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := Lit(AtLayer((lambda $l#3#ly#0: LayerType :: Handle1((lambda $l#3#heap#0: Heap, $l#3#_v3#0: Box :: $Box(expected#0)), (lambda $l#3#heap#0: Heap, $l#3#_v3#0: Box :: $IsBox($l#3#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#3#heap#0: Heap, $l#3#_v3#0: Box :: SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), $LS($LZ)));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#4#ly#0: LayerType :: Handle1((lambda $l#4#heap#0: Heap, $l#4#_v3#0: Box :: $Box(expected#0)), (lambda $l#4#heap#0: Heap, $l#4#_v3#0: Box :: $IsBox($l#4#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#4#heap#0: Heap, $l#4#_v3#0: Box :: SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), $LS($LZ))));
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#_v3#0: Box :: $Box(expected#0)), (lambda $l#5#heap#0: Heap, $l#5#_v3#0: Box :: $IsBox($l#5#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#5#heap#0: Heap, $l#5#_v3#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $LS($LZ))));
    goto anon12;

  anon19_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#_v3#0: Box :: $Box(expected#0)), (lambda $l#6#heap#0: Heap, $l#6#_v3#0: Box :: $IsBox($l#6#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#6#heap#0: Heap, $l#6#_v3#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($LZ))));
    goto anon12;

  anon12:
    assume false;
    return;

  anon17_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##bs#0 := expected#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    ##offset#0 := LitInt(0);
    assume $IsAlloc(##offset#0, Tclass.BoundedInts.uint32(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume {:subsumption 0} ##offset#0 <= Seq#Length(##bs#0);
    assume ##offset#0 <= Seq#Length(##bs#0);
    assume {:subsumption 0} (forall b#0: int :: { Seq#Contains(##bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##bs#0, $Box(b#0)) ==> b#0 < 256);
    assume (forall b#0: int :: { Seq#Contains(##bs#0, $Box(b#0)) } LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(##bs#0, $Box(b#0)) ==> b#0 < 256);
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0));
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0));
    assume JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon22_Then, anon22_Else;

  anon22_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, expected#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon16;

  anon22_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc cs#Z#0;
    assume $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Cursor());
    assume cs#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0));
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, expected#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#Z#0)));
    assume JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon16;

  anon16:
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, expected#0) == pr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Constants.reveal_Constant (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mConstants.__default.reveal__Constant();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Constants.reveal_Constant (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mConstants.__default.reveal__Constant();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Constants.reveal_Constant (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mConstants.__default.reveal__Constant();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#252 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#252))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#254 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#254)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#378 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#378))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#380 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#380)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#382 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#382)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#378 := Wrappers.Option.value(this); v#378)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#380 := Lit(Wrappers.Option.value(Lit(this))); v#380)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#382 := Lit(Wrappers.Option.value(Lit(this))); v#382)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#252 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#252)) else (var e#252 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#254 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#254))) else (var e#254 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#378 := Wrappers.Result.value(this); s#378) else (var e#378 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#380 := Lit(Wrappers.Result.value(Lit(this))); s#380) else (var e#380 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#382 := Lit(Wrappers.Result.value(Lit(this))); s#382) else (var e#382 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#378 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#378)) else (var e#378 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#378)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#380 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#380))) else (var e#380 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#380)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#382 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#382))) else (var e#382 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#382)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#174: int, y#174: int :: { Mul(x#174, y#174) } Mul(x#174, y#174) == Mul(y#174, x#174)) && (forall x#175: int, y#175: int, z#116: int :: { Mul(x#175 + y#175, z#116) } Mul(x#175 + y#175, z#116) == Mul(x#175, z#116) + Mul(y#175, z#116)) && (forall x#176: int, y#176: int, z#117: int :: { Mul(x#176 - y#176, z#117) } Mul(x#176 - y#176, z#117) == Mul(x#176, z#117) - Mul(y#176, z#117));

axiom MulInternals.__default.MulAuto() <==> (forall x#177: int, y#177: int :: { Mul(x#177, y#177) } Mul(x#177, y#177) == Mul(y#177, x#177)) && (forall x#178: int, y#178: int, z#118: int :: { Mul(x#178 + y#178, z#118) } Mul(x#178 + y#178, z#118) == Mul(x#178, z#118) + Mul(y#178, z#118)) && (forall x#179: int, y#179: int, z#119: int :: { Mul(x#179 - y#179, z#119) } Mul(x#179 - y#179, z#119) == Mul(x#179, z#119) - Mul(y#179, z#119));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#216: int :: { Mod(Mod(x#216, n#0), n#0) } Mod(Mod(x#216, n#0), n#0) == Mod(x#216, n#0)) && (forall x#217: int :: { Mod(x#217, n#0) } LitInt(0) <= x#217 && x#217 < n#0 <==> Mod(x#217, n#0) == x#217) && (forall x#218: int, y#108: int :: { Mod(x#218 + y#108, n#0) } (var z#106 := Mod(x#218, n#0) + Mod(y#108, n#0); (LitInt(0) <= z#106 && z#106 < n#0 && Mod(x#218 + y#108, n#0) == z#106) || (n#0 <= z#106 && z#106 < n#0 + n#0 && Mod(x#218 + y#108, n#0) == z#106 - n#0))) && (forall x#219: int, y#109: int :: { Mod(x#219 - y#109, n#0) } (var z#107 := Mod(x#219, n#0) - Mod(y#109, n#0); (LitInt(0) <= z#107 && z#107 < n#0 && Mod(x#219 - y#109, n#0) == z#107) || (0 - n#0 <= z#107 && z#107 < 0 && Mod(x#219 - y#109, n#0) == z#107 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#220: int :: { Mod(Mod(x#220, n#0), n#0) } Mod(Mod(x#220, LitInt(n#0)), LitInt(n#0)) == Mod(x#220, LitInt(n#0))) && (forall x#221: int :: { Mod(x#221, n#0) } LitInt(0) <= x#221 && x#221 < n#0 <==> Mod(x#221, LitInt(n#0)) == x#221) && (forall x#222: int, y#110: int :: { Mod(x#222 + y#110, n#0) } (var z#108 := Mod(x#222, LitInt(n#0)) + Mod(y#110, LitInt(n#0)); (LitInt(0) <= z#108 && z#108 < n#0 && Mod(x#222 + y#110, LitInt(n#0)) == z#108) || (LitInt(n#0) <= z#108 && z#108 < n#0 + n#0 && Mod(x#222 + y#110, LitInt(n#0)) == z#108 - n#0))) && (forall x#223: int, y#111: int :: { Mod(x#223 - y#111, n#0) } (var z#109 := Mod(x#223, LitInt(n#0)) - Mod(y#111, LitInt(n#0)); (LitInt(0) <= z#109 && z#109 < n#0 && Mod(x#223 - y#111, LitInt(n#0)) == z#109) || (LitInt(0 - n#0) <= z#109 && z#109 < 0 && Mod(x#223 - y#111, LitInt(n#0)) == z#109 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#156: int :: { Div(x#156, n#0) } LitInt(0) <= x#156 && x#156 < n#0 <==> Div(x#156, n#0) == LitInt(0)) && (forall x#157: int, y#104: int :: { Div(x#157 + y#104, n#0) } (var z#102 := Mod(x#157, n#0) + Mod(y#104, n#0); (LitInt(0) <= z#102 && z#102 < n#0 && Div(x#157 + y#104, n#0) == Div(x#157, n#0) + Div(y#104, n#0)) || (n#0 <= z#102 && z#102 < n#0 + n#0 && Div(x#157 + y#104, n#0) == Div(x#157, n#0) + Div(y#104, n#0) + 1))) && (forall x#158: int, y#105: int :: { Div(x#158 - y#105, n#0) } (var z#103 := Mod(x#158, n#0) - Mod(y#105, n#0); (LitInt(0) <= z#103 && z#103 < n#0 && Div(x#158 - y#105, n#0) == Div(x#158, n#0) - Div(y#105, n#0)) || (0 - n#0 <= z#103 && z#103 < 0 && Div(x#158 - y#105, n#0) == Div(x#158, n#0) - Div(y#105, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#159: int :: { Div(x#159, n#0) } LitInt(0) <= x#159 && x#159 < n#0 <==> Div(x#159, LitInt(n#0)) == LitInt(0)) && (forall x#160: int, y#106: int :: { Div(x#160 + y#106, n#0) } (var z#104 := Mod(x#160, LitInt(n#0)) + Mod(y#106, LitInt(n#0)); (LitInt(0) <= z#104 && z#104 < n#0 && Div(x#160 + y#106, LitInt(n#0)) == Div(x#160, LitInt(n#0)) + Div(y#106, LitInt(n#0))) || (LitInt(n#0) <= z#104 && z#104 < n#0 + n#0 && Div(x#160 + y#106, LitInt(n#0)) == Div(x#160, LitInt(n#0)) + Div(y#106, LitInt(n#0)) + 1))) && (forall x#161: int, y#107: int :: { Div(x#161 - y#107, n#0) } (var z#105 := Mod(x#161, LitInt(n#0)) - Mod(y#107, LitInt(n#0)); (LitInt(0) <= z#105 && z#105 < n#0 && Div(x#161 - y#107, LitInt(n#0)) == Div(x#161, LitInt(n#0)) - Div(y#107, LitInt(n#0))) || (LitInt(0 - n#0) <= z#105 && z#105 < 0 && Div(x#161 - y#107, LitInt(n#0)) == Div(x#161, LitInt(n#0)) - Div(y#107, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#40 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#40) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#40)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#40 := lv#0; (var dt_update#end#0#40 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#40), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#40), dt_update#end#0#40))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#41 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#41) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#41)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#41 := Lit(lv#0); (var dt_update#end#0#41 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#41)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#41)), dt_update#end#0#41)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#42: char :: { Seq#Contains(s#0, $Box(c#42)) } $Is(c#42, TChar) && Seq#Contains(s#0, $Box(c#42)) ==> char#ToInt(c#42) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#42: char :: { Seq#Contains(s#0, $Box(c#42)) } $Is(c#42, TChar) && Seq#Contains(s#0, $Box(c#42)) ==> char#ToInt(c#42) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#84#i#0): int)): char))), (lambda $l#84#heap#0: Heap, $l#84#i#0: Box :: $IsBox($l#84#i#0, TInt) && LitInt(0) <= $Unbox($l#84#i#0): int && $Unbox($l#84#i#0): int < Seq#Length(s#0)), (lambda $l#84#heap#0: Heap, $l#84#i#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#43: char :: { Seq#Contains(s#0, $Box(c#43)) } $Is(c#43, TChar) && Seq#Contains(s#0, $Box(c#43)) ==> char#ToInt(c#43) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#86#i#0): int)): char))), (lambda $l#86#heap#0: Heap, $l#86#i#0: Box :: $IsBox($l#86#i#0, TInt) && LitInt(0) <= $Unbox($l#86#i#0): int && $Unbox($l#86#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#86#heap#0: Heap, $l#86#i#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#144 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#72 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#144 := (if b#144 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#144)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#72)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#144)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#145 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#72 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#145 := (if b#145 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#145)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#72 := Seq#Create(TChar, $Heap, Seq#Length(bs0#72), Lit(AtLayer((lambda $l#112#ly#0: LayerType :: Handle1((lambda $l#112#heap#0: Heap, $l#112#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#72, $Unbox($l#112#idx#0): int)): int))), (lambda $l#112#heap#0: Heap, $l#112#idx#0: Box :: $IsBox($l#112#idx#0, TInt) && LitInt(0) <= $Unbox($l#112#idx#0): int && $Unbox($l#112#idx#0): int < Seq#Length(bs0#72)), (lambda $l#112#heap#0: Heap, $l#112#idx#0: Box :: SetRef_to_SetBox((lambda $l#112#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#72), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#145))))) else (var err#72 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#72)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#148 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#74 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#148 := (if b#148 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#148)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#74)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#148)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#149 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#74 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#149 := (if b#149 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#149)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#74 := Seq#Create(TChar, $Heap, Seq#Length(bs0#74), Lit(AtLayer((lambda $l#115#ly#0: LayerType :: Handle1((lambda $l#115#heap#0: Heap, $l#115#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#74, $Unbox($l#115#idx#0): int)): int))), (lambda $l#115#heap#0: Heap, $l#115#idx#0: Box :: $IsBox($l#115#idx#0, TInt) && LitInt(0) <= $Unbox($l#115#idx#0): int && $Unbox($l#115#idx#0): int < Seq#Length(bs0#74)), (lambda $l#115#heap#0: Heap, $l#115#idx#0: Box :: SetRef_to_SetBox((lambda $l#115#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#74), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#149))))) else (var err#74 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#74)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#152 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#76 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#152 := (if b#152 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#152)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#76)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#152)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#153 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#76 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#153 := (if b#153 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#153)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#76 := Seq#Create(TChar, $Heap, Seq#Length(bs0#76), Lit(AtLayer((lambda $l#118#ly#0: LayerType :: Handle1((lambda $l#118#heap#0: Heap, $l#118#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#76, $Unbox($l#118#idx#0): int)): int))), (lambda $l#118#heap#0: Heap, $l#118#idx#0: Box :: $IsBox($l#118#idx#0, TInt) && LitInt(0) <= $Unbox($l#118#idx#0): int && $Unbox($l#118#idx#0): int < Seq#Length(bs0#76)), (lambda $l#118#heap#0: Heap, $l#118#idx#0: Box :: SetRef_to_SetBox((lambda $l#118#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#76), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#153))))) else (var err#76 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#76)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#14: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#14)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#14)): int } LitInt(0) <= idx#14 && idx#14 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#14 && idx#14 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#14)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#14)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#24 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#24 := this; (var dt_update#beg#0#24 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#24), dt_update#beg#0#24, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#24), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#24)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#25 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#25 := Lit(this); (var dt_update#beg#0#25 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#25)), dt_update#beg#0#25, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#25)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#25)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#72#v#0): DatatypeType))), (lambda $l#72#heap#0: Heap, $l#72#v#0: Box :: $IsBox($l#72#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#72#heap#0: Heap, $l#72#v#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#73#v#0): DatatypeType))), (lambda $l#73#heap#0: Heap, $l#73#v#0: Box :: $IsBox($l#73#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#73#heap#0: Heap, $l#73#v#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#74#v#0): DatatypeType))), (lambda $l#74#heap#0: Heap, $l#74#v#0: Box :: $IsBox($l#74#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#74#heap#0: Heap, $l#74#v#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#24 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#24 := this; (var dt_update#point#0#24 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#24), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#24), dt_update#point#0#24, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#24)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#25 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#25 := Lit(this); (var dt_update#point#0#25 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#25)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#25)), dt_update#point#0#25, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#25)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#24 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#24)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#24 := this; (var dt_update#point#0#24 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#24), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#24), dt_update#point#0#24, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#24)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#25 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#25)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#25 := Lit(this); (var dt_update#point#0#25 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#25)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#25)), dt_update#point#0#25, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#25)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#24 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#24 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#24 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#24 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#24))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#25 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#25 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#25 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#25 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#25)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#39: int :: { Seq#Contains(bs#0, $Box(b#39)) } LitInt(0) <= b#39 && b#39 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#39)) ==> b#39 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#39: int :: { Seq#Contains(bs#0, $Box(b#39)) } LitInt(0) <= b#39 && b#39 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#39)) ==> b#39 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#36 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#36)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36) && (var ps#36 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#36, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#36 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#36) else (var ps#36 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#36)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#36, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#40: int :: { Seq#Contains(bs#0, $Box(b#40)) } LitInt(0) <= b#40 && b#40 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#40)) ==> b#40 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#37 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#37)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37) && (var ps#37 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#37, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#37 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#37) else (var ps#37 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#37)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#37, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#41: int :: { Seq#Contains(bs#0, $Box(b#41)) } LitInt(0) <= b#41 && b#41 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#41)) ==> b#41 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#38 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#38)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38) && (var ps#38 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#38, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#38 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#38) else (var ps#38 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#38)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#38, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#14: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#14)): int } LitInt(0) <= idx#14 && idx#14 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#14 && idx#14 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#14)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#74 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#74)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#73 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#73)))) else (var st#73 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#73))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#76 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#76)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#75 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#75)))) else (var st#75 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#75))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#78 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#78)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#77 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#77)))) else (var st#77 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#77))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#96#ly#0: LayerType :: Handle1((lambda $l#96#heap#0: Heap, $l#96#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#96#heap#0: Heap, $l#96#_v0#0: Box :: $IsBox($l#96#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#96#heap#0: Heap, $l#96#_v0#0: Box :: SetRef_to_SetBox((lambda $l#96#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#97#ly#0: LayerType :: Handle1((lambda $l#97#heap#0: Heap, $l#97#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#97#heap#0: Heap, $l#97#_v1#0: Box :: $IsBox($l#97#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#97#heap#0: Heap, $l#97#_v1#0: Box :: SetRef_to_SetBox((lambda $l#97#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#100#ly#0: LayerType :: Handle1((lambda $l#100#heap#0: Heap, $l#100#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#100#heap#0: Heap, $l#100#_v0#0: Box :: $IsBox($l#100#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#100#heap#0: Heap, $l#100#_v0#0: Box :: SetRef_to_SetBox((lambda $l#100#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#101#ly#0: LayerType :: Handle1((lambda $l#101#heap#0: Heap, $l#101#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#101#heap#0: Heap, $l#101#_v1#0: Box :: $IsBox($l#101#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#101#heap#0: Heap, $l#101#_v1#0: Box :: SetRef_to_SetBox((lambda $l#101#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#144#ly#0: LayerType :: Handle1((lambda $l#144#heap#0: Heap, $l#144#cs#0: Box :: $Box(Lit(false))), (lambda $l#144#heap#0: Heap, $l#144#cs#0: Box :: $IsBox($l#144#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#144#heap#0: Heap, $l#144#cs#0: Box :: SetRef_to_SetBox((lambda $l#144#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#145#ly#0: LayerType :: Handle1((lambda $l#145#heap#0: Heap, $l#145#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#145#heap#0: Heap, $l#145#cs#0: Box :: $IsBox($l#145#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#145#heap#0: Heap, $l#145#cs#0: Box :: SetRef_to_SetBox((lambda $l#145#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#146#ly#0: LayerType :: Handle1((lambda $l#146#heap#0: Heap, $l#146#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#146#heap#0: Heap, $l#146#_v2#0: Box :: $IsBox($l#146#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#146#heap#0: Heap, $l#146#_v2#0: Box :: SetRef_to_SetBox((lambda $l#146#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#150#ly#0: LayerType :: Handle1((lambda $l#150#heap#0: Heap, $l#150#cs#0: Box :: $Box(Lit(false))), (lambda $l#150#heap#0: Heap, $l#150#cs#0: Box :: $IsBox($l#150#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#150#heap#0: Heap, $l#150#cs#0: Box :: SetRef_to_SetBox((lambda $l#150#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#151#ly#0: LayerType :: Handle1((lambda $l#151#heap#0: Heap, $l#151#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#151#heap#0: Heap, $l#151#cs#0: Box :: $IsBox($l#151#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#151#heap#0: Heap, $l#151#cs#0: Box :: SetRef_to_SetBox((lambda $l#151#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#152#ly#0: LayerType :: Handle1((lambda $l#152#heap#0: Heap, $l#152#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#152#heap#0: Heap, $l#152#_v2#0: Box :: $IsBox($l#152#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#152#heap#0: Heap, $l#152#_v2#0: Box :: SetRef_to_SetBox((lambda $l#152#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#24: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#24))): DatatypeType } $Is(cs'#24, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#24))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#24))): DatatypeType)): DatatypeType, cs'#24, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#24: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#24))): DatatypeType } $Is(cs'#24, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#24))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#24))): DatatypeType)): DatatypeType, cs'#24, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#25: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#25))): DatatypeType } $Is(cs'#25, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#25))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#25))): DatatypeType)): DatatypeType, cs'#25, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#25: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#25))): DatatypeType } $Is(cs'#25, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#25))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#25))): DatatypeType)): DatatypeType, cs'#25, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#72: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#72)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#72))): bool } $Is(cs'#72, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#72))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#72)))) && ((forall cs'#72: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#72)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#72))): bool } $Is(cs'#72, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#72))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#72))) ==> (forall cs'#73: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#73))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#73, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#73: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#73))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#73, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#73))): bool) ==> (forall cs'#74: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#74))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#74))): bool } $Is(cs'#74, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#74))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#74))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#74))): DatatypeType)): DatatypeType, cs'#74, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#72: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#72)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#72))): bool } $Is(cs'#72, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#72))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#72))) && (forall cs'#73: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#73))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#73, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#73, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#73))): bool) && (forall cs'#74: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#74))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#74))): bool } $Is(cs'#74, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#74))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#74))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#74))): DatatypeType)): DatatypeType, cs'#74, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#75: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#75)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#75))): bool } $Is(cs'#75, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#75))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#75)))) && ((forall cs'#75: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#75)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#75))): bool } $Is(cs'#75, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#75))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#75))) ==> (forall cs'#76: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#76))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#76, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#76, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#76, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#76, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#76: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#76))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#76, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#76, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#76, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#76))): bool) ==> (forall cs'#77: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#77))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#77))): bool } $Is(cs'#77, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#77))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#77))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#77))): DatatypeType)): DatatypeType, cs'#77, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#75: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#75)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#75))): bool } $Is(cs'#75, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#75))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#75))) && (forall cs'#76: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#76))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#76, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#76, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#76, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#76))): bool) && (forall cs'#77: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#77))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#77))): bool } $Is(cs'#77, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#77))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#77))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#77))): DatatypeType)): DatatypeType, cs'#77, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#19: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#19)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#19)) ==> LitInt(0) <= d#19 && d#19 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#51 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#52 := Seq#Append(digits'#51, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#52))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#52 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#53 := Seq#Append(digits'#52, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#53))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#53 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#54 := Seq#Append(digits'#53, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#54))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#19: Box :: { Seq#Contains(chars#0, c#19) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#19) } $IsBox(c#19, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#19) ==> Seq#Contains(chars#0, c#19)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#39: int :: { Seq#Contains(digits#0, $Box(d#39)) } Seq#Contains(digits#0, $Box(d#39)) ==> LitInt(0) <= d#39 && d#39 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#39: int :: { Seq#Contains(digits#0, $Box(d#39)) } Seq#Contains(digits#0, $Box(d#39)) ==> LitInt(0) <= d#39 && d#39 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#40: int :: { Seq#Contains(digits#0, $Box(d#40)) } Seq#Contains(digits#0, $Box(d#40)) ==> LitInt(0) <= d#40 && d#40 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#19: Box :: { Seq#Contains(chars#0, c#19) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#19) } $IsBox(c#19, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#19) ==> Seq#Contains(chars#0, c#19)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#34 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#34) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#34), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#34 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#34), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#35 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#35) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#35), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#35 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#35), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#53: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#53)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#53) } $IsBox(c#53, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#53) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#53)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#54: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#54)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#54) } $IsBox(c#54, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#54) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#54)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#55: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#55)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#55) } $IsBox(c#55, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#55) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#55)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Seq#Contains(chars#0, $l#23#c#0))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#37: Box :: { Map#Domain(digits#0)[c#37] } { Seq#Contains(str#0, c#37) } $IsBox(c#37, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#37) ==> Map#Domain(digits#0)[c#37])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#37: Box :: { Map#Domain(digits#0)[c#37] } { Seq#Contains(str#0, c#37) } $IsBox(c#37, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#37) ==> Map#Domain(digits#0)[c#37])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#38: Box :: { Map#Domain(digits#0)[c#38] } { Seq#Contains(str#0, c#38) } $IsBox(c#38, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#38) ==> Map#Domain(digits#0)[c#38])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box(Map#Domain(digits#0)[$l#73#c#0])), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box(Map#Domain(digits#0)[$l#73#c#0])), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box(Map#Domain(digits#0)[$l#74#c#0])), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $Box(Map#Domain(digits#0)[$l#75#c#0])), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $IsBox($l#75#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#51 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#51) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#51) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#51)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#51) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#51)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#51 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#51) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#51) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#51)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#51) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#51))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#51 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#51) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#51) else (var tl#102 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#51)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#102)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#51 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#51) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#51) else (var tl#103 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#51)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#103)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#52 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#52) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#52) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#52)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#52) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#52)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#52 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#52) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#52) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#52)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#52) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#52))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#52 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#52) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#52) else (var tl#104 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#52)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#104)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#52 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#52) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#52) else (var tl#105 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#52)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#105)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#53 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#53) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#53) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#53)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#53) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#53)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#53 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#53) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#53) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#53)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#53) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#53))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#53 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#53) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#53) else (var tl#106 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#53)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#106)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#53 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#53) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#53) else (var tl#107 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#53)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#107)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#19: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#19)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#19)) ==> LitInt(0) <= d#19 && d#19 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#51 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#52 := Seq#Append(digits'#51, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#52))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#52 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#53 := Seq#Append(digits'#52, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#53))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#53 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#54 := Seq#Append(digits'#53, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#54))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#19: char :: { Seq#Contains(chars#0, $Box(c#19)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#19)) ==> Seq#Contains(chars#0, $Box(c#19))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#39: int :: { Seq#Contains(digits#0, $Box(d#39)) } Seq#Contains(digits#0, $Box(d#39)) ==> LitInt(0) <= d#39 && d#39 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#39: int :: { Seq#Contains(digits#0, $Box(d#39)) } Seq#Contains(digits#0, $Box(d#39)) ==> LitInt(0) <= d#39 && d#39 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#40: int :: { Seq#Contains(digits#0, $Box(d#40)) } Seq#Contains(digits#0, $Box(d#40)) ==> LitInt(0) <= d#40 && d#40 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#19: char :: { Seq#Contains(chars#0, $Box(c#19)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#19)) ==> Seq#Contains(chars#0, $Box(c#19))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#34 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#34) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#34), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#34 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#34), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#35 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#35) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#35), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#35 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#35), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#53: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#53))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#53)) } $Is(c#53, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#53)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#53))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#54: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#54))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#54)) } $Is(c#54, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#54)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#54))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#55: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#55))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#55)) } $Is(c#55, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#55)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#55))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Seq#Contains(chars#0, $l#23#c#0))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#37: char :: { Map#Domain(digits#0)[$Box(c#37)] } { Seq#Contains(str#0, $Box(c#37)) } $Is(c#37, TChar) && Seq#Contains(str#0, $Box(c#37)) ==> Map#Domain(digits#0)[$Box(c#37)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#37: char :: { Map#Domain(digits#0)[$Box(c#37)] } { Seq#Contains(str#0, $Box(c#37)) } $Is(c#37, TChar) && Seq#Contains(str#0, $Box(c#37)) ==> Map#Domain(digits#0)[$Box(c#37)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#38: char :: { Map#Domain(digits#0)[$Box(c#38)] } { Seq#Contains(str#0, $Box(c#38)) } $Is(c#38, TChar) && Seq#Contains(str#0, $Box(c#38)) ==> Map#Domain(digits#0)[$Box(c#38)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box(Map#Domain(digits#0)[$l#73#c#0])), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, TChar)), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box(Map#Domain(digits#0)[$l#73#c#0])), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, TChar)), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box(Map#Domain(digits#0)[$l#74#c#0])), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, TChar)), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $Box(Map#Domain(digits#0)[$l#75#c#0])), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: $IsBox($l#75#c#0, TChar)), (lambda $l#75#heap#0: Heap, $l#75#c#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#51 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#51) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#51) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#51)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#51) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#51)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#51 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#51) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#51) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#51)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#51) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#51))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#51 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#51) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#51) else (var tl#102 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#51)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#102)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#51 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#51) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#51) else (var tl#103 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#51)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#103)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#52 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#52) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#52) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#52)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#52) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#52)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#52 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#52) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#52) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#52)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#52) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#52))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#52 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#52) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#52) else (var tl#104 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#52)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#104)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#52 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#52) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#52) else (var tl#105 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#52)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#105)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#53 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#53) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#53) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#53)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#53) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#53)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#53 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#53) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#53) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#53)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#53) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#53))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#53 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#53) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#53) else (var tl#106 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#53)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#106)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#53 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#53) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#53) else (var tl#107 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#53)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#107)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#18: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#18)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#18)) } $Is(c#18, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#18)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#18))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#21#c#0))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, TChar)), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#35: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)] } { Seq#Contains(str#0, $Box(c#35)) } $Is(c#35, TChar) && Seq#Contains(str#0, $Box(c#35)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#35: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)] } { Seq#Contains(str#0, $Box(c#35)) } $Is(c#35, TChar) && Seq#Contains(str#0, $Box(c#35)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#35)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#36: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#36)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#36)] } { Seq#Contains(str#0, $Box(c#36)) } $Is(c#36, TChar) && Seq#Contains(str#0, $Box(c#36)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#36)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#36)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#56#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#56#c#0]): int < base#0)), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, TChar)), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#56#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#56#c#0]): int < base#0)), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, TChar)), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#57#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#57#c#0]): int < base#0)), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, TChar)), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#60 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#60)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#120 := JSON_mErrors.DeserializationError.b(this); (var b0#60 := JSON_mErrors.DeserializationError.expected(this); (var c#120 := (if b#120 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#120)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#60)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#120)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#121 := JSON_mErrors.DeserializationError.b(this); (var bs0#60 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#121 := (if b#121 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#121)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#60 := Seq#Create(TChar, $Heap, Seq#Length(bs0#60), Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#60, $Unbox($l#94#idx#0): int)): int))), (lambda $l#94#heap#0: Heap, $l#94#idx#0: Box :: $IsBox($l#94#idx#0, TInt) && LitInt(0) <= $Unbox($l#94#idx#0): int && $Unbox($l#94#idx#0): int < Seq#Length(bs0#60)), (lambda $l#94#heap#0: Heap, $l#94#idx#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#60), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#121))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#62 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#62)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#124 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#62 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#124 := (if b#124 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#124)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#62)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#124)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#125 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#62 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#125 := (if b#125 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#125)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#62 := Seq#Create(TChar, $Heap, Seq#Length(bs0#62), Lit(AtLayer((lambda $l#97#ly#0: LayerType :: Handle1((lambda $l#97#heap#0: Heap, $l#97#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#62, $Unbox($l#97#idx#0): int)): int))), (lambda $l#97#heap#0: Heap, $l#97#idx#0: Box :: $IsBox($l#97#idx#0, TInt) && LitInt(0) <= $Unbox($l#97#idx#0): int && $Unbox($l#97#idx#0): int < Seq#Length(bs0#62)), (lambda $l#97#heap#0: Heap, $l#97#idx#0: Box :: SetRef_to_SetBox((lambda $l#97#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#62), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#125))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#61 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#61, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#60 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#60, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#60 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#60)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#63 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#63, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#62 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#62, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#62 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#62)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#34: int :: { JSON_mGrammar.__default.Blank_q(b#34) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) } LitInt(0) <= b#34 && b#34 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#34))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#34: int :: { JSON_mGrammar.__default.Blank_q(b#34) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) } LitInt(0) <= b#34 && b#34 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) ==> JSON_mGrammar.__default.Blank_q(b#34))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#35: int :: { JSON_mGrammar.__default.Blank_q(b#35) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#35)) } LitInt(0) <= b#35 && b#35 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#35)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#35))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#35: int :: { JSON_mGrammar.__default.Blank_q(b#35) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#35)) } LitInt(0) <= b#35 && b#35 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#35)) ==> JSON_mGrammar.__default.Blank_q(b#35))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#34: int :: { $Unbox(Seq#Index(s#0, idx#34)): DatatypeType } LitInt(0) <= idx#34 && idx#34 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#34)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#34: int :: { $Unbox(Seq#Index(s#0, idx#34)): DatatypeType } LitInt(0) <= idx#34 && idx#34 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#34)): DatatypeType)) <==> idx#34 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#35: int :: { $Unbox(Seq#Index(s#0, idx#35)): DatatypeType } LitInt(0) <= idx#35 && idx#35 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#35)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#35: int :: { $Unbox(Seq#Index(s#0, idx#35)): DatatypeType } LitInt(0) <= idx#35 && idx#35 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#35)): DatatypeType)) <==> idx#35 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#34: int :: { JSON_mGrammar.__default.Digit_q(b#34) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) } LitInt(0) <= b#34 && b#34 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#34))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#34: int :: { JSON_mGrammar.__default.Digit_q(b#34) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) } LitInt(0) <= b#34 && b#34 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#34)) ==> JSON_mGrammar.__default.Digit_q(b#34))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#35: int :: { JSON_mGrammar.__default.Digit_q(b#35) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#35)) } LitInt(0) <= b#35 && b#35 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#35)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#35))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#35: int :: { JSON_mGrammar.__default.Digit_q(b#35) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#35)) } LitInt(0) <= b#35 && b#35 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#35)) ==> JSON_mGrammar.__default.Digit_q(b#35))));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$13x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$13x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$13x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$13x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$13x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$13x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$13x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$13x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$13x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$13x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$13x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$13x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$13x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#42: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#42) } { Seq#Contains(ts#0, d#42) } $IsBox(d#42, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#42) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#42))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#42: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#42) } { Seq#Contains(ts#0, d#42) } $IsBox(d#42, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#42) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#42))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#43: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#43) } { Seq#Contains(ts#0, d#43) } $IsBox(d#43, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#43) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#43))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#44: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#44) } { Seq#Contains(ts#0, d#44) } $IsBox(d#44, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#44) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#44))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#42: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#42)) } $Is(d#42, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#42) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#42)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#42: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#42)) } $Is(d#42, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#42) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#42)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#43: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#43)) } $Is(d#43, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#43) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#43)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#44: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#44)) } $Is(d#44, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#44) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#44)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$13x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$13x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$13x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$13x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$13x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$13x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$13x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$13x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$13x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$13x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$13x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$13x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$13x#0))): Seq);

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$13x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$13x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$13x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$13x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$13x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$13x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$13x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$13x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$13x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$13x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$13x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$13x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$13x#0))): Seq);

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$13x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$13x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$13x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$13x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$13x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$13x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$13x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$13x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$13x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$13x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$13x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$13x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$13x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#86#d#0: DatatypeType :: $Is($l#86#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#86#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#86#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#87#ly#0, $Unbox($l#87#d#0): DatatypeType))), (lambda $l#87#heap#0: Heap, $l#87#d#0: Box :: $IsBox($l#87#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#87#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#87#heap#0: Heap, $l#87#d#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#85#ly#0, $Unbox($l#85#d#0): DatatypeType))), (lambda $l#85#heap#0: Heap, $l#85#d#0: Box :: $IsBox($l#85#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#85#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#85#heap#0: Heap, $l#85#d#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#89#d#0: DatatypeType :: $Is($l#89#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#89#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#89#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#90#ly#0, $Unbox($l#90#d#0): DatatypeType))), (lambda $l#90#heap#0: Heap, $l#90#d#0: Box :: $IsBox($l#90#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#90#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#90#heap#0: Heap, $l#90#d#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#88#ly#0, $Unbox($l#88#d#0): DatatypeType))), (lambda $l#88#heap#0: Heap, $l#88#d#0: Box :: $IsBox($l#88#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#88#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#88#heap#0: Heap, $l#88#d#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#86#d#0: DatatypeType :: $Is($l#86#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#86#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#86#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#87#ly#0, $Unbox($l#87#d#0): DatatypeType))), (lambda $l#87#heap#0: Heap, $l#87#d#0: Box :: $IsBox($l#87#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#87#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#87#heap#0: Heap, $l#87#d#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#85#ly#0, $Unbox($l#85#d#0): DatatypeType))), (lambda $l#85#heap#0: Heap, $l#85#d#0: Box :: $IsBox($l#85#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#85#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#85#heap#0: Heap, $l#85#d#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#89#d#0: DatatypeType :: $Is($l#89#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#89#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#89#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#90#ly#0, $Unbox($l#90#d#0): DatatypeType))), (lambda $l#90#heap#0: Heap, $l#90#d#0: Box :: $IsBox($l#90#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#90#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#90#heap#0: Heap, $l#90#d#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#88#ly#0, $Unbox($l#88#d#0): DatatypeType))), (lambda $l#88#heap#0: Heap, $l#88#d#0: Box :: $IsBox($l#88#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#88#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#88#heap#0: Heap, $l#88#d#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#53 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#53))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#53 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#53))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#53 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#53))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#53 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#53))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#53 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#53))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#53 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#53))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#52 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#52)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#52 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#52)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#52 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#52)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#52 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#52)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#52 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#52)) else (var arr#52 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#52))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#55 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#55))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#55 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#55))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#55 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#55))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#55 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#55))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#55 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#55))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#55 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#55))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#54 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#54))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#54 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#54))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#54 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#54))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#54 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#54))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#54 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#54))) else (var arr#54 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#54)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$13x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$13x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$13x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$13x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$13x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$13x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$13x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$13x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$13x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$13x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$13x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$13x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$13x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$13x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$13x#0))): Seq);

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#20 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#20)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) && (var cs#21 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#21)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#20 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#20) else (var cs#21 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#21)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#21 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#21)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) && (var cs#22 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#22)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#21 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#21) else (var cs#22 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#22)))))))));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$10x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$10x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$10x#0): int)));

axiom (forall $heap: Heap, $fh$10x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$10x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$10x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$10x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$10x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$10x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$10x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$10x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$10x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$10x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$10x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#16#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $IsBox($l#16#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#83: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#83)) } $Is(cs#83, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#83)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#83: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#83)) } $Is(cs#83, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#83)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#84 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#20 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#84))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#20)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) && (var cs#85 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#85))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#20, cs#84 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#20 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#84))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#20) else (var val#20, cs#85 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType); (var after#20, cs#86 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#85))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#85)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#20, val#20, after#20)), cs#86)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#87: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#87)) } $Is(cs#87, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#87)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#88 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#21 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#88))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#21)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) && (var cs#89 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#89))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#21, cs#88 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#21 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#88))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#21) else (var val#21, cs#89 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#21)): DatatypeType); (var after#21, cs#90 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#89))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#89)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#21, val#21, after#21)), cs#90)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#15#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: $IsBox($l#15#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#15#heap#0: Heap, $l#15#st#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#61 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#61) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#61)) && (var cs#62 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#61))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#62))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#20, cs#61 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#20, cs#62 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#61)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#61))); (var after#20, cs#63 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#62))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#62)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#20, $Box(val#20), after#20)), cs#63)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#64 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#64) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#64)) && (var cs#65 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#64))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#65))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#21, cs#64 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#21, cs#65 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#64)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#64))); (var after#21, cs#66 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#65))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#65)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#21, $Box(val#21), after#21)), cs#66)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#22: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#22) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#22))): Seq } $Is(t#22, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#22)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#22: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#22) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#22))): Seq } $Is(t#22, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#22))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#22)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#23: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#23) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#23))): Seq } $Is(t#23, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#23)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#23: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#23) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#23))): Seq } $Is(t#23, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#23))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#23)))));

const reveal_JSON.ZeroCopy.Deserializer.Values._default.Value: bool;

const reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mValues.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly: LayerType, $reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0) && (var c#0 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (c#0 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)))) && (c#0 != char#ToInt(Lit(char#FromInt(123))) ==> (c#0 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)))) && (c#0 != char#ToInt(Lit(char#FromInt(91))) ==> (c#0 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError2#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)))) && (c#0 != char#ToInt(Lit(char#FromInt(34))) ==> (c#0 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE()) && (var valueOrError3#0 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0)))) && (c#0 != char#ToInt(Lit(char#FromInt(116))) ==> (c#0 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE()) && (var valueOrError4#0 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0)))) && (c#0 != char#ToInt(Lit(char#FromInt(102))) ==> (c#0 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL()) && (var valueOrError5#0 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0)))) && (c#0 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) && (var valueOrError6#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0) == (var c#0 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (if c#0 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#0) else (var obj#0, cs'#0 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#0)): DatatypeType); (var v#0 := #JSON.Grammar.Value.Object(obj#0); (var sp#0 := #JSON.Utils.Cursors.Split.SP($Box(v#0), cs'#0); #Wrappers.Result.Success($Box(sp#0))))))) else (if c#0 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#0 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#0) else (var arr#0, cs'#1 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#0)): DatatypeType); (var v#1 := #JSON.Grammar.Value.Array(arr#0); (var sp#1 := #JSON.Utils.Cursors.Split.SP($Box(v#1), cs'#1); #Wrappers.Result.Success($Box(sp#1))))))) else (if c#0 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#0 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#0) else (var str#0, cs'#2 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#0)), cs'#2)))))) else (if c#0 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#0 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#0) else (var cst#0, cs'#3 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#0)), cs'#3)))))) else (if c#0 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#0 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#0) else (var cst#1, cs'#4 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#1)), cs'#4)))))) else (if c#0 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#0 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#0) else (var cst#2, cs'#5 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#0)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#2)), cs'#5)))))) else (var valueOrError6#0 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#0) else (var num#0, cs'#6 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#0)): DatatypeType); (var v#2 := #JSON.Grammar.Value.Number(num#0); (var sp#2 := #JSON.Utils.Cursors.Split.SP($Box(v#2), cs'#6); #Wrappers.Result.Success($Box(sp#2)))))))))))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(cs#0)) && (var c#1 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (c#1 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)))) && (c#1 != char#ToInt(Lit(char#FromInt(123))) ==> (c#1 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)))) && (c#1 != char#ToInt(Lit(char#FromInt(91))) ==> (c#1 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError2#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)))) && (c#1 != char#ToInt(Lit(char#FromInt(34))) ==> (c#1 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.TRUE()) && (var valueOrError3#1 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1)))) && (c#1 != char#ToInt(Lit(char#FromInt(116))) ==> (c#1 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.FALSE()) && (var valueOrError4#1 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1)))) && (c#1 != char#ToInt(Lit(char#FromInt(102))) ==> (c#1 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.NULL()) && (var valueOrError5#1 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1)))) && (c#1 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) && (var valueOrError6#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)) == (var c#1 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (if c#1 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#1) else (var obj#1, cs'#7 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#1)): DatatypeType); (var v#3 := #JSON.Grammar.Value.Object(obj#1); (var sp#3 := #JSON.Utils.Cursors.Split.SP($Box(v#3), cs'#7); #Wrappers.Result.Success($Box(sp#3))))))) else (if c#1 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#1 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#1) else (var arr#1, cs'#8 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#1)): DatatypeType); (var v#4 := #JSON.Grammar.Value.Array(arr#1); (var sp#4 := #JSON.Utils.Cursors.Split.SP($Box(v#4), cs'#8); #Wrappers.Result.Success($Box(sp#4))))))) else (if c#1 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#1 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#1) else (var str#1, cs'#9 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#1)), cs'#9)))))) else (if c#1 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#1 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#1) else (var cst#3, cs'#10 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#3)), cs'#10)))))) else (if c#1 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#1 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#1) else (var cst#4, cs'#11 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#4)), cs'#11)))))) else (if c#1 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#1 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#1) else (var cst#5, cs'#12 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#1)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#5)), cs'#12)))))) else (var valueOrError6#1 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#1) else (var num#1, cs'#13 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#1)): DatatypeType); (var v#5 := #JSON.Grammar.Value.Number(num#1); (var sp#5 := #JSON.Utils.Cursors.Split.SP($Box(v#5), cs'#13); #Wrappers.Result.Success($Box(sp#5)))))))))))))));
}

function JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), $reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), $reveal, cs#0) == JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0));

axiom (forall $ly: LayerType, $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value(AsFuelBottom($ly), $reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0) == JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LZ, $reveal, cs#0));

axiom (forall $ly: LayerType, $heap: Heap, $fh$14x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$14x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$14x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$14x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$14x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$14x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$14x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$14x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$14x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$14x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$14x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$14x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$14x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$14x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$14x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires($ly, cs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires($ly, cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.Value (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mValues.__default.Value(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28079"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))));



axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Object($ly, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, $Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$1x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $Box($fh$1x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Array($ly, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, $Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$1x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $Box($fh$1x#0))): Seq);

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Number#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Number($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($fh$1x#0))): Seq);

implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Values.Value (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mValues.__default.Value(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var c#Z#0: int;
  var let#0#0#0: int;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var valueOrError0#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var ##cs#1: DatatypeType;
  var ##json#0: DatatypeType;
  var obj#Z#0: DatatypeType;
  var cs'#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var v#Z#0: DatatypeType;
  var let#3#0#0: DatatypeType;
  var sp#Z#0: DatatypeType;
  var let#4#0#0: DatatypeType;
  var ##cs0#1: DatatypeType;
  var ##spec#1: HandleType;
  var v##0_0: DatatypeType;
  var ##cs0#0_0: DatatypeType;
  var ##spec#0_0: HandleType;
  var v##0: DatatypeType;
  var ##cs0#2: DatatypeType;
  var ##spec#2: HandleType;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var valueOrError1#Z#0: DatatypeType;
  var let#5#0#0: DatatypeType;
  var ##cs#2: DatatypeType;
  var ##cs#3: DatatypeType;
  var ##json#1: DatatypeType;
  var arr#Z#0: DatatypeType;
  var cs'#Z#1: DatatypeType;
  var let#6#0#0: DatatypeType;
  var v#Z#1: DatatypeType;
  var let#7#0#0: DatatypeType;
  var sp#Z#1: DatatypeType;
  var let#8#0#0: DatatypeType;
  var ##cs0#3: DatatypeType;
  var ##spec#3: HandleType;
  var ##cs0#1_0: DatatypeType;
  var ##spec#1_0: HandleType;
  var v##1_0: DatatypeType;
  var ##cs0#4: DatatypeType;
  var ##spec#4: HandleType;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var valueOrError2#Z#0: DatatypeType;
  var let#9#0#0: DatatypeType;
  var ##cs#4: DatatypeType;
  var str#Z#0: DatatypeType;
  var cs'#Z#2: DatatypeType;
  var let#10#0#0: DatatypeType;
  var ##cs0#5: DatatypeType;
  var ##spec#5: HandleType;
  var ##cs0#2_0_0_0: DatatypeType;
  var ##spec#2_0_0_0: HandleType;
  var ##cs0#2_0_1_0: DatatypeType;
  var ##spec#2_0_1_0: HandleType;
  var ##other#2_0_1_0: DatatypeType;
  var ##cs0#2_0_1_1: DatatypeType;
  var ##spec#2_0_1_1: HandleType;
  var ##other#2_0_2_0: DatatypeType;
  var ##cs0#2_0_2_0: DatatypeType;
  var ##spec#2_0_2_0: HandleType;
  var ##other#2_0_2_1: DatatypeType;
  var ##self#2_0_2_0: DatatypeType;
  var ##other#2_0_3_0: DatatypeType;
  var ##self#2_0_3_0: DatatypeType;
  var ##other#2_0_3_1: DatatypeType;
  var ##self#2_0_3_1: DatatypeType;
  var ##other#2_0_4_0: DatatypeType;
  var ##self#2_0_4_0: DatatypeType;
  var ##other#2_0_4_1: DatatypeType;
  var ##cs0#2_0_4_0: DatatypeType;
  var ##spec#2_0_4_0: HandleType;
  var ##other#2_0_5_0: DatatypeType;
  var ##cs0#2_0_5_0: DatatypeType;
  var ##spec#2_0_5_0: HandleType;
  var ##cs0#2_0_5_1: DatatypeType;
  var ##spec#2_0_5_1: HandleType;
  var newtype$check#6: int;
  var newtype$check#7: int;
  var valueOrError3#Z#0: DatatypeType;
  var let#11#0#0: DatatypeType;
  var ##cs#5: DatatypeType;
  var ##expected#0: Seq;
  var cst#Z#0: DatatypeType;
  var cs'#Z#3: DatatypeType;
  var let#12#0#0: DatatypeType;
  var ##cs0#6: DatatypeType;
  var ##spec#6: HandleType;
  var f#3_0: HandleType where $Is(f#3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(f#3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#3_0: Heap;
  var _v0#3_0: DatatypeType;
  var $_Frame#l3_0: [ref,Field]bool;
  var lambdaResult#3_0: Seq;
  var ##cs0#3_0_0_0: DatatypeType;
  var ##spec#3_0_0_0: HandleType;
  var ##cs0#3_0_1_0: DatatypeType;
  var ##spec#3_0_1_0: HandleType;
  var ##other#3_0_1_0: DatatypeType;
  var ##cs0#3_0_1_1: DatatypeType;
  var ##spec#3_0_1_1: HandleType;
  var ##other#3_0_2_0: DatatypeType;
  var ##cs0#3_0_2_0: DatatypeType;
  var ##spec#3_0_2_0: HandleType;
  var ##other#3_0_2_1: DatatypeType;
  var ##other#3_0_2_2: DatatypeType;
  var ##other#3_0_2_3: DatatypeType;
  var ##cs0#3_0_2_1: DatatypeType;
  var ##spec#3_0_2_1: HandleType;
  var ##other#3_0_3_0: DatatypeType;
  var ##cs0#3_0_3_0: DatatypeType;
  var ##spec#3_0_3_0: HandleType;
  var ##other#3_0_3_1: DatatypeType;
  var ##other#3_0_4_0: DatatypeType;
  var ##other#3_0_4_1: DatatypeType;
  var ##other#3_0_5_0: DatatypeType;
  var ##other#3_0_5_1: DatatypeType;
  var ##other#3_0_6_0: DatatypeType;
  var ##other#3_0_6_1: DatatypeType;
  var ##v#3_0_6_0: DatatypeType;
  var ##other#3_0_7_0: DatatypeType;
  var ##v#3_0_7_0: DatatypeType;
  var ##other#3_0_7_1: DatatypeType;
  var ##self#3_0_7_0: DatatypeType;
  var ##other#3_0_8_0: DatatypeType;
  var ##self#3_0_8_0: DatatypeType;
  var ##other#3_0_8_1: DatatypeType;
  var ##cs0#3_0_8_0: DatatypeType;
  var ##spec#3_0_8_0: HandleType;
  var ##other#3_0_9_0: DatatypeType;
  var ##cs0#3_0_9_0: DatatypeType;
  var ##spec#3_0_9_0: HandleType;
  var ##cs0#3_0_9_1: DatatypeType;
  var ##spec#3_0_9_1: HandleType;
  var newtype$check#8: int;
  var newtype$check#9: int;
  var valueOrError4#Z#0: DatatypeType;
  var let#13#0#0: DatatypeType;
  var ##cs#6: DatatypeType;
  var ##expected#1: Seq;
  var cst#Z#1: DatatypeType;
  var cs'#Z#4: DatatypeType;
  var let#14#0#0: DatatypeType;
  var ##cs0#7: DatatypeType;
  var ##spec#7: HandleType;
  var f#4_0: HandleType where $Is(f#4_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(f#4_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#4_0: Heap;
  var _v1#4_0: DatatypeType;
  var $_Frame#l4_0: [ref,Field]bool;
  var lambdaResult#4_0: Seq;
  var ##cs0#4_0_0_0: DatatypeType;
  var ##spec#4_0_0_0: HandleType;
  var ##cs0#4_0_1_0: DatatypeType;
  var ##spec#4_0_1_0: HandleType;
  var ##other#4_0_1_0: DatatypeType;
  var ##cs0#4_0_1_1: DatatypeType;
  var ##spec#4_0_1_1: HandleType;
  var ##other#4_0_2_0: DatatypeType;
  var ##cs0#4_0_2_0: DatatypeType;
  var ##spec#4_0_2_0: HandleType;
  var ##other#4_0_2_1: DatatypeType;
  var ##other#4_0_2_2: DatatypeType;
  var ##other#4_0_2_3: DatatypeType;
  var ##cs0#4_0_2_1: DatatypeType;
  var ##spec#4_0_2_1: HandleType;
  var ##other#4_0_3_0: DatatypeType;
  var ##cs0#4_0_3_0: DatatypeType;
  var ##spec#4_0_3_0: HandleType;
  var ##other#4_0_3_1: DatatypeType;
  var ##other#4_0_4_0: DatatypeType;
  var ##other#4_0_4_1: DatatypeType;
  var ##other#4_0_5_0: DatatypeType;
  var ##other#4_0_5_1: DatatypeType;
  var ##other#4_0_6_0: DatatypeType;
  var ##other#4_0_6_1: DatatypeType;
  var ##v#4_0_6_0: DatatypeType;
  var ##other#4_0_7_0: DatatypeType;
  var ##v#4_0_7_0: DatatypeType;
  var ##other#4_0_7_1: DatatypeType;
  var ##self#4_0_7_0: DatatypeType;
  var ##other#4_0_8_0: DatatypeType;
  var ##self#4_0_8_0: DatatypeType;
  var ##other#4_0_8_1: DatatypeType;
  var ##cs0#4_0_8_0: DatatypeType;
  var ##spec#4_0_8_0: HandleType;
  var ##other#4_0_9_0: DatatypeType;
  var ##cs0#4_0_9_0: DatatypeType;
  var ##spec#4_0_9_0: HandleType;
  var ##cs0#4_0_9_1: DatatypeType;
  var ##spec#4_0_9_1: HandleType;
  var newtype$check#10: int;
  var newtype$check#11: int;
  var valueOrError5#Z#0: DatatypeType;
  var let#15#0#0: DatatypeType;
  var ##cs#7: DatatypeType;
  var ##expected#2: Seq;
  var cst#Z#2: DatatypeType;
  var cs'#Z#5: DatatypeType;
  var let#16#0#0: DatatypeType;
  var ##cs0#8: DatatypeType;
  var ##spec#8: HandleType;
  var f#5_0: HandleType where $Is(f#5_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(f#5_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
  var $lambdaHeap#5_0: Heap;
  var _v2#5_0: DatatypeType;
  var $_Frame#l5_0: [ref,Field]bool;
  var lambdaResult#5_0: Seq;
  var ##cs0#5_0_0_0: DatatypeType;
  var ##spec#5_0_0_0: HandleType;
  var ##cs0#5_0_1_0: DatatypeType;
  var ##spec#5_0_1_0: HandleType;
  var ##other#5_0_1_0: DatatypeType;
  var ##cs0#5_0_1_1: DatatypeType;
  var ##spec#5_0_1_1: HandleType;
  var ##other#5_0_2_0: DatatypeType;
  var ##cs0#5_0_2_0: DatatypeType;
  var ##spec#5_0_2_0: HandleType;
  var ##other#5_0_2_1: DatatypeType;
  var ##other#5_0_2_2: DatatypeType;
  var ##other#5_0_2_3: DatatypeType;
  var ##cs0#5_0_2_1: DatatypeType;
  var ##spec#5_0_2_1: HandleType;
  var ##other#5_0_3_0: DatatypeType;
  var ##cs0#5_0_3_0: DatatypeType;
  var ##spec#5_0_3_0: HandleType;
  var ##other#5_0_3_1: DatatypeType;
  var ##other#5_0_4_0: DatatypeType;
  var ##other#5_0_4_1: DatatypeType;
  var ##other#5_0_5_0: DatatypeType;
  var ##other#5_0_5_1: DatatypeType;
  var ##other#5_0_6_0: DatatypeType;
  var ##other#5_0_6_1: DatatypeType;
  var ##v#5_0_6_0: DatatypeType;
  var ##other#5_0_7_0: DatatypeType;
  var ##v#5_0_7_0: DatatypeType;
  var ##other#5_0_7_1: DatatypeType;
  var ##self#5_0_7_0: DatatypeType;
  var ##other#5_0_8_0: DatatypeType;
  var ##self#5_0_8_0: DatatypeType;
  var ##other#5_0_8_1: DatatypeType;
  var ##cs0#5_0_8_0: DatatypeType;
  var ##spec#5_0_8_0: HandleType;
  var ##other#5_0_9_0: DatatypeType;
  var ##cs0#5_0_9_0: DatatypeType;
  var ##spec#5_0_9_0: HandleType;
  var ##cs0#5_0_9_1: DatatypeType;
  var ##spec#5_0_9_1: HandleType;
  var valueOrError6#Z#0: DatatypeType;
  var let#17#0#0: DatatypeType;
  var ##cs#8: DatatypeType;
  var num#Z#0: DatatypeType;
  var cs'#Z#6: DatatypeType;
  var let#18#0#0: DatatypeType;
  var v#Z#2: DatatypeType;
  var let#19#0#0: DatatypeType;
  var sp#Z#2: DatatypeType;
  var let#20#0#0: DatatypeType;
  var ##cs0#9: DatatypeType;
  var ##spec#9: HandleType;
  var ##cs0#6_0: DatatypeType;
  var ##spec#6_0: HandleType;
  var v##6_0: DatatypeType;
  var ##cs0#10: DatatypeType;
  var ##spec#10: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Values.Value", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(517,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    goto anon222_Then, anon222_Else;

  anon222_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon223_Then, anon223_Else;

  anon223_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon5;

  anon223_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon5;

  anon5:
    assume false;
    return;

  anon222_Else:
    havoc c#Z#0;
    assume LitInt(-1) <= c#Z#0 && c#Z#0 < BoundedInts.__default.TWO__TO__THE__8();
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0);
    assume let#0#0#0 == JSON_mUtils_mCursors.Cursor__.Peek(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0);
    assume $Is(let#0#0#0, Tclass.BoundedInts.opt__byte());
    assume c#Z#0 == let#0#0#0;
    newtype$check#0 := char#ToInt(Lit(char#FromInt(123)));
    assume LitInt(-1) <= newtype$check#0 && newtype$check#0 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#1 := char#ToInt(Lit(char#FromInt(123)));
    assume LitInt(-1) <= newtype$check#1 && newtype$check#1 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon224_Then, anon224_Else;

  anon224_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(123)));
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.Length(cs#0) || JSON_mUtils_mCursors.Cursor__.Length(##cs#0) == JSON_mUtils_mCursors.Cursor__.Length(cs#0);
    assume 0 <= LitInt(1) || JSON_mUtils_mCursors.Cursor__.Length(##cs#0) < JSON_mUtils_mCursors.Cursor__.Length(cs#0) || LitInt(0) == LitInt(1);
    assume JSON_mUtils_mCursors.Cursor__.Length(##cs#0) < JSON_mUtils_mCursors.Cursor__.Length(cs#0) || (JSON_mUtils_mCursors.Cursor__.Length(##cs#0) == JSON_mUtils_mCursors.Cursor__.Length(cs#0) && LitInt(0) < LitInt(1));
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    ##cs#1 := cs#0;
    assume $IsAlloc(##cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#0 := JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0);
    assume $IsAlloc(##json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(##cs#1, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#1, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__#Equal(##cs#1, JSON_mUtils_mParsers.SubParser__.cs(##json#0)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#1, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#1, JSON_mUtils_mParsers.SubParser__.cs(##json#0));
    assume JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    assume let#1#0#0 == JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    assume $Is(let#1#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError0#Z#0 == let#1#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    goto anon225_Then, anon225_Else;

  anon225_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon225_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    havoc obj#Z#0;
    havoc cs'#Z#0;
    assume $Is(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $Is(cs'#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType);
    assume let#2#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#Z#0);
    assume $Is(let#2#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())));
    assume JSON_mUtils_mCursors.Split.SP_q(let#2#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0) == let#2#0#0;
    havoc v#Z#0;
    assume $Is(v#Z#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#Z#0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume let#3#0#0 == #JSON.Grammar.Value.Object(obj#Z#0);
    assume true;
    assume $Is(let#3#0#0, Tclass.JSON_mGrammar.Value());
    assume v#Z#0 == let#3#0#0;
    havoc sp#Z#0;
    assume $Is(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(sp#Z#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume let#4#0#0 == #JSON.Utils.Cursors.Split.SP($Box(v#Z#0), cs'#Z#0);
    assume true;
    assume $Is(let#4#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()));
    assume sp#Z#0 == let#4#0#0;
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#1 := cs#0;
    assume $IsAlloc(##cs0#1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon226_Then, anon226_Else;

  anon226_Then:
    assume true;
    v##0_0 := v#Z#0;
    call CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v##0_0);
    call CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v##0_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(527,35)"} true;
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), $Heap);
    assume true;
    ##cs0#0_0 := cs#0;
    assume $IsAlloc(##cs0#0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0_0 := JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ));
    assume $IsAlloc(##spec#0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0))))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), #JSON.Utils.Cursors.Split.SP($Box(obj#Z#0), cs'#Z#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(528,65)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume false;
    goto anon11;

  anon226_Else:
    goto anon11;

  anon11:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(529,8)"} true;
    assume true;
    v##0 := v#Z#0;
    call CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v##0);
    call CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v##0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(530,32)"} true;
    assume $IsAllocBox($Box(sp#Z#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#2 := cs#0;
    assume $IsAlloc(##cs0#2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#2, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#0)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#0), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#0)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#0)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#0)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(531,52)"} true;
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(sp#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon224_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(123)));
    newtype$check#2 := char#ToInt(Lit(char#FromInt(91)));
    assume LitInt(-1) <= newtype$check#2 && newtype$check#2 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#3 := char#ToInt(Lit(char#FromInt(91)));
    assume LitInt(-1) <= newtype$check#3 && newtype$check#3 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon227_Then, anon227_Else;

  anon227_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(91)));
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#2 := cs#0;
    assume $IsAlloc(##cs#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.Length(cs#0) || JSON_mUtils_mCursors.Cursor__.Length(##cs#2) == JSON_mUtils_mCursors.Cursor__.Length(cs#0);
    assume 0 <= LitInt(1) || JSON_mUtils_mCursors.Cursor__.Length(##cs#2) < JSON_mUtils_mCursors.Cursor__.Length(cs#0) || LitInt(0) == LitInt(1);
    assume JSON_mUtils_mCursors.Cursor__.Length(##cs#2) < JSON_mUtils_mCursors.Cursor__.Length(cs#0) || (JSON_mUtils_mCursors.Cursor__.Length(##cs#2) == JSON_mUtils_mCursors.Cursor__.Length(cs#0) && LitInt(0) < LitInt(1));
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    ##cs#3 := cs#0;
    assume $IsAlloc(##cs#3, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##json#1 := JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0);
    assume $IsAlloc(##json#1, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(##cs#3, JSON_mUtils_mParsers.SubParser__.cs(##json#1)) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#3, JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__#Equal(##cs#3, JSON_mUtils_mParsers.SubParser__.cs(##json#1)) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(##cs#3, JSON_mUtils_mParsers.SubParser__.cs(##json#1));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(##cs#3, JSON_mUtils_mParsers.SubParser__.cs(##json#1));
    assume JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    assume let#5#0#0 == JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0));
    assume $Is(let#5#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError1#Z#0 == let#5#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    goto anon228_Then, anon228_Else;

  anon228_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon228_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    havoc arr#Z#0;
    havoc cs'#Z#1;
    assume $Is(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#Z#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $Is(cs'#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Success_q(valueOrError1#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType);
    assume let#6#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#Z#0);
    assume $Is(let#6#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())));
    assume JSON_mUtils_mCursors.Split.SP_q(let#6#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1) == let#6#0#0;
    havoc v#Z#1;
    assume $Is(v#Z#1, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#Z#1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume let#7#0#0 == #JSON.Grammar.Value.Array(arr#Z#0);
    assume true;
    assume $Is(let#7#0#0, Tclass.JSON_mGrammar.Value());
    assume v#Z#1 == let#7#0#0;
    havoc sp#Z#1;
    assume $Is(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(sp#Z#1, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume let#8#0#0 == #JSON.Utils.Cursors.Split.SP($Box(v#Z#1), cs'#Z#1);
    assume true;
    assume $Is(let#8#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()));
    assume sp#Z#1 == let#8#0#0;
    assume $IsAllocBox($Box(sp#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#3 := cs#0;
    assume $IsAlloc(##cs0#3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#3, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon229_Then, anon229_Else;

  anon229_Then:
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), $Heap);
    assume true;
    ##cs0#1_0 := cs#0;
    assume $IsAlloc(##cs0#1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#1_0 := JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ));
    assume $IsAlloc(##spec#1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1))))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), #JSON.Utils.Cursors.Split.SP($Box(arr#Z#0), cs'#Z#1), cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(538,64)"} true;
    assume true;
    v##1_0 := v#Z#1;
    call CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v##1_0);
    call CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v##1_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(539,34)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#1)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#1)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#1)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#1)))));
    assume false;
    goto anon17;

  anon229_Else:
    goto anon17;

  anon17:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(540,8)"} true;
    assume $IsAllocBox($Box(sp#Z#1), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#4 := cs#0;
    assume $IsAlloc(##cs0#4, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#4, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#1)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#1)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#1), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#1)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#1)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#1)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#1, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(541,52)"} true;
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(sp#Z#1));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon227_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(91)));
    newtype$check#4 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#4 && newtype$check#4 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#5 := char#ToInt(Lit(char#FromInt(34)));
    assume LitInt(-1) <= newtype$check#5 && newtype$check#5 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon230_Then, anon230_Else;

  anon230_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(34)));
    havoc valueOrError2#Z#0;
    assume $Is(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError2#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#4 := cs#0;
    assume $IsAlloc(##cs#4, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0);
    assume let#9#0#0 == JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0);
    assume $Is(let#9#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError2#Z#0 == let#9#0#0;
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    goto anon231_Then, anon231_Else;

  anon231_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon231_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    havoc str#Z#0;
    havoc cs'#Z#2;
    assume $Is(str#Z#0, Tclass.JSON_mGrammar.jstring()) && $IsAlloc(str#Z#0, Tclass.JSON_mGrammar.jstring(), $Heap) && $Is(cs'#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#2, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError2#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Success_q(valueOrError2#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType);
    assume let#10#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#Z#0);
    assume $Is(let#10#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#10#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2) == let#10#0#0;
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#5 := cs#0;
    assume $IsAlloc(##cs0#5, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#5, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon232_Then, anon232_Else;

  anon232_Then:
    goto anon233_Then, anon233_Else;

  anon233_Then:
    assume true;
    assume false;
    goto anon46;

  anon233_Else:
    goto anon234_Then, anon234_Else;

  anon234_Then:
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_5_0 := cs#0;
    assume $IsAlloc(##other#2_0_5_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon235_Then, anon235_Else;

  anon235_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#2_0_5_0 := cs#0;
    assume $IsAlloc(##cs0#2_0_5_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_5_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#2_0_5_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon26;

  anon235_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon26;

  anon26:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#2_0_5_1 := cs#0;
    assume $IsAlloc(##cs0#2_0_5_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_5_1 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#2_0_5_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))))));
    assume false;
    goto anon46;

  anon234_Else:
    goto anon236_Then, anon236_Else;

  anon236_Then:
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_4_0 := cs#0;
    assume $IsAlloc(##other#2_0_4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon237_Then, anon237_Else;

  anon237_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##self#2_0_4_0 := #JSON.Grammar.Value.String(str#Z#0);
    assume $IsAlloc(##self#2_0_4_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.String(str#Z#0));
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2);
    goto anon29;

  anon237_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon29;

  anon29:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.String(str#Z#0)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2)));
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_4_1 := cs#0;
    assume $IsAlloc(##other#2_0_4_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon238_Then, anon238_Else;

  anon238_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#2_0_4_0 := cs#0;
    assume $IsAlloc(##cs0#2_0_4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_4_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#2_0_4_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon31;

  anon238_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon31;

  anon31:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#2);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#2), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#2) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#2) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)))));
    assume false;
    goto anon46;

  anon236_Else:
    goto anon239_Then, anon239_Else;

  anon239_Then:
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_3_0 := cs#0;
    assume $IsAlloc(##other#2_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon240_Then, anon240_Else;

  anon240_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##self#2_0_3_0 := str#Z#0;
    assume $IsAlloc(##self#2_0_3_0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#Z#0);
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2);
    goto anon34;

  anon240_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon34;

  anon34:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2)));
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_3_1 := cs#0;
    assume $IsAlloc(##other#2_0_3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon241_Then, anon241_Else;

  anon241_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##self#2_0_3_1 := #JSON.Grammar.Value.String(str#Z#0);
    assume $IsAlloc(##self#2_0_3_1, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.String(str#Z#0));
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2);
    goto anon36;

  anon241_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon36;

  anon36:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.String(str#Z#0)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#2);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#2), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#2) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#2) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), #JSON.Grammar.Value.String(str#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2)));
    assume false;
    goto anon46;

  anon239_Else:
    goto anon242_Then, anon242_Else;

  anon242_Then:
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_2_0 := cs#0;
    assume $IsAlloc(##other#2_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon243_Then, anon243_Else;

  anon243_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#2_0_2_0 := cs#0;
    assume $IsAlloc(##cs0#2_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_2_0 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#2_0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    goto anon39;

  anon243_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon39;

  anon39:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_2_1 := cs#0;
    assume $IsAlloc(##other#2_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon244_Then, anon244_Else;

  anon244_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##self#2_0_2_0 := str#Z#0;
    assume $IsAlloc(##self#2_0_2_0, Tclass.JSON_mGrammar.jstring(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#Z#0);
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2);
    goto anon41;

  anon244_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon41;

  anon41:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#2));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#2);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#2), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#2) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#2) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.String(str#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#2)));
    assume false;
    goto anon46;

  anon242_Else:
    goto anon245_Then, anon245_Else;

  anon245_Then:
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#2_0_1_0 := cs#0;
    assume $IsAlloc(##cs0#2_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_1_0 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#2_0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume $IsAllocBox($Box(cs'#Z#2), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#2_0_1_0 := cs#0;
    assume $IsAlloc(##other#2_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#2);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0);
    goto anon246_Then, anon246_Else;

  anon246_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#2_0_1_1 := cs#0;
    assume $IsAlloc(##cs0#2_0_1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_1_1 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#2_0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    goto anon44;

  anon246_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0);
    goto anon44;

  anon44:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#2);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#2), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#2) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#2, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#2, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#2, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#2) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)))));
    assume false;
    goto anon46;

  anon245_Else:
    goto anon247_Then, anon247_Else;

  anon247_Then:
    assume true;
    assume true;
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap);
    assume true;
    ##cs0#2_0_0_0 := cs#0;
    assume $IsAlloc(##cs0#2_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#2_0_0_0 := JSON_mConcreteSyntax_mSpec.__default.String#Handle();
    assume $IsAlloc(##spec#2_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle());
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jstring(), #JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(str#Z#0), cs'#Z#2))))));
    assume false;
    goto anon46;

  anon247_Else:
    goto anon46;

  anon46:
    assume true ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2))))));
    assume false;
    goto anon47;

  anon232_Else:
    goto anon47;

  anon47:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(555,8)"} true;
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#Z#0)), cs'#Z#2)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon230_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(34)));
    newtype$check#6 := char#ToInt(Lit(char#FromInt(116)));
    assume LitInt(-1) <= newtype$check#6 && newtype$check#6 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#7 := char#ToInt(Lit(char#FromInt(116)));
    assume LitInt(-1) <= newtype$check#7 && newtype$check#7 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon248_Then, anon248_Else;

  anon248_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(116)));
    havoc valueOrError3#Z#0;
    assume $Is(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError3#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#5 := cs#0;
    assume $IsAlloc(##cs#5, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##expected#0 := JSON_mGrammar.__default.TRUE();
    assume $IsAlloc(##expected#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##expected#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##expected#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE());
    assume let#11#0#0 == JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE());
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE());
    assume $Is(let#11#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError3#Z#0 == let#11#0#0;
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0);
    goto anon249_Then, anon249_Else;

  anon249_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon249_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0);
    havoc cst#Z#0;
    havoc cs'#Z#3;
    assume $Is(cst#Z#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(cst#Z#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs'#Z#3, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#3, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError3#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Success_q(valueOrError3#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0)): DatatypeType);
    assume let#12#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#Z#0);
    assume $Is(let#12#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#12#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(cst#Z#0), cs'#Z#3) == let#12#0#0;
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#6 := cs#0;
    assume $IsAlloc(##cs0#6, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#6 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#6, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon250_Then, anon250_Else;

  anon250_Then:
    assume true;
    goto anon251_Then, anon251_Else;

  anon251_Then:
    havoc $lambdaHeap#3_0;
    assume $IsGoodHeap($lambdaHeap#3_0);
    assume $Heap == $lambdaHeap#3_0 || $HeapSucc($Heap, $lambdaHeap#3_0);
    havoc _v0#3_0;
    goto anon252_Then, anon252_Else;

  anon252_Then:
    assume {:partition} $Is(_v0#3_0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(_v0#3_0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#3_0);
    $_Frame#l3_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#3_0, $o, alloc)): bool ==> false);
    assume lambdaResult#3_0 == JSON_mGrammar.__default.TRUE();
    assume true;
    assume $Is(lambdaResult#3_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon55;

  anon252_Else:
    assume {:partition} !($Is(_v0#3_0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(_v0#3_0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#3_0));
    goto anon55;

  anon55:
    assume false;
    goto anon56;

  anon251_Else:
    goto anon56;

  anon56:
    assume true;
    f#3_0 := Lit(AtLayer((lambda $l#3_1#ly#0: LayerType :: Handle1((lambda $l#3_1#heap#0: Heap, $l#3_1#_v0#0: Box :: $Box(JSON_mGrammar.__default.TRUE())), (lambda $l#3_1#heap#0: Heap, $l#3_1#_v0#0: Box :: $IsBox($l#3_1#_v0#0, Tclass.JSON_mGrammar.Value())), (lambda $l#3_1#heap#0: Heap, $l#3_1#_v0#0: Box :: SetRef_to_SetBox((lambda $l#3_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(560,28)"} true;
    goto anon253_Then, anon253_Else;

  anon253_Then:
    assume true;
    assume false;
    goto anon102;

  anon253_Else:
    goto anon254_Then, anon254_Else;

  anon254_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_9_0 := cs#0;
    assume $IsAlloc(##other#3_0_9_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon255_Then, anon255_Else;

  anon255_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#3_0_9_0 := cs#0;
    assume $IsAlloc(##cs0#3_0_9_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_9_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#3_0_9_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon60;

  anon255_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon60;

  anon60:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#3_0_9_1 := cs#0;
    assume $IsAlloc(##cs0#3_0_9_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_9_1 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#3_0_9_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))))));
    assume false;
    goto anon102;

  anon254_Else:
    goto anon256_Then, anon256_Else;

  anon256_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_8_0 := cs#0;
    assume $IsAlloc(##other#3_0_8_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon257_Then, anon257_Else;

  anon257_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    ##self#3_0_8_0 := #JSON.Grammar.Value.Bool(cst#Z#0);
    assume $IsAlloc(##self#3_0_8_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#0));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon63;

  anon257_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon63;

  anon63:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#0)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_8_1 := cs#0;
    assume $IsAlloc(##other#3_0_8_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon258_Then, anon258_Else;

  anon258_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#3_0_8_0 := cs#0;
    assume $IsAlloc(##cs0#3_0_8_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_8_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#3_0_8_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon65;

  anon258_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon65;

  anon65:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)))));
    assume false;
    goto anon102;

  anon256_Else:
    goto anon259_Then, anon259_Else;

  anon259_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_7_0 := cs#0;
    assume $IsAlloc(##other#3_0_7_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon260_Then, anon260_Else;

  anon260_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##v#3_0_7_0 := cst#Z#0;
    assume $IsAlloc(##v#3_0_7_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon68;

  anon260_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon68;

  anon68:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_7_1 := cs#0;
    assume $IsAlloc(##other#3_0_7_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon261_Then, anon261_Else;

  anon261_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    ##self#3_0_7_0 := #JSON.Grammar.Value.Bool(cst#Z#0);
    assume $IsAlloc(##self#3_0_7_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#0));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon70;

  anon261_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon70;

  anon70:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#0)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), #JSON.Grammar.Value.Bool(cst#Z#0)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume false;
    goto anon102;

  anon259_Else:
    goto anon262_Then, anon262_Else;

  anon262_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_6_0 := cs#0;
    assume $IsAlloc(##other#3_0_6_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon263_Then, anon263_Else;

  anon263_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cst#Z#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(cst#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon73;

  anon263_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon73;

  anon73:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_6_1 := cs#0;
    assume $IsAlloc(##other#3_0_6_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon264_Then, anon264_Else;

  anon264_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##v#3_0_6_0 := cst#Z#0;
    assume $IsAlloc(##v#3_0_6_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon75;

  anon264_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon75;

  anon75:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume false;
    goto anon102;

  anon262_Else:
    goto anon265_Then, anon265_Else;

  anon265_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_5_0 := cs#0;
    assume $IsAlloc(##other#3_0_5_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon266_Then, anon266_Else;

  anon266_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon78;

  anon266_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon78;

  anon78:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_5_1 := cs#0;
    assume $IsAlloc(##other#3_0_5_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon267_Then, anon267_Else;

  anon267_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cst#Z#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(cst#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon80;

  anon267_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon80;

  anon80:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume false;
    goto anon102;

  anon265_Else:
    goto anon268_Then, anon268_Else;

  anon268_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_4_0 := cs#0;
    assume $IsAlloc(##other#3_0_4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon269_Then, anon269_Else;

  anon269_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon83;

  anon269_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon83;

  anon83:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_4_1 := cs#0;
    assume $IsAlloc(##other#3_0_4_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon270_Then, anon270_Else;

  anon270_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon85;

  anon270_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon85;

  anon85:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.TRUE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume false;
    goto anon102;

  anon268_Else:
    goto anon271_Then, anon271_Else;

  anon271_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_3_0 := cs#0;
    assume $IsAlloc(##other#3_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon272_Then, anon272_Else;

  anon272_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#3_0_3_0 := cs#0;
    assume $IsAlloc(##cs0#3_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_3_0 := f#3_0;
    assume $IsAlloc(##spec#3_0_3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    goto anon88;

  anon272_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon88;

  anon88:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_3_1 := cs#0;
    assume $IsAlloc(##other#3_0_3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon273_Then, anon273_Else;

  anon273_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3);
    goto anon90;

  anon273_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon90;

  anon90:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#3));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#0)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#3)));
    assume false;
    goto anon102;

  anon271_Else:
    goto anon274_Then, anon274_Else;

  anon274_Then:
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_2_0 := cs#0;
    assume $IsAlloc(##other#3_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon275_Then, anon275_Else;

  anon275_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#3_0_2_0 := cs#0;
    assume $IsAlloc(##cs0#3_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_2_0 := f#3_0;
    assume $IsAlloc(##spec#3_0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    goto anon93;

  anon275_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0);
    goto anon93;

  anon93:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_2_1 := cs#0;
    assume $IsAlloc(##other#3_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_2_2 := cs#0;
    assume $IsAlloc(##other#3_0_2_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon276_Then, anon276_Else;

  anon276_Then:
    assume $IsA#JSON_mUtils_mCursors.Cursor__(cs'#Z#3) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0);
    assume !JSON_mUtils_mCursors.Cursor__#Equal(cs'#Z#3, cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(570,93)"} true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0);
    assume false;
    goto anon95;

  anon276_Else:
    goto anon95;

  anon95:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(570,95)"} true;
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_2_3 := cs#0;
    assume $IsAlloc(##other#3_0_2_3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon277_Then, anon277_Else;

  anon277_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#3_0_2_1 := cs#0;
    assume $IsAlloc(##cs0#3_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_2_1 := f#3_0;
    assume $IsAlloc(##spec#3_0_2_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    goto anon97;

  anon277_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    goto anon97;

  anon97:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#3);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#3), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#3) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#3) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)))));
    assume false;
    goto anon102;

  anon274_Else:
    goto anon278_Then, anon278_Else;

  anon278_Then:
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#3_0_1_0 := cs#0;
    assume $IsAlloc(##cs0#3_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_1_0 := f#3_0;
    assume $IsAlloc(##spec#3_0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume $IsAllocBox($Box(cs'#Z#3), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#3_0_1_0 := cs#0;
    assume $IsAlloc(##other#3_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#3);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0);
    goto anon279_Then, anon279_Else;

  anon279_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0);
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#3_0_1_1 := cs#0;
    assume $IsAlloc(##cs0#3_0_1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_1_1 := f#3_0;
    assume $IsAlloc(##spec#3_0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    goto anon100;

  anon279_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0);
    goto anon100;

  anon100:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#3, cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(cs'#Z#3, cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#3, cs#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)))));
    assume false;
    goto anon102;

  anon278_Else:
    goto anon280_Then, anon280_Else;

  anon280_Then:
    assume true;
    assume true;
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#3_0_0_0 := cs#0;
    assume $IsAlloc(##cs0#3_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#3_0_0_0 := f#3_0;
    assume $IsAlloc(##spec#3_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0);
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, f#3_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#3_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))))));
    assume false;
    goto anon102;

  anon280_Else:
    goto anon102;

  anon102:
    assume true ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3))))));
    assume false;
    goto anon103;

  anon250_Else:
    goto anon103;

  anon103:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(575,8)"} true;
    assume $Is(cst#Z#0, Tclass.JSON_mGrammar.jbool());
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#0)), cs'#Z#3)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon248_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(116)));
    newtype$check#8 := char#ToInt(Lit(char#FromInt(102)));
    assume LitInt(-1) <= newtype$check#8 && newtype$check#8 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#9 := char#ToInt(Lit(char#FromInt(102)));
    assume LitInt(-1) <= newtype$check#9 && newtype$check#9 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon281_Then, anon281_Else;

  anon281_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(102)));
    havoc valueOrError4#Z#0;
    assume $Is(valueOrError4#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError4#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#6 := cs#0;
    assume $IsAlloc(##cs#6, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##expected#1 := JSON_mGrammar.__default.FALSE();
    assume $IsAlloc(##expected#1, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##expected#1) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##expected#1) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE());
    assume let#13#0#0 == JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE());
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE());
    assume $Is(let#13#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError4#Z#0 == let#13#0#0;
    assume $IsAllocBox($Box(valueOrError4#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0);
    goto anon282_Then, anon282_Else;

  anon282_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0);
    assume $IsAllocBox($Box(valueOrError4#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError4#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError4#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon282_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0);
    havoc cst#Z#1;
    havoc cs'#Z#4;
    assume $Is(cst#Z#1, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(cst#Z#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs'#Z#4, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#4, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError4#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError4#Z#0);
    assume Wrappers.Result.Success_q(valueOrError4#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0)): DatatypeType);
    assume let#14#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#Z#0);
    assume $Is(let#14#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#14#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(cst#Z#1), cs'#Z#4) == let#14#0#0;
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#7 := cs#0;
    assume $IsAlloc(##cs0#7, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#7 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#7, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon283_Then, anon283_Else;

  anon283_Then:
    assume true;
    goto anon284_Then, anon284_Else;

  anon284_Then:
    havoc $lambdaHeap#4_0;
    assume $IsGoodHeap($lambdaHeap#4_0);
    assume $Heap == $lambdaHeap#4_0 || $HeapSucc($Heap, $lambdaHeap#4_0);
    havoc _v1#4_0;
    goto anon285_Then, anon285_Else;

  anon285_Then:
    assume {:partition} $Is(_v1#4_0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(_v1#4_0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#4_0);
    $_Frame#l4_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#4_0, $o, alloc)): bool ==> false);
    assume lambdaResult#4_0 == JSON_mGrammar.__default.FALSE();
    assume true;
    assume $Is(lambdaResult#4_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon111;

  anon285_Else:
    assume {:partition} !($Is(_v1#4_0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(_v1#4_0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#4_0));
    goto anon111;

  anon111:
    assume false;
    goto anon112;

  anon284_Else:
    goto anon112;

  anon112:
    assume true;
    f#4_0 := Lit(AtLayer((lambda $l#4_1#ly#0: LayerType :: Handle1((lambda $l#4_1#heap#0: Heap, $l#4_1#_v1#0: Box :: $Box(JSON_mGrammar.__default.FALSE())), (lambda $l#4_1#heap#0: Heap, $l#4_1#_v1#0: Box :: $IsBox($l#4_1#_v1#0, Tclass.JSON_mGrammar.Value())), (lambda $l#4_1#heap#0: Heap, $l#4_1#_v1#0: Box :: SetRef_to_SetBox((lambda $l#4_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(580,29)"} true;
    goto anon286_Then, anon286_Else;

  anon286_Then:
    assume true;
    assume false;
    goto anon158;

  anon286_Else:
    goto anon287_Then, anon287_Else;

  anon287_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_9_0 := cs#0;
    assume $IsAlloc(##other#4_0_9_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon288_Then, anon288_Else;

  anon288_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#4_0_9_0 := cs#0;
    assume $IsAlloc(##cs0#4_0_9_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_9_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#4_0_9_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon116;

  anon288_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon116;

  anon116:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#4_0_9_1 := cs#0;
    assume $IsAlloc(##cs0#4_0_9_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_9_1 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#4_0_9_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))))));
    assume false;
    goto anon158;

  anon287_Else:
    goto anon289_Then, anon289_Else;

  anon289_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_8_0 := cs#0;
    assume $IsAlloc(##other#4_0_8_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon290_Then, anon290_Else;

  anon290_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    ##self#4_0_8_0 := #JSON.Grammar.Value.Bool(cst#Z#1);
    assume $IsAlloc(##self#4_0_8_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#1));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon119;

  anon290_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon119;

  anon119:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#1)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_8_1 := cs#0;
    assume $IsAlloc(##other#4_0_8_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon291_Then, anon291_Else;

  anon291_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#4_0_8_0 := cs#0;
    assume $IsAlloc(##cs0#4_0_8_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_8_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#4_0_8_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon121;

  anon291_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon121;

  anon121:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)))));
    assume false;
    goto anon158;

  anon289_Else:
    goto anon292_Then, anon292_Else;

  anon292_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_7_0 := cs#0;
    assume $IsAlloc(##other#4_0_7_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon293_Then, anon293_Else;

  anon293_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##v#4_0_7_0 := cst#Z#1;
    assume $IsAlloc(##v#4_0_7_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#1);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon124;

  anon293_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon124;

  anon124:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#1) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_7_1 := cs#0;
    assume $IsAlloc(##other#4_0_7_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon294_Then, anon294_Else;

  anon294_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    ##self#4_0_7_0 := #JSON.Grammar.Value.Bool(cst#Z#1);
    assume $IsAlloc(##self#4_0_7_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#1));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon126;

  anon294_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon126;

  anon126:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Bool(cst#Z#1)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), #JSON.Grammar.Value.Bool(cst#Z#1)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume false;
    goto anon158;

  anon292_Else:
    goto anon295_Then, anon295_Else;

  anon295_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_6_0 := cs#0;
    assume $IsAlloc(##other#4_0_6_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon296_Then, anon296_Else;

  anon296_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cst#Z#1), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(cst#Z#1);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#1);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon129;

  anon296_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon129;

  anon129:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#1) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_6_1 := cs#0;
    assume $IsAlloc(##other#4_0_6_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon297_Then, anon297_Else;

  anon297_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##v#4_0_6_0 := cst#Z#1;
    assume $IsAlloc(##v#4_0_6_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#1);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon131;

  anon297_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon131;

  anon131:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#1) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume false;
    goto anon158;

  anon295_Else:
    goto anon298_Then, anon298_Else;

  anon298_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_5_0 := cs#0;
    assume $IsAlloc(##other#4_0_5_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon299_Then, anon299_Else;

  anon299_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon134;

  anon299_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon134;

  anon134:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_5_1 := cs#0;
    assume $IsAlloc(##other#4_0_5_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon300_Then, anon300_Else;

  anon300_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cst#Z#1), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(cst#Z#1);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#1);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon136;

  anon300_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon136;

  anon136:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#1) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#1), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume false;
    goto anon158;

  anon298_Else:
    goto anon301_Then, anon301_Else;

  anon301_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_4_0 := cs#0;
    assume $IsAlloc(##other#4_0_4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon302_Then, anon302_Else;

  anon302_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon139;

  anon302_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon139;

  anon139:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_4_1 := cs#0;
    assume $IsAlloc(##other#4_0_4_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon303_Then, anon303_Else;

  anon303_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon141;

  anon303_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon141;

  anon141:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.FALSE(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume false;
    goto anon158;

  anon301_Else:
    goto anon304_Then, anon304_Else;

  anon304_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_3_0 := cs#0;
    assume $IsAlloc(##other#4_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon305_Then, anon305_Else;

  anon305_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#4_0_3_0 := cs#0;
    assume $IsAlloc(##cs0#4_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_3_0 := f#4_0;
    assume $IsAlloc(##spec#4_0_3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    goto anon144;

  anon305_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon144;

  anon144:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_3_1 := cs#0;
    assume $IsAlloc(##other#4_0_3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon306_Then, anon306_Else;

  anon306_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4);
    goto anon146;

  anon306_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon146;

  anon146:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#4));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box(#JSON.Grammar.Value.Bool(cst#Z#1)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#4)));
    assume false;
    goto anon158;

  anon304_Else:
    goto anon307_Then, anon307_Else;

  anon307_Then:
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_2_0 := cs#0;
    assume $IsAlloc(##other#4_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon308_Then, anon308_Else;

  anon308_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#4_0_2_0 := cs#0;
    assume $IsAlloc(##cs0#4_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_2_0 := f#4_0;
    assume $IsAlloc(##spec#4_0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    goto anon149;

  anon308_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0);
    goto anon149;

  anon149:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_2_1 := cs#0;
    assume $IsAlloc(##other#4_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_2_2 := cs#0;
    assume $IsAlloc(##other#4_0_2_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon309_Then, anon309_Else;

  anon309_Then:
    assume $IsA#JSON_mUtils_mCursors.Cursor__(cs'#Z#4) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0);
    assume !JSON_mUtils_mCursors.Cursor__#Equal(cs'#Z#4, cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(590,93)"} true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0);
    assume false;
    goto anon151;

  anon309_Else:
    goto anon151;

  anon151:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(590,95)"} true;
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_2_3 := cs#0;
    assume $IsAlloc(##other#4_0_2_3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon310_Then, anon310_Else;

  anon310_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#4_0_2_1 := cs#0;
    assume $IsAlloc(##cs0#4_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_2_1 := f#4_0;
    assume $IsAlloc(##spec#4_0_2_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    goto anon153;

  anon310_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    goto anon153;

  anon153:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#4);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#4), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#4) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#4) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)))));
    assume false;
    goto anon158;

  anon307_Else:
    goto anon311_Then, anon311_Else;

  anon311_Then:
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#4_0_1_0 := cs#0;
    assume $IsAlloc(##cs0#4_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_1_0 := f#4_0;
    assume $IsAlloc(##spec#4_0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume $IsAllocBox($Box(cs'#Z#4), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#4_0_1_0 := cs#0;
    assume $IsAlloc(##other#4_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#4);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0);
    goto anon312_Then, anon312_Else;

  anon312_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0);
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#4_0_1_1 := cs#0;
    assume $IsAlloc(##cs0#4_0_1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_1_1 := f#4_0;
    assume $IsAlloc(##spec#4_0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    goto anon156;

  anon312_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0);
    goto anon156;

  anon156:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#4, cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(cs'#Z#4, cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#4, cs#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)))));
    assume false;
    goto anon158;

  anon311_Else:
    goto anon313_Then, anon313_Else;

  anon313_Then:
    assume true;
    assume true;
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#4_0_0_0 := cs#0;
    assume $IsAlloc(##cs0#4_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#4_0_0_0 := f#4_0;
    assume $IsAlloc(##spec#4_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0);
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, f#4_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#4_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))))));
    assume false;
    goto anon158;

  anon313_Else:
    goto anon158;

  anon158:
    assume true ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4))))));
    assume false;
    goto anon159;

  anon283_Else:
    goto anon159;

  anon159:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(595,8)"} true;
    assume $Is(cst#Z#1, Tclass.JSON_mGrammar.jbool());
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#Z#1)), cs'#Z#4)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon281_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(102)));
    newtype$check#10 := char#ToInt(Lit(char#FromInt(110)));
    assume LitInt(-1) <= newtype$check#10 && newtype$check#10 < BoundedInts.__default.TWO__TO__THE__8();
    newtype$check#11 := char#ToInt(Lit(char#FromInt(110)));
    assume LitInt(-1) <= newtype$check#11 && newtype$check#11 < BoundedInts.__default.TWO__TO__THE__8();
    goto anon314_Then, anon314_Else;

  anon314_Then:
    assume {:partition} c#Z#0 == char#ToInt(Lit(char#FromInt(110)));
    havoc valueOrError5#Z#0;
    assume $Is(valueOrError5#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError5#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#7 := cs#0;
    assume $IsAlloc(##cs#7, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    ##expected#2 := JSON_mGrammar.__default.NULL();
    assume $IsAlloc(##expected#2, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##expected#2) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##expected#2) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL());
    assume let#15#0#0 == JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL());
    assume JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL());
    assume $Is(let#15#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError5#Z#0 == let#15#0#0;
    assume $IsAllocBox($Box(valueOrError5#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0);
    goto anon315_Then, anon315_Else;

  anon315_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0);
    assume $IsAllocBox($Box(valueOrError5#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError5#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError5#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon315_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0);
    havoc cst#Z#2;
    havoc cs'#Z#5;
    assume $Is(cst#Z#2, Tclass.JSON_mUtils_mViews_mCore.View()) && $IsAlloc(cst#Z#2, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap) && $Is(cs'#Z#5, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#5, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError5#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError5#Z#0);
    assume Wrappers.Result.Success_q(valueOrError5#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0)): DatatypeType);
    assume let#16#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#Z#0);
    assume $Is(let#16#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#16#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(cst#Z#2), cs'#Z#5) == let#16#0#0;
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#8 := cs#0;
    assume $IsAlloc(##cs0#8, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#8 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#8, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon316_Then, anon316_Else;

  anon316_Then:
    assume true;
    goto anon317_Then, anon317_Else;

  anon317_Then:
    havoc $lambdaHeap#5_0;
    assume $IsGoodHeap($lambdaHeap#5_0);
    assume $Heap == $lambdaHeap#5_0 || $HeapSucc($Heap, $lambdaHeap#5_0);
    havoc _v2#5_0;
    goto anon318_Then, anon318_Else;

  anon318_Then:
    assume {:partition} $Is(_v2#5_0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(_v2#5_0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#5_0);
    $_Frame#l5_0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#5_0, $o, alloc)): bool ==> false);
    assume lambdaResult#5_0 == JSON_mGrammar.__default.NULL();
    assume true;
    assume $Is(lambdaResult#5_0, TSeq(Tclass.BoundedInts.uint8()));
    goto anon167;

  anon318_Else:
    assume {:partition} !($Is(_v2#5_0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(_v2#5_0, Tclass.JSON_mGrammar.Value(), $lambdaHeap#5_0));
    goto anon167;

  anon167:
    assume false;
    goto anon168;

  anon317_Else:
    goto anon168;

  anon168:
    assume true;
    f#5_0 := Lit(AtLayer((lambda $l#5_1#ly#0: LayerType :: Handle1((lambda $l#5_1#heap#0: Heap, $l#5_1#_v2#0: Box :: $Box(JSON_mGrammar.__default.NULL())), (lambda $l#5_1#heap#0: Heap, $l#5_1#_v2#0: Box :: $IsBox($l#5_1#_v2#0, Tclass.JSON_mGrammar.Value())), (lambda $l#5_1#heap#0: Heap, $l#5_1#_v2#0: Box :: SetRef_to_SetBox((lambda $l#5_1#o#0: ref :: false))))), $LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(600,28)"} true;
    goto anon319_Then, anon319_Else;

  anon319_Then:
    assume true;
    assume false;
    goto anon214;

  anon319_Else:
    goto anon320_Then, anon320_Else;

  anon320_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_9_0 := cs#0;
    assume $IsAlloc(##other#5_0_9_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon321_Then, anon321_Else;

  anon321_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#5_0_9_0 := cs#0;
    assume $IsAlloc(##cs0#5_0_9_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_9_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#5_0_9_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon172;

  anon321_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon172;

  anon172:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#5_0_9_1 := cs#0;
    assume $IsAlloc(##cs0#5_0_9_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_9_1 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#5_0_9_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))))));
    assume false;
    goto anon214;

  anon320_Else:
    goto anon322_Then, anon322_Else;

  anon322_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_8_0 := cs#0;
    assume $IsAlloc(##other#5_0_8_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon323_Then, anon323_Else;

  anon323_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    ##self#5_0_8_0 := #JSON.Grammar.Value.Null(cst#Z#2);
    assume $IsAlloc(##self#5_0_8_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Null(cst#Z#2));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon175;

  anon323_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon175;

  anon175:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Null(cst#Z#2)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_8_1 := cs#0;
    assume $IsAlloc(##other#5_0_8_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon324_Then, anon324_Else;

  anon324_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#5_0_8_0 := cs#0;
    assume $IsAlloc(##cs0#5_0_8_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_8_0 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#5_0_8_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon177;

  anon324_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon177;

  anon177:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)))));
    assume false;
    goto anon214;

  anon322_Else:
    goto anon325_Then, anon325_Else;

  anon325_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_7_0 := cs#0;
    assume $IsAlloc(##other#5_0_7_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon326_Then, anon326_Else;

  anon326_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##v#5_0_7_0 := cst#Z#2;
    assume $IsAlloc(##v#5_0_7_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#2);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon180;

  anon326_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon180;

  anon180:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#2) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_7_1 := cs#0;
    assume $IsAlloc(##other#5_0_7_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon327_Then, anon327_Else;

  anon327_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    ##self#5_0_7_0 := #JSON.Grammar.Value.Null(cst#Z#2);
    assume $IsAlloc(##self#5_0_7_0, Tclass.JSON_mGrammar.Value(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Null(cst#Z#2));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon182;

  anon327_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon182;

  anon182:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(#JSON.Grammar.Value.Null(cst#Z#2)) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.Value($LS($LS($LZ)), #JSON.Grammar.Value.Null(cst#Z#2)), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume false;
    goto anon214;

  anon325_Else:
    goto anon328_Then, anon328_Else;

  anon328_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_6_0 := cs#0;
    assume $IsAlloc(##other#5_0_6_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon329_Then, anon329_Else;

  anon329_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cst#Z#2), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(cst#Z#2);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#2);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon185;

  anon329_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon185;

  anon185:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#2) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_6_1 := cs#0;
    assume $IsAlloc(##other#5_0_6_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon330_Then, anon330_Else;

  anon330_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    ##v#5_0_6_0 := cst#Z#2;
    assume $IsAlloc(##v#5_0_6_0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#2);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon187;

  anon330_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon187;

  anon187:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mConcreteSyntax_mSpec.__default.View#canCall(cst#Z#2) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.View(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume false;
    goto anon214;

  anon328_Else:
    goto anon331_Then, anon331_Else;

  anon331_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_5_0 := cs#0;
    assume $IsAlloc(##other#5_0_5_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon332_Then, anon332_Else;

  anon332_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon190;

  anon332_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon190;

  anon190:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_5_1 := cs#0;
    assume $IsAlloc(##other#5_0_5_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon333_Then, anon333_Else;

  anon333_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cst#Z#2), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(cst#Z#2);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#2);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon192;

  anon333_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon192;

  anon192:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(cst#Z#2) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mUtils_mViews_mCore.View__.Bytes(cst#Z#2), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume false;
    goto anon214;

  anon331_Else:
    goto anon334_Then, anon334_Else;

  anon334_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_4_0 := cs#0;
    assume $IsAlloc(##other#5_0_4_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon335_Then, anon335_Else;

  anon335_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon195;

  anon335_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon195;

  anon195:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_4_1 := cs#0;
    assume $IsAlloc(##other#5_0_4_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon336_Then, anon336_Else;

  anon336_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon197;

  anon336_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon197;

  anon197:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5))) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append(JSON_mGrammar.__default.NULL(), JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume false;
    goto anon214;

  anon334_Else:
    goto anon337_Then, anon337_Else;

  anon337_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_3_0 := cs#0;
    assume $IsAlloc(##other#5_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon338_Then, anon338_Else;

  anon338_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#5_0_3_0 := cs#0;
    assume $IsAlloc(##cs0#5_0_3_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_3_0 := f#5_0;
    assume $IsAlloc(##spec#5_0_3_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    goto anon200;

  anon338_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon200;

  anon200:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0));
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_3_1 := cs#0;
    assume $IsAlloc(##other#5_0_3_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon339_Then, anon339_Else;

  anon339_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5);
    goto anon202;

  anon339_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon202;

  anon202:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs'#Z#5));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box(#JSON.Grammar.Value.Null(cst#Z#2)))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(cs'#Z#5)));
    assume false;
    goto anon214;

  anon337_Else:
    goto anon340_Then, anon340_Else;

  anon340_Then:
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_2_0 := cs#0;
    assume $IsAlloc(##other#5_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon341_Then, anon341_Else;

  anon341_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#5_0_2_0 := cs#0;
    assume $IsAlloc(##cs0#5_0_2_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_2_0 := f#5_0;
    assume $IsAlloc(##spec#5_0_2_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    goto anon205;

  anon341_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0);
    goto anon205;

  anon205:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_2_1 := cs#0;
    assume $IsAlloc(##other#5_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_2_2 := cs#0;
    assume $IsAlloc(##other#5_0_2_2, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon342_Then, anon342_Else;

  anon342_Then:
    assume $IsA#JSON_mUtils_mCursors.Cursor__(cs'#Z#5) && $IsA#JSON_mUtils_mCursors.Cursor__(cs#0);
    assume !JSON_mUtils_mCursors.Cursor__#Equal(cs'#Z#5, cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(610,93)"} true;
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0);
    assume false;
    goto anon207;

  anon342_Else:
    goto anon207;

  anon207:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) <==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(610,95)"} true;
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_2_3 := cs#0;
    assume $IsAlloc(##other#5_0_2_3, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon343_Then, anon343_Else;

  anon343_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#5_0_2_1 := cs#0;
    assume $IsAlloc(##cs0#5_0_2_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_2_1 := f#5_0;
    assume $IsAlloc(##spec#5_0_2_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    goto anon209;

  anon343_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    goto anon209;

  anon209:
    assume JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(cs'#Z#5);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(cs'#Z#5), JSON_mUtils_mCursors.Cursor__.s(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.beg(cs'#Z#5) > JSON_mUtils_mCursors.Cursor__.beg(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.end(cs'#Z#5) == JSON_mUtils_mCursors.Cursor__.end(cs#0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)))));
    assume false;
    goto anon214;

  anon340_Else:
    goto anon344_Then, anon344_Else;

  anon344_Then:
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#5_0_1_0 := cs#0;
    assume $IsAlloc(##cs0#5_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_1_0 := f#5_0;
    assume $IsAlloc(##spec#5_0_1_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume $IsAllocBox($Box(cs'#Z#5), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    ##other#5_0_1_0 := cs#0;
    assume $IsAlloc(##other#5_0_1_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs'#Z#5);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0);
    goto anon345_Then, anon345_Else;

  anon345_Then:
    assume {:partition} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0);
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#5_0_1_1 := cs#0;
    assume $IsAlloc(##cs0#5_0_1_1, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_1_1 := f#5_0;
    assume $IsAlloc(##spec#5_0_1_1, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    goto anon212;

  anon345_Else:
    assume {:partition} !JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0);
    goto anon212;

  anon212:
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0) && (JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs'#Z#5, cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(cs'#Z#5, cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#Z#5, cs#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)))));
    assume false;
    goto anon214;

  anon344_Else:
    goto anon346_Then, anon346_Else;

  anon346_Then:
    assume true;
    assume true;
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    ##cs0#5_0_0_0 := cs#0;
    assume $IsAlloc(##cs0#5_0_0_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#5_0_0_0 := f#5_0;
    assume $IsAlloc(##spec#5_0_0_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0);
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) || (JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__#Equal(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0));
    assume {:subsumption 0} Lit(true) ==> JSON_mUtils_mCursors.Split.SplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, f#5_0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, f#5_0, $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))))));
    assume false;
    goto anon214;

  anon346_Else:
    goto anon214;

  anon214:
    assume true ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5))))));
    assume false;
    goto anon215;

  anon316_Else:
    goto anon215;

  anon215:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5), cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(615,8)"} true;
    assume $Is(cst#Z#2, Tclass.JSON_mGrammar.jnull());
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#Z#2)), cs'#Z#5)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon314_Else:
    assume {:partition} c#Z#0 != char#ToInt(Lit(char#FromInt(110)));
    havoc valueOrError6#Z#0;
    assume $Is(valueOrError6#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) && $IsAlloc(valueOrError6#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    ##cs#8 := cs#0;
    assume $IsAlloc(##cs#8, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0);
    assume let#17#0#0 == JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0);
    assume JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0);
    assume $Is(let#17#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    assume valueOrError6#Z#0 == let#17#0#0;
    assume $IsAllocBox($Box(valueOrError6#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0);
    goto anon347_Then, anon347_Else;

  anon347_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0);
    assume $IsAllocBox($Box(valueOrError6#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError6#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError6#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon347_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0);
    havoc num#Z#0;
    havoc cs'#Z#6;
    assume $Is(num#Z#0, Tclass.JSON_mGrammar.jnumber()) && $IsAlloc(num#Z#0, Tclass.JSON_mGrammar.jnumber(), $Heap) && $Is(cs'#Z#6, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs'#Z#6, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError6#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError6#Z#0);
    assume Wrappers.Result.Success_q(valueOrError6#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0)): DatatypeType);
    assume let#18#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#Z#0);
    assume $Is(let#18#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()));
    assume JSON_mUtils_mCursors.Split.SP_q(let#18#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6) == let#18#0#0;
    havoc v#Z#2;
    assume $Is(v#Z#2, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#Z#2, Tclass.JSON_mGrammar.Value(), $Heap);
    assume let#19#0#0 == #JSON.Grammar.Value.Number(num#Z#0);
    assume true;
    assume $Is(let#19#0#0, Tclass.JSON_mGrammar.Value());
    assume v#Z#2 == let#19#0#0;
    havoc sp#Z#2;
    assume $Is(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(sp#Z#2, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume let#20#0#0 == #JSON.Utils.Cursors.Split.SP($Box(v#Z#2), cs'#Z#6);
    assume true;
    assume $Is(let#20#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()));
    assume sp#Z#2 == let#20#0#0;
    assume $IsAllocBox($Box(sp#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#9 := cs#0;
    assume $IsAlloc(##cs0#9, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#9 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#9, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    goto anon348_Then, anon348_Else;

  anon348_Then:
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), $Heap);
    assume true;
    ##cs0#6_0 := cs#0;
    assume $IsAlloc(##cs0#6_0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#6_0 := JSON_mConcreteSyntax_mSpec.__default.Number#Handle();
    assume $IsAlloc(##spec#6_0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6))), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6))) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6)), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6))) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6))))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), #JSON.Utils.Cursors.Split.SP($Box(num#Z#0), cs'#Z#6), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(622,65)"} true;
    assume true;
    v##6_0 := v#Z#2;
    call CallPre$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v##6_0);
    call CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v##6_0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(623,35)"} true;
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#2)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#2)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#2)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#2)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#2)))));
    assume false;
    goto anon220;

  anon348_Else:
    goto anon220;

  anon220:
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(624,8)"} true;
    assume $IsAllocBox($Box(sp#Z#2), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap);
    assume true;
    ##cs0#10 := cs#0;
    assume $IsAlloc(##cs0#10, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#10 := JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ));
    assume $IsAlloc(##spec#10, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || JSON_mUtils_mCursors.Cursor__.BOF_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Split.cs(sp#Z#2)), JSON_mUtils_mCursors.Cursor__.s(cs#0))));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || JSON_mUtils_mCursors.Cursor__.beg(JSON_mUtils_mCursors.Split.cs(sp#Z#2)) > JSON_mUtils_mCursors.Cursor__.beg(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || (JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q#canCall(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) ==> JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(sp#Z#2), cs#0) || JSON_mUtils_mCursors.Cursor__.end(JSON_mUtils_mCursors.Split.cs(sp#Z#2)) == JSON_mUtils_mCursors.Cursor__.end(cs#0)));
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || (JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#0), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LS($LZ))), $Box($Unbox(JSON_mUtils_mCursors.Split.t(sp#Z#2)): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(sp#Z#2)))));
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), sp#Z#2, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(625,52)"} true;
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == #Wrappers.Result.Success($Box(sp#Z#2));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon221;

  anon221:
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly: LayerType, $reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || (0 < $FunctionContextHeight && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0))) && $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#2#ps'#0: DatatypeType :: $Is($l#2#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#2#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0)) && (var pre#0 := Lit(AtLayer((lambda $l#5#ly#0: LayerType :: Handle1((lambda $l#5#heap#0: Heap, $l#5#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#5#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#5#heap#0: Heap, $l#5#ps'#0: Box :: $IsBox($l#5#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#5#heap#0: Heap, $l#5#ps'#0: Box :: SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), $ly)); (forall $l#3#ps'#0: DatatypeType :: $Is($l#3#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#0, $Box($l#3#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#3#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0) == (var pre#0 := Lit(AtLayer((lambda $l#0#ly#0: LayerType :: Handle1((lambda $l#0#heap#0: Heap, $l#0#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#0#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#0#heap#0: Heap, $l#0#ps'#0: Box :: $IsBox($l#0#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#0#heap#0: Heap, $l#0#ps'#0: Box :: SetRef_to_SetBox((lambda $l#0#o#0: ref :: false))))), $ly)); (var fn#0 := Lit(AtLayer((lambda $l#1#ly#0: LayerType :: Handle1((lambda $l#1#heap#0: Heap, $l#1#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#1#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#1#ps'#0): DatatypeType))), (lambda $l#1#heap#0: Heap, $l#1#ps'#0: Box :: $IsBox($l#1#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#1#heap#0, pre#0, $Box($Unbox($l#1#ps'#0): DatatypeType))): bool), (lambda $l#1#heap#0: Heap, $l#1#ps'#0: Box :: SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), $ly)); #JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#0, fn#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));
axiom 0 <= $FunctionContextHeight ==> (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) || (0 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#8#ps'#0: DatatypeType :: $Is($l#8#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#8#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(cs#0))) && (var pre#1 := Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#11#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#11#heap#0: Heap, $l#11#ps'#0: Box :: $IsBox($l#11#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#11#heap#0: Heap, $l#11#ps'#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($ly))); (forall $l#9#ps'#0: DatatypeType :: $Is($l#9#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#1, $Box($l#9#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#9#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)) == (var pre#1 := Lit(AtLayer((lambda $l#6#ly#0: LayerType :: Handle1((lambda $l#6#heap#0: Heap, $l#6#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#6#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#6#heap#0: Heap, $l#6#ps'#0: Box :: $IsBox($l#6#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#6#heap#0: Heap, $l#6#ps'#0: Box :: SetRef_to_SetBox((lambda $l#6#o#0: ref :: false))))), $LS($ly))); (var fn#1 := Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#7#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#7#ps'#0): DatatypeType))), (lambda $l#7#heap#0: Heap, $l#7#ps'#0: Box :: $IsBox($l#7#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#7#heap#0, pre#1, $Box($Unbox($l#7#ps'#0): DatatypeType))): bool), (lambda $l#7#heap#0: Heap, $l#7#ps'#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($ly))); #JSON.Utils.Parsers.SubParser_.SubParser(Lit(cs#0), pre#1, fn#1, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));
}

function JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0: DatatypeType) : bool;

axiom (forall $ly: LayerType, $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), $reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), $reveal, cs#0) == JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0));

axiom (forall $ly: LayerType, $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser(AsFuelBottom($ly), $reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0) == JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LZ, $reveal, cs#0));

function JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#requires(LayerType, DatatypeType) : bool;

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#requires($ly, cs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#requires($ly, cs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.ValueParser (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (p#0: DatatypeType where $Is(p#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28694"} JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(p#0));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.Values.ValueParser (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser(cs#0: DatatypeType) returns (p#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##other#0: DatatypeType;
  var pre#Z#0: HandleType;
  var let#0#0#0: HandleType;
  var $lambdaHeap#0: Heap;
  var ps'#0: DatatypeType;
  var $_Frame#l0: [ref,Field]bool;
  var lambdaResult#0: bool;
  var fn#Z#0: HandleType;
  var let#1#0#0: HandleType;
  var $lambdaHeap#1: Heap;
  var ps'#1: DatatypeType;
  var $_Frame#l1: [ref,Field]bool;
  var lambdaResult#1: DatatypeType;
  var ##cs#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Values.ValueParser", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(629,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser());
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume JSON_mUtils_mParsers.SubParser__.SubParser_q(p#0);
    ##other#0 := JSON_mUtils_mParsers.SubParser__.cs(p#0);
    assume $IsAlloc(##other#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q#canCall(cs#0, JSON_mUtils_mParsers.SubParser__.cs(p#0));
    assume JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(p#0));
    assume false;
    return;

  anon13_Else:
    havoc pre#Z#0;
    assume $Is(pre#Z#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool)) && $IsAlloc(pre#Z#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool), $Heap);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    havoc $lambdaHeap#0;
    assume $IsGoodHeap($lambdaHeap#0);
    assume $Heap == $lambdaHeap#0 || $HeapSucc($Heap, $lambdaHeap#0);
    havoc ps'#0;
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} $Is(ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#0);
    $_Frame#l0 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#0, $o, alloc)): bool ==> false);
    assume $IsAllocBox($Box(ps'#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $lambdaHeap#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(ps'#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(ps'#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(ps'#0);
    assume $IsAllocBox($Box(cs#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $lambdaHeap#0);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Valid_q(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    assume lambdaResult#0 <==> JSON_mUtils_mCursors.Cursor__.Length(ps'#0) < JSON_mUtils_mCursors.Cursor__.Length(cs#0);
    assume JSON_mUtils_mCursors.Cursor__.Length#canCall(ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0);
    assume $Is(lambdaResult#0, TBool);
    goto anon6;

  anon15_Else:
    assume {:partition} !($Is(ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#0));
    goto anon6;

  anon6:
    assume false;
    goto anon7;

  anon14_Else:
    goto anon7;

  anon7:
    assume let#0#0#0 == Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#13#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#13#heap#0: Heap, $l#13#ps'#0: Box :: $IsBox($l#13#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#13#heap#0: Heap, $l#13#ps'#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)));
    assume (forall $l#14#ps'#0: DatatypeType :: $Is($l#14#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#14#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0));
    assume $Is(let#0#0#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool));
    assume pre#Z#0 == let#0#0#0;
    havoc fn#Z#0;
    assume $Is(fn#Z#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())))) && $IsAlloc(fn#Z#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))), $Heap);
    goto anon16_Then, anon16_Else;

  anon16_Then:
    havoc $lambdaHeap#1;
    assume $IsGoodHeap($lambdaHeap#1);
    assume $Heap == $lambdaHeap#1 || $HeapSucc($Heap, $lambdaHeap#1);
    havoc ps'#1;
    goto anon17_Then, anon17_Else;

  anon17_Then:
    assume {:partition} $Is(ps'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(ps'#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#1);
    $_Frame#l1 := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($lambdaHeap#1, $o, alloc)): bool ==> false);
    goto anon18_Then, anon18_Else;

  anon18_Then:
    assume {:partition} $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $lambdaHeap#1, pre#Z#0, $Box(ps'#1))): bool;
    ##cs#0 := ps'#1;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#1);
    assume 0 <= JSON_mUtils_mCursors.Cursor__.Length(cs#0) || JSON_mUtils_mCursors.Cursor__.Length(##cs#0) == JSON_mUtils_mCursors.Cursor__.Length(cs#0);
    assume 0 <= LitInt(0) || JSON_mUtils_mCursors.Cursor__.Length(##cs#0) < JSON_mUtils_mCursors.Cursor__.Length(cs#0) || LitInt(1) == LitInt(0);
    assume JSON_mUtils_mCursors.Cursor__.Length(##cs#0) < JSON_mUtils_mCursors.Cursor__.Length(cs#0) || (JSON_mUtils_mCursors.Cursor__.Length(##cs#0) == JSON_mUtils_mCursors.Cursor__.Length(cs#0) && LitInt(1) < LitInt(0));
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(ps'#1);
    assume lambdaResult#1 == JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, ps'#1);
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(ps'#1);
    assume $Is(lambdaResult#1, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
    goto anon11;

  anon18_Else:
    assume {:partition} !$Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $lambdaHeap#1, pre#Z#0, $Box(ps'#1))): bool;
    goto anon11;

  anon17_Else:
    assume {:partition} !($Is(ps'#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(ps'#1, Tclass.JSON_mUtils_mCursors.FreshCursor(), $lambdaHeap#1));
    goto anon11;

  anon11:
    assume false;
    goto anon12;

  anon16_Else:
    goto anon12;

  anon12:
    assume let#1#0#0 == Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#16#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#16#ps'#0): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#ps'#0: Box :: $IsBox($l#16#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#16#heap#0, pre#Z#0, $Box($Unbox($l#16#ps'#0): DatatypeType))): bool), (lambda $l#16#heap#0: Heap, $l#16#ps'#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)));
    assume (forall $l#17#ps'#0: DatatypeType :: $Is($l#17#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#Z#0, $Box($l#17#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#17#ps'#0));
    assume $Is(let#1#0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));
    assume fn#Z#0 == let#1#0#0;
    assume true;
    assume $Is(#JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#Z#0, fn#Z#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser());
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0) == #JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#Z#0, fn#Z#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser());
    assume JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0) == p#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.reveal_Value (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mValues.__default.reveal__Value();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.reveal_Value (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mValues.__default.reveal__Value();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.reveal_Value (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mValues.__default.reveal__Value();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Values._default.Value;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.reveal_ValueParser (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mValues.__default.reveal__ValueParser();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.reveal_ValueParser (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mValues.__default.reveal__ValueParser();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.Values.reveal_ValueParser (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mValues.__default.reveal__ValueParser();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#256 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#256))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#258 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#258)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#384 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#384))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#386 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#386)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#388 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#388)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#384 := Wrappers.Option.value(this); v#384)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#386 := Lit(Wrappers.Option.value(Lit(this))); v#386)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#388 := Lit(Wrappers.Option.value(Lit(this))); v#388)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#256 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#256)) else (var e#256 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#258 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#258))) else (var e#258 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#384 := Wrappers.Result.value(this); s#384) else (var e#384 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#386 := Lit(Wrappers.Result.value(Lit(this))); s#386) else (var e#386 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#388 := Lit(Wrappers.Result.value(Lit(this))); s#388) else (var e#388 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#384 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#384)) else (var e#384 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#384)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#386 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#386))) else (var e#386 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#386)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#388 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#388))) else (var e#388 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#388)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#180: int, y#180: int :: { Mul(x#180, y#180) } Mul(x#180, y#180) == Mul(y#180, x#180)) && (forall x#181: int, y#181: int, z#120: int :: { Mul(x#181 + y#181, z#120) } Mul(x#181 + y#181, z#120) == Mul(x#181, z#120) + Mul(y#181, z#120)) && (forall x#182: int, y#182: int, z#121: int :: { Mul(x#182 - y#182, z#121) } Mul(x#182 - y#182, z#121) == Mul(x#182, z#121) - Mul(y#182, z#121));

axiom MulInternals.__default.MulAuto() <==> (forall x#183: int, y#183: int :: { Mul(x#183, y#183) } Mul(x#183, y#183) == Mul(y#183, x#183)) && (forall x#184: int, y#184: int, z#122: int :: { Mul(x#184 + y#184, z#122) } Mul(x#184 + y#184, z#122) == Mul(x#184, z#122) + Mul(y#184, z#122)) && (forall x#185: int, y#185: int, z#123: int :: { Mul(x#185 - y#185, z#123) } Mul(x#185 - y#185, z#123) == Mul(x#185, z#123) - Mul(y#185, z#123));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#224: int :: { Mod(Mod(x#224, n#0), n#0) } Mod(Mod(x#224, n#0), n#0) == Mod(x#224, n#0)) && (forall x#225: int :: { Mod(x#225, n#0) } LitInt(0) <= x#225 && x#225 < n#0 <==> Mod(x#225, n#0) == x#225) && (forall x#226: int, y#112: int :: { Mod(x#226 + y#112, n#0) } (var z#110 := Mod(x#226, n#0) + Mod(y#112, n#0); (LitInt(0) <= z#110 && z#110 < n#0 && Mod(x#226 + y#112, n#0) == z#110) || (n#0 <= z#110 && z#110 < n#0 + n#0 && Mod(x#226 + y#112, n#0) == z#110 - n#0))) && (forall x#227: int, y#113: int :: { Mod(x#227 - y#113, n#0) } (var z#111 := Mod(x#227, n#0) - Mod(y#113, n#0); (LitInt(0) <= z#111 && z#111 < n#0 && Mod(x#227 - y#113, n#0) == z#111) || (0 - n#0 <= z#111 && z#111 < 0 && Mod(x#227 - y#113, n#0) == z#111 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#228: int :: { Mod(Mod(x#228, n#0), n#0) } Mod(Mod(x#228, LitInt(n#0)), LitInt(n#0)) == Mod(x#228, LitInt(n#0))) && (forall x#229: int :: { Mod(x#229, n#0) } LitInt(0) <= x#229 && x#229 < n#0 <==> Mod(x#229, LitInt(n#0)) == x#229) && (forall x#230: int, y#114: int :: { Mod(x#230 + y#114, n#0) } (var z#112 := Mod(x#230, LitInt(n#0)) + Mod(y#114, LitInt(n#0)); (LitInt(0) <= z#112 && z#112 < n#0 && Mod(x#230 + y#114, LitInt(n#0)) == z#112) || (LitInt(n#0) <= z#112 && z#112 < n#0 + n#0 && Mod(x#230 + y#114, LitInt(n#0)) == z#112 - n#0))) && (forall x#231: int, y#115: int :: { Mod(x#231 - y#115, n#0) } (var z#113 := Mod(x#231, LitInt(n#0)) - Mod(y#115, LitInt(n#0)); (LitInt(0) <= z#113 && z#113 < n#0 && Mod(x#231 - y#115, LitInt(n#0)) == z#113) || (LitInt(0 - n#0) <= z#113 && z#113 < 0 && Mod(x#231 - y#115, LitInt(n#0)) == z#113 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#162: int :: { Div(x#162, n#0) } LitInt(0) <= x#162 && x#162 < n#0 <==> Div(x#162, n#0) == LitInt(0)) && (forall x#163: int, y#108: int :: { Div(x#163 + y#108, n#0) } (var z#106 := Mod(x#163, n#0) + Mod(y#108, n#0); (LitInt(0) <= z#106 && z#106 < n#0 && Div(x#163 + y#108, n#0) == Div(x#163, n#0) + Div(y#108, n#0)) || (n#0 <= z#106 && z#106 < n#0 + n#0 && Div(x#163 + y#108, n#0) == Div(x#163, n#0) + Div(y#108, n#0) + 1))) && (forall x#164: int, y#109: int :: { Div(x#164 - y#109, n#0) } (var z#107 := Mod(x#164, n#0) - Mod(y#109, n#0); (LitInt(0) <= z#107 && z#107 < n#0 && Div(x#164 - y#109, n#0) == Div(x#164, n#0) - Div(y#109, n#0)) || (0 - n#0 <= z#107 && z#107 < 0 && Div(x#164 - y#109, n#0) == Div(x#164, n#0) - Div(y#109, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#165: int :: { Div(x#165, n#0) } LitInt(0) <= x#165 && x#165 < n#0 <==> Div(x#165, LitInt(n#0)) == LitInt(0)) && (forall x#166: int, y#110: int :: { Div(x#166 + y#110, n#0) } (var z#108 := Mod(x#166, LitInt(n#0)) + Mod(y#110, LitInt(n#0)); (LitInt(0) <= z#108 && z#108 < n#0 && Div(x#166 + y#110, LitInt(n#0)) == Div(x#166, LitInt(n#0)) + Div(y#110, LitInt(n#0))) || (LitInt(n#0) <= z#108 && z#108 < n#0 + n#0 && Div(x#166 + y#110, LitInt(n#0)) == Div(x#166, LitInt(n#0)) + Div(y#110, LitInt(n#0)) + 1))) && (forall x#167: int, y#111: int :: { Div(x#167 - y#111, n#0) } (var z#109 := Mod(x#167, LitInt(n#0)) - Mod(y#111, LitInt(n#0)); (LitInt(0) <= z#109 && z#109 < n#0 && Div(x#167 - y#111, LitInt(n#0)) == Div(x#167, LitInt(n#0)) - Div(y#111, LitInt(n#0))) || (LitInt(0 - n#0) <= z#109 && z#109 < 0 && Div(x#167 - y#111, LitInt(n#0)) == Div(x#167, LitInt(n#0)) - Div(y#111, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#42 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#42) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#42)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#42 := lv#0; (var dt_update#end#0#42 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#42), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#42), dt_update#end#0#42))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#43 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#43) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#43)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#43 := Lit(lv#0); (var dt_update#end#0#43 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#43)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#43)), dt_update#end#0#43)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#44: char :: { Seq#Contains(s#0, $Box(c#44)) } $Is(c#44, TChar) && Seq#Contains(s#0, $Box(c#44)) ==> char#ToInt(c#44) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#44: char :: { Seq#Contains(s#0, $Box(c#44)) } $Is(c#44, TChar) && Seq#Contains(s#0, $Box(c#44)) ==> char#ToInt(c#44) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#88#i#0): int)): char))), (lambda $l#88#heap#0: Heap, $l#88#i#0: Box :: $IsBox($l#88#i#0, TInt) && LitInt(0) <= $Unbox($l#88#i#0): int && $Unbox($l#88#i#0): int < Seq#Length(s#0)), (lambda $l#88#heap#0: Heap, $l#88#i#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#45: char :: { Seq#Contains(s#0, $Box(c#45)) } $Is(c#45, TChar) && Seq#Contains(s#0, $Box(c#45)) ==> char#ToInt(c#45) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#90#i#0): int)): char))), (lambda $l#90#heap#0: Heap, $l#90#i#0: Box :: $IsBox($l#90#i#0, TInt) && LitInt(0) <= $Unbox($l#90#i#0): int && $Unbox($l#90#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#90#heap#0: Heap, $l#90#i#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#24 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#24))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#24 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#26 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#26))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#26 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#156 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#78 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#156 := (if b#156 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#156)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#78)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#156)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#157 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#78 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#157 := (if b#157 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#157)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#78 := Seq#Create(TChar, $Heap, Seq#Length(bs0#78), Lit(AtLayer((lambda $l#121#ly#0: LayerType :: Handle1((lambda $l#121#heap#0: Heap, $l#121#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#78, $Unbox($l#121#idx#0): int)): int))), (lambda $l#121#heap#0: Heap, $l#121#idx#0: Box :: $IsBox($l#121#idx#0, TInt) && LitInt(0) <= $Unbox($l#121#idx#0): int && $Unbox($l#121#idx#0): int < Seq#Length(bs0#78)), (lambda $l#121#heap#0: Heap, $l#121#idx#0: Box :: SetRef_to_SetBox((lambda $l#121#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#78), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#157))))) else (var err#78 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#78)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#160 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#80 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#160 := (if b#160 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#160)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#80)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#160)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#161 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#80 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#161 := (if b#161 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#161)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#80 := Seq#Create(TChar, $Heap, Seq#Length(bs0#80), Lit(AtLayer((lambda $l#124#ly#0: LayerType :: Handle1((lambda $l#124#heap#0: Heap, $l#124#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#80, $Unbox($l#124#idx#0): int)): int))), (lambda $l#124#heap#0: Heap, $l#124#idx#0: Box :: $IsBox($l#124#idx#0, TInt) && LitInt(0) <= $Unbox($l#124#idx#0): int && $Unbox($l#124#idx#0): int < Seq#Length(bs0#80)), (lambda $l#124#heap#0: Heap, $l#124#idx#0: Box :: SetRef_to_SetBox((lambda $l#124#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#80), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#161))))) else (var err#80 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#80)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#164 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#82 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#164 := (if b#164 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#164)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#82)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#164)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#165 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#82 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#165 := (if b#165 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#165)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#82 := Seq#Create(TChar, $Heap, Seq#Length(bs0#82), Lit(AtLayer((lambda $l#127#ly#0: LayerType :: Handle1((lambda $l#127#heap#0: Heap, $l#127#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#82, $Unbox($l#127#idx#0): int)): int))), (lambda $l#127#heap#0: Heap, $l#127#idx#0: Box :: $IsBox($l#127#idx#0, TInt) && LitInt(0) <= $Unbox($l#127#idx#0): int && $Unbox($l#127#idx#0): int < Seq#Length(bs0#82)), (lambda $l#127#heap#0: Heap, $l#127#idx#0: Box :: SetRef_to_SetBox((lambda $l#127#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#82), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#165))))) else (var err#82 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#82)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#15: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#15)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#15)): int } LitInt(0) <= idx#15 && idx#15 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#15 && idx#15 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#15)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#15)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#26 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#26 := this; (var dt_update#beg#0#26 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#26), dt_update#beg#0#26, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#26), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#26)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#27 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#27 := Lit(this); (var dt_update#beg#0#27 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#27)), dt_update#beg#0#27, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#27)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#27)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#75#v#0): DatatypeType))), (lambda $l#75#heap#0: Heap, $l#75#v#0: Box :: $IsBox($l#75#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#75#heap#0: Heap, $l#75#v#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#76#v#0): DatatypeType))), (lambda $l#76#heap#0: Heap, $l#76#v#0: Box :: $IsBox($l#76#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#76#heap#0: Heap, $l#76#v#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#77#v#0): DatatypeType))), (lambda $l#77#heap#0: Heap, $l#77#v#0: Box :: $IsBox($l#77#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#77#heap#0: Heap, $l#77#v#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#26 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#26 := this; (var dt_update#point#0#26 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#26), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#26), dt_update#point#0#26, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#26)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#27 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#27 := Lit(this); (var dt_update#point#0#27 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#27)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#27)), dt_update#point#0#27, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#27)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#26 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#26)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#26 := this; (var dt_update#point#0#26 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#26), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#26), dt_update#point#0#26, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#26)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#27 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#27)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#27 := Lit(this); (var dt_update#point#0#27 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#27)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#27)), dt_update#point#0#27, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#27)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#26 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#26 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#26 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#26 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#26))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#27 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#27 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#27 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#27 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#27)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#42: int :: { Seq#Contains(bs#0, $Box(b#42)) } LitInt(0) <= b#42 && b#42 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#42)) ==> b#42 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#42: int :: { Seq#Contains(bs#0, $Box(b#42)) } LitInt(0) <= b#42 && b#42 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#42)) ==> b#42 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#39 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#39)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39) && (var ps#39 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#39, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#39 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#39) else (var ps#39 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#39)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#39, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#43: int :: { Seq#Contains(bs#0, $Box(b#43)) } LitInt(0) <= b#43 && b#43 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#43)) ==> b#43 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#40 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#40)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40) && (var ps#40 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#40, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#40 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#40) else (var ps#40 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#40)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#40, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#44: int :: { Seq#Contains(bs#0, $Box(b#44)) } LitInt(0) <= b#44 && b#44 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#44)) ==> b#44 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#41 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#41)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41) && (var ps#41 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#41, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#41 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#41) else (var ps#41 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#41)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#41, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#15: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#15)): int } LitInt(0) <= idx#15 && idx#15 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#15 && idx#15 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#15)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#80 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#80)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#79 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#79)))) else (var st#79 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#79))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#82 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#82)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#81 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#81)))) else (var st#81 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#81))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#84 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#84)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#83 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#83)))) else (var st#83 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#83))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#104#ly#0: LayerType :: Handle1((lambda $l#104#heap#0: Heap, $l#104#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#104#heap#0: Heap, $l#104#_v0#0: Box :: $IsBox($l#104#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#104#heap#0: Heap, $l#104#_v0#0: Box :: SetRef_to_SetBox((lambda $l#104#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#105#ly#0: LayerType :: Handle1((lambda $l#105#heap#0: Heap, $l#105#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#105#heap#0: Heap, $l#105#_v1#0: Box :: $IsBox($l#105#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#105#heap#0: Heap, $l#105#_v1#0: Box :: SetRef_to_SetBox((lambda $l#105#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#108#ly#0: LayerType :: Handle1((lambda $l#108#heap#0: Heap, $l#108#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#108#heap#0: Heap, $l#108#_v0#0: Box :: $IsBox($l#108#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#108#heap#0: Heap, $l#108#_v0#0: Box :: SetRef_to_SetBox((lambda $l#108#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#109#ly#0: LayerType :: Handle1((lambda $l#109#heap#0: Heap, $l#109#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#109#heap#0: Heap, $l#109#_v1#0: Box :: $IsBox($l#109#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#109#heap#0: Heap, $l#109#_v1#0: Box :: SetRef_to_SetBox((lambda $l#109#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#156#ly#0: LayerType :: Handle1((lambda $l#156#heap#0: Heap, $l#156#cs#0: Box :: $Box(Lit(false))), (lambda $l#156#heap#0: Heap, $l#156#cs#0: Box :: $IsBox($l#156#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#156#heap#0: Heap, $l#156#cs#0: Box :: SetRef_to_SetBox((lambda $l#156#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#157#ly#0: LayerType :: Handle1((lambda $l#157#heap#0: Heap, $l#157#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#157#heap#0: Heap, $l#157#cs#0: Box :: $IsBox($l#157#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#157#heap#0: Heap, $l#157#cs#0: Box :: SetRef_to_SetBox((lambda $l#157#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#158#ly#0: LayerType :: Handle1((lambda $l#158#heap#0: Heap, $l#158#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#158#heap#0: Heap, $l#158#_v2#0: Box :: $IsBox($l#158#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#158#heap#0: Heap, $l#158#_v2#0: Box :: SetRef_to_SetBox((lambda $l#158#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#162#ly#0: LayerType :: Handle1((lambda $l#162#heap#0: Heap, $l#162#cs#0: Box :: $Box(Lit(false))), (lambda $l#162#heap#0: Heap, $l#162#cs#0: Box :: $IsBox($l#162#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#162#heap#0: Heap, $l#162#cs#0: Box :: SetRef_to_SetBox((lambda $l#162#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#163#ly#0: LayerType :: Handle1((lambda $l#163#heap#0: Heap, $l#163#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#163#heap#0: Heap, $l#163#cs#0: Box :: $IsBox($l#163#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#163#heap#0: Heap, $l#163#cs#0: Box :: SetRef_to_SetBox((lambda $l#163#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#164#ly#0: LayerType :: Handle1((lambda $l#164#heap#0: Heap, $l#164#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#164#heap#0: Heap, $l#164#_v2#0: Box :: $IsBox($l#164#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#164#heap#0: Heap, $l#164#_v2#0: Box :: SetRef_to_SetBox((lambda $l#164#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#26: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#26))): DatatypeType } $Is(cs'#26, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#26))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#26))): DatatypeType)): DatatypeType, cs'#26, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#26: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#26))): DatatypeType } $Is(cs'#26, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#26))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#26))): DatatypeType)): DatatypeType, cs'#26, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#27: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#27))): DatatypeType } $Is(cs'#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#27))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#27))): DatatypeType)): DatatypeType, cs'#27, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#27: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#27))): DatatypeType } $Is(cs'#27, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#27))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#27))): DatatypeType)): DatatypeType, cs'#27, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#78: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#78)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#78))): bool } $Is(cs'#78, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#78))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#78)))) && ((forall cs'#78: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#78)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#78))): bool } $Is(cs'#78, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#78))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#78))) ==> (forall cs'#79: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#79))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#79, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#79: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#79))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#79, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#79))): bool) ==> (forall cs'#80: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#80))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#80))): bool } $Is(cs'#80, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#80))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#80))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#80))): DatatypeType)): DatatypeType, cs'#80, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#78: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#78)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#78))): bool } $Is(cs'#78, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#78))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#78))) && (forall cs'#79: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#79))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#79, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#79, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#79))): bool) && (forall cs'#80: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#80))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#80))): bool } $Is(cs'#80, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#80))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#80))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#80))): DatatypeType)): DatatypeType, cs'#80, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#81: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#81)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#81))): bool } $Is(cs'#81, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#81))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#81)))) && ((forall cs'#81: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#81)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#81))): bool } $Is(cs'#81, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#81))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#81))) ==> (forall cs'#82: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#82))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#82, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#82, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#82, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#82, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#82: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#82))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#82, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#82, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#82, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#82))): bool) ==> (forall cs'#83: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#83))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#83))): bool } $Is(cs'#83, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#83))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#83))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#83))): DatatypeType)): DatatypeType, cs'#83, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#81: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#81)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#81))): bool } $Is(cs'#81, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#81))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#81))) && (forall cs'#82: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#82))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#82, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#82, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#82, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#82))): bool) && (forall cs'#83: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#83))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#83))): bool } $Is(cs'#83, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#83))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#83))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#83))): DatatypeType)): DatatypeType, cs'#83, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#20: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#20)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#20)) ==> LitInt(0) <= d#20 && d#20 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#54 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#55 := Seq#Append(digits'#54, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#55))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#55 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#56 := Seq#Append(digits'#55, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#56))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#56 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#57 := Seq#Append(digits'#56, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#57))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#20: Box :: { Seq#Contains(chars#0, c#20) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#20) } $IsBox(c#20, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#20) ==> Seq#Contains(chars#0, c#20)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#41: int :: { Seq#Contains(digits#0, $Box(d#41)) } Seq#Contains(digits#0, $Box(d#41)) ==> LitInt(0) <= d#41 && d#41 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#41: int :: { Seq#Contains(digits#0, $Box(d#41)) } Seq#Contains(digits#0, $Box(d#41)) ==> LitInt(0) <= d#41 && d#41 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#42: int :: { Seq#Contains(digits#0, $Box(d#42)) } Seq#Contains(digits#0, $Box(d#42)) ==> LitInt(0) <= d#42 && d#42 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#20: Box :: { Seq#Contains(chars#0, c#20) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#20) } $IsBox(c#20, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#20) ==> Seq#Contains(chars#0, c#20)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#36 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#36) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#36), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#36 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#36), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#37 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#37) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#37), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#37 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#37), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#56: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#56)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#56) } $IsBox(c#56, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#56) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#56)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#57: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#57)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#57) } $IsBox(c#57, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#57) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#57)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#58: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#58)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#58) } $IsBox(c#58, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#58) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#58)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(Seq#Contains(chars#0, $l#24#c#0))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#39: Box :: { Map#Domain(digits#0)[c#39] } { Seq#Contains(str#0, c#39) } $IsBox(c#39, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#39) ==> Map#Domain(digits#0)[c#39])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#39: Box :: { Map#Domain(digits#0)[c#39] } { Seq#Contains(str#0, c#39) } $IsBox(c#39, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#39) ==> Map#Domain(digits#0)[c#39])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#40: Box :: { Map#Domain(digits#0)[c#40] } { Seq#Contains(str#0, c#40) } $IsBox(c#40, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#40) ==> Map#Domain(digits#0)[c#40])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $Box(Map#Domain(digits#0)[$l#77#c#0])), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $IsBox($l#77#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $Box(Map#Domain(digits#0)[$l#77#c#0])), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $IsBox($l#77#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box(Map#Domain(digits#0)[$l#78#c#0])), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box(Map#Domain(digits#0)[$l#79#c#0])), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#54 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#54) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#54) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#54)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#54) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#54)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#54 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#54) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#54) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#54)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#54) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#54))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#54 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#54) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#54) else (var tl#108 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#54)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#108)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#54 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#54) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#54) else (var tl#109 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#54)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#109)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#55 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#55) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#55) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#55)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#55) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#55)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#55 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#55) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#55) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#55)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#55) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#55))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#55 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#55) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#55) else (var tl#110 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#55)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#110)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#55 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#55) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#55) else (var tl#111 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#55)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#111)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#56 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#56) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#56) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#56)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#56) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#56)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#56 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#56) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#56) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#56)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#56) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#56))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#56 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#56) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#56) else (var tl#112 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#56)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#112)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#56 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#56) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#56) else (var tl#113 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#56)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#113)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#20: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#20)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#20)) ==> LitInt(0) <= d#20 && d#20 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#54 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#55 := Seq#Append(digits'#54, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#55))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#55 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#56 := Seq#Append(digits'#55, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#56))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#56 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#57 := Seq#Append(digits'#56, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#57))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#20: char :: { Seq#Contains(chars#0, $Box(c#20)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#20)) ==> Seq#Contains(chars#0, $Box(c#20))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#41: int :: { Seq#Contains(digits#0, $Box(d#41)) } Seq#Contains(digits#0, $Box(d#41)) ==> LitInt(0) <= d#41 && d#41 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#41: int :: { Seq#Contains(digits#0, $Box(d#41)) } Seq#Contains(digits#0, $Box(d#41)) ==> LitInt(0) <= d#41 && d#41 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#42: int :: { Seq#Contains(digits#0, $Box(d#42)) } Seq#Contains(digits#0, $Box(d#42)) ==> LitInt(0) <= d#42 && d#42 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#20: char :: { Seq#Contains(chars#0, $Box(c#20)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#20)) ==> Seq#Contains(chars#0, $Box(c#20))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#36 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#36) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#36), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#36 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#36), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#37 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#37) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#37), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#37 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#37), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#56: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#56))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#56)) } $Is(c#56, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#56)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#56))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#57: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#57))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#57)) } $Is(c#57, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#57)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#57))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#58: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#58))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#58)) } $Is(c#58, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#58)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#58))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(Seq#Contains(chars#0, $l#24#c#0))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, TChar)), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#39: char :: { Map#Domain(digits#0)[$Box(c#39)] } { Seq#Contains(str#0, $Box(c#39)) } $Is(c#39, TChar) && Seq#Contains(str#0, $Box(c#39)) ==> Map#Domain(digits#0)[$Box(c#39)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#39: char :: { Map#Domain(digits#0)[$Box(c#39)] } { Seq#Contains(str#0, $Box(c#39)) } $Is(c#39, TChar) && Seq#Contains(str#0, $Box(c#39)) ==> Map#Domain(digits#0)[$Box(c#39)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#40: char :: { Map#Domain(digits#0)[$Box(c#40)] } { Seq#Contains(str#0, $Box(c#40)) } $Is(c#40, TChar) && Seq#Contains(str#0, $Box(c#40)) ==> Map#Domain(digits#0)[$Box(c#40)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $Box(Map#Domain(digits#0)[$l#77#c#0])), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $IsBox($l#77#c#0, TChar)), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $Box(Map#Domain(digits#0)[$l#77#c#0])), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $IsBox($l#77#c#0, TChar)), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box(Map#Domain(digits#0)[$l#78#c#0])), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, TChar)), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box(Map#Domain(digits#0)[$l#79#c#0])), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, TChar)), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#54 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#54) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#54) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#54)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#54) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#54)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#54 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#54) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#54) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#54)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#54) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#54))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#54 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#54) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#54) else (var tl#108 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#54)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#108)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#54 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#54) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#54) else (var tl#109 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#54)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#109)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#55 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#55) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#55) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#55)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#55) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#55)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#55 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#55) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#55) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#55)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#55) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#55))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#55 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#55) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#55) else (var tl#110 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#55)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#110)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#55 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#55) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#55) else (var tl#111 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#55)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#111)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#56 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#56) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#56) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#56)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#56) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#56)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#56 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#56) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#56) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#56)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#56) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#56))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#56 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#56) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#56) else (var tl#112 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#56)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#112)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#56 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#56) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#56) else (var tl#113 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#56)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#113)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#19: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#19)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#19)) } $Is(c#19, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#19)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#19))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#22#c#0))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, TChar)), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#37: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)] } { Seq#Contains(str#0, $Box(c#37)) } $Is(c#37, TChar) && Seq#Contains(str#0, $Box(c#37)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#37: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)] } { Seq#Contains(str#0, $Box(c#37)) } $Is(c#37, TChar) && Seq#Contains(str#0, $Box(c#37)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#37)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#38: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#38)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#38)] } { Seq#Contains(str#0, $Box(c#38)) } $Is(c#38, TChar) && Seq#Contains(str#0, $Box(c#38)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#38)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#38)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#59#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#59#c#0]): int < base#0)), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, TChar)), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#59#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#59#c#0]): int < base#0)), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, TChar)), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#60#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#60#c#0]): int < base#0)), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, TChar)), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#64 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#64)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#128 := JSON_mErrors.DeserializationError.b(this); (var b0#64 := JSON_mErrors.DeserializationError.expected(this); (var c#128 := (if b#128 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#128)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#64)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#128)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#129 := JSON_mErrors.DeserializationError.b(this); (var bs0#64 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#129 := (if b#129 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#129)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#64 := Seq#Create(TChar, $Heap, Seq#Length(bs0#64), Lit(AtLayer((lambda $l#100#ly#0: LayerType :: Handle1((lambda $l#100#heap#0: Heap, $l#100#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#64, $Unbox($l#100#idx#0): int)): int))), (lambda $l#100#heap#0: Heap, $l#100#idx#0: Box :: $IsBox($l#100#idx#0, TInt) && LitInt(0) <= $Unbox($l#100#idx#0): int && $Unbox($l#100#idx#0): int < Seq#Length(bs0#64)), (lambda $l#100#heap#0: Heap, $l#100#idx#0: Box :: SetRef_to_SetBox((lambda $l#100#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#64), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#129))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#66 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#66)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#132 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#66 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#132 := (if b#132 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#132)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#66)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#132)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#133 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#66 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#133 := (if b#133 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#133)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#66 := Seq#Create(TChar, $Heap, Seq#Length(bs0#66), Lit(AtLayer((lambda $l#103#ly#0: LayerType :: Handle1((lambda $l#103#heap#0: Heap, $l#103#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#66, $Unbox($l#103#idx#0): int)): int))), (lambda $l#103#heap#0: Heap, $l#103#idx#0: Box :: $IsBox($l#103#idx#0, TInt) && LitInt(0) <= $Unbox($l#103#idx#0): int && $Unbox($l#103#idx#0): int < Seq#Length(bs0#66)), (lambda $l#103#heap#0: Heap, $l#103#idx#0: Box :: SetRef_to_SetBox((lambda $l#103#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#66), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#133))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#65 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#65, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#64 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#64, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#64 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#64)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#67 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#67, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#66 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#66, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#66 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#66)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#36: int :: { JSON_mGrammar.__default.Blank_q(b#36) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) } LitInt(0) <= b#36 && b#36 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#36))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#36: int :: { JSON_mGrammar.__default.Blank_q(b#36) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) } LitInt(0) <= b#36 && b#36 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) ==> JSON_mGrammar.__default.Blank_q(b#36))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#37: int :: { JSON_mGrammar.__default.Blank_q(b#37) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#37)) } LitInt(0) <= b#37 && b#37 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#37)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#37))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#37: int :: { JSON_mGrammar.__default.Blank_q(b#37) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#37)) } LitInt(0) <= b#37 && b#37 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#37)) ==> JSON_mGrammar.__default.Blank_q(b#37))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#36: int :: { $Unbox(Seq#Index(s#0, idx#36)): DatatypeType } LitInt(0) <= idx#36 && idx#36 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#36)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#36: int :: { $Unbox(Seq#Index(s#0, idx#36)): DatatypeType } LitInt(0) <= idx#36 && idx#36 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#36)): DatatypeType)) <==> idx#36 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#37: int :: { $Unbox(Seq#Index(s#0, idx#37)): DatatypeType } LitInt(0) <= idx#37 && idx#37 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#37)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#37: int :: { $Unbox(Seq#Index(s#0, idx#37)): DatatypeType } LitInt(0) <= idx#37 && idx#37 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#37)): DatatypeType)) <==> idx#37 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#36: int :: { JSON_mGrammar.__default.Digit_q(b#36) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) } LitInt(0) <= b#36 && b#36 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#36))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#36: int :: { JSON_mGrammar.__default.Digit_q(b#36) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) } LitInt(0) <= b#36 && b#36 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#36)) ==> JSON_mGrammar.__default.Digit_q(b#36))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#37: int :: { JSON_mGrammar.__default.Digit_q(b#37) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#37)) } LitInt(0) <= b#37 && b#37 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#37)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#37))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#37: int :: { JSON_mGrammar.__default.Digit_q(b#37) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#37)) } LitInt(0) <= b#37 && b#37 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#37)) ==> JSON_mGrammar.__default.Digit_q(b#37))));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$14x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$14x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$14x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$14x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$14x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$14x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$14x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$14x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$14x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$14x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$14x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$14x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$14x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#45: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#45) } { Seq#Contains(ts#0, d#45) } $IsBox(d#45, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#45) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#45))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#45: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#45) } { Seq#Contains(ts#0, d#45) } $IsBox(d#45, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#45) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#45))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#46: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#46) } { Seq#Contains(ts#0, d#46) } $IsBox(d#46, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#46) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#46))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#47: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#47) } { Seq#Contains(ts#0, d#47) } $IsBox(d#47, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#47) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#47))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#45: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#45)) } $Is(d#45, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#45) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#45)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#45: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#45)) } $Is(d#45, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#45) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#45)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#46: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#46)) } $Is(d#46, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#46) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#46)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#47: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#47)) } $Is(d#47, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#47) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#47)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$14x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$14x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$14x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$14x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$14x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$14x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$14x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$14x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$14x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$14x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$14x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$14x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$14x#0))): Seq);

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$14x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$14x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$14x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$14x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$14x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$14x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$14x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$14x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$14x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$14x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$14x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$14x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$14x#0))): Seq);

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$14x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$14x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$14x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$14x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$14x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$14x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$14x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$14x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$14x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$14x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$14x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$14x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$14x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#92#d#0: DatatypeType :: $Is($l#92#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#92#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#92#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#93#ly#0, $Unbox($l#93#d#0): DatatypeType))), (lambda $l#93#heap#0: Heap, $l#93#d#0: Box :: $IsBox($l#93#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#93#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#93#heap#0: Heap, $l#93#d#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#91#ly#0, $Unbox($l#91#d#0): DatatypeType))), (lambda $l#91#heap#0: Heap, $l#91#d#0: Box :: $IsBox($l#91#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#91#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#91#heap#0: Heap, $l#91#d#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#95#d#0: DatatypeType :: $Is($l#95#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#95#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#95#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#96#ly#0: LayerType :: Handle1((lambda $l#96#heap#0: Heap, $l#96#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#96#ly#0, $Unbox($l#96#d#0): DatatypeType))), (lambda $l#96#heap#0: Heap, $l#96#d#0: Box :: $IsBox($l#96#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#96#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#96#heap#0: Heap, $l#96#d#0: Box :: SetRef_to_SetBox((lambda $l#96#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#94#ly#0, $Unbox($l#94#d#0): DatatypeType))), (lambda $l#94#heap#0: Heap, $l#94#d#0: Box :: $IsBox($l#94#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#94#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#94#heap#0: Heap, $l#94#d#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#92#d#0: DatatypeType :: $Is($l#92#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#92#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#92#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#93#ly#0, $Unbox($l#93#d#0): DatatypeType))), (lambda $l#93#heap#0: Heap, $l#93#d#0: Box :: $IsBox($l#93#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#93#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#93#heap#0: Heap, $l#93#d#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#91#ly#0, $Unbox($l#91#d#0): DatatypeType))), (lambda $l#91#heap#0: Heap, $l#91#d#0: Box :: $IsBox($l#91#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#91#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#91#heap#0: Heap, $l#91#d#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#95#d#0: DatatypeType :: $Is($l#95#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#95#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#95#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#96#ly#0: LayerType :: Handle1((lambda $l#96#heap#0: Heap, $l#96#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#96#ly#0, $Unbox($l#96#d#0): DatatypeType))), (lambda $l#96#heap#0: Heap, $l#96#d#0: Box :: $IsBox($l#96#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#96#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#96#heap#0: Heap, $l#96#d#0: Box :: SetRef_to_SetBox((lambda $l#96#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#94#ly#0, $Unbox($l#94#d#0): DatatypeType))), (lambda $l#94#heap#0: Heap, $l#94#d#0: Box :: $IsBox($l#94#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#94#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#94#heap#0: Heap, $l#94#d#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#57 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#57))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#57 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#57))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#57 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#57))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#57 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#57))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#57 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#57))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#57 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#57))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#56 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#56)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#56 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#56)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#56 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#56)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#56 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#56)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#56 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#56)) else (var arr#56 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#56))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#59 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#59))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#59 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#59))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#59 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#59))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#59 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#59))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#59 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#59))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#59 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#59))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#58 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#58))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#58 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#58))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#58 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#58))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#58 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#58))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#58 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#58))) else (var arr#58 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#58)))))))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#51: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#51)) } $Is(d#51, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#51) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#51))) && ((forall d#51: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#51)) } $Is(d#51, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#51) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#51))) ==> (forall d#52: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#52)) } $Is(d#52, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#52) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#52)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#51: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#51)) } $Is(d#51, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#51) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#51))) && (forall d#52: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#52)) } $Is(d#52, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#52) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#52))) && (forall d#53: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#53))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#53))): Seq } $Is(d#53, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#53) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#53))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#53))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#54: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#54)) } $Is(d#54, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#54) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#54))) && ((forall d#54: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#54)) } $Is(d#54, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#54) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#54))) ==> (forall d#55: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#55)) } $Is(d#55, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#55) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#55)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#54: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#54)) } $Is(d#54, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#54) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#54))) && (forall d#55: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#55)) } $Is(d#55, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#55) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#55))) && (forall d#56: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#56))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#56))): Seq } $Is(d#56, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#56) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#56))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#56))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#57: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#57)) } $Is(d#57, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#57) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#57))) && ((forall d#57: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#57)) } $Is(d#57, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#57) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#57))) ==> (forall d#58: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#58)) } $Is(d#58, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#58) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#58)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#57: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#57)) } $Is(d#57, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#57) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#57))) && (forall d#58: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#58)) } $Is(d#58, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#58) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#58))) && (forall d#59: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#59))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#59))): Seq } $Is(d#59, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#59) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#59))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#59))): Seq))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#22 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#22)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) && (var cs#23 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#23)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#22 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#22) else (var cs#23 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#23)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#23 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#23)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) && (var cs#24 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#24)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#23 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#23) else (var cs#24 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#24)))))))));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$11x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$11x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$11x#0): int)));

axiom (forall $heap: Heap, $fh$11x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$11x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$11x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$11x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$11x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$11x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$11x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$11x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$11x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$11x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$11x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#17#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#17#heap#0: Heap, $l#17#st#0: Box :: $IsBox($l#17#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#17#heap#0: Heap, $l#17#st#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#91: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#91)) } $Is(cs#91, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#91)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#91: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#91)) } $Is(cs#91, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#91)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#92 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#22 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#92))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#22)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) && (var cs#93 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#93))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#22, cs#92 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#22 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#92))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#22) else (var val#22, cs#93 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#22)): DatatypeType); (var after#22, cs#94 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#93))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#93)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#22, val#22, after#22)), cs#94)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#95: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#95)) } $Is(cs#95, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#95)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#96 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#23 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#96))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#23)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) && (var cs#97 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#97))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#23, cs#96 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#23 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#96))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#23) else (var val#23, cs#97 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#23)): DatatypeType); (var after#23, cs#98 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#97))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#97)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#23, val#23, after#23)), cs#98)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#16#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: $IsBox($l#16#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#16#heap#0: Heap, $l#16#st#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#67 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#67) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#67)) && (var cs#68 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#67))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#68))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#22, cs#67 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#22, cs#68 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#67)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#67))); (var after#22, cs#69 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#68))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#68)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#22, $Box(val#22), after#22)), cs#69)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#70 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#70) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#70)) && (var cs#71 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#70))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#71))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#23, cs#70 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#23, cs#71 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#70)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#70))); (var after#23, cs#72 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#71))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#71)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#23, $Box(val#23), after#23)), cs#72)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#24: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#24) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#24))): Seq } $Is(t#24, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#24)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#24: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#24) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#24))): Seq } $Is(t#24, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#24))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#24)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#25: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#25) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#25))): Seq } $Is(t#25, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#25)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#25: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#25) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#25))): Seq } $Is(t#25, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#25))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#25)))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$5x#0: Box, $fh$5x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$5x#0, $fh$5x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$5x#0, $fh$5x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$5x#0): bool, $Unbox($fh$5x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$5x#0: Box, $fh$5x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$5x#0, $fh$5x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$5x#0, $fh$5x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$5x#0): bool, $Unbox($fh$5x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$5x#0: Box, $fh$5x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$5x#0, $fh$5x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$5x#0, $fh$5x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$5x#0: bool, $fh$5x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$5x#0, $fh$5x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$5x#0, $fh$5x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$5x#0), $Box($fh$5x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#31 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#31) && (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#31); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (var contents#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#20) && (var cs#32 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#20)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#32) && (var valueOrError2#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#32); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#10) else (var lq#10, cs#31 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType); (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#31); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#10) else (var contents#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; (var contents#21, cs#32 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#20))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#20)); (var valueOrError2#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#32); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#10) else (var rq#10, cs#33 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#10, contents#21, rq#10)), cs#33))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#11 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#34 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#34) && (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#34); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (var contents#22 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#22) && (var cs#35 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#22)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#35) && (var valueOrError2#11 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#35); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#11 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#11) else (var lq#11, cs#34 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType)); (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#34); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#11) else (var contents#22 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; (var contents#23, cs#35 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#22))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#22)); (var valueOrError2#11 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#35); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#11) else (var rq#11, cs#36 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#11, contents#23, rq#11)), cs#36))))))))))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jdigits(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$1x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$1x#0) == $Box(JSON_mGrammar.__default.Digit_q($Unbox($fh$1x#0): int)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$1x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$1x#0) <==> JSON_mGrammar.__default.Digit_q#requires($Unbox($fh$1x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: int :: { JSON_mGrammar.__default.Digit_q($fh$1x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Digit_q($fh$1x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $Box($fh$1x#0))): bool);

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(cs#0, JSON_mGrammar.__default.Digit_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), cs#0, JSON_mGrammar.__default.Digit_q#Handle())));

axiom (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(Lit(cs#0), JSON_mGrammar.__default.Digit_q#Handle()) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Digit_q#Handle())) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(true, Lit(cs#0)) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipWhile($LS($LZ), Lit(cs#0), JSON_mGrammar.__default.Digit_q#Handle())));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnum(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) && (var sp#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#2) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#2)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#2 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#2)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#2)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) == (var sp#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); (var valueOrError0#2 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#2)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#2) else #Wrappers.Result.Success($Box(sp#2))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) && (var sp#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(sp#3) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#3 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#3)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) == (var sp#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); (var valueOrError0#3 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#3) else #Wrappers.Result.Success($Box(sp#3))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(cs#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.Peek(cs#0) != char#ToInt(Lit(char#FromInt(48)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(cs#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.Peek(cs#0) != char#ToInt(Lit(char#FromInt(48)))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, cs#0) == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#0));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(Lit(cs#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0)) != char#ToInt(Lit(char#FromInt(48)))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(true, Lit(cs#0)) == JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, Lit(cs#0)));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box($Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.BoundedInts.uint8())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box($Unbox($l#25#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.BoundedInts.uint8())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box($Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.BoundedInts.uint8())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box($Unbox($l#28#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.BoundedInts.uint8())), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box($Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint8())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box($Unbox($l#26#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.BoundedInts.uint8())), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jsign(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal, cs#0), cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign($reveal, cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jsign())));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box($Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.BoundedInts.uint8())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box($Unbox($l#25#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#25#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.BoundedInts.uint8())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box($Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#22#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.BoundedInts.uint8())), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box($Unbox($l#28#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#28#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.BoundedInts.uint8())), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box($Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint8())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box($Unbox($l#26#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#26#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.BoundedInts.uint8())), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box($Unbox($l#26#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.BoundedInts.uint8())), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box($Unbox($l#27#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.BoundedInts.uint8())), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))))) && (var sp#2 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box($Unbox($l#28#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.BoundedInts.uint8())), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))))); JSON_mUtils_mCursors.Split.SP_q(sp#2) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#2)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#2) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#2)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) == (var sp#2 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box($Unbox($l#24#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.BoundedInts.uint8())), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#2)): DatatypeType) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#2)) else #Wrappers.Result.Success($Box(sp#2)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box($Unbox($l#31#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.BoundedInts.uint8())), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))))) && (var sp#3 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box($Unbox($l#33#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.BoundedInts.uint8())), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))))); JSON_mUtils_mCursors.Split.SP_q(sp#3) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#3) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#3)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) == (var sp#3 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box($Unbox($l#29#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.BoundedInts.uint8())), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit($Unbox(JSON_mUtils_mCursors.Split.t(sp#3)): DatatypeType)) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, Lit(JSON_mUtils_mCursors.Split.cs(sp#3))) else #Wrappers.Result.Success($Box(sp#3)))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#31#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#31#heap#0: Heap, $l#31#exp#0: Box :: $IsBox($l#31#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#31#heap#0: Heap, $l#31#exp#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box($Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.BoundedInts.uint8())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box($Unbox($l#35#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#35#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.BoundedInts.uint8())), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))) && (var e#2, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#2) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#7) && (var cs#8 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#7)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#8) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#8); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) == (var e#2, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#2) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#7))) else (var sign#2, cs#8 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#7))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#7)); (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#8); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#2) else (var num#2, cs#9 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#2, sign#2, num#2)))), cs#9))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box($Unbox($l#39#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#39#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.BoundedInts.uint8())), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box($Unbox($l#40#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#40#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.BoundedInts.uint8())), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))))) && (var e#3, cs#10 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#3) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#10) && (var cs#11 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#10)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#11) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#11); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) == (var e#3, cs#10 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#3) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#10))) else (var sign#3, cs#11 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#10))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#10)); (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#11); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#3) else (var num#3, cs#12 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#3, sign#3, num#3)))), cs#12))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#31#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#31#heap#0: Heap, $l#31#frac#0: Box :: $IsBox($l#31#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#31#heap#0: Heap, $l#31#frac#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box($Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.BoundedInts.uint8())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box($Unbox($l#35#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.BoundedInts.uint8())), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))) && (var period#2, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#2) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#5) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) == (var period#2, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#2) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#5))) else (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#2) else (var num#2, cs#6 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#2, num#2)))), cs#6)))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box($Unbox($l#39#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.BoundedInts.uint8())), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box($Unbox($l#40#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.BoundedInts.uint8())), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))))) && (var period#3, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#3) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#7) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) == (var period#3, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#3) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#7))) else (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#7); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#3) else (var num#3, cs#8 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#3, num#3)))), cs#8)))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#14#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#14#heap#0: Heap, $l#14#frac#0: Box :: $IsBox($l#14#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#14#heap#0: Heap, $l#14#frac#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#15#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: $IsBox($l#15#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#15#heap#0: Heap, $l#15#exp#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0) <==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#16#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: $IsBox($l#16#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#17#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#17#heap#0: Heap, $l#17#exp#0: Box :: $IsBox($l#17#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#17#heap#0: Heap, $l#17#exp#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#16#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: $IsBox($l#16#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#16#heap#0: Heap, $l#16#frac#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#17#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#17#heap#0: Heap, $l#17#exp#0: Box :: $IsBox($l#17#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#17#heap#0: Heap, $l#17#exp#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0) == (var sp#3 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0)); sp#3));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), Lit(minus#0), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), Lit(num#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(minus#0))), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), Lit(frac#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(num#0))), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#18#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#18#heap#0: Heap, $l#18#frac#0: Box :: $IsBox($l#18#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#18#heap#0: Heap, $l#18#frac#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Lit(exp#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(frac#0))), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#19#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#19#heap#0: Heap, $l#19#exp#0: Box :: $IsBox($l#19#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#19#heap#0: Heap, $l#19#exp#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(num#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) == (var sp#4 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jnumber.JNumber(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(minus#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(num#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(frac#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(exp#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(exp#0))))); sp#4));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) && (var minus#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); JSON_mUtils_mCursors.Split.SP_q(minus#2) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#2)) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#2)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var num#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#2) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#2)) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#2)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (var frac#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#2) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#2)) && (var valueOrError2#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#2)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) && (var exp#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#2, num#2, frac#2, exp#2))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) == (var minus#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#2) else (var num#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#2) else (var frac#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; (var valueOrError2#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#2)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#2) else (var exp#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#2, num#2, frac#2, exp#2))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) && (var minus#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(minus#3) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#3)) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#3)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var num#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#3) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#3)) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#3)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (var frac#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#3) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#3)) && (var valueOrError2#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#3)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) && (var exp#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), minus#3, num#3, frac#3, exp#3))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) == (var minus#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#3)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#3) else (var num#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#3)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#3) else (var frac#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; (var valueOrError2#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#3)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#3) else (var exp#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, Lit(cs#0), minus#3, num#3, frac#3, exp#3))))))))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#5 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#5));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#6 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#6));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$2x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var k#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#6), p#6) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#6), p#6); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (var colon#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#6) && (var valueOrError2#6 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#6)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) && (var v#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#6, colon#6, v#6))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#6) else (var k#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#6), p#6); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#6) else (var colon#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; (var valueOrError2#6 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#6)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#6) else (var v#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType; (var kv#6 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#6, colon#6, v#6); #Wrappers.Result.Success($Box(kv#6))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var k#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#7), p#7) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#7), p#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (var colon#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#7) && (var valueOrError2#7 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#7)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) && (var v#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#7, colon#7, v#7))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#7) else (var k#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#7), p#7); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#7) else (var colon#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; (var valueOrError2#7 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#7)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#7) else (var v#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType; (var kv#7 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#7, colon#7, v#7); #Wrappers.Result.Success($Box(kv#7))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var k#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (var p#8 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#8) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#8), p#8) && (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#8), p#8); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (var colon#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#8) && (var valueOrError2#8 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#8)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) && (var v#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#8, colon#8, v#8))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#8) else (var k#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (var p#8 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#8), p#8); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#8) else (var colon#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; (var valueOrError2#8 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#8)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#8) else (var v#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType; (var kv#8 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#8, colon#8, v#8); #Wrappers.Result.Success($Box(kv#8))))))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Object($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#2) else (var sp#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(sp#2))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#3) else (var sp#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(sp#3))))));

axiom $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(e#0) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(e#0) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(e#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(e#0) == Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(e#0))));

axiom (forall e#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(Lit(e#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#canCall(Lit(e#0)) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec(Lit(e#0)) == Seq#Append(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0))))));

axiom (forall ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(ts#0) || $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(ts#0) || ($IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));

axiom (forall $Heap: Heap, ts#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#canCall(Lit(ts#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));

axiom (forall ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(ts#0) || $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(ts#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));

axiom (forall $Heap: Heap, ts#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#canCall(Lit(ts#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle()));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) == (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) == (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox($fh$1x#0): Seq)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires($Unbox($fh$1x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$1x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$1x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#3 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#3));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#4 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#4));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#2 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#3 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#2)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#3)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#3 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#4 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#3)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#4)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#2 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#3 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#2)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#3)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))) && (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#3 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#4 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#3)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#4)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#48#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#49#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#49#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var elem#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#3) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#3)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#3)) && (var sep#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#3)); JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) && (var s0#3 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType); (s0#3 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType)) && (s0#3 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#10 := sep#9; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10) && (var elems#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#4)))) && (!(s0#3 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#3 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType)) && (s0#3 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#11 := sep#9; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11) && (var elems'#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#3, sep#11))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#3) else (var elem#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#3)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#3)); (var s0#3 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType); (if s0#3 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#10 := sep#9; (var elems#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#4))) else (if s0#3 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#11 := sep#9; (var elems'#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11); (var bracketed#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#3, sep#11); #Wrappers.Result.Success($Box(bracketed#3))))) else (var separator#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#4 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#3)), s0#3))); pr#4)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#50#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var elem#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#4) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#4)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#4)) && (var sep#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#4)); JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) && (var s0#4 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType); (s0#4 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType)) && (s0#4 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#13 := sep#12; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13) && (var elems#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#5)))) && (!(s0#4 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#4 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType)) && (s0#4 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#14 := sep#12; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14) && (var elems'#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#4, sep#14))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#4) else (var elem#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#4)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#4)); (var s0#4 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType); (if s0#4 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#13 := sep#12; (var elems#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#5))) else (if s0#4 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#14 := sep#12; (var elems'#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14); (var bracketed#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#4, sep#14); #Wrappers.Result.Success($Box(bracketed#4))))) else (var separator#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#5 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#4)), s0#4))); pr#5)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#51#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var elem#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#5) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#5)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#5)) && (var sep#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#5)); JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) && (var s0#5 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType); (s0#5 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType)) && (s0#5 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#16 := sep#15; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16) && (var elems#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#6)))) && (!(s0#5 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#5 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType)) && (s0#5 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#17 := sep#15; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17) && (var elems'#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#5, sep#17))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#5) else (var elem#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#5)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#5)); (var s0#5 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType); (if s0#5 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#16 := sep#15; (var elems#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#6))) else (if s0#5 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#17 := sep#15; (var elems'#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17); (var bracketed#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#5, sep#17); #Wrappers.Result.Success($Box(bracketed#5))))) else (var separator#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#6 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#5)), s0#5))); pr#6)))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var open#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#2) && (var elems#2 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#2)); JSON_mUtils_mCursors.Split.SP_q(open#2) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#2)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#2), p#2) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#2), p#2); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (var close#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#2, elems#2, close#2)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#2, elems#2)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#2) else (var open#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (var elems#2 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#2)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#2), p#2); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#2) else (var close#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#2, elems#2, close#2))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#2, elems#2)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var open#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#3) && (var elems#3 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#3)); JSON_mUtils_mCursors.Split.SP_q(open#3) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#3)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#3), p#3) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#3), p#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (var close#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), open#3, elems#3, close#3)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#3, elems#3)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#3) else (var open#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (var elems#3 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#3)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#3), p#3); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#3) else (var close#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs#0), open#3, elems#3, close#3))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs#0), Lit(json#0), open#3, elems#3)))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Array($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#2) else (var sp#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(sp#2))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#3) else (var sp#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(sp#3))))));

axiom $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(e#0) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(e#0) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType) && JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(e#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(e#0) == Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox(JSON_mGrammar.Suffixed.t(e#0)): DatatypeType), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(e#0))));

axiom (forall e#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(Lit(e#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#canCall(Lit(e#0)) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec(Lit(e#0)) == Seq#Append(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(e#0))): DatatypeType)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0))))));

axiom (forall ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(ts#0) || $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(ts#0) || ($IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));

axiom (forall $Heap: Heap, ts#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#canCall(Lit(ts#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));

axiom (forall ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(ts#0) || $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(ts#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));

axiom (forall $Heap: Heap, ts#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#canCall(Lit(ts#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle()));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) == (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) == (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox($fh$1x#0): Seq)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires($Unbox($fh$1x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$1x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$1x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#3 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#3));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#4 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#4));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#2 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#3 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#2)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#3)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#3 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#4 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#3)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#4)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#2 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#3 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#2)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#3)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))) && (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#3 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#4 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#3)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#4)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#48#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#49#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#49#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var elem#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#3) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#3)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#3)) && (var sep#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#3)); JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) && (var s0#3 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType); (s0#3 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType)) && (s0#3 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#10 := sep#9; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10) && (var elems#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#4)))) && (!(s0#3 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#3 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType)) && (s0#3 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#11 := sep#9; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11) && (var elems'#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#3, sep#11))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#3) else (var elem#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#3)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#3)); (var s0#3 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType); (if s0#3 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#10 := sep#9; (var elems#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#4))) else (if s0#3 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#11 := sep#9; (var elems'#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11); (var bracketed#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#3, sep#11); #Wrappers.Result.Success($Box(bracketed#3))))) else (var separator#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#4 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#3)), s0#3))); pr#4)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#50#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var elem#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#4) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#4)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#4)) && (var sep#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#4)); JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) && (var s0#4 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType); (s0#4 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType)) && (s0#4 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#13 := sep#12; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13) && (var elems#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#5)))) && (!(s0#4 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#4 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType)) && (s0#4 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#14 := sep#12; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14) && (var elems'#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#4, sep#14))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#4) else (var elem#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#4)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#4)); (var s0#4 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType); (if s0#4 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#13 := sep#12; (var elems#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#5))) else (if s0#4 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#14 := sep#12; (var elems'#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14); (var bracketed#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#4, sep#14); #Wrappers.Result.Success($Box(bracketed#4))))) else (var separator#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#5 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#4)), s0#4))); pr#5)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#51#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var elem#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#5) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#5)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#5)) && (var sep#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#5)); JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) && (var s0#5 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType); (s0#5 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType)) && (s0#5 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#16 := sep#15; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16) && (var elems#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#6)))) && (!(s0#5 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#5 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType)) && (s0#5 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#17 := sep#15; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17) && (var elems'#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#5, sep#17))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#5) else (var elem#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#5)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#5)); (var s0#5 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType); (if s0#5 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#16 := sep#15; (var elems#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#6))) else (if s0#5 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#17 := sep#15; (var elems'#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17); (var bracketed#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#5, sep#17); #Wrappers.Result.Success($Box(bracketed#5))))) else (var separator#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#6 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#5)), s0#5))); pr#6)))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var open#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#2) && (var elems#2 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#2)); JSON_mUtils_mCursors.Split.SP_q(open#2) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#2)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#2), p#2) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#2), p#2); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (var close#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#2, elems#2, close#2)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#2, elems#2)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#2) else (var open#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (var elems#2 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#2)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#2), p#2); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#2) else (var close#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#2, elems#2, close#2))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#2, elems#2)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var open#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#3) && (var elems#3 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#3)); JSON_mUtils_mCursors.Split.SP_q(open#3) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#3)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#3), p#3) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#3), p#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (var close#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), open#3, elems#3, close#3)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#3, elems#3)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#3) else (var open#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (var elems#3 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#3)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#3), p#3); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#3) else (var close#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs#0), open#3, elems#3, close#3))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs#0), Lit(json#0), open#3, elems#3)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType)): DatatypeType), expected#0)) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#_v3#0: Box :: $Box(expected#0)), (lambda $l#7#heap#0: Heap, $l#7#_v3#0: Box :: $IsBox($l#7#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#7#heap#0: Heap, $l#7#_v3#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0)) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), Lit(expected#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(expected#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(expected#0), LitInt(0)) && (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) == (var valueOrError0#3 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))))));

const reveal_JSON.ZeroCopy.Deserializer.API._default.JSON: bool;

const reveal_JSON.ZeroCopy.Deserializer.API._default.Text: bool;

const reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes: bool;

const unique class.JSON_mZeroCopy_mDeserializer_mAPI.__default: ClassName;

function JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0) || (0 < $FunctionContextHeight && $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0), Tclass.JSON_mErrors.DeserializationError()));
axiom 0 <= $FunctionContextHeight ==> (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0) || (0 < $FunctionContextHeight && $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(err#0) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(err#0) then (var b#0 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected#0 := JSON_mUtils_mCursors.CursorError.expected(err#0); #JSON.Errors.DeserializationError.ExpectingByte(expected#0, b#0))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(err#0) then (var b#1 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected_sq#0 := JSON_mUtils_mCursors.CursorError.expected__sq(err#0); #JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#0, b#1))) else (var err#1 := $Unbox(JSON_mUtils_mCursors.CursorError.err(err#0)): DatatypeType; err#1)))));
axiom 0 <= $FunctionContextHeight ==> (forall err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(Lit(err#0)) || (0 < $FunctionContextHeight && $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(err#0)) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(err#0)) then (var b#4 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected#2 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingByte(expected#2, b#4)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(err#0)) then (var b#5 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected_sq#2 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#2, b#5)))) else (var err#3 := Lit($Unbox(JSON_mUtils_mCursors.CursorError.err(Lit(err#0))): DatatypeType); err#3)))));
}

function JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires(DatatypeType) : bool;

axiom (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires(err#0) } $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires(err#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.LiftCursorError (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0: DatatypeType where $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



function JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal: bool, cs#0: DatatypeType) : DatatypeType
uses {
axiom 1 <= $FunctionContextHeight ==> (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(cs#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError())));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(cs#0) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && Wrappers.Result.MapFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, cs#0) == Wrappers.Result.MapFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()));
axiom 1 <= $FunctionContextHeight ==> (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(Lit(cs#0)) || (1 < $FunctionContextHeight && $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && Wrappers.Result.MapFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, Lit(cs#0)) == Wrappers.Result.MapFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()));
}

function JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(cs#0: DatatypeType) : bool;

function JSON_mConcreteSyntax_mSpec.__default.JSON#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$0x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$0x#0) <==> JSON_mConcreteSyntax_mSpec.__default.JSON#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON($fh$0x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.JSON($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $Box($fh$0x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#requires(DatatypeType) : bool;

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#requires(cs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#requires(cs#0) <==> true));

axiom (forall $ly: LayerType, $reveal: bool :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($ly), $reveal) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($ly), $reveal) == JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal));

function JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($fuel: LayerType, $reveal: bool) : HandleType;

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $Unbox($fh$0x#0): DatatypeType)));

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires($ly, $Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $reveal: bool, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$0x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $Box($fh$0x#0))): DatatypeType);

axiom (forall $ly: LayerType, $heap: Heap, $fh$15x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$15x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$15x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$15x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$15x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$15x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$15x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$15x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$15x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$15x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$15x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$15x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$15x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$15x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$15x#0))): Seq);

function JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$0x#0) } Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$0x#0) == $Box(JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$0x#0) } Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$0x#0) <==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$0x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$0x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$0x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$0x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $Box($fh$0x#0))): DatatypeType);

procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.JSON (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(cs#0: DatatypeType where $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) returns (pr#0: DatatypeType where $Is(pr#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError())));
  free requires 1 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28746"} Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.API.JSON (well-formedness)"} {:vcs_split_on_every_assert} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##cs#0: DatatypeType;
  var ##parser#0: DatatypeType;
  var ##reWrap#0: HandleType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.API.JSON", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(476,52): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(pr#0);
    assume Wrappers.Result.Success_q(pr#0);
    assume $IsAllocBox(Wrappers.Result.value(pr#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), $Heap);
    assume true;
    ##cs0#0 := cs#0;
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.JSON#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());
    assume JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(pr#0) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Unbox(Wrappers.Result.value(pr#0)): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    assume true;
    assume true;
    ##cs#0 := cs#0;
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $Is(#JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))), Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()));
    ##parser#0 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)));
    assume $IsAlloc(##parser#0, Tclass.JSON_mUtils_mParsers.Parser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(##parser#0), $Box(cs#1)));
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))));
    assume $IsAllocBox($Box(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap);
    assume 0 != $FunctionContextHeight;
    ##reWrap#0 := JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle();
    assume $IsAlloc(##reWrap#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.MapFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle());
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, cs#0) == Wrappers.Result.MapFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle());
    assume JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && Wrappers.Result.MapFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle());
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()));
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, cs#0) == pr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal: bool, v#0: DatatypeType) : DatatypeType
uses {
axiom 2 <= $FunctionContextHeight ==> (forall $reveal: bool, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0))): DatatypeType))) && $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));
axiom 2 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(JSON_mUtils_mCursors.Cursor__.OfView(v#0)) && (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (var cs#0 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#0)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) == (var valueOrError0#0 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#0) else (var text#0, cs#0 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): DatatypeType); (var valueOrError1#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#0), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#0) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#0) else #Wrappers.Result.Success($Box(text#0))))))));
axiom 2 <= $FunctionContextHeight ==> (forall v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(v#0)) || (2 < $FunctionContextHeight && $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))) && (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (var cs#1 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#1), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#1 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#1), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#1)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#1) else (var text#1, cs#1 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): DatatypeType); (var valueOrError1#1 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#1), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#1) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#1) else #Wrappers.Result.Success($Box(text#1))))))));
}

function JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0: DatatypeType) : bool;

function JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#requires(DatatypeType) : bool;

axiom (forall v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#requires(v#0) } $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#requires(v#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.Text (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(v#0: DatatypeType where $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View())) returns (jsr#0: DatatypeType where $Is(jsr#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28759"} Wrappers.Result.Success_q(jsr#0) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.API.Text (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(v#0: DatatypeType) returns (jsr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##v#0: DatatypeType;
  var ##cs#0: DatatypeType;
  var text#Z#0: DatatypeType;
  var cs#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##v#1: DatatypeType;
  var ##cs0#0: DatatypeType;
  var ##spec#0: HandleType;
  var ##js#1: DatatypeType;
  var valueOrError1#Z#0: DatatypeType;
  var let#2#0#0: DatatypeType;
  var ##condition#0: bool;
  var ##error#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.API.Text", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(482,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Wrappers.Result.Success_q(jsr#0);
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    assume Wrappers.Result.Success_q(jsr#0);
    ##js#0 := $Unbox(Wrappers.Result.value(jsr#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType));
    goto anon5;

  anon13_Else:
    assume Wrappers.Result.Success_q(jsr#0) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType));
    goto anon5;

  anon5:
    assume false;
    return;

  anon12_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##v#0 := v#0;
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.OfView(v#0));
    ##cs#0 := JSON_mUtils_mCursors.Cursor__.OfView(v#0);
    assume $IsAlloc(##cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(JSON_mUtils_mCursors.Cursor__.OfView(v#0));
    assume let#0#0#0 == JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0));
    assume JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(JSON_mUtils_mCursors.Cursor__.OfView(v#0));
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon11;

  anon14_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    havoc text#Z#0;
    havoc cs#Z#0;
    assume $Is(text#Z#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(text#Z#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#Z#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume JSON_mUtils_mCursors.Split.SP_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())));
    assume JSON_mUtils_mCursors.Split.SP_q(let#1#0#0);
    assume #JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0) == let#1#0#0;
    assume $IsAllocBox($Box(#JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0)), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), $Heap);
    ##v#1 := v#0;
    assume $IsAlloc(##v#1, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0);
    assume JSON_mUtils_mCursors.Cursor__.Cursor_q(JSON_mUtils_mCursors.Cursor__.OfView(v#0));
    assume true;
    ##cs0#0 := JSON_mUtils_mCursors.Cursor__.OfView(v#0);
    assume $IsAlloc(##cs0#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap);
    ##spec#0 := JSON_mConcreteSyntax_mSpec.__default.JSON#Handle();
    assume $IsAlloc(##spec#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8())), $Heap);
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), #JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0), JSON_mUtils_mCursors.Cursor__.OfView(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());
    assume JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) && JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), #JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0), JSON_mUtils_mCursors.Cursor__.OfView(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());
    assume {:subsumption 0} JSON_mUtils_mCursors.Split.BytesSplitFrom_q#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), #JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0), JSON_mUtils_mCursors.Cursor__.OfView(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON#Handle()) ==> JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), #JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0), JSON_mUtils_mCursors.Cursor__.OfView(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON#Handle()) || Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Cursor__.OfView(v#0)), Seq#Append($Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $Box($Unbox(JSON_mUtils_mCursors.Split.t(#JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0))): DatatypeType))): Seq, JSON_mUtils_mCursors.Cursor__.Bytes(JSON_mUtils_mCursors.Split.cs(#JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0)))));
    assume JSON_mUtils_mCursors.Split.BytesSplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), #JSON.Utils.Cursors.Split.SP($Box(text#Z#0), cs#Z#0), JSON_mUtils_mCursors.Cursor__.OfView(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON#Handle());
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(486,86)"} true;
    assume $IsAllocBox($Box(v#0), Tclass.JSON_mUtils_mViews_mCore.View__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mViews_mCore.View__.Valid_q(v#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0);
    ##js#1 := text#Z#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(text#Z#0);
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#Z#0);
    assume JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(text#Z#0) && JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#Z#0);
    assume Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), Seq#Append(JSON_mConcreteSyntax_mSpec.__default.JSON(text#Z#0), JSON_mUtils_mCursors.Cursor__.Bytes(cs#Z#0)));
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(487,54)"} true;
    havoc valueOrError1#Z#0;
    assume $Is(valueOrError1#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError1#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##condition#0 := JSON_mUtils_mCursors.Cursor__.EOF_q(cs#Z#0);
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Lit(#JSON.Errors.DeserializationError.ExpectingEOF());
    assume $IsAlloc(##error#0, Tclass.JSON_mErrors.DeserializationError(), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF())));
    assume let#2#0#0 == Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF())));
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#Z#0), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF())));
    assume $Is(let#2#0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError1#Z#0 == let#2#0#0;
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(valueOrError1#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError1#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError1#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0) == Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon11;

  anon15_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#Z#0);
    assume $IsAllocBox($Box(cs#Z#0), Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap);
    assume {:subsumption 0} JSON_mUtils_mCursors.Cursor__.Valid_q(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#Z#0);
    assume JSON_mUtils_mCursors.Cursor__.Bytes#canCall(cs#Z#0);
    assume Seq#Equal(JSON_mUtils_mCursors.Cursor__.Bytes(cs#Z#0), Seq#Empty(): Seq);
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(489,29)"} true;
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0) == #Wrappers.Result.Success($Box(text#Z#0));
    assume true;
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon11;

  anon11:
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, v#0) == jsr#0;
    return;
}



function JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal: bool, bs#0: Seq) : DatatypeType
uses {
axiom 3 <= $FunctionContextHeight ==> (forall $reveal: bool, bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) || (3 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0)) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0))): DatatypeType))) && $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));
axiom 3 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) || (3 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#0)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) == (var valueOrError0#0 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#0) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))));
axiom 3 <= $FunctionContextHeight ==> (forall bs#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(Lit(bs#0)) || (3 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#1 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#1)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(bs#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) == (var valueOrError0#1 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#1) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))));
}

function JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0: Seq) : bool;

function JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#requires(bs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.OfBytes (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) returns (jsr#0: DatatypeType where $Is(jsr#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28786"} Wrappers.Result.Success_q(jsr#0) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.Deserializer.API.OfBytes (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(bs#0: Seq) returns (jsr#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##condition#0: bool;
  var ##error#0: DatatypeType;
  var ##bs#0: Seq;
  var ##v#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.API.OfBytes", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/Deserializer.dfy(493,23): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon10_Then, anon10_Else;

  anon10_Then:
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon11_Then, anon11_Else;

  anon11_Then:
    assume Wrappers.Result.Success_q(jsr#0);
    assume Wrappers.Result.Success_q(jsr#0);
    ##js#0 := $Unbox(Wrappers.Result.value(jsr#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType);
    assume Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType));
    goto anon5;

  anon11_Else:
    assume Wrappers.Result.Success_q(jsr#0) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(jsr#0)): DatatypeType));
    goto anon5;

  anon5:
    assume false;
    return;

  anon10_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##condition#0 := Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume $IsAlloc(##condition#0, TBool, $Heap);
    ##error#0 := Lit(#JSON.Errors.DeserializationError.IntOverflow());
    assume $IsAlloc(##error#0, Tclass.JSON_mErrors.DeserializationError(), $Heap);
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow())));
    assume let#0#0#0 == Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow())));
    assume Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow())));
    assume $Is(let#0#0#0, Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon12_Then, anon12_Else;

  anon12_Then:
    assume {:partition} Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.Fail_q(valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0) == Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#Z#0);
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon9;

  anon12_Else:
    assume {:partition} !Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    ##bs#0 := bs#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume {:subsumption 0} Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume Seq#Length(##bs#0) < BoundedInts.__default.TWO__TO__THE__32();
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0);
    assume JSON_mUtils_mViews_mCore.View__.View_q(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0));
    ##v#0 := JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0);
    assume $IsAlloc(##v#0, Tclass.JSON_mUtils_mViews_mCore.View(), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0));
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0) == JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0));
    assume JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0));
    assume $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon9;

  anon9:
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0) == jsr#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_JSON (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__JSON();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_JSON (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__JSON();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_JSON (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__JSON();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.API._default.JSON;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_Text (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__Text();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_Text (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__Text();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_Text (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__Text();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.API._default.Text;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_OfBytes (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__OfBytes();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_OfBytes (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__OfBytes();



procedure {:verboseName "JSON.ZeroCopy.Deserializer.API.reveal_OfBytes (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mDeserializer_mAPI.__default.reveal__OfBytes();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#260 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#260))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#262 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#262)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#390 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#390))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#392 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#392)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#394 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#394)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#390 := Wrappers.Option.value(this); v#390)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#392 := Lit(Wrappers.Option.value(Lit(this))); v#392)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#394 := Lit(Wrappers.Option.value(Lit(this))); v#394)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#260 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#260)) else (var e#260 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#262 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#262))) else (var e#262 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#390 := Wrappers.Result.value(this); s#390) else (var e#390 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#392 := Lit(Wrappers.Result.value(Lit(this))); s#392) else (var e#392 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#394 := Lit(Wrappers.Result.value(Lit(this))); s#394) else (var e#394 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#390 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#390)) else (var e#390 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#390)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#392 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#392))) else (var e#392 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#392)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#394 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#394))) else (var e#394 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#394)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#186: int, y#186: int :: { Mul(x#186, y#186) } Mul(x#186, y#186) == Mul(y#186, x#186)) && (forall x#187: int, y#187: int, z#124: int :: { Mul(x#187 + y#187, z#124) } Mul(x#187 + y#187, z#124) == Mul(x#187, z#124) + Mul(y#187, z#124)) && (forall x#188: int, y#188: int, z#125: int :: { Mul(x#188 - y#188, z#125) } Mul(x#188 - y#188, z#125) == Mul(x#188, z#125) - Mul(y#188, z#125));

axiom MulInternals.__default.MulAuto() <==> (forall x#189: int, y#189: int :: { Mul(x#189, y#189) } Mul(x#189, y#189) == Mul(y#189, x#189)) && (forall x#190: int, y#190: int, z#126: int :: { Mul(x#190 + y#190, z#126) } Mul(x#190 + y#190, z#126) == Mul(x#190, z#126) + Mul(y#190, z#126)) && (forall x#191: int, y#191: int, z#127: int :: { Mul(x#191 - y#191, z#127) } Mul(x#191 - y#191, z#127) == Mul(x#191, z#127) - Mul(y#191, z#127));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#232: int :: { Mod(Mod(x#232, n#0), n#0) } Mod(Mod(x#232, n#0), n#0) == Mod(x#232, n#0)) && (forall x#233: int :: { Mod(x#233, n#0) } LitInt(0) <= x#233 && x#233 < n#0 <==> Mod(x#233, n#0) == x#233) && (forall x#234: int, y#116: int :: { Mod(x#234 + y#116, n#0) } (var z#114 := Mod(x#234, n#0) + Mod(y#116, n#0); (LitInt(0) <= z#114 && z#114 < n#0 && Mod(x#234 + y#116, n#0) == z#114) || (n#0 <= z#114 && z#114 < n#0 + n#0 && Mod(x#234 + y#116, n#0) == z#114 - n#0))) && (forall x#235: int, y#117: int :: { Mod(x#235 - y#117, n#0) } (var z#115 := Mod(x#235, n#0) - Mod(y#117, n#0); (LitInt(0) <= z#115 && z#115 < n#0 && Mod(x#235 - y#117, n#0) == z#115) || (0 - n#0 <= z#115 && z#115 < 0 && Mod(x#235 - y#117, n#0) == z#115 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#236: int :: { Mod(Mod(x#236, n#0), n#0) } Mod(Mod(x#236, LitInt(n#0)), LitInt(n#0)) == Mod(x#236, LitInt(n#0))) && (forall x#237: int :: { Mod(x#237, n#0) } LitInt(0) <= x#237 && x#237 < n#0 <==> Mod(x#237, LitInt(n#0)) == x#237) && (forall x#238: int, y#118: int :: { Mod(x#238 + y#118, n#0) } (var z#116 := Mod(x#238, LitInt(n#0)) + Mod(y#118, LitInt(n#0)); (LitInt(0) <= z#116 && z#116 < n#0 && Mod(x#238 + y#118, LitInt(n#0)) == z#116) || (LitInt(n#0) <= z#116 && z#116 < n#0 + n#0 && Mod(x#238 + y#118, LitInt(n#0)) == z#116 - n#0))) && (forall x#239: int, y#119: int :: { Mod(x#239 - y#119, n#0) } (var z#117 := Mod(x#239, LitInt(n#0)) - Mod(y#119, LitInt(n#0)); (LitInt(0) <= z#117 && z#117 < n#0 && Mod(x#239 - y#119, LitInt(n#0)) == z#117) || (LitInt(0 - n#0) <= z#117 && z#117 < 0 && Mod(x#239 - y#119, LitInt(n#0)) == z#117 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#168: int :: { Div(x#168, n#0) } LitInt(0) <= x#168 && x#168 < n#0 <==> Div(x#168, n#0) == LitInt(0)) && (forall x#169: int, y#112: int :: { Div(x#169 + y#112, n#0) } (var z#110 := Mod(x#169, n#0) + Mod(y#112, n#0); (LitInt(0) <= z#110 && z#110 < n#0 && Div(x#169 + y#112, n#0) == Div(x#169, n#0) + Div(y#112, n#0)) || (n#0 <= z#110 && z#110 < n#0 + n#0 && Div(x#169 + y#112, n#0) == Div(x#169, n#0) + Div(y#112, n#0) + 1))) && (forall x#170: int, y#113: int :: { Div(x#170 - y#113, n#0) } (var z#111 := Mod(x#170, n#0) - Mod(y#113, n#0); (LitInt(0) <= z#111 && z#111 < n#0 && Div(x#170 - y#113, n#0) == Div(x#170, n#0) - Div(y#113, n#0)) || (0 - n#0 <= z#111 && z#111 < 0 && Div(x#170 - y#113, n#0) == Div(x#170, n#0) - Div(y#113, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#171: int :: { Div(x#171, n#0) } LitInt(0) <= x#171 && x#171 < n#0 <==> Div(x#171, LitInt(n#0)) == LitInt(0)) && (forall x#172: int, y#114: int :: { Div(x#172 + y#114, n#0) } (var z#112 := Mod(x#172, LitInt(n#0)) + Mod(y#114, LitInt(n#0)); (LitInt(0) <= z#112 && z#112 < n#0 && Div(x#172 + y#114, LitInt(n#0)) == Div(x#172, LitInt(n#0)) + Div(y#114, LitInt(n#0))) || (LitInt(n#0) <= z#112 && z#112 < n#0 + n#0 && Div(x#172 + y#114, LitInt(n#0)) == Div(x#172, LitInt(n#0)) + Div(y#114, LitInt(n#0)) + 1))) && (forall x#173: int, y#115: int :: { Div(x#173 - y#115, n#0) } (var z#113 := Mod(x#173, LitInt(n#0)) - Mod(y#115, LitInt(n#0)); (LitInt(0) <= z#113 && z#113 < n#0 && Div(x#173 - y#115, LitInt(n#0)) == Div(x#173, LitInt(n#0)) - Div(y#115, LitInt(n#0))) || (LitInt(0 - n#0) <= z#113 && z#113 < 0 && Div(x#173 - y#115, LitInt(n#0)) == Div(x#173, LitInt(n#0)) - Div(y#115, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#44 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#44) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#44)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#44 := lv#0; (var dt_update#end#0#44 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#44), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#44), dt_update#end#0#44))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#45 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#45) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#45)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#45 := Lit(lv#0); (var dt_update#end#0#45 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#45)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#45)), dt_update#end#0#45)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#46: char :: { Seq#Contains(s#0, $Box(c#46)) } $Is(c#46, TChar) && Seq#Contains(s#0, $Box(c#46)) ==> char#ToInt(c#46) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#46: char :: { Seq#Contains(s#0, $Box(c#46)) } $Is(c#46, TChar) && Seq#Contains(s#0, $Box(c#46)) ==> char#ToInt(c#46) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#92#ly#0: LayerType :: Handle1((lambda $l#92#heap#0: Heap, $l#92#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#92#i#0): int)): char))), (lambda $l#92#heap#0: Heap, $l#92#i#0: Box :: $IsBox($l#92#i#0, TInt) && LitInt(0) <= $Unbox($l#92#i#0): int && $Unbox($l#92#i#0): int < Seq#Length(s#0)), (lambda $l#92#heap#0: Heap, $l#92#i#0: Box :: SetRef_to_SetBox((lambda $l#92#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#47: char :: { Seq#Contains(s#0, $Box(c#47)) } $Is(c#47, TChar) && Seq#Contains(s#0, $Box(c#47)) ==> char#ToInt(c#47) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#94#i#0): int)): char))), (lambda $l#94#heap#0: Heap, $l#94#i#0: Box :: $IsBox($l#94#i#0, TInt) && LitInt(0) <= $Unbox($l#94#i#0): int && $Unbox($l#94#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#94#heap#0: Heap, $l#94#i#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#28 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#28))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#28 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#30 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#30))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#30 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#168 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#84 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#168 := (if b#168 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#168)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#84)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#168)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#169 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#84 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#169 := (if b#169 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#169)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#84 := Seq#Create(TChar, $Heap, Seq#Length(bs0#84), Lit(AtLayer((lambda $l#130#ly#0: LayerType :: Handle1((lambda $l#130#heap#0: Heap, $l#130#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#84, $Unbox($l#130#idx#0): int)): int))), (lambda $l#130#heap#0: Heap, $l#130#idx#0: Box :: $IsBox($l#130#idx#0, TInt) && LitInt(0) <= $Unbox($l#130#idx#0): int && $Unbox($l#130#idx#0): int < Seq#Length(bs0#84)), (lambda $l#130#heap#0: Heap, $l#130#idx#0: Box :: SetRef_to_SetBox((lambda $l#130#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#84), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#169))))) else (var err#84 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#84)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#172 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#86 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#172 := (if b#172 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#172)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#86)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#172)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#173 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#86 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#173 := (if b#173 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#173)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#86 := Seq#Create(TChar, $Heap, Seq#Length(bs0#86), Lit(AtLayer((lambda $l#133#ly#0: LayerType :: Handle1((lambda $l#133#heap#0: Heap, $l#133#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#86, $Unbox($l#133#idx#0): int)): int))), (lambda $l#133#heap#0: Heap, $l#133#idx#0: Box :: $IsBox($l#133#idx#0, TInt) && LitInt(0) <= $Unbox($l#133#idx#0): int && $Unbox($l#133#idx#0): int < Seq#Length(bs0#86)), (lambda $l#133#heap#0: Heap, $l#133#idx#0: Box :: SetRef_to_SetBox((lambda $l#133#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#86), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#173))))) else (var err#86 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#86)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#176 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#88 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#176 := (if b#176 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#176)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#88)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#176)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#177 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#88 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#177 := (if b#177 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#177)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#88 := Seq#Create(TChar, $Heap, Seq#Length(bs0#88), Lit(AtLayer((lambda $l#136#ly#0: LayerType :: Handle1((lambda $l#136#heap#0: Heap, $l#136#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#88, $Unbox($l#136#idx#0): int)): int))), (lambda $l#136#heap#0: Heap, $l#136#idx#0: Box :: $IsBox($l#136#idx#0, TInt) && LitInt(0) <= $Unbox($l#136#idx#0): int && $Unbox($l#136#idx#0): int < Seq#Length(bs0#88)), (lambda $l#136#heap#0: Heap, $l#136#idx#0: Box :: SetRef_to_SetBox((lambda $l#136#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#88), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#177))))) else (var err#88 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#88)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#16: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#16)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#16)): int } LitInt(0) <= idx#16 && idx#16 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#16 && idx#16 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#16)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#16)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#28 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#28 := this; (var dt_update#beg#0#28 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#28), dt_update#beg#0#28, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#28), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#28)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#29 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#29 := Lit(this); (var dt_update#beg#0#29 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#29)), dt_update#beg#0#29, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#29)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#29)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#78#v#0): DatatypeType))), (lambda $l#78#heap#0: Heap, $l#78#v#0: Box :: $IsBox($l#78#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#78#heap#0: Heap, $l#78#v#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#79#v#0): DatatypeType))), (lambda $l#79#heap#0: Heap, $l#79#v#0: Box :: $IsBox($l#79#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#79#heap#0: Heap, $l#79#v#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#80#v#0): DatatypeType))), (lambda $l#80#heap#0: Heap, $l#80#v#0: Box :: $IsBox($l#80#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#80#heap#0: Heap, $l#80#v#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#28 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#28 := this; (var dt_update#point#0#28 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#28), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#28), dt_update#point#0#28, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#28)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#29 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#29 := Lit(this); (var dt_update#point#0#29 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#29)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#29)), dt_update#point#0#29, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#29)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#28 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#28)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#28 := this; (var dt_update#point#0#28 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#28), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#28), dt_update#point#0#28, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#28)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#29 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#29)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#29 := Lit(this); (var dt_update#point#0#29 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#29)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#29)), dt_update#point#0#29, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#29)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#28 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#28 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#28 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#28 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#28))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#29 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#29 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#29 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#29 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#29)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#45: int :: { Seq#Contains(bs#0, $Box(b#45)) } LitInt(0) <= b#45 && b#45 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#45)) ==> b#45 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#45: int :: { Seq#Contains(bs#0, $Box(b#45)) } LitInt(0) <= b#45 && b#45 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#45)) ==> b#45 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#42 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#42)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42) && (var ps#42 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#42, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#42 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#42) else (var ps#42 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#42)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#42, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#46: int :: { Seq#Contains(bs#0, $Box(b#46)) } LitInt(0) <= b#46 && b#46 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#46)) ==> b#46 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#43 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#43)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43) && (var ps#43 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#43, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#43 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#43) else (var ps#43 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#43)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#43, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#47: int :: { Seq#Contains(bs#0, $Box(b#47)) } LitInt(0) <= b#47 && b#47 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#47)) ==> b#47 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#44 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#44)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44) && (var ps#44 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#44, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#44 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#44) else (var ps#44 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#44)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#44, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#16: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#16)): int } LitInt(0) <= idx#16 && idx#16 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#16 && idx#16 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#16)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#86 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#86)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#85 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#85)))) else (var st#85 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#85))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#88 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#88)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#87 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#87)))) else (var st#87 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#87))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#90 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#90)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#89 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#89)))) else (var st#89 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#89))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#112#ly#0: LayerType :: Handle1((lambda $l#112#heap#0: Heap, $l#112#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#112#heap#0: Heap, $l#112#_v0#0: Box :: $IsBox($l#112#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#112#heap#0: Heap, $l#112#_v0#0: Box :: SetRef_to_SetBox((lambda $l#112#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#113#ly#0: LayerType :: Handle1((lambda $l#113#heap#0: Heap, $l#113#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#113#heap#0: Heap, $l#113#_v1#0: Box :: $IsBox($l#113#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#113#heap#0: Heap, $l#113#_v1#0: Box :: SetRef_to_SetBox((lambda $l#113#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#116#ly#0: LayerType :: Handle1((lambda $l#116#heap#0: Heap, $l#116#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#116#heap#0: Heap, $l#116#_v0#0: Box :: $IsBox($l#116#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#116#heap#0: Heap, $l#116#_v0#0: Box :: SetRef_to_SetBox((lambda $l#116#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#117#ly#0: LayerType :: Handle1((lambda $l#117#heap#0: Heap, $l#117#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#117#heap#0: Heap, $l#117#_v1#0: Box :: $IsBox($l#117#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#117#heap#0: Heap, $l#117#_v1#0: Box :: SetRef_to_SetBox((lambda $l#117#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#168#ly#0: LayerType :: Handle1((lambda $l#168#heap#0: Heap, $l#168#cs#0: Box :: $Box(Lit(false))), (lambda $l#168#heap#0: Heap, $l#168#cs#0: Box :: $IsBox($l#168#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#168#heap#0: Heap, $l#168#cs#0: Box :: SetRef_to_SetBox((lambda $l#168#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#169#ly#0: LayerType :: Handle1((lambda $l#169#heap#0: Heap, $l#169#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#169#heap#0: Heap, $l#169#cs#0: Box :: $IsBox($l#169#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#169#heap#0: Heap, $l#169#cs#0: Box :: SetRef_to_SetBox((lambda $l#169#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#170#ly#0: LayerType :: Handle1((lambda $l#170#heap#0: Heap, $l#170#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#170#heap#0: Heap, $l#170#_v2#0: Box :: $IsBox($l#170#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#170#heap#0: Heap, $l#170#_v2#0: Box :: SetRef_to_SetBox((lambda $l#170#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#174#ly#0: LayerType :: Handle1((lambda $l#174#heap#0: Heap, $l#174#cs#0: Box :: $Box(Lit(false))), (lambda $l#174#heap#0: Heap, $l#174#cs#0: Box :: $IsBox($l#174#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#174#heap#0: Heap, $l#174#cs#0: Box :: SetRef_to_SetBox((lambda $l#174#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#175#ly#0: LayerType :: Handle1((lambda $l#175#heap#0: Heap, $l#175#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#175#heap#0: Heap, $l#175#cs#0: Box :: $IsBox($l#175#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#175#heap#0: Heap, $l#175#cs#0: Box :: SetRef_to_SetBox((lambda $l#175#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#176#ly#0: LayerType :: Handle1((lambda $l#176#heap#0: Heap, $l#176#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#176#heap#0: Heap, $l#176#_v2#0: Box :: $IsBox($l#176#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#176#heap#0: Heap, $l#176#_v2#0: Box :: SetRef_to_SetBox((lambda $l#176#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#28: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#28))): DatatypeType } $Is(cs'#28, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#28))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#28))): DatatypeType)): DatatypeType, cs'#28, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#28: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#28))): DatatypeType } $Is(cs'#28, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#28))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#28))): DatatypeType)): DatatypeType, cs'#28, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#29: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#29))): DatatypeType } $Is(cs'#29, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType)): DatatypeType, cs'#29, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#29: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#29))): DatatypeType } $Is(cs'#29, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#29))): DatatypeType)): DatatypeType, cs'#29, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#84: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#84)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#84))): bool } $Is(cs'#84, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#84))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#84)))) && ((forall cs'#84: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#84)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#84))): bool } $Is(cs'#84, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#84))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#84))) ==> (forall cs'#85: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#85))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#85, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#85: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#85))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#85, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#85))): bool) ==> (forall cs'#86: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#86))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#86))): bool } $Is(cs'#86, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#86))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#86))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#86))): DatatypeType)): DatatypeType, cs'#86, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#84: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#84)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#84))): bool } $Is(cs'#84, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#84))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#84))) && (forall cs'#85: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#85))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#85, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#85, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#85))): bool) && (forall cs'#86: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#86))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#86))): bool } $Is(cs'#86, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#86))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#86))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#86))): DatatypeType)): DatatypeType, cs'#86, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#87: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#87)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#87))): bool } $Is(cs'#87, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#87))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#87)))) && ((forall cs'#87: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#87)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#87))): bool } $Is(cs'#87, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#87))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#87))) ==> (forall cs'#88: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#88))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#88, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#88, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#88, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#88, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#88: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#88))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#88, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#88, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#88, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#88))): bool) ==> (forall cs'#89: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#89))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#89))): bool } $Is(cs'#89, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#89))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#89))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#89))): DatatypeType)): DatatypeType, cs'#89, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#87: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#87)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#87))): bool } $Is(cs'#87, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#87))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#87))) && (forall cs'#88: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#88))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#88, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#88, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#88, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#88))): bool) && (forall cs'#89: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#89))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#89))): bool } $Is(cs'#89, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#89))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#89))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#89))): DatatypeType)): DatatypeType, cs'#89, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#21: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#21)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#21)) ==> LitInt(0) <= d#21 && d#21 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#57 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#58 := Seq#Append(digits'#57, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#58))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#58 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#59 := Seq#Append(digits'#58, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#59))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#59 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#60 := Seq#Append(digits'#59, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#60))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#21: Box :: { Seq#Contains(chars#0, c#21) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#21) } $IsBox(c#21, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#21) ==> Seq#Contains(chars#0, c#21)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#43: int :: { Seq#Contains(digits#0, $Box(d#43)) } Seq#Contains(digits#0, $Box(d#43)) ==> LitInt(0) <= d#43 && d#43 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#43: int :: { Seq#Contains(digits#0, $Box(d#43)) } Seq#Contains(digits#0, $Box(d#43)) ==> LitInt(0) <= d#43 && d#43 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#44: int :: { Seq#Contains(digits#0, $Box(d#44)) } Seq#Contains(digits#0, $Box(d#44)) ==> LitInt(0) <= d#44 && d#44 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#21: Box :: { Seq#Contains(chars#0, c#21) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#21) } $IsBox(c#21, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#21) ==> Seq#Contains(chars#0, c#21)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#38 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#38) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#38), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#38 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#38), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#39 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#39) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#39), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#39 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#39), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#59: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#59)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#59) } $IsBox(c#59, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#59) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#59)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#60: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#60)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#60) } $IsBox(c#60, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#60) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#60)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#61: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#61)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#61) } $IsBox(c#61, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#61) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#61)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Seq#Contains(chars#0, $l#25#c#0))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#41: Box :: { Map#Domain(digits#0)[c#41] } { Seq#Contains(str#0, c#41) } $IsBox(c#41, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#41) ==> Map#Domain(digits#0)[c#41])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#41: Box :: { Map#Domain(digits#0)[c#41] } { Seq#Contains(str#0, c#41) } $IsBox(c#41, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#41) ==> Map#Domain(digits#0)[c#41])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#42: Box :: { Map#Domain(digits#0)[c#42] } { Seq#Contains(str#0, c#42) } $IsBox(c#42, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#42) ==> Map#Domain(digits#0)[c#42])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box(Map#Domain(digits#0)[$l#81#c#0])), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box(Map#Domain(digits#0)[$l#81#c#0])), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $Box(Map#Domain(digits#0)[$l#82#c#0])), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $IsBox($l#82#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box(Map#Domain(digits#0)[$l#83#c#0])), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#57 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#57) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#57) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#57)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#57) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#57)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#57 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#57) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#57) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#57)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#57) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#57))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#57 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#57) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#57) else (var tl#114 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#57)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#114)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#57 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#57) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#57) else (var tl#115 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#57)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#115)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#58 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#58) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#58) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#58)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#58) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#58)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#58 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#58) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#58) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#58)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#58) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#58))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#58 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#58) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#58) else (var tl#116 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#58)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#116)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#58 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#58) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#58) else (var tl#117 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#58)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#117)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#59 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#59) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#59) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#59)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#59) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#59)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#59 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#59) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#59) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#59)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#59) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#59))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#59 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#59) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#59) else (var tl#118 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#59)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#118)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#59 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#59) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#59) else (var tl#119 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#59)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#119)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#21: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#21)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#21)) ==> LitInt(0) <= d#21 && d#21 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#57 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#58 := Seq#Append(digits'#57, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#58))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#58 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#59 := Seq#Append(digits'#58, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#59))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#59 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#60 := Seq#Append(digits'#59, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#60))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#21: char :: { Seq#Contains(chars#0, $Box(c#21)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#21)) ==> Seq#Contains(chars#0, $Box(c#21))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#43: int :: { Seq#Contains(digits#0, $Box(d#43)) } Seq#Contains(digits#0, $Box(d#43)) ==> LitInt(0) <= d#43 && d#43 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#43: int :: { Seq#Contains(digits#0, $Box(d#43)) } Seq#Contains(digits#0, $Box(d#43)) ==> LitInt(0) <= d#43 && d#43 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#44: int :: { Seq#Contains(digits#0, $Box(d#44)) } Seq#Contains(digits#0, $Box(d#44)) ==> LitInt(0) <= d#44 && d#44 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#21: char :: { Seq#Contains(chars#0, $Box(c#21)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#21)) ==> Seq#Contains(chars#0, $Box(c#21))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#38 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#38) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#38), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#38 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#38), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#39 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#39) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#39), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#39 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#39), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#59: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#59))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#59)) } $Is(c#59, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#59)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#59))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#60: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#60))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#60)) } $Is(c#60, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#60)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#60))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#61: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#61))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#61)) } $Is(c#61, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#61)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#61))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Seq#Contains(chars#0, $l#25#c#0))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar)), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#41: char :: { Map#Domain(digits#0)[$Box(c#41)] } { Seq#Contains(str#0, $Box(c#41)) } $Is(c#41, TChar) && Seq#Contains(str#0, $Box(c#41)) ==> Map#Domain(digits#0)[$Box(c#41)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#41: char :: { Map#Domain(digits#0)[$Box(c#41)] } { Seq#Contains(str#0, $Box(c#41)) } $Is(c#41, TChar) && Seq#Contains(str#0, $Box(c#41)) ==> Map#Domain(digits#0)[$Box(c#41)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#42: char :: { Map#Domain(digits#0)[$Box(c#42)] } { Seq#Contains(str#0, $Box(c#42)) } $Is(c#42, TChar) && Seq#Contains(str#0, $Box(c#42)) ==> Map#Domain(digits#0)[$Box(c#42)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box(Map#Domain(digits#0)[$l#81#c#0])), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, TChar)), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box(Map#Domain(digits#0)[$l#81#c#0])), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, TChar)), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $Box(Map#Domain(digits#0)[$l#82#c#0])), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $IsBox($l#82#c#0, TChar)), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box(Map#Domain(digits#0)[$l#83#c#0])), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, TChar)), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#57 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#57) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#57) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#57)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#57) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#57)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#57 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#57) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#57) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#57)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#57) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#57))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#57 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#57) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#57) else (var tl#114 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#57)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#114)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#57 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#57) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#57) else (var tl#115 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#57)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#115)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#58 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#58) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#58) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#58)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#58) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#58)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#58 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#58) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#58) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#58)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#58) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#58))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#58 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#58) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#58) else (var tl#116 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#58)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#116)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#58 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#58) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#58) else (var tl#117 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#58)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#117)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#59 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#59) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#59) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#59)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#59) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#59)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#59 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#59) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#59) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#59)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#59) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#59))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#59 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#59) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#59) else (var tl#118 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#59)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#118)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#59 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#59) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#59) else (var tl#119 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#59)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#119)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#20: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#20)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#20)) } $Is(c#20, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#20)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#20))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#23#c#0))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, TChar)), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#39: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)] } { Seq#Contains(str#0, $Box(c#39)) } $Is(c#39, TChar) && Seq#Contains(str#0, $Box(c#39)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#39: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)] } { Seq#Contains(str#0, $Box(c#39)) } $Is(c#39, TChar) && Seq#Contains(str#0, $Box(c#39)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#39)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#40: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#40)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#40)] } { Seq#Contains(str#0, $Box(c#40)) } $Is(c#40, TChar) && Seq#Contains(str#0, $Box(c#40)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#40)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#40)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#62#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#62#c#0]): int < base#0)), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, TChar)), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#62#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#62#c#0]): int < base#0)), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, TChar)), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#63#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#63#c#0]): int < base#0)), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, TChar)), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#68 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#68)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#136 := JSON_mErrors.DeserializationError.b(this); (var b0#68 := JSON_mErrors.DeserializationError.expected(this); (var c#136 := (if b#136 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#136)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#68)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#136)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#137 := JSON_mErrors.DeserializationError.b(this); (var bs0#68 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#137 := (if b#137 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#137)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#68 := Seq#Create(TChar, $Heap, Seq#Length(bs0#68), Lit(AtLayer((lambda $l#106#ly#0: LayerType :: Handle1((lambda $l#106#heap#0: Heap, $l#106#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#68, $Unbox($l#106#idx#0): int)): int))), (lambda $l#106#heap#0: Heap, $l#106#idx#0: Box :: $IsBox($l#106#idx#0, TInt) && LitInt(0) <= $Unbox($l#106#idx#0): int && $Unbox($l#106#idx#0): int < Seq#Length(bs0#68)), (lambda $l#106#heap#0: Heap, $l#106#idx#0: Box :: SetRef_to_SetBox((lambda $l#106#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#68), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#137))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#70 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#70)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#140 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#70 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#140 := (if b#140 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#140)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#70)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#140)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#141 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#70 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#141 := (if b#141 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#141)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#70 := Seq#Create(TChar, $Heap, Seq#Length(bs0#70), Lit(AtLayer((lambda $l#109#ly#0: LayerType :: Handle1((lambda $l#109#heap#0: Heap, $l#109#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#70, $Unbox($l#109#idx#0): int)): int))), (lambda $l#109#heap#0: Heap, $l#109#idx#0: Box :: $IsBox($l#109#idx#0, TInt) && LitInt(0) <= $Unbox($l#109#idx#0): int && $Unbox($l#109#idx#0): int < Seq#Length(bs0#70)), (lambda $l#109#heap#0: Heap, $l#109#idx#0: Box :: SetRef_to_SetBox((lambda $l#109#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#70), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#141))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#69 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#69, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#68 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#68, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#68 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#68)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#71 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#71, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#70 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#70, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#70 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#70)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#38: int :: { JSON_mGrammar.__default.Blank_q(b#38) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) } LitInt(0) <= b#38 && b#38 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#38))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#38: int :: { JSON_mGrammar.__default.Blank_q(b#38) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) } LitInt(0) <= b#38 && b#38 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) ==> JSON_mGrammar.__default.Blank_q(b#38))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#39: int :: { JSON_mGrammar.__default.Blank_q(b#39) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#39)) } LitInt(0) <= b#39 && b#39 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#39)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#39))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#39: int :: { JSON_mGrammar.__default.Blank_q(b#39) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#39)) } LitInt(0) <= b#39 && b#39 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#39)) ==> JSON_mGrammar.__default.Blank_q(b#39))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#38: int :: { $Unbox(Seq#Index(s#0, idx#38)): DatatypeType } LitInt(0) <= idx#38 && idx#38 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#38)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#38: int :: { $Unbox(Seq#Index(s#0, idx#38)): DatatypeType } LitInt(0) <= idx#38 && idx#38 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#38)): DatatypeType)) <==> idx#38 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#39: int :: { $Unbox(Seq#Index(s#0, idx#39)): DatatypeType } LitInt(0) <= idx#39 && idx#39 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#39)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#39: int :: { $Unbox(Seq#Index(s#0, idx#39)): DatatypeType } LitInt(0) <= idx#39 && idx#39 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#39)): DatatypeType)) <==> idx#39 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#38: int :: { JSON_mGrammar.__default.Digit_q(b#38) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) } LitInt(0) <= b#38 && b#38 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#38))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#38: int :: { JSON_mGrammar.__default.Digit_q(b#38) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) } LitInt(0) <= b#38 && b#38 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#38)) ==> JSON_mGrammar.__default.Digit_q(b#38))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#39: int :: { JSON_mGrammar.__default.Digit_q(b#39) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#39)) } LitInt(0) <= b#39 && b#39 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#39)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#39))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#39: int :: { JSON_mGrammar.__default.Digit_q(b#39) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#39)) } LitInt(0) <= b#39 && b#39 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#39)) ==> JSON_mGrammar.__default.Digit_q(b#39))));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$15x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$15x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$15x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$15x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$15x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$15x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$15x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$15x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$15x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$15x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$15x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$15x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$15x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#48: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#48) } { Seq#Contains(ts#0, d#48) } $IsBox(d#48, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#48) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#48))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#48: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#48) } { Seq#Contains(ts#0, d#48) } $IsBox(d#48, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#48) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#48))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#49: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#49) } { Seq#Contains(ts#0, d#49) } $IsBox(d#49, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#49) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#49))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#50: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#50) } { Seq#Contains(ts#0, d#50) } $IsBox(d#50, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#50) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#50))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#48: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#48)) } $Is(d#48, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#48) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#48)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#48: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#48)) } $Is(d#48, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#48) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#48)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#49: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#49)) } $Is(d#49, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#49) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#49)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#50: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#50)) } $Is(d#50, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#50) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#50)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$15x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$15x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$15x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$15x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$15x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$15x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$15x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$15x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$15x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$15x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$15x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$15x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$15x#0))): Seq);

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$15x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$15x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$15x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$15x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$15x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$15x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$15x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$15x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$15x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$15x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$15x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$15x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$15x#0))): Seq);

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$15x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$15x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$15x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$15x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$15x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$15x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$15x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$15x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$15x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$15x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$15x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$15x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$15x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#98#d#0: DatatypeType :: $Is($l#98#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#98#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#98#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#99#ly#0: LayerType :: Handle1((lambda $l#99#heap#0: Heap, $l#99#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#99#ly#0, $Unbox($l#99#d#0): DatatypeType))), (lambda $l#99#heap#0: Heap, $l#99#d#0: Box :: $IsBox($l#99#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#99#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#99#heap#0: Heap, $l#99#d#0: Box :: SetRef_to_SetBox((lambda $l#99#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#97#ly#0: LayerType :: Handle1((lambda $l#97#heap#0: Heap, $l#97#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#97#ly#0, $Unbox($l#97#d#0): DatatypeType))), (lambda $l#97#heap#0: Heap, $l#97#d#0: Box :: $IsBox($l#97#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#97#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#97#heap#0: Heap, $l#97#d#0: Box :: SetRef_to_SetBox((lambda $l#97#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#101#d#0: DatatypeType :: $Is($l#101#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#101#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#101#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#102#ly#0: LayerType :: Handle1((lambda $l#102#heap#0: Heap, $l#102#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#102#ly#0, $Unbox($l#102#d#0): DatatypeType))), (lambda $l#102#heap#0: Heap, $l#102#d#0: Box :: $IsBox($l#102#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#102#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#102#heap#0: Heap, $l#102#d#0: Box :: SetRef_to_SetBox((lambda $l#102#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#100#ly#0: LayerType :: Handle1((lambda $l#100#heap#0: Heap, $l#100#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#100#ly#0, $Unbox($l#100#d#0): DatatypeType))), (lambda $l#100#heap#0: Heap, $l#100#d#0: Box :: $IsBox($l#100#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#100#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#100#heap#0: Heap, $l#100#d#0: Box :: SetRef_to_SetBox((lambda $l#100#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#98#d#0: DatatypeType :: $Is($l#98#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#98#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#98#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#99#ly#0: LayerType :: Handle1((lambda $l#99#heap#0: Heap, $l#99#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#99#ly#0, $Unbox($l#99#d#0): DatatypeType))), (lambda $l#99#heap#0: Heap, $l#99#d#0: Box :: $IsBox($l#99#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#99#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#99#heap#0: Heap, $l#99#d#0: Box :: SetRef_to_SetBox((lambda $l#99#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#97#ly#0: LayerType :: Handle1((lambda $l#97#heap#0: Heap, $l#97#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#97#ly#0, $Unbox($l#97#d#0): DatatypeType))), (lambda $l#97#heap#0: Heap, $l#97#d#0: Box :: $IsBox($l#97#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#97#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#97#heap#0: Heap, $l#97#d#0: Box :: SetRef_to_SetBox((lambda $l#97#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#101#d#0: DatatypeType :: $Is($l#101#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#101#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#101#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#102#ly#0: LayerType :: Handle1((lambda $l#102#heap#0: Heap, $l#102#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#102#ly#0, $Unbox($l#102#d#0): DatatypeType))), (lambda $l#102#heap#0: Heap, $l#102#d#0: Box :: $IsBox($l#102#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#102#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#102#heap#0: Heap, $l#102#d#0: Box :: SetRef_to_SetBox((lambda $l#102#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#100#ly#0: LayerType :: Handle1((lambda $l#100#heap#0: Heap, $l#100#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#100#ly#0, $Unbox($l#100#d#0): DatatypeType))), (lambda $l#100#heap#0: Heap, $l#100#d#0: Box :: $IsBox($l#100#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#100#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#100#heap#0: Heap, $l#100#d#0: Box :: SetRef_to_SetBox((lambda $l#100#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#61 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#61))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#61 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#61))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#61 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#61))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#61 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#61))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#61 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#61))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#61 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#61))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#60 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#60)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#60 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#60)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#60 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#60)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#60 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#60)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#60 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#60)) else (var arr#60 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#60))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#63 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#63))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#63 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#63))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#63 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#63))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#63 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#63))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#63 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#63))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#63 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#63))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#62 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#62))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#62 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#62))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#62 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#62))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#62 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#62))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#62 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#62))) else (var arr#62 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#62)))))))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#60: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#60)) } $Is(d#60, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#60) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#60))) && ((forall d#60: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#60)) } $Is(d#60, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#60) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#60))) ==> (forall d#61: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#61)) } $Is(d#61, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#61) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#61)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#60: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#60)) } $Is(d#60, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#60) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#60))) && (forall d#61: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#61)) } $Is(d#61, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#61) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#61))) && (forall d#62: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#62))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#62))): Seq } $Is(d#62, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#62) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#62))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#62))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#63: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#63)) } $Is(d#63, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#63) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#63))) && ((forall d#63: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#63)) } $Is(d#63, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#63) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#63))) ==> (forall d#64: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#64)) } $Is(d#64, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#64) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#64)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#63: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#63)) } $Is(d#63, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#63) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#63))) && (forall d#64: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#64)) } $Is(d#64, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#64) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#64))) && (forall d#65: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#65))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#65))): Seq } $Is(d#65, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#65) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#65))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#65))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#66: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#66)) } $Is(d#66, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#66) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#66))) && ((forall d#66: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#66)) } $Is(d#66, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#66) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#66))) ==> (forall d#67: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#67)) } $Is(d#67, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#67) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#67)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#66: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#66)) } $Is(d#66, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#66) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#66))) && (forall d#67: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#67)) } $Is(d#67, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#67) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#67))) && (forall d#68: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#68))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#68))): Seq } $Is(d#68, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#68) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#68))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#68))): Seq))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#24 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#24)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) && (var cs#25 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#25)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#24 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#24) else (var cs#25 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#25)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#25 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#25)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) && (var cs#26 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#26)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#25 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#25) else (var cs#26 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#26)))))))));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$12x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$12x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$12x#0): int)));

axiom (forall $heap: Heap, $fh$12x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$12x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$12x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$12x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$12x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$12x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$12x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$12x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$12x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$12x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$12x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#18#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#18#heap#0: Heap, $l#18#st#0: Box :: $IsBox($l#18#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#18#heap#0: Heap, $l#18#st#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#99: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#99)) } $Is(cs#99, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#99)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#99: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#99)) } $Is(cs#99, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#99)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#100 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#24 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#100))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#24)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) && (var cs#101 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#101))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#24, cs#100 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#24 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#100))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#24) else (var val#24, cs#101 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#24)): DatatypeType); (var after#24, cs#102 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#101))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#101)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#24, val#24, after#24)), cs#102)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#103: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#103)) } $Is(cs#103, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#103)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#104 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#25 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#104))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#25)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) && (var cs#105 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#105))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#25, cs#104 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#25 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#104))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#25) else (var val#25, cs#105 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#25)): DatatypeType); (var after#25, cs#106 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#105))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#105)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#25, val#25, after#25)), cs#106)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#17#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#st#0: Box :: $IsBox($l#17#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#17#heap#0: Heap, $l#17#st#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#73 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#73) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#73)) && (var cs#74 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#73))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#74))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#24, cs#73 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#24, cs#74 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#73)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#73))); (var after#24, cs#75 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#74))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#74)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#24, $Box(val#24), after#24)), cs#75)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#76 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#76) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#76)) && (var cs#77 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#76))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#77))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#25, cs#76 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#25, cs#77 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#76)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#76))); (var after#25, cs#78 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#77))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#77)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#25, $Box(val#25), after#25)), cs#78)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#26: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#26) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#26))): Seq } $Is(t#26, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#26)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#26: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#26) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#26))): Seq } $Is(t#26, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#26))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#26)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#27: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#27) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#27))): Seq } $Is(t#27, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#27)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#27: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#27) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#27))): Seq } $Is(t#27, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#27))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#27)))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$6x#0: Box, $fh$6x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$6x#0, $fh$6x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$6x#0, $fh$6x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$6x#0): bool, $Unbox($fh$6x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$6x#0: Box, $fh$6x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$6x#0, $fh$6x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$6x#0, $fh$6x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$6x#0): bool, $Unbox($fh$6x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$6x#0: Box, $fh$6x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$6x#0, $fh$6x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$6x#0, $fh$6x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$6x#0: bool, $fh$6x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$6x#0, $fh$6x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$6x#0, $fh$6x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$6x#0), $Box($fh$6x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var cs#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#13)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#12) else (var cs#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#13)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#13 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var cs#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#14)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#13 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#13) else (var cs#14 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#14)))))))));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$6x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$6x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$6x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var cs#37 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#37) && (var valueOrError1#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#37); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) && (var contents#24 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#24) && (var cs#38 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#24)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#38) && (var valueOrError2#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#38); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#12) else (var lq#12, cs#37 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType); (var valueOrError1#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#37); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#12) else (var contents#24 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12)): DatatypeType; (var contents#25, cs#38 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#24))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#24)); (var valueOrError2#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#38); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#12) else (var rq#12, cs#39 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#12, contents#25, rq#12)), cs#39))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#13 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var cs#40 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#40) && (var valueOrError1#13 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#40); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) && (var contents#26 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#26) && (var cs#41 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#26)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#41) && (var valueOrError2#13 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#41); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#13 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#13) else (var lq#13, cs#40 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType)); (var valueOrError1#13 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#40); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#13) else (var contents#26 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13)): DatatypeType; (var contents#27, cs#41 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#26))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#26)); (var valueOrError2#13 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#41); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#13) else (var rq#13, cs#42 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#13, contents#27, rq#13)), cs#42))))))))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$2x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$2x#0) == $Box(JSON_mGrammar.__default.Digit_q($Unbox($fh$2x#0): int)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$2x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$2x#0) <==> JSON_mGrammar.__default.Digit_q#requires($Unbox($fh$2x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: int :: { JSON_mGrammar.__default.Digit_q($fh$2x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Digit_q($fh$2x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $Box($fh$2x#0))): bool);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) && (var sp#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#4) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#4)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#4 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#4)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#4)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) == (var sp#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); (var valueOrError0#4 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#4)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#4) else #Wrappers.Result.Success($Box(sp#4))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) && (var sp#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(sp#5) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#5 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#5)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) == (var sp#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); (var valueOrError0#5 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#5) else #Wrappers.Result.Success($Box(sp#5))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box($Unbox($l#33#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.BoundedInts.uint8())), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box($Unbox($l#30#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.BoundedInts.uint8())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box($Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.BoundedInts.uint8())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box($Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#32#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.BoundedInts.uint8())), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box($Unbox($l#33#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#33#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.BoundedInts.uint8())), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box($Unbox($l#30#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#30#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.BoundedInts.uint8())), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box($Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.BoundedInts.uint8())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box($Unbox($l#36#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.BoundedInts.uint8())), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box($Unbox($l#37#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.BoundedInts.uint8())), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ))))) && (var sp#4 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box($Unbox($l#38#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.BoundedInts.uint8())), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))); JSON_mUtils_mCursors.Split.SP_q(sp#4) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#4)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#4) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#4)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) == (var sp#4 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box($Unbox($l#34#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.BoundedInts.uint8())), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#4)): DatatypeType) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#4)) else #Wrappers.Result.Success($Box(sp#4)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box($Unbox($l#42#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.BoundedInts.uint8())), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ)))))) && (var sp#5 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box($Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint8())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))))))); JSON_mUtils_mCursors.Split.SP_q(sp#5) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#5) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#5)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) == (var sp#5 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box($Unbox($l#39#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.BoundedInts.uint8())), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit($Unbox(JSON_mUtils_mCursors.Split.t(sp#5)): DatatypeType)) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, Lit(JSON_mUtils_mCursors.Split.cs(sp#5))) else #Wrappers.Result.Success($Box(sp#5)))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#42#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#42#heap#0: Heap, $l#42#exp#0: Box :: $IsBox($l#42#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#42#heap#0: Heap, $l#42#exp#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box($Unbox($l#45#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#45#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, Tclass.BoundedInts.uint8())), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box($Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint8())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))) && (var e#4, cs#13 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box($Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.BoundedInts.uint8())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box($Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.BoundedInts.uint8())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#4) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#13) && (var cs#14 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#13)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#14) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#14); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) == (var e#4, cs#13 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box($Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint8())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box($Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint8())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#4) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#13))) else (var sign#4, cs#14 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#13))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#13)); (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#14); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#4) else (var num#4, cs#15 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#4, sign#4, num#4)))), cs#15))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box($Unbox($l#50#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#50#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.BoundedInts.uint8())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box($Unbox($l#51#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#51#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.BoundedInts.uint8())), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))))) && (var e#5, cs#16 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#5) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#16) && (var cs#17 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#16)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#17) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#17); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) == (var e#5, cs#16 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#5) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#16))) else (var sign#5, cs#17 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#16))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#16)); (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#17); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#5) else (var num#5, cs#18 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#5, sign#5, num#5)))), cs#18))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#42#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#42#heap#0: Heap, $l#42#frac#0: Box :: $IsBox($l#42#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#42#heap#0: Heap, $l#42#frac#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box($Unbox($l#45#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, Tclass.BoundedInts.uint8())), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box($Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint8())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))) && (var period#4, cs#9 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box($Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.BoundedInts.uint8())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box($Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.BoundedInts.uint8())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#4) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#9) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#9); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) == (var period#4, cs#9 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box($Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint8())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box($Unbox($l#43#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.BoundedInts.uint8())), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#4) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#9))) else (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#9); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#4) else (var num#4, cs#10 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#4, num#4)))), cs#10)))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box($Unbox($l#50#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.BoundedInts.uint8())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box($Unbox($l#51#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.BoundedInts.uint8())), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))))) && (var period#5, cs#11 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#5) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#11) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#11); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) == (var period#5, cs#11 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#5) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#11))) else (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#11); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#5) else (var num#5, cs#12 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#5, num#5)))), cs#12)))))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Number#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Number($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#20#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#20#heap#0: Heap, $l#20#frac#0: Box :: $IsBox($l#20#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#20#heap#0: Heap, $l#20#frac#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#21#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#21#heap#0: Heap, $l#21#exp#0: Box :: $IsBox($l#21#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#21#heap#0: Heap, $l#21#exp#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0) <==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#22#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#22#heap#0: Heap, $l#22#frac#0: Box :: $IsBox($l#22#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#22#heap#0: Heap, $l#22#frac#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#23#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#23#heap#0: Heap, $l#23#exp#0: Box :: $IsBox($l#23#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#23#heap#0: Heap, $l#23#exp#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#22#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#22#heap#0: Heap, $l#22#frac#0: Box :: $IsBox($l#22#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#22#heap#0: Heap, $l#22#frac#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#23#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#23#heap#0: Heap, $l#23#exp#0: Box :: $IsBox($l#23#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#23#heap#0: Heap, $l#23#exp#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0) == (var sp#5 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0)); sp#5));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), Lit(minus#0), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), Lit(num#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(minus#0))), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), Lit(frac#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(num#0))), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#24#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#24#heap#0: Heap, $l#24#frac#0: Box :: $IsBox($l#24#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#24#heap#0: Heap, $l#24#frac#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Lit(exp#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(frac#0))), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#25#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#25#heap#0: Heap, $l#25#exp#0: Box :: $IsBox($l#25#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#25#heap#0: Heap, $l#25#exp#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(num#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) == (var sp#6 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jnumber.JNumber(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(minus#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(num#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(frac#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(exp#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(exp#0))))); sp#6));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) && (var minus#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); JSON_mUtils_mCursors.Split.SP_q(minus#4) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#4)) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#4)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var num#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#4) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#4)) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#4)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (var frac#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#4) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#4)) && (var valueOrError2#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#4)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) && (var exp#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#4, num#4, frac#4, exp#4))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) == (var minus#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#4)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#4) else (var num#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#4)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#4) else (var frac#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; (var valueOrError2#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#4)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#4) else (var exp#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#4, num#4, frac#4, exp#4))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) && (var minus#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(minus#5) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#5)) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#5)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var num#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#5) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#5)) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#5)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (var frac#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#5) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#5)) && (var valueOrError2#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#5)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) && (var exp#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), minus#5, num#5, frac#5, exp#5))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) == (var minus#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#5)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#5) else (var num#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#5)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#5) else (var frac#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; (var valueOrError2#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#5)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#5) else (var exp#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, Lit(cs#0), minus#5, num#5, frac#5, exp#5))))))))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#7 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#7));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#8 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#8));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$3x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var k#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (var p#9 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#9) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#9), p#9) && (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#9), p#9); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (var colon#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#9) && (var valueOrError2#9 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#9)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) && (var v#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#9, colon#9, v#9))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#9) else (var k#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (var p#9 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#9), p#9); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#9) else (var colon#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; (var valueOrError2#9 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#9)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#9) else (var v#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType; (var kv#9 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#9, colon#9, v#9); #Wrappers.Result.Success($Box(kv#9))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var k#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (var p#10 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#10) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#10), p#10) && (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#10), p#10); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (var colon#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#10) && (var valueOrError2#10 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#10)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) && (var v#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#10, colon#10, v#10))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#10) else (var k#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (var p#10 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#10), p#10); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#10) else (var colon#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; (var valueOrError2#10 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#10)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#10) else (var v#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)): DatatypeType; (var kv#10 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#10, colon#10, v#10); #Wrappers.Result.Success($Box(kv#10))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var k#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (var p#11 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#11) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#11), p#11) && (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#11), p#11); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (var colon#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#11) && (var valueOrError2#11 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#11)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) && (var v#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#11, colon#11, v#11))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#11) else (var k#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (var p#11 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#11), p#11); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#11) else (var colon#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; (var valueOrError2#11 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#11)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#11) else (var v#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)): DatatypeType; (var kv#11 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#11, colon#11, v#11); #Wrappers.Result.Success($Box(kv#11))))))))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Object($ly, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, $Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$2x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $Box($fh$2x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#4) else (var sp#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(sp#4))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#5) else (var sp#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(sp#5))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) == (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) == (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox($fh$2x#0): Seq)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires($Unbox($fh$2x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$2x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$2x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#5 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#5));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#6 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#6));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#4 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#5 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#4)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#5)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#5 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#6 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#5)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#6)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#4 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#5 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#4)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#5)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))) && (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#5 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#6 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#5)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#6)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#52#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#53#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#53#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var elem#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#6) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#6)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#6)) && (var sep#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#6)); JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) && (var s0#6 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType); (s0#6 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType)) && (s0#6 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#19 := sep#18; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19) && (var elems#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#7)))) && (!(s0#6 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#6 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType)) && (s0#6 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#20 := sep#18; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20) && (var elems'#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#6, sep#20))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#6) else (var elem#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#6)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#6)); (var s0#6 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType); (if s0#6 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#19 := sep#18; (var elems#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#7))) else (if s0#6 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#20 := sep#18; (var elems'#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20); (var bracketed#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#6, sep#20); #Wrappers.Result.Success($Box(bracketed#6))))) else (var separator#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#7 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#6)), s0#6))); pr#7)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#54#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var elem#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#7) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#7)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#7)) && (var sep#21 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#7)); JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) && (var s0#7 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType); (s0#7 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType)) && (s0#7 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#22 := sep#21; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22) && (var elems#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#8)))) && (!(s0#7 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#7 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType)) && (s0#7 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#23 := sep#21; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23) && (var elems'#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#7, sep#23))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#7) else (var elem#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#7)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#21 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#7)); (var s0#7 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType); (if s0#7 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#22 := sep#21; (var elems#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#8))) else (if s0#7 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#23 := sep#21; (var elems'#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23); (var bracketed#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#7, sep#23); #Wrappers.Result.Success($Box(bracketed#7))))) else (var separator#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#8 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#7)), s0#7))); pr#8)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#55#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var elem#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#8) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#8)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#8) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#8)) && (var sep#24 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#8)); JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) && (var s0#8 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType); (s0#8 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType)) && (s0#8 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#25 := sep#24; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25) && (var elems#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#9)))) && (!(s0#8 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#8 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType)) && (s0#8 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#26 := sep#24; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26) && (var elems'#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#8, sep#26))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#8) else (var elem#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#8)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#24 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#8)); (var s0#8 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType); (if s0#8 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#25 := sep#24; (var elems#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#9))) else (if s0#8 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#26 := sep#24; (var elems'#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26); (var bracketed#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#8, sep#26); #Wrappers.Result.Success($Box(bracketed#8))))) else (var separator#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#9 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#8)), s0#8))); pr#9)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var open#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#4) && (var elems#4 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#4)); JSON_mUtils_mCursors.Split.SP_q(open#4) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#4)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#4), p#4) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#4), p#4); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (var close#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#4, elems#4, close#4)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#4, elems#4)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#4) else (var open#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (var elems#4 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#4)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#4), p#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#4) else (var close#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#4, elems#4, close#4))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#4, elems#4)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var open#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#5) && (var elems#5 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#5)); JSON_mUtils_mCursors.Split.SP_q(open#5) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#5)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#5), p#5) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#5), p#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (var close#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), open#5, elems#5, close#5)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#5, elems#5)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#5) else (var open#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (var elems#5 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#5)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#5), p#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#5) else (var close#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs#0), open#5, elems#5, close#5))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs#0), Lit(json#0), open#5, elems#5)))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Array($ly, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, $Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$2x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $Box($fh$2x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#4) else (var sp#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(sp#4))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#5) else (var sp#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(sp#5))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) == (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) == (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox($fh$2x#0): Seq)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires($Unbox($fh$2x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$2x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$2x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#5 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#5));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#6 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#6));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#4 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#5 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#4)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#5)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#5 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#6 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#5)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#6)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#4 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#5 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#4)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#5)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))) && (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#5 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#6 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#5)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#6)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#52#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#53#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#53#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var elem#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#6) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#6)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#6)) && (var sep#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#6)); JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) && (var s0#6 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType); (s0#6 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType)) && (s0#6 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#19 := sep#18; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19) && (var elems#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#7)))) && (!(s0#6 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#6 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType)) && (s0#6 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#20 := sep#18; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20) && (var elems'#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#6, sep#20))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#6) else (var elem#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#6)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#6)); (var s0#6 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType); (if s0#6 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#19 := sep#18; (var elems#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#7))) else (if s0#6 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#20 := sep#18; (var elems'#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20); (var bracketed#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#6, sep#20); #Wrappers.Result.Success($Box(bracketed#6))))) else (var separator#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#7 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#6)), s0#6))); pr#7)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#54#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var elem#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#7) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#7)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#7)) && (var sep#21 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#7)); JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) && (var s0#7 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType); (s0#7 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType)) && (s0#7 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#22 := sep#21; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22) && (var elems#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#8)))) && (!(s0#7 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#7 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType)) && (s0#7 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#23 := sep#21; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23) && (var elems'#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#7, sep#23))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#7) else (var elem#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#7)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#21 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#7)); (var s0#7 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType); (if s0#7 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#22 := sep#21; (var elems#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#8))) else (if s0#7 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#23 := sep#21; (var elems'#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23); (var bracketed#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#7, sep#23); #Wrappers.Result.Success($Box(bracketed#7))))) else (var separator#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#8 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#7)), s0#7))); pr#8)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#55#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var elem#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#8) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#8)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#8) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#8)) && (var sep#24 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#8)); JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) && (var s0#8 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType); (s0#8 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType)) && (s0#8 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#25 := sep#24; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25) && (var elems#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#9)))) && (!(s0#8 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#8 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType)) && (s0#8 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#26 := sep#24; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26) && (var elems'#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#8, sep#26))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#8) else (var elem#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#8)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#24 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#8)); (var s0#8 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType); (if s0#8 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#25 := sep#24; (var elems#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#9))) else (if s0#8 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#26 := sep#24; (var elems'#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26); (var bracketed#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#8, sep#26); #Wrappers.Result.Success($Box(bracketed#8))))) else (var separator#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#9 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#8)), s0#8))); pr#9)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var open#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#4) && (var elems#4 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#4)); JSON_mUtils_mCursors.Split.SP_q(open#4) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#4)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#4), p#4) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#4), p#4); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (var close#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#4, elems#4, close#4)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#4, elems#4)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#4) else (var open#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (var elems#4 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#4)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#4), p#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#4) else (var close#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#4, elems#4, close#4))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#4, elems#4)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var open#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#5) && (var elems#5 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#5)); JSON_mUtils_mCursors.Split.SP_q(open#5) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#5)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#5), p#5) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#5), p#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (var close#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), open#5, elems#5, close#5)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#5, elems#5)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#5) else (var open#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (var elems#5 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#5)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#5), p#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#5) else (var close#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs#0), open#5, elems#5, close#5))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs#0), Lit(json#0), open#5, elems#5)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType)): DatatypeType), expected#0)) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#_v3#0: Box :: $Box(expected#0)), (lambda $l#8#heap#0: Heap, $l#8#_v3#0: Box :: $IsBox($l#8#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#8#heap#0: Heap, $l#8#_v3#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0)) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), Lit(expected#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(expected#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(expected#0), LitInt(0)) && (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) == (var valueOrError0#5 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))))));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0) && (var c#2 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (c#2 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)))) && (c#2 != char#ToInt(Lit(char#FromInt(123))) ==> (c#2 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)))) && (c#2 != char#ToInt(Lit(char#FromInt(91))) ==> (c#2 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError2#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)))) && (c#2 != char#ToInt(Lit(char#FromInt(34))) ==> (c#2 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE()) && (var valueOrError3#2 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2)))) && (c#2 != char#ToInt(Lit(char#FromInt(116))) ==> (c#2 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE()) && (var valueOrError4#2 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2)))) && (c#2 != char#ToInt(Lit(char#FromInt(102))) ==> (c#2 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL()) && (var valueOrError5#2 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2)))) && (c#2 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) && (var valueOrError6#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0) == (var c#2 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (if c#2 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#2) else (var obj#2, cs'#14 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType); (var v#6 := #JSON.Grammar.Value.Object(obj#2); (var sp#6 := #JSON.Utils.Cursors.Split.SP($Box(v#6), cs'#14); #Wrappers.Result.Success($Box(sp#6))))))) else (if c#2 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#2) else (var arr#2, cs'#15 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType); (var v#7 := #JSON.Grammar.Value.Array(arr#2); (var sp#7 := #JSON.Utils.Cursors.Split.SP($Box(v#7), cs'#15); #Wrappers.Result.Success($Box(sp#7))))))) else (if c#2 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#2 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#2) else (var str#2, cs'#16 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#2)), cs'#16)))))) else (if c#2 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#2 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#2) else (var cst#6, cs'#17 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#6)), cs'#17)))))) else (if c#2 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#2 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#2) else (var cst#7, cs'#18 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#7)), cs'#18)))))) else (if c#2 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#2 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#2) else (var cst#8, cs'#19 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#2)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#8)), cs'#19)))))) else (var valueOrError6#2 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#2) else (var num#2, cs'#20 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#2)): DatatypeType); (var v#8 := #JSON.Grammar.Value.Number(num#2); (var sp#8 := #JSON.Utils.Cursors.Split.SP($Box(v#8), cs'#20); #Wrappers.Result.Success($Box(sp#8)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(cs#0)) && (var c#3 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (c#3 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)))) && (c#3 != char#ToInt(Lit(char#FromInt(123))) ==> (c#3 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)))) && (c#3 != char#ToInt(Lit(char#FromInt(91))) ==> (c#3 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError2#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)))) && (c#3 != char#ToInt(Lit(char#FromInt(34))) ==> (c#3 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.TRUE()) && (var valueOrError3#3 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3)))) && (c#3 != char#ToInt(Lit(char#FromInt(116))) ==> (c#3 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.FALSE()) && (var valueOrError4#3 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3)))) && (c#3 != char#ToInt(Lit(char#FromInt(102))) ==> (c#3 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.NULL()) && (var valueOrError5#3 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3)))) && (c#3 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) && (var valueOrError6#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)) == (var c#3 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (if c#3 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#3) else (var obj#3, cs'#21 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType); (var v#9 := #JSON.Grammar.Value.Object(obj#3); (var sp#9 := #JSON.Utils.Cursors.Split.SP($Box(v#9), cs'#21); #Wrappers.Result.Success($Box(sp#9))))))) else (if c#3 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#3) else (var arr#3, cs'#22 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType); (var v#10 := #JSON.Grammar.Value.Array(arr#3); (var sp#10 := #JSON.Utils.Cursors.Split.SP($Box(v#10), cs'#22); #Wrappers.Result.Success($Box(sp#10))))))) else (if c#3 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#3 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#3) else (var str#3, cs'#23 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#3)), cs'#23)))))) else (if c#3 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#3 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#3) else (var cst#9, cs'#24 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#9)), cs'#24)))))) else (if c#3 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#3 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#3) else (var cst#10, cs'#25 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#10)), cs'#25)))))) else (if c#3 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#3 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#3) else (var cst#11, cs'#26 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#11)), cs'#26)))))) else (var valueOrError6#3 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#3) else (var num#3, cs'#27 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#3)): DatatypeType); (var v#11 := #JSON.Grammar.Value.Number(num#3); (var sp#11 := #JSON.Utils.Cursors.Split.SP($Box(v#11), cs'#27); #Wrappers.Result.Success($Box(sp#11)))))))))))))));

axiom (forall $ly: LayerType, $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0))) && $Is(JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, $reveal, cs#0), Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#20#ps'#0: DatatypeType :: $Is($l#20#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#20#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0)) && (var pre#2 := Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#23#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#23#heap#0: Heap, $l#23#ps'#0: Box :: $IsBox($l#23#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#23#heap#0: Heap, $l#23#ps'#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $ly)); (forall $l#21#ps'#0: DatatypeType :: $Is($l#21#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#2, $Box($l#21#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#21#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0) == (var pre#2 := Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#18#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#18#heap#0: Heap, $l#18#ps'#0: Box :: $IsBox($l#18#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#18#heap#0: Heap, $l#18#ps'#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $ly)); (var fn#2 := Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#19#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#19#ps'#0): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#ps'#0: Box :: $IsBox($l#19#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#19#heap#0, pre#2, $Box($Unbox($l#19#ps'#0): DatatypeType))): bool), (lambda $l#19#heap#0: Heap, $l#19#ps'#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $ly)); #JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#2, fn#2, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#26#ps'#0: DatatypeType :: $Is($l#26#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#26#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(cs#0))) && (var pre#3 := Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#29#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#29#heap#0: Heap, $l#29#ps'#0: Box :: $IsBox($l#29#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#29#heap#0: Heap, $l#29#ps'#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($ly))); (forall $l#27#ps'#0: DatatypeType :: $Is($l#27#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#3, $Box($l#27#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#27#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)) == (var pre#3 := Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#24#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#24#heap#0: Heap, $l#24#ps'#0: Box :: $IsBox($l#24#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#24#heap#0: Heap, $l#24#ps'#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($ly))); (var fn#3 := Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#25#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#25#ps'#0): DatatypeType))), (lambda $l#25#heap#0: Heap, $l#25#ps'#0: Box :: $IsBox($l#25#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#25#heap#0, pre#3, $Box($Unbox($l#25#ps'#0): DatatypeType))): bool), (lambda $l#25#heap#0: Heap, $l#25#ps'#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($ly))); #JSON.Utils.Parsers.SubParser_.SubParser(Lit(cs#0), pre#3, fn#3, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

const unique class.JSON_mZeroCopy_mDeserializer.__default: ClassName;

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#264 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#264))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#266 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#266)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#396 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#396))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#398 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#398)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#400 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#400)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#396 := Wrappers.Option.value(this); v#396)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#398 := Lit(Wrappers.Option.value(Lit(this))); v#398)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#400 := Lit(Wrappers.Option.value(Lit(this))); v#400)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#264 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#264)) else (var e#264 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#266 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#266))) else (var e#266 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#396 := Wrappers.Result.value(this); s#396) else (var e#396 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#398 := Lit(Wrappers.Result.value(Lit(this))); s#398) else (var e#398 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#400 := Lit(Wrappers.Result.value(Lit(this))); s#400) else (var e#400 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#396 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#396)) else (var e#396 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#396)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#398 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#398))) else (var e#398 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#398)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#400 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#400))) else (var e#400 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#400)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#192: int, y#192: int :: { Mul(x#192, y#192) } Mul(x#192, y#192) == Mul(y#192, x#192)) && (forall x#193: int, y#193: int, z#128: int :: { Mul(x#193 + y#193, z#128) } Mul(x#193 + y#193, z#128) == Mul(x#193, z#128) + Mul(y#193, z#128)) && (forall x#194: int, y#194: int, z#129: int :: { Mul(x#194 - y#194, z#129) } Mul(x#194 - y#194, z#129) == Mul(x#194, z#129) - Mul(y#194, z#129));

axiom MulInternals.__default.MulAuto() <==> (forall x#195: int, y#195: int :: { Mul(x#195, y#195) } Mul(x#195, y#195) == Mul(y#195, x#195)) && (forall x#196: int, y#196: int, z#130: int :: { Mul(x#196 + y#196, z#130) } Mul(x#196 + y#196, z#130) == Mul(x#196, z#130) + Mul(y#196, z#130)) && (forall x#197: int, y#197: int, z#131: int :: { Mul(x#197 - y#197, z#131) } Mul(x#197 - y#197, z#131) == Mul(x#197, z#131) - Mul(y#197, z#131));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#240: int :: { Mod(Mod(x#240, n#0), n#0) } Mod(Mod(x#240, n#0), n#0) == Mod(x#240, n#0)) && (forall x#241: int :: { Mod(x#241, n#0) } LitInt(0) <= x#241 && x#241 < n#0 <==> Mod(x#241, n#0) == x#241) && (forall x#242: int, y#120: int :: { Mod(x#242 + y#120, n#0) } (var z#118 := Mod(x#242, n#0) + Mod(y#120, n#0); (LitInt(0) <= z#118 && z#118 < n#0 && Mod(x#242 + y#120, n#0) == z#118) || (n#0 <= z#118 && z#118 < n#0 + n#0 && Mod(x#242 + y#120, n#0) == z#118 - n#0))) && (forall x#243: int, y#121: int :: { Mod(x#243 - y#121, n#0) } (var z#119 := Mod(x#243, n#0) - Mod(y#121, n#0); (LitInt(0) <= z#119 && z#119 < n#0 && Mod(x#243 - y#121, n#0) == z#119) || (0 - n#0 <= z#119 && z#119 < 0 && Mod(x#243 - y#121, n#0) == z#119 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#244: int :: { Mod(Mod(x#244, n#0), n#0) } Mod(Mod(x#244, LitInt(n#0)), LitInt(n#0)) == Mod(x#244, LitInt(n#0))) && (forall x#245: int :: { Mod(x#245, n#0) } LitInt(0) <= x#245 && x#245 < n#0 <==> Mod(x#245, LitInt(n#0)) == x#245) && (forall x#246: int, y#122: int :: { Mod(x#246 + y#122, n#0) } (var z#120 := Mod(x#246, LitInt(n#0)) + Mod(y#122, LitInt(n#0)); (LitInt(0) <= z#120 && z#120 < n#0 && Mod(x#246 + y#122, LitInt(n#0)) == z#120) || (LitInt(n#0) <= z#120 && z#120 < n#0 + n#0 && Mod(x#246 + y#122, LitInt(n#0)) == z#120 - n#0))) && (forall x#247: int, y#123: int :: { Mod(x#247 - y#123, n#0) } (var z#121 := Mod(x#247, LitInt(n#0)) - Mod(y#123, LitInt(n#0)); (LitInt(0) <= z#121 && z#121 < n#0 && Mod(x#247 - y#123, LitInt(n#0)) == z#121) || (LitInt(0 - n#0) <= z#121 && z#121 < 0 && Mod(x#247 - y#123, LitInt(n#0)) == z#121 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#174: int :: { Div(x#174, n#0) } LitInt(0) <= x#174 && x#174 < n#0 <==> Div(x#174, n#0) == LitInt(0)) && (forall x#175: int, y#116: int :: { Div(x#175 + y#116, n#0) } (var z#114 := Mod(x#175, n#0) + Mod(y#116, n#0); (LitInt(0) <= z#114 && z#114 < n#0 && Div(x#175 + y#116, n#0) == Div(x#175, n#0) + Div(y#116, n#0)) || (n#0 <= z#114 && z#114 < n#0 + n#0 && Div(x#175 + y#116, n#0) == Div(x#175, n#0) + Div(y#116, n#0) + 1))) && (forall x#176: int, y#117: int :: { Div(x#176 - y#117, n#0) } (var z#115 := Mod(x#176, n#0) - Mod(y#117, n#0); (LitInt(0) <= z#115 && z#115 < n#0 && Div(x#176 - y#117, n#0) == Div(x#176, n#0) - Div(y#117, n#0)) || (0 - n#0 <= z#115 && z#115 < 0 && Div(x#176 - y#117, n#0) == Div(x#176, n#0) - Div(y#117, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#177: int :: { Div(x#177, n#0) } LitInt(0) <= x#177 && x#177 < n#0 <==> Div(x#177, LitInt(n#0)) == LitInt(0)) && (forall x#178: int, y#118: int :: { Div(x#178 + y#118, n#0) } (var z#116 := Mod(x#178, LitInt(n#0)) + Mod(y#118, LitInt(n#0)); (LitInt(0) <= z#116 && z#116 < n#0 && Div(x#178 + y#118, LitInt(n#0)) == Div(x#178, LitInt(n#0)) + Div(y#118, LitInt(n#0))) || (LitInt(n#0) <= z#116 && z#116 < n#0 + n#0 && Div(x#178 + y#118, LitInt(n#0)) == Div(x#178, LitInt(n#0)) + Div(y#118, LitInt(n#0)) + 1))) && (forall x#179: int, y#119: int :: { Div(x#179 - y#119, n#0) } (var z#117 := Mod(x#179, LitInt(n#0)) - Mod(y#119, LitInt(n#0)); (LitInt(0) <= z#117 && z#117 < n#0 && Div(x#179 - y#119, LitInt(n#0)) == Div(x#179, LitInt(n#0)) - Div(y#119, LitInt(n#0))) || (LitInt(0 - n#0) <= z#117 && z#117 < 0 && Div(x#179 - y#119, LitInt(n#0)) == Div(x#179, LitInt(n#0)) - Div(y#119, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#46 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#46) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#46)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#46 := lv#0; (var dt_update#end#0#46 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#46), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#46), dt_update#end#0#46))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#47 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#47) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#47)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#47 := Lit(lv#0); (var dt_update#end#0#47 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#47)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#47)), dt_update#end#0#47)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#48: char :: { Seq#Contains(s#0, $Box(c#48)) } $Is(c#48, TChar) && Seq#Contains(s#0, $Box(c#48)) ==> char#ToInt(c#48) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#48: char :: { Seq#Contains(s#0, $Box(c#48)) } $Is(c#48, TChar) && Seq#Contains(s#0, $Box(c#48)) ==> char#ToInt(c#48) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#96#ly#0: LayerType :: Handle1((lambda $l#96#heap#0: Heap, $l#96#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#96#i#0): int)): char))), (lambda $l#96#heap#0: Heap, $l#96#i#0: Box :: $IsBox($l#96#i#0, TInt) && LitInt(0) <= $Unbox($l#96#i#0): int && $Unbox($l#96#i#0): int < Seq#Length(s#0)), (lambda $l#96#heap#0: Heap, $l#96#i#0: Box :: SetRef_to_SetBox((lambda $l#96#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#49: char :: { Seq#Contains(s#0, $Box(c#49)) } $Is(c#49, TChar) && Seq#Contains(s#0, $Box(c#49)) ==> char#ToInt(c#49) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#98#ly#0: LayerType :: Handle1((lambda $l#98#heap#0: Heap, $l#98#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#98#i#0): int)): char))), (lambda $l#98#heap#0: Heap, $l#98#i#0: Box :: $IsBox($l#98#i#0, TInt) && LitInt(0) <= $Unbox($l#98#i#0): int && $Unbox($l#98#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#98#heap#0: Heap, $l#98#i#0: Box :: SetRef_to_SetBox((lambda $l#98#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#32 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#32))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#32 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#34 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#34))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#34 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#180 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#90 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#180 := (if b#180 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#180)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#90)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#180)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#181 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#90 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#181 := (if b#181 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#181)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#90 := Seq#Create(TChar, $Heap, Seq#Length(bs0#90), Lit(AtLayer((lambda $l#139#ly#0: LayerType :: Handle1((lambda $l#139#heap#0: Heap, $l#139#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#90, $Unbox($l#139#idx#0): int)): int))), (lambda $l#139#heap#0: Heap, $l#139#idx#0: Box :: $IsBox($l#139#idx#0, TInt) && LitInt(0) <= $Unbox($l#139#idx#0): int && $Unbox($l#139#idx#0): int < Seq#Length(bs0#90)), (lambda $l#139#heap#0: Heap, $l#139#idx#0: Box :: SetRef_to_SetBox((lambda $l#139#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#90), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#181))))) else (var err#90 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#90)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#184 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#92 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#184 := (if b#184 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#184)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#92)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#184)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#185 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#92 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#185 := (if b#185 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#185)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#92 := Seq#Create(TChar, $Heap, Seq#Length(bs0#92), Lit(AtLayer((lambda $l#142#ly#0: LayerType :: Handle1((lambda $l#142#heap#0: Heap, $l#142#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#92, $Unbox($l#142#idx#0): int)): int))), (lambda $l#142#heap#0: Heap, $l#142#idx#0: Box :: $IsBox($l#142#idx#0, TInt) && LitInt(0) <= $Unbox($l#142#idx#0): int && $Unbox($l#142#idx#0): int < Seq#Length(bs0#92)), (lambda $l#142#heap#0: Heap, $l#142#idx#0: Box :: SetRef_to_SetBox((lambda $l#142#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#92), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#185))))) else (var err#92 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#92)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#188 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#94 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#188 := (if b#188 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#188)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#94)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#188)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#189 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#94 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#189 := (if b#189 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#189)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#94 := Seq#Create(TChar, $Heap, Seq#Length(bs0#94), Lit(AtLayer((lambda $l#145#ly#0: LayerType :: Handle1((lambda $l#145#heap#0: Heap, $l#145#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#94, $Unbox($l#145#idx#0): int)): int))), (lambda $l#145#heap#0: Heap, $l#145#idx#0: Box :: $IsBox($l#145#idx#0, TInt) && LitInt(0) <= $Unbox($l#145#idx#0): int && $Unbox($l#145#idx#0): int < Seq#Length(bs0#94)), (lambda $l#145#heap#0: Heap, $l#145#idx#0: Box :: SetRef_to_SetBox((lambda $l#145#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#94), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#189))))) else (var err#94 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#94)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#17: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#17)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#17)): int } LitInt(0) <= idx#17 && idx#17 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#17 && idx#17 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#17)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#17)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#30 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#30 := this; (var dt_update#beg#0#30 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#30), dt_update#beg#0#30, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#30), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#30)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#31 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#31 := Lit(this); (var dt_update#beg#0#31 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#31)), dt_update#beg#0#31, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#31)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#31)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#81#v#0): DatatypeType))), (lambda $l#81#heap#0: Heap, $l#81#v#0: Box :: $IsBox($l#81#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#81#heap#0: Heap, $l#81#v#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#82#v#0): DatatypeType))), (lambda $l#82#heap#0: Heap, $l#82#v#0: Box :: $IsBox($l#82#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#82#heap#0: Heap, $l#82#v#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#83#v#0): DatatypeType))), (lambda $l#83#heap#0: Heap, $l#83#v#0: Box :: $IsBox($l#83#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#83#heap#0: Heap, $l#83#v#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#30 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#30 := this; (var dt_update#point#0#30 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#30), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#30), dt_update#point#0#30, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#30)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#31 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#31 := Lit(this); (var dt_update#point#0#31 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#31)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#31)), dt_update#point#0#31, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#31)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#30 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#30)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#30 := this; (var dt_update#point#0#30 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#30), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#30), dt_update#point#0#30, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#30)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#31 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#31)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#31 := Lit(this); (var dt_update#point#0#31 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#31)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#31)), dt_update#point#0#31, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#31)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#30 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#30 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#30 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#30 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#30))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#31 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#31 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#31 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#31 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#31)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#48: int :: { Seq#Contains(bs#0, $Box(b#48)) } LitInt(0) <= b#48 && b#48 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#48)) ==> b#48 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#48: int :: { Seq#Contains(bs#0, $Box(b#48)) } LitInt(0) <= b#48 && b#48 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#48)) ==> b#48 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#45 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#45)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45) && (var ps#45 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#45, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#45 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#45) else (var ps#45 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#45)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#45, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#49: int :: { Seq#Contains(bs#0, $Box(b#49)) } LitInt(0) <= b#49 && b#49 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#49)) ==> b#49 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#46 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#46)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46) && (var ps#46 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#46, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#46 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#46) else (var ps#46 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#46)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#46, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#50: int :: { Seq#Contains(bs#0, $Box(b#50)) } LitInt(0) <= b#50 && b#50 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#50)) ==> b#50 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#47 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#47)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47) && (var ps#47 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#47, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#47 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#47) else (var ps#47 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#47)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#47, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#17: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#17)): int } LitInt(0) <= idx#17 && idx#17 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#17 && idx#17 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#17)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#92 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#92)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#91 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#91)))) else (var st#91 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#91))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#94 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#94)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#93 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#93)))) else (var st#93 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#93))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#96 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#96)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#95 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#95)))) else (var st#95 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#95))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#120#ly#0: LayerType :: Handle1((lambda $l#120#heap#0: Heap, $l#120#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#120#heap#0: Heap, $l#120#_v0#0: Box :: $IsBox($l#120#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#120#heap#0: Heap, $l#120#_v0#0: Box :: SetRef_to_SetBox((lambda $l#120#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#121#ly#0: LayerType :: Handle1((lambda $l#121#heap#0: Heap, $l#121#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#121#heap#0: Heap, $l#121#_v1#0: Box :: $IsBox($l#121#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#121#heap#0: Heap, $l#121#_v1#0: Box :: SetRef_to_SetBox((lambda $l#121#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#124#ly#0: LayerType :: Handle1((lambda $l#124#heap#0: Heap, $l#124#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#124#heap#0: Heap, $l#124#_v0#0: Box :: $IsBox($l#124#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#124#heap#0: Heap, $l#124#_v0#0: Box :: SetRef_to_SetBox((lambda $l#124#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#125#ly#0: LayerType :: Handle1((lambda $l#125#heap#0: Heap, $l#125#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#125#heap#0: Heap, $l#125#_v1#0: Box :: $IsBox($l#125#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#125#heap#0: Heap, $l#125#_v1#0: Box :: SetRef_to_SetBox((lambda $l#125#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#180#ly#0: LayerType :: Handle1((lambda $l#180#heap#0: Heap, $l#180#cs#0: Box :: $Box(Lit(false))), (lambda $l#180#heap#0: Heap, $l#180#cs#0: Box :: $IsBox($l#180#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#180#heap#0: Heap, $l#180#cs#0: Box :: SetRef_to_SetBox((lambda $l#180#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#181#ly#0: LayerType :: Handle1((lambda $l#181#heap#0: Heap, $l#181#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#181#heap#0: Heap, $l#181#cs#0: Box :: $IsBox($l#181#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#181#heap#0: Heap, $l#181#cs#0: Box :: SetRef_to_SetBox((lambda $l#181#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#182#ly#0: LayerType :: Handle1((lambda $l#182#heap#0: Heap, $l#182#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#182#heap#0: Heap, $l#182#_v2#0: Box :: $IsBox($l#182#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#182#heap#0: Heap, $l#182#_v2#0: Box :: SetRef_to_SetBox((lambda $l#182#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#186#ly#0: LayerType :: Handle1((lambda $l#186#heap#0: Heap, $l#186#cs#0: Box :: $Box(Lit(false))), (lambda $l#186#heap#0: Heap, $l#186#cs#0: Box :: $IsBox($l#186#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#186#heap#0: Heap, $l#186#cs#0: Box :: SetRef_to_SetBox((lambda $l#186#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#187#ly#0: LayerType :: Handle1((lambda $l#187#heap#0: Heap, $l#187#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#187#heap#0: Heap, $l#187#cs#0: Box :: $IsBox($l#187#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#187#heap#0: Heap, $l#187#cs#0: Box :: SetRef_to_SetBox((lambda $l#187#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#188#ly#0: LayerType :: Handle1((lambda $l#188#heap#0: Heap, $l#188#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#188#heap#0: Heap, $l#188#_v2#0: Box :: $IsBox($l#188#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#188#heap#0: Heap, $l#188#_v2#0: Box :: SetRef_to_SetBox((lambda $l#188#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#30: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#30))): DatatypeType } $Is(cs'#30, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#30))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#30))): DatatypeType)): DatatypeType, cs'#30, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#30: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#30))): DatatypeType } $Is(cs'#30, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#30))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#30))): DatatypeType)): DatatypeType, cs'#30, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#31: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#31))): DatatypeType } $Is(cs'#31, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#31))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#31))): DatatypeType)): DatatypeType, cs'#31, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#31: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#31))): DatatypeType } $Is(cs'#31, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#31))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#31))): DatatypeType)): DatatypeType, cs'#31, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#90: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#90)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#90))): bool } $Is(cs'#90, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#90))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#90)))) && ((forall cs'#90: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#90)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#90))): bool } $Is(cs'#90, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#90))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#90))) ==> (forall cs'#91: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#91))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#91, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#91: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#91))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#91, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#91))): bool) ==> (forall cs'#92: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#92))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#92))): bool } $Is(cs'#92, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#92))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#92))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#92))): DatatypeType)): DatatypeType, cs'#92, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#90: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#90)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#90))): bool } $Is(cs'#90, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#90))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#90))) && (forall cs'#91: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#91))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#91, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#91, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#91))): bool) && (forall cs'#92: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#92))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#92))): bool } $Is(cs'#92, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#92))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#92))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#92))): DatatypeType)): DatatypeType, cs'#92, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#93: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#93)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#93))): bool } $Is(cs'#93, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#93))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#93)))) && ((forall cs'#93: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#93)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#93))): bool } $Is(cs'#93, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#93))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#93))) ==> (forall cs'#94: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#94))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#94, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#94, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#94, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#94, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#94: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#94))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#94, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#94, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#94, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#94))): bool) ==> (forall cs'#95: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#95))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#95))): bool } $Is(cs'#95, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#95))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#95))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#95))): DatatypeType)): DatatypeType, cs'#95, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#93: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#93)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#93))): bool } $Is(cs'#93, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#93))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#93))) && (forall cs'#94: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#94))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#94, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#94, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#94, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#94))): bool) && (forall cs'#95: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#95))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#95))): bool } $Is(cs'#95, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#95))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#95))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#95))): DatatypeType)): DatatypeType, cs'#95, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#22: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#22)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#22)) ==> LitInt(0) <= d#22 && d#22 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#60 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#61 := Seq#Append(digits'#60, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#61))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#61 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#62 := Seq#Append(digits'#61, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#62))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#62 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#63 := Seq#Append(digits'#62, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#63))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#22: Box :: { Seq#Contains(chars#0, c#22) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#22) } $IsBox(c#22, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#22) ==> Seq#Contains(chars#0, c#22)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#45: int :: { Seq#Contains(digits#0, $Box(d#45)) } Seq#Contains(digits#0, $Box(d#45)) ==> LitInt(0) <= d#45 && d#45 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#45: int :: { Seq#Contains(digits#0, $Box(d#45)) } Seq#Contains(digits#0, $Box(d#45)) ==> LitInt(0) <= d#45 && d#45 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#46: int :: { Seq#Contains(digits#0, $Box(d#46)) } Seq#Contains(digits#0, $Box(d#46)) ==> LitInt(0) <= d#46 && d#46 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#22: Box :: { Seq#Contains(chars#0, c#22) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#22) } $IsBox(c#22, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#22) ==> Seq#Contains(chars#0, c#22)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#40 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#40) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#40), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#40 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#40), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#41 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#41) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#41), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#41 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#41), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#62: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#62)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#62) } $IsBox(c#62, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#62) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#62)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#63: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#63)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#63) } $IsBox(c#63, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#63) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#63)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#64: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#64)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#64) } $IsBox(c#64, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#64) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#64)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Seq#Contains(chars#0, $l#26#c#0))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#43: Box :: { Map#Domain(digits#0)[c#43] } { Seq#Contains(str#0, c#43) } $IsBox(c#43, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#43) ==> Map#Domain(digits#0)[c#43])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#43: Box :: { Map#Domain(digits#0)[c#43] } { Seq#Contains(str#0, c#43) } $IsBox(c#43, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#43) ==> Map#Domain(digits#0)[c#43])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#44: Box :: { Map#Domain(digits#0)[c#44] } { Seq#Contains(str#0, c#44) } $IsBox(c#44, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#44) ==> Map#Domain(digits#0)[c#44])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box(Map#Domain(digits#0)[$l#85#c#0])), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box(Map#Domain(digits#0)[$l#85#c#0])), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $Box(Map#Domain(digits#0)[$l#86#c#0])), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $IsBox($l#86#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $Box(Map#Domain(digits#0)[$l#87#c#0])), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $IsBox($l#87#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#60 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#60) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#60) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#60)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#60) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#60)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#60 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#60) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#60) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#60)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#60) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#60))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#60 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#60) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#60) else (var tl#120 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#60)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#120)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#60 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#60) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#60) else (var tl#121 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#60)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#121)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#61 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#61) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#61) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#61)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#61) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#61)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#61 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#61) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#61) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#61)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#61) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#61))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#61 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#61) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#61) else (var tl#122 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#61)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#122)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#61 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#61) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#61) else (var tl#123 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#61)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#123)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#62 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#62) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#62) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#62)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#62) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#62)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#62 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#62) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#62) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#62)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#62) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#62))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#62 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#62) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#62) else (var tl#124 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#62)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#124)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#62 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#62) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#62) else (var tl#125 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#62)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#125)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#22: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#22)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#22)) ==> LitInt(0) <= d#22 && d#22 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#60 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#61 := Seq#Append(digits'#60, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#61))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#61 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#62 := Seq#Append(digits'#61, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#62))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#62 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#63 := Seq#Append(digits'#62, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#63))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#22: char :: { Seq#Contains(chars#0, $Box(c#22)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#22)) ==> Seq#Contains(chars#0, $Box(c#22))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#45: int :: { Seq#Contains(digits#0, $Box(d#45)) } Seq#Contains(digits#0, $Box(d#45)) ==> LitInt(0) <= d#45 && d#45 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#45: int :: { Seq#Contains(digits#0, $Box(d#45)) } Seq#Contains(digits#0, $Box(d#45)) ==> LitInt(0) <= d#45 && d#45 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#46: int :: { Seq#Contains(digits#0, $Box(d#46)) } Seq#Contains(digits#0, $Box(d#46)) ==> LitInt(0) <= d#46 && d#46 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#22: char :: { Seq#Contains(chars#0, $Box(c#22)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#22)) ==> Seq#Contains(chars#0, $Box(c#22))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#40 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#40) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#40), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#40 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#40), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#41 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#41) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#41), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#41 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#41), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#62: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#62))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#62)) } $Is(c#62, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#62)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#62))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#63: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#63))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#63)) } $Is(c#63, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#63)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#63))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#64: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#64))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#64)) } $Is(c#64, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#64)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#64))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Seq#Contains(chars#0, $l#26#c#0))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TChar)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#43: char :: { Map#Domain(digits#0)[$Box(c#43)] } { Seq#Contains(str#0, $Box(c#43)) } $Is(c#43, TChar) && Seq#Contains(str#0, $Box(c#43)) ==> Map#Domain(digits#0)[$Box(c#43)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#43: char :: { Map#Domain(digits#0)[$Box(c#43)] } { Seq#Contains(str#0, $Box(c#43)) } $Is(c#43, TChar) && Seq#Contains(str#0, $Box(c#43)) ==> Map#Domain(digits#0)[$Box(c#43)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#44: char :: { Map#Domain(digits#0)[$Box(c#44)] } { Seq#Contains(str#0, $Box(c#44)) } $Is(c#44, TChar) && Seq#Contains(str#0, $Box(c#44)) ==> Map#Domain(digits#0)[$Box(c#44)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box(Map#Domain(digits#0)[$l#85#c#0])), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, TChar)), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box(Map#Domain(digits#0)[$l#85#c#0])), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, TChar)), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $Box(Map#Domain(digits#0)[$l#86#c#0])), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $IsBox($l#86#c#0, TChar)), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $Box(Map#Domain(digits#0)[$l#87#c#0])), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $IsBox($l#87#c#0, TChar)), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#60 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#60) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#60) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#60)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#60) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#60)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#60 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#60) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#60) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#60)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#60) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#60))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#60 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#60) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#60) else (var tl#120 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#60)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#120)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#60 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#60) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#60) else (var tl#121 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#60)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#121)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#61 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#61) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#61) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#61)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#61) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#61)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#61 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#61) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#61) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#61)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#61) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#61))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#61 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#61) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#61) else (var tl#122 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#61)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#122)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#61 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#61) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#61) else (var tl#123 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#61)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#123)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#62 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#62) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#62) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#62)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#62) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#62)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#62 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#62) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#62) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#62)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#62) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#62))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#62 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#62) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#62) else (var tl#124 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#62)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#124)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#62 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#62) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#62) else (var tl#125 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#62)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#125)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#21: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#21)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#21)) } $Is(c#21, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#21)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#21))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#24#c#0))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, TChar)), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#41: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)] } { Seq#Contains(str#0, $Box(c#41)) } $Is(c#41, TChar) && Seq#Contains(str#0, $Box(c#41)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#41: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)] } { Seq#Contains(str#0, $Box(c#41)) } $Is(c#41, TChar) && Seq#Contains(str#0, $Box(c#41)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#41)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#42: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#42)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#42)] } { Seq#Contains(str#0, $Box(c#42)) } $Is(c#42, TChar) && Seq#Contains(str#0, $Box(c#42)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#42)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#42)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#65#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#65#c#0]): int < base#0)), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, TChar)), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#65#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#65#c#0]): int < base#0)), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, TChar)), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#66#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#66#c#0]): int < base#0)), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, TChar)), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#72 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#72)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#144 := JSON_mErrors.DeserializationError.b(this); (var b0#72 := JSON_mErrors.DeserializationError.expected(this); (var c#144 := (if b#144 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#144)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#72)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#144)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#145 := JSON_mErrors.DeserializationError.b(this); (var bs0#72 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#145 := (if b#145 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#145)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#72 := Seq#Create(TChar, $Heap, Seq#Length(bs0#72), Lit(AtLayer((lambda $l#112#ly#0: LayerType :: Handle1((lambda $l#112#heap#0: Heap, $l#112#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#72, $Unbox($l#112#idx#0): int)): int))), (lambda $l#112#heap#0: Heap, $l#112#idx#0: Box :: $IsBox($l#112#idx#0, TInt) && LitInt(0) <= $Unbox($l#112#idx#0): int && $Unbox($l#112#idx#0): int < Seq#Length(bs0#72)), (lambda $l#112#heap#0: Heap, $l#112#idx#0: Box :: SetRef_to_SetBox((lambda $l#112#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#72), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#145))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#74 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#74)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#148 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#74 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#148 := (if b#148 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#148)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#74)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#148)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#149 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#74 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#149 := (if b#149 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#149)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#74 := Seq#Create(TChar, $Heap, Seq#Length(bs0#74), Lit(AtLayer((lambda $l#115#ly#0: LayerType :: Handle1((lambda $l#115#heap#0: Heap, $l#115#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#74, $Unbox($l#115#idx#0): int)): int))), (lambda $l#115#heap#0: Heap, $l#115#idx#0: Box :: $IsBox($l#115#idx#0, TInt) && LitInt(0) <= $Unbox($l#115#idx#0): int && $Unbox($l#115#idx#0): int < Seq#Length(bs0#74)), (lambda $l#115#heap#0: Heap, $l#115#idx#0: Box :: SetRef_to_SetBox((lambda $l#115#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#74), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#149))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#73 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#73, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#72 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#72, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#72 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#72)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#75 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#75, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#74 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#74, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#74 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#74)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#40: int :: { JSON_mGrammar.__default.Blank_q(b#40) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) } LitInt(0) <= b#40 && b#40 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#40))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#40: int :: { JSON_mGrammar.__default.Blank_q(b#40) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) } LitInt(0) <= b#40 && b#40 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) ==> JSON_mGrammar.__default.Blank_q(b#40))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#41: int :: { JSON_mGrammar.__default.Blank_q(b#41) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#41)) } LitInt(0) <= b#41 && b#41 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#41)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#41))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#41: int :: { JSON_mGrammar.__default.Blank_q(b#41) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#41)) } LitInt(0) <= b#41 && b#41 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#41)) ==> JSON_mGrammar.__default.Blank_q(b#41))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#40: int :: { $Unbox(Seq#Index(s#0, idx#40)): DatatypeType } LitInt(0) <= idx#40 && idx#40 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#40)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#40: int :: { $Unbox(Seq#Index(s#0, idx#40)): DatatypeType } LitInt(0) <= idx#40 && idx#40 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#40)): DatatypeType)) <==> idx#40 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#41: int :: { $Unbox(Seq#Index(s#0, idx#41)): DatatypeType } LitInt(0) <= idx#41 && idx#41 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#41)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#41: int :: { $Unbox(Seq#Index(s#0, idx#41)): DatatypeType } LitInt(0) <= idx#41 && idx#41 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#41)): DatatypeType)) <==> idx#41 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#40: int :: { JSON_mGrammar.__default.Digit_q(b#40) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) } LitInt(0) <= b#40 && b#40 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#40))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#40: int :: { JSON_mGrammar.__default.Digit_q(b#40) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) } LitInt(0) <= b#40 && b#40 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#40)) ==> JSON_mGrammar.__default.Digit_q(b#40))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#41: int :: { JSON_mGrammar.__default.Digit_q(b#41) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#41)) } LitInt(0) <= b#41 && b#41 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#41)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#41))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#41: int :: { JSON_mGrammar.__default.Digit_q(b#41) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#41)) } LitInt(0) <= b#41 && b#41 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#41)) ==> JSON_mGrammar.__default.Digit_q(b#41))));

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$16x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$16x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$16x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$16x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$16x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$16x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$16x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$16x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$16x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$16x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$16x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$16x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$16x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#51: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#51) } { Seq#Contains(ts#0, d#51) } $IsBox(d#51, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#51) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#51))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#51: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#51) } { Seq#Contains(ts#0, d#51) } $IsBox(d#51, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#51) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#51))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#52: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#52) } { Seq#Contains(ts#0, d#52) } $IsBox(d#52, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#52) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#52))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#53: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#53) } { Seq#Contains(ts#0, d#53) } $IsBox(d#53, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#53) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#53))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#51: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#51)) } $Is(d#51, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#51) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#51)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#51: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#51)) } $Is(d#51, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#51) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#51)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#52: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#52)) } $Is(d#52, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#52) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#52)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#53: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#53)) } $Is(d#53, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#53) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#53)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$16x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$16x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$16x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$16x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$16x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$16x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$16x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$16x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$16x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$16x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$16x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$16x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$16x#0))): Seq);

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$16x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$16x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$16x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$16x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$16x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$16x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$16x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$16x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$16x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$16x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$16x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$16x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$16x#0))): Seq);

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$16x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$16x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$16x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$16x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$16x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$16x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$16x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$16x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$16x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$16x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$16x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$16x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$16x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$16x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#104#d#0: DatatypeType :: $Is($l#104#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#104#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#104#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#105#ly#0: LayerType :: Handle1((lambda $l#105#heap#0: Heap, $l#105#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#105#ly#0, $Unbox($l#105#d#0): DatatypeType))), (lambda $l#105#heap#0: Heap, $l#105#d#0: Box :: $IsBox($l#105#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#105#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#105#heap#0: Heap, $l#105#d#0: Box :: SetRef_to_SetBox((lambda $l#105#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#103#ly#0: LayerType :: Handle1((lambda $l#103#heap#0: Heap, $l#103#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#103#ly#0, $Unbox($l#103#d#0): DatatypeType))), (lambda $l#103#heap#0: Heap, $l#103#d#0: Box :: $IsBox($l#103#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#103#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#103#heap#0: Heap, $l#103#d#0: Box :: SetRef_to_SetBox((lambda $l#103#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#107#d#0: DatatypeType :: $Is($l#107#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#107#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#107#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#108#ly#0: LayerType :: Handle1((lambda $l#108#heap#0: Heap, $l#108#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#108#ly#0, $Unbox($l#108#d#0): DatatypeType))), (lambda $l#108#heap#0: Heap, $l#108#d#0: Box :: $IsBox($l#108#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#108#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#108#heap#0: Heap, $l#108#d#0: Box :: SetRef_to_SetBox((lambda $l#108#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#106#ly#0: LayerType :: Handle1((lambda $l#106#heap#0: Heap, $l#106#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#106#ly#0, $Unbox($l#106#d#0): DatatypeType))), (lambda $l#106#heap#0: Heap, $l#106#d#0: Box :: $IsBox($l#106#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#106#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#106#heap#0: Heap, $l#106#d#0: Box :: SetRef_to_SetBox((lambda $l#106#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#104#d#0: DatatypeType :: $Is($l#104#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#104#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#104#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#105#ly#0: LayerType :: Handle1((lambda $l#105#heap#0: Heap, $l#105#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#105#ly#0, $Unbox($l#105#d#0): DatatypeType))), (lambda $l#105#heap#0: Heap, $l#105#d#0: Box :: $IsBox($l#105#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#105#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#105#heap#0: Heap, $l#105#d#0: Box :: SetRef_to_SetBox((lambda $l#105#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#103#ly#0: LayerType :: Handle1((lambda $l#103#heap#0: Heap, $l#103#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#103#ly#0, $Unbox($l#103#d#0): DatatypeType))), (lambda $l#103#heap#0: Heap, $l#103#d#0: Box :: $IsBox($l#103#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#103#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#103#heap#0: Heap, $l#103#d#0: Box :: SetRef_to_SetBox((lambda $l#103#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#107#d#0: DatatypeType :: $Is($l#107#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#107#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#107#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#108#ly#0: LayerType :: Handle1((lambda $l#108#heap#0: Heap, $l#108#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#108#ly#0, $Unbox($l#108#d#0): DatatypeType))), (lambda $l#108#heap#0: Heap, $l#108#d#0: Box :: $IsBox($l#108#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#108#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#108#heap#0: Heap, $l#108#d#0: Box :: SetRef_to_SetBox((lambda $l#108#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#106#ly#0: LayerType :: Handle1((lambda $l#106#heap#0: Heap, $l#106#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#106#ly#0, $Unbox($l#106#d#0): DatatypeType))), (lambda $l#106#heap#0: Heap, $l#106#d#0: Box :: $IsBox($l#106#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#106#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#106#heap#0: Heap, $l#106#d#0: Box :: SetRef_to_SetBox((lambda $l#106#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#65 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#65))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#65 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#65))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#65 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#65))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#65 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#65))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#65 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#65))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#65 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#65))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#64 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#64)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#64 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#64)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#64 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#64)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#64 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#64)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#64 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#64)) else (var arr#64 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#64))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#67 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#67))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#67 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#67))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#67 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#67))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#67 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#67))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#67 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#67))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#67 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#67))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#66 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#66))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#66 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#66))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#66 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#66))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#66 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#66))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#66 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#66))) else (var arr#66 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#66)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$16x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$16x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$16x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$16x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$16x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$16x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$16x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$16x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$16x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$16x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$16x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$16x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$16x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$16x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$16x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#69: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#69)) } $Is(d#69, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#69) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#69))) && ((forall d#69: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#69)) } $Is(d#69, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#69) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#69))) ==> (forall d#70: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#70)) } $Is(d#70, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#70) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#70)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#69: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#69)) } $Is(d#69, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#69) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#69))) && (forall d#70: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#70)) } $Is(d#70, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#70) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#70))) && (forall d#71: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#71))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#71))): Seq } $Is(d#71, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#71) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#71))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#71))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#72: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#72)) } $Is(d#72, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#72) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#72))) && ((forall d#72: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#72)) } $Is(d#72, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#72) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#72))) ==> (forall d#73: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#73)) } $Is(d#73, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#73) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#73)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#72: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#72)) } $Is(d#72, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#72) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#72))) && (forall d#73: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#73)) } $Is(d#73, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#73) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#73))) && (forall d#74: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#74))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#74))): Seq } $Is(d#74, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#74) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#74))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#74))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#75: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#75)) } $Is(d#75, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#75) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#75))) && ((forall d#75: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#75)) } $Is(d#75, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#75) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#75))) ==> (forall d#76: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#76)) } $Is(d#76, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#76) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#76)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#75: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#75)) } $Is(d#75, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#75) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#75))) && (forall d#76: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#76)) } $Is(d#76, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#76) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#76))) && (forall d#77: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#77))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#77))): Seq } $Is(d#77, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#77) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#77))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#77))): Seq))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#26 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#26)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) && (var cs#27 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#27)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#26 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#26) else (var cs#27 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#27)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#27 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#27)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) && (var cs#28 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#28)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#27 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#27) else (var cs#28 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#28)))))))));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$13x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$13x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$13x#0): int)));

axiom (forall $heap: Heap, $fh$13x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$13x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$13x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$13x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$13x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$13x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$13x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$13x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$13x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$13x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$13x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#19#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#19#heap#0: Heap, $l#19#st#0: Box :: $IsBox($l#19#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#19#heap#0: Heap, $l#19#st#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#107: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#107)) } $Is(cs#107, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#107)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#107: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#107)) } $Is(cs#107, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#107)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#108 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#26 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#108))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#26)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) && (var cs#109 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#109))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#26, cs#108 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#26 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#108))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#26) else (var val#26, cs#109 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#26)): DatatypeType); (var after#26, cs#110 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#109))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#109)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#26, val#26, after#26)), cs#110)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#111: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#111)) } $Is(cs#111, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#111)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#112 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#27 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#112))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#27)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) && (var cs#113 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#113))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#27, cs#112 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#27 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#112))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#27) else (var val#27, cs#113 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#27)): DatatypeType); (var after#27, cs#114 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#113))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#113)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#27, val#27, after#27)), cs#114)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#18#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#st#0: Box :: $IsBox($l#18#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#18#heap#0: Heap, $l#18#st#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#79 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#79) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#79)) && (var cs#80 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#79))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#80))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#26, cs#79 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#26, cs#80 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#79)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#79))); (var after#26, cs#81 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#80))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#80)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#26, $Box(val#26), after#26)), cs#81)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#82 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#82) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#82)) && (var cs#83 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#82))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#83))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#27, cs#82 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#27, cs#83 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#82)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#82))); (var after#27, cs#84 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#83))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#83)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#27, $Box(val#27), after#27)), cs#84)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#28: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#28) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#28))): Seq } $Is(t#28, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#28)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#28: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#28) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#28))): Seq } $Is(t#28, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#28))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#28)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#29: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#29) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#29))): Seq } $Is(t#29, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#29)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#29: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#29) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#29))): Seq } $Is(t#29, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#29))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#29)))));

axiom $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.OPEN(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.CLOSE(), Tclass.BoundedInts.uint8(), $h));

axiom (forall t#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec(t#0) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#canCall(t#0) || $IsBox(t#0, Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec(t#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$1x#0)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires($fh$1x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$1x#0)): Seq);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.Element(cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0) == $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$2x#0)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0) <==> JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires($fh$2x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$2x#0)): Seq);

axiom $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(), Tclass.BoundedInts.uint8(), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen(), Tclass._System.___hTotalFunc1(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), TSeq(Tclass.BoundedInts.uint8())), $h));

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(e#0) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall e#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(e#0) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(JSON_mGrammar.Suffixed.t(e#0)) && JSON_mGrammar.Suffixed.Suffixed_q(e#0) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(JSON_mGrammar.Suffixed.suffix(e#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(e#0) == Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(JSON_mGrammar.Suffixed.t(e#0)), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(JSON_mGrammar.Suffixed.suffix(e#0))));

axiom (forall e#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(Lit(e#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#canCall(Lit(e#0)) || $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#canCall(Lit(JSON_mGrammar.Suffixed.t(Lit(e#0)))) && JSON_mGrammar.Suffixed.Suffixed_q(Lit(e#0)) && JSON_mConcreteSyntax_mSpec.__default.CommaSuffix#canCall(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec(Lit(e#0)) == Seq#Append(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec(Lit(JSON_mGrammar.Suffixed.t(Lit(e#0)))), JSON_mConcreteSyntax_mSpec.__default.CommaSuffix(Lit(JSON_mGrammar.Suffixed.suffix(Lit(e#0))))));

axiom (forall ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(ts#0) || $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $Heap: Heap, ts#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(ts#0) || ($IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));

axiom (forall $Heap: Heap, ts#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#canCall(Lit(ts#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));

axiom (forall ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(ts#0) || $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))) ==> $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $Heap: Heap, ts#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(ts#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(ts#0) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), ts#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));

axiom (forall $Heap: Heap, ts#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Lit(ts#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#canCall(Lit(ts#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()) && JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec(Lit(ts#0)) == JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), Lit(ts#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle()));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) == (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#3)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) == (var valueOrError0#2 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var cs#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#3)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#4)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) == (var valueOrError0#3 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var cs#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#4)))))));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox($fh$1x#0): Seq)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires($Unbox($fh$1x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$1x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$1x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#3 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#3));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#4 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#4));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#7#ly#0: LayerType :: Handle1((lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#7#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: $IsBox($l#7#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#7#heap#0: Heap, $l#7#c#0: Box :: SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#8#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#2 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#3 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#2)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#3)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#9#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: $IsBox($l#9#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#9#heap#0: Heap, $l#9#c#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#3 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#4 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#3)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#4)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))) && (forall e#4: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#4) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) } $Is(e#4, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#4)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#4)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#2 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#3 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#2)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#3)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ))))) && (forall e#5: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#5) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#5)) } $Is(e#5, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#5)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#5)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#3 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#4 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#3)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#4)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#48#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#48#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#49#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#49#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#3 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var elem#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#3) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#3)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#3)) && (var sep#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#3)); JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) && (var s0#3 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType); (s0#3 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType)) && (s0#3 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#10 := sep#9; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10) && (var elems#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#4)))) && (!(s0#3 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#3 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#9) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType)) && (s0#3 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#11 := sep#9; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11) && (var elems'#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#3, sep#11))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#3 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#3) else (var elem#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#3)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#3)); (var s0#3 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType); (if s0#3 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#10 := sep#9; (var elems#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#10); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#4))) else (if s0#3 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#9)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#11 := sep#9; (var elems'#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#3, sep#11); (var bracketed#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#3, sep#11); #Wrappers.Result.Success($Box(bracketed#3))))) else (var separator#3 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#4 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#3)), s0#3))); pr#4)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#50#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#4 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var elem#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#4) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#4)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#4)) && (var sep#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#4)); JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) && (var s0#4 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType); (s0#4 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType)) && (s0#4 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#13 := sep#12; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13) && (var elems#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#5)))) && (!(s0#4 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#4 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#12) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType)) && (s0#4 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#14 := sep#12; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14) && (var elems'#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#4, sep#14))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#4 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#4) else (var elem#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#4)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#4)); (var s0#4 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType); (if s0#4 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#13 := sep#12; (var elems#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#13); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#5))) else (if s0#4 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#12)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#14 := sep#12; (var elems'#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#4, sep#14); (var bracketed#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#4, sep#14); #Wrappers.Result.Success($Box(bracketed#4))))) else (var separator#4 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#5 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#4)), s0#4))); pr#5)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#51#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#5 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var elem#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#5) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#5)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#5)) && (var sep#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#5)); JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) && (var s0#5 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType); (s0#5 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType)) && (s0#5 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#16 := sep#15; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16) && (var elems#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#6)))) && (!(s0#5 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#5 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#15) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType)) && (s0#5 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#17 := sep#15; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17) && (var elems'#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#5, sep#17))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#5 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#5) else (var elem#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#5)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#5)); (var s0#5 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType); (if s0#5 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#16 := sep#15; (var elems#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#16); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#6))) else (if s0#5 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#15)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#17 := sep#15; (var elems'#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#5, sep#17); (var bracketed#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#5, sep#17); #Wrappers.Result.Success($Box(bracketed#5))))) else (var separator#5 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#6 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#5)), s0#5))); pr#6)))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0))): DatatypeType, cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed($reveal, cs#0, json#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) && (var open#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#2) && (var elems#2 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#2)); JSON_mUtils_mCursors.Split.SP_q(open#2) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#2)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#2) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#2), p#2) && (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#2), p#2); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) && (var close#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#2, elems#2, close#2)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs#0, json#0, open#2, elems#2)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#2) else (var open#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#2)): DatatypeType; (var elems#2 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#2)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#2)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#2 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#2 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#2), p#2); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#2) else (var close#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#2, elems#2, close#2))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs#0, json#0, open#2, elems#2)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) && (var open#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#3) && (var elems#3 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#3)); JSON_mUtils_mCursors.Split.SP_q(open#3) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#3)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#3) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#3), p#3) && (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#3), p#3); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) && (var close#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), open#3, elems#3, close#3)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#3, elems#3)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#3) else (var open#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#3)): DatatypeType; (var elems#3 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#3)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#3)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#3 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#3 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#3), p#3); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#3) else (var close#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#3)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs#0), open#3, elems#3, close#3))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs#0), Lit(json#0), open#3, elems#3)))))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$7x#0: Box, $fh$7x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$7x#0, $fh$7x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$7x#0, $fh$7x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$7x#0): bool, $Unbox($fh$7x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$7x#0: Box, $fh$7x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$7x#0, $fh$7x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$7x#0, $fh$7x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$7x#0): bool, $Unbox($fh$7x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$7x#0: Box, $fh$7x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$7x#0, $fh$7x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$7x#0, $fh$7x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$7x#0: bool, $fh$7x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$7x#0, $fh$7x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$7x#0, $fh$7x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$7x#0), $Box($fh$7x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#14 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var cs#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#15)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#14 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#14) else (var cs#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#15)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#15 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var cs#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#16)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#15 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#15) else (var cs#16 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#16)))))))));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$7x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$7x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$7x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$7x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$7x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$7x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$7x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$7x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$7x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$7x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$7x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$7x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$7x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$7x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var cs#43 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#43) && (var valueOrError1#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#43); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) && (var contents#28 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#28) && (var cs#44 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#28)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#44) && (var valueOrError2#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#44); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#14) else (var lq#14, cs#43 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType); (var valueOrError1#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#43); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#14) else (var contents#28 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14)): DatatypeType; (var contents#29, cs#44 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#28))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#28)); (var valueOrError2#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#44); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#14) else (var rq#14, cs#45 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#14, contents#29, rq#14)), cs#45))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#15 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var cs#46 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#46) && (var valueOrError1#15 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#46); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) && (var contents#30 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#30) && (var cs#47 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#30)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#47) && (var valueOrError2#15 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#47); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#15 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#15) else (var lq#15, cs#46 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType)); (var valueOrError1#15 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#46); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#15) else (var contents#30 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15)): DatatypeType; (var contents#31, cs#47 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#30))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#30)); (var valueOrError2#15 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#47); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#15) else (var rq#15, cs#48 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#15, contents#31, rq#15)), cs#48))))))))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$3x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$3x#0) == $Box(JSON_mGrammar.__default.Digit_q($Unbox($fh$3x#0): int)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$3x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$3x#0) <==> JSON_mGrammar.__default.Digit_q#requires($Unbox($fh$3x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: int :: { JSON_mGrammar.__default.Digit_q($fh$3x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Digit_q($fh$3x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $Box($fh$3x#0))): bool);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) && (var sp#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#6) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#6)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#6 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#6)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#6)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) == (var sp#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); (var valueOrError0#6 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#6)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#6) else #Wrappers.Result.Success($Box(sp#6))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) && (var sp#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(sp#7) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#7 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#7)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) == (var sp#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); (var valueOrError0#7 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#7) else #Wrappers.Result.Success($Box(sp#7))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box($Unbox($l#40#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.BoundedInts.uint8())), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box($Unbox($l#38#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.BoundedInts.uint8())), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box($Unbox($l#44#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.BoundedInts.uint8())), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box($Unbox($l#45#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, Tclass.BoundedInts.uint8())), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box($Unbox($l#42#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.BoundedInts.uint8())), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box($Unbox($l#40#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#40#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.BoundedInts.uint8())), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box($Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#41#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.BoundedInts.uint8())), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box($Unbox($l#38#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#38#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.BoundedInts.uint8())), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box($Unbox($l#44#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#44#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.BoundedInts.uint8())), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box($Unbox($l#45#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#45#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, Tclass.BoundedInts.uint8())), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box($Unbox($l#42#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#42#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.BoundedInts.uint8())), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box($Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint8())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box($Unbox($l#47#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, Tclass.BoundedInts.uint8())), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))))) && (var sp#6 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ))))); JSON_mUtils_mCursors.Split.SP_q(sp#6) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#6)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#6) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#6)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) == (var sp#6 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#44#ly#0: LayerType :: Handle1((lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $Box($Unbox($l#44#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: $IsBox($l#44#c#0, Tclass.BoundedInts.uint8())), (lambda $l#44#heap#0: Heap, $l#44#c#0: Box :: SetRef_to_SetBox((lambda $l#44#o#0: ref :: false))))), $LS($LZ))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#6)): DatatypeType) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#6)) else #Wrappers.Result.Success($Box(sp#6)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#51#ly#0: LayerType :: Handle1((lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $Box($Unbox($l#51#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: $IsBox($l#51#c#0, Tclass.BoundedInts.uint8())), (lambda $l#51#heap#0: Heap, $l#51#c#0: Box :: SetRef_to_SetBox((lambda $l#51#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))))) && (var sp#7 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box($Unbox($l#53#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.BoundedInts.uint8())), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))))); JSON_mUtils_mCursors.Split.SP_q(sp#7) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#7) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#7)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) == (var sp#7 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box($Unbox($l#49#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.BoundedInts.uint8())), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit($Unbox(JSON_mUtils_mCursors.Split.t(sp#7)): DatatypeType)) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, Lit(JSON_mUtils_mCursors.Split.cs(sp#7))) else #Wrappers.Result.Success($Box(sp#7)))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#53#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#53#heap#0: Heap, $l#53#exp#0: Box :: $IsBox($l#53#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#53#heap#0: Heap, $l#53#exp#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box($Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint8())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box($Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.BoundedInts.uint8())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) && (var e#6, cs#19 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#6) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#19) && (var cs#20 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#19)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#20) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#20); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) == (var e#6, cs#19 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#6) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#19))) else (var sign#6, cs#20 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#19))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#19)); (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#20); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#6) else (var num#6, cs#21 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#6, sign#6, num#6)))), cs#21))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box($Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.BoundedInts.uint8())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box($Unbox($l#62#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#62#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.BoundedInts.uint8())), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))))) && (var e#7, cs#22 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box($Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint8())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box($Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint8())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#7) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#22) && (var cs#23 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#22)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#23) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#23); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) == (var e#7, cs#22 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box($Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.BoundedInts.uint8())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box($Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.BoundedInts.uint8())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#7) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#22))) else (var sign#7, cs#23 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#22))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#22)); (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#23); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#7) else (var num#7, cs#24 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#7, sign#7, num#7)))), cs#24))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#53#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#53#heap#0: Heap, $l#53#frac#0: Box :: $IsBox($l#53#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#53#heap#0: Heap, $l#53#frac#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box($Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint8())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box($Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.BoundedInts.uint8())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) && (var period#6, cs#13 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#6) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#13) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#13); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) == (var period#6, cs#13 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#6) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#13))) else (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#13); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#6) else (var num#6, cs#14 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#6, num#6)))), cs#14)))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box($Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.BoundedInts.uint8())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box($Unbox($l#62#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.BoundedInts.uint8())), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))))) && (var period#7, cs#15 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box($Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint8())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box($Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint8())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#7) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#15) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#15); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) == (var period#7, cs#15 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box($Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.BoundedInts.uint8())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box($Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.BoundedInts.uint8())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#7) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#15))) else (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#15); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#7) else (var num#7, cs#16 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#7, num#7)))), cs#16)))))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Number#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Number($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#26#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#26#heap#0: Heap, $l#26#frac#0: Box :: $IsBox($l#26#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#26#heap#0: Heap, $l#26#frac#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#27#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#27#heap#0: Heap, $l#27#exp#0: Box :: $IsBox($l#27#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#27#heap#0: Heap, $l#27#exp#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0) <==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#28#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#28#heap#0: Heap, $l#28#frac#0: Box :: $IsBox($l#28#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#28#heap#0: Heap, $l#28#frac#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#29#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#29#heap#0: Heap, $l#29#exp#0: Box :: $IsBox($l#29#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#29#heap#0: Heap, $l#29#exp#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#28#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#28#heap#0: Heap, $l#28#frac#0: Box :: $IsBox($l#28#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#28#heap#0: Heap, $l#28#frac#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#29#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#29#heap#0: Heap, $l#29#exp#0: Box :: $IsBox($l#29#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#29#heap#0: Heap, $l#29#exp#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0) == (var sp#7 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0)); sp#7));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), Lit(minus#0), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), Lit(num#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(minus#0))), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), Lit(frac#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(num#0))), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#30#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#30#heap#0: Heap, $l#30#frac#0: Box :: $IsBox($l#30#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#30#heap#0: Heap, $l#30#frac#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Lit(exp#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(frac#0))), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#31#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#31#heap#0: Heap, $l#31#exp#0: Box :: $IsBox($l#31#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#31#heap#0: Heap, $l#31#exp#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(num#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) == (var sp#8 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jnumber.JNumber(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(minus#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(num#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(frac#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(exp#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(exp#0))))); sp#8));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) && (var minus#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); JSON_mUtils_mCursors.Split.SP_q(minus#6) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#6)) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#6)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var num#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#6) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#6)) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#6)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (var frac#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#6) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#6)) && (var valueOrError2#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#6)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) && (var exp#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#6, num#6, frac#6, exp#6))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) == (var minus#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#6) else (var num#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#6) else (var frac#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; (var valueOrError2#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#6) else (var exp#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#6, num#6, frac#6, exp#6))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) && (var minus#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(minus#7) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#7)) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#7)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var num#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#7) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#7)) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#7)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (var frac#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#7) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#7)) && (var valueOrError2#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#7)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) && (var exp#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), minus#7, num#7, frac#7, exp#7))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) == (var minus#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#7)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#7) else (var num#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#7)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#7) else (var frac#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; (var valueOrError2#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#7)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#7) else (var exp#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, Lit(cs#0), minus#7, num#7, frac#7, exp#7))))))))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#9 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#9));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#10 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#10));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$4x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var k#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; (var p#12 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#12) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#12), p#12) && (var valueOrError1#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#12), p#12); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) && (var colon#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#12) && (var valueOrError2#12 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#12)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) && (var v#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#12, colon#12, v#12))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#12) else (var k#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; (var p#12 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#12 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#12), p#12); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#12) else (var colon#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#12)): DatatypeType; (var valueOrError2#12 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#12)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#12) else (var v#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#12)): DatatypeType; (var kv#12 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#12, colon#12, v#12); #Wrappers.Result.Success($Box(kv#12))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#13 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var k#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; (var p#13 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#13) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#13), p#13) && (var valueOrError1#13 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#13), p#13); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) && (var colon#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#13) && (var valueOrError2#13 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#13)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) && (var v#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#13, colon#13, v#13))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#13 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#13) else (var k#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; (var p#13 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#13 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#13), p#13); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#13) else (var colon#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#13)): DatatypeType; (var valueOrError2#13 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#13)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#13) else (var v#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#13)): DatatypeType; (var kv#13 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#13, colon#13, v#13); #Wrappers.Result.Success($Box(kv#13))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var k#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; (var p#14 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#14) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#14), p#14) && (var valueOrError1#14 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#14), p#14); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) && (var colon#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#14) && (var valueOrError2#14 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#14)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) && (var v#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#14, colon#14, v#14))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#14) else (var k#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; (var p#14 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#14 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#14), p#14); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#14) else (var colon#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#14)): DatatypeType; (var valueOrError2#14 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#14)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#14) else (var v#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#14)): DatatypeType; (var kv#14 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#14, colon#14, v#14); #Wrappers.Result.Success($Box(kv#14))))))))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Object($ly, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, $Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$3x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $Box($fh$3x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#6) else (var sp#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(sp#6))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#7) else (var sp#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(sp#7))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) == (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) == (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox($fh$3x#0): Seq)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires($Unbox($fh$3x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$3x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$3x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#7 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#7));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#30#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#8 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#8));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#15: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#15) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#15)) } $Is(e#15, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#15)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#15))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#6 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#7 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#6)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#7)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#7 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#8 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#7)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#8)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#6 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#7 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#6)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#7)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#7 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#8 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#7)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#8)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#56#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#57#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#57#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var elem#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#9) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#9)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#9) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#9)) && (var sep#27 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#9)); JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) && (var s0#9 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType); (s0#9 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType)) && (s0#9 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#28 := sep#27; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28) && (var elems#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#10)))) && (!(s0#9 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#9 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType)) && (s0#9 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#29 := sep#27; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29) && (var elems'#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#9, sep#29))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#9) else (var elem#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#9)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#27 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#9)); (var s0#9 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType); (if s0#9 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#28 := sep#27; (var elems#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#10))) else (if s0#9 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#29 := sep#27; (var elems'#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29); (var bracketed#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#9, sep#29); #Wrappers.Result.Success($Box(bracketed#9))))) else (var separator#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#10 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#9)), s0#9))); pr#10)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#58#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#15: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#15) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#15)) } $Is(e#15, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#15)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#15)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var elem#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#10) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#10)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#10) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#10)) && (var sep#30 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#10)); JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) && (var s0#10 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType); (s0#10 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType)) && (s0#10 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#31 := sep#30; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31) && (var elems#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#11)))) && (!(s0#10 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#10 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType)) && (s0#10 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#32 := sep#30; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32) && (var elems'#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#10, sep#32))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#10) else (var elem#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#10)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#30 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#10)); (var s0#10 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType); (if s0#10 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#31 := sep#30; (var elems#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#11))) else (if s0#10 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#32 := sep#30; (var elems'#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32); (var bracketed#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#10, sep#32); #Wrappers.Result.Success($Box(bracketed#10))))) else (var separator#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#11 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#10)), s0#10))); pr#11)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#59#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var elem#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#11) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#11)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#11) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#11)) && (var sep#33 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#11)); JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) && (var s0#11 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType); (s0#11 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType)) && (s0#11 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#34 := sep#33; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34) && (var elems#12 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#12)))) && (!(s0#11 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#11 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType)) && (s0#11 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#35 := sep#33; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35) && (var elems'#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#11, sep#35))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#11) else (var elem#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#11)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#33 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#11)); (var s0#11 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType); (if s0#11 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#34 := sep#33; (var elems#12 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#12))) else (if s0#11 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#35 := sep#33; (var elems'#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35); (var bracketed#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#11, sep#35); #Wrappers.Result.Success($Box(bracketed#11))))) else (var separator#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#12 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#11)), s0#11))); pr#12)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var open#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#6) && (var elems#6 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#6)); JSON_mUtils_mCursors.Split.SP_q(open#6) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#6)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#6), p#6) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#6), p#6); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (var close#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#6, elems#6, close#6)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#6, elems#6)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#6) else (var open#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (var elems#6 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#6)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#6), p#6); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#6) else (var close#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#6, elems#6, close#6))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#6, elems#6)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var open#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#7) && (var elems#7 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#7)); JSON_mUtils_mCursors.Split.SP_q(open#7) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#7)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#7), p#7) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#7), p#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (var close#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), open#7, elems#7, close#7)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#7, elems#7)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#7) else (var open#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (var elems#7 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#7)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#7), p#7); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#7) else (var close#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs#0), open#7, elems#7, close#7))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs#0), Lit(json#0), open#7, elems#7)))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Array($ly, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, $Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$3x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $Box($fh$3x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#6) else (var sp#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(sp#6))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#7) else (var sp#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(sp#7))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) == (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) == (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox($fh$3x#0): Seq)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires($Unbox($fh$3x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$3x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$3x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#7 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#7));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#30#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#8 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#8));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#15: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#15) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#15)) } $Is(e#15, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#15)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#15))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#6 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#7 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#6)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#7)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#7 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#8 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#7)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#8)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#6 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#7 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#6)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#7)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#7 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#8 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#7)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#8)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#56#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#57#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#57#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var elem#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#9) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#9)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#9) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#9)) && (var sep#27 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#9)); JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) && (var s0#9 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType); (s0#9 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType)) && (s0#9 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#28 := sep#27; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28) && (var elems#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#10)))) && (!(s0#9 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#9 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType)) && (s0#9 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#29 := sep#27; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29) && (var elems'#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#9, sep#29))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#9) else (var elem#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#9)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#27 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#9)); (var s0#9 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType); (if s0#9 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#28 := sep#27; (var elems#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#10))) else (if s0#9 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#29 := sep#27; (var elems'#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29); (var bracketed#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#9, sep#29); #Wrappers.Result.Success($Box(bracketed#9))))) else (var separator#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#10 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#9)), s0#9))); pr#10)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#58#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#15: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#15) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#15)) } $Is(e#15, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#15)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#15)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var elem#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#10) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#10)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#10) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#10)) && (var sep#30 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#10)); JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) && (var s0#10 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType); (s0#10 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType)) && (s0#10 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#31 := sep#30; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31) && (var elems#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#11)))) && (!(s0#10 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#10 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType)) && (s0#10 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#32 := sep#30; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32) && (var elems'#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#10, sep#32))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#10) else (var elem#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#10)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#30 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#10)); (var s0#10 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType); (if s0#10 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#31 := sep#30; (var elems#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#11))) else (if s0#10 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#32 := sep#30; (var elems'#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32); (var bracketed#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#10, sep#32); #Wrappers.Result.Success($Box(bracketed#10))))) else (var separator#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#11 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#10)), s0#10))); pr#11)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#59#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var elem#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#11) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#11)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#11) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#11)) && (var sep#33 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#11)); JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) && (var s0#11 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType); (s0#11 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType)) && (s0#11 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#34 := sep#33; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34) && (var elems#12 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#12)))) && (!(s0#11 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#11 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType)) && (s0#11 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#35 := sep#33; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35) && (var elems'#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#11, sep#35))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#11) else (var elem#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#11)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#33 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#11)); (var s0#11 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType); (if s0#11 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#34 := sep#33; (var elems#12 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#12))) else (if s0#11 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#35 := sep#33; (var elems'#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35); (var bracketed#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#11, sep#35); #Wrappers.Result.Success($Box(bracketed#11))))) else (var separator#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#12 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#11)), s0#11))); pr#12)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var open#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#6) && (var elems#6 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#6)); JSON_mUtils_mCursors.Split.SP_q(open#6) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#6)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#6), p#6) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#6), p#6); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (var close#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#6, elems#6, close#6)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#6, elems#6)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#6) else (var open#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (var elems#6 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#6)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#6), p#6); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#6) else (var close#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#6, elems#6, close#6))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#6, elems#6)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var open#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#7) && (var elems#7 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#7)); JSON_mUtils_mCursors.Split.SP_q(open#7) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#7)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#7), p#7) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#7), p#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (var close#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), open#7, elems#7, close#7)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#7, elems#7)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#7) else (var open#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (var elems#7 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#7)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#7), p#7); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#7) else (var close#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs#0), open#7, elems#7, close#7))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs#0), Lit(json#0), open#7, elems#7)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType)): DatatypeType), expected#0)) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#9#ly#0: LayerType :: Handle1((lambda $l#9#heap#0: Heap, $l#9#_v3#0: Box :: $Box(expected#0)), (lambda $l#9#heap#0: Heap, $l#9#_v3#0: Box :: $IsBox($l#9#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#9#heap#0: Heap, $l#9#_v3#0: Box :: SetRef_to_SetBox((lambda $l#9#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0)) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), Lit(expected#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(expected#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(expected#0), LitInt(0)) && (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) == (var valueOrError0#7 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0) && (var c#4 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (c#4 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)))) && (c#4 != char#ToInt(Lit(char#FromInt(123))) ==> (c#4 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)))) && (c#4 != char#ToInt(Lit(char#FromInt(91))) ==> (c#4 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError2#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)))) && (c#4 != char#ToInt(Lit(char#FromInt(34))) ==> (c#4 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE()) && (var valueOrError3#4 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4)))) && (c#4 != char#ToInt(Lit(char#FromInt(116))) ==> (c#4 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE()) && (var valueOrError4#4 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4)))) && (c#4 != char#ToInt(Lit(char#FromInt(102))) ==> (c#4 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL()) && (var valueOrError5#4 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4)))) && (c#4 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) && (var valueOrError6#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0) == (var c#4 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (if c#4 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#4) else (var obj#4, cs'#28 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType); (var v#12 := #JSON.Grammar.Value.Object(obj#4); (var sp#12 := #JSON.Utils.Cursors.Split.SP($Box(v#12), cs'#28); #Wrappers.Result.Success($Box(sp#12))))))) else (if c#4 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#4) else (var arr#4, cs'#29 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType); (var v#13 := #JSON.Grammar.Value.Array(arr#4); (var sp#13 := #JSON.Utils.Cursors.Split.SP($Box(v#13), cs'#29); #Wrappers.Result.Success($Box(sp#13))))))) else (if c#4 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#4 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#4) else (var str#4, cs'#30 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#4)), cs'#30)))))) else (if c#4 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#4 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#4) else (var cst#12, cs'#31 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#12)), cs'#31)))))) else (if c#4 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#4 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#4) else (var cst#13, cs'#32 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#13)), cs'#32)))))) else (if c#4 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#4 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#4) else (var cst#14, cs'#33 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#4)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#14)), cs'#33)))))) else (var valueOrError6#4 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#4) else (var num#4, cs'#34 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#4)): DatatypeType); (var v#14 := #JSON.Grammar.Value.Number(num#4); (var sp#14 := #JSON.Utils.Cursors.Split.SP($Box(v#14), cs'#34); #Wrappers.Result.Success($Box(sp#14)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(cs#0)) && (var c#5 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (c#5 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)))) && (c#5 != char#ToInt(Lit(char#FromInt(123))) ==> (c#5 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)))) && (c#5 != char#ToInt(Lit(char#FromInt(91))) ==> (c#5 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError2#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)))) && (c#5 != char#ToInt(Lit(char#FromInt(34))) ==> (c#5 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.TRUE()) && (var valueOrError3#5 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5)))) && (c#5 != char#ToInt(Lit(char#FromInt(116))) ==> (c#5 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.FALSE()) && (var valueOrError4#5 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5)))) && (c#5 != char#ToInt(Lit(char#FromInt(102))) ==> (c#5 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.NULL()) && (var valueOrError5#5 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5)))) && (c#5 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) && (var valueOrError6#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)) == (var c#5 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (if c#5 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#5) else (var obj#5, cs'#35 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType); (var v#15 := #JSON.Grammar.Value.Object(obj#5); (var sp#15 := #JSON.Utils.Cursors.Split.SP($Box(v#15), cs'#35); #Wrappers.Result.Success($Box(sp#15))))))) else (if c#5 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#5) else (var arr#5, cs'#36 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType); (var v#16 := #JSON.Grammar.Value.Array(arr#5); (var sp#16 := #JSON.Utils.Cursors.Split.SP($Box(v#16), cs'#36); #Wrappers.Result.Success($Box(sp#16))))))) else (if c#5 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#5 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#5) else (var str#5, cs'#37 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#5)), cs'#37)))))) else (if c#5 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#5 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#5) else (var cst#15, cs'#38 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#15)), cs'#38)))))) else (if c#5 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#5 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#5) else (var cst#16, cs'#39 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#16)), cs'#39)))))) else (if c#5 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#5 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#5) else (var cst#17, cs'#40 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#5)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#17)), cs'#40)))))) else (var valueOrError6#5 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#5) else (var num#5, cs'#41 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#5)): DatatypeType); (var v#17 := #JSON.Grammar.Value.Number(num#5); (var sp#17 := #JSON.Utils.Cursors.Split.SP($Box(v#17), cs'#41); #Wrappers.Result.Success($Box(sp#17)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#32#ps'#0: DatatypeType :: $Is($l#32#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#32#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0)) && (var pre#4 := Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#35#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#35#heap#0: Heap, $l#35#ps'#0: Box :: $IsBox($l#35#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#35#heap#0: Heap, $l#35#ps'#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $ly)); (forall $l#33#ps'#0: DatatypeType :: $Is($l#33#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#4, $Box($l#33#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#33#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0) == (var pre#4 := Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#30#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#30#heap#0: Heap, $l#30#ps'#0: Box :: $IsBox($l#30#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#30#heap#0: Heap, $l#30#ps'#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $ly)); (var fn#4 := Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#31#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#31#ps'#0): DatatypeType))), (lambda $l#31#heap#0: Heap, $l#31#ps'#0: Box :: $IsBox($l#31#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#31#heap#0, pre#4, $Box($Unbox($l#31#ps'#0): DatatypeType))): bool), (lambda $l#31#heap#0: Heap, $l#31#ps'#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $ly)); #JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#4, fn#4, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#38#ps'#0: DatatypeType :: $Is($l#38#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#38#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(cs#0))) && (var pre#5 := Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#41#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#41#heap#0: Heap, $l#41#ps'#0: Box :: $IsBox($l#41#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#41#heap#0: Heap, $l#41#ps'#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($ly))); (forall $l#39#ps'#0: DatatypeType :: $Is($l#39#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#5, $Box($l#39#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#39#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)) == (var pre#5 := Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#36#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#36#heap#0: Heap, $l#36#ps'#0: Box :: $IsBox($l#36#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#36#heap#0: Heap, $l#36#ps'#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($ly))); (var fn#5 := Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#37#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#37#ps'#0): DatatypeType))), (lambda $l#37#heap#0: Heap, $l#37#ps'#0: Box :: $IsBox($l#37#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#37#heap#0, pre#5, $Box($Unbox($l#37#ps'#0): DatatypeType))): bool), (lambda $l#37#heap#0: Heap, $l#37#ps'#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($ly))); #JSON.Utils.Parsers.SubParser_.SubParser(Lit(cs#0), pre#5, fn#5, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0), Tclass.JSON_mErrors.DeserializationError()));

axiom (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(err#0) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(err#0) then (var b#8 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected#4 := JSON_mUtils_mCursors.CursorError.expected(err#0); #JSON.Errors.DeserializationError.ExpectingByte(expected#4, b#8))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(err#0) then (var b#9 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected_sq#4 := JSON_mUtils_mCursors.CursorError.expected__sq(err#0); #JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#4, b#9))) else (var err#5 := $Unbox(JSON_mUtils_mCursors.CursorError.err(err#0)): DatatypeType; err#5)))));

axiom (forall err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(Lit(err#0)) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(err#0)) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(err#0)) then (var b#12 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected#6 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingByte(expected#6, b#12)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(err#0)) then (var b#13 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected_sq#6 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#6, b#13)))) else (var err#7 := Lit($Unbox(JSON_mUtils_mCursors.CursorError.err(Lit(err#0))): DatatypeType); err#7)))));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.JSON#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON($fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.JSON($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $Box($fh$1x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0))): DatatypeType, cs#0, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires($ly, $Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $reveal: bool, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$1x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $Box($fh$1x#0))): DatatypeType);

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$1x#0) } Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$1x#0) == $Box(JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($Unbox($fh$1x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$1x#0) } Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$1x#0) <==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires($Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$1x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$1x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $Box($fh$1x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && Wrappers.Result.MapFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, cs#0) == Wrappers.Result.MapFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()));

axiom (forall $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.Value(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) && Wrappers.Result.MapFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(true, Lit(cs#0)) == Wrappers.Result.MapFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.Value(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Values._default.Value), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))), JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle()));

axiom (forall $reveal: bool, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0))): DatatypeType))) && $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.Text($reveal, v#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(JSON_mUtils_mCursors.Cursor__.OfView(v#0)) && (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (var cs#2 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#2), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#2 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#2), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#2)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) == (var valueOrError0#2 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#2) else (var text#2, cs#2 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): DatatypeType); (var valueOrError1#2 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#2), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#2) else #Wrappers.Result.Success($Box(text#2))))))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))) && (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (var cs#3 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#3), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#3 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#3), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#3)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) == (var valueOrError0#3 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#3) else (var text#3, cs#3 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): DatatypeType); (var valueOrError1#3 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#3), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#3) else #Wrappers.Result.Success($Box(text#3))))))));

axiom (forall $reveal: bool, bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0)) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0))): DatatypeType))) && $Is(JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes($reveal, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#2 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#2)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) == (var valueOrError0#2 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#2) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))));

axiom (forall bs#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(Lit(bs#0)) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#3 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#3)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(bs#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) == (var valueOrError0#3 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#3) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))));

const reveal_JSON.ZeroCopy.API._default.Serialize: bool;

const reveal_JSON.ZeroCopy.API._default.Deserialize: bool;

const unique class.JSON_mZeroCopy_mAPI.__default: ClassName;

function JSON_mZeroCopy_mAPI.__default.Serialize($reveal: bool, js#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, js#0: DatatypeType :: { JSON_mZeroCopy_mAPI.__default.Serialize($reveal, js#0) } JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#0) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> Wrappers.Result#Equal(JSON_mZeroCopy_mAPI.__default.Serialize($reveal, js#0), #Wrappers.Result.Success($Box(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0)))) && $Is(JSON_mZeroCopy_mAPI.__default.Serialize($reveal, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 0 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mZeroCopy_mAPI.__default.Serialize(true, js#0) } JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#0) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0)) && JSON_mZeroCopy_mAPI.__default.Serialize(true, js#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0)))));
axiom 0 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mAPI.__default.Serialize(true, Lit(js#0)) } JSON_mZeroCopy_mAPI.__default.Serialize#canCall(Lit(js#0)) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) ==> JSON_mZeroCopy_mSerializer.__default.Text#canCall(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, Lit(js#0))) && JSON_mZeroCopy_mAPI.__default.Serialize(true, Lit(js#0)) == #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, Lit(js#0))))));
}

function JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#0: DatatypeType) : bool;

function JSON_mZeroCopy_mAPI.__default.Serialize#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mZeroCopy_mAPI.__default.Serialize#requires(js#0) } $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mAPI.__default.Serialize#requires(js#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.API.Serialize (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mAPI.__default.Serialize(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()))) returns (bs#0: DatatypeType where $Is(bs#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28824"} Wrappers.Result#Equal(bs#0, #Wrappers.Result.Success($Box(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0))));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.API.Serialize (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mAPI.__default.Serialize(js#0: DatatypeType) returns (bs#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;
  var ##js#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.Serialize", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(19,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon4_Then, anon4_Else;

  anon4_Then:
    assume $Is(JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Wrappers.Result#Equal(bs#0, #Wrappers.Result.Success($Box(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0))));
    assume false;
    return;

  anon4_Else:
    ##js#1 := js#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0);
    assume JSON_mUtils_mViews_mWriters.Writer__.Writer_q(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0));
    assume $IsAllocBox($Box(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0)), Tclass.JSON_mUtils_mViews_mWriters.Writer__(), $Heap);
    assume JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0));
    assume JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0))));
    assume JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0));
    assume $Is(JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#0) == bs#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0)) returns (bs#0: DatatypeType where $Is(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType) returns (bs#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.SerializeAlloc", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(25,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc bs#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(26,24): post-state"} true;
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume Wrappers.Result.Success_q(bs#0);
    assume Wrappers.Result.Success_q(bs#0);
    assume $Unbox(Wrappers.Result.value(bs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(bs#0)): ref, alloc)): bool;
    goto anon4;

  anon7_Else:
    assume Wrappers.Result.Success_q(bs#0) ==> $Unbox(Wrappers.Result.value(bs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(bs#0)): ref, alloc)): bool;
    goto anon4;

  anon4:
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(bs#0);
    assume Wrappers.Result.Success_q(bs#0);
    assume $Unbox(Wrappers.Result.value(bs#0)): ref != null;
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(bs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    return;

  anon8_Else:
    assume Wrappers.Result.Success_q(bs#0) ==> Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(bs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (call precondtion)"} CallPre$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0));



procedure {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (call postcondition)"} CallPost$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0)) returns (bs#0: DatatypeType where $Is(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id28837"} Wrappers.Result.Success_q(bs#0) ==> $Unbox(Wrappers.Result.value(bs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(bs#0)): ref, alloc)): bool;
  free ensures Wrappers.Result.Success_q(bs#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id28838"} Wrappers.Result.Success_q(bs#0) ==> Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(bs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (correctness)"} Impl$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0)) returns (defass#bs#0: bool, bs#0: DatatypeType where defass#bs#0 ==> $Is(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id28839"} Wrappers.Result.Success_q(bs#0) ==> $Unbox(Wrappers.Result.value(bs#0)): ref != null && !$Unbox(read(old($Heap), $Unbox(Wrappers.Result.value(bs#0)): ref, alloc)): bool;
  free ensures Wrappers.Result.Success_q(bs#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id28840"} Wrappers.Result.Success_q(bs#0) ==> Seq#Equal(Seq#FromArray($Heap, $Unbox(Wrappers.Result.value(bs#0)): ref), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (correctness)"} Impl$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType) returns (defass#bs#0: bool, bs#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var js##0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.SerializeAlloc", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(28,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    js##0 := js#0;
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.Serialize(js##0);
    call $rhs##0 := CallPost$$JSON_mZeroCopy_mSerializer.__default.Serialize(js##0);
    bs#0 := $rhs##0;
    defass#bs#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(29,34)"} true;
    assume defass#bs#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.API.SerializeInto (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (len#0: DatatypeType where $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.API.SerializeInto (well-formedness)"} CheckWellFormed$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType, bs#0: ref) returns (len#0: DatatypeType)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.SerializeInto", " | ", js#0, " | ", bs#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == bs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(32,9): initial state"} true;
    havoc $Heap /* where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap) */;
    assume (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == bs#0);
    assume $HeapSucc(old($Heap), $Heap);
    havoc len#0;
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(34,25): post-state"} true;
    goto anon13_Then, anon13_Else;

  anon13_Then:
    assume Wrappers.Result.Success_q(len#0);
    assume Wrappers.Result.Success_q(len#0);
    assume bs#0 != null;
    assume $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
    goto anon4;

  anon13_Else:
    assume Wrappers.Result.Success_q(len#0) ==> $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
    goto anon4;

  anon4:
    goto anon14_Then, anon14_Else;

  anon14_Then:
    assume Wrappers.Result.Success_q(len#0);
    assume bs#0 != null;
    assume Wrappers.Result.Success_q(len#0);
    assume 0 <= $Unbox(Wrappers.Result.value(len#0)): int && $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
    assume Seq#Equal(Seq#Take(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    goto anon7;

  anon14_Else:
    assume Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
    goto anon7;

  anon7:
    goto anon15_Then, anon15_Else;

  anon15_Then:
    assume Wrappers.Result.Success_q(len#0);
    assume bs#0 != null;
    assume Wrappers.Result.Success_q(len#0);
    assume 0 <= $Unbox(Wrappers.Result.value(len#0)): int && $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
    assume bs#0 != null;
    assume $IsAlloc(bs#0, Tclass._System.array?(Tclass.BoundedInts.uint8()), old($Heap));
    assume Wrappers.Result.Success_q(len#0);
    assume $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), old($Heap));
    assume 0 <= $Unbox(Wrappers.Result.value(len#0)): int && $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
    assume Seq#Equal(Seq#Drop(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), bs#0), $Unbox(Wrappers.Result.value(len#0)): int));
    goto anon10;

  anon15_Else:
    assume Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), bs#0), $Unbox(Wrappers.Result.value(len#0)): int));
    goto anon10;

  anon10:
    goto anon16_Then, anon16_Else;

  anon16_Then:
    assume Wrappers.Result.Failure_q(len#0);
    assume $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), old($Heap));
    assume (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == bs#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    return;

  anon16_Else:
    assume Wrappers.Result.Failure_q(len#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == bs#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
    return;
}



procedure {:verboseName "JSON.ZeroCopy.API.SerializeInto (call precondtion)"} CallPre$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "JSON.ZeroCopy.API.SerializeInto (call postcondition)"} CallPost$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (len#0: DatatypeType where $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap));
  modifies $Heap;
  free ensures true;
  free ensures {:id "id28871"} Wrappers.Result.Success_q(len#0) ==> $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
  free ensures Wrappers.Result.Success_q(len#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id28872"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures true;
  free ensures {:id "id28873"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), bs#0), $Unbox(Wrappers.Result.value(len#0)): int));
  free ensures true;
  free ensures {:id "id28874"} Wrappers.Result.Failure_q(len#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == bs#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == bs#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.ZeroCopy.API.SerializeInto (correctness)"} Impl$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap) && $IsA#JSON_mGrammar.Structural(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (defass#len#0: bool, len#0: DatatypeType where defass#len#0 ==> $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures true;
  free ensures {:id "id28875"} Wrappers.Result.Success_q(len#0) ==> $Unbox(Wrappers.Result.value(len#0)): int <= _System.array.Length(bs#0);
  free ensures Wrappers.Result.Success_q(len#0) ==> JSON_mConcreteSyntax_mSpec.__default.JSON#canCall(js#0);
  free ensures {:id "id28876"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Take(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0));
  free ensures true;
  free ensures {:id "id28877"} Wrappers.Result.Success_q(len#0) ==> Seq#Equal(Seq#Drop(Seq#FromArray($Heap, bs#0), $Unbox(Wrappers.Result.value(len#0)): int), Seq#Drop(Seq#FromArray(old($Heap), bs#0), $Unbox(Wrappers.Result.value(len#0)): int));
  free ensures true;
  free ensures {:id "id28878"} Wrappers.Result.Failure_q(len#0) ==> (forall $o: ref, $f: Field :: { read($Heap, $o, $f) } $o != null ==> $o == bs#0 ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == bs#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.API.SerializeInto (correctness)"} Impl$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType, bs#0: ref) returns (defass#len#0: bool, len#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var $rhs##0: DatatypeType;
  var js##0: DatatypeType;
  var dest##0: ref;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.SerializeInto", " | ", js#0, " | ", bs#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == bs#0);
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(38,2): initial state"} true;
    $_reverifyPost := false;
    assume true;
    assume true;
    js##0 := js#0;
    assume true;
    dest##0 := bs#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == dest##0 ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js##0, dest##0);
    call $rhs##0 := CallPost$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js##0, dest##0);
    len#0 := $rhs##0;
    defass#len#0 := true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(39,41)"} true;
    assume defass#len#0;
    return;
}



function JSON_mZeroCopy_mAPI.__default.Deserialize($reveal: bool, bs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, bs#0: Seq :: { JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0) } JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0)) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0))): DatatypeType))) && $Is(JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mZeroCopy_mAPI.__default.Deserialize(true, bs#0) } JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mAPI.__default.Deserialize(true, bs#0) == JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0));
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: {:weight 3} { JSON_mZeroCopy_mAPI.__default.Deserialize(true, Lit(bs#0)) } JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(Lit(bs#0)) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(Lit(bs#0)) && JSON_mZeroCopy_mAPI.__default.Deserialize(true, Lit(bs#0)) == JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, Lit(bs#0)));
}

function JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0: Seq) : bool;

function JSON_mZeroCopy_mAPI.__default.Deserialize#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { JSON_mZeroCopy_mAPI.__default.Deserialize#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mZeroCopy_mAPI.__default.Deserialize#requires(bs#0) <==> true));

procedure {:verboseName "JSON.ZeroCopy.API.Deserialize (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mAPI.__default.Deserialize(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) returns (js#0: DatatypeType where $Is(js#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures {:id "id28884"} Wrappers.Result.Success_q(js#0) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(js#0)): DatatypeType));



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.ZeroCopy.API.Deserialize (well-formedness)"} CheckWellformed$$JSON_mZeroCopy_mAPI.__default.Deserialize(bs#0: Seq) returns (js#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var ##js#0: DatatypeType;
  var ##bs#0: Seq;

  anon0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.Deserialize", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/ZeroCopy/API.dfy(42,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume Wrappers.Result.Success_q(js#0);
    assume Wrappers.Result.Success_q(js#0);
    ##js#0 := $Unbox(Wrappers.Result.value(js#0)): DatatypeType;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mConcreteSyntax_mSpec.__default.JSON#canCall($Unbox(Wrappers.Result.value(js#0)): DatatypeType);
    assume Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(js#0)): DatatypeType));
    goto anon5;

  anon8_Else:
    assume Wrappers.Result.Success_q(js#0) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(js#0)): DatatypeType));
    goto anon5;

  anon5:
    assume false;
    return;

  anon7_Else:
    ##bs#0 := bs#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0);
    assume JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0) == JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0);
    assume JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0);
    assume $Is(JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    assume JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0) == js#0;
    return;
}



procedure {:verboseName "JSON.ZeroCopy.API.reveal_Serialize (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mAPI.__default.reveal__Serialize();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.API.reveal_Serialize (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mAPI.__default.reveal__Serialize();



procedure {:verboseName "JSON.ZeroCopy.API.reveal_Serialize (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mAPI.__default.reveal__Serialize();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.API._default.Serialize;



procedure {:verboseName "JSON.ZeroCopy.API.reveal_Deserialize (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mZeroCopy_mAPI.__default.reveal__Deserialize();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.ZeroCopy.API.reveal_Deserialize (call precondtion)"} {:verify false} CallPre$$JSON_mZeroCopy_mAPI.__default.reveal__Deserialize();



procedure {:verboseName "JSON.ZeroCopy.API.reveal_Deserialize (call postcondition)"} {:verify false} CallPost$$JSON_mZeroCopy_mAPI.__default.reveal__Deserialize();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.ZeroCopy.API._default.Deserialize;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#268 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#268))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#270 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#270)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#402 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#402))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#404 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#404)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#406 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#406)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#402 := Wrappers.Option.value(this); v#402)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#404 := Lit(Wrappers.Option.value(Lit(this))); v#404)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#406 := Lit(Wrappers.Option.value(Lit(this))); v#406)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#268 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#268)) else (var e#268 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#270 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#270))) else (var e#270 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#402 := Wrappers.Result.value(this); s#402) else (var e#402 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#404 := Lit(Wrappers.Result.value(Lit(this))); s#404) else (var e#404 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#406 := Lit(Wrappers.Result.value(Lit(this))); s#406) else (var e#406 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#402 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#402)) else (var e#402 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#402)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#404 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#404))) else (var e#404 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#404)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#406 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#406))) else (var e#406 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#406)))));

axiom MulInternals.__default.MulAuto() <==> (forall x#198: int, y#198: int :: { Mul(x#198, y#198) } Mul(x#198, y#198) == Mul(y#198, x#198)) && (forall x#199: int, y#199: int, z#132: int :: { Mul(x#199 + y#199, z#132) } Mul(x#199 + y#199, z#132) == Mul(x#199, z#132) + Mul(y#199, z#132)) && (forall x#200: int, y#200: int, z#133: int :: { Mul(x#200 - y#200, z#133) } Mul(x#200 - y#200, z#133) == Mul(x#200, z#133) - Mul(y#200, z#133));

axiom MulInternals.__default.MulAuto() <==> (forall x#201: int, y#201: int :: { Mul(x#201, y#201) } Mul(x#201, y#201) == Mul(y#201, x#201)) && (forall x#202: int, y#202: int, z#134: int :: { Mul(x#202 + y#202, z#134) } Mul(x#202 + y#202, z#134) == Mul(x#202, z#134) + Mul(y#202, z#134)) && (forall x#203: int, y#203: int, z#135: int :: { Mul(x#203 - y#203, z#135) } Mul(x#203 - y#203, z#135) == Mul(x#203, z#135) - Mul(y#203, z#135));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#248: int :: { Mod(Mod(x#248, n#0), n#0) } Mod(Mod(x#248, n#0), n#0) == Mod(x#248, n#0)) && (forall x#249: int :: { Mod(x#249, n#0) } LitInt(0) <= x#249 && x#249 < n#0 <==> Mod(x#249, n#0) == x#249) && (forall x#250: int, y#124: int :: { Mod(x#250 + y#124, n#0) } (var z#122 := Mod(x#250, n#0) + Mod(y#124, n#0); (LitInt(0) <= z#122 && z#122 < n#0 && Mod(x#250 + y#124, n#0) == z#122) || (n#0 <= z#122 && z#122 < n#0 + n#0 && Mod(x#250 + y#124, n#0) == z#122 - n#0))) && (forall x#251: int, y#125: int :: { Mod(x#251 - y#125, n#0) } (var z#123 := Mod(x#251, n#0) - Mod(y#125, n#0); (LitInt(0) <= z#123 && z#123 < n#0 && Mod(x#251 - y#125, n#0) == z#123) || (0 - n#0 <= z#123 && z#123 < 0 && Mod(x#251 - y#125, n#0) == z#123 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#252: int :: { Mod(Mod(x#252, n#0), n#0) } Mod(Mod(x#252, LitInt(n#0)), LitInt(n#0)) == Mod(x#252, LitInt(n#0))) && (forall x#253: int :: { Mod(x#253, n#0) } LitInt(0) <= x#253 && x#253 < n#0 <==> Mod(x#253, LitInt(n#0)) == x#253) && (forall x#254: int, y#126: int :: { Mod(x#254 + y#126, n#0) } (var z#124 := Mod(x#254, LitInt(n#0)) + Mod(y#126, LitInt(n#0)); (LitInt(0) <= z#124 && z#124 < n#0 && Mod(x#254 + y#126, LitInt(n#0)) == z#124) || (LitInt(n#0) <= z#124 && z#124 < n#0 + n#0 && Mod(x#254 + y#126, LitInt(n#0)) == z#124 - n#0))) && (forall x#255: int, y#127: int :: { Mod(x#255 - y#127, n#0) } (var z#125 := Mod(x#255, LitInt(n#0)) - Mod(y#127, LitInt(n#0)); (LitInt(0) <= z#125 && z#125 < n#0 && Mod(x#255 - y#127, LitInt(n#0)) == z#125) || (LitInt(0 - n#0) <= z#125 && z#125 < 0 && Mod(x#255 - y#127, LitInt(n#0)) == z#125 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#180: int :: { Div(x#180, n#0) } LitInt(0) <= x#180 && x#180 < n#0 <==> Div(x#180, n#0) == LitInt(0)) && (forall x#181: int, y#120: int :: { Div(x#181 + y#120, n#0) } (var z#118 := Mod(x#181, n#0) + Mod(y#120, n#0); (LitInt(0) <= z#118 && z#118 < n#0 && Div(x#181 + y#120, n#0) == Div(x#181, n#0) + Div(y#120, n#0)) || (n#0 <= z#118 && z#118 < n#0 + n#0 && Div(x#181 + y#120, n#0) == Div(x#181, n#0) + Div(y#120, n#0) + 1))) && (forall x#182: int, y#121: int :: { Div(x#182 - y#121, n#0) } (var z#119 := Mod(x#182, n#0) - Mod(y#121, n#0); (LitInt(0) <= z#119 && z#119 < n#0 && Div(x#182 - y#121, n#0) == Div(x#182, n#0) - Div(y#121, n#0)) || (0 - n#0 <= z#119 && z#119 < 0 && Div(x#182 - y#121, n#0) == Div(x#182, n#0) - Div(y#121, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#183: int :: { Div(x#183, n#0) } LitInt(0) <= x#183 && x#183 < n#0 <==> Div(x#183, LitInt(n#0)) == LitInt(0)) && (forall x#184: int, y#122: int :: { Div(x#184 + y#122, n#0) } (var z#120 := Mod(x#184, LitInt(n#0)) + Mod(y#122, LitInt(n#0)); (LitInt(0) <= z#120 && z#120 < n#0 && Div(x#184 + y#122, LitInt(n#0)) == Div(x#184, LitInt(n#0)) + Div(y#122, LitInt(n#0))) || (LitInt(n#0) <= z#120 && z#120 < n#0 + n#0 && Div(x#184 + y#122, LitInt(n#0)) == Div(x#184, LitInt(n#0)) + Div(y#122, LitInt(n#0)) + 1))) && (forall x#185: int, y#123: int :: { Div(x#185 - y#123, n#0) } (var z#121 := Mod(x#185, LitInt(n#0)) - Mod(y#123, LitInt(n#0)); (LitInt(0) <= z#121 && z#121 < n#0 && Div(x#185 - y#123, LitInt(n#0)) == Div(x#185, LitInt(n#0)) - Div(y#123, LitInt(n#0))) || (LitInt(0 - n#0) <= z#121 && z#121 < 0 && Div(x#185 - y#123, LitInt(n#0)) == Div(x#185, LitInt(n#0)) - Div(y#123, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#48 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#48) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#48)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#48 := lv#0; (var dt_update#end#0#48 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#48), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#48), dt_update#end#0#48))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#49 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#49) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#49)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#49 := Lit(lv#0); (var dt_update#end#0#49 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#49)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#49)), dt_update#end#0#49)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#50: char :: { Seq#Contains(s#0, $Box(c#50)) } $Is(c#50, TChar) && Seq#Contains(s#0, $Box(c#50)) ==> char#ToInt(c#50) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#50: char :: { Seq#Contains(s#0, $Box(c#50)) } $Is(c#50, TChar) && Seq#Contains(s#0, $Box(c#50)) ==> char#ToInt(c#50) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#100#ly#0: LayerType :: Handle1((lambda $l#100#heap#0: Heap, $l#100#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#100#i#0): int)): char))), (lambda $l#100#heap#0: Heap, $l#100#i#0: Box :: $IsBox($l#100#i#0, TInt) && LitInt(0) <= $Unbox($l#100#i#0): int && $Unbox($l#100#i#0): int < Seq#Length(s#0)), (lambda $l#100#heap#0: Heap, $l#100#i#0: Box :: SetRef_to_SetBox((lambda $l#100#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#51: char :: { Seq#Contains(s#0, $Box(c#51)) } $Is(c#51, TChar) && Seq#Contains(s#0, $Box(c#51)) ==> char#ToInt(c#51) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#102#ly#0: LayerType :: Handle1((lambda $l#102#heap#0: Heap, $l#102#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#102#i#0): int)): char))), (lambda $l#102#heap#0: Heap, $l#102#i#0: Box :: $IsBox($l#102#i#0, TInt) && LitInt(0) <= $Unbox($l#102#i#0): int && $Unbox($l#102#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#102#heap#0: Heap, $l#102#i#0: Box :: SetRef_to_SetBox((lambda $l#102#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#36 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#36))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#36 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#38 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#38))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#38 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#192 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#96 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#192 := (if b#192 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#192)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#96)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#192)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#193 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#96 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#193 := (if b#193 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#193)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#96 := Seq#Create(TChar, $Heap, Seq#Length(bs0#96), Lit(AtLayer((lambda $l#148#ly#0: LayerType :: Handle1((lambda $l#148#heap#0: Heap, $l#148#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#96, $Unbox($l#148#idx#0): int)): int))), (lambda $l#148#heap#0: Heap, $l#148#idx#0: Box :: $IsBox($l#148#idx#0, TInt) && LitInt(0) <= $Unbox($l#148#idx#0): int && $Unbox($l#148#idx#0): int < Seq#Length(bs0#96)), (lambda $l#148#heap#0: Heap, $l#148#idx#0: Box :: SetRef_to_SetBox((lambda $l#148#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#96), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#193))))) else (var err#96 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#96)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#196 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#98 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#196 := (if b#196 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#196)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#98)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#196)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#197 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#98 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#197 := (if b#197 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#197)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#98 := Seq#Create(TChar, $Heap, Seq#Length(bs0#98), Lit(AtLayer((lambda $l#151#ly#0: LayerType :: Handle1((lambda $l#151#heap#0: Heap, $l#151#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#98, $Unbox($l#151#idx#0): int)): int))), (lambda $l#151#heap#0: Heap, $l#151#idx#0: Box :: $IsBox($l#151#idx#0, TInt) && LitInt(0) <= $Unbox($l#151#idx#0): int && $Unbox($l#151#idx#0): int < Seq#Length(bs0#98)), (lambda $l#151#heap#0: Heap, $l#151#idx#0: Box :: SetRef_to_SetBox((lambda $l#151#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#98), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#197))))) else (var err#98 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#98)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#200 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#100 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#200 := (if b#200 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#200)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#100)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#200)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#201 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#100 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#201 := (if b#201 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#201)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#100 := Seq#Create(TChar, $Heap, Seq#Length(bs0#100), Lit(AtLayer((lambda $l#154#ly#0: LayerType :: Handle1((lambda $l#154#heap#0: Heap, $l#154#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#100, $Unbox($l#154#idx#0): int)): int))), (lambda $l#154#heap#0: Heap, $l#154#idx#0: Box :: $IsBox($l#154#idx#0, TInt) && LitInt(0) <= $Unbox($l#154#idx#0): int && $Unbox($l#154#idx#0): int < Seq#Length(bs0#100)), (lambda $l#154#heap#0: Heap, $l#154#idx#0: Box :: SetRef_to_SetBox((lambda $l#154#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#100), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#201))))) else (var err#100 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#100)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#18: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#18)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#18)): int } LitInt(0) <= idx#18 && idx#18 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#18 && idx#18 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#18)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#18)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#32 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#32 := this; (var dt_update#beg#0#32 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#32), dt_update#beg#0#32, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#32), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#32)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#33 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#33 := Lit(this); (var dt_update#beg#0#33 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#33)), dt_update#beg#0#33, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#33)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#33)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#84#v#0): DatatypeType))), (lambda $l#84#heap#0: Heap, $l#84#v#0: Box :: $IsBox($l#84#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#84#heap#0: Heap, $l#84#v#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#85#v#0): DatatypeType))), (lambda $l#85#heap#0: Heap, $l#85#v#0: Box :: $IsBox($l#85#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#85#heap#0: Heap, $l#85#v#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#86#v#0): DatatypeType))), (lambda $l#86#heap#0: Heap, $l#86#v#0: Box :: $IsBox($l#86#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#86#heap#0: Heap, $l#86#v#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#32 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#32 := this; (var dt_update#point#0#32 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#32), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#32), dt_update#point#0#32, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#32)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#33 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#33 := Lit(this); (var dt_update#point#0#33 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#33)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#33)), dt_update#point#0#33, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#33)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#32 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#32)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#32 := this; (var dt_update#point#0#32 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#32), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#32), dt_update#point#0#32, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#32)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#33 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#33)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#33 := Lit(this); (var dt_update#point#0#33 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#33)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#33)), dt_update#point#0#33, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#33)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#32 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#32 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#32 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#32 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#32))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#33 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#33 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#33 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#33 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#33)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#51: int :: { Seq#Contains(bs#0, $Box(b#51)) } LitInt(0) <= b#51 && b#51 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#51)) ==> b#51 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#51: int :: { Seq#Contains(bs#0, $Box(b#51)) } LitInt(0) <= b#51 && b#51 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#51)) ==> b#51 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#48 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#48)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48) && (var ps#48 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#48, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#48 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#48) else (var ps#48 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#48)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#48, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#52: int :: { Seq#Contains(bs#0, $Box(b#52)) } LitInt(0) <= b#52 && b#52 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#52)) ==> b#52 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#49 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#49)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49) && (var ps#49 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#49, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#49 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#49) else (var ps#49 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#49)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#49, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#53: int :: { Seq#Contains(bs#0, $Box(b#53)) } LitInt(0) <= b#53 && b#53 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#53)) ==> b#53 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#50 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#50)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50) && (var ps#50 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#50, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#50 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#50) else (var ps#50 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#50)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#50, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#18: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#18)): int } LitInt(0) <= idx#18 && idx#18 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#18 && idx#18 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#18)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#98 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#98)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#97 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#97)))) else (var st#97 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#97))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#100 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#100)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#99 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#99)))) else (var st#99 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#99))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#102 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#102)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#101 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#101)))) else (var st#101 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#101))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#128#ly#0: LayerType :: Handle1((lambda $l#128#heap#0: Heap, $l#128#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#128#heap#0: Heap, $l#128#_v0#0: Box :: $IsBox($l#128#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#128#heap#0: Heap, $l#128#_v0#0: Box :: SetRef_to_SetBox((lambda $l#128#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#129#ly#0: LayerType :: Handle1((lambda $l#129#heap#0: Heap, $l#129#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#129#heap#0: Heap, $l#129#_v1#0: Box :: $IsBox($l#129#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#129#heap#0: Heap, $l#129#_v1#0: Box :: SetRef_to_SetBox((lambda $l#129#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#132#ly#0: LayerType :: Handle1((lambda $l#132#heap#0: Heap, $l#132#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#132#heap#0: Heap, $l#132#_v0#0: Box :: $IsBox($l#132#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#132#heap#0: Heap, $l#132#_v0#0: Box :: SetRef_to_SetBox((lambda $l#132#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#133#ly#0: LayerType :: Handle1((lambda $l#133#heap#0: Heap, $l#133#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#133#heap#0: Heap, $l#133#_v1#0: Box :: $IsBox($l#133#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#133#heap#0: Heap, $l#133#_v1#0: Box :: SetRef_to_SetBox((lambda $l#133#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#192#ly#0: LayerType :: Handle1((lambda $l#192#heap#0: Heap, $l#192#cs#0: Box :: $Box(Lit(false))), (lambda $l#192#heap#0: Heap, $l#192#cs#0: Box :: $IsBox($l#192#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#192#heap#0: Heap, $l#192#cs#0: Box :: SetRef_to_SetBox((lambda $l#192#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#193#ly#0: LayerType :: Handle1((lambda $l#193#heap#0: Heap, $l#193#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#193#heap#0: Heap, $l#193#cs#0: Box :: $IsBox($l#193#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#193#heap#0: Heap, $l#193#cs#0: Box :: SetRef_to_SetBox((lambda $l#193#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#194#ly#0: LayerType :: Handle1((lambda $l#194#heap#0: Heap, $l#194#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#194#heap#0: Heap, $l#194#_v2#0: Box :: $IsBox($l#194#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#194#heap#0: Heap, $l#194#_v2#0: Box :: SetRef_to_SetBox((lambda $l#194#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#198#ly#0: LayerType :: Handle1((lambda $l#198#heap#0: Heap, $l#198#cs#0: Box :: $Box(Lit(false))), (lambda $l#198#heap#0: Heap, $l#198#cs#0: Box :: $IsBox($l#198#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#198#heap#0: Heap, $l#198#cs#0: Box :: SetRef_to_SetBox((lambda $l#198#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#199#ly#0: LayerType :: Handle1((lambda $l#199#heap#0: Heap, $l#199#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#199#heap#0: Heap, $l#199#cs#0: Box :: $IsBox($l#199#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#199#heap#0: Heap, $l#199#cs#0: Box :: SetRef_to_SetBox((lambda $l#199#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#200#ly#0: LayerType :: Handle1((lambda $l#200#heap#0: Heap, $l#200#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#200#heap#0: Heap, $l#200#_v2#0: Box :: $IsBox($l#200#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#200#heap#0: Heap, $l#200#_v2#0: Box :: SetRef_to_SetBox((lambda $l#200#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#32: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#32))): DatatypeType } $Is(cs'#32, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#32))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#32))): DatatypeType)): DatatypeType, cs'#32, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#32: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#32))): DatatypeType } $Is(cs'#32, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#32))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#32))): DatatypeType)): DatatypeType, cs'#32, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#33: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#33))): DatatypeType } $Is(cs'#33, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#33))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#33))): DatatypeType)): DatatypeType, cs'#33, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#33: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#33))): DatatypeType } $Is(cs'#33, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#33))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#33))): DatatypeType)): DatatypeType, cs'#33, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#96: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#96)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#96))): bool } $Is(cs'#96, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#96))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#96)))) && ((forall cs'#96: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#96)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#96))): bool } $Is(cs'#96, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#96))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#96))) ==> (forall cs'#97: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#97))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#97, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#97: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#97))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#97, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#97))): bool) ==> (forall cs'#98: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#98))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#98))): bool } $Is(cs'#98, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#98))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#98))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#98))): DatatypeType)): DatatypeType, cs'#98, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#96: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#96)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#96))): bool } $Is(cs'#96, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#96))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#96))) && (forall cs'#97: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#97))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#97, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#97, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#97))): bool) && (forall cs'#98: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#98))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#98))): bool } $Is(cs'#98, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#98))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#98))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#98))): DatatypeType)): DatatypeType, cs'#98, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#99: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#99)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#99))): bool } $Is(cs'#99, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#99))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#99)))) && ((forall cs'#99: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#99)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#99))): bool } $Is(cs'#99, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#99))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#99))) ==> (forall cs'#100: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#100))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#100, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#100, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#100, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#100, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#100: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#100))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#100, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#100, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#100, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#100))): bool) ==> (forall cs'#101: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#101))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#101))): bool } $Is(cs'#101, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#101))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#101))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#101))): DatatypeType)): DatatypeType, cs'#101, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#99: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#99)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#99))): bool } $Is(cs'#99, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#99))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#99))) && (forall cs'#100: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#100))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#100, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#100, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#100, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#100))): bool) && (forall cs'#101: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#101))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#101))): bool } $Is(cs'#101, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#101))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#101))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#101))): DatatypeType)): DatatypeType, cs'#101, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#23: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#23)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#23)) ==> LitInt(0) <= d#23 && d#23 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#63 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#64 := Seq#Append(digits'#63, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#64))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#64 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#65 := Seq#Append(digits'#64, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#65))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#65 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#66 := Seq#Append(digits'#65, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#66))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#23: Box :: { Seq#Contains(chars#0, c#23) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#23) } $IsBox(c#23, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#23) ==> Seq#Contains(chars#0, c#23)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#47: int :: { Seq#Contains(digits#0, $Box(d#47)) } Seq#Contains(digits#0, $Box(d#47)) ==> LitInt(0) <= d#47 && d#47 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#47: int :: { Seq#Contains(digits#0, $Box(d#47)) } Seq#Contains(digits#0, $Box(d#47)) ==> LitInt(0) <= d#47 && d#47 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#48: int :: { Seq#Contains(digits#0, $Box(d#48)) } Seq#Contains(digits#0, $Box(d#48)) ==> LitInt(0) <= d#48 && d#48 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#23: Box :: { Seq#Contains(chars#0, c#23) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#23) } $IsBox(c#23, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#23) ==> Seq#Contains(chars#0, c#23)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#42 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#42) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#42), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#42 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#42), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#43 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#43) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#43), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#43 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#43), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#65: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#65)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#65) } $IsBox(c#65, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#65) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#65)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#66: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#66)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#66) } $IsBox(c#66, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#66) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#66)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#67: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#67)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#67) } $IsBox(c#67, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#67) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#67)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(Seq#Contains(chars#0, $l#27#c#0))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#45: Box :: { Map#Domain(digits#0)[c#45] } { Seq#Contains(str#0, c#45) } $IsBox(c#45, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#45) ==> Map#Domain(digits#0)[c#45])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#45: Box :: { Map#Domain(digits#0)[c#45] } { Seq#Contains(str#0, c#45) } $IsBox(c#45, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#45) ==> Map#Domain(digits#0)[c#45])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#46: Box :: { Map#Domain(digits#0)[c#46] } { Seq#Contains(str#0, c#46) } $IsBox(c#46, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#46) ==> Map#Domain(digits#0)[c#46])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#89#ly#0: LayerType :: Handle1((lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $Box(Map#Domain(digits#0)[$l#89#c#0])), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $IsBox($l#89#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: SetRef_to_SetBox((lambda $l#89#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#89#ly#0: LayerType :: Handle1((lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $Box(Map#Domain(digits#0)[$l#89#c#0])), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $IsBox($l#89#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: SetRef_to_SetBox((lambda $l#89#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $Box(Map#Domain(digits#0)[$l#90#c#0])), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $IsBox($l#90#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $Box(Map#Domain(digits#0)[$l#91#c#0])), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $IsBox($l#91#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#63 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#63) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#63) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#63)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#63) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#63)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#63 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#63) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#63) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#63)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#63) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#63))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#63 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#63) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#63) else (var tl#126 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#63)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#126)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#63 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#63) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#63) else (var tl#127 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#63)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#127)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#64 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#64) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#64) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#64)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#64) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#64)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#64 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#64) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#64) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#64)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#64) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#64))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#64 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#64) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#64) else (var tl#128 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#64)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#128)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#64 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#64) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#64) else (var tl#129 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#64)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#129)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#65 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#65) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#65) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#65)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#65) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#65)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#65 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#65) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#65) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#65)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#65) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#65))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#65 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#65) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#65) else (var tl#130 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#65)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#130)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#65 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#65) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#65) else (var tl#131 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#65)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#131)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#23: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#23)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#23)) ==> LitInt(0) <= d#23 && d#23 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#63 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#64 := Seq#Append(digits'#63, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#64))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#64 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#65 := Seq#Append(digits'#64, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#65))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#65 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#66 := Seq#Append(digits'#65, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#66))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#23: char :: { Seq#Contains(chars#0, $Box(c#23)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#23)) ==> Seq#Contains(chars#0, $Box(c#23))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#47: int :: { Seq#Contains(digits#0, $Box(d#47)) } Seq#Contains(digits#0, $Box(d#47)) ==> LitInt(0) <= d#47 && d#47 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#47: int :: { Seq#Contains(digits#0, $Box(d#47)) } Seq#Contains(digits#0, $Box(d#47)) ==> LitInt(0) <= d#47 && d#47 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#48: int :: { Seq#Contains(digits#0, $Box(d#48)) } Seq#Contains(digits#0, $Box(d#48)) ==> LitInt(0) <= d#48 && d#48 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#23: char :: { Seq#Contains(chars#0, $Box(c#23)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#23)) ==> Seq#Contains(chars#0, $Box(c#23))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#42 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#42) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#42), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#42 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#42), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#43 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#43) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#43), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#43 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#43), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#65: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#65))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#65)) } $Is(c#65, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#65)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#65))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#66: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#66))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#66)) } $Is(c#66, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#66)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#66))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#67: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#67))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#67)) } $Is(c#67, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#67)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#67))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(Seq#Contains(chars#0, $l#27#c#0))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, TChar)), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#45: char :: { Map#Domain(digits#0)[$Box(c#45)] } { Seq#Contains(str#0, $Box(c#45)) } $Is(c#45, TChar) && Seq#Contains(str#0, $Box(c#45)) ==> Map#Domain(digits#0)[$Box(c#45)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#45: char :: { Map#Domain(digits#0)[$Box(c#45)] } { Seq#Contains(str#0, $Box(c#45)) } $Is(c#45, TChar) && Seq#Contains(str#0, $Box(c#45)) ==> Map#Domain(digits#0)[$Box(c#45)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#46: char :: { Map#Domain(digits#0)[$Box(c#46)] } { Seq#Contains(str#0, $Box(c#46)) } $Is(c#46, TChar) && Seq#Contains(str#0, $Box(c#46)) ==> Map#Domain(digits#0)[$Box(c#46)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#89#ly#0: LayerType :: Handle1((lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $Box(Map#Domain(digits#0)[$l#89#c#0])), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $IsBox($l#89#c#0, TChar)), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: SetRef_to_SetBox((lambda $l#89#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#89#ly#0: LayerType :: Handle1((lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $Box(Map#Domain(digits#0)[$l#89#c#0])), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: $IsBox($l#89#c#0, TChar)), (lambda $l#89#heap#0: Heap, $l#89#c#0: Box :: SetRef_to_SetBox((lambda $l#89#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $Box(Map#Domain(digits#0)[$l#90#c#0])), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $IsBox($l#90#c#0, TChar)), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $Box(Map#Domain(digits#0)[$l#91#c#0])), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $IsBox($l#91#c#0, TChar)), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#63 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#63) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#63) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#63)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#63) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#63)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#63 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#63) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#63) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#63)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#63) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#63))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#63 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#63) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#63) else (var tl#126 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#63)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#126)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#63 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#63) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#63) else (var tl#127 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#63)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#127)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#64 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#64) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#64) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#64)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#64) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#64)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#64 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#64) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#64) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#64)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#64) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#64))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#64 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#64) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#64) else (var tl#128 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#64)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#128)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#64 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#64) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#64) else (var tl#129 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#64)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#129)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#65 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#65) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#65) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#65)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#65) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#65)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#65 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#65) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#65) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#65)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#65) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#65))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#65 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#65) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#65) else (var tl#130 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#65)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#130)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#65 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#65) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#65) else (var tl#131 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#65)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#131)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#22: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#22)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#22)) } $Is(c#22, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#22)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#22))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#25#c#0))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, TChar)), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#43: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)] } { Seq#Contains(str#0, $Box(c#43)) } $Is(c#43, TChar) && Seq#Contains(str#0, $Box(c#43)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#43: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)] } { Seq#Contains(str#0, $Box(c#43)) } $Is(c#43, TChar) && Seq#Contains(str#0, $Box(c#43)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#43)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#44: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#44)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#44)] } { Seq#Contains(str#0, $Box(c#44)) } $Is(c#44, TChar) && Seq#Contains(str#0, $Box(c#44)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#44)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#44)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#68#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#68#c#0]): int < base#0)), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, TChar)), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#68#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#68#c#0]): int < base#0)), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, TChar)), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#69#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#69#c#0]): int < base#0)), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, TChar)), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#76 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#76)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#152 := JSON_mErrors.DeserializationError.b(this); (var b0#76 := JSON_mErrors.DeserializationError.expected(this); (var c#152 := (if b#152 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#152)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#76)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#152)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#153 := JSON_mErrors.DeserializationError.b(this); (var bs0#76 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#153 := (if b#153 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#153)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#76 := Seq#Create(TChar, $Heap, Seq#Length(bs0#76), Lit(AtLayer((lambda $l#118#ly#0: LayerType :: Handle1((lambda $l#118#heap#0: Heap, $l#118#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#76, $Unbox($l#118#idx#0): int)): int))), (lambda $l#118#heap#0: Heap, $l#118#idx#0: Box :: $IsBox($l#118#idx#0, TInt) && LitInt(0) <= $Unbox($l#118#idx#0): int && $Unbox($l#118#idx#0): int < Seq#Length(bs0#76)), (lambda $l#118#heap#0: Heap, $l#118#idx#0: Box :: SetRef_to_SetBox((lambda $l#118#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#76), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#153))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#78 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#78)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#156 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#78 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#156 := (if b#156 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#156)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#78)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#156)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#157 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#78 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#157 := (if b#157 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#157)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#78 := Seq#Create(TChar, $Heap, Seq#Length(bs0#78), Lit(AtLayer((lambda $l#121#ly#0: LayerType :: Handle1((lambda $l#121#heap#0: Heap, $l#121#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#78, $Unbox($l#121#idx#0): int)): int))), (lambda $l#121#heap#0: Heap, $l#121#idx#0: Box :: $IsBox($l#121#idx#0, TInt) && LitInt(0) <= $Unbox($l#121#idx#0): int && $Unbox($l#121#idx#0): int < Seq#Length(bs0#78)), (lambda $l#121#heap#0: Heap, $l#121#idx#0: Box :: SetRef_to_SetBox((lambda $l#121#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#78), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#157))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#77 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#77, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#76 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#76, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#76 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#76)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#79 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#79, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#78 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#78, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#78 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#78)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#42: int :: { JSON_mGrammar.__default.Blank_q(b#42) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) } LitInt(0) <= b#42 && b#42 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#42))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#42: int :: { JSON_mGrammar.__default.Blank_q(b#42) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) } LitInt(0) <= b#42 && b#42 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) ==> JSON_mGrammar.__default.Blank_q(b#42))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#43: int :: { JSON_mGrammar.__default.Blank_q(b#43) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#43)) } LitInt(0) <= b#43 && b#43 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#43)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#43))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#43: int :: { JSON_mGrammar.__default.Blank_q(b#43) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#43)) } LitInt(0) <= b#43 && b#43 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#43)) ==> JSON_mGrammar.__default.Blank_q(b#43))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#42: int :: { $Unbox(Seq#Index(s#0, idx#42)): DatatypeType } LitInt(0) <= idx#42 && idx#42 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#42)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#42: int :: { $Unbox(Seq#Index(s#0, idx#42)): DatatypeType } LitInt(0) <= idx#42 && idx#42 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#42)): DatatypeType)) <==> idx#42 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#43: int :: { $Unbox(Seq#Index(s#0, idx#43)): DatatypeType } LitInt(0) <= idx#43 && idx#43 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#43)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#43: int :: { $Unbox(Seq#Index(s#0, idx#43)): DatatypeType } LitInt(0) <= idx#43 && idx#43 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#43)): DatatypeType)) <==> idx#43 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#42: int :: { JSON_mGrammar.__default.Digit_q(b#42) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) } LitInt(0) <= b#42 && b#42 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#42))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#42: int :: { JSON_mGrammar.__default.Digit_q(b#42) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) } LitInt(0) <= b#42 && b#42 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#42)) ==> JSON_mGrammar.__default.Digit_q(b#42))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#43: int :: { JSON_mGrammar.__default.Digit_q(b#43) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#43)) } LitInt(0) <= b#43 && b#43 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#43)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#43))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#43: int :: { JSON_mGrammar.__default.Digit_q(b#43) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#43)) } LitInt(0) <= b#43 && b#43 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#43)) ==> JSON_mGrammar.__default.Digit_q(b#43))));

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$17x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$17x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$17x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$17x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$17x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$17x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$17x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$17x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$17x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$17x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$17x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$17x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$17x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#54: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#54) } { Seq#Contains(ts#0, d#54) } $IsBox(d#54, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#54) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#54))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#54: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#54) } { Seq#Contains(ts#0, d#54) } $IsBox(d#54, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#54) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#54))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#55: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#55) } { Seq#Contains(ts#0, d#55) } $IsBox(d#55, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#55) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#55))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#56: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#56) } { Seq#Contains(ts#0, d#56) } $IsBox(d#56, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#56) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#56))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#54: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#54)) } $Is(d#54, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#54) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#54)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#54: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#54)) } $Is(d#54, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#54) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#54)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#55: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#55)) } $Is(d#55, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#55) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#55)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#56: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#56)) } $Is(d#56, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#56) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#56)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$17x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$17x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$17x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$17x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$17x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$17x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$17x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$17x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$17x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$17x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$17x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$17x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$17x#0))): Seq);

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$17x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$17x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$17x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$17x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$17x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$17x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$17x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$17x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$17x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$17x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$17x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$17x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$17x#0))): Seq);

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$17x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$17x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$17x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$17x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$17x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$17x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$17x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$17x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$17x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$17x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$17x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$17x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$17x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$17x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#110#d#0: DatatypeType :: $Is($l#110#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#110#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#110#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#111#ly#0: LayerType :: Handle1((lambda $l#111#heap#0: Heap, $l#111#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#111#ly#0, $Unbox($l#111#d#0): DatatypeType))), (lambda $l#111#heap#0: Heap, $l#111#d#0: Box :: $IsBox($l#111#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#111#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#111#heap#0: Heap, $l#111#d#0: Box :: SetRef_to_SetBox((lambda $l#111#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#109#ly#0: LayerType :: Handle1((lambda $l#109#heap#0: Heap, $l#109#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#109#ly#0, $Unbox($l#109#d#0): DatatypeType))), (lambda $l#109#heap#0: Heap, $l#109#d#0: Box :: $IsBox($l#109#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#109#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#109#heap#0: Heap, $l#109#d#0: Box :: SetRef_to_SetBox((lambda $l#109#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#113#d#0: DatatypeType :: $Is($l#113#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#113#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#113#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#114#ly#0: LayerType :: Handle1((lambda $l#114#heap#0: Heap, $l#114#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#114#ly#0, $Unbox($l#114#d#0): DatatypeType))), (lambda $l#114#heap#0: Heap, $l#114#d#0: Box :: $IsBox($l#114#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#114#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#114#heap#0: Heap, $l#114#d#0: Box :: SetRef_to_SetBox((lambda $l#114#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#112#ly#0: LayerType :: Handle1((lambda $l#112#heap#0: Heap, $l#112#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#112#ly#0, $Unbox($l#112#d#0): DatatypeType))), (lambda $l#112#heap#0: Heap, $l#112#d#0: Box :: $IsBox($l#112#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#112#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#112#heap#0: Heap, $l#112#d#0: Box :: SetRef_to_SetBox((lambda $l#112#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#110#d#0: DatatypeType :: $Is($l#110#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#110#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#110#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#111#ly#0: LayerType :: Handle1((lambda $l#111#heap#0: Heap, $l#111#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#111#ly#0, $Unbox($l#111#d#0): DatatypeType))), (lambda $l#111#heap#0: Heap, $l#111#d#0: Box :: $IsBox($l#111#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#111#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#111#heap#0: Heap, $l#111#d#0: Box :: SetRef_to_SetBox((lambda $l#111#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#109#ly#0: LayerType :: Handle1((lambda $l#109#heap#0: Heap, $l#109#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#109#ly#0, $Unbox($l#109#d#0): DatatypeType))), (lambda $l#109#heap#0: Heap, $l#109#d#0: Box :: $IsBox($l#109#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#109#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#109#heap#0: Heap, $l#109#d#0: Box :: SetRef_to_SetBox((lambda $l#109#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#113#d#0: DatatypeType :: $Is($l#113#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#113#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#113#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#114#ly#0: LayerType :: Handle1((lambda $l#114#heap#0: Heap, $l#114#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#114#ly#0, $Unbox($l#114#d#0): DatatypeType))), (lambda $l#114#heap#0: Heap, $l#114#d#0: Box :: $IsBox($l#114#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#114#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#114#heap#0: Heap, $l#114#d#0: Box :: SetRef_to_SetBox((lambda $l#114#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#112#ly#0: LayerType :: Handle1((lambda $l#112#heap#0: Heap, $l#112#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#112#ly#0, $Unbox($l#112#d#0): DatatypeType))), (lambda $l#112#heap#0: Heap, $l#112#d#0: Box :: $IsBox($l#112#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#112#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#112#heap#0: Heap, $l#112#d#0: Box :: SetRef_to_SetBox((lambda $l#112#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#69 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#69))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#69 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#69))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#69 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#69))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#69 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#69))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#69 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#69))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#69 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#69))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#68 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#68)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#68 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#68)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#68 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#68)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#68 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#68)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#68 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#68)) else (var arr#68 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#68))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#71 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#71))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#71 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#71))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#71 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#71))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#71 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#71))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#71 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#71))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#71 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#71))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#70 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#70))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#70 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#70))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#70 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#70))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#70 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#70))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#70 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#70))) else (var arr#70 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#70)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$17x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$17x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$17x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$17x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$17x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$17x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$17x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$17x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$17x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$17x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$17x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$17x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$17x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$17x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$17x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#78: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#78)) } $Is(d#78, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#78) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#78))) && ((forall d#78: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#78)) } $Is(d#78, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#78) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#78))) ==> (forall d#79: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#79)) } $Is(d#79, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#79) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#79)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#78: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#78)) } $Is(d#78, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#78) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#78))) && (forall d#79: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#79)) } $Is(d#79, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#79) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#79))) && (forall d#80: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#80))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#80))): Seq } $Is(d#80, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#80) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#80))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#80))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#81: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#81)) } $Is(d#81, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#81) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#81))) && ((forall d#81: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#81)) } $Is(d#81, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#81) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#81))) ==> (forall d#82: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#82)) } $Is(d#82, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#82) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#82)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#81: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#81)) } $Is(d#81, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#81) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#81))) && (forall d#82: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#82)) } $Is(d#82, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#82) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#82))) && (forall d#83: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#83))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#83))): Seq } $Is(d#83, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#83) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#83))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#83))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#84: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#84)) } $Is(d#84, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#84) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#84))) && ((forall d#84: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#84)) } $Is(d#84, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#84) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#84))) ==> (forall d#85: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#85)) } $Is(d#85, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#85) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#85)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#84: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#84)) } $Is(d#84, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#84) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#84))) && (forall d#85: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#85)) } $Is(d#85, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#85) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#85))) && (forall d#86: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#86))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#86))): Seq } $Is(d#86, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#86) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#86))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#86))): Seq))));

axiom (forall $reveal: bool, js#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Text($reveal, js#0) } JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text($reveal, js#0)), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0)) && $Is(JSON_mZeroCopy_mSerializer.__default.Text($reveal, js#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall js#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Text(true, js#0) } JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty()) && JSON_mZeroCopy_mSerializer.__default.Text(true, js#0) == JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, js#0, JSON_mUtils_mViews_mWriters.Writer__.Empty()));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Text(true, Lit(js#0)) } JSON_mZeroCopy_mSerializer.__default.Text#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> JSON_mZeroCopy_mSerializer.__default.JSON#canCall(Lit(js#0), JSON_mUtils_mViews_mWriters.Writer__.Empty()) && JSON_mZeroCopy_mSerializer.__default.Text(true, Lit(js#0)) == JSON_mZeroCopy_mSerializer.__default.JSON(reveal_JSON.ZeroCopy.Serializer._default.JSON, Lit(js#0), JSON_mUtils_mViews_mWriters.Writer__.Empty()));

axiom (forall $reveal: bool, js#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.JSON($reveal, js#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, writer#0) || ($Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.JSON($reveal, js#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.JSON(js#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.JSON($reveal, js#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.JSON(true, js#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, writer#0) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(js#0)) && (forall $l#23#wr#0: DatatypeType :: $Is($l#23#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $l#23#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#24#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#24#wr#0): DatatypeType))), (lambda $l#24#heap#0: Heap, $l#24#wr#0: Box :: $IsBox($l#24#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#24#heap#0: Heap, $l#24#wr#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#25#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#25#wr#0): DatatypeType))), (lambda $l#25#heap#0: Heap, $l#25#wr#0: Box :: $IsBox($l#25#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#25#heap#0: Heap, $l#25#wr#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)) && JSON_mZeroCopy_mSerializer.__default.JSON(true, js#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#22#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#22#wr#0): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#wr#0: Box :: $IsBox($l#22#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#22#heap#0: Heap, $l#22#wr#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)));

axiom (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.JSON(true, Lit(js#0), Lit(writer#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(Lit(js#0), Lit(writer#0)) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))) && (forall $l#27#wr#0: DatatypeType :: $Is($l#27#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $l#27#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#28#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#28#wr#0): DatatypeType))), (lambda $l#28#heap#0: Heap, $l#28#wr#0: Box :: $IsBox($l#28#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#28#heap#0: Heap, $l#28#wr#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#29#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#29#wr#0): DatatypeType))), (lambda $l#29#heap#0: Heap, $l#29#wr#0: Box :: $IsBox($l#29#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#29#heap#0: Heap, $l#29#wr#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))), Lit(JSON_mGrammar.Structural.after(Lit(js#0)))) && JSON_mZeroCopy_mSerializer.__default.JSON(true, Lit(js#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#26#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#26#wr#0): DatatypeType))), (lambda $l#26#heap#0: Heap, $l#26#wr#0: Box :: $IsBox($l#26#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#26#heap#0: Heap, $l#26#wr#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))), Lit(JSON_mGrammar.Structural.after(Lit(js#0)))));

axiom (forall $ly: LayerType, $reveal: bool, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(v#0, writer#0) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), v#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Value($ly, $reveal, v#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(v#0, writer#0) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (JSON_mGrammar.Value.Null_q(v#0) ==> (var n#7 := JSON_mGrammar.Value.n(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#7))) && (!JSON_mGrammar.Value.Null_q(v#0) ==> (JSON_mGrammar.Value.Bool_q(v#0) ==> (var b#7 := JSON_mGrammar.Value.b(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#7))) && (!JSON_mGrammar.Value.Bool_q(v#0) ==> (JSON_mGrammar.Value.String_q(v#0) ==> (var str#7 := JSON_mGrammar.Value.str(v#0); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#7, writer#0))) && (!JSON_mGrammar.Value.String_q(v#0) ==> (JSON_mGrammar.Value.Number_q(v#0) ==> (var num#7 := JSON_mGrammar.Value.num(v#0); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#7, writer#0))) && (!JSON_mGrammar.Value.Number_q(v#0) ==> (JSON_mGrammar.Value.Object_q(v#0) ==> (var obj#7 := JSON_mGrammar.Value.obj(v#0); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#7, writer#0))) && (!JSON_mGrammar.Value.Object_q(v#0) ==> (var arr#7 := JSON_mGrammar.Value.arr(v#0); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#7, writer#0))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, v#0, writer#0) == (if JSON_mGrammar.Value.Null_q(v#0) then (var n#6 := JSON_mGrammar.Value.n(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#6)) else (if JSON_mGrammar.Value.Bool_q(v#0) then (var b#6 := JSON_mGrammar.Value.b(v#0); (var wr#31 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#6); wr#31)) else (if JSON_mGrammar.Value.String_q(v#0) then (var str#6 := JSON_mGrammar.Value.str(v#0); (var wr#32 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#6, writer#0); wr#32)) else (if JSON_mGrammar.Value.Number_q(v#0) then (var num#6 := JSON_mGrammar.Value.num(v#0); (var wr#33 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#6, writer#0); wr#33)) else (if JSON_mGrammar.Value.Object_q(v#0) then (var obj#6 := JSON_mGrammar.Value.obj(v#0); (var wr#34 := JSON_mZeroCopy_mSerializer.__default.Object($ly, reveal_JSON.ZeroCopy.Serializer._default.Object, obj#6, writer#0); wr#34)) else (var arr#6 := JSON_mGrammar.Value.arr(v#0); (var wr#35 := JSON_mZeroCopy_mSerializer.__default.Array($ly, reveal_JSON.ZeroCopy.Serializer._default.Array, arr#6, writer#0); wr#35))))))));

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(v#0), writer#0) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (var n#9 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#9))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (var b#9 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#9))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (var str#9 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#9, writer#0))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (var num#9 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#9, writer#0))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var obj#9 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#9, writer#0))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var arr#9 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#9, writer#0))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), writer#0) == (if JSON_mGrammar.Value.Null_q(Lit(v#0)) then (var n#8 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#8)) else (if JSON_mGrammar.Value.Bool_q(Lit(v#0)) then (var b#8 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); (var wr#41 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#8); wr#41)) else (if JSON_mGrammar.Value.String_q(Lit(v#0)) then (var str#8 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); (var wr#42 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#8, writer#0); wr#42)) else (if JSON_mGrammar.Value.Number_q(Lit(v#0)) then (var num#8 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); (var wr#43 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#8, writer#0); wr#43)) else (if JSON_mGrammar.Value.Object_q(Lit(v#0)) then (var obj#8 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); (var wr#44 := JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#8, writer#0); wr#44)) else (var arr#8 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); (var wr#45 := JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#8, writer#0); wr#45))))))));

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(v#0), Lit(writer#0)) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (var n#11 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), n#11))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (var b#11 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), b#11))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (var str#11 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#11, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (var num#11 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#11, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var obj#11 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#11, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var arr#11 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#11, Lit(writer#0)))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), Lit(writer#0)) == (if JSON_mGrammar.Value.Null_q(Lit(v#0)) then (var n#10 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), n#10)) else (if JSON_mGrammar.Value.Bool_q(Lit(v#0)) then (var b#10 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); (var wr#51 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), b#10); wr#51)) else (if JSON_mGrammar.Value.String_q(Lit(v#0)) then (var str#10 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); (var wr#52 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#10, Lit(writer#0)); wr#52)) else (if JSON_mGrammar.Value.Number_q(Lit(v#0)) then (var num#10 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); (var wr#53 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#10, Lit(writer#0)); wr#53)) else (if JSON_mGrammar.Value.Object_q(Lit(v#0)) then (var obj#10 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); (var wr#54 := JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#10, Lit(writer#0)); wr#54)) else (var arr#10 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); (var wr#55 := JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#10, Lit(writer#0)); wr#55))))))));

axiom (forall $reveal: bool, str#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.String($reveal, str#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.String#canCall(str#0, writer#0) || ($Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.String($reveal, str#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.String(str#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.String($reveal, str#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall str#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.String(true, str#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.String#canCall(str#0, writer#0) || ($Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jstring.lq(str#0)) && JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)) && JSON_mGrammar.jstring.JString_q(str#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0)) && JSON_mZeroCopy_mSerializer.__default.String(true, str#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jstring.lq(str#0)), JSON_mGrammar.jstring.contents(str#0)), JSON_mGrammar.jstring.rq(str#0)));

axiom (forall str#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(str#0), writer#0) || ($Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))) && JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))));

axiom (forall str#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(str#0), Lit(writer#0)) || ($Is(str#0, Tclass.JSON_mGrammar.jstring()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))) && JSON_mGrammar.jstring.JString_q(Lit(str#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))) && JSON_mZeroCopy_mSerializer.__default.String(true, Lit(str#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jstring.lq(Lit(str#0)))), Lit(JSON_mGrammar.jstring.contents(Lit(str#0)))), Lit(JSON_mGrammar.jstring.rq(Lit(str#0)))));

axiom (forall $reveal: bool, num#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Number($reveal, num#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#0, writer#0) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Number($reveal, num#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Number(num#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Number($reveal, num#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Number(true, num#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#0, writer#0) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)) && (var wr#10 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)); JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#10, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#10, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType))) && (var wr#11 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#10, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) else wr#10); JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0)) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#11, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#11, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#11, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, num#0, writer#0) == (var wr#10 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)); (var wr#11 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#10, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) else wr#10); (var wr#12 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#11, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) else wr#11); wr#12))));

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(Lit(num#0), writer#0) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))) && (var wr#13 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#13, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#13, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType))))) && (var wr#14 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#13, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#13); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#14, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#14, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#14, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType))))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), writer#0) == (var wr#13 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); (var wr#14 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#13, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#13); (var wr#15 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#14, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) else wr#14); wr#15))));

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(Lit(num#0), Lit(writer#0)) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))) && (var wr#16 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#16, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#16, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType))))) && (var wr#17 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#16, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#16); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#17, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#17, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#17, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType))))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), Lit(writer#0)) == (var wr#16 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); (var wr#17 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#16, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#16); (var wr#18 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#17, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) else wr#17); wr#18))));

axiom (forall $Heap: Heap, st#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0) || ($IsGoodHeap($Heap) && $Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $IsAlloc(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mUtils_mViews_mCore.View(), st#0, JSON_mConcreteSyntax_mSpec.__default.View#Handle()))) && $Is(JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall st#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(st#0, writer#0) || ($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(st#0)) && JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType) && JSON_mGrammar.Structural.Structural_q(st#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView(st#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(st#0)), $Unbox(JSON_mGrammar.Structural.t(st#0)): DatatypeType), JSON_mGrammar.Structural.after(st#0)));

axiom (forall st#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(st#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(st#0), Lit(writer#0)) || ($Is(st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(Lit(st#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))) && JSON_mGrammar.Structural.Structural_q(Lit(st#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(st#0))): DatatypeType)) && JSON_mGrammar.Structural.Structural_q(Lit(st#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(st#0))): DatatypeType)), Lit(JSON_mGrammar.Structural.after(Lit(st#0)))) && JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(st#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(st#0)))), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(st#0))): DatatypeType)), Lit(JSON_mGrammar.Structural.after(Lit(st#0)))));

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Object($LS($LZ), obj#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Object($ly, $reveal, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(obj#0), writer#0) && (var wr#10 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0); JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, wr#10) && (var wr#11 := JSON_mZeroCopy_mSerializer.__default.Members($ly, reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#10); JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(obj#0), wr#11))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, obj#0, writer#0) == (var wr#10 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0); (var wr#11 := JSON_mZeroCopy_mSerializer.__default.Members($ly, reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#10); (var wr#12 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(obj#0), wr#11); wr#12))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(Lit(obj#0), writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0) && (var wr#13 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0); JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), wr#13) && (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#13); JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#14))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), writer#0) == (var wr#13 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0); (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#13); (var wr#15 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#14); wr#15))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(Lit(obj#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0)) && (var wr#16 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0))); JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), wr#16) && (var wr#17 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#16); JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#17))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), Lit(writer#0)) == (var wr#16 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0))); (var wr#17 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#16); (var wr#18 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#17); wr#18))));

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Array($LS($LZ), arr#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Array($ly, $reveal, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(arr#0), writer#0) && (var wr#10 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0); JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, wr#10) && (var wr#11 := JSON_mZeroCopy_mSerializer.__default.Items($ly, reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#10); JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(arr#0), wr#11))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, arr#0, writer#0) == (var wr#10 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0); (var wr#11 := JSON_mZeroCopy_mSerializer.__default.Items($ly, reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#10); (var wr#12 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(arr#0), wr#11); wr#12))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(Lit(arr#0), writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0) && (var wr#13 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0); JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), wr#13) && (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#13); JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#14))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), writer#0) == (var wr#13 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0); (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#13); (var wr#15 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#14); wr#15))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(Lit(arr#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0)) && (var wr#16 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0))); JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), wr#16) && (var wr#17 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#16); JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#17))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), Lit(writer#0)) == (var wr#16 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0))); (var wr#17 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#16); (var wr#18 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#17); wr#18))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Member($ly, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Member#requires($ly, $Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$1x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($ly, $fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Member($ly, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $Box($fh$1x#0))): Seq);

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0) || ($IsGoodHeap($Heap) && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(obj#0), JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.Members($ly, $reveal, obj#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0) && JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, obj#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, JSON_mGrammar.Bracketed.data(obj#0), writer#0));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), writer#0) && JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), writer#0) == JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), writer#0));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), Lit(writer#0)) && JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), true, Lit(obj#0), Lit(writer#0)) == Lit(JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(JSON_mGrammar.Bracketed.data(Lit(obj#0))), Lit(writer#0))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$1x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$1x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Item($ly, $Unbox($fh$1x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$1x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$1x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Item#requires($ly, $Unbox($fh$1x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$1x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$1x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$1x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$1x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($ly, $fh$1x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Item($ly, $fh$1x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $Box($fh$1x#0))): Seq);

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0) || ($IsGoodHeap($Heap) && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), JSON_mGrammar.Bracketed.data(arr#0), JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.Items($ly, $reveal, arr#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0) && JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, arr#0, writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, JSON_mGrammar.Bracketed.data(arr#0), writer#0));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), writer#0) && JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), writer#0) == JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), writer#0));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), Lit(writer#0)) && JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), true, Lit(arr#0), Lit(writer#0)) == Lit(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(JSON_mGrammar.Bracketed.data(Lit(arr#0))), Lit(writer#0))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0) || ($IsGoodHeap($Heap) && $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $IsAlloc(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), $Heap) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && (forall j#0: int :: { $Unbox(Seq#Index(members#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#0)): DatatypeType) < DtRank(obj#0))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), members#0, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, members#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires($ly, obj#0, members#0, writer#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires($ly, obj#0, members#0, writer#0) <==> (forall j#6: int :: { $Unbox(Seq#Index(members#0, j#6)): DatatypeType } LitInt(0) <= j#6 && j#6 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#6)): DatatypeType) < DtRank(obj#0))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#6: int :: { $Unbox(Seq#Index(members#0, j#6)): DatatypeType } LitInt(0) <= j#6 && j#6 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#6)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#3, last#3 := Seq#Take(members#0, Seq#Length(members#0) - 1), $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, butLast#3, writer#0) && (var wr#7 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, butLast#3, writer#0); JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, last#3, wr#7)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#3, last#3 := Seq#Take(members#0, Seq#Length(members#0) - 1), $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType; (var wr#7 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, butLast#3, writer#0); (var wr#8 := JSON_mZeroCopy_mSerializer.__default.Member($ly, reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, last#3, wr#7); wr#8)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(members#0), writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#7: int :: { $Unbox(Seq#Index(members#0, j#7)): DatatypeType } LitInt(0) <= j#7 && j#7 < Seq#Length(Lit(members#0)) ==> DtRank($Unbox(Seq#Index(Lit(members#0), j#7)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#4, last#4 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), butLast#4, writer#0) && (var wr#9 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#4, writer#0); JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), last#4, wr#9)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), writer#0) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#4, last#4 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; (var wr#9 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#4, writer#0); (var wr#10 := JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Member, Lit(obj#0), last#4, wr#9); wr#10)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(members#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#8: int :: { $Unbox(Seq#Index(members#0, j#8)): DatatypeType } LitInt(0) <= j#8 && j#8 < Seq#Length(Lit(members#0)) ==> DtRank($Unbox(Seq#Index(Lit(members#0), j#8)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#5, last#5 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), butLast#5, Lit(writer#0)) && (var wr#11 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#5, Lit(writer#0)); JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), last#5, wr#11)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), Lit(writer#0)) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#5, last#5 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; (var wr#11 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#5, Lit(writer#0)); (var wr#12 := JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Member, Lit(obj#0), last#5, wr#11); wr#12)))));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, items#0, spec#0, impl#0, writer#0) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $IsAlloc(v#0, Tclass.JSON_mGrammar.Value(), $Heap) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $IsAlloc(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T), $Heap) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $IsAlloc(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8())), $Heap) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $IsAlloc(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer()), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && (forall item#0: Box, wr#0: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#0, $Box(wr#0)) } $IsBox(item#0, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#0) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#0, $Box(wr#0))) && (forall item#1: Box, wr#1: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#1), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#1)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#1, $Box(wr#1))): DatatypeType } $IsBox(item#1, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#1, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#1) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#1, $Box(wr#1))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#1), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#1)): Seq)))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($LZ), items#0, spec#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0) <==> (forall item#12: Box, wr#13: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#12, $Box(wr#13)) } $IsBox(item#12, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#13, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#12) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#12, $Box(wr#13))) && (forall item#13: Box, wr#14: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#14), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#13)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#13, $Box(wr#14))): DatatypeType } $IsBox(item#13, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#14, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#13) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#13, $Box(wr#14))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#14), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#13)): Seq)))));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, items#0, spec#0, impl#0, writer#0) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#12: Box, wr#13: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#12, $Box(wr#13)) } $IsBox(item#12, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#13, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#12) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#12, $Box(wr#13))) && (forall item#13: Box, wr#14: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#14), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#13)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#13, $Box(wr#14))): DatatypeType } $IsBox(item#13, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#14, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#13) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#13, $Box(wr#14))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#14), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#13)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#4 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), Seq#Index(items#0, Seq#Length(items#0) - 1), $Box(writer#4))): DatatypeType)));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#14: Box, wr#15: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#14, $Box(wr#15)) } $IsBox(item#14, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#15, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#14) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), item#14, $Box(wr#15))) && (forall item#15: Box, wr#16: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#16), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#15)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#15, $Box(wr#16))): DatatypeType } $IsBox(item#15, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#16, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#15) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), item#15, $Box(wr#16))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#16), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#15)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), spec#0, impl#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#5 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), spec#0, impl#0, writer#0); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Box(writer#5))): DatatypeType)));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#16: Box, wr#17: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#16, $Box(wr#17)) } $IsBox(item#16, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#17, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#16) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), item#16, $Box(wr#17))) && (forall item#17: Box, wr#18: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#18), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#17)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#17, $Box(wr#18))): DatatypeType } $IsBox(item#17, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#18, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#17) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), item#17, $Box(wr#18))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#18), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(spec#0), item#17)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), Lit(spec#0), Lit(impl#0), Lit(writer#0))) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#6 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), Lit(spec#0), Lit(impl#0), Lit(writer#0)); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Box(writer#6))): DatatypeType)));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, items#0, writer#0) || ($IsGoodHeap($Heap) && $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $IsAlloc(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), $Heap) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), $Heap) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && $IsAlloc(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap) && (forall j#0: int :: { $Unbox(Seq#Index(items#0, j#0)): DatatypeType } LitInt(0) <= j#0 && j#0 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#0)): DatatypeType) < DtRank(arr#0))) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), $LS($LZ), items#0, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($LS($LZ))))) && $Is(JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, items#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires($ly, arr#0, items#0, writer#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires($ly, arr#0, items#0, writer#0) <==> (forall j#6: int :: { $Unbox(Seq#Index(items#0, j#6)): DatatypeType } LitInt(0) <= j#6 && j#6 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#6)): DatatypeType) < DtRank(arr#0))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, items#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#6: int :: { $Unbox(Seq#Index(items#0, j#6)): DatatypeType } LitInt(0) <= j#6 && j#6 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#6)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#3, last#3 := Seq#Take(items#0, Seq#Length(items#0) - 1), $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, butLast#3, writer#0) && (var wr#7 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, butLast#3, writer#0); JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, last#3, wr#7)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#3, last#3 := Seq#Take(items#0, Seq#Length(items#0) - 1), $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType; (var wr#7 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, butLast#3, writer#0); (var wr#8 := JSON_mZeroCopy_mSerializer.__default.Item($ly, reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, last#3, wr#7); wr#8)))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(items#0), writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#7: int :: { $Unbox(Seq#Index(items#0, j#7)): DatatypeType } LitInt(0) <= j#7 && j#7 < Seq#Length(Lit(items#0)) ==> DtRank($Unbox(Seq#Index(Lit(items#0), j#7)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#4, last#4 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), butLast#4, writer#0) && (var wr#9 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#4, writer#0); JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), last#4, wr#9)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#4, last#4 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; (var wr#9 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#4, writer#0); (var wr#10 := JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Item, Lit(arr#0), last#4, wr#9); wr#10)))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(items#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#8: int :: { $Unbox(Seq#Index(items#0, j#8)): DatatypeType } LitInt(0) <= j#8 && j#8 < Seq#Length(Lit(items#0)) ==> DtRank($Unbox(Seq#Index(Lit(items#0), j#8)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#5, last#5 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), butLast#5, Lit(writer#0)) && (var wr#11 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#5, Lit(writer#0)); JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), last#5, wr#11)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), Lit(writer#0)) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#5, last#5 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; (var wr#11 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#5, Lit(writer#0)); (var wr#12 := JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Item, Lit(arr#0), last#5, wr#11); wr#12)))));

axiom (forall $ly: LayerType, $reveal: bool, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, m#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Member($LS($LZ), m#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Member($ly, $reveal, obj#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, m#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0) && (var wr#13 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#13) && (var wr#14 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#13); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#14) && (var wr#15 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#14); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#15))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, obj#0, m#0, writer#0) == (var wr#13 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); (var wr#14 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#13); (var wr#15 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#14); (var wr#16 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#15 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#15)); wr#16)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), m#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0) && (var wr#17 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#17) && (var wr#18 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#17); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#18) && (var wr#19 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#18); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#19))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), m#0, writer#0) == (var wr#17 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); (var wr#18 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#17); (var wr#19 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#18); (var wr#20 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#19 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#19)); wr#20)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), Lit(m#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), Lit(m#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)) && (var wr#21 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#21) && (var wr#22 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#21); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#22) && (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#22); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && (!Lit(JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#23))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), Lit(m#0), Lit(writer#0)) == (var wr#21 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)); (var wr#22 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#21); (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#22); (var wr#24 := (if JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0)))) then wr#23 else JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#23)); wr#24)))));

axiom (forall $ly: LayerType, $reveal: bool, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, m#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0)), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(writer#0), JSON_mConcreteSyntax_mSpec.__default.Item($LS($LZ), m#0))) && $Is(JSON_mZeroCopy_mSerializer.__default.Item($ly, $reveal, arr#0, m#0, writer#0), Tclass.JSON_mUtils_mViews_mWriters.Writer()));

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, m#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0) && (var wr#7 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#7))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, arr#0, m#0, writer#0) == (var wr#7 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); (var wr#8 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#7 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#7)); wr#8)));

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), m#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0) && (var wr#9 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#9))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), m#0, writer#0) == (var wr#9 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); (var wr#10 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#9 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#9)); wr#10)));

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), Lit(m#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), Lit(m#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)) && (var wr#11 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && (!Lit(JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#11))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), Lit(m#0), Lit(writer#0)) == (var wr#11 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)); (var wr#12 := (if JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0)))) then wr#11 else JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#11)); wr#12)));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#28 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#28)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) && (var cs#29 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#29)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#28 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#28) else (var cs#29 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#29)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#29 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#29)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) && (var cs#30 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#30)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#29 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#29) else (var cs#30 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#30)))))))));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$14x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$14x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$14x#0): int)));

axiom (forall $heap: Heap, $fh$14x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$14x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$14x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$14x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$14x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$14x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$14x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$14x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$14x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$14x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$14x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#20#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#20#heap#0: Heap, $l#20#st#0: Box :: $IsBox($l#20#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#20#heap#0: Heap, $l#20#st#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#115: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#115)) } $Is(cs#115, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#115)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#115: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#115)) } $Is(cs#115, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#115)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#116 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#28 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#116))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#28)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) && (var cs#117 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#117))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#28, cs#116 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#28 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#116))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#28) else (var val#28, cs#117 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#28)): DatatypeType); (var after#28, cs#118 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#117))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#117)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#28, val#28, after#28)), cs#118)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#119: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#119)) } $Is(cs#119, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#119)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#120 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#29 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#120))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#29)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) && (var cs#121 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#121))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#29, cs#120 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#29 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#120))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#29) else (var val#29, cs#121 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#29)): DatatypeType); (var after#29, cs#122 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#121))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#121)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#29, val#29, after#29)), cs#122)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#19#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#st#0: Box :: $IsBox($l#19#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#19#heap#0: Heap, $l#19#st#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#85 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#85) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#85)) && (var cs#86 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#85))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#86))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#28, cs#85 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#28, cs#86 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#85)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#85))); (var after#28, cs#87 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#86))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#86)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#28, $Box(val#28), after#28)), cs#87)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#88 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#88) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#88)) && (var cs#89 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#88))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#89))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#29, cs#88 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#29, cs#89 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#88)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#88))); (var after#29, cs#90 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#89))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#89)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#29, $Box(val#29), after#29)), cs#90)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#30: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#30) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#30))): Seq } $Is(t#30, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#30)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#30: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#30) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#30))): Seq } $Is(t#30, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#30))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#30)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#31: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#31) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#31))): Seq } $Is(t#31, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#31)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#31: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#31) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#31))): Seq } $Is(t#31, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#31))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#31)))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$2x#0)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires($fh$2x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$2x#0)): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0) == $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$3x#0)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0) <==> JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires($fh$3x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$3x#0)): Seq);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) == (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#5)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) == (var valueOrError0#4 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#4) else (var cs#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#5)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#6)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) == (var valueOrError0#5 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#5) else (var cs#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#6)))))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox($fh$2x#0): Seq)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires($Unbox($fh$2x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$2x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$2x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#5 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#5));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#6 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#6));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#10#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: $IsBox($l#10#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#10#heap#0: Heap, $l#10#c#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#11#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: $IsBox($l#11#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#11#heap#0: Heap, $l#11#c#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ)))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#4 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#5 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#4)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#5)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#12#ly#0: LayerType :: Handle1((lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#12#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: $IsBox($l#12#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#12#heap#0: Heap, $l#12#c#0: Box :: SetRef_to_SetBox((lambda $l#12#o#0: ref :: false))))), $LS($LZ))))) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#5 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#6 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#5)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#6)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#6: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#6) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) } $Is(e#6, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#6)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#6)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#4 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#5 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#4)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#5)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))) && (forall e#7: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#7) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#7)) } $Is(e#7, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#7)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#7)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#5 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#6 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#5)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#6)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#52#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#52#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#53#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#53#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#6 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var elem#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#6) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#6)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#6)) && (var sep#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#6)); JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) && (var s0#6 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType); (s0#6 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType)) && (s0#6 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#19 := sep#18; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19) && (var elems#7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#7)))) && (!(s0#6 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#6 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#18) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType)) && (s0#6 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#20 := sep#18; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20) && (var elems'#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#6, sep#20))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#6 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#6) else (var elem#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#6)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#6)); (var s0#6 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType); (if s0#6 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#19 := sep#18; (var elems#7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#19); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#7))) else (if s0#6 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#18)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#20 := sep#18; (var elems'#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#6, sep#20); (var bracketed#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#6, sep#20); #Wrappers.Result.Success($Box(bracketed#6))))) else (var separator#6 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#7 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#6)), s0#6))); pr#7)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#54#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#7 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var elem#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#7) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#7)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#7)) && (var sep#21 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#7)); JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) && (var s0#7 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType); (s0#7 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType)) && (s0#7 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#22 := sep#21; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22) && (var elems#8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#8)))) && (!(s0#7 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#7 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#21) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType)) && (s0#7 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#23 := sep#21; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23) && (var elems'#7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#7, sep#23))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#7 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#7) else (var elem#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#7)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#21 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#7)); (var s0#7 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType); (if s0#7 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#22 := sep#21; (var elems#8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#22); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#8))) else (if s0#7 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#21)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#23 := sep#21; (var elems'#7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#7, sep#23); (var bracketed#7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#7, sep#23); #Wrappers.Result.Success($Box(bracketed#7))))) else (var separator#7 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#8 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#7)), s0#7))); pr#8)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#55#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: $IsBox($l#55#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#55#heap#0: Heap, $l#55#c#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#8 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var elem#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#8) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#8)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#8) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#8)) && (var sep#24 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#8)); JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) && (var s0#8 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType); (s0#8 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType)) && (s0#8 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#25 := sep#24; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25) && (var elems#9 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#9)))) && (!(s0#8 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#8 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#24) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType)) && (s0#8 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#26 := sep#24; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26) && (var elems'#8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#8, sep#26))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#8 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#8) else (var elem#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#8)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#24 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#8)); (var s0#8 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType); (if s0#8 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#25 := sep#24; (var elems#9 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#25); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#9))) else (if s0#8 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#24)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#26 := sep#24; (var elems'#8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#8, sep#26); (var bracketed#8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#8, sep#26); #Wrappers.Result.Success($Box(bracketed#8))))) else (var separator#8 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#9 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#8)), s0#8))); pr#9)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) && (var open#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#4) && (var elems#4 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#4)); JSON_mUtils_mCursors.Split.SP_q(open#4) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#4)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#4) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#4), p#4) && (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#4), p#4); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) && (var close#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#4, elems#4, close#4)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs#0, json#0, open#4, elems#4)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#4) else (var open#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#4)): DatatypeType; (var elems#4 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#4)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#4)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#4 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#4 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#4), p#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#4) else (var close#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#4)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#4, elems#4, close#4))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs#0, json#0, open#4, elems#4)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) && (var open#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#5) && (var elems#5 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#5)); JSON_mUtils_mCursors.Split.SP_q(open#5) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#5)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#5) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#5), p#5) && (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#5), p#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) && (var close#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), open#5, elems#5, close#5)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#5, elems#5)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#5) else (var open#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#5)): DatatypeType; (var elems#5 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#5)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#5)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#5 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#5 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#5), p#5); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#5) else (var close#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#5)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs#0), open#5, elems#5, close#5))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs#0), Lit(json#0), open#5, elems#5)))))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$8x#0: Box, $fh$8x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$8x#0, $fh$8x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$8x#0, $fh$8x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$8x#0): bool, $Unbox($fh$8x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$8x#0: Box, $fh$8x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$8x#0, $fh$8x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$8x#0, $fh$8x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$8x#0): bool, $Unbox($fh$8x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$8x#0: Box, $fh$8x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$8x#0, $fh$8x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$8x#0, $fh$8x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$8x#0: bool, $fh$8x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$8x#0, $fh$8x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$8x#0, $fh$8x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$8x#0), $Box($fh$8x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#16 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var cs#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#17)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#16 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#16) else (var cs#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#17)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#17 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var cs#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#18)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#17 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#17) else (var cs#18 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#18)))))))));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$8x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$8x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$8x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$8x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$8x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$8x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$8x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$8x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$8x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$8x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$8x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$8x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$8x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$8x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var cs#49 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#49) && (var valueOrError1#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#49); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) && (var contents#32 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#32) && (var cs#50 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#32)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#50) && (var valueOrError2#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#50); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#16) else (var lq#16, cs#49 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType); (var valueOrError1#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#49); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#16) else (var contents#32 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16)): DatatypeType; (var contents#33, cs#50 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#32))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#32)); (var valueOrError2#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#50); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#16) else (var rq#16, cs#51 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#16, contents#33, rq#16)), cs#51))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#17 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var cs#52 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#52) && (var valueOrError1#17 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#52); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) && (var contents#34 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#34) && (var cs#53 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#34)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#53) && (var valueOrError2#17 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#53); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#17 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#17) else (var lq#17, cs#52 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType)); (var valueOrError1#17 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#52); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#17) else (var contents#34 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17)): DatatypeType; (var contents#35, cs#53 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#34))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#34)); (var valueOrError2#17 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#53); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#17) else (var rq#17, cs#54 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#17, contents#35, rq#17)), cs#54))))))))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$4x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$4x#0) == $Box(JSON_mGrammar.__default.Digit_q($Unbox($fh$4x#0): int)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$4x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$4x#0) <==> JSON_mGrammar.__default.Digit_q#requires($Unbox($fh$4x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: int :: { JSON_mGrammar.__default.Digit_q($fh$4x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Digit_q($fh$4x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $Box($fh$4x#0))): bool);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) && (var sp#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#8) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#8)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#8 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#8)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#8)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) == (var sp#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); (var valueOrError0#8 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#8)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#8) else #Wrappers.Result.Success($Box(sp#8))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) && (var sp#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(sp#9) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#9)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#9 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#9)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#9)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) == (var sp#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); (var valueOrError0#9 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#9)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#9) else #Wrappers.Result.Success($Box(sp#9))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box($Unbox($l#49#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.BoundedInts.uint8())), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box($Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint8())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box($Unbox($l#53#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.BoundedInts.uint8())), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box($Unbox($l#50#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.BoundedInts.uint8())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $Box($Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#48#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: $IsBox($l#48#c#0, Tclass.BoundedInts.uint8())), (lambda $l#48#heap#0: Heap, $l#48#c#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box($Unbox($l#49#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#49#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, Tclass.BoundedInts.uint8())), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box($Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#46#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, Tclass.BoundedInts.uint8())), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#52#ly#0: LayerType :: Handle1((lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $Box($Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#52#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: $IsBox($l#52#c#0, Tclass.BoundedInts.uint8())), (lambda $l#52#heap#0: Heap, $l#52#c#0: Box :: SetRef_to_SetBox((lambda $l#52#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $Box($Unbox($l#53#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#53#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: $IsBox($l#53#c#0, Tclass.BoundedInts.uint8())), (lambda $l#53#heap#0: Heap, $l#53#c#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box($Unbox($l#50#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#50#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, Tclass.BoundedInts.uint8())), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box($Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint8())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box($Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.BoundedInts.uint8())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) && (var sp#8 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))); JSON_mUtils_mCursors.Split.SP_q(sp#8) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#8)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#8) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#8)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) == (var sp#8 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#8)): DatatypeType) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#8)) else #Wrappers.Result.Success($Box(sp#8)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box($Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.BoundedInts.uint8())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box($Unbox($l#62#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.BoundedInts.uint8())), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))))) && (var sp#9 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box($Unbox($l#63#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.BoundedInts.uint8())), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))))))); JSON_mUtils_mCursors.Split.SP_q(sp#9) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#9)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#9) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#9)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) == (var sp#9 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box($Unbox($l#59#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.BoundedInts.uint8())), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit($Unbox(JSON_mUtils_mCursors.Split.t(sp#9)): DatatypeType)) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, Lit(JSON_mUtils_mCursors.Split.cs(sp#9))) else #Wrappers.Result.Success($Box(sp#9)))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#64#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#64#heap#0: Heap, $l#64#exp#0: Box :: $IsBox($l#64#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#64#heap#0: Heap, $l#64#exp#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box($Unbox($l#67#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#67#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.BoundedInts.uint8())), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box($Unbox($l#68#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#68#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, Tclass.BoundedInts.uint8())), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))))) && (var e#8, cs#25 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box($Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.BoundedInts.uint8())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box($Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.BoundedInts.uint8())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#8) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#25) && (var cs#26 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#25)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#26) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#26); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) == (var e#8, cs#25 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box($Unbox($l#65#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#65#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.BoundedInts.uint8())), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box($Unbox($l#65#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#65#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.BoundedInts.uint8())), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#8) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#25))) else (var sign#8, cs#26 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#25))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#25)); (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#26); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#8) else (var num#8, cs#27 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#8, sign#8, num#8)))), cs#27))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box($Unbox($l#72#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#72#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, Tclass.BoundedInts.uint8())), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box($Unbox($l#73#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#73#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, Tclass.BoundedInts.uint8())), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ)))))) && (var e#9, cs#28 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box($Unbox($l#74#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#74#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.BoundedInts.uint8())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box($Unbox($l#74#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#74#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.BoundedInts.uint8())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#9) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#28) && (var cs#29 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#28)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#29) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#29); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) == (var e#9, cs#28 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box($Unbox($l#70#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#70#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.BoundedInts.uint8())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box($Unbox($l#70#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#70#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.BoundedInts.uint8())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#9) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#28))) else (var sign#9, cs#29 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#28))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#28)); (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#29); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#9) else (var num#9, cs#30 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#9, sign#9, num#9)))), cs#30))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#64#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#64#heap#0: Heap, $l#64#frac#0: Box :: $IsBox($l#64#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#64#heap#0: Heap, $l#64#frac#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box($Unbox($l#67#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.BoundedInts.uint8())), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box($Unbox($l#68#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, Tclass.BoundedInts.uint8())), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))))) && (var period#8, cs#17 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box($Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.BoundedInts.uint8())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box($Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.BoundedInts.uint8())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#8) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#17) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#17); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) == (var period#8, cs#17 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box($Unbox($l#65#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.BoundedInts.uint8())), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box($Unbox($l#65#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.BoundedInts.uint8())), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#8) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#17))) else (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#17); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#8) else (var num#8, cs#18 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#8, num#8)))), cs#18)))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box($Unbox($l#72#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, Tclass.BoundedInts.uint8())), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box($Unbox($l#73#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, Tclass.BoundedInts.uint8())), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ)))))) && (var period#9, cs#19 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box($Unbox($l#74#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.BoundedInts.uint8())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box($Unbox($l#74#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.BoundedInts.uint8())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#9) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#19) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#19); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) == (var period#9, cs#19 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box($Unbox($l#70#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.BoundedInts.uint8())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#70#ly#0: LayerType :: Handle1((lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $Box($Unbox($l#70#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: $IsBox($l#70#c#0, Tclass.BoundedInts.uint8())), (lambda $l#70#heap#0: Heap, $l#70#c#0: Box :: SetRef_to_SetBox((lambda $l#70#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#9) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#19))) else (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#19); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#9) else (var num#9, cs#20 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#9, num#9)))), cs#20)))))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Number#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number($fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Number($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#32#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#32#heap#0: Heap, $l#32#frac#0: Box :: $IsBox($l#32#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#32#heap#0: Heap, $l#32#frac#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#33#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#33#heap#0: Heap, $l#33#exp#0: Box :: $IsBox($l#33#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#33#heap#0: Heap, $l#33#exp#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0) <==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#34#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#34#heap#0: Heap, $l#34#frac#0: Box :: $IsBox($l#34#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#34#heap#0: Heap, $l#34#frac#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#35#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#35#heap#0: Heap, $l#35#exp#0: Box :: $IsBox($l#35#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#35#heap#0: Heap, $l#35#exp#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#34#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#34#heap#0: Heap, $l#34#frac#0: Box :: $IsBox($l#34#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#34#heap#0: Heap, $l#34#frac#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#35#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#35#heap#0: Heap, $l#35#exp#0: Box :: $IsBox($l#35#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#35#heap#0: Heap, $l#35#exp#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0) == (var sp#9 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0)); sp#9));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), Lit(minus#0), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), Lit(num#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(minus#0))), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), Lit(frac#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(num#0))), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#36#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#36#heap#0: Heap, $l#36#frac#0: Box :: $IsBox($l#36#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#36#heap#0: Heap, $l#36#frac#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Lit(exp#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(frac#0))), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#37#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#37#heap#0: Heap, $l#37#exp#0: Box :: $IsBox($l#37#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#37#heap#0: Heap, $l#37#exp#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(num#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) == (var sp#10 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jnumber.JNumber(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(minus#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(num#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(frac#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(exp#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(exp#0))))); sp#10));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) && (var minus#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); JSON_mUtils_mCursors.Split.SP_q(minus#8) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#8)) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#8)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var num#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#8) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#8)) && (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#8)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (var frac#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#8) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#8)) && (var valueOrError2#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#8)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) && (var exp#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#8, num#8, frac#8, exp#8))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) == (var minus#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#8)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#8) else (var num#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#8)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#8) else (var frac#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; (var valueOrError2#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#8)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#8) else (var exp#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#8, num#8, frac#8, exp#8))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) && (var minus#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(minus#9) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#9)) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#9)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var num#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#9) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#9)) && (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#9)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (var frac#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#9) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#9)) && (var valueOrError2#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#9)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) && (var exp#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), minus#9, num#9, frac#9, exp#9))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) == (var minus#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#9)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#9) else (var num#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#9)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#9) else (var frac#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; (var valueOrError2#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#9)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#9) else (var exp#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, Lit(cs#0), minus#9, num#9, frac#9, exp#9))))))))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#11 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#11));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#12 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#12));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$5x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#15 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var k#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; (var p#15 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#15) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#15), p#15) && (var valueOrError1#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#15), p#15); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) && (var colon#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#15) && (var valueOrError2#15 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#15)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) && (var v#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#15, colon#15, v#15))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#15 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#15) else (var k#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; (var p#15 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#15 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#15), p#15); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#15) else (var colon#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#15)): DatatypeType; (var valueOrError2#15 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#15)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#15) else (var v#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#15)): DatatypeType; (var kv#15 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#15, colon#15, v#15); #Wrappers.Result.Success($Box(kv#15))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var k#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; (var p#16 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#16) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#16), p#16) && (var valueOrError1#16 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#16), p#16); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) && (var colon#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#16) && (var valueOrError2#16 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#16)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) && (var v#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#16, colon#16, v#16))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#16) else (var k#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; (var p#16 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#16 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#16), p#16); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#16) else (var colon#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#16)): DatatypeType; (var valueOrError2#16 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#16)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#16) else (var v#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#16)): DatatypeType; (var kv#16 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#16, colon#16, v#16); #Wrappers.Result.Success($Box(kv#16))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#17 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var k#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; (var p#17 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#17) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#17), p#17) && (var valueOrError1#17 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#17), p#17); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) && (var colon#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#17) && (var valueOrError2#17 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#17)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) && (var v#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#17, colon#17, v#17))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#17 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#17) else (var k#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; (var p#17 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#17 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#17), p#17); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#17) else (var colon#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#17)): DatatypeType; (var valueOrError2#17 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#17)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#17) else (var v#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#17)): DatatypeType; (var kv#17 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#17, colon#17, v#17); #Wrappers.Result.Success($Box(kv#17))))))))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Object($ly, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, $Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$4x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $Box($fh$4x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#8) else (var sp#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(sp#8))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#9) else (var sp#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; #Wrappers.Result.Success($Box(sp#9))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) == (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) == (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox($fh$4x#0): Seq)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires($Unbox($fh$4x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$4x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$4x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#9 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#9));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#36#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#37#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#10 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#10));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#18: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#18) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#18)) } $Is(e#18, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#18)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#18))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#19: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#19) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) } $Is(e#19, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#19)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#19: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#19) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) } $Is(e#19, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#19)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#8 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#9 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#8)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#9)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && (forall e#20: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#20) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) } $Is(e#20, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#20)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#20)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#9 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#10 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#9)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#10)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#8 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#9 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#8)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#9)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))))) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#9 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#10 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#9)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#10)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#60#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#61#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#61#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var elem#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#12) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#12)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#12) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#12)) && (var sep#36 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#12)); JSON_mUtils_mCursors.Split.SP_q(sep#36) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) && (var s0#12 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType); (s0#12 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#36) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType)) && (s0#12 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#37 := sep#36; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#37) && (var elems#13 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#37); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#13)))) && (!(s0#12 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#12 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#36) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType)) && (s0#12 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#38 := sep#36; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#38) && (var elems'#12 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#38); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#12, sep#38))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#12) else (var elem#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#12)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#36 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#12)); (var s0#12 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType); (if s0#12 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#37 := sep#36; (var elems#13 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#37); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#13))) else (if s0#12 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#38 := sep#36; (var elems'#12 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#38); (var bracketed#12 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#12, sep#38); #Wrappers.Result.Success($Box(bracketed#12))))) else (var separator#12 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#13 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#12)), s0#12))); pr#13)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#62#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#18: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#18) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#18)) } $Is(e#18, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#18)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#18)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#13 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var elem#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#13) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#13)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#13) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#13)) && (var sep#39 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#13)); JSON_mUtils_mCursors.Split.SP_q(sep#39) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) && (var s0#13 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType); (s0#13 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#39) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType)) && (s0#13 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#40 := sep#39; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#40) && (var elems#14 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#40); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#14)))) && (!(s0#13 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#13 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#39) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType)) && (s0#13 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#41 := sep#39; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#41) && (var elems'#13 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#41); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#13, sep#41))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#13 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#13) else (var elem#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#13)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#39 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#13)); (var s0#13 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType); (if s0#13 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#40 := sep#39; (var elems#14 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#40); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#14))) else (if s0#13 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#41 := sep#39; (var elems'#13 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#41); (var bracketed#13 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#13, sep#41); #Wrappers.Result.Success($Box(bracketed#13))))) else (var separator#13 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#14 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#13)), s0#13))); pr#14)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#63#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#19: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#19) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) } $Is(e#19, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#19)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#19)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var elem#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#14) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#14)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#14) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#14)) && (var sep#42 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#14)); JSON_mUtils_mCursors.Split.SP_q(sep#42) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) && (var s0#14 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType); (s0#14 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#42) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType)) && (s0#14 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#43 := sep#42; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#43) && (var elems#15 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#43); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#15)))) && (!(s0#14 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#14 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#42) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType)) && (s0#14 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#44 := sep#42; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#44) && (var elems'#14 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#44); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#14, sep#44))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#14) else (var elem#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#14)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#42 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#14)); (var s0#14 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType); (if s0#14 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#43 := sep#42; (var elems#15 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#43); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#15))) else (if s0#14 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#44 := sep#42; (var elems'#14 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#44); (var bracketed#14 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#14, sep#44); #Wrappers.Result.Success($Box(bracketed#14))))) else (var separator#14 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#15 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#14)), s0#14))); pr#15)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$4x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$4x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$4x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $Box($fh$4x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$4x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$4x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$4x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $Box($fh$4x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var open#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#8) && (var elems#8 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#8)); JSON_mUtils_mCursors.Split.SP_q(open#8) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#8)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#8)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#8 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#8) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#8), p#8) && (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#8), p#8); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (var close#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#8, elems#8, close#8)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#8)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#8, elems#8)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#8) else (var open#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (var elems#8 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#8)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#8)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#8 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#8), p#8); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#8) else (var close#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#8, elems#8, close#8))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#8, elems#8)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var open#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#9) && (var elems#9 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#9)); JSON_mUtils_mCursors.Split.SP_q(open#9) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#9)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#9)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#9 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#9) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#9), p#9) && (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#9), p#9); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (var close#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), open#9, elems#9, close#9)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#9)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#9, elems#9)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#9) else (var open#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (var elems#9 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#9)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#9)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#9 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#9), p#9); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#9) else (var close#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs#0), open#9, elems#9, close#9))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs#0), Lit(json#0), open#9, elems#9)))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$4x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Array($ly, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$4x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, $Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$4x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$4x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $Box($fh$4x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#8) else (var sp#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(sp#8))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#9) else (var sp#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; #Wrappers.Result.Success($Box(sp#9))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) == (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) == (var valueOrError0#9 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox($fh$4x#0): Seq)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires($Unbox($fh$4x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$4x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$4x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($Unbox($fh$4x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($fh$4x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#33#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#34#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#35#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: $IsBox($l#35#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#35#heap#0: Heap, $l#35#c#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#9 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#9));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#36#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#37#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: $IsBox($l#37#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#37#heap#0: Heap, $l#37#c#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#10 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#10));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#16#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: $IsBox($l#16#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#16#heap#0: Heap, $l#16#c#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#18: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#18) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#18)) } $Is(e#18, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#18)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#18))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#19: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#19) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) } $Is(e#19, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#19)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#17#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: $IsBox($l#17#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#17#heap#0: Heap, $l#17#c#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $LS($LZ)))) && (forall e#19: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#19) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) } $Is(e#19, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#19)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#8 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#9 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#8)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#9)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#18#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: $IsBox($l#18#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#18#heap#0: Heap, $l#18#c#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))) && (forall e#20: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#20) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) } $Is(e#20, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#20)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#20)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#9 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#10 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#9)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#10)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#25#ly#0: LayerType :: Handle1((lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#25#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: $IsBox($l#25#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#25#heap#0: Heap, $l#25#c#0: Box :: SetRef_to_SetBox((lambda $l#25#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ)))) && (forall e#10: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#10) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) } $Is(e#10, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#10)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#10)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#8 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#9 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#8)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#9)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ))))) && (forall e#11: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#11) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#11)) } $Is(e#11, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#11)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#11)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#9 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#10 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#9)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#10)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#60#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#61#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#61#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var elem#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#12) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#12)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#12) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#12)) && (var sep#36 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#12)); JSON_mUtils_mCursors.Split.SP_q(sep#36) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) && (var s0#12 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType); (s0#12 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#36) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType)) && (s0#12 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#37 := sep#36; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#37) && (var elems#13 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#37); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#13)))) && (!(s0#12 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#12 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#36) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType)) && (s0#12 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#38 := sep#36; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#38) && (var elems'#12 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#38); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#12, sep#38))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#12 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#12) else (var elem#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#12)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#36 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#12)); (var s0#12 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType); (if s0#12 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#37 := sep#36; (var elems#13 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#37); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#13))) else (if s0#12 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#36)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#38 := sep#36; (var elems'#12 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#12, sep#38); (var bracketed#12 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#12, sep#38); #Wrappers.Result.Success($Box(bracketed#12))))) else (var separator#12 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#13 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#12)), s0#12))); pr#13)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#62#ly#0: LayerType :: Handle1((lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#62#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: $IsBox($l#62#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#62#heap#0: Heap, $l#62#c#0: Box :: SetRef_to_SetBox((lambda $l#62#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#18: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#18) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#18)) } $Is(e#18, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#18)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#18)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#13 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var elem#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#13) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#13)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#13) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#13)) && (var sep#39 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#13)); JSON_mUtils_mCursors.Split.SP_q(sep#39) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) && (var s0#13 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType); (s0#13 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#39) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType)) && (s0#13 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#40 := sep#39; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#40) && (var elems#14 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#40); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#14)))) && (!(s0#13 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#13 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#39) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType)) && (s0#13 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#41 := sep#39; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#41) && (var elems'#13 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#41); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#13, sep#41))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#13 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#13) else (var elem#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#13)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#39 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#13)); (var s0#13 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType); (if s0#13 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#40 := sep#39; (var elems#14 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#40); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#14))) else (if s0#13 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#39)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#41 := sep#39; (var elems'#13 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#13, sep#41); (var bracketed#13 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#13, sep#41); #Wrappers.Result.Success($Box(bracketed#13))))) else (var separator#13 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#14 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#13)), s0#13))); pr#14)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#63#ly#0: LayerType :: Handle1((lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#63#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: $IsBox($l#63#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#63#heap#0: Heap, $l#63#c#0: Box :: SetRef_to_SetBox((lambda $l#63#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#19: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#19) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#19)) } $Is(e#19, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#19)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#19)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#14)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) && (var elem#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#14) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#14)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#14) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#14)) && (var sep#42 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#14)); JSON_mUtils_mCursors.Split.SP_q(sep#42) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) && (var s0#14 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType); (s0#14 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#42) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType)) && (s0#14 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#43 := sep#42; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#43) && (var elems#15 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#43); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#15)))) && (!(s0#14 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#14 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#42) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType)) && (s0#14 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#44 := sep#42; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#44) && (var elems'#14 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#44); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#14, sep#44))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#14 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#14) else (var elem#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#14)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#14)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#42 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#14)); (var s0#14 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType); (if s0#14 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#43 := sep#42; (var elems#15 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#43); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#15))) else (if s0#14 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#42)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#44 := sep#42; (var elems'#14 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#14, sep#44); (var bracketed#14 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#14, sep#44); #Wrappers.Result.Success($Box(bracketed#14))))) else (var separator#14 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#15 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#14)), s0#14))); pr#15)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$4x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$4x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$4x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $Box($fh$4x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$4x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$4x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $Unbox($fh$4x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$4x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$4x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires($Unbox($fh$4x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$4x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$4x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$4x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$4x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$4x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $Box($fh$4x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var open#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#8) && (var elems#8 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#8)); JSON_mUtils_mCursors.Split.SP_q(open#8) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#8)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#8)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#8 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#8) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#8), p#8) && (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#8), p#8); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (var close#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#8, elems#8, close#8)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#8)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#8, elems#8)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#8) else (var open#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; (var elems#8 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#8)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#8)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#8 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#8), p#8); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#8) else (var close#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#8, elems#8, close#8))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#8, elems#8)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var open#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#9) && (var elems#9 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#9)); JSON_mUtils_mCursors.Split.SP_q(open#9) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#9)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#9)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#9 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#9) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#9), p#9) && (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#9), p#9); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (var close#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), open#9, elems#9, close#9)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#9)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#9, elems#9)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#9) else (var open#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (var elems#9 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#9)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#9)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#9 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#9), p#9); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#9) else (var close#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs#0), open#9, elems#9, close#9))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs#0), Lit(json#0), open#9, elems#9)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType)): DatatypeType), expected#0)) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#10#ly#0: LayerType :: Handle1((lambda $l#10#heap#0: Heap, $l#10#_v3#0: Box :: $Box(expected#0)), (lambda $l#10#heap#0: Heap, $l#10#_v3#0: Box :: $IsBox($l#10#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#10#heap#0: Heap, $l#10#_v3#0: Box :: SetRef_to_SetBox((lambda $l#10#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0)) && (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#9)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) == (var valueOrError0#8 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#8) else (var cs#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#9)))))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), Lit(expected#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(expected#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(expected#0), LitInt(0)) && (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var cs#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#10)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) == (var valueOrError0#9 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#9) else (var cs#10 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#10)))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0) && (var c#6 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (c#6 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)))) && (c#6 != char#ToInt(Lit(char#FromInt(123))) ==> (c#6 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)))) && (c#6 != char#ToInt(Lit(char#FromInt(91))) ==> (c#6 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError2#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)))) && (c#6 != char#ToInt(Lit(char#FromInt(34))) ==> (c#6 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE()) && (var valueOrError3#6 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6)))) && (c#6 != char#ToInt(Lit(char#FromInt(116))) ==> (c#6 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE()) && (var valueOrError4#6 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6)))) && (c#6 != char#ToInt(Lit(char#FromInt(102))) ==> (c#6 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL()) && (var valueOrError5#6 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6)))) && (c#6 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) && (var valueOrError6#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0) == (var c#6 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (if c#6 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#6) else (var obj#6, cs'#42 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType); (var v#18 := #JSON.Grammar.Value.Object(obj#6); (var sp#18 := #JSON.Utils.Cursors.Split.SP($Box(v#18), cs'#42); #Wrappers.Result.Success($Box(sp#18))))))) else (if c#6 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#6) else (var arr#6, cs'#43 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType); (var v#19 := #JSON.Grammar.Value.Array(arr#6); (var sp#19 := #JSON.Utils.Cursors.Split.SP($Box(v#19), cs'#43); #Wrappers.Result.Success($Box(sp#19))))))) else (if c#6 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#6 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#6) else (var str#6, cs'#44 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#6)), cs'#44)))))) else (if c#6 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#6 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#6) else (var cst#18, cs'#45 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#18)), cs'#45)))))) else (if c#6 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#6 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#6) else (var cst#19, cs'#46 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#19)), cs'#46)))))) else (if c#6 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#6 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#6) else (var cst#20, cs'#47 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#6)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#20)), cs'#47)))))) else (var valueOrError6#6 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#6) else (var num#6, cs'#48 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#6)): DatatypeType); (var v#20 := #JSON.Grammar.Value.Number(num#6); (var sp#20 := #JSON.Utils.Cursors.Split.SP($Box(v#20), cs'#48); #Wrappers.Result.Success($Box(sp#20)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(cs#0)) && (var c#7 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (c#7 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)))) && (c#7 != char#ToInt(Lit(char#FromInt(123))) ==> (c#7 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)))) && (c#7 != char#ToInt(Lit(char#FromInt(91))) ==> (c#7 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError2#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)))) && (c#7 != char#ToInt(Lit(char#FromInt(34))) ==> (c#7 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.TRUE()) && (var valueOrError3#7 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7)))) && (c#7 != char#ToInt(Lit(char#FromInt(116))) ==> (c#7 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.FALSE()) && (var valueOrError4#7 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7)))) && (c#7 != char#ToInt(Lit(char#FromInt(102))) ==> (c#7 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.NULL()) && (var valueOrError5#7 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7)))) && (c#7 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) && (var valueOrError6#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)) == (var c#7 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (if c#7 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#7) else (var obj#7, cs'#49 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType); (var v#21 := #JSON.Grammar.Value.Object(obj#7); (var sp#21 := #JSON.Utils.Cursors.Split.SP($Box(v#21), cs'#49); #Wrappers.Result.Success($Box(sp#21))))))) else (if c#7 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#7) else (var arr#7, cs'#50 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType); (var v#22 := #JSON.Grammar.Value.Array(arr#7); (var sp#22 := #JSON.Utils.Cursors.Split.SP($Box(v#22), cs'#50); #Wrappers.Result.Success($Box(sp#22))))))) else (if c#7 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#7 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#7) else (var str#7, cs'#51 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#7)), cs'#51)))))) else (if c#7 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#7 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#7) else (var cst#21, cs'#52 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#21)), cs'#52)))))) else (if c#7 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#7 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#7) else (var cst#22, cs'#53 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#22)), cs'#53)))))) else (if c#7 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#7 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#7) else (var cst#23, cs'#54 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#7)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#23)), cs'#54)))))) else (var valueOrError6#7 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#7) else (var num#7, cs'#55 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#7)): DatatypeType); (var v#23 := #JSON.Grammar.Value.Number(num#7); (var sp#23 := #JSON.Utils.Cursors.Split.SP($Box(v#23), cs'#55); #Wrappers.Result.Success($Box(sp#23)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#44#ps'#0: DatatypeType :: $Is($l#44#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#44#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0)) && (var pre#6 := Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#47#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#47#heap#0: Heap, $l#47#ps'#0: Box :: $IsBox($l#47#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#47#heap#0: Heap, $l#47#ps'#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $ly)); (forall $l#45#ps'#0: DatatypeType :: $Is($l#45#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#6, $Box($l#45#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#45#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0) == (var pre#6 := Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#42#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#42#heap#0: Heap, $l#42#ps'#0: Box :: $IsBox($l#42#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#42#heap#0: Heap, $l#42#ps'#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $ly)); (var fn#6 := Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#43#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#43#ps'#0): DatatypeType))), (lambda $l#43#heap#0: Heap, $l#43#ps'#0: Box :: $IsBox($l#43#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#43#heap#0, pre#6, $Box($Unbox($l#43#ps'#0): DatatypeType))): bool), (lambda $l#43#heap#0: Heap, $l#43#ps'#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $ly)); #JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#6, fn#6, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#50#ps'#0: DatatypeType :: $Is($l#50#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#50#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(cs#0))) && (var pre#7 := Lit(AtLayer((lambda $l#53#ly#0: LayerType :: Handle1((lambda $l#53#heap#0: Heap, $l#53#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#53#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#53#heap#0: Heap, $l#53#ps'#0: Box :: $IsBox($l#53#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#53#heap#0: Heap, $l#53#ps'#0: Box :: SetRef_to_SetBox((lambda $l#53#o#0: ref :: false))))), $LS($ly))); (forall $l#51#ps'#0: DatatypeType :: $Is($l#51#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#7, $Box($l#51#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#51#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)) == (var pre#7 := Lit(AtLayer((lambda $l#48#ly#0: LayerType :: Handle1((lambda $l#48#heap#0: Heap, $l#48#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#48#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#48#heap#0: Heap, $l#48#ps'#0: Box :: $IsBox($l#48#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#48#heap#0: Heap, $l#48#ps'#0: Box :: SetRef_to_SetBox((lambda $l#48#o#0: ref :: false))))), $LS($ly))); (var fn#7 := Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#49#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#49#ps'#0): DatatypeType))), (lambda $l#49#heap#0: Heap, $l#49#ps'#0: Box :: $IsBox($l#49#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#49#heap#0, pre#7, $Box($Unbox($l#49#ps'#0): DatatypeType))): bool), (lambda $l#49#heap#0: Heap, $l#49#ps'#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($ly))); #JSON.Utils.Parsers.SubParser_.SubParser(Lit(cs#0), pre#7, fn#7, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(err#0) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(err#0) then (var b#16 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected#8 := JSON_mUtils_mCursors.CursorError.expected(err#0); #JSON.Errors.DeserializationError.ExpectingByte(expected#8, b#16))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(err#0) then (var b#17 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected_sq#8 := JSON_mUtils_mCursors.CursorError.expected__sq(err#0); #JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#8, b#17))) else (var err#9 := $Unbox(JSON_mUtils_mCursors.CursorError.err(err#0)): DatatypeType; err#9)))));

axiom (forall err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(Lit(err#0)) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(err#0)) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(err#0)) then (var b#20 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected#10 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingByte(expected#10, b#20)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(err#0)) then (var b#21 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected_sq#10 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#10, b#21)))) else (var err#11 := Lit($Unbox(JSON_mUtils_mCursors.CursorError.err(Lit(err#0))): DatatypeType); err#11)))));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.JSON#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON($fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.JSON($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $Box($fh$2x#0))): Seq);

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires($ly, $Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $reveal: bool, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$2x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $Box($fh$2x#0))): DatatypeType);

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$2x#0) } Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$2x#0) == $Box(JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($Unbox($fh$2x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$2x#0) } Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$2x#0) <==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires($Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$2x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$2x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $Box($fh$2x#0))): DatatypeType);

axiom (forall v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(JSON_mUtils_mCursors.Cursor__.OfView(v#0)) && (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#4)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) && (var cs#4 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#4), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#4 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#4), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#4) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#4) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#4)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) == (var valueOrError0#4 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#4) else (var text#4, cs#4 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4)): DatatypeType); (var valueOrError1#4 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#4), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#4) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#4) else #Wrappers.Result.Success($Box(text#4))))))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))) && (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) && (var cs#5 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#5), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#5 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#5), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#5)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) == (var valueOrError0#5 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#5) else (var text#5, cs#5 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5)): DatatypeType); (var valueOrError1#5 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#5), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#5) else #Wrappers.Result.Success($Box(text#5))))))));

axiom (forall bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#4 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#4)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) == (var valueOrError0#4 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#4) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))));

axiom (forall bs#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(Lit(bs#0)) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#5 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#5)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(bs#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) == (var valueOrError0#5 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#5) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))));

const reveal_JSON.API._default.Serialize: bool;

const reveal_JSON.API._default.Deserialize: bool;

const unique class.JSON_mAPI.__default: ClassName;

function JSON_mAPI.__default.Serialize($reveal: bool, js#0: DatatypeType) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, js#0: DatatypeType :: { JSON_mAPI.__default.Serialize($reveal, js#0) } JSON_mAPI.__default.Serialize#canCall(js#0) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mAPI.__default.Serialize($reveal, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
axiom 0 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: { JSON_mAPI.__default.Serialize(true, js#0) } JSON_mAPI.__default.Serialize#canCall(js#0) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> JSON_mSerializer.__default.JSON#canCall(js#0) && (var valueOrError0#0 := JSON_mSerializer.__default.JSON(js#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) && (var js#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#1)))) && JSON_mAPI.__default.Serialize(true, js#0) == (var valueOrError0#0 := JSON_mSerializer.__default.JSON(js#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#0) else (var js#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType; JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#1)))));
axiom 0 <= $FunctionContextHeight ==> (forall js#0: DatatypeType :: {:weight 3} { JSON_mAPI.__default.Serialize(true, Lit(js#0)) } JSON_mAPI.__default.Serialize#canCall(Lit(js#0)) || (0 < $FunctionContextHeight && $Is(js#0, Tclass.JSON_mValues.JSON())) ==> JSON_mSerializer.__default.JSON#canCall(Lit(js#0)) && (var valueOrError0#1 := Lit(JSON_mSerializer.__default.JSON(Lit(js#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) && (var js#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): DatatypeType; JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#2)))) && JSON_mAPI.__default.Serialize(true, Lit(js#0)) == (var valueOrError0#1 := Lit(JSON_mSerializer.__default.JSON(Lit(js#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#1) else (var js#2 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#1)): DatatypeType); JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#2)))));
}

function JSON_mAPI.__default.Serialize#canCall(js#0: DatatypeType) : bool;

function JSON_mAPI.__default.Serialize#requires(DatatypeType) : bool;

axiom (forall js#0: DatatypeType :: { JSON_mAPI.__default.Serialize#requires(js#0) } $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mAPI.__default.Serialize#requires(js#0) <==> true));

procedure {:verboseName "JSON.API.Serialize (well-formedness)"} CheckWellformed$$JSON_mAPI.__default.Serialize(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON())) returns (bs#0: DatatypeType where $Is(bs#0, Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.API.Serialize (well-formedness)"} CheckWellformed$$JSON_mAPI.__default.Serialize(js#0: DatatypeType) returns (bs#0: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##js#0: DatatypeType;
  var js#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##js#1: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.API.Serialize", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    assume {:captureState "libraries/src/JSON/API.dfy(16,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mAPI.__default.Serialize(reveal_JSON.API._default.Serialize, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    assume false;
    return;

  anon7_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume JSON_mSerializer.__default.JSON#canCall(js#0);
    assume let#0#0#0 == JSON_mSerializer.__default.JSON(js#0);
    assume JSON_mSerializer.__default.JSON#canCall(js#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume JSON_mAPI.__default.Serialize(reveal_JSON.API._default.Serialize, js#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#Z#0);
    assume $Is(JSON_mAPI.__default.Serialize(reveal_JSON.API._default.Serialize, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon6;

  anon8_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    havoc js#Z#0;
    assume $Is(js#Z#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#Z#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()));
    assume js#Z#0 == let#1#0#0;
    ##js#1 := js#Z#0;
    assume $IsAlloc(##js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#Z#0);
    assume JSON_mAPI.__default.Serialize(reveal_JSON.API._default.Serialize, js#0) == JSON_mZeroCopy_mAPI.__default.Serialize(reveal_JSON.ZeroCopy.API._default.Serialize, js#Z#0);
    assume JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#Z#0);
    assume $Is(JSON_mAPI.__default.Serialize(reveal_JSON.API._default.Serialize, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()));
    goto anon6;

  anon6:
    assume JSON_mAPI.__default.Serialize(reveal_JSON.API._default.Serialize, js#0) == bs#0;
    return;
}



procedure {:verboseName "JSON.API.SerializeAlloc (well-formedness)"} CheckWellFormed$$JSON_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0)) returns (bs#0: DatatypeType where $Is(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.API.SerializeAlloc (call precondtion)"} CallPre$$JSON_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0));



procedure {:verboseName "JSON.API.SerializeAlloc (call postcondition)"} CallPost$$JSON_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0)) returns (bs#0: DatatypeType where $Is(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.API.SerializeAlloc (correctness)"} Impl$$JSON_mAPI.__default.SerializeAlloc(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0)) returns (defass#bs#0: bool, bs#0: DatatypeType where defass#bs#0 ==> $Is(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(bs#0, Tclass.Wrappers.Result(Tclass._System.array(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o]);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.API.SerializeAlloc (correctness)"} Impl$$JSON_mAPI.__default.SerializeAlloc(js#0: DatatypeType) returns (defass#bs#0: bool, bs#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var js#1: DatatypeType where $Is(js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
  var ##js#0: DatatypeType;
  var $rhs##0: DatatypeType;
  var js##0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.API.SerializeAlloc", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    assume {:captureState "libraries/src/JSON/API.dfy(23,2): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap) */;
    assume true;
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume JSON_mSerializer.__default.JSON#canCall(js#0);
    assume JSON_mSerializer.__default.JSON#canCall(js#0);
    valueOrError0#0 := JSON_mSerializer.__default.JSON(js#0);
    defass#valueOrError0#0 := true;
    assume {:captureState "libraries/src/JSON/API.dfy(24,33)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass._System.array(Tclass.BoundedInts.uint8()), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass._System.array(Tclass.BoundedInts.uint8()), valueOrError0#0);
    bs#0 := Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass._System.array(Tclass.BoundedInts.uint8()), valueOrError0#0);
    defass#bs#0 := true;
    assume {:captureState "libraries/src/JSON/API.dfy(24,33)"} true;
    assume defass#bs#0;
    pop;
    return;

  anon5_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    js#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType;
    assume {:captureState "libraries/src/JSON/API.dfy(24,33)"} true;
    assume true;
    assume true;
    js##0 := js#1;
    call CallPre$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js##0);
    call $rhs##0 := CallPost$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js##0);
    bs#0 := $rhs##0;
    defass#bs#0 := true;
    assume {:captureState "libraries/src/JSON/API.dfy(25,37)"} true;
    assume defass#bs#0;
    return;
}



procedure {:verboseName "JSON.API.SerializeInto (well-formedness)"} CheckWellFormed$$JSON_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (len#0: DatatypeType where $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.API.SerializeInto (call precondtion)"} CallPre$$JSON_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap));



procedure {:verboseName "JSON.API.SerializeInto (call postcondition)"} CallPost$$JSON_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (len#0: DatatypeType where $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap));
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == bs#0);
  free ensures $HeapSucc(old($Heap), $Heap);



procedure {:verboseName "JSON.API.SerializeInto (correctness)"} Impl$$JSON_mAPI.__default.SerializeInto(js#0: DatatypeType where $Is(js#0, Tclass.JSON_mValues.JSON()) && $IsAlloc(js#0, Tclass.JSON_mValues.JSON(), $Heap) && $IsA#JSON_mValues.JSON(js#0), bs#0: ref where $Is(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8())) && $IsAlloc(bs#0, Tclass._System.array(Tclass.BoundedInts.uint8()), $Heap)) returns (defass#len#0: bool, len#0: DatatypeType where defass#len#0 ==> $Is(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(len#0, Tclass.Wrappers.Result(Tclass.BoundedInts.uint32(), Tclass.JSON_mErrors.SerializationError()), $Heap), $_reverifyPost: bool);
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;
  free ensures (forall $o: ref :: { $Heap[$o] } $o != null && $Unbox(read(old($Heap), $o, alloc)): bool ==> $Heap[$o] == old($Heap)[$o] || $o == bs#0);
  free ensures $HeapSucc(old($Heap), $Heap);



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.API.SerializeInto (correctness)"} Impl$$JSON_mAPI.__default.SerializeInto(js#0: DatatypeType, bs#0: ref) returns (defass#len#0: bool, len#0: DatatypeType, $_reverifyPost: bool)
{
  var $_ModifiesFrame: [ref,Field]bool;
  var js#1: DatatypeType where $Is(js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#1, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
  var defass#valueOrError0#0: bool;
  var valueOrError0#0: DatatypeType where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
  var ##js#0: DatatypeType;
  var $rhs##0: DatatypeType;
  var js##0: DatatypeType;
  var bs##0: ref;

  anon0:
    assume {:print "Impl", " | ", "JSON.API.SerializeInto", " | ", js#0, " | ", bs#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    $_ModifiesFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> $o == bs#0);
    assume {:captureState "libraries/src/JSON/API.dfy(30,2): initial state"} true;
    $_reverifyPost := false;
    havoc valueOrError0#0 /* where defass#valueOrError0#0 ==> $Is(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())) && $IsAlloc(valueOrError0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap) */;
    assume true;
    ##js#0 := js#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mValues.JSON(), $Heap);
    assume JSON_mSerializer.__default.JSON#canCall(js#0);
    assume JSON_mSerializer.__default.JSON#canCall(js#0);
    valueOrError0#0 := JSON_mSerializer.__default.JSON(js#0);
    defass#valueOrError0#0 := true;
    assume {:captureState "libraries/src/JSON/API.dfy(31,33)"} true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    goto anon5_Then, anon5_Else;

  anon5_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    push;
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.Failure_q(valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError0#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError0#0);
    len#0 := Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.BoundedInts.uint32(), valueOrError0#0);
    defass#len#0 := true;
    assume {:captureState "libraries/src/JSON/API.dfy(31,33)"} true;
    assume defass#len#0;
    pop;
    return;

  anon5_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume true;
    assume defass#valueOrError0#0;
    assume $IsAllocBox($Box(valueOrError0#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Success_q(valueOrError0#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0);
    js#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#0)): DatatypeType;
    assume {:captureState "libraries/src/JSON/API.dfy(31,33)"} true;
    assume true;
    assume true;
    js##0 := js#1;
    assume true;
    bs##0 := bs#0;
    assume (forall $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool && $o == bs##0 ==> $_ModifiesFrame[$o, $f]);
    call CallPre$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js##0, bs##0);
    call $rhs##0 := CallPost$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js##0, bs##0);
    len#0 := $rhs##0;
    defass#len#0 := true;
    assume {:captureState "libraries/src/JSON/API.dfy(32,41)"} true;
    assume defass#len#0;
    return;
}



function JSON_mAPI.__default.Deserialize($reveal: bool, bs#0: Seq) : DatatypeType
uses {
axiom 0 <= $FunctionContextHeight ==> (forall $reveal: bool, bs#0: Seq :: { JSON_mAPI.__default.Deserialize($reveal, bs#0) } JSON_mAPI.__default.Deserialize#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> $Is(JSON_mAPI.__default.Deserialize($reveal, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())));
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: { JSON_mAPI.__default.Deserialize(true, bs#0) } JSON_mAPI.__default.Deserialize#canCall(bs#0) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0) && (var valueOrError0#0 := JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#0)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) && (var js#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): DatatypeType; JSON_mDeserializer.__default.JSON#canCall(js#0)))) && JSON_mAPI.__default.Deserialize(true, bs#0) == (var valueOrError0#0 := JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#0) else (var js#0 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#0)): DatatypeType; JSON_mDeserializer.__default.JSON(js#0)))));
axiom 0 <= $FunctionContextHeight ==> (forall bs#0: Seq :: {:weight 3} { JSON_mAPI.__default.Deserialize(true, Lit(bs#0)) } JSON_mAPI.__default.Deserialize#canCall(Lit(bs#0)) || (0 < $FunctionContextHeight && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(Lit(bs#0)) && (var valueOrError0#1 := JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, Lit(bs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#1)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) && (var js#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): DatatypeType; JSON_mDeserializer.__default.JSON#canCall(js#1)))) && JSON_mAPI.__default.Deserialize(true, Lit(bs#0)) == (var valueOrError0#1 := JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, Lit(bs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#1) else (var js#1 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#1)): DatatypeType; JSON_mDeserializer.__default.JSON(js#1)))));
}

function JSON_mAPI.__default.Deserialize#canCall(bs#0: Seq) : bool;

function JSON_mAPI.__default.Deserialize#requires(Seq) : bool;

axiom (forall bs#0: Seq :: { JSON_mAPI.__default.Deserialize#requires(bs#0) } $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mAPI.__default.Deserialize#requires(bs#0) <==> true));

procedure {:verboseName "JSON.API.Deserialize (well-formedness)"} CheckWellformed$$JSON_mAPI.__default.Deserialize(bs#0: Seq where $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) returns (js#2: DatatypeType where $Is(js#2, Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())));
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



implementation {:smt_option "smt.arith.solver", "2"} {:verboseName "JSON.API.Deserialize (well-formedness)"} CheckWellformed$$JSON_mAPI.__default.Deserialize(bs#0: Seq) returns (js#2: DatatypeType)
{
  var $_ReadsFrame: [ref,Field]bool;
  var valueOrError0#Z#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##bs#0: Seq;
  var js#Z#0: DatatypeType;
  var let#1#0#0: DatatypeType;
  var ##js#0: DatatypeType;

  anon0:
    assume {:print "Impl", " | ", "JSON.API.Deserialize", " | ", bs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    assume {:captureState "libraries/src/JSON/API.dfy(35,21): initial state"} true;
    $_ReadsFrame := (lambda $o: ref, $f: Field :: $o != null && $Unbox(read($Heap, $o, alloc)): bool ==> false);
    goto anon7_Then, anon7_Else;

  anon7_Then:
    assume $Is(JSON_mAPI.__default.Deserialize(reveal_JSON.API._default.Deserialize, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    assume false;
    return;

  anon7_Else:
    havoc valueOrError0#Z#0;
    assume $Is(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(valueOrError0#Z#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    ##bs#0 := bs#0;
    assume $IsAlloc(##bs#0, TSeq(Tclass.BoundedInts.uint8()), $Heap);
    assume JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0);
    assume let#0#0#0 == JSON_mZeroCopy_mAPI.__default.Deserialize(reveal_JSON.ZeroCopy.API._default.Deserialize, bs#0);
    assume JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0);
    assume $Is(let#0#0#0, Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()));
    assume valueOrError0#Z#0 == let#0#0#0;
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    goto anon8_Then, anon8_Else;

  anon8_Then:
    assume {:partition} Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.Failure_q(valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#Z#0);
    assume JSON_mAPI.__default.Deserialize(reveal_JSON.API._default.Deserialize, bs#0) == Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#Z#0);
    assume Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#Z#0);
    assume $Is(JSON_mAPI.__default.Deserialize(reveal_JSON.API._default.Deserialize, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    goto anon6;

  anon8_Else:
    assume {:partition} !Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    havoc js#Z#0;
    assume $Is(js#Z#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $IsAlloc(js#Z#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume $IsAllocBox($Box(valueOrError0#Z#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError()), $Heap);
    assume {:subsumption 0} Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Success_q(valueOrError0#Z#0);
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume JSON_mGrammar.Structural.Structural_q($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): DatatypeType);
    assume let#1#0#0 == $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0)): DatatypeType;
    assume Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#Z#0);
    assume $Is(let#1#0#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()));
    assume js#Z#0 == let#1#0#0;
    ##js#0 := js#Z#0;
    assume $IsAlloc(##js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), $Heap);
    assume JSON_mDeserializer.__default.JSON#canCall(js#Z#0);
    assume JSON_mAPI.__default.Deserialize(reveal_JSON.API._default.Deserialize, bs#0) == JSON_mDeserializer.__default.JSON(js#Z#0);
    assume JSON_mDeserializer.__default.JSON#canCall(js#Z#0);
    assume $Is(JSON_mAPI.__default.Deserialize(reveal_JSON.API._default.Deserialize, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError()));
    goto anon6;

  anon6:
    assume JSON_mAPI.__default.Deserialize(reveal_JSON.API._default.Deserialize, bs#0) == js#2;
    return;
}



procedure {:verboseName "JSON.API.reveal_Serialize (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mAPI.__default.reveal__Serialize();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.API.reveal_Serialize (call precondtion)"} {:verify false} CallPre$$JSON_mAPI.__default.reveal__Serialize();



procedure {:verboseName "JSON.API.reveal_Serialize (call postcondition)"} {:verify false} CallPost$$JSON_mAPI.__default.reveal__Serialize();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.API._default.Serialize;



procedure {:verboseName "JSON.API.reveal_Deserialize (well-formedness)"} {:verify false} CheckWellFormed$$JSON_mAPI.__default.reveal__Deserialize();
  free requires 0 == $FunctionContextHeight;
  modifies $Heap;



procedure {:verboseName "JSON.API.reveal_Deserialize (call precondtion)"} {:verify false} CallPre$$JSON_mAPI.__default.reveal__Deserialize();



procedure {:verboseName "JSON.API.reveal_Deserialize (call postcondition)"} {:verify false} CallPost$$JSON_mAPI.__default.reveal__Deserialize();
  modifies $Heap;
  free ensures old($Heap) == $Heap;
  free ensures reveal_JSON.API._default.Deserialize;



axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: { Wrappers.Option.ToResult(Wrappers.Option$T, this) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, this) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, this) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#272 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#272))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) } Wrappers.Option.ToResult#canCall(Wrappers.Option$T, Lit(this)) || $Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) ==> Wrappers.Option.ToResult(Wrappers.Option$T, Lit(this)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(112))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(78))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101)))))) else (var v#274 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#274)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, this, error#0) == (if Wrappers.Option.None_q(this) then #Wrappers.Result.Failure(error#0) else (var v#408 := Wrappers.Option.value(this); #Wrappers.Result.Success(v#408))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), error#0) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(error#0) else (var v#410 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#410)))));

axiom (forall Wrappers.Option$T: Ty, Wrappers.Option.ToResult'$R: Ty, this: DatatypeType, error#0: Box :: {:weight 3} { Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) } Wrappers.Option.ToResult_k#canCall(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(error#0, Wrappers.Option.ToResult'$R)) ==> Wrappers.Option.ToResult_k(Wrappers.Option$T, Wrappers.Option.ToResult'$R, Lit(this), Lit(error#0)) == (if Wrappers.Option.None_q(Lit(this)) then #Wrappers.Result.Failure(Lit(error#0)) else (var v#412 := Lit(Wrappers.Option.value(Lit(this))); Lit(#Wrappers.Result.Success(v#412)))));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, this, default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, this, default#0) == (if Wrappers.Option.None_q(this) then default#0 else (var v#408 := Wrappers.Option.value(this); v#408)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), default#0) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#410 := Lit(Wrappers.Option.value(Lit(this))); v#410)));

axiom (forall Wrappers.Option$T: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) } Wrappers.Option.UnwrapOr#canCall(Wrappers.Option$T, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Option(Wrappers.Option$T)) && $IsBox(default#0, Wrappers.Option$T)) ==> Wrappers.Option.UnwrapOr(Wrappers.Option$T, Lit(this), Lit(default#0)) == (if Wrappers.Option.None_q(Lit(this)) then default#0 else (var v#412 := Lit(Wrappers.Option.value(Lit(this))); v#412)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, this) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, this) == (if Wrappers.Result.Success_q(this) then (var s#272 := Wrappers.Result.value(this); #Wrappers.Option.Some(s#272)) else (var e#272 := Wrappers.Result.error(this); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType :: {:weight 3} { Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) } Wrappers.Result.ToOption#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) || $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) ==> Wrappers.Result.ToOption(Wrappers.Result$T, Wrappers.Result$R, Lit(this)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#274 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Option.Some(s#274))) else (var e#274 := Lit(Wrappers.Result.error(Lit(this))); Lit(#Wrappers.Option.None()))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, this, default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, this, default#0) == (if Wrappers.Result.Success_q(this) then (var s#408 := Wrappers.Result.value(this); s#408) else (var e#408 := Wrappers.Result.error(this); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), default#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#410 := Lit(Wrappers.Result.value(Lit(this))); s#410) else (var e#410 := Lit(Wrappers.Result.error(Lit(this))); default#0)));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, this: DatatypeType, default#0: Box :: {:weight 3} { Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) } Wrappers.Result.UnwrapOr#canCall(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) || ($Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsBox(default#0, Wrappers.Result$T)) ==> Wrappers.Result.UnwrapOr(Wrappers.Result$T, Wrappers.Result$R, Lit(this), Lit(default#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#412 := Lit(Wrappers.Result.value(Lit(this))); s#412) else (var e#412 := Lit(Wrappers.Result.error(Lit(this))); Lit(default#0))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, this, reWrap#0) == (if Wrappers.Result.Success_q(this) then (var s#408 := Wrappers.Result.value(this); #Wrappers.Result.Success(s#408)) else (var e#408 := Wrappers.Result.error(this); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#408)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), reWrap#0) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#410 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#410))) else (var e#410 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, reWrap#0, e#410)))));

axiom (forall Wrappers.Result$T: Ty, Wrappers.Result$R: Ty, Wrappers.Result.MapFailure$NewR: Ty, $Heap: Heap, this: DatatypeType, reWrap#0: HandleType :: {:weight 3} { Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)), $IsGoodHeap($Heap) } Wrappers.Result.MapFailure#canCall(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R)) && $IsAlloc(this, Tclass.Wrappers.Result(Wrappers.Result$T, Wrappers.Result$R), $Heap) && $Is(reWrap#0, Tclass._System.___hTotalFunc1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR))) ==> Wrappers.Result.MapFailure(Wrappers.Result$T, Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, Lit(this), Lit(reWrap#0)) == (if Wrappers.Result.Success_q(Lit(this)) then (var s#412 := Lit(Wrappers.Result.value(Lit(this))); Lit(#Wrappers.Result.Success(s#412))) else (var e#412 := Lit(Wrappers.Result.error(Lit(this))); #Wrappers.Result.Failure(Apply1(Wrappers.Result$R, Wrappers.Result.MapFailure$NewR, $Heap, Lit(reWrap#0), e#412)))));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, R#0) <==> (forall x#30: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#30, x#30)): bool } $IsBox(x#30, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#30, x#30)): bool)));

axiom (forall Relations._default.Reflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Reflexive#canCall(Relations._default.Reflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool))) ==> (Relations.__default.Reflexive(Relations._default.Reflexive$T, Lit(R#0)) <==> (forall x#31: Box :: { $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, R#0, x#31, x#31)): bool } $IsBox(x#31, Relations._default.Reflexive$T) ==> $Unbox(Apply2(Relations._default.Reflexive$T, Relations._default.Reflexive$T, TBool, $Heap, Lit(R#0), x#31, x#31)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, R#0) <==> (forall x#30: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#30, x#30)): bool } $IsBox(x#30, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#30, x#30)): bool)));

axiom (forall Relations._default.Irreflexive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Irreflexive#canCall(Relations._default.Irreflexive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool))) ==> (Relations.__default.Irreflexive(Relations._default.Irreflexive$T, Lit(R#0)) <==> (forall x#31: Box :: { $Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, R#0, x#31, x#31)): bool } $IsBox(x#31, Relations._default.Irreflexive$T) ==> !$Unbox(Apply2(Relations._default.Irreflexive$T, Relations._default.Irreflexive$T, TBool, $Heap, Lit(R#0), x#31, x#31)): bool)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, R#0) <==> (forall x#30: Box, y#30: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#30, x#30)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#30, y#30)): bool } $IsBox(x#30, Relations._default.AntiSymmetric$T) && $IsBox(y#30, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#30, y#30)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#30, x#30)): bool ==> x#30 == y#30)));

axiom (forall Relations._default.AntiSymmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.AntiSymmetric#canCall(Relations._default.AntiSymmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool))) ==> (Relations.__default.AntiSymmetric(Relations._default.AntiSymmetric$T, Lit(R#0)) <==> (forall x#31: Box, y#31: Box :: { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, y#31, x#31)): bool } { $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, R#0, x#31, y#31)): bool } $IsBox(x#31, Relations._default.AntiSymmetric$T) && $IsBox(y#31, Relations._default.AntiSymmetric$T) ==> $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), x#31, y#31)): bool && $Unbox(Apply2(Relations._default.AntiSymmetric$T, Relations._default.AntiSymmetric$T, TBool, $Heap, Lit(R#0), y#31, x#31)): bool ==> x#31 == y#31)));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, R#0) <==> (forall x#30: Box, y#30: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#30, x#30)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#30, y#30)): bool } $IsBox(x#30, Relations._default.Symmetric$T) && $IsBox(y#30, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#30, y#30)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#30, x#30)): bool))));

axiom (forall Relations._default.Symmetric$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Symmetric#canCall(Relations._default.Symmetric$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool))) ==> (Relations.__default.Symmetric(Relations._default.Symmetric$T, Lit(R#0)) <==> (forall x#31: Box, y#31: Box :: { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, y#31, x#31)): bool } { $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, R#0, x#31, y#31)): bool } $IsBox(x#31, Relations._default.Symmetric$T) && $IsBox(y#31, Relations._default.Symmetric$T) ==> ($Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), x#31, y#31)): bool <==> $Unbox(Apply2(Relations._default.Symmetric$T, Relations._default.Symmetric$T, TBool, $Heap, Lit(R#0), y#31, x#31)): bool))));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Connected(Relations._default.Connected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, R#0) <==> (forall x#30: Box, y#30: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#30, x#30)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#30, y#30)): bool } $IsBox(x#30, Relations._default.Connected$T) && $IsBox(y#30, Relations._default.Connected$T) ==> x#30 != y#30 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#30, y#30)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#30, x#30)): bool)));

axiom (forall Relations._default.Connected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Connected#canCall(Relations._default.Connected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Connected$T, Relations._default.Connected$T, TBool))) ==> (Relations.__default.Connected(Relations._default.Connected$T, Lit(R#0)) <==> (forall x#31: Box, y#31: Box :: { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, y#31, x#31)): bool } { $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, R#0, x#31, y#31)): bool } $IsBox(x#31, Relations._default.Connected$T) && $IsBox(y#31, Relations._default.Connected$T) ==> x#31 != y#31 ==> $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), x#31, y#31)): bool || $Unbox(Apply2(Relations._default.Connected$T, Relations._default.Connected$T, TBool, $Heap, Lit(R#0), y#31, x#31)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, R#0) <==> (forall x#30: Box, y#30: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#30, x#30)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#30, y#30)): bool } $IsBox(x#30, Relations._default.StronglyConnected$T) && $IsBox(y#30, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#30, y#30)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#30, x#30)): bool)));

axiom (forall Relations._default.StronglyConnected$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.StronglyConnected#canCall(Relations._default.StronglyConnected$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool))) ==> (Relations.__default.StronglyConnected(Relations._default.StronglyConnected$T, Lit(R#0)) <==> (forall x#31: Box, y#31: Box :: { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, y#31, x#31)): bool } { $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, R#0, x#31, y#31)): bool } $IsBox(x#31, Relations._default.StronglyConnected$T) && $IsBox(y#31, Relations._default.StronglyConnected$T) ==> $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), x#31, y#31)): bool || $Unbox(Apply2(Relations._default.StronglyConnected$T, Relations._default.StronglyConnected$T, TBool, $Heap, Lit(R#0), y#31, x#31)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: { Relations.__default.Transitive(Relations._default.Transitive$T, R#0), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, R#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, R#0) <==> (forall x#30: Box, y#30: Box, z#30: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#30, z#30)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#30, z#30)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#30, z#30)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#30, y#30)): bool } $IsBox(x#30, Relations._default.Transitive$T) && $IsBox(y#30, Relations._default.Transitive$T) && $IsBox(z#30, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#30, y#30)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#30, z#30)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#30, z#30)): bool)));

axiom (forall Relations._default.Transitive$T: Ty, $Heap: Heap, R#0: HandleType :: {:weight 3} { Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)), $IsGoodHeap($Heap) } Relations.__default.Transitive#canCall(Relations._default.Transitive$T, Lit(R#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool))) ==> (Relations.__default.Transitive(Relations._default.Transitive$T, Lit(R#0)) <==> (forall x#31: Box, y#31: Box, z#31: Box :: { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#31, z#31)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#31, z#31)): bool } { $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, y#31, z#31)): bool, $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, R#0, x#31, y#31)): bool } $IsBox(x#31, Relations._default.Transitive$T) && $IsBox(y#31, Relations._default.Transitive$T) && $IsBox(z#31, Relations._default.Transitive$T) ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#31, y#31)): bool && $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), y#31, z#31)): bool ==> $Unbox(Apply2(Relations._default.Transitive$T, Relations._default.Transitive$T, TBool, $Heap, Lit(R#0), x#31, z#31)): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: { Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, a#0, lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, a#0, lessThan#0) <==> (forall i#44: int, j#44: int :: { Seq#Index(a#0, j#44), Seq#Index(a#0, i#44) } LitInt(0) <= i#44 && i#44 < j#44 && j#44 < Seq#Length(a#0) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(a#0, i#44), Seq#Index(a#0, j#44))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), lessThan#0) <==> (forall i#45: int, j#45: int :: { Seq#Index(a#0, j#45), Seq#Index(a#0, i#45) } LitInt(0) <= i#45 && i#45 < j#45 && j#45 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, lessThan#0, Seq#Index(Lit(a#0), i#45), Seq#Index(Lit(a#0), j#45))): bool)));

axiom (forall Relations._default.SortedBy$T: Ty, $Heap: Heap, a#0: Seq, lessThan#0: HandleType :: {:weight 3} { Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)), $IsGoodHeap($Heap) } Relations.__default.SortedBy#canCall(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) || ($IsGoodHeap($Heap) && $Is(a#0, TSeq(Relations._default.SortedBy$T)) && $Is(lessThan#0, Tclass._System.___hTotalFunc2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool))) ==> (Relations.__default.SortedBy(Relations._default.SortedBy$T, Lit(a#0), Lit(lessThan#0)) <==> (forall i#46: int, j#46: int :: { Seq#Index(a#0, j#46), Seq#Index(a#0, i#46) } LitInt(0) <= i#46 && i#46 < j#46 && j#46 < Seq#Length(Lit(a#0)) ==> $Unbox(Apply2(Relations._default.SortedBy$T, Relations._default.SortedBy$T, TBool, $Heap, Lit(lessThan#0), Seq#Index(Lit(a#0), i#46), Seq#Index(Lit(a#0), j#46))): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#44: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#44)): bool } { s#0[x#44] } $IsBox(x#44, Relations._default.IsLeast$T) && s#0[x#44] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#44)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#45: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#45)): bool } { s#0[x#45] } $IsBox(x#45, Relations._default.IsLeast$T) && Lit(s#0)[x#45] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#45)): bool)));

axiom (forall Relations._default.IsLeast$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsLeast#canCall(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool)) && $IsBox(min#0, Relations._default.IsLeast$T) && $Is(s#0, TSet(Relations._default.IsLeast$T))) ==> (Relations.__default.IsLeast(Relations._default.IsLeast$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#46: Box :: { $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, R#0, min#0, x#46)): bool } { s#0[x#46] } $IsBox(x#46, Relations._default.IsLeast$T) && Lit(s#0)[x#46] ==> $Unbox(Apply2(Relations._default.IsLeast$T, Relations._default.IsLeast$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#46)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, s#0) <==> s#0[min#0] && (forall x#44: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#44)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#44, min#0)): bool } { s#0[x#44] } $IsBox(x#44, Relations._default.IsMinimal$T) && s#0[x#44] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#44, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#44)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, R#0, min#0, Lit(s#0)) <==> Lit(s#0)[min#0] && (forall x#45: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#45)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#45, min#0)): bool } { s#0[x#45] } $IsBox(x#45, Relations._default.IsMinimal$T) && Lit(s#0)[x#45] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#45, min#0)): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#45)): bool)));

axiom (forall Relations._default.IsMinimal$T: Ty, $Heap: Heap, R#0: HandleType, min#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMinimal#canCall(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool)) && $IsBox(min#0, Relations._default.IsMinimal$T) && $Is(s#0, TSet(Relations._default.IsMinimal$T))) ==> (Relations.__default.IsMinimal(Relations._default.IsMinimal$T, Lit(R#0), Lit(min#0), Lit(s#0)) <==> Lit(s#0)[Lit(min#0)] && (forall x#46: Box :: { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, min#0, x#46)): bool } { $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, R#0, x#46, min#0)): bool } { s#0[x#46] } $IsBox(x#46, Relations._default.IsMinimal$T) && Lit(s#0)[x#46] && $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), x#46, Lit(min#0))): bool ==> $Unbox(Apply2(Relations._default.IsMinimal$T, Relations._default.IsMinimal$T, TBool, $Heap, Lit(R#0), Lit(min#0), x#46)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#44: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#44, max#0)): bool } { s#0[x#44] } $IsBox(x#44, Relations._default.IsGreatest$T) && s#0[x#44] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#44, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#45: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#45, max#0)): bool } { s#0[x#45] } $IsBox(x#45, Relations._default.IsGreatest$T) && Lit(s#0)[x#45] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#45, max#0)): bool)));

axiom (forall Relations._default.IsGreatest$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsGreatest#canCall(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool)) && $IsBox(max#0, Relations._default.IsGreatest$T) && $Is(s#0, TSet(Relations._default.IsGreatest$T))) ==> (Relations.__default.IsGreatest(Relations._default.IsGreatest$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#46: Box :: { $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, R#0, x#46, max#0)): bool } { s#0[x#46] } $IsBox(x#46, Relations._default.IsGreatest$T) && Lit(s#0)[x#46] ==> $Unbox(Apply2(Relations._default.IsGreatest$T, Relations._default.IsGreatest$T, TBool, $Heap, Lit(R#0), x#46, Lit(max#0))): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, s#0) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, s#0) <==> s#0[max#0] && (forall x#44: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#44, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#44)): bool } { s#0[x#44] } $IsBox(x#44, Relations._default.IsMaximal$T) && s#0[x#44] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#44)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#44, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, R#0, max#0, Lit(s#0)) <==> Lit(s#0)[max#0] && (forall x#45: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#45, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#45)): bool } { s#0[x#45] } $IsBox(x#45, Relations._default.IsMaximal$T) && Lit(s#0)[x#45] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#45)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#45, max#0)): bool)));

axiom (forall Relations._default.IsMaximal$T: Ty, $Heap: Heap, R#0: HandleType, max#0: Box, s#0: Set :: {:weight 3} { Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)), $IsGoodHeap($Heap) } Relations.__default.IsMaximal#canCall(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(R#0, Tclass._System.___hTotalFunc2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool)) && $IsBox(max#0, Relations._default.IsMaximal$T) && $Is(s#0, TSet(Relations._default.IsMaximal$T))) ==> (Relations.__default.IsMaximal(Relations._default.IsMaximal$T, Lit(R#0), Lit(max#0), Lit(s#0)) <==> Lit(s#0)[Lit(max#0)] && (forall x#46: Box :: { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, x#46, max#0)): bool } { $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, R#0, max#0, x#46)): bool } { s#0[x#46] } $IsBox(x#46, Relations._default.IsMaximal$T) && Lit(s#0)[x#46] && $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), Lit(max#0), x#46)): bool ==> $Unbox(Apply2(Relations._default.IsMaximal$T, Relations._default.IsMaximal$T, TBool, $Heap, Lit(R#0), x#46, Lit(max#0))): bool)));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, a#0, lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(a#0) ==> (var splitIndex#39 := Div(Seq#Length(a#0), LitInt(2)); (var left#39, right#39 := Seq#Take(a#0, splitIndex#39), Seq#Drop(a#0, splitIndex#39); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#39, lessThanOrEq#0) && (var leftSorted#39 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#39, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#39, lessThanOrEq#0) && (var rightSorted#39 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#39, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#39, rightSorted#39, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), a#0, lessThanOrEq#0) == (if Seq#Length(a#0) <= LitInt(1) then a#0 else (var splitIndex#39 := Div(Seq#Length(a#0), LitInt(2)); (var left#39, right#39 := Seq#Take(a#0, splitIndex#39), Seq#Drop(a#0, splitIndex#39); (var leftSorted#39 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, left#39, lessThanOrEq#0); (var rightSorted#39 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $ly, right#39, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#39, rightSorted#39, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), lessThanOrEq#0) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, lessThanOrEq#0)) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#40 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#40, right#40 := Seq#Take(Lit(a#0), splitIndex#40), Seq#Drop(Lit(a#0), splitIndex#40); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#40, lessThanOrEq#0) && (var leftSorted#40 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#40, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#40, lessThanOrEq#0) && (var rightSorted#40 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#40, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#40, rightSorted#40, lessThanOrEq#0)))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), lessThanOrEq#0) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#40 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#40, right#40 := Seq#Take(Lit(a#0), splitIndex#40), Seq#Drop(Lit(a#0), splitIndex#40); (var leftSorted#40 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#40, lessThanOrEq#0); (var rightSorted#40 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#40, lessThanOrEq#0); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#40, rightSorted#40, lessThanOrEq#0)))))));

axiom (forall Seq.MergeSort._default.MergeSortBy$T: Ty, $ly: LayerType, a#0: Seq, lessThanOrEq#0: HandleType :: {:weight 3} { Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) } Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, Lit(a#0), Lit(lessThanOrEq#0)) || ($Is(a#0, TSeq(Seq.MergeSort._default.MergeSortBy$T)) && $Is(lessThanOrEq#0, Tclass._System.___hTotalFunc2(Seq.MergeSort._default.MergeSortBy$T, Seq.MergeSort._default.MergeSortBy$T, TBool)) && Lit(Relations.__default.TotalOrdering(Seq.MergeSort._default.MergeSortBy$T, Lit(lessThanOrEq#0)))) ==> (LitInt(1) < Seq#Length(Lit(a#0)) ==> (var splitIndex#41 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#41, right#41 := Seq#Take(Lit(a#0), splitIndex#41), Seq#Drop(Lit(a#0), splitIndex#41); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, left#41, Lit(lessThanOrEq#0)) && (var leftSorted#41 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#41, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortBy#canCall(Seq.MergeSort._default.MergeSortBy$T, right#41, Lit(lessThanOrEq#0)) && (var rightSorted#41 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#41, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith#canCall(Seq.MergeSort._default.MergeSortBy$T, leftSorted#41, rightSorted#41, Lit(lessThanOrEq#0))))))) && Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), Lit(a#0), Lit(lessThanOrEq#0)) == (if Seq#Length(Lit(a#0)) <= LitInt(1) then a#0 else (var splitIndex#41 := Div(Seq#Length(Lit(a#0)), LitInt(2)); (var left#41, right#41 := Seq#Take(Lit(a#0), splitIndex#41), Seq#Drop(Lit(a#0), splitIndex#41); (var leftSorted#41 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), left#41, Lit(lessThanOrEq#0)); (var rightSorted#41 := Seq_mMergeSort.__default.MergeSortBy(Seq.MergeSort._default.MergeSortBy$T, $LS($ly), right#41, Lit(lessThanOrEq#0)); Seq_mMergeSort.__default.MergeSortedWith(Seq.MergeSort._default.MergeSortBy$T, $LS($LZ), leftSorted#41, rightSorted#41, Lit(lessThanOrEq#0))))))));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: { Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, xs#0) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, xs#0) == (lambda $y#26: Box :: $IsBox($y#26, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#26)));

axiom (forall Seq._default.ToSet$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) } Seq.__default.ToSet#canCall(Seq._default.ToSet$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.ToSet$T)) ==> Seq.__default.ToSet(Seq._default.ToSet$T, true, Lit(xs#0)) == (lambda $y#27: Box :: $IsBox($y#27, Seq._default.ToSet$T) && Seq#Contains(xs#0, $y#27)));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, xs#0) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, xs#0) <==> (forall i#26: int, j#26: int :: { Seq#Index(xs#0, j#26), Seq#Index(xs#0, i#26) } LitInt(0) <= i#26 && i#26 < Seq#Length(xs#0) && LitInt(0) <= j#26 && j#26 < Seq#Length(xs#0) && i#26 != j#26 ==> Seq#Index(xs#0, i#26) != Seq#Index(xs#0, j#26))));

axiom (forall Seq._default.HasNoDuplicates$T: Ty, xs#0: Seq :: {:weight 3} { Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) } Seq.__default.HasNoDuplicates#canCall(Seq._default.HasNoDuplicates$T, Lit(xs#0)) || $Is(xs#0, TSeq(Seq._default.HasNoDuplicates$T)) ==> (Seq.__default.HasNoDuplicates(Seq._default.HasNoDuplicates$T, true, Lit(xs#0)) <==> (forall i#27: int, j#27: int :: { Seq#Index(xs#0, j#27), Seq#Index(xs#0, i#27) } LitInt(0) <= i#27 && i#27 < Seq#Length(Lit(xs#0)) && LitInt(0) <= j#27 && j#27 < Seq#Length(Lit(xs#0)) && i#27 != j#27 ==> Seq#Index(Lit(xs#0), i#27) != Seq#Index(Lit(xs#0), j#27))));

axiom (forall Seq._default.IndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOf#canCall(Seq._default.IndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOf$T)) && $IsBox(v#0, Seq._default.IndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#14: int :: { Seq#Index(xs#0, j#14) } LitInt(0) <= j#14 && j#14 < Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0) ==> Seq#Index(xs#0, j#14) != v#0) && LitInt(0) <= Seq.__default.IndexOf(Seq._default.IndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#14: int :: { Seq#Index(xs#0, j#14) } LitInt(0) <= j#14 && j#14 < $Unbox(Wrappers.Option.value(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0))): int ==> Seq#Index(xs#0, j#14) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq#Index(xs#0, LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Seq#Drop(xs#0, LitInt(1)), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, xs#0, v#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(xs#0, LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#36 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $ly, reveal_Seq._default.IndexOfOption, Seq#Drop(xs#0, LitInt(1)), v#0); (if Wrappers.Option.Some_q(o'#36) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#36)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != v#0 ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0)) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), v#0) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == v#0 then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#37 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), v#0); (if Wrappers.Option.Some_q(o'#37) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#37)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.IndexOfOption$T: Ty, $ly: LayerType, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) } Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.IndexOfOption$T)) && $IsBox(v#0, Seq._default.IndexOfOption$T)) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq#Index(Lit(xs#0), LitInt(0)) != Lit(v#0) ==> Seq.__default.IndexOfOption#canCall(Seq._default.IndexOfOption$T, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0))) && Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), true, Lit(xs#0), Lit(v#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #Wrappers.Option.None() else (if Seq#Index(Lit(xs#0), LitInt(0)) == Lit(v#0) then #Wrappers.Option.Some($Box(LitInt(0))) else (var o'#38 := Seq.__default.IndexOfOption(Seq._default.IndexOfOption$T, $LS($ly), reveal_Seq._default.IndexOfOption, Lit(Seq#Drop(Lit(xs#0), LitInt(1))), Lit(v#0)); (if Wrappers.Option.Some_q(o'#38) then #Wrappers.Option.Some($Box($Unbox(Wrappers.Option.value(o'#38)): int + 1)) else #Wrappers.Option.None())))));

axiom (forall Seq._default.LastIndexOf$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOf#canCall(Seq._default.LastIndexOf$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOf$T)) && $IsBox(v#0, Seq._default.LastIndexOf$T) && Seq#Contains(xs#0, v#0)) ==> Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < Seq#Length(xs#0) && Seq#Index(xs#0, Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0)) == v#0 && (forall j#14: int :: { Seq#Index(xs#0, j#14) } Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0) < j#14 && j#14 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#14) != v#0) && LitInt(0) <= Seq.__default.LastIndexOf(Seq._default.LastIndexOf$T, $ly, $reveal, xs#0, v#0));

axiom (forall Seq._default.LastIndexOfOption$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, v#0: Box :: { Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0) } Seq.__default.LastIndexOfOption#canCall(Seq._default.LastIndexOfOption$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.LastIndexOfOption$T)) && $IsBox(v#0, Seq._default.LastIndexOfOption$T)) ==> (if Wrappers.Option.Some_q(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0)) then $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < Seq#Length(xs#0) && Seq#Index(xs#0, $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int) == v#0 && (forall j#14: int :: { Seq#Index(xs#0, j#14) } $Unbox(Wrappers.Option.value(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0))): int < j#14 && j#14 < Seq#Length(xs#0) ==> Seq#Index(xs#0, j#14) != v#0) else !Seq#Contains(xs#0, v#0)) && $Is(Seq.__default.LastIndexOfOption(Seq._default.LastIndexOfOption$T, $ly, $reveal, xs#0, v#0), Tclass.Wrappers.Option(Tclass._System.nat())));

axiom (forall Seq._default.Remove$T: Ty, $reveal: bool, xs#0: Seq, pos#0: int :: { Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0) } Seq.__default.Remove#canCall(Seq._default.Remove$T, xs#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Remove$T)) && LitInt(0) <= pos#0 && pos#0 < Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0)) == Seq#Length(xs#0) - 1 && (forall i#28: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#28), Seq#Index(xs#0, i#28) } LitInt(0) <= i#28 && i#28 < pos#0 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#28) == Seq#Index(xs#0, i#28)) && (forall i#29: int :: { Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#29) } pos#0 <= i#29 && i#29 < Seq#Length(xs#0) - 1 ==> Seq#Index(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), i#29) == Seq#Index(xs#0, i#29 + 1)) && $Is(Seq.__default.Remove(Seq._default.Remove$T, $reveal, xs#0, pos#0), TSeq(Seq._default.Remove$T)));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, xs#0, v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, xs#0, v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, xs#0, v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#36 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, xs#0, v#0); Seq#Append(Seq#Take(xs#0, i#36), Seq#Drop(xs#0, i#36 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), v#0)) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), v#0) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#37 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), v#0); Seq#Append(Seq#Take(Lit(xs#0), i#37), Seq#Drop(Lit(xs#0), i#37 + 1)))));

axiom (forall Seq._default.RemoveValue$T: Ty, xs#0: Seq, v#0: Box :: {:weight 3} { Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) } Seq.__default.RemoveValue#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0)) || ($Is(xs#0, TSeq(Seq._default.RemoveValue$T)) && $IsBox(v#0, Seq._default.RemoveValue$T)) ==> (Seq#Contains(xs#0, v#0) ==> Seq.__default.IndexOf#canCall(Seq._default.RemoveValue$T, Lit(xs#0), Lit(v#0))) && Seq.__default.RemoveValue(Seq._default.RemoveValue$T, true, Lit(xs#0), Lit(v#0)) == (if !Seq#Contains(xs#0, v#0) then xs#0 else (var i#38 := Seq.__default.IndexOf(Seq._default.RemoveValue$T, $LS($LZ), reveal_Seq._default.IndexOf, Lit(xs#0), Lit(v#0)); Seq#Append(Seq#Take(Lit(xs#0), i#38), Seq#Drop(Lit(xs#0), i#38 + 1)))));

axiom (forall Seq._default.Insert$T: Ty, $reveal: bool, xs#0: Seq, a#0: Box, pos#0: int :: { Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0) } Seq.__default.Insert#canCall(Seq._default.Insert$T, xs#0, a#0, pos#0) || ($Is(xs#0, TSeq(Seq._default.Insert$T)) && $IsBox(a#0, Seq._default.Insert$T) && LitInt(0) <= pos#0 && pos#0 <= Seq#Length(xs#0)) ==> Seq#Length(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)) == Seq#Length(xs#0) + 1 && (forall i#28: int :: { Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#28), Seq#Index(xs#0, i#28) } LitInt(0) <= i#28 && i#28 < pos#0 ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#28) == Seq#Index(xs#0, i#28)) && (forall i#29: int :: { Seq#Index(xs#0, i#29) } pos#0 <= i#29 && i#29 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), i#29 + 1) == Seq#Index(xs#0, i#29)) && Seq#Index(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0), pos#0) == a#0 && MultiSet#Equal(MultiSet#FromSeq(Seq.__default.Insert(Seq._default.Insert$T, reveal_Seq._default.Insert, xs#0, a#0, pos#0)), MultiSet#Union(MultiSet#FromSeq(xs#0), MultiSet#UnionOne(MultiSet#Empty(): MultiSet, a#0))) && $Is(Seq.__default.Insert(Seq._default.Insert$T, $reveal, xs#0, a#0, pos#0), TSeq(Seq._default.Insert$T)));

axiom (forall Seq._default.Reverse$T: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0) } Seq.__default.Reverse#canCall(Seq._default.Reverse$T, xs#0) || $Is(xs#0, TSeq(Seq._default.Reverse$T)) ==> Seq#Length(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0)) == Seq#Length(xs#0) && (forall i#14: int :: { Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#14) } { Seq#Index(xs#0, Seq#Length(xs#0) - i#14 - 1) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), i#14) == Seq#Index(xs#0, Seq#Length(xs#0) - i#14 - 1)) && $Is(Seq.__default.Reverse(Seq._default.Reverse$T, $ly, $reveal, xs#0), TSeq(Seq._default.Reverse$T)));

axiom (forall Seq._default.Repeat$T: Ty, $ly: LayerType, $reveal: bool, v#0: Box, length#0: int :: { Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0) } Seq.__default.Repeat#canCall(Seq._default.Repeat$T, v#0, length#0) || ($IsBox(v#0, Seq._default.Repeat$T) && LitInt(0) <= length#0) ==> Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) == length#0 && (forall i#14: int :: { Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0)) ==> Seq#Index(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), i#14) == v#0) && $Is(Seq.__default.Repeat(Seq._default.Repeat$T, $ly, $reveal, v#0, length#0), TSeq(Seq._default.Repeat$T)));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> Seq#Length($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) && Seq#Length($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#14: int :: { Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#14) } { Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#14) } LitInt(0) <= i#14 && i#14 < Seq#Length(xs#0) ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#14), Seq#Index($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, xs#0))): Seq, i#14)), $Unbox(Seq#Index(xs#0, i#14)): DatatypeType)) && $Is(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, $reveal, xs#0), Tclass._System.Tuple2(TSeq(Seq._default.Unzip$A), TSeq(Seq._default.Unzip$B))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, xs#0) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0) && _System.Tuple2.___hMake2_q($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#24, b#24 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $ly, reveal_Seq._default.Unzip, Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#24, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._0($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType)))), $Box(Seq#Append(b#24, Seq#Build(Seq#Empty(): Seq, _System.Tuple2._1($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), xs#0)): DatatypeType))))))));

axiom (forall Seq._default.Unzip$A: Ty, Seq._default.Unzip$B: Ty, $ly: LayerType, xs#0: Seq :: {:weight 3} { Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) } Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(xs#0)) || $Is(xs#0, TSeq(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B))) ==> (Seq#Length(Lit(xs#0)) != LitInt(0) ==> Seq.__default.DropLast#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && Seq.__default.Unzip#canCall(Seq._default.Unzip$A, Seq._default.Unzip$B, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)) && Seq.__default.Last#canCall(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)) && _System.Tuple2.___hMake2_q(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))) && Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), true, Lit(xs#0)) == (if Seq#Length(Lit(xs#0)) == LitInt(0) then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq)), $Box(Lit(Seq#Empty(): Seq))) else (var a#25, b#25 := $Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq, $Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Unzip$A, Seq._default.Unzip$B, $LS($ly), reveal_Seq._default.Unzip, Lit(Seq.__default.DropLast(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0)))))): Seq; #_System._tuple#2._#Make2($Box(Seq#Append(a#25, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._0(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType)))))), $Box(Seq#Append(b#25, Seq#Build(Seq#Empty(): Seq, Lit(_System.Tuple2._1(Lit($Unbox(Seq.__default.Last(Tclass._System.Tuple2(Seq._default.Unzip$A, Seq._default.Unzip$B), Lit(xs#0))): DatatypeType))))))))));

axiom (forall Seq._default.Zip$A: Ty, Seq._default.Zip$B: Ty, $ly: LayerType, $reveal: bool, xs#0: Seq, ys#0: Seq :: { Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0) } Seq.__default.Zip#canCall(Seq._default.Zip$A, Seq._default.Zip$B, xs#0, ys#0) || ($Is(xs#0, TSeq(Seq._default.Zip$A)) && $Is(ys#0, TSeq(Seq._default.Zip$B)) && Seq#Length(xs#0) == Seq#Length(ys#0)) ==> Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) == Seq#Length(xs#0) && (forall i#14: int :: { $Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#14)): DatatypeType } LitInt(0) <= i#14 && i#14 < Seq#Length(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)) ==> _System.Tuple2#Equal($Unbox(Seq#Index(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0), i#14)): DatatypeType, #_System._tuple#2._#Make2(Seq#Index(xs#0, i#14), Seq#Index(ys#0, i#14)))) && Seq#Equal($Unbox(_System.Tuple2._0(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, xs#0) && Seq#Equal($Unbox(_System.Tuple2._1(Seq.__default.Unzip(Seq._default.Zip$A, Seq._default.Zip$B, $LS($LZ), reveal_Seq._default.Unzip, Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, reveal_Seq._default.Zip, xs#0, ys#0)))): Seq, ys#0) && $Is(Seq.__default.Zip(Seq._default.Zip$A, Seq._default.Zip$B, $ly, $reveal, xs#0, ys#0), TSeq(Tclass._System.Tuple2(Seq._default.Zip$A, Seq._default.Zip$B))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Max($ly, $reveal, xs#0) } Seq.__default.Max#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#14: int :: { Seq#Contains(xs#0, $Box(k#14)) } Seq#Contains(xs#0, $Box(k#14)) ==> Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0) >= k#14) && Seq#Contains(xs#0, $Box(Seq.__default.Max($ly, reveal_Seq._default.Max, xs#0))));

axiom (forall $ly: LayerType, $reveal: bool, xs#0: Seq :: { Seq.__default.Min($ly, $reveal, xs#0) } Seq.__default.Min#canCall(xs#0) || ($Is(xs#0, TSeq(TInt)) && 0 < Seq#Length(xs#0)) ==> (forall k#14: int :: { Seq#Contains(xs#0, $Box(k#14)) } Seq#Contains(xs#0, $Box(k#14)) ==> Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0) <= k#14) && Seq#Contains(xs#0, $Box(Seq.__default.Min($ly, reveal_Seq._default.Min, xs#0))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R), $Heap) && $Is(xs#0, TSeq(Seq._default.Map$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Map$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0)) == Seq#Length(xs#0) && (forall i#49: int :: { Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#49) } LitInt(0) <= i#49 && i#49 < Seq#Length(xs#0) ==> Seq#Index(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), i#49) == Apply1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#49))) && $Is(Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Map$R)));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) ==> (Seq.__default.Map#requires(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) <==> (forall i#50: int :: { Seq#Index(xs#0, i#50) } LitInt(0) <= i#50 && i#50 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#50)))));

axiom (forall Seq._default.Map$T: Ty, Seq._default.Map$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Map#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Map$T, Seq._default.Map$R)) && $Is(xs#0, TSeq(Seq._default.Map$T)) && (forall i#50: int :: { Seq#Index(xs#0, i#50) } LitInt(0) <= i#50 && i#50 < Seq#Length(xs#0) ==> Requires1(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, i#50)))) ==> (forall $l#29#i#0: int :: LitInt(0) <= $l#29#i#0 ==> $l#29#i#0 < Seq#Length(xs#0) ==> Requires1#canCall(Seq._default.Map$T, Seq._default.Map$R, $Heap, f#0, Seq#Index(xs#0, $l#29#i#0))) && Seq.__default.Map(Seq._default.Map$T, Seq._default.Map$R, true, $Heap, f#0, xs#0) == Seq#Create(Seq._default.Map$R, $Heap, Seq#Length(xs#0), Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: Apply1(Seq._default.Map$T, Seq._default.Map$R, $l#28#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#28#i#0): int))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: $IsBox($l#28#i#0, TInt) && LitInt(0) <= $Unbox($l#28#i#0): int && $Unbox($l#28#i#0): int < Seq#Length(xs#0) && Requires1(Seq._default.Map$T, Seq._default.Map$R, $l#28#heap#0, f#0, Seq#Index(xs#0, $Unbox($l#28#i#0): int))), (lambda $l#28#heap#0: Heap, $l#28#i#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: (exists i#51: int, o#20: ref :: { Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#28#heap#0, f#0, Seq#Index(xs#0, i#51))[$Box(o#20)] } $Is(o#20, Tclass._System.object?()) && LitInt(0) <= i#51 && i#51 < Seq#Length(xs#0) && Reads1(Seq._default.Map$T, Seq._default.Map$R, $l#28#heap#0, f#0, Seq#Index(xs#0, i#51))[$Box(o#20)] && $Box($l#28#o#0) == $Box(o#20))))))), $LS($LZ)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E)), $Heap) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && $IsAlloc(xs#0, TSeq(Seq._default.MapWithResult$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> (Wrappers.Result.Success_q(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0)) ==> Seq#Length($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq) == Seq#Length(xs#0) && (forall i#35: int :: { Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#35) } { Seq#Index(xs#0, i#35) } (LitInt(0) <= i#35 && i#35 < Seq#Length(xs#0) ==> Wrappers.Result.Success_q($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#35))): DatatypeType)) && (LitInt(0) <= i#35 && i#35 < Seq#Length(xs#0) ==> Seq#Index($Unbox(Wrappers.Result.value(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0))): Seq, i#35) == Wrappers.Result.value($Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#35))): DatatypeType)))) && $Is(Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $reveal, $Heap, f#0, xs#0), Tclass.Wrappers.Result(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E)));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) ==> (Seq.__default.MapWithResult#requires(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, $Heap, f#0, xs#0) <==> (forall i#36: int :: { Seq#Index(xs#0, i#36) } LitInt(0) <= i#36 && i#36 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#36)))));

axiom (forall Seq._default.MapWithResult$T: Ty, Seq._default.MapWithResult$R: Ty, Seq._default.MapWithResult$E: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E))) && $Is(xs#0, TSeq(Seq._default.MapWithResult$T)) && (forall i#36: int :: { Seq#Index(xs#0, i#36) } LitInt(0) <= i#36 && i#36 < Seq#Length(xs#0) ==> Requires1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, i#36)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> (var valueOrError0#12 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#12) && (Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#12) && Seq.__default.MapWithResult#canCall(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))) && (var valueOrError1#12 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#12) && (Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#12) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#12)) && (!Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#12) ==> Wrappers.Result.Extract#canCall(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#12)))))) && Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#12 := $Unbox(Apply1(Seq._default.MapWithResult$T, Tclass.Wrappers.Result(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E), $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): DatatypeType; (if Wrappers.Result.IsFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#12) then Wrappers.Result.PropagateFailure(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError0#12) else (var head#12 := Wrappers.Result.Extract(Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, valueOrError0#12); (var valueOrError1#12 := Seq.__default.MapWithResult(Seq._default.MapWithResult$T, Seq._default.MapWithResult$R, Seq._default.MapWithResult$E, $ly, reveal_Seq._default.MapWithResult, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#12) then Wrappers.Result.PropagateFailure(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, TSeq(Seq._default.MapWithResult$R), valueOrError1#12) else (var tail#12 := $Unbox(Wrappers.Result.Extract(TSeq(Seq._default.MapWithResult$R), Seq._default.MapWithResult$E, valueOrError1#12)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, head#12), tail#12)))))))))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $reveal: bool, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $IsAlloc(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool), $Heap) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && $IsAlloc(xs#0, TSeq(Seq._default.Filter$T), $Heap) && (forall i#1: int :: { Seq#Index(xs#0, i#1) } LitInt(0) <= i#1 && i#1 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#1)))) ==> Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) <= Seq#Length(xs#0) && (forall i#35: int :: { Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#35) } LitInt(0) <= i#35 ==> i#35 < Seq#Length(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0)) && Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#35)) ==> $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), i#35))): bool) && $Is(Seq.__default.Filter(Seq._default.Filter$T, $ly, $reveal, $Heap, f#0, xs#0), TSeq(Seq._default.Filter$T)));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) ==> (Seq.__default.Filter#requires(Seq._default.Filter$T, $ly, $Heap, f#0, xs#0) <==> (forall i#36: int :: { Seq#Index(xs#0, i#36) } LitInt(0) <= i#36 && i#36 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#36)))));

axiom (forall Seq._default.Filter$T: Ty, $ly: LayerType, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.Filter$T, TBool)) && $Is(xs#0, TSeq(Seq._default.Filter$T)) && (forall i#36: int :: { Seq#Index(xs#0, i#36) } LitInt(0) <= i#36 && i#36 < Seq#Length(xs#0) ==> Requires1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, i#36)))) ==> (Seq#Length(xs#0) != LitInt(0) ==> Seq.__default.Filter#canCall(Seq._default.Filter$T, $Heap, f#0, Seq#Drop(xs#0, LitInt(1)))) && Seq.__default.Filter(Seq._default.Filter$T, $LS($ly), true, $Heap, f#0, xs#0) == (if Seq#Length(xs#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Apply1(Seq._default.Filter$T, TBool, $Heap, f#0, Seq#Index(xs#0, LitInt(0)))): bool then Seq#Build(Seq#Empty(): Seq, Seq#Index(xs#0, LitInt(0))) else Seq#Empty(): Seq), Seq.__default.Filter(Seq._default.Filter$T, $ly, reveal_Seq._default.Filter, $Heap, f#0, Seq#Drop(xs#0, LitInt(1))))));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, inv#0, stp#0) <==> (forall x#26: Box, xs#26: Seq, b#26: Box, b'#26: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#26, x#26, b'#26)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#26), xs#26) } $IsBox(x#26, Seq._default.InvFoldLeft$A) && $Is(xs#26, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#26, Seq._default.InvFoldLeft$B) && $IsBox(b'#26, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b#26, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#26), xs#26)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#26, x#26, b'#26)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, inv#0, b'#26, $Box(xs#26))): bool)));

axiom (forall Seq._default.InvFoldLeft$A: Ty, Seq._default.InvFoldLeft$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldLeft#canCall(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool))) ==> (Seq.__default.InvFoldLeft(Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#27: Box, xs#27: Seq, b#27: Box, b'#27: Box :: { $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, stp#0, b#27, x#27, b'#27)): bool, Seq#Append(Seq#Build(Seq#Empty(): Seq, x#27), xs#27) } $IsBox(x#27, Seq._default.InvFoldLeft$A) && $Is(xs#27, TSeq(Seq._default.InvFoldLeft$A)) && $IsBox(b#27, Seq._default.InvFoldLeft$B) && $IsBox(b'#27, Seq._default.InvFoldLeft$B) ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b#27, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#27), xs#27)))): bool && $Unbox(Apply3(Seq._default.InvFoldLeft$B, Seq._default.InvFoldLeft$A, Seq._default.InvFoldLeft$B, TBool, $Heap, Lit(stp#0), b#27, x#27, b'#27)): bool ==> $Unbox(Apply2(Seq._default.InvFoldLeft$B, TSeq(Seq._default.InvFoldLeft$A), TBool, $Heap, Lit(inv#0), b'#27, $Box(xs#27))): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, inv#0, stp#0) <==> (forall x#26: Box, xs#26: Seq, b#26: Box, b'#26: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#26), xs#26), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#26, b#26, b'#26)): bool } $IsBox(x#26, Seq._default.InvFoldRight$A) && $Is(xs#26, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#26, Seq._default.InvFoldRight$B) && $IsBox(b'#26, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(xs#26), b#26)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#26, b#26, b'#26)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, inv#0, $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#26), xs#26)), b'#26)): bool)));

axiom (forall Seq._default.InvFoldRight$A: Ty, Seq._default.InvFoldRight$B: Ty, $Heap: Heap, inv#0: HandleType, stp#0: HandleType :: {:weight 3} { Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)), $IsGoodHeap($Heap) } Seq.__default.InvFoldRight#canCall(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) || ($IsGoodHeap($Heap) && $Is(inv#0, Tclass._System.___hTotalFunc2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool)) && $Is(stp#0, Tclass._System.___hTotalFunc3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool))) ==> (Seq.__default.InvFoldRight(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Lit(inv#0), Lit(stp#0)) <==> (forall x#27: Box, xs#27: Seq, b#27: Box, b'#27: Box :: { Seq#Append(Seq#Build(Seq#Empty(): Seq, x#27), xs#27), $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, stp#0, x#27, b#27, b'#27)): bool } $IsBox(x#27, Seq._default.InvFoldRight$A) && $Is(xs#27, TSeq(Seq._default.InvFoldRight$A)) && $IsBox(b#27, Seq._default.InvFoldRight$B) && $IsBox(b'#27, Seq._default.InvFoldRight$B) ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(xs#27), b#27)): bool && $Unbox(Apply3(Seq._default.InvFoldRight$A, Seq._default.InvFoldRight$B, Seq._default.InvFoldRight$B, TBool, $Heap, Lit(stp#0), x#27, b#27, b'#27)): bool ==> $Unbox(Apply2(TSeq(Seq._default.InvFoldRight$A), Seq._default.InvFoldRight$B, TBool, $Heap, Lit(inv#0), $Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, x#27), xs#27)), b'#27)): bool)));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) ==> (Seq.__default.FlatMap#requires(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) <==> (forall i#21: int :: { Seq#Index(xs#0, i#21) } LitInt(0) <= i#21 && i#21 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#21)))));

axiom (forall Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, $Heap: Heap, f#0: HandleType, xs#0: Seq :: { Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0), $IsGoodHeap($Heap) } Seq.__default.FlatMap#canCall(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hFunc1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R))) && $Is(xs#0, TSeq(Seq._default.FlatMap$T)) && (forall i#21: int :: { Seq#Index(xs#0, i#21) } LitInt(0) <= i#21 && i#21 < Seq#Length(xs#0) ==> Requires1(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, Seq#Index(xs#0, i#21)))) ==> Seq.__default.Map#canCall(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), $Heap, f#0, xs#0) && Seq.__default.Flatten#canCall(Seq._default.FlatMap$R, Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)) && Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, $Heap, f#0, xs#0) == Seq.__default.Flatten(Seq._default.FlatMap$R, $LS($LZ), Seq.__default.Map(Seq._default.FlatMap$T, TSeq(Seq._default.FlatMap$R), reveal_Seq._default.Map, $Heap, f#0, xs#0)));

axiom (forall i#0: bv24 :: { Unicode.__default.IsInAssignedPlane(true, i#0) } Unicode.__default.IsInAssignedPlane#canCall(i#0) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, i#0) <==> (var plane#16 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#16)])));

axiom (forall i#0: bv24 :: {:weight 3} { Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) } Unicode.__default.IsInAssignedPlane#canCall(Lit(i#0)) || (le_bv24(0bv24, i#0) && le_bv24(i#0, 1114111bv24)) ==> (Unicode.__default.IsInAssignedPlane(true, Lit(i#0)) <==> (var plane#17 := RightShift_bv24(i#0, (0bv19 ++ 16bv5): bv24)[8:0]; Unicode.__default.ASSIGNED__PLANES()[$Box(plane#17)])));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) ==> (Functions.__default.Injective#requires(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x#10: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#10) } $IsBox(x#10, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#10))));

axiom (forall Functions._default.Injective$X: Ty, Functions._default.Injective$Y: Ty, $Heap: Heap, f#0: HandleType :: { Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0), $IsGoodHeap($Heap) } Functions.__default.Injective#canCall(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) || ($IsGoodHeap($Heap) && $Is(f#0, Tclass._System.___hPartialFunc1(Functions._default.Injective$X, Functions._default.Injective$Y)) && (forall x#10: Box :: { Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#10) } $IsBox(x#10, Functions._default.Injective$X) ==> Requires1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x#10))) ==> (Functions.__default.Injective(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0) <==> (forall x1#10: Box, x2#10: Box :: { Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#10), Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#10) } $IsBox(x1#10, Functions._default.Injective$X) && $IsBox(x2#10, Functions._default.Injective$X) ==> Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x1#10) == Apply1(Functions._default.Injective$X, Functions._default.Injective$Y, $Heap, f#0, x2#10) ==> x1#10 == x2#10)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#15: int :: { Seq#Take(s#0, i#15) } 0 < i#15 && i#15 < Seq#Length(s#0) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#15))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> (Seq#Length(s#0) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(2) ==> (Seq#Length(s#0) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(3) ==> Seq#Length(s#0) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0)))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then (var b#41 := Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0); b#41) else (if Seq#Length(s#0) == LitInt(2) then (var b#42 := Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#42) else (if Seq#Length(s#0) == LitInt(3) then (var b#43 := Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0); b#43) else (if Seq#Length(s#0) == LitInt(4) then (var b#44 := Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0); b#44) else false))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> (Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(2) ==> (Seq#Length(Lit(s#0)) == LitInt(3) ==> Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(3) ==> Seq#Length(Lit(s#0)) == LitInt(4) ==> Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0))))) && (Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then (var b#45 := Lit(Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0))); b#45) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#46 := Lit(Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#46) else (if Seq#Length(Lit(s#0)) == LitInt(3) then (var b#47 := Lit(Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0))); b#47) else (if Seq#Length(Lit(s#0)) == LitInt(4) then (var b#48 := Lit(Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0))); b#48) else false))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstByte#10 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#10) && le_bv8(firstByte#10, 127bv8))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf8EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; true && le_bv8(0bv8, firstByte#11) && le_bv8(firstByte#11, 127bv8))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstByte#10 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#10 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; le_bv8(194bv8, firstByte#10) && le_bv8(firstByte#10, 223bv8) && le_bv8(128bv8, secondByte#10) && le_bv8(secondByte#10, 191bv8)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf8EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; le_bv8(194bv8, firstByte#11) && le_bv8(firstByte#11, 223bv8) && le_bv8(128bv8, secondByte#11) && le_bv8(secondByte#11, 191bv8)))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(s#0) <==> (var firstByte#10 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#10 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#10 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; ((firstByte#10 == Lit(224bv8) && le_bv8(160bv8, secondByte#10) && le_bv8(secondByte#10, 191bv8)) || (le_bv8(225bv8, firstByte#10) && le_bv8(firstByte#10, 236bv8) && le_bv8(128bv8, secondByte#10) && le_bv8(secondByte#10, 191bv8)) || (firstByte#10 == Lit(237bv8) && le_bv8(128bv8, secondByte#10) && le_bv8(secondByte#10, 159bv8)) || (le_bv8(238bv8, firstByte#10) && le_bv8(firstByte#10, 239bv8) && le_bv8(128bv8, secondByte#10) && le_bv8(secondByte#10, 191bv8))) && le_bv8(128bv8, thirdByte#10) && le_bv8(thirdByte#10, 191bv8))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(3)) ==> (Utf8EncodingForm.__default.IsWellFormedTripleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; ((firstByte#11 == Lit(224bv8) && le_bv8(160bv8, secondByte#11) && le_bv8(secondByte#11, 191bv8)) || (le_bv8(225bv8, firstByte#11) && le_bv8(firstByte#11, 236bv8) && le_bv8(128bv8, secondByte#11) && le_bv8(secondByte#11, 191bv8)) || (firstByte#11 == Lit(237bv8) && le_bv8(128bv8, secondByte#11) && le_bv8(secondByte#11, 159bv8)) || (le_bv8(238bv8, firstByte#11) && le_bv8(firstByte#11, 239bv8) && le_bv8(128bv8, secondByte#11) && le_bv8(secondByte#11, 191bv8))) && le_bv8(128bv8, thirdByte#11) && le_bv8(thirdByte#11, 191bv8))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(s#0) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(s#0) <==> (var firstByte#10 := $Unbox(Seq#Index(s#0, LitInt(0))): bv8; (var secondByte#10 := $Unbox(Seq#Index(s#0, LitInt(1))): bv8; (var thirdByte#10 := $Unbox(Seq#Index(s#0, LitInt(2))): bv8; (var fourthByte#10 := $Unbox(Seq#Index(s#0, LitInt(3))): bv8; ((firstByte#10 == Lit(240bv8) && le_bv8(144bv8, secondByte#10) && le_bv8(secondByte#10, 191bv8)) || (le_bv8(241bv8, firstByte#10) && le_bv8(firstByte#10, 243bv8) && le_bv8(128bv8, secondByte#10) && le_bv8(secondByte#10, 191bv8)) || (firstByte#10 == Lit(244bv8) && le_bv8(128bv8, secondByte#10) && le_bv8(secondByte#10, 143bv8))) && le_bv8(128bv8, thirdByte#10) && le_bv8(thirdByte#10, 191bv8) && le_bv8(128bv8, fourthByte#10) && le_bv8(fourthByte#10, 191bv8)))))));

axiom (forall s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) } Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(8))) && Seq#Length(Lit(s#0)) == LitInt(4)) ==> (Utf8EncodingForm.__default.IsWellFormedQuadrupleCodeUnitSequence(Lit(s#0)) <==> (var firstByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv8; (var secondByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv8; (var thirdByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(2))): bv8; (var fourthByte#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(3))): bv8; ((firstByte#11 == Lit(240bv8) && le_bv8(144bv8, secondByte#11) && le_bv8(secondByte#11, 191bv8)) || (le_bv8(241bv8, firstByte#11) && le_bv8(firstByte#11, 243bv8) && le_bv8(128bv8, secondByte#11) && le_bv8(secondByte#11, 191bv8)) || (firstByte#11 == Lit(244bv8) && le_bv8(128bv8, secondByte#11) && le_bv8(secondByte#11, 143bv8))) && le_bv8(128bv8, thirdByte#11) && le_bv8(thirdByte#11, 191bv8) && le_bv8(128bv8, fourthByte#11) && le_bv8(fourthByte#11, 191bv8)))))));

axiom (forall s#0: Seq :: { Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#14: int :: { Seq#Take(s#0, i#14) } 0 < i#14 && i#14 <= Seq#Length(s#0) && Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#14))) <==> true && Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#6 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#6) && Seq#Length(prefix#6) <= Seq#Length(s#0) && Seq#Equal(prefix#6, Seq#Take(s#0, Seq#Length(prefix#6))) && (forall i#15: int :: { Seq#Take(s#0, i#15) } 0 < i#15 && i#15 < Seq#Length(prefix#6) ==> !Utf8EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#15))))) && $Is(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(v#0) == (var x#10 := and_bv24(v#0, 127bv24)[7:0]; (var firstByte#11 := (0bv1 ++ x#10): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#11)))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueSingleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(0bv24, v#0) && le_bv24(v#0, 127bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueSingleByte(Lit(v#0)) == (var x#11 := Lit(and_bv24(v#0, 127bv24))[7:0]; (var firstByte#12 := (0bv1 ++ x#11): bv8; Seq#Build(Seq#Empty(): Seq, $Box(firstByte#12)))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(v#0) == (var x#10 := and_bv24(v#0, 63bv24)[6:0]; (var y#10 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#11 := or_bv8(192bv8, (0bv3 ++ y#10): bv8); (var secondByte#11 := or_bv8(128bv8, (0bv2 ++ x#10): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#11)), $Box(secondByte#11)))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueDoubleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(128bv24, v#0) && le_bv24(v#0, 2047bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueDoubleByte(Lit(v#0)) == (var x#11 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#11 := RightShift_bv24(and_bv24(v#0, 1984bv24), (0bv19 ++ 6bv5): bv24)[5:0]; (var firstByte#12 := or_bv8(192bv8, (0bv3 ++ y#11): bv8); (var secondByte#12 := or_bv8(128bv8, (0bv2 ++ x#11): bv8); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#12)), $Box(secondByte#12)))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(v#0) == (var x#10 := and_bv24(v#0, 63bv24)[6:0]; (var y#10 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#10 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#11 := or_bv8(224bv8, (0bv4 ++ z#10): bv8); (var secondByte#11 := or_bv8(128bv8, (0bv2 ++ y#10): bv8); (var thirdByte#11 := or_bv8(128bv8, (0bv2 ++ x#10): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#11)), $Box(secondByte#11)), $Box(thirdByte#11)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueTripleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(2048bv24, v#0) && le_bv24(v#0, 65535bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueTripleByte(Lit(v#0)) == (var x#11 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#11 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#11 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var firstByte#12 := or_bv8(224bv8, (0bv4 ++ z#11): bv8); (var secondByte#12 := or_bv8(128bv8, (0bv2 ++ y#11): bv8); (var thirdByte#12 := or_bv8(128bv8, (0bv2 ++ x#11): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#12)), $Box(secondByte#12)), $Box(thirdByte#12)))))))));

axiom (forall v#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(v#0) == (var x#10 := and_bv24(v#0, 63bv24)[6:0]; (var y#10 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#10 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#10 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#10 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#11 := or_bv8(240bv8, (0bv5 ++ u1#10): bv8); (var secondByte#11 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#10): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#10): bv8); (var thirdByte#11 := or_bv8(128bv8, (0bv2 ++ y#10): bv8); (var fourthByte#11 := or_bv8(128bv8, (0bv2 ++ x#10): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#11)), $Box(secondByte#11)), $Box(thirdByte#11)), $Box(fourthByte#11))))))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) } Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf8EncodingForm.__default.EncodeScalarValueQuadrupleByte(Lit(v#0)) == (var x#11 := Lit(and_bv24(v#0, 63bv24))[6:0]; (var y#11 := RightShift_bv24(and_bv24(v#0, 4032bv24), (0bv19 ++ 6bv5): bv24)[6:0]; (var z#11 := RightShift_bv24(and_bv24(v#0, 61440bv24), (0bv19 ++ 12bv5): bv24)[4:0]; (var u2#11 := RightShift_bv24(and_bv24(v#0, 196608bv24), (0bv19 ++ 16bv5): bv24)[2:0]; (var u1#11 := RightShift_bv24(and_bv24(v#0, 1835008bv24), (0bv19 ++ 18bv5): bv24)[3:0]; (var firstByte#12 := or_bv8(240bv8, (0bv5 ++ u1#11): bv8); (var secondByte#12 := or_bv8(or_bv8(128bv8, LeftShift_bv8((0bv6 ++ u2#11): bv8, (0bv4 ++ 4bv4): bv8)), (0bv4 ++ z#11): bv8); (var thirdByte#12 := or_bv8(128bv8, (0bv2 ++ y#11): bv8); (var fourthByte#12 := or_bv8(128bv8, (0bv2 ++ x#11): bv8); Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstByte#12)), $Box(secondByte#12)), $Box(thirdByte#12)), $Box(fourthByte#12))))))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(m#0) == (var firstByte#10 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var x#10 := firstByte#10[7:0]; (0bv17 ++ x#10): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleByte(Lit(m#0)) == (var firstByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var x#11 := firstByte#11[7:0]; (0bv17 ++ x#11): bv24)));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(m#0) == (var firstByte#10 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#10 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var y#10 := (0bv16 ++ and_bv8(firstByte#10, 31bv8)): bv24; (var x#10 := (0bv16 ++ and_bv8(secondByte#10, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#10, (0bv19 ++ 6bv5): bv24), x#10))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleByte(Lit(m#0)) == (var firstByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var y#11 := (0bv16 ++ and_bv8(firstByte#11, 31bv8)): bv24; (var x#11 := (0bv16 ++ and_bv8(secondByte#11, 63bv8)): bv24; or_bv24(LeftShift_bv24(y#11, (0bv19 ++ 6bv5): bv24), x#11))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(m#0) == (var firstByte#10 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#10 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#10 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var z#10 := (0bv16 ++ and_bv8(firstByte#10, 15bv8)): bv24; (var y#10 := (0bv16 ++ and_bv8(secondByte#10, 63bv8)): bv24; (var x#10 := (0bv16 ++ and_bv8(thirdByte#10, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#10, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#10, (0bv19 ++ 6bv5): bv24)), x#10))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(3)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceTripleByte(Lit(m#0)) == (var firstByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var z#11 := (0bv16 ++ and_bv8(firstByte#11, 15bv8)): bv24; (var y#11 := (0bv16 ++ and_bv8(secondByte#11, 63bv8)): bv24; (var x#11 := (0bv16 ++ and_bv8(thirdByte#11, 63bv8)): bv24; or_bv24(or_bv24(LeftShift_bv24(z#11, (0bv19 ++ 12bv5): bv24), LeftShift_bv24(y#11, (0bv19 ++ 6bv5): bv24)), x#11))))))));

axiom (forall m#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(m#0) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(m#0) == (var firstByte#10 := $Unbox(Seq#Index(m#0, LitInt(0))): bv8; (var secondByte#10 := $Unbox(Seq#Index(m#0, LitInt(1))): bv8; (var thirdByte#10 := $Unbox(Seq#Index(m#0, LitInt(2))): bv8; (var fourthByte#10 := $Unbox(Seq#Index(m#0, LitInt(3))): bv8; (var u1#10 := (0bv16 ++ and_bv8(firstByte#10, 7bv8)): bv24; (var u2#10 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#10, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#10 := (0bv16 ++ and_bv8(secondByte#10, 15bv8)): bv24; (var y#10 := (0bv16 ++ and_bv8(thirdByte#10, 63bv8)): bv24; (var x#10 := (0bv16 ++ and_bv8(fourthByte#10, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#10, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#10, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#10, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#10, (0bv19 ++ 6bv5): bv24)), x#10)))))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(4)) ==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceQuadrupleByte(Lit(m#0)) == (var firstByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv8; (var secondByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv8; (var thirdByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(2))): bv8; (var fourthByte#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(3))): bv8; (var u1#11 := (0bv16 ++ and_bv8(firstByte#11, 7bv8)): bv24; (var u2#11 := (0bv16 ++ RightShift_bv8(and_bv8(secondByte#11, 48bv8), (0bv4 ++ 4bv4): bv8)): bv24; (var z#11 := (0bv16 ++ and_bv8(secondByte#11, 15bv8)): bv24; (var y#11 := (0bv16 ++ and_bv8(thirdByte#11, 63bv8)): bv24; (var x#11 := (0bv16 ++ and_bv8(fourthByte#11, 63bv8)): bv24; or_bv24(or_bv24(or_bv24(or_bv24(LeftShift_bv24(u1#11, (0bv19 ++ 18bv5): bv24), LeftShift_bv24(u2#11, (0bv19 ++ 16bv5): bv24)), LeftShift_bv24(z#11, (0bv19 ++ 12bv5): bv24)), LeftShift_bv24(y#11, (0bv19 ++ 6bv5): bv24)), x#11)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#11 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#11)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) && (var prefix#11 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#11))) && (var valueOrError1#10 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#11))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#11 := Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#11) else (var prefix#11 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11)): Seq; (var valueOrError1#10 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#11))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) else (var restParts#10 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#11)), restParts#10)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(8))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#12 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) && (Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#12)) && (!Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) ==> Wrappers.Option.Extract#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) && (var prefix#12 := $Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12)): Seq; Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#12))) && (var valueOrError1#11 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#12))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11))))))) && Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#12 := Lit(Utf8EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) then Wrappers.Option.PropagateFailure(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#12) else (var prefix#12 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12)): Seq); (var valueOrError1#11 := Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#12))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) else (var restParts#11 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#12)), restParts#11)))))))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) == $Box(Utf8EncodingForm.__default.EncodeScalarValue($Unbox($fh$5x#0): bv24)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) <==> Utf8EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$5x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: bv24 :: { Utf8EncodingForm.__default.EncodeScalarValue($fh$5x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.EncodeScalarValue($fh$5x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf8EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#10 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(8), ms#10)) && Utf8EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#10 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#10)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#11 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(8), ms#11)) && Utf8EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#11 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(8), $LS($LZ), ms#11)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) } Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) == $Box(Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$5x#0): Seq)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) } Requires1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) <==> Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$5x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: Seq :: { Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$5x#0), $IsGoodHeap($heap) } Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$5x#0) == $Unbox(Apply1(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$5x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#10 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#10)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#10 := Utf8EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#11 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#10); vs#11)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf8EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf8EncodingForm.WellFormedCodeUnitSeq())) ==> Utf8EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#11 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#11)) && Utf8EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#11 := Lit(Utf8EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#12 := Seq.__default.Map(Tclass.Utf8EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf8EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#11); vs#12)));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, s#0) ==> Seq#Length(s#0) > 0 && (forall i#9: int :: { Seq#Take(s#0, i#9) } 0 < i#9 && i#9 < Seq#Length(s#0) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($ly, Seq#Take(s#0, i#9))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0)) && (Seq#Length(s#0) != LitInt(1) ==> Seq#Length(s#0) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0)) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), s#0) <==> (if Seq#Length(s#0) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) else (if Seq#Length(s#0) == LitInt(2) then (var b#11 := Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0); b#11) else false))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(Lit(s#0)) == LitInt(1) ==> Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0))) && (Seq#Length(Lit(s#0)) != LitInt(1) ==> Seq#Length(Lit(s#0)) == LitInt(2) ==> Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0))) && (Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($ly), Lit(s#0)) <==> (if Seq#Length(Lit(s#0)) == LitInt(1) then Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) else (if Seq#Length(Lit(s#0)) == LitInt(2) then (var b#12 := Lit(Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0))); b#12) else false))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(s#0) <==> (var firstWord#10 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (le_bv16(0bv16, firstWord#10) && le_bv16(firstWord#10, 55295bv16)) || (le_bv16(57344bv16, firstWord#10) && le_bv16(firstWord#10, 65535bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(1)) ==> (Utf16EncodingForm.__default.IsWellFormedSingleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (le_bv16(0bv16, firstWord#11) && le_bv16(firstWord#11, 55295bv16)) || (le_bv16(57344bv16, firstWord#11) && le_bv16(firstWord#11, 65535bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(s#0) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(s#0) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(s#0) <==> (var firstWord#10 := $Unbox(Seq#Index(s#0, LitInt(0))): bv16; (var secondWord#10 := $Unbox(Seq#Index(s#0, LitInt(1))): bv16; le_bv16(55296bv16, firstWord#10) && le_bv16(firstWord#10, 56319bv16) && le_bv16(56320bv16, secondWord#10) && le_bv16(secondWord#10, 57343bv16)))));

axiom (forall s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) } Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence#canCall(Lit(s#0)) || ($Is(s#0, TSeq(TBitvector(16))) && Seq#Length(Lit(s#0)) == LitInt(2)) ==> (Utf16EncodingForm.__default.IsWellFormedDoubleCodeUnitSequence(Lit(s#0)) <==> (var firstWord#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(0))): bv16; (var secondWord#11 := $Unbox(Seq#Index(Lit(s#0), LitInt(1))): bv16; le_bv16(55296bv16, firstWord#11) && le_bv16(firstWord#11, 56319bv16) && le_bv16(56320bv16, secondWord#11) && le_bv16(secondWord#11, 57343bv16)))));

axiom (forall s#0: Seq :: { Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0) } Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#22: int :: { Seq#Take(s#0, i#22) } 0 < i#22 && i#22 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#22))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#12 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#12) && Seq#Length(prefix#12) <= Seq#Length(s#0) && Seq#Equal(prefix#12, Seq#Take(s#0, Seq#Length(prefix#12))) && (forall i#23: int :: { Seq#Take(s#0, i#23) } 0 < i#23 && i#23 < Seq#Length(prefix#12) ==> !Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#23))))) && (Seq#Length(s#0) == LitInt(0) ==> Wrappers.Option.None_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && ((exists i#24: int :: { Seq#Take(s#0, i#24) } 0 < i#24 && i#24 <= Seq#Length(s#0) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), Seq#Take(s#0, i#24))) <==> true && Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))) && (Wrappers.Option.Some_q(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0)) ==> true && (var prefix#13 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0))): Seq; 0 < Seq#Length(prefix#13) && Seq#Length(prefix#13) <= Seq#Length(s#0) && Seq#Equal(prefix#13, Seq#Take(s#0, Seq#Length(prefix#13))) && Utf16EncodingForm.__default.IsMinimalWellFormedCodeUnitSubsequence($LS($LZ), prefix#13))) && $Is(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0), Tclass.Wrappers.Option(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq())));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(v#0) == (var firstWord#11 := v#0[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#11))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueSingleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && ((le_bv24(0bv24, v#0) && le_bv24(v#0, 55295bv24)) || (le_bv24(57344bv24, v#0) && le_bv24(v#0, 65535bv24)))) ==> Utf16EncodingForm.__default.EncodeScalarValueSingleWord(Lit(v#0)) == (var firstWord#12 := Lit(v#0)[16:0]; Seq#Build(Seq#Empty(): Seq, $Box(firstWord#12))));

axiom (forall v#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(v#0) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(v#0) == (var x2#10 := and_bv24(v#0, 1023bv24)[10:0]; (var x1#10 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#10 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#10 := sub_bv5(u#10, 1bv5)[4:0]; (var firstWord#11 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#10): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#10): bv16); (var secondWord#11 := or_bv16(56320bv16, (0bv6 ++ x2#10): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#11)), $Box(secondWord#11)))))))));

axiom (forall v#0: bv24 :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) } Utf16EncodingForm.__default.EncodeScalarValueDoubleWord#canCall(Lit(v#0)) || (le_bv24(0bv24, v#0) && le_bv24(v#0, 1114111bv24) && (lt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.HIGH__SURROGATE__MAX())) && (lt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MIN()) || gt_bv24(v#0, Unicode.__default.LOW__SURROGATE__MAX())) && le_bv24(65536bv24, v#0) && le_bv24(v#0, 1114111bv24)) ==> Utf16EncodingForm.__default.EncodeScalarValueDoubleWord(Lit(v#0)) == (var x2#11 := Lit(and_bv24(v#0, 1023bv24))[10:0]; (var x1#11 := RightShift_bv24(and_bv24(v#0, 64512bv24), (0bv19 ++ 10bv5): bv24)[6:0]; (var u#11 := RightShift_bv24(and_bv24(v#0, 2031616bv24), (0bv19 ++ 16bv5): bv24)[5:0]; (var w#11 := sub_bv5(u#11, 1bv5)[4:0]; (var firstWord#12 := or_bv16(or_bv16(55296bv16, LeftShift_bv16((0bv12 ++ w#11): bv16, (0bv11 ++ 6bv5): bv16)), (0bv10 ++ x1#11): bv16); (var secondWord#12 := or_bv16(56320bv16, (0bv6 ++ x2#11): bv16); Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(firstWord#12)), $Box(secondWord#12)))))))));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(m#0) == (var firstWord#10 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var x#10 := firstWord#10; (0bv8 ++ x#10): bv24)));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(1)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceSingleWord(Lit(m#0)) == (var firstWord#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var x#11 := firstWord#11; (0bv8 ++ x#11): bv24)));

axiom (forall m#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(m#0) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(m#0) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(m#0) == (var firstWord#10 := $Unbox(Seq#Index(m#0, LitInt(0))): bv16; (var secondWord#10 := $Unbox(Seq#Index(m#0, LitInt(1))): bv16; (var x2#10 := (0bv8 ++ and_bv16(secondWord#10, 1023bv16)): bv24; (var x1#10 := (0bv8 ++ and_bv16(firstWord#10, 63bv16)): bv24; (var w#10 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#10, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#10 := add_bv24(w#10, 1bv24); (var v#11 := or_bv24(or_bv24(LeftShift_bv24(u#10, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#10, (0bv19 ++ 10bv5): bv24)), x2#10); v#11))))))));

axiom (forall m#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord#canCall(Lit(m#0)) || ($Is(m#0, Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()) && Seq#Length(Lit(m#0)) == LitInt(2)) ==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequenceDoubleWord(Lit(m#0)) == (var firstWord#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(0))): bv16; (var secondWord#11 := $Unbox(Seq#Index(Lit(m#0), LitInt(1))): bv16; (var x2#11 := (0bv8 ++ and_bv16(secondWord#11, 1023bv16)): bv24; (var x1#11 := (0bv8 ++ and_bv16(firstWord#11, 63bv16)): bv24; (var w#11 := (0bv8 ++ RightShift_bv16(and_bv16(firstWord#11, 960bv16), (0bv11 ++ 6bv5): bv16)): bv24; (var u#11 := add_bv24(w#11, 1bv24); (var v#12 := or_bv24(or_bv24(LeftShift_bv24(u#11, (0bv19 ++ 16bv5): bv24), LeftShift_bv24(x1#11, (0bv19 ++ 10bv5): bv24)), x2#11); v#12))))))));

axiom (forall $ly: LayerType, s#0: Seq :: { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(s#0) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(s#0) && (var valueOrError0#11 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#11)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) && (var prefix#11 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(s#0, Seq#Length(prefix#11))) && (var valueOrError1#10 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#11))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), s#0) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#11 := Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(s#0); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#11) else (var prefix#11 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#11)): Seq; (var valueOrError1#10 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($ly, Seq#Drop(s#0, Seq#Length(prefix#11))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10) else (var restParts#10 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#10)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#11)), restParts#10)))))))))));

axiom (forall $ly: LayerType, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) } Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Lit(s#0)) || $Is(s#0, TSeq(TBitvector(16))) ==> (!Seq#Equal(s#0, Seq#Empty(): Seq) ==> Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence#canCall(Lit(s#0)) && (var valueOrError0#12 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); Wrappers.Option.IsFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) && (Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) ==> Wrappers.Option.PropagateFailure#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#12)) && (!Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) ==> Wrappers.Option.Extract#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) && (var prefix#12 := $Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12)): Seq; Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked#canCall(Seq#Drop(Lit(s#0), Seq#Length(prefix#12))) && (var valueOrError1#11 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#12))); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) && (Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11))))))) && Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Lit(s#0)) == (if Seq#Equal(s#0, Seq#Empty(): Seq) then #Wrappers.Option.Some($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#12 := Lit(Utf16EncodingForm.__default.SplitPrefixMinimalWellFormedCodeUnitSubsequence(Lit(s#0))); (if Wrappers.Option.IsFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12) then Wrappers.Option.PropagateFailure(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError0#12) else (var prefix#12 := Lit($Unbox(Wrappers.Option.Extract(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), valueOrError0#12)): Seq); (var valueOrError1#11 := Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked($LS($ly), Seq#Drop(Lit(s#0), Seq#Length(prefix#12))); (if Wrappers.Option.IsFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11) else (var restParts#11 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq()), valueOrError1#11)): Seq; #Wrappers.Option.Some($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(prefix#12)), restParts#11)))))))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) } Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) == $Box(Utf16EncodingForm.__default.EncodeScalarValue($Unbox($fh$5x#0): bv24)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) } Requires1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0) <==> Utf16EncodingForm.__default.EncodeScalarValue#requires($Unbox($fh$5x#0): bv24));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: bv24 :: { Utf16EncodingForm.__default.EncodeScalarValue($fh$5x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.EncodeScalarValue($fh$5x#0) == $Unbox(Apply1(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $Heap: Heap, vs#0: Seq :: { Utf16EncodingForm.__default.EncodeScalarSequence(vs#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(vs#0) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0) && (var ms#10 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten#canCall(TBitvector(16), ms#10)) && Utf16EncodingForm.__default.EncodeScalarSequence(vs#0) == (var ms#10 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), vs#0); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#10)));

axiom (forall $Heap: Heap, vs#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.EncodeScalarSequence#canCall(Lit(vs#0)) || ($IsGoodHeap($Heap) && $Is(vs#0, TSeq(Tclass.Unicode.ScalarValue()))) ==> Seq.__default.Map#canCall(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)) && (var ms#11 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten#canCall(TBitvector(16), ms#11)) && Utf16EncodingForm.__default.EncodeScalarSequence(Lit(vs#0)) == (var ms#11 := Seq.__default.Map(Tclass.Unicode.ScalarValue(), Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.EncodeScalarValue#Handle(), Lit(vs#0)); Seq.__default.Flatten(TBitvector(16), $LS($LZ), ms#11)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) } Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) == $Box(Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($Unbox($fh$5x#0): Seq)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) } Requires1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0) <==> Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#requires($Unbox($fh$5x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: Seq :: { Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$5x#0), $IsGoodHeap($heap) } Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence($fh$5x#0) == $Unbox(Apply1(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), $Box($fh$5x#0))): bv24);

axiom (forall $Heap: Heap, s#0: Seq :: { Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(s#0) && (var parts#10 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#10)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(s#0) == (var parts#10 := Utf16EncodingForm.__default.PartitionCodeUnitSequence(s#0); (var vs#11 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#10); vs#11)));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)), $IsGoodHeap($Heap) } Utf16EncodingForm.__default.DecodeCodeUnitSequence#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, Tclass.Utf16EncodingForm.WellFormedCodeUnitSeq())) ==> Utf16EncodingForm.__default.PartitionCodeUnitSequence#canCall(Lit(s#0)) && (var parts#11 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); Seq.__default.Map#canCall(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#11)) && Utf16EncodingForm.__default.DecodeCodeUnitSequence(Lit(s#0)) == (var parts#11 := Lit(Utf16EncodingForm.__default.PartitionCodeUnitSequence(Lit(s#0))); (var vs#12 := Seq.__default.Map(Tclass.Utf16EncodingForm.MinimalWellFormedCodeUnitSeq(), Tclass.Unicode.ScalarValue(), reveal_Seq._default.Map, $Heap, Utf16EncodingForm.__default.DecodeMinimalWellFormedCodeUnitSubsequence#Handle(), parts#11); vs#12)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.IsWellFormedString(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#45#ly#0: LayerType :: Handle1((lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#45#c#0): char)))), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: $IsBox($l#45#c#0, TChar)), (lambda $l#45#heap#0: Heap, $l#45#c#0: Box :: SetRef_to_SetBox((lambda $l#45#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#46#ly#0: LayerType :: Handle1((lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#46#c#0): char)))), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: $IsBox($l#46#c#0, TChar)), (lambda $l#46#heap#0: Heap, $l#46#c#0: Box :: SetRef_to_SetBox((lambda $l#46#o#0: ref :: false))))), $LS($LZ))), s#0)) && (UnicodeStrings.__default.IsWellFormedString(s#0) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#43#c#0): char)))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, TChar)), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ))), s#0))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.IsWellFormedString(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.IsWellFormedString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#49#ly#0: LayerType :: Handle1((lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#49#c#0): char)))), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: $IsBox($l#49#c#0, TChar)), (lambda $l#49#heap#0: Heap, $l#49#c#0: Box :: SetRef_to_SetBox((lambda $l#49#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#50#ly#0: LayerType :: Handle1((lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#50#c#0): char)))), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: $IsBox($l#50#c#0, TChar)), (lambda $l#50#heap#0: Heap, $l#50#c#0: Box :: SetRef_to_SetBox((lambda $l#50#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (UnicodeStrings.__default.IsWellFormedString(Lit(s#0)) <==> Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#47#ly#0: LayerType :: Handle1((lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#47#c#0): char)))), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: $IsBox($l#47#c#0, TChar)), (lambda $l#47#heap#0: Heap, $l#47#c#0: Box :: SetRef_to_SetBox((lambda $l#47#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF8Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#74#c#0): char)))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, TChar)), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))), s#0) && (var asCodeUnits#8 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#77#c#0): char)))), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $IsBox($l#77#c#0, TChar)), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))), s#0); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#8) && (var valueOrError0#8 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#8); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#8)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) && (var utf32#8 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#8) && (var asUtf8CodeUnits#8 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#8); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box(nat_from_bv8($Unbox($l#76#c#0): bv8))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, TBitvector(8))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#8)))))) && UnicodeStrings.__default.ToUTF8Checked(s#0) == (var asCodeUnits#8 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#71#c#0): char)))), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, TChar)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ))), s#0); (var valueOrError0#8 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#8); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#8) else (var utf32#8 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8)): Seq; (var asUtf8CodeUnits#8 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#8); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box(nat_from_bv8($Unbox($l#72#c#0): bv8))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, TBitvector(8))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#8)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF8Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#81#c#0): char)))), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, TChar)), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && (var asCodeUnits#9 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#84#c#0): char)))), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $IsBox($l#84#c#0, TChar)), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#9) && (var valueOrError0#9 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#9); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#9)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) && (var utf32#9 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9)): Seq; Utf8EncodingForm.__default.EncodeScalarSequence#canCall(utf32#9) && (var asUtf8CodeUnits#9 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#9); Seq.__default.Map#canCall(TBitvector(8), Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box(nat_from_bv8($Unbox($l#83#c#0): bv8))), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, TBitvector(8))), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#9)))))) && UnicodeStrings.__default.ToUTF8Checked(Lit(s#0)) == (var asCodeUnits#9 := Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#78#c#0): char)))), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, TChar)), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)); (var valueOrError0#9 := Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#9); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#9) else (var utf32#9 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9)): Seq; (var asUtf8CodeUnits#9 := Utf8EncodingForm.__default.EncodeScalarSequence(utf32#9); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(8), Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box(nat_from_bv8($Unbox($l#79#c#0): bv8))), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, TBitvector(8))), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))), asUtf8CodeUnits#9)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF8Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#74#ly#0: LayerType :: Handle1((lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $Box(nat_to_bv8($Unbox($l#74#c#0): int))), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: $IsBox($l#74#c#0, Tclass.BoundedInts.uint8())), (lambda $l#74#heap#0: Heap, $l#74#c#0: Box :: SetRef_to_SetBox((lambda $l#74#o#0: ref :: false))))), $LS($LZ))), bs#0) && (var asCodeUnits#8 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#77#ly#0: LayerType :: Handle1((lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $Box(nat_to_bv8($Unbox($l#77#c#0): int))), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: $IsBox($l#77#c#0, Tclass.BoundedInts.uint8())), (lambda $l#77#heap#0: Heap, $l#77#c#0: Box :: SetRef_to_SetBox((lambda $l#77#o#0: ref :: false))))), $LS($LZ))), bs#0); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#8) && (var valueOrError0#8 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#8); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#8)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) && (var utf32#8 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#8) && (var asUtf16CodeUnits#8 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#8); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#76#cu#0): bv16)))), (lambda $l#76#heap#0: Heap, $l#76#cu#0: Box :: $IsBox($l#76#cu#0, TBitvector(16))), (lambda $l#76#heap#0: Heap, $l#76#cu#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#8)))))) && UnicodeStrings.__default.FromUTF8Checked(bs#0) == (var asCodeUnits#8 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(nat_to_bv8($Unbox($l#71#c#0): int))), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, Tclass.BoundedInts.uint8())), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ))), bs#0); (var valueOrError0#8 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#8); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#8) else (var utf32#8 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#8)): Seq; (var asUtf16CodeUnits#8 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#8); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#72#cu#0): bv16)))), (lambda $l#72#heap#0: Heap, $l#72#cu#0: Box :: $IsBox($l#72#cu#0, TBitvector(16))), (lambda $l#72#heap#0: Heap, $l#72#cu#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#8)))))))));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint8(), TBitvector(8), $Heap, Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box(nat_to_bv8($Unbox($l#81#c#0): int))), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.BoundedInts.uint8())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && (var asCodeUnits#9 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $Box(nat_to_bv8($Unbox($l#84#c#0): int))), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $IsBox($l#84#c#0, Tclass.BoundedInts.uint8())), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked#canCall(asCodeUnits#9) && (var valueOrError0#9 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#9); Wrappers.Option.IsFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) && (Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) ==> Wrappers.Option.PropagateFailure#canCall(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#9)) && (!Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) ==> Wrappers.Option.Extract#canCall(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) && (var utf32#9 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9)): Seq; Utf16EncodingForm.__default.EncodeScalarSequence#canCall(utf32#9) && (var asUtf16CodeUnits#9 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#9); Seq.__default.Map#canCall(TBitvector(16), TChar, $Heap, Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#83#cu#0): bv16)))), (lambda $l#83#heap#0: Heap, $l#83#cu#0: Box :: $IsBox($l#83#cu#0, TBitvector(16))), (lambda $l#83#heap#0: Heap, $l#83#cu#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#9)))))) && UnicodeStrings.__default.FromUTF8Checked(Lit(bs#0)) == (var asCodeUnits#9 := Seq.__default.Map(Tclass.BoundedInts.uint8(), TBitvector(8), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box(nat_to_bv8($Unbox($l#78#c#0): int))), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, Tclass.BoundedInts.uint8())), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)); (var valueOrError0#9 := Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(asCodeUnits#9); (if Wrappers.Option.IsFailure(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9) then Wrappers.Option.PropagateFailure(TSeq(Tclass.Unicode.ScalarValue()), TSeq(TChar), valueOrError0#9) else (var utf32#9 := $Unbox(Wrappers.Option.Extract(TSeq(Tclass.Unicode.ScalarValue()), valueOrError0#9)): Seq; (var asUtf16CodeUnits#9 := Utf16EncodingForm.__default.EncodeScalarSequence(utf32#9); #Wrappers.Option.Some($Box(Seq.__default.Map(TBitvector(16), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#cu#0: Box :: $Box(char#FromInt(nat_from_bv16($Unbox($l#79#cu#0): bv16)))), (lambda $l#79#heap#0: Heap, $l#79#cu#0: Box :: $IsBox($l#79#cu#0, TBitvector(16))), (lambda $l#79#heap#0: Heap, $l#79#cu#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))), asUtf16CodeUnits#9)))))))));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ToUTF16Checked(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#82#c#0): char)))), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $IsBox($l#82#c#0, TChar)), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ))), s#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#83#c#0): char)))), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, TChar)), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ))), s#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#84#c#0): char)))), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $IsBox($l#84#c#0, TChar)), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), s#0)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $Box(char#ToInt($Unbox($l#86#c#0): char))), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $IsBox($l#86#c#0, TChar)), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ))), s#0)) && UnicodeStrings.__default.ToUTF16Checked(s#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#79#c#0): char)))), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, TChar)), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))), s#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $Box(char#ToInt($Unbox($l#80#c#0): char))), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $IsBox($l#80#c#0, TChar)), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ))), s#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar))) ==> Seq.__default.Map#canCall(TChar, TBitvector(16), $Heap, Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#90#c#0): char)))), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $IsBox($l#90#c#0, TChar)), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#91#c#0): char)))), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $IsBox($l#91#c#0, TChar)), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#92#ly#0: LayerType :: Handle1((lambda $l#92#heap#0: Heap, $l#92#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#92#c#0): char)))), (lambda $l#92#heap#0: Heap, $l#92#c#0: Box :: $IsBox($l#92#c#0, TChar)), (lambda $l#92#heap#0: Heap, $l#92#c#0: Box :: SetRef_to_SetBox((lambda $l#92#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $Box(char#ToInt($Unbox($l#94#c#0): char))), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $IsBox($l#94#c#0, TChar)), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) && UnicodeStrings.__default.ToUTF16Checked(Lit(s#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(TChar, TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $Box(nat_to_bv16(char#ToInt($Unbox($l#87#c#0): char)))), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $IsBox($l#87#c#0, TChar)), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $LS($LZ))), Lit(s#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#c#0: Box :: $Box(char#ToInt($Unbox($l#88#c#0): char))), (lambda $l#88#heap#0: Heap, $l#88#c#0: Box :: $IsBox($l#88#c#0, TChar)), (lambda $l#88#heap#0: Heap, $l#88#c#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: { UnicodeStrings.__default.FromUTF16Checked(bs#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(bs#0) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#82#ly#0: LayerType :: Handle1((lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $Box(nat_to_bv16($Unbox($l#82#c#0): int))), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: $IsBox($l#82#c#0, Tclass.BoundedInts.uint16())), (lambda $l#82#heap#0: Heap, $l#82#c#0: Box :: SetRef_to_SetBox((lambda $l#82#o#0: ref :: false))))), $LS($LZ))), bs#0) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box(nat_to_bv16($Unbox($l#83#c#0): int))), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, Tclass.BoundedInts.uint16())), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ))), bs#0)) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $Box(nat_to_bv16($Unbox($l#84#c#0): int))), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $IsBox($l#84#c#0, Tclass.BoundedInts.uint16())), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ))), bs#0)) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#86#ly#0: LayerType :: Handle1((lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $Box(char#FromInt($Unbox($l#86#c#0): int))), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: $IsBox($l#86#c#0, Tclass.BoundedInts.uint16())), (lambda $l#86#heap#0: Heap, $l#86#c#0: Box :: SetRef_to_SetBox((lambda $l#86#o#0: ref :: false))))), $LS($LZ))), bs#0)) && UnicodeStrings.__default.FromUTF16Checked(bs#0) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box(nat_to_bv16($Unbox($l#79#c#0): int))), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, Tclass.BoundedInts.uint16())), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))), bs#0)) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $Box(char#FromInt($Unbox($l#80#c#0): int))), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $IsBox($l#80#c#0, Tclass.BoundedInts.uint16())), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ))), bs#0))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, bs#0: Seq :: {:weight 3} { UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(bs#0)) || ($IsGoodHeap($Heap) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint16()))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TBitvector(16), $Heap, Lit(AtLayer((lambda $l#90#ly#0: LayerType :: Handle1((lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $Box(nat_to_bv16($Unbox($l#90#c#0): int))), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: $IsBox($l#90#c#0, Tclass.BoundedInts.uint16())), (lambda $l#90#heap#0: Heap, $l#90#c#0: Box :: SetRef_to_SetBox((lambda $l#90#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)) && Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence#canCall(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#91#ly#0: LayerType :: Handle1((lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $Box(nat_to_bv16($Unbox($l#91#c#0): int))), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: $IsBox($l#91#c#0, Tclass.BoundedInts.uint16())), (lambda $l#91#heap#0: Heap, $l#91#c#0: Box :: SetRef_to_SetBox((lambda $l#91#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && (Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#92#ly#0: LayerType :: Handle1((lambda $l#92#heap#0: Heap, $l#92#c#0: Box :: $Box(nat_to_bv16($Unbox($l#92#c#0): int))), (lambda $l#92#heap#0: Heap, $l#92#c#0: Box :: $IsBox($l#92#c#0, Tclass.BoundedInts.uint16())), (lambda $l#92#heap#0: Heap, $l#92#c#0: Box :: SetRef_to_SetBox((lambda $l#92#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) ==> Seq.__default.Map#canCall(Tclass.BoundedInts.uint16(), TChar, $Heap, Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $Box(char#FromInt($Unbox($l#94#c#0): int))), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $IsBox($l#94#c#0, Tclass.BoundedInts.uint16())), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) && UnicodeStrings.__default.FromUTF16Checked(Lit(bs#0)) == (if Utf16EncodingForm.__default.IsWellFormedCodeUnitSequence(Seq.__default.Map(Tclass.BoundedInts.uint16(), TBitvector(16), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $Box(nat_to_bv16($Unbox($l#87#c#0): int))), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: $IsBox($l#87#c#0, Tclass.BoundedInts.uint16())), (lambda $l#87#heap#0: Heap, $l#87#c#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0))) then #Wrappers.Option.Some($Box(Seq.__default.Map(Tclass.BoundedInts.uint16(), TChar, reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#c#0: Box :: $Box(char#FromInt($Unbox($l#88#c#0): int))), (lambda $l#88#heap#0: Heap, $l#88#c#0: Box :: $IsBox($l#88#c#0, Tclass.BoundedInts.uint16())), (lambda $l#88#heap#0: Heap, $l#88#c#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ))), Lit(bs#0)))) else #Wrappers.Option.None()));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF8#requires(s#0) <==> (forall i#12: int :: { $Unbox(Seq#Index(s#0, i#12)): char } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF8(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#12: int :: { $Unbox(Seq#Index(s#0, i#12)): char } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(char#ToInt($Unbox($l#33#c#0): char))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#33#c#0): char) && char#ToInt($Unbox($l#33#c#0): char) < 128), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF8(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(char#ToInt($Unbox($l#31#c#0): char))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#31#c#0): char) && char#ToInt($Unbox($l#31#c#0): char) < 128), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#13: int :: { $Unbox(Seq#Index(s#0, i#13)): char } LitInt(0) <= i#13 && i#13 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#13)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#13)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint8(), $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(char#ToInt($Unbox($l#36#c#0): char))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#36#c#0): char) && char#ToInt($Unbox($l#36#c#0): char) < 128), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF8(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint8(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(char#ToInt($Unbox($l#34#c#0): char))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#34#c#0): char) && char#ToInt($Unbox($l#34#c#0): char) < 128), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (UnicodeStrings.__default.ASCIIToUTF16#requires(s#0) <==> (forall i#12: int :: { $Unbox(Seq#Index(s#0, i#12)): char } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) < 128)));

axiom (forall $Heap: Heap, s#0: Seq :: { UnicodeStrings.__default.ASCIIToUTF16(s#0), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#12: int :: { $Unbox(Seq#Index(s#0, i#12)): char } LitInt(0) <= i#12 && i#12 < Seq#Length(s#0) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) && char#ToInt($Unbox(Seq#Index(s#0, i#12)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $Box(char#ToInt($Unbox($l#33#c#0): char))), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: $IsBox($l#33#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#33#c#0): char) && char#ToInt($Unbox($l#33#c#0): char) < 128), (lambda $l#33#heap#0: Heap, $l#33#c#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ))), s#0) && UnicodeStrings.__default.ASCIIToUTF16(s#0) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(char#ToInt($Unbox($l#31#c#0): char))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#31#c#0): char) && char#ToInt($Unbox($l#31#c#0): char) < 128), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ))), s#0));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)), $IsGoodHeap($Heap) } UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall i#13: int :: { $Unbox(Seq#Index(s#0, i#13)): char } LitInt(0) <= i#13 && i#13 < Seq#Length(Lit(s#0)) ==> LitInt(0) <= char#ToInt($Unbox(Seq#Index(Lit(s#0), i#13)): char) && char#ToInt($Unbox(Seq#Index(Lit(s#0), i#13)): char) < 128)) ==> Seq.__default.Map#canCall(TChar, Tclass.BoundedInts.uint16(), $Heap, Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $Box(char#ToInt($Unbox($l#36#c#0): char))), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: $IsBox($l#36#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#36#c#0): char) && char#ToInt($Unbox($l#36#c#0): char) < 128), (lambda $l#36#heap#0: Heap, $l#36#c#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)) && UnicodeStrings.__default.ASCIIToUTF16(Lit(s#0)) == Seq.__default.Map(TChar, Tclass.BoundedInts.uint16(), reveal_Seq._default.Map, $Heap, Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $Box(char#ToInt($Unbox($l#34#c#0): char))), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: $IsBox($l#34#c#0, TChar) && LitInt(0) <= char#ToInt($Unbox($l#34#c#0): char) && char#ToInt($Unbox($l#34#c#0): char) < 128), (lambda $l#34#heap#0: Heap, $l#34#c#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ))), Lit(s#0)));

axiom MulInternals.__default.MulAuto() <==> (forall x#204: int, y#204: int :: { Mul(x#204, y#204) } Mul(x#204, y#204) == Mul(y#204, x#204)) && (forall x#205: int, y#205: int, z#136: int :: { Mul(x#205 + y#205, z#136) } Mul(x#205 + y#205, z#136) == Mul(x#205, z#136) + Mul(y#205, z#136)) && (forall x#206: int, y#206: int, z#137: int :: { Mul(x#206 - y#206, z#137) } Mul(x#206 - y#206, z#137) == Mul(x#206, z#137) - Mul(y#206, z#137));

axiom MulInternals.__default.MulAuto() <==> (forall x#207: int, y#207: int :: { Mul(x#207, y#207) } Mul(x#207, y#207) == Mul(y#207, x#207)) && (forall x#208: int, y#208: int, z#138: int :: { Mul(x#208 + y#208, z#138) } Mul(x#208 + y#208, z#138) == Mul(x#208, z#138) + Mul(y#208, z#138)) && (forall x#209: int, y#209: int, z#139: int :: { Mul(x#209 - y#209, z#139) } Mul(x#209 - y#209, z#139) == Mul(x#209, z#139) - Mul(y#209, z#139));

axiom (forall n#0: int :: { ModInternals.__default.ModAuto(n#0) } ModInternals.__default.ModAuto#canCall(n#0) || n#0 > 0 ==> (ModInternals.__default.ModAuto(n#0) <==> Mod(n#0, n#0) == Mod(0 - n#0, n#0) && Mod(0 - n#0, n#0) == LitInt(0) && (forall x#256: int :: { Mod(Mod(x#256, n#0), n#0) } Mod(Mod(x#256, n#0), n#0) == Mod(x#256, n#0)) && (forall x#257: int :: { Mod(x#257, n#0) } LitInt(0) <= x#257 && x#257 < n#0 <==> Mod(x#257, n#0) == x#257) && (forall x#258: int, y#128: int :: { Mod(x#258 + y#128, n#0) } (var z#126 := Mod(x#258, n#0) + Mod(y#128, n#0); (LitInt(0) <= z#126 && z#126 < n#0 && Mod(x#258 + y#128, n#0) == z#126) || (n#0 <= z#126 && z#126 < n#0 + n#0 && Mod(x#258 + y#128, n#0) == z#126 - n#0))) && (forall x#259: int, y#129: int :: { Mod(x#259 - y#129, n#0) } (var z#127 := Mod(x#259, n#0) - Mod(y#129, n#0); (LitInt(0) <= z#127 && z#127 < n#0 && Mod(x#259 - y#129, n#0) == z#127) || (0 - n#0 <= z#127 && z#127 < 0 && Mod(x#259 - y#129, n#0) == z#127 + n#0)))));

axiom (forall n#0: int :: {:weight 3} { ModInternals.__default.ModAuto(LitInt(n#0)) } ModInternals.__default.ModAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> (ModInternals.__default.ModAuto(LitInt(n#0)) <==> LitInt(Mod(n#0, LitInt(n#0))) == LitInt(Mod(0 - n#0, LitInt(n#0))) && LitInt(Mod(0 - n#0, LitInt(n#0))) == LitInt(0) && (forall x#260: int :: { Mod(Mod(x#260, n#0), n#0) } Mod(Mod(x#260, LitInt(n#0)), LitInt(n#0)) == Mod(x#260, LitInt(n#0))) && (forall x#261: int :: { Mod(x#261, n#0) } LitInt(0) <= x#261 && x#261 < n#0 <==> Mod(x#261, LitInt(n#0)) == x#261) && (forall x#262: int, y#130: int :: { Mod(x#262 + y#130, n#0) } (var z#128 := Mod(x#262, LitInt(n#0)) + Mod(y#130, LitInt(n#0)); (LitInt(0) <= z#128 && z#128 < n#0 && Mod(x#262 + y#130, LitInt(n#0)) == z#128) || (LitInt(n#0) <= z#128 && z#128 < n#0 + n#0 && Mod(x#262 + y#130, LitInt(n#0)) == z#128 - n#0))) && (forall x#263: int, y#131: int :: { Mod(x#263 - y#131, n#0) } (var z#129 := Mod(x#263, LitInt(n#0)) - Mod(y#131, LitInt(n#0)); (LitInt(0) <= z#129 && z#129 < n#0 && Mod(x#263 - y#131, LitInt(n#0)) == z#129) || (LitInt(0 - n#0) <= z#129 && z#129 < 0 && Mod(x#263 - y#131, LitInt(n#0)) == z#129 + n#0)))));

axiom (forall n#0: int :: { DivInternals.__default.DivAuto(n#0) } DivInternals.__default.DivAuto#canCall(n#0) || n#0 > 0 ==> ModInternals.__default.ModAuto#canCall(n#0) && (DivInternals.__default.DivAuto(n#0) <==> ModInternals.__default.ModAuto(n#0) && Div(n#0, n#0) == 0 - Div(0 - n#0, n#0) && 0 - Div(0 - n#0, n#0) == LitInt(1) && (forall x#186: int :: { Div(x#186, n#0) } LitInt(0) <= x#186 && x#186 < n#0 <==> Div(x#186, n#0) == LitInt(0)) && (forall x#187: int, y#124: int :: { Div(x#187 + y#124, n#0) } (var z#122 := Mod(x#187, n#0) + Mod(y#124, n#0); (LitInt(0) <= z#122 && z#122 < n#0 && Div(x#187 + y#124, n#0) == Div(x#187, n#0) + Div(y#124, n#0)) || (n#0 <= z#122 && z#122 < n#0 + n#0 && Div(x#187 + y#124, n#0) == Div(x#187, n#0) + Div(y#124, n#0) + 1))) && (forall x#188: int, y#125: int :: { Div(x#188 - y#125, n#0) } (var z#123 := Mod(x#188, n#0) - Mod(y#125, n#0); (LitInt(0) <= z#123 && z#123 < n#0 && Div(x#188 - y#125, n#0) == Div(x#188, n#0) - Div(y#125, n#0)) || (0 - n#0 <= z#123 && z#123 < 0 && Div(x#188 - y#125, n#0) == Div(x#188, n#0) - Div(y#125, n#0) - 1)))));

axiom (forall n#0: int :: {:weight 3} { DivInternals.__default.DivAuto(LitInt(n#0)) } DivInternals.__default.DivAuto#canCall(LitInt(n#0)) || Lit(n#0 > 0) ==> ModInternals.__default.ModAuto#canCall(LitInt(n#0)) && (DivInternals.__default.DivAuto(LitInt(n#0)) <==> ModInternals.__default.ModAuto(LitInt(n#0)) && LitInt(Div(n#0, LitInt(n#0))) == LitInt(0 - Div(0 - n#0, LitInt(n#0))) && LitInt(0 - Div(0 - n#0, LitInt(n#0))) == LitInt(1) && (forall x#189: int :: { Div(x#189, n#0) } LitInt(0) <= x#189 && x#189 < n#0 <==> Div(x#189, LitInt(n#0)) == LitInt(0)) && (forall x#190: int, y#126: int :: { Div(x#190 + y#126, n#0) } (var z#124 := Mod(x#190, LitInt(n#0)) + Mod(y#126, LitInt(n#0)); (LitInt(0) <= z#124 && z#124 < n#0 && Div(x#190 + y#126, LitInt(n#0)) == Div(x#190, LitInt(n#0)) + Div(y#126, LitInt(n#0))) || (LitInt(n#0) <= z#124 && z#124 < n#0 + n#0 && Div(x#190 + y#126, LitInt(n#0)) == Div(x#190, LitInt(n#0)) + Div(y#126, LitInt(n#0)) + 1))) && (forall x#191: int, y#127: int :: { Div(x#191 - y#127, n#0) } (var z#125 := Mod(x#191, LitInt(n#0)) - Mod(y#127, LitInt(n#0)); (LitInt(0) <= z#125 && z#125 < n#0 && Div(x#191 - y#127, LitInt(n#0)) == Div(x#191, LitInt(n#0)) - Div(y#127, LitInt(n#0))) || (LitInt(0 - n#0) <= z#125 && z#125 < 0 && Div(x#191 - y#127, LitInt(n#0)) == Div(x#191, LitInt(n#0)) - Div(y#127, LitInt(n#0)) - 1)))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: { JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(lv#0, rv#0) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && JSON_mUtils_mViews_mCore.__default.Adjacent(lv#0, rv#0)) ==> (var dt_update_tmp#0#50 := lv#0; JSON_mUtils_mViews_mCore.View__.View_q(rv#0) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#50) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#50)) && JSON_mUtils_mViews_mCore.__default.Merge(lv#0, rv#0) == (var dt_update_tmp#0#50 := lv#0; (var dt_update#end#0#50 := JSON_mUtils_mViews_mCore.View__.end(rv#0); #JSON.Utils.Views.Core.View_.View(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#50), JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#50), dt_update#end#0#50))));

axiom (forall lv#0: DatatypeType, rv#0: DatatypeType :: {:weight 3} { JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) } JSON_mUtils_mViews_mCore.__default.Merge#canCall(Lit(lv#0), Lit(rv#0)) || ($Is(lv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && $Is(rv#0, Tclass.JSON_mUtils_mViews_mCore.View()) && Lit(JSON_mUtils_mViews_mCore.__default.Adjacent(Lit(lv#0), Lit(rv#0)))) ==> (var dt_update_tmp#0#51 := Lit(lv#0); JSON_mUtils_mViews_mCore.View__.View_q(Lit(rv#0)) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#51) && JSON_mUtils_mViews_mCore.View__.View_q(dt_update_tmp#0#51)) && JSON_mUtils_mViews_mCore.__default.Merge(Lit(lv#0), Lit(rv#0)) == (var dt_update_tmp#0#51 := Lit(lv#0); (var dt_update#end#0#51 := LitInt(JSON_mUtils_mViews_mCore.View__.end(Lit(rv#0))); Lit(#JSON.Utils.Views.Core.View_.View(Lit(JSON_mUtils_mViews_mCore.View__.s(dt_update_tmp#0#51)), LitInt(JSON_mUtils_mViews_mCore.View__.beg(dt_update_tmp#0#51)), dt_update#end#0#51)))));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) ==> (JSON_mUtils_mViews_mCore.View__.OfString#requires(s#0) <==> (forall c#52: char :: { Seq#Contains(s#0, $Box(c#52)) } $Is(c#52, TChar) && Seq#Contains(s#0, $Box(c#52)) ==> char#ToInt(c#52) < 256)));

axiom (forall $Heap: Heap, s#0: Seq :: { JSON_mUtils_mViews_mCore.View__.OfString(s#0), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(s#0) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#52: char :: { Seq#Contains(s#0, $Box(c#52)) } $Is(c#52, TChar) && Seq#Contains(s#0, $Box(c#52)) ==> char#ToInt(c#52) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(s#0) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(s#0), Lit(AtLayer((lambda $l#104#ly#0: LayerType :: Handle1((lambda $l#104#heap#0: Heap, $l#104#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(s#0, $Unbox($l#104#i#0): int)): char))), (lambda $l#104#heap#0: Heap, $l#104#i#0: Box :: $IsBox($l#104#i#0, TInt) && LitInt(0) <= $Unbox($l#104#i#0): int && $Unbox($l#104#i#0): int < Seq#Length(s#0)), (lambda $l#104#heap#0: Heap, $l#104#i#0: Box :: SetRef_to_SetBox((lambda $l#104#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall $Heap: Heap, s#0: Seq :: {:weight 3} { JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)), $IsGoodHeap($Heap) } JSON_mUtils_mViews_mCore.View__.OfString#canCall(Lit(s#0)) || ($IsGoodHeap($Heap) && $Is(s#0, TSeq(TChar)) && (forall c#53: char :: { Seq#Contains(s#0, $Box(c#53)) } $Is(c#53, TChar) && Seq#Contains(s#0, $Box(c#53)) ==> char#ToInt(c#53) < 256)) ==> JSON_mUtils_mViews_mCore.View__.OfString(Lit(s#0)) == Seq#Create(Tclass.BoundedInts.uint8(), $Heap, Seq#Length(Lit(s#0)), Lit(AtLayer((lambda $l#106#ly#0: LayerType :: Handle1((lambda $l#106#heap#0: Heap, $l#106#i#0: Box :: $Box(char#ToInt($Unbox(Seq#Index(Lit(s#0), $Unbox($l#106#i#0): int)): char))), (lambda $l#106#heap#0: Heap, $l#106#i#0: Box :: $IsBox($l#106#i#0, TInt) && LitInt(0) <= $Unbox($l#106#i#0): int && $Unbox($l#106#i#0): int < Seq#Length(Lit(s#0))), (lambda $l#106#heap#0: Heap, $l#106#i#0: Box :: SetRef_to_SetBox((lambda $l#106#o#0: ref :: false))))), $LS($LZ)))));

axiom (forall st#0: DatatypeType, byte#0: int :: { JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(st#0, byte#0) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(st#0, byte#0) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(st#0) then (if byte#0 == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(st#0) then (var escaped#40 := JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(st#0); (if byte#0 == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#40))) else (if byte#0 == char#ToInt(Lit(char#FromInt(34))) && !escaped#40 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall st#0: DatatypeType, byte#0: int :: {:weight 3} { JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) } JSON_mUtils_mLexers_mStrings.__default.String#canCall(Lit(st#0), LitInt(byte#0)) || ($Is(st#0, Tclass.JSON_mUtils_mLexers_mStrings.StringLexerState()) && LitInt(-1) <= byte#0 && byte#0 < BoundedInts.__default.TWO__TO__THE__8()) ==> JSON_mUtils_mLexers_mStrings.__default.String(Lit(st#0), LitInt(byte#0)) == (if JSON_mUtils_mLexers_mStrings.StringLexerState.Start_q(Lit(st#0)) then (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false))))) else #JSON.Utils.Lexers.Core.LexerResult.Reject($Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(119))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(98))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(101))))))) else (if JSON_mUtils_mLexers_mStrings.StringLexerState.Body_q(Lit(st#0)) then (var escaped#42 := Lit(JSON_mUtils_mLexers_mStrings.StringLexerState.escaped(Lit(st#0))); (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(92))) then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(#JSON.Utils.Lexers.Strings.StringLexerState.Body(!escaped#42))) else (if LitInt(byte#0) == char#ToInt(Lit(char#FromInt(34))) && !escaped#42 then #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.End()))) else #JSON.Utils.Lexers.Core.LexerResult.Partial($Box(Lit(#JSON.Utils.Lexers.Strings.StringLexerState.Body(Lit(false)))))))) else #JSON.Utils.Lexers.Core.LexerResult.Accept())));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, this, pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, this, pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(this) then (var b#204 := JSON_mUtils_mCursors.CursorError.b(this); (var b0#102 := JSON_mUtils_mCursors.CursorError.expected(this); (var c#204 := (if b#204 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#204)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#102)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#204)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(this) then (var b#205 := JSON_mUtils_mCursors.CursorError.b(this); (var bs0#102 := JSON_mUtils_mCursors.CursorError.expected__sq(this); (var c#205 := (if b#205 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#205)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#102 := Seq#Create(TChar, $Heap, Seq#Length(bs0#102), Lit(AtLayer((lambda $l#157#ly#0: LayerType :: Handle1((lambda $l#157#heap#0: Heap, $l#157#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#102, $Unbox($l#157#idx#0): int)): int))), (lambda $l#157#heap#0: Heap, $l#157#idx#0: Box :: $IsBox($l#157#idx#0, TInt) && LitInt(0) <= $Unbox($l#157#idx#0): int && $Unbox($l#157#idx#0): int < Seq#Length(bs0#102)), (lambda $l#157#heap#0: Heap, $l#157#idx#0: Box :: SetRef_to_SetBox((lambda $l#157#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#102), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#205))))) else (var err#102 := JSON_mUtils_mCursors.CursorError.err(this); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#102)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), pr#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#208 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#104 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#208 := (if b#208 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#208)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#104)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#208)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#209 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#104 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#209 := (if b#209 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#209)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#104 := Seq#Create(TChar, $Heap, Seq#Length(bs0#104), Lit(AtLayer((lambda $l#160#ly#0: LayerType :: Handle1((lambda $l#160#heap#0: Heap, $l#160#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#104, $Unbox($l#160#idx#0): int)): int))), (lambda $l#160#heap#0: Heap, $l#160#idx#0: Box :: $IsBox($l#160#idx#0, TInt) && LitInt(0) <= $Unbox($l#160#idx#0): int && $Unbox($l#160#idx#0): int < Seq#Length(bs0#104)), (lambda $l#160#heap#0: Heap, $l#160#idx#0: Box :: SetRef_to_SetBox((lambda $l#160#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#104), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#209))))) else (var err#104 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, pr#0, err#104)): Seq)))));

axiom (forall JSON.Utils.Cursors.CursorError$R: Ty, $Heap: Heap, this: DatatypeType, pr#0: HandleType :: {:weight 3} { JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.CursorError.ToString#canCall(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.CursorError$R), $Heap) && $Is(pr#0, Tclass._System.___hTotalFunc1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar)))) ==> JSON_mUtils_mCursors.CursorError.ToString(JSON.Utils.Cursors.CursorError$R, Lit(this), Lit(pr#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(this)) then (var b#212 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var b0#106 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(this))); (var c#212 := (if b#212 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#212)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#106)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#212)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(this)) then (var b#213 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(this))); (var bs0#106 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(this))); (var c#213 := (if b#213 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#213)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#106 := Seq#Create(TChar, $Heap, Seq#Length(bs0#106), Lit(AtLayer((lambda $l#163#ly#0: LayerType :: Handle1((lambda $l#163#heap#0: Heap, $l#163#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#106, $Unbox($l#163#idx#0): int)): int))), (lambda $l#163#heap#0: Heap, $l#163#idx#0: Box :: $IsBox($l#163#idx#0, TInt) && LitInt(0) <= $Unbox($l#163#idx#0): int && $Unbox($l#163#idx#0): int < Seq#Length(bs0#106)), (lambda $l#163#heap#0: Heap, $l#163#idx#0: Box :: SetRef_to_SetBox((lambda $l#163#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#106), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#213))))) else (var err#106 := Lit(JSON_mUtils_mCursors.CursorError.err(Lit(this))); $Unbox(Apply1(JSON.Utils.Cursors.CursorError$R, TSeq(TChar), $Heap, Lit(pr#0), err#106)): Seq)))));

axiom (forall this: DatatypeType, other#0: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) } JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q#canCall(this, other#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(other#0, Tclass.JSON_mUtils_mCursors.Cursor()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.SuffixLength(this) < JSON_mUtils_mCursors.Cursor__.SuffixLength(other#0)) && (JSON_mUtils_mCursors.Cursor__.StrictlyAdvancedFrom_q(this, other#0) ==> JSON_mUtils_mCursors.Cursor__.beg(this) == JSON_mUtils_mCursors.Cursor__.beg(other#0) && JSON_mUtils_mCursors.Cursor__.end(this) == JSON_mUtils_mCursors.Cursor__.end(other#0) ==> (forall idx#19: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#19)): int } { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#19)): int } LitInt(0) <= idx#19 && idx#19 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.beg(this) <= idx#19 && idx#19 < JSON_mUtils_mCursors.Cursor__.point(this) ==> $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(this), idx#19)): int == $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(other#0), idx#19)): int)));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Suffix(this) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> (var dt_update_tmp#0#34 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34)) && JSON_mUtils_mCursors.Cursor__.Suffix(this) == (var dt_update_tmp#0#34 := this; (var dt_update#beg#0#34 := JSON_mUtils_mCursors.Cursor__.point(this); #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#34), dt_update#beg#0#34, JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#34), JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#34)))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) } JSON_mUtils_mCursors.Cursor__.Suffix#canCall(Lit(this)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> (var dt_update_tmp#0#35 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35)) && JSON_mUtils_mCursors.Cursor__.Suffix(Lit(this)) == (var dt_update_tmp#0#35 := Lit(this); (var dt_update#beg#0#35 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this))); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#35)), dt_update#beg#0#35, LitInt(JSON_mUtils_mCursors.Cursor__.point(dt_update_tmp#0#35)), LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#35)))))));

axiom (forall this: DatatypeType :: { JSON_mUtils_mCursors.Cursor__.Split(this) } JSON_mUtils_mCursors.Cursor__.Split#canCall(this) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#87#ly#0: LayerType :: Handle1((lambda $l#87#heap#0: Heap, $l#87#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#87#v#0): DatatypeType))), (lambda $l#87#heap#0: Heap, $l#87#v#0: Box :: $IsBox($l#87#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#87#heap#0: Heap, $l#87#v#0: Box :: SetRef_to_SetBox((lambda $l#87#o#0: ref :: false))))), $LS($LZ)))) && (JSON_mUtils_mCursors.Cursor__.beg(this) != JSON_mUtils_mCursors.Cursor__.point(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#88#ly#0: LayerType :: Handle1((lambda $l#88#heap#0: Heap, $l#88#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#88#v#0): DatatypeType))), (lambda $l#88#heap#0: Heap, $l#88#v#0: Box :: $IsBox($l#88#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#88#heap#0: Heap, $l#88#v#0: Box :: SetRef_to_SetBox((lambda $l#88#o#0: ref :: false))))), $LS($LZ))))) && (!JSON_mUtils_mCursors.Cursor__.BOF_q(this) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), JSON_mUtils_mCursors.Cursor__.Split(this), this, Lit(AtLayer((lambda $l#89#ly#0: LayerType :: Handle1((lambda $l#89#heap#0: Heap, $l#89#v#0: Box :: $Box(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox($l#89#v#0): DatatypeType))), (lambda $l#89#heap#0: Heap, $l#89#v#0: Box :: $IsBox($l#89#v#0, Tclass.JSON_mUtils_mViews_mCore.View())), (lambda $l#89#heap#0: Heap, $l#89#v#0: Box :: SetRef_to_SetBox((lambda $l#89#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictSuffixOf_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)), this)) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(this) <==> !JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(this)))) && $Is(JSON_mUtils_mCursors.Cursor__.Split(this), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View())));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.point(this) + n#0 <= JSON_mUtils_mCursors.Cursor__.end(this)) ==> (var dt_update_tmp#0#34 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34)) && JSON_mUtils_mCursors.Cursor__.Skip(this, n#0) == (var dt_update_tmp#0#34 := this; (var dt_update#point#0#34 := JSON_mUtils_mCursors.Cursor__.point(this) + n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#34), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#34), dt_update#point#0#34, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#34)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0) <= LitInt(JSON_mUtils_mCursors.Cursor__.end(Lit(this)))) ==> (var dt_update_tmp#0#35 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35)) && JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#35 := Lit(this); (var dt_update#point#0#35 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) + n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#35)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#35)), dt_update#point#0#35, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#35)))))));

axiom (forall this: DatatypeType, n#0: int :: { JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(this, n#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && JSON_mUtils_mCursors.Cursor__.beg(this) <= JSON_mUtils_mCursors.Cursor__.point(this) - n#0) ==> (var dt_update_tmp#0#34 := this; JSON_mUtils_mCursors.Cursor__.Cursor_q(this) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#34)) && JSON_mUtils_mCursors.Cursor__.Unskip(this, n#0) == (var dt_update_tmp#0#34 := this; (var dt_update#point#0#34 := JSON_mUtils_mCursors.Cursor__.point(this) - n#0; #JSON.Utils.Cursors.Cursor_.Cursor(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#34), JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#34), dt_update#point#0#34, JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#34)))));

axiom (forall this: DatatypeType, n#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) } JSON_mUtils_mCursors.Cursor__.Unskip#canCall(Lit(this), LitInt(n#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= n#0 && n#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && LitInt(JSON_mUtils_mCursors.Cursor__.beg(Lit(this))) <= LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0)) ==> (var dt_update_tmp#0#35 := Lit(this); JSON_mUtils_mCursors.Cursor__.Cursor_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35) && JSON_mUtils_mCursors.Cursor__.Cursor_q(dt_update_tmp#0#35)) && JSON_mUtils_mCursors.Cursor__.Unskip(Lit(this), LitInt(n#0)) == (var dt_update_tmp#0#35 := Lit(this); (var dt_update#point#0#35 := LitInt(JSON_mUtils_mCursors.Cursor__.point(Lit(this)) - n#0); Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(JSON_mUtils_mCursors.Cursor__.s(dt_update_tmp#0#35)), LitInt(JSON_mUtils_mCursors.Cursor__.beg(dt_update_tmp#0#35)), dt_update#point#0#35, LitInt(JSON_mUtils_mCursors.Cursor__.end(dt_update_tmp#0#35)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var nxt#34 := JSON_mUtils_mCursors.Cursor__.Peek(this); nxt#34 == b#0 ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, this, b#0) == (var nxt#34 := JSON_mUtils_mCursors.Cursor__.Peek(this); (if nxt#34 == b#0 then #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)))) else #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingByte(b#0, nxt#34))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertByte$R: Ty, this: DatatypeType, b#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) } JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && LitInt(0) <= b#0 && b#0 < BoundedInts.__default.TWO__TO__THE__8() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var nxt#35 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); nxt#35 == LitInt(b#0) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1))) && JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertByte$R, Lit(this), LitInt(b#0)) == (var nxt#35 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this))); (if nxt#35 == LitInt(b#0) then #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.ExpectingByte(LitInt(b#0), nxt#35)))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) } $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() ==> (JSON_mUtils_mCursors.Cursor__.AssertBytes#requires(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, this, bs#0, offset#0) <==> JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#54: int :: { Seq#Contains(bs#0, $Box(b#54)) } LitInt(0) <= b#54 && b#54 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#54)) ==> b#54 < 256)));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(this) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#54: int :: { Seq#Contains(bs#0, $Box(b#54)) } LitInt(0) <= b#54 && b#54 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#54)) ==> b#54 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#51 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#51)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51) && (var ps#51 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#51, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), this, bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(this)) else (var valueOrError0#51 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, this, $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#51) else (var ps#51 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#51)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $ly, ps#51, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), bs#0, offset#0) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32() && offset#0 <= Seq#Length(bs#0) && (forall b#55: int :: { Seq#Contains(bs#0, $Box(b#55)) } LitInt(0) <= b#55 && b#55 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#55)) ==> b#55 < 256)) ==> (offset#0 != Seq#Length(bs#0) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int) && (var valueOrError0#52 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#52)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52) && (var ps#52 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#52, bs#0, offset#0 + 1))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), bs#0, offset#0) == (if offset#0 == Seq#Length(bs#0) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#52 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(bs#0, offset#0)): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#52) else (var ps#52 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#52)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#52, bs#0, offset#0 + 1))))));

axiom (forall JSON.Utils.Cursors.Cursor_.AssertBytes$R: Ty, $ly: LayerType, this: DatatypeType, bs#0: Seq, offset#0: int :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) } JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), Lit(bs#0), LitInt(offset#0)) || ($Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= offset#0 && offset#0 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this)) && Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32() && LitInt(offset#0) <= Seq#Length(Lit(bs#0)) && (forall b#56: int :: { Seq#Contains(bs#0, $Box(b#56)) } LitInt(0) <= b#56 && b#56 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(bs#0, $Box(b#56)) ==> b#56 < 256)) ==> (LitInt(offset#0) != Seq#Length(Lit(bs#0)) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int) && (var valueOrError0#53 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#53)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53) && (var ps#53 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(JSON.Utils.Cursors.Cursor_.AssertBytes$R, ps#53, Lit(bs#0), LitInt(offset#0 + 1)))))) && JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), Lit(this), Lit(bs#0), LitInt(offset#0)) == (if LitInt(offset#0) == Seq#Length(Lit(bs#0)) then #Wrappers.Result.Success($Box(Lit(this))) else (var valueOrError0#53 := JSON_mUtils_mCursors.Cursor__.AssertByte(JSON.Utils.Cursors.Cursor_.AssertBytes$R, Lit(this), $Unbox(Seq#Index(Lit(bs#0), LitInt(offset#0))): int); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), Tclass.JSON_mUtils_mCursors.Cursor__(), valueOrError0#53) else (var ps#53 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Cursors.Cursor_.AssertBytes$R), valueOrError0#53)): DatatypeType; JSON_mUtils_mCursors.Cursor__.AssertBytes(JSON.Utils.Cursors.Cursor_.AssertBytes$R, $LS($ly), ps#53, Lit(bs#0), LitInt(offset#0 + 1)))))));

axiom (forall $ly: LayerType, $Heap: Heap, this: DatatypeType, p#0: HandleType :: { JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhile#canCall(this, p#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool)) && $IsAlloc(p#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool), $Heap) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.AdvancedFrom_q(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), this) && (forall idx#19: int :: { $Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#19)): int } LitInt(0) <= idx#19 && idx#19 < BoundedInts.__default.TWO__TO__THE__32() && JSON_mUtils_mCursors.Cursor__.point(this) <= idx#19 && idx#19 < JSON_mUtils_mCursors.Cursor__.point(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, p#0, $Box($Unbox(Seq#Index(JSON_mUtils_mCursors.Cursor__.s(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0)), idx#19)): int))): bool) && $Is(JSON_mUtils_mCursors.Cursor__.SkipWhile($ly, this, p#0), Tclass.JSON_mUtils_mCursors.Cursor()));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(this)) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(this) && (var st#104 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(this) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(this, LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#104)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), this, step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then #Wrappers.Result.Success($Box(this)) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType) then (var err#103 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#103)))) else (var st#103 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(JSON_mUtils_mCursors.Cursor__.Peek(this)))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(this) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $ly, JSON_mUtils_mCursors.Cursor__.Skip(this, LitInt(1)), step#0, st#103))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), step#0, st#0) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#106 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#106)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), step#0, st#0) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#105 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#105)))) else (var st#105 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, step#0, st#0, $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), step#0, st#105))))));

axiom (forall JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, $ly: LayerType, $Heap: Heap, this: DatatypeType, step#0: HandleType, st#0: Box :: {:weight 3} { JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)), $IsGoodHeap($Heap) } JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(this), Lit(step#0), Lit(st#0)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mCursors.Cursor__()) && $IsAlloc(this, Tclass.JSON_mUtils_mCursors.Cursor__(), $Heap) && $Is(step#0, Tclass._System.___hTotalFunc2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R))) && $IsBox(st#0, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A) && JSON_mUtils_mCursors.Cursor__.Valid_q(Lit(this))) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (!JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this))) && (!JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(this)) && (var st#108 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); !JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) ==> JSON_mUtils_mCursors.Cursor__.Skip#canCall(Lit(this), LitInt(1)) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer#canCall(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#108)))) && JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(this), Lit(step#0), Lit(st#0)) == (if JSON_mUtils_mLexers_mCore.LexerResult.Accept_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then #Wrappers.Result.Success($Box(Lit(this))) else (if JSON_mUtils_mLexers_mCore.LexerResult.Reject_q($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType) then (var err#107 := JSON_mUtils_mLexers_mCore.LexerResult.err($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.OtherError(err#107)))) else (var st#107 := JSON_mUtils_mLexers_mCore.LexerResult.st($Unbox(Apply2(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R), $Heap, Lit(step#0), Lit(st#0), $Box(LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(this)))))): DatatypeType); (if JSON_mUtils_mCursors.Cursor__.EOF_q(Lit(this)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, $LS($ly), Lit(JSON_mUtils_mCursors.Cursor__.Skip(Lit(this), LitInt(1))), Lit(step#0), st#107))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#136#ly#0: LayerType :: Handle1((lambda $l#136#heap#0: Heap, $l#136#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#136#heap#0: Heap, $l#136#_v0#0: Box :: $IsBox($l#136#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#136#heap#0: Heap, $l#136#_v0#0: Box :: SetRef_to_SetBox((lambda $l#136#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#137#ly#0: LayerType :: Handle1((lambda $l#137#heap#0: Heap, $l#137#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#137#heap#0: Heap, $l#137#_v1#0: Box :: $IsBox($l#137#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#137#heap#0: Heap, $l#137#_v1#0: Box :: SetRef_to_SetBox((lambda $l#137#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.ParserWitness$T: Ty, JSON.Utils.Parsers._default.ParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) } JSON_mUtils_mParsers.__default.ParserWitness(JSON.Utils.Parsers._default.ParserWitness$T, JSON.Utils.Parsers._default.ParserWitness$R, true) == Lit(#JSON.Utils.Parsers.Parser_.Parser(Lit(AtLayer((lambda $l#140#ly#0: LayerType :: Handle1((lambda $l#140#heap#0: Heap, $l#140#_v0#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#140#heap#0: Heap, $l#140#_v0#0: Box :: $IsBox($l#140#_v0#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#140#heap#0: Heap, $l#140#_v0#0: Box :: SetRef_to_SetBox((lambda $l#140#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#141#ly#0: LayerType :: Handle1((lambda $l#141#heap#0: Heap, $l#141#_v1#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#141#heap#0: Heap, $l#141#_v1#0: Box :: $IsBox($l#141#_v1#0, JSON.Utils.Parsers._default.ParserWitness$T)), (lambda $l#141#heap#0: Heap, $l#141#_v1#0: Box :: SetRef_to_SetBox((lambda $l#141#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#204#ly#0: LayerType :: Handle1((lambda $l#204#heap#0: Heap, $l#204#cs#0: Box :: $Box(Lit(false))), (lambda $l#204#heap#0: Heap, $l#204#cs#0: Box :: $IsBox($l#204#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#204#heap#0: Heap, $l#204#cs#0: Box :: SetRef_to_SetBox((lambda $l#204#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#205#ly#0: LayerType :: Handle1((lambda $l#205#heap#0: Heap, $l#205#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#205#heap#0: Heap, $l#205#cs#0: Box :: $IsBox($l#205#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#205#heap#0: Heap, $l#205#cs#0: Box :: SetRef_to_SetBox((lambda $l#205#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#206#ly#0: LayerType :: Handle1((lambda $l#206#heap#0: Heap, $l#206#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#206#heap#0: Heap, $l#206#_v2#0: Box :: $IsBox($l#206#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#206#heap#0: Heap, $l#206#_v2#0: Box :: SetRef_to_SetBox((lambda $l#206#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers._default.SubParserWitness$T: Ty, JSON.Utils.Parsers._default.SubParserWitness$R: Ty :: {:weight 3} { JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) } JSON_mUtils_mParsers.__default.SubParserWitness(JSON.Utils.Parsers._default.SubParserWitness$T, JSON.Utils.Parsers._default.SubParserWitness$R, true) == Lit(#JSON.Utils.Parsers.SubParser_.SubParser(Lit(#JSON.Utils.Cursors.Cursor_.Cursor(Lit(Seq#Empty(): Seq), LitInt(0), LitInt(0), LitInt(0))), Lit(AtLayer((lambda $l#210#ly#0: LayerType :: Handle1((lambda $l#210#heap#0: Heap, $l#210#cs#0: Box :: $Box(Lit(false))), (lambda $l#210#heap#0: Heap, $l#210#cs#0: Box :: $IsBox($l#210#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#210#heap#0: Heap, $l#210#cs#0: Box :: SetRef_to_SetBox((lambda $l#210#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#211#ly#0: LayerType :: Handle1((lambda $l#211#heap#0: Heap, $l#211#cs#0: Box :: $Box(Lit(#Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF())))))), (lambda $l#211#heap#0: Heap, $l#211#cs#0: Box :: $IsBox($l#211#cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#211#heap#0: Heap, $l#211#cs#0: Box :: SetRef_to_SetBox((lambda $l#211#o#0: ref :: false))))), $LS($LZ))), Lit(AtLayer((lambda $l#212#ly#0: LayerType :: Handle1((lambda $l#212#heap#0: Heap, $l#212#_v2#0: Box :: $Box(Lit(Seq#Empty(): Seq))), (lambda $l#212#heap#0: Heap, $l#212#_v2#0: Box :: $IsBox($l#212#_v2#0, JSON.Utils.Parsers._default.SubParserWitness$T)), (lambda $l#212#heap#0: Heap, $l#212#_v2#0: Box :: SetRef_to_SetBox((lambda $l#212#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#34: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#34))): DatatypeType } $Is(cs'#34, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#34))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mParsers.Parser__.Parser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#34))): DatatypeType)): DatatypeType, cs'#34, JSON_mUtils_mParsers.Parser__.spec(this)))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, this) <==> (forall cs'#34: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#34))): DatatypeType } $Is(cs'#34, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#34))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#34))): DatatypeType)): DatatypeType, cs'#34, JSON_mUtils_mParsers.Parser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.Parser_$T: Ty, JSON.Utils.Parsers.Parser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.Parser__.Valid_q#canCall(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.Parser__(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R), $Heap)) ==> (forall cs'#35: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#35))): DatatypeType } $Is(cs'#35, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType) ==> JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mParsers.Parser__.Parser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType)): DatatypeType, cs'#35, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))) && (JSON_mUtils_mParsers.Parser__.Valid_q(JSON.Utils.Parsers.Parser_$T, JSON.Utils.Parsers.Parser_$R, Lit(this)) <==> (forall cs'#35: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, JSON_mUtils_mParsers.Parser__.fn(this), $Box(cs'#35))): DatatypeType } $Is(cs'#35, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.Parser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.Parser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.Parser_$R)), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(this))), $Box(cs'#35))): DatatypeType)): DatatypeType, cs'#35, Lit(JSON_mUtils_mParsers.Parser__.spec(Lit(this)))))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#102: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#102)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#102))): bool } $Is(cs'#102, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#102))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#102)))) && ((forall cs'#102: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#102)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#102))): bool } $Is(cs'#102, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#102))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#102))) ==> (forall cs'#103: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#103))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#103, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this))) && ((forall cs'#103: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#103))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#103, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#103))): bool) ==> (forall cs'#104: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#104))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#104))): bool } $Is(cs'#104, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#104))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#104))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mParsers.SubParser__.SubParser_q(this) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#104))): DatatypeType)): DatatypeType, cs'#104, JSON_mUtils_mParsers.SubParser__.spec(this))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, this) <==> (forall cs'#102: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#102)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#102))): bool } $Is(cs'#102, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#102))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#102))) && (forall cs'#103: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#103))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#103, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#103, JSON_mUtils_mParsers.SubParser__.cs(this)) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#103))): bool) && (forall cs'#104: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#104))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#104))): bool } $Is(cs'#104, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#104))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#104))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#104))): DatatypeType)): DatatypeType, cs'#104, JSON_mUtils_mParsers.SubParser__.spec(this)))));

axiom (forall JSON.Utils.Parsers.SubParser_$T: Ty, JSON.Utils.Parsers.SubParser_$R: Ty, $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)), $IsGoodHeap($Heap) } JSON_mUtils_mParsers.SubParser__.Valid_q#canCall(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R)) && $IsAlloc(this, Tclass.JSON_mUtils_mParsers.SubParser__(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R), $Heap)) ==> (forall cs'#105: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#105)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#105))): bool } $Is(cs'#105, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#105))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && Requires1#canCall(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#105)))) && ((forall cs'#105: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#105)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#105))): bool } $Is(cs'#105, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#105))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#105))) ==> (forall cs'#106: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#106))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#106, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#106, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q#canCall(cs'#106, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) && (JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#106, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)))) && ((forall cs'#106: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#106))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#106, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#106, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#106, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#106))): bool) ==> (forall cs'#107: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#107))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#107))): bool } $Is(cs'#107, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && ($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#107))): bool ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && (Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#107))): DatatypeType) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(this)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q#canCall(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#107))): DatatypeType)): DatatypeType, cs'#107, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this))))))))) && (JSON_mUtils_mParsers.SubParser__.Valid_q(JSON.Utils.Parsers.SubParser_$T, JSON.Utils.Parsers.SubParser_$R, Lit(this)) <==> (forall cs'#105: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#105)) } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#105))): bool } $Is(cs'#105, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#105))): bool ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#105))) && (forall cs'#106: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#106))): bool } { JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#106, JSON_mUtils_mParsers.SubParser__.cs(this)) } $Is(cs'#106, Tclass.JSON_mUtils_mCursors.FreshCursor()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs'#106, Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(this)))) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#106))): bool) && (forall cs'#107: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, JSON_mUtils_mParsers.SubParser__.fn(this), $Box(cs'#107))): DatatypeType } { $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, JSON_mUtils_mParsers.SubParser__.pre(this), $Box(cs'#107))): bool } $Is(cs'#107, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, Lit(JSON_mUtils_mParsers.SubParser__.pre(Lit(this))), $Box(cs'#107))): bool ==> Wrappers.Result.Success_q($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#107))): DatatypeType) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(JSON.Utils.Parsers.SubParser_$T, $Unbox(Wrappers.Result.value($Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.Utils.Parsers.SubParser_$T), Tclass.JSON_mUtils_mCursors.CursorError(JSON.Utils.Parsers.SubParser_$R)), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(this))), $Box(cs'#107))): DatatypeType)): DatatypeType, cs'#107, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(this)))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#24: int :: { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#24)) } Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), $Box(d#24)) ==> LitInt(0) <= d#24 && d#24 < base#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#66 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#67 := Seq#Append(digits'#66, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#67))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#67 := JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#68 := Seq#Append(digits'#67, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#68))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#68 := Lit(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#69 := Seq#Append(digits'#68, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#69))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#24: Box :: { Seq#Contains(chars#0, c#24) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#24) } $IsBox(c#24, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), c#24) ==> Seq#Contains(chars#0, c#24)) && Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#49: int :: { Seq#Contains(digits#0, $Box(d#49)) } Seq#Contains(digits#0, $Box(d#49)) ==> LitInt(0) <= d#49 && d#49 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#49: int :: { Seq#Contains(digits#0, $Box(d#49)) } Seq#Contains(digits#0, $Box(d#49)) ==> LitInt(0) <= d#49 && d#49 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && (forall d#50: int :: { Seq#Contains(digits#0, $Box(d#50)) } Seq#Contains(digits#0, $Box(d#50)) ==> LitInt(0) <= d#50 && d#50 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#24: Box :: { Seq#Contains(chars#0, c#24) } { Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#24) } $IsBox(c#24, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), c#24) ==> Seq#Contains(chars#0, c#24)) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(chars#0) > 1) ==> (var base#44 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(n#0, base#44) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#44), chars#0)) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(n#0, chars#0) == (var base#44 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), n#0, base#44), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#45 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mParametricConversion.__default.Digits#canCall(LitInt(n#0), base#45) && JSON_mUtils_mStr_mParametricConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#45), Lit(chars#0))) && JSON_mUtils_mStr_mParametricConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#45 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mParametricConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mParametricConversion.__default.Digits($LS($LZ), LitInt(n#0), base#45), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(str#0, LitInt(0)))): bool) && (forall c#68: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#68)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#68) } $IsBox(c#68, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), c#68) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#68)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == minus#0 || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#69: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#69)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#69) } $IsBox(c#69, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#69) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#69)): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: Box, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mParametricConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool))) ==> (JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(minus#0) || $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), Seq#Index(Lit(str#0), LitInt(0)))): bool) && (forall c#70: Box :: { $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, is_digit#0, c#70)): bool } { Seq#Contains(Seq#Drop(str#0, 1), c#70) } $IsBox(c#70, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), c#70) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), TBool, $Heap, Lit(is_digit#0), c#70)): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: Box :: { JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(Seq#Contains(chars#0, $l#28#c#0))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mParametricConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#47: Box :: { Map#Domain(digits#0)[c#47] } { Seq#Contains(str#0, c#47) } $IsBox(c#47, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#47) ==> Map#Domain(digits#0)[c#47])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && (forall c#47: Box :: { Map#Domain(digits#0)[c#47] } { Seq#Contains(str#0, c#47) } $IsBox(c#47, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#47) ==> Map#Domain(digits#0)[c#47])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#48: Box :: { Map#Domain(digits#0)[c#48] } { Seq#Contains(str#0, c#48) } $IsBox(c#48, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && Seq#Contains(str#0, c#48) ==> Map#Domain(digits#0)[c#48])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) ==> (JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $Box(Map#Domain(digits#0)[$l#93#c#0])), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $IsBox($l#93#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $Box(Map#Domain(digits#0)[$l#93#c#0])), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $IsBox($l#93#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, minus#0)) && JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $Box(Map#Domain(digits#0)[$l#94#c#0])), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $IsBox($l#94#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0)) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, minus#0), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, minus#0))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: Box, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricConversion.Char())) && $IsBox(minus#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char()) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.JSON_mUtils_mStr_mParametricConversion.Char(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) && Lit(JSON_mUtils_mStr_mParametricConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#95#ly#0: LayerType :: Handle1((lambda $l#95#heap#0: Heap, $l#95#c#0: Box :: $Box(Map#Domain(digits#0)[$l#95#c#0])), (lambda $l#95#heap#0: Heap, $l#95#c#0: Box :: $IsBox($l#95#c#0, Tclass.JSON_mUtils_mStr_mParametricConversion.Char())), (lambda $l#95#heap#0: Heap, $l#95#c#0: Box :: SetRef_to_SetBox((lambda $l#95#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))))) ==> JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mParametricConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, Lit(minus#0)))) then 0 - JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mParametricConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(str#0, LitInt(0)) == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#66 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#66) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#66) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#66)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#66) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#66)))) && (Seq#Index(str#0, LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#66 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#66) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#66) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#66)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#66) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#66))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if Seq#Index(str#0, LitInt(0)) == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#66 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#66) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#66) else (var tl#132 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#66)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#132)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#66 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#66) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#66) else (var tl#133 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#66)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#133)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#67 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#67) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#67) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#67)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#67) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#67)))) && (Seq#Index(Lit(str#0), LitInt(0)) != escape#0 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#67 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#67) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#67) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#67)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#67) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#67))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#67 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#67) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#67) else (var tl#134 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#67)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#134)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#67 := JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#67) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#67) else (var tl#135 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#67)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#135)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: Box :: {:weight 3} { JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) && $IsBox(escape#0, Tclass.JSON_mUtils_mStr_mParametricEscaping.Char())) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> (Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#68 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#68) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#68) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#68)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#68) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#68)))) && (Seq#Index(Lit(str#0), LitInt(0)) != Lit(escape#0) ==> JSON_mUtils_mStr_mParametricEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#68 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#68) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#68) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#68)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#68) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#68))))) && JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if Seq#Index(Lit(str#0), LitInt(0)) == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#68 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#68) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError0#68) else (var tl#136 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError0#68)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#136)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.ParametricEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#68 := Lit(JSON_mUtils_mStr_mParametricEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#68) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), valueOrError1#68) else (var tl#137 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mUtils_mStr_mParametricEscaping.Char()), Tclass.JSON_mUtils_mStr_mParametricEscaping.UnescapeError(), valueOrError1#68)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#137)))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#24: int :: { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#24)) } Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#24)) ==> LitInt(0) <= d#24 && d#24 < base#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#66 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#67 := Seq#Append(digits'#66, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#67))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#67 := JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#68 := Seq#Append(digits'#67, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#68))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#68 := Lit(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#69 := Seq#Append(digits'#68, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#69))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#24: char :: { Seq#Contains(chars#0, $Box(c#24)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#24)) ==> Seq#Contains(chars#0, $Box(c#24))) && Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(TChar)));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#49: int :: { Seq#Contains(digits#0, $Box(d#49)) } Seq#Contains(digits#0, $Box(d#49)) ==> LitInt(0) <= d#49 && d#49 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#49: int :: { Seq#Contains(digits#0, $Box(d#49)) } Seq#Contains(digits#0, $Box(d#49)) ==> LitInt(0) <= d#49 && d#49 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(TChar)) && (forall d#50: int :: { Seq#Contains(digits#0, $Box(d#50)) } Seq#Contains(digits#0, $Box(d#50)) ==> LitInt(0) <= d#50 && d#50 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#24: char :: { Seq#Contains(chars#0, $Box(c#24)) } { Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#24)) } $Is(c#24, TChar) && Seq#Contains(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#24)) ==> Seq#Contains(chars#0, $Box(c#24))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(TChar)));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(chars#0) > 1) ==> (var base#44 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(n#0, base#44) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#44), chars#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#44 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), n#0, base#44), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(TChar)) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#45 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mUtils_mStr_mCharStrConversion.__default.Digits#canCall(LitInt(n#0), base#45) && JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits#canCall(JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#45), Lit(chars#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#45 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mUtils_mStr_mCharStrConversion.__default.OfDigits($LS($LZ), JSON_mUtils_mStr_mCharStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#45), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): char))): bool) && (forall c#68: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#68))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#68)) } $Is(c#68, TChar) && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#68)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#68))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == minus#0 || $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#69: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#69))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#69)) } $Is(c#69, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#69)) ==> $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#69))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: char, is_digit#0: HandleType :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr#canCall(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && $Is(is_digit#0, Tclass._System.___hTotalFunc1(TChar, TBool))) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(minus#0) || $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char))): bool) && (forall c#70: char :: { $Unbox(Apply1(TChar, TBool, $Heap, is_digit#0, $Box(c#70))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#70)) } $Is(c#70, TChar) && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#70)) ==> $Unbox(Apply1(TChar, TBool, $Heap, Lit(is_digit#0), $Box(c#70))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: char :: { JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(TChar)) && $Is(minus#0, TChar) && Seq#Length(chars#0) > 1) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(Seq#Contains(chars#0, $l#28#c#0))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, TChar)), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr_mCharStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(TChar)));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#47: char :: { Map#Domain(digits#0)[$Box(c#47)] } { Seq#Contains(str#0, $Box(c#47)) } $Is(c#47, TChar) && Seq#Contains(str#0, $Box(c#47)) ==> Map#Domain(digits#0)[$Box(c#47)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && (forall c#47: char :: { Map#Domain(digits#0)[$Box(c#47)] } { Seq#Contains(str#0, $Box(c#47)) } $Is(c#47, TChar) && Seq#Contains(str#0, $Box(c#47)) ==> Map#Domain(digits#0)[$Box(c#47)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#48: char :: { Map#Domain(digits#0)[$Box(c#48)] } { Seq#Contains(str#0, $Box(c#48)) } $Is(c#48, TChar) && Seq#Contains(str#0, $Box(c#48)) ==> Map#Domain(digits#0)[$Box(c#48)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) ==> (JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $Box(Map#Domain(digits#0)[$l#93#c#0])), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $IsBox($l#93#c#0, TChar)), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#93#ly#0: LayerType :: Handle1((lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $Box(Map#Domain(digits#0)[$l#93#c#0])), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: $IsBox($l#93#c#0, TChar)), (lambda $l#93#heap#0: Heap, $l#93#c#0: Box :: SetRef_to_SetBox((lambda $l#93#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#94#ly#0: LayerType :: Handle1((lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $Box(Map#Domain(digits#0)[$l#94#c#0])), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: $IsBox($l#94#c#0, TChar)), (lambda $l#94#heap#0: Heap, $l#94#c#0: Box :: SetRef_to_SetBox((lambda $l#94#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: char, base#0: int, digits#0: Map :: {:weight 3} { JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(TChar)) && $Is(minus#0, TChar) && LitInt(0) <= base#0 && $Is(digits#0, TMap(TChar, Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(minus#0), Lit(AtLayer((lambda $l#95#ly#0: LayerType :: Handle1((lambda $l#95#heap#0: Heap, $l#95#c#0: Box :: $Box(Map#Domain(digits#0)[$l#95#c#0])), (lambda $l#95#heap#0: Heap, $l#95#c#0: Box :: $IsBox($l#95#c#0, TChar)), (lambda $l#95#heap#0: Heap, $l#95#c#0: Box :: SetRef_to_SetBox((lambda $l#95#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(Lit(minus#0))))) then 0 - JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(str#0, escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 ==> Seq#Length(str#0) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(2)), escape#0) && (var valueOrError0#66 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#66) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#66) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#66)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#66) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#66)))) && ($Unbox(Seq#Index(str#0, LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Seq#Drop(str#0, LitInt(1)), escape#0) && (var valueOrError1#66 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#66) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#66) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#66)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#66) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#66))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), str#0, escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(str#0)) else (if $Unbox(Seq#Index(str#0, LitInt(0))): char == escape#0 then (if Seq#Length(str#0) > 1 then (var valueOrError0#66 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(2)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#66) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#66) else (var tl#132 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#66)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(1))), tl#132)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#66 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($ly, Seq#Drop(str#0, LitInt(1)), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#66) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#66) else (var tl#133 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#66)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, LitInt(0))), tl#133)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), escape#0) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0) && (var valueOrError0#67 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#67) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#67) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#67)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#67) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#67)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != escape#0 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0) && (var valueOrError1#67 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#67) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#67) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#67)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#67) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#67))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), escape#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == escape#0 then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#67 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#67) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#67) else (var tl#134 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#67)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#134)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#67 := JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), escape#0); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#67) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#67) else (var tl#135 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#67)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#135)))))))));

axiom (forall $ly: LayerType, str#0: Seq, escape#0: char :: {:weight 3} { JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) } JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(str#0), Lit(escape#0)) || ($Is(str#0, TSeq(TChar)) && $Is(escape#0, TChar)) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) ==> Seq#Length(Lit(str#0)) > 1 ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0)) && (var valueOrError0#68 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#68) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#68) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#68)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#68) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#68)))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): char != Lit(escape#0) ==> JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0)) && (var valueOrError1#68 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#68) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#68) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#68)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#68) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#68))))) && JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(str#0), Lit(escape#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then #Wrappers.Result.Success($Box(Lit(str#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(0))): char == Lit(escape#0) then (if Seq#Length(Lit(str#0)) > 1 then (var valueOrError0#68 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(2))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#68) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError0#68) else (var tl#136 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError0#68)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(1))), tl#136)))))) else #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Str.CharStrEscaping.UnescapeError.EscapeAtEOS())))) else (var valueOrError1#68 := Lit(JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape($LS($ly), Lit(Seq#Drop(Lit(str#0), LitInt(1))), Lit(escape#0))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#68) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), TSeq(TChar), valueOrError1#68) else (var tl#137 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mUtils_mStr_mCharStrEscaping.UnescapeError(), valueOrError1#68)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(0))), tl#137)))))))));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfNat(n#0, base#0) } JSON_mUtils_mStr.__default.OfNat#canCall(n#0, base#0) || (LitInt(0) <= n#0 && LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> Seq#Length(JSON_mUtils_mStr.__default.OfNat(n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1 && (forall c#23: char :: { Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#23)) } { Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#23)) } $Is(c#23, TChar) && Seq#Contains(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), $Box(c#23)) ==> Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $Box(c#23))) && $Is(JSON_mUtils_mStr.__default.OfNat(n#0, base#0), TSeq(TChar)));

axiom (forall n#0: int, base#0: int :: { JSON_mUtils_mStr.__default.OfInt(n#0, base#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, base#0) || (LitInt(2) <= base#0 && base#0 <= LitInt(16)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(Seq#Contains(Seq#Take(JSON_mUtils_mStr.__default.HEX__DIGITS(), base#0), $l#26#c#0))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, TChar)), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mUtils_mStr.__default.OfInt(n#0, base#0), TSeq(TChar)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToNat#requires(str#0, base#0) <==> LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#45: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)] } { Seq#Contains(str#0, $Box(c#45)) } $Is(c#45, TChar) && Seq#Contains(str#0, $Box(c#45)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)]): int < base#0)));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToNat(str#0, base#0) } JSON_mUtils_mStr.__default.ToNat#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && (forall c#45: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)] } { Seq#Contains(str#0, $Box(c#45)) } $Is(c#45, TChar) && Seq#Contains(str#0, $Box(c#45)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#45)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToNat#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && (forall c#46: char :: { $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#46)]): int } { Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#46)] } { Seq#Contains(str#0, $Box(c#46)) } $Is(c#46, TChar) && Seq#Contains(str#0, $Box(c#46)) ==> Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#46)] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$Box(c#46)]): int < base#0)) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToNat(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) } $Is(str#0, TSeq(TChar)) ==> (JSON_mUtils_mStr.__default.ToInt#requires(str#0, base#0) <==> !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#71#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#71#c#0]): int < base#0)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, TChar)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, base#0: int :: { JSON_mUtils_mStr.__default.ToInt(str#0, base#0) } JSON_mUtils_mStr.__default.ToInt#canCall(str#0, base#0) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= base#0 && base#0 <= LitInt(16) && JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(str#0, Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#71#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#71#c#0]): int < base#0)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, TChar)), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(str#0, base#0) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(str#0, Lit(char#FromInt(45)), base#0, JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall str#0: Seq, base#0: int :: {:weight 3} { JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) } JSON_mUtils_mStr.__default.ToInt#canCall(Lit(str#0), LitInt(base#0)) || ($Is(str#0, TSeq(TChar)) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(45)))) && LitInt(2) <= LitInt(base#0) && LitInt(base#0) <= LitInt(16) && Lit(JSON_mUtils_mStr_mCharStrConversion.__default.NumberStr(Lit(str#0), Lit(char#FromInt(45)), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box(Map#Domain(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#72#c#0] && $Unbox(Map#Elements(JSON_mUtils_mStr.__default.HEX__TABLE())[$l#72#c#0]): int < base#0)), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, TChar)), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any#canCall(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()) && JSON_mUtils_mStr.__default.ToInt(Lit(str#0), LitInt(base#0)) == JSON_mUtils_mStr_mCharStrConversion.__default.ToInt__any(Lit(str#0), Lit(char#FromInt(45)), LitInt(base#0), JSON_mUtils_mStr.__default.HEX__TABLE()));

axiom (forall $Heap: Heap, this: DatatypeType :: { JSON_mErrors.DeserializationError.ToString(this), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(this) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(this) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(this) then (var str#80 := JSON_mErrors.DeserializationError.str(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#80)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(this) then (var b#160 := JSON_mErrors.DeserializationError.b(this); (var b0#80 := JSON_mErrors.DeserializationError.expected(this); (var c#160 := (if b#160 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#160)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#80)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#160)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(this) then (var b#161 := JSON_mErrors.DeserializationError.b(this); (var bs0#80 := JSON_mErrors.DeserializationError.expected__sq(this); (var c#161 := (if b#161 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#161)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#80 := Seq#Create(TChar, $Heap, Seq#Length(bs0#80), Lit(AtLayer((lambda $l#124#ly#0: LayerType :: Handle1((lambda $l#124#heap#0: Heap, $l#124#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#80, $Unbox($l#124#idx#0): int)): int))), (lambda $l#124#heap#0: Heap, $l#124#idx#0: Box :: $IsBox($l#124#idx#0, TInt) && LitInt(0) <= $Unbox($l#124#idx#0): int && $Unbox($l#124#idx#0): int < Seq#Length(bs0#80)), (lambda $l#124#heap#0: Heap, $l#124#idx#0: Box :: SetRef_to_SetBox((lambda $l#124#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#80), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#161))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall $Heap: Heap, this: DatatypeType :: {:weight 3} { JSON_mErrors.DeserializationError.ToString(Lit(this)), $IsGoodHeap($Heap) } JSON_mErrors.DeserializationError.ToString#canCall(Lit(this)) || ($IsGoodHeap($Heap) && $Is(this, Tclass.JSON_mErrors.DeserializationError()) && $IsAlloc(this, Tclass.JSON_mErrors.DeserializationError(), $Heap)) ==> JSON_mErrors.DeserializationError.ToString(Lit(this)) == (if JSON_mErrors.DeserializationError.UnterminatedSequence_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(109))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))) else (if JSON_mErrors.DeserializationError.UnsupportedEscape_q(Lit(this)) then (var str#82 := Lit(JSON_mErrors.DeserializationError.str(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(115))), $Box(char#FromInt(117))), $Box(char#FromInt(112))), $Box(char#FromInt(112))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), str#82)) else (if JSON_mErrors.DeserializationError.EscapeAtEOS_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(115))), $Box(char#FromInt(99))), $Box(char#FromInt(97))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))) else (if JSON_mErrors.DeserializationError.EmptyNumber_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(78))), $Box(char#FromInt(117))), $Box(char#FromInt(109))), $Box(char#FromInt(98))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(117))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(97))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(115))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(105))), $Box(char#FromInt(103))), $Box(char#FromInt(105))), $Box(char#FromInt(116))) else (if JSON_mErrors.DeserializationError.ExpectingEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.IntOverflow_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(112))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(116))), $Box(char#FromInt(104))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(111))), $Box(char#FromInt(101))), $Box(char#FromInt(115))), $Box(char#FromInt(32))), $Box(char#FromInt(110))), $Box(char#FromInt(111))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(102))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(32))), $Box(char#FromInt(97))), $Box(char#FromInt(32))), $Box(char#FromInt(51))), $Box(char#FromInt(50))), $Box(char#FromInt(45))), $Box(char#FromInt(98))), $Box(char#FromInt(105))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(114))) else (if JSON_mErrors.DeserializationError.ReachedEOF_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(82))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(99))), $Box(char#FromInt(104))), $Box(char#FromInt(101))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70))) else (if JSON_mErrors.DeserializationError.ExpectingByte_q(Lit(this)) then (var b#164 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var b0#82 := LitInt(JSON_mErrors.DeserializationError.expected(Lit(this))); (var c#164 := (if b#164 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#164)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b0#82)))), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#164)))) else (if JSON_mErrors.DeserializationError.ExpectingAnyByte_q(Lit(this)) then (var b#165 := LitInt(JSON_mErrors.DeserializationError.b(Lit(this))); (var bs0#82 := Lit(JSON_mErrors.DeserializationError.expected__sq(Lit(this))); (var c#165 := (if b#165 > 0 then Seq#Append(Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(b#165)))), Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39)))) else Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(79))), $Box(char#FromInt(70)))); (var c0s#82 := Seq#Create(TChar, $Heap, Seq#Length(bs0#82), Lit(AtLayer((lambda $l#127#ly#0: LayerType :: Handle1((lambda $l#127#heap#0: Heap, $l#127#idx#0: Box :: $Box(char#FromInt($Unbox(Seq#Index(bs0#82, $Unbox($l#127#idx#0): int)): int))), (lambda $l#127#heap#0: Heap, $l#127#idx#0: Box :: $IsBox($l#127#idx#0, TInt) && LitInt(0) <= $Unbox($l#127#idx#0): int && $Unbox($l#127#idx#0): int < Seq#Length(bs0#82)), (lambda $l#127#heap#0: Heap, $l#127#idx#0: Box :: SetRef_to_SetBox((lambda $l#127#o#0: ref :: false))))), $LS($LZ)))); Seq#Append(Seq#Append(Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(69))), $Box(char#FromInt(120))), $Box(char#FromInt(112))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(116))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(39))), c0s#82), Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(39))), $Box(char#FromInt(44))), $Box(char#FromInt(32))), $Box(char#FromInt(114))), $Box(char#FromInt(101))), $Box(char#FromInt(97))), $Box(char#FromInt(100))), $Box(char#FromInt(32)))), c#165))))) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))))))))));

axiom (forall this: DatatypeType :: { JSON_mErrors.SerializationError.ToString(this) } JSON_mErrors.SerializationError.ToString#canCall(this) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!JSON_mErrors.SerializationError.OutOfMemory_q(this) ==> JSON_mErrors.SerializationError.IntTooLarge_q(this) ==> (var i#81 := JSON_mErrors.SerializationError.i(this); JSON_mUtils_mStr.__default.OfInt#canCall(i#81, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(this) == (if JSON_mErrors.SerializationError.OutOfMemory_q(this) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(this) then (var i#80 := JSON_mErrors.SerializationError.i(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#80, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(this) then (var s#80 := JSON_mErrors.SerializationError.s(this); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#80)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall this: DatatypeType :: {:weight 3} { JSON_mErrors.SerializationError.ToString(Lit(this)) } JSON_mErrors.SerializationError.ToString#canCall(Lit(this)) || $Is(this, Tclass.JSON_mErrors.SerializationError()) ==> (!Lit(JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this))) ==> Lit(JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this))) ==> (var i#83 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); JSON_mUtils_mStr.__default.OfInt#canCall(i#83, LitInt(10)))) && JSON_mErrors.SerializationError.ToString(Lit(this)) == (if JSON_mErrors.SerializationError.OutOfMemory_q(Lit(this)) then Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(79))), $Box(char#FromInt(117))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(111))), $Box(char#FromInt(102))), $Box(char#FromInt(32))), $Box(char#FromInt(109))), $Box(char#FromInt(101))), $Box(char#FromInt(109))), $Box(char#FromInt(111))), $Box(char#FromInt(114))), $Box(char#FromInt(121))) else (if JSON_mErrors.SerializationError.IntTooLarge_q(Lit(this)) then (var i#82 := LitInt(JSON_mErrors.SerializationError.i(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(116))), $Box(char#FromInt(101))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(114))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(97))), $Box(char#FromInt(114))), $Box(char#FromInt(103))), $Box(char#FromInt(101))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), JSON_mUtils_mStr.__default.OfInt(i#82, LitInt(10)))) else (if JSON_mErrors.SerializationError.StringTooLong_q(Lit(this)) then (var s#82 := Lit(JSON_mErrors.SerializationError.s(Lit(this))); Seq#Append(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(83))), $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(105))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(32))), $Box(char#FromInt(116))), $Box(char#FromInt(111))), $Box(char#FromInt(111))), $Box(char#FromInt(32))), $Box(char#FromInt(108))), $Box(char#FromInt(111))), $Box(char#FromInt(110))), $Box(char#FromInt(103))), $Box(char#FromInt(58))), $Box(char#FromInt(32))), s#82)) else Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(73))), $Box(char#FromInt(110))), $Box(char#FromInt(118))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(105))), $Box(char#FromInt(100))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(110))), $Box(char#FromInt(105))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(115))), $Box(char#FromInt(101))), $Box(char#FromInt(113))), $Box(char#FromInt(117))), $Box(char#FromInt(101))), $Box(char#FromInt(110))), $Box(char#FromInt(99))), $Box(char#FromInt(101)))))));

axiom (forall $Heap: Heap, c#0: int :: { JSON_mSpec.__default.EscapeUnicode(c#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(c#0) || ($IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(c#0, LitInt(16)) && (var sStr#6 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#6)) && JSON_mSpec.__default.EscapeUnicode(c#0) == (var sStr#6 := JSON_mUtils_mStr.__default.OfNat(c#0, LitInt(16)); (var s#6 := UnicodeStrings.__default.ASCIIToUTF16(sStr#6); Seq#Append(s#6, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#6), Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#18#heap#0: Heap, $l#18#_v0#0: Box :: $IsBox($l#18#_v0#0, TInt)), (lambda $l#18#heap#0: Heap, $l#18#_v0#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $Heap: Heap, c#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.EscapeUnicode#canCall(LitInt(c#0)) || ($IsGoodHeap($Heap) && LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16()) ==> JSON_mUtils_mStr.__default.OfNat#canCall(LitInt(c#0), LitInt(16)) && (var sStr#7 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); UnicodeStrings.__default.ASCIIToUTF16#canCall(sStr#7)) && JSON_mSpec.__default.EscapeUnicode(LitInt(c#0)) == (var sStr#7 := Lit(JSON_mUtils_mStr.__default.OfNat(LitInt(c#0), LitInt(16))); (var s#7 := Lit(UnicodeStrings.__default.ASCIIToUTF16(sStr#7)); Seq#Append(s#7, Seq#Create(Tclass.BoundedInts.uint16(), $Heap, 4 - Seq#Length(s#7), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: $Box(char#ToInt(Lit(char#FromInt(32))))), (lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: $IsBox($l#20#_v0#0, TInt)), (lambda $l#20#heap#0: Heap, $l#20#_v0#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: { JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) } JSON_mSpec.__default.Escape#canCall(str#0, start#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(str#0) > start#0 ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(34) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(92) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(8) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(12) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(10) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(13) ==> ($Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(str#0, start#0)): int != LitInt(9) ==> (var c#7 := $Unbox(Seq#Index(str#0, start#0)): int; c#7 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#7))))))))) && JSON_mSpec.__default.Escape#canCall(str#0, start#0 + 1)) && JSON_mSpec.__default.Escape($LS($ly), str#0, start#0) == (if start#0 >= Seq#Length(str#0) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(str#0, start#0)): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#7 := $Unbox(Seq#Index(str#0, start#0)): int; (if c#7 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#7)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0))))))))))), JSON_mSpec.__default.Escape($ly, str#0, start#0 + 1))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(34) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(92) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(8) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(12) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(10) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(13) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116)))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != LitInt(9) ==> (var c#8 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; c#8 < 31 ==> UnicodeStrings.__default.ASCIIToUTF16#canCall(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))) && JSON_mSpec.__default.EscapeUnicode#canCall(c#8))))))))) && JSON_mSpec.__default.Escape#canCall(Lit(str#0), LitInt(start#0 + 1))) && JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then Seq#Empty(): Seq else Seq#Append((if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(34) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(34))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(92) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(92))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(8) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(98))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(12) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(102))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(10) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(110))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(13) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(114))))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == LitInt(9) then UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(116))))) else (var c#8 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int; (if c#8 < 31 then Seq#Append(UnicodeStrings.__default.ASCIIToUTF16(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(92))), $Box(char#FromInt(117))))), JSON_mSpec.__default.EscapeUnicode(c#8)) else Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0)))))))))))), JSON_mSpec.__default.Escape($LS($ly), Lit(str#0), LitInt(start#0 + 1)))));

axiom (forall str#0: Seq, start#0: int :: { JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) } JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, start#0) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(str#0) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#6 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (var utf16#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#6, LitInt(0)) && (var escaped#6 := JSON_mSpec.__default.Escape($LS($LZ), utf16#6, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#6) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#6), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#6 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#6), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) && (var utf32#6 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#6) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#6), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(str#0, start#0) == (var valueOrError0#6 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF16Checked(str#0), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var utf16#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; (var escaped#6 := JSON_mSpec.__default.Escape($LS($LZ), utf16#6, LitInt(0)); (var valueOrError1#6 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#6), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#6) else (var utf32#6 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6)): Seq; Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#6), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))));

axiom (forall str#0: Seq, start#0: int :: {:weight 3} { JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) } JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(start#0)) || ($Is(str#0, TSeq(TChar)) && LitInt(0) <= start#0) ==> UnicodeStrings.__default.ToUTF16Checked#canCall(Lit(str#0)) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError0#7 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (var utf16#7 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq; JSON_mSpec.__default.Escape#canCall(utf16#7, LitInt(0)) && (var escaped#7 := JSON_mSpec.__default.Escape($LS($LZ), utf16#7, LitInt(0)); UnicodeStrings.__default.FromUTF16Checked#canCall(escaped#7) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#7), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))) && (var valueOrError1#7 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.FromUTF16Checked(escaped#7), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) && (var utf32#7 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7)): Seq; UnicodeStrings.__default.ToUTF8Checked#canCall(utf32#7) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), UnicodeStrings.__default.ToUTF8Checked(utf32#7), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))))))))) && JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(start#0)) == (var valueOrError0#7 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(Lit(str#0))), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var utf16#7 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq); (var escaped#7 := Lit(JSON_mSpec.__default.Escape($LS($LZ), utf16#7, LitInt(0))); (var valueOrError1#7 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.FromUTF16Checked(escaped#7)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#7) else (var utf32#7 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7)): Seq); Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Lit(UnicodeStrings.__default.ToUTF8Checked(utf32#7)), $Box(Lit(#JSON.Errors.SerializationError.InvalidUnicode()))))))))))));

axiom (forall str#0: Seq :: { JSON_mSpec.__default.String(str#0) } JSON_mSpec.__default.String#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0)) && (var valueOrError0#6 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(str#0) == (var valueOrError0#6 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var inBytes#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#6), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mSpec.__default.String(Lit(str#0)) } JSON_mSpec.__default.String#canCall(Lit(str#0)) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(0)) && (var valueOrError0#7 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))) && JSON_mSpec.__default.String(Lit(str#0)) == (var valueOrError0#7 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var inBytes#7 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))), inBytes#7), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(34))))))))))));

axiom (forall n#0: int :: { JSON_mSpec.__default.IntToBytes(n#0) } JSON_mUtils_mStr.__default.OfInt#canCall(n#0, LitInt(10)) && (var s#6 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#6)) && JSON_mSpec.__default.IntToBytes(n#0) == (var s#6 := JSON_mUtils_mStr.__default.OfInt(n#0, LitInt(10)); UnicodeStrings.__default.ASCIIToUTF8(s#6)));

axiom (forall n#0: int :: {:weight 3} { JSON_mSpec.__default.IntToBytes(LitInt(n#0)) } JSON_mUtils_mStr.__default.OfInt#canCall(LitInt(n#0), LitInt(10)) && (var s#7 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); UnicodeStrings.__default.ASCIIToUTF8#canCall(s#7)) && JSON_mSpec.__default.IntToBytes(LitInt(n#0)) == (var s#7 := Lit(JSON_mUtils_mStr.__default.OfInt(LitInt(n#0), LitInt(10))); Lit(UnicodeStrings.__default.ASCIIToUTF8(s#7))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSpec.__default.KeyValue($LS($ly), kv#0) } JSON_mSpec.__default.KeyValue#canCall(kv#0) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq) && (var valueOrError0#6 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && _System.Tuple2.___hMake2_q(kv#0) && JSON_mSpec.__default.JSON#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType) && (var valueOrError1#6 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), kv#0) == (var valueOrError0#6 := JSON_mSpec.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var key#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; (var valueOrError1#6 := JSON_mSpec.__default.JSON($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#6) else (var value#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#6, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#6))))))))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) } JSON_mSpec.__default.KeyValue#canCall(Lit(kv#0)) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.String#canCall(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq)) && (var valueOrError0#7 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSpec.__default.JSON#canCall(Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType)) && (var valueOrError1#7 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58))))))))) && JSON_mSpec.__default.KeyValue($LS($ly), Lit(kv#0)) == (var valueOrError0#7 := Lit(JSON_mSpec.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var key#7 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq); (var valueOrError1#7 := Lit(JSON_mSpec.__default.JSON($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#7) else (var value#7 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(key#7, UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(58)))))), value#7))))))))));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: { JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) } JSON_mSpec.__default.Join#canCall(sep#0, items#0) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(items#0) != LitInt(0) ==> (var valueOrError0#6 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Seq#Length(items#0) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(sep#0, Seq#Drop(items#0, LitInt(1))) && (var valueOrError1#6 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6))))))) && JSON_mSpec.__default.Join($LS($ly), sep#0, items#0) == (if Seq#Length(items#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#6 := $Unbox(Seq#Index(items#0, LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var first#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; (if Seq#Length(items#0) == LitInt(1) then #Wrappers.Result.Success($Box(first#6)) else (var valueOrError1#6 := JSON_mSpec.__default.Join($ly, sep#0, Seq#Drop(items#0, LitInt(1))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#6) else (var rest#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#6, sep#0), rest#6))))))))))));

axiom (forall $ly: LayerType, sep#0: Seq, items#0: Seq :: {:weight 3} { JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) } JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(items#0)) || ($Is(sep#0, TSeq(Tclass.BoundedInts.uint8())) && $Is(items#0, TSeq(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())))) ==> (Seq#Length(Lit(items#0)) != LitInt(0) ==> (var valueOrError0#7 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Seq#Length(Lit(items#0)) != LitInt(1) ==> JSON_mSpec.__default.Join#canCall(Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1)))) && (var valueOrError1#7 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7))))))) && JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(items#0)) == (if Seq#Length(Lit(items#0)) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(Seq#Empty(): Seq))) else (var valueOrError0#7 := $Unbox(Seq#Index(Lit(items#0), LitInt(0))): DatatypeType; (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var first#7 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq; (if Seq#Length(Lit(items#0)) == LitInt(1) then #Wrappers.Result.Success($Box(first#7)) else (var valueOrError1#7 := Lit(JSON_mSpec.__default.Join($LS($ly), Lit(sep#0), Lit(Seq#Drop(Lit(items#0), LitInt(1))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError1#7) else (var rest#7 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7)): Seq); #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(first#7, sep#0), rest#7))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSpec.__default.Object($LS($ly), obj#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(obj#0) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#33#i#0: int :: LitInt(0) <= $l#33#i#0 && $l#33#i#0 < Seq#Length(obj#0) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(obj#0, $l#33#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#34#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#34#i#0): int)): DatatypeType))), (lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: $IsBox($l#34#i#0, TInt) && LitInt(0) <= $Unbox($l#34#i#0): int && $Unbox($l#34#i#0): int < Seq#Length(obj#0)), (lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $ly)))) && (var valueOrError0#6 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#35#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#35#i#0): int)): DatatypeType))), (lambda $l#35#heap#0: Heap, $l#35#i#0: Box :: $IsBox($l#35#i#0, TInt) && LitInt(0) <= $Unbox($l#35#i#0): int && $Unbox($l#35#i#0): int < Seq#Length(obj#0)), (lambda $l#35#heap#0: Heap, $l#35#i#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), obj#0) == (var valueOrError0#6 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(obj#0), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#32#ly#0, $Unbox(Seq#Index(obj#0, $Unbox($l#32#i#0): int)): DatatypeType))), (lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: $IsBox($l#32#i#0, TInt) && LitInt(0) <= $Unbox($l#32#i#0): int && $Unbox($l#32#i#0): int < Seq#Length(obj#0)), (lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var middle#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#6), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: {:weight 3} { JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Object#canCall(Lit(obj#0)) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#37#i#0: int :: LitInt(0) <= $l#37#i#0 && $l#37#i#0 < Seq#Length(Lit(obj#0)) ==> JSON_mSpec.__default.KeyValue#canCall($Unbox(Seq#Index(Lit(obj#0), $l#37#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#38#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#38#i#0): int)): DatatypeType))), (lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: $IsBox($l#38#i#0, TInt) && LitInt(0) <= $Unbox($l#38#i#0): int && $Unbox($l#38#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#7 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#39#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#39#i#0): int)): DatatypeType))), (lambda $l#39#heap#0: Heap, $l#39#i#0: Box :: $IsBox($l#39#i#0, TInt) && LitInt(0) <= $Unbox($l#39#i#0): int && $Unbox($l#39#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#39#heap#0: Heap, $l#39#i#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))) && JSON_mSpec.__default.Object($LS($ly), Lit(obj#0)) == (var valueOrError0#7 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(obj#0)), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: $Box(JSON_mSpec.__default.KeyValue($l#36#ly#0, $Unbox(Seq#Index(Lit(obj#0), $Unbox($l#36#i#0): int)): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: $IsBox($l#36#i#0, TInt) && LitInt(0) <= $Unbox($l#36#i#0): int && $Unbox($l#36#i#0): int < Seq#Length(Lit(obj#0))), (lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var middle#7 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(123))))), middle#7), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(125))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSpec.__default.Array($LS($ly), arr#0), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(arr#0) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#33#i#0: int :: LitInt(0) <= $l#33#i#0 && $l#33#i#0 < Seq#Length(arr#0) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(arr#0, $l#33#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#34#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#34#i#0): int)): DatatypeType))), (lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: $IsBox($l#34#i#0, TInt) && LitInt(0) <= $Unbox($l#34#i#0): int && $Unbox($l#34#i#0): int < Seq#Length(arr#0)), (lambda $l#34#heap#0: Heap, $l#34#i#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $ly)))) && (var valueOrError0#6 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#35#ly#0: LayerType :: Handle1((lambda $l#35#heap#0: Heap, $l#35#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#35#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#35#i#0): int)): DatatypeType))), (lambda $l#35#heap#0: Heap, $l#35#i#0: Box :: $IsBox($l#35#i#0, TInt) && LitInt(0) <= $Unbox($l#35#i#0): int && $Unbox($l#35#i#0): int < Seq#Length(arr#0)), (lambda $l#35#heap#0: Heap, $l#35#i#0: Box :: SetRef_to_SetBox((lambda $l#35#o#0: ref :: false))))), $ly)))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), arr#0) == (var valueOrError0#6 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(arr#0), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#32#ly#0, $Unbox(Seq#Index(arr#0, $Unbox($l#32#i#0): int)): DatatypeType))), (lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: $IsBox($l#32#i#0, TInt) && LitInt(0) <= $Unbox($l#32#i#0): int && $Unbox($l#32#i#0): int < Seq#Length(arr#0)), (lambda $l#32#heap#0: Heap, $l#32#i#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $ly)))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#6) else (var middle#6 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#6), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: {:weight 3} { JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)), $IsGoodHeap($Heap) } JSON_mSpec.__default.Array#canCall(Lit(arr#0)) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44))))) && (forall $l#37#i#0: int :: LitInt(0) <= $l#37#i#0 && $l#37#i#0 < Seq#Length(Lit(arr#0)) ==> JSON_mSpec.__default.JSON#canCall($Unbox(Seq#Index(Lit(arr#0), $l#37#i#0)): DatatypeType)) && JSON_mSpec.__default.Join#canCall(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#38#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#38#i#0): int)): DatatypeType))), (lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: $IsBox($l#38#i#0, TInt) && LitInt(0) <= $Unbox($l#38#i#0): int && $Unbox($l#38#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#38#heap#0: Heap, $l#38#i#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($ly))))) && (var valueOrError0#7 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#39#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#39#i#0): int)): DatatypeType))), (lambda $l#39#heap#0: Heap, $l#39#i#0: Box :: $IsBox($l#39#i#0, TInt) && LitInt(0) <= $Unbox($l#39#i#0): int && $Unbox($l#39#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#39#heap#0: Heap, $l#39#i#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($ly))))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))) && UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))) && JSON_mSpec.__default.Array($LS($ly), Lit(arr#0)) == (var valueOrError0#7 := JSON_mSpec.__default.Join($LS($LZ), Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(44)))))), Seq#Create(Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError()), $Heap, Seq#Length(Lit(arr#0)), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: $Box(JSON_mSpec.__default.JSON($l#36#ly#0, $Unbox(Seq#Index(Lit(arr#0), $Unbox($l#36#i#0): int)): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: $IsBox($l#36#i#0, TInt) && LitInt(0) <= $Unbox($l#36#i#0): int && $Unbox($l#36#i#0): int < Seq#Length(Lit(arr#0))), (lambda $l#36#heap#0: Heap, $l#36#i#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($ly))))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), TSeq(Tclass.BoundedInts.uint8()), valueOrError0#7) else (var middle#7 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7)): Seq; #Wrappers.Result.Success($Box(Seq#Append(Seq#Append(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(91))))), middle#7), UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(93))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSpec.__default.JSON($LS($ly), js#0) } JSON_mSpec.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mValues.JSON.Null_q(js#0) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!JSON_mValues.JSON.Null_q(js#0) ==> (JSON_mValues.JSON.Bool_q(js#0) ==> (var b#13 := JSON_mValues.JSON.b(js#0); (b#13 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#13 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!JSON_mValues.JSON.Bool_q(js#0) ==> (JSON_mValues.JSON.String_q(js#0) ==> (var str#13 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String#canCall(str#13))) && (!JSON_mValues.JSON.String_q(js#0) ==> (JSON_mValues.JSON.Number_q(js#0) ==> (var dec#13 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number#canCall(dec#13))) && (!JSON_mValues.JSON.Number_q(js#0) ==> (JSON_mValues.JSON.Object_q(js#0) ==> (var obj#13 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object#canCall(obj#13))) && (!JSON_mValues.JSON.Object_q(js#0) ==> (var arr#13 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array#canCall(arr#13))))))) && JSON_mSpec.__default.JSON($LS($ly), js#0) == (if JSON_mValues.JSON.Null_q(js#0) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(js#0) then (var b#12 := JSON_mValues.JSON.b(js#0); #Wrappers.Result.Success($Box((if b#12 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(js#0) then (var str#12 := JSON_mValues.JSON.str(js#0); JSON_mSpec.__default.String(str#12)) else (if JSON_mValues.JSON.Number_q(js#0) then (var dec#12 := JSON_mValues.JSON.num(js#0); JSON_mSpec.__default.Number(dec#12)) else (if JSON_mValues.JSON.Object_q(js#0) then (var obj#12 := JSON_mValues.JSON.obj(js#0); JSON_mSpec.__default.Object($ly, obj#12)) else (var arr#12 := JSON_mValues.JSON.arr(js#0); JSON_mSpec.__default.Array($ly, arr#12))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) } JSON_mSpec.__default.JSON#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))) && (!Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (var b#15 := Lit(JSON_mValues.JSON.b(Lit(js#0))); (b#15 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101)))))) && (!b#15 ==> UnicodeStrings.__default.ASCIIToUTF8#canCall(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101)))))))) && (!Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (var str#15 := Lit(JSON_mValues.JSON.str(Lit(js#0))); JSON_mSpec.__default.String#canCall(str#15))) && (!Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (var dec#15 := Lit(JSON_mValues.JSON.num(Lit(js#0))); JSON_mSpec.__default.Number#canCall(dec#15))) && (!Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var obj#15 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); JSON_mSpec.__default.Object#canCall(obj#15))) && (!Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var arr#15 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); JSON_mSpec.__default.Array#canCall(arr#15))))))) && JSON_mSpec.__default.JSON($LS($ly), Lit(js#0)) == (if JSON_mValues.JSON.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(Lit(UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(110))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(108)))))))) else (if JSON_mValues.JSON.Bool_q(Lit(js#0)) then (var b#14 := Lit(JSON_mValues.JSON.b(Lit(js#0))); #Wrappers.Result.Success($Box((if b#14 then UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(116))), $Box(char#FromInt(114))), $Box(char#FromInt(117))), $Box(char#FromInt(101))))) else UnicodeStrings.__default.ASCIIToUTF8(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(102))), $Box(char#FromInt(97))), $Box(char#FromInt(108))), $Box(char#FromInt(115))), $Box(char#FromInt(101))))))))) else (if JSON_mValues.JSON.String_q(Lit(js#0)) then (var str#14 := Lit(JSON_mValues.JSON.str(Lit(js#0))); Lit(JSON_mSpec.__default.String(str#14))) else (if JSON_mValues.JSON.Number_q(Lit(js#0)) then (var dec#14 := Lit(JSON_mValues.JSON.num(Lit(js#0))); Lit(JSON_mSpec.__default.Number(dec#14))) else (if JSON_mValues.JSON.Object_q(Lit(js#0)) then (var obj#14 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); Lit(JSON_mSpec.__default.Object($LS($ly), obj#14))) else (var arr#14 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); Lit(JSON_mSpec.__default.Array($LS($ly), arr#14)))))))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Blanks_q(v#0) } JSON_mGrammar.__default.Blanks_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#44: int :: { JSON_mGrammar.__default.Blank_q(b#44) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) } LitInt(0) <= b#44 && b#44 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#44))) && (JSON_mGrammar.__default.Blanks_q(v#0) <==> (forall b#44: int :: { JSON_mGrammar.__default.Blank_q(b#44) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) } LitInt(0) <= b#44 && b#44 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) ==> JSON_mGrammar.__default.Blank_q(b#44))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Blanks_q(Lit(v#0)) } JSON_mGrammar.__default.Blanks_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#45: int :: { JSON_mGrammar.__default.Blank_q(b#45) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#45)) } LitInt(0) <= b#45 && b#45 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#45)) ==> JSON_mGrammar.__default.Blank_q#canCall(b#45))) && (JSON_mGrammar.__default.Blanks_q(Lit(v#0)) <==> (forall b#45: int :: { JSON_mGrammar.__default.Blank_q(b#45) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#45)) } LitInt(0) <= b#45 && b#45 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#45)) ==> JSON_mGrammar.__default.Blank_q(b#45))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#44: int :: { $Unbox(Seq#Index(s#0, idx#44)): DatatypeType } LitInt(0) <= idx#44 && idx#44 < Seq#Length(s#0) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(s#0, idx#44)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, s#0) <==> (forall idx#44: int :: { $Unbox(Seq#Index(s#0, idx#44)): DatatypeType } LitInt(0) <= idx#44 && idx#44 < Seq#Length(s#0) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(s#0, idx#44)): DatatypeType)) <==> idx#44 == Seq#Length(s#0) - 1))));

axiom (forall JSON.Grammar._default.NoTrailingSuffix$S: Ty, JSON.Grammar._default.NoTrailingSuffix$D: Ty, s#0: Seq :: {:weight 3} { JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) } JSON_mGrammar.__default.NoTrailingSuffix#canCall(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) || $Is(s#0, TSeq(Tclass.JSON_mGrammar.Suffixed(JSON.Grammar._default.NoTrailingSuffix$D, JSON.Grammar._default.NoTrailingSuffix$S))) ==> (forall idx#45: int :: { $Unbox(Seq#Index(s#0, idx#45)): DatatypeType } LitInt(0) <= idx#45 && idx#45 < Seq#Length(Lit(s#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($Unbox(Seq#Index(Lit(s#0), idx#45)): DatatypeType)) && (JSON_mGrammar.__default.NoTrailingSuffix(JSON.Grammar._default.NoTrailingSuffix$S, JSON.Grammar._default.NoTrailingSuffix$D, Lit(s#0)) <==> (forall idx#45: int :: { $Unbox(Seq#Index(s#0, idx#45)): DatatypeType } LitInt(0) <= idx#45 && idx#45 < Seq#Length(Lit(s#0)) ==> (JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix($Unbox(Seq#Index(Lit(s#0), idx#45)): DatatypeType)) <==> idx#45 == Seq#Length(Lit(s#0)) - 1))));

axiom (forall v#0: DatatypeType :: { JSON_mGrammar.__default.Digits_q(v#0) } JSON_mGrammar.__default.Digits_q#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#44: int :: { JSON_mGrammar.__default.Digit_q(b#44) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) } LitInt(0) <= b#44 && b#44 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(v#0) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#44))) && (JSON_mGrammar.__default.Digits_q(v#0) <==> (forall b#44: int :: { JSON_mGrammar.__default.Digit_q(b#44) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) } LitInt(0) <= b#44 && b#44 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#44)) ==> JSON_mGrammar.__default.Digit_q(b#44))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mGrammar.__default.Digits_q(Lit(v#0)) } JSON_mGrammar.__default.Digits_q#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> (forall b#45: int :: { JSON_mGrammar.__default.Digit_q(b#45) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#45)) } LitInt(0) <= b#45 && b#45 < BoundedInts.__default.TWO__TO__THE__8() ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(v#0)) && (Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#45)) ==> JSON_mGrammar.__default.Digit_q#canCall(b#45))) && (JSON_mGrammar.__default.Digits_q(Lit(v#0)) <==> (forall b#45: int :: { JSON_mGrammar.__default.Digit_q(b#45) } { Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(v#0), $Box(b#45)) } LitInt(0) <= b#45 && b#45 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(v#0)), $Box(b#45)) ==> JSON_mGrammar.__default.Digit_q(b#45))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#4: int :: { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) } Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) ==> LitInt(0) <= d#4 && d#4 < base#0) && $Is(JSON_mSerializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#6 := JSON_mSerializer_mByteStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#7 := Seq#Append(digits'#6, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#7))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#7 := JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#8 := Seq#Append(digits'#7, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#8))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#8 := Lit(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#9 := Seq#Append(digits'#8, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#9))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#4: int :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && Seq#Length(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mSerializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mSerializer_mByteStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#10: int :: { Seq#Contains(digits#0, $Box(d#10)) } Seq#Contains(digits#0, $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#4: int :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> (var base#4 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(n#0, base#4) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0)) && JSON_mSerializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#4 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mSerializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#5 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mSerializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#5) && JSON_mSerializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0))) && JSON_mSerializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#5 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mSerializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mSerializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#8: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#8))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#8)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#8))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#9: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#9))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#9)) } LitInt(0) <= c#9 && c#9 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#9)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#9))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mSerializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#10: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#10))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#10)) } LitInt(0) <= c#10 && c#10 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#10)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box(c#10))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> JSON_mSerializer_mByteStrConversion.__default.NumberStr(JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Seq#Contains(chars#0, $l#8#c#0))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint8())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mSerializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#7: int :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#7: int :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#8: int :: { Map#Domain(digits#0)[$Box(c#8)] } { Seq#Contains(str#0, $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#8)) ==> Map#Domain(digits#0)[$Box(c#8)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mSerializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(digits#0)[$l#14#c#0])), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.BoundedInts.uint8())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mSerializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mSerializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Map#Domain(digits#0)[$l#15#c#0])), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint8())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mSerializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mSerializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mSerializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall b#0: bool :: { JSON_mSerializer.__default.Bool(b#0) } $Is(JSON_mSerializer.__default.Bool(b#0), Tclass.JSON_mGrammar.jbool()));

axiom (forall b#0: bool :: { JSON_mSerializer.__default.Bool(b#0) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())) && JSON_mSerializer.__default.Bool(b#0) == JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())));

axiom (forall b#0: bool :: {:weight 3} { JSON_mSerializer.__default.Bool(Lit(b#0)) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())) && JSON_mSerializer.__default.Bool(Lit(b#0)) == JSON_mUtils_mViews_mCore.View__.OfBytes((if b#0 then JSON_mGrammar.__default.TRUE() else JSON_mGrammar.__default.FALSE())));

axiom (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: { JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0) } JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T, s#0, err#0) || ($Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError())) ==> $Is(JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0), Tclass.Wrappers.Outcome(Tclass.JSON_mErrors.SerializationError())));

axiom (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: { JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0) } JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T, s#0, err#0) || ($Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), Seq#Length(s#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(err#0)) && JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, s#0, err#0) == Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), Seq#Length(s#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(err#0)));

axiom (forall JSON.Serializer._default.CheckLength$T: Ty, s#0: Seq, err#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, Lit(s#0), Lit(err#0)) } JSON_mSerializer.__default.CheckLength#canCall(JSON.Serializer._default.CheckLength$T, Lit(s#0), Lit(err#0)) || ($Is(s#0, TSeq(JSON.Serializer._default.CheckLength$T)) && $Is(err#0, Tclass.JSON_mErrors.SerializationError())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.SerializationError(), Seq#Length(Lit(s#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(err#0))) && JSON_mSerializer.__default.CheckLength(JSON.Serializer._default.CheckLength$T, Lit(s#0), Lit(err#0)) == Wrappers.__default.Need(Tclass.JSON_mErrors.SerializationError(), Seq#Length(Lit(s#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(err#0))));

axiom (forall str#0: Seq :: { JSON_mSerializer.__default.String(str#0) } JSON_mSerializer.__default.String#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> $Is(JSON_mSerializer.__default.String(str#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError())));

axiom (forall str#0: Seq :: { JSON_mSerializer.__default.String(str#0) } JSON_mSerializer.__default.String#canCall(str#0) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(str#0, LitInt(0)) && (var valueOrError0#2 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (var bs#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#2, #JSON.Errors.SerializationError.StringTooLong(str#0)) && (var valueOrError1#2 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#2, #JSON.Errors.SerializationError.StringTooLong(str#0)); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#2)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#2)))))) && JSON_mSerializer.__default.String(str#0) == (var valueOrError0#2 := JSON_mSpec.__default.EscapeToUTF8(str#0, LitInt(0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#2) else (var bs#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; (var valueOrError1#2 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#2, #JSON.Errors.SerializationError.StringTooLong(str#0)); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#2) else #Wrappers.Result.Success($Box(#JSON.Grammar.jstring.JString(JSON_mGrammar.__default.DOUBLEQUOTE(), JSON_mUtils_mViews_mCore.View__.OfBytes(bs#2), JSON_mGrammar.__default.DOUBLEQUOTE())))))))));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mSerializer.__default.String(Lit(str#0)) } JSON_mSerializer.__default.String#canCall(Lit(str#0)) || $Is(str#0, TSeq(TChar)) ==> JSON_mSpec.__default.EscapeToUTF8#canCall(Lit(str#0), LitInt(0)) && (var valueOrError0#3 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (var bs#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#3, Lit(#JSON.Errors.SerializationError.StringTooLong(Lit(str#0)))) && (var valueOrError1#3 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#3, Lit(#JSON.Errors.SerializationError.StringTooLong(Lit(str#0)))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#3)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#3)))))) && JSON_mSerializer.__default.String(Lit(str#0)) == (var valueOrError0#3 := Lit(JSON_mSpec.__default.EscapeToUTF8(Lit(str#0), LitInt(0))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError0#3) else (var bs#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq); (var valueOrError1#3 := Lit(JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#3, Lit(#JSON.Errors.SerializationError.StringTooLong(Lit(str#0))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jstring(), valueOrError1#3) else #Wrappers.Result.Success($Box(#JSON.Grammar.jstring.JString(JSON_mGrammar.__default.DOUBLEQUOTE(), Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#3)), JSON_mGrammar.__default.DOUBLEQUOTE())))))))));

axiom (forall n#0: int :: { JSON_mSerializer.__default.Sign(n#0) } $Is(JSON_mSerializer.__default.Sign(n#0), Tclass.JSON_mGrammar.jminus()));

axiom (forall n#0: int :: { JSON_mSerializer.__default.Sign(n#0) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)) && JSON_mSerializer.__default.Sign(n#0) == JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)));

axiom (forall n#0: int :: {:weight 3} { JSON_mSerializer.__default.Sign(LitInt(n#0)) } JSON_mUtils_mViews_mCore.View__.OfBytes#canCall((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)) && JSON_mSerializer.__default.Sign(LitInt(n#0)) == JSON_mUtils_mViews_mCore.View__.OfBytes((if n#0 < 0 then Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(45))))) else Seq#Empty(): Seq)));

axiom $Is(JSON_mSerializer.__default.DIGITS(), TSeq(Tclass.BoundedInts.uint8()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.DIGITS(), TSeq(Tclass.BoundedInts.uint8()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.DIGITS(), TSeq(Tclass.BoundedInts.uint8()), $h));

axiom $Is(JSON_mSerializer.__default.MINUS(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h));

axiom (forall n#0: int :: { JSON_mSerializer.__default.Int_k(n#0) } (forall c#3: int :: { Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#3)) } { Seq#Contains(JSON_mSerializer.__default.Int_k(n#0), $Box(c#3)) } LitInt(0) <= c#3 && c#3 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mSerializer.__default.Int_k(n#0), $Box(c#3)) ==> Seq#Contains(JSON_mSerializer.__default.DIGITS(), $Box(c#3)) || c#3 == JSON_mSerializer.__default.MINUS()) && $Is(JSON_mSerializer.__default.Int_k(n#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int :: { JSON_mSerializer.__default.Int_k(n#0) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()) && JSON_mSerializer.__default.Int_k(n#0) == JSON_mSerializer_mByteStrConversion.__default.OfInt__any(n#0, JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()));

axiom (forall n#0: int :: {:weight 3} { JSON_mSerializer.__default.Int_k(LitInt(n#0)) } JSON_mSerializer_mByteStrConversion.__default.OfInt__any#canCall(LitInt(n#0), JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()) && JSON_mSerializer.__default.Int_k(LitInt(n#0)) == JSON_mSerializer_mByteStrConversion.__default.OfInt__any(LitInt(n#0), JSON_mSerializer.__default.DIGITS(), JSON_mSerializer.__default.MINUS()));

axiom (forall n#0: int :: { JSON_mSerializer.__default.Int(n#0) } $Is(JSON_mSerializer.__default.Int(n#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError())));

axiom (forall n#0: int :: { JSON_mSerializer.__default.Int(n#0) } JSON_mSerializer.__default.Int_k#canCall(n#0) && (var bs#2 := JSON_mSerializer.__default.Int_k(n#0); JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#2, #JSON.Errors.SerializationError.IntTooLarge(n#0)) && (var valueOrError0#2 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#2, #JSON.Errors.SerializationError.IntTooLarge(n#0)); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#2)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#2)))) && JSON_mSerializer.__default.Int(n#0) == (var bs#2 := JSON_mSerializer.__default.Int_k(n#0); (var valueOrError0#2 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#2, #JSON.Errors.SerializationError.IntTooLarge(n#0)); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#2) else #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#2)))))));

axiom (forall n#0: int :: {:weight 3} { JSON_mSerializer.__default.Int(LitInt(n#0)) } JSON_mSerializer.__default.Int_k#canCall(LitInt(n#0)) && (var bs#3 := Lit(JSON_mSerializer.__default.Int_k(LitInt(n#0))); JSON_mSerializer.__default.CheckLength#canCall(Tclass.BoundedInts.uint8(), bs#3, Lit(#JSON.Errors.SerializationError.IntTooLarge(LitInt(n#0)))) && (var valueOrError0#3 := JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#3, Lit(#JSON.Errors.SerializationError.IntTooLarge(LitInt(n#0)))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#3)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#3)))) && JSON_mSerializer.__default.Int(LitInt(n#0)) == (var bs#3 := Lit(JSON_mSerializer.__default.Int_k(LitInt(n#0))); (var valueOrError0#3 := Lit(JSON_mSerializer.__default.CheckLength(Tclass.BoundedInts.uint8(), bs#3, Lit(#JSON.Errors.SerializationError.IntTooLarge(LitInt(n#0))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mUtils_mViews_mCore.View(), valueOrError0#3) else #Wrappers.Result.Success($Box(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#3))))))));

axiom (forall dec#0: DatatypeType :: { JSON_mSerializer.__default.Number(dec#0) } JSON_mSerializer.__default.Number#canCall(dec#0) || $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> $Is(JSON_mSerializer.__default.Number(dec#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError())));

axiom (forall dec#0: DatatypeType :: { JSON_mSerializer.__default.Number(dec#0) } JSON_mSerializer.__default.Number#canCall(dec#0) || $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && Math.__default.Abs#canCall(JSON_mValues.Decimal.n(dec#0)) && JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0))) && (var valueOrError0#2 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && JSON_mValues.Decimal.Decimal_q(dec#0) && (JSON_mValues.Decimal.e10(dec#0) != LitInt(0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))) && JSON_mValues.Decimal.Decimal_q(dec#0) && JSON_mSerializer.__default.Sign#canCall(JSON_mValues.Decimal.e10(dec#0)) && JSON_mValues.Decimal.Decimal_q(dec#0) && Math.__default.Abs#canCall(JSON_mValues.Decimal.e10(dec#0)) && JSON_mSerializer.__default.Int#canCall(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))) && (var valueOrError2#2 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2)))) && (var valueOrError1#2 := (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#2 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#2 := JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0)); (var valueOrError2#2 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#2) else (var num#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#2, sign#2, num#5))))))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2))))) && JSON_mSerializer.__default.Number(dec#0) == (var minus#2 := JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.n(dec#0)); (var valueOrError0#2 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.n(dec#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#2) else (var num#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): DatatypeType; (var frac#2 := Lit(#JSON.Grammar.Maybe.Empty()); (var valueOrError1#2 := (if JSON_mValues.Decimal.e10(dec#0) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#2 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#2 := JSON_mSerializer.__default.Sign(JSON_mValues.Decimal.e10(dec#0)); (var valueOrError2#2 := JSON_mSerializer.__default.Int(Math.__default.Abs(JSON_mValues.Decimal.e10(dec#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#2) else (var num#5 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#2)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#2, sign#2, num#5))))))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#2) else (var exp#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.jnumber.JNumber(minus#2, num#4, Lit(#JSON.Grammar.Maybe.Empty()), exp#2))))))))))));

axiom (forall dec#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.Number(Lit(dec#0)) } JSON_mSerializer.__default.Number#canCall(Lit(dec#0)) || $Is(dec#0, Tclass.JSON_mValues.Decimal()) ==> JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSerializer.__default.Sign#canCall(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && Math.__default.Abs#canCall(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))) && JSON_mSerializer.__default.Int#canCall(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.n(Lit(dec#0)))))) && (var valueOrError0#3 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.n(Lit(dec#0))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && (LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) != LitInt(0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && JSON_mSerializer.__default.Sign#canCall(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0)))) && JSON_mValues.Decimal.Decimal_q(Lit(dec#0)) && Math.__default.Abs#canCall(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0)))) && JSON_mSerializer.__default.Int#canCall(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0)))))) && (var valueOrError2#3 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3)))) && (var valueOrError1#3 := (if LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#3 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#3 := Lit(JSON_mSerializer.__default.Sign(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))); (var valueOrError2#3 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#3) else (var num#7 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#3, sign#3, num#7))))))))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3))))) && JSON_mSerializer.__default.Number(Lit(dec#0)) == (var minus#3 := Lit(JSON_mSerializer.__default.Sign(LitInt(JSON_mValues.Decimal.n(Lit(dec#0))))); (var valueOrError0#3 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.n(Lit(dec#0))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError0#3) else (var num#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): DatatypeType); (var frac#3 := Lit(#JSON.Grammar.Maybe.Empty()); (var valueOrError1#3 := (if LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))) == LitInt(0) then #Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Maybe.Empty()))) else (var e#3 := JSON_mUtils_mViews_mCore.View__.OfBytes(Seq#Build(Seq#Empty(): Seq, $Box(char#ToInt(Lit(char#FromInt(101)))))); (var sign#3 := Lit(JSON_mSerializer.__default.Sign(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))); (var valueOrError2#3 := Lit(JSON_mSerializer.__default.Int(LitInt(Math.__default.Abs(LitInt(JSON_mValues.Decimal.e10(Lit(dec#0))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), valueOrError2#3) else (var num#7 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mErrors.SerializationError(), valueOrError2#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#3, sign#3, num#7))))))))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jnumber(), valueOrError1#3) else (var exp#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.jnumber.JNumber(minus#3, num#6, Lit(#JSON.Grammar.Maybe.Empty()), exp#3))))))))))));

axiom (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) } JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, v#0) || $IsBox(v#0, JSON.Serializer._default.MkStructural$T) ==> $Is(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T)));

axiom (forall $Heap: Heap, JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { $IsAlloc(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T), $Heap) } (JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, v#0) || ($IsBox(v#0, JSON.Serializer._default.MkStructural$T) && $IsAllocBox(v#0, JSON.Serializer._default.MkStructural$T, $Heap))) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0), Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkStructural$T), $Heap));

axiom (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: { JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) } JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, v#0) || $IsBox(v#0, JSON.Serializer._default.MkStructural$T) ==> JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, v#0) == #JSON.Grammar.Structural.Structural(JSON_mGrammar.__default.EMPTY(), v#0, JSON_mGrammar.__default.EMPTY()));

axiom (forall JSON.Serializer._default.MkStructural$T: Ty, v#0: Box :: {:weight 3} { JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, Lit(v#0)) } JSON_mSerializer.__default.MkStructural#canCall(JSON.Serializer._default.MkStructural$T, Lit(v#0)) || $IsBox(v#0, JSON.Serializer._default.MkStructural$T) ==> JSON_mSerializer.__default.MkStructural(JSON.Serializer._default.MkStructural$T, Lit(v#0)) == #JSON.Grammar.Structural.Structural(JSON_mGrammar.__default.EMPTY(), Lit(v#0), JSON_mGrammar.__default.EMPTY()));

axiom $Is(JSON_mSerializer.__default.COLON(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.COLON(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.COLON(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), $h));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue($ly, kv#0) } JSON_mSerializer.__default.KeyValue#canCall(kv#0) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSerializer.__default.KeyValue($ly, kv#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: { JSON_mSerializer.__default.KeyValue($LS($ly), kv#0) } JSON_mSerializer.__default.KeyValue#canCall(kv#0) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(kv#0) && JSON_mSerializer.__default.String#canCall($Unbox(_System.Tuple2._0(kv#0)): Seq) && (var valueOrError0#2 := JSON_mSerializer.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && _System.Tuple2.___hMake2_q(kv#0) && JSON_mSerializer.__default.Value#canCall($Unbox(_System.Tuple2._1(kv#0)): DatatypeType) && (var valueOrError1#2 := JSON_mSerializer.__default.Value($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2))))) && JSON_mSerializer.__default.KeyValue($LS($ly), kv#0) == (var valueOrError0#2 := JSON_mSerializer.__default.String($Unbox(_System.Tuple2._0(kv#0)): Seq); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#2) else (var k#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): DatatypeType; (var valueOrError1#2 := JSON_mSerializer.__default.Value($ly, $Unbox(_System.Tuple2._1(kv#0)): DatatypeType); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#2) else (var v#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#2)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.jKeyValue.KeyValue(k#2, JSON_mSerializer.__default.COLON(), v#2))))))))));

axiom (forall $ly: LayerType, kv#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.KeyValue($LS($ly), Lit(kv#0)) } JSON_mSerializer.__default.KeyValue#canCall(Lit(kv#0)) || $Is(kv#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSerializer.__default.String#canCall(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq)) && (var valueOrError0#3 := Lit(JSON_mSerializer.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && _System.Tuple2.___hMake2_q(Lit(kv#0)) && JSON_mSerializer.__default.Value#canCall(Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType)) && (var valueOrError1#3 := Lit(JSON_mSerializer.__default.Value($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3))))) && JSON_mSerializer.__default.KeyValue($LS($ly), Lit(kv#0)) == (var valueOrError0#3 := Lit(JSON_mSerializer.__default.String(Lit($Unbox(_System.Tuple2._0(Lit(kv#0))): Seq))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError0#3) else (var k#3 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): DatatypeType); (var valueOrError1#3 := Lit(JSON_mSerializer.__default.Value($LS($ly), Lit($Unbox(_System.Tuple2._1(Lit(kv#0))): DatatypeType))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.jKeyValue(), valueOrError1#3) else (var v#3 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#3)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Grammar.jKeyValue.KeyValue(k#3, JSON_mSerializer.__default.COLON(), v#3))))))))));

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0) || ($Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> $Is(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S)));

axiom (forall $Heap: Heap, JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { $IsAlloc(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S), $Heap) } (JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0) || ($Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $IsAlloc(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D), $Heap) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && $IsAlloc(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S), $Heap) && LitInt(0) <= start#0)) && $IsGoodHeap($Heap) ==> $IsAlloc(JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0), Tclass.JSON_mGrammar.SuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S), $Heap));

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), ds#0, suffix#0, start#0) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0) || ($Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> (Seq#Length(ds#0) > start#0 ==> start#0 != Seq#Length(ds#0) - 1 ==> JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, ds#0, suffix#0, start#0 + 1)) && JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), ds#0, suffix#0, start#0) == (if start#0 >= Seq#Length(ds#0) then Seq#Empty(): Seq else (if start#0 == Seq#Length(ds#0) - 1 then Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), Lit(#JSON.Grammar.Maybe.Empty())))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(ds#0, start#0), #JSON.Grammar.Maybe.NonEmpty($Box(suffix#0))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $ly, ds#0, suffix#0, start#0 + 1)))));

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: {:weight 3} { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), suffix#0, LitInt(start#0)) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), suffix#0, LitInt(start#0)) || ($Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(ds#0)) > LitInt(start#0) ==> LitInt(start#0) != Seq#Length(Lit(ds#0)) - 1 ==> JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), suffix#0, LitInt(start#0 + 1))) && JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), suffix#0, LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(ds#0)) then Seq#Empty(): Seq else (if LitInt(start#0) == Seq#Length(Lit(ds#0)) - 1 then Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), Lit(#JSON.Grammar.Maybe.Empty())))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), #JSON.Grammar.Maybe.NonEmpty($Box(suffix#0))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), suffix#0, LitInt(start#0 + 1))))));

axiom (forall JSON.Serializer._default.MkSuffixedSequence$D: Ty, JSON.Serializer._default.MkSuffixedSequence$S: Ty, $ly: LayerType, ds#0: Seq, suffix#0: DatatypeType, start#0: int :: {:weight 3} { JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), Lit(suffix#0), LitInt(start#0)) } JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), Lit(suffix#0), LitInt(start#0)) || ($Is(ds#0, TSeq(JSON.Serializer._default.MkSuffixedSequence$D)) && $Is(suffix#0, Tclass.JSON_mGrammar.Structural(JSON.Serializer._default.MkSuffixedSequence$S)) && LitInt(0) <= start#0) ==> (Seq#Length(Lit(ds#0)) > LitInt(start#0) ==> LitInt(start#0) != Seq#Length(Lit(ds#0)) - 1 ==> JSON_mSerializer.__default.MkSuffixedSequence#canCall(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, Lit(ds#0), Lit(suffix#0), LitInt(start#0 + 1))) && JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), Lit(suffix#0), LitInt(start#0)) == (if LitInt(start#0) >= Seq#Length(Lit(ds#0)) then Seq#Empty(): Seq else (if LitInt(start#0) == Seq#Length(Lit(ds#0)) - 1 then Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), Lit(#JSON.Grammar.Maybe.Empty())))) else Seq#Append(Seq#Build(Seq#Empty(): Seq, $Box(#JSON.Grammar.Suffixed.Suffixed(Seq#Index(Lit(ds#0), LitInt(start#0)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit(suffix#0))))))), JSON_mSerializer.__default.MkSuffixedSequence(JSON.Serializer._default.MkSuffixedSequence$D, JSON.Serializer._default.MkSuffixedSequence$S, $LS($ly), Lit(ds#0), Lit(suffix#0), LitInt(start#0 + 1))))));

axiom $Is(JSON_mSerializer.__default.COMMA(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mSerializer.__default.COMMA(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mSerializer.__default.COMMA(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), $h));

axiom (forall $ly: LayerType, obj#0: Seq :: { JSON_mSerializer.__default.Object($ly, obj#0) } JSON_mSerializer.__default.Object#canCall(obj#0) || $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()))) ==> $Is(JSON_mSerializer.__default.Object($ly, obj#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: { JSON_mSerializer.__default.Object($LS($ly), obj#0), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Object#canCall(obj#0) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> (forall $l#16#v#0: DatatypeType :: $Is($l#16#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> Seq#Contains(obj#0, $Box($l#16#v#0)) ==> JSON_mSerializer.__default.KeyValue#canCall($l#16#v#0)) && Seq.__default.MapWithResult#canCall(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#17#ly#0, $Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#17#v#0)), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $ly)), obj#0) && (var valueOrError0#2 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#18#ly#0, $Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#18#v#0)), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $ly)), obj#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (var items#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), items#2, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()))))) && JSON_mSerializer.__default.Object($LS($ly), obj#0) == (var valueOrError0#2 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#15#ly#0, $Unbox($l#15#v#0): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#v#0: Box :: $IsBox($l#15#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#15#v#0)), (lambda $l#15#heap#0: Heap, $l#15#v#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $ly)), obj#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var items#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#2, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE())))))))));

axiom (forall $ly: LayerType, $Heap: Heap, obj#0: Seq :: {:weight 3} { JSON_mSerializer.__default.Object($LS($ly), Lit(obj#0)), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Object#canCall(Lit(obj#0)) || ($IsGoodHeap($Heap) && $Is(obj#0, TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())))) ==> (forall $l#20#v#0: DatatypeType :: $Is($l#20#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) ==> Seq#Contains(obj#0, $Box($l#20#v#0)) ==> JSON_mSerializer.__default.KeyValue#canCall($l#20#v#0)) && Seq.__default.MapWithResult#canCall(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#21#ly#0, $Unbox($l#21#v#0): DatatypeType))), (lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: $IsBox($l#21#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#21#v#0)), (lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($ly))), Lit(obj#0)) && (var valueOrError0#3 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#22#ly#0, $Unbox($l#22#v#0): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#v#0: Box :: $IsBox($l#22#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#22#v#0)), (lambda $l#22#heap#0: Heap, $l#22#v#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($ly))), Lit(obj#0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (var items#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), items#3, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE()))))) && JSON_mSerializer.__default.Object($LS($ly), Lit(obj#0)) == (var valueOrError0#3 := Seq.__default.MapWithResult(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: $Box(JSON_mSerializer.__default.KeyValue($l#19#ly#0, $Unbox($l#19#v#0): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: $IsBox($l#19#v#0, Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())) && Seq#Contains(obj#0, $l#19#v#0)), (lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($ly))), Lit(obj#0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var items#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACE())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#3, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACE())))))))));

axiom (forall $ly: LayerType, arr#0: Seq :: { JSON_mSerializer.__default.Array($ly, arr#0) } JSON_mSerializer.__default.Array#canCall(arr#0) || $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON())) ==> $Is(JSON_mSerializer.__default.Array($ly, arr#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: { JSON_mSerializer.__default.Array($LS($ly), arr#0), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Array#canCall(arr#0) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> (forall $l#16#v#0: DatatypeType :: $Is($l#16#v#0, Tclass.JSON_mValues.JSON()) ==> Seq#Contains(arr#0, $Box($l#16#v#0)) ==> JSON_mSerializer.__default.Value#canCall($l#16#v#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#17#ly#0: LayerType :: Handle1((lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#17#ly#0, $Unbox($l#17#v#0): DatatypeType))), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: $IsBox($l#17#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#17#v#0)), (lambda $l#17#heap#0: Heap, $l#17#v#0: Box :: SetRef_to_SetBox((lambda $l#17#o#0: ref :: false))))), $ly)), arr#0) && (var valueOrError0#2 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#18#ly#0, $Unbox($l#18#v#0): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: $IsBox($l#18#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#18#v#0)), (lambda $l#18#heap#0: Heap, $l#18#v#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $ly)), arr#0); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (var items#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), items#2, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()))))) && JSON_mSerializer.__default.Array($LS($ly), arr#0) == (var valueOrError0#2 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#15#ly#0, $Unbox($l#15#v#0): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#v#0: Box :: $IsBox($l#15#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#15#v#0)), (lambda $l#15#heap#0: Heap, $l#15#v#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $ly)), arr#0); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#2) else (var items#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#2, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET())))))))));

axiom (forall $ly: LayerType, $Heap: Heap, arr#0: Seq :: {:weight 3} { JSON_mSerializer.__default.Array($LS($ly), Lit(arr#0)), $IsGoodHeap($Heap) } JSON_mSerializer.__default.Array#canCall(Lit(arr#0)) || ($IsGoodHeap($Heap) && $Is(arr#0, TSeq(Tclass.JSON_mValues.JSON()))) ==> (forall $l#20#v#0: DatatypeType :: $Is($l#20#v#0, Tclass.JSON_mValues.JSON()) ==> Seq#Contains(arr#0, $Box($l#20#v#0)) ==> JSON_mSerializer.__default.Value#canCall($l#20#v#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $Heap, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#21#ly#0, $Unbox($l#21#v#0): DatatypeType))), (lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: $IsBox($l#21#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#21#v#0)), (lambda $l#21#heap#0: Heap, $l#21#v#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($ly))), Lit(arr#0)) && (var valueOrError0#3 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#22#ly#0, $Unbox($l#22#v#0): DatatypeType))), (lambda $l#22#heap#0: Heap, $l#22#v#0: Box :: $IsBox($l#22#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#22#v#0)), (lambda $l#22#heap#0: Heap, $l#22#v#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($ly))), Lit(arr#0)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (var items#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())) && JSON_mSerializer.__default.MkSuffixedSequence#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), items#3, JSON_mSerializer.__default.COMMA(), LitInt(0)) && JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET()))))) && JSON_mSerializer.__default.Array($LS($ly), Lit(arr#0)) == (var valueOrError0#3 := Seq.__default.MapWithResult(Tclass.JSON_mValues.JSON(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: $Box(JSON_mSerializer.__default.Value($l#19#ly#0, $Unbox($l#19#v#0): DatatypeType))), (lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: $IsBox($l#19#v#0, Tclass.JSON_mValues.JSON()) && Seq#Contains(arr#0, $l#19#v#0)), (lambda $l#19#heap#0: Heap, $l#19#v#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($ly))), Lit(arr#0)); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#3) else (var items#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): Seq; #Wrappers.Result.Success($Box(#JSON.Grammar.Bracketed.Bracketed(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.LBRACKET())), JSON_mSerializer.__default.MkSuffixedSequence(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), $LS($LZ), items#3, JSON_mSerializer.__default.COMMA(), LitInt(0)), JSON_mSerializer.__default.MkStructural(Tclass.JSON_mUtils_mViews_mCore.View(), $Box(JSON_mGrammar.__default.RBRACKET())))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value($ly, js#0) } JSON_mSerializer.__default.Value#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> $Is(JSON_mSerializer.__default.Value($ly, js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError())));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mSerializer.__default.Value($LS($ly), js#0) } JSON_mSerializer.__default.Value#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (JSON_mValues.JSON.Null_q(js#0) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL())) && (!JSON_mValues.JSON.Null_q(js#0) ==> (JSON_mValues.JSON.Bool_q(js#0) ==> (var b#5 := JSON_mValues.JSON.b(js#0); JSON_mSerializer.__default.Bool#canCall(b#5))) && (!JSON_mValues.JSON.Bool_q(js#0) ==> (JSON_mValues.JSON.String_q(js#0) ==> (var str#5 := JSON_mValues.JSON.str(js#0); JSON_mSerializer.__default.String#canCall(str#5) && (var valueOrError0#5 := JSON_mSerializer.__default.String(str#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#5))))) && (!JSON_mValues.JSON.String_q(js#0) ==> (JSON_mValues.JSON.Number_q(js#0) ==> (var dec#5 := JSON_mValues.JSON.num(js#0); JSON_mSerializer.__default.Number#canCall(dec#5) && (var valueOrError1#5 := JSON_mSerializer.__default.Number(dec#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#5))))) && (!JSON_mValues.JSON.Number_q(js#0) ==> (JSON_mValues.JSON.Object_q(js#0) ==> (var obj#5 := JSON_mValues.JSON.obj(js#0); JSON_mSerializer.__default.Object#canCall(obj#5) && (var valueOrError2#5 := JSON_mSerializer.__default.Object($ly, obj#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#5))))) && (!JSON_mValues.JSON.Object_q(js#0) ==> (var arr#5 := JSON_mValues.JSON.arr(js#0); JSON_mSerializer.__default.Array#canCall(arr#5) && (var valueOrError3#5 := JSON_mSerializer.__default.Array($ly, arr#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#5))))))))) && JSON_mSerializer.__default.Value($LS($ly), js#0) == (if JSON_mValues.JSON.Null_q(js#0) then #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Null(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())))) else (if JSON_mValues.JSON.Bool_q(js#0) then (var b#4 := JSON_mValues.JSON.b(js#0); #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Bool(JSON_mSerializer.__default.Bool(b#4))))) else (if JSON_mValues.JSON.String_q(js#0) then (var str#4 := JSON_mValues.JSON.str(js#0); (var valueOrError0#4 := JSON_mSerializer.__default.String(str#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#4) else (var s#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#4)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.String(s#4))))))) else (if JSON_mValues.JSON.Number_q(js#0) then (var dec#4 := JSON_mValues.JSON.num(js#0); (var valueOrError1#4 := JSON_mSerializer.__default.Number(dec#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#4) else (var n#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#4)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Number(n#4))))))) else (if JSON_mValues.JSON.Object_q(js#0) then (var obj#4 := JSON_mValues.JSON.obj(js#0); (var valueOrError2#4 := JSON_mSerializer.__default.Object($ly, obj#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#4) else (var o#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#4)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Object(o#4))))))) else (var arr#4 := JSON_mValues.JSON.arr(js#0); (var valueOrError3#4 := JSON_mSerializer.__default.Array($ly, arr#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#4) else (var a#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#4)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Array(a#4)))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.Value($LS($ly), Lit(js#0)) } JSON_mSerializer.__default.Value#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> (Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(JSON_mGrammar.__default.NULL())) && (!Lit(JSON_mValues.JSON.Null_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (var b#7 := Lit(JSON_mValues.JSON.b(Lit(js#0))); JSON_mSerializer.__default.Bool#canCall(b#7))) && (!Lit(JSON_mValues.JSON.Bool_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (var str#7 := Lit(JSON_mValues.JSON.str(Lit(js#0))); JSON_mSerializer.__default.String#canCall(str#7) && (var valueOrError0#7 := JSON_mSerializer.__default.String(str#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#7))))) && (!Lit(JSON_mValues.JSON.String_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (var dec#7 := Lit(JSON_mValues.JSON.num(Lit(js#0))); JSON_mSerializer.__default.Number#canCall(dec#7) && (var valueOrError1#7 := JSON_mSerializer.__default.Number(dec#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#7))))) && (!Lit(JSON_mValues.JSON.Number_q(Lit(js#0))) ==> (Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var obj#7 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); JSON_mSerializer.__default.Object#canCall(obj#7) && (var valueOrError2#7 := JSON_mSerializer.__default.Object($LS($ly), obj#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#7))))) && (!Lit(JSON_mValues.JSON.Object_q(Lit(js#0))) ==> (var arr#7 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); JSON_mSerializer.__default.Array#canCall(arr#7) && (var valueOrError3#7 := JSON_mSerializer.__default.Array($LS($ly), arr#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#7))))))))) && JSON_mSerializer.__default.Value($LS($ly), Lit(js#0)) == (if JSON_mValues.JSON.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(#JSON.Grammar.Value.Null(JSON_mUtils_mViews_mCore.View__.OfBytes(JSON_mGrammar.__default.NULL())))) else (if JSON_mValues.JSON.Bool_q(Lit(js#0)) then (var b#6 := Lit(JSON_mValues.JSON.b(Lit(js#0))); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Bool(Lit(JSON_mSerializer.__default.Bool(b#6)))))))) else (if JSON_mValues.JSON.String_q(Lit(js#0)) then (var str#6 := Lit(JSON_mValues.JSON.str(Lit(js#0))); (var valueOrError0#6 := Lit(JSON_mSerializer.__default.String(str#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError0#6) else (var s#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jstring(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#6)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.String(s#6))))))))) else (if JSON_mValues.JSON.Number_q(Lit(js#0)) then (var dec#6 := Lit(JSON_mValues.JSON.num(Lit(js#0))); (var valueOrError1#6 := Lit(JSON_mSerializer.__default.Number(dec#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError1#6) else (var n#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.jnumber(), Tclass.JSON_mErrors.SerializationError(), valueOrError1#6)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Number(n#6))))))))) else (if JSON_mValues.JSON.Object_q(Lit(js#0)) then (var obj#6 := Lit(JSON_mValues.JSON.obj(Lit(js#0))); (var valueOrError2#6 := Lit(JSON_mSerializer.__default.Object($LS($ly), obj#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError2#6) else (var o#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), Tclass.JSON_mErrors.SerializationError(), valueOrError2#6)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Object(o#6))))))))) else (var arr#6 := Lit(JSON_mValues.JSON.arr(Lit(js#0))); (var valueOrError3#6 := Lit(JSON_mSerializer.__default.Array($LS($ly), arr#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Value(), valueOrError3#6) else (var a#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), Tclass.JSON_mErrors.SerializationError(), valueOrError3#6)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Grammar.Value.Array(a#6)))))))))))))));

axiom (forall js#0: DatatypeType :: { JSON_mSerializer.__default.JSON(js#0) } JSON_mSerializer.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> $Is(JSON_mSerializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall js#0: DatatypeType :: { JSON_mSerializer.__default.JSON(js#0) } JSON_mSerializer.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> JSON_mSerializer.__default.Value#canCall(js#0) && (var valueOrError0#2 := JSON_mSerializer.__default.Value($LS($LZ), js#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) && (var val#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): DatatypeType; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mGrammar.Value(), $Box(val#2))))) && JSON_mSerializer.__default.JSON(js#0) == (var valueOrError0#2 := JSON_mSerializer.__default.Value($LS($LZ), js#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#2) else (var val#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#2)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mGrammar.Value(), $Box(val#2))))))));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mSerializer.__default.JSON(Lit(js#0)) } JSON_mSerializer.__default.JSON#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mValues.JSON()) ==> JSON_mSerializer.__default.Value#canCall(Lit(js#0)) && (var valueOrError0#3 := Lit(JSON_mSerializer.__default.Value($LS($LZ), Lit(js#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) && (var val#3 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): DatatypeType; JSON_mSerializer.__default.MkStructural#canCall(Tclass.JSON_mGrammar.Value(), $Box(val#3))))) && JSON_mSerializer.__default.JSON(Lit(js#0)) == (var valueOrError0#3 := Lit(JSON_mSerializer.__default.Value($LS($LZ), Lit(js#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#3) else (var val#3 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.SerializationError(), valueOrError0#3)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mSerializer.__default.MkStructural(Tclass.JSON_mGrammar.Value(), $Box(val#3))))))))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#4: int :: { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) } Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) ==> LitInt(0) <= d#4 && d#4 < base#0) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#6 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#7 := Seq#Append(digits'#6, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#7))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#7 := JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#8 := Seq#Append(digits'#7, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#8))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#8 := Lit(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#9 := Seq#Append(digits'#8, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#9))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#4: int :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && (forall d#10: int :: { Seq#Contains(digits#0, $Box(d#10)) } Seq#Contains(digits#0, $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#4: int :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(chars#0) > 1) ==> (var base#4 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(n#0, base#4) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0)) && JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(n#0, chars#0) == (var base#4 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#5 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mUint16StrConversion.__default.Digits#canCall(LitInt(n#0), base#5) && JSON_mDeserializer_mUint16StrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0))) && JSON_mDeserializer_mUint16StrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#5 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mDeserializer_mUint16StrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mUint16StrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#8: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#8))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#8)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#8))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#9: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#9))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#9)) } LitInt(0) <= c#9 && c#9 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#9)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#9))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mDeserializer_mUint16StrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint16(), TBool))) ==> (JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#10: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, is_digit#0, $Box(c#10))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#10)) } LitInt(0) <= c#10 && c#10 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#10)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint16(), TBool, $Heap, Lit(is_digit#0), $Box(c#10))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Length(chars#0) > 1) ==> JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Seq#Contains(chars#0, $l#8#c#0))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint16())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mDeserializer_mUint16StrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint16())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#7: int :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && (forall c#7: int :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#8: int :: { Map#Domain(digits#0)[$Box(c#8)] } { Seq#Contains(str#0, $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#8)) ==> Map#Domain(digits#0)[$Box(c#8)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) ==> (JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint16())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint16())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(digits#0)[$l#14#c#0])), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.BoundedInts.uint16())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__16() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mDeserializer_mUint16StrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Map#Domain(digits#0)[$l#15#c#0])), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint16())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mUint16StrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 == LitInt(0) ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == LitInt(0)) && (n#0 > 0 ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, base#0, n#0) + 1) && (forall d#4: int :: { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) } Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), $Box(d#4)) ==> LitInt(0) <= d#4 && d#4 < base#0) && $Is(JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, n#0, base#0), TSeq(TInt)));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (n#0 != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), n#0, base#0) == (if n#0 == LitInt(0) then Seq#Empty(): Seq else (var digits'#6 := JSON_mDeserializer_mByteStrConversion.__default.Digits($ly, Div(n#0, base#0), base#0); (var digits#7 := Seq#Append(digits'#6, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#7))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#0) || (LitInt(0) <= n#0 && base#0 > 1) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(Div(n#0, base#0), base#0)) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), base#0) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#7 := JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), Div(n#0, base#0), base#0); (var digits#8 := Seq#Append(digits'#7, Seq#Build(Seq#Empty(): Seq, $Box(Mod(n#0, base#0)))); digits#8))));

axiom (forall $ly: LayerType, n#0: int, base#0: int :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) } JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), LitInt(base#0)) || (LitInt(0) <= n#0 && Lit(base#0 > 1)) ==> (LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))) && JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(n#0), LitInt(base#0)) == (if LitInt(n#0) == LitInt(0) then Seq#Empty(): Seq else (var digits'#8 := Lit(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($ly), LitInt(Div(n#0, LitInt(base#0))), LitInt(base#0))); (var digits#9 := Seq#Append(digits'#8, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(Mod(n#0, LitInt(base#0)))))); digits#9))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#0: int :: { Seq#Contains(digits#0, $Box(d#0)) } Seq#Contains(digits#0, $Box(d#0)) ==> LitInt(0) <= d#0 && d#0 < Seq#Length(chars#0))) ==> (forall c#4: int :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0)) == Seq#Length(digits#0) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, digits#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) } $Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) ==> (JSON_mDeserializer_mByteStrConversion.__default.OfDigits#requires($ly, digits#0, chars#0) <==> (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(digits#0, chars#0) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#9: int :: { Seq#Contains(digits#0, $Box(d#9)) } Seq#Contains(digits#0, $Box(d#9)) ==> LitInt(0) <= d#9 && d#9 < Seq#Length(chars#0))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Seq#Drop(digits#0, LitInt(1)), chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), digits#0, chars#0) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, $Unbox(Seq#Index(digits#0, LitInt(0))): int)), JSON_mDeserializer_mByteStrConversion.__default.OfDigits($ly, Seq#Drop(digits#0, LitInt(1)), chars#0))));

axiom (forall $ly: LayerType, digits#0: Seq, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Lit(digits#0), Lit(chars#0)) || ($Is(digits#0, TSeq(TInt)) && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && (forall d#10: int :: { Seq#Contains(digits#0, $Box(d#10)) } Seq#Contains(digits#0, $Box(d#10)) ==> LitInt(0) <= d#10 && d#10 < Seq#Length(Lit(chars#0)))) ==> (!Seq#Equal(digits#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(digits#0), Lit(chars#0)) == (if Seq#Equal(digits#0, Seq#Empty(): Seq) then Seq#Empty(): Seq else Seq#Append(Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), $Unbox(Seq#Index(Lit(digits#0), LitInt(0))): int)), JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($ly), Lit(Seq#Drop(Lit(digits#0), LitInt(1))), Lit(chars#0)))));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> Seq#Length(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0)) == Logarithm.__default.Log($LS($LZ), reveal_Logarithm._default.Log, Seq#Length(chars#0), n#0) + 1 && (forall c#4: int :: { Seq#Contains(chars#0, $Box(c#4)) } { Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) } LitInt(0) <= c#4 && c#4 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), $Box(c#4)) ==> Seq#Contains(chars#0, $Box(c#4))) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall n#0: int, chars#0: Seq :: { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(n#0, chars#0) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(chars#0) > 1) ==> (var base#4 := Seq#Length(chars#0); n#0 != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(n#0, base#4) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0)) && JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(n#0, chars#0) == (var base#4 := Seq#Length(chars#0); (if n#0 == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(chars#0, LitInt(0))) else JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), n#0, base#4), chars#0))));

axiom (forall n#0: int, chars#0: Seq :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) } JSON_mDeserializer_mByteStrConversion.__default.OfNat__any#canCall(LitInt(n#0), Lit(chars#0)) || (LitInt(0) <= n#0 && $Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(chars#0)) > 1) ==> (var base#5 := Seq#Length(Lit(chars#0)); LitInt(n#0) != LitInt(0) ==> JSON_mDeserializer_mByteStrConversion.__default.Digits#canCall(LitInt(n#0), base#5) && JSON_mDeserializer_mByteStrConversion.__default.OfDigits#canCall(JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0))) && JSON_mDeserializer_mByteStrConversion.__default.OfNat__any(LitInt(n#0), Lit(chars#0)) == (var base#5 := Seq#Length(Lit(chars#0)); (if LitInt(n#0) == LitInt(0) then Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(chars#0), LitInt(0))) else JSON_mDeserializer_mByteStrConversion.__default.OfDigits($LS($LZ), JSON_mDeserializer_mByteStrConversion.__default.Digits($LS($LZ), LitInt(n#0), base#5), Lit(chars#0)))));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(str#0, minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(str#0, LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(str#0, LitInt(0))): int))): bool) && (forall c#8: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#8))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(str#0, LitInt(1)), $Box(c#8)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#8))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), minus#0, is_digit#0) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, is_digit#0) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == minus#0 || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#9: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#9))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#9)) } LitInt(0) <= c#9 && c#9 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#9)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#9))): bool)));

axiom (forall $Heap: Heap, str#0: Seq, minus#0: int, is_digit#0: HandleType :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)), $IsGoodHeap($Heap) } JSON_mDeserializer_mByteStrConversion.__default.NumberStr#canCall(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) || ($IsGoodHeap($Heap) && $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && $Is(is_digit#0, Tclass._System.___hTotalFunc1(Tclass.BoundedInts.uint8(), TBool))) ==> (JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(is_digit#0)) <==> !Seq#Equal(str#0, Seq#Empty(): Seq) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int == LitInt(minus#0) || $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box($Unbox(Seq#Index(Lit(str#0), LitInt(0))): int))): bool) && (forall c#10: int :: { $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, is_digit#0, $Box(c#10))): bool } { Seq#Contains(Seq#Drop(str#0, 1), $Box(c#10)) } LitInt(0) <= c#10 && c#10 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(Seq#Drop(Lit(str#0), LitInt(1)), $Box(c#10)) ==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $Heap, Lit(is_digit#0), $Box(c#10))): bool)));

axiom (forall n#0: int, chars#0: Seq, minus#0: int :: { JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0) } JSON_mDeserializer_mByteStrConversion.__default.OfInt__any#canCall(n#0, chars#0, minus#0) || ($Is(chars#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Length(chars#0) > 1) ==> JSON_mDeserializer_mByteStrConversion.__default.NumberStr(JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), minus#0, Lit(AtLayer((lambda $l#8#ly#0: LayerType :: Handle1((lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $Box(Seq#Contains(chars#0, $l#8#c#0))), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: $IsBox($l#8#c#0, Tclass.BoundedInts.uint8())), (lambda $l#8#heap#0: Heap, $l#8#c#0: Box :: SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mDeserializer_mByteStrConversion.__default.OfInt__any(n#0, chars#0, minus#0), TSeq(Tclass.BoundedInts.uint8())));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#requires($ly, str#0, base#0, digits#0) <==> base#0 > 0 && (forall c#7: int :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && (forall c#7: int :: { Map#Domain(digits#0)[$Box(c#7)] } { Seq#Contains(str#0, $Box(c#7)) } LitInt(0) <= c#7 && c#7 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#7)) ==> Map#Domain(digits#0)[$Box(c#7)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), str#0, base#0, digits#0) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($ly, Seq#Take(str#0, Seq#Length(str#0) - 1), base#0, digits#0), base#0) + $Unbox(Map#Elements(digits#0)[Seq#Index(str#0, Seq#Length(str#0) - 1)]): int));

axiom (forall $ly: LayerType, str#0: Seq, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && (forall c#8: int :: { Map#Domain(digits#0)[$Box(c#8)] } { Seq#Contains(str#0, $Box(c#8)) } LitInt(0) <= c#8 && c#8 < BoundedInts.__default.TWO__TO__THE__8() && Seq#Contains(str#0, $Box(c#8)) ==> Map#Domain(digits#0)[$Box(c#8)])) ==> (!Seq#Equal(str#0, Seq#Empty(): Seq) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Lit(str#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Equal(str#0, Seq#Empty(): Seq) then 0 else Mul(JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($ly), Seq#Take(Lit(str#0), Seq#Length(Lit(str#0)) - 1), LitInt(base#0), Lit(digits#0)), LitInt(base#0)) + $Unbox(Map#Elements(Lit(digits#0))[Seq#Index(Lit(str#0), Seq#Length(Lit(str#0)) - 1)]): int));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) ==> (JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#requires(str#0, minus#0, base#0, digits#0) <==> base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(str#0, minus#0, base#0, digits#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && base#0 > 0 && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(str#0, minus#0, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(Map#Domain(digits#0)[$l#13#c#0])), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.BoundedInts.uint8())), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Seq#Drop(str#0, LitInt(1)), base#0, digits#0)) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(str#0, base#0, digits#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(str#0, minus#0, base#0, digits#0) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Seq#Drop(str#0, LitInt(1)), base#0, digits#0) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), str#0, base#0, digits#0)));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) && JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), minus#0, Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(Map#Domain(digits#0)[$l#14#c#0])), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.BoundedInts.uint8())), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), minus#0, LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(minus#0)))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall str#0: Seq, minus#0: int, base#0: int, digits#0: Map :: {:weight 3} { JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) } JSON_mDeserializer_mByteStrConversion.__default.ToInt__any#canCall(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint8())) && LitInt(0) <= minus#0 && minus#0 < BoundedInts.__default.TWO__TO__THE__8() && LitInt(0) <= base#0 && $Is(digits#0, TMap(Tclass.BoundedInts.uint8(), Tclass._System.nat())) && Lit(base#0 > 0) && !Seq#Equal(str#0, Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) && Lit(JSON_mDeserializer_mByteStrConversion.__default.NumberStr(Lit(str#0), LitInt(minus#0), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(Map#Domain(digits#0)[$l#15#c#0])), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.BoundedInts.uint8())), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ)))))) ==> (Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0))) && (!(Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))))) ==> JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(base#0), Lit(digits#0))) && JSON_mDeserializer_mByteStrConversion.__default.ToInt__any(Lit(str#0), LitInt(minus#0), LitInt(base#0), Lit(digits#0)) == (if Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0)))) <= Seq#Length(str#0) && Seq#SameUntil(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))), str#0, Seq#Length(Seq#Build(Seq#Empty(): Seq, $Box(LitInt(minus#0))))) then 0 - JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(Seq#Drop(Lit(str#0), LitInt(1))), LitInt(base#0), Lit(digits#0)) else JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(base#0), Lit(digits#0))));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Bool(js#0) } JSON_mDeserializer.__default.Bool#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jbool()) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(js#0, LitInt(0)) && (JSON_mDeserializer.__default.Bool(js#0) <==> JSON_mUtils_mViews_mCore.View__.At(js#0, LitInt(0)) == char#ToInt(Lit(char#FromInt(116)))));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Bool(Lit(js#0)) } JSON_mDeserializer.__default.Bool#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.jbool()) ==> JSON_mUtils_mViews_mCore.View__.At#canCall(Lit(js#0), LitInt(0)) && (JSON_mDeserializer.__default.Bool(Lit(js#0)) <==> LitInt(JSON_mUtils_mViews_mCore.View__.At(Lit(js#0), LitInt(0))) == char#ToInt(Lit(char#FromInt(116)))));

axiom (forall code#0: Seq :: { JSON_mDeserializer.__default.UnsupportedEscape16(code#0) } JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#0) || $Is(code#0, TSeq(Tclass.BoundedInts.uint16())) ==> $Is(JSON_mDeserializer.__default.UnsupportedEscape16(code#0), Tclass.JSON_mErrors.DeserializationError()));

axiom (forall code#0: Seq :: { JSON_mDeserializer.__default.UnsupportedEscape16(code#0) } JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#0) || $Is(code#0, TSeq(Tclass.BoundedInts.uint16())) ==> UnicodeStrings.__default.FromUTF16Checked#canCall(code#0) && Wrappers.Option.UnwrapOr#canCall(TSeq(TChar), UnicodeStrings.__default.FromUTF16Checked(code#0), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54)))))) && JSON_mDeserializer.__default.UnsupportedEscape16(code#0) == #JSON.Errors.DeserializationError.UnsupportedEscape($Unbox(Wrappers.Option.UnwrapOr(TSeq(TChar), UnicodeStrings.__default.FromUTF16Checked(code#0), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54))))))): Seq));

axiom (forall code#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.UnsupportedEscape16(Lit(code#0)) } JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Lit(code#0)) || $Is(code#0, TSeq(Tclass.BoundedInts.uint16())) ==> UnicodeStrings.__default.FromUTF16Checked#canCall(Lit(code#0)) && Wrappers.Option.UnwrapOr#canCall(TSeq(TChar), Lit(UnicodeStrings.__default.FromUTF16Checked(Lit(code#0))), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54)))))) && JSON_mDeserializer.__default.UnsupportedEscape16(Lit(code#0)) == Lit(#JSON.Errors.DeserializationError.UnsupportedEscape(Lit($Unbox(Wrappers.Option.UnwrapOr(TSeq(TChar), Lit(UnicodeStrings.__default.FromUTF16Checked(Lit(code#0))), $Box(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(char#FromInt(67))), $Box(char#FromInt(111))), $Box(char#FromInt(117))), $Box(char#FromInt(108))), $Box(char#FromInt(100))), $Box(char#FromInt(110))), $Box(char#FromInt(39))), $Box(char#FromInt(116))), $Box(char#FromInt(32))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(99))), $Box(char#FromInt(111))), $Box(char#FromInt(100))), $Box(char#FromInt(101))), $Box(char#FromInt(32))), $Box(char#FromInt(85))), $Box(char#FromInt(84))), $Box(char#FromInt(70))), $Box(char#FromInt(45))), $Box(char#FromInt(49))), $Box(char#FromInt(54))))))): Seq))));

axiom $Is(JSON_mDeserializer.__default.HEX__TABLE__16(), TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mDeserializer.__default.HEX__TABLE__16(), TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mDeserializer.__default.HEX__TABLE__16(), TMap(Tclass.BoundedInts.uint16(), Tclass._System.nat()), $h));

axiom (forall str#0: Seq :: { JSON_mDeserializer.__default.ToNat16(str#0) } JSON_mDeserializer.__default.ToNat16#canCall(str#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(str#0) <= LitInt(4) && (forall c#0: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#0)] } { Seq#Contains(str#0, $Box(c#0)) } LitInt(0) <= c#0 && c#0 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#0)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#0)])) ==> LitInt(0) <= JSON_mDeserializer.__default.ToNat16(str#0) && JSON_mDeserializer.__default.ToNat16(str#0) < BoundedInts.__default.TWO__TO__THE__16());

axiom (forall str#0: Seq :: { JSON_mDeserializer.__default.ToNat16#requires(str#0) } $Is(str#0, TSeq(Tclass.BoundedInts.uint16())) ==> (JSON_mDeserializer.__default.ToNat16#requires(str#0) <==> Seq#Length(str#0) <= LitInt(4) && (forall c#5: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)])));

axiom (forall str#0: Seq :: { JSON_mDeserializer.__default.ToNat16(str#0) } JSON_mDeserializer.__default.ToNat16#canCall(str#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(str#0) <= LitInt(4) && (forall c#5: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)] } { Seq#Contains(str#0, $Box(c#5)) } LitInt(0) <= c#5 && c#5 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#5)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#5)])) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()) && JSON_mDeserializer.__default.ToNat16(str#0) == (var hd#2 := JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), str#0, LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()); hd#2));

axiom (forall str#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.ToNat16(Lit(str#0)) } JSON_mDeserializer.__default.ToNat16#canCall(Lit(str#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && Seq#Length(Lit(str#0)) <= LitInt(4) && (forall c#6: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#6)] } { Seq#Contains(str#0, $Box(c#6)) } LitInt(0) <= c#6 && c#6 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(str#0, $Box(c#6)) ==> Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#6)])) ==> JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any#canCall(Lit(str#0), LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()) && JSON_mDeserializer.__default.ToNat16(Lit(str#0)) == (var hd#3 := JSON_mDeserializer_mUint16StrConversion.__default.ToNat__any($LS($LZ), Lit(str#0), LitInt(16), JSON_mDeserializer.__default.HEX__TABLE__16()); hd#3));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape($ly, str#0, start#0, prefix#0) } JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0, prefix#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> $Is(JSON_mDeserializer.__default.Unescape($ly, str#0, start#0, prefix#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: { JSON_mDeserializer.__default.Unescape($LS($ly), str#0, start#0, prefix#0) } JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0, prefix#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> (Seq#Length(str#0) > start#0 ==> ($Unbox(Seq#Index(str#0, start#0)): int == char#ToInt(Lit(char#FromInt(92))) ==> Seq#Length(str#0) != start#0 + 1 ==> (var c#9 := $Unbox(Seq#Index(str#0, start#0 + 1)): int; (c#9 == char#ToInt(Lit(char#FromInt(117))) ==> start#0 + 6 < Seq#Length(str#0) ==> (var code#3 := Seq#Drop(Seq#Take(str#0, start#0 + 6), start#0 + 2); ((exists c#10: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#10)] } { Seq#Contains(code#3, $Box(c#10)) } LitInt(0) <= c#10 && c#10 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#3, $Box(c#10)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#10)]) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#3)) && (!(exists c#10: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#10)] } { Seq#Contains(code#3, $Box(c#10)) } LitInt(0) <= c#10 && c#10 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#3, $Box(c#10)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#10)]) ==> JSON_mDeserializer.__default.ToNat16#canCall(code#3) && (var hd#3 := JSON_mDeserializer.__default.ToNat16(code#3); JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#3)))))))) && (c#9 != char#ToInt(Lit(char#FromInt(117))) ==> (var unescaped#3 := (if c#9 == LitInt(34) then 34 else (if c#9 == LitInt(92) then 92 else (if c#9 == LitInt(98) then 8 else (if c#9 == LitInt(102) then 12 else (if c#9 == LitInt(110) then 10 else (if c#9 == LitInt(114) then 13 else (if c#9 == LitInt(116) then 9 else 0))))))); (unescaped#3 == LitInt(0) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0))) && (unescaped#3 != LitInt(0) ==> JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#3))))))))) && ($Unbox(Seq#Index(str#0, start#0)): int != char#ToInt(Lit(char#FromInt(92))) ==> JSON_mDeserializer.__default.Unescape#canCall(str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0)))))) && JSON_mDeserializer.__default.Unescape($LS($ly), str#0, start#0, prefix#0) == (if start#0 >= Seq#Length(str#0) then #Wrappers.Result.Success($Box(prefix#0)) else (if $Unbox(Seq#Index(str#0, start#0)): int == char#ToInt(Lit(char#FromInt(92))) then (if Seq#Length(str#0) == start#0 + 1 then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var c#9 := $Unbox(Seq#Index(str#0, start#0 + 1)): int; (if c#9 == char#ToInt(Lit(char#FromInt(117))) then (if Seq#Length(str#0) <= start#0 + 6 then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var code#3 := Seq#Drop(Seq#Take(str#0, start#0 + 6), start#0 + 2); (if (exists c#10: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#10)] } { Seq#Contains(code#3, $Box(c#10)) } LitInt(0) <= c#10 && c#10 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#3, $Box(c#10)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#10)]) then #Wrappers.Result.Failure($Box(JSON_mDeserializer.__default.UnsupportedEscape16(code#3))) else (var hd#3 := JSON_mDeserializer.__default.ToNat16(code#3); JSON_mDeserializer.__default.Unescape($ly, str#0, start#0 + 6, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#3)))))))) else (var unescaped#3 := (if c#9 == LitInt(34) then 34 else (if c#9 == LitInt(92) then 92 else (if c#9 == LitInt(98) then 8 else (if c#9 == LitInt(102) then 12 else (if c#9 == LitInt(110) then 10 else (if c#9 == LitInt(114) then 13 else (if c#9 == LitInt(116) then 9 else 0))))))); (if unescaped#3 == LitInt(0) then #Wrappers.Result.Failure($Box(JSON_mDeserializer.__default.UnsupportedEscape16(Seq#Drop(Seq#Take(str#0, start#0 + 2), start#0)))) else JSON_mDeserializer.__default.Unescape($ly, str#0, start#0 + 2, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#3))))))))) else JSON_mDeserializer.__default.Unescape($ly, str#0, start#0 + 1, Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(str#0, start#0)))))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), prefix#0) } JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0), prefix#0) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) ==> Seq#Length(Lit(str#0)) != LitInt(start#0 + 1) ==> (var c#11 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (c#11 == char#ToInt(Lit(char#FromInt(117))) ==> LitInt(start#0 + 6) < Seq#Length(Lit(str#0)) ==> (var code#4 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); ((exists c#12: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#12)] } { Seq#Contains(code#4, $Box(c#12)) } LitInt(0) <= c#12 && c#12 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#4, $Box(c#12)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#12)]) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#4)) && (!(exists c#12: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#12)] } { Seq#Contains(code#4, $Box(c#12)) } LitInt(0) <= c#12 && c#12 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#4, $Box(c#12)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#12)]) ==> JSON_mDeserializer.__default.ToNat16#canCall(code#4) && (var hd#4 := JSON_mDeserializer.__default.ToNat16(code#4); JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#4)))))))) && (c#11 != char#ToInt(Lit(char#FromInt(117))) ==> (var unescaped#4 := (if c#11 == LitInt(34) then 34 else (if c#11 == LitInt(92) then 92 else (if c#11 == LitInt(98) then 8 else (if c#11 == LitInt(102) then 12 else (if c#11 == LitInt(110) then 10 else (if c#11 == LitInt(114) then 13 else (if c#11 == LitInt(116) then 9 else 0))))))); (unescaped#4 == LitInt(0) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))) && (unescaped#4 != LitInt(0) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#4))))))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != char#ToInt(Lit(char#FromInt(92))) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))) && JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), prefix#0) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then #Wrappers.Result.Success($Box(prefix#0)) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) then (if Seq#Length(Lit(str#0)) == LitInt(start#0 + 1) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var c#11 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (if c#11 == char#ToInt(Lit(char#FromInt(117))) then (if Seq#Length(Lit(str#0)) <= LitInt(start#0 + 6) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var code#4 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); (if (exists c#12: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#12)] } { Seq#Contains(code#4, $Box(c#12)) } LitInt(0) <= c#12 && c#12 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#4, $Box(c#12)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#12)]) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(code#4)))) else (var hd#4 := LitInt(JSON_mDeserializer.__default.ToNat16(code#4)); JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#4)))))))) else (var unescaped#4 := (if c#11 == LitInt(34) then 34 else (if c#11 == LitInt(92) then 92 else (if c#11 == LitInt(98) then 8 else (if c#11 == LitInt(102) then 12 else (if c#11 == LitInt(110) then 10 else (if c#11 == LitInt(114) then 13 else (if c#11 == LitInt(116) then 9 else 0))))))); (if unescaped#4 == LitInt(0) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#4))))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))));

axiom (forall $ly: LayerType, str#0: Seq, start#0: int, prefix#0: Seq :: {:weight 3} { JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), Lit(prefix#0)) } JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0), Lit(prefix#0)) || ($Is(str#0, TSeq(Tclass.BoundedInts.uint16())) && LitInt(0) <= start#0 && $Is(prefix#0, TSeq(Tclass.BoundedInts.uint16()))) ==> (Seq#Length(Lit(str#0)) > LitInt(start#0) ==> ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) ==> Seq#Length(Lit(str#0)) != LitInt(start#0 + 1) ==> (var c#13 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (c#13 == char#ToInt(Lit(char#FromInt(117))) ==> LitInt(start#0 + 6) < Seq#Length(Lit(str#0)) ==> (var code#5 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); ((exists c#14: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#14)] } { Seq#Contains(code#5, $Box(c#14)) } LitInt(0) <= c#14 && c#14 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#5, $Box(c#14)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#14)]) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(code#5)) && (!(exists c#14: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#14)] } { Seq#Contains(code#5, $Box(c#14)) } LitInt(0) <= c#14 && c#14 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#5, $Box(c#14)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#14)]) ==> JSON_mDeserializer.__default.ToNat16#canCall(code#5) && (var hd#5 := JSON_mDeserializer.__default.ToNat16(code#5); JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#5)))))))) && (c#13 != char#ToInt(Lit(char#FromInt(117))) ==> (var unescaped#5 := (if c#13 == LitInt(34) then 34 else (if c#13 == LitInt(92) then 92 else (if c#13 == LitInt(98) then 8 else (if c#13 == LitInt(102) then 12 else (if c#13 == LitInt(110) then 10 else (if c#13 == LitInt(114) then 13 else (if c#13 == LitInt(116) then 9 else 0))))))); (unescaped#5 == LitInt(0) ==> JSON_mDeserializer.__default.UnsupportedEscape16#canCall(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))) && (unescaped#5 != LitInt(0) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#5))))))))) && ($Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int != char#ToInt(Lit(char#FromInt(92))) ==> JSON_mDeserializer.__default.Unescape#canCall(Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))) && JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0), Lit(prefix#0)) == (if LitInt(start#0) >= Seq#Length(Lit(str#0)) then #Wrappers.Result.Success($Box(Lit(prefix#0))) else (if $Unbox(Seq#Index(Lit(str#0), LitInt(start#0))): int == char#ToInt(Lit(char#FromInt(92))) then (if Seq#Length(Lit(str#0)) == LitInt(start#0 + 1) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var c#13 := $Unbox(Seq#Index(Lit(str#0), LitInt(start#0 + 1))): int; (if c#13 == char#ToInt(Lit(char#FromInt(117))) then (if Seq#Length(Lit(str#0)) <= LitInt(start#0 + 6) then #Wrappers.Result.Failure($Box(Lit(#JSON.Errors.DeserializationError.EscapeAtEOS()))) else (var code#5 := Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 6)), LitInt(start#0 + 2))); (if (exists c#14: int :: { Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#14)] } { Seq#Contains(code#5, $Box(c#14)) } LitInt(0) <= c#14 && c#14 < BoundedInts.__default.TWO__TO__THE__16() && Seq#Contains(code#5, $Box(c#14)) && !Map#Domain(JSON_mDeserializer.__default.HEX__TABLE__16())[$Box(c#14)]) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(code#5)))) else (var hd#5 := LitInt(JSON_mDeserializer.__default.ToNat16(code#5)); JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 6), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(hd#5)))))))) else (var unescaped#5 := (if c#13 == LitInt(34) then 34 else (if c#13 == LitInt(92) then 92 else (if c#13 == LitInt(98) then 8 else (if c#13 == LitInt(102) then 12 else (if c#13 == LitInt(110) then 10 else (if c#13 == LitInt(114) then 13 else (if c#13 == LitInt(116) then 9 else 0))))))); (if unescaped#5 == LitInt(0) then #Wrappers.Result.Failure($Box(Lit(JSON_mDeserializer.__default.UnsupportedEscape16(Lit(Seq#Drop(Seq#Take(Lit(str#0), LitInt(start#0 + 2)), LitInt(start#0))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 2), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, $Box(unescaped#5))))))))) else JSON_mDeserializer.__default.Unescape($LS($ly), Lit(str#0), LitInt(start#0 + 1), Seq#Append(prefix#0, Seq#Build(Seq#Empty(): Seq, Seq#Index(Lit(str#0), LitInt(start#0))))))));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.String(js#0) } JSON_mDeserializer.__default.String#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jstring()) ==> $Is(JSON_mDeserializer.__default.String(js#0), Tclass.Wrappers.Result(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.String(js#0) } JSON_mDeserializer.__default.String#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jstring()) ==> JSON_mGrammar.jstring.JString_q(js#0) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(JSON_mGrammar.jstring.contents(js#0)) && UnicodeStrings.__default.FromUTF8Checked#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError0#2 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (var asUtf32#2 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): Seq; UnicodeStrings.__default.ToUTF16Checked#canCall(asUtf32#2) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#2), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError1#2 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#2), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) && (var asUint16#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2)): Seq; JSON_mDeserializer.__default.Unescape#canCall(asUint16#2, LitInt(0), Lit(Seq#Empty(): Seq)) && (var valueOrError2#2 := JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#2, LitInt(0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#2)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) && (var unescaped#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2)): Seq; UnicodeStrings.__default.FromUTF16Checked#canCall(unescaped#2) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#2), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))))))))))) && JSON_mDeserializer.__default.String(js#0) == (var valueOrError0#2 := Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF8Checked(JSON_mUtils_mViews_mCore.View__.Bytes(JSON_mGrammar.jstring.contents(js#0))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#2) else (var asUtf32#2 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): Seq; (var valueOrError1#2 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#2), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#2) else (var asUint16#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2)): Seq; (var valueOrError2#2 := JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#2, LitInt(0), Lit(Seq#Empty(): Seq)); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#2) else (var unescaped#2 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#2)): Seq; Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#2), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))))))))))));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.String(Lit(js#0)) } JSON_mDeserializer.__default.String#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.jstring()) ==> JSON_mGrammar.jstring.JString_q(Lit(js#0)) && JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(JSON_mGrammar.jstring.contents(Lit(js#0)))) && UnicodeStrings.__default.FromUTF8Checked#canCall(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0)))))) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF8Checked(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0))))))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError0#3 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF8Checked(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0))))))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (var asUtf32#3 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): Seq; UnicodeStrings.__default.ToUTF16Checked#canCall(asUtf32#3) && Wrappers.Option.ToResult_k#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#3), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))) && (var valueOrError1#3 := Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.ToUTF16Checked(asUtf32#3), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (var asUint16#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3)): Seq; JSON_mDeserializer.__default.Unescape#canCall(asUint16#3, LitInt(0), Lit(Seq#Empty(): Seq)) && (var valueOrError2#3 := JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#3, LitInt(0), Lit(Seq#Empty(): Seq)); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) && (Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#3)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) && (var unescaped#3 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3)): Seq; UnicodeStrings.__default.FromUTF16Checked#canCall(unescaped#3) && Wrappers.Option.ToResult_k#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), UnicodeStrings.__default.FromUTF16Checked(unescaped#3), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))))))))))) && JSON_mDeserializer.__default.String(Lit(js#0)) == (var valueOrError0#3 := Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF8Checked(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(JSON_mGrammar.jstring.contents(Lit(js#0))))))), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError0#3) else (var asUtf32#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): Seq); (var valueOrError1#3 := Lit(Wrappers.Option.ToResult_k(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.ToUTF16Checked(asUtf32#3)), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode())))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError1#3) else (var asUint16#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3)): Seq); (var valueOrError2#3 := Lit(JSON_mDeserializer.__default.Unescape($LS($LZ), asUint16#3, LitInt(0), Lit(Seq#Empty(): Seq))); (if Wrappers.Result.IsFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3) then Wrappers.Result.PropagateFailure(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), TSeq(TChar), valueOrError2#3) else (var unescaped#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.BoundedInts.uint16()), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#3)): Seq); Lit(Wrappers.Option.ToResult_k(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Lit(UnicodeStrings.__default.FromUTF16Checked(unescaped#3)), $Box(Lit(#JSON.Errors.DeserializationError.InvalidUnicode()))))))))))))));

axiom $Is(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), TInt));

axiom (forall $h: Heap :: { $IsAlloc(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), TInt), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mDeserializer.__default.DIGITS(), TMap(Tclass.BoundedInts.uint8(), TInt), $h));

axiom $Is(JSON_mDeserializer.__default.MINUS(), Tclass.BoundedInts.uint8());

axiom (forall $h: Heap :: { $IsAlloc(JSON_mDeserializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h) } $IsGoodHeap($h) ==> $IsAlloc(JSON_mDeserializer.__default.MINUS(), Tclass.BoundedInts.uint8(), $h));

axiom (forall sign#0: DatatypeType, n#0: DatatypeType :: { JSON_mDeserializer.__default.ToInt(sign#0, n#0) } JSON_mDeserializer.__default.ToInt#canCall(sign#0, n#0) || ($Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum())) ==> $Is(JSON_mDeserializer.__default.ToInt(sign#0, n#0), Tclass.Wrappers.Result(TInt, Tclass.JSON_mErrors.DeserializationError())));

axiom (forall sign#0: DatatypeType, n#0: DatatypeType :: { JSON_mDeserializer.__default.ToInt(sign#0, n#0) } JSON_mDeserializer.__default.ToInt#canCall(sign#0, n#0) || ($Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(n#0) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS()) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall(sign#0, Lit(char#FromInt(45))) && JSON_mDeserializer.__default.ToInt(sign#0, n#0) == (var n#3 := JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), JSON_mUtils_mViews_mCore.View__.Bytes(n#0), LitInt(10), JSON_mDeserializer.__default.DIGITS()); #Wrappers.Result.Success($Box((if JSON_mUtils_mViews_mCore.View__.Char_q(sign#0, Lit(char#FromInt(45))) then 0 - n#3 else n#3)))));

axiom (forall sign#0: DatatypeType, n#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.ToInt(Lit(sign#0), Lit(n#0)) } JSON_mDeserializer.__default.ToInt#canCall(Lit(sign#0), Lit(n#0)) || ($Is(sign#0, Tclass.JSON_mGrammar.jsign()) && $Is(n#0, Tclass.JSON_mGrammar.jnum())) ==> JSON_mUtils_mViews_mCore.View__.Bytes#canCall(Lit(n#0)) && JSON_mDeserializer_mByteStrConversion.__default.ToNat__any#canCall(Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(n#0))), LitInt(10), JSON_mDeserializer.__default.DIGITS()) && JSON_mUtils_mViews_mCore.View__.Char_q#canCall(Lit(sign#0), Lit(char#FromInt(45))) && JSON_mDeserializer.__default.ToInt(Lit(sign#0), Lit(n#0)) == (var n#4 := JSON_mDeserializer_mByteStrConversion.__default.ToNat__any($LS($LZ), Lit(JSON_mUtils_mViews_mCore.View__.Bytes(Lit(n#0))), LitInt(10), JSON_mDeserializer.__default.DIGITS()); #Wrappers.Result.Success($Box((if JSON_mUtils_mViews_mCore.View__.Char_q(Lit(sign#0), Lit(char#FromInt(45))) then 0 - n#4 else n#4)))));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Number(js#0) } JSON_mDeserializer.__default.Number#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jnumber()) ==> $Is(JSON_mDeserializer.__default.Number(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.Number(js#0) } JSON_mDeserializer.__default.Number#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jnumber()) ==> (var minus#2, num#12, frac#6, exp#2 := JSON_mGrammar.jnumber.minus(js#0), JSON_mGrammar.jnumber.num(js#0), JSON_mGrammar.jnumber.frac(js#0), JSON_mGrammar.jnumber.exp(js#0); JSON_mDeserializer.__default.ToInt#canCall(minus#2, num#12) && (var valueOrError0#2 := JSON_mDeserializer.__default.ToInt(minus#2, num#12); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (!JSON_mGrammar.Maybe.Empty_q(exp#2) ==> JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType) && (var num#15 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType); JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType) && (var sign#7 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType); JSON_mDeserializer.__default.ToInt#canCall(sign#7, num#15)))) && (var valueOrError1#2 := (if JSON_mGrammar.Maybe.Empty_q(exp#2) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#17 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType); (var sign#8 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#8, num#17)))); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#2)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) && (!JSON_mGrammar.Maybe.Empty_q(frac#6) ==> JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(frac#6)): DatatypeType) && (var num#16 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#6)): DatatypeType); JSON_mUtils_mViews_mCore.View__.Length#canCall(num#16) && (var pow10#5 := JSON_mUtils_mViews_mCore.View__.Length(num#16); JSON_mDeserializer.__default.ToInt#canCall(minus#2, num#16) && (var valueOrError2#5 := JSON_mDeserializer.__default.ToInt(minus#2, num#16); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#5)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) && Power.__default.Pow#canCall(LitInt(10), pow10#5))))))))))) && JSON_mDeserializer.__default.Number(js#0) == (var minus#2, num#12, frac#6, exp#2 := JSON_mGrammar.jnumber.minus(js#0), JSON_mGrammar.jnumber.num(js#0), JSON_mGrammar.jnumber.frac(js#0), JSON_mGrammar.jnumber.exp(js#0); (var valueOrError0#2 := JSON_mDeserializer.__default.ToInt(minus#2, num#12); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#2) else (var n#2 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): int; (var valueOrError1#2 := (if JSON_mGrammar.Maybe.Empty_q(exp#2) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#13 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType); (var sign#6 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#2)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#6, num#13)))); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#2) else (var e10#2 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2)): int; (if JSON_mGrammar.Maybe.Empty_q(frac#6) then #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(n#2, e10#2))) else (var num#14 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#6)): DatatypeType); (var pow10#4 := JSON_mUtils_mViews_mCore.View__.Length(num#14); (var valueOrError2#4 := JSON_mDeserializer.__default.ToInt(minus#2, num#14); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#4) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#4) else (var frac#7 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#4)): int; #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(Mul(n#2, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(10), pow10#4)) + frac#7, e10#2 - pow10#4)))))))))))))))));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Number(Lit(js#0)) } JSON_mDeserializer.__default.Number#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.jnumber()) ==> (var minus#3, num#18, frac#9, exp#3 := JSON_mGrammar.jnumber.minus(Lit(js#0)), JSON_mGrammar.jnumber.num(Lit(js#0)), JSON_mGrammar.jnumber.frac(Lit(js#0)), JSON_mGrammar.jnumber.exp(Lit(js#0)); JSON_mDeserializer.__default.ToInt#canCall(minus#3, num#18) && (var valueOrError0#3 := JSON_mDeserializer.__default.ToInt(minus#3, num#18); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (!JSON_mGrammar.Maybe.Empty_q(exp#3) ==> JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType) && (var num#21 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType); JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType) && (var sign#10 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType); JSON_mDeserializer.__default.ToInt#canCall(sign#10, num#21)))) && (var valueOrError1#3 := (if JSON_mGrammar.Maybe.Empty_q(exp#3) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#23 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType); (var sign#11 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#11, num#23)))); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#3)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (!JSON_mGrammar.Maybe.Empty_q(frac#9) ==> JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(frac#9)): DatatypeType) && (var num#22 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#9)): DatatypeType); JSON_mUtils_mViews_mCore.View__.Length#canCall(num#22) && (var pow10#7 := JSON_mUtils_mViews_mCore.View__.Length(num#22); JSON_mDeserializer.__default.ToInt#canCall(minus#3, num#22) && (var valueOrError2#7 := JSON_mDeserializer.__default.ToInt(minus#3, num#22); Wrappers.Result.IsFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) && (Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#7)) && (!Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) && Power.__default.Pow#canCall(LitInt(10), pow10#7))))))))))) && JSON_mDeserializer.__default.Number(Lit(js#0)) == (var minus#3, num#18, frac#9, exp#3 := JSON_mGrammar.jnumber.minus(Lit(js#0)), JSON_mGrammar.jnumber.num(Lit(js#0)), JSON_mGrammar.jnumber.frac(Lit(js#0)), JSON_mGrammar.jnumber.exp(Lit(js#0)); (var valueOrError0#3 := JSON_mDeserializer.__default.ToInt(minus#3, num#18); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError0#3) else (var n#3 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): int; (var valueOrError1#3 := (if JSON_mGrammar.Maybe.Empty_q(exp#3) then #Wrappers.Result.Success($Box(LitInt(0))) else (var num#19 := JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType); (var sign#9 := JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(exp#3)): DatatypeType); JSON_mDeserializer.__default.ToInt(sign#9, num#19)))); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError1#3) else (var e10#3 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3)): int; (if JSON_mGrammar.Maybe.Empty_q(frac#9) then #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(n#3, e10#3))) else (var num#20 := JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(frac#9)): DatatypeType); (var pow10#6 := JSON_mUtils_mViews_mCore.View__.Length(num#20); (var valueOrError2#6 := JSON_mDeserializer.__default.ToInt(minus#3, num#20); (if Wrappers.Result.IsFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#6) then Wrappers.Result.PropagateFailure(TInt, Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.Decimal(), valueOrError2#6) else (var frac#10 := $Unbox(Wrappers.Result.Extract(TInt, Tclass.JSON_mErrors.DeserializationError(), valueOrError2#6)): int; #Wrappers.Result.Success($Box(#JSON.Values.Decimal.Decimal(Mul(n#3, Power.__default.Pow($LS($LZ), reveal_Power._default.Pow, LitInt(10), pow10#6)) + frac#10, e10#3 - pow10#6)))))))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue($ly, js#0) } JSON_mDeserializer.__default.KeyValue#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jKeyValue()) ==> $Is(JSON_mDeserializer.__default.KeyValue($ly, js#0), Tclass.Wrappers.Result(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.KeyValue($LS($ly), js#0) } JSON_mDeserializer.__default.KeyValue#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mGrammar.jKeyValue.KeyValue_q(js#0) && JSON_mDeserializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k(js#0)) && (var valueOrError0#2 := JSON_mDeserializer.__default.String(JSON_mGrammar.jKeyValue.k(js#0)); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#2)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) && JSON_mGrammar.jKeyValue.KeyValue_q(js#0) && JSON_mDeserializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v(js#0)) && (var valueOrError1#2 := JSON_mDeserializer.__default.Value($ly, JSON_mGrammar.jKeyValue.v(js#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#2)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2))))) && JSON_mDeserializer.__default.KeyValue($LS($ly), js#0) == (var valueOrError0#2 := JSON_mDeserializer.__default.String(JSON_mGrammar.jKeyValue.k(js#0)); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#2) else (var k#2 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#2)): Seq; (var valueOrError1#2 := JSON_mDeserializer.__default.Value($ly, JSON_mGrammar.jKeyValue.v(js#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#2) else (var v#2 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#2)): DatatypeType; #Wrappers.Result.Success($Box(#_System._tuple#2._#Make2($Box(k#2), $Box(v#2)))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.KeyValue($LS($ly), Lit(js#0)) } JSON_mDeserializer.__default.KeyValue#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.jKeyValue()) ==> JSON_mGrammar.jKeyValue.KeyValue_q(Lit(js#0)) && JSON_mDeserializer.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit(js#0)))) && (var valueOrError0#3 := Lit(JSON_mDeserializer.__default.String(Lit(JSON_mGrammar.jKeyValue.k(Lit(js#0))))); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#3)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit(js#0)) && JSON_mDeserializer.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit(js#0)))) && (var valueOrError1#3 := Lit(JSON_mDeserializer.__default.Value($LS($ly), Lit(JSON_mGrammar.jKeyValue.v(Lit(js#0))))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#3)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3))))) && JSON_mDeserializer.__default.KeyValue($LS($ly), Lit(js#0)) == (var valueOrError0#3 := Lit(JSON_mDeserializer.__default.String(Lit(JSON_mGrammar.jKeyValue.k(Lit(js#0))))); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError0#3) else (var k#3 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#3)): Seq); (var valueOrError1#3 := Lit(JSON_mDeserializer.__default.Value($LS($ly), Lit(JSON_mGrammar.jKeyValue.v(Lit(js#0))))); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), valueOrError1#3) else (var v#3 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#3)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#_System._tuple#2._#Make2($Box(k#3), $Box(v#3)))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object($ly, js#0) } JSON_mDeserializer.__default.Object#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> $Is(JSON_mDeserializer.__default.Object($ly, js#0), Tclass.Wrappers.Result(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: { JSON_mDeserializer.__default.Object($LS($ly), js#0), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Object#canCall(js#0) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> (forall $l#14#d#0: DatatypeType :: $Is($l#14#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(js#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box($l#14#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#14#d#0) && JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#14#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(js#0) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#15#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#15#d#0): DatatypeType)): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $IsBox($l#15#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#15#d#0)), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)) && JSON_mDeserializer.__default.Object($LS($ly), js#0) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#13#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#13#d#0): DatatypeType)): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $IsBox($l#13#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#13#d#0)), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)));

axiom (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Object($LS($ly), Lit(js#0)), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Object#canCall(Lit(js#0)) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()))) ==> (forall $l#17#d#0: DatatypeType :: $Is($l#17#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && (Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $Box($l#17#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#17#d#0) && JSON_mDeserializer.__default.KeyValue#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#17#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#18#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#18#d#0): DatatypeType)): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $IsBox($l#18#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#18#d#0)), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))) && JSON_mDeserializer.__default.Object($LS($ly), Lit(js#0)) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $Box(JSON_mDeserializer.__default.KeyValue($l#16#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#16#d#0): DatatypeType)): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $IsBox($l#16#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#16#d#0)), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array($ly, js#0) } JSON_mDeserializer.__default.Array#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> $Is(JSON_mDeserializer.__default.Array($ly, js#0), Tclass.Wrappers.Result(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: { JSON_mDeserializer.__default.Array($LS($ly), js#0), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Array#canCall(js#0) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> (forall $l#14#d#0: DatatypeType :: $Is($l#14#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(js#0) && (Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $Box($l#14#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#14#d#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#14#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(js#0) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#15#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#15#d#0): DatatypeType)): DatatypeType))), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: $IsBox($l#15#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#15#d#0)), (lambda $l#15#heap#0: Heap, $l#15#d#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)) && JSON_mDeserializer.__default.Array($LS($ly), js#0) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#13#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#13#d#0): DatatypeType)): DatatypeType))), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: $IsBox($l#13#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(js#0), $l#13#d#0)), (lambda $l#13#heap#0: Heap, $l#13#d#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $ly)), JSON_mGrammar.Bracketed.data(js#0)));

axiom (forall $ly: LayerType, $Heap: Heap, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Array($LS($ly), Lit(js#0)), $IsGoodHeap($Heap) } JSON_mDeserializer.__default.Array#canCall(Lit(js#0)) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()))) ==> (forall $l#17#d#0: DatatypeType :: $Is($l#17#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && (Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $Box($l#17#d#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q($l#17#d#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t($l#17#d#0)): DatatypeType))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(js#0)) && Seq.__default.MapWithResult#canCall(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $Heap, Lit(AtLayer((lambda $l#18#ly#0: LayerType :: Handle1((lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#18#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#18#d#0): DatatypeType)): DatatypeType))), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: $IsBox($l#18#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#18#d#0)), (lambda $l#18#heap#0: Heap, $l#18#d#0: Box :: SetRef_to_SetBox((lambda $l#18#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))) && JSON_mDeserializer.__default.Array($LS($ly), Lit(js#0)) == Seq.__default.MapWithResult(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), reveal_Seq._default.MapWithResult, $Heap, Lit(AtLayer((lambda $l#16#ly#0: LayerType :: Handle1((lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $Box(JSON_mDeserializer.__default.Value($l#16#ly#0, $Unbox(JSON_mGrammar.Suffixed.t($Unbox($l#16#d#0): DatatypeType)): DatatypeType))), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: $IsBox($l#16#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains(JSON_mGrammar.Bracketed.data(Lit(js#0)), $l#16#d#0)), (lambda $l#16#heap#0: Heap, $l#16#d#0: Box :: SetRef_to_SetBox((lambda $l#16#o#0: ref :: false))))), $LS($ly))), Lit(JSON_mGrammar.Bracketed.data(Lit(js#0)))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value($ly, js#0) } JSON_mDeserializer.__default.Value#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Value()) ==> $Is(JSON_mDeserializer.__default.Value($ly, js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall $ly: LayerType, js#0: DatatypeType :: { JSON_mDeserializer.__default.Value($LS($ly), js#0) } JSON_mDeserializer.__default.Value#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Value()) ==> (!JSON_mGrammar.Value.Null_q(js#0) ==> (JSON_mGrammar.Value.Bool_q(js#0) ==> (var b#5 := JSON_mGrammar.Value.b(js#0); JSON_mDeserializer.__default.Bool#canCall(b#5))) && (!JSON_mGrammar.Value.Bool_q(js#0) ==> (JSON_mGrammar.Value.String_q(js#0) ==> (var str#5 := JSON_mGrammar.Value.str(js#0); JSON_mDeserializer.__default.String#canCall(str#5) && (var valueOrError0#5 := JSON_mDeserializer.__default.String(str#5); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#5)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#5))))) && (!JSON_mGrammar.Value.String_q(js#0) ==> (JSON_mGrammar.Value.Number_q(js#0) ==> (var dec#5 := JSON_mGrammar.Value.num(js#0); JSON_mDeserializer.__default.Number#canCall(dec#5) && (var valueOrError1#5 := JSON_mDeserializer.__default.Number(dec#5); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#5)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#5))))) && (!JSON_mGrammar.Value.Number_q(js#0) ==> (JSON_mGrammar.Value.Object_q(js#0) ==> (var obj#5 := JSON_mGrammar.Value.obj(js#0); JSON_mDeserializer.__default.Object#canCall(obj#5) && (var valueOrError2#5 := JSON_mDeserializer.__default.Object($ly, obj#5); Wrappers.Result.IsFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) && (Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#5))))) && (!JSON_mGrammar.Value.Object_q(js#0) ==> (var arr#5 := JSON_mGrammar.Value.arr(js#0); JSON_mDeserializer.__default.Array#canCall(arr#5) && (var valueOrError3#5 := JSON_mDeserializer.__default.Array($ly, arr#5); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#5) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#5) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#5)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#5) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#5))))))))) && JSON_mDeserializer.__default.Value($LS($ly), js#0) == (if JSON_mGrammar.Value.Null_q(js#0) then #Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Null()))) else (if JSON_mGrammar.Value.Bool_q(js#0) then (var b#4 := JSON_mGrammar.Value.b(js#0); #Wrappers.Result.Success($Box(#JSON.Values.JSON.Bool(JSON_mDeserializer.__default.Bool(b#4))))) else (if JSON_mGrammar.Value.String_q(js#0) then (var str#4 := JSON_mGrammar.Value.str(js#0); (var valueOrError0#4 := JSON_mDeserializer.__default.String(str#4); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#4) else (var s#4 := $Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#4)): Seq; #Wrappers.Result.Success($Box(#JSON.Values.JSON.String(s#4))))))) else (if JSON_mGrammar.Value.Number_q(js#0) then (var dec#4 := JSON_mGrammar.Value.num(js#0); (var valueOrError1#4 := JSON_mDeserializer.__default.Number(dec#4); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#4) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#4) else (var n#4 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#4)): DatatypeType; #Wrappers.Result.Success($Box(#JSON.Values.JSON.Number(n#4))))))) else (if JSON_mGrammar.Value.Object_q(js#0) then (var obj#4 := JSON_mGrammar.Value.obj(js#0); (var valueOrError2#4 := JSON_mDeserializer.__default.Object($ly, obj#4); (if Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#4) else (var o#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#4)): Seq; #Wrappers.Result.Success($Box(#JSON.Values.JSON.Object(o#4))))))) else (var arr#4 := JSON_mGrammar.Value.arr(js#0); (var valueOrError3#4 := JSON_mDeserializer.__default.Array($ly, arr#4); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#4) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#4) else (var a#4 := $Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#4)): Seq; #Wrappers.Result.Success($Box(#JSON.Values.JSON.Array(a#4)))))))))))));

axiom (forall $ly: LayerType, js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.Value($LS($ly), Lit(js#0)) } JSON_mDeserializer.__default.Value#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.Value()) ==> (!Lit(JSON_mGrammar.Value.Null_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(js#0))) ==> (var b#7 := Lit(JSON_mGrammar.Value.b(Lit(js#0))); JSON_mDeserializer.__default.Bool#canCall(b#7))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(js#0))) ==> (var str#7 := Lit(JSON_mGrammar.Value.str(Lit(js#0))); JSON_mDeserializer.__default.String#canCall(str#7) && (var valueOrError0#7 := JSON_mDeserializer.__default.String(str#7); Wrappers.Result.IsFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#7)) && (!Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7))))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(js#0))) ==> (var dec#7 := Lit(JSON_mGrammar.Value.num(Lit(js#0))); JSON_mDeserializer.__default.Number#canCall(dec#7) && (var valueOrError1#7 := JSON_mDeserializer.__default.Number(dec#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7))))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(js#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(js#0))) ==> (var obj#7 := Lit(JSON_mGrammar.Value.obj(Lit(js#0))); JSON_mDeserializer.__default.Object#canCall(obj#7) && (var valueOrError2#7 := JSON_mDeserializer.__default.Object($LS($ly), obj#7); Wrappers.Result.IsFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) && (Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#7))))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(js#0))) ==> (var arr#7 := Lit(JSON_mGrammar.Value.arr(Lit(js#0))); JSON_mDeserializer.__default.Array#canCall(arr#7) && (var valueOrError3#7 := JSON_mDeserializer.__default.Array($LS($ly), arr#7); Wrappers.Result.IsFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#7) && (Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#7) ==> Wrappers.Result.PropagateFailure#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#7)) && (!Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#7) ==> Wrappers.Result.Extract#canCall(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#7))))))))) && JSON_mDeserializer.__default.Value($LS($ly), Lit(js#0)) == (if JSON_mGrammar.Value.Null_q(Lit(js#0)) then #Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Null()))) else (if JSON_mGrammar.Value.Bool_q(Lit(js#0)) then (var b#6 := Lit(JSON_mGrammar.Value.b(Lit(js#0))); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Bool(Lit(JSON_mDeserializer.__default.Bool(b#6)))))))) else (if JSON_mGrammar.Value.String_q(Lit(js#0)) then (var str#6 := Lit(JSON_mGrammar.Value.str(Lit(js#0))); (var valueOrError0#6 := Lit(JSON_mDeserializer.__default.String(str#6)); (if Wrappers.Result.IsFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError0#6) else (var s#6 := Lit($Unbox(Wrappers.Result.Extract(TSeq(TChar), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6)): Seq); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.String(s#6))))))))) else (if JSON_mGrammar.Value.Number_q(Lit(js#0)) then (var dec#6 := Lit(JSON_mGrammar.Value.num(Lit(js#0))); (var valueOrError1#6 := Lit(JSON_mDeserializer.__default.Number(dec#6)); (if Wrappers.Result.IsFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError1#6) else (var n#6 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mValues.Decimal(), Tclass.JSON_mErrors.DeserializationError(), valueOrError1#6)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Number(n#6))))))))) else (if JSON_mGrammar.Value.Object_q(Lit(js#0)) then (var obj#6 := Lit(JSON_mGrammar.Value.obj(Lit(js#0))); (var valueOrError2#6 := Lit(JSON_mDeserializer.__default.Object($LS($ly), obj#6)); (if Wrappers.Result.IsFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError2#6) else (var o#6 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass._System.Tuple2(TSeq(TChar), Tclass.JSON_mValues.JSON())), Tclass.JSON_mErrors.DeserializationError(), valueOrError2#6)): Seq); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Object(o#6))))))))) else (var arr#6 := Lit(JSON_mGrammar.Value.arr(Lit(js#0))); (var valueOrError3#6 := Lit(JSON_mDeserializer.__default.Array($LS($ly), arr#6)); (if Wrappers.Result.IsFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#6) then Wrappers.Result.PropagateFailure(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mValues.JSON(), valueOrError3#6) else (var a#6 := Lit($Unbox(Wrappers.Result.Extract(TSeq(Tclass.JSON_mValues.JSON()), Tclass.JSON_mErrors.DeserializationError(), valueOrError3#6)): Seq); Lit(#Wrappers.Result.Success($Box(Lit(#JSON.Values.JSON.Array(a#6)))))))))))))));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.JSON(js#0) } JSON_mDeserializer.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> $Is(JSON_mDeserializer.__default.JSON(js#0), Tclass.Wrappers.Result(Tclass.JSON_mValues.JSON(), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall js#0: DatatypeType :: { JSON_mDeserializer.__default.JSON(js#0) } JSON_mDeserializer.__default.JSON#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mDeserializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType) && JSON_mDeserializer.__default.JSON(js#0) == JSON_mDeserializer.__default.Value($LS($LZ), $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mDeserializer.__default.JSON(Lit(js#0)) } JSON_mDeserializer.__default.JSON#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mDeserializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType)) && JSON_mDeserializer.__default.JSON(Lit(js#0)) == Lit(JSON_mDeserializer.__default.Value($LS($LZ), Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType))));

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$18x#0) } Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$18x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.View($Unbox($fh$18x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$18x#0) } Requires1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$18x#0) <==> JSON_mConcreteSyntax_mSpec.__default.View#requires($Unbox($fh$18x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$18x#0: Box :: { Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$18x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $fh$18x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$18x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.View($fh$18x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.View($fh$18x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mViews_mCore.View(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.View#Handle(), $Box($fh$18x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#requires(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, ts#0, fT#0) <==> (forall d#57: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#57) } { Seq#Contains(ts#0, d#57) } $IsBox(d#57, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#57) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#57))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, ts#0, fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#57: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#57) } { Seq#Contains(ts#0, d#57) } $IsBox(d#57, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#57) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#57))) ==> (Seq#Length(ts#0) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Seq#Drop(ts#0, LitInt(1)), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), ts#0, fT#0) == (if Seq#Length(ts#0) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(ts#0, LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $ly, Seq#Drop(ts#0, LitInt(1)), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), fT#0) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#58: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#58) } { Seq#Contains(ts#0, d#58) } $IsBox(d#58, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#58) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#58))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), fT#0) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), fT#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.ConcatBytes$T: Ty, $ly: LayerType, $Heap: Heap, ts#0: Seq, fT#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(ts#0), Lit(fT#0)) || ($IsGoodHeap($Heap) && $Is(ts#0, TSeq(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T)) && $Is(fT#0, Tclass._System.___hPartialFunc1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()))) && (forall d#59: Box :: { Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, fT#0, d#59) } { Seq#Contains(ts#0, d#59) } $IsBox(d#59, JSON.ConcreteSyntax.Spec._default.ConcatBytes$T) && Seq#Contains(ts#0, d#59) ==> Requires1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), d#59))) ==> (Seq#Length(Lit(ts#0)) != LitInt(0) ==> JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0))) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(ts#0), Lit(fT#0)) == (if Seq#Length(Lit(ts#0)) == LitInt(0) then Seq#Empty(): Seq else Seq#Append($Unbox(Apply1(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fT#0), Seq#Index(Lit(ts#0), LitInt(0)))): Seq, JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(JSON.ConcreteSyntax.Spec._default.ConcatBytes$T, $LS($ly), Lit(Seq#Drop(Lit(ts#0), LitInt(1))), Lit(fT#0)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) ==> (JSON_mConcreteSyntax_mSpec.__default.Bracketed#requires(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) <==> (forall d#57: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#57)) } $Is(d#57, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#57) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#57)))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#57: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#57)) } $Is(d#57, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#57) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#57)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(self#0)) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), JSON_mGrammar.Bracketed.data(self#0), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(self#0) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(self#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, self#0, fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.l(self#0)), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), JSON_mGrammar.Bracketed.data(self#0), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(JSON_mGrammar.Bracketed.r(self#0))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#58: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#58)) } $Is(d#58, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#58) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#58)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), fDatum#0) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), fDatum#0)), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall JSON.ConcreteSyntax.Spec._default.Bracketed$D: Ty, JSON.ConcreteSyntax.Spec._default.Bracketed$S: Ty, $Heap: Heap, self#0: DatatypeType, fDatum#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) || ($IsGoodHeap($Heap) && $Is(self#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(fDatum#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()))) && (forall d#59: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, fDatum#0, $Box(d#59)) } $Is(d#59, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S)) && DtRank(d#59) < DtRank(self#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(fDatum#0), $Box(d#59)))) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.ConcatBytes#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0)) && JSON_mGrammar.Bracketed.Bracketed_q(Lit(self#0)) && JSON_mConcreteSyntax_mSpec.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0)))) && JSON_mConcreteSyntax_mSpec.__default.Bracketed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S, Lit(self#0), Lit(fDatum#0)) == Seq#Append(Seq#Append(JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(self#0)))), JSON_mConcreteSyntax_mSpec.__default.ConcatBytes(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.Spec._default.Bracketed$D, JSON.ConcreteSyntax.Spec._default.Bracketed$S), $LS($LZ), Lit(JSON_mGrammar.Bracketed.data(Lit(self#0))), Lit(fDatum#0))), JSON_mConcreteSyntax_mSpec.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(self#0))))));

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$18x#0) } Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$18x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Frac($Unbox($fh$18x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$18x#0) } Requires1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$18x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Frac#requires($Unbox($fh$18x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$18x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$18x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $fh$18x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$18x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Frac($fh$18x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Frac($fh$18x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jfrac(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle(), $Box($fh$18x#0))): Seq);

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$18x#0) } Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$18x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Exp($Unbox($fh$18x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$18x#0) } Requires1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$18x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Exp#requires($Unbox($fh$18x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$18x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$18x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $fh$18x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$18x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Exp($fh$18x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Exp($fh$18x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jexp(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle(), $Box($fh$18x#0))): Seq);

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$18x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$18x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.StructuralView($Unbox($fh$18x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$18x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$18x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$18x#0) <==> JSON_mConcreteSyntax_mSpec.__default.StructuralView#requires($Unbox($fh$18x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$18x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$18x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $fh$18x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$18x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$18x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.StructuralView($fh$18x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mUtils_mViews_mCore.View()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.StructuralView#Handle(), $Box($fh$18x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#0) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#116#d#0: DatatypeType :: $Is($l#116#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#116#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#116#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#117#ly#0: LayerType :: Handle1((lambda $l#117#heap#0: Heap, $l#117#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#117#ly#0, $Unbox($l#117#d#0): DatatypeType))), (lambda $l#117#heap#0: Heap, $l#117#d#0: Box :: $IsBox($l#117#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#117#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#117#heap#0: Heap, $l#117#d#0: Box :: SetRef_to_SetBox((lambda $l#117#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), obj#0, Lit(AtLayer((lambda $l#115#ly#0: LayerType :: Handle1((lambda $l#115#heap#0: Heap, $l#115#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#115#ly#0, $Unbox($l#115#d#0): DatatypeType))), (lambda $l#115#heap#0: Heap, $l#115#d#0: Box :: $IsBox($l#115#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#115#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#115#heap#0: Heap, $l#115#d#0: Box :: SetRef_to_SetBox((lambda $l#115#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, obj#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) } JSON_mConcreteSyntax_mSpec.__default.Object#canCall(Lit(obj#0)) || $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) ==> (forall $l#119#d#0: DatatypeType :: $Is($l#119#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#119#d#0) < DtRank(obj#0) ==> JSON_mConcreteSyntax_mSpec.__default.Member#canCall($l#119#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#120#ly#0: LayerType :: Handle1((lambda $l#120#heap#0: Heap, $l#120#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#120#ly#0, $Unbox($l#120#d#0): DatatypeType))), (lambda $l#120#heap#0: Heap, $l#120#d#0: Box :: $IsBox($l#120#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#120#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#120#heap#0: Heap, $l#120#d#0: Box :: SetRef_to_SetBox((lambda $l#120#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), Lit(obj#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Lit(obj#0), Lit(AtLayer((lambda $l#118#ly#0: LayerType :: Handle1((lambda $l#118#heap#0: Heap, $l#118#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Member($l#118#ly#0, $Unbox($l#118#d#0): DatatypeType))), (lambda $l#118#heap#0: Heap, $l#118#d#0: Box :: $IsBox($l#118#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#118#d#0): DatatypeType) < DtRank(obj#0)), (lambda $l#118#heap#0: Heap, $l#118#d#0: Box :: SetRef_to_SetBox((lambda $l#118#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#0) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#116#d#0: DatatypeType :: $Is($l#116#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#116#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#116#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#117#ly#0: LayerType :: Handle1((lambda $l#117#heap#0: Heap, $l#117#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#117#ly#0, $Unbox($l#117#d#0): DatatypeType))), (lambda $l#117#heap#0: Heap, $l#117#d#0: Box :: $IsBox($l#117#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#117#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#117#heap#0: Heap, $l#117#d#0: Box :: SetRef_to_SetBox((lambda $l#117#o#0: ref :: false))))), $ly))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#0) == JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), arr#0, Lit(AtLayer((lambda $l#115#ly#0: LayerType :: Handle1((lambda $l#115#heap#0: Heap, $l#115#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#115#ly#0, $Unbox($l#115#d#0): DatatypeType))), (lambda $l#115#heap#0: Heap, $l#115#d#0: Box :: $IsBox($l#115#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#115#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#115#heap#0: Heap, $l#115#d#0: Box :: SetRef_to_SetBox((lambda $l#115#o#0: ref :: false))))), $ly))));

axiom (forall $ly: LayerType, arr#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) } JSON_mConcreteSyntax_mSpec.__default.Array#canCall(Lit(arr#0)) || $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) ==> (forall $l#119#d#0: DatatypeType :: $Is($l#119#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) ==> DtRank($l#119#d#0) < DtRank(arr#0) ==> JSON_mConcreteSyntax_mSpec.__default.Item#canCall($l#119#d#0)) && JSON_mConcreteSyntax_mSpec.__default.Bracketed#canCall(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#120#ly#0: LayerType :: Handle1((lambda $l#120#heap#0: Heap, $l#120#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#120#ly#0, $Unbox($l#120#d#0): DatatypeType))), (lambda $l#120#heap#0: Heap, $l#120#d#0: Box :: $IsBox($l#120#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#120#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#120#heap#0: Heap, $l#120#d#0: Box :: SetRef_to_SetBox((lambda $l#120#o#0: ref :: false))))), $LS($ly)))) && JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), Lit(arr#0)) == Lit(JSON_mConcreteSyntax_mSpec.__default.Bracketed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Lit(arr#0), Lit(AtLayer((lambda $l#118#ly#0: LayerType :: Handle1((lambda $l#118#heap#0: Heap, $l#118#d#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Item($l#118#ly#0, $Unbox($l#118#d#0): DatatypeType))), (lambda $l#118#heap#0: Heap, $l#118#d#0: Box :: $IsBox($l#118#d#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && DtRank($Unbox($l#118#d#0): DatatypeType) < DtRank(arr#0)), (lambda $l#118#heap#0: Heap, $l#118#d#0: Box :: SetRef_to_SetBox((lambda $l#118#o#0: ref :: false))))), $LS($ly))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(self#0) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (JSON_mGrammar.Value.Null_q(self#0) ==> (var n#73 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#73))) && (!JSON_mGrammar.Value.Null_q(self#0) ==> (JSON_mGrammar.Value.Bool_q(self#0) ==> (var b#73 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#73))) && (!JSON_mGrammar.Value.Bool_q(self#0) ==> (JSON_mGrammar.Value.String_q(self#0) ==> (var str#73 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#73))) && (!JSON_mGrammar.Value.String_q(self#0) ==> (JSON_mGrammar.Value.Number_q(self#0) ==> (var num#73 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#73))) && (!JSON_mGrammar.Value.Number_q(self#0) ==> (JSON_mGrammar.Value.Object_q(self#0) ==> (var obj#73 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#73))) && (!JSON_mGrammar.Value.Object_q(self#0) ==> (var arr#73 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#73))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), self#0) == (if JSON_mGrammar.Value.Null_q(self#0) then (var n#72 := JSON_mGrammar.Value.n(self#0); JSON_mConcreteSyntax_mSpec.__default.View(n#72)) else (if JSON_mGrammar.Value.Bool_q(self#0) then (var b#72 := JSON_mGrammar.Value.b(self#0); JSON_mConcreteSyntax_mSpec.__default.View(b#72)) else (if JSON_mGrammar.Value.String_q(self#0) then (var str#72 := JSON_mGrammar.Value.str(self#0); JSON_mConcreteSyntax_mSpec.__default.String(str#72)) else (if JSON_mGrammar.Value.Number_q(self#0) then (var num#72 := JSON_mGrammar.Value.num(self#0); JSON_mConcreteSyntax_mSpec.__default.Number(num#72)) else (if JSON_mGrammar.Value.Object_q(self#0) then (var obj#72 := JSON_mGrammar.Value.obj(self#0); JSON_mConcreteSyntax_mSpec.__default.Object($ly, obj#72)) else (var arr#72 := JSON_mGrammar.Value.arr(self#0); JSON_mConcreteSyntax_mSpec.__default.Array($ly, arr#72))))))));

axiom (forall $ly: LayerType, self#0: DatatypeType :: {:weight 3} { JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) } JSON_mConcreteSyntax_mSpec.__default.Value#canCall(Lit(self#0)) || $Is(self#0, Tclass.JSON_mGrammar.Value()) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (var n#75 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(n#75))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (var b#75 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.View#canCall(b#75))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (var str#75 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.String#canCall(str#75))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (var num#75 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Number#canCall(num#75))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(self#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var obj#75 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Object#canCall(obj#75))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(self#0))) ==> (var arr#75 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); JSON_mConcreteSyntax_mSpec.__default.Array#canCall(arr#75))))))) && JSON_mConcreteSyntax_mSpec.__default.Value($LS($ly), Lit(self#0)) == (if JSON_mGrammar.Value.Null_q(Lit(self#0)) then (var n#74 := Lit(JSON_mGrammar.Value.n(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(n#74))) else (if JSON_mGrammar.Value.Bool_q(Lit(self#0)) then (var b#74 := Lit(JSON_mGrammar.Value.b(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.View(b#74))) else (if JSON_mGrammar.Value.String_q(Lit(self#0)) then (var str#74 := Lit(JSON_mGrammar.Value.str(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.String(str#74))) else (if JSON_mGrammar.Value.Number_q(Lit(self#0)) then (var num#74 := Lit(JSON_mGrammar.Value.num(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Number(num#74))) else (if JSON_mGrammar.Value.Object_q(Lit(self#0)) then (var obj#74 := Lit(JSON_mGrammar.Value.obj(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Object($LS($ly), obj#74))) else (var arr#74 := Lit(JSON_mGrammar.Value.arr(Lit(self#0))); Lit(JSON_mConcreteSyntax_mSpec.__default.Array($LS($ly), arr#74)))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$18x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$18x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$18x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Value($ly, $Unbox($fh$18x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$18x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$18x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$18x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Value#requires($ly, $Unbox($fh$18x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$18x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$18x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $fh$18x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$18x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$18x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Value($ly, $fh$18x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($ly), $Box($fh$18x#0))): Seq);

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#87: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#87)) } $Is(d#87, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#87) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#87))) && ((forall d#87: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#87)) } $Is(d#87, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#87) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#87))) ==> (forall d#88: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#88)) } $Is(d#88, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#88) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#88)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, bracketed#0, pd0#0, pd1#0) <==> (forall d#87: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#87)) } $Is(d#87, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#87) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#87))) && (forall d#88: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#88)) } $Is(d#88, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#88) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#88))) && (forall d#89: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#89))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#89))): Seq } $Is(d#89, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#89) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#89))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#89))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#90: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#90)) } $Is(d#90, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#90) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#90))) && ((forall d#90: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#90)) } $Is(d#90, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#90) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#90))) ==> (forall d#91: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#91)) } $Is(d#91, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#91) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#91)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), pd0#0, pd1#0) <==> (forall d#90: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#90)) } $Is(d#90, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#90) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#90))) && (forall d#91: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#91)) } $Is(d#91, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#91) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#91))) && (forall d#92: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#92))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#92))): Seq } $Is(d#92, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#92) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#92))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#92))): Seq))));

axiom (forall JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S: Ty, $Heap: Heap, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType :: {:weight 3} { JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)), $IsGoodHeap($Heap) } JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires#canCall(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) || ($IsGoodHeap($Heap) && $Is(bracketed#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mUtils_mViews_mCore.View(), JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Tclass.JSON_mUtils_mViews_mCore.View())) && $Is(pd0#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()))) && $Is(pd1#0, Tclass._System.___hPartialFunc1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8())))) ==> (forall d#93: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#93)) } $Is(d#93, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#93) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#93))) && ((forall d#93: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#93)) } $Is(d#93, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#93) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#93))) ==> (forall d#94: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#94)) } $Is(d#94, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) ==> DtRank(d#94) < DtRank(bracketed#0) ==> Requires1#canCall(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#94)))) && (JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism__Requires(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S, Lit(bracketed#0), Lit(pd0#0), Lit(pd1#0)) <==> (forall d#93: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#93)) } $Is(d#93, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#93) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#93))) && (forall d#94: DatatypeType :: { Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#94)) } $Is(d#94, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#94) < DtRank(bracketed#0) ==> Requires1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#94))) && (forall d#95: DatatypeType :: { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd1#0, $Box(d#95))): Seq } { $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, pd0#0, $Box(d#95))): Seq } $Is(d#95, Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S)) && DtRank(d#95) < DtRank(bracketed#0) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd0#0), $Box(d#95))): Seq, $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism_Requires$S), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(pd1#0), $Box(d#95))): Seq))));

axiom (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.JSON(true, js#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(js#0, writer#0) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.Structural.before(js#0)) && (forall $l#31#wr#0: DatatypeType :: $Is($l#31#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $l#31#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#32#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#32#wr#0): DatatypeType))), (lambda $l#32#heap#0: Heap, $l#32#wr#0: Box :: $IsBox($l#32#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#32#heap#0: Heap, $l#32#wr#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#33#ly#0: LayerType :: Handle1((lambda $l#33#heap#0: Heap, $l#33#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#33#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#33#wr#0): DatatypeType))), (lambda $l#33#heap#0: Heap, $l#33#wr#0: Box :: $IsBox($l#33#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#33#heap#0: Heap, $l#33#wr#0: Box :: SetRef_to_SetBox((lambda $l#33#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)) && JSON_mZeroCopy_mSerializer.__default.JSON(true, js#0, writer#0) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.Structural.before(js#0)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#30#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Structural.t(js#0)): DatatypeType, $Unbox($l#30#wr#0): DatatypeType))), (lambda $l#30#heap#0: Heap, $l#30#wr#0: Box :: $IsBox($l#30#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#30#heap#0: Heap, $l#30#wr#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))), JSON_mGrammar.Structural.after(js#0)));

axiom (forall $Heap: Heap, js#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.JSON(true, Lit(js#0), Lit(writer#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.JSON#canCall(Lit(js#0), Lit(writer#0)) || ($IsGoodHeap($Heap) && $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))) && (forall $l#35#wr#0: DatatypeType :: $Is($l#35#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $l#35#wr#0)) && JSON_mUtils_mViews_mWriters.Writer__.Then#canCall($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#36#ly#0: LayerType :: Handle1((lambda $l#36#heap#0: Heap, $l#36#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#36#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#36#wr#0): DatatypeType))), (lambda $l#36#heap#0: Heap, $l#36#wr#0: Box :: $IsBox($l#36#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#36#heap#0: Heap, $l#36#wr#0: Box :: SetRef_to_SetBox((lambda $l#36#o#0: ref :: false))))), $LS($LZ)))) && JSON_mGrammar.Structural.Structural_q(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#37#ly#0: LayerType :: Handle1((lambda $l#37#heap#0: Heap, $l#37#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#37#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#37#wr#0): DatatypeType))), (lambda $l#37#heap#0: Heap, $l#37#wr#0: Box :: $IsBox($l#37#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#37#heap#0: Heap, $l#37#wr#0: Box :: SetRef_to_SetBox((lambda $l#37#o#0: ref :: false))))), $LS($LZ)))), Lit(JSON_mGrammar.Structural.after(Lit(js#0)))) && JSON_mZeroCopy_mSerializer.__default.JSON(true, Lit(js#0), Lit(writer#0)) == JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Then($Heap, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.Structural.before(Lit(js#0)))), Lit(AtLayer((lambda $l#34#ly#0: LayerType :: Handle1((lambda $l#34#heap#0: Heap, $l#34#wr#0: Box :: $Box(JSON_mZeroCopy_mSerializer.__default.Value($l#34#ly#0, reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Structural.t(Lit(js#0))): DatatypeType), $Unbox($l#34#wr#0): DatatypeType))), (lambda $l#34#heap#0: Heap, $l#34#wr#0: Box :: $IsBox($l#34#wr#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())), (lambda $l#34#heap#0: Heap, $l#34#wr#0: Box :: SetRef_to_SetBox((lambda $l#34#o#0: ref :: false))))), $LS($LZ)))), Lit(JSON_mGrammar.Structural.after(Lit(js#0)))));

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, v#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(v#0, writer#0) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (JSON_mGrammar.Value.Null_q(v#0) ==> (var n#13 := JSON_mGrammar.Value.n(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#13))) && (!JSON_mGrammar.Value.Null_q(v#0) ==> (JSON_mGrammar.Value.Bool_q(v#0) ==> (var b#13 := JSON_mGrammar.Value.b(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#13))) && (!JSON_mGrammar.Value.Bool_q(v#0) ==> (JSON_mGrammar.Value.String_q(v#0) ==> (var str#13 := JSON_mGrammar.Value.str(v#0); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#13, writer#0))) && (!JSON_mGrammar.Value.String_q(v#0) ==> (JSON_mGrammar.Value.Number_q(v#0) ==> (var num#13 := JSON_mGrammar.Value.num(v#0); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#13, writer#0))) && (!JSON_mGrammar.Value.Number_q(v#0) ==> (JSON_mGrammar.Value.Object_q(v#0) ==> (var obj#13 := JSON_mGrammar.Value.obj(v#0); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#13, writer#0))) && (!JSON_mGrammar.Value.Object_q(v#0) ==> (var arr#13 := JSON_mGrammar.Value.arr(v#0); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#13, writer#0))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, v#0, writer#0) == (if JSON_mGrammar.Value.Null_q(v#0) then (var n#12 := JSON_mGrammar.Value.n(v#0); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#12)) else (if JSON_mGrammar.Value.Bool_q(v#0) then (var b#12 := JSON_mGrammar.Value.b(v#0); (var wr#61 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#12); wr#61)) else (if JSON_mGrammar.Value.String_q(v#0) then (var str#12 := JSON_mGrammar.Value.str(v#0); (var wr#62 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#12, writer#0); wr#62)) else (if JSON_mGrammar.Value.Number_q(v#0) then (var num#12 := JSON_mGrammar.Value.num(v#0); (var wr#63 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#12, writer#0); wr#63)) else (if JSON_mGrammar.Value.Object_q(v#0) then (var obj#12 := JSON_mGrammar.Value.obj(v#0); (var wr#64 := JSON_mZeroCopy_mSerializer.__default.Object($ly, reveal_JSON.ZeroCopy.Serializer._default.Object, obj#12, writer#0); wr#64)) else (var arr#12 := JSON_mGrammar.Value.arr(v#0); (var wr#65 := JSON_mZeroCopy_mSerializer.__default.Array($ly, reveal_JSON.ZeroCopy.Serializer._default.Array, arr#12, writer#0); wr#65))))))));

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(v#0), writer#0) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (var n#15 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, n#15))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (var b#15 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, b#15))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (var str#15 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#15, writer#0))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (var num#15 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#15, writer#0))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var obj#15 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#15, writer#0))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var arr#15 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#15, writer#0))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), writer#0) == (if JSON_mGrammar.Value.Null_q(Lit(v#0)) then (var n#14 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, n#14)) else (if JSON_mGrammar.Value.Bool_q(Lit(v#0)) then (var b#14 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); (var wr#71 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, b#14); wr#71)) else (if JSON_mGrammar.Value.String_q(Lit(v#0)) then (var str#14 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); (var wr#72 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#14, writer#0); wr#72)) else (if JSON_mGrammar.Value.Number_q(Lit(v#0)) then (var num#14 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); (var wr#73 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#14, writer#0); wr#73)) else (if JSON_mGrammar.Value.Object_q(Lit(v#0)) then (var obj#14 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); (var wr#74 := JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#14, writer#0); wr#74)) else (var arr#14 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); (var wr#75 := JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#14, writer#0); wr#75))))))));

axiom (forall $ly: LayerType, v#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(v#0), Lit(writer#0)) || ($Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> (Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (var n#17 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), n#17))) && (!Lit(JSON_mGrammar.Value.Null_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (var b#17 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), b#17))) && (!Lit(JSON_mGrammar.Value.Bool_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (var str#17 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.String#canCall(str#17, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.String_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (var num#17 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#17, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.Number_q(Lit(v#0))) ==> (Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var obj#17 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#17, Lit(writer#0)))) && (!Lit(JSON_mGrammar.Value.Object_q(Lit(v#0))) ==> (var arr#17 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#17, Lit(writer#0)))))))) && JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), true, Lit(v#0), Lit(writer#0)) == (if JSON_mGrammar.Value.Null_q(Lit(v#0)) then (var n#16 := Lit(JSON_mGrammar.Value.n(Lit(v#0))); JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), n#16)) else (if JSON_mGrammar.Value.Bool_q(Lit(v#0)) then (var b#16 := Lit(JSON_mGrammar.Value.b(Lit(v#0))); (var wr#81 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), b#16); wr#81)) else (if JSON_mGrammar.Value.String_q(Lit(v#0)) then (var str#16 := Lit(JSON_mGrammar.Value.str(Lit(v#0))); (var wr#82 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, str#16, Lit(writer#0)); wr#82)) else (if JSON_mGrammar.Value.Number_q(Lit(v#0)) then (var num#16 := Lit(JSON_mGrammar.Value.num(Lit(v#0))); (var wr#83 := JSON_mZeroCopy_mSerializer.__default.Number(reveal_JSON.ZeroCopy.Serializer._default.Number, num#16, Lit(writer#0)); wr#83)) else (if JSON_mGrammar.Value.Object_q(Lit(v#0)) then (var obj#16 := Lit(JSON_mGrammar.Value.obj(Lit(v#0))); (var wr#84 := JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Object, obj#16, Lit(writer#0)); wr#84)) else (var arr#16 := Lit(JSON_mGrammar.Value.arr(Lit(v#0))); (var wr#85 := JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Array, arr#16, Lit(writer#0)); wr#85))))))));

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Number(true, num#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(num#0, writer#0) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, JSON_mGrammar.jnumber.minus(num#0)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)) && (var wr#19 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)); JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#19, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jfrac.JFrac_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#19, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType))) && (var wr#20 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#19, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) else wr#19); JSON_mGrammar.jnumber.JNumber_q(num#0) && (JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0)) ==> JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#20, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#20, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) && JSON_mGrammar.jnumber.JNumber_q(num#0) && JSON_mGrammar.jexp.JExp_q($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#20, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, num#0, writer#0) == (var wr#19 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, JSON_mGrammar.jnumber.minus(num#0)), JSON_mGrammar.jnumber.num(num#0)); (var wr#20 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.frac(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#19, JSON_mGrammar.jfrac.period($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)), JSON_mGrammar.jfrac.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.frac(num#0))): DatatypeType)) else wr#19); (var wr#21 := (if JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.jnumber.exp(num#0)) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#20, JSON_mGrammar.jexp.e($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.sign($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)), JSON_mGrammar.jexp.num($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.jnumber.exp(num#0))): DatatypeType)) else wr#20); wr#21))));

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(Lit(num#0), writer#0) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))) && (var wr#22 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#22, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#22, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType))))) && (var wr#23 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#22, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#22); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#23, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#23, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#23, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType))))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), writer#0) == (var wr#22 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, writer#0, Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); (var wr#23 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#22, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#22); (var wr#24 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#23, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) else wr#23); wr#24))));

axiom (forall num#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Number#canCall(Lit(num#0), Lit(writer#0)) || ($Is(num#0, Tclass.JSON_mGrammar.jnumber()) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))) && (var wr#25 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#25, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jfrac.JFrac_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#25, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType))))) && (var wr#26 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#25, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#25); JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && (Lit(JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))) ==> JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(wr#26, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#26, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) && JSON_mGrammar.jnumber.JNumber_q(Lit(num#0)) && JSON_mGrammar.jexp.JExp_q(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)) && JSON_mUtils_mViews_mWriters.Writer__.Append#canCall(JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#26, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType))))))) && JSON_mZeroCopy_mSerializer.__default.Number(true, Lit(num#0), Lit(writer#0)) == (var wr#25 := JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, Lit(writer#0), Lit(JSON_mGrammar.jnumber.minus(Lit(num#0)))), Lit(JSON_mGrammar.jnumber.num(Lit(num#0)))); (var wr#26 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#25, Lit(JSON_mGrammar.jfrac.period(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jfrac.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.frac(Lit(num#0))))): DatatypeType)))) else wr#25); (var wr#27 := (if JSON_mGrammar.Maybe.NonEmpty_q(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0)))) then JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, JSON_mUtils_mViews_mWriters.Writer__.Append(reveal_JSON.Utils.Views.Writers.Writer_.Append, wr#26, Lit(JSON_mGrammar.jexp.e(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.sign(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))), Lit(JSON_mGrammar.jexp.num(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.jnumber.exp(Lit(num#0))))): DatatypeType)))) else wr#26); wr#27))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, obj#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(obj#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(obj#0), writer#0) && (var wr#19 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0); JSON_mZeroCopy_mSerializer.__default.Members#canCall(obj#0, wr#19) && (var wr#20 := JSON_mZeroCopy_mSerializer.__default.Members($ly, reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#19); JSON_mGrammar.Bracketed.Bracketed_q(obj#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(obj#0), wr#20))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, obj#0, writer#0) == (var wr#19 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(obj#0), writer#0); (var wr#20 := JSON_mZeroCopy_mSerializer.__default.Members($ly, reveal_JSON.ZeroCopy.Serializer._default.Members, obj#0, wr#19); (var wr#21 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(obj#0), wr#20); wr#21))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(Lit(obj#0), writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0) && (var wr#22 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0); JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), wr#22) && (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#22); JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#23))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), writer#0) == (var wr#22 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), writer#0); (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#22); (var wr#24 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#23); wr#24))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Object#canCall(Lit(obj#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0)) && (var wr#25 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0))); JSON_mZeroCopy_mSerializer.__default.Members#canCall(Lit(obj#0), wr#25) && (var wr#26 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#25); JSON_mGrammar.Bracketed.Bracketed_q(Lit(obj#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#26))) && JSON_mZeroCopy_mSerializer.__default.Object($LS($ly), true, Lit(obj#0), Lit(writer#0)) == (var wr#25 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(obj#0))), Lit(writer#0))); (var wr#26 := JSON_mZeroCopy_mSerializer.__default.Members($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Members, Lit(obj#0), wr#25); (var wr#27 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(obj#0))), wr#26); wr#27))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, arr#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(arr#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.l(arr#0), writer#0) && (var wr#19 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0); JSON_mZeroCopy_mSerializer.__default.Items#canCall(arr#0, wr#19) && (var wr#20 := JSON_mZeroCopy_mSerializer.__default.Items($ly, reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#19); JSON_mGrammar.Bracketed.Bracketed_q(arr#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.Bracketed.r(arr#0), wr#20))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, arr#0, writer#0) == (var wr#19 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.l(arr#0), writer#0); (var wr#20 := JSON_mZeroCopy_mSerializer.__default.Items($ly, reveal_JSON.ZeroCopy.Serializer._default.Items, arr#0, wr#19); (var wr#21 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.Bracketed.r(arr#0), wr#20); wr#21))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(Lit(arr#0), writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0) && (var wr#22 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0); JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), wr#22) && (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#22); JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#23))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), writer#0) == (var wr#22 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), writer#0); (var wr#23 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#22); (var wr#24 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#23); wr#24))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Array#canCall(Lit(arr#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer())) ==> JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0)) && (var wr#25 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0))); JSON_mZeroCopy_mSerializer.__default.Items#canCall(Lit(arr#0), wr#25) && (var wr#26 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#25); JSON_mGrammar.Bracketed.Bracketed_q(Lit(arr#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#26))) && JSON_mZeroCopy_mSerializer.__default.Array($LS($ly), true, Lit(arr#0), Lit(writer#0)) == (var wr#25 := Lit(JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.l(Lit(arr#0))), Lit(writer#0))); (var wr#26 := JSON_mZeroCopy_mSerializer.__default.Items($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Items, Lit(arr#0), wr#25); (var wr#27 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.Bracketed.r(Lit(arr#0))), wr#26); wr#27))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Member($ly, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Member#requires($ly, $Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $fh$2x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Member($ly, $fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Member($ly, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Member#Handle($ly), $Box($fh$2x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$2x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$2x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Item($ly, $Unbox($fh$2x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$2x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$2x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Item#requires($ly, $Unbox($fh$2x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$2x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$2x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $fh$2x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$2x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Item($ly, $fh$2x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Item($ly, $fh$2x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Item#Handle($ly), $Box($fh$2x#0))): Seq);

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires($ly, obj#0, members#0, writer#0) } $Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.MembersSpec#requires($ly, obj#0, members#0, writer#0) <==> (forall j#9: int :: { $Unbox(Seq#Index(members#0, j#9)): DatatypeType } LitInt(0) <= j#9 && j#9 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#9)): DatatypeType) < DtRank(obj#0))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, members#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#9: int :: { $Unbox(Seq#Index(members#0, j#9)): DatatypeType } LitInt(0) <= j#9 && j#9 < Seq#Length(members#0) ==> DtRank($Unbox(Seq#Index(members#0, j#9)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#6, last#6 := Seq#Take(members#0, Seq#Length(members#0) - 1), $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(obj#0, butLast#6, writer#0) && (var wr#13 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, butLast#6, writer#0); JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, last#6, wr#13)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), obj#0, members#0, writer#0) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#6, last#6 := Seq#Take(members#0, Seq#Length(members#0) - 1), $Unbox(Seq#Index(members#0, Seq#Length(members#0) - 1)): DatatypeType; (var wr#13 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($ly, obj#0, butLast#6, writer#0); (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Member($ly, reveal_JSON.ZeroCopy.Serializer._default.Member, obj#0, last#6, wr#13); wr#14)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(members#0), writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#10: int :: { $Unbox(Seq#Index(members#0, j#10)): DatatypeType } LitInt(0) <= j#10 && j#10 < Seq#Length(Lit(members#0)) ==> DtRank($Unbox(Seq#Index(Lit(members#0), j#10)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#7, last#7 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), butLast#7, writer#0) && (var wr#15 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#7, writer#0); JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), last#7, wr#15)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), writer#0) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#7, last#7 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; (var wr#15 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#7, writer#0); (var wr#16 := JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Member, Lit(obj#0), last#7, wr#15); wr#16)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, members#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), Lit(members#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(members#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#11: int :: { $Unbox(Seq#Index(members#0, j#11)): DatatypeType } LitInt(0) <= j#11 && j#11 < Seq#Length(Lit(members#0)) ==> DtRank($Unbox(Seq#Index(Lit(members#0), j#11)): DatatypeType) < DtRank(obj#0))) ==> (!Seq#Equal(members#0, Seq#Empty(): Seq) ==> (var butLast#8, last#8 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.MembersSpec#canCall(Lit(obj#0), butLast#8, Lit(writer#0)) && (var wr#17 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#8, Lit(writer#0)); JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), last#8, wr#17)))) && JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), Lit(members#0), Lit(writer#0)) == (if Seq#Equal(members#0, Seq#Empty(): Seq) then writer#0 else (var butLast#8, last#8 := Seq#Take(Lit(members#0), Seq#Length(Lit(members#0)) - 1), $Unbox(Seq#Index(Lit(members#0), Seq#Length(Lit(members#0)) - 1)): DatatypeType; (var wr#17 := JSON_mZeroCopy_mSerializer.__default.MembersSpec($LS($ly), Lit(obj#0), butLast#8, Lit(writer#0)); (var wr#18 := JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Member, Lit(obj#0), last#8, wr#17); wr#18)))));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.SequenceSpec#requires(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, items#0, spec#0, impl#0, writer#0) <==> (forall item#18: Box, wr#19: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#18, $Box(wr#19)) } $IsBox(item#18, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#19, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#18) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#18, $Box(wr#19))) && (forall item#19: Box, wr#20: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#20), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#19)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#19, $Box(wr#20))): DatatypeType } $IsBox(item#19, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#20, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#19) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#19, $Box(wr#20))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#20), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#19)): Seq)))));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, items#0, spec#0, impl#0, writer#0) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#18: Box, wr#19: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#18, $Box(wr#19)) } $IsBox(item#18, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#19, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#18) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#18, $Box(wr#19))) && (forall item#19: Box, wr#20: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#20), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#19)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#19, $Box(wr#20))): DatatypeType } $IsBox(item#19, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#20, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#19) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#19, $Box(wr#20))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#20), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#19)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), v#0, items#0, spec#0, impl#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#7 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $ly, v#0, Seq#Take(items#0, Seq#Length(items#0) - 1), spec#0, impl#0, writer#0); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), Seq#Index(items#0, Seq#Length(items#0) - 1), $Box(writer#7))): DatatypeType)));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#20: Box, wr#21: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#20, $Box(wr#21)) } $IsBox(item#20, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#21, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#20) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), item#20, $Box(wr#21))) && (forall item#21: Box, wr#22: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#22), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#21)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#21, $Box(wr#22))): DatatypeType } $IsBox(item#21, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#22, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#21) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), item#21, $Box(wr#22))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#22), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#21)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), spec#0, impl#0, writer#0)) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), spec#0, impl#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#8 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), spec#0, impl#0, writer#0); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(Lit(v#0)), Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Box(writer#8))): DatatypeType)));

axiom (forall JSON.ZeroCopy.Serializer._default.SequenceSpec$T: Ty, $ly: LayerType, $Heap: Heap, v#0: DatatypeType, items#0: Seq, spec#0: HandleType, impl#0: HandleType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)) || ($IsGoodHeap($Heap) && $Is(v#0, Tclass.JSON_mGrammar.Value()) && $Is(items#0, TSeq(JSON.ZeroCopy.Serializer._default.SequenceSpec$T)) && $Is(spec#0, Tclass._System.___hTotalFunc1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()))) && $Is(impl#0, Tclass._System.___hPartialFunc3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall item#22: Box, wr#23: DatatypeType :: { Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#22, $Box(wr#23)) } $IsBox(item#22, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#23, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#22) ==> Requires3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), item#22, $Box(wr#23))) && (forall item#23: Box, wr#24: DatatypeType :: { Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#24), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, spec#0, item#23)): Seq) } { $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, impl#0, $Box(v#0), item#23, $Box(wr#24))): DatatypeType } $IsBox(item#23, JSON.ZeroCopy.Serializer._default.SequenceSpec$T) && $Is(wr#24, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && Seq#Contains(items#0, item#23) ==> Seq#Equal(JSON_mUtils_mViews_mWriters.Writer__.Bytes($Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), item#23, $Box(wr#24))): DatatypeType), Seq#Append(JSON_mUtils_mViews_mWriters.Writer__.Bytes(wr#24), $Unbox(Apply1(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(spec#0), item#23)): Seq)))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> JSON_mZeroCopy_mSerializer.__default.SequenceSpec#canCall(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), Lit(spec#0), Lit(impl#0), Lit(writer#0))) && JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Lit(items#0), Lit(spec#0), Lit(impl#0), Lit(writer#0)) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var writer#9 := JSON_mZeroCopy_mSerializer.__default.SequenceSpec(JSON.ZeroCopy.Serializer._default.SequenceSpec$T, $LS($ly), Lit(v#0), Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), Lit(spec#0), Lit(impl#0), Lit(writer#0)); $Unbox(Apply3(Tclass.JSON_mGrammar.Value(), JSON.ZeroCopy.Serializer._default.SequenceSpec$T, Tclass.JSON_mUtils_mViews_mWriters.Writer(), Tclass.JSON_mUtils_mViews_mWriters.Writer(), $Heap, Lit(impl#0), $Box(Lit(v#0)), Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Box(writer#9))): DatatypeType)));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires($ly, arr#0, items#0, writer#0) } $Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) ==> (JSON_mZeroCopy_mSerializer.__default.ItemsSpec#requires($ly, arr#0, items#0, writer#0) <==> (forall j#9: int :: { $Unbox(Seq#Index(items#0, j#9)): DatatypeType } LitInt(0) <= j#9 && j#9 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#9)): DatatypeType) < DtRank(arr#0))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, items#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#9: int :: { $Unbox(Seq#Index(items#0, j#9)): DatatypeType } LitInt(0) <= j#9 && j#9 < Seq#Length(items#0) ==> DtRank($Unbox(Seq#Index(items#0, j#9)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#6, last#6 := Seq#Take(items#0, Seq#Length(items#0) - 1), $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(arr#0, butLast#6, writer#0) && (var wr#13 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, butLast#6, writer#0); JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, last#6, wr#13)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), arr#0, items#0, writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#6, last#6 := Seq#Take(items#0, Seq#Length(items#0) - 1), $Unbox(Seq#Index(items#0, Seq#Length(items#0) - 1)): DatatypeType; (var wr#13 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($ly, arr#0, butLast#6, writer#0); (var wr#14 := JSON_mZeroCopy_mSerializer.__default.Item($ly, reveal_JSON.ZeroCopy.Serializer._default.Item, arr#0, last#6, wr#13); wr#14)))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), writer#0) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(items#0), writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#10: int :: { $Unbox(Seq#Index(items#0, j#10)): DatatypeType } LitInt(0) <= j#10 && j#10 < Seq#Length(Lit(items#0)) ==> DtRank($Unbox(Seq#Index(Lit(items#0), j#10)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#7, last#7 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), butLast#7, writer#0) && (var wr#15 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#7, writer#0); JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), last#7, wr#15)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), writer#0) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#7, last#7 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; (var wr#15 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#7, writer#0); (var wr#16 := JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Item, Lit(arr#0), last#7, wr#15); wr#16)))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, items#0: Seq, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), Lit(items#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(items#0, TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && (forall j#11: int :: { $Unbox(Seq#Index(items#0, j#11)): DatatypeType } LitInt(0) <= j#11 && j#11 < Seq#Length(Lit(items#0)) ==> DtRank($Unbox(Seq#Index(Lit(items#0), j#11)): DatatypeType) < DtRank(arr#0))) ==> (!Seq#Equal(items#0, Seq#Empty(): Seq) ==> (var butLast#8, last#8 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; JSON_mZeroCopy_mSerializer.__default.ItemsSpec#canCall(Lit(arr#0), butLast#8, Lit(writer#0)) && (var wr#17 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#8, Lit(writer#0)); JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), last#8, wr#17)))) && JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), Lit(items#0), Lit(writer#0)) == (if Seq#Equal(items#0, Seq#Empty(): Seq) then writer#0 else (var butLast#8, last#8 := Seq#Take(Lit(items#0), Seq#Length(Lit(items#0)) - 1), $Unbox(Seq#Index(Lit(items#0), Seq#Length(Lit(items#0)) - 1)): DatatypeType; (var wr#17 := JSON_mZeroCopy_mSerializer.__default.ItemsSpec($LS($ly), Lit(arr#0), butLast#8, Lit(writer#0)); (var wr#18 := JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Item, Lit(arr#0), last#8, wr#17); wr#18)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, obj#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(obj#0, m#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0) && (var wr#25 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#25) && (var wr#26 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#25); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#26) && (var wr#27 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#26); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#27))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, obj#0, m#0, writer#0) == (var wr#25 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); (var wr#26 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#25); (var wr#27 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#26); (var wr#28 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#27 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#27)); wr#28)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), m#0, writer#0) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.String#canCall(JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0) && (var wr#29 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#29) && (var wr#30 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#29); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mGrammar.jKeyValue.KeyValue_q($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#30) && (var wr#31 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#30); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#31))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), m#0, writer#0) == (var wr#29 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, JSON_mGrammar.jKeyValue.k($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), writer#0); (var wr#30 := JSON_mZeroCopy_mSerializer.__default.StructuralView(JSON_mGrammar.jKeyValue.colon($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#29); (var wr#31 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, JSON_mGrammar.jKeyValue.v($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType), wr#30); (var wr#32 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#31 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#31)); wr#32)))));

axiom (forall $ly: LayerType, obj#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), Lit(m#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Member#canCall(Lit(obj#0), Lit(m#0), Lit(writer#0)) || ($Is(obj#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(obj#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.String#canCall(Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)) && (var wr#33 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#33) && (var wr#34 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#33); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mGrammar.jKeyValue.KeyValue_q(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#34) && (var wr#35 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#34); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && (!Lit(JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#35))))) && JSON_mZeroCopy_mSerializer.__default.Member($LS($ly), true, Lit(obj#0), Lit(m#0), Lit(writer#0)) == (var wr#33 := JSON_mZeroCopy_mSerializer.__default.String(reveal_JSON.ZeroCopy.Serializer._default.String, Lit(JSON_mGrammar.jKeyValue.k(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), Lit(writer#0)); (var wr#34 := JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit(JSON_mGrammar.jKeyValue.colon(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#33); (var wr#35 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit(JSON_mGrammar.jKeyValue.v(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType))), wr#34); (var wr#36 := (if JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0)))) then wr#35 else JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#35)); wr#36)))));

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, arr#0, m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(arr#0, m#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0) && (var wr#13 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#13))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, arr#0, m#0, writer#0) == (var wr#13 := JSON_mZeroCopy_mSerializer.__default.Value($ly, reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); (var wr#14 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#13 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#13)); wr#14)));

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), m#0, writer#0) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), m#0, writer#0) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.Value#canCall($Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0) && (var wr#15 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); JSON_mGrammar.Suffixed.Suffixed_q(m#0) && (!JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(m#0) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#15))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), m#0, writer#0) == (var wr#15 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, $Unbox(JSON_mGrammar.Suffixed.t(m#0)): DatatypeType, writer#0); (var wr#16 := (if JSON_mGrammar.Maybe.Empty_q(JSON_mGrammar.Suffixed.suffix(m#0)) then wr#15 else JSON_mZeroCopy_mSerializer.__default.StructuralView($Unbox(JSON_mGrammar.Maybe.t(JSON_mGrammar.Suffixed.suffix(m#0))): DatatypeType, wr#15)); wr#16)));

axiom (forall $ly: LayerType, arr#0: DatatypeType, m#0: DatatypeType, writer#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), Lit(m#0), Lit(writer#0)) } JSON_mZeroCopy_mSerializer.__default.Item#canCall(Lit(arr#0), Lit(m#0), Lit(writer#0)) || ($Is(arr#0, Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())) && $Is(m#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && $Is(writer#0, Tclass.JSON_mUtils_mViews_mWriters.Writer()) && DtRank(m#0) < DtRank(arr#0)) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.Value#canCall(Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)) && (var wr#17 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)); JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && (!Lit(JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))) ==> JSON_mGrammar.Suffixed.Suffixed_q(Lit(m#0)) && JSON_mZeroCopy_mSerializer.__default.StructuralView#canCall(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#17))) && JSON_mZeroCopy_mSerializer.__default.Item($LS($ly), true, Lit(arr#0), Lit(m#0), Lit(writer#0)) == (var wr#17 := JSON_mZeroCopy_mSerializer.__default.Value($LS($ly), reveal_JSON.ZeroCopy.Serializer._default.Value, Lit($Unbox(JSON_mGrammar.Suffixed.t(Lit(m#0))): DatatypeType), Lit(writer#0)); (var wr#18 := (if JSON_mGrammar.Maybe.Empty_q(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0)))) then wr#17 else JSON_mZeroCopy_mSerializer.__default.StructuralView(Lit($Unbox(JSON_mGrammar.Maybe.t(Lit(JSON_mGrammar.Suffixed.suffix(Lit(m#0))))): DatatypeType), wr#17)); wr#18)));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(cs#0, err#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)) && (var valueOrError0#30 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#30)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) && (var cs#31 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#31)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, cs#0, err#0) == (var valueOrError0#30 := JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), cs#0, $Box(err#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#30) else (var cs#31 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#31)))))));

axiom (forall cs#0: DatatypeType, err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.Get#canCall(Lit(cs#0), Lit(err#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(err#0, Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mUtils_mCursors.Cursor__.Get#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0))) && (var valueOrError0#31 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#31)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) && (var cs#32 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#32)))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Get(true, Lit(cs#0), Lit(err#0)) == (var valueOrError0#31 := Lit(JSON_mUtils_mCursors.Cursor__.Get(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), $Box(Lit(err#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#31) else (var cs#32 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#32)))))))));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$15x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$15x#0) == $Box(JSON_mGrammar.__default.Blank_q($Unbox($fh$15x#0): int)));

axiom (forall $heap: Heap, $fh$15x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$15x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$15x#0) <==> JSON_mGrammar.__default.Blank_q#requires($Unbox($fh$15x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$15x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$15x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $fh$15x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$15x#0: int :: { JSON_mGrammar.__default.Blank_q($fh$15x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Blank_q($fh$15x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Blank_q#Handle(), $Box($fh$15x#0))): bool);

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $reveal: bool, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && $IsAlloc(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError()), $Heap) && (forall cs#1: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)) } $Is(cs#1, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#1)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $Unbox($l#21#st#0): DatatypeType, JSON_mUtils_mParsers.Parser__.spec(parser#0)))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: $IsBox($l#21#st#0, Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T))), (lambda $l#21#heap#0: Heap, $l#21#st#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, $reveal, cs#0, parser#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) ==> (JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#requires(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) <==> (forall cs#123: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#123)) } $Is(cs#123, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#123)))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, cs#0, parser#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#123: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#123)) } $Is(cs#123, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#123)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#124 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mParsers.Parser__.Parser_q(parser#0) && (var valueOrError0#30 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#124))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#30)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) && (var cs#125 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#125))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, cs#0, parser#0) == (var before#30, cs#124 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var valueOrError0#30 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#124))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#30) else (var val#30, cs#125 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#30)): DatatypeType); (var after#30, cs#126 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#125))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#125)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#30, val#30, after#30)), cs#126)))))))));

axiom (forall JSON.ZeroCopy.Deserializer.Core._default.Structural$T: Ty, $Heap: Heap, cs#0: DatatypeType, parser#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Lit(cs#0), Lit(parser#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(parser#0, Tclass.JSON_mUtils_mParsers.Parser(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, Tclass.JSON_mErrors.DeserializationError())) && (forall cs#127: DatatypeType :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.Parser__.fn(parser#0), $Box(cs#127)) } $Is(cs#127, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#127)))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#128 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mParsers.Parser__.Parser_q(Lit(parser#0)) && (var valueOrError0#31 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#128))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#31)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) && (var cs#129 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31)): DatatypeType); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#129))))) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T, true, Lit(cs#0), Lit(parser#0)) == (var before#31, cs#128 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var valueOrError0#31 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.Parser__.fn(Lit(parser#0))), $Box(cs#128))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(JSON.ZeroCopy.Deserializer.Core._default.Structural$T)), valueOrError0#31) else (var val#31, cs#129 := JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31)): DatatypeType), JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(JSON.ZeroCopy.Deserializer.Core._default.Structural$T), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#31)): DatatypeType); (var after#31, cs#130 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#129))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#129)); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#31, val#31, after#31)), cs#130)))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()), JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), cs#0, Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#st#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt(), $Unbox($l#20#st#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#st#0: Box :: $IsBox($l#20#st#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))), (lambda $l#20#heap#0: Heap, $l#20#st#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mCore.jopt()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#0) && (var cs#91 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#91) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#91)) && (var cs#92 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#91))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#92))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(cs#0) == (var before#30, cs#91 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#0)); (var val#30, cs#92 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#91)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#91))); (var after#30, cs#93 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#92))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#92)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#30, $Box(val#30), after#30)), cs#93)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(Lit(cs#0)) && (var cs#94 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); JSON_mUtils_mCursors.Cursor__.SkipByte#canCall(cs#94) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#94)) && (var cs#95 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#94))); JSON_mZeroCopy_mDeserializer_mCore.__default.WS#canCall(cs#95))) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(Lit(cs#0)) == (var before#31, cs#94 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, Lit(cs#0))); (var val#31, cs#95 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#94)))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipByte(cs#94))); (var after#31, cs#96 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#95))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mCore.__default.WS(reveal_JSON.ZeroCopy.Deserializer.Core._default.WS, cs#95)); #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Structural.Structural(before#31, $Box(val#31), after#31)), cs#96)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(sp#0) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#32: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#32) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#32))): Seq } $Is(t#32, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(sp#0) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#32)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(sp#0) <==> (forall t#32: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#32) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#32))): Seq } $Is(t#32, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#32))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#32)))));

axiom (forall $Heap: Heap, sp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid#canCall(Lit(sp#0)) || ($IsGoodHeap($Heap) && $Is(sp#0, Tclass.JSON_mUtils_mParsers.SubParser(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mErrors.DeserializationError()))) ==> (forall t#33: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#33) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#33))): Seq } $Is(t#33, Tclass.JSON_mGrammar.Value()) ==> JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(sp#0)) && JSON_mConcreteSyntax_mSpec.__default.Value#canCall(t#33)) && (JSON_mZeroCopy_mDeserializer_mCore.__default.ValueParserValid(Lit(sp#0)) <==> (forall t#33: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#33) } { $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, JSON_mUtils_mParsers.SubParser__.spec(sp#0), $Box(t#33))): Seq } $Is(t#33, Tclass.JSON_mGrammar.Value()) ==> Seq#Equal($Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.spec(Lit(sp#0))), $Box(t#33))): Seq, JSON_mConcreteSyntax_mSpec.__default.Value($LS($LZ), t#33)))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$3x#0)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#requires($fh$3x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mZeroCopy_mDeserializer_mSequenceParams.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequenceParams.__default.ElementSpec#Handle(), $fh$3x#0)): Seq);

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0) } Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0) == $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$4x#0)));

axiom (forall $heap: Heap, $fh$4x#0: Box :: { Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0) } Requires1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0) <==> JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#requires($fh$4x#0));

axiom (forall $bx: Box, $heap: Heap, $fh$4x#0: Box :: { Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0)[$bx] } Reads1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$4x#0: Box :: { JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$4x#0), $IsGoodHeap($heap) } JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec($fh$4x#0) == $Unbox(Apply1(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle(), $fh$4x#0)): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Open(true, Lit(cs#0)) == (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#7)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, cs#0) == (var valueOrError0#6 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#6) else (var cs#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#7)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()) && (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#8)))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Close(true, Lit(cs#0)) == (var valueOrError0#7 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#7) else (var cs#8 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#8)))))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($Unbox($fh$3x#0): Seq)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#requires($Unbox($fh$3x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$3x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec($fh$3x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#26#ly#0: LayerType :: Handle1((lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#26#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: $IsBox($l#26#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#26#heap#0: Heap, $l#26#c#0: Box :: SetRef_to_SetBox((lambda $l#26#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#27#ly#0: LayerType :: Handle1((lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#27#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: $IsBox($l#27#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#27#heap#0: Heap, $l#27#c#0: Box :: SetRef_to_SetBox((lambda $l#27#o#0: ref :: false))))), $LS($LZ))))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#28#ly#0: LayerType :: Handle1((lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#28#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: $IsBox($l#28#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#28#heap#0: Heap, $l#28#c#0: Box :: SetRef_to_SetBox((lambda $l#28#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#7 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#7));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#30#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#8 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#8));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#15: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#15) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#15)) } $Is(e#15, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#15)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#15))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#13#ly#0: LayerType :: Handle1((lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#13#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: $IsBox($l#13#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#13#heap#0: Heap, $l#13#c#0: Box :: SetRef_to_SetBox((lambda $l#13#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#14#ly#0: LayerType :: Handle1((lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#14#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: $IsBox($l#14#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#14#heap#0: Heap, $l#14#c#0: Box :: SetRef_to_SetBox((lambda $l#14#o#0: ref :: false))))), $LS($LZ)))) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#6 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#7 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#6)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#7)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#15#ly#0: LayerType :: Handle1((lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#15#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: $IsBox($l#15#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#15#heap#0: Heap, $l#15#c#0: Box :: SetRef_to_SetBox((lambda $l#15#o#0: ref :: false))))), $LS($LZ))))) && (forall e#17: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#17) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#17)) } $Is(e#17, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#17)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#17)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#7 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#8 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#7)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#8)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && (forall e#8: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#8) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) } $Is(e#8, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#8)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#8)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#6 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#7 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#6)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#7)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && (forall e#9: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#9) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#9)) } $Is(e#9, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#9)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#9)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#7 := Lit(#JSON.Grammar.Suffixed.Suffixed(Lit(JSON_mUtils_mCursors.Split.t(Lit(elem#0))), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#8 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#7)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#8)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#56#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#56#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> $IsAlloc(JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#57#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#57#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#14: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#14) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) } $Is(e#14, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#14)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#14)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#9 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (var elem#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#9) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#9)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#9) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#9)) && (var sep#27 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#9)); JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) && (var s0#9 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType); (s0#9 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType)) && (s0#9 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#28 := sep#27; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28) && (var elems#10 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#10)))) && (!(s0#9 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#9 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#27) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType)) && (s0#9 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#29 := sep#27; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29) && (var elems'#9 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#9, sep#29))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#9 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#9) else (var elem#9 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#9)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#27 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#9)); (var s0#9 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType); (if s0#9 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#28 := sep#27; (var elems#10 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#28); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#10))) else (if s0#9 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#27)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#29 := sep#27; (var elems'#9 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#9, sep#29); (var bracketed#9 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#9, sep#29); #Wrappers.Result.Success($Box(bracketed#9))))) else (var separator#9 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#10 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#9)), s0#9))); pr#10)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#58#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#15: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#15) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#15)) } $Is(e#15, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#15)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#15)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#10 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var elem#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#10) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#10)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#10) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#10)) && (var sep#30 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#10)); JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) && (var s0#10 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType); (s0#10 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType)) && (s0#10 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#31 := sep#30; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31) && (var elems#11 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs0#0, json#0, open#0, elems#11)))) && (!(s0#10 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#10 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#30) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType)) && (s0#10 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#32 := sep#30; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32) && (var elems'#10 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#10, sep#32))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#10 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#10) else (var elem#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#10)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#30 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#10)); (var s0#10 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType); (if s0#10 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#31 := sep#30; (var elems#11 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#31); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs0#0, json#0, open#0, elems#11))) else (if s0#10 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#30)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#32 := sep#30; (var elems'#10 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#10, sep#32); (var bracketed#10 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs0#0, open#0, elems'#10, sep#32); #Wrappers.Result.Success($Box(bracketed#10))))) else (var separator#10 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#11 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#10)), s0#10))); pr#11)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), $Unbox($l#59#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: $IsBox($l#59#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()))), (lambda $l#59#heap#0: Heap, $l#59#c#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mSequences.__default.SuffixedElementsSpec#Handle()) && (forall e#16: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#16) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#16)) } $Is(e#16, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#16)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#16)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#11 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var elem#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#11) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#11)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#11) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#11)) && (var sep#33 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#11)); JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) && (var s0#11 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType); (s0#11 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType)) && (s0#11 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#34 := sep#33; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34) && (var elems#12 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#12)))) && (!(s0#11 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#11 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#33) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType)) && (s0#11 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#35 := sep#33; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35) && (var elems'#11 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35); JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#11, sep#35))))))))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#11 := JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.Element(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#11) else (var elem#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#11)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#33 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#11)); (var s0#11 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType); (if s0#11 == JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#34 := sep#33; (var elems#12 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#34); JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#12))) else (if s0#11 == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#33)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#35 := sep#33; (var elems'#11 := JSON_mZeroCopy_mDeserializer_mSequences.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#11, sep#35); (var bracketed#11 := JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#11, sep#35); #Wrappers.Result.Success($Box(bracketed#11))))) else (var separator#11 := JSON_mZeroCopy_mDeserializer_mSequences.__default.SEPARATOR(); (var pr#12 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE())), $Box(separator#11)), s0#11))); pr#12)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Open($reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle($reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Close($reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle($reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) && (var open#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#6) && (var elems#6 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#6)); JSON_mUtils_mCursors.Split.SP_q(open#6) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#6)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#6) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#6), p#6) && (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#6), p#6); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) && (var close#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(cs#0, open#6, elems#6, close#6)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(cs#0, json#0, open#6, elems#6)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#6) else (var open#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#6)): DatatypeType; (var elems#6 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#6)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#6)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#6 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#6 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#6), p#6); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#6) else (var close#6 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#6)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, cs#0, open#6, elems#6, close#6))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, cs#0, json#0, open#6, elems#6)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) && (var open#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#7) && (var elems#7 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#7)); JSON_mUtils_mCursors.Split.SP_q(open#7) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#7)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#7) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), JSON_mUtils_mCursors.Split.cs(open#7), p#7) && (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#7), p#7); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) && (var close#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts#canCall(Lit(cs#0), open#7, elems#7, close#7)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) != JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#7, elems#7)))))) && JSON_mZeroCopy_mDeserializer_mSequences.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Open), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError0#7) else (var open#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#7)): DatatypeType; (var elems#7 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#7)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#7)) == JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.__default.CLOSE() then (var p#7 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mSequences.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Close), JSON_mZeroCopy_mDeserializer_mSequences.__default.SpecViewClose()); (var valueOrError1#7 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#7), p#7); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jopen(), Tclass.JSON__mZeroCopy__mDeserializer__mSequences.Params.Abs.TElement(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), valueOrError1#7) else (var close#7 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mSequences.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#7)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mSequences.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Sequences._default.BracketedFromParts, Lit(cs#0), open#7, elems#7, close#7))))))) else JSON_mZeroCopy_mDeserializer_mSequences.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Sequences._default.Elements, Lit(cs#0), Lit(json#0), open#7, elems#7)))))));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$9x#0: Box, $fh$9x#1: Box :: { Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$9x#0, $fh$9x#1) } Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$9x#0, $fh$9x#1) == $Box(JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$9x#0): bool, $Unbox($fh$9x#1): int)));

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$9x#0: Box, $fh$9x#1: Box :: { Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$9x#0, $fh$9x#1) } Requires2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$9x#0, $fh$9x#1) <==> JSON_mUtils_mLexers_mStrings.__default.StringBody#requires(JSON.Utils.Lexers.Strings._default.StringBody$R, $Unbox($fh$9x#0): bool, $Unbox($fh$9x#1): int));

axiom (forall $bx: Box, JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$9x#0: Box, $fh$9x#1: Box :: { Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$9x#0, $fh$9x#1)[$bx] } Reads2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $fh$9x#0, $fh$9x#1)[$bx] <==> false);

axiom (forall JSON.Utils.Lexers.Strings._default.StringBody$R: Ty, $heap: Heap, $fh$9x#0: bool, $fh$9x#1: int :: { JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$9x#0, $fh$9x#1), $IsGoodHeap($heap) } JSON_mUtils_mLexers_mStrings.__default.StringBody(JSON.Utils.Lexers.Strings._default.StringBody$R, $fh$9x#0, $fh$9x#1) == $Unbox(Apply2(TBool, Tclass.BoundedInts.opt__byte(), Tclass.JSON_mUtils_mLexers_mCore.LexerResult(TBool, JSON.Utils.Lexers.Strings._default.StringBody$R), $heap, JSON_mUtils_mLexers_mStrings.__default.StringBody#Handle(JSON.Utils.Lexers.Strings._default.StringBody$R), $Box($fh$9x#0), $Box($fh$9x#1))): DatatypeType);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))) && (var valueOrError0#18 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (var cs#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#19)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0) == (var valueOrError0#18 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(34))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#18) else (var cs#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#19)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34))) && (var valueOrError0#19 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (var cs#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#20)))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0)) == (var valueOrError0#19 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(34)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#19) else (var cs#20 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#20)))))))));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$9x#0) } Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$9x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.String($Unbox($fh$9x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$9x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$9x#0) } Requires1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$9x#0) <==> JSON_mConcreteSyntax_mSpec.__default.String#requires($Unbox($fh$9x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$9x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$9x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $fh$9x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$9x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.String($fh$9x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.String($fh$9x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jstring(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.String#Handle(), $Box($fh$9x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#0) && (var valueOrError0#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (var cs#55 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#55) && (var valueOrError1#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#55); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) && (var contents#36 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#36) && (var cs#56 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#36)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#56) && (var valueOrError2#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#56); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, cs#0) == (var valueOrError0#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#18) else (var lq#18, cs#55 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType); (var valueOrError1#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#55); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#18) else (var contents#36 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18)): DatatypeType; (var contents#37, cs#56 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#36))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#36)); (var valueOrError2#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#56); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#18) else (var rq#18, cs#57 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#18, contents#37, rq#18)), cs#57))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(Lit(cs#0)) && (var valueOrError0#19 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (var cs#58 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType); JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody#canCall(cs#58) && (var valueOrError1#19 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#58); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) && (var contents#38 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(contents#38) && (var cs#59 := JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#38)); JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote#canCall(cs#59) && (var valueOrError2#19 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#59); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19)))))))))) && JSON_mZeroCopy_mDeserializer_mStrings.__default.String(true, Lit(cs#0)) == (var valueOrError0#19 := Lit(JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError0#19) else (var lq#19, cs#58 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType)); (var valueOrError1#19 := JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(reveal_JSON.ZeroCopy.Deserializer.Strings._default.StringBody, cs#58); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError1#19) else (var contents#38 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19)): DatatypeType; (var contents#39, cs#59 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(contents#38))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(contents#38)); (var valueOrError2#19 := JSON_mZeroCopy_mDeserializer_mStrings.__default.Quote(cs#59); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), valueOrError2#19) else (var rq#19, cs#60 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jquote()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jstring.JString(lq#19, contents#39, rq#19)), cs#60))))))))))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$5x#0) } Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$5x#0) == $Box(JSON_mGrammar.__default.Digit_q($Unbox($fh$5x#0): int)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$5x#0) } Requires1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$5x#0) <==> JSON_mGrammar.__default.Digit_q#requires($Unbox($fh$5x#0): int));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: int :: { JSON_mGrammar.__default.Digit_q($fh$5x#0), $IsGoodHeap($heap) } JSON_mGrammar.__default.Digit_q($fh$5x#0) <==> $Unbox(Apply1(Tclass.BoundedInts.uint8(), TBool, $heap, JSON_mGrammar.__default.Digit_q#Handle(), $Box($fh$5x#0))): bool);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(cs#0) && (var sp#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); JSON_mUtils_mCursors.Split.SP_q(sp#10) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#10)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#10 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#10)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#10)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, cs#0) == (var sp#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, cs#0); (var valueOrError0#10 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#10)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#10) else #Wrappers.Result.Success($Box(sp#10))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits#canCall(Lit(cs#0)) && (var sp#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(sp#11) && Wrappers.__default.Need#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#11)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))) && (var valueOrError0#11 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#11)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#11)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(true, Lit(cs#0)) == (var sp#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Digits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Digits, Lit(cs#0)); (var valueOrError0#11 := Wrappers.__default.Need(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), !JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#11)): DatatypeType), $Box(Lit(#JSON.Utils.Cursors.CursorError.OtherError($Box(Lit(#JSON.Errors.DeserializationError.EmptyNumber())))))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jdigits()), valueOrError0#11) else #Wrappers.Result.Success($Box(sp#11))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box($Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint8())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box($Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.BoundedInts.uint8())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box($Unbox($l#60#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, Tclass.BoundedInts.uint8())), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box($Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.BoundedInts.uint8())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(45))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#56#ly#0: LayerType :: Handle1((lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $Box($Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#56#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: $IsBox($l#56#c#0, Tclass.BoundedInts.uint8())), (lambda $l#56#heap#0: Heap, $l#56#c#0: Box :: SetRef_to_SetBox((lambda $l#56#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#57#ly#0: LayerType :: Handle1((lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $Box($Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#57#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: $IsBox($l#57#c#0, Tclass.BoundedInts.uint8())), (lambda $l#57#heap#0: Heap, $l#57#c#0: Box :: SetRef_to_SetBox((lambda $l#57#o#0: ref :: false))))), $LS($LZ))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, cs#0) == JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $Box($Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#54#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: $IsBox($l#54#c#0, Tclass.BoundedInts.uint8())), (lambda $l#54#heap#0: Heap, $l#54#c#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $Box($Unbox($l#60#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#60#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: $IsBox($l#60#c#0, Tclass.BoundedInts.uint8())), (lambda $l#60#heap#0: Heap, $l#60#c#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $Box($Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#61#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: $IsBox($l#61#c#0, Tclass.BoundedInts.uint8())), (lambda $l#61#heap#0: Heap, $l#61#c#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($LZ)))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(true, Lit(cs#0)) == Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#58#ly#0: LayerType :: Handle1((lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $Box($Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(45))) || $Unbox($l#58#c#0): int == char#ToInt(Lit(char#FromInt(43))))), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: $IsBox($l#58#c#0, Tclass.BoundedInts.uint8())), (lambda $l#58#heap#0: Heap, $l#58#c#0: Box :: SetRef_to_SetBox((lambda $l#58#o#0: ref :: false))))), $LS($LZ))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box($Unbox($l#66#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, Tclass.BoundedInts.uint8())), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box($Unbox($l#67#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.BoundedInts.uint8())), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))))) && (var sp#10 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#68#ly#0: LayerType :: Handle1((lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $Box($Unbox($l#68#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: $IsBox($l#68#c#0, Tclass.BoundedInts.uint8())), (lambda $l#68#heap#0: Heap, $l#68#c#0: Box :: SetRef_to_SetBox((lambda $l#68#o#0: ref :: false))))), $LS($LZ))))); JSON_mUtils_mCursors.Split.SP_q(sp#10) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#10)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#10) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#10)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, cs#0) == (var sp#10 := JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box($Unbox($l#64#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, Tclass.BoundedInts.uint8())), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#10)): DatatypeType) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, JSON_mUtils_mCursors.Split.cs(sp#10)) else #Wrappers.Result.Success($Box(sp#10)))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#71#ly#0: LayerType :: Handle1((lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $Box($Unbox($l#71#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: $IsBox($l#71#c#0, Tclass.BoundedInts.uint8())), (lambda $l#71#heap#0: Heap, $l#71#c#0: Box :: SetRef_to_SetBox((lambda $l#71#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#72#ly#0: LayerType :: Handle1((lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $Box($Unbox($l#72#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: $IsBox($l#72#c#0, Tclass.BoundedInts.uint8())), (lambda $l#72#heap#0: Heap, $l#72#c#0: Box :: SetRef_to_SetBox((lambda $l#72#o#0: ref :: false))))), $LS($LZ)))))) && (var sp#11 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#73#ly#0: LayerType :: Handle1((lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $Box($Unbox($l#73#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: $IsBox($l#73#c#0, Tclass.BoundedInts.uint8())), (lambda $l#73#heap#0: Heap, $l#73#c#0: Box :: SetRef_to_SetBox((lambda $l#73#o#0: ref :: false))))), $LS($LZ))))))); JSON_mUtils_mCursors.Split.SP_q(sp#11) && (JSON_mUtils_mViews_mCore.View__.Empty_q($Unbox(JSON_mUtils_mCursors.Split.t(sp#11)): DatatypeType) ==> JSON_mUtils_mCursors.Split.SP_q(sp#11) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt#canCall(JSON_mUtils_mCursors.Split.cs(sp#11)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(true, Lit(cs#0)) == (var sp#11 := Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#69#ly#0: LayerType :: Handle1((lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $Box($Unbox($l#69#c#0): int == char#ToInt(Lit(char#FromInt(48))))), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: $IsBox($l#69#c#0, Tclass.BoundedInts.uint8())), (lambda $l#69#heap#0: Heap, $l#69#c#0: Box :: SetRef_to_SetBox((lambda $l#69#o#0: ref :: false))))), $LS($LZ))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(Lit($Unbox(JSON_mUtils_mCursors.Split.t(sp#11)): DatatypeType)) then JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonZeroInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonZeroInt, Lit(JSON_mUtils_mCursors.Split.cs(sp#11))) else #Wrappers.Result.Success($Box(sp#11)))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#75#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#75#heap#0: Heap, $l#75#exp#0: Box :: $IsBox($l#75#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#75#heap#0: Heap, $l#75#exp#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box($Unbox($l#78#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#78#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, Tclass.BoundedInts.uint8())), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box($Unbox($l#79#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#79#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, Tclass.BoundedInts.uint8())), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))))) && (var e#10, cs#31 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $Box($Unbox($l#80#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#80#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $IsBox($l#80#c#0, Tclass.BoundedInts.uint8())), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $Box($Unbox($l#80#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#80#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $IsBox($l#80#c#0, Tclass.BoundedInts.uint8())), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#10) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#31) && (var cs#32 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#31)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#32) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#32); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, cs#0) == (var e#10, cs#31 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box($Unbox($l#76#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#76#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, Tclass.BoundedInts.uint8())), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box($Unbox($l#76#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#76#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, Tclass.BoundedInts.uint8())), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#10) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#31))) else (var sign#10, cs#32 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#31))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#31)); (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#32); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#10) else (var num#10, cs#33 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#10, sign#10, num#10)))), cs#33))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box($Unbox($l#83#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#83#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, Tclass.BoundedInts.uint8())), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $Box($Unbox($l#84#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#84#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $IsBox($l#84#c#0, Tclass.BoundedInts.uint8())), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ)))))) && (var e#11, cs#34 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box($Unbox($l#85#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#85#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, Tclass.BoundedInts.uint8())), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box($Unbox($l#85#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#85#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, Tclass.BoundedInts.uint8())), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(e#11) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign#canCall(cs#34) && (var cs#35 := JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#34)); JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#35) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#35); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(true, Lit(cs#0)) == (var e#11, cs#34 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box($Unbox($l#81#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#81#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.BoundedInts.uint8())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box($Unbox($l#81#c#0): int == char#ToInt(Lit(char#FromInt(101))) || $Unbox($l#81#c#0): int == char#ToInt(Lit(char#FromInt(69))))), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.BoundedInts.uint8())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(e#11) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#34))) else (var sign#11, cs#35 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#34))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalSign(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalSign, cs#34)); (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#35); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), valueOrError0#11) else (var num#11, cs#36 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jexp.JExp(e#11, sign#11, num#11)))), cs#36))))))))));

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap)) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#75#ly#0: LayerType :: Handle1((lambda $l#75#heap#0: Heap, $l#75#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#75#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#75#heap#0: Heap, $l#75#frac#0: Box :: $IsBox($l#75#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#75#heap#0: Heap, $l#75#frac#0: Box :: SetRef_to_SetBox((lambda $l#75#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac($reveal, cs#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(cs#0, Lit(AtLayer((lambda $l#78#ly#0: LayerType :: Handle1((lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $Box($Unbox($l#78#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: $IsBox($l#78#c#0, Tclass.BoundedInts.uint8())), (lambda $l#78#heap#0: Heap, $l#78#c#0: Box :: SetRef_to_SetBox((lambda $l#78#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#79#ly#0: LayerType :: Handle1((lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $Box($Unbox($l#79#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: $IsBox($l#79#c#0, Tclass.BoundedInts.uint8())), (lambda $l#79#heap#0: Heap, $l#79#c#0: Box :: SetRef_to_SetBox((lambda $l#79#o#0: ref :: false))))), $LS($LZ))))) && (var period#10, cs#21 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $Box($Unbox($l#80#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $IsBox($l#80#c#0, Tclass.BoundedInts.uint8())), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#80#ly#0: LayerType :: Handle1((lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $Box($Unbox($l#80#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: $IsBox($l#80#c#0, Tclass.BoundedInts.uint8())), (lambda $l#80#heap#0: Heap, $l#80#c#0: Box :: SetRef_to_SetBox((lambda $l#80#o#0: ref :: false))))), $LS($LZ)))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#10) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#21) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#21); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, cs#0) == (var period#10, cs#21 := $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box($Unbox($l#76#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, Tclass.BoundedInts.uint8())), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(JSON_mUtils_mCursors.Cursor__.Split(JSON_mUtils_mCursors.Cursor__.SkipIf(cs#0, Lit(AtLayer((lambda $l#76#ly#0: LayerType :: Handle1((lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $Box($Unbox($l#76#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: $IsBox($l#76#c#0, Tclass.BoundedInts.uint8())), (lambda $l#76#heap#0: Heap, $l#76#c#0: Box :: SetRef_to_SetBox((lambda $l#76#o#0: ref :: false))))), $LS($LZ)))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#10) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#21))) else (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#21); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#10) else (var num#10, cs#22 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#10, num#10)))), cs#22)))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.SkipIf#canCall(Lit(cs#0), Lit(AtLayer((lambda $l#83#ly#0: LayerType :: Handle1((lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $Box($Unbox($l#83#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: $IsBox($l#83#c#0, Tclass.BoundedInts.uint8())), (lambda $l#83#heap#0: Heap, $l#83#c#0: Box :: SetRef_to_SetBox((lambda $l#83#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.Split#canCall(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#84#ly#0: LayerType :: Handle1((lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $Box($Unbox($l#84#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: $IsBox($l#84#c#0, Tclass.BoundedInts.uint8())), (lambda $l#84#heap#0: Heap, $l#84#c#0: Box :: SetRef_to_SetBox((lambda $l#84#o#0: ref :: false))))), $LS($LZ)))))) && (var period#11, cs#23 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box($Unbox($l#85#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, Tclass.BoundedInts.uint8())), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#85#ly#0: LayerType :: Handle1((lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $Box($Unbox($l#85#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: $IsBox($l#85#c#0, Tclass.BoundedInts.uint8())), (lambda $l#85#heap#0: Heap, $l#85#c#0: Box :: SetRef_to_SetBox((lambda $l#85#o#0: ref :: false))))), $LS($LZ)))))))); !JSON_mUtils_mViews_mCore.View__.Empty_q(period#11) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits#canCall(cs#23) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#23); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(true, Lit(cs#0)) == (var period#11, cs#23 := $Unbox(JSON_mUtils_mCursors.Split.t(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box($Unbox($l#81#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.BoundedInts.uint8())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ))))))))): DatatypeType, JSON_mUtils_mCursors.Split.cs(Lit(JSON_mUtils_mCursors.Cursor__.Split(Lit(JSON_mUtils_mCursors.Cursor__.SkipIf(Lit(cs#0), Lit(AtLayer((lambda $l#81#ly#0: LayerType :: Handle1((lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $Box($Unbox($l#81#c#0): int == char#ToInt(Lit(char#FromInt(46))))), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: $IsBox($l#81#c#0, Tclass.BoundedInts.uint8())), (lambda $l#81#heap#0: Heap, $l#81#c#0: Box :: SetRef_to_SetBox((lambda $l#81#o#0: ref :: false))))), $LS($LZ)))))))); (if JSON_mUtils_mViews_mCore.View__.Empty_q(period#11) then #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Maybe.Empty())), cs#23))) else (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.NonEmptyDigits(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NonEmptyDigits, cs#23); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), valueOrError0#11) else (var num#11, cs#24 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnum()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Maybe.NonEmpty($Box(#JSON.Grammar.jfrac.JFrac(period#11, num#11)))), cs#24)))))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Number($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Number#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Number($fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Number($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jnumber(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Number#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $IsAlloc(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus()), $Heap) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $IsAlloc(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), $Heap) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $IsAlloc(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), $Heap) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && $IsAlloc(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), $Heap) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#38#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#38#heap#0: Heap, $l#38#frac#0: Box :: $IsBox($l#38#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#38#heap#0: Heap, $l#38#frac#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#39#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#39#heap#0: Heap, $l#39#exp#0: Box :: $IsBox($l#39#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#39#heap#0: Heap, $l#39#exp#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jnumber(), JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), cs#0, JSON_mConcreteSyntax_mSpec.__default.Number#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts($reveal, cs#0, minus#0, num#0, frac#0, exp#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) ==> (JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#requires(cs#0, minus#0, num#0, frac#0, exp#0) <==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#40#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#40#heap#0: Heap, $l#40#frac#0: Box :: $IsBox($l#40#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#40#heap#0: Heap, $l#40#frac#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#41#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#41#heap#0: Heap, $l#41#exp#0: Box :: $IsBox($l#41#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#41#heap#0: Heap, $l#41#exp#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#0, num#0, frac#0, exp#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), minus#0, cs#0, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), num#0, JSON_mUtils_mCursors.Split.cs(minus#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), frac#0, JSON_mUtils_mCursors.Split.cs(num#0), Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#40#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#40#heap#0: Heap, $l#40#frac#0: Box :: $IsBox($l#40#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#40#heap#0: Heap, $l#40#frac#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), exp#0, JSON_mUtils_mCursors.Split.cs(frac#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#41#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#41#heap#0: Heap, $l#41#exp#0: Box :: $IsBox($l#41#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#41#heap#0: Heap, $l#41#exp#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(minus#0) && JSON_mUtils_mCursors.Split.SP_q(num#0) && JSON_mUtils_mCursors.Split.SP_q(frac#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mUtils_mCursors.Split.SP_q(exp#0) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, cs#0, minus#0, num#0, frac#0, exp#0) == (var sp#11 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jnumber.JNumber($Unbox(JSON_mUtils_mCursors.Split.t(minus#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(num#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(frac#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(exp#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(exp#0)); sp#11));

axiom (forall $Heap: Heap, cs#0: DatatypeType, minus#0: DatatypeType, num#0: DatatypeType, frac#0: DatatypeType, exp#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(minus#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jminus())) && $Is(num#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint())) && $Is(frac#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))) && $Is(exp#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))) && JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.jminus(), Lit(minus#0), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jint(), Lit(num#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(minus#0))), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()), Lit(frac#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(num#0))), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#frac#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jfrac(), $Unbox($l#42#frac#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Frac#Handle()))), (lambda $l#42#heap#0: Heap, $l#42#frac#0: Box :: $IsBox($l#42#frac#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac()))), (lambda $l#42#heap#0: Heap, $l#42#frac#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()), Lit(exp#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(frac#0))), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#exp#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Maybe(Tclass.JSON_mGrammar.jexp(), $Unbox($l#43#exp#0): DatatypeType, JSON_mConcreteSyntax_mSpec.__default.Exp#Handle()))), (lambda $l#43#heap#0: Heap, $l#43#exp#0: Box :: $IsBox($l#43#exp#0, Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp()))), (lambda $l#43#heap#0: Heap, $l#43#exp#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(minus#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(num#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(frac#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(exp#0)) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(true, Lit(cs#0), Lit(minus#0), Lit(num#0), Lit(frac#0), Lit(exp#0)) == (var sp#12 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jnumber.JNumber(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(minus#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(num#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(frac#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(exp#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(exp#0))))); sp#12));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(cs#0) && (var minus#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); JSON_mUtils_mCursors.Split.SP_q(minus#10) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#10)) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#10)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var num#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#10) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#10)) && (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#10)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (var frac#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#10) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#10)) && (var valueOrError2#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#10)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) && (var exp#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(cs#0, minus#10, num#10, frac#10, exp#10))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, cs#0) == (var minus#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, cs#0); (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#10)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#10) else (var num#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#10)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#10) else (var frac#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; (var valueOrError2#10 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#10)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#10) else (var exp#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, cs#0, minus#10, num#10, frac#10, exp#10))))))))))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus#canCall(Lit(cs#0)) && (var minus#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); JSON_mUtils_mCursors.Split.SP_q(minus#11) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt#canCall(JSON_mUtils_mCursors.Split.cs(minus#11)) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#11)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var num#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(num#11) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac#canCall(JSON_mUtils_mCursors.Split.cs(num#11)) && (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#11)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (var frac#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(frac#11) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp#canCall(JSON_mUtils_mCursors.Split.cs(frac#11)) && (var valueOrError2#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#11)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) && (var exp#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)): DatatypeType; JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts#canCall(Lit(cs#0), minus#11, num#11, frac#11, exp#11))))))))))) && JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(true, Lit(cs#0)) == (var minus#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.OptionalMinus(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.OptionalMinus, Lit(cs#0)); (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.TrimmedInt(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.TrimmedInt, JSON_mUtils_mCursors.Split.cs(minus#11)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError0#11) else (var num#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jint()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Frac(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Frac, JSON_mUtils_mCursors.Split.cs(num#11)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError1#11) else (var frac#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jfrac())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; (var valueOrError2#11 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Exp(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Exp, JSON_mUtils_mCursors.Split.cs(frac#11)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), valueOrError2#11) else (var exp#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Maybe(Tclass.JSON_mGrammar.jexp())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mNumbers.__default.NumberFromParts(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.NumberFromParts, Lit(cs#0), minus#11, num#11, frac#11, exp#11))))))))))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))) && (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#12)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) && (var cs#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#13)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(cs#0) == (var valueOrError0#12 := JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), cs#0, Lit(char#FromInt(58))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#12) else (var cs#13 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#12)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#13)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertChar#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58))) && (var valueOrError0#13 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#13)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) && (var cs#14 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#14)))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon(Lit(cs#0)) == (var valueOrError0#13 := Lit(JSON_mUtils_mCursors.Cursor__.AssertChar(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(char#FromInt(58)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#13) else (var cs#14 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#13)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#14)))))))));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$6x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$6x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$6x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.jKeyValue(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $IsAlloc(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), $Heap) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $IsAlloc(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), $Heap) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#22#ly#0: LayerType :: Handle1((lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#22#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: $IsBox($l#22#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#22#heap#0: Heap, $l#22#c#0: Box :: SetRef_to_SetBox((lambda $l#22#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts($reveal, cs#0, k#0, colon#0, v#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) ==> (JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#requires(cs#0, k#0, colon#0, v#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#0, colon#0, v#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), k#0, cs#0, JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), colon#0, JSON_mUtils_mCursors.Split.cs(k#0), Lit(AtLayer((lambda $l#23#ly#0: LayerType :: Handle1((lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#23#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: $IsBox($l#23#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#23#heap#0: Heap, $l#23#c#0: Box :: SetRef_to_SetBox((lambda $l#23#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), v#0, JSON_mUtils_mCursors.Split.cs(colon#0), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(k#0) && JSON_mUtils_mCursors.Split.SP_q(colon#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mUtils_mCursors.Split.SP_q(v#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, cs#0, k#0, colon#0, v#0) == (var sp#13 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.jKeyValue.KeyValue($Unbox(JSON_mUtils_mCursors.Split.t(k#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(colon#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(v#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(v#0)); sp#13));

axiom (forall $Heap: Heap, cs#0: DatatypeType, k#0: DatatypeType, colon#0: DatatypeType, v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(k#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring())) && $Is(colon#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))) && $Is(v#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jstring(), Lit(k#0), Lit(cs#0), JSON_mConcreteSyntax_mSpec.__default.String#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()), Lit(colon#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(k#0))), Lit(AtLayer((lambda $l#24#ly#0: LayerType :: Handle1((lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcolon(), $Unbox($l#24#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: $IsBox($l#24#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon()))), (lambda $l#24#heap#0: Heap, $l#24#c#0: Box :: SetRef_to_SetBox((lambda $l#24#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(v#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(colon#0))), JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(k#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(colon#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(true, Lit(cs#0), Lit(k#0), Lit(colon#0), Lit(v#0)) == (var sp#14 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.jKeyValue.KeyValue(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(k#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(colon#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(v#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(v#0))))); sp#14));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$6x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$6x#0) <==> JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$6x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jcolon()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), $Box($fh$6x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError0#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) && (var k#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType; (var p#18 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#18) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#18), p#18) && (var valueOrError1#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#18), p#18); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) && (var colon#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#18) && (var valueOrError2#18 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#18)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#18)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) && (var v#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(cs#0, k#18, colon#18, v#18))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, cs#0, json#0) == (var valueOrError0#18 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#18) else (var k#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#18)): DatatypeType; (var p#18 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#18 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#18), p#18); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#18) else (var colon#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#18)): DatatypeType; (var valueOrError2#18 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#18)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#18) else (var v#18 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#18)): DatatypeType; (var kv#18 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, cs#0, k#18, colon#18, v#18); #Wrappers.Result.Success($Box(kv#18))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#19 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) && (var k#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType; (var p#19 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#19) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#19), p#19) && (var valueOrError1#19 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#19), p#19); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) && (var colon#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(json#0) && JSON_mUtils_mCursors.Split.SP_q(colon#19) && (var valueOrError2#19 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#19)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#19)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) && (var v#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#19, colon#19, v#19))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), json#0) == (var valueOrError0#19 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#19) else (var k#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#19)): DatatypeType; (var p#19 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#19 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#19), p#19); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#19) else (var colon#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#19)): DatatypeType; (var valueOrError2#19 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, JSON_mUtils_mParsers.SubParser__.fn(json#0), $Box(JSON_mUtils_mCursors.Split.cs(colon#19)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#19) else (var v#19 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#19)): DatatypeType; (var kv#19 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#19, colon#19, v#19); #Wrappers.Result.Success($Box(kv#19))))))))))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError0#20 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#20)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) && (var k#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType; (var p#20 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); JSON_mUtils_mCursors.Split.SP_q(k#20) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mGrammar.jcolon(), JSON_mUtils_mCursors.Split.cs(k#20), p#20) && (var valueOrError1#20 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#20), p#20); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#20)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20) && (var colon#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20)): DatatypeType; JSON_mUtils_mParsers.SubParser__.SubParser_q(Lit(json#0)) && JSON_mUtils_mCursors.Split.SP_q(colon#20) && (var valueOrError2#20 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#20)))): DatatypeType; Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#20)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20) && (var v#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts#canCall(Lit(cs#0), k#20, colon#20, v#20))))))))))) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#20 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError0#20) else (var k#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#20)): DatatypeType; (var p#20 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Colon#Handle(), JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()); (var valueOrError1#20 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mGrammar.jcolon(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(k#20), p#20); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError1#20) else (var colon#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcolon())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#20)): DatatypeType; (var valueOrError2#20 := $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $Heap, Lit(JSON_mUtils_mParsers.SubParser__.fn(Lit(json#0))), $Box(JSON_mUtils_mCursors.Split.cs(colon#20)))): DatatypeType; (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), valueOrError2#20) else (var v#20 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#20)): DatatypeType; (var kv#20 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.KeyValueFromParts(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.KeyValueFromParts, Lit(cs#0), k#20, colon#20, v#20); #Wrappers.Result.Success($Box(kv#20))))))))))))));

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Object($ly, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Object#requires($ly, $Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $fh$5x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Object($ly, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Object#Handle($ly), $Box($fh$5x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, cs#0, json#0) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#10) else (var sp#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(sp#10))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#11) else (var sp#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; #Wrappers.Result.Success($Box(sp#11))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, cs#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()) && (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Open(true, Lit(cs#0)) == (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, cs#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()) && (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Close(true, Lit(cs#0)) == (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($Unbox($fh$5x#0): Seq)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#requires($Unbox($fh$5x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$5x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec($fh$5x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#38#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#39#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#11 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#11));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#42#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#43#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#12 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#12));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#21: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#21) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#21)) } $Is(e#21, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#21)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#21))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && (forall e#22: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#22) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) } $Is(e#22, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#22)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && (forall e#22: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#22) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) } $Is(e#22, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#22)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#10 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#11 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#10)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#11)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) && (forall e#23: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#23) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#23)) } $Is(e#23, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#23)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#23)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#11 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#12 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#11)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#12)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jKeyValue(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#30#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#10 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#11 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#10)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#11)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.jKeyValue(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mObjectParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#11 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#12 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#11)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#12)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#64#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#65#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#20: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#20) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) } $Is(e#20, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#20)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#65#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#20: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#20) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) } $Is(e#20, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#20)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#15 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var elem#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#15) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#15)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#15) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#15)) && (var sep#45 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#15)); JSON_mUtils_mCursors.Split.SP_q(sep#45) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) && (var s0#15 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType); (s0#15 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#45) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType)) && (s0#15 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#46 := sep#45; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#46) && (var elems#16 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#46); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#16)))) && (!(s0#15 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#15 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#45) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType)) && (s0#15 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#47 := sep#45; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#47) && (var elems'#15 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#47); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#15, sep#47))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#15 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#15) else (var elem#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#15)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#45 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#15)); (var s0#15 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType); (if s0#15 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#46 := sep#45; (var elems#16 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#46); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#16))) else (if s0#15 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#47 := sep#45; (var elems'#15 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#47); (var bracketed#15 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#15, sep#47); #Wrappers.Result.Success($Box(bracketed#15))))) else (var separator#15 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#16 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#15)), s0#15))); pr#16)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#66#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#21: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#21) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#21)) } $Is(e#21, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#21)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#21)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var elem#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#16) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#16)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#16) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#16)) && (var sep#48 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#16)); JSON_mUtils_mCursors.Split.SP_q(sep#48) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) && (var s0#16 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType); (s0#16 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#48) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType)) && (s0#16 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#49 := sep#48; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#49) && (var elems#17 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#49); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs0#0, json#0, open#0, elems#17)))) && (!(s0#16 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#16 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#48) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType)) && (s0#16 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#50 := sep#48; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#50) && (var elems'#16 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#50); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#16, sep#50))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#16) else (var elem#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#16)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#48 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#16)); (var s0#16 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType); (if s0#16 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#49 := sep#48; (var elems#17 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#49); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs0#0, json#0, open#0, elems#17))) else (if s0#16 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#50 := sep#48; (var elems'#16 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#50); (var bracketed#16 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs0#0, open#0, elems'#16, sep#50); #Wrappers.Result.Success($Box(bracketed#16))))) else (var separator#16 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#17 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#16)), s0#16))); pr#17)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), $Unbox($l#67#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mObjects.__default.SuffixedElementsSpec#Handle()) && (forall e#22: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#22) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) } $Is(e#22, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#22)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#22)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#17 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var elem#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#17) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#17)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#17) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#17)) && (var sep#51 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#17)); JSON_mUtils_mCursors.Split.SP_q(sep#51) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) && (var s0#17 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType); (s0#17 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#51) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType)) && (s0#17 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#52 := sep#51; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#52) && (var elems#18 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#52); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#18)))) && (!(s0#17 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#17 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#51) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType)) && (s0#17 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#53 := sep#51; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#53) && (var elems'#17 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#53); JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#17, sep#53))))))))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#17 := JSON_mZeroCopy_mDeserializer_mObjectParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ObjectParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#17) else (var elem#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jKeyValue()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#17)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#51 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#17)); (var s0#17 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType); (if s0#17 == JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#52 := sep#51; (var elems#18 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#52); JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#18))) else (if s0#17 == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#53 := sep#51; (var elems'#17 := JSON_mZeroCopy_mDeserializer_mObjects.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Objects._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#53); (var bracketed#17 := JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#17, sep#53); #Wrappers.Result.Success($Box(bracketed#17))))) else (var separator#17 := JSON_mZeroCopy_mDeserializer_mObjects.__default.SEPARATOR(); (var pr#18 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE())), $Box(separator#17)), s0#17))); pr#18)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$5x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$5x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $fh$5x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Open($reveal, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle($reveal), $Box($fh$5x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$5x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$5x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $fh$5x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Close($reveal, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle($reveal), $Box($fh$5x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var open#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#10) && (var elems#10 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#10)); JSON_mUtils_mCursors.Split.SP_q(open#10) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#10)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#10)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#10 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#10) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#10), p#10) && (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#10), p#10); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (var close#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(cs#0, open#10, elems#10, close#10)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#10)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(cs#0, json#0, open#10, elems#10)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#10) else (var open#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (var elems#10 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#10)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#10)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#10 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#10), p#10); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#10) else (var close#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, cs#0, open#10, elems#10, close#10))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, cs#0, json#0, open#10, elems#10)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var open#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#11) && (var elems#11 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#11)); JSON_mUtils_mCursors.Split.SP_q(open#11) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#11)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#11)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> (var p#11 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#11) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), JSON_mUtils_mCursors.Split.cs(open#11), p#11) && (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#11), p#11); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (var close#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts#canCall(Lit(cs#0), open#11, elems#11, close#11)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#11)) != JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#11, elems#11)))))) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Open), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError0#11) else (var open#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (var elems#11 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#11)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#11)) == JSON_mZeroCopy_mDeserializer_mObjectParams.__default.CLOSE() then (var p#11 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mObjects.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Close), JSON_mZeroCopy_mDeserializer_mObjects.__default.SpecViewClose()); (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#11), p#11); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jopen(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), valueOrError1#11) else (var close#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mObjects.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Objects._default.BracketedFromParts, Lit(cs#0), open#11, elems#11, close#11))))))) else JSON_mZeroCopy_mDeserializer_mObjects.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Objects._default.Elements, Lit(cs#0), Lit(json#0), open#11, elems#11)))))));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$6x#0) } Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$6x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($Unbox($fh$6x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$6x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$6x#0) } Requires1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$6x#0) <==> JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#requires($Unbox($fh$6x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$6x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$6x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $fh$6x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$6x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$6x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec($fh$6x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Value(), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle(), $Box($fh$6x#0))): Seq);

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$5x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.Array($ly, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$5x#0) <==> JSON_mConcreteSyntax_mSpec.__default.Array#requires($ly, $Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $fh$5x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$5x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.Array($ly, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.Array#Handle($ly), $Box($fh$5x#0))): Seq);

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, json#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, cs#0, json#0) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, cs#0, json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#10) else (var sp#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(sp#10))))));

axiom (forall cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), Lit(json#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Bracketed, Lit(cs#0), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#11) else (var sp#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; #Wrappers.Result.Success($Box(sp#11))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, cs#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()) && (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Open(true, Lit(cs#0)) == (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.OPEN()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))));

axiom (forall cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(cs#0) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, cs#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), cs#0, JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#canCall(Lit(cs#0)) || $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.AssertByte#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()) && (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Close(true, Lit(cs#0)) == (var valueOrError0#11 := JSON_mUtils_mCursors.Cursor__.AssertByte(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) } Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($Unbox($fh$5x#0): Seq)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) } Requires1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#requires($Unbox($fh$5x#0): Seq));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$5x#0)[$bx] } Reads1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: Seq :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec($fh$5x#0) == $Unbox(Apply1(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$5x#0) } Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($Unbox($fh$5x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$5x#0) } Requires1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $fh$5x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec($fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle(), $Box($fh$5x#0))): Seq);

axiom (forall $reveal: bool, $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $IsAlloc(cs#0, Tclass.JSON_mUtils_mCursors.Cursor(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#38#ly#0: LayerType :: Handle1((lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#38#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: $IsBox($l#38#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#38#heap#0: Heap, $l#38#c#0: Box :: SetRef_to_SetBox((lambda $l#38#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#39#ly#0: LayerType :: Handle1((lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#39#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: $IsBox($l#39#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#39#heap#0: Heap, $l#39#c#0: Box :: SetRef_to_SetBox((lambda $l#39#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), cs#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts($reveal, cs#0, open#0, elems#0, close#0), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#requires(cs#0, open#0, elems#0, close#0) <==> JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#0, elems#0, close#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs#0, Lit(AtLayer((lambda $l#40#ly#0: LayerType :: Handle1((lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#40#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: $IsBox($l#40#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#40#heap#0: Heap, $l#40#c#0: Box :: SetRef_to_SetBox((lambda $l#40#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), close#0, JSON_mUtils_mCursors.Split.cs(elems#0), Lit(AtLayer((lambda $l#41#ly#0: LayerType :: Handle1((lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#41#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: $IsBox($l#41#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#41#heap#0: Heap, $l#41#c#0: Box :: SetRef_to_SetBox((lambda $l#41#o#0: ref :: false))))), $LS($LZ))))) ==> JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mUtils_mCursors.Split.SP_q(close#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, cs#0, open#0, elems#0, close#0) == (var sp#11 := #JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Bracketed.Bracketed($Unbox(JSON_mUtils_mCursors.Split.t(open#0)): DatatypeType, $Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Unbox(JSON_mUtils_mCursors.Split.t(close#0)): DatatypeType)), JSON_mUtils_mCursors.Split.cs(close#0)); sp#11));

axiom (forall $Heap: Heap, cs#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType, close#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.Cursor()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(close#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs#0), Lit(AtLayer((lambda $l#42#ly#0: LayerType :: Handle1((lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#42#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: $IsBox($l#42#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#42#heap#0: Heap, $l#42#c#0: Box :: SetRef_to_SetBox((lambda $l#42#o#0: ref :: false))))), $LS($LZ))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(close#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(AtLayer((lambda $l#43#ly#0: LayerType :: Handle1((lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#43#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: $IsBox($l#43#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#43#heap#0: Heap, $l#43#c#0: Box :: SetRef_to_SetBox((lambda $l#43#o#0: ref :: false))))), $LS($LZ)))))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(close#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(true, Lit(cs#0), Lit(open#0), Lit(elems#0), Lit(close#0)) == (var sp#12 := Lit(#JSON.Utils.Cursors.Split.SP($Box(Lit(#JSON.Grammar.Bracketed.Bracketed(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(open#0))): DatatypeType), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq), Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(close#0))): DatatypeType)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(close#0))))); sp#12));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#19#ly#0: LayerType :: Handle1((lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#19#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: $IsBox($l#19#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#19#heap#0: Heap, $l#19#c#0: Box :: SetRef_to_SetBox((lambda $l#19#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#21: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#21) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#21)) } $Is(e#21, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq, $Box(e#21)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#21))) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && (forall e#22: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#22) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) } $Is(e#22, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#22)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#20#ly#0: LayerType :: Handle1((lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#20#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: $IsBox($l#20#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#20#heap#0: Heap, $l#20#c#0: Box :: SetRef_to_SetBox((lambda $l#20#o#0: ref :: false))))), $LS($LZ)))) && (forall e#22: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#22) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) } $Is(e#22, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#22)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(sep#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#10 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), #JSON.Grammar.Maybe.NonEmpty(JSON_mUtils_mCursors.Split.t(sep#0))); (var elems'#11 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#10)))), JSON_mUtils_mCursors.Split.cs(sep#0)); elems'#11)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#21#ly#0: LayerType :: Handle1((lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mGrammar.jcomma(), $Unbox($l#21#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: $IsBox($l#21#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.jcomma()))), (lambda $l#21#heap#0: Heap, $l#21#c#0: Box :: SetRef_to_SetBox((lambda $l#21#o#0: ref :: false))))), $LS($LZ))))) && (forall e#23: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#23) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#23)) } $Is(e#23, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#23)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#23)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(sep#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#11 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.NonEmpty($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(sep#0))): DatatypeType)))))); (var elems'#12 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#11)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(sep#0)))); elems'#12)));

axiom (forall $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $IsAlloc(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), $Heap) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && $IsAlloc(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), $Heap) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#29#ly#0: LayerType :: Handle1((lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#29#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: $IsBox($l#29#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#29#heap#0: Heap, $l#29#c#0: Box :: SetRef_to_SetBox((lambda $l#29#o#0: ref :: false))))), $LS($LZ)))) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mGrammar.__default.NoTrailingSuffix(Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.Value(), $Unbox(JSON_mUtils_mCursors.Split.t(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))): Seq) && JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0))) < JSON_mUtils_mCursors.Cursor__.Length(JSON_mUtils_mCursors.Split.cs(elems#0)) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0)), Lit(AtLayer((lambda $l#30#ly#0: LayerType :: Handle1((lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#30#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: $IsBox($l#30#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#30#heap#0: Heap, $l#30#c#0: Box :: SetRef_to_SetBox((lambda $l#30#o#0: ref :: false))))), $LS($LZ)))) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast($reveal, cs0#0, json#0, elems#0, elem#0, sep#0), Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#requires(cs0#0, json#0, elems#0, elem#0, sep#0) <==> JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(cs0#0, json#0, elems#0, elem#0, sep#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), elem#0, JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), sep#0, JSON_mUtils_mCursors.Split.cs(elem#0), Lit(AtLayer((lambda $l#31#ly#0: LayerType :: Handle1((lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#31#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: $IsBox($l#31#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#31#heap#0: Heap, $l#31#c#0: Box :: SetRef_to_SetBox((lambda $l#31#o#0: ref :: false))))), $LS($LZ)))) && (forall e#12: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#12) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) } $Is(e#12, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#12)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#12)))) ==> JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mUtils_mCursors.Split.SP_q(elem#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, cs0#0, json#0, elems#0, elem#0, sep#0) == (var suffixed#10 := #JSON.Grammar.Suffixed.Suffixed(JSON_mUtils_mCursors.Split.t(elem#0), Lit(#JSON.Grammar.Maybe.Empty())); (var elems'#11 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#10)))), JSON_mUtils_mCursors.Split.cs(elem#0)); elems'#11)));

axiom (forall $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, elems#0: DatatypeType, elem#0: DatatypeType, sep#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $Is(elem#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value())) && $Is(sep#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(cs0#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Value(), Lit(elem#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mZeroCopy_mDeserializer_mArrayParams.__default.ElementSpec#Handle()) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Lit(sep#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0))), Lit(AtLayer((lambda $l#32#ly#0: LayerType :: Handle1((lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), $Unbox($l#32#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: $IsBox($l#32#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()))), (lambda $l#32#heap#0: Heap, $l#32#c#0: Box :: SetRef_to_SetBox((lambda $l#32#o#0: ref :: false))))), $LS($LZ))))) && (forall e#13: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#13) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#13)) } $Is(e#13, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#13)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#13)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mUtils_mCursors.Split.SP_q(Lit(elem#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(true, Lit(cs0#0), Lit(json#0), Lit(elems#0), Lit(elem#0), Lit(sep#0)) == (var suffixed#11 := Lit(#JSON.Grammar.Suffixed.Suffixed($Box(Lit($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elem#0))): DatatypeType)), Lit(#JSON.Grammar.Maybe.Empty()))); (var elems'#12 := #JSON.Utils.Cursors.Split.SP($Box(Seq#Append($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, Seq#Build(Seq#Empty(): Seq, $Box(suffixed#11)))), Lit(JSON_mUtils_mCursors.Split.cs(Lit(elem#0)))); elems'#12)));

axiom (forall $ly: LayerType, $reveal: bool, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $IsAlloc(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor(), $Heap) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $IsAlloc(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser(), $Heap) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $IsAlloc(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), $Heap) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && $IsAlloc(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma()))), $Heap) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#64#ly#0: LayerType :: Handle1((lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#64#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: $IsBox($l#64#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#64#heap#0: Heap, $l#64#c#0: Box :: SetRef_to_SetBox((lambda $l#64#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#0: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#0) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) } $Is(e#0, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#0)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#0)))) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0)) ==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0))): DatatypeType, cs0#0, JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedSpec#Handle())) && $Is(JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, $reveal, cs0#0, json#0, open#0, elems#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } $IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) ==> (JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#requires($ly, cs0#0, json#0, open#0, elems#0) <==> JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#65#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#20: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#20) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) } $Is(e#20, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#20)))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#0) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#65#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: $IsBox($l#65#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#65#heap#0: Heap, $l#65#c#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(JSON_mUtils_mCursors.Split.cs(elems#0), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), elems#0, JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#20: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#20) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) } $Is(e#20, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#20)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#20)))) ==> JSON_mUtils_mCursors.Split.SP_q(elems#0) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(JSON_mUtils_mCursors.Split.cs(elems#0), json#0) && (var valueOrError0#15 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#15)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) && (var elem#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#15) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#15)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#15) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#15)) && (var sep#45 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#15)); JSON_mUtils_mCursors.Split.SP_q(sep#45) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) && (var s0#15 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType); (s0#15 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#45) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType)) && (s0#15 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#46 := sep#45; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#46) && (var elems#16 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#46); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#16)))) && (!(s0#15 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#15 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#45) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType)) && (s0#15 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#47 := sep#45; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#47) && (var elems'#15 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#47); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#15, sep#47))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, elems#0) == (var valueOrError0#15 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, JSON_mUtils_mCursors.Split.cs(elems#0), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#15) else (var elem#15 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#15)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#15)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#45 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#15)); (var s0#15 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType); (if s0#15 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#46 := sep#45; (var elems#16 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#46); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($ly, reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#16))) else (if s0#15 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#45)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#47 := sep#45; (var elems'#15 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, elems#0, elem#15, sep#47); (var bracketed#15 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#15, sep#47); #Wrappers.Result.Success($Box(bracketed#15))))) else (var separator#15 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#16 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#15)), s0#15))); pr#16)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), open#0, cs0#0, Lit(AtLayer((lambda $l#66#ly#0: LayerType :: Handle1((lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#66#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: $IsBox($l#66#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#66#heap#0: Heap, $l#66#c#0: Box :: SetRef_to_SetBox((lambda $l#66#o#0: ref :: false))))), $LS($LZ)))) && JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), JSON_mUtils_mParsers.SubParser__.cs(json#0)) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), JSON_mUtils_mCursors.Split.cs(open#0), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#21: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#21) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#21)) } $Is(e#21, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#21)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#21)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0) && (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#16)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) && (var elem#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#16) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#16)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#16) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#16)) && (var sep#48 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#16)); JSON_mUtils_mCursors.Split.SP_q(sep#48) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) && (var s0#16 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType); (s0#16 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#48) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType)) && (s0#16 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#49 := sep#48; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#49) && (var elems#17 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#49); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs0#0, json#0, open#0, elems#17)))) && (!(s0#16 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#16 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#48) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType)) && (s0#16 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#50 := sep#48; JSON_mUtils_mCursors.Split.SP_q(open#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#50) && (var elems'#16 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#50); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs0#0, open#0, elems'#16, sep#50))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, cs0#0, json#0, open#0, Lit(elems#0)) == (var valueOrError0#16 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), json#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#16) else (var elem#16 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#16)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#16)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#48 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#16)); (var s0#16 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType); (if s0#16 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#49 := sep#48; (var elems#17 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#49); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs0#0, json#0, open#0, elems#17))) else (if s0#16 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#48)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#50 := sep#48; (var elems'#16 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, JSON_mUtils_mCursors.Split.cs(open#0), json#0, Lit(elems#0), elem#16, sep#50); (var bracketed#16 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs0#0, open#0, elems'#16, sep#50); #Wrappers.Result.Success($Box(bracketed#16))))) else (var separator#16 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#17 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#16)), s0#16))); pr#17)))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs0#0: DatatypeType, json#0: DatatypeType, open#0: DatatypeType, elems#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) || ($IsGoodHeap($Heap) && $Is(cs0#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && $Is(open#0, Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))) && $Is(elems#0, Tclass.JSON_mUtils_mCursors.Split(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())))) && Lit(JSON_mUtils_mCursors.Split.StrictlySplitFrom_q(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Lit(open#0), Lit(cs0#0), Lit(AtLayer((lambda $l#67#ly#0: LayerType :: Handle1((lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $Box(JSON_mConcreteSyntax_mSpec.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), $Unbox($l#67#c#0): DatatypeType, JSON_mZeroCopy_mDeserializer_mCore.__default.SpecView()))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: $IsBox($l#67#c#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()))), (lambda $l#67#heap#0: Heap, $l#67#c#0: Box :: SetRef_to_SetBox((lambda $l#67#o#0: ref :: false))))), $LS($LZ))))) && Lit(JSON_mUtils_mCursors.Cursor__.StrictlySplitFrom_q(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0))))) && JSON_mUtils_mCursors.Split.SplitFrom_q(TSeq(Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())), Lit(elems#0), Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), JSON_mZeroCopy_mDeserializer_mArrays.__default.SuffixedElementsSpec#Handle()) && (forall e#22: DatatypeType :: { JSON_mGrammar.Suffixed.suffix(e#22) } { Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(elems#0)): Seq, $Box(e#22)) } $Is(e#22, Tclass.JSON_mGrammar.Suffixed(Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma())) && Seq#Contains($Unbox(JSON_mUtils_mCursors.Split.t(Lit(elems#0))): Seq, $Box(e#22)) ==> JSON_mGrammar.Maybe.NonEmpty_q(JSON_mGrammar.Suffixed.suffix(e#22)))) ==> JSON_mUtils_mCursors.Split.SP_q(Lit(elems#0)) && JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)) && (var valueOrError0#17 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#17)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) && (var elem#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(elem#17) && (!JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#17)) ==> JSON_mUtils_mCursors.Split.SP_q(elem#17) && JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural#canCall(JSON_mUtils_mCursors.Split.cs(elem#17)) && (var sep#51 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#17)); JSON_mUtils_mCursors.Split.SP_q(sep#51) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Peek#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) && (var s0#17 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType); (s0#17 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() ==> JSON_mUtils_mCursors.Split.SP_q(sep#51) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType)) && (s0#17 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#52 := sep#51; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#52) && (var elems#18 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#52); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs0#0), Lit(json#0), Lit(open#0), elems#18)))) && (!(s0#17 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1)) ==> (s0#17 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mUtils_mCursors.Split.SP_q(sep#51) && JSON_mGrammar.Structural.Structural_q($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType) && JSON_mUtils_mViews_mCore.View__.Length#canCall($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType)) && (s0#17 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) ==> (var sep#53 := sep#51; JSON_mUtils_mCursors.Split.SP_q(Lit(open#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast#canCall(Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#53) && (var elems'#17 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#53); JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs0#0), Lit(open#0), elems'#17, sep#53))))))))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), true, Lit(cs0#0), Lit(json#0), Lit(open#0), Lit(elems#0)) == (var valueOrError0#17 := JSON_mZeroCopy_mDeserializer_mArrayParams.__default.Element(reveal_JSON.ZeroCopy.Deserializer.ArrayParams._default.Element, Lit(JSON_mUtils_mCursors.Split.cs(Lit(elems#0))), Lit(json#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#17) else (var elem#17 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#17)): DatatypeType; (if JSON_mUtils_mCursors.Cursor__.EOF_q(JSON_mUtils_mCursors.Split.cs(elem#17)) then #Wrappers.Result.Failure($Box(Lit(#JSON.Utils.Cursors.CursorError.EOF()))) else (var sep#51 := JSON_mZeroCopy_mDeserializer_mCore.__default.TryStructural(JSON_mUtils_mCursors.Split.cs(elem#17)); (var s0#17 := JSON_mUtils_mViews_mCore.View__.Peek($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType); (if s0#17 == JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#52 := sep#51; (var elems#18 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendWithSuffix(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendWithSuffix, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#52); JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs0#0), Lit(json#0), Lit(open#0), elems#18))) else (if s0#17 == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() && JSON_mUtils_mViews_mCore.View__.Length($Unbox(JSON_mGrammar.Structural.t($Unbox(JSON_mUtils_mCursors.Split.t(sep#51)): DatatypeType)): DatatypeType) == LitInt(1) then (var sep#53 := sep#51; (var elems'#17 := JSON_mZeroCopy_mDeserializer_mArrays.__default.AppendLast(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.AppendLast, Lit(JSON_mUtils_mCursors.Split.cs(Lit(open#0))), Lit(json#0), Lit(elems#0), elem#17, sep#53); (var bracketed#17 := JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs0#0), Lit(open#0), elems'#17, sep#53); #Wrappers.Result.Success($Box(bracketed#17))))) else (var separator#17 := JSON_mZeroCopy_mDeserializer_mArrays.__default.SEPARATOR(); (var pr#18 := #Wrappers.Result.Failure($Box(#JSON.Utils.Cursors.CursorError.ExpectingAnyByte(Seq#Build(Seq#Build(Seq#Empty(): Seq, $Box(JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE())), $Box(separator#17)), s0#17))); pr#18)))))))))));

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$5x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$5x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $fh$5x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Open($reveal, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle($reveal), $Box($fh$5x#0))): DatatypeType);

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$5x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$5x#0) == $Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $Unbox($fh$5x#0): DatatypeType)));

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$5x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$5x#0) <==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#requires($Unbox($fh$5x#0): DatatypeType));

axiom (forall $bx: Box, $reveal: bool, $heap: Heap, $fh$5x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$5x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $fh$5x#0)[$bx] <==> false);

axiom (forall $reveal: bool, $heap: Heap, $fh$5x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$5x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Close($reveal, $fh$5x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle($reveal), $Box($fh$5x#0))): DatatypeType);

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(cs#0, json#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && JSON_mUtils_mCursors.Cursor__.SplitFrom_q(cs#0, JSON_mUtils_mParsers.SubParser__.cs(json#0))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var open#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#10) && (var elems#10 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#10)); JSON_mUtils_mCursors.Split.SP_q(open#10) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#10)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#10)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#10 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#10) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#10), p#10) && (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#10), p#10); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) && (var close#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(cs#0, open#10, elems#10, close#10)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#10)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(cs#0, json#0, open#10, elems#10)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, cs#0, json#0) == (var valueOrError0#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, cs#0, #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#10) else (var open#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; (var elems#10 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#10)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#10)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#10 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#10 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#10), p#10); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#10) else (var close#10 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, cs#0, open#10, elems#10, close#10))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, cs#0, json#0, open#10, elems#10)))))));

axiom (forall $Heap: Heap, cs#0: DatatypeType, json#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed#canCall(Lit(cs#0), Lit(json#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(json#0, Tclass.JSON_mZeroCopy_mDeserializer_mCore.ValueParser()) && Lit(JSON_mUtils_mCursors.Cursor__.SplitFrom_q(Lit(cs#0), Lit(JSON_mUtils_mParsers.SubParser__.cs(Lit(json#0)))))) ==> JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())) && (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var open#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Split.SP_q(open#11) && (var elems#11 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#11)); JSON_mUtils_mCursors.Split.SP_q(open#11) && JSON_mUtils_mCursors.Cursor__.Peek#canCall(JSON_mUtils_mCursors.Split.cs(open#11)) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#11)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> (var p#11 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); JSON_mUtils_mCursors.Split.SP_q(open#11) && JSON_mZeroCopy_mDeserializer_mCore.__default.Structural#canCall(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), JSON_mUtils_mCursors.Split.cs(open#11), p#11) && (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#11), p#11); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) && (var close#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts#canCall(Lit(cs#0), open#11, elems#11, close#11)))))) && (JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#11)) != JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() ==> JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements#canCall(Lit(cs#0), Lit(json#0), open#11, elems#11)))))) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Bracketed(true, Lit(cs#0), Lit(json#0)) == (var valueOrError0#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, Lit(cs#0), #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Open#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Open), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewOpen())); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError0#11) else (var open#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; (var elems#11 := #JSON.Utils.Cursors.Split.SP($Box(Lit(Seq#Empty(): Seq)), JSON_mUtils_mCursors.Split.cs(open#11)); (if JSON_mUtils_mCursors.Cursor__.Peek(JSON_mUtils_mCursors.Split.cs(open#11)) == JSON_mZeroCopy_mDeserializer_mArrayParams.__default.CLOSE() then (var p#11 := #JSON.Utils.Parsers.Parser_.Parser(JSON_mZeroCopy_mDeserializer_mArrays.__default.Close#Handle(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Close), JSON_mZeroCopy_mDeserializer_mArrays.__default.SpecViewClose()); (var valueOrError1#11 := JSON_mZeroCopy_mDeserializer_mCore.__default.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose(), reveal_JSON.ZeroCopy.Deserializer.Core._default.Structural, JSON_mUtils_mCursors.Split.cs(open#11), p#11); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jopen(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), valueOrError1#11) else (var close#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mZeroCopy_mDeserializer_mArrays.jclose())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#11)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedFromParts(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.BracketedFromParts, Lit(cs#0), open#11, elems#11, close#11))))))) else JSON_mZeroCopy_mDeserializer_mArrays.__default.Elements($LS($LZ), reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Elements, Lit(cs#0), Lit(json#0), open#11, elems#11)))))));

axiom (forall $reveal: bool, cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> Seq#Equal(JSON_mUtils_mViews_mCore.View__.Bytes($Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType)): DatatypeType), expected#0)) && (Wrappers.Result.Success_q(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0)) ==> JSON_mUtils_mCursors.Split.SplitFrom_q(Tclass.JSON_mUtils_mViews_mCore.View(), $Unbox(Wrappers.Result.value(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0))): DatatypeType, cs#0, Lit(AtLayer((lambda $l#11#ly#0: LayerType :: Handle1((lambda $l#11#heap#0: Heap, $l#11#_v3#0: Box :: $Box(expected#0)), (lambda $l#11#heap#0: Heap, $l#11#_v3#0: Box :: $IsBox($l#11#_v3#0, Tclass.JSON_mUtils_mViews_mCore.View__())), (lambda $l#11#heap#0: Heap, $l#11#_v3#0: Box :: SetRef_to_SetBox((lambda $l#11#o#0: ref :: false))))), $LS($LZ))))) && $Is(JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant($reveal, cs#0, expected#0), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, expected#0) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(expected#0) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), cs#0, expected#0, LitInt(0)) && (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) && (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#11)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, cs#0, expected#0) == (var valueOrError0#10 := JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), cs#0, expected#0, LitInt(0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#10) else (var cs#11 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#10)): DatatypeType; #Wrappers.Result.Success($Box(JSON_mUtils_mCursors.Cursor__.Split(cs#11)))))));

axiom (forall cs#0: DatatypeType, expected#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) } JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), Lit(expected#0)) || ($Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Is(expected#0, TSeq(Tclass.BoundedInts.uint8())) && Seq#Length(Lit(expected#0)) < BoundedInts.__default.TWO__TO__THE__32()) ==> JSON_mUtils_mCursors.Cursor__.AssertBytes#canCall(Tclass.JSON_mErrors.DeserializationError(), Lit(cs#0), Lit(expected#0), LitInt(0)) && (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) && (var cs#12 := $Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType; JSON_mUtils_mCursors.Cursor__.Split#canCall(cs#12)))) && JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(true, Lit(cs#0), Lit(expected#0)) == (var valueOrError0#11 := Lit(JSON_mUtils_mCursors.Cursor__.AssertBytes(Tclass.JSON_mErrors.DeserializationError(), $LS($LZ), Lit(cs#0), Lit(expected#0), LitInt(0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), valueOrError0#11) else (var cs#12 := Lit($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Cursor(), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#11)): DatatypeType); Lit(#Wrappers.Result.Success($Box(Lit(JSON_mUtils_mCursors.Cursor__.Split(cs#12)))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(cs#0) && (var c#8 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (c#8 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)))) && (c#8 != char#ToInt(Lit(char#FromInt(123))) ==> (c#8 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)) && (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)))) && (c#8 != char#ToInt(Lit(char#FromInt(91))) ==> (c#8 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(cs#0) && (var valueOrError2#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)))) && (c#8 != char#ToInt(Lit(char#FromInt(34))) ==> (c#8 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.TRUE()) && (var valueOrError3#8 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8)))) && (c#8 != char#ToInt(Lit(char#FromInt(116))) ==> (c#8 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.FALSE()) && (var valueOrError4#8 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8)))) && (c#8 != char#ToInt(Lit(char#FromInt(102))) ==> (c#8 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(cs#0, JSON_mGrammar.__default.NULL()) && (var valueOrError5#8 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8)))) && (c#8 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(cs#0) && (var valueOrError6#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#8)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, cs#0) == (var c#8 := JSON_mUtils_mCursors.Cursor__.Peek(cs#0); (if c#8 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#8 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#8) else (var obj#8, cs'#56 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#8)): DatatypeType); (var v#24 := #JSON.Grammar.Value.Object(obj#8); (var sp#24 := #JSON.Utils.Cursors.Split.SP($Box(v#24), cs'#56); #Wrappers.Result.Success($Box(sp#24))))))) else (if c#8 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#8 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, cs#0, JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($ly, reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#8) else (var arr#8, cs'#57 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#8)): DatatypeType); (var v#25 := #JSON.Grammar.Value.Array(arr#8); (var sp#25 := #JSON.Utils.Cursors.Split.SP($Box(v#25), cs'#57); #Wrappers.Result.Success($Box(sp#25))))))) else (if c#8 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#8 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#8) else (var str#8, cs'#58 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#8)), cs'#58)))))) else (if c#8 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#8 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#8) else (var cst#24, cs'#59 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#24)), cs'#59)))))) else (if c#8 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#8 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#8) else (var cst#25, cs'#60 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#25)), cs'#60)))))) else (if c#8 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#8 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, cs#0, JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#8) else (var cst#26, cs'#61 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#8)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#26)), cs'#61)))))) else (var valueOrError6#8 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, cs#0); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#8) else (var num#8, cs'#62 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#8)): DatatypeType); (var v#26 := #JSON.Grammar.Value.Number(num#8); (var sp#26 := #JSON.Utils.Cursors.Split.SP($Box(v#26), cs'#62); #Wrappers.Result.Success($Box(sp#26)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> JSON_mUtils_mCursors.Cursor__.Peek#canCall(Lit(cs#0)) && (var c#9 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (c#9 == char#ToInt(Lit(char#FromInt(123))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mObjects.__default.Object#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)))) && (c#9 != char#ToInt(Lit(char#FromInt(123))) ==> (c#9 == char#ToInt(Lit(char#FromInt(91))) ==> JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) && JSON_mZeroCopy_mDeserializer_mArrays.__default.Array#canCall(Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))) && (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)))) && (c#9 != char#ToInt(Lit(char#FromInt(91))) ==> (c#9 == char#ToInt(Lit(char#FromInt(34))) ==> JSON_mZeroCopy_mDeserializer_mStrings.__default.String#canCall(Lit(cs#0)) && (var valueOrError2#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)))) && (c#9 != char#ToInt(Lit(char#FromInt(34))) ==> (c#9 == char#ToInt(Lit(char#FromInt(116))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.TRUE()) && (var valueOrError3#9 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9)))) && (c#9 != char#ToInt(Lit(char#FromInt(116))) ==> (c#9 == char#ToInt(Lit(char#FromInt(102))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.FALSE()) && (var valueOrError4#9 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9)))) && (c#9 != char#ToInt(Lit(char#FromInt(102))) ==> (c#9 == char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant#canCall(Lit(cs#0), JSON_mGrammar.__default.NULL()) && (var valueOrError5#9 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9)))) && (c#9 != char#ToInt(Lit(char#FromInt(110))) ==> JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number#canCall(Lit(cs#0)) && (var valueOrError6#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#9)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9)))))))))) && JSON_mZeroCopy_mDeserializer_mValues.__default.Value($LS($ly), true, Lit(cs#0)) == (var c#9 := LitInt(JSON_mUtils_mCursors.Cursor__.Peek(Lit(cs#0))); (if c#9 == char#ToInt(Lit(char#FromInt(123))) then (var valueOrError0#9 := JSON_mZeroCopy_mDeserializer_mObjects.__default.Object(reveal_JSON.ZeroCopy.Deserializer.Objects._default.Object, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError0#9) else (var obj#9, cs'#63 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbrace(), Tclass.JSON_mGrammar.jKeyValue(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbrace())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError0#9)): DatatypeType); (var v#27 := #JSON.Grammar.Value.Object(obj#9); (var sp#27 := #JSON.Utils.Cursors.Split.SP($Box(v#27), cs'#63); #Wrappers.Result.Success($Box(sp#27))))))) else (if c#9 == char#ToInt(Lit(char#FromInt(91))) then (var valueOrError1#9 := JSON_mZeroCopy_mDeserializer_mArrays.__default.Array(reveal_JSON.ZeroCopy.Deserializer.Arrays._default.Array, Lit(cs#0), JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), reveal_JSON.ZeroCopy.Deserializer.Values._default.ValueParser, Lit(cs#0))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError1#9) else (var arr#9, cs'#64 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Bracketed(Tclass.JSON_mGrammar.jlbracket(), Tclass.JSON_mGrammar.Value(), Tclass.JSON_mGrammar.jcomma(), Tclass.JSON_mGrammar.jrbracket())), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError1#9)): DatatypeType); (var v#28 := #JSON.Grammar.Value.Array(arr#9); (var sp#28 := #JSON.Utils.Cursors.Split.SP($Box(v#28), cs'#64); #Wrappers.Result.Success($Box(sp#28))))))) else (if c#9 == char#ToInt(Lit(char#FromInt(34))) then (var valueOrError2#9 := JSON_mZeroCopy_mDeserializer_mStrings.__default.String(reveal_JSON.ZeroCopy.Deserializer.Strings._default.String, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError2#9) else (var str#9, cs'#65 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jstring()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError2#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.String(str#9)), cs'#65)))))) else (if c#9 == char#ToInt(Lit(char#FromInt(116))) then (var valueOrError3#9 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.TRUE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError3#9) else (var cst#27, cs'#66 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError3#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#27)), cs'#66)))))) else (if c#9 == char#ToInt(Lit(char#FromInt(102))) then (var valueOrError4#9 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.FALSE()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError4#9) else (var cst#28, cs'#67 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError4#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Bool(cst#28)), cs'#67)))))) else (if c#9 == char#ToInt(Lit(char#FromInt(110))) then (var valueOrError5#9 := JSON_mZeroCopy_mDeserializer_mConstants.__default.Constant(reveal_JSON.ZeroCopy.Deserializer.Constants._default.Constant, Lit(cs#0), JSON_mGrammar.__default.NULL()); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError5#9) else (var cst#29, cs'#68 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mUtils_mViews_mCore.View()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError5#9)): DatatypeType); #Wrappers.Result.Success($Box(#JSON.Utils.Cursors.Split.SP($Box(#JSON.Grammar.Value.Null(cst#29)), cs'#68)))))) else (var valueOrError6#9 := JSON_mZeroCopy_mDeserializer_mNumbers.__default.Number(reveal_JSON.ZeroCopy.Deserializer.Numbers._default.Number, Lit(cs#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), valueOrError6#9) else (var num#9, cs'#69 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.jnumber()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), valueOrError6#9)): DatatypeType); (var v#29 := #JSON.Grammar.Value.Number(num#9); (var sp#29 := #JSON.Utils.Cursors.Split.SP($Box(v#29), cs'#69); #Wrappers.Result.Success($Box(sp#29)))))))))))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(cs#0) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#56#ps'#0: DatatypeType :: $Is($l#56#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#56#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(cs#0)) && (var pre#8 := Lit(AtLayer((lambda $l#59#ly#0: LayerType :: Handle1((lambda $l#59#heap#0: Heap, $l#59#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#59#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#59#heap#0: Heap, $l#59#ps'#0: Box :: $IsBox($l#59#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#59#heap#0: Heap, $l#59#ps'#0: Box :: SetRef_to_SetBox((lambda $l#59#o#0: ref :: false))))), $ly)); (forall $l#57#ps'#0: DatatypeType :: $Is($l#57#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#8, $Box($l#57#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#57#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, cs#0) == (var pre#8 := Lit(AtLayer((lambda $l#54#ly#0: LayerType :: Handle1((lambda $l#54#heap#0: Heap, $l#54#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#54#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(cs#0))), (lambda $l#54#heap#0: Heap, $l#54#ps'#0: Box :: $IsBox($l#54#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#54#heap#0: Heap, $l#54#ps'#0: Box :: SetRef_to_SetBox((lambda $l#54#o#0: ref :: false))))), $ly)); (var fn#8 := Lit(AtLayer((lambda $l#55#ly#0: LayerType :: Handle1((lambda $l#55#heap#0: Heap, $l#55#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#55#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#55#ps'#0): DatatypeType))), (lambda $l#55#heap#0: Heap, $l#55#ps'#0: Box :: $IsBox($l#55#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#55#heap#0, pre#8, $Box($Unbox($l#55#ps'#0): DatatypeType))): bool), (lambda $l#55#heap#0: Heap, $l#55#ps'#0: Box :: SetRef_to_SetBox((lambda $l#55#o#0: ref :: false))))), $ly)); #JSON.Utils.Parsers.SubParser_.SubParser(cs#0, pre#8, fn#8, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall $ly: LayerType, $Heap: Heap, cs#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)), $IsGoodHeap($Heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser#canCall(Lit(cs#0)) || ($IsGoodHeap($Heap) && $Is(cs#0, Tclass.JSON_mUtils_mCursors.FreshCursor())) ==> (forall $l#62#ps'#0: DatatypeType :: $Is($l#62#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> JSON_mUtils_mCursors.Cursor__.Length#canCall($l#62#ps'#0) && JSON_mUtils_mCursors.Cursor__.Length#canCall(Lit(cs#0))) && (var pre#9 := Lit(AtLayer((lambda $l#65#ly#0: LayerType :: Handle1((lambda $l#65#heap#0: Heap, $l#65#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#65#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#65#heap#0: Heap, $l#65#ps'#0: Box :: $IsBox($l#65#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#65#heap#0: Heap, $l#65#ps'#0: Box :: SetRef_to_SetBox((lambda $l#65#o#0: ref :: false))))), $LS($ly))); (forall $l#63#ps'#0: DatatypeType :: $Is($l#63#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) ==> $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $Heap, pre#9, $Box($l#63#ps'#0))): bool ==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#canCall($l#63#ps'#0))) && JSON_mZeroCopy_mDeserializer_mValues.__default.ValueParser($LS($ly), true, Lit(cs#0)) == (var pre#9 := Lit(AtLayer((lambda $l#60#ly#0: LayerType :: Handle1((lambda $l#60#heap#0: Heap, $l#60#ps'#0: Box :: $Box(JSON_mUtils_mCursors.Cursor__.Length($Unbox($l#60#ps'#0): DatatypeType) < JSON_mUtils_mCursors.Cursor__.Length(Lit(cs#0)))), (lambda $l#60#heap#0: Heap, $l#60#ps'#0: Box :: $IsBox($l#60#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor())), (lambda $l#60#heap#0: Heap, $l#60#ps'#0: Box :: SetRef_to_SetBox((lambda $l#60#o#0: ref :: false))))), $LS($ly))); (var fn#9 := Lit(AtLayer((lambda $l#61#ly#0: LayerType :: Handle1((lambda $l#61#heap#0: Heap, $l#61#ps'#0: Box :: $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($l#61#ly#0, reveal_JSON.ZeroCopy.Deserializer.Values._default.Value, $Unbox($l#61#ps'#0): DatatypeType))), (lambda $l#61#heap#0: Heap, $l#61#ps'#0: Box :: $IsBox($l#61#ps'#0, Tclass.JSON_mUtils_mCursors.FreshCursor()) && $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), TBool, $l#61#heap#0, pre#9, $Box($Unbox($l#61#ps'#0): DatatypeType))): bool), (lambda $l#61#heap#0: Heap, $l#61#ps'#0: Box :: SetRef_to_SetBox((lambda $l#61#o#0: ref :: false))))), $LS($ly))); #JSON.Utils.Parsers.SubParser_.SubParser(Lit(cs#0), pre#9, fn#9, JSON_mConcreteSyntax_mSpec.__default.Value#Handle($LS($LZ))))));

axiom (forall err#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(err#0) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(err#0) == (if JSON_mUtils_mCursors.CursorError.EOF_q(err#0) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(err#0) then (var b#24 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected#12 := JSON_mUtils_mCursors.CursorError.expected(err#0); #JSON.Errors.DeserializationError.ExpectingByte(expected#12, b#24))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(err#0) then (var b#25 := JSON_mUtils_mCursors.CursorError.b(err#0); (var expected_sq#12 := JSON_mUtils_mCursors.CursorError.expected__sq(err#0); #JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#12, b#25))) else (var err#13 := $Unbox(JSON_mUtils_mCursors.CursorError.err(err#0)): DatatypeType; err#13)))));

axiom (forall err#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#canCall(Lit(err#0)) || $Is(err#0, Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError(Lit(err#0)) == (if JSON_mUtils_mCursors.CursorError.EOF_q(Lit(err#0)) then #JSON.Errors.DeserializationError.ReachedEOF() else (if JSON_mUtils_mCursors.CursorError.ExpectingByte_q(Lit(err#0)) then (var b#28 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected#14 := LitInt(JSON_mUtils_mCursors.CursorError.expected(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingByte(expected#14, b#28)))) else (if JSON_mUtils_mCursors.CursorError.ExpectingAnyByte_q(Lit(err#0)) then (var b#29 := LitInt(JSON_mUtils_mCursors.CursorError.b(Lit(err#0))); (var expected_sq#14 := Lit(JSON_mUtils_mCursors.CursorError.expected__sq(Lit(err#0))); Lit(#JSON.Errors.DeserializationError.ExpectingAnyByte(expected_sq#14, b#29)))) else (var err#15 := Lit($Unbox(JSON_mUtils_mCursors.CursorError.err(Lit(err#0))): DatatypeType); err#15)))));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$3x#0) == $Box(JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$3x#0) <==> JSON_mConcreteSyntax_mSpec.__default.JSON#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mConcreteSyntax_mSpec.__default.JSON($fh$3x#0), $IsGoodHeap($heap) } JSON_mConcreteSyntax_mSpec.__default.JSON($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), TSeq(Tclass.BoundedInts.uint8()), $heap, JSON_mConcreteSyntax_mSpec.__default.JSON#Handle(), $Box($fh$3x#0))): Seq);

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $Unbox($fh$3x#0): DatatypeType)));

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mValues.__default.Value#requires($ly, $Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $ly: LayerType, $reveal: bool, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $fh$3x#0)[$bx] <==> false);

axiom (forall $ly: LayerType, $reveal: bool, $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mValues.__default.Value($ly, $reveal, $fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.FreshCursor(), Tclass.Wrappers.Result(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError())), $heap, JSON_mZeroCopy_mDeserializer_mValues.__default.Value#Handle($ly, $reveal), $Box($fh$3x#0))): DatatypeType);

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$3x#0) } Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$3x#0) == $Box(JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($Unbox($fh$3x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$3x#0: Box :: { Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$3x#0) } Requires1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$3x#0) <==> JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#requires($Unbox($fh$3x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$3x#0: Box :: { Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$3x#0)[$bx] } Reads1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $fh$3x#0)[$bx] <==> false);

axiom (forall $heap: Heap, $fh$3x#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$3x#0), $IsGoodHeap($heap) } JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError($fh$3x#0) == $Unbox(Apply1(Tclass.JSON_mUtils_mCursors.CursorError(Tclass.JSON_mErrors.DeserializationError()), Tclass.JSON_mErrors.DeserializationError(), $heap, JSON_mZeroCopy_mDeserializer_mAPI.__default.LiftCursorError#Handle(), $Box($fh$3x#0))): DatatypeType);

axiom (forall v#0: DatatypeType :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(v#0) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(v#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(JSON_mUtils_mCursors.Cursor__.OfView(v#0)) && (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#6)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) && (var cs#6 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#6), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#6 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#6), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#6) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#6) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#6)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, v#0) == (var valueOrError0#6 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, JSON_mUtils_mCursors.Cursor__.OfView(v#0)); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#6) else (var text#6, cs#6 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6)): DatatypeType); (var valueOrError1#6 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#6), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#6) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#6) else #Wrappers.Result.Success($Box(text#6))))))));

axiom (forall v#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(v#0)) || $Is(v#0, Tclass.JSON_mUtils_mViews_mCore.View()) ==> JSON_mUtils_mCursors.Cursor__.OfView#canCall(Lit(v#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON#canCall(Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))) && (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); Wrappers.Result.IsFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) && (Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) ==> Wrappers.Result.PropagateFailure#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#7)) && (!Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) ==> Wrappers.Result.Extract#canCall(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) && (var cs#7 := JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7)): DatatypeType); Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#7), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))) && (var valueOrError1#7 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#7), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#7)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(true, Lit(v#0)) == (var valueOrError0#7 := JSON_mZeroCopy_mDeserializer_mAPI.__default.JSON(reveal_JSON.ZeroCopy.Deserializer.API._default.JSON, Lit(JSON_mUtils_mCursors.Cursor__.OfView(Lit(v#0)))); (if Wrappers.Result.IsFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) then Wrappers.Result.PropagateFailure(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#7) else (var text#7, cs#7 := $Unbox(JSON_mUtils_mCursors.Split.t($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7)): DatatypeType)): DatatypeType, JSON_mUtils_mCursors.Split.cs($Unbox(Wrappers.Result.Extract(Tclass.JSON_mUtils_mCursors.Split(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())), Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7)): DatatypeType); (var valueOrError1#7 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), JSON_mUtils_mCursors.Cursor__.EOF_q(cs#7), $Box(Lit(#JSON.Errors.DeserializationError.ExpectingEOF()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError1#7) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError1#7) else #Wrappers.Result.Success($Box(text#7))))))));

axiom (forall bs#0: Seq :: { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#6 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#6)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, bs#0) == (var valueOrError0#6 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(bs#0) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#6) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#6) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, JSON_mUtils_mViews_mCore.View__.OfBytes(bs#0)))));

axiom (forall bs#0: Seq :: {:weight 3} { JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) } JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(Lit(bs#0)) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> Wrappers.__default.Need#canCall(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))) && (var valueOrError0#7 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); Wrappers.Outcome.IsFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) && (Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) ==> Wrappers.Outcome.PropagateFailure#canCall(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#7)) && (!Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) ==> JSON_mUtils_mViews_mCore.View__.OfBytes#canCall(Lit(bs#0)) && JSON_mZeroCopy_mDeserializer_mAPI.__default.Text#canCall(Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))) && JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(true, Lit(bs#0)) == (var valueOrError0#7 := Wrappers.__default.Need(Tclass.JSON_mErrors.DeserializationError(), Seq#Length(Lit(bs#0)) < BoundedInts.__default.TWO__TO__THE__32(), $Box(Lit(#JSON.Errors.DeserializationError.IntOverflow()))); (if Wrappers.Outcome.IsFailure(Tclass.JSON_mErrors.DeserializationError(), valueOrError0#7) then Wrappers.Outcome.PropagateFailure(Tclass.JSON_mErrors.DeserializationError(), Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), valueOrError0#7) else JSON_mZeroCopy_mDeserializer_mAPI.__default.Text(reveal_JSON.ZeroCopy.Deserializer.API._default.Text, Lit(JSON_mUtils_mViews_mCore.View__.OfBytes(Lit(bs#0)))))));

axiom (forall $reveal: bool, js#0: DatatypeType :: { JSON_mZeroCopy_mAPI.__default.Serialize($reveal, js#0) } JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> Wrappers.Result#Equal(JSON_mZeroCopy_mAPI.__default.Serialize($reveal, js#0), #Wrappers.Result.Success($Box(JSON_mConcreteSyntax_mSpec.__default.JSON(js#0)))) && $Is(JSON_mZeroCopy_mAPI.__default.Serialize($reveal, js#0), Tclass.Wrappers.Result(TSeq(Tclass.BoundedInts.uint8()), Tclass.JSON_mErrors.SerializationError())));

axiom (forall js#0: DatatypeType :: { JSON_mZeroCopy_mAPI.__default.Serialize(true, js#0) } JSON_mZeroCopy_mAPI.__default.Serialize#canCall(js#0) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> JSON_mZeroCopy_mSerializer.__default.Text#canCall(js#0) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0)) && JSON_mZeroCopy_mAPI.__default.Serialize(true, js#0) == #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, js#0)))));

axiom (forall js#0: DatatypeType :: {:weight 3} { JSON_mZeroCopy_mAPI.__default.Serialize(true, Lit(js#0)) } JSON_mZeroCopy_mAPI.__default.Serialize#canCall(Lit(js#0)) || $Is(js#0, Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value())) ==> JSON_mZeroCopy_mSerializer.__default.Text#canCall(Lit(js#0)) && JSON_mUtils_mViews_mWriters.Writer__.Bytes#canCall(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, Lit(js#0))) && JSON_mZeroCopy_mAPI.__default.Serialize(true, Lit(js#0)) == #Wrappers.Result.Success($Box(JSON_mUtils_mViews_mWriters.Writer__.Bytes(JSON_mZeroCopy_mSerializer.__default.Text(reveal_JSON.ZeroCopy.Serializer._default.Text, Lit(js#0))))));

axiom (forall $reveal: bool, bs#0: Seq :: { JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0) } JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> (Wrappers.Result.Success_q(JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0)) ==> Seq#Equal(bs#0, JSON_mConcreteSyntax_mSpec.__default.JSON($Unbox(Wrappers.Result.value(JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0))): DatatypeType))) && $Is(JSON_mZeroCopy_mAPI.__default.Deserialize($reveal, bs#0), Tclass.Wrappers.Result(Tclass.JSON_mGrammar.Structural(Tclass.JSON_mGrammar.Value()), Tclass.JSON_mErrors.DeserializationError())));

axiom (forall bs#0: Seq :: { JSON_mZeroCopy_mAPI.__default.Deserialize(true, bs#0) } JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(bs#0) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(bs#0) && JSON_mZeroCopy_mAPI.__default.Deserialize(true, bs#0) == JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, bs#0));

axiom (forall bs#0: Seq :: {:weight 3} { JSON_mZeroCopy_mAPI.__default.Deserialize(true, Lit(bs#0)) } JSON_mZeroCopy_mAPI.__default.Deserialize#canCall(Lit(bs#0)) || $Is(bs#0, TSeq(Tclass.BoundedInts.uint8())) ==> JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes#canCall(Lit(bs#0)) && JSON_mZeroCopy_mAPI.__default.Deserialize(true, Lit(bs#0)) == JSON_mZeroCopy_mDeserializer_mAPI.__default.OfBytes(reveal_JSON.ZeroCopy.Deserializer.API._default.OfBytes, Lit(bs#0)));

implementation {:verboseName "StandardLibrary.UInt.UInt16SeqSerializeDeserialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt16SeqSerializeDeserialize(x#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.UInt16SeqDeserializeSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt16SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt16SeqDeserializeSerialize(s#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.UInt32SeqSerializeDeserialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt32SeqSerializeDeserialize(x#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.UInt32SeqDeserializeSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt32SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt32SeqDeserializeSerialize(s#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.UInt64SeqSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0: int, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqSerialize", " | ", x#0, " | ", s#0} true;
    assume {:print "Types", " | ", "int", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt64SeqSerialize(x#0, s#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.UInt64SeqSerializeDeserialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqSerializeDeserialize", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt64SeqSerializeDeserialize(x#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.UInt64SeqDeserializeSerialize (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.UInt64SeqDeserializeSerialize", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.UInt64SeqDeserializeSerialize(s#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.SeqToNatZeroPrefix (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqToNatZeroPrefix", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.SeqToNatZeroPrefix(s#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt.SeqWithUInt32Suffix (call postcondition)"} CallPost$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0: Seq, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt.SeqWithUInt32Suffix", " | ", s#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary_mUInt.__default.SeqWithUInt32Suffix(s#0, n#0);
    return;
}



implementation {:verboseName "StandardLibrary.Sequence.SequenceEqual (call postcondition)"} CallPost$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T: Ty, seq1#0: Seq, seq2#0: Seq, start1#0: int, start2#0: int, size#0: int) returns (ret#0: bool)
{
  var defass#ret#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.Sequence.SequenceEqual", " | ", StandardLibrary.Sequence._default.SequenceEqual$T, " | ", seq1#0, " | ", seq2#0, " | ", start1#0, " | ", start2#0, " | ", size#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    call defass#ret#0, ret#0, $_reverifyPost := Impl$$StandardLibrary_mSequence.__default.SequenceEqual(StandardLibrary.Sequence._default.SequenceEqual$T, seq1#0, seq2#0, start1#0, start2#0, size#0);
    return;
}



implementation {:verboseName "StandardLibrary.String.HasSubString (call postcondition)"} CallPost$$String.__default.HasSubString(haystack#0: Seq, needle#0: Seq) returns (o#0: DatatypeType)
{
  var defass#o#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.String.HasSubString", " | ", haystack#0, " | ", needle#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call defass#o#0, o#0, $_reverifyPost := Impl$$String.__default.HasSubString(haystack#0, needle#0);
    return;
}



implementation {:verboseName "StandardLibrary.SeqTakeAppend (call postcondition)"} CallPost$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A: Ty, s#0: Seq, i#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqTakeAppend", " | ", StandardLibrary._default.SeqTakeAppend$A, " | ", s#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.SeqTakeAppend(StandardLibrary._default.SeqTakeAppend$A, s#0, i#0);
    return;
}



implementation {:verboseName "StandardLibrary.WillSplitOnDelim (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T: Ty, s#0: Seq, delim#0: Box, prefix#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.WillSplitOnDelim", " | ", StandardLibrary._default.WillSplitOnDelim$T, " | ", s#0, " | ", delim#0, " | ", prefix#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.WillSplitOnDelim(StandardLibrary._default.WillSplitOnDelim$T, s#0, delim#0, prefix#0);
    return;
}



implementation {:verboseName "StandardLibrary.WillNotSplitWithOutDelim (call postcondition)"} CallPost$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T: Ty, s#0: Seq, delim#0: Box)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.WillNotSplitWithOutDelim", " | ", StandardLibrary._default.WillNotSplitWithOutDelim$T, " | ", s#0, " | ", delim#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.WillNotSplitWithOutDelim(StandardLibrary._default.WillNotSplitWithOutDelim$T, s#0, delim#0);
    return;
}



implementation {:verboseName "StandardLibrary.FindIndexMatchingLocatesElem (call postcondition)"} CallPost$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T: Ty, s#0: Seq, c#0: Box, start#0: int, elemIndex#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.FindIndexMatchingLocatesElem", " | ", StandardLibrary._default.FindIndexMatchingLocatesElem$T, " | ", s#0, " | ", c#0, " | ", start#0, " | ", elemIndex#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Box", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.FindIndexMatchingLocatesElem(StandardLibrary._default.FindIndexMatchingLocatesElem$T, s#0, c#0, start#0, elemIndex#0);
    return;
}



implementation {:verboseName "StandardLibrary.FilterIsDistributive (call postcondition)"} CallPost$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T: Ty, s#0: Seq, s'#0: Seq, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.FilterIsDistributive", " | ", StandardLibrary._default.FilterIsDistributive$T, " | ", s#0, " | ", s'#0, " | ", f#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.FilterIsDistributive(StandardLibrary._default.FilterIsDistributive$T, s#0, s'#0, f#0);
    return;
}



implementation {:verboseName "StandardLibrary.SeqToArray (call postcondition)"} CallPost$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T: Ty, s#0: Seq) returns (a#0: ref)
{
  var defass#a#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqToArray", " | ", StandardLibrary._default.SeqToArray$T, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call defass#a#0, a#0, $_reverifyPost := Impl$$StandardLibrary.__default.SeqToArray(StandardLibrary._default.SeqToArray$T, s#0);
    return;
}



implementation {:verboseName "StandardLibrary.SeqPartsMakeWhole (call postcondition)"} CallPost$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T: Ty, s#0: Seq, i#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.SeqPartsMakeWhole", " | ", StandardLibrary._default.SeqPartsMakeWhole$T, " | ", s#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.SeqPartsMakeWhole(StandardLibrary._default.SeqPartsMakeWhole$T, s#0, i#0);
    return;
}



implementation {:verboseName "StandardLibrary.UInt8LessIsTrichotomousTransitive (call postcondition)"} CallPost$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.UInt8LessIsTrichotomousTransitive"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.UInt8LessIsTrichotomousTransitive();
    return;
}



implementation {:verboseName "StandardLibrary.LexIsReflexive (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T: Ty, a#0: Seq, less#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsReflexive", " | ", StandardLibrary._default.LexIsReflexive$T, " | ", a#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.LexIsReflexive(StandardLibrary._default.LexIsReflexive$T, a#0, less#0);
    return;
}



implementation {:verboseName "StandardLibrary.LexIsAntisymmetric (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsAntisymmetric", " | ", StandardLibrary._default.LexIsAntisymmetric$T, " | ", a#0, " | ", b#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.LexIsAntisymmetric(StandardLibrary._default.LexIsAntisymmetric$T, a#0, b#0, less#0);
    return;
}



implementation {:verboseName "StandardLibrary.LexIsTransitive (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T: Ty, a#0: Seq, b#0: Seq, c#0: Seq, less#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsTransitive", " | ", StandardLibrary._default.LexIsTransitive$T, " | ", a#0, " | ", b#0, " | ", c#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.LexIsTransitive(StandardLibrary._default.LexIsTransitive$T, a#0, b#0, c#0, less#0);
    return;
}



implementation {:verboseName "StandardLibrary.LexIsTotal (call postcondition)"} CallPost$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T: Ty, a#0: Seq, b#0: Seq, less#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.LexIsTotal", " | ", StandardLibrary._default.LexIsTotal$T, " | ", a#0, " | ", b#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.LexIsTotal(StandardLibrary._default.LexIsTotal$T, a#0, b#0, less#0);
    return;
}



implementation {:verboseName "StandardLibrary.ThereIsAMinimum (call postcondition)"} CallPost$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T: Ty, s#0: Set, less#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.ThereIsAMinimum", " | ", StandardLibrary._default.ThereIsAMinimum$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.ThereIsAMinimum(StandardLibrary._default.ThereIsAMinimum$T, s#0, less#0);
    return;
}



implementation {:verboseName "StandardLibrary.MinimumIsUnique (call postcondition)"} CallPost$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T: Ty, a#0: Seq, b#0: Seq, s#0: Set, less#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.MinimumIsUnique", " | ", StandardLibrary._default.MinimumIsUnique$T, " | ", a#0, " | ", b#0, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Set", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$StandardLibrary.__default.MinimumIsUnique(StandardLibrary._default.MinimumIsUnique$T, a#0, b#0, s#0, less#0);
    return;
}



implementation {:verboseName "StandardLibrary.FindMinimum (call postcondition)"} CallPost$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T: Ty, s#0: Set, less#0: HandleType) returns (a#0: Seq)
{
  var defass#a#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "StandardLibrary.FindMinimum", " | ", StandardLibrary._default.FindMinimum$T, " | ", s#0, " | ", less#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Set", " | ", "HandleType"} true;
    call defass#a#0, a#0, $_reverifyPost := Impl$$StandardLibrary.__default.FindMinimum(StandardLibrary._default.FindMinimum$T, s#0, less#0);
    return;
}



implementation {:verboseName "UTF8.EncodeAsciiUnique2 (call postcondition)"} CallPost$$UTF8.__default.EncodeAsciiUnique2(x#0: Seq, y#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UTF8.EncodeAsciiUnique2", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UTF8.__default.EncodeAsciiUnique2(x#0, y#0);
    return;
}



implementation {:verboseName "UTF8.EncodeAsciiUnique (call postcondition)"} CallPost$$UTF8.__default.EncodeAsciiUnique()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UTF8.EncodeAsciiUnique"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$UTF8.__default.EncodeAsciiUnique();
    return;
}



implementation {:verboseName "UTF8.ValidUTF8Embed (call postcondition)"} CallPost$$UTF8.__default.ValidUTF8Embed(a#0: Seq, b#0: Seq, c#0: Seq, lo#0: int, hi#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Embed", " | ", a#0, " | ", b#0, " | ", c#0, " | ", lo#0, " | ", hi#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$UTF8.__default.ValidUTF8Embed(a#0, b#0, c#0, lo#0, hi#0);
    return;
}



implementation {:verboseName "UTF8.ValidUTF8Concat (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$UTF8.__default.ValidUTF8Concat(s#0: Seq, t#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UTF8.ValidUTF8Concat", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UTF8.__default.ValidUTF8Concat(s#0, t#0);
    return;
}



implementation {:verboseName "Digest.Digest (call postcondition)"} CallPost$$Digest.__default.Digest(input#0: DatatypeType) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Digest.Digest", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Digest.__default.Digest(input#0);
    return;
}



implementation {:verboseName "KdfCtr.KdfCounterMode (call postcondition)"} {:testEntry} CallPost$$KdfCtr.__default.KdfCounterMode(input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "KdfCtr.KdfCounterMode", " | ", input#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$KdfCtr.__default.KdfCounterMode(input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRandomBytes(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Digest(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExtract(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.HkdfExpand(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.Hkdf(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.KdfCounterMode(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AesKdfCounterMode(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESEncrypt(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.AESDecrypt(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateRSAKeyPair(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSADecrypt(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.RSAEncrypt(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECDSASignatureKey(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSASign(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ECDSAVerify(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GenerateECCKeyPair(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.GetPublicKeyFromPrivateKey(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ValidatePublicKey(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DeriveSharedSecret(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.CompressPublicKey(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.DecompressPublicKey(this, input#0);
    return;
}



implementation {:verboseName "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey (call postcondition)"} CallPost$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this: ref, input#0: DatatypeType) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey", " | ", this, " | ", input#0} true;
    assume {:print "Types", " | ", "ref", " | ", "DatatypeType"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$AbstractAwsCryptographyPrimitivesService.AtomicPrimitivesClient.ParsePublicKey(this, input#0);
    return;
}



implementation {:verboseName "Relations.LemmaNewFirstElementStillSortedBy (call postcondition)"} CallPost$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T: Ty, x#0: Box, s#0: Seq, lessThan#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Relations.LemmaNewFirstElementStillSortedBy", " | ", Relations._default.LemmaNewFirstElementStillSortedBy$T, " | ", x#0, " | ", s#0, " | ", lessThan#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$Relations.__default.LemmaNewFirstElementStillSortedBy(Relations._default.LemmaNewFirstElementStillSortedBy$T, x#0, s#0, lessThan#0);
    return;
}



implementation {:verboseName "Seq.LemmaLast (call postcondition)"} CallPost$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaLast", " | ", Seq._default.LemmaLast$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaLast(Seq._default.LemmaLast$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaAppendLast (call postcondition)"} CallPost$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaAppendLast", " | ", Seq._default.LemmaAppendLast$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaAppendLast(Seq._default.LemmaAppendLast$T, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaConcatIsAssociative (call postcondition)"} CallPost$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T: Ty, xs#0: Seq, ys#0: Seq, zs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaConcatIsAssociative", " | ", Seq._default.LemmaConcatIsAssociative$T, " | ", xs#0, " | ", ys#0, " | ", zs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaConcatIsAssociative(Seq._default.LemmaConcatIsAssociative$T, xs#0, ys#0, zs#0);
    return;
}



implementation {:verboseName "Seq.IndexingImpliesMembership (call postcondition)"} CallPost$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T: Ty, p#0: HandleType, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.IndexingImpliesMembership", " | ", Seq._default.IndexingImpliesMembership$T, " | ", p#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.IndexingImpliesMembership(Seq._default.IndexingImpliesMembership$T, p#0, xs#0);
    return;
}



implementation {:verboseName "Seq.MembershipImpliesIndexing (call postcondition)"} CallPost$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T: Ty, p#0: HandleType, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.MembershipImpliesIndexing", " | ", Seq._default.MembershipImpliesIndexing$T, " | ", p#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.MembershipImpliesIndexing(Seq._default.MembershipImpliesIndexing$T, p#0, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaSplitAt (call postcondition)"} CallPost$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T: Ty, xs#0: Seq, pos#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaSplitAt", " | ", Seq._default.LemmaSplitAt$T, " | ", xs#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaSplitAt(Seq._default.LemmaSplitAt$T, xs#0, pos#0);
    return;
}



implementation {:verboseName "Seq.LemmaElementFromSlice (call postcondition)"} CallPost$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T: Ty, xs#0: Seq, xs'#0: Seq, a#0: int, b#0: int, pos#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaElementFromSlice", " | ", Seq._default.LemmaElementFromSlice$T, " | ", xs#0, " | ", xs'#0, " | ", a#0, " | ", b#0, " | ", pos#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaElementFromSlice(Seq._default.LemmaElementFromSlice$T, xs#0, xs'#0, a#0, b#0, pos#0);
    return;
}



implementation {:verboseName "Seq.LemmaSliceOfSlice (call postcondition)"} CallPost$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T: Ty, xs#0: Seq, s1#0: int, e1#0: int, s2#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaSliceOfSlice", " | ", Seq._default.LemmaSliceOfSlice$T, " | ", xs#0, " | ", s1#0, " | ", e1#0, " | ", s2#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaSliceOfSlice(Seq._default.LemmaSliceOfSlice$T, xs#0, s1#0, e1#0, s2#0, e2#0);
    return;
}



implementation {:verboseName "Seq.ToArray (call postcondition)"} CallPost$$Seq.__default.ToArray(Seq._default.ToArray$T: Ty, xs#0: Seq) returns (a#0: ref)
{
  var defass#a#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.ToArray", " | ", Seq._default.ToArray$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call defass#a#0, a#0, $_reverifyPost := Impl$$Seq.__default.ToArray(Seq._default.ToArray$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaCardinalityOfSet (call postcondition)"} CallPost$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaCardinalityOfSet", " | ", Seq._default.LemmaCardinalityOfSet$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaCardinalityOfSet(Seq._default.LemmaCardinalityOfSet$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaCardinalityOfEmptySetIs0 (call postcondition)"} CallPost$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaCardinalityOfEmptySetIs0", " | ", Seq._default.LemmaCardinalityOfEmptySetIs0$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaCardinalityOfEmptySetIs0(Seq._default.LemmaCardinalityOfEmptySetIs0$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaNoDuplicatesInConcat (call postcondition)"} {:timeLimit 30} CallPost$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaNoDuplicatesInConcat", " | ", Seq._default.LemmaNoDuplicatesInConcat$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaNoDuplicatesInConcat(Seq._default.LemmaNoDuplicatesInConcat$T, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaCardinalityOfSetNoDuplicates (call postcondition)"} CallPost$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaCardinalityOfSetNoDuplicates", " | ", Seq._default.LemmaCardinalityOfSetNoDuplicates$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaCardinalityOfSetNoDuplicates(Seq._default.LemmaCardinalityOfSetNoDuplicates$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaNoDuplicatesCardinalityOfSet (call postcondition)"} CallPost$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaNoDuplicatesCardinalityOfSet", " | ", Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaNoDuplicatesCardinalityOfSet(Seq._default.LemmaNoDuplicatesCardinalityOfSet$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaMultisetHasNoDuplicates (call postcondition)"} CallPost$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaMultisetHasNoDuplicates", " | ", Seq._default.LemmaMultisetHasNoDuplicates$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaMultisetHasNoDuplicates(Seq._default.LemmaMultisetHasNoDuplicates$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaZipOfUnzip (call postcondition)"} CallPost$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A: Ty, Seq._default.LemmaZipOfUnzip$B: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaZipOfUnzip", " | ", Seq._default.LemmaZipOfUnzip$A, " | ", Seq._default.LemmaZipOfUnzip$B, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaZipOfUnzip(Seq._default.LemmaZipOfUnzip$A, Seq._default.LemmaZipOfUnzip$B, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaMaxOfConcat (call postcondition)"} CallPost$$Seq.__default.LemmaMaxOfConcat(xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaMaxOfConcat", " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaMaxOfConcat(xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaMinOfConcat (call postcondition)"} CallPost$$Seq.__default.LemmaMinOfConcat(xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaMinOfConcat", " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaMinOfConcat(xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaSubseqMax (call postcondition)"} CallPost$$Seq.__default.LemmaSubseqMax(xs#0: Seq, from#0: int, to#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaSubseqMax", " | ", xs#0, " | ", from#0, " | ", to#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaSubseqMax(xs#0, from#0, to#0);
    return;
}



implementation {:verboseName "Seq.LemmaSubseqMin (call postcondition)"} CallPost$$Seq.__default.LemmaSubseqMin(xs#0: Seq, from#0: int, to#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaSubseqMin", " | ", xs#0, " | ", from#0, " | ", to#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaSubseqMin(xs#0, from#0, to#0);
    return;
}



implementation {:verboseName "Seq.LemmaFlattenConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenConcat", " | ", Seq._default.LemmaFlattenConcat$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFlattenConcat(Seq._default.LemmaFlattenConcat$T, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaFlattenReverseConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T: Ty, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenReverseConcat", " | ", Seq._default.LemmaFlattenReverseConcat$T, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFlattenReverseConcat(Seq._default.LemmaFlattenReverseConcat$T, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaFlattenAndFlattenReverseAreEquivalent (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T: Ty, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenAndFlattenReverseAreEquivalent", " | ", Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFlattenAndFlattenReverseAreEquivalent(Seq._default.LemmaFlattenAndFlattenReverseAreEquivalent$T, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaFlattenLengthGeSingleElementLength (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T: Ty, xs#0: Seq, i#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenLengthGeSingleElementLength", " | ", Seq._default.LemmaFlattenLengthGeSingleElementLength$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFlattenLengthGeSingleElementLength(Seq._default.LemmaFlattenLengthGeSingleElementLength$T, xs#0, i#0);
    return;
}



implementation {:verboseName "Seq.LemmaFlattenLengthLeMul (call postcondition)"} CallPost$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T: Ty, xs#0: Seq, j#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFlattenLengthLeMul", " | ", Seq._default.LemmaFlattenLengthLeMul$T, " | ", xs#0, " | ", j#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFlattenLengthLeMul(Seq._default.LemmaFlattenLengthLeMul$T, xs#0, j#0);
    return;
}



implementation {:verboseName "Seq.LemmaMapDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T: Ty, Seq._default.LemmaMapDistributesOverConcat$R: Ty, f#0: HandleType, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaMapDistributesOverConcat", " | ", Seq._default.LemmaMapDistributesOverConcat$T, " | ", Seq._default.LemmaMapDistributesOverConcat$R, " | ", f#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaMapDistributesOverConcat(Seq._default.LemmaMapDistributesOverConcat$T, Seq._default.LemmaMapDistributesOverConcat$R, f#0, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaFilterDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T: Ty, f#0: HandleType, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFilterDistributesOverConcat", " | ", Seq._default.LemmaFilterDistributesOverConcat$T, " | ", f#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "HandleType", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFilterDistributesOverConcat(Seq._default.LemmaFilterDistributesOverConcat$T, f#0, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaFoldLeftDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A: Ty, Seq._default.LemmaFoldLeftDistributesOverConcat$T: Ty, f#0: HandleType, init#0: Box, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFoldLeftDistributesOverConcat", " | ", Seq._default.LemmaFoldLeftDistributesOverConcat$A, " | ", Seq._default.LemmaFoldLeftDistributesOverConcat$T, " | ", f#0, " | ", init#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Box", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFoldLeftDistributesOverConcat(Seq._default.LemmaFoldLeftDistributesOverConcat$A, Seq._default.LemmaFoldLeftDistributesOverConcat$T, f#0, init#0, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaInvFoldLeft (call postcondition)"} CallPost$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A: Ty, Seq._default.LemmaInvFoldLeft$B: Ty, inv#0: HandleType, stp#0: HandleType, f#0: HandleType, b#0: Box, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaInvFoldLeft", " | ", Seq._default.LemmaInvFoldLeft$A, " | ", Seq._default.LemmaInvFoldLeft$B, " | ", inv#0, " | ", stp#0, " | ", f#0, " | ", b#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "HandleType", " | ", "HandleType", " | ", "Box", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaInvFoldLeft(Seq._default.LemmaInvFoldLeft$A, Seq._default.LemmaInvFoldLeft$B, inv#0, stp#0, f#0, b#0, xs#0);
    return;
}



implementation {:verboseName "Seq.LemmaFoldRightDistributesOverConcat (call postcondition)"} CallPost$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A: Ty, Seq._default.LemmaFoldRightDistributesOverConcat$T: Ty, f#0: HandleType, init#0: Box, xs#0: Seq, ys#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaFoldRightDistributesOverConcat", " | ", Seq._default.LemmaFoldRightDistributesOverConcat$A, " | ", Seq._default.LemmaFoldRightDistributesOverConcat$T, " | ", f#0, " | ", init#0, " | ", xs#0, " | ", ys#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Box", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaFoldRightDistributesOverConcat(Seq._default.LemmaFoldRightDistributesOverConcat$A, Seq._default.LemmaFoldRightDistributesOverConcat$T, f#0, init#0, xs#0, ys#0);
    return;
}



implementation {:verboseName "Seq.LemmaInvFoldRight (call postcondition)"} CallPost$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A: Ty, Seq._default.LemmaInvFoldRight$B: Ty, inv#0: HandleType, stp#0: HandleType, f#0: HandleType, b#0: Box, xs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.LemmaInvFoldRight", " | ", Seq._default.LemmaInvFoldRight$A, " | ", Seq._default.LemmaInvFoldRight$B, " | ", inv#0, " | ", stp#0, " | ", f#0, " | ", b#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "HandleType", " | ", "HandleType", " | ", "Box", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Seq.__default.LemmaInvFoldRight(Seq._default.LemmaInvFoldRight$A, Seq._default.LemmaInvFoldRight$B, inv#0, stp#0, f#0, b#0, xs#0);
    return;
}



implementation {:verboseName "Seq.FlatMap (call postcondition)"} CallPost$$Seq.__default.FlatMap(Seq._default.FlatMap$T: Ty, Seq._default.FlatMap$R: Ty, f#0: HandleType, xs#0: Seq) returns (result#0: Seq)
{
  var defass#result#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Seq.FlatMap", " | ", Seq._default.FlatMap$T, " | ", Seq._default.FlatMap$R, " | ", f#0, " | ", xs#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "HandleType", " | ", "Seq"} true;
    call defass#result#0, result#0, $_reverifyPost := Impl$$Seq.__default.FlatMap(Seq._default.FlatMap$T, Seq._default.FlatMap$R, f#0, xs#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UnicodeEncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0, s#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UnicodeEncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UnicodeEncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UnicodeEncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0, s#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences", " | ", ms#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UnicodeEncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq, t#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.LemmaConcatWellFormedCodeUnitSubsequences", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$UnicodeEncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0, t#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (maybeParts#0: DatatypeType)
{
  var defass#maybeParts#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#maybeParts#0, maybeParts#0, $_reverifyPost := Impl$$UnicodeEncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.EncodeScalarSequence (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (s#0: Seq)
{
  var defass#s#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#s#0, s#0, $_reverifyPost := Impl$$UnicodeEncodingForm.__default.EncodeScalarSequence(vs#0);
    return;
}



implementation {:verboseName "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked (call postcondition)"} CallPost$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (maybeVs#0: DatatypeType)
{
  var defass#maybeVs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "UnicodeEncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#maybeVs#0, maybeVs#0, $_reverifyPost := Impl$$UnicodeEncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf8EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0, s#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf8EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf8EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf8EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0, s#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences", " | ", ms#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf8EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq, t#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf8EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0, t#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.PartitionCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (maybeParts#0: DatatypeType)
{
  var defass#maybeParts#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#maybeParts#0, maybeParts#0, $_reverifyPost := Impl$$Utf8EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.EncodeScalarSequence (call postcondition)"} CallPost$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (s#0: Seq)
{
  var defass#s#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#s#0, s#0, $_reverifyPost := Impl$$Utf8EncodingForm.__default.EncodeScalarSequence(vs#0);
    return;
}



implementation {:verboseName "Utf8EncodingForm.DecodeCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (maybeVs#0: DatatypeType)
{
  var defass#maybeVs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf8EncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#maybeVs#0, maybeVs#0, $_reverifyPost := Impl$$Utf8EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0: Seq, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf16EncodingForm.__default.LemmaSplitPrefixMinimalWellFormedCodeUnitSubsequenceInvertsPrepend(m#0, s#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaPartitionMinimalWellFormedCodeUnitSubsequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf16EncodingForm.__default.LemmaPartitionMinimalWellFormedCodeUnitSubsequence(m#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence", " | ", m#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf16EncodingForm.__default.LemmaMinimalWellFormedCodeUnitSubsequenceIsWellFormedSequence(m#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0: Seq, s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaPrependMinimalWellFormedCodeUnitSubsequence", " | ", m#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf16EncodingForm.__default.LemmaPrependMinimalWellFormedCodeUnitSubsequence(m#0, s#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaFlattenMinimalWellFormedCodeUnitSubsequences", " | ", ms#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf16EncodingForm.__default.LemmaFlattenMinimalWellFormedCodeUnitSubsequences(ms#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences (call postcondition)"} CallPost$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0: Seq, t#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.LemmaConcatWellFormedCodeUnitSubsequences", " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Utf16EncodingForm.__default.LemmaConcatWellFormedCodeUnitSubsequences(s#0, t#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.PartitionCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0: Seq) returns (maybeParts#0: DatatypeType)
{
  var defass#maybeParts#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.PartitionCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#maybeParts#0, maybeParts#0, $_reverifyPost := Impl$$Utf16EncodingForm.__default.PartitionCodeUnitSequenceChecked(s#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.EncodeScalarSequence (call postcondition)"} CallPost$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0: Seq) returns (s#0: Seq)
{
  var defass#s#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.EncodeScalarSequence", " | ", vs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#s#0, s#0, $_reverifyPost := Impl$$Utf16EncodingForm.__default.EncodeScalarSequence(vs#0);
    return;
}



implementation {:verboseName "Utf16EncodingForm.DecodeCodeUnitSequenceChecked (call postcondition)"} CallPost$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0: Seq) returns (maybeVs#0: DatatypeType)
{
  var defass#maybeVs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Utf16EncodingForm.DecodeCodeUnitSequenceChecked", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#maybeVs#0, maybeVs#0, $_reverifyPost := Impl$$Utf16EncodingForm.__default.DecodeCodeUnitSequenceChecked(s#0);
    return;
}



implementation {:verboseName "FileIO.ReadBytesFromFile (call postcondition)"} CallPost$$FileIO.__default.ReadBytesFromFile(path#0: Seq) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "FileIO.ReadBytesFromFile", " | ", path#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$FileIO.__default.ReadBytesFromFile(path#0);
    return;
}



implementation {:verboseName "FileIO.WriteBytesToFile (call postcondition)"} CallPost$$FileIO.__default.WriteBytesToFile(path#0: Seq, bytes#0: Seq) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "FileIO.WriteBytesToFile", " | ", path#0, " | ", bytes#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$FileIO.__default.WriteBytesToFile(path#0, bytes#0);
    return;
}



implementation {:verboseName "GeneralInternals.LemmaInductionHelper (call postcondition)"} CallPost$$GeneralInternals.__default.LemmaInductionHelper(n#0: int, f#0: HandleType, x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "GeneralInternals.LemmaInductionHelper", " | ", n#0, " | ", f#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType", " | ", "int"} true;
    call $_reverifyPost := Impl$$GeneralInternals.__default.LemmaInductionHelper(n#0, f#0, x#0);
    return;
}



implementation {:verboseName "MulInternalsNonlinear.LemmaMulStrictlyPositive (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulStrictlyPositive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$MulInternalsNonlinear.__default.LemmaMulStrictlyPositive(x#0, y#0);
    return;
}



implementation {:verboseName "MulInternalsNonlinear.LemmaMulNonzero (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulNonzero", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$MulInternalsNonlinear.__default.LemmaMulNonzero(x#0, y#0);
    return;
}



implementation {:verboseName "MulInternalsNonlinear.LemmaMulIsAssociative (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulIsAssociative", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$MulInternalsNonlinear.__default.LemmaMulIsAssociative(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "MulInternalsNonlinear.LemmaMulIsDistributiveAdd (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulIsDistributiveAdd", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$MulInternalsNonlinear.__default.LemmaMulIsDistributiveAdd(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "MulInternalsNonlinear.LemmaMulOrdering (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulOrdering", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$MulInternalsNonlinear.__default.LemmaMulOrdering(x#0, y#0);
    return;
}



implementation {:verboseName "MulInternalsNonlinear.LemmaMulStrictInequality (call postcondition)"} CallPost$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternalsNonlinear.LemmaMulStrictInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$MulInternalsNonlinear.__default.LemmaMulStrictInequality(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "MulInternals.LemmaMulInduction (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulInduction(f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulInduction", " | ", f#0} true;
    assume {:print "Types", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulInduction(f#0);
    return;
}



implementation {:verboseName "MulInternals.LemmaMulCommutes (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulCommutes()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulCommutes"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulCommutes();
    return;
}



implementation {:verboseName "MulInternals.LemmaMulSuccessor (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulSuccessor()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulSuccessor"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulSuccessor();
    return;
}



implementation {:verboseName "MulInternals.LemmaMulDistributes (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulDistributes()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulDistributes"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulDistributes();
    return;
}



implementation {:verboseName "MulInternals.LemmaMulAuto (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulAuto();
    return;
}



implementation {:verboseName "MulInternals.LemmaMulInductionAuto (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulInductionAuto(x#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulInductionAuto", " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulInductionAuto(x#0, f#0);
    return;
}



implementation {:verboseName "MulInternals.LemmaMulInductionAutoForall (call postcondition)"} CallPost$$MulInternals.__default.LemmaMulInductionAutoForall(f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "MulInternals.LemmaMulInductionAutoForall", " | ", f#0} true;
    assume {:print "Types", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$MulInternals.__default.LemmaMulInductionAutoForall(f#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsMulRecursive (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsMulRecursive(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulRecursive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsMulRecursive(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsMulRecursiveAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsMulRecursiveAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulRecursiveAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsMulRecursiveAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsMulPos (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsMulPos(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsMulPos", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsMulPos(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulBasics (call postcondition)"} CallPost$$Mul.__default.LemmaMulBasics(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulBasics", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulBasics(x#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulBasicsAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulBasicsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulBasicsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulBasicsAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulNonzero (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonzero(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonzero", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulNonzero(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulNonzeroAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonzeroAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonzeroAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulNonzeroAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulByZeroIsZeroAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulByZeroIsZeroAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulByZeroIsZeroAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulByZeroIsZeroAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsAssociative (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsAssociative(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsAssociative", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsAssociative(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsAssociativeAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsAssociativeAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsAssociativeAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsAssociativeAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsCommutative (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsCommutative(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsCommutative", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsCommutative(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsCommutativeAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsCommutativeAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsCommutativeAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsCommutativeAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulOrdering (call postcondition)"} CallPost$$Mul.__default.LemmaMulOrdering(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulOrdering", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulOrdering(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulOrderingAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulOrderingAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulOrderingAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulOrderingAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulEquality (call postcondition)"} CallPost$$Mul.__default.LemmaMulEquality(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEquality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulEquality(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulEqualityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulEqualityAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEqualityAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulEqualityAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulInequality (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequality(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulInequality(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulInequalityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequalityAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequalityAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulInequalityAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictInequality (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequality(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictInequality(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictInequalityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequalityAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequalityAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictInequalityAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulUpperBound (call postcondition)"} CallPost$$Mul.__default.LemmaMulUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUpperBound", " | ", x#0, " | ", XBound#0, " | ", y#0, " | ", YBound#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulUpperBound(x#0, XBound#0, y#0, YBound#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulUpperBoundAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulUpperBoundAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUpperBoundAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulUpperBoundAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictUpperBound (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictUpperBound(x#0: int, XBound#0: int, y#0: int, YBound#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictUpperBound", " | ", x#0, " | ", XBound#0, " | ", y#0, " | ", YBound#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictUpperBound(x#0, XBound#0, y#0, YBound#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictUpperBoundAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictUpperBoundAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictUpperBoundAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictUpperBoundAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulLeftInequality (call postcondition)"} CallPost$$Mul.__default.LemmaMulLeftInequality(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulLeftInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulLeftInequality(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulLeftInequalityAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulLeftInequalityAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulLeftInequalityAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulLeftInequalityAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulEqualityConverse (call postcondition)"} CallPost$$Mul.__default.LemmaMulEqualityConverse(m#0: int, x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEqualityConverse", " | ", m#0, " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulEqualityConverse(m#0, x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulEqualityConverseAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulEqualityConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulEqualityConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulEqualityConverseAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulInequalityConverse (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequalityConverse(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequalityConverse", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulInequalityConverse(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulInequalityConverseAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulInequalityConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulInequalityConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulInequalityConverseAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictInequalityConverse (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequalityConverse(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequalityConverse", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictInequalityConverse(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictInequalityConverseAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictInequalityConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictInequalityConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictInequalityConverseAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveAdd (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAdd(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAdd", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveAdd(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveAddAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAddAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAddAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveAddAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWay (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAddOtherWay", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveAddOtherWay(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveAddOtherWayAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAddOtherWayAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveAddOtherWayAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveSub (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveSub(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveSub", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveSub(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveSubAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveSubAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveSubAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveSubAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributive (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributive(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributive", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributive(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIsDistributiveAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIsDistributiveAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIsDistributiveAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIsDistributiveAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictlyPositive (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyPositive(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyPositive", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictlyPositive(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictlyPositiveAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyPositiveAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyPositiveAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictlyPositiveAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictlyIncreases (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyIncreases(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyIncreases", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictlyIncreases(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulStrictlyIncreasesAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulStrictlyIncreasesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulStrictlyIncreasesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulStrictlyIncreasesAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulIncreases (call postcondition)"} CallPost$$Mul.__default.LemmaMulIncreases(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIncreases", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIncreases(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulIncreasesAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulIncreasesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulIncreasesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulIncreasesAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulNonnegative (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonnegative(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonnegative", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulNonnegative(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulNonnegativeAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulNonnegativeAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulNonnegativeAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulNonnegativeAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulUnaryNegation (call postcondition)"} CallPost$$Mul.__default.LemmaMulUnaryNegation(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUnaryNegation", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulUnaryNegation(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulUnaryNegationAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulUnaryNegationAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulUnaryNegationAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulUnaryNegationAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulCancelsNegatives (call postcondition)"} CallPost$$Mul.__default.LemmaMulCancelsNegatives(x#0: int, y#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulCancelsNegatives", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulCancelsNegatives(x#0, y#0);
    return;
}



implementation {:verboseName "Mul.LemmaMulCancelsNegativesAuto (call postcondition)"} CallPost$$Mul.__default.LemmaMulCancelsNegativesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulCancelsNegativesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulCancelsNegativesAuto();
    return;
}



implementation {:verboseName "Mul.LemmaMulProperties (call postcondition)"} CallPost$$Mul.__default.LemmaMulProperties()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Mul.LemmaMulProperties"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Mul.__default.LemmaMulProperties();
    return;
}



implementation {:verboseName "ModInternalsNonlinear.LemmaModOfZeroIsZero (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaModOfZeroIsZero", " | ", m#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternalsNonlinear.__default.LemmaModOfZeroIsZero(m#0);
    return;
}



implementation {:verboseName "ModInternalsNonlinear.LemmaFundamentalDivMod (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaFundamentalDivMod", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternalsNonlinear.__default.LemmaFundamentalDivMod(x#0, d#0);
    return;
}



implementation {:verboseName "ModInternalsNonlinear.Lemma0ModAnything (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.Lemma0ModAnything()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.Lemma0ModAnything"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$ModInternalsNonlinear.__default.Lemma0ModAnything();
    return;
}



implementation {:verboseName "ModInternalsNonlinear.LemmaSmallMod (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaSmallMod", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternalsNonlinear.__default.LemmaSmallMod(x#0, m#0);
    return;
}



implementation {:verboseName "ModInternalsNonlinear.LemmaModRange (call postcondition)"} CallPost$$ModInternalsNonlinear.__default.LemmaModRange(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternalsNonlinear.LemmaModRange", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternalsNonlinear.__default.LemmaModRange(x#0, m#0);
    return;
}



implementation {:verboseName "DivInternalsNonlinear.LemmaDivOf0 (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaDivOf0", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivInternalsNonlinear.__default.LemmaDivOf0(d#0);
    return;
}



implementation {:verboseName "DivInternalsNonlinear.LemmaDivBySelf (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaDivBySelf", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivInternalsNonlinear.__default.LemmaDivBySelf(d#0);
    return;
}



implementation {:verboseName "DivInternalsNonlinear.LemmaSmallDiv (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaSmallDiv()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaSmallDiv"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivInternalsNonlinear.__default.LemmaSmallDiv();
    return;
}



implementation {:verboseName "DivInternalsNonlinear.LemmaRealDivGt (call postcondition)"} CallPost$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0: real, y#0: real)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternalsNonlinear.LemmaRealDivGt", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "real", " | ", "real"} true;
    call $_reverifyPost := Impl$$DivInternalsNonlinear.__default.LemmaRealDivGt(x#0, y#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModInductionForall (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionForall(n#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModInductionForall(n#0, f#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModInductionForall2 (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionForall2(n#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionForall2", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModInductionForall2(n#0, f#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaDivAddDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaDivAddDenominator(n#0: int, x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaDivAddDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaDivAddDenominator(n#0, x#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaDivSubDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaDivSubDenominator(n#0: int, x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaDivSubDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaDivSubDenominator(n#0, x#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModAddDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaModAddDenominator(n#0: int, x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModAddDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModAddDenominator(n#0, x#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModSubDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaModSubDenominator(n#0: int, x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModSubDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModSubDenominator(n#0, x#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModBelowDenominator (call postcondition)"} CallPost$$ModInternals.__default.LemmaModBelowDenominator(n#0: int, x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModBelowDenominator", " | ", n#0, " | ", x#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModBelowDenominator(n#0, x#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModBasics (call postcondition)"} CallPost$$ModInternals.__default.LemmaModBasics(n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModBasics", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModBasics(n#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaQuotientAndRemainder (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$ModInternals.__default.LemmaQuotientAndRemainder(x#0: int, q#0: int, r#0: int, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaQuotientAndRemainder", " | ", x#0, " | ", q#0, " | ", r#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaQuotientAndRemainder(x#0, q#0, r#0, n#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModAuto (call postcondition)"} CallPost$$ModInternals.__default.LemmaModAuto(n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModAuto(n#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModInductionAuto (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionAuto(n#0: int, x#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionAuto", " | ", n#0, " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModInductionAuto(n#0, x#0, f#0);
    return;
}



implementation {:verboseName "ModInternals.LemmaModInductionAutoForall (call postcondition)"} CallPost$$ModInternals.__default.LemmaModInductionAutoForall(n#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "ModInternals.LemmaModInductionAutoForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$ModInternals.__default.LemmaModInductionAutoForall(n#0, f#0);
    return;
}



implementation {:verboseName "DivInternals.LemmaDivBasics (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivBasics(n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivBasics", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivInternals.__default.LemmaDivBasics(n#0);
    return;
}



implementation {:verboseName "DivInternals.LemmaDivAuto (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivAuto(n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivAuto", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivInternals.__default.LemmaDivAuto(n#0);
    return;
}



implementation {:verboseName "DivInternals.LemmaDivInductionAuto (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivInductionAuto(n#0: int, x#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivInductionAuto", " | ", n#0, " | ", x#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$DivInternals.__default.LemmaDivInductionAuto(n#0, x#0, f#0);
    return;
}



implementation {:verboseName "DivInternals.LemmaDivInductionAutoForall (call postcondition)"} CallPost$$DivInternals.__default.LemmaDivInductionAutoForall(n#0: int, f#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivInternals.LemmaDivInductionAutoForall", " | ", n#0, " | ", f#0} true;
    assume {:print "Types", " | ", "int", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$DivInternals.__default.LemmaDivInductionAutoForall(n#0, f#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsDivRecursive (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsDivRecursive(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsDivRecursive", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsDivRecursive(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsDivRecursiveAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsDivRecursiveAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsDivRecursiveAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsDivRecursiveAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivBySelf (call postcondition)"} CallPost$$DivMod.__default.LemmaDivBySelf(d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBySelf", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivBySelf(d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivOf0 (call postcondition)"} CallPost$$DivMod.__default.LemmaDivOf0(d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivOf0", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivOf0(d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivBasics (call postcondition)"} CallPost$$DivMod.__default.LemmaDivBasics(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBasics", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivBasics(x#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivBasicsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivBasicsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivBasicsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivBasicsAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaSmallDivConverseAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaSmallDivConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaSmallDivConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaSmallDivConverseAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivNonZero (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonZero(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonZero", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivNonZero(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivNonZeroAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonZeroAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonZeroAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivNonZeroAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsOrderedByDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedByDenominator", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsOrderedByDenominator(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsOrderedByDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedByDenominatorAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsOrderedByDenominatorAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsStrictlyOrderedByDenominator", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominator(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsStrictlyOrderedByDenominatorAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsStrictlyOrderedByDenominatorAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDividingSums (call postcondition)"} CallPost$$DivMod.__default.LemmaDividingSums(a#0: int, b#0: int, d#0: int, R#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDividingSums", " | ", a#0, " | ", b#0, " | ", d#0, " | ", R#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDividingSums(a#0, b#0, d#0, R#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDividingSumsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDividingSumsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDividingSumsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDividingSumsAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivPosIsPos (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPosIsPos(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPosIsPos", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivPosIsPos(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivPosIsPosAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPosIsPosAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPosIsPosAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivPosIsPosAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivPlusOne (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPlusOne(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPlusOne", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivPlusOne(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivPlusOneAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivPlusOneAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivPlusOneAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivPlusOneAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivMinusOne (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMinusOne(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMinusOne", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMinusOne(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivMinusOneAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMinusOneAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMinusOneAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMinusOneAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaBasicDiv (call postcondition)"} CallPost$$DivMod.__default.LemmaBasicDiv(d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaBasicDiv", " | ", d#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaBasicDiv(d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaBasicDivAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaBasicDivAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaBasicDivAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaBasicDivAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsOrdered (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrdered(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrdered", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsOrdered(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivIsOrderedAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivIsOrderedAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivIsOrderedAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivIsOrderedAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivDecreases (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDecreases(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDecreases", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivDecreases(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivDecreasesAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDecreasesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDecreasesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivDecreasesAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivNonincreasing (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonincreasing(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonincreasing", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivNonincreasing(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivNonincreasingAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivNonincreasingAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivNonincreasingAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivNonincreasingAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaSmallMod (call postcondition)"} CallPost$$DivMod.__default.LemmaSmallMod(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaSmallMod", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaSmallMod(x#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaBreakdown (call postcondition)"} CallPost$$DivMod.__default.LemmaBreakdown(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaBreakdown", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaBreakdown(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaBreakdownAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaBreakdownAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaBreakdownAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaBreakdownAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaRemainderUpper (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderUpper(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderUpper", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRemainderUpper(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaRemainderUpperAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderUpperAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderUpperAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRemainderUpperAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaRemainderLower (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderLower(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderLower", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRemainderLower(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaRemainderLowerAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderLowerAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderLowerAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRemainderLowerAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaRemainder (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainder(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainder", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRemainder(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaRemainderAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRemainderAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRemainderAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRemainderAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaFundamentalDivMod (call postcondition)"} CallPost$$DivMod.__default.LemmaFundamentalDivMod(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivMod", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaFundamentalDivMod(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaFundamentalDivModAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaFundamentalDivModAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaFundamentalDivModAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDenominator(x#0: int, c#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDenominator", " | ", x#0, " | ", c#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivDenominator(x#0, c#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivDenominatorAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivDenominatorAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivDenominatorAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMulHoistInequality (call postcondition)"} CallPost$$DivMod.__default.LemmaMulHoistInequality(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulHoistInequality", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulHoistInequality(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMulHoistInequalityAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulHoistInequalityAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulHoistInequalityAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulHoistInequalityAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaIndistinguishableQuotients (call postcondition)"} CallPost$$DivMod.__default.LemmaIndistinguishableQuotients(a#0: int, b#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaIndistinguishableQuotients", " | ", a#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaIndistinguishableQuotients(a#0, b#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaIndistinguishableQuotientsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaIndistinguishableQuotientsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaIndistinguishableQuotientsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaIndistinguishableQuotientsAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaTruncateMiddle (call postcondition)"} CallPost$$DivMod.__default.LemmaTruncateMiddle(x#0: int, b#0: int, c#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaTruncateMiddle", " | ", x#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaTruncateMiddle(x#0, b#0, c#0);
    return;
}



implementation {:verboseName "DivMod.LemmaTruncateMiddleAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaTruncateMiddleAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaTruncateMiddleAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaTruncateMiddleAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivMultiplesVanishQuotient (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0: int, a#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishQuotient", " | ", x#0, " | ", a#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMultiplesVanishQuotient(x#0, a#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivMultiplesVanishQuotientAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishQuotientAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMultiplesVanishQuotientAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaRoundDown (call postcondition)"} CallPost$$DivMod.__default.LemmaRoundDown(a#0: int, r#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRoundDown", " | ", a#0, " | ", r#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRoundDown(a#0, r#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaRoundDownAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaRoundDownAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaRoundDownAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaRoundDownAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivMultiplesVanishFancy (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0: int, b#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishFancy", " | ", x#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMultiplesVanishFancy(x#0, b#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivMultiplesVanishFancyAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishFancyAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMultiplesVanishFancyAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanish(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanish", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMultiplesVanish(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivMultiplesVanishAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivMultiplesVanishAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivByMultiple (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultiple(b#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultiple", " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivByMultiple(b#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivByMultipleAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultipleAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivByMultipleAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrdered (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0: int, y#0: int, m#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleIsStronglyOrdered", " | ", x#0, " | ", y#0, " | ", m#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivByMultipleIsStronglyOrdered(x#0, y#0, m#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaDivByMultipleIsStronglyOrderedAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaDivByMultipleIsStronglyOrderedAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMultiplyDivideLe (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLe(a#0: int, b#0: int, c#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLe", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMultiplyDivideLe(a#0, b#0, c#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMultiplyDivideLeAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLeAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLeAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMultiplyDivideLeAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMultiplyDivideLt (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLt(a#0: int, b#0: int, c#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLt", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMultiplyDivideLt(a#0, b#0, c#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMultiplyDivideLtAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMultiplyDivideLtAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMultiplyDivideLtAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMultiplyDivideLtAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaHoistOverDenominator (call postcondition)"} CallPost$$DivMod.__default.LemmaHoistOverDenominator(x#0: int, j#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaHoistOverDenominator", " | ", x#0, " | ", j#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaHoistOverDenominator(x#0, j#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaHoistOverDenominatorAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaHoistOverDenominatorAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaHoistOverDenominatorAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaHoistOverDenominatorAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaPartBound1 (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound1(a#0: int, b#0: int, c#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound1", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaPartBound1(a#0, b#0, c#0);
    return;
}



implementation {:verboseName "DivMod.LemmaPartBound1Auto (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound1Auto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound1Auto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaPartBound1Auto();
    return;
}



implementation {:verboseName "DivMod.LemmaModIsModRecursive (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsModRecursive(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsModRecursive", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModIsModRecursive(x#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModIsModRecursiveAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsModRecursiveAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsModRecursiveAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModIsModRecursiveAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModBasicsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModBasicsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBasicsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModBasicsAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModPropertiesAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModPropertiesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPropertiesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModPropertiesAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModDecreases (call postcondition)"} CallPost$$DivMod.__default.LemmaModDecreases(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModDecreases", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModDecreases(x#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModDecreasesAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModDecreasesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModDecreasesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModDecreasesAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModIsZero (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsZero(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsZero", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModIsZero(x#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModIsZeroAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModIsZeroAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModIsZeroAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModIsZeroAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModMultiplesBasic (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesBasic(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesBasic", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMultiplesBasic(x#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModMultiplesBasicAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesBasicAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesBasicAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMultiplesBasicAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModAddMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaModAddMultiplesVanish(b#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddMultiplesVanish", " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModAddMultiplesVanish(b#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModAddMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModAddMultiplesVanishAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModAddMultiplesVanishAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModSubMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubMultiplesVanish(b#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubMultiplesVanish", " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModSubMultiplesVanish(b#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModSubMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubMultiplesVanishAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModSubMultiplesVanishAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModMultiplesVanish (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesVanish(a#0: int, b#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesVanish", " | ", a#0, " | ", b#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMultiplesVanish(a#0, b#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModMultiplesVanishAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModMultiplesVanishAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMultiplesVanishAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMultiplesVanishAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModSubtraction (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubtraction(x#0: int, s#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubtraction", " | ", x#0, " | ", s#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModSubtraction(x#0, s#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModSubtractionAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModSubtractionAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModSubtractionAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModSubtractionAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaAddModNoop (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoop(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaAddModNoop(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaAddModNoopAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoopAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaAddModNoopAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaAddModNoopRight (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoopRight(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaAddModNoopRight(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaAddModNoopRightAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaAddModNoopRightAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaAddModNoopRightAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaAddModNoopRightAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaSubModNoop (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoop(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaSubModNoop(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaSubModNoopAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoopAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaSubModNoopAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaSubModNoopRight (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoopRight(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaSubModNoopRight(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaSubModNoopRightAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaSubModNoopRightAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaSubModNoopRightAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaSubModNoopRightAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModAdds (call postcondition)"} CallPost$$DivMod.__default.LemmaModAdds(a#0: int, b#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAdds", " | ", a#0, " | ", b#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModAdds(a#0, b#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModAddsAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModAddsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModAddsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModAddsAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModNegNeg (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$DivMod.__default.LemmaModNegNeg(x#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModNegNeg", " | ", x#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModNegNeg(x#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaFundamentalDivModConverse (call postcondition)"} {:timeLimit 50} CallPost$$DivMod.__default.LemmaFundamentalDivModConverse(x#0: int, d#0: int, q#0: int, r#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModConverse", " | ", x#0, " | ", d#0, " | ", q#0, " | ", r#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaFundamentalDivModConverse(x#0, d#0, q#0, r#0);
    return;
}



implementation {:verboseName "DivMod.LemmaFundamentalDivModConverseAuto (call postcondition)"} {:timeLimit 50} CallPost$$DivMod.__default.LemmaFundamentalDivModConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaFundamentalDivModConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaFundamentalDivModConverseAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModPosBound (call postcondition)"} CallPost$$DivMod.__default.LemmaModPosBound(x#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPosBound", " | ", x#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModPosBound(x#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModPosBoundAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModPosBoundAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModPosBoundAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModPosBoundAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopLeft (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopLeft(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopLeft", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopLeft(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopLeftAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopLeftAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopLeftAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopLeftAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopRight (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopRight(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopRight", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopRight(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopRightAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopRightAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopRightAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopRightAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopGeneral (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopGeneral(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopGeneral", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopGeneral(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopGeneralAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopGeneralAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopGeneralAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopGeneralAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoop (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoop(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoop", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoop(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaMulModNoopAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaMulModNoopAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaMulModNoopAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaMulModNoopAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModEquivalence (call postcondition)"} CallPost$$DivMod.__default.LemmaModEquivalence(x#0: int, y#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModEquivalence", " | ", x#0, " | ", y#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModEquivalence(x#0, y#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModEquivalenceAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModEquivalenceAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModEquivalenceAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModEquivalenceAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModMulEquivalent (call postcondition)"} CallPost$$DivMod.__default.LemmaModMulEquivalent(x#0: int, y#0: int, z#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMulEquivalent", " | ", x#0, " | ", y#0, " | ", z#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMulEquivalent(x#0, y#0, z#0, m#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModMulEquivalentAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModMulEquivalentAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMulEquivalentAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMulEquivalentAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModOrdering (call postcondition)"} CallPost$$DivMod.__default.LemmaModOrdering(x#0: int, k#0: int, d#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModOrdering", " | ", x#0, " | ", k#0, " | ", d#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModOrdering(x#0, k#0, d#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModOrderingAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModOrderingAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModOrderingAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModOrderingAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaModMod (call postcondition)"} CallPost$$DivMod.__default.LemmaModMod(x#0: int, a#0: int, b#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModMod", " | ", x#0, " | ", a#0, " | ", b#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModMod(x#0, a#0, b#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModModAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModModAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModModAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModModAuto();
    return;
}



implementation {:verboseName "DivMod.LemmaPartBound2 (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound2(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound2", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaPartBound2(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaPartBound2Auto (call postcondition)"} CallPost$$DivMod.__default.LemmaPartBound2Auto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaPartBound2Auto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaPartBound2Auto();
    return;
}



implementation {:verboseName "DivMod.LemmaModBreakdown (call postcondition)"} CallPost$$DivMod.__default.LemmaModBreakdown(x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBreakdown", " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModBreakdown(x#0, y#0, z#0);
    return;
}



implementation {:verboseName "DivMod.LemmaModBreakdownAuto (call postcondition)"} CallPost$$DivMod.__default.LemmaModBreakdownAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "DivMod.LemmaModBreakdownAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$DivMod.__default.LemmaModBreakdownAuto();
    return;
}



implementation {:verboseName "Power.LemmaPow0 (call postcondition)"} CallPost$$Power.__default.LemmaPow0(b#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPow0", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPow0(b#0);
    return;
}



implementation {:verboseName "Power.LemmaPow0Auto (call postcondition)"} CallPost$$Power.__default.LemmaPow0Auto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPow0Auto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPow0Auto();
    return;
}



implementation {:verboseName "Power.LemmaPow1 (call postcondition)"} CallPost$$Power.__default.LemmaPow1(b#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPow1", " | ", b#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPow1(b#0);
    return;
}



implementation {:verboseName "Power.LemmaPow1Auto (call postcondition)"} CallPost$$Power.__default.LemmaPow1Auto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPow1Auto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPow1Auto();
    return;
}



implementation {:verboseName "Power.Lemma0Pow (call postcondition)"} CallPost$$Power.__default.Lemma0Pow(e#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.Lemma0Pow", " | ", e#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.Lemma0Pow(e#0);
    return;
}



implementation {:verboseName "Power.Lemma0PowAuto (call postcondition)"} CallPost$$Power.__default.Lemma0PowAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.Lemma0PowAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.Lemma0PowAuto();
    return;
}



implementation {:verboseName "Power.Lemma1Pow (call postcondition)"} CallPost$$Power.__default.Lemma1Pow(e#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.Lemma1Pow", " | ", e#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.Lemma1Pow(e#0);
    return;
}



implementation {:verboseName "Power.Lemma1PowAuto (call postcondition)"} CallPost$$Power.__default.Lemma1PowAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.Lemma1PowAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.Lemma1PowAuto();
    return;
}



implementation {:verboseName "Power.LemmaSquareIsPow2 (call postcondition)"} CallPost$$Power.__default.LemmaSquareIsPow2(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaSquareIsPow2", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaSquareIsPow2(x#0);
    return;
}



implementation {:verboseName "Power.LemmaSquareIsPow2Auto (call postcondition)"} CallPost$$Power.__default.LemmaSquareIsPow2Auto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaSquareIsPow2Auto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaSquareIsPow2Auto();
    return;
}



implementation {:verboseName "Power.LemmaPowPositive (call postcondition)"} CallPost$$Power.__default.LemmaPowPositive(b#0: int, e#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowPositive", " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowPositive(b#0, e#0);
    return;
}



implementation {:verboseName "Power.LemmaPowPositiveAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowPositiveAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowPositiveAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowPositiveAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowAdds (call postcondition)"} CallPost$$Power.__default.LemmaPowAdds(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowAdds", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowAdds(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowAddsAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowAddsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowAddsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowAddsAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowSubAddCancel (call postcondition)"} CallPost$$Power.__default.LemmaPowSubAddCancel(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubAddCancel", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowSubAddCancel(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowSubAddCancelAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowSubAddCancelAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubAddCancelAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowSubAddCancelAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowSubtracts (call postcondition)"} CallPost$$Power.__default.LemmaPowSubtracts(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubtracts", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowSubtracts(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowSubtractsAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowSubtractsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowSubtractsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowSubtractsAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowMultiplies (call postcondition)"} CallPost$$Power.__default.LemmaPowMultiplies(a#0: int, b#0: int, c#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowMultiplies", " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowMultiplies(a#0, b#0, c#0);
    return;
}



implementation {:verboseName "Power.LemmaPowMultipliesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowMultipliesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowMultipliesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowMultipliesAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowDistributes (call postcondition)"} CallPost$$Power.__default.LemmaPowDistributes(a#0: int, b#0: int, e#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowDistributes", " | ", a#0, " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowDistributes(a#0, b#0, e#0);
    return;
}



implementation {:verboseName "Power.LemmaPowDistributesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowDistributesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowDistributesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowDistributesAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowStrictlyIncreases (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreases(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreases", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowStrictlyIncreases(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowStrictlyIncreasesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreasesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreasesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowStrictlyIncreasesAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowIncreases (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreases(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreases", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowIncreases(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowIncreasesAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreasesAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreasesAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowIncreasesAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowStrictlyIncreasesConverse (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreasesConverse", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowStrictlyIncreasesConverse(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowStrictlyIncreasesConverseAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowStrictlyIncreasesConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowStrictlyIncreasesConverseAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowIncreasesConverse (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreasesConverse(b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreasesConverse", " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowIncreasesConverse(b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowIncreasesConverseAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowIncreasesConverseAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowIncreasesConverseAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowIncreasesConverseAuto();
    return;
}



implementation {:verboseName "Power.LemmaPullOutPows (call postcondition)"} CallPost$$Power.__default.LemmaPullOutPows(b#0: int, x#0: int, y#0: int, z#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPullOutPows", " | ", b#0, " | ", x#0, " | ", y#0, " | ", z#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPullOutPows(b#0, x#0, y#0, z#0);
    return;
}



implementation {:verboseName "Power.LemmaPullOutPowsAuto (call postcondition)"} CallPost$$Power.__default.LemmaPullOutPowsAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPullOutPowsAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPullOutPowsAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowDivisionInequality (call postcondition)"} CallPost$$Power.__default.LemmaPowDivisionInequality(x#0: int, b#0: int, e1#0: int, e2#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowDivisionInequality", " | ", x#0, " | ", b#0, " | ", e1#0, " | ", e2#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowDivisionInequality(x#0, b#0, e1#0, e2#0);
    return;
}



implementation {:verboseName "Power.LemmaPowDivisionInequalityAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowDivisionInequalityAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowDivisionInequalityAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowDivisionInequalityAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowMod (call postcondition)"} CallPost$$Power.__default.LemmaPowMod(b#0: int, e#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowMod", " | ", b#0, " | ", e#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowMod(b#0, e#0);
    return;
}



implementation {:verboseName "Power.LemmaPowModAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowModAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowModAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowModAuto();
    return;
}



implementation {:verboseName "Power.LemmaPowModNoop (call postcondition)"} CallPost$$Power.__default.LemmaPowModNoop(b#0: int, e#0: int, m#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowModNoop", " | ", b#0, " | ", e#0, " | ", m#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowModNoop(b#0, e#0, m#0);
    return;
}



implementation {:verboseName "Power.LemmaPowModNoopAuto (call postcondition)"} CallPost$$Power.__default.LemmaPowModNoopAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Power.LemmaPowModNoopAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Power.__default.LemmaPowModNoopAuto();
    return;
}



implementation {:verboseName "Logarithm.LemmaLog0 (call postcondition)"} CallPost$$Logarithm.__default.LemmaLog0(base#0: int, pow#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLog0", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Logarithm.__default.LemmaLog0(base#0, pow#0);
    return;
}



implementation {:verboseName "Logarithm.LemmaLogS (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogS(base#0: int, pow#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogS", " | ", base#0, " | ", pow#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Logarithm.__default.LemmaLogS(base#0, pow#0);
    return;
}



implementation {:verboseName "Logarithm.LemmaLogSAuto (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogSAuto()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogSAuto"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Logarithm.__default.LemmaLogSAuto();
    return;
}



implementation {:verboseName "Logarithm.LemmaLogIsOrdered (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogIsOrdered(base#0: int, pow#0: int, pow'#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogIsOrdered", " | ", base#0, " | ", pow#0, " | ", pow'#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Logarithm.__default.LemmaLogIsOrdered(base#0, pow#0, pow'#0);
    return;
}



implementation {:verboseName "Logarithm.LemmaLogPow (call postcondition)"} CallPost$$Logarithm.__default.LemmaLogPow(base#0: int, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Logarithm.LemmaLogPow", " | ", base#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Logarithm.__default.LemmaLogPow(base#0, n#0);
    return;
}



implementation {:verboseName "Streams.SeqReader.ReadElements (call postcondition)"} CallPost$$Streams.SeqReader.ReadElements(Streams.SeqReader$T: Ty, this: ref, n#0: int) returns (elems#0: Seq)
{
  var defass#elems#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.SeqReader.ReadElements", " | ", Streams.SeqReader$T, " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    call defass#elems#0, elems#0, $_reverifyPost := Impl$$Streams.SeqReader.ReadElements(Streams.SeqReader$T, this, n#0);
    return;
}



implementation {:verboseName "Streams.SeqReader.ReadExact (call postcondition)"} CallPost$$Streams.SeqReader.ReadExact(Streams.SeqReader$T: Ty, this: ref, n#0: int) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.SeqReader.ReadExact", " | ", Streams.SeqReader$T, " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Streams.SeqReader.ReadExact(Streams.SeqReader$T, this, n#0);
    return;
}



implementation {:verboseName "Streams.ByteReader.ReadByte (call postcondition)"} CallPost$$Streams.ByteReader.ReadByte(this: ref) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadByte", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Streams.ByteReader.ReadByte(this);
    return;
}



implementation {:verboseName "Streams.ByteReader.ReadBytes (call postcondition)"} CallPost$$Streams.ByteReader.ReadBytes(this: ref, n#0: int) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadBytes", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Streams.ByteReader.ReadBytes(this, n#0);
    return;
}



implementation {:verboseName "Streams.ByteReader.ReadUInt16 (call postcondition)"} CallPost$$Streams.ByteReader.ReadUInt16(this: ref) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt16", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Streams.ByteReader.ReadUInt16(this);
    return;
}



implementation {:verboseName "Streams.ByteReader.ReadUInt32 (call postcondition)"} CallPost$$Streams.ByteReader.ReadUInt32(this: ref) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt32", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Streams.ByteReader.ReadUInt32(this);
    return;
}



implementation {:verboseName "Streams.ByteReader.ReadUInt64 (call postcondition)"} CallPost$$Streams.ByteReader.ReadUInt64(this: ref) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.ReadUInt64", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Streams.ByteReader.ReadUInt64(this);
    return;
}



implementation {:verboseName "Streams.ByteReader.IsDoneReading (call postcondition)"} CallPost$$Streams.ByteReader.IsDoneReading(this: ref) returns (b#0: bool)
{
  var defass#b#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.IsDoneReading", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    call defass#b#0, b#0, $_reverifyPost := Impl$$Streams.ByteReader.IsDoneReading(this);
    return;
}



implementation {:verboseName "Streams.ByteReader.GetSizeRead (call postcondition)"} CallPost$$Streams.ByteReader.GetSizeRead(this: ref) returns (n#0: int)
{
  var defass#n#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteReader.GetSizeRead", " | ", this} true;
    assume {:print "Types", " | ", "ref"} true;
    call defass#n#0, n#0, $_reverifyPost := Impl$$Streams.ByteReader.GetSizeRead(this);
    return;
}



implementation {:verboseName "Streams.SeqWriter.WriteElements (call postcondition)"} CallPost$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T: Ty, this: ref, elems#0: Seq) returns (n#0: int)
{
  var defass#n#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.SeqWriter.WriteElements", " | ", Streams.SeqWriter$T, " | ", this, " | ", elems#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#n#0, n#0, $_reverifyPost := Impl$$Streams.SeqWriter.WriteElements(Streams.SeqWriter$T, this, elems#0);
    return;
}



implementation {:verboseName "Streams.ByteWriter.WriteByte (call postcondition)"} CallPost$$Streams.ByteWriter.WriteByte(this: ref, n#0: int) returns (r#0: int)
{
  var defass#r#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteByte", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    call defass#r#0, r#0, $_reverifyPost := Impl$$Streams.ByteWriter.WriteByte(this, n#0);
    return;
}



implementation {:verboseName "Streams.ByteWriter.WriteBytes (call postcondition)"} CallPost$$Streams.ByteWriter.WriteBytes(this: ref, s#0: Seq) returns (r#0: int)
{
  var defass#r#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteBytes", " | ", this, " | ", s#0} true;
    assume {:print "Types", " | ", "ref", " | ", "Seq"} true;
    call defass#r#0, r#0, $_reverifyPost := Impl$$Streams.ByteWriter.WriteBytes(this, s#0);
    return;
}



implementation {:verboseName "Streams.ByteWriter.WriteUInt16 (call postcondition)"} CallPost$$Streams.ByteWriter.WriteUInt16(this: ref, n#0: int) returns (r#0: int)
{
  var defass#r#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteUInt16", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    call defass#r#0, r#0, $_reverifyPost := Impl$$Streams.ByteWriter.WriteUInt16(this, n#0);
    return;
}



implementation {:verboseName "Streams.ByteWriter.WriteUInt32 (call postcondition)"} CallPost$$Streams.ByteWriter.WriteUInt32(this: ref, n#0: int) returns (r#0: int)
{
  var defass#r#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Streams.ByteWriter.WriteUInt32", " | ", this, " | ", n#0} true;
    assume {:print "Types", " | ", "ref", " | ", "int"} true;
    call defass#r#0, r#0, $_reverifyPost := Impl$$Streams.ByteWriter.WriteUInt32(this, n#0);
    return;
}



implementation {:verboseName "Sorting.AboutLexicographicByteSeqBelow (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelow()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelow"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$Sorting.__default.AboutLexicographicByteSeqBelow();
    return;
}



implementation {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0: Seq, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Reflexive", " | ", x#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Reflexive(x#0, n#0);
    return;
}



implementation {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0: Seq, y#0: Seq, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_AntiSymmetric", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__AntiSymmetric(x#0, y#0, n#0);
    return;
}



implementation {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Transitive (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0: Seq, y#0: Seq, z#0: Seq, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Transitive", " | ", x#0, " | ", y#0, " | ", z#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Transitive(x#0, y#0, z#0, n#0);
    return;
}



implementation {:verboseName "Sorting.AboutLexicographicByteSeqBelowAux_Connected (call postcondition)"} CallPost$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0: Seq, y#0: Seq, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Sorting.AboutLexicographicByteSeqBelowAux_Connected", " | ", x#0, " | ", y#0, " | ", n#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$Sorting.__default.AboutLexicographicByteSeqBelowAux__Connected(x#0, y#0, n#0);
    return;
}



implementation {:verboseName "Sorting.SelectionSort (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data: Ty, a#0: ref, below#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Sorting.SelectionSort", " | ", Sorting._default.SelectionSort$Data, " | ", a#0, " | ", below#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$Sorting.__default.SelectionSort(Sorting._default.SelectionSort$Data, a#0, below#0);
    return;
}



implementation {:verboseName "HexStrings.PlainIsLooseChar (call postcondition)"} CallPost$$HexStrings.__default.PlainIsLooseChar(ch#0: char)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.PlainIsLooseChar", " | ", ch#0} true;
    assume {:print "Types", " | ", "char"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.PlainIsLooseChar(ch#0);
    return;
}



implementation {:verboseName "HexStrings.PlainIsLooseString (call postcondition)"} CallPost$$HexStrings.__default.PlainIsLooseString(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.PlainIsLooseString", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.PlainIsLooseString(s#0);
    return;
}



implementation {:verboseName "HexStrings.HexCharRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexCharRoundTrip(ch#0: char)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.HexCharRoundTrip", " | ", ch#0} true;
    assume {:print "Types", " | ", "char"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.HexCharRoundTrip(ch#0);
    return;
}



implementation {:verboseName "HexStrings.HexValRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexValRoundTrip(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.HexValRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.HexValRoundTrip(x#0);
    return;
}



implementation {:verboseName "HexStrings.HexValueRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexValueRoundTrip(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.HexValueRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.HexValueRoundTrip(x#0);
    return;
}



implementation {:verboseName "HexStrings.HexStrRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.HexStrRoundTrip(x#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.HexStrRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.HexStrRoundTrip(x#0);
    return;
}



implementation {:verboseName "HexStrings.ToHexStringRoundTrip (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$HexStrings.__default.ToHexStringRoundTrip(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.ToHexStringRoundTrip", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.ToHexStringRoundTrip(s#0);
    return;
}



implementation {:verboseName "HexStrings.FromHexStringRoundTrip (call postcondition)"} CallPost$$HexStrings.__default.FromHexStringRoundTrip(x#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.FromHexStringRoundTrip", " | ", x#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.FromHexStringRoundTrip(x#0);
    return;
}



implementation {:verboseName "HexStrings.EmptyHexStrings (call postcondition)"} CallPost$$HexStrings.__default.EmptyHexStrings()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "HexStrings.EmptyHexStrings"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$HexStrings.__default.EmptyHexStrings();
    return;
}



implementation {:verboseName "GetOpt.Example (call postcondition)"} CallPost$$GetOpt.__default.Example(args#0: Seq) returns (output#0: DatatypeType)
{
  var defass#output#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "GetOpt.Example", " | ", args#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call defass#output#0, output#0, $_reverifyPost := Impl$$GetOpt.__default.Example(args#0);
    return;
}



implementation {:verboseName "GetOpt.Print (call postcondition)"} CallPost$$GetOpt.__default.Print(GetOpt._default.Print$T: Ty, x#0: Box) returns (#result#0: DatatypeType)
{
  var defass##result#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "GetOpt.Print", " | ", GetOpt._default.Print$T, " | ", x#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Box"} true;
    call defass##result#0, #result#0, $_reverifyPost := Impl$$GetOpt.__default.Print(GetOpt._default.Print$T, x#0);
    return;
}



implementation {:verboseName "FloatCompare.StrCmpSymmetric (call postcondition)"} CallPost$$FloatCompare.__default.StrCmpSymmetric(x#0: Seq, y#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "FloatCompare.StrCmpSymmetric", " | ", x#0, " | ", y#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$FloatCompare.__default.StrCmpSymmetric(x#0, y#0);
    return;
}



implementation {:verboseName "Base64.CharToIndexToChar (call postcondition)"} CallPost$$Base64.__default.CharToIndexToChar(x#0: char)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.CharToIndexToChar", " | ", x#0} true;
    assume {:print "Types", " | ", "char"} true;
    call $_reverifyPost := Impl$$Base64.__default.CharToIndexToChar(x#0);
    return;
}



implementation {:verboseName "Base64.IndexToCharToIndex (call postcondition)"} CallPost$$Base64.__default.IndexToCharToIndex(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.IndexToCharToIndex", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Base64.__default.IndexToCharToIndex(x#0);
    return;
}



implementation {:verboseName "Base64.UInt24ToSeqToUInt24 (call postcondition)"} CallPost$$Base64.__default.UInt24ToSeqToUInt24(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.UInt24ToSeqToUInt24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Base64.__default.UInt24ToSeqToUInt24(x#0);
    return;
}



implementation {:verboseName "Base64.SeqToUInt24ToSeq (call postcondition)"} CallPost$$Base64.__default.SeqToUInt24ToSeq(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.SeqToUInt24ToSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.SeqToUInt24ToSeq(s#0);
    return;
}



implementation {:verboseName "Base64.UInt24ToIndexSeqToUInt24 (call postcondition)"} CallPost$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.UInt24ToIndexSeqToUInt24", " | ", x#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$Base64.__default.UInt24ToIndexSeqToUInt24(x#0);
    return;
}



implementation {:verboseName "Base64.IndexSeqToUInt24ToIndexSeq (call postcondition)"} CallPost$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.IndexSeqToUInt24ToIndexSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.IndexSeqToUInt24ToIndexSeq(s#0);
    return;
}



implementation {:verboseName "Base64.EncodeDecodeBlock (call postcondition)"} CallPost$$Base64.__default.EncodeDecodeBlock(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeDecodeBlock(s#0);
    return;
}



implementation {:verboseName "Base64.DecodeEncodeBlock (call postcondition)"} CallPost$$Base64.__default.DecodeEncodeBlock(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeBlock", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.DecodeEncodeBlock(s#0);
    return;
}



implementation {:verboseName "Base64.DecodeEncodeRecursively (call postcondition)"} CallPost$$Base64.__default.DecodeEncodeRecursively(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeRecursively", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.DecodeEncodeRecursively(s#0);
    return;
}



implementation {:verboseName "Base64.EncodeDecodeRecursively (call postcondition)"} CallPost$$Base64.__default.EncodeDecodeRecursively(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeRecursively", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeDecodeRecursively(b#0);
    return;
}



implementation {:verboseName "Base64.FromCharsToIndicesToChars (call postcondition)"} CallPost$$Base64.__default.FromCharsToIndicesToChars(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.FromCharsToIndicesToChars", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.FromCharsToIndicesToChars(s#0);
    return;
}



implementation {:verboseName "Base64.FromIndicesToCharsToIndices (call postcondition)"} CallPost$$Base64.__default.FromIndicesToCharsToIndices(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.FromIndicesToCharsToIndices", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.FromIndicesToCharsToIndices(b#0);
    return;
}



implementation {:verboseName "Base64.EncodeDecodeUnpadded (call postcondition)"} CallPost$$Base64.__default.EncodeDecodeUnpadded(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeDecodeUnpadded", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeDecodeUnpadded(b#0);
    return;
}



implementation {:verboseName "Base64.DecodeEncodeUnpadded (call postcondition)"} CallPost$$Base64.__default.DecodeEncodeUnpadded(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.DecodeEncodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.DecodeEncodeUnpadded(s#0);
    return;
}



implementation {:verboseName "Base64.DecodeEncode1Padding (call postcondition)"} CallPost$$Base64.__default.DecodeEncode1Padding(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.DecodeEncode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.DecodeEncode1Padding(s#0);
    return;
}



implementation {:verboseName "Base64.EncodeDecode1Padding (call postcondition)"} CallPost$$Base64.__default.EncodeDecode1Padding(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeDecode1Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeDecode1Padding(b#0);
    return;
}



implementation {:verboseName "Base64.DecodeEncode2Padding (call postcondition)"} CallPost$$Base64.__default.DecodeEncode2Padding(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.DecodeEncode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.DecodeEncode2Padding(s#0);
    return;
}



implementation {:verboseName "Base64.EncodeDecode2Padding (call postcondition)"} CallPost$$Base64.__default.EncodeDecode2Padding(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeDecode2Padding", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeDecode2Padding(b#0);
    return;
}



implementation {:verboseName "Base64.AboutDecodeValid (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64.__default.AboutDecodeValid(s#0: Seq, b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.AboutDecodeValid", " | ", s#0, " | ", b#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.AboutDecodeValid(s#0, b#0);
    return;
}



implementation {:verboseName "Base64.Mod3 (call postcondition)"} CallPost$$Base64.__default.Mod3(x#0: int, k#0: int, n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.Mod3", " | ", x#0, " | ", k#0, " | ", n#0} true;
    assume {:print "Types", " | ", "int", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$Base64.__default.Mod3(x#0, k#0, n#0);
    return;
}



implementation {:verboseName "Base64.ConcatMod4Sequences (call postcondition)"} CallPost$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T: Ty, s#0: Seq, t#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.ConcatMod4Sequences", " | ", Base64._default.ConcatMod4Sequences$T, " | ", s#0, " | ", t#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.ConcatMod4Sequences(Base64._default.ConcatMod4Sequences$T, s#0, t#0);
    return;
}



implementation {:verboseName "Base64.EncodeLengthExact (call postcondition)"} CallPost$$Base64.__default.EncodeLengthExact(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeLengthExact", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeLengthExact(b#0);
    return;
}



implementation {:verboseName "Base64.EncodeLengthBound (call postcondition)"} CallPost$$Base64.__default.EncodeLengthBound(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64.EncodeLengthBound", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64.__default.EncodeLengthBound(b#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidEncodeEmpty (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncodeEmpty", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidEncodeEmpty(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidEncodeUnpadded (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncodeUnpadded", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidEncodeUnpadded(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidUnpaddedPartialFrom1PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom1PaddedSeq(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValid1PaddedPartialFrom1PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValid1PaddedPartialFrom1PaddedSeq(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidEncode1Padding (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode1Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidEncode1Padding(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidUnpaddedPartialFrom2PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidUnpaddedPartialFrom2PaddedSeq(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValid2PaddedPartialFrom2PaddedSeq", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValid2PaddedPartialFrom2PaddedSeq(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidEncode2Padding (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode2Padding", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidEncode2Padding(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeValidEncode (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeValidEncode(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeValidEncode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeValidEncode(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.EncodeDecodeValid (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$Base64Lemmas.__default.EncodeDecodeValid(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.EncodeDecodeValid(b#0);
    return;
}



implementation {:verboseName "Base64Lemmas.EncodeDecodeValid0 (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecodeValid0(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid0", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.EncodeDecodeValid0(b#0);
    return;
}



implementation {:verboseName "Base64Lemmas.EncodeDecodeValid1 (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecodeValid1(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid1", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.EncodeDecodeValid1(b#0);
    return;
}



implementation {:verboseName "Base64Lemmas.EncodeDecodeValid2 (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecodeValid2(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecodeValid2", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.EncodeDecodeValid2(b#0);
    return;
}



implementation {:verboseName "Base64Lemmas.DecodeEncode (call postcondition)"} CallPost$$Base64Lemmas.__default.DecodeEncode(s#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.DecodeEncode", " | ", s#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.DecodeEncode(s#0);
    return;
}



implementation {:verboseName "Base64Lemmas.EncodeDecode (call postcondition)"} CallPost$$Base64Lemmas.__default.EncodeDecode(b#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Base64Lemmas.EncodeDecode", " | ", b#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$Base64Lemmas.__default.EncodeDecode(b#0);
    return;
}



implementation {:verboseName "Actions.DeterministicMap (call postcondition)"} CallPost$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A: Ty, Actions._default.DeterministicMap$R: Ty, action#0: ref, s#0: Seq) returns (res#0: Seq)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.DeterministicMap", " | ", Actions._default.DeterministicMap$A, " | ", Actions._default.DeterministicMap$R, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Actions.__default.DeterministicMap(Actions._default.DeterministicMap$A, Actions._default.DeterministicMap$R, action#0, s#0);
    return;
}



implementation {:verboseName "Actions.DeterministicMapWithResult (call postcondition)"} CallPost$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A: Ty, Actions._default.DeterministicMapWithResult$R: Ty, Actions._default.DeterministicMapWithResult$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.DeterministicMapWithResult", " | ", Actions._default.DeterministicMapWithResult$A, " | ", Actions._default.DeterministicMapWithResult$R, " | ", Actions._default.DeterministicMapWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Actions.__default.DeterministicMapWithResult(Actions._default.DeterministicMapWithResult$A, Actions._default.DeterministicMapWithResult$R, Actions._default.DeterministicMapWithResult$E, action#0, s#0);
    return;
}



implementation {:verboseName "Actions.DeterministicFlatMap (call postcondition)"} CallPost$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A: Ty, Actions._default.DeterministicFlatMap$R: Ty, action#0: ref, s#0: Seq) returns (res#0: Seq)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.DeterministicFlatMap", " | ", Actions._default.DeterministicFlatMap$A, " | ", Actions._default.DeterministicFlatMap$R, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Actions.__default.DeterministicFlatMap(Actions._default.DeterministicFlatMap$A, Actions._default.DeterministicFlatMap$R, action#0, s#0);
    return;
}



implementation {:verboseName "Actions.DeterministicFlatMapWithResult (call postcondition)"} CallPost$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A: Ty, Actions._default.DeterministicFlatMapWithResult$R: Ty, Actions._default.DeterministicFlatMapWithResult$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType, parts#0: Seq)
{
  var defass#res#0: bool;
  var defass#parts#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.DeterministicFlatMapWithResult", " | ", Actions._default.DeterministicFlatMapWithResult$A, " | ", Actions._default.DeterministicFlatMapWithResult$R, " | ", Actions._default.DeterministicFlatMapWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, defass#parts#0, parts#0, $_reverifyPost := Impl$$Actions.__default.DeterministicFlatMapWithResult(Actions._default.DeterministicFlatMapWithResult$A, Actions._default.DeterministicFlatMapWithResult$R, Actions._default.DeterministicFlatMapWithResult$E, action#0, s#0);
    return;
}



implementation {:verboseName "Actions.Filter (call postcondition)"} CallPost$$Actions.__default.Filter(Actions._default.Filter$A: Ty, action#0: ref, s#0: Seq) returns (res#0: Seq)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.Filter", " | ", Actions._default.Filter$A, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Actions.__default.Filter(Actions._default.Filter$A, action#0, s#0);
    return;
}



implementation {:verboseName "Actions.FilterWithResult (call postcondition)"} CallPost$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A: Ty, Actions._default.FilterWithResult$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType)
{
  var defass#res#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.FilterWithResult", " | ", Actions._default.FilterWithResult$A, " | ", Actions._default.FilterWithResult$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, $_reverifyPost := Impl$$Actions.__default.FilterWithResult(Actions._default.FilterWithResult$A, Actions._default.FilterWithResult$E, action#0, s#0);
    return;
}



implementation {:verboseName "Actions.ReduceToSuccess (call postcondition)"} CallPost$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A: Ty, Actions._default.ReduceToSuccess$B: Ty, Actions._default.ReduceToSuccess$E: Ty, action#0: ref, s#0: Seq) returns (res#0: DatatypeType, attemptsState#0: Seq)
{
  var defass#res#0: bool;
  var defass#attemptsState#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "Actions.ReduceToSuccess", " | ", Actions._default.ReduceToSuccess$A, " | ", Actions._default.ReduceToSuccess$B, " | ", Actions._default.ReduceToSuccess$E, " | ", action#0, " | ", s#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "Ty", " | ", "ref", " | ", "Seq"} true;
    call defass#res#0, res#0, defass#attemptsState#0, attemptsState#0, $_reverifyPost := Impl$$Actions.__default.ReduceToSuccess(Actions._default.ReduceToSuccess$A, Actions._default.ReduceToSuccess$B, Actions._default.ReduceToSuccess$E, action#0, s#0);
    return;
}



implementation {:verboseName "JSON.Utils.Views.Core.View_.CopyTo (call postcondition)"} CallPost$$JSON_mUtils_mViews_mCore.View__.CopyTo(this: DatatypeType, dest#0: ref, start#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.CopyTo", " | ", this, " | ", dest#0, " | ", start#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mViews_mCore.View__.CopyTo(this, dest#0, start#0);
    return;
}



implementation {:verboseName "JSON.Utils.Views.Core.View_.Byte? (call postcondition)"} CallPost$$JSON_mUtils_mViews_mCore.View__.Byte_q(this: DatatypeType, c#0: int) returns (#result#0: bool)
{
  var defass##result#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Core.View_.Byte?", " | ", this, " | ", c#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "int"} true;
    call defass##result#0, #result#0, $_reverifyPost := Impl$$JSON_mUtils_mViews_mCore.View__.Byte_q(this, c#0);
    return;
}



implementation {:verboseName "JSON.Utils.Views.Writers.Chain.CopyTo (call postcondition)"} CallPost$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this: DatatypeType, dest#0: ref, end#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Chain.CopyTo", " | ", this, " | ", dest#0, " | ", end#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mViews_mWriters.Chain.CopyTo(this, dest#0, end#0);
    return;
}



implementation {:verboseName "JSON.Utils.Views.Writers.Writer_.CopyTo (call postcondition)"} CallPost$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this: DatatypeType, dest#0: ref)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.CopyTo", " | ", this, " | ", dest#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mViews_mWriters.Writer__.CopyTo(this, dest#0);
    return;
}



implementation {:verboseName "JSON.Utils.Views.Writers.Writer_.ToArray (call postcondition)"} CallPost$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this: DatatypeType) returns (bs#0: ref)
{
  var defass#bs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Views.Writers.Writer_.ToArray", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#bs#0, bs#0, $_reverifyPost := Impl$$JSON_mUtils_mViews_mWriters.Writer__.ToArray(this);
    return;
}



implementation {:verboseName "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength (call postcondition)"} CallPost$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.PrefixSuffixLength", " | ", this} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mCursors.Cursor__.PrefixSuffixLength(this);
    return;
}



implementation {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhile (call postcondition)"} CallPost$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this: DatatypeType, p#0: HandleType) returns (ps#0: DatatypeType)
{
  var defass#ps#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhile", " | ", this, " | ", p#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "HandleType"} true;
    call defass#ps#0, ps#0, $_reverifyPost := Impl$$JSON_mUtils_mCursors.Cursor__.SkipWhile(this, p#0);
    return;
}



implementation {:verboseName "JSON.Utils.Cursors.Cursor_.SkipWhileLexer (call postcondition)"} CallPost$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A: Ty, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R: Ty, this: DatatypeType, step#0: HandleType, st#0: Box) returns (pr#0: DatatypeType)
{
  var defass#pr#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Cursors.Cursor_.SkipWhileLexer", " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, " | ", JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, " | ", this, " | ", step#0, " | ", st#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "Box"} true;
    call defass#pr#0, pr#0, $_reverifyPost := Impl$$JSON_mUtils_mCursors.Cursor__.SkipWhileLexer(JSON.Utils.Cursors.Cursor_.SkipWhileLexer$A, JSON.Utils.Cursors.Cursor_.SkipWhileLexer$R, this, step#0, st#0);
    return;
}



implementation {:verboseName "JSON.Utils.Str.ParametricConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mStr_mParametricConversion.__default.ToNat__bound(str#0, base#0, digits#0);
    return;
}



implementation {:verboseName "JSON.Utils.Str.ParametricEscaping.Unescape_Escape (call postcondition)"} CallPost$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0: Seq, special#0: Set, escape#0: Box)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.ParametricEscaping.Unescape_Escape", " | ", str#0, " | ", special#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set", " | ", "Box"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mStr_mParametricEscaping.__default.Unescape__Escape(str#0, special#0, escape#0);
    return;
}



implementation {:verboseName "JSON.Utils.Str.CharStrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mStr_mCharStrConversion.__default.ToNat__bound(str#0, base#0, digits#0);
    return;
}



implementation {:verboseName "JSON.Utils.Str.CharStrEscaping.Unescape_Escape (call postcondition)"} CallPost$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0: Seq, special#0: Set, escape#0: char)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.CharStrEscaping.Unescape_Escape", " | ", str#0, " | ", special#0, " | ", escape#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "Set", " | ", "char"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mStr_mCharStrEscaping.__default.Unescape__Escape(str#0, special#0, escape#0);
    return;
}



implementation {:verboseName "JSON.Utils.Str.Test (call postcondition)"} CallPost$$JSON_mUtils_mStr.__default.Test()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.Test"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mStr.__default.Test();
    return;
}



implementation {:verboseName "JSON.Utils.Str.Concat_Join (call postcondition)"} CallPost$$JSON_mUtils_mStr.__default.Concat__Join(strs#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Str.Concat_Join", " | ", strs#0} true;
    assume {:print "Types", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mStr.__default.Concat__Join(strs#0);
    return;
}



implementation {:verboseName "JSON.Utils.Seq.Neutral (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0: Ty, l#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Neutral", " | ", JSON.Utils.Seq._default.Neutral$_T0, " | ", l#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mSeq.__default.Neutral(JSON.Utils.Seq._default.Neutral$_T0, l#0);
    return;
}



implementation {:verboseName "JSON.Utils.Seq.Assoc (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0: Ty, a#0: Seq, b#0: Seq, c#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Assoc", " | ", JSON.Utils.Seq._default.Assoc$_T0, " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mSeq.__default.Assoc(JSON.Utils.Seq._default.Assoc$_T0, a#0, b#0, c#0);
    return;
}



implementation {:verboseName "JSON.Utils.Seq.Assoc' (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0: Ty, a#0: Seq, b#0: Seq, c#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Assoc'", " | ", JSON.Utils.Seq._default.Assoc'$_T0, " | ", a#0, " | ", b#0, " | ", c#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mSeq.__default.Assoc_k(JSON.Utils.Seq._default.Assoc'$_T0, a#0, b#0, c#0);
    return;
}



implementation {:verboseName "JSON.Utils.Seq.Assoc2 (call postcondition)"} CallPost$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0: Ty, a#0: Seq, b#0: Seq, c#0: Seq, d#0: Seq)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Seq.Assoc2", " | ", JSON.Utils.Seq._default.Assoc2$_T0, " | ", a#0, " | ", b#0, " | ", c#0, " | ", d#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "Seq", " | ", "Seq"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mSeq.__default.Assoc2(JSON.Utils.Seq._default.Assoc2$_T0, a#0, b#0, c#0, d#0);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.Put (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A: Ty, this: ref, idx#0: int, a#0: Box)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Put", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", idx#0, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int", " | ", "Box"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.Put(JSON.Utils.Vectors.Vector$A, this, idx#0, a#0);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.CopyFrom (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A: Ty, this: ref, new_data#0: ref, count#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.CopyFrom", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", new_data#0, " | ", count#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "ref", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.CopyFrom(JSON.Utils.Vectors.Vector$A, this, new_data#0, count#0);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.Realloc (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A: Ty, this: ref, new_capacity#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Realloc", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", new_capacity#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.Realloc(JSON.Utils.Vectors.Vector$A, this, new_capacity#0);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.ReallocDefault (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A: Ty, this: ref) returns (o#0: DatatypeType)
{
  var defass#o#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.ReallocDefault", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    call defass#o#0, o#0, $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.ReallocDefault(JSON.Utils.Vectors.Vector$A, this);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.Ensure (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A: Ty, this: ref, reserved#0: int) returns (o#0: DatatypeType)
{
  var defass#o#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Ensure", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", reserved#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "int"} true;
    call defass#o#0, o#0, $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.Ensure(JSON.Utils.Vectors.Vector$A, this, reserved#0);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.PopFast (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.PopFast", " | ", JSON.Utils.Vectors.Vector$A, " | ", this} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.PopFast(JSON.Utils.Vectors.Vector$A, this);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.PushFast (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A: Ty, this: ref, a#0: Box)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.PushFast", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    call $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.PushFast(JSON.Utils.Vectors.Vector$A, this, a#0);
    return;
}



implementation {:verboseName "JSON.Utils.Vectors.Vector.Push (call postcondition)"} CallPost$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A: Ty, this: ref, a#0: Box) returns (o#0: DatatypeType)
{
  var defass#o#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Utils.Vectors.Vector.Push", " | ", JSON.Utils.Vectors.Vector$A, " | ", this, " | ", a#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "ref", " | ", "Box"} true;
    call defass#o#0, o#0, $_reverifyPost := Impl$$JSON_mUtils_mVectors.Vector.Push(JSON.Utils.Vectors.Vector$A, this, a#0);
    return;
}



implementation {:verboseName "JSON.Spec.OfIntOnlyASCII (call postcondition)"} CallPost$$JSON_mSpec.__default.OfIntOnlyASCII(n#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Spec.OfIntOnlyASCII", " | ", n#0} true;
    assume {:print "Types", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mSpec.__default.OfIntOnlyASCII(n#0);
    return;
}



implementation {:verboseName "JSON.Serializer.ByteStrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Serializer.ByteStrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    call $_reverifyPost := Impl$$JSON_mSerializer_mByteStrConversion.__default.ToNat__bound(str#0, base#0, digits#0);
    return;
}



implementation {:verboseName "JSON.Deserializer.Uint16StrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Deserializer.Uint16StrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    call $_reverifyPost := Impl$$JSON_mDeserializer_mUint16StrConversion.__default.ToNat__bound(str#0, base#0, digits#0);
    return;
}



implementation {:verboseName "JSON.Deserializer.ByteStrConversion.ToNat_bound (call postcondition)"} CallPost$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0: Seq, base#0: int, digits#0: Map)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.Deserializer.ByteStrConversion.ToNat_bound", " | ", str#0, " | ", base#0, " | ", digits#0} true;
    assume {:print "Types", " | ", "Seq", " | ", "int", " | ", "Map"} true;
    call $_reverifyPost := Impl$$JSON_mDeserializer_mByteStrConversion.__default.ToNat__bound(str#0, base#0, digits#0);
    return;
}



implementation {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueNumber (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueNumber", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueNumber(v#0);
    return;
}



implementation {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueObject (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueObject", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueObject(v#0);
    return;
}



implementation {:verboseName "JSON.ConcreteSyntax.Spec.UnfoldValueArray (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.Spec.UnfoldValueArray", " | ", v#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mConcreteSyntax_mSpec.__default.UnfoldValueArray(v#0);
    return;
}



implementation {:verboseName "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D: Ty, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S: Ty, bracketed#0: DatatypeType, pd0#0: HandleType, pd1#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.Bracketed_Morphism", " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, " | ", JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, " | ", bracketed#0, " | ", pd0#0, " | ", pd1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Ty", " | ", "DatatypeType", " | ", "HandleType", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.Bracketed__Morphism(JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$D, JSON.ConcreteSyntax.SpecProperties._default.Bracketed_Morphism$S, bracketed#0, pd0#0, pd1#0);
    return;
}



implementation {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T: Ty, ts#0: Seq, pt0#0: HandleType, pt1#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Morphism", " | ", JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, " | ", ts#0, " | ", pt0#0, " | ", pt1#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "HandleType", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Morphism(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Morphism$T, ts#0, pt0#0, pt1#0);
    return;
}



implementation {:verboseName "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear (call postcondition)"} CallPost$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T: Ty, ts0#0: Seq, ts1#0: Seq, pt#0: HandleType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ConcreteSyntax.SpecProperties.ConcatBytes_Linear", " | ", JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, " | ", ts0#0, " | ", ts1#0, " | ", pt#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "Seq", " | ", "HandleType"} true;
    call $_reverifyPost := Impl$$JSON_mConcreteSyntax_mSpecProperties.__default.ConcatBytes__Linear(JSON.ConcreteSyntax.SpecProperties._default.ConcatBytes_Linear$T, ts0#0, ts1#0, pt#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.Serialize (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0: DatatypeType) returns (rbs#0: DatatypeType)
{
  var defass#rbs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Serialize", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#rbs#0, rbs#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.Serialize(js#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.SerializeTo (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0: DatatypeType, dest#0: ref) returns (len#0: DatatypeType)
{
  var defass#len#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.SerializeTo", " | ", js#0, " | ", dest#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    call defass#len#0, len#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.SerializeTo(js#0, dest#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.StructuralViewEns (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0: DatatypeType, writer#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.StructuralViewEns", " | ", st#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.StructuralViewEns(st#0, writer#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.BracketedToObject (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.BracketedToObject", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.BracketedToObject(obj#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.BracketedToArray (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.BracketedToArray", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.BracketedToArray(arr#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.MembersImpl (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var defass#wr#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.MembersImpl", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    call defass#wr#0, wr#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.MembersImpl(obj#0, writer#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.ItemsImpl (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var defass#wr#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.ItemsImpl", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    call defass#wr#0, wr#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.ItemsImpl(arr#0, writer#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.AboutList (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T: Ty, xs#0: Seq, i#0: int, j#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.AboutList", " | ", JSON.ZeroCopy.Serializer._default.AboutList$T, " | ", xs#0, " | ", i#0, " | ", j#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.AboutList(JSON.ZeroCopy.Serializer._default.AboutList$T, xs#0, i#0, j#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.Members (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var defass#wr#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Members", " | ", obj#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    call defass#wr#0, wr#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.Members(obj#0, writer#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Serializer.Items (call postcondition)"} CallPost$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0: DatatypeType, writer#0: DatatypeType) returns (wr#0: DatatypeType)
{
  var defass#wr#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Serializer.Items", " | ", arr#0, " | ", writer#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "DatatypeType"} true;
    call defass#wr#0, wr#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mSerializer.__default.Items(arr#0, writer#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Core.WS (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0: DatatypeType) returns (sp#0: DatatypeType)
{
  var defass#sp#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Core.WS", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#sp#0, sp#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mCore.__default.WS(cs#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutTryStructural(cs#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutLists (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T: Ty, xs#0: Seq, i#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutLists(JSON.ZeroCopy.Deserializer.Sequences._default.AboutLists$T, xs#0, i#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.AboutCloseParser"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.AboutCloseParser();
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Sequences.Valid (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Sequences.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mSequences.__default.Valid(x#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Strings.StringBody (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0: DatatypeType) returns (pr#0: DatatypeType)
{
  var defass#pr#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Strings.StringBody", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#pr#0, pr#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mStrings.__default.StringBody(cs#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.BracketedToObject", " | ", obj#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.BracketedToObject(obj#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutTryStructural(cs#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutLists (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T: Ty, xs#0: Seq, i#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutLists(JSON.ZeroCopy.Deserializer.Objects._default.AboutLists$T, xs#0, i#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.AboutCloseParser"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.AboutCloseParser();
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Objects.Valid (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Objects.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mObjects.__default.Valid(x#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.BracketedToArray", " | ", arr#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.BracketedToArray(arr#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutTryStructural", " | ", cs#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutTryStructural(cs#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutLists (call postcondition)"} {:vcs_split_on_every_assert} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T: Ty, xs#0: Seq, i#0: int)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutLists", " | ", JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T, " | ", xs#0, " | ", i#0} true;
    assume {:print "Types", " | ", "Ty", " | ", "Seq", " | ", "int"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutLists(JSON.ZeroCopy.Deserializer.Arrays._default.AboutLists$T, xs#0, i#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser()
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.AboutCloseParser"} true;
    assume {:print "Types"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.AboutCloseParser();
    return;
}



implementation {:verboseName "JSON.ZeroCopy.Deserializer.Arrays.Valid (call postcondition)"} CallPost$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0: DatatypeType)
{
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.Deserializer.Arrays.Valid", " | ", x#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call $_reverifyPost := Impl$$JSON_mZeroCopy_mDeserializer_mArrays.__default.Valid(x#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.API.SerializeAlloc (call postcondition)"} CallPost$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0: DatatypeType) returns (bs#0: DatatypeType)
{
  var defass#bs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.SerializeAlloc", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#bs#0, bs#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mAPI.__default.SerializeAlloc(js#0);
    return;
}



implementation {:verboseName "JSON.ZeroCopy.API.SerializeInto (call postcondition)"} CallPost$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0: DatatypeType, bs#0: ref) returns (len#0: DatatypeType)
{
  var defass#len#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.ZeroCopy.API.SerializeInto", " | ", js#0, " | ", bs#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    call defass#len#0, len#0, $_reverifyPost := Impl$$JSON_mZeroCopy_mAPI.__default.SerializeInto(js#0, bs#0);
    return;
}



implementation {:verboseName "JSON.API.SerializeAlloc (call postcondition)"} CallPost$$JSON_mAPI.__default.SerializeAlloc(js#0: DatatypeType) returns (bs#0: DatatypeType)
{
  var defass#bs#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.API.SerializeAlloc", " | ", js#0} true;
    assume {:print "Types", " | ", "DatatypeType"} true;
    call defass#bs#0, bs#0, $_reverifyPost := Impl$$JSON_mAPI.__default.SerializeAlloc(js#0);
    return;
}



implementation {:verboseName "JSON.API.SerializeInto (call postcondition)"} CallPost$$JSON_mAPI.__default.SerializeInto(js#0: DatatypeType, bs#0: ref) returns (len#0: DatatypeType)
{
  var defass#len#0: bool;
  var $_reverifyPost: bool;

  anon_0:
    assume {:print "Impl", " | ", "JSON.API.SerializeInto", " | ", js#0, " | ", bs#0} true;
    assume {:print "Types", " | ", "DatatypeType", " | ", "ref"} true;
    call defass#len#0, len#0, $_reverifyPost := Impl$$JSON_mAPI.__default.SerializeInto(js#0, bs#0);
    return;
}


